// @bun
var __create = Object.create;
var __getProtoOf = Object.getPrototypeOf;
var __defProp = Object.defineProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __toESM = (mod, isNodeMode, target) => {
  target = mod != null ? __create(__getProtoOf(mod)) : {};
  const to = isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target;
  for (let key of __getOwnPropNames(mod))
    if (!__hasOwnProp.call(to, key))
      __defProp(to, key, {
        get: () => mod[key],
        enumerable: true
      });
  return to;
};

// bin/cli.ts
import os10 from "os";

// node_modules/@stacksjs/cli/dist/index.js
import { formatWithOptions } from "util";
import { sep } from "path";
import * as tty from "tty";
import { stdin, stdout } from "process";
import f from "readline";
import { WriteStream } from "tty";
import require$$0 from "tty";
import process$1 from "process";
import { createRequire as __tinyexec_cr } from "module";
import { EventEmitter } from "events";
import { access, appendFile, mkdir } from "fs/promises";
import { dirname as dirname2 } from "path";
import process7 from "process";
import {
  basename,
  delimiter,
  dirname,
  extname,
  isAbsolute,
  join,
  normalize,
  parse,
  relative,
  resolve as resolve2,
  sep as sep2,
  toNamespacedPath
} from "path";
import process5 from "process";
import process4 from "process";
import p2 from "process";
import process10 from "process";
import process18 from "process";
import process11 from "process";
import os from "os";
import tty3 from "tty";
import process14 from "process";
import process13 from "process";
import process15 from "process";
import process16 from "process";
import process17 from "process";
import process19 from "process";
var __create2 = Object.create;
var __getProtoOf2 = Object.getPrototypeOf;
var __defProp2 = Object.defineProperty;
var __getOwnPropNames2 = Object.getOwnPropertyNames;
var __hasOwnProp2 = Object.prototype.hasOwnProperty;
var __toESM2 = (mod, isNodeMode, target) => {
  target = mod != null ? __create2(__getProtoOf2(mod)) : {};
  const to = isNodeMode || !mod || !mod.__esModule ? __defProp2(target, "default", { value: mod, enumerable: true }) : target;
  for (let key of __getOwnPropNames2(mod))
    if (!__hasOwnProp2.call(to, key))
      __defProp2(to, key, {
        get: () => mod[key],
        enumerable: true
      });
  return to;
};
var __commonJS = (cb, mod) => () => (mod || cb((mod = { exports: {} }).exports, mod), mod.exports);
var __export = (target, all) => {
  for (var name in all)
    __defProp2(target, name, {
      get: all[name],
      enumerable: true,
      configurable: true,
      set: (newValue) => all[name] = () => newValue
    });
};
var __esm = (fn, res) => () => (fn && (res = fn(fn = 0)), res);
function isObject(value) {
  return value !== null && typeof value === "object";
}
function _defu(baseObject, defaults, namespace = ".", merger) {
  if (!isObject(defaults)) {
    return _defu(baseObject, {}, namespace, merger);
  }
  const object = Object.assign({}, defaults);
  for (const key in baseObject) {
    if (key === "__proto__" || key === "constructor") {
      continue;
    }
    const value = baseObject[key];
    if (value === null || value === undefined) {
      continue;
    }
    if (merger && merger(object, key, value, namespace)) {
      continue;
    }
    if (Array.isArray(value) && Array.isArray(object[key])) {
      object[key] = [...value, ...object[key]];
    } else if (isObject(value) && isObject(object[key])) {
      object[key] = _defu(value, object[key], (namespace ? `${namespace}.` : "") + key.toString(), merger);
    } else {
      object[key] = value;
    }
  }
  return object;
}
function createDefu(merger) {
  return (...arguments_) => arguments_.reduce((p, c) => _defu(p, c, "", merger), {});
}
function isPlainObject(obj) {
  return Object.prototype.toString.call(obj) === "[object Object]";
}
function isLogObj(arg) {
  if (!isPlainObject(arg)) {
    return false;
  }
  if (!arg.message && !arg.args) {
    return false;
  }
  if (arg.stack) {
    return false;
  }
  return true;
}

class Consola {
  constructor(options2 = {}) {
    const types = options2.types || LogTypes;
    this.options = defu({
      ...options2,
      defaults: { ...options2.defaults },
      level: _normalizeLogLevel(options2.level, types),
      reporters: [...options2.reporters || []]
    }, {
      types: LogTypes,
      throttle: 1000,
      throttleMin: 5,
      formatOptions: {
        date: true,
        colors: false,
        compact: true
      }
    });
    for (const type in types) {
      const defaults = {
        type,
        ...this.options.defaults,
        ...types[type]
      };
      this[type] = this._wrapLogFn(defaults);
      this[type].raw = this._wrapLogFn(defaults, true);
    }
    if (this.options.mockFn) {
      this.mockTypes();
    }
    this._lastLog = {};
  }
  get level() {
    return this.options.level;
  }
  set level(level) {
    this.options.level = _normalizeLogLevel(level, this.options.types, this.options.level);
  }
  prompt(message, opts) {
    if (!this.options.prompt) {
      throw new Error("prompt is not supported!");
    }
    return this.options.prompt(message, opts);
  }
  create(options2) {
    const instance = new Consola({
      ...this.options,
      ...options2
    });
    if (this._mockFn) {
      instance.mockTypes(this._mockFn);
    }
    return instance;
  }
  withDefaults(defaults) {
    return this.create({
      ...this.options,
      defaults: {
        ...this.options.defaults,
        ...defaults
      }
    });
  }
  withTag(tag) {
    return this.withDefaults({
      tag: this.options.defaults.tag ? this.options.defaults.tag + ":" + tag : tag
    });
  }
  addReporter(reporter) {
    this.options.reporters.push(reporter);
    return this;
  }
  removeReporter(reporter) {
    if (reporter) {
      const i = this.options.reporters.indexOf(reporter);
      if (i >= 0) {
        return this.options.reporters.splice(i, 1);
      }
    } else {
      this.options.reporters.splice(0);
    }
    return this;
  }
  setReporters(reporters) {
    this.options.reporters = Array.isArray(reporters) ? reporters : [reporters];
    return this;
  }
  wrapAll() {
    this.wrapConsole();
    this.wrapStd();
  }
  restoreAll() {
    this.restoreConsole();
    this.restoreStd();
  }
  wrapConsole() {
    for (const type in this.options.types) {
      if (!console["__" + type]) {
        console["__" + type] = console[type];
      }
      console[type] = this[type].raw;
    }
  }
  restoreConsole() {
    for (const type in this.options.types) {
      if (console["__" + type]) {
        console[type] = console["__" + type];
        delete console["__" + type];
      }
    }
  }
  wrapStd() {
    this._wrapStream(this.options.stdout, "log");
    this._wrapStream(this.options.stderr, "log");
  }
  _wrapStream(stream2, type) {
    if (!stream2) {
      return;
    }
    if (!stream2.__write) {
      stream2.__write = stream2.write;
    }
    stream2.write = (data) => {
      this[type].raw(String(data).trim());
    };
  }
  restoreStd() {
    this._restoreStream(this.options.stdout);
    this._restoreStream(this.options.stderr);
  }
  _restoreStream(stream2) {
    if (!stream2) {
      return;
    }
    if (stream2.__write) {
      stream2.write = stream2.__write;
      delete stream2.__write;
    }
  }
  pauseLogs() {
    paused = true;
  }
  resumeLogs() {
    paused = false;
    const _queue = queue2.splice(0);
    for (const item of _queue) {
      item[0]._logFn(item[1], item[2]);
    }
  }
  mockTypes(mockFn) {
    const _mockFn = mockFn || this.options.mockFn;
    this._mockFn = _mockFn;
    if (typeof _mockFn !== "function") {
      return;
    }
    for (const type in this.options.types) {
      this[type] = _mockFn(type, this.options.types[type]) || this[type];
      this[type].raw = this[type];
    }
  }
  _wrapLogFn(defaults, isRaw) {
    return (...args) => {
      if (paused) {
        queue2.push([this, defaults, args, isRaw]);
        return;
      }
      return this._logFn(defaults, args, isRaw);
    };
  }
  _logFn(defaults, args, isRaw) {
    if ((defaults.level || 0) > this.level) {
      return false;
    }
    const logObj = {
      date: /* @__PURE__ */ new Date,
      args: [],
      ...defaults,
      level: _normalizeLogLevel(defaults.level, this.options.types)
    };
    if (!isRaw && args.length === 1 && isLogObj(args[0])) {
      Object.assign(logObj, args[0]);
    } else {
      logObj.args = [...args];
    }
    if (logObj.message) {
      logObj.args.unshift(logObj.message);
      delete logObj.message;
    }
    if (logObj.additional) {
      if (!Array.isArray(logObj.additional)) {
        logObj.additional = logObj.additional.split("\n");
      }
      logObj.args.push("\n" + logObj.additional.join("\n"));
      delete logObj.additional;
    }
    logObj.type = typeof logObj.type === "string" ? logObj.type.toLowerCase() : "log";
    logObj.tag = typeof logObj.tag === "string" ? logObj.tag : "";
    const resolveLog = (newLog = false) => {
      const repeated = (this._lastLog.count || 0) - this.options.throttleMin;
      if (this._lastLog.object && repeated > 0) {
        const args2 = [...this._lastLog.object.args];
        if (repeated > 1) {
          args2.push(`(repeated ${repeated} times)`);
        }
        this._log({ ...this._lastLog.object, args: args2 });
        this._lastLog.count = 1;
      }
      if (newLog) {
        this._lastLog.object = logObj;
        this._log(logObj);
      }
    };
    clearTimeout(this._lastLog.timeout);
    const diffTime = this._lastLog.time && logObj.date ? logObj.date.getTime() - this._lastLog.time.getTime() : 0;
    this._lastLog.time = logObj.date;
    if (diffTime < this.options.throttle) {
      try {
        const serializedLog = JSON.stringify([
          logObj.type,
          logObj.tag,
          logObj.args
        ]);
        const isSameLog = this._lastLog.serialized === serializedLog;
        this._lastLog.serialized = serializedLog;
        if (isSameLog) {
          this._lastLog.count = (this._lastLog.count || 0) + 1;
          if (this._lastLog.count > this.options.throttleMin) {
            this._lastLog.timeout = setTimeout(resolveLog, this.options.throttle);
            return;
          }
        }
      } catch {
      }
    }
    resolveLog(true);
  }
  _log(logObj) {
    for (const reporter of this.options.reporters) {
      reporter.log(logObj, {
        options: this.options
      });
    }
  }
}
function _normalizeLogLevel(input, types = {}, defaultLevel = 3) {
  if (input === undefined) {
    return defaultLevel;
  }
  if (typeof input === "number") {
    return input;
  }
  if (types[input] && types[input].level !== undefined) {
    return types[input].level;
  }
  return defaultLevel;
}
function createConsola(options2 = {}) {
  return new Consola(options2);
}
var LogLevels;
var LogTypes;
var defu;
var paused = false;
var queue2;
var init_core = __esm(() => {
  LogLevels = {
    silent: Number.NEGATIVE_INFINITY,
    fatal: 0,
    error: 0,
    warn: 1,
    log: 2,
    info: 3,
    success: 3,
    fail: 3,
    ready: 3,
    start: 3,
    box: 3,
    debug: 4,
    trace: 5,
    verbose: Number.POSITIVE_INFINITY
  };
  LogTypes = {
    silent: {
      level: -1
    },
    fatal: {
      level: LogLevels.fatal
    },
    error: {
      level: LogLevels.error
    },
    warn: {
      level: LogLevels.warn
    },
    log: {
      level: LogLevels.log
    },
    info: {
      level: LogLevels.info
    },
    success: {
      level: LogLevels.success
    },
    fail: {
      level: LogLevels.fail
    },
    ready: {
      level: LogLevels.info
    },
    start: {
      level: LogLevels.info
    },
    box: {
      level: LogLevels.info
    },
    debug: {
      level: LogLevels.debug
    },
    trace: {
      level: LogLevels.trace
    },
    verbose: {
      level: LogLevels.verbose
    }
  };
  defu = createDefu();
  queue2 = [];
  Consola.prototype.add = Consola.prototype.addReporter;
  Consola.prototype.remove = Consola.prototype.removeReporter;
  Consola.prototype.clear = Consola.prototype.removeReporter;
  Consola.prototype.withScope = Consola.prototype.withTag;
  Consola.prototype.mock = Consola.prototype.mockTypes;
  Consola.prototype.pause = Consola.prototype.pauseLogs;
  Consola.prototype.resume = Consola.prototype.resumeLogs;
});
function parseStack(stack) {
  const cwd = process.cwd() + sep;
  const lines = stack.split("\n").splice(1).map((l2) => l2.trim().replace("file://", "").replace(cwd, ""));
  return lines;
}
function writeStream(data, stream2) {
  const write = stream2.__write || stream2.write;
  return write.call(stream2, data);
}

class BasicReporter {
  formatStack(stack, opts) {
    return "  " + parseStack(stack).join("\n  ");
  }
  formatArgs(args, opts) {
    const _args = args.map((arg) => {
      if (arg && typeof arg.stack === "string") {
        return arg.message + "\n" + this.formatStack(arg.stack, opts);
      }
      return arg;
    });
    return formatWithOptions(opts, ..._args);
  }
  formatDate(date, opts) {
    return opts.date ? date.toLocaleTimeString() : "";
  }
  filterAndJoin(arr) {
    return arr.filter(Boolean).join(" ");
  }
  formatLogObj(logObj, opts) {
    const message = this.formatArgs(logObj.args, opts);
    if (logObj.type === "box") {
      return "\n" + [
        bracket(logObj.tag),
        logObj.title && logObj.title,
        ...message.split("\n")
      ].filter(Boolean).map((l2) => " > " + l2).join("\n") + "\n";
    }
    return this.filterAndJoin([
      bracket(logObj.type),
      bracket(logObj.tag),
      message
    ]);
  }
  log(logObj, ctx) {
    const line = this.formatLogObj(logObj, {
      columns: ctx.options.stdout.columns || 0,
      ...ctx.options.formatOptions
    });
    return writeStream(line + "\n", logObj.level < 2 ? ctx.options.stderr || process.stderr : ctx.options.stdout || process.stdout);
  }
}
var bracket = (x2) => x2 ? `[${x2}]` : "";
var init_consola_06ad8a64 = () => {
};
function replaceClose(index, string2, close, replace2, head2 = string2.slice(0, Math.max(0, index)) + replace2, tail = string2.slice(Math.max(0, index + close.length)), next = tail.indexOf(close)) {
  return head2 + (next < 0 ? tail : replaceClose(next, tail, close, replace2));
}
function clearBleed(index, string2, open, close, replace2) {
  return index < 0 ? open + string2 + close : open + replaceClose(index, string2, close, replace2) + close;
}
function filterEmpty(open, close, replace2 = open, at = open.length + 1) {
  return (string2) => string2 || !(string2 === "" || string2 === undefined) ? clearBleed(("" + string2).indexOf(close, at), string2, open, close, replace2) : "";
}
function init(open, close, replace2) {
  return filterEmpty(`\x1B[${open}m`, `\x1B[${close}m`, replace2);
}
function createColors(useColor = isColorSupported) {
  return useColor ? colorDefs : Object.fromEntries(Object.keys(colorDefs).map((key) => [key, String]));
}
function getColor(color, fallback2 = "reset") {
  return colors[color] || colors[fallback2];
}
function stripAnsi(text) {
  return text.replace(new RegExp(ansiRegex, "g"), "");
}
function box(text, _opts = {}) {
  const opts = {
    ..._opts,
    style: {
      ...defaultStyle,
      ..._opts.style
    }
  };
  const textLines = text.split("\n");
  const boxLines = [];
  const _color = getColor(opts.style.borderColor);
  const borderStyle = {
    ...typeof opts.style.borderStyle === "string" ? boxStylePresets[opts.style.borderStyle] || boxStylePresets.solid : opts.style.borderStyle
  };
  if (_color) {
    for (const key in borderStyle) {
      borderStyle[key] = _color(borderStyle[key]);
    }
  }
  const paddingOffset = opts.style.padding % 2 === 0 ? opts.style.padding : opts.style.padding + 1;
  const height = textLines.length + paddingOffset;
  const width = Math.max(...textLines.map((line) => line.length)) + paddingOffset;
  const widthOffset = width + paddingOffset;
  const leftSpace = opts.style.marginLeft > 0 ? " ".repeat(opts.style.marginLeft) : "";
  if (opts.style.marginTop > 0) {
    boxLines.push("".repeat(opts.style.marginTop));
  }
  if (opts.title) {
    const left = borderStyle.h.repeat(Math.floor((width - stripAnsi(opts.title).length) / 2));
    const right = borderStyle.h.repeat(width - stripAnsi(opts.title).length - stripAnsi(left).length + paddingOffset);
    boxLines.push(`${leftSpace}${borderStyle.tl}${left}${opts.title}${right}${borderStyle.tr}`);
  } else {
    boxLines.push(`${leftSpace}${borderStyle.tl}${borderStyle.h.repeat(widthOffset)}${borderStyle.tr}`);
  }
  const valignOffset = opts.style.valign === "center" ? Math.floor((height - textLines.length) / 2) : opts.style.valign === "top" ? height - textLines.length - paddingOffset : height - textLines.length;
  for (let i = 0;i < height; i++) {
    if (i < valignOffset || i >= valignOffset + textLines.length) {
      boxLines.push(`${leftSpace}${borderStyle.v}${" ".repeat(widthOffset)}${borderStyle.v}`);
    } else {
      const line = textLines[i - valignOffset];
      const left = " ".repeat(paddingOffset);
      const right = " ".repeat(width - stripAnsi(line).length);
      boxLines.push(`${leftSpace}${borderStyle.v}${left}${line}${right}${borderStyle.v}`);
    }
  }
  boxLines.push(`${leftSpace}${borderStyle.bl}${borderStyle.h.repeat(widthOffset)}${borderStyle.br}`);
  if (opts.style.marginBottom > 0) {
    boxLines.push("".repeat(opts.style.marginBottom));
  }
  return boxLines.join("\n");
}
var env2;
var argv;
var platform;
var isDisabled;
var isForced;
var isWindows;
var isDumbTerminal;
var isCompatibleTerminal;
var isCI;
var isColorSupported;
var colorDefs;
var colors;
var ansiRegex;
var boxStylePresets;
var defaultStyle;
var init_utils = __esm(() => {
  ({
    env: env2 = {},
    argv = [],
    platform = ""
  } = typeof process === "undefined" ? {} : process);
  isDisabled = "NO_COLOR" in env2 || argv.includes("--no-color");
  isForced = "FORCE_COLOR" in env2 || argv.includes("--color");
  isWindows = platform === "win32";
  isDumbTerminal = env2.TERM === "dumb";
  isCompatibleTerminal = tty && tty.isatty && tty.isatty(1) && env2.TERM && !isDumbTerminal;
  isCI = "CI" in env2 && (("GITHUB_ACTIONS" in env2) || ("GITLAB_CI" in env2) || ("CIRCLECI" in env2));
  isColorSupported = !isDisabled && (isForced || isWindows && !isDumbTerminal || isCompatibleTerminal || isCI);
  colorDefs = {
    reset: init(0, 0),
    bold: init(1, 22, "\x1B[22m\x1B[1m"),
    dim: init(2, 22, "\x1B[22m\x1B[2m"),
    italic: init(3, 23),
    underline: init(4, 24),
    inverse: init(7, 27),
    hidden: init(8, 28),
    strikethrough: init(9, 29),
    black: init(30, 39),
    red: init(31, 39),
    green: init(32, 39),
    yellow: init(33, 39),
    blue: init(34, 39),
    magenta: init(35, 39),
    cyan: init(36, 39),
    white: init(37, 39),
    gray: init(90, 39),
    bgBlack: init(40, 49),
    bgRed: init(41, 49),
    bgGreen: init(42, 49),
    bgYellow: init(43, 49),
    bgBlue: init(44, 49),
    bgMagenta: init(45, 49),
    bgCyan: init(46, 49),
    bgWhite: init(47, 49),
    blackBright: init(90, 39),
    redBright: init(91, 39),
    greenBright: init(92, 39),
    yellowBright: init(93, 39),
    blueBright: init(94, 39),
    magentaBright: init(95, 39),
    cyanBright: init(96, 39),
    whiteBright: init(97, 39),
    bgBlackBright: init(100, 49),
    bgRedBright: init(101, 49),
    bgGreenBright: init(102, 49),
    bgYellowBright: init(103, 49),
    bgBlueBright: init(104, 49),
    bgMagentaBright: init(105, 49),
    bgCyanBright: init(106, 49),
    bgWhiteBright: init(107, 49)
  };
  colors = createColors();
  ansiRegex = [
    "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))"
  ].join("|");
  boxStylePresets = {
    solid: {
      tl: "\u250C",
      tr: "\u2510",
      bl: "\u2514",
      br: "\u2518",
      h: "\u2500",
      v: "\u2502"
    },
    double: {
      tl: "\u2554",
      tr: "\u2557",
      bl: "\u255A",
      br: "\u255D",
      h: "\u2550",
      v: "\u2551"
    },
    doubleSingle: {
      tl: "\u2553",
      tr: "\u2556",
      bl: "\u2559",
      br: "\u255C",
      h: "\u2500",
      v: "\u2551"
    },
    doubleSingleRounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2500",
      v: "\u2551"
    },
    singleThick: {
      tl: "\u250F",
      tr: "\u2513",
      bl: "\u2517",
      br: "\u251B",
      h: "\u2501",
      v: "\u2503"
    },
    singleDouble: {
      tl: "\u2552",
      tr: "\u2555",
      bl: "\u2558",
      br: "\u255B",
      h: "\u2550",
      v: "\u2502"
    },
    singleDoubleRounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2550",
      v: "\u2502"
    },
    rounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2500",
      v: "\u2502"
    }
  };
  defaultStyle = {
    borderColor: "white",
    borderStyle: "rounded",
    valign: "center",
    padding: 2,
    marginLeft: 1,
    marginTop: 1,
    marginBottom: 1
  };
});
var exports_prompt = {};
__export(exports_prompt, {
  prompt: () => prompt
});
function z({ onlyFirst: t = false } = {}) {
  const u = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
  return new RegExp(u, t ? undefined : "g");
}
function $2(t) {
  if (typeof t != "string")
    throw new TypeError(`Expected a \`string\`, got \`${typeof t}\``);
  return t.replace(z(), "");
}
function c(t, u = {}) {
  if (typeof t != "string" || t.length === 0 || (u = { ambiguousIsNarrow: true, ...u }, t = $2(t), t.length === 0))
    return 0;
  t = t.replace(Y(), "  ");
  const F = u.ambiguousIsNarrow ? 1 : 2;
  let e = 0;
  for (const s of t) {
    const C = s.codePointAt(0);
    if (C <= 31 || C >= 127 && C <= 159 || C >= 768 && C <= 879)
      continue;
    switch (K.eastAsianWidth(s)) {
      case "F":
      case "W":
        e += 2;
        break;
      case "A":
        e += F;
        break;
      default:
        e += 1;
    }
  }
  return e;
}
function U2() {
  const t = new Map;
  for (const [u, F] of Object.entries(r)) {
    for (const [e, s] of Object.entries(F))
      r[e] = { open: `\x1B[${s[0]}m`, close: `\x1B[${s[1]}m` }, F[e] = r[e], t.set(s[0], s[1]);
    Object.defineProperty(r, u, { value: F, enumerable: false });
  }
  return Object.defineProperty(r, "codes", { value: t, enumerable: false }), r.color.close = "\x1B[39m", r.bgColor.close = "\x1B[49m", r.color.ansi = L2(), r.color.ansi256 = M(), r.color.ansi16m = T(), r.bgColor.ansi = L2(v), r.bgColor.ansi256 = M(v), r.bgColor.ansi16m = T(v), Object.defineProperties(r, { rgbToAnsi256: { value: (u, F, e) => u === F && F === e ? u < 8 ? 16 : u > 248 ? 231 : Math.round((u - 8) / 247 * 24) + 232 : 16 + 36 * Math.round(u / 255 * 5) + 6 * Math.round(F / 255 * 5) + Math.round(e / 255 * 5), enumerable: false }, hexToRgb: { value: (u) => {
    const F = /[a-f\d]{6}|[a-f\d]{3}/i.exec(u.toString(16));
    if (!F)
      return [0, 0, 0];
    let [e] = F;
    e.length === 3 && (e = [...e].map((C) => C + C).join(""));
    const s = Number.parseInt(e, 16);
    return [s >> 16 & 255, s >> 8 & 255, s & 255];
  }, enumerable: false }, hexToAnsi256: { value: (u) => r.rgbToAnsi256(...r.hexToRgb(u)), enumerable: false }, ansi256ToAnsi: { value: (u) => {
    if (u < 8)
      return 30 + u;
    if (u < 16)
      return 90 + (u - 8);
    let F, e, s;
    if (u >= 232)
      F = ((u - 232) * 10 + 8) / 255, e = F, s = F;
    else {
      u -= 16;
      const i = u % 36;
      F = Math.floor(u / 36) / 5, e = Math.floor(i / 6) / 5, s = i % 6 / 5;
    }
    const C = Math.max(F, e, s) * 2;
    if (C === 0)
      return 30;
    let D = 30 + (Math.round(s) << 2 | Math.round(e) << 1 | Math.round(F));
    return C === 2 && (D += 60), D;
  }, enumerable: false }, rgbToAnsi: { value: (u, F, e) => r.ansi256ToAnsi(r.rgbToAnsi256(u, F, e)), enumerable: false }, hexToAnsi: { value: (u) => r.ansi256ToAnsi(r.hexToAnsi256(u)), enumerable: false } }), r;
}
function P(t, u, F) {
  return String(t).normalize().replace(/\r\n/g, `
`).split(`
`).map((e) => uD(e, u, F)).join(`
`);
}
function FD(t, u) {
  if (t === u)
    return;
  const F = t.split(`
`), e = u.split(`
`), s = [];
  for (let C = 0;C < Math.max(F.length, e.length); C++)
    F[C] !== e[C] && s.push(C);
  return s;
}
function g(t, u) {
  t.isTTY && t.setRawMode(u);
}

class h2 {
  constructor({ render: u, input: F = stdin, output: e = stdout, ...s }, C = true) {
    this._track = false, this._cursor = 0, this.state = "initial", this.error = "", this.subscribers = new Map, this._prevFrame = "", this.opts = s, this.onKeypress = this.onKeypress.bind(this), this.close = this.close.bind(this), this.render = this.render.bind(this), this._render = u.bind(this), this._track = C, this.input = F, this.output = e;
  }
  prompt() {
    const u = new WriteStream(0);
    return u._write = (F, e, s) => {
      this._track && (this.value = this.rl.line.replace(/\t/g, ""), this._cursor = this.rl.cursor, this.emit("value", this.value)), s();
    }, this.input.pipe(u), this.rl = f.createInterface({ input: this.input, output: u, tabSize: 2, prompt: "", escapeCodeTimeout: 50 }), f.emitKeypressEvents(this.input, this.rl), this.rl.prompt(), this.opts.initialValue !== undefined && this._track && this.rl.write(this.opts.initialValue), this.input.on("keypress", this.onKeypress), g(this.input, true), this.output.on("resize", this.render), this.render(), new Promise((F, e) => {
      this.once("submit", () => {
        this.output.write(src.cursor.show), this.output.off("resize", this.render), g(this.input, false), F(this.value);
      }), this.once("cancel", () => {
        this.output.write(src.cursor.show), this.output.off("resize", this.render), g(this.input, false), F(R2);
      });
    });
  }
  on(u, F) {
    const e = this.subscribers.get(u) ?? [];
    e.push({ cb: F }), this.subscribers.set(u, e);
  }
  once(u, F) {
    const e = this.subscribers.get(u) ?? [];
    e.push({ cb: F, once: true }), this.subscribers.set(u, e);
  }
  emit(u, ...F) {
    const e = this.subscribers.get(u) ?? [], s = [];
    for (const C of e)
      C.cb(...F), C.once && s.push(() => e.splice(e.indexOf(C), 1));
    for (const C of s)
      C();
  }
  unsubscribe() {
    this.subscribers.clear();
  }
  onKeypress(u, F) {
    if (this.state === "error" && (this.state = "active"), F?.name && !this._track && V.has(F.name) && this.emit("cursor", V.get(F.name)), F?.name && tD.has(F.name) && this.emit("cursor", F.name), u && (u.toLowerCase() === "y" || u.toLowerCase() === "n") && this.emit("confirm", u.toLowerCase() === "y"), u && this.emit("key", u.toLowerCase()), F?.name === "return") {
      if (this.opts.validate) {
        const e = this.opts.validate(this.value);
        e && (this.error = e, this.state = "error", this.rl.write(this.value));
      }
      this.state !== "error" && (this.state = "submit");
    }
    u === "" && (this.state = "cancel"), (this.state === "submit" || this.state === "cancel") && this.emit("finalize"), this.render(), (this.state === "submit" || this.state === "cancel") && this.close();
  }
  close() {
    this.input.unpipe(), this.input.removeListener("keypress", this.onKeypress), this.output.write(`
`), g(this.input, false), this.rl.close(), this.emit(`${this.state}`, this.value), this.unsubscribe();
  }
  restoreCursor() {
    const u = P(this._prevFrame, process.stdout.columns, { hard: true }).split(`
`).length - 1;
    this.output.write(src.cursor.move(-999, u * -1));
  }
  render() {
    const u = P(this._render(this) ?? "", process.stdout.columns, { hard: true });
    if (u !== this._prevFrame) {
      if (this.state === "initial")
        this.output.write(src.cursor.hide);
      else {
        const F = FD(this._prevFrame, u);
        if (this.restoreCursor(), F && F?.length === 1) {
          const e = F[0];
          this.output.write(src.cursor.move(0, e)), this.output.write(src.erase.lines(1));
          const s = u.split(`
`);
          this.output.write(s[e]), this._prevFrame = u, this.output.write(src.cursor.move(0, s.length - e - 1));
          return;
        } else if (F && F?.length > 1) {
          const e = F[0];
          this.output.write(src.cursor.move(0, e)), this.output.write(src.erase.down());
          const C = u.split(`
`).slice(e);
          this.output.write(C.join(`
`)), this._prevFrame = u;
          return;
        }
        this.output.write(src.erase.down());
      }
      this.output.write(u), this.state === "initial" && (this.state = "active"), this._prevFrame = u;
    }
  }
}
async function prompt(message, opts = {}) {
  if (!opts.type || opts.type === "text") {
    return await text({
      message,
      defaultValue: opts.default,
      placeholder: opts.placeholder,
      initialValue: opts.initial
    });
  }
  if (opts.type === "confirm") {
    return await confirm({
      message,
      initialValue: opts.initial
    });
  }
  if (opts.type === "select") {
    return await select({
      message,
      options: opts.options.map((o) => typeof o === "string" ? { value: o, label: o } : o)
    });
  }
  if (opts.type === "multiselect") {
    return await multiselect({
      message,
      options: opts.options.map((o) => typeof o === "string" ? { value: o, label: o } : o),
      required: opts.required
    });
  }
  throw new Error(`Unknown prompt type: ${opts.type}`);
}
var ESC = "\x1B";
var CSI;
var beep = "\x07";
var cursor;
var scroll;
var erase;
var src;
var picocolors;
var tty2;
var isColorSupported2;
var formatter = (open, close, replace2 = open) => (input) => {
  let string2 = "" + input;
  let index = string2.indexOf(close, open.length);
  return ~index ? open + replaceClose2(string2, close, replace2, index) + close : open + string2 + close;
};
var replaceClose2 = (string2, close, replace2, index) => {
  let start = string2.substring(0, index) + replace2;
  let end = string2.substring(index + close.length);
  let nextIndex = end.indexOf(close);
  return ~nextIndex ? start + replaceClose2(end, close, replace2, nextIndex) : start + end;
};
var createColors2 = (enabled = isColorSupported2) => ({
  isColorSupported: enabled,
  reset: enabled ? (s) => `\x1B[0m${s}\x1B[0m` : String,
  bold: enabled ? formatter("\x1B[1m", "\x1B[22m", "\x1B[22m\x1B[1m") : String,
  dim: enabled ? formatter("\x1B[2m", "\x1B[22m", "\x1B[22m\x1B[2m") : String,
  italic: enabled ? formatter("\x1B[3m", "\x1B[23m") : String,
  underline: enabled ? formatter("\x1B[4m", "\x1B[24m") : String,
  inverse: enabled ? formatter("\x1B[7m", "\x1B[27m") : String,
  hidden: enabled ? formatter("\x1B[8m", "\x1B[28m") : String,
  strikethrough: enabled ? formatter("\x1B[9m", "\x1B[29m") : String,
  black: enabled ? formatter("\x1B[30m", "\x1B[39m") : String,
  red: enabled ? formatter("\x1B[31m", "\x1B[39m") : String,
  green: enabled ? formatter("\x1B[32m", "\x1B[39m") : String,
  yellow: enabled ? formatter("\x1B[33m", "\x1B[39m") : String,
  blue: enabled ? formatter("\x1B[34m", "\x1B[39m") : String,
  magenta: enabled ? formatter("\x1B[35m", "\x1B[39m") : String,
  cyan: enabled ? formatter("\x1B[36m", "\x1B[39m") : String,
  white: enabled ? formatter("\x1B[37m", "\x1B[39m") : String,
  gray: enabled ? formatter("\x1B[90m", "\x1B[39m") : String,
  bgBlack: enabled ? formatter("\x1B[40m", "\x1B[49m") : String,
  bgRed: enabled ? formatter("\x1B[41m", "\x1B[49m") : String,
  bgGreen: enabled ? formatter("\x1B[42m", "\x1B[49m") : String,
  bgYellow: enabled ? formatter("\x1B[43m", "\x1B[49m") : String,
  bgBlue: enabled ? formatter("\x1B[44m", "\x1B[49m") : String,
  bgMagenta: enabled ? formatter("\x1B[45m", "\x1B[49m") : String,
  bgCyan: enabled ? formatter("\x1B[46m", "\x1B[49m") : String,
  bgWhite: enabled ? formatter("\x1B[47m", "\x1B[49m") : String
});
var picocolorsExports;
var l2;
var m;
var G;
var K;
var Y = function() {
  return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
};
var v = 10;
var L2 = (t = 0) => (u) => `\x1B[${u + t}m`;
var M = (t = 0) => (u) => `\x1B[${38 + t};5;${u}m`;
var T = (t = 0) => (u, F, e) => `\x1B[${38 + t};2;${u};${F};${e}m`;
var r;
var Z;
var H;
var q2;
var p;
var J = 39;
var b = "\x07";
var W2 = "[";
var Q = "]";
var I2 = "m";
var w;
var N2 = (t) => `${p.values().next().value}${W2}${t}${I2}`;
var j = (t) => `${p.values().next().value}${w}${t}${b}`;
var X2 = (t) => t.split(" ").map((u) => c(u));
var _ = (t, u, F) => {
  const e = [...u];
  let s = false, C = false, D = c($2(t[t.length - 1]));
  for (const [i, o] of e.entries()) {
    const E = c(o);
    if (D + E <= F ? t[t.length - 1] += o : (t.push(o), D = 0), p.has(o) && (s = true, C = e.slice(i + 1).join("").startsWith(w)), s) {
      C ? o === b && (s = false, C = false) : o === I2 && (s = false);
      continue;
    }
    D += E, D === F && i < e.length - 1 && (t.push(""), D = 0);
  }
  !D && t[t.length - 1].length > 0 && t.length > 1 && (t[t.length - 2] += t.pop());
};
var DD = (t) => {
  const u = t.split(" ");
  let F = u.length;
  for (;F > 0 && !(c(u[F - 1]) > 0); )
    F--;
  return F === u.length ? t : u.slice(0, F).join(" ") + u.slice(F).join("");
};
var uD = (t, u, F = {}) => {
  if (F.trim !== false && t.trim() === "")
    return "";
  let e = "", s, C;
  const D = X2(t);
  let i = [""];
  for (const [E, a] of t.split(" ").entries()) {
    F.trim !== false && (i[i.length - 1] = i[i.length - 1].trimStart());
    let n = c(i[i.length - 1]);
    if (E !== 0 && (n >= u && (F.wordWrap === false || F.trim === false) && (i.push(""), n = 0), (n > 0 || F.trim === false) && (i[i.length - 1] += " ", n++)), F.hard && D[E] > u) {
      const B = u - n, A = 1 + Math.floor((D[E] - B - 1) / u);
      Math.floor((D[E] - 1) / u) < A && i.push(""), _(i, a, u);
      continue;
    }
    if (n + D[E] > u && n > 0 && D[E] > 0) {
      if (F.wordWrap === false && n < u) {
        _(i, a, u);
        continue;
      }
      i.push("");
    }
    if (n + D[E] > u && F.wordWrap === false) {
      _(i, a, u);
      continue;
    }
    i[i.length - 1] += a;
  }
  F.trim !== false && (i = i.map((E) => DD(E)));
  const o = [...i.join(`
`)];
  for (const [E, a] of o.entries()) {
    if (e += a, p.has(a)) {
      const { groups: B } = new RegExp(`(?:\\${W2}(?<code>\\d+)m|\\${w}(?<uri>.*)${b})`).exec(o.slice(E).join("")) || { groups: {} };
      if (B.code !== undefined) {
        const A = Number.parseFloat(B.code);
        s = A === J ? undefined : A;
      } else
        B.uri !== undefined && (C = B.uri.length === 0 ? undefined : B.uri);
    }
    const n = q2.codes.get(Number(s));
    o[E + 1] === `
` ? (C && (e += j("")), s && n && (e += N2(n))) : a === `
` && (s && n && (e += N2(s)), C && (e += j(C)));
  }
  return e;
};
var R2;
var V;
var tD;
var sD;
var iD;
var ED;
var oD;
var unicode;
var s = (c2, fallback2) => unicode ? c2 : fallback2;
var S_STEP_ACTIVE;
var S_STEP_CANCEL;
var S_STEP_ERROR;
var S_STEP_SUBMIT;
var S_BAR = "";
var S_BAR_END = "";
var S_RADIO_ACTIVE;
var S_RADIO_INACTIVE;
var S_CHECKBOX_ACTIVE;
var S_CHECKBOX_SELECTED;
var S_CHECKBOX_INACTIVE;
var symbol = (state) => {
  switch (state) {
    case "initial":
    case "active": {
      return colors.cyan(S_STEP_ACTIVE);
    }
    case "cancel": {
      return colors.red(S_STEP_CANCEL);
    }
    case "error": {
      return colors.yellow(S_STEP_ERROR);
    }
    case "submit": {
      return colors.green(S_STEP_SUBMIT);
    }
  }
};
var text = (opts) => {
  return new oD({
    validate: opts.validate,
    placeholder: opts.placeholder,
    defaultValue: opts.defaultValue,
    initialValue: opts.initialValue,
    render() {
      const title = `${colors.gray(S_BAR)}
${symbol(this.state)} ${opts.message}
`;
      const placeholder = opts.placeholder ? colors.inverse(opts.placeholder[0]) + colors.dim(opts.placeholder.slice(1)) : colors.inverse(colors.hidden("_"));
      const value = this.value ? this.valueWithCursor : placeholder;
      switch (this.state) {
        case "error": {
          return `${title.trim()}
${colors.yellow(S_BAR)} ${value}
${colors.yellow(S_BAR_END)} ${colors.yellow(this.error)}
`;
        }
        case "submit": {
          return `${title}${colors.gray(S_BAR)} ${colors.dim(this.value || opts.placeholder)}`;
        }
        case "cancel": {
          return `${title}${colors.gray(S_BAR)} ${colors.strikethrough(colors.dim(this.value ?? ""))}${this.value?.trim() ? "\n" + colors.gray(S_BAR) : ""}`;
        }
        default: {
          return `${title}${colors.cyan(S_BAR)} ${value}
${colors.cyan(S_BAR_END)}
`;
        }
      }
    }
  }).prompt();
};
var confirm = (opts) => {
  const active = opts.active ?? "Yes";
  const inactive = opts.inactive ?? "No";
  return new sD({
    active,
    inactive,
    initialValue: opts.initialValue ?? true,
    render() {
      const title = `${colors.gray(S_BAR)}
${symbol(this.state)} ${opts.message}
`;
      const value = this.value ? active : inactive;
      switch (this.state) {
        case "submit": {
          return `${title}${colors.gray(S_BAR)} ${colors.dim(value)}`;
        }
        case "cancel": {
          return `${title}${colors.gray(S_BAR)} ${colors.strikethrough(colors.dim(value))}
${colors.gray(S_BAR)}`;
        }
        default: {
          return `${title}${colors.cyan(S_BAR)} ${this.value ? `${colors.green(S_RADIO_ACTIVE)} ${active}` : `${colors.dim(S_RADIO_INACTIVE)} ${colors.dim(active)}`} ${colors.dim("/")} ${this.value ? `${colors.dim(S_RADIO_INACTIVE)} ${colors.dim(inactive)}` : `${colors.green(S_RADIO_ACTIVE)} ${inactive}`}
${colors.cyan(S_BAR_END)}
`;
        }
      }
    }
  }).prompt();
};
var select = (opts) => {
  const opt = (option, state) => {
    const label = option.label ?? String(option.value);
    switch (state) {
      case "active": {
        return `${colors.green(S_RADIO_ACTIVE)} ${label} ${option.hint ? colors.dim(`(${option.hint})`) : ""}`;
      }
      case "selected": {
        return `${colors.dim(label)}`;
      }
      case "cancelled": {
        return `${colors.strikethrough(colors.dim(label))}`;
      }
    }
    return `${colors.dim(S_RADIO_INACTIVE)} ${colors.dim(label)}`;
  };
  return new ED({
    options: opts.options,
    initialValue: opts.initialValue,
    render() {
      const title = `${colors.gray(S_BAR)}
${symbol(this.state)} ${opts.message}
`;
      switch (this.state) {
        case "submit": {
          return `${title}${colors.gray(S_BAR)} ${opt(this.options[this.cursor], "selected")}`;
        }
        case "cancel": {
          return `${title}${colors.gray(S_BAR)} ${opt(this.options[this.cursor], "cancelled")}
${colors.gray(S_BAR)}`;
        }
        default: {
          return `${title}${colors.cyan(S_BAR)} ${this.options.map((option, i) => opt(option, i === this.cursor ? "active" : "inactive")).join(`
${colors.cyan(S_BAR)}  `)}
${colors.cyan(S_BAR_END)}
`;
        }
      }
    }
  }).prompt();
};
var multiselect = (opts) => {
  const opt = (option, state) => {
    const label = option.label ?? String(option.value);
    switch (state) {
      case "active": {
        return `${colors.cyan(S_CHECKBOX_ACTIVE)} ${label} ${option.hint ? colors.dim(`(${option.hint})`) : ""}`;
      }
      case "selected": {
        return `${colors.green(S_CHECKBOX_SELECTED)} ${colors.dim(label)}`;
      }
      case "cancelled": {
        return `${colors.strikethrough(colors.dim(label))}`;
      }
      case "active-selected": {
        return `${colors.green(S_CHECKBOX_SELECTED)} ${label} ${option.hint ? colors.dim(`(${option.hint})`) : ""}`;
      }
      case "submitted": {
        return `${colors.dim(label)}`;
      }
    }
    return `${colors.dim(S_CHECKBOX_INACTIVE)} ${colors.dim(label)}`;
  };
  return new iD({
    options: opts.options,
    initialValues: opts.initialValues,
    required: opts.required ?? true,
    cursorAt: opts.cursorAt,
    validate(selected) {
      if (this.required && selected.length === 0) {
        return `Please select at least one option.
${colors.reset(colors.dim(`Press ${colors.gray(colors.bgWhite(colors.inverse(" space ")))} to select, ${colors.gray(colors.bgWhite(colors.inverse(" enter ")))} to submit`))}`;
      }
    },
    render() {
      const title = `${colors.gray(S_BAR)}
${symbol(this.state)} ${opts.message}
`;
      switch (this.state) {
        case "submit": {
          return `${title}${colors.gray(S_BAR)} ${this.options.filter(({ value }) => this.value.includes(value)).map((option) => opt(option, "submitted")).join(colors.dim(", ")) || colors.dim("none")}`;
        }
        case "cancel": {
          const label = this.options.filter(({ value }) => this.value.includes(value)).map((option) => opt(option, "cancelled")).join(colors.dim(", "));
          return `${title}${colors.gray(S_BAR)} ${label.trim() ? `${label}
${colors.gray(S_BAR)}` : ""}`;
        }
        case "error": {
          const footer = this.error.split("\n").map((ln, i) => i === 0 ? `${colors.yellow(S_BAR_END)} ${colors.yellow(ln)}` : `   ${ln}`).join("\n");
          return title + colors.yellow(S_BAR) + "  " + this.options.map((option, i) => {
            const selected = this.value.includes(option.value);
            const active = i === this.cursor;
            if (active && selected) {
              return opt(option, "active-selected");
            }
            if (selected) {
              return opt(option, "selected");
            }
            return opt(option, active ? "active" : "inactive");
          }).join(`
${colors.yellow(S_BAR)}  `) + "\n" + footer + "\n";
        }
        default: {
          return `${title}${colors.cyan(S_BAR)} ${this.options.map((option, i) => {
            const selected = this.value.includes(option.value);
            const active = i === this.cursor;
            if (active && selected) {
              return opt(option, "active-selected");
            }
            if (selected) {
              return opt(option, "selected");
            }
            return opt(option, active ? "active" : "inactive");
          }).join(`
${colors.cyan(S_BAR)}  `)}
${colors.cyan(S_BAR_END)}
`;
        }
      }
    }
  }).prompt();
};
var init_prompt = __esm(() => {
  init_consola_36c0034f();
  init_utils();
  init_core();
  init_consola_06ad8a64();
  CSI = `${ESC}[`;
  cursor = {
    to(x2, y) {
      if (!y)
        return `${CSI}${x2 + 1}G`;
      return `${CSI}${y + 1};${x2 + 1}H`;
    },
    move(x2, y) {
      let ret = "";
      if (x2 < 0)
        ret += `${CSI}${-x2}D`;
      else if (x2 > 0)
        ret += `${CSI}${x2}C`;
      if (y < 0)
        ret += `${CSI}${-y}A`;
      else if (y > 0)
        ret += `${CSI}${y}B`;
      return ret;
    },
    up: (count = 1) => `${CSI}${count}A`,
    down: (count = 1) => `${CSI}${count}B`,
    forward: (count = 1) => `${CSI}${count}C`,
    backward: (count = 1) => `${CSI}${count}D`,
    nextLine: (count = 1) => `${CSI}E`.repeat(count),
    prevLine: (count = 1) => `${CSI}F`.repeat(count),
    left: `${CSI}G`,
    hide: `${CSI}?25l`,
    show: `${CSI}?25h`,
    save: `${ESC}7`,
    restore: `${ESC}8`
  };
  scroll = {
    up: (count = 1) => `${CSI}S`.repeat(count),
    down: (count = 1) => `${CSI}T`.repeat(count)
  };
  erase = {
    screen: `${CSI}2J`,
    up: (count = 1) => `${CSI}1J`.repeat(count),
    down: (count = 1) => `${CSI}J`.repeat(count),
    line: `${CSI}2K`,
    lineEnd: `${CSI}K`,
    lineStart: `${CSI}1K`,
    lines(count) {
      let clear = "";
      for (let i = 0;i < count; i++)
        clear += this.line + (i < count - 1 ? cursor.up() : "");
      if (count)
        clear += cursor.left;
      return clear;
    }
  };
  src = { cursor, scroll, erase, beep };
  picocolors = { exports: {} };
  tty2 = require$$0;
  isColorSupported2 = !(("NO_COLOR" in process.env) || process.argv.includes("--no-color")) && (("FORCE_COLOR" in process.env) || process.argv.includes("--color") || process.platform === "win32" || tty2.isatty(1) && true || ("CI" in process.env));
  picocolors.exports = createColors2();
  picocolors.exports.createColors = createColors2;
  picocolorsExports = picocolors.exports;
  l2 = /* @__PURE__ */ getDefaultExportFromCjs(picocolorsExports);
  m = {};
  G = { get exports() {
    return m;
  }, set exports(t) {
    m = t;
  } };
  (function(t) {
    var u = {};
    t.exports = u, u.eastAsianWidth = function(e) {
      var s2 = e.charCodeAt(0), C = e.length == 2 ? e.charCodeAt(1) : 0, D = s2;
      return 55296 <= s2 && s2 <= 56319 && 56320 <= C && C <= 57343 && (s2 &= 1023, C &= 1023, D = s2 << 10 | C, D += 65536), D == 12288 || 65281 <= D && D <= 65376 || 65504 <= D && D <= 65510 ? "F" : D == 8361 || 65377 <= D && D <= 65470 || 65474 <= D && D <= 65479 || 65482 <= D && D <= 65487 || 65490 <= D && D <= 65495 || 65498 <= D && D <= 65500 || 65512 <= D && D <= 65518 ? "H" : 4352 <= D && D <= 4447 || 4515 <= D && D <= 4519 || 4602 <= D && D <= 4607 || 9001 <= D && D <= 9002 || 11904 <= D && D <= 11929 || 11931 <= D && D <= 12019 || 12032 <= D && D <= 12245 || 12272 <= D && D <= 12283 || 12289 <= D && D <= 12350 || 12353 <= D && D <= 12438 || 12441 <= D && D <= 12543 || 12549 <= D && D <= 12589 || 12593 <= D && D <= 12686 || 12688 <= D && D <= 12730 || 12736 <= D && D <= 12771 || 12784 <= D && D <= 12830 || 12832 <= D && D <= 12871 || 12880 <= D && D <= 13054 || 13056 <= D && D <= 19903 || 19968 <= D && D <= 42124 || 42128 <= D && D <= 42182 || 43360 <= D && D <= 43388 || 44032 <= D && D <= 55203 || 55216 <= D && D <= 55238 || 55243 <= D && D <= 55291 || 63744 <= D && D <= 64255 || 65040 <= D && D <= 65049 || 65072 <= D && D <= 65106 || 65108 <= D && D <= 65126 || 65128 <= D && D <= 65131 || 110592 <= D && D <= 110593 || 127488 <= D && D <= 127490 || 127504 <= D && D <= 127546 || 127552 <= D && D <= 127560 || 127568 <= D && D <= 127569 || 131072 <= D && D <= 194367 || 177984 <= D && D <= 196605 || 196608 <= D && D <= 262141 ? "W" : 32 <= D && D <= 126 || 162 <= D && D <= 163 || 165 <= D && D <= 166 || D == 172 || D == 175 || 10214 <= D && D <= 10221 || 10629 <= D && D <= 10630 ? "Na" : D == 161 || D == 164 || 167 <= D && D <= 168 || D == 170 || 173 <= D && D <= 174 || 176 <= D && D <= 180 || 182 <= D && D <= 186 || 188 <= D && D <= 191 || D == 198 || D == 208 || 215 <= D && D <= 216 || 222 <= D && D <= 225 || D == 230 || 232 <= D && D <= 234 || 236 <= D && D <= 237 || D == 240 || 242 <= D && D <= 243 || 247 <= D && D <= 250 || D == 252 || D == 254 || D == 257 || D == 273 || D == 275 || D == 283 || 294 <= D && D <= 295 || D == 299 || 305 <= D && D <= 307 || D == 312 || 319 <= D && D <= 322 || D == 324 || 328 <= D && D <= 331 || D == 333 || 338 <= D && D <= 339 || 358 <= D && D <= 359 || D == 363 || D == 462 || D == 464 || D == 466 || D == 468 || D == 470 || D == 472 || D == 474 || D == 476 || D == 593 || D == 609 || D == 708 || D == 711 || 713 <= D && D <= 715 || D == 717 || D == 720 || 728 <= D && D <= 731 || D == 733 || D == 735 || 768 <= D && D <= 879 || 913 <= D && D <= 929 || 931 <= D && D <= 937 || 945 <= D && D <= 961 || 963 <= D && D <= 969 || D == 1025 || 1040 <= D && D <= 1103 || D == 1105 || D == 8208 || 8211 <= D && D <= 8214 || 8216 <= D && D <= 8217 || 8220 <= D && D <= 8221 || 8224 <= D && D <= 8226 || 8228 <= D && D <= 8231 || D == 8240 || 8242 <= D && D <= 8243 || D == 8245 || D == 8251 || D == 8254 || D == 8308 || D == 8319 || 8321 <= D && D <= 8324 || D == 8364 || D == 8451 || D == 8453 || D == 8457 || D == 8467 || D == 8470 || 8481 <= D && D <= 8482 || D == 8486 || D == 8491 || 8531 <= D && D <= 8532 || 8539 <= D && D <= 8542 || 8544 <= D && D <= 8555 || 8560 <= D && D <= 8569 || D == 8585 || 8592 <= D && D <= 8601 || 8632 <= D && D <= 8633 || D == 8658 || D == 8660 || D == 8679 || D == 8704 || 8706 <= D && D <= 8707 || 8711 <= D && D <= 8712 || D == 8715 || D == 8719 || D == 8721 || D == 8725 || D == 8730 || 8733 <= D && D <= 8736 || D == 8739 || D == 8741 || 8743 <= D && D <= 8748 || D == 8750 || 8756 <= D && D <= 8759 || 8764 <= D && D <= 8765 || D == 8776 || D == 8780 || D == 8786 || 8800 <= D && D <= 8801 || 8804 <= D && D <= 8807 || 8810 <= D && D <= 8811 || 8814 <= D && D <= 8815 || 8834 <= D && D <= 8835 || 8838 <= D && D <= 8839 || D == 8853 || D == 8857 || D == 8869 || D == 8895 || D == 8978 || 9312 <= D && D <= 9449 || 9451 <= D && D <= 9547 || 9552 <= D && D <= 9587 || 9600 <= D && D <= 9615 || 9618 <= D && D <= 9621 || 9632 <= D && D <= 9633 || 9635 <= D && D <= 9641 || 9650 <= D && D <= 9651 || 9654 <= D && D <= 9655 || 9660 <= D && D <= 9661 || 9664 <= D && D <= 9665 || 9670 <= D && D <= 9672 || D == 9675 || 9678 <= D && D <= 9681 || 9698 <= D && D <= 9701 || D == 9711 || 9733 <= D && D <= 9734 || D == 9737 || 9742 <= D && D <= 9743 || 9748 <= D && D <= 9749 || D == 9756 || D == 9758 || D == 9792 || D == 9794 || 9824 <= D && D <= 9825 || 9827 <= D && D <= 9829 || 9831 <= D && D <= 9834 || 9836 <= D && D <= 9837 || D == 9839 || 9886 <= D && D <= 9887 || 9918 <= D && D <= 9919 || 9924 <= D && D <= 9933 || 9935 <= D && D <= 9953 || D == 9955 || 9960 <= D && D <= 9983 || D == 10045 || D == 10071 || 10102 <= D && D <= 10111 || 11093 <= D && D <= 11097 || 12872 <= D && D <= 12879 || 57344 <= D && D <= 63743 || 65024 <= D && D <= 65039 || D == 65533 || 127232 <= D && D <= 127242 || 127248 <= D && D <= 127277 || 127280 <= D && D <= 127337 || 127344 <= D && D <= 127386 || 917760 <= D && D <= 917999 || 983040 <= D && D <= 1048573 || 1048576 <= D && D <= 1114109 ? "A" : "N";
    }, u.characterLength = function(e) {
      var s2 = this.eastAsianWidth(e);
      return s2 == "F" || s2 == "W" || s2 == "A" ? 2 : 1;
    };
    function F(e) {
      return e.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]|[^\uD800-\uDFFF]/g) || [];
    }
    u.length = function(e) {
      for (var s2 = F(e), C = 0, D = 0;D < s2.length; D++)
        C = C + this.characterLength(s2[D]);
      return C;
    }, u.slice = function(e, s2, C) {
      textLen = u.length(e), s2 = s2 || 0, C = C || 1, s2 < 0 && (s2 = textLen + s2), C < 0 && (C = textLen + C);
      for (var D = "", i = 0, o = F(e), E = 0;E < o.length; E++) {
        var a = o[E], n = u.length(a);
        if (i >= s2 - (n == 2 ? 1 : 0))
          if (i + n <= C)
            D += a;
          else
            break;
        i += n;
      }
      return D;
    };
  })(G);
  K = m;
  r = { modifier: { reset: [0, 0], bold: [1, 22], dim: [2, 22], italic: [3, 23], underline: [4, 24], overline: [53, 55], inverse: [7, 27], hidden: [8, 28], strikethrough: [9, 29] }, color: { black: [30, 39], red: [31, 39], green: [32, 39], yellow: [33, 39], blue: [34, 39], magenta: [35, 39], cyan: [36, 39], white: [37, 39], blackBright: [90, 39], gray: [90, 39], grey: [90, 39], redBright: [91, 39], greenBright: [92, 39], yellowBright: [93, 39], blueBright: [94, 39], magentaBright: [95, 39], cyanBright: [96, 39], whiteBright: [97, 39] }, bgColor: { bgBlack: [40, 49], bgRed: [41, 49], bgGreen: [42, 49], bgYellow: [43, 49], bgBlue: [44, 49], bgMagenta: [45, 49], bgCyan: [46, 49], bgWhite: [47, 49], bgBlackBright: [100, 49], bgGray: [100, 49], bgGrey: [100, 49], bgRedBright: [101, 49], bgGreenBright: [102, 49], bgYellowBright: [103, 49], bgBlueBright: [104, 49], bgMagentaBright: [105, 49], bgCyanBright: [106, 49], bgWhiteBright: [107, 49] } };
  Object.keys(r.modifier);
  Z = Object.keys(r.color);
  H = Object.keys(r.bgColor);
  [...Z];
  q2 = U2();
  p = new Set(["\x1B", "\x9B"]);
  w = `${Q}8;;`;
  R2 = Symbol("clack:cancel");
  V = new Map([["k", "up"], ["j", "down"], ["h", "left"], ["l", "right"]]);
  tD = new Set(["up", "down", "left", "right", "space", "enter"]);
  sD = class sD2 extends h2 {
    get cursor() {
      return this.value ? 0 : 1;
    }
    get _value() {
      return this.cursor === 0;
    }
    constructor(u) {
      super(u, false), this.value = !!u.initialValue, this.on("value", () => {
        this.value = this._value;
      }), this.on("confirm", (F) => {
        this.output.write(src.cursor.move(0, -1)), this.value = F, this.state = "submit", this.close();
      }), this.on("cursor", () => {
        this.value = !this.value;
      });
    }
  };
  iD = class iD2 extends h2 {
    constructor(u) {
      super(u, false), this.cursor = 0, this.options = u.options, this.value = [...u.initialValues ?? []], this.cursor = Math.max(this.options.findIndex(({ value: F }) => F === u.cursorAt), 0), this.on("key", (F) => {
        F === "a" && this.toggleAll();
      }), this.on("cursor", (F) => {
        switch (F) {
          case "left":
          case "up":
            this.cursor = this.cursor === 0 ? this.options.length - 1 : this.cursor - 1;
            break;
          case "down":
          case "right":
            this.cursor = this.cursor === this.options.length - 1 ? 0 : this.cursor + 1;
            break;
          case "space":
            this.toggleValue();
            break;
        }
      });
    }
    get _value() {
      return this.options[this.cursor].value;
    }
    toggleAll() {
      const u = this.value.length === this.options.length;
      this.value = u ? [] : this.options.map((F) => F.value);
    }
    toggleValue() {
      const u = this.value.includes(this._value);
      this.value = u ? this.value.filter((F) => F !== this._value) : [...this.value, this._value];
    }
  };
  ED = class ED2 extends h2 {
    constructor(u) {
      super(u, false), this.cursor = 0, this.options = u.options, this.cursor = this.options.findIndex(({ value: F }) => F === u.initialValue), this.cursor === -1 && (this.cursor = 0), this.changeValue(), this.on("cursor", (F) => {
        switch (F) {
          case "left":
          case "up":
            this.cursor = this.cursor === 0 ? this.options.length - 1 : this.cursor - 1;
            break;
          case "down":
          case "right":
            this.cursor = this.cursor === this.options.length - 1 ? 0 : this.cursor + 1;
            break;
        }
        this.changeValue();
      });
    }
    get _value() {
      return this.options[this.cursor];
    }
    changeValue() {
      this.value = this._value.value;
    }
  };
  oD = class oD2 extends h2 {
    constructor(u) {
      super(u), this.valueWithCursor = "", this.on("finalize", () => {
        this.value || (this.value = u.defaultValue), this.valueWithCursor = this.value;
      }), this.on("value", () => {
        if (this.cursor >= this.value.length)
          this.valueWithCursor = `${this.value}${l2.inverse(l2.hidden("_"))}`;
        else {
          const F = this.value.slice(0, this.cursor), e = this.value.slice(this.cursor);
          this.valueWithCursor = `${F}${l2.inverse(e[0])}${e.slice(1)}`;
        }
      });
    }
    get cursor() {
      return this._cursor;
    }
  };
  unicode = isUnicodeSupported();
  S_STEP_ACTIVE = s("\u276F", ">");
  S_STEP_CANCEL = s("\u25A0", "x");
  S_STEP_ERROR = s("\u25B2", "x");
  S_STEP_SUBMIT = s("\u2714", "\u221A");
  S_RADIO_ACTIVE = s("\u25CF", ">");
  S_RADIO_INACTIVE = s("\u25CB", " ");
  S_CHECKBOX_ACTIVE = s("\u25FB", "[\u2022]");
  S_CHECKBOX_SELECTED = s("\u25FC", "[+]");
  S_CHECKBOX_INACTIVE = s("\u25FB", "[ ]");
});
function detectProvider(env3) {
  for (const provider of providers) {
    const envName = provider[1] || provider[0];
    if (env3[envName]) {
      return {
        name: provider[0].toLowerCase(),
        ...provider[2]
      };
    }
  }
  if (env3.SHELL && env3.SHELL === "/bin/jsh") {
    return {
      name: "stackblitz",
      ci: false
    };
  }
  return {
    name: "",
    ci: false
  };
}
function toBoolean(val2) {
  return val2 ? val2 !== "false" : false;
}
function ansiRegex2({ onlyFirst = false } = {}) {
  const pattern = [
    "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"
  ].join("|");
  return new RegExp(pattern, onlyFirst ? undefined : "g");
}
function stripAnsi2(string2) {
  if (typeof string2 !== "string") {
    throw new TypeError(`Expected a \`string\`, got \`${typeof string2}\``);
  }
  return string2.replace(regex, "");
}
function getDefaultExportFromCjs(x2) {
  return x2 && x2.__esModule && Object.prototype.hasOwnProperty.call(x2, "default") ? x2["default"] : x2;
}
function stringWidth$1(string2, options2) {
  if (typeof string2 !== "string" || string2.length === 0) {
    return 0;
  }
  options2 = {
    ambiguousIsNarrow: true,
    countAnsiEscapeCodes: false,
    ...options2
  };
  if (!options2.countAnsiEscapeCodes) {
    string2 = stripAnsi2(string2);
  }
  if (string2.length === 0) {
    return 0;
  }
  const ambiguousCharacterWidth = options2.ambiguousIsNarrow ? 1 : 2;
  let width = 0;
  for (const { segment: character } of new Intl.Segmenter().segment(string2)) {
    const codePoint = character.codePointAt(0);
    if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
      continue;
    }
    if (codePoint >= 768 && codePoint <= 879) {
      continue;
    }
    if (emojiRegex().test(character)) {
      width += 2;
      continue;
    }
    const code = eastAsianWidth.eastAsianWidth(character);
    switch (code) {
      case "F":
      case "W": {
        width += 2;
        break;
      }
      case "A": {
        width += ambiguousCharacterWidth;
        break;
      }
      default: {
        width += 1;
      }
    }
  }
  return width;
}
function isUnicodeSupported() {
  if (process$1.platform !== "win32") {
    return process$1.env.TERM !== "linux";
  }
  return Boolean(process$1.env.CI) || Boolean(process$1.env.WT_SESSION) || Boolean(process$1.env.TERMINUS_SUBLIME) || process$1.env.ConEmuTask === "{cmd::Cmder}" || process$1.env.TERM_PROGRAM === "Terminus-Sublime" || process$1.env.TERM_PROGRAM === "vscode" || process$1.env.TERM === "xterm-256color" || process$1.env.TERM === "alacritty" || process$1.env.TERMINAL_EMULATOR === "JetBrains-JediTerm";
}
function stringWidth(str) {
  if (!Intl.Segmenter) {
    return stripAnsi(str).length;
  }
  return stringWidth$1(str);
}
function characterFormat(str) {
  return str.replace(/`([^`]+)`/gm, (_2, m2) => colors.cyan(m2)).replace(/\s+_([^_]+)_\s+/gm, (_2, m2) => ` ${colors.underline(m2)} `);
}
function getColor2(color = "white") {
  return colors[color] || colors.white;
}
function getBgColor(color = "bgWhite") {
  return colors[`bg${color[0].toUpperCase()}${color.slice(1)}`] || colors.bgWhite;
}
function createConsola2(options2 = {}) {
  let level = _getDefaultLogLevel();
  if (process.env.CONSOLA_LEVEL) {
    level = Number.parseInt(process.env.CONSOLA_LEVEL) ?? level;
  }
  const consola2 = createConsola({
    level,
    defaults: { level },
    stdout: process.stdout,
    stderr: process.stderr,
    prompt: (...args) => Promise.resolve().then(() => (init_prompt(), exports_prompt)).then((m2) => m2.prompt(...args)),
    reporters: options2.reporters || [
      options2.fancy ?? !(isCI2 || isTest) ? new FancyReporter : new BasicReporter
    ],
    ...options2
  });
  return consola2;
}
function _getDefaultLogLevel() {
  if (isDebug) {
    return LogLevels.debug;
  }
  if (isTest) {
    return LogLevels.warn;
  }
  return LogLevels.info;
}
var providers;
var processShim;
var envShim;
var providerInfo;
var nodeENV;
var isCI2;
var hasTTY;
var isDebug;
var isTest;
var regex;
var eastasianwidth;
var eastasianwidthExports;
var eastAsianWidth;
var emojiRegex = () => {
  return /[#*0-9]\uFE0F?\u20E3|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26AA\u26B0\u26B1\u26BD\u26BE\u26C4\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0-\u26F5\u26F7\u26F8\u26FA\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2757\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B55\u3030\u303D\u3297\u3299]\uFE0F?|[\u261D\u270C\u270D](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\u270A\u270B](?:\uD83C[\uDFFB-\uDFFF])?|[\u23E9-\u23EC\u23F0\u23F3\u25FD\u2693\u26A1\u26AB\u26C5\u26CE\u26D4\u26EA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2795-\u2797\u27B0\u27BF\u2B50]|\u26F9(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\u2764\uFE0F?(?:\u200D(?:\uD83D\uDD25|\uD83E\uDE79))?|\uD83C(?:[\uDC04\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]\uFE0F?|[\uDF85\uDFC2\uDFC7](?:\uD83C[\uDFFB-\uDFFF])?|[\uDFC3\uDFC4\uDFCA](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDFCB\uDFCC](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uDDE6\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF]|\uDDE7\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF]|\uDDE8\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF]|\uDDE9\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF]|\uDDEA\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA]|\uDDEB\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7]|\uDDEC\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE]|\uDDED\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA]|\uDDEE\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9]|\uDDEF\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5]|\uDDF0\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF]|\uDDF1\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE]|\uDDF2\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF]|\uDDF3\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF]|\uDDF4\uD83C\uDDF2|\uDDF5\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE]|\uDDF6\uD83C\uDDE6|\uDDF7\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC]|\uDDF8\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF]|\uDDF9\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF]|\uDDFA\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF]|\uDDFB\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA]|\uDDFC\uD83C[\uDDEB\uDDF8]|\uDDFD\uD83C\uDDF0|\uDDFE\uD83C[\uDDEA\uDDF9]|\uDDFF\uD83C[\uDDE6\uDDF2\uDDFC]|\uDFF3\uFE0F?(?:\u200D(?:\u26A7\uFE0F?|\uD83C\uDF08))?|\uDFF4(?:\u200D\u2620\uFE0F?|\uDB40\uDC67\uDB40\uDC62\uDB40(?:\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDC73\uDB40\uDC63\uDB40\uDC74|\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F)?)|\uD83D(?:[\uDC08\uDC26](?:\u200D\u2B1B)?|[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3]\uFE0F?|[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC](?:\uD83C[\uDFFB-\uDFFF])?|[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD74\uDD90](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC25\uDC27-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEDC-\uDEDF\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB\uDFF0]|\uDC15(?:\u200D\uD83E\uDDBA)?|\uDC3B(?:\u200D\u2744\uFE0F?)?|\uDC41\uFE0F?(?:\u200D\uD83D\uDDE8\uFE0F?)?|\uDC68(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDC68\uDC69]\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFE])))?))?|\uDC69(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?[\uDC68\uDC69]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?|\uDC69\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?))|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFE])))?))?|\uDC6F(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDD75(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDE2E(?:\u200D\uD83D\uDCA8)?|\uDE35(?:\u200D\uD83D\uDCAB)?|\uDE36(?:\u200D\uD83C\uDF2B\uFE0F?)?)|\uD83E(?:[\uDD0C\uDD0F\uDD18-\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5\uDEC3-\uDEC5\uDEF0\uDEF2-\uDEF8](?:\uD83C[\uDFFB-\uDFFF])?|[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDDDE\uDDDF](?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD0D\uDD0E\uDD10-\uDD17\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCC\uDDD0\uDDE0-\uDDFF\uDE70-\uDE7C\uDE80-\uDE88\uDE90-\uDEBD\uDEBF-\uDEC2\uDECE-\uDEDB\uDEE0-\uDEE8]|\uDD3C(?:\u200D[\u2640\u2642]\uFE0F?|\uD83C[\uDFFB-\uDFFF])?|\uDDD1(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFC-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFD-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFD\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFE]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?))?|\uDEF1(?:\uD83C(?:\uDFFB(?:\u200D\uD83E\uDEF2\uD83C[\uDFFC-\uDFFF])?|\uDFFC(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFD-\uDFFF])?|\uDFFD(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])?|\uDFFE(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFD\uDFFF])?|\uDFFF(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFE])?))?)/g;
};
var TYPE_COLOR_MAP;
var LEVEL_COLOR_MAP;
var unicode2;
var s2 = (c2, fallback2) => unicode2 ? c2 : fallback2;
var TYPE_ICONS;
var FancyReporter;
var consola;
var init_consola_36c0034f = __esm(() => {
  init_core();
  init_consola_06ad8a64();
  init_utils();
  providers = [
    ["APPVEYOR"],
    ["AZURE_PIPELINES", "SYSTEM_TEAMFOUNDATIONCOLLECTIONURI"],
    ["AZURE_STATIC", "INPUT_AZURE_STATIC_WEB_APPS_API_TOKEN"],
    ["APPCIRCLE", "AC_APPCIRCLE"],
    ["BAMBOO", "bamboo_planKey"],
    ["BITBUCKET", "BITBUCKET_COMMIT"],
    ["BITRISE", "BITRISE_IO"],
    ["BUDDY", "BUDDY_WORKSPACE_ID"],
    ["BUILDKITE"],
    ["CIRCLE", "CIRCLECI"],
    ["CIRRUS", "CIRRUS_CI"],
    ["CLOUDFLARE_PAGES", "CF_PAGES", { ci: true }],
    ["CODEBUILD", "CODEBUILD_BUILD_ARN"],
    ["CODEFRESH", "CF_BUILD_ID"],
    ["DRONE"],
    ["DRONE", "DRONE_BUILD_EVENT"],
    ["DSARI"],
    ["GITHUB_ACTIONS"],
    ["GITLAB", "GITLAB_CI"],
    ["GITLAB", "CI_MERGE_REQUEST_ID"],
    ["GOCD", "GO_PIPELINE_LABEL"],
    ["LAYERCI"],
    ["HUDSON", "HUDSON_URL"],
    ["JENKINS", "JENKINS_URL"],
    ["MAGNUM"],
    ["NETLIFY"],
    ["NETLIFY", "NETLIFY_LOCAL", { ci: false }],
    ["NEVERCODE"],
    ["RENDER"],
    ["SAIL", "SAILCI"],
    ["SEMAPHORE"],
    ["SCREWDRIVER"],
    ["SHIPPABLE"],
    ["SOLANO", "TDDIUM"],
    ["STRIDER"],
    ["TEAMCITY", "TEAMCITY_VERSION"],
    ["TRAVIS"],
    ["VERCEL", "NOW_BUILDER"],
    ["APPCENTER", "APPCENTER_BUILD_ID"],
    ["CODESANDBOX", "CODESANDBOX_SSE", { ci: false }],
    ["STACKBLITZ"],
    ["STORMKIT"],
    ["CLEAVR"]
  ];
  processShim = typeof process !== "undefined" ? process : {};
  envShim = processShim.env || {};
  providerInfo = detectProvider(envShim);
  nodeENV = typeof process !== "undefined" && process.env && "development" || "";
  processShim.platform;
  providerInfo.name;
  isCI2 = toBoolean(envShim.CI) || providerInfo.ci !== false;
  hasTTY = toBoolean(processShim.stdout && processShim.stdout.isTTY);
  isDebug = toBoolean(envShim.DEBUG);
  isTest = nodeENV === "test" || toBoolean(envShim.TEST);
  toBoolean(envShim.MINIMAL);
  regex = ansiRegex2();
  eastasianwidth = { exports: {} };
  (function(module) {
    var eaw = {};
    {
      module.exports = eaw;
    }
    eaw.eastAsianWidth = function(character) {
      var x2 = character.charCodeAt(0);
      var y = character.length == 2 ? character.charCodeAt(1) : 0;
      var codePoint = x2;
      if (55296 <= x2 && x2 <= 56319 && (56320 <= y && y <= 57343)) {
        x2 &= 1023;
        y &= 1023;
        codePoint = x2 << 10 | y;
        codePoint += 65536;
      }
      if (codePoint == 12288 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510) {
        return "F";
      }
      if (codePoint == 8361 || 65377 <= codePoint && codePoint <= 65470 || 65474 <= codePoint && codePoint <= 65479 || 65482 <= codePoint && codePoint <= 65487 || 65490 <= codePoint && codePoint <= 65495 || 65498 <= codePoint && codePoint <= 65500 || 65512 <= codePoint && codePoint <= 65518) {
        return "H";
      }
      if (4352 <= codePoint && codePoint <= 4447 || 4515 <= codePoint && codePoint <= 4519 || 4602 <= codePoint && codePoint <= 4607 || 9001 <= codePoint && codePoint <= 9002 || 11904 <= codePoint && codePoint <= 11929 || 11931 <= codePoint && codePoint <= 12019 || 12032 <= codePoint && codePoint <= 12245 || 12272 <= codePoint && codePoint <= 12283 || 12289 <= codePoint && codePoint <= 12350 || 12353 <= codePoint && codePoint <= 12438 || 12441 <= codePoint && codePoint <= 12543 || 12549 <= codePoint && codePoint <= 12589 || 12593 <= codePoint && codePoint <= 12686 || 12688 <= codePoint && codePoint <= 12730 || 12736 <= codePoint && codePoint <= 12771 || 12784 <= codePoint && codePoint <= 12830 || 12832 <= codePoint && codePoint <= 12871 || 12880 <= codePoint && codePoint <= 13054 || 13056 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42124 || 42128 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 55216 <= codePoint && codePoint <= 55238 || 55243 <= codePoint && codePoint <= 55291 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65106 || 65108 <= codePoint && codePoint <= 65126 || 65128 <= codePoint && codePoint <= 65131 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127490 || 127504 <= codePoint && codePoint <= 127546 || 127552 <= codePoint && codePoint <= 127560 || 127568 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 194367 || 177984 <= codePoint && codePoint <= 196605 || 196608 <= codePoint && codePoint <= 262141) {
        return "W";
      }
      if (32 <= codePoint && codePoint <= 126 || 162 <= codePoint && codePoint <= 163 || 165 <= codePoint && codePoint <= 166 || codePoint == 172 || codePoint == 175 || 10214 <= codePoint && codePoint <= 10221 || 10629 <= codePoint && codePoint <= 10630) {
        return "Na";
      }
      if (codePoint == 161 || codePoint == 164 || 167 <= codePoint && codePoint <= 168 || codePoint == 170 || 173 <= codePoint && codePoint <= 174 || 176 <= codePoint && codePoint <= 180 || 182 <= codePoint && codePoint <= 186 || 188 <= codePoint && codePoint <= 191 || codePoint == 198 || codePoint == 208 || 215 <= codePoint && codePoint <= 216 || 222 <= codePoint && codePoint <= 225 || codePoint == 230 || 232 <= codePoint && codePoint <= 234 || 236 <= codePoint && codePoint <= 237 || codePoint == 240 || 242 <= codePoint && codePoint <= 243 || 247 <= codePoint && codePoint <= 250 || codePoint == 252 || codePoint == 254 || codePoint == 257 || codePoint == 273 || codePoint == 275 || codePoint == 283 || 294 <= codePoint && codePoint <= 295 || codePoint == 299 || 305 <= codePoint && codePoint <= 307 || codePoint == 312 || 319 <= codePoint && codePoint <= 322 || codePoint == 324 || 328 <= codePoint && codePoint <= 331 || codePoint == 333 || 338 <= codePoint && codePoint <= 339 || 358 <= codePoint && codePoint <= 359 || codePoint == 363 || codePoint == 462 || codePoint == 464 || codePoint == 466 || codePoint == 468 || codePoint == 470 || codePoint == 472 || codePoint == 474 || codePoint == 476 || codePoint == 593 || codePoint == 609 || codePoint == 708 || codePoint == 711 || 713 <= codePoint && codePoint <= 715 || codePoint == 717 || codePoint == 720 || 728 <= codePoint && codePoint <= 731 || codePoint == 733 || codePoint == 735 || 768 <= codePoint && codePoint <= 879 || 913 <= codePoint && codePoint <= 929 || 931 <= codePoint && codePoint <= 937 || 945 <= codePoint && codePoint <= 961 || 963 <= codePoint && codePoint <= 969 || codePoint == 1025 || 1040 <= codePoint && codePoint <= 1103 || codePoint == 1105 || codePoint == 8208 || 8211 <= codePoint && codePoint <= 8214 || 8216 <= codePoint && codePoint <= 8217 || 8220 <= codePoint && codePoint <= 8221 || 8224 <= codePoint && codePoint <= 8226 || 8228 <= codePoint && codePoint <= 8231 || codePoint == 8240 || 8242 <= codePoint && codePoint <= 8243 || codePoint == 8245 || codePoint == 8251 || codePoint == 8254 || codePoint == 8308 || codePoint == 8319 || 8321 <= codePoint && codePoint <= 8324 || codePoint == 8364 || codePoint == 8451 || codePoint == 8453 || codePoint == 8457 || codePoint == 8467 || codePoint == 8470 || 8481 <= codePoint && codePoint <= 8482 || codePoint == 8486 || codePoint == 8491 || 8531 <= codePoint && codePoint <= 8532 || 8539 <= codePoint && codePoint <= 8542 || 8544 <= codePoint && codePoint <= 8555 || 8560 <= codePoint && codePoint <= 8569 || codePoint == 8585 || 8592 <= codePoint && codePoint <= 8601 || 8632 <= codePoint && codePoint <= 8633 || codePoint == 8658 || codePoint == 8660 || codePoint == 8679 || codePoint == 8704 || 8706 <= codePoint && codePoint <= 8707 || 8711 <= codePoint && codePoint <= 8712 || codePoint == 8715 || codePoint == 8719 || codePoint == 8721 || codePoint == 8725 || codePoint == 8730 || 8733 <= codePoint && codePoint <= 8736 || codePoint == 8739 || codePoint == 8741 || 8743 <= codePoint && codePoint <= 8748 || codePoint == 8750 || 8756 <= codePoint && codePoint <= 8759 || 8764 <= codePoint && codePoint <= 8765 || codePoint == 8776 || codePoint == 8780 || codePoint == 8786 || 8800 <= codePoint && codePoint <= 8801 || 8804 <= codePoint && codePoint <= 8807 || 8810 <= codePoint && codePoint <= 8811 || 8814 <= codePoint && codePoint <= 8815 || 8834 <= codePoint && codePoint <= 8835 || 8838 <= codePoint && codePoint <= 8839 || codePoint == 8853 || codePoint == 8857 || codePoint == 8869 || codePoint == 8895 || codePoint == 8978 || 9312 <= codePoint && codePoint <= 9449 || 9451 <= codePoint && codePoint <= 9547 || 9552 <= codePoint && codePoint <= 9587 || 9600 <= codePoint && codePoint <= 9615 || 9618 <= codePoint && codePoint <= 9621 || 9632 <= codePoint && codePoint <= 9633 || 9635 <= codePoint && codePoint <= 9641 || 9650 <= codePoint && codePoint <= 9651 || 9654 <= codePoint && codePoint <= 9655 || 9660 <= codePoint && codePoint <= 9661 || 9664 <= codePoint && codePoint <= 9665 || 9670 <= codePoint && codePoint <= 9672 || codePoint == 9675 || 9678 <= codePoint && codePoint <= 9681 || 9698 <= codePoint && codePoint <= 9701 || codePoint == 9711 || 9733 <= codePoint && codePoint <= 9734 || codePoint == 9737 || 9742 <= codePoint && codePoint <= 9743 || 9748 <= codePoint && codePoint <= 9749 || codePoint == 9756 || codePoint == 9758 || codePoint == 9792 || codePoint == 9794 || 9824 <= codePoint && codePoint <= 9825 || 9827 <= codePoint && codePoint <= 9829 || 9831 <= codePoint && codePoint <= 9834 || 9836 <= codePoint && codePoint <= 9837 || codePoint == 9839 || 9886 <= codePoint && codePoint <= 9887 || 9918 <= codePoint && codePoint <= 9919 || 9924 <= codePoint && codePoint <= 9933 || 9935 <= codePoint && codePoint <= 9953 || codePoint == 9955 || 9960 <= codePoint && codePoint <= 9983 || codePoint == 10045 || codePoint == 10071 || 10102 <= codePoint && codePoint <= 10111 || 11093 <= codePoint && codePoint <= 11097 || 12872 <= codePoint && codePoint <= 12879 || 57344 <= codePoint && codePoint <= 63743 || 65024 <= codePoint && codePoint <= 65039 || codePoint == 65533 || 127232 <= codePoint && codePoint <= 127242 || 127248 <= codePoint && codePoint <= 127277 || 127280 <= codePoint && codePoint <= 127337 || 127344 <= codePoint && codePoint <= 127386 || 917760 <= codePoint && codePoint <= 917999 || 983040 <= codePoint && codePoint <= 1048573 || 1048576 <= codePoint && codePoint <= 1114109) {
        return "A";
      }
      return "N";
    };
    eaw.characterLength = function(character) {
      var code = this.eastAsianWidth(character);
      if (code == "F" || code == "W" || code == "A") {
        return 2;
      } else {
        return 1;
      }
    };
    function stringToArray(string2) {
      return string2.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]|[^\uD800-\uDFFF]/g) || [];
    }
    eaw.length = function(string2) {
      var characters = stringToArray(string2);
      var len = 0;
      for (var i = 0;i < characters.length; i++) {
        len = len + this.characterLength(characters[i]);
      }
      return len;
    };
    eaw.slice = function(text2, start, end) {
      textLen = eaw.length(text2);
      start = start ? start : 0;
      end = end ? end : 1;
      if (start < 0) {
        start = textLen + start;
      }
      if (end < 0) {
        end = textLen + end;
      }
      var result2 = "";
      var eawLen = 0;
      var chars = stringToArray(text2);
      for (var i = 0;i < chars.length; i++) {
        var char = chars[i];
        var charLen = eaw.length(char);
        if (eawLen >= start - (charLen == 2 ? 1 : 0)) {
          if (eawLen + charLen <= end) {
            result2 += char;
          } else {
            break;
          }
        }
        eawLen += charLen;
      }
      return result2;
    };
  })(eastasianwidth);
  eastasianwidthExports = eastasianwidth.exports;
  eastAsianWidth = /* @__PURE__ */ getDefaultExportFromCjs(eastasianwidthExports);
  TYPE_COLOR_MAP = {
    info: "cyan",
    fail: "red",
    success: "green",
    ready: "green",
    start: "magenta"
  };
  LEVEL_COLOR_MAP = {
    0: "red",
    1: "yellow"
  };
  unicode2 = isUnicodeSupported();
  TYPE_ICONS = {
    error: s2("\u2716", "\xD7"),
    fatal: s2("\u2716", "\xD7"),
    ready: s2("\u2714", "\u221A"),
    warn: s2("\u26A0", "\u203C"),
    info: s2("\u2139", "i"),
    success: s2("\u2714", "\u221A"),
    debug: s2("\u2699", "D"),
    trace: s2("\u2192", "\u2192"),
    fail: s2("\u2716", "\xD7"),
    start: s2("\u25D0", "o"),
    log: ""
  };
  FancyReporter = class FancyReporter2 extends BasicReporter {
    formatStack(stack) {
      return "\n" + parseStack(stack).map((line) => "  " + line.replace(/^at +/, (m2) => colors.gray(m2)).replace(/\((.+)\)/, (_2, m2) => `(${colors.cyan(m2)})`)).join("\n");
    }
    formatType(logObj, isBadge, opts) {
      const typeColor = TYPE_COLOR_MAP[logObj.type] || LEVEL_COLOR_MAP[logObj.level] || "gray";
      if (isBadge) {
        return getBgColor(typeColor)(colors.black(` ${logObj.type.toUpperCase()} `));
      }
      const _type = typeof TYPE_ICONS[logObj.type] === "string" ? TYPE_ICONS[logObj.type] : logObj.icon || logObj.type;
      return _type ? getColor2(typeColor)(_type) : "";
    }
    formatLogObj(logObj, opts) {
      const [message, ...additional] = this.formatArgs(logObj.args, opts).split("\n");
      if (logObj.type === "box") {
        return box(characterFormat(message + (additional.length > 0 ? "\n" + additional.join("\n") : "")), {
          title: logObj.title ? characterFormat(logObj.title) : undefined,
          style: logObj.style
        });
      }
      const date = this.formatDate(logObj.date, opts);
      const coloredDate = date && colors.gray(date);
      const isBadge = logObj.badge ?? logObj.level < 2;
      const type = this.formatType(logObj, isBadge, opts);
      const tag = logObj.tag ? colors.gray(logObj.tag) : "";
      let line;
      const left = this.filterAndJoin([type, characterFormat(message)]);
      const right = this.filterAndJoin(opts.columns ? [tag, coloredDate] : [tag]);
      const space = (opts.columns || 0) - stringWidth(left) - stringWidth(right) - 2;
      line = space > 0 && (opts.columns || 0) >= 80 ? left + " ".repeat(space) + right : (right ? `${colors.gray(`[${right}]`)} ` : "") + left;
      line += characterFormat(additional.length > 0 ? "\n" + additional.join("\n") : "");
      if (logObj.type === "trace") {
        const _err = new Error("Trace: " + logObj.message);
        line += this.formatStack(_err.stack || "");
      }
      return isBadge ? "\n" + line + "\n" : line;
    }
  };
  consola = createConsola2();
});
var require_assertString = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = assertString;
  function _typeof(o) {
    "@babel/helpers - typeof";
    return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o2) {
      return typeof o2;
    } : function(o2) {
      return o2 && typeof Symbol == "function" && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
    }, _typeof(o);
  }
  function assertString(input) {
    var isString2 = typeof input === "string" || input instanceof String;
    if (!isString2) {
      var invalidType = _typeof(input);
      if (input === null)
        invalidType = "null";
      else if (invalidType === "object")
        invalidType = input.constructor.name;
      throw new TypeError("Expected a string but received a ".concat(invalidType));
    }
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isIP = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isIP;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var IPv4SegmentFormat = "(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])";
  var IPv4AddressFormat = "(".concat(IPv4SegmentFormat, "[.]){3}").concat(IPv4SegmentFormat);
  var IPv4AddressRegExp = new RegExp("^".concat(IPv4AddressFormat, "$"));
  var IPv6SegmentFormat = "(?:[0-9a-fA-F]{1,4})";
  var IPv6AddressRegExp = new RegExp("^(" + "(?:".concat(IPv6SegmentFormat, ":){7}(?:").concat(IPv6SegmentFormat, "|:)|") + "(?:".concat(IPv6SegmentFormat, ":){6}(?:").concat(IPv4AddressFormat, "|:").concat(IPv6SegmentFormat, "|:)|") + "(?:".concat(IPv6SegmentFormat, ":){5}(?::").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,2}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){4}(?:(:").concat(IPv6SegmentFormat, "){0,1}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,3}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){3}(?:(:").concat(IPv6SegmentFormat, "){0,2}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,4}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){2}(?:(:").concat(IPv6SegmentFormat, "){0,3}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,5}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){1}(?:(:").concat(IPv6SegmentFormat, "){0,4}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,6}|:)|") + "(?::((?::".concat(IPv6SegmentFormat, "){0,5}:").concat(IPv4AddressFormat, "|(?::").concat(IPv6SegmentFormat, "){1,7}|:))") + ")(%[0-9a-zA-Z-.:]{1,})?$");
  function isIP(str) {
    var version = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
    (0, _assertString.default)(str);
    version = String(version);
    if (!version) {
      return isIP(str, 4) || isIP(str, 6);
    }
    if (version === "4") {
      return IPv4AddressRegExp.test(str);
    }
    if (version === "6") {
      return IPv6AddressRegExp.test(str);
    }
    return false;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_merge = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = merge;
  function merge() {
    var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var defaults = arguments.length > 1 ? arguments[1] : undefined;
    for (var key in defaults) {
      if (typeof obj[key] === "undefined") {
        obj[key] = defaults[key];
      }
    }
    return obj;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isBase64 = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isBase64;
  var _assertString = _interopRequireDefault(require_assertString());
  var _merge = _interopRequireDefault(require_merge());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var notBase64 = /[^A-Z0-9+\/=]/i;
  var urlSafeBase64 = /^[A-Z0-9_\-]*$/i;
  var defaultBase64Options = {
    urlSafe: false
  };
  function isBase64(str, options2) {
    (0, _assertString.default)(str);
    options2 = (0, _merge.default)(options2, defaultBase64Options);
    var len = str.length;
    if (options2.urlSafe) {
      return urlSafeBase64.test(str);
    }
    if (len % 4 !== 0 || notBase64.test(str)) {
      return false;
    }
    var firstPaddingChar = str.indexOf("=");
    return firstPaddingChar === -1 || firstPaddingChar === len - 1 || firstPaddingChar === len - 2 && str[len - 1] === "=";
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isJWT = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isJWT;
  var _assertString = _interopRequireDefault(require_assertString());
  var _isBase = _interopRequireDefault(require_isBase64());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isJWT(str) {
    (0, _assertString.default)(str);
    var dotSplit = str.split(".");
    var len = dotSplit.length;
    if (len !== 3) {
      return false;
    }
    return dotSplit.reduce(function(acc, currElem) {
      return acc && (0, _isBase.default)(currElem, {
        urlSafe: true
      });
    }, true);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isFQDN = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isFQDN;
  var _assertString = _interopRequireDefault(require_assertString());
  var _merge = _interopRequireDefault(require_merge());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_fqdn_options = {
    require_tld: true,
    allow_underscores: false,
    allow_trailing_dot: false,
    allow_numeric_tld: false,
    allow_wildcard: false,
    ignore_max_length: false
  };
  function isFQDN(str, options2) {
    (0, _assertString.default)(str);
    options2 = (0, _merge.default)(options2, default_fqdn_options);
    if (options2.allow_trailing_dot && str[str.length - 1] === ".") {
      str = str.substring(0, str.length - 1);
    }
    if (options2.allow_wildcard === true && str.indexOf("*.") === 0) {
      str = str.substring(2);
    }
    var parts = str.split(".");
    var tld = parts[parts.length - 1];
    if (options2.require_tld) {
      if (parts.length < 2) {
        return false;
      }
      if (!options2.allow_numeric_tld && !/^([a-z\u00A1-\u00A8\u00AA-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}|xn[a-z0-9-]{2,})$/i.test(tld)) {
        return false;
      }
      if (/\s/.test(tld)) {
        return false;
      }
    }
    if (!options2.allow_numeric_tld && /^\d+$/.test(tld)) {
      return false;
    }
    return parts.every(function(part) {
      if (part.length > 63 && !options2.ignore_max_length) {
        return false;
      }
      if (!/^[a-z_\u00a1-\uffff0-9-]+$/i.test(part)) {
        return false;
      }
      if (/[\uff01-\uff5e]/.test(part)) {
        return false;
      }
      if (/^-|-$/.test(part)) {
        return false;
      }
      if (!options2.allow_underscores && /_/.test(part)) {
        return false;
      }
      return true;
    });
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isURL = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isURL;
  var _assertString = _interopRequireDefault(require_assertString());
  var _isFQDN = _interopRequireDefault(require_isFQDN());
  var _isIP = _interopRequireDefault(require_isIP());
  var _merge = _interopRequireDefault(require_merge());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }
  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o)
      return;
    if (typeof o === "string")
      return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor)
      n = o.constructor.name;
    if (n === "Map" || n === "Set")
      return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i = 0, arr2 = new Array(len);i < len; i++)
      arr2[i] = arr[i];
    return arr2;
  }
  function _iterableToArrayLimit(r2, l3) {
    var t = r2 == null ? null : typeof Symbol != "undefined" && r2[Symbol.iterator] || r2["@@iterator"];
    if (t != null) {
      var e, n, i, u, a = [], f2 = true, o = false;
      try {
        if (i = (t = t.call(r2)).next, l3 === 0) {
          if (Object(t) !== t)
            return;
          f2 = false;
        } else
          for (;!(f2 = (e = i.call(t)).done) && (a.push(e.value), a.length !== l3); f2 = true)
            ;
      } catch (r3) {
        o = true, n = r3;
      } finally {
        try {
          if (!f2 && t.return != null && (u = t.return(), Object(u) !== u))
            return;
        } finally {
          if (o)
            throw n;
        }
      }
      return a;
    }
  }
  function _arrayWithHoles(arr) {
    if (Array.isArray(arr))
      return arr;
  }
  var default_url_options = {
    protocols: ["http", "https", "ftp"],
    require_tld: true,
    require_protocol: false,
    require_host: true,
    require_port: false,
    require_valid_protocol: true,
    allow_underscores: false,
    allow_trailing_dot: false,
    allow_protocol_relative_urls: false,
    allow_fragments: true,
    allow_query_components: true,
    validate_length: true
  };
  var wrapped_ipv6 = /^\[([^\]]+)\](?::([0-9]+))?$/;
  function isRegExp(obj) {
    return Object.prototype.toString.call(obj) === "[object RegExp]";
  }
  function checkHost(host, matches) {
    for (var i = 0;i < matches.length; i++) {
      var match = matches[i];
      if (host === match || isRegExp(match) && match.test(host)) {
        return true;
      }
    }
    return false;
  }
  function isURL(url, options2) {
    (0, _assertString.default)(url);
    if (!url || /[\s<>]/.test(url)) {
      return false;
    }
    if (url.indexOf("mailto:") === 0) {
      return false;
    }
    options2 = (0, _merge.default)(options2, default_url_options);
    if (options2.validate_length && url.length >= 2083) {
      return false;
    }
    if (!options2.allow_fragments && url.includes("#")) {
      return false;
    }
    if (!options2.allow_query_components && (url.includes("?") || url.includes("&"))) {
      return false;
    }
    var protocol, auth, host, hostname, port, port_str, split, ipv6;
    split = url.split("#");
    url = split.shift();
    split = url.split("?");
    url = split.shift();
    split = url.split("://");
    if (split.length > 1) {
      protocol = split.shift().toLowerCase();
      if (options2.require_valid_protocol && options2.protocols.indexOf(protocol) === -1) {
        return false;
      }
    } else if (options2.require_protocol) {
      return false;
    } else if (url.slice(0, 2) === "//") {
      if (!options2.allow_protocol_relative_urls) {
        return false;
      }
      split[0] = url.slice(2);
    }
    url = split.join("://");
    if (url === "") {
      return false;
    }
    split = url.split("/");
    url = split.shift();
    if (url === "" && !options2.require_host) {
      return true;
    }
    split = url.split("@");
    if (split.length > 1) {
      if (options2.disallow_auth) {
        return false;
      }
      if (split[0] === "") {
        return false;
      }
      auth = split.shift();
      if (auth.indexOf(":") >= 0 && auth.split(":").length > 2) {
        return false;
      }
      var _auth$split = auth.split(":"), _auth$split2 = _slicedToArray(_auth$split, 2), user = _auth$split2[0], password = _auth$split2[1];
      if (user === "" && password === "") {
        return false;
      }
    }
    hostname = split.join("@");
    port_str = null;
    ipv6 = null;
    var ipv6_match = hostname.match(wrapped_ipv6);
    if (ipv6_match) {
      host = "";
      ipv6 = ipv6_match[1];
      port_str = ipv6_match[2] || null;
    } else {
      split = hostname.split(":");
      host = split.shift();
      if (split.length) {
        port_str = split.join(":");
      }
    }
    if (port_str !== null && port_str.length > 0) {
      port = parseInt(port_str, 10);
      if (!/^[0-9]+$/.test(port_str) || port <= 0 || port > 65535) {
        return false;
      }
    } else if (options2.require_port) {
      return false;
    }
    if (options2.host_whitelist) {
      return checkHost(host, options2.host_whitelist);
    }
    if (host === "" && !options2.require_host) {
      return true;
    }
    if (!(0, _isIP.default)(host) && !(0, _isFQDN.default)(host, options2) && (!ipv6 || !(0, _isIP.default)(ipv6, 6))) {
      return false;
    }
    host = host || ipv6;
    if (options2.host_blacklist && checkHost(host, options2.host_blacklist)) {
      return false;
    }
    return true;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isSlug = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isSlug;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var charsetRegex = /^[^\s-_](?!.*?[-_]{2,})[a-z0-9-\\][^\s]*[^-_\s]$/;
  function isSlug(str) {
    (0, _assertString.default)(str);
    return charsetRegex.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isIBAN = __commonJS((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isIBAN;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var ibanRegexThroughCountryCode = {
    AD: /^(AD[0-9]{2})\d{8}[A-Z0-9]{12}$/,
    AE: /^(AE[0-9]{2})\d{3}\d{16}$/,
    AL: /^(AL[0-9]{2})\d{8}[A-Z0-9]{16}$/,
    AT: /^(AT[0-9]{2})\d{16}$/,
    AZ: /^(AZ[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    BA: /^(BA[0-9]{2})\d{16}$/,
    BE: /^(BE[0-9]{2})\d{12}$/,
    BG: /^(BG[0-9]{2})[A-Z]{4}\d{6}[A-Z0-9]{8}$/,
    BH: /^(BH[0-9]{2})[A-Z]{4}[A-Z0-9]{14}$/,
    BR: /^(BR[0-9]{2})\d{23}[A-Z]{1}[A-Z0-9]{1}$/,
    BY: /^(BY[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    CH: /^(CH[0-9]{2})\d{5}[A-Z0-9]{12}$/,
    CR: /^(CR[0-9]{2})\d{18}$/,
    CY: /^(CY[0-9]{2})\d{8}[A-Z0-9]{16}$/,
    CZ: /^(CZ[0-9]{2})\d{20}$/,
    DE: /^(DE[0-9]{2})\d{18}$/,
    DK: /^(DK[0-9]{2})\d{14}$/,
    DO: /^(DO[0-9]{2})[A-Z]{4}\d{20}$/,
    DZ: /^(DZ\d{24})$/,
    EE: /^(EE[0-9]{2})\d{16}$/,
    EG: /^(EG[0-9]{2})\d{25}$/,
    ES: /^(ES[0-9]{2})\d{20}$/,
    FI: /^(FI[0-9]{2})\d{14}$/,
    FO: /^(FO[0-9]{2})\d{14}$/,
    FR: /^(FR[0-9]{2})\d{10}[A-Z0-9]{11}\d{2}$/,
    GB: /^(GB[0-9]{2})[A-Z]{4}\d{14}$/,
    GE: /^(GE[0-9]{2})[A-Z0-9]{2}\d{16}$/,
    GI: /^(GI[0-9]{2})[A-Z]{4}[A-Z0-9]{15}$/,
    GL: /^(GL[0-9]{2})\d{14}$/,
    GR: /^(GR[0-9]{2})\d{7}[A-Z0-9]{16}$/,
    GT: /^(GT[0-9]{2})[A-Z0-9]{4}[A-Z0-9]{20}$/,
    HR: /^(HR[0-9]{2})\d{17}$/,
    HU: /^(HU[0-9]{2})\d{24}$/,
    IE: /^(IE[0-9]{2})[A-Z0-9]{4}\d{14}$/,
    IL: /^(IL[0-9]{2})\d{19}$/,
    IQ: /^(IQ[0-9]{2})[A-Z]{4}\d{15}$/,
    IR: /^(IR[0-9]{2})0\d{2}0\d{18}$/,
    IS: /^(IS[0-9]{2})\d{22}$/,
    IT: /^(IT[0-9]{2})[A-Z]{1}\d{10}[A-Z0-9]{12}$/,
    JO: /^(JO[0-9]{2})[A-Z]{4}\d{22}$/,
    KW: /^(KW[0-9]{2})[A-Z]{4}[A-Z0-9]{22}$/,
    KZ: /^(KZ[0-9]{2})\d{3}[A-Z0-9]{13}$/,
    LB: /^(LB[0-9]{2})\d{4}[A-Z0-9]{20}$/,
    LC: /^(LC[0-9]{2})[A-Z]{4}[A-Z0-9]{24}$/,
    LI: /^(LI[0-9]{2})\d{5}[A-Z0-9]{12}$/,
    LT: /^(LT[0-9]{2})\d{16}$/,
    LU: /^(LU[0-9]{2})\d{3}[A-Z0-9]{13}$/,
    LV: /^(LV[0-9]{2})[A-Z]{4}[A-Z0-9]{13}$/,
    MA: /^(MA[0-9]{26})$/,
    MC: /^(MC[0-9]{2})\d{10}[A-Z0-9]{11}\d{2}$/,
    MD: /^(MD[0-9]{2})[A-Z0-9]{20}$/,
    ME: /^(ME[0-9]{2})\d{18}$/,
    MK: /^(MK[0-9]{2})\d{3}[A-Z0-9]{10}\d{2}$/,
    MR: /^(MR[0-9]{2})\d{23}$/,
    MT: /^(MT[0-9]{2})[A-Z]{4}\d{5}[A-Z0-9]{18}$/,
    MU: /^(MU[0-9]{2})[A-Z]{4}\d{19}[A-Z]{3}$/,
    MZ: /^(MZ[0-9]{2})\d{21}$/,
    NL: /^(NL[0-9]{2})[A-Z]{4}\d{10}$/,
    NO: /^(NO[0-9]{2})\d{11}$/,
    PK: /^(PK[0-9]{2})[A-Z0-9]{4}\d{16}$/,
    PL: /^(PL[0-9]{2})\d{24}$/,
    PS: /^(PS[0-9]{2})[A-Z0-9]{4}\d{21}$/,
    PT: /^(PT[0-9]{2})\d{21}$/,
    QA: /^(QA[0-9]{2})[A-Z]{4}[A-Z0-9]{21}$/,
    RO: /^(RO[0-9]{2})[A-Z]{4}[A-Z0-9]{16}$/,
    RS: /^(RS[0-9]{2})\d{18}$/,
    SA: /^(SA[0-9]{2})\d{2}[A-Z0-9]{18}$/,
    SC: /^(SC[0-9]{2})[A-Z]{4}\d{20}[A-Z]{3}$/,
    SE: /^(SE[0-9]{2})\d{20}$/,
    SI: /^(SI[0-9]{2})\d{15}$/,
    SK: /^(SK[0-9]{2})\d{20}$/,
    SM: /^(SM[0-9]{2})[A-Z]{1}\d{10}[A-Z0-9]{12}$/,
    SV: /^(SV[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    TL: /^(TL[0-9]{2})\d{19}$/,
    TN: /^(TN[0-9]{2})\d{20}$/,
    TR: /^(TR[0-9]{2})\d{5}[A-Z0-9]{17}$/,
    UA: /^(UA[0-9]{2})\d{6}[A-Z0-9]{19}$/,
    VA: /^(VA[0-9]{2})\d{18}$/,
    VG: /^(VG[0-9]{2})[A-Z0-9]{4}\d{16}$/,
    XK: /^(XK[0-9]{2})\d{16}$/
  };
  function hasOnlyValidCountryCodes(countryCodeArray) {
    var countryCodeArrayFilteredWithObjectIbanCode = countryCodeArray.filter(function(countryCode) {
      return !(countryCode in ibanRegexThroughCountryCode);
    });
    if (countryCodeArrayFilteredWithObjectIbanCode.length > 0) {
      return false;
    }
    return true;
  }
  function hasValidIbanFormat(str, options2) {
    var strippedStr = str.replace(/[\s\-]+/gi, "").toUpperCase();
    var isoCountryCode = strippedStr.slice(0, 2).toUpperCase();
    var isoCountryCodeInIbanRegexCodeObject = isoCountryCode in ibanRegexThroughCountryCode;
    if (options2.whitelist) {
      if (!hasOnlyValidCountryCodes(options2.whitelist)) {
        return false;
      }
      var isoCountryCodeInWhiteList = options2.whitelist.includes(isoCountryCode);
      if (!isoCountryCodeInWhiteList) {
        return false;
      }
    }
    if (options2.blacklist) {
      var isoCountryCodeInBlackList = options2.blacklist.includes(isoCountryCode);
      if (isoCountryCodeInBlackList) {
        return false;
      }
    }
    return isoCountryCodeInIbanRegexCodeObject && ibanRegexThroughCountryCode[isoCountryCode].test(strippedStr);
  }
  function hasValidIbanChecksum(str) {
    var strippedStr = str.replace(/[^A-Z0-9]+/gi, "").toUpperCase();
    var rearranged = strippedStr.slice(4) + strippedStr.slice(0, 4);
    var alphaCapsReplacedWithDigits = rearranged.replace(/[A-Z]/g, function(char) {
      return char.charCodeAt(0) - 55;
    });
    var remainder = alphaCapsReplacedWithDigits.match(/\d{1,7}/g).reduce(function(acc, value) {
      return Number(acc + value) % 97;
    }, "");
    return remainder === 1;
  }
  function isIBAN(str) {
    var options2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _assertString.default)(str);
    return hasValidIbanFormat(str, options2) && hasValidIbanChecksum(str);
  }
  var locales2 = exports.locales = Object.keys(ibanRegexThroughCountryCode);
});
var require_isUUID = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isUUID;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var uuid = {
    1: /^[0-9A-F]{8}-[0-9A-F]{4}-1[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    2: /^[0-9A-F]{8}-[0-9A-F]{4}-2[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    3: /^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    4: /^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    5: /^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    7: /^[0-9A-F]{8}-[0-9A-F]{4}-7[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    all: /^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i
  };
  function isUUID(str, version) {
    (0, _assertString.default)(str);
    var pattern = uuid[![undefined, null].includes(version) ? version : "all"];
    return !!pattern && pattern.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isAscii = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAscii;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var ascii = /^[\x00-\x7F]+$/;
  function isAscii(str) {
    (0, _assertString.default)(str);
    return ascii.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isByteLength = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isByteLength;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function _typeof(o) {
    "@babel/helpers - typeof";
    return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o2) {
      return typeof o2;
    } : function(o2) {
      return o2 && typeof Symbol == "function" && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
    }, _typeof(o);
  }
  function isByteLength(str, options2) {
    (0, _assertString.default)(str);
    var min;
    var max;
    if (_typeof(options2) === "object") {
      min = options2.min || 0;
      max = options2.max;
    } else {
      min = arguments[1];
      max = arguments[2];
    }
    var len = encodeURI(str).split(/%..|./).length - 1;
    return len >= min && (typeof max === "undefined" || len <= max);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isEmail = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isEmail;
  var _assertString = _interopRequireDefault(require_assertString());
  var _isByteLength = _interopRequireDefault(require_isByteLength());
  var _isFQDN = _interopRequireDefault(require_isFQDN());
  var _isIP = _interopRequireDefault(require_isIP());
  var _merge = _interopRequireDefault(require_merge());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_email_options = {
    allow_display_name: false,
    allow_underscores: false,
    require_display_name: false,
    allow_utf8_local_part: true,
    require_tld: true,
    blacklisted_chars: "",
    ignore_max_length: false,
    host_blacklist: [],
    host_whitelist: []
  };
  var splitNameAddress = /^([^\x00-\x1F\x7F-\x9F\cX]+)</i;
  var emailUserPart = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i;
  var gmailUserPart = /^[a-z\d]+$/;
  var quotedEmailUser = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i;
  var emailUserUtf8Part = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A1-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i;
  var quotedEmailUserUtf8 = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i;
  var defaultMaxEmailLength = 254;
  function validateDisplayName(display_name) {
    var display_name_without_quotes = display_name.replace(/^"(.+)"$/, "$1");
    if (!display_name_without_quotes.trim()) {
      return false;
    }
    var contains_illegal = /[\.";<>]/.test(display_name_without_quotes);
    if (contains_illegal) {
      if (display_name_without_quotes === display_name) {
        return false;
      }
      var all_start_with_back_slash = display_name_without_quotes.split('"').length === display_name_without_quotes.split('\\"').length;
      if (!all_start_with_back_slash) {
        return false;
      }
    }
    return true;
  }
  function isEmail(str, options2) {
    (0, _assertString.default)(str);
    options2 = (0, _merge.default)(options2, default_email_options);
    if (options2.require_display_name || options2.allow_display_name) {
      var display_email = str.match(splitNameAddress);
      if (display_email) {
        var display_name = display_email[1];
        str = str.replace(display_name, "").replace(/(^<|>$)/g, "");
        if (display_name.endsWith(" ")) {
          display_name = display_name.slice(0, -1);
        }
        if (!validateDisplayName(display_name)) {
          return false;
        }
      } else if (options2.require_display_name) {
        return false;
      }
    }
    if (!options2.ignore_max_length && str.length > defaultMaxEmailLength) {
      return false;
    }
    var parts = str.split("@");
    var domain = parts.pop();
    var lower_domain = domain.toLowerCase();
    if (options2.host_blacklist.includes(lower_domain)) {
      return false;
    }
    if (options2.host_whitelist.length > 0 && !options2.host_whitelist.includes(lower_domain)) {
      return false;
    }
    var user = parts.join("@");
    if (options2.domain_specific_validation && (lower_domain === "gmail.com" || lower_domain === "googlemail.com")) {
      user = user.toLowerCase();
      var username = user.split("+")[0];
      if (!(0, _isByteLength.default)(username.replace(/\./g, ""), {
        min: 6,
        max: 30
      })) {
        return false;
      }
      var _user_parts = username.split(".");
      for (var i = 0;i < _user_parts.length; i++) {
        if (!gmailUserPart.test(_user_parts[i])) {
          return false;
        }
      }
    }
    if (options2.ignore_max_length === false && (!(0, _isByteLength.default)(user, {
      max: 64
    }) || !(0, _isByteLength.default)(domain, {
      max: 254
    }))) {
      return false;
    }
    if (!(0, _isFQDN.default)(domain, {
      require_tld: options2.require_tld,
      ignore_max_length: options2.ignore_max_length,
      allow_underscores: options2.allow_underscores
    })) {
      if (!options2.allow_ip_domain) {
        return false;
      }
      if (!(0, _isIP.default)(domain)) {
        if (!domain.startsWith("[") || !domain.endsWith("]")) {
          return false;
        }
        var noBracketdomain = domain.slice(1, -1);
        if (noBracketdomain.length === 0 || !(0, _isIP.default)(noBracketdomain)) {
          return false;
        }
      }
    }
    if (user[0] === '"') {
      user = user.slice(1, user.length - 1);
      return options2.allow_utf8_local_part ? quotedEmailUserUtf8.test(user) : quotedEmailUser.test(user);
    }
    var pattern = options2.allow_utf8_local_part ? emailUserUtf8Part : emailUserPart;
    var user_parts = user.split(".");
    for (var _i = 0;_i < user_parts.length; _i++) {
      if (!pattern.test(user_parts[_i])) {
        return false;
      }
    }
    if (options2.blacklisted_chars) {
      if (user.search(new RegExp("[".concat(options2.blacklisted_chars, "]+"), "g")) !== -1)
        return false;
    }
    return true;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_alpha = __commonJS((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.farsiLocales = exports.englishLocales = exports.dotDecimal = exports.decimal = exports.commaDecimal = exports.bengaliLocales = exports.arabicLocales = exports.alphanumeric = exports.alpha = undefined;
  var alpha = exports.alpha = {
    "en-US": /^[A-Z]+$/i,
    "az-AZ": /^[A-VXYZ\u00C7\u018F\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "bg-BG": /^[\u0410-\u042F]+$/i,
    "cs-CZ": /^[A-Z\u00C1\u010C\u010E\u00C9\u011A\u00CD\u0147\u00D3\u0158\u0160\u0164\u00DA\u016E\u00DD\u017D]+$/i,
    "da-DK": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "de-DE": /^[A-Z\u00C4\u00D6\u00DC\u00DF]+$/i,
    "el-GR": /^[\u0391-\u03CE]+$/i,
    "es-ES": /^[A-Z\u00C1\u00C9\u00CD\u00D1\u00D3\u00DA\u00DC]+$/i,
    "fa-IR": /^[\u0627\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u06CC]+$/i,
    "fi-FI": /^[A-Z\u00C5\u00C4\u00D6]+$/i,
    "fr-FR": /^[A-Z\u00C0\u00C2\u00C6\u00C7\u00C9\u00C8\u00CA\u00CB\u00CF\u00CE\u00D4\u0152\u00D9\u00DB\u00DC\u0178]+$/i,
    "it-IT": /^[A-Z\u00C0\u00C9\u00C8\u00CC\u00CE\u00D3\u00D2\u00D9]+$/i,
    "ja-JP": /^[\u3041-\u3093\u30A1-\u30F6\uFF66-\uFF9F\u4E00-\u9FA0\u30FC\u30FB\u3002\u3001]+$/i,
    "nb-NO": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "nl-NL": /^[A-Z\u00C1\u00C9\u00CB\u00CF\u00D3\u00D6\u00DC\u00DA]+$/i,
    "nn-NO": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "hu-HU": /^[A-Z\u00C1\u00C9\u00CD\u00D3\u00D6\u0150\u00DA\u00DC\u0170]+$/i,
    "pl-PL": /^[A-Z\u0104\u0106\u0118\u015A\u0141\u0143\u00D3\u017B\u0179]+$/i,
    "pt-PT": /^[A-Z\u00C3\u00C1\u00C0\u00C2\u00C4\u00C7\u00C9\u00CA\u00CB\u00CD\u00CF\u00D5\u00D3\u00D4\u00D6\u00DA\u00DC]+$/i,
    "ru-RU": /^[\u0410-\u042F\u0401]+$/i,
    "kk-KZ": /^[\u0410-\u042F\u0401\u04D8\u04B0\u0406\u04A2\u0492\u04AE\u049A\u04E8\u04BA]+$/i,
    "sl-SI": /^[A-Z\u010C\u0106\u0110\u0160\u017D]+$/i,
    "sk-SK": /^[A-Z\u00C1\u010C\u010E\u00C9\u00CD\u0147\u00D3\u0160\u0164\u00DA\u00DD\u017D\u0139\u0154\u013D\u00C4\u00D4]+$/i,
    "sr-RS@latin": /^[A-Z\u010C\u0106\u017D\u0160\u0110]+$/i,
    "sr-RS": /^[\u0410-\u042F\u0402\u0408\u0409\u040A\u040B\u040F]+$/i,
    "sv-SE": /^[A-Z\u00C5\u00C4\u00D6]+$/i,
    "th-TH": /^[\u0E01-\u0E50\s]+$/i,
    "tr-TR": /^[A-Z\u00C7\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "uk-UA": /^[\u0410-\u0429\u042C\u042E\u042F\u0404I\u0407\u0490\u0456]+$/i,
    "vi-VN": /^[A-Z\u00C0\u00C1\u1EA0\u1EA2\u00C3\u00C2\u1EA6\u1EA4\u1EAC\u1EA8\u1EAA\u0102\u1EB0\u1EAE\u1EB6\u1EB2\u1EB4\u0110\u00C8\u00C9\u1EB8\u1EBA\u1EBC\u00CA\u1EC0\u1EBE\u1EC6\u1EC2\u1EC4\u00CC\u00CD\u1ECA\u1EC8\u0128\u00D2\u00D3\u1ECC\u1ECE\u00D5\u00D4\u1ED2\u1ED0\u1ED8\u1ED4\u1ED6\u01A0\u1EDC\u1EDA\u1EE2\u1EDE\u1EE0\u00D9\u00DA\u1EE4\u1EE6\u0168\u01AF\u1EEA\u1EE8\u1EF0\u1EEC\u1EEE\u1EF2\u00DD\u1EF4\u1EF6\u1EF8]+$/i,
    "ko-KR": /^[\u3131-\u314E\u314F-\u3163\uAC00-\uD7A3]*$/,
    "ku-IQ": /^[\u0626\u0627\u0628\u067E\u062A\u062C\u0686\u062D\u062E\u062F\u0631\u0695\u0632\u0698\u0633\u0634\u0639\u063A\u0641\u06A4\u0642\u06A9\u06AF\u0644\u06B5\u0645\u0646\u0648\u06C6\u06BE\u06D5\u06CC\u06CE\u064A\u0637\u0624\u062B\u0622\u0625\u0623\u0643\u0636\u0635\u0629\u0638\u0630]+$/i,
    ar: /^[\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\u0670]+$/,
    he: /^[\u05D0-\u05EA]+$/,
    fa: /^['\u0622\u0627\u0621\u0623\u0624\u0626\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u0629\u06CC']+$/i,
    bn: /^['\u0980\u0981\u0982\u0983\u0985\u0986\u0987\u0988\u0989\u098A\u098B\u098C\u098F\u0990\u0993\u0994\u0995\u0996\u0997\u0998\u0999\u099A\u099B\u099C\u099D\u099E\u099F\u09A0\u09A1\u09A2\u09A3\u09A4\u09A5\u09A6\u09A7\u09A8\u09AA\u09AB\u09AC\u09AD\u09AE\u09AF\u09B0\u09B2\u09B6\u09B7\u09B8\u09B9\u09BC\u09BD\u09BE\u09BF\u09C0\u09C1\u09C2\u09C3\u09C4\u09C7\u09C8\u09CB\u09CC\u09CD\u09CE\u09D7\u09DC\u09DD\u09DF\u09E0\u09E1\u09E2\u09E3\u09F0\u09F1\u09F2\u09F3\u09F4\u09F5\u09F6\u09F7\u09F8\u09F9\u09FA\u09FB']+$/,
    eo: /^[ABC\u0108D-G\u011CH\u0124IJ\u0134K-PRS\u015CTU\u016CVZ]+$/i,
    "hi-IN": /^[\u0900-\u0961]+[\u0972-\u097F]*$/i,
    "si-LK": /^[\u0D80-\u0DFF]+$/
  };
  var alphanumeric = exports.alphanumeric = {
    "en-US": /^[0-9A-Z]+$/i,
    "az-AZ": /^[0-9A-VXYZ\u00C7\u018F\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "bg-BG": /^[0-9\u0410-\u042F]+$/i,
    "cs-CZ": /^[0-9A-Z\u00C1\u010C\u010E\u00C9\u011A\u00CD\u0147\u00D3\u0158\u0160\u0164\u00DA\u016E\u00DD\u017D]+$/i,
    "da-DK": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "de-DE": /^[0-9A-Z\u00C4\u00D6\u00DC\u00DF]+$/i,
    "el-GR": /^[0-9\u0391-\u03C9]+$/i,
    "es-ES": /^[0-9A-Z\u00C1\u00C9\u00CD\u00D1\u00D3\u00DA\u00DC]+$/i,
    "fi-FI": /^[0-9A-Z\u00C5\u00C4\u00D6]+$/i,
    "fr-FR": /^[0-9A-Z\u00C0\u00C2\u00C6\u00C7\u00C9\u00C8\u00CA\u00CB\u00CF\u00CE\u00D4\u0152\u00D9\u00DB\u00DC\u0178]+$/i,
    "it-IT": /^[0-9A-Z\u00C0\u00C9\u00C8\u00CC\u00CE\u00D3\u00D2\u00D9]+$/i,
    "ja-JP": /^[0-9\uFF10-\uFF19\u3041-\u3093\u30A1-\u30F6\uFF66-\uFF9F\u4E00-\u9FA0\u30FC\u30FB\u3002\u3001]+$/i,
    "hu-HU": /^[0-9A-Z\u00C1\u00C9\u00CD\u00D3\u00D6\u0150\u00DA\u00DC\u0170]+$/i,
    "nb-NO": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "nl-NL": /^[0-9A-Z\u00C1\u00C9\u00CB\u00CF\u00D3\u00D6\u00DC\u00DA]+$/i,
    "nn-NO": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "pl-PL": /^[0-9A-Z\u0104\u0106\u0118\u015A\u0141\u0143\u00D3\u017B\u0179]+$/i,
    "pt-PT": /^[0-9A-Z\u00C3\u00C1\u00C0\u00C2\u00C4\u00C7\u00C9\u00CA\u00CB\u00CD\u00CF\u00D5\u00D3\u00D4\u00D6\u00DA\u00DC]+$/i,
    "ru-RU": /^[0-9\u0410-\u042F\u0401]+$/i,
    "kk-KZ": /^[0-9\u0410-\u042F\u0401\u04D8\u04B0\u0406\u04A2\u0492\u04AE\u049A\u04E8\u04BA]+$/i,
    "sl-SI": /^[0-9A-Z\u010C\u0106\u0110\u0160\u017D]+$/i,
    "sk-SK": /^[0-9A-Z\u00C1\u010C\u010E\u00C9\u00CD\u0147\u00D3\u0160\u0164\u00DA\u00DD\u017D\u0139\u0154\u013D\u00C4\u00D4]+$/i,
    "sr-RS@latin": /^[0-9A-Z\u010C\u0106\u017D\u0160\u0110]+$/i,
    "sr-RS": /^[0-9\u0410-\u042F\u0402\u0408\u0409\u040A\u040B\u040F]+$/i,
    "sv-SE": /^[0-9A-Z\u00C5\u00C4\u00D6]+$/i,
    "th-TH": /^[\u0E01-\u0E59\s]+$/i,
    "tr-TR": /^[0-9A-Z\u00C7\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "uk-UA": /^[0-9\u0410-\u0429\u042C\u042E\u042F\u0404I\u0407\u0490\u0456]+$/i,
    "ko-KR": /^[0-9\u3131-\u314E\u314F-\u3163\uAC00-\uD7A3]*$/,
    "ku-IQ": /^[\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u06690-9\u0626\u0627\u0628\u067E\u062A\u062C\u0686\u062D\u062E\u062F\u0631\u0695\u0632\u0698\u0633\u0634\u0639\u063A\u0641\u06A4\u0642\u06A9\u06AF\u0644\u06B5\u0645\u0646\u0648\u06C6\u06BE\u06D5\u06CC\u06CE\u064A\u0637\u0624\u062B\u0622\u0625\u0623\u0643\u0636\u0635\u0629\u0638\u0630]+$/i,
    "vi-VN": /^[0-9A-Z\u00C0\u00C1\u1EA0\u1EA2\u00C3\u00C2\u1EA6\u1EA4\u1EAC\u1EA8\u1EAA\u0102\u1EB0\u1EAE\u1EB6\u1EB2\u1EB4\u0110\u00C8\u00C9\u1EB8\u1EBA\u1EBC\u00CA\u1EC0\u1EBE\u1EC6\u1EC2\u1EC4\u00CC\u00CD\u1ECA\u1EC8\u0128\u00D2\u00D3\u1ECC\u1ECE\u00D5\u00D4\u1ED2\u1ED0\u1ED8\u1ED4\u1ED6\u01A0\u1EDC\u1EDA\u1EE2\u1EDE\u1EE0\u00D9\u00DA\u1EE4\u1EE6\u0168\u01AF\u1EEA\u1EE8\u1EF0\u1EEC\u1EEE\u1EF2\u00DD\u1EF4\u1EF6\u1EF8]+$/i,
    ar: /^[\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u06690-9\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\u0670]+$/,
    he: /^[0-9\u05D0-\u05EA]+$/,
    fa: /^['0-9\u0622\u0627\u0621\u0623\u0624\u0626\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u0629\u06CC\u06F1\u06F2\u06F3\u06F4\u06F5\u06F6\u06F7\u06F8\u06F9\u06F0']+$/i,
    bn: /^['\u0980\u0981\u0982\u0983\u0985\u0986\u0987\u0988\u0989\u098A\u098B\u098C\u098F\u0990\u0993\u0994\u0995\u0996\u0997\u0998\u0999\u099A\u099B\u099C\u099D\u099E\u099F\u09A0\u09A1\u09A2\u09A3\u09A4\u09A5\u09A6\u09A7\u09A8\u09AA\u09AB\u09AC\u09AD\u09AE\u09AF\u09B0\u09B2\u09B6\u09B7\u09B8\u09B9\u09BC\u09BD\u09BE\u09BF\u09C0\u09C1\u09C2\u09C3\u09C4\u09C7\u09C8\u09CB\u09CC\u09CD\u09CE\u09D7\u09DC\u09DD\u09DF\u09E0\u09E1\u09E2\u09E3\u09E6\u09E7\u09E8\u09E9\u09EA\u09EB\u09EC\u09ED\u09EE\u09EF\u09F0\u09F1\u09F2\u09F3\u09F4\u09F5\u09F6\u09F7\u09F8\u09F9\u09FA\u09FB']+$/,
    eo: /^[0-9ABC\u0108D-G\u011CH\u0124IJ\u0134K-PRS\u015CTU\u016CVZ]+$/i,
    "hi-IN": /^[\u0900-\u0963]+[\u0966-\u097F]*$/i,
    "si-LK": /^[0-9\u0D80-\u0DFF]+$/
  };
  var decimal = exports.decimal = {
    "en-US": ".",
    ar: "\u066B"
  };
  var englishLocales = exports.englishLocales = ["AU", "GB", "HK", "IN", "NZ", "ZA", "ZM"];
  for (i = 0;i < englishLocales.length; i++) {
    locale = "en-".concat(englishLocales[i]);
    alpha[locale] = alpha["en-US"];
    alphanumeric[locale] = alphanumeric["en-US"];
    decimal[locale] = decimal["en-US"];
  }
  var locale;
  var i;
  var arabicLocales = exports.arabicLocales = ["AE", "BH", "DZ", "EG", "IQ", "JO", "KW", "LB", "LY", "MA", "QM", "QA", "SA", "SD", "SY", "TN", "YE"];
  for (_i = 0;_i < arabicLocales.length; _i++) {
    _locale = "ar-".concat(arabicLocales[_i]);
    alpha[_locale] = alpha.ar;
    alphanumeric[_locale] = alphanumeric.ar;
    decimal[_locale] = decimal.ar;
  }
  var _locale;
  var _i;
  var farsiLocales = exports.farsiLocales = ["IR", "AF"];
  for (_i2 = 0;_i2 < farsiLocales.length; _i2++) {
    _locale2 = "fa-".concat(farsiLocales[_i2]);
    alphanumeric[_locale2] = alphanumeric.fa;
    decimal[_locale2] = decimal.ar;
  }
  var _locale2;
  var _i2;
  var bengaliLocales = exports.bengaliLocales = ["BD", "IN"];
  for (_i3 = 0;_i3 < bengaliLocales.length; _i3++) {
    _locale3 = "bn-".concat(bengaliLocales[_i3]);
    alpha[_locale3] = alpha.bn;
    alphanumeric[_locale3] = alphanumeric.bn;
    decimal[_locale3] = decimal["en-US"];
  }
  var _locale3;
  var _i3;
  var dotDecimal = exports.dotDecimal = ["ar-EG", "ar-LB", "ar-LY"];
  var commaDecimal = exports.commaDecimal = ["bg-BG", "cs-CZ", "da-DK", "de-DE", "el-GR", "en-ZM", "eo", "es-ES", "fr-CA", "fr-FR", "id-ID", "it-IT", "ku-IQ", "hi-IN", "hu-HU", "nb-NO", "nn-NO", "nl-NL", "pl-PL", "pt-PT", "ru-RU", "kk-KZ", "si-LK", "sl-SI", "sr-RS@latin", "sr-RS", "sv-SE", "tr-TR", "uk-UA", "vi-VN"];
  for (_i4 = 0;_i4 < dotDecimal.length; _i4++) {
    decimal[dotDecimal[_i4]] = decimal["en-US"];
  }
  var _i4;
  for (_i5 = 0;_i5 < commaDecimal.length; _i5++) {
    decimal[commaDecimal[_i5]] = ",";
  }
  var _i5;
  alpha["fr-CA"] = alpha["fr-FR"];
  alphanumeric["fr-CA"] = alphanumeric["fr-FR"];
  alpha["pt-BR"] = alpha["pt-PT"];
  alphanumeric["pt-BR"] = alphanumeric["pt-PT"];
  decimal["pt-BR"] = decimal["pt-PT"];
  alpha["pl-Pl"] = alpha["pl-PL"];
  alphanumeric["pl-Pl"] = alphanumeric["pl-PL"];
  decimal["pl-Pl"] = decimal["pl-PL"];
  alpha["fa-AF"] = alpha.fa;
});
var require_isAlpha = __commonJS((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAlpha;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString());
  var _alpha = require_alpha();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isAlpha(_str) {
    var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "en-US";
    var options2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    (0, _assertString.default)(_str);
    var str = _str;
    var ignore = options2.ignore;
    if (ignore) {
      if (ignore instanceof RegExp) {
        str = str.replace(ignore, "");
      } else if (typeof ignore === "string") {
        str = str.replace(new RegExp("[".concat(ignore.replace(/[-[\]{}()*+?.,\\^$|#\\s]/g, "\\$&"), "]"), "g"), "");
      } else {
        throw new Error("ignore should be instance of a String or RegExp");
      }
    }
    if (locale in _alpha.alpha) {
      return _alpha.alpha[locale].test(str);
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales2 = exports.locales = Object.keys(_alpha.alpha);
});
var require_isLatLong = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isLatLong;
  var _assertString = _interopRequireDefault(require_assertString());
  var _merge = _interopRequireDefault(require_merge());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var lat = /^\(?[+-]?(90(\.0+)?|[1-8]?\d(\.\d+)?)$/;
  var long = /^\s?[+-]?(180(\.0+)?|1[0-7]\d(\.\d+)?|\d{1,2}(\.\d+)?)\)?$/;
  var latDMS = /^(([1-8]?\d)\D+([1-5]?\d|60)\D+([1-5]?\d|60)(\.\d+)?|90\D+0\D+0)\D+[NSns]?$/i;
  var longDMS = /^\s*([1-7]?\d{1,2}\D+([1-5]?\d|60)\D+([1-5]?\d|60)(\.\d+)?|180\D+0\D+0)\D+[EWew]?$/i;
  var defaultLatLongOptions = {
    checkDMS: false
  };
  function isLatLong(str, options2) {
    (0, _assertString.default)(str);
    options2 = (0, _merge.default)(options2, defaultLatLongOptions);
    if (!str.includes(","))
      return false;
    var pair = str.split(",");
    if (pair[0].startsWith("(") && !pair[1].endsWith(")") || pair[1].endsWith(")") && !pair[0].startsWith("("))
      return false;
    if (options2.checkDMS) {
      return latDMS.test(pair[0]) && longDMS.test(pair[1]);
    }
    return lat.test(pair[0]) && long.test(pair[1]);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_includes = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var includes = function includes(arr, val2) {
    return arr.some(function(arrVal) {
      return val2 === arrVal;
    });
  };
  var _default = exports.default = includes;
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isDecimal = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isDecimal;
  var _merge = _interopRequireDefault(require_merge());
  var _assertString = _interopRequireDefault(require_assertString());
  var _includes = _interopRequireDefault(require_includes());
  var _alpha = require_alpha();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function decimalRegExp(options2) {
    var regExp = new RegExp("^[-+]?([0-9]+)?(\\".concat(_alpha.decimal[options2.locale], "[0-9]{").concat(options2.decimal_digits, "})").concat(options2.force_decimal ? "" : "?", "$"));
    return regExp;
  }
  var default_decimal_options = {
    force_decimal: false,
    decimal_digits: "1,",
    locale: "en-US"
  };
  var blacklist = ["", "-", "+"];
  function isDecimal(str, options2) {
    (0, _assertString.default)(str);
    options2 = (0, _merge.default)(options2, default_decimal_options);
    if (options2.locale in _alpha.decimal) {
      return !(0, _includes.default)(blacklist, str.replace(/ /g, "")) && decimalRegExp(options2).test(str);
    }
    throw new Error("Invalid locale '".concat(options2.locale, "'"));
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isHexColor = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isHexColor;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var hexcolor = /^#?([0-9A-F]{3}|[0-9A-F]{4}|[0-9A-F]{6}|[0-9A-F]{8})$/i;
  function isHexColor(str) {
    (0, _assertString.default)(str);
    return hexcolor.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isLuhnNumber = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isLuhnNumber;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isLuhnNumber(str) {
    (0, _assertString.default)(str);
    var sanitized = str.replace(/[- ]+/g, "");
    var sum = 0;
    var digit;
    var tmpNum;
    var shouldDouble;
    for (var i = sanitized.length - 1;i >= 0; i--) {
      digit = sanitized.substring(i, i + 1);
      tmpNum = parseInt(digit, 10);
      if (shouldDouble) {
        tmpNum *= 2;
        if (tmpNum >= 10) {
          sum += tmpNum % 10 + 1;
        } else {
          sum += tmpNum;
        }
      } else {
        sum += tmpNum;
      }
      shouldDouble = !shouldDouble;
    }
    return !!(sum % 10 === 0 ? sanitized : false);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isCreditCard = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isCreditCard;
  var _assertString = _interopRequireDefault(require_assertString());
  var _isLuhnNumber = _interopRequireDefault(require_isLuhnNumber());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var cards = {
    amex: /^3[47][0-9]{13}$/,
    dinersclub: /^3(?:0[0-5]|[68][0-9])[0-9]{11}$/,
    discover: /^6(?:011|5[0-9][0-9])[0-9]{12,15}$/,
    jcb: /^(?:2131|1800|35\d{3})\d{11}$/,
    mastercard: /^5[1-5][0-9]{2}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}$/,
    unionpay: /^(6[27][0-9]{14}|^(81[0-9]{14,17}))$/,
    visa: /^(?:4[0-9]{12})(?:[0-9]{3,6})?$/
  };
  var allCards = function() {
    var tmpCardsArray = [];
    for (var cardProvider in cards) {
      if (cards.hasOwnProperty(cardProvider)) {
        tmpCardsArray.push(cards[cardProvider]);
      }
    }
    return tmpCardsArray;
  }();
  function isCreditCard(card) {
    var options2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _assertString.default)(card);
    var provider = options2.provider;
    var sanitized = card.replace(/[- ]+/g, "");
    if (provider && provider.toLowerCase() in cards) {
      if (!cards[provider.toLowerCase()].test(sanitized)) {
        return false;
      }
    } else if (provider && !(provider.toLowerCase() in cards)) {
      throw new Error("".concat(provider, " is not a valid credit card provider."));
    } else if (!allCards.some(function(cardProvider) {
      return cardProvider.test(sanitized);
    })) {
      return false;
    }
    return (0, _isLuhnNumber.default)(card);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isAlphanumeric = __commonJS((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAlphanumeric;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString());
  var _alpha = require_alpha();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isAlphanumeric(_str) {
    var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "en-US";
    var options2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    (0, _assertString.default)(_str);
    var str = _str;
    var ignore = options2.ignore;
    if (ignore) {
      if (ignore instanceof RegExp) {
        str = str.replace(ignore, "");
      } else if (typeof ignore === "string") {
        str = str.replace(new RegExp("[".concat(ignore.replace(/[-[\]{}()*+?.,\\^$|#\\s]/g, "\\$&"), "]"), "g"), "");
      } else {
        throw new Error("ignore should be instance of a String or RegExp");
      }
    }
    if (locale in _alpha.alphanumeric) {
      return _alpha.alphanumeric[locale].test(str);
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales2 = exports.locales = Object.keys(_alpha.alphanumeric);
});
var require_isPassportNumber = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isPassportNumber;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var passportRegexByCountryCode = {
    AM: /^[A-Z]{2}\d{7}$/,
    AR: /^[A-Z]{3}\d{6}$/,
    AT: /^[A-Z]\d{7}$/,
    AU: /^[A-Z]\d{7}$/,
    AZ: /^[A-Z]{1}\d{8}$/,
    BE: /^[A-Z]{2}\d{6}$/,
    BG: /^\d{9}$/,
    BR: /^[A-Z]{2}\d{6}$/,
    BY: /^[A-Z]{2}\d{7}$/,
    CA: /^[A-Z]{2}\d{6}$/,
    CH: /^[A-Z]\d{7}$/,
    CN: /^G\d{8}$|^E(?![IO])[A-Z0-9]\d{7}$/,
    CY: /^[A-Z](\d{6}|\d{8})$/,
    CZ: /^\d{8}$/,
    DE: /^[CFGHJKLMNPRTVWXYZ0-9]{9}$/,
    DK: /^\d{9}$/,
    DZ: /^\d{9}$/,
    EE: /^([A-Z]\d{7}|[A-Z]{2}\d{7})$/,
    ES: /^[A-Z0-9]{2}([A-Z0-9]?)\d{6}$/,
    FI: /^[A-Z]{2}\d{7}$/,
    FR: /^\d{2}[A-Z]{2}\d{5}$/,
    GB: /^\d{9}$/,
    GR: /^[A-Z]{2}\d{7}$/,
    HR: /^\d{9}$/,
    HU: /^[A-Z]{2}(\d{6}|\d{7})$/,
    IE: /^[A-Z0-9]{2}\d{7}$/,
    IN: /^[A-Z]{1}-?\d{7}$/,
    ID: /^[A-C]\d{7}$/,
    IR: /^[A-Z]\d{8}$/,
    IS: /^(A)\d{7}$/,
    IT: /^[A-Z0-9]{2}\d{7}$/,
    JM: /^[Aa]\d{7}$/,
    JP: /^[A-Z]{2}\d{7}$/,
    KR: /^[MS]\d{8}$/,
    KZ: /^[a-zA-Z]\d{7}$/,
    LI: /^[a-zA-Z]\d{5}$/,
    LT: /^[A-Z0-9]{8}$/,
    LU: /^[A-Z0-9]{8}$/,
    LV: /^[A-Z0-9]{2}\d{7}$/,
    LY: /^[A-Z0-9]{8}$/,
    MT: /^\d{7}$/,
    MZ: /^([A-Z]{2}\d{7})|(\d{2}[A-Z]{2}\d{5})$/,
    MY: /^[AHK]\d{8}$/,
    MX: /^\d{10,11}$/,
    NL: /^[A-Z]{2}[A-Z0-9]{6}\d$/,
    NZ: /^([Ll]([Aa]|[Dd]|[Ff]|[Hh])|[Ee]([Aa]|[Pp])|[Nn])\d{6}$/,
    PH: /^([A-Z](\d{6}|\d{7}[A-Z]))|([A-Z]{2}(\d{6}|\d{7}))$/,
    PK: /^[A-Z]{2}\d{7}$/,
    PL: /^[A-Z]{2}\d{7}$/,
    PT: /^[A-Z]\d{6}$/,
    RO: /^\d{8,9}$/,
    RU: /^\d{9}$/,
    SE: /^\d{8}$/,
    SL: /^(P)[A-Z]\d{7}$/,
    SK: /^[0-9A-Z]\d{7}$/,
    TH: /^[A-Z]{1,2}\d{6,7}$/,
    TR: /^[A-Z]\d{8}$/,
    UA: /^[A-Z]{2}\d{6}$/,
    US: /^\d{9}$/,
    ZA: /^[TAMD]\d{8}$/
  };
  function isPassportNumber(str, countryCode) {
    (0, _assertString.default)(str);
    var normalizedStr = str.replace(/\s/g, "").toUpperCase();
    return countryCode.toUpperCase() in passportRegexByCountryCode && passportRegexByCountryCode[countryCode].test(normalizedStr);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isPostalCode = __commonJS((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isPostalCode;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var threeDigit = /^\d{3}$/;
  var fourDigit = /^\d{4}$/;
  var fiveDigit = /^\d{5}$/;
  var sixDigit = /^\d{6}$/;
  var patterns = {
    AD: /^AD\d{3}$/,
    AT: fourDigit,
    AU: fourDigit,
    AZ: /^AZ\d{4}$/,
    BA: /^([7-8]\d{4}$)/,
    BE: fourDigit,
    BG: fourDigit,
    BR: /^\d{5}-\d{3}$/,
    BY: /^2[1-4]\d{4}$/,
    CA: /^[ABCEGHJKLMNPRSTVXY]\d[ABCEGHJ-NPRSTV-Z][\s\-]?\d[ABCEGHJ-NPRSTV-Z]\d$/i,
    CH: fourDigit,
    CN: /^(0[1-7]|1[012356]|2[0-7]|3[0-6]|4[0-7]|5[1-7]|6[1-7]|7[1-5]|8[1345]|9[09])\d{4}$/,
    CZ: /^\d{3}\s?\d{2}$/,
    DE: fiveDigit,
    DK: fourDigit,
    DO: fiveDigit,
    DZ: fiveDigit,
    EE: fiveDigit,
    ES: /^(5[0-2]{1}|[0-4]{1}\d{1})\d{3}$/,
    FI: fiveDigit,
    FR: /^\d{2}\s?\d{3}$/,
    GB: /^(gir\s?0aa|[a-z]{1,2}\d[\da-z]?\s?(\d[a-z]{2})?)$/i,
    GR: /^\d{3}\s?\d{2}$/,
    HR: /^([1-5]\d{4}$)/,
    HT: /^HT\d{4}$/,
    HU: fourDigit,
    ID: fiveDigit,
    IE: /^(?!.*(?:o))[A-Za-z]\d[\dw]\s\w{4}$/i,
    IL: /^(\d{5}|\d{7})$/,
    IN: /^((?!10|29|35|54|55|65|66|86|87|88|89)[1-9][0-9]{5})$/,
    IR: /^(?!(\d)\1{3})[13-9]{4}[1346-9][013-9]{5}$/,
    IS: threeDigit,
    IT: fiveDigit,
    JP: /^\d{3}\-\d{4}$/,
    KE: fiveDigit,
    KR: /^(\d{5}|\d{6})$/,
    LI: /^(948[5-9]|949[0-7])$/,
    LT: /^LT\-\d{5}$/,
    LU: fourDigit,
    LV: /^LV\-\d{4}$/,
    LK: fiveDigit,
    MG: threeDigit,
    MX: fiveDigit,
    MT: /^[A-Za-z]{3}\s{0,1}\d{4}$/,
    MY: fiveDigit,
    NL: /^[1-9]\d{3}\s?(?!sa|sd|ss)[a-z]{2}$/i,
    NO: fourDigit,
    NP: /^(10|21|22|32|33|34|44|45|56|57)\d{3}$|^(977)$/i,
    NZ: fourDigit,
    PL: /^\d{2}\-\d{3}$/,
    PR: /^00[679]\d{2}([ -]\d{4})?$/,
    PT: /^\d{4}\-\d{3}?$/,
    RO: sixDigit,
    RU: sixDigit,
    SA: fiveDigit,
    SE: /^[1-9]\d{2}\s?\d{2}$/,
    SG: sixDigit,
    SI: fourDigit,
    SK: /^\d{3}\s?\d{2}$/,
    TH: fiveDigit,
    TN: fourDigit,
    TW: /^\d{3}(\d{2})?$/,
    UA: fiveDigit,
    US: /^\d{5}(-\d{4})?$/,
    ZA: fourDigit,
    ZM: fiveDigit
  };
  var locales2 = exports.locales = Object.keys(patterns);
  function isPostalCode(str, locale) {
    (0, _assertString.default)(str);
    if (locale in patterns) {
      return patterns[locale].test(str);
    } else if (locale === "any") {
      for (var key in patterns) {
        if (patterns.hasOwnProperty(key)) {
          var pattern = patterns[key];
          if (pattern.test(str)) {
            return true;
          }
        }
      }
      return false;
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
});
var require_isMobilePhone = __commonJS((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isMobilePhone;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var phones = {
    "am-AM": /^(\+?374|0)(33|4[134]|55|77|88|9[13-689])\d{6}$/,
    "ar-AE": /^((\+?971)|0)?5[024568]\d{7}$/,
    "ar-BH": /^(\+?973)?(3|6)\d{7}$/,
    "ar-DZ": /^(\+?213|0)(5|6|7)\d{8}$/,
    "ar-LB": /^(\+?961)?((3|81)\d{6}|7\d{7})$/,
    "ar-EG": /^((\+?20)|0)?1[0125]\d{8}$/,
    "ar-IQ": /^(\+?964|0)?7[0-9]\d{8}$/,
    "ar-JO": /^(\+?962|0)?7[789]\d{7}$/,
    "ar-KW": /^(\+?965)([569]\d{7}|41\d{6})$/,
    "ar-LY": /^((\+?218)|0)?(9[1-6]\d{7}|[1-8]\d{7,9})$/,
    "ar-MA": /^(?:(?:\+|00)212|0)[5-7]\d{8}$/,
    "ar-OM": /^((\+|00)968)?(9[1-9])\d{6}$/,
    "ar-PS": /^(\+?970|0)5[6|9](\d{7})$/,
    "ar-SA": /^(!?(\+?966)|0)?5\d{8}$/,
    "ar-SD": /^((\+?249)|0)?(9[012369]|1[012])\d{7}$/,
    "ar-SY": /^(!?(\+?963)|0)?9\d{8}$/,
    "ar-TN": /^(\+?216)?[2459]\d{7}$/,
    "az-AZ": /^(\+994|0)(10|5[015]|7[07]|99)\d{7}$/,
    "bs-BA": /^((((\+|00)3876)|06))((([0-3]|[5-6])\d{6})|(4\d{7}))$/,
    "be-BY": /^(\+?375)?(24|25|29|33|44)\d{7}$/,
    "bg-BG": /^(\+?359|0)?8[789]\d{7}$/,
    "bn-BD": /^(\+?880|0)1[13456789][0-9]{8}$/,
    "ca-AD": /^(\+376)?[346]\d{5}$/,
    "cs-CZ": /^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,
    "da-DK": /^(\+?45)?\s?\d{2}\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "de-DE": /^((\+49|0)1)(5[0-25-9]\d|6([23]|0\d?)|7([0-57-9]|6\d))\d{7,9}$/,
    "de-AT": /^(\+43|0)\d{1,4}\d{3,12}$/,
    "de-CH": /^(\+41|0)([1-9])\d{1,9}$/,
    "de-LU": /^(\+352)?((6\d1)\d{6})$/,
    "dv-MV": /^(\+?960)?(7[2-9]|9[1-9])\d{5}$/,
    "el-GR": /^(\+?30|0)?6(8[5-9]|9(?![26])[0-9])\d{7}$/,
    "el-CY": /^(\+?357?)?(9(9|6)\d{6})$/,
    "en-AI": /^(\+?1|0)264(?:2(35|92)|4(?:6[1-2]|76|97)|5(?:3[6-9]|8[1-4])|7(?:2(4|9)|72))\d{4}$/,
    "en-AU": /^(\+?61|0)4\d{8}$/,
    "en-AG": /^(?:\+1|1)268(?:464|7(?:1[3-9]|[28]\d|3[0246]|64|7[0-689]))\d{4}$/,
    "en-BM": /^(\+?1)?441(((3|7)\d{6}$)|(5[0-3][0-9]\d{4}$)|(59\d{5}$))/,
    "en-BS": /^(\+?1[-\s]?|0)?\(?242\)?[-\s]?\d{3}[-\s]?\d{4}$/,
    "en-GB": /^(\+?44|0)7\d{9}$/,
    "en-GG": /^(\+?44|0)1481\d{6}$/,
    "en-GH": /^(\+233|0)(20|50|24|54|27|57|26|56|23|28|55|59)\d{7}$/,
    "en-GY": /^(\+592|0)6\d{6}$/,
    "en-HK": /^(\+?852[-\s]?)?[456789]\d{3}[-\s]?\d{4}$/,
    "en-MO": /^(\+?853[-\s]?)?[6]\d{3}[-\s]?\d{4}$/,
    "en-IE": /^(\+?353|0)8[356789]\d{7}$/,
    "en-IN": /^(\+?91|0)?[6789]\d{9}$/,
    "en-JM": /^(\+?876)?\d{7}$/,
    "en-KE": /^(\+?254|0)(7|1)\d{8}$/,
    "fr-CF": /^(\+?236| ?)(70|75|77|72|21|22)\d{6}$/,
    "en-SS": /^(\+?211|0)(9[1257])\d{7}$/,
    "en-KI": /^((\+686|686)?)?( )?((6|7)(2|3|8)[0-9]{6})$/,
    "en-KN": /^(?:\+1|1)869(?:46\d|48[89]|55[6-8]|66\d|76[02-7])\d{4}$/,
    "en-LS": /^(\+?266)(22|28|57|58|59|27|52)\d{6}$/,
    "en-MT": /^(\+?356|0)?(99|79|77|21|27|22|25)[0-9]{6}$/,
    "en-MU": /^(\+?230|0)?\d{8}$/,
    "en-MW": /^(\+?265|0)(((77|88|31|99|98|21)\d{7})|(((111)|1)\d{6})|(32000\d{4}))$/,
    "en-NA": /^(\+?264|0)(6|8)\d{7}$/,
    "en-NG": /^(\+?234|0)?[789]\d{9}$/,
    "en-NZ": /^(\+?64|0)[28]\d{7,9}$/,
    "en-PG": /^(\+?675|0)?(7\d|8[18])\d{6}$/,
    "en-PK": /^((00|\+)?92|0)3[0-6]\d{8}$/,
    "en-PH": /^(09|\+639)\d{9}$/,
    "en-RW": /^(\+?250|0)?[7]\d{8}$/,
    "en-SG": /^(\+65)?[3689]\d{7}$/,
    "en-SL": /^(\+?232|0)\d{8}$/,
    "en-TZ": /^(\+?255|0)?[67]\d{8}$/,
    "en-UG": /^(\+?256|0)?[7]\d{8}$/,
    "en-US": /^((\+1|1)?( |-)?)?(\([2-9][0-9]{2}\)|[2-9][0-9]{2})( |-)?([2-9][0-9]{2}( |-)?[0-9]{4})$/,
    "en-ZA": /^(\+?27|0)\d{9}$/,
    "en-ZM": /^(\+?26)?09[567]\d{7}$/,
    "en-ZW": /^(\+263)[0-9]{9}$/,
    "en-BW": /^(\+?267)?(7[1-8]{1})\d{6}$/,
    "es-AR": /^\+?549(11|[2368]\d)\d{8}$/,
    "es-BO": /^(\+?591)?(6|7)\d{7}$/,
    "es-CO": /^(\+?57)?3(0(0|1|2|4|5)|1\d|2[0-4]|5(0|1))\d{7}$/,
    "es-CL": /^(\+?56|0)[2-9]\d{1}\d{7}$/,
    "es-CR": /^(\+506)?[2-8]\d{7}$/,
    "es-CU": /^(\+53|0053)?5\d{7}$/,
    "es-DO": /^(\+?1)?8[024]9\d{7}$/,
    "es-HN": /^(\+?504)?[9|8|3|2]\d{7}$/,
    "es-EC": /^(\+?593|0)([2-7]|9[2-9])\d{7}$/,
    "es-ES": /^(\+?34)?[6|7]\d{8}$/,
    "es-PE": /^(\+?51)?9\d{8}$/,
    "es-MX": /^(\+?52)?(1|01)?\d{10,11}$/,
    "es-NI": /^(\+?505)\d{7,8}$/,
    "es-PA": /^(\+?507)\d{7,8}$/,
    "es-PY": /^(\+?595|0)9[9876]\d{7}$/,
    "es-SV": /^(\+?503)?[67]\d{7}$/,
    "es-UY": /^(\+598|0)9[1-9][\d]{6}$/,
    "es-VE": /^(\+?58)?(2|4)\d{9}$/,
    "et-EE": /^(\+?372)?\s?(5|8[1-4])\s?([0-9]\s?){6,7}$/,
    "fa-IR": /^(\+?98[\-\s]?|0)9[0-39]\d[\-\s]?\d{3}[\-\s]?\d{4}$/,
    "fi-FI": /^(\+?358|0)\s?(4[0-6]|50)\s?(\d\s?){4,8}$/,
    "fj-FJ": /^(\+?679)?\s?\d{3}\s?\d{4}$/,
    "fo-FO": /^(\+?298)?\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "fr-BF": /^(\+226|0)[67]\d{7}$/,
    "fr-BJ": /^(\+229)\d{8}$/,
    "fr-CD": /^(\+?243|0)?(8|9)\d{8}$/,
    "fr-CM": /^(\+?237)6[0-9]{8}$/,
    "fr-FR": /^(\+?33|0)[67]\d{8}$/,
    "fr-GF": /^(\+?594|0|00594)[67]\d{8}$/,
    "fr-GP": /^(\+?590|0|00590)[67]\d{8}$/,
    "fr-MQ": /^(\+?596|0|00596)[67]\d{8}$/,
    "fr-PF": /^(\+?689)?8[789]\d{6}$/,
    "fr-RE": /^(\+?262|0|00262)[67]\d{8}$/,
    "fr-WF": /^(\+681)?\d{6}$/,
    "he-IL": /^(\+972|0)([23489]|5[012345689]|77)[1-9]\d{6}$/,
    "hu-HU": /^(\+?36|06)(20|30|31|50|70)\d{7}$/,
    "id-ID": /^(\+?62|0)8(1[123456789]|2[1238]|3[1238]|5[12356789]|7[78]|9[56789]|8[123456789])([\s?|\d]{5,11})$/,
    "ir-IR": /^(\+98|0)?9\d{9}$/,
    "it-IT": /^(\+?39)?\s?3\d{2} ?\d{6,7}$/,
    "it-SM": /^((\+378)|(0549)|(\+390549)|(\+3780549))?6\d{5,9}$/,
    "ja-JP": /^(\+81[ \-]?(\(0\))?|0)[6789]0[ \-]?\d{4}[ \-]?\d{4}$/,
    "ka-GE": /^(\+?995)?(79\d{7}|5\d{8})$/,
    "kk-KZ": /^(\+?7|8)?7\d{9}$/,
    "kl-GL": /^(\+?299)?\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "ko-KR": /^((\+?82)[ \-]?)?0?1([0|1|6|7|8|9]{1})[ \-]?\d{3,4}[ \-]?\d{4}$/,
    "ky-KG": /^(\+?7\s?\+?7|0)\s?\d{2}\s?\d{3}\s?\d{4}$/,
    "lt-LT": /^(\+370|8)\d{8}$/,
    "lv-LV": /^(\+?371)2\d{7}$/,
    "mg-MG": /^((\+?261|0)(2|3)\d)?\d{7}$/,
    "mn-MN": /^(\+|00|011)?976(77|81|88|91|94|95|96|99)\d{6}$/,
    "my-MM": /^(\+?959|09|9)(2[5-7]|3[1-2]|4[0-5]|6[6-9]|7[5-9]|9[6-9])[0-9]{7}$/,
    "ms-MY": /^(\+?60|0)1(([0145](-|\s)?\d{7,8})|([236-9](-|\s)?\d{7}))$/,
    "mz-MZ": /^(\+?258)?8[234567]\d{7}$/,
    "nb-NO": /^(\+?47)?[49]\d{7}$/,
    "ne-NP": /^(\+?977)?9[78]\d{8}$/,
    "nl-BE": /^(\+?32|0)4\d{8}$/,
    "nl-NL": /^(((\+|00)?31\(0\))|((\+|00)?31)|0)6{1}\d{8}$/,
    "nl-AW": /^(\+)?297(56|59|64|73|74|99)\d{5}$/,
    "nn-NO": /^(\+?47)?[49]\d{7}$/,
    "pl-PL": /^(\+?48)? ?([5-8]\d|45) ?\d{3} ?\d{2} ?\d{2}$/,
    "pt-BR": /^((\+?55\ ?[1-9]{2}\ ?)|(\+?55\ ?\([1-9]{2}\)\ ?)|(0[1-9]{2}\ ?)|(\([1-9]{2}\)\ ?)|([1-9]{2}\ ?))((\d{4}\-?\d{4})|(9[1-9]{1}\d{3}\-?\d{4}))$/,
    "pt-PT": /^(\+?351)?9[1236]\d{7}$/,
    "pt-AO": /^(\+244)\d{9}$/,
    "ro-MD": /^(\+?373|0)((6(0|1|2|6|7|8|9))|(7(6|7|8|9)))\d{6}$/,
    "ro-RO": /^(\+?40|0)\s?7\d{2}(\/|\s|\.|-)?\d{3}(\s|\.|-)?\d{3}$/,
    "ru-RU": /^(\+?7|8)?9\d{9}$/,
    "si-LK": /^(?:0|94|\+94)?(7(0|1|2|4|5|6|7|8)( |-)?)\d{7}$/,
    "sl-SI": /^(\+386\s?|0)(\d{1}\s?\d{3}\s?\d{2}\s?\d{2}|\d{2}\s?\d{3}\s?\d{3})$/,
    "sk-SK": /^(\+?421)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,
    "so-SO": /^(\+?252|0)((6[0-9])\d{7}|(7[1-9])\d{7})$/,
    "sq-AL": /^(\+355|0)6[789]\d{6}$/,
    "sr-RS": /^(\+3816|06)[- \d]{5,9}$/,
    "sv-SE": /^(\+?46|0)[\s\-]?7[\s\-]?[02369]([\s\-]?\d){7}$/,
    "tg-TJ": /^(\+?992)?[5][5]\d{7}$/,
    "th-TH": /^(\+66|66|0)\d{9}$/,
    "tr-TR": /^(\+?90|0)?5\d{9}$/,
    "tk-TM": /^(\+993|993|8)\d{8}$/,
    "uk-UA": /^(\+?38|8)?0\d{9}$/,
    "uz-UZ": /^(\+?998)?(6[125-79]|7[1-69]|88|9\d)\d{7}$/,
    "vi-VN": /^((\+?84)|0)((3([2-9]))|(5([25689]))|(7([0|6-9]))|(8([1-9]))|(9([0-9])))([0-9]{7})$/,
    "zh-CN": /^((\+|00)86)?(1[3-9]|9[28])\d{9}$/,
    "zh-TW": /^(\+?886\-?|0)?9\d{8}$/,
    "dz-BT": /^(\+?975|0)?(17|16|77|02)\d{6}$/,
    "ar-YE": /^(((\+|00)9677|0?7)[0137]\d{7}|((\+|00)967|0)[1-7]\d{6})$/,
    "ar-EH": /^(\+?212|0)[\s\-]?(5288|5289)[\s\-]?\d{5}$/,
    "fa-AF": /^(\+93|0)?(2{1}[0-8]{1}|[3-5]{1}[0-4]{1})(\d{7})$/
  };
  phones["en-CA"] = phones["en-US"];
  phones["fr-CA"] = phones["en-CA"];
  phones["fr-BE"] = phones["nl-BE"];
  phones["zh-HK"] = phones["en-HK"];
  phones["zh-MO"] = phones["en-MO"];
  phones["ga-IE"] = phones["en-IE"];
  phones["fr-CH"] = phones["de-CH"];
  phones["it-CH"] = phones["fr-CH"];
  function isMobilePhone(str, locale, options2) {
    (0, _assertString.default)(str);
    if (options2 && options2.strictMode && !str.startsWith("+")) {
      return false;
    }
    if (Array.isArray(locale)) {
      return locale.some(function(key2) {
        if (phones.hasOwnProperty(key2)) {
          var phone2 = phones[key2];
          if (phone2.test(str)) {
            return true;
          }
        }
        return false;
      });
    } else if (locale in phones) {
      return phones[locale].test(str);
    } else if (!locale || locale === "any") {
      for (var key in phones) {
        if (phones.hasOwnProperty(key)) {
          var phone = phones[key];
          if (phone.test(str)) {
            return true;
          }
        }
      }
      return false;
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales2 = exports.locales = Object.keys(phones);
});
var require_dayjs_min = __commonJS((exports, module) => {
  (function(t, e) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = e() : typeof define == "function" && define.amd ? define(e) : (t = typeof globalThis != "undefined" ? globalThis : t || self).dayjs = e();
  })(exports, function() {
    var t = 1000, e = 60000, n = 3600000, r2 = "millisecond", i = "second", s3 = "minute", u = "hour", a = "day", o = "week", c2 = "month", f2 = "quarter", h3 = "year", d = "date", l3 = "Invalid Date", $3 = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, M2 = { name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"), ordinal: function(t2) {
      var e2 = ["th", "st", "nd", "rd"], n2 = t2 % 100;
      return "[" + t2 + (e2[(n2 - 20) % 10] || e2[n2] || e2[0]) + "]";
    } }, m2 = function(t2, e2, n2) {
      var r3 = String(t2);
      return !r3 || r3.length >= e2 ? t2 : "" + Array(e2 + 1 - r3.length).join(n2) + t2;
    }, v2 = { s: m2, z: function(t2) {
      var e2 = -t2.utcOffset(), n2 = Math.abs(e2), r3 = Math.floor(n2 / 60), i2 = n2 % 60;
      return (e2 <= 0 ? "+" : "-") + m2(r3, 2, "0") + ":" + m2(i2, 2, "0");
    }, m: function t(e2, n2) {
      if (e2.date() < n2.date())
        return -t(n2, e2);
      var r3 = 12 * (n2.year() - e2.year()) + (n2.month() - e2.month()), i2 = e2.clone().add(r3, c2), s4 = n2 - i2 < 0, u2 = e2.clone().add(r3 + (s4 ? -1 : 1), c2);
      return +(-(r3 + (n2 - i2) / (s4 ? i2 - u2 : u2 - i2)) || 0);
    }, a: function(t2) {
      return t2 < 0 ? Math.ceil(t2) || 0 : Math.floor(t2);
    }, p: function(t2) {
      return { M: c2, y: h3, w: o, d: a, D: d, h: u, m: s3, s: i, ms: r2, Q: f2 }[t2] || String(t2 || "").toLowerCase().replace(/s$/, "");
    }, u: function(t2) {
      return t2 === undefined;
    } }, g2 = "en", D = {};
    D[g2] = M2;
    var p22 = "$isDayjsObject", S = function(t2) {
      return t2 instanceof _2 || !(!t2 || !t2[p22]);
    }, w2 = function t(e2, n2, r3) {
      var i2;
      if (!e2)
        return g2;
      if (typeof e2 == "string") {
        var s4 = e2.toLowerCase();
        D[s4] && (i2 = s4), n2 && (D[s4] = n2, i2 = s4);
        var u2 = e2.split("-");
        if (!i2 && u2.length > 1)
          return t(u2[0]);
      } else {
        var a2 = e2.name;
        D[a2] = e2, i2 = a2;
      }
      return !r3 && i2 && (g2 = i2), i2 || !r3 && g2;
    }, O = function(t2, e2) {
      if (S(t2))
        return t2.clone();
      var n2 = typeof e2 == "object" ? e2 : {};
      return n2.date = t2, n2.args = arguments, new _2(n2);
    }, b2 = v2;
    b2.l = w2, b2.i = S, b2.w = function(t2, e2) {
      return O(t2, { locale: e2.$L, utc: e2.$u, x: e2.$x, $offset: e2.$offset });
    };
    var _2 = function() {
      function M3(t2) {
        this.$L = w2(t2.locale, null, true), this.parse(t2), this.$x = this.$x || t2.x || {}, this[p22] = true;
      }
      var m3 = M3.prototype;
      return m3.parse = function(t2) {
        this.$d = function(t3) {
          var { date: e2, utc: n2 } = t3;
          if (e2 === null)
            return new Date(NaN);
          if (b2.u(e2))
            return new Date;
          if (e2 instanceof Date)
            return new Date(e2);
          if (typeof e2 == "string" && !/Z$/i.test(e2)) {
            var r3 = e2.match($3);
            if (r3) {
              var i2 = r3[2] - 1 || 0, s4 = (r3[7] || "0").substring(0, 3);
              return n2 ? new Date(Date.UTC(r3[1], i2, r3[3] || 1, r3[4] || 0, r3[5] || 0, r3[6] || 0, s4)) : new Date(r3[1], i2, r3[3] || 1, r3[4] || 0, r3[5] || 0, r3[6] || 0, s4);
            }
          }
          return new Date(e2);
        }(t2), this.init();
      }, m3.init = function() {
        var t2 = this.$d;
        this.$y = t2.getFullYear(), this.$M = t2.getMonth(), this.$D = t2.getDate(), this.$W = t2.getDay(), this.$H = t2.getHours(), this.$m = t2.getMinutes(), this.$s = t2.getSeconds(), this.$ms = t2.getMilliseconds();
      }, m3.$utils = function() {
        return b2;
      }, m3.isValid = function() {
        return !(this.$d.toString() === l3);
      }, m3.isSame = function(t2, e2) {
        var n2 = O(t2);
        return this.startOf(e2) <= n2 && n2 <= this.endOf(e2);
      }, m3.isAfter = function(t2, e2) {
        return O(t2) < this.startOf(e2);
      }, m3.isBefore = function(t2, e2) {
        return this.endOf(e2) < O(t2);
      }, m3.$g = function(t2, e2, n2) {
        return b2.u(t2) ? this[e2] : this.set(n2, t2);
      }, m3.unix = function() {
        return Math.floor(this.valueOf() / 1000);
      }, m3.valueOf = function() {
        return this.$d.getTime();
      }, m3.startOf = function(t2, e2) {
        var n2 = this, r3 = !!b2.u(e2) || e2, f3 = b2.p(t2), l4 = function(t3, e3) {
          var i2 = b2.w(n2.$u ? Date.UTC(n2.$y, e3, t3) : new Date(n2.$y, e3, t3), n2);
          return r3 ? i2 : i2.endOf(a);
        }, $4 = function(t3, e3) {
          return b2.w(n2.toDate()[t3].apply(n2.toDate("s"), (r3 ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e3)), n2);
        }, y2 = this.$W, M4 = this.$M, m4 = this.$D, v3 = "set" + (this.$u ? "UTC" : "");
        switch (f3) {
          case h3:
            return r3 ? l4(1, 0) : l4(31, 11);
          case c2:
            return r3 ? l4(1, M4) : l4(0, M4 + 1);
          case o:
            var g3 = this.$locale().weekStart || 0, D2 = (y2 < g3 ? y2 + 7 : y2) - g3;
            return l4(r3 ? m4 - D2 : m4 + (6 - D2), M4);
          case a:
          case d:
            return $4(v3 + "Hours", 0);
          case u:
            return $4(v3 + "Minutes", 1);
          case s3:
            return $4(v3 + "Seconds", 2);
          case i:
            return $4(v3 + "Milliseconds", 3);
          default:
            return this.clone();
        }
      }, m3.endOf = function(t2) {
        return this.startOf(t2, false);
      }, m3.$set = function(t2, e2) {
        var n2, o2 = b2.p(t2), f3 = "set" + (this.$u ? "UTC" : ""), l4 = (n2 = {}, n2[a] = f3 + "Date", n2[d] = f3 + "Date", n2[c2] = f3 + "Month", n2[h3] = f3 + "FullYear", n2[u] = f3 + "Hours", n2[s3] = f3 + "Minutes", n2[i] = f3 + "Seconds", n2[r2] = f3 + "Milliseconds", n2)[o2], $4 = o2 === a ? this.$D + (e2 - this.$W) : e2;
        if (o2 === c2 || o2 === h3) {
          var y2 = this.clone().set(d, 1);
          y2.$d[l4]($4), y2.init(), this.$d = y2.set(d, Math.min(this.$D, y2.daysInMonth())).$d;
        } else
          l4 && this.$d[l4]($4);
        return this.init(), this;
      }, m3.set = function(t2, e2) {
        return this.clone().$set(t2, e2);
      }, m3.get = function(t2) {
        return this[b2.p(t2)]();
      }, m3.add = function(r3, f3) {
        var d2, l4 = this;
        r3 = Number(r3);
        var $4 = b2.p(f3), y2 = function(t2) {
          var e2 = O(l4);
          return b2.w(e2.date(e2.date() + Math.round(t2 * r3)), l4);
        };
        if ($4 === c2)
          return this.set(c2, this.$M + r3);
        if ($4 === h3)
          return this.set(h3, this.$y + r3);
        if ($4 === a)
          return y2(1);
        if ($4 === o)
          return y2(7);
        var M4 = (d2 = {}, d2[s3] = e, d2[u] = n, d2[i] = t, d2)[$4] || 1, m4 = this.$d.getTime() + r3 * M4;
        return b2.w(m4, this);
      }, m3.subtract = function(t2, e2) {
        return this.add(-1 * t2, e2);
      }, m3.format = function(t2) {
        var e2 = this, n2 = this.$locale();
        if (!this.isValid())
          return n2.invalidDate || l3;
        var r3 = t2 || "YYYY-MM-DDTHH:mm:ssZ", i2 = b2.z(this), s4 = this.$H, u2 = this.$m, a2 = this.$M, o2 = n2.weekdays, c3 = n2.months, f3 = n2.meridiem, h4 = function(t3, n3, i3, s5) {
          return t3 && (t3[n3] || t3(e2, r3)) || i3[n3].slice(0, s5);
        }, d2 = function(t3) {
          return b2.s(s4 % 12 || 12, t3, "0");
        }, $4 = f3 || function(t3, e3, n3) {
          var r4 = t3 < 12 ? "AM" : "PM";
          return n3 ? r4.toLowerCase() : r4;
        };
        return r3.replace(y, function(t3, r4) {
          return r4 || function(t4) {
            switch (t4) {
              case "YY":
                return String(e2.$y).slice(-2);
              case "YYYY":
                return b2.s(e2.$y, 4, "0");
              case "M":
                return a2 + 1;
              case "MM":
                return b2.s(a2 + 1, 2, "0");
              case "MMM":
                return h4(n2.monthsShort, a2, c3, 3);
              case "MMMM":
                return h4(c3, a2);
              case "D":
                return e2.$D;
              case "DD":
                return b2.s(e2.$D, 2, "0");
              case "d":
                return String(e2.$W);
              case "dd":
                return h4(n2.weekdaysMin, e2.$W, o2, 2);
              case "ddd":
                return h4(n2.weekdaysShort, e2.$W, o2, 3);
              case "dddd":
                return o2[e2.$W];
              case "H":
                return String(s4);
              case "HH":
                return b2.s(s4, 2, "0");
              case "h":
                return d2(1);
              case "hh":
                return d2(2);
              case "a":
                return $4(s4, u2, true);
              case "A":
                return $4(s4, u2, false);
              case "m":
                return String(u2);
              case "mm":
                return b2.s(u2, 2, "0");
              case "s":
                return String(e2.$s);
              case "ss":
                return b2.s(e2.$s, 2, "0");
              case "SSS":
                return b2.s(e2.$ms, 3, "0");
              case "Z":
                return i2;
            }
            return null;
          }(t3) || i2.replace(":", "");
        });
      }, m3.utcOffset = function() {
        return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
      }, m3.diff = function(r3, d2, l4) {
        var $4, y2 = this, M4 = b2.p(d2), m4 = O(r3), v3 = (m4.utcOffset() - this.utcOffset()) * e, g3 = this - m4, D2 = function() {
          return b2.m(y2, m4);
        };
        switch (M4) {
          case h3:
            $4 = D2() / 12;
            break;
          case c2:
            $4 = D2();
            break;
          case f2:
            $4 = D2() / 3;
            break;
          case o:
            $4 = (g3 - v3) / 604800000;
            break;
          case a:
            $4 = (g3 - v3) / 86400000;
            break;
          case u:
            $4 = g3 / n;
            break;
          case s3:
            $4 = g3 / e;
            break;
          case i:
            $4 = g3 / t;
            break;
          default:
            $4 = g3;
        }
        return l4 ? $4 : b2.a($4);
      }, m3.daysInMonth = function() {
        return this.endOf(c2).$D;
      }, m3.$locale = function() {
        return D[this.$L];
      }, m3.locale = function(t2, e2) {
        if (!t2)
          return this.$L;
        var n2 = this.clone(), r3 = w2(t2, e2, true);
        return r3 && (n2.$L = r3), n2;
      }, m3.clone = function() {
        return b2.w(this.$d, this);
      }, m3.toDate = function() {
        return new Date(this.valueOf());
      }, m3.toJSON = function() {
        return this.isValid() ? this.toISOString() : null;
      }, m3.toISOString = function() {
        return this.$d.toISOString();
      }, m3.toString = function() {
        return this.$d.toUTCString();
      }, M3;
    }(), k = _2.prototype;
    return O.prototype = k, [["$ms", r2], ["$s", i], ["$m", s3], ["$H", u], ["$W", a], ["$M", c2], ["$y", h3], ["$D", d]].forEach(function(t2) {
      k[t2[1]] = function(e2) {
        return this.$g(e2, t2[0], t2[1]);
      };
    }), O.extend = function(t2, e2) {
      return t2.$i || (t2(e2, _2, O), t2.$i = true), O;
    }, O.locale = w2, O.isDayjs = S, O.unix = function(t2) {
      return O(1000 * t2);
    }, O.en = D[g2], O.Ls = D, O.p = {}, O;
  });
});
var require_isSameOrAfter = __commonJS((exports, module) => {
  (function(e, t) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = t() : typeof define == "function" && define.amd ? define(t) : (e = typeof globalThis != "undefined" ? globalThis : e || self).dayjs_plugin_isSameOrAfter = t();
  })(exports, function() {
    return function(e, t) {
      t.prototype.isSameOrAfter = function(e2, t2) {
        return this.isSame(e2, t2) || this.isAfter(e2, t2);
      };
    };
  });
});
var require_isSameOrBefore = __commonJS((exports, module) => {
  (function(e, i) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = i() : typeof define == "function" && define.amd ? define(i) : (e = typeof globalThis != "undefined" ? globalThis : e || self).dayjs_plugin_isSameOrBefore = i();
  })(exports, function() {
    return function(e, i) {
      i.prototype.isSameOrBefore = function(e2, i2) {
        return this.isSame(e2, i2) || this.isBefore(e2, i2);
      };
    };
  });
});
var require_customParseFormat = __commonJS((exports, module) => {
  (function(e, t) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = t() : typeof define == "function" && define.amd ? define(t) : (e = typeof globalThis != "undefined" ? globalThis : e || self).dayjs_plugin_customParseFormat = t();
  })(exports, function() {
    var e = { LTS: "h:mm:ss A", LT: "h:mm A", L: "MM/DD/YYYY", LL: "MMMM D, YYYY", LLL: "MMMM D, YYYY h:mm A", LLLL: "dddd, MMMM D, YYYY h:mm A" }, t = /(\[[^[]*\])|([-_:/.,()\s]+)|(A|a|Q|YYYY|YY?|ww?|MM?M?M?|Do|DD?|hh?|HH?|mm?|ss?|S{1,3}|z|ZZ?)/g, n = /\d/, r2 = /\d\d/, i = /\d\d?/, o = /\d*[^-_:/,()\s\d]+/, s3 = {}, a = function(e2) {
      return (e2 = +e2) + (e2 > 68 ? 1900 : 2000);
    };
    var f2 = function(e2) {
      return function(t2) {
        this[e2] = +t2;
      };
    }, h3 = [/[+-]\d\d:?(\d\d)?|Z/, function(e2) {
      (this.zone || (this.zone = {})).offset = function(e3) {
        if (!e3)
          return 0;
        if (e3 === "Z")
          return 0;
        var t2 = e3.match(/([+-]|\d\d)/g), n2 = 60 * t2[1] + (+t2[2] || 0);
        return n2 === 0 ? 0 : t2[0] === "+" ? -n2 : n2;
      }(e2);
    }], u = function(e2) {
      var t2 = s3[e2];
      return t2 && (t2.indexOf ? t2 : t2.s.concat(t2.f));
    }, d = function(e2, t2) {
      var n2, r3 = s3.meridiem;
      if (r3) {
        for (var i2 = 1;i2 <= 24; i2 += 1)
          if (e2.indexOf(r3(i2, 0, t2)) > -1) {
            n2 = i2 > 12;
            break;
          }
      } else
        n2 = e2 === (t2 ? "pm" : "PM");
      return n2;
    }, c2 = { A: [o, function(e2) {
      this.afternoon = d(e2, false);
    }], a: [o, function(e2) {
      this.afternoon = d(e2, true);
    }], Q: [n, function(e2) {
      this.month = 3 * (e2 - 1) + 1;
    }], S: [n, function(e2) {
      this.milliseconds = 100 * +e2;
    }], SS: [r2, function(e2) {
      this.milliseconds = 10 * +e2;
    }], SSS: [/\d{3}/, function(e2) {
      this.milliseconds = +e2;
    }], s: [i, f2("seconds")], ss: [i, f2("seconds")], m: [i, f2("minutes")], mm: [i, f2("minutes")], H: [i, f2("hours")], h: [i, f2("hours")], HH: [i, f2("hours")], hh: [i, f2("hours")], D: [i, f2("day")], DD: [r2, f2("day")], Do: [o, function(e2) {
      var t2 = s3.ordinal, n2 = e2.match(/\d+/);
      if (this.day = n2[0], t2)
        for (var r3 = 1;r3 <= 31; r3 += 1)
          t2(r3).replace(/\[|\]/g, "") === e2 && (this.day = r3);
    }], w: [i, f2("week")], ww: [r2, f2("week")], M: [i, f2("month")], MM: [r2, f2("month")], MMM: [o, function(e2) {
      var t2 = u("months"), n2 = (u("monthsShort") || t2.map(function(e3) {
        return e3.slice(0, 3);
      })).indexOf(e2) + 1;
      if (n2 < 1)
        throw new Error;
      this.month = n2 % 12 || n2;
    }], MMMM: [o, function(e2) {
      var t2 = u("months").indexOf(e2) + 1;
      if (t2 < 1)
        throw new Error;
      this.month = t2 % 12 || t2;
    }], Y: [/[+-]?\d+/, f2("year")], YY: [r2, function(e2) {
      this.year = a(e2);
    }], YYYY: [/\d{4}/, f2("year")], Z: h3, ZZ: h3 };
    function l3(n2) {
      var r3, i2;
      r3 = n2, i2 = s3 && s3.formats;
      for (var o2 = (n2 = r3.replace(/(\[[^\]]+])|(LTS?|l{1,4}|L{1,4})/g, function(t2, n3, r4) {
        var o3 = r4 && r4.toUpperCase();
        return n3 || i2[r4] || e[r4] || i2[o3].replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g, function(e2, t3, n4) {
          return t3 || n4.slice(1);
        });
      })).match(t), a2 = o2.length, f3 = 0;f3 < a2; f3 += 1) {
        var h4 = o2[f3], u2 = c2[h4], d2 = u2 && u2[0], l4 = u2 && u2[1];
        o2[f3] = l4 ? { regex: d2, parser: l4 } : h4.replace(/^\[|\]$/g, "");
      }
      return function(e2) {
        for (var t2 = {}, n3 = 0, r4 = 0;n3 < a2; n3 += 1) {
          var i3 = o2[n3];
          if (typeof i3 == "string")
            r4 += i3.length;
          else {
            var { regex: s4, parser: f4 } = i3, h5 = e2.slice(r4), u3 = s4.exec(h5)[0];
            f4.call(t2, u3), e2 = e2.replace(u3, "");
          }
        }
        return function(e3) {
          var t3 = e3.afternoon;
          if (t3 !== undefined) {
            var n4 = e3.hours;
            t3 ? n4 < 12 && (e3.hours += 12) : n4 === 12 && (e3.hours = 0), delete e3.afternoon;
          }
        }(t2), t2;
      };
    }
    return function(e2, t2, n2) {
      n2.p.customParseFormat = true, e2 && e2.parseTwoDigitYear && (a = e2.parseTwoDigitYear);
      var r3 = t2.prototype, i2 = r3.parse;
      r3.parse = function(e3) {
        var { date: t3, utc: r4, args: o2 } = e3;
        this.$u = r4;
        var a2 = o2[1];
        if (typeof a2 == "string") {
          var f3 = o2[2] === true, h4 = o2[3] === true, u2 = f3 || h4, d2 = o2[2];
          h4 && (d2 = o2[2]), s3 = this.$locale(), !f3 && d2 && (s3 = n2.Ls[d2]), this.$d = function(e4, t4, n3, r5) {
            try {
              if (["x", "X"].indexOf(t4) > -1)
                return new Date((t4 === "X" ? 1000 : 1) * e4);
              var i3 = l3(t4)(e4), o3 = i3.year, s4 = i3.month, a3 = i3.day, f4 = i3.hours, h5 = i3.minutes, u3 = i3.seconds, d3 = i3.milliseconds, c4 = i3.zone, m3 = i3.week, M3 = new Date, Y2 = a3 || (o3 || s4 ? 1 : M3.getDate()), p22 = o3 || M3.getFullYear(), v2 = 0;
              o3 && !s4 || (v2 = s4 > 0 ? s4 - 1 : M3.getMonth());
              var D, w2 = f4 || 0, g2 = h5 || 0, y = u3 || 0, L3 = d3 || 0;
              return c4 ? new Date(Date.UTC(p22, v2, Y2, w2, g2, y, L3 + 60 * c4.offset * 1000)) : n3 ? new Date(Date.UTC(p22, v2, Y2, w2, g2, y, L3)) : (D = new Date(p22, v2, Y2, w2, g2, y, L3), m3 && (D = r5(D).week(m3).toDate()), D);
            } catch (e5) {
              return new Date("");
            }
          }(t3, a2, r4, n2), this.init(), d2 && d2 !== true && (this.$L = this.locale(d2).$L), u2 && t3 != this.format(a2) && (this.$d = new Date("")), s3 = {};
        } else if (a2 instanceof Array)
          for (var c3 = a2.length, m2 = 1;m2 <= c3; m2 += 1) {
            o2[1] = a2[m2 - 1];
            var M2 = n2.apply(this, o2);
            if (M2.isValid()) {
              this.$d = M2.$d, this.$L = M2.$L, this.init();
              break;
            }
            m2 === c3 && (this.$d = new Date(""));
          }
        else
          i2.call(this, e3);
      };
    };
  });
});
var require_escape = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = escape2;
  var _assertString = _interopRequireDefault(require_assertString());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function escape2(str) {
    (0, _assertString.default)(str);
    return str.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\//g, "&#x2F;").replace(/\\/g, "&#x5C;").replace(/`/g, "&#96;");
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_normalizeEmail = __commonJS((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = normalizeEmail;
  var _merge = _interopRequireDefault(require_merge());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_normalize_email_options = {
    all_lowercase: true,
    gmail_lowercase: true,
    gmail_remove_dots: true,
    gmail_remove_subaddress: true,
    gmail_convert_googlemaildotcom: true,
    outlookdotcom_lowercase: true,
    outlookdotcom_remove_subaddress: true,
    yahoo_lowercase: true,
    yahoo_remove_subaddress: true,
    yandex_lowercase: true,
    icloud_lowercase: true,
    icloud_remove_subaddress: true
  };
  var icloud_domains = ["icloud.com", "me.com"];
  var outlookdotcom_domains = ["hotmail.at", "hotmail.be", "hotmail.ca", "hotmail.cl", "hotmail.co.il", "hotmail.co.nz", "hotmail.co.th", "hotmail.co.uk", "hotmail.com", "hotmail.com.ar", "hotmail.com.au", "hotmail.com.br", "hotmail.com.gr", "hotmail.com.mx", "hotmail.com.pe", "hotmail.com.tr", "hotmail.com.vn", "hotmail.cz", "hotmail.de", "hotmail.dk", "hotmail.es", "hotmail.fr", "hotmail.hu", "hotmail.id", "hotmail.ie", "hotmail.in", "hotmail.it", "hotmail.jp", "hotmail.kr", "hotmail.lv", "hotmail.my", "hotmail.ph", "hotmail.pt", "hotmail.sa", "hotmail.sg", "hotmail.sk", "live.be", "live.co.uk", "live.com", "live.com.ar", "live.com.mx", "live.de", "live.es", "live.eu", "live.fr", "live.it", "live.nl", "msn.com", "outlook.at", "outlook.be", "outlook.cl", "outlook.co.il", "outlook.co.nz", "outlook.co.th", "outlook.com", "outlook.com.ar", "outlook.com.au", "outlook.com.br", "outlook.com.gr", "outlook.com.pe", "outlook.com.tr", "outlook.com.vn", "outlook.cz", "outlook.de", "outlook.dk", "outlook.es", "outlook.fr", "outlook.hu", "outlook.id", "outlook.ie", "outlook.in", "outlook.it", "outlook.jp", "outlook.kr", "outlook.lv", "outlook.my", "outlook.ph", "outlook.pt", "outlook.sa", "outlook.sg", "outlook.sk", "passport.com"];
  var yahoo_domains = ["rocketmail.com", "yahoo.ca", "yahoo.co.uk", "yahoo.com", "yahoo.de", "yahoo.fr", "yahoo.in", "yahoo.it", "ymail.com"];
  var yandex_domains = ["yandex.ru", "yandex.ua", "yandex.kz", "yandex.com", "yandex.by", "ya.ru"];
  function dotsReplacer(match) {
    if (match.length > 1) {
      return match;
    }
    return "";
  }
  function normalizeEmail(email2, options2) {
    options2 = (0, _merge.default)(options2, default_normalize_email_options);
    var raw_parts = email2.split("@");
    var domain = raw_parts.pop();
    var user = raw_parts.join("@");
    var parts = [user, domain];
    parts[1] = parts[1].toLowerCase();
    if (parts[1] === "gmail.com" || parts[1] === "googlemail.com") {
      if (options2.gmail_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (options2.gmail_remove_dots) {
        parts[0] = parts[0].replace(/\.+/g, dotsReplacer);
      }
      if (!parts[0].length) {
        return false;
      }
      if (options2.all_lowercase || options2.gmail_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
      parts[1] = options2.gmail_convert_googlemaildotcom ? "gmail.com" : parts[1];
    } else if (icloud_domains.indexOf(parts[1]) >= 0) {
      if (options2.icloud_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options2.all_lowercase || options2.icloud_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (outlookdotcom_domains.indexOf(parts[1]) >= 0) {
      if (options2.outlookdotcom_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options2.all_lowercase || options2.outlookdotcom_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (yahoo_domains.indexOf(parts[1]) >= 0) {
      if (options2.yahoo_remove_subaddress) {
        var components2 = parts[0].split("-");
        parts[0] = components2.length > 1 ? components2.slice(0, -1).join("-") : components2[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options2.all_lowercase || options2.yahoo_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (yandex_domains.indexOf(parts[1]) >= 0) {
      if (options2.all_lowercase || options2.yandex_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
      parts[1] = "yandex.ru";
    } else if (options2.all_lowercase) {
      parts[0] = parts[0].toLowerCase();
    }
    return parts.join("@");
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_kleur = __commonJS((exports, module) => {
  var { FORCE_COLOR, NODE_DISABLE_COLORS, TERM } = process.env;
  var $3 = {
    enabled: !NODE_DISABLE_COLORS && TERM !== "dumb" && FORCE_COLOR !== "0",
    reset: init2(0, 0),
    bold: init2(1, 22),
    dim: init2(2, 22),
    italic: init2(3, 23),
    underline: init2(4, 24),
    inverse: init2(7, 27),
    hidden: init2(8, 28),
    strikethrough: init2(9, 29),
    black: init2(30, 39),
    red: init2(31, 39),
    green: init2(32, 39),
    yellow: init2(33, 39),
    blue: init2(34, 39),
    magenta: init2(35, 39),
    cyan: init2(36, 39),
    white: init2(37, 39),
    gray: init2(90, 39),
    grey: init2(90, 39),
    bgBlack: init2(40, 49),
    bgRed: init2(41, 49),
    bgGreen: init2(42, 49),
    bgYellow: init2(43, 49),
    bgBlue: init2(44, 49),
    bgMagenta: init2(45, 49),
    bgCyan: init2(46, 49),
    bgWhite: init2(47, 49)
  };
  function run(arr, str) {
    let i = 0, tmp, beg = "", end = "";
    for (;i < arr.length; i++) {
      tmp = arr[i];
      beg += tmp.open;
      end += tmp.close;
      if (str.includes(tmp.close)) {
        str = str.replace(tmp.rgx, tmp.close + tmp.open);
      }
    }
    return beg + str + end;
  }
  function chain(has, keys) {
    let ctx = { has, keys };
    ctx.reset = $3.reset.bind(ctx);
    ctx.bold = $3.bold.bind(ctx);
    ctx.dim = $3.dim.bind(ctx);
    ctx.italic = $3.italic.bind(ctx);
    ctx.underline = $3.underline.bind(ctx);
    ctx.inverse = $3.inverse.bind(ctx);
    ctx.hidden = $3.hidden.bind(ctx);
    ctx.strikethrough = $3.strikethrough.bind(ctx);
    ctx.black = $3.black.bind(ctx);
    ctx.red = $3.red.bind(ctx);
    ctx.green = $3.green.bind(ctx);
    ctx.yellow = $3.yellow.bind(ctx);
    ctx.blue = $3.blue.bind(ctx);
    ctx.magenta = $3.magenta.bind(ctx);
    ctx.cyan = $3.cyan.bind(ctx);
    ctx.white = $3.white.bind(ctx);
    ctx.gray = $3.gray.bind(ctx);
    ctx.grey = $3.grey.bind(ctx);
    ctx.bgBlack = $3.bgBlack.bind(ctx);
    ctx.bgRed = $3.bgRed.bind(ctx);
    ctx.bgGreen = $3.bgGreen.bind(ctx);
    ctx.bgYellow = $3.bgYellow.bind(ctx);
    ctx.bgBlue = $3.bgBlue.bind(ctx);
    ctx.bgMagenta = $3.bgMagenta.bind(ctx);
    ctx.bgCyan = $3.bgCyan.bind(ctx);
    ctx.bgWhite = $3.bgWhite.bind(ctx);
    return ctx;
  }
  function init2(open, close) {
    let blk = {
      open: `\x1B[${open}m`,
      close: `\x1B[${close}m`,
      rgx: new RegExp(`\\x1b\\[${close}m`, "g")
    };
    return function(txt) {
      if (this !== undefined && this.has !== undefined) {
        this.has.includes(open) || (this.has.push(open), this.keys.push(blk));
        return txt === undefined ? this : $3.enabled ? run(this.keys, txt + "") : txt + "";
      }
      return txt === undefined ? chain([open], [blk]) : $3.enabled ? run([blk], txt + "") : txt + "";
    };
  }
  module.exports = $3;
});
var require_action = __commonJS((exports, module) => {
  module.exports = (key, isSelect) => {
    if (key.meta && key.name !== "escape")
      return;
    if (key.ctrl) {
      if (key.name === "a")
        return "first";
      if (key.name === "c")
        return "abort";
      if (key.name === "d")
        return "abort";
      if (key.name === "e")
        return "last";
      if (key.name === "g")
        return "reset";
    }
    if (isSelect) {
      if (key.name === "j")
        return "down";
      if (key.name === "k")
        return "up";
    }
    if (key.name === "return")
      return "submit";
    if (key.name === "enter")
      return "submit";
    if (key.name === "backspace")
      return "delete";
    if (key.name === "delete")
      return "deleteForward";
    if (key.name === "abort")
      return "abort";
    if (key.name === "escape")
      return "exit";
    if (key.name === "tab")
      return "next";
    if (key.name === "pagedown")
      return "nextPage";
    if (key.name === "pageup")
      return "prevPage";
    if (key.name === "home")
      return "home";
    if (key.name === "end")
      return "end";
    if (key.name === "up")
      return "up";
    if (key.name === "down")
      return "down";
    if (key.name === "right")
      return "right";
    if (key.name === "left")
      return "left";
    return false;
  };
});
var require_strip = __commonJS((exports, module) => {
  module.exports = (str) => {
    const pattern = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PRZcf-ntqry=><~]))"].join("|");
    const RGX = new RegExp(pattern, "g");
    return typeof str === "string" ? str.replace(RGX, "") : str;
  };
});
var require_src = __commonJS((exports, module) => {
  var ESC2 = "\x1B";
  var CSI2 = `${ESC2}[`;
  var beep2 = "\x07";
  var cursor2 = {
    to(x2, y) {
      if (!y)
        return `${CSI2}${x2 + 1}G`;
      return `${CSI2}${y + 1};${x2 + 1}H`;
    },
    move(x2, y) {
      let ret = "";
      if (x2 < 0)
        ret += `${CSI2}${-x2}D`;
      else if (x2 > 0)
        ret += `${CSI2}${x2}C`;
      if (y < 0)
        ret += `${CSI2}${-y}A`;
      else if (y > 0)
        ret += `${CSI2}${y}B`;
      return ret;
    },
    up: (count = 1) => `${CSI2}${count}A`,
    down: (count = 1) => `${CSI2}${count}B`,
    forward: (count = 1) => `${CSI2}${count}C`,
    backward: (count = 1) => `${CSI2}${count}D`,
    nextLine: (count = 1) => `${CSI2}E`.repeat(count),
    prevLine: (count = 1) => `${CSI2}F`.repeat(count),
    left: `${CSI2}G`,
    hide: `${CSI2}?25l`,
    show: `${CSI2}?25h`,
    save: `${ESC2}7`,
    restore: `${ESC2}8`
  };
  var scroll2 = {
    up: (count = 1) => `${CSI2}S`.repeat(count),
    down: (count = 1) => `${CSI2}T`.repeat(count)
  };
  var erase2 = {
    screen: `${CSI2}2J`,
    up: (count = 1) => `${CSI2}1J`.repeat(count),
    down: (count = 1) => `${CSI2}J`.repeat(count),
    line: `${CSI2}2K`,
    lineEnd: `${CSI2}K`,
    lineStart: `${CSI2}1K`,
    lines(count) {
      let clear = "";
      for (let i = 0;i < count; i++)
        clear += this.line + (i < count - 1 ? cursor2.up() : "");
      if (count)
        clear += cursor2.left;
      return clear;
    }
  };
  module.exports = { cursor: cursor2, scroll: scroll2, erase: erase2, beep: beep2 };
});
var require_clear = __commonJS((exports, module) => {
  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it)
          o = it;
        var i = 0;
        var F = function F() {
        };
        return { s: F, n: function n() {
          if (i >= o.length)
            return { done: true };
          return { done: false, value: o[i++] };
        }, e: function e(_e) {
          throw _e;
        }, f: F };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true, didErr = false, err2;
    return { s: function s() {
      it = it.call(o);
    }, n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    }, e: function e(_e2) {
      didErr = true;
      err2 = _e2;
    }, f: function f() {
      try {
        if (!normalCompletion && it.return != null)
          it.return();
      } finally {
        if (didErr)
          throw err2;
      }
    } };
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o)
      return;
    if (typeof o === "string")
      return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor)
      n = o.constructor.name;
    if (n === "Map" || n === "Set")
      return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i = 0, arr2 = new Array(len);i < len; i++)
      arr2[i] = arr[i];
    return arr2;
  }
  var strip = require_strip();
  var _require = require_src();
  var erase2 = _require.erase;
  var cursor2 = _require.cursor;
  var width = (str) => [...strip(str)].length;
  module.exports = function(prompt2, perLine) {
    if (!perLine)
      return erase2.line + cursor2.to(0);
    let rows = 0;
    const lines = prompt2.split(/\r?\n/);
    var _iterator = _createForOfIteratorHelper(lines), _step;
    try {
      for (_iterator.s();!(_step = _iterator.n()).done; ) {
        let line = _step.value;
        rows += 1 + Math.floor(Math.max(width(line) - 1, 0) / perLine);
      }
    } catch (err2) {
      _iterator.e(err2);
    } finally {
      _iterator.f();
    }
    return erase2.lines(rows);
  };
});
var require_figures = __commonJS((exports, module) => {
  var main = {
    arrowUp: "\u2191",
    arrowDown: "\u2193",
    arrowLeft: "\u2190",
    arrowRight: "\u2192",
    radioOn: "\u25C9",
    radioOff: "\u25EF",
    tick: "\u2714",
    cross: "\u2716",
    ellipsis: "\u2026",
    pointerSmall: "\u203A",
    line: "\u2500",
    pointer: "\u276F"
  };
  var win = {
    arrowUp: main.arrowUp,
    arrowDown: main.arrowDown,
    arrowLeft: main.arrowLeft,
    arrowRight: main.arrowRight,
    radioOn: "(*)",
    radioOff: "( )",
    tick: "\u221A",
    cross: "\xD7",
    ellipsis: "...",
    pointerSmall: "\xBB",
    line: "\u2500",
    pointer: ">"
  };
  var figures = process.platform === "win32" ? win : main;
  module.exports = figures;
});
var require_style = __commonJS((exports, module) => {
  var c2 = require_kleur();
  var figures = require_figures();
  var styles = Object.freeze({
    password: {
      scale: 1,
      render: (input) => "*".repeat(input.length)
    },
    emoji: {
      scale: 2,
      render: (input) => "\uD83D\uDE03".repeat(input.length)
    },
    invisible: {
      scale: 0,
      render: (input) => ""
    },
    default: {
      scale: 1,
      render: (input) => `${input}`
    }
  });
  var render = (type) => styles[type] || styles.default;
  var symbols = Object.freeze({
    aborted: c2.red(figures.cross),
    done: c2.green(figures.tick),
    exited: c2.yellow(figures.cross),
    default: c2.cyan("?")
  });
  var symbol2 = (done, aborted, exited) => aborted ? symbols.aborted : exited ? symbols.exited : done ? symbols.done : symbols.default;
  var delimiter2 = (completing) => c2.gray(completing ? figures.ellipsis : figures.pointerSmall);
  var item = (expandable, expanded) => c2.gray(expandable ? expanded ? figures.pointerSmall : "+" : figures.line);
  module.exports = {
    styles,
    render,
    symbols,
    symbol: symbol2,
    delimiter: delimiter2,
    item
  };
});
var require_lines = __commonJS((exports, module) => {
  var strip = require_strip();
  module.exports = function(msg, perLine) {
    let lines = String(strip(msg) || "").split(/\r?\n/);
    if (!perLine)
      return lines.length;
    return lines.map((l3) => Math.ceil(l3.length / perLine)).reduce((a, b2) => a + b2);
  };
});
var require_wrap = __commonJS((exports, module) => {
  module.exports = (msg, opts = {}) => {
    const tab = Number.isSafeInteger(parseInt(opts.margin)) ? new Array(parseInt(opts.margin)).fill(" ").join("") : opts.margin || "";
    const width = opts.width;
    return (msg || "").split(/\r?\n/g).map((line) => line.split(/\s+/g).reduce((arr, w2) => {
      if (w2.length + tab.length >= width || arr[arr.length - 1].length + w2.length + 1 < width)
        arr[arr.length - 1] += ` ${w2}`;
      else
        arr.push(`${tab}${w2}`);
      return arr;
    }, [tab]).join("\n")).join("\n");
  };
});
var require_entriesToDisplay = __commonJS((exports, module) => {
  module.exports = (cursor2, total, maxVisible) => {
    maxVisible = maxVisible || total;
    let startIndex = Math.min(total - maxVisible, cursor2 - Math.floor(maxVisible / 2));
    if (startIndex < 0)
      startIndex = 0;
    let endIndex = Math.min(startIndex + maxVisible, total);
    return {
      startIndex,
      endIndex
    };
  };
});
var require_util = __commonJS((exports, module) => {
  module.exports = {
    action: require_action(),
    clear: require_clear(),
    style: require_style(),
    strip: require_strip(),
    figures: require_figures(),
    lines: require_lines(),
    wrap: require_wrap(),
    entriesToDisplay: require_entriesToDisplay()
  };
});
var require_prompt = __commonJS((exports, module) => {
  var readline = import.meta.require("readline");
  var _require = require_util();
  var action = _require.action;
  var EventEmitter2 = import.meta.require("events");
  var _require2 = require_src();
  var beep2 = _require2.beep;
  var cursor2 = _require2.cursor;
  var color = require_kleur();

  class Prompt extends EventEmitter2 {
    constructor(opts = {}) {
      super();
      this.firstRender = true;
      this.in = opts.stdin || process.stdin;
      this.out = opts.stdout || process.stdout;
      this.onRender = (opts.onRender || (() => {
        return;
      })).bind(this);
      const rl = readline.createInterface({
        input: this.in,
        escapeCodeTimeout: 50
      });
      readline.emitKeypressEvents(this.in, rl);
      if (this.in.isTTY)
        this.in.setRawMode(true);
      const isSelect = ["SelectPrompt", "MultiselectPrompt"].indexOf(this.constructor.name) > -1;
      const keypress = (str, key) => {
        let a = action(key, isSelect);
        if (a === false) {
          this._ && this._(str, key);
        } else if (typeof this[a] === "function") {
          this[a](key);
        } else {
          this.bell();
        }
      };
      this.close = () => {
        this.out.write(cursor2.show);
        this.in.removeListener("keypress", keypress);
        if (this.in.isTTY)
          this.in.setRawMode(false);
        rl.close();
        this.emit(this.aborted ? "abort" : this.exited ? "exit" : "submit", this.value);
        this.closed = true;
      };
      this.in.on("keypress", keypress);
    }
    fire() {
      this.emit("state", {
        value: this.value,
        aborted: !!this.aborted,
        exited: !!this.exited
      });
    }
    bell() {
      this.out.write(beep2);
    }
    render() {
      this.onRender(color);
      if (this.firstRender)
        this.firstRender = false;
    }
  }
  module.exports = Prompt;
});
var require_text = __commonJS((exports, module) => {
  function asyncGeneratorStep(gen, resolve3, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve3(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve3, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "next", value);
        }
        function _throw(err2) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "throw", err2);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur();
  var Prompt = require_prompt();
  var _require = require_src();
  var erase2 = _require.erase;
  var cursor2 = _require.cursor;
  var _require2 = require_util();
  var style = _require2.style;
  var clear = _require2.clear;
  var lines = _require2.lines;
  var figures = _require2.figures;

  class TextPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.msg = opts.message;
      this.initial = opts.initial || ``;
      this.validator = opts.validate || (() => true);
      this.value = ``;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.clear = clear(``, this.out.columns);
      this.render();
    }
    set value(v2) {
      if (!v2 && this.initial) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(this.initial));
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(v2);
      }
      this._value = v2;
      this.fire();
    }
    get value() {
      return this._value;
    }
    reset() {
      this.value = ``;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.value = this.value || this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.red = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === `string`) {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        _this2.value = _this2.value || _this2.initial;
        _this2.cursorOffset = 0;
        _this2.cursor = _this2.rendered.length;
        yield _this2.validate();
        if (_this2.error) {
          _this2.red = true;
          _this2.fire();
          _this2.render();
          return;
        }
        _this2.done = true;
        _this2.aborted = false;
        _this2.fire();
        _this2.render();
        _this2.out.write("\n");
        _this2.close();
      })();
    }
    next() {
      if (!this.placeholder)
        return this.bell();
      this.value = this.initial;
      this.cursor = this.rendered.length;
      this.fire();
      this.render();
    }
    moveCursor(n) {
      if (this.placeholder)
        return;
      this.cursor = this.cursor + n;
      this.cursorOffset += n;
    }
    _(c2, key) {
      let s1 = this.value.slice(0, this.cursor);
      let s22 = this.value.slice(this.cursor);
      this.value = `${s1}${c2}${s22}`;
      this.red = false;
      this.cursor = this.placeholder ? 0 : s1.length + 1;
      this.render();
    }
    delete() {
      if (this.isCursorAtStart())
        return this.bell();
      let s1 = this.value.slice(0, this.cursor - 1);
      let s22 = this.value.slice(this.cursor);
      this.value = `${s1}${s22}`;
      this.red = false;
      if (this.isCursorAtStart()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
        this.moveCursor(-1);
      }
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      let s1 = this.value.slice(0, this.cursor);
      let s22 = this.value.slice(this.cursor + 1);
      this.value = `${s1}${s22}`;
      this.red = false;
      if (this.isCursorAtEnd()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
      }
      this.render();
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length;
      this.render();
    }
    left() {
      if (this.cursor <= 0 || this.placeholder)
        return this.bell();
      this.moveCursor(-1);
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      this.moveCursor(1);
      this.render();
    }
    isCursorAtStart() {
      return this.cursor === 0 || this.placeholder && this.cursor === 1;
    }
    isCursorAtEnd() {
      return this.cursor === this.rendered.length || this.placeholder && this.cursor === this.rendered.length + 1;
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor2.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.red ? color.red(this.rendered) : this.rendered].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l3, i) => a + `\n${i ? " " : figures.pointerSmall} ${color.red().italic(l3)}`, ``);
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText + cursor2.save + this.outputError + cursor2.restore + cursor2.move(this.cursorOffset, 0));
    }
  }
  module.exports = TextPrompt;
});
var require_select = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt();
  var _require = require_util();
  var style = _require.style;
  var clear = _require.clear;
  var figures = _require.figures;
  var wrap = _require.wrap;
  var entriesToDisplay = _require.entriesToDisplay;
  var _require2 = require_src();
  var cursor2 = _require2.cursor;

  class SelectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.hint = opts.hint || "- Use arrow-keys. Return to submit.";
      this.warn = opts.warn || "- This option is disabled";
      this.cursor = opts.initial || 0;
      this.choices = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = {
            title: ch,
            value: idx
          };
        return {
          title: ch && (ch.title || ch.value || ch),
          value: ch && (ch.value === undefined ? idx : ch.value),
          description: ch && ch.description,
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = (this.choices[this.cursor] || {}).value;
      this.clear = clear("", this.out.columns);
      this.render();
    }
    moveCursor(n) {
      this.cursor = n;
      this.value = this.choices[n].value;
      this.fire();
    }
    reset() {
      this.moveCursor(0);
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      if (!this.selection.disabled) {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      } else
        this.bell();
    }
    first() {
      this.moveCursor(0);
      this.render();
    }
    last() {
      this.moveCursor(this.choices.length - 1);
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.moveCursor(this.choices.length - 1);
      } else {
        this.moveCursor(this.cursor - 1);
      }
      this.render();
    }
    down() {
      if (this.cursor === this.choices.length - 1) {
        this.moveCursor(0);
      } else {
        this.moveCursor(this.cursor + 1);
      }
      this.render();
    }
    next() {
      this.moveCursor((this.cursor + 1) % this.choices.length);
      this.render();
    }
    _(c2, key) {
      if (c2 === " ")
        return this.submit();
    }
    get selection() {
      return this.choices[this.cursor];
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let _entriesToDisplay = entriesToDisplay(this.cursor, this.choices.length, this.optionsPerPage), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.done ? this.selection.title : this.selection.disabled ? color.yellow(this.warn) : color.gray(this.hint)].join(" ");
      if (!this.done) {
        this.outputText += "\n";
        for (let i = startIndex;i < endIndex; i++) {
          let title, prefix, desc = "", v2 = this.choices[i];
          if (i === startIndex && startIndex > 0) {
            prefix = figures.arrowUp;
          } else if (i === endIndex - 1 && endIndex < this.choices.length) {
            prefix = figures.arrowDown;
          } else {
            prefix = " ";
          }
          if (v2.disabled) {
            title = this.cursor === i ? color.gray().underline(v2.title) : color.strikethrough().gray(v2.title);
            prefix = (this.cursor === i ? color.bold().gray(figures.pointer) + " " : "  ") + prefix;
          } else {
            title = this.cursor === i ? color.cyan().underline(v2.title) : v2.title;
            prefix = (this.cursor === i ? color.cyan(figures.pointer) + " " : "  ") + prefix;
            if (v2.description && this.cursor === i) {
              desc = ` - ${v2.description}`;
              if (prefix.length + title.length + desc.length >= this.out.columns || v2.description.split(/\r?\n/).length > 1) {
                desc = "\n" + wrap(v2.description, {
                  margin: 3,
                  width: this.out.columns
                });
              }
            }
          }
          this.outputText += `${prefix} ${title}${color.gray(desc)}\n`;
        }
      }
      this.out.write(this.outputText);
    }
  }
  module.exports = SelectPrompt;
});
var require_toggle = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt();
  var _require = require_util();
  var style = _require.style;
  var clear = _require.clear;
  var _require2 = require_src();
  var cursor2 = _require2.cursor;
  var erase2 = _require2.erase;

  class TogglePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = !!opts.initial;
      this.active = opts.active || "on";
      this.inactive = opts.inactive || "off";
      this.initialValue = this.value;
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    deactivate() {
      if (this.value === false)
        return this.bell();
      this.value = false;
      this.render();
    }
    activate() {
      if (this.value === true)
        return this.bell();
      this.value = true;
      this.render();
    }
    delete() {
      this.deactivate();
    }
    left() {
      this.deactivate();
    }
    right() {
      this.activate();
    }
    down() {
      this.deactivate();
    }
    up() {
      this.activate();
    }
    next() {
      this.value = !this.value;
      this.fire();
      this.render();
    }
    _(c2, key) {
      if (c2 === " ") {
        this.value = !this.value;
      } else if (c2 === "1") {
        this.value = true;
      } else if (c2 === "0") {
        this.value = false;
      } else
        return this.bell();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.value ? this.inactive : color.cyan().underline(this.inactive), color.gray("/"), this.value ? color.cyan().underline(this.active) : this.active].join(" ");
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = TogglePrompt;
});
var require_datepart = __commonJS((exports, module) => {

  class DatePart {
    constructor({
      token,
      date,
      parts,
      locales: locales2
    }) {
      this.token = token;
      this.date = date || new Date;
      this.parts = parts || [this];
      this.locales = locales2 || {};
    }
    up() {
    }
    down() {
    }
    next() {
      const currentIdx = this.parts.indexOf(this);
      return this.parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    setTo(val2) {
    }
    prev() {
      let parts = [].concat(this.parts).reverse();
      const currentIdx = parts.indexOf(this);
      return parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    toString() {
      return String(this.date);
    }
  }
  module.exports = DatePart;
});
var require_meridiem = __commonJS((exports, module) => {
  var DatePart = require_datepart();

  class Meridiem extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours((this.date.getHours() + 12) % 24);
    }
    down() {
      this.up();
    }
    toString() {
      let meridiem = this.date.getHours() > 12 ? "pm" : "am";
      return /\A/.test(this.token) ? meridiem.toUpperCase() : meridiem;
    }
  }
  module.exports = Meridiem;
});
var require_day = __commonJS((exports, module) => {
  var DatePart = require_datepart();
  var pos = (n) => {
    n = n % 10;
    return n === 1 ? "st" : n === 2 ? "nd" : n === 3 ? "rd" : "th";
  };

  class Day extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setDate(this.date.getDate() + 1);
    }
    down() {
      this.date.setDate(this.date.getDate() - 1);
    }
    setTo(val2) {
      this.date.setDate(parseInt(val2.substr(-2)));
    }
    toString() {
      let date = this.date.getDate();
      let day = this.date.getDay();
      return this.token === "DD" ? String(date).padStart(2, "0") : this.token === "Do" ? date + pos(date) : this.token === "d" ? day + 1 : this.token === "ddd" ? this.locales.weekdaysShort[day] : this.token === "dddd" ? this.locales.weekdays[day] : date;
    }
  }
  module.exports = Day;
});
var require_hours = __commonJS((exports, module) => {
  var DatePart = require_datepart();

  class Hours extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours(this.date.getHours() + 1);
    }
    down() {
      this.date.setHours(this.date.getHours() - 1);
    }
    setTo(val2) {
      this.date.setHours(parseInt(val2.substr(-2)));
    }
    toString() {
      let hours = this.date.getHours();
      if (/h/.test(this.token))
        hours = hours % 12 || 12;
      return this.token.length > 1 ? String(hours).padStart(2, "0") : hours;
    }
  }
  module.exports = Hours;
});
var require_milliseconds = __commonJS((exports, module) => {
  var DatePart = require_datepart();

  class Milliseconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMilliseconds(this.date.getMilliseconds() + 1);
    }
    down() {
      this.date.setMilliseconds(this.date.getMilliseconds() - 1);
    }
    setTo(val2) {
      this.date.setMilliseconds(parseInt(val2.substr(-this.token.length)));
    }
    toString() {
      return String(this.date.getMilliseconds()).padStart(4, "0").substr(0, this.token.length);
    }
  }
  module.exports = Milliseconds;
});
var require_minutes = __commonJS((exports, module) => {
  var DatePart = require_datepart();

  class Minutes extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMinutes(this.date.getMinutes() + 1);
    }
    down() {
      this.date.setMinutes(this.date.getMinutes() - 1);
    }
    setTo(val2) {
      this.date.setMinutes(parseInt(val2.substr(-2)));
    }
    toString() {
      let m2 = this.date.getMinutes();
      return this.token.length > 1 ? String(m2).padStart(2, "0") : m2;
    }
  }
  module.exports = Minutes;
});
var require_month = __commonJS((exports, module) => {
  var DatePart = require_datepart();

  class Month extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMonth(this.date.getMonth() + 1);
    }
    down() {
      this.date.setMonth(this.date.getMonth() - 1);
    }
    setTo(val2) {
      val2 = parseInt(val2.substr(-2)) - 1;
      this.date.setMonth(val2 < 0 ? 0 : val2);
    }
    toString() {
      let month = this.date.getMonth();
      let tl = this.token.length;
      return tl === 2 ? String(month + 1).padStart(2, "0") : tl === 3 ? this.locales.monthsShort[month] : tl === 4 ? this.locales.months[month] : String(month + 1);
    }
  }
  module.exports = Month;
});
var require_seconds = __commonJS((exports, module) => {
  var DatePart = require_datepart();

  class Seconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setSeconds(this.date.getSeconds() + 1);
    }
    down() {
      this.date.setSeconds(this.date.getSeconds() - 1);
    }
    setTo(val2) {
      this.date.setSeconds(parseInt(val2.substr(-2)));
    }
    toString() {
      let s3 = this.date.getSeconds();
      return this.token.length > 1 ? String(s3).padStart(2, "0") : s3;
    }
  }
  module.exports = Seconds;
});
var require_year = __commonJS((exports, module) => {
  var DatePart = require_datepart();

  class Year extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setFullYear(this.date.getFullYear() + 1);
    }
    down() {
      this.date.setFullYear(this.date.getFullYear() - 1);
    }
    setTo(val2) {
      this.date.setFullYear(val2.substr(-4));
    }
    toString() {
      let year = String(this.date.getFullYear()).padStart(4, "0");
      return this.token.length === 2 ? year.substr(-2) : year;
    }
  }
  module.exports = Year;
});
var require_dateparts = __commonJS((exports, module) => {
  module.exports = {
    DatePart: require_datepart(),
    Meridiem: require_meridiem(),
    Day: require_day(),
    Hours: require_hours(),
    Milliseconds: require_milliseconds(),
    Minutes: require_minutes(),
    Month: require_month(),
    Seconds: require_seconds(),
    Year: require_year()
  };
});
var require_date = __commonJS((exports, module) => {
  function asyncGeneratorStep(gen, resolve3, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve3(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve3, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "next", value);
        }
        function _throw(err2) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "throw", err2);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur();
  var Prompt = require_prompt();
  var _require = require_util();
  var style = _require.style;
  var clear = _require.clear;
  var figures = _require.figures;
  var _require2 = require_src();
  var erase2 = _require2.erase;
  var cursor2 = _require2.cursor;
  var _require3 = require_dateparts();
  var DatePart = _require3.DatePart;
  var Meridiem = _require3.Meridiem;
  var Day = _require3.Day;
  var Hours = _require3.Hours;
  var Milliseconds = _require3.Milliseconds;
  var Minutes = _require3.Minutes;
  var Month = _require3.Month;
  var Seconds = _require3.Seconds;
  var Year = _require3.Year;
  var regex2 = /\\(.)|"((?:\\["\\]|[^"])+)"|(D[Do]?|d{3,4}|d)|(M{1,4})|(YY(?:YY)?)|([aA])|([Hh]{1,2})|(m{1,2})|(s{1,2})|(S{1,4})|./g;
  var regexGroups = {
    1: ({
      token
    }) => token.replace(/\\(.)/g, "$1"),
    2: (opts) => new Day(opts),
    3: (opts) => new Month(opts),
    4: (opts) => new Year(opts),
    5: (opts) => new Meridiem(opts),
    6: (opts) => new Hours(opts),
    7: (opts) => new Minutes(opts),
    8: (opts) => new Seconds(opts),
    9: (opts) => new Milliseconds(opts)
  };
  var dfltLocales = {
    months: "January,February,March,April,May,June,July,August,September,October,November,December".split(","),
    monthsShort: "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),
    weekdays: "Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),
    weekdaysShort: "Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(",")
  };

  class DatePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = 0;
      this.typed = "";
      this.locales = Object.assign(dfltLocales, opts.locales);
      this._date = opts.initial || new Date;
      this.errorMsg = opts.error || "Please Enter A Valid Value";
      this.validator = opts.validate || (() => true);
      this.mask = opts.mask || "YYYY-MM-DD HH:mm:ss";
      this.clear = clear("", this.out.columns);
      this.render();
    }
    get value() {
      return this.date;
    }
    get date() {
      return this._date;
    }
    set date(date) {
      if (date)
        this._date.setTime(date.getTime());
    }
    set mask(mask) {
      let result2;
      this.parts = [];
      while (result2 = regex2.exec(mask)) {
        let match = result2.shift();
        let idx = result2.findIndex((gr) => gr != null);
        this.parts.push(idx in regexGroups ? regexGroups[idx]({
          token: result2[idx] || match,
          date: this.date,
          parts: this.parts,
          locales: this.locales
        }) : result2[idx] || match);
      }
      let parts = this.parts.reduce((arr, i) => {
        if (typeof i === "string" && typeof arr[arr.length - 1] === "string")
          arr[arr.length - 1] += i;
        else
          arr.push(i);
        return arr;
      }, []);
      this.parts.splice(0);
      this.parts.push(...parts);
      this.reset();
    }
    moveCursor(n) {
      this.typed = "";
      this.cursor = n;
      this.fire();
    }
    reset() {
      this.moveCursor(this.parts.findIndex((p3) => p3 instanceof DatePart));
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === "string") {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        yield _this2.validate();
        if (_this2.error) {
          _this2.color = "red";
          _this2.fire();
          _this2.render();
          return;
        }
        _this2.done = true;
        _this2.aborted = false;
        _this2.fire();
        _this2.render();
        _this2.out.write("\n");
        _this2.close();
      })();
    }
    up() {
      this.typed = "";
      this.parts[this.cursor].up();
      this.render();
    }
    down() {
      this.typed = "";
      this.parts[this.cursor].down();
      this.render();
    }
    left() {
      let prev = this.parts[this.cursor].prev();
      if (prev == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(prev));
      this.render();
    }
    right() {
      let next = this.parts[this.cursor].next();
      if (next == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(next));
      this.render();
    }
    next() {
      let next = this.parts[this.cursor].next();
      this.moveCursor(next ? this.parts.indexOf(next) : this.parts.findIndex((part) => part instanceof DatePart));
      this.render();
    }
    _(c2) {
      if (/\d/.test(c2)) {
        this.typed += c2;
        this.parts[this.cursor].setTo(this.typed);
        this.render();
      }
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.parts.reduce((arr, p3, idx) => arr.concat(idx === this.cursor && !this.done ? color.cyan().underline(p3.toString()) : p3), []).join("")].join(" ");
      if (this.error) {
        this.outputText += this.errorMsg.split("\n").reduce((a, l3, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l3)}`, ``);
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = DatePrompt;
});
var require_number = __commonJS((exports, module) => {
  function asyncGeneratorStep(gen, resolve3, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve3(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve3, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "next", value);
        }
        function _throw(err2) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "throw", err2);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur();
  var Prompt = require_prompt();
  var _require = require_src();
  var cursor2 = _require.cursor;
  var erase2 = _require.erase;
  var _require2 = require_util();
  var style = _require2.style;
  var figures = _require2.figures;
  var clear = _require2.clear;
  var lines = _require2.lines;
  var isNumber = /[0-9]/;
  var isDef = (any) => any !== undefined;
  var round = (number, precision) => {
    let factor = Math.pow(10, precision);
    return Math.round(number * factor) / factor;
  };

  class NumberPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.msg = opts.message;
      this.initial = isDef(opts.initial) ? opts.initial : "";
      this.float = !!opts.float;
      this.round = opts.round || 2;
      this.inc = opts.increment || 1;
      this.min = isDef(opts.min) ? opts.min : -Infinity;
      this.max = isDef(opts.max) ? opts.max : Infinity;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.validator = opts.validate || (() => true);
      this.color = `cyan`;
      this.value = ``;
      this.typed = ``;
      this.lastHit = 0;
      this.render();
    }
    set value(v2) {
      if (!v2 && v2 !== 0) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(`${this.initial}`));
        this._value = ``;
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(`${round(v2, this.round)}`);
        this._value = round(v2, this.round);
      }
      this.fire();
    }
    get value() {
      return this._value;
    }
    parse(x2) {
      return this.float ? parseFloat(x2) : parseInt(x2);
    }
    valid(c2) {
      return c2 === `-` || c2 === `.` && this.float || isNumber.test(c2);
    }
    reset() {
      this.typed = ``;
      this.value = ``;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      let x2 = this.value;
      this.value = x2 !== `` ? x2 : this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === `string`) {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        yield _this2.validate();
        if (_this2.error) {
          _this2.color = `red`;
          _this2.fire();
          _this2.render();
          return;
        }
        let x2 = _this2.value;
        _this2.value = x2 !== `` ? x2 : _this2.initial;
        _this2.done = true;
        _this2.aborted = false;
        _this2.error = false;
        _this2.fire();
        _this2.render();
        _this2.out.write(`\n`);
        _this2.close();
      })();
    }
    up() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min - this.inc;
      }
      if (this.value >= this.max)
        return this.bell();
      this.value += this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    down() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min + this.inc;
      }
      if (this.value <= this.min)
        return this.bell();
      this.value -= this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    delete() {
      let val2 = this.value.toString();
      if (val2.length === 0)
        return this.bell();
      this.value = this.parse(val2 = val2.slice(0, -1)) || ``;
      if (this.value !== "" && this.value < this.min) {
        this.value = this.min;
      }
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    next() {
      this.value = this.initial;
      this.fire();
      this.render();
    }
    _(c2, key) {
      if (!this.valid(c2))
        return this.bell();
      const now = Date.now();
      if (now - this.lastHit > 1000)
        this.typed = ``;
      this.typed += c2;
      this.lastHit = now;
      this.color = `cyan`;
      if (c2 === `.`)
        return this.fire();
      this.value = Math.min(this.parse(this.typed), this.max);
      if (this.value > this.max)
        this.value = this.max;
      if (this.value < this.min)
        this.value = this.min;
      this.fire();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor2.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), !this.done || !this.done && !this.placeholder ? color[this.color]().underline(this.rendered) : this.rendered].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l3, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l3)}`, ``);
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText + cursor2.save + this.outputError + cursor2.restore);
    }
  }
  module.exports = NumberPrompt;
});
var require_multiselect = __commonJS((exports, module) => {
  var color = require_kleur();
  var _require = require_src();
  var cursor2 = _require.cursor;
  var Prompt = require_prompt();
  var _require2 = require_util();
  var clear = _require2.clear;
  var figures = _require2.figures;
  var style = _require2.style;
  var wrap = _require2.wrap;
  var entriesToDisplay = _require2.entriesToDisplay;

  class MultiselectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = opts.cursor || 0;
      this.scrollIndex = opts.cursor || 0;
      this.hint = opts.hint || "";
      this.warn = opts.warn || "- This option is disabled -";
      this.minSelected = opts.min;
      this.showMinError = false;
      this.maxChoices = opts.max;
      this.instructions = opts.instructions;
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = {
            title: ch,
            value: idx
          };
        return {
          title: ch && (ch.title || ch.value || ch),
          description: ch && ch.description,
          value: ch && (ch.value === undefined ? idx : ch.value),
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.clear = clear("", this.out.columns);
      if (!opts.overrideRender) {
        this.render();
      }
    }
    reset() {
      this.value.map((v2) => !v2.selected);
      this.cursor = 0;
      this.fire();
      this.render();
    }
    selected() {
      return this.value.filter((v2) => v2.selected);
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      const selected = this.value.filter((e) => e.selected);
      if (this.minSelected && selected.length < this.minSelected) {
        this.showMinError = true;
        this.render();
      } else {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.value.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.value.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.value.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.value[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.value[this.cursor].selected = true;
      this.render();
    }
    handleSpaceToggle() {
      const v2 = this.value[this.cursor];
      if (v2.selected) {
        v2.selected = false;
        this.render();
      } else if (v2.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v2.selected = true;
        this.render();
      }
    }
    toggleAll() {
      if (this.maxChoices !== undefined || this.value[this.cursor].disabled) {
        return this.bell();
      }
      const newSelected = !this.value[this.cursor].selected;
      this.value.filter((v2) => !v2.disabled).forEach((v2) => v2.selected = newSelected);
      this.render();
    }
    _(c2, key) {
      if (c2 === " ") {
        this.handleSpaceToggle();
      } else if (c2 === "a") {
        this.toggleAll();
      } else {
        return this.bell();
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return "\nInstructions:\n" + `    ${figures.arrowUp}/${figures.arrowDown}: Highlight option\n` + `    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection\n` + (this.maxChoices === undefined ? `    a: Toggle all\n` : "") + `    enter/return: Complete answer`;
      }
      return "";
    }
    renderOption(cursor3, v2, i, arrowIndicator) {
      const prefix = (v2.selected ? color.green(figures.radioOn) : figures.radioOff) + " " + arrowIndicator + " ";
      let title, desc;
      if (v2.disabled) {
        title = cursor3 === i ? color.gray().underline(v2.title) : color.strikethrough().gray(v2.title);
      } else {
        title = cursor3 === i ? color.cyan().underline(v2.title) : v2.title;
        if (cursor3 === i && v2.description) {
          desc = ` - ${v2.description}`;
          if (prefix.length + title.length + desc.length >= this.out.columns || v2.description.split(/\r?\n/).length > 1) {
            desc = "\n" + wrap(v2.description, {
              margin: prefix.length,
              width: this.out.columns
            });
          }
        }
      }
      return prefix + title + color.gray(desc || "");
    }
    paginateOptions(options2) {
      if (options2.length === 0) {
        return color.red("No matches for this query.");
      }
      let _entriesToDisplay = entriesToDisplay(this.cursor, options2.length, this.optionsPerPage), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      let prefix, styledOptions = [];
      for (let i = startIndex;i < endIndex; i++) {
        if (i === startIndex && startIndex > 0) {
          prefix = figures.arrowUp;
        } else if (i === endIndex - 1 && endIndex < options2.length) {
          prefix = figures.arrowDown;
        } else {
          prefix = " ";
        }
        styledOptions.push(this.renderOption(this.cursor, options2[i], i, prefix));
      }
      return "\n" + styledOptions.join("\n");
    }
    renderOptions(options2) {
      if (!this.done) {
        return this.paginateOptions(options2);
      }
      return "";
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v2) => v2.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions()];
      if (this.value[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      super.render();
      let prompt2 = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.renderDoneOrInstructions()].join(" ");
      if (this.showMinError) {
        prompt2 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt2 += this.renderOptions(this.value);
      this.out.write(this.clear + prompt2);
      this.clear = clear(prompt2, this.out.columns);
    }
  }
  module.exports = MultiselectPrompt;
});
var require_autocomplete = __commonJS((exports, module) => {
  function asyncGeneratorStep(gen, resolve3, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve3(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve3, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "next", value);
        }
        function _throw(err2) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "throw", err2);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur();
  var Prompt = require_prompt();
  var _require = require_src();
  var erase2 = _require.erase;
  var cursor2 = _require.cursor;
  var _require2 = require_util();
  var style = _require2.style;
  var clear = _require2.clear;
  var figures = _require2.figures;
  var wrap = _require2.wrap;
  var entriesToDisplay = _require2.entriesToDisplay;
  var getVal = (arr, i) => arr[i] && (arr[i].value || arr[i].title || arr[i]);
  var getTitle = (arr, i) => arr[i] && (arr[i].title || arr[i].value || arr[i]);
  var getIndex = (arr, valOrTitle) => {
    const index = arr.findIndex((el) => el.value === valOrTitle || el.title === valOrTitle);
    return index > -1 ? index : undefined;
  };

  class AutocompletePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.suggest = opts.suggest;
      this.choices = opts.choices;
      this.initial = typeof opts.initial === "number" ? opts.initial : getIndex(opts.choices, opts.initial);
      this.select = this.initial || opts.cursor || 0;
      this.i18n = {
        noMatches: opts.noMatches || "no matches found"
      };
      this.fallback = opts.fallback || this.initial;
      this.clearFirst = opts.clearFirst || false;
      this.suggestions = [];
      this.input = "";
      this.limit = opts.limit || 10;
      this.cursor = 0;
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.render = this.render.bind(this);
      this.complete = this.complete.bind(this);
      this.clear = clear("", this.out.columns);
      this.complete(this.render);
      this.render();
    }
    set fallback(fb) {
      this._fb = Number.isSafeInteger(parseInt(fb)) ? parseInt(fb) : fb;
    }
    get fallback() {
      let choice;
      if (typeof this._fb === "number")
        choice = this.choices[this._fb];
      else if (typeof this._fb === "string")
        choice = {
          title: this._fb
        };
      return choice || this._fb || {
        title: this.i18n.noMatches
      };
    }
    moveSelect(i) {
      this.select = i;
      if (this.suggestions.length > 0)
        this.value = getVal(this.suggestions, i);
      else
        this.value = this.fallback.value;
      this.fire();
    }
    complete(cb) {
      var _this = this;
      return _asyncToGenerator(function* () {
        const p3 = _this.completing = _this.suggest(_this.input, _this.choices);
        const suggestions = yield p3;
        if (_this.completing !== p3)
          return;
        _this.suggestions = suggestions.map((s3, i, arr) => ({
          title: getTitle(arr, i),
          value: getVal(arr, i),
          description: s3.description
        }));
        _this.completing = false;
        const l3 = Math.max(suggestions.length - 1, 0);
        _this.moveSelect(Math.min(l3, _this.select));
        cb && cb();
      })();
    }
    reset() {
      this.input = "";
      this.complete(() => {
        this.moveSelect(this.initial !== undefined ? this.initial : 0);
        this.render();
      });
      this.render();
    }
    exit() {
      if (this.clearFirst && this.input.length > 0) {
        this.reset();
      } else {
        this.done = this.exited = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    abort() {
      this.done = this.aborted = true;
      this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c2, key) {
      let s1 = this.input.slice(0, this.cursor);
      let s22 = this.input.slice(this.cursor);
      this.input = `${s1}${c2}${s22}`;
      this.cursor = s1.length + 1;
      this.complete(this.render);
      this.render();
    }
    delete() {
      if (this.cursor === 0)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor - 1);
      let s22 = this.input.slice(this.cursor);
      this.input = `${s1}${s22}`;
      this.complete(this.render);
      this.cursor = this.cursor - 1;
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor);
      let s22 = this.input.slice(this.cursor + 1);
      this.input = `${s1}${s22}`;
      this.complete(this.render);
      this.render();
    }
    first() {
      this.moveSelect(0);
      this.render();
    }
    last() {
      this.moveSelect(this.suggestions.length - 1);
      this.render();
    }
    up() {
      if (this.select === 0) {
        this.moveSelect(this.suggestions.length - 1);
      } else {
        this.moveSelect(this.select - 1);
      }
      this.render();
    }
    down() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else {
        this.moveSelect(this.select + 1);
      }
      this.render();
    }
    next() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else
        this.moveSelect(this.select + 1);
      this.render();
    }
    nextPage() {
      this.moveSelect(Math.min(this.select + this.limit, this.suggestions.length - 1));
      this.render();
    }
    prevPage() {
      this.moveSelect(Math.max(this.select - this.limit, 0));
      this.render();
    }
    left() {
      if (this.cursor <= 0)
        return this.bell();
      this.cursor = this.cursor - 1;
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      this.cursor = this.cursor + 1;
      this.render();
    }
    renderOption(v2, hovered, isStart, isEnd) {
      let desc;
      let prefix = isStart ? figures.arrowUp : isEnd ? figures.arrowDown : " ";
      let title = hovered ? color.cyan().underline(v2.title) : v2.title;
      prefix = (hovered ? color.cyan(figures.pointer) + " " : "  ") + prefix;
      if (v2.description) {
        desc = ` - ${v2.description}`;
        if (prefix.length + title.length + desc.length >= this.out.columns || v2.description.split(/\r?\n/).length > 1) {
          desc = "\n" + wrap(v2.description, {
            margin: 3,
            width: this.out.columns
          });
        }
      }
      return prefix + " " + title + color.gray(desc || "");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let _entriesToDisplay = entriesToDisplay(this.select, this.choices.length, this.limit), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      this.outputText = [style.symbol(this.done, this.aborted, this.exited), color.bold(this.msg), style.delimiter(this.completing), this.done && this.suggestions[this.select] ? this.suggestions[this.select].title : this.rendered = this.transform.render(this.input)].join(" ");
      if (!this.done) {
        const suggestions = this.suggestions.slice(startIndex, endIndex).map((item, i) => this.renderOption(item, this.select === i + startIndex, i === 0 && startIndex > 0, i + startIndex === endIndex - 1 && endIndex < this.choices.length)).join("\n");
        this.outputText += `\n` + (suggestions || color.gray(this.fallback.title));
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = AutocompletePrompt;
});
var require_autocompleteMultiselect = __commonJS((exports, module) => {
  var color = require_kleur();
  var _require = require_src();
  var cursor2 = _require.cursor;
  var MultiselectPrompt = require_multiselect();
  var _require2 = require_util();
  var clear = _require2.clear;
  var style = _require2.style;
  var figures = _require2.figures;

  class AutocompleteMultiselectPrompt extends MultiselectPrompt {
    constructor(opts = {}) {
      opts.overrideRender = true;
      super(opts);
      this.inputValue = "";
      this.clear = clear("", this.out.columns);
      this.filteredOptions = this.value;
      this.render();
    }
    last() {
      this.cursor = this.filteredOptions.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.filteredOptions.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.filteredOptions.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.filteredOptions.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.filteredOptions[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.filteredOptions[this.cursor].selected = true;
      this.render();
    }
    delete() {
      if (this.inputValue.length) {
        this.inputValue = this.inputValue.substr(0, this.inputValue.length - 1);
        this.updateFilteredOptions();
      }
    }
    updateFilteredOptions() {
      const currentHighlight = this.filteredOptions[this.cursor];
      this.filteredOptions = this.value.filter((v2) => {
        if (this.inputValue) {
          if (typeof v2.title === "string") {
            if (v2.title.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          if (typeof v2.value === "string") {
            if (v2.value.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          return false;
        }
        return true;
      });
      const newHighlightIndex = this.filteredOptions.findIndex((v2) => v2 === currentHighlight);
      this.cursor = newHighlightIndex < 0 ? 0 : newHighlightIndex;
      this.render();
    }
    handleSpaceToggle() {
      const v2 = this.filteredOptions[this.cursor];
      if (v2.selected) {
        v2.selected = false;
        this.render();
      } else if (v2.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v2.selected = true;
        this.render();
      }
    }
    handleInputChange(c2) {
      this.inputValue = this.inputValue + c2;
      this.updateFilteredOptions();
    }
    _(c2, key) {
      if (c2 === " ") {
        this.handleSpaceToggle();
      } else {
        this.handleInputChange(c2);
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `
Instructions:
    ${figures.arrowUp}/${figures.arrowDown}: Highlight option
    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection
    [a,b,c]/delete: Filter choices
    enter/return: Complete answer
`;
      }
      return "";
    }
    renderCurrentInput() {
      return `
Filtered results for: ${this.inputValue ? this.inputValue : color.gray("Enter something to filter")}\n`;
    }
    renderOption(cursor3, v2, i) {
      let title;
      if (v2.disabled)
        title = cursor3 === i ? color.gray().underline(v2.title) : color.strikethrough().gray(v2.title);
      else
        title = cursor3 === i ? color.cyan().underline(v2.title) : v2.title;
      return (v2.selected ? color.green(figures.radioOn) : figures.radioOff) + "  " + title;
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v2) => v2.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions(), this.renderCurrentInput()];
      if (this.filteredOptions.length && this.filteredOptions[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      super.render();
      let prompt2 = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.renderDoneOrInstructions()].join(" ");
      if (this.showMinError) {
        prompt2 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt2 += this.renderOptions(this.filteredOptions);
      this.out.write(this.clear + prompt2);
      this.clear = clear(prompt2, this.out.columns);
    }
  }
  module.exports = AutocompleteMultiselectPrompt;
});
var require_confirm = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt();
  var _require = require_util();
  var style = _require.style;
  var clear = _require.clear;
  var _require2 = require_src();
  var erase2 = _require2.erase;
  var cursor2 = _require2.cursor;

  class ConfirmPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = opts.initial;
      this.initialValue = !!opts.initial;
      this.yesMsg = opts.yes || "yes";
      this.yesOption = opts.yesOption || "(Y/n)";
      this.noMsg = opts.no || "no";
      this.noOption = opts.noOption || "(y/N)";
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.value = this.value || false;
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c2, key) {
      if (c2.toLowerCase() === "y") {
        this.value = true;
        return this.submit();
      }
      if (c2.toLowerCase() === "n") {
        this.value = false;
        return this.submit();
      }
      return this.bell();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.done ? this.value ? this.yesMsg : this.noMsg : color.gray(this.initialValue ? this.yesOption : this.noOption)].join(" ");
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = ConfirmPrompt;
});
var require_elements = __commonJS((exports, module) => {
  module.exports = {
    TextPrompt: require_text(),
    SelectPrompt: require_select(),
    TogglePrompt: require_toggle(),
    DatePrompt: require_date(),
    NumberPrompt: require_number(),
    MultiselectPrompt: require_multiselect(),
    AutocompletePrompt: require_autocomplete(),
    AutocompleteMultiselectPrompt: require_autocompleteMultiselect(),
    ConfirmPrompt: require_confirm()
  };
});
var require_prompts = __commonJS((exports) => {
  var $3 = exports;
  var el = require_elements();
  var noop = (v2) => v2;
  function toPrompt(type, args, opts = {}) {
    return new Promise((res, rej) => {
      const p3 = new el[type](args);
      const onAbort = opts.onAbort || noop;
      const onSubmit = opts.onSubmit || noop;
      const onExit = opts.onExit || noop;
      p3.on("state", args.onState || noop);
      p3.on("submit", (x2) => res(onSubmit(x2)));
      p3.on("exit", (x2) => res(onExit(x2)));
      p3.on("abort", (x2) => rej(onAbort(x2)));
    });
  }
  $3.text = (args) => toPrompt("TextPrompt", args);
  $3.password = (args) => {
    args.style = "password";
    return $3.text(args);
  };
  $3.invisible = (args) => {
    args.style = "invisible";
    return $3.text(args);
  };
  $3.number = (args) => toPrompt("NumberPrompt", args);
  $3.date = (args) => toPrompt("DatePrompt", args);
  $3.confirm = (args) => toPrompt("ConfirmPrompt", args);
  $3.list = (args) => {
    const sep3 = args.separator || ",";
    return toPrompt("TextPrompt", args, {
      onSubmit: (str) => str.split(sep3).map((s3) => s3.trim())
    });
  };
  $3.toggle = (args) => toPrompt("TogglePrompt", args);
  $3.select = (args) => toPrompt("SelectPrompt", args);
  $3.multiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("MultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  $3.autocompleteMultiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("AutocompleteMultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  var byTitle = (input, choices) => Promise.resolve(choices.filter((item) => item.title.slice(0, input.length).toLowerCase() === input.toLowerCase()));
  $3.autocomplete = (args) => {
    args.suggest = args.suggest || byTitle;
    args.choices = [].concat(args.choices || []);
    return toPrompt("AutocompletePrompt", args);
  };
});
var require_dist = __commonJS((exports, module) => {
  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) {
        symbols = symbols.filter(function(sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }
      keys.push.apply(keys, symbols);
    }
    return keys;
  }
  function _objectSpread(target) {
    for (var i = 1;i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      if (i % 2) {
        ownKeys(Object(source), true).forEach(function(key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function(key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }
    return target;
  }
  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }
    return obj;
  }
  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it)
          o = it;
        var i = 0;
        var F = function F() {
        };
        return { s: F, n: function n() {
          if (i >= o.length)
            return { done: true };
          return { done: false, value: o[i++] };
        }, e: function e(_e) {
          throw _e;
        }, f: F };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true, didErr = false, err2;
    return { s: function s() {
      it = it.call(o);
    }, n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    }, e: function e(_e2) {
      didErr = true;
      err2 = _e2;
    }, f: function f() {
      try {
        if (!normalCompletion && it.return != null)
          it.return();
      } finally {
        if (didErr)
          throw err2;
      }
    } };
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o)
      return;
    if (typeof o === "string")
      return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor)
      n = o.constructor.name;
    if (n === "Map" || n === "Set")
      return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i = 0, arr2 = new Array(len);i < len; i++)
      arr2[i] = arr[i];
    return arr2;
  }
  function asyncGeneratorStep(gen, resolve3, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve3(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve3, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "next", value);
        }
        function _throw(err2) {
          asyncGeneratorStep(gen, resolve3, reject, _next, _throw, "throw", err2);
        }
        _next(undefined);
      });
    };
  }
  var prompts = require_prompts();
  var passOn = ["suggest", "format", "onState", "validate", "onRender", "type"];
  var noop = () => {
  };
  function prompt2() {
    return _prompt.apply(this, arguments);
  }
  function _prompt() {
    _prompt = _asyncToGenerator(function* (questions = [], {
      onSubmit = noop,
      onCancel = noop
    } = {}) {
      const answers = {};
      const override2 = prompt2._override || {};
      questions = [].concat(questions);
      let answer, question, quit, name, type, lastPrompt;
      const getFormattedAnswer = /* @__PURE__ */ function() {
        var _ref = _asyncToGenerator(function* (question2, answer2, skipValidation = false) {
          if (!skipValidation && question2.validate && question2.validate(answer2) !== true) {
            return;
          }
          return question2.format ? yield question2.format(answer2, answers) : answer2;
        });
        return function getFormattedAnswer(_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }();
      var _iterator = _createForOfIteratorHelper(questions), _step;
      try {
        for (_iterator.s();!(_step = _iterator.n()).done; ) {
          question = _step.value;
          var _question = question;
          name = _question.name;
          type = _question.type;
          if (typeof type === "function") {
            type = yield type(answer, _objectSpread({}, answers), question);
            question["type"] = type;
          }
          if (!type)
            continue;
          for (let key in question) {
            if (passOn.includes(key))
              continue;
            let value = question[key];
            question[key] = typeof value === "function" ? yield value(answer, _objectSpread({}, answers), lastPrompt) : value;
          }
          lastPrompt = question;
          if (typeof question.message !== "string") {
            throw new Error("prompt message is required");
          }
          var _question2 = question;
          name = _question2.name;
          type = _question2.type;
          if (prompts[type] === undefined) {
            throw new Error(`prompt type (${type}) is not defined`);
          }
          if (override2[question.name] !== undefined) {
            answer = yield getFormattedAnswer(question, override2[question.name]);
            if (answer !== undefined) {
              answers[name] = answer;
              continue;
            }
          }
          try {
            answer = prompt2._injected ? getInjectedAnswer(prompt2._injected, question.initial) : yield prompts[type](question);
            answers[name] = answer = yield getFormattedAnswer(question, answer, true);
            quit = yield onSubmit(question, answer, answers);
          } catch (err2) {
            quit = !(yield onCancel(question, answers));
          }
          if (quit)
            return answers;
        }
      } catch (err2) {
        _iterator.e(err2);
      } finally {
        _iterator.f();
      }
      return answers;
    });
    return _prompt.apply(this, arguments);
  }
  function getInjectedAnswer(injected, deafultValue) {
    const answer = injected.shift();
    if (answer instanceof Error) {
      throw answer;
    }
    return answer === undefined ? deafultValue : answer;
  }
  function inject(answers) {
    prompt2._injected = (prompt2._injected || []).concat(answers);
  }
  function override(answers) {
    prompt2._override = Object.assign({}, answers);
  }
  module.exports = Object.assign(prompt2, {
    prompt: prompt2,
    prompts,
    inject,
    override
  });
});
var require_action2 = __commonJS((exports, module) => {
  module.exports = (key, isSelect) => {
    if (key.meta && key.name !== "escape")
      return;
    if (key.ctrl) {
      if (key.name === "a")
        return "first";
      if (key.name === "c")
        return "abort";
      if (key.name === "d")
        return "abort";
      if (key.name === "e")
        return "last";
      if (key.name === "g")
        return "reset";
    }
    if (isSelect) {
      if (key.name === "j")
        return "down";
      if (key.name === "k")
        return "up";
    }
    if (key.name === "return")
      return "submit";
    if (key.name === "enter")
      return "submit";
    if (key.name === "backspace")
      return "delete";
    if (key.name === "delete")
      return "deleteForward";
    if (key.name === "abort")
      return "abort";
    if (key.name === "escape")
      return "exit";
    if (key.name === "tab")
      return "next";
    if (key.name === "pagedown")
      return "nextPage";
    if (key.name === "pageup")
      return "prevPage";
    if (key.name === "home")
      return "home";
    if (key.name === "end")
      return "end";
    if (key.name === "up")
      return "up";
    if (key.name === "down")
      return "down";
    if (key.name === "right")
      return "right";
    if (key.name === "left")
      return "left";
    return false;
  };
});
var require_strip2 = __commonJS((exports, module) => {
  module.exports = (str) => {
    const pattern = [
      "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
      "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PRZcf-ntqry=><~]))"
    ].join("|");
    const RGX = new RegExp(pattern, "g");
    return typeof str === "string" ? str.replace(RGX, "") : str;
  };
});
var require_clear2 = __commonJS((exports, module) => {
  var strip = require_strip2();
  var { erase: erase2, cursor: cursor2 } = require_src();
  var width = (str) => [...strip(str)].length;
  module.exports = function(prompt2, perLine) {
    if (!perLine)
      return erase2.line + cursor2.to(0);
    let rows = 0;
    const lines = prompt2.split(/\r?\n/);
    for (let line of lines) {
      rows += 1 + Math.floor(Math.max(width(line) - 1, 0) / perLine);
    }
    return erase2.lines(rows);
  };
});
var require_figures2 = __commonJS((exports, module) => {
  var main = {
    arrowUp: "\u2191",
    arrowDown: "\u2193",
    arrowLeft: "\u2190",
    arrowRight: "\u2192",
    radioOn: "\u25C9",
    radioOff: "\u25EF",
    tick: "\u2714",
    cross: "\u2716",
    ellipsis: "\u2026",
    pointerSmall: "\u203A",
    line: "\u2500",
    pointer: "\u276F"
  };
  var win = {
    arrowUp: main.arrowUp,
    arrowDown: main.arrowDown,
    arrowLeft: main.arrowLeft,
    arrowRight: main.arrowRight,
    radioOn: "(*)",
    radioOff: "( )",
    tick: "\u221A",
    cross: "\xD7",
    ellipsis: "...",
    pointerSmall: "\xBB",
    line: "\u2500",
    pointer: ">"
  };
  var figures = process.platform === "win32" ? win : main;
  module.exports = figures;
});
var require_style2 = __commonJS((exports, module) => {
  var c2 = require_kleur();
  var figures = require_figures2();
  var styles = Object.freeze({
    password: { scale: 1, render: (input) => "*".repeat(input.length) },
    emoji: { scale: 2, render: (input) => "\uD83D\uDE03".repeat(input.length) },
    invisible: { scale: 0, render: (input) => "" },
    default: { scale: 1, render: (input) => `${input}` }
  });
  var render = (type) => styles[type] || styles.default;
  var symbols = Object.freeze({
    aborted: c2.red(figures.cross),
    done: c2.green(figures.tick),
    exited: c2.yellow(figures.cross),
    default: c2.cyan("?")
  });
  var symbol2 = (done, aborted, exited) => aborted ? symbols.aborted : exited ? symbols.exited : done ? symbols.done : symbols.default;
  var delimiter2 = (completing) => c2.gray(completing ? figures.ellipsis : figures.pointerSmall);
  var item = (expandable, expanded) => c2.gray(expandable ? expanded ? figures.pointerSmall : "+" : figures.line);
  module.exports = {
    styles,
    render,
    symbols,
    symbol: symbol2,
    delimiter: delimiter2,
    item
  };
});
var require_lines2 = __commonJS((exports, module) => {
  var strip = require_strip2();
  module.exports = function(msg, perLine) {
    let lines = String(strip(msg) || "").split(/\r?\n/);
    if (!perLine)
      return lines.length;
    return lines.map((l3) => Math.ceil(l3.length / perLine)).reduce((a, b2) => a + b2);
  };
});
var require_wrap2 = __commonJS((exports, module) => {
  module.exports = (msg, opts = {}) => {
    const tab = Number.isSafeInteger(parseInt(opts.margin)) ? new Array(parseInt(opts.margin)).fill(" ").join("") : opts.margin || "";
    const width = opts.width;
    return (msg || "").split(/\r?\n/g).map((line) => line.split(/\s+/g).reduce((arr, w2) => {
      if (w2.length + tab.length >= width || arr[arr.length - 1].length + w2.length + 1 < width)
        arr[arr.length - 1] += ` ${w2}`;
      else
        arr.push(`${tab}${w2}`);
      return arr;
    }, [tab]).join("\n")).join("\n");
  };
});
var require_entriesToDisplay2 = __commonJS((exports, module) => {
  module.exports = (cursor2, total, maxVisible) => {
    maxVisible = maxVisible || total;
    let startIndex = Math.min(total - maxVisible, cursor2 - Math.floor(maxVisible / 2));
    if (startIndex < 0)
      startIndex = 0;
    let endIndex = Math.min(startIndex + maxVisible, total);
    return { startIndex, endIndex };
  };
});
var require_util2 = __commonJS((exports, module) => {
  module.exports = {
    action: require_action2(),
    clear: require_clear2(),
    style: require_style2(),
    strip: require_strip2(),
    figures: require_figures2(),
    lines: require_lines2(),
    wrap: require_wrap2(),
    entriesToDisplay: require_entriesToDisplay2()
  };
});
var require_prompt2 = __commonJS((exports, module) => {
  var readline = import.meta.require("readline");
  var { action } = require_util2();
  var EventEmitter2 = import.meta.require("events");
  var { beep: beep2, cursor: cursor2 } = require_src();
  var color = require_kleur();

  class Prompt extends EventEmitter2 {
    constructor(opts = {}) {
      super();
      this.firstRender = true;
      this.in = opts.stdin || process.stdin;
      this.out = opts.stdout || process.stdout;
      this.onRender = (opts.onRender || (() => {
        return;
      })).bind(this);
      const rl = readline.createInterface({ input: this.in, escapeCodeTimeout: 50 });
      readline.emitKeypressEvents(this.in, rl);
      if (this.in.isTTY)
        this.in.setRawMode(true);
      const isSelect = ["SelectPrompt", "MultiselectPrompt"].indexOf(this.constructor.name) > -1;
      const keypress = (str, key) => {
        let a = action(key, isSelect);
        if (a === false) {
          this._ && this._(str, key);
        } else if (typeof this[a] === "function") {
          this[a](key);
        } else {
          this.bell();
        }
      };
      this.close = () => {
        this.out.write(cursor2.show);
        this.in.removeListener("keypress", keypress);
        if (this.in.isTTY)
          this.in.setRawMode(false);
        rl.close();
        this.emit(this.aborted ? "abort" : this.exited ? "exit" : "submit", this.value);
        this.closed = true;
      };
      this.in.on("keypress", keypress);
    }
    fire() {
      this.emit("state", {
        value: this.value,
        aborted: !!this.aborted,
        exited: !!this.exited
      });
    }
    bell() {
      this.out.write(beep2);
    }
    render() {
      this.onRender(color);
      if (this.firstRender)
        this.firstRender = false;
    }
  }
  module.exports = Prompt;
});
var require_text2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt2();
  var { erase: erase2, cursor: cursor2 } = require_src();
  var { style, clear, lines, figures } = require_util2();

  class TextPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.msg = opts.message;
      this.initial = opts.initial || ``;
      this.validator = opts.validate || (() => true);
      this.value = ``;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.clear = clear(``, this.out.columns);
      this.render();
    }
    set value(v2) {
      if (!v2 && this.initial) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(this.initial));
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(v2);
      }
      this._value = v2;
      this.fire();
    }
    get value() {
      return this._value;
    }
    reset() {
      this.value = ``;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.value = this.value || this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.red = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === `string`) {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      this.value = this.value || this.initial;
      this.cursorOffset = 0;
      this.cursor = this.rendered.length;
      await this.validate();
      if (this.error) {
        this.red = true;
        this.fire();
        this.render();
        return;
      }
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    next() {
      if (!this.placeholder)
        return this.bell();
      this.value = this.initial;
      this.cursor = this.rendered.length;
      this.fire();
      this.render();
    }
    moveCursor(n) {
      if (this.placeholder)
        return;
      this.cursor = this.cursor + n;
      this.cursorOffset += n;
    }
    _(c2, key) {
      let s1 = this.value.slice(0, this.cursor);
      let s22 = this.value.slice(this.cursor);
      this.value = `${s1}${c2}${s22}`;
      this.red = false;
      this.cursor = this.placeholder ? 0 : s1.length + 1;
      this.render();
    }
    delete() {
      if (this.isCursorAtStart())
        return this.bell();
      let s1 = this.value.slice(0, this.cursor - 1);
      let s22 = this.value.slice(this.cursor);
      this.value = `${s1}${s22}`;
      this.red = false;
      if (this.isCursorAtStart()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
        this.moveCursor(-1);
      }
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      let s1 = this.value.slice(0, this.cursor);
      let s22 = this.value.slice(this.cursor + 1);
      this.value = `${s1}${s22}`;
      this.red = false;
      if (this.isCursorAtEnd()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
      }
      this.render();
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length;
      this.render();
    }
    left() {
      if (this.cursor <= 0 || this.placeholder)
        return this.bell();
      this.moveCursor(-1);
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      this.moveCursor(1);
      this.render();
    }
    isCursorAtStart() {
      return this.cursor === 0 || this.placeholder && this.cursor === 1;
    }
    isCursorAtEnd() {
      return this.cursor === this.rendered.length || this.placeholder && this.cursor === this.rendered.length + 1;
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor2.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.red ? color.red(this.rendered) : this.rendered
      ].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l3, i) => a + `\n${i ? " " : figures.pointerSmall} ${color.red().italic(l3)}`, ``);
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText + cursor2.save + this.outputError + cursor2.restore + cursor2.move(this.cursorOffset, 0));
    }
  }
  module.exports = TextPrompt;
});
var require_select2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt2();
  var { style, clear, figures, wrap, entriesToDisplay } = require_util2();
  var { cursor: cursor2 } = require_src();

  class SelectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.hint = opts.hint || "- Use arrow-keys. Return to submit.";
      this.warn = opts.warn || "- This option is disabled";
      this.cursor = opts.initial || 0;
      this.choices = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = { title: ch, value: idx };
        return {
          title: ch && (ch.title || ch.value || ch),
          value: ch && (ch.value === undefined ? idx : ch.value),
          description: ch && ch.description,
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = (this.choices[this.cursor] || {}).value;
      this.clear = clear("", this.out.columns);
      this.render();
    }
    moveCursor(n) {
      this.cursor = n;
      this.value = this.choices[n].value;
      this.fire();
    }
    reset() {
      this.moveCursor(0);
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      if (!this.selection.disabled) {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      } else
        this.bell();
    }
    first() {
      this.moveCursor(0);
      this.render();
    }
    last() {
      this.moveCursor(this.choices.length - 1);
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.moveCursor(this.choices.length - 1);
      } else {
        this.moveCursor(this.cursor - 1);
      }
      this.render();
    }
    down() {
      if (this.cursor === this.choices.length - 1) {
        this.moveCursor(0);
      } else {
        this.moveCursor(this.cursor + 1);
      }
      this.render();
    }
    next() {
      this.moveCursor((this.cursor + 1) % this.choices.length);
      this.render();
    }
    _(c2, key) {
      if (c2 === " ")
        return this.submit();
    }
    get selection() {
      return this.choices[this.cursor];
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let { startIndex, endIndex } = entriesToDisplay(this.cursor, this.choices.length, this.optionsPerPage);
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.done ? this.selection.title : this.selection.disabled ? color.yellow(this.warn) : color.gray(this.hint)
      ].join(" ");
      if (!this.done) {
        this.outputText += "\n";
        for (let i = startIndex;i < endIndex; i++) {
          let title, prefix, desc = "", v2 = this.choices[i];
          if (i === startIndex && startIndex > 0) {
            prefix = figures.arrowUp;
          } else if (i === endIndex - 1 && endIndex < this.choices.length) {
            prefix = figures.arrowDown;
          } else {
            prefix = " ";
          }
          if (v2.disabled) {
            title = this.cursor === i ? color.gray().underline(v2.title) : color.strikethrough().gray(v2.title);
            prefix = (this.cursor === i ? color.bold().gray(figures.pointer) + " " : "  ") + prefix;
          } else {
            title = this.cursor === i ? color.cyan().underline(v2.title) : v2.title;
            prefix = (this.cursor === i ? color.cyan(figures.pointer) + " " : "  ") + prefix;
            if (v2.description && this.cursor === i) {
              desc = ` - ${v2.description}`;
              if (prefix.length + title.length + desc.length >= this.out.columns || v2.description.split(/\r?\n/).length > 1) {
                desc = "\n" + wrap(v2.description, { margin: 3, width: this.out.columns });
              }
            }
          }
          this.outputText += `${prefix} ${title}${color.gray(desc)}\n`;
        }
      }
      this.out.write(this.outputText);
    }
  }
  module.exports = SelectPrompt;
});
var require_toggle2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt2();
  var { style, clear } = require_util2();
  var { cursor: cursor2, erase: erase2 } = require_src();

  class TogglePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = !!opts.initial;
      this.active = opts.active || "on";
      this.inactive = opts.inactive || "off";
      this.initialValue = this.value;
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    deactivate() {
      if (this.value === false)
        return this.bell();
      this.value = false;
      this.render();
    }
    activate() {
      if (this.value === true)
        return this.bell();
      this.value = true;
      this.render();
    }
    delete() {
      this.deactivate();
    }
    left() {
      this.deactivate();
    }
    right() {
      this.activate();
    }
    down() {
      this.deactivate();
    }
    up() {
      this.activate();
    }
    next() {
      this.value = !this.value;
      this.fire();
      this.render();
    }
    _(c2, key) {
      if (c2 === " ") {
        this.value = !this.value;
      } else if (c2 === "1") {
        this.value = true;
      } else if (c2 === "0") {
        this.value = false;
      } else
        return this.bell();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.value ? this.inactive : color.cyan().underline(this.inactive),
        color.gray("/"),
        this.value ? color.cyan().underline(this.active) : this.active
      ].join(" ");
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = TogglePrompt;
});
var require_datepart2 = __commonJS((exports, module) => {

  class DatePart {
    constructor({ token, date, parts, locales: locales2 }) {
      this.token = token;
      this.date = date || new Date;
      this.parts = parts || [this];
      this.locales = locales2 || {};
    }
    up() {
    }
    down() {
    }
    next() {
      const currentIdx = this.parts.indexOf(this);
      return this.parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    setTo(val2) {
    }
    prev() {
      let parts = [].concat(this.parts).reverse();
      const currentIdx = parts.indexOf(this);
      return parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    toString() {
      return String(this.date);
    }
  }
  module.exports = DatePart;
});
var require_meridiem2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();

  class Meridiem extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours((this.date.getHours() + 12) % 24);
    }
    down() {
      this.up();
    }
    toString() {
      let meridiem = this.date.getHours() > 12 ? "pm" : "am";
      return /\A/.test(this.token) ? meridiem.toUpperCase() : meridiem;
    }
  }
  module.exports = Meridiem;
});
var require_day2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();
  var pos = (n) => {
    n = n % 10;
    return n === 1 ? "st" : n === 2 ? "nd" : n === 3 ? "rd" : "th";
  };

  class Day extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setDate(this.date.getDate() + 1);
    }
    down() {
      this.date.setDate(this.date.getDate() - 1);
    }
    setTo(val2) {
      this.date.setDate(parseInt(val2.substr(-2)));
    }
    toString() {
      let date = this.date.getDate();
      let day = this.date.getDay();
      return this.token === "DD" ? String(date).padStart(2, "0") : this.token === "Do" ? date + pos(date) : this.token === "d" ? day + 1 : this.token === "ddd" ? this.locales.weekdaysShort[day] : this.token === "dddd" ? this.locales.weekdays[day] : date;
    }
  }
  module.exports = Day;
});
var require_hours2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();

  class Hours extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours(this.date.getHours() + 1);
    }
    down() {
      this.date.setHours(this.date.getHours() - 1);
    }
    setTo(val2) {
      this.date.setHours(parseInt(val2.substr(-2)));
    }
    toString() {
      let hours = this.date.getHours();
      if (/h/.test(this.token))
        hours = hours % 12 || 12;
      return this.token.length > 1 ? String(hours).padStart(2, "0") : hours;
    }
  }
  module.exports = Hours;
});
var require_milliseconds2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();

  class Milliseconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMilliseconds(this.date.getMilliseconds() + 1);
    }
    down() {
      this.date.setMilliseconds(this.date.getMilliseconds() - 1);
    }
    setTo(val2) {
      this.date.setMilliseconds(parseInt(val2.substr(-this.token.length)));
    }
    toString() {
      return String(this.date.getMilliseconds()).padStart(4, "0").substr(0, this.token.length);
    }
  }
  module.exports = Milliseconds;
});
var require_minutes2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();

  class Minutes extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMinutes(this.date.getMinutes() + 1);
    }
    down() {
      this.date.setMinutes(this.date.getMinutes() - 1);
    }
    setTo(val2) {
      this.date.setMinutes(parseInt(val2.substr(-2)));
    }
    toString() {
      let m2 = this.date.getMinutes();
      return this.token.length > 1 ? String(m2).padStart(2, "0") : m2;
    }
  }
  module.exports = Minutes;
});
var require_month2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();

  class Month extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMonth(this.date.getMonth() + 1);
    }
    down() {
      this.date.setMonth(this.date.getMonth() - 1);
    }
    setTo(val2) {
      val2 = parseInt(val2.substr(-2)) - 1;
      this.date.setMonth(val2 < 0 ? 0 : val2);
    }
    toString() {
      let month = this.date.getMonth();
      let tl = this.token.length;
      return tl === 2 ? String(month + 1).padStart(2, "0") : tl === 3 ? this.locales.monthsShort[month] : tl === 4 ? this.locales.months[month] : String(month + 1);
    }
  }
  module.exports = Month;
});
var require_seconds2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();

  class Seconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setSeconds(this.date.getSeconds() + 1);
    }
    down() {
      this.date.setSeconds(this.date.getSeconds() - 1);
    }
    setTo(val2) {
      this.date.setSeconds(parseInt(val2.substr(-2)));
    }
    toString() {
      let s3 = this.date.getSeconds();
      return this.token.length > 1 ? String(s3).padStart(2, "0") : s3;
    }
  }
  module.exports = Seconds;
});
var require_year2 = __commonJS((exports, module) => {
  var DatePart = require_datepart2();

  class Year extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setFullYear(this.date.getFullYear() + 1);
    }
    down() {
      this.date.setFullYear(this.date.getFullYear() - 1);
    }
    setTo(val2) {
      this.date.setFullYear(val2.substr(-4));
    }
    toString() {
      let year = String(this.date.getFullYear()).padStart(4, "0");
      return this.token.length === 2 ? year.substr(-2) : year;
    }
  }
  module.exports = Year;
});
var require_dateparts2 = __commonJS((exports, module) => {
  module.exports = {
    DatePart: require_datepart2(),
    Meridiem: require_meridiem2(),
    Day: require_day2(),
    Hours: require_hours2(),
    Milliseconds: require_milliseconds2(),
    Minutes: require_minutes2(),
    Month: require_month2(),
    Seconds: require_seconds2(),
    Year: require_year2()
  };
});
var require_date2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt2();
  var { style, clear, figures } = require_util2();
  var { erase: erase2, cursor: cursor2 } = require_src();
  var { DatePart, Meridiem, Day, Hours, Milliseconds, Minutes, Month, Seconds, Year } = require_dateparts2();
  var regex2 = /\\(.)|"((?:\\["\\]|[^"])+)"|(D[Do]?|d{3,4}|d)|(M{1,4})|(YY(?:YY)?)|([aA])|([Hh]{1,2})|(m{1,2})|(s{1,2})|(S{1,4})|./g;
  var regexGroups = {
    1: ({ token }) => token.replace(/\\(.)/g, "$1"),
    2: (opts) => new Day(opts),
    3: (opts) => new Month(opts),
    4: (opts) => new Year(opts),
    5: (opts) => new Meridiem(opts),
    6: (opts) => new Hours(opts),
    7: (opts) => new Minutes(opts),
    8: (opts) => new Seconds(opts),
    9: (opts) => new Milliseconds(opts)
  };
  var dfltLocales = {
    months: "January,February,March,April,May,June,July,August,September,October,November,December".split(","),
    monthsShort: "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),
    weekdays: "Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),
    weekdaysShort: "Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(",")
  };

  class DatePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = 0;
      this.typed = "";
      this.locales = Object.assign(dfltLocales, opts.locales);
      this._date = opts.initial || new Date;
      this.errorMsg = opts.error || "Please Enter A Valid Value";
      this.validator = opts.validate || (() => true);
      this.mask = opts.mask || "YYYY-MM-DD HH:mm:ss";
      this.clear = clear("", this.out.columns);
      this.render();
    }
    get value() {
      return this.date;
    }
    get date() {
      return this._date;
    }
    set date(date) {
      if (date)
        this._date.setTime(date.getTime());
    }
    set mask(mask) {
      let result2;
      this.parts = [];
      while (result2 = regex2.exec(mask)) {
        let match = result2.shift();
        let idx = result2.findIndex((gr) => gr != null);
        this.parts.push(idx in regexGroups ? regexGroups[idx]({ token: result2[idx] || match, date: this.date, parts: this.parts, locales: this.locales }) : result2[idx] || match);
      }
      let parts = this.parts.reduce((arr, i) => {
        if (typeof i === "string" && typeof arr[arr.length - 1] === "string")
          arr[arr.length - 1] += i;
        else
          arr.push(i);
        return arr;
      }, []);
      this.parts.splice(0);
      this.parts.push(...parts);
      this.reset();
    }
    moveCursor(n) {
      this.typed = "";
      this.cursor = n;
      this.fire();
    }
    reset() {
      this.moveCursor(this.parts.findIndex((p3) => p3 instanceof DatePart));
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === "string") {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      await this.validate();
      if (this.error) {
        this.color = "red";
        this.fire();
        this.render();
        return;
      }
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    up() {
      this.typed = "";
      this.parts[this.cursor].up();
      this.render();
    }
    down() {
      this.typed = "";
      this.parts[this.cursor].down();
      this.render();
    }
    left() {
      let prev = this.parts[this.cursor].prev();
      if (prev == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(prev));
      this.render();
    }
    right() {
      let next = this.parts[this.cursor].next();
      if (next == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(next));
      this.render();
    }
    next() {
      let next = this.parts[this.cursor].next();
      this.moveCursor(next ? this.parts.indexOf(next) : this.parts.findIndex((part) => part instanceof DatePart));
      this.render();
    }
    _(c2) {
      if (/\d/.test(c2)) {
        this.typed += c2;
        this.parts[this.cursor].setTo(this.typed);
        this.render();
      }
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.parts.reduce((arr, p3, idx) => arr.concat(idx === this.cursor && !this.done ? color.cyan().underline(p3.toString()) : p3), []).join("")
      ].join(" ");
      if (this.error) {
        this.outputText += this.errorMsg.split("\n").reduce((a, l3, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l3)}`, ``);
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = DatePrompt;
});
var require_number2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt2();
  var { cursor: cursor2, erase: erase2 } = require_src();
  var { style, figures, clear, lines } = require_util2();
  var isNumber = /[0-9]/;
  var isDef = (any) => any !== undefined;
  var round = (number, precision) => {
    let factor = Math.pow(10, precision);
    return Math.round(number * factor) / factor;
  };

  class NumberPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.msg = opts.message;
      this.initial = isDef(opts.initial) ? opts.initial : "";
      this.float = !!opts.float;
      this.round = opts.round || 2;
      this.inc = opts.increment || 1;
      this.min = isDef(opts.min) ? opts.min : -Infinity;
      this.max = isDef(opts.max) ? opts.max : Infinity;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.validator = opts.validate || (() => true);
      this.color = `cyan`;
      this.value = ``;
      this.typed = ``;
      this.lastHit = 0;
      this.render();
    }
    set value(v2) {
      if (!v2 && v2 !== 0) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(`${this.initial}`));
        this._value = ``;
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(`${round(v2, this.round)}`);
        this._value = round(v2, this.round);
      }
      this.fire();
    }
    get value() {
      return this._value;
    }
    parse(x2) {
      return this.float ? parseFloat(x2) : parseInt(x2);
    }
    valid(c2) {
      return c2 === `-` || c2 === `.` && this.float || isNumber.test(c2);
    }
    reset() {
      this.typed = ``;
      this.value = ``;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      let x2 = this.value;
      this.value = x2 !== `` ? x2 : this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === `string`) {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      await this.validate();
      if (this.error) {
        this.color = `red`;
        this.fire();
        this.render();
        return;
      }
      let x2 = this.value;
      this.value = x2 !== `` ? x2 : this.initial;
      this.done = true;
      this.aborted = false;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    up() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min - this.inc;
      }
      if (this.value >= this.max)
        return this.bell();
      this.value += this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    down() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min + this.inc;
      }
      if (this.value <= this.min)
        return this.bell();
      this.value -= this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    delete() {
      let val2 = this.value.toString();
      if (val2.length === 0)
        return this.bell();
      this.value = this.parse(val2 = val2.slice(0, -1)) || ``;
      if (this.value !== "" && this.value < this.min) {
        this.value = this.min;
      }
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    next() {
      this.value = this.initial;
      this.fire();
      this.render();
    }
    _(c2, key) {
      if (!this.valid(c2))
        return this.bell();
      const now = Date.now();
      if (now - this.lastHit > 1000)
        this.typed = ``;
      this.typed += c2;
      this.lastHit = now;
      this.color = `cyan`;
      if (c2 === `.`)
        return this.fire();
      this.value = Math.min(this.parse(this.typed), this.max);
      if (this.value > this.max)
        this.value = this.max;
      if (this.value < this.min)
        this.value = this.min;
      this.fire();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor2.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        !this.done || !this.done && !this.placeholder ? color[this.color]().underline(this.rendered) : this.rendered
      ].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l3, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l3)}`, ``);
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText + cursor2.save + this.outputError + cursor2.restore);
    }
  }
  module.exports = NumberPrompt;
});
var require_multiselect2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var { cursor: cursor2 } = require_src();
  var Prompt = require_prompt2();
  var { clear, figures, style, wrap, entriesToDisplay } = require_util2();

  class MultiselectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = opts.cursor || 0;
      this.scrollIndex = opts.cursor || 0;
      this.hint = opts.hint || "";
      this.warn = opts.warn || "- This option is disabled -";
      this.minSelected = opts.min;
      this.showMinError = false;
      this.maxChoices = opts.max;
      this.instructions = opts.instructions;
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = { title: ch, value: idx };
        return {
          title: ch && (ch.title || ch.value || ch),
          description: ch && ch.description,
          value: ch && (ch.value === undefined ? idx : ch.value),
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.clear = clear("", this.out.columns);
      if (!opts.overrideRender) {
        this.render();
      }
    }
    reset() {
      this.value.map((v2) => !v2.selected);
      this.cursor = 0;
      this.fire();
      this.render();
    }
    selected() {
      return this.value.filter((v2) => v2.selected);
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      const selected = this.value.filter((e) => e.selected);
      if (this.minSelected && selected.length < this.minSelected) {
        this.showMinError = true;
        this.render();
      } else {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.value.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.value.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.value.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.value[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.value[this.cursor].selected = true;
      this.render();
    }
    handleSpaceToggle() {
      const v2 = this.value[this.cursor];
      if (v2.selected) {
        v2.selected = false;
        this.render();
      } else if (v2.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v2.selected = true;
        this.render();
      }
    }
    toggleAll() {
      if (this.maxChoices !== undefined || this.value[this.cursor].disabled) {
        return this.bell();
      }
      const newSelected = !this.value[this.cursor].selected;
      this.value.filter((v2) => !v2.disabled).forEach((v2) => v2.selected = newSelected);
      this.render();
    }
    _(c2, key) {
      if (c2 === " ") {
        this.handleSpaceToggle();
      } else if (c2 === "a") {
        this.toggleAll();
      } else {
        return this.bell();
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return "\nInstructions:\n" + `    ${figures.arrowUp}/${figures.arrowDown}: Highlight option\n` + `    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection\n` + (this.maxChoices === undefined ? `    a: Toggle all\n` : "") + `    enter/return: Complete answer`;
      }
      return "";
    }
    renderOption(cursor3, v2, i, arrowIndicator) {
      const prefix = (v2.selected ? color.green(figures.radioOn) : figures.radioOff) + " " + arrowIndicator + " ";
      let title, desc;
      if (v2.disabled) {
        title = cursor3 === i ? color.gray().underline(v2.title) : color.strikethrough().gray(v2.title);
      } else {
        title = cursor3 === i ? color.cyan().underline(v2.title) : v2.title;
        if (cursor3 === i && v2.description) {
          desc = ` - ${v2.description}`;
          if (prefix.length + title.length + desc.length >= this.out.columns || v2.description.split(/\r?\n/).length > 1) {
            desc = "\n" + wrap(v2.description, { margin: prefix.length, width: this.out.columns });
          }
        }
      }
      return prefix + title + color.gray(desc || "");
    }
    paginateOptions(options2) {
      if (options2.length === 0) {
        return color.red("No matches for this query.");
      }
      let { startIndex, endIndex } = entriesToDisplay(this.cursor, options2.length, this.optionsPerPage);
      let prefix, styledOptions = [];
      for (let i = startIndex;i < endIndex; i++) {
        if (i === startIndex && startIndex > 0) {
          prefix = figures.arrowUp;
        } else if (i === endIndex - 1 && endIndex < options2.length) {
          prefix = figures.arrowDown;
        } else {
          prefix = " ";
        }
        styledOptions.push(this.renderOption(this.cursor, options2[i], i, prefix));
      }
      return "\n" + styledOptions.join("\n");
    }
    renderOptions(options2) {
      if (!this.done) {
        return this.paginateOptions(options2);
      }
      return "";
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v2) => v2.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions()];
      if (this.value[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      super.render();
      let prompt2 = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.renderDoneOrInstructions()
      ].join(" ");
      if (this.showMinError) {
        prompt2 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt2 += this.renderOptions(this.value);
      this.out.write(this.clear + prompt2);
      this.clear = clear(prompt2, this.out.columns);
    }
  }
  module.exports = MultiselectPrompt;
});
var require_autocomplete2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt2();
  var { erase: erase2, cursor: cursor2 } = require_src();
  var { style, clear, figures, wrap, entriesToDisplay } = require_util2();
  var getVal = (arr, i) => arr[i] && (arr[i].value || arr[i].title || arr[i]);
  var getTitle = (arr, i) => arr[i] && (arr[i].title || arr[i].value || arr[i]);
  var getIndex = (arr, valOrTitle) => {
    const index = arr.findIndex((el) => el.value === valOrTitle || el.title === valOrTitle);
    return index > -1 ? index : undefined;
  };

  class AutocompletePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.suggest = opts.suggest;
      this.choices = opts.choices;
      this.initial = typeof opts.initial === "number" ? opts.initial : getIndex(opts.choices, opts.initial);
      this.select = this.initial || opts.cursor || 0;
      this.i18n = { noMatches: opts.noMatches || "no matches found" };
      this.fallback = opts.fallback || this.initial;
      this.clearFirst = opts.clearFirst || false;
      this.suggestions = [];
      this.input = "";
      this.limit = opts.limit || 10;
      this.cursor = 0;
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.render = this.render.bind(this);
      this.complete = this.complete.bind(this);
      this.clear = clear("", this.out.columns);
      this.complete(this.render);
      this.render();
    }
    set fallback(fb) {
      this._fb = Number.isSafeInteger(parseInt(fb)) ? parseInt(fb) : fb;
    }
    get fallback() {
      let choice;
      if (typeof this._fb === "number")
        choice = this.choices[this._fb];
      else if (typeof this._fb === "string")
        choice = { title: this._fb };
      return choice || this._fb || { title: this.i18n.noMatches };
    }
    moveSelect(i) {
      this.select = i;
      if (this.suggestions.length > 0)
        this.value = getVal(this.suggestions, i);
      else
        this.value = this.fallback.value;
      this.fire();
    }
    async complete(cb) {
      const p3 = this.completing = this.suggest(this.input, this.choices);
      const suggestions = await p3;
      if (this.completing !== p3)
        return;
      this.suggestions = suggestions.map((s3, i, arr) => ({ title: getTitle(arr, i), value: getVal(arr, i), description: s3.description }));
      this.completing = false;
      const l3 = Math.max(suggestions.length - 1, 0);
      this.moveSelect(Math.min(l3, this.select));
      cb && cb();
    }
    reset() {
      this.input = "";
      this.complete(() => {
        this.moveSelect(this.initial !== undefined ? this.initial : 0);
        this.render();
      });
      this.render();
    }
    exit() {
      if (this.clearFirst && this.input.length > 0) {
        this.reset();
      } else {
        this.done = this.exited = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    abort() {
      this.done = this.aborted = true;
      this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c2, key) {
      let s1 = this.input.slice(0, this.cursor);
      let s22 = this.input.slice(this.cursor);
      this.input = `${s1}${c2}${s22}`;
      this.cursor = s1.length + 1;
      this.complete(this.render);
      this.render();
    }
    delete() {
      if (this.cursor === 0)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor - 1);
      let s22 = this.input.slice(this.cursor);
      this.input = `${s1}${s22}`;
      this.complete(this.render);
      this.cursor = this.cursor - 1;
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor);
      let s22 = this.input.slice(this.cursor + 1);
      this.input = `${s1}${s22}`;
      this.complete(this.render);
      this.render();
    }
    first() {
      this.moveSelect(0);
      this.render();
    }
    last() {
      this.moveSelect(this.suggestions.length - 1);
      this.render();
    }
    up() {
      if (this.select === 0) {
        this.moveSelect(this.suggestions.length - 1);
      } else {
        this.moveSelect(this.select - 1);
      }
      this.render();
    }
    down() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else {
        this.moveSelect(this.select + 1);
      }
      this.render();
    }
    next() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else
        this.moveSelect(this.select + 1);
      this.render();
    }
    nextPage() {
      this.moveSelect(Math.min(this.select + this.limit, this.suggestions.length - 1));
      this.render();
    }
    prevPage() {
      this.moveSelect(Math.max(this.select - this.limit, 0));
      this.render();
    }
    left() {
      if (this.cursor <= 0)
        return this.bell();
      this.cursor = this.cursor - 1;
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      this.cursor = this.cursor + 1;
      this.render();
    }
    renderOption(v2, hovered, isStart, isEnd) {
      let desc;
      let prefix = isStart ? figures.arrowUp : isEnd ? figures.arrowDown : " ";
      let title = hovered ? color.cyan().underline(v2.title) : v2.title;
      prefix = (hovered ? color.cyan(figures.pointer) + " " : "  ") + prefix;
      if (v2.description) {
        desc = ` - ${v2.description}`;
        if (prefix.length + title.length + desc.length >= this.out.columns || v2.description.split(/\r?\n/).length > 1) {
          desc = "\n" + wrap(v2.description, { margin: 3, width: this.out.columns });
        }
      }
      return prefix + " " + title + color.gray(desc || "");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let { startIndex, endIndex } = entriesToDisplay(this.select, this.choices.length, this.limit);
      this.outputText = [
        style.symbol(this.done, this.aborted, this.exited),
        color.bold(this.msg),
        style.delimiter(this.completing),
        this.done && this.suggestions[this.select] ? this.suggestions[this.select].title : this.rendered = this.transform.render(this.input)
      ].join(" ");
      if (!this.done) {
        const suggestions = this.suggestions.slice(startIndex, endIndex).map((item, i) => this.renderOption(item, this.select === i + startIndex, i === 0 && startIndex > 0, i + startIndex === endIndex - 1 && endIndex < this.choices.length)).join("\n");
        this.outputText += `\n` + (suggestions || color.gray(this.fallback.title));
      }
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = AutocompletePrompt;
});
var require_autocompleteMultiselect2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var { cursor: cursor2 } = require_src();
  var MultiselectPrompt = require_multiselect2();
  var { clear, style, figures } = require_util2();

  class AutocompleteMultiselectPrompt extends MultiselectPrompt {
    constructor(opts = {}) {
      opts.overrideRender = true;
      super(opts);
      this.inputValue = "";
      this.clear = clear("", this.out.columns);
      this.filteredOptions = this.value;
      this.render();
    }
    last() {
      this.cursor = this.filteredOptions.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.filteredOptions.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.filteredOptions.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.filteredOptions.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.filteredOptions[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.filteredOptions[this.cursor].selected = true;
      this.render();
    }
    delete() {
      if (this.inputValue.length) {
        this.inputValue = this.inputValue.substr(0, this.inputValue.length - 1);
        this.updateFilteredOptions();
      }
    }
    updateFilteredOptions() {
      const currentHighlight = this.filteredOptions[this.cursor];
      this.filteredOptions = this.value.filter((v2) => {
        if (this.inputValue) {
          if (typeof v2.title === "string") {
            if (v2.title.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          if (typeof v2.value === "string") {
            if (v2.value.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          return false;
        }
        return true;
      });
      const newHighlightIndex = this.filteredOptions.findIndex((v2) => v2 === currentHighlight);
      this.cursor = newHighlightIndex < 0 ? 0 : newHighlightIndex;
      this.render();
    }
    handleSpaceToggle() {
      const v2 = this.filteredOptions[this.cursor];
      if (v2.selected) {
        v2.selected = false;
        this.render();
      } else if (v2.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v2.selected = true;
        this.render();
      }
    }
    handleInputChange(c2) {
      this.inputValue = this.inputValue + c2;
      this.updateFilteredOptions();
    }
    _(c2, key) {
      if (c2 === " ") {
        this.handleSpaceToggle();
      } else {
        this.handleInputChange(c2);
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `
Instructions:
    ${figures.arrowUp}/${figures.arrowDown}: Highlight option
    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection
    [a,b,c]/delete: Filter choices
    enter/return: Complete answer
`;
      }
      return "";
    }
    renderCurrentInput() {
      return `
Filtered results for: ${this.inputValue ? this.inputValue : color.gray("Enter something to filter")}\n`;
    }
    renderOption(cursor3, v2, i) {
      let title;
      if (v2.disabled)
        title = cursor3 === i ? color.gray().underline(v2.title) : color.strikethrough().gray(v2.title);
      else
        title = cursor3 === i ? color.cyan().underline(v2.title) : v2.title;
      return (v2.selected ? color.green(figures.radioOn) : figures.radioOff) + "  " + title;
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v2) => v2.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions(), this.renderCurrentInput()];
      if (this.filteredOptions.length && this.filteredOptions[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      super.render();
      let prompt2 = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.renderDoneOrInstructions()
      ].join(" ");
      if (this.showMinError) {
        prompt2 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt2 += this.renderOptions(this.filteredOptions);
      this.out.write(this.clear + prompt2);
      this.clear = clear(prompt2, this.out.columns);
    }
  }
  module.exports = AutocompleteMultiselectPrompt;
});
var require_confirm2 = __commonJS((exports, module) => {
  var color = require_kleur();
  var Prompt = require_prompt2();
  var { style, clear } = require_util2();
  var { erase: erase2, cursor: cursor2 } = require_src();

  class ConfirmPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = opts.initial;
      this.initialValue = !!opts.initial;
      this.yesMsg = opts.yes || "yes";
      this.yesOption = opts.yesOption || "(Y/n)";
      this.noMsg = opts.no || "no";
      this.noOption = opts.noOption || "(y/N)";
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.value = this.value || false;
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c2, key) {
      if (c2.toLowerCase() === "y") {
        this.value = true;
        return this.submit();
      }
      if (c2.toLowerCase() === "n") {
        this.value = false;
        return this.submit();
      }
      return this.bell();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor2.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.done ? this.value ? this.yesMsg : this.noMsg : color.gray(this.initialValue ? this.yesOption : this.noOption)
      ].join(" ");
      this.out.write(erase2.line + cursor2.to(0) + this.outputText);
    }
  }
  module.exports = ConfirmPrompt;
});
var require_elements2 = __commonJS((exports, module) => {
  module.exports = {
    TextPrompt: require_text2(),
    SelectPrompt: require_select2(),
    TogglePrompt: require_toggle2(),
    DatePrompt: require_date2(),
    NumberPrompt: require_number2(),
    MultiselectPrompt: require_multiselect2(),
    AutocompletePrompt: require_autocomplete2(),
    AutocompleteMultiselectPrompt: require_autocompleteMultiselect2(),
    ConfirmPrompt: require_confirm2()
  };
});
var require_prompts2 = __commonJS((exports) => {
  var $3 = exports;
  var el = require_elements2();
  var noop = (v2) => v2;
  function toPrompt(type, args, opts = {}) {
    return new Promise((res, rej) => {
      const p3 = new el[type](args);
      const onAbort = opts.onAbort || noop;
      const onSubmit = opts.onSubmit || noop;
      const onExit = opts.onExit || noop;
      p3.on("state", args.onState || noop);
      p3.on("submit", (x2) => res(onSubmit(x2)));
      p3.on("exit", (x2) => res(onExit(x2)));
      p3.on("abort", (x2) => rej(onAbort(x2)));
    });
  }
  $3.text = (args) => toPrompt("TextPrompt", args);
  $3.password = (args) => {
    args.style = "password";
    return $3.text(args);
  };
  $3.invisible = (args) => {
    args.style = "invisible";
    return $3.text(args);
  };
  $3.number = (args) => toPrompt("NumberPrompt", args);
  $3.date = (args) => toPrompt("DatePrompt", args);
  $3.confirm = (args) => toPrompt("ConfirmPrompt", args);
  $3.list = (args) => {
    const sep3 = args.separator || ",";
    return toPrompt("TextPrompt", args, {
      onSubmit: (str) => str.split(sep3).map((s3) => s3.trim())
    });
  };
  $3.toggle = (args) => toPrompt("TogglePrompt", args);
  $3.select = (args) => toPrompt("SelectPrompt", args);
  $3.multiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("MultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  $3.autocompleteMultiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("AutocompleteMultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  var byTitle = (input, choices) => Promise.resolve(choices.filter((item) => item.title.slice(0, input.length).toLowerCase() === input.toLowerCase()));
  $3.autocomplete = (args) => {
    args.suggest = args.suggest || byTitle;
    args.choices = [].concat(args.choices || []);
    return toPrompt("AutocompletePrompt", args);
  };
});
var require_lib = __commonJS((exports, module) => {
  var prompts = require_prompts2();
  var passOn = ["suggest", "format", "onState", "validate", "onRender", "type"];
  var noop = () => {
  };
  async function prompt2(questions = [], { onSubmit = noop, onCancel = noop } = {}) {
    const answers = {};
    const override2 = prompt2._override || {};
    questions = [].concat(questions);
    let answer, question, quit, name, type, lastPrompt;
    const getFormattedAnswer = async (question2, answer2, skipValidation = false) => {
      if (!skipValidation && question2.validate && question2.validate(answer2) !== true) {
        return;
      }
      return question2.format ? await question2.format(answer2, answers) : answer2;
    };
    for (question of questions) {
      ({ name, type } = question);
      if (typeof type === "function") {
        type = await type(answer, { ...answers }, question);
        question["type"] = type;
      }
      if (!type)
        continue;
      for (let key in question) {
        if (passOn.includes(key))
          continue;
        let value = question[key];
        question[key] = typeof value === "function" ? await value(answer, { ...answers }, lastPrompt) : value;
      }
      lastPrompt = question;
      if (typeof question.message !== "string") {
        throw new Error("prompt message is required");
      }
      ({ name, type } = question);
      if (prompts[type] === undefined) {
        throw new Error(`prompt type (${type}) is not defined`);
      }
      if (override2[question.name] !== undefined) {
        answer = await getFormattedAnswer(question, override2[question.name]);
        if (answer !== undefined) {
          answers[name] = answer;
          continue;
        }
      }
      try {
        answer = prompt2._injected ? getInjectedAnswer(prompt2._injected, question.initial) : await prompts[type](question);
        answers[name] = answer = await getFormattedAnswer(question, answer, true);
        quit = await onSubmit(question, answer, answers);
      } catch (err2) {
        quit = !await onCancel(question, answers);
      }
      if (quit)
        return answers;
    }
    return answers;
  }
  function getInjectedAnswer(injected, deafultValue) {
    const answer = injected.shift();
    if (answer instanceof Error) {
      throw answer;
    }
    return answer === undefined ? deafultValue : answer;
  }
  function inject(answers) {
    prompt2._injected = (prompt2._injected || []).concat(answers);
  }
  function override(answers) {
    prompt2._override = Object.assign({}, answers);
  }
  module.exports = Object.assign(prompt2, { prompt: prompt2, prompts, inject, override });
});
var require_prompts3 = __commonJS((exports, module) => {
  function isNodeLT(tar) {
    tar = (Array.isArray(tar) ? tar : tar.split(".")).map(Number);
    let i = 0, src2 = process.versions.node.split(".").map(Number);
    for (;i < tar.length; i++) {
      if (src2[i] > tar[i])
        return false;
      if (tar[i] > src2[i])
        return true;
    }
    return false;
  }
  module.exports = isNodeLT("8.6.0") ? require_dist() : require_lib();
});
var require_spinners = __commonJS((exports, module) => {
  module.exports = {
    dots: {
      interval: 80,
      frames: [
        "\u280B",
        "\u2819",
        "\u2839",
        "\u2838",
        "\u283C",
        "\u2834",
        "\u2826",
        "\u2827",
        "\u2807",
        "\u280F"
      ]
    },
    dots2: {
      interval: 80,
      frames: [
        "\u28FE",
        "\u28FD",
        "\u28FB",
        "\u28BF",
        "\u287F",
        "\u28DF",
        "\u28EF",
        "\u28F7"
      ]
    },
    dots3: {
      interval: 80,
      frames: [
        "\u280B",
        "\u2819",
        "\u281A",
        "\u281E",
        "\u2816",
        "\u2826",
        "\u2834",
        "\u2832",
        "\u2833",
        "\u2813"
      ]
    },
    dots4: {
      interval: 80,
      frames: [
        "\u2804",
        "\u2806",
        "\u2807",
        "\u280B",
        "\u2819",
        "\u2838",
        "\u2830",
        "\u2820",
        "\u2830",
        "\u2838",
        "\u2819",
        "\u280B",
        "\u2807",
        "\u2806"
      ]
    },
    dots5: {
      interval: 80,
      frames: [
        "\u280B",
        "\u2819",
        "\u281A",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u2832",
        "\u2834",
        "\u2826",
        "\u2816",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2813",
        "\u280B"
      ]
    },
    dots6: {
      interval: 80,
      frames: [
        "\u2801",
        "\u2809",
        "\u2819",
        "\u281A",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u2832",
        "\u2834",
        "\u2824",
        "\u2804",
        "\u2804",
        "\u2824",
        "\u2834",
        "\u2832",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u281A",
        "\u2819",
        "\u2809",
        "\u2801"
      ]
    },
    dots7: {
      interval: 80,
      frames: [
        "\u2808",
        "\u2809",
        "\u280B",
        "\u2813",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2816",
        "\u2826",
        "\u2824",
        "\u2820",
        "\u2820",
        "\u2824",
        "\u2826",
        "\u2816",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2813",
        "\u280B",
        "\u2809",
        "\u2808"
      ]
    },
    dots8: {
      interval: 80,
      frames: [
        "\u2801",
        "\u2801",
        "\u2809",
        "\u2819",
        "\u281A",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u2832",
        "\u2834",
        "\u2824",
        "\u2804",
        "\u2804",
        "\u2824",
        "\u2820",
        "\u2820",
        "\u2824",
        "\u2826",
        "\u2816",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2813",
        "\u280B",
        "\u2809",
        "\u2808",
        "\u2808"
      ]
    },
    dots9: {
      interval: 80,
      frames: [
        "\u28B9",
        "\u28BA",
        "\u28BC",
        "\u28F8",
        "\u28C7",
        "\u2867",
        "\u2857",
        "\u284F"
      ]
    },
    dots10: {
      interval: 80,
      frames: [
        "\u2884",
        "\u2882",
        "\u2881",
        "\u2841",
        "\u2848",
        "\u2850",
        "\u2860"
      ]
    },
    dots11: {
      interval: 100,
      frames: [
        "\u2801",
        "\u2802",
        "\u2804",
        "\u2840",
        "\u2880",
        "\u2820",
        "\u2810",
        "\u2808"
      ]
    },
    dots12: {
      interval: 80,
      frames: [
        "\u2880\u2800",
        "\u2840\u2800",
        "\u2804\u2800",
        "\u2882\u2800",
        "\u2842\u2800",
        "\u2805\u2800",
        "\u2883\u2800",
        "\u2843\u2800",
        "\u280D\u2800",
        "\u288B\u2800",
        "\u284B\u2800",
        "\u280D\u2801",
        "\u288B\u2801",
        "\u284B\u2801",
        "\u280D\u2809",
        "\u280B\u2809",
        "\u280B\u2809",
        "\u2809\u2819",
        "\u2809\u2819",
        "\u2809\u2829",
        "\u2808\u2899",
        "\u2808\u2859",
        "\u2888\u2829",
        "\u2840\u2899",
        "\u2804\u2859",
        "\u2882\u2829",
        "\u2842\u2898",
        "\u2805\u2858",
        "\u2883\u2828",
        "\u2843\u2890",
        "\u280D\u2850",
        "\u288B\u2820",
        "\u284B\u2880",
        "\u280D\u2841",
        "\u288B\u2801",
        "\u284B\u2801",
        "\u280D\u2809",
        "\u280B\u2809",
        "\u280B\u2809",
        "\u2809\u2819",
        "\u2809\u2819",
        "\u2809\u2829",
        "\u2808\u2899",
        "\u2808\u2859",
        "\u2808\u2829",
        "\u2800\u2899",
        "\u2800\u2859",
        "\u2800\u2829",
        "\u2800\u2898",
        "\u2800\u2858",
        "\u2800\u2828",
        "\u2800\u2890",
        "\u2800\u2850",
        "\u2800\u2820",
        "\u2800\u2880",
        "\u2800\u2840"
      ]
    },
    dots13: {
      interval: 80,
      frames: [
        "\u28FC",
        "\u28F9",
        "\u28BB",
        "\u283F",
        "\u285F",
        "\u28CF",
        "\u28E7",
        "\u28F6"
      ]
    },
    dots8Bit: {
      interval: 80,
      frames: [
        "\u2800",
        "\u2801",
        "\u2802",
        "\u2803",
        "\u2804",
        "\u2805",
        "\u2806",
        "\u2807",
        "\u2840",
        "\u2841",
        "\u2842",
        "\u2843",
        "\u2844",
        "\u2845",
        "\u2846",
        "\u2847",
        "\u2808",
        "\u2809",
        "\u280A",
        "\u280B",
        "\u280C",
        "\u280D",
        "\u280E",
        "\u280F",
        "\u2848",
        "\u2849",
        "\u284A",
        "\u284B",
        "\u284C",
        "\u284D",
        "\u284E",
        "\u284F",
        "\u2810",
        "\u2811",
        "\u2812",
        "\u2813",
        "\u2814",
        "\u2815",
        "\u2816",
        "\u2817",
        "\u2850",
        "\u2851",
        "\u2852",
        "\u2853",
        "\u2854",
        "\u2855",
        "\u2856",
        "\u2857",
        "\u2818",
        "\u2819",
        "\u281A",
        "\u281B",
        "\u281C",
        "\u281D",
        "\u281E",
        "\u281F",
        "\u2858",
        "\u2859",
        "\u285A",
        "\u285B",
        "\u285C",
        "\u285D",
        "\u285E",
        "\u285F",
        "\u2820",
        "\u2821",
        "\u2822",
        "\u2823",
        "\u2824",
        "\u2825",
        "\u2826",
        "\u2827",
        "\u2860",
        "\u2861",
        "\u2862",
        "\u2863",
        "\u2864",
        "\u2865",
        "\u2866",
        "\u2867",
        "\u2828",
        "\u2829",
        "\u282A",
        "\u282B",
        "\u282C",
        "\u282D",
        "\u282E",
        "\u282F",
        "\u2868",
        "\u2869",
        "\u286A",
        "\u286B",
        "\u286C",
        "\u286D",
        "\u286E",
        "\u286F",
        "\u2830",
        "\u2831",
        "\u2832",
        "\u2833",
        "\u2834",
        "\u2835",
        "\u2836",
        "\u2837",
        "\u2870",
        "\u2871",
        "\u2872",
        "\u2873",
        "\u2874",
        "\u2875",
        "\u2876",
        "\u2877",
        "\u2838",
        "\u2839",
        "\u283A",
        "\u283B",
        "\u283C",
        "\u283D",
        "\u283E",
        "\u283F",
        "\u2878",
        "\u2879",
        "\u287A",
        "\u287B",
        "\u287C",
        "\u287D",
        "\u287E",
        "\u287F",
        "\u2880",
        "\u2881",
        "\u2882",
        "\u2883",
        "\u2884",
        "\u2885",
        "\u2886",
        "\u2887",
        "\u28C0",
        "\u28C1",
        "\u28C2",
        "\u28C3",
        "\u28C4",
        "\u28C5",
        "\u28C6",
        "\u28C7",
        "\u2888",
        "\u2889",
        "\u288A",
        "\u288B",
        "\u288C",
        "\u288D",
        "\u288E",
        "\u288F",
        "\u28C8",
        "\u28C9",
        "\u28CA",
        "\u28CB",
        "\u28CC",
        "\u28CD",
        "\u28CE",
        "\u28CF",
        "\u2890",
        "\u2891",
        "\u2892",
        "\u2893",
        "\u2894",
        "\u2895",
        "\u2896",
        "\u2897",
        "\u28D0",
        "\u28D1",
        "\u28D2",
        "\u28D3",
        "\u28D4",
        "\u28D5",
        "\u28D6",
        "\u28D7",
        "\u2898",
        "\u2899",
        "\u289A",
        "\u289B",
        "\u289C",
        "\u289D",
        "\u289E",
        "\u289F",
        "\u28D8",
        "\u28D9",
        "\u28DA",
        "\u28DB",
        "\u28DC",
        "\u28DD",
        "\u28DE",
        "\u28DF",
        "\u28A0",
        "\u28A1",
        "\u28A2",
        "\u28A3",
        "\u28A4",
        "\u28A5",
        "\u28A6",
        "\u28A7",
        "\u28E0",
        "\u28E1",
        "\u28E2",
        "\u28E3",
        "\u28E4",
        "\u28E5",
        "\u28E6",
        "\u28E7",
        "\u28A8",
        "\u28A9",
        "\u28AA",
        "\u28AB",
        "\u28AC",
        "\u28AD",
        "\u28AE",
        "\u28AF",
        "\u28E8",
        "\u28E9",
        "\u28EA",
        "\u28EB",
        "\u28EC",
        "\u28ED",
        "\u28EE",
        "\u28EF",
        "\u28B0",
        "\u28B1",
        "\u28B2",
        "\u28B3",
        "\u28B4",
        "\u28B5",
        "\u28B6",
        "\u28B7",
        "\u28F0",
        "\u28F1",
        "\u28F2",
        "\u28F3",
        "\u28F4",
        "\u28F5",
        "\u28F6",
        "\u28F7",
        "\u28B8",
        "\u28B9",
        "\u28BA",
        "\u28BB",
        "\u28BC",
        "\u28BD",
        "\u28BE",
        "\u28BF",
        "\u28F8",
        "\u28F9",
        "\u28FA",
        "\u28FB",
        "\u28FC",
        "\u28FD",
        "\u28FE",
        "\u28FF"
      ]
    },
    sand: {
      interval: 80,
      frames: [
        "\u2801",
        "\u2802",
        "\u2804",
        "\u2840",
        "\u2848",
        "\u2850",
        "\u2860",
        "\u28C0",
        "\u28C1",
        "\u28C2",
        "\u28C4",
        "\u28CC",
        "\u28D4",
        "\u28E4",
        "\u28E5",
        "\u28E6",
        "\u28EE",
        "\u28F6",
        "\u28F7",
        "\u28FF",
        "\u287F",
        "\u283F",
        "\u289F",
        "\u281F",
        "\u285B",
        "\u281B",
        "\u282B",
        "\u288B",
        "\u280B",
        "\u280D",
        "\u2849",
        "\u2809",
        "\u2811",
        "\u2821",
        "\u2881"
      ]
    },
    line: {
      interval: 130,
      frames: [
        "-",
        "\\",
        "|",
        "/"
      ]
    },
    line2: {
      interval: 100,
      frames: [
        "\u2802",
        "-",
        "\u2013",
        "\u2014",
        "\u2013",
        "-"
      ]
    },
    pipe: {
      interval: 100,
      frames: [
        "\u2524",
        "\u2518",
        "\u2534",
        "\u2514",
        "\u251C",
        "\u250C",
        "\u252C",
        "\u2510"
      ]
    },
    simpleDots: {
      interval: 400,
      frames: [
        ".  ",
        ".. ",
        "...",
        "   "
      ]
    },
    simpleDotsScrolling: {
      interval: 200,
      frames: [
        ".  ",
        ".. ",
        "...",
        " ..",
        "  .",
        "   "
      ]
    },
    star: {
      interval: 70,
      frames: [
        "\u2736",
        "\u2738",
        "\u2739",
        "\u273A",
        "\u2739",
        "\u2737"
      ]
    },
    star2: {
      interval: 80,
      frames: [
        "+",
        "x",
        "*"
      ]
    },
    flip: {
      interval: 70,
      frames: [
        "_",
        "_",
        "_",
        "-",
        "`",
        "`",
        "'",
        "\xB4",
        "-",
        "_",
        "_",
        "_"
      ]
    },
    hamburger: {
      interval: 100,
      frames: [
        "\u2631",
        "\u2632",
        "\u2634"
      ]
    },
    growVertical: {
      interval: 120,
      frames: [
        "\u2581",
        "\u2583",
        "\u2584",
        "\u2585",
        "\u2586",
        "\u2587",
        "\u2586",
        "\u2585",
        "\u2584",
        "\u2583"
      ]
    },
    growHorizontal: {
      interval: 120,
      frames: [
        "\u258F",
        "\u258E",
        "\u258D",
        "\u258C",
        "\u258B",
        "\u258A",
        "\u2589",
        "\u258A",
        "\u258B",
        "\u258C",
        "\u258D",
        "\u258E"
      ]
    },
    balloon: {
      interval: 140,
      frames: [
        " ",
        ".",
        "o",
        "O",
        "@",
        "*",
        " "
      ]
    },
    balloon2: {
      interval: 120,
      frames: [
        ".",
        "o",
        "O",
        "\xB0",
        "O",
        "o",
        "."
      ]
    },
    noise: {
      interval: 100,
      frames: [
        "\u2593",
        "\u2592",
        "\u2591"
      ]
    },
    bounce: {
      interval: 120,
      frames: [
        "\u2801",
        "\u2802",
        "\u2804",
        "\u2802"
      ]
    },
    boxBounce: {
      interval: 120,
      frames: [
        "\u2596",
        "\u2598",
        "\u259D",
        "\u2597"
      ]
    },
    boxBounce2: {
      interval: 100,
      frames: [
        "\u258C",
        "\u2580",
        "\u2590",
        "\u2584"
      ]
    },
    triangle: {
      interval: 50,
      frames: [
        "\u25E2",
        "\u25E3",
        "\u25E4",
        "\u25E5"
      ]
    },
    binary: {
      interval: 80,
      frames: [
        "010010",
        "001100",
        "100101",
        "111010",
        "111101",
        "010111",
        "101011",
        "111000",
        "110011",
        "110101"
      ]
    },
    arc: {
      interval: 100,
      frames: [
        "\u25DC",
        "\u25E0",
        "\u25DD",
        "\u25DE",
        "\u25E1",
        "\u25DF"
      ]
    },
    circle: {
      interval: 120,
      frames: [
        "\u25E1",
        "\u2299",
        "\u25E0"
      ]
    },
    squareCorners: {
      interval: 180,
      frames: [
        "\u25F0",
        "\u25F3",
        "\u25F2",
        "\u25F1"
      ]
    },
    circleQuarters: {
      interval: 120,
      frames: [
        "\u25F4",
        "\u25F7",
        "\u25F6",
        "\u25F5"
      ]
    },
    circleHalves: {
      interval: 50,
      frames: [
        "\u25D0",
        "\u25D3",
        "\u25D1",
        "\u25D2"
      ]
    },
    squish: {
      interval: 100,
      frames: [
        "\u256B",
        "\u256A"
      ]
    },
    toggle: {
      interval: 250,
      frames: [
        "\u22B6",
        "\u22B7"
      ]
    },
    toggle2: {
      interval: 80,
      frames: [
        "\u25AB",
        "\u25AA"
      ]
    },
    toggle3: {
      interval: 120,
      frames: [
        "\u25A1",
        "\u25A0"
      ]
    },
    toggle4: {
      interval: 100,
      frames: [
        "\u25A0",
        "\u25A1",
        "\u25AA",
        "\u25AB"
      ]
    },
    toggle5: {
      interval: 100,
      frames: [
        "\u25AE",
        "\u25AF"
      ]
    },
    toggle6: {
      interval: 300,
      frames: [
        "\u101D",
        "\u1040"
      ]
    },
    toggle7: {
      interval: 80,
      frames: [
        "\u29BE",
        "\u29BF"
      ]
    },
    toggle8: {
      interval: 100,
      frames: [
        "\u25CD",
        "\u25CC"
      ]
    },
    toggle9: {
      interval: 100,
      frames: [
        "\u25C9",
        "\u25CE"
      ]
    },
    toggle10: {
      interval: 100,
      frames: [
        "\u3282",
        "\u3280",
        "\u3281"
      ]
    },
    toggle11: {
      interval: 50,
      frames: [
        "\u29C7",
        "\u29C6"
      ]
    },
    toggle12: {
      interval: 120,
      frames: [
        "\u2617",
        "\u2616"
      ]
    },
    toggle13: {
      interval: 80,
      frames: [
        "=",
        "*",
        "-"
      ]
    },
    arrow: {
      interval: 100,
      frames: [
        "\u2190",
        "\u2196",
        "\u2191",
        "\u2197",
        "\u2192",
        "\u2198",
        "\u2193",
        "\u2199"
      ]
    },
    arrow2: {
      interval: 80,
      frames: [
        "\u2B06\uFE0F ",
        "\u2197\uFE0F ",
        "\u27A1\uFE0F ",
        "\u2198\uFE0F ",
        "\u2B07\uFE0F ",
        "\u2199\uFE0F ",
        "\u2B05\uFE0F ",
        "\u2196\uFE0F "
      ]
    },
    arrow3: {
      interval: 120,
      frames: [
        "\u25B9\u25B9\u25B9\u25B9\u25B9",
        "\u25B8\u25B9\u25B9\u25B9\u25B9",
        "\u25B9\u25B8\u25B9\u25B9\u25B9",
        "\u25B9\u25B9\u25B8\u25B9\u25B9",
        "\u25B9\u25B9\u25B9\u25B8\u25B9",
        "\u25B9\u25B9\u25B9\u25B9\u25B8"
      ]
    },
    bouncingBar: {
      interval: 80,
      frames: [
        "[    ]",
        "[=   ]",
        "[==  ]",
        "[=== ]",
        "[====]",
        "[ ===]",
        "[  ==]",
        "[   =]",
        "[    ]",
        "[   =]",
        "[  ==]",
        "[ ===]",
        "[====]",
        "[=== ]",
        "[==  ]",
        "[=   ]"
      ]
    },
    bouncingBall: {
      interval: 80,
      frames: [
        "( \u25CF    )",
        "(  \u25CF   )",
        "(   \u25CF  )",
        "(    \u25CF )",
        "(     \u25CF)",
        "(    \u25CF )",
        "(   \u25CF  )",
        "(  \u25CF   )",
        "( \u25CF    )",
        "(\u25CF     )"
      ]
    },
    smiley: {
      interval: 200,
      frames: [
        "\uD83D\uDE04 ",
        "\uD83D\uDE1D "
      ]
    },
    monkey: {
      interval: 300,
      frames: [
        "\uD83D\uDE48 ",
        "\uD83D\uDE48 ",
        "\uD83D\uDE49 ",
        "\uD83D\uDE4A "
      ]
    },
    hearts: {
      interval: 100,
      frames: [
        "\uD83D\uDC9B ",
        "\uD83D\uDC99 ",
        "\uD83D\uDC9C ",
        "\uD83D\uDC9A ",
        "\u2764\uFE0F "
      ]
    },
    clock: {
      interval: 100,
      frames: [
        "\uD83D\uDD5B ",
        "\uD83D\uDD50 ",
        "\uD83D\uDD51 ",
        "\uD83D\uDD52 ",
        "\uD83D\uDD53 ",
        "\uD83D\uDD54 ",
        "\uD83D\uDD55 ",
        "\uD83D\uDD56 ",
        "\uD83D\uDD57 ",
        "\uD83D\uDD58 ",
        "\uD83D\uDD59 ",
        "\uD83D\uDD5A "
      ]
    },
    earth: {
      interval: 180,
      frames: [
        "\uD83C\uDF0D ",
        "\uD83C\uDF0E ",
        "\uD83C\uDF0F "
      ]
    },
    material: {
      interval: 17,
      frames: [
        "\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
        "\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581"
      ]
    },
    moon: {
      interval: 80,
      frames: [
        "\uD83C\uDF11 ",
        "\uD83C\uDF12 ",
        "\uD83C\uDF13 ",
        "\uD83C\uDF14 ",
        "\uD83C\uDF15 ",
        "\uD83C\uDF16 ",
        "\uD83C\uDF17 ",
        "\uD83C\uDF18 "
      ]
    },
    runner: {
      interval: 140,
      frames: [
        "\uD83D\uDEB6 ",
        "\uD83C\uDFC3 "
      ]
    },
    pong: {
      interval: 80,
      frames: [
        "\u2590\u2802       \u258C",
        "\u2590\u2808       \u258C",
        "\u2590 \u2802      \u258C",
        "\u2590 \u2820      \u258C",
        "\u2590  \u2840     \u258C",
        "\u2590  \u2820     \u258C",
        "\u2590   \u2802    \u258C",
        "\u2590   \u2808    \u258C",
        "\u2590    \u2802   \u258C",
        "\u2590    \u2820   \u258C",
        "\u2590     \u2840  \u258C",
        "\u2590     \u2820  \u258C",
        "\u2590      \u2802 \u258C",
        "\u2590      \u2808 \u258C",
        "\u2590       \u2802\u258C",
        "\u2590       \u2820\u258C",
        "\u2590       \u2840\u258C",
        "\u2590      \u2820 \u258C",
        "\u2590      \u2802 \u258C",
        "\u2590     \u2808  \u258C",
        "\u2590     \u2802  \u258C",
        "\u2590    \u2820   \u258C",
        "\u2590    \u2840   \u258C",
        "\u2590   \u2820    \u258C",
        "\u2590   \u2802    \u258C",
        "\u2590  \u2808     \u258C",
        "\u2590  \u2802     \u258C",
        "\u2590 \u2820      \u258C",
        "\u2590 \u2840      \u258C",
        "\u2590\u2820       \u258C"
      ]
    },
    shark: {
      interval: 120,
      frames: [
        "\u2590|\\____________\u258C",
        "\u2590_|\\___________\u258C",
        "\u2590__|\\__________\u258C",
        "\u2590___|\\_________\u258C",
        "\u2590____|\\________\u258C",
        "\u2590_____|\\_______\u258C",
        "\u2590______|\\______\u258C",
        "\u2590_______|\\_____\u258C",
        "\u2590________|\\____\u258C",
        "\u2590_________|\\___\u258C",
        "\u2590__________|\\__\u258C",
        "\u2590___________|\\_\u258C",
        "\u2590____________|\\\u258C",
        "\u2590____________/|\u258C",
        "\u2590___________/|_\u258C",
        "\u2590__________/|__\u258C",
        "\u2590_________/|___\u258C",
        "\u2590________/|____\u258C",
        "\u2590_______/|_____\u258C",
        "\u2590______/|______\u258C",
        "\u2590_____/|_______\u258C",
        "\u2590____/|________\u258C",
        "\u2590___/|_________\u258C",
        "\u2590__/|__________\u258C",
        "\u2590_/|___________\u258C",
        "\u2590/|____________\u258C"
      ]
    },
    dqpb: {
      interval: 100,
      frames: [
        "d",
        "q",
        "p",
        "b"
      ]
    },
    weather: {
      interval: 100,
      frames: [
        "\u2600\uFE0F ",
        "\u2600\uFE0F ",
        "\u2600\uFE0F ",
        "\uD83C\uDF24 ",
        "\u26C5\uFE0F ",
        "\uD83C\uDF25 ",
        "\u2601\uFE0F ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\u26C8 ",
        "\uD83C\uDF28 ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\u2601\uFE0F ",
        "\uD83C\uDF25 ",
        "\u26C5\uFE0F ",
        "\uD83C\uDF24 ",
        "\u2600\uFE0F ",
        "\u2600\uFE0F "
      ]
    },
    christmas: {
      interval: 400,
      frames: [
        "\uD83C\uDF32",
        "\uD83C\uDF84"
      ]
    },
    grenade: {
      interval: 80,
      frames: [
        "\u060C  ",
        "\u2032  ",
        " \xB4 ",
        " \u203E ",
        "  \u2E0C",
        "  \u2E0A",
        "  |",
        "  \u204E",
        "  \u2055",
        " \u0DF4 ",
        "  \u2053",
        "   ",
        "   ",
        "   "
      ]
    },
    point: {
      interval: 125,
      frames: [
        "\u2219\u2219\u2219",
        "\u25CF\u2219\u2219",
        "\u2219\u25CF\u2219",
        "\u2219\u2219\u25CF",
        "\u2219\u2219\u2219"
      ]
    },
    layer: {
      interval: 150,
      frames: [
        "-",
        "=",
        "\u2261"
      ]
    },
    betaWave: {
      interval: 80,
      frames: [
        "\u03C1\u03B2\u03B2\u03B2\u03B2\u03B2\u03B2",
        "\u03B2\u03C1\u03B2\u03B2\u03B2\u03B2\u03B2",
        "\u03B2\u03B2\u03C1\u03B2\u03B2\u03B2\u03B2",
        "\u03B2\u03B2\u03B2\u03C1\u03B2\u03B2\u03B2",
        "\u03B2\u03B2\u03B2\u03B2\u03C1\u03B2\u03B2",
        "\u03B2\u03B2\u03B2\u03B2\u03B2\u03C1\u03B2",
        "\u03B2\u03B2\u03B2\u03B2\u03B2\u03B2\u03C1"
      ]
    },
    fingerDance: {
      interval: 160,
      frames: [
        "\uD83E\uDD18 ",
        "\uD83E\uDD1F ",
        "\uD83D\uDD96 ",
        "\u270B ",
        "\uD83E\uDD1A ",
        "\uD83D\uDC46 "
      ]
    },
    fistBump: {
      interval: 80,
      frames: [
        "\uD83E\uDD1C\u3000\u3000\u3000\u3000\uD83E\uDD1B ",
        "\uD83E\uDD1C\u3000\u3000\u3000\u3000\uD83E\uDD1B ",
        "\uD83E\uDD1C\u3000\u3000\u3000\u3000\uD83E\uDD1B ",
        "\u3000\uD83E\uDD1C\u3000\u3000\uD83E\uDD1B\u3000 ",
        "\u3000\u3000\uD83E\uDD1C\uD83E\uDD1B\u3000\u3000 ",
        "\u3000\uD83E\uDD1C\u2728\uD83E\uDD1B\u3000\u3000 ",
        "\uD83E\uDD1C\u3000\u2728\u3000\uD83E\uDD1B\u3000 "
      ]
    },
    soccerHeader: {
      interval: 80,
      frames: [
        " \uD83E\uDDD1\u26BD\uFE0F       \uD83E\uDDD1 ",
        "\uD83E\uDDD1  \u26BD\uFE0F      \uD83E\uDDD1 ",
        "\uD83E\uDDD1   \u26BD\uFE0F     \uD83E\uDDD1 ",
        "\uD83E\uDDD1    \u26BD\uFE0F    \uD83E\uDDD1 ",
        "\uD83E\uDDD1     \u26BD\uFE0F   \uD83E\uDDD1 ",
        "\uD83E\uDDD1      \u26BD\uFE0F  \uD83E\uDDD1 ",
        "\uD83E\uDDD1       \u26BD\uFE0F\uD83E\uDDD1  ",
        "\uD83E\uDDD1      \u26BD\uFE0F  \uD83E\uDDD1 ",
        "\uD83E\uDDD1     \u26BD\uFE0F   \uD83E\uDDD1 ",
        "\uD83E\uDDD1    \u26BD\uFE0F    \uD83E\uDDD1 ",
        "\uD83E\uDDD1   \u26BD\uFE0F     \uD83E\uDDD1 ",
        "\uD83E\uDDD1  \u26BD\uFE0F      \uD83E\uDDD1 "
      ]
    },
    mindblown: {
      interval: 160,
      frames: [
        "\uD83D\uDE10 ",
        "\uD83D\uDE10 ",
        "\uD83D\uDE2E ",
        "\uD83D\uDE2E ",
        "\uD83D\uDE26 ",
        "\uD83D\uDE26 ",
        "\uD83D\uDE27 ",
        "\uD83D\uDE27 ",
        "\uD83E\uDD2F ",
        "\uD83D\uDCA5 ",
        "\u2728 ",
        "\u3000 ",
        "\u3000 ",
        "\u3000 "
      ]
    },
    speaker: {
      interval: 160,
      frames: [
        "\uD83D\uDD08 ",
        "\uD83D\uDD09 ",
        "\uD83D\uDD0A ",
        "\uD83D\uDD09 "
      ]
    },
    orangePulse: {
      interval: 100,
      frames: [
        "\uD83D\uDD38 ",
        "\uD83D\uDD36 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDD36 "
      ]
    },
    bluePulse: {
      interval: 100,
      frames: [
        "\uD83D\uDD39 ",
        "\uD83D\uDD37 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD37 "
      ]
    },
    orangeBluePulse: {
      interval: 100,
      frames: [
        "\uD83D\uDD38 ",
        "\uD83D\uDD36 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDD36 ",
        "\uD83D\uDD39 ",
        "\uD83D\uDD37 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD37 "
      ]
    },
    timeTravel: {
      interval: 100,
      frames: [
        "\uD83D\uDD5B ",
        "\uD83D\uDD5A ",
        "\uD83D\uDD59 ",
        "\uD83D\uDD58 ",
        "\uD83D\uDD57 ",
        "\uD83D\uDD56 ",
        "\uD83D\uDD55 ",
        "\uD83D\uDD54 ",
        "\uD83D\uDD53 ",
        "\uD83D\uDD52 ",
        "\uD83D\uDD51 ",
        "\uD83D\uDD50 "
      ]
    },
    aesthetic: {
      interval: 80,
      frames: [
        "\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B1\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0",
        "\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1\u25B1"
      ]
    },
    dwarfFortress: {
      interval: 80,
      frames: [
        " \u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2593\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2593\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2592\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2592\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2591\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2591\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A \u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2593\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2593\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2592\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2592\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2591\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2591\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A \u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2593\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2593\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2592\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2592\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2591\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2591\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A \u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2593\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2593\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2592\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2592\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2591\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2591\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A \u2588\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2588\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2588\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2593\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2593\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2592\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2592\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2591\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2591\u2588\xA3\xA3\xA3  ",
        "    \u263A \u2588\xA3\xA3\xA3  ",
        "     \u263A\u2588\xA3\xA3\xA3  ",
        "     \u263A\u2588\xA3\xA3\xA3  ",
        "     \u263A\u2593\xA3\xA3\xA3  ",
        "     \u263A\u2593\xA3\xA3\xA3  ",
        "     \u263A\u2592\xA3\xA3\xA3  ",
        "     \u263A\u2592\xA3\xA3\xA3  ",
        "     \u263A\u2591\xA3\xA3\xA3  ",
        "     \u263A\u2591\xA3\xA3\xA3  ",
        "     \u263A \xA3\xA3\xA3  ",
        "      \u263A\xA3\xA3\xA3  ",
        "      \u263A\xA3\xA3\xA3  ",
        "      \u263A\u2593\xA3\xA3  ",
        "      \u263A\u2593\xA3\xA3  ",
        "      \u263A\u2592\xA3\xA3  ",
        "      \u263A\u2592\xA3\xA3  ",
        "      \u263A\u2591\xA3\xA3  ",
        "      \u263A\u2591\xA3\xA3  ",
        "      \u263A \xA3\xA3  ",
        "       \u263A\xA3\xA3  ",
        "       \u263A\xA3\xA3  ",
        "       \u263A\u2593\xA3  ",
        "       \u263A\u2593\xA3  ",
        "       \u263A\u2592\xA3  ",
        "       \u263A\u2592\xA3  ",
        "       \u263A\u2591\xA3  ",
        "       \u263A\u2591\xA3  ",
        "       \u263A \xA3  ",
        "        \u263A\xA3  ",
        "        \u263A\xA3  ",
        "        \u263A\u2593  ",
        "        \u263A\u2593  ",
        "        \u263A\u2592  ",
        "        \u263A\u2592  ",
        "        \u263A\u2591  ",
        "        \u263A\u2591  ",
        "        \u263A   ",
        "        \u263A  &",
        "        \u263A \u263C&",
        "       \u263A \u263C &",
        "       \u263A\u263C  &",
        "      \u263A\u263C  & ",
        "      \u203C   & ",
        "     \u263A   &  ",
        "    \u203C    &  ",
        "   \u263A    &   ",
        "  \u203C     &   ",
        " \u263A     &    ",
        "\u203C      &    ",
        "      &     ",
        "      &     ",
        "     &   \u2591  ",
        "     &   \u2592  ",
        "    &    \u2593  ",
        "    &    \xA3  ",
        "   &    \u2591\xA3  ",
        "   &    \u2592\xA3  ",
        "  &     \u2593\xA3  ",
        "  &     \xA3\xA3  ",
        " &     \u2591\xA3\xA3  ",
        " &     \u2592\xA3\xA3  ",
        "&      \u2593\xA3\xA3  ",
        "&      \xA3\xA3\xA3  ",
        "      \u2591\xA3\xA3\xA3  ",
        "      \u2592\xA3\xA3\xA3  ",
        "      \u2593\xA3\xA3\xA3  ",
        "      \u2588\xA3\xA3\xA3  ",
        "     \u2591\u2588\xA3\xA3\xA3  ",
        "     \u2592\u2588\xA3\xA3\xA3  ",
        "     \u2593\u2588\xA3\xA3\xA3  ",
        "     \u2588\u2588\xA3\xA3\xA3  ",
        "    \u2591\u2588\u2588\xA3\xA3\xA3  ",
        "    \u2592\u2588\u2588\xA3\xA3\xA3  ",
        "    \u2593\u2588\u2588\xA3\xA3\xA3  ",
        "    \u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2591\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2592\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2593\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2591\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2592\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2593\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2591\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2592\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2593\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  "
      ]
    }
  };
});
var require_cli_spinners = __commonJS((exports, module) => {
  var spinners = Object.assign({}, require_spinners());
  var spinnersList = Object.keys(spinners);
  Object.defineProperty(spinners, "random", {
    get() {
      const randomIndex = Math.floor(Math.random() * spinnersList.length);
      const spinnerName = spinnersList[randomIndex];
      return spinners[spinnerName];
    }
  });
  module.exports = spinners;
});
var require2 = __tinyexec_cr(import.meta.url);
var St = Object.create;
var $ = Object.defineProperty;
var kt = Object.getOwnPropertyDescriptor;
var Tt = Object.getOwnPropertyNames;
var At = Object.getPrototypeOf;
var Rt = Object.prototype.hasOwnProperty;
var h = /* @__PURE__ */ ((t) => typeof require2 < "u" ? require2 : typeof Proxy < "u" ? new Proxy(t, {
  get: (e, n) => (typeof require2 < "u" ? require2 : e)[n]
}) : t)(function(t) {
  if (typeof require2 < "u")
    return require2.apply(this, arguments);
  throw Error('Dynamic require of "' + t + '" is not supported');
});
var l = (t, e) => () => (e || t((e = { exports: {} }).exports, e), e.exports);
var $t = (t, e, n, r2) => {
  if (e && typeof e == "object" || typeof e == "function")
    for (let s3 of Tt(e))
      !Rt.call(t, s3) && s3 !== n && $(t, s3, { get: () => e[s3], enumerable: !(r2 = kt(e, s3)) || r2.enumerable });
  return t;
};
var Nt = (t, e, n) => (n = t != null ? St(At(t)) : {}, $t(e || !t || !t.__esModule ? $(n, "default", { value: t, enumerable: true }) : n, t));
var W = l((Se, H2) => {
  H2.exports = z2;
  z2.sync = Wt;
  var j2 = h("fs");
  function Ht(t, e) {
    var n = e.pathExt !== undefined ? e.pathExt : process.env.PATHEXT;
    if (!n || (n = n.split(";"), n.indexOf("") !== -1))
      return true;
    for (var r2 = 0;r2 < n.length; r2++) {
      var s3 = n[r2].toLowerCase();
      if (s3 && t.substr(-s3.length).toLowerCase() === s3)
        return true;
    }
    return false;
  }
  function F(t, e, n) {
    return !t.isSymbolicLink() && !t.isFile() ? false : Ht(e, n);
  }
  function z2(t, e, n) {
    j2.stat(t, function(r2, s3) {
      n(r2, r2 ? false : F(s3, t, e));
    });
  }
  function Wt(t, e) {
    return F(j2.statSync(t), t, e);
  }
});
var X = l((ke, B) => {
  B.exports = K2;
  K2.sync = Dt;
  var D = h("fs");
  function K2(t, e, n) {
    D.stat(t, function(r2, s3) {
      n(r2, r2 ? false : M2(s3, e));
    });
  }
  function Dt(t, e) {
    return M2(D.statSync(t), e);
  }
  function M2(t, e) {
    return t.isFile() && Kt(t, e);
  }
  function Kt(t, e) {
    var { mode: n, uid: r2, gid: s3 } = t, o = e.uid !== undefined ? e.uid : process.getuid && process.getuid(), i = e.gid !== undefined ? e.gid : process.getgid && process.getgid(), a = parseInt("100", 8), c2 = parseInt("010", 8), u = parseInt("001", 8), f2 = a | c2, p3 = n & u || n & c2 && s3 === i || n & a && r2 === o || n & f2 && o === 0;
    return p3;
  }
});
var U = l((Ae, G2) => {
  var Te = h("fs"), v2;
  process.platform === "win32" || global.TESTING_WINDOWS ? v2 = W() : v2 = X();
  G2.exports = y;
  y.sync = Mt;
  function y(t, e, n) {
    if (typeof e == "function" && (n = e, e = {}), !n) {
      if (typeof Promise != "function")
        throw new TypeError("callback not provided");
      return new Promise(function(r2, s3) {
        y(t, e || {}, function(o, i) {
          o ? s3(o) : r2(i);
        });
      });
    }
    v2(t, e || {}, function(r2, s3) {
      r2 && (r2.code === "EACCES" || e && e.ignoreErrors) && (r2 = null, s3 = false), n(r2, s3);
    });
  }
  function Mt(t, e) {
    try {
      return v2.sync(t, e || {});
    } catch (n) {
      if (e && e.ignoreErrors || n.code === "EACCES")
        return false;
      throw n;
    }
  }
});
var et = l((Re, tt) => {
  var g2 = process.platform === "win32" || process.env.OSTYPE === "cygwin" || process.env.OSTYPE === "msys", Y2 = h("path"), Bt = g2 ? ";" : ":", V2 = U(), J2 = (t) => Object.assign(new Error(`not found: ${t}`), { code: "ENOENT" }), Q2 = (t, e) => {
    let n = e.colon || Bt, r2 = t.match(/\//) || g2 && t.match(/\\/) ? [""] : [
      ...g2 ? [process.cwd()] : [],
      ...(e.path || "/Users/chrisbreuer/Code/stacks/storage/framework/core/cli/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/framework/core/cli/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/framework/core/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/framework/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/node_modules/.bin:/Users/chrisbreuer/Code/stacks/node_modules/.bin:/Users/chrisbreuer/Code/node_modules/.bin:/Users/chrisbreuer/node_modules/.bin:/Users/node_modules/.bin:/node_modules/.bin:/Users/chrisbreuer/.bun/bin:/Users/chrisbreuer/.pkgx/libpng.org/v1.6.43/bin:/Users/chrisbreuer/.pkgx/freedesktop.org/pkg-config/v0.29.2/bin:/Users/chrisbreuer/.pkgx/sourceware.org/bzip2/v1.0.8/bin:/Users/chrisbreuer/.pkgx/libexpat.github.io/v2.6.2/bin:/Users/chrisbreuer/.pkgx/tukaani.org/xz/v5.6.1/bin:/Users/chrisbreuer/.pkgx/sqlite.org/v3.45.2/bin:/Users/chrisbreuer/.pkgx/gnu.org/readline/v8.2.0/bin:/Users/chrisbreuer/.pkgx/invisible-island.net/ncurses/v6.4.0/bin:/Users/chrisbreuer/.pkgx/tcl-lang.org/v8.6.14/bin:/Users/chrisbreuer/.pkgx/gnome.org/libxml2/v2.12.6/bin:/Users/chrisbreuer/.pkgx/pkgx.sh/v1.1.6/bin:/Users/chrisbreuer/.pkgx/openssl.org/v1.1.1w/bin:/Users/chrisbreuer/.pkgx/python.org/v3.11.9/bin:/Users/chrisbreuer/.pkgx/gnu.org/gettext/v0.21.1/bin:/Users/chrisbreuer/.pkgx/curl.se/v8.6.0/bin:/Users/chrisbreuer/.pkgx/perl.org/v5.38.2/bin:/Users/chrisbreuer/.pkgx/aws.amazon.com/cli/v2.17.13/bin:/Users/chrisbreuer/.pkgx/bun.sh/v1.1.33/bin:/Users/chrisbreuer/.pkgx/dns.lookup.dog/v0.1.0/bin:/Users/chrisbreuer/.pkgx/httpie.io/v3.2.2/bin:/Users/chrisbreuer/.pkgx/info-zip.org/zip/v3.0.0/bin:/Users/chrisbreuer/.pkgx/info-zip.org/unzip/v6.0.0/bin:/Users/chrisbreuer/.pkgx/mailpit.axllent.org/v1.15.0/bin:/Users/chrisbreuer/.pkgx/redis.io/v7.4.0/bin:/Users/chrisbreuer/.pkgx/git-scm.org/v2.44.0/bin:.:node_modules/.bin:vendor/bin:/opt/homebrew/bin:/Users/chrisbreuer/.composer/vendor/bin:/Users/chrisbreuer/.dotfiles/bin:/opt/homebrew/bin:/opt/homebrew/sbin:/usr/local/bin:/System/Cryptexes/App/usr/bin:/usr/bin:/bin:/usr/sbin:/sbin:/var/run/com.apple.security.cryptexd/codex.system/bootstrap/usr/local/bin:/var/run/com.apple.security.cryptexd/codex.system/bootstrap/usr/bin:/var/run/com.apple.security.cryptexd/codex.system/bootstrap/usr/appleinternal/bin:/usr/local/share/cputil-osx-x64_v112/cputil-osx-x64:/Users/chrisbreuer/.bun/bin:.:node_modules/.bin:vendor/bin:/Users/chrisbreuer/.composer/vendor/bin:/Users/chrisbreuer/.dotfiles/bin:/Users/chrisbreuer/.local/bin:/Users/chrisbreuer/Library/Application Support/JetBrains/Toolbox/scripts:/Users/chrisbreuer/Library/Application Support/JetBrains/Toolbox/scripts").split(n)
    ], s3 = g2 ? e.pathExt || process.env.PATHEXT || ".EXE;.CMD;.BAT;.COM" : "", o = g2 ? s3.split(n) : [""];
    return g2 && t.indexOf(".") !== -1 && o[0] !== "" && o.unshift(""), {
      pathEnv: r2,
      pathExt: o,
      pathExtExe: s3
    };
  }, Z2 = (t, e, n) => {
    typeof e == "function" && (n = e, e = {}), e || (e = {});
    let { pathEnv: r2, pathExt: s3, pathExtExe: o } = Q2(t, e), i = [], a = (u) => new Promise((f2, p3) => {
      if (u === r2.length)
        return e.all && i.length ? f2(i) : p3(J2(t));
      let d = r2[u], w2 = /^".*"$/.test(d) ? d.slice(1, -1) : d, m2 = Y2.join(w2, t), b2 = !w2 && /^\.[\\\/]/.test(t) ? t.slice(0, 2) + m2 : m2;
      f2(c2(b2, u, 0));
    }), c2 = (u, f2, p3) => new Promise((d, w2) => {
      if (p3 === s3.length)
        return d(a(f2 + 1));
      let m2 = s3[p3];
      V2(u + m2, { pathExt: o }, (b2, Ot) => {
        if (!b2 && Ot)
          if (e.all)
            i.push(u + m2);
          else
            return d(u + m2);
        return d(c2(u, f2, p3 + 1));
      });
    });
    return n ? a(0).then((u) => n(null, u), n) : a(0);
  }, Xt = (t, e) => {
    e = e || {};
    let { pathEnv: n, pathExt: r2, pathExtExe: s3 } = Q2(t, e), o = [];
    for (let i = 0;i < n.length; i++) {
      let a = n[i], c2 = /^".*"$/.test(a) ? a.slice(1, -1) : a, u = Y2.join(c2, t), f2 = !c2 && /^\.[\\\/]/.test(t) ? t.slice(0, 2) + u : u;
      for (let p3 = 0;p3 < r2.length; p3++) {
        let d = f2 + r2[p3];
        try {
          if (V2.sync(d, { pathExt: s3 }))
            if (e.all)
              o.push(d);
            else
              return d;
        } catch {
        }
      }
    }
    if (e.all && o.length)
      return o;
    if (e.nothrow)
      return null;
    throw J2(t);
  };
  tt.exports = Z2;
  Z2.sync = Xt;
});
var rt = l(($e, _2) => {
  var nt = (t = {}) => {
    let e = t.env || process.env;
    return (t.platform || process.platform) !== "win32" ? "PATH" : Object.keys(e).reverse().find((r2) => r2.toUpperCase() === "PATH") || "Path";
  };
  _2.exports = nt;
  _2.exports.default = nt;
});
var ct = l((Ne, it) => {
  var st = h("path"), Gt = et(), Ut = rt();
  function ot(t, e) {
    let n = t.options.env || process.env, r2 = process.cwd(), s3 = t.options.cwd != null, o = s3 && process.chdir !== undefined && !process.chdir.disabled;
    if (o)
      try {
        process.chdir(t.options.cwd);
      } catch {
      }
    let i;
    try {
      i = Gt.sync(t.command, {
        path: n[Ut({ env: n })],
        pathExt: e ? st.delimiter : undefined
      });
    } catch {
    } finally {
      o && process.chdir(r2);
    }
    return i && (i = st.resolve(s3 ? t.options.cwd : "", i)), i;
  }
  function Yt(t) {
    return ot(t) || ot(t, true);
  }
  it.exports = Yt;
});
var ut = l((qe, P2) => {
  var C = /([()\][%!^"`<>&|;, *?])/g;
  function Vt(t) {
    return t = t.replace(C, "^$1"), t;
  }
  function Jt(t, e) {
    return t = `${t}`, t = t.replace(/(\\*)"/g, '$1$1\\"'), t = t.replace(/(\\*)$/, "$1$1"), t = `"${t}"`, t = t.replace(C, "^$1"), e && (t = t.replace(C, "^$1")), t;
  }
  P2.exports.command = Vt;
  P2.exports.argument = Jt;
});
var lt = l((Ie, at) => {
  at.exports = /^#!(.*)/;
});
var dt = l((Le, pt) => {
  var Qt = lt();
  pt.exports = (t = "") => {
    let e = t.match(Qt);
    if (!e)
      return null;
    let [n, r2] = e[0].replace(/#! ?/, "").split(" "), s3 = n.split("/").pop();
    return s3 === "env" ? r2 : r2 ? `${s3} ${r2}` : s3;
  };
});
var ht = l((je, ft) => {
  var O = h("fs"), Zt = dt();
  function te(t) {
    let n = Buffer.alloc(150), r2;
    try {
      r2 = O.openSync(t, "r"), O.readSync(r2, n, 0, 150, 0), O.closeSync(r2);
    } catch {
    }
    return Zt(n.toString());
  }
  ft.exports = te;
});
var wt = l((Fe, Et) => {
  var ee = h("path"), mt = ct(), gt = ut(), ne = ht(), re = process.platform === "win32", se = /\.(?:com|exe)$/i, oe = /node_modules[\\/].bin[\\/][^\\/]+\.cmd$/i;
  function ie(t) {
    t.file = mt(t);
    let e = t.file && ne(t.file);
    return e ? (t.args.unshift(t.file), t.command = e, mt(t)) : t.file;
  }
  function ce(t) {
    if (!re)
      return t;
    let e = ie(t), n = !se.test(e);
    if (t.options.forceShell || n) {
      let r2 = oe.test(e);
      t.command = ee.normalize(t.command), t.command = gt.command(t.command), t.args = t.args.map((o) => gt.argument(o, r2));
      let s3 = [t.command].concat(t.args).join(" ");
      t.args = ["/d", "/s", "/c", `"${s3}"`], t.command = process.env.comspec || "cmd.exe", t.options.windowsVerbatimArguments = true;
    }
    return t;
  }
  function ue(t, e, n) {
    e && !Array.isArray(e) && (n = e, e = null), e = e ? e.slice(0) : [], n = Object.assign({}, n);
    let r2 = {
      command: t,
      args: e,
      options: n,
      file: undefined,
      original: {
        command: t,
        args: e
      }
    };
    return n.shell ? r2 : ce(r2);
  }
  Et.exports = ue;
});
var bt = l((ze, vt) => {
  var S = process.platform === "win32";
  function k(t, e) {
    return Object.assign(new Error(`${e} ${t.command} ENOENT`), {
      code: "ENOENT",
      errno: "ENOENT",
      syscall: `${e} ${t.command}`,
      path: t.command,
      spawnargs: t.args
    });
  }
  function ae(t, e) {
    if (!S)
      return;
    let n = t.emit;
    t.emit = function(r2, s3) {
      if (r2 === "exit") {
        let o = xt(s3, e, "spawn");
        if (o)
          return n.call(t, "error", o);
      }
      return n.apply(t, arguments);
    };
  }
  function xt(t, e) {
    return S && t === 1 && !e.file ? k(e.original, "spawn") : null;
  }
  function le(t, e) {
    return S && t === 1 && !e.file ? k(e.original, "spawnSync") : null;
  }
  vt.exports = {
    hookChildProcess: ae,
    verifyENOENT: xt,
    verifyENOENTSync: le,
    notFoundError: k
  };
});
var Ct = l((He, E) => {
  var yt = h("child_process"), T2 = wt(), A = bt();
  function _t(t, e, n) {
    let r2 = T2(t, e, n), s3 = yt.spawn(r2.command, r2.args, r2.options);
    return A.hookChildProcess(s3, r2), s3;
  }
  function pe(t, e, n) {
    let r2 = T2(t, e, n), s3 = yt.spawnSync(r2.command, r2.args, r2.options);
    return s3.error = s3.error || A.verifyENOENTSync(s3.status, r2), s3;
  }
  E.exports = _t;
  E.exports.spawn = _t;
  E.exports.sync = pe;
  E.exports._parse = T2;
  E.exports._enoent = A;
});
var Pt = Nt(Ct(), 1);
function toArr(any) {
  return any == null ? [] : Array.isArray(any) ? any : [any];
}
function toVal(out, key, val2, opts) {
  var x2, old = out[key], nxt = ~opts.string.indexOf(key) ? val2 == null || val2 === true ? "" : String(val2) : typeof val2 === "boolean" ? val2 : ~opts.boolean.indexOf(key) ? val2 === "false" ? false : val2 === "true" || (out._.push((x2 = +val2, x2 * 0 === 0) ? x2 : val2), !!val2) : (x2 = +val2, x2 * 0 === 0) ? x2 : val2;
  out[key] = old == null ? nxt : Array.isArray(old) ? old.concat(nxt) : [old, nxt];
}
function mri2(args, opts) {
  args = args || [];
  opts = opts || {};
  var k, arr, arg, name, val2, out = { _: [] };
  var i = 0, j2 = 0, idx = 0, len = args.length;
  const alibi = opts.alias !== undefined;
  const strict = opts.unknown !== undefined;
  const defaults = opts.default !== undefined;
  opts.alias = opts.alias || {};
  opts.string = toArr(opts.string);
  opts.boolean = toArr(opts.boolean);
  if (alibi) {
    for (k in opts.alias) {
      arr = opts.alias[k] = toArr(opts.alias[k]);
      for (i = 0;i < arr.length; i++) {
        (opts.alias[arr[i]] = arr.concat(k)).splice(i, 1);
      }
    }
  }
  for (i = opts.boolean.length;i-- > 0; ) {
    arr = opts.alias[opts.boolean[i]] || [];
    for (j2 = arr.length;j2-- > 0; )
      opts.boolean.push(arr[j2]);
  }
  for (i = opts.string.length;i-- > 0; ) {
    arr = opts.alias[opts.string[i]] || [];
    for (j2 = arr.length;j2-- > 0; )
      opts.string.push(arr[j2]);
  }
  if (defaults) {
    for (k in opts.default) {
      name = typeof opts.default[k];
      arr = opts.alias[k] = opts.alias[k] || [];
      if (opts[name] !== undefined) {
        opts[name].push(k);
        for (i = 0;i < arr.length; i++) {
          opts[name].push(arr[i]);
        }
      }
    }
  }
  const keys = strict ? Object.keys(opts.alias) : [];
  for (i = 0;i < len; i++) {
    arg = args[i];
    if (arg === "--") {
      out._ = out._.concat(args.slice(++i));
      break;
    }
    for (j2 = 0;j2 < arg.length; j2++) {
      if (arg.charCodeAt(j2) !== 45)
        break;
    }
    if (j2 === 0) {
      out._.push(arg);
    } else if (arg.substring(j2, j2 + 3) === "no-") {
      name = arg.substring(j2 + 3);
      if (strict && !~keys.indexOf(name)) {
        return opts.unknown(arg);
      }
      out[name] = false;
    } else {
      for (idx = j2 + 1;idx < arg.length; idx++) {
        if (arg.charCodeAt(idx) === 61)
          break;
      }
      name = arg.substring(j2, idx);
      val2 = arg.substring(++idx) || (i + 1 === len || ("" + args[i + 1]).charCodeAt(0) === 45 || args[++i]);
      arr = j2 === 2 ? [name] : name;
      for (idx = 0;idx < arr.length; idx++) {
        name = arr[idx];
        if (strict && !~keys.indexOf(name))
          return opts.unknown("-".repeat(j2) + name);
        toVal(out, name, idx + 1 < arr.length || val2, opts);
      }
    }
  }
  if (defaults) {
    for (k in opts.default) {
      if (out[k] === undefined) {
        out[k] = opts.default[k];
      }
    }
  }
  if (alibi) {
    for (k in out) {
      arr = opts.alias[k] || [];
      while (arr.length > 0) {
        out[arr.shift()] = out[k];
      }
    }
  }
  return out;
}
var removeBrackets = (v2) => v2.replace(/[<[].+/, "").trim();
var findAllBrackets = (v2) => {
  const ANGLED_BRACKET_RE_GLOBAL = /<([^>]+)>/g;
  const SQUARE_BRACKET_RE_GLOBAL = /\[([^\]]+)\]/g;
  const res = [];
  const parse2 = (match) => {
    let variadic = false;
    let value = match[1];
    if (value.startsWith("...")) {
      value = value.slice(3);
      variadic = true;
    }
    return {
      required: match[0].startsWith("<"),
      value,
      variadic
    };
  };
  let angledMatch;
  while (angledMatch = ANGLED_BRACKET_RE_GLOBAL.exec(v2)) {
    res.push(parse2(angledMatch));
  }
  let squareMatch;
  while (squareMatch = SQUARE_BRACKET_RE_GLOBAL.exec(v2)) {
    res.push(parse2(squareMatch));
  }
  return res;
};
var getMriOptions = (options2) => {
  const result2 = { alias: {}, boolean: [] };
  for (const [index, option] of options2.entries()) {
    if (option.names.length > 1) {
      result2.alias[option.names[0]] = option.names.slice(1);
    }
    if (option.isBoolean) {
      if (option.negated) {
        const hasStringTypeOption = options2.some((o, i) => {
          return i !== index && o.names.some((name) => option.names.includes(name)) && typeof o.required === "boolean";
        });
        if (!hasStringTypeOption) {
          result2.boolean.push(option.names[0]);
        }
      } else {
        result2.boolean.push(option.names[0]);
      }
    }
  }
  return result2;
};
var findLongest = (arr) => {
  return arr.sort((a, b2) => {
    return a.length > b2.length ? -1 : 1;
  })[0];
};
var padRight = (str, length) => {
  return str.length >= length ? str : `${str}${" ".repeat(length - str.length)}`;
};
var camelcase = (input) => {
  return input.replace(/([a-z])-([a-z])/g, (_2, p1, p22) => {
    return p1 + p22.toUpperCase();
  });
};
var setDotProp = (obj, keys, val2) => {
  let i = 0;
  let length = keys.length;
  let t = obj;
  let x2;
  for (;i < length; ++i) {
    x2 = t[keys[i]];
    t = t[keys[i]] = i === length - 1 ? val2 : x2 != null ? x2 : !!~keys[i + 1].indexOf(".") || !(+keys[i + 1] > -1) ? {} : [];
  }
};
var setByType = (obj, transforms) => {
  for (const key of Object.keys(transforms)) {
    const transform = transforms[key];
    if (transform.shouldTransform) {
      obj[key] = Array.prototype.concat.call([], obj[key]);
      if (typeof transform.transformFunction === "function") {
        obj[key] = obj[key].map(transform.transformFunction);
      }
    }
  }
};
var getFileName = (input) => {
  const m2 = /([^\\\/]+)$/.exec(input);
  return m2 ? m2[1] : "";
};
var camelcaseOptionName = (name) => {
  return name.split(".").map((v2, i) => {
    return i === 0 ? camelcase(v2) : v2;
  }).join(".");
};

class CACError extends Error {
  constructor(message) {
    super(message);
    this.name = this.constructor.name;
    if (typeof Error.captureStackTrace === "function") {
      Error.captureStackTrace(this, this.constructor);
    } else {
      this.stack = new Error(message).stack;
    }
  }
}

class Option {
  constructor(rawName, description, config) {
    this.rawName = rawName;
    this.description = description;
    this.config = Object.assign({}, config);
    rawName = rawName.replace(/\.\*/g, "");
    this.negated = false;
    this.names = removeBrackets(rawName).split(",").map((v2) => {
      let name = v2.trim().replace(/^-{1,2}/, "");
      if (name.startsWith("no-")) {
        this.negated = true;
        name = name.replace(/^no-/, "");
      }
      return camelcaseOptionName(name);
    }).sort((a, b2) => a.length > b2.length ? 1 : -1);
    this.name = this.names[this.names.length - 1];
    if (this.negated && this.config.default == null) {
      this.config.default = true;
    }
    if (rawName.includes("<")) {
      this.required = true;
    } else if (rawName.includes("[")) {
      this.required = false;
    } else {
      this.isBoolean = true;
    }
  }
}
var processArgs = process.argv;
var platformInfo = `${process.platform}-${process.arch} node-${process.version}`;

class Command {
  constructor(rawName, description, config = {}, cli) {
    this.rawName = rawName;
    this.description = description;
    this.config = config;
    this.cli = cli;
    this.options = [];
    this.aliasNames = [];
    this.name = removeBrackets(rawName);
    this.args = findAllBrackets(rawName);
    this.examples = [];
  }
  usage(text2) {
    this.usageText = text2;
    return this;
  }
  allowUnknownOptions() {
    this.config.allowUnknownOptions = true;
    return this;
  }
  ignoreOptionDefaultValue() {
    this.config.ignoreOptionDefaultValue = true;
    return this;
  }
  version(version, customFlags = "-v, --version") {
    this.versionNumber = version;
    this.option(customFlags, "Display version number");
    return this;
  }
  example(example) {
    this.examples.push(example);
    return this;
  }
  option(rawName, description, config) {
    const option = new Option(rawName, description, config);
    this.options.push(option);
    return this;
  }
  alias(name) {
    this.aliasNames.push(name);
    return this;
  }
  action(callback) {
    this.commandAction = callback;
    return this;
  }
  isMatched(name) {
    return this.name === name || this.aliasNames.includes(name);
  }
  get isDefaultCommand() {
    return this.name === "" || this.aliasNames.includes("!");
  }
  get isGlobalCommand() {
    return this instanceof GlobalCommand;
  }
  hasOption(name) {
    name = name.split(".")[0];
    return this.options.find((option) => {
      return option.names.includes(name);
    });
  }
  outputHelp() {
    const { name, commands } = this.cli;
    const {
      versionNumber,
      options: globalOptions,
      helpCallback
    } = this.cli.globalCommand;
    let sections = [
      {
        body: `${name}${versionNumber ? `/${versionNumber}` : ""}`
      }
    ];
    sections.push({
      title: "Usage",
      body: `  $ ${name} ${this.usageText || this.rawName}`
    });
    const showCommands = (this.isGlobalCommand || this.isDefaultCommand) && commands.length > 0;
    if (showCommands) {
      const longestCommandName = findLongest(commands.map((command) => command.rawName));
      sections.push({
        title: "Commands",
        body: commands.map((command) => {
          return `  ${padRight(command.rawName, longestCommandName.length)}  ${command.description}`;
        }).join("\n")
      });
      sections.push({
        title: `For more info, run any command with the \`--help\` flag`,
        body: commands.map((command) => `  $ ${name}${command.name === "" ? "" : ` ${command.name}`} --help`).join("\n")
      });
    }
    let options2 = this.isGlobalCommand ? globalOptions : [...this.options, ...globalOptions || []];
    if (!this.isGlobalCommand && !this.isDefaultCommand) {
      options2 = options2.filter((option) => option.name !== "version");
    }
    if (options2.length > 0) {
      const longestOptionName = findLongest(options2.map((option) => option.rawName));
      sections.push({
        title: "Options",
        body: options2.map((option) => {
          return `  ${padRight(option.rawName, longestOptionName.length)}  ${option.description} ${option.config.default === undefined ? "" : `(default: ${option.config.default})`}`;
        }).join("\n")
      });
    }
    if (this.examples.length > 0) {
      sections.push({
        title: "Examples",
        body: this.examples.map((example) => {
          if (typeof example === "function") {
            return example(name);
          }
          return example;
        }).join("\n")
      });
    }
    if (helpCallback) {
      sections = helpCallback(sections) || sections;
    }
    console.log(sections.map((section) => {
      return section.title ? `${section.title}:
${section.body}` : section.body;
    }).join("\n\n"));
  }
  outputVersion() {
    const { name } = this.cli;
    const { versionNumber } = this.cli.globalCommand;
    if (versionNumber) {
      console.log(`${name}/${versionNumber} ${platformInfo}`);
    }
  }
  checkRequiredArgs() {
    const minimalArgsCount = this.args.filter((arg) => arg.required).length;
    if (this.cli.args.length < minimalArgsCount) {
      throw new CACError(`missing required args for command \`${this.rawName}\``);
    }
  }
  checkUnknownOptions() {
    const { options: options2, globalCommand } = this.cli;
    if (!this.config.allowUnknownOptions) {
      for (const name of Object.keys(options2)) {
        if (name !== "--" && !this.hasOption(name) && !globalCommand.hasOption(name)) {
          throw new CACError(`Unknown option \`${name.length > 1 ? `--${name}` : `-${name}`}\``);
        }
      }
    }
  }
  checkOptionValue() {
    const { options: parsedOptions, globalCommand } = this.cli;
    const options2 = [...globalCommand.options, ...this.options];
    for (const option of options2) {
      const value = parsedOptions[option.name.split(".")[0]];
      if (option.required) {
        const hasNegated = options2.some((o) => o.negated && o.names.includes(option.name));
        if (value === true || value === false && !hasNegated) {
          throw new CACError(`option \`${option.rawName}\` value is missing`);
        }
      }
    }
  }
}

class GlobalCommand extends Command {
  constructor(cli) {
    super("@@global@@", "", {}, cli);
  }
}
var __assign = Object.assign;

class CAC extends EventEmitter {
  constructor(name = "") {
    super();
    this.name = name;
    this.commands = [];
    this.rawArgs = [];
    this.args = [];
    this.options = {};
    this.globalCommand = new GlobalCommand(this);
    this.globalCommand.usage("<command> [options]");
  }
  usage(text2) {
    this.globalCommand.usage(text2);
    return this;
  }
  command(rawName, description, config) {
    const command = new Command(rawName, description || "", config, this);
    command.globalCommand = this.globalCommand;
    this.commands.push(command);
    return command;
  }
  option(rawName, description, config) {
    this.globalCommand.option(rawName, description, config);
    return this;
  }
  help(callback) {
    this.globalCommand.option("-h, --help", "Display this message");
    this.globalCommand.helpCallback = callback;
    this.showHelpOnExit = true;
    return this;
  }
  version(version, customFlags = "-v, --version") {
    this.globalCommand.version(version, customFlags);
    this.showVersionOnExit = true;
    return this;
  }
  example(example) {
    this.globalCommand.example(example);
    return this;
  }
  outputHelp() {
    if (this.matchedCommand) {
      this.matchedCommand.outputHelp();
    } else {
      this.globalCommand.outputHelp();
    }
  }
  outputVersion() {
    this.globalCommand.outputVersion();
  }
  setParsedInfo({ args, options: options2 }, matchedCommand, matchedCommandName) {
    this.args = args;
    this.options = options2;
    if (matchedCommand) {
      this.matchedCommand = matchedCommand;
    }
    if (matchedCommandName) {
      this.matchedCommandName = matchedCommandName;
    }
    return this;
  }
  unsetMatchedCommand() {
    this.matchedCommand = undefined;
    this.matchedCommandName = undefined;
  }
  parse(argv2 = processArgs, {
    run = true
  } = {}) {
    this.rawArgs = argv2;
    if (!this.name) {
      this.name = argv2[1] ? getFileName(argv2[1]) : "cli";
    }
    let shouldParse = true;
    for (const command of this.commands) {
      const parsed = this.mri(argv2.slice(2), command);
      const commandName = parsed.args[0];
      if (command.isMatched(commandName)) {
        shouldParse = false;
        const parsedInfo = __assign(__assign({}, parsed), {
          args: parsed.args.slice(1)
        });
        this.setParsedInfo(parsedInfo, command, commandName);
        this.emit(`command:${commandName}`, command);
      }
    }
    if (shouldParse) {
      for (const command of this.commands) {
        if (command.name === "") {
          shouldParse = false;
          const parsed = this.mri(argv2.slice(2), command);
          this.setParsedInfo(parsed, command);
          this.emit(`command:!`, command);
        }
      }
    }
    if (shouldParse) {
      const parsed = this.mri(argv2.slice(2));
      this.setParsedInfo(parsed);
    }
    if (this.options.help && this.showHelpOnExit) {
      this.outputHelp();
      run = false;
      this.unsetMatchedCommand();
    }
    if (this.options.version && this.showVersionOnExit && this.matchedCommandName == null) {
      this.outputVersion();
      run = false;
      this.unsetMatchedCommand();
    }
    const parsedArgv = { args: this.args, options: this.options };
    if (run) {
      this.runMatchedCommand();
    }
    if (!this.matchedCommand && this.args[0]) {
      this.emit("command:*");
    }
    return parsedArgv;
  }
  mri(argv2, command) {
    const cliOptions = [
      ...this.globalCommand.options,
      ...command ? command.options : []
    ];
    const mriOptions = getMriOptions(cliOptions);
    let argsAfterDoubleDashes = [];
    const doubleDashesIndex = argv2.indexOf("--");
    if (doubleDashesIndex > -1) {
      argsAfterDoubleDashes = argv2.slice(doubleDashesIndex + 1);
      argv2 = argv2.slice(0, doubleDashesIndex);
    }
    let parsed = mri2(argv2, mriOptions);
    parsed = Object.keys(parsed).reduce((res, name) => {
      return __assign(__assign({}, res), {
        [camelcaseOptionName(name)]: parsed[name]
      });
    }, { _: [] });
    const args = parsed._;
    const options2 = {
      "--": argsAfterDoubleDashes
    };
    const ignoreDefault = command && command.config.ignoreOptionDefaultValue ? command.config.ignoreOptionDefaultValue : this.globalCommand.config.ignoreOptionDefaultValue;
    let transforms = Object.create(null);
    for (const cliOption of cliOptions) {
      if (!ignoreDefault && cliOption.config.default !== undefined) {
        for (const name of cliOption.names) {
          options2[name] = cliOption.config.default;
        }
      }
      if (Array.isArray(cliOption.config.type)) {
        if (transforms[cliOption.name] === undefined) {
          transforms[cliOption.name] = Object.create(null);
          transforms[cliOption.name]["shouldTransform"] = true;
          transforms[cliOption.name]["transformFunction"] = cliOption.config.type[0];
        }
      }
    }
    for (const key of Object.keys(parsed)) {
      if (key !== "_") {
        const keys = key.split(".");
        setDotProp(options2, keys, parsed[key]);
        setByType(options2, transforms);
      }
    }
    return {
      args,
      options: options2
    };
  }
  runMatchedCommand() {
    const { args, options: options2, matchedCommand: command } = this;
    if (!command || !command.commandAction)
      return;
    command.checkUnknownOptions();
    command.checkOptionValue();
    command.checkRequiredArgs();
    const actionArgs = [];
    command.args.forEach((arg, index) => {
      if (arg.variadic) {
        actionArgs.push(args.slice(index));
      } else {
        actionArgs.push(args[index]);
      }
    });
    actionArgs.push(options2);
    return command.commandAction.apply(this, actionArgs);
  }
}
var exports_config = {};
__export(exports_config, {
  ui: () => ui2,
  team: () => team2,
  storage: () => storage2,
  services: () => services2,
  security: () => security2,
  searchEngine: () => searchEngine,
  saas: () => saas2,
  queue: () => queue3,
  ports: () => ports2,
  payment: () => payment,
  overrides: () => overrides_default,
  notification: () => notification,
  logging: () => logging2,
  localUrl: () => localUrl,
  library: () => library2,
  hashing: () => hashing2,
  git: () => git2,
  errors: () => errors2,
  email: () => email2,
  docs: () => docs2,
  dns: () => dns2,
  determineAppEnv: () => determineAppEnv,
  defineUi: () => defineUi,
  defineStorage: () => defineStorage,
  defineStacksConfig: () => defineStacksConfig,
  defineSms: () => defineSms,
  defineServices: () => defineServices,
  defineSecurity: () => defineSecurity,
  defineSearchEngine: () => defineSearchEngine,
  defineQueue: () => defineQueue,
  definePayment: () => definePayment,
  defineNotification: () => defineNotification,
  defineModel: () => defineModel,
  defineLibrary: () => defineLibrary,
  defineJob: () => defineJob,
  defineHashing: () => defineHashing,
  defineGit: () => defineGit,
  defineEvents: () => defineEvents,
  defineEmailConfig: () => defineEmailConfig,
  defineEmail: () => defineEmail,
  defineDns: () => defineDns,
  defineDependencies: () => defineDependencies,
  defineDatabase: () => defineDatabase,
  defineCronJob: () => defineCronJob,
  defineCli: () => defineCli,
  defineChat: () => defineChat,
  defineCdn: () => defineCdn,
  defineCache: () => defineCache,
  defineApp: () => defineApp,
  defaults: () => defaults_default,
  database: () => database2,
  config: () => config3,
  cloud: () => cloud2,
  cli: () => cli3,
  cache: () => cache2,
  app: () => app2,
  analytics: () => analytics2,
  ai: () => ai2
});
var WORD_SEPARATORS = new Set(["\u2014", "\u2013", "-", "\u2015", "/"]);
var SENTENCE_TERMINATORS = new Set([".", "!", "?"]);
var TITLE_TERMINATORS = new Set([
  ...SENTENCE_TERMINATORS,
  ":",
  '"',
  "\'",
  "\u201D"
]);
var SMALL_WORDS = new Set([
  "a",
  "an",
  "and",
  "as",
  "at",
  "because",
  "but",
  "by",
  "en",
  "for",
  "if",
  "in",
  "neither",
  "nor",
  "of",
  "on",
  "only",
  "or",
  "over",
  "per",
  "so",
  "some",
  "than",
  "that",
  "the",
  "to",
  "up",
  "upon",
  "v",
  "versus",
  "via",
  "vs",
  "when",
  "with",
  "without",
  "yet"
]);
var pluralRules = [];
var singularRules = [];
var uncountables = {};
var irregularPlurals = {};
var irregularSingles = {};
function sanitizeRule(rule) {
  return typeof rule === "string" ? new RegExp(`^${rule}$`, "i") : rule;
}
function restoreCase(word, token) {
  if (word === token)
    return token;
  if (word === word.toLowerCase())
    return token.toLowerCase();
  if (word === word.toUpperCase())
    return token.toUpperCase();
  if (word[0] === word[0].toUpperCase()) {
    return token.charAt(0).toUpperCase() + token.slice(1).toLowerCase();
  }
  return token.toLowerCase();
}
function interpolate(str, ...args) {
  return str.replace(/\$(\d{1,2})/g, (match, index) => args[Number(index)] || "");
}
function replace(word, rule) {
  return word.replace(rule[0], (...matchArgs) => {
    const result2 = interpolate(rule[1], ...matchArgs);
    if (matchArgs[0] === "") {
      return restoreCase(word[matchArgs[matchArgs.length - 2] - 1], result2);
    }
    return restoreCase(matchArgs[0], result2);
  });
}
function sanitizeWord(token, word, rules) {
  if (!token.length || uncountables[token]) {
    return word;
  }
  for (let i = rules.length - 1;i >= 0; i--) {
    const rule = rules[i];
    if (rule[0].test(word))
      return replace(word, rule);
  }
  return word;
}
function replaceWord(replaceMap, keepMap, rules) {
  return (word) => {
    const token = word.toLowerCase();
    if (keepMap[token])
      return restoreCase(word, token);
    if (replaceMap[token])
      return restoreCase(word, replaceMap[token]);
    return sanitizeWord(token, word, rules);
  };
}
function checkWord(replaceMap, keepMap, rules) {
  return (word) => {
    const token = word.toLowerCase();
    if (keepMap[token])
      return true;
    if (replaceMap[token])
      return false;
    return sanitizeWord(token, token, rules) === token;
  };
}
var pluralize = (word, options2 = {}) => {
  const { count = 2, inclusive = false } = options2;
  if (typeof word !== "string") {
    throw new TypeError("Word must be a string");
  }
  const pluralized = count === 1 ? pluralize.singular(word) : pluralize.plural(word);
  return inclusive ? `${count} ${pluralized}` : pluralized;
};
pluralize.plural = replaceWord(irregularSingles, irregularPlurals, pluralRules);
pluralize.isPlural = checkWord(irregularSingles, irregularPlurals, pluralRules);
pluralize.singular = replaceWord(irregularPlurals, irregularSingles, singularRules);
pluralize.isSingular = checkWord(irregularPlurals, irregularSingles, singularRules);
pluralize.addPluralRule = (rule, replacement) => {
  pluralRules.push([sanitizeRule(rule), replacement]);
};
pluralize.addSingularRule = (rule, replacement) => {
  singularRules.push([sanitizeRule(rule), replacement]);
};
pluralize.addUncountableRule = (word) => {
  if (typeof word === "string") {
    uncountables[word.toLowerCase()] = true;
    return;
  }
  pluralize.addPluralRule(word, "$0");
  pluralize.addSingularRule(word, "$0");
};
pluralize.addIrregularRule = (single, plural) => {
  const lowerPlural = plural.toLowerCase();
  const lowerSingle = single.toLowerCase();
  irregularSingles[lowerSingle] = lowerPlural;
  irregularPlurals[lowerPlural] = lowerSingle;
};
[
  ["I", "we"],
  ["me", "us"],
  ["he", "they"],
  ["she", "they"],
  ["them", "them"],
  ["myself", "ourselves"],
  ["yourself", "yourselves"],
  ["itself", "themselves"],
  ["herself", "themselves"],
  ["himself", "themselves"],
  ["themself", "themselves"],
  ["is", "are"],
  ["was", "were"],
  ["has", "have"],
  ["this", "these"],
  ["that", "those"],
  ["my", "our"],
  ["its", "their"],
  ["his", "their"],
  ["her", "their"],
  ["echo", "echoes"],
  ["dingo", "dingoes"],
  ["volcano", "volcanoes"],
  ["tornado", "tornadoes"],
  ["torpedo", "torpedoes"],
  ["genus", "genera"],
  ["viscus", "viscera"],
  ["stigma", "stigmata"],
  ["stoma", "stomata"],
  ["dogma", "dogmata"],
  ["lemma", "lemmata"],
  ["schema", "schemata"],
  ["anathema", "anathemata"],
  ["ox", "oxen"],
  ["axe", "axes"],
  ["die", "dice"],
  ["yes", "yeses"],
  ["foot", "feet"],
  ["eave", "eaves"],
  ["goose", "geese"],
  ["tooth", "teeth"],
  ["quiz", "quizzes"],
  ["human", "humans"],
  ["proof", "proofs"],
  ["carve", "carves"],
  ["valve", "valves"],
  ["looey", "looies"],
  ["thief", "thieves"],
  ["groove", "grooves"],
  ["pickaxe", "pickaxes"],
  ["passerby", "passersby"],
  ["canvas", "canvases"]
].forEach(([single, plural]) => pluralize.addIrregularRule(single, plural));
[
  [/s?$/i, "s"],
  [/[^\x20-\x7F]$/, "$0"],
  [/([^aeiou]ese)$/i, "$1"],
  [/(ax|test)is$/i, "$1es"],
  [/(alias|[^aou]us|t[lm]as|gas|ris)$/i, "$1es"],
  [/(e[mn]u)s?$/i, "$1s"],
  [/([^l]ias|[aeiou]las|[ejzr]as|[iu]am)$/i, "$1"],
  [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1i"],
  [/(alumn|alg|vertebr)(?:a|ae)$/i, "$1ae"],
  [/(seraph|cherub)(?:im)?$/i, "$1im"],
  [/(her|at|gr)o$/i, "$1oes"],
  [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i, "$1a"],
  [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i, "$1a"],
  [/sis$/i, "ses"],
  [/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i, "$1$2ves"],
  [/([^aeiouy]|qu)y$/i, "$1ies"],
  [/([^ch][ieo][ln])ey$/i, "$1ies"],
  [/(x|ch|ss|sh|zz)$/i, "$1es"],
  [/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i, "$1ices"],
  [/\b((?:tit)?m|l)(?:ice|ouse)$/i, "$1ice"],
  [/(pe)(?:rson|ople)$/i, "$1ople"],
  [/(child)(?:ren)?$/i, "$1ren"],
  [/eaux$/i, "$0"],
  [/m[ae]n$/i, "men"],
  ["thou", "you"]
].forEach(([rule, replacement]) => pluralize.addPluralRule(rule, replacement));
[
  [/s$/i, ""],
  [/(ss)$/i, "$1"],
  [/(wi|kni|(?:after|half|high|low|mid|non|night|\W|^)li)ves$/i, "$1fe"],
  [/(ar|(?:wo|[ae])l|[eo][ao])ves$/i, "$1f"],
  [/ies$/i, "y"],
  [/(dg|ss|ois|lk|ok|wn|mb|th|ch|ec|oal|is|ck|ix|sser|ts|wb)ies$/i, "$1ie"],
  [/\b(l|(?:neck|cross|hog|aun)?t|coll|faer|food|gen|goon|group|hipp|junk|vegg|(?:pork)?p|charl|calor|cut)ies$/i, "$1ie"],
  [/\b(mon|smil)ies$/i, "$1ey"],
  [/\b((?:tit)?m|l)ice$/i, "$1ouse"],
  [/(seraph|cherub)im$/i, "$1"],
  [/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|t[lm]as|gas|(?:her|at|gr)o|[aeiou]ris)(?:es)?$/i, "$1"],
  [/(analy|diagno|parenthe|progno|synop|the|empha|cri|ne)(?:sis|ses)$/i, "$1sis"],
  [/(movie|twelve|abuse|e[mn]u)s$/i, "$1"],
  [/(test)(?:is|es)$/i, "$1is"],
  [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1us"],
  [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i, "$1um"],
  [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i, "$1on"],
  [/(alumn|alg|vertebr)ae$/i, "$1a"],
  [/(cod|mur|sil|vert|ind)ices$/i, "$1ex"],
  [/(matr|append)ices$/i, "$1ix"],
  [/(pe)(rson|ople)$/i, "$1rson"],
  [/(child)ren$/i, "$1"],
  [/(eau)x?$/i, "$1"],
  [/men$/i, "man"]
].forEach(([rule, replacement]) => pluralize.addSingularRule(rule, replacement));
[
  "adulthood",
  "advice",
  "agenda",
  "aid",
  "aircraft",
  "alcohol",
  "ammo",
  "analytics",
  "anime",
  "athletics",
  "audio",
  "bison",
  "blood",
  "bream",
  "buffalo",
  "butter",
  "carp",
  "cash",
  "chassis",
  "chess",
  "clothing",
  "cod",
  "commerce",
  "cooperation",
  "corps",
  "debris",
  "diabetes",
  "digestion",
  "elk",
  "energy",
  "equipment",
  "excretion",
  "expertise",
  "firmware",
  "flounder",
  "fun",
  "gallows",
  "garbage",
  "graffiti",
  "hardware",
  "headquarters",
  "health",
  "herpes",
  "highjinks",
  "homework",
  "housework",
  "information",
  "jeans",
  "justice",
  "kudos",
  "labour",
  "literature",
  "machinery",
  "mackerel",
  "mail",
  "media",
  "mews",
  "moose",
  "music",
  "mud",
  "manga",
  "news",
  "only",
  "personnel",
  "pike",
  "plankton",
  "pliers",
  "police",
  "pollution",
  "premises",
  "rain",
  "research",
  "rice",
  "salmon",
  "scissors",
  "series",
  "sewage",
  "shambles",
  "shrimp",
  "software",
  "staff",
  "swine",
  "tennis",
  "traffic",
  "transportation",
  "trout",
  "tuna",
  "wealth",
  "welfare",
  "whiting",
  "wildebeest",
  "wildlife",
  "you",
  /pok[e\u00E9]mon$/i,
  /[^aeiou]ese$/i,
  /deer$/i,
  /fish$/i,
  /measles$/i,
  /o[iu]s$/i,
  /pox$/i,
  /sheep$/i
].forEach(pluralize.addUncountableRule);
var charMap = JSON.parse(`{"$":"dollar","%":"percent","&":"and","<":"less",">":"greater","|":"or","\xA2":"cent","\xA3":"pound","\xA4":"currency","\xA5":"yen","\xA9":"(c)","\xAA":"a","\xAE":"(r)","\xBA":"o","\xC0":"A","\xC1":"A","\xC2":"A","\xC3":"A","\xC4":"A","\xC5":"A","\xC6":"AE","\xC7":"C","\xC8":"E","\xC9":"E","\xCA":"E","\xCB":"E","\xCC":"I","\xCD":"I","\xCE":"I","\xCF":"I","\xD0":"D","\xD1":"N","\xD2":"O","\xD3":"O","\xD4":"O","\xD5":"O","\xD6":"O","\xD8":"O","\xD9":"U","\xDA":"U","\xDB":"U","\xDC":"U","\xDD":"Y","\xDE":"TH","\xDF":"ss","\xE0":"a","\xE1":"a","\xE2":"a","\xE3":"a","\xE4":"a","\xE5":"a","\xE6":"ae","\xE7":"c","\xE8":"e","\xE9":"e","\xEA":"e","\xEB":"e","\xEC":"i","\xED":"i","\xEE":"i","\xEF":"i","\xF0":"d","\xF1":"n","\xF2":"o","\xF3":"o","\xF4":"o","\xF5":"o","\xF6":"o","\xF8":"o","\xF9":"u","\xFA":"u","\xFB":"u","\xFC":"u","\xFD":"y","\xFE":"th","\xFF":"y","\u0100":"A","\u0101":"a","\u0102":"A","\u0103":"a","\u0104":"A","\u0105":"a","\u0106":"C","\u0107":"c","\u010C":"C","\u010D":"c","\u010E":"D","\u010F":"d","\u0110":"DJ","\u0111":"dj","\u0112":"E","\u0113":"e","\u0116":"E","\u0117":"e","\u0118":"e","\u0119":"e","\u011A":"E","\u011B":"e","\u011E":"G","\u011F":"g","\u0122":"G","\u0123":"g","\u0128":"I","\u0129":"i","\u012A":"i","\u012B":"i","\u012E":"I","\u012F":"i","\u0130":"I","\u0131":"i","\u0136":"k","\u0137":"k","\u013B":"L","\u013C":"l","\u013D":"L","\u013E":"l","\u0141":"L","\u0142":"l","\u0143":"N","\u0144":"n","\u0145":"N","\u0146":"n","\u0147":"N","\u0148":"n","\u014C":"O","\u014D":"o","\u0150":"O","\u0151":"o","\u0152":"OE","\u0153":"oe","\u0154":"R","\u0155":"r","\u0158":"R","\u0159":"r","\u015A":"S","\u015B":"s","\u015E":"S","\u015F":"s","\u0160":"S","\u0161":"s","\u0162":"T","\u0163":"t","\u0164":"T","\u0165":"t","\u0168":"U","\u0169":"u","\u016A":"u","\u016B":"u","\u016E":"U","\u016F":"u","\u0170":"U","\u0171":"u","\u0172":"U","\u0173":"u","\u0174":"W","\u0175":"w","\u0176":"Y","\u0177":"y","\u0178":"Y","\u0179":"Z","\u017A":"z","\u017B":"Z","\u017C":"z","\u017D":"Z","\u017E":"z","\u018F":"E","\u0192":"f","\u01A0":"O","\u01A1":"o","\u01AF":"U","\u01B0":"u","\u01C8":"LJ","\u01C9":"lj","\u01CB":"NJ","\u01CC":"nj","\u0218":"S","\u0219":"s","\u021A":"T","\u021B":"t","\u0259":"e","\u02DA":"o","\u0386":"A","\u0388":"E","\u0389":"H","\u038A":"I","\u038C":"O","\u038E":"Y","\u038F":"W","\u0390":"i","\u0391":"A","\u0392":"B","\u0393":"G","\u0394":"D","\u0395":"E","\u0396":"Z","\u0397":"H","\u0398":"8","\u0399":"I","\u039A":"K","\u039B":"L","\u039C":"M","\u039D":"N","\u039E":"3","\u039F":"O","\u03A0":"P","\u03A1":"R","\u03A3":"S","\u03A4":"T","\u03A5":"Y","\u03A6":"F","\u03A7":"X","\u03A8":"PS","\u03A9":"W","\u03AA":"I","\u03AB":"Y","\u03AC":"a","\u03AD":"e","\u03AE":"h","\u03AF":"i","\u03B0":"y","\u03B1":"a","\u03B2":"b","\u03B3":"g","\u03B4":"d","\u03B5":"e","\u03B6":"z","\u03B7":"h","\u03B8":"8","\u03B9":"i","\u03BA":"k","\u03BB":"l","\u03BC":"m","\u03BD":"n","\u03BE":"3","\u03BF":"o","\u03C0":"p","\u03C1":"r","\u03C2":"s","\u03C3":"s","\u03C4":"t","\u03C5":"y","\u03C6":"f","\u03C7":"x","\u03C8":"ps","\u03C9":"w","\u03CA":"i","\u03CB":"y","\u03CC":"o","\u03CD":"y","\u03CE":"w","\u0401":"Yo","\u0402":"DJ","\u0404":"Ye","\u0406":"I","\u0407":"Yi","\u0408":"J","\u0409":"LJ","\u040A":"NJ","\u040B":"C","\u040F":"DZ","\u0410":"A","\u0411":"B","\u0412":"V","\u0413":"G","\u0414":"D","\u0415":"E","\u0416":"Zh","\u0417":"Z","\u0418":"I","\u0419":"J","\u041A":"K","\u041B":"L","\u041C":"M","\u041D":"N","\u041E":"O","\u041F":"P","\u0420":"R","\u0421":"S","\u0422":"T","\u0423":"U","\u0424":"F","\u0425":"H","\u0426":"C","\u0427":"Ch","\u0428":"Sh","\u0429":"Sh","\u042A":"U","\u042B":"Y","\u042C":"","\u042D":"E","\u042E":"Yu","\u042F":"Ya","\u0430":"a","\u0431":"b","\u0432":"v","\u0433":"g","\u0434":"d","\u0435":"e","\u0436":"zh","\u0437":"z","\u0438":"i","\u0439":"j","\u043A":"k","\u043B":"l","\u043C":"m","\u043D":"n","\u043E":"o","\u043F":"p","\u0440":"r","\u0441":"s","\u0442":"t","\u0443":"u","\u0444":"f","\u0445":"h","\u0446":"c","\u0447":"ch","\u0448":"sh","\u0449":"sh","\u044A":"u","\u044B":"y","\u044C":"","\u044D":"e","\u044E":"yu","\u044F":"ya","\u0451":"yo","\u0452":"dj","\u0454":"ye","\u0456":"i","\u0457":"yi","\u0458":"j","\u0459":"lj","\u045A":"nj","\u045B":"c","\u045D":"u","\u045F":"dz","\u0490":"G","\u0491":"g","\u0492":"GH","\u0493":"gh","\u049A":"KH","\u049B":"kh","\u04A2":"NG","\u04A3":"ng","\u04AE":"UE","\u04AF":"ue","\u04B0":"U","\u04B1":"u","\u04BA":"H","\u04BB":"h","\u04D8":"AE","\u04D9":"ae","\u04E8":"OE","\u04E9":"oe","\u0531":"A","\u0532":"B","\u0533":"G","\u0534":"D","\u0535":"E","\u0536":"Z","\u0537":"E'","\u0538":"Y'","\u0539":"T'","\u053A":"JH","\u053B":"I","\u053C":"L","\u053D":"X","\u053E":"C'","\u053F":"K","\u0540":"H","\u0541":"D'","\u0542":"GH","\u0543":"TW","\u0544":"M","\u0545":"Y","\u0546":"N","\u0547":"SH","\u0549":"CH","\u054A":"P","\u054B":"J","\u054C":"R'","\u054D":"S","\u054E":"V","\u054F":"T","\u0550":"R","\u0551":"C","\u0553":"P'","\u0554":"Q'","\u0555":"O''","\u0556":"F","\u0587":"EV","\u0621":"a","\u0622":"aa","\u0623":"a","\u0624":"u","\u0625":"i","\u0626":"e","\u0627":"a","\u0628":"b","\u0629":"h","\u062A":"t","\u062B":"th","\u062C":"j","\u062D":"h","\u062E":"kh","\u062F":"d","\u0630":"th","\u0631":"r","\u0632":"z","\u0633":"s","\u0634":"sh","\u0635":"s","\u0636":"dh","\u0637":"t","\u0638":"z","\u0639":"a","\u063A":"gh","\u0641":"f","\u0642":"q","\u0643":"k","\u0644":"l","\u0645":"m","\u0646":"n","\u0647":"h","\u0648":"w","\u0649":"a","\u064A":"y","\u064B":"an","\u064C":"on","\u064D":"en","\u064E":"a","\u064F":"u","\u0650":"e","\u0652":"","\u0660":"0","\u0661":"1","\u0662":"2","\u0663":"3","\u0664":"4","\u0665":"5","\u0666":"6","\u0667":"7","\u0668":"8","\u0669":"9","\u067E":"p","\u0686":"ch","\u0698":"zh","\u06A9":"k","\u06AF":"g","\u06CC":"y","\u06F0":"0","\u06F1":"1","\u06F2":"2","\u06F3":"3","\u06F4":"4","\u06F5":"5","\u06F6":"6","\u06F7":"7","\u06F8":"8","\u06F9":"9","\u0E3F":"baht","\u10D0":"a","\u10D1":"b","\u10D2":"g","\u10D3":"d","\u10D4":"e","\u10D5":"v","\u10D6":"z","\u10D7":"t","\u10D8":"i","\u10D9":"k","\u10DA":"l","\u10DB":"m","\u10DC":"n","\u10DD":"o","\u10DE":"p","\u10DF":"zh","\u10E0":"r","\u10E1":"s","\u10E2":"t","\u10E3":"u","\u10E4":"f","\u10E5":"k","\u10E6":"gh","\u10E7":"q","\u10E8":"sh","\u10E9":"ch","\u10EA":"ts","\u10EB":"dz","\u10EC":"ts","\u10ED":"ch","\u10EE":"kh","\u10EF":"j","\u10F0":"h","\u1E62":"S","\u1E63":"s","\u1E80":"W","\u1E81":"w","\u1E82":"W","\u1E83":"w","\u1E84":"W","\u1E85":"w","\u1E9E":"SS","\u1EA0":"A","\u1EA1":"a","\u1EA2":"A","\u1EA3":"a","\u1EA4":"A","\u1EA5":"a","\u1EA6":"A","\u1EA7":"a","\u1EA8":"A","\u1EA9":"a","\u1EAA":"A","\u1EAB":"a","\u1EAC":"A","\u1EAD":"a","\u1EAE":"A","\u1EAF":"a","\u1EB0":"A","\u1EB1":"a","\u1EB2":"A","\u1EB3":"a","\u1EB4":"A","\u1EB5":"a","\u1EB6":"A","\u1EB7":"a","\u1EB8":"E","\u1EB9":"e","\u1EBA":"E","\u1EBB":"e","\u1EBC":"E","\u1EBD":"e","\u1EBE":"E","\u1EBF":"e","\u1EC0":"E","\u1EC1":"e","\u1EC2":"E","\u1EC3":"e","\u1EC4":"E","\u1EC5":"e","\u1EC6":"E","\u1EC7":"e","\u1EC8":"I","\u1EC9":"i","\u1ECA":"I","\u1ECB":"i","\u1ECC":"O","\u1ECD":"o","\u1ECE":"O","\u1ECF":"o","\u1ED0":"O","\u1ED1":"o","\u1ED2":"O","\u1ED3":"o","\u1ED4":"O","\u1ED5":"o","\u1ED6":"O","\u1ED7":"o","\u1ED8":"O","\u1ED9":"o","\u1EDA":"O","\u1EDB":"o","\u1EDC":"O","\u1EDD":"o","\u1EDE":"O","\u1EDF":"o","\u1EE0":"O","\u1EE1":"o","\u1EE2":"O","\u1EE3":"o","\u1EE4":"U","\u1EE5":"u","\u1EE6":"U","\u1EE7":"u","\u1EE8":"U","\u1EE9":"u","\u1EEA":"U","\u1EEB":"u","\u1EEC":"U","\u1EED":"u","\u1EEE":"U","\u1EEF":"u","\u1EF0":"U","\u1EF1":"u","\u1EF2":"Y","\u1EF3":"y","\u1EF4":"Y","\u1EF5":"y","\u1EF6":"Y","\u1EF7":"y","\u1EF8":"Y","\u1EF9":"y","\u2013":"-","\u2018":"'","\u2019":"'","\u201C":"\\"","\u201D":"\\"","\u201E":"\\"","\u2020":"+","\u2022":"*","\u2026":"...","\u20A0":"ecu","\u20A2":"cruzeiro","\u20A3":"french franc","\u20A4":"lira","\u20A5":"mill","\u20A6":"naira","\u20A7":"peseta","\u20A8":"rupee","\u20A9":"won","\u20AA":"new shequel","\u20AB":"dong","\u20AC":"euro","\u20AD":"kip","\u20AE":"tugrik","\u20AF":"drachma","\u20B0":"penny","\u20B1":"peso","\u20B2":"guarani","\u20B3":"austral","\u20B4":"hryvnia","\u20B5":"cedi","\u20B8":"kazakhstani tenge","\u20B9":"indian rupee","\u20BA":"turkish lira","\u20BD":"russian ruble","\u20BF":"bitcoin","\u2120":"sm","\u2122":"tm","\u2202":"d","\u2206":"delta","\u2211":"sum","\u221E":"infinity","\u2665":"love","\u5143":"yuan","\u5186":"yen","\uFDFC":"rial","\uFEF5":"laa","\uFEF7":"laa","\uFEF9":"lai","\uFEFB":"la"}`);
var locales = JSON.parse('{"bg":{"\u0419":"Y","\u0426":"Ts","\u0429":"Sht","\u042A":"A","\u042C":"Y","\u0439":"y","\u0446":"ts","\u0449":"sht","\u044A":"a","\u044C":"y"},"de":{"\xC4":"AE","\xE4":"ae","\xD6":"OE","\xF6":"oe","\xDC":"UE","\xFC":"ue","\xDF":"ss","%":"prozent","&":"und","|":"oder","\u2211":"summe","\u221E":"unendlich","\u2665":"liebe"},"es":{"%":"por ciento","&":"y","<":"menor que",">":"mayor que","|":"o","\xA2":"centavos","\xA3":"libras","\xA4":"moneda","\u20A3":"francos","\u2211":"suma","\u221E":"infinito","\u2665":"amor"},"fr":{"%":"pourcent","&":"et","<":"plus petit",">":"plus grand","|":"ou","\xA2":"centime","\xA3":"livre","\xA4":"devise","\u20A3":"franc","\u2211":"somme","\u221E":"infini","\u2665":"amour"},"pt":{"%":"porcento","&":"e","<":"menor",">":"maior","|":"ou","\xA2":"centavo","\u2211":"soma","\xA3":"libra","\u221E":"infinito","\u2665":"amor"},"uk":{"\u0418":"Y","\u0438":"y","\u0419":"Y","\u0439":"y","\u0426":"Ts","\u0446":"ts","\u0425":"Kh","\u0445":"kh","\u0429":"Shch","\u0449":"shch","\u0413":"H","\u0433":"h"},"vi":{"\u0110":"D","\u0111":"d"},"da":{"\xD8":"OE","\xF8":"oe","\xC5":"AA","\xE5":"aa","%":"procent","&":"og","|":"eller","$":"dollar","<":"mindre end",">":"st\xF8rre end"},"nb":{"&":"og","\xC5":"AA","\xC6":"AE","\xD8":"OE","\xE5":"aa","\xE6":"ae","\xF8":"oe"},"it":{"&":"e"},"nl":{"&":"en"},"sv":{"&":"och","\xC5":"AA","\xC4":"AE","\xD6":"OE","\xE5":"aa","\xE4":"ae","\xF6":"oe"}}');
init_consola_36c0034f();
init_core();
init_consola_06ad8a64();
init_utils();
function logLevel() {
  const verboseRegex = /--verbose(?!\s*=\s*false|\s+false)(?:\s+|=true)?(?:$|\s)/;
  const opts = buddyOptions();
  if (verboseRegex.test(opts))
    return 4;
  return 3;
}
var logger = {
  ...createConsola2({
    level: logLevel()
  }),
  warning: (message) => console.warn(message),
  dump: (...args) => console.log(...args),
  dd: (...args) => {
    console.log(...args);
    process4.exit(1);
  },
  echo: (message) => console.log(message)
};
var log = {
  info: async (message, options2) => {
    if (options2?.styled === false)
      console.log(message);
    else
      logger.info(message);
    await writeToLogFile(`INFO: ${stripAnsi(message)}`);
  },
  success: async (message, options2) => {
    if (options2?.styled === false)
      console.log(message);
    else
      logger.success(message);
    await writeToLogFile(`SUCCESS: ${stripAnsi(message)}`);
  },
  warn: async (message, options2) => {
    if (options2?.styled === false)
      console.log(message);
    else
      logger.warn(message);
    await writeToLogFile(`WARN: ${stripAnsi(message)}`);
  },
  warning: async (message, options2) => {
    if (options2?.styled === false)
      console.log(message);
    else
      logger.warn(message);
    await writeToLogFile(`WARN: ${stripAnsi(message)}`);
  },
  error: async (err, options2) => {
    handleError(err, options2);
  },
  debug: async (...args) => {
    const formattedArgs = args.map((arg) => typeof arg === "object" ? JSON.stringify(arg, null, 2) : arg);
    const message = `DEBUG: ${formattedArgs.join(" ")}`;
    if (process4.env.APP_ENV === "production" || process4.env.APP_ENV === "prod")
      return writeToLogFile(message);
    logger.debug(message);
    await writeToLogFile(stripAnsi(message));
  },
  dump: (...args) => args.forEach((arg) => console.log(arg)),
  dd: (...args) => {
    args.forEach((arg) => console.log(arg));
    process4.exit(1);
  },
  echo: (...args) => console.log(...args)
};
function userDatabasePath(path2) {
  return projectPath(`database/${path2 || ""}`);
}
function appPath(path2) {
  return projectPath(`app/${path2 || ""}`);
}
function commandsPath(path2) {
  return appPath(`Commands/${path2 || ""}`);
}
function logsPath(path2) {
  return storagePath(`logs/${path2 || ""}`);
}
function projectPath(filePath = "", options2) {
  let path2 = process5.cwd();
  while (path2.includes("storage"))
    path2 = resolve2(path2, "..");
  const finalPath = resolve2(path2, filePath);
  if (options2?.relative)
    return relative(process5.cwd(), finalPath);
  return finalPath;
}
function storagePath(path2) {
  return projectPath(`storage/${path2 || ""}`);
}
var config = {
  ai: {
    deploy: false,
    models: [
      "amazon.titan-embed-text-v1",
      "amazon.titan-text-express-v1",
      "amazon.titan-embed-image-v1",
      "amazon.titan-image-generator-v1",
      "anthropic.claude-v1",
      "anthropic.claude-v2",
      "anthropic.claude-v2:1",
      "anthropic.claude-instant-v1",
      "meta.llama2-13b-chat-v1",
      "meta.llama2-70b-chat-v1"
    ]
  },
  analytics: {
    driver: undefined
  },
  app: {
    name: "Stacks",
    description: "A Stacks application.",
    env: "local",
    url: "stacks.localhost",
    debug: true,
    key: "",
    timezone: "UTC",
    locale: "en",
    fallbackLocale: "en",
    cipher: "AES-256-CBC",
    docMode: false,
    redirectUrls: [],
    maintenanceMode: false
  },
  cli: {
    name: "My Custom CLI",
    command: "my-custom-cli",
    description: "Stacks is a full-stack framework for TypeScript.",
    source: commandsPath(),
    deploy: false
  },
  cache: {
    driver: "redis",
    prefix: "stx",
    ttl: 3600,
    drivers: {
      redis: {
        connection: "default",
        host: "localhost",
        port: 6379,
        username: "",
        password: ""
      }
    }
  },
  cloud: {
    type: "serverless",
    driver: "aws",
    storage: {},
    environments: ["production", "staging", "development"],
    firewall: {
      enabled: true,
      countryCodes: [],
      ipAddresses: [],
      queryString: [],
      httpHeaders: [],
      rateLimitPerMinute: 1000,
      useIpReputationLists: true,
      useKnownBadInputsRuleSet: true
    },
    cdn: {
      allowedMethods: "GET_HEAD",
      cachedMethods: "GET_HEAD",
      minTtl: 0,
      defaultTtl: 86400,
      maxTtl: 31536000,
      compress: true,
      priceClass: "PriceClass_All",
      originShieldRegion: "us-east-1",
      cookieBehavior: "none",
      allowList: {
        cookies: [],
        headers: [],
        queryStrings: []
      },
      realtimeLogs: {
        enabled: true,
        samplingRate: 2
      }
    },
    fileSystem: false
  },
  database: {
    default: "sqlite",
    connections: {
      sqlite: {
        database: userDatabasePath("stacks.sqlite"),
        prefix: ""
      }
    },
    migrations: "migrations",
    migrationLocks: "migration_locks"
  },
  dns: {
    driver: "aws",
    a: [],
    aaaa: [],
    cname: [],
    mx: [],
    txt: []
  },
  docs: {
    lang: "en-US",
    title: "Stacks",
    description: "Rapid application, cloud & library framework.",
    lastUpdated: true,
    deploy: false,
    themeConfig: {
      editLink: {
        pattern: "https://github.com/stacksjs/stacks/edit/main/docs/docs/:path",
        text: "Edit this page on GitHub"
      },
      footer: {
        message: "Released under the MIT License.",
        copyright: "Copyright \xA9 2024-present Stacks.js, Inc."
      }
    }
  },
  email: {
    from: {
      name: "Stacks",
      address: "no-reply@stacksjs.org"
    },
    mailboxes: [],
    server: {
      scan: true
    }
  },
  errors: {
    messages: {
      string: "The {{ field }} field must be a string",
      email: "The {{ field }} field must be a valid email address",
      regex: "The {{ field }} field format is invalid",
      url: "The {{ field }} field must be a valid URL",
      activeUrl: "The {{ field }} field must be a valid URL",
      alpha: "The {{ field }} field must contain only letters",
      alphaNumeric: "The {{ field }} field must contain only letters and numbers",
      minLength: "The {{ field }} field must have at least {{ min }} characters",
      maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
      fixedLength: "The {{ field }} field must be {{ size }} characters long",
      confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
      endsWith: "The {{ field }} field must end with {{ substring }}",
      startsWith: "The {{ field }} field must start with {{ substring }}",
      sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
      notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
      in: "The selected {{ field }} is invalid",
      notIn: "The selected {{ field }} is invalid",
      ipAddress: "The {{ field }} field must be a valid IP address",
      uuid: "The {{ field }} field must be a valid UUID",
      ascii: "The {{ field }} field must only contain ASCII characters",
      creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
      hexCode: "The {{ field }} field must be a valid hex color code",
      iban: "The {{ field }} field must be a valid IBAN number",
      jwt: "The {{ field }} field must be a valid JWT token",
      coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
      mobile: "The {{ field }} field must be a valid mobile phone number",
      passport: "The {{ field }} field must be a valid passport number",
      postalCode: "The {{ field }} field must be a valid postal code",
      boolean: "The value must be a boolean",
      number: "The {{ field }} field must be a number",
      min: "The {{ field }} field must be at least {{ min }}",
      max: "The {{ field }} field must not be greater than {{ max }}",
      range: "The {{ field }} field must be between {{ min }} and {{ max }}",
      positive: "The {{ field }} field must be positive",
      negative: "The {{ field }} field must be negative",
      decimal: "The {{ field }} field must have {{ digits }} decimal places",
      withoutDecimals: "The {{ field }} field must not have decimal places",
      date: "The {{ field }} field must be a datetime value",
      "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
      "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
      "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
      "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
      "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
      "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
      "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
      "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
      accepted: "The {{ field }} field must be accepted",
      enum: "The selected {{ field }} is invalid",
      literal: "The {{ field }} field must be {{ expectedValue }}",
      object: "The {{ field }} field must be an object",
      record: "The {{ field }} field must be an object",
      "record.minLength": "The {{ field }} field must have at least {{ min }} items",
      "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
      "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
      array: "The {{ field }} field must be an array",
      "array.minLength": "The {{ field }} field must have at least {{ min }} items",
      "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
      "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
      notEmpty: "The {{ field }} field must not be empty",
      distinct: "The {{ field }} field has duplicate values",
      tuple: "The {{ field }} field must be an array",
      union: "Invalid value provided for {{ field }} field",
      unionGroup: "Invalid value provided for {{ field }} field",
      unionOfTypes: "Invalid value provided for {{ field }} field"
    }
  },
  git: {
    hooks: {
      "pre-commit": "lint-staged"
    },
    scopes: [
      "",
      "ci",
      "deps",
      "dx",
      "release",
      "docs",
      "test",
      "core",
      "actions",
      "arrays",
      "auth",
      "build",
      "cache",
      "cli",
      "cloud",
      "collections",
      "config",
      "database",
      "datetime",
      "docs",
      "errors",
      "git",
      "lint",
      "x-ray",
      "modules",
      "notifications",
      "objects",
      "path",
      "realtime",
      "router",
      "buddy",
      "security",
      "server",
      "storage",
      "strings",
      "tests",
      "types",
      "ui",
      "utils"
    ],
    messages: {
      type: "Select the type of change that you\u2019re committing:",
      scope: "Select the SCOPE of this change (optional):",
      customScope: "Select the SCOPE of this change:",
      subject: "Write a SHORT, IMPERATIVE tense description of the change:\n",
      body: 'Provide a LONGER description of the change (optional). Use "|" to break new line:\n',
      breaking: 'List any BREAKING CHANGES (optional). Use "|" to break new line:\n',
      footerPrefixesSelect: "Select the ISSUES type of the change list by this change (optional):",
      customFooterPrefixes: "Input ISSUES prefix:",
      footer: "List any ISSUES by this change. E.g.: #31, #34:\n",
      confirmCommit: "Are you sure you want to proceed with the commit above?"
    },
    types: [
      {
        value: "feat",
        name: "feat:     \u2728  A new feature",
        emoji: ":sparkles:"
      },
      { value: "fix", name: "fix:      \uD83D\uDC1B  A bug fix", emoji: ":bug:" },
      {
        value: "docs",
        name: "docs:     \uD83D\uDCDD  Documentation only changes",
        emoji: ":memo:"
      },
      {
        value: "style",
        name: "style:    \uD83D\uDC84  Changes that do not affect the meaning of the code",
        emoji: ":lipstick:"
      },
      {
        value: "refactor",
        name: "refactor: \u267B\uFE0F   A code change that neither fixes a bug nor adds a feature",
        emoji: ":recycle:"
      },
      {
        value: "perf",
        name: "perf:     \u26A1\uFE0F  A code change that improves performance",
        emoji: ":zap:"
      },
      {
        value: "test",
        name: "test:     \u2705  Adding missing tests or adjusting existing tests",
        emoji: ":white_check_mark:"
      },
      {
        value: "build",
        name: "build:    \uD83D\uDCE6\uFE0F  Changes that affect the build system or external dependencies",
        emoji: ":package:"
      },
      {
        value: "ci",
        name: "ci:       \uD83C\uDFA1  Changes to our CI configuration files and scripts",
        emoji: ":ferris_wheel:"
      },
      {
        value: "chore",
        name: "chore:    \uD83D\uDD28  Other changes that don\u2019t modify src or test files",
        emoji: ":hammer:"
      },
      {
        value: "revert",
        name: "revert:   \u23EA\uFE0F  Reverts a previous commit",
        emoji: ":rewind:"
      }
    ]
  },
  hashing: {
    driver: "argon2",
    bcrypt: {
      rounds: 10,
      cost: 4
    },
    argon2: {
      memory: 65536,
      time: 1
    }
  },
  library: {
    name: "hello-world",
    owner: "@stacksjs",
    repository: "stacksjs/stacks",
    license: "MIT",
    author: "Chris Breuer",
    contributors: ["Chris Breuer <chris@stacksjs.org>"],
    defaultLanguage: "en",
    vueComponents: {
      name: "hello-world-vue",
      description: "Your Vue component library description",
      keywords: ["component", "library", "vue", "vite", "typescript", "javascript"],
      tags: [
        {
          name: ["HelloWorld", "AppHelloWorld"],
          description: "The Hello World custom element, built via this framework.",
          attributes: [
            {
              name: "greeting",
              description: "The greeting."
            }
          ]
        }
      ]
    },
    webComponents: {
      name: "hello-world-elements",
      description: "Your framework agnostic web component library description.",
      keywords: ["custom-elements", "web-components", "library", "framework-agnostic", "typescript", "javascript"],
      tags: [
        {
          name: ["HelloWorld", "AppHelloWorld"],
          description: "The Hello World custom element, built via this framework.",
          attributes: [
            {
              name: "greeting",
              description: "The greeting."
            }
          ]
        }
      ]
    },
    functions: {
      name: "hello-world-fx",
      description: "Your function library description.",
      keywords: ["functions", "composables", "library", "typescript", "javascript"],
      shouldGenerateSourcemap: false,
      files: ["counter", "dark"]
    }
  },
  logging: {
    logsPath: "storage/logs/stacks.log",
    deploymentsPath: "storage/logs/deployments.log"
  },
  notification: {
    default: "email"
  },
  payment: {
    driver: "stripe"
  },
  ports: {
    frontend: 3000,
    backend: 3001,
    admin: 3002,
    library: 3003,
    desktop: 3004,
    email: 3005,
    docs: 3006,
    inspect: 3007,
    api: 3008,
    systemTray: 3009,
    database: 3010
  },
  queue: {
    default: "sync",
    connections: {
      sync: {
        driver: "sync"
      },
      database: {
        driver: "database",
        table: "jobs",
        queue: "default",
        retry_after: 90
      },
      redis: {
        driver: "redis",
        connection: "default",
        queue: "default",
        retry_after: 90
      },
      sqs: {
        driver: "sqs",
        key: "",
        secret: "",
        prefix: "",
        suffix: "",
        queue: "default",
        region: "us-east-1"
      }
    }
  },
  saas: {
    plans: [
      {
        productName: "Stacks Hobby",
        description: "All the Stacks features.",
        pricing: [
          {
            key: "stacks_hobby_monthly",
            price: 3900,
            interval: "month",
            currency: "usd"
          },
          {
            key: "stacks_hobby_yearly",
            price: 37900,
            interval: "year",
            currency: "usd"
          }
        ],
        metadata: {
          createdBy: "admin",
          version: "1.0.0"
        }
      },
      {
        productName: "Stacks Pro",
        description: "All the Stacks features, including being able to invite team members.",
        pricing: [
          {
            key: "stacks_pro_monthly",
            price: 5900,
            interval: "month",
            currency: "usd"
          },
          {
            key: "stacks_pro_yearly",
            price: 57900,
            interval: "year",
            currency: "usd"
          }
        ],
        metadata: {
          createdBy: "admin",
          version: "1.0.0"
        }
      }
    ],
    webhook: {
      endpoint: "/webhooks/stripe",
      secret: ""
    },
    currencies: ["usd"],
    coupons: [
      {
        code: "SUMMER2024",
        amountOff: 500,
        duration: "once"
      }
    ],
    products: [
      {
        name: "Stacks Pro",
        description: "All the Stacks features.",
        images: ["url_to_image"]
      }
    ]
  },
  searchEngine: {
    driver: "opensearch"
  },
  security: {
    firewall: {
      enabled: true,
      countryCodes: [],
      ipAddresses: [],
      queryString: [],
      httpHeaders: [],
      rateLimitPerMinute: 1000,
      useIpReputationLists: true,
      useKnownBadInputsRuleSet: true
    }
  },
  services: {
    aws: {
      accountId: "",
      appId: "",
      apiKey: "",
      region: "us-east-1"
    },
    algolia: {
      appId: "",
      apiKey: ""
    },
    meilisearch: {
      appId: "",
      apiKey: ""
    },
    stripe: {
      appId: "",
      apiKey: ""
    }
  },
  storage: {
    driver: "s3"
  },
  team: {
    name: "Stacks",
    members: {
      "Chris Breuer": "chris@stacksjs.org"
    }
  },
  ui: {
    shortcuts: [
      [
        "btn",
        "inline-flex items-center px-4 py-2 ml-2 border border-transparent shadow-sm text-base font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 cursor-pointer"
      ]
    ],
    safelist: "prose prose-sm m-auto text-left",
    trigger: ":stx:",
    classPrefix: "stx-",
    reset: "tailwind",
    icons: ["heroicons"],
    fonts: {
      email: {
        title: "Mona",
        text: "Hubot"
      },
      desktop: {
        title: "Mona",
        text: "Hubot"
      },
      mobile: {
        title: "Mona",
        text: "Hubot"
      },
      web: {
        title: "Mona",
        text: "Hubot"
      }
    }
  }
};
var defaults_default = config;
var ai_default = {
  default: "meta.llama2-70b-chat-v1",
  models: [
    "amazon.titan-text-express-v1",
    "amazon.titan-text-lite-v1",
    "meta.llama2-70b-chat-v1"
  ],
  deploy: true
};
var analytics_default = {
  driver: "fathom",
  drivers: {
    googleAnalytics: {
      trackingId: "UA-XXXXXXXXX-X"
    },
    fathom: {
      siteId: "WOLZMJDL"
    }
  }
};
function isString(val2) {
  return typeof val2 === "string";
}
var messages = {
  required: "The {{ field }} field must be defined",
  string: "The {{ field }} field must be a string",
  email: "The {{ field }} field must be a valid email address",
  mobile: "The {{ field }} field must be a valid mobile phone number",
  creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
  passport: "The {{ field }} field must be a valid passport number",
  postalCode: "The {{ field }} field must be a valid postal code",
  regex: "The {{ field }} field format is invalid",
  ascii: "The {{ field }} field must only contain ASCII characters",
  iban: "The {{ field }} field must be a valid IBAN number",
  jwt: "The {{ field }} field must be a valid JWT token",
  coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
  url: "The {{ field }} field must be a valid URL",
  activeUrl: "The {{ field }} field must be a valid URL",
  alpha: "The {{ field }} field must contain only letters",
  alphaNumeric: "The {{ field }} field must contain only letters and numbers",
  minLength: "The {{ field }} field must have at least {{ min }} characters",
  maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
  fixedLength: "The {{ field }} field must be {{ size }} characters long",
  confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
  endsWith: "The {{ field }} field must end with {{ substring }}",
  startsWith: "The {{ field }} field must start with {{ substring }}",
  sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
  notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
  in: "The selected {{ field }} is invalid",
  notIn: "The selected {{ field }} is invalid",
  ipAddress: "The {{ field }} field must be a valid IP address",
  uuid: "The {{ field }} field must be a valid UUID",
  hexCode: "The {{ field }} field must be a valid hex color code",
  boolean: "The value must be a boolean",
  number: "The {{ field }} field must be a number",
  "number.in": "The selected {{ field }} is not in {{ values }}",
  min: "The {{ field }} field must be at least {{ min }}",
  max: "The {{ field }} field must not be greater than {{ max }}",
  range: "The {{ field }} field must be between {{ min }} and {{ max }}",
  positive: "The {{ field }} field must be positive",
  negative: "The {{ field }} field must be negative",
  decimal: "The {{ field }} field must have {{ digits }} decimal places",
  withoutDecimals: "The {{ field }} field must be an integer",
  accepted: "The {{ field }} field must be accepted",
  enum: "The selected {{ field }} is invalid",
  literal: "The {{ field }} field must be {{ expectedValue }}",
  object: "The {{ field }} field must be an object",
  array: "The {{ field }} field must be an array",
  "array.minLength": "The {{ field }} field must have at least {{ min }} items",
  "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
  "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
  notEmpty: "The {{ field }} field must not be empty",
  distinct: "The {{ field }} field has duplicate values",
  record: "The {{ field }} field must be an object",
  "record.minLength": "The {{ field }} field must have at least {{ min }} items",
  "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
  "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
  tuple: "The {{ field }} field must be an array",
  union: "Invalid value provided for {{ field }} field",
  unionGroup: "Invalid value provided for {{ field }} field",
  unionOfTypes: "Invalid value provided for {{ field }} field",
  date: "The {{ field }} field must be a datetime value",
  "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
  "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
  "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
  "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
  "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
  "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
  "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
  "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
  "date.afterOrSameAs": "The {{ field }} field must be a date after or same as {{ otherField }}",
  "date.beforeField": "The {{ field }} field must be a date before {{ otherField }}",
  "date.beforeOrSameAs": "The {{ field }} field must be a date before or same as {{ otherField }}",
  "date.weekend": "The {{ field }} field is not a weekend",
  "date.weekday": "The {{ field }} field is not a weekday"
};
var fields = {
  "": "data"
};
var __defProp22 = Object.defineProperty;
var __export2 = (target, all) => {
  for (var name in all)
    __defProp22(target, name, { get: all[name], enumerable: true });
};
function dlv_es_default(t, e, l3, n, r2) {
  for (e = e.split ? e.split(".") : e, n = 0;n < e.length; n++)
    t = t ? t[e[n]] : r2;
  return t === r2 ? l3 : t;
}
var import_isIP = __toESM2(require_isIP(), 1);
var import_isJWT = __toESM2(require_isJWT(), 1);
var import_isURL = __toESM2(require_isURL(), 1);
var import_isSlug = __toESM2(require_isSlug(), 1);
var import_isIBAN = __toESM2(require_isIBAN(), 1);
var import_isUUID = __toESM2(require_isUUID(), 1);
var import_isAscii = __toESM2(require_isAscii(), 1);
var import_isEmail = __toESM2(require_isEmail(), 1);
var import_isAlpha = __toESM2(require_isAlpha(), 1);
var import_isLatLong = __toESM2(require_isLatLong(), 1);
var import_isDecimal = __toESM2(require_isDecimal(), 1);
var import_isHexColor = __toESM2(require_isHexColor(), 1);
var import_isCreditCard = __toESM2(require_isCreditCard(), 1);
var import_isAlphanumeric = __toESM2(require_isAlphanumeric(), 1);
var import_isPassportNumber = __toESM2(require_isPassportNumber(), 1);
var import_isPostalCode = __toESM2(require_isPostalCode(), 1);
var import_isMobilePhone = __toESM2(require_isMobilePhone(), 1);
var import_isMobilePhone2 = __toESM2(require_isMobilePhone(), 1);
var import_isPostalCode2 = __toESM2(require_isPostalCode(), 1);
var SimpleMessagesProvider = class {
  #messages;
  #fields;
  constructor(messages2, fields2) {
    this.#messages = messages2;
    this.#fields = fields2 || {};
  }
  #interpolate(message, data) {
    if (!message.includes("{{")) {
      return message;
    }
    return message.replace(/(\\)?{{(.*?)}}/g, (_2, __, key) => {
      const tokens = key.trim().split(".");
      let output = data;
      while (tokens.length) {
        if (output === null || typeof output !== "object") {
          return;
        }
        const token = tokens.shift();
        output = Object.hasOwn(output, token) ? output[token] : undefined;
      }
      return output;
    });
  }
  getMessage(rawMessage, rule, field, args) {
    const fieldName = this.#fields[field.name] || field.name;
    const fieldMessage = this.#messages[`${field.getFieldPath()}.${rule}`];
    if (fieldMessage) {
      return this.#interpolate(fieldMessage, {
        field: fieldName,
        ...args
      });
    }
    const wildcardMessage = this.#messages[`${field.wildCardPath}.${rule}`];
    if (wildcardMessage) {
      return this.#interpolate(wildcardMessage, {
        field: fieldName,
        ...args
      });
    }
    const ruleMessage = this.#messages[rule];
    if (ruleMessage) {
      return this.#interpolate(ruleMessage, {
        field: fieldName,
        ...args
      });
    }
    return this.#interpolate(rawMessage, {
      field: fieldName,
      ...args
    });
  }
  toJSON() {
    return {
      messages: this.#messages,
      fields: this.#fields
    };
  }
};
var main_exports = {};
__export2(main_exports, {
  E_VALIDATION_ERROR: () => E_VALIDATION_ERROR
});
var ValidationError = class extends Error {
  constructor(messages2, options2) {
    super("Validation failure", options2);
    this.messages = messages2;
    const ErrorConstructor = this.constructor;
    Error.captureStackTrace(this, ErrorConstructor);
  }
  status = 422;
  code = "E_VALIDATION_ERROR";
  get [Symbol.toStringTag]() {
    return this.constructor.name;
  }
  toString() {
    return `${this.name} [${this.code}]: ${this.message}`;
  }
};
var E_VALIDATION_ERROR = ValidationError;
var SimpleErrorReporter = class {
  hasErrors = false;
  errors = [];
  report(message, rule, field, meta) {
    const error = {
      message,
      rule,
      field: field.getFieldPath()
    };
    if (meta) {
      error.meta = meta;
    }
    if (field.isArrayMember) {
      error.index = field.name;
    }
    this.hasErrors = true;
    this.errors.push(error);
  }
  createError() {
    return new E_VALIDATION_ERROR(this.errors);
  }
};
var BOOLEAN_POSITIVES = ["1", 1, "true", true, "on"];
var BOOLEAN_NEGATIVES = ["0", 0, "false", false];
var helpers3 = {
  exists(value) {
    return value !== null && value !== undefined;
  },
  isMissing(value) {
    return !this.exists(value);
  },
  isTrue(value) {
    return BOOLEAN_POSITIVES.includes(value);
  },
  isFalse(value) {
    return BOOLEAN_NEGATIVES.includes(value);
  },
  isString(value) {
    return typeof value === "string";
  },
  isObject(value) {
    return !!(value && typeof value === "object" && !Array.isArray(value));
  },
  hasKeys(value, keys) {
    for (let key of keys) {
      if (key in value === false) {
        return false;
      }
    }
    return true;
  },
  isArray(value) {
    return Array.isArray(value);
  },
  isNumeric(value) {
    return !Number.isNaN(Number(value));
  },
  asNumber(value) {
    return value === null ? Number.NaN : Number(value);
  },
  asBoolean(value) {
    if (this.isTrue(value)) {
      return true;
    }
    if (this.isFalse(value)) {
      return false;
    }
    return null;
  },
  isEmail: import_isEmail.default.default,
  isURL: import_isURL.default.default,
  isAlpha: import_isAlpha.default.default,
  isAlphaNumeric: import_isAlphanumeric.default.default,
  isIP: import_isIP.default.default,
  isUUID: import_isUUID.default.default,
  isAscii: import_isAscii.default.default,
  isCreditCard: import_isCreditCard.default.default,
  isIBAN: import_isIBAN.default.default,
  isJWT: import_isJWT.default.default,
  isLatLong: import_isLatLong.default.default,
  isMobilePhone: import_isMobilePhone.default.default,
  isPassportNumber: import_isPassportNumber.default.default,
  isPostalCode: import_isPostalCode.default.default,
  isSlug: import_isSlug.default.default,
  isDecimal: import_isDecimal.default.default,
  mobileLocales: import_isMobilePhone2.locales,
  postalCountryCodes: import_isPostalCode2.locales,
  passportCountryCodes: [
    "AM",
    "AR",
    "AT",
    "AU",
    "AZ",
    "BE",
    "BG",
    "BR",
    "BY",
    "CA",
    "CH",
    "CY",
    "CZ",
    "DE",
    "DK",
    "DZ",
    "ES",
    "FI",
    "FR",
    "GB",
    "GR",
    "HR",
    "HU",
    "IE",
    "IN",
    "ID",
    "IR",
    "IS",
    "IT",
    "JM",
    "JP",
    "KR",
    "KZ",
    "LI",
    "LT",
    "LU",
    "LV",
    "LY",
    "MT",
    "MZ",
    "MY",
    "MX",
    "NL",
    "NZ",
    "PH",
    "PK",
    "PL",
    "PT",
    "RO",
    "RU",
    "SE",
    "SL",
    "SK",
    "TH",
    "TR",
    "UA",
    "US"
  ],
  isHexColor: (value) => {
    if (!value.startsWith("#")) {
      return false;
    }
    return import_isHexColor.default.default(value);
  },
  isActiveURL: async (url) => {
    const { resolve4, resolve6 } = await import("dns/promises");
    try {
      const { hostname } = new URL(url);
      const v6Addresses = await resolve6(hostname);
      if (v6Addresses.length) {
        return true;
      } else {
        const v4Addresses = await resolve4(hostname);
        return v4Addresses.length > 0;
      }
    } catch {
      return false;
    }
  },
  isDistinct: (dataSet, fields2) => {
    const uniqueItems = /* @__PURE__ */ new Set;
    if (!fields2) {
      for (let item of dataSet) {
        if (helpers3.exists(item)) {
          if (uniqueItems.has(item)) {
            return false;
          } else {
            uniqueItems.add(item);
          }
        }
      }
      return true;
    }
    const fieldsList = Array.isArray(fields2) ? fields2 : [fields2];
    for (let item of dataSet) {
      if (helpers3.isObject(item) && helpers3.hasKeys(item, fieldsList)) {
        const element = fieldsList.map((field) => item[field]).join("_");
        if (uniqueItems.has(element)) {
          return false;
        } else {
          uniqueItems.add(element);
        }
      }
    }
    return true;
  },
  getNestedValue(key, field) {
    if (key.indexOf(".") > -1) {
      return dlv_es_default(field.data, key);
    }
    return field.parent[key];
  }
};
var Macroable = class {
  static macro(name, value) {
    this.prototype[name] = value;
  }
  static getter(name, accumulator, singleton = false) {
    Object.defineProperty(this.prototype, name, {
      get() {
        const value = accumulator.call(this);
        if (singleton) {
          Object.defineProperty(this, name, {
            configurable: false,
            enumerable: false,
            value,
            writable: false
          });
        }
        return value;
      },
      configurable: true,
      enumerable: false
    });
  }
};
var UPPERCASE = /[\p{Lu}]/u;
var LOWERCASE = /[\p{Ll}]/u;
var LEADING_CAPITAL = /^[\p{Lu}](?![\p{Lu}])/gu;
var IDENTIFIER = /([\p{Alpha}\p{N}_]|$)/u;
var SEPARATORS = /[_.\- ]+/;
var LEADING_SEPARATORS = new RegExp("^" + SEPARATORS.source);
var SEPARATORS_AND_IDENTIFIER = new RegExp(SEPARATORS.source + IDENTIFIER.source, "gu");
var NUMBERS_AND_IDENTIFIER = new RegExp("\\d+" + IDENTIFIER.source, "gu");
var preserveCamelCase = (string2, toLowerCase, toUpperCase, preserveConsecutiveUppercase) => {
  let isLastCharLower = false;
  let isLastCharUpper = false;
  let isLastLastCharUpper = false;
  let isLastLastCharPreserved = false;
  for (let index = 0;index < string2.length; index++) {
    const character = string2[index];
    isLastLastCharPreserved = index > 2 ? string2[index - 3] === "-" : true;
    if (isLastCharLower && UPPERCASE.test(character)) {
      string2 = string2.slice(0, index) + "-" + string2.slice(index);
      isLastCharLower = false;
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = true;
      index++;
    } else if (isLastCharUpper && isLastLastCharUpper && LOWERCASE.test(character) && (!isLastLastCharPreserved || preserveConsecutiveUppercase)) {
      string2 = string2.slice(0, index - 1) + "-" + string2.slice(index - 1);
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = false;
      isLastCharLower = true;
    } else {
      isLastCharLower = toLowerCase(character) === character && toUpperCase(character) !== character;
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = toUpperCase(character) === character && toLowerCase(character) !== character;
    }
  }
  return string2;
};
var preserveConsecutiveUppercase = (input, toLowerCase) => {
  LEADING_CAPITAL.lastIndex = 0;
  return input.replaceAll(LEADING_CAPITAL, (match) => toLowerCase(match));
};
var postProcess = (input, toUpperCase) => {
  SEPARATORS_AND_IDENTIFIER.lastIndex = 0;
  NUMBERS_AND_IDENTIFIER.lastIndex = 0;
  return input.replaceAll(NUMBERS_AND_IDENTIFIER, (match, pattern, offset) => ["_", "-"].includes(input.charAt(offset + match.length)) ? match : toUpperCase(match)).replaceAll(SEPARATORS_AND_IDENTIFIER, (_2, identifier) => toUpperCase(identifier));
};
function camelCase2(input, options2) {
  if (!(typeof input === "string" || Array.isArray(input))) {
    throw new TypeError("Expected the input to be `string | string[]`");
  }
  options2 = {
    pascalCase: false,
    preserveConsecutiveUppercase: false,
    ...options2
  };
  if (Array.isArray(input)) {
    input = input.map((x2) => x2.trim()).filter((x2) => x2.length).join("-");
  } else {
    input = input.trim();
  }
  if (input.length === 0) {
    return "";
  }
  const toLowerCase = options2.locale === false ? (string2) => string2.toLowerCase() : (string2) => string2.toLocaleLowerCase(options2.locale);
  const toUpperCase = options2.locale === false ? (string2) => string2.toUpperCase() : (string2) => string2.toLocaleUpperCase(options2.locale);
  if (input.length === 1) {
    if (SEPARATORS.test(input)) {
      return "";
    }
    return options2.pascalCase ? toUpperCase(input) : toLowerCase(input);
  }
  const hasUpperCase = input !== toLowerCase(input);
  if (hasUpperCase) {
    input = preserveCamelCase(input, toLowerCase, toUpperCase, options2.preserveConsecutiveUppercase);
  }
  input = input.replace(LEADING_SEPARATORS, "");
  input = options2.preserveConsecutiveUppercase ? preserveConsecutiveUppercase(input, toLowerCase) : toLowerCase(input);
  if (options2.pascalCase) {
    input = toUpperCase(input.charAt(0)) + input.slice(1);
  }
  return postProcess(input, toUpperCase);
}
var import_dayjs = __toESM2(require_dayjs_min(), 1);
var import_dayjs2 = __toESM2(require_dayjs_min(), 1);
var import_isSameOrAfter = __toESM2(require_isSameOrAfter(), 1);
var import_isSameOrBefore = __toESM2(require_isSameOrBefore(), 1);
var import_customParseFormat = __toESM2(require_customParseFormat(), 1);
var DATA_URL_DEFAULT_MIME_TYPE = "text/plain";
var DATA_URL_DEFAULT_CHARSET = "us-ascii";
var testParameter = (name, filters) => filters.some((filter) => filter instanceof RegExp ? filter.test(name) : filter === name);
var supportedProtocols = new Set([
  "https:",
  "http:",
  "file:"
]);
var hasCustomProtocol = (urlString) => {
  try {
    const { protocol } = new URL(urlString);
    return protocol.endsWith(":") && !protocol.includes(".") && !supportedProtocols.has(protocol);
  } catch {
    return false;
  }
};
var normalizeDataURL = (urlString, { stripHash }) => {
  const match = /^data:(?<type>[^,]*?),(?<data>[^#]*?)(?:#(?<hash>.*))?$/.exec(urlString);
  if (!match) {
    throw new Error(`Invalid URL: ${urlString}`);
  }
  let { type, data, hash } = match.groups;
  const mediaType = type.split(";");
  hash = stripHash ? "" : hash;
  let isBase64 = false;
  if (mediaType[mediaType.length - 1] === "base64") {
    mediaType.pop();
    isBase64 = true;
  }
  const mimeType = mediaType.shift()?.toLowerCase() ?? "";
  const attributes = mediaType.map((attribute) => {
    let [key, value = ""] = attribute.split("=").map((string2) => string2.trim());
    if (key === "charset") {
      value = value.toLowerCase();
      if (value === DATA_URL_DEFAULT_CHARSET) {
        return "";
      }
    }
    return `${key}${value ? `=${value}` : ""}`;
  }).filter(Boolean);
  const normalizedMediaType = [
    ...attributes
  ];
  if (isBase64) {
    normalizedMediaType.push("base64");
  }
  if (normalizedMediaType.length > 0 || mimeType && mimeType !== DATA_URL_DEFAULT_MIME_TYPE) {
    normalizedMediaType.unshift(mimeType);
  }
  return `data:${normalizedMediaType.join(";")},${isBase64 ? data.trim() : data}${hash ? `#${hash}` : ""}`;
};
function normalizeUrl(urlString, options2) {
  options2 = {
    defaultProtocol: "http",
    normalizeProtocol: true,
    forceHttp: false,
    forceHttps: false,
    stripAuthentication: true,
    stripHash: false,
    stripTextFragment: true,
    stripWWW: true,
    removeQueryParameters: [/^utm_\w+/i],
    removeTrailingSlash: true,
    removeSingleSlash: true,
    removeDirectoryIndex: false,
    removeExplicitPort: false,
    sortQueryParameters: true,
    ...options2
  };
  if (typeof options2.defaultProtocol === "string" && !options2.defaultProtocol.endsWith(":")) {
    options2.defaultProtocol = `${options2.defaultProtocol}:`;
  }
  urlString = urlString.trim();
  if (/^data:/i.test(urlString)) {
    return normalizeDataURL(urlString, options2);
  }
  if (hasCustomProtocol(urlString)) {
    return urlString;
  }
  const hasRelativeProtocol = urlString.startsWith("//");
  const isRelativeUrl = !hasRelativeProtocol && /^\.*\//.test(urlString);
  if (!isRelativeUrl) {
    urlString = urlString.replace(/^(?!(?:\w+:)?\/\/)|^\/\//, options2.defaultProtocol);
  }
  const urlObject = new URL(urlString);
  if (options2.forceHttp && options2.forceHttps) {
    throw new Error("The `forceHttp` and `forceHttps` options cannot be used together");
  }
  if (options2.forceHttp && urlObject.protocol === "https:") {
    urlObject.protocol = "http:";
  }
  if (options2.forceHttps && urlObject.protocol === "http:") {
    urlObject.protocol = "https:";
  }
  if (options2.stripAuthentication) {
    urlObject.username = "";
    urlObject.password = "";
  }
  if (options2.stripHash) {
    urlObject.hash = "";
  } else if (options2.stripTextFragment) {
    urlObject.hash = urlObject.hash.replace(/#?:~:text.*?$/i, "");
  }
  if (urlObject.pathname) {
    const protocolRegex = /\b[a-z][a-z\d+\-.]{1,50}:\/\//g;
    let lastIndex = 0;
    let result2 = "";
    for (;; ) {
      const match = protocolRegex.exec(urlObject.pathname);
      if (!match) {
        break;
      }
      const protocol = match[0];
      const protocolAtIndex = match.index;
      const intermediate = urlObject.pathname.slice(lastIndex, protocolAtIndex);
      result2 += intermediate.replace(/\/{2,}/g, "/");
      result2 += protocol;
      lastIndex = protocolAtIndex + protocol.length;
    }
    const remnant = urlObject.pathname.slice(lastIndex, urlObject.pathname.length);
    result2 += remnant.replace(/\/{2,}/g, "/");
    urlObject.pathname = result2;
  }
  if (urlObject.pathname) {
    try {
      urlObject.pathname = decodeURI(urlObject.pathname);
    } catch {
    }
  }
  if (options2.removeDirectoryIndex === true) {
    options2.removeDirectoryIndex = [/^index\.[a-z]+$/];
  }
  if (Array.isArray(options2.removeDirectoryIndex) && options2.removeDirectoryIndex.length > 0) {
    let pathComponents = urlObject.pathname.split("/");
    const lastComponent = pathComponents[pathComponents.length - 1];
    if (testParameter(lastComponent, options2.removeDirectoryIndex)) {
      pathComponents = pathComponents.slice(0, -1);
      urlObject.pathname = pathComponents.slice(1).join("/") + "/";
    }
  }
  if (urlObject.hostname) {
    urlObject.hostname = urlObject.hostname.replace(/\.$/, "");
    if (options2.stripWWW && /^www\.(?!www\.)[a-z\-\d]{1,63}\.[a-z.\-\d]{2,63}$/.test(urlObject.hostname)) {
      urlObject.hostname = urlObject.hostname.replace(/^www\./, "");
    }
  }
  if (Array.isArray(options2.removeQueryParameters)) {
    for (const key of [...urlObject.searchParams.keys()]) {
      if (testParameter(key, options2.removeQueryParameters)) {
        urlObject.searchParams.delete(key);
      }
    }
  }
  if (!Array.isArray(options2.keepQueryParameters) && options2.removeQueryParameters === true) {
    urlObject.search = "";
  }
  if (Array.isArray(options2.keepQueryParameters) && options2.keepQueryParameters.length > 0) {
    for (const key of [...urlObject.searchParams.keys()]) {
      if (!testParameter(key, options2.keepQueryParameters)) {
        urlObject.searchParams.delete(key);
      }
    }
  }
  if (options2.sortQueryParameters) {
    urlObject.searchParams.sort();
    try {
      urlObject.search = decodeURIComponent(urlObject.search);
    } catch {
    }
  }
  if (options2.removeTrailingSlash) {
    urlObject.pathname = urlObject.pathname.replace(/\/$/, "");
  }
  if (options2.removeExplicitPort && urlObject.port) {
    urlObject.port = "";
  }
  const oldUrlString = urlString;
  urlString = urlObject.toString();
  if (!options2.removeSingleSlash && urlObject.pathname === "/" && !oldUrlString.endsWith("/") && urlObject.hash === "") {
    urlString = urlString.replace(/\/$/, "");
  }
  if ((options2.removeTrailingSlash || urlObject.pathname === "/") && urlObject.hash === "" && options2.removeSingleSlash) {
    urlString = urlString.replace(/\/$/, "");
  }
  if (hasRelativeProtocol && !options2.normalizeProtocol) {
    urlString = urlString.replace(/^http:\/\//, "//");
  }
  if (options2.stripProtocol) {
    urlString = urlString.replace(/^(?:https?:)?\/\//, "");
  }
  return urlString;
}
var import_escape = __toESM2(require_escape(), 1);
var import_normalizeEmail = __toESM2(require_normalizeEmail(), 1);
var CompilerBuffer = class _CompilerBuffer {
  #content = "";
  newLine = "\n";
  writeStatement(statement) {
    this.#content = `${this.#content}${this.newLine}${statement}`;
  }
  child() {
    return new _CompilerBuffer;
  }
  toString() {
    return this.#content;
  }
  flush() {
    this.#content = "";
  }
};
function defineFieldVariables({
  parseFnRefId,
  variableName,
  wildCardPath,
  isArrayMember,
  valueExpression,
  parentExpression,
  fieldNameExpression,
  parentValueExpression
}) {
  const inValueExpression = parseFnRefId ? `refs['${parseFnRefId}'](${valueExpression}, {
      data: root,
      meta: meta,
      parent: ${parentValueExpression}
    })` : valueExpression;
  let fieldPathOutputExpression = "";
  if (parentExpression === "root" || parentExpression === "root_item") {
    fieldPathOutputExpression = fieldNameExpression;
  } else if (fieldNameExpression !== "''") {
    fieldPathOutputExpression = `${parentExpression}.getFieldPath() + '.' + ${fieldNameExpression}`;
  }
  return `const ${variableName} = defineValue(${inValueExpression}, {
  data: root,
  meta: meta,
  name: ${fieldNameExpression},
  wildCardPath: '${wildCardPath}',
  getFieldPath() {
    return ${fieldPathOutputExpression};
  },
  mutate: defineValue,
  report: report,
  isValid: true,
  parent: ${parentValueExpression},
  isArrayMember: ${isArrayMember},
});`;
}
var BaseNode = class {
  #node;
  #parentField;
  field;
  constructor(node, compiler, parent, parentField) {
    this.#parentField = parentField;
    this.#node = node;
    if (this.#parentField) {
      this.field = this.#parentField;
    } else {
      compiler.variablesCounter++;
      this.field = compiler.createFieldFor(node, parent);
    }
  }
  defineField(buffer) {
    if (!this.#parentField) {
      buffer.writeStatement(defineFieldVariables({
        fieldNameExpression: this.field.fieldNameExpression,
        isArrayMember: this.field.isArrayMember,
        parentExpression: this.field.parentExpression,
        parentValueExpression: this.field.parentValueExpression,
        valueExpression: this.field.valueExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath,
        parseFnRefId: "parseFnId" in this.#node ? this.#node.parseFnId : undefined
      }));
    }
  }
};
function defineArrayGuard({ variableName, guardedCodeSnippet }) {
  return `if (ensureIsArray(${variableName})) {
${guardedCodeSnippet}
}`;
}
function defineIsValidGuard({ variableName, bail, guardedCodeSnippet }) {
  if (!bail) {
    return guardedCodeSnippet;
  }
  return `if (${variableName}.isValid) {
${guardedCodeSnippet}
}`;
}
function defineFieldNullOutput({
  allowNull,
  conditional,
  variableName,
  outputExpression,
  transformFnRefId
}) {
  if (!allowNull) {
    return "";
  }
  return `${conditional || "if"}(${variableName}.value === null) {
  ${outputExpression} = ${transformFnRefId ? `refs['${transformFnRefId}'](null, ${variableName});` : "null;"}
}`;
}
function wrapInConditional(conditions, wrappingCode) {
  const [first, second] = conditions;
  if (first && second) {
    return `if (${first} && ${second}) {
  ${wrappingCode}
}`;
  }
  if (first) {
    return `if (${first}) {
  ${wrappingCode}
}`;
  }
  if (second) {
    return `if (${second}) {
  ${wrappingCode}
}`;
  }
  return wrappingCode;
}
function emitValidationSnippet({ isAsync, implicit, ruleFnId }, variableName, bail, dropMissingCheck) {
  const rule = `refs['${ruleFnId}']`;
  const callable = `${rule}.validator(${variableName}.value, ${rule}.options, ${variableName});`;
  const bailCondition = bail ? `${variableName}.isValid` : "";
  const implicitCondition = implicit || dropMissingCheck ? "" : `${variableName}.isDefined`;
  return wrapInConditional([bailCondition, implicitCondition], isAsync ? `await ${callable}` : `${callable}`);
}
function defineFieldValidations({
  bail,
  validations,
  variableName,
  dropMissingCheck
}) {
  return `${validations.map((one) => emitValidationSnippet(one, variableName, bail, dropMissingCheck)).join("\n")}`;
}
function defineArrayInitialOutput({
  variableName,
  outputExpression,
  outputValueExpression
}) {
  return `const ${variableName}_out = ${outputValueExpression};
${outputExpression} = ${variableName}_out;`;
}
function defineFieldExistenceValidations({
  allowNull,
  isOptional,
  variableName
}) {
  if (isOptional === false) {
    if (allowNull === false) {
      return `ensureExists(${variableName});`;
    } else {
      return `ensureIsDefined(${variableName});`;
    }
  }
  return "";
}
var TupleNodeCompiler = class extends BaseNode {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #compileTupleChildren() {
    const buffer = this.#buffer.child();
    const parent = {
      type: "tuple",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    };
    this.#node.properties.forEach((child) => {
      this.#compiler.compileNode(child, buffer, parent);
    });
    return buffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isArrayValidBlock = defineIsValidGuard({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineArrayInitialOutput({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: this.#node.allowUnknownProperties ? `copyProperties(${this.field.variableName}.value)` : `[]`
      })}${this.#compileTupleChildren()}`
    });
    const isValueAnArrayBlock = defineArrayGuard({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${this.#buffer.newLine}${isArrayValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnArrayBlock}${this.#buffer.newLine}${defineFieldNullOutput({
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      conditional: "else if"
    })}`);
  }
};
function defineArrayLoop({
  variableName,
  loopCodeSnippet,
  startingIndex
}) {
  startingIndex = startingIndex || 0;
  return `const ${variableName}_items_size = ${variableName}.value.length;
for (let ${variableName}_i = ${startingIndex}; ${variableName}_i < ${variableName}_items_size; ${variableName}_i++) {
${loopCodeSnippet}
}`;
}
var ArrayNodeCompiler = class extends BaseNode {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #compileArrayElements() {
    const arrayElementsBuffer = this.#buffer.child();
    this.#compiler.compileNode(this.#node.each, arrayElementsBuffer, {
      type: "array",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    });
    const buffer = this.#buffer.child();
    buffer.writeStatement(defineArrayLoop({
      variableName: this.field.variableName,
      startingIndex: 0,
      loopCodeSnippet: arrayElementsBuffer.toString()
    }));
    arrayElementsBuffer.flush();
    return buffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isArrayValidBlock = defineIsValidGuard({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineArrayInitialOutput({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: `[]`
      })}${this.#buffer.newLine}${this.#compileArrayElements()}`
    });
    const isValueAnArrayBlock = defineArrayGuard({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${this.#buffer.newLine}${isArrayValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnArrayBlock}${this.#buffer.newLine}${defineFieldNullOutput({
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      conditional: "else if"
    })}`);
  }
};
function callParseFunction({ parseFnRefId, variableName }) {
  if (parseFnRefId) {
    return `${variableName}.value = refs['${parseFnRefId}'](${variableName}.value);`;
  }
  return "";
}
function defineElseCondition({ variableName, conditionalFnRefId }) {
  return `else {
refs['${conditionalFnRefId}'](${variableName}.value, ${variableName});
}`;
}
function defineConditionalGuard({
  conditional,
  variableName,
  conditionalFnRefId,
  guardedCodeSnippet
}) {
  return `${conditional}(refs['${conditionalFnRefId}'](${variableName}.value, ${variableName})) {
${guardedCodeSnippet}
}`;
}
var UnionNodeCompiler = class extends BaseNode {
  #compiler;
  #node;
  #buffer;
  #parent;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#parent = parent;
    this.#compiler = compiler;
  }
  #compileUnionChildren() {
    const childrenBuffer = this.#buffer.child();
    this.#node.conditions.forEach((child, index) => {
      const conditionalBuffer = this.#buffer.child();
      if ("parseFnId" in child.schema) {
        conditionalBuffer.writeStatement(callParseFunction({
          parseFnRefId: child.schema.parseFnId,
          variableName: this.field.variableName
        }));
      }
      this.#compiler.compileNode(child.schema, conditionalBuffer, this.#parent, this.field);
      childrenBuffer.writeStatement(defineConditionalGuard({
        conditional: index === 0 ? "if" : "else if",
        variableName: this.field.variableName,
        conditionalFnRefId: child.conditionalFnRefId,
        guardedCodeSnippet: conditionalBuffer.toString()
      }));
      conditionalBuffer.flush();
    });
    if (this.#node.elseConditionalFnRefId && this.#node.conditions.length) {
      childrenBuffer.writeStatement(defineElseCondition({
        variableName: this.field.variableName,
        conditionalFnRefId: this.#node.elseConditionalFnRefId
      }));
    }
    return childrenBuffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(this.#compileUnionChildren());
  }
};
function defineRecordLoop({ variableName, loopCodeSnippet }) {
  return `const ${variableName}_keys = Object.keys(${variableName}.value);
const ${variableName}_keys_size = ${variableName}_keys.length;
for (let ${variableName}_key_i = 0; ${variableName}_key_i < ${variableName}_keys_size; ${variableName}_key_i++) {
const ${variableName}_i = ${variableName}_keys[${variableName}_key_i];
${loopCodeSnippet}
}`;
}
function defineObjectGuard({ variableName, guardedCodeSnippet }) {
  return `if (ensureIsObject(${variableName})) {
${guardedCodeSnippet}
}`;
}
function defineObjectInitialOutput({
  variableName,
  outputExpression,
  outputValueExpression
}) {
  return `const ${variableName}_out = ${outputValueExpression};
${outputExpression} = ${variableName}_out;`;
}
var RecordNodeCompiler = class extends BaseNode {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #compileRecordElements() {
    const buffer = this.#buffer.child();
    const recordElementsBuffer = this.#buffer.child();
    this.#compiler.compileNode(this.#node.each, recordElementsBuffer, {
      type: "record",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    });
    buffer.writeStatement(defineRecordLoop({
      variableName: this.field.variableName,
      loopCodeSnippet: recordElementsBuffer.toString()
    }));
    recordElementsBuffer.flush();
    return buffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isObjectValidBlock = defineIsValidGuard({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineObjectInitialOutput({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: `{}`
      })}${this.#compileRecordElements()}`
    });
    const isValueAnObjectBlock = defineObjectGuard({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${this.#buffer.newLine}${isObjectValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnObjectBlock}${this.#buffer.newLine}${defineFieldNullOutput({
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      conditional: "else if"
    })}`);
  }
};
function arrayToString(arr) {
  return `[${arr.map((str) => `"${str}"`).join(", ")}]`;
}
function defineMoveProperties({
  variableName,
  fieldsToIgnore,
  allowUnknownProperties
}) {
  if (!allowUnknownProperties) {
    return "";
  }
  const serializedFieldsToIgnore = arrayToString(fieldsToIgnore);
  return `moveProperties(${variableName}.value, ${variableName}_out, ${serializedFieldsToIgnore});`;
}
var ObjectNodeCompiler = class extends BaseNode {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #getFieldNames(node) {
    let fieldNames = node.properties.map((child) => child.fieldName);
    const groupsFieldNames = node.groups.flatMap((group) => this.#getGroupFieldNames(group));
    return fieldNames.concat(groupsFieldNames);
  }
  #getGroupFieldNames(group) {
    return group.conditions.flatMap((condition) => {
      return this.#getFieldNames(condition.schema);
    });
  }
  #compileObjectChildren() {
    const buffer = this.#buffer.child();
    const parent = {
      type: "object",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    };
    this.#node.properties.forEach((child) => this.#compiler.compileNode(child, buffer, parent));
    return buffer.toString();
  }
  #compileObjectGroups() {
    const buffer = this.#buffer.child();
    const parent = {
      type: "object",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    };
    this.#node.groups.forEach((group) => this.#compileObjectGroup(group, buffer, parent));
    return buffer.toString();
  }
  #compileObjectGroup(group, buffer, parent) {
    group.conditions.forEach((condition, index) => {
      const guardBuffer = buffer.child();
      condition.schema.properties.forEach((child) => {
        this.#compiler.compileNode(child, guardBuffer, parent);
      });
      condition.schema.groups.forEach((child) => {
        this.#compileObjectGroup(child, guardBuffer, parent);
      });
      buffer.writeStatement(defineConditionalGuard({
        variableName: this.field.variableName,
        conditional: index === 0 ? "if" : "else if",
        conditionalFnRefId: condition.conditionalFnRefId,
        guardedCodeSnippet: guardBuffer.toString()
      }));
    });
    if (group.elseConditionalFnRefId && group.conditions.length) {
      buffer.writeStatement(defineElseCondition({
        variableName: this.field.variableName,
        conditionalFnRefId: group.elseConditionalFnRefId
      }));
    }
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isObjectValidBlock = defineIsValidGuard({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineObjectInitialOutput({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: "{}"
      })}${this.#buffer.newLine}${this.#compileObjectChildren()}${this.#buffer.newLine}${this.#compileObjectGroups()}${this.#buffer.newLine}${defineMoveProperties({
        variableName: this.field.variableName,
        allowUnknownProperties: this.#node.allowUnknownProperties,
        fieldsToIgnore: this.#node.allowUnknownProperties ? this.#getFieldNames(this.#node) : []
      })}`
    });
    const isValueAnObject = defineObjectGuard({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${isObjectValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnObject}${this.#buffer.newLine}${defineFieldNullOutput({
      variableName: this.field.variableName,
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      conditional: "else if"
    })}`);
  }
};
function createRootField(parent) {
  return {
    parentExpression: parent.variableName,
    parentValueExpression: parent.variableName,
    fieldNameExpression: `''`,
    fieldPathExpression: `''`,
    wildCardPath: "",
    variableName: `${parent.variableName}_item`,
    valueExpression: "root",
    outputExpression: parent.outputExpression,
    isArrayMember: false
  };
}
function defineFieldValueOutput({
  variableName,
  outputExpression,
  transformFnRefId
}) {
  const outputValueExpression = transformFnRefId ? `refs['${transformFnRefId}'](${variableName}.value, ${variableName})` : `${variableName}.value`;
  return `if (${variableName}.isDefined && ${variableName}.isValid) {
  ${outputExpression} = ${outputValueExpression};
}`;
}
var LiteralNodeCompiler = class extends BaseNode {
  #node;
  #buffer;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    this.#buffer.writeStatement(defineFieldValidations({
      variableName: this.field.variableName,
      validations: this.#node.validations,
      bail: this.#node.bail,
      dropMissingCheck: false
    }));
    this.#buffer.writeStatement(`${defineFieldValueOutput({
      variableName: this.field.variableName,
      outputExpression: this.field.outputExpression,
      transformFnRefId: this.#node.transformFnId
    })}${this.#buffer.newLine}${defineFieldNullOutput({
      variableName: this.field.variableName,
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      transformFnRefId: this.#node.transformFnId,
      conditional: "else if"
    })}`);
  }
};
function createArrayField(parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.*` : `*`;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${parent.variableName}_i`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item`,
    valueExpression: `${parent.variableName}.value[${parent.variableName}_i]`,
    outputExpression: `${parent.variableName}_out[${parent.variableName}_i]`,
    isArrayMember: true
  };
}
function createTupleField(node, parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.${node.fieldName}` : node.fieldName;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${node.fieldName}`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item_${node.fieldName}`,
    valueExpression: `${parent.variableName}.value[${node.fieldName}]`,
    outputExpression: `${parent.variableName}_out[${node.propertyName}]`,
    isArrayMember: true
  };
}
function reportErrors() {
  return `if(errorReporter.hasErrors) {
  throw errorReporter.createError();
}`;
}
function createObjectField(node, variablesCounter, parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.${node.fieldName}` : node.fieldName;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `'${node.fieldName}'`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${node.propertyName}_${variablesCounter}`,
    valueExpression: `${parent.variableName}.value['${node.fieldName}']`,
    outputExpression: `${parent.variableName}_out['${node.propertyName}']`,
    isArrayMember: false
  };
}
function createRecordField(parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.*` : `*`;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${parent.variableName}_i`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item`,
    valueExpression: `${parent.variableName}.value[${parent.variableName}_i]`,
    outputExpression: `${parent.variableName}_out[${parent.variableName}_i]`,
    isArrayMember: false
  };
}
function defineInlineFunctions(options2) {
  return `function report(message, rule, field, args) {
  field.isValid = false;
  errorReporter.report(messagesProvider.getMessage(message, rule, field, args), rule, field, args);
};
function defineValue(value, field) {
  ${options2.convertEmptyStringsToNull ? `if (value === '') { value = null; }` : ""}
  field.value = value;
  field.isDefined = value !== undefined && value !== null;
  return field;
};
function ensureExists(field) {
  if (field.value === undefined || field.value === null) {
    field.report(REQUIRED, 'required', field);
    return false;
  }
  return true;
};
function ensureIsDefined(field) {
  if (field.value === undefined) {
    field.report(REQUIRED, 'required', field);
    return false;
  }
  return true;
};
function ensureIsObject(field) {
  if (!field.isDefined) {
    return false;
  }
  if (typeof field.value == 'object' && !Array.isArray(field.value)) {
    return true;
  }
  field.report(NOT_AN_OBJECT, 'object', field);
  return false;
};
function ensureIsArray(field) {
  if (!field.isDefined) {
    return false;
  }
  if (Array.isArray(field.value)) {
    return true;
  }
  field.report(NOT_AN_ARRAY, 'array', field);
  return false;
};
function copyProperties(val) {
  let k, out, tmp;

  if (Array.isArray(val)) {
    out = Array((k = val.length))
    while (k--) out[k] = (tmp = val[k]) && typeof tmp == 'object' ? copyProperties(tmp) : tmp
    return out
  }

  if (Object.prototype.toString.call(val) === '[object Object]') {
    out = {} // null
    for (k in val) {
      out[k] = (tmp = val[k]) && typeof tmp == 'object' ? copyProperties(tmp) : tmp
    }
    return out
  }
  return val
};
function moveProperties(source, destination, ignoreKeys) {
  for (let key in source) {
    if (!ignoreKeys.includes(key)) {
      const value = source[key]
      destination[key] = copyProperties(value)
    }
  }
};`;
}
function defineInlineErrorMessages(messages2) {
  return `const REQUIRED = '${messages2.required}';
const NOT_AN_OBJECT = '${messages2.object}';
const NOT_AN_ARRAY = '${messages2.array}';`;
}
var AsyncFunction = Object.getPrototypeOf(async function() {
}).constructor;
var Compiler = class {
  variablesCounter = 0;
  #rootNode;
  #options;
  #buffer = new CompilerBuffer;
  constructor(rootNode, options2) {
    this.#rootNode = rootNode;
    this.#options = options2 || { convertEmptyStringsToNull: false };
  }
  #initiateJSOutput() {
    this.#buffer.writeStatement(defineInlineErrorMessages({
      required: "value is required",
      object: "value is not a valid object",
      array: "value is not a valid array",
      ...this.#options.messages
    }));
    this.#buffer.writeStatement(defineInlineFunctions(this.#options));
    this.#buffer.writeStatement("let out;");
  }
  #finishJSOutput() {
    this.#buffer.writeStatement(reportErrors());
    this.#buffer.writeStatement("return out;");
  }
  #compileNodes() {
    this.compileNode(this.#rootNode.schema, this.#buffer, {
      type: "root",
      variableName: "root",
      outputExpression: "out",
      fieldPathExpression: "out",
      wildCardPath: ""
    });
  }
  #toAsyncFunction() {
    return new AsyncFunction("root", "meta", "refs", "messagesProvider", "errorReporter", this.#buffer.toString());
  }
  createFieldFor(node, parent) {
    switch (parent.type) {
      case "array":
        return createArrayField(parent);
      case "root":
        return createRootField(parent);
      case "object":
        return createObjectField(node, this.variablesCounter, parent);
      case "tuple":
        return createTupleField(node, parent);
      case "record":
        return createRecordField(parent);
    }
  }
  compileNode(node, buffer, parent, parentField) {
    switch (node.type) {
      case "literal":
        return new LiteralNodeCompiler(node, buffer, this, parent, parentField).compile();
      case "array":
        return new ArrayNodeCompiler(node, buffer, this, parent, parentField).compile();
      case "record":
        return new RecordNodeCompiler(node, buffer, this, parent, parentField).compile();
      case "object":
        return new ObjectNodeCompiler(node, buffer, this, parent, parentField).compile();
      case "tuple":
        return new TupleNodeCompiler(node, buffer, this, parent, parentField).compile();
      case "union":
        return new UnionNodeCompiler(node, buffer, this, parent, parentField).compile();
    }
  }
  compile() {
    this.#initiateJSOutput();
    this.#compileNodes();
    this.#finishJSOutput();
    const outputFunction = this.#toAsyncFunction();
    this.variablesCounter = 0;
    this.#buffer.flush();
    return outputFunction;
  }
};
function refsBuilder() {
  let counter = 0;
  const refs = {};
  return {
    toJSON() {
      return refs;
    },
    track(value) {
      counter++;
      const ref = `ref://${counter}`;
      refs[ref] = value;
      return ref;
    },
    trackValidation(validation) {
      return this.track(validation);
    },
    trackParser(fn) {
      return this.track(fn);
    },
    trackTransformer(fn) {
      return this.track(fn);
    },
    trackConditional(fn) {
      return this.track(fn);
    }
  };
}
function createRule(validator, metaData) {
  const rule = {
    validator,
    isAsync: metaData?.isAsync || validator.constructor.name === "AsyncFunction",
    implicit: metaData?.implicit ?? false
  };
  return function(...options2) {
    return {
      rule,
      options: options2[0]
    };
  };
}
var symbols_exports = {};
__export2(symbols_exports, {
  COTYPE: () => COTYPE,
  IS_OF_TYPE: () => IS_OF_TYPE,
  ITYPE: () => ITYPE,
  OTYPE: () => OTYPE,
  PARSE: () => PARSE,
  UNIQUE_NAME: () => UNIQUE_NAME,
  VALIDATION: () => VALIDATION
});
var UNIQUE_NAME = Symbol.for("schema_name");
var IS_OF_TYPE = Symbol.for("is_of_type");
var PARSE = Symbol.for("parse");
var ITYPE = Symbol.for("opaque_input_type");
var OTYPE = Symbol.for("opaque_type");
var COTYPE = Symbol.for("camelcase_opaque_type");
var VALIDATION = Symbol.for("to_validation");
var requiredWhen = createRule((_2, checker, field) => {
  const shouldBeRequired = checker(field);
  if (!field.isDefined && shouldBeRequired) {
    field.report(messages.required, "required", field);
  }
}, {
  implicit: true
});
var BaseModifiersType = class extends Macroable {
  optional(validations) {
    return new OptionalModifier(this, validations);
  }
  nullable() {
    return new NullableModifier(this);
  }
  transform(transformer) {
    return new TransformModifier(transformer, this);
  }
};
var NullableModifier = class _NullableModifier extends BaseModifiersType {
  #parent;
  constructor(parent) {
    super();
    this.#parent = parent;
  }
  clone() {
    return new _NullableModifier(this.#parent.clone());
  }
  [PARSE](propertyName, refs, options2) {
    const output = this.#parent[PARSE](propertyName, refs, options2);
    output.allowNull = true;
    return output;
  }
};
var OptionalModifier = class _OptionalModifier extends BaseModifiersType {
  #parent;
  validations;
  constructor(parent, validations) {
    super();
    this.#parent = parent;
    this.validations = validations || [];
  }
  cloneValidations() {
    return this.validations.map((validation) => {
      return {
        options: validation.options,
        rule: validation.rule
      };
    });
  }
  compileValidations(refs) {
    return this.validations.map((validation) => {
      return {
        ruleFnId: refs.track({
          validator: validation.rule.validator,
          options: validation.options
        }),
        implicit: validation.rule.implicit,
        isAsync: validation.rule.isAsync
      };
    });
  }
  use(validation) {
    this.validations.push(VALIDATION in validation ? validation[VALIDATION]() : validation);
    return this;
  }
  requiredWhen(otherField, operator, expectedValue) {
    if (typeof otherField === "function") {
      return this.use(requiredWhen(otherField));
    }
    let checker;
    switch (operator) {
      case "=":
        checker = (value) => value === expectedValue;
        break;
      case "!=":
        checker = (value) => value !== expectedValue;
        break;
      case "in":
        checker = (value) => expectedValue.includes(value);
        break;
      case "notIn":
        checker = (value) => !expectedValue.includes(value);
        break;
      case ">":
        checker = (value) => value > expectedValue;
        break;
      case "<":
        checker = (value) => value < expectedValue;
        break;
      case ">=":
        checker = (value) => value >= expectedValue;
        break;
      case "<=":
        checker = (value) => value <= expectedValue;
    }
    return this.use(requiredWhen((field) => {
      const otherFieldValue = helpers3.getNestedValue(otherField, field);
      return checker(otherFieldValue);
    }));
  }
  requiredIfExists(fields2) {
    const fieldsToExist = Array.isArray(fields2) ? fields2 : [fields2];
    return this.use(requiredWhen((field) => {
      return fieldsToExist.every((otherField) => helpers3.exists(helpers3.getNestedValue(otherField, field)));
    }));
  }
  requiredIfAnyExists(fields2) {
    return this.use(requiredWhen((field) => {
      return fields2.some((otherField) => helpers3.exists(helpers3.getNestedValue(otherField, field)));
    }));
  }
  requiredIfMissing(fields2) {
    const fieldsToExist = Array.isArray(fields2) ? fields2 : [fields2];
    return this.use(requiredWhen((field) => {
      return fieldsToExist.every((otherField) => helpers3.isMissing(helpers3.getNestedValue(otherField, field)));
    }));
  }
  requiredIfAnyMissing(fields2) {
    return this.use(requiredWhen((field) => {
      return fields2.some((otherField) => helpers3.isMissing(helpers3.getNestedValue(otherField, field)));
    }));
  }
  clone() {
    return new _OptionalModifier(this.#parent.clone(), this.cloneValidations());
  }
  [PARSE](propertyName, refs, options2) {
    const output = this.#parent[PARSE](propertyName, refs, options2);
    output.isOptional = true;
    output.validations = output.validations.concat(this.compileValidations(refs));
    return output;
  }
};
var TransformModifier = class _TransformModifier extends BaseModifiersType {
  #parent;
  #transform;
  constructor(transform, parent) {
    super();
    this.#transform = transform;
    this.#parent = parent;
  }
  clone() {
    return new _TransformModifier(this.#transform, this.#parent.clone());
  }
  [PARSE](propertyName, refs, options2) {
    const output = this.#parent[PARSE](propertyName, refs, options2);
    output.transformFnId = refs.trackTransformer(this.#transform);
    return output;
  }
};
var BaseLiteralType = class extends BaseModifiersType {
  options;
  validations;
  constructor(options2, validations) {
    super();
    this.options = {
      bail: true,
      allowNull: false,
      isOptional: false,
      ...options2
    };
    this.validations = validations || [];
  }
  cloneValidations() {
    return this.validations.map((validation) => {
      return {
        options: validation.options,
        rule: validation.rule
      };
    });
  }
  cloneOptions() {
    return { ...this.options };
  }
  compileValidations(refs) {
    return this.validations.map((validation) => {
      return {
        ruleFnId: refs.track({
          validator: validation.rule.validator,
          options: validation.options
        }),
        implicit: validation.rule.implicit,
        isAsync: validation.rule.isAsync
      };
    });
  }
  parse(callback) {
    this.options.parse = callback;
    return this;
  }
  use(validation) {
    this.validations.push(VALIDATION in validation ? validation[VALIDATION]() : validation);
    return this;
  }
  bail(state) {
    this.options.bail = state;
    return this;
  }
  [PARSE](propertyName, refs, options2) {
    return {
      type: "literal",
      fieldName: propertyName,
      propertyName: options2.toCamelCase ? camelCase2(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs)
    };
  }
};
var VineAny = class _VineAny extends BaseLiteralType {
  constructor(options2, validations) {
    super(options2, validations);
  }
  clone() {
    return new _VineAny(this.cloneOptions(), this.cloneValidations());
  }
};
var enumRule = createRule((value, options2, field) => {
  const choices = typeof options2.choices === "function" ? options2.choices(field) : options2.choices;
  if (!choices.includes(value)) {
    field.report(messages.enum, "enum", field, { choices });
  }
});
var VineEnum = class _VineEnum extends BaseLiteralType {
  static rules = {
    enum: enumRule
  };
  #values;
  getChoices() {
    return this.#values;
  }
  constructor(values, options2, validations) {
    super(options2, validations || [enumRule({ choices: values })]);
    this.#values = values;
  }
  clone() {
    return new _VineEnum(this.#values, this.cloneOptions(), this.cloneValidations());
  }
};
var DEFAULT_DATE_FORMATS = ["YYYY-MM-DD", "YYYY-MM-DD HH:mm:ss"];
import_dayjs2.default.extend(import_customParseFormat.default);
import_dayjs2.default.extend(import_isSameOrAfter.default);
import_dayjs2.default.extend(import_isSameOrBefore.default);
var dateRule = createRule((value, options2, field) => {
  if (typeof value !== "string" && typeof value !== "number") {
    field.report(messages.date, "date", field);
    return;
  }
  let isTimestampAllowed = false;
  let formats = options2.formats || DEFAULT_DATE_FORMATS;
  if (Array.isArray(formats)) {
    formats = [...formats];
    isTimestampAllowed = formats.includes("x");
  } else if (typeof formats !== "string") {
    formats = { ...formats };
    isTimestampAllowed = formats.format === "x";
  }
  const valueAsNumber = isTimestampAllowed ? helpers3.asNumber(value) : value;
  const dateTime = isTimestampAllowed && !Number.isNaN(valueAsNumber) ? import_dayjs2.default(valueAsNumber) : import_dayjs2.default(value, formats, true);
  if (!dateTime.isValid()) {
    field.report(messages.date, "date", field);
    return;
  }
  field.meta.$value = dateTime;
  field.meta.$formats = formats;
  field.mutate(dateTime.toDate(), field);
});
var equalsRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const format = options2.format || DEFAULT_DATE_FORMATS;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options2.expectedValue === "function" ? options2.expectedValue(field) : options2.expectedValue;
  const expectedDateTime = import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the equals rule`);
  }
  if (!dateTime.isSame(expectedDateTime, compare)) {
    field.report(messages["date.equals"], "date.equals", field, {
      expectedValue,
      compare
    });
  }
});
var afterRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const format = options2.format || DEFAULT_DATE_FORMATS;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options2.expectedValue === "function" ? options2.expectedValue(field) : options2.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs2.default() : expectedValue === "tomorrow" ? import_dayjs2.default().add(1, "day") : import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the after rule`);
  }
  if (!dateTime.isAfter(expectedDateTime, compare)) {
    field.report(messages["date.after"], "date.after", field, {
      expectedValue,
      compare
    });
  }
});
var afterOrEqualRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const format = options2.format || DEFAULT_DATE_FORMATS;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options2.expectedValue === "function" ? options2.expectedValue(field) : options2.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs2.default() : expectedValue === "tomorrow" ? import_dayjs2.default().add(1, "day") : import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the afterOrEqual rule`);
  }
  if (!dateTime.isSameOrAfter(expectedDateTime, compare)) {
    field.report(messages["date.afterOrEqual"], "date.afterOrEqual", field, {
      expectedValue,
      compare
    });
  }
});
var beforeRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const format = options2.format || DEFAULT_DATE_FORMATS;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options2.expectedValue === "function" ? options2.expectedValue(field) : options2.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs2.default() : expectedValue === "yesterday" ? import_dayjs2.default().subtract(1, "day") : import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the before rule`);
  }
  if (!dateTime.isBefore(expectedDateTime, compare)) {
    field.report(messages["date.before"], "date.before", field, {
      expectedValue,
      compare
    });
  }
});
var beforeOrEqualRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const format = options2.format || DEFAULT_DATE_FORMATS;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options2.expectedValue === "function" ? options2.expectedValue(field) : options2.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs2.default() : expectedValue === "yesterday" ? import_dayjs2.default().subtract(1, "day") : import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the beforeOrEqual rule`);
  }
  if (!dateTime.isSameOrBefore(expectedDateTime, compare)) {
    field.report(messages["date.beforeOrEqual"], "date.beforeOrEqual", field, {
      expectedValue,
      compare
    });
  }
});
var sameAsRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const dateTime = field.meta.$value;
  const format = options2.format || field.meta.$formats;
  const expectedValue = helpers3.getNestedValue(options2.otherField, field);
  const expectedDateTime = import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isSame(expectedDateTime, compare)) {
    field.report(messages["date.sameAs"], "date.sameAs", field, {
      otherField: options2.otherField,
      expectedValue,
      compare
    });
  }
});
var notSameAsRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const dateTime = field.meta.$value;
  const format = options2.format || field.meta.$formats;
  const expectedValue = helpers3.getNestedValue(options2.otherField, field);
  const expectedDateTime = import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (dateTime.isSame(expectedDateTime, compare)) {
    field.report(messages["date.notSameAs"], "date.notSameAs", field, {
      otherField: options2.otherField,
      expectedValue,
      compare
    });
  }
});
var afterFieldRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const dateTime = field.meta.$value;
  const format = options2.format || field.meta.$formats;
  const expectedValue = helpers3.getNestedValue(options2.otherField, field);
  const expectedDateTime = import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isAfter(expectedDateTime, compare)) {
    field.report(messages["date.afterField"], "date.afterField", field, {
      otherField: options2.otherField,
      expectedValue,
      compare
    });
  }
});
var afterOrSameAsRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const dateTime = field.meta.$value;
  const format = options2.format || field.meta.$formats;
  const expectedValue = helpers3.getNestedValue(options2.otherField, field);
  const expectedDateTime = import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isSameOrAfter(expectedDateTime, compare)) {
    field.report(messages["date.afterOrSameAs"], "date.afterOrSameAs", field, {
      otherField: options2.otherField,
      expectedValue,
      compare
    });
  }
});
var beforeFieldRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const dateTime = field.meta.$value;
  const format = options2.format || field.meta.$formats;
  const expectedValue = helpers3.getNestedValue(options2.otherField, field);
  const expectedDateTime = import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isBefore(expectedDateTime, compare)) {
    field.report(messages["date.beforeField"], "date.beforeField", field, {
      otherField: options2.otherField,
      expectedValue,
      compare
    });
  }
});
var beforeOrSameAsRule = createRule((_2, options2, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare = options2.compare || "day";
  const dateTime = field.meta.$value;
  const format = options2.format || field.meta.$formats;
  const expectedValue = helpers3.getNestedValue(options2.otherField, field);
  const expectedDateTime = import_dayjs2.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isSameOrBefore(expectedDateTime, compare)) {
    field.report(messages["date.beforeOrSameAs"], "date.beforeOrSameAs", field, {
      otherField: options2.otherField,
      expectedValue,
      compare
    });
  }
});
var weekendRule = createRule((_2, __, field) => {
  if (!field.meta.$value) {
    return;
  }
  const dateTime = field.meta.$value;
  const day = dateTime.day();
  if (day !== 0 && day !== 6) {
    field.report(messages["date.weekend"], "date.weekend", field);
  }
});
var weekdayRule = createRule((_2, __, field) => {
  if (!field.meta.$value) {
    return;
  }
  const dateTime = field.meta.$value;
  const day = dateTime.day();
  if (day === 0 || day === 6) {
    field.report(messages["date.weekday"], "date.weekday", field);
  }
});
var VineDate = class _VineDate extends BaseLiteralType {
  static rules = {
    equals: equalsRule,
    after: afterRule,
    afterOrEqual: afterOrEqualRule,
    before: beforeRule,
    beforeOrEqual: beforeOrEqualRule,
    sameAs: sameAsRule,
    notSameAs: notSameAsRule,
    afterField: afterFieldRule,
    afterOrSameAs: afterOrSameAsRule,
    beforeField: beforeFieldRule,
    beforeOrSameAs: beforeOrSameAsRule,
    weekend: weekendRule,
    weekday: weekdayRule
  };
  [UNIQUE_NAME] = "vine.date";
  [IS_OF_TYPE] = (value) => {
    if (typeof value !== "string") {
      return false;
    }
    return import_dayjs.default(value, this.options.formats || DEFAULT_DATE_FORMATS, true).isValid();
  };
  constructor(options2, validations) {
    super(options2, validations || [dateRule(options2 || {})]);
  }
  equals(expectedValue, options2) {
    return this.use(equalsRule({ expectedValue, ...options2 }));
  }
  after(expectedValue, options2) {
    return this.use(afterRule({ expectedValue, ...options2 }));
  }
  afterOrEqual(expectedValue, options2) {
    return this.use(afterOrEqualRule({ expectedValue, ...options2 }));
  }
  before(expectedValue, options2) {
    return this.use(beforeRule({ expectedValue, ...options2 }));
  }
  beforeOrEqual(expectedValue, options2) {
    return this.use(beforeOrEqualRule({ expectedValue, ...options2 }));
  }
  sameAs(otherField, options2) {
    return this.use(sameAsRule({ otherField, ...options2 }));
  }
  notSameAs(otherField, options2) {
    return this.use(notSameAsRule({ otherField, ...options2 }));
  }
  afterField(otherField, options2) {
    return this.use(afterFieldRule({ otherField, ...options2 }));
  }
  afterOrSameAs(otherField, options2) {
    return this.use(afterOrSameAsRule({ otherField, ...options2 }));
  }
  beforeField(otherField, options2) {
    return this.use(beforeFieldRule({ otherField, ...options2 }));
  }
  beforeOrSameAs(otherField, options2) {
    return this.use(beforeOrSameAsRule({ otherField, ...options2 }));
  }
  weekend() {
    return this.use(weekendRule());
  }
  weekday() {
    return this.use(weekdayRule());
  }
  clone() {
    return new _VineDate(this.cloneOptions(), this.cloneValidations());
  }
};
var VineUnion = class _VineUnion {
  #conditionals;
  #otherwiseCallback = (_2, field) => {
    field.report(messages.union, "union", field);
  };
  constructor(conditionals) {
    this.#conditionals = conditionals;
  }
  otherwise(callback) {
    this.#otherwiseCallback = callback;
    return this;
  }
  clone() {
    const cloned = new _VineUnion(this.#conditionals);
    cloned.otherwise(this.#otherwiseCallback);
    return cloned;
  }
  [PARSE](propertyName, refs, options2) {
    return {
      type: "union",
      fieldName: propertyName,
      propertyName: options2.toCamelCase ? camelCase2(propertyName) : propertyName,
      elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
      conditions: this.#conditionals.map((conditional) => conditional[PARSE](propertyName, refs, options2))
    };
  }
};
var UnionConditional = class {
  #schema;
  #conditional;
  constructor(conditional, schema) {
    this.#schema = schema;
    this.#conditional = conditional;
  }
  [PARSE](propertyName, refs, options2) {
    return {
      conditionalFnRefId: refs.trackConditional(this.#conditional),
      schema: this.#schema[PARSE](propertyName, refs, options2)
    };
  }
};
function union(conditionals) {
  return new VineUnion(conditionals);
}
union.if = function unionIf(conditon, schema) {
  return new UnionConditional(conditon, schema);
};
union.else = function unionElse(schema) {
  return new UnionConditional(() => true, schema);
};
var BaseModifiersType2 = class extends Macroable {
  optional() {
    return new OptionalModifier2(this);
  }
  nullable() {
    return new NullableModifier2(this);
  }
};
var NullableModifier2 = class _NullableModifier2 extends BaseModifiersType2 {
  #parent;
  constructor(parent) {
    super();
    this.#parent = parent;
  }
  clone() {
    return new _NullableModifier2(this.#parent.clone());
  }
  [PARSE](propertyName, refs, options2) {
    const output = this.#parent[PARSE](propertyName, refs, options2);
    if (output.type !== "union") {
      output.allowNull = true;
    }
    return output;
  }
};
var OptionalModifier2 = class _OptionalModifier2 extends BaseModifiersType2 {
  #parent;
  constructor(parent) {
    super();
    this.#parent = parent;
  }
  clone() {
    return new _OptionalModifier2(this.#parent.clone());
  }
  [PARSE](propertyName, refs, options2) {
    const output = this.#parent[PARSE](propertyName, refs, options2);
    if (output.type !== "union") {
      output.isOptional = true;
    }
    return output;
  }
};
var BaseType = class extends BaseModifiersType2 {
  options;
  validations;
  constructor(options2, validations) {
    super();
    this.options = options2 || {
      bail: true,
      allowNull: false,
      isOptional: false
    };
    this.validations = validations || [];
  }
  cloneValidations() {
    return this.validations.map((validation) => {
      return {
        options: validation.options,
        rule: validation.rule
      };
    });
  }
  cloneOptions() {
    return { ...this.options };
  }
  compileValidations(refs) {
    return this.validations.map((validation) => {
      return {
        ruleFnId: refs.track({
          validator: validation.rule.validator,
          options: validation.options
        }),
        implicit: validation.rule.implicit,
        isAsync: validation.rule.isAsync
      };
    });
  }
  parse(callback) {
    this.options.parse = callback;
    return this;
  }
  use(validation) {
    this.validations.push(VALIDATION in validation ? validation[VALIDATION]() : validation);
    return this;
  }
  bail(state) {
    this.options.bail = state;
    return this;
  }
};
var VineTuple = class _VineTuple extends BaseType {
  #schemas;
  #allowUnknownProperties = false;
  [UNIQUE_NAME] = "vine.array";
  [IS_OF_TYPE] = (value) => {
    return Array.isArray(value);
  };
  constructor(schemas, options2, validations) {
    super(options2, validations);
    this.#schemas = schemas;
  }
  allowUnknownProperties() {
    this.#allowUnknownProperties = true;
    return this;
  }
  clone() {
    const cloned = new _VineTuple(this.#schemas.map((schema) => schema.clone()), this.cloneOptions(), this.cloneValidations());
    if (this.#allowUnknownProperties) {
      cloned.allowUnknownProperties();
    }
    return cloned;
  }
  [PARSE](propertyName, refs, options2) {
    return {
      type: "tuple",
      fieldName: propertyName,
      propertyName: options2.toCamelCase ? camelCase2(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      allowUnknownProperties: this.#allowUnknownProperties,
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs),
      properties: this.#schemas.map((schema, index) => schema[PARSE](String(index), refs, options2))
    };
  }
};
var minLengthRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length < options2.min) {
    field.report(messages["array.minLength"], "array.minLength", field, options2);
  }
});
var maxLengthRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length > options2.max) {
    field.report(messages["array.maxLength"], "array.maxLength", field, options2);
  }
});
var fixedLengthRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length !== options2.size) {
    field.report(messages["array.fixedLength"], "array.fixedLength", field, options2);
  }
});
var notEmptyRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length <= 0) {
    field.report(messages.notEmpty, "notEmpty", field);
  }
});
var distinctRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isDistinct(value, options2.fields)) {
    field.report(messages.distinct, "distinct", field, options2);
  }
});
var compactRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.filter((item) => helpers3.exists(item) && item !== ""), field);
});
var VineArray = class _VineArray extends BaseType {
  static rules = {
    compact: compactRule,
    notEmpty: notEmptyRule,
    distinct: distinctRule,
    minLength: minLengthRule,
    maxLength: maxLengthRule,
    fixedLength: fixedLengthRule
  };
  #schema;
  [UNIQUE_NAME] = "vine.array";
  [IS_OF_TYPE] = (value) => {
    return Array.isArray(value);
  };
  constructor(schema, options2, validations) {
    super(options2, validations);
    this.#schema = schema;
  }
  minLength(expectedLength) {
    return this.use(minLengthRule({ min: expectedLength }));
  }
  maxLength(expectedLength) {
    return this.use(maxLengthRule({ max: expectedLength }));
  }
  fixedLength(expectedLength) {
    return this.use(fixedLengthRule({ size: expectedLength }));
  }
  notEmpty() {
    return this.use(notEmptyRule());
  }
  distinct(fields2) {
    return this.use(distinctRule({ fields: fields2 }));
  }
  compact() {
    return this.use(compactRule());
  }
  clone() {
    return new _VineArray(this.#schema.clone(), this.cloneOptions(), this.cloneValidations());
  }
  [PARSE](propertyName, refs, options2) {
    return {
      type: "array",
      fieldName: propertyName,
      propertyName: options2.toCamelCase ? camelCase2(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      each: this.#schema[PARSE]("*", refs, options2),
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs)
    };
  }
};
var VineCamelCaseObject = class _VineCamelCaseObject extends BaseModifiersType2 {
  #schema;
  [UNIQUE_NAME] = "types.object";
  [IS_OF_TYPE] = (value) => {
    return value !== null && typeof value === "object" && !Array.isArray(value);
  };
  constructor(schema) {
    super();
    this.#schema = schema;
  }
  clone() {
    return new _VineCamelCaseObject(this.#schema.clone());
  }
  [PARSE](propertyName, refs, options2) {
    options2.toCamelCase = true;
    return this.#schema[PARSE](propertyName, refs, options2);
  }
};
var VineObject = class _VineObject extends BaseType {
  #properties;
  #groups = [];
  #allowUnknownProperties = false;
  [UNIQUE_NAME] = "vine.object";
  [IS_OF_TYPE] = (value) => {
    return value !== null && typeof value === "object" && !Array.isArray(value);
  };
  constructor(properties, options2, validations) {
    super(options2, validations);
    this.#properties = properties;
  }
  getProperties() {
    return Object.keys(this.#properties).reduce((result2, key) => {
      result2[key] = this.#properties[key].clone();
      return result2;
    }, {});
  }
  allowUnknownProperties() {
    this.#allowUnknownProperties = true;
    return this;
  }
  merge(group2) {
    this.#groups.push(group2);
    return this;
  }
  clone() {
    const cloned = new _VineObject(this.getProperties(), this.cloneOptions(), this.cloneValidations());
    this.#groups.forEach((group2) => cloned.merge(group2));
    if (this.#allowUnknownProperties) {
      cloned.allowUnknownProperties();
    }
    return cloned;
  }
  toCamelCase() {
    return new VineCamelCaseObject(this);
  }
  [PARSE](propertyName, refs, options2) {
    return {
      type: "object",
      fieldName: propertyName,
      propertyName: options2.toCamelCase ? camelCase2(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      allowUnknownProperties: this.#allowUnknownProperties,
      validations: this.compileValidations(refs),
      properties: Object.keys(this.#properties).map((property) => {
        return this.#properties[property][PARSE](property, refs, options2);
      }),
      groups: this.#groups.map((group2) => {
        return group2[PARSE](refs, options2);
      })
    };
  }
};
var minLengthRule2 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (Object.keys(value).length < options2.min) {
    field.report(messages["record.minLength"], "record.minLength", field, options2);
  }
});
var maxLengthRule2 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (Object.keys(value).length > options2.max) {
    field.report(messages["record.maxLength"], "record.maxLength", field, options2);
  }
});
var fixedLengthRule2 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (Object.keys(value).length !== options2.size) {
    field.report(messages["record.fixedLength"], "record.fixedLength", field, options2);
  }
});
var validateKeysRule = createRule((value, callback, field) => {
  if (!field.isValid) {
    return;
  }
  callback(Object.keys(value), field);
});
var VineRecord = class _VineRecord extends BaseType {
  static rules = {
    maxLength: maxLengthRule2,
    minLength: minLengthRule2,
    fixedLength: fixedLengthRule2,
    validateKeys: validateKeysRule
  };
  #schema;
  [UNIQUE_NAME] = "vine.object";
  [IS_OF_TYPE] = (value) => {
    return value !== null && typeof value === "object" && !Array.isArray(value);
  };
  constructor(schema, options2, validations) {
    super(options2, validations);
    this.#schema = schema;
  }
  minLength(expectedLength) {
    return this.use(minLengthRule2({ min: expectedLength }));
  }
  maxLength(expectedLength) {
    return this.use(maxLengthRule2({ max: expectedLength }));
  }
  fixedLength(expectedLength) {
    return this.use(fixedLengthRule2({ size: expectedLength }));
  }
  validateKeys(...args) {
    return this.use(validateKeysRule(...args));
  }
  clone() {
    return new _VineRecord(this.#schema.clone(), this.cloneOptions(), this.cloneValidations());
  }
  [PARSE](propertyName, refs, options2) {
    return {
      type: "record",
      fieldName: propertyName,
      propertyName: options2.toCamelCase ? camelCase2(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      each: this.#schema[PARSE]("*", refs, options2),
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs)
    };
  }
};
var stringRule = createRule((value, _2, field) => {
  if (typeof value !== "string") {
    field.report(messages.string, "string", field);
  }
});
var emailRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isEmail(value, options2)) {
    field.report(messages.email, "email", field);
  }
});
var mobileRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const normalizedOptions = options2 && typeof options2 === "function" ? options2(field) : options2;
  const locales2 = normalizedOptions?.locale || "any";
  if (!helpers3.isMobilePhone(value, locales2, normalizedOptions)) {
    field.report(messages.mobile, "mobile", field);
  }
});
var ipAddressRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isIP(value, options2?.version)) {
    field.report(messages.ipAddress, "ipAddress", field);
  }
});
var regexRule = createRule((value, expression, field) => {
  if (!field.isValid) {
    return;
  }
  if (!expression.test(value)) {
    field.report(messages.regex, "regex", field);
  }
});
var hexCodeRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isHexColor(value)) {
    field.report(messages.hexCode, "hexCode", field);
  }
});
var urlRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isURL(value, options2)) {
    field.report(messages.url, "url", field);
  }
});
var activeUrlRule = createRule(async (value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!await helpers3.isActiveURL(value)) {
    field.report(messages.activeUrl, "activeUrl", field);
  }
});
var alphaRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  let characterSet = "a-zA-Z";
  if (options2) {
    if (options2.allowSpaces) {
      characterSet += "\\s";
    }
    if (options2.allowDashes) {
      characterSet += "-";
    }
    if (options2.allowUnderscores) {
      characterSet += "_";
    }
  }
  const expression = new RegExp(`^[${characterSet}]+$`);
  if (!expression.test(value)) {
    field.report(messages.alpha, "alpha", field);
  }
});
var alphaNumericRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  let characterSet = "a-zA-Z0-9";
  if (options2) {
    if (options2.allowSpaces) {
      characterSet += "\\s";
    }
    if (options2.allowDashes) {
      characterSet += "-";
    }
    if (options2.allowUnderscores) {
      characterSet += "_";
    }
  }
  const expression = new RegExp(`^[${characterSet}]+$`);
  if (!expression.test(value)) {
    field.report(messages.alphaNumeric, "alphaNumeric", field);
  }
});
var minLengthRule3 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length < options2.min) {
    field.report(messages.minLength, "minLength", field, options2);
  }
});
var maxLengthRule3 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length > options2.max) {
    field.report(messages.maxLength, "maxLength", field, options2);
  }
});
var fixedLengthRule3 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length !== options2.size) {
    field.report(messages.fixedLength, "fixedLength", field, options2);
  }
});
var endsWithRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!value.endsWith(options2.substring)) {
    field.report(messages.endsWith, "endsWith", field, options2);
  }
});
var startsWithRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!value.startsWith(options2.substring)) {
    field.report(messages.startsWith, "startsWith", field, options2);
  }
});
var sameAsRule2 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const input = helpers3.getNestedValue(options2.otherField, field);
  if (input !== value) {
    field.report(messages.sameAs, "sameAs", field, options2);
    return;
  }
});
var notSameAsRule2 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const input = helpers3.getNestedValue(options2.otherField, field);
  if (input === value) {
    field.report(messages.notSameAs, "notSameAs", field, options2);
    return;
  }
});
var confirmedRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const otherField = options2?.confirmationField || `${field.name}_confirmation`;
  const input = field.parent[otherField];
  if (input !== value) {
    field.report(messages.confirmed, "confirmed", field, { otherField });
    return;
  }
});
var trimRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.trim(), field);
});
var normalizeEmailRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(import_normalizeEmail.default.default(value, options2), field);
});
var toUpperCaseRule = createRule((value, locales2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.toLocaleUpperCase(locales2), field);
});
var toLowerCaseRule = createRule((value, locales2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.toLocaleLowerCase(locales2), field);
});
var toCamelCaseRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(camelCase2(value), field);
});
var escapeRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(import_escape.default.default(value), field);
});
var normalizeUrlRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(normalizeUrl(value, options2), field);
});
var inRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const choices = typeof options2.choices === "function" ? options2.choices(field) : options2.choices;
  if (!choices.includes(value)) {
    field.report(messages.in, "in", field, options2);
    return;
  }
});
var notInRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const list = typeof options2.list === "function" ? options2.list(field) : options2.list;
  if (list.includes(value)) {
    field.report(messages.notIn, "notIn", field, options2);
    return;
  }
});
var creditCardRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const providers2 = options2 ? typeof options2 === "function" ? options2(field)?.provider || [] : options2.provider : [];
  if (!providers2.length) {
    if (!helpers3.isCreditCard(value)) {
      field.report(messages.creditCard, "creditCard", field, {
        providersList: "credit"
      });
    }
  } else {
    const matchesAnyProvider = providers2.find((provider) => helpers3.isCreditCard(value, { provider }));
    if (!matchesAnyProvider) {
      field.report(messages.creditCard, "creditCard", field, {
        providers: providers2,
        providersList: providers2.join("/")
      });
    }
  }
});
var passportRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const countryCodes = typeof options2 === "function" ? options2(field).countryCode : options2.countryCode;
  const matchesAnyCountryCode = countryCodes.find((countryCode) => helpers3.isPassportNumber(value, countryCode));
  if (!matchesAnyCountryCode) {
    field.report(messages.passport, "passport", field, { countryCodes });
  }
});
var postalCodeRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  const countryCodes = options2 ? typeof options2 === "function" ? options2(field)?.countryCode || [] : options2.countryCode : [];
  if (!countryCodes.length) {
    if (!helpers3.isPostalCode(value, "any")) {
      field.report(messages.postalCode, "postalCode", field);
    }
  } else {
    const matchesAnyCountryCode = countryCodes.find((countryCode) => helpers3.isPostalCode(value, countryCode));
    if (!matchesAnyCountryCode) {
      field.report(messages.postalCode, "postalCode", field, { countryCodes });
    }
  }
});
var uuidRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!options2 || !options2.version) {
    if (!helpers3.isUUID(value)) {
      field.report(messages.uuid, "uuid", field);
    }
  } else {
    const matchesAnyVersion = options2.version.find((version) => helpers3.isUUID(value, version));
    if (!matchesAnyVersion) {
      field.report(messages.uuid, "uuid", field, options2);
    }
  }
});
var asciiRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isAscii(value)) {
    field.report(messages.ascii, "ascii", field);
  }
});
var ibanRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isIBAN(value)) {
    field.report(messages.iban, "iban", field);
  }
});
var jwtRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isJWT(value)) {
    field.report(messages.jwt, "jwt", field);
  }
});
var coordinatesRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isLatLong(value)) {
    field.report(messages.coordinates, "coordinates", field);
  }
});
var VineString = class _VineString extends BaseLiteralType {
  static rules = {
    in: inRule,
    jwt: jwtRule,
    url: urlRule,
    iban: ibanRule,
    uuid: uuidRule,
    trim: trimRule,
    email: emailRule,
    alpha: alphaRule,
    ascii: asciiRule,
    notIn: notInRule,
    regex: regexRule,
    escape: escapeRule,
    sameAs: sameAsRule2,
    mobile: mobileRule,
    string: stringRule,
    hexCode: hexCodeRule,
    passport: passportRule,
    endsWith: endsWithRule,
    confirmed: confirmedRule,
    activeUrl: activeUrlRule,
    minLength: minLengthRule3,
    notSameAs: notSameAsRule2,
    maxLength: maxLengthRule3,
    ipAddress: ipAddressRule,
    creditCard: creditCardRule,
    postalCode: postalCodeRule,
    startsWith: startsWithRule,
    toUpperCase: toUpperCaseRule,
    toLowerCase: toLowerCaseRule,
    toCamelCase: toCamelCaseRule,
    fixedLength: fixedLengthRule3,
    coordinates: coordinatesRule,
    normalizeUrl: normalizeUrlRule,
    alphaNumeric: alphaNumericRule,
    normalizeEmail: normalizeEmailRule
  };
  [UNIQUE_NAME] = "vine.string";
  [IS_OF_TYPE] = (value) => {
    return typeof value === "string";
  };
  constructor(options2, validations) {
    super(options2, validations || [stringRule()]);
  }
  url(...args) {
    return this.use(urlRule(...args));
  }
  activeUrl() {
    return this.use(activeUrlRule());
  }
  email(...args) {
    return this.use(emailRule(...args));
  }
  mobile(...args) {
    return this.use(mobileRule(...args));
  }
  ipAddress(version) {
    return this.use(ipAddressRule(version ? { version } : undefined));
  }
  hexCode() {
    return this.use(hexCodeRule());
  }
  regex(expression) {
    return this.use(regexRule(expression));
  }
  alpha(options2) {
    return this.use(alphaRule(options2));
  }
  alphaNumeric(options2) {
    return this.use(alphaNumericRule(options2));
  }
  minLength(expectedLength) {
    return this.use(minLengthRule3({ min: expectedLength }));
  }
  maxLength(expectedLength) {
    return this.use(maxLengthRule3({ max: expectedLength }));
  }
  fixedLength(expectedLength) {
    return this.use(fixedLengthRule3({ size: expectedLength }));
  }
  confirmed(options2) {
    return this.use(confirmedRule(options2));
  }
  trim() {
    return this.use(trimRule());
  }
  normalizeEmail(options2) {
    return this.use(normalizeEmailRule(options2));
  }
  toUpperCase() {
    return this.use(toUpperCaseRule());
  }
  toLowerCase() {
    return this.use(toLowerCaseRule());
  }
  toCamelCase() {
    return this.use(toCamelCaseRule());
  }
  escape() {
    return this.use(escapeRule());
  }
  normalizeUrl(...args) {
    return this.use(normalizeUrlRule(...args));
  }
  startsWith(substring) {
    return this.use(startsWithRule({ substring }));
  }
  endsWith(substring) {
    return this.use(endsWithRule({ substring }));
  }
  sameAs(otherField) {
    return this.use(sameAsRule2({ otherField }));
  }
  notSameAs(otherField) {
    return this.use(notSameAsRule2({ otherField }));
  }
  in(choices) {
    return this.use(inRule({ choices }));
  }
  notIn(list) {
    return this.use(notInRule({ list }));
  }
  creditCard(...args) {
    return this.use(creditCardRule(...args));
  }
  passport(...args) {
    return this.use(passportRule(...args));
  }
  postalCode(...args) {
    return this.use(postalCodeRule(...args));
  }
  uuid(...args) {
    return this.use(uuidRule(...args));
  }
  ascii() {
    return this.use(asciiRule());
  }
  iban() {
    return this.use(ibanRule());
  }
  jwt() {
    return this.use(jwtRule());
  }
  coordinates() {
    return this.use(coordinatesRule());
  }
  clone() {
    return new _VineString(this.cloneOptions(), this.cloneValidations());
  }
};
var numberRule = createRule((value, options2, field) => {
  const valueAsNumber = options2.strict ? value : helpers3.asNumber(value);
  if (typeof valueAsNumber !== "number" || Number.isNaN(valueAsNumber) || valueAsNumber === Number.POSITIVE_INFINITY || valueAsNumber === Number.NEGATIVE_INFINITY) {
    field.report(messages.number, "number", field);
    return;
  }
  field.mutate(valueAsNumber, field);
});
var minRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value < options2.min) {
    field.report(messages.min, "min", field, options2);
  }
});
var maxRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value > options2.max) {
    field.report(messages.max, "max", field, options2);
  }
});
var rangeRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value < options2.min || value > options2.max) {
    field.report(messages.range, "range", field, options2);
  }
});
var positiveRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value < 0) {
    field.report(messages.positive, "positive", field);
  }
});
var negativeRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (value >= 0) {
    field.report(messages.negative, "negative", field);
  }
});
var decimalRule = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers3.isDecimal(String(value), {
    force_decimal: options2.range[0] !== 0,
    decimal_digits: options2.range.join(",")
  })) {
    field.report(messages.decimal, "decimal", field, { digits: options2.range.join("-") });
  }
});
var withoutDecimalsRule = createRule((value, _2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!Number.isInteger(value)) {
    field.report(messages.withoutDecimals, "withoutDecimals", field);
  }
});
var inRule2 = createRule((value, options2, field) => {
  if (!field.isValid) {
    return;
  }
  if (!options2.values.includes(value)) {
    field.report(messages["number.in"], "in", field, options2);
  }
});
var VineNumber = class _VineNumber extends BaseLiteralType {
  static rules = {
    in: inRule2,
    max: maxRule,
    min: minRule,
    range: rangeRule,
    number: numberRule,
    decimal: decimalRule,
    negative: negativeRule,
    positive: positiveRule,
    withoutDecimals: withoutDecimalsRule
  };
  [UNIQUE_NAME] = "vine.number";
  [IS_OF_TYPE] = (value) => {
    const valueAsNumber = helpers3.asNumber(value);
    return !Number.isNaN(valueAsNumber);
  };
  constructor(options2, validations) {
    super(options2, validations || [numberRule(options2 || {})]);
  }
  min(value) {
    return this.use(minRule({ min: value }));
  }
  max(value) {
    return this.use(maxRule({ max: value }));
  }
  range(value) {
    return this.use(rangeRule({ min: value[0], max: value[1] }));
  }
  positive() {
    return this.use(positiveRule());
  }
  negative() {
    return this.use(negativeRule());
  }
  decimal(range) {
    return this.use(decimalRule({ range: Array.isArray(range) ? range : [range] }));
  }
  withoutDecimals() {
    return this.use(withoutDecimalsRule());
  }
  clone() {
    return new _VineNumber(this.cloneOptions(), this.cloneValidations());
  }
  in(values) {
    return this.use(inRule2({ values }));
  }
};
var booleanRule = createRule((value, options2, field) => {
  const valueAsBoolean = options2.strict === true ? value : helpers3.asBoolean(value);
  if (typeof valueAsBoolean !== "boolean") {
    field.report(messages.boolean, "boolean", field);
    return;
  }
  field.mutate(valueAsBoolean, field);
});
var VineBoolean = class _VineBoolean extends BaseLiteralType {
  static rules = {
    boolean: booleanRule
  };
  [UNIQUE_NAME] = "vine.boolean";
  [IS_OF_TYPE] = (value) => {
    const valueAsBoolean = this.options.strict === true ? value : helpers3.asBoolean(value);
    return typeof valueAsBoolean === "boolean";
  };
  constructor(options2, validations) {
    super(options2, validations || [booleanRule(options2 || {})]);
  }
  clone() {
    return new _VineBoolean(this.cloneOptions(), this.cloneValidations());
  }
};
var equalsRule2 = createRule((value, options2, field) => {
  let input = value;
  if (typeof options2.expectedValue === "boolean") {
    input = helpers3.asBoolean(value);
  } else if (typeof options2.expectedValue === "number") {
    input = helpers3.asNumber(value);
  }
  if (input !== options2.expectedValue) {
    field.report(messages.literal, "literal", field, options2);
    return;
  }
  field.mutate(input, field);
});
var VineLiteral = class _VineLiteral extends BaseLiteralType {
  static rules = {
    equals: equalsRule2
  };
  #value;
  constructor(value, options2, validations) {
    super(options2, validations || [equalsRule2({ expectedValue: value })]);
    this.#value = value;
  }
  clone() {
    return new _VineLiteral(this.#value, this.cloneOptions(), this.cloneValidations());
  }
};
var ACCEPTED_VALUES = ["on", "1", "yes", "true", true, 1];
var acceptedRule = createRule((value, _2, field) => {
  if (!ACCEPTED_VALUES.includes(value)) {
    field.report(messages.accepted, "accepted", field);
  }
});
var VineAccepted = class _VineAccepted extends BaseLiteralType {
  static rules = {
    accepted: acceptedRule
  };
  constructor(options2, validations) {
    super(options2, validations || [acceptedRule()]);
  }
  clone() {
    return new _VineAccepted(this.cloneOptions(), this.cloneValidations());
  }
};
var ObjectGroup = class _ObjectGroup {
  #conditionals;
  #otherwiseCallback = (_2, field) => {
    field.report(messages.unionGroup, "unionGroup", field);
  };
  constructor(conditionals) {
    this.#conditionals = conditionals;
  }
  clone() {
    const cloned = new _ObjectGroup(this.#conditionals);
    cloned.otherwise(this.#otherwiseCallback);
    return cloned;
  }
  otherwise(callback) {
    this.#otherwiseCallback = callback;
    return this;
  }
  [PARSE](refs, options2) {
    return {
      type: "group",
      elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
      conditions: this.#conditionals.map((conditional) => conditional[PARSE](refs, options2))
    };
  }
};
var GroupConditional = class {
  #properties;
  #conditional;
  constructor(conditional, properties) {
    this.#properties = properties;
    this.#conditional = conditional;
  }
  [PARSE](refs, options2) {
    return {
      schema: {
        type: "sub_object",
        properties: Object.keys(this.#properties).map((property) => {
          return this.#properties[property][PARSE](property, refs, options2);
        }),
        groups: []
      },
      conditionalFnRefId: refs.trackConditional(this.#conditional)
    };
  }
};
function group(conditionals) {
  return new ObjectGroup(conditionals);
}
group.if = function groupIf(conditon, properties) {
  return new GroupConditional(conditon, properties);
};
group.else = function groupElse(properties) {
  return new GroupConditional(() => true, properties);
};
var VineNativeEnum = class _VineNativeEnum extends BaseLiteralType {
  static rules = {
    enum: enumRule
  };
  #values;
  constructor(values, options2, validations) {
    super(options2, validations || [enumRule({ choices: Object.values(values) })]);
    this.#values = values;
  }
  clone() {
    return new _VineNativeEnum(this.#values, this.cloneOptions(), this.cloneValidations());
  }
};
var VineUnionOfTypes = class _VineUnionOfTypes {
  #schemas;
  #otherwiseCallback = (_2, field) => {
    field.report(messages.unionOfTypes, "unionOfTypes", field);
  };
  constructor(schemas) {
    this.#schemas = schemas;
  }
  otherwise(callback) {
    this.#otherwiseCallback = callback;
    return this;
  }
  clone() {
    const cloned = new _VineUnionOfTypes(this.#schemas);
    cloned.otherwise(this.#otherwiseCallback);
    return cloned;
  }
  [PARSE](propertyName, refs, options2) {
    return {
      type: "union",
      fieldName: propertyName,
      propertyName: options2.toCamelCase ? camelCase2(propertyName) : propertyName,
      elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
      conditions: this.#schemas.map((schema) => {
        return {
          conditionalFnRefId: refs.trackConditional((value, field) => {
            return schema[IS_OF_TYPE](value, field);
          }),
          schema: schema[PARSE](propertyName, refs, options2)
        };
      })
    };
  }
};
var SchemaBuilder = class extends Macroable {
  group = group;
  union = union;
  string() {
    return new VineString;
  }
  boolean(options2) {
    return new VineBoolean(options2);
  }
  accepted() {
    return new VineAccepted;
  }
  number(options2) {
    return new VineNumber(options2);
  }
  date(options2) {
    return new VineDate(options2);
  }
  literal(value) {
    return new VineLiteral(value);
  }
  object(properties) {
    return new VineObject(properties);
  }
  array(schema) {
    return new VineArray(schema);
  }
  tuple(schemas) {
    return new VineTuple(schemas);
  }
  record(schema) {
    return new VineRecord(schema);
  }
  enum(values) {
    if (Array.isArray(values) || typeof values === "function") {
      return new VineEnum(values);
    }
    return new VineNativeEnum(values);
  }
  any() {
    return new VineAny;
  }
  unionOfTypes(schemas) {
    const schemasInUse = /* @__PURE__ */ new Set;
    schemas.forEach((schema) => {
      if (!schema[IS_OF_TYPE] || !schema[UNIQUE_NAME]) {
        throw new Error(`Cannot use "${schema.constructor.name}". The schema type is not compatible for use with "vine.unionOfTypes"`);
      }
      if (schemasInUse.has(schema[UNIQUE_NAME])) {
        throw new Error(`Cannot use duplicate schema "${schema[UNIQUE_NAME]}". "vine.unionOfTypes" needs distinct schema types only`);
      }
      schemasInUse.add(schema[UNIQUE_NAME]);
    });
    schemasInUse.clear();
    return new VineUnionOfTypes(schemas);
  }
};
var COMPILER_ERROR_MESSAGES = {
  required: messages.required,
  array: messages.array,
  object: messages.object
};
var VineValidator = class {
  #compiled;
  messagesProvider;
  errorReporter;
  #parse(schema) {
    const refs = refsBuilder();
    return {
      compilerNode: {
        type: "root",
        schema: schema[PARSE]("", refs, { toCamelCase: false })
      },
      refs: refs.toJSON()
    };
  }
  constructor(schema, options2) {
    const { compilerNode, refs } = this.#parse(schema);
    this.#compiled = { schema: compilerNode, refs };
    const metaDataValidator = options2.metaDataValidator;
    const validateFn = new Compiler(compilerNode, {
      convertEmptyStringsToNull: options2.convertEmptyStringsToNull,
      messages: COMPILER_ERROR_MESSAGES
    }).compile();
    this.errorReporter = options2.errorReporter;
    this.messagesProvider = options2.messagesProvider;
    if (metaDataValidator) {
      this.validate = (data, validateOptions) => {
        let normalizedOptions = validateOptions ?? {};
        const meta = normalizedOptions.meta ?? {};
        const errorReporter = normalizedOptions.errorReporter ?? this.errorReporter;
        const messagesProvider = normalizedOptions.messagesProvider ?? this.messagesProvider;
        metaDataValidator(meta);
        return validateFn(data, meta, refs, messagesProvider, errorReporter());
      };
    } else {
      this.validate = (data, validateOptions) => {
        let normalizedOptions = validateOptions ?? {};
        const meta = normalizedOptions.meta ?? {};
        const errorReporter = normalizedOptions.errorReporter ?? this.errorReporter;
        const messagesProvider = normalizedOptions.messagesProvider ?? this.messagesProvider;
        return validateFn(data, meta, refs, messagesProvider, errorReporter());
      };
    }
  }
  async tryValidate(data, ...[options2]) {
    try {
      const result2 = await this.validate(data, options2);
      return [null, result2];
    } catch (error) {
      if (error instanceof ValidationError) {
        return [error, null];
      }
      throw error;
    }
  }
  toJSON() {
    const { schema, refs } = this.#compiled;
    return {
      schema: structuredClone(schema),
      refs
    };
  }
};
var Vine = class extends SchemaBuilder {
  messagesProvider = new SimpleMessagesProvider(messages, fields);
  errorReporter = () => new SimpleErrorReporter;
  convertEmptyStringsToNull = false;
  helpers = helpers3;
  createRule = createRule;
  compile(schema) {
    return new VineValidator(schema, {
      convertEmptyStringsToNull: this.convertEmptyStringsToNull,
      messagesProvider: this.messagesProvider,
      errorReporter: this.errorReporter
    });
  }
  withMetaData(callback) {
    return {
      compile: (schema) => {
        return new VineValidator(schema, {
          convertEmptyStringsToNull: this.convertEmptyStringsToNull,
          messagesProvider: this.messagesProvider,
          errorReporter: this.errorReporter,
          metaDataValidator: callback
        });
      }
    };
  }
  validate(options2) {
    const validator = this.compile(options2.schema);
    return validator.validate(options2.data, options2);
  }
  tryValidate(options2) {
    const validator = this.compile(options2.schema);
    return validator.tryValidate(options2.data, options2);
  }
};
var vine = new Vine;
var vine_default = vine;
var env_default = {
  APP_NAME: vine_default.string(),
  APP_ENV: vine_default.enum(["local", "dev", "stage", "prod"]),
  APP_KEY: vine_default.string(),
  APP_URL: vine_default.string(),
  PORT: vine_default.number(),
  PORT_BACKEND: vine_default.number(),
  PORT_ADMIN: vine_default.number(),
  PORT_LIBRARY: vine_default.number(),
  PORT_DESKTOP: vine_default.number(),
  PORT_EMAIL: vine_default.number(),
  PORT_DOCS: vine_default.number(),
  PORT_INSPECT: vine_default.number(),
  PORT_API: vine_default.number(),
  PORT_SYSTEM_TRAY: vine_default.number(),
  APP_MAINTENANCE: vine_default.boolean(),
  DEBUG: vine_default.boolean(),
  API_PREFIX: vine_default.string(),
  DOCS_PREFIX: vine_default.string(),
  DB_CONNECTION: vine_default.enum(["mysql", "sqlite", "postgres"]),
  DB_HOST: vine_default.string(),
  DB_PORT: vine_default.number(),
  DB_DATABASE: vine_default.string(),
  DB_USERNAME: vine_default.string(),
  DB_PASSWORD: vine_default.string(),
  AWS_ACCOUNT_ID: vine_default.string(),
  AWS_ACCESS_KEY_ID: vine_default.string(),
  AWS_SECRET_ACCESS_KEY: vine_default.string(),
  AWS_DEFAULT_REGION: vine_default.string(),
  AWS_DEFAULT_PASSWORD: vine_default.string(),
  MAIL_MAILER: vine_default.enum(["ses", "sendmail", "log", "smtp"]),
  MAIL_HOST: vine_default.string(),
  MAIL_PORT: vine_default.number(),
  MAIL_USERNAME: vine_default.string(),
  MAIL_PASSWORD: vine_default.string(),
  MAIL_ENCRYPTION: vine_default.string(),
  MAIL_FROM_NAME: vine_default.string(),
  MAIL_FROM_ADDRESS: vine_default.string(),
  SEARCH_ENGINE_DRIVER: vine_default.enum(["meilisearch", "algolia", "typesense"]),
  MEILISEARCH_HOST: vine_default.string(),
  MEILISEARCH_KEY: vine_default.string(),
  FRONTEND_APP_ENV: vine_default.enum(["development", "staging", "production"]),
  FRONTEND_APP_URL: vine_default.string()
};
var envEnum = {
  APP_ENV: ["local", "dev", "development", "staging", "prod", "production"],
  DB_CONNECTION: ["mysql", "sqlite", "postgres", "dynamodb"],
  MAIL_MAILER: ["smtp", "mailgun", "ses", "postmark", "sendmail", "log"],
  SEARCH_ENGINE_DRIVER: ["opensearch"],
  FRONTEND_APP_ENV: ["development", "staging", "production"]
};
var envStructure = Object.entries(env_default).reduce((acc, [key, value]) => {
  let validatorType;
  switch (typeof value) {
    case "string":
      validatorType = vine_default.string();
      break;
    case "number":
      validatorType = vine_default.number();
      break;
    case "boolean":
      validatorType = vine_default.boolean();
      break;
    default:
      if (Array.isArray(value)) {
        validatorType = vine_default.enum(value);
        break;
      }
      if (typeof value === "object") {
        const schemaNameSymbol = Symbol.for("schema_name");
        const schemaName = value[schemaNameSymbol];
        if (schemaName === "vine.string") {
          validatorType = vine_default.string();
          break;
        }
        if (schemaName === "vine.number") {
          validatorType = vine_default.number();
          break;
        }
        if (schemaName === "vine.boolean") {
          validatorType = vine_default.boolean();
          break;
        }
        if (!schemaName) {
          validatorType = vine_default.enum(envEnum.APP_ENV);
          break;
        }
        console.error("Unknown env value type", typeof value);
      }
      throw new Error(`Invalid env value for ${key}`);
  }
  const envKey = key;
  acc[envKey] = validatorType;
  return acc;
}, {});
var envSchema = vine_default.object(envStructure);
var handler = {
  get: (target, key) => {
    const value = target[key];
    if (typeof value === "string" && /^\d+$/.test(value) && key !== "AWS_ACCOUNT_ID")
      return Number(value);
    if (typeof value === "string" && /^true|false$/.test(value))
      return value === "true";
    if (value instanceof VineEnum)
      return target[key];
    if (value instanceof VineBoolean)
      return !!target[key];
    if (value instanceof VineNumber)
      return Number(target[key]);
    return value;
  }
};
function process6() {
  return typeof Bun !== "undefined" ? Bun.env : p2.env;
}
var env3 = new Proxy(process6(), handler);
var app_default = {
  name: env3.APP_NAME ?? "Stacks",
  description: "Stacks is a full-stack framework for building modern web applications.",
  env: env3.APP_ENV ?? "local",
  url: env3.APP_URL ?? "stacks.localhost",
  redirectUrls: ["stacksjs.com"],
  debug: env3.DEBUG ?? false,
  key: env3.APP_KEY,
  maintenanceMode: env3.APP_MAINTENANCE ?? false,
  docMode: false,
  timezone: "America/Los_Angeles",
  locale: "en",
  fallbackLocale: "en",
  cipher: "aes-256-cbc"
};
var cache_default = {
  driver: "dynamodb",
  prefix: "stacks",
  ttl: 3600,
  drivers: {
    dynamodb: {
      key: env3.AWS_ACCESS_KEY_ID || "",
      secret: env3.AWS_SECRET_ACCESS_KEY || "",
      region: env3.AWS_DEFAULT_REGION || "us-east-1",
      table: "cache",
      endpoint: ""
    },
    memcached: {
      persistent_id: "",
      sasl: ["", ""],
      options: {},
      servers: [
        {
          host: "127.0.0.1",
          port: 11211,
          weight: 100
        }
      ]
    },
    redis: {
      connection: "cache",
      host: "127.0.0.1",
      port: 6379,
      password: "",
      username: "stacks"
    }
  }
};
var cli_default = {
  name: "My Custom CLI",
  command: "custom-cli",
  description: "This is an example command to illustrate how to create your own commands. Check out `../app/commands` for more.",
  deploy: true
};
var security_default = {
  firewall: {
    enabled: true,
    countryCodes: ["RU", "IR"],
    ipAddresses: [],
    rateLimitPerMinute: 1000,
    useIpReputationLists: true,
    useKnownBadInputsRuleSet: true,
    queryString: [],
    httpHeaders: []
  }
};
var cloud_default = {
  sites: {
    root: "stacksjs.org",
    path: "dist",
    modals: {
      domain: "modals.stacksjs.org",
      path: "dist"
    },
    stepper: {
      domain: "stepper.stacksjs.org",
      path: "dist"
    },
    notification: {
      domain: "notification.stacksjs.org",
      path: "dist"
    },
    docs: {
      domain: "docs.stacksjs.org",
      path: "dist"
    },
    tlsx: {
      domain: "tlsx.stacksjs.org",
      path: "dist"
    },
    dtsx: {
      domain: "dtsx.stacksjs.org",
      path: "dist"
    },
    spreadsheet: {
      domain: "spreadsheet.stacksjs.org",
      path: "dist"
    }
  },
  infrastructure: {
    type: "serverless",
    driver: "aws",
    firewall: security_default.firewall,
    environments: ["production", "staging", "development"],
    storage: {},
    api: {
      prefix: env3.API_PREFIX || "api",
      description: "My awesome Stacks API",
      deploy: true,
      memorySize: 512,
      prewarm: 10,
      timeout: 30
    },
    cdn: {
      compress: true,
      allowedMethods: "ALL",
      cachedMethods: "GET_HEAD",
      originShieldRegion: "us-east-1",
      minTtl: 0,
      defaultTtl: 86400,
      maxTtl: 31536000,
      cookieBehavior: "none",
      allowList: {
        cookies: [],
        headers: [],
        queryStrings: []
      },
      realtimeLogs: {
        enabled: true,
        samplingRate: 1
      }
    },
    fileSystem: true
  }
};
var database_default = {
  default: env3.DB_CONNECTION || "sqlite",
  connections: {
    sqlite: {
      database: env3.DB_DATABASE || "database/stacks.sqlite",
      prefix: ""
    },
    dynamodb: {
      key: env3.AWS_ACCESS_KEY_ID || "",
      secret: env3.AWS_SECRET_ACCESS_KEY || "",
      region: env3.AWS_DEFAULT_REGION || "us-east-1",
      prefix: env3.DB_DATABASE || "stacks",
      endpoint: "http://localhost",
      port: env3.DB_PORT || 8000
    },
    mysql: {
      name: env3.DB_DATABASE || "stacks",
      host: env3.DB_HOST || "127.0.0.1",
      port: env3.DB_PORT || 3306,
      username: env3.DB_USERNAME || "root",
      password: env3.DB_PASSWORD || "",
      prefix: ""
    },
    postgres: {
      name: env3.DB_DATABASE || "stacks",
      host: env3.DB_HOST || "127.0.0.1",
      port: env3.DB_PORT || 3306,
      username: env3.DB_USERNAME || "",
      password: env3.DB_PASSWORD || "",
      prefix: ""
    }
  },
  migrations: "migrations",
  migrationLocks: "migration_locks"
};
var dns_default = {
  a: [
    {
      name: env3.APP_URL || "",
      address: "10.0.0.1",
      ttl: 300
    },
    {
      name: "www",
      address: "@",
      ttl: 300
    }
  ],
  aaaa: [],
  cname: [],
  mx: [],
  txt: [],
  nameservers: []
};
var email_default = {
  from: {
    name: env3.MAIL_FROM_NAME || "Stacks",
    address: env3.MAIL_FROM_ADDRESS || "no-reply@stacksjs.org"
  },
  mailboxes: ["chris@stacksjs.org", "blake@stacksjs.org", "glenn@stacksjs.org"],
  url: env3.APP_URL || "http://localhost:3000",
  charset: "UTF-8",
  server: {
    scan: true
  }
};
var errors_default = {
  messages: {
    string: "The {{ field }} field must be a string",
    email: "The {{ field }} field must be a valid email address",
    regex: "The {{ field }} field format is invalid",
    url: "The {{ field }} field must be a valid URL",
    activeUrl: "The {{ field }} field must be a valid URL",
    alpha: "The {{ field }} field must contain only letters",
    alphaNumeric: "The {{ field }} field must contain only letters and numbers",
    minLength: "The {{ field }} field must have at least {{ min }} characters",
    maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
    fixedLength: "The {{ field }} field must be {{ size }} characters long",
    confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
    endsWith: "The {{ field }} field must end with {{ substring }}",
    startsWith: "The {{ field }} field must start with {{ substring }}",
    sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
    notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
    in: "The selected {{ field }} is invalid",
    notIn: "The selected {{ field }} is invalid",
    ipAddress: "The {{ field }} field must be a valid IP address",
    uuid: "The {{ field }} field must be a valid UUID",
    ascii: "The {{ field }} field must only contain ASCII characters",
    creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
    hexCode: "The {{ field }} field must be a valid hex color code",
    iban: "The {{ field }} field must be a valid IBAN number",
    jwt: "The {{ field }} field must be a valid JWT token",
    coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
    mobile: "The {{ field }} field must be a valid mobile phone number",
    passport: "The {{ field }} field must be a valid passport number",
    postalCode: "The {{ field }} field must be a valid postal code",
    boolean: "The value must be a boolean",
    number: "The {{ field }} field must be a number",
    min: "The {{ field }} field must be at least {{ min }}",
    max: "The {{ field }} field must not be greater than {{ max }}",
    range: "The {{ field }} field must be between {{ min }} and {{ max }}",
    positive: "The {{ field }} field must be positive",
    negative: "The {{ field }} field must be negative",
    decimal: "The {{ field }} field must have {{ digits }} decimal places",
    withoutDecimals: "The {{ field }} field must not have decimal places",
    date: "The {{ field }} field must be a datetime value",
    "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
    "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
    "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
    "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
    "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
    "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
    "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
    "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
    accepted: "The {{ field }} field must be accepted",
    enum: "The selected {{ field }} is invalid",
    literal: "The {{ field }} field must be {{ expectedValue }}",
    object: "The {{ field }} field must be an object",
    record: "The {{ field }} field must be an object",
    "record.minLength": "The {{ field }} field must have at least {{ min }} items",
    "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
    "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
    array: "The {{ field }} field must be an array",
    "array.minLength": "The {{ field }} field must have at least {{ min }} items",
    "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
    "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
    notEmpty: "The {{ field }} field must not be empty",
    distinct: "The {{ field }} field has duplicate values",
    tuple: "The {{ field }} field must be an array",
    union: "Invalid value provided for {{ field }} field",
    unionGroup: "Invalid value provided for {{ field }} field",
    unionOfTypes: "Invalid value provided for {{ field }} field"
  }
};
var git_default = {
  hooks: {
    "pre-commit": "lint-staged"
  },
  scopes: [
    "",
    "ci",
    "deps",
    "dx",
    "release",
    "docs",
    "test",
    "core",
    "actions",
    "arrays",
    "auth",
    "build",
    "cache",
    "cli",
    "cloud",
    "collections",
    "config",
    "database",
    "datetime",
    "docs",
    "errors",
    "git",
    "lint",
    "x-ray",
    "modules",
    "notifications",
    "objects",
    "path",
    "realtime",
    "router",
    "buddy",
    "security",
    "server",
    "storage",
    "strings",
    "tests",
    "types",
    "ui",
    "utils"
  ],
  messages: {
    type: "Select the type of change that you\u2019re committing:",
    scope: "Select the SCOPE of this change (optional):",
    customScope: "Select the SCOPE of this change:",
    subject: "Write a SHORT, IMPERATIVE tense description of the change:\n",
    body: 'Provide a LONGER description of the change (optional). Use "|" to break new line:\n',
    breaking: 'List any BREAKING CHANGES (optional). Use "|" to break new line:\n',
    footerPrefixesSelect: "Select the ISSUES type of the change list by this change (optional):",
    customFooterPrefixes: "Input ISSUES prefix:",
    footer: "List any ISSUES by this change. E.g.: #31, #34:\n",
    confirmCommit: "Are you sure you want to proceed with the commit above?"
  },
  types: [
    { value: "feat", name: "feat:     \u2728  A new feature", emoji: ":sparkles:" },
    { value: "fix", name: "fix:      \uD83D\uDC1B  A bug fix", emoji: ":bug:" },
    {
      value: "docs",
      name: "docs:     \uD83D\uDCDD  Documentation only changes",
      emoji: ":memo:"
    },
    {
      value: "style",
      name: "style:    \uD83D\uDC84  Changes that do not affect the meaning of the code",
      emoji: ":lipstick:"
    },
    {
      value: "refactor",
      name: "refactor: \u267B\uFE0F   A code change that neither fixes a bug nor adds a feature",
      emoji: ":recycle:"
    },
    {
      value: "perf",
      name: "perf:     \u26A1\uFE0F  A code change that improves performance",
      emoji: ":zap:"
    },
    {
      value: "test",
      name: "test:     \u2705  Adding missing tests or adjusting existing tests",
      emoji: ":white_check_mark:"
    },
    {
      value: "build",
      name: "build:    \uD83D\uDCE6\uFE0F  Changes that affect the build system or external dependencies",
      emoji: ":package:"
    },
    {
      value: "ci",
      name: "ci:       \uD83C\uDFA1  Changes to our CI configuration files and scripts",
      emoji: ":ferris_wheel:"
    },
    {
      value: "chore",
      name: "chore:    \uD83D\uDD28  Other changes that don\u2019t modify src or test files",
      emoji: ":hammer:"
    },
    {
      value: "revert",
      name: "revert:   \u23EA\uFE0F  Reverts a previous commit",
      emoji: ":rewind:"
    }
  ]
};
var hashing_default = {
  driver: "argon2",
  bcrypt: {
    rounds: 10,
    cost: 4
  },
  argon2: {
    memory: 65536,
    threads: 1,
    time: 1
  }
};
var library_default = {
  name: "hello-world",
  owner: "@stacksjs",
  repository: "stacksjs/stacks",
  license: "MIT",
  author: "Chris Breuer",
  contributors: ["Chris Breuer <chris@stacksjs.org>"],
  defaultLanguage: "en",
  releaseable: true,
  vueComponents: {
    name: "hello-world-vue",
    description: "Your Vue component library description",
    keywords: ["component", "library", "vue", "vite", "typescript", "javascript"],
    tags: [
      {
        name: ["HelloWorld", "AppHelloWorld"],
        description: "The Hello World custom element, built via this framework.",
        attributes: [
          {
            name: "greeting",
            description: "The greeting."
          }
        ]
      }
    ]
  },
  webComponents: {
    name: "hello-world-elements",
    description: "Your framework agnostic web component library description.",
    keywords: ["custom-elements", "web-components", "library", "framework-agnostic", "typescript", "javascript"],
    tags: [
      {
        name: ["HelloWorld", "AppHelloWorld"],
        description: "The Hello World custom element, built via this framework.",
        attributes: [
          {
            name: "greeting",
            description: "The greeting."
          }
        ]
      }
    ]
  },
  functions: {
    name: "hello-world-fx",
    description: "Your function library description.",
    keywords: ["functions", "composables", "library", "typescript", "javascript"],
    shouldGenerateSourcemap: false,
    files: ["counter", "dark"]
  }
};
var logging_default = {
  logsPath: storagePath("logs/stacks.log"),
  deploymentsPath: storagePath("logs/deployments.log")
};
var notification_default = {
  default: "email"
};
var payment_default = {
  driver: "stripe",
  stripe: {
    publishableKey: env3.STRIPE_PUBLISHABLE_KEY || "",
    secretKey: env3.STRIPE_SECRET_KEY || ""
  }
};
var ports_default = {
  frontend: env3.PORT ?? 3000,
  backend: env3.PORT_BACKEND ?? 3001,
  admin: env3.PORT_ADMIN ?? 3002,
  library: env3.PORT_LIBRARY ?? 3003,
  desktop: env3.PORT_DESKTOP ?? 3004,
  email: env3.PORT_EMAIL ?? 3005,
  docs: env3.PORT_DOCS ?? 3006,
  inspect: env3.PORT_INSPECT ?? 3007,
  api: env3.PORT_API ?? 3008,
  systemTray: env3.PORT_SYSTEM_TRAY ?? 3009,
  database: 3010
};
var queue_default = {
  default: "sync",
  connections: {
    sync: {
      driver: "sync"
    },
    sqs: {
      driver: "sqs",
      key: "",
      secret: "",
      prefix: "",
      suffix: "",
      queue: "default",
      region: "us-east-1"
    }
  }
};
var saas_default = {
  plans: [
    {
      productName: "Stacks Hobby",
      description: "All the Stacks features.",
      pricing: [
        {
          key: "stacks_hobby_monthly",
          price: 3900,
          interval: "month",
          currency: "usd"
        },
        {
          key: "stacks_hobby_yearly",
          price: 37900,
          interval: "year",
          currency: "usd"
        }
      ],
      metadata: {
        createdBy: "admin",
        version: "1.0.0"
      }
    },
    {
      productName: "Stacks Pro",
      description: "All the Stacks features, including being able to invite team members.",
      pricing: [
        {
          key: "stacks_pro_monthly",
          price: 5900,
          interval: "month",
          currency: "usd"
        },
        {
          key: "stacks_pro_yearly",
          price: 57900,
          interval: "year",
          currency: "usd"
        }
      ],
      metadata: {
        createdBy: "admin",
        version: "1.0.0"
      }
    }
  ],
  webhook: {
    endpoint: "/webhooks/stripe",
    secret: ""
  },
  currencies: ["usd"],
  coupons: [
    {
      code: "SUMMER2024",
      amountOff: 500,
      duration: "once"
    }
  ],
  products: [
    {
      name: "Stacks Pro",
      description: "All the Stacks features.",
      images: ["url_to_image"]
    }
  ]
};
var search_engine_default = {
  driver: "opensearch"
};
var services_default = {
  aws: {
    accountId: env3.AWS_ACCOUNT_ID || "",
    appId: env3.AWS_ACCESS_KEY_ID || "",
    apiKey: env3.AWS_SECRET_ACCESS_KEY || "",
    region: env3.AWS_DEFAULT_REGION || "us-east-1"
  },
  algolia: {
    appId: "",
    apiKey: ""
  },
  meilisearch: {
    appId: "",
    apiKey: ""
  },
  lemonSqueezy: {
    appId: "",
    apiKey: ""
  },
  stripe: {
    appId: "",
    apiKey: ""
  }
};
var storage_default = {
  driver: "s3"
};
var team_default = {
  name: "Stacks",
  members: {
    chris: "chris@stacksjs.org",
    blake: "blake@stacksjs.org",
    zoltan: "zoltan@stacksjs.org",
    freddy: "freddy@stacksjs.org",
    glenn: "glenn@stacksjs.org",
    dorell: "dorell@stacksjs.org",
    avery: "avery@stacksjs.org",
    adelino: "adelino@stacksjs.org"
  }
};
var ui_default = {
  shortcuts: [
    [
      "btn",
      "inline-flex items-center px-4 py-2 ml-2 border border-transparent shadow-sm text-base font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 cursor-pointer"
    ]
  ],
  safelist: "prose prose-sm m-auto text-left",
  trigger: ":stx:",
  classPrefix: "stx-",
  reset: "tailwind",
  icons: ["heroicons"],
  fonts: {
    email: {
      title: "Mona",
      text: "Hubot"
    },
    desktop: {
      title: "Mona",
      text: "Hubot"
    },
    mobile: {
      title: "Mona",
      text: "Hubot"
    },
    web: {
      title: "Mona",
      text: "Hubot"
    }
  },
  theme: {
    colors: {
      veryCool: "#0000ff",
      brand: {
        primary: "hsl(var(--hue, 217) 78% 51%)"
      }
    }
  }
};
var config2 = {
  ai: ai_default,
  analytics: analytics_default,
  app: app_default,
  cache: cache_default,
  cli: cli_default,
  cloud: cloud_default,
  database: database_default,
  dns: dns_default,
  email: email_default,
  errors: errors_default,
  git: git_default,
  hashing: hashing_default,
  library: library_default,
  logging: logging_default,
  notification: notification_default,
  queue: queue_default,
  payment: payment_default,
  ports: ports_default,
  saas: saas_default,
  searchEngine: search_engine_default,
  security: security_default,
  services: services_default,
  storage: storage_default,
  team: team_default,
  ui: ui_default
};
var overrides_default = config2;
async function localTunnel(options2) {
  const port = 3000;
  if (!options2?.port)
    options2 = { port };
  console.log("Creating local tunnel", options2.port);
  return "localTunnel";
}
async function createLocalTunnel(port) {
  return await localTunnel({ port });
}
async function localUrl({
  domain = exports_config.app.url || "stacks",
  type = "frontend",
  localhost = false,
  https = undefined,
  network = undefined
} = {}) {
  let url = domain.replace(/\.[^.]+$/, ".localhost");
  switch (type) {
    case "frontend":
      if (network)
        return await createLocalTunnel(exports_config.ports?.frontend || 3000);
      if (localhost)
        return `http://localhost:${exports_config.ports?.frontend}`;
      break;
    case "backend":
      if (network)
        return await createLocalTunnel(exports_config.ports?.backend || 3001);
      if (localhost)
        return `http://localhost:${exports_config.ports?.backend}`;
      url = `api.${url}`;
      break;
    case "admin":
      if (network)
        return await createLocalTunnel(exports_config.ports?.admin || 3002);
      if (localhost)
        return `http://localhost:${exports_config.ports?.admin}`;
      url = `admin.${url}`;
      break;
    case "library":
      if (network)
        return await createLocalTunnel(exports_config.ports?.library || 3003);
      if (localhost)
        return `http://localhost:${exports_config.ports?.library}`;
      url = `libs.${url}`;
      break;
    case "email":
      if (network)
        return await createLocalTunnel(exports_config.ports?.email || 3005);
      if (localhost)
        return `http://localhost:${exports_config.ports?.email}`;
      url = `email.${url}`;
      break;
    case "desktop":
      if (network)
        return await createLocalTunnel(exports_config.ports?.desktop || 3004);
      if (localhost)
        return `http://localhost:${exports_config.ports?.desktop}`;
      url = `desktop.${url}`;
      break;
    case "docs":
      if (network)
        return await createLocalTunnel(exports_config.ports?.docs || 3006);
      if (localhost)
        return `http://localhost:${exports_config.ports?.docs}`;
      url = `docs.${url}`;
      break;
    case "inspect":
      if (network)
        return await createLocalTunnel(exports_config.ports?.inspect || 3007);
      if (localhost)
        return `http://localhost:${exports_config.ports?.inspect}`;
      url = `inspect.${url}`;
      break;
    default:
      if (localhost)
        return `http://localhost:${exports_config.ports?.frontend}`;
  }
  if (https)
    return `https://${url}`;
  return `http://${url}`;
}
function defineStacksConfig(config3) {
  return config3;
}
function defineApp(config3) {
  return config3;
}
function defineCache(config3) {
  return config3;
}
function defineCdn(config3) {
  return config3;
}
function defineChat(config3) {
  return config3;
}
function defineCli(config3) {
  return config3;
}
function defineJob(config3) {
  return config3;
}
function defineCronJob(config3) {
  return config3;
}
function defineDatabase(config3) {
  return config3;
}
function defineDependencies(config3) {
  return config3;
}
function defineDns(config3) {
  return config3;
}
function defineEmailConfig(config3) {
  return config3;
}
function defineEmail(config3) {
  return config3;
}
function defineGit(config3) {
  return config3;
}
function defineHashing(config3) {
  return config3;
}
function defineLibrary(config3) {
  return config3;
}
function defineNotification(config3) {
  return config3;
}
function definePayment(config3) {
  return config3;
}
function defineQueue(config3) {
  return config3;
}
function defineSearchEngine(config3) {
  return config3;
}
function defineSecurity(config3) {
  return config3;
}
function defineServices(config3) {
  return config3;
}
function defineSms(config3) {
  return config3;
}
function defineStorage(config3) {
  return config3;
}
function defineUi(config3) {
  return config3;
}
function defineModel(config3) {
  return config3;
}
function defineEvents(config3) {
  return config3;
}
var config3 = {
  ...defaults_default,
  ...overrides_default
};
var ai2 = config3.ai;
var analytics2 = config3.analytics;
var app2 = config3.app;
var cache2 = config3.cache;
var cloud2 = config3.cloud;
var cli3 = config3.cli;
var database2 = config3.database;
var dns2 = config3.dns;
var docs2 = config3.docs;
var email2 = config3.email;
var errors2 = config3.errors;
var git2 = config3.git;
var hashing2 = config3.hashing;
var library2 = config3.library;
var logging2 = config3.logging;
var notification = config3.notification;
var payment = config3.payment;
var ports2 = config3.ports;
var queue3 = config3.queue;
var security2 = config3.security;
var saas2 = config3.saas;
var searchEngine = config3.searchEngine;
var services2 = config3.services;
var storage2 = config3.storage;
var team2 = config3.team;
var ui2 = config3.ui;
function determineAppEnv() {
  if (app2.env === "local")
    return "dev";
  if (app2.env === "development")
    return "dev";
  if (app2.env === "staging")
    return "stage";
  if (app2.env === "production")
    return "prod";
  if (!app2.env)
    throw new Error("Couldn\'t determine app environment");
  return app2.env;
}

class ErrorHandler {
  static isTestEnvironment = false;
  static shouldExitProcess = true;
  static handle(err, options2) {
    this.shouldExitProcess = options2?.shouldExit !== false;
    if (options2?.silent !== true)
      this.writeErrorToConsole(err);
    let errorMessage;
    if (options2?.message) {
      errorMessage = options2.message;
    } else if (err instanceof Error) {
      errorMessage = err.message;
    } else if (typeof err === "string") {
      errorMessage = err;
    } else {
      errorMessage = JSON.stringify(err);
    }
    const error = new Error(errorMessage);
    if (err instanceof Error) {
      Object.assign(error, err);
    }
    this.writeErrorToFile(error).catch((e) => console.error(e));
    return error;
  }
  static handleError(err, options2) {
    this.handle(err, options2);
    return err;
  }
  static async writeErrorToFile(err) {
    if (!(err instanceof Error)) {
      console.error("Error is not an instance of Error:", err);
      return;
    }
    const formattedError = `[${new Date().toISOString()}] ${err.name}: ${err.message}\n`;
    const logFilePath = logsPath("stacks.log") ?? logsPath("errors.log");
    try {
      await mkdir(dirname(logFilePath), { recursive: true });
      await appendFile(logFilePath, formattedError);
    } catch (error) {
      console.error("Failed to write to error file:", error);
    }
  }
  static writeErrorToConsole(err) {
    console.error(err);
    const errorString = typeof err === "string" ? err : err instanceof Error ? err.message : JSON.stringify(err);
    if (errorString.includes("bunx --bun cdk destroy") || errorString === `Failed to execute command: ${italic("bunx --bun eslint . --fix")}` || errorString === `Failed to execute command: ${italic("bun storage/framework/core/actions/src/lint/fix.ts")}`) {
      if (!this.isTestEnvironment) {
        console.log("No need to worry. The edge function is currently being destroyed. Please run `buddy undeploy` shortly again, and continue doing so until it succeeds running.");
        console.log("Hoping to see you back soon!");
      }
    }
    if (this.shouldExitProcess) {
      process7.exit(1);
    }
  }
}
function handleError(err, options2) {
  let errorMessage;
  if (isString(err)) {
    errorMessage = err;
  } else if (err instanceof Error) {
    errorMessage = err.message;
  } else if (options2 instanceof Error) {
    errorMessage = options2.message;
  } else {
    errorMessage = String(err);
  }
  writeToLogFile(`ERROR: ${stripAnsi(errorMessage)}`);
  return ErrorHandler.handle(err, options2);
}
async function writeToLogFile(message, options2) {
  const formattedMessage = `[${new Date().toISOString()}] ${message}\n`;
  try {
    const logFile = options2?.logFile ?? exports_config.logging.logsPath ?? "storage/logs/stacks.log";
    try {
      await access(logFile);
    } catch {
      await mkdir(dirname2(logFile), { recursive: true });
    }
    await appendFile(logFile, formattedMessage);
  } catch (error) {
    console.error("Failed to write to log file:", error);
  }
}
var defaultErrorConfig = {
  withStackTrace: false
};
var createNeverThrowError = (message, result2, config5 = defaultErrorConfig) => {
  const data = result2.isOk() ? { type: "Ok", value: result2.value } : { type: "Err", value: result2.error };
  const maybeStack = config5.withStackTrace ? new Error().stack : undefined;
  return {
    data,
    message,
    stack: maybeStack
  };
};
function __awaiter(thisArg, _arguments, P2, generator) {
  function adopt(value) {
    return value instanceof P2 ? value : new P2(function(resolve3) {
      resolve3(value);
    });
  }
  return new (P2 || (P2 = Promise))(function(resolve3, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result2) {
      result2.done ? resolve3(result2.value) : adopt(result2.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __values(o) {
  var s3 = typeof Symbol === "function" && Symbol.iterator, m2 = s3 && o[s3], i = 0;
  if (m2)
    return m2.call(o);
  if (o && typeof o.length === "number")
    return {
      next: function() {
        if (o && i >= o.length)
          o = undefined;
        return { value: o && o[i++], done: !o };
      }
    };
  throw new TypeError(s3 ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __await(v2) {
  return this instanceof __await ? (this.v = v2, this) : new __await(v2);
}
function __asyncGenerator(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g2 = generator.apply(thisArg, _arguments || []), i, q3 = [];
  return i = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function() {
    return this;
  }, i;
  function awaitReturn(f2) {
    return function(v2) {
      return Promise.resolve(v2).then(f2, reject);
    };
  }
  function verb(n, f2) {
    if (g2[n]) {
      i[n] = function(v2) {
        return new Promise(function(a, b2) {
          q3.push([n, v2, a, b2]) > 1 || resume(n, v2);
        });
      };
      if (f2)
        i[n] = f2(i[n]);
    }
  }
  function resume(n, v2) {
    try {
      step(g2[n](v2));
    } catch (e) {
      settle(q3[0][3], e);
    }
  }
  function step(r2) {
    r2.value instanceof __await ? Promise.resolve(r2.value.v).then(fulfill, reject) : settle(q3[0][2], r2);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f2, v2) {
    if (f2(v2), q3.shift(), q3.length)
      resume(q3[0][0], q3[0][1]);
  }
}
function __asyncDelegator(o) {
  var i, p3;
  return i = {}, verb("next"), verb("throw", function(e) {
    throw e;
  }), verb("return"), i[Symbol.iterator] = function() {
    return this;
  }, i;
  function verb(n, f2) {
    i[n] = o[n] ? function(v2) {
      return (p3 = !p3) ? { value: __await(o[n](v2)), done: false } : f2 ? f2(v2) : v2;
    } : f2;
  }
}
function __asyncValues(o) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m2 = o[Symbol.asyncIterator], i;
  return m2 ? m2.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i);
  function verb(n) {
    i[n] = o[n] && function(v2) {
      return new Promise(function(resolve3, reject) {
        v2 = o[n](v2), settle(resolve3, reject, v2.done, v2.value);
      });
    };
  }
  function settle(resolve3, reject, d, v2) {
    Promise.resolve(v2).then(function(v3) {
      resolve3({ value: v3, done: d });
    }, reject);
  }
}

class ResultAsync {
  constructor(res) {
    this._promise = res;
  }
  static fromSafePromise(promise2) {
    const newPromise = promise2.then((value) => new Ok(value));
    return new ResultAsync(newPromise);
  }
  static fromPromise(promise2, errorFn) {
    const newPromise = promise2.then((value) => new Ok(value)).catch((e) => new Err(errorFn(e)));
    return new ResultAsync(newPromise);
  }
  static fromThrowable(fn, errorFn) {
    return (...args) => {
      return new ResultAsync((() => __awaiter(this, undefined, undefined, function* () {
        try {
          return new Ok(yield fn(...args));
        } catch (error) {
          return new Err(errorFn ? errorFn(error) : error);
        }
      }))());
    };
  }
  static combine(asyncResultList) {
    return combineResultAsyncList(asyncResultList);
  }
  static combineWithAllErrors(asyncResultList) {
    return combineResultAsyncListWithAllErrors(asyncResultList);
  }
  map(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return new Err(res.error);
      }
      return new Ok(yield f2(res.value));
    })));
  }
  andThrough(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return new Err(res.error);
      }
      const newRes = yield f2(res.value);
      if (newRes.isErr()) {
        return new Err(newRes.error);
      }
      return new Ok(res.value);
    })));
  }
  andTee(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return new Err(res.error);
      }
      try {
        yield f2(res.value);
      } catch (e) {
      }
      return new Ok(res.value);
    })));
  }
  mapErr(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, undefined, undefined, function* () {
      if (res.isOk()) {
        return new Ok(res.value);
      }
      return new Err(yield f2(res.error));
    })));
  }
  andThen(f2) {
    return new ResultAsync(this._promise.then((res) => {
      if (res.isErr()) {
        return new Err(res.error);
      }
      const newValue = f2(res.value);
      return newValue instanceof ResultAsync ? newValue._promise : newValue;
    }));
  }
  orElse(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return f2(res.error);
      }
      return new Ok(res.value);
    })));
  }
  match(ok, _err) {
    return this._promise.then((res) => res.match(ok, _err));
  }
  unwrapOr(t) {
    return this._promise.then((res) => res.unwrapOr(t));
  }
  safeUnwrap() {
    return __asyncGenerator(this, arguments, function* safeUnwrap_1() {
      return yield __await(yield __await(yield* __asyncDelegator(__asyncValues(yield __await(this._promise.then((res) => res.safeUnwrap()))))));
    });
  }
  then(successCallback, failureCallback) {
    return this._promise.then(successCallback, failureCallback);
  }
  [Symbol.asyncIterator]() {
    return __asyncGenerator(this, arguments, function* _a() {
      const result2 = yield __await(this._promise);
      if (result2.isErr()) {
        yield yield __await(errAsync(result2.error));
      }
      return yield __await(result2.value);
    });
  }
}
var errAsync = (err) => new ResultAsync(Promise.resolve(new Err(err)));
var fromPromise = ResultAsync.fromPromise;
var fromSafePromise = ResultAsync.fromSafePromise;
var fromAsyncThrowable = ResultAsync.fromThrowable;
var combineResultList = (resultList) => {
  let acc = ok([]);
  for (const result2 of resultList) {
    if (result2.isErr()) {
      acc = err(result2.error);
      break;
    } else {
      acc.map((list) => list.push(result2.value));
    }
  }
  return acc;
};
var combineResultAsyncList = (asyncResultList) => ResultAsync.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultList);
var combineResultListWithAllErrors = (resultList) => {
  let acc = ok([]);
  for (const result2 of resultList) {
    if (result2.isErr() && acc.isErr()) {
      acc.error.push(result2.error);
    } else if (result2.isErr() && acc.isOk()) {
      acc = err([result2.error]);
    } else if (result2.isOk() && acc.isOk()) {
      acc.value.push(result2.value);
    }
  }
  return acc;
};
var combineResultAsyncListWithAllErrors = (asyncResultList) => ResultAsync.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultListWithAllErrors);
var Result;
(function(Result2) {
  function fromThrowable(fn, errorFn) {
    return (...args) => {
      try {
        const result2 = fn(...args);
        return ok(result2);
      } catch (e) {
        return err(errorFn ? errorFn(e) : e);
      }
    };
  }
  Result2.fromThrowable = fromThrowable;
  function combine(resultList) {
    return combineResultList(resultList);
  }
  Result2.combine = combine;
  function combineWithAllErrors(resultList) {
    return combineResultListWithAllErrors(resultList);
  }
  Result2.combineWithAllErrors = combineWithAllErrors;
})(Result || (Result = {}));
var ok = (value) => new Ok(value);
function err(err2) {
  return new Err(err2);
}

class Ok {
  constructor(value) {
    this.value = value;
  }
  isOk() {
    return true;
  }
  isErr() {
    return !this.isOk();
  }
  map(f2) {
    return ok(f2(this.value));
  }
  mapErr(_f) {
    return ok(this.value);
  }
  andThen(f2) {
    return f2(this.value);
  }
  andThrough(f2) {
    return f2(this.value).map((_value) => this.value);
  }
  andTee(f2) {
    try {
      f2(this.value);
    } catch (e) {
    }
    return ok(this.value);
  }
  orElse(_f) {
    return ok(this.value);
  }
  asyncAndThen(f2) {
    return f2(this.value);
  }
  asyncAndThrough(f2) {
    return f2(this.value).map(() => this.value);
  }
  asyncMap(f2) {
    return ResultAsync.fromSafePromise(f2(this.value));
  }
  unwrapOr(_v) {
    return this.value;
  }
  match(ok2, _err) {
    return ok2(this.value);
  }
  safeUnwrap() {
    const value = this.value;
    return function* () {
      return value;
    }();
  }
  _unsafeUnwrap(_2) {
    return this.value;
  }
  _unsafeUnwrapErr(config5) {
    throw createNeverThrowError("Called `_unsafeUnwrapErr` on an Ok", this, config5);
  }
  *[Symbol.iterator]() {
    return this.value;
  }
}

class Err {
  constructor(error) {
    this.error = error;
  }
  isOk() {
    return false;
  }
  isErr() {
    return !this.isOk();
  }
  map(_f) {
    return err(this.error);
  }
  mapErr(f2) {
    return err(f2(this.error));
  }
  andThrough(_f) {
    return err(this.error);
  }
  andTee(_f) {
    return err(this.error);
  }
  andThen(_f) {
    return err(this.error);
  }
  orElse(f2) {
    return f2(this.error);
  }
  asyncAndThen(_f) {
    return errAsync(this.error);
  }
  asyncAndThrough(_f) {
    return errAsync(this.error);
  }
  asyncMap(_f) {
    return errAsync(this.error);
  }
  unwrapOr(v2) {
    return v2;
  }
  match(_ok, err2) {
    return err2(this.error);
  }
  safeUnwrap() {
    const error = this.error;
    return function* () {
      yield err(error);
      throw new Error("Do not use this generator out of `safeTry`");
    }();
  }
  _unsafeUnwrap(config5) {
    throw createNeverThrowError("Called `_unsafeUnwrap` on an Err", this, config5);
  }
  _unsafeUnwrapErr(_2) {
    return this.error;
  }
  *[Symbol.iterator]() {
    const self2 = this;
    yield self2;
    return self2;
  }
}
var fromThrowable = Result.fromThrowable;
var import_prompts = __toESM2(require_prompts3(), 1);
var exports_esm = {};
__export(exports_esm, {
  yellow: () => yellow,
  white: () => white,
  underline: () => underline,
  trueColorBg: () => trueColorBg,
  trueColor: () => trueColor,
  stripColors: () => stripColors,
  strikethrough: () => strikethrough,
  reset: () => reset,
  red: () => red,
  options: () => options2,
  magenta: () => magenta,
  link: () => link,
  lightYellow: () => lightYellow,
  lightRed: () => lightRed,
  lightMagenta: () => lightMagenta,
  lightGreen: () => lightGreen,
  lightGray: () => lightGray,
  lightCyan: () => lightCyan,
  lightBlue: () => lightBlue,
  italic: () => italic,
  inverse: () => inverse,
  hidden: () => hidden,
  green: () => green,
  gray: () => gray,
  dim: () => dim,
  cyan: () => cyan,
  bold: () => bold,
  blue: () => blue,
  black: () => black,
  bgYellow: () => bgYellow,
  bgWhite: () => bgWhite,
  bgRed: () => bgRed,
  bgMagenta: () => bgMagenta,
  bgLightYellow: () => bgLightYellow,
  bgLightRed: () => bgLightRed,
  bgLightMagenta: () => bgLightMagenta,
  bgLightGreen: () => bgLightGreen,
  bgLightGray: () => bgLightGray,
  bgLightCyan: () => bgLightCyan,
  bgLightBlue: () => bgLightBlue,
  bgGreen: () => bgGreen,
  bgGray: () => bgGray,
  bgCyan: () => bgCyan,
  bgBlue: () => bgBlue,
  bgBlack: () => bgBlack,
  ansi256Bg: () => ansi256Bg,
  ansi256: () => ansi256
});
var enabled = true;
var globalVar = typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var supportLevel = 0;
if (globalVar.process && globalVar.process.env && globalVar.process.stdout) {
  const { FORCE_COLOR, NODE_DISABLE_COLORS, NO_COLOR, TERM, COLORTERM } = globalVar.process.env;
  if (NODE_DISABLE_COLORS || NO_COLOR || FORCE_COLOR === "0") {
    enabled = false;
  } else if (FORCE_COLOR === "1" || FORCE_COLOR === "2" || FORCE_COLOR === "3") {
    enabled = true;
  } else if (TERM === "dumb") {
    enabled = false;
  } else if ("CI" in globalVar.process.env && [
    "TRAVIS",
    "CIRCLECI",
    "APPVEYOR",
    "GITLAB_CI",
    "GITHUB_ACTIONS",
    "BUILDKITE",
    "DRONE"
  ].some((vendor) => (vendor in globalVar.process.env))) {
    enabled = true;
  } else {
    enabled = process.stdout.isTTY;
  }
  if (enabled) {
    if (process.platform === "win32") {
      supportLevel = 3;
    } else {
      if (COLORTERM && (COLORTERM === "truecolor" || COLORTERM === "24bit")) {
        supportLevel = 3;
      } else if (TERM && (TERM.endsWith("-256color") || TERM.endsWith("256"))) {
        supportLevel = 2;
      } else {
        supportLevel = 1;
      }
    }
  }
}
var options2 = {
  enabled,
  supportLevel
};
function kolorist(start, end, level = 1) {
  const open = `\x1B[${start}m`;
  const close = `\x1B[${end}m`;
  const regex2 = new RegExp(`\\x1b\\[${end}m`, "g");
  return (str) => {
    return options2.enabled && options2.supportLevel >= level ? open + ("" + str).replace(regex2, open) + close : "" + str;
  };
}
function rgbToAnsi256(r2, g2, b2) {
  if (r2 >> 4 === g2 >> 4 && g2 >> 4 === b2 >> 4) {
    if (r2 < 8) {
      return 16;
    }
    if (r2 > 248) {
      return 231;
    }
    return Math.round((r2 - 8) / 247 * 24) + 232;
  }
  const ansi = 16 + 36 * Math.round(r2 / 255 * 5) + 6 * Math.round(g2 / 255 * 5) + Math.round(b2 / 255 * 5);
  return ansi;
}
function stripColors(str) {
  return ("" + str).replace(/\x1b\[[0-9;]+m/g, "").replace(/\x1b\]8;;.*?\x07(.*?)\x1b\]8;;\x07/g, (_2, group2) => group2);
}
var reset = kolorist(0, 0);
var bold = kolorist(1, 22);
var dim = kolorist(2, 22);
var italic = kolorist(3, 23);
var underline = kolorist(4, 24);
var inverse = kolorist(7, 27);
var hidden = kolorist(8, 28);
var strikethrough = kolorist(9, 29);
var black = kolorist(30, 39);
var red = kolorist(31, 39);
var green = kolorist(32, 39);
var yellow = kolorist(33, 39);
var blue = kolorist(34, 39);
var magenta = kolorist(35, 39);
var cyan = kolorist(36, 39);
var white = kolorist(97, 39);
var gray = kolorist(90, 39);
var lightGray = kolorist(37, 39);
var lightRed = kolorist(91, 39);
var lightGreen = kolorist(92, 39);
var lightYellow = kolorist(93, 39);
var lightBlue = kolorist(94, 39);
var lightMagenta = kolorist(95, 39);
var lightCyan = kolorist(96, 39);
var bgBlack = kolorist(40, 49);
var bgRed = kolorist(41, 49);
var bgGreen = kolorist(42, 49);
var bgYellow = kolorist(43, 49);
var bgBlue = kolorist(44, 49);
var bgMagenta = kolorist(45, 49);
var bgCyan = kolorist(46, 49);
var bgWhite = kolorist(107, 49);
var bgGray = kolorist(100, 49);
var bgLightRed = kolorist(101, 49);
var bgLightGreen = kolorist(102, 49);
var bgLightYellow = kolorist(103, 49);
var bgLightBlue = kolorist(104, 49);
var bgLightMagenta = kolorist(105, 49);
var bgLightCyan = kolorist(106, 49);
var bgLightGray = kolorist(47, 49);
var ansi256 = (n) => kolorist("38;5;" + n, 0, 2);
var ansi256Bg = (n) => kolorist("48;5;" + n, 0, 2);
var trueColor = (r2, g2, b2) => {
  return options2.supportLevel === 2 ? ansi256(rgbToAnsi256(r2, g2, b2)) : kolorist(`38;2;${r2};${g2};${b2}`, 0, 3);
};
var trueColorBg = (r2, g2, b2) => {
  return options2.supportLevel === 2 ? ansi256Bg(rgbToAnsi256(r2, g2, b2)) : kolorist(`48;2;${r2};${g2};${b2}`, 0, 3);
};
var OSC = "\x1B]";
var BEL = "\x07";
var SEP = ";";
function link(text2, url) {
  return options2.enabled ? OSC + "8" + SEP + SEP + url + BEL + text2 + OSC + "8" + SEP + SEP + BEL : `${text2} (\u200B${url}\u200B)`;
}
function buddyOptions(options22) {
  if (Array.isArray(options22)) {
    options22 = Array.from(new Set(options22));
    if (Array.isArray(options22) && options22[0] && !options22[0].startsWith("-"))
      options22.shift();
    return options22.join(" ");
  }
  if (typeof options22 === "object" && options22 !== null) {
    return Object.entries(options22).map(([key, value]) => {
      if (value === true)
        return `--${key}`;
      return `--${key} ${value}`;
    }).join(" ");
  }
  return buddyOptions(process10.argv.slice(2));
}
var ANSI_BACKGROUND_OFFSET = 10;
var wrapAnsi16 = (offset = 0) => (code) => `\x1B[${code + offset}m`;
var wrapAnsi256 = (offset = 0) => (code) => `\x1B[${38 + offset};5;${code}m`;
var wrapAnsi16m = (offset = 0) => (red2, green2, blue2) => `\x1B[${38 + offset};2;${red2};${green2};${blue2}m`;
var styles = {
  modifier: {
    reset: [0, 0],
    bold: [1, 22],
    dim: [2, 22],
    italic: [3, 23],
    underline: [4, 24],
    overline: [53, 55],
    inverse: [7, 27],
    hidden: [8, 28],
    strikethrough: [9, 29]
  },
  color: {
    black: [30, 39],
    red: [31, 39],
    green: [32, 39],
    yellow: [33, 39],
    blue: [34, 39],
    magenta: [35, 39],
    cyan: [36, 39],
    white: [37, 39],
    blackBright: [90, 39],
    gray: [90, 39],
    grey: [90, 39],
    redBright: [91, 39],
    greenBright: [92, 39],
    yellowBright: [93, 39],
    blueBright: [94, 39],
    magentaBright: [95, 39],
    cyanBright: [96, 39],
    whiteBright: [97, 39]
  },
  bgColor: {
    bgBlack: [40, 49],
    bgRed: [41, 49],
    bgGreen: [42, 49],
    bgYellow: [43, 49],
    bgBlue: [44, 49],
    bgMagenta: [45, 49],
    bgCyan: [46, 49],
    bgWhite: [47, 49],
    bgBlackBright: [100, 49],
    bgGray: [100, 49],
    bgGrey: [100, 49],
    bgRedBright: [101, 49],
    bgGreenBright: [102, 49],
    bgYellowBright: [103, 49],
    bgBlueBright: [104, 49],
    bgMagentaBright: [105, 49],
    bgCyanBright: [106, 49],
    bgWhiteBright: [107, 49]
  }
};
var modifierNames = Object.keys(styles.modifier);
var foregroundColorNames = Object.keys(styles.color);
var backgroundColorNames = Object.keys(styles.bgColor);
var colorNames = [...foregroundColorNames, ...backgroundColorNames];
function assembleStyles() {
  const codes = new Map;
  for (const [groupName, group2] of Object.entries(styles)) {
    for (const [styleName, style] of Object.entries(group2)) {
      styles[styleName] = {
        open: `\x1B[${style[0]}m`,
        close: `\x1B[${style[1]}m`
      };
      group2[styleName] = styles[styleName];
      codes.set(style[0], style[1]);
    }
    Object.defineProperty(styles, groupName, {
      value: group2,
      enumerable: false
    });
  }
  Object.defineProperty(styles, "codes", {
    value: codes,
    enumerable: false
  });
  styles.color.close = "\x1B[39m";
  styles.bgColor.close = "\x1B[49m";
  styles.color.ansi = wrapAnsi16();
  styles.color.ansi256 = wrapAnsi256();
  styles.color.ansi16m = wrapAnsi16m();
  styles.bgColor.ansi = wrapAnsi16(ANSI_BACKGROUND_OFFSET);
  styles.bgColor.ansi256 = wrapAnsi256(ANSI_BACKGROUND_OFFSET);
  styles.bgColor.ansi16m = wrapAnsi16m(ANSI_BACKGROUND_OFFSET);
  Object.defineProperties(styles, {
    rgbToAnsi256: {
      value(red2, green2, blue2) {
        if (red2 === green2 && green2 === blue2) {
          if (red2 < 8) {
            return 16;
          }
          if (red2 > 248) {
            return 231;
          }
          return Math.round((red2 - 8) / 247 * 24) + 232;
        }
        return 16 + 36 * Math.round(red2 / 255 * 5) + 6 * Math.round(green2 / 255 * 5) + Math.round(blue2 / 255 * 5);
      },
      enumerable: false
    },
    hexToRgb: {
      value(hex) {
        const matches = /[a-f\d]{6}|[a-f\d]{3}/i.exec(hex.toString(16));
        if (!matches) {
          return [0, 0, 0];
        }
        let [colorString] = matches;
        if (colorString.length === 3) {
          colorString = [...colorString].map((character) => character + character).join("");
        }
        const integer = Number.parseInt(colorString, 16);
        return [
          integer >> 16 & 255,
          integer >> 8 & 255,
          integer & 255
        ];
      },
      enumerable: false
    },
    hexToAnsi256: {
      value: (hex) => styles.rgbToAnsi256(...styles.hexToRgb(hex)),
      enumerable: false
    },
    ansi256ToAnsi: {
      value(code) {
        if (code < 8) {
          return 30 + code;
        }
        if (code < 16) {
          return 90 + (code - 8);
        }
        let red2;
        let green2;
        let blue2;
        if (code >= 232) {
          red2 = ((code - 232) * 10 + 8) / 255;
          green2 = red2;
          blue2 = red2;
        } else {
          code -= 16;
          const remainder = code % 36;
          red2 = Math.floor(code / 36) / 5;
          green2 = Math.floor(remainder / 6) / 5;
          blue2 = remainder % 6 / 5;
        }
        const value = Math.max(red2, green2, blue2) * 2;
        if (value === 0) {
          return 30;
        }
        let result2 = 30 + (Math.round(blue2) << 2 | Math.round(green2) << 1 | Math.round(red2));
        if (value === 2) {
          result2 += 60;
        }
        return result2;
      },
      enumerable: false
    },
    rgbToAnsi: {
      value: (red2, green2, blue2) => styles.ansi256ToAnsi(styles.rgbToAnsi256(red2, green2, blue2)),
      enumerable: false
    },
    hexToAnsi: {
      value: (hex) => styles.ansi256ToAnsi(styles.hexToAnsi256(hex)),
      enumerable: false
    }
  });
  return styles;
}
var ansiStyles = assembleStyles();
var ansi_styles_default = ansiStyles;
function hasFlag(flag, argv2 = globalThis.Deno ? globalThis.Deno.args : process11.argv) {
  const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
  const position = argv2.indexOf(prefix + flag);
  const terminatorPosition = argv2.indexOf("--");
  return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
}
var { env: env4 } = process11;
var flagForceColor;
if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false") || hasFlag("color=never")) {
  flagForceColor = 0;
} else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
  flagForceColor = 1;
}
function envForceColor() {
  if ("FORCE_COLOR" in env4) {
    if (env4.FORCE_COLOR === "true") {
      return 1;
    }
    if (env4.FORCE_COLOR === "false") {
      return 0;
    }
    return env4.FORCE_COLOR.length === 0 ? 1 : Math.min(Number.parseInt(env4.FORCE_COLOR, 10), 3);
  }
}
function translateLevel(level) {
  if (level === 0) {
    return false;
  }
  return {
    level,
    hasBasic: true,
    has256: level >= 2,
    has16m: level >= 3
  };
}
function _supportsColor(haveStream, { streamIsTTY, sniffFlags = true } = {}) {
  const noFlagForceColor = envForceColor();
  if (noFlagForceColor !== undefined) {
    flagForceColor = noFlagForceColor;
  }
  const forceColor = sniffFlags ? flagForceColor : noFlagForceColor;
  if (forceColor === 0) {
    return 0;
  }
  if (sniffFlags) {
    if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
      return 3;
    }
    if (hasFlag("color=256")) {
      return 2;
    }
  }
  if ("TF_BUILD" in env4 && "AGENT_NAME" in env4) {
    return 1;
  }
  if (haveStream && !streamIsTTY && forceColor === undefined) {
    return 0;
  }
  const min = forceColor || 0;
  if (env4.TERM === "dumb") {
    return min;
  }
  if (process11.platform === "win32") {
    const osRelease = os.release().split(".");
    if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
      return Number(osRelease[2]) >= 14931 ? 3 : 2;
    }
    return 1;
  }
  if ("CI" in env4) {
    if ("GITHUB_ACTIONS" in env4 || "GITEA_ACTIONS" in env4) {
      return 3;
    }
    if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI", "BUILDKITE", "DRONE"].some((sign) => (sign in env4)) || env4.CI_NAME === "codeship") {
      return 1;
    }
    return min;
  }
  if ("TEAMCITY_VERSION" in env4) {
    return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env4.TEAMCITY_VERSION) ? 1 : 0;
  }
  if (env4.COLORTERM === "truecolor") {
    return 3;
  }
  if (env4.TERM === "xterm-kitty") {
    return 3;
  }
  if ("TERM_PROGRAM" in env4) {
    const version2 = Number.parseInt((env4.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
    switch (env4.TERM_PROGRAM) {
      case "iTerm.app": {
        return version2 >= 3 ? 3 : 2;
      }
      case "Apple_Terminal": {
        return 2;
      }
    }
  }
  if (/-256(color)?$/i.test(env4.TERM)) {
    return 2;
  }
  if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env4.TERM)) {
    return 1;
  }
  if ("COLORTERM" in env4) {
    return 1;
  }
  return min;
}
function createSupportsColor(stream2, options22 = {}) {
  const level = _supportsColor(stream2, {
    streamIsTTY: stream2 && stream2.isTTY,
    ...options22
  });
  return translateLevel(level);
}
var supportsColor = {
  stdout: createSupportsColor({ isTTY: tty3.isatty(1) }),
  stderr: createSupportsColor({ isTTY: tty3.isatty(2) })
};
var supports_color_default = supportsColor;
function stringReplaceAll(string2, substring, replacer) {
  let index = string2.indexOf(substring);
  if (index === -1) {
    return string2;
  }
  const substringLength = substring.length;
  let endIndex = 0;
  let returnValue = "";
  do {
    returnValue += string2.slice(endIndex, index) + substring + replacer;
    endIndex = index + substringLength;
    index = string2.indexOf(substring, endIndex);
  } while (index !== -1);
  returnValue += string2.slice(endIndex);
  return returnValue;
}
function stringEncaseCRLFWithFirstIndex(string2, prefix, postfix, index) {
  let endIndex = 0;
  let returnValue = "";
  do {
    const gotCR = string2[index - 1] === "\r";
    returnValue += string2.slice(endIndex, gotCR ? index - 1 : index) + prefix + (gotCR ? "\r\n" : "\n") + postfix;
    endIndex = index + 1;
    index = string2.indexOf("\n", endIndex);
  } while (index !== -1);
  returnValue += string2.slice(endIndex);
  return returnValue;
}
var { stdout: stdoutColor, stderr: stderrColor } = supports_color_default;
var GENERATOR = Symbol("GENERATOR");
var STYLER = Symbol("STYLER");
var IS_EMPTY = Symbol("IS_EMPTY");
var levelMapping = [
  "ansi",
  "ansi",
  "ansi256",
  "ansi16m"
];
var styles2 = Object.create(null);
var applyOptions = (object, options22 = {}) => {
  if (options22.level && !(Number.isInteger(options22.level) && options22.level >= 0 && options22.level <= 3)) {
    throw new Error("The `level` option should be an integer from 0 to 3");
  }
  const colorLevel = stdoutColor ? stdoutColor.level : 0;
  object.level = options22.level === undefined ? colorLevel : options22.level;
};
var chalkFactory = (options22) => {
  const chalk = (...strings) => strings.join(" ");
  applyOptions(chalk, options22);
  Object.setPrototypeOf(chalk, createChalk.prototype);
  return chalk;
};
function createChalk(options22) {
  return chalkFactory(options22);
}
Object.setPrototypeOf(createChalk.prototype, Function.prototype);
for (const [styleName, style] of Object.entries(ansi_styles_default)) {
  styles2[styleName] = {
    get() {
      const builder = createBuilder(this, createStyler(style.open, style.close, this[STYLER]), this[IS_EMPTY]);
      Object.defineProperty(this, styleName, { value: builder });
      return builder;
    }
  };
}
styles2.visible = {
  get() {
    const builder = createBuilder(this, this[STYLER], true);
    Object.defineProperty(this, "visible", { value: builder });
    return builder;
  }
};
var getModelAnsi = (model2, level, type, ...arguments_) => {
  if (model2 === "rgb") {
    if (level === "ansi16m") {
      return ansi_styles_default[type].ansi16m(...arguments_);
    }
    if (level === "ansi256") {
      return ansi_styles_default[type].ansi256(ansi_styles_default.rgbToAnsi256(...arguments_));
    }
    return ansi_styles_default[type].ansi(ansi_styles_default.rgbToAnsi(...arguments_));
  }
  if (model2 === "hex") {
    return getModelAnsi("rgb", level, type, ...ansi_styles_default.hexToRgb(...arguments_));
  }
  return ansi_styles_default[type][model2](...arguments_);
};
var usedModels = ["rgb", "hex", "ansi256"];
for (const model2 of usedModels) {
  styles2[model2] = {
    get() {
      const { level } = this;
      return function(...arguments_) {
        const styler = createStyler(getModelAnsi(model2, levelMapping[level], "color", ...arguments_), ansi_styles_default.color.close, this[STYLER]);
        return createBuilder(this, styler, this[IS_EMPTY]);
      };
    }
  };
  const bgModel = "bg" + model2[0].toUpperCase() + model2.slice(1);
  styles2[bgModel] = {
    get() {
      const { level } = this;
      return function(...arguments_) {
        const styler = createStyler(getModelAnsi(model2, levelMapping[level], "bgColor", ...arguments_), ansi_styles_default.bgColor.close, this[STYLER]);
        return createBuilder(this, styler, this[IS_EMPTY]);
      };
    }
  };
}
var proto = Object.defineProperties(() => {
}, {
  ...styles2,
  level: {
    enumerable: true,
    get() {
      return this[GENERATOR].level;
    },
    set(level) {
      this[GENERATOR].level = level;
    }
  }
});
var createStyler = (open, close, parent) => {
  let openAll;
  let closeAll;
  if (parent === undefined) {
    openAll = open;
    closeAll = close;
  } else {
    openAll = parent.openAll + open;
    closeAll = close + parent.closeAll;
  }
  return {
    open,
    close,
    openAll,
    closeAll,
    parent
  };
};
var createBuilder = (self2, _styler, _isEmpty) => {
  const builder = (...arguments_) => applyStyle(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
  Object.setPrototypeOf(builder, proto);
  builder[GENERATOR] = self2;
  builder[STYLER] = _styler;
  builder[IS_EMPTY] = _isEmpty;
  return builder;
};
var applyStyle = (self2, string2) => {
  if (self2.level <= 0 || !string2) {
    return self2[IS_EMPTY] ? "" : string2;
  }
  let styler = self2[STYLER];
  if (styler === undefined) {
    return string2;
  }
  const { openAll, closeAll } = styler;
  if (string2.includes("\x1B")) {
    while (styler !== undefined) {
      string2 = stringReplaceAll(string2, styler.close, styler.open);
      styler = styler.parent;
    }
  }
  const lfIndex = string2.indexOf("\n");
  if (lfIndex !== -1) {
    string2 = stringEncaseCRLFWithFirstIndex(string2, closeAll, openAll, lfIndex);
  }
  return openAll + string2 + closeAll;
};
Object.defineProperties(createChalk.prototype, styles2);
var chalk = createChalk();
var chalkStderr = createChalk({ level: stderrColor ? stderrColor.level : 0 });
var source_default = chalk;
var copyProperty = (to, from, property, ignoreNonConfigurable) => {
  if (property === "length" || property === "prototype") {
    return;
  }
  if (property === "arguments" || property === "caller") {
    return;
  }
  const toDescriptor = Object.getOwnPropertyDescriptor(to, property);
  const fromDescriptor = Object.getOwnPropertyDescriptor(from, property);
  if (!canCopyProperty(toDescriptor, fromDescriptor) && ignoreNonConfigurable) {
    return;
  }
  Object.defineProperty(to, property, fromDescriptor);
};
var canCopyProperty = function(toDescriptor, fromDescriptor) {
  return toDescriptor === undefined || toDescriptor.configurable || toDescriptor.writable === fromDescriptor.writable && toDescriptor.enumerable === fromDescriptor.enumerable && toDescriptor.configurable === fromDescriptor.configurable && (toDescriptor.writable || toDescriptor.value === fromDescriptor.value);
};
var changePrototype = (to, from) => {
  const fromPrototype = Object.getPrototypeOf(from);
  if (fromPrototype === Object.getPrototypeOf(to)) {
    return;
  }
  Object.setPrototypeOf(to, fromPrototype);
};
var wrappedToString = (withName, fromBody) => `/* Wrapped ${withName}*/\n${fromBody}`;
var toStringDescriptor = Object.getOwnPropertyDescriptor(Function.prototype, "toString");
var toStringName = Object.getOwnPropertyDescriptor(Function.prototype.toString, "name");
var changeToString = (to, from, name) => {
  const withName = name === "" ? "" : `with ${name.trim()}() `;
  const newToString = wrappedToString.bind(null, withName, from.toString());
  Object.defineProperty(newToString, "name", toStringName);
  const { writable, enumerable, configurable } = toStringDescriptor;
  Object.defineProperty(to, "toString", { value: newToString, writable, enumerable, configurable });
};
function mimicFunction(to, from, { ignoreNonConfigurable = false } = {}) {
  const { name } = to;
  for (const property of Reflect.ownKeys(from)) {
    copyProperty(to, from, property, ignoreNonConfigurable);
  }
  changePrototype(to, from);
  changeToString(to, from, name);
  return to;
}
var calledFunctions = new WeakMap;
var onetime = (function_, options22 = {}) => {
  if (typeof function_ !== "function") {
    throw new TypeError("Expected a function");
  }
  let returnValue;
  let callCount = 0;
  const functionName = function_.displayName || function_.name || "<anonymous>";
  const onetime2 = function(...arguments_) {
    calledFunctions.set(onetime2, ++callCount);
    if (callCount === 1) {
      returnValue = function_.apply(this, arguments_);
      function_ = undefined;
    } else if (options22.throw === true) {
      throw new Error(`Function \`${functionName}\` can only be called once`);
    }
    return returnValue;
  };
  mimicFunction(onetime2, function_);
  calledFunctions.set(onetime2, callCount);
  return onetime2;
};
onetime.callCount = (function_) => {
  if (!calledFunctions.has(function_)) {
    throw new Error(`The given function \`${function_.name}\` is not wrapped by the \`onetime\` package`);
  }
  return calledFunctions.get(function_);
};
var onetime_default = onetime;
var signals = [];
signals.push("SIGHUP", "SIGINT", "SIGTERM");
if (process.platform !== "win32") {
  signals.push("SIGALRM", "SIGABRT", "SIGVTALRM", "SIGXCPU", "SIGXFSZ", "SIGUSR2", "SIGTRAP", "SIGSYS", "SIGQUIT", "SIGIOT");
}
if (process.platform === "linux") {
  signals.push("SIGIO", "SIGPOLL", "SIGPWR", "SIGSTKFLT");
}
var processOk = (process12) => !!process12 && typeof process12 === "object" && typeof process12.removeListener === "function" && typeof process12.emit === "function" && typeof process12.reallyExit === "function" && typeof process12.listeners === "function" && typeof process12.kill === "function" && typeof process12.pid === "number" && typeof process12.on === "function";
var kExitEmitter = Symbol.for("signal-exit emitter");
var global2 = globalThis;
var ObjectDefineProperty = Object.defineProperty.bind(Object);

class Emitter {
  emitted = {
    afterExit: false,
    exit: false
  };
  listeners = {
    afterExit: [],
    exit: []
  };
  count = 0;
  id = Math.random();
  constructor() {
    if (global2[kExitEmitter]) {
      return global2[kExitEmitter];
    }
    ObjectDefineProperty(global2, kExitEmitter, {
      value: this,
      writable: false,
      enumerable: false,
      configurable: false
    });
  }
  on(ev, fn) {
    this.listeners[ev].push(fn);
  }
  removeListener(ev, fn) {
    const list = this.listeners[ev];
    const i = list.indexOf(fn);
    if (i === -1) {
      return;
    }
    if (i === 0 && list.length === 1) {
      list.length = 0;
    } else {
      list.splice(i, 1);
    }
  }
  emit(ev, code, signal) {
    if (this.emitted[ev]) {
      return false;
    }
    this.emitted[ev] = true;
    let ret = false;
    for (const fn of this.listeners[ev]) {
      ret = fn(code, signal) === true || ret;
    }
    if (ev === "exit") {
      ret = this.emit("afterExit", code, signal) || ret;
    }
    return ret;
  }
}

class SignalExitBase {
}
var signalExitWrap = (handler3) => {
  return {
    onExit(cb, opts) {
      return handler3.onExit(cb, opts);
    },
    load() {
      return handler3.load();
    },
    unload() {
      return handler3.unload();
    }
  };
};

class SignalExitFallback extends SignalExitBase {
  onExit() {
    return () => {
    };
  }
  load() {
  }
  unload() {
  }
}

class SignalExit extends SignalExitBase {
  #hupSig = process12.platform === "win32" ? "SIGINT" : "SIGHUP";
  #emitter = new Emitter;
  #process;
  #originalProcessEmit;
  #originalProcessReallyExit;
  #sigListeners = {};
  #loaded = false;
  constructor(process12) {
    super();
    this.#process = process12;
    this.#sigListeners = {};
    for (const sig of signals) {
      this.#sigListeners[sig] = () => {
        const listeners = this.#process.listeners(sig);
        let { count } = this.#emitter;
        const p3 = process12;
        if (typeof p3.__signal_exit_emitter__ === "object" && typeof p3.__signal_exit_emitter__.count === "number") {
          count += p3.__signal_exit_emitter__.count;
        }
        if (listeners.length === count) {
          this.unload();
          const ret = this.#emitter.emit("exit", null, sig);
          const s3 = sig === "SIGHUP" ? this.#hupSig : sig;
          if (!ret)
            process12.kill(process12.pid, s3);
        }
      };
    }
    this.#originalProcessReallyExit = process12.reallyExit;
    this.#originalProcessEmit = process12.emit;
  }
  onExit(cb, opts) {
    if (!processOk(this.#process)) {
      return () => {
      };
    }
    if (this.#loaded === false) {
      this.load();
    }
    const ev = opts?.alwaysLast ? "afterExit" : "exit";
    this.#emitter.on(ev, cb);
    return () => {
      this.#emitter.removeListener(ev, cb);
      if (this.#emitter.listeners["exit"].length === 0 && this.#emitter.listeners["afterExit"].length === 0) {
        this.unload();
      }
    };
  }
  load() {
    if (this.#loaded) {
      return;
    }
    this.#loaded = true;
    this.#emitter.count += 1;
    for (const sig of signals) {
      try {
        const fn = this.#sigListeners[sig];
        if (fn)
          this.#process.on(sig, fn);
      } catch (_2) {
      }
    }
    this.#process.emit = (ev, ...a) => {
      return this.#processEmit(ev, ...a);
    };
    this.#process.reallyExit = (code) => {
      return this.#processReallyExit(code);
    };
  }
  unload() {
    if (!this.#loaded) {
      return;
    }
    this.#loaded = false;
    signals.forEach((sig) => {
      const listener = this.#sigListeners[sig];
      if (!listener) {
        throw new Error("Listener not defined for signal: " + sig);
      }
      try {
        this.#process.removeListener(sig, listener);
      } catch (_2) {
      }
    });
    this.#process.emit = this.#originalProcessEmit;
    this.#process.reallyExit = this.#originalProcessReallyExit;
    this.#emitter.count -= 1;
  }
  #processReallyExit(code) {
    if (!processOk(this.#process)) {
      return 0;
    }
    this.#process.exitCode = code || 0;
    this.#emitter.emit("exit", this.#process.exitCode, null);
    return this.#originalProcessReallyExit.call(this.#process, this.#process.exitCode);
  }
  #processEmit(ev, ...args) {
    const og = this.#originalProcessEmit;
    if (ev === "exit" && processOk(this.#process)) {
      if (typeof args[0] === "number") {
        this.#process.exitCode = args[0];
      }
      const ret = og.call(this.#process, ev, ...args);
      this.#emitter.emit("exit", this.#process.exitCode, null);
      return ret;
    } else {
      return og.call(this.#process, ev, ...args);
    }
  }
}
var process12 = globalThis.process;
var {
  onExit,
  load,
  unload
} = signalExitWrap(processOk(process12) ? new SignalExit(process12) : new SignalExitFallback);
var terminal = process13.stderr.isTTY ? process13.stderr : process13.stdout.isTTY ? process13.stdout : undefined;
var restoreCursor = terminal ? onetime_default(() => {
  onExit(() => {
    terminal.write("\x1B[?25h");
  }, { alwaysLast: true });
}) : () => {
};
var restore_cursor_default = restoreCursor;
var isHidden = false;
var cliCursor = {};
cliCursor.show = (writableStream = process14.stderr) => {
  if (!writableStream.isTTY) {
    return;
  }
  isHidden = false;
  writableStream.write("\x1B[?25h");
};
cliCursor.hide = (writableStream = process14.stderr) => {
  if (!writableStream.isTTY) {
    return;
  }
  restore_cursor_default();
  isHidden = true;
  writableStream.write("\x1B[?25l");
};
cliCursor.toggle = (force, writableStream) => {
  if (force !== undefined) {
    isHidden = force;
  }
  if (isHidden) {
    cliCursor.show(writableStream);
  } else {
    cliCursor.hide(writableStream);
  }
};
var cli_cursor_default = cliCursor;
var import_cli_spinners = __toESM2(require_cli_spinners(), 1);
function isUnicodeSupported2() {
  if (process15.platform !== "win32") {
    return process15.env.TERM !== "linux";
  }
  return Boolean(process15.env.CI) || Boolean(process15.env.WT_SESSION) || Boolean(process15.env.TERMINUS_SUBLIME) || process15.env.ConEmuTask === "{cmd::Cmder}" || process15.env.TERM_PROGRAM === "Terminus-Sublime" || process15.env.TERM_PROGRAM === "vscode" || process15.env.TERM === "xterm-256color" || process15.env.TERM === "alacritty" || process15.env.TERMINAL_EMULATOR === "JetBrains-JediTerm";
}
var main = {
  info: source_default.blue("\u2139"),
  success: source_default.green("\u2714"),
  warning: source_default.yellow("\u26A0"),
  error: source_default.red("\u2716")
};
var fallback2 = {
  info: source_default.blue("i"),
  success: source_default.green("\u221A"),
  warning: source_default.yellow("\u203C"),
  error: source_default.red("\xD7")
};
var logSymbols = isUnicodeSupported2() ? main : fallback2;
var log_symbols_default = logSymbols;
function ansiRegex3({ onlyFirst = false } = {}) {
  const ST = "(?:\\u0007|\\u001B\\u005C|\\u009C)";
  const pattern = [
    `[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?${ST})`,
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))"
  ].join("|");
  return new RegExp(pattern, onlyFirst ? undefined : "g");
}
var regex2 = ansiRegex3();
function stripAnsi3(string2) {
  if (typeof string2 !== "string") {
    throw new TypeError(`Expected a \`string\`, got \`${typeof string2}\``);
  }
  return string2.replace(regex2, "");
}
function isAmbiguous(x2) {
  return x2 === 161 || x2 === 164 || x2 === 167 || x2 === 168 || x2 === 170 || x2 === 173 || x2 === 174 || x2 >= 176 && x2 <= 180 || x2 >= 182 && x2 <= 186 || x2 >= 188 && x2 <= 191 || x2 === 198 || x2 === 208 || x2 === 215 || x2 === 216 || x2 >= 222 && x2 <= 225 || x2 === 230 || x2 >= 232 && x2 <= 234 || x2 === 236 || x2 === 237 || x2 === 240 || x2 === 242 || x2 === 243 || x2 >= 247 && x2 <= 250 || x2 === 252 || x2 === 254 || x2 === 257 || x2 === 273 || x2 === 275 || x2 === 283 || x2 === 294 || x2 === 295 || x2 === 299 || x2 >= 305 && x2 <= 307 || x2 === 312 || x2 >= 319 && x2 <= 322 || x2 === 324 || x2 >= 328 && x2 <= 331 || x2 === 333 || x2 === 338 || x2 === 339 || x2 === 358 || x2 === 359 || x2 === 363 || x2 === 462 || x2 === 464 || x2 === 466 || x2 === 468 || x2 === 470 || x2 === 472 || x2 === 474 || x2 === 476 || x2 === 593 || x2 === 609 || x2 === 708 || x2 === 711 || x2 >= 713 && x2 <= 715 || x2 === 717 || x2 === 720 || x2 >= 728 && x2 <= 731 || x2 === 733 || x2 === 735 || x2 >= 768 && x2 <= 879 || x2 >= 913 && x2 <= 929 || x2 >= 931 && x2 <= 937 || x2 >= 945 && x2 <= 961 || x2 >= 963 && x2 <= 969 || x2 === 1025 || x2 >= 1040 && x2 <= 1103 || x2 === 1105 || x2 === 8208 || x2 >= 8211 && x2 <= 8214 || x2 === 8216 || x2 === 8217 || x2 === 8220 || x2 === 8221 || x2 >= 8224 && x2 <= 8226 || x2 >= 8228 && x2 <= 8231 || x2 === 8240 || x2 === 8242 || x2 === 8243 || x2 === 8245 || x2 === 8251 || x2 === 8254 || x2 === 8308 || x2 === 8319 || x2 >= 8321 && x2 <= 8324 || x2 === 8364 || x2 === 8451 || x2 === 8453 || x2 === 8457 || x2 === 8467 || x2 === 8470 || x2 === 8481 || x2 === 8482 || x2 === 8486 || x2 === 8491 || x2 === 8531 || x2 === 8532 || x2 >= 8539 && x2 <= 8542 || x2 >= 8544 && x2 <= 8555 || x2 >= 8560 && x2 <= 8569 || x2 === 8585 || x2 >= 8592 && x2 <= 8601 || x2 === 8632 || x2 === 8633 || x2 === 8658 || x2 === 8660 || x2 === 8679 || x2 === 8704 || x2 === 8706 || x2 === 8707 || x2 === 8711 || x2 === 8712 || x2 === 8715 || x2 === 8719 || x2 === 8721 || x2 === 8725 || x2 === 8730 || x2 >= 8733 && x2 <= 8736 || x2 === 8739 || x2 === 8741 || x2 >= 8743 && x2 <= 8748 || x2 === 8750 || x2 >= 8756 && x2 <= 8759 || x2 === 8764 || x2 === 8765 || x2 === 8776 || x2 === 8780 || x2 === 8786 || x2 === 8800 || x2 === 8801 || x2 >= 8804 && x2 <= 8807 || x2 === 8810 || x2 === 8811 || x2 === 8814 || x2 === 8815 || x2 === 8834 || x2 === 8835 || x2 === 8838 || x2 === 8839 || x2 === 8853 || x2 === 8857 || x2 === 8869 || x2 === 8895 || x2 === 8978 || x2 >= 9312 && x2 <= 9449 || x2 >= 9451 && x2 <= 9547 || x2 >= 9552 && x2 <= 9587 || x2 >= 9600 && x2 <= 9615 || x2 >= 9618 && x2 <= 9621 || x2 === 9632 || x2 === 9633 || x2 >= 9635 && x2 <= 9641 || x2 === 9650 || x2 === 9651 || x2 === 9654 || x2 === 9655 || x2 === 9660 || x2 === 9661 || x2 === 9664 || x2 === 9665 || x2 >= 9670 && x2 <= 9672 || x2 === 9675 || x2 >= 9678 && x2 <= 9681 || x2 >= 9698 && x2 <= 9701 || x2 === 9711 || x2 === 9733 || x2 === 9734 || x2 === 9737 || x2 === 9742 || x2 === 9743 || x2 === 9756 || x2 === 9758 || x2 === 9792 || x2 === 9794 || x2 === 9824 || x2 === 9825 || x2 >= 9827 && x2 <= 9829 || x2 >= 9831 && x2 <= 9834 || x2 === 9836 || x2 === 9837 || x2 === 9839 || x2 === 9886 || x2 === 9887 || x2 === 9919 || x2 >= 9926 && x2 <= 9933 || x2 >= 9935 && x2 <= 9939 || x2 >= 9941 && x2 <= 9953 || x2 === 9955 || x2 === 9960 || x2 === 9961 || x2 >= 9963 && x2 <= 9969 || x2 === 9972 || x2 >= 9974 && x2 <= 9977 || x2 === 9979 || x2 === 9980 || x2 === 9982 || x2 === 9983 || x2 === 10045 || x2 >= 10102 && x2 <= 10111 || x2 >= 11094 && x2 <= 11097 || x2 >= 12872 && x2 <= 12879 || x2 >= 57344 && x2 <= 63743 || x2 >= 65024 && x2 <= 65039 || x2 === 65533 || x2 >= 127232 && x2 <= 127242 || x2 >= 127248 && x2 <= 127277 || x2 >= 127280 && x2 <= 127337 || x2 >= 127344 && x2 <= 127373 || x2 === 127375 || x2 === 127376 || x2 >= 127387 && x2 <= 127404 || x2 >= 917760 && x2 <= 917999 || x2 >= 983040 && x2 <= 1048573 || x2 >= 1048576 && x2 <= 1114109;
}
function isFullWidth(x2) {
  return x2 === 12288 || x2 >= 65281 && x2 <= 65376 || x2 >= 65504 && x2 <= 65510;
}
function isWide(x2) {
  return x2 >= 4352 && x2 <= 4447 || x2 === 8986 || x2 === 8987 || x2 === 9001 || x2 === 9002 || x2 >= 9193 && x2 <= 9196 || x2 === 9200 || x2 === 9203 || x2 === 9725 || x2 === 9726 || x2 === 9748 || x2 === 9749 || x2 >= 9776 && x2 <= 9783 || x2 >= 9800 && x2 <= 9811 || x2 === 9855 || x2 >= 9866 && x2 <= 9871 || x2 === 9875 || x2 === 9889 || x2 === 9898 || x2 === 9899 || x2 === 9917 || x2 === 9918 || x2 === 9924 || x2 === 9925 || x2 === 9934 || x2 === 9940 || x2 === 9962 || x2 === 9970 || x2 === 9971 || x2 === 9973 || x2 === 9978 || x2 === 9981 || x2 === 9989 || x2 === 9994 || x2 === 9995 || x2 === 10024 || x2 === 10060 || x2 === 10062 || x2 >= 10067 && x2 <= 10069 || x2 === 10071 || x2 >= 10133 && x2 <= 10135 || x2 === 10160 || x2 === 10175 || x2 === 11035 || x2 === 11036 || x2 === 11088 || x2 === 11093 || x2 >= 11904 && x2 <= 11929 || x2 >= 11931 && x2 <= 12019 || x2 >= 12032 && x2 <= 12245 || x2 >= 12272 && x2 <= 12287 || x2 >= 12289 && x2 <= 12350 || x2 >= 12353 && x2 <= 12438 || x2 >= 12441 && x2 <= 12543 || x2 >= 12549 && x2 <= 12591 || x2 >= 12593 && x2 <= 12686 || x2 >= 12688 && x2 <= 12773 || x2 >= 12783 && x2 <= 12830 || x2 >= 12832 && x2 <= 12871 || x2 >= 12880 && x2 <= 42124 || x2 >= 42128 && x2 <= 42182 || x2 >= 43360 && x2 <= 43388 || x2 >= 44032 && x2 <= 55203 || x2 >= 63744 && x2 <= 64255 || x2 >= 65040 && x2 <= 65049 || x2 >= 65072 && x2 <= 65106 || x2 >= 65108 && x2 <= 65126 || x2 >= 65128 && x2 <= 65131 || x2 >= 94176 && x2 <= 94180 || x2 === 94192 || x2 === 94193 || x2 >= 94208 && x2 <= 100343 || x2 >= 100352 && x2 <= 101589 || x2 >= 101631 && x2 <= 101640 || x2 >= 110576 && x2 <= 110579 || x2 >= 110581 && x2 <= 110587 || x2 === 110589 || x2 === 110590 || x2 >= 110592 && x2 <= 110882 || x2 === 110898 || x2 >= 110928 && x2 <= 110930 || x2 === 110933 || x2 >= 110948 && x2 <= 110951 || x2 >= 110960 && x2 <= 111355 || x2 >= 119552 && x2 <= 119638 || x2 >= 119648 && x2 <= 119670 || x2 === 126980 || x2 === 127183 || x2 === 127374 || x2 >= 127377 && x2 <= 127386 || x2 >= 127488 && x2 <= 127490 || x2 >= 127504 && x2 <= 127547 || x2 >= 127552 && x2 <= 127560 || x2 === 127568 || x2 === 127569 || x2 >= 127584 && x2 <= 127589 || x2 >= 127744 && x2 <= 127776 || x2 >= 127789 && x2 <= 127797 || x2 >= 127799 && x2 <= 127868 || x2 >= 127870 && x2 <= 127891 || x2 >= 127904 && x2 <= 127946 || x2 >= 127951 && x2 <= 127955 || x2 >= 127968 && x2 <= 127984 || x2 === 127988 || x2 >= 127992 && x2 <= 128062 || x2 === 128064 || x2 >= 128066 && x2 <= 128252 || x2 >= 128255 && x2 <= 128317 || x2 >= 128331 && x2 <= 128334 || x2 >= 128336 && x2 <= 128359 || x2 === 128378 || x2 === 128405 || x2 === 128406 || x2 === 128420 || x2 >= 128507 && x2 <= 128591 || x2 >= 128640 && x2 <= 128709 || x2 === 128716 || x2 >= 128720 && x2 <= 128722 || x2 >= 128725 && x2 <= 128727 || x2 >= 128732 && x2 <= 128735 || x2 === 128747 || x2 === 128748 || x2 >= 128756 && x2 <= 128764 || x2 >= 128992 && x2 <= 129003 || x2 === 129008 || x2 >= 129292 && x2 <= 129338 || x2 >= 129340 && x2 <= 129349 || x2 >= 129351 && x2 <= 129535 || x2 >= 129648 && x2 <= 129660 || x2 >= 129664 && x2 <= 129673 || x2 >= 129679 && x2 <= 129734 || x2 >= 129742 && x2 <= 129756 || x2 >= 129759 && x2 <= 129769 || x2 >= 129776 && x2 <= 129784 || x2 >= 131072 && x2 <= 196605 || x2 >= 196608 && x2 <= 262141;
}
function validate(codePoint) {
  if (!Number.isSafeInteger(codePoint)) {
    throw new TypeError(`Expected a code point, got \`${typeof codePoint}\`.`);
  }
}
function eastAsianWidth2(codePoint, { ambiguousAsWide = false } = {}) {
  validate(codePoint);
  if (isFullWidth(codePoint) || isWide(codePoint) || ambiguousAsWide && isAmbiguous(codePoint)) {
    return 2;
  }
  return 1;
}
var emoji_regex_default = () => {
  return /[#*0-9]\uFE0F?\u20E3|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26AA\u26B0\u26B1\u26BD\u26BE\u26C4\u26C8\u26CF\u26D1\u26E9\u26F0-\u26F5\u26F7\u26F8\u26FA\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2757\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B55\u3030\u303D\u3297\u3299]\uFE0F?|[\u261D\u270C\u270D](?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?|[\u270A\u270B](?:\uD83C[\uDFFB-\uDFFF])?|[\u23E9-\u23EC\u23F0\u23F3\u25FD\u2693\u26A1\u26AB\u26C5\u26CE\u26D4\u26EA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2795-\u2797\u27B0\u27BF\u2B50]|\u26D3\uFE0F?(?:\u200D\uD83D\uDCA5)?|\u26F9(?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?(?:\u200D[\u2640\u2642]\uFE0F?)?|\u2764\uFE0F?(?:\u200D(?:\uD83D\uDD25|\uD83E\uDE79))?|\uD83C(?:[\uDC04\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]\uFE0F?|[\uDF85\uDFC2\uDFC7](?:\uD83C[\uDFFB-\uDFFF])?|[\uDFC4\uDFCA](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDFCB\uDFCC](?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF43\uDF45-\uDF4A\uDF4C-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uDDE6\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF]|\uDDE7\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF]|\uDDE8\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF7\uDDFA-\uDDFF]|\uDDE9\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF]|\uDDEA\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA]|\uDDEB\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7]|\uDDEC\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE]|\uDDED\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA]|\uDDEE\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9]|\uDDEF\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5]|\uDDF0\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF]|\uDDF1\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE]|\uDDF2\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF]|\uDDF3\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF]|\uDDF4\uD83C\uDDF2|\uDDF5\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE]|\uDDF6\uD83C\uDDE6|\uDDF7\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC]|\uDDF8\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF]|\uDDF9\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF]|\uDDFA\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF]|\uDDFB\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA]|\uDDFC\uD83C[\uDDEB\uDDF8]|\uDDFD\uD83C\uDDF0|\uDDFE\uD83C[\uDDEA\uDDF9]|\uDDFF\uD83C[\uDDE6\uDDF2\uDDFC]|\uDF44(?:\u200D\uD83D\uDFEB)?|\uDF4B(?:\u200D\uD83D\uDFE9)?|\uDFC3(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?|\uDFF3\uFE0F?(?:\u200D(?:\u26A7\uFE0F?|\uD83C\uDF08))?|\uDFF4(?:\u200D\u2620\uFE0F?|\uDB40\uDC67\uDB40\uDC62\uDB40(?:\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDC73\uDB40\uDC63\uDB40\uDC74|\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F)?)|\uD83D(?:[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3]\uFE0F?|[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC](?:\uD83C[\uDFFB-\uDFFF])?|[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4\uDEB5](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD74\uDD90](?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?|[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC25\uDC27-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE41\uDE43\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEDC-\uDEDF\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB\uDFF0]|\uDC08(?:\u200D\u2B1B)?|\uDC15(?:\u200D\uD83E\uDDBA)?|\uDC26(?:\u200D(?:\u2B1B|\uD83D\uDD25))?|\uDC3B(?:\u200D\u2744\uFE0F?)?|\uDC41\uFE0F?(?:\u200D\uD83D\uDDE8\uFE0F?)?|\uDC68(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDC68\uDC69]\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFE])))?))?|\uDC69(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?[\uDC68\uDC69]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?|\uDC69\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?))|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFE])))?))?|\uDC6F(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDD75(?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDE2E(?:\u200D\uD83D\uDCA8)?|\uDE35(?:\u200D\uD83D\uDCAB)?|\uDE36(?:\u200D\uD83C\uDF2B\uFE0F?)?|\uDE42(?:\u200D[\u2194\u2195]\uFE0F?)?|\uDEB6(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?)|\uD83E(?:[\uDD0C\uDD0F\uDD18-\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5\uDEC3-\uDEC5\uDEF0\uDEF2-\uDEF8](?:\uD83C[\uDFFB-\uDFFF])?|[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD\uDDCF\uDDD4\uDDD6-\uDDDD](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDDDE\uDDDF](?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD0D\uDD0E\uDD10-\uDD17\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCC\uDDD0\uDDE0-\uDDFF\uDE70-\uDE7C\uDE80-\uDE89\uDE8F-\uDEC2\uDEC6\uDECE-\uDEDC\uDEDF-\uDEE9]|\uDD3C(?:\u200D[\u2640\u2642]\uFE0F?|\uD83C[\uDFFB-\uDFFF])?|\uDDCE(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?|\uDDD1(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1|\uDDD1\u200D\uD83E\uDDD2(?:\u200D\uD83E\uDDD2)?|\uDDD2(?:\u200D\uD83E\uDDD2)?))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFC-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFD-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFD\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFE]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?))?|\uDEF1(?:\uD83C(?:\uDFFB(?:\u200D\uD83E\uDEF2\uD83C[\uDFFC-\uDFFF])?|\uDFFC(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFD-\uDFFF])?|\uDFFD(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])?|\uDFFE(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFD\uDFFF])?|\uDFFF(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFE])?))?)/g;
};
var segmenter = new Intl.Segmenter;
var defaultIgnorableCodePointRegex = /^\p{Default_Ignorable_Code_Point}$/u;
function stringWidth2(string2, options22 = {}) {
  if (typeof string2 !== "string" || string2.length === 0) {
    return 0;
  }
  const {
    ambiguousIsNarrow = true,
    countAnsiEscapeCodes = false
  } = options22;
  if (!countAnsiEscapeCodes) {
    string2 = stripAnsi3(string2);
  }
  if (string2.length === 0) {
    return 0;
  }
  let width = 0;
  const eastAsianWidthOptions = { ambiguousAsWide: !ambiguousIsNarrow };
  for (const { segment: character } of segmenter.segment(string2)) {
    const codePoint = character.codePointAt(0);
    if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
      continue;
    }
    if (codePoint >= 8203 && codePoint <= 8207 || codePoint === 65279) {
      continue;
    }
    if (codePoint >= 768 && codePoint <= 879 || codePoint >= 6832 && codePoint <= 6911 || codePoint >= 7616 && codePoint <= 7679 || codePoint >= 8400 && codePoint <= 8447 || codePoint >= 65056 && codePoint <= 65071) {
      continue;
    }
    if (codePoint >= 55296 && codePoint <= 57343) {
      continue;
    }
    if (codePoint >= 65024 && codePoint <= 65039) {
      continue;
    }
    if (defaultIgnorableCodePointRegex.test(character)) {
      continue;
    }
    if (emoji_regex_default().test(character)) {
      width += 2;
      continue;
    }
    width += eastAsianWidth2(codePoint, eastAsianWidthOptions);
  }
  return width;
}
function isInteractive({ stream: stream2 = process.stdout } = {}) {
  return Boolean(stream2 && stream2.isTTY && true && !("CI" in process.env));
}
function isUnicodeSupported3() {
  const { env: env5 } = process16;
  const { TERM, TERM_PROGRAM } = env5;
  if (process16.platform !== "win32") {
    return TERM !== "linux";
  }
  return Boolean(env5.WT_SESSION) || Boolean(env5.TERMINUS_SUBLIME) || env5.ConEmuTask === "{cmd::Cmder}" || TERM_PROGRAM === "Terminus-Sublime" || TERM_PROGRAM === "vscode" || TERM === "xterm-256color" || TERM === "alacritty" || TERM === "rxvt-unicode" || TERM === "rxvt-unicode-256color" || env5.TERMINAL_EMULATOR === "JetBrains-JediTerm";
}
var ASCII_ETX_CODE = 3;

class StdinDiscarder {
  #activeCount = 0;
  start() {
    this.#activeCount++;
    if (this.#activeCount === 1) {
      this.#realStart();
    }
  }
  stop() {
    if (this.#activeCount <= 0) {
      throw new Error("`stop` called more times than `start`");
    }
    this.#activeCount--;
    if (this.#activeCount === 0) {
      this.#realStop();
    }
  }
  #realStart() {
    if (process17.platform === "win32" || !process17.stdin.isTTY) {
      return;
    }
    process17.stdin.setRawMode(true);
    process17.stdin.on("data", this.#handleInput);
    process17.stdin.resume();
  }
  #realStop() {
    if (!process17.stdin.isTTY) {
      return;
    }
    process17.stdin.off("data", this.#handleInput);
    process17.stdin.pause();
    process17.stdin.setRawMode(false);
  }
  #handleInput(chunk) {
    if (chunk[0] === ASCII_ETX_CODE) {
      process17.emit("SIGINT");
    }
  }
}
var stdinDiscarder = new StdinDiscarder;
var stdin_discarder_default = stdinDiscarder;
var import_cli_spinners2 = __toESM2(require_cli_spinners(), 1);

class Ora {
  #linesToClear = 0;
  #isDiscardingStdin = false;
  #lineCount = 0;
  #frameIndex = 0;
  #options;
  #spinner;
  #stream;
  #id;
  #initialInterval;
  #isEnabled;
  #isSilent;
  #indent;
  #text;
  #prefixText;
  #suffixText;
  color;
  constructor(options22) {
    if (typeof options22 === "string") {
      options22 = {
        text: options22
      };
    }
    this.#options = {
      color: "cyan",
      stream: process18.stderr,
      discardStdin: true,
      hideCursor: true,
      ...options22
    };
    this.color = this.#options.color;
    this.spinner = this.#options.spinner;
    this.#initialInterval = this.#options.interval;
    this.#stream = this.#options.stream;
    this.#isEnabled = typeof this.#options.isEnabled === "boolean" ? this.#options.isEnabled : isInteractive({ stream: this.#stream });
    this.#isSilent = typeof this.#options.isSilent === "boolean" ? this.#options.isSilent : false;
    this.text = this.#options.text;
    this.prefixText = this.#options.prefixText;
    this.suffixText = this.#options.suffixText;
    this.indent = this.#options.indent;
    if (process18.env.NODE_ENV === "test") {
      this._stream = this.#stream;
      this._isEnabled = this.#isEnabled;
      Object.defineProperty(this, "_linesToClear", {
        get() {
          return this.#linesToClear;
        },
        set(newValue) {
          this.#linesToClear = newValue;
        }
      });
      Object.defineProperty(this, "_frameIndex", {
        get() {
          return this.#frameIndex;
        }
      });
      Object.defineProperty(this, "_lineCount", {
        get() {
          return this.#lineCount;
        }
      });
    }
  }
  get indent() {
    return this.#indent;
  }
  set indent(indent = 0) {
    if (!(indent >= 0 && Number.isInteger(indent))) {
      throw new Error("The `indent` option must be an integer from 0 and up");
    }
    this.#indent = indent;
    this.#updateLineCount();
  }
  get interval() {
    return this.#initialInterval ?? this.#spinner.interval ?? 100;
  }
  get spinner() {
    return this.#spinner;
  }
  set spinner(spinner) {
    this.#frameIndex = 0;
    this.#initialInterval = undefined;
    if (typeof spinner === "object") {
      if (spinner.frames === undefined) {
        throw new Error("The given spinner must have a `frames` property");
      }
      this.#spinner = spinner;
    } else if (!isUnicodeSupported3()) {
      this.#spinner = import_cli_spinners.default.line;
    } else if (spinner === undefined) {
      this.#spinner = import_cli_spinners.default.dots;
    } else if (spinner !== "default" && import_cli_spinners.default[spinner]) {
      this.#spinner = import_cli_spinners.default[spinner];
    } else {
      throw new Error(`There is no built-in spinner named '${spinner}'. See https://github.com/sindresorhus/cli-spinners/blob/main/spinners.json for a full list.`);
    }
  }
  get text() {
    return this.#text;
  }
  set text(value = "") {
    this.#text = value;
    this.#updateLineCount();
  }
  get prefixText() {
    return this.#prefixText;
  }
  set prefixText(value = "") {
    this.#prefixText = value;
    this.#updateLineCount();
  }
  get suffixText() {
    return this.#suffixText;
  }
  set suffixText(value = "") {
    this.#suffixText = value;
    this.#updateLineCount();
  }
  get isSpinning() {
    return this.#id !== undefined;
  }
  #getFullPrefixText(prefixText = this.#prefixText, postfix = " ") {
    if (typeof prefixText === "string" && prefixText !== "") {
      return prefixText + postfix;
    }
    if (typeof prefixText === "function") {
      return prefixText() + postfix;
    }
    return "";
  }
  #getFullSuffixText(suffixText = this.#suffixText, prefix = " ") {
    if (typeof suffixText === "string" && suffixText !== "") {
      return prefix + suffixText;
    }
    if (typeof suffixText === "function") {
      return prefix + suffixText();
    }
    return "";
  }
  #updateLineCount() {
    const columns = this.#stream.columns ?? 80;
    const fullPrefixText = this.#getFullPrefixText(this.#prefixText, "-");
    const fullSuffixText = this.#getFullSuffixText(this.#suffixText, "-");
    const fullText = " ".repeat(this.#indent) + fullPrefixText + "--" + this.#text + "--" + fullSuffixText;
    this.#lineCount = 0;
    for (const line of stripAnsi3(fullText).split("\n")) {
      this.#lineCount += Math.max(1, Math.ceil(stringWidth2(line, { countAnsiEscapeCodes: true }) / columns));
    }
  }
  get isEnabled() {
    return this.#isEnabled && !this.#isSilent;
  }
  set isEnabled(value) {
    if (typeof value !== "boolean") {
      throw new TypeError("The `isEnabled` option must be a boolean");
    }
    this.#isEnabled = value;
  }
  get isSilent() {
    return this.#isSilent;
  }
  set isSilent(value) {
    if (typeof value !== "boolean") {
      throw new TypeError("The `isSilent` option must be a boolean");
    }
    this.#isSilent = value;
  }
  frame() {
    const { frames } = this.#spinner;
    let frame = frames[this.#frameIndex];
    if (this.color) {
      frame = source_default[this.color](frame);
    }
    this.#frameIndex = ++this.#frameIndex % frames.length;
    const fullPrefixText = typeof this.#prefixText === "string" && this.#prefixText !== "" ? this.#prefixText + " " : "";
    const fullText = typeof this.text === "string" ? " " + this.text : "";
    const fullSuffixText = typeof this.#suffixText === "string" && this.#suffixText !== "" ? " " + this.#suffixText : "";
    return fullPrefixText + frame + fullText + fullSuffixText;
  }
  clear() {
    if (!this.#isEnabled || !this.#stream.isTTY) {
      return this;
    }
    this.#stream.cursorTo(0);
    for (let index = 0;index < this.#linesToClear; index++) {
      if (index > 0) {
        this.#stream.moveCursor(0, -1);
      }
      this.#stream.clearLine(1);
    }
    if (this.#indent || this.lastIndent !== this.#indent) {
      this.#stream.cursorTo(this.#indent);
    }
    this.lastIndent = this.#indent;
    this.#linesToClear = 0;
    return this;
  }
  render() {
    if (this.#isSilent) {
      return this;
    }
    this.clear();
    this.#stream.write(this.frame());
    this.#linesToClear = this.#lineCount;
    return this;
  }
  start(text2) {
    if (text2) {
      this.text = text2;
    }
    if (this.#isSilent) {
      return this;
    }
    if (!this.#isEnabled) {
      if (this.text) {
        this.#stream.write(`- ${this.text}\n`);
      }
      return this;
    }
    if (this.isSpinning) {
      return this;
    }
    if (this.#options.hideCursor) {
      cli_cursor_default.hide(this.#stream);
    }
    if (this.#options.discardStdin && process18.stdin.isTTY) {
      this.#isDiscardingStdin = true;
      stdin_discarder_default.start();
    }
    this.render();
    this.#id = setInterval(this.render.bind(this), this.interval);
    return this;
  }
  stop() {
    if (!this.#isEnabled) {
      return this;
    }
    clearInterval(this.#id);
    this.#id = undefined;
    this.#frameIndex = 0;
    this.clear();
    if (this.#options.hideCursor) {
      cli_cursor_default.show(this.#stream);
    }
    if (this.#options.discardStdin && process18.stdin.isTTY && this.#isDiscardingStdin) {
      stdin_discarder_default.stop();
      this.#isDiscardingStdin = false;
    }
    return this;
  }
  succeed(text2) {
    return this.stopAndPersist({ symbol: log_symbols_default.success, text: text2 });
  }
  fail(text2) {
    return this.stopAndPersist({ symbol: log_symbols_default.error, text: text2 });
  }
  warn(text2) {
    return this.stopAndPersist({ symbol: log_symbols_default.warning, text: text2 });
  }
  info(text2) {
    return this.stopAndPersist({ symbol: log_symbols_default.info, text: text2 });
  }
  stopAndPersist(options22 = {}) {
    if (this.#isSilent) {
      return this;
    }
    const prefixText = options22.prefixText ?? this.#prefixText;
    const fullPrefixText = this.#getFullPrefixText(prefixText, " ");
    const symbolText = options22.symbol ?? " ";
    const text2 = options22.text ?? this.text;
    const fullText = typeof text2 === "string" ? " " + text2 : "";
    const suffixText = options22.suffixText ?? this.#suffixText;
    const fullSuffixText = this.#getFullSuffixText(suffixText, " ");
    const textToWrite = fullPrefixText + symbolText + fullText + fullSuffixText + "\n";
    this.stop();
    this.#stream.write(textToWrite);
    return this;
  }
}
function clone(items) {
  if (Array.isArray(items)) {
    return [...items];
  }
  return { ...items };
}
function variadic(args) {
  if (Array.isArray(args)) {
    return args;
  }
  return [args];
}
function deleteKeys(obj, ...keys) {
  variadic(keys).forEach((key) => {
    delete obj[key];
  });
}
var isArray = (item) => Array.isArray(item);
function isObject2(item) {
  return typeof item === "object" && !Array.isArray(item) && item !== null;
}
var isFunction = (item) => typeof item === "function";
function nestedValue(mainObject, key) {
  try {
    return key.split(".").reduce((obj, property) => obj[property], mainObject);
  } catch (err2) {
    return mainObject;
  }
}
function values(items) {
  if (Array.isArray(items)) {
    return [...items];
  }
  if ("all" in items && typeof items.all === "function") {
    return items.all();
  }
  return Object.values(items);
}
function collect(items) {
  return new Collection(items);
}

class Collection {
  items;
  constructor(items = []) {
    this.items = items;
  }
  [Symbol.iterator] = SymbolIterator;
  toJSON() {
    return this.items;
  }
  all() {
    return this.items;
  }
  average(key) {
    if (key === undefined) {
      return this.sum() / Number(this.items.length);
    }
    if (isFunction(key)) {
      return Number(new this.constructor(this.items).sum(key)) / Number(this.items.length);
    }
    return Number(new this.constructor(this.items).pluck(key).sum()) / Number(this.items.length);
  }
  avg = this.average;
  chunk(size) {
    const chunks = [];
    const items = Array.isArray(this.items) ? this.items : Object.values(this.items);
    for (let i = 0;i < items.length; i += size) {
      chunks.push(items.slice(i, i + size));
    }
    return new Collection(chunks);
  }
  collapse() {
    return new this.constructor([].concat(...this.items));
  }
  combine(values2) {
    if (typeof values2 === "string") {
      values2 = [values2];
    }
    if (!Array.isArray(values2)) {
      throw new TypeError("The values must be an array or a string");
    }
    const collection = {};
    const keys = Array.isArray(this.items) ? this.items : Object.keys(this.items);
    keys.forEach((key, index) => {
      if (values2[index] !== undefined) {
        collection[key] = values2[index];
      }
    });
    return new Collection(collection);
  }
  concat(collectionOrArrayOrObject) {
    let list = collectionOrArrayOrObject;
    if (collectionOrArrayOrObject instanceof this.constructor) {
      list = collectionOrArrayOrObject.all();
    } else if (typeof collectionOrArrayOrObject === "object") {
      list = [];
      Object.keys(collectionOrArrayOrObject).forEach((property) => {
        list.push(collectionOrArrayOrObject[property]);
      });
    }
    const collection = clone(this.items);
    list.forEach((item) => {
      if (typeof item === "object") {
        Object.keys(item).forEach((key) => collection.push(item[key]));
      } else {
        collection.push(item);
      }
    });
    return new this.constructor(collection);
  }
  contains(key, value) {
    if (typeof key === "function") {
      return this.items.some(key);
    }
    if (Array.isArray(this.items)) {
      return this.items.includes(key);
    }
    if (value !== undefined) {
      if (Array.isArray(this.items)) {
        return this.items.some((item) => item[key] !== undefined && item[key] === value);
      }
      return key in this.items && this.items[key] === value;
    }
    if (Array.isArray(this.items)) {
      return this.items.includes(key);
    }
    return Object.values(this.items).includes(key);
  }
  containsOneItem() {
    if (typeof this.items === "string") {
      return true;
    }
    return Object.keys(this.items).length === 1;
  }
  count(predicate) {
    if (predicate) {
      return this.filter(predicate).count();
    }
    return Object.keys(this.items).length;
  }
  countBy(callback) {
    const counts = {};
    this.each((item) => {
      const key = callback ? callback(item) : item;
      counts[key] = (counts[key] || 0) + 1;
    });
    return new Collection(counts);
  }
  crossJoin(...values2) {
    function join2(collection, constructor, args) {
      let current = args[0];
      if (current instanceof Collection) {
        current = current.all();
      }
      const rest = args.slice(1);
      const last = !rest.length;
      let result2 = [];
      for (let i = 0;i < current.length; i += 1) {
        const collectionCopy = collection.slice();
        collectionCopy.push(current[i]);
        if (last) {
          result2.push(collectionCopy);
        } else {
          result2 = result2.concat(join2(collectionCopy, constructor, rest));
        }
      }
      return result2;
    }
    return new this.constructor(join2([], this.constructor, [].concat([this.items], values2)));
  }
  dd() {
    console.log(JSON.stringify(this.all(), null, 2));
    process19.exit();
  }
  diff(values2) {
    let valuesToDiff;
    if (values2 instanceof this.constructor) {
      valuesToDiff = values2.all();
    } else {
      valuesToDiff = values2;
    }
    const collection = this.items.filter((item) => !valuesToDiff.includes(item));
    return new this.constructor(collection);
  }
  diffAssoc(values2) {
    let diffValues = values2;
    if (values2 instanceof this.constructor) {
      diffValues = values2.all();
    }
    const collection = {};
    Object.keys(this.items).forEach((key) => {
      if (diffValues[key] === undefined || diffValues[key] !== this.items[key]) {
        collection[key] = this.items[key];
      }
    });
    return new this.constructor(collection);
  }
  diffKeys(object) {
    let objectToDiff;
    if (object instanceof this.constructor) {
      objectToDiff = object.all();
    } else {
      objectToDiff = object;
    }
    const objectKeys = Object.keys(objectToDiff);
    const remainingKeys = Object.keys(this.items).filter((item) => !objectKeys.includes(item));
    return new this.constructor(this.items).only(remainingKeys);
  }
  diffUsing(array, callback) {
    console.log("Original collection:", this.items);
    console.log("Array to compare:", array);
    if (array === null) {
      return new Collection(this.items);
    }
    const collection = this.items.filter((item) => {
      const index = array.findIndex((otherItem) => {
        return callback(item, otherItem) === 0;
      });
      return index === -1;
    });
    return new Collection(collection);
  }
  doesntContain(key, value) {
    console.log("doesntContain called with:", { key, value });
    if (typeof key === "function") {
      console.log("Function branch");
      return !this.contains(key);
    }
    if (value !== undefined) {
      console.log("Key-value pair branch");
      return !this.contains((item) => {
        console.log("Comparing:", item[key], "with", value);
        return item[key] === value;
      });
    }
    console.log("Single value branch");
    return !this.contains(key);
  }
  dump() {
    console.log(this.items);
    return this;
  }
  duplicates() {
    const occuredValues = [];
    const duplicateValues = {};
    const stringifiedValue = (value) => {
      if (Array.isArray(value) || typeof value === "object") {
        return JSON.stringify(value);
      }
      return value;
    };
    if (Array.isArray(this.items)) {
      this.items.forEach((value, index) => {
        const valueAsString = stringifiedValue(value);
        if (!occuredValues.includes(valueAsString)) {
          occuredValues.push(valueAsString);
        } else {
          duplicateValues[index] = value;
        }
      });
    } else if (typeof this.items === "object") {
      Object.keys(this.items).forEach((key) => {
        const valueAsString = stringifiedValue(this.items[key]);
        if (!occuredValues.includes(valueAsString)) {
          occuredValues.push(valueAsString);
        } else {
          duplicateValues[key] = this.items[key];
        }
      });
    }
    return new this.constructor(duplicateValues);
  }
  each(fn) {
    let stop = false;
    if (Array.isArray(this.items)) {
      const { length } = this.items;
      for (let index = 0;index < length && !stop; index += 1) {
        stop = fn(this.items[index], index, this.items) === false;
      }
    } else {
      const keys = Object.keys(this.items);
      const { length } = keys;
      for (let index = 0;index < length && !stop; index += 1) {
        const key = keys[index];
        stop = fn(this.items[key], key, this.items) === false;
      }
    }
    return this;
  }
  eachSpread(fn) {
    this.each((values2, key) => {
      fn(...values2, key);
    });
    return this;
  }
  every(fn) {
    const items = values(this.items);
    return items.every(fn);
  }
  except(keys) {
    const result2 = { ...this.items };
    const keysArray = Array.isArray(keys) ? keys : [keys];
    keysArray.forEach((key) => delete result2[key]);
    return new Collection(result2);
  }
  filter(callback) {
    console.log("Filter method called with callback:", callback);
    console.log("Current items:", this.items);
    if (typeof callback !== "function") {
      console.log("No callback provided, removing falsy values");
      const filteredItems2 = this.items.filter((item) => {
        console.log("Filtering item:", item);
        return Boolean(item);
      });
      console.log("Filtered items:", filteredItems2);
      return new Collection(filteredItems2);
    }
    const filteredItems = this.items.filter((item, index) => {
      console.log("Filtering item:", item, "at index:", index);
      return callback(item, index);
    });
    console.log("Filtered items:", filteredItems);
    return new Collection(filteredItems);
  }
  first(fn, defaultValue) {
    if (isFunction(fn)) {
      const keys = Object.keys(this.items);
      for (let i = 0;i < keys.length; i += 1) {
        const key = keys[i];
        const item = this.items[key];
        if (fn(item, key)) {
          return item;
        }
      }
      if (isFunction(defaultValue)) {
        return defaultValue();
      }
      return defaultValue;
    }
    if (Array.isArray(this.items) && this.items.length || Object.keys(this.items).length) {
      if (Array.isArray(this.items)) {
        return this.items[0];
      }
      const firstKey = Object.keys(this.items)[0];
      return this.items[firstKey];
    }
    if (isFunction(defaultValue)) {
      return defaultValue();
    }
    return defaultValue;
  }
  firstOrFail(callback) {
    const found = this.items.find(callback || (() => true));
    if (found === undefined) {
      throw new Error("Item not found.");
    }
    return found;
  }
  firstWhere(key, operator, value) {
    return this.where(key, operator, value).first() || null;
  }
  flatMap(fn) {
    return this.map(fn).collapse();
  }
  flatten(depth = Number.POSITIVE_INFINITY) {
    const flatten = (item, d) => {
      if (!Array.isArray(item) && typeof item !== "object") {
        return [item];
      }
      return d > 0 ? Object.values(item).reduce((acc, val2) => acc.concat(Array.isArray(val2) || typeof val2 === "object" ? flatten(val2, d - 1) : val2), []) : Array.isArray(item) ? [...item] : [item];
    };
    return new Collection(flatten(this.items, depth));
  }
  flip() {
    const flipped = {};
    if (Array.isArray(this.items)) {
      this.items.forEach((value, index) => {
        flipped[value] = index;
      });
    } else {
      Object.entries(this.items).forEach(([key, value]) => {
        flipped[value] = key;
      });
    }
    return new this.constructor(flipped);
  }
  forPage(page, chunk) {
    let collection = {};
    if (Array.isArray(this.items)) {
      collection = this.items.slice(page * chunk - chunk, page * chunk);
    } else {
      Object.keys(this.items).slice(page * chunk - chunk, page * chunk).forEach((key) => {
        collection[key] = this.items[key];
      });
    }
    return new this.constructor(collection);
  }
  forget(key) {
    if (Array.isArray(this.items)) {
      this.items = this.items.filter((item, index) => index !== Number.parseInt(key, 10));
    } else if (typeof this.items === "object" && this.items !== null) {
      delete this.items[key];
    }
    return this;
  }
  get(key, defaultValue = null) {
    if (Array.isArray(this.items)) {
      return this.items[key] ?? defaultValue;
    }
    return this.items[key] ?? defaultValue;
  }
  groupBy(fn) {
    const groups = {};
    this.each((item, key) => {
      const groupKey = typeof fn === "function" ? fn(item) : item[fn];
      if (!(groupKey in groups)) {
        groups[groupKey] = new Collection;
      }
      groups[groupKey].push(item);
    });
    return new Collection(groups);
  }
  has(key) {
    if (Array.isArray(this.items)) {
      return key in this.items;
    }
    return key in this.items;
  }
  implode(key, glue) {
    if (glue === undefined) {
      return this.items.join(key);
    }
    return new this.constructor(this.items).pluck(key).all().join(glue);
  }
  includes(key) {
    if (Array.isArray(this.items)) {
      return this.items.includes(key);
    }
    return Object.values(this.items).includes(key);
  }
  intersect(values2) {
    let intersectValues = values2;
    if (values2 instanceof this.constructor) {
      intersectValues = values2.all();
    }
    const collection = this.items.filter((item) => intersectValues.includes(item));
    return new this.constructor(collection);
  }
  intersectByKeys(values2) {
    let intersectKeys = Object.keys(values2);
    if (values2 instanceof this.constructor) {
      intersectKeys = Object.keys(values2.all());
    }
    const collection = {};
    Object.keys(this.items).forEach((key) => {
      if (intersectKeys.includes(key)) {
        collection[key] = this.items[key];
      }
    });
    return new this.constructor(collection);
  }
  isEmpty() {
    return this.count() === 0;
  }
  isNotEmpty() {
    return !this.isEmpty();
  }
  join(glue, finalGlue) {
    const collection = this.values();
    if (finalGlue === undefined) {
      return collection.implode(glue);
    }
    const count = collection.count();
    if (count === 0) {
      return "";
    }
    if (count === 1) {
      return collection.last();
    }
    const finalItem = collection.pop();
    return collection.implode(glue) + finalGlue + finalItem;
  }
  keyBy(key) {
    const collection = {};
    if (isFunction(key)) {
      this.items.forEach((item) => {
        collection[key(item)] = item;
      });
    } else {
      this.items.forEach((item) => {
        const keyValue = nestedValue(item, key);
        collection[keyValue || ""] = item;
      });
    }
    return new this.constructor(collection);
  }
  keys() {
    return new Collection(Object.keys(this.items));
  }
  last(fn, defaultValue) {
    let { items } = this;
    if (isFunction(fn)) {
      items = this.filter(fn).all();
    }
    if (Array.isArray(items) && !items.length || !Object.keys(items).length) {
      if (isFunction(defaultValue)) {
        return defaultValue();
      }
      return defaultValue;
    }
    if (Array.isArray(items)) {
      return items[items.length - 1];
    }
    const keys = Object.keys(items);
    return items[keys[keys.length - 1]];
  }
  macro(name, fn) {
    this.constructor.prototype[name] = fn;
  }
  make(items = []) {
    return new this.constructor(items);
  }
  map(fn) {
    if (Array.isArray(this.items)) {
      return new this.constructor(this.items.map(fn));
    }
    const collection = {};
    Object.keys(this.items).forEach((key) => {
      collection[key] = fn(this.items[key], Number(key));
    });
    return new this.constructor(collection);
  }
  mapSpread(fn) {
    return this.map((values2, key) => fn(...values2, key));
  }
  mapToDictionary(fn) {
    const collection = {};
    this.items.forEach((item, k) => {
      const [key, value] = fn(item, k);
      if (collection[key] === undefined) {
        collection[key] = [value];
      } else {
        collection[key].push(value);
      }
    });
    return new this.constructor(collection);
  }
  mapInto(ClassName) {
    return this.map((value, key) => new ClassName(value, key));
  }
  mapToGroups(fn) {
    const collection = {};
    this.items.forEach((item, key) => {
      const [keyed, value] = fn(item, key);
      if (collection[keyed] === undefined) {
        collection[keyed] = [value];
      } else {
        collection[keyed].push(value);
      }
    });
    return new this.constructor(collection);
  }
  mapWithKeys(fn) {
    const collection = {};
    if (Array.isArray(this.items)) {
      this.items.forEach((item, index) => {
        const [keyed, value] = fn(item, index);
        collection[keyed] = value;
      });
    } else {
      Object.keys(this.items).forEach((key) => {
        const [keyed, value] = fn(this.items[key], Number(key));
        collection[keyed] = value;
      });
    }
    return new this.constructor(collection);
  }
  max(key) {
    if (typeof key === "string") {
      const filtered = this.items.filter((item) => item[key] !== undefined);
      return Math.max(...filtered.map((item) => item[key]));
    }
    return Math.max(...this.items);
  }
  median(key) {
    const { length } = this.items;
    if (key === undefined) {
      if (length % 2 === 0) {
        return (this.items[length / 2 - 1] + this.items[length / 2]) / 2;
      }
      return this.items[Math.floor(length / 2)];
    }
    if (length % 2 === 0) {
      return (this.items[length / 2 - 1][key] + this.items[length / 2][key]) / 2;
    }
    return this.items[Math.floor(length / 2)][key];
  }
  merge(object) {
    const merged = { ...this.items, ...object };
    return new Collection(merged);
  }
  mergeRecursive(items) {
    const merge = (target, source) => {
      const merged = {};
      const mergedKeys = Object.keys({ ...target, ...source });
      mergedKeys.forEach((key) => {
        if (target[key] === undefined && source[key] !== undefined) {
          merged[key] = source[key];
        } else if (target[key] !== undefined && source[key] === undefined) {
          merged[key] = target[key];
        } else if (target[key] !== undefined && source[key] !== undefined) {
          if (target[key] === source[key]) {
            merged[key] = target[key];
          } else if (!Array.isArray(target[key]) && typeof target[key] === "object" && !Array.isArray(source[key]) && typeof source[key] === "object") {
            merged[key] = merge(target[key], source[key]);
          } else {
            merged[key] = [].concat(target[key], source[key]);
          }
        }
      });
      return merged;
    };
    if (!items) {
      return this;
    }
    if (items.constructor.name === "Collection") {
      return new this.constructor(merge(this.items, items.all()));
    }
    return new this.constructor(merge(this.items, items));
  }
  min(key) {
    if (key !== undefined) {
      const filtered = this.items.filter((item) => item[key] !== undefined);
      return Math.min(...filtered.map((item) => item[key]));
    }
    return Math.min(...this.items);
  }
  mode(key) {
    const values2 = [];
    let highestCount = 1;
    if (!this.items.length) {
      return null;
    }
    this.items.forEach((item) => {
      const tempValues = values2.filter((value) => {
        if (key !== undefined) {
          return value.key === item[key];
        }
        return value.key === item;
      });
      if (!tempValues.length) {
        if (key !== undefined) {
          values2.push({ key: item[key], count: 1 });
        } else {
          values2.push({ key: item, count: 1 });
        }
      } else {
        tempValues[0].count += 1;
        const { count } = tempValues[0];
        if (count > highestCount) {
          highestCount = count;
        }
      }
    });
    return values2.filter((value) => value.count === highestCount).map((value) => value.key);
  }
  nth(n, offset = 0) {
    const items = values(this.items);
    const collection = items.slice(offset).filter((item, index) => index % n === 0);
    return new this.constructor(collection);
  }
  only(keys) {
    const result2 = {};
    keys.forEach((key) => {
      if (key in this.items)
        result2[key] = this.items[key];
    });
    return new Collection(result2);
  }
  pad(size, value) {
    const abs = Math.abs(size);
    const count = this.count();
    if (abs <= count) {
      return this;
    }
    let diff = abs - count;
    const items = clone(this.items);
    const isArray2 = Array.isArray(this.items);
    const prepend = size < 0;
    for (let iterator = 0;iterator < diff; ) {
      if (!isArray2) {
        if (items[iterator] !== undefined) {
          diff += 1;
        } else {
          items[iterator] = value;
        }
      } else if (prepend) {
        items.unshift(value);
      } else {
        items.push(value);
      }
      iterator += 1;
    }
    return new this.constructor(items);
  }
  partition(fn) {
    let arrays;
    if (Array.isArray(this.items)) {
      arrays = [new this.constructor([]), new this.constructor([])];
      this.items.forEach((item) => {
        if (fn(item) === true) {
          arrays[0].push(item);
        } else {
          arrays[1].push(item);
        }
      });
    } else {
      arrays = [new this.constructor({}), new this.constructor({})];
      Object.keys(this.items).forEach((prop) => {
        const value = this.items[prop];
        if (fn(value) === true) {
          arrays[0].put(prop, value);
        } else {
          arrays[1].put(prop, value);
        }
      });
    }
    return new this.constructor(arrays);
  }
  pipe(fn) {
    return fn(this);
  }
  pluck(value, key) {
    if (value.includes("*")) {
      const keyPathMap = buildKeyPathMap(this.items);
      const keyMatches = [];
      if (key !== undefined) {
        const keyRegex = new RegExp(`0.${key}`, "g");
        const keyNumberOfLevels = `0.${key}`.split(".").length;
        Object.keys(keyPathMap).forEach((k) => {
          const matchingKey = k.match(keyRegex);
          if (matchingKey) {
            const match = matchingKey[0];
            if (match.split(".").length === keyNumberOfLevels) {
              keyMatches.push(keyPathMap[match]);
            }
          }
        });
      }
      const valueMatches = [];
      const valueRegex = new RegExp(`0.${value}`, "g");
      const valueNumberOfLevels = `0.${value}`.split(".").length;
      Object.keys(keyPathMap).forEach((k) => {
        const matchingValue = k.match(valueRegex);
        if (matchingValue) {
          const match = matchingValue[0];
          if (match.split(".").length === valueNumberOfLevels) {
            valueMatches.push(keyPathMap[match]);
          }
        }
      });
      if (key !== undefined) {
        const collection = {};
        this.items.forEach((item, index) => {
          collection[keyMatches[index] || ""] = valueMatches;
        });
        return new this.constructor(collection);
      }
      return new this.constructor([valueMatches]);
    }
    if (key !== undefined) {
      const collection = {};
      this.items.forEach((item) => {
        if (nestedValue(item, value) !== undefined) {
          collection[item[key] || ""] = nestedValue(item, value);
        } else {
          collection[item[key] || ""] = null;
        }
      });
      return new this.constructor(collection);
    }
    return this.map((item) => {
      if (nestedValue(item, value) !== undefined) {
        return nestedValue(item, value);
      }
      return null;
    });
  }
  pop(count = 1) {
    if (this.isEmpty()) {
      return null;
    }
    if (isArray(this.items)) {
      if (count === 1) {
        return this.items.pop();
      }
      return new this.constructor(this.items.splice(-count));
    }
    if (isObject2(this.items)) {
      const keys = Object.keys(this.items);
      if (count === 1) {
        const key = keys[keys.length - 1];
        const last = this.items[key];
        deleteKeys(this.items, key);
        return last;
      }
      const poppedKeys = keys.slice(-count);
      const newObject = poppedKeys.reduce((acc, current) => {
        acc[current] = this.items[current];
        return acc;
      }, {});
      deleteKeys(this.items, poppedKeys);
      return new this.constructor(newObject);
    }
    return null;
  }
  prepend(value, key) {
    if (key !== undefined) {
      return this.put(key, value);
    }
    this.items.unshift(value);
    return this;
  }
  pull(key, defaultValue = null) {
    if (Array.isArray(this.items)) {
      const index = Number(key);
      if (Number.isNaN(index))
        return defaultValue;
      const value2 = this.items[index];
      this.items.splice(index, 1);
      return value2 ?? defaultValue;
    }
    const value = this.items[key];
    delete this.items[key];
    return value ?? defaultValue;
  }
  push(...items) {
    this.items = [...this.items, ...items];
    return this;
  }
  put(key, value) {
    this.items[key] = value;
    return this;
  }
  random(length = null) {
    const items = values(this.items);
    const collection = new this.constructor(items).shuffle();
    if (length !== Number.parseInt(length, 10)) {
      return collection.first();
    }
    return collection.take(length);
  }
  reduce(fn, carry) {
    let reduceCarry = null;
    if (carry !== undefined) {
      reduceCarry = carry;
    }
    if (Array.isArray(this.items)) {
      this.items.forEach((item) => {
        reduceCarry = fn(reduceCarry, item);
      });
    } else {
      Object.keys(this.items).forEach((key) => {
        reduceCarry = fn(reduceCarry, this.items[key], key);
      });
    }
    return reduceCarry;
  }
  reject(fn) {
    return new this.constructor(this.items).filter((item) => !fn(item));
  }
  replace(items) {
    if (!items) {
      return this;
    }
    if (Array.isArray(items)) {
      const replaced2 = this.items.map((value, index) => items[index] || value);
      return new this.constructor(replaced2);
    }
    if (items.constructor.name === "Collection") {
      const replaced2 = { ...this.items, ...items.all() };
      return new this.constructor(replaced2);
    }
    const replaced = { ...this.items, ...items };
    return new this.constructor(replaced);
  }
  replaceRecursive(items) {
    const replace2 = (target, source) => {
      const replaced = { ...target };
      const mergedKeys = Object.keys({ ...target, ...source });
      mergedKeys.forEach((key) => {
        if (!Array.isArray(source[key]) && typeof source[key] === "object") {
          replaced[key] = replace2(target[key], source[key]);
        } else if (target[key] === undefined && source[key] !== undefined) {
          if (typeof target[key] === "object") {
            replaced[key] = { ...source[key] };
          } else {
            replaced[key] = source[key];
          }
        } else if (target[key] !== undefined && source[key] === undefined) {
          if (typeof target[key] === "object") {
            replaced[key] = { ...target[key] };
          } else {
            replaced[key] = target[key];
          }
        } else if (target[key] !== undefined && source[key] !== undefined) {
          if (typeof source[key] === "object") {
            replaced[key] = { ...source[key] };
          } else {
            replaced[key] = source[key];
          }
        }
      });
      return replaced;
    };
    if (!items) {
      return this;
    }
    if (!Array.isArray(items) && typeof items !== "object") {
      return new this.constructor(replace2(this.items, [items]));
    }
    if (items.constructor.name === "Collection") {
      return new this.constructor(replace2(this.items, items.all()));
    }
    return new this.constructor(replace2(this.items, items));
  }
  reverse() {
    const collection = [].concat(this.items).reverse();
    return new this.constructor(collection);
  }
  search(valueOrFunction, strict) {
    let result2;
    const find = (item, key) => {
      if (isFunction(valueOrFunction)) {
        return valueOrFunction(this.items[key], key);
      }
      if (strict) {
        return this.items[key] === valueOrFunction;
      }
      return this.items[key] == valueOrFunction;
    };
    if (isArray(this.items)) {
      result2 = this.items.findIndex(find);
    } else if (isObject2(this.items)) {
      result2 = Object.keys(this.items).find((key) => find(this.items[key], key));
    }
    if (result2 === undefined || result2 < 0) {
      return false;
    }
    return result2;
  }
  shift(count = 1) {
    if (this.isEmpty()) {
      return null;
    }
    if (isArray(this.items)) {
      if (count === 1) {
        return this.items.shift();
      }
      return new this.constructor(this.items.splice(0, count));
    }
    if (isObject2(this.items)) {
      if (count === 1) {
        const key = Object.keys(this.items)[0];
        const value = this.items[key];
        delete this.items[key];
        return value;
      }
      const keys = Object.keys(this.items);
      const poppedKeys = keys.slice(0, count);
      const newObject = poppedKeys.reduce((acc, current) => {
        acc[current] = this.items[current];
        return acc;
      }, {});
      deleteKeys(this.items, poppedKeys);
      return new this.constructor(newObject);
    }
    return null;
  }
  shuffle() {
    const items = values(this.items);
    let j2;
    let x2;
    let i;
    for (i = items.length;i; i -= 1) {
      j2 = Math.floor(Math.random() * i);
      x2 = items[i - 1];
      items[i - 1] = items[j2];
      items[j2] = x2;
    }
    this.items = items;
    return this;
  }
  skip(number) {
    if (isObject2(this.items)) {
      return new this.constructor(Object.keys(this.items).reduce((accumulator, key, index) => {
        if (index + 1 > number) {
          accumulator[key] = this.items[key];
        }
        return accumulator;
      }, {}));
    }
    return new this.constructor(this.items.slice(number));
  }
  skipUntil(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== true) {
          previous = callback(item);
        }
        return previous;
      });
    }
    if (isObject2(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== true) {
          previous = callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  skipWhile(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== true) {
          previous = !callback(item);
        }
        return previous;
      });
    }
    if (isObject2(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== true) {
          previous = !callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  slice(remove, limit) {
    let collection = this.items.slice(remove);
    if (limit !== undefined) {
      collection = collection.slice(0, limit);
    }
    return new this.constructor(collection);
  }
  sole() {
    if (this.items.length !== 1) {
      throw new Error("Collection does not contain exactly one item.");
    }
    return this.items[0];
  }
  some(key) {
    return this.items.some((item) => item.hasOwnProperty(key));
  }
  sort(fn) {
    const collection = [].concat(this.items);
    if (fn === undefined) {
      if (this.every((item) => typeof item === "number")) {
        collection.sort((a, b2) => a - b2);
      } else {
        collection.sort();
      }
    } else {
      collection.sort(fn);
    }
    return new this.constructor(collection);
  }
  sortDesc() {
    return this.sort().reverse();
  }
  sortBy(valueOrFunction) {
    const collection = [].concat(this.items);
    const getValue = (item) => {
      if (isFunction(valueOrFunction)) {
        return valueOrFunction(item);
      }
      return nestedValue(item, valueOrFunction);
    };
    collection.sort((a, b2) => {
      const valueA = getValue(a);
      const valueB = getValue(b2);
      if (valueA === null || valueA === undefined) {
        return 1;
      }
      if (valueB === null || valueB === undefined) {
        return -1;
      }
      if (valueA < valueB) {
        return -1;
      }
      if (valueA > valueB) {
        return 1;
      }
      return 0;
    });
    return new this.constructor(collection);
  }
  sortByDesc(valueOrFunction) {
    return this.sortBy(valueOrFunction).reverse();
  }
  sortKeys() {
    const ordered = {};
    Object.keys(this.items).sort().forEach((key) => {
      ordered[key] = this.items[key];
    });
    return new this.constructor(ordered);
  }
  sortKeysDesc() {
    const ordered = {};
    Object.keys(this.items).sort().reverse().forEach((key) => {
      ordered[key] = this.items[key];
    });
    return new this.constructor(ordered);
  }
  splice(index, limit, replace2) {
    const slicedCollection = this.slice(index, limit);
    this.items = this.diff(slicedCollection.all()).all();
    if (Array.isArray(replace2)) {
      for (let iterator = 0, { length } = replace2;iterator < length; iterator += 1) {
        this.items.splice(index + iterator, 0, replace2[iterator]);
      }
    }
    return slicedCollection;
  }
  split(numberOfGroups) {
    const itemsArray = this.toArray();
    const groups = [];
    const size = Math.ceil(itemsArray.length / numberOfGroups);
    for (let i = 0;i < itemsArray.length; i += size) {
      groups.push(itemsArray.slice(i, i + size));
    }
    return new Collection(groups);
  }
  sum(key) {
    const items = values(this.items);
    let total = 0;
    if (key === undefined) {
      for (let i = 0, { length } = items;i < length; i += 1) {
        total += Number.parseFloat(items[i]);
      }
    } else if (isFunction(key)) {
      for (let i = 0, { length } = items;i < length; i += 1) {
        total += Number.parseFloat(key(items[i]));
      }
    } else {
      for (let i = 0, { length } = items;i < length; i += 1) {
        total += Number.parseFloat(items[i][key]);
      }
    }
    return Number.parseFloat(total.toPrecision(12));
  }
  take(length) {
    if (!Array.isArray(this.items) && typeof this.items === "object") {
      const keys = Object.keys(this.items);
      let slicedKeys;
      if (length < 0) {
        slicedKeys = keys.slice(length);
      } else {
        slicedKeys = keys.slice(0, length);
      }
      const collection = {};
      keys.forEach((prop) => {
        if (slicedKeys.includes(prop)) {
          collection[prop] = this.items[prop];
        }
      });
      return new this.constructor(collection);
    }
    if (length < 0) {
      return new this.constructor(this.items.slice(length));
    }
    return new this.constructor(this.items.slice(0, length));
  }
  takeUntil(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== false) {
          previous = !callback(item);
        }
        return previous;
      });
    }
    if (isObject2(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== false) {
          previous = !callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  takeWhile(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== false) {
          previous = callback(item);
        }
        return previous;
      });
    }
    if (isObject2(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== false) {
          previous = callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  tap(fn) {
    fn(this);
    return this;
  }
  times(n, fn) {
    for (let iterator = 1;iterator <= n; iterator += 1) {
      this.items.push(fn(iterator));
    }
    return this;
  }
  toArray() {
    return Array.isArray(this.items) ? this.items : Object.values(this.items);
  }
  toJson() {
    return JSON.stringify(this.items);
  }
  transform(fn) {
    if (Array.isArray(this.items)) {
      this.items = this.items.map(fn);
    } else {
      const collection = {};
      Object.keys(this.items).forEach((key) => {
        collection[key] = fn(this.items[key], key);
      });
      this.items = collection;
    }
    return this;
  }
  undot() {
    if (Array.isArray(this.items)) {
      return this;
    }
    let collection = {};
    Object.keys(this.items).forEach((key) => {
      if (key.includes(".")) {
        const obj = collection;
        key.split(".").reduce((acc, current, index, array) => {
          if (!acc[current]) {
            acc[current] = {};
          }
          if (index === array.length - 1) {
            acc[current] = this.items[key];
          }
          return acc[current];
        }, obj);
        collection = { ...collection, ...obj };
      } else {
        collection[key] = this.items[key];
      }
    });
    return new this.constructor(collection);
  }
  unless(value, fn, defaultFn) {
    if (!value) {
      return fn(this);
    }
    if (defaultFn)
      return defaultFn();
    return;
  }
  unlessEmpty(callback) {
    if (!this.isEmpty()) {
      callback(this);
    }
    return this;
  }
  unlessNotEmpty(callback) {
    if (this.isEmpty()) {
      callback(this);
    }
    return this;
  }
  union(object) {
    const collection = JSON.parse(JSON.stringify(this.items));
    Object.keys(object).forEach((prop) => {
      if (this.items[prop] === undefined) {
        collection[prop] = object[prop];
      }
    });
    return new this.constructor(collection);
  }
  unique() {
    const uniqueItems = Array.from(new Set(this.items));
    return new this.constructor(uniqueItems);
  }
  unwrap() {
    return this.items;
  }
  values() {
    return new Collection(Object.values(this.items));
  }
  when(value, callback, defaultCallback) {
    if (value) {
      callback(this, value);
    } else if (defaultCallback) {
      defaultCallback();
    }
    return this;
  }
  whenEmpty(fn, defaultFn) {
    if (Array.isArray(this.items) && !this.items.length) {
      return fn(this);
    }
    if (!Object.keys(this.items).length) {
      return fn(this);
    }
    if (defaultFn !== undefined) {
      if (Array.isArray(this.items) && this.items.length) {
        return defaultFn(this);
      }
      if (Object.keys(this.items).length) {
        return defaultFn(this);
      }
    }
    return this;
  }
  whenNotEmpty(fn, defaultFn) {
    if (Array.isArray(this.items) && this.items.length) {
      return fn(this);
    }
    if (Object.keys(this.items).length) {
      return fn(this);
    }
    if (defaultFn !== undefined) {
      if (Array.isArray(this.items) && !this.items.length) {
        return defaultFn(this);
      }
      if (!Object.keys(this.items).length) {
        return defaultFn(this);
      }
    }
    return this;
  }
  where(key, operator, value) {
    if (arguments.length === 1) {
      return new Collection(this.items.filter((item) => item[key] !== undefined));
    }
    if (arguments.length === 2) {
      value = operator;
      operator = "===";
    }
    const compareValues = (item, key2, value2, operator2) => {
      const itemValue = item[key2];
      switch (operator2) {
        case "===":
          return itemValue === value2;
        case "!==":
          return itemValue !== value2;
        case "<":
          return itemValue < value2;
        case "<=":
          return itemValue <= value2;
        case ">":
          return itemValue > value2;
        case ">=":
          return itemValue >= value2;
        default:
          return itemValue == value2;
      }
    };
    return new Collection(this.items.filter((item) => compareValues(item, key, value, operator)));
  }
  whereBetween(key, values2) {
    return this.filter((item) => {
      const itemValue = typeof item === "object" ? item[key] : item;
      return itemValue >= values2[0] && itemValue <= values2[1];
    });
  }
  whereIn(key, values2) {
    return this.filter((item) => {
      const itemValue = typeof item === "object" ? item[key] : item;
      return values2.includes(itemValue);
    });
  }
  whereNotBetween(key, values2) {
    return this.filter((item) => {
      const itemValue = typeof item === "object" ? item[key] : item;
      return itemValue < values2[0] || itemValue > values2[1];
    });
  }
  whereNotIn(key, values2) {
    const filteredItems = this.items.filter((item) => {
      const keys = key.split(".");
      let value = item;
      for (const k of keys) {
        if (value[k] === undefined)
          return true;
        value = value[k];
      }
      return !values2.includes(value);
    });
    return new Collection(filteredItems);
  }
  getNestedValue(item, key) {
    const keys = key.split(".");
    return keys.reduce((obj, k) => obj && obj[k] !== undefined ? obj[k] : null, item);
  }
  whereInstanceOf(type) {
    return this.filter((item) => item instanceof type);
  }
  whereNotNull(key) {
    return this.where(key, "!==", null);
  }
  whereNull(key) {
    return this.where(key, "===", null);
  }
  static wrap(value) {
    if (value instanceof Collection)
      return value;
    return new Collection(Array.isArray(value) ? value : [value]);
  }
  static unwrap(value) {
    if (value instanceof Collection) {
      return value.all();
    }
    return value;
  }
  wrap(value) {
    if (value instanceof Collection) {
      return value;
    }
    if (typeof value === "object") {
      return new Collection(value);
    }
    return new Collection([value]);
  }
  zip(...arrays) {
    const arrayOfArrays = arrays.map((arg) => this.constructor.wrap(arg).all());
    const zipped = this.items.map((item, index) => {
      const values2 = [item];
      arrayOfArrays.forEach((array) => {
        values2.push(array[index]);
      });
      return new this.constructor(values2);
    });
    return new this.constructor(zipped);
  }
}
var buildKeyPathMap = function buildKeyPathMap2(items) {
  const keyPaths = {};
  items.forEach((item, index) => {
    function buildKeyPath(val2, keyPath) {
      if (isObject2(val2)) {
        Object.keys(val2).forEach((prop) => {
          buildKeyPath(val2[prop], `${keyPath}.${prop}`);
        });
      } else if (isArray(val2)) {
        val2.forEach((v2, i) => {
          buildKeyPath(v2, `${keyPath}.${i}`);
        });
      }
      keyPaths[keyPath] = val2;
    }
    buildKeyPath(item, index);
  });
  return keyPaths;
};
function SymbolIterator() {
  let index = -1;
  return {
    next: () => {
      index += 1;
      return {
        value: this.items[index],
        done: index >= this.items.length
      };
    }
  };
}
init_utils();
var quotes = collect([
  "The best way to get started is to quit talking and begin doing.",
  "The pessimist sees difficulty in every opportunity. The optimist sees opportunity in every difficulty.",
  "Don\u2019t let yesterday take up too much of today.",
  "You learn more from failure than from success. Don\u2019t let it stop you. Failure builds character.",
  "It\u2019s not whether you get knocked down, it\u2019s whether you get up.",
  "If you are working on something that you really care about, you don\u2019t have to be pushed. The vision pulls you.",
  "People who are crazy enough to think they can change the world, are the ones who do.",
  "Failure will never overtake me if my determination to succeed is strong enough.",
  "Entrepreneurs are great at dealing with uncertainty and also very good at minimizing risk. That\u2019s the classic entrepreneur.",
  "We may encounter many defeats but we must not be defeated.",
  "Knowing is not enough; we must apply. Wishing is not enough; we must do.",
  "Imagine your life is perfect in every respect; what would it look like?",
  "We generate fears while we sit. We overcome them by action.",
  "Whether you think you can or think you can\u2019t, you\u2019re right.",
  "Security is mostly a superstition. Life is either a daring adventure or nothing."
]);
var export_prompts = import_prompts.default;

// node_modules/@stacksjs/storage/dist/index.js
import p3 from "process";
import { access as access2, appendFile as appendFile2, mkdir as mkdir2 } from "fs/promises";
import { dirname as dirname3 } from "path";
import process3 from "process";
import { formatWithOptions as formatWithOptions2 } from "util";
import { sep as sep3 } from "path";
import * as tty4 from "tty";
import { stdin as stdin2, stdout as stdout2 } from "process";
import f2 from "readline";
import { WriteStream as WriteStream2 } from "tty";
import require$$02 from "tty";
import process$12 from "process";
import process42 from "process";
import process52 from "process";
import process62 from "process";
import process72 from "process";
import os2 from "os";
import {
  basename as basename2,
  delimiter as delimiter2,
  dirname as dirname22,
  extname as extname2,
  isAbsolute as isAbsolute2,
  join as join2,
  normalize as normalize2,
  parse as parse2,
  relative as relative2,
  resolve,
  sep as sep22,
  toNamespacedPath as toNamespacedPath2
} from "path";
import process8 from "process";
import process9 from "process";
import os22 from "os";
import tty32 from "tty";
import { resolve as resolve22, basename as basename22, extname as extname22, dirname as dirname32, relative as relative$1 } from "path";
import require$$0$1, { win32, posix, isAbsolute as isAbsolute$1, resolve as resolve$1 } from "path";
import process$122, { env as env$1 } from "process";
import * as tty42 from "tty";
import { extname as extname3, win32 as win322, posix as posix2, isAbsolute as isAbsolute3, resolve as resolve3 } from "path";
import fs, { realpathSync } from "fs";
import { promisify } from "util";
import os3 from "os";
import { EventEmitter as EventEmitter2 } from "events";
import path4, { posix as posix3 } from "path";
import { Buffer as Buffer2 } from "buffer";
import { Buffer as Buffer3 } from "buffer";
import { Transform } from "stream";
import { Readable } from "stream";
import { Readable as Readable2 } from "stream";
import { Agent as hAgent, request as hRequest } from "http";
import { Agent as hsAgent, request as hsRequest } from "https";
import { Writable } from "stream";
import { Readable as Readable3 } from "stream";
import { TextDecoder as TextDecoder2 } from "util";
import { PassThrough } from "stream";
import { Writable as Writable2 } from "stream";
import { homedir } from "os";
import { sep as sep32 } from "path";
import { createHash } from "crypto";
import { join as join22 } from "path";
import { promises as fsPromises } from "fs";
import { join as join3 } from "path";
import { join as join4 } from "path";
import { promises as fsPromises2 } from "fs";
import { join as join5 } from "path";
import { Readable as Readable4 } from "stream";
import { Buffer as Buffer4 } from "buffer";
import { request as request4 } from "http";
import { parse as parse9 } from "url";
import fs3 from "fs/promises";
import { platform as platform3, release } from "os";
import { env as env6, versions as versions2 } from "process";
import { Buffer as Buffer5 } from "buffer";
import { createHash as createHash2, createHmac } from "crypto";
import { fstatSync, lstatSync } from "fs";
import { promises as fsPromises3 } from "fs";
import { exec as exec3 } from "child_process";
import { promisify as promisify2 } from "util";
import { readFileSync as readFileSync2 } from "fs";
import { Readable as Readable5 } from "stream";
import { Writable as Writable3 } from "stream";
import { lstatSync as lstatSync2 } from "fs";
import { Buffer as Buffer6 } from "buffer";
import { Buffer as Buffer7 } from "buffer";
import { Buffer as Buffer8 } from "buffer";
import { Buffer as Buffer9 } from "buffer";
import { Buffer as Buffer10 } from "buffer";
import { Readable as Readable6 } from "stream";
import { EventEmitter as EventEmitter22 } from "events";
import { createHash as createHash3 } from "crypto";
import { join as join6 } from "path";
import { Readable as Readable7 } from "stream";
import { TextEncoder as TextEncoder2 } from "util";
import { join as join7 } from "path";
import { parse as parse11 } from "path";
import { PassThrough as PassThrough2 } from "stream";
import { join as join8 } from "path";
import { Readable as Readable8 } from "stream";
import { open as fsOpen } from "fs/promises";
import { stat as fsStat } from "fs/promises";
import { ReadableStream as WebReadableStream } from "stream/web";
import { pipeline, PassThrough as PassThrough3, Readable as Readable9 } from "stream";
import { dirname as dirname4, parse as parse12 } from "path";
import { createReadStream, createWriteStream, Dirent } from "fs";
import { chmod, mkdir as mkdir22, opendir, rm, stat as stat2, rename, copyFile as copyFile2 } from "fs/promises";
import { posix as posix4, extname as extname5 } from "path";
import { pipeline as pipeline2 } from "stream/promises";
import { createHash as createHash4 } from "crypto";
import { fileURLToPath } from "url";
var __create3 = Object.create;
var __getProtoOf3 = Object.getPrototypeOf;
var __defProp3 = Object.defineProperty;
var __getOwnPropNames3 = Object.getOwnPropertyNames;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __hasOwnProp3 = Object.prototype.hasOwnProperty;
var __toESM3 = (mod, isNodeMode, target) => {
  target = mod != null ? __create3(__getProtoOf3(mod)) : {};
  const to = isNodeMode || !mod || !mod.__esModule ? __defProp3(target, "default", { value: mod, enumerable: true }) : target;
  for (let key of __getOwnPropNames3(mod))
    if (!__hasOwnProp3.call(to, key))
      __defProp3(to, key, {
        get: () => mod[key],
        enumerable: true
      });
  return to;
};
var __moduleCache = /* @__PURE__ */ new WeakMap;
var __toCommonJS = (from) => {
  var entry = __moduleCache.get(from), desc;
  if (entry)
    return entry;
  entry = __defProp3({}, "__esModule", { value: true });
  if (from && typeof from === "object" || typeof from === "function")
    __getOwnPropNames3(from).map((key) => !__hasOwnProp3.call(entry, key) && __defProp3(entry, key, {
      get: () => from[key],
      enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable
    }));
  __moduleCache.set(from, entry);
  return entry;
};
var __commonJS2 = (cb, mod) => () => (mod || cb((mod = { exports: {} }).exports, mod), mod.exports);
var __export3 = (target, all) => {
  for (var name in all)
    __defProp3(target, name, {
      get: all[name],
      enumerable: true,
      configurable: true,
      set: (newValue) => all[name] = () => newValue
    });
};
var __esm2 = (fn, res) => () => (fn && (res = fn(fn = 0)), res);
function contains(needle, haystack) {
  return haystack.some((hay) => needle.includes(hay));
}
var init_install = () => {
};
var init_actions = __esm2(() => {
  init_install();
});
var processArgs2;
var platformInfo2;
var init_dist = __esm2(() => {
  processArgs2 = process.argv;
  platformInfo2 = `${process.platform}-${process.arch} node-${process.version}`;
});
var init_cli = __esm2(() => {
  init_dist();
});
var config4;
var defaults_default2;
var init_defaults = __esm2(() => {
  init_src11();
  config4 = {
    ai: {
      deploy: false,
      models: [
        "amazon.titan-embed-text-v1",
        "amazon.titan-text-express-v1",
        "amazon.titan-embed-image-v1",
        "amazon.titan-image-generator-v1",
        "anthropic.claude-v1",
        "anthropic.claude-v2",
        "anthropic.claude-v2:1",
        "anthropic.claude-instant-v1",
        "meta.llama2-13b-chat-v1",
        "meta.llama2-70b-chat-v1"
      ]
    },
    analytics: {
      driver: undefined
    },
    app: {
      name: "Stacks",
      description: "A Stacks application.",
      env: "local",
      url: "stacks.localhost",
      debug: true,
      key: "",
      timezone: "UTC",
      locale: "en",
      fallbackLocale: "en",
      cipher: "AES-256-CBC",
      docMode: false,
      redirectUrls: [],
      maintenanceMode: false
    },
    cli: {
      name: "My Custom CLI",
      command: "my-custom-cli",
      description: "Stacks is a full-stack framework for TypeScript.",
      source: commandsPath2(),
      deploy: false
    },
    cache: {
      driver: "redis",
      prefix: "stx",
      ttl: 3600,
      drivers: {
        redis: {
          connection: "default",
          host: "localhost",
          port: 6379,
          username: "",
          password: ""
        }
      }
    },
    cloud: {
      type: "serverless",
      driver: "aws",
      storage: {},
      environments: ["production", "staging", "development"],
      firewall: {
        enabled: true,
        countryCodes: [],
        ipAddresses: [],
        queryString: [],
        httpHeaders: [],
        rateLimitPerMinute: 1000,
        useIpReputationLists: true,
        useKnownBadInputsRuleSet: true
      },
      cdn: {
        allowedMethods: "GET_HEAD",
        cachedMethods: "GET_HEAD",
        minTtl: 0,
        defaultTtl: 86400,
        maxTtl: 31536000,
        compress: true,
        priceClass: "PriceClass_All",
        originShieldRegion: "us-east-1",
        cookieBehavior: "none",
        allowList: {
          cookies: [],
          headers: [],
          queryStrings: []
        },
        realtimeLogs: {
          enabled: true,
          samplingRate: 2
        }
      },
      fileSystem: false
    },
    database: {
      default: "sqlite",
      connections: {
        sqlite: {
          database: userDatabasePath2("stacks.sqlite"),
          prefix: ""
        }
      },
      migrations: "migrations",
      migrationLocks: "migration_locks"
    },
    dns: {
      driver: "aws",
      a: [],
      aaaa: [],
      cname: [],
      mx: [],
      txt: []
    },
    docs: {
      lang: "en-US",
      title: "Stacks",
      description: "Rapid application, cloud & library framework.",
      lastUpdated: true,
      deploy: false,
      themeConfig: {
        editLink: {
          pattern: "https://github.com/stacksjs/stacks/edit/main/docs/docs/:path",
          text: "Edit this page on GitHub"
        },
        footer: {
          message: "Released under the MIT License.",
          copyright: "Copyright \xA9 2024-present Stacks.js, Inc."
        }
      }
    },
    email: {
      from: {
        name: "Stacks",
        address: "no-reply@stacksjs.org"
      },
      mailboxes: [],
      server: {
        scan: true
      }
    },
    errors: {
      messages: {
        string: "The {{ field }} field must be a string",
        email: "The {{ field }} field must be a valid email address",
        regex: "The {{ field }} field format is invalid",
        url: "The {{ field }} field must be a valid URL",
        activeUrl: "The {{ field }} field must be a valid URL",
        alpha: "The {{ field }} field must contain only letters",
        alphaNumeric: "The {{ field }} field must contain only letters and numbers",
        minLength: "The {{ field }} field must have at least {{ min }} characters",
        maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
        fixedLength: "The {{ field }} field must be {{ size }} characters long",
        confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
        endsWith: "The {{ field }} field must end with {{ substring }}",
        startsWith: "The {{ field }} field must start with {{ substring }}",
        sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
        notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
        in: "The selected {{ field }} is invalid",
        notIn: "The selected {{ field }} is invalid",
        ipAddress: "The {{ field }} field must be a valid IP address",
        uuid: "The {{ field }} field must be a valid UUID",
        ascii: "The {{ field }} field must only contain ASCII characters",
        creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
        hexCode: "The {{ field }} field must be a valid hex color code",
        iban: "The {{ field }} field must be a valid IBAN number",
        jwt: "The {{ field }} field must be a valid JWT token",
        coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
        mobile: "The {{ field }} field must be a valid mobile phone number",
        passport: "The {{ field }} field must be a valid passport number",
        postalCode: "The {{ field }} field must be a valid postal code",
        boolean: "The value must be a boolean",
        number: "The {{ field }} field must be a number",
        min: "The {{ field }} field must be at least {{ min }}",
        max: "The {{ field }} field must not be greater than {{ max }}",
        range: "The {{ field }} field must be between {{ min }} and {{ max }}",
        positive: "The {{ field }} field must be positive",
        negative: "The {{ field }} field must be negative",
        decimal: "The {{ field }} field must have {{ digits }} decimal places",
        withoutDecimals: "The {{ field }} field must not have decimal places",
        date: "The {{ field }} field must be a datetime value",
        "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
        "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
        "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
        "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
        "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
        "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
        "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
        "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
        accepted: "The {{ field }} field must be accepted",
        enum: "The selected {{ field }} is invalid",
        literal: "The {{ field }} field must be {{ expectedValue }}",
        object: "The {{ field }} field must be an object",
        record: "The {{ field }} field must be an object",
        "record.minLength": "The {{ field }} field must have at least {{ min }} items",
        "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
        "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
        array: "The {{ field }} field must be an array",
        "array.minLength": "The {{ field }} field must have at least {{ min }} items",
        "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
        "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
        notEmpty: "The {{ field }} field must not be empty",
        distinct: "The {{ field }} field has duplicate values",
        tuple: "The {{ field }} field must be an array",
        union: "Invalid value provided for {{ field }} field",
        unionGroup: "Invalid value provided for {{ field }} field",
        unionOfTypes: "Invalid value provided for {{ field }} field"
      }
    },
    git: {
      hooks: {
        "pre-commit": "lint-staged"
      },
      scopes: [
        "",
        "ci",
        "deps",
        "dx",
        "release",
        "docs",
        "test",
        "core",
        "actions",
        "arrays",
        "auth",
        "build",
        "cache",
        "cli",
        "cloud",
        "collections",
        "config",
        "database",
        "datetime",
        "docs",
        "errors",
        "git",
        "lint",
        "x-ray",
        "modules",
        "notifications",
        "objects",
        "path",
        "realtime",
        "router",
        "buddy",
        "security",
        "server",
        "storage",
        "strings",
        "tests",
        "types",
        "ui",
        "utils"
      ],
      messages: {
        type: "Select the type of change that you\u2019re committing:",
        scope: "Select the SCOPE of this change (optional):",
        customScope: "Select the SCOPE of this change:",
        subject: "Write a SHORT, IMPERATIVE tense description of the change:\n",
        body: 'Provide a LONGER description of the change (optional). Use "|" to break new line:\n',
        breaking: 'List any BREAKING CHANGES (optional). Use "|" to break new line:\n',
        footerPrefixesSelect: "Select the ISSUES type of the change list by this change (optional):",
        customFooterPrefixes: "Input ISSUES prefix:",
        footer: "List any ISSUES by this change. E.g.: #31, #34:\n",
        confirmCommit: "Are you sure you want to proceed with the commit above?"
      },
      types: [
        {
          value: "feat",
          name: "feat:     \u2728  A new feature",
          emoji: ":sparkles:"
        },
        { value: "fix", name: "fix:      \uD83D\uDC1B  A bug fix", emoji: ":bug:" },
        {
          value: "docs",
          name: "docs:     \uD83D\uDCDD  Documentation only changes",
          emoji: ":memo:"
        },
        {
          value: "style",
          name: "style:    \uD83D\uDC84  Changes that do not affect the meaning of the code",
          emoji: ":lipstick:"
        },
        {
          value: "refactor",
          name: "refactor: \u267B\uFE0F   A code change that neither fixes a bug nor adds a feature",
          emoji: ":recycle:"
        },
        {
          value: "perf",
          name: "perf:     \u26A1\uFE0F  A code change that improves performance",
          emoji: ":zap:"
        },
        {
          value: "test",
          name: "test:     \u2705  Adding missing tests or adjusting existing tests",
          emoji: ":white_check_mark:"
        },
        {
          value: "build",
          name: "build:    \uD83D\uDCE6\uFE0F  Changes that affect the build system or external dependencies",
          emoji: ":package:"
        },
        {
          value: "ci",
          name: "ci:       \uD83C\uDFA1  Changes to our CI configuration files and scripts",
          emoji: ":ferris_wheel:"
        },
        {
          value: "chore",
          name: "chore:    \uD83D\uDD28  Other changes that don\u2019t modify src or test files",
          emoji: ":hammer:"
        },
        {
          value: "revert",
          name: "revert:   \u23EA\uFE0F  Reverts a previous commit",
          emoji: ":rewind:"
        }
      ]
    },
    hashing: {
      driver: "argon2",
      bcrypt: {
        rounds: 10,
        cost: 4
      },
      argon2: {
        memory: 65536,
        time: 1
      }
    },
    library: {
      name: "hello-world",
      owner: "@stacksjs",
      repository: "stacksjs/stacks",
      license: "MIT",
      author: "Chris Breuer",
      contributors: ["Chris Breuer <chris@stacksjs.org>"],
      defaultLanguage: "en",
      vueComponents: {
        name: "hello-world-vue",
        description: "Your Vue component library description",
        keywords: ["component", "library", "vue", "vite", "typescript", "javascript"],
        tags: [
          {
            name: ["HelloWorld", "AppHelloWorld"],
            description: "The Hello World custom element, built via this framework.",
            attributes: [
              {
                name: "greeting",
                description: "The greeting."
              }
            ]
          }
        ]
      },
      webComponents: {
        name: "hello-world-elements",
        description: "Your framework agnostic web component library description.",
        keywords: ["custom-elements", "web-components", "library", "framework-agnostic", "typescript", "javascript"],
        tags: [
          {
            name: ["HelloWorld", "AppHelloWorld"],
            description: "The Hello World custom element, built via this framework.",
            attributes: [
              {
                name: "greeting",
                description: "The greeting."
              }
            ]
          }
        ]
      },
      functions: {
        name: "hello-world-fx",
        description: "Your function library description.",
        keywords: ["functions", "composables", "library", "typescript", "javascript"],
        shouldGenerateSourcemap: false,
        files: ["counter", "dark"]
      }
    },
    logging: {
      logsPath: "storage/logs/stacks.log",
      deploymentsPath: "storage/logs/deployments.log"
    },
    notification: {
      default: "email"
    },
    payment: {
      driver: "stripe"
    },
    ports: {
      frontend: 3000,
      backend: 3001,
      admin: 3002,
      library: 3003,
      desktop: 3004,
      email: 3005,
      docs: 3006,
      inspect: 3007,
      api: 3008,
      systemTray: 3009,
      database: 3010
    },
    queue: {
      default: "sync",
      connections: {
        sync: {
          driver: "sync"
        },
        database: {
          driver: "database",
          table: "jobs",
          queue: "default",
          retry_after: 90
        },
        redis: {
          driver: "redis",
          connection: "default",
          queue: "default",
          retry_after: 90
        },
        sqs: {
          driver: "sqs",
          key: "",
          secret: "",
          prefix: "",
          suffix: "",
          queue: "default",
          region: "us-east-1"
        }
      }
    },
    saas: {
      plans: [
        {
          productName: "Stacks Hobby",
          description: "All the Stacks features.",
          pricing: [
            {
              key: "stacks_hobby_monthly",
              price: 3900,
              interval: "month",
              currency: "usd"
            },
            {
              key: "stacks_hobby_yearly",
              price: 37900,
              interval: "year",
              currency: "usd"
            }
          ],
          metadata: {
            createdBy: "admin",
            version: "1.0.0"
          }
        },
        {
          productName: "Stacks Pro",
          description: "All the Stacks features, including being able to invite team members.",
          pricing: [
            {
              key: "stacks_pro_monthly",
              price: 5900,
              interval: "month",
              currency: "usd"
            },
            {
              key: "stacks_pro_yearly",
              price: 57900,
              interval: "year",
              currency: "usd"
            }
          ],
          metadata: {
            createdBy: "admin",
            version: "1.0.0"
          }
        }
      ],
      webhook: {
        endpoint: "/webhooks/stripe",
        secret: ""
      },
      currencies: ["usd"],
      coupons: [
        {
          code: "SUMMER2024",
          amountOff: 500,
          duration: "once"
        }
      ],
      products: [
        {
          name: "Stacks Pro",
          description: "All the Stacks features.",
          images: ["url_to_image"]
        }
      ]
    },
    searchEngine: {
      driver: "opensearch"
    },
    security: {
      firewall: {
        enabled: true,
        countryCodes: [],
        ipAddresses: [],
        queryString: [],
        httpHeaders: [],
        rateLimitPerMinute: 1000,
        useIpReputationLists: true,
        useKnownBadInputsRuleSet: true
      }
    },
    services: {
      aws: {
        accountId: "",
        appId: "",
        apiKey: "",
        region: "us-east-1"
      },
      algolia: {
        appId: "",
        apiKey: ""
      },
      meilisearch: {
        appId: "",
        apiKey: ""
      },
      stripe: {
        appId: "",
        apiKey: ""
      }
    },
    storage: {
      driver: "s3"
    },
    team: {
      name: "Stacks",
      members: {
        "Chris Breuer": "chris@stacksjs.org"
      }
    },
    ui: {
      shortcuts: [
        [
          "btn",
          "inline-flex items-center px-4 py-2 ml-2 border border-transparent shadow-sm text-base font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 cursor-pointer"
        ]
      ],
      safelist: "prose prose-sm m-auto text-left",
      trigger: ":stx:",
      classPrefix: "stx-",
      reset: "tailwind",
      icons: ["heroicons"],
      fonts: {
        email: {
          title: "Mona",
          text: "Hubot"
        },
        desktop: {
          title: "Mona",
          text: "Hubot"
        },
        mobile: {
          title: "Mona",
          text: "Hubot"
        },
        web: {
          title: "Mona",
          text: "Hubot"
        }
      }
    }
  };
  defaults_default2 = config4;
});
var ai_default2;
var init_ai = __esm2(() => {
  ai_default2 = {
    default: "meta.llama2-70b-chat-v1",
    models: [
      "amazon.titan-text-express-v1",
      "amazon.titan-text-lite-v1",
      "meta.llama2-70b-chat-v1"
    ],
    deploy: true
  };
});
var analytics_default2;
var init_analytics = __esm2(() => {
  analytics_default2 = {
    driver: "fathom",
    drivers: {
      googleAnalytics: {
        trackingId: "UA-XXXXXXXXX-X"
      },
      fathom: {
        siteId: "WOLZMJDL"
      }
    }
  };
});
var WORD_SEPARATORS2;
var SENTENCE_TERMINATORS2;
var TITLE_TERMINATORS2;
var SMALL_WORDS2;
var init_title_case = __esm2(() => {
  WORD_SEPARATORS2 = new Set(["\u2014", "\u2013", "-", "\u2015", "/"]);
  SENTENCE_TERMINATORS2 = new Set([".", "!", "?"]);
  TITLE_TERMINATORS2 = new Set([
    ...SENTENCE_TERMINATORS2,
    ":",
    '"',
    "\'",
    "\u201D"
  ]);
  SMALL_WORDS2 = new Set([
    "a",
    "an",
    "and",
    "as",
    "at",
    "because",
    "but",
    "by",
    "en",
    "for",
    "if",
    "in",
    "neither",
    "nor",
    "of",
    "on",
    "only",
    "or",
    "over",
    "per",
    "so",
    "some",
    "than",
    "that",
    "the",
    "to",
    "up",
    "upon",
    "v",
    "versus",
    "via",
    "vs",
    "when",
    "with",
    "without",
    "yet"
  ]);
});
function split(value) {
  let result2 = value.trim();
  result2 = result2.replace(SPLIT_LOWER_UPPER_RE, SPLIT_REPLACE_VALUE).replace(SPLIT_UPPER_UPPER_RE, SPLIT_REPLACE_VALUE);
  result2 = result2.replace(DEFAULT_STRIP_REGEXP, "\0");
  let start = 0;
  let end = result2.length;
  while (result2.charAt(start) === "\0")
    start++;
  if (start === end)
    return [];
  while (result2.charAt(end - 1) === "\0")
    end--;
  return result2.slice(start, end).split(/\0/g);
}
function noCase(input, options22) {
  const [prefix, words, suffix] = splitPrefixSuffix(input, options22);
  return prefix + words.map(lowerFactory(options22?.locale)).join(options22?.delimiter ?? " ") + suffix;
}
function pascalCase(input, options22) {
  const [prefix, words, suffix] = splitPrefixSuffix(input, options22);
  const lower = lowerFactory(options22?.locale);
  const upper = upperFactory(options22?.locale);
  const transform = options22?.mergeAmbiguousCharacters ? capitalCaseTransformFactory(lower, upper) : pascalCaseTransformFactory(lower, upper);
  return prefix + words.map(transform).join(options22?.delimiter ?? "") + suffix;
}
function kebabCase(input, options22) {
  return noCase(input, { delimiter: "-", ...options22 });
}
function snakeCase(input, options22) {
  return noCase(input, { delimiter: "_", ...options22 });
}
function lowerFactory(locale) {
  return locale === false ? (input) => input.toLowerCase() : (input) => input.toLocaleLowerCase(locale);
}
function upperFactory(locale) {
  return locale === false ? (input) => input.toUpperCase() : (input) => input.toLocaleUpperCase(locale);
}
function capitalCaseTransformFactory(lower, upper) {
  return (word) => `${upper(word[0])}${lower(word.slice(1))}`;
}
function pascalCaseTransformFactory(lower, upper) {
  return (word, index) => {
    const char0 = word[0];
    const initial = index > 0 && char0 >= "0" && char0 <= "9" ? `_${char0}` : upper(char0);
    return initial + lower(word.slice(1));
  };
}
function splitPrefixSuffix(input, options22 = {}) {
  const splitFn = options22.split ?? split;
  const prefixCharacters = options22.prefixCharacters ?? DEFAULT_PREFIX_SUFFIX_CHARACTERS;
  const suffixCharacters = options22.suffixCharacters ?? DEFAULT_PREFIX_SUFFIX_CHARACTERS;
  let prefixIndex = 0;
  let suffixIndex = input.length;
  while (prefixIndex < input.length) {
    const char = input.charAt(prefixIndex);
    if (!prefixCharacters.includes(char))
      break;
    prefixIndex++;
  }
  while (suffixIndex > prefixIndex) {
    const index = suffixIndex - 1;
    const char = input.charAt(index);
    if (!suffixCharacters.includes(char))
      break;
    suffixIndex = index;
  }
  return [
    input.slice(0, prefixIndex),
    splitFn(input.slice(prefixIndex, suffixIndex)),
    input.slice(suffixIndex)
  ];
}
var SPLIT_LOWER_UPPER_RE;
var SPLIT_UPPER_UPPER_RE;
var DEFAULT_STRIP_REGEXP;
var SPLIT_REPLACE_VALUE = "$1\0$2";
var DEFAULT_PREFIX_SUFFIX_CHARACTERS = "";
var init_case = __esm2(() => {
  init_title_case();
  SPLIT_LOWER_UPPER_RE = /([\p{Ll}\d])(\p{Lu})/gu;
  SPLIT_UPPER_UPPER_RE = /(\p{Lu})(\p{Lu}\p{Ll})/gu;
  DEFAULT_STRIP_REGEXP = /[^\p{L}\d]+/giu;
});
function sanitizeRule2(rule) {
  return typeof rule === "string" ? new RegExp(`^${rule}$`, "i") : rule;
}
function restoreCase2(word, token) {
  if (word === token)
    return token;
  if (word === word.toLowerCase())
    return token.toLowerCase();
  if (word === word.toUpperCase())
    return token.toUpperCase();
  if (word[0] === word[0].toUpperCase()) {
    return token.charAt(0).toUpperCase() + token.slice(1).toLowerCase();
  }
  return token.toLowerCase();
}
function interpolate2(str, ...args) {
  return str.replace(/\$(\d{1,2})/g, (match, index) => args[Number(index)] || "");
}
function replace2(word, rule) {
  return word.replace(rule[0], (...matchArgs) => {
    const result2 = interpolate2(rule[1], ...matchArgs);
    if (matchArgs[0] === "") {
      return restoreCase2(word[matchArgs[matchArgs.length - 2] - 1], result2);
    }
    return restoreCase2(matchArgs[0], result2);
  });
}
function sanitizeWord2(token, word, rules) {
  if (!token.length || uncountables2[token]) {
    return word;
  }
  for (let i = rules.length - 1;i >= 0; i--) {
    const rule = rules[i];
    if (rule[0].test(word))
      return replace2(word, rule);
  }
  return word;
}
function replaceWord2(replaceMap, keepMap, rules) {
  return (word) => {
    const token = word.toLowerCase();
    if (keepMap[token])
      return restoreCase2(word, token);
    if (replaceMap[token])
      return restoreCase2(word, replaceMap[token]);
    return sanitizeWord2(token, word, rules);
  };
}
function checkWord2(replaceMap, keepMap, rules) {
  return (word) => {
    const token = word.toLowerCase();
    if (keepMap[token])
      return true;
    if (replaceMap[token])
      return false;
    return sanitizeWord2(token, token, rules) === token;
  };
}
var pluralRules2;
var singularRules2;
var uncountables2;
var irregularPlurals2;
var irregularSingles2;
var pluralize2 = (word, options22 = {}) => {
  const { count = 2, inclusive = false } = options22;
  if (typeof word !== "string") {
    throw new TypeError("Word must be a string");
  }
  const pluralized = count === 1 ? pluralize2.singular(word) : pluralize2.plural(word);
  return inclusive ? `${count} ${pluralized}` : pluralized;
};
var init_pluralize = __esm2(() => {
  pluralRules2 = [];
  singularRules2 = [];
  uncountables2 = {};
  irregularPlurals2 = {};
  irregularSingles2 = {};
  pluralize2.plural = replaceWord2(irregularSingles2, irregularPlurals2, pluralRules2);
  pluralize2.isPlural = checkWord2(irregularSingles2, irregularPlurals2, pluralRules2);
  pluralize2.singular = replaceWord2(irregularPlurals2, irregularSingles2, singularRules2);
  pluralize2.isSingular = checkWord2(irregularPlurals2, irregularSingles2, singularRules2);
  pluralize2.addPluralRule = (rule, replacement) => {
    pluralRules2.push([sanitizeRule2(rule), replacement]);
  };
  pluralize2.addSingularRule = (rule, replacement) => {
    singularRules2.push([sanitizeRule2(rule), replacement]);
  };
  pluralize2.addUncountableRule = (word) => {
    if (typeof word === "string") {
      uncountables2[word.toLowerCase()] = true;
      return;
    }
    pluralize2.addPluralRule(word, "$0");
    pluralize2.addSingularRule(word, "$0");
  };
  pluralize2.addIrregularRule = (single, plural) => {
    const lowerPlural = plural.toLowerCase();
    const lowerSingle = single.toLowerCase();
    irregularSingles2[lowerSingle] = lowerPlural;
    irregularPlurals2[lowerPlural] = lowerSingle;
  };
  [
    ["I", "we"],
    ["me", "us"],
    ["he", "they"],
    ["she", "they"],
    ["them", "them"],
    ["myself", "ourselves"],
    ["yourself", "yourselves"],
    ["itself", "themselves"],
    ["herself", "themselves"],
    ["himself", "themselves"],
    ["themself", "themselves"],
    ["is", "are"],
    ["was", "were"],
    ["has", "have"],
    ["this", "these"],
    ["that", "those"],
    ["my", "our"],
    ["its", "their"],
    ["his", "their"],
    ["her", "their"],
    ["echo", "echoes"],
    ["dingo", "dingoes"],
    ["volcano", "volcanoes"],
    ["tornado", "tornadoes"],
    ["torpedo", "torpedoes"],
    ["genus", "genera"],
    ["viscus", "viscera"],
    ["stigma", "stigmata"],
    ["stoma", "stomata"],
    ["dogma", "dogmata"],
    ["lemma", "lemmata"],
    ["schema", "schemata"],
    ["anathema", "anathemata"],
    ["ox", "oxen"],
    ["axe", "axes"],
    ["die", "dice"],
    ["yes", "yeses"],
    ["foot", "feet"],
    ["eave", "eaves"],
    ["goose", "geese"],
    ["tooth", "teeth"],
    ["quiz", "quizzes"],
    ["human", "humans"],
    ["proof", "proofs"],
    ["carve", "carves"],
    ["valve", "valves"],
    ["looey", "looies"],
    ["thief", "thieves"],
    ["groove", "grooves"],
    ["pickaxe", "pickaxes"],
    ["passerby", "passersby"],
    ["canvas", "canvases"]
  ].forEach(([single, plural]) => pluralize2.addIrregularRule(single, plural));
  [
    [/s?$/i, "s"],
    [/[^\x20-\x7F]$/, "$0"],
    [/([^aeiou]ese)$/i, "$1"],
    [/(ax|test)is$/i, "$1es"],
    [/(alias|[^aou]us|t[lm]as|gas|ris)$/i, "$1es"],
    [/(e[mn]u)s?$/i, "$1s"],
    [/([^l]ias|[aeiou]las|[ejzr]as|[iu]am)$/i, "$1"],
    [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1i"],
    [/(alumn|alg|vertebr)(?:a|ae)$/i, "$1ae"],
    [/(seraph|cherub)(?:im)?$/i, "$1im"],
    [/(her|at|gr)o$/i, "$1oes"],
    [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i, "$1a"],
    [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i, "$1a"],
    [/sis$/i, "ses"],
    [/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i, "$1$2ves"],
    [/([^aeiouy]|qu)y$/i, "$1ies"],
    [/([^ch][ieo][ln])ey$/i, "$1ies"],
    [/(x|ch|ss|sh|zz)$/i, "$1es"],
    [/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i, "$1ices"],
    [/\b((?:tit)?m|l)(?:ice|ouse)$/i, "$1ice"],
    [/(pe)(?:rson|ople)$/i, "$1ople"],
    [/(child)(?:ren)?$/i, "$1ren"],
    [/eaux$/i, "$0"],
    [/m[ae]n$/i, "men"],
    ["thou", "you"]
  ].forEach(([rule, replacement]) => pluralize2.addPluralRule(rule, replacement));
  [
    [/s$/i, ""],
    [/(ss)$/i, "$1"],
    [/(wi|kni|(?:after|half|high|low|mid|non|night|\W|^)li)ves$/i, "$1fe"],
    [/(ar|(?:wo|[ae])l|[eo][ao])ves$/i, "$1f"],
    [/ies$/i, "y"],
    [/(dg|ss|ois|lk|ok|wn|mb|th|ch|ec|oal|is|ck|ix|sser|ts|wb)ies$/i, "$1ie"],
    [/\b(l|(?:neck|cross|hog|aun)?t|coll|faer|food|gen|goon|group|hipp|junk|vegg|(?:pork)?p|charl|calor|cut)ies$/i, "$1ie"],
    [/\b(mon|smil)ies$/i, "$1ey"],
    [/\b((?:tit)?m|l)ice$/i, "$1ouse"],
    [/(seraph|cherub)im$/i, "$1"],
    [/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|t[lm]as|gas|(?:her|at|gr)o|[aeiou]ris)(?:es)?$/i, "$1"],
    [/(analy|diagno|parenthe|progno|synop|the|empha|cri|ne)(?:sis|ses)$/i, "$1sis"],
    [/(movie|twelve|abuse|e[mn]u)s$/i, "$1"],
    [/(test)(?:is|es)$/i, "$1is"],
    [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1us"],
    [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i, "$1um"],
    [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i, "$1on"],
    [/(alumn|alg|vertebr)ae$/i, "$1a"],
    [/(cod|mur|sil|vert|ind)ices$/i, "$1ex"],
    [/(matr|append)ices$/i, "$1ix"],
    [/(pe)(rson|ople)$/i, "$1rson"],
    [/(child)ren$/i, "$1"],
    [/(eau)x?$/i, "$1"],
    [/men$/i, "man"]
  ].forEach(([rule, replacement]) => pluralize2.addSingularRule(rule, replacement));
  [
    "adulthood",
    "advice",
    "agenda",
    "aid",
    "aircraft",
    "alcohol",
    "ammo",
    "analytics",
    "anime",
    "athletics",
    "audio",
    "bison",
    "blood",
    "bream",
    "buffalo",
    "butter",
    "carp",
    "cash",
    "chassis",
    "chess",
    "clothing",
    "cod",
    "commerce",
    "cooperation",
    "corps",
    "debris",
    "diabetes",
    "digestion",
    "elk",
    "energy",
    "equipment",
    "excretion",
    "expertise",
    "firmware",
    "flounder",
    "fun",
    "gallows",
    "garbage",
    "graffiti",
    "hardware",
    "headquarters",
    "health",
    "herpes",
    "highjinks",
    "homework",
    "housework",
    "information",
    "jeans",
    "justice",
    "kudos",
    "labour",
    "literature",
    "machinery",
    "mackerel",
    "mail",
    "media",
    "mews",
    "moose",
    "music",
    "mud",
    "manga",
    "news",
    "only",
    "personnel",
    "pike",
    "plankton",
    "pliers",
    "police",
    "pollution",
    "premises",
    "rain",
    "research",
    "rice",
    "salmon",
    "scissors",
    "series",
    "sewage",
    "shambles",
    "shrimp",
    "software",
    "staff",
    "swine",
    "tennis",
    "traffic",
    "transportation",
    "trout",
    "tuna",
    "wealth",
    "welfare",
    "whiting",
    "wildebeest",
    "wildlife",
    "you",
    /pok[e\u00E9]mon$/i,
    /[^aeiou]ese$/i,
    /deer$/i,
    /fish$/i,
    /measles$/i,
    /o[iu]s$/i,
    /pox$/i,
    /sheep$/i
  ].forEach(pluralize2.addUncountableRule);
});
var charMap2;
var locales2;
var init_slug = __esm2(() => {
  charMap2 = JSON.parse(`{"$":"dollar","%":"percent","&":"and","<":"less",">":"greater","|":"or","\xA2":"cent","\xA3":"pound","\xA4":"currency","\xA5":"yen","\xA9":"(c)","\xAA":"a","\xAE":"(r)","\xBA":"o","\xC0":"A","\xC1":"A","\xC2":"A","\xC3":"A","\xC4":"A","\xC5":"A","\xC6":"AE","\xC7":"C","\xC8":"E","\xC9":"E","\xCA":"E","\xCB":"E","\xCC":"I","\xCD":"I","\xCE":"I","\xCF":"I","\xD0":"D","\xD1":"N","\xD2":"O","\xD3":"O","\xD4":"O","\xD5":"O","\xD6":"O","\xD8":"O","\xD9":"U","\xDA":"U","\xDB":"U","\xDC":"U","\xDD":"Y","\xDE":"TH","\xDF":"ss","\xE0":"a","\xE1":"a","\xE2":"a","\xE3":"a","\xE4":"a","\xE5":"a","\xE6":"ae","\xE7":"c","\xE8":"e","\xE9":"e","\xEA":"e","\xEB":"e","\xEC":"i","\xED":"i","\xEE":"i","\xEF":"i","\xF0":"d","\xF1":"n","\xF2":"o","\xF3":"o","\xF4":"o","\xF5":"o","\xF6":"o","\xF8":"o","\xF9":"u","\xFA":"u","\xFB":"u","\xFC":"u","\xFD":"y","\xFE":"th","\xFF":"y","\u0100":"A","\u0101":"a","\u0102":"A","\u0103":"a","\u0104":"A","\u0105":"a","\u0106":"C","\u0107":"c","\u010C":"C","\u010D":"c","\u010E":"D","\u010F":"d","\u0110":"DJ","\u0111":"dj","\u0112":"E","\u0113":"e","\u0116":"E","\u0117":"e","\u0118":"e","\u0119":"e","\u011A":"E","\u011B":"e","\u011E":"G","\u011F":"g","\u0122":"G","\u0123":"g","\u0128":"I","\u0129":"i","\u012A":"i","\u012B":"i","\u012E":"I","\u012F":"i","\u0130":"I","\u0131":"i","\u0136":"k","\u0137":"k","\u013B":"L","\u013C":"l","\u013D":"L","\u013E":"l","\u0141":"L","\u0142":"l","\u0143":"N","\u0144":"n","\u0145":"N","\u0146":"n","\u0147":"N","\u0148":"n","\u014C":"O","\u014D":"o","\u0150":"O","\u0151":"o","\u0152":"OE","\u0153":"oe","\u0154":"R","\u0155":"r","\u0158":"R","\u0159":"r","\u015A":"S","\u015B":"s","\u015E":"S","\u015F":"s","\u0160":"S","\u0161":"s","\u0162":"T","\u0163":"t","\u0164":"T","\u0165":"t","\u0168":"U","\u0169":"u","\u016A":"u","\u016B":"u","\u016E":"U","\u016F":"u","\u0170":"U","\u0171":"u","\u0172":"U","\u0173":"u","\u0174":"W","\u0175":"w","\u0176":"Y","\u0177":"y","\u0178":"Y","\u0179":"Z","\u017A":"z","\u017B":"Z","\u017C":"z","\u017D":"Z","\u017E":"z","\u018F":"E","\u0192":"f","\u01A0":"O","\u01A1":"o","\u01AF":"U","\u01B0":"u","\u01C8":"LJ","\u01C9":"lj","\u01CB":"NJ","\u01CC":"nj","\u0218":"S","\u0219":"s","\u021A":"T","\u021B":"t","\u0259":"e","\u02DA":"o","\u0386":"A","\u0388":"E","\u0389":"H","\u038A":"I","\u038C":"O","\u038E":"Y","\u038F":"W","\u0390":"i","\u0391":"A","\u0392":"B","\u0393":"G","\u0394":"D","\u0395":"E","\u0396":"Z","\u0397":"H","\u0398":"8","\u0399":"I","\u039A":"K","\u039B":"L","\u039C":"M","\u039D":"N","\u039E":"3","\u039F":"O","\u03A0":"P","\u03A1":"R","\u03A3":"S","\u03A4":"T","\u03A5":"Y","\u03A6":"F","\u03A7":"X","\u03A8":"PS","\u03A9":"W","\u03AA":"I","\u03AB":"Y","\u03AC":"a","\u03AD":"e","\u03AE":"h","\u03AF":"i","\u03B0":"y","\u03B1":"a","\u03B2":"b","\u03B3":"g","\u03B4":"d","\u03B5":"e","\u03B6":"z","\u03B7":"h","\u03B8":"8","\u03B9":"i","\u03BA":"k","\u03BB":"l","\u03BC":"m","\u03BD":"n","\u03BE":"3","\u03BF":"o","\u03C0":"p","\u03C1":"r","\u03C2":"s","\u03C3":"s","\u03C4":"t","\u03C5":"y","\u03C6":"f","\u03C7":"x","\u03C8":"ps","\u03C9":"w","\u03CA":"i","\u03CB":"y","\u03CC":"o","\u03CD":"y","\u03CE":"w","\u0401":"Yo","\u0402":"DJ","\u0404":"Ye","\u0406":"I","\u0407":"Yi","\u0408":"J","\u0409":"LJ","\u040A":"NJ","\u040B":"C","\u040F":"DZ","\u0410":"A","\u0411":"B","\u0412":"V","\u0413":"G","\u0414":"D","\u0415":"E","\u0416":"Zh","\u0417":"Z","\u0418":"I","\u0419":"J","\u041A":"K","\u041B":"L","\u041C":"M","\u041D":"N","\u041E":"O","\u041F":"P","\u0420":"R","\u0421":"S","\u0422":"T","\u0423":"U","\u0424":"F","\u0425":"H","\u0426":"C","\u0427":"Ch","\u0428":"Sh","\u0429":"Sh","\u042A":"U","\u042B":"Y","\u042C":"","\u042D":"E","\u042E":"Yu","\u042F":"Ya","\u0430":"a","\u0431":"b","\u0432":"v","\u0433":"g","\u0434":"d","\u0435":"e","\u0436":"zh","\u0437":"z","\u0438":"i","\u0439":"j","\u043A":"k","\u043B":"l","\u043C":"m","\u043D":"n","\u043E":"o","\u043F":"p","\u0440":"r","\u0441":"s","\u0442":"t","\u0443":"u","\u0444":"f","\u0445":"h","\u0446":"c","\u0447":"ch","\u0448":"sh","\u0449":"sh","\u044A":"u","\u044B":"y","\u044C":"","\u044D":"e","\u044E":"yu","\u044F":"ya","\u0451":"yo","\u0452":"dj","\u0454":"ye","\u0456":"i","\u0457":"yi","\u0458":"j","\u0459":"lj","\u045A":"nj","\u045B":"c","\u045D":"u","\u045F":"dz","\u0490":"G","\u0491":"g","\u0492":"GH","\u0493":"gh","\u049A":"KH","\u049B":"kh","\u04A2":"NG","\u04A3":"ng","\u04AE":"UE","\u04AF":"ue","\u04B0":"U","\u04B1":"u","\u04BA":"H","\u04BB":"h","\u04D8":"AE","\u04D9":"ae","\u04E8":"OE","\u04E9":"oe","\u0531":"A","\u0532":"B","\u0533":"G","\u0534":"D","\u0535":"E","\u0536":"Z","\u0537":"E'","\u0538":"Y'","\u0539":"T'","\u053A":"JH","\u053B":"I","\u053C":"L","\u053D":"X","\u053E":"C'","\u053F":"K","\u0540":"H","\u0541":"D'","\u0542":"GH","\u0543":"TW","\u0544":"M","\u0545":"Y","\u0546":"N","\u0547":"SH","\u0549":"CH","\u054A":"P","\u054B":"J","\u054C":"R'","\u054D":"S","\u054E":"V","\u054F":"T","\u0550":"R","\u0551":"C","\u0553":"P'","\u0554":"Q'","\u0555":"O''","\u0556":"F","\u0587":"EV","\u0621":"a","\u0622":"aa","\u0623":"a","\u0624":"u","\u0625":"i","\u0626":"e","\u0627":"a","\u0628":"b","\u0629":"h","\u062A":"t","\u062B":"th","\u062C":"j","\u062D":"h","\u062E":"kh","\u062F":"d","\u0630":"th","\u0631":"r","\u0632":"z","\u0633":"s","\u0634":"sh","\u0635":"s","\u0636":"dh","\u0637":"t","\u0638":"z","\u0639":"a","\u063A":"gh","\u0641":"f","\u0642":"q","\u0643":"k","\u0644":"l","\u0645":"m","\u0646":"n","\u0647":"h","\u0648":"w","\u0649":"a","\u064A":"y","\u064B":"an","\u064C":"on","\u064D":"en","\u064E":"a","\u064F":"u","\u0650":"e","\u0652":"","\u0660":"0","\u0661":"1","\u0662":"2","\u0663":"3","\u0664":"4","\u0665":"5","\u0666":"6","\u0667":"7","\u0668":"8","\u0669":"9","\u067E":"p","\u0686":"ch","\u0698":"zh","\u06A9":"k","\u06AF":"g","\u06CC":"y","\u06F0":"0","\u06F1":"1","\u06F2":"2","\u06F3":"3","\u06F4":"4","\u06F5":"5","\u06F6":"6","\u06F7":"7","\u06F8":"8","\u06F9":"9","\u0E3F":"baht","\u10D0":"a","\u10D1":"b","\u10D2":"g","\u10D3":"d","\u10D4":"e","\u10D5":"v","\u10D6":"z","\u10D7":"t","\u10D8":"i","\u10D9":"k","\u10DA":"l","\u10DB":"m","\u10DC":"n","\u10DD":"o","\u10DE":"p","\u10DF":"zh","\u10E0":"r","\u10E1":"s","\u10E2":"t","\u10E3":"u","\u10E4":"f","\u10E5":"k","\u10E6":"gh","\u10E7":"q","\u10E8":"sh","\u10E9":"ch","\u10EA":"ts","\u10EB":"dz","\u10EC":"ts","\u10ED":"ch","\u10EE":"kh","\u10EF":"j","\u10F0":"h","\u1E62":"S","\u1E63":"s","\u1E80":"W","\u1E81":"w","\u1E82":"W","\u1E83":"w","\u1E84":"W","\u1E85":"w","\u1E9E":"SS","\u1EA0":"A","\u1EA1":"a","\u1EA2":"A","\u1EA3":"a","\u1EA4":"A","\u1EA5":"a","\u1EA6":"A","\u1EA7":"a","\u1EA8":"A","\u1EA9":"a","\u1EAA":"A","\u1EAB":"a","\u1EAC":"A","\u1EAD":"a","\u1EAE":"A","\u1EAF":"a","\u1EB0":"A","\u1EB1":"a","\u1EB2":"A","\u1EB3":"a","\u1EB4":"A","\u1EB5":"a","\u1EB6":"A","\u1EB7":"a","\u1EB8":"E","\u1EB9":"e","\u1EBA":"E","\u1EBB":"e","\u1EBC":"E","\u1EBD":"e","\u1EBE":"E","\u1EBF":"e","\u1EC0":"E","\u1EC1":"e","\u1EC2":"E","\u1EC3":"e","\u1EC4":"E","\u1EC5":"e","\u1EC6":"E","\u1EC7":"e","\u1EC8":"I","\u1EC9":"i","\u1ECA":"I","\u1ECB":"i","\u1ECC":"O","\u1ECD":"o","\u1ECE":"O","\u1ECF":"o","\u1ED0":"O","\u1ED1":"o","\u1ED2":"O","\u1ED3":"o","\u1ED4":"O","\u1ED5":"o","\u1ED6":"O","\u1ED7":"o","\u1ED8":"O","\u1ED9":"o","\u1EDA":"O","\u1EDB":"o","\u1EDC":"O","\u1EDD":"o","\u1EDE":"O","\u1EDF":"o","\u1EE0":"O","\u1EE1":"o","\u1EE2":"O","\u1EE3":"o","\u1EE4":"U","\u1EE5":"u","\u1EE6":"U","\u1EE7":"u","\u1EE8":"U","\u1EE9":"u","\u1EEA":"U","\u1EEB":"u","\u1EEC":"U","\u1EED":"u","\u1EEE":"U","\u1EEF":"u","\u1EF0":"U","\u1EF1":"u","\u1EF2":"Y","\u1EF3":"y","\u1EF4":"Y","\u1EF5":"y","\u1EF6":"Y","\u1EF7":"y","\u1EF8":"Y","\u1EF9":"y","\u2013":"-","\u2018":"'","\u2019":"'","\u201C":"\\"","\u201D":"\\"","\u201E":"\\"","\u2020":"+","\u2022":"*","\u2026":"...","\u20A0":"ecu","\u20A2":"cruzeiro","\u20A3":"french franc","\u20A4":"lira","\u20A5":"mill","\u20A6":"naira","\u20A7":"peseta","\u20A8":"rupee","\u20A9":"won","\u20AA":"new shequel","\u20AB":"dong","\u20AC":"euro","\u20AD":"kip","\u20AE":"tugrik","\u20AF":"drachma","\u20B0":"penny","\u20B1":"peso","\u20B2":"guarani","\u20B3":"austral","\u20B4":"hryvnia","\u20B5":"cedi","\u20B8":"kazakhstani tenge","\u20B9":"indian rupee","\u20BA":"turkish lira","\u20BD":"russian ruble","\u20BF":"bitcoin","\u2120":"sm","\u2122":"tm","\u2202":"d","\u2206":"delta","\u2211":"sum","\u221E":"infinity","\u2665":"love","\u5143":"yuan","\u5186":"yen","\uFDFC":"rial","\uFEF5":"laa","\uFEF7":"laa","\uFEF9":"lai","\uFEFB":"la"}`);
  locales2 = JSON.parse('{"bg":{"\u0419":"Y","\u0426":"Ts","\u0429":"Sht","\u042A":"A","\u042C":"Y","\u0439":"y","\u0446":"ts","\u0449":"sht","\u044A":"a","\u044C":"y"},"de":{"\xC4":"AE","\xE4":"ae","\xD6":"OE","\xF6":"oe","\xDC":"UE","\xFC":"ue","\xDF":"ss","%":"prozent","&":"und","|":"oder","\u2211":"summe","\u221E":"unendlich","\u2665":"liebe"},"es":{"%":"por ciento","&":"y","<":"menor que",">":"mayor que","|":"o","\xA2":"centavos","\xA3":"libras","\xA4":"moneda","\u20A3":"francos","\u2211":"suma","\u221E":"infinito","\u2665":"amor"},"fr":{"%":"pourcent","&":"et","<":"plus petit",">":"plus grand","|":"ou","\xA2":"centime","\xA3":"livre","\xA4":"devise","\u20A3":"franc","\u2211":"somme","\u221E":"infini","\u2665":"amour"},"pt":{"%":"porcento","&":"e","<":"menor",">":"maior","|":"ou","\xA2":"centavo","\u2211":"soma","\xA3":"libra","\u221E":"infinito","\u2665":"amor"},"uk":{"\u0418":"Y","\u0438":"y","\u0419":"Y","\u0439":"y","\u0426":"Ts","\u0446":"ts","\u0425":"Kh","\u0445":"kh","\u0429":"Shch","\u0449":"shch","\u0413":"H","\u0433":"h"},"vi":{"\u0110":"D","\u0111":"d"},"da":{"\xD8":"OE","\xF8":"oe","\xC5":"AA","\xE5":"aa","%":"procent","&":"og","|":"eller","$":"dollar","<":"mindre end",">":"st\xF8rre end"},"nb":{"&":"og","\xC5":"AA","\xC6":"AE","\xD8":"OE","\xE5":"aa","\xE6":"ae","\xF8":"oe"},"it":{"&":"e"},"nl":{"&":"en"},"sv":{"&":"och","\xC5":"AA","\xC4":"AE","\xD6":"OE","\xE5":"aa","\xE4":"ae","\xF6":"oe"}}');
});
function makeIndentsMap(string, ignoreSingleSpaces = true) {
  const indents = new Map;
  let previousSize = 0;
  let previousIndentType;
  let key;
  for (const line of string.split(/\n/g)) {
    if (!line) {
      continue;
    }
    let indent;
    let indentType;
    let use;
    let weight;
    let entry;
    const matches = line.match(INDENT_REGEX);
    if (matches === null) {
      previousSize = 0;
      previousIndentType = "";
    } else {
      indent = matches[0].length;
      indentType = matches[1] ? INDENT_TYPE_SPACE : INDENT_TYPE_TAB;
      if (ignoreSingleSpaces && indentType === INDENT_TYPE_SPACE && indent === 1) {
        continue;
      }
      if (indentType !== previousIndentType) {
        previousSize = 0;
      }
      previousIndentType = indentType;
      use = 1;
      weight = 0;
      const indentDifference = indent - previousSize;
      previousSize = indent;
      if (indentDifference === 0) {
        use = 0;
        weight = 1;
      } else {
        const absoluteIndentDifference = indentDifference > 0 ? indentDifference : -indentDifference;
        key = encodeIndentsKey(indentType, absoluteIndentDifference);
      }
      entry = indents.get(key);
      entry = entry === undefined ? [1, 0] : [entry[0] + use, entry[1] + weight];
      indents.set(key, entry);
    }
  }
  return indents;
}
function encodeIndentsKey(indentType, indentAmount) {
  const typeCharacter = indentType === INDENT_TYPE_SPACE ? "s" : "t";
  return typeCharacter + String(indentAmount);
}
function decodeIndentsKey(indentsKey) {
  const keyHasTypeSpace = indentsKey[0] === "s";
  const type = keyHasTypeSpace ? INDENT_TYPE_SPACE : INDENT_TYPE_TAB;
  const amount = Number(indentsKey.slice(1));
  return { type, amount };
}
function getMostUsedKey(indents) {
  let result2;
  let maxUsed = 0;
  let maxWeight = 0;
  for (const [key, [usedCount, weight]] of indents) {
    if (usedCount > maxUsed || usedCount === maxUsed && weight > maxWeight) {
      maxUsed = usedCount;
      maxWeight = weight;
      result2 = key;
    }
  }
  return result2;
}
function makeIndentString(type, amount) {
  const indentCharacter = type === INDENT_TYPE_SPACE ? " " : "\t";
  return indentCharacter.repeat(amount);
}
function detectIndent(string) {
  if (typeof string !== "string") {
    throw new TypeError("Expected a string");
  }
  let indents = makeIndentsMap(string, true);
  if (indents.size === 0) {
    indents = makeIndentsMap(string, false);
  }
  const keyOfMostUsedIndent = getMostUsedKey(indents);
  let type;
  let amount = 0;
  let indent = "";
  if (keyOfMostUsedIndent !== undefined) {
    ({ type, amount } = decodeIndentsKey(keyOfMostUsedIndent));
    indent = makeIndentString(type, amount);
  }
  return {
    amount,
    type,
    indent
  };
}
var INDENT_REGEX;
var INDENT_TYPE_SPACE = "space";
var INDENT_TYPE_TAB = "tab";
var init_detect_indent = __esm2(() => {
  INDENT_REGEX = /^(?:( )+|\t+)/;
});
function detectNewline(string) {
  if (typeof string !== "string") {
    throw new TypeError("Expected a string");
  }
  const newlines = string.match(/\r?\n/g) || [];
  if (newlines.length === 0) {
    return;
  }
  const crlf = newlines.filter((newline) => newline === "\r\n").length;
  const lf = newlines.length - crlf;
  return crlf > lf ? "\r\n" : "\n";
}
var init_utils2 = __esm2(() => {
  init_slug();
  init_detect_indent();
});
var init_macro = __esm2(() => {
  init_case();
  init_pluralize();
  init_utils2();
});
var init_string = __esm2(() => {
  init_case();
  init_macro();
  init_pluralize();
  init_slug();
  init_utils2();
});
var init_src = __esm2(() => {
  init_string();
  init_string();
});
var init_cron_jobs = () => {
};
var init_docs = () => {
};
var init_exit_code = () => {
};
var init_helpers = __esm2(() => {
  init_src();
});
var init_src2 = __esm2(() => {
  init_cron_jobs();
  init_docs();
  init_exit_code();
  init_helpers();
});
function isString2(val2) {
  return typeof val2 === "string";
}
var init_is = __esm2(() => {
  init_src();
  init_src2();
});
function reportError(errors22) {
  messages2 = errors22;
}
var messages2;
var init_reporter = __esm2(() => {
  messages2 = [];
});
var messages22;
var fields2;
var init_chunk_577THMJC = __esm2(() => {
  messages22 = {
    required: "The {{ field }} field must be defined",
    string: "The {{ field }} field must be a string",
    email: "The {{ field }} field must be a valid email address",
    mobile: "The {{ field }} field must be a valid mobile phone number",
    creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
    passport: "The {{ field }} field must be a valid passport number",
    postalCode: "The {{ field }} field must be a valid postal code",
    regex: "The {{ field }} field format is invalid",
    ascii: "The {{ field }} field must only contain ASCII characters",
    iban: "The {{ field }} field must be a valid IBAN number",
    jwt: "The {{ field }} field must be a valid JWT token",
    coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
    url: "The {{ field }} field must be a valid URL",
    activeUrl: "The {{ field }} field must be a valid URL",
    alpha: "The {{ field }} field must contain only letters",
    alphaNumeric: "The {{ field }} field must contain only letters and numbers",
    minLength: "The {{ field }} field must have at least {{ min }} characters",
    maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
    fixedLength: "The {{ field }} field must be {{ size }} characters long",
    confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
    endsWith: "The {{ field }} field must end with {{ substring }}",
    startsWith: "The {{ field }} field must start with {{ substring }}",
    sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
    notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
    in: "The selected {{ field }} is invalid",
    notIn: "The selected {{ field }} is invalid",
    ipAddress: "The {{ field }} field must be a valid IP address",
    uuid: "The {{ field }} field must be a valid UUID",
    hexCode: "The {{ field }} field must be a valid hex color code",
    boolean: "The value must be a boolean",
    number: "The {{ field }} field must be a number",
    "number.in": "The selected {{ field }} is not in {{ values }}",
    min: "The {{ field }} field must be at least {{ min }}",
    max: "The {{ field }} field must not be greater than {{ max }}",
    range: "The {{ field }} field must be between {{ min }} and {{ max }}",
    positive: "The {{ field }} field must be positive",
    negative: "The {{ field }} field must be negative",
    decimal: "The {{ field }} field must have {{ digits }} decimal places",
    withoutDecimals: "The {{ field }} field must be an integer",
    accepted: "The {{ field }} field must be accepted",
    enum: "The selected {{ field }} is invalid",
    literal: "The {{ field }} field must be {{ expectedValue }}",
    object: "The {{ field }} field must be an object",
    array: "The {{ field }} field must be an array",
    "array.minLength": "The {{ field }} field must have at least {{ min }} items",
    "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
    "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
    notEmpty: "The {{ field }} field must not be empty",
    distinct: "The {{ field }} field has duplicate values",
    record: "The {{ field }} field must be an object",
    "record.minLength": "The {{ field }} field must have at least {{ min }} items",
    "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
    "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
    tuple: "The {{ field }} field must be an array",
    union: "Invalid value provided for {{ field }} field",
    unionGroup: "Invalid value provided for {{ field }} field",
    unionOfTypes: "Invalid value provided for {{ field }} field",
    date: "The {{ field }} field must be a datetime value",
    "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
    "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
    "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
    "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
    "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
    "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
    "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
    "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
    "date.afterOrSameAs": "The {{ field }} field must be a date after or same as {{ otherField }}",
    "date.beforeField": "The {{ field }} field must be a date before {{ otherField }}",
    "date.beforeOrSameAs": "The {{ field }} field must be a date before or same as {{ otherField }}",
    "date.weekend": "The {{ field }} field is not a weekend",
    "date.weekday": "The {{ field }} field is not a weekday"
  };
  fields2 = {
    "": "data"
  };
});
var __defProp23;
var __export22 = (target, all) => {
  for (var name in all)
    __defProp23(target, name, { get: all[name], enumerable: true });
};
var init_chunk_CSAU5B4Q = __esm2(() => {
  __defProp23 = Object.defineProperty;
});
function dlv_es_default2(t, e, l3, n, r2) {
  for (e = e.split ? e.split(".") : e, n = 0;n < e.length; n++)
    t = t ? t[e[n]] : r2;
  return t === r2 ? l3 : t;
}
var require_assertString2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = assertString;
  function _typeof(o) {
    "@babel/helpers - typeof";
    return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o2) {
      return typeof o2;
    } : function(o2) {
      return o2 && typeof Symbol == "function" && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
    }, _typeof(o);
  }
  function assertString(input) {
    var isString22 = typeof input === "string" || input instanceof String;
    if (!isString22) {
      var invalidType = _typeof(input);
      if (input === null)
        invalidType = "null";
      else if (invalidType === "object")
        invalidType = input.constructor.name;
      throw new TypeError("Expected a string but received a ".concat(invalidType));
    }
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isIP2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isIP;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var IPv4SegmentFormat = "(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])";
  var IPv4AddressFormat = "(".concat(IPv4SegmentFormat, "[.]){3}").concat(IPv4SegmentFormat);
  var IPv4AddressRegExp = new RegExp("^".concat(IPv4AddressFormat, "$"));
  var IPv6SegmentFormat = "(?:[0-9a-fA-F]{1,4})";
  var IPv6AddressRegExp = new RegExp("^(" + "(?:".concat(IPv6SegmentFormat, ":){7}(?:").concat(IPv6SegmentFormat, "|:)|") + "(?:".concat(IPv6SegmentFormat, ":){6}(?:").concat(IPv4AddressFormat, "|:").concat(IPv6SegmentFormat, "|:)|") + "(?:".concat(IPv6SegmentFormat, ":){5}(?::").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,2}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){4}(?:(:").concat(IPv6SegmentFormat, "){0,1}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,3}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){3}(?:(:").concat(IPv6SegmentFormat, "){0,2}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,4}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){2}(?:(:").concat(IPv6SegmentFormat, "){0,3}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,5}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){1}(?:(:").concat(IPv6SegmentFormat, "){0,4}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,6}|:)|") + "(?::((?::".concat(IPv6SegmentFormat, "){0,5}:").concat(IPv4AddressFormat, "|(?::").concat(IPv6SegmentFormat, "){1,7}|:))") + ")(%[0-9a-zA-Z-.:]{1,})?$");
  function isIP(str) {
    var version = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
    (0, _assertString.default)(str);
    version = String(version);
    if (!version) {
      return isIP(str, 4) || isIP(str, 6);
    }
    if (version === "4") {
      return IPv4AddressRegExp.test(str);
    }
    if (version === "6") {
      return IPv6AddressRegExp.test(str);
    }
    return false;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_merge2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = merge;
  function merge() {
    var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var defaults = arguments.length > 1 ? arguments[1] : undefined;
    for (var key in defaults) {
      if (typeof obj[key] === "undefined") {
        obj[key] = defaults[key];
      }
    }
    return obj;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isBase642 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isBase64;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _merge = _interopRequireDefault(require_merge2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var notBase64 = /[^A-Z0-9+\/=]/i;
  var urlSafeBase64 = /^[A-Z0-9_\-]*$/i;
  var defaultBase64Options = {
    urlSafe: false
  };
  function isBase64(str, options22) {
    (0, _assertString.default)(str);
    options22 = (0, _merge.default)(options22, defaultBase64Options);
    var len = str.length;
    if (options22.urlSafe) {
      return urlSafeBase64.test(str);
    }
    if (len % 4 !== 0 || notBase64.test(str)) {
      return false;
    }
    var firstPaddingChar = str.indexOf("=");
    return firstPaddingChar === -1 || firstPaddingChar === len - 1 || firstPaddingChar === len - 2 && str[len - 1] === "=";
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isJWT2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isJWT;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _isBase = _interopRequireDefault(require_isBase642());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isJWT(str) {
    (0, _assertString.default)(str);
    var dotSplit = str.split(".");
    var len = dotSplit.length;
    if (len !== 3) {
      return false;
    }
    return dotSplit.reduce(function(acc, currElem) {
      return acc && (0, _isBase.default)(currElem, {
        urlSafe: true
      });
    }, true);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isFQDN2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isFQDN;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _merge = _interopRequireDefault(require_merge2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_fqdn_options = {
    require_tld: true,
    allow_underscores: false,
    allow_trailing_dot: false,
    allow_numeric_tld: false,
    allow_wildcard: false,
    ignore_max_length: false
  };
  function isFQDN(str, options22) {
    (0, _assertString.default)(str);
    options22 = (0, _merge.default)(options22, default_fqdn_options);
    if (options22.allow_trailing_dot && str[str.length - 1] === ".") {
      str = str.substring(0, str.length - 1);
    }
    if (options22.allow_wildcard === true && str.indexOf("*.") === 0) {
      str = str.substring(2);
    }
    var parts = str.split(".");
    var tld = parts[parts.length - 1];
    if (options22.require_tld) {
      if (parts.length < 2) {
        return false;
      }
      if (!options22.allow_numeric_tld && !/^([a-z\u00A1-\u00A8\u00AA-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}|xn[a-z0-9-]{2,})$/i.test(tld)) {
        return false;
      }
      if (/\s/.test(tld)) {
        return false;
      }
    }
    if (!options22.allow_numeric_tld && /^\d+$/.test(tld)) {
      return false;
    }
    return parts.every(function(part) {
      if (part.length > 63 && !options22.ignore_max_length) {
        return false;
      }
      if (!/^[a-z_\u00a1-\uffff0-9-]+$/i.test(part)) {
        return false;
      }
      if (/[\uff01-\uff5e]/.test(part)) {
        return false;
      }
      if (/^-|-$/.test(part)) {
        return false;
      }
      if (!options22.allow_underscores && /_/.test(part)) {
        return false;
      }
      return true;
    });
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isURL2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isURL;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _isFQDN = _interopRequireDefault(require_isFQDN2());
  var _isIP = _interopRequireDefault(require_isIP2());
  var _merge = _interopRequireDefault(require_merge2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }
  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o)
      return;
    if (typeof o === "string")
      return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor)
      n = o.constructor.name;
    if (n === "Map" || n === "Set")
      return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i = 0, arr2 = new Array(len);i < len; i++)
      arr2[i] = arr[i];
    return arr2;
  }
  function _iterableToArrayLimit(r2, l3) {
    var t = r2 == null ? null : typeof Symbol != "undefined" && r2[Symbol.iterator] || r2["@@iterator"];
    if (t != null) {
      var e, n, i, u, a = [], f3 = true, o = false;
      try {
        if (i = (t = t.call(r2)).next, l3 === 0) {
          if (Object(t) !== t)
            return;
          f3 = false;
        } else
          for (;!(f3 = (e = i.call(t)).done) && (a.push(e.value), a.length !== l3); f3 = true)
            ;
      } catch (r22) {
        o = true, n = r22;
      } finally {
        try {
          if (!f3 && t.return != null && (u = t.return(), Object(u) !== u))
            return;
        } finally {
          if (o)
            throw n;
        }
      }
      return a;
    }
  }
  function _arrayWithHoles(arr) {
    if (Array.isArray(arr))
      return arr;
  }
  var default_url_options = {
    protocols: ["http", "https", "ftp"],
    require_tld: true,
    require_protocol: false,
    require_host: true,
    require_port: false,
    require_valid_protocol: true,
    allow_underscores: false,
    allow_trailing_dot: false,
    allow_protocol_relative_urls: false,
    allow_fragments: true,
    allow_query_components: true,
    validate_length: true
  };
  var wrapped_ipv6 = /^\[([^\]]+)\](?::([0-9]+))?$/;
  function isRegExp(obj) {
    return Object.prototype.toString.call(obj) === "[object RegExp]";
  }
  function checkHost(host, matches) {
    for (var i = 0;i < matches.length; i++) {
      var match = matches[i];
      if (host === match || isRegExp(match) && match.test(host)) {
        return true;
      }
    }
    return false;
  }
  function isURL(url, options22) {
    (0, _assertString.default)(url);
    if (!url || /[\s<>]/.test(url)) {
      return false;
    }
    if (url.indexOf("mailto:") === 0) {
      return false;
    }
    options22 = (0, _merge.default)(options22, default_url_options);
    if (options22.validate_length && url.length >= 2083) {
      return false;
    }
    if (!options22.allow_fragments && url.includes("#")) {
      return false;
    }
    if (!options22.allow_query_components && (url.includes("?") || url.includes("&"))) {
      return false;
    }
    var protocol, auth, host, hostname, port, port_str, split2, ipv6;
    split2 = url.split("#");
    url = split2.shift();
    split2 = url.split("?");
    url = split2.shift();
    split2 = url.split("://");
    if (split2.length > 1) {
      protocol = split2.shift().toLowerCase();
      if (options22.require_valid_protocol && options22.protocols.indexOf(protocol) === -1) {
        return false;
      }
    } else if (options22.require_protocol) {
      return false;
    } else if (url.slice(0, 2) === "//") {
      if (!options22.allow_protocol_relative_urls) {
        return false;
      }
      split2[0] = url.slice(2);
    }
    url = split2.join("://");
    if (url === "") {
      return false;
    }
    split2 = url.split("/");
    url = split2.shift();
    if (url === "" && !options22.require_host) {
      return true;
    }
    split2 = url.split("@");
    if (split2.length > 1) {
      if (options22.disallow_auth) {
        return false;
      }
      if (split2[0] === "") {
        return false;
      }
      auth = split2.shift();
      if (auth.indexOf(":") >= 0 && auth.split(":").length > 2) {
        return false;
      }
      var _auth$split = auth.split(":"), _auth$split2 = _slicedToArray(_auth$split, 2), user = _auth$split2[0], password = _auth$split2[1];
      if (user === "" && password === "") {
        return false;
      }
    }
    hostname = split2.join("@");
    port_str = null;
    ipv6 = null;
    var ipv6_match = hostname.match(wrapped_ipv6);
    if (ipv6_match) {
      host = "";
      ipv6 = ipv6_match[1];
      port_str = ipv6_match[2] || null;
    } else {
      split2 = hostname.split(":");
      host = split2.shift();
      if (split2.length) {
        port_str = split2.join(":");
      }
    }
    if (port_str !== null && port_str.length > 0) {
      port = parseInt(port_str, 10);
      if (!/^[0-9]+$/.test(port_str) || port <= 0 || port > 65535) {
        return false;
      }
    } else if (options22.require_port) {
      return false;
    }
    if (options22.host_whitelist) {
      return checkHost(host, options22.host_whitelist);
    }
    if (host === "" && !options22.require_host) {
      return true;
    }
    if (!(0, _isIP.default)(host) && !(0, _isFQDN.default)(host, options22) && (!ipv6 || !(0, _isIP.default)(ipv6, 6))) {
      return false;
    }
    host = host || ipv6;
    if (options22.host_blacklist && checkHost(host, options22.host_blacklist)) {
      return false;
    }
    return true;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isSlug2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isSlug;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var charsetRegex = /^[^\s-_](?!.*?[-_]{2,})[a-z0-9-\\][^\s]*[^-_\s]$/;
  function isSlug(str) {
    (0, _assertString.default)(str);
    return charsetRegex.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isIBAN2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isIBAN;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var ibanRegexThroughCountryCode = {
    AD: /^(AD[0-9]{2})\d{8}[A-Z0-9]{12}$/,
    AE: /^(AE[0-9]{2})\d{3}\d{16}$/,
    AL: /^(AL[0-9]{2})\d{8}[A-Z0-9]{16}$/,
    AT: /^(AT[0-9]{2})\d{16}$/,
    AZ: /^(AZ[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    BA: /^(BA[0-9]{2})\d{16}$/,
    BE: /^(BE[0-9]{2})\d{12}$/,
    BG: /^(BG[0-9]{2})[A-Z]{4}\d{6}[A-Z0-9]{8}$/,
    BH: /^(BH[0-9]{2})[A-Z]{4}[A-Z0-9]{14}$/,
    BR: /^(BR[0-9]{2})\d{23}[A-Z]{1}[A-Z0-9]{1}$/,
    BY: /^(BY[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    CH: /^(CH[0-9]{2})\d{5}[A-Z0-9]{12}$/,
    CR: /^(CR[0-9]{2})\d{18}$/,
    CY: /^(CY[0-9]{2})\d{8}[A-Z0-9]{16}$/,
    CZ: /^(CZ[0-9]{2})\d{20}$/,
    DE: /^(DE[0-9]{2})\d{18}$/,
    DK: /^(DK[0-9]{2})\d{14}$/,
    DO: /^(DO[0-9]{2})[A-Z]{4}\d{20}$/,
    DZ: /^(DZ\d{24})$/,
    EE: /^(EE[0-9]{2})\d{16}$/,
    EG: /^(EG[0-9]{2})\d{25}$/,
    ES: /^(ES[0-9]{2})\d{20}$/,
    FI: /^(FI[0-9]{2})\d{14}$/,
    FO: /^(FO[0-9]{2})\d{14}$/,
    FR: /^(FR[0-9]{2})\d{10}[A-Z0-9]{11}\d{2}$/,
    GB: /^(GB[0-9]{2})[A-Z]{4}\d{14}$/,
    GE: /^(GE[0-9]{2})[A-Z0-9]{2}\d{16}$/,
    GI: /^(GI[0-9]{2})[A-Z]{4}[A-Z0-9]{15}$/,
    GL: /^(GL[0-9]{2})\d{14}$/,
    GR: /^(GR[0-9]{2})\d{7}[A-Z0-9]{16}$/,
    GT: /^(GT[0-9]{2})[A-Z0-9]{4}[A-Z0-9]{20}$/,
    HR: /^(HR[0-9]{2})\d{17}$/,
    HU: /^(HU[0-9]{2})\d{24}$/,
    IE: /^(IE[0-9]{2})[A-Z0-9]{4}\d{14}$/,
    IL: /^(IL[0-9]{2})\d{19}$/,
    IQ: /^(IQ[0-9]{2})[A-Z]{4}\d{15}$/,
    IR: /^(IR[0-9]{2})0\d{2}0\d{18}$/,
    IS: /^(IS[0-9]{2})\d{22}$/,
    IT: /^(IT[0-9]{2})[A-Z]{1}\d{10}[A-Z0-9]{12}$/,
    JO: /^(JO[0-9]{2})[A-Z]{4}\d{22}$/,
    KW: /^(KW[0-9]{2})[A-Z]{4}[A-Z0-9]{22}$/,
    KZ: /^(KZ[0-9]{2})\d{3}[A-Z0-9]{13}$/,
    LB: /^(LB[0-9]{2})\d{4}[A-Z0-9]{20}$/,
    LC: /^(LC[0-9]{2})[A-Z]{4}[A-Z0-9]{24}$/,
    LI: /^(LI[0-9]{2})\d{5}[A-Z0-9]{12}$/,
    LT: /^(LT[0-9]{2})\d{16}$/,
    LU: /^(LU[0-9]{2})\d{3}[A-Z0-9]{13}$/,
    LV: /^(LV[0-9]{2})[A-Z]{4}[A-Z0-9]{13}$/,
    MA: /^(MA[0-9]{26})$/,
    MC: /^(MC[0-9]{2})\d{10}[A-Z0-9]{11}\d{2}$/,
    MD: /^(MD[0-9]{2})[A-Z0-9]{20}$/,
    ME: /^(ME[0-9]{2})\d{18}$/,
    MK: /^(MK[0-9]{2})\d{3}[A-Z0-9]{10}\d{2}$/,
    MR: /^(MR[0-9]{2})\d{23}$/,
    MT: /^(MT[0-9]{2})[A-Z]{4}\d{5}[A-Z0-9]{18}$/,
    MU: /^(MU[0-9]{2})[A-Z]{4}\d{19}[A-Z]{3}$/,
    MZ: /^(MZ[0-9]{2})\d{21}$/,
    NL: /^(NL[0-9]{2})[A-Z]{4}\d{10}$/,
    NO: /^(NO[0-9]{2})\d{11}$/,
    PK: /^(PK[0-9]{2})[A-Z0-9]{4}\d{16}$/,
    PL: /^(PL[0-9]{2})\d{24}$/,
    PS: /^(PS[0-9]{2})[A-Z0-9]{4}\d{21}$/,
    PT: /^(PT[0-9]{2})\d{21}$/,
    QA: /^(QA[0-9]{2})[A-Z]{4}[A-Z0-9]{21}$/,
    RO: /^(RO[0-9]{2})[A-Z]{4}[A-Z0-9]{16}$/,
    RS: /^(RS[0-9]{2})\d{18}$/,
    SA: /^(SA[0-9]{2})\d{2}[A-Z0-9]{18}$/,
    SC: /^(SC[0-9]{2})[A-Z]{4}\d{20}[A-Z]{3}$/,
    SE: /^(SE[0-9]{2})\d{20}$/,
    SI: /^(SI[0-9]{2})\d{15}$/,
    SK: /^(SK[0-9]{2})\d{20}$/,
    SM: /^(SM[0-9]{2})[A-Z]{1}\d{10}[A-Z0-9]{12}$/,
    SV: /^(SV[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    TL: /^(TL[0-9]{2})\d{19}$/,
    TN: /^(TN[0-9]{2})\d{20}$/,
    TR: /^(TR[0-9]{2})\d{5}[A-Z0-9]{17}$/,
    UA: /^(UA[0-9]{2})\d{6}[A-Z0-9]{19}$/,
    VA: /^(VA[0-9]{2})\d{18}$/,
    VG: /^(VG[0-9]{2})[A-Z0-9]{4}\d{16}$/,
    XK: /^(XK[0-9]{2})\d{16}$/
  };
  function hasOnlyValidCountryCodes(countryCodeArray) {
    var countryCodeArrayFilteredWithObjectIbanCode = countryCodeArray.filter(function(countryCode) {
      return !(countryCode in ibanRegexThroughCountryCode);
    });
    if (countryCodeArrayFilteredWithObjectIbanCode.length > 0) {
      return false;
    }
    return true;
  }
  function hasValidIbanFormat(str, options22) {
    var strippedStr = str.replace(/[\s\-]+/gi, "").toUpperCase();
    var isoCountryCode = strippedStr.slice(0, 2).toUpperCase();
    var isoCountryCodeInIbanRegexCodeObject = isoCountryCode in ibanRegexThroughCountryCode;
    if (options22.whitelist) {
      if (!hasOnlyValidCountryCodes(options22.whitelist)) {
        return false;
      }
      var isoCountryCodeInWhiteList = options22.whitelist.includes(isoCountryCode);
      if (!isoCountryCodeInWhiteList) {
        return false;
      }
    }
    if (options22.blacklist) {
      var isoCountryCodeInBlackList = options22.blacklist.includes(isoCountryCode);
      if (isoCountryCodeInBlackList) {
        return false;
      }
    }
    return isoCountryCodeInIbanRegexCodeObject && ibanRegexThroughCountryCode[isoCountryCode].test(strippedStr);
  }
  function hasValidIbanChecksum(str) {
    var strippedStr = str.replace(/[^A-Z0-9]+/gi, "").toUpperCase();
    var rearranged = strippedStr.slice(4) + strippedStr.slice(0, 4);
    var alphaCapsReplacedWithDigits = rearranged.replace(/[A-Z]/g, function(char) {
      return char.charCodeAt(0) - 55;
    });
    var remainder = alphaCapsReplacedWithDigits.match(/\d{1,7}/g).reduce(function(acc, value) {
      return Number(acc + value) % 97;
    }, "");
    return remainder === 1;
  }
  function isIBAN(str) {
    var options22 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _assertString.default)(str);
    return hasValidIbanFormat(str, options22) && hasValidIbanChecksum(str);
  }
  var locales22 = exports.locales = Object.keys(ibanRegexThroughCountryCode);
});
var require_isUUID2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isUUID;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var uuid = {
    1: /^[0-9A-F]{8}-[0-9A-F]{4}-1[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    2: /^[0-9A-F]{8}-[0-9A-F]{4}-2[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    3: /^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    4: /^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    5: /^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    7: /^[0-9A-F]{8}-[0-9A-F]{4}-7[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    all: /^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i
  };
  function isUUID(str, version) {
    (0, _assertString.default)(str);
    var pattern = uuid[![undefined, null].includes(version) ? version : "all"];
    return !!pattern && pattern.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isAscii2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAscii;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var ascii = /^[\x00-\x7F]+$/;
  function isAscii(str) {
    (0, _assertString.default)(str);
    return ascii.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isByteLength2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isByteLength;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function _typeof(o) {
    "@babel/helpers - typeof";
    return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o2) {
      return typeof o2;
    } : function(o2) {
      return o2 && typeof Symbol == "function" && o2.constructor === Symbol && o2 !== Symbol.prototype ? "symbol" : typeof o2;
    }, _typeof(o);
  }
  function isByteLength(str, options22) {
    (0, _assertString.default)(str);
    var min;
    var max;
    if (_typeof(options22) === "object") {
      min = options22.min || 0;
      max = options22.max;
    } else {
      min = arguments[1];
      max = arguments[2];
    }
    var len = encodeURI(str).split(/%..|./).length - 1;
    return len >= min && (typeof max === "undefined" || len <= max);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isEmail2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isEmail;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _isByteLength = _interopRequireDefault(require_isByteLength2());
  var _isFQDN = _interopRequireDefault(require_isFQDN2());
  var _isIP = _interopRequireDefault(require_isIP2());
  var _merge = _interopRequireDefault(require_merge2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_email_options = {
    allow_display_name: false,
    allow_underscores: false,
    require_display_name: false,
    allow_utf8_local_part: true,
    require_tld: true,
    blacklisted_chars: "",
    ignore_max_length: false,
    host_blacklist: [],
    host_whitelist: []
  };
  var splitNameAddress = /^([^\x00-\x1F\x7F-\x9F\cX]+)</i;
  var emailUserPart = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i;
  var gmailUserPart = /^[a-z\d]+$/;
  var quotedEmailUser = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i;
  var emailUserUtf8Part = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A1-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i;
  var quotedEmailUserUtf8 = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i;
  var defaultMaxEmailLength = 254;
  function validateDisplayName(display_name) {
    var display_name_without_quotes = display_name.replace(/^"(.+)"$/, "$1");
    if (!display_name_without_quotes.trim()) {
      return false;
    }
    var contains_illegal = /[\.";<>]/.test(display_name_without_quotes);
    if (contains_illegal) {
      if (display_name_without_quotes === display_name) {
        return false;
      }
      var all_start_with_back_slash = display_name_without_quotes.split('"').length === display_name_without_quotes.split('\\"').length;
      if (!all_start_with_back_slash) {
        return false;
      }
    }
    return true;
  }
  function isEmail(str, options22) {
    (0, _assertString.default)(str);
    options22 = (0, _merge.default)(options22, default_email_options);
    if (options22.require_display_name || options22.allow_display_name) {
      var display_email = str.match(splitNameAddress);
      if (display_email) {
        var display_name = display_email[1];
        str = str.replace(display_name, "").replace(/(^<|>$)/g, "");
        if (display_name.endsWith(" ")) {
          display_name = display_name.slice(0, -1);
        }
        if (!validateDisplayName(display_name)) {
          return false;
        }
      } else if (options22.require_display_name) {
        return false;
      }
    }
    if (!options22.ignore_max_length && str.length > defaultMaxEmailLength) {
      return false;
    }
    var parts = str.split("@");
    var domain = parts.pop();
    var lower_domain = domain.toLowerCase();
    if (options22.host_blacklist.includes(lower_domain)) {
      return false;
    }
    if (options22.host_whitelist.length > 0 && !options22.host_whitelist.includes(lower_domain)) {
      return false;
    }
    var user = parts.join("@");
    if (options22.domain_specific_validation && (lower_domain === "gmail.com" || lower_domain === "googlemail.com")) {
      user = user.toLowerCase();
      var username = user.split("+")[0];
      if (!(0, _isByteLength.default)(username.replace(/\./g, ""), {
        min: 6,
        max: 30
      })) {
        return false;
      }
      var _user_parts = username.split(".");
      for (var i = 0;i < _user_parts.length; i++) {
        if (!gmailUserPart.test(_user_parts[i])) {
          return false;
        }
      }
    }
    if (options22.ignore_max_length === false && (!(0, _isByteLength.default)(user, {
      max: 64
    }) || !(0, _isByteLength.default)(domain, {
      max: 254
    }))) {
      return false;
    }
    if (!(0, _isFQDN.default)(domain, {
      require_tld: options22.require_tld,
      ignore_max_length: options22.ignore_max_length,
      allow_underscores: options22.allow_underscores
    })) {
      if (!options22.allow_ip_domain) {
        return false;
      }
      if (!(0, _isIP.default)(domain)) {
        if (!domain.startsWith("[") || !domain.endsWith("]")) {
          return false;
        }
        var noBracketdomain = domain.slice(1, -1);
        if (noBracketdomain.length === 0 || !(0, _isIP.default)(noBracketdomain)) {
          return false;
        }
      }
    }
    if (user[0] === '"') {
      user = user.slice(1, user.length - 1);
      return options22.allow_utf8_local_part ? quotedEmailUserUtf8.test(user) : quotedEmailUser.test(user);
    }
    var pattern = options22.allow_utf8_local_part ? emailUserUtf8Part : emailUserPart;
    var user_parts = user.split(".");
    for (var _i = 0;_i < user_parts.length; _i++) {
      if (!pattern.test(user_parts[_i])) {
        return false;
      }
    }
    if (options22.blacklisted_chars) {
      if (user.search(new RegExp("[".concat(options22.blacklisted_chars, "]+"), "g")) !== -1)
        return false;
    }
    return true;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_alpha2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.farsiLocales = exports.englishLocales = exports.dotDecimal = exports.decimal = exports.commaDecimal = exports.bengaliLocales = exports.arabicLocales = exports.alphanumeric = exports.alpha = undefined;
  var alpha = exports.alpha = {
    "en-US": /^[A-Z]+$/i,
    "az-AZ": /^[A-VXYZ\u00C7\u018F\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "bg-BG": /^[\u0410-\u042F]+$/i,
    "cs-CZ": /^[A-Z\u00C1\u010C\u010E\u00C9\u011A\u00CD\u0147\u00D3\u0158\u0160\u0164\u00DA\u016E\u00DD\u017D]+$/i,
    "da-DK": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "de-DE": /^[A-Z\u00C4\u00D6\u00DC\u00DF]+$/i,
    "el-GR": /^[\u0391-\u03CE]+$/i,
    "es-ES": /^[A-Z\u00C1\u00C9\u00CD\u00D1\u00D3\u00DA\u00DC]+$/i,
    "fa-IR": /^[\u0627\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u06CC]+$/i,
    "fi-FI": /^[A-Z\u00C5\u00C4\u00D6]+$/i,
    "fr-FR": /^[A-Z\u00C0\u00C2\u00C6\u00C7\u00C9\u00C8\u00CA\u00CB\u00CF\u00CE\u00D4\u0152\u00D9\u00DB\u00DC\u0178]+$/i,
    "it-IT": /^[A-Z\u00C0\u00C9\u00C8\u00CC\u00CE\u00D3\u00D2\u00D9]+$/i,
    "ja-JP": /^[\u3041-\u3093\u30A1-\u30F6\uFF66-\uFF9F\u4E00-\u9FA0\u30FC\u30FB\u3002\u3001]+$/i,
    "nb-NO": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "nl-NL": /^[A-Z\u00C1\u00C9\u00CB\u00CF\u00D3\u00D6\u00DC\u00DA]+$/i,
    "nn-NO": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "hu-HU": /^[A-Z\u00C1\u00C9\u00CD\u00D3\u00D6\u0150\u00DA\u00DC\u0170]+$/i,
    "pl-PL": /^[A-Z\u0104\u0106\u0118\u015A\u0141\u0143\u00D3\u017B\u0179]+$/i,
    "pt-PT": /^[A-Z\u00C3\u00C1\u00C0\u00C2\u00C4\u00C7\u00C9\u00CA\u00CB\u00CD\u00CF\u00D5\u00D3\u00D4\u00D6\u00DA\u00DC]+$/i,
    "ru-RU": /^[\u0410-\u042F\u0401]+$/i,
    "kk-KZ": /^[\u0410-\u042F\u0401\u04D8\u04B0\u0406\u04A2\u0492\u04AE\u049A\u04E8\u04BA]+$/i,
    "sl-SI": /^[A-Z\u010C\u0106\u0110\u0160\u017D]+$/i,
    "sk-SK": /^[A-Z\u00C1\u010C\u010E\u00C9\u00CD\u0147\u00D3\u0160\u0164\u00DA\u00DD\u017D\u0139\u0154\u013D\u00C4\u00D4]+$/i,
    "sr-RS@latin": /^[A-Z\u010C\u0106\u017D\u0160\u0110]+$/i,
    "sr-RS": /^[\u0410-\u042F\u0402\u0408\u0409\u040A\u040B\u040F]+$/i,
    "sv-SE": /^[A-Z\u00C5\u00C4\u00D6]+$/i,
    "th-TH": /^[\u0E01-\u0E50\s]+$/i,
    "tr-TR": /^[A-Z\u00C7\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "uk-UA": /^[\u0410-\u0429\u042C\u042E\u042F\u0404I\u0407\u0490\u0456]+$/i,
    "vi-VN": /^[A-Z\u00C0\u00C1\u1EA0\u1EA2\u00C3\u00C2\u1EA6\u1EA4\u1EAC\u1EA8\u1EAA\u0102\u1EB0\u1EAE\u1EB6\u1EB2\u1EB4\u0110\u00C8\u00C9\u1EB8\u1EBA\u1EBC\u00CA\u1EC0\u1EBE\u1EC6\u1EC2\u1EC4\u00CC\u00CD\u1ECA\u1EC8\u0128\u00D2\u00D3\u1ECC\u1ECE\u00D5\u00D4\u1ED2\u1ED0\u1ED8\u1ED4\u1ED6\u01A0\u1EDC\u1EDA\u1EE2\u1EDE\u1EE0\u00D9\u00DA\u1EE4\u1EE6\u0168\u01AF\u1EEA\u1EE8\u1EF0\u1EEC\u1EEE\u1EF2\u00DD\u1EF4\u1EF6\u1EF8]+$/i,
    "ko-KR": /^[\u3131-\u314E\u314F-\u3163\uAC00-\uD7A3]*$/,
    "ku-IQ": /^[\u0626\u0627\u0628\u067E\u062A\u062C\u0686\u062D\u062E\u062F\u0631\u0695\u0632\u0698\u0633\u0634\u0639\u063A\u0641\u06A4\u0642\u06A9\u06AF\u0644\u06B5\u0645\u0646\u0648\u06C6\u06BE\u06D5\u06CC\u06CE\u064A\u0637\u0624\u062B\u0622\u0625\u0623\u0643\u0636\u0635\u0629\u0638\u0630]+$/i,
    ar: /^[\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\u0670]+$/,
    he: /^[\u05D0-\u05EA]+$/,
    fa: /^['\u0622\u0627\u0621\u0623\u0624\u0626\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u0629\u06CC']+$/i,
    bn: /^['\u0980\u0981\u0982\u0983\u0985\u0986\u0987\u0988\u0989\u098A\u098B\u098C\u098F\u0990\u0993\u0994\u0995\u0996\u0997\u0998\u0999\u099A\u099B\u099C\u099D\u099E\u099F\u09A0\u09A1\u09A2\u09A3\u09A4\u09A5\u09A6\u09A7\u09A8\u09AA\u09AB\u09AC\u09AD\u09AE\u09AF\u09B0\u09B2\u09B6\u09B7\u09B8\u09B9\u09BC\u09BD\u09BE\u09BF\u09C0\u09C1\u09C2\u09C3\u09C4\u09C7\u09C8\u09CB\u09CC\u09CD\u09CE\u09D7\u09DC\u09DD\u09DF\u09E0\u09E1\u09E2\u09E3\u09F0\u09F1\u09F2\u09F3\u09F4\u09F5\u09F6\u09F7\u09F8\u09F9\u09FA\u09FB']+$/,
    eo: /^[ABC\u0108D-G\u011CH\u0124IJ\u0134K-PRS\u015CTU\u016CVZ]+$/i,
    "hi-IN": /^[\u0900-\u0961]+[\u0972-\u097F]*$/i,
    "si-LK": /^[\u0D80-\u0DFF]+$/
  };
  var alphanumeric = exports.alphanumeric = {
    "en-US": /^[0-9A-Z]+$/i,
    "az-AZ": /^[0-9A-VXYZ\u00C7\u018F\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "bg-BG": /^[0-9\u0410-\u042F]+$/i,
    "cs-CZ": /^[0-9A-Z\u00C1\u010C\u010E\u00C9\u011A\u00CD\u0147\u00D3\u0158\u0160\u0164\u00DA\u016E\u00DD\u017D]+$/i,
    "da-DK": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "de-DE": /^[0-9A-Z\u00C4\u00D6\u00DC\u00DF]+$/i,
    "el-GR": /^[0-9\u0391-\u03C9]+$/i,
    "es-ES": /^[0-9A-Z\u00C1\u00C9\u00CD\u00D1\u00D3\u00DA\u00DC]+$/i,
    "fi-FI": /^[0-9A-Z\u00C5\u00C4\u00D6]+$/i,
    "fr-FR": /^[0-9A-Z\u00C0\u00C2\u00C6\u00C7\u00C9\u00C8\u00CA\u00CB\u00CF\u00CE\u00D4\u0152\u00D9\u00DB\u00DC\u0178]+$/i,
    "it-IT": /^[0-9A-Z\u00C0\u00C9\u00C8\u00CC\u00CE\u00D3\u00D2\u00D9]+$/i,
    "ja-JP": /^[0-9\uFF10-\uFF19\u3041-\u3093\u30A1-\u30F6\uFF66-\uFF9F\u4E00-\u9FA0\u30FC\u30FB\u3002\u3001]+$/i,
    "hu-HU": /^[0-9A-Z\u00C1\u00C9\u00CD\u00D3\u00D6\u0150\u00DA\u00DC\u0170]+$/i,
    "nb-NO": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "nl-NL": /^[0-9A-Z\u00C1\u00C9\u00CB\u00CF\u00D3\u00D6\u00DC\u00DA]+$/i,
    "nn-NO": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "pl-PL": /^[0-9A-Z\u0104\u0106\u0118\u015A\u0141\u0143\u00D3\u017B\u0179]+$/i,
    "pt-PT": /^[0-9A-Z\u00C3\u00C1\u00C0\u00C2\u00C4\u00C7\u00C9\u00CA\u00CB\u00CD\u00CF\u00D5\u00D3\u00D4\u00D6\u00DA\u00DC]+$/i,
    "ru-RU": /^[0-9\u0410-\u042F\u0401]+$/i,
    "kk-KZ": /^[0-9\u0410-\u042F\u0401\u04D8\u04B0\u0406\u04A2\u0492\u04AE\u049A\u04E8\u04BA]+$/i,
    "sl-SI": /^[0-9A-Z\u010C\u0106\u0110\u0160\u017D]+$/i,
    "sk-SK": /^[0-9A-Z\u00C1\u010C\u010E\u00C9\u00CD\u0147\u00D3\u0160\u0164\u00DA\u00DD\u017D\u0139\u0154\u013D\u00C4\u00D4]+$/i,
    "sr-RS@latin": /^[0-9A-Z\u010C\u0106\u017D\u0160\u0110]+$/i,
    "sr-RS": /^[0-9\u0410-\u042F\u0402\u0408\u0409\u040A\u040B\u040F]+$/i,
    "sv-SE": /^[0-9A-Z\u00C5\u00C4\u00D6]+$/i,
    "th-TH": /^[\u0E01-\u0E59\s]+$/i,
    "tr-TR": /^[0-9A-Z\u00C7\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "uk-UA": /^[0-9\u0410-\u0429\u042C\u042E\u042F\u0404I\u0407\u0490\u0456]+$/i,
    "ko-KR": /^[0-9\u3131-\u314E\u314F-\u3163\uAC00-\uD7A3]*$/,
    "ku-IQ": /^[\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u06690-9\u0626\u0627\u0628\u067E\u062A\u062C\u0686\u062D\u062E\u062F\u0631\u0695\u0632\u0698\u0633\u0634\u0639\u063A\u0641\u06A4\u0642\u06A9\u06AF\u0644\u06B5\u0645\u0646\u0648\u06C6\u06BE\u06D5\u06CC\u06CE\u064A\u0637\u0624\u062B\u0622\u0625\u0623\u0643\u0636\u0635\u0629\u0638\u0630]+$/i,
    "vi-VN": /^[0-9A-Z\u00C0\u00C1\u1EA0\u1EA2\u00C3\u00C2\u1EA6\u1EA4\u1EAC\u1EA8\u1EAA\u0102\u1EB0\u1EAE\u1EB6\u1EB2\u1EB4\u0110\u00C8\u00C9\u1EB8\u1EBA\u1EBC\u00CA\u1EC0\u1EBE\u1EC6\u1EC2\u1EC4\u00CC\u00CD\u1ECA\u1EC8\u0128\u00D2\u00D3\u1ECC\u1ECE\u00D5\u00D4\u1ED2\u1ED0\u1ED8\u1ED4\u1ED6\u01A0\u1EDC\u1EDA\u1EE2\u1EDE\u1EE0\u00D9\u00DA\u1EE4\u1EE6\u0168\u01AF\u1EEA\u1EE8\u1EF0\u1EEC\u1EEE\u1EF2\u00DD\u1EF4\u1EF6\u1EF8]+$/i,
    ar: /^[\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u06690-9\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\u0670]+$/,
    he: /^[0-9\u05D0-\u05EA]+$/,
    fa: /^['0-9\u0622\u0627\u0621\u0623\u0624\u0626\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u0629\u06CC\u06F1\u06F2\u06F3\u06F4\u06F5\u06F6\u06F7\u06F8\u06F9\u06F0']+$/i,
    bn: /^['\u0980\u0981\u0982\u0983\u0985\u0986\u0987\u0988\u0989\u098A\u098B\u098C\u098F\u0990\u0993\u0994\u0995\u0996\u0997\u0998\u0999\u099A\u099B\u099C\u099D\u099E\u099F\u09A0\u09A1\u09A2\u09A3\u09A4\u09A5\u09A6\u09A7\u09A8\u09AA\u09AB\u09AC\u09AD\u09AE\u09AF\u09B0\u09B2\u09B6\u09B7\u09B8\u09B9\u09BC\u09BD\u09BE\u09BF\u09C0\u09C1\u09C2\u09C3\u09C4\u09C7\u09C8\u09CB\u09CC\u09CD\u09CE\u09D7\u09DC\u09DD\u09DF\u09E0\u09E1\u09E2\u09E3\u09E6\u09E7\u09E8\u09E9\u09EA\u09EB\u09EC\u09ED\u09EE\u09EF\u09F0\u09F1\u09F2\u09F3\u09F4\u09F5\u09F6\u09F7\u09F8\u09F9\u09FA\u09FB']+$/,
    eo: /^[0-9ABC\u0108D-G\u011CH\u0124IJ\u0134K-PRS\u015CTU\u016CVZ]+$/i,
    "hi-IN": /^[\u0900-\u0963]+[\u0966-\u097F]*$/i,
    "si-LK": /^[0-9\u0D80-\u0DFF]+$/
  };
  var decimal = exports.decimal = {
    "en-US": ".",
    ar: "\u066B"
  };
  var englishLocales = exports.englishLocales = ["AU", "GB", "HK", "IN", "NZ", "ZA", "ZM"];
  for (i = 0;i < englishLocales.length; i++) {
    locale = "en-".concat(englishLocales[i]);
    alpha[locale] = alpha["en-US"];
    alphanumeric[locale] = alphanumeric["en-US"];
    decimal[locale] = decimal["en-US"];
  }
  var locale;
  var i;
  var arabicLocales = exports.arabicLocales = ["AE", "BH", "DZ", "EG", "IQ", "JO", "KW", "LB", "LY", "MA", "QM", "QA", "SA", "SD", "SY", "TN", "YE"];
  for (_i = 0;_i < arabicLocales.length; _i++) {
    _locale = "ar-".concat(arabicLocales[_i]);
    alpha[_locale] = alpha.ar;
    alphanumeric[_locale] = alphanumeric.ar;
    decimal[_locale] = decimal.ar;
  }
  var _locale;
  var _i;
  var farsiLocales = exports.farsiLocales = ["IR", "AF"];
  for (_i2 = 0;_i2 < farsiLocales.length; _i2++) {
    _locale2 = "fa-".concat(farsiLocales[_i2]);
    alphanumeric[_locale2] = alphanumeric.fa;
    decimal[_locale2] = decimal.ar;
  }
  var _locale2;
  var _i2;
  var bengaliLocales = exports.bengaliLocales = ["BD", "IN"];
  for (_i3 = 0;_i3 < bengaliLocales.length; _i3++) {
    _locale3 = "bn-".concat(bengaliLocales[_i3]);
    alpha[_locale3] = alpha.bn;
    alphanumeric[_locale3] = alphanumeric.bn;
    decimal[_locale3] = decimal["en-US"];
  }
  var _locale3;
  var _i3;
  var dotDecimal = exports.dotDecimal = ["ar-EG", "ar-LB", "ar-LY"];
  var commaDecimal = exports.commaDecimal = ["bg-BG", "cs-CZ", "da-DK", "de-DE", "el-GR", "en-ZM", "eo", "es-ES", "fr-CA", "fr-FR", "id-ID", "it-IT", "ku-IQ", "hi-IN", "hu-HU", "nb-NO", "nn-NO", "nl-NL", "pl-PL", "pt-PT", "ru-RU", "kk-KZ", "si-LK", "sl-SI", "sr-RS@latin", "sr-RS", "sv-SE", "tr-TR", "uk-UA", "vi-VN"];
  for (_i4 = 0;_i4 < dotDecimal.length; _i4++) {
    decimal[dotDecimal[_i4]] = decimal["en-US"];
  }
  var _i4;
  for (_i5 = 0;_i5 < commaDecimal.length; _i5++) {
    decimal[commaDecimal[_i5]] = ",";
  }
  var _i5;
  alpha["fr-CA"] = alpha["fr-FR"];
  alphanumeric["fr-CA"] = alphanumeric["fr-FR"];
  alpha["pt-BR"] = alpha["pt-PT"];
  alphanumeric["pt-BR"] = alphanumeric["pt-PT"];
  decimal["pt-BR"] = decimal["pt-PT"];
  alpha["pl-Pl"] = alpha["pl-PL"];
  alphanumeric["pl-Pl"] = alphanumeric["pl-PL"];
  decimal["pl-Pl"] = decimal["pl-PL"];
  alpha["fa-AF"] = alpha.fa;
});
var require_isAlpha2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAlpha;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _alpha = require_alpha2();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isAlpha(_str) {
    var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "en-US";
    var options22 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    (0, _assertString.default)(_str);
    var str = _str;
    var ignore = options22.ignore;
    if (ignore) {
      if (ignore instanceof RegExp) {
        str = str.replace(ignore, "");
      } else if (typeof ignore === "string") {
        str = str.replace(new RegExp("[".concat(ignore.replace(/[-[\]{}()*+?.,\\^$|#\\s]/g, "\\$&"), "]"), "g"), "");
      } else {
        throw new Error("ignore should be instance of a String or RegExp");
      }
    }
    if (locale in _alpha.alpha) {
      return _alpha.alpha[locale].test(str);
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales22 = exports.locales = Object.keys(_alpha.alpha);
});
var require_isLatLong2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isLatLong;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _merge = _interopRequireDefault(require_merge2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var lat = /^\(?[+-]?(90(\.0+)?|[1-8]?\d(\.\d+)?)$/;
  var long = /^\s?[+-]?(180(\.0+)?|1[0-7]\d(\.\d+)?|\d{1,2}(\.\d+)?)\)?$/;
  var latDMS = /^(([1-8]?\d)\D+([1-5]?\d|60)\D+([1-5]?\d|60)(\.\d+)?|90\D+0\D+0)\D+[NSns]?$/i;
  var longDMS = /^\s*([1-7]?\d{1,2}\D+([1-5]?\d|60)\D+([1-5]?\d|60)(\.\d+)?|180\D+0\D+0)\D+[EWew]?$/i;
  var defaultLatLongOptions = {
    checkDMS: false
  };
  function isLatLong(str, options22) {
    (0, _assertString.default)(str);
    options22 = (0, _merge.default)(options22, defaultLatLongOptions);
    if (!str.includes(","))
      return false;
    var pair = str.split(",");
    if (pair[0].startsWith("(") && !pair[1].endsWith(")") || pair[1].endsWith(")") && !pair[0].startsWith("("))
      return false;
    if (options22.checkDMS) {
      return latDMS.test(pair[0]) && longDMS.test(pair[1]);
    }
    return lat.test(pair[0]) && long.test(pair[1]);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_includes2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var includes = function includes(arr, val2) {
    return arr.some(function(arrVal) {
      return val2 === arrVal;
    });
  };
  var _default = exports.default = includes;
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isDecimal2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isDecimal;
  var _merge = _interopRequireDefault(require_merge2());
  var _assertString = _interopRequireDefault(require_assertString2());
  var _includes = _interopRequireDefault(require_includes2());
  var _alpha = require_alpha2();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function decimalRegExp(options22) {
    var regExp = new RegExp("^[-+]?([0-9]+)?(\\".concat(_alpha.decimal[options22.locale], "[0-9]{").concat(options22.decimal_digits, "})").concat(options22.force_decimal ? "" : "?", "$"));
    return regExp;
  }
  var default_decimal_options = {
    force_decimal: false,
    decimal_digits: "1,",
    locale: "en-US"
  };
  var blacklist = ["", "-", "+"];
  function isDecimal(str, options22) {
    (0, _assertString.default)(str);
    options22 = (0, _merge.default)(options22, default_decimal_options);
    if (options22.locale in _alpha.decimal) {
      return !(0, _includes.default)(blacklist, str.replace(/ /g, "")) && decimalRegExp(options22).test(str);
    }
    throw new Error("Invalid locale '".concat(options22.locale, "'"));
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isHexColor2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isHexColor;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var hexcolor = /^#?([0-9A-F]{3}|[0-9A-F]{4}|[0-9A-F]{6}|[0-9A-F]{8})$/i;
  function isHexColor(str) {
    (0, _assertString.default)(str);
    return hexcolor.test(str);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isLuhnNumber2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isLuhnNumber;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isLuhnNumber(str) {
    (0, _assertString.default)(str);
    var sanitized = str.replace(/[- ]+/g, "");
    var sum = 0;
    var digit;
    var tmpNum;
    var shouldDouble;
    for (var i = sanitized.length - 1;i >= 0; i--) {
      digit = sanitized.substring(i, i + 1);
      tmpNum = parseInt(digit, 10);
      if (shouldDouble) {
        tmpNum *= 2;
        if (tmpNum >= 10) {
          sum += tmpNum % 10 + 1;
        } else {
          sum += tmpNum;
        }
      } else {
        sum += tmpNum;
      }
      shouldDouble = !shouldDouble;
    }
    return !!(sum % 10 === 0 ? sanitized : false);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isCreditCard2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isCreditCard;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _isLuhnNumber = _interopRequireDefault(require_isLuhnNumber2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var cards = {
    amex: /^3[47][0-9]{13}$/,
    dinersclub: /^3(?:0[0-5]|[68][0-9])[0-9]{11}$/,
    discover: /^6(?:011|5[0-9][0-9])[0-9]{12,15}$/,
    jcb: /^(?:2131|1800|35\d{3})\d{11}$/,
    mastercard: /^5[1-5][0-9]{2}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}$/,
    unionpay: /^(6[27][0-9]{14}|^(81[0-9]{14,17}))$/,
    visa: /^(?:4[0-9]{12})(?:[0-9]{3,6})?$/
  };
  var allCards = function() {
    var tmpCardsArray = [];
    for (var cardProvider in cards) {
      if (cards.hasOwnProperty(cardProvider)) {
        tmpCardsArray.push(cards[cardProvider]);
      }
    }
    return tmpCardsArray;
  }();
  function isCreditCard(card) {
    var options22 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _assertString.default)(card);
    var provider = options22.provider;
    var sanitized = card.replace(/[- ]+/g, "");
    if (provider && provider.toLowerCase() in cards) {
      if (!cards[provider.toLowerCase()].test(sanitized)) {
        return false;
      }
    } else if (provider && !(provider.toLowerCase() in cards)) {
      throw new Error("".concat(provider, " is not a valid credit card provider."));
    } else if (!allCards.some(function(cardProvider) {
      return cardProvider.test(sanitized);
    })) {
      return false;
    }
    return (0, _isLuhnNumber.default)(card);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isAlphanumeric2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAlphanumeric;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString2());
  var _alpha = require_alpha2();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isAlphanumeric(_str) {
    var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "en-US";
    var options22 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    (0, _assertString.default)(_str);
    var str = _str;
    var ignore = options22.ignore;
    if (ignore) {
      if (ignore instanceof RegExp) {
        str = str.replace(ignore, "");
      } else if (typeof ignore === "string") {
        str = str.replace(new RegExp("[".concat(ignore.replace(/[-[\]{}()*+?.,\\^$|#\\s]/g, "\\$&"), "]"), "g"), "");
      } else {
        throw new Error("ignore should be instance of a String or RegExp");
      }
    }
    if (locale in _alpha.alphanumeric) {
      return _alpha.alphanumeric[locale].test(str);
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales22 = exports.locales = Object.keys(_alpha.alphanumeric);
});
var require_isPassportNumber2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isPassportNumber;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var passportRegexByCountryCode = {
    AM: /^[A-Z]{2}\d{7}$/,
    AR: /^[A-Z]{3}\d{6}$/,
    AT: /^[A-Z]\d{7}$/,
    AU: /^[A-Z]\d{7}$/,
    AZ: /^[A-Z]{1}\d{8}$/,
    BE: /^[A-Z]{2}\d{6}$/,
    BG: /^\d{9}$/,
    BR: /^[A-Z]{2}\d{6}$/,
    BY: /^[A-Z]{2}\d{7}$/,
    CA: /^[A-Z]{2}\d{6}$/,
    CH: /^[A-Z]\d{7}$/,
    CN: /^G\d{8}$|^E(?![IO])[A-Z0-9]\d{7}$/,
    CY: /^[A-Z](\d{6}|\d{8})$/,
    CZ: /^\d{8}$/,
    DE: /^[CFGHJKLMNPRTVWXYZ0-9]{9}$/,
    DK: /^\d{9}$/,
    DZ: /^\d{9}$/,
    EE: /^([A-Z]\d{7}|[A-Z]{2}\d{7})$/,
    ES: /^[A-Z0-9]{2}([A-Z0-9]?)\d{6}$/,
    FI: /^[A-Z]{2}\d{7}$/,
    FR: /^\d{2}[A-Z]{2}\d{5}$/,
    GB: /^\d{9}$/,
    GR: /^[A-Z]{2}\d{7}$/,
    HR: /^\d{9}$/,
    HU: /^[A-Z]{2}(\d{6}|\d{7})$/,
    IE: /^[A-Z0-9]{2}\d{7}$/,
    IN: /^[A-Z]{1}-?\d{7}$/,
    ID: /^[A-C]\d{7}$/,
    IR: /^[A-Z]\d{8}$/,
    IS: /^(A)\d{7}$/,
    IT: /^[A-Z0-9]{2}\d{7}$/,
    JM: /^[Aa]\d{7}$/,
    JP: /^[A-Z]{2}\d{7}$/,
    KR: /^[MS]\d{8}$/,
    KZ: /^[a-zA-Z]\d{7}$/,
    LI: /^[a-zA-Z]\d{5}$/,
    LT: /^[A-Z0-9]{8}$/,
    LU: /^[A-Z0-9]{8}$/,
    LV: /^[A-Z0-9]{2}\d{7}$/,
    LY: /^[A-Z0-9]{8}$/,
    MT: /^\d{7}$/,
    MZ: /^([A-Z]{2}\d{7})|(\d{2}[A-Z]{2}\d{5})$/,
    MY: /^[AHK]\d{8}$/,
    MX: /^\d{10,11}$/,
    NL: /^[A-Z]{2}[A-Z0-9]{6}\d$/,
    NZ: /^([Ll]([Aa]|[Dd]|[Ff]|[Hh])|[Ee]([Aa]|[Pp])|[Nn])\d{6}$/,
    PH: /^([A-Z](\d{6}|\d{7}[A-Z]))|([A-Z]{2}(\d{6}|\d{7}))$/,
    PK: /^[A-Z]{2}\d{7}$/,
    PL: /^[A-Z]{2}\d{7}$/,
    PT: /^[A-Z]\d{6}$/,
    RO: /^\d{8,9}$/,
    RU: /^\d{9}$/,
    SE: /^\d{8}$/,
    SL: /^(P)[A-Z]\d{7}$/,
    SK: /^[0-9A-Z]\d{7}$/,
    TH: /^[A-Z]{1,2}\d{6,7}$/,
    TR: /^[A-Z]\d{8}$/,
    UA: /^[A-Z]{2}\d{6}$/,
    US: /^\d{9}$/,
    ZA: /^[TAMD]\d{8}$/
  };
  function isPassportNumber(str, countryCode) {
    (0, _assertString.default)(str);
    var normalizedStr = str.replace(/\s/g, "").toUpperCase();
    return countryCode.toUpperCase() in passportRegexByCountryCode && passportRegexByCountryCode[countryCode].test(normalizedStr);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isPostalCode2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isPostalCode;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var threeDigit = /^\d{3}$/;
  var fourDigit = /^\d{4}$/;
  var fiveDigit = /^\d{5}$/;
  var sixDigit = /^\d{6}$/;
  var patterns = {
    AD: /^AD\d{3}$/,
    AT: fourDigit,
    AU: fourDigit,
    AZ: /^AZ\d{4}$/,
    BA: /^([7-8]\d{4}$)/,
    BE: fourDigit,
    BG: fourDigit,
    BR: /^\d{5}-\d{3}$/,
    BY: /^2[1-4]\d{4}$/,
    CA: /^[ABCEGHJKLMNPRSTVXY]\d[ABCEGHJ-NPRSTV-Z][\s\-]?\d[ABCEGHJ-NPRSTV-Z]\d$/i,
    CH: fourDigit,
    CN: /^(0[1-7]|1[012356]|2[0-7]|3[0-6]|4[0-7]|5[1-7]|6[1-7]|7[1-5]|8[1345]|9[09])\d{4}$/,
    CZ: /^\d{3}\s?\d{2}$/,
    DE: fiveDigit,
    DK: fourDigit,
    DO: fiveDigit,
    DZ: fiveDigit,
    EE: fiveDigit,
    ES: /^(5[0-2]{1}|[0-4]{1}\d{1})\d{3}$/,
    FI: fiveDigit,
    FR: /^\d{2}\s?\d{3}$/,
    GB: /^(gir\s?0aa|[a-z]{1,2}\d[\da-z]?\s?(\d[a-z]{2})?)$/i,
    GR: /^\d{3}\s?\d{2}$/,
    HR: /^([1-5]\d{4}$)/,
    HT: /^HT\d{4}$/,
    HU: fourDigit,
    ID: fiveDigit,
    IE: /^(?!.*(?:o))[A-Za-z]\d[\dw]\s\w{4}$/i,
    IL: /^(\d{5}|\d{7})$/,
    IN: /^((?!10|29|35|54|55|65|66|86|87|88|89)[1-9][0-9]{5})$/,
    IR: /^(?!(\d)\1{3})[13-9]{4}[1346-9][013-9]{5}$/,
    IS: threeDigit,
    IT: fiveDigit,
    JP: /^\d{3}\-\d{4}$/,
    KE: fiveDigit,
    KR: /^(\d{5}|\d{6})$/,
    LI: /^(948[5-9]|949[0-7])$/,
    LT: /^LT\-\d{5}$/,
    LU: fourDigit,
    LV: /^LV\-\d{4}$/,
    LK: fiveDigit,
    MG: threeDigit,
    MX: fiveDigit,
    MT: /^[A-Za-z]{3}\s{0,1}\d{4}$/,
    MY: fiveDigit,
    NL: /^[1-9]\d{3}\s?(?!sa|sd|ss)[a-z]{2}$/i,
    NO: fourDigit,
    NP: /^(10|21|22|32|33|34|44|45|56|57)\d{3}$|^(977)$/i,
    NZ: fourDigit,
    PL: /^\d{2}\-\d{3}$/,
    PR: /^00[679]\d{2}([ -]\d{4})?$/,
    PT: /^\d{4}\-\d{3}?$/,
    RO: sixDigit,
    RU: sixDigit,
    SA: fiveDigit,
    SE: /^[1-9]\d{2}\s?\d{2}$/,
    SG: sixDigit,
    SI: fourDigit,
    SK: /^\d{3}\s?\d{2}$/,
    TH: fiveDigit,
    TN: fourDigit,
    TW: /^\d{3}(\d{2})?$/,
    UA: fiveDigit,
    US: /^\d{5}(-\d{4})?$/,
    ZA: fourDigit,
    ZM: fiveDigit
  };
  var locales22 = exports.locales = Object.keys(patterns);
  function isPostalCode(str, locale) {
    (0, _assertString.default)(str);
    if (locale in patterns) {
      return patterns[locale].test(str);
    } else if (locale === "any") {
      for (var key in patterns) {
        if (patterns.hasOwnProperty(key)) {
          var pattern = patterns[key];
          if (pattern.test(str)) {
            return true;
          }
        }
      }
      return false;
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
});
var require_isMobilePhone2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isMobilePhone;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var phones = {
    "am-AM": /^(\+?374|0)(33|4[134]|55|77|88|9[13-689])\d{6}$/,
    "ar-AE": /^((\+?971)|0)?5[024568]\d{7}$/,
    "ar-BH": /^(\+?973)?(3|6)\d{7}$/,
    "ar-DZ": /^(\+?213|0)(5|6|7)\d{8}$/,
    "ar-LB": /^(\+?961)?((3|81)\d{6}|7\d{7})$/,
    "ar-EG": /^((\+?20)|0)?1[0125]\d{8}$/,
    "ar-IQ": /^(\+?964|0)?7[0-9]\d{8}$/,
    "ar-JO": /^(\+?962|0)?7[789]\d{7}$/,
    "ar-KW": /^(\+?965)([569]\d{7}|41\d{6})$/,
    "ar-LY": /^((\+?218)|0)?(9[1-6]\d{7}|[1-8]\d{7,9})$/,
    "ar-MA": /^(?:(?:\+|00)212|0)[5-7]\d{8}$/,
    "ar-OM": /^((\+|00)968)?(9[1-9])\d{6}$/,
    "ar-PS": /^(\+?970|0)5[6|9](\d{7})$/,
    "ar-SA": /^(!?(\+?966)|0)?5\d{8}$/,
    "ar-SD": /^((\+?249)|0)?(9[012369]|1[012])\d{7}$/,
    "ar-SY": /^(!?(\+?963)|0)?9\d{8}$/,
    "ar-TN": /^(\+?216)?[2459]\d{7}$/,
    "az-AZ": /^(\+994|0)(10|5[015]|7[07]|99)\d{7}$/,
    "bs-BA": /^((((\+|00)3876)|06))((([0-3]|[5-6])\d{6})|(4\d{7}))$/,
    "be-BY": /^(\+?375)?(24|25|29|33|44)\d{7}$/,
    "bg-BG": /^(\+?359|0)?8[789]\d{7}$/,
    "bn-BD": /^(\+?880|0)1[13456789][0-9]{8}$/,
    "ca-AD": /^(\+376)?[346]\d{5}$/,
    "cs-CZ": /^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,
    "da-DK": /^(\+?45)?\s?\d{2}\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "de-DE": /^((\+49|0)1)(5[0-25-9]\d|6([23]|0\d?)|7([0-57-9]|6\d))\d{7,9}$/,
    "de-AT": /^(\+43|0)\d{1,4}\d{3,12}$/,
    "de-CH": /^(\+41|0)([1-9])\d{1,9}$/,
    "de-LU": /^(\+352)?((6\d1)\d{6})$/,
    "dv-MV": /^(\+?960)?(7[2-9]|9[1-9])\d{5}$/,
    "el-GR": /^(\+?30|0)?6(8[5-9]|9(?![26])[0-9])\d{7}$/,
    "el-CY": /^(\+?357?)?(9(9|6)\d{6})$/,
    "en-AI": /^(\+?1|0)264(?:2(35|92)|4(?:6[1-2]|76|97)|5(?:3[6-9]|8[1-4])|7(?:2(4|9)|72))\d{4}$/,
    "en-AU": /^(\+?61|0)4\d{8}$/,
    "en-AG": /^(?:\+1|1)268(?:464|7(?:1[3-9]|[28]\d|3[0246]|64|7[0-689]))\d{4}$/,
    "en-BM": /^(\+?1)?441(((3|7)\d{6}$)|(5[0-3][0-9]\d{4}$)|(59\d{5}$))/,
    "en-BS": /^(\+?1[-\s]?|0)?\(?242\)?[-\s]?\d{3}[-\s]?\d{4}$/,
    "en-GB": /^(\+?44|0)7\d{9}$/,
    "en-GG": /^(\+?44|0)1481\d{6}$/,
    "en-GH": /^(\+233|0)(20|50|24|54|27|57|26|56|23|28|55|59)\d{7}$/,
    "en-GY": /^(\+592|0)6\d{6}$/,
    "en-HK": /^(\+?852[-\s]?)?[456789]\d{3}[-\s]?\d{4}$/,
    "en-MO": /^(\+?853[-\s]?)?[6]\d{3}[-\s]?\d{4}$/,
    "en-IE": /^(\+?353|0)8[356789]\d{7}$/,
    "en-IN": /^(\+?91|0)?[6789]\d{9}$/,
    "en-JM": /^(\+?876)?\d{7}$/,
    "en-KE": /^(\+?254|0)(7|1)\d{8}$/,
    "fr-CF": /^(\+?236| ?)(70|75|77|72|21|22)\d{6}$/,
    "en-SS": /^(\+?211|0)(9[1257])\d{7}$/,
    "en-KI": /^((\+686|686)?)?( )?((6|7)(2|3|8)[0-9]{6})$/,
    "en-KN": /^(?:\+1|1)869(?:46\d|48[89]|55[6-8]|66\d|76[02-7])\d{4}$/,
    "en-LS": /^(\+?266)(22|28|57|58|59|27|52)\d{6}$/,
    "en-MT": /^(\+?356|0)?(99|79|77|21|27|22|25)[0-9]{6}$/,
    "en-MU": /^(\+?230|0)?\d{8}$/,
    "en-MW": /^(\+?265|0)(((77|88|31|99|98|21)\d{7})|(((111)|1)\d{6})|(32000\d{4}))$/,
    "en-NA": /^(\+?264|0)(6|8)\d{7}$/,
    "en-NG": /^(\+?234|0)?[789]\d{9}$/,
    "en-NZ": /^(\+?64|0)[28]\d{7,9}$/,
    "en-PG": /^(\+?675|0)?(7\d|8[18])\d{6}$/,
    "en-PK": /^((00|\+)?92|0)3[0-6]\d{8}$/,
    "en-PH": /^(09|\+639)\d{9}$/,
    "en-RW": /^(\+?250|0)?[7]\d{8}$/,
    "en-SG": /^(\+65)?[3689]\d{7}$/,
    "en-SL": /^(\+?232|0)\d{8}$/,
    "en-TZ": /^(\+?255|0)?[67]\d{8}$/,
    "en-UG": /^(\+?256|0)?[7]\d{8}$/,
    "en-US": /^((\+1|1)?( |-)?)?(\([2-9][0-9]{2}\)|[2-9][0-9]{2})( |-)?([2-9][0-9]{2}( |-)?[0-9]{4})$/,
    "en-ZA": /^(\+?27|0)\d{9}$/,
    "en-ZM": /^(\+?26)?09[567]\d{7}$/,
    "en-ZW": /^(\+263)[0-9]{9}$/,
    "en-BW": /^(\+?267)?(7[1-8]{1})\d{6}$/,
    "es-AR": /^\+?549(11|[2368]\d)\d{8}$/,
    "es-BO": /^(\+?591)?(6|7)\d{7}$/,
    "es-CO": /^(\+?57)?3(0(0|1|2|4|5)|1\d|2[0-4]|5(0|1))\d{7}$/,
    "es-CL": /^(\+?56|0)[2-9]\d{1}\d{7}$/,
    "es-CR": /^(\+506)?[2-8]\d{7}$/,
    "es-CU": /^(\+53|0053)?5\d{7}$/,
    "es-DO": /^(\+?1)?8[024]9\d{7}$/,
    "es-HN": /^(\+?504)?[9|8|3|2]\d{7}$/,
    "es-EC": /^(\+?593|0)([2-7]|9[2-9])\d{7}$/,
    "es-ES": /^(\+?34)?[6|7]\d{8}$/,
    "es-PE": /^(\+?51)?9\d{8}$/,
    "es-MX": /^(\+?52)?(1|01)?\d{10,11}$/,
    "es-NI": /^(\+?505)\d{7,8}$/,
    "es-PA": /^(\+?507)\d{7,8}$/,
    "es-PY": /^(\+?595|0)9[9876]\d{7}$/,
    "es-SV": /^(\+?503)?[67]\d{7}$/,
    "es-UY": /^(\+598|0)9[1-9][\d]{6}$/,
    "es-VE": /^(\+?58)?(2|4)\d{9}$/,
    "et-EE": /^(\+?372)?\s?(5|8[1-4])\s?([0-9]\s?){6,7}$/,
    "fa-IR": /^(\+?98[\-\s]?|0)9[0-39]\d[\-\s]?\d{3}[\-\s]?\d{4}$/,
    "fi-FI": /^(\+?358|0)\s?(4[0-6]|50)\s?(\d\s?){4,8}$/,
    "fj-FJ": /^(\+?679)?\s?\d{3}\s?\d{4}$/,
    "fo-FO": /^(\+?298)?\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "fr-BF": /^(\+226|0)[67]\d{7}$/,
    "fr-BJ": /^(\+229)\d{8}$/,
    "fr-CD": /^(\+?243|0)?(8|9)\d{8}$/,
    "fr-CM": /^(\+?237)6[0-9]{8}$/,
    "fr-FR": /^(\+?33|0)[67]\d{8}$/,
    "fr-GF": /^(\+?594|0|00594)[67]\d{8}$/,
    "fr-GP": /^(\+?590|0|00590)[67]\d{8}$/,
    "fr-MQ": /^(\+?596|0|00596)[67]\d{8}$/,
    "fr-PF": /^(\+?689)?8[789]\d{6}$/,
    "fr-RE": /^(\+?262|0|00262)[67]\d{8}$/,
    "fr-WF": /^(\+681)?\d{6}$/,
    "he-IL": /^(\+972|0)([23489]|5[012345689]|77)[1-9]\d{6}$/,
    "hu-HU": /^(\+?36|06)(20|30|31|50|70)\d{7}$/,
    "id-ID": /^(\+?62|0)8(1[123456789]|2[1238]|3[1238]|5[12356789]|7[78]|9[56789]|8[123456789])([\s?|\d]{5,11})$/,
    "ir-IR": /^(\+98|0)?9\d{9}$/,
    "it-IT": /^(\+?39)?\s?3\d{2} ?\d{6,7}$/,
    "it-SM": /^((\+378)|(0549)|(\+390549)|(\+3780549))?6\d{5,9}$/,
    "ja-JP": /^(\+81[ \-]?(\(0\))?|0)[6789]0[ \-]?\d{4}[ \-]?\d{4}$/,
    "ka-GE": /^(\+?995)?(79\d{7}|5\d{8})$/,
    "kk-KZ": /^(\+?7|8)?7\d{9}$/,
    "kl-GL": /^(\+?299)?\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "ko-KR": /^((\+?82)[ \-]?)?0?1([0|1|6|7|8|9]{1})[ \-]?\d{3,4}[ \-]?\d{4}$/,
    "ky-KG": /^(\+?7\s?\+?7|0)\s?\d{2}\s?\d{3}\s?\d{4}$/,
    "lt-LT": /^(\+370|8)\d{8}$/,
    "lv-LV": /^(\+?371)2\d{7}$/,
    "mg-MG": /^((\+?261|0)(2|3)\d)?\d{7}$/,
    "mn-MN": /^(\+|00|011)?976(77|81|88|91|94|95|96|99)\d{6}$/,
    "my-MM": /^(\+?959|09|9)(2[5-7]|3[1-2]|4[0-5]|6[6-9]|7[5-9]|9[6-9])[0-9]{7}$/,
    "ms-MY": /^(\+?60|0)1(([0145](-|\s)?\d{7,8})|([236-9](-|\s)?\d{7}))$/,
    "mz-MZ": /^(\+?258)?8[234567]\d{7}$/,
    "nb-NO": /^(\+?47)?[49]\d{7}$/,
    "ne-NP": /^(\+?977)?9[78]\d{8}$/,
    "nl-BE": /^(\+?32|0)4\d{8}$/,
    "nl-NL": /^(((\+|00)?31\(0\))|((\+|00)?31)|0)6{1}\d{8}$/,
    "nl-AW": /^(\+)?297(56|59|64|73|74|99)\d{5}$/,
    "nn-NO": /^(\+?47)?[49]\d{7}$/,
    "pl-PL": /^(\+?48)? ?([5-8]\d|45) ?\d{3} ?\d{2} ?\d{2}$/,
    "pt-BR": /^((\+?55\ ?[1-9]{2}\ ?)|(\+?55\ ?\([1-9]{2}\)\ ?)|(0[1-9]{2}\ ?)|(\([1-9]{2}\)\ ?)|([1-9]{2}\ ?))((\d{4}\-?\d{4})|(9[1-9]{1}\d{3}\-?\d{4}))$/,
    "pt-PT": /^(\+?351)?9[1236]\d{7}$/,
    "pt-AO": /^(\+244)\d{9}$/,
    "ro-MD": /^(\+?373|0)((6(0|1|2|6|7|8|9))|(7(6|7|8|9)))\d{6}$/,
    "ro-RO": /^(\+?40|0)\s?7\d{2}(\/|\s|\.|-)?\d{3}(\s|\.|-)?\d{3}$/,
    "ru-RU": /^(\+?7|8)?9\d{9}$/,
    "si-LK": /^(?:0|94|\+94)?(7(0|1|2|4|5|6|7|8)( |-)?)\d{7}$/,
    "sl-SI": /^(\+386\s?|0)(\d{1}\s?\d{3}\s?\d{2}\s?\d{2}|\d{2}\s?\d{3}\s?\d{3})$/,
    "sk-SK": /^(\+?421)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,
    "so-SO": /^(\+?252|0)((6[0-9])\d{7}|(7[1-9])\d{7})$/,
    "sq-AL": /^(\+355|0)6[789]\d{6}$/,
    "sr-RS": /^(\+3816|06)[- \d]{5,9}$/,
    "sv-SE": /^(\+?46|0)[\s\-]?7[\s\-]?[02369]([\s\-]?\d){7}$/,
    "tg-TJ": /^(\+?992)?[5][5]\d{7}$/,
    "th-TH": /^(\+66|66|0)\d{9}$/,
    "tr-TR": /^(\+?90|0)?5\d{9}$/,
    "tk-TM": /^(\+993|993|8)\d{8}$/,
    "uk-UA": /^(\+?38|8)?0\d{9}$/,
    "uz-UZ": /^(\+?998)?(6[125-79]|7[1-69]|88|9\d)\d{7}$/,
    "vi-VN": /^((\+?84)|0)((3([2-9]))|(5([25689]))|(7([0|6-9]))|(8([1-9]))|(9([0-9])))([0-9]{7})$/,
    "zh-CN": /^((\+|00)86)?(1[3-9]|9[28])\d{9}$/,
    "zh-TW": /^(\+?886\-?|0)?9\d{8}$/,
    "dz-BT": /^(\+?975|0)?(17|16|77|02)\d{6}$/,
    "ar-YE": /^(((\+|00)9677|0?7)[0137]\d{7}|((\+|00)967|0)[1-7]\d{6})$/,
    "ar-EH": /^(\+?212|0)[\s\-]?(5288|5289)[\s\-]?\d{5}$/,
    "fa-AF": /^(\+93|0)?(2{1}[0-8]{1}|[3-5]{1}[0-4]{1})(\d{7})$/
  };
  phones["en-CA"] = phones["en-US"];
  phones["fr-CA"] = phones["en-CA"];
  phones["fr-BE"] = phones["nl-BE"];
  phones["zh-HK"] = phones["en-HK"];
  phones["zh-MO"] = phones["en-MO"];
  phones["ga-IE"] = phones["en-IE"];
  phones["fr-CH"] = phones["de-CH"];
  phones["it-CH"] = phones["fr-CH"];
  function isMobilePhone(str, locale, options22) {
    (0, _assertString.default)(str);
    if (options22 && options22.strictMode && !str.startsWith("+")) {
      return false;
    }
    if (Array.isArray(locale)) {
      return locale.some(function(key2) {
        if (phones.hasOwnProperty(key2)) {
          var phone2 = phones[key2];
          if (phone2.test(str)) {
            return true;
          }
        }
        return false;
      });
    } else if (locale in phones) {
      return phones[locale].test(str);
    } else if (!locale || locale === "any") {
      for (var key in phones) {
        if (phones.hasOwnProperty(key)) {
          var phone = phones[key];
          if (phone.test(str)) {
            return true;
          }
        }
      }
      return false;
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales22 = exports.locales = Object.keys(phones);
});
var import_isIP2;
var import_isJWT2;
var import_isURL2;
var import_isSlug2;
var import_isIBAN2;
var import_isUUID2;
var import_isAscii2;
var import_isEmail2;
var import_isAlpha2;
var import_isLatLong2;
var import_isDecimal2;
var import_isHexColor2;
var import_isCreditCard2;
var import_isAlphanumeric2;
var import_isPassportNumber2;
var import_isPostalCode3;
var import_isMobilePhone3;
var import_isMobilePhone22;
var import_isPostalCode22;
var SimpleMessagesProvider2 = class {
  #messages;
  #fields;
  constructor(messages3, fields22) {
    this.#messages = messages3;
    this.#fields = fields22 || {};
  }
  #interpolate(message, data) {
    if (!message.includes("{{")) {
      return message;
    }
    return message.replace(/(\\)?{{(.*?)}}/g, (_2, __, key) => {
      const tokens = key.trim().split(".");
      let output = data;
      while (tokens.length) {
        if (output === null || typeof output !== "object") {
          return;
        }
        const token = tokens.shift();
        output = Object.hasOwn(output, token) ? output[token] : undefined;
      }
      return output;
    });
  }
  getMessage(rawMessage, rule, field, args) {
    const fieldName = this.#fields[field.name] || field.name;
    const fieldMessage = this.#messages[`${field.getFieldPath()}.${rule}`];
    if (fieldMessage) {
      return this.#interpolate(fieldMessage, {
        field: fieldName,
        ...args
      });
    }
    const wildcardMessage = this.#messages[`${field.wildCardPath}.${rule}`];
    if (wildcardMessage) {
      return this.#interpolate(wildcardMessage, {
        field: fieldName,
        ...args
      });
    }
    const ruleMessage = this.#messages[rule];
    if (ruleMessage) {
      return this.#interpolate(ruleMessage, {
        field: fieldName,
        ...args
      });
    }
    return this.#interpolate(rawMessage, {
      field: fieldName,
      ...args
    });
  }
  toJSON() {
    return {
      messages: this.#messages,
      fields: this.#fields
    };
  }
};
var main_exports2;
var ValidationError2;
var E_VALIDATION_ERROR2;
var SimpleErrorReporter2 = class {
  hasErrors = false;
  errors = [];
  report(message, rule, field, meta) {
    const error = {
      message,
      rule,
      field: field.getFieldPath()
    };
    if (meta) {
      error.meta = meta;
    }
    if (field.isArrayMember) {
      error.index = field.name;
    }
    this.hasErrors = true;
    this.errors.push(error);
  }
  createError() {
    return new E_VALIDATION_ERROR2(this.errors);
  }
};
var BOOLEAN_POSITIVES2;
var BOOLEAN_NEGATIVES2;
var helpers32;
var init_chunk_2W32DW3L = __esm2(() => {
  init_chunk_CSAU5B4Q();
  import_isIP2 = __toESM3(require_isIP2(), 1);
  import_isJWT2 = __toESM3(require_isJWT2(), 1);
  import_isURL2 = __toESM3(require_isURL2(), 1);
  import_isSlug2 = __toESM3(require_isSlug2(), 1);
  import_isIBAN2 = __toESM3(require_isIBAN2(), 1);
  import_isUUID2 = __toESM3(require_isUUID2(), 1);
  import_isAscii2 = __toESM3(require_isAscii2(), 1);
  import_isEmail2 = __toESM3(require_isEmail2(), 1);
  import_isAlpha2 = __toESM3(require_isAlpha2(), 1);
  import_isLatLong2 = __toESM3(require_isLatLong2(), 1);
  import_isDecimal2 = __toESM3(require_isDecimal2(), 1);
  import_isHexColor2 = __toESM3(require_isHexColor2(), 1);
  import_isCreditCard2 = __toESM3(require_isCreditCard2(), 1);
  import_isAlphanumeric2 = __toESM3(require_isAlphanumeric2(), 1);
  import_isPassportNumber2 = __toESM3(require_isPassportNumber2(), 1);
  import_isPostalCode3 = __toESM3(require_isPostalCode2(), 1);
  import_isMobilePhone3 = __toESM3(require_isMobilePhone2(), 1);
  import_isMobilePhone22 = __toESM3(require_isMobilePhone2(), 1);
  import_isPostalCode22 = __toESM3(require_isPostalCode2(), 1);
  main_exports2 = {};
  __export22(main_exports2, {
    E_VALIDATION_ERROR: () => E_VALIDATION_ERROR2
  });
  ValidationError2 = class extends Error {
    constructor(messages3, options22) {
      super("Validation failure", options22);
      this.messages = messages3;
      const ErrorConstructor = this.constructor;
      Error.captureStackTrace(this, ErrorConstructor);
    }
    status = 422;
    code = "E_VALIDATION_ERROR";
    get [Symbol.toStringTag]() {
      return this.constructor.name;
    }
    toString() {
      return `${this.name} [${this.code}]: ${this.message}`;
    }
  };
  E_VALIDATION_ERROR2 = ValidationError2;
  BOOLEAN_POSITIVES2 = ["1", 1, "true", true, "on"];
  BOOLEAN_NEGATIVES2 = ["0", 0, "false", false];
  helpers32 = {
    exists(value) {
      return value !== null && value !== undefined;
    },
    isMissing(value) {
      return !this.exists(value);
    },
    isTrue(value) {
      return BOOLEAN_POSITIVES2.includes(value);
    },
    isFalse(value) {
      return BOOLEAN_NEGATIVES2.includes(value);
    },
    isString(value) {
      return typeof value === "string";
    },
    isObject(value) {
      return !!(value && typeof value === "object" && !Array.isArray(value));
    },
    hasKeys(value, keys) {
      for (let key of keys) {
        if (key in value === false) {
          return false;
        }
      }
      return true;
    },
    isArray(value) {
      return Array.isArray(value);
    },
    isNumeric(value) {
      return !Number.isNaN(Number(value));
    },
    asNumber(value) {
      return value === null ? Number.NaN : Number(value);
    },
    asBoolean(value) {
      if (this.isTrue(value)) {
        return true;
      }
      if (this.isFalse(value)) {
        return false;
      }
      return null;
    },
    isEmail: import_isEmail2.default.default,
    isURL: import_isURL2.default.default,
    isAlpha: import_isAlpha2.default.default,
    isAlphaNumeric: import_isAlphanumeric2.default.default,
    isIP: import_isIP2.default.default,
    isUUID: import_isUUID2.default.default,
    isAscii: import_isAscii2.default.default,
    isCreditCard: import_isCreditCard2.default.default,
    isIBAN: import_isIBAN2.default.default,
    isJWT: import_isJWT2.default.default,
    isLatLong: import_isLatLong2.default.default,
    isMobilePhone: import_isMobilePhone3.default.default,
    isPassportNumber: import_isPassportNumber2.default.default,
    isPostalCode: import_isPostalCode3.default.default,
    isSlug: import_isSlug2.default.default,
    isDecimal: import_isDecimal2.default.default,
    mobileLocales: import_isMobilePhone22.locales,
    postalCountryCodes: import_isPostalCode22.locales,
    passportCountryCodes: [
      "AM",
      "AR",
      "AT",
      "AU",
      "AZ",
      "BE",
      "BG",
      "BR",
      "BY",
      "CA",
      "CH",
      "CY",
      "CZ",
      "DE",
      "DK",
      "DZ",
      "ES",
      "FI",
      "FR",
      "GB",
      "GR",
      "HR",
      "HU",
      "IE",
      "IN",
      "ID",
      "IR",
      "IS",
      "IT",
      "JM",
      "JP",
      "KR",
      "KZ",
      "LI",
      "LT",
      "LU",
      "LV",
      "LY",
      "MT",
      "MZ",
      "MY",
      "MX",
      "NL",
      "NZ",
      "PH",
      "PK",
      "PL",
      "PT",
      "RO",
      "RU",
      "SE",
      "SL",
      "SK",
      "TH",
      "TR",
      "UA",
      "US"
    ],
    isHexColor: (value) => {
      if (!value.startsWith("#")) {
        return false;
      }
      return import_isHexColor2.default.default(value);
    },
    isActiveURL: async (url) => {
      const { resolve4, resolve6 } = await import("dns/promises");
      try {
        const { hostname } = new URL(url);
        const v6Addresses = await resolve6(hostname);
        if (v6Addresses.length) {
          return true;
        } else {
          const v4Addresses = await resolve4(hostname);
          return v4Addresses.length > 0;
        }
      } catch {
        return false;
      }
    },
    isDistinct: (dataSet, fields22) => {
      const uniqueItems = /* @__PURE__ */ new Set;
      if (!fields22) {
        for (let item of dataSet) {
          if (helpers32.exists(item)) {
            if (uniqueItems.has(item)) {
              return false;
            } else {
              uniqueItems.add(item);
            }
          }
        }
        return true;
      }
      const fieldsList = Array.isArray(fields22) ? fields22 : [fields22];
      for (let item of dataSet) {
        if (helpers32.isObject(item) && helpers32.hasKeys(item, fieldsList)) {
          const element = fieldsList.map((field) => item[field]).join("_");
          if (uniqueItems.has(element)) {
            return false;
          } else {
            uniqueItems.add(element);
          }
        }
      }
      return true;
    },
    getNestedValue(key, field) {
      if (key.indexOf(".") > -1) {
        return dlv_es_default2(field.data, key);
      }
      return field.parent[key];
    }
  };
});
var Macroable2 = class {
  static macro(name, value) {
    this.prototype[name] = value;
  }
  static getter(name, accumulator, singleton = false) {
    Object.defineProperty(this.prototype, name, {
      get() {
        const value = accumulator.call(this);
        if (singleton) {
          Object.defineProperty(this, name, {
            configurable: false,
            enumerable: false,
            value,
            writable: false
          });
        }
        return value;
      },
      configurable: true,
      enumerable: false
    });
  }
};
var init_build = () => {
};
function camelCase22(input, options22) {
  if (!(typeof input === "string" || Array.isArray(input))) {
    throw new TypeError("Expected the input to be `string | string[]`");
  }
  options22 = {
    pascalCase: false,
    preserveConsecutiveUppercase: false,
    ...options22
  };
  if (Array.isArray(input)) {
    input = input.map((x) => x.trim()).filter((x) => x.length).join("-");
  } else {
    input = input.trim();
  }
  if (input.length === 0) {
    return "";
  }
  const toLowerCase = options22.locale === false ? (string2) => string2.toLowerCase() : (string2) => string2.toLocaleLowerCase(options22.locale);
  const toUpperCase = options22.locale === false ? (string2) => string2.toUpperCase() : (string2) => string2.toLocaleUpperCase(options22.locale);
  if (input.length === 1) {
    if (SEPARATORS2.test(input)) {
      return "";
    }
    return options22.pascalCase ? toUpperCase(input) : toLowerCase(input);
  }
  const hasUpperCase = input !== toLowerCase(input);
  if (hasUpperCase) {
    input = preserveCamelCase2(input, toLowerCase, toUpperCase, options22.preserveConsecutiveUppercase);
  }
  input = input.replace(LEADING_SEPARATORS2, "");
  input = options22.preserveConsecutiveUppercase ? preserveConsecutiveUppercase2(input, toLowerCase) : toLowerCase(input);
  if (options22.pascalCase) {
    input = toUpperCase(input.charAt(0)) + input.slice(1);
  }
  return postProcess2(input, toUpperCase);
}
var UPPERCASE2;
var LOWERCASE2;
var LEADING_CAPITAL2;
var IDENTIFIER2;
var SEPARATORS2;
var LEADING_SEPARATORS2;
var SEPARATORS_AND_IDENTIFIER2;
var NUMBERS_AND_IDENTIFIER2;
var preserveCamelCase2 = (string2, toLowerCase, toUpperCase, preserveConsecutiveUppercase2) => {
  let isLastCharLower = false;
  let isLastCharUpper = false;
  let isLastLastCharUpper = false;
  let isLastLastCharPreserved = false;
  for (let index = 0;index < string2.length; index++) {
    const character = string2[index];
    isLastLastCharPreserved = index > 2 ? string2[index - 3] === "-" : true;
    if (isLastCharLower && UPPERCASE2.test(character)) {
      string2 = string2.slice(0, index) + "-" + string2.slice(index);
      isLastCharLower = false;
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = true;
      index++;
    } else if (isLastCharUpper && isLastLastCharUpper && LOWERCASE2.test(character) && (!isLastLastCharPreserved || preserveConsecutiveUppercase2)) {
      string2 = string2.slice(0, index - 1) + "-" + string2.slice(index - 1);
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = false;
      isLastCharLower = true;
    } else {
      isLastCharLower = toLowerCase(character) === character && toUpperCase(character) !== character;
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = toUpperCase(character) === character && toLowerCase(character) !== character;
    }
  }
  return string2;
};
var preserveConsecutiveUppercase2 = (input, toLowerCase) => {
  LEADING_CAPITAL2.lastIndex = 0;
  return input.replaceAll(LEADING_CAPITAL2, (match) => toLowerCase(match));
};
var postProcess2 = (input, toUpperCase) => {
  SEPARATORS_AND_IDENTIFIER2.lastIndex = 0;
  NUMBERS_AND_IDENTIFIER2.lastIndex = 0;
  return input.replaceAll(NUMBERS_AND_IDENTIFIER2, (match, pattern, offset) => ["_", "-"].includes(input.charAt(offset + match.length)) ? match : toUpperCase(match)).replaceAll(SEPARATORS_AND_IDENTIFIER2, (_2, identifier) => toUpperCase(identifier));
};
var init_camelcase = __esm2(() => {
  UPPERCASE2 = /[\p{Lu}]/u;
  LOWERCASE2 = /[\p{Ll}]/u;
  LEADING_CAPITAL2 = /^[\p{Lu}](?![\p{Lu}])/gu;
  IDENTIFIER2 = /([\p{Alpha}\p{N}_]|$)/u;
  SEPARATORS2 = /[_.\- ]+/;
  LEADING_SEPARATORS2 = new RegExp("^" + SEPARATORS2.source);
  SEPARATORS_AND_IDENTIFIER2 = new RegExp(SEPARATORS2.source + IDENTIFIER2.source, "gu");
  NUMBERS_AND_IDENTIFIER2 = new RegExp("\\d+" + IDENTIFIER2.source, "gu");
});
var require_dayjs_min2 = __commonJS2((exports, module) => {
  (function(t, e) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = e() : typeof define == "function" && define.amd ? define(e) : (t = typeof globalThis != "undefined" ? globalThis : t || self).dayjs = e();
  })(exports, function() {
    var t = 1000, e = 60000, n = 3600000, r2 = "millisecond", i = "second", s3 = "minute", u = "hour", a = "day", o = "week", c2 = "month", f3 = "quarter", h3 = "year", d = "date", l3 = "Invalid Date", $3 = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, M2 = { name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"), ordinal: function(t2) {
      var e2 = ["th", "st", "nd", "rd"], n2 = t2 % 100;
      return "[" + t2 + (e2[(n2 - 20) % 10] || e2[n2] || e2[0]) + "]";
    } }, m2 = function(t2, e2, n2) {
      var r22 = String(t2);
      return !r22 || r22.length >= e2 ? t2 : "" + Array(e2 + 1 - r22.length).join(n2) + t2;
    }, v2 = { s: m2, z: function(t2) {
      var e2 = -t2.utcOffset(), n2 = Math.abs(e2), r22 = Math.floor(n2 / 60), i2 = n2 % 60;
      return (e2 <= 0 ? "+" : "-") + m2(r22, 2, "0") + ":" + m2(i2, 2, "0");
    }, m: function t(e2, n2) {
      if (e2.date() < n2.date())
        return -t(n2, e2);
      var r22 = 12 * (n2.year() - e2.year()) + (n2.month() - e2.month()), i2 = e2.clone().add(r22, c2), s22 = n2 - i2 < 0, u2 = e2.clone().add(r22 + (s22 ? -1 : 1), c2);
      return +(-(r22 + (n2 - i2) / (s22 ? i2 - u2 : u2 - i2)) || 0);
    }, a: function(t2) {
      return t2 < 0 ? Math.ceil(t2) || 0 : Math.floor(t2);
    }, p: function(t2) {
      return { M: c2, y: h3, w: o, d: a, D: d, h: u, m: s3, s: i, ms: r2, Q: f3 }[t2] || String(t2 || "").toLowerCase().replace(/s$/, "");
    }, u: function(t2) {
      return t2 === undefined;
    } }, g2 = "en", D = {};
    D[g2] = M2;
    var p4 = "$isDayjsObject", S = function(t2) {
      return t2 instanceof _2 || !(!t2 || !t2[p4]);
    }, w2 = function t(e2, n2, r22) {
      var i2;
      if (!e2)
        return g2;
      if (typeof e2 == "string") {
        var s22 = e2.toLowerCase();
        D[s22] && (i2 = s22), n2 && (D[s22] = n2, i2 = s22);
        var u2 = e2.split("-");
        if (!i2 && u2.length > 1)
          return t(u2[0]);
      } else {
        var a2 = e2.name;
        D[a2] = e2, i2 = a2;
      }
      return !r22 && i2 && (g2 = i2), i2 || !r22 && g2;
    }, O = function(t2, e2) {
      if (S(t2))
        return t2.clone();
      var n2 = typeof e2 == "object" ? e2 : {};
      return n2.date = t2, n2.args = arguments, new _2(n2);
    }, b2 = v2;
    b2.l = w2, b2.i = S, b2.w = function(t2, e2) {
      return O(t2, { locale: e2.$L, utc: e2.$u, x: e2.$x, $offset: e2.$offset });
    };
    var _2 = function() {
      function M22(t2) {
        this.$L = w2(t2.locale, null, true), this.parse(t2), this.$x = this.$x || t2.x || {}, this[p4] = true;
      }
      var m22 = M22.prototype;
      return m22.parse = function(t2) {
        this.$d = function(t3) {
          var { date: e2, utc: n2 } = t3;
          if (e2 === null)
            return new Date(NaN);
          if (b2.u(e2))
            return new Date;
          if (e2 instanceof Date)
            return new Date(e2);
          if (typeof e2 == "string" && !/Z$/i.test(e2)) {
            var r22 = e2.match($3);
            if (r22) {
              var i2 = r22[2] - 1 || 0, s22 = (r22[7] || "0").substring(0, 3);
              return n2 ? new Date(Date.UTC(r22[1], i2, r22[3] || 1, r22[4] || 0, r22[5] || 0, r22[6] || 0, s22)) : new Date(r22[1], i2, r22[3] || 1, r22[4] || 0, r22[5] || 0, r22[6] || 0, s22);
            }
          }
          return new Date(e2);
        }(t2), this.init();
      }, m22.init = function() {
        var t2 = this.$d;
        this.$y = t2.getFullYear(), this.$M = t2.getMonth(), this.$D = t2.getDate(), this.$W = t2.getDay(), this.$H = t2.getHours(), this.$m = t2.getMinutes(), this.$s = t2.getSeconds(), this.$ms = t2.getMilliseconds();
      }, m22.$utils = function() {
        return b2;
      }, m22.isValid = function() {
        return !(this.$d.toString() === l3);
      }, m22.isSame = function(t2, e2) {
        var n2 = O(t2);
        return this.startOf(e2) <= n2 && n2 <= this.endOf(e2);
      }, m22.isAfter = function(t2, e2) {
        return O(t2) < this.startOf(e2);
      }, m22.isBefore = function(t2, e2) {
        return this.endOf(e2) < O(t2);
      }, m22.$g = function(t2, e2, n2) {
        return b2.u(t2) ? this[e2] : this.set(n2, t2);
      }, m22.unix = function() {
        return Math.floor(this.valueOf() / 1000);
      }, m22.valueOf = function() {
        return this.$d.getTime();
      }, m22.startOf = function(t2, e2) {
        var n2 = this, r22 = !!b2.u(e2) || e2, f22 = b2.p(t2), l22 = function(t3, e3) {
          var i2 = b2.w(n2.$u ? Date.UTC(n2.$y, e3, t3) : new Date(n2.$y, e3, t3), n2);
          return r22 ? i2 : i2.endOf(a);
        }, $22 = function(t3, e3) {
          return b2.w(n2.toDate()[t3].apply(n2.toDate("s"), (r22 ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e3)), n2);
        }, y2 = this.$W, M3 = this.$M, m3 = this.$D, v22 = "set" + (this.$u ? "UTC" : "");
        switch (f22) {
          case h3:
            return r22 ? l22(1, 0) : l22(31, 11);
          case c2:
            return r22 ? l22(1, M3) : l22(0, M3 + 1);
          case o:
            var g22 = this.$locale().weekStart || 0, D2 = (y2 < g22 ? y2 + 7 : y2) - g22;
            return l22(r22 ? m3 - D2 : m3 + (6 - D2), M3);
          case a:
          case d:
            return $22(v22 + "Hours", 0);
          case u:
            return $22(v22 + "Minutes", 1);
          case s3:
            return $22(v22 + "Seconds", 2);
          case i:
            return $22(v22 + "Milliseconds", 3);
          default:
            return this.clone();
        }
      }, m22.endOf = function(t2) {
        return this.startOf(t2, false);
      }, m22.$set = function(t2, e2) {
        var n2, o2 = b2.p(t2), f22 = "set" + (this.$u ? "UTC" : ""), l22 = (n2 = {}, n2[a] = f22 + "Date", n2[d] = f22 + "Date", n2[c2] = f22 + "Month", n2[h3] = f22 + "FullYear", n2[u] = f22 + "Hours", n2[s3] = f22 + "Minutes", n2[i] = f22 + "Seconds", n2[r2] = f22 + "Milliseconds", n2)[o2], $22 = o2 === a ? this.$D + (e2 - this.$W) : e2;
        if (o2 === c2 || o2 === h3) {
          var y2 = this.clone().set(d, 1);
          y2.$d[l22]($22), y2.init(), this.$d = y2.set(d, Math.min(this.$D, y2.daysInMonth())).$d;
        } else
          l22 && this.$d[l22]($22);
        return this.init(), this;
      }, m22.set = function(t2, e2) {
        return this.clone().$set(t2, e2);
      }, m22.get = function(t2) {
        return this[b2.p(t2)]();
      }, m22.add = function(r22, f22) {
        var d2, l22 = this;
        r22 = Number(r22);
        var $22 = b2.p(f22), y2 = function(t2) {
          var e2 = O(l22);
          return b2.w(e2.date(e2.date() + Math.round(t2 * r22)), l22);
        };
        if ($22 === c2)
          return this.set(c2, this.$M + r22);
        if ($22 === h3)
          return this.set(h3, this.$y + r22);
        if ($22 === a)
          return y2(1);
        if ($22 === o)
          return y2(7);
        var M3 = (d2 = {}, d2[s3] = e, d2[u] = n, d2[i] = t, d2)[$22] || 1, m3 = this.$d.getTime() + r22 * M3;
        return b2.w(m3, this);
      }, m22.subtract = function(t2, e2) {
        return this.add(-1 * t2, e2);
      }, m22.format = function(t2) {
        var e2 = this, n2 = this.$locale();
        if (!this.isValid())
          return n2.invalidDate || l3;
        var r22 = t2 || "YYYY-MM-DDTHH:mm:ssZ", i2 = b2.z(this), s22 = this.$H, u2 = this.$m, a2 = this.$M, o2 = n2.weekdays, c22 = n2.months, f22 = n2.meridiem, h22 = function(t3, n3, i3, s32) {
          return t3 && (t3[n3] || t3(e2, r22)) || i3[n3].slice(0, s32);
        }, d2 = function(t3) {
          return b2.s(s22 % 12 || 12, t3, "0");
        }, $22 = f22 || function(t3, e3, n3) {
          var r3 = t3 < 12 ? "AM" : "PM";
          return n3 ? r3.toLowerCase() : r3;
        };
        return r22.replace(y, function(t3, r3) {
          return r3 || function(t4) {
            switch (t4) {
              case "YY":
                return String(e2.$y).slice(-2);
              case "YYYY":
                return b2.s(e2.$y, 4, "0");
              case "M":
                return a2 + 1;
              case "MM":
                return b2.s(a2 + 1, 2, "0");
              case "MMM":
                return h22(n2.monthsShort, a2, c22, 3);
              case "MMMM":
                return h22(c22, a2);
              case "D":
                return e2.$D;
              case "DD":
                return b2.s(e2.$D, 2, "0");
              case "d":
                return String(e2.$W);
              case "dd":
                return h22(n2.weekdaysMin, e2.$W, o2, 2);
              case "ddd":
                return h22(n2.weekdaysShort, e2.$W, o2, 3);
              case "dddd":
                return o2[e2.$W];
              case "H":
                return String(s22);
              case "HH":
                return b2.s(s22, 2, "0");
              case "h":
                return d2(1);
              case "hh":
                return d2(2);
              case "a":
                return $22(s22, u2, true);
              case "A":
                return $22(s22, u2, false);
              case "m":
                return String(u2);
              case "mm":
                return b2.s(u2, 2, "0");
              case "s":
                return String(e2.$s);
              case "ss":
                return b2.s(e2.$s, 2, "0");
              case "SSS":
                return b2.s(e2.$ms, 3, "0");
              case "Z":
                return i2;
            }
            return null;
          }(t3) || i2.replace(":", "");
        });
      }, m22.utcOffset = function() {
        return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
      }, m22.diff = function(r22, d2, l22) {
        var $22, y2 = this, M3 = b2.p(d2), m3 = O(r22), v22 = (m3.utcOffset() - this.utcOffset()) * e, g22 = this - m3, D2 = function() {
          return b2.m(y2, m3);
        };
        switch (M3) {
          case h3:
            $22 = D2() / 12;
            break;
          case c2:
            $22 = D2();
            break;
          case f3:
            $22 = D2() / 3;
            break;
          case o:
            $22 = (g22 - v22) / 604800000;
            break;
          case a:
            $22 = (g22 - v22) / 86400000;
            break;
          case u:
            $22 = g22 / n;
            break;
          case s3:
            $22 = g22 / e;
            break;
          case i:
            $22 = g22 / t;
            break;
          default:
            $22 = g22;
        }
        return l22 ? $22 : b2.a($22);
      }, m22.daysInMonth = function() {
        return this.endOf(c2).$D;
      }, m22.$locale = function() {
        return D[this.$L];
      }, m22.locale = function(t2, e2) {
        if (!t2)
          return this.$L;
        var n2 = this.clone(), r22 = w2(t2, e2, true);
        return r22 && (n2.$L = r22), n2;
      }, m22.clone = function() {
        return b2.w(this.$d, this);
      }, m22.toDate = function() {
        return new Date(this.valueOf());
      }, m22.toJSON = function() {
        return this.isValid() ? this.toISOString() : null;
      }, m22.toISOString = function() {
        return this.$d.toISOString();
      }, m22.toString = function() {
        return this.$d.toUTCString();
      }, M22;
    }(), k = _2.prototype;
    return O.prototype = k, [["$ms", r2], ["$s", i], ["$m", s3], ["$H", u], ["$W", a], ["$M", c2], ["$y", h3], ["$D", d]].forEach(function(t2) {
      k[t2[1]] = function(e2) {
        return this.$g(e2, t2[0], t2[1]);
      };
    }), O.extend = function(t2, e2) {
      return t2.$i || (t2(e2, _2, O), t2.$i = true), O;
    }, O.locale = w2, O.isDayjs = S, O.unix = function(t2) {
      return O(1000 * t2);
    }, O.en = D[g2], O.Ls = D, O.p = {}, O;
  });
});
var require_isSameOrAfter2 = __commonJS2((exports, module) => {
  (function(e, t) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = t() : typeof define == "function" && define.amd ? define(t) : (e = typeof globalThis != "undefined" ? globalThis : e || self).dayjs_plugin_isSameOrAfter = t();
  })(exports, function() {
    return function(e, t) {
      t.prototype.isSameOrAfter = function(e2, t2) {
        return this.isSame(e2, t2) || this.isAfter(e2, t2);
      };
    };
  });
});
var require_isSameOrBefore2 = __commonJS2((exports, module) => {
  (function(e, i) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = i() : typeof define == "function" && define.amd ? define(i) : (e = typeof globalThis != "undefined" ? globalThis : e || self).dayjs_plugin_isSameOrBefore = i();
  })(exports, function() {
    return function(e, i) {
      i.prototype.isSameOrBefore = function(e2, i2) {
        return this.isSame(e2, i2) || this.isBefore(e2, i2);
      };
    };
  });
});
var require_customParseFormat2 = __commonJS2((exports, module) => {
  (function(e, t) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = t() : typeof define == "function" && define.amd ? define(t) : (e = typeof globalThis != "undefined" ? globalThis : e || self).dayjs_plugin_customParseFormat = t();
  })(exports, function() {
    var e = { LTS: "h:mm:ss A", LT: "h:mm A", L: "MM/DD/YYYY", LL: "MMMM D, YYYY", LLL: "MMMM D, YYYY h:mm A", LLLL: "dddd, MMMM D, YYYY h:mm A" }, t = /(\[[^[]*\])|([-_:/.,()\s]+)|(A|a|Q|YYYY|YY?|ww?|MM?M?M?|Do|DD?|hh?|HH?|mm?|ss?|S{1,3}|z|ZZ?)/g, n = /\d/, r2 = /\d\d/, i = /\d\d?/, o = /\d*[^-_:/,()\s\d]+/, s3 = {}, a = function(e2) {
      return (e2 = +e2) + (e2 > 68 ? 1900 : 2000);
    };
    var f3 = function(e2) {
      return function(t2) {
        this[e2] = +t2;
      };
    }, h3 = [/[+-]\d\d:?(\d\d)?|Z/, function(e2) {
      (this.zone || (this.zone = {})).offset = function(e3) {
        if (!e3)
          return 0;
        if (e3 === "Z")
          return 0;
        var t2 = e3.match(/([+-]|\d\d)/g), n2 = 60 * t2[1] + (+t2[2] || 0);
        return n2 === 0 ? 0 : t2[0] === "+" ? -n2 : n2;
      }(e2);
    }], u = function(e2) {
      var t2 = s3[e2];
      return t2 && (t2.indexOf ? t2 : t2.s.concat(t2.f));
    }, d = function(e2, t2) {
      var n2, r22 = s3.meridiem;
      if (r22) {
        for (var i2 = 1;i2 <= 24; i2 += 1)
          if (e2.indexOf(r22(i2, 0, t2)) > -1) {
            n2 = i2 > 12;
            break;
          }
      } else
        n2 = e2 === (t2 ? "pm" : "PM");
      return n2;
    }, c2 = { A: [o, function(e2) {
      this.afternoon = d(e2, false);
    }], a: [o, function(e2) {
      this.afternoon = d(e2, true);
    }], Q: [n, function(e2) {
      this.month = 3 * (e2 - 1) + 1;
    }], S: [n, function(e2) {
      this.milliseconds = 100 * +e2;
    }], SS: [r2, function(e2) {
      this.milliseconds = 10 * +e2;
    }], SSS: [/\d{3}/, function(e2) {
      this.milliseconds = +e2;
    }], s: [i, f3("seconds")], ss: [i, f3("seconds")], m: [i, f3("minutes")], mm: [i, f3("minutes")], H: [i, f3("hours")], h: [i, f3("hours")], HH: [i, f3("hours")], hh: [i, f3("hours")], D: [i, f3("day")], DD: [r2, f3("day")], Do: [o, function(e2) {
      var t2 = s3.ordinal, n2 = e2.match(/\d+/);
      if (this.day = n2[0], t2)
        for (var r22 = 1;r22 <= 31; r22 += 1)
          t2(r22).replace(/\[|\]/g, "") === e2 && (this.day = r22);
    }], w: [i, f3("week")], ww: [r2, f3("week")], M: [i, f3("month")], MM: [r2, f3("month")], MMM: [o, function(e2) {
      var t2 = u("months"), n2 = (u("monthsShort") || t2.map(function(e3) {
        return e3.slice(0, 3);
      })).indexOf(e2) + 1;
      if (n2 < 1)
        throw new Error;
      this.month = n2 % 12 || n2;
    }], MMMM: [o, function(e2) {
      var t2 = u("months").indexOf(e2) + 1;
      if (t2 < 1)
        throw new Error;
      this.month = t2 % 12 || t2;
    }], Y: [/[+-]?\d+/, f3("year")], YY: [r2, function(e2) {
      this.year = a(e2);
    }], YYYY: [/\d{4}/, f3("year")], Z: h3, ZZ: h3 };
    function l3(n2) {
      var r22, i2;
      r22 = n2, i2 = s3 && s3.formats;
      for (var o2 = (n2 = r22.replace(/(\[[^\]]+])|(LTS?|l{1,4}|L{1,4})/g, function(t2, n3, r3) {
        var o3 = r3 && r3.toUpperCase();
        return n3 || i2[r3] || e[r3] || i2[o3].replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g, function(e2, t3, n4) {
          return t3 || n4.slice(1);
        });
      })).match(t), a2 = o2.length, f22 = 0;f22 < a2; f22 += 1) {
        var h22 = o2[f22], u2 = c2[h22], d2 = u2 && u2[0], l22 = u2 && u2[1];
        o2[f22] = l22 ? { regex: d2, parser: l22 } : h22.replace(/^\[|\]$/g, "");
      }
      return function(e2) {
        for (var t2 = {}, n3 = 0, r3 = 0;n3 < a2; n3 += 1) {
          var i3 = o2[n3];
          if (typeof i3 == "string")
            r3 += i3.length;
          else {
            var { regex: s22, parser: f32 } = i3, h32 = e2.slice(r3), u3 = s22.exec(h32)[0];
            f32.call(t2, u3), e2 = e2.replace(u3, "");
          }
        }
        return function(e3) {
          var t3 = e3.afternoon;
          if (t3 !== undefined) {
            var n4 = e3.hours;
            t3 ? n4 < 12 && (e3.hours += 12) : n4 === 12 && (e3.hours = 0), delete e3.afternoon;
          }
        }(t2), t2;
      };
    }
    return function(e2, t2, n2) {
      n2.p.customParseFormat = true, e2 && e2.parseTwoDigitYear && (a = e2.parseTwoDigitYear);
      var r22 = t2.prototype, i2 = r22.parse;
      r22.parse = function(e3) {
        var { date: t3, utc: r3, args: o2 } = e3;
        this.$u = r3;
        var a2 = o2[1];
        if (typeof a2 == "string") {
          var f22 = o2[2] === true, h22 = o2[3] === true, u2 = f22 || h22, d2 = o2[2];
          h22 && (d2 = o2[2]), s3 = this.$locale(), !f22 && d2 && (s3 = n2.Ls[d2]), this.$d = function(e4, t4, n3, r4) {
            try {
              if (["x", "X"].indexOf(t4) > -1)
                return new Date((t4 === "X" ? 1000 : 1) * e4);
              var i3 = l3(t4)(e4), o3 = i3.year, s22 = i3.month, a3 = i3.day, f32 = i3.hours, h32 = i3.minutes, u3 = i3.seconds, d3 = i3.milliseconds, c3 = i3.zone, m22 = i3.week, M22 = new Date, Y2 = a3 || (o3 || s22 ? 1 : M22.getDate()), p4 = o3 || M22.getFullYear(), v2 = 0;
              o3 && !s22 || (v2 = s22 > 0 ? s22 - 1 : M22.getMonth());
              var D, w2 = f32 || 0, g2 = h32 || 0, y = u3 || 0, L = d3 || 0;
              return c3 ? new Date(Date.UTC(p4, v2, Y2, w2, g2, y, L + 60 * c3.offset * 1000)) : n3 ? new Date(Date.UTC(p4, v2, Y2, w2, g2, y, L)) : (D = new Date(p4, v2, Y2, w2, g2, y, L), m22 && (D = r4(D).week(m22).toDate()), D);
            } catch (e5) {
              return new Date("");
            }
          }(t3, a2, r3, n2), this.init(), d2 && d2 !== true && (this.$L = this.locale(d2).$L), u2 && t3 != this.format(a2) && (this.$d = new Date("")), s3 = {};
        } else if (a2 instanceof Array)
          for (var c22 = a2.length, m2 = 1;m2 <= c22; m2 += 1) {
            o2[1] = a2[m2 - 1];
            var M2 = n2.apply(this, o2);
            if (M2.isValid()) {
              this.$d = M2.$d, this.$L = M2.$L, this.init();
              break;
            }
            m2 === c22 && (this.$d = new Date(""));
          }
        else
          i2.call(this, e3);
      };
    };
  });
});
function normalizeUrl2(urlString, options22) {
  options22 = {
    defaultProtocol: "http",
    normalizeProtocol: true,
    forceHttp: false,
    forceHttps: false,
    stripAuthentication: true,
    stripHash: false,
    stripTextFragment: true,
    stripWWW: true,
    removeQueryParameters: [/^utm_\w+/i],
    removeTrailingSlash: true,
    removeSingleSlash: true,
    removeDirectoryIndex: false,
    removeExplicitPort: false,
    sortQueryParameters: true,
    ...options22
  };
  if (typeof options22.defaultProtocol === "string" && !options22.defaultProtocol.endsWith(":")) {
    options22.defaultProtocol = `${options22.defaultProtocol}:`;
  }
  urlString = urlString.trim();
  if (/^data:/i.test(urlString)) {
    return normalizeDataURL2(urlString, options22);
  }
  if (hasCustomProtocol2(urlString)) {
    return urlString;
  }
  const hasRelativeProtocol = urlString.startsWith("//");
  const isRelativeUrl = !hasRelativeProtocol && /^\.*\//.test(urlString);
  if (!isRelativeUrl) {
    urlString = urlString.replace(/^(?!(?:\w+:)?\/\/)|^\/\//, options22.defaultProtocol);
  }
  const urlObject = new URL(urlString);
  if (options22.forceHttp && options22.forceHttps) {
    throw new Error("The `forceHttp` and `forceHttps` options cannot be used together");
  }
  if (options22.forceHttp && urlObject.protocol === "https:") {
    urlObject.protocol = "http:";
  }
  if (options22.forceHttps && urlObject.protocol === "http:") {
    urlObject.protocol = "https:";
  }
  if (options22.stripAuthentication) {
    urlObject.username = "";
    urlObject.password = "";
  }
  if (options22.stripHash) {
    urlObject.hash = "";
  } else if (options22.stripTextFragment) {
    urlObject.hash = urlObject.hash.replace(/#?:~:text.*?$/i, "");
  }
  if (urlObject.pathname) {
    const protocolRegex = /\b[a-z][a-z\d+\-.]{1,50}:\/\//g;
    let lastIndex = 0;
    let result2 = "";
    for (;; ) {
      const match = protocolRegex.exec(urlObject.pathname);
      if (!match) {
        break;
      }
      const protocol = match[0];
      const protocolAtIndex = match.index;
      const intermediate = urlObject.pathname.slice(lastIndex, protocolAtIndex);
      result2 += intermediate.replace(/\/{2,}/g, "/");
      result2 += protocol;
      lastIndex = protocolAtIndex + protocol.length;
    }
    const remnant = urlObject.pathname.slice(lastIndex, urlObject.pathname.length);
    result2 += remnant.replace(/\/{2,}/g, "/");
    urlObject.pathname = result2;
  }
  if (urlObject.pathname) {
    try {
      urlObject.pathname = decodeURI(urlObject.pathname);
    } catch {
    }
  }
  if (options22.removeDirectoryIndex === true) {
    options22.removeDirectoryIndex = [/^index\.[a-z]+$/];
  }
  if (Array.isArray(options22.removeDirectoryIndex) && options22.removeDirectoryIndex.length > 0) {
    let pathComponents = urlObject.pathname.split("/");
    const lastComponent = pathComponents[pathComponents.length - 1];
    if (testParameter2(lastComponent, options22.removeDirectoryIndex)) {
      pathComponents = pathComponents.slice(0, -1);
      urlObject.pathname = pathComponents.slice(1).join("/") + "/";
    }
  }
  if (urlObject.hostname) {
    urlObject.hostname = urlObject.hostname.replace(/\.$/, "");
    if (options22.stripWWW && /^www\.(?!www\.)[a-z\-\d]{1,63}\.[a-z.\-\d]{2,63}$/.test(urlObject.hostname)) {
      urlObject.hostname = urlObject.hostname.replace(/^www\./, "");
    }
  }
  if (Array.isArray(options22.removeQueryParameters)) {
    for (const key of [...urlObject.searchParams.keys()]) {
      if (testParameter2(key, options22.removeQueryParameters)) {
        urlObject.searchParams.delete(key);
      }
    }
  }
  if (!Array.isArray(options22.keepQueryParameters) && options22.removeQueryParameters === true) {
    urlObject.search = "";
  }
  if (Array.isArray(options22.keepQueryParameters) && options22.keepQueryParameters.length > 0) {
    for (const key of [...urlObject.searchParams.keys()]) {
      if (!testParameter2(key, options22.keepQueryParameters)) {
        urlObject.searchParams.delete(key);
      }
    }
  }
  if (options22.sortQueryParameters) {
    urlObject.searchParams.sort();
    try {
      urlObject.search = decodeURIComponent(urlObject.search);
    } catch {
    }
  }
  if (options22.removeTrailingSlash) {
    urlObject.pathname = urlObject.pathname.replace(/\/$/, "");
  }
  if (options22.removeExplicitPort && urlObject.port) {
    urlObject.port = "";
  }
  const oldUrlString = urlString;
  urlString = urlObject.toString();
  if (!options22.removeSingleSlash && urlObject.pathname === "/" && !oldUrlString.endsWith("/") && urlObject.hash === "") {
    urlString = urlString.replace(/\/$/, "");
  }
  if ((options22.removeTrailingSlash || urlObject.pathname === "/") && urlObject.hash === "" && options22.removeSingleSlash) {
    urlString = urlString.replace(/\/$/, "");
  }
  if (hasRelativeProtocol && !options22.normalizeProtocol) {
    urlString = urlString.replace(/^http:\/\//, "//");
  }
  if (options22.stripProtocol) {
    urlString = urlString.replace(/^(?:https?:)?\/\//, "");
  }
  return urlString;
}
var DATA_URL_DEFAULT_MIME_TYPE2 = "text/plain";
var DATA_URL_DEFAULT_CHARSET2 = "us-ascii";
var testParameter2 = (name, filters) => filters.some((filter) => filter instanceof RegExp ? filter.test(name) : filter === name);
var supportedProtocols2;
var hasCustomProtocol2 = (urlString) => {
  try {
    const { protocol } = new URL(urlString);
    return protocol.endsWith(":") && !protocol.includes(".") && !supportedProtocols2.has(protocol);
  } catch {
    return false;
  }
};
var normalizeDataURL2 = (urlString, { stripHash }) => {
  const match = /^data:(?<type>[^,]*?),(?<data>[^#]*?)(?:#(?<hash>.*))?$/.exec(urlString);
  if (!match) {
    throw new Error(`Invalid URL: ${urlString}`);
  }
  let { type, data, hash } = match.groups;
  const mediaType = type.split(";");
  hash = stripHash ? "" : hash;
  let isBase64 = false;
  if (mediaType[mediaType.length - 1] === "base64") {
    mediaType.pop();
    isBase64 = true;
  }
  const mimeType = mediaType.shift()?.toLowerCase() ?? "";
  const attributes = mediaType.map((attribute) => {
    let [key, value = ""] = attribute.split("=").map((string2) => string2.trim());
    if (key === "charset") {
      value = value.toLowerCase();
      if (value === DATA_URL_DEFAULT_CHARSET2) {
        return "";
      }
    }
    return `${key}${value ? `=${value}` : ""}`;
  }).filter(Boolean);
  const normalizedMediaType = [
    ...attributes
  ];
  if (isBase64) {
    normalizedMediaType.push("base64");
  }
  if (normalizedMediaType.length > 0 || mimeType && mimeType !== DATA_URL_DEFAULT_MIME_TYPE2) {
    normalizedMediaType.unshift(mimeType);
  }
  return `data:${normalizedMediaType.join(";")},${isBase64 ? data.trim() : data}${hash ? `#${hash}` : ""}`;
};
var init_normalize_url = __esm2(() => {
  supportedProtocols2 = new Set([
    "https:",
    "http:",
    "file:"
  ]);
});
var require_escape2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = escape2;
  var _assertString = _interopRequireDefault(require_assertString2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function escape2(str) {
    (0, _assertString.default)(str);
    return str.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\//g, "&#x2F;").replace(/\\/g, "&#x5C;").replace(/`/g, "&#96;");
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_normalizeEmail2 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = normalizeEmail;
  var _merge = _interopRequireDefault(require_merge2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_normalize_email_options = {
    all_lowercase: true,
    gmail_lowercase: true,
    gmail_remove_dots: true,
    gmail_remove_subaddress: true,
    gmail_convert_googlemaildotcom: true,
    outlookdotcom_lowercase: true,
    outlookdotcom_remove_subaddress: true,
    yahoo_lowercase: true,
    yahoo_remove_subaddress: true,
    yandex_lowercase: true,
    icloud_lowercase: true,
    icloud_remove_subaddress: true
  };
  var icloud_domains = ["icloud.com", "me.com"];
  var outlookdotcom_domains = ["hotmail.at", "hotmail.be", "hotmail.ca", "hotmail.cl", "hotmail.co.il", "hotmail.co.nz", "hotmail.co.th", "hotmail.co.uk", "hotmail.com", "hotmail.com.ar", "hotmail.com.au", "hotmail.com.br", "hotmail.com.gr", "hotmail.com.mx", "hotmail.com.pe", "hotmail.com.tr", "hotmail.com.vn", "hotmail.cz", "hotmail.de", "hotmail.dk", "hotmail.es", "hotmail.fr", "hotmail.hu", "hotmail.id", "hotmail.ie", "hotmail.in", "hotmail.it", "hotmail.jp", "hotmail.kr", "hotmail.lv", "hotmail.my", "hotmail.ph", "hotmail.pt", "hotmail.sa", "hotmail.sg", "hotmail.sk", "live.be", "live.co.uk", "live.com", "live.com.ar", "live.com.mx", "live.de", "live.es", "live.eu", "live.fr", "live.it", "live.nl", "msn.com", "outlook.at", "outlook.be", "outlook.cl", "outlook.co.il", "outlook.co.nz", "outlook.co.th", "outlook.com", "outlook.com.ar", "outlook.com.au", "outlook.com.br", "outlook.com.gr", "outlook.com.pe", "outlook.com.tr", "outlook.com.vn", "outlook.cz", "outlook.de", "outlook.dk", "outlook.es", "outlook.fr", "outlook.hu", "outlook.id", "outlook.ie", "outlook.in", "outlook.it", "outlook.jp", "outlook.kr", "outlook.lv", "outlook.my", "outlook.ph", "outlook.pt", "outlook.sa", "outlook.sg", "outlook.sk", "passport.com"];
  var yahoo_domains = ["rocketmail.com", "yahoo.ca", "yahoo.co.uk", "yahoo.com", "yahoo.de", "yahoo.fr", "yahoo.in", "yahoo.it", "ymail.com"];
  var yandex_domains = ["yandex.ru", "yandex.ua", "yandex.kz", "yandex.com", "yandex.by", "ya.ru"];
  function dotsReplacer(match) {
    if (match.length > 1) {
      return match;
    }
    return "";
  }
  function normalizeEmail(email22, options22) {
    options22 = (0, _merge.default)(options22, default_normalize_email_options);
    var raw_parts = email22.split("@");
    var domain = raw_parts.pop();
    var user = raw_parts.join("@");
    var parts = [user, domain];
    parts[1] = parts[1].toLowerCase();
    if (parts[1] === "gmail.com" || parts[1] === "googlemail.com") {
      if (options22.gmail_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (options22.gmail_remove_dots) {
        parts[0] = parts[0].replace(/\.+/g, dotsReplacer);
      }
      if (!parts[0].length) {
        return false;
      }
      if (options22.all_lowercase || options22.gmail_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
      parts[1] = options22.gmail_convert_googlemaildotcom ? "gmail.com" : parts[1];
    } else if (icloud_domains.indexOf(parts[1]) >= 0) {
      if (options22.icloud_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options22.all_lowercase || options22.icloud_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (outlookdotcom_domains.indexOf(parts[1]) >= 0) {
      if (options22.outlookdotcom_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options22.all_lowercase || options22.outlookdotcom_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (yahoo_domains.indexOf(parts[1]) >= 0) {
      if (options22.yahoo_remove_subaddress) {
        var components2 = parts[0].split("-");
        parts[0] = components2.length > 1 ? components2.slice(0, -1).join("-") : components2[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options22.all_lowercase || options22.yahoo_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (yandex_domains.indexOf(parts[1]) >= 0) {
      if (options22.all_lowercase || options22.yandex_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
      parts[1] = "yandex.ru";
    } else if (options22.all_lowercase) {
      parts[0] = parts[0].toLowerCase();
    }
    return parts.join("@");
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
function defineFieldVariables2({
  parseFnRefId,
  variableName,
  wildCardPath,
  isArrayMember,
  valueExpression,
  parentExpression,
  fieldNameExpression,
  parentValueExpression
}) {
  const inValueExpression = parseFnRefId ? `refs['${parseFnRefId}'](${valueExpression}, {
      data: root,
      meta: meta,
      parent: ${parentValueExpression}
    })` : valueExpression;
  let fieldPathOutputExpression = "";
  if (parentExpression === "root" || parentExpression === "root_item") {
    fieldPathOutputExpression = fieldNameExpression;
  } else if (fieldNameExpression !== "''") {
    fieldPathOutputExpression = `${parentExpression}.getFieldPath() + '.' + ${fieldNameExpression}`;
  }
  return `const ${variableName} = defineValue(${inValueExpression}, {
  data: root,
  meta: meta,
  name: ${fieldNameExpression},
  wildCardPath: '${wildCardPath}',
  getFieldPath() {
    return ${fieldPathOutputExpression};
  },
  mutate: defineValue,
  report: report,
  isValid: true,
  parent: ${parentValueExpression},
  isArrayMember: ${isArrayMember},
});`;
}
function defineArrayGuard2({ variableName, guardedCodeSnippet }) {
  return `if (ensureIsArray(${variableName})) {
${guardedCodeSnippet}
}`;
}
function defineIsValidGuard2({ variableName, bail, guardedCodeSnippet }) {
  if (!bail) {
    return guardedCodeSnippet;
  }
  return `if (${variableName}.isValid) {
${guardedCodeSnippet}
}`;
}
function defineFieldNullOutput2({
  allowNull,
  conditional,
  variableName,
  outputExpression,
  transformFnRefId
}) {
  if (!allowNull) {
    return "";
  }
  return `${conditional || "if"}(${variableName}.value === null) {
  ${outputExpression} = ${transformFnRefId ? `refs['${transformFnRefId}'](null, ${variableName});` : "null;"}
}`;
}
function wrapInConditional2(conditions, wrappingCode) {
  const [first, second] = conditions;
  if (first && second) {
    return `if (${first} && ${second}) {
  ${wrappingCode}
}`;
  }
  if (first) {
    return `if (${first}) {
  ${wrappingCode}
}`;
  }
  if (second) {
    return `if (${second}) {
  ${wrappingCode}
}`;
  }
  return wrappingCode;
}
function emitValidationSnippet2({ isAsync, implicit, ruleFnId }, variableName, bail, dropMissingCheck) {
  const rule = `refs['${ruleFnId}']`;
  const callable = `${rule}.validator(${variableName}.value, ${rule}.options, ${variableName});`;
  const bailCondition = bail ? `${variableName}.isValid` : "";
  const implicitCondition = implicit || dropMissingCheck ? "" : `${variableName}.isDefined`;
  return wrapInConditional2([bailCondition, implicitCondition], isAsync ? `await ${callable}` : `${callable}`);
}
function defineFieldValidations2({
  bail,
  validations,
  variableName,
  dropMissingCheck
}) {
  return `${validations.map((one) => emitValidationSnippet2(one, variableName, bail, dropMissingCheck)).join("\n")}`;
}
function defineArrayInitialOutput2({
  variableName,
  outputExpression,
  outputValueExpression
}) {
  return `const ${variableName}_out = ${outputValueExpression};
${outputExpression} = ${variableName}_out;`;
}
function defineFieldExistenceValidations2({
  allowNull,
  isOptional,
  variableName
}) {
  if (isOptional === false) {
    if (allowNull === false) {
      return `ensureExists(${variableName});`;
    } else {
      return `ensureIsDefined(${variableName});`;
    }
  }
  return "";
}
function defineArrayLoop2({
  variableName,
  loopCodeSnippet,
  startingIndex
}) {
  startingIndex = startingIndex || 0;
  return `const ${variableName}_items_size = ${variableName}.value.length;
for (let ${variableName}_i = ${startingIndex}; ${variableName}_i < ${variableName}_items_size; ${variableName}_i++) {
${loopCodeSnippet}
}`;
}
function callParseFunction2({ parseFnRefId, variableName }) {
  if (parseFnRefId) {
    return `${variableName}.value = refs['${parseFnRefId}'](${variableName}.value);`;
  }
  return "";
}
function defineElseCondition2({ variableName, conditionalFnRefId }) {
  return `else {
refs['${conditionalFnRefId}'](${variableName}.value, ${variableName});
}`;
}
function defineConditionalGuard2({
  conditional,
  variableName,
  conditionalFnRefId,
  guardedCodeSnippet
}) {
  return `${conditional}(refs['${conditionalFnRefId}'](${variableName}.value, ${variableName})) {
${guardedCodeSnippet}
}`;
}
function defineRecordLoop2({ variableName, loopCodeSnippet }) {
  return `const ${variableName}_keys = Object.keys(${variableName}.value);
const ${variableName}_keys_size = ${variableName}_keys.length;
for (let ${variableName}_key_i = 0; ${variableName}_key_i < ${variableName}_keys_size; ${variableName}_key_i++) {
const ${variableName}_i = ${variableName}_keys[${variableName}_key_i];
${loopCodeSnippet}
}`;
}
function defineObjectGuard2({ variableName, guardedCodeSnippet }) {
  return `if (ensureIsObject(${variableName})) {
${guardedCodeSnippet}
}`;
}
function defineObjectInitialOutput2({
  variableName,
  outputExpression,
  outputValueExpression
}) {
  return `const ${variableName}_out = ${outputValueExpression};
${outputExpression} = ${variableName}_out;`;
}
function arrayToString2(arr) {
  return `[${arr.map((str) => `"${str}"`).join(", ")}]`;
}
function defineMoveProperties2({
  variableName,
  fieldsToIgnore,
  allowUnknownProperties
}) {
  if (!allowUnknownProperties) {
    return "";
  }
  const serializedFieldsToIgnore = arrayToString2(fieldsToIgnore);
  return `moveProperties(${variableName}.value, ${variableName}_out, ${serializedFieldsToIgnore});`;
}
function createRootField2(parent) {
  return {
    parentExpression: parent.variableName,
    parentValueExpression: parent.variableName,
    fieldNameExpression: `''`,
    fieldPathExpression: `''`,
    wildCardPath: "",
    variableName: `${parent.variableName}_item`,
    valueExpression: "root",
    outputExpression: parent.outputExpression,
    isArrayMember: false
  };
}
function defineFieldValueOutput2({
  variableName,
  outputExpression,
  transformFnRefId
}) {
  const outputValueExpression = transformFnRefId ? `refs['${transformFnRefId}'](${variableName}.value, ${variableName})` : `${variableName}.value`;
  return `if (${variableName}.isDefined && ${variableName}.isValid) {
  ${outputExpression} = ${outputValueExpression};
}`;
}
function createArrayField2(parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.*` : `*`;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${parent.variableName}_i`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item`,
    valueExpression: `${parent.variableName}.value[${parent.variableName}_i]`,
    outputExpression: `${parent.variableName}_out[${parent.variableName}_i]`,
    isArrayMember: true
  };
}
function createTupleField2(node, parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.${node.fieldName}` : node.fieldName;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${node.fieldName}`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item_${node.fieldName}`,
    valueExpression: `${parent.variableName}.value[${node.fieldName}]`,
    outputExpression: `${parent.variableName}_out[${node.propertyName}]`,
    isArrayMember: true
  };
}
function reportErrors2() {
  return `if(errorReporter.hasErrors) {
  throw errorReporter.createError();
}`;
}
function createObjectField2(node, variablesCounter, parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.${node.fieldName}` : node.fieldName;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `'${node.fieldName}'`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${node.propertyName}_${variablesCounter}`,
    valueExpression: `${parent.variableName}.value['${node.fieldName}']`,
    outputExpression: `${parent.variableName}_out['${node.propertyName}']`,
    isArrayMember: false
  };
}
function createRecordField2(parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.*` : `*`;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${parent.variableName}_i`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item`,
    valueExpression: `${parent.variableName}.value[${parent.variableName}_i]`,
    outputExpression: `${parent.variableName}_out[${parent.variableName}_i]`,
    isArrayMember: false
  };
}
function defineInlineFunctions2(options22) {
  return `function report(message, rule, field, args) {
  field.isValid = false;
  errorReporter.report(messagesProvider.getMessage(message, rule, field, args), rule, field, args);
};
function defineValue(value, field) {
  ${options22.convertEmptyStringsToNull ? `if (value === '') { value = null; }` : ""}
  field.value = value;
  field.isDefined = value !== undefined && value !== null;
  return field;
};
function ensureExists(field) {
  if (field.value === undefined || field.value === null) {
    field.report(REQUIRED, 'required', field);
    return false;
  }
  return true;
};
function ensureIsDefined(field) {
  if (field.value === undefined) {
    field.report(REQUIRED, 'required', field);
    return false;
  }
  return true;
};
function ensureIsObject(field) {
  if (!field.isDefined) {
    return false;
  }
  if (typeof field.value == 'object' && !Array.isArray(field.value)) {
    return true;
  }
  field.report(NOT_AN_OBJECT, 'object', field);
  return false;
};
function ensureIsArray(field) {
  if (!field.isDefined) {
    return false;
  }
  if (Array.isArray(field.value)) {
    return true;
  }
  field.report(NOT_AN_ARRAY, 'array', field);
  return false;
};
function copyProperties(val) {
  let k, out, tmp;

  if (Array.isArray(val)) {
    out = Array((k = val.length))
    while (k--) out[k] = (tmp = val[k]) && typeof tmp == 'object' ? copyProperties(tmp) : tmp
    return out
  }

  if (Object.prototype.toString.call(val) === '[object Object]') {
    out = {} // null
    for (k in val) {
      out[k] = (tmp = val[k]) && typeof tmp == 'object' ? copyProperties(tmp) : tmp
    }
    return out
  }
  return val
};
function moveProperties(source, destination, ignoreKeys) {
  for (let key in source) {
    if (!ignoreKeys.includes(key)) {
      const value = source[key]
      destination[key] = copyProperties(value)
    }
  }
};`;
}
function defineInlineErrorMessages2(messages3) {
  return `const REQUIRED = '${messages3.required}';
const NOT_AN_OBJECT = '${messages3.object}';
const NOT_AN_ARRAY = '${messages3.array}';`;
}
function refsBuilder2() {
  let counter = 0;
  const refs = {};
  return {
    toJSON() {
      return refs;
    },
    track(value) {
      counter++;
      const ref = `ref://${counter}`;
      refs[ref] = value;
      return ref;
    },
    trackValidation(validation) {
      return this.track(validation);
    },
    trackParser(fn) {
      return this.track(fn);
    },
    trackTransformer(fn) {
      return this.track(fn);
    },
    trackConditional(fn) {
      return this.track(fn);
    }
  };
}
var CompilerBuffer2 = class _CompilerBuffer2 {
  #content = "";
  newLine = "\n";
  writeStatement(statement) {
    this.#content = `${this.#content}${this.newLine}${statement}`;
  }
  child() {
    return new _CompilerBuffer2;
  }
  toString() {
    return this.#content;
  }
  flush() {
    this.#content = "";
  }
};
var BaseNode2 = class {
  #node;
  #parentField;
  field;
  constructor(node, compiler, parent, parentField) {
    this.#parentField = parentField;
    this.#node = node;
    if (this.#parentField) {
      this.field = this.#parentField;
    } else {
      compiler.variablesCounter++;
      this.field = compiler.createFieldFor(node, parent);
    }
  }
  defineField(buffer) {
    if (!this.#parentField) {
      buffer.writeStatement(defineFieldVariables2({
        fieldNameExpression: this.field.fieldNameExpression,
        isArrayMember: this.field.isArrayMember,
        parentExpression: this.field.parentExpression,
        parentValueExpression: this.field.parentValueExpression,
        valueExpression: this.field.valueExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath,
        parseFnRefId: "parseFnId" in this.#node ? this.#node.parseFnId : undefined
      }));
    }
  }
};
var TupleNodeCompiler2;
var ArrayNodeCompiler2;
var UnionNodeCompiler2;
var RecordNodeCompiler2;
var ObjectNodeCompiler2;
var LiteralNodeCompiler2;
var AsyncFunction2;
var Compiler2 = class {
  variablesCounter = 0;
  #rootNode;
  #options;
  #buffer = new CompilerBuffer2;
  constructor(rootNode, options22) {
    this.#rootNode = rootNode;
    this.#options = options22 || { convertEmptyStringsToNull: false };
  }
  #initiateJSOutput() {
    this.#buffer.writeStatement(defineInlineErrorMessages2({
      required: "value is required",
      object: "value is not a valid object",
      array: "value is not a valid array",
      ...this.#options.messages
    }));
    this.#buffer.writeStatement(defineInlineFunctions2(this.#options));
    this.#buffer.writeStatement("let out;");
  }
  #finishJSOutput() {
    this.#buffer.writeStatement(reportErrors2());
    this.#buffer.writeStatement("return out;");
  }
  #compileNodes() {
    this.compileNode(this.#rootNode.schema, this.#buffer, {
      type: "root",
      variableName: "root",
      outputExpression: "out",
      fieldPathExpression: "out",
      wildCardPath: ""
    });
  }
  #toAsyncFunction() {
    return new AsyncFunction2("root", "meta", "refs", "messagesProvider", "errorReporter", this.#buffer.toString());
  }
  createFieldFor(node, parent) {
    switch (parent.type) {
      case "array":
        return createArrayField2(parent);
      case "root":
        return createRootField2(parent);
      case "object":
        return createObjectField2(node, this.variablesCounter, parent);
      case "tuple":
        return createTupleField2(node, parent);
      case "record":
        return createRecordField2(parent);
    }
  }
  compileNode(node, buffer, parent, parentField) {
    switch (node.type) {
      case "literal":
        return new LiteralNodeCompiler2(node, buffer, this, parent, parentField).compile();
      case "array":
        return new ArrayNodeCompiler2(node, buffer, this, parent, parentField).compile();
      case "record":
        return new RecordNodeCompiler2(node, buffer, this, parent, parentField).compile();
      case "object":
        return new ObjectNodeCompiler2(node, buffer, this, parent, parentField).compile();
      case "tuple":
        return new TupleNodeCompiler2(node, buffer, this, parent, parentField).compile();
      case "union":
        return new UnionNodeCompiler2(node, buffer, this, parent, parentField).compile();
    }
  }
  compile() {
    this.#initiateJSOutput();
    this.#compileNodes();
    this.#finishJSOutput();
    const outputFunction = this.#toAsyncFunction();
    this.variablesCounter = 0;
    this.#buffer.flush();
    return outputFunction;
  }
};
var init_build2 = __esm2(() => {
  TupleNodeCompiler2 = class extends BaseNode2 {
    #node;
    #buffer;
    #compiler;
    constructor(node, buffer, compiler, parent, parentField) {
      super(node, compiler, parent, parentField);
      this.#node = node;
      this.#buffer = buffer;
      this.#compiler = compiler;
    }
    #compileTupleChildren() {
      const buffer = this.#buffer.child();
      const parent = {
        type: "tuple",
        fieldPathExpression: this.field.fieldPathExpression,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath
      };
      this.#node.properties.forEach((child) => {
        this.#compiler.compileNode(child, buffer, parent);
      });
      return buffer.toString();
    }
    compile() {
      this.defineField(this.#buffer);
      this.#buffer.writeStatement(defineFieldExistenceValidations2({
        allowNull: this.#node.allowNull,
        isOptional: this.#node.isOptional,
        variableName: this.field.variableName
      }));
      const isArrayValidBlock = defineIsValidGuard2({
        variableName: this.field.variableName,
        bail: this.#node.bail,
        guardedCodeSnippet: `${defineArrayInitialOutput2({
          variableName: this.field.variableName,
          outputExpression: this.field.outputExpression,
          outputValueExpression: this.#node.allowUnknownProperties ? `copyProperties(${this.field.variableName}.value)` : `[]`
        })}${this.#compileTupleChildren()}`
      });
      const isValueAnArrayBlock = defineArrayGuard2({
        variableName: this.field.variableName,
        guardedCodeSnippet: `${defineFieldValidations2({
          variableName: this.field.variableName,
          validations: this.#node.validations,
          bail: this.#node.bail,
          dropMissingCheck: true
        })}${this.#buffer.newLine}${isArrayValidBlock}`
      });
      this.#buffer.writeStatement(`${isValueAnArrayBlock}${this.#buffer.newLine}${defineFieldNullOutput2({
        allowNull: this.#node.allowNull,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        conditional: "else if"
      })}`);
    }
  };
  ArrayNodeCompiler2 = class extends BaseNode2 {
    #node;
    #buffer;
    #compiler;
    constructor(node, buffer, compiler, parent, parentField) {
      super(node, compiler, parent, parentField);
      this.#node = node;
      this.#buffer = buffer;
      this.#compiler = compiler;
    }
    #compileArrayElements() {
      const arrayElementsBuffer = this.#buffer.child();
      this.#compiler.compileNode(this.#node.each, arrayElementsBuffer, {
        type: "array",
        fieldPathExpression: this.field.fieldPathExpression,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath
      });
      const buffer = this.#buffer.child();
      buffer.writeStatement(defineArrayLoop2({
        variableName: this.field.variableName,
        startingIndex: 0,
        loopCodeSnippet: arrayElementsBuffer.toString()
      }));
      arrayElementsBuffer.flush();
      return buffer.toString();
    }
    compile() {
      this.defineField(this.#buffer);
      this.#buffer.writeStatement(defineFieldExistenceValidations2({
        allowNull: this.#node.allowNull,
        isOptional: this.#node.isOptional,
        variableName: this.field.variableName
      }));
      const isArrayValidBlock = defineIsValidGuard2({
        variableName: this.field.variableName,
        bail: this.#node.bail,
        guardedCodeSnippet: `${defineArrayInitialOutput2({
          variableName: this.field.variableName,
          outputExpression: this.field.outputExpression,
          outputValueExpression: `[]`
        })}${this.#buffer.newLine}${this.#compileArrayElements()}`
      });
      const isValueAnArrayBlock = defineArrayGuard2({
        variableName: this.field.variableName,
        guardedCodeSnippet: `${defineFieldValidations2({
          variableName: this.field.variableName,
          validations: this.#node.validations,
          bail: this.#node.bail,
          dropMissingCheck: true
        })}${this.#buffer.newLine}${isArrayValidBlock}`
      });
      this.#buffer.writeStatement(`${isValueAnArrayBlock}${this.#buffer.newLine}${defineFieldNullOutput2({
        allowNull: this.#node.allowNull,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        conditional: "else if"
      })}`);
    }
  };
  UnionNodeCompiler2 = class extends BaseNode2 {
    #compiler;
    #node;
    #buffer;
    #parent;
    constructor(node, buffer, compiler, parent, parentField) {
      super(node, compiler, parent, parentField);
      this.#node = node;
      this.#buffer = buffer;
      this.#parent = parent;
      this.#compiler = compiler;
    }
    #compileUnionChildren() {
      const childrenBuffer = this.#buffer.child();
      this.#node.conditions.forEach((child, index) => {
        const conditionalBuffer = this.#buffer.child();
        if ("parseFnId" in child.schema) {
          conditionalBuffer.writeStatement(callParseFunction2({
            parseFnRefId: child.schema.parseFnId,
            variableName: this.field.variableName
          }));
        }
        this.#compiler.compileNode(child.schema, conditionalBuffer, this.#parent, this.field);
        childrenBuffer.writeStatement(defineConditionalGuard2({
          conditional: index === 0 ? "if" : "else if",
          variableName: this.field.variableName,
          conditionalFnRefId: child.conditionalFnRefId,
          guardedCodeSnippet: conditionalBuffer.toString()
        }));
        conditionalBuffer.flush();
      });
      if (this.#node.elseConditionalFnRefId && this.#node.conditions.length) {
        childrenBuffer.writeStatement(defineElseCondition2({
          variableName: this.field.variableName,
          conditionalFnRefId: this.#node.elseConditionalFnRefId
        }));
      }
      return childrenBuffer.toString();
    }
    compile() {
      this.defineField(this.#buffer);
      this.#buffer.writeStatement(this.#compileUnionChildren());
    }
  };
  RecordNodeCompiler2 = class extends BaseNode2 {
    #node;
    #buffer;
    #compiler;
    constructor(node, buffer, compiler, parent, parentField) {
      super(node, compiler, parent, parentField);
      this.#node = node;
      this.#buffer = buffer;
      this.#compiler = compiler;
    }
    #compileRecordElements() {
      const buffer = this.#buffer.child();
      const recordElementsBuffer = this.#buffer.child();
      this.#compiler.compileNode(this.#node.each, recordElementsBuffer, {
        type: "record",
        fieldPathExpression: this.field.fieldPathExpression,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath
      });
      buffer.writeStatement(defineRecordLoop2({
        variableName: this.field.variableName,
        loopCodeSnippet: recordElementsBuffer.toString()
      }));
      recordElementsBuffer.flush();
      return buffer.toString();
    }
    compile() {
      this.defineField(this.#buffer);
      this.#buffer.writeStatement(defineFieldExistenceValidations2({
        allowNull: this.#node.allowNull,
        isOptional: this.#node.isOptional,
        variableName: this.field.variableName
      }));
      const isObjectValidBlock = defineIsValidGuard2({
        variableName: this.field.variableName,
        bail: this.#node.bail,
        guardedCodeSnippet: `${defineObjectInitialOutput2({
          variableName: this.field.variableName,
          outputExpression: this.field.outputExpression,
          outputValueExpression: `{}`
        })}${this.#compileRecordElements()}`
      });
      const isValueAnObjectBlock = defineObjectGuard2({
        variableName: this.field.variableName,
        guardedCodeSnippet: `${defineFieldValidations2({
          variableName: this.field.variableName,
          validations: this.#node.validations,
          bail: this.#node.bail,
          dropMissingCheck: true
        })}${this.#buffer.newLine}${isObjectValidBlock}`
      });
      this.#buffer.writeStatement(`${isValueAnObjectBlock}${this.#buffer.newLine}${defineFieldNullOutput2({
        allowNull: this.#node.allowNull,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        conditional: "else if"
      })}`);
    }
  };
  ObjectNodeCompiler2 = class extends BaseNode2 {
    #node;
    #buffer;
    #compiler;
    constructor(node, buffer, compiler, parent, parentField) {
      super(node, compiler, parent, parentField);
      this.#node = node;
      this.#buffer = buffer;
      this.#compiler = compiler;
    }
    #getFieldNames(node) {
      let fieldNames = node.properties.map((child) => child.fieldName);
      const groupsFieldNames = node.groups.flatMap((group2) => this.#getGroupFieldNames(group2));
      return fieldNames.concat(groupsFieldNames);
    }
    #getGroupFieldNames(group2) {
      return group2.conditions.flatMap((condition) => {
        return this.#getFieldNames(condition.schema);
      });
    }
    #compileObjectChildren() {
      const buffer = this.#buffer.child();
      const parent = {
        type: "object",
        fieldPathExpression: this.field.fieldPathExpression,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath
      };
      this.#node.properties.forEach((child) => this.#compiler.compileNode(child, buffer, parent));
      return buffer.toString();
    }
    #compileObjectGroups() {
      const buffer = this.#buffer.child();
      const parent = {
        type: "object",
        fieldPathExpression: this.field.fieldPathExpression,
        outputExpression: this.field.outputExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath
      };
      this.#node.groups.forEach((group2) => this.#compileObjectGroup(group2, buffer, parent));
      return buffer.toString();
    }
    #compileObjectGroup(group2, buffer, parent) {
      group2.conditions.forEach((condition, index) => {
        const guardBuffer = buffer.child();
        condition.schema.properties.forEach((child) => {
          this.#compiler.compileNode(child, guardBuffer, parent);
        });
        condition.schema.groups.forEach((child) => {
          this.#compileObjectGroup(child, guardBuffer, parent);
        });
        buffer.writeStatement(defineConditionalGuard2({
          variableName: this.field.variableName,
          conditional: index === 0 ? "if" : "else if",
          conditionalFnRefId: condition.conditionalFnRefId,
          guardedCodeSnippet: guardBuffer.toString()
        }));
      });
      if (group2.elseConditionalFnRefId && group2.conditions.length) {
        buffer.writeStatement(defineElseCondition2({
          variableName: this.field.variableName,
          conditionalFnRefId: group2.elseConditionalFnRefId
        }));
      }
    }
    compile() {
      this.defineField(this.#buffer);
      this.#buffer.writeStatement(defineFieldExistenceValidations2({
        allowNull: this.#node.allowNull,
        isOptional: this.#node.isOptional,
        variableName: this.field.variableName
      }));
      const isObjectValidBlock = defineIsValidGuard2({
        variableName: this.field.variableName,
        bail: this.#node.bail,
        guardedCodeSnippet: `${defineObjectInitialOutput2({
          variableName: this.field.variableName,
          outputExpression: this.field.outputExpression,
          outputValueExpression: "{}"
        })}${this.#buffer.newLine}${this.#compileObjectChildren()}${this.#buffer.newLine}${this.#compileObjectGroups()}${this.#buffer.newLine}${defineMoveProperties2({
          variableName: this.field.variableName,
          allowUnknownProperties: this.#node.allowUnknownProperties,
          fieldsToIgnore: this.#node.allowUnknownProperties ? this.#getFieldNames(this.#node) : []
        })}`
      });
      const isValueAnObject = defineObjectGuard2({
        variableName: this.field.variableName,
        guardedCodeSnippet: `${defineFieldValidations2({
          variableName: this.field.variableName,
          validations: this.#node.validations,
          bail: this.#node.bail,
          dropMissingCheck: true
        })}${isObjectValidBlock}`
      });
      this.#buffer.writeStatement(`${isValueAnObject}${this.#buffer.newLine}${defineFieldNullOutput2({
        variableName: this.field.variableName,
        allowNull: this.#node.allowNull,
        outputExpression: this.field.outputExpression,
        conditional: "else if"
      })}`);
    }
  };
  LiteralNodeCompiler2 = class extends BaseNode2 {
    #node;
    #buffer;
    constructor(node, buffer, compiler, parent, parentField) {
      super(node, compiler, parent, parentField);
      this.#node = node;
      this.#buffer = buffer;
    }
    compile() {
      this.defineField(this.#buffer);
      this.#buffer.writeStatement(defineFieldExistenceValidations2({
        allowNull: this.#node.allowNull,
        isOptional: this.#node.isOptional,
        variableName: this.field.variableName
      }));
      this.#buffer.writeStatement(defineFieldValidations2({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: false
      }));
      this.#buffer.writeStatement(`${defineFieldValueOutput2({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        transformFnRefId: this.#node.transformFnId
      })}${this.#buffer.newLine}${defineFieldNullOutput2({
        variableName: this.field.variableName,
        allowNull: this.#node.allowNull,
        outputExpression: this.field.outputExpression,
        transformFnRefId: this.#node.transformFnId,
        conditional: "else if"
      })}`);
    }
  };
  AsyncFunction2 = Object.getPrototypeOf(async function() {
  }).constructor;
});
function createRule2(validator, metaData) {
  const rule = {
    validator,
    isAsync: metaData?.isAsync || validator.constructor.name === "AsyncFunction",
    implicit: metaData?.implicit ?? false
  };
  return function(...options22) {
    return {
      rule,
      options: options22[0]
    };
  };
}
function union2(conditionals) {
  return new VineUnion2(conditionals);
}
function group2(conditionals) {
  return new ObjectGroup2(conditionals);
}
var import_dayjs3;
var import_dayjs22;
var import_isSameOrAfter2;
var import_isSameOrBefore2;
var import_customParseFormat2;
var import_escape2;
var import_normalizeEmail2;
var symbols_exports2;
var UNIQUE_NAME2;
var IS_OF_TYPE2;
var PARSE2;
var ITYPE2;
var OTYPE2;
var COTYPE2;
var VALIDATION2;
var requiredWhen2;
var BaseModifiersType3;
var NullableModifier3;
var OptionalModifier3;
var TransformModifier2;
var BaseLiteralType2;
var VineAny2;
var enumRule2;
var VineEnum2;
var DEFAULT_DATE_FORMATS2;
var dateRule2;
var equalsRule3;
var afterRule2;
var afterOrEqualRule2;
var beforeRule2;
var beforeOrEqualRule2;
var sameAsRule3;
var notSameAsRule3;
var afterFieldRule2;
var afterOrSameAsRule2;
var beforeFieldRule2;
var beforeOrSameAsRule2;
var weekendRule2;
var weekdayRule2;
var VineDate2;
var VineUnion2;
var UnionConditional2;
var BaseModifiersType22;
var NullableModifier22;
var OptionalModifier22;
var BaseType2;
var VineTuple2;
var minLengthRule4;
var maxLengthRule4;
var fixedLengthRule4;
var notEmptyRule2;
var distinctRule2;
var compactRule2;
var VineArray2;
var VineCamelCaseObject2;
var VineObject2;
var minLengthRule22;
var maxLengthRule22;
var fixedLengthRule22;
var validateKeysRule2;
var VineRecord2;
var stringRule2;
var emailRule2;
var mobileRule2;
var ipAddressRule2;
var regexRule2;
var hexCodeRule2;
var urlRule2;
var activeUrlRule2;
var alphaRule2;
var alphaNumericRule2;
var minLengthRule32;
var maxLengthRule32;
var fixedLengthRule32;
var endsWithRule2;
var startsWithRule2;
var sameAsRule22;
var notSameAsRule22;
var confirmedRule2;
var trimRule2;
var normalizeEmailRule2;
var toUpperCaseRule2;
var toLowerCaseRule2;
var toCamelCaseRule2;
var escapeRule2;
var normalizeUrlRule2;
var inRule3;
var notInRule2;
var creditCardRule2;
var passportRule2;
var postalCodeRule2;
var uuidRule2;
var asciiRule2;
var ibanRule2;
var jwtRule2;
var coordinatesRule2;
var VineString2;
var numberRule2;
var minRule2;
var maxRule2;
var rangeRule2;
var positiveRule2;
var negativeRule2;
var decimalRule2;
var withoutDecimalsRule2;
var inRule22;
var VineNumber2;
var booleanRule2;
var VineBoolean2;
var equalsRule22;
var VineLiteral2;
var ACCEPTED_VALUES2;
var acceptedRule2;
var VineAccepted2;
var ObjectGroup2;
var GroupConditional2;
var VineNativeEnum2;
var VineUnionOfTypes2;
var SchemaBuilder2;
var COMPILER_ERROR_MESSAGES2;
var VineValidator2 = class {
  #compiled;
  messagesProvider;
  errorReporter;
  #parse(schema) {
    const refs = refsBuilder2();
    return {
      compilerNode: {
        type: "root",
        schema: schema[PARSE2]("", refs, { toCamelCase: false })
      },
      refs: refs.toJSON()
    };
  }
  constructor(schema, options22) {
    const { compilerNode, refs } = this.#parse(schema);
    this.#compiled = { schema: compilerNode, refs };
    const metaDataValidator = options22.metaDataValidator;
    const validateFn = new Compiler2(compilerNode, {
      convertEmptyStringsToNull: options22.convertEmptyStringsToNull,
      messages: COMPILER_ERROR_MESSAGES2
    }).compile();
    this.errorReporter = options22.errorReporter;
    this.messagesProvider = options22.messagesProvider;
    if (metaDataValidator) {
      this.validate = (data, validateOptions) => {
        let normalizedOptions = validateOptions ?? {};
        const meta = normalizedOptions.meta ?? {};
        const errorReporter = normalizedOptions.errorReporter ?? this.errorReporter;
        const messagesProvider = normalizedOptions.messagesProvider ?? this.messagesProvider;
        metaDataValidator(meta);
        return validateFn(data, meta, refs, messagesProvider, errorReporter());
      };
    } else {
      this.validate = (data, validateOptions) => {
        let normalizedOptions = validateOptions ?? {};
        const meta = normalizedOptions.meta ?? {};
        const errorReporter = normalizedOptions.errorReporter ?? this.errorReporter;
        const messagesProvider = normalizedOptions.messagesProvider ?? this.messagesProvider;
        return validateFn(data, meta, refs, messagesProvider, errorReporter());
      };
    }
  }
  async tryValidate(data, ...[options22]) {
    try {
      const result2 = await this.validate(data, options22);
      return [null, result2];
    } catch (error) {
      if (error instanceof ValidationError2) {
        return [error, null];
      }
      throw error;
    }
  }
  toJSON() {
    const { schema, refs } = this.#compiled;
    return {
      schema: structuredClone(schema),
      refs
    };
  }
};
var Vine2;
var vine2;
var vine_default2;
var init_chunk_46WINKKP = __esm2(() => {
  init_chunk_577THMJC();
  init_chunk_2W32DW3L();
  init_chunk_CSAU5B4Q();
  init_build();
  init_camelcase();
  init_build();
  import_dayjs3 = __toESM3(require_dayjs_min2(), 1);
  import_dayjs22 = __toESM3(require_dayjs_min2(), 1);
  import_isSameOrAfter2 = __toESM3(require_isSameOrAfter2(), 1);
  import_isSameOrBefore2 = __toESM3(require_isSameOrBefore2(), 1);
  import_customParseFormat2 = __toESM3(require_customParseFormat2(), 1);
  init_camelcase();
  init_camelcase();
  init_build();
  init_camelcase();
  init_camelcase();
  init_camelcase();
  init_camelcase();
  init_normalize_url();
  import_escape2 = __toESM3(require_escape2(), 1);
  import_normalizeEmail2 = __toESM3(require_normalizeEmail2(), 1);
  init_camelcase();
  init_build2();
  symbols_exports2 = {};
  __export22(symbols_exports2, {
    COTYPE: () => COTYPE2,
    IS_OF_TYPE: () => IS_OF_TYPE2,
    ITYPE: () => ITYPE2,
    OTYPE: () => OTYPE2,
    PARSE: () => PARSE2,
    UNIQUE_NAME: () => UNIQUE_NAME2,
    VALIDATION: () => VALIDATION2
  });
  UNIQUE_NAME2 = Symbol.for("schema_name");
  IS_OF_TYPE2 = Symbol.for("is_of_type");
  PARSE2 = Symbol.for("parse");
  ITYPE2 = Symbol.for("opaque_input_type");
  OTYPE2 = Symbol.for("opaque_type");
  COTYPE2 = Symbol.for("camelcase_opaque_type");
  VALIDATION2 = Symbol.for("to_validation");
  requiredWhen2 = createRule2((_2, checker, field) => {
    const shouldBeRequired = checker(field);
    if (!field.isDefined && shouldBeRequired) {
      field.report(messages22.required, "required", field);
    }
  }, {
    implicit: true
  });
  BaseModifiersType3 = class extends Macroable2 {
    optional(validations) {
      return new OptionalModifier3(this, validations);
    }
    nullable() {
      return new NullableModifier3(this);
    }
    transform(transformer) {
      return new TransformModifier2(transformer, this);
    }
  };
  NullableModifier3 = class _NullableModifier3 extends BaseModifiersType3 {
    #parent;
    constructor(parent) {
      super();
      this.#parent = parent;
    }
    clone() {
      return new _NullableModifier3(this.#parent.clone());
    }
    [PARSE2](propertyName, refs, options22) {
      const output = this.#parent[PARSE2](propertyName, refs, options22);
      output.allowNull = true;
      return output;
    }
  };
  OptionalModifier3 = class _OptionalModifier3 extends BaseModifiersType3 {
    #parent;
    validations;
    constructor(parent, validations) {
      super();
      this.#parent = parent;
      this.validations = validations || [];
    }
    cloneValidations() {
      return this.validations.map((validation) => {
        return {
          options: validation.options,
          rule: validation.rule
        };
      });
    }
    compileValidations(refs) {
      return this.validations.map((validation) => {
        return {
          ruleFnId: refs.track({
            validator: validation.rule.validator,
            options: validation.options
          }),
          implicit: validation.rule.implicit,
          isAsync: validation.rule.isAsync
        };
      });
    }
    use(validation) {
      this.validations.push(VALIDATION2 in validation ? validation[VALIDATION2]() : validation);
      return this;
    }
    requiredWhen(otherField, operator, expectedValue) {
      if (typeof otherField === "function") {
        return this.use(requiredWhen2(otherField));
      }
      let checker;
      switch (operator) {
        case "=":
          checker = (value) => value === expectedValue;
          break;
        case "!=":
          checker = (value) => value !== expectedValue;
          break;
        case "in":
          checker = (value) => expectedValue.includes(value);
          break;
        case "notIn":
          checker = (value) => !expectedValue.includes(value);
          break;
        case ">":
          checker = (value) => value > expectedValue;
          break;
        case "<":
          checker = (value) => value < expectedValue;
          break;
        case ">=":
          checker = (value) => value >= expectedValue;
          break;
        case "<=":
          checker = (value) => value <= expectedValue;
      }
      return this.use(requiredWhen2((field) => {
        const otherFieldValue = helpers32.getNestedValue(otherField, field);
        return checker(otherFieldValue);
      }));
    }
    requiredIfExists(fields22) {
      const fieldsToExist = Array.isArray(fields22) ? fields22 : [fields22];
      return this.use(requiredWhen2((field) => {
        return fieldsToExist.every((otherField) => helpers32.exists(helpers32.getNestedValue(otherField, field)));
      }));
    }
    requiredIfAnyExists(fields22) {
      return this.use(requiredWhen2((field) => {
        return fields22.some((otherField) => helpers32.exists(helpers32.getNestedValue(otherField, field)));
      }));
    }
    requiredIfMissing(fields22) {
      const fieldsToExist = Array.isArray(fields22) ? fields22 : [fields22];
      return this.use(requiredWhen2((field) => {
        return fieldsToExist.every((otherField) => helpers32.isMissing(helpers32.getNestedValue(otherField, field)));
      }));
    }
    requiredIfAnyMissing(fields22) {
      return this.use(requiredWhen2((field) => {
        return fields22.some((otherField) => helpers32.isMissing(helpers32.getNestedValue(otherField, field)));
      }));
    }
    clone() {
      return new _OptionalModifier3(this.#parent.clone(), this.cloneValidations());
    }
    [PARSE2](propertyName, refs, options22) {
      const output = this.#parent[PARSE2](propertyName, refs, options22);
      output.isOptional = true;
      output.validations = output.validations.concat(this.compileValidations(refs));
      return output;
    }
  };
  TransformModifier2 = class _TransformModifier2 extends BaseModifiersType3 {
    #parent;
    #transform;
    constructor(transform, parent) {
      super();
      this.#transform = transform;
      this.#parent = parent;
    }
    clone() {
      return new _TransformModifier2(this.#transform, this.#parent.clone());
    }
    [PARSE2](propertyName, refs, options22) {
      const output = this.#parent[PARSE2](propertyName, refs, options22);
      output.transformFnId = refs.trackTransformer(this.#transform);
      return output;
    }
  };
  BaseLiteralType2 = class extends BaseModifiersType3 {
    options;
    validations;
    constructor(options22, validations) {
      super();
      this.options = {
        bail: true,
        allowNull: false,
        isOptional: false,
        ...options22
      };
      this.validations = validations || [];
    }
    cloneValidations() {
      return this.validations.map((validation) => {
        return {
          options: validation.options,
          rule: validation.rule
        };
      });
    }
    cloneOptions() {
      return { ...this.options };
    }
    compileValidations(refs) {
      return this.validations.map((validation) => {
        return {
          ruleFnId: refs.track({
            validator: validation.rule.validator,
            options: validation.options
          }),
          implicit: validation.rule.implicit,
          isAsync: validation.rule.isAsync
        };
      });
    }
    parse(callback) {
      this.options.parse = callback;
      return this;
    }
    use(validation) {
      this.validations.push(VALIDATION2 in validation ? validation[VALIDATION2]() : validation);
      return this;
    }
    bail(state) {
      this.options.bail = state;
      return this;
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        type: "literal",
        fieldName: propertyName,
        propertyName: options22.toCamelCase ? camelCase22(propertyName) : propertyName,
        bail: this.options.bail,
        allowNull: this.options.allowNull,
        isOptional: this.options.isOptional,
        parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
        validations: this.compileValidations(refs)
      };
    }
  };
  VineAny2 = class _VineAny2 extends BaseLiteralType2 {
    constructor(options22, validations) {
      super(options22, validations);
    }
    clone() {
      return new _VineAny2(this.cloneOptions(), this.cloneValidations());
    }
  };
  enumRule2 = createRule2((value, options22, field) => {
    const choices = typeof options22.choices === "function" ? options22.choices(field) : options22.choices;
    if (!choices.includes(value)) {
      field.report(messages22.enum, "enum", field, { choices });
    }
  });
  VineEnum2 = class _VineEnum2 extends BaseLiteralType2 {
    static rules = {
      enum: enumRule2
    };
    #values;
    getChoices() {
      return this.#values;
    }
    constructor(values2, options22, validations) {
      super(options22, validations || [enumRule2({ choices: values2 })]);
      this.#values = values2;
    }
    clone() {
      return new _VineEnum2(this.#values, this.cloneOptions(), this.cloneValidations());
    }
  };
  DEFAULT_DATE_FORMATS2 = ["YYYY-MM-DD", "YYYY-MM-DD HH:mm:ss"];
  import_dayjs22.default.extend(import_customParseFormat2.default);
  import_dayjs22.default.extend(import_isSameOrAfter2.default);
  import_dayjs22.default.extend(import_isSameOrBefore2.default);
  dateRule2 = createRule2((value, options22, field) => {
    if (typeof value !== "string" && typeof value !== "number") {
      field.report(messages22.date, "date", field);
      return;
    }
    let isTimestampAllowed = false;
    let formats = options22.formats || DEFAULT_DATE_FORMATS2;
    if (Array.isArray(formats)) {
      formats = [...formats];
      isTimestampAllowed = formats.includes("x");
    } else if (typeof formats !== "string") {
      formats = { ...formats };
      isTimestampAllowed = formats.format === "x";
    }
    const valueAsNumber = isTimestampAllowed ? helpers32.asNumber(value) : value;
    const dateTime = isTimestampAllowed && !Number.isNaN(valueAsNumber) ? import_dayjs22.default(valueAsNumber) : import_dayjs22.default(value, formats, true);
    if (!dateTime.isValid()) {
      field.report(messages22.date, "date", field);
      return;
    }
    field.meta.$value = dateTime;
    field.meta.$formats = formats;
    field.mutate(dateTime.toDate(), field);
  });
  equalsRule3 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const format = options22.format || DEFAULT_DATE_FORMATS2;
    const dateTime = field.meta.$value;
    const expectedValue = typeof options22.expectedValue === "function" ? options22.expectedValue(field) : options22.expectedValue;
    const expectedDateTime = import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      throw new Error(`Invalid datetime value "${expectedValue}" value provided to the equals rule`);
    }
    if (!dateTime.isSame(expectedDateTime, compare)) {
      field.report(messages22["date.equals"], "date.equals", field, {
        expectedValue,
        compare
      });
    }
  });
  afterRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const format = options22.format || DEFAULT_DATE_FORMATS2;
    const dateTime = field.meta.$value;
    const expectedValue = typeof options22.expectedValue === "function" ? options22.expectedValue(field) : options22.expectedValue;
    const expectedDateTime = expectedValue === "today" ? import_dayjs22.default() : expectedValue === "tomorrow" ? import_dayjs22.default().add(1, "day") : import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      throw new Error(`Invalid datetime value "${expectedValue}" value provided to the after rule`);
    }
    if (!dateTime.isAfter(expectedDateTime, compare)) {
      field.report(messages22["date.after"], "date.after", field, {
        expectedValue,
        compare
      });
    }
  });
  afterOrEqualRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const format = options22.format || DEFAULT_DATE_FORMATS2;
    const dateTime = field.meta.$value;
    const expectedValue = typeof options22.expectedValue === "function" ? options22.expectedValue(field) : options22.expectedValue;
    const expectedDateTime = expectedValue === "today" ? import_dayjs22.default() : expectedValue === "tomorrow" ? import_dayjs22.default().add(1, "day") : import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      throw new Error(`Invalid datetime value "${expectedValue}" value provided to the afterOrEqual rule`);
    }
    if (!dateTime.isSameOrAfter(expectedDateTime, compare)) {
      field.report(messages22["date.afterOrEqual"], "date.afterOrEqual", field, {
        expectedValue,
        compare
      });
    }
  });
  beforeRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const format = options22.format || DEFAULT_DATE_FORMATS2;
    const dateTime = field.meta.$value;
    const expectedValue = typeof options22.expectedValue === "function" ? options22.expectedValue(field) : options22.expectedValue;
    const expectedDateTime = expectedValue === "today" ? import_dayjs22.default() : expectedValue === "yesterday" ? import_dayjs22.default().subtract(1, "day") : import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      throw new Error(`Invalid datetime value "${expectedValue}" value provided to the before rule`);
    }
    if (!dateTime.isBefore(expectedDateTime, compare)) {
      field.report(messages22["date.before"], "date.before", field, {
        expectedValue,
        compare
      });
    }
  });
  beforeOrEqualRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const format = options22.format || DEFAULT_DATE_FORMATS2;
    const dateTime = field.meta.$value;
    const expectedValue = typeof options22.expectedValue === "function" ? options22.expectedValue(field) : options22.expectedValue;
    const expectedDateTime = expectedValue === "today" ? import_dayjs22.default() : expectedValue === "yesterday" ? import_dayjs22.default().subtract(1, "day") : import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      throw new Error(`Invalid datetime value "${expectedValue}" value provided to the beforeOrEqual rule`);
    }
    if (!dateTime.isSameOrBefore(expectedDateTime, compare)) {
      field.report(messages22["date.beforeOrEqual"], "date.beforeOrEqual", field, {
        expectedValue,
        compare
      });
    }
  });
  sameAsRule3 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const dateTime = field.meta.$value;
    const format = options22.format || field.meta.$formats;
    const expectedValue = helpers32.getNestedValue(options22.otherField, field);
    const expectedDateTime = import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      return;
    }
    if (!dateTime.isSame(expectedDateTime, compare)) {
      field.report(messages22["date.sameAs"], "date.sameAs", field, {
        otherField: options22.otherField,
        expectedValue,
        compare
      });
    }
  });
  notSameAsRule3 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const dateTime = field.meta.$value;
    const format = options22.format || field.meta.$formats;
    const expectedValue = helpers32.getNestedValue(options22.otherField, field);
    const expectedDateTime = import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      return;
    }
    if (dateTime.isSame(expectedDateTime, compare)) {
      field.report(messages22["date.notSameAs"], "date.notSameAs", field, {
        otherField: options22.otherField,
        expectedValue,
        compare
      });
    }
  });
  afterFieldRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const dateTime = field.meta.$value;
    const format = options22.format || field.meta.$formats;
    const expectedValue = helpers32.getNestedValue(options22.otherField, field);
    const expectedDateTime = import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      return;
    }
    if (!dateTime.isAfter(expectedDateTime, compare)) {
      field.report(messages22["date.afterField"], "date.afterField", field, {
        otherField: options22.otherField,
        expectedValue,
        compare
      });
    }
  });
  afterOrSameAsRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const dateTime = field.meta.$value;
    const format = options22.format || field.meta.$formats;
    const expectedValue = helpers32.getNestedValue(options22.otherField, field);
    const expectedDateTime = import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      return;
    }
    if (!dateTime.isSameOrAfter(expectedDateTime, compare)) {
      field.report(messages22["date.afterOrSameAs"], "date.afterOrSameAs", field, {
        otherField: options22.otherField,
        expectedValue,
        compare
      });
    }
  });
  beforeFieldRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const dateTime = field.meta.$value;
    const format = options22.format || field.meta.$formats;
    const expectedValue = helpers32.getNestedValue(options22.otherField, field);
    const expectedDateTime = import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      return;
    }
    if (!dateTime.isBefore(expectedDateTime, compare)) {
      field.report(messages22["date.beforeField"], "date.beforeField", field, {
        otherField: options22.otherField,
        expectedValue,
        compare
      });
    }
  });
  beforeOrSameAsRule2 = createRule2((_2, options22, field) => {
    if (!field.meta.$value) {
      return;
    }
    const compare = options22.compare || "day";
    const dateTime = field.meta.$value;
    const format = options22.format || field.meta.$formats;
    const expectedValue = helpers32.getNestedValue(options22.otherField, field);
    const expectedDateTime = import_dayjs22.default(expectedValue, format, true);
    if (!expectedDateTime.isValid()) {
      return;
    }
    if (!dateTime.isSameOrBefore(expectedDateTime, compare)) {
      field.report(messages22["date.beforeOrSameAs"], "date.beforeOrSameAs", field, {
        otherField: options22.otherField,
        expectedValue,
        compare
      });
    }
  });
  weekendRule2 = createRule2((_2, __, field) => {
    if (!field.meta.$value) {
      return;
    }
    const dateTime = field.meta.$value;
    const day = dateTime.day();
    if (day !== 0 && day !== 6) {
      field.report(messages22["date.weekend"], "date.weekend", field);
    }
  });
  weekdayRule2 = createRule2((_2, __, field) => {
    if (!field.meta.$value) {
      return;
    }
    const dateTime = field.meta.$value;
    const day = dateTime.day();
    if (day === 0 || day === 6) {
      field.report(messages22["date.weekday"], "date.weekday", field);
    }
  });
  VineDate2 = class _VineDate2 extends BaseLiteralType2 {
    static rules = {
      equals: equalsRule3,
      after: afterRule2,
      afterOrEqual: afterOrEqualRule2,
      before: beforeRule2,
      beforeOrEqual: beforeOrEqualRule2,
      sameAs: sameAsRule3,
      notSameAs: notSameAsRule3,
      afterField: afterFieldRule2,
      afterOrSameAs: afterOrSameAsRule2,
      beforeField: beforeFieldRule2,
      beforeOrSameAs: beforeOrSameAsRule2,
      weekend: weekendRule2,
      weekday: weekdayRule2
    };
    [UNIQUE_NAME2] = "vine.date";
    [IS_OF_TYPE2] = (value) => {
      if (typeof value !== "string") {
        return false;
      }
      return import_dayjs3.default(value, this.options.formats || DEFAULT_DATE_FORMATS2, true).isValid();
    };
    constructor(options22, validations) {
      super(options22, validations || [dateRule2(options22 || {})]);
    }
    equals(expectedValue, options22) {
      return this.use(equalsRule3({ expectedValue, ...options22 }));
    }
    after(expectedValue, options22) {
      return this.use(afterRule2({ expectedValue, ...options22 }));
    }
    afterOrEqual(expectedValue, options22) {
      return this.use(afterOrEqualRule2({ expectedValue, ...options22 }));
    }
    before(expectedValue, options22) {
      return this.use(beforeRule2({ expectedValue, ...options22 }));
    }
    beforeOrEqual(expectedValue, options22) {
      return this.use(beforeOrEqualRule2({ expectedValue, ...options22 }));
    }
    sameAs(otherField, options22) {
      return this.use(sameAsRule3({ otherField, ...options22 }));
    }
    notSameAs(otherField, options22) {
      return this.use(notSameAsRule3({ otherField, ...options22 }));
    }
    afterField(otherField, options22) {
      return this.use(afterFieldRule2({ otherField, ...options22 }));
    }
    afterOrSameAs(otherField, options22) {
      return this.use(afterOrSameAsRule2({ otherField, ...options22 }));
    }
    beforeField(otherField, options22) {
      return this.use(beforeFieldRule2({ otherField, ...options22 }));
    }
    beforeOrSameAs(otherField, options22) {
      return this.use(beforeOrSameAsRule2({ otherField, ...options22 }));
    }
    weekend() {
      return this.use(weekendRule2());
    }
    weekday() {
      return this.use(weekdayRule2());
    }
    clone() {
      return new _VineDate2(this.cloneOptions(), this.cloneValidations());
    }
  };
  VineUnion2 = class _VineUnion2 {
    #conditionals;
    #otherwiseCallback = (_2, field) => {
      field.report(messages22.union, "union", field);
    };
    constructor(conditionals) {
      this.#conditionals = conditionals;
    }
    otherwise(callback) {
      this.#otherwiseCallback = callback;
      return this;
    }
    clone() {
      const cloned = new _VineUnion2(this.#conditionals);
      cloned.otherwise(this.#otherwiseCallback);
      return cloned;
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        type: "union",
        fieldName: propertyName,
        propertyName: options22.toCamelCase ? camelCase22(propertyName) : propertyName,
        elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
        conditions: this.#conditionals.map((conditional) => conditional[PARSE2](propertyName, refs, options22))
      };
    }
  };
  UnionConditional2 = class {
    #schema;
    #conditional;
    constructor(conditional, schema) {
      this.#schema = schema;
      this.#conditional = conditional;
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        conditionalFnRefId: refs.trackConditional(this.#conditional),
        schema: this.#schema[PARSE2](propertyName, refs, options22)
      };
    }
  };
  union2.if = function unionIf(conditon, schema) {
    return new UnionConditional2(conditon, schema);
  };
  union2.else = function unionElse(schema) {
    return new UnionConditional2(() => true, schema);
  };
  BaseModifiersType22 = class extends Macroable2 {
    optional() {
      return new OptionalModifier22(this);
    }
    nullable() {
      return new NullableModifier22(this);
    }
  };
  NullableModifier22 = class _NullableModifier22 extends BaseModifiersType22 {
    #parent;
    constructor(parent) {
      super();
      this.#parent = parent;
    }
    clone() {
      return new _NullableModifier22(this.#parent.clone());
    }
    [PARSE2](propertyName, refs, options22) {
      const output = this.#parent[PARSE2](propertyName, refs, options22);
      if (output.type !== "union") {
        output.allowNull = true;
      }
      return output;
    }
  };
  OptionalModifier22 = class _OptionalModifier22 extends BaseModifiersType22 {
    #parent;
    constructor(parent) {
      super();
      this.#parent = parent;
    }
    clone() {
      return new _OptionalModifier22(this.#parent.clone());
    }
    [PARSE2](propertyName, refs, options22) {
      const output = this.#parent[PARSE2](propertyName, refs, options22);
      if (output.type !== "union") {
        output.isOptional = true;
      }
      return output;
    }
  };
  BaseType2 = class extends BaseModifiersType22 {
    options;
    validations;
    constructor(options22, validations) {
      super();
      this.options = options22 || {
        bail: true,
        allowNull: false,
        isOptional: false
      };
      this.validations = validations || [];
    }
    cloneValidations() {
      return this.validations.map((validation) => {
        return {
          options: validation.options,
          rule: validation.rule
        };
      });
    }
    cloneOptions() {
      return { ...this.options };
    }
    compileValidations(refs) {
      return this.validations.map((validation) => {
        return {
          ruleFnId: refs.track({
            validator: validation.rule.validator,
            options: validation.options
          }),
          implicit: validation.rule.implicit,
          isAsync: validation.rule.isAsync
        };
      });
    }
    parse(callback) {
      this.options.parse = callback;
      return this;
    }
    use(validation) {
      this.validations.push(VALIDATION2 in validation ? validation[VALIDATION2]() : validation);
      return this;
    }
    bail(state) {
      this.options.bail = state;
      return this;
    }
  };
  VineTuple2 = class _VineTuple2 extends BaseType2 {
    #schemas;
    #allowUnknownProperties = false;
    [UNIQUE_NAME2] = "vine.array";
    [IS_OF_TYPE2] = (value) => {
      return Array.isArray(value);
    };
    constructor(schemas, options22, validations) {
      super(options22, validations);
      this.#schemas = schemas;
    }
    allowUnknownProperties() {
      this.#allowUnknownProperties = true;
      return this;
    }
    clone() {
      const cloned = new _VineTuple2(this.#schemas.map((schema) => schema.clone()), this.cloneOptions(), this.cloneValidations());
      if (this.#allowUnknownProperties) {
        cloned.allowUnknownProperties();
      }
      return cloned;
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        type: "tuple",
        fieldName: propertyName,
        propertyName: options22.toCamelCase ? camelCase22(propertyName) : propertyName,
        bail: this.options.bail,
        allowNull: this.options.allowNull,
        isOptional: this.options.isOptional,
        allowUnknownProperties: this.#allowUnknownProperties,
        parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
        validations: this.compileValidations(refs),
        properties: this.#schemas.map((schema, index) => schema[PARSE2](String(index), refs, options22))
      };
    }
  };
  minLengthRule4 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value.length < options22.min) {
      field.report(messages22["array.minLength"], "array.minLength", field, options22);
    }
  });
  maxLengthRule4 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value.length > options22.max) {
      field.report(messages22["array.maxLength"], "array.maxLength", field, options22);
    }
  });
  fixedLengthRule4 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value.length !== options22.size) {
      field.report(messages22["array.fixedLength"], "array.fixedLength", field, options22);
    }
  });
  notEmptyRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (value.length <= 0) {
      field.report(messages22.notEmpty, "notEmpty", field);
    }
  });
  distinctRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isDistinct(value, options22.fields)) {
      field.report(messages22.distinct, "distinct", field, options22);
    }
  });
  compactRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(value.filter((item) => helpers32.exists(item) && item !== ""), field);
  });
  VineArray2 = class _VineArray2 extends BaseType2 {
    static rules = {
      compact: compactRule2,
      notEmpty: notEmptyRule2,
      distinct: distinctRule2,
      minLength: minLengthRule4,
      maxLength: maxLengthRule4,
      fixedLength: fixedLengthRule4
    };
    #schema;
    [UNIQUE_NAME2] = "vine.array";
    [IS_OF_TYPE2] = (value) => {
      return Array.isArray(value);
    };
    constructor(schema, options22, validations) {
      super(options22, validations);
      this.#schema = schema;
    }
    minLength(expectedLength) {
      return this.use(minLengthRule4({ min: expectedLength }));
    }
    maxLength(expectedLength) {
      return this.use(maxLengthRule4({ max: expectedLength }));
    }
    fixedLength(expectedLength) {
      return this.use(fixedLengthRule4({ size: expectedLength }));
    }
    notEmpty() {
      return this.use(notEmptyRule2());
    }
    distinct(fields22) {
      return this.use(distinctRule2({ fields: fields22 }));
    }
    compact() {
      return this.use(compactRule2());
    }
    clone() {
      return new _VineArray2(this.#schema.clone(), this.cloneOptions(), this.cloneValidations());
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        type: "array",
        fieldName: propertyName,
        propertyName: options22.toCamelCase ? camelCase22(propertyName) : propertyName,
        bail: this.options.bail,
        allowNull: this.options.allowNull,
        isOptional: this.options.isOptional,
        each: this.#schema[PARSE2]("*", refs, options22),
        parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
        validations: this.compileValidations(refs)
      };
    }
  };
  VineCamelCaseObject2 = class _VineCamelCaseObject2 extends BaseModifiersType22 {
    #schema;
    [UNIQUE_NAME2] = "types.object";
    [IS_OF_TYPE2] = (value) => {
      return value !== null && typeof value === "object" && !Array.isArray(value);
    };
    constructor(schema) {
      super();
      this.#schema = schema;
    }
    clone() {
      return new _VineCamelCaseObject2(this.#schema.clone());
    }
    [PARSE2](propertyName, refs, options22) {
      options22.toCamelCase = true;
      return this.#schema[PARSE2](propertyName, refs, options22);
    }
  };
  VineObject2 = class _VineObject2 extends BaseType2 {
    #properties;
    #groups = [];
    #allowUnknownProperties = false;
    [UNIQUE_NAME2] = "vine.object";
    [IS_OF_TYPE2] = (value) => {
      return value !== null && typeof value === "object" && !Array.isArray(value);
    };
    constructor(properties, options22, validations) {
      super(options22, validations);
      this.#properties = properties;
    }
    getProperties() {
      return Object.keys(this.#properties).reduce((result2, key) => {
        result2[key] = this.#properties[key].clone();
        return result2;
      }, {});
    }
    allowUnknownProperties() {
      this.#allowUnknownProperties = true;
      return this;
    }
    merge(group22) {
      this.#groups.push(group22);
      return this;
    }
    clone() {
      const cloned = new _VineObject2(this.getProperties(), this.cloneOptions(), this.cloneValidations());
      this.#groups.forEach((group22) => cloned.merge(group22));
      if (this.#allowUnknownProperties) {
        cloned.allowUnknownProperties();
      }
      return cloned;
    }
    toCamelCase() {
      return new VineCamelCaseObject2(this);
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        type: "object",
        fieldName: propertyName,
        propertyName: options22.toCamelCase ? camelCase22(propertyName) : propertyName,
        bail: this.options.bail,
        allowNull: this.options.allowNull,
        isOptional: this.options.isOptional,
        parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
        allowUnknownProperties: this.#allowUnknownProperties,
        validations: this.compileValidations(refs),
        properties: Object.keys(this.#properties).map((property) => {
          return this.#properties[property][PARSE2](property, refs, options22);
        }),
        groups: this.#groups.map((group22) => {
          return group22[PARSE2](refs, options22);
        })
      };
    }
  };
  minLengthRule22 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (Object.keys(value).length < options22.min) {
      field.report(messages22["record.minLength"], "record.minLength", field, options22);
    }
  });
  maxLengthRule22 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (Object.keys(value).length > options22.max) {
      field.report(messages22["record.maxLength"], "record.maxLength", field, options22);
    }
  });
  fixedLengthRule22 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (Object.keys(value).length !== options22.size) {
      field.report(messages22["record.fixedLength"], "record.fixedLength", field, options22);
    }
  });
  validateKeysRule2 = createRule2((value, callback, field) => {
    if (!field.isValid) {
      return;
    }
    callback(Object.keys(value), field);
  });
  VineRecord2 = class _VineRecord2 extends BaseType2 {
    static rules = {
      maxLength: maxLengthRule22,
      minLength: minLengthRule22,
      fixedLength: fixedLengthRule22,
      validateKeys: validateKeysRule2
    };
    #schema;
    [UNIQUE_NAME2] = "vine.object";
    [IS_OF_TYPE2] = (value) => {
      return value !== null && typeof value === "object" && !Array.isArray(value);
    };
    constructor(schema, options22, validations) {
      super(options22, validations);
      this.#schema = schema;
    }
    minLength(expectedLength) {
      return this.use(minLengthRule22({ min: expectedLength }));
    }
    maxLength(expectedLength) {
      return this.use(maxLengthRule22({ max: expectedLength }));
    }
    fixedLength(expectedLength) {
      return this.use(fixedLengthRule22({ size: expectedLength }));
    }
    validateKeys(...args) {
      return this.use(validateKeysRule2(...args));
    }
    clone() {
      return new _VineRecord2(this.#schema.clone(), this.cloneOptions(), this.cloneValidations());
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        type: "record",
        fieldName: propertyName,
        propertyName: options22.toCamelCase ? camelCase22(propertyName) : propertyName,
        bail: this.options.bail,
        allowNull: this.options.allowNull,
        isOptional: this.options.isOptional,
        each: this.#schema[PARSE2]("*", refs, options22),
        parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
        validations: this.compileValidations(refs)
      };
    }
  };
  stringRule2 = createRule2((value, _2, field) => {
    if (typeof value !== "string") {
      field.report(messages22.string, "string", field);
    }
  });
  emailRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isEmail(value, options22)) {
      field.report(messages22.email, "email", field);
    }
  });
  mobileRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const normalizedOptions = options22 && typeof options22 === "function" ? options22(field) : options22;
    const locales22 = normalizedOptions?.locale || "any";
    if (!helpers32.isMobilePhone(value, locales22, normalizedOptions)) {
      field.report(messages22.mobile, "mobile", field);
    }
  });
  ipAddressRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isIP(value, options22?.version)) {
      field.report(messages22.ipAddress, "ipAddress", field);
    }
  });
  regexRule2 = createRule2((value, expression, field) => {
    if (!field.isValid) {
      return;
    }
    if (!expression.test(value)) {
      field.report(messages22.regex, "regex", field);
    }
  });
  hexCodeRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isHexColor(value)) {
      field.report(messages22.hexCode, "hexCode", field);
    }
  });
  urlRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isURL(value, options22)) {
      field.report(messages22.url, "url", field);
    }
  });
  activeUrlRule2 = createRule2(async (value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (!await helpers32.isActiveURL(value)) {
      field.report(messages22.activeUrl, "activeUrl", field);
    }
  });
  alphaRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    let characterSet = "a-zA-Z";
    if (options22) {
      if (options22.allowSpaces) {
        characterSet += "\\s";
      }
      if (options22.allowDashes) {
        characterSet += "-";
      }
      if (options22.allowUnderscores) {
        characterSet += "_";
      }
    }
    const expression = new RegExp(`^[${characterSet}]+$`);
    if (!expression.test(value)) {
      field.report(messages22.alpha, "alpha", field);
    }
  });
  alphaNumericRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    let characterSet = "a-zA-Z0-9";
    if (options22) {
      if (options22.allowSpaces) {
        characterSet += "\\s";
      }
      if (options22.allowDashes) {
        characterSet += "-";
      }
      if (options22.allowUnderscores) {
        characterSet += "_";
      }
    }
    const expression = new RegExp(`^[${characterSet}]+$`);
    if (!expression.test(value)) {
      field.report(messages22.alphaNumeric, "alphaNumeric", field);
    }
  });
  minLengthRule32 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value.length < options22.min) {
      field.report(messages22.minLength, "minLength", field, options22);
    }
  });
  maxLengthRule32 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value.length > options22.max) {
      field.report(messages22.maxLength, "maxLength", field, options22);
    }
  });
  fixedLengthRule32 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value.length !== options22.size) {
      field.report(messages22.fixedLength, "fixedLength", field, options22);
    }
  });
  endsWithRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!value.endsWith(options22.substring)) {
      field.report(messages22.endsWith, "endsWith", field, options22);
    }
  });
  startsWithRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!value.startsWith(options22.substring)) {
      field.report(messages22.startsWith, "startsWith", field, options22);
    }
  });
  sameAsRule22 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const input = helpers32.getNestedValue(options22.otherField, field);
    if (input !== value) {
      field.report(messages22.sameAs, "sameAs", field, options22);
      return;
    }
  });
  notSameAsRule22 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const input = helpers32.getNestedValue(options22.otherField, field);
    if (input === value) {
      field.report(messages22.notSameAs, "notSameAs", field, options22);
      return;
    }
  });
  confirmedRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const otherField = options22?.confirmationField || `${field.name}_confirmation`;
    const input = field.parent[otherField];
    if (input !== value) {
      field.report(messages22.confirmed, "confirmed", field, { otherField });
      return;
    }
  });
  trimRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(value.trim(), field);
  });
  normalizeEmailRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(import_normalizeEmail2.default.default(value, options22), field);
  });
  toUpperCaseRule2 = createRule2((value, locales22, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(value.toLocaleUpperCase(locales22), field);
  });
  toLowerCaseRule2 = createRule2((value, locales22, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(value.toLocaleLowerCase(locales22), field);
  });
  toCamelCaseRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(camelCase22(value), field);
  });
  escapeRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(import_escape2.default.default(value), field);
  });
  normalizeUrlRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    field.mutate(normalizeUrl2(value, options22), field);
  });
  inRule3 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const choices = typeof options22.choices === "function" ? options22.choices(field) : options22.choices;
    if (!choices.includes(value)) {
      field.report(messages22.in, "in", field, options22);
      return;
    }
  });
  notInRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const list = typeof options22.list === "function" ? options22.list(field) : options22.list;
    if (list.includes(value)) {
      field.report(messages22.notIn, "notIn", field, options22);
      return;
    }
  });
  creditCardRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const providers2 = options22 ? typeof options22 === "function" ? options22(field)?.provider || [] : options22.provider : [];
    if (!providers2.length) {
      if (!helpers32.isCreditCard(value)) {
        field.report(messages22.creditCard, "creditCard", field, {
          providersList: "credit"
        });
      }
    } else {
      const matchesAnyProvider = providers2.find((provider) => helpers32.isCreditCard(value, { provider }));
      if (!matchesAnyProvider) {
        field.report(messages22.creditCard, "creditCard", field, {
          providers: providers2,
          providersList: providers2.join("/")
        });
      }
    }
  });
  passportRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const countryCodes = typeof options22 === "function" ? options22(field).countryCode : options22.countryCode;
    const matchesAnyCountryCode = countryCodes.find((countryCode) => helpers32.isPassportNumber(value, countryCode));
    if (!matchesAnyCountryCode) {
      field.report(messages22.passport, "passport", field, { countryCodes });
    }
  });
  postalCodeRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    const countryCodes = options22 ? typeof options22 === "function" ? options22(field)?.countryCode || [] : options22.countryCode : [];
    if (!countryCodes.length) {
      if (!helpers32.isPostalCode(value, "any")) {
        field.report(messages22.postalCode, "postalCode", field);
      }
    } else {
      const matchesAnyCountryCode = countryCodes.find((countryCode) => helpers32.isPostalCode(value, countryCode));
      if (!matchesAnyCountryCode) {
        field.report(messages22.postalCode, "postalCode", field, { countryCodes });
      }
    }
  });
  uuidRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!options22 || !options22.version) {
      if (!helpers32.isUUID(value)) {
        field.report(messages22.uuid, "uuid", field);
      }
    } else {
      const matchesAnyVersion = options22.version.find((version) => helpers32.isUUID(value, version));
      if (!matchesAnyVersion) {
        field.report(messages22.uuid, "uuid", field, options22);
      }
    }
  });
  asciiRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isAscii(value)) {
      field.report(messages22.ascii, "ascii", field);
    }
  });
  ibanRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isIBAN(value)) {
      field.report(messages22.iban, "iban", field);
    }
  });
  jwtRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isJWT(value)) {
      field.report(messages22.jwt, "jwt", field);
    }
  });
  coordinatesRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isLatLong(value)) {
      field.report(messages22.coordinates, "coordinates", field);
    }
  });
  VineString2 = class _VineString2 extends BaseLiteralType2 {
    static rules = {
      in: inRule3,
      jwt: jwtRule2,
      url: urlRule2,
      iban: ibanRule2,
      uuid: uuidRule2,
      trim: trimRule2,
      email: emailRule2,
      alpha: alphaRule2,
      ascii: asciiRule2,
      notIn: notInRule2,
      regex: regexRule2,
      escape: escapeRule2,
      sameAs: sameAsRule22,
      mobile: mobileRule2,
      string: stringRule2,
      hexCode: hexCodeRule2,
      passport: passportRule2,
      endsWith: endsWithRule2,
      confirmed: confirmedRule2,
      activeUrl: activeUrlRule2,
      minLength: minLengthRule32,
      notSameAs: notSameAsRule22,
      maxLength: maxLengthRule32,
      ipAddress: ipAddressRule2,
      creditCard: creditCardRule2,
      postalCode: postalCodeRule2,
      startsWith: startsWithRule2,
      toUpperCase: toUpperCaseRule2,
      toLowerCase: toLowerCaseRule2,
      toCamelCase: toCamelCaseRule2,
      fixedLength: fixedLengthRule32,
      coordinates: coordinatesRule2,
      normalizeUrl: normalizeUrlRule2,
      alphaNumeric: alphaNumericRule2,
      normalizeEmail: normalizeEmailRule2
    };
    [UNIQUE_NAME2] = "vine.string";
    [IS_OF_TYPE2] = (value) => {
      return typeof value === "string";
    };
    constructor(options22, validations) {
      super(options22, validations || [stringRule2()]);
    }
    url(...args) {
      return this.use(urlRule2(...args));
    }
    activeUrl() {
      return this.use(activeUrlRule2());
    }
    email(...args) {
      return this.use(emailRule2(...args));
    }
    mobile(...args) {
      return this.use(mobileRule2(...args));
    }
    ipAddress(version) {
      return this.use(ipAddressRule2(version ? { version } : undefined));
    }
    hexCode() {
      return this.use(hexCodeRule2());
    }
    regex(expression) {
      return this.use(regexRule2(expression));
    }
    alpha(options22) {
      return this.use(alphaRule2(options22));
    }
    alphaNumeric(options22) {
      return this.use(alphaNumericRule2(options22));
    }
    minLength(expectedLength) {
      return this.use(minLengthRule32({ min: expectedLength }));
    }
    maxLength(expectedLength) {
      return this.use(maxLengthRule32({ max: expectedLength }));
    }
    fixedLength(expectedLength) {
      return this.use(fixedLengthRule32({ size: expectedLength }));
    }
    confirmed(options22) {
      return this.use(confirmedRule2(options22));
    }
    trim() {
      return this.use(trimRule2());
    }
    normalizeEmail(options22) {
      return this.use(normalizeEmailRule2(options22));
    }
    toUpperCase() {
      return this.use(toUpperCaseRule2());
    }
    toLowerCase() {
      return this.use(toLowerCaseRule2());
    }
    toCamelCase() {
      return this.use(toCamelCaseRule2());
    }
    escape() {
      return this.use(escapeRule2());
    }
    normalizeUrl(...args) {
      return this.use(normalizeUrlRule2(...args));
    }
    startsWith(substring) {
      return this.use(startsWithRule2({ substring }));
    }
    endsWith(substring) {
      return this.use(endsWithRule2({ substring }));
    }
    sameAs(otherField) {
      return this.use(sameAsRule22({ otherField }));
    }
    notSameAs(otherField) {
      return this.use(notSameAsRule22({ otherField }));
    }
    in(choices) {
      return this.use(inRule3({ choices }));
    }
    notIn(list) {
      return this.use(notInRule2({ list }));
    }
    creditCard(...args) {
      return this.use(creditCardRule2(...args));
    }
    passport(...args) {
      return this.use(passportRule2(...args));
    }
    postalCode(...args) {
      return this.use(postalCodeRule2(...args));
    }
    uuid(...args) {
      return this.use(uuidRule2(...args));
    }
    ascii() {
      return this.use(asciiRule2());
    }
    iban() {
      return this.use(ibanRule2());
    }
    jwt() {
      return this.use(jwtRule2());
    }
    coordinates() {
      return this.use(coordinatesRule2());
    }
    clone() {
      return new _VineString2(this.cloneOptions(), this.cloneValidations());
    }
  };
  numberRule2 = createRule2((value, options22, field) => {
    const valueAsNumber = options22.strict ? value : helpers32.asNumber(value);
    if (typeof valueAsNumber !== "number" || Number.isNaN(valueAsNumber) || valueAsNumber === Number.POSITIVE_INFINITY || valueAsNumber === Number.NEGATIVE_INFINITY) {
      field.report(messages22.number, "number", field);
      return;
    }
    field.mutate(valueAsNumber, field);
  });
  minRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value < options22.min) {
      field.report(messages22.min, "min", field, options22);
    }
  });
  maxRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value > options22.max) {
      field.report(messages22.max, "max", field, options22);
    }
  });
  rangeRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (value < options22.min || value > options22.max) {
      field.report(messages22.range, "range", field, options22);
    }
  });
  positiveRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (value < 0) {
      field.report(messages22.positive, "positive", field);
    }
  });
  negativeRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (value >= 0) {
      field.report(messages22.negative, "negative", field);
    }
  });
  decimalRule2 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!helpers32.isDecimal(String(value), {
      force_decimal: options22.range[0] !== 0,
      decimal_digits: options22.range.join(",")
    })) {
      field.report(messages22.decimal, "decimal", field, { digits: options22.range.join("-") });
    }
  });
  withoutDecimalsRule2 = createRule2((value, _2, field) => {
    if (!field.isValid) {
      return;
    }
    if (!Number.isInteger(value)) {
      field.report(messages22.withoutDecimals, "withoutDecimals", field);
    }
  });
  inRule22 = createRule2((value, options22, field) => {
    if (!field.isValid) {
      return;
    }
    if (!options22.values.includes(value)) {
      field.report(messages22["number.in"], "in", field, options22);
    }
  });
  VineNumber2 = class _VineNumber2 extends BaseLiteralType2 {
    static rules = {
      in: inRule22,
      max: maxRule2,
      min: minRule2,
      range: rangeRule2,
      number: numberRule2,
      decimal: decimalRule2,
      negative: negativeRule2,
      positive: positiveRule2,
      withoutDecimals: withoutDecimalsRule2
    };
    [UNIQUE_NAME2] = "vine.number";
    [IS_OF_TYPE2] = (value) => {
      const valueAsNumber = helpers32.asNumber(value);
      return !Number.isNaN(valueAsNumber);
    };
    constructor(options22, validations) {
      super(options22, validations || [numberRule2(options22 || {})]);
    }
    min(value) {
      return this.use(minRule2({ min: value }));
    }
    max(value) {
      return this.use(maxRule2({ max: value }));
    }
    range(value) {
      return this.use(rangeRule2({ min: value[0], max: value[1] }));
    }
    positive() {
      return this.use(positiveRule2());
    }
    negative() {
      return this.use(negativeRule2());
    }
    decimal(range) {
      return this.use(decimalRule2({ range: Array.isArray(range) ? range : [range] }));
    }
    withoutDecimals() {
      return this.use(withoutDecimalsRule2());
    }
    clone() {
      return new _VineNumber2(this.cloneOptions(), this.cloneValidations());
    }
    in(values2) {
      return this.use(inRule22({ values: values2 }));
    }
  };
  booleanRule2 = createRule2((value, options22, field) => {
    const valueAsBoolean = options22.strict === true ? value : helpers32.asBoolean(value);
    if (typeof valueAsBoolean !== "boolean") {
      field.report(messages22.boolean, "boolean", field);
      return;
    }
    field.mutate(valueAsBoolean, field);
  });
  VineBoolean2 = class _VineBoolean2 extends BaseLiteralType2 {
    static rules = {
      boolean: booleanRule2
    };
    [UNIQUE_NAME2] = "vine.boolean";
    [IS_OF_TYPE2] = (value) => {
      const valueAsBoolean = this.options.strict === true ? value : helpers32.asBoolean(value);
      return typeof valueAsBoolean === "boolean";
    };
    constructor(options22, validations) {
      super(options22, validations || [booleanRule2(options22 || {})]);
    }
    clone() {
      return new _VineBoolean2(this.cloneOptions(), this.cloneValidations());
    }
  };
  equalsRule22 = createRule2((value, options22, field) => {
    let input = value;
    if (typeof options22.expectedValue === "boolean") {
      input = helpers32.asBoolean(value);
    } else if (typeof options22.expectedValue === "number") {
      input = helpers32.asNumber(value);
    }
    if (input !== options22.expectedValue) {
      field.report(messages22.literal, "literal", field, options22);
      return;
    }
    field.mutate(input, field);
  });
  VineLiteral2 = class _VineLiteral2 extends BaseLiteralType2 {
    static rules = {
      equals: equalsRule22
    };
    #value;
    constructor(value, options22, validations) {
      super(options22, validations || [equalsRule22({ expectedValue: value })]);
      this.#value = value;
    }
    clone() {
      return new _VineLiteral2(this.#value, this.cloneOptions(), this.cloneValidations());
    }
  };
  ACCEPTED_VALUES2 = ["on", "1", "yes", "true", true, 1];
  acceptedRule2 = createRule2((value, _2, field) => {
    if (!ACCEPTED_VALUES2.includes(value)) {
      field.report(messages22.accepted, "accepted", field);
    }
  });
  VineAccepted2 = class _VineAccepted2 extends BaseLiteralType2 {
    static rules = {
      accepted: acceptedRule2
    };
    constructor(options22, validations) {
      super(options22, validations || [acceptedRule2()]);
    }
    clone() {
      return new _VineAccepted2(this.cloneOptions(), this.cloneValidations());
    }
  };
  ObjectGroup2 = class _ObjectGroup2 {
    #conditionals;
    #otherwiseCallback = (_2, field) => {
      field.report(messages22.unionGroup, "unionGroup", field);
    };
    constructor(conditionals) {
      this.#conditionals = conditionals;
    }
    clone() {
      const cloned = new _ObjectGroup2(this.#conditionals);
      cloned.otherwise(this.#otherwiseCallback);
      return cloned;
    }
    otherwise(callback) {
      this.#otherwiseCallback = callback;
      return this;
    }
    [PARSE2](refs, options22) {
      return {
        type: "group",
        elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
        conditions: this.#conditionals.map((conditional) => conditional[PARSE2](refs, options22))
      };
    }
  };
  GroupConditional2 = class {
    #properties;
    #conditional;
    constructor(conditional, properties) {
      this.#properties = properties;
      this.#conditional = conditional;
    }
    [PARSE2](refs, options22) {
      return {
        schema: {
          type: "sub_object",
          properties: Object.keys(this.#properties).map((property) => {
            return this.#properties[property][PARSE2](property, refs, options22);
          }),
          groups: []
        },
        conditionalFnRefId: refs.trackConditional(this.#conditional)
      };
    }
  };
  group2.if = function groupIf(conditon, properties) {
    return new GroupConditional2(conditon, properties);
  };
  group2.else = function groupElse(properties) {
    return new GroupConditional2(() => true, properties);
  };
  VineNativeEnum2 = class _VineNativeEnum2 extends BaseLiteralType2 {
    static rules = {
      enum: enumRule2
    };
    #values;
    constructor(values2, options22, validations) {
      super(options22, validations || [enumRule2({ choices: Object.values(values2) })]);
      this.#values = values2;
    }
    clone() {
      return new _VineNativeEnum2(this.#values, this.cloneOptions(), this.cloneValidations());
    }
  };
  VineUnionOfTypes2 = class _VineUnionOfTypes2 {
    #schemas;
    #otherwiseCallback = (_2, field) => {
      field.report(messages22.unionOfTypes, "unionOfTypes", field);
    };
    constructor(schemas) {
      this.#schemas = schemas;
    }
    otherwise(callback) {
      this.#otherwiseCallback = callback;
      return this;
    }
    clone() {
      const cloned = new _VineUnionOfTypes2(this.#schemas);
      cloned.otherwise(this.#otherwiseCallback);
      return cloned;
    }
    [PARSE2](propertyName, refs, options22) {
      return {
        type: "union",
        fieldName: propertyName,
        propertyName: options22.toCamelCase ? camelCase22(propertyName) : propertyName,
        elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
        conditions: this.#schemas.map((schema) => {
          return {
            conditionalFnRefId: refs.trackConditional((value, field) => {
              return schema[IS_OF_TYPE2](value, field);
            }),
            schema: schema[PARSE2](propertyName, refs, options22)
          };
        })
      };
    }
  };
  SchemaBuilder2 = class extends Macroable2 {
    group = group2;
    union = union2;
    string() {
      return new VineString2;
    }
    boolean(options22) {
      return new VineBoolean2(options22);
    }
    accepted() {
      return new VineAccepted2;
    }
    number(options22) {
      return new VineNumber2(options22);
    }
    date(options22) {
      return new VineDate2(options22);
    }
    literal(value) {
      return new VineLiteral2(value);
    }
    object(properties) {
      return new VineObject2(properties);
    }
    array(schema) {
      return new VineArray2(schema);
    }
    tuple(schemas) {
      return new VineTuple2(schemas);
    }
    record(schema) {
      return new VineRecord2(schema);
    }
    enum(values2) {
      if (Array.isArray(values2) || typeof values2 === "function") {
        return new VineEnum2(values2);
      }
      return new VineNativeEnum2(values2);
    }
    any() {
      return new VineAny2;
    }
    unionOfTypes(schemas) {
      const schemasInUse = /* @__PURE__ */ new Set;
      schemas.forEach((schema) => {
        if (!schema[IS_OF_TYPE2] || !schema[UNIQUE_NAME2]) {
          throw new Error(`Cannot use "${schema.constructor.name}". The schema type is not compatible for use with "vine.unionOfTypes"`);
        }
        if (schemasInUse.has(schema[UNIQUE_NAME2])) {
          throw new Error(`Cannot use duplicate schema "${schema[UNIQUE_NAME2]}". "vine.unionOfTypes" needs distinct schema types only`);
        }
        schemasInUse.add(schema[UNIQUE_NAME2]);
      });
      schemasInUse.clear();
      return new VineUnionOfTypes2(schemas);
    }
  };
  COMPILER_ERROR_MESSAGES2 = {
    required: messages22.required,
    array: messages22.array,
    object: messages22.object
  };
  Vine2 = class extends SchemaBuilder2 {
    messagesProvider = new SimpleMessagesProvider2(messages22, fields2);
    errorReporter = () => new SimpleErrorReporter2;
    convertEmptyStringsToNull = false;
    helpers = helpers32;
    createRule = createRule2;
    compile(schema) {
      return new VineValidator2(schema, {
        convertEmptyStringsToNull: this.convertEmptyStringsToNull,
        messagesProvider: this.messagesProvider,
        errorReporter: this.errorReporter
      });
    }
    withMetaData(callback) {
      return {
        compile: (schema) => {
          return new VineValidator2(schema, {
            convertEmptyStringsToNull: this.convertEmptyStringsToNull,
            messagesProvider: this.messagesProvider,
            errorReporter: this.errorReporter,
            metaDataValidator: callback
          });
        }
      };
    }
    validate(options22) {
      const validator = this.compile(options22.schema);
      return validator.validate(options22.data, options22);
    }
    tryValidate(options22) {
      const validator = this.compile(options22.schema);
      return validator.tryValidate(options22.data, options22);
    }
  };
  vine2 = new Vine2;
  vine_default2 = vine2;
});
var init_build3 = __esm2(() => {
  init_chunk_46WINKKP();
  init_chunk_577THMJC();
  init_chunk_2W32DW3L();
  init_chunk_CSAU5B4Q();
});
var init_schema = __esm2(() => {
  init_build3();
  init_build3();
});
var init_types = __esm2(() => {
  init_build3();
});
function isObjectNotEmpty(obj) {
  if (obj === undefined)
    return false;
  return Object.keys(obj).length > 0;
}
async function validateField(modelFile, params) {
  const model2 = (await import(path2.userModelsPath(`${modelFile}.ts`))).default;
  const attributes = model2.attributes;
  const ruleObject = {};
  const messageObject = {};
  for (const key in attributes) {
    if (Object.prototype.hasOwnProperty.call(attributes, key)) {
      ruleObject[snakeCase(key)] = attributes[key]?.validation?.rule;
      const validatorMessages = attributes[key]?.validation?.message;
      for (const validatorMessageKey in validatorMessages) {
        const validatorMessageString = `${key}.${validatorMessageKey}`;
        messageObject[validatorMessageString] = attributes[key]?.validation?.message[validatorMessageKey] || "";
      }
    }
  }
  vine_default2.messagesProvider = new SimpleMessagesProvider2(messageObject);
  try {
    const vineSchema = vine_default2.object(ruleObject);
    const validator = vine_default2.compile(vineSchema);
    await validator.validate(params);
  } catch (error) {
    if (error instanceof main_exports2.E_VALIDATION_ERROR)
      reportError(error.messages);
    throw new HttpError(422, JSON.stringify(error.messages));
  }
}
async function customValidate(attributes, params) {
  const ruleObject = {};
  const messageObject = {};
  for (const key in attributes) {
    if (Object.prototype.hasOwnProperty.call(attributes, key)) {
      const rule = attributes[key]?.rule;
      if (rule)
        ruleObject[key] = rule;
      const validatorMessages = attributes[key]?.message;
      for (const validatorMessageKey in validatorMessages) {
        const validatorMessageString = `${key}.${validatorMessageKey}`;
        messageObject[validatorMessageString] = attributes[key]?.message[validatorMessageKey] || "";
      }
    }
  }
  vine_default2.messagesProvider = new SimpleMessagesProvider2(messageObject);
  try {
    const vineSchema = vine_default2.object(ruleObject);
    const validator = vine_default2.compile(vineSchema);
    await validator.validate(params);
  } catch (error) {
    if (error instanceof main_exports2.E_VALIDATION_ERROR)
      reportError(error.messages);
    throw new HttpError(422, JSON.stringify(error.messages));
  }
}
var init_validator = __esm2(() => {
  init_src7();
  init_src11();
  init_src();
  init_src3();
});
var init_src3 = __esm2(() => {
  init_is();
  init_reporter();
  init_schema();
  init_types();
  init_validator();
});
var require_universalify = __commonJS2((exports) => {
  exports.fromCallback = function(fn) {
    return Object.defineProperty(function(...args) {
      if (typeof args[args.length - 1] === "function")
        fn.apply(this, args);
      else {
        return new Promise((resolve4, reject) => {
          args.push((err2, res) => err2 != null ? reject(err2) : resolve4(res));
          fn.apply(this, args);
        });
      }
    }, "name", { value: fn.name });
  };
  exports.fromPromise = function(fn) {
    return Object.defineProperty(function(...args) {
      const cb = args[args.length - 1];
      if (typeof cb !== "function")
        return fn.apply(this, args);
      else {
        args.pop();
        fn.apply(this, args).then((r2) => cb(null, r2), cb);
      }
    }, "name", { value: fn.name });
  };
});
var require_polyfills = __commonJS2((exports, module) => {
  var constants = import.meta.require("constants");
  var origCwd = process.cwd;
  var cwd = null;
  var platform2 = process.env.GRACEFUL_FS_PLATFORM || process.platform;
  process.cwd = function() {
    if (!cwd)
      cwd = origCwd.call(process);
    return cwd;
  };
  try {
    process.cwd();
  } catch (er) {
  }
  if (typeof process.chdir === "function") {
    chdir = process.chdir;
    process.chdir = function(d) {
      cwd = null;
      chdir.call(process, d);
    };
    if (Object.setPrototypeOf)
      Object.setPrototypeOf(process.chdir, chdir);
  }
  var chdir;
  module.exports = patch;
  function patch(fs2) {
    if (constants.hasOwnProperty("O_SYMLINK") && process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
      patchLchmod(fs2);
    }
    if (!fs2.lutimes) {
      patchLutimes(fs2);
    }
    fs2.chown = chownFix(fs2.chown);
    fs2.fchown = chownFix(fs2.fchown);
    fs2.lchown = chownFix(fs2.lchown);
    fs2.chmod = chmodFix(fs2.chmod);
    fs2.fchmod = chmodFix(fs2.fchmod);
    fs2.lchmod = chmodFix(fs2.lchmod);
    fs2.chownSync = chownFixSync(fs2.chownSync);
    fs2.fchownSync = chownFixSync(fs2.fchownSync);
    fs2.lchownSync = chownFixSync(fs2.lchownSync);
    fs2.chmodSync = chmodFixSync(fs2.chmodSync);
    fs2.fchmodSync = chmodFixSync(fs2.fchmodSync);
    fs2.lchmodSync = chmodFixSync(fs2.lchmodSync);
    fs2.stat = statFix(fs2.stat);
    fs2.fstat = statFix(fs2.fstat);
    fs2.lstat = statFix(fs2.lstat);
    fs2.statSync = statFixSync(fs2.statSync);
    fs2.fstatSync = statFixSync(fs2.fstatSync);
    fs2.lstatSync = statFixSync(fs2.lstatSync);
    if (fs2.chmod && !fs2.lchmod) {
      fs2.lchmod = function(path3, mode, cb) {
        if (cb)
          process.nextTick(cb);
      };
      fs2.lchmodSync = function() {
      };
    }
    if (fs2.chown && !fs2.lchown) {
      fs2.lchown = function(path3, uid, gid, cb) {
        if (cb)
          process.nextTick(cb);
      };
      fs2.lchownSync = function() {
      };
    }
    if (platform2 === "win32") {
      fs2.rename = typeof fs2.rename !== "function" ? fs2.rename : function(fs$rename) {
        function rename2(from, to, cb) {
          var start = Date.now();
          var backoff = 0;
          fs$rename(from, to, function CB(er) {
            if (er && (er.code === "EACCES" || er.code === "EPERM" || er.code === "EBUSY") && Date.now() - start < 60000) {
              setTimeout(function() {
                fs2.stat(to, function(stater, st) {
                  if (stater && stater.code === "ENOENT")
                    fs$rename(from, to, CB);
                  else
                    cb(er);
                });
              }, backoff);
              if (backoff < 100)
                backoff += 10;
              return;
            }
            if (cb)
              cb(er);
          });
        }
        if (Object.setPrototypeOf)
          Object.setPrototypeOf(rename2, fs$rename);
        return rename2;
      }(fs2.rename);
    }
    fs2.read = typeof fs2.read !== "function" ? fs2.read : function(fs$read) {
      function read(fd, buffer, offset, length, position, callback_) {
        var callback;
        if (callback_ && typeof callback_ === "function") {
          var eagCounter = 0;
          callback = function(er, _2, __) {
            if (er && er.code === "EAGAIN" && eagCounter < 10) {
              eagCounter++;
              return fs$read.call(fs2, fd, buffer, offset, length, position, callback);
            }
            callback_.apply(this, arguments);
          };
        }
        return fs$read.call(fs2, fd, buffer, offset, length, position, callback);
      }
      if (Object.setPrototypeOf)
        Object.setPrototypeOf(read, fs$read);
      return read;
    }(fs2.read);
    fs2.readSync = typeof fs2.readSync !== "function" ? fs2.readSync : function(fs$readSync) {
      return function(fd, buffer, offset, length, position) {
        var eagCounter = 0;
        while (true) {
          try {
            return fs$readSync.call(fs2, fd, buffer, offset, length, position);
          } catch (er) {
            if (er.code === "EAGAIN" && eagCounter < 10) {
              eagCounter++;
              continue;
            }
            throw er;
          }
        }
      };
    }(fs2.readSync);
    function patchLchmod(fs22) {
      fs22.lchmod = function(path3, mode, callback) {
        fs22.open(path3, constants.O_WRONLY | constants.O_SYMLINK, mode, function(err2, fd) {
          if (err2) {
            if (callback)
              callback(err2);
            return;
          }
          fs22.fchmod(fd, mode, function(err22) {
            fs22.close(fd, function(err222) {
              if (callback)
                callback(err22 || err222);
            });
          });
        });
      };
      fs22.lchmodSync = function(path3, mode) {
        var fd = fs22.openSync(path3, constants.O_WRONLY | constants.O_SYMLINK, mode);
        var threw = true;
        var ret;
        try {
          ret = fs22.fchmodSync(fd, mode);
          threw = false;
        } finally {
          if (threw) {
            try {
              fs22.closeSync(fd);
            } catch (er) {
            }
          } else {
            fs22.closeSync(fd);
          }
        }
        return ret;
      };
    }
    function patchLutimes(fs22) {
      if (constants.hasOwnProperty("O_SYMLINK") && fs22.futimes) {
        fs22.lutimes = function(path3, at, mt, cb) {
          fs22.open(path3, constants.O_SYMLINK, function(er, fd) {
            if (er) {
              if (cb)
                cb(er);
              return;
            }
            fs22.futimes(fd, at, mt, function(er2) {
              fs22.close(fd, function(er22) {
                if (cb)
                  cb(er2 || er22);
              });
            });
          });
        };
        fs22.lutimesSync = function(path3, at, mt) {
          var fd = fs22.openSync(path3, constants.O_SYMLINK);
          var ret;
          var threw = true;
          try {
            ret = fs22.futimesSync(fd, at, mt);
            threw = false;
          } finally {
            if (threw) {
              try {
                fs22.closeSync(fd);
              } catch (er) {
              }
            } else {
              fs22.closeSync(fd);
            }
          }
          return ret;
        };
      } else if (fs22.futimes) {
        fs22.lutimes = function(_a, _b, _c, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs22.lutimesSync = function() {
        };
      }
    }
    function chmodFix(orig) {
      if (!orig)
        return orig;
      return function(target, mode, cb) {
        return orig.call(fs2, target, mode, function(er) {
          if (chownErOk(er))
            er = null;
          if (cb)
            cb.apply(this, arguments);
        });
      };
    }
    function chmodFixSync(orig) {
      if (!orig)
        return orig;
      return function(target, mode) {
        try {
          return orig.call(fs2, target, mode);
        } catch (er) {
          if (!chownErOk(er))
            throw er;
        }
      };
    }
    function chownFix(orig) {
      if (!orig)
        return orig;
      return function(target, uid, gid, cb) {
        return orig.call(fs2, target, uid, gid, function(er) {
          if (chownErOk(er))
            er = null;
          if (cb)
            cb.apply(this, arguments);
        });
      };
    }
    function chownFixSync(orig) {
      if (!orig)
        return orig;
      return function(target, uid, gid) {
        try {
          return orig.call(fs2, target, uid, gid);
        } catch (er) {
          if (!chownErOk(er))
            throw er;
        }
      };
    }
    function statFix(orig) {
      if (!orig)
        return orig;
      return function(target, options22, cb) {
        if (typeof options22 === "function") {
          cb = options22;
          options22 = null;
        }
        function callback(er, stats) {
          if (stats) {
            if (stats.uid < 0)
              stats.uid += 4294967296;
            if (stats.gid < 0)
              stats.gid += 4294967296;
          }
          if (cb)
            cb.apply(this, arguments);
        }
        return options22 ? orig.call(fs2, target, options22, callback) : orig.call(fs2, target, callback);
      };
    }
    function statFixSync(orig) {
      if (!orig)
        return orig;
      return function(target, options22) {
        var stats = options22 ? orig.call(fs2, target, options22) : orig.call(fs2, target);
        if (stats) {
          if (stats.uid < 0)
            stats.uid += 4294967296;
          if (stats.gid < 0)
            stats.gid += 4294967296;
        }
        return stats;
      };
    }
    function chownErOk(er) {
      if (!er)
        return true;
      if (er.code === "ENOSYS")
        return true;
      var nonroot = !process.getuid || process.getuid() !== 0;
      if (nonroot) {
        if (er.code === "EINVAL" || er.code === "EPERM")
          return true;
      }
      return false;
    }
  }
});
var require_legacy_streams = __commonJS2((exports, module) => {
  var Stream = import.meta.require("stream").Stream;
  module.exports = legacy;
  function legacy(fs2) {
    return {
      ReadStream,
      WriteStream: WriteStream3
    };
    function ReadStream(path3, options22) {
      if (!(this instanceof ReadStream))
        return new ReadStream(path3, options22);
      Stream.call(this);
      var self2 = this;
      this.path = path3;
      this.fd = null;
      this.readable = true;
      this.paused = false;
      this.flags = "r";
      this.mode = 438;
      this.bufferSize = 65536;
      options22 = options22 || {};
      var keys = Object.keys(options22);
      for (var index = 0, length = keys.length;index < length; index++) {
        var key = keys[index];
        this[key] = options22[key];
      }
      if (this.encoding)
        this.setEncoding(this.encoding);
      if (this.start !== undefined) {
        if (typeof this.start !== "number") {
          throw TypeError("start must be a Number");
        }
        if (this.end === undefined) {
          this.end = Infinity;
        } else if (typeof this.end !== "number") {
          throw TypeError("end must be a Number");
        }
        if (this.start > this.end) {
          throw new Error("start must be <= end");
        }
        this.pos = this.start;
      }
      if (this.fd !== null) {
        process.nextTick(function() {
          self2._read();
        });
        return;
      }
      fs2.open(this.path, this.flags, this.mode, function(err2, fd) {
        if (err2) {
          self2.emit("error", err2);
          self2.readable = false;
          return;
        }
        self2.fd = fd;
        self2.emit("open", fd);
        self2._read();
      });
    }
    function WriteStream3(path3, options22) {
      if (!(this instanceof WriteStream3))
        return new WriteStream3(path3, options22);
      Stream.call(this);
      this.path = path3;
      this.fd = null;
      this.writable = true;
      this.flags = "w";
      this.encoding = "binary";
      this.mode = 438;
      this.bytesWritten = 0;
      options22 = options22 || {};
      var keys = Object.keys(options22);
      for (var index = 0, length = keys.length;index < length; index++) {
        var key = keys[index];
        this[key] = options22[key];
      }
      if (this.start !== undefined) {
        if (typeof this.start !== "number") {
          throw TypeError("start must be a Number");
        }
        if (this.start < 0) {
          throw new Error("start must be >= zero");
        }
        this.pos = this.start;
      }
      this.busy = false;
      this._queue = [];
      if (this.fd === null) {
        this._open = fs2.open;
        this._queue.push([this._open, this.path, this.flags, this.mode, undefined]);
        this.flush();
      }
    }
  }
});
var require_clone = __commonJS2((exports, module) => {
  module.exports = clone2;
  var getPrototypeOf = Object.getPrototypeOf || function(obj) {
    return obj.__proto__;
  };
  function clone2(obj) {
    if (obj === null || typeof obj !== "object")
      return obj;
    if (obj instanceof Object)
      var copy = { __proto__: getPrototypeOf(obj) };
    else
      var copy = Object.create(null);
    Object.getOwnPropertyNames(obj).forEach(function(key) {
      Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
    });
    return copy;
  }
});
var require_graceful_fs = __commonJS2((exports, module) => {
  var fs2 = import.meta.require("fs");
  var polyfills = require_polyfills();
  var legacy = require_legacy_streams();
  var clone2 = require_clone();
  var util = import.meta.require("util");
  var gracefulQueue;
  var previousSymbol;
  if (typeof Symbol === "function" && typeof Symbol.for === "function") {
    gracefulQueue = Symbol.for("graceful-fs.queue");
    previousSymbol = Symbol.for("graceful-fs.previous");
  } else {
    gracefulQueue = "___graceful-fs.queue";
    previousSymbol = "___graceful-fs.previous";
  }
  function noop() {
  }
  function publishQueue(context, queue32) {
    Object.defineProperty(context, gracefulQueue, {
      get: function() {
        return queue32;
      }
    });
  }
  var debug = noop;
  if (util.debuglog)
    debug = util.debuglog("gfs4");
  else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ""))
    debug = function() {
      var m2 = util.format.apply(util, arguments);
      m2 = "GFS4: " + m2.split(/\n/).join("\nGFS4: ");
      console.error(m2);
    };
  if (!fs2[gracefulQueue]) {
    queue22 = global[gracefulQueue] || [];
    publishQueue(fs2, queue22);
    fs2.close = function(fs$close) {
      function close(fd, cb) {
        return fs$close.call(fs2, fd, function(err2) {
          if (!err2) {
            resetQueue();
          }
          if (typeof cb === "function")
            cb.apply(this, arguments);
        });
      }
      Object.defineProperty(close, previousSymbol, {
        value: fs$close
      });
      return close;
    }(fs2.close);
    fs2.closeSync = function(fs$closeSync) {
      function closeSync(fd) {
        fs$closeSync.apply(fs2, arguments);
        resetQueue();
      }
      Object.defineProperty(closeSync, previousSymbol, {
        value: fs$closeSync
      });
      return closeSync;
    }(fs2.closeSync);
    if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || "")) {
      process.on("exit", function() {
        debug(fs2[gracefulQueue]);
        import.meta.require("assert").equal(fs2[gracefulQueue].length, 0);
      });
    }
  }
  var queue22;
  if (!global[gracefulQueue]) {
    publishQueue(global, fs2[gracefulQueue]);
  }
  module.exports = patch(clone2(fs2));
  if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs2.__patched) {
    module.exports = patch(fs2);
    fs2.__patched = true;
  }
  function patch(fs22) {
    polyfills(fs22);
    fs22.gracefulify = patch;
    fs22.createReadStream = createReadStream2;
    fs22.createWriteStream = createWriteStream2;
    var fs$readFile = fs22.readFile;
    fs22.readFile = readFile;
    function readFile(path3, options22, cb) {
      if (typeof options22 === "function")
        cb = options22, options22 = null;
      return go$readFile(path3, options22, cb);
      function go$readFile(path42, options3, cb2, startTime) {
        return fs$readFile(path42, options3, function(err2) {
          if (err2 && (err2.code === "EMFILE" || err2.code === "ENFILE"))
            enqueue([go$readFile, [path42, options3, cb2], err2, startTime || Date.now(), Date.now()]);
          else {
            if (typeof cb2 === "function")
              cb2.apply(this, arguments);
          }
        });
      }
    }
    var fs$writeFile = fs22.writeFile;
    fs22.writeFile = writeFile;
    function writeFile(path3, data, options22, cb) {
      if (typeof options22 === "function")
        cb = options22, options22 = null;
      return go$writeFile(path3, data, options22, cb);
      function go$writeFile(path42, data2, options3, cb2, startTime) {
        return fs$writeFile(path42, data2, options3, function(err2) {
          if (err2 && (err2.code === "EMFILE" || err2.code === "ENFILE"))
            enqueue([go$writeFile, [path42, data2, options3, cb2], err2, startTime || Date.now(), Date.now()]);
          else {
            if (typeof cb2 === "function")
              cb2.apply(this, arguments);
          }
        });
      }
    }
    var fs$appendFile = fs22.appendFile;
    if (fs$appendFile)
      fs22.appendFile = appendFile3;
    function appendFile3(path3, data, options22, cb) {
      if (typeof options22 === "function")
        cb = options22, options22 = null;
      return go$appendFile(path3, data, options22, cb);
      function go$appendFile(path42, data2, options3, cb2, startTime) {
        return fs$appendFile(path42, data2, options3, function(err2) {
          if (err2 && (err2.code === "EMFILE" || err2.code === "ENFILE"))
            enqueue([go$appendFile, [path42, data2, options3, cb2], err2, startTime || Date.now(), Date.now()]);
          else {
            if (typeof cb2 === "function")
              cb2.apply(this, arguments);
          }
        });
      }
    }
    var fs$copyFile = fs22.copyFile;
    if (fs$copyFile)
      fs22.copyFile = copyFile;
    function copyFile(src2, dest, flags, cb) {
      if (typeof flags === "function") {
        cb = flags;
        flags = 0;
      }
      return go$copyFile(src2, dest, flags, cb);
      function go$copyFile(src22, dest2, flags2, cb2, startTime) {
        return fs$copyFile(src22, dest2, flags2, function(err2) {
          if (err2 && (err2.code === "EMFILE" || err2.code === "ENFILE"))
            enqueue([go$copyFile, [src22, dest2, flags2, cb2], err2, startTime || Date.now(), Date.now()]);
          else {
            if (typeof cb2 === "function")
              cb2.apply(this, arguments);
          }
        });
      }
    }
    var fs$readdir = fs22.readdir;
    fs22.readdir = readdir;
    var noReaddirOptionVersions = /^v[0-5]\./;
    function readdir(path3, options22, cb) {
      if (typeof options22 === "function")
        cb = options22, options22 = null;
      var go$readdir = noReaddirOptionVersions.test(process.version) ? function go$readdir(path42, options3, cb2, startTime) {
        return fs$readdir(path42, fs$readdirCallback(path42, options3, cb2, startTime));
      } : function go$readdir(path42, options3, cb2, startTime) {
        return fs$readdir(path42, options3, fs$readdirCallback(path42, options3, cb2, startTime));
      };
      return go$readdir(path3, options22, cb);
      function fs$readdirCallback(path42, options3, cb2, startTime) {
        return function(err2, files) {
          if (err2 && (err2.code === "EMFILE" || err2.code === "ENFILE"))
            enqueue([
              go$readdir,
              [path42, options3, cb2],
              err2,
              startTime || Date.now(),
              Date.now()
            ]);
          else {
            if (files && files.sort)
              files.sort();
            if (typeof cb2 === "function")
              cb2.call(this, err2, files);
          }
        };
      }
    }
    if (process.version.substr(0, 4) === "v0.8") {
      var legStreams = legacy(fs22);
      ReadStream = legStreams.ReadStream;
      WriteStream3 = legStreams.WriteStream;
    }
    var fs$ReadStream = fs22.ReadStream;
    if (fs$ReadStream) {
      ReadStream.prototype = Object.create(fs$ReadStream.prototype);
      ReadStream.prototype.open = ReadStream$open;
    }
    var fs$WriteStream = fs22.WriteStream;
    if (fs$WriteStream) {
      WriteStream3.prototype = Object.create(fs$WriteStream.prototype);
      WriteStream3.prototype.open = WriteStream$open;
    }
    Object.defineProperty(fs22, "ReadStream", {
      get: function() {
        return ReadStream;
      },
      set: function(val2) {
        ReadStream = val2;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(fs22, "WriteStream", {
      get: function() {
        return WriteStream3;
      },
      set: function(val2) {
        WriteStream3 = val2;
      },
      enumerable: true,
      configurable: true
    });
    var FileReadStream = ReadStream;
    Object.defineProperty(fs22, "FileReadStream", {
      get: function() {
        return FileReadStream;
      },
      set: function(val2) {
        FileReadStream = val2;
      },
      enumerable: true,
      configurable: true
    });
    var FileWriteStream = WriteStream3;
    Object.defineProperty(fs22, "FileWriteStream", {
      get: function() {
        return FileWriteStream;
      },
      set: function(val2) {
        FileWriteStream = val2;
      },
      enumerable: true,
      configurable: true
    });
    function ReadStream(path3, options22) {
      if (this instanceof ReadStream)
        return fs$ReadStream.apply(this, arguments), this;
      else
        return ReadStream.apply(Object.create(ReadStream.prototype), arguments);
    }
    function ReadStream$open() {
      var that = this;
      open(that.path, that.flags, that.mode, function(err2, fd) {
        if (err2) {
          if (that.autoClose)
            that.destroy();
          that.emit("error", err2);
        } else {
          that.fd = fd;
          that.emit("open", fd);
          that.read();
        }
      });
    }
    function WriteStream3(path3, options22) {
      if (this instanceof WriteStream3)
        return fs$WriteStream.apply(this, arguments), this;
      else
        return WriteStream3.apply(Object.create(WriteStream3.prototype), arguments);
    }
    function WriteStream$open() {
      var that = this;
      open(that.path, that.flags, that.mode, function(err2, fd) {
        if (err2) {
          that.destroy();
          that.emit("error", err2);
        } else {
          that.fd = fd;
          that.emit("open", fd);
        }
      });
    }
    function createReadStream2(path3, options22) {
      return new fs22.ReadStream(path3, options22);
    }
    function createWriteStream2(path3, options22) {
      return new fs22.WriteStream(path3, options22);
    }
    var fs$open = fs22.open;
    fs22.open = open;
    function open(path3, flags, mode, cb) {
      if (typeof mode === "function")
        cb = mode, mode = null;
      return go$open(path3, flags, mode, cb);
      function go$open(path42, flags2, mode2, cb2, startTime) {
        return fs$open(path42, flags2, mode2, function(err2, fd) {
          if (err2 && (err2.code === "EMFILE" || err2.code === "ENFILE"))
            enqueue([go$open, [path42, flags2, mode2, cb2], err2, startTime || Date.now(), Date.now()]);
          else {
            if (typeof cb2 === "function")
              cb2.apply(this, arguments);
          }
        });
      }
    }
    return fs22;
  }
  function enqueue(elem) {
    debug("ENQUEUE", elem[0].name, elem[1]);
    fs2[gracefulQueue].push(elem);
    retry();
  }
  var retryTimer;
  function resetQueue() {
    var now = Date.now();
    for (var i = 0;i < fs2[gracefulQueue].length; ++i) {
      if (fs2[gracefulQueue][i].length > 2) {
        fs2[gracefulQueue][i][3] = now;
        fs2[gracefulQueue][i][4] = now;
      }
    }
    retry();
  }
  function retry() {
    clearTimeout(retryTimer);
    retryTimer = undefined;
    if (fs2[gracefulQueue].length === 0)
      return;
    var elem = fs2[gracefulQueue].shift();
    var fn = elem[0];
    var args = elem[1];
    var err2 = elem[2];
    var startTime = elem[3];
    var lastTime = elem[4];
    if (startTime === undefined) {
      debug("RETRY", fn.name, args);
      fn.apply(null, args);
    } else if (Date.now() - startTime >= 60000) {
      debug("TIMEOUT", fn.name, args);
      var cb = args.pop();
      if (typeof cb === "function")
        cb.call(null, err2);
    } else {
      var sinceAttempt = Date.now() - lastTime;
      var sinceStart = Math.max(lastTime - startTime, 1);
      var desiredDelay = Math.min(sinceStart * 1.2, 100);
      if (sinceAttempt >= desiredDelay) {
        debug("RETRY", fn.name, args);
        fn.apply(null, args.concat([startTime]));
      } else {
        fs2[gracefulQueue].push(elem);
      }
    }
    if (retryTimer === undefined) {
      retryTimer = setTimeout(retry, 0);
    }
  }
});
var require_fs = __commonJS2((exports) => {
  var u = require_universalify().fromCallback;
  var fs2 = require_graceful_fs();
  var api2 = [
    "access",
    "appendFile",
    "chmod",
    "chown",
    "close",
    "copyFile",
    "fchmod",
    "fchown",
    "fdatasync",
    "fstat",
    "fsync",
    "ftruncate",
    "futimes",
    "lchmod",
    "lchown",
    "link",
    "lstat",
    "mkdir",
    "mkdtemp",
    "open",
    "opendir",
    "readdir",
    "readFile",
    "readlink",
    "realpath",
    "rename",
    "rm",
    "rmdir",
    "stat",
    "symlink",
    "truncate",
    "unlink",
    "utimes",
    "writeFile"
  ].filter((key) => {
    return typeof fs2[key] === "function";
  });
  Object.assign(exports, fs2);
  api2.forEach((method) => {
    exports[method] = u(fs2[method]);
  });
  exports.exists = function(filename2, callback) {
    if (typeof callback === "function") {
      return fs2.exists(filename2, callback);
    }
    return new Promise((resolve4) => {
      return fs2.exists(filename2, resolve4);
    });
  };
  exports.read = function(fd, buffer, offset, length, position, callback) {
    if (typeof callback === "function") {
      return fs2.read(fd, buffer, offset, length, position, callback);
    }
    return new Promise((resolve4, reject) => {
      fs2.read(fd, buffer, offset, length, position, (err2, bytesRead, buffer2) => {
        if (err2)
          return reject(err2);
        resolve4({ bytesRead, buffer: buffer2 });
      });
    });
  };
  exports.write = function(fd, buffer, ...args) {
    if (typeof args[args.length - 1] === "function") {
      return fs2.write(fd, buffer, ...args);
    }
    return new Promise((resolve4, reject) => {
      fs2.write(fd, buffer, ...args, (err2, bytesWritten, buffer2) => {
        if (err2)
          return reject(err2);
        resolve4({ bytesWritten, buffer: buffer2 });
      });
    });
  };
  exports.readv = function(fd, buffers, ...args) {
    if (typeof args[args.length - 1] === "function") {
      return fs2.readv(fd, buffers, ...args);
    }
    return new Promise((resolve4, reject) => {
      fs2.readv(fd, buffers, ...args, (err2, bytesRead, buffers2) => {
        if (err2)
          return reject(err2);
        resolve4({ bytesRead, buffers: buffers2 });
      });
    });
  };
  exports.writev = function(fd, buffers, ...args) {
    if (typeof args[args.length - 1] === "function") {
      return fs2.writev(fd, buffers, ...args);
    }
    return new Promise((resolve4, reject) => {
      fs2.writev(fd, buffers, ...args, (err2, bytesWritten, buffers2) => {
        if (err2)
          return reject(err2);
        resolve4({ bytesWritten, buffers: buffers2 });
      });
    });
  };
  if (typeof fs2.realpath.native === "function") {
    exports.realpath.native = u(fs2.realpath.native);
  } else {
    process.emitWarning("fs.realpath.native is not a function. Is fs being monkey-patched?", "Warning", "fs-extra-WARN0003");
  }
});
var require_utils = __commonJS2((exports, module) => {
  var path3 = import.meta.require("path");
  exports.checkPath = function checkPath(pth) {
    if (process.platform === "win32") {
      const pathHasInvalidWinCharacters = /[<>:"|?*]/.test(pth.replace(path3.parse(pth).root, ""));
      if (pathHasInvalidWinCharacters) {
        const error = new Error(`Path contains invalid characters: ${pth}`);
        error.code = "EINVAL";
        throw error;
      }
    }
  };
});
var require_make_dir = __commonJS2((exports, module) => {
  var fs2 = require_fs();
  var { checkPath } = require_utils();
  var getMode = (options22) => {
    const defaults = { mode: 511 };
    if (typeof options22 === "number")
      return options22;
    return { ...defaults, ...options22 }.mode;
  };
  exports.makeDir = async (dir, options22) => {
    checkPath(dir);
    return fs2.mkdir(dir, {
      mode: getMode(options22),
      recursive: true
    });
  };
  exports.makeDirSync = (dir, options22) => {
    checkPath(dir);
    return fs2.mkdirSync(dir, {
      mode: getMode(options22),
      recursive: true
    });
  };
});
var require_mkdirs = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var { makeDir: _makeDir, makeDirSync } = require_make_dir();
  var makeDir = u(_makeDir);
  module.exports = {
    mkdirs: makeDir,
    mkdirsSync: makeDirSync,
    mkdirp: makeDir,
    mkdirpSync: makeDirSync,
    ensureDir: makeDir,
    ensureDirSync: makeDirSync
  };
});
var require_path_exists = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var fs2 = require_fs();
  function pathExists(path3) {
    return fs2.access(path3).then(() => true).catch(() => false);
  }
  module.exports = {
    pathExists: u(pathExists),
    pathExistsSync: fs2.existsSync
  };
});
var require_utimes = __commonJS2((exports, module) => {
  var fs2 = require_fs();
  var u = require_universalify().fromPromise;
  async function utimesMillis(path3, atime, mtime) {
    const fd = await fs2.open(path3, "r+");
    let closeErr = null;
    try {
      await fs2.futimes(fd, atime, mtime);
    } finally {
      try {
        await fs2.close(fd);
      } catch (e) {
        closeErr = e;
      }
    }
    if (closeErr) {
      throw closeErr;
    }
  }
  function utimesMillisSync(path3, atime, mtime) {
    const fd = fs2.openSync(path3, "r+");
    fs2.futimesSync(fd, atime, mtime);
    return fs2.closeSync(fd);
  }
  module.exports = {
    utimesMillis: u(utimesMillis),
    utimesMillisSync
  };
});
var require_stat = __commonJS2((exports, module) => {
  var fs2 = require_fs();
  var path3 = import.meta.require("path");
  var u = require_universalify().fromPromise;
  function getStats(src2, dest, opts) {
    const statFunc = opts.dereference ? (file) => fs2.stat(file, { bigint: true }) : (file) => fs2.lstat(file, { bigint: true });
    return Promise.all([
      statFunc(src2),
      statFunc(dest).catch((err2) => {
        if (err2.code === "ENOENT")
          return null;
        throw err2;
      })
    ]).then(([srcStat, destStat]) => ({ srcStat, destStat }));
  }
  function getStatsSync(src2, dest, opts) {
    let destStat;
    const statFunc = opts.dereference ? (file) => fs2.statSync(file, { bigint: true }) : (file) => fs2.lstatSync(file, { bigint: true });
    const srcStat = statFunc(src2);
    try {
      destStat = statFunc(dest);
    } catch (err2) {
      if (err2.code === "ENOENT")
        return { srcStat, destStat: null };
      throw err2;
    }
    return { srcStat, destStat };
  }
  async function checkPaths(src2, dest, funcName, opts) {
    const { srcStat, destStat } = await getStats(src2, dest, opts);
    if (destStat) {
      if (areIdentical(srcStat, destStat)) {
        const srcBaseName = path3.basename(src2);
        const destBaseName = path3.basename(dest);
        if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
          return { srcStat, destStat, isChangingCase: true };
        }
        throw new Error("Source and destination must not be the same.");
      }
      if (srcStat.isDirectory() && !destStat.isDirectory()) {
        throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src2}'.`);
      }
      if (!srcStat.isDirectory() && destStat.isDirectory()) {
        throw new Error(`Cannot overwrite directory '${dest}' with non-directory '${src2}'.`);
      }
    }
    if (srcStat.isDirectory() && isSrcSubdir(src2, dest)) {
      throw new Error(errMsg(src2, dest, funcName));
    }
    return { srcStat, destStat };
  }
  function checkPathsSync(src2, dest, funcName, opts) {
    const { srcStat, destStat } = getStatsSync(src2, dest, opts);
    if (destStat) {
      if (areIdentical(srcStat, destStat)) {
        const srcBaseName = path3.basename(src2);
        const destBaseName = path3.basename(dest);
        if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
          return { srcStat, destStat, isChangingCase: true };
        }
        throw new Error("Source and destination must not be the same.");
      }
      if (srcStat.isDirectory() && !destStat.isDirectory()) {
        throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src2}'.`);
      }
      if (!srcStat.isDirectory() && destStat.isDirectory()) {
        throw new Error(`Cannot overwrite directory '${dest}' with non-directory '${src2}'.`);
      }
    }
    if (srcStat.isDirectory() && isSrcSubdir(src2, dest)) {
      throw new Error(errMsg(src2, dest, funcName));
    }
    return { srcStat, destStat };
  }
  async function checkParentPaths(src2, srcStat, dest, funcName) {
    const srcParent = path3.resolve(path3.dirname(src2));
    const destParent = path3.resolve(path3.dirname(dest));
    if (destParent === srcParent || destParent === path3.parse(destParent).root)
      return;
    let destStat;
    try {
      destStat = await fs2.stat(destParent, { bigint: true });
    } catch (err2) {
      if (err2.code === "ENOENT")
        return;
      throw err2;
    }
    if (areIdentical(srcStat, destStat)) {
      throw new Error(errMsg(src2, dest, funcName));
    }
    return checkParentPaths(src2, srcStat, destParent, funcName);
  }
  function checkParentPathsSync(src2, srcStat, dest, funcName) {
    const srcParent = path3.resolve(path3.dirname(src2));
    const destParent = path3.resolve(path3.dirname(dest));
    if (destParent === srcParent || destParent === path3.parse(destParent).root)
      return;
    let destStat;
    try {
      destStat = fs2.statSync(destParent, { bigint: true });
    } catch (err2) {
      if (err2.code === "ENOENT")
        return;
      throw err2;
    }
    if (areIdentical(srcStat, destStat)) {
      throw new Error(errMsg(src2, dest, funcName));
    }
    return checkParentPathsSync(src2, srcStat, destParent, funcName);
  }
  function areIdentical(srcStat, destStat) {
    return destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev;
  }
  function isSrcSubdir(src2, dest) {
    const srcArr = path3.resolve(src2).split(path3.sep).filter((i) => i);
    const destArr = path3.resolve(dest).split(path3.sep).filter((i) => i);
    return srcArr.every((cur, i) => destArr[i] === cur);
  }
  function errMsg(src2, dest, funcName) {
    return `Cannot ${funcName} '${src2}' to a subdirectory of itself, '${dest}'.`;
  }
  module.exports = {
    checkPaths: u(checkPaths),
    checkPathsSync,
    checkParentPaths: u(checkParentPaths),
    checkParentPathsSync,
    isSrcSubdir,
    areIdentical
  };
});
var require_copy = __commonJS2((exports, module) => {
  var fs2 = require_fs();
  var path3 = import.meta.require("path");
  var { mkdirs } = require_mkdirs();
  var { pathExists } = require_path_exists();
  var { utimesMillis } = require_utimes();
  var stat = require_stat();
  async function copy(src2, dest, opts = {}) {
    if (typeof opts === "function") {
      opts = { filter: opts };
    }
    opts.clobber = "clobber" in opts ? !!opts.clobber : true;
    opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
    if (opts.preserveTimestamps && process.arch === "ia32") {
      process.emitWarning("Using the preserveTimestamps option in 32-bit node is not recommended;\n\n\tsee https://github.com/jprichardson/node-fs-extra/issues/269", "Warning", "fs-extra-WARN0001");
    }
    const { srcStat, destStat } = await stat.checkPaths(src2, dest, "copy", opts);
    await stat.checkParentPaths(src2, srcStat, dest, "copy");
    const include = await runFilter(src2, dest, opts);
    if (!include)
      return;
    const destParent = path3.dirname(dest);
    const dirExists = await pathExists(destParent);
    if (!dirExists) {
      await mkdirs(destParent);
    }
    await getStatsAndPerformCopy(destStat, src2, dest, opts);
  }
  async function runFilter(src2, dest, opts) {
    if (!opts.filter)
      return true;
    return opts.filter(src2, dest);
  }
  async function getStatsAndPerformCopy(destStat, src2, dest, opts) {
    const statFn = opts.dereference ? fs2.stat : fs2.lstat;
    const srcStat = await statFn(src2);
    if (srcStat.isDirectory())
      return onDir(srcStat, destStat, src2, dest, opts);
    if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
      return onFile(srcStat, destStat, src2, dest, opts);
    if (srcStat.isSymbolicLink())
      return onLink(destStat, src2, dest, opts);
    if (srcStat.isSocket())
      throw new Error(`Cannot copy a socket file: ${src2}`);
    if (srcStat.isFIFO())
      throw new Error(`Cannot copy a FIFO pipe: ${src2}`);
    throw new Error(`Unknown file: ${src2}`);
  }
  async function onFile(srcStat, destStat, src2, dest, opts) {
    if (!destStat)
      return copyFile(srcStat, src2, dest, opts);
    if (opts.overwrite) {
      await fs2.unlink(dest);
      return copyFile(srcStat, src2, dest, opts);
    }
    if (opts.errorOnExist) {
      throw new Error(`'${dest}' already exists`);
    }
  }
  async function copyFile(srcStat, src2, dest, opts) {
    await fs2.copyFile(src2, dest);
    if (opts.preserveTimestamps) {
      if (fileIsNotWritable(srcStat.mode)) {
        await makeFileWritable(dest, srcStat.mode);
      }
      const updatedSrcStat = await fs2.stat(src2);
      await utimesMillis(dest, updatedSrcStat.atime, updatedSrcStat.mtime);
    }
    return fs2.chmod(dest, srcStat.mode);
  }
  function fileIsNotWritable(srcMode) {
    return (srcMode & 128) === 0;
  }
  function makeFileWritable(dest, srcMode) {
    return fs2.chmod(dest, srcMode | 128);
  }
  async function onDir(srcStat, destStat, src2, dest, opts) {
    if (!destStat) {
      await fs2.mkdir(dest);
    }
    const items = await fs2.readdir(src2);
    await Promise.all(items.map(async (item) => {
      const srcItem = path3.join(src2, item);
      const destItem = path3.join(dest, item);
      const include = await runFilter(srcItem, destItem, opts);
      if (!include)
        return;
      const { destStat: destStat2 } = await stat.checkPaths(srcItem, destItem, "copy", opts);
      return getStatsAndPerformCopy(destStat2, srcItem, destItem, opts);
    }));
    if (!destStat) {
      await fs2.chmod(dest, srcStat.mode);
    }
  }
  async function onLink(destStat, src2, dest, opts) {
    let resolvedSrc = await fs2.readlink(src2);
    if (opts.dereference) {
      resolvedSrc = path3.resolve(process.cwd(), resolvedSrc);
    }
    if (!destStat) {
      return fs2.symlink(resolvedSrc, dest);
    }
    let resolvedDest = null;
    try {
      resolvedDest = await fs2.readlink(dest);
    } catch (e) {
      if (e.code === "EINVAL" || e.code === "UNKNOWN")
        return fs2.symlink(resolvedSrc, dest);
      throw e;
    }
    if (opts.dereference) {
      resolvedDest = path3.resolve(process.cwd(), resolvedDest);
    }
    if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
      throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
    }
    if (stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
      throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
    }
    await fs2.unlink(dest);
    return fs2.symlink(resolvedSrc, dest);
  }
  module.exports = copy;
});
var require_copy_sync = __commonJS2((exports, module) => {
  var fs2 = require_graceful_fs();
  var path3 = import.meta.require("path");
  var mkdirsSync = require_mkdirs().mkdirsSync;
  var utimesMillisSync = require_utimes().utimesMillisSync;
  var stat = require_stat();
  function copySync(src2, dest, opts) {
    if (typeof opts === "function") {
      opts = { filter: opts };
    }
    opts = opts || {};
    opts.clobber = "clobber" in opts ? !!opts.clobber : true;
    opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
    if (opts.preserveTimestamps && process.arch === "ia32") {
      process.emitWarning("Using the preserveTimestamps option in 32-bit node is not recommended;\n\n\tsee https://github.com/jprichardson/node-fs-extra/issues/269", "Warning", "fs-extra-WARN0002");
    }
    const { srcStat, destStat } = stat.checkPathsSync(src2, dest, "copy", opts);
    stat.checkParentPathsSync(src2, srcStat, dest, "copy");
    if (opts.filter && !opts.filter(src2, dest))
      return;
    const destParent = path3.dirname(dest);
    if (!fs2.existsSync(destParent))
      mkdirsSync(destParent);
    return getStats(destStat, src2, dest, opts);
  }
  function getStats(destStat, src2, dest, opts) {
    const statSync = opts.dereference ? fs2.statSync : fs2.lstatSync;
    const srcStat = statSync(src2);
    if (srcStat.isDirectory())
      return onDir(srcStat, destStat, src2, dest, opts);
    else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
      return onFile(srcStat, destStat, src2, dest, opts);
    else if (srcStat.isSymbolicLink())
      return onLink(destStat, src2, dest, opts);
    else if (srcStat.isSocket())
      throw new Error(`Cannot copy a socket file: ${src2}`);
    else if (srcStat.isFIFO())
      throw new Error(`Cannot copy a FIFO pipe: ${src2}`);
    throw new Error(`Unknown file: ${src2}`);
  }
  function onFile(srcStat, destStat, src2, dest, opts) {
    if (!destStat)
      return copyFile(srcStat, src2, dest, opts);
    return mayCopyFile(srcStat, src2, dest, opts);
  }
  function mayCopyFile(srcStat, src2, dest, opts) {
    if (opts.overwrite) {
      fs2.unlinkSync(dest);
      return copyFile(srcStat, src2, dest, opts);
    } else if (opts.errorOnExist) {
      throw new Error(`'${dest}' already exists`);
    }
  }
  function copyFile(srcStat, src2, dest, opts) {
    fs2.copyFileSync(src2, dest);
    if (opts.preserveTimestamps)
      handleTimestamps(srcStat.mode, src2, dest);
    return setDestMode(dest, srcStat.mode);
  }
  function handleTimestamps(srcMode, src2, dest) {
    if (fileIsNotWritable(srcMode))
      makeFileWritable(dest, srcMode);
    return setDestTimestamps(src2, dest);
  }
  function fileIsNotWritable(srcMode) {
    return (srcMode & 128) === 0;
  }
  function makeFileWritable(dest, srcMode) {
    return setDestMode(dest, srcMode | 128);
  }
  function setDestMode(dest, srcMode) {
    return fs2.chmodSync(dest, srcMode);
  }
  function setDestTimestamps(src2, dest) {
    const updatedSrcStat = fs2.statSync(src2);
    return utimesMillisSync(dest, updatedSrcStat.atime, updatedSrcStat.mtime);
  }
  function onDir(srcStat, destStat, src2, dest, opts) {
    if (!destStat)
      return mkDirAndCopy(srcStat.mode, src2, dest, opts);
    return copyDir(src2, dest, opts);
  }
  function mkDirAndCopy(srcMode, src2, dest, opts) {
    fs2.mkdirSync(dest);
    copyDir(src2, dest, opts);
    return setDestMode(dest, srcMode);
  }
  function copyDir(src2, dest, opts) {
    fs2.readdirSync(src2).forEach((item) => copyDirItem(item, src2, dest, opts));
  }
  function copyDirItem(item, src2, dest, opts) {
    const srcItem = path3.join(src2, item);
    const destItem = path3.join(dest, item);
    if (opts.filter && !opts.filter(srcItem, destItem))
      return;
    const { destStat } = stat.checkPathsSync(srcItem, destItem, "copy", opts);
    return getStats(destStat, srcItem, destItem, opts);
  }
  function onLink(destStat, src2, dest, opts) {
    let resolvedSrc = fs2.readlinkSync(src2);
    if (opts.dereference) {
      resolvedSrc = path3.resolve(process.cwd(), resolvedSrc);
    }
    if (!destStat) {
      return fs2.symlinkSync(resolvedSrc, dest);
    } else {
      let resolvedDest;
      try {
        resolvedDest = fs2.readlinkSync(dest);
      } catch (err2) {
        if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
          return fs2.symlinkSync(resolvedSrc, dest);
        throw err2;
      }
      if (opts.dereference) {
        resolvedDest = path3.resolve(process.cwd(), resolvedDest);
      }
      if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
        throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
      }
      if (stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
        throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
      }
      return copyLink(resolvedSrc, dest);
    }
  }
  function copyLink(resolvedSrc, dest) {
    fs2.unlinkSync(dest);
    return fs2.symlinkSync(resolvedSrc, dest);
  }
  module.exports = copySync;
});
var require_copy2 = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  module.exports = {
    copy: u(require_copy()),
    copySync: require_copy_sync()
  };
});
var require_remove = __commonJS2((exports, module) => {
  var fs2 = require_graceful_fs();
  var u = require_universalify().fromCallback;
  function remove(path3, callback) {
    fs2.rm(path3, { recursive: true, force: true }, callback);
  }
  function removeSync(path3) {
    fs2.rmSync(path3, { recursive: true, force: true });
  }
  module.exports = {
    remove: u(remove),
    removeSync
  };
});
var require_empty = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var fs2 = require_fs();
  var path3 = import.meta.require("path");
  var mkdir3 = require_mkdirs();
  var remove = require_remove();
  var emptyDir = u(async function emptyDir(dir) {
    let items;
    try {
      items = await fs2.readdir(dir);
    } catch {
      return mkdir3.mkdirs(dir);
    }
    return Promise.all(items.map((item) => remove.remove(path3.join(dir, item))));
  });
  function emptyDirSync(dir) {
    let items;
    try {
      items = fs2.readdirSync(dir);
    } catch {
      return mkdir3.mkdirsSync(dir);
    }
    items.forEach((item) => {
      item = path3.join(dir, item);
      remove.removeSync(item);
    });
  }
  module.exports = {
    emptyDirSync,
    emptydirSync: emptyDirSync,
    emptyDir,
    emptydir: emptyDir
  };
});
var require_file = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var path3 = import.meta.require("path");
  var fs2 = require_fs();
  var mkdir3 = require_mkdirs();
  async function createFile(file) {
    let stats;
    try {
      stats = await fs2.stat(file);
    } catch {
    }
    if (stats && stats.isFile())
      return;
    const dir = path3.dirname(file);
    let dirStats = null;
    try {
      dirStats = await fs2.stat(dir);
    } catch (err2) {
      if (err2.code === "ENOENT") {
        await mkdir3.mkdirs(dir);
        await fs2.writeFile(file, "");
        return;
      } else {
        throw err2;
      }
    }
    if (dirStats.isDirectory()) {
      await fs2.writeFile(file, "");
    } else {
      await fs2.readdir(dir);
    }
  }
  function createFileSync(file) {
    let stats;
    try {
      stats = fs2.statSync(file);
    } catch {
    }
    if (stats && stats.isFile())
      return;
    const dir = path3.dirname(file);
    try {
      if (!fs2.statSync(dir).isDirectory()) {
        fs2.readdirSync(dir);
      }
    } catch (err2) {
      if (err2 && err2.code === "ENOENT")
        mkdir3.mkdirsSync(dir);
      else
        throw err2;
    }
    fs2.writeFileSync(file, "");
  }
  module.exports = {
    createFile: u(createFile),
    createFileSync
  };
});
var require_link = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var path3 = import.meta.require("path");
  var fs2 = require_fs();
  var mkdir3 = require_mkdirs();
  var { pathExists } = require_path_exists();
  var { areIdentical } = require_stat();
  async function createLink(srcpath, dstpath) {
    let dstStat;
    try {
      dstStat = await fs2.lstat(dstpath);
    } catch {
    }
    let srcStat;
    try {
      srcStat = await fs2.lstat(srcpath);
    } catch (err2) {
      err2.message = err2.message.replace("lstat", "ensureLink");
      throw err2;
    }
    if (dstStat && areIdentical(srcStat, dstStat))
      return;
    const dir = path3.dirname(dstpath);
    const dirExists = await pathExists(dir);
    if (!dirExists) {
      await mkdir3.mkdirs(dir);
    }
    await fs2.link(srcpath, dstpath);
  }
  function createLinkSync(srcpath, dstpath) {
    let dstStat;
    try {
      dstStat = fs2.lstatSync(dstpath);
    } catch {
    }
    try {
      const srcStat = fs2.lstatSync(srcpath);
      if (dstStat && areIdentical(srcStat, dstStat))
        return;
    } catch (err2) {
      err2.message = err2.message.replace("lstat", "ensureLink");
      throw err2;
    }
    const dir = path3.dirname(dstpath);
    const dirExists = fs2.existsSync(dir);
    if (dirExists)
      return fs2.linkSync(srcpath, dstpath);
    mkdir3.mkdirsSync(dir);
    return fs2.linkSync(srcpath, dstpath);
  }
  module.exports = {
    createLink: u(createLink),
    createLinkSync
  };
});
var require_symlink_paths = __commonJS2((exports, module) => {
  var path3 = import.meta.require("path");
  var fs2 = require_fs();
  var { pathExists } = require_path_exists();
  var u = require_universalify().fromPromise;
  async function symlinkPaths(srcpath, dstpath) {
    if (path3.isAbsolute(srcpath)) {
      try {
        await fs2.lstat(srcpath);
      } catch (err2) {
        err2.message = err2.message.replace("lstat", "ensureSymlink");
        throw err2;
      }
      return {
        toCwd: srcpath,
        toDst: srcpath
      };
    }
    const dstdir = path3.dirname(dstpath);
    const relativeToDst = path3.join(dstdir, srcpath);
    const exists = await pathExists(relativeToDst);
    if (exists) {
      return {
        toCwd: relativeToDst,
        toDst: srcpath
      };
    }
    try {
      await fs2.lstat(srcpath);
    } catch (err2) {
      err2.message = err2.message.replace("lstat", "ensureSymlink");
      throw err2;
    }
    return {
      toCwd: srcpath,
      toDst: path3.relative(dstdir, srcpath)
    };
  }
  function symlinkPathsSync(srcpath, dstpath) {
    if (path3.isAbsolute(srcpath)) {
      const exists2 = fs2.existsSync(srcpath);
      if (!exists2)
        throw new Error("absolute srcpath does not exist");
      return {
        toCwd: srcpath,
        toDst: srcpath
      };
    }
    const dstdir = path3.dirname(dstpath);
    const relativeToDst = path3.join(dstdir, srcpath);
    const exists = fs2.existsSync(relativeToDst);
    if (exists) {
      return {
        toCwd: relativeToDst,
        toDst: srcpath
      };
    }
    const srcExists = fs2.existsSync(srcpath);
    if (!srcExists)
      throw new Error("relative srcpath does not exist");
    return {
      toCwd: srcpath,
      toDst: path3.relative(dstdir, srcpath)
    };
  }
  module.exports = {
    symlinkPaths: u(symlinkPaths),
    symlinkPathsSync
  };
});
var require_symlink_type = __commonJS2((exports, module) => {
  var fs2 = require_fs();
  var u = require_universalify().fromPromise;
  async function symlinkType(srcpath, type) {
    if (type)
      return type;
    let stats;
    try {
      stats = await fs2.lstat(srcpath);
    } catch {
      return "file";
    }
    return stats && stats.isDirectory() ? "dir" : "file";
  }
  function symlinkTypeSync(srcpath, type) {
    if (type)
      return type;
    let stats;
    try {
      stats = fs2.lstatSync(srcpath);
    } catch {
      return "file";
    }
    return stats && stats.isDirectory() ? "dir" : "file";
  }
  module.exports = {
    symlinkType: u(symlinkType),
    symlinkTypeSync
  };
});
var require_symlink = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var path3 = import.meta.require("path");
  var fs2 = require_fs();
  var { mkdirs, mkdirsSync } = require_mkdirs();
  var { symlinkPaths, symlinkPathsSync } = require_symlink_paths();
  var { symlinkType, symlinkTypeSync } = require_symlink_type();
  var { pathExists } = require_path_exists();
  var { areIdentical } = require_stat();
  async function createSymlink(srcpath, dstpath, type) {
    let stats;
    try {
      stats = await fs2.lstat(dstpath);
    } catch {
    }
    if (stats && stats.isSymbolicLink()) {
      const [srcStat, dstStat] = await Promise.all([
        fs2.stat(srcpath),
        fs2.stat(dstpath)
      ]);
      if (areIdentical(srcStat, dstStat))
        return;
    }
    const relative3 = await symlinkPaths(srcpath, dstpath);
    srcpath = relative3.toDst;
    const toType = await symlinkType(relative3.toCwd, type);
    const dir = path3.dirname(dstpath);
    if (!await pathExists(dir)) {
      await mkdirs(dir);
    }
    return fs2.symlink(srcpath, dstpath, toType);
  }
  function createSymlinkSync(srcpath, dstpath, type) {
    let stats;
    try {
      stats = fs2.lstatSync(dstpath);
    } catch {
    }
    if (stats && stats.isSymbolicLink()) {
      const srcStat = fs2.statSync(srcpath);
      const dstStat = fs2.statSync(dstpath);
      if (areIdentical(srcStat, dstStat))
        return;
    }
    const relative3 = symlinkPathsSync(srcpath, dstpath);
    srcpath = relative3.toDst;
    type = symlinkTypeSync(relative3.toCwd, type);
    const dir = path3.dirname(dstpath);
    const exists = fs2.existsSync(dir);
    if (exists)
      return fs2.symlinkSync(srcpath, dstpath, type);
    mkdirsSync(dir);
    return fs2.symlinkSync(srcpath, dstpath, type);
  }
  module.exports = {
    createSymlink: u(createSymlink),
    createSymlinkSync
  };
});
var require_ensure = __commonJS2((exports, module) => {
  var { createFile, createFileSync } = require_file();
  var { createLink, createLinkSync } = require_link();
  var { createSymlink, createSymlinkSync } = require_symlink();
  module.exports = {
    createFile,
    createFileSync,
    ensureFile: createFile,
    ensureFileSync: createFileSync,
    createLink,
    createLinkSync,
    ensureLink: createLink,
    ensureLinkSync: createLinkSync,
    createSymlink,
    createSymlinkSync,
    ensureSymlink: createSymlink,
    ensureSymlinkSync: createSymlinkSync
  };
});
var require_utils2 = __commonJS2((exports, module) => {
  function stringify(obj, { EOL = "\n", finalEOL = true, replacer = null, spaces } = {}) {
    const EOF = finalEOL ? EOL : "";
    const str = JSON.stringify(obj, replacer, spaces);
    return str.replace(/\n/g, EOL) + EOF;
  }
  function stripBom(content) {
    if (Buffer.isBuffer(content))
      content = content.toString("utf8");
    return content.replace(/^\uFEFF/, "");
  }
  module.exports = { stringify, stripBom };
});
var require_jsonfile = __commonJS2((exports, module) => {
  var _fs;
  try {
    _fs = require_graceful_fs();
  } catch (_2) {
    _fs = import.meta.require("fs");
  }
  var universalify = require_universalify();
  var { stringify, stripBom } = require_utils2();
  async function _readFile(file, options22 = {}) {
    if (typeof options22 === "string") {
      options22 = { encoding: options22 };
    }
    const fs2 = options22.fs || _fs;
    const shouldThrow = "throws" in options22 ? options22.throws : true;
    let data = await universalify.fromCallback(fs2.readFile)(file, options22);
    data = stripBom(data);
    let obj;
    try {
      obj = JSON.parse(data, options22 ? options22.reviver : null);
    } catch (err2) {
      if (shouldThrow) {
        err2.message = `${file}: ${err2.message}`;
        throw err2;
      } else {
        return null;
      }
    }
    return obj;
  }
  var readFile = universalify.fromPromise(_readFile);
  function readFileSync(file, options22 = {}) {
    if (typeof options22 === "string") {
      options22 = { encoding: options22 };
    }
    const fs2 = options22.fs || _fs;
    const shouldThrow = "throws" in options22 ? options22.throws : true;
    try {
      let content = fs2.readFileSync(file, options22);
      content = stripBom(content);
      return JSON.parse(content, options22.reviver);
    } catch (err2) {
      if (shouldThrow) {
        err2.message = `${file}: ${err2.message}`;
        throw err2;
      } else {
        return null;
      }
    }
  }
  async function _writeFile(file, obj, options22 = {}) {
    const fs2 = options22.fs || _fs;
    const str = stringify(obj, options22);
    await universalify.fromCallback(fs2.writeFile)(file, str, options22);
  }
  var writeFile = universalify.fromPromise(_writeFile);
  function writeFileSync(file, obj, options22 = {}) {
    const fs2 = options22.fs || _fs;
    const str = stringify(obj, options22);
    return fs2.writeFileSync(file, str, options22);
  }
  var jsonfile = {
    readFile,
    readFileSync,
    writeFile,
    writeFileSync
  };
  module.exports = jsonfile;
});
var require_jsonfile2 = __commonJS2((exports, module) => {
  var jsonFile = require_jsonfile();
  module.exports = {
    readJson: jsonFile.readFile,
    readJsonSync: jsonFile.readFileSync,
    writeJson: jsonFile.writeFile,
    writeJsonSync: jsonFile.writeFileSync
  };
});
var require_output_file = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var fs2 = require_fs();
  var path3 = import.meta.require("path");
  var mkdir3 = require_mkdirs();
  var pathExists = require_path_exists().pathExists;
  async function outputFile(file, data, encoding = "utf-8") {
    const dir = path3.dirname(file);
    if (!await pathExists(dir)) {
      await mkdir3.mkdirs(dir);
    }
    return fs2.writeFile(file, data, encoding);
  }
  function outputFileSync(file, ...args) {
    const dir = path3.dirname(file);
    if (!fs2.existsSync(dir)) {
      mkdir3.mkdirsSync(dir);
    }
    fs2.writeFileSync(file, ...args);
  }
  module.exports = {
    outputFile: u(outputFile),
    outputFileSync
  };
});
var require_output_json = __commonJS2((exports, module) => {
  var { stringify } = require_utils2();
  var { outputFile } = require_output_file();
  async function outputJson(file, data, options22 = {}) {
    const str = stringify(data, options22);
    await outputFile(file, str, options22);
  }
  module.exports = outputJson;
});
var require_output_json_sync = __commonJS2((exports, module) => {
  var { stringify } = require_utils2();
  var { outputFileSync } = require_output_file();
  function outputJsonSync(file, data, options22) {
    const str = stringify(data, options22);
    outputFileSync(file, str, options22);
  }
  module.exports = outputJsonSync;
});
var require_json = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  var jsonFile = require_jsonfile2();
  jsonFile.outputJson = u(require_output_json());
  jsonFile.outputJsonSync = require_output_json_sync();
  jsonFile.outputJSON = jsonFile.outputJson;
  jsonFile.outputJSONSync = jsonFile.outputJsonSync;
  jsonFile.writeJSON = jsonFile.writeJson;
  jsonFile.writeJSONSync = jsonFile.writeJsonSync;
  jsonFile.readJSON = jsonFile.readJson;
  jsonFile.readJSONSync = jsonFile.readJsonSync;
  module.exports = jsonFile;
});
var require_move = __commonJS2((exports, module) => {
  var fs2 = require_fs();
  var path3 = import.meta.require("path");
  var { copy } = require_copy2();
  var { remove } = require_remove();
  var { mkdirp } = require_mkdirs();
  var { pathExists } = require_path_exists();
  var stat = require_stat();
  async function move(src2, dest, opts = {}) {
    const overwrite = opts.overwrite || opts.clobber || false;
    const { srcStat, isChangingCase = false } = await stat.checkPaths(src2, dest, "move", opts);
    await stat.checkParentPaths(src2, srcStat, dest, "move");
    const destParent = path3.dirname(dest);
    const parsedParentPath = path3.parse(destParent);
    if (parsedParentPath.root !== destParent) {
      await mkdirp(destParent);
    }
    return doRename(src2, dest, overwrite, isChangingCase);
  }
  async function doRename(src2, dest, overwrite, isChangingCase) {
    if (!isChangingCase) {
      if (overwrite) {
        await remove(dest);
      } else if (await pathExists(dest)) {
        throw new Error("dest already exists.");
      }
    }
    try {
      await fs2.rename(src2, dest);
    } catch (err2) {
      if (err2.code !== "EXDEV") {
        throw err2;
      }
      await moveAcrossDevice(src2, dest, overwrite);
    }
  }
  async function moveAcrossDevice(src2, dest, overwrite) {
    const opts = {
      overwrite,
      errorOnExist: true,
      preserveTimestamps: true
    };
    await copy(src2, dest, opts);
    return remove(src2);
  }
  module.exports = move;
});
var require_move_sync = __commonJS2((exports, module) => {
  var fs2 = require_graceful_fs();
  var path3 = import.meta.require("path");
  var copySync = require_copy2().copySync;
  var removeSync = require_remove().removeSync;
  var mkdirpSync = require_mkdirs().mkdirpSync;
  var stat = require_stat();
  function moveSync(src2, dest, opts) {
    opts = opts || {};
    const overwrite = opts.overwrite || opts.clobber || false;
    const { srcStat, isChangingCase = false } = stat.checkPathsSync(src2, dest, "move", opts);
    stat.checkParentPathsSync(src2, srcStat, dest, "move");
    if (!isParentRoot(dest))
      mkdirpSync(path3.dirname(dest));
    return doRename(src2, dest, overwrite, isChangingCase);
  }
  function isParentRoot(dest) {
    const parent = path3.dirname(dest);
    const parsedPath = path3.parse(parent);
    return parsedPath.root === parent;
  }
  function doRename(src2, dest, overwrite, isChangingCase) {
    if (isChangingCase)
      return rename2(src2, dest, overwrite);
    if (overwrite) {
      removeSync(dest);
      return rename2(src2, dest, overwrite);
    }
    if (fs2.existsSync(dest))
      throw new Error("dest already exists.");
    return rename2(src2, dest, overwrite);
  }
  function rename2(src2, dest, overwrite) {
    try {
      fs2.renameSync(src2, dest);
    } catch (err2) {
      if (err2.code !== "EXDEV")
        throw err2;
      return moveAcrossDevice(src2, dest, overwrite);
    }
  }
  function moveAcrossDevice(src2, dest, overwrite) {
    const opts = {
      overwrite,
      errorOnExist: true,
      preserveTimestamps: true
    };
    copySync(src2, dest, opts);
    return removeSync(src2);
  }
  module.exports = moveSync;
});
var require_move2 = __commonJS2((exports, module) => {
  var u = require_universalify().fromPromise;
  module.exports = {
    move: u(require_move()),
    moveSync: require_move_sync()
  };
});
var require_lib2 = __commonJS2((exports, module) => {
  module.exports = {
    ...require_fs(),
    ...require_copy2(),
    ...require_empty(),
    ...require_ensure(),
    ...require_json(),
    ...require_mkdirs(),
    ...require_move2(),
    ...require_output_file(),
    ...require_path_exists(),
    ...require_remove()
  };
});
var env_default2;
var init_env = __esm2(() => {
  init_src3();
  env_default2 = {
    APP_NAME: vine_default2.string(),
    APP_ENV: vine_default2.enum(["local", "dev", "stage", "prod"]),
    APP_KEY: vine_default2.string(),
    APP_URL: vine_default2.string(),
    PORT: vine_default2.number(),
    PORT_BACKEND: vine_default2.number(),
    PORT_ADMIN: vine_default2.number(),
    PORT_LIBRARY: vine_default2.number(),
    PORT_DESKTOP: vine_default2.number(),
    PORT_EMAIL: vine_default2.number(),
    PORT_DOCS: vine_default2.number(),
    PORT_INSPECT: vine_default2.number(),
    PORT_API: vine_default2.number(),
    PORT_SYSTEM_TRAY: vine_default2.number(),
    APP_MAINTENANCE: vine_default2.boolean(),
    DEBUG: vine_default2.boolean(),
    API_PREFIX: vine_default2.string(),
    DOCS_PREFIX: vine_default2.string(),
    DB_CONNECTION: vine_default2.enum(["mysql", "sqlite", "postgres"]),
    DB_HOST: vine_default2.string(),
    DB_PORT: vine_default2.number(),
    DB_DATABASE: vine_default2.string(),
    DB_USERNAME: vine_default2.string(),
    DB_PASSWORD: vine_default2.string(),
    AWS_ACCOUNT_ID: vine_default2.string(),
    AWS_ACCESS_KEY_ID: vine_default2.string(),
    AWS_SECRET_ACCESS_KEY: vine_default2.string(),
    AWS_DEFAULT_REGION: vine_default2.string(),
    AWS_DEFAULT_PASSWORD: vine_default2.string(),
    MAIL_MAILER: vine_default2.enum(["ses", "sendmail", "log", "smtp"]),
    MAIL_HOST: vine_default2.string(),
    MAIL_PORT: vine_default2.number(),
    MAIL_USERNAME: vine_default2.string(),
    MAIL_PASSWORD: vine_default2.string(),
    MAIL_ENCRYPTION: vine_default2.string(),
    MAIL_FROM_NAME: vine_default2.string(),
    MAIL_FROM_ADDRESS: vine_default2.string(),
    SEARCH_ENGINE_DRIVER: vine_default2.enum(["meilisearch", "algolia", "typesense"]),
    MEILISEARCH_HOST: vine_default2.string(),
    MEILISEARCH_KEY: vine_default2.string(),
    FRONTEND_APP_ENV: vine_default2.enum(["development", "staging", "production"]),
    FRONTEND_APP_URL: vine_default2.string()
  };
});
var envEnum2;
var envStructure2;
var envSchema2;
var init_types2 = __esm2(() => {
  init_src3();
  init_env();
  envEnum2 = {
    APP_ENV: ["local", "dev", "development", "staging", "prod", "production"],
    DB_CONNECTION: ["mysql", "sqlite", "postgres", "dynamodb"],
    MAIL_MAILER: ["smtp", "mailgun", "ses", "postmark", "sendmail", "log"],
    SEARCH_ENGINE_DRIVER: ["opensearch"],
    FRONTEND_APP_ENV: ["development", "staging", "production"]
  };
  envStructure2 = Object.entries(env_default2).reduce((acc, [key, value]) => {
    let validatorType;
    switch (typeof value) {
      case "string":
        validatorType = vine_default2.string();
        break;
      case "number":
        validatorType = vine_default2.number();
        break;
      case "boolean":
        validatorType = vine_default2.boolean();
        break;
      default:
        if (Array.isArray(value)) {
          validatorType = vine_default2.enum(value);
          break;
        }
        if (typeof value === "object") {
          const schemaNameSymbol = Symbol.for("schema_name");
          const schemaName = value[schemaNameSymbol];
          if (schemaName === "vine.string") {
            validatorType = vine_default2.string();
            break;
          }
          if (schemaName === "vine.number") {
            validatorType = vine_default2.number();
            break;
          }
          if (schemaName === "vine.boolean") {
            validatorType = vine_default2.boolean();
            break;
          }
          if (!schemaName) {
            validatorType = vine_default2.enum(envEnum2.APP_ENV);
            break;
          }
          console.error("Unknown env value type", typeof value);
        }
        throw new Error(`Invalid env value for ${key}`);
    }
    const envKey = key;
    acc[envKey] = validatorType;
    return acc;
  }, {});
  envSchema2 = vine_default2.object(envStructure2);
});
function process2() {
  return typeof Bun !== "undefined" ? Bun.env : p3.env;
}
var handler2;
var env22;
var init_src4 = __esm2(() => {
  init_src11();
  init_src3();
  init_types2();
  handler2 = {
    get: (target, key) => {
      const value = target[key];
      if (typeof value === "string" && /^\d+$/.test(value) && key !== "AWS_ACCOUNT_ID")
        return Number(value);
      if (typeof value === "string" && /^true|false$/.test(value))
        return value === "true";
      if (value instanceof VineEnum2)
        return target[key];
      if (value instanceof VineBoolean2)
        return !!target[key];
      if (value instanceof VineNumber2)
        return Number(target[key]);
      return value;
    }
  };
  env22 = new Proxy(process2(), handler2);
});
var app_default2;
var init_app = __esm2(() => {
  init_src4();
  app_default2 = {
    name: env22.APP_NAME ?? "Stacks",
    description: "Stacks is a full-stack framework for building modern web applications.",
    env: env22.APP_ENV ?? "local",
    url: env22.APP_URL ?? "stacks.localhost",
    redirectUrls: ["stacksjs.com"],
    debug: env22.DEBUG ?? false,
    key: env22.APP_KEY,
    maintenanceMode: env22.APP_MAINTENANCE ?? false,
    docMode: false,
    timezone: "America/Los_Angeles",
    locale: "en",
    fallbackLocale: "en",
    cipher: "aes-256-cbc"
  };
});
var cache_default2;
var init_cache = __esm2(() => {
  init_src4();
  cache_default2 = {
    driver: "dynamodb",
    prefix: "stacks",
    ttl: 3600,
    drivers: {
      dynamodb: {
        key: env22.AWS_ACCESS_KEY_ID || "",
        secret: env22.AWS_SECRET_ACCESS_KEY || "",
        region: env22.AWS_DEFAULT_REGION || "us-east-1",
        table: "cache",
        endpoint: ""
      },
      memcached: {
        persistent_id: "",
        sasl: ["", ""],
        options: {},
        servers: [
          {
            host: "127.0.0.1",
            port: 11211,
            weight: 100
          }
        ]
      },
      redis: {
        connection: "cache",
        host: "127.0.0.1",
        port: 6379,
        password: "",
        username: "stacks"
      }
    }
  };
});
var cli_default2;
var init_cli2 = __esm2(() => {
  cli_default2 = {
    name: "My Custom CLI",
    command: "custom-cli",
    description: "This is an example command to illustrate how to create your own commands. Check out `../app/commands` for more.",
    deploy: true
  };
});
var security_default2;
var init_security = __esm2(() => {
  security_default2 = {
    firewall: {
      enabled: true,
      countryCodes: ["RU", "IR"],
      ipAddresses: [],
      rateLimitPerMinute: 1000,
      useIpReputationLists: true,
      useKnownBadInputsRuleSet: true,
      queryString: [],
      httpHeaders: []
    }
  };
});
var cloud_default2;
var init_cloud = __esm2(() => {
  init_src4();
  init_security();
  cloud_default2 = {
    sites: {
      root: "stacksjs.org",
      path: "dist",
      modals: {
        domain: "modals.stacksjs.org",
        path: "dist"
      },
      stepper: {
        domain: "stepper.stacksjs.org",
        path: "dist"
      },
      notification: {
        domain: "notification.stacksjs.org",
        path: "dist"
      },
      docs: {
        domain: "docs.stacksjs.org",
        path: "dist"
      },
      tlsx: {
        domain: "tlsx.stacksjs.org",
        path: "dist"
      },
      dtsx: {
        domain: "dtsx.stacksjs.org",
        path: "dist"
      },
      spreadsheet: {
        domain: "spreadsheet.stacksjs.org",
        path: "dist"
      }
    },
    infrastructure: {
      type: "serverless",
      driver: "aws",
      firewall: security_default2.firewall,
      environments: ["production", "staging", "development"],
      storage: {},
      api: {
        prefix: env22.API_PREFIX || "api",
        description: "My awesome Stacks API",
        deploy: true,
        memorySize: 512,
        prewarm: 10,
        timeout: 30
      },
      cdn: {
        compress: true,
        allowedMethods: "ALL",
        cachedMethods: "GET_HEAD",
        originShieldRegion: "us-east-1",
        minTtl: 0,
        defaultTtl: 86400,
        maxTtl: 31536000,
        cookieBehavior: "none",
        allowList: {
          cookies: [],
          headers: [],
          queryStrings: []
        },
        realtimeLogs: {
          enabled: true,
          samplingRate: 1
        }
      },
      fileSystem: true
    }
  };
});
var database_default2;
var init_database = __esm2(() => {
  init_src4();
  database_default2 = {
    default: env22.DB_CONNECTION || "sqlite",
    connections: {
      sqlite: {
        database: env22.DB_DATABASE || "database/stacks.sqlite",
        prefix: ""
      },
      dynamodb: {
        key: env22.AWS_ACCESS_KEY_ID || "",
        secret: env22.AWS_SECRET_ACCESS_KEY || "",
        region: env22.AWS_DEFAULT_REGION || "us-east-1",
        prefix: env22.DB_DATABASE || "stacks",
        endpoint: "http://localhost",
        port: env22.DB_PORT || 8000
      },
      mysql: {
        name: env22.DB_DATABASE || "stacks",
        host: env22.DB_HOST || "127.0.0.1",
        port: env22.DB_PORT || 3306,
        username: env22.DB_USERNAME || "root",
        password: env22.DB_PASSWORD || "",
        prefix: ""
      },
      postgres: {
        name: env22.DB_DATABASE || "stacks",
        host: env22.DB_HOST || "127.0.0.1",
        port: env22.DB_PORT || 3306,
        username: env22.DB_USERNAME || "",
        password: env22.DB_PASSWORD || "",
        prefix: ""
      }
    },
    migrations: "migrations",
    migrationLocks: "migration_locks"
  };
});
var dns_default2;
var init_dns = __esm2(() => {
  init_src4();
  dns_default2 = {
    a: [
      {
        name: env22.APP_URL || "",
        address: "10.0.0.1",
        ttl: 300
      },
      {
        name: "www",
        address: "@",
        ttl: 300
      }
    ],
    aaaa: [],
    cname: [],
    mx: [],
    txt: [],
    nameservers: []
  };
});
var email_default2;
var init_email = __esm2(() => {
  init_src4();
  email_default2 = {
    from: {
      name: env22.MAIL_FROM_NAME || "Stacks",
      address: env22.MAIL_FROM_ADDRESS || "no-reply@stacksjs.org"
    },
    mailboxes: ["chris@stacksjs.org", "blake@stacksjs.org", "glenn@stacksjs.org"],
    url: env22.APP_URL || "http://localhost:3000",
    charset: "UTF-8",
    server: {
      scan: true
    }
  };
});
var errors_default2;
var init_errors = __esm2(() => {
  errors_default2 = {
    messages: {
      string: "The {{ field }} field must be a string",
      email: "The {{ field }} field must be a valid email address",
      regex: "The {{ field }} field format is invalid",
      url: "The {{ field }} field must be a valid URL",
      activeUrl: "The {{ field }} field must be a valid URL",
      alpha: "The {{ field }} field must contain only letters",
      alphaNumeric: "The {{ field }} field must contain only letters and numbers",
      minLength: "The {{ field }} field must have at least {{ min }} characters",
      maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
      fixedLength: "The {{ field }} field must be {{ size }} characters long",
      confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
      endsWith: "The {{ field }} field must end with {{ substring }}",
      startsWith: "The {{ field }} field must start with {{ substring }}",
      sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
      notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
      in: "The selected {{ field }} is invalid",
      notIn: "The selected {{ field }} is invalid",
      ipAddress: "The {{ field }} field must be a valid IP address",
      uuid: "The {{ field }} field must be a valid UUID",
      ascii: "The {{ field }} field must only contain ASCII characters",
      creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
      hexCode: "The {{ field }} field must be a valid hex color code",
      iban: "The {{ field }} field must be a valid IBAN number",
      jwt: "The {{ field }} field must be a valid JWT token",
      coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
      mobile: "The {{ field }} field must be a valid mobile phone number",
      passport: "The {{ field }} field must be a valid passport number",
      postalCode: "The {{ field }} field must be a valid postal code",
      boolean: "The value must be a boolean",
      number: "The {{ field }} field must be a number",
      min: "The {{ field }} field must be at least {{ min }}",
      max: "The {{ field }} field must not be greater than {{ max }}",
      range: "The {{ field }} field must be between {{ min }} and {{ max }}",
      positive: "The {{ field }} field must be positive",
      negative: "The {{ field }} field must be negative",
      decimal: "The {{ field }} field must have {{ digits }} decimal places",
      withoutDecimals: "The {{ field }} field must not have decimal places",
      date: "The {{ field }} field must be a datetime value",
      "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
      "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
      "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
      "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
      "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
      "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
      "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
      "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
      accepted: "The {{ field }} field must be accepted",
      enum: "The selected {{ field }} is invalid",
      literal: "The {{ field }} field must be {{ expectedValue }}",
      object: "The {{ field }} field must be an object",
      record: "The {{ field }} field must be an object",
      "record.minLength": "The {{ field }} field must have at least {{ min }} items",
      "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
      "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
      array: "The {{ field }} field must be an array",
      "array.minLength": "The {{ field }} field must have at least {{ min }} items",
      "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
      "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
      notEmpty: "The {{ field }} field must not be empty",
      distinct: "The {{ field }} field has duplicate values",
      tuple: "The {{ field }} field must be an array",
      union: "Invalid value provided for {{ field }} field",
      unionGroup: "Invalid value provided for {{ field }} field",
      unionOfTypes: "Invalid value provided for {{ field }} field"
    }
  };
});
var git_default2;
var init_git = __esm2(() => {
  git_default2 = {
    hooks: {
      "pre-commit": "lint-staged"
    },
    scopes: [
      "",
      "ci",
      "deps",
      "dx",
      "release",
      "docs",
      "test",
      "core",
      "actions",
      "arrays",
      "auth",
      "build",
      "cache",
      "cli",
      "cloud",
      "collections",
      "config",
      "database",
      "datetime",
      "docs",
      "errors",
      "git",
      "lint",
      "x-ray",
      "modules",
      "notifications",
      "objects",
      "path",
      "realtime",
      "router",
      "buddy",
      "security",
      "server",
      "storage",
      "strings",
      "tests",
      "types",
      "ui",
      "utils"
    ],
    messages: {
      type: "Select the type of change that you\u2019re committing:",
      scope: "Select the SCOPE of this change (optional):",
      customScope: "Select the SCOPE of this change:",
      subject: "Write a SHORT, IMPERATIVE tense description of the change:\n",
      body: 'Provide a LONGER description of the change (optional). Use "|" to break new line:\n',
      breaking: 'List any BREAKING CHANGES (optional). Use "|" to break new line:\n',
      footerPrefixesSelect: "Select the ISSUES type of the change list by this change (optional):",
      customFooterPrefixes: "Input ISSUES prefix:",
      footer: "List any ISSUES by this change. E.g.: #31, #34:\n",
      confirmCommit: "Are you sure you want to proceed with the commit above?"
    },
    types: [
      { value: "feat", name: "feat:     \u2728  A new feature", emoji: ":sparkles:" },
      { value: "fix", name: "fix:      \uD83D\uDC1B  A bug fix", emoji: ":bug:" },
      {
        value: "docs",
        name: "docs:     \uD83D\uDCDD  Documentation only changes",
        emoji: ":memo:"
      },
      {
        value: "style",
        name: "style:    \uD83D\uDC84  Changes that do not affect the meaning of the code",
        emoji: ":lipstick:"
      },
      {
        value: "refactor",
        name: "refactor: \u267B\uFE0F   A code change that neither fixes a bug nor adds a feature",
        emoji: ":recycle:"
      },
      {
        value: "perf",
        name: "perf:     \u26A1\uFE0F  A code change that improves performance",
        emoji: ":zap:"
      },
      {
        value: "test",
        name: "test:     \u2705  Adding missing tests or adjusting existing tests",
        emoji: ":white_check_mark:"
      },
      {
        value: "build",
        name: "build:    \uD83D\uDCE6\uFE0F  Changes that affect the build system or external dependencies",
        emoji: ":package:"
      },
      {
        value: "ci",
        name: "ci:       \uD83C\uDFA1  Changes to our CI configuration files and scripts",
        emoji: ":ferris_wheel:"
      },
      {
        value: "chore",
        name: "chore:    \uD83D\uDD28  Other changes that don\u2019t modify src or test files",
        emoji: ":hammer:"
      },
      {
        value: "revert",
        name: "revert:   \u23EA\uFE0F  Reverts a previous commit",
        emoji: ":rewind:"
      }
    ]
  };
});
var hashing_default2;
var init_hashing = __esm2(() => {
  hashing_default2 = {
    driver: "argon2",
    bcrypt: {
      rounds: 10,
      cost: 4
    },
    argon2: {
      memory: 65536,
      threads: 1,
      time: 1
    }
  };
});
var library_default2;
var init_library = __esm2(() => {
  library_default2 = {
    name: "hello-world",
    owner: "@stacksjs",
    repository: "stacksjs/stacks",
    license: "MIT",
    author: "Chris Breuer",
    contributors: ["Chris Breuer <chris@stacksjs.org>"],
    defaultLanguage: "en",
    releaseable: true,
    vueComponents: {
      name: "hello-world-vue",
      description: "Your Vue component library description",
      keywords: ["component", "library", "vue", "vite", "typescript", "javascript"],
      tags: [
        {
          name: ["HelloWorld", "AppHelloWorld"],
          description: "The Hello World custom element, built via this framework.",
          attributes: [
            {
              name: "greeting",
              description: "The greeting."
            }
          ]
        }
      ]
    },
    webComponents: {
      name: "hello-world-elements",
      description: "Your framework agnostic web component library description.",
      keywords: ["custom-elements", "web-components", "library", "framework-agnostic", "typescript", "javascript"],
      tags: [
        {
          name: ["HelloWorld", "AppHelloWorld"],
          description: "The Hello World custom element, built via this framework.",
          attributes: [
            {
              name: "greeting",
              description: "The greeting."
            }
          ]
        }
      ]
    },
    functions: {
      name: "hello-world-fx",
      description: "Your function library description.",
      keywords: ["functions", "composables", "library", "typescript", "javascript"],
      shouldGenerateSourcemap: false,
      files: ["counter", "dark"]
    }
  };
});
var logging_default2;
var init_logging = __esm2(() => {
  init_src11();
  logging_default2 = {
    logsPath: storagePath2("logs/stacks.log"),
    deploymentsPath: storagePath2("logs/deployments.log")
  };
});
var notification_default2;
var init_notification = __esm2(() => {
  notification_default2 = {
    default: "email"
  };
});
var payment_default2;
var init_payment = __esm2(() => {
  init_src4();
  payment_default2 = {
    driver: "stripe",
    stripe: {
      publishableKey: env22.STRIPE_PUBLISHABLE_KEY || "",
      secretKey: env22.STRIPE_SECRET_KEY || ""
    }
  };
});
var ports_default2;
var init_ports = __esm2(() => {
  init_src4();
  ports_default2 = {
    frontend: env22.PORT ?? 3000,
    backend: env22.PORT_BACKEND ?? 3001,
    admin: env22.PORT_ADMIN ?? 3002,
    library: env22.PORT_LIBRARY ?? 3003,
    desktop: env22.PORT_DESKTOP ?? 3004,
    email: env22.PORT_EMAIL ?? 3005,
    docs: env22.PORT_DOCS ?? 3006,
    inspect: env22.PORT_INSPECT ?? 3007,
    api: env22.PORT_API ?? 3008,
    systemTray: env22.PORT_SYSTEM_TRAY ?? 3009,
    database: 3010
  };
});
var queue_default2;
var init_queue = __esm2(() => {
  queue_default2 = {
    default: "sync",
    connections: {
      sync: {
        driver: "sync"
      },
      sqs: {
        driver: "sqs",
        key: "",
        secret: "",
        prefix: "",
        suffix: "",
        queue: "default",
        region: "us-east-1"
      }
    }
  };
});
var saas_default2;
var init_saas = __esm2(() => {
  saas_default2 = {
    plans: [
      {
        productName: "Stacks Hobby",
        description: "All the Stacks features.",
        pricing: [
          {
            key: "stacks_hobby_monthly",
            price: 3900,
            interval: "month",
            currency: "usd"
          },
          {
            key: "stacks_hobby_yearly",
            price: 37900,
            interval: "year",
            currency: "usd"
          }
        ],
        metadata: {
          createdBy: "admin",
          version: "1.0.0"
        }
      },
      {
        productName: "Stacks Pro",
        description: "All the Stacks features, including being able to invite team members.",
        pricing: [
          {
            key: "stacks_pro_monthly",
            price: 5900,
            interval: "month",
            currency: "usd"
          },
          {
            key: "stacks_pro_yearly",
            price: 57900,
            interval: "year",
            currency: "usd"
          }
        ],
        metadata: {
          createdBy: "admin",
          version: "1.0.0"
        }
      }
    ],
    webhook: {
      endpoint: "/webhooks/stripe",
      secret: ""
    },
    currencies: ["usd"],
    coupons: [
      {
        code: "SUMMER2024",
        amountOff: 500,
        duration: "once"
      }
    ],
    products: [
      {
        name: "Stacks Pro",
        description: "All the Stacks features.",
        images: ["url_to_image"]
      }
    ]
  };
});
var search_engine_default2;
var init_search_engine = __esm2(() => {
  search_engine_default2 = {
    driver: "opensearch"
  };
});
var services_default2;
var init_services = __esm2(() => {
  init_src4();
  services_default2 = {
    aws: {
      accountId: env22.AWS_ACCOUNT_ID || "",
      appId: env22.AWS_ACCESS_KEY_ID || "",
      apiKey: env22.AWS_SECRET_ACCESS_KEY || "",
      region: env22.AWS_DEFAULT_REGION || "us-east-1"
    },
    algolia: {
      appId: "",
      apiKey: ""
    },
    meilisearch: {
      appId: "",
      apiKey: ""
    },
    lemonSqueezy: {
      appId: "",
      apiKey: ""
    },
    stripe: {
      appId: "",
      apiKey: ""
    }
  };
});
var storage_default2;
var init_storage = __esm2(() => {
  storage_default2 = {
    driver: "s3"
  };
});
var team_default2;
var init_team = __esm2(() => {
  team_default2 = {
    name: "Stacks",
    members: {
      chris: "chris@stacksjs.org",
      blake: "blake@stacksjs.org",
      zoltan: "zoltan@stacksjs.org",
      freddy: "freddy@stacksjs.org",
      glenn: "glenn@stacksjs.org",
      dorell: "dorell@stacksjs.org",
      avery: "avery@stacksjs.org",
      adelino: "adelino@stacksjs.org"
    }
  };
});
var ui_default2;
var init_ui = __esm2(() => {
  ui_default2 = {
    shortcuts: [
      [
        "btn",
        "inline-flex items-center px-4 py-2 ml-2 border border-transparent shadow-sm text-base font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 cursor-pointer"
      ]
    ],
    safelist: "prose prose-sm m-auto text-left",
    trigger: ":stx:",
    classPrefix: "stx-",
    reset: "tailwind",
    icons: ["heroicons"],
    fonts: {
      email: {
        title: "Mona",
        text: "Hubot"
      },
      desktop: {
        title: "Mona",
        text: "Hubot"
      },
      mobile: {
        title: "Mona",
        text: "Hubot"
      },
      web: {
        title: "Mona",
        text: "Hubot"
      }
    },
    theme: {
      colors: {
        veryCool: "#0000ff",
        brand: {
          primary: "hsl(var(--hue, 217) 78% 51%)"
        }
      }
    }
  };
});
var config22;
var overrides_default2;
var init_overrides = __esm2(() => {
  init_ai();
  init_analytics();
  init_app();
  init_cache();
  init_cli2();
  init_cloud();
  init_database();
  init_dns();
  init_email();
  init_errors();
  init_git();
  init_hashing();
  init_library();
  init_logging();
  init_notification();
  init_payment();
  init_ports();
  init_queue();
  init_saas();
  init_search_engine();
  init_security();
  init_services();
  init_storage();
  init_team();
  init_ui();
  config22 = {
    ai: ai_default2,
    analytics: analytics_default2,
    app: app_default2,
    cache: cache_default2,
    cli: cli_default2,
    cloud: cloud_default2,
    database: database_default2,
    dns: dns_default2,
    email: email_default2,
    errors: errors_default2,
    git: git_default2,
    hashing: hashing_default2,
    library: library_default2,
    logging: logging_default2,
    notification: notification_default2,
    queue: queue_default2,
    payment: payment_default2,
    ports: ports_default2,
    saas: saas_default2,
    searchEngine: search_engine_default2,
    security: security_default2,
    services: services_default2,
    storage: storage_default2,
    team: team_default2,
    ui: ui_default2
  };
  overrides_default2 = config22;
});
async function localTunnel2(options22) {
  const port = 3000;
  if (!options22?.port)
    options22 = { port };
  console.log("Creating local tunnel", options22.port);
  return "localTunnel";
}
async function createLocalTunnel2(port) {
  return await localTunnel2({ port });
}
var init_src5 = () => {
};
async function localUrl2({
  domain = exports_config2.app.url || "stacks",
  type = "frontend",
  localhost = false,
  https = undefined,
  network = undefined
} = {}) {
  let url = domain.replace(/\.[^.]+$/, ".localhost");
  switch (type) {
    case "frontend":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.frontend || 3000);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.frontend}`;
      break;
    case "backend":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.backend || 3001);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.backend}`;
      url = `api.${url}`;
      break;
    case "admin":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.admin || 3002);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.admin}`;
      url = `admin.${url}`;
      break;
    case "library":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.library || 3003);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.library}`;
      url = `libs.${url}`;
      break;
    case "email":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.email || 3005);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.email}`;
      url = `email.${url}`;
      break;
    case "desktop":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.desktop || 3004);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.desktop}`;
      url = `desktop.${url}`;
      break;
    case "docs":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.docs || 3006);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.docs}`;
      url = `docs.${url}`;
      break;
    case "inspect":
      if (network)
        return await createLocalTunnel2(exports_config2.ports?.inspect || 3007);
      if (localhost)
        return `http://localhost:${exports_config2.ports?.inspect}`;
      url = `inspect.${url}`;
      break;
    default:
      if (localhost)
        return `http://localhost:${exports_config2.ports?.frontend}`;
  }
  if (https)
    return `https://${url}`;
  return `http://${url}`;
}
function defineStacksConfig2(config32) {
  return config32;
}
function defineApp2(config32) {
  return config32;
}
function defineCache2(config32) {
  return config32;
}
function defineCdn2(config32) {
  return config32;
}
function defineChat2(config32) {
  return config32;
}
function defineCli2(config32) {
  return config32;
}
function defineJob2(config32) {
  return config32;
}
function defineCronJob2(config32) {
  return config32;
}
function defineDatabase2(config32) {
  return config32;
}
function defineDependencies2(config32) {
  return config32;
}
function defineDns2(config32) {
  return config32;
}
function defineEmailConfig2(config32) {
  return config32;
}
function defineEmail2(config32) {
  return config32;
}
function defineGit2(config32) {
  return config32;
}
function defineHashing2(config32) {
  return config32;
}
function defineLibrary2(config32) {
  return config32;
}
function defineNotification2(config32) {
  return config32;
}
function definePayment2(config32) {
  return config32;
}
function defineQueue2(config32) {
  return config32;
}
function defineSearchEngine2(config32) {
  return config32;
}
function defineSecurity2(config32) {
  return config32;
}
function defineServices2(config32) {
  return config32;
}
function defineSms2(config32) {
  return config32;
}
function defineStorage2(config32) {
  return config32;
}
function defineUi2(config32) {
  return config32;
}
function defineModel2(config32) {
  return config32;
}
function defineEvents2(config32) {
  return config32;
}
var init_helpers2 = __esm2(() => {
  init_src5();
  init_src6();
});
var exports_config2 = {};
__export3(exports_config2, {
  ui: () => ui22,
  team: () => team22,
  storage: () => storage22,
  services: () => services22,
  security: () => security22,
  searchEngine: () => searchEngine2,
  saas: () => saas22,
  queue: () => queue22,
  ports: () => ports22,
  payment: () => payment2,
  overrides: () => overrides_default2,
  notification: () => notification2,
  logging: () => logging22,
  localUrl: () => localUrl2,
  library: () => library22,
  hashing: () => hashing22,
  git: () => git22,
  errors: () => errors22,
  email: () => email22,
  docs: () => docs22,
  dns: () => dns22,
  determineAppEnv: () => determineAppEnv2,
  defineUi: () => defineUi2,
  defineStorage: () => defineStorage2,
  defineStacksConfig: () => defineStacksConfig2,
  defineSms: () => defineSms2,
  defineServices: () => defineServices2,
  defineSecurity: () => defineSecurity2,
  defineSearchEngine: () => defineSearchEngine2,
  defineQueue: () => defineQueue2,
  definePayment: () => definePayment2,
  defineNotification: () => defineNotification2,
  defineModel: () => defineModel2,
  defineLibrary: () => defineLibrary2,
  defineJob: () => defineJob2,
  defineHashing: () => defineHashing2,
  defineGit: () => defineGit2,
  defineEvents: () => defineEvents2,
  defineEmailConfig: () => defineEmailConfig2,
  defineEmail: () => defineEmail2,
  defineDns: () => defineDns2,
  defineDependencies: () => defineDependencies2,
  defineDatabase: () => defineDatabase2,
  defineCronJob: () => defineCronJob2,
  defineCli: () => defineCli2,
  defineChat: () => defineChat2,
  defineCdn: () => defineCdn2,
  defineCache: () => defineCache2,
  defineApp: () => defineApp2,
  defaults: () => defaults_default2,
  database: () => database22,
  config: () => config32,
  cloud: () => cloud22,
  cli: () => cli2,
  cache: () => cache22,
  app: () => app22,
  analytics: () => analytics22,
  ai: () => ai22
});
function determineAppEnv2() {
  if (app22.env === "local")
    return "dev";
  if (app22.env === "development")
    return "dev";
  if (app22.env === "staging")
    return "stage";
  if (app22.env === "production")
    return "prod";
  if (!app22.env)
    throw new Error("Couldn\'t determine app environment");
  return app22.env;
}
var config32;
var ai22;
var analytics22;
var app22;
var cache22;
var cloud22;
var cli2;
var database22;
var dns22;
var docs22;
var email22;
var errors22;
var git22;
var hashing22;
var library22;
var logging22;
var notification2;
var payment2;
var ports22;
var queue22;
var security22;
var saas22;
var searchEngine2;
var services22;
var storage22;
var team22;
var ui22;
var init_config = __esm2(() => {
  init_defaults();
  init_overrides();
  init_helpers2();
  config32 = {
    ...defaults_default2,
    ...overrides_default2
  };
  ai22 = config32.ai;
  analytics22 = config32.analytics;
  app22 = config32.app;
  cache22 = config32.cache;
  cloud22 = config32.cloud;
  cli2 = config32.cli;
  database22 = config32.database;
  dns22 = config32.dns;
  docs22 = config32.docs;
  email22 = config32.email;
  errors22 = config32.errors;
  git22 = config32.git;
  hashing22 = config32.hashing;
  library22 = config32.library;
  logging22 = config32.logging;
  notification2 = config32.notification;
  payment2 = config32.payment;
  ports22 = config32.ports;
  queue22 = config32.queue;
  security22 = config32.security;
  saas22 = config32.saas;
  searchEngine2 = config32.searchEngine;
  services22 = config32.services;
  storage22 = config32.storage;
  team22 = config32.team;
  ui22 = config32.ui;
});
var init_src6 = __esm2(() => {
  init_config();
  init_config();
});

class ErrorHandler2 {
  static isTestEnvironment = false;
  static shouldExitProcess = true;
  static handle(err2, options22) {
    this.shouldExitProcess = options22?.shouldExit !== false;
    if (options22?.silent !== true)
      this.writeErrorToConsole(err2);
    let errorMessage;
    if (options22?.message) {
      errorMessage = options22.message;
    } else if (err2 instanceof Error) {
      errorMessage = err2.message;
    } else if (typeof err2 === "string") {
      errorMessage = err2;
    } else {
      errorMessage = JSON.stringify(err2);
    }
    const error = new Error(errorMessage);
    if (err2 instanceof Error) {
      Object.assign(error, err2);
    }
    this.writeErrorToFile(error).catch((e) => console.error(e));
    return error;
  }
  static handleError(err2, options22) {
    this.handle(err2, options22);
    return err2;
  }
  static async writeErrorToFile(err2) {
    if (!(err2 instanceof Error)) {
      console.error("Error is not an instance of Error:", err2);
      return;
    }
    const formattedError = `[${new Date().toISOString()}] ${err2.name}: ${err2.message}\n`;
    const logFilePath = logsPath2("stacks.log") ?? logsPath2("errors.log");
    try {
      await mkdir2(dirname22(logFilePath), { recursive: true });
      await appendFile2(logFilePath, formattedError);
    } catch (error) {
      console.error("Failed to write to error file:", error);
    }
  }
  static writeErrorToConsole(err2) {
    console.error(err2);
    const errorString = typeof err2 === "string" ? err2 : err2 instanceof Error ? err2.message : JSON.stringify(err2);
    if (errorString.includes("bunx --bun cdk destroy") || errorString === `Failed to execute command: ${italic2("bunx --bun eslint . --fix")}` || errorString === `Failed to execute command: ${italic2("bun storage/framework/core/actions/src/lint/fix.ts")}`) {
      if (!this.isTestEnvironment) {
        console.log("No need to worry. The edge function is currently being destroyed. Please run `buddy undeploy` shortly again, and continue doing so until it succeeds running.");
        console.log("Hoping to see you back soon!");
      }
    }
    if (this.shouldExitProcess) {
      process3.exit(1);
    }
  }
}
function handleError2(err2, options22) {
  let errorMessage;
  if (isString2(err2)) {
    errorMessage = err2;
  } else if (err2 instanceof Error) {
    errorMessage = err2.message;
  } else if (options22 instanceof Error) {
    errorMessage = options22.message;
  } else {
    errorMessage = String(err2);
  }
  writeToLogFile2(`ERROR: ${stripAnsi4(errorMessage)}`);
  return ErrorHandler2.handle(err2, options22);
}
async function writeToLogFile2(message, options22) {
  const formattedMessage = `[${new Date().toISOString()}] ${message}\n`;
  try {
    const logFile = options22?.logFile ?? exports_config2.logging.logsPath ?? "storage/logs/stacks.log";
    try {
      await access2(logFile);
    } catch {
      await mkdir2(dirname3(logFile), { recursive: true });
    }
    await appendFile2(logFile, formattedMessage);
  } catch (error) {
    console.error("Failed to write to log file:", error);
  }
}
var init_handler = __esm2(() => {
  init_src10();
  init_src6();
  init_src11();
  init_src2();
  init_src3();
});
var HttpError;
var init_http = __esm2(() => {
  HttpError = class HttpError2 extends Error {
    status;
    constructor(status, message) {
      super(message);
      this.status = status;
      this.name = "Server Error!";
    }
  };
});
var init_utils22 = __esm2(() => {
  init_handler();
});
function __awaiter2(thisArg, _arguments, P2, generator) {
  function adopt(value) {
    return value instanceof P2 ? value : new P2(function(resolve4) {
      resolve4(value);
    });
  }
  return new (P2 || (P2 = Promise))(function(resolve4, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result2) {
      result2.done ? resolve4(result2.value) : adopt(result2.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __values2(o) {
  var s3 = typeof Symbol === "function" && Symbol.iterator, m2 = s3 && o[s3], i = 0;
  if (m2)
    return m2.call(o);
  if (o && typeof o.length === "number")
    return {
      next: function() {
        if (o && i >= o.length)
          o = undefined;
        return { value: o && o[i++], done: !o };
      }
    };
  throw new TypeError(s3 ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __await2(v2) {
  return this instanceof __await2 ? (this.v = v2, this) : new __await2(v2);
}
function __asyncGenerator2(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g2 = generator.apply(thisArg, _arguments || []), i, q = [];
  return i = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function() {
    return this;
  }, i;
  function awaitReturn(f3) {
    return function(v2) {
      return Promise.resolve(v2).then(f3, reject);
    };
  }
  function verb(n, f3) {
    if (g2[n]) {
      i[n] = function(v2) {
        return new Promise(function(a, b2) {
          q.push([n, v2, a, b2]) > 1 || resume(n, v2);
        });
      };
      if (f3)
        i[n] = f3(i[n]);
    }
  }
  function resume(n, v2) {
    try {
      step(g2[n](v2));
    } catch (e) {
      settle(q[0][3], e);
    }
  }
  function step(r2) {
    r2.value instanceof __await2 ? Promise.resolve(r2.value.v).then(fulfill, reject) : settle(q[0][2], r2);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f3, v2) {
    if (f3(v2), q.shift(), q.length)
      resume(q[0][0], q[0][1]);
  }
}
function __asyncDelegator2(o) {
  var i, p22;
  return i = {}, verb("next"), verb("throw", function(e) {
    throw e;
  }), verb("return"), i[Symbol.iterator] = function() {
    return this;
  }, i;
  function verb(n, f3) {
    i[n] = o[n] ? function(v2) {
      return (p22 = !p22) ? { value: __await2(o[n](v2)), done: false } : f3 ? f3(v2) : v2;
    } : f3;
  }
}
function __asyncValues2(o) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m2 = o[Symbol.asyncIterator], i;
  return m2 ? m2.call(o) : (o = typeof __values2 === "function" ? __values2(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
    return this;
  }, i);
  function verb(n) {
    i[n] = o[n] && function(v2) {
      return new Promise(function(resolve4, reject) {
        v2 = o[n](v2), settle(resolve4, reject, v2.done, v2.value);
      });
    };
  }
  function settle(resolve4, reject, d, v2) {
    Promise.resolve(v2).then(function(v22) {
      resolve4({ value: v22, done: d });
    }, reject);
  }
}
function err2(err22) {
  return new Err2(err22);
}
var defaultErrorConfig2;
var createNeverThrowError2 = (message, result2, config5 = defaultErrorConfig2) => {
  const data = result2.isOk() ? { type: "Ok", value: result2.value } : { type: "Err", value: result2.error };
  const maybeStack = config5.withStackTrace ? new Error().stack : undefined;
  return {
    data,
    message,
    stack: maybeStack
  };
};
var ResultAsync2;
var errAsync2 = (err3) => new ResultAsync2(Promise.resolve(new Err2(err3)));
var fromPromise2;
var fromSafePromise2;
var fromAsyncThrowable2;
var combineResultList2 = (resultList) => {
  let acc = ok2([]);
  for (const result2 of resultList) {
    if (result2.isErr()) {
      acc = err2(result2.error);
      break;
    } else {
      acc.map((list) => list.push(result2.value));
    }
  }
  return acc;
};
var combineResultAsyncList2 = (asyncResultList) => ResultAsync2.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultList2);
var combineResultListWithAllErrors2 = (resultList) => {
  let acc = ok2([]);
  for (const result2 of resultList) {
    if (result2.isErr() && acc.isErr()) {
      acc.error.push(result2.error);
    } else if (result2.isErr() && acc.isOk()) {
      acc = err2([result2.error]);
    } else if (result2.isOk() && acc.isOk()) {
      acc.value.push(result2.value);
    }
  }
  return acc;
};
var combineResultAsyncListWithAllErrors2 = (asyncResultList) => ResultAsync2.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultListWithAllErrors2);
var Result2;
var ok2 = (value) => new Ok2(value);
var Ok2;
var Err2;
var fromThrowable2;
var init_index_es = __esm2(() => {
  defaultErrorConfig2 = {
    withStackTrace: false
  };
  ResultAsync2 = class ResultAsync3 {
    constructor(res) {
      this._promise = res;
    }
    static fromSafePromise(promise2) {
      const newPromise = promise2.then((value) => new Ok2(value));
      return new ResultAsync3(newPromise);
    }
    static fromPromise(promise2, errorFn) {
      const newPromise = promise2.then((value) => new Ok2(value)).catch((e) => new Err2(errorFn(e)));
      return new ResultAsync3(newPromise);
    }
    static fromThrowable(fn, errorFn) {
      return (...args) => {
        return new ResultAsync3((() => __awaiter2(this, undefined, undefined, function* () {
          try {
            return new Ok2(yield fn(...args));
          } catch (error) {
            return new Err2(errorFn ? errorFn(error) : error);
          }
        }))());
      };
    }
    static combine(asyncResultList) {
      return combineResultAsyncList2(asyncResultList);
    }
    static combineWithAllErrors(asyncResultList) {
      return combineResultAsyncListWithAllErrors2(asyncResultList);
    }
    map(f3) {
      return new ResultAsync3(this._promise.then((res) => __awaiter2(this, undefined, undefined, function* () {
        if (res.isErr()) {
          return new Err2(res.error);
        }
        return new Ok2(yield f3(res.value));
      })));
    }
    andThrough(f3) {
      return new ResultAsync3(this._promise.then((res) => __awaiter2(this, undefined, undefined, function* () {
        if (res.isErr()) {
          return new Err2(res.error);
        }
        const newRes = yield f3(res.value);
        if (newRes.isErr()) {
          return new Err2(newRes.error);
        }
        return new Ok2(res.value);
      })));
    }
    andTee(f3) {
      return new ResultAsync3(this._promise.then((res) => __awaiter2(this, undefined, undefined, function* () {
        if (res.isErr()) {
          return new Err2(res.error);
        }
        try {
          yield f3(res.value);
        } catch (e) {
        }
        return new Ok2(res.value);
      })));
    }
    mapErr(f3) {
      return new ResultAsync3(this._promise.then((res) => __awaiter2(this, undefined, undefined, function* () {
        if (res.isOk()) {
          return new Ok2(res.value);
        }
        return new Err2(yield f3(res.error));
      })));
    }
    andThen(f3) {
      return new ResultAsync3(this._promise.then((res) => {
        if (res.isErr()) {
          return new Err2(res.error);
        }
        const newValue = f3(res.value);
        return newValue instanceof ResultAsync3 ? newValue._promise : newValue;
      }));
    }
    orElse(f3) {
      return new ResultAsync3(this._promise.then((res) => __awaiter2(this, undefined, undefined, function* () {
        if (res.isErr()) {
          return f3(res.error);
        }
        return new Ok2(res.value);
      })));
    }
    match(ok3, _err) {
      return this._promise.then((res) => res.match(ok3, _err));
    }
    unwrapOr(t) {
      return this._promise.then((res) => res.unwrapOr(t));
    }
    safeUnwrap() {
      return __asyncGenerator2(this, arguments, function* safeUnwrap_1() {
        return yield __await2(yield __await2(yield* __asyncDelegator2(__asyncValues2(yield __await2(this._promise.then((res) => res.safeUnwrap()))))));
      });
    }
    then(successCallback, failureCallback) {
      return this._promise.then(successCallback, failureCallback);
    }
    [Symbol.asyncIterator]() {
      return __asyncGenerator2(this, arguments, function* _a() {
        const result2 = yield __await2(this._promise);
        if (result2.isErr()) {
          yield yield __await2(errAsync2(result2.error));
        }
        return yield __await2(result2.value);
      });
    }
  };
  fromPromise2 = ResultAsync2.fromPromise;
  fromSafePromise2 = ResultAsync2.fromSafePromise;
  fromAsyncThrowable2 = ResultAsync2.fromThrowable;
  (function(Result22) {
    function fromThrowable3(fn, errorFn) {
      return (...args) => {
        try {
          const result2 = fn(...args);
          return ok2(result2);
        } catch (e) {
          return err2(errorFn ? errorFn(e) : e);
        }
      };
    }
    Result22.fromThrowable = fromThrowable3;
    function combine(resultList) {
      return combineResultList2(resultList);
    }
    Result22.combine = combine;
    function combineWithAllErrors(resultList) {
      return combineResultListWithAllErrors2(resultList);
    }
    Result22.combineWithAllErrors = combineWithAllErrors;
  })(Result2 || (Result2 = {}));
  Ok2 = class Ok3 {
    constructor(value) {
      this.value = value;
    }
    isOk() {
      return true;
    }
    isErr() {
      return !this.isOk();
    }
    map(f3) {
      return ok2(f3(this.value));
    }
    mapErr(_f) {
      return ok2(this.value);
    }
    andThen(f3) {
      return f3(this.value);
    }
    andThrough(f3) {
      return f3(this.value).map((_value) => this.value);
    }
    andTee(f3) {
      try {
        f3(this.value);
      } catch (e) {
      }
      return ok2(this.value);
    }
    orElse(_f) {
      return ok2(this.value);
    }
    asyncAndThen(f3) {
      return f3(this.value);
    }
    asyncAndThrough(f3) {
      return f3(this.value).map(() => this.value);
    }
    asyncMap(f3) {
      return ResultAsync2.fromSafePromise(f3(this.value));
    }
    unwrapOr(_v) {
      return this.value;
    }
    match(ok22, _err) {
      return ok22(this.value);
    }
    safeUnwrap() {
      const value = this.value;
      return function* () {
        return value;
      }();
    }
    _unsafeUnwrap(_2) {
      return this.value;
    }
    _unsafeUnwrapErr(config5) {
      throw createNeverThrowError2("Called `_unsafeUnwrapErr` on an Ok", this, config5);
    }
    *[Symbol.iterator]() {
      return this.value;
    }
  };
  Err2 = class Err3 {
    constructor(error) {
      this.error = error;
    }
    isOk() {
      return false;
    }
    isErr() {
      return !this.isOk();
    }
    map(_f) {
      return err2(this.error);
    }
    mapErr(f3) {
      return err2(f3(this.error));
    }
    andThrough(_f) {
      return err2(this.error);
    }
    andTee(_f) {
      return err2(this.error);
    }
    andThen(_f) {
      return err2(this.error);
    }
    orElse(f3) {
      return f3(this.error);
    }
    asyncAndThen(_f) {
      return errAsync2(this.error);
    }
    asyncAndThrough(_f) {
      return errAsync2(this.error);
    }
    asyncMap(_f) {
      return errAsync2(this.error);
    }
    unwrapOr(v2) {
      return v2;
    }
    match(_ok, err22) {
      return err22(this.error);
    }
    safeUnwrap() {
      const error = this.error;
      return function* () {
        yield err2(error);
        throw new Error("Do not use this generator out of `safeTry`");
      }();
    }
    _unsafeUnwrap(config5) {
      throw createNeverThrowError2("Called `_unsafeUnwrap` on an Err", this, config5);
    }
    _unsafeUnwrapErr(_2) {
      return this.error;
    }
    *[Symbol.iterator]() {
      const self2 = this;
      yield self2;
      return self2;
    }
  };
  fromThrowable2 = Result2.fromThrowable;
});
var init_src7 = __esm2(() => {
  init_handler();
  init_http();
  init_utils22();
  init_index_es();
});
function isObject3(value) {
  return value !== null && typeof value === "object";
}
function _defu2(baseObject, defaults, namespace = ".", merger) {
  if (!isObject3(defaults)) {
    return _defu2(baseObject, {}, namespace, merger);
  }
  const object = Object.assign({}, defaults);
  for (const key in baseObject) {
    if (key === "__proto__" || key === "constructor") {
      continue;
    }
    const value = baseObject[key];
    if (value === null || value === undefined) {
      continue;
    }
    if (merger && merger(object, key, value, namespace)) {
      continue;
    }
    if (Array.isArray(value) && Array.isArray(object[key])) {
      object[key] = [...value, ...object[key]];
    } else if (isObject3(value) && isObject3(object[key])) {
      object[key] = _defu2(value, object[key], (namespace ? `${namespace}.` : "") + key.toString(), merger);
    } else {
      object[key] = value;
    }
  }
  return object;
}
function createDefu2(merger) {
  return (...arguments_) => arguments_.reduce((p22, c2) => _defu2(p22, c2, "", merger), {});
}
function isPlainObject2(obj) {
  return Object.prototype.toString.call(obj) === "[object Object]";
}
function isLogObj2(arg) {
  if (!isPlainObject2(arg)) {
    return false;
  }
  if (!arg.message && !arg.args) {
    return false;
  }
  if (arg.stack) {
    return false;
  }
  return true;
}

class Consola2 {
  constructor(options22 = {}) {
    const types3 = options22.types || LogTypes2;
    this.options = defu2({
      ...options22,
      defaults: { ...options22.defaults },
      level: _normalizeLogLevel2(options22.level, types3),
      reporters: [...options22.reporters || []]
    }, {
      types: LogTypes2,
      throttle: 1000,
      throttleMin: 5,
      formatOptions: {
        date: true,
        colors: false,
        compact: true
      }
    });
    for (const type in types3) {
      const defaults = {
        type,
        ...this.options.defaults,
        ...types3[type]
      };
      this[type] = this._wrapLogFn(defaults);
      this[type].raw = this._wrapLogFn(defaults, true);
    }
    if (this.options.mockFn) {
      this.mockTypes();
    }
    this._lastLog = {};
  }
  get level() {
    return this.options.level;
  }
  set level(level) {
    this.options.level = _normalizeLogLevel2(level, this.options.types, this.options.level);
  }
  prompt(message, opts) {
    if (!this.options.prompt) {
      throw new Error("prompt is not supported!");
    }
    return this.options.prompt(message, opts);
  }
  create(options22) {
    const instance = new Consola2({
      ...this.options,
      ...options22
    });
    if (this._mockFn) {
      instance.mockTypes(this._mockFn);
    }
    return instance;
  }
  withDefaults(defaults) {
    return this.create({
      ...this.options,
      defaults: {
        ...this.options.defaults,
        ...defaults
      }
    });
  }
  withTag(tag) {
    return this.withDefaults({
      tag: this.options.defaults.tag ? this.options.defaults.tag + ":" + tag : tag
    });
  }
  addReporter(reporter2) {
    this.options.reporters.push(reporter2);
    return this;
  }
  removeReporter(reporter2) {
    if (reporter2) {
      const i = this.options.reporters.indexOf(reporter2);
      if (i >= 0) {
        return this.options.reporters.splice(i, 1);
      }
    } else {
      this.options.reporters.splice(0);
    }
    return this;
  }
  setReporters(reporters) {
    this.options.reporters = Array.isArray(reporters) ? reporters : [reporters];
    return this;
  }
  wrapAll() {
    this.wrapConsole();
    this.wrapStd();
  }
  restoreAll() {
    this.restoreConsole();
    this.restoreStd();
  }
  wrapConsole() {
    for (const type in this.options.types) {
      if (!console["__" + type]) {
        console["__" + type] = console[type];
      }
      console[type] = this[type].raw;
    }
  }
  restoreConsole() {
    for (const type in this.options.types) {
      if (console["__" + type]) {
        console[type] = console["__" + type];
        delete console["__" + type];
      }
    }
  }
  wrapStd() {
    this._wrapStream(this.options.stdout, "log");
    this._wrapStream(this.options.stderr, "log");
  }
  _wrapStream(stream2, type) {
    if (!stream2) {
      return;
    }
    if (!stream2.__write) {
      stream2.__write = stream2.write;
    }
    stream2.write = (data) => {
      this[type].raw(String(data).trim());
    };
  }
  restoreStd() {
    this._restoreStream(this.options.stdout);
    this._restoreStream(this.options.stderr);
  }
  _restoreStream(stream2) {
    if (!stream2) {
      return;
    }
    if (stream2.__write) {
      stream2.write = stream2.__write;
      delete stream2.__write;
    }
  }
  pauseLogs() {
    paused2 = true;
  }
  resumeLogs() {
    paused2 = false;
    const _queue = queue32.splice(0);
    for (const item of _queue) {
      item[0]._logFn(item[1], item[2]);
    }
  }
  mockTypes(mockFn) {
    const _mockFn = mockFn || this.options.mockFn;
    this._mockFn = _mockFn;
    if (typeof _mockFn !== "function") {
      return;
    }
    for (const type in this.options.types) {
      this[type] = _mockFn(type, this.options.types[type]) || this[type];
      this[type].raw = this[type];
    }
  }
  _wrapLogFn(defaults, isRaw) {
    return (...args) => {
      if (paused2) {
        queue32.push([this, defaults, args, isRaw]);
        return;
      }
      return this._logFn(defaults, args, isRaw);
    };
  }
  _logFn(defaults, args, isRaw) {
    if ((defaults.level || 0) > this.level) {
      return false;
    }
    const logObj = {
      date: /* @__PURE__ */ new Date,
      args: [],
      ...defaults,
      level: _normalizeLogLevel2(defaults.level, this.options.types)
    };
    if (!isRaw && args.length === 1 && isLogObj2(args[0])) {
      Object.assign(logObj, args[0]);
    } else {
      logObj.args = [...args];
    }
    if (logObj.message) {
      logObj.args.unshift(logObj.message);
      delete logObj.message;
    }
    if (logObj.additional) {
      if (!Array.isArray(logObj.additional)) {
        logObj.additional = logObj.additional.split("\n");
      }
      logObj.args.push("\n" + logObj.additional.join("\n"));
      delete logObj.additional;
    }
    logObj.type = typeof logObj.type === "string" ? logObj.type.toLowerCase() : "log";
    logObj.tag = typeof logObj.tag === "string" ? logObj.tag : "";
    const resolveLog = (newLog = false) => {
      const repeated = (this._lastLog.count || 0) - this.options.throttleMin;
      if (this._lastLog.object && repeated > 0) {
        const args2 = [...this._lastLog.object.args];
        if (repeated > 1) {
          args2.push(`(repeated ${repeated} times)`);
        }
        this._log({ ...this._lastLog.object, args: args2 });
        this._lastLog.count = 1;
      }
      if (newLog) {
        this._lastLog.object = logObj;
        this._log(logObj);
      }
    };
    clearTimeout(this._lastLog.timeout);
    const diffTime = this._lastLog.time && logObj.date ? logObj.date.getTime() - this._lastLog.time.getTime() : 0;
    this._lastLog.time = logObj.date;
    if (diffTime < this.options.throttle) {
      try {
        const serializedLog = JSON.stringify([
          logObj.type,
          logObj.tag,
          logObj.args
        ]);
        const isSameLog = this._lastLog.serialized === serializedLog;
        this._lastLog.serialized = serializedLog;
        if (isSameLog) {
          this._lastLog.count = (this._lastLog.count || 0) + 1;
          if (this._lastLog.count > this.options.throttleMin) {
            this._lastLog.timeout = setTimeout(resolveLog, this.options.throttle);
            return;
          }
        }
      } catch {
      }
    }
    resolveLog(true);
  }
  _log(logObj) {
    for (const reporter2 of this.options.reporters) {
      reporter2.log(logObj, {
        options: this.options
      });
    }
  }
}
function _normalizeLogLevel2(input, types3 = {}, defaultLevel = 3) {
  if (input === undefined) {
    return defaultLevel;
  }
  if (typeof input === "number") {
    return input;
  }
  if (types3[input] && types3[input].level !== undefined) {
    return types3[input].level;
  }
  return defaultLevel;
}
function createConsola3(options22 = {}) {
  return new Consola2(options22);
}
var LogLevels2;
var LogTypes2;
var defu2;
var paused2 = false;
var queue32;
var init_core2 = __esm2(() => {
  LogLevels2 = {
    silent: Number.NEGATIVE_INFINITY,
    fatal: 0,
    error: 0,
    warn: 1,
    log: 2,
    info: 3,
    success: 3,
    fail: 3,
    ready: 3,
    start: 3,
    box: 3,
    debug: 4,
    trace: 5,
    verbose: Number.POSITIVE_INFINITY
  };
  LogTypes2 = {
    silent: {
      level: -1
    },
    fatal: {
      level: LogLevels2.fatal
    },
    error: {
      level: LogLevels2.error
    },
    warn: {
      level: LogLevels2.warn
    },
    log: {
      level: LogLevels2.log
    },
    info: {
      level: LogLevels2.info
    },
    success: {
      level: LogLevels2.success
    },
    fail: {
      level: LogLevels2.fail
    },
    ready: {
      level: LogLevels2.info
    },
    start: {
      level: LogLevels2.info
    },
    box: {
      level: LogLevels2.info
    },
    debug: {
      level: LogLevels2.debug
    },
    trace: {
      level: LogLevels2.trace
    },
    verbose: {
      level: LogLevels2.verbose
    }
  };
  defu2 = createDefu2();
  queue32 = [];
  Consola2.prototype.add = Consola2.prototype.addReporter;
  Consola2.prototype.remove = Consola2.prototype.removeReporter;
  Consola2.prototype.clear = Consola2.prototype.removeReporter;
  Consola2.prototype.withScope = Consola2.prototype.withTag;
  Consola2.prototype.mock = Consola2.prototype.mockTypes;
  Consola2.prototype.pause = Consola2.prototype.pauseLogs;
  Consola2.prototype.resume = Consola2.prototype.resumeLogs;
});
function parseStack2(stack) {
  const cwd = process.cwd() + sep3;
  const lines = stack.split("\n").splice(1).map((l3) => l3.trim().replace("file://", "").replace(cwd, ""));
  return lines;
}
function writeStream2(data, stream2) {
  const write = stream2.__write || stream2.write;
  return write.call(stream2, data);
}

class BasicReporter2 {
  formatStack(stack, opts) {
    return "  " + parseStack2(stack).join("\n  ");
  }
  formatArgs(args, opts) {
    const _args = args.map((arg) => {
      if (arg && typeof arg.stack === "string") {
        return arg.message + "\n" + this.formatStack(arg.stack, opts);
      }
      return arg;
    });
    return formatWithOptions2(opts, ..._args);
  }
  formatDate(date, opts) {
    return opts.date ? date.toLocaleTimeString() : "";
  }
  filterAndJoin(arr) {
    return arr.filter(Boolean).join(" ");
  }
  formatLogObj(logObj, opts) {
    const message = this.formatArgs(logObj.args, opts);
    if (logObj.type === "box") {
      return "\n" + [
        bracket2(logObj.tag),
        logObj.title && logObj.title,
        ...message.split("\n")
      ].filter(Boolean).map((l3) => " > " + l3).join("\n") + "\n";
    }
    return this.filterAndJoin([
      bracket2(logObj.type),
      bracket2(logObj.tag),
      message
    ]);
  }
  log(logObj, ctx) {
    const line = this.formatLogObj(logObj, {
      columns: ctx.options.stdout.columns || 0,
      ...ctx.options.formatOptions
    });
    return writeStream2(line + "\n", logObj.level < 2 ? ctx.options.stderr || process.stderr : ctx.options.stdout || process.stdout);
  }
}
var bracket2 = (x) => x ? `[${x}]` : "";
var init_consola_06ad8a642 = () => {
};
function replaceClose3(index, string2, close, replace22, head2 = string2.slice(0, Math.max(0, index)) + replace22, tail = string2.slice(Math.max(0, index + close.length)), next = tail.indexOf(close)) {
  return head2 + (next < 0 ? tail : replaceClose3(next, tail, close, replace22));
}
function clearBleed2(index, string2, open, close, replace22) {
  return index < 0 ? open + string2 + close : open + replaceClose3(index, string2, close, replace22) + close;
}
function filterEmpty2(open, close, replace22 = open, at = open.length + 1) {
  return (string2) => string2 || !(string2 === "" || string2 === undefined) ? clearBleed2(("" + string2).indexOf(close, at), string2, open, close, replace22) : "";
}
function init2(open, close, replace22) {
  return filterEmpty2(`\x1B[${open}m`, `\x1B[${close}m`, replace22);
}
function createColors3(useColor = isColorSupported3) {
  return useColor ? colorDefs2 : Object.fromEntries(Object.keys(colorDefs2).map((key) => [key, String]));
}
function getColor3(color, fallback22 = "reset") {
  return colors2[color] || colors2[fallback22];
}
function stripAnsi4(text2) {
  return text2.replace(new RegExp(ansiRegex4, "g"), "");
}
function box2(text2, _opts = {}) {
  const opts = {
    ..._opts,
    style: {
      ...defaultStyle2,
      ..._opts.style
    }
  };
  const textLines = text2.split("\n");
  const boxLines = [];
  const _color = getColor3(opts.style.borderColor);
  const borderStyle = {
    ...typeof opts.style.borderStyle === "string" ? boxStylePresets2[opts.style.borderStyle] || boxStylePresets2.solid : opts.style.borderStyle
  };
  if (_color) {
    for (const key in borderStyle) {
      borderStyle[key] = _color(borderStyle[key]);
    }
  }
  const paddingOffset = opts.style.padding % 2 === 0 ? opts.style.padding : opts.style.padding + 1;
  const height = textLines.length + paddingOffset;
  const width = Math.max(...textLines.map((line) => line.length)) + paddingOffset;
  const widthOffset = width + paddingOffset;
  const leftSpace = opts.style.marginLeft > 0 ? " ".repeat(opts.style.marginLeft) : "";
  if (opts.style.marginTop > 0) {
    boxLines.push("".repeat(opts.style.marginTop));
  }
  if (opts.title) {
    const left = borderStyle.h.repeat(Math.floor((width - stripAnsi4(opts.title).length) / 2));
    const right = borderStyle.h.repeat(width - stripAnsi4(opts.title).length - stripAnsi4(left).length + paddingOffset);
    boxLines.push(`${leftSpace}${borderStyle.tl}${left}${opts.title}${right}${borderStyle.tr}`);
  } else {
    boxLines.push(`${leftSpace}${borderStyle.tl}${borderStyle.h.repeat(widthOffset)}${borderStyle.tr}`);
  }
  const valignOffset = opts.style.valign === "center" ? Math.floor((height - textLines.length) / 2) : opts.style.valign === "top" ? height - textLines.length - paddingOffset : height - textLines.length;
  for (let i = 0;i < height; i++) {
    if (i < valignOffset || i >= valignOffset + textLines.length) {
      boxLines.push(`${leftSpace}${borderStyle.v}${" ".repeat(widthOffset)}${borderStyle.v}`);
    } else {
      const line = textLines[i - valignOffset];
      const left = " ".repeat(paddingOffset);
      const right = " ".repeat(width - stripAnsi4(line).length);
      boxLines.push(`${leftSpace}${borderStyle.v}${left}${line}${right}${borderStyle.v}`);
    }
  }
  boxLines.push(`${leftSpace}${borderStyle.bl}${borderStyle.h.repeat(widthOffset)}${borderStyle.br}`);
  if (opts.style.marginBottom > 0) {
    boxLines.push("".repeat(opts.style.marginBottom));
  }
  return boxLines.join("\n");
}
var env32;
var argv2;
var platform2;
var isDisabled2;
var isForced2;
var isWindows2;
var isDumbTerminal2;
var isCompatibleTerminal2;
var isCI3;
var isColorSupported3;
var colorDefs2;
var colors2;
var ansiRegex4;
var boxStylePresets2;
var defaultStyle2;
var init_utils3 = __esm2(() => {
  ({
    env: env32 = {},
    argv: argv2 = [],
    platform: platform2 = ""
  } = typeof process === "undefined" ? {} : process);
  isDisabled2 = "NO_COLOR" in env32 || argv2.includes("--no-color");
  isForced2 = "FORCE_COLOR" in env32 || argv2.includes("--color");
  isWindows2 = platform2 === "win32";
  isDumbTerminal2 = env32.TERM === "dumb";
  isCompatibleTerminal2 = tty4 && tty4.isatty && tty4.isatty(1) && env32.TERM && !isDumbTerminal2;
  isCI3 = "CI" in env32 && (("GITHUB_ACTIONS" in env32) || ("GITLAB_CI" in env32) || ("CIRCLECI" in env32));
  isColorSupported3 = !isDisabled2 && (isForced2 || isWindows2 && !isDumbTerminal2 || isCompatibleTerminal2 || isCI3);
  colorDefs2 = {
    reset: init2(0, 0),
    bold: init2(1, 22, "\x1B[22m\x1B[1m"),
    dim: init2(2, 22, "\x1B[22m\x1B[2m"),
    italic: init2(3, 23),
    underline: init2(4, 24),
    inverse: init2(7, 27),
    hidden: init2(8, 28),
    strikethrough: init2(9, 29),
    black: init2(30, 39),
    red: init2(31, 39),
    green: init2(32, 39),
    yellow: init2(33, 39),
    blue: init2(34, 39),
    magenta: init2(35, 39),
    cyan: init2(36, 39),
    white: init2(37, 39),
    gray: init2(90, 39),
    bgBlack: init2(40, 49),
    bgRed: init2(41, 49),
    bgGreen: init2(42, 49),
    bgYellow: init2(43, 49),
    bgBlue: init2(44, 49),
    bgMagenta: init2(45, 49),
    bgCyan: init2(46, 49),
    bgWhite: init2(47, 49),
    blackBright: init2(90, 39),
    redBright: init2(91, 39),
    greenBright: init2(92, 39),
    yellowBright: init2(93, 39),
    blueBright: init2(94, 39),
    magentaBright: init2(95, 39),
    cyanBright: init2(96, 39),
    whiteBright: init2(97, 39),
    bgBlackBright: init2(100, 49),
    bgRedBright: init2(101, 49),
    bgGreenBright: init2(102, 49),
    bgYellowBright: init2(103, 49),
    bgBlueBright: init2(104, 49),
    bgMagentaBright: init2(105, 49),
    bgCyanBright: init2(106, 49),
    bgWhiteBright: init2(107, 49)
  };
  colors2 = createColors3();
  ansiRegex4 = [
    "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))"
  ].join("|");
  boxStylePresets2 = {
    solid: {
      tl: "\u250C",
      tr: "\u2510",
      bl: "\u2514",
      br: "\u2518",
      h: "\u2500",
      v: "\u2502"
    },
    double: {
      tl: "\u2554",
      tr: "\u2557",
      bl: "\u255A",
      br: "\u255D",
      h: "\u2550",
      v: "\u2551"
    },
    doubleSingle: {
      tl: "\u2553",
      tr: "\u2556",
      bl: "\u2559",
      br: "\u255C",
      h: "\u2500",
      v: "\u2551"
    },
    doubleSingleRounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2500",
      v: "\u2551"
    },
    singleThick: {
      tl: "\u250F",
      tr: "\u2513",
      bl: "\u2517",
      br: "\u251B",
      h: "\u2501",
      v: "\u2503"
    },
    singleDouble: {
      tl: "\u2552",
      tr: "\u2555",
      bl: "\u2558",
      br: "\u255B",
      h: "\u2550",
      v: "\u2502"
    },
    singleDoubleRounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2550",
      v: "\u2502"
    },
    rounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2500",
      v: "\u2502"
    }
  };
  defaultStyle2 = {
    borderColor: "white",
    borderStyle: "rounded",
    valign: "center",
    padding: 2,
    marginLeft: 1,
    marginTop: 1,
    marginBottom: 1
  };
});
var exports_prompt2 = {};
__export3(exports_prompt2, {
  prompt: () => prompt2
});
function z2({ onlyFirst: t = false } = {}) {
  const u = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
  return new RegExp(u, t ? undefined : "g");
}
function $3(t) {
  if (typeof t != "string")
    throw new TypeError(`Expected a \`string\`, got \`${typeof t}\``);
  return t.replace(z2(), "");
}
function c2(t, u = {}) {
  if (typeof t != "string" || t.length === 0 || (u = { ambiguousIsNarrow: true, ...u }, t = $3(t), t.length === 0))
    return 0;
  t = t.replace(Y2(), "  ");
  const F = u.ambiguousIsNarrow ? 1 : 2;
  let e = 0;
  for (const s3 of t) {
    const C = s3.codePointAt(0);
    if (C <= 31 || C >= 127 && C <= 159 || C >= 768 && C <= 879)
      continue;
    switch (K2.eastAsianWidth(s3)) {
      case "F":
      case "W":
        e += 2;
        break;
      case "A":
        e += F;
        break;
      default:
        e += 1;
    }
  }
  return e;
}
function U3() {
  const t = new Map;
  for (const [u, F] of Object.entries(r2)) {
    for (const [e, s3] of Object.entries(F))
      r2[e] = { open: `\x1B[${s3[0]}m`, close: `\x1B[${s3[1]}m` }, F[e] = r2[e], t.set(s3[0], s3[1]);
    Object.defineProperty(r2, u, { value: F, enumerable: false });
  }
  return Object.defineProperty(r2, "codes", { value: t, enumerable: false }), r2.color.close = "\x1B[39m", r2.bgColor.close = "\x1B[49m", r2.color.ansi = L(), r2.color.ansi256 = M2(), r2.color.ansi16m = T2(), r2.bgColor.ansi = L(v2), r2.bgColor.ansi256 = M2(v2), r2.bgColor.ansi16m = T2(v2), Object.defineProperties(r2, { rgbToAnsi256: { value: (u, F, e) => u === F && F === e ? u < 8 ? 16 : u > 248 ? 231 : Math.round((u - 8) / 247 * 24) + 232 : 16 + 36 * Math.round(u / 255 * 5) + 6 * Math.round(F / 255 * 5) + Math.round(e / 255 * 5), enumerable: false }, hexToRgb: { value: (u) => {
    const F = /[a-f\d]{6}|[a-f\d]{3}/i.exec(u.toString(16));
    if (!F)
      return [0, 0, 0];
    let [e] = F;
    e.length === 3 && (e = [...e].map((C) => C + C).join(""));
    const s3 = Number.parseInt(e, 16);
    return [s3 >> 16 & 255, s3 >> 8 & 255, s3 & 255];
  }, enumerable: false }, hexToAnsi256: { value: (u) => r2.rgbToAnsi256(...r2.hexToRgb(u)), enumerable: false }, ansi256ToAnsi: { value: (u) => {
    if (u < 8)
      return 30 + u;
    if (u < 16)
      return 90 + (u - 8);
    let F, e, s3;
    if (u >= 232)
      F = ((u - 232) * 10 + 8) / 255, e = F, s3 = F;
    else {
      u -= 16;
      const i = u % 36;
      F = Math.floor(u / 36) / 5, e = Math.floor(i / 6) / 5, s3 = i % 6 / 5;
    }
    const C = Math.max(F, e, s3) * 2;
    if (C === 0)
      return 30;
    let D = 30 + (Math.round(s3) << 2 | Math.round(e) << 1 | Math.round(F));
    return C === 2 && (D += 60), D;
  }, enumerable: false }, rgbToAnsi: { value: (u, F, e) => r2.ansi256ToAnsi(r2.rgbToAnsi256(u, F, e)), enumerable: false }, hexToAnsi: { value: (u) => r2.ansi256ToAnsi(r2.hexToAnsi256(u)), enumerable: false } }), r2;
}
function P2(t, u, F) {
  return String(t).normalize().replace(/\r\n/g, `
`).split(`
`).map((e) => uD2(e, u, F)).join(`
`);
}
function FD2(t, u) {
  if (t === u)
    return;
  const F = t.split(`
`), e = u.split(`
`), s3 = [];
  for (let C = 0;C < Math.max(F.length, e.length); C++)
    F[C] !== e[C] && s3.push(C);
  return s3;
}
function g2(t, u) {
  t.isTTY && t.setRawMode(u);
}

class h3 {
  constructor({ render: u, input: F = stdin2, output: e = stdout2, ...s3 }, C = true) {
    this._track = false, this._cursor = 0, this.state = "initial", this.error = "", this.subscribers = new Map, this._prevFrame = "", this.opts = s3, this.onKeypress = this.onKeypress.bind(this), this.close = this.close.bind(this), this.render = this.render.bind(this), this._render = u.bind(this), this._track = C, this.input = F, this.output = e;
  }
  prompt() {
    const u = new WriteStream2(0);
    return u._write = (F, e, s3) => {
      this._track && (this.value = this.rl.line.replace(/\t/g, ""), this._cursor = this.rl.cursor, this.emit("value", this.value)), s3();
    }, this.input.pipe(u), this.rl = f2.createInterface({ input: this.input, output: u, tabSize: 2, prompt: "", escapeCodeTimeout: 50 }), f2.emitKeypressEvents(this.input, this.rl), this.rl.prompt(), this.opts.initialValue !== undefined && this._track && this.rl.write(this.opts.initialValue), this.input.on("keypress", this.onKeypress), g2(this.input, true), this.output.on("resize", this.render), this.render(), new Promise((F, e) => {
      this.once("submit", () => {
        this.output.write(src2.cursor.show), this.output.off("resize", this.render), g2(this.input, false), F(this.value);
      }), this.once("cancel", () => {
        this.output.write(src2.cursor.show), this.output.off("resize", this.render), g2(this.input, false), F(R);
      });
    });
  }
  on(u, F) {
    const e = this.subscribers.get(u) ?? [];
    e.push({ cb: F }), this.subscribers.set(u, e);
  }
  once(u, F) {
    const e = this.subscribers.get(u) ?? [];
    e.push({ cb: F, once: true }), this.subscribers.set(u, e);
  }
  emit(u, ...F) {
    const e = this.subscribers.get(u) ?? [], s3 = [];
    for (const C of e)
      C.cb(...F), C.once && s3.push(() => e.splice(e.indexOf(C), 1));
    for (const C of s3)
      C();
  }
  unsubscribe() {
    this.subscribers.clear();
  }
  onKeypress(u, F) {
    if (this.state === "error" && (this.state = "active"), F?.name && !this._track && V2.has(F.name) && this.emit("cursor", V2.get(F.name)), F?.name && tD2.has(F.name) && this.emit("cursor", F.name), u && (u.toLowerCase() === "y" || u.toLowerCase() === "n") && this.emit("confirm", u.toLowerCase() === "y"), u && this.emit("key", u.toLowerCase()), F?.name === "return") {
      if (this.opts.validate) {
        const e = this.opts.validate(this.value);
        e && (this.error = e, this.state = "error", this.rl.write(this.value));
      }
      this.state !== "error" && (this.state = "submit");
    }
    u === "" && (this.state = "cancel"), (this.state === "submit" || this.state === "cancel") && this.emit("finalize"), this.render(), (this.state === "submit" || this.state === "cancel") && this.close();
  }
  close() {
    this.input.unpipe(), this.input.removeListener("keypress", this.onKeypress), this.output.write(`
`), g2(this.input, false), this.rl.close(), this.emit(`${this.state}`, this.value), this.unsubscribe();
  }
  restoreCursor() {
    const u = P2(this._prevFrame, process.stdout.columns, { hard: true }).split(`
`).length - 1;
    this.output.write(src2.cursor.move(-999, u * -1));
  }
  render() {
    const u = P2(this._render(this) ?? "", process.stdout.columns, { hard: true });
    if (u !== this._prevFrame) {
      if (this.state === "initial")
        this.output.write(src2.cursor.hide);
      else {
        const F = FD2(this._prevFrame, u);
        if (this.restoreCursor(), F && F?.length === 1) {
          const e = F[0];
          this.output.write(src2.cursor.move(0, e)), this.output.write(src2.erase.lines(1));
          const s3 = u.split(`
`);
          this.output.write(s3[e]), this._prevFrame = u, this.output.write(src2.cursor.move(0, s3.length - e - 1));
          return;
        } else if (F && F?.length > 1) {
          const e = F[0];
          this.output.write(src2.cursor.move(0, e)), this.output.write(src2.erase.down());
          const C = u.split(`
`).slice(e);
          this.output.write(C.join(`
`)), this._prevFrame = u;
          return;
        }
        this.output.write(src2.erase.down());
      }
      this.output.write(u), this.state === "initial" && (this.state = "active"), this._prevFrame = u;
    }
  }
}
async function prompt2(message, opts = {}) {
  if (!opts.type || opts.type === "text") {
    return await text2({
      message,
      defaultValue: opts.default,
      placeholder: opts.placeholder,
      initialValue: opts.initial
    });
  }
  if (opts.type === "confirm") {
    return await confirm2({
      message,
      initialValue: opts.initial
    });
  }
  if (opts.type === "select") {
    return await select2({
      message,
      options: opts.options.map((o) => typeof o === "string" ? { value: o, label: o } : o)
    });
  }
  if (opts.type === "multiselect") {
    return await multiselect2({
      message,
      options: opts.options.map((o) => typeof o === "string" ? { value: o, label: o } : o),
      required: opts.required
    });
  }
  throw new Error(`Unknown prompt type: ${opts.type}`);
}
var ESC2 = "\x1B";
var CSI2;
var beep2 = "\x07";
var cursor2;
var scroll2;
var erase2;
var src2;
var picocolors2;
var tty22;
var isColorSupported22;
var formatter2 = (open, close, replace22 = open) => (input) => {
  let string2 = "" + input;
  let index = string2.indexOf(close, open.length);
  return ~index ? open + replaceClose22(string2, close, replace22, index) + close : open + string2 + close;
};
var replaceClose22 = (string2, close, replace22, index) => {
  let start = string2.substring(0, index) + replace22;
  let end = string2.substring(index + close.length);
  let nextIndex = end.indexOf(close);
  return ~nextIndex ? start + replaceClose22(end, close, replace22, nextIndex) : start + end;
};
var createColors22 = (enabled2 = isColorSupported22) => ({
  isColorSupported: enabled2,
  reset: enabled2 ? (s3) => `\x1B[0m${s3}\x1B[0m` : String,
  bold: enabled2 ? formatter2("\x1B[1m", "\x1B[22m", "\x1B[22m\x1B[1m") : String,
  dim: enabled2 ? formatter2("\x1B[2m", "\x1B[22m", "\x1B[22m\x1B[2m") : String,
  italic: enabled2 ? formatter2("\x1B[3m", "\x1B[23m") : String,
  underline: enabled2 ? formatter2("\x1B[4m", "\x1B[24m") : String,
  inverse: enabled2 ? formatter2("\x1B[7m", "\x1B[27m") : String,
  hidden: enabled2 ? formatter2("\x1B[8m", "\x1B[28m") : String,
  strikethrough: enabled2 ? formatter2("\x1B[9m", "\x1B[29m") : String,
  black: enabled2 ? formatter2("\x1B[30m", "\x1B[39m") : String,
  red: enabled2 ? formatter2("\x1B[31m", "\x1B[39m") : String,
  green: enabled2 ? formatter2("\x1B[32m", "\x1B[39m") : String,
  yellow: enabled2 ? formatter2("\x1B[33m", "\x1B[39m") : String,
  blue: enabled2 ? formatter2("\x1B[34m", "\x1B[39m") : String,
  magenta: enabled2 ? formatter2("\x1B[35m", "\x1B[39m") : String,
  cyan: enabled2 ? formatter2("\x1B[36m", "\x1B[39m") : String,
  white: enabled2 ? formatter2("\x1B[37m", "\x1B[39m") : String,
  gray: enabled2 ? formatter2("\x1B[90m", "\x1B[39m") : String,
  bgBlack: enabled2 ? formatter2("\x1B[40m", "\x1B[49m") : String,
  bgRed: enabled2 ? formatter2("\x1B[41m", "\x1B[49m") : String,
  bgGreen: enabled2 ? formatter2("\x1B[42m", "\x1B[49m") : String,
  bgYellow: enabled2 ? formatter2("\x1B[43m", "\x1B[49m") : String,
  bgBlue: enabled2 ? formatter2("\x1B[44m", "\x1B[49m") : String,
  bgMagenta: enabled2 ? formatter2("\x1B[45m", "\x1B[49m") : String,
  bgCyan: enabled2 ? formatter2("\x1B[46m", "\x1B[49m") : String,
  bgWhite: enabled2 ? formatter2("\x1B[47m", "\x1B[49m") : String
});
var picocolorsExports2;
var l3;
var m2;
var G2;
var K2;
var Y2 = function() {
  return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
};
var v2 = 10;
var L = (t = 0) => (u) => `\x1B[${u + t}m`;
var M2 = (t = 0) => (u) => `\x1B[${38 + t};5;${u}m`;
var T2 = (t = 0) => (u, F, e) => `\x1B[${38 + t};2;${u};${F};${e}m`;
var r2;
var Z2;
var H2;
var q;
var p22;
var J2 = 39;
var b2 = "\x07";
var W3 = "[";
var Q2 = "]";
var I = "m";
var w2;
var N = (t) => `${p22.values().next().value}${W3}${t}${I}`;
var j2 = (t) => `${p22.values().next().value}${w2}${t}${b2}`;
var X3 = (t) => t.split(" ").map((u) => c2(u));
var _2 = (t, u, F) => {
  const e = [...u];
  let s3 = false, C = false, D = c2($3(t[t.length - 1]));
  for (const [i, o] of e.entries()) {
    const E = c2(o);
    if (D + E <= F ? t[t.length - 1] += o : (t.push(o), D = 0), p22.has(o) && (s3 = true, C = e.slice(i + 1).join("").startsWith(w2)), s3) {
      C ? o === b2 && (s3 = false, C = false) : o === I && (s3 = false);
      continue;
    }
    D += E, D === F && i < e.length - 1 && (t.push(""), D = 0);
  }
  !D && t[t.length - 1].length > 0 && t.length > 1 && (t[t.length - 2] += t.pop());
};
var DD2 = (t) => {
  const u = t.split(" ");
  let F = u.length;
  for (;F > 0 && !(c2(u[F - 1]) > 0); )
    F--;
  return F === u.length ? t : u.slice(0, F).join(" ") + u.slice(F).join("");
};
var uD2 = (t, u, F = {}) => {
  if (F.trim !== false && t.trim() === "")
    return "";
  let e = "", s3, C;
  const D = X3(t);
  let i = [""];
  for (const [E, a] of t.split(" ").entries()) {
    F.trim !== false && (i[i.length - 1] = i[i.length - 1].trimStart());
    let n = c2(i[i.length - 1]);
    if (E !== 0 && (n >= u && (F.wordWrap === false || F.trim === false) && (i.push(""), n = 0), (n > 0 || F.trim === false) && (i[i.length - 1] += " ", n++)), F.hard && D[E] > u) {
      const B = u - n, A = 1 + Math.floor((D[E] - B - 1) / u);
      Math.floor((D[E] - 1) / u) < A && i.push(""), _2(i, a, u);
      continue;
    }
    if (n + D[E] > u && n > 0 && D[E] > 0) {
      if (F.wordWrap === false && n < u) {
        _2(i, a, u);
        continue;
      }
      i.push("");
    }
    if (n + D[E] > u && F.wordWrap === false) {
      _2(i, a, u);
      continue;
    }
    i[i.length - 1] += a;
  }
  F.trim !== false && (i = i.map((E) => DD2(E)));
  const o = [...i.join(`
`)];
  for (const [E, a] of o.entries()) {
    if (e += a, p22.has(a)) {
      const { groups: B } = new RegExp(`(?:\\${W3}(?<code>\\d+)m|\\${w2}(?<uri>.*)${b2})`).exec(o.slice(E).join("")) || { groups: {} };
      if (B.code !== undefined) {
        const A = Number.parseFloat(B.code);
        s3 = A === J2 ? undefined : A;
      } else
        B.uri !== undefined && (C = B.uri.length === 0 ? undefined : B.uri);
    }
    const n = q.codes.get(Number(s3));
    o[E + 1] === `
` ? (C && (e += j2("")), s3 && n && (e += N(n))) : a === `
` && (s3 && n && (e += N(s3)), C && (e += j2(C)));
  }
  return e;
};
var R;
var V2;
var tD2;
var sD2;
var iD2;
var ED2;
var oD2;
var unicode3;
var s3 = (c22, fallback22) => unicode3 ? c22 : fallback22;
var S_STEP_ACTIVE2;
var S_STEP_CANCEL2;
var S_STEP_ERROR2;
var S_STEP_SUBMIT2;
var S_BAR2 = "";
var S_BAR_END2 = "";
var S_RADIO_ACTIVE2;
var S_RADIO_INACTIVE2;
var S_CHECKBOX_ACTIVE2;
var S_CHECKBOX_SELECTED2;
var S_CHECKBOX_INACTIVE2;
var symbol2 = (state) => {
  switch (state) {
    case "initial":
    case "active": {
      return colors2.cyan(S_STEP_ACTIVE2);
    }
    case "cancel": {
      return colors2.red(S_STEP_CANCEL2);
    }
    case "error": {
      return colors2.yellow(S_STEP_ERROR2);
    }
    case "submit": {
      return colors2.green(S_STEP_SUBMIT2);
    }
  }
};
var text2 = (opts) => {
  return new oD2({
    validate: opts.validate,
    placeholder: opts.placeholder,
    defaultValue: opts.defaultValue,
    initialValue: opts.initialValue,
    render() {
      const title = `${colors2.gray(S_BAR2)}
${symbol2(this.state)} ${opts.message}
`;
      const placeholder = opts.placeholder ? colors2.inverse(opts.placeholder[0]) + colors2.dim(opts.placeholder.slice(1)) : colors2.inverse(colors2.hidden("_"));
      const value = this.value ? this.valueWithCursor : placeholder;
      switch (this.state) {
        case "error": {
          return `${title.trim()}
${colors2.yellow(S_BAR2)} ${value}
${colors2.yellow(S_BAR_END2)} ${colors2.yellow(this.error)}
`;
        }
        case "submit": {
          return `${title}${colors2.gray(S_BAR2)} ${colors2.dim(this.value || opts.placeholder)}`;
        }
        case "cancel": {
          return `${title}${colors2.gray(S_BAR2)} ${colors2.strikethrough(colors2.dim(this.value ?? ""))}${this.value?.trim() ? "\n" + colors2.gray(S_BAR2) : ""}`;
        }
        default: {
          return `${title}${colors2.cyan(S_BAR2)} ${value}
${colors2.cyan(S_BAR_END2)}
`;
        }
      }
    }
  }).prompt();
};
var confirm2 = (opts) => {
  const active = opts.active ?? "Yes";
  const inactive = opts.inactive ?? "No";
  return new sD2({
    active,
    inactive,
    initialValue: opts.initialValue ?? true,
    render() {
      const title = `${colors2.gray(S_BAR2)}
${symbol2(this.state)} ${opts.message}
`;
      const value = this.value ? active : inactive;
      switch (this.state) {
        case "submit": {
          return `${title}${colors2.gray(S_BAR2)} ${colors2.dim(value)}`;
        }
        case "cancel": {
          return `${title}${colors2.gray(S_BAR2)} ${colors2.strikethrough(colors2.dim(value))}
${colors2.gray(S_BAR2)}`;
        }
        default: {
          return `${title}${colors2.cyan(S_BAR2)} ${this.value ? `${colors2.green(S_RADIO_ACTIVE2)} ${active}` : `${colors2.dim(S_RADIO_INACTIVE2)} ${colors2.dim(active)}`} ${colors2.dim("/")} ${this.value ? `${colors2.dim(S_RADIO_INACTIVE2)} ${colors2.dim(inactive)}` : `${colors2.green(S_RADIO_ACTIVE2)} ${inactive}`}
${colors2.cyan(S_BAR_END2)}
`;
        }
      }
    }
  }).prompt();
};
var select2 = (opts) => {
  const opt = (option, state) => {
    const label = option.label ?? String(option.value);
    switch (state) {
      case "active": {
        return `${colors2.green(S_RADIO_ACTIVE2)} ${label} ${option.hint ? colors2.dim(`(${option.hint})`) : ""}`;
      }
      case "selected": {
        return `${colors2.dim(label)}`;
      }
      case "cancelled": {
        return `${colors2.strikethrough(colors2.dim(label))}`;
      }
    }
    return `${colors2.dim(S_RADIO_INACTIVE2)} ${colors2.dim(label)}`;
  };
  return new ED2({
    options: opts.options,
    initialValue: opts.initialValue,
    render() {
      const title = `${colors2.gray(S_BAR2)}
${symbol2(this.state)} ${opts.message}
`;
      switch (this.state) {
        case "submit": {
          return `${title}${colors2.gray(S_BAR2)} ${opt(this.options[this.cursor], "selected")}`;
        }
        case "cancel": {
          return `${title}${colors2.gray(S_BAR2)} ${opt(this.options[this.cursor], "cancelled")}
${colors2.gray(S_BAR2)}`;
        }
        default: {
          return `${title}${colors2.cyan(S_BAR2)} ${this.options.map((option, i) => opt(option, i === this.cursor ? "active" : "inactive")).join(`
${colors2.cyan(S_BAR2)}  `)}
${colors2.cyan(S_BAR_END2)}
`;
        }
      }
    }
  }).prompt();
};
var multiselect2 = (opts) => {
  const opt = (option, state) => {
    const label = option.label ?? String(option.value);
    switch (state) {
      case "active": {
        return `${colors2.cyan(S_CHECKBOX_ACTIVE2)} ${label} ${option.hint ? colors2.dim(`(${option.hint})`) : ""}`;
      }
      case "selected": {
        return `${colors2.green(S_CHECKBOX_SELECTED2)} ${colors2.dim(label)}`;
      }
      case "cancelled": {
        return `${colors2.strikethrough(colors2.dim(label))}`;
      }
      case "active-selected": {
        return `${colors2.green(S_CHECKBOX_SELECTED2)} ${label} ${option.hint ? colors2.dim(`(${option.hint})`) : ""}`;
      }
      case "submitted": {
        return `${colors2.dim(label)}`;
      }
    }
    return `${colors2.dim(S_CHECKBOX_INACTIVE2)} ${colors2.dim(label)}`;
  };
  return new iD2({
    options: opts.options,
    initialValues: opts.initialValues,
    required: opts.required ?? true,
    cursorAt: opts.cursorAt,
    validate(selected) {
      if (this.required && selected.length === 0) {
        return `Please select at least one option.
${colors2.reset(colors2.dim(`Press ${colors2.gray(colors2.bgWhite(colors2.inverse(" space ")))} to select, ${colors2.gray(colors2.bgWhite(colors2.inverse(" enter ")))} to submit`))}`;
      }
    },
    render() {
      const title = `${colors2.gray(S_BAR2)}
${symbol2(this.state)} ${opts.message}
`;
      switch (this.state) {
        case "submit": {
          return `${title}${colors2.gray(S_BAR2)} ${this.options.filter(({ value }) => this.value.includes(value)).map((option) => opt(option, "submitted")).join(colors2.dim(", ")) || colors2.dim("none")}`;
        }
        case "cancel": {
          const label = this.options.filter(({ value }) => this.value.includes(value)).map((option) => opt(option, "cancelled")).join(colors2.dim(", "));
          return `${title}${colors2.gray(S_BAR2)} ${label.trim() ? `${label}
${colors2.gray(S_BAR2)}` : ""}`;
        }
        case "error": {
          const footer = this.error.split("\n").map((ln, i) => i === 0 ? `${colors2.yellow(S_BAR_END2)} ${colors2.yellow(ln)}` : `   ${ln}`).join("\n");
          return title + colors2.yellow(S_BAR2) + "  " + this.options.map((option, i) => {
            const selected = this.value.includes(option.value);
            const active = i === this.cursor;
            if (active && selected) {
              return opt(option, "active-selected");
            }
            if (selected) {
              return opt(option, "selected");
            }
            return opt(option, active ? "active" : "inactive");
          }).join(`
${colors2.yellow(S_BAR2)}  `) + "\n" + footer + "\n";
        }
        default: {
          return `${title}${colors2.cyan(S_BAR2)} ${this.options.map((option, i) => {
            const selected = this.value.includes(option.value);
            const active = i === this.cursor;
            if (active && selected) {
              return opt(option, "active-selected");
            }
            if (selected) {
              return opt(option, "selected");
            }
            return opt(option, active ? "active" : "inactive");
          }).join(`
${colors2.cyan(S_BAR2)}  `)}
${colors2.cyan(S_BAR_END2)}
`;
        }
      }
    }
  }).prompt();
};
var init_prompt2 = __esm2(() => {
  init_consola_36c0034f2();
  init_utils3();
  init_core2();
  init_consola_06ad8a642();
  CSI2 = `${ESC2}[`;
  cursor2 = {
    to(x, y) {
      if (!y)
        return `${CSI2}${x + 1}G`;
      return `${CSI2}${y + 1};${x + 1}H`;
    },
    move(x, y) {
      let ret = "";
      if (x < 0)
        ret += `${CSI2}${-x}D`;
      else if (x > 0)
        ret += `${CSI2}${x}C`;
      if (y < 0)
        ret += `${CSI2}${-y}A`;
      else if (y > 0)
        ret += `${CSI2}${y}B`;
      return ret;
    },
    up: (count = 1) => `${CSI2}${count}A`,
    down: (count = 1) => `${CSI2}${count}B`,
    forward: (count = 1) => `${CSI2}${count}C`,
    backward: (count = 1) => `${CSI2}${count}D`,
    nextLine: (count = 1) => `${CSI2}E`.repeat(count),
    prevLine: (count = 1) => `${CSI2}F`.repeat(count),
    left: `${CSI2}G`,
    hide: `${CSI2}?25l`,
    show: `${CSI2}?25h`,
    save: `${ESC2}7`,
    restore: `${ESC2}8`
  };
  scroll2 = {
    up: (count = 1) => `${CSI2}S`.repeat(count),
    down: (count = 1) => `${CSI2}T`.repeat(count)
  };
  erase2 = {
    screen: `${CSI2}2J`,
    up: (count = 1) => `${CSI2}1J`.repeat(count),
    down: (count = 1) => `${CSI2}J`.repeat(count),
    line: `${CSI2}2K`,
    lineEnd: `${CSI2}K`,
    lineStart: `${CSI2}1K`,
    lines(count) {
      let clear = "";
      for (let i = 0;i < count; i++)
        clear += this.line + (i < count - 1 ? cursor2.up() : "");
      if (count)
        clear += cursor2.left;
      return clear;
    }
  };
  src2 = { cursor: cursor2, scroll: scroll2, erase: erase2, beep: beep2 };
  picocolors2 = { exports: {} };
  tty22 = require$$02;
  isColorSupported22 = !(("NO_COLOR" in process.env) || process.argv.includes("--no-color")) && (("FORCE_COLOR" in process.env) || process.argv.includes("--color") || process.platform === "win32" || tty22.isatty(1) && true || ("CI" in process.env));
  picocolors2.exports = createColors22();
  picocolors2.exports.createColors = createColors22;
  picocolorsExports2 = picocolors2.exports;
  l3 = /* @__PURE__ */ getDefaultExportFromCjs2(picocolorsExports2);
  m2 = {};
  G2 = { get exports() {
    return m2;
  }, set exports(t) {
    m2 = t;
  } };
  (function(t) {
    var u = {};
    t.exports = u, u.eastAsianWidth = function(e) {
      var s4 = e.charCodeAt(0), C = e.length == 2 ? e.charCodeAt(1) : 0, D = s4;
      return 55296 <= s4 && s4 <= 56319 && 56320 <= C && C <= 57343 && (s4 &= 1023, C &= 1023, D = s4 << 10 | C, D += 65536), D == 12288 || 65281 <= D && D <= 65376 || 65504 <= D && D <= 65510 ? "F" : D == 8361 || 65377 <= D && D <= 65470 || 65474 <= D && D <= 65479 || 65482 <= D && D <= 65487 || 65490 <= D && D <= 65495 || 65498 <= D && D <= 65500 || 65512 <= D && D <= 65518 ? "H" : 4352 <= D && D <= 4447 || 4515 <= D && D <= 4519 || 4602 <= D && D <= 4607 || 9001 <= D && D <= 9002 || 11904 <= D && D <= 11929 || 11931 <= D && D <= 12019 || 12032 <= D && D <= 12245 || 12272 <= D && D <= 12283 || 12289 <= D && D <= 12350 || 12353 <= D && D <= 12438 || 12441 <= D && D <= 12543 || 12549 <= D && D <= 12589 || 12593 <= D && D <= 12686 || 12688 <= D && D <= 12730 || 12736 <= D && D <= 12771 || 12784 <= D && D <= 12830 || 12832 <= D && D <= 12871 || 12880 <= D && D <= 13054 || 13056 <= D && D <= 19903 || 19968 <= D && D <= 42124 || 42128 <= D && D <= 42182 || 43360 <= D && D <= 43388 || 44032 <= D && D <= 55203 || 55216 <= D && D <= 55238 || 55243 <= D && D <= 55291 || 63744 <= D && D <= 64255 || 65040 <= D && D <= 65049 || 65072 <= D && D <= 65106 || 65108 <= D && D <= 65126 || 65128 <= D && D <= 65131 || 110592 <= D && D <= 110593 || 127488 <= D && D <= 127490 || 127504 <= D && D <= 127546 || 127552 <= D && D <= 127560 || 127568 <= D && D <= 127569 || 131072 <= D && D <= 194367 || 177984 <= D && D <= 196605 || 196608 <= D && D <= 262141 ? "W" : 32 <= D && D <= 126 || 162 <= D && D <= 163 || 165 <= D && D <= 166 || D == 172 || D == 175 || 10214 <= D && D <= 10221 || 10629 <= D && D <= 10630 ? "Na" : D == 161 || D == 164 || 167 <= D && D <= 168 || D == 170 || 173 <= D && D <= 174 || 176 <= D && D <= 180 || 182 <= D && D <= 186 || 188 <= D && D <= 191 || D == 198 || D == 208 || 215 <= D && D <= 216 || 222 <= D && D <= 225 || D == 230 || 232 <= D && D <= 234 || 236 <= D && D <= 237 || D == 240 || 242 <= D && D <= 243 || 247 <= D && D <= 250 || D == 252 || D == 254 || D == 257 || D == 273 || D == 275 || D == 283 || 294 <= D && D <= 295 || D == 299 || 305 <= D && D <= 307 || D == 312 || 319 <= D && D <= 322 || D == 324 || 328 <= D && D <= 331 || D == 333 || 338 <= D && D <= 339 || 358 <= D && D <= 359 || D == 363 || D == 462 || D == 464 || D == 466 || D == 468 || D == 470 || D == 472 || D == 474 || D == 476 || D == 593 || D == 609 || D == 708 || D == 711 || 713 <= D && D <= 715 || D == 717 || D == 720 || 728 <= D && D <= 731 || D == 733 || D == 735 || 768 <= D && D <= 879 || 913 <= D && D <= 929 || 931 <= D && D <= 937 || 945 <= D && D <= 961 || 963 <= D && D <= 969 || D == 1025 || 1040 <= D && D <= 1103 || D == 1105 || D == 8208 || 8211 <= D && D <= 8214 || 8216 <= D && D <= 8217 || 8220 <= D && D <= 8221 || 8224 <= D && D <= 8226 || 8228 <= D && D <= 8231 || D == 8240 || 8242 <= D && D <= 8243 || D == 8245 || D == 8251 || D == 8254 || D == 8308 || D == 8319 || 8321 <= D && D <= 8324 || D == 8364 || D == 8451 || D == 8453 || D == 8457 || D == 8467 || D == 8470 || 8481 <= D && D <= 8482 || D == 8486 || D == 8491 || 8531 <= D && D <= 8532 || 8539 <= D && D <= 8542 || 8544 <= D && D <= 8555 || 8560 <= D && D <= 8569 || D == 8585 || 8592 <= D && D <= 8601 || 8632 <= D && D <= 8633 || D == 8658 || D == 8660 || D == 8679 || D == 8704 || 8706 <= D && D <= 8707 || 8711 <= D && D <= 8712 || D == 8715 || D == 8719 || D == 8721 || D == 8725 || D == 8730 || 8733 <= D && D <= 8736 || D == 8739 || D == 8741 || 8743 <= D && D <= 8748 || D == 8750 || 8756 <= D && D <= 8759 || 8764 <= D && D <= 8765 || D == 8776 || D == 8780 || D == 8786 || 8800 <= D && D <= 8801 || 8804 <= D && D <= 8807 || 8810 <= D && D <= 8811 || 8814 <= D && D <= 8815 || 8834 <= D && D <= 8835 || 8838 <= D && D <= 8839 || D == 8853 || D == 8857 || D == 8869 || D == 8895 || D == 8978 || 9312 <= D && D <= 9449 || 9451 <= D && D <= 9547 || 9552 <= D && D <= 9587 || 9600 <= D && D <= 9615 || 9618 <= D && D <= 9621 || 9632 <= D && D <= 9633 || 9635 <= D && D <= 9641 || 9650 <= D && D <= 9651 || 9654 <= D && D <= 9655 || 9660 <= D && D <= 9661 || 9664 <= D && D <= 9665 || 9670 <= D && D <= 9672 || D == 9675 || 9678 <= D && D <= 9681 || 9698 <= D && D <= 9701 || D == 9711 || 9733 <= D && D <= 9734 || D == 9737 || 9742 <= D && D <= 9743 || 9748 <= D && D <= 9749 || D == 9756 || D == 9758 || D == 9792 || D == 9794 || 9824 <= D && D <= 9825 || 9827 <= D && D <= 9829 || 9831 <= D && D <= 9834 || 9836 <= D && D <= 9837 || D == 9839 || 9886 <= D && D <= 9887 || 9918 <= D && D <= 9919 || 9924 <= D && D <= 9933 || 9935 <= D && D <= 9953 || D == 9955 || 9960 <= D && D <= 9983 || D == 10045 || D == 10071 || 10102 <= D && D <= 10111 || 11093 <= D && D <= 11097 || 12872 <= D && D <= 12879 || 57344 <= D && D <= 63743 || 65024 <= D && D <= 65039 || D == 65533 || 127232 <= D && D <= 127242 || 127248 <= D && D <= 127277 || 127280 <= D && D <= 127337 || 127344 <= D && D <= 127386 || 917760 <= D && D <= 917999 || 983040 <= D && D <= 1048573 || 1048576 <= D && D <= 1114109 ? "A" : "N";
    }, u.characterLength = function(e) {
      var s4 = this.eastAsianWidth(e);
      return s4 == "F" || s4 == "W" || s4 == "A" ? 2 : 1;
    };
    function F(e) {
      return e.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]|[^\uD800-\uDFFF]/g) || [];
    }
    u.length = function(e) {
      for (var s4 = F(e), C = 0, D = 0;D < s4.length; D++)
        C = C + this.characterLength(s4[D]);
      return C;
    }, u.slice = function(e, s4, C) {
      textLen = u.length(e), s4 = s4 || 0, C = C || 1, s4 < 0 && (s4 = textLen + s4), C < 0 && (C = textLen + C);
      for (var D = "", i = 0, o = F(e), E = 0;E < o.length; E++) {
        var a = o[E], n = u.length(a);
        if (i >= s4 - (n == 2 ? 1 : 0))
          if (i + n <= C)
            D += a;
          else
            break;
        i += n;
      }
      return D;
    };
  })(G2);
  K2 = m2;
  r2 = { modifier: { reset: [0, 0], bold: [1, 22], dim: [2, 22], italic: [3, 23], underline: [4, 24], overline: [53, 55], inverse: [7, 27], hidden: [8, 28], strikethrough: [9, 29] }, color: { black: [30, 39], red: [31, 39], green: [32, 39], yellow: [33, 39], blue: [34, 39], magenta: [35, 39], cyan: [36, 39], white: [37, 39], blackBright: [90, 39], gray: [90, 39], grey: [90, 39], redBright: [91, 39], greenBright: [92, 39], yellowBright: [93, 39], blueBright: [94, 39], magentaBright: [95, 39], cyanBright: [96, 39], whiteBright: [97, 39] }, bgColor: { bgBlack: [40, 49], bgRed: [41, 49], bgGreen: [42, 49], bgYellow: [43, 49], bgBlue: [44, 49], bgMagenta: [45, 49], bgCyan: [46, 49], bgWhite: [47, 49], bgBlackBright: [100, 49], bgGray: [100, 49], bgGrey: [100, 49], bgRedBright: [101, 49], bgGreenBright: [102, 49], bgYellowBright: [103, 49], bgBlueBright: [104, 49], bgMagentaBright: [105, 49], bgCyanBright: [106, 49], bgWhiteBright: [107, 49] } };
  Object.keys(r2.modifier);
  Z2 = Object.keys(r2.color);
  H2 = Object.keys(r2.bgColor);
  [...Z2];
  q = U3();
  p22 = new Set(["\x1B", "\x9B"]);
  w2 = `${Q2}8;;`;
  R = Symbol("clack:cancel");
  V2 = new Map([["k", "up"], ["j", "down"], ["h", "left"], ["l", "right"]]);
  tD2 = new Set(["up", "down", "left", "right", "space", "enter"]);
  sD2 = class sD3 extends h3 {
    get cursor() {
      return this.value ? 0 : 1;
    }
    get _value() {
      return this.cursor === 0;
    }
    constructor(u) {
      super(u, false), this.value = !!u.initialValue, this.on("value", () => {
        this.value = this._value;
      }), this.on("confirm", (F) => {
        this.output.write(src2.cursor.move(0, -1)), this.value = F, this.state = "submit", this.close();
      }), this.on("cursor", () => {
        this.value = !this.value;
      });
    }
  };
  iD2 = class iD3 extends h3 {
    constructor(u) {
      super(u, false), this.cursor = 0, this.options = u.options, this.value = [...u.initialValues ?? []], this.cursor = Math.max(this.options.findIndex(({ value: F }) => F === u.cursorAt), 0), this.on("key", (F) => {
        F === "a" && this.toggleAll();
      }), this.on("cursor", (F) => {
        switch (F) {
          case "left":
          case "up":
            this.cursor = this.cursor === 0 ? this.options.length - 1 : this.cursor - 1;
            break;
          case "down":
          case "right":
            this.cursor = this.cursor === this.options.length - 1 ? 0 : this.cursor + 1;
            break;
          case "space":
            this.toggleValue();
            break;
        }
      });
    }
    get _value() {
      return this.options[this.cursor].value;
    }
    toggleAll() {
      const u = this.value.length === this.options.length;
      this.value = u ? [] : this.options.map((F) => F.value);
    }
    toggleValue() {
      const u = this.value.includes(this._value);
      this.value = u ? this.value.filter((F) => F !== this._value) : [...this.value, this._value];
    }
  };
  ED2 = class ED3 extends h3 {
    constructor(u) {
      super(u, false), this.cursor = 0, this.options = u.options, this.cursor = this.options.findIndex(({ value: F }) => F === u.initialValue), this.cursor === -1 && (this.cursor = 0), this.changeValue(), this.on("cursor", (F) => {
        switch (F) {
          case "left":
          case "up":
            this.cursor = this.cursor === 0 ? this.options.length - 1 : this.cursor - 1;
            break;
          case "down":
          case "right":
            this.cursor = this.cursor === this.options.length - 1 ? 0 : this.cursor + 1;
            break;
        }
        this.changeValue();
      });
    }
    get _value() {
      return this.options[this.cursor];
    }
    changeValue() {
      this.value = this._value.value;
    }
  };
  oD2 = class oD3 extends h3 {
    constructor(u) {
      super(u), this.valueWithCursor = "", this.on("finalize", () => {
        this.value || (this.value = u.defaultValue), this.valueWithCursor = this.value;
      }), this.on("value", () => {
        if (this.cursor >= this.value.length)
          this.valueWithCursor = `${this.value}${l3.inverse(l3.hidden("_"))}`;
        else {
          const F = this.value.slice(0, this.cursor), e = this.value.slice(this.cursor);
          this.valueWithCursor = `${F}${l3.inverse(e[0])}${e.slice(1)}`;
        }
      });
    }
    get cursor() {
      return this._cursor;
    }
  };
  unicode3 = isUnicodeSupported4();
  S_STEP_ACTIVE2 = s3("\u276F", ">");
  S_STEP_CANCEL2 = s3("\u25A0", "x");
  S_STEP_ERROR2 = s3("\u25B2", "x");
  S_STEP_SUBMIT2 = s3("\u2714", "\u221A");
  S_RADIO_ACTIVE2 = s3("\u25CF", ">");
  S_RADIO_INACTIVE2 = s3("\u25CB", " ");
  S_CHECKBOX_ACTIVE2 = s3("\u25FB", "[\u2022]");
  S_CHECKBOX_SELECTED2 = s3("\u25FC", "[+]");
  S_CHECKBOX_INACTIVE2 = s3("\u25FB", "[ ]");
});
function detectProvider2(env42) {
  for (const provider of providers2) {
    const envName = provider[1] || provider[0];
    if (env42[envName]) {
      return {
        name: provider[0].toLowerCase(),
        ...provider[2]
      };
    }
  }
  if (env42.SHELL && env42.SHELL === "/bin/jsh") {
    return {
      name: "stackblitz",
      ci: false
    };
  }
  return {
    name: "",
    ci: false
  };
}
function toBoolean2(val2) {
  return val2 ? val2 !== "false" : false;
}
function ansiRegex22({ onlyFirst = false } = {}) {
  const pattern = [
    "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"
  ].join("|");
  return new RegExp(pattern, onlyFirst ? undefined : "g");
}
function stripAnsi22(string2) {
  if (typeof string2 !== "string") {
    throw new TypeError(`Expected a \`string\`, got \`${typeof string2}\``);
  }
  return string2.replace(regex3, "");
}
function getDefaultExportFromCjs2(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
function stringWidth$12(string2, options22) {
  if (typeof string2 !== "string" || string2.length === 0) {
    return 0;
  }
  options22 = {
    ambiguousIsNarrow: true,
    countAnsiEscapeCodes: false,
    ...options22
  };
  if (!options22.countAnsiEscapeCodes) {
    string2 = stripAnsi22(string2);
  }
  if (string2.length === 0) {
    return 0;
  }
  const ambiguousCharacterWidth = options22.ambiguousIsNarrow ? 1 : 2;
  let width = 0;
  for (const { segment: character } of new Intl.Segmenter().segment(string2)) {
    const codePoint = character.codePointAt(0);
    if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
      continue;
    }
    if (codePoint >= 768 && codePoint <= 879) {
      continue;
    }
    if (emojiRegex2().test(character)) {
      width += 2;
      continue;
    }
    const code = eastAsianWidth3.eastAsianWidth(character);
    switch (code) {
      case "F":
      case "W": {
        width += 2;
        break;
      }
      case "A": {
        width += ambiguousCharacterWidth;
        break;
      }
      default: {
        width += 1;
      }
    }
  }
  return width;
}
function isUnicodeSupported4() {
  if (process$12.platform !== "win32") {
    return process$12.env.TERM !== "linux";
  }
  return Boolean(process$12.env.CI) || Boolean(process$12.env.WT_SESSION) || Boolean(process$12.env.TERMINUS_SUBLIME) || process$12.env.ConEmuTask === "{cmd::Cmder}" || process$12.env.TERM_PROGRAM === "Terminus-Sublime" || process$12.env.TERM_PROGRAM === "vscode" || process$12.env.TERM === "xterm-256color" || process$12.env.TERM === "alacritty" || process$12.env.TERMINAL_EMULATOR === "JetBrains-JediTerm";
}
function stringWidth3(str) {
  if (!Intl.Segmenter) {
    return stripAnsi4(str).length;
  }
  return stringWidth$12(str);
}
function characterFormat2(str) {
  return str.replace(/`([^`]+)`/gm, (_22, m22) => colors2.cyan(m22)).replace(/\s+_([^_]+)_\s+/gm, (_22, m22) => ` ${colors2.underline(m22)} `);
}
function getColor22(color = "white") {
  return colors2[color] || colors2.white;
}
function getBgColor2(color = "bgWhite") {
  return colors2[`bg${color[0].toUpperCase()}${color.slice(1)}`] || colors2.bgWhite;
}
function createConsola22(options22 = {}) {
  let level = _getDefaultLogLevel2();
  if (process.env.CONSOLA_LEVEL) {
    level = Number.parseInt(process.env.CONSOLA_LEVEL) ?? level;
  }
  const consola2 = createConsola3({
    level,
    defaults: { level },
    stdout: process.stdout,
    stderr: process.stderr,
    prompt: (...args) => Promise.resolve().then(() => (init_prompt2(), exports_prompt2)).then((m22) => m22.prompt(...args)),
    reporters: options22.reporters || [
      options22.fancy ?? !(isCI22 || isTest2) ? new FancyReporter2 : new BasicReporter2
    ],
    ...options22
  });
  return consola2;
}
function _getDefaultLogLevel2() {
  if (isDebug2) {
    return LogLevels2.debug;
  }
  if (isTest2) {
    return LogLevels2.warn;
  }
  return LogLevels2.info;
}
var providers2;
var processShim2;
var envShim2;
var providerInfo2;
var nodeENV2;
var isCI22;
var hasTTY2;
var isDebug2;
var isTest2;
var regex3;
var eastasianwidth2;
var eastasianwidthExports2;
var eastAsianWidth3;
var emojiRegex2 = () => {
  return /[#*0-9]\uFE0F?\u20E3|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26AA\u26B0\u26B1\u26BD\u26BE\u26C4\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0-\u26F5\u26F7\u26F8\u26FA\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2757\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B55\u3030\u303D\u3297\u3299]\uFE0F?|[\u261D\u270C\u270D](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\u270A\u270B](?:\uD83C[\uDFFB-\uDFFF])?|[\u23E9-\u23EC\u23F0\u23F3\u25FD\u2693\u26A1\u26AB\u26C5\u26CE\u26D4\u26EA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2795-\u2797\u27B0\u27BF\u2B50]|\u26F9(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\u2764\uFE0F?(?:\u200D(?:\uD83D\uDD25|\uD83E\uDE79))?|\uD83C(?:[\uDC04\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]\uFE0F?|[\uDF85\uDFC2\uDFC7](?:\uD83C[\uDFFB-\uDFFF])?|[\uDFC3\uDFC4\uDFCA](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDFCB\uDFCC](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uDDE6\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF]|\uDDE7\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF]|\uDDE8\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF]|\uDDE9\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF]|\uDDEA\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA]|\uDDEB\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7]|\uDDEC\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE]|\uDDED\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA]|\uDDEE\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9]|\uDDEF\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5]|\uDDF0\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF]|\uDDF1\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE]|\uDDF2\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF]|\uDDF3\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF]|\uDDF4\uD83C\uDDF2|\uDDF5\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE]|\uDDF6\uD83C\uDDE6|\uDDF7\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC]|\uDDF8\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF]|\uDDF9\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF]|\uDDFA\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF]|\uDDFB\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA]|\uDDFC\uD83C[\uDDEB\uDDF8]|\uDDFD\uD83C\uDDF0|\uDDFE\uD83C[\uDDEA\uDDF9]|\uDDFF\uD83C[\uDDE6\uDDF2\uDDFC]|\uDFF3\uFE0F?(?:\u200D(?:\u26A7\uFE0F?|\uD83C\uDF08))?|\uDFF4(?:\u200D\u2620\uFE0F?|\uDB40\uDC67\uDB40\uDC62\uDB40(?:\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDC73\uDB40\uDC63\uDB40\uDC74|\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F)?)|\uD83D(?:[\uDC08\uDC26](?:\u200D\u2B1B)?|[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3]\uFE0F?|[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC](?:\uD83C[\uDFFB-\uDFFF])?|[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD74\uDD90](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC25\uDC27-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEDC-\uDEDF\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB\uDFF0]|\uDC15(?:\u200D\uD83E\uDDBA)?|\uDC3B(?:\u200D\u2744\uFE0F?)?|\uDC41\uFE0F?(?:\u200D\uD83D\uDDE8\uFE0F?)?|\uDC68(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDC68\uDC69]\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFE])))?))?|\uDC69(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?[\uDC68\uDC69]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?|\uDC69\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?))|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFE])))?))?|\uDC6F(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDD75(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDE2E(?:\u200D\uD83D\uDCA8)?|\uDE35(?:\u200D\uD83D\uDCAB)?|\uDE36(?:\u200D\uD83C\uDF2B\uFE0F?)?)|\uD83E(?:[\uDD0C\uDD0F\uDD18-\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5\uDEC3-\uDEC5\uDEF0\uDEF2-\uDEF8](?:\uD83C[\uDFFB-\uDFFF])?|[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDDDE\uDDDF](?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD0D\uDD0E\uDD10-\uDD17\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCC\uDDD0\uDDE0-\uDDFF\uDE70-\uDE7C\uDE80-\uDE88\uDE90-\uDEBD\uDEBF-\uDEC2\uDECE-\uDEDB\uDEE0-\uDEE8]|\uDD3C(?:\u200D[\u2640\u2642]\uFE0F?|\uD83C[\uDFFB-\uDFFF])?|\uDDD1(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFC-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFD-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFD\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFE]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?))?|\uDEF1(?:\uD83C(?:\uDFFB(?:\u200D\uD83E\uDEF2\uD83C[\uDFFC-\uDFFF])?|\uDFFC(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFD-\uDFFF])?|\uDFFD(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])?|\uDFFE(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFD\uDFFF])?|\uDFFF(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFE])?))?)/g;
};
var TYPE_COLOR_MAP2;
var LEVEL_COLOR_MAP2;
var unicode22;
var s22 = (c22, fallback22) => unicode22 ? c22 : fallback22;
var TYPE_ICONS2;
var FancyReporter2;
var consola2;
var init_consola_36c0034f2 = __esm2(() => {
  init_core2();
  init_consola_06ad8a642();
  init_utils3();
  providers2 = [
    ["APPVEYOR"],
    ["AZURE_PIPELINES", "SYSTEM_TEAMFOUNDATIONCOLLECTIONURI"],
    ["AZURE_STATIC", "INPUT_AZURE_STATIC_WEB_APPS_API_TOKEN"],
    ["APPCIRCLE", "AC_APPCIRCLE"],
    ["BAMBOO", "bamboo_planKey"],
    ["BITBUCKET", "BITBUCKET_COMMIT"],
    ["BITRISE", "BITRISE_IO"],
    ["BUDDY", "BUDDY_WORKSPACE_ID"],
    ["BUILDKITE"],
    ["CIRCLE", "CIRCLECI"],
    ["CIRRUS", "CIRRUS_CI"],
    ["CLOUDFLARE_PAGES", "CF_PAGES", { ci: true }],
    ["CODEBUILD", "CODEBUILD_BUILD_ARN"],
    ["CODEFRESH", "CF_BUILD_ID"],
    ["DRONE"],
    ["DRONE", "DRONE_BUILD_EVENT"],
    ["DSARI"],
    ["GITHUB_ACTIONS"],
    ["GITLAB", "GITLAB_CI"],
    ["GITLAB", "CI_MERGE_REQUEST_ID"],
    ["GOCD", "GO_PIPELINE_LABEL"],
    ["LAYERCI"],
    ["HUDSON", "HUDSON_URL"],
    ["JENKINS", "JENKINS_URL"],
    ["MAGNUM"],
    ["NETLIFY"],
    ["NETLIFY", "NETLIFY_LOCAL", { ci: false }],
    ["NEVERCODE"],
    ["RENDER"],
    ["SAIL", "SAILCI"],
    ["SEMAPHORE"],
    ["SCREWDRIVER"],
    ["SHIPPABLE"],
    ["SOLANO", "TDDIUM"],
    ["STRIDER"],
    ["TEAMCITY", "TEAMCITY_VERSION"],
    ["TRAVIS"],
    ["VERCEL", "NOW_BUILDER"],
    ["APPCENTER", "APPCENTER_BUILD_ID"],
    ["CODESANDBOX", "CODESANDBOX_SSE", { ci: false }],
    ["STACKBLITZ"],
    ["STORMKIT"],
    ["CLEAVR"]
  ];
  processShim2 = typeof process !== "undefined" ? process : {};
  envShim2 = processShim2.env || {};
  providerInfo2 = detectProvider2(envShim2);
  nodeENV2 = typeof process !== "undefined" && process.env && "development" || "";
  processShim2.platform;
  providerInfo2.name;
  isCI22 = toBoolean2(envShim2.CI) || providerInfo2.ci !== false;
  hasTTY2 = toBoolean2(processShim2.stdout && processShim2.stdout.isTTY);
  isDebug2 = toBoolean2(envShim2.DEBUG);
  isTest2 = nodeENV2 === "test" || toBoolean2(envShim2.TEST);
  toBoolean2(envShim2.MINIMAL);
  regex3 = ansiRegex22();
  eastasianwidth2 = { exports: {} };
  (function(module) {
    var eaw = {};
    {
      module.exports = eaw;
    }
    eaw.eastAsianWidth = function(character) {
      var x = character.charCodeAt(0);
      var y = character.length == 2 ? character.charCodeAt(1) : 0;
      var codePoint = x;
      if (55296 <= x && x <= 56319 && (56320 <= y && y <= 57343)) {
        x &= 1023;
        y &= 1023;
        codePoint = x << 10 | y;
        codePoint += 65536;
      }
      if (codePoint == 12288 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510) {
        return "F";
      }
      if (codePoint == 8361 || 65377 <= codePoint && codePoint <= 65470 || 65474 <= codePoint && codePoint <= 65479 || 65482 <= codePoint && codePoint <= 65487 || 65490 <= codePoint && codePoint <= 65495 || 65498 <= codePoint && codePoint <= 65500 || 65512 <= codePoint && codePoint <= 65518) {
        return "H";
      }
      if (4352 <= codePoint && codePoint <= 4447 || 4515 <= codePoint && codePoint <= 4519 || 4602 <= codePoint && codePoint <= 4607 || 9001 <= codePoint && codePoint <= 9002 || 11904 <= codePoint && codePoint <= 11929 || 11931 <= codePoint && codePoint <= 12019 || 12032 <= codePoint && codePoint <= 12245 || 12272 <= codePoint && codePoint <= 12283 || 12289 <= codePoint && codePoint <= 12350 || 12353 <= codePoint && codePoint <= 12438 || 12441 <= codePoint && codePoint <= 12543 || 12549 <= codePoint && codePoint <= 12589 || 12593 <= codePoint && codePoint <= 12686 || 12688 <= codePoint && codePoint <= 12730 || 12736 <= codePoint && codePoint <= 12771 || 12784 <= codePoint && codePoint <= 12830 || 12832 <= codePoint && codePoint <= 12871 || 12880 <= codePoint && codePoint <= 13054 || 13056 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42124 || 42128 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 55216 <= codePoint && codePoint <= 55238 || 55243 <= codePoint && codePoint <= 55291 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65106 || 65108 <= codePoint && codePoint <= 65126 || 65128 <= codePoint && codePoint <= 65131 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127490 || 127504 <= codePoint && codePoint <= 127546 || 127552 <= codePoint && codePoint <= 127560 || 127568 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 194367 || 177984 <= codePoint && codePoint <= 196605 || 196608 <= codePoint && codePoint <= 262141) {
        return "W";
      }
      if (32 <= codePoint && codePoint <= 126 || 162 <= codePoint && codePoint <= 163 || 165 <= codePoint && codePoint <= 166 || codePoint == 172 || codePoint == 175 || 10214 <= codePoint && codePoint <= 10221 || 10629 <= codePoint && codePoint <= 10630) {
        return "Na";
      }
      if (codePoint == 161 || codePoint == 164 || 167 <= codePoint && codePoint <= 168 || codePoint == 170 || 173 <= codePoint && codePoint <= 174 || 176 <= codePoint && codePoint <= 180 || 182 <= codePoint && codePoint <= 186 || 188 <= codePoint && codePoint <= 191 || codePoint == 198 || codePoint == 208 || 215 <= codePoint && codePoint <= 216 || 222 <= codePoint && codePoint <= 225 || codePoint == 230 || 232 <= codePoint && codePoint <= 234 || 236 <= codePoint && codePoint <= 237 || codePoint == 240 || 242 <= codePoint && codePoint <= 243 || 247 <= codePoint && codePoint <= 250 || codePoint == 252 || codePoint == 254 || codePoint == 257 || codePoint == 273 || codePoint == 275 || codePoint == 283 || 294 <= codePoint && codePoint <= 295 || codePoint == 299 || 305 <= codePoint && codePoint <= 307 || codePoint == 312 || 319 <= codePoint && codePoint <= 322 || codePoint == 324 || 328 <= codePoint && codePoint <= 331 || codePoint == 333 || 338 <= codePoint && codePoint <= 339 || 358 <= codePoint && codePoint <= 359 || codePoint == 363 || codePoint == 462 || codePoint == 464 || codePoint == 466 || codePoint == 468 || codePoint == 470 || codePoint == 472 || codePoint == 474 || codePoint == 476 || codePoint == 593 || codePoint == 609 || codePoint == 708 || codePoint == 711 || 713 <= codePoint && codePoint <= 715 || codePoint == 717 || codePoint == 720 || 728 <= codePoint && codePoint <= 731 || codePoint == 733 || codePoint == 735 || 768 <= codePoint && codePoint <= 879 || 913 <= codePoint && codePoint <= 929 || 931 <= codePoint && codePoint <= 937 || 945 <= codePoint && codePoint <= 961 || 963 <= codePoint && codePoint <= 969 || codePoint == 1025 || 1040 <= codePoint && codePoint <= 1103 || codePoint == 1105 || codePoint == 8208 || 8211 <= codePoint && codePoint <= 8214 || 8216 <= codePoint && codePoint <= 8217 || 8220 <= codePoint && codePoint <= 8221 || 8224 <= codePoint && codePoint <= 8226 || 8228 <= codePoint && codePoint <= 8231 || codePoint == 8240 || 8242 <= codePoint && codePoint <= 8243 || codePoint == 8245 || codePoint == 8251 || codePoint == 8254 || codePoint == 8308 || codePoint == 8319 || 8321 <= codePoint && codePoint <= 8324 || codePoint == 8364 || codePoint == 8451 || codePoint == 8453 || codePoint == 8457 || codePoint == 8467 || codePoint == 8470 || 8481 <= codePoint && codePoint <= 8482 || codePoint == 8486 || codePoint == 8491 || 8531 <= codePoint && codePoint <= 8532 || 8539 <= codePoint && codePoint <= 8542 || 8544 <= codePoint && codePoint <= 8555 || 8560 <= codePoint && codePoint <= 8569 || codePoint == 8585 || 8592 <= codePoint && codePoint <= 8601 || 8632 <= codePoint && codePoint <= 8633 || codePoint == 8658 || codePoint == 8660 || codePoint == 8679 || codePoint == 8704 || 8706 <= codePoint && codePoint <= 8707 || 8711 <= codePoint && codePoint <= 8712 || codePoint == 8715 || codePoint == 8719 || codePoint == 8721 || codePoint == 8725 || codePoint == 8730 || 8733 <= codePoint && codePoint <= 8736 || codePoint == 8739 || codePoint == 8741 || 8743 <= codePoint && codePoint <= 8748 || codePoint == 8750 || 8756 <= codePoint && codePoint <= 8759 || 8764 <= codePoint && codePoint <= 8765 || codePoint == 8776 || codePoint == 8780 || codePoint == 8786 || 8800 <= codePoint && codePoint <= 8801 || 8804 <= codePoint && codePoint <= 8807 || 8810 <= codePoint && codePoint <= 8811 || 8814 <= codePoint && codePoint <= 8815 || 8834 <= codePoint && codePoint <= 8835 || 8838 <= codePoint && codePoint <= 8839 || codePoint == 8853 || codePoint == 8857 || codePoint == 8869 || codePoint == 8895 || codePoint == 8978 || 9312 <= codePoint && codePoint <= 9449 || 9451 <= codePoint && codePoint <= 9547 || 9552 <= codePoint && codePoint <= 9587 || 9600 <= codePoint && codePoint <= 9615 || 9618 <= codePoint && codePoint <= 9621 || 9632 <= codePoint && codePoint <= 9633 || 9635 <= codePoint && codePoint <= 9641 || 9650 <= codePoint && codePoint <= 9651 || 9654 <= codePoint && codePoint <= 9655 || 9660 <= codePoint && codePoint <= 9661 || 9664 <= codePoint && codePoint <= 9665 || 9670 <= codePoint && codePoint <= 9672 || codePoint == 9675 || 9678 <= codePoint && codePoint <= 9681 || 9698 <= codePoint && codePoint <= 9701 || codePoint == 9711 || 9733 <= codePoint && codePoint <= 9734 || codePoint == 9737 || 9742 <= codePoint && codePoint <= 9743 || 9748 <= codePoint && codePoint <= 9749 || codePoint == 9756 || codePoint == 9758 || codePoint == 9792 || codePoint == 9794 || 9824 <= codePoint && codePoint <= 9825 || 9827 <= codePoint && codePoint <= 9829 || 9831 <= codePoint && codePoint <= 9834 || 9836 <= codePoint && codePoint <= 9837 || codePoint == 9839 || 9886 <= codePoint && codePoint <= 9887 || 9918 <= codePoint && codePoint <= 9919 || 9924 <= codePoint && codePoint <= 9933 || 9935 <= codePoint && codePoint <= 9953 || codePoint == 9955 || 9960 <= codePoint && codePoint <= 9983 || codePoint == 10045 || codePoint == 10071 || 10102 <= codePoint && codePoint <= 10111 || 11093 <= codePoint && codePoint <= 11097 || 12872 <= codePoint && codePoint <= 12879 || 57344 <= codePoint && codePoint <= 63743 || 65024 <= codePoint && codePoint <= 65039 || codePoint == 65533 || 127232 <= codePoint && codePoint <= 127242 || 127248 <= codePoint && codePoint <= 127277 || 127280 <= codePoint && codePoint <= 127337 || 127344 <= codePoint && codePoint <= 127386 || 917760 <= codePoint && codePoint <= 917999 || 983040 <= codePoint && codePoint <= 1048573 || 1048576 <= codePoint && codePoint <= 1114109) {
        return "A";
      }
      return "N";
    };
    eaw.characterLength = function(character) {
      var code = this.eastAsianWidth(character);
      if (code == "F" || code == "W" || code == "A") {
        return 2;
      } else {
        return 1;
      }
    };
    function stringToArray(string2) {
      return string2.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]|[^\uD800-\uDFFF]/g) || [];
    }
    eaw.length = function(string2) {
      var characters = stringToArray(string2);
      var len = 0;
      for (var i = 0;i < characters.length; i++) {
        len = len + this.characterLength(characters[i]);
      }
      return len;
    };
    eaw.slice = function(text22, start, end) {
      textLen = eaw.length(text22);
      start = start ? start : 0;
      end = end ? end : 1;
      if (start < 0) {
        start = textLen + start;
      }
      if (end < 0) {
        end = textLen + end;
      }
      var result2 = "";
      var eawLen = 0;
      var chars = stringToArray(text22);
      for (var i = 0;i < chars.length; i++) {
        var char = chars[i];
        var charLen = eaw.length(char);
        if (eawLen >= start - (charLen == 2 ? 1 : 0)) {
          if (eawLen + charLen <= end) {
            result2 += char;
          } else {
            break;
          }
        }
        eawLen += charLen;
      }
      return result2;
    };
  })(eastasianwidth2);
  eastasianwidthExports2 = eastasianwidth2.exports;
  eastAsianWidth3 = /* @__PURE__ */ getDefaultExportFromCjs2(eastasianwidthExports2);
  TYPE_COLOR_MAP2 = {
    info: "cyan",
    fail: "red",
    success: "green",
    ready: "green",
    start: "magenta"
  };
  LEVEL_COLOR_MAP2 = {
    0: "red",
    1: "yellow"
  };
  unicode22 = isUnicodeSupported4();
  TYPE_ICONS2 = {
    error: s22("\u2716", "\xD7"),
    fatal: s22("\u2716", "\xD7"),
    ready: s22("\u2714", "\u221A"),
    warn: s22("\u26A0", "\u203C"),
    info: s22("\u2139", "i"),
    success: s22("\u2714", "\u221A"),
    debug: s22("\u2699", "D"),
    trace: s22("\u2192", "\u2192"),
    fail: s22("\u2716", "\xD7"),
    start: s22("\u25D0", "o"),
    log: ""
  };
  FancyReporter2 = class FancyReporter3 extends BasicReporter2 {
    formatStack(stack) {
      return "\n" + parseStack2(stack).map((line) => "  " + line.replace(/^at +/, (m22) => colors2.gray(m22)).replace(/\((.+)\)/, (_22, m22) => `(${colors2.cyan(m22)})`)).join("\n");
    }
    formatType(logObj, isBadge, opts) {
      const typeColor = TYPE_COLOR_MAP2[logObj.type] || LEVEL_COLOR_MAP2[logObj.level] || "gray";
      if (isBadge) {
        return getBgColor2(typeColor)(colors2.black(` ${logObj.type.toUpperCase()} `));
      }
      const _type = typeof TYPE_ICONS2[logObj.type] === "string" ? TYPE_ICONS2[logObj.type] : logObj.icon || logObj.type;
      return _type ? getColor22(typeColor)(_type) : "";
    }
    formatLogObj(logObj, opts) {
      const [message, ...additional] = this.formatArgs(logObj.args, opts).split("\n");
      if (logObj.type === "box") {
        return box2(characterFormat2(message + (additional.length > 0 ? "\n" + additional.join("\n") : "")), {
          title: logObj.title ? characterFormat2(logObj.title) : undefined,
          style: logObj.style
        });
      }
      const date = this.formatDate(logObj.date, opts);
      const coloredDate = date && colors2.gray(date);
      const isBadge = logObj.badge ?? logObj.level < 2;
      const type = this.formatType(logObj, isBadge, opts);
      const tag = logObj.tag ? colors2.gray(logObj.tag) : "";
      let line;
      const left = this.filterAndJoin([type, characterFormat2(message)]);
      const right = this.filterAndJoin(opts.columns ? [tag, coloredDate] : [tag]);
      const space = (opts.columns || 0) - stringWidth3(left) - stringWidth3(right) - 2;
      line = space > 0 && (opts.columns || 0) >= 80 ? left + " ".repeat(space) + right : (right ? `${colors2.gray(`[${right}]`)} ` : "") + left;
      line += characterFormat2(additional.length > 0 ? "\n" + additional.join("\n") : "");
      if (logObj.type === "trace") {
        const _err = new Error("Trace: " + logObj.message);
        line += this.formatStack(_err.stack || "");
      }
      return isBadge ? "\n" + line + "\n" : line;
    }
  };
  consola2 = createConsola22();
});
var init_dist2 = __esm2(() => {
  init_consola_36c0034f2();
  init_core2();
  init_consola_06ad8a642();
  init_utils3();
});
function logLevel2() {
  const verboseRegex = /--verbose(?!\s*=\s*false|\s+false)(?:\s+|=true)?(?:$|\s)/;
  const opts = buddyOptions2();
  if (verboseRegex.test(opts))
    return 4;
  return 3;
}
var logger2;
var log2;
var init_src8 = __esm2(() => {
  init_src10();
  init_src7();
  init_src2();
  init_dist2();
  logger2 = {
    ...createConsola22({
      level: logLevel2()
    }),
    warning: (message) => console.warn(message),
    dump: (...args) => console.log(...args),
    dd: (...args) => {
      console.log(...args);
      process42.exit(1);
    },
    echo: (message) => console.log(message)
  };
  log2 = {
    info: async (message, options22) => {
      if (options22?.styled === false)
        console.log(message);
      else
        logger2.info(message);
      await writeToLogFile2(`INFO: ${stripAnsi4(message)}`);
    },
    success: async (message, options22) => {
      if (options22?.styled === false)
        console.log(message);
      else
        logger2.success(message);
      await writeToLogFile2(`SUCCESS: ${stripAnsi4(message)}`);
    },
    warn: async (message, options22) => {
      if (options22?.styled === false)
        console.log(message);
      else
        logger2.warn(message);
      await writeToLogFile2(`WARN: ${stripAnsi4(message)}`);
    },
    warning: async (message, options22) => {
      if (options22?.styled === false)
        console.log(message);
      else
        logger2.warn(message);
      await writeToLogFile2(`WARN: ${stripAnsi4(message)}`);
    },
    error: async (err22, options22) => {
      handleError2(err22, options22);
    },
    debug: async (...args) => {
      const formattedArgs = args.map((arg) => typeof arg === "object" ? JSON.stringify(arg, null, 2) : arg);
      const message = `DEBUG: ${formattedArgs.join(" ")}`;
      if (process42.env.APP_ENV === "production" || process42.env.APP_ENV === "prod")
        return writeToLogFile2(message);
      logger2.debug(message);
      await writeToLogFile2(stripAnsi4(message));
    },
    dump: (...args) => args.forEach((arg) => console.log(arg)),
    dd: (...args) => {
      args.forEach((arg) => console.log(arg));
      process42.exit(1);
    },
    echo: (...args) => console.log(...args)
  };
});
var require_kleur2 = __commonJS2((exports, module) => {
  var { FORCE_COLOR, NODE_DISABLE_COLORS, TERM } = process.env;
  var $22 = {
    enabled: !NODE_DISABLE_COLORS && TERM !== "dumb" && FORCE_COLOR !== "0",
    reset: init22(0, 0),
    bold: init22(1, 22),
    dim: init22(2, 22),
    italic: init22(3, 23),
    underline: init22(4, 24),
    inverse: init22(7, 27),
    hidden: init22(8, 28),
    strikethrough: init22(9, 29),
    black: init22(30, 39),
    red: init22(31, 39),
    green: init22(32, 39),
    yellow: init22(33, 39),
    blue: init22(34, 39),
    magenta: init22(35, 39),
    cyan: init22(36, 39),
    white: init22(37, 39),
    gray: init22(90, 39),
    grey: init22(90, 39),
    bgBlack: init22(40, 49),
    bgRed: init22(41, 49),
    bgGreen: init22(42, 49),
    bgYellow: init22(43, 49),
    bgBlue: init22(44, 49),
    bgMagenta: init22(45, 49),
    bgCyan: init22(46, 49),
    bgWhite: init22(47, 49)
  };
  function run(arr, str) {
    let i = 0, tmp, beg = "", end = "";
    for (;i < arr.length; i++) {
      tmp = arr[i];
      beg += tmp.open;
      end += tmp.close;
      if (str.includes(tmp.close)) {
        str = str.replace(tmp.rgx, tmp.close + tmp.open);
      }
    }
    return beg + str + end;
  }
  function chain(has, keys) {
    let ctx = { has, keys };
    ctx.reset = $22.reset.bind(ctx);
    ctx.bold = $22.bold.bind(ctx);
    ctx.dim = $22.dim.bind(ctx);
    ctx.italic = $22.italic.bind(ctx);
    ctx.underline = $22.underline.bind(ctx);
    ctx.inverse = $22.inverse.bind(ctx);
    ctx.hidden = $22.hidden.bind(ctx);
    ctx.strikethrough = $22.strikethrough.bind(ctx);
    ctx.black = $22.black.bind(ctx);
    ctx.red = $22.red.bind(ctx);
    ctx.green = $22.green.bind(ctx);
    ctx.yellow = $22.yellow.bind(ctx);
    ctx.blue = $22.blue.bind(ctx);
    ctx.magenta = $22.magenta.bind(ctx);
    ctx.cyan = $22.cyan.bind(ctx);
    ctx.white = $22.white.bind(ctx);
    ctx.gray = $22.gray.bind(ctx);
    ctx.grey = $22.grey.bind(ctx);
    ctx.bgBlack = $22.bgBlack.bind(ctx);
    ctx.bgRed = $22.bgRed.bind(ctx);
    ctx.bgGreen = $22.bgGreen.bind(ctx);
    ctx.bgYellow = $22.bgYellow.bind(ctx);
    ctx.bgBlue = $22.bgBlue.bind(ctx);
    ctx.bgMagenta = $22.bgMagenta.bind(ctx);
    ctx.bgCyan = $22.bgCyan.bind(ctx);
    ctx.bgWhite = $22.bgWhite.bind(ctx);
    return ctx;
  }
  function init22(open, close) {
    let blk = {
      open: `\x1B[${open}m`,
      close: `\x1B[${close}m`,
      rgx: new RegExp(`\\x1b\\[${close}m`, "g")
    };
    return function(txt) {
      if (this !== undefined && this.has !== undefined) {
        this.has.includes(open) || (this.has.push(open), this.keys.push(blk));
        return txt === undefined ? this : $22.enabled ? run(this.keys, txt + "") : txt + "";
      }
      return txt === undefined ? chain([open], [blk]) : $22.enabled ? run([blk], txt + "") : txt + "";
    };
  }
  module.exports = $22;
});
var require_action3 = __commonJS2((exports, module) => {
  module.exports = (key, isSelect) => {
    if (key.meta && key.name !== "escape")
      return;
    if (key.ctrl) {
      if (key.name === "a")
        return "first";
      if (key.name === "c")
        return "abort";
      if (key.name === "d")
        return "abort";
      if (key.name === "e")
        return "last";
      if (key.name === "g")
        return "reset";
    }
    if (isSelect) {
      if (key.name === "j")
        return "down";
      if (key.name === "k")
        return "up";
    }
    if (key.name === "return")
      return "submit";
    if (key.name === "enter")
      return "submit";
    if (key.name === "backspace")
      return "delete";
    if (key.name === "delete")
      return "deleteForward";
    if (key.name === "abort")
      return "abort";
    if (key.name === "escape")
      return "exit";
    if (key.name === "tab")
      return "next";
    if (key.name === "pagedown")
      return "nextPage";
    if (key.name === "pageup")
      return "prevPage";
    if (key.name === "home")
      return "home";
    if (key.name === "end")
      return "end";
    if (key.name === "up")
      return "up";
    if (key.name === "down")
      return "down";
    if (key.name === "right")
      return "right";
    if (key.name === "left")
      return "left";
    return false;
  };
});
var require_strip3 = __commonJS2((exports, module) => {
  module.exports = (str) => {
    const pattern = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PRZcf-ntqry=><~]))"].join("|");
    const RGX = new RegExp(pattern, "g");
    return typeof str === "string" ? str.replace(RGX, "") : str;
  };
});
var require_src2 = __commonJS2((exports, module) => {
  var ESC22 = "\x1B";
  var CSI22 = `${ESC22}[`;
  var beep22 = "\x07";
  var cursor22 = {
    to(x, y) {
      if (!y)
        return `${CSI22}${x + 1}G`;
      return `${CSI22}${y + 1};${x + 1}H`;
    },
    move(x, y) {
      let ret = "";
      if (x < 0)
        ret += `${CSI22}${-x}D`;
      else if (x > 0)
        ret += `${CSI22}${x}C`;
      if (y < 0)
        ret += `${CSI22}${-y}A`;
      else if (y > 0)
        ret += `${CSI22}${y}B`;
      return ret;
    },
    up: (count = 1) => `${CSI22}${count}A`,
    down: (count = 1) => `${CSI22}${count}B`,
    forward: (count = 1) => `${CSI22}${count}C`,
    backward: (count = 1) => `${CSI22}${count}D`,
    nextLine: (count = 1) => `${CSI22}E`.repeat(count),
    prevLine: (count = 1) => `${CSI22}F`.repeat(count),
    left: `${CSI22}G`,
    hide: `${CSI22}?25l`,
    show: `${CSI22}?25h`,
    save: `${ESC22}7`,
    restore: `${ESC22}8`
  };
  var scroll22 = {
    up: (count = 1) => `${CSI22}S`.repeat(count),
    down: (count = 1) => `${CSI22}T`.repeat(count)
  };
  var erase22 = {
    screen: `${CSI22}2J`,
    up: (count = 1) => `${CSI22}1J`.repeat(count),
    down: (count = 1) => `${CSI22}J`.repeat(count),
    line: `${CSI22}2K`,
    lineEnd: `${CSI22}K`,
    lineStart: `${CSI22}1K`,
    lines(count) {
      let clear = "";
      for (let i = 0;i < count; i++)
        clear += this.line + (i < count - 1 ? cursor22.up() : "");
      if (count)
        clear += cursor22.left;
      return clear;
    }
  };
  module.exports = { cursor: cursor22, scroll: scroll22, erase: erase22, beep: beep22 };
});
var require_clear3 = __commonJS2((exports, module) => {
  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it)
          o = it;
        var i = 0;
        var F = function F() {
        };
        return { s: F, n: function n() {
          if (i >= o.length)
            return { done: true };
          return { done: false, value: o[i++] };
        }, e: function e(_e) {
          throw _e;
        }, f: F };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true, didErr = false, err22;
    return { s: function s() {
      it = it.call(o);
    }, n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    }, e: function e(_e2) {
      didErr = true;
      err22 = _e2;
    }, f: function f() {
      try {
        if (!normalCompletion && it.return != null)
          it.return();
      } finally {
        if (didErr)
          throw err22;
      }
    } };
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o)
      return;
    if (typeof o === "string")
      return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor)
      n = o.constructor.name;
    if (n === "Map" || n === "Set")
      return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i = 0, arr2 = new Array(len);i < len; i++)
      arr2[i] = arr[i];
    return arr2;
  }
  var strip = require_strip3();
  var _require = require_src2();
  var erase22 = _require.erase;
  var cursor22 = _require.cursor;
  var width = (str) => [...strip(str)].length;
  module.exports = function(prompt22, perLine) {
    if (!perLine)
      return erase22.line + cursor22.to(0);
    let rows = 0;
    const lines = prompt22.split(/\r?\n/);
    var _iterator = _createForOfIteratorHelper(lines), _step;
    try {
      for (_iterator.s();!(_step = _iterator.n()).done; ) {
        let line = _step.value;
        rows += 1 + Math.floor(Math.max(width(line) - 1, 0) / perLine);
      }
    } catch (err22) {
      _iterator.e(err22);
    } finally {
      _iterator.f();
    }
    return erase22.lines(rows);
  };
});
var require_figures3 = __commonJS2((exports, module) => {
  var main2 = {
    arrowUp: "\u2191",
    arrowDown: "\u2193",
    arrowLeft: "\u2190",
    arrowRight: "\u2192",
    radioOn: "\u25C9",
    radioOff: "\u25EF",
    tick: "\u2714",
    cross: "\u2716",
    ellipsis: "\u2026",
    pointerSmall: "\u203A",
    line: "\u2500",
    pointer: "\u276F"
  };
  var win = {
    arrowUp: main2.arrowUp,
    arrowDown: main2.arrowDown,
    arrowLeft: main2.arrowLeft,
    arrowRight: main2.arrowRight,
    radioOn: "(*)",
    radioOff: "( )",
    tick: "\u221A",
    cross: "\xD7",
    ellipsis: "...",
    pointerSmall: "\xBB",
    line: "\u2500",
    pointer: ">"
  };
  var figures = process.platform === "win32" ? win : main2;
  module.exports = figures;
});
var require_style3 = __commonJS2((exports, module) => {
  var c22 = require_kleur2();
  var figures = require_figures3();
  var styles3 = Object.freeze({
    password: {
      scale: 1,
      render: (input) => "*".repeat(input.length)
    },
    emoji: {
      scale: 2,
      render: (input) => "\uD83D\uDE03".repeat(input.length)
    },
    invisible: {
      scale: 0,
      render: (input) => ""
    },
    default: {
      scale: 1,
      render: (input) => `${input}`
    }
  });
  var render = (type) => styles3[type] || styles3.default;
  var symbols = Object.freeze({
    aborted: c22.red(figures.cross),
    done: c22.green(figures.tick),
    exited: c22.yellow(figures.cross),
    default: c22.cyan("?")
  });
  var symbol22 = (done, aborted, exited) => aborted ? symbols.aborted : exited ? symbols.exited : done ? symbols.done : symbols.default;
  var delimiter3 = (completing) => c22.gray(completing ? figures.ellipsis : figures.pointerSmall);
  var item = (expandable, expanded) => c22.gray(expandable ? expanded ? figures.pointerSmall : "+" : figures.line);
  module.exports = {
    styles: styles3,
    render,
    symbols,
    symbol: symbol22,
    delimiter: delimiter3,
    item
  };
});
var require_lines3 = __commonJS2((exports, module) => {
  var strip = require_strip3();
  module.exports = function(msg, perLine) {
    let lines = String(strip(msg) || "").split(/\r?\n/);
    if (!perLine)
      return lines.length;
    return lines.map((l22) => Math.ceil(l22.length / perLine)).reduce((a, b22) => a + b22);
  };
});
var require_wrap3 = __commonJS2((exports, module) => {
  module.exports = (msg, opts = {}) => {
    const tab = Number.isSafeInteger(parseInt(opts.margin)) ? new Array(parseInt(opts.margin)).fill(" ").join("") : opts.margin || "";
    const width = opts.width;
    return (msg || "").split(/\r?\n/g).map((line) => line.split(/\s+/g).reduce((arr, w22) => {
      if (w22.length + tab.length >= width || arr[arr.length - 1].length + w22.length + 1 < width)
        arr[arr.length - 1] += ` ${w22}`;
      else
        arr.push(`${tab}${w22}`);
      return arr;
    }, [tab]).join("\n")).join("\n");
  };
});
var require_entriesToDisplay3 = __commonJS2((exports, module) => {
  module.exports = (cursor22, total, maxVisible) => {
    maxVisible = maxVisible || total;
    let startIndex = Math.min(total - maxVisible, cursor22 - Math.floor(maxVisible / 2));
    if (startIndex < 0)
      startIndex = 0;
    let endIndex = Math.min(startIndex + maxVisible, total);
    return {
      startIndex,
      endIndex
    };
  };
});
var require_util3 = __commonJS2((exports, module) => {
  module.exports = {
    action: require_action3(),
    clear: require_clear3(),
    style: require_style3(),
    strip: require_strip3(),
    figures: require_figures3(),
    lines: require_lines3(),
    wrap: require_wrap3(),
    entriesToDisplay: require_entriesToDisplay3()
  };
});
var require_prompt3 = __commonJS2((exports, module) => {
  var readline = import.meta.require("readline");
  var _require = require_util3();
  var action = _require.action;
  var EventEmitter3 = import.meta.require("events");
  var _require2 = require_src2();
  var beep22 = _require2.beep;
  var cursor22 = _require2.cursor;
  var color = require_kleur2();

  class Prompt extends EventEmitter3 {
    constructor(opts = {}) {
      super();
      this.firstRender = true;
      this.in = opts.stdin || process.stdin;
      this.out = opts.stdout || process.stdout;
      this.onRender = (opts.onRender || (() => {
        return;
      })).bind(this);
      const rl = readline.createInterface({
        input: this.in,
        escapeCodeTimeout: 50
      });
      readline.emitKeypressEvents(this.in, rl);
      if (this.in.isTTY)
        this.in.setRawMode(true);
      const isSelect = ["SelectPrompt", "MultiselectPrompt"].indexOf(this.constructor.name) > -1;
      const keypress = (str, key) => {
        let a = action(key, isSelect);
        if (a === false) {
          this._ && this._(str, key);
        } else if (typeof this[a] === "function") {
          this[a](key);
        } else {
          this.bell();
        }
      };
      this.close = () => {
        this.out.write(cursor22.show);
        this.in.removeListener("keypress", keypress);
        if (this.in.isTTY)
          this.in.setRawMode(false);
        rl.close();
        this.emit(this.aborted ? "abort" : this.exited ? "exit" : "submit", this.value);
        this.closed = true;
      };
      this.in.on("keypress", keypress);
    }
    fire() {
      this.emit("state", {
        value: this.value,
        aborted: !!this.aborted,
        exited: !!this.exited
      });
    }
    bell() {
      this.out.write(beep22);
    }
    render() {
      this.onRender(color);
      if (this.firstRender)
        this.firstRender = false;
    }
  }
  module.exports = Prompt;
});
var require_text3 = __commonJS2((exports, module) => {
  function asyncGeneratorStep(gen, resolve4, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve4(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve4, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur2();
  var Prompt = require_prompt3();
  var _require = require_src2();
  var erase22 = _require.erase;
  var cursor22 = _require.cursor;
  var _require2 = require_util3();
  var style = _require2.style;
  var clear = _require2.clear;
  var lines = _require2.lines;
  var figures = _require2.figures;

  class TextPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.msg = opts.message;
      this.initial = opts.initial || ``;
      this.validator = opts.validate || (() => true);
      this.value = ``;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.clear = clear(``, this.out.columns);
      this.render();
    }
    set value(v22) {
      if (!v22 && this.initial) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(this.initial));
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(v22);
      }
      this._value = v22;
      this.fire();
    }
    get value() {
      return this._value;
    }
    reset() {
      this.value = ``;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.value = this.value || this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.red = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === `string`) {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        _this2.value = _this2.value || _this2.initial;
        _this2.cursorOffset = 0;
        _this2.cursor = _this2.rendered.length;
        yield _this2.validate();
        if (_this2.error) {
          _this2.red = true;
          _this2.fire();
          _this2.render();
          return;
        }
        _this2.done = true;
        _this2.aborted = false;
        _this2.fire();
        _this2.render();
        _this2.out.write("\n");
        _this2.close();
      })();
    }
    next() {
      if (!this.placeholder)
        return this.bell();
      this.value = this.initial;
      this.cursor = this.rendered.length;
      this.fire();
      this.render();
    }
    moveCursor(n) {
      if (this.placeholder)
        return;
      this.cursor = this.cursor + n;
      this.cursorOffset += n;
    }
    _(c22, key) {
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${c22}${s222}`;
      this.red = false;
      this.cursor = this.placeholder ? 0 : s1.length + 1;
      this.render();
    }
    delete() {
      if (this.isCursorAtStart())
        return this.bell();
      let s1 = this.value.slice(0, this.cursor - 1);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtStart()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
        this.moveCursor(-1);
      }
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor + 1);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtEnd()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
      }
      this.render();
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length;
      this.render();
    }
    left() {
      if (this.cursor <= 0 || this.placeholder)
        return this.bell();
      this.moveCursor(-1);
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      this.moveCursor(1);
      this.render();
    }
    isCursorAtStart() {
      return this.cursor === 0 || this.placeholder && this.cursor === 1;
    }
    isCursorAtEnd() {
      return this.cursor === this.rendered.length || this.placeholder && this.cursor === this.rendered.length + 1;
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.red ? color.red(this.rendered) : this.rendered].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l22, i) => a + `\n${i ? " " : figures.pointerSmall} ${color.red().italic(l22)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore + cursor22.move(this.cursorOffset, 0));
    }
  }
  module.exports = TextPrompt;
});
var require_select3 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt3();
  var _require = require_util3();
  var style = _require.style;
  var clear = _require.clear;
  var figures = _require.figures;
  var wrap = _require.wrap;
  var entriesToDisplay = _require.entriesToDisplay;
  var _require2 = require_src2();
  var cursor22 = _require2.cursor;

  class SelectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.hint = opts.hint || "- Use arrow-keys. Return to submit.";
      this.warn = opts.warn || "- This option is disabled";
      this.cursor = opts.initial || 0;
      this.choices = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = {
            title: ch,
            value: idx
          };
        return {
          title: ch && (ch.title || ch.value || ch),
          value: ch && (ch.value === undefined ? idx : ch.value),
          description: ch && ch.description,
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = (this.choices[this.cursor] || {}).value;
      this.clear = clear("", this.out.columns);
      this.render();
    }
    moveCursor(n) {
      this.cursor = n;
      this.value = this.choices[n].value;
      this.fire();
    }
    reset() {
      this.moveCursor(0);
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      if (!this.selection.disabled) {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      } else
        this.bell();
    }
    first() {
      this.moveCursor(0);
      this.render();
    }
    last() {
      this.moveCursor(this.choices.length - 1);
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.moveCursor(this.choices.length - 1);
      } else {
        this.moveCursor(this.cursor - 1);
      }
      this.render();
    }
    down() {
      if (this.cursor === this.choices.length - 1) {
        this.moveCursor(0);
      } else {
        this.moveCursor(this.cursor + 1);
      }
      this.render();
    }
    next() {
      this.moveCursor((this.cursor + 1) % this.choices.length);
      this.render();
    }
    _(c22, key) {
      if (c22 === " ")
        return this.submit();
    }
    get selection() {
      return this.choices[this.cursor];
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let _entriesToDisplay = entriesToDisplay(this.cursor, this.choices.length, this.optionsPerPage), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.done ? this.selection.title : this.selection.disabled ? color.yellow(this.warn) : color.gray(this.hint)].join(" ");
      if (!this.done) {
        this.outputText += "\n";
        for (let i = startIndex;i < endIndex; i++) {
          let title, prefix, desc = "", v22 = this.choices[i];
          if (i === startIndex && startIndex > 0) {
            prefix = figures.arrowUp;
          } else if (i === endIndex - 1 && endIndex < this.choices.length) {
            prefix = figures.arrowDown;
          } else {
            prefix = " ";
          }
          if (v22.disabled) {
            title = this.cursor === i ? color.gray().underline(v22.title) : color.strikethrough().gray(v22.title);
            prefix = (this.cursor === i ? color.bold().gray(figures.pointer) + " " : "  ") + prefix;
          } else {
            title = this.cursor === i ? color.cyan().underline(v22.title) : v22.title;
            prefix = (this.cursor === i ? color.cyan(figures.pointer) + " " : "  ") + prefix;
            if (v22.description && this.cursor === i) {
              desc = ` - ${v22.description}`;
              if (prefix.length + title.length + desc.length >= this.out.columns || v22.description.split(/\r?\n/).length > 1) {
                desc = "\n" + wrap(v22.description, {
                  margin: 3,
                  width: this.out.columns
                });
              }
            }
          }
          this.outputText += `${prefix} ${title}${color.gray(desc)}\n`;
        }
      }
      this.out.write(this.outputText);
    }
  }
  module.exports = SelectPrompt;
});
var require_toggle3 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt3();
  var _require = require_util3();
  var style = _require.style;
  var clear = _require.clear;
  var _require2 = require_src2();
  var cursor22 = _require2.cursor;
  var erase22 = _require2.erase;

  class TogglePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = !!opts.initial;
      this.active = opts.active || "on";
      this.inactive = opts.inactive || "off";
      this.initialValue = this.value;
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    deactivate() {
      if (this.value === false)
        return this.bell();
      this.value = false;
      this.render();
    }
    activate() {
      if (this.value === true)
        return this.bell();
      this.value = true;
      this.render();
    }
    delete() {
      this.deactivate();
    }
    left() {
      this.deactivate();
    }
    right() {
      this.activate();
    }
    down() {
      this.deactivate();
    }
    up() {
      this.activate();
    }
    next() {
      this.value = !this.value;
      this.fire();
      this.render();
    }
    _(c22, key) {
      if (c22 === " ") {
        this.value = !this.value;
      } else if (c22 === "1") {
        this.value = true;
      } else if (c22 === "0") {
        this.value = false;
      } else
        return this.bell();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.value ? this.inactive : color.cyan().underline(this.inactive), color.gray("/"), this.value ? color.cyan().underline(this.active) : this.active].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = TogglePrompt;
});
var require_datepart3 = __commonJS2((exports, module) => {

  class DatePart {
    constructor({
      token,
      date,
      parts,
      locales: locales22
    }) {
      this.token = token;
      this.date = date || new Date;
      this.parts = parts || [this];
      this.locales = locales22 || {};
    }
    up() {
    }
    down() {
    }
    next() {
      const currentIdx = this.parts.indexOf(this);
      return this.parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    setTo(val2) {
    }
    prev() {
      let parts = [].concat(this.parts).reverse();
      const currentIdx = parts.indexOf(this);
      return parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    toString() {
      return String(this.date);
    }
  }
  module.exports = DatePart;
});
var require_meridiem3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();

  class Meridiem extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours((this.date.getHours() + 12) % 24);
    }
    down() {
      this.up();
    }
    toString() {
      let meridiem = this.date.getHours() > 12 ? "pm" : "am";
      return /\A/.test(this.token) ? meridiem.toUpperCase() : meridiem;
    }
  }
  module.exports = Meridiem;
});
var require_day3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();
  var pos = (n) => {
    n = n % 10;
    return n === 1 ? "st" : n === 2 ? "nd" : n === 3 ? "rd" : "th";
  };

  class Day extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setDate(this.date.getDate() + 1);
    }
    down() {
      this.date.setDate(this.date.getDate() - 1);
    }
    setTo(val2) {
      this.date.setDate(parseInt(val2.substr(-2)));
    }
    toString() {
      let date = this.date.getDate();
      let day = this.date.getDay();
      return this.token === "DD" ? String(date).padStart(2, "0") : this.token === "Do" ? date + pos(date) : this.token === "d" ? day + 1 : this.token === "ddd" ? this.locales.weekdaysShort[day] : this.token === "dddd" ? this.locales.weekdays[day] : date;
    }
  }
  module.exports = Day;
});
var require_hours3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();

  class Hours extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours(this.date.getHours() + 1);
    }
    down() {
      this.date.setHours(this.date.getHours() - 1);
    }
    setTo(val2) {
      this.date.setHours(parseInt(val2.substr(-2)));
    }
    toString() {
      let hours = this.date.getHours();
      if (/h/.test(this.token))
        hours = hours % 12 || 12;
      return this.token.length > 1 ? String(hours).padStart(2, "0") : hours;
    }
  }
  module.exports = Hours;
});
var require_milliseconds3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();

  class Milliseconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMilliseconds(this.date.getMilliseconds() + 1);
    }
    down() {
      this.date.setMilliseconds(this.date.getMilliseconds() - 1);
    }
    setTo(val2) {
      this.date.setMilliseconds(parseInt(val2.substr(-this.token.length)));
    }
    toString() {
      return String(this.date.getMilliseconds()).padStart(4, "0").substr(0, this.token.length);
    }
  }
  module.exports = Milliseconds;
});
var require_minutes3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();

  class Minutes extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMinutes(this.date.getMinutes() + 1);
    }
    down() {
      this.date.setMinutes(this.date.getMinutes() - 1);
    }
    setTo(val2) {
      this.date.setMinutes(parseInt(val2.substr(-2)));
    }
    toString() {
      let m22 = this.date.getMinutes();
      return this.token.length > 1 ? String(m22).padStart(2, "0") : m22;
    }
  }
  module.exports = Minutes;
});
var require_month3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();

  class Month extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMonth(this.date.getMonth() + 1);
    }
    down() {
      this.date.setMonth(this.date.getMonth() - 1);
    }
    setTo(val2) {
      val2 = parseInt(val2.substr(-2)) - 1;
      this.date.setMonth(val2 < 0 ? 0 : val2);
    }
    toString() {
      let month = this.date.getMonth();
      let tl = this.token.length;
      return tl === 2 ? String(month + 1).padStart(2, "0") : tl === 3 ? this.locales.monthsShort[month] : tl === 4 ? this.locales.months[month] : String(month + 1);
    }
  }
  module.exports = Month;
});
var require_seconds3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();

  class Seconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setSeconds(this.date.getSeconds() + 1);
    }
    down() {
      this.date.setSeconds(this.date.getSeconds() - 1);
    }
    setTo(val2) {
      this.date.setSeconds(parseInt(val2.substr(-2)));
    }
    toString() {
      let s32 = this.date.getSeconds();
      return this.token.length > 1 ? String(s32).padStart(2, "0") : s32;
    }
  }
  module.exports = Seconds;
});
var require_year3 = __commonJS2((exports, module) => {
  var DatePart = require_datepart3();

  class Year extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setFullYear(this.date.getFullYear() + 1);
    }
    down() {
      this.date.setFullYear(this.date.getFullYear() - 1);
    }
    setTo(val2) {
      this.date.setFullYear(val2.substr(-4));
    }
    toString() {
      let year = String(this.date.getFullYear()).padStart(4, "0");
      return this.token.length === 2 ? year.substr(-2) : year;
    }
  }
  module.exports = Year;
});
var require_dateparts3 = __commonJS2((exports, module) => {
  module.exports = {
    DatePart: require_datepart3(),
    Meridiem: require_meridiem3(),
    Day: require_day3(),
    Hours: require_hours3(),
    Milliseconds: require_milliseconds3(),
    Minutes: require_minutes3(),
    Month: require_month3(),
    Seconds: require_seconds3(),
    Year: require_year3()
  };
});
var require_date3 = __commonJS2((exports, module) => {
  function asyncGeneratorStep(gen, resolve4, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve4(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve4, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur2();
  var Prompt = require_prompt3();
  var _require = require_util3();
  var style = _require.style;
  var clear = _require.clear;
  var figures = _require.figures;
  var _require2 = require_src2();
  var erase22 = _require2.erase;
  var cursor22 = _require2.cursor;
  var _require3 = require_dateparts3();
  var DatePart = _require3.DatePart;
  var Meridiem = _require3.Meridiem;
  var Day = _require3.Day;
  var Hours = _require3.Hours;
  var Milliseconds = _require3.Milliseconds;
  var Minutes = _require3.Minutes;
  var Month = _require3.Month;
  var Seconds = _require3.Seconds;
  var Year = _require3.Year;
  var regex22 = /\\(.)|"((?:\\["\\]|[^"])+)"|(D[Do]?|d{3,4}|d)|(M{1,4})|(YY(?:YY)?)|([aA])|([Hh]{1,2})|(m{1,2})|(s{1,2})|(S{1,4})|./g;
  var regexGroups = {
    1: ({
      token
    }) => token.replace(/\\(.)/g, "$1"),
    2: (opts) => new Day(opts),
    3: (opts) => new Month(opts),
    4: (opts) => new Year(opts),
    5: (opts) => new Meridiem(opts),
    6: (opts) => new Hours(opts),
    7: (opts) => new Minutes(opts),
    8: (opts) => new Seconds(opts),
    9: (opts) => new Milliseconds(opts)
  };
  var dfltLocales = {
    months: "January,February,March,April,May,June,July,August,September,October,November,December".split(","),
    monthsShort: "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),
    weekdays: "Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),
    weekdaysShort: "Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(",")
  };

  class DatePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = 0;
      this.typed = "";
      this.locales = Object.assign(dfltLocales, opts.locales);
      this._date = opts.initial || new Date;
      this.errorMsg = opts.error || "Please Enter A Valid Value";
      this.validator = opts.validate || (() => true);
      this.mask = opts.mask || "YYYY-MM-DD HH:mm:ss";
      this.clear = clear("", this.out.columns);
      this.render();
    }
    get value() {
      return this.date;
    }
    get date() {
      return this._date;
    }
    set date(date) {
      if (date)
        this._date.setTime(date.getTime());
    }
    set mask(mask) {
      let result2;
      this.parts = [];
      while (result2 = regex22.exec(mask)) {
        let match = result2.shift();
        let idx = result2.findIndex((gr) => gr != null);
        this.parts.push(idx in regexGroups ? regexGroups[idx]({
          token: result2[idx] || match,
          date: this.date,
          parts: this.parts,
          locales: this.locales
        }) : result2[idx] || match);
      }
      let parts = this.parts.reduce((arr, i) => {
        if (typeof i === "string" && typeof arr[arr.length - 1] === "string")
          arr[arr.length - 1] += i;
        else
          arr.push(i);
        return arr;
      }, []);
      this.parts.splice(0);
      this.parts.push(...parts);
      this.reset();
    }
    moveCursor(n) {
      this.typed = "";
      this.cursor = n;
      this.fire();
    }
    reset() {
      this.moveCursor(this.parts.findIndex((p32) => p32 instanceof DatePart));
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === "string") {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        yield _this2.validate();
        if (_this2.error) {
          _this2.color = "red";
          _this2.fire();
          _this2.render();
          return;
        }
        _this2.done = true;
        _this2.aborted = false;
        _this2.fire();
        _this2.render();
        _this2.out.write("\n");
        _this2.close();
      })();
    }
    up() {
      this.typed = "";
      this.parts[this.cursor].up();
      this.render();
    }
    down() {
      this.typed = "";
      this.parts[this.cursor].down();
      this.render();
    }
    left() {
      let prev = this.parts[this.cursor].prev();
      if (prev == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(prev));
      this.render();
    }
    right() {
      let next = this.parts[this.cursor].next();
      if (next == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(next));
      this.render();
    }
    next() {
      let next = this.parts[this.cursor].next();
      this.moveCursor(next ? this.parts.indexOf(next) : this.parts.findIndex((part) => part instanceof DatePart));
      this.render();
    }
    _(c22) {
      if (/\d/.test(c22)) {
        this.typed += c22;
        this.parts[this.cursor].setTo(this.typed);
        this.render();
      }
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.parts.reduce((arr, p32, idx) => arr.concat(idx === this.cursor && !this.done ? color.cyan().underline(p32.toString()) : p32), []).join("")].join(" ");
      if (this.error) {
        this.outputText += this.errorMsg.split("\n").reduce((a, l22, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l22)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = DatePrompt;
});
var require_number3 = __commonJS2((exports, module) => {
  function asyncGeneratorStep(gen, resolve4, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve4(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve4, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur2();
  var Prompt = require_prompt3();
  var _require = require_src2();
  var cursor22 = _require.cursor;
  var erase22 = _require.erase;
  var _require2 = require_util3();
  var style = _require2.style;
  var figures = _require2.figures;
  var clear = _require2.clear;
  var lines = _require2.lines;
  var isNumber = /[0-9]/;
  var isDef = (any) => any !== undefined;
  var round = (number, precision) => {
    let factor = Math.pow(10, precision);
    return Math.round(number * factor) / factor;
  };

  class NumberPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.msg = opts.message;
      this.initial = isDef(opts.initial) ? opts.initial : "";
      this.float = !!opts.float;
      this.round = opts.round || 2;
      this.inc = opts.increment || 1;
      this.min = isDef(opts.min) ? opts.min : -Infinity;
      this.max = isDef(opts.max) ? opts.max : Infinity;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.validator = opts.validate || (() => true);
      this.color = `cyan`;
      this.value = ``;
      this.typed = ``;
      this.lastHit = 0;
      this.render();
    }
    set value(v22) {
      if (!v22 && v22 !== 0) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(`${this.initial}`));
        this._value = ``;
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(`${round(v22, this.round)}`);
        this._value = round(v22, this.round);
      }
      this.fire();
    }
    get value() {
      return this._value;
    }
    parse(x) {
      return this.float ? parseFloat(x) : parseInt(x);
    }
    valid(c22) {
      return c22 === `-` || c22 === `.` && this.float || isNumber.test(c22);
    }
    reset() {
      this.typed = ``;
      this.value = ``;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      let x = this.value;
      this.value = x !== `` ? x : this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === `string`) {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        yield _this2.validate();
        if (_this2.error) {
          _this2.color = `red`;
          _this2.fire();
          _this2.render();
          return;
        }
        let x = _this2.value;
        _this2.value = x !== `` ? x : _this2.initial;
        _this2.done = true;
        _this2.aborted = false;
        _this2.error = false;
        _this2.fire();
        _this2.render();
        _this2.out.write(`\n`);
        _this2.close();
      })();
    }
    up() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min - this.inc;
      }
      if (this.value >= this.max)
        return this.bell();
      this.value += this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    down() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min + this.inc;
      }
      if (this.value <= this.min)
        return this.bell();
      this.value -= this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    delete() {
      let val2 = this.value.toString();
      if (val2.length === 0)
        return this.bell();
      this.value = this.parse(val2 = val2.slice(0, -1)) || ``;
      if (this.value !== "" && this.value < this.min) {
        this.value = this.min;
      }
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    next() {
      this.value = this.initial;
      this.fire();
      this.render();
    }
    _(c22, key) {
      if (!this.valid(c22))
        return this.bell();
      const now = Date.now();
      if (now - this.lastHit > 1000)
        this.typed = ``;
      this.typed += c22;
      this.lastHit = now;
      this.color = `cyan`;
      if (c22 === `.`)
        return this.fire();
      this.value = Math.min(this.parse(this.typed), this.max);
      if (this.value > this.max)
        this.value = this.max;
      if (this.value < this.min)
        this.value = this.min;
      this.fire();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), !this.done || !this.done && !this.placeholder ? color[this.color]().underline(this.rendered) : this.rendered].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l22, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l22)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore);
    }
  }
  module.exports = NumberPrompt;
});
var require_multiselect3 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var _require = require_src2();
  var cursor22 = _require.cursor;
  var Prompt = require_prompt3();
  var _require2 = require_util3();
  var clear = _require2.clear;
  var figures = _require2.figures;
  var style = _require2.style;
  var wrap = _require2.wrap;
  var entriesToDisplay = _require2.entriesToDisplay;

  class MultiselectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = opts.cursor || 0;
      this.scrollIndex = opts.cursor || 0;
      this.hint = opts.hint || "";
      this.warn = opts.warn || "- This option is disabled -";
      this.minSelected = opts.min;
      this.showMinError = false;
      this.maxChoices = opts.max;
      this.instructions = opts.instructions;
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = {
            title: ch,
            value: idx
          };
        return {
          title: ch && (ch.title || ch.value || ch),
          description: ch && ch.description,
          value: ch && (ch.value === undefined ? idx : ch.value),
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.clear = clear("", this.out.columns);
      if (!opts.overrideRender) {
        this.render();
      }
    }
    reset() {
      this.value.map((v22) => !v22.selected);
      this.cursor = 0;
      this.fire();
      this.render();
    }
    selected() {
      return this.value.filter((v22) => v22.selected);
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      const selected = this.value.filter((e) => e.selected);
      if (this.minSelected && selected.length < this.minSelected) {
        this.showMinError = true;
        this.render();
      } else {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.value.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.value.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.value.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.value[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.value[this.cursor].selected = true;
      this.render();
    }
    handleSpaceToggle() {
      const v22 = this.value[this.cursor];
      if (v22.selected) {
        v22.selected = false;
        this.render();
      } else if (v22.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v22.selected = true;
        this.render();
      }
    }
    toggleAll() {
      if (this.maxChoices !== undefined || this.value[this.cursor].disabled) {
        return this.bell();
      }
      const newSelected = !this.value[this.cursor].selected;
      this.value.filter((v22) => !v22.disabled).forEach((v22) => v22.selected = newSelected);
      this.render();
    }
    _(c22, key) {
      if (c22 === " ") {
        this.handleSpaceToggle();
      } else if (c22 === "a") {
        this.toggleAll();
      } else {
        return this.bell();
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `\nInstructions:\n    ${figures.arrowUp}/${figures.arrowDown}: Highlight option\n    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection\n` + (this.maxChoices === undefined ? `    a: Toggle all\n` : "") + `    enter/return: Complete answer`;
      }
      return "";
    }
    renderOption(cursor3, v22, i, arrowIndicator) {
      const prefix = (v22.selected ? color.green(figures.radioOn) : figures.radioOff) + " " + arrowIndicator + " ";
      let title, desc;
      if (v22.disabled) {
        title = cursor3 === i ? color.gray().underline(v22.title) : color.strikethrough().gray(v22.title);
      } else {
        title = cursor3 === i ? color.cyan().underline(v22.title) : v22.title;
        if (cursor3 === i && v22.description) {
          desc = ` - ${v22.description}`;
          if (prefix.length + title.length + desc.length >= this.out.columns || v22.description.split(/\r?\n/).length > 1) {
            desc = "\n" + wrap(v22.description, {
              margin: prefix.length,
              width: this.out.columns
            });
          }
        }
      }
      return prefix + title + color.gray(desc || "");
    }
    paginateOptions(options22) {
      if (options22.length === 0) {
        return color.red("No matches for this query.");
      }
      let _entriesToDisplay = entriesToDisplay(this.cursor, options22.length, this.optionsPerPage), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      let prefix, styledOptions = [];
      for (let i = startIndex;i < endIndex; i++) {
        if (i === startIndex && startIndex > 0) {
          prefix = figures.arrowUp;
        } else if (i === endIndex - 1 && endIndex < options22.length) {
          prefix = figures.arrowDown;
        } else {
          prefix = " ";
        }
        styledOptions.push(this.renderOption(this.cursor, options22[i], i, prefix));
      }
      return "\n" + styledOptions.join("\n");
    }
    renderOptions(options22) {
      if (!this.done) {
        return this.paginateOptions(options22);
      }
      return "";
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v22) => v22.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions()];
      if (this.value[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.renderDoneOrInstructions()].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.value);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = MultiselectPrompt;
});
var require_autocomplete3 = __commonJS2((exports, module) => {
  function asyncGeneratorStep(gen, resolve4, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve4(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve4, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur2();
  var Prompt = require_prompt3();
  var _require = require_src2();
  var erase22 = _require.erase;
  var cursor22 = _require.cursor;
  var _require2 = require_util3();
  var style = _require2.style;
  var clear = _require2.clear;
  var figures = _require2.figures;
  var wrap = _require2.wrap;
  var entriesToDisplay = _require2.entriesToDisplay;
  var getVal = (arr, i) => arr[i] && (arr[i].value || arr[i].title || arr[i]);
  var getTitle = (arr, i) => arr[i] && (arr[i].title || arr[i].value || arr[i]);
  var getIndex = (arr, valOrTitle) => {
    const index = arr.findIndex((el) => el.value === valOrTitle || el.title === valOrTitle);
    return index > -1 ? index : undefined;
  };

  class AutocompletePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.suggest = opts.suggest;
      this.choices = opts.choices;
      this.initial = typeof opts.initial === "number" ? opts.initial : getIndex(opts.choices, opts.initial);
      this.select = this.initial || opts.cursor || 0;
      this.i18n = {
        noMatches: opts.noMatches || "no matches found"
      };
      this.fallback = opts.fallback || this.initial;
      this.clearFirst = opts.clearFirst || false;
      this.suggestions = [];
      this.input = "";
      this.limit = opts.limit || 10;
      this.cursor = 0;
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.render = this.render.bind(this);
      this.complete = this.complete.bind(this);
      this.clear = clear("", this.out.columns);
      this.complete(this.render);
      this.render();
    }
    set fallback(fb) {
      this._fb = Number.isSafeInteger(parseInt(fb)) ? parseInt(fb) : fb;
    }
    get fallback() {
      let choice;
      if (typeof this._fb === "number")
        choice = this.choices[this._fb];
      else if (typeof this._fb === "string")
        choice = {
          title: this._fb
        };
      return choice || this._fb || {
        title: this.i18n.noMatches
      };
    }
    moveSelect(i) {
      this.select = i;
      if (this.suggestions.length > 0)
        this.value = getVal(this.suggestions, i);
      else
        this.value = this.fallback.value;
      this.fire();
    }
    complete(cb) {
      var _this = this;
      return _asyncToGenerator(function* () {
        const p32 = _this.completing = _this.suggest(_this.input, _this.choices);
        const suggestions = yield p32;
        if (_this.completing !== p32)
          return;
        _this.suggestions = suggestions.map((s32, i, arr) => ({
          title: getTitle(arr, i),
          value: getVal(arr, i),
          description: s32.description
        }));
        _this.completing = false;
        const l22 = Math.max(suggestions.length - 1, 0);
        _this.moveSelect(Math.min(l22, _this.select));
        cb && cb();
      })();
    }
    reset() {
      this.input = "";
      this.complete(() => {
        this.moveSelect(this.initial !== undefined ? this.initial : 0);
        this.render();
      });
      this.render();
    }
    exit() {
      if (this.clearFirst && this.input.length > 0) {
        this.reset();
      } else {
        this.done = this.exited = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    abort() {
      this.done = this.aborted = true;
      this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c22, key) {
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${c22}${s222}`;
      this.cursor = s1.length + 1;
      this.complete(this.render);
      this.render();
    }
    delete() {
      if (this.cursor === 0)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor - 1);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.cursor = this.cursor - 1;
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor + 1);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.render();
    }
    first() {
      this.moveSelect(0);
      this.render();
    }
    last() {
      this.moveSelect(this.suggestions.length - 1);
      this.render();
    }
    up() {
      if (this.select === 0) {
        this.moveSelect(this.suggestions.length - 1);
      } else {
        this.moveSelect(this.select - 1);
      }
      this.render();
    }
    down() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else {
        this.moveSelect(this.select + 1);
      }
      this.render();
    }
    next() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else
        this.moveSelect(this.select + 1);
      this.render();
    }
    nextPage() {
      this.moveSelect(Math.min(this.select + this.limit, this.suggestions.length - 1));
      this.render();
    }
    prevPage() {
      this.moveSelect(Math.max(this.select - this.limit, 0));
      this.render();
    }
    left() {
      if (this.cursor <= 0)
        return this.bell();
      this.cursor = this.cursor - 1;
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      this.cursor = this.cursor + 1;
      this.render();
    }
    renderOption(v22, hovered, isStart, isEnd) {
      let desc;
      let prefix = isStart ? figures.arrowUp : isEnd ? figures.arrowDown : " ";
      let title = hovered ? color.cyan().underline(v22.title) : v22.title;
      prefix = (hovered ? color.cyan(figures.pointer) + " " : "  ") + prefix;
      if (v22.description) {
        desc = ` - ${v22.description}`;
        if (prefix.length + title.length + desc.length >= this.out.columns || v22.description.split(/\r?\n/).length > 1) {
          desc = "\n" + wrap(v22.description, {
            margin: 3,
            width: this.out.columns
          });
        }
      }
      return prefix + " " + title + color.gray(desc || "");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let _entriesToDisplay = entriesToDisplay(this.select, this.choices.length, this.limit), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      this.outputText = [style.symbol(this.done, this.aborted, this.exited), color.bold(this.msg), style.delimiter(this.completing), this.done && this.suggestions[this.select] ? this.suggestions[this.select].title : this.rendered = this.transform.render(this.input)].join(" ");
      if (!this.done) {
        const suggestions = this.suggestions.slice(startIndex, endIndex).map((item, i) => this.renderOption(item, this.select === i + startIndex, i === 0 && startIndex > 0, i + startIndex === endIndex - 1 && endIndex < this.choices.length)).join("\n");
        this.outputText += `\n` + (suggestions || color.gray(this.fallback.title));
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = AutocompletePrompt;
});
var require_autocompleteMultiselect3 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var _require = require_src2();
  var cursor22 = _require.cursor;
  var MultiselectPrompt = require_multiselect3();
  var _require2 = require_util3();
  var clear = _require2.clear;
  var style = _require2.style;
  var figures = _require2.figures;

  class AutocompleteMultiselectPrompt extends MultiselectPrompt {
    constructor(opts = {}) {
      opts.overrideRender = true;
      super(opts);
      this.inputValue = "";
      this.clear = clear("", this.out.columns);
      this.filteredOptions = this.value;
      this.render();
    }
    last() {
      this.cursor = this.filteredOptions.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.filteredOptions.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.filteredOptions.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.filteredOptions.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.filteredOptions[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.filteredOptions[this.cursor].selected = true;
      this.render();
    }
    delete() {
      if (this.inputValue.length) {
        this.inputValue = this.inputValue.substr(0, this.inputValue.length - 1);
        this.updateFilteredOptions();
      }
    }
    updateFilteredOptions() {
      const currentHighlight = this.filteredOptions[this.cursor];
      this.filteredOptions = this.value.filter((v22) => {
        if (this.inputValue) {
          if (typeof v22.title === "string") {
            if (v22.title.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          if (typeof v22.value === "string") {
            if (v22.value.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          return false;
        }
        return true;
      });
      const newHighlightIndex = this.filteredOptions.findIndex((v22) => v22 === currentHighlight);
      this.cursor = newHighlightIndex < 0 ? 0 : newHighlightIndex;
      this.render();
    }
    handleSpaceToggle() {
      const v22 = this.filteredOptions[this.cursor];
      if (v22.selected) {
        v22.selected = false;
        this.render();
      } else if (v22.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v22.selected = true;
        this.render();
      }
    }
    handleInputChange(c22) {
      this.inputValue = this.inputValue + c22;
      this.updateFilteredOptions();
    }
    _(c22, key) {
      if (c22 === " ") {
        this.handleSpaceToggle();
      } else {
        this.handleInputChange(c22);
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `
Instructions:
    ${figures.arrowUp}/${figures.arrowDown}: Highlight option
    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection
    [a,b,c]/delete: Filter choices
    enter/return: Complete answer
`;
      }
      return "";
    }
    renderCurrentInput() {
      return `
Filtered results for: ${this.inputValue ? this.inputValue : color.gray("Enter something to filter")}\n`;
    }
    renderOption(cursor3, v22, i) {
      let title;
      if (v22.disabled)
        title = cursor3 === i ? color.gray().underline(v22.title) : color.strikethrough().gray(v22.title);
      else
        title = cursor3 === i ? color.cyan().underline(v22.title) : v22.title;
      return (v22.selected ? color.green(figures.radioOn) : figures.radioOff) + "  " + title;
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v22) => v22.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions(), this.renderCurrentInput()];
      if (this.filteredOptions.length && this.filteredOptions[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.renderDoneOrInstructions()].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.filteredOptions);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = AutocompleteMultiselectPrompt;
});
var require_confirm3 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt3();
  var _require = require_util3();
  var style = _require.style;
  var clear = _require.clear;
  var _require2 = require_src2();
  var erase22 = _require2.erase;
  var cursor22 = _require2.cursor;

  class ConfirmPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = opts.initial;
      this.initialValue = !!opts.initial;
      this.yesMsg = opts.yes || "yes";
      this.yesOption = opts.yesOption || "(Y/n)";
      this.noMsg = opts.no || "no";
      this.noOption = opts.noOption || "(y/N)";
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.value = this.value || false;
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c22, key) {
      if (c22.toLowerCase() === "y") {
        this.value = true;
        return this.submit();
      }
      if (c22.toLowerCase() === "n") {
        this.value = false;
        return this.submit();
      }
      return this.bell();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.done ? this.value ? this.yesMsg : this.noMsg : color.gray(this.initialValue ? this.yesOption : this.noOption)].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = ConfirmPrompt;
});
var require_elements3 = __commonJS2((exports, module) => {
  module.exports = {
    TextPrompt: require_text3(),
    SelectPrompt: require_select3(),
    TogglePrompt: require_toggle3(),
    DatePrompt: require_date3(),
    NumberPrompt: require_number3(),
    MultiselectPrompt: require_multiselect3(),
    AutocompletePrompt: require_autocomplete3(),
    AutocompleteMultiselectPrompt: require_autocompleteMultiselect3(),
    ConfirmPrompt: require_confirm3()
  };
});
var require_prompts4 = __commonJS2((exports) => {
  var $22 = exports;
  var el = require_elements3();
  var noop = (v22) => v22;
  function toPrompt(type, args, opts = {}) {
    return new Promise((res, rej) => {
      const p32 = new el[type](args);
      const onAbort = opts.onAbort || noop;
      const onSubmit = opts.onSubmit || noop;
      const onExit2 = opts.onExit || noop;
      p32.on("state", args.onState || noop);
      p32.on("submit", (x) => res(onSubmit(x)));
      p32.on("exit", (x) => res(onExit2(x)));
      p32.on("abort", (x) => rej(onAbort(x)));
    });
  }
  $22.text = (args) => toPrompt("TextPrompt", args);
  $22.password = (args) => {
    args.style = "password";
    return $22.text(args);
  };
  $22.invisible = (args) => {
    args.style = "invisible";
    return $22.text(args);
  };
  $22.number = (args) => toPrompt("NumberPrompt", args);
  $22.date = (args) => toPrompt("DatePrompt", args);
  $22.confirm = (args) => toPrompt("ConfirmPrompt", args);
  $22.list = (args) => {
    const sep23 = args.separator || ",";
    return toPrompt("TextPrompt", args, {
      onSubmit: (str) => str.split(sep23).map((s32) => s32.trim())
    });
  };
  $22.toggle = (args) => toPrompt("TogglePrompt", args);
  $22.select = (args) => toPrompt("SelectPrompt", args);
  $22.multiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("MultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  $22.autocompleteMultiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("AutocompleteMultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  var byTitle = (input, choices) => Promise.resolve(choices.filter((item) => item.title.slice(0, input.length).toLowerCase() === input.toLowerCase()));
  $22.autocomplete = (args) => {
    args.suggest = args.suggest || byTitle;
    args.choices = [].concat(args.choices || []);
    return toPrompt("AutocompletePrompt", args);
  };
});
var require_dist2 = __commonJS2((exports, module) => {
  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) {
        symbols = symbols.filter(function(sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }
      keys.push.apply(keys, symbols);
    }
    return keys;
  }
  function _objectSpread(target) {
    for (var i = 1;i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      if (i % 2) {
        ownKeys(Object(source), true).forEach(function(key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function(key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }
    return target;
  }
  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }
    return obj;
  }
  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it)
          o = it;
        var i = 0;
        var F = function F() {
        };
        return { s: F, n: function n() {
          if (i >= o.length)
            return { done: true };
          return { done: false, value: o[i++] };
        }, e: function e(_e) {
          throw _e;
        }, f: F };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true, didErr = false, err22;
    return { s: function s() {
      it = it.call(o);
    }, n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    }, e: function e(_e2) {
      didErr = true;
      err22 = _e2;
    }, f: function f() {
      try {
        if (!normalCompletion && it.return != null)
          it.return();
      } finally {
        if (didErr)
          throw err22;
      }
    } };
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o)
      return;
    if (typeof o === "string")
      return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor)
      n = o.constructor.name;
    if (n === "Map" || n === "Set")
      return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i = 0, arr2 = new Array(len);i < len; i++)
      arr2[i] = arr[i];
    return arr2;
  }
  function asyncGeneratorStep(gen, resolve4, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve4(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve4, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve4, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var prompts = require_prompts4();
  var passOn = ["suggest", "format", "onState", "validate", "onRender", "type"];
  var noop = () => {
  };
  function prompt22() {
    return _prompt.apply(this, arguments);
  }
  function _prompt() {
    _prompt = _asyncToGenerator(function* (questions = [], {
      onSubmit = noop,
      onCancel = noop
    } = {}) {
      const answers = {};
      const override2 = prompt22._override || {};
      questions = [].concat(questions);
      let answer, question, quit, name, type, lastPrompt;
      const getFormattedAnswer = /* @__PURE__ */ function() {
        var _ref = _asyncToGenerator(function* (question2, answer2, skipValidation = false) {
          if (!skipValidation && question2.validate && question2.validate(answer2) !== true) {
            return;
          }
          return question2.format ? yield question2.format(answer2, answers) : answer2;
        });
        return function getFormattedAnswer(_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }();
      var _iterator = _createForOfIteratorHelper(questions), _step;
      try {
        for (_iterator.s();!(_step = _iterator.n()).done; ) {
          question = _step.value;
          var _question = question;
          name = _question.name;
          type = _question.type;
          if (typeof type === "function") {
            type = yield type(answer, _objectSpread({}, answers), question);
            question["type"] = type;
          }
          if (!type)
            continue;
          for (let key in question) {
            if (passOn.includes(key))
              continue;
            let value = question[key];
            question[key] = typeof value === "function" ? yield value(answer, _objectSpread({}, answers), lastPrompt) : value;
          }
          lastPrompt = question;
          if (typeof question.message !== "string") {
            throw new Error("prompt message is required");
          }
          var _question2 = question;
          name = _question2.name;
          type = _question2.type;
          if (prompts[type] === undefined) {
            throw new Error(`prompt type (${type}) is not defined`);
          }
          if (override2[question.name] !== undefined) {
            answer = yield getFormattedAnswer(question, override2[question.name]);
            if (answer !== undefined) {
              answers[name] = answer;
              continue;
            }
          }
          try {
            answer = prompt22._injected ? getInjectedAnswer(prompt22._injected, question.initial) : yield prompts[type](question);
            answers[name] = answer = yield getFormattedAnswer(question, answer, true);
            quit = yield onSubmit(question, answer, answers);
          } catch (err22) {
            quit = !(yield onCancel(question, answers));
          }
          if (quit)
            return answers;
        }
      } catch (err22) {
        _iterator.e(err22);
      } finally {
        _iterator.f();
      }
      return answers;
    });
    return _prompt.apply(this, arguments);
  }
  function getInjectedAnswer(injected, deafultValue) {
    const answer = injected.shift();
    if (answer instanceof Error) {
      throw answer;
    }
    return answer === undefined ? deafultValue : answer;
  }
  function inject(answers) {
    prompt22._injected = (prompt22._injected || []).concat(answers);
  }
  function override(answers) {
    prompt22._override = Object.assign({}, answers);
  }
  module.exports = Object.assign(prompt22, {
    prompt: prompt22,
    prompts,
    inject,
    override
  });
});
var require_action22 = __commonJS2((exports, module) => {
  module.exports = (key, isSelect) => {
    if (key.meta && key.name !== "escape")
      return;
    if (key.ctrl) {
      if (key.name === "a")
        return "first";
      if (key.name === "c")
        return "abort";
      if (key.name === "d")
        return "abort";
      if (key.name === "e")
        return "last";
      if (key.name === "g")
        return "reset";
    }
    if (isSelect) {
      if (key.name === "j")
        return "down";
      if (key.name === "k")
        return "up";
    }
    if (key.name === "return")
      return "submit";
    if (key.name === "enter")
      return "submit";
    if (key.name === "backspace")
      return "delete";
    if (key.name === "delete")
      return "deleteForward";
    if (key.name === "abort")
      return "abort";
    if (key.name === "escape")
      return "exit";
    if (key.name === "tab")
      return "next";
    if (key.name === "pagedown")
      return "nextPage";
    if (key.name === "pageup")
      return "prevPage";
    if (key.name === "home")
      return "home";
    if (key.name === "end")
      return "end";
    if (key.name === "up")
      return "up";
    if (key.name === "down")
      return "down";
    if (key.name === "right")
      return "right";
    if (key.name === "left")
      return "left";
    return false;
  };
});
var require_strip22 = __commonJS2((exports, module) => {
  module.exports = (str) => {
    const pattern = [
      "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
      "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PRZcf-ntqry=><~]))"
    ].join("|");
    const RGX = new RegExp(pattern, "g");
    return typeof str === "string" ? str.replace(RGX, "") : str;
  };
});
var require_clear22 = __commonJS2((exports, module) => {
  var strip = require_strip22();
  var { erase: erase22, cursor: cursor22 } = require_src2();
  var width = (str) => [...strip(str)].length;
  module.exports = function(prompt22, perLine) {
    if (!perLine)
      return erase22.line + cursor22.to(0);
    let rows = 0;
    const lines = prompt22.split(/\r?\n/);
    for (let line of lines) {
      rows += 1 + Math.floor(Math.max(width(line) - 1, 0) / perLine);
    }
    return erase22.lines(rows);
  };
});
var require_figures22 = __commonJS2((exports, module) => {
  var main2 = {
    arrowUp: "\u2191",
    arrowDown: "\u2193",
    arrowLeft: "\u2190",
    arrowRight: "\u2192",
    radioOn: "\u25C9",
    radioOff: "\u25EF",
    tick: "\u2714",
    cross: "\u2716",
    ellipsis: "\u2026",
    pointerSmall: "\u203A",
    line: "\u2500",
    pointer: "\u276F"
  };
  var win = {
    arrowUp: main2.arrowUp,
    arrowDown: main2.arrowDown,
    arrowLeft: main2.arrowLeft,
    arrowRight: main2.arrowRight,
    radioOn: "(*)",
    radioOff: "( )",
    tick: "\u221A",
    cross: "\xD7",
    ellipsis: "...",
    pointerSmall: "\xBB",
    line: "\u2500",
    pointer: ">"
  };
  var figures = process.platform === "win32" ? win : main2;
  module.exports = figures;
});
var require_style22 = __commonJS2((exports, module) => {
  var c22 = require_kleur2();
  var figures = require_figures22();
  var styles3 = Object.freeze({
    password: { scale: 1, render: (input) => "*".repeat(input.length) },
    emoji: { scale: 2, render: (input) => "\uD83D\uDE03".repeat(input.length) },
    invisible: { scale: 0, render: (input) => "" },
    default: { scale: 1, render: (input) => `${input}` }
  });
  var render = (type) => styles3[type] || styles3.default;
  var symbols = Object.freeze({
    aborted: c22.red(figures.cross),
    done: c22.green(figures.tick),
    exited: c22.yellow(figures.cross),
    default: c22.cyan("?")
  });
  var symbol22 = (done, aborted, exited) => aborted ? symbols.aborted : exited ? symbols.exited : done ? symbols.done : symbols.default;
  var delimiter3 = (completing) => c22.gray(completing ? figures.ellipsis : figures.pointerSmall);
  var item = (expandable, expanded) => c22.gray(expandable ? expanded ? figures.pointerSmall : "+" : figures.line);
  module.exports = {
    styles: styles3,
    render,
    symbols,
    symbol: symbol22,
    delimiter: delimiter3,
    item
  };
});
var require_lines22 = __commonJS2((exports, module) => {
  var strip = require_strip22();
  module.exports = function(msg, perLine) {
    let lines = String(strip(msg) || "").split(/\r?\n/);
    if (!perLine)
      return lines.length;
    return lines.map((l22) => Math.ceil(l22.length / perLine)).reduce((a, b22) => a + b22);
  };
});
var require_wrap22 = __commonJS2((exports, module) => {
  module.exports = (msg, opts = {}) => {
    const tab = Number.isSafeInteger(parseInt(opts.margin)) ? new Array(parseInt(opts.margin)).fill(" ").join("") : opts.margin || "";
    const width = opts.width;
    return (msg || "").split(/\r?\n/g).map((line) => line.split(/\s+/g).reduce((arr, w22) => {
      if (w22.length + tab.length >= width || arr[arr.length - 1].length + w22.length + 1 < width)
        arr[arr.length - 1] += ` ${w22}`;
      else
        arr.push(`${tab}${w22}`);
      return arr;
    }, [tab]).join("\n")).join("\n");
  };
});
var require_entriesToDisplay22 = __commonJS2((exports, module) => {
  module.exports = (cursor22, total, maxVisible) => {
    maxVisible = maxVisible || total;
    let startIndex = Math.min(total - maxVisible, cursor22 - Math.floor(maxVisible / 2));
    if (startIndex < 0)
      startIndex = 0;
    let endIndex = Math.min(startIndex + maxVisible, total);
    return { startIndex, endIndex };
  };
});
var require_util22 = __commonJS2((exports, module) => {
  module.exports = {
    action: require_action22(),
    clear: require_clear22(),
    style: require_style22(),
    strip: require_strip22(),
    figures: require_figures22(),
    lines: require_lines22(),
    wrap: require_wrap22(),
    entriesToDisplay: require_entriesToDisplay22()
  };
});
var require_prompt22 = __commonJS2((exports, module) => {
  var readline = import.meta.require("readline");
  var { action } = require_util22();
  var EventEmitter3 = import.meta.require("events");
  var { beep: beep22, cursor: cursor22 } = require_src2();
  var color = require_kleur2();

  class Prompt extends EventEmitter3 {
    constructor(opts = {}) {
      super();
      this.firstRender = true;
      this.in = opts.stdin || process.stdin;
      this.out = opts.stdout || process.stdout;
      this.onRender = (opts.onRender || (() => {
        return;
      })).bind(this);
      const rl = readline.createInterface({ input: this.in, escapeCodeTimeout: 50 });
      readline.emitKeypressEvents(this.in, rl);
      if (this.in.isTTY)
        this.in.setRawMode(true);
      const isSelect = ["SelectPrompt", "MultiselectPrompt"].indexOf(this.constructor.name) > -1;
      const keypress = (str, key) => {
        let a = action(key, isSelect);
        if (a === false) {
          this._ && this._(str, key);
        } else if (typeof this[a] === "function") {
          this[a](key);
        } else {
          this.bell();
        }
      };
      this.close = () => {
        this.out.write(cursor22.show);
        this.in.removeListener("keypress", keypress);
        if (this.in.isTTY)
          this.in.setRawMode(false);
        rl.close();
        this.emit(this.aborted ? "abort" : this.exited ? "exit" : "submit", this.value);
        this.closed = true;
      };
      this.in.on("keypress", keypress);
    }
    fire() {
      this.emit("state", {
        value: this.value,
        aborted: !!this.aborted,
        exited: !!this.exited
      });
    }
    bell() {
      this.out.write(beep22);
    }
    render() {
      this.onRender(color);
      if (this.firstRender)
        this.firstRender = false;
    }
  }
  module.exports = Prompt;
});
var require_text22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt22();
  var { erase: erase22, cursor: cursor22 } = require_src2();
  var { style, clear, lines, figures } = require_util22();

  class TextPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.msg = opts.message;
      this.initial = opts.initial || ``;
      this.validator = opts.validate || (() => true);
      this.value = ``;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.clear = clear(``, this.out.columns);
      this.render();
    }
    set value(v22) {
      if (!v22 && this.initial) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(this.initial));
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(v22);
      }
      this._value = v22;
      this.fire();
    }
    get value() {
      return this._value;
    }
    reset() {
      this.value = ``;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.value = this.value || this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.red = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === `string`) {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      this.value = this.value || this.initial;
      this.cursorOffset = 0;
      this.cursor = this.rendered.length;
      await this.validate();
      if (this.error) {
        this.red = true;
        this.fire();
        this.render();
        return;
      }
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    next() {
      if (!this.placeholder)
        return this.bell();
      this.value = this.initial;
      this.cursor = this.rendered.length;
      this.fire();
      this.render();
    }
    moveCursor(n) {
      if (this.placeholder)
        return;
      this.cursor = this.cursor + n;
      this.cursorOffset += n;
    }
    _(c22, key) {
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${c22}${s222}`;
      this.red = false;
      this.cursor = this.placeholder ? 0 : s1.length + 1;
      this.render();
    }
    delete() {
      if (this.isCursorAtStart())
        return this.bell();
      let s1 = this.value.slice(0, this.cursor - 1);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtStart()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
        this.moveCursor(-1);
      }
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor + 1);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtEnd()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
      }
      this.render();
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length;
      this.render();
    }
    left() {
      if (this.cursor <= 0 || this.placeholder)
        return this.bell();
      this.moveCursor(-1);
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      this.moveCursor(1);
      this.render();
    }
    isCursorAtStart() {
      return this.cursor === 0 || this.placeholder && this.cursor === 1;
    }
    isCursorAtEnd() {
      return this.cursor === this.rendered.length || this.placeholder && this.cursor === this.rendered.length + 1;
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.red ? color.red(this.rendered) : this.rendered
      ].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l22, i) => a + `\n${i ? " " : figures.pointerSmall} ${color.red().italic(l22)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore + cursor22.move(this.cursorOffset, 0));
    }
  }
  module.exports = TextPrompt;
});
var require_select22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt22();
  var { style, clear, figures, wrap, entriesToDisplay } = require_util22();
  var { cursor: cursor22 } = require_src2();

  class SelectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.hint = opts.hint || "- Use arrow-keys. Return to submit.";
      this.warn = opts.warn || "- This option is disabled";
      this.cursor = opts.initial || 0;
      this.choices = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = { title: ch, value: idx };
        return {
          title: ch && (ch.title || ch.value || ch),
          value: ch && (ch.value === undefined ? idx : ch.value),
          description: ch && ch.description,
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = (this.choices[this.cursor] || {}).value;
      this.clear = clear("", this.out.columns);
      this.render();
    }
    moveCursor(n) {
      this.cursor = n;
      this.value = this.choices[n].value;
      this.fire();
    }
    reset() {
      this.moveCursor(0);
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      if (!this.selection.disabled) {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      } else
        this.bell();
    }
    first() {
      this.moveCursor(0);
      this.render();
    }
    last() {
      this.moveCursor(this.choices.length - 1);
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.moveCursor(this.choices.length - 1);
      } else {
        this.moveCursor(this.cursor - 1);
      }
      this.render();
    }
    down() {
      if (this.cursor === this.choices.length - 1) {
        this.moveCursor(0);
      } else {
        this.moveCursor(this.cursor + 1);
      }
      this.render();
    }
    next() {
      this.moveCursor((this.cursor + 1) % this.choices.length);
      this.render();
    }
    _(c22, key) {
      if (c22 === " ")
        return this.submit();
    }
    get selection() {
      return this.choices[this.cursor];
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let { startIndex, endIndex } = entriesToDisplay(this.cursor, this.choices.length, this.optionsPerPage);
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.done ? this.selection.title : this.selection.disabled ? color.yellow(this.warn) : color.gray(this.hint)
      ].join(" ");
      if (!this.done) {
        this.outputText += "\n";
        for (let i = startIndex;i < endIndex; i++) {
          let title, prefix, desc = "", v22 = this.choices[i];
          if (i === startIndex && startIndex > 0) {
            prefix = figures.arrowUp;
          } else if (i === endIndex - 1 && endIndex < this.choices.length) {
            prefix = figures.arrowDown;
          } else {
            prefix = " ";
          }
          if (v22.disabled) {
            title = this.cursor === i ? color.gray().underline(v22.title) : color.strikethrough().gray(v22.title);
            prefix = (this.cursor === i ? color.bold().gray(figures.pointer) + " " : "  ") + prefix;
          } else {
            title = this.cursor === i ? color.cyan().underline(v22.title) : v22.title;
            prefix = (this.cursor === i ? color.cyan(figures.pointer) + " " : "  ") + prefix;
            if (v22.description && this.cursor === i) {
              desc = ` - ${v22.description}`;
              if (prefix.length + title.length + desc.length >= this.out.columns || v22.description.split(/\r?\n/).length > 1) {
                desc = "\n" + wrap(v22.description, { margin: 3, width: this.out.columns });
              }
            }
          }
          this.outputText += `${prefix} ${title}${color.gray(desc)}\n`;
        }
      }
      this.out.write(this.outputText);
    }
  }
  module.exports = SelectPrompt;
});
var require_toggle22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt22();
  var { style, clear } = require_util22();
  var { cursor: cursor22, erase: erase22 } = require_src2();

  class TogglePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = !!opts.initial;
      this.active = opts.active || "on";
      this.inactive = opts.inactive || "off";
      this.initialValue = this.value;
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    deactivate() {
      if (this.value === false)
        return this.bell();
      this.value = false;
      this.render();
    }
    activate() {
      if (this.value === true)
        return this.bell();
      this.value = true;
      this.render();
    }
    delete() {
      this.deactivate();
    }
    left() {
      this.deactivate();
    }
    right() {
      this.activate();
    }
    down() {
      this.deactivate();
    }
    up() {
      this.activate();
    }
    next() {
      this.value = !this.value;
      this.fire();
      this.render();
    }
    _(c22, key) {
      if (c22 === " ") {
        this.value = !this.value;
      } else if (c22 === "1") {
        this.value = true;
      } else if (c22 === "0") {
        this.value = false;
      } else
        return this.bell();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.value ? this.inactive : color.cyan().underline(this.inactive),
        color.gray("/"),
        this.value ? color.cyan().underline(this.active) : this.active
      ].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = TogglePrompt;
});
var require_datepart22 = __commonJS2((exports, module) => {

  class DatePart {
    constructor({ token, date, parts, locales: locales22 }) {
      this.token = token;
      this.date = date || new Date;
      this.parts = parts || [this];
      this.locales = locales22 || {};
    }
    up() {
    }
    down() {
    }
    next() {
      const currentIdx = this.parts.indexOf(this);
      return this.parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    setTo(val2) {
    }
    prev() {
      let parts = [].concat(this.parts).reverse();
      const currentIdx = parts.indexOf(this);
      return parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    toString() {
      return String(this.date);
    }
  }
  module.exports = DatePart;
});
var require_meridiem22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();

  class Meridiem extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours((this.date.getHours() + 12) % 24);
    }
    down() {
      this.up();
    }
    toString() {
      let meridiem = this.date.getHours() > 12 ? "pm" : "am";
      return /\A/.test(this.token) ? meridiem.toUpperCase() : meridiem;
    }
  }
  module.exports = Meridiem;
});
var require_day22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();
  var pos = (n) => {
    n = n % 10;
    return n === 1 ? "st" : n === 2 ? "nd" : n === 3 ? "rd" : "th";
  };

  class Day extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setDate(this.date.getDate() + 1);
    }
    down() {
      this.date.setDate(this.date.getDate() - 1);
    }
    setTo(val2) {
      this.date.setDate(parseInt(val2.substr(-2)));
    }
    toString() {
      let date = this.date.getDate();
      let day = this.date.getDay();
      return this.token === "DD" ? String(date).padStart(2, "0") : this.token === "Do" ? date + pos(date) : this.token === "d" ? day + 1 : this.token === "ddd" ? this.locales.weekdaysShort[day] : this.token === "dddd" ? this.locales.weekdays[day] : date;
    }
  }
  module.exports = Day;
});
var require_hours22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();

  class Hours extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours(this.date.getHours() + 1);
    }
    down() {
      this.date.setHours(this.date.getHours() - 1);
    }
    setTo(val2) {
      this.date.setHours(parseInt(val2.substr(-2)));
    }
    toString() {
      let hours = this.date.getHours();
      if (/h/.test(this.token))
        hours = hours % 12 || 12;
      return this.token.length > 1 ? String(hours).padStart(2, "0") : hours;
    }
  }
  module.exports = Hours;
});
var require_milliseconds22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();

  class Milliseconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMilliseconds(this.date.getMilliseconds() + 1);
    }
    down() {
      this.date.setMilliseconds(this.date.getMilliseconds() - 1);
    }
    setTo(val2) {
      this.date.setMilliseconds(parseInt(val2.substr(-this.token.length)));
    }
    toString() {
      return String(this.date.getMilliseconds()).padStart(4, "0").substr(0, this.token.length);
    }
  }
  module.exports = Milliseconds;
});
var require_minutes22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();

  class Minutes extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMinutes(this.date.getMinutes() + 1);
    }
    down() {
      this.date.setMinutes(this.date.getMinutes() - 1);
    }
    setTo(val2) {
      this.date.setMinutes(parseInt(val2.substr(-2)));
    }
    toString() {
      let m22 = this.date.getMinutes();
      return this.token.length > 1 ? String(m22).padStart(2, "0") : m22;
    }
  }
  module.exports = Minutes;
});
var require_month22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();

  class Month extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMonth(this.date.getMonth() + 1);
    }
    down() {
      this.date.setMonth(this.date.getMonth() - 1);
    }
    setTo(val2) {
      val2 = parseInt(val2.substr(-2)) - 1;
      this.date.setMonth(val2 < 0 ? 0 : val2);
    }
    toString() {
      let month = this.date.getMonth();
      let tl = this.token.length;
      return tl === 2 ? String(month + 1).padStart(2, "0") : tl === 3 ? this.locales.monthsShort[month] : tl === 4 ? this.locales.months[month] : String(month + 1);
    }
  }
  module.exports = Month;
});
var require_seconds22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();

  class Seconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setSeconds(this.date.getSeconds() + 1);
    }
    down() {
      this.date.setSeconds(this.date.getSeconds() - 1);
    }
    setTo(val2) {
      this.date.setSeconds(parseInt(val2.substr(-2)));
    }
    toString() {
      let s32 = this.date.getSeconds();
      return this.token.length > 1 ? String(s32).padStart(2, "0") : s32;
    }
  }
  module.exports = Seconds;
});
var require_year22 = __commonJS2((exports, module) => {
  var DatePart = require_datepart22();

  class Year extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setFullYear(this.date.getFullYear() + 1);
    }
    down() {
      this.date.setFullYear(this.date.getFullYear() - 1);
    }
    setTo(val2) {
      this.date.setFullYear(val2.substr(-4));
    }
    toString() {
      let year = String(this.date.getFullYear()).padStart(4, "0");
      return this.token.length === 2 ? year.substr(-2) : year;
    }
  }
  module.exports = Year;
});
var require_dateparts22 = __commonJS2((exports, module) => {
  module.exports = {
    DatePart: require_datepart22(),
    Meridiem: require_meridiem22(),
    Day: require_day22(),
    Hours: require_hours22(),
    Milliseconds: require_milliseconds22(),
    Minutes: require_minutes22(),
    Month: require_month22(),
    Seconds: require_seconds22(),
    Year: require_year22()
  };
});
var require_date22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt22();
  var { style, clear, figures } = require_util22();
  var { erase: erase22, cursor: cursor22 } = require_src2();
  var { DatePart, Meridiem, Day, Hours, Milliseconds, Minutes, Month, Seconds, Year } = require_dateparts22();
  var regex22 = /\\(.)|"((?:\\["\\]|[^"])+)"|(D[Do]?|d{3,4}|d)|(M{1,4})|(YY(?:YY)?)|([aA])|([Hh]{1,2})|(m{1,2})|(s{1,2})|(S{1,4})|./g;
  var regexGroups = {
    1: ({ token }) => token.replace(/\\(.)/g, "$1"),
    2: (opts) => new Day(opts),
    3: (opts) => new Month(opts),
    4: (opts) => new Year(opts),
    5: (opts) => new Meridiem(opts),
    6: (opts) => new Hours(opts),
    7: (opts) => new Minutes(opts),
    8: (opts) => new Seconds(opts),
    9: (opts) => new Milliseconds(opts)
  };
  var dfltLocales = {
    months: "January,February,March,April,May,June,July,August,September,October,November,December".split(","),
    monthsShort: "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),
    weekdays: "Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),
    weekdaysShort: "Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(",")
  };

  class DatePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = 0;
      this.typed = "";
      this.locales = Object.assign(dfltLocales, opts.locales);
      this._date = opts.initial || new Date;
      this.errorMsg = opts.error || "Please Enter A Valid Value";
      this.validator = opts.validate || (() => true);
      this.mask = opts.mask || "YYYY-MM-DD HH:mm:ss";
      this.clear = clear("", this.out.columns);
      this.render();
    }
    get value() {
      return this.date;
    }
    get date() {
      return this._date;
    }
    set date(date) {
      if (date)
        this._date.setTime(date.getTime());
    }
    set mask(mask) {
      let result2;
      this.parts = [];
      while (result2 = regex22.exec(mask)) {
        let match = result2.shift();
        let idx = result2.findIndex((gr) => gr != null);
        this.parts.push(idx in regexGroups ? regexGroups[idx]({ token: result2[idx] || match, date: this.date, parts: this.parts, locales: this.locales }) : result2[idx] || match);
      }
      let parts = this.parts.reduce((arr, i) => {
        if (typeof i === "string" && typeof arr[arr.length - 1] === "string")
          arr[arr.length - 1] += i;
        else
          arr.push(i);
        return arr;
      }, []);
      this.parts.splice(0);
      this.parts.push(...parts);
      this.reset();
    }
    moveCursor(n) {
      this.typed = "";
      this.cursor = n;
      this.fire();
    }
    reset() {
      this.moveCursor(this.parts.findIndex((p32) => p32 instanceof DatePart));
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === "string") {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      await this.validate();
      if (this.error) {
        this.color = "red";
        this.fire();
        this.render();
        return;
      }
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    up() {
      this.typed = "";
      this.parts[this.cursor].up();
      this.render();
    }
    down() {
      this.typed = "";
      this.parts[this.cursor].down();
      this.render();
    }
    left() {
      let prev = this.parts[this.cursor].prev();
      if (prev == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(prev));
      this.render();
    }
    right() {
      let next = this.parts[this.cursor].next();
      if (next == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(next));
      this.render();
    }
    next() {
      let next = this.parts[this.cursor].next();
      this.moveCursor(next ? this.parts.indexOf(next) : this.parts.findIndex((part) => part instanceof DatePart));
      this.render();
    }
    _(c22) {
      if (/\d/.test(c22)) {
        this.typed += c22;
        this.parts[this.cursor].setTo(this.typed);
        this.render();
      }
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.parts.reduce((arr, p32, idx) => arr.concat(idx === this.cursor && !this.done ? color.cyan().underline(p32.toString()) : p32), []).join("")
      ].join(" ");
      if (this.error) {
        this.outputText += this.errorMsg.split("\n").reduce((a, l22, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l22)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = DatePrompt;
});
var require_number22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt22();
  var { cursor: cursor22, erase: erase22 } = require_src2();
  var { style, figures, clear, lines } = require_util22();
  var isNumber = /[0-9]/;
  var isDef = (any) => any !== undefined;
  var round = (number, precision) => {
    let factor = Math.pow(10, precision);
    return Math.round(number * factor) / factor;
  };

  class NumberPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.msg = opts.message;
      this.initial = isDef(opts.initial) ? opts.initial : "";
      this.float = !!opts.float;
      this.round = opts.round || 2;
      this.inc = opts.increment || 1;
      this.min = isDef(opts.min) ? opts.min : -Infinity;
      this.max = isDef(opts.max) ? opts.max : Infinity;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.validator = opts.validate || (() => true);
      this.color = `cyan`;
      this.value = ``;
      this.typed = ``;
      this.lastHit = 0;
      this.render();
    }
    set value(v22) {
      if (!v22 && v22 !== 0) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(`${this.initial}`));
        this._value = ``;
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(`${round(v22, this.round)}`);
        this._value = round(v22, this.round);
      }
      this.fire();
    }
    get value() {
      return this._value;
    }
    parse(x) {
      return this.float ? parseFloat(x) : parseInt(x);
    }
    valid(c22) {
      return c22 === `-` || c22 === `.` && this.float || isNumber.test(c22);
    }
    reset() {
      this.typed = ``;
      this.value = ``;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      let x = this.value;
      this.value = x !== `` ? x : this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === `string`) {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      await this.validate();
      if (this.error) {
        this.color = `red`;
        this.fire();
        this.render();
        return;
      }
      let x = this.value;
      this.value = x !== `` ? x : this.initial;
      this.done = true;
      this.aborted = false;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    up() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min - this.inc;
      }
      if (this.value >= this.max)
        return this.bell();
      this.value += this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    down() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min + this.inc;
      }
      if (this.value <= this.min)
        return this.bell();
      this.value -= this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    delete() {
      let val2 = this.value.toString();
      if (val2.length === 0)
        return this.bell();
      this.value = this.parse(val2 = val2.slice(0, -1)) || ``;
      if (this.value !== "" && this.value < this.min) {
        this.value = this.min;
      }
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    next() {
      this.value = this.initial;
      this.fire();
      this.render();
    }
    _(c22, key) {
      if (!this.valid(c22))
        return this.bell();
      const now = Date.now();
      if (now - this.lastHit > 1000)
        this.typed = ``;
      this.typed += c22;
      this.lastHit = now;
      this.color = `cyan`;
      if (c22 === `.`)
        return this.fire();
      this.value = Math.min(this.parse(this.typed), this.max);
      if (this.value > this.max)
        this.value = this.max;
      if (this.value < this.min)
        this.value = this.min;
      this.fire();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        !this.done || !this.done && !this.placeholder ? color[this.color]().underline(this.rendered) : this.rendered
      ].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a, l22, i) => a + `\n${i ? ` ` : figures.pointerSmall} ${color.red().italic(l22)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore);
    }
  }
  module.exports = NumberPrompt;
});
var require_multiselect22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var { cursor: cursor22 } = require_src2();
  var Prompt = require_prompt22();
  var { clear, figures, style, wrap, entriesToDisplay } = require_util22();

  class MultiselectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = opts.cursor || 0;
      this.scrollIndex = opts.cursor || 0;
      this.hint = opts.hint || "";
      this.warn = opts.warn || "- This option is disabled -";
      this.minSelected = opts.min;
      this.showMinError = false;
      this.maxChoices = opts.max;
      this.instructions = opts.instructions;
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = opts.choices.map((ch, idx) => {
        if (typeof ch === "string")
          ch = { title: ch, value: idx };
        return {
          title: ch && (ch.title || ch.value || ch),
          description: ch && ch.description,
          value: ch && (ch.value === undefined ? idx : ch.value),
          selected: ch && ch.selected,
          disabled: ch && ch.disabled
        };
      });
      this.clear = clear("", this.out.columns);
      if (!opts.overrideRender) {
        this.render();
      }
    }
    reset() {
      this.value.map((v22) => !v22.selected);
      this.cursor = 0;
      this.fire();
      this.render();
    }
    selected() {
      return this.value.filter((v22) => v22.selected);
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      const selected = this.value.filter((e) => e.selected);
      if (this.minSelected && selected.length < this.minSelected) {
        this.showMinError = true;
        this.render();
      } else {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.value.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.value.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.value.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.value[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.value[this.cursor].selected = true;
      this.render();
    }
    handleSpaceToggle() {
      const v22 = this.value[this.cursor];
      if (v22.selected) {
        v22.selected = false;
        this.render();
      } else if (v22.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v22.selected = true;
        this.render();
      }
    }
    toggleAll() {
      if (this.maxChoices !== undefined || this.value[this.cursor].disabled) {
        return this.bell();
      }
      const newSelected = !this.value[this.cursor].selected;
      this.value.filter((v22) => !v22.disabled).forEach((v22) => v22.selected = newSelected);
      this.render();
    }
    _(c22, key) {
      if (c22 === " ") {
        this.handleSpaceToggle();
      } else if (c22 === "a") {
        this.toggleAll();
      } else {
        return this.bell();
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `\nInstructions:\n    ${figures.arrowUp}/${figures.arrowDown}: Highlight option\n    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection\n` + (this.maxChoices === undefined ? `    a: Toggle all\n` : "") + `    enter/return: Complete answer`;
      }
      return "";
    }
    renderOption(cursor3, v22, i, arrowIndicator) {
      const prefix = (v22.selected ? color.green(figures.radioOn) : figures.radioOff) + " " + arrowIndicator + " ";
      let title, desc;
      if (v22.disabled) {
        title = cursor3 === i ? color.gray().underline(v22.title) : color.strikethrough().gray(v22.title);
      } else {
        title = cursor3 === i ? color.cyan().underline(v22.title) : v22.title;
        if (cursor3 === i && v22.description) {
          desc = ` - ${v22.description}`;
          if (prefix.length + title.length + desc.length >= this.out.columns || v22.description.split(/\r?\n/).length > 1) {
            desc = "\n" + wrap(v22.description, { margin: prefix.length, width: this.out.columns });
          }
        }
      }
      return prefix + title + color.gray(desc || "");
    }
    paginateOptions(options22) {
      if (options22.length === 0) {
        return color.red("No matches for this query.");
      }
      let { startIndex, endIndex } = entriesToDisplay(this.cursor, options22.length, this.optionsPerPage);
      let prefix, styledOptions = [];
      for (let i = startIndex;i < endIndex; i++) {
        if (i === startIndex && startIndex > 0) {
          prefix = figures.arrowUp;
        } else if (i === endIndex - 1 && endIndex < options22.length) {
          prefix = figures.arrowDown;
        } else {
          prefix = " ";
        }
        styledOptions.push(this.renderOption(this.cursor, options22[i], i, prefix));
      }
      return "\n" + styledOptions.join("\n");
    }
    renderOptions(options22) {
      if (!this.done) {
        return this.paginateOptions(options22);
      }
      return "";
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v22) => v22.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions()];
      if (this.value[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.renderDoneOrInstructions()
      ].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.value);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = MultiselectPrompt;
});
var require_autocomplete22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt22();
  var { erase: erase22, cursor: cursor22 } = require_src2();
  var { style, clear, figures, wrap, entriesToDisplay } = require_util22();
  var getVal = (arr, i) => arr[i] && (arr[i].value || arr[i].title || arr[i]);
  var getTitle = (arr, i) => arr[i] && (arr[i].title || arr[i].value || arr[i]);
  var getIndex = (arr, valOrTitle) => {
    const index = arr.findIndex((el) => el.value === valOrTitle || el.title === valOrTitle);
    return index > -1 ? index : undefined;
  };

  class AutocompletePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.suggest = opts.suggest;
      this.choices = opts.choices;
      this.initial = typeof opts.initial === "number" ? opts.initial : getIndex(opts.choices, opts.initial);
      this.select = this.initial || opts.cursor || 0;
      this.i18n = { noMatches: opts.noMatches || "no matches found" };
      this.fallback = opts.fallback || this.initial;
      this.clearFirst = opts.clearFirst || false;
      this.suggestions = [];
      this.input = "";
      this.limit = opts.limit || 10;
      this.cursor = 0;
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.render = this.render.bind(this);
      this.complete = this.complete.bind(this);
      this.clear = clear("", this.out.columns);
      this.complete(this.render);
      this.render();
    }
    set fallback(fb) {
      this._fb = Number.isSafeInteger(parseInt(fb)) ? parseInt(fb) : fb;
    }
    get fallback() {
      let choice;
      if (typeof this._fb === "number")
        choice = this.choices[this._fb];
      else if (typeof this._fb === "string")
        choice = { title: this._fb };
      return choice || this._fb || { title: this.i18n.noMatches };
    }
    moveSelect(i) {
      this.select = i;
      if (this.suggestions.length > 0)
        this.value = getVal(this.suggestions, i);
      else
        this.value = this.fallback.value;
      this.fire();
    }
    async complete(cb) {
      const p32 = this.completing = this.suggest(this.input, this.choices);
      const suggestions = await p32;
      if (this.completing !== p32)
        return;
      this.suggestions = suggestions.map((s32, i, arr) => ({ title: getTitle(arr, i), value: getVal(arr, i), description: s32.description }));
      this.completing = false;
      const l22 = Math.max(suggestions.length - 1, 0);
      this.moveSelect(Math.min(l22, this.select));
      cb && cb();
    }
    reset() {
      this.input = "";
      this.complete(() => {
        this.moveSelect(this.initial !== undefined ? this.initial : 0);
        this.render();
      });
      this.render();
    }
    exit() {
      if (this.clearFirst && this.input.length > 0) {
        this.reset();
      } else {
        this.done = this.exited = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    abort() {
      this.done = this.aborted = true;
      this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c22, key) {
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${c22}${s222}`;
      this.cursor = s1.length + 1;
      this.complete(this.render);
      this.render();
    }
    delete() {
      if (this.cursor === 0)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor - 1);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.cursor = this.cursor - 1;
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor + 1);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.render();
    }
    first() {
      this.moveSelect(0);
      this.render();
    }
    last() {
      this.moveSelect(this.suggestions.length - 1);
      this.render();
    }
    up() {
      if (this.select === 0) {
        this.moveSelect(this.suggestions.length - 1);
      } else {
        this.moveSelect(this.select - 1);
      }
      this.render();
    }
    down() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else {
        this.moveSelect(this.select + 1);
      }
      this.render();
    }
    next() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else
        this.moveSelect(this.select + 1);
      this.render();
    }
    nextPage() {
      this.moveSelect(Math.min(this.select + this.limit, this.suggestions.length - 1));
      this.render();
    }
    prevPage() {
      this.moveSelect(Math.max(this.select - this.limit, 0));
      this.render();
    }
    left() {
      if (this.cursor <= 0)
        return this.bell();
      this.cursor = this.cursor - 1;
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      this.cursor = this.cursor + 1;
      this.render();
    }
    renderOption(v22, hovered, isStart, isEnd) {
      let desc;
      let prefix = isStart ? figures.arrowUp : isEnd ? figures.arrowDown : " ";
      let title = hovered ? color.cyan().underline(v22.title) : v22.title;
      prefix = (hovered ? color.cyan(figures.pointer) + " " : "  ") + prefix;
      if (v22.description) {
        desc = ` - ${v22.description}`;
        if (prefix.length + title.length + desc.length >= this.out.columns || v22.description.split(/\r?\n/).length > 1) {
          desc = "\n" + wrap(v22.description, { margin: 3, width: this.out.columns });
        }
      }
      return prefix + " " + title + color.gray(desc || "");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let { startIndex, endIndex } = entriesToDisplay(this.select, this.choices.length, this.limit);
      this.outputText = [
        style.symbol(this.done, this.aborted, this.exited),
        color.bold(this.msg),
        style.delimiter(this.completing),
        this.done && this.suggestions[this.select] ? this.suggestions[this.select].title : this.rendered = this.transform.render(this.input)
      ].join(" ");
      if (!this.done) {
        const suggestions = this.suggestions.slice(startIndex, endIndex).map((item, i) => this.renderOption(item, this.select === i + startIndex, i === 0 && startIndex > 0, i + startIndex === endIndex - 1 && endIndex < this.choices.length)).join("\n");
        this.outputText += `\n` + (suggestions || color.gray(this.fallback.title));
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = AutocompletePrompt;
});
var require_autocompleteMultiselect22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var { cursor: cursor22 } = require_src2();
  var MultiselectPrompt = require_multiselect22();
  var { clear, style, figures } = require_util22();

  class AutocompleteMultiselectPrompt extends MultiselectPrompt {
    constructor(opts = {}) {
      opts.overrideRender = true;
      super(opts);
      this.inputValue = "";
      this.clear = clear("", this.out.columns);
      this.filteredOptions = this.value;
      this.render();
    }
    last() {
      this.cursor = this.filteredOptions.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.filteredOptions.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.filteredOptions.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.filteredOptions.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.filteredOptions[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e) => e.selected).length >= this.maxChoices)
        return this.bell();
      this.filteredOptions[this.cursor].selected = true;
      this.render();
    }
    delete() {
      if (this.inputValue.length) {
        this.inputValue = this.inputValue.substr(0, this.inputValue.length - 1);
        this.updateFilteredOptions();
      }
    }
    updateFilteredOptions() {
      const currentHighlight = this.filteredOptions[this.cursor];
      this.filteredOptions = this.value.filter((v22) => {
        if (this.inputValue) {
          if (typeof v22.title === "string") {
            if (v22.title.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          if (typeof v22.value === "string") {
            if (v22.value.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          return false;
        }
        return true;
      });
      const newHighlightIndex = this.filteredOptions.findIndex((v22) => v22 === currentHighlight);
      this.cursor = newHighlightIndex < 0 ? 0 : newHighlightIndex;
      this.render();
    }
    handleSpaceToggle() {
      const v22 = this.filteredOptions[this.cursor];
      if (v22.selected) {
        v22.selected = false;
        this.render();
      } else if (v22.disabled || this.value.filter((e) => e.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v22.selected = true;
        this.render();
      }
    }
    handleInputChange(c22) {
      this.inputValue = this.inputValue + c22;
      this.updateFilteredOptions();
    }
    _(c22, key) {
      if (c22 === " ") {
        this.handleSpaceToggle();
      } else {
        this.handleInputChange(c22);
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `
Instructions:
    ${figures.arrowUp}/${figures.arrowDown}: Highlight option
    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection
    [a,b,c]/delete: Filter choices
    enter/return: Complete answer
`;
      }
      return "";
    }
    renderCurrentInput() {
      return `
Filtered results for: ${this.inputValue ? this.inputValue : color.gray("Enter something to filter")}\n`;
    }
    renderOption(cursor3, v22, i) {
      let title;
      if (v22.disabled)
        title = cursor3 === i ? color.gray().underline(v22.title) : color.strikethrough().gray(v22.title);
      else
        title = cursor3 === i ? color.cyan().underline(v22.title) : v22.title;
      return (v22.selected ? color.green(figures.radioOn) : figures.radioOff) + "  " + title;
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e) => e.selected).map((v22) => v22.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions(), this.renderCurrentInput()];
      if (this.filteredOptions.length && this.filteredOptions[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.renderDoneOrInstructions()
      ].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.filteredOptions);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = AutocompleteMultiselectPrompt;
});
var require_confirm22 = __commonJS2((exports, module) => {
  var color = require_kleur2();
  var Prompt = require_prompt22();
  var { style, clear } = require_util22();
  var { erase: erase22, cursor: cursor22 } = require_src2();

  class ConfirmPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = opts.initial;
      this.initialValue = !!opts.initial;
      this.yesMsg = opts.yes || "yes";
      this.yesOption = opts.yesOption || "(Y/n)";
      this.noMsg = opts.no || "no";
      this.noOption = opts.noOption || "(y/N)";
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.value = this.value || false;
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c22, key) {
      if (c22.toLowerCase() === "y") {
        this.value = true;
        return this.submit();
      }
      if (c22.toLowerCase() === "n") {
        this.value = false;
        return this.submit();
      }
      return this.bell();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.done ? this.value ? this.yesMsg : this.noMsg : color.gray(this.initialValue ? this.yesOption : this.noOption)
      ].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = ConfirmPrompt;
});
var require_elements22 = __commonJS2((exports, module) => {
  module.exports = {
    TextPrompt: require_text22(),
    SelectPrompt: require_select22(),
    TogglePrompt: require_toggle22(),
    DatePrompt: require_date22(),
    NumberPrompt: require_number22(),
    MultiselectPrompt: require_multiselect22(),
    AutocompletePrompt: require_autocomplete22(),
    AutocompleteMultiselectPrompt: require_autocompleteMultiselect22(),
    ConfirmPrompt: require_confirm22()
  };
});
var require_prompts22 = __commonJS2((exports) => {
  var $22 = exports;
  var el = require_elements22();
  var noop = (v22) => v22;
  function toPrompt(type, args, opts = {}) {
    return new Promise((res, rej) => {
      const p32 = new el[type](args);
      const onAbort = opts.onAbort || noop;
      const onSubmit = opts.onSubmit || noop;
      const onExit2 = opts.onExit || noop;
      p32.on("state", args.onState || noop);
      p32.on("submit", (x) => res(onSubmit(x)));
      p32.on("exit", (x) => res(onExit2(x)));
      p32.on("abort", (x) => rej(onAbort(x)));
    });
  }
  $22.text = (args) => toPrompt("TextPrompt", args);
  $22.password = (args) => {
    args.style = "password";
    return $22.text(args);
  };
  $22.invisible = (args) => {
    args.style = "invisible";
    return $22.text(args);
  };
  $22.number = (args) => toPrompt("NumberPrompt", args);
  $22.date = (args) => toPrompt("DatePrompt", args);
  $22.confirm = (args) => toPrompt("ConfirmPrompt", args);
  $22.list = (args) => {
    const sep23 = args.separator || ",";
    return toPrompt("TextPrompt", args, {
      onSubmit: (str) => str.split(sep23).map((s32) => s32.trim())
    });
  };
  $22.toggle = (args) => toPrompt("TogglePrompt", args);
  $22.select = (args) => toPrompt("SelectPrompt", args);
  $22.multiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("MultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  $22.autocompleteMultiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("AutocompleteMultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  var byTitle = (input, choices) => Promise.resolve(choices.filter((item) => item.title.slice(0, input.length).toLowerCase() === input.toLowerCase()));
  $22.autocomplete = (args) => {
    args.suggest = args.suggest || byTitle;
    args.choices = [].concat(args.choices || []);
    return toPrompt("AutocompletePrompt", args);
  };
});
var require_lib22 = __commonJS2((exports, module) => {
  var prompts = require_prompts22();
  var passOn = ["suggest", "format", "onState", "validate", "onRender", "type"];
  var noop = () => {
  };
  async function prompt22(questions = [], { onSubmit = noop, onCancel = noop } = {}) {
    const answers = {};
    const override2 = prompt22._override || {};
    questions = [].concat(questions);
    let answer, question, quit, name, type, lastPrompt;
    const getFormattedAnswer = async (question2, answer2, skipValidation = false) => {
      if (!skipValidation && question2.validate && question2.validate(answer2) !== true) {
        return;
      }
      return question2.format ? await question2.format(answer2, answers) : answer2;
    };
    for (question of questions) {
      ({ name, type } = question);
      if (typeof type === "function") {
        type = await type(answer, { ...answers }, question);
        question["type"] = type;
      }
      if (!type)
        continue;
      for (let key in question) {
        if (passOn.includes(key))
          continue;
        let value = question[key];
        question[key] = typeof value === "function" ? await value(answer, { ...answers }, lastPrompt) : value;
      }
      lastPrompt = question;
      if (typeof question.message !== "string") {
        throw new Error("prompt message is required");
      }
      ({ name, type } = question);
      if (prompts[type] === undefined) {
        throw new Error(`prompt type (${type}) is not defined`);
      }
      if (override2[question.name] !== undefined) {
        answer = await getFormattedAnswer(question, override2[question.name]);
        if (answer !== undefined) {
          answers[name] = answer;
          continue;
        }
      }
      try {
        answer = prompt22._injected ? getInjectedAnswer(prompt22._injected, question.initial) : await prompts[type](question);
        answers[name] = answer = await getFormattedAnswer(question, answer, true);
        quit = await onSubmit(question, answer, answers);
      } catch (err22) {
        quit = !await onCancel(question, answers);
      }
      if (quit)
        return answers;
    }
    return answers;
  }
  function getInjectedAnswer(injected, deafultValue) {
    const answer = injected.shift();
    if (answer instanceof Error) {
      throw answer;
    }
    return answer === undefined ? deafultValue : answer;
  }
  function inject(answers) {
    prompt22._injected = (prompt22._injected || []).concat(answers);
  }
  function override(answers) {
    prompt22._override = Object.assign({}, answers);
  }
  module.exports = Object.assign(prompt22, { prompt: prompt22, prompts, inject, override });
});
var require_prompts32 = __commonJS2((exports, module) => {
  function isNodeLT(tar) {
    tar = (Array.isArray(tar) ? tar : tar.split(".")).map(Number);
    let i = 0, src22 = process.versions.node.split(".").map(Number);
    for (;i < tar.length; i++) {
      if (src22[i] > tar[i])
        return false;
      if (tar[i] > src22[i])
        return true;
    }
    return false;
  }
  module.exports = isNodeLT("8.6.0") ? require_dist2() : require_lib22();
});
var import_prompts2;
var init_console = __esm2(() => {
  init_src8();
  import_prompts2 = __toESM3(require_prompts32(), 1);
});
async function exec(command, options22) {
  const cmd = Array.isArray(command) ? command : command.match(/(?:[^\s"]|"[^"]*")+/g);
  log2.debug("exec:", Array.isArray(command) ? command.join(" ") : command, options22);
  log2.debug("cmd:", cmd);
  if (!cmd)
    return err2(handleError2(`Failed to parse command: ${cmd}`, options22));
  const cwd = options22?.cwd ?? process52.cwd();
  const proc = Bun.spawn(cmd, {
    stdin: options22?.stdin ?? "inherit",
    stdout: options22?.silent || options22?.quiet ? "ignore" : options22?.stdin ? options22.stdin : options22?.stdout || "inherit",
    stderr: options22?.silent || options22?.quiet ? "ignore" : options22?.stderr || "inherit",
    cwd,
    onExit(subprocess, exitCode, signalCode, error) {
      exitHandler("spawn", subprocess, exitCode, signalCode, error);
    }
  });
  if (options22?.stdin === "pipe" && options22.input) {
    if (proc.stdin) {
      proc.stdin.write(options22.input);
      proc.stdin.end();
    }
  }
  const exited = await proc.exited;
  if (exited === 0)
    return ok2(proc);
  return err2(handleError2(`Failed to execute command: ${italic2(cmd.join(" "))} in ${italic2(cwd)}`, options22));
}
async function execSync(command, options22) {
  log2.debug("Running execSync:", command);
  log2.debug("execSync options:", options22);
  const cmd = Array.isArray(command) ? command : command.match(/(?:[^\s"]|"[^"]*")+/g);
  if (!cmd) {
    log2.error(`Failed to parse command: ${cmd}`, options22);
    process52.exit(1);
  }
  const proc = Bun.spawnSync(cmd, {
    ...options22,
    stdin: options22?.stdin ?? "inherit",
    stdout: options22?.stdout ?? "pipe",
    stderr: options22?.stderr ?? "inherit",
    cwd: options22?.cwd ?? process52.cwd(),
    onExit(subprocess, exitCode, signalCode, error) {
      exitHandler("spawnSync", subprocess, exitCode, signalCode, error);
    }
  });
  return proc.stdout?.toString() ?? "";
}
function exitHandler(type, subprocess, exitCode, signalCode, error) {
  log2.debug(`exitHandler: ${type}`);
  log2.debug("subprocess", subprocess);
  log2.debug("exitCode", exitCode);
  log2.debug("signalCode", signalCode);
  if (error) {
    log2.error(error);
    process52.exit(1);
  }
  if (exitCode !== 0 && exitCode)
    process52.exit(exitCode);
}
var init_exec = __esm2(() => {
  init_src7();
  init_src2();
  init_src10();
});
async function runCommand(command, options22) {
  log2.debug("runCommand:", command, options22);
  const opts = {
    ...options22,
    stdio: options22?.stdio ?? [options22?.stdin ?? "inherit", "pipe", "pipe"],
    verbose: options22?.verbose ?? false
  };
  return await exec(command, opts);
}
async function runCommandSync(command, options22) {
  log2.debug("runCommandSync:", command, options22);
  const opts = {
    ...options22,
    stdio: [options22?.stdin ?? "inherit", "pipe", "pipe"],
    verbose: options22?.verbose ?? false
  };
  return await execSync(command, opts);
}
var init_run = __esm2(() => {
  init_src7();
  init_src2();
  init_console();
  init_exec();
});
var init_command = __esm2(() => {
  init_run();
});
function kolorist2(start, end, level = 1) {
  const open = `\x1B[${start}m`;
  const close = `\x1B[${end}m`;
  const regex22 = new RegExp(`\\x1b\\[${end}m`, "g");
  return (str) => {
    return options22.enabled && options22.supportLevel >= level ? open + ("" + str).replace(regex22, open) + close : "" + str;
  };
}
var enabled2 = true;
var globalVar2;
var supportLevel2 = 0;
var options22;
var reset2;
var bold2;
var dim2;
var italic2;
var underline2;
var inverse2;
var hidden2;
var strikethrough2;
var black2;
var red2;
var green2;
var yellow2;
var blue2;
var magenta2;
var cyan2;
var white2;
var gray2;
var lightGray2;
var lightRed2;
var lightGreen2;
var lightYellow2;
var lightBlue2;
var lightMagenta2;
var lightCyan2;
var bgBlack2;
var bgRed2;
var bgGreen2;
var bgYellow2;
var bgBlue2;
var bgMagenta2;
var bgCyan2;
var bgWhite2;
var bgGray2;
var bgLightRed2;
var bgLightGreen2;
var bgLightYellow2;
var bgLightBlue2;
var bgLightMagenta2;
var bgLightCyan2;
var bgLightGray2;
var init_esm = __esm2(() => {
  globalVar2 = typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
  if (globalVar2.process && globalVar2.process.env && globalVar2.process.stdout) {
    const { FORCE_COLOR, NODE_DISABLE_COLORS, NO_COLOR, TERM, COLORTERM } = globalVar2.process.env;
    if (NODE_DISABLE_COLORS || NO_COLOR || FORCE_COLOR === "0") {
      enabled2 = false;
    } else if (FORCE_COLOR === "1" || FORCE_COLOR === "2" || FORCE_COLOR === "3") {
      enabled2 = true;
    } else if (TERM === "dumb") {
      enabled2 = false;
    } else if ("CI" in globalVar2.process.env && [
      "TRAVIS",
      "CIRCLECI",
      "APPVEYOR",
      "GITLAB_CI",
      "GITHUB_ACTIONS",
      "BUILDKITE",
      "DRONE"
    ].some((vendor) => (vendor in globalVar2.process.env))) {
      enabled2 = true;
    } else {
      enabled2 = process.stdout.isTTY;
    }
    if (enabled2) {
      if (process.platform === "win32") {
        supportLevel2 = 3;
      } else {
        if (COLORTERM && (COLORTERM === "truecolor" || COLORTERM === "24bit")) {
          supportLevel2 = 3;
        } else if (TERM && (TERM.endsWith("-256color") || TERM.endsWith("256"))) {
          supportLevel2 = 2;
        } else {
          supportLevel2 = 1;
        }
      }
    }
  }
  options22 = {
    enabled: enabled2,
    supportLevel: supportLevel2
  };
  reset2 = kolorist2(0, 0);
  bold2 = kolorist2(1, 22);
  dim2 = kolorist2(2, 22);
  italic2 = kolorist2(3, 23);
  underline2 = kolorist2(4, 24);
  inverse2 = kolorist2(7, 27);
  hidden2 = kolorist2(8, 28);
  strikethrough2 = kolorist2(9, 29);
  black2 = kolorist2(30, 39);
  red2 = kolorist2(31, 39);
  green2 = kolorist2(32, 39);
  yellow2 = kolorist2(33, 39);
  blue2 = kolorist2(34, 39);
  magenta2 = kolorist2(35, 39);
  cyan2 = kolorist2(36, 39);
  white2 = kolorist2(97, 39);
  gray2 = kolorist2(90, 39);
  lightGray2 = kolorist2(37, 39);
  lightRed2 = kolorist2(91, 39);
  lightGreen2 = kolorist2(92, 39);
  lightYellow2 = kolorist2(93, 39);
  lightBlue2 = kolorist2(94, 39);
  lightMagenta2 = kolorist2(95, 39);
  lightCyan2 = kolorist2(96, 39);
  bgBlack2 = kolorist2(40, 49);
  bgRed2 = kolorist2(41, 49);
  bgGreen2 = kolorist2(42, 49);
  bgYellow2 = kolorist2(43, 49);
  bgBlue2 = kolorist2(44, 49);
  bgMagenta2 = kolorist2(45, 49);
  bgCyan2 = kolorist2(46, 49);
  bgWhite2 = kolorist2(107, 49);
  bgGray2 = kolorist2(100, 49);
  bgLightRed2 = kolorist2(101, 49);
  bgLightGreen2 = kolorist2(102, 49);
  bgLightYellow2 = kolorist2(103, 49);
  bgLightBlue2 = kolorist2(104, 49);
  bgLightMagenta2 = kolorist2(105, 49);
  bgLightCyan2 = kolorist2(106, 49);
  bgLightGray2 = kolorist2(47, 49);
});
var init_package = () => {
};
var init_helpers3 = __esm2(() => {
  init_src7();
  init_src8();
  init_src2();
  init_esm();
  init_package();
});
function buddyOptions2(options3) {
  if (Array.isArray(options3)) {
    options3 = Array.from(new Set(options3));
    if (Array.isArray(options3) && options3[0] && !options3[0].startsWith("-"))
      options3.shift();
    return options3.join(" ");
  }
  if (typeof options3 === "object" && options3 !== null) {
    return Object.entries(options3).map(([key, value]) => {
      if (value === true)
        return `--${key}`;
      return `--${key} ${value}`;
    }).join(" ");
  }
  return buddyOptions2(process62.argv.slice(2));
}
var init_parse = () => {
};
var init_spinner = () => {
};
function clone2(items) {
  if (Array.isArray(items)) {
    return [...items];
  }
  return { ...items };
}
function variadic2(args) {
  if (Array.isArray(args)) {
    return args;
  }
  return [args];
}
function deleteKeys2(obj, ...keys) {
  variadic2(keys).forEach((key) => {
    delete obj[key];
  });
}
var init_delete_keys = () => {
};
function isObject22(item) {
  return typeof item === "object" && !Array.isArray(item) && item !== null;
}
var isArray2 = (item) => Array.isArray(item);
var isFunction2 = (item) => typeof item === "function";
function nestedValue2(mainObject, key) {
  try {
    return key.split(".").reduce((obj, property) => obj[property], mainObject);
  } catch (err22) {
    return mainObject;
  }
}
function values2(items) {
  if (Array.isArray(items)) {
    return [...items];
  }
  if ("all" in items && typeof items.all === "function") {
    return items.all();
  }
  return Object.values(items);
}
var init_helpers4 = __esm2(() => {
  init_delete_keys();
});
function collect2(items) {
  return new Collection2(items);
}
function SymbolIterator2() {
  let index = -1;
  return {
    next: () => {
      index += 1;
      return {
        value: this.items[index],
        done: index >= this.items.length
      };
    }
  };
}
var Collection2;
var buildKeyPathMap3 = function buildKeyPathMap22(items) {
  const keyPaths = {};
  items.forEach((item, index) => {
    function buildKeyPath(val2, keyPath) {
      if (isObject22(val2)) {
        Object.keys(val2).forEach((prop) => {
          buildKeyPath(val2[prop], `${keyPath}.${prop}`);
        });
      } else if (isArray2(val2)) {
        val2.forEach((v22, i) => {
          buildKeyPath(v22, `${keyPath}.${i}`);
        });
      }
      keyPaths[keyPath] = val2;
    }
    buildKeyPath(item, index);
  });
  return keyPaths;
};
var init_src9 = __esm2(() => {
  init_helpers4();
  Collection2 = class Collection3 {
    items;
    constructor(items = []) {
      this.items = items;
    }
    [Symbol.iterator] = SymbolIterator2;
    toJSON() {
      return this.items;
    }
    all() {
      return this.items;
    }
    average(key) {
      if (key === undefined) {
        return this.sum() / Number(this.items.length);
      }
      if (isFunction2(key)) {
        return Number(new this.constructor(this.items).sum(key)) / Number(this.items.length);
      }
      return Number(new this.constructor(this.items).pluck(key).sum()) / Number(this.items.length);
    }
    avg = this.average;
    chunk(size) {
      const chunks = [];
      const items = Array.isArray(this.items) ? this.items : Object.values(this.items);
      for (let i = 0;i < items.length; i += size) {
        chunks.push(items.slice(i, i + size));
      }
      return new Collection3(chunks);
    }
    collapse() {
      return new this.constructor([].concat(...this.items));
    }
    combine(values3) {
      if (typeof values3 === "string") {
        values3 = [values3];
      }
      if (!Array.isArray(values3)) {
        throw new TypeError("The values must be an array or a string");
      }
      const collection = {};
      const keys = Array.isArray(this.items) ? this.items : Object.keys(this.items);
      keys.forEach((key, index) => {
        if (values3[index] !== undefined) {
          collection[key] = values3[index];
        }
      });
      return new Collection3(collection);
    }
    concat(collectionOrArrayOrObject) {
      let list = collectionOrArrayOrObject;
      if (collectionOrArrayOrObject instanceof this.constructor) {
        list = collectionOrArrayOrObject.all();
      } else if (typeof collectionOrArrayOrObject === "object") {
        list = [];
        Object.keys(collectionOrArrayOrObject).forEach((property) => {
          list.push(collectionOrArrayOrObject[property]);
        });
      }
      const collection = clone2(this.items);
      list.forEach((item) => {
        if (typeof item === "object") {
          Object.keys(item).forEach((key) => collection.push(item[key]));
        } else {
          collection.push(item);
        }
      });
      return new this.constructor(collection);
    }
    contains(key, value) {
      if (typeof key === "function") {
        return this.items.some(key);
      }
      if (Array.isArray(this.items)) {
        return this.items.includes(key);
      }
      if (value !== undefined) {
        if (Array.isArray(this.items)) {
          return this.items.some((item) => item[key] !== undefined && item[key] === value);
        }
        return key in this.items && this.items[key] === value;
      }
      if (Array.isArray(this.items)) {
        return this.items.includes(key);
      }
      return Object.values(this.items).includes(key);
    }
    containsOneItem() {
      if (typeof this.items === "string") {
        return true;
      }
      return Object.keys(this.items).length === 1;
    }
    count(predicate) {
      if (predicate) {
        return this.filter(predicate).count();
      }
      return Object.keys(this.items).length;
    }
    countBy(callback) {
      const counts = {};
      this.each((item) => {
        const key = callback ? callback(item) : item;
        counts[key] = (counts[key] || 0) + 1;
      });
      return new Collection3(counts);
    }
    crossJoin(...values3) {
      function join9(collection, constructor, args) {
        let current = args[0];
        if (current instanceof Collection3) {
          current = current.all();
        }
        const rest = args.slice(1);
        const last = !rest.length;
        let result2 = [];
        for (let i = 0;i < current.length; i += 1) {
          const collectionCopy = collection.slice();
          collectionCopy.push(current[i]);
          if (last) {
            result2.push(collectionCopy);
          } else {
            result2 = result2.concat(join9(collectionCopy, constructor, rest));
          }
        }
        return result2;
      }
      return new this.constructor(join9([], this.constructor, [].concat([this.items], values3)));
    }
    dd() {
      console.log(JSON.stringify(this.all(), null, 2));
      process72.exit();
    }
    diff(values3) {
      let valuesToDiff;
      if (values3 instanceof this.constructor) {
        valuesToDiff = values3.all();
      } else {
        valuesToDiff = values3;
      }
      const collection = this.items.filter((item) => !valuesToDiff.includes(item));
      return new this.constructor(collection);
    }
    diffAssoc(values3) {
      let diffValues = values3;
      if (values3 instanceof this.constructor) {
        diffValues = values3.all();
      }
      const collection = {};
      Object.keys(this.items).forEach((key) => {
        if (diffValues[key] === undefined || diffValues[key] !== this.items[key]) {
          collection[key] = this.items[key];
        }
      });
      return new this.constructor(collection);
    }
    diffKeys(object) {
      let objectToDiff;
      if (object instanceof this.constructor) {
        objectToDiff = object.all();
      } else {
        objectToDiff = object;
      }
      const objectKeys = Object.keys(objectToDiff);
      const remainingKeys = Object.keys(this.items).filter((item) => !objectKeys.includes(item));
      return new this.constructor(this.items).only(remainingKeys);
    }
    diffUsing(array, callback) {
      console.log("Original collection:", this.items);
      console.log("Array to compare:", array);
      if (array === null) {
        return new Collection3(this.items);
      }
      const collection = this.items.filter((item) => {
        const index = array.findIndex((otherItem) => {
          return callback(item, otherItem) === 0;
        });
        return index === -1;
      });
      return new Collection3(collection);
    }
    doesntContain(key, value) {
      console.log("doesntContain called with:", { key, value });
      if (typeof key === "function") {
        console.log("Function branch");
        return !this.contains(key);
      }
      if (value !== undefined) {
        console.log("Key-value pair branch");
        return !this.contains((item) => {
          console.log("Comparing:", item[key], "with", value);
          return item[key] === value;
        });
      }
      console.log("Single value branch");
      return !this.contains(key);
    }
    dump() {
      console.log(this.items);
      return this;
    }
    duplicates() {
      const occuredValues = [];
      const duplicateValues = {};
      const stringifiedValue = (value) => {
        if (Array.isArray(value) || typeof value === "object") {
          return JSON.stringify(value);
        }
        return value;
      };
      if (Array.isArray(this.items)) {
        this.items.forEach((value, index) => {
          const valueAsString = stringifiedValue(value);
          if (!occuredValues.includes(valueAsString)) {
            occuredValues.push(valueAsString);
          } else {
            duplicateValues[index] = value;
          }
        });
      } else if (typeof this.items === "object") {
        Object.keys(this.items).forEach((key) => {
          const valueAsString = stringifiedValue(this.items[key]);
          if (!occuredValues.includes(valueAsString)) {
            occuredValues.push(valueAsString);
          } else {
            duplicateValues[key] = this.items[key];
          }
        });
      }
      return new this.constructor(duplicateValues);
    }
    each(fn) {
      let stop = false;
      if (Array.isArray(this.items)) {
        const { length } = this.items;
        for (let index = 0;index < length && !stop; index += 1) {
          stop = fn(this.items[index], index, this.items) === false;
        }
      } else {
        const keys = Object.keys(this.items);
        const { length } = keys;
        for (let index = 0;index < length && !stop; index += 1) {
          const key = keys[index];
          stop = fn(this.items[key], key, this.items) === false;
        }
      }
      return this;
    }
    eachSpread(fn) {
      this.each((values3, key) => {
        fn(...values3, key);
      });
      return this;
    }
    every(fn) {
      const items = values2(this.items);
      return items.every(fn);
    }
    except(keys) {
      const result2 = { ...this.items };
      const keysArray = Array.isArray(keys) ? keys : [keys];
      keysArray.forEach((key) => delete result2[key]);
      return new Collection3(result2);
    }
    filter(callback) {
      console.log("Filter method called with callback:", callback);
      console.log("Current items:", this.items);
      if (typeof callback !== "function") {
        console.log("No callback provided, removing falsy values");
        const filteredItems2 = this.items.filter((item) => {
          console.log("Filtering item:", item);
          return Boolean(item);
        });
        console.log("Filtered items:", filteredItems2);
        return new Collection3(filteredItems2);
      }
      const filteredItems = this.items.filter((item, index) => {
        console.log("Filtering item:", item, "at index:", index);
        return callback(item, index);
      });
      console.log("Filtered items:", filteredItems);
      return new Collection3(filteredItems);
    }
    first(fn, defaultValue) {
      if (isFunction2(fn)) {
        const keys = Object.keys(this.items);
        for (let i = 0;i < keys.length; i += 1) {
          const key = keys[i];
          const item = this.items[key];
          if (fn(item, key)) {
            return item;
          }
        }
        if (isFunction2(defaultValue)) {
          return defaultValue();
        }
        return defaultValue;
      }
      if (Array.isArray(this.items) && this.items.length || Object.keys(this.items).length) {
        if (Array.isArray(this.items)) {
          return this.items[0];
        }
        const firstKey = Object.keys(this.items)[0];
        return this.items[firstKey];
      }
      if (isFunction2(defaultValue)) {
        return defaultValue();
      }
      return defaultValue;
    }
    firstOrFail(callback) {
      const found = this.items.find(callback || (() => true));
      if (found === undefined) {
        throw new Error("Item not found.");
      }
      return found;
    }
    firstWhere(key, operator, value) {
      return this.where(key, operator, value).first() || null;
    }
    flatMap(fn) {
      return this.map(fn).collapse();
    }
    flatten(depth = Number.POSITIVE_INFINITY) {
      const flatten = (item, d) => {
        if (!Array.isArray(item) && typeof item !== "object") {
          return [item];
        }
        return d > 0 ? Object.values(item).reduce((acc, val2) => acc.concat(Array.isArray(val2) || typeof val2 === "object" ? flatten(val2, d - 1) : val2), []) : Array.isArray(item) ? [...item] : [item];
      };
      return new Collection3(flatten(this.items, depth));
    }
    flip() {
      const flipped = {};
      if (Array.isArray(this.items)) {
        this.items.forEach((value, index) => {
          flipped[value] = index;
        });
      } else {
        Object.entries(this.items).forEach(([key, value]) => {
          flipped[value] = key;
        });
      }
      return new this.constructor(flipped);
    }
    forPage(page, chunk) {
      let collection = {};
      if (Array.isArray(this.items)) {
        collection = this.items.slice(page * chunk - chunk, page * chunk);
      } else {
        Object.keys(this.items).slice(page * chunk - chunk, page * chunk).forEach((key) => {
          collection[key] = this.items[key];
        });
      }
      return new this.constructor(collection);
    }
    forget(key) {
      if (Array.isArray(this.items)) {
        this.items = this.items.filter((item, index) => index !== Number.parseInt(key, 10));
      } else if (typeof this.items === "object" && this.items !== null) {
        delete this.items[key];
      }
      return this;
    }
    get(key, defaultValue = null) {
      if (Array.isArray(this.items)) {
        return this.items[key] ?? defaultValue;
      }
      return this.items[key] ?? defaultValue;
    }
    groupBy(fn) {
      const groups = {};
      this.each((item, key) => {
        const groupKey = typeof fn === "function" ? fn(item) : item[fn];
        if (!(groupKey in groups)) {
          groups[groupKey] = new Collection3;
        }
        groups[groupKey].push(item);
      });
      return new Collection3(groups);
    }
    has(key) {
      if (Array.isArray(this.items)) {
        return key in this.items;
      }
      return key in this.items;
    }
    implode(key, glue) {
      if (glue === undefined) {
        return this.items.join(key);
      }
      return new this.constructor(this.items).pluck(key).all().join(glue);
    }
    includes(key) {
      if (Array.isArray(this.items)) {
        return this.items.includes(key);
      }
      return Object.values(this.items).includes(key);
    }
    intersect(values3) {
      let intersectValues = values3;
      if (values3 instanceof this.constructor) {
        intersectValues = values3.all();
      }
      const collection = this.items.filter((item) => intersectValues.includes(item));
      return new this.constructor(collection);
    }
    intersectByKeys(values3) {
      let intersectKeys = Object.keys(values3);
      if (values3 instanceof this.constructor) {
        intersectKeys = Object.keys(values3.all());
      }
      const collection = {};
      Object.keys(this.items).forEach((key) => {
        if (intersectKeys.includes(key)) {
          collection[key] = this.items[key];
        }
      });
      return new this.constructor(collection);
    }
    isEmpty() {
      return this.count() === 0;
    }
    isNotEmpty() {
      return !this.isEmpty();
    }
    join(glue, finalGlue) {
      const collection = this.values();
      if (finalGlue === undefined) {
        return collection.implode(glue);
      }
      const count = collection.count();
      if (count === 0) {
        return "";
      }
      if (count === 1) {
        return collection.last();
      }
      const finalItem = collection.pop();
      return collection.implode(glue) + finalGlue + finalItem;
    }
    keyBy(key) {
      const collection = {};
      if (isFunction2(key)) {
        this.items.forEach((item) => {
          collection[key(item)] = item;
        });
      } else {
        this.items.forEach((item) => {
          const keyValue = nestedValue2(item, key);
          collection[keyValue || ""] = item;
        });
      }
      return new this.constructor(collection);
    }
    keys() {
      return new Collection3(Object.keys(this.items));
    }
    last(fn, defaultValue) {
      let { items } = this;
      if (isFunction2(fn)) {
        items = this.filter(fn).all();
      }
      if (Array.isArray(items) && !items.length || !Object.keys(items).length) {
        if (isFunction2(defaultValue)) {
          return defaultValue();
        }
        return defaultValue;
      }
      if (Array.isArray(items)) {
        return items[items.length - 1];
      }
      const keys = Object.keys(items);
      return items[keys[keys.length - 1]];
    }
    macro(name, fn) {
      this.constructor.prototype[name] = fn;
    }
    make(items = []) {
      return new this.constructor(items);
    }
    map(fn) {
      if (Array.isArray(this.items)) {
        return new this.constructor(this.items.map(fn));
      }
      const collection = {};
      Object.keys(this.items).forEach((key) => {
        collection[key] = fn(this.items[key], Number(key));
      });
      return new this.constructor(collection);
    }
    mapSpread(fn) {
      return this.map((values3, key) => fn(...values3, key));
    }
    mapToDictionary(fn) {
      const collection = {};
      this.items.forEach((item, k) => {
        const [key, value] = fn(item, k);
        if (collection[key] === undefined) {
          collection[key] = [value];
        } else {
          collection[key].push(value);
        }
      });
      return new this.constructor(collection);
    }
    mapInto(ClassName) {
      return this.map((value, key) => new ClassName(value, key));
    }
    mapToGroups(fn) {
      const collection = {};
      this.items.forEach((item, key) => {
        const [keyed, value] = fn(item, key);
        if (collection[keyed] === undefined) {
          collection[keyed] = [value];
        } else {
          collection[keyed].push(value);
        }
      });
      return new this.constructor(collection);
    }
    mapWithKeys(fn) {
      const collection = {};
      if (Array.isArray(this.items)) {
        this.items.forEach((item, index) => {
          const [keyed, value] = fn(item, index);
          collection[keyed] = value;
        });
      } else {
        Object.keys(this.items).forEach((key) => {
          const [keyed, value] = fn(this.items[key], Number(key));
          collection[keyed] = value;
        });
      }
      return new this.constructor(collection);
    }
    max(key) {
      if (typeof key === "string") {
        const filtered = this.items.filter((item) => item[key] !== undefined);
        return Math.max(...filtered.map((item) => item[key]));
      }
      return Math.max(...this.items);
    }
    median(key) {
      const { length } = this.items;
      if (key === undefined) {
        if (length % 2 === 0) {
          return (this.items[length / 2 - 1] + this.items[length / 2]) / 2;
        }
        return this.items[Math.floor(length / 2)];
      }
      if (length % 2 === 0) {
        return (this.items[length / 2 - 1][key] + this.items[length / 2][key]) / 2;
      }
      return this.items[Math.floor(length / 2)][key];
    }
    merge(object) {
      const merged = { ...this.items, ...object };
      return new Collection3(merged);
    }
    mergeRecursive(items) {
      const merge = (target, source) => {
        const merged = {};
        const mergedKeys = Object.keys({ ...target, ...source });
        mergedKeys.forEach((key) => {
          if (target[key] === undefined && source[key] !== undefined) {
            merged[key] = source[key];
          } else if (target[key] !== undefined && source[key] === undefined) {
            merged[key] = target[key];
          } else if (target[key] !== undefined && source[key] !== undefined) {
            if (target[key] === source[key]) {
              merged[key] = target[key];
            } else if (!Array.isArray(target[key]) && typeof target[key] === "object" && !Array.isArray(source[key]) && typeof source[key] === "object") {
              merged[key] = merge(target[key], source[key]);
            } else {
              merged[key] = [].concat(target[key], source[key]);
            }
          }
        });
        return merged;
      };
      if (!items) {
        return this;
      }
      if (items.constructor.name === "Collection") {
        return new this.constructor(merge(this.items, items.all()));
      }
      return new this.constructor(merge(this.items, items));
    }
    min(key) {
      if (key !== undefined) {
        const filtered = this.items.filter((item) => item[key] !== undefined);
        return Math.min(...filtered.map((item) => item[key]));
      }
      return Math.min(...this.items);
    }
    mode(key) {
      const values3 = [];
      let highestCount = 1;
      if (!this.items.length) {
        return null;
      }
      this.items.forEach((item) => {
        const tempValues = values3.filter((value) => {
          if (key !== undefined) {
            return value.key === item[key];
          }
          return value.key === item;
        });
        if (!tempValues.length) {
          if (key !== undefined) {
            values3.push({ key: item[key], count: 1 });
          } else {
            values3.push({ key: item, count: 1 });
          }
        } else {
          tempValues[0].count += 1;
          const { count } = tempValues[0];
          if (count > highestCount) {
            highestCount = count;
          }
        }
      });
      return values3.filter((value) => value.count === highestCount).map((value) => value.key);
    }
    nth(n, offset = 0) {
      const items = values2(this.items);
      const collection = items.slice(offset).filter((item, index) => index % n === 0);
      return new this.constructor(collection);
    }
    only(keys) {
      const result2 = {};
      keys.forEach((key) => {
        if (key in this.items)
          result2[key] = this.items[key];
      });
      return new Collection3(result2);
    }
    pad(size, value) {
      const abs = Math.abs(size);
      const count = this.count();
      if (abs <= count) {
        return this;
      }
      let diff = abs - count;
      const items = clone2(this.items);
      const isArray22 = Array.isArray(this.items);
      const prepend = size < 0;
      for (let iterator = 0;iterator < diff; ) {
        if (!isArray22) {
          if (items[iterator] !== undefined) {
            diff += 1;
          } else {
            items[iterator] = value;
          }
        } else if (prepend) {
          items.unshift(value);
        } else {
          items.push(value);
        }
        iterator += 1;
      }
      return new this.constructor(items);
    }
    partition(fn) {
      let arrays;
      if (Array.isArray(this.items)) {
        arrays = [new this.constructor([]), new this.constructor([])];
        this.items.forEach((item) => {
          if (fn(item) === true) {
            arrays[0].push(item);
          } else {
            arrays[1].push(item);
          }
        });
      } else {
        arrays = [new this.constructor({}), new this.constructor({})];
        Object.keys(this.items).forEach((prop) => {
          const value = this.items[prop];
          if (fn(value) === true) {
            arrays[0].put(prop, value);
          } else {
            arrays[1].put(prop, value);
          }
        });
      }
      return new this.constructor(arrays);
    }
    pipe(fn) {
      return fn(this);
    }
    pluck(value, key) {
      if (value.includes("*")) {
        const keyPathMap = buildKeyPathMap3(this.items);
        const keyMatches = [];
        if (key !== undefined) {
          const keyRegex = new RegExp(`0.${key}`, "g");
          const keyNumberOfLevels = `0.${key}`.split(".").length;
          Object.keys(keyPathMap).forEach((k) => {
            const matchingKey = k.match(keyRegex);
            if (matchingKey) {
              const match = matchingKey[0];
              if (match.split(".").length === keyNumberOfLevels) {
                keyMatches.push(keyPathMap[match]);
              }
            }
          });
        }
        const valueMatches = [];
        const valueRegex = new RegExp(`0.${value}`, "g");
        const valueNumberOfLevels = `0.${value}`.split(".").length;
        Object.keys(keyPathMap).forEach((k) => {
          const matchingValue = k.match(valueRegex);
          if (matchingValue) {
            const match = matchingValue[0];
            if (match.split(".").length === valueNumberOfLevels) {
              valueMatches.push(keyPathMap[match]);
            }
          }
        });
        if (key !== undefined) {
          const collection = {};
          this.items.forEach((item, index) => {
            collection[keyMatches[index] || ""] = valueMatches;
          });
          return new this.constructor(collection);
        }
        return new this.constructor([valueMatches]);
      }
      if (key !== undefined) {
        const collection = {};
        this.items.forEach((item) => {
          if (nestedValue2(item, value) !== undefined) {
            collection[item[key] || ""] = nestedValue2(item, value);
          } else {
            collection[item[key] || ""] = null;
          }
        });
        return new this.constructor(collection);
      }
      return this.map((item) => {
        if (nestedValue2(item, value) !== undefined) {
          return nestedValue2(item, value);
        }
        return null;
      });
    }
    pop(count = 1) {
      if (this.isEmpty()) {
        return null;
      }
      if (isArray2(this.items)) {
        if (count === 1) {
          return this.items.pop();
        }
        return new this.constructor(this.items.splice(-count));
      }
      if (isObject22(this.items)) {
        const keys = Object.keys(this.items);
        if (count === 1) {
          const key = keys[keys.length - 1];
          const last = this.items[key];
          deleteKeys2(this.items, key);
          return last;
        }
        const poppedKeys = keys.slice(-count);
        const newObject = poppedKeys.reduce((acc, current) => {
          acc[current] = this.items[current];
          return acc;
        }, {});
        deleteKeys2(this.items, poppedKeys);
        return new this.constructor(newObject);
      }
      return null;
    }
    prepend(value, key) {
      if (key !== undefined) {
        return this.put(key, value);
      }
      this.items.unshift(value);
      return this;
    }
    pull(key, defaultValue = null) {
      if (Array.isArray(this.items)) {
        const index = Number(key);
        if (Number.isNaN(index))
          return defaultValue;
        const value2 = this.items[index];
        this.items.splice(index, 1);
        return value2 ?? defaultValue;
      }
      const value = this.items[key];
      delete this.items[key];
      return value ?? defaultValue;
    }
    push(...items) {
      this.items = [...this.items, ...items];
      return this;
    }
    put(key, value) {
      this.items[key] = value;
      return this;
    }
    random(length = null) {
      const items = values2(this.items);
      const collection = new this.constructor(items).shuffle();
      if (length !== Number.parseInt(length, 10)) {
        return collection.first();
      }
      return collection.take(length);
    }
    reduce(fn, carry) {
      let reduceCarry = null;
      if (carry !== undefined) {
        reduceCarry = carry;
      }
      if (Array.isArray(this.items)) {
        this.items.forEach((item) => {
          reduceCarry = fn(reduceCarry, item);
        });
      } else {
        Object.keys(this.items).forEach((key) => {
          reduceCarry = fn(reduceCarry, this.items[key], key);
        });
      }
      return reduceCarry;
    }
    reject(fn) {
      return new this.constructor(this.items).filter((item) => !fn(item));
    }
    replace(items) {
      if (!items) {
        return this;
      }
      if (Array.isArray(items)) {
        const replaced2 = this.items.map((value, index) => items[index] || value);
        return new this.constructor(replaced2);
      }
      if (items.constructor.name === "Collection") {
        const replaced2 = { ...this.items, ...items.all() };
        return new this.constructor(replaced2);
      }
      const replaced = { ...this.items, ...items };
      return new this.constructor(replaced);
    }
    replaceRecursive(items) {
      const replace22 = (target, source) => {
        const replaced = { ...target };
        const mergedKeys = Object.keys({ ...target, ...source });
        mergedKeys.forEach((key) => {
          if (!Array.isArray(source[key]) && typeof source[key] === "object") {
            replaced[key] = replace22(target[key], source[key]);
          } else if (target[key] === undefined && source[key] !== undefined) {
            if (typeof target[key] === "object") {
              replaced[key] = { ...source[key] };
            } else {
              replaced[key] = source[key];
            }
          } else if (target[key] !== undefined && source[key] === undefined) {
            if (typeof target[key] === "object") {
              replaced[key] = { ...target[key] };
            } else {
              replaced[key] = target[key];
            }
          } else if (target[key] !== undefined && source[key] !== undefined) {
            if (typeof source[key] === "object") {
              replaced[key] = { ...source[key] };
            } else {
              replaced[key] = source[key];
            }
          }
        });
        return replaced;
      };
      if (!items) {
        return this;
      }
      if (!Array.isArray(items) && typeof items !== "object") {
        return new this.constructor(replace22(this.items, [items]));
      }
      if (items.constructor.name === "Collection") {
        return new this.constructor(replace22(this.items, items.all()));
      }
      return new this.constructor(replace22(this.items, items));
    }
    reverse() {
      const collection = [].concat(this.items).reverse();
      return new this.constructor(collection);
    }
    search(valueOrFunction, strict) {
      let result2;
      const find = (item, key) => {
        if (isFunction2(valueOrFunction)) {
          return valueOrFunction(this.items[key], key);
        }
        if (strict) {
          return this.items[key] === valueOrFunction;
        }
        return this.items[key] == valueOrFunction;
      };
      if (isArray2(this.items)) {
        result2 = this.items.findIndex(find);
      } else if (isObject22(this.items)) {
        result2 = Object.keys(this.items).find((key) => find(this.items[key], key));
      }
      if (result2 === undefined || result2 < 0) {
        return false;
      }
      return result2;
    }
    shift(count = 1) {
      if (this.isEmpty()) {
        return null;
      }
      if (isArray2(this.items)) {
        if (count === 1) {
          return this.items.shift();
        }
        return new this.constructor(this.items.splice(0, count));
      }
      if (isObject22(this.items)) {
        if (count === 1) {
          const key = Object.keys(this.items)[0];
          const value = this.items[key];
          delete this.items[key];
          return value;
        }
        const keys = Object.keys(this.items);
        const poppedKeys = keys.slice(0, count);
        const newObject = poppedKeys.reduce((acc, current) => {
          acc[current] = this.items[current];
          return acc;
        }, {});
        deleteKeys2(this.items, poppedKeys);
        return new this.constructor(newObject);
      }
      return null;
    }
    shuffle() {
      const items = values2(this.items);
      let j22;
      let x;
      let i;
      for (i = items.length;i; i -= 1) {
        j22 = Math.floor(Math.random() * i);
        x = items[i - 1];
        items[i - 1] = items[j22];
        items[j22] = x;
      }
      this.items = items;
      return this;
    }
    skip(number) {
      if (isObject22(this.items)) {
        return new this.constructor(Object.keys(this.items).reduce((accumulator, key, index) => {
          if (index + 1 > number) {
            accumulator[key] = this.items[key];
          }
          return accumulator;
        }, {}));
      }
      return new this.constructor(this.items.slice(number));
    }
    skipUntil(valueOrFunction) {
      let previous = null;
      let items;
      let callback = (value) => value === valueOrFunction;
      if (isFunction2(valueOrFunction)) {
        callback = valueOrFunction;
      }
      if (isArray2(this.items)) {
        items = this.items.filter((item) => {
          if (previous !== true) {
            previous = callback(item);
          }
          return previous;
        });
      }
      if (isObject22(this.items)) {
        items = Object.keys(this.items).reduce((acc, key) => {
          if (previous !== true) {
            previous = callback(this.items[key]);
          }
          if (previous !== false) {
            acc[key] = this.items[key];
          }
          return acc;
        }, {});
      }
      return new this.constructor(items);
    }
    skipWhile(valueOrFunction) {
      let previous = null;
      let items;
      let callback = (value) => value === valueOrFunction;
      if (isFunction2(valueOrFunction)) {
        callback = valueOrFunction;
      }
      if (isArray2(this.items)) {
        items = this.items.filter((item) => {
          if (previous !== true) {
            previous = !callback(item);
          }
          return previous;
        });
      }
      if (isObject22(this.items)) {
        items = Object.keys(this.items).reduce((acc, key) => {
          if (previous !== true) {
            previous = !callback(this.items[key]);
          }
          if (previous !== false) {
            acc[key] = this.items[key];
          }
          return acc;
        }, {});
      }
      return new this.constructor(items);
    }
    slice(remove, limit) {
      let collection = this.items.slice(remove);
      if (limit !== undefined) {
        collection = collection.slice(0, limit);
      }
      return new this.constructor(collection);
    }
    sole() {
      if (this.items.length !== 1) {
        throw new Error("Collection does not contain exactly one item.");
      }
      return this.items[0];
    }
    some(key) {
      return this.items.some((item) => item.hasOwnProperty(key));
    }
    sort(fn) {
      const collection = [].concat(this.items);
      if (fn === undefined) {
        if (this.every((item) => typeof item === "number")) {
          collection.sort((a, b22) => a - b22);
        } else {
          collection.sort();
        }
      } else {
        collection.sort(fn);
      }
      return new this.constructor(collection);
    }
    sortDesc() {
      return this.sort().reverse();
    }
    sortBy(valueOrFunction) {
      const collection = [].concat(this.items);
      const getValue = (item) => {
        if (isFunction2(valueOrFunction)) {
          return valueOrFunction(item);
        }
        return nestedValue2(item, valueOrFunction);
      };
      collection.sort((a, b22) => {
        const valueA = getValue(a);
        const valueB = getValue(b22);
        if (valueA === null || valueA === undefined) {
          return 1;
        }
        if (valueB === null || valueB === undefined) {
          return -1;
        }
        if (valueA < valueB) {
          return -1;
        }
        if (valueA > valueB) {
          return 1;
        }
        return 0;
      });
      return new this.constructor(collection);
    }
    sortByDesc(valueOrFunction) {
      return this.sortBy(valueOrFunction).reverse();
    }
    sortKeys() {
      const ordered = {};
      Object.keys(this.items).sort().forEach((key) => {
        ordered[key] = this.items[key];
      });
      return new this.constructor(ordered);
    }
    sortKeysDesc() {
      const ordered = {};
      Object.keys(this.items).sort().reverse().forEach((key) => {
        ordered[key] = this.items[key];
      });
      return new this.constructor(ordered);
    }
    splice(index, limit, replace22) {
      const slicedCollection = this.slice(index, limit);
      this.items = this.diff(slicedCollection.all()).all();
      if (Array.isArray(replace22)) {
        for (let iterator = 0, { length } = replace22;iterator < length; iterator += 1) {
          this.items.splice(index + iterator, 0, replace22[iterator]);
        }
      }
      return slicedCollection;
    }
    split(numberOfGroups) {
      const itemsArray = this.toArray();
      const groups = [];
      const size = Math.ceil(itemsArray.length / numberOfGroups);
      for (let i = 0;i < itemsArray.length; i += size) {
        groups.push(itemsArray.slice(i, i + size));
      }
      return new Collection3(groups);
    }
    sum(key) {
      const items = values2(this.items);
      let total = 0;
      if (key === undefined) {
        for (let i = 0, { length } = items;i < length; i += 1) {
          total += Number.parseFloat(items[i]);
        }
      } else if (isFunction2(key)) {
        for (let i = 0, { length } = items;i < length; i += 1) {
          total += Number.parseFloat(key(items[i]));
        }
      } else {
        for (let i = 0, { length } = items;i < length; i += 1) {
          total += Number.parseFloat(items[i][key]);
        }
      }
      return Number.parseFloat(total.toPrecision(12));
    }
    take(length) {
      if (!Array.isArray(this.items) && typeof this.items === "object") {
        const keys = Object.keys(this.items);
        let slicedKeys;
        if (length < 0) {
          slicedKeys = keys.slice(length);
        } else {
          slicedKeys = keys.slice(0, length);
        }
        const collection = {};
        keys.forEach((prop) => {
          if (slicedKeys.includes(prop)) {
            collection[prop] = this.items[prop];
          }
        });
        return new this.constructor(collection);
      }
      if (length < 0) {
        return new this.constructor(this.items.slice(length));
      }
      return new this.constructor(this.items.slice(0, length));
    }
    takeUntil(valueOrFunction) {
      let previous = null;
      let items;
      let callback = (value) => value === valueOrFunction;
      if (isFunction2(valueOrFunction)) {
        callback = valueOrFunction;
      }
      if (isArray2(this.items)) {
        items = this.items.filter((item) => {
          if (previous !== false) {
            previous = !callback(item);
          }
          return previous;
        });
      }
      if (isObject22(this.items)) {
        items = Object.keys(this.items).reduce((acc, key) => {
          if (previous !== false) {
            previous = !callback(this.items[key]);
          }
          if (previous !== false) {
            acc[key] = this.items[key];
          }
          return acc;
        }, {});
      }
      return new this.constructor(items);
    }
    takeWhile(valueOrFunction) {
      let previous = null;
      let items;
      let callback = (value) => value === valueOrFunction;
      if (isFunction2(valueOrFunction)) {
        callback = valueOrFunction;
      }
      if (isArray2(this.items)) {
        items = this.items.filter((item) => {
          if (previous !== false) {
            previous = callback(item);
          }
          return previous;
        });
      }
      if (isObject22(this.items)) {
        items = Object.keys(this.items).reduce((acc, key) => {
          if (previous !== false) {
            previous = callback(this.items[key]);
          }
          if (previous !== false) {
            acc[key] = this.items[key];
          }
          return acc;
        }, {});
      }
      return new this.constructor(items);
    }
    tap(fn) {
      fn(this);
      return this;
    }
    times(n, fn) {
      for (let iterator = 1;iterator <= n; iterator += 1) {
        this.items.push(fn(iterator));
      }
      return this;
    }
    toArray() {
      return Array.isArray(this.items) ? this.items : Object.values(this.items);
    }
    toJson() {
      return JSON.stringify(this.items);
    }
    transform(fn) {
      if (Array.isArray(this.items)) {
        this.items = this.items.map(fn);
      } else {
        const collection = {};
        Object.keys(this.items).forEach((key) => {
          collection[key] = fn(this.items[key], key);
        });
        this.items = collection;
      }
      return this;
    }
    undot() {
      if (Array.isArray(this.items)) {
        return this;
      }
      let collection = {};
      Object.keys(this.items).forEach((key) => {
        if (key.includes(".")) {
          const obj = collection;
          key.split(".").reduce((acc, current, index, array) => {
            if (!acc[current]) {
              acc[current] = {};
            }
            if (index === array.length - 1) {
              acc[current] = this.items[key];
            }
            return acc[current];
          }, obj);
          collection = { ...collection, ...obj };
        } else {
          collection[key] = this.items[key];
        }
      });
      return new this.constructor(collection);
    }
    unless(value, fn, defaultFn) {
      if (!value) {
        return fn(this);
      }
      if (defaultFn)
        return defaultFn();
      return;
    }
    unlessEmpty(callback) {
      if (!this.isEmpty()) {
        callback(this);
      }
      return this;
    }
    unlessNotEmpty(callback) {
      if (this.isEmpty()) {
        callback(this);
      }
      return this;
    }
    union(object) {
      const collection = JSON.parse(JSON.stringify(this.items));
      Object.keys(object).forEach((prop) => {
        if (this.items[prop] === undefined) {
          collection[prop] = object[prop];
        }
      });
      return new this.constructor(collection);
    }
    unique() {
      const uniqueItems = Array.from(new Set(this.items));
      return new this.constructor(uniqueItems);
    }
    unwrap() {
      return this.items;
    }
    values() {
      return new Collection3(Object.values(this.items));
    }
    when(value, callback, defaultCallback) {
      if (value) {
        callback(this, value);
      } else if (defaultCallback) {
        defaultCallback();
      }
      return this;
    }
    whenEmpty(fn, defaultFn) {
      if (Array.isArray(this.items) && !this.items.length) {
        return fn(this);
      }
      if (!Object.keys(this.items).length) {
        return fn(this);
      }
      if (defaultFn !== undefined) {
        if (Array.isArray(this.items) && this.items.length) {
          return defaultFn(this);
        }
        if (Object.keys(this.items).length) {
          return defaultFn(this);
        }
      }
      return this;
    }
    whenNotEmpty(fn, defaultFn) {
      if (Array.isArray(this.items) && this.items.length) {
        return fn(this);
      }
      if (Object.keys(this.items).length) {
        return fn(this);
      }
      if (defaultFn !== undefined) {
        if (Array.isArray(this.items) && !this.items.length) {
          return defaultFn(this);
        }
        if (!Object.keys(this.items).length) {
          return defaultFn(this);
        }
      }
      return this;
    }
    where(key, operator, value) {
      if (arguments.length === 1) {
        return new Collection3(this.items.filter((item) => item[key] !== undefined));
      }
      if (arguments.length === 2) {
        value = operator;
        operator = "===";
      }
      const compareValues = (item, key2, value2, operator2) => {
        const itemValue = item[key2];
        switch (operator2) {
          case "===":
            return itemValue === value2;
          case "!==":
            return itemValue !== value2;
          case "<":
            return itemValue < value2;
          case "<=":
            return itemValue <= value2;
          case ">":
            return itemValue > value2;
          case ">=":
            return itemValue >= value2;
          default:
            return itemValue == value2;
        }
      };
      return new Collection3(this.items.filter((item) => compareValues(item, key, value, operator)));
    }
    whereBetween(key, values3) {
      return this.filter((item) => {
        const itemValue = typeof item === "object" ? item[key] : item;
        return itemValue >= values3[0] && itemValue <= values3[1];
      });
    }
    whereIn(key, values3) {
      return this.filter((item) => {
        const itemValue = typeof item === "object" ? item[key] : item;
        return values3.includes(itemValue);
      });
    }
    whereNotBetween(key, values3) {
      return this.filter((item) => {
        const itemValue = typeof item === "object" ? item[key] : item;
        return itemValue < values3[0] || itemValue > values3[1];
      });
    }
    whereNotIn(key, values3) {
      const filteredItems = this.items.filter((item) => {
        const keys = key.split(".");
        let value = item;
        for (const k of keys) {
          if (value[k] === undefined)
            return true;
          value = value[k];
        }
        return !values3.includes(value);
      });
      return new Collection3(filteredItems);
    }
    getNestedValue(item, key) {
      const keys = key.split(".");
      return keys.reduce((obj, k) => obj && obj[k] !== undefined ? obj[k] : null, item);
    }
    whereInstanceOf(type) {
      return this.filter((item) => item instanceof type);
    }
    whereNotNull(key) {
      return this.where(key, "!==", null);
    }
    whereNull(key) {
      return this.where(key, "===", null);
    }
    static wrap(value) {
      if (value instanceof Collection3)
        return value;
      return new Collection3(Array.isArray(value) ? value : [value]);
    }
    static unwrap(value) {
      if (value instanceof Collection3) {
        return value.all();
      }
      return value;
    }
    wrap(value) {
      if (value instanceof Collection3) {
        return value;
      }
      if (typeof value === "object") {
        return new Collection3(value);
      }
      return new Collection3([value]);
    }
    zip(...arrays) {
      const arrayOfArrays = arrays.map((arg) => this.constructor.wrap(arg).all());
      const zipped = this.items.map((item, index) => {
        const values3 = [item];
        arrayOfArrays.forEach((array) => {
          values3.push(array[index]);
        });
        return new this.constructor(values3);
      });
      return new this.constructor(zipped);
    }
  };
});
var quotes2;
var init_utils4 = __esm2(() => {
  init_src9();
  init_utils3();
  init_esm();
  init_esm();
  quotes2 = collect2([
    "The best way to get started is to quit talking and begin doing.",
    "The pessimist sees difficulty in every opportunity. The optimist sees opportunity in every difficulty.",
    "Don\u2019t let yesterday take up too much of today.",
    "You learn more from failure than from success. Don\u2019t let it stop you. Failure builds character.",
    "It\u2019s not whether you get knocked down, it\u2019s whether you get up.",
    "If you are working on something that you really care about, you don\u2019t have to be pushed. The vision pulls you.",
    "People who are crazy enough to think they can change the world, are the ones who do.",
    "Failure will never overtake me if my determination to succeed is strong enough.",
    "Entrepreneurs are great at dealing with uncertainty and also very good at minimizing risk. That\u2019s the classic entrepreneur.",
    "We may encounter many defeats but we must not be defeated.",
    "Knowing is not enough; we must apply. Wishing is not enough; we must do.",
    "Imagine your life is perfect in every respect; what would it look like?",
    "We generate fears while we sit. We overcome them by action.",
    "Whether you think you can or think you can\u2019t, you\u2019re right.",
    "Security is mostly a superstition. Life is either a daring adventure or nothing."
  ]);
});
var init_src10 = __esm2(() => {
  init_actions();
  init_cli();
  init_command();
  init_console();
  init_exec();
  init_helpers3();
  init_parse();
  init_run();
  init_spinner();
  init_utils4();
});
function actionsPath(path3) {
  return corePath(`actions/${path3 || ""}`);
}
function relativeActionsPath(path3) {
  return relative2(projectPath2(), actionsPath(path3));
}
function userActionsPath(path3, options3) {
  const absolutePath = appPath2(`Actions/${path3 || ""}`);
  if (options3?.relative)
    return relative2(process8.cwd(), absolutePath);
  return absolutePath;
}
function builtUserActionsPath(path3, options3) {
  const absolutePath = frameworkPath(`actions/${path3 || ""}`);
  if (options3?.relative)
    return relative2(process8.cwd(), absolutePath);
  return absolutePath;
}
function userComponentsPath(path3) {
  return libsPath(`components/${path3 || ""}`);
}
function userViewsPath(path3) {
  return resourcesPath(`views/${path3 || ""}`);
}
function userFunctionsPath(path3) {
  return resourcesPath(`functions/${path3 || ""}`);
}
function userJobsPath(path3) {
  return appPath2(`Jobs/${path3 || ""}`);
}
function userListenersPath(path3) {
  return appPath2(`Listeners/${path3 || ""}`);
}
function userMiddlewarePath(path3) {
  return appPath2(`Middleware/${path3 || ""}`);
}
function userModelsPath(path3) {
  return appPath2(`Models/${path3 || ""}`);
}
function userNotificationsPath(path3) {
  return appPath2(`Notifications/${path3 || ""}`);
}
function userDatabasePath2(path3) {
  return projectPath2(`database/${path3 || ""}`);
}
function userMigrationsPath(path3) {
  return userDatabasePath2(`migrations/${path3 || ""}`);
}
function userEventsPath() {
  return appPath2(`Events.ts`);
}
function aiPath(path3) {
  return corePath(`ai/${path3 || ""}`);
}
function assetsPath(path3) {
  return resourcesPath(`assets/${path3 || ""}`);
}
function aliasPath() {
  return corePath("alias/src/index.ts");
}
function buddyPath(path3, options3) {
  const absolutePath = corePath(`buddy/${path3 || ""}`);
  if (options3?.relative)
    return relative2(process8.cwd(), absolutePath);
  return absolutePath;
}
function runtimePath(path3) {
  return frameworkPath(`buddy/${path3 || ""}`);
}
function analyticsPath(path3) {
  return corePath(`analytics/${path3 || ""}`);
}
function arraysPath(path3) {
  return corePath(`arrays/${path3 || ""}`);
}
function appPath2(path3) {
  return projectPath2(`app/${path3 || ""}`);
}
function authPath(path3) {
  return corePath(`auth/${path3 || ""}`);
}
function coreApiPath(path3) {
  return corePath(`api/${path3 || ""}`);
}
function buildPath(path3) {
  return corePath(`build/${path3 || ""}`);
}
function buildEnginePath(path3) {
  return buildPath(`${path3 || ""}`);
}
function libsPath(path3) {
  return frameworkPath(`libs/${path3 || ""}`);
}
function userLibsPath(path3) {
  return resourcesPath(`${path3 || ""}`);
}
function libsEntriesPath(path3) {
  return libsPath(`entries/${path3 || ""}`);
}
function cachePath(path3) {
  return corePath(`cache/${path3 || ""}`);
}
function chatPath(path3) {
  return corePath(`chat/${path3 || ""}`);
}
function cliPath(path3) {
  return corePath(`cli/${path3 || ""}`);
}
function cloudPath(path3) {
  return corePath(`cloud/${path3 || ""}`);
}
function frameworkCloudPath(path3) {
  return frameworkPath(`cloud/${path3 || ""}`);
}
function collectionsPath(path3) {
  return corePath(`collections/${path3 || ""}`);
}
function commandsPath2(path3) {
  return appPath2(`Commands/${path3 || ""}`);
}
function componentsPath(path3) {
  return userLibsPath(`components/${path3 || ""}`);
}
function configPath(path3) {
  return corePath(`config/${path3 || ""}`);
}
function corePath(path3) {
  return frameworkPath(`core/${path3 || ""}`);
}
function customElementsDataPath() {
  return frameworkPath("core/custom-elements.json");
}
function databasePath(path3) {
  return corePath(`database/${path3 || ""}`);
}
function datetimePath(path3) {
  return corePath(`datetime/${path3 || ""}`);
}
function developmentPath(path3) {
  return corePath(`development/${path3 || ""}`);
}
function desktopPath(path3) {
  return corePath(`desktop/${path3 || ""}`);
}
function docsPath(path3) {
  return corePath(`docs/${path3 || ""}`);
}
function dnsPath(path3) {
  return corePath(`domains/${path3 || ""}`);
}
function emailPath(path3) {
  return notificationsPath(`email/${path3 || ""}`);
}
function enumsPath(path3) {
  return corePath(`enums/${path3 || ""}`);
}
function eslintPluginPath(path3) {
  return corePath(`eslint-plugin/${path3 || ""}`);
}
function errorHandlingPath(path3) {
  return corePath(`error-handling/${path3 || ""}`);
}
function eventsPath(path3) {
  return corePath(`events/${path3 || ""}`);
}
function coreEnvPath(path3) {
  return corePath(`env/${path3 || ""}`);
}
function examplesPath(type) {
  return frameworkPath(`examples/${type || ""}`);
}
function fakerPath(path3) {
  return corePath(`faker/${path3 || ""}`);
}
function frameworkPath(path3, options3) {
  const absolutePath = storagePath2(`framework/${path3 || ""}`);
  if (options3?.relative)
    return relative2(options3.cwd || process8.cwd(), absolutePath);
  return absolutePath;
}
function browserPath(path3) {
  return corePath(`browser/${path3 || ""}`);
}
function healthPath(path3) {
  return corePath(`health/${path3 || ""}`);
}
function functionsPath(path3) {
  return userLibsPath(`functions/${path3 || ""}`);
}
function gitPath(path3) {
  return corePath(`git/${path3 || ""}`);
}
function langPath(path3) {
  return resourcesPath(`lang/${path3 || ""}`);
}
function layoutsPath(path3, options3) {
  const absolutePath = resourcesPath(`layouts/${path3 || ""}`);
  if (options3?.relative)
    return relative2(process8.cwd(), absolutePath);
  return absolutePath;
}
function libraryEntryPath(type) {
  return libsEntriesPath(`${type}.ts`);
}
function lintPath(path3) {
  return corePath(`lint/${path3 || ""}`);
}
function listenersPath(path3) {
  return appPath2(`Listeners/${path3 || ""}`);
}
function jobsPath(path3) {
  return appPath2(`Jobs/${path3 || ""}`);
}
function loggingPath(path3) {
  return corePath(`logging/${path3 || ""}`);
}
function logsPath2(path3) {
  return storagePath2(`logs/${path3 || ""}`);
}
function modulesPath(path3) {
  return resourcesPath(`modules/${path3 || ""}`);
}
function notificationsPath(path3) {
  return corePath(`notifications/${path3 || ""}`);
}
function ormPath(path3) {
  return corePath(`orm/${path3 || ""}`);
}
function objectsPath(path3) {
  return corePath(`objects/${path3 || ""}`);
}
function onboardingPath(path3) {
  return projectPath2(`${path3 || "views/dashboard/onboarding"}`);
}
function packageJsonPath(type) {
  if (type === "vue-components")
    return frameworkPath("libs/components/vue/package.json");
  if (type === "web-components")
    return frameworkPath("libs/components/web/package.json");
  return frameworkPath(`libs/${type}/package.json`);
}
function viewsPath(path3) {
  return resourcesPath(`views/${path3 || ""}`);
}
function pathPath(path3) {
  return corePath(`path/${path3 || ""}`);
}
function paymentsPath(path3) {
  return corePath(`payments/${path3 || ""}`);
}
function projectPath2(filePath = "", options3) {
  let path3 = process8.cwd();
  while (path3.includes("storage"))
    path3 = resolve(path3, "..");
  const finalPath = resolve(path3, filePath);
  if (options3?.relative)
    return relative2(process8.cwd(), finalPath);
  return finalPath;
}
async function findProjectPath(project) {
  const projectList = await runCommandSync("buddy projects:list --quiet");
  log2.debug(`ProjectList in findProjectPath ${projectList}`);
  const projects = projectList.split("\n").filter((line) => line.startsWith("   - ")).map((line) => line.trim().substring(4));
  log2.debug(`Projects in findProjectPath ${projects}`);
  const projectPath22 = projects.find((proj) => proj.includes(project));
  if (!projectPath22)
    throw new Error(`Could not find project with name: ${project}`);
  return projectPath22.startsWith("/") ? projectPath22 : `/${projectPath22}`;
}
function projectConfigPath(path3) {
  return projectPath2(`config/${path3 || ""}`);
}
function storagePath2(path3) {
  return projectPath2(`storage/${path3 || ""}`);
}
function publicPath(path3) {
  return projectPath2(`public/${path3 || ""}`);
}
function pushPath(path3) {
  return notificationsPath(`push/${path3 || ""}`);
}
function queryBuilderPath(path3) {
  return corePath(`query-builder/${path3 || ""}`);
}
function queuePath(path3) {
  return corePath(`queue/${path3 || ""}`);
}
function realtimePath(path3) {
  return corePath(`realtime/${path3 || ""}`);
}
function resourcesPath(path3, options3) {
  if (options3?.relative) {
    const absolutePath = projectPath2(`resources/${path3 || ""}`);
    return relative2(process8.cwd(), absolutePath);
  }
  return projectPath2(`resources/${path3 || ""}`);
}
function replPath(path3) {
  return corePath(`repl/${path3 || ""}`);
}
function routerPath(path3) {
  return corePath(`router/${path3 || ""}`);
}
function routesPath(path3, options3) {
  const absolutePath = resourcesPath(`routes/${path3 || ""}`);
  if (options3?.relative)
    return relative2(process8.cwd(), absolutePath);
  return projectPath2(`routes/${path3 || ""}`);
}
function searchEnginePath(path3) {
  return corePath(`search-engine/${path3 || ""}`);
}
function settingsPath(path3) {
  return projectPath2(`${path3 || "views/dashboard/settings"}`);
}
function scriptsPath(path3) {
  return frameworkPath(`scripts/${path3 || ""}`);
}
function schedulerPath(path3) {
  return corePath(`scheduler/${path3 || ""}`);
}
function slugPath(path3) {
  return corePath(`slug/${path3 || ""}`);
}
function smsPath(path3) {
  return notificationsPath(`sms/${path3 || ""}`);
}
function coreStoragePath(path3) {
  return corePath(`storage/${path3 || ""}`);
}
function storesPath(path3) {
  return resourcesPath(`stores/${path3 || ""}`);
}
function securityPath(path3) {
  return corePath(`security/${path3 || ""}`);
}
function serverPath(path3) {
  return corePath(`server/${path3 || ""}`);
}
function userServerPath(path3) {
  return frameworkPath(`server/${path3 || ""}`);
}
function serverlessPath(path3) {
  return corePath(`serverless/${path3 || ""}`);
}
function stacksPath(path3) {
  return frameworkPath(`src/${path3 || ""}`);
}
function shellPath(path3) {
  return corePath(`shell/${path3 || ""}`);
}
function stringsPath(path3) {
  return corePath(`strings/${path3 || ""}`);
}
function testingPath(path3) {
  return corePath(`testing/${path3 || ""}`);
}
function tinkerPath(path3) {
  return corePath(`tinker/${path3 || ""}`);
}
function testsPath(path3) {
  return frameworkPath(`tests/${path3 || ""}`);
}
function typesPath(path3) {
  return corePath(`types/${path3 || ""}`);
}
function uiPath(path3, options3) {
  const absolutePath = corePath(`ui/${path3 || ""}`);
  if (options3?.relative)
    return relative2(process8.cwd(), absolutePath);
  return absolutePath;
}
function utilsPath(path3) {
  return corePath(`utils/${path3 || ""}`);
}
function validationPath(path3) {
  return corePath(`validation/${path3 || ""}`);
}
function viteConfigPath(path3) {
  return corePath(`vite-config/${path3 || ""}`);
}
function vitePluginPath(path3) {
  return corePath(`vite-plugin/${path3 || ""}`);
}
function xRayPath(path3) {
  return frameworkPath(`stacks/x-ray/${path3 || ""}`);
}
function homeDir(path3) {
  return os2.homedir() + (path3 ? (path3.startsWith("/") ? "" : "/") + path3 : "~");
}
var path2;
var init_src11 = __esm2(() => {
  init_src10();
  init_src8();
  path2 = {
    actionsPath,
    userActionsPath,
    builtUserActionsPath,
    userComponentsPath,
    userViewsPath,
    userFunctionsPath,
    aiPath,
    assetsPath,
    relativeActionsPath,
    aliasPath,
    analyticsPath,
    arraysPath,
    appPath: appPath2,
    authPath,
    coreApiPath,
    buddyPath,
    buildEnginePath,
    libsEntriesPath,
    buildPath,
    cachePath,
    chatPath,
    cliPath,
    cloudPath,
    frameworkCloudPath,
    collectionsPath,
    commandsPath: commandsPath2,
    componentsPath,
    configPath,
    projectConfigPath,
    corePath,
    customElementsDataPath,
    databasePath,
    datetimePath,
    developmentPath,
    desktopPath,
    docsPath,
    dnsPath,
    emailPath,
    enumsPath,
    eslintPluginPath,
    errorHandlingPath,
    eventsPath,
    coreEnvPath,
    healthPath,
    examplesPath,
    fakerPath,
    frameworkPath,
    browserPath,
    storagePath: storagePath2,
    functionsPath,
    gitPath,
    langPath,
    layoutsPath,
    libsPath,
    userLibsPath,
    libraryEntryPath,
    lintPath,
    listenersPath,
    loggingPath,
    logsPath: logsPath2,
    jobsPath,
    modulesPath,
    ormPath,
    objectsPath,
    onboardingPath,
    notificationsPath,
    packageJsonPath,
    viewsPath,
    pathPath,
    paymentsPath,
    projectPath: projectPath2,
    findProjectPath,
    coreStoragePath,
    publicPath,
    pushPath,
    queryBuilderPath,
    queuePath,
    realtimePath,
    resourcesPath,
    replPath,
    routerPath,
    routesPath,
    runtimePath,
    searchEnginePath,
    schedulerPath,
    settingsPath,
    smsPath,
    slugPath,
    scriptsPath,
    securityPath,
    serverPath,
    userServerPath,
    serverlessPath,
    stacksPath,
    stringsPath,
    shellPath,
    storesPath,
    testingPath,
    testsPath,
    tinkerPath,
    typesPath,
    uiPath,
    userDatabasePath: userDatabasePath2,
    userMigrationsPath,
    userEventsPath,
    userJobsPath,
    userListenersPath,
    userMiddlewarePath,
    userModelsPath,
    userNotificationsPath,
    utilsPath,
    validationPath,
    viteConfigPath,
    vitePluginPath,
    xRayPath,
    homeDir,
    basename: basename2,
    delimiter: () => delimiter2,
    dirname: dirname22,
    extname: extname2,
    isAbsolute: isAbsolute2,
    join: join2,
    normalize: normalize2,
    relative: relative2,
    resolve,
    parse: parse2,
    sep: () => sep22,
    toNamespacedPath: toNamespacedPath2
  };
});
var init_clean = __esm2(() => {
  init_src11();
});
var init_config2 = __esm2(() => {
  init_src6();
});
var init_equal = __esm2(() => {
  init_src2();
});
var require_lib3 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  function _objectWithoutPropertiesLoose(r22, e) {
    if (r22 == null)
      return {};
    var t = {};
    for (var n in r22)
      if ({}.hasOwnProperty.call(r22, n)) {
        if (e.includes(n))
          continue;
        t[n] = r22[n];
      }
    return t;
  }

  class Position {
    constructor(line, col, index) {
      this.line = undefined;
      this.column = undefined;
      this.index = undefined;
      this.line = line;
      this.column = col;
      this.index = index;
    }
  }

  class SourceLocation {
    constructor(start, end) {
      this.start = undefined;
      this.end = undefined;
      this.filename = undefined;
      this.identifierName = undefined;
      this.start = start;
      this.end = end;
    }
  }
  function createPositionWithColumnOffset(position, columnOffset) {
    const {
      line,
      column,
      index
    } = position;
    return new Position(line, column + columnOffset, index + columnOffset);
  }
  var code = "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED";
  var ModuleErrors = {
    ImportMetaOutsideModule: {
      message: `import.meta may appear only with 'sourceType: "module"'`,
      code
    },
    ImportOutsideModule: {
      message: `'import' and 'export' may appear only with 'sourceType: "module"'`,
      code
    }
  };
  var NodeDescriptions = {
    ArrayPattern: "array destructuring pattern",
    AssignmentExpression: "assignment expression",
    AssignmentPattern: "assignment expression",
    ArrowFunctionExpression: "arrow function expression",
    ConditionalExpression: "conditional expression",
    CatchClause: "catch clause",
    ForOfStatement: "for-of statement",
    ForInStatement: "for-in statement",
    ForStatement: "for-loop",
    FormalParameters: "function parameter list",
    Identifier: "identifier",
    ImportSpecifier: "import specifier",
    ImportDefaultSpecifier: "import default specifier",
    ImportNamespaceSpecifier: "import namespace specifier",
    ObjectPattern: "object destructuring pattern",
    ParenthesizedExpression: "parenthesized expression",
    RestElement: "rest element",
    UpdateExpression: {
      true: "prefix operation",
      false: "postfix operation"
    },
    VariableDeclarator: "variable declaration",
    YieldExpression: "yield expression"
  };
  var toNodeDescription = (node) => node.type === "UpdateExpression" ? NodeDescriptions.UpdateExpression[`${node.prefix}`] : NodeDescriptions[node.type];
  var StandardErrors = {
    AccessorIsGenerator: ({
      kind
    }) => `A ${kind}ter cannot be a generator.`,
    ArgumentsInClass: "'arguments' is only allowed in functions and class methods.",
    AsyncFunctionInSingleStatementContext: "Async functions can only be declared at the top level or inside a block.",
    AwaitBindingIdentifier: "Can not use 'await' as identifier inside an async function.",
    AwaitBindingIdentifierInStaticBlock: "Can not use 'await' as identifier inside a static block.",
    AwaitExpressionFormalParameter: "'await' is not allowed in async function parameters.",
    AwaitUsingNotInAsyncContext: "'await using' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncContext: "'await' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
    BadGetterArity: "A 'get' accessor must not have any formal parameters.",
    BadSetterArity: "A 'set' accessor must have exactly one formal parameter.",
    BadSetterRestParameter: "A 'set' accessor function argument must not be a rest parameter.",
    ConstructorClassField: "Classes may not have a field named 'constructor'.",
    ConstructorClassPrivateField: "Classes may not have a private field named '#constructor'.",
    ConstructorIsAccessor: "Class constructor may not be an accessor.",
    ConstructorIsAsync: "Constructor can't be an async function.",
    ConstructorIsGenerator: "Constructor can't be a generator.",
    DeclarationMissingInitializer: ({
      kind
    }) => `Missing initializer in ${kind} declaration.`,
    DecoratorArgumentsOutsideParentheses: "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
    DecoratorBeforeExport: "Decorators must be placed *before* the 'export' keyword. Remove the 'decoratorsBeforeExport: true' option to use the 'export @decorator class {}' syntax.",
    DecoratorsBeforeAfterExport: "Decorators can be placed *either* before or after the 'export' keyword, but not in both locations at the same time.",
    DecoratorConstructor: "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
    DecoratorExportClass: "Decorators must be placed *after* the 'export' keyword. Remove the 'decoratorsBeforeExport: false' option to use the '@decorator export class {}' syntax.",
    DecoratorSemicolon: "Decorators must not be followed by a semicolon.",
    DecoratorStaticBlock: "Decorators can't be used with a static block.",
    DeferImportRequiresNamespace: 'Only `import defer * as x from "./module"` is valid.',
    DeletePrivateField: "Deleting a private field is not allowed.",
    DestructureNamedImport: "ES2015 named imports do not destructure. Use another statement for destructuring after the import.",
    DuplicateConstructor: "Duplicate constructor in the same class.",
    DuplicateDefaultExport: "Only one default export allowed per module.",
    DuplicateExport: ({
      exportName
    }) => `\`${exportName}\` has already been exported. Exported identifiers must be unique.`,
    DuplicateProto: "Redefinition of __proto__ property.",
    DuplicateRegExpFlags: "Duplicate regular expression flag.",
    DynamicImportPhaseRequiresImportExpressions: ({
      phase
    }) => `'import.${phase}(...)' can only be parsed when using the 'createImportExpressions' option.`,
    ElementAfterRest: "Rest element must be last element.",
    EscapedCharNotAnIdentifier: "Invalid Unicode escape.",
    ExportBindingIsString: ({
      localName,
      exportName
    }) => `A string literal cannot be used as an exported binding without \`from\`.\n- Did you mean \`export { '${localName}' as '${exportName}' } from 'some-module'\`?`,
    ExportDefaultFromAsIdentifier: "'from' is not allowed as an identifier after 'export default'.",
    ForInOfLoopInitializer: ({
      type
    }) => `'${type === "ForInStatement" ? "for-in" : "for-of"}' loop variable declaration may not have an initializer.`,
    ForInUsing: "For-in loop may not start with 'using' declaration.",
    ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
    ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
    GeneratorInSingleStatementContext: "Generators can only be declared at the top level or inside a block.",
    IllegalBreakContinue: ({
      type
    }) => `Unsyntactic ${type === "BreakStatement" ? "break" : "continue"}.`,
    IllegalLanguageModeDirective: "Illegal 'use strict' directive in function with non-simple parameter list.",
    IllegalReturn: "'return' outside of function.",
    ImportAttributesUseAssert: "The `assert` keyword in import attributes is deprecated and it has been replaced by the `with` keyword. You can enable the `deprecatedAssertSyntax: true` option in the import attributes plugin to suppress this error.",
    ImportBindingIsString: ({
      importName
    }) => `A string literal cannot be used as an imported binding.\n- Did you mean \`import { "${importName}" as foo }\`?`,
    ImportCallArgumentTrailingComma: "Trailing comma is disallowed inside import(...) arguments.",
    ImportCallArity: ({
      maxArgumentCount
    }) => `\`import()\` requires exactly ${maxArgumentCount === 1 ? "one argument" : "one or two arguments"}.`,
    ImportCallNotNewExpression: "Cannot use new with import(...).",
    ImportCallSpreadArgument: "`...` is not allowed in `import()`.",
    ImportJSONBindingNotDefault: "A JSON module can only be imported with `default`.",
    ImportReflectionHasAssertion: "`import module x` cannot have assertions.",
    ImportReflectionNotBinding: 'Only `import module x from "./module"` is valid.',
    IncompatibleRegExpUVFlags: "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
    InvalidBigIntLiteral: "Invalid BigIntLiteral.",
    InvalidCodePoint: "Code point out of bounds.",
    InvalidCoverInitializedName: "Invalid shorthand property initializer.",
    InvalidDecimal: "Invalid decimal.",
    InvalidDigit: ({
      radix
    }) => `Expected number in radix ${radix}.`,
    InvalidEscapeSequence: "Bad character escape sequence.",
    InvalidEscapeSequenceTemplate: "Invalid escape sequence in template.",
    InvalidEscapedReservedWord: ({
      reservedWord
    }) => `Escape sequence in keyword ${reservedWord}.`,
    InvalidIdentifier: ({
      identifierName
    }) => `Invalid identifier ${identifierName}.`,
    InvalidLhs: ({
      ancestor
    }) => `Invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidLhsBinding: ({
      ancestor
    }) => `Binding invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidLhsOptionalChaining: ({
      ancestor
    }) => `Invalid optional chaining in the left-hand side of ${toNodeDescription(ancestor)}.`,
    InvalidNumber: "Invalid number.",
    InvalidOrMissingExponent: "Floating-point numbers require a valid exponent after the 'e'.",
    InvalidOrUnexpectedToken: ({
      unexpected
    }) => `Unexpected character '${unexpected}'.`,
    InvalidParenthesizedAssignment: "Invalid parenthesized assignment pattern.",
    InvalidPrivateFieldResolution: ({
      identifierName
    }) => `Private name #${identifierName} is not defined.`,
    InvalidPropertyBindingPattern: "Binding member expression.",
    InvalidRecordProperty: "Only properties and spread elements are allowed in record definitions.",
    InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
    LabelRedeclaration: ({
      labelName
    }) => `Label '${labelName}' is already declared.`,
    LetInLexicalBinding: "'let' is disallowed as a lexically bound name.",
    LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
    MalformedRegExpFlags: "Invalid regular expression flag.",
    MissingClassName: "A class name is required.",
    MissingEqInAssignment: "Only '=' operator can be used for specifying default value.",
    MissingSemicolon: "Missing semicolon.",
    MissingPlugin: ({
      missingPlugin
    }) => `This experimental syntax requires enabling the parser plugin: ${missingPlugin.map((name) => JSON.stringify(name)).join(", ")}.`,
    MissingOneOfPlugins: ({
      missingPlugin
    }) => `This experimental syntax requires enabling one of the following parser plugin(s): ${missingPlugin.map((name) => JSON.stringify(name)).join(", ")}.`,
    MissingUnicodeEscape: "Expecting Unicode escape sequence \\uXXXX.",
    MixingCoalesceWithLogical: "Nullish coalescing operator(??) requires parens when mixing with logical operators.",
    ModuleAttributeDifferentFromType: "The only accepted module attribute is `type`.",
    ModuleAttributeInvalidValue: "Only string literals are allowed as module attribute values.",
    ModuleAttributesWithDuplicateKeys: ({
      key
    }) => `Duplicate key "${key}" is not allowed in module attributes.`,
    ModuleExportNameHasLoneSurrogate: ({
      surrogateCharCode
    }) => `An export name cannot include a lone surrogate, found '\\u${surrogateCharCode.toString(16)}'.`,
    ModuleExportUndefined: ({
      localName
    }) => `Export '${localName}' is not defined.`,
    MultipleDefaultsInSwitch: "Multiple default clauses.",
    NewlineAfterThrow: "Illegal newline after throw.",
    NoCatchOrFinally: "Missing catch or finally clause.",
    NumberIdentifier: "Identifier directly after number.",
    NumericSeparatorInEscapeSequence: "Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.",
    ObsoleteAwaitStar: "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
    OptionalChainingNoNew: "Constructors in/after an Optional Chain are not allowed.",
    OptionalChainingNoTemplate: "Tagged Template Literals are not allowed in optionalChain.",
    OverrideOnConstructor: "'override' modifier cannot appear on a constructor declaration.",
    ParamDupe: "Argument name clash.",
    PatternHasAccessor: "Object pattern can't contain getter or setter.",
    PatternHasMethod: "Object pattern can't contain methods.",
    PrivateInExpectedIn: ({
      identifierName
    }) => `Private names are only allowed in property accesses (\`obj.#${identifierName}\`) or in \`in\` expressions (\`#${identifierName} in obj\`).`,
    PrivateNameRedeclaration: ({
      identifierName
    }) => `Duplicate private name #${identifierName}.`,
    RecordExpressionBarIncorrectEndSyntaxType: "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionBarIncorrectStartSyntaxType: "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionHashIncorrectStartSyntaxType: "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    RecordNoProto: "'__proto__' is not allowed in Record expressions.",
    RestTrailingComma: "Unexpected trailing comma after rest element.",
    SloppyFunction: "In non-strict mode code, functions can only be declared at top level or inside a block.",
    SloppyFunctionAnnexB: "In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.",
    SourcePhaseImportRequiresDefault: 'Only `import source x from "./module"` is valid.',
    StaticPrototype: "Classes may not have static property named prototype.",
    SuperNotAllowed: "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
    SuperPrivateField: "Private fields can't be accessed on super.",
    TrailingDecorator: "Decorators must be attached to a class element.",
    TupleExpressionBarIncorrectEndSyntaxType: "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionBarIncorrectStartSyntaxType: "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionHashIncorrectStartSyntaxType: "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    UnexpectedArgumentPlaceholder: "Unexpected argument placeholder.",
    UnexpectedAwaitAfterPipelineBody: 'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
    UnexpectedDigitAfterHash: "Unexpected digit after hash token.",
    UnexpectedImportExport: "'import' and 'export' may only appear at the top level.",
    UnexpectedKeyword: ({
      keyword
    }) => `Unexpected keyword '${keyword}'.`,
    UnexpectedLeadingDecorator: "Leading decorators must be attached to a class declaration.",
    UnexpectedLexicalDeclaration: "Lexical declaration cannot appear in a single-statement context.",
    UnexpectedNewTarget: "`new.target` can only be used in functions or class properties.",
    UnexpectedNumericSeparator: "A numeric separator is only allowed between two digits.",
    UnexpectedPrivateField: "Unexpected private name.",
    UnexpectedReservedWord: ({
      reservedWord
    }) => `Unexpected reserved word '${reservedWord}'.`,
    UnexpectedSuper: "'super' is only allowed in object methods and classes.",
    UnexpectedToken: ({
      expected,
      unexpected
    }) => `Unexpected token${unexpected ? ` '${unexpected}'.` : ""}${expected ? `, expected "${expected}"` : ""}`,
    UnexpectedTokenUnaryExponentiation: "Illegal expression. Wrap left hand side or entire exponentiation in parentheses.",
    UnexpectedUsingDeclaration: "Using declaration cannot appear in the top level when source type is `script`.",
    UnsupportedBind: "Binding should be performed on object property.",
    UnsupportedDecoratorExport: "A decorated export must export a class declaration.",
    UnsupportedDefaultExport: "Only expressions, functions or classes are allowed as the `default` export.",
    UnsupportedImport: "`import` can only be used in `import()` or `import.meta`.",
    UnsupportedMetaProperty: ({
      target,
      onlyValidPropertyName
    }) => `The only valid meta property for ${target} is ${target}.${onlyValidPropertyName}.`,
    UnsupportedParameterDecorator: "Decorators cannot be used to decorate parameters.",
    UnsupportedPropertyDecorator: "Decorators cannot be used to decorate object literal properties.",
    UnsupportedSuper: "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
    UnterminatedComment: "Unterminated comment.",
    UnterminatedRegExp: "Unterminated regular expression.",
    UnterminatedString: "Unterminated string constant.",
    UnterminatedTemplate: "Unterminated template.",
    UsingDeclarationExport: "Using declaration cannot be exported.",
    UsingDeclarationHasBindingPattern: "Using declaration cannot have destructuring patterns.",
    VarRedeclaration: ({
      identifierName
    }) => `Identifier '${identifierName}' has already been declared.`,
    YieldBindingIdentifier: "Can not use 'yield' as identifier inside a generator.",
    YieldInParameter: "Yield expression is not allowed in formal parameters.",
    ZeroDigitNumericSeparator: "Numeric separator can not be used after leading 0."
  };
  var StrictModeErrors = {
    StrictDelete: "Deleting local variable in strict mode.",
    StrictEvalArguments: ({
      referenceName
    }) => `Assigning to '${referenceName}' in strict mode.`,
    StrictEvalArgumentsBinding: ({
      bindingName
    }) => `Binding '${bindingName}' in strict mode.`,
    StrictFunction: "In strict mode code, functions can only be declared at top level or inside a block.",
    StrictNumericEscape: "The only valid numeric escape in strict mode is '\\0'.",
    StrictOctalLiteral: "Legacy octal literals are not allowed in strict mode.",
    StrictWith: "'with' in strict mode."
  };
  var UnparenthesizedPipeBodyDescriptions = new Set(["ArrowFunctionExpression", "AssignmentExpression", "ConditionalExpression", "YieldExpression"]);
  var PipelineOperatorErrors = {
    PipeBodyIsTighter: "Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.",
    PipeTopicRequiresHackPipes: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
    PipeTopicUnbound: "Topic reference is unbound; it must be inside a pipe body.",
    PipeTopicUnconfiguredToken: ({
      token
    }) => `Invalid topic token ${token}. In order to use ${token} as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "${token}" }.`,
    PipeTopicUnused: "Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.",
    PipeUnparenthesizedBody: ({
      type
    }) => `Hack-style pipe body cannot be an unparenthesized ${toNodeDescription({
      type
    })}; please wrap it in parentheses.`,
    PipelineBodyNoArrow: 'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
    PipelineBodySequenceExpression: "Pipeline body may not be a comma-separated sequence expression.",
    PipelineHeadSequenceExpression: "Pipeline head should not be a comma-separated sequence expression.",
    PipelineTopicUnused: "Pipeline is in topic style but does not use topic reference.",
    PrimaryTopicNotAllowed: "Topic reference was used in a lexical context without topic binding.",
    PrimaryTopicRequiresSmartPipeline: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.'
  };
  var _excluded = ["message"];
  function defineHidden(obj, key, value) {
    Object.defineProperty(obj, key, {
      enumerable: false,
      configurable: true,
      value
    });
  }
  function toParseErrorConstructor({
    toMessage,
    code: code2,
    reasonCode,
    syntaxPlugin
  }) {
    const hasMissingPlugin = reasonCode === "MissingPlugin" || reasonCode === "MissingOneOfPlugins";
    {
      const oldReasonCodes = {
        AccessorCannotDeclareThisParameter: "AccesorCannotDeclareThisParameter",
        AccessorCannotHaveTypeParameters: "AccesorCannotHaveTypeParameters",
        ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference: "ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference",
        SetAccessorCannotHaveOptionalParameter: "SetAccesorCannotHaveOptionalParameter",
        SetAccessorCannotHaveRestParameter: "SetAccesorCannotHaveRestParameter",
        SetAccessorCannotHaveReturnType: "SetAccesorCannotHaveReturnType"
      };
      if (oldReasonCodes[reasonCode]) {
        reasonCode = oldReasonCodes[reasonCode];
      }
    }
    return function constructor(loc, details) {
      const error = new SyntaxError;
      error.code = code2;
      error.reasonCode = reasonCode;
      error.loc = loc;
      error.pos = loc.index;
      error.syntaxPlugin = syntaxPlugin;
      if (hasMissingPlugin) {
        error.missingPlugin = details.missingPlugin;
      }
      defineHidden(error, "clone", function clone(overrides = {}) {
        var _overrides$loc;
        const {
          line,
          column,
          index
        } = (_overrides$loc = overrides.loc) != null ? _overrides$loc : loc;
        return constructor(new Position(line, column, index), Object.assign({}, details, overrides.details));
      });
      defineHidden(error, "details", details);
      Object.defineProperty(error, "message", {
        configurable: true,
        get() {
          const message = `${toMessage(details)} (${loc.line}:${loc.column})`;
          this.message = message;
          return message;
        },
        set(value) {
          Object.defineProperty(this, "message", {
            value,
            writable: true
          });
        }
      });
      return error;
    };
  }
  function ParseErrorEnum(argument, syntaxPlugin) {
    if (Array.isArray(argument)) {
      return (parseErrorTemplates) => ParseErrorEnum(parseErrorTemplates, argument[0]);
    }
    const ParseErrorConstructors = {};
    for (const reasonCode of Object.keys(argument)) {
      const template2 = argument[reasonCode];
      const _ref = typeof template2 === "string" ? {
        message: () => template2
      } : typeof template2 === "function" ? {
        message: template2
      } : template2, {
        message
      } = _ref, rest = _objectWithoutPropertiesLoose(_ref, _excluded);
      const toMessage = typeof message === "string" ? () => message : message;
      ParseErrorConstructors[reasonCode] = toParseErrorConstructor(Object.assign({
        code: "BABEL_PARSER_SYNTAX_ERROR",
        reasonCode,
        toMessage
      }, syntaxPlugin ? {
        syntaxPlugin
      } : {}, rest));
    }
    return ParseErrorConstructors;
  }
  var Errors = Object.assign({}, ParseErrorEnum(ModuleErrors), ParseErrorEnum(StandardErrors), ParseErrorEnum(StrictModeErrors), ParseErrorEnum`pipelineOperator`(PipelineOperatorErrors));
  var {
    defineProperty
  } = Object;
  var toUnenumerable = (object, key) => {
    if (object) {
      defineProperty(object, key, {
        enumerable: false,
        value: object[key]
      });
    }
  };
  function toESTreeLocation(node) {
    toUnenumerable(node.loc.start, "index");
    toUnenumerable(node.loc.end, "index");
    return node;
  }
  var estree = (superClass) => class ESTreeParserMixin extends superClass {
    parse() {
      const file = toESTreeLocation(super.parse());
      if (this.options.tokens) {
        file.tokens = file.tokens.map(toESTreeLocation);
      }
      return file;
    }
    parseRegExpLiteral({
      pattern,
      flags
    }) {
      let regex22 = null;
      try {
        regex22 = new RegExp(pattern, flags);
      } catch (_22) {
      }
      const node = this.estreeParseLiteral(regex22);
      node.regex = {
        pattern,
        flags
      };
      return node;
    }
    parseBigIntLiteral(value) {
      let bigInt;
      try {
        bigInt = BigInt(value);
      } catch (_unused) {
        bigInt = null;
      }
      const node = this.estreeParseLiteral(bigInt);
      node.bigint = String(node.value || value);
      return node;
    }
    parseDecimalLiteral(value) {
      const decimal = null;
      const node = this.estreeParseLiteral(decimal);
      node.decimal = String(node.value || value);
      return node;
    }
    estreeParseLiteral(value) {
      return this.parseLiteral(value, "Literal");
    }
    parseStringLiteral(value) {
      return this.estreeParseLiteral(value);
    }
    parseNumericLiteral(value) {
      return this.estreeParseLiteral(value);
    }
    parseNullLiteral() {
      return this.estreeParseLiteral(null);
    }
    parseBooleanLiteral(value) {
      return this.estreeParseLiteral(value);
    }
    directiveToStmt(directive) {
      const expression = directive.value;
      delete directive.value;
      expression.type = "Literal";
      expression.raw = expression.extra.raw;
      expression.value = expression.extra.expressionValue;
      const stmt = directive;
      stmt.type = "ExpressionStatement";
      stmt.expression = expression;
      stmt.directive = expression.extra.rawValue;
      delete expression.extra;
      return stmt;
    }
    initFunction(node, isAsync) {
      super.initFunction(node, isAsync);
      node.expression = false;
    }
    checkDeclaration(node) {
      if (node != null && this.isObjectProperty(node)) {
        this.checkDeclaration(node.value);
      } else {
        super.checkDeclaration(node);
      }
    }
    getObjectOrClassMethodParams(method) {
      return method.value.params;
    }
    isValidDirective(stmt) {
      var _stmt$expression$extr;
      return stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && typeof stmt.expression.value === "string" && !((_stmt$expression$extr = stmt.expression.extra) != null && _stmt$expression$extr.parenthesized);
    }
    parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
      super.parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse);
      const directiveStatements = node.directives.map((d) => this.directiveToStmt(d));
      node.body = directiveStatements.concat(node.body);
      delete node.directives;
    }
    pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
      this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true);
      if (method.typeParameters) {
        method.value.typeParameters = method.typeParameters;
        delete method.typeParameters;
      }
      classBody.body.push(method);
    }
    parsePrivateName() {
      const node = super.parsePrivateName();
      {
        if (!this.getPluginOption("estree", "classFeatures")) {
          return node;
        }
      }
      return this.convertPrivateNameToPrivateIdentifier(node);
    }
    convertPrivateNameToPrivateIdentifier(node) {
      const name = super.getPrivateNameSV(node);
      node = node;
      delete node.id;
      node.name = name;
      node.type = "PrivateIdentifier";
      return node;
    }
    isPrivateName(node) {
      {
        if (!this.getPluginOption("estree", "classFeatures")) {
          return super.isPrivateName(node);
        }
      }
      return node.type === "PrivateIdentifier";
    }
    getPrivateNameSV(node) {
      {
        if (!this.getPluginOption("estree", "classFeatures")) {
          return super.getPrivateNameSV(node);
        }
      }
      return node.name;
    }
    parseLiteral(value, type) {
      const node = super.parseLiteral(value, type);
      node.raw = node.extra.raw;
      delete node.extra;
      return node;
    }
    parseFunctionBody(node, allowExpression, isMethod = false) {
      super.parseFunctionBody(node, allowExpression, isMethod);
      node.expression = node.body.type !== "BlockStatement";
    }
    parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope = false) {
      let funcNode = this.startNode();
      funcNode.kind = node.kind;
      funcNode = super.parseMethod(funcNode, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
      funcNode.type = "FunctionExpression";
      delete funcNode.kind;
      node.value = funcNode;
      if (type === "ClassPrivateMethod") {
        node.computed = false;
      }
      return this.finishNode(node, "MethodDefinition");
    }
    nameIsConstructor(key) {
      if (key.type === "Literal")
        return key.value === "constructor";
      return super.nameIsConstructor(key);
    }
    parseClassProperty(...args) {
      const propertyNode = super.parseClassProperty(...args);
      {
        if (!this.getPluginOption("estree", "classFeatures")) {
          return propertyNode;
        }
      }
      propertyNode.type = "PropertyDefinition";
      return propertyNode;
    }
    parseClassPrivateProperty(...args) {
      const propertyNode = super.parseClassPrivateProperty(...args);
      {
        if (!this.getPluginOption("estree", "classFeatures")) {
          return propertyNode;
        }
      }
      propertyNode.type = "PropertyDefinition";
      propertyNode.computed = false;
      return propertyNode;
    }
    parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
      const node = super.parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor);
      if (node) {
        node.type = "Property";
        if (node.kind === "method") {
          node.kind = "init";
        }
        node.shorthand = false;
      }
      return node;
    }
    parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
      const node = super.parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors);
      if (node) {
        node.kind = "init";
        node.type = "Property";
      }
      return node;
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      return type === "Property" ? "value" : super.isValidLVal(type, isUnparenthesizedInAssign, binding);
    }
    isAssignable(node, isBinding) {
      if (node != null && this.isObjectProperty(node)) {
        return this.isAssignable(node.value, isBinding);
      }
      return super.isAssignable(node, isBinding);
    }
    toAssignable(node, isLHS = false) {
      if (node != null && this.isObjectProperty(node)) {
        const {
          key,
          value
        } = node;
        if (this.isPrivateName(key)) {
          this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
        }
        this.toAssignable(value, isLHS);
      } else {
        super.toAssignable(node, isLHS);
      }
    }
    toAssignableObjectExpressionProp(prop, isLast, isLHS) {
      if (prop.type === "Property" && (prop.kind === "get" || prop.kind === "set")) {
        this.raise(Errors.PatternHasAccessor, prop.key);
      } else if (prop.type === "Property" && prop.method) {
        this.raise(Errors.PatternHasMethod, prop.key);
      } else {
        super.toAssignableObjectExpressionProp(prop, isLast, isLHS);
      }
    }
    finishCallExpression(unfinished, optional) {
      const node = super.finishCallExpression(unfinished, optional);
      if (node.callee.type === "Import") {
        node.type = "ImportExpression";
        node.source = node.arguments[0];
        if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
          var _ref, _ref2;
          node.options = (_ref = node.arguments[1]) != null ? _ref : null;
          node.attributes = (_ref2 = node.arguments[1]) != null ? _ref2 : null;
        }
        delete node.arguments;
        delete node.callee;
      }
      return node;
    }
    toReferencedArguments(node) {
      if (node.type === "ImportExpression") {
        return;
      }
      super.toReferencedArguments(node);
    }
    parseExport(unfinished, decorators) {
      const exportStartLoc = this.state.lastTokStartLoc;
      const node = super.parseExport(unfinished, decorators);
      switch (node.type) {
        case "ExportAllDeclaration":
          node.exported = null;
          break;
        case "ExportNamedDeclaration":
          if (node.specifiers.length === 1 && node.specifiers[0].type === "ExportNamespaceSpecifier") {
            node.type = "ExportAllDeclaration";
            node.exported = node.specifiers[0].exported;
            delete node.specifiers;
          }
        case "ExportDefaultDeclaration":
          {
            var _declaration$decorato;
            const {
              declaration
            } = node;
            if ((declaration == null ? undefined : declaration.type) === "ClassDeclaration" && ((_declaration$decorato = declaration.decorators) == null ? undefined : _declaration$decorato.length) > 0 && declaration.start === node.start) {
              this.resetStartLocation(node, exportStartLoc);
            }
          }
          break;
      }
      return node;
    }
    parseSubscript(base, startLoc, noCalls, state) {
      const node = super.parseSubscript(base, startLoc, noCalls, state);
      if (state.optionalChainMember) {
        if (node.type === "OptionalMemberExpression" || node.type === "OptionalCallExpression") {
          node.type = node.type.substring(8);
        }
        if (state.stop) {
          const chain = this.startNodeAtNode(node);
          chain.expression = node;
          return this.finishNode(chain, "ChainExpression");
        }
      } else if (node.type === "MemberExpression" || node.type === "CallExpression") {
        node.optional = false;
      }
      return node;
    }
    isOptionalMemberExpression(node) {
      if (node.type === "ChainExpression") {
        return node.expression.type === "MemberExpression";
      }
      return super.isOptionalMemberExpression(node);
    }
    hasPropertyAsPrivateName(node) {
      if (node.type === "ChainExpression") {
        node = node.expression;
      }
      return super.hasPropertyAsPrivateName(node);
    }
    isObjectProperty(node) {
      return node.type === "Property" && node.kind === "init" && !node.method;
    }
    isObjectMethod(node) {
      return node.type === "Property" && (node.method || node.kind === "get" || node.kind === "set");
    }
    finishNodeAt(node, type, endLoc) {
      return toESTreeLocation(super.finishNodeAt(node, type, endLoc));
    }
    resetStartLocation(node, startLoc) {
      super.resetStartLocation(node, startLoc);
      toESTreeLocation(node);
    }
    resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
      super.resetEndLocation(node, endLoc);
      toESTreeLocation(node);
    }
  };

  class TokContext {
    constructor(token, preserveSpace) {
      this.token = undefined;
      this.preserveSpace = undefined;
      this.token = token;
      this.preserveSpace = !!preserveSpace;
    }
  }
  var types3 = {
    brace: new TokContext("{"),
    j_oTag: new TokContext("<tag"),
    j_cTag: new TokContext("</tag"),
    j_expr: new TokContext("<tag>...</tag>", true)
  };
  {
    types3.template = new TokContext("`", true);
  }
  var beforeExpr = true;
  var startsExpr = true;
  var isLoop = true;
  var isAssign = true;
  var prefix = true;
  var postfix = true;

  class ExportedTokenType {
    constructor(label, conf = {}) {
      this.label = undefined;
      this.keyword = undefined;
      this.beforeExpr = undefined;
      this.startsExpr = undefined;
      this.rightAssociative = undefined;
      this.isLoop = undefined;
      this.isAssign = undefined;
      this.prefix = undefined;
      this.postfix = undefined;
      this.binop = undefined;
      this.label = label;
      this.keyword = conf.keyword;
      this.beforeExpr = !!conf.beforeExpr;
      this.startsExpr = !!conf.startsExpr;
      this.rightAssociative = !!conf.rightAssociative;
      this.isLoop = !!conf.isLoop;
      this.isAssign = !!conf.isAssign;
      this.prefix = !!conf.prefix;
      this.postfix = !!conf.postfix;
      this.binop = conf.binop != null ? conf.binop : null;
      {
        this.updateContext = null;
      }
    }
  }
  var keywords$1 = new Map;
  function createKeyword(name, options3 = {}) {
    options3.keyword = name;
    const token = createToken(name, options3);
    keywords$1.set(name, token);
    return token;
  }
  function createBinop(name, binop) {
    return createToken(name, {
      beforeExpr,
      binop
    });
  }
  var tokenTypeCounter = -1;
  var tokenTypes = [];
  var tokenLabels = [];
  var tokenBinops = [];
  var tokenBeforeExprs = [];
  var tokenStartsExprs = [];
  var tokenPrefixes = [];
  function createToken(name, options3 = {}) {
    var _options$binop, _options$beforeExpr, _options$startsExpr, _options$prefix;
    ++tokenTypeCounter;
    tokenLabels.push(name);
    tokenBinops.push((_options$binop = options3.binop) != null ? _options$binop : -1);
    tokenBeforeExprs.push((_options$beforeExpr = options3.beforeExpr) != null ? _options$beforeExpr : false);
    tokenStartsExprs.push((_options$startsExpr = options3.startsExpr) != null ? _options$startsExpr : false);
    tokenPrefixes.push((_options$prefix = options3.prefix) != null ? _options$prefix : false);
    tokenTypes.push(new ExportedTokenType(name, options3));
    return tokenTypeCounter;
  }
  function createKeywordLike(name, options3 = {}) {
    var _options$binop2, _options$beforeExpr2, _options$startsExpr2, _options$prefix2;
    ++tokenTypeCounter;
    keywords$1.set(name, tokenTypeCounter);
    tokenLabels.push(name);
    tokenBinops.push((_options$binop2 = options3.binop) != null ? _options$binop2 : -1);
    tokenBeforeExprs.push((_options$beforeExpr2 = options3.beforeExpr) != null ? _options$beforeExpr2 : false);
    tokenStartsExprs.push((_options$startsExpr2 = options3.startsExpr) != null ? _options$startsExpr2 : false);
    tokenPrefixes.push((_options$prefix2 = options3.prefix) != null ? _options$prefix2 : false);
    tokenTypes.push(new ExportedTokenType("name", options3));
    return tokenTypeCounter;
  }
  var tt = {
    bracketL: createToken("[", {
      beforeExpr,
      startsExpr
    }),
    bracketHashL: createToken("#[", {
      beforeExpr,
      startsExpr
    }),
    bracketBarL: createToken("[|", {
      beforeExpr,
      startsExpr
    }),
    bracketR: createToken("]"),
    bracketBarR: createToken("|]"),
    braceL: createToken("{", {
      beforeExpr,
      startsExpr
    }),
    braceBarL: createToken("{|", {
      beforeExpr,
      startsExpr
    }),
    braceHashL: createToken("#{", {
      beforeExpr,
      startsExpr
    }),
    braceR: createToken("}"),
    braceBarR: createToken("|}"),
    parenL: createToken("(", {
      beforeExpr,
      startsExpr
    }),
    parenR: createToken(")"),
    comma: createToken(",", {
      beforeExpr
    }),
    semi: createToken(";", {
      beforeExpr
    }),
    colon: createToken(":", {
      beforeExpr
    }),
    doubleColon: createToken("::", {
      beforeExpr
    }),
    dot: createToken("."),
    question: createToken("?", {
      beforeExpr
    }),
    questionDot: createToken("?."),
    arrow: createToken("=>", {
      beforeExpr
    }),
    template: createToken("template"),
    ellipsis: createToken("...", {
      beforeExpr
    }),
    backQuote: createToken("`", {
      startsExpr
    }),
    dollarBraceL: createToken("${", {
      beforeExpr,
      startsExpr
    }),
    templateTail: createToken("...`", {
      startsExpr
    }),
    templateNonTail: createToken("...${", {
      beforeExpr,
      startsExpr
    }),
    at: createToken("@"),
    hash: createToken("#", {
      startsExpr
    }),
    interpreterDirective: createToken("#!..."),
    eq: createToken("=", {
      beforeExpr,
      isAssign
    }),
    assign: createToken("_=", {
      beforeExpr,
      isAssign
    }),
    slashAssign: createToken("_=", {
      beforeExpr,
      isAssign
    }),
    xorAssign: createToken("_=", {
      beforeExpr,
      isAssign
    }),
    moduloAssign: createToken("_=", {
      beforeExpr,
      isAssign
    }),
    incDec: createToken("++/--", {
      prefix,
      postfix,
      startsExpr
    }),
    bang: createToken("!", {
      beforeExpr,
      prefix,
      startsExpr
    }),
    tilde: createToken("~", {
      beforeExpr,
      prefix,
      startsExpr
    }),
    doubleCaret: createToken("^^", {
      startsExpr
    }),
    doubleAt: createToken("@@", {
      startsExpr
    }),
    pipeline: createBinop("|>", 0),
    nullishCoalescing: createBinop("??", 1),
    logicalOR: createBinop("||", 1),
    logicalAND: createBinop("&&", 2),
    bitwiseOR: createBinop("|", 3),
    bitwiseXOR: createBinop("^", 4),
    bitwiseAND: createBinop("&", 5),
    equality: createBinop("==/!=/===/!==", 6),
    lt: createBinop("</>/<=/>=", 7),
    gt: createBinop("</>/<=/>=", 7),
    relational: createBinop("</>/<=/>=", 7),
    bitShift: createBinop("<</>>/>>>", 8),
    bitShiftL: createBinop("<</>>/>>>", 8),
    bitShiftR: createBinop("<</>>/>>>", 8),
    plusMin: createToken("+/-", {
      beforeExpr,
      binop: 9,
      prefix,
      startsExpr
    }),
    modulo: createToken("%", {
      binop: 10,
      startsExpr
    }),
    star: createToken("*", {
      binop: 10
    }),
    slash: createBinop("/", 10),
    exponent: createToken("**", {
      beforeExpr,
      binop: 11,
      rightAssociative: true
    }),
    _in: createKeyword("in", {
      beforeExpr,
      binop: 7
    }),
    _instanceof: createKeyword("instanceof", {
      beforeExpr,
      binop: 7
    }),
    _break: createKeyword("break"),
    _case: createKeyword("case", {
      beforeExpr
    }),
    _catch: createKeyword("catch"),
    _continue: createKeyword("continue"),
    _debugger: createKeyword("debugger"),
    _default: createKeyword("default", {
      beforeExpr
    }),
    _else: createKeyword("else", {
      beforeExpr
    }),
    _finally: createKeyword("finally"),
    _function: createKeyword("function", {
      startsExpr
    }),
    _if: createKeyword("if"),
    _return: createKeyword("return", {
      beforeExpr
    }),
    _switch: createKeyword("switch"),
    _throw: createKeyword("throw", {
      beforeExpr,
      prefix,
      startsExpr
    }),
    _try: createKeyword("try"),
    _var: createKeyword("var"),
    _const: createKeyword("const"),
    _with: createKeyword("with"),
    _new: createKeyword("new", {
      beforeExpr,
      startsExpr
    }),
    _this: createKeyword("this", {
      startsExpr
    }),
    _super: createKeyword("super", {
      startsExpr
    }),
    _class: createKeyword("class", {
      startsExpr
    }),
    _extends: createKeyword("extends", {
      beforeExpr
    }),
    _export: createKeyword("export"),
    _import: createKeyword("import", {
      startsExpr
    }),
    _null: createKeyword("null", {
      startsExpr
    }),
    _true: createKeyword("true", {
      startsExpr
    }),
    _false: createKeyword("false", {
      startsExpr
    }),
    _typeof: createKeyword("typeof", {
      beforeExpr,
      prefix,
      startsExpr
    }),
    _void: createKeyword("void", {
      beforeExpr,
      prefix,
      startsExpr
    }),
    _delete: createKeyword("delete", {
      beforeExpr,
      prefix,
      startsExpr
    }),
    _do: createKeyword("do", {
      isLoop,
      beforeExpr
    }),
    _for: createKeyword("for", {
      isLoop
    }),
    _while: createKeyword("while", {
      isLoop
    }),
    _as: createKeywordLike("as", {
      startsExpr
    }),
    _assert: createKeywordLike("assert", {
      startsExpr
    }),
    _async: createKeywordLike("async", {
      startsExpr
    }),
    _await: createKeywordLike("await", {
      startsExpr
    }),
    _defer: createKeywordLike("defer", {
      startsExpr
    }),
    _from: createKeywordLike("from", {
      startsExpr
    }),
    _get: createKeywordLike("get", {
      startsExpr
    }),
    _let: createKeywordLike("let", {
      startsExpr
    }),
    _meta: createKeywordLike("meta", {
      startsExpr
    }),
    _of: createKeywordLike("of", {
      startsExpr
    }),
    _sent: createKeywordLike("sent", {
      startsExpr
    }),
    _set: createKeywordLike("set", {
      startsExpr
    }),
    _source: createKeywordLike("source", {
      startsExpr
    }),
    _static: createKeywordLike("static", {
      startsExpr
    }),
    _using: createKeywordLike("using", {
      startsExpr
    }),
    _yield: createKeywordLike("yield", {
      startsExpr
    }),
    _asserts: createKeywordLike("asserts", {
      startsExpr
    }),
    _checks: createKeywordLike("checks", {
      startsExpr
    }),
    _exports: createKeywordLike("exports", {
      startsExpr
    }),
    _global: createKeywordLike("global", {
      startsExpr
    }),
    _implements: createKeywordLike("implements", {
      startsExpr
    }),
    _intrinsic: createKeywordLike("intrinsic", {
      startsExpr
    }),
    _infer: createKeywordLike("infer", {
      startsExpr
    }),
    _is: createKeywordLike("is", {
      startsExpr
    }),
    _mixins: createKeywordLike("mixins", {
      startsExpr
    }),
    _proto: createKeywordLike("proto", {
      startsExpr
    }),
    _require: createKeywordLike("require", {
      startsExpr
    }),
    _satisfies: createKeywordLike("satisfies", {
      startsExpr
    }),
    _keyof: createKeywordLike("keyof", {
      startsExpr
    }),
    _readonly: createKeywordLike("readonly", {
      startsExpr
    }),
    _unique: createKeywordLike("unique", {
      startsExpr
    }),
    _abstract: createKeywordLike("abstract", {
      startsExpr
    }),
    _declare: createKeywordLike("declare", {
      startsExpr
    }),
    _enum: createKeywordLike("enum", {
      startsExpr
    }),
    _module: createKeywordLike("module", {
      startsExpr
    }),
    _namespace: createKeywordLike("namespace", {
      startsExpr
    }),
    _interface: createKeywordLike("interface", {
      startsExpr
    }),
    _type: createKeywordLike("type", {
      startsExpr
    }),
    _opaque: createKeywordLike("opaque", {
      startsExpr
    }),
    name: createToken("name", {
      startsExpr
    }),
    string: createToken("string", {
      startsExpr
    }),
    num: createToken("num", {
      startsExpr
    }),
    bigint: createToken("bigint", {
      startsExpr
    }),
    decimal: createToken("decimal", {
      startsExpr
    }),
    regexp: createToken("regexp", {
      startsExpr
    }),
    privateName: createToken("#name", {
      startsExpr
    }),
    eof: createToken("eof"),
    jsxName: createToken("jsxName"),
    jsxText: createToken("jsxText", {
      beforeExpr: true
    }),
    jsxTagStart: createToken("jsxTagStart", {
      startsExpr: true
    }),
    jsxTagEnd: createToken("jsxTagEnd"),
    placeholder: createToken("%%", {
      startsExpr: true
    })
  };
  function tokenIsIdentifier(token) {
    return token >= 93 && token <= 132;
  }
  function tokenKeywordOrIdentifierIsKeyword(token) {
    return token <= 92;
  }
  function tokenIsKeywordOrIdentifier(token) {
    return token >= 58 && token <= 132;
  }
  function tokenIsLiteralPropertyName(token) {
    return token >= 58 && token <= 136;
  }
  function tokenComesBeforeExpression(token) {
    return tokenBeforeExprs[token];
  }
  function tokenCanStartExpression(token) {
    return tokenStartsExprs[token];
  }
  function tokenIsAssignment(token) {
    return token >= 29 && token <= 33;
  }
  function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
    return token >= 129 && token <= 131;
  }
  function tokenIsLoop(token) {
    return token >= 90 && token <= 92;
  }
  function tokenIsKeyword(token) {
    return token >= 58 && token <= 92;
  }
  function tokenIsOperator(token) {
    return token >= 39 && token <= 59;
  }
  function tokenIsPostfix(token) {
    return token === 34;
  }
  function tokenIsPrefix(token) {
    return tokenPrefixes[token];
  }
  function tokenIsTSTypeOperator(token) {
    return token >= 121 && token <= 123;
  }
  function tokenIsTSDeclarationStart(token) {
    return token >= 124 && token <= 130;
  }
  function tokenLabelName(token) {
    return tokenLabels[token];
  }
  function tokenOperatorPrecedence(token) {
    return tokenBinops[token];
  }
  function tokenIsRightAssociative(token) {
    return token === 57;
  }
  function tokenIsTemplate(token) {
    return token >= 24 && token <= 25;
  }
  function getExportedToken(token) {
    return tokenTypes[token];
  }
  {
    tokenTypes[8].updateContext = (context) => {
      context.pop();
    };
    tokenTypes[5].updateContext = tokenTypes[7].updateContext = tokenTypes[23].updateContext = (context) => {
      context.push(types3.brace);
    };
    tokenTypes[22].updateContext = (context) => {
      if (context[context.length - 1] === types3.template) {
        context.pop();
      } else {
        context.push(types3.template);
      }
    };
    tokenTypes[142].updateContext = (context) => {
      context.push(types3.j_expr, types3.j_oTag);
    };
  }
  var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C8A\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CD\uA7D0\uA7D1\uA7D3\uA7D5-\uA7DC\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
  var nonASCIIidentifierChars = "\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0897-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0CF3\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECE\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\u30FB\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F\uFF65";
  var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
  var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 4, 51, 13, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 39, 27, 10, 22, 251, 41, 7, 1, 17, 2, 60, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 31, 9, 2, 0, 3, 0, 2, 37, 2, 0, 26, 0, 2, 0, 45, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 200, 32, 32, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 26, 3994, 6, 582, 6842, 29, 1763, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 433, 44, 212, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 42, 9, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 229, 29, 3, 0, 496, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191];
  var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 7, 9, 32, 4, 318, 1, 80, 3, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 68, 8, 2, 0, 3, 0, 2, 3, 2, 4, 2, 0, 15, 1, 83, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 7, 19, 58, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 343, 9, 54, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 10, 5350, 0, 7, 14, 11465, 27, 2343, 9, 87, 9, 39, 4, 60, 6, 26, 9, 535, 9, 470, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4178, 9, 519, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 245, 1, 2, 9, 726, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
  function isInAstralSet(code2, set) {
    let pos = 65536;
    for (let i = 0, length = set.length;i < length; i += 2) {
      pos += set[i];
      if (pos > code2)
        return false;
      pos += set[i + 1];
      if (pos >= code2)
        return true;
    }
    return false;
  }
  function isIdentifierStart(code2) {
    if (code2 < 65)
      return code2 === 36;
    if (code2 <= 90)
      return true;
    if (code2 < 97)
      return code2 === 95;
    if (code2 <= 122)
      return true;
    if (code2 <= 65535) {
      return code2 >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code2));
    }
    return isInAstralSet(code2, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code2) {
    if (code2 < 48)
      return code2 === 36;
    if (code2 < 58)
      return true;
    if (code2 < 65)
      return false;
    if (code2 <= 90)
      return true;
    if (code2 < 97)
      return code2 === 95;
    if (code2 <= 122)
      return true;
    if (code2 <= 65535) {
      return code2 >= 170 && nonASCIIidentifier.test(String.fromCharCode(code2));
    }
    return isInAstralSet(code2, astralIdentifierStartCodes) || isInAstralSet(code2, astralIdentifierCodes);
  }
  var reservedWords = {
    keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
    strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
    strictBind: ["eval", "arguments"]
  };
  var keywords = new Set(reservedWords.keyword);
  var reservedWordsStrictSet = new Set(reservedWords.strict);
  var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return inModule && word === "await" || word === "enum";
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
  function isIteratorStart(current, next, next2) {
    return current === 64 && next === 64 && isIdentifierStart(next2);
  }
  var reservedWordLikeSet = new Set(["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete", "implements", "interface", "let", "package", "private", "protected", "public", "static", "yield", "eval", "arguments", "enum", "await"]);
  function canBeReservedWord(word) {
    return reservedWordLikeSet.has(word);
  }

  class Scope {
    constructor(flags) {
      this.flags = 0;
      this.names = new Map;
      this.firstLexicalName = "";
      this.flags = flags;
    }
  }

  class ScopeHandler {
    constructor(parser, inModule) {
      this.parser = undefined;
      this.scopeStack = [];
      this.inModule = undefined;
      this.undefinedExports = new Map;
      this.parser = parser;
      this.inModule = inModule;
    }
    get inTopLevel() {
      return (this.currentScope().flags & 1) > 0;
    }
    get inFunction() {
      return (this.currentVarScopeFlags() & 2) > 0;
    }
    get allowSuper() {
      return (this.currentThisScopeFlags() & 16) > 0;
    }
    get allowDirectSuper() {
      return (this.currentThisScopeFlags() & 32) > 0;
    }
    get inClass() {
      return (this.currentThisScopeFlags() & 64) > 0;
    }
    get inClassAndNotInNonArrowFunction() {
      const flags = this.currentThisScopeFlags();
      return (flags & 64) > 0 && (flags & 2) === 0;
    }
    get inStaticBlock() {
      for (let i = this.scopeStack.length - 1;; i--) {
        const {
          flags
        } = this.scopeStack[i];
        if (flags & 128) {
          return true;
        }
        if (flags & 451) {
          return false;
        }
      }
    }
    get inNonArrowFunction() {
      return (this.currentThisScopeFlags() & 2) > 0;
    }
    get treatFunctionsAsVar() {
      return this.treatFunctionsAsVarInScope(this.currentScope());
    }
    createScope(flags) {
      return new Scope(flags);
    }
    enter(flags) {
      this.scopeStack.push(this.createScope(flags));
    }
    exit() {
      const scope = this.scopeStack.pop();
      return scope.flags;
    }
    treatFunctionsAsVarInScope(scope) {
      return !!(scope.flags & 130 || !this.parser.inModule && scope.flags & 1);
    }
    declareName(name, bindingType, loc) {
      let scope = this.currentScope();
      if (bindingType & 8 || bindingType & 16) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        let type = scope.names.get(name) || 0;
        if (bindingType & 16) {
          type = type | 4;
        } else {
          if (!scope.firstLexicalName) {
            scope.firstLexicalName = name;
          }
          type = type | 2;
        }
        scope.names.set(name, type);
        if (bindingType & 8) {
          this.maybeExportDefined(scope, name);
        }
      } else if (bindingType & 4) {
        for (let i = this.scopeStack.length - 1;i >= 0; --i) {
          scope = this.scopeStack[i];
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          scope.names.set(name, (scope.names.get(name) || 0) | 1);
          this.maybeExportDefined(scope, name);
          if (scope.flags & 387)
            break;
        }
      }
      if (this.parser.inModule && scope.flags & 1) {
        this.undefinedExports.delete(name);
      }
    }
    maybeExportDefined(scope, name) {
      if (this.parser.inModule && scope.flags & 1) {
        this.undefinedExports.delete(name);
      }
    }
    checkRedeclarationInScope(scope, name, bindingType, loc) {
      if (this.isRedeclaredInScope(scope, name, bindingType)) {
        this.parser.raise(Errors.VarRedeclaration, loc, {
          identifierName: name
        });
      }
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (!(bindingType & 1))
        return false;
      if (bindingType & 8) {
        return scope.names.has(name);
      }
      const type = scope.names.get(name);
      if (bindingType & 16) {
        return (type & 2) > 0 || !this.treatFunctionsAsVarInScope(scope) && (type & 1) > 0;
      }
      return (type & 2) > 0 && !(scope.flags & 8 && scope.firstLexicalName === name) || !this.treatFunctionsAsVarInScope(scope) && (type & 4) > 0;
    }
    checkLocalExport(id) {
      const {
        name
      } = id;
      const topLevelScope = this.scopeStack[0];
      if (!topLevelScope.names.has(name)) {
        this.undefinedExports.set(name, id.loc.start);
      }
    }
    currentScope() {
      return this.scopeStack[this.scopeStack.length - 1];
    }
    currentVarScopeFlags() {
      for (let i = this.scopeStack.length - 1;; i--) {
        const {
          flags
        } = this.scopeStack[i];
        if (flags & 387) {
          return flags;
        }
      }
    }
    currentThisScopeFlags() {
      for (let i = this.scopeStack.length - 1;; i--) {
        const {
          flags
        } = this.scopeStack[i];
        if (flags & 451 && !(flags & 4)) {
          return flags;
        }
      }
    }
  }

  class FlowScope extends Scope {
    constructor(...args) {
      super(...args);
      this.declareFunctions = new Set;
    }
  }

  class FlowScopeHandler extends ScopeHandler {
    createScope(flags) {
      return new FlowScope(flags);
    }
    declareName(name, bindingType, loc) {
      const scope = this.currentScope();
      if (bindingType & 2048) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        this.maybeExportDefined(scope, name);
        scope.declareFunctions.add(name);
        return;
      }
      super.declareName(name, bindingType, loc);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (super.isRedeclaredInScope(scope, name, bindingType))
        return true;
      if (bindingType & 2048 && !scope.declareFunctions.has(name)) {
        const type = scope.names.get(name);
        return (type & 4) > 0 || (type & 2) > 0;
      }
      return false;
    }
    checkLocalExport(id) {
      if (!this.scopeStack[0].declareFunctions.has(id.name)) {
        super.checkLocalExport(id);
      }
    }
  }

  class BaseParser {
    constructor() {
      this.sawUnambiguousESM = false;
      this.ambiguousScriptDifferentAst = false;
    }
    hasPlugin(pluginConfig) {
      if (typeof pluginConfig === "string") {
        return this.plugins.has(pluginConfig);
      } else {
        const [pluginName, pluginOptions] = pluginConfig;
        if (!this.hasPlugin(pluginName)) {
          return false;
        }
        const actualOptions = this.plugins.get(pluginName);
        for (const key of Object.keys(pluginOptions)) {
          if ((actualOptions == null ? undefined : actualOptions[key]) !== pluginOptions[key]) {
            return false;
          }
        }
        return true;
      }
    }
    getPluginOption(plugin, name) {
      var _this$plugins$get;
      return (_this$plugins$get = this.plugins.get(plugin)) == null ? undefined : _this$plugins$get[name];
    }
  }
  function setTrailingComments(node, comments) {
    if (node.trailingComments === undefined) {
      node.trailingComments = comments;
    } else {
      node.trailingComments.unshift(...comments);
    }
  }
  function setLeadingComments(node, comments) {
    if (node.leadingComments === undefined) {
      node.leadingComments = comments;
    } else {
      node.leadingComments.unshift(...comments);
    }
  }
  function setInnerComments(node, comments) {
    if (node.innerComments === undefined) {
      node.innerComments = comments;
    } else {
      node.innerComments.unshift(...comments);
    }
  }
  function adjustInnerComments(node, elements, commentWS) {
    let lastElement = null;
    let i = elements.length;
    while (lastElement === null && i > 0) {
      lastElement = elements[--i];
    }
    if (lastElement === null || lastElement.start > commentWS.start) {
      setInnerComments(node, commentWS.comments);
    } else {
      setTrailingComments(lastElement, commentWS.comments);
    }
  }

  class CommentsParser extends BaseParser {
    addComment(comment) {
      if (this.filename)
        comment.loc.filename = this.filename;
      const {
        commentsLen
      } = this.state;
      if (this.comments.length !== commentsLen) {
        this.comments.length = commentsLen;
      }
      this.comments.push(comment);
      this.state.commentsLen++;
    }
    processComment(node) {
      const {
        commentStack
      } = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0)
        return;
      let i = commentStackLength - 1;
      const lastCommentWS = commentStack[i];
      if (lastCommentWS.start === node.end) {
        lastCommentWS.leadingNode = node;
        i--;
      }
      const {
        start: nodeStart
      } = node;
      for (;i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        if (commentEnd > nodeStart) {
          commentWS.containingNode = node;
          this.finalizeComment(commentWS);
          commentStack.splice(i, 1);
        } else {
          if (commentEnd === nodeStart) {
            commentWS.trailingNode = node;
          }
          break;
        }
      }
    }
    finalizeComment(commentWS) {
      const {
        comments
      } = commentWS;
      if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
        if (commentWS.leadingNode !== null) {
          setTrailingComments(commentWS.leadingNode, comments);
        }
        if (commentWS.trailingNode !== null) {
          setLeadingComments(commentWS.trailingNode, comments);
        }
      } else {
        const {
          containingNode: node,
          start: commentStart
        } = commentWS;
        if (this.input.charCodeAt(commentStart - 1) === 44) {
          switch (node.type) {
            case "ObjectExpression":
            case "ObjectPattern":
            case "RecordExpression":
              adjustInnerComments(node, node.properties, commentWS);
              break;
            case "CallExpression":
            case "OptionalCallExpression":
              adjustInnerComments(node, node.arguments, commentWS);
              break;
            case "FunctionDeclaration":
            case "FunctionExpression":
            case "ArrowFunctionExpression":
            case "ObjectMethod":
            case "ClassMethod":
            case "ClassPrivateMethod":
              adjustInnerComments(node, node.params, commentWS);
              break;
            case "ArrayExpression":
            case "ArrayPattern":
            case "TupleExpression":
              adjustInnerComments(node, node.elements, commentWS);
              break;
            case "ExportNamedDeclaration":
            case "ImportDeclaration":
              adjustInnerComments(node, node.specifiers, commentWS);
              break;
            default: {
              setInnerComments(node, comments);
            }
          }
        } else {
          setInnerComments(node, comments);
        }
      }
    }
    finalizeRemainingComments() {
      const {
        commentStack
      } = this.state;
      for (let i = commentStack.length - 1;i >= 0; i--) {
        this.finalizeComment(commentStack[i]);
      }
      this.state.commentStack = [];
    }
    resetPreviousNodeTrailingComments(node) {
      const {
        commentStack
      } = this.state;
      const {
        length
      } = commentStack;
      if (length === 0)
        return;
      const commentWS = commentStack[length - 1];
      if (commentWS.leadingNode === node) {
        commentWS.leadingNode = null;
      }
    }
    resetPreviousIdentifierLeadingComments(node) {
      const {
        commentStack
      } = this.state;
      const {
        length
      } = commentStack;
      if (length === 0)
        return;
      if (commentStack[length - 1].trailingNode === node) {
        commentStack[length - 1].trailingNode = null;
      } else if (length >= 2 && commentStack[length - 2].trailingNode === node) {
        commentStack[length - 2].trailingNode = null;
      }
    }
    takeSurroundingComments(node, start, end) {
      const {
        commentStack
      } = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0)
        return;
      let i = commentStackLength - 1;
      for (;i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        const commentStart = commentWS.start;
        if (commentStart === end) {
          commentWS.leadingNode = node;
        } else if (commentEnd === start) {
          commentWS.trailingNode = node;
        } else if (commentEnd < start) {
          break;
        }
      }
    }
  }
  var lineBreak = /\r\n|[\r\n\u2028\u2029]/;
  var lineBreakG = new RegExp(lineBreak.source, "g");
  function isNewLine(code2) {
    switch (code2) {
      case 10:
      case 13:
      case 8232:
      case 8233:
        return true;
      default:
        return false;
    }
  }
  function hasNewLine(input, start, end) {
    for (let i = start;i < end; i++) {
      if (isNewLine(input.charCodeAt(i))) {
        return true;
      }
    }
    return false;
  }
  var skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
  var skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/g;
  function isWhitespace(code2) {
    switch (code2) {
      case 9:
      case 11:
      case 12:
      case 32:
      case 160:
      case 5760:
      case 8192:
      case 8193:
      case 8194:
      case 8195:
      case 8196:
      case 8197:
      case 8198:
      case 8199:
      case 8200:
      case 8201:
      case 8202:
      case 8239:
      case 8287:
      case 12288:
      case 65279:
        return true;
      default:
        return false;
    }
  }

  class State {
    constructor() {
      this.flags = 1024;
      this.curLine = undefined;
      this.lineStart = undefined;
      this.startLoc = undefined;
      this.endLoc = undefined;
      this.errors = [];
      this.potentialArrowAt = -1;
      this.noArrowAt = [];
      this.noArrowParamsConversionAt = [];
      this.topicContext = {
        maxNumOfResolvableTopics: 0,
        maxTopicIndex: null
      };
      this.labels = [];
      this.commentsLen = 0;
      this.commentStack = [];
      this.pos = 0;
      this.type = 139;
      this.value = null;
      this.start = 0;
      this.end = 0;
      this.lastTokEndLoc = null;
      this.lastTokStartLoc = null;
      this.context = [types3.brace];
      this.firstInvalidTemplateEscapePos = null;
      this.strictErrors = new Map;
      this.tokensLength = 0;
    }
    get strict() {
      return (this.flags & 1) > 0;
    }
    set strict(v22) {
      if (v22)
        this.flags |= 1;
      else
        this.flags &= -2;
    }
    init({
      strictMode,
      sourceType,
      startLine,
      startColumn
    }) {
      this.strict = strictMode === false ? false : strictMode === true ? true : sourceType === "module";
      this.curLine = startLine;
      this.lineStart = -startColumn;
      this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
    }
    get maybeInArrowParameters() {
      return (this.flags & 2) > 0;
    }
    set maybeInArrowParameters(v22) {
      if (v22)
        this.flags |= 2;
      else
        this.flags &= -3;
    }
    get inType() {
      return (this.flags & 4) > 0;
    }
    set inType(v22) {
      if (v22)
        this.flags |= 4;
      else
        this.flags &= -5;
    }
    get noAnonFunctionType() {
      return (this.flags & 8) > 0;
    }
    set noAnonFunctionType(v22) {
      if (v22)
        this.flags |= 8;
      else
        this.flags &= -9;
    }
    get hasFlowComment() {
      return (this.flags & 16) > 0;
    }
    set hasFlowComment(v22) {
      if (v22)
        this.flags |= 16;
      else
        this.flags &= -17;
    }
    get isAmbientContext() {
      return (this.flags & 32) > 0;
    }
    set isAmbientContext(v22) {
      if (v22)
        this.flags |= 32;
      else
        this.flags &= -33;
    }
    get inAbstractClass() {
      return (this.flags & 64) > 0;
    }
    set inAbstractClass(v22) {
      if (v22)
        this.flags |= 64;
      else
        this.flags &= -65;
    }
    get inDisallowConditionalTypesContext() {
      return (this.flags & 128) > 0;
    }
    set inDisallowConditionalTypesContext(v22) {
      if (v22)
        this.flags |= 128;
      else
        this.flags &= -129;
    }
    get soloAwait() {
      return (this.flags & 256) > 0;
    }
    set soloAwait(v22) {
      if (v22)
        this.flags |= 256;
      else
        this.flags &= -257;
    }
    get inFSharpPipelineDirectBody() {
      return (this.flags & 512) > 0;
    }
    set inFSharpPipelineDirectBody(v22) {
      if (v22)
        this.flags |= 512;
      else
        this.flags &= -513;
    }
    get canStartJSXElement() {
      return (this.flags & 1024) > 0;
    }
    set canStartJSXElement(v22) {
      if (v22)
        this.flags |= 1024;
      else
        this.flags &= -1025;
    }
    get containsEsc() {
      return (this.flags & 2048) > 0;
    }
    set containsEsc(v22) {
      if (v22)
        this.flags |= 2048;
      else
        this.flags &= -2049;
    }
    get hasTopLevelAwait() {
      return (this.flags & 4096) > 0;
    }
    set hasTopLevelAwait(v22) {
      if (v22)
        this.flags |= 4096;
      else
        this.flags &= -4097;
    }
    curPosition() {
      return new Position(this.curLine, this.pos - this.lineStart, this.pos);
    }
    clone() {
      const state = new State;
      state.flags = this.flags;
      state.curLine = this.curLine;
      state.lineStart = this.lineStart;
      state.startLoc = this.startLoc;
      state.endLoc = this.endLoc;
      state.errors = this.errors.slice();
      state.potentialArrowAt = this.potentialArrowAt;
      state.noArrowAt = this.noArrowAt.slice();
      state.noArrowParamsConversionAt = this.noArrowParamsConversionAt.slice();
      state.topicContext = this.topicContext;
      state.labels = this.labels.slice();
      state.commentsLen = this.commentsLen;
      state.commentStack = this.commentStack.slice();
      state.pos = this.pos;
      state.type = this.type;
      state.value = this.value;
      state.start = this.start;
      state.end = this.end;
      state.lastTokEndLoc = this.lastTokEndLoc;
      state.lastTokStartLoc = this.lastTokStartLoc;
      state.context = this.context.slice();
      state.firstInvalidTemplateEscapePos = this.firstInvalidTemplateEscapePos;
      state.strictErrors = this.strictErrors;
      state.tokensLength = this.tokensLength;
      return state;
    }
  }
  var _isDigit = function isDigit(code2) {
    return code2 >= 48 && code2 <= 57;
  };
  var forbiddenNumericSeparatorSiblings = {
    decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
    hex: new Set([46, 88, 95, 120])
  };
  var isAllowedNumericSeparatorSibling = {
    bin: (ch) => ch === 48 || ch === 49,
    oct: (ch) => ch >= 48 && ch <= 55,
    dec: (ch) => ch >= 48 && ch <= 57,
    hex: (ch) => ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102
  };
  function readStringContents(type, input, pos, lineStart, curLine, errors3) {
    const initialPos = pos;
    const initialLineStart = lineStart;
    const initialCurLine = curLine;
    let out = "";
    let firstInvalidLoc = null;
    let chunkStart = pos;
    const {
      length
    } = input;
    for (;; ) {
      if (pos >= length) {
        errors3.unterminated(initialPos, initialLineStart, initialCurLine);
        out += input.slice(chunkStart, pos);
        break;
      }
      const ch = input.charCodeAt(pos);
      if (isStringEnd(type, ch, input, pos)) {
        out += input.slice(chunkStart, pos);
        break;
      }
      if (ch === 92) {
        out += input.slice(chunkStart, pos);
        const res = readEscapedChar(input, pos, lineStart, curLine, type === "template", errors3);
        if (res.ch === null && !firstInvalidLoc) {
          firstInvalidLoc = {
            pos,
            lineStart,
            curLine
          };
        } else {
          out += res.ch;
        }
        ({
          pos,
          lineStart,
          curLine
        } = res);
        chunkStart = pos;
      } else if (ch === 8232 || ch === 8233) {
        ++pos;
        ++curLine;
        lineStart = pos;
      } else if (ch === 10 || ch === 13) {
        if (type === "template") {
          out += input.slice(chunkStart, pos) + "\n";
          ++pos;
          if (ch === 13 && input.charCodeAt(pos) === 10) {
            ++pos;
          }
          ++curLine;
          chunkStart = lineStart = pos;
        } else {
          errors3.unterminated(initialPos, initialLineStart, initialCurLine);
        }
      } else {
        ++pos;
      }
    }
    return {
      pos,
      str: out,
      firstInvalidLoc,
      lineStart,
      curLine,
      containsInvalid: !!firstInvalidLoc
    };
  }
  function isStringEnd(type, ch, input, pos) {
    if (type === "template") {
      return ch === 96 || ch === 36 && input.charCodeAt(pos + 1) === 123;
    }
    return ch === (type === "double" ? 34 : 39);
  }
  function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors3) {
    const throwOnInvalid = !inTemplate;
    pos++;
    const res = (ch2) => ({
      pos,
      ch: ch2,
      lineStart,
      curLine
    });
    const ch = input.charCodeAt(pos++);
    switch (ch) {
      case 110:
        return res("\n");
      case 114:
        return res("\r");
      case 120: {
        let code2;
        ({
          code: code2,
          pos
        } = readHexChar(input, pos, lineStart, curLine, 2, false, throwOnInvalid, errors3));
        return res(code2 === null ? null : String.fromCharCode(code2));
      }
      case 117: {
        let code2;
        ({
          code: code2,
          pos
        } = readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors3));
        return res(code2 === null ? null : String.fromCodePoint(code2));
      }
      case 116:
        return res("\t");
      case 98:
        return res("\b");
      case 118:
        return res("\v");
      case 102:
        return res("\f");
      case 13:
        if (input.charCodeAt(pos) === 10) {
          ++pos;
        }
      case 10:
        lineStart = pos;
        ++curLine;
      case 8232:
      case 8233:
        return res("");
      case 56:
      case 57:
        if (inTemplate) {
          return res(null);
        } else {
          errors3.strictNumericEscape(pos - 1, lineStart, curLine);
        }
      default:
        if (ch >= 48 && ch <= 55) {
          const startPos = pos - 1;
          const match = /^[0-7]+/.exec(input.slice(startPos, pos + 2));
          let octalStr = match[0];
          let octal = parseInt(octalStr, 8);
          if (octal > 255) {
            octalStr = octalStr.slice(0, -1);
            octal = parseInt(octalStr, 8);
          }
          pos += octalStr.length - 1;
          const next = input.charCodeAt(pos);
          if (octalStr !== "0" || next === 56 || next === 57) {
            if (inTemplate) {
              return res(null);
            } else {
              errors3.strictNumericEscape(startPos, lineStart, curLine);
            }
          }
          return res(String.fromCharCode(octal));
        }
        return res(String.fromCharCode(ch));
    }
  }
  function readHexChar(input, pos, lineStart, curLine, len, forceLen, throwOnInvalid, errors3) {
    const initialPos = pos;
    let n;
    ({
      n,
      pos
    } = readInt(input, pos, lineStart, curLine, 16, len, forceLen, false, errors3, !throwOnInvalid));
    if (n === null) {
      if (throwOnInvalid) {
        errors3.invalidEscapeSequence(initialPos, lineStart, curLine);
      } else {
        pos = initialPos - 1;
      }
    }
    return {
      code: n,
      pos
    };
  }
  function readInt(input, pos, lineStart, curLine, radix, len, forceLen, allowNumSeparator, errors3, bailOnError) {
    const start = pos;
    const forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
    const isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling.hex : radix === 10 ? isAllowedNumericSeparatorSibling.dec : radix === 8 ? isAllowedNumericSeparatorSibling.oct : isAllowedNumericSeparatorSibling.bin;
    let invalid = false;
    let total = 0;
    for (let i = 0, e = len == null ? Infinity : len;i < e; ++i) {
      const code2 = input.charCodeAt(pos);
      let val2;
      if (code2 === 95 && allowNumSeparator !== "bail") {
        const prev = input.charCodeAt(pos - 1);
        const next = input.charCodeAt(pos + 1);
        if (!allowNumSeparator) {
          if (bailOnError)
            return {
              n: null,
              pos
            };
          errors3.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
        } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
          if (bailOnError)
            return {
              n: null,
              pos
            };
          errors3.unexpectedNumericSeparator(pos, lineStart, curLine);
        }
        ++pos;
        continue;
      }
      if (code2 >= 97) {
        val2 = code2 - 97 + 10;
      } else if (code2 >= 65) {
        val2 = code2 - 65 + 10;
      } else if (_isDigit(code2)) {
        val2 = code2 - 48;
      } else {
        val2 = Infinity;
      }
      if (val2 >= radix) {
        if (val2 <= 9 && bailOnError) {
          return {
            n: null,
            pos
          };
        } else if (val2 <= 9 && errors3.invalidDigit(pos, lineStart, curLine, radix)) {
          val2 = 0;
        } else if (forceLen) {
          val2 = 0;
          invalid = true;
        } else {
          break;
        }
      }
      ++pos;
      total = total * radix + val2;
    }
    if (pos === start || len != null && pos - start !== len || invalid) {
      return {
        n: null,
        pos
      };
    }
    return {
      n: total,
      pos
    };
  }
  function readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors3) {
    const ch = input.charCodeAt(pos);
    let code2;
    if (ch === 123) {
      ++pos;
      ({
        code: code2,
        pos
      } = readHexChar(input, pos, lineStart, curLine, input.indexOf("}", pos) - pos, true, throwOnInvalid, errors3));
      ++pos;
      if (code2 !== null && code2 > 1114111) {
        if (throwOnInvalid) {
          errors3.invalidCodePoint(pos, lineStart, curLine);
        } else {
          return {
            code: null,
            pos
          };
        }
      }
    } else {
      ({
        code: code2,
        pos
      } = readHexChar(input, pos, lineStart, curLine, 4, false, throwOnInvalid, errors3));
    }
    return {
      code: code2,
      pos
    };
  }
  function buildPosition(pos, lineStart, curLine) {
    return new Position(curLine, pos - lineStart, pos);
  }
  var VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);

  class Token {
    constructor(state) {
      this.type = state.type;
      this.value = state.value;
      this.start = state.start;
      this.end = state.end;
      this.loc = new SourceLocation(state.startLoc, state.endLoc);
    }
  }

  class Tokenizer extends CommentsParser {
    constructor(options3, input) {
      super();
      this.isLookahead = undefined;
      this.tokens = [];
      this.errorHandlers_readInt = {
        invalidDigit: (pos, lineStart, curLine, radix) => {
          if (!this.options.errorRecovery)
            return false;
          this.raise(Errors.InvalidDigit, buildPosition(pos, lineStart, curLine), {
            radix
          });
          return true;
        },
        numericSeparatorInEscapeSequence: this.errorBuilder(Errors.NumericSeparatorInEscapeSequence),
        unexpectedNumericSeparator: this.errorBuilder(Errors.UnexpectedNumericSeparator)
      };
      this.errorHandlers_readCodePoint = Object.assign({}, this.errorHandlers_readInt, {
        invalidEscapeSequence: this.errorBuilder(Errors.InvalidEscapeSequence),
        invalidCodePoint: this.errorBuilder(Errors.InvalidCodePoint)
      });
      this.errorHandlers_readStringContents_string = Object.assign({}, this.errorHandlers_readCodePoint, {
        strictNumericEscape: (pos, lineStart, curLine) => {
          this.recordStrictModeErrors(Errors.StrictNumericEscape, buildPosition(pos, lineStart, curLine));
        },
        unterminated: (pos, lineStart, curLine) => {
          throw this.raise(Errors.UnterminatedString, buildPosition(pos - 1, lineStart, curLine));
        }
      });
      this.errorHandlers_readStringContents_template = Object.assign({}, this.errorHandlers_readCodePoint, {
        strictNumericEscape: this.errorBuilder(Errors.StrictNumericEscape),
        unterminated: (pos, lineStart, curLine) => {
          throw this.raise(Errors.UnterminatedTemplate, buildPosition(pos, lineStart, curLine));
        }
      });
      this.state = new State;
      this.state.init(options3);
      this.input = input;
      this.length = input.length;
      this.comments = [];
      this.isLookahead = false;
    }
    pushToken(token) {
      this.tokens.length = this.state.tokensLength;
      this.tokens.push(token);
      ++this.state.tokensLength;
    }
    next() {
      this.checkKeywordEscapes();
      if (this.options.tokens) {
        this.pushToken(new Token(this.state));
      }
      this.state.lastTokEndLoc = this.state.endLoc;
      this.state.lastTokStartLoc = this.state.startLoc;
      this.nextToken();
    }
    eat(type) {
      if (this.match(type)) {
        this.next();
        return true;
      } else {
        return false;
      }
    }
    match(type) {
      return this.state.type === type;
    }
    createLookaheadState(state) {
      return {
        pos: state.pos,
        value: null,
        type: state.type,
        start: state.start,
        end: state.end,
        context: [this.curContext()],
        inType: state.inType,
        startLoc: state.startLoc,
        lastTokEndLoc: state.lastTokEndLoc,
        curLine: state.curLine,
        lineStart: state.lineStart,
        curPosition: state.curPosition
      };
    }
    lookahead() {
      const old = this.state;
      this.state = this.createLookaheadState(old);
      this.isLookahead = true;
      this.nextToken();
      this.isLookahead = false;
      const curr = this.state;
      this.state = old;
      return curr;
    }
    nextTokenStart() {
      return this.nextTokenStartSince(this.state.pos);
    }
    nextTokenStartSince(pos) {
      skipWhiteSpace.lastIndex = pos;
      return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
    }
    lookaheadCharCode() {
      return this.input.charCodeAt(this.nextTokenStart());
    }
    nextTokenInLineStart() {
      return this.nextTokenInLineStartSince(this.state.pos);
    }
    nextTokenInLineStartSince(pos) {
      skipWhiteSpaceInLine.lastIndex = pos;
      return skipWhiteSpaceInLine.test(this.input) ? skipWhiteSpaceInLine.lastIndex : pos;
    }
    lookaheadInLineCharCode() {
      return this.input.charCodeAt(this.nextTokenInLineStart());
    }
    codePointAtPos(pos) {
      let cp = this.input.charCodeAt(pos);
      if ((cp & 64512) === 55296 && ++pos < this.input.length) {
        const trail = this.input.charCodeAt(pos);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      return cp;
    }
    setStrict(strict) {
      this.state.strict = strict;
      if (strict) {
        this.state.strictErrors.forEach(([toParseError, at]) => this.raise(toParseError, at));
        this.state.strictErrors.clear();
      }
    }
    curContext() {
      return this.state.context[this.state.context.length - 1];
    }
    nextToken() {
      this.skipSpace();
      this.state.start = this.state.pos;
      if (!this.isLookahead)
        this.state.startLoc = this.state.curPosition();
      if (this.state.pos >= this.length) {
        this.finishToken(139);
        return;
      }
      this.getTokenFromCode(this.codePointAtPos(this.state.pos));
    }
    skipBlockComment(commentEnd) {
      let startLoc;
      if (!this.isLookahead)
        startLoc = this.state.curPosition();
      const start = this.state.pos;
      const end = this.input.indexOf(commentEnd, start + 2);
      if (end === -1) {
        throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
      }
      this.state.pos = end + commentEnd.length;
      lineBreakG.lastIndex = start + 2;
      while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
        ++this.state.curLine;
        this.state.lineStart = lineBreakG.lastIndex;
      }
      if (this.isLookahead)
        return;
      const comment = {
        type: "CommentBlock",
        value: this.input.slice(start + 2, end),
        start,
        end: end + commentEnd.length,
        loc: new SourceLocation(startLoc, this.state.curPosition())
      };
      if (this.options.tokens)
        this.pushToken(comment);
      return comment;
    }
    skipLineComment(startSkip) {
      const start = this.state.pos;
      let startLoc;
      if (!this.isLookahead)
        startLoc = this.state.curPosition();
      let ch = this.input.charCodeAt(this.state.pos += startSkip);
      if (this.state.pos < this.length) {
        while (!isNewLine(ch) && ++this.state.pos < this.length) {
          ch = this.input.charCodeAt(this.state.pos);
        }
      }
      if (this.isLookahead)
        return;
      const end = this.state.pos;
      const value = this.input.slice(start + startSkip, end);
      const comment = {
        type: "CommentLine",
        value,
        start,
        end,
        loc: new SourceLocation(startLoc, this.state.curPosition())
      };
      if (this.options.tokens)
        this.pushToken(comment);
      return comment;
    }
    skipSpace() {
      const spaceStart = this.state.pos;
      const comments = [];
      loop:
        while (this.state.pos < this.length) {
          const ch = this.input.charCodeAt(this.state.pos);
          switch (ch) {
            case 32:
            case 160:
            case 9:
              ++this.state.pos;
              break;
            case 13:
              if (this.input.charCodeAt(this.state.pos + 1) === 10) {
                ++this.state.pos;
              }
            case 10:
            case 8232:
            case 8233:
              ++this.state.pos;
              ++this.state.curLine;
              this.state.lineStart = this.state.pos;
              break;
            case 47:
              switch (this.input.charCodeAt(this.state.pos + 1)) {
                case 42: {
                  const comment = this.skipBlockComment("*/");
                  if (comment !== undefined) {
                    this.addComment(comment);
                    if (this.options.attachComment)
                      comments.push(comment);
                  }
                  break;
                }
                case 47: {
                  const comment = this.skipLineComment(2);
                  if (comment !== undefined) {
                    this.addComment(comment);
                    if (this.options.attachComment)
                      comments.push(comment);
                  }
                  break;
                }
                default:
                  break loop;
              }
              break;
            default:
              if (isWhitespace(ch)) {
                ++this.state.pos;
              } else if (ch === 45 && !this.inModule && this.options.annexB) {
                const pos = this.state.pos;
                if (this.input.charCodeAt(pos + 1) === 45 && this.input.charCodeAt(pos + 2) === 62 && (spaceStart === 0 || this.state.lineStart > spaceStart)) {
                  const comment = this.skipLineComment(3);
                  if (comment !== undefined) {
                    this.addComment(comment);
                    if (this.options.attachComment)
                      comments.push(comment);
                  }
                } else {
                  break loop;
                }
              } else if (ch === 60 && !this.inModule && this.options.annexB) {
                const pos = this.state.pos;
                if (this.input.charCodeAt(pos + 1) === 33 && this.input.charCodeAt(pos + 2) === 45 && this.input.charCodeAt(pos + 3) === 45) {
                  const comment = this.skipLineComment(4);
                  if (comment !== undefined) {
                    this.addComment(comment);
                    if (this.options.attachComment)
                      comments.push(comment);
                  }
                } else {
                  break loop;
                }
              } else {
                break loop;
              }
          }
        }
      if (comments.length > 0) {
        const end = this.state.pos;
        const commentWhitespace = {
          start: spaceStart,
          end,
          comments,
          leadingNode: null,
          trailingNode: null,
          containingNode: null
        };
        this.state.commentStack.push(commentWhitespace);
      }
    }
    finishToken(type, val2) {
      this.state.end = this.state.pos;
      this.state.endLoc = this.state.curPosition();
      const prevType = this.state.type;
      this.state.type = type;
      this.state.value = val2;
      if (!this.isLookahead) {
        this.updateContext(prevType);
      }
    }
    replaceToken(type) {
      this.state.type = type;
      this.updateContext();
    }
    readToken_numberSign() {
      if (this.state.pos === 0 && this.readToken_interpreter()) {
        return;
      }
      const nextPos = this.state.pos + 1;
      const next = this.codePointAtPos(nextPos);
      if (next >= 48 && next <= 57) {
        throw this.raise(Errors.UnexpectedDigitAfterHash, this.state.curPosition());
      }
      if (next === 123 || next === 91 && this.hasPlugin("recordAndTuple")) {
        this.expectPlugin("recordAndTuple");
        if (this.getPluginOption("recordAndTuple", "syntaxType") === "bar") {
          throw this.raise(next === 123 ? Errors.RecordExpressionHashIncorrectStartSyntaxType : Errors.TupleExpressionHashIncorrectStartSyntaxType, this.state.curPosition());
        }
        this.state.pos += 2;
        if (next === 123) {
          this.finishToken(7);
        } else {
          this.finishToken(1);
        }
      } else if (isIdentifierStart(next)) {
        ++this.state.pos;
        this.finishToken(138, this.readWord1(next));
      } else if (next === 92) {
        ++this.state.pos;
        this.finishToken(138, this.readWord1());
      } else {
        this.finishOp(27, 1);
      }
    }
    readToken_dot() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next >= 48 && next <= 57) {
        this.readNumber(true);
        return;
      }
      if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
        this.state.pos += 3;
        this.finishToken(21);
      } else {
        ++this.state.pos;
        this.finishToken(16);
      }
    }
    readToken_slash() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(31, 2);
      } else {
        this.finishOp(56, 1);
      }
    }
    readToken_interpreter() {
      if (this.state.pos !== 0 || this.length < 2)
        return false;
      let ch = this.input.charCodeAt(this.state.pos + 1);
      if (ch !== 33)
        return false;
      const start = this.state.pos;
      this.state.pos += 1;
      while (!isNewLine(ch) && ++this.state.pos < this.length) {
        ch = this.input.charCodeAt(this.state.pos);
      }
      const value = this.input.slice(start + 2, this.state.pos);
      this.finishToken(28, value);
      return true;
    }
    readToken_mult_modulo(code2) {
      let type = code2 === 42 ? 55 : 54;
      let width = 1;
      let next = this.input.charCodeAt(this.state.pos + 1);
      if (code2 === 42 && next === 42) {
        width++;
        next = this.input.charCodeAt(this.state.pos + 2);
        type = 57;
      }
      if (next === 61 && !this.state.inType) {
        width++;
        type = code2 === 37 ? 33 : 30;
      }
      this.finishOp(type, width);
    }
    readToken_pipe_amp(code2) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code2) {
        if (this.input.charCodeAt(this.state.pos + 2) === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(code2 === 124 ? 41 : 42, 2);
        }
        return;
      }
      if (code2 === 124) {
        if (next === 62) {
          this.finishOp(39, 2);
          return;
        }
        if (this.hasPlugin("recordAndTuple") && next === 125) {
          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
            throw this.raise(Errors.RecordExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
          }
          this.state.pos += 2;
          this.finishToken(9);
          return;
        }
        if (this.hasPlugin("recordAndTuple") && next === 93) {
          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
            throw this.raise(Errors.TupleExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
          }
          this.state.pos += 2;
          this.finishToken(4);
          return;
        }
      }
      if (next === 61) {
        this.finishOp(30, 2);
        return;
      }
      this.finishOp(code2 === 124 ? 43 : 45, 1);
    }
    readToken_caret() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61 && !this.state.inType) {
        this.finishOp(32, 2);
      } else if (next === 94 && this.hasPlugin(["pipelineOperator", {
        proposal: "hack",
        topicToken: "^^"
      }])) {
        this.finishOp(37, 2);
        const lookaheadCh = this.input.codePointAt(this.state.pos);
        if (lookaheadCh === 94) {
          this.unexpected();
        }
      } else {
        this.finishOp(44, 1);
      }
    }
    readToken_atSign() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 64 && this.hasPlugin(["pipelineOperator", {
        proposal: "hack",
        topicToken: "@@"
      }])) {
        this.finishOp(38, 2);
      } else {
        this.finishOp(26, 1);
      }
    }
    readToken_plus_min(code2) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code2) {
        this.finishOp(34, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(30, 2);
      } else {
        this.finishOp(53, 1);
      }
    }
    readToken_lt() {
      const {
        pos
      } = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 60) {
        if (this.input.charCodeAt(pos + 2) === 61) {
          this.finishOp(30, 3);
          return;
        }
        this.finishOp(51, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(47, 1);
    }
    readToken_gt() {
      const {
        pos
      } = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 62) {
        const size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
        if (this.input.charCodeAt(pos + size) === 61) {
          this.finishOp(30, size + 1);
          return;
        }
        this.finishOp(52, size);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(48, 1);
    }
    readToken_eq_excl(code2) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
        return;
      }
      if (code2 === 61 && next === 62) {
        this.state.pos += 2;
        this.finishToken(19);
        return;
      }
      this.finishOp(code2 === 61 ? 29 : 35, 1);
    }
    readToken_question() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      const next2 = this.input.charCodeAt(this.state.pos + 2);
      if (next === 63) {
        if (next2 === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(40, 2);
        }
      } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
        this.state.pos += 2;
        this.finishToken(18);
      } else {
        ++this.state.pos;
        this.finishToken(17);
      }
    }
    getTokenFromCode(code2) {
      switch (code2) {
        case 46:
          this.readToken_dot();
          return;
        case 40:
          ++this.state.pos;
          this.finishToken(10);
          return;
        case 41:
          ++this.state.pos;
          this.finishToken(11);
          return;
        case 59:
          ++this.state.pos;
          this.finishToken(13);
          return;
        case 44:
          ++this.state.pos;
          this.finishToken(12);
          return;
        case 91:
          if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
              throw this.raise(Errors.TupleExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
            }
            this.state.pos += 2;
            this.finishToken(2);
          } else {
            ++this.state.pos;
            this.finishToken(0);
          }
          return;
        case 93:
          ++this.state.pos;
          this.finishToken(3);
          return;
        case 123:
          if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
              throw this.raise(Errors.RecordExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
            }
            this.state.pos += 2;
            this.finishToken(6);
          } else {
            ++this.state.pos;
            this.finishToken(5);
          }
          return;
        case 125:
          ++this.state.pos;
          this.finishToken(8);
          return;
        case 58:
          if (this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58) {
            this.finishOp(15, 2);
          } else {
            ++this.state.pos;
            this.finishToken(14);
          }
          return;
        case 63:
          this.readToken_question();
          return;
        case 96:
          this.readTemplateToken();
          return;
        case 48: {
          const next = this.input.charCodeAt(this.state.pos + 1);
          if (next === 120 || next === 88) {
            this.readRadixNumber(16);
            return;
          }
          if (next === 111 || next === 79) {
            this.readRadixNumber(8);
            return;
          }
          if (next === 98 || next === 66) {
            this.readRadixNumber(2);
            return;
          }
        }
        case 49:
        case 50:
        case 51:
        case 52:
        case 53:
        case 54:
        case 55:
        case 56:
        case 57:
          this.readNumber(false);
          return;
        case 34:
        case 39:
          this.readString(code2);
          return;
        case 47:
          this.readToken_slash();
          return;
        case 37:
        case 42:
          this.readToken_mult_modulo(code2);
          return;
        case 124:
        case 38:
          this.readToken_pipe_amp(code2);
          return;
        case 94:
          this.readToken_caret();
          return;
        case 43:
        case 45:
          this.readToken_plus_min(code2);
          return;
        case 60:
          this.readToken_lt();
          return;
        case 62:
          this.readToken_gt();
          return;
        case 61:
        case 33:
          this.readToken_eq_excl(code2);
          return;
        case 126:
          this.finishOp(36, 1);
          return;
        case 64:
          this.readToken_atSign();
          return;
        case 35:
          this.readToken_numberSign();
          return;
        case 92:
          this.readWord();
          return;
        default:
          if (isIdentifierStart(code2)) {
            this.readWord(code2);
            return;
          }
      }
      throw this.raise(Errors.InvalidOrUnexpectedToken, this.state.curPosition(), {
        unexpected: String.fromCodePoint(code2)
      });
    }
    finishOp(type, size) {
      const str = this.input.slice(this.state.pos, this.state.pos + size);
      this.state.pos += size;
      this.finishToken(type, str);
    }
    readRegexp() {
      const startLoc = this.state.startLoc;
      const start = this.state.start + 1;
      let escaped, inClass;
      let {
        pos
      } = this.state;
      for (;; ++pos) {
        if (pos >= this.length) {
          throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
        }
        const ch = this.input.charCodeAt(pos);
        if (isNewLine(ch)) {
          throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
        }
        if (escaped) {
          escaped = false;
        } else {
          if (ch === 91) {
            inClass = true;
          } else if (ch === 93 && inClass) {
            inClass = false;
          } else if (ch === 47 && !inClass) {
            break;
          }
          escaped = ch === 92;
        }
      }
      const content = this.input.slice(start, pos);
      ++pos;
      let mods = "";
      const nextPos = () => createPositionWithColumnOffset(startLoc, pos + 2 - start);
      while (pos < this.length) {
        const cp = this.codePointAtPos(pos);
        const char = String.fromCharCode(cp);
        if (VALID_REGEX_FLAGS.has(cp)) {
          if (cp === 118) {
            if (mods.includes("u")) {
              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
            }
          } else if (cp === 117) {
            if (mods.includes("v")) {
              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
            }
          }
          if (mods.includes(char)) {
            this.raise(Errors.DuplicateRegExpFlags, nextPos());
          }
        } else if (isIdentifierChar(cp) || cp === 92) {
          this.raise(Errors.MalformedRegExpFlags, nextPos());
        } else {
          break;
        }
        ++pos;
        mods += char;
      }
      this.state.pos = pos;
      this.finishToken(137, {
        pattern: content,
        flags: mods
      });
    }
    readInt(radix, len, forceLen = false, allowNumSeparator = true) {
      const {
        n,
        pos
      } = readInt(this.input, this.state.pos, this.state.lineStart, this.state.curLine, radix, len, forceLen, allowNumSeparator, this.errorHandlers_readInt, false);
      this.state.pos = pos;
      return n;
    }
    readRadixNumber(radix) {
      const startLoc = this.state.curPosition();
      let isBigInt = false;
      this.state.pos += 2;
      const val2 = this.readInt(radix);
      if (val2 == null) {
        this.raise(Errors.InvalidDigit, createPositionWithColumnOffset(startLoc, 2), {
          radix
        });
      }
      const next = this.input.charCodeAt(this.state.pos);
      if (next === 110) {
        ++this.state.pos;
        isBigInt = true;
      } else if (next === 109) {
        throw this.raise(Errors.InvalidDecimal, startLoc);
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
      }
      if (isBigInt) {
        const str = this.input.slice(startLoc.index, this.state.pos).replace(/[_n]/g, "");
        this.finishToken(135, str);
        return;
      }
      this.finishToken(134, val2);
    }
    readNumber(startsWithDot) {
      const start = this.state.pos;
      const startLoc = this.state.curPosition();
      let isFloat = false;
      let isBigInt = false;
      let hasExponent = false;
      let isOctal = false;
      if (!startsWithDot && this.readInt(10) === null) {
        this.raise(Errors.InvalidNumber, this.state.curPosition());
      }
      const hasLeadingZero = this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
      if (hasLeadingZero) {
        const integer = this.input.slice(start, this.state.pos);
        this.recordStrictModeErrors(Errors.StrictOctalLiteral, startLoc);
        if (!this.state.strict) {
          const underscorePos = integer.indexOf("_");
          if (underscorePos > 0) {
            this.raise(Errors.ZeroDigitNumericSeparator, createPositionWithColumnOffset(startLoc, underscorePos));
          }
        }
        isOctal = hasLeadingZero && !/[89]/.test(integer);
      }
      let next = this.input.charCodeAt(this.state.pos);
      if (next === 46 && !isOctal) {
        ++this.state.pos;
        this.readInt(10);
        isFloat = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if ((next === 69 || next === 101) && !isOctal) {
        next = this.input.charCodeAt(++this.state.pos);
        if (next === 43 || next === 45) {
          ++this.state.pos;
        }
        if (this.readInt(10) === null) {
          this.raise(Errors.InvalidOrMissingExponent, startLoc);
        }
        isFloat = true;
        hasExponent = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if (next === 110) {
        if (isFloat || hasLeadingZero) {
          this.raise(Errors.InvalidBigIntLiteral, startLoc);
        }
        ++this.state.pos;
        isBigInt = true;
      }
      if (next === 109) {
        this.expectPlugin("decimal", this.state.curPosition());
        if (hasExponent || hasLeadingZero) {
          this.raise(Errors.InvalidDecimal, startLoc);
        }
        ++this.state.pos;
        var isDecimal2 = true;
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
      }
      const str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, "");
      if (isBigInt) {
        this.finishToken(135, str);
        return;
      }
      if (isDecimal2) {
        this.finishToken(136, str);
        return;
      }
      const val2 = isOctal ? parseInt(str, 8) : parseFloat(str);
      this.finishToken(134, val2);
    }
    readCodePoint(throwOnInvalid) {
      const {
        code: code2,
        pos
      } = readCodePoint(this.input, this.state.pos, this.state.lineStart, this.state.curLine, throwOnInvalid, this.errorHandlers_readCodePoint);
      this.state.pos = pos;
      return code2;
    }
    readString(quote) {
      const {
        str,
        pos,
        curLine,
        lineStart
      } = readStringContents(quote === 34 ? "double" : "single", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_string);
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      this.finishToken(133, str);
    }
    readTemplateContinuation() {
      if (!this.match(8)) {
        this.unexpected(null, 8);
      }
      this.state.pos--;
      this.readTemplateToken();
    }
    readTemplateToken() {
      const opening = this.input[this.state.pos];
      const {
        str,
        firstInvalidLoc,
        pos,
        curLine,
        lineStart
      } = readStringContents("template", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_template);
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      if (firstInvalidLoc) {
        this.state.firstInvalidTemplateEscapePos = new Position(firstInvalidLoc.curLine, firstInvalidLoc.pos - firstInvalidLoc.lineStart, firstInvalidLoc.pos);
      }
      if (this.input.codePointAt(pos) === 96) {
        this.finishToken(24, firstInvalidLoc ? null : opening + str + "`");
      } else {
        this.state.pos++;
        this.finishToken(25, firstInvalidLoc ? null : opening + str + "${");
      }
    }
    recordStrictModeErrors(toParseError, at) {
      const index = at.index;
      if (this.state.strict && !this.state.strictErrors.has(index)) {
        this.raise(toParseError, at);
      } else {
        this.state.strictErrors.set(index, [toParseError, at]);
      }
    }
    readWord1(firstCode) {
      this.state.containsEsc = false;
      let word = "";
      const start = this.state.pos;
      let chunkStart = this.state.pos;
      if (firstCode !== undefined) {
        this.state.pos += firstCode <= 65535 ? 1 : 2;
      }
      while (this.state.pos < this.length) {
        const ch = this.codePointAtPos(this.state.pos);
        if (isIdentifierChar(ch)) {
          this.state.pos += ch <= 65535 ? 1 : 2;
        } else if (ch === 92) {
          this.state.containsEsc = true;
          word += this.input.slice(chunkStart, this.state.pos);
          const escStart = this.state.curPosition();
          const identifierCheck = this.state.pos === start ? isIdentifierStart : isIdentifierChar;
          if (this.input.charCodeAt(++this.state.pos) !== 117) {
            this.raise(Errors.MissingUnicodeEscape, this.state.curPosition());
            chunkStart = this.state.pos - 1;
            continue;
          }
          ++this.state.pos;
          const esc = this.readCodePoint(true);
          if (esc !== null) {
            if (!identifierCheck(esc)) {
              this.raise(Errors.EscapedCharNotAnIdentifier, escStart);
            }
            word += String.fromCodePoint(esc);
          }
          chunkStart = this.state.pos;
        } else {
          break;
        }
      }
      return word + this.input.slice(chunkStart, this.state.pos);
    }
    readWord(firstCode) {
      const word = this.readWord1(firstCode);
      const type = keywords$1.get(word);
      if (type !== undefined) {
        this.finishToken(type, tokenLabelName(type));
      } else {
        this.finishToken(132, word);
      }
    }
    checkKeywordEscapes() {
      const {
        type
      } = this.state;
      if (tokenIsKeyword(type) && this.state.containsEsc) {
        this.raise(Errors.InvalidEscapedReservedWord, this.state.startLoc, {
          reservedWord: tokenLabelName(type)
        });
      }
    }
    raise(toParseError, at, details = {}) {
      const loc = at instanceof Position ? at : at.loc.start;
      const error = toParseError(loc, details);
      if (!this.options.errorRecovery)
        throw error;
      if (!this.isLookahead)
        this.state.errors.push(error);
      return error;
    }
    raiseOverwrite(toParseError, at, details = {}) {
      const loc = at instanceof Position ? at : at.loc.start;
      const pos = loc.index;
      const errors3 = this.state.errors;
      for (let i = errors3.length - 1;i >= 0; i--) {
        const error = errors3[i];
        if (error.loc.index === pos) {
          return errors3[i] = toParseError(loc, details);
        }
        if (error.loc.index < pos)
          break;
      }
      return this.raise(toParseError, at, details);
    }
    updateContext(prevType) {
    }
    unexpected(loc, type) {
      throw this.raise(Errors.UnexpectedToken, loc != null ? loc : this.state.startLoc, {
        expected: type ? tokenLabelName(type) : null
      });
    }
    expectPlugin(pluginName, loc) {
      if (this.hasPlugin(pluginName)) {
        return true;
      }
      throw this.raise(Errors.MissingPlugin, loc != null ? loc : this.state.startLoc, {
        missingPlugin: [pluginName]
      });
    }
    expectOnePlugin(pluginNames) {
      if (!pluginNames.some((name) => this.hasPlugin(name))) {
        throw this.raise(Errors.MissingOneOfPlugins, this.state.startLoc, {
          missingPlugin: pluginNames
        });
      }
    }
    errorBuilder(error) {
      return (pos, lineStart, curLine) => {
        this.raise(error, buildPosition(pos, lineStart, curLine));
      };
    }
  }

  class ClassScope {
    constructor() {
      this.privateNames = new Set;
      this.loneAccessors = new Map;
      this.undefinedPrivateNames = new Map;
    }
  }

  class ClassScopeHandler {
    constructor(parser) {
      this.parser = undefined;
      this.stack = [];
      this.undefinedPrivateNames = new Map;
      this.parser = parser;
    }
    current() {
      return this.stack[this.stack.length - 1];
    }
    enter() {
      this.stack.push(new ClassScope);
    }
    exit() {
      const oldClassScope = this.stack.pop();
      const current = this.current();
      for (const [name, loc] of Array.from(oldClassScope.undefinedPrivateNames)) {
        if (current) {
          if (!current.undefinedPrivateNames.has(name)) {
            current.undefinedPrivateNames.set(name, loc);
          }
        } else {
          this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
            identifierName: name
          });
        }
      }
    }
    declarePrivateName(name, elementType, loc) {
      const {
        privateNames,
        loneAccessors,
        undefinedPrivateNames
      } = this.current();
      let redefined = privateNames.has(name);
      if (elementType & 3) {
        const accessor = redefined && loneAccessors.get(name);
        if (accessor) {
          const oldStatic = accessor & 4;
          const newStatic = elementType & 4;
          const oldKind = accessor & 3;
          const newKind = elementType & 3;
          redefined = oldKind === newKind || oldStatic !== newStatic;
          if (!redefined)
            loneAccessors.delete(name);
        } else if (!redefined) {
          loneAccessors.set(name, elementType);
        }
      }
      if (redefined) {
        this.parser.raise(Errors.PrivateNameRedeclaration, loc, {
          identifierName: name
        });
      }
      privateNames.add(name);
      undefinedPrivateNames.delete(name);
    }
    usePrivateName(name, loc) {
      let classScope;
      for (classScope of this.stack) {
        if (classScope.privateNames.has(name))
          return;
      }
      if (classScope) {
        classScope.undefinedPrivateNames.set(name, loc);
      } else {
        this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
          identifierName: name
        });
      }
    }
  }

  class ExpressionScope {
    constructor(type = 0) {
      this.type = type;
    }
    canBeArrowParameterDeclaration() {
      return this.type === 2 || this.type === 1;
    }
    isCertainlyParameterDeclaration() {
      return this.type === 3;
    }
  }

  class ArrowHeadParsingScope extends ExpressionScope {
    constructor(type) {
      super(type);
      this.declarationErrors = new Map;
    }
    recordDeclarationError(ParsingErrorClass, at) {
      const index = at.index;
      this.declarationErrors.set(index, [ParsingErrorClass, at]);
    }
    clearDeclarationError(index) {
      this.declarationErrors.delete(index);
    }
    iterateErrors(iterator) {
      this.declarationErrors.forEach(iterator);
    }
  }

  class ExpressionScopeHandler {
    constructor(parser) {
      this.parser = undefined;
      this.stack = [new ExpressionScope];
      this.parser = parser;
    }
    enter(scope) {
      this.stack.push(scope);
    }
    exit() {
      this.stack.pop();
    }
    recordParameterInitializerError(toParseError, node) {
      const origin = node.loc.start;
      const {
        stack
      } = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (!scope.isCertainlyParameterDeclaration()) {
        if (scope.canBeArrowParameterDeclaration()) {
          scope.recordDeclarationError(toParseError, origin);
        } else {
          return;
        }
        scope = stack[--i];
      }
      this.parser.raise(toParseError, origin);
    }
    recordArrowParameterBindingError(error, node) {
      const {
        stack
      } = this;
      const scope = stack[stack.length - 1];
      const origin = node.loc.start;
      if (scope.isCertainlyParameterDeclaration()) {
        this.parser.raise(error, origin);
      } else if (scope.canBeArrowParameterDeclaration()) {
        scope.recordDeclarationError(error, origin);
      } else {
        return;
      }
    }
    recordAsyncArrowParametersError(at) {
      const {
        stack
      } = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (scope.canBeArrowParameterDeclaration()) {
        if (scope.type === 2) {
          scope.recordDeclarationError(Errors.AwaitBindingIdentifier, at);
        }
        scope = stack[--i];
      }
    }
    validateAsPattern() {
      const {
        stack
      } = this;
      const currentScope = stack[stack.length - 1];
      if (!currentScope.canBeArrowParameterDeclaration())
        return;
      currentScope.iterateErrors(([toParseError, loc]) => {
        this.parser.raise(toParseError, loc);
        let i = stack.length - 2;
        let scope = stack[i];
        while (scope.canBeArrowParameterDeclaration()) {
          scope.clearDeclarationError(loc.index);
          scope = stack[--i];
        }
      });
    }
  }
  function newParameterDeclarationScope() {
    return new ExpressionScope(3);
  }
  function newArrowHeadScope() {
    return new ArrowHeadParsingScope(1);
  }
  function newAsyncArrowScope() {
    return new ArrowHeadParsingScope(2);
  }
  function newExpressionScope() {
    return new ExpressionScope;
  }

  class ProductionParameterHandler {
    constructor() {
      this.stacks = [];
    }
    enter(flags) {
      this.stacks.push(flags);
    }
    exit() {
      this.stacks.pop();
    }
    currentFlags() {
      return this.stacks[this.stacks.length - 1];
    }
    get hasAwait() {
      return (this.currentFlags() & 2) > 0;
    }
    get hasYield() {
      return (this.currentFlags() & 1) > 0;
    }
    get hasReturn() {
      return (this.currentFlags() & 4) > 0;
    }
    get hasIn() {
      return (this.currentFlags() & 8) > 0;
    }
  }
  function functionFlags(isAsync, isGenerator) {
    return (isAsync ? 2 : 0) | (isGenerator ? 1 : 0);
  }

  class UtilParser extends Tokenizer {
    addExtra(node, key, value, enumerable = true) {
      if (!node)
        return;
      let {
        extra
      } = node;
      if (extra == null) {
        extra = {};
        node.extra = extra;
      }
      if (enumerable) {
        extra[key] = value;
      } else {
        Object.defineProperty(extra, key, {
          enumerable,
          value
        });
      }
    }
    isContextual(token) {
      return this.state.type === token && !this.state.containsEsc;
    }
    isUnparsedContextual(nameStart, name) {
      const nameEnd = nameStart + name.length;
      if (this.input.slice(nameStart, nameEnd) === name) {
        const nextCh = this.input.charCodeAt(nameEnd);
        return !(isIdentifierChar(nextCh) || (nextCh & 64512) === 55296);
      }
      return false;
    }
    isLookaheadContextual(name) {
      const next = this.nextTokenStart();
      return this.isUnparsedContextual(next, name);
    }
    eatContextual(token) {
      if (this.isContextual(token)) {
        this.next();
        return true;
      }
      return false;
    }
    expectContextual(token, toParseError) {
      if (!this.eatContextual(token)) {
        if (toParseError != null) {
          throw this.raise(toParseError, this.state.startLoc);
        }
        this.unexpected(null, token);
      }
    }
    canInsertSemicolon() {
      return this.match(139) || this.match(8) || this.hasPrecedingLineBreak();
    }
    hasPrecedingLineBreak() {
      return hasNewLine(this.input, this.state.lastTokEndLoc.index, this.state.start);
    }
    hasFollowingLineBreak() {
      return hasNewLine(this.input, this.state.end, this.nextTokenStart());
    }
    isLineTerminator() {
      return this.eat(13) || this.canInsertSemicolon();
    }
    semicolon(allowAsi = true) {
      if (allowAsi ? this.isLineTerminator() : this.eat(13))
        return;
      this.raise(Errors.MissingSemicolon, this.state.lastTokEndLoc);
    }
    expect(type, loc) {
      if (!this.eat(type)) {
        this.unexpected(loc, type);
      }
    }
    tryParse(fn, oldState = this.state.clone()) {
      const abortSignal = {
        node: null
      };
      try {
        const node = fn((node2 = null) => {
          abortSignal.node = node2;
          throw abortSignal;
        });
        if (this.state.errors.length > oldState.errors.length) {
          const failState = this.state;
          this.state = oldState;
          this.state.tokensLength = failState.tokensLength;
          return {
            node,
            error: failState.errors[oldState.errors.length],
            thrown: false,
            aborted: false,
            failState
          };
        }
        return {
          node,
          error: null,
          thrown: false,
          aborted: false,
          failState: null
        };
      } catch (error) {
        const failState = this.state;
        this.state = oldState;
        if (error instanceof SyntaxError) {
          return {
            node: null,
            error,
            thrown: true,
            aborted: false,
            failState
          };
        }
        if (error === abortSignal) {
          return {
            node: abortSignal.node,
            error: null,
            thrown: false,
            aborted: true,
            failState
          };
        }
        throw error;
      }
    }
    checkExpressionErrors(refExpressionErrors, andThrow) {
      if (!refExpressionErrors)
        return false;
      const {
        shorthandAssignLoc,
        doubleProtoLoc,
        privateKeyLoc,
        optionalParametersLoc
      } = refExpressionErrors;
      const hasErrors = !!shorthandAssignLoc || !!doubleProtoLoc || !!optionalParametersLoc || !!privateKeyLoc;
      if (!andThrow) {
        return hasErrors;
      }
      if (shorthandAssignLoc != null) {
        this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
      }
      if (doubleProtoLoc != null) {
        this.raise(Errors.DuplicateProto, doubleProtoLoc);
      }
      if (privateKeyLoc != null) {
        this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
      }
      if (optionalParametersLoc != null) {
        this.unexpected(optionalParametersLoc);
      }
    }
    isLiteralPropertyName() {
      return tokenIsLiteralPropertyName(this.state.type);
    }
    isPrivateName(node) {
      return node.type === "PrivateName";
    }
    getPrivateNameSV(node) {
      return node.id.name;
    }
    hasPropertyAsPrivateName(node) {
      return (node.type === "MemberExpression" || node.type === "OptionalMemberExpression") && this.isPrivateName(node.property);
    }
    isObjectProperty(node) {
      return node.type === "ObjectProperty";
    }
    isObjectMethod(node) {
      return node.type === "ObjectMethod";
    }
    initializeScopes(inModule = this.options.sourceType === "module") {
      const oldLabels = this.state.labels;
      this.state.labels = [];
      const oldExportedIdentifiers = this.exportedIdentifiers;
      this.exportedIdentifiers = new Set;
      const oldInModule = this.inModule;
      this.inModule = inModule;
      const oldScope = this.scope;
      const ScopeHandler2 = this.getScopeHandler();
      this.scope = new ScopeHandler2(this, inModule);
      const oldProdParam = this.prodParam;
      this.prodParam = new ProductionParameterHandler;
      const oldClassScope = this.classScope;
      this.classScope = new ClassScopeHandler(this);
      const oldExpressionScope = this.expressionScope;
      this.expressionScope = new ExpressionScopeHandler(this);
      return () => {
        this.state.labels = oldLabels;
        this.exportedIdentifiers = oldExportedIdentifiers;
        this.inModule = oldInModule;
        this.scope = oldScope;
        this.prodParam = oldProdParam;
        this.classScope = oldClassScope;
        this.expressionScope = oldExpressionScope;
      };
    }
    enterInitialScopes() {
      let paramFlags = 0;
      if (this.inModule) {
        paramFlags |= 2;
      }
      this.scope.enter(1);
      this.prodParam.enter(paramFlags);
    }
    checkDestructuringPrivate(refExpressionErrors) {
      const {
        privateKeyLoc
      } = refExpressionErrors;
      if (privateKeyLoc !== null) {
        this.expectPlugin("destructuringPrivate", privateKeyLoc);
      }
    }
  }

  class ExpressionErrors {
    constructor() {
      this.shorthandAssignLoc = null;
      this.doubleProtoLoc = null;
      this.privateKeyLoc = null;
      this.optionalParametersLoc = null;
    }
  }

  class Node {
    constructor(parser, pos, loc) {
      this.type = "";
      this.start = pos;
      this.end = 0;
      this.loc = new SourceLocation(loc);
      if (parser != null && parser.options.ranges)
        this.range = [pos, 0];
      if (parser != null && parser.filename)
        this.loc.filename = parser.filename;
    }
  }
  var NodePrototype = Node.prototype;
  {
    NodePrototype.__clone = function() {
      const newNode = new Node(undefined, this.start, this.loc.start);
      const keys = Object.keys(this);
      for (let i = 0, length = keys.length;i < length; i++) {
        const key = keys[i];
        if (key !== "leadingComments" && key !== "trailingComments" && key !== "innerComments") {
          newNode[key] = this[key];
        }
      }
      return newNode;
    };
  }
  function clonePlaceholder(node) {
    return cloneIdentifier(node);
  }
  function cloneIdentifier(node) {
    const {
      type,
      start,
      end,
      loc,
      range,
      extra,
      name
    } = node;
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    cloned.extra = extra;
    cloned.name = name;
    if (type === "Placeholder") {
      cloned.expectedNode = node.expectedNode;
    }
    return cloned;
  }
  function cloneStringLiteral(node) {
    const {
      type,
      start,
      end,
      loc,
      range,
      extra
    } = node;
    if (type === "Placeholder") {
      return clonePlaceholder(node);
    }
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    if (node.raw !== undefined) {
      cloned.raw = node.raw;
    } else {
      cloned.extra = extra;
    }
    cloned.value = node.value;
    return cloned;
  }

  class NodeUtils extends UtilParser {
    startNode() {
      const loc = this.state.startLoc;
      return new Node(this, loc.index, loc);
    }
    startNodeAt(loc) {
      return new Node(this, loc.index, loc);
    }
    startNodeAtNode(type) {
      return this.startNodeAt(type.loc.start);
    }
    finishNode(node, type) {
      return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
    }
    finishNodeAt(node, type, endLoc) {
      node.type = type;
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges)
        node.range[1] = endLoc.index;
      if (this.options.attachComment)
        this.processComment(node);
      return node;
    }
    resetStartLocation(node, startLoc) {
      node.start = startLoc.index;
      node.loc.start = startLoc;
      if (this.options.ranges)
        node.range[0] = startLoc.index;
    }
    resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges)
        node.range[1] = endLoc.index;
    }
    resetStartLocationFromNode(node, locationNode) {
      this.resetStartLocation(node, locationNode.loc.start);
    }
  }
  var reservedTypes = new Set(["_", "any", "bool", "boolean", "empty", "extends", "false", "interface", "mixed", "null", "number", "static", "string", "true", "typeof", "void"]);
  var FlowErrors = ParseErrorEnum`flow`({
    AmbiguousConditionalArrow: "Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.",
    AmbiguousDeclareModuleKind: "Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.",
    AssignReservedType: ({
      reservedType
    }) => `Cannot overwrite reserved type ${reservedType}.`,
    DeclareClassElement: "The `declare` modifier can only appear on class fields.",
    DeclareClassFieldInitializer: "Initializers are not allowed in fields with the `declare` modifier.",
    DuplicateDeclareModuleExports: "Duplicate `declare module.exports` statement.",
    EnumBooleanMemberNotInitialized: ({
      memberName,
      enumName
    }) => `Boolean enum members need to be initialized. Use either \`${memberName} = true,\` or \`${memberName} = false,\` in enum \`${enumName}\`.`,
    EnumDuplicateMemberName: ({
      memberName,
      enumName
    }) => `Enum member names need to be unique, but the name \`${memberName}\` has already been used before in enum \`${enumName}\`.`,
    EnumInconsistentMemberValues: ({
      enumName
    }) => `Enum \`${enumName}\` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.`,
    EnumInvalidExplicitType: ({
      invalidEnumType,
      enumName
    }) => `Enum type \`${invalidEnumType}\` is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidExplicitTypeUnknownSupplied: ({
      enumName
    }) => `Supplied enum type is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerPrimaryType: ({
      enumName,
      memberName,
      explicitType
    }) => `Enum \`${enumName}\` has type \`${explicitType}\`, so the initializer of \`${memberName}\` needs to be a ${explicitType} literal.`,
    EnumInvalidMemberInitializerSymbolType: ({
      enumName,
      memberName
    }) => `Symbol enum members cannot be initialized. Use \`${memberName},\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerUnknownType: ({
      enumName,
      memberName
    }) => `The enum member initializer for \`${memberName}\` needs to be a literal (either a boolean, number, or string) in enum \`${enumName}\`.`,
    EnumInvalidMemberName: ({
      enumName,
      memberName,
      suggestion
    }) => `Enum member names cannot start with lowercase 'a' through 'z'. Instead of using \`${memberName}\`, consider using \`${suggestion}\`, in enum \`${enumName}\`.`,
    EnumNumberMemberNotInitialized: ({
      enumName,
      memberName
    }) => `Number enum members need to be initialized, e.g. \`${memberName} = 1\` in enum \`${enumName}\`.`,
    EnumStringMemberInconsistentlyInitialized: ({
      enumName
    }) => `String enum members need to consistently either all use initializers, or use no initializers, in enum \`${enumName}\`.`,
    GetterMayNotHaveThisParam: "A getter cannot have a `this` parameter.",
    ImportReflectionHasImportType: "An `import module` declaration can not use `type` or `typeof` keyword.",
    ImportTypeShorthandOnlyInPureImport: "The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.",
    InexactInsideExact: "Explicit inexact syntax cannot appear inside an explicit exact object type.",
    InexactInsideNonObject: "Explicit inexact syntax cannot appear in class or interface definitions.",
    InexactVariance: "Explicit inexact syntax cannot have variance.",
    InvalidNonTypeImportInDeclareModule: "Imports within a `declare module` body must always be `import type` or `import typeof`.",
    MissingTypeParamDefault: "Type parameter declaration needs a default, since a preceding type parameter declaration has a default.",
    NestedDeclareModule: "`declare module` cannot be used inside another `declare module`.",
    NestedFlowComment: "Cannot have a flow comment inside another flow comment.",
    PatternIsOptional: Object.assign({
      message: "A binding pattern parameter cannot be optional in an implementation signature."
    }, {
      reasonCode: "OptionalBindingPattern"
    }),
    SetterMayNotHaveThisParam: "A setter cannot have a `this` parameter.",
    SpreadVariance: "Spread properties cannot have variance.",
    ThisParamAnnotationRequired: "A type annotation is required for the `this` parameter.",
    ThisParamBannedInConstructor: "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
    ThisParamMayNotBeOptional: "The `this` parameter cannot be optional.",
    ThisParamMustBeFirst: "The `this` parameter must be the first function parameter.",
    ThisParamNoDefault: "The `this` parameter may not have a default value.",
    TypeBeforeInitializer: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
    TypeCastInPattern: "The type cast expression is expected to be wrapped with parenthesis.",
    UnexpectedExplicitInexactInObject: "Explicit inexact syntax must appear at the end of an inexact object.",
    UnexpectedReservedType: ({
      reservedType
    }) => `Unexpected reserved type ${reservedType}.`,
    UnexpectedReservedUnderscore: "`_` is only allowed as a type argument to call or new.",
    UnexpectedSpaceBetweenModuloChecks: "Spaces between `%` and `checks` are not allowed here.",
    UnexpectedSpreadType: "Spread operator cannot appear in class or interface definitions.",
    UnexpectedSubtractionOperand: 'Unexpected token, expected "number" or "bigint".',
    UnexpectedTokenAfterTypeParameter: "Expected an arrow function after this type parameter declaration.",
    UnexpectedTypeParameterBeforeAsyncArrowFunction: "Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.",
    UnsupportedDeclareExportKind: ({
      unsupportedExportKind,
      suggestion
    }) => `\`declare export ${unsupportedExportKind}\` is not supported. Use \`${suggestion}\` instead.`,
    UnsupportedStatementInDeclareModule: "Only declares and type imports are allowed inside declare module.",
    UnterminatedFlowComment: "Unterminated flow-comment."
  });
  function isEsModuleType(bodyElement) {
    return bodyElement.type === "DeclareExportAllDeclaration" || bodyElement.type === "DeclareExportDeclaration" && (!bodyElement.declaration || bodyElement.declaration.type !== "TypeAlias" && bodyElement.declaration.type !== "InterfaceDeclaration");
  }
  function hasTypeImportKind(node) {
    return node.importKind === "type" || node.importKind === "typeof";
  }
  var exportSuggestions = {
    const: "declare export var",
    let: "declare export var",
    type: "export type",
    interface: "export interface"
  };
  function partition(list, test) {
    const list1 = [];
    const list2 = [];
    for (let i = 0;i < list.length; i++) {
      (test(list[i], i, list) ? list1 : list2).push(list[i]);
    }
    return [list1, list2];
  }
  var FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
  var flow = (superClass) => class FlowParserMixin extends superClass {
    constructor(...args) {
      super(...args);
      this.flowPragma = undefined;
    }
    getScopeHandler() {
      return FlowScopeHandler;
    }
    shouldParseTypes() {
      return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
    }
    finishToken(type, val2) {
      if (type !== 133 && type !== 13 && type !== 28) {
        if (this.flowPragma === undefined) {
          this.flowPragma = null;
        }
      }
      super.finishToken(type, val2);
    }
    addComment(comment) {
      if (this.flowPragma === undefined) {
        const matches = FLOW_PRAGMA_REGEX.exec(comment.value);
        if (!matches)
          ;
        else if (matches[1] === "flow") {
          this.flowPragma = "flow";
        } else if (matches[1] === "noflow") {
          this.flowPragma = "noflow";
        } else {
          throw new Error("Unexpected flow pragma");
        }
      }
      super.addComment(comment);
    }
    flowParseTypeInitialiser(tok) {
      const oldInType = this.state.inType;
      this.state.inType = true;
      this.expect(tok || 14);
      const type = this.flowParseType();
      this.state.inType = oldInType;
      return type;
    }
    flowParsePredicate() {
      const node = this.startNode();
      const moduloLoc = this.state.startLoc;
      this.next();
      this.expectContextual(110);
      if (this.state.lastTokStartLoc.index > moduloLoc.index + 1) {
        this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, moduloLoc);
      }
      if (this.eat(10)) {
        node.value = super.parseExpression();
        this.expect(11);
        return this.finishNode(node, "DeclaredPredicate");
      } else {
        return this.finishNode(node, "InferredPredicate");
      }
    }
    flowParseTypeAndPredicateInitialiser() {
      const oldInType = this.state.inType;
      this.state.inType = true;
      this.expect(14);
      let type = null;
      let predicate = null;
      if (this.match(54)) {
        this.state.inType = oldInType;
        predicate = this.flowParsePredicate();
      } else {
        type = this.flowParseType();
        this.state.inType = oldInType;
        if (this.match(54)) {
          predicate = this.flowParsePredicate();
        }
      }
      return [type, predicate];
    }
    flowParseDeclareClass(node) {
      this.next();
      this.flowParseInterfaceish(node, true);
      return this.finishNode(node, "DeclareClass");
    }
    flowParseDeclareFunction(node) {
      this.next();
      const id = node.id = this.parseIdentifier();
      const typeNode = this.startNode();
      const typeContainer = this.startNode();
      if (this.match(47)) {
        typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        typeNode.typeParameters = null;
      }
      this.expect(10);
      const tmp = this.flowParseFunctionTypeParams();
      typeNode.params = tmp.params;
      typeNode.rest = tmp.rest;
      typeNode.this = tmp._this;
      this.expect(11);
      [typeNode.returnType, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
      typeContainer.typeAnnotation = this.finishNode(typeNode, "FunctionTypeAnnotation");
      id.typeAnnotation = this.finishNode(typeContainer, "TypeAnnotation");
      this.resetEndLocation(id);
      this.semicolon();
      this.scope.declareName(node.id.name, 2048, node.id.loc.start);
      return this.finishNode(node, "DeclareFunction");
    }
    flowParseDeclare(node, insideModule) {
      if (this.match(80)) {
        return this.flowParseDeclareClass(node);
      } else if (this.match(68)) {
        return this.flowParseDeclareFunction(node);
      } else if (this.match(74)) {
        return this.flowParseDeclareVariable(node);
      } else if (this.eatContextual(127)) {
        if (this.match(16)) {
          return this.flowParseDeclareModuleExports(node);
        } else {
          if (insideModule) {
            this.raise(FlowErrors.NestedDeclareModule, this.state.lastTokStartLoc);
          }
          return this.flowParseDeclareModule(node);
        }
      } else if (this.isContextual(130)) {
        return this.flowParseDeclareTypeAlias(node);
      } else if (this.isContextual(131)) {
        return this.flowParseDeclareOpaqueType(node);
      } else if (this.isContextual(129)) {
        return this.flowParseDeclareInterface(node);
      } else if (this.match(82)) {
        return this.flowParseDeclareExportDeclaration(node, insideModule);
      } else {
        this.unexpected();
      }
    }
    flowParseDeclareVariable(node) {
      this.next();
      node.id = this.flowParseTypeAnnotatableIdentifier(true);
      this.scope.declareName(node.id.name, 5, node.id.loc.start);
      this.semicolon();
      return this.finishNode(node, "DeclareVariable");
    }
    flowParseDeclareModule(node) {
      this.scope.enter(0);
      if (this.match(133)) {
        node.id = super.parseExprAtom();
      } else {
        node.id = this.parseIdentifier();
      }
      const bodyNode = node.body = this.startNode();
      const body = bodyNode.body = [];
      this.expect(5);
      while (!this.match(8)) {
        let bodyNode2 = this.startNode();
        if (this.match(83)) {
          this.next();
          if (!this.isContextual(130) && !this.match(87)) {
            this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, this.state.lastTokStartLoc);
          }
          super.parseImport(bodyNode2);
        } else {
          this.expectContextual(125, FlowErrors.UnsupportedStatementInDeclareModule);
          bodyNode2 = this.flowParseDeclare(bodyNode2, true);
        }
        body.push(bodyNode2);
      }
      this.scope.exit();
      this.expect(8);
      this.finishNode(bodyNode, "BlockStatement");
      let kind = null;
      let hasModuleExport = false;
      body.forEach((bodyElement) => {
        if (isEsModuleType(bodyElement)) {
          if (kind === "CommonJS") {
            this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
          }
          kind = "ES";
        } else if (bodyElement.type === "DeclareModuleExports") {
          if (hasModuleExport) {
            this.raise(FlowErrors.DuplicateDeclareModuleExports, bodyElement);
          }
          if (kind === "ES") {
            this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
          }
          kind = "CommonJS";
          hasModuleExport = true;
        }
      });
      node.kind = kind || "CommonJS";
      return this.finishNode(node, "DeclareModule");
    }
    flowParseDeclareExportDeclaration(node, insideModule) {
      this.expect(82);
      if (this.eat(65)) {
        if (this.match(68) || this.match(80)) {
          node.declaration = this.flowParseDeclare(this.startNode());
        } else {
          node.declaration = this.flowParseType();
          this.semicolon();
        }
        node.default = true;
        return this.finishNode(node, "DeclareExportDeclaration");
      } else {
        if (this.match(75) || this.isLet() || (this.isContextual(130) || this.isContextual(129)) && !insideModule) {
          const label = this.state.value;
          throw this.raise(FlowErrors.UnsupportedDeclareExportKind, this.state.startLoc, {
            unsupportedExportKind: label,
            suggestion: exportSuggestions[label]
          });
        }
        if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(131)) {
          node.declaration = this.flowParseDeclare(this.startNode());
          node.default = false;
          return this.finishNode(node, "DeclareExportDeclaration");
        } else if (this.match(55) || this.match(5) || this.isContextual(129) || this.isContextual(130) || this.isContextual(131)) {
          node = this.parseExport(node, null);
          if (node.type === "ExportNamedDeclaration") {
            node.type = "ExportDeclaration";
            node.default = false;
            delete node.exportKind;
          }
          node.type = "Declare" + node.type;
          return node;
        }
      }
      this.unexpected();
    }
    flowParseDeclareModuleExports(node) {
      this.next();
      this.expectContextual(111);
      node.typeAnnotation = this.flowParseTypeAnnotation();
      this.semicolon();
      return this.finishNode(node, "DeclareModuleExports");
    }
    flowParseDeclareTypeAlias(node) {
      this.next();
      const finished = this.flowParseTypeAlias(node);
      finished.type = "DeclareTypeAlias";
      return finished;
    }
    flowParseDeclareOpaqueType(node) {
      this.next();
      const finished = this.flowParseOpaqueType(node, true);
      finished.type = "DeclareOpaqueType";
      return finished;
    }
    flowParseDeclareInterface(node) {
      this.next();
      this.flowParseInterfaceish(node, false);
      return this.finishNode(node, "DeclareInterface");
    }
    flowParseInterfaceish(node, isClass) {
      node.id = this.flowParseRestrictedIdentifier(!isClass, true);
      this.scope.declareName(node.id.name, isClass ? 17 : 8201, node.id.loc.start);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        node.typeParameters = null;
      }
      node.extends = [];
      if (this.eat(81)) {
        do {
          node.extends.push(this.flowParseInterfaceExtends());
        } while (!isClass && this.eat(12));
      }
      if (isClass) {
        node.implements = [];
        node.mixins = [];
        if (this.eatContextual(117)) {
          do {
            node.mixins.push(this.flowParseInterfaceExtends());
          } while (this.eat(12));
        }
        if (this.eatContextual(113)) {
          do {
            node.implements.push(this.flowParseInterfaceExtends());
          } while (this.eat(12));
        }
      }
      node.body = this.flowParseObjectType({
        allowStatic: isClass,
        allowExact: false,
        allowSpread: false,
        allowProto: isClass,
        allowInexact: false
      });
    }
    flowParseInterfaceExtends() {
      const node = this.startNode();
      node.id = this.flowParseQualifiedTypeIdentifier();
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterInstantiation();
      } else {
        node.typeParameters = null;
      }
      return this.finishNode(node, "InterfaceExtends");
    }
    flowParseInterface(node) {
      this.flowParseInterfaceish(node, false);
      return this.finishNode(node, "InterfaceDeclaration");
    }
    checkNotUnderscore(word) {
      if (word === "_") {
        this.raise(FlowErrors.UnexpectedReservedUnderscore, this.state.startLoc);
      }
    }
    checkReservedType(word, startLoc, declaration) {
      if (!reservedTypes.has(word))
        return;
      this.raise(declaration ? FlowErrors.AssignReservedType : FlowErrors.UnexpectedReservedType, startLoc, {
        reservedType: word
      });
    }
    flowParseRestrictedIdentifier(liberal, declaration) {
      this.checkReservedType(this.state.value, this.state.startLoc, declaration);
      return this.parseIdentifier(liberal);
    }
    flowParseTypeAlias(node) {
      node.id = this.flowParseRestrictedIdentifier(false, true);
      this.scope.declareName(node.id.name, 8201, node.id.loc.start);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        node.typeParameters = null;
      }
      node.right = this.flowParseTypeInitialiser(29);
      this.semicolon();
      return this.finishNode(node, "TypeAlias");
    }
    flowParseOpaqueType(node, declare) {
      this.expectContextual(130);
      node.id = this.flowParseRestrictedIdentifier(true, true);
      this.scope.declareName(node.id.name, 8201, node.id.loc.start);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        node.typeParameters = null;
      }
      node.supertype = null;
      if (this.match(14)) {
        node.supertype = this.flowParseTypeInitialiser(14);
      }
      node.impltype = null;
      if (!declare) {
        node.impltype = this.flowParseTypeInitialiser(29);
      }
      this.semicolon();
      return this.finishNode(node, "OpaqueType");
    }
    flowParseTypeParameter(requireDefault = false) {
      const nodeStartLoc = this.state.startLoc;
      const node = this.startNode();
      const variance = this.flowParseVariance();
      const ident = this.flowParseTypeAnnotatableIdentifier();
      node.name = ident.name;
      node.variance = variance;
      node.bound = ident.typeAnnotation;
      if (this.match(29)) {
        this.eat(29);
        node.default = this.flowParseType();
      } else {
        if (requireDefault) {
          this.raise(FlowErrors.MissingTypeParamDefault, nodeStartLoc);
        }
      }
      return this.finishNode(node, "TypeParameter");
    }
    flowParseTypeParameterDeclaration() {
      const oldInType = this.state.inType;
      const node = this.startNode();
      node.params = [];
      this.state.inType = true;
      if (this.match(47) || this.match(142)) {
        this.next();
      } else {
        this.unexpected();
      }
      let defaultRequired = false;
      do {
        const typeParameter = this.flowParseTypeParameter(defaultRequired);
        node.params.push(typeParameter);
        if (typeParameter.default) {
          defaultRequired = true;
        }
        if (!this.match(48)) {
          this.expect(12);
        }
      } while (!this.match(48));
      this.expect(48);
      this.state.inType = oldInType;
      return this.finishNode(node, "TypeParameterDeclaration");
    }
    flowParseTypeParameterInstantiation() {
      const node = this.startNode();
      const oldInType = this.state.inType;
      node.params = [];
      this.state.inType = true;
      this.expect(47);
      const oldNoAnonFunctionType = this.state.noAnonFunctionType;
      this.state.noAnonFunctionType = false;
      while (!this.match(48)) {
        node.params.push(this.flowParseType());
        if (!this.match(48)) {
          this.expect(12);
        }
      }
      this.state.noAnonFunctionType = oldNoAnonFunctionType;
      this.expect(48);
      this.state.inType = oldInType;
      return this.finishNode(node, "TypeParameterInstantiation");
    }
    flowParseTypeParameterInstantiationCallOrNew() {
      const node = this.startNode();
      const oldInType = this.state.inType;
      node.params = [];
      this.state.inType = true;
      this.expect(47);
      while (!this.match(48)) {
        node.params.push(this.flowParseTypeOrImplicitInstantiation());
        if (!this.match(48)) {
          this.expect(12);
        }
      }
      this.expect(48);
      this.state.inType = oldInType;
      return this.finishNode(node, "TypeParameterInstantiation");
    }
    flowParseInterfaceType() {
      const node = this.startNode();
      this.expectContextual(129);
      node.extends = [];
      if (this.eat(81)) {
        do {
          node.extends.push(this.flowParseInterfaceExtends());
        } while (this.eat(12));
      }
      node.body = this.flowParseObjectType({
        allowStatic: false,
        allowExact: false,
        allowSpread: false,
        allowProto: false,
        allowInexact: false
      });
      return this.finishNode(node, "InterfaceTypeAnnotation");
    }
    flowParseObjectPropertyKey() {
      return this.match(134) || this.match(133) ? super.parseExprAtom() : this.parseIdentifier(true);
    }
    flowParseObjectTypeIndexer(node, isStatic, variance) {
      node.static = isStatic;
      if (this.lookahead().type === 14) {
        node.id = this.flowParseObjectPropertyKey();
        node.key = this.flowParseTypeInitialiser();
      } else {
        node.id = null;
        node.key = this.flowParseType();
      }
      this.expect(3);
      node.value = this.flowParseTypeInitialiser();
      node.variance = variance;
      return this.finishNode(node, "ObjectTypeIndexer");
    }
    flowParseObjectTypeInternalSlot(node, isStatic) {
      node.static = isStatic;
      node.id = this.flowParseObjectPropertyKey();
      this.expect(3);
      this.expect(3);
      if (this.match(47) || this.match(10)) {
        node.method = true;
        node.optional = false;
        node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
      } else {
        node.method = false;
        if (this.eat(17)) {
          node.optional = true;
        }
        node.value = this.flowParseTypeInitialiser();
      }
      return this.finishNode(node, "ObjectTypeInternalSlot");
    }
    flowParseObjectTypeMethodish(node) {
      node.params = [];
      node.rest = null;
      node.typeParameters = null;
      node.this = null;
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      this.expect(10);
      if (this.match(78)) {
        node.this = this.flowParseFunctionTypeParam(true);
        node.this.name = null;
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      while (!this.match(11) && !this.match(21)) {
        node.params.push(this.flowParseFunctionTypeParam(false));
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      if (this.eat(21)) {
        node.rest = this.flowParseFunctionTypeParam(false);
      }
      this.expect(11);
      node.returnType = this.flowParseTypeInitialiser();
      return this.finishNode(node, "FunctionTypeAnnotation");
    }
    flowParseObjectTypeCallProperty(node, isStatic) {
      const valueNode = this.startNode();
      node.static = isStatic;
      node.value = this.flowParseObjectTypeMethodish(valueNode);
      return this.finishNode(node, "ObjectTypeCallProperty");
    }
    flowParseObjectType({
      allowStatic,
      allowExact,
      allowSpread,
      allowProto,
      allowInexact
    }) {
      const oldInType = this.state.inType;
      this.state.inType = true;
      const nodeStart = this.startNode();
      nodeStart.callProperties = [];
      nodeStart.properties = [];
      nodeStart.indexers = [];
      nodeStart.internalSlots = [];
      let endDelim;
      let exact;
      let inexact = false;
      if (allowExact && this.match(6)) {
        this.expect(6);
        endDelim = 9;
        exact = true;
      } else {
        this.expect(5);
        endDelim = 8;
        exact = false;
      }
      nodeStart.exact = exact;
      while (!this.match(endDelim)) {
        let isStatic = false;
        let protoStartLoc = null;
        let inexactStartLoc = null;
        const node = this.startNode();
        if (allowProto && this.isContextual(118)) {
          const lookahead = this.lookahead();
          if (lookahead.type !== 14 && lookahead.type !== 17) {
            this.next();
            protoStartLoc = this.state.startLoc;
            allowStatic = false;
          }
        }
        if (allowStatic && this.isContextual(106)) {
          const lookahead = this.lookahead();
          if (lookahead.type !== 14 && lookahead.type !== 17) {
            this.next();
            isStatic = true;
          }
        }
        const variance = this.flowParseVariance();
        if (this.eat(0)) {
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (this.eat(0)) {
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            nodeStart.internalSlots.push(this.flowParseObjectTypeInternalSlot(node, isStatic));
          } else {
            nodeStart.indexers.push(this.flowParseObjectTypeIndexer(node, isStatic, variance));
          }
        } else if (this.match(10) || this.match(47)) {
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (variance) {
            this.unexpected(variance.loc.start);
          }
          nodeStart.callProperties.push(this.flowParseObjectTypeCallProperty(node, isStatic));
        } else {
          let kind = "init";
          if (this.isContextual(99) || this.isContextual(104)) {
            const lookahead = this.lookahead();
            if (tokenIsLiteralPropertyName(lookahead.type)) {
              kind = this.state.value;
              this.next();
            }
          }
          const propOrInexact = this.flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact != null ? allowInexact : !exact);
          if (propOrInexact === null) {
            inexact = true;
            inexactStartLoc = this.state.lastTokStartLoc;
          } else {
            nodeStart.properties.push(propOrInexact);
          }
        }
        this.flowObjectTypeSemicolon();
        if (inexactStartLoc && !this.match(8) && !this.match(9)) {
          this.raise(FlowErrors.UnexpectedExplicitInexactInObject, inexactStartLoc);
        }
      }
      this.expect(endDelim);
      if (allowSpread) {
        nodeStart.inexact = inexact;
      }
      const out = this.finishNode(nodeStart, "ObjectTypeAnnotation");
      this.state.inType = oldInType;
      return out;
    }
    flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact) {
      if (this.eat(21)) {
        const isInexactToken = this.match(12) || this.match(13) || this.match(8) || this.match(9);
        if (isInexactToken) {
          if (!allowSpread) {
            this.raise(FlowErrors.InexactInsideNonObject, this.state.lastTokStartLoc);
          } else if (!allowInexact) {
            this.raise(FlowErrors.InexactInsideExact, this.state.lastTokStartLoc);
          }
          if (variance) {
            this.raise(FlowErrors.InexactVariance, variance);
          }
          return null;
        }
        if (!allowSpread) {
          this.raise(FlowErrors.UnexpectedSpreadType, this.state.lastTokStartLoc);
        }
        if (protoStartLoc != null) {
          this.unexpected(protoStartLoc);
        }
        if (variance) {
          this.raise(FlowErrors.SpreadVariance, variance);
        }
        node.argument = this.flowParseType();
        return this.finishNode(node, "ObjectTypeSpreadProperty");
      } else {
        node.key = this.flowParseObjectPropertyKey();
        node.static = isStatic;
        node.proto = protoStartLoc != null;
        node.kind = kind;
        let optional = false;
        if (this.match(47) || this.match(10)) {
          node.method = true;
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (variance) {
            this.unexpected(variance.loc.start);
          }
          node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
          if (kind === "get" || kind === "set") {
            this.flowCheckGetterSetterParams(node);
          }
          if (!allowSpread && node.key.name === "constructor" && node.value.this) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, node.value.this);
          }
        } else {
          if (kind !== "init")
            this.unexpected();
          node.method = false;
          if (this.eat(17)) {
            optional = true;
          }
          node.value = this.flowParseTypeInitialiser();
          node.variance = variance;
        }
        node.optional = optional;
        return this.finishNode(node, "ObjectTypeProperty");
      }
    }
    flowCheckGetterSetterParams(property) {
      const paramCount = property.kind === "get" ? 0 : 1;
      const length = property.value.params.length + (property.value.rest ? 1 : 0);
      if (property.value.this) {
        this.raise(property.kind === "get" ? FlowErrors.GetterMayNotHaveThisParam : FlowErrors.SetterMayNotHaveThisParam, property.value.this);
      }
      if (length !== paramCount) {
        this.raise(property.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, property);
      }
      if (property.kind === "set" && property.value.rest) {
        this.raise(Errors.BadSetterRestParameter, property);
      }
    }
    flowObjectTypeSemicolon() {
      if (!this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9)) {
        this.unexpected();
      }
    }
    flowParseQualifiedTypeIdentifier(startLoc, id) {
      var _startLoc;
      (_startLoc = startLoc) != null || (startLoc = this.state.startLoc);
      let node = id || this.flowParseRestrictedIdentifier(true);
      while (this.eat(16)) {
        const node2 = this.startNodeAt(startLoc);
        node2.qualification = node;
        node2.id = this.flowParseRestrictedIdentifier(true);
        node = this.finishNode(node2, "QualifiedTypeIdentifier");
      }
      return node;
    }
    flowParseGenericType(startLoc, id) {
      const node = this.startNodeAt(startLoc);
      node.typeParameters = null;
      node.id = this.flowParseQualifiedTypeIdentifier(startLoc, id);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterInstantiation();
      }
      return this.finishNode(node, "GenericTypeAnnotation");
    }
    flowParseTypeofType() {
      const node = this.startNode();
      this.expect(87);
      node.argument = this.flowParsePrimaryType();
      return this.finishNode(node, "TypeofTypeAnnotation");
    }
    flowParseTupleType() {
      const node = this.startNode();
      node.types = [];
      this.expect(0);
      while (this.state.pos < this.length && !this.match(3)) {
        node.types.push(this.flowParseType());
        if (this.match(3))
          break;
        this.expect(12);
      }
      this.expect(3);
      return this.finishNode(node, "TupleTypeAnnotation");
    }
    flowParseFunctionTypeParam(first) {
      let name = null;
      let optional = false;
      let typeAnnotation = null;
      const node = this.startNode();
      const lh = this.lookahead();
      const isThis = this.state.type === 78;
      if (lh.type === 14 || lh.type === 17) {
        if (isThis && !first) {
          this.raise(FlowErrors.ThisParamMustBeFirst, node);
        }
        name = this.parseIdentifier(isThis);
        if (this.eat(17)) {
          optional = true;
          if (isThis) {
            this.raise(FlowErrors.ThisParamMayNotBeOptional, node);
          }
        }
        typeAnnotation = this.flowParseTypeInitialiser();
      } else {
        typeAnnotation = this.flowParseType();
      }
      node.name = name;
      node.optional = optional;
      node.typeAnnotation = typeAnnotation;
      return this.finishNode(node, "FunctionTypeParam");
    }
    reinterpretTypeAsFunctionTypeParam(type) {
      const node = this.startNodeAt(type.loc.start);
      node.name = null;
      node.optional = false;
      node.typeAnnotation = type;
      return this.finishNode(node, "FunctionTypeParam");
    }
    flowParseFunctionTypeParams(params = []) {
      let rest = null;
      let _this = null;
      if (this.match(78)) {
        _this = this.flowParseFunctionTypeParam(true);
        _this.name = null;
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      while (!this.match(11) && !this.match(21)) {
        params.push(this.flowParseFunctionTypeParam(false));
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      if (this.eat(21)) {
        rest = this.flowParseFunctionTypeParam(false);
      }
      return {
        params,
        rest,
        _this
      };
    }
    flowIdentToTypeAnnotation(startLoc, node, id) {
      switch (id.name) {
        case "any":
          return this.finishNode(node, "AnyTypeAnnotation");
        case "bool":
        case "boolean":
          return this.finishNode(node, "BooleanTypeAnnotation");
        case "mixed":
          return this.finishNode(node, "MixedTypeAnnotation");
        case "empty":
          return this.finishNode(node, "EmptyTypeAnnotation");
        case "number":
          return this.finishNode(node, "NumberTypeAnnotation");
        case "string":
          return this.finishNode(node, "StringTypeAnnotation");
        case "symbol":
          return this.finishNode(node, "SymbolTypeAnnotation");
        default:
          this.checkNotUnderscore(id.name);
          return this.flowParseGenericType(startLoc, id);
      }
    }
    flowParsePrimaryType() {
      const startLoc = this.state.startLoc;
      const node = this.startNode();
      let tmp;
      let type;
      let isGroupedType = false;
      const oldNoAnonFunctionType = this.state.noAnonFunctionType;
      switch (this.state.type) {
        case 5:
          return this.flowParseObjectType({
            allowStatic: false,
            allowExact: false,
            allowSpread: true,
            allowProto: false,
            allowInexact: true
          });
        case 6:
          return this.flowParseObjectType({
            allowStatic: false,
            allowExact: true,
            allowSpread: true,
            allowProto: false,
            allowInexact: false
          });
        case 0:
          this.state.noAnonFunctionType = false;
          type = this.flowParseTupleType();
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
          return type;
        case 47: {
          const node2 = this.startNode();
          node2.typeParameters = this.flowParseTypeParameterDeclaration();
          this.expect(10);
          tmp = this.flowParseFunctionTypeParams();
          node2.params = tmp.params;
          node2.rest = tmp.rest;
          node2.this = tmp._this;
          this.expect(11);
          this.expect(19);
          node2.returnType = this.flowParseType();
          return this.finishNode(node2, "FunctionTypeAnnotation");
        }
        case 10: {
          const node2 = this.startNode();
          this.next();
          if (!this.match(11) && !this.match(21)) {
            if (tokenIsIdentifier(this.state.type) || this.match(78)) {
              const token = this.lookahead().type;
              isGroupedType = token !== 17 && token !== 14;
            } else {
              isGroupedType = true;
            }
          }
          if (isGroupedType) {
            this.state.noAnonFunctionType = false;
            type = this.flowParseType();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            if (this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19)) {
              this.expect(11);
              return type;
            } else {
              this.eat(12);
            }
          }
          if (type) {
            tmp = this.flowParseFunctionTypeParams([this.reinterpretTypeAsFunctionTypeParam(type)]);
          } else {
            tmp = this.flowParseFunctionTypeParams();
          }
          node2.params = tmp.params;
          node2.rest = tmp.rest;
          node2.this = tmp._this;
          this.expect(11);
          this.expect(19);
          node2.returnType = this.flowParseType();
          node2.typeParameters = null;
          return this.finishNode(node2, "FunctionTypeAnnotation");
        }
        case 133:
          return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");
        case 85:
        case 86:
          node.value = this.match(85);
          this.next();
          return this.finishNode(node, "BooleanLiteralTypeAnnotation");
        case 53:
          if (this.state.value === "-") {
            this.next();
            if (this.match(134)) {
              return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", node);
            }
            if (this.match(135)) {
              return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", node);
            }
            throw this.raise(FlowErrors.UnexpectedSubtractionOperand, this.state.startLoc);
          }
          this.unexpected();
          return;
        case 134:
          return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");
        case 135:
          return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");
        case 88:
          this.next();
          return this.finishNode(node, "VoidTypeAnnotation");
        case 84:
          this.next();
          return this.finishNode(node, "NullLiteralTypeAnnotation");
        case 78:
          this.next();
          return this.finishNode(node, "ThisTypeAnnotation");
        case 55:
          this.next();
          return this.finishNode(node, "ExistsTypeAnnotation");
        case 87:
          return this.flowParseTypeofType();
        default:
          if (tokenIsKeyword(this.state.type)) {
            const label = tokenLabelName(this.state.type);
            this.next();
            return super.createIdentifier(node, label);
          } else if (tokenIsIdentifier(this.state.type)) {
            if (this.isContextual(129)) {
              return this.flowParseInterfaceType();
            }
            return this.flowIdentToTypeAnnotation(startLoc, node, this.parseIdentifier());
          }
      }
      this.unexpected();
    }
    flowParsePostfixType() {
      const startLoc = this.state.startLoc;
      let type = this.flowParsePrimaryType();
      let seenOptionalIndexedAccess = false;
      while ((this.match(0) || this.match(18)) && !this.canInsertSemicolon()) {
        const node = this.startNodeAt(startLoc);
        const optional = this.eat(18);
        seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
        this.expect(0);
        if (!optional && this.match(3)) {
          node.elementType = type;
          this.next();
          type = this.finishNode(node, "ArrayTypeAnnotation");
        } else {
          node.objectType = type;
          node.indexType = this.flowParseType();
          this.expect(3);
          if (seenOptionalIndexedAccess) {
            node.optional = optional;
            type = this.finishNode(node, "OptionalIndexedAccessType");
          } else {
            type = this.finishNode(node, "IndexedAccessType");
          }
        }
      }
      return type;
    }
    flowParsePrefixType() {
      const node = this.startNode();
      if (this.eat(17)) {
        node.typeAnnotation = this.flowParsePrefixType();
        return this.finishNode(node, "NullableTypeAnnotation");
      } else {
        return this.flowParsePostfixType();
      }
    }
    flowParseAnonFunctionWithoutParens() {
      const param = this.flowParsePrefixType();
      if (!this.state.noAnonFunctionType && this.eat(19)) {
        const node = this.startNodeAt(param.loc.start);
        node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
        node.rest = null;
        node.this = null;
        node.returnType = this.flowParseType();
        node.typeParameters = null;
        return this.finishNode(node, "FunctionTypeAnnotation");
      }
      return param;
    }
    flowParseIntersectionType() {
      const node = this.startNode();
      this.eat(45);
      const type = this.flowParseAnonFunctionWithoutParens();
      node.types = [type];
      while (this.eat(45)) {
        node.types.push(this.flowParseAnonFunctionWithoutParens());
      }
      return node.types.length === 1 ? type : this.finishNode(node, "IntersectionTypeAnnotation");
    }
    flowParseUnionType() {
      const node = this.startNode();
      this.eat(43);
      const type = this.flowParseIntersectionType();
      node.types = [type];
      while (this.eat(43)) {
        node.types.push(this.flowParseIntersectionType());
      }
      return node.types.length === 1 ? type : this.finishNode(node, "UnionTypeAnnotation");
    }
    flowParseType() {
      const oldInType = this.state.inType;
      this.state.inType = true;
      const type = this.flowParseUnionType();
      this.state.inType = oldInType;
      return type;
    }
    flowParseTypeOrImplicitInstantiation() {
      if (this.state.type === 132 && this.state.value === "_") {
        const startLoc = this.state.startLoc;
        const node = this.parseIdentifier();
        return this.flowParseGenericType(startLoc, node);
      } else {
        return this.flowParseType();
      }
    }
    flowParseTypeAnnotation() {
      const node = this.startNode();
      node.typeAnnotation = this.flowParseTypeInitialiser();
      return this.finishNode(node, "TypeAnnotation");
    }
    flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
      const ident = allowPrimitiveOverride ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();
      if (this.match(14)) {
        ident.typeAnnotation = this.flowParseTypeAnnotation();
        this.resetEndLocation(ident);
      }
      return ident;
    }
    typeCastToParameter(node) {
      node.expression.typeAnnotation = node.typeAnnotation;
      this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
      return node.expression;
    }
    flowParseVariance() {
      let variance = null;
      if (this.match(53)) {
        variance = this.startNode();
        if (this.state.value === "+") {
          variance.kind = "plus";
        } else {
          variance.kind = "minus";
        }
        this.next();
        return this.finishNode(variance, "Variance");
      }
      return variance;
    }
    parseFunctionBody(node, allowExpressionBody, isMethod = false) {
      if (allowExpressionBody) {
        this.forwardNoArrowParamsConversionAt(node, () => super.parseFunctionBody(node, true, isMethod));
        return;
      }
      super.parseFunctionBody(node, false, isMethod);
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      if (this.match(14)) {
        const typeNode = this.startNode();
        [typeNode.typeAnnotation, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
        node.returnType = typeNode.typeAnnotation ? this.finishNode(typeNode, "TypeAnnotation") : null;
      }
      return super.parseFunctionBodyAndFinish(node, type, isMethod);
    }
    parseStatementLike(flags) {
      if (this.state.strict && this.isContextual(129)) {
        const lookahead = this.lookahead();
        if (tokenIsKeywordOrIdentifier(lookahead.type)) {
          const node = this.startNode();
          this.next();
          return this.flowParseInterface(node);
        }
      } else if (this.plugins.get("flow").enums && this.isContextual(126)) {
        const node = this.startNode();
        this.next();
        return this.flowParseEnumDeclaration(node);
      }
      const stmt = super.parseStatementLike(flags);
      if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
        this.flowPragma = null;
      }
      return stmt;
    }
    parseExpressionStatement(node, expr, decorators) {
      if (expr.type === "Identifier") {
        if (expr.name === "declare") {
          if (this.match(80) || tokenIsIdentifier(this.state.type) || this.match(68) || this.match(74) || this.match(82)) {
            return this.flowParseDeclare(node);
          }
        } else if (tokenIsIdentifier(this.state.type)) {
          if (expr.name === "interface") {
            return this.flowParseInterface(node);
          } else if (expr.name === "type") {
            return this.flowParseTypeAlias(node);
          } else if (expr.name === "opaque") {
            return this.flowParseOpaqueType(node, false);
          }
        }
      }
      return super.parseExpressionStatement(node, expr, decorators);
    }
    shouldParseExportDeclaration() {
      const {
        type
      } = this.state;
      if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.plugins.get("flow").enums && type === 126) {
        return !this.state.containsEsc;
      }
      return super.shouldParseExportDeclaration();
    }
    isExportDefaultSpecifier() {
      const {
        type
      } = this.state;
      if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.plugins.get("flow").enums && type === 126) {
        return this.state.containsEsc;
      }
      return super.isExportDefaultSpecifier();
    }
    parseExportDefaultExpression() {
      if (this.plugins.get("flow").enums && this.isContextual(126)) {
        const node = this.startNode();
        this.next();
        return this.flowParseEnumDeclaration(node);
      }
      return super.parseExportDefaultExpression();
    }
    parseConditional(expr, startLoc, refExpressionErrors) {
      if (!this.match(17))
        return expr;
      if (this.state.maybeInArrowParameters) {
        const nextCh = this.lookaheadCharCode();
        if (nextCh === 44 || nextCh === 61 || nextCh === 58 || nextCh === 41) {
          this.setOptionalParametersError(refExpressionErrors);
          return expr;
        }
      }
      this.expect(17);
      const state = this.state.clone();
      const originalNoArrowAt = this.state.noArrowAt;
      const node = this.startNodeAt(startLoc);
      let {
        consequent,
        failed
      } = this.tryParseConditionalConsequent();
      let [valid, invalid] = this.getArrowLikeExpressions(consequent);
      if (failed || invalid.length > 0) {
        const noArrowAt = [...originalNoArrowAt];
        if (invalid.length > 0) {
          this.state = state;
          this.state.noArrowAt = noArrowAt;
          for (let i = 0;i < invalid.length; i++) {
            noArrowAt.push(invalid[i].start);
          }
          ({
            consequent,
            failed
          } = this.tryParseConditionalConsequent());
          [valid, invalid] = this.getArrowLikeExpressions(consequent);
        }
        if (failed && valid.length > 1) {
          this.raise(FlowErrors.AmbiguousConditionalArrow, state.startLoc);
        }
        if (failed && valid.length === 1) {
          this.state = state;
          noArrowAt.push(valid[0].start);
          this.state.noArrowAt = noArrowAt;
          ({
            consequent,
            failed
          } = this.tryParseConditionalConsequent());
        }
      }
      this.getArrowLikeExpressions(consequent, true);
      this.state.noArrowAt = originalNoArrowAt;
      this.expect(14);
      node.test = expr;
      node.consequent = consequent;
      node.alternate = this.forwardNoArrowParamsConversionAt(node, () => this.parseMaybeAssign(undefined, undefined));
      return this.finishNode(node, "ConditionalExpression");
    }
    tryParseConditionalConsequent() {
      this.state.noArrowParamsConversionAt.push(this.state.start);
      const consequent = this.parseMaybeAssignAllowIn();
      const failed = !this.match(14);
      this.state.noArrowParamsConversionAt.pop();
      return {
        consequent,
        failed
      };
    }
    getArrowLikeExpressions(node, disallowInvalid) {
      const stack = [node];
      const arrows = [];
      while (stack.length !== 0) {
        const node2 = stack.pop();
        if (node2.type === "ArrowFunctionExpression" && node2.body.type !== "BlockStatement") {
          if (node2.typeParameters || !node2.returnType) {
            this.finishArrowValidation(node2);
          } else {
            arrows.push(node2);
          }
          stack.push(node2.body);
        } else if (node2.type === "ConditionalExpression") {
          stack.push(node2.consequent);
          stack.push(node2.alternate);
        }
      }
      if (disallowInvalid) {
        arrows.forEach((node2) => this.finishArrowValidation(node2));
        return [arrows, []];
      }
      return partition(arrows, (node2) => node2.params.every((param) => this.isAssignable(param, true)));
    }
    finishArrowValidation(node) {
      var _node$extra;
      this.toAssignableList(node.params, (_node$extra = node.extra) == null ? undefined : _node$extra.trailingCommaLoc, false);
      this.scope.enter(6);
      super.checkParams(node, false, true);
      this.scope.exit();
    }
    forwardNoArrowParamsConversionAt(node, parse4) {
      let result2;
      if (this.state.noArrowParamsConversionAt.includes(node.start)) {
        this.state.noArrowParamsConversionAt.push(this.state.start);
        result2 = parse4();
        this.state.noArrowParamsConversionAt.pop();
      } else {
        result2 = parse4();
      }
      return result2;
    }
    parseParenItem(node, startLoc) {
      const newNode = super.parseParenItem(node, startLoc);
      if (this.eat(17)) {
        newNode.optional = true;
        this.resetEndLocation(node);
      }
      if (this.match(14)) {
        const typeCastNode = this.startNodeAt(startLoc);
        typeCastNode.expression = newNode;
        typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
        return this.finishNode(typeCastNode, "TypeCastExpression");
      }
      return newNode;
    }
    assertModuleNodeAllowed(node) {
      if (node.type === "ImportDeclaration" && (node.importKind === "type" || node.importKind === "typeof") || node.type === "ExportNamedDeclaration" && node.exportKind === "type" || node.type === "ExportAllDeclaration" && node.exportKind === "type") {
        return;
      }
      super.assertModuleNodeAllowed(node);
    }
    parseExportDeclaration(node) {
      if (this.isContextual(130)) {
        node.exportKind = "type";
        const declarationNode = this.startNode();
        this.next();
        if (this.match(5)) {
          node.specifiers = this.parseExportSpecifiers(true);
          super.parseExportFrom(node);
          return null;
        } else {
          return this.flowParseTypeAlias(declarationNode);
        }
      } else if (this.isContextual(131)) {
        node.exportKind = "type";
        const declarationNode = this.startNode();
        this.next();
        return this.flowParseOpaqueType(declarationNode, false);
      } else if (this.isContextual(129)) {
        node.exportKind = "type";
        const declarationNode = this.startNode();
        this.next();
        return this.flowParseInterface(declarationNode);
      } else if (this.plugins.get("flow").enums && this.isContextual(126)) {
        node.exportKind = "value";
        const declarationNode = this.startNode();
        this.next();
        return this.flowParseEnumDeclaration(declarationNode);
      } else {
        return super.parseExportDeclaration(node);
      }
    }
    eatExportStar(node) {
      if (super.eatExportStar(node))
        return true;
      if (this.isContextual(130) && this.lookahead().type === 55) {
        node.exportKind = "type";
        this.next();
        this.next();
        return true;
      }
      return false;
    }
    maybeParseExportNamespaceSpecifier(node) {
      const {
        startLoc
      } = this.state;
      const hasNamespace = super.maybeParseExportNamespaceSpecifier(node);
      if (hasNamespace && node.exportKind === "type") {
        this.unexpected(startLoc);
      }
      return hasNamespace;
    }
    parseClassId(node, isStatement, optionalId) {
      super.parseClassId(node, isStatement, optionalId);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      }
    }
    parseClassMember(classBody, member, state) {
      const {
        startLoc
      } = this.state;
      if (this.isContextual(125)) {
        if (super.parseClassMemberFromModifier(classBody, member)) {
          return;
        }
        member.declare = true;
      }
      super.parseClassMember(classBody, member, state);
      if (member.declare) {
        if (member.type !== "ClassProperty" && member.type !== "ClassPrivateProperty" && member.type !== "PropertyDefinition") {
          this.raise(FlowErrors.DeclareClassElement, startLoc);
        } else if (member.value) {
          this.raise(FlowErrors.DeclareClassFieldInitializer, member.value);
        }
      }
    }
    isIterator(word) {
      return word === "iterator" || word === "asyncIterator";
    }
    readIterator() {
      const word = super.readWord1();
      const fullWord = "@@" + word;
      if (!this.isIterator(word) || !this.state.inType) {
        this.raise(Errors.InvalidIdentifier, this.state.curPosition(), {
          identifierName: fullWord
        });
      }
      this.finishToken(132, fullWord);
    }
    getTokenFromCode(code2) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (code2 === 123 && next === 124) {
        this.finishOp(6, 2);
      } else if (this.state.inType && (code2 === 62 || code2 === 60)) {
        this.finishOp(code2 === 62 ? 48 : 47, 1);
      } else if (this.state.inType && code2 === 63) {
        if (next === 46) {
          this.finishOp(18, 2);
        } else {
          this.finishOp(17, 1);
        }
      } else if (isIteratorStart(code2, next, this.input.charCodeAt(this.state.pos + 2))) {
        this.state.pos += 2;
        this.readIterator();
      } else {
        super.getTokenFromCode(code2);
      }
    }
    isAssignable(node, isBinding) {
      if (node.type === "TypeCastExpression") {
        return this.isAssignable(node.expression, isBinding);
      } else {
        return super.isAssignable(node, isBinding);
      }
    }
    toAssignable(node, isLHS = false) {
      if (!isLHS && node.type === "AssignmentExpression" && node.left.type === "TypeCastExpression") {
        node.left = this.typeCastToParameter(node.left);
      }
      super.toAssignable(node, isLHS);
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      for (let i = 0;i < exprList.length; i++) {
        const expr = exprList[i];
        if ((expr == null ? undefined : expr.type) === "TypeCastExpression") {
          exprList[i] = this.typeCastToParameter(expr);
        }
      }
      super.toAssignableList(exprList, trailingCommaLoc, isLHS);
    }
    toReferencedList(exprList, isParenthesizedExpr) {
      for (let i = 0;i < exprList.length; i++) {
        var _expr$extra;
        const expr = exprList[i];
        if (expr && expr.type === "TypeCastExpression" && !((_expr$extra = expr.extra) != null && _expr$extra.parenthesized) && (exprList.length > 1 || !isParenthesizedExpr)) {
          this.raise(FlowErrors.TypeCastInPattern, expr.typeAnnotation);
        }
      }
      return exprList;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      const node = super.parseArrayLike(close, canBePattern, isTuple, refExpressionErrors);
      if (canBePattern && !this.state.maybeInArrowParameters) {
        this.toReferencedList(node.elements);
      }
      return node;
    }
    isValidLVal(type, isParenthesized, binding) {
      return type === "TypeCastExpression" || super.isValidLVal(type, isParenthesized, binding);
    }
    parseClassProperty(node) {
      if (this.match(14)) {
        node.typeAnnotation = this.flowParseTypeAnnotation();
      }
      return super.parseClassProperty(node);
    }
    parseClassPrivateProperty(node) {
      if (this.match(14)) {
        node.typeAnnotation = this.flowParseTypeAnnotation();
      }
      return super.parseClassPrivateProperty(node);
    }
    isClassMethod() {
      return this.match(47) || super.isClassMethod();
    }
    isClassProperty() {
      return this.match(14) || super.isClassProperty();
    }
    isNonstaticConstructor(method) {
      return !this.match(14) && super.isNonstaticConstructor(method);
    }
    pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
      if (method.variance) {
        this.unexpected(method.variance.loc.start);
      }
      delete method.variance;
      if (this.match(47)) {
        method.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      super.pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
      if (method.params && isConstructor) {
        const params = method.params;
        if (params.length > 0 && this.isThisParam(params[0])) {
          this.raise(FlowErrors.ThisParamBannedInConstructor, method);
        }
      } else if (method.type === "MethodDefinition" && isConstructor && method.value.params) {
        const params = method.value.params;
        if (params.length > 0 && this.isThisParam(params[0])) {
          this.raise(FlowErrors.ThisParamBannedInConstructor, method);
        }
      }
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      if (method.variance) {
        this.unexpected(method.variance.loc.start);
      }
      delete method.variance;
      if (this.match(47)) {
        method.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
    }
    parseClassSuper(node) {
      super.parseClassSuper(node);
      if (node.superClass && this.match(47)) {
        node.superTypeParameters = this.flowParseTypeParameterInstantiation();
      }
      if (this.isContextual(113)) {
        this.next();
        const implemented = node.implements = [];
        do {
          const node2 = this.startNode();
          node2.id = this.flowParseRestrictedIdentifier(true);
          if (this.match(47)) {
            node2.typeParameters = this.flowParseTypeParameterInstantiation();
          } else {
            node2.typeParameters = null;
          }
          implemented.push(this.finishNode(node2, "ClassImplements"));
        } while (this.eat(12));
      }
    }
    checkGetterSetterParams(method) {
      super.checkGetterSetterParams(method);
      const params = this.getObjectOrClassMethodParams(method);
      if (params.length > 0) {
        const param = params[0];
        if (this.isThisParam(param) && method.kind === "get") {
          this.raise(FlowErrors.GetterMayNotHaveThisParam, param);
        } else if (this.isThisParam(param)) {
          this.raise(FlowErrors.SetterMayNotHaveThisParam, param);
        }
      }
    }
    parsePropertyNamePrefixOperator(node) {
      node.variance = this.flowParseVariance();
    }
    parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
      if (prop.variance) {
        this.unexpected(prop.variance.loc.start);
      }
      delete prop.variance;
      let typeParameters;
      if (this.match(47) && !isAccessor) {
        typeParameters = this.flowParseTypeParameterDeclaration();
        if (!this.match(10))
          this.unexpected();
      }
      const result2 = super.parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors);
      if (typeParameters) {
        (result2.value || result2).typeParameters = typeParameters;
      }
      return result2;
    }
    parseFunctionParamType(param) {
      if (this.eat(17)) {
        if (param.type !== "Identifier") {
          this.raise(FlowErrors.PatternIsOptional, param);
        }
        if (this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamMayNotBeOptional, param);
        }
        param.optional = true;
      }
      if (this.match(14)) {
        param.typeAnnotation = this.flowParseTypeAnnotation();
      } else if (this.isThisParam(param)) {
        this.raise(FlowErrors.ThisParamAnnotationRequired, param);
      }
      if (this.match(29) && this.isThisParam(param)) {
        this.raise(FlowErrors.ThisParamNoDefault, param);
      }
      this.resetEndLocation(param);
      return param;
    }
    parseMaybeDefault(startLoc, left) {
      const node = super.parseMaybeDefault(startLoc, left);
      if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
        this.raise(FlowErrors.TypeBeforeInitializer, node.typeAnnotation);
      }
      return node;
    }
    checkImportReflection(node) {
      super.checkImportReflection(node);
      if (node.module && node.importKind !== "value") {
        this.raise(FlowErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
      }
    }
    parseImportSpecifierLocal(node, specifier, type) {
      specifier.local = hasTypeImportKind(node) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier();
      node.specifiers.push(this.finishImportSpecifier(specifier, type));
    }
    isPotentialImportPhase(isExport) {
      if (super.isPotentialImportPhase(isExport))
        return true;
      if (this.isContextual(130)) {
        if (!isExport)
          return true;
        const ch = this.lookaheadCharCode();
        return ch === 123 || ch === 42;
      }
      return !isExport && this.isContextual(87);
    }
    applyImportPhase(node, isExport, phase, loc) {
      super.applyImportPhase(node, isExport, phase, loc);
      if (isExport) {
        if (!phase && this.match(65)) {
          return;
        }
        node.exportKind = phase === "type" ? phase : "value";
      } else {
        if (phase === "type" && this.match(55))
          this.unexpected();
        node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
      }
    }
    parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
      const firstIdent = specifier.imported;
      let specifierTypeKind = null;
      if (firstIdent.type === "Identifier") {
        if (firstIdent.name === "type") {
          specifierTypeKind = "type";
        } else if (firstIdent.name === "typeof") {
          specifierTypeKind = "typeof";
        }
      }
      let isBinding = false;
      if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
        const as_ident = this.parseIdentifier(true);
        if (specifierTypeKind !== null && !tokenIsKeywordOrIdentifier(this.state.type)) {
          specifier.imported = as_ident;
          specifier.importKind = specifierTypeKind;
          specifier.local = cloneIdentifier(as_ident);
        } else {
          specifier.imported = firstIdent;
          specifier.importKind = null;
          specifier.local = this.parseIdentifier();
        }
      } else {
        if (specifierTypeKind !== null && tokenIsKeywordOrIdentifier(this.state.type)) {
          specifier.imported = this.parseIdentifier(true);
          specifier.importKind = specifierTypeKind;
        } else {
          if (importedIsString) {
            throw this.raise(Errors.ImportBindingIsString, specifier, {
              importName: firstIdent.value
            });
          }
          specifier.imported = firstIdent;
          specifier.importKind = null;
        }
        if (this.eatContextual(93)) {
          specifier.local = this.parseIdentifier();
        } else {
          isBinding = true;
          specifier.local = cloneIdentifier(specifier.imported);
        }
      }
      const specifierIsTypeImport = hasTypeImportKind(specifier);
      if (isInTypeOnlyImport && specifierIsTypeImport) {
        this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, specifier);
      }
      if (isInTypeOnlyImport || specifierIsTypeImport) {
        this.checkReservedType(specifier.local.name, specifier.local.loc.start, true);
      }
      if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
        this.checkReservedWord(specifier.local.name, specifier.loc.start, true, true);
      }
      return this.finishImportSpecifier(specifier, "ImportSpecifier");
    }
    parseBindingAtom() {
      switch (this.state.type) {
        case 78:
          return this.parseIdentifier(true);
        default:
          return super.parseBindingAtom();
      }
    }
    parseFunctionParams(node, isConstructor) {
      const kind = node.kind;
      if (kind !== "get" && kind !== "set" && this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      super.parseFunctionParams(node, isConstructor);
    }
    parseVarId(decl, kind) {
      super.parseVarId(decl, kind);
      if (this.match(14)) {
        decl.id.typeAnnotation = this.flowParseTypeAnnotation();
        this.resetEndLocation(decl.id);
      }
    }
    parseAsyncArrowFromCallExpression(node, call) {
      if (this.match(14)) {
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        this.state.noAnonFunctionType = true;
        node.returnType = this.flowParseTypeAnnotation();
        this.state.noAnonFunctionType = oldNoAnonFunctionType;
      }
      return super.parseAsyncArrowFromCallExpression(node, call);
    }
    shouldParseAsyncArrow() {
      return this.match(14) || super.shouldParseAsyncArrow();
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      var _jsx;
      let state = null;
      let jsx2;
      if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
        state = this.state.clone();
        jsx2 = this.tryParse(() => super.parseMaybeAssign(refExpressionErrors, afterLeftParse), state);
        if (!jsx2.error)
          return jsx2.node;
        const {
          context
        } = this.state;
        const currentContext = context[context.length - 1];
        if (currentContext === types3.j_oTag || currentContext === types3.j_expr) {
          context.pop();
        }
      }
      if ((_jsx = jsx2) != null && _jsx.error || this.match(47)) {
        var _jsx2, _jsx3;
        state = state || this.state.clone();
        let typeParameters;
        const arrow = this.tryParse((abort) => {
          var _arrowExpression$extr;
          typeParameters = this.flowParseTypeParameterDeclaration();
          const arrowExpression2 = this.forwardNoArrowParamsConversionAt(typeParameters, () => {
            const result2 = super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
            this.resetStartLocationFromNode(result2, typeParameters);
            return result2;
          });
          if ((_arrowExpression$extr = arrowExpression2.extra) != null && _arrowExpression$extr.parenthesized)
            abort();
          const expr = this.maybeUnwrapTypeCastExpression(arrowExpression2);
          if (expr.type !== "ArrowFunctionExpression")
            abort();
          expr.typeParameters = typeParameters;
          this.resetStartLocationFromNode(expr, typeParameters);
          return arrowExpression2;
        }, state);
        let arrowExpression = null;
        if (arrow.node && this.maybeUnwrapTypeCastExpression(arrow.node).type === "ArrowFunctionExpression") {
          if (!arrow.error && !arrow.aborted) {
            if (arrow.node.async) {
              this.raise(FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction, typeParameters);
            }
            return arrow.node;
          }
          arrowExpression = arrow.node;
        }
        if ((_jsx2 = jsx2) != null && _jsx2.node) {
          this.state = jsx2.failState;
          return jsx2.node;
        }
        if (arrowExpression) {
          this.state = arrow.failState;
          return arrowExpression;
        }
        if ((_jsx3 = jsx2) != null && _jsx3.thrown)
          throw jsx2.error;
        if (arrow.thrown)
          throw arrow.error;
        throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, typeParameters);
      }
      return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
    }
    parseArrow(node) {
      if (this.match(14)) {
        const result2 = this.tryParse(() => {
          const oldNoAnonFunctionType = this.state.noAnonFunctionType;
          this.state.noAnonFunctionType = true;
          const typeNode = this.startNode();
          [typeNode.typeAnnotation, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
          if (this.canInsertSemicolon())
            this.unexpected();
          if (!this.match(19))
            this.unexpected();
          return typeNode;
        });
        if (result2.thrown)
          return null;
        if (result2.error)
          this.state = result2.failState;
        node.returnType = result2.node.typeAnnotation ? this.finishNode(result2.node, "TypeAnnotation") : null;
      }
      return super.parseArrow(node);
    }
    shouldParseArrow(params) {
      return this.match(14) || super.shouldParseArrow(params);
    }
    setArrowFunctionParameters(node, params) {
      if (this.state.noArrowParamsConversionAt.includes(node.start)) {
        node.params = params;
      } else {
        super.setArrowFunctionParameters(node, params);
      }
    }
    checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged = true) {
      if (isArrowFunction && this.state.noArrowParamsConversionAt.includes(node.start)) {
        return;
      }
      for (let i = 0;i < node.params.length; i++) {
        if (this.isThisParam(node.params[i]) && i > 0) {
          this.raise(FlowErrors.ThisParamMustBeFirst, node.params[i]);
        }
      }
      super.checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged);
    }
    parseParenAndDistinguishExpression(canBeArrow) {
      return super.parseParenAndDistinguishExpression(canBeArrow && !this.state.noArrowAt.includes(this.state.start));
    }
    parseSubscripts(base, startLoc, noCalls) {
      if (base.type === "Identifier" && base.name === "async" && this.state.noArrowAt.includes(startLoc.index)) {
        this.next();
        const node = this.startNodeAt(startLoc);
        node.callee = base;
        node.arguments = super.parseCallExpressionArguments(11, false);
        base = this.finishNode(node, "CallExpression");
      } else if (base.type === "Identifier" && base.name === "async" && this.match(47)) {
        const state = this.state.clone();
        const arrow = this.tryParse((abort) => this.parseAsyncArrowWithTypeParameters(startLoc) || abort(), state);
        if (!arrow.error && !arrow.aborted)
          return arrow.node;
        const result2 = this.tryParse(() => super.parseSubscripts(base, startLoc, noCalls), state);
        if (result2.node && !result2.error)
          return result2.node;
        if (arrow.node) {
          this.state = arrow.failState;
          return arrow.node;
        }
        if (result2.node) {
          this.state = result2.failState;
          return result2.node;
        }
        throw arrow.error || result2.error;
      }
      return super.parseSubscripts(base, startLoc, noCalls);
    }
    parseSubscript(base, startLoc, noCalls, subscriptState) {
      if (this.match(18) && this.isLookaheadToken_lt()) {
        subscriptState.optionalChainMember = true;
        if (noCalls) {
          subscriptState.stop = true;
          return base;
        }
        this.next();
        const node = this.startNodeAt(startLoc);
        node.callee = base;
        node.typeArguments = this.flowParseTypeParameterInstantiation();
        this.expect(10);
        node.arguments = this.parseCallExpressionArguments(11, false);
        node.optional = true;
        return this.finishCallExpression(node, true);
      } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
        const node = this.startNodeAt(startLoc);
        node.callee = base;
        const result2 = this.tryParse(() => {
          node.typeArguments = this.flowParseTypeParameterInstantiationCallOrNew();
          this.expect(10);
          node.arguments = super.parseCallExpressionArguments(11, false);
          if (subscriptState.optionalChainMember) {
            node.optional = false;
          }
          return this.finishCallExpression(node, subscriptState.optionalChainMember);
        });
        if (result2.node) {
          if (result2.error)
            this.state = result2.failState;
          return result2.node;
        }
      }
      return super.parseSubscript(base, startLoc, noCalls, subscriptState);
    }
    parseNewCallee(node) {
      super.parseNewCallee(node);
      let targs = null;
      if (this.shouldParseTypes() && this.match(47)) {
        targs = this.tryParse(() => this.flowParseTypeParameterInstantiationCallOrNew()).node;
      }
      node.typeArguments = targs;
    }
    parseAsyncArrowWithTypeParameters(startLoc) {
      const node = this.startNodeAt(startLoc);
      this.parseFunctionParams(node, false);
      if (!this.parseArrow(node))
        return;
      return super.parseArrowExpression(node, undefined, true);
    }
    readToken_mult_modulo(code2) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (code2 === 42 && next === 47 && this.state.hasFlowComment) {
        this.state.hasFlowComment = false;
        this.state.pos += 2;
        this.nextToken();
        return;
      }
      super.readToken_mult_modulo(code2);
    }
    readToken_pipe_amp(code2) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (code2 === 124 && next === 125) {
        this.finishOp(9, 2);
        return;
      }
      super.readToken_pipe_amp(code2);
    }
    parseTopLevel(file, program) {
      const fileNode = super.parseTopLevel(file, program);
      if (this.state.hasFlowComment) {
        this.raise(FlowErrors.UnterminatedFlowComment, this.state.curPosition());
      }
      return fileNode;
    }
    skipBlockComment() {
      if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
        if (this.state.hasFlowComment) {
          throw this.raise(FlowErrors.NestedFlowComment, this.state.startLoc);
        }
        this.hasFlowCommentCompletion();
        const commentSkip = this.skipFlowComment();
        if (commentSkip) {
          this.state.pos += commentSkip;
          this.state.hasFlowComment = true;
        }
        return;
      }
      return super.skipBlockComment(this.state.hasFlowComment ? "*-/" : "*/");
    }
    skipFlowComment() {
      const {
        pos
      } = this.state;
      let shiftToFirstNonWhiteSpace = 2;
      while ([32, 9].includes(this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace))) {
        shiftToFirstNonWhiteSpace++;
      }
      const ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
      const ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
      if (ch2 === 58 && ch3 === 58) {
        return shiftToFirstNonWhiteSpace + 2;
      }
      if (this.input.slice(shiftToFirstNonWhiteSpace + pos, shiftToFirstNonWhiteSpace + pos + 12) === "flow-include") {
        return shiftToFirstNonWhiteSpace + 12;
      }
      if (ch2 === 58 && ch3 !== 58) {
        return shiftToFirstNonWhiteSpace;
      }
      return false;
    }
    hasFlowCommentCompletion() {
      const end = this.input.indexOf("*/", this.state.pos);
      if (end === -1) {
        throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
      }
    }
    flowEnumErrorBooleanMemberNotInitialized(loc, {
      enumName,
      memberName
    }) {
      this.raise(FlowErrors.EnumBooleanMemberNotInitialized, loc, {
        memberName,
        enumName
      });
    }
    flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
      return this.raise(!enumContext.explicitType ? FlowErrors.EnumInvalidMemberInitializerUnknownType : enumContext.explicitType === "symbol" ? FlowErrors.EnumInvalidMemberInitializerSymbolType : FlowErrors.EnumInvalidMemberInitializerPrimaryType, loc, enumContext);
    }
    flowEnumErrorNumberMemberNotInitialized(loc, details) {
      this.raise(FlowErrors.EnumNumberMemberNotInitialized, loc, details);
    }
    flowEnumErrorStringMemberInconsistentlyInitialized(node, details) {
      this.raise(FlowErrors.EnumStringMemberInconsistentlyInitialized, node, details);
    }
    flowEnumMemberInit() {
      const startLoc = this.state.startLoc;
      const endOfInit = () => this.match(12) || this.match(8);
      switch (this.state.type) {
        case 134: {
          const literal = this.parseNumericLiteral(this.state.value);
          if (endOfInit()) {
            return {
              type: "number",
              loc: literal.loc.start,
              value: literal
            };
          }
          return {
            type: "invalid",
            loc: startLoc
          };
        }
        case 133: {
          const literal = this.parseStringLiteral(this.state.value);
          if (endOfInit()) {
            return {
              type: "string",
              loc: literal.loc.start,
              value: literal
            };
          }
          return {
            type: "invalid",
            loc: startLoc
          };
        }
        case 85:
        case 86: {
          const literal = this.parseBooleanLiteral(this.match(85));
          if (endOfInit()) {
            return {
              type: "boolean",
              loc: literal.loc.start,
              value: literal
            };
          }
          return {
            type: "invalid",
            loc: startLoc
          };
        }
        default:
          return {
            type: "invalid",
            loc: startLoc
          };
      }
    }
    flowEnumMemberRaw() {
      const loc = this.state.startLoc;
      const id = this.parseIdentifier(true);
      const init22 = this.eat(29) ? this.flowEnumMemberInit() : {
        type: "none",
        loc
      };
      return {
        id,
        init: init22
      };
    }
    flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
      const {
        explicitType
      } = context;
      if (explicitType === null) {
        return;
      }
      if (explicitType !== expectedType) {
        this.flowEnumErrorInvalidMemberInitializer(loc, context);
      }
    }
    flowEnumMembers({
      enumName,
      explicitType
    }) {
      const seenNames = new Set;
      const members = {
        booleanMembers: [],
        numberMembers: [],
        stringMembers: [],
        defaultedMembers: []
      };
      let hasUnknownMembers = false;
      while (!this.match(8)) {
        if (this.eat(21)) {
          hasUnknownMembers = true;
          break;
        }
        const memberNode = this.startNode();
        const {
          id,
          init: init22
        } = this.flowEnumMemberRaw();
        const memberName = id.name;
        if (memberName === "") {
          continue;
        }
        if (/^[a-z]/.test(memberName)) {
          this.raise(FlowErrors.EnumInvalidMemberName, id, {
            memberName,
            suggestion: memberName[0].toUpperCase() + memberName.slice(1),
            enumName
          });
        }
        if (seenNames.has(memberName)) {
          this.raise(FlowErrors.EnumDuplicateMemberName, id, {
            memberName,
            enumName
          });
        }
        seenNames.add(memberName);
        const context = {
          enumName,
          explicitType,
          memberName
        };
        memberNode.id = id;
        switch (init22.type) {
          case "boolean": {
            this.flowEnumCheckExplicitTypeMismatch(init22.loc, context, "boolean");
            memberNode.init = init22.value;
            members.booleanMembers.push(this.finishNode(memberNode, "EnumBooleanMember"));
            break;
          }
          case "number": {
            this.flowEnumCheckExplicitTypeMismatch(init22.loc, context, "number");
            memberNode.init = init22.value;
            members.numberMembers.push(this.finishNode(memberNode, "EnumNumberMember"));
            break;
          }
          case "string": {
            this.flowEnumCheckExplicitTypeMismatch(init22.loc, context, "string");
            memberNode.init = init22.value;
            members.stringMembers.push(this.finishNode(memberNode, "EnumStringMember"));
            break;
          }
          case "invalid": {
            throw this.flowEnumErrorInvalidMemberInitializer(init22.loc, context);
          }
          case "none": {
            switch (explicitType) {
              case "boolean":
                this.flowEnumErrorBooleanMemberNotInitialized(init22.loc, context);
                break;
              case "number":
                this.flowEnumErrorNumberMemberNotInitialized(init22.loc, context);
                break;
              default:
                members.defaultedMembers.push(this.finishNode(memberNode, "EnumDefaultedMember"));
            }
          }
        }
        if (!this.match(8)) {
          this.expect(12);
        }
      }
      return {
        members,
        hasUnknownMembers
      };
    }
    flowEnumStringMembers(initializedMembers, defaultedMembers, {
      enumName
    }) {
      if (initializedMembers.length === 0) {
        return defaultedMembers;
      } else if (defaultedMembers.length === 0) {
        return initializedMembers;
      } else if (defaultedMembers.length > initializedMembers.length) {
        for (const member of initializedMembers) {
          this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
            enumName
          });
        }
        return defaultedMembers;
      } else {
        for (const member of defaultedMembers) {
          this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
            enumName
          });
        }
        return initializedMembers;
      }
    }
    flowEnumParseExplicitType({
      enumName
    }) {
      if (!this.eatContextual(102))
        return null;
      if (!tokenIsIdentifier(this.state.type)) {
        throw this.raise(FlowErrors.EnumInvalidExplicitTypeUnknownSupplied, this.state.startLoc, {
          enumName
        });
      }
      const {
        value
      } = this.state;
      this.next();
      if (value !== "boolean" && value !== "number" && value !== "string" && value !== "symbol") {
        this.raise(FlowErrors.EnumInvalidExplicitType, this.state.startLoc, {
          enumName,
          invalidEnumType: value
        });
      }
      return value;
    }
    flowEnumBody(node, id) {
      const enumName = id.name;
      const nameLoc = id.loc.start;
      const explicitType = this.flowEnumParseExplicitType({
        enumName
      });
      this.expect(5);
      const {
        members,
        hasUnknownMembers
      } = this.flowEnumMembers({
        enumName,
        explicitType
      });
      node.hasUnknownMembers = hasUnknownMembers;
      switch (explicitType) {
        case "boolean":
          node.explicitType = true;
          node.members = members.booleanMembers;
          this.expect(8);
          return this.finishNode(node, "EnumBooleanBody");
        case "number":
          node.explicitType = true;
          node.members = members.numberMembers;
          this.expect(8);
          return this.finishNode(node, "EnumNumberBody");
        case "string":
          node.explicitType = true;
          node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
            enumName
          });
          this.expect(8);
          return this.finishNode(node, "EnumStringBody");
        case "symbol":
          node.members = members.defaultedMembers;
          this.expect(8);
          return this.finishNode(node, "EnumSymbolBody");
        default: {
          const empty = () => {
            node.members = [];
            this.expect(8);
            return this.finishNode(node, "EnumStringBody");
          };
          node.explicitType = false;
          const boolsLen = members.booleanMembers.length;
          const numsLen = members.numberMembers.length;
          const strsLen = members.stringMembers.length;
          const defaultedLen = members.defaultedMembers.length;
          if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
            return empty();
          } else if (!boolsLen && !numsLen) {
            node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
              enumName
            });
            this.expect(8);
            return this.finishNode(node, "EnumStringBody");
          } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
            for (const member of members.defaultedMembers) {
              this.flowEnumErrorBooleanMemberNotInitialized(member.loc.start, {
                enumName,
                memberName: member.id.name
              });
            }
            node.members = members.booleanMembers;
            this.expect(8);
            return this.finishNode(node, "EnumBooleanBody");
          } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
            for (const member of members.defaultedMembers) {
              this.flowEnumErrorNumberMemberNotInitialized(member.loc.start, {
                enumName,
                memberName: member.id.name
              });
            }
            node.members = members.numberMembers;
            this.expect(8);
            return this.finishNode(node, "EnumNumberBody");
          } else {
            this.raise(FlowErrors.EnumInconsistentMemberValues, nameLoc, {
              enumName
            });
            return empty();
          }
        }
      }
    }
    flowParseEnumDeclaration(node) {
      const id = this.parseIdentifier();
      node.id = id;
      node.body = this.flowEnumBody(this.startNode(), id);
      return this.finishNode(node, "EnumDeclaration");
    }
    isLookaheadToken_lt() {
      const next = this.nextTokenStart();
      if (this.input.charCodeAt(next) === 60) {
        const afterNext = this.input.charCodeAt(next + 1);
        return afterNext !== 60 && afterNext !== 61;
      }
      return false;
    }
    maybeUnwrapTypeCastExpression(node) {
      return node.type === "TypeCastExpression" ? node.expression : node;
    }
  };
  var entities = {
    __proto__: null,
    quot: '"',
    amp: "&",
    apos: "'",
    lt: "<",
    gt: ">",
    nbsp: "\xA0",
    iexcl: "\xA1",
    cent: "\xA2",
    pound: "\xA3",
    curren: "\xA4",
    yen: "\xA5",
    brvbar: "\xA6",
    sect: "\xA7",
    uml: "\xA8",
    copy: "\xA9",
    ordf: "\xAA",
    laquo: "\xAB",
    not: "\xAC",
    shy: "\xAD",
    reg: "\xAE",
    macr: "\xAF",
    deg: "\xB0",
    plusmn: "\xB1",
    sup2: "\xB2",
    sup3: "\xB3",
    acute: "\xB4",
    micro: "\xB5",
    para: "\xB6",
    middot: "\xB7",
    cedil: "\xB8",
    sup1: "\xB9",
    ordm: "\xBA",
    raquo: "\xBB",
    frac14: "\xBC",
    frac12: "\xBD",
    frac34: "\xBE",
    iquest: "\xBF",
    Agrave: "\xC0",
    Aacute: "\xC1",
    Acirc: "\xC2",
    Atilde: "\xC3",
    Auml: "\xC4",
    Aring: "\xC5",
    AElig: "\xC6",
    Ccedil: "\xC7",
    Egrave: "\xC8",
    Eacute: "\xC9",
    Ecirc: "\xCA",
    Euml: "\xCB",
    Igrave: "\xCC",
    Iacute: "\xCD",
    Icirc: "\xCE",
    Iuml: "\xCF",
    ETH: "\xD0",
    Ntilde: "\xD1",
    Ograve: "\xD2",
    Oacute: "\xD3",
    Ocirc: "\xD4",
    Otilde: "\xD5",
    Ouml: "\xD6",
    times: "\xD7",
    Oslash: "\xD8",
    Ugrave: "\xD9",
    Uacute: "\xDA",
    Ucirc: "\xDB",
    Uuml: "\xDC",
    Yacute: "\xDD",
    THORN: "\xDE",
    szlig: "\xDF",
    agrave: "\xE0",
    aacute: "\xE1",
    acirc: "\xE2",
    atilde: "\xE3",
    auml: "\xE4",
    aring: "\xE5",
    aelig: "\xE6",
    ccedil: "\xE7",
    egrave: "\xE8",
    eacute: "\xE9",
    ecirc: "\xEA",
    euml: "\xEB",
    igrave: "\xEC",
    iacute: "\xED",
    icirc: "\xEE",
    iuml: "\xEF",
    eth: "\xF0",
    ntilde: "\xF1",
    ograve: "\xF2",
    oacute: "\xF3",
    ocirc: "\xF4",
    otilde: "\xF5",
    ouml: "\xF6",
    divide: "\xF7",
    oslash: "\xF8",
    ugrave: "\xF9",
    uacute: "\xFA",
    ucirc: "\xFB",
    uuml: "\xFC",
    yacute: "\xFD",
    thorn: "\xFE",
    yuml: "\xFF",
    OElig: "\u0152",
    oelig: "\u0153",
    Scaron: "\u0160",
    scaron: "\u0161",
    Yuml: "\u0178",
    fnof: "\u0192",
    circ: "\u02C6",
    tilde: "\u02DC",
    Alpha: "\u0391",
    Beta: "\u0392",
    Gamma: "\u0393",
    Delta: "\u0394",
    Epsilon: "\u0395",
    Zeta: "\u0396",
    Eta: "\u0397",
    Theta: "\u0398",
    Iota: "\u0399",
    Kappa: "\u039A",
    Lambda: "\u039B",
    Mu: "\u039C",
    Nu: "\u039D",
    Xi: "\u039E",
    Omicron: "\u039F",
    Pi: "\u03A0",
    Rho: "\u03A1",
    Sigma: "\u03A3",
    Tau: "\u03A4",
    Upsilon: "\u03A5",
    Phi: "\u03A6",
    Chi: "\u03A7",
    Psi: "\u03A8",
    Omega: "\u03A9",
    alpha: "\u03B1",
    beta: "\u03B2",
    gamma: "\u03B3",
    delta: "\u03B4",
    epsilon: "\u03B5",
    zeta: "\u03B6",
    eta: "\u03B7",
    theta: "\u03B8",
    iota: "\u03B9",
    kappa: "\u03BA",
    lambda: "\u03BB",
    mu: "\u03BC",
    nu: "\u03BD",
    xi: "\u03BE",
    omicron: "\u03BF",
    pi: "\u03C0",
    rho: "\u03C1",
    sigmaf: "\u03C2",
    sigma: "\u03C3",
    tau: "\u03C4",
    upsilon: "\u03C5",
    phi: "\u03C6",
    chi: "\u03C7",
    psi: "\u03C8",
    omega: "\u03C9",
    thetasym: "\u03D1",
    upsih: "\u03D2",
    piv: "\u03D6",
    ensp: "\u2002",
    emsp: "\u2003",
    thinsp: "\u2009",
    zwnj: "\u200C",
    zwj: "\u200D",
    lrm: "\u200E",
    rlm: "\u200F",
    ndash: "\u2013",
    mdash: "\u2014",
    lsquo: "\u2018",
    rsquo: "\u2019",
    sbquo: "\u201A",
    ldquo: "\u201C",
    rdquo: "\u201D",
    bdquo: "\u201E",
    dagger: "\u2020",
    Dagger: "\u2021",
    bull: "\u2022",
    hellip: "\u2026",
    permil: "\u2030",
    prime: "\u2032",
    Prime: "\u2033",
    lsaquo: "\u2039",
    rsaquo: "\u203A",
    oline: "\u203E",
    frasl: "\u2044",
    euro: "\u20AC",
    image: "\u2111",
    weierp: "\u2118",
    real: "\u211C",
    trade: "\u2122",
    alefsym: "\u2135",
    larr: "\u2190",
    uarr: "\u2191",
    rarr: "\u2192",
    darr: "\u2193",
    harr: "\u2194",
    crarr: "\u21B5",
    lArr: "\u21D0",
    uArr: "\u21D1",
    rArr: "\u21D2",
    dArr: "\u21D3",
    hArr: "\u21D4",
    forall: "\u2200",
    part: "\u2202",
    exist: "\u2203",
    empty: "\u2205",
    nabla: "\u2207",
    isin: "\u2208",
    notin: "\u2209",
    ni: "\u220B",
    prod: "\u220F",
    sum: "\u2211",
    minus: "\u2212",
    lowast: "\u2217",
    radic: "\u221A",
    prop: "\u221D",
    infin: "\u221E",
    ang: "\u2220",
    and: "\u2227",
    or: "\u2228",
    cap: "\u2229",
    cup: "\u222A",
    int: "\u222B",
    there4: "\u2234",
    sim: "\u223C",
    cong: "\u2245",
    asymp: "\u2248",
    ne: "\u2260",
    equiv: "\u2261",
    le: "\u2264",
    ge: "\u2265",
    sub: "\u2282",
    sup: "\u2283",
    nsub: "\u2284",
    sube: "\u2286",
    supe: "\u2287",
    oplus: "\u2295",
    otimes: "\u2297",
    perp: "\u22A5",
    sdot: "\u22C5",
    lceil: "\u2308",
    rceil: "\u2309",
    lfloor: "\u230A",
    rfloor: "\u230B",
    lang: "\u2329",
    rang: "\u232A",
    loz: "\u25CA",
    spades: "\u2660",
    clubs: "\u2663",
    hearts: "\u2665",
    diams: "\u2666"
  };
  var JsxErrors = ParseErrorEnum`jsx`({
    AttributeIsEmpty: "JSX attributes must only be assigned a non-empty expression.",
    MissingClosingTagElement: ({
      openingTagName
    }) => `Expected corresponding JSX closing tag for <${openingTagName}>.`,
    MissingClosingTagFragment: "Expected corresponding JSX closing tag for <>.",
    UnexpectedSequenceExpression: "Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?",
    UnexpectedToken: ({
      unexpected,
      HTMLEntity
    }) => `Unexpected token \`${unexpected}\`. Did you mean \`${HTMLEntity}\` or \`{'${unexpected}'}\`?`,
    UnsupportedJsxValue: "JSX value should be either an expression or a quoted JSX text.",
    UnterminatedJsxContent: "Unterminated JSX contents.",
    UnwrappedAdjacentJSXElements: "Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?"
  });
  function isFragment(object) {
    return object ? object.type === "JSXOpeningFragment" || object.type === "JSXClosingFragment" : false;
  }
  function getQualifiedJSXName(object) {
    if (object.type === "JSXIdentifier") {
      return object.name;
    }
    if (object.type === "JSXNamespacedName") {
      return object.namespace.name + ":" + object.name.name;
    }
    if (object.type === "JSXMemberExpression") {
      return getQualifiedJSXName(object.object) + "." + getQualifiedJSXName(object.property);
    }
    throw new Error("Node had unexpected type: " + object.type);
  }
  var jsx = (superClass) => class JSXParserMixin extends superClass {
    jsxReadToken() {
      let out = "";
      let chunkStart = this.state.pos;
      for (;; ) {
        if (this.state.pos >= this.length) {
          throw this.raise(JsxErrors.UnterminatedJsxContent, this.state.startLoc);
        }
        const ch = this.input.charCodeAt(this.state.pos);
        switch (ch) {
          case 60:
          case 123:
            if (this.state.pos === this.state.start) {
              if (ch === 60 && this.state.canStartJSXElement) {
                ++this.state.pos;
                this.finishToken(142);
              } else {
                super.getTokenFromCode(ch);
              }
              return;
            }
            out += this.input.slice(chunkStart, this.state.pos);
            this.finishToken(141, out);
            return;
          case 38:
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadEntity();
            chunkStart = this.state.pos;
            break;
          case 62:
          case 125:
          default:
            if (isNewLine(ch)) {
              out += this.input.slice(chunkStart, this.state.pos);
              out += this.jsxReadNewLine(true);
              chunkStart = this.state.pos;
            } else {
              ++this.state.pos;
            }
        }
      }
    }
    jsxReadNewLine(normalizeCRLF) {
      const ch = this.input.charCodeAt(this.state.pos);
      let out;
      ++this.state.pos;
      if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
        ++this.state.pos;
        out = normalizeCRLF ? "\n" : "\r\n";
      } else {
        out = String.fromCharCode(ch);
      }
      ++this.state.curLine;
      this.state.lineStart = this.state.pos;
      return out;
    }
    jsxReadString(quote) {
      let out = "";
      let chunkStart = ++this.state.pos;
      for (;; ) {
        if (this.state.pos >= this.length) {
          throw this.raise(Errors.UnterminatedString, this.state.startLoc);
        }
        const ch = this.input.charCodeAt(this.state.pos);
        if (ch === quote)
          break;
        if (ch === 38) {
          out += this.input.slice(chunkStart, this.state.pos);
          out += this.jsxReadEntity();
          chunkStart = this.state.pos;
        } else if (isNewLine(ch)) {
          out += this.input.slice(chunkStart, this.state.pos);
          out += this.jsxReadNewLine(false);
          chunkStart = this.state.pos;
        } else {
          ++this.state.pos;
        }
      }
      out += this.input.slice(chunkStart, this.state.pos++);
      this.finishToken(133, out);
    }
    jsxReadEntity() {
      const startPos = ++this.state.pos;
      if (this.codePointAtPos(this.state.pos) === 35) {
        ++this.state.pos;
        let radix = 10;
        if (this.codePointAtPos(this.state.pos) === 120) {
          radix = 16;
          ++this.state.pos;
        }
        const codePoint = this.readInt(radix, undefined, false, "bail");
        if (codePoint !== null && this.codePointAtPos(this.state.pos) === 59) {
          ++this.state.pos;
          return String.fromCodePoint(codePoint);
        }
      } else {
        let count = 0;
        let semi = false;
        while (count++ < 10 && this.state.pos < this.length && !(semi = this.codePointAtPos(this.state.pos) === 59)) {
          ++this.state.pos;
        }
        if (semi) {
          const desc = this.input.slice(startPos, this.state.pos);
          const entity = entities[desc];
          ++this.state.pos;
          if (entity) {
            return entity;
          }
        }
      }
      this.state.pos = startPos;
      return "&";
    }
    jsxReadWord() {
      let ch;
      const start = this.state.pos;
      do {
        ch = this.input.charCodeAt(++this.state.pos);
      } while (isIdentifierChar(ch) || ch === 45);
      this.finishToken(140, this.input.slice(start, this.state.pos));
    }
    jsxParseIdentifier() {
      const node = this.startNode();
      if (this.match(140)) {
        node.name = this.state.value;
      } else if (tokenIsKeyword(this.state.type)) {
        node.name = tokenLabelName(this.state.type);
      } else {
        this.unexpected();
      }
      this.next();
      return this.finishNode(node, "JSXIdentifier");
    }
    jsxParseNamespacedName() {
      const startLoc = this.state.startLoc;
      const name = this.jsxParseIdentifier();
      if (!this.eat(14))
        return name;
      const node = this.startNodeAt(startLoc);
      node.namespace = name;
      node.name = this.jsxParseIdentifier();
      return this.finishNode(node, "JSXNamespacedName");
    }
    jsxParseElementName() {
      const startLoc = this.state.startLoc;
      let node = this.jsxParseNamespacedName();
      if (node.type === "JSXNamespacedName") {
        return node;
      }
      while (this.eat(16)) {
        const newNode = this.startNodeAt(startLoc);
        newNode.object = node;
        newNode.property = this.jsxParseIdentifier();
        node = this.finishNode(newNode, "JSXMemberExpression");
      }
      return node;
    }
    jsxParseAttributeValue() {
      let node;
      switch (this.state.type) {
        case 5:
          node = this.startNode();
          this.setContext(types3.brace);
          this.next();
          node = this.jsxParseExpressionContainer(node, types3.j_oTag);
          if (node.expression.type === "JSXEmptyExpression") {
            this.raise(JsxErrors.AttributeIsEmpty, node);
          }
          return node;
        case 142:
        case 133:
          return this.parseExprAtom();
        default:
          throw this.raise(JsxErrors.UnsupportedJsxValue, this.state.startLoc);
      }
    }
    jsxParseEmptyExpression() {
      const node = this.startNodeAt(this.state.lastTokEndLoc);
      return this.finishNodeAt(node, "JSXEmptyExpression", this.state.startLoc);
    }
    jsxParseSpreadChild(node) {
      this.next();
      node.expression = this.parseExpression();
      this.setContext(types3.j_expr);
      this.state.canStartJSXElement = true;
      this.expect(8);
      return this.finishNode(node, "JSXSpreadChild");
    }
    jsxParseExpressionContainer(node, previousContext) {
      if (this.match(8)) {
        node.expression = this.jsxParseEmptyExpression();
      } else {
        const expression = this.parseExpression();
        node.expression = expression;
      }
      this.setContext(previousContext);
      this.state.canStartJSXElement = true;
      this.expect(8);
      return this.finishNode(node, "JSXExpressionContainer");
    }
    jsxParseAttribute() {
      const node = this.startNode();
      if (this.match(5)) {
        this.setContext(types3.brace);
        this.next();
        this.expect(21);
        node.argument = this.parseMaybeAssignAllowIn();
        this.setContext(types3.j_oTag);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, "JSXSpreadAttribute");
      }
      node.name = this.jsxParseNamespacedName();
      node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
      return this.finishNode(node, "JSXAttribute");
    }
    jsxParseOpeningElementAt(startLoc) {
      const node = this.startNodeAt(startLoc);
      if (this.eat(143)) {
        return this.finishNode(node, "JSXOpeningFragment");
      }
      node.name = this.jsxParseElementName();
      return this.jsxParseOpeningElementAfterName(node);
    }
    jsxParseOpeningElementAfterName(node) {
      const attributes = [];
      while (!this.match(56) && !this.match(143)) {
        attributes.push(this.jsxParseAttribute());
      }
      node.attributes = attributes;
      node.selfClosing = this.eat(56);
      this.expect(143);
      return this.finishNode(node, "JSXOpeningElement");
    }
    jsxParseClosingElementAt(startLoc) {
      const node = this.startNodeAt(startLoc);
      if (this.eat(143)) {
        return this.finishNode(node, "JSXClosingFragment");
      }
      node.name = this.jsxParseElementName();
      this.expect(143);
      return this.finishNode(node, "JSXClosingElement");
    }
    jsxParseElementAt(startLoc) {
      const node = this.startNodeAt(startLoc);
      const children = [];
      const openingElement = this.jsxParseOpeningElementAt(startLoc);
      let closingElement = null;
      if (!openingElement.selfClosing) {
        contents:
          for (;; ) {
            switch (this.state.type) {
              case 142:
                startLoc = this.state.startLoc;
                this.next();
                if (this.eat(56)) {
                  closingElement = this.jsxParseClosingElementAt(startLoc);
                  break contents;
                }
                children.push(this.jsxParseElementAt(startLoc));
                break;
              case 141:
                children.push(this.parseLiteral(this.state.value, "JSXText"));
                break;
              case 5: {
                const node2 = this.startNode();
                this.setContext(types3.brace);
                this.next();
                if (this.match(21)) {
                  children.push(this.jsxParseSpreadChild(node2));
                } else {
                  children.push(this.jsxParseExpressionContainer(node2, types3.j_expr));
                }
                break;
              }
              default:
                this.unexpected();
            }
          }
        if (isFragment(openingElement) && !isFragment(closingElement) && closingElement !== null) {
          this.raise(JsxErrors.MissingClosingTagFragment, closingElement);
        } else if (!isFragment(openingElement) && isFragment(closingElement)) {
          this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
            openingTagName: getQualifiedJSXName(openingElement.name)
          });
        } else if (!isFragment(openingElement) && !isFragment(closingElement)) {
          if (getQualifiedJSXName(closingElement.name) !== getQualifiedJSXName(openingElement.name)) {
            this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
              openingTagName: getQualifiedJSXName(openingElement.name)
            });
          }
        }
      }
      if (isFragment(openingElement)) {
        node.openingFragment = openingElement;
        node.closingFragment = closingElement;
      } else {
        node.openingElement = openingElement;
        node.closingElement = closingElement;
      }
      node.children = children;
      if (this.match(47)) {
        throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, this.state.startLoc);
      }
      return isFragment(openingElement) ? this.finishNode(node, "JSXFragment") : this.finishNode(node, "JSXElement");
    }
    jsxParseElement() {
      const startLoc = this.state.startLoc;
      this.next();
      return this.jsxParseElementAt(startLoc);
    }
    setContext(newContext) {
      const {
        context
      } = this.state;
      context[context.length - 1] = newContext;
    }
    parseExprAtom(refExpressionErrors) {
      if (this.match(142)) {
        return this.jsxParseElement();
      } else if (this.match(47) && this.input.charCodeAt(this.state.pos) !== 33) {
        this.replaceToken(142);
        return this.jsxParseElement();
      } else {
        return super.parseExprAtom(refExpressionErrors);
      }
    }
    skipSpace() {
      const curContext = this.curContext();
      if (!curContext.preserveSpace)
        super.skipSpace();
    }
    getTokenFromCode(code2) {
      const context = this.curContext();
      if (context === types3.j_expr) {
        this.jsxReadToken();
        return;
      }
      if (context === types3.j_oTag || context === types3.j_cTag) {
        if (isIdentifierStart(code2)) {
          this.jsxReadWord();
          return;
        }
        if (code2 === 62) {
          ++this.state.pos;
          this.finishToken(143);
          return;
        }
        if ((code2 === 34 || code2 === 39) && context === types3.j_oTag) {
          this.jsxReadString(code2);
          return;
        }
      }
      if (code2 === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33) {
        ++this.state.pos;
        this.finishToken(142);
        return;
      }
      super.getTokenFromCode(code2);
    }
    updateContext(prevType) {
      const {
        context,
        type
      } = this.state;
      if (type === 56 && prevType === 142) {
        context.splice(-2, 2, types3.j_cTag);
        this.state.canStartJSXElement = false;
      } else if (type === 142) {
        context.push(types3.j_oTag);
      } else if (type === 143) {
        const out = context[context.length - 1];
        if (out === types3.j_oTag && prevType === 56 || out === types3.j_cTag) {
          context.pop();
          this.state.canStartJSXElement = context[context.length - 1] === types3.j_expr;
        } else {
          this.setContext(types3.j_expr);
          this.state.canStartJSXElement = true;
        }
      } else {
        this.state.canStartJSXElement = tokenComesBeforeExpression(type);
      }
    }
  };

  class TypeScriptScope extends Scope {
    constructor(...args) {
      super(...args);
      this.tsNames = new Map;
    }
  }

  class TypeScriptScopeHandler extends ScopeHandler {
    constructor(...args) {
      super(...args);
      this.importsStack = [];
    }
    createScope(flags) {
      this.importsStack.push(new Set);
      return new TypeScriptScope(flags);
    }
    enter(flags) {
      if (flags === 256) {
        this.importsStack.push(new Set);
      }
      super.enter(flags);
    }
    exit() {
      const flags = super.exit();
      if (flags === 256) {
        this.importsStack.pop();
      }
      return flags;
    }
    hasImport(name, allowShadow) {
      const len = this.importsStack.length;
      if (this.importsStack[len - 1].has(name)) {
        return true;
      }
      if (!allowShadow && len > 1) {
        for (let i = 0;i < len - 1; i++) {
          if (this.importsStack[i].has(name))
            return true;
        }
      }
      return false;
    }
    declareName(name, bindingType, loc) {
      if (bindingType & 4096) {
        if (this.hasImport(name, true)) {
          this.parser.raise(Errors.VarRedeclaration, loc, {
            identifierName: name
          });
        }
        this.importsStack[this.importsStack.length - 1].add(name);
        return;
      }
      const scope = this.currentScope();
      let type = scope.tsNames.get(name) || 0;
      if (bindingType & 1024) {
        this.maybeExportDefined(scope, name);
        scope.tsNames.set(name, type | 16);
        return;
      }
      super.declareName(name, bindingType, loc);
      if (bindingType & 2) {
        if (!(bindingType & 1)) {
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          this.maybeExportDefined(scope, name);
        }
        type = type | 1;
      }
      if (bindingType & 256) {
        type = type | 2;
      }
      if (bindingType & 512) {
        type = type | 4;
      }
      if (bindingType & 128) {
        type = type | 8;
      }
      if (type)
        scope.tsNames.set(name, type);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      const type = scope.tsNames.get(name);
      if ((type & 2) > 0) {
        if (bindingType & 256) {
          const isConst = !!(bindingType & 512);
          const wasConst = (type & 4) > 0;
          return isConst !== wasConst;
        }
        return true;
      }
      if (bindingType & 128 && (type & 8) > 0) {
        if (scope.names.get(name) & 2) {
          return !!(bindingType & 1);
        } else {
          return false;
        }
      }
      if (bindingType & 2 && (type & 1) > 0) {
        return true;
      }
      return super.isRedeclaredInScope(scope, name, bindingType);
    }
    checkLocalExport(id) {
      const {
        name
      } = id;
      if (this.hasImport(name))
        return;
      const len = this.scopeStack.length;
      for (let i = len - 1;i >= 0; i--) {
        const scope = this.scopeStack[i];
        const type = scope.tsNames.get(name);
        if ((type & 1) > 0 || (type & 16) > 0) {
          return;
        }
      }
      super.checkLocalExport(id);
    }
  }
  var unwrapParenthesizedExpression = (node) => {
    return node.type === "ParenthesizedExpression" ? unwrapParenthesizedExpression(node.expression) : node;
  };

  class LValParser extends NodeUtils {
    toAssignable(node, isLHS = false) {
      var _node$extra, _node$extra3;
      let parenthesized = undefined;
      if (node.type === "ParenthesizedExpression" || (_node$extra = node.extra) != null && _node$extra.parenthesized) {
        parenthesized = unwrapParenthesizedExpression(node);
        if (isLHS) {
          if (parenthesized.type === "Identifier") {
            this.expressionScope.recordArrowParameterBindingError(Errors.InvalidParenthesizedAssignment, node);
          } else if (parenthesized.type !== "MemberExpression" && !this.isOptionalMemberExpression(parenthesized)) {
            this.raise(Errors.InvalidParenthesizedAssignment, node);
          }
        } else {
          this.raise(Errors.InvalidParenthesizedAssignment, node);
        }
      }
      switch (node.type) {
        case "Identifier":
        case "ObjectPattern":
        case "ArrayPattern":
        case "AssignmentPattern":
        case "RestElement":
          break;
        case "ObjectExpression":
          node.type = "ObjectPattern";
          for (let i = 0, length = node.properties.length, last = length - 1;i < length; i++) {
            var _node$extra2;
            const prop = node.properties[i];
            const isLast = i === last;
            this.toAssignableObjectExpressionProp(prop, isLast, isLHS);
            if (isLast && prop.type === "RestElement" && (_node$extra2 = node.extra) != null && _node$extra2.trailingCommaLoc) {
              this.raise(Errors.RestTrailingComma, node.extra.trailingCommaLoc);
            }
          }
          break;
        case "ObjectProperty": {
          const {
            key,
            value
          } = node;
          if (this.isPrivateName(key)) {
            this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
          }
          this.toAssignable(value, isLHS);
          break;
        }
        case "SpreadElement": {
          throw new Error("Internal @babel/parser error (this is a bug, please report it). SpreadElement should be converted by .toAssignable's caller.");
        }
        case "ArrayExpression":
          node.type = "ArrayPattern";
          this.toAssignableList(node.elements, (_node$extra3 = node.extra) == null ? undefined : _node$extra3.trailingCommaLoc, isLHS);
          break;
        case "AssignmentExpression":
          if (node.operator !== "=") {
            this.raise(Errors.MissingEqInAssignment, node.left.loc.end);
          }
          node.type = "AssignmentPattern";
          delete node.operator;
          this.toAssignable(node.left, isLHS);
          break;
        case "ParenthesizedExpression":
          this.toAssignable(parenthesized, isLHS);
          break;
      }
    }
    toAssignableObjectExpressionProp(prop, isLast, isLHS) {
      if (prop.type === "ObjectMethod") {
        this.raise(prop.kind === "get" || prop.kind === "set" ? Errors.PatternHasAccessor : Errors.PatternHasMethod, prop.key);
      } else if (prop.type === "SpreadElement") {
        prop.type = "RestElement";
        const arg = prop.argument;
        this.checkToRestConversion(arg, false);
        this.toAssignable(arg, isLHS);
        if (!isLast) {
          this.raise(Errors.RestTrailingComma, prop);
        }
      } else {
        this.toAssignable(prop, isLHS);
      }
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      const end = exprList.length - 1;
      for (let i = 0;i <= end; i++) {
        const elt = exprList[i];
        if (!elt)
          continue;
        if (elt.type === "SpreadElement") {
          elt.type = "RestElement";
          const arg = elt.argument;
          this.checkToRestConversion(arg, true);
          this.toAssignable(arg, isLHS);
        } else {
          this.toAssignable(elt, isLHS);
        }
        if (elt.type === "RestElement") {
          if (i < end) {
            this.raise(Errors.RestTrailingComma, elt);
          } else if (trailingCommaLoc) {
            this.raise(Errors.RestTrailingComma, trailingCommaLoc);
          }
        }
      }
    }
    isAssignable(node, isBinding) {
      switch (node.type) {
        case "Identifier":
        case "ObjectPattern":
        case "ArrayPattern":
        case "AssignmentPattern":
        case "RestElement":
          return true;
        case "ObjectExpression": {
          const last = node.properties.length - 1;
          return node.properties.every((prop, i) => {
            return prop.type !== "ObjectMethod" && (i === last || prop.type !== "SpreadElement") && this.isAssignable(prop);
          });
        }
        case "ObjectProperty":
          return this.isAssignable(node.value);
        case "SpreadElement":
          return this.isAssignable(node.argument);
        case "ArrayExpression":
          return node.elements.every((element) => element === null || this.isAssignable(element));
        case "AssignmentExpression":
          return node.operator === "=";
        case "ParenthesizedExpression":
          return this.isAssignable(node.expression);
        case "MemberExpression":
        case "OptionalMemberExpression":
          return !isBinding;
        default:
          return false;
      }
    }
    toReferencedList(exprList, isParenthesizedExpr) {
      return exprList;
    }
    toReferencedListDeep(exprList, isParenthesizedExpr) {
      this.toReferencedList(exprList, isParenthesizedExpr);
      for (const expr of exprList) {
        if ((expr == null ? undefined : expr.type) === "ArrayExpression") {
          this.toReferencedListDeep(expr.elements);
        }
      }
    }
    parseSpread(refExpressionErrors) {
      const node = this.startNode();
      this.next();
      node.argument = this.parseMaybeAssignAllowIn(refExpressionErrors, undefined);
      return this.finishNode(node, "SpreadElement");
    }
    parseRestBinding() {
      const node = this.startNode();
      this.next();
      node.argument = this.parseBindingAtom();
      return this.finishNode(node, "RestElement");
    }
    parseBindingAtom() {
      switch (this.state.type) {
        case 0: {
          const node = this.startNode();
          this.next();
          node.elements = this.parseBindingList(3, 93, 1);
          return this.finishNode(node, "ArrayPattern");
        }
        case 5:
          return this.parseObjectLike(8, true);
      }
      return this.parseIdentifier();
    }
    parseBindingList(close, closeCharCode, flags) {
      const allowEmpty = flags & 1;
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
        }
        if (allowEmpty && this.match(12)) {
          elts.push(null);
        } else if (this.eat(close)) {
          break;
        } else if (this.match(21)) {
          let rest = this.parseRestBinding();
          if (this.hasPlugin("flow") || flags & 2) {
            rest = this.parseFunctionParamType(rest);
          }
          elts.push(rest);
          if (!this.checkCommaAfterRest(closeCharCode)) {
            this.expect(close);
            break;
          }
        } else {
          const decorators = [];
          if (this.match(26) && this.hasPlugin("decorators")) {
            this.raise(Errors.UnsupportedParameterDecorator, this.state.startLoc);
          }
          while (this.match(26)) {
            decorators.push(this.parseDecorator());
          }
          elts.push(this.parseAssignableListItem(flags, decorators));
        }
      }
      return elts;
    }
    parseBindingRestProperty(prop) {
      this.next();
      prop.argument = this.parseIdentifier();
      this.checkCommaAfterRest(125);
      return this.finishNode(prop, "RestElement");
    }
    parseBindingProperty() {
      const {
        type,
        startLoc
      } = this.state;
      if (type === 21) {
        return this.parseBindingRestProperty(this.startNode());
      }
      const prop = this.startNode();
      if (type === 138) {
        this.expectPlugin("destructuringPrivate", startLoc);
        this.classScope.usePrivateName(this.state.value, startLoc);
        prop.key = this.parsePrivateName();
      } else {
        this.parsePropertyName(prop);
      }
      prop.method = false;
      return this.parseObjPropValue(prop, startLoc, false, false, true, false);
    }
    parseAssignableListItem(flags, decorators) {
      const left = this.parseMaybeDefault();
      if (this.hasPlugin("flow") || flags & 2) {
        this.parseFunctionParamType(left);
      }
      const elt = this.parseMaybeDefault(left.loc.start, left);
      if (decorators.length) {
        left.decorators = decorators;
      }
      return elt;
    }
    parseFunctionParamType(param) {
      return param;
    }
    parseMaybeDefault(startLoc, left) {
      var _startLoc, _left;
      (_startLoc = startLoc) != null || (startLoc = this.state.startLoc);
      left = (_left = left) != null ? _left : this.parseBindingAtom();
      if (!this.eat(29))
        return left;
      const node = this.startNodeAt(startLoc);
      node.left = left;
      node.right = this.parseMaybeAssignAllowIn();
      return this.finishNode(node, "AssignmentPattern");
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      switch (type) {
        case "AssignmentPattern":
          return "left";
        case "RestElement":
          return "argument";
        case "ObjectProperty":
          return "value";
        case "ParenthesizedExpression":
          return "expression";
        case "ArrayPattern":
          return "elements";
        case "ObjectPattern":
          return "properties";
      }
      return false;
    }
    isOptionalMemberExpression(expression) {
      return expression.type === "OptionalMemberExpression";
    }
    checkLVal(expression, ancestor, binding = 64, checkClashes = false, strictModeChanged = false, hasParenthesizedAncestor = false) {
      var _expression$extra;
      const type = expression.type;
      if (this.isObjectMethod(expression))
        return;
      const isOptionalMemberExpression = this.isOptionalMemberExpression(expression);
      if (isOptionalMemberExpression || type === "MemberExpression") {
        if (isOptionalMemberExpression) {
          this.expectPlugin("optionalChainingAssign", expression.loc.start);
          if (ancestor.type !== "AssignmentExpression") {
            this.raise(Errors.InvalidLhsOptionalChaining, expression, {
              ancestor
            });
          }
        }
        if (binding !== 64) {
          this.raise(Errors.InvalidPropertyBindingPattern, expression);
        }
        return;
      }
      if (type === "Identifier") {
        this.checkIdentifier(expression, binding, strictModeChanged);
        const {
          name
        } = expression;
        if (checkClashes) {
          if (checkClashes.has(name)) {
            this.raise(Errors.ParamDupe, expression);
          } else {
            checkClashes.add(name);
          }
        }
        return;
      }
      const validity = this.isValidLVal(type, !(hasParenthesizedAncestor || (_expression$extra = expression.extra) != null && _expression$extra.parenthesized) && ancestor.type === "AssignmentExpression", binding);
      if (validity === true)
        return;
      if (validity === false) {
        const ParseErrorClass = binding === 64 ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
        this.raise(ParseErrorClass, expression, {
          ancestor
        });
        return;
      }
      let key, isParenthesizedExpression;
      if (typeof validity === "string") {
        key = validity;
        isParenthesizedExpression = type === "ParenthesizedExpression";
      } else {
        [key, isParenthesizedExpression] = validity;
      }
      const nextAncestor = type === "ArrayPattern" || type === "ObjectPattern" ? {
        type
      } : ancestor;
      const val2 = expression[key];
      if (Array.isArray(val2)) {
        for (const child of val2) {
          if (child) {
            this.checkLVal(child, nextAncestor, binding, checkClashes, strictModeChanged, isParenthesizedExpression);
          }
        }
      } else if (val2) {
        this.checkLVal(val2, nextAncestor, binding, checkClashes, strictModeChanged, isParenthesizedExpression);
      }
    }
    checkIdentifier(at, bindingType, strictModeChanged = false) {
      if (this.state.strict && (strictModeChanged ? isStrictBindReservedWord(at.name, this.inModule) : isStrictBindOnlyReservedWord(at.name))) {
        if (bindingType === 64) {
          this.raise(Errors.StrictEvalArguments, at, {
            referenceName: at.name
          });
        } else {
          this.raise(Errors.StrictEvalArgumentsBinding, at, {
            bindingName: at.name
          });
        }
      }
      if (bindingType & 8192 && at.name === "let") {
        this.raise(Errors.LetInLexicalBinding, at);
      }
      if (!(bindingType & 64)) {
        this.declareNameFromIdentifier(at, bindingType);
      }
    }
    declareNameFromIdentifier(identifier, binding) {
      this.scope.declareName(identifier.name, binding, identifier.loc.start);
    }
    checkToRestConversion(node, allowPattern) {
      switch (node.type) {
        case "ParenthesizedExpression":
          this.checkToRestConversion(node.expression, allowPattern);
          break;
        case "Identifier":
        case "MemberExpression":
          break;
        case "ArrayExpression":
        case "ObjectExpression":
          if (allowPattern)
            break;
        default:
          this.raise(Errors.InvalidRestAssignmentPattern, node);
      }
    }
    checkCommaAfterRest(close) {
      if (!this.match(12)) {
        return false;
      }
      this.raise(this.lookaheadCharCode() === close ? Errors.RestTrailingComma : Errors.ElementAfterRest, this.state.startLoc);
      return true;
    }
  }
  function nonNull(x) {
    if (x == null) {
      throw new Error(`Unexpected ${x} value.`);
    }
    return x;
  }
  function assert(x) {
    if (!x) {
      throw new Error("Assert fail");
    }
  }
  var TSErrors = ParseErrorEnum`typescript`({
    AbstractMethodHasImplementation: ({
      methodName
    }) => `Method '${methodName}' cannot have an implementation because it is marked abstract.`,
    AbstractPropertyHasInitializer: ({
      propertyName
    }) => `Property '${propertyName}' cannot have an initializer because it is marked abstract.`,
    AccessorCannotBeOptional: "An 'accessor' property cannot be declared optional.",
    AccessorCannotDeclareThisParameter: "'get' and 'set' accessors cannot declare 'this' parameters.",
    AccessorCannotHaveTypeParameters: "An accessor cannot have type parameters.",
    ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
    ClassMethodHasReadonly: "Class methods cannot have the 'readonly' modifier.",
    ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference: "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
    ConstructorHasTypeParameters: "Type parameters cannot appear on a constructor declaration.",
    DeclareAccessor: ({
      kind
    }) => `'declare' is not allowed in ${kind}ters.`,
    DeclareClassFieldHasInitializer: "Initializers are not allowed in ambient contexts.",
    DeclareFunctionHasImplementation: "An implementation cannot be declared in ambient contexts.",
    DuplicateAccessibilityModifier: ({
      modifier
    }) => `Accessibility modifier already seen.`,
    DuplicateModifier: ({
      modifier
    }) => `Duplicate modifier: '${modifier}'.`,
    EmptyHeritageClauseType: ({
      token
    }) => `'${token}' list cannot be empty.`,
    EmptyTypeArguments: "Type argument list cannot be empty.",
    EmptyTypeParameters: "Type parameter list cannot be empty.",
    ExpectedAmbientAfterExportDeclare: "'export declare' must be followed by an ambient declaration.",
    ImportAliasHasImportType: "An import alias can not use 'import type'.",
    ImportReflectionHasImportType: "An `import module` declaration can not use `type` modifier",
    IncompatibleModifiers: ({
      modifiers
    }) => `'${modifiers[0]}' modifier cannot be used with '${modifiers[1]}' modifier.`,
    IndexSignatureHasAbstract: "Index signatures cannot have the 'abstract' modifier.",
    IndexSignatureHasAccessibility: ({
      modifier
    }) => `Index signatures cannot have an accessibility modifier ('${modifier}').`,
    IndexSignatureHasDeclare: "Index signatures cannot have the 'declare' modifier.",
    IndexSignatureHasOverride: "'override' modifier cannot appear on an index signature.",
    IndexSignatureHasStatic: "Index signatures cannot have the 'static' modifier.",
    InitializerNotAllowedInAmbientContext: "Initializers are not allowed in ambient contexts.",
    InvalidModifierOnTypeMember: ({
      modifier
    }) => `'${modifier}' modifier cannot appear on a type member.`,
    InvalidModifierOnTypeParameter: ({
      modifier
    }) => `'${modifier}' modifier cannot appear on a type parameter.`,
    InvalidModifierOnTypeParameterPositions: ({
      modifier
    }) => `'${modifier}' modifier can only appear on a type parameter of a class, interface or type alias.`,
    InvalidModifiersOrder: ({
      orderedModifiers
    }) => `'${orderedModifiers[0]}' modifier must precede '${orderedModifiers[1]}' modifier.`,
    InvalidPropertyAccessAfterInstantiationExpression: "Invalid property access after an instantiation expression. You can either wrap the instantiation expression in parentheses, or delete the type arguments.",
    InvalidTupleMemberLabel: "Tuple members must be labeled with a simple identifier.",
    MissingInterfaceName: "'interface' declarations must be followed by an identifier.",
    NonAbstractClassHasAbstractMethod: "Abstract methods can only appear within an abstract class.",
    NonClassMethodPropertyHasAbstractModifer: "'abstract' modifier can only appear on a class, method, or property declaration.",
    OptionalTypeBeforeRequired: "A required element cannot follow an optional element.",
    OverrideNotInSubClass: "This member cannot have an 'override' modifier because its containing class does not extend another class.",
    PatternIsOptional: "A binding pattern parameter cannot be optional in an implementation signature.",
    PrivateElementHasAbstract: "Private elements cannot have the 'abstract' modifier.",
    PrivateElementHasAccessibility: ({
      modifier
    }) => `Private elements cannot have an accessibility modifier ('${modifier}').`,
    ReadonlyForMethodSignature: "'readonly' modifier can only appear on a property declaration or index signature.",
    ReservedArrowTypeParam: "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.",
    ReservedTypeAssertion: "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.",
    SetAccessorCannotHaveOptionalParameter: "A 'set' accessor cannot have an optional parameter.",
    SetAccessorCannotHaveRestParameter: "A 'set' accessor cannot have rest parameter.",
    SetAccessorCannotHaveReturnType: "A 'set' accessor cannot have a return type annotation.",
    SingleTypeParameterWithoutTrailingComma: ({
      typeParameterName
    }) => `Single type parameter ${typeParameterName} should have a trailing comma. Example usage: <${typeParameterName},>.`,
    StaticBlockCannotHaveModifier: "Static class blocks cannot have any modifier.",
    TupleOptionalAfterType: "A labeled tuple optional element must be declared using a question mark after the name and before the colon (`name?: type`), rather than after the type (`name: type?`).",
    TypeAnnotationAfterAssign: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
    TypeImportCannotSpecifyDefaultAndNamed: "A type-only import can specify a default import or named bindings, but not both.",
    TypeModifierIsUsedInTypeExports: "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
    TypeModifierIsUsedInTypeImports: "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
    UnexpectedParameterModifier: "A parameter property is only allowed in a constructor implementation.",
    UnexpectedReadonly: "'readonly' type modifier is only permitted on array and tuple literal types.",
    UnexpectedTypeAnnotation: "Did not expect a type annotation here.",
    UnexpectedTypeCastInParameter: "Unexpected type cast in parameter position.",
    UnsupportedImportTypeArgument: "Argument in a type import must be a string literal.",
    UnsupportedParameterPropertyKind: "A parameter property may not be declared using a binding pattern.",
    UnsupportedSignatureParameterKind: ({
      type
    }) => `Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ${type}.`
  });
  function keywordTypeFromName(value) {
    switch (value) {
      case "any":
        return "TSAnyKeyword";
      case "boolean":
        return "TSBooleanKeyword";
      case "bigint":
        return "TSBigIntKeyword";
      case "never":
        return "TSNeverKeyword";
      case "number":
        return "TSNumberKeyword";
      case "object":
        return "TSObjectKeyword";
      case "string":
        return "TSStringKeyword";
      case "symbol":
        return "TSSymbolKeyword";
      case "undefined":
        return "TSUndefinedKeyword";
      case "unknown":
        return "TSUnknownKeyword";
      default:
        return;
    }
  }
  function tsIsAccessModifier(modifier) {
    return modifier === "private" || modifier === "public" || modifier === "protected";
  }
  function tsIsVarianceAnnotations(modifier) {
    return modifier === "in" || modifier === "out";
  }
  var typescript = (superClass) => class TypeScriptParserMixin extends superClass {
    constructor(...args) {
      super(...args);
      this.tsParseInOutModifiers = this.tsParseModifiers.bind(this, {
        allowedModifiers: ["in", "out"],
        disallowedModifiers: ["const", "public", "private", "protected", "readonly", "declare", "abstract", "override"],
        errorTemplate: TSErrors.InvalidModifierOnTypeParameter
      });
      this.tsParseConstModifier = this.tsParseModifiers.bind(this, {
        allowedModifiers: ["const"],
        disallowedModifiers: ["in", "out"],
        errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
      });
      this.tsParseInOutConstModifiers = this.tsParseModifiers.bind(this, {
        allowedModifiers: ["in", "out", "const"],
        disallowedModifiers: ["public", "private", "protected", "readonly", "declare", "abstract", "override"],
        errorTemplate: TSErrors.InvalidModifierOnTypeParameter
      });
    }
    getScopeHandler() {
      return TypeScriptScopeHandler;
    }
    tsIsIdentifier() {
      return tokenIsIdentifier(this.state.type);
    }
    tsTokenCanFollowModifier() {
      return this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(138) || this.isLiteralPropertyName();
    }
    tsNextTokenOnSameLineAndCanFollowModifier() {
      this.next();
      if (this.hasPrecedingLineBreak()) {
        return false;
      }
      return this.tsTokenCanFollowModifier();
    }
    tsNextTokenCanFollowModifier() {
      if (this.match(106)) {
        this.next();
        return this.tsTokenCanFollowModifier();
      }
      return this.tsNextTokenOnSameLineAndCanFollowModifier();
    }
    tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
      if (!tokenIsIdentifier(this.state.type) && this.state.type !== 58 && this.state.type !== 75) {
        return;
      }
      const modifier = this.state.value;
      if (allowedModifiers.includes(modifier)) {
        if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
          return;
        }
        if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
          return modifier;
        }
      }
      return;
    }
    tsParseModifiers({
      allowedModifiers,
      disallowedModifiers,
      stopOnStartOfClassStaticBlock,
      errorTemplate = TSErrors.InvalidModifierOnTypeMember
    }, modified) {
      const enforceOrder = (loc, modifier, before, after) => {
        if (modifier === before && modified[after]) {
          this.raise(TSErrors.InvalidModifiersOrder, loc, {
            orderedModifiers: [before, after]
          });
        }
      };
      const incompatible = (loc, modifier, mod1, mod2) => {
        if (modified[mod1] && modifier === mod2 || modified[mod2] && modifier === mod1) {
          this.raise(TSErrors.IncompatibleModifiers, loc, {
            modifiers: [mod1, mod2]
          });
        }
      };
      for (;; ) {
        const {
          startLoc
        } = this.state;
        const modifier = this.tsParseModifier(allowedModifiers.concat(disallowedModifiers != null ? disallowedModifiers : []), stopOnStartOfClassStaticBlock);
        if (!modifier)
          break;
        if (tsIsAccessModifier(modifier)) {
          if (modified.accessibility) {
            this.raise(TSErrors.DuplicateAccessibilityModifier, startLoc, {
              modifier
            });
          } else {
            enforceOrder(startLoc, modifier, modifier, "override");
            enforceOrder(startLoc, modifier, modifier, "static");
            enforceOrder(startLoc, modifier, modifier, "readonly");
            modified.accessibility = modifier;
          }
        } else if (tsIsVarianceAnnotations(modifier)) {
          if (modified[modifier]) {
            this.raise(TSErrors.DuplicateModifier, startLoc, {
              modifier
            });
          }
          modified[modifier] = true;
          enforceOrder(startLoc, modifier, "in", "out");
        } else {
          if (hasOwnProperty.call(modified, modifier)) {
            this.raise(TSErrors.DuplicateModifier, startLoc, {
              modifier
            });
          } else {
            enforceOrder(startLoc, modifier, "static", "readonly");
            enforceOrder(startLoc, modifier, "static", "override");
            enforceOrder(startLoc, modifier, "override", "readonly");
            enforceOrder(startLoc, modifier, "abstract", "override");
            incompatible(startLoc, modifier, "declare", "override");
            incompatible(startLoc, modifier, "static", "abstract");
          }
          modified[modifier] = true;
        }
        if (disallowedModifiers != null && disallowedModifiers.includes(modifier)) {
          this.raise(errorTemplate, startLoc, {
            modifier
          });
        }
      }
    }
    tsIsListTerminator(kind) {
      switch (kind) {
        case "EnumMembers":
        case "TypeMembers":
          return this.match(8);
        case "HeritageClauseElement":
          return this.match(5);
        case "TupleElementTypes":
          return this.match(3);
        case "TypeParametersOrArguments":
          return this.match(48);
      }
    }
    tsParseList(kind, parseElement) {
      const result2 = [];
      while (!this.tsIsListTerminator(kind)) {
        result2.push(parseElement());
      }
      return result2;
    }
    tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
      return nonNull(this.tsParseDelimitedListWorker(kind, parseElement, true, refTrailingCommaPos));
    }
    tsParseDelimitedListWorker(kind, parseElement, expectSuccess, refTrailingCommaPos) {
      const result2 = [];
      let trailingCommaPos = -1;
      for (;; ) {
        if (this.tsIsListTerminator(kind)) {
          break;
        }
        trailingCommaPos = -1;
        const element = parseElement();
        if (element == null) {
          return;
        }
        result2.push(element);
        if (this.eat(12)) {
          trailingCommaPos = this.state.lastTokStartLoc.index;
          continue;
        }
        if (this.tsIsListTerminator(kind)) {
          break;
        }
        if (expectSuccess) {
          this.expect(12);
        }
        return;
      }
      if (refTrailingCommaPos) {
        refTrailingCommaPos.value = trailingCommaPos;
      }
      return result2;
    }
    tsParseBracketedList(kind, parseElement, bracket22, skipFirstToken, refTrailingCommaPos) {
      if (!skipFirstToken) {
        if (bracket22) {
          this.expect(0);
        } else {
          this.expect(47);
        }
      }
      const result2 = this.tsParseDelimitedList(kind, parseElement, refTrailingCommaPos);
      if (bracket22) {
        this.expect(3);
      } else {
        this.expect(48);
      }
      return result2;
    }
    tsParseImportType() {
      const node = this.startNode();
      this.expect(83);
      this.expect(10);
      if (!this.match(133)) {
        this.raise(TSErrors.UnsupportedImportTypeArgument, this.state.startLoc);
      }
      node.argument = super.parseExprAtom();
      if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
        node.options = null;
      }
      if (this.eat(12)) {
        if (!this.hasPlugin("importAssertions")) {
          this.expectPlugin("importAttributes");
        }
        if (!this.match(11)) {
          node.options = super.parseMaybeAssignAllowIn();
          this.eat(12);
        }
      }
      this.expect(11);
      if (this.eat(16)) {
        node.qualifier = this.tsParseEntityName();
      }
      if (this.match(47)) {
        node.typeParameters = this.tsParseTypeArguments();
      }
      return this.finishNode(node, "TSImportType");
    }
    tsParseEntityName(allowReservedWords = true) {
      let entity = this.parseIdentifier(allowReservedWords);
      while (this.eat(16)) {
        const node = this.startNodeAtNode(entity);
        node.left = entity;
        node.right = this.parseIdentifier(allowReservedWords);
        entity = this.finishNode(node, "TSQualifiedName");
      }
      return entity;
    }
    tsParseTypeReference() {
      const node = this.startNode();
      node.typeName = this.tsParseEntityName();
      if (!this.hasPrecedingLineBreak() && this.match(47)) {
        node.typeParameters = this.tsParseTypeArguments();
      }
      return this.finishNode(node, "TSTypeReference");
    }
    tsParseThisTypePredicate(lhs) {
      this.next();
      const node = this.startNodeAtNode(lhs);
      node.parameterName = lhs;
      node.typeAnnotation = this.tsParseTypeAnnotation(false);
      node.asserts = false;
      return this.finishNode(node, "TSTypePredicate");
    }
    tsParseThisTypeNode() {
      const node = this.startNode();
      this.next();
      return this.finishNode(node, "TSThisType");
    }
    tsParseTypeQuery() {
      const node = this.startNode();
      this.expect(87);
      if (this.match(83)) {
        node.exprName = this.tsParseImportType();
      } else {
        node.exprName = this.tsParseEntityName();
      }
      if (!this.hasPrecedingLineBreak() && this.match(47)) {
        node.typeParameters = this.tsParseTypeArguments();
      }
      return this.finishNode(node, "TSTypeQuery");
    }
    tsParseTypeParameter(parseModifiers) {
      const node = this.startNode();
      parseModifiers(node);
      node.name = this.tsParseTypeParameterName();
      node.constraint = this.tsEatThenParseType(81);
      node.default = this.tsEatThenParseType(29);
      return this.finishNode(node, "TSTypeParameter");
    }
    tsTryParseTypeParameters(parseModifiers) {
      if (this.match(47)) {
        return this.tsParseTypeParameters(parseModifiers);
      }
    }
    tsParseTypeParameters(parseModifiers) {
      const node = this.startNode();
      if (this.match(47) || this.match(142)) {
        this.next();
      } else {
        this.unexpected();
      }
      const refTrailingCommaPos = {
        value: -1
      };
      node.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this, parseModifiers), false, true, refTrailingCommaPos);
      if (node.params.length === 0) {
        this.raise(TSErrors.EmptyTypeParameters, node);
      }
      if (refTrailingCommaPos.value !== -1) {
        this.addExtra(node, "trailingComma", refTrailingCommaPos.value);
      }
      return this.finishNode(node, "TSTypeParameterDeclaration");
    }
    tsFillSignature(returnToken, signature) {
      const returnTokenRequired = returnToken === 19;
      const paramsKey = "parameters";
      const returnTypeKey = "typeAnnotation";
      signature.typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
      this.expect(10);
      signature[paramsKey] = this.tsParseBindingListForSignature();
      if (returnTokenRequired) {
        signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
      } else if (this.match(returnToken)) {
        signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
      }
    }
    tsParseBindingListForSignature() {
      const list = super.parseBindingList(11, 41, 2);
      for (const pattern of list) {
        const {
          type
        } = pattern;
        if (type === "AssignmentPattern" || type === "TSParameterProperty") {
          this.raise(TSErrors.UnsupportedSignatureParameterKind, pattern, {
            type
          });
        }
      }
      return list;
    }
    tsParseTypeMemberSemicolon() {
      if (!this.eat(12) && !this.isLineTerminator()) {
        this.expect(13);
      }
    }
    tsParseSignatureMember(kind, node) {
      this.tsFillSignature(14, node);
      this.tsParseTypeMemberSemicolon();
      return this.finishNode(node, kind);
    }
    tsIsUnambiguouslyIndexSignature() {
      this.next();
      if (tokenIsIdentifier(this.state.type)) {
        this.next();
        return this.match(14);
      }
      return false;
    }
    tsTryParseIndexSignature(node) {
      if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this)))) {
        return;
      }
      this.expect(0);
      const id = this.parseIdentifier();
      id.typeAnnotation = this.tsParseTypeAnnotation();
      this.resetEndLocation(id);
      this.expect(3);
      node.parameters = [id];
      const type = this.tsTryParseTypeAnnotation();
      if (type)
        node.typeAnnotation = type;
      this.tsParseTypeMemberSemicolon();
      return this.finishNode(node, "TSIndexSignature");
    }
    tsParsePropertyOrMethodSignature(node, readonly) {
      if (this.eat(17))
        node.optional = true;
      const nodeAny = node;
      if (this.match(10) || this.match(47)) {
        if (readonly) {
          this.raise(TSErrors.ReadonlyForMethodSignature, node);
        }
        const method = nodeAny;
        if (method.kind && this.match(47)) {
          this.raise(TSErrors.AccessorCannotHaveTypeParameters, this.state.curPosition());
        }
        this.tsFillSignature(14, method);
        this.tsParseTypeMemberSemicolon();
        const paramsKey = "parameters";
        const returnTypeKey = "typeAnnotation";
        if (method.kind === "get") {
          if (method[paramsKey].length > 0) {
            this.raise(Errors.BadGetterArity, this.state.curPosition());
            if (this.isThisParam(method[paramsKey][0])) {
              this.raise(TSErrors.AccessorCannotDeclareThisParameter, this.state.curPosition());
            }
          }
        } else if (method.kind === "set") {
          if (method[paramsKey].length !== 1) {
            this.raise(Errors.BadSetterArity, this.state.curPosition());
          } else {
            const firstParameter = method[paramsKey][0];
            if (this.isThisParam(firstParameter)) {
              this.raise(TSErrors.AccessorCannotDeclareThisParameter, this.state.curPosition());
            }
            if (firstParameter.type === "Identifier" && firstParameter.optional) {
              this.raise(TSErrors.SetAccessorCannotHaveOptionalParameter, this.state.curPosition());
            }
            if (firstParameter.type === "RestElement") {
              this.raise(TSErrors.SetAccessorCannotHaveRestParameter, this.state.curPosition());
            }
          }
          if (method[returnTypeKey]) {
            this.raise(TSErrors.SetAccessorCannotHaveReturnType, method[returnTypeKey]);
          }
        } else {
          method.kind = "method";
        }
        return this.finishNode(method, "TSMethodSignature");
      } else {
        const property = nodeAny;
        if (readonly)
          property.readonly = true;
        const type = this.tsTryParseTypeAnnotation();
        if (type)
          property.typeAnnotation = type;
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(property, "TSPropertySignature");
      }
    }
    tsParseTypeMember() {
      const node = this.startNode();
      if (this.match(10) || this.match(47)) {
        return this.tsParseSignatureMember("TSCallSignatureDeclaration", node);
      }
      if (this.match(77)) {
        const id = this.startNode();
        this.next();
        if (this.match(10) || this.match(47)) {
          return this.tsParseSignatureMember("TSConstructSignatureDeclaration", node);
        } else {
          node.key = this.createIdentifier(id, "new");
          return this.tsParsePropertyOrMethodSignature(node, false);
        }
      }
      this.tsParseModifiers({
        allowedModifiers: ["readonly"],
        disallowedModifiers: ["declare", "abstract", "private", "protected", "public", "static", "override"]
      }, node);
      const idx = this.tsTryParseIndexSignature(node);
      if (idx) {
        return idx;
      }
      super.parsePropertyName(node);
      if (!node.computed && node.key.type === "Identifier" && (node.key.name === "get" || node.key.name === "set") && this.tsTokenCanFollowModifier()) {
        node.kind = node.key.name;
        super.parsePropertyName(node);
      }
      return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
    }
    tsParseTypeLiteral() {
      const node = this.startNode();
      node.members = this.tsParseObjectTypeMembers();
      return this.finishNode(node, "TSTypeLiteral");
    }
    tsParseObjectTypeMembers() {
      this.expect(5);
      const members = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
      this.expect(8);
      return members;
    }
    tsIsStartOfMappedType() {
      this.next();
      if (this.eat(53)) {
        return this.isContextual(122);
      }
      if (this.isContextual(122)) {
        this.next();
      }
      if (!this.match(0)) {
        return false;
      }
      this.next();
      if (!this.tsIsIdentifier()) {
        return false;
      }
      this.next();
      return this.match(58);
    }
    tsParseMappedType() {
      const node = this.startNode();
      this.expect(5);
      if (this.match(53)) {
        node.readonly = this.state.value;
        this.next();
        this.expectContextual(122);
      } else if (this.eatContextual(122)) {
        node.readonly = true;
      }
      this.expect(0);
      {
        const typeParameter = this.startNode();
        typeParameter.name = this.tsParseTypeParameterName();
        typeParameter.constraint = this.tsExpectThenParseType(58);
        node.typeParameter = this.finishNode(typeParameter, "TSTypeParameter");
      }
      node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
      this.expect(3);
      if (this.match(53)) {
        node.optional = this.state.value;
        this.next();
        this.expect(17);
      } else if (this.eat(17)) {
        node.optional = true;
      }
      node.typeAnnotation = this.tsTryParseType();
      this.semicolon();
      this.expect(8);
      return this.finishNode(node, "TSMappedType");
    }
    tsParseTupleType() {
      const node = this.startNode();
      node.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
      let seenOptionalElement = false;
      node.elementTypes.forEach((elementNode) => {
        const {
          type
        } = elementNode;
        if (seenOptionalElement && type !== "TSRestType" && type !== "TSOptionalType" && !(type === "TSNamedTupleMember" && elementNode.optional)) {
          this.raise(TSErrors.OptionalTypeBeforeRequired, elementNode);
        }
        seenOptionalElement || (seenOptionalElement = type === "TSNamedTupleMember" && elementNode.optional || type === "TSOptionalType");
      });
      return this.finishNode(node, "TSTupleType");
    }
    tsParseTupleElementType() {
      const {
        startLoc
      } = this.state;
      const rest = this.eat(21);
      let labeled;
      let label;
      let optional;
      let type;
      const isWord = tokenIsKeywordOrIdentifier(this.state.type);
      const chAfterWord = isWord ? this.lookaheadCharCode() : null;
      if (chAfterWord === 58) {
        labeled = true;
        optional = false;
        label = this.parseIdentifier(true);
        this.expect(14);
        type = this.tsParseType();
      } else if (chAfterWord === 63) {
        optional = true;
        const startLoc2 = this.state.startLoc;
        const wordName = this.state.value;
        const typeOrLabel = this.tsParseNonArrayType();
        if (this.lookaheadCharCode() === 58) {
          labeled = true;
          label = this.createIdentifier(this.startNodeAt(startLoc2), wordName);
          this.expect(17);
          this.expect(14);
          type = this.tsParseType();
        } else {
          labeled = false;
          type = typeOrLabel;
          this.expect(17);
        }
      } else {
        type = this.tsParseType();
        optional = this.eat(17);
        labeled = this.eat(14);
      }
      if (labeled) {
        let labeledNode;
        if (label) {
          labeledNode = this.startNodeAtNode(label);
          labeledNode.optional = optional;
          labeledNode.label = label;
          labeledNode.elementType = type;
          if (this.eat(17)) {
            labeledNode.optional = true;
            this.raise(TSErrors.TupleOptionalAfterType, this.state.lastTokStartLoc);
          }
        } else {
          labeledNode = this.startNodeAtNode(type);
          labeledNode.optional = optional;
          this.raise(TSErrors.InvalidTupleMemberLabel, type);
          labeledNode.label = type;
          labeledNode.elementType = this.tsParseType();
        }
        type = this.finishNode(labeledNode, "TSNamedTupleMember");
      } else if (optional) {
        const optionalTypeNode = this.startNodeAtNode(type);
        optionalTypeNode.typeAnnotation = type;
        type = this.finishNode(optionalTypeNode, "TSOptionalType");
      }
      if (rest) {
        const restNode = this.startNodeAt(startLoc);
        restNode.typeAnnotation = type;
        type = this.finishNode(restNode, "TSRestType");
      }
      return type;
    }
    tsParseParenthesizedType() {
      const node = this.startNode();
      this.expect(10);
      node.typeAnnotation = this.tsParseType();
      this.expect(11);
      return this.finishNode(node, "TSParenthesizedType");
    }
    tsParseFunctionOrConstructorType(type, abstract) {
      const node = this.startNode();
      if (type === "TSConstructorType") {
        node.abstract = !!abstract;
        if (abstract)
          this.next();
        this.next();
      }
      this.tsInAllowConditionalTypesContext(() => this.tsFillSignature(19, node));
      return this.finishNode(node, type);
    }
    tsParseLiteralTypeNode() {
      const node = this.startNode();
      switch (this.state.type) {
        case 134:
        case 135:
        case 133:
        case 85:
        case 86:
          node.literal = super.parseExprAtom();
          break;
        default:
          this.unexpected();
      }
      return this.finishNode(node, "TSLiteralType");
    }
    tsParseTemplateLiteralType() {
      const node = this.startNode();
      node.literal = super.parseTemplate(false);
      return this.finishNode(node, "TSLiteralType");
    }
    parseTemplateSubstitution() {
      if (this.state.inType)
        return this.tsParseType();
      return super.parseTemplateSubstitution();
    }
    tsParseThisTypeOrThisTypePredicate() {
      const thisKeyword = this.tsParseThisTypeNode();
      if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
        return this.tsParseThisTypePredicate(thisKeyword);
      } else {
        return thisKeyword;
      }
    }
    tsParseNonArrayType() {
      switch (this.state.type) {
        case 133:
        case 134:
        case 135:
        case 85:
        case 86:
          return this.tsParseLiteralTypeNode();
        case 53:
          if (this.state.value === "-") {
            const node = this.startNode();
            const nextToken = this.lookahead();
            if (nextToken.type !== 134 && nextToken.type !== 135) {
              this.unexpected();
            }
            node.literal = this.parseMaybeUnary();
            return this.finishNode(node, "TSLiteralType");
          }
          break;
        case 78:
          return this.tsParseThisTypeOrThisTypePredicate();
        case 87:
          return this.tsParseTypeQuery();
        case 83:
          return this.tsParseImportType();
        case 5:
          return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();
        case 0:
          return this.tsParseTupleType();
        case 10:
          return this.tsParseParenthesizedType();
        case 25:
        case 24:
          return this.tsParseTemplateLiteralType();
        default: {
          const {
            type
          } = this.state;
          if (tokenIsIdentifier(type) || type === 88 || type === 84) {
            const nodeType = type === 88 ? "TSVoidKeyword" : type === 84 ? "TSNullKeyword" : keywordTypeFromName(this.state.value);
            if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
              const node = this.startNode();
              this.next();
              return this.finishNode(node, nodeType);
            }
            return this.tsParseTypeReference();
          }
        }
      }
      this.unexpected();
    }
    tsParseArrayTypeOrHigher() {
      let type = this.tsParseNonArrayType();
      while (!this.hasPrecedingLineBreak() && this.eat(0)) {
        if (this.match(3)) {
          const node = this.startNodeAtNode(type);
          node.elementType = type;
          this.expect(3);
          type = this.finishNode(node, "TSArrayType");
        } else {
          const node = this.startNodeAtNode(type);
          node.objectType = type;
          node.indexType = this.tsParseType();
          this.expect(3);
          type = this.finishNode(node, "TSIndexedAccessType");
        }
      }
      return type;
    }
    tsParseTypeOperator() {
      const node = this.startNode();
      const operator = this.state.value;
      this.next();
      node.operator = operator;
      node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
      if (operator === "readonly") {
        this.tsCheckTypeAnnotationForReadOnly(node);
      }
      return this.finishNode(node, "TSTypeOperator");
    }
    tsCheckTypeAnnotationForReadOnly(node) {
      switch (node.typeAnnotation.type) {
        case "TSTupleType":
        case "TSArrayType":
          return;
        default:
          this.raise(TSErrors.UnexpectedReadonly, node);
      }
    }
    tsParseInferType() {
      const node = this.startNode();
      this.expectContextual(115);
      const typeParameter = this.startNode();
      typeParameter.name = this.tsParseTypeParameterName();
      typeParameter.constraint = this.tsTryParse(() => this.tsParseConstraintForInferType());
      node.typeParameter = this.finishNode(typeParameter, "TSTypeParameter");
      return this.finishNode(node, "TSInferType");
    }
    tsParseConstraintForInferType() {
      if (this.eat(81)) {
        const constraint = this.tsInDisallowConditionalTypesContext(() => this.tsParseType());
        if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
          return constraint;
        }
      }
    }
    tsParseTypeOperatorOrHigher() {
      const isTypeOperator = tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
      return isTypeOperator ? this.tsParseTypeOperator() : this.isContextual(115) ? this.tsParseInferType() : this.tsInAllowConditionalTypesContext(() => this.tsParseArrayTypeOrHigher());
    }
    tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
      const node = this.startNode();
      const hasLeadingOperator = this.eat(operator);
      const types4 = [];
      do {
        types4.push(parseConstituentType());
      } while (this.eat(operator));
      if (types4.length === 1 && !hasLeadingOperator) {
        return types4[0];
      }
      node.types = types4;
      return this.finishNode(node, kind);
    }
    tsParseIntersectionTypeOrHigher() {
      return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
    }
    tsParseUnionTypeOrHigher() {
      return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
    }
    tsIsStartOfFunctionType() {
      if (this.match(47)) {
        return true;
      }
      return this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
    }
    tsSkipParameterStart() {
      if (tokenIsIdentifier(this.state.type) || this.match(78)) {
        this.next();
        return true;
      }
      if (this.match(5)) {
        const {
          errors: errors3
        } = this.state;
        const previousErrorCount = errors3.length;
        try {
          this.parseObjectLike(8, true);
          return errors3.length === previousErrorCount;
        } catch (_unused) {
          return false;
        }
      }
      if (this.match(0)) {
        this.next();
        const {
          errors: errors3
        } = this.state;
        const previousErrorCount = errors3.length;
        try {
          super.parseBindingList(3, 93, 1);
          return errors3.length === previousErrorCount;
        } catch (_unused2) {
          return false;
        }
      }
      return false;
    }
    tsIsUnambiguouslyStartOfFunctionType() {
      this.next();
      if (this.match(11) || this.match(21)) {
        return true;
      }
      if (this.tsSkipParameterStart()) {
        if (this.match(14) || this.match(12) || this.match(17) || this.match(29)) {
          return true;
        }
        if (this.match(11)) {
          this.next();
          if (this.match(19)) {
            return true;
          }
        }
      }
      return false;
    }
    tsParseTypeOrTypePredicateAnnotation(returnToken) {
      return this.tsInType(() => {
        const t = this.startNode();
        this.expect(returnToken);
        const node = this.startNode();
        const asserts = !!this.tsTryParse(this.tsParseTypePredicateAsserts.bind(this));
        if (asserts && this.match(78)) {
          let thisTypePredicate = this.tsParseThisTypeOrThisTypePredicate();
          if (thisTypePredicate.type === "TSThisType") {
            node.parameterName = thisTypePredicate;
            node.asserts = true;
            node.typeAnnotation = null;
            thisTypePredicate = this.finishNode(node, "TSTypePredicate");
          } else {
            this.resetStartLocationFromNode(thisTypePredicate, node);
            thisTypePredicate.asserts = true;
          }
          t.typeAnnotation = thisTypePredicate;
          return this.finishNode(t, "TSTypeAnnotation");
        }
        const typePredicateVariable = this.tsIsIdentifier() && this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
        if (!typePredicateVariable) {
          if (!asserts) {
            return this.tsParseTypeAnnotation(false, t);
          }
          node.parameterName = this.parseIdentifier();
          node.asserts = asserts;
          node.typeAnnotation = null;
          t.typeAnnotation = this.finishNode(node, "TSTypePredicate");
          return this.finishNode(t, "TSTypeAnnotation");
        }
        const type = this.tsParseTypeAnnotation(false);
        node.parameterName = typePredicateVariable;
        node.typeAnnotation = type;
        node.asserts = asserts;
        t.typeAnnotation = this.finishNode(node, "TSTypePredicate");
        return this.finishNode(t, "TSTypeAnnotation");
      });
    }
    tsTryParseTypeOrTypePredicateAnnotation() {
      if (this.match(14)) {
        return this.tsParseTypeOrTypePredicateAnnotation(14);
      }
    }
    tsTryParseTypeAnnotation() {
      if (this.match(14)) {
        return this.tsParseTypeAnnotation();
      }
    }
    tsTryParseType() {
      return this.tsEatThenParseType(14);
    }
    tsParseTypePredicatePrefix() {
      const id = this.parseIdentifier();
      if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
        this.next();
        return id;
      }
    }
    tsParseTypePredicateAsserts() {
      if (this.state.type !== 109) {
        return false;
      }
      const containsEsc = this.state.containsEsc;
      this.next();
      if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
        return false;
      }
      if (containsEsc) {
        this.raise(Errors.InvalidEscapedReservedWord, this.state.lastTokStartLoc, {
          reservedWord: "asserts"
        });
      }
      return true;
    }
    tsParseTypeAnnotation(eatColon = true, t = this.startNode()) {
      this.tsInType(() => {
        if (eatColon)
          this.expect(14);
        t.typeAnnotation = this.tsParseType();
      });
      return this.finishNode(t, "TSTypeAnnotation");
    }
    tsParseType() {
      assert(this.state.inType);
      const type = this.tsParseNonConditionalType();
      if (this.state.inDisallowConditionalTypesContext || this.hasPrecedingLineBreak() || !this.eat(81)) {
        return type;
      }
      const node = this.startNodeAtNode(type);
      node.checkType = type;
      node.extendsType = this.tsInDisallowConditionalTypesContext(() => this.tsParseNonConditionalType());
      this.expect(17);
      node.trueType = this.tsInAllowConditionalTypesContext(() => this.tsParseType());
      this.expect(14);
      node.falseType = this.tsInAllowConditionalTypesContext(() => this.tsParseType());
      return this.finishNode(node, "TSConditionalType");
    }
    isAbstractConstructorSignature() {
      return this.isContextual(124) && this.lookahead().type === 77;
    }
    tsParseNonConditionalType() {
      if (this.tsIsStartOfFunctionType()) {
        return this.tsParseFunctionOrConstructorType("TSFunctionType");
      }
      if (this.match(77)) {
        return this.tsParseFunctionOrConstructorType("TSConstructorType");
      } else if (this.isAbstractConstructorSignature()) {
        return this.tsParseFunctionOrConstructorType("TSConstructorType", true);
      }
      return this.tsParseUnionTypeOrHigher();
    }
    tsParseTypeAssertion() {
      if (this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
        this.raise(TSErrors.ReservedTypeAssertion, this.state.startLoc);
      }
      const node = this.startNode();
      node.typeAnnotation = this.tsInType(() => {
        this.next();
        return this.match(75) ? this.tsParseTypeReference() : this.tsParseType();
      });
      this.expect(48);
      node.expression = this.parseMaybeUnary();
      return this.finishNode(node, "TSTypeAssertion");
    }
    tsParseHeritageClause(token) {
      const originalStartLoc = this.state.startLoc;
      const delimitedList = this.tsParseDelimitedList("HeritageClauseElement", () => {
        const node = this.startNode();
        node.expression = this.tsParseEntityName();
        if (this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, "TSExpressionWithTypeArguments");
      });
      if (!delimitedList.length) {
        this.raise(TSErrors.EmptyHeritageClauseType, originalStartLoc, {
          token
        });
      }
      return delimitedList;
    }
    tsParseInterfaceDeclaration(node, properties = {}) {
      if (this.hasFollowingLineBreak())
        return null;
      this.expectContextual(129);
      if (properties.declare)
        node.declare = true;
      if (tokenIsIdentifier(this.state.type)) {
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, 130);
      } else {
        node.id = null;
        this.raise(TSErrors.MissingInterfaceName, this.state.startLoc);
      }
      node.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
      if (this.eat(81)) {
        node.extends = this.tsParseHeritageClause("extends");
      }
      const body = this.startNode();
      body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
      node.body = this.finishNode(body, "TSInterfaceBody");
      return this.finishNode(node, "TSInterfaceDeclaration");
    }
    tsParseTypeAliasDeclaration(node) {
      node.id = this.parseIdentifier();
      this.checkIdentifier(node.id, 2);
      node.typeAnnotation = this.tsInType(() => {
        node.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutModifiers);
        this.expect(29);
        if (this.isContextual(114) && this.lookahead().type !== 16) {
          const node2 = this.startNode();
          this.next();
          return this.finishNode(node2, "TSIntrinsicKeyword");
        }
        return this.tsParseType();
      });
      this.semicolon();
      return this.finishNode(node, "TSTypeAliasDeclaration");
    }
    tsInNoContext(cb) {
      const oldContext = this.state.context;
      this.state.context = [oldContext[0]];
      try {
        return cb();
      } finally {
        this.state.context = oldContext;
      }
    }
    tsInType(cb) {
      const oldInType = this.state.inType;
      this.state.inType = true;
      try {
        return cb();
      } finally {
        this.state.inType = oldInType;
      }
    }
    tsInDisallowConditionalTypesContext(cb) {
      const oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
      this.state.inDisallowConditionalTypesContext = true;
      try {
        return cb();
      } finally {
        this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
      }
    }
    tsInAllowConditionalTypesContext(cb) {
      const oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
      this.state.inDisallowConditionalTypesContext = false;
      try {
        return cb();
      } finally {
        this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
      }
    }
    tsEatThenParseType(token) {
      if (this.match(token)) {
        return this.tsNextThenParseType();
      }
    }
    tsExpectThenParseType(token) {
      return this.tsInType(() => {
        this.expect(token);
        return this.tsParseType();
      });
    }
    tsNextThenParseType() {
      return this.tsInType(() => {
        this.next();
        return this.tsParseType();
      });
    }
    tsParseEnumMember() {
      const node = this.startNode();
      node.id = this.match(133) ? super.parseStringLiteral(this.state.value) : this.parseIdentifier(true);
      if (this.eat(29)) {
        node.initializer = super.parseMaybeAssignAllowIn();
      }
      return this.finishNode(node, "TSEnumMember");
    }
    tsParseEnumDeclaration(node, properties = {}) {
      if (properties.const)
        node.const = true;
      if (properties.declare)
        node.declare = true;
      this.expectContextual(126);
      node.id = this.parseIdentifier();
      this.checkIdentifier(node.id, node.const ? 8971 : 8459);
      this.expect(5);
      node.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this));
      this.expect(8);
      return this.finishNode(node, "TSEnumDeclaration");
    }
    tsParseModuleBlock() {
      const node = this.startNode();
      this.scope.enter(0);
      this.expect(5);
      super.parseBlockOrModuleBlockBody(node.body = [], undefined, true, 8);
      this.scope.exit();
      return this.finishNode(node, "TSModuleBlock");
    }
    tsParseModuleOrNamespaceDeclaration(node, nested = false) {
      node.id = this.parseIdentifier();
      if (!nested) {
        this.checkIdentifier(node.id, 1024);
      }
      if (this.eat(16)) {
        const inner = this.startNode();
        this.tsParseModuleOrNamespaceDeclaration(inner, true);
        node.body = inner;
      } else {
        this.scope.enter(256);
        this.prodParam.enter(0);
        node.body = this.tsParseModuleBlock();
        this.prodParam.exit();
        this.scope.exit();
      }
      return this.finishNode(node, "TSModuleDeclaration");
    }
    tsParseAmbientExternalModuleDeclaration(node) {
      if (this.isContextual(112)) {
        node.global = true;
        node.id = this.parseIdentifier();
      } else if (this.match(133)) {
        node.id = super.parseStringLiteral(this.state.value);
      } else {
        this.unexpected();
      }
      if (this.match(5)) {
        this.scope.enter(256);
        this.prodParam.enter(0);
        node.body = this.tsParseModuleBlock();
        this.prodParam.exit();
        this.scope.exit();
      } else {
        this.semicolon();
      }
      return this.finishNode(node, "TSModuleDeclaration");
    }
    tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier, isExport) {
      node.isExport = isExport || false;
      node.id = maybeDefaultIdentifier || this.parseIdentifier();
      this.checkIdentifier(node.id, 4096);
      this.expect(29);
      const moduleReference = this.tsParseModuleReference();
      if (node.importKind === "type" && moduleReference.type !== "TSExternalModuleReference") {
        this.raise(TSErrors.ImportAliasHasImportType, moduleReference);
      }
      node.moduleReference = moduleReference;
      this.semicolon();
      return this.finishNode(node, "TSImportEqualsDeclaration");
    }
    tsIsExternalModuleReference() {
      return this.isContextual(119) && this.lookaheadCharCode() === 40;
    }
    tsParseModuleReference() {
      return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
    }
    tsParseExternalModuleReference() {
      const node = this.startNode();
      this.expectContextual(119);
      this.expect(10);
      if (!this.match(133)) {
        this.unexpected();
      }
      node.expression = super.parseExprAtom();
      this.expect(11);
      this.sawUnambiguousESM = true;
      return this.finishNode(node, "TSExternalModuleReference");
    }
    tsLookAhead(f22) {
      const state = this.state.clone();
      const res = f22();
      this.state = state;
      return res;
    }
    tsTryParseAndCatch(f22) {
      const result2 = this.tryParse((abort) => f22() || abort());
      if (result2.aborted || !result2.node)
        return;
      if (result2.error)
        this.state = result2.failState;
      return result2.node;
    }
    tsTryParse(f22) {
      const state = this.state.clone();
      const result2 = f22();
      if (result2 !== undefined && result2 !== false) {
        return result2;
      }
      this.state = state;
    }
    tsTryParseDeclare(nany) {
      if (this.isLineTerminator()) {
        return;
      }
      let startType = this.state.type;
      let kind;
      if (this.isContextual(100)) {
        startType = 74;
        kind = "let";
      }
      return this.tsInAmbientContext(() => {
        switch (startType) {
          case 68:
            nany.declare = true;
            return super.parseFunctionStatement(nany, false, false);
          case 80:
            nany.declare = true;
            return this.parseClass(nany, true, false);
          case 126:
            return this.tsParseEnumDeclaration(nany, {
              declare: true
            });
          case 112:
            return this.tsParseAmbientExternalModuleDeclaration(nany);
          case 75:
          case 74:
            if (!this.match(75) || !this.isLookaheadContextual("enum")) {
              nany.declare = true;
              return this.parseVarStatement(nany, kind || this.state.value, true);
            }
            this.expect(75);
            return this.tsParseEnumDeclaration(nany, {
              const: true,
              declare: true
            });
          case 129: {
            const result2 = this.tsParseInterfaceDeclaration(nany, {
              declare: true
            });
            if (result2)
              return result2;
          }
          default:
            if (tokenIsIdentifier(startType)) {
              return this.tsParseDeclaration(nany, this.state.value, true, null);
            }
        }
      });
    }
    tsTryParseExportDeclaration() {
      return this.tsParseDeclaration(this.startNode(), this.state.value, true, null);
    }
    tsParseExpressionStatement(node, expr, decorators) {
      switch (expr.name) {
        case "declare": {
          const declaration = this.tsTryParseDeclare(node);
          if (declaration) {
            declaration.declare = true;
          }
          return declaration;
        }
        case "global":
          if (this.match(5)) {
            this.scope.enter(256);
            this.prodParam.enter(0);
            const mod = node;
            mod.global = true;
            mod.id = expr;
            mod.body = this.tsParseModuleBlock();
            this.scope.exit();
            this.prodParam.exit();
            return this.finishNode(mod, "TSModuleDeclaration");
          }
          break;
        default:
          return this.tsParseDeclaration(node, expr.name, false, decorators);
      }
    }
    tsParseDeclaration(node, value, next, decorators) {
      switch (value) {
        case "abstract":
          if (this.tsCheckLineTerminator(next) && (this.match(80) || tokenIsIdentifier(this.state.type))) {
            return this.tsParseAbstractDeclaration(node, decorators);
          }
          break;
        case "module":
          if (this.tsCheckLineTerminator(next)) {
            if (this.match(133)) {
              return this.tsParseAmbientExternalModuleDeclaration(node);
            } else if (tokenIsIdentifier(this.state.type)) {
              return this.tsParseModuleOrNamespaceDeclaration(node);
            }
          }
          break;
        case "namespace":
          if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
            return this.tsParseModuleOrNamespaceDeclaration(node);
          }
          break;
        case "type":
          if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
            return this.tsParseTypeAliasDeclaration(node);
          }
          break;
      }
    }
    tsCheckLineTerminator(next) {
      if (next) {
        if (this.hasFollowingLineBreak())
          return false;
        this.next();
        return true;
      }
      return !this.isLineTerminator();
    }
    tsTryParseGenericAsyncArrowFunction(startLoc) {
      if (!this.match(47))
        return;
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      this.state.maybeInArrowParameters = true;
      const res = this.tsTryParseAndCatch(() => {
        const node = this.startNodeAt(startLoc);
        node.typeParameters = this.tsParseTypeParameters(this.tsParseConstModifier);
        super.parseFunctionParams(node);
        node.returnType = this.tsTryParseTypeOrTypePredicateAnnotation();
        this.expect(19);
        return node;
      });
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      if (!res)
        return;
      return super.parseArrowExpression(res, null, true);
    }
    tsParseTypeArgumentsInExpression() {
      if (this.reScan_lt() !== 47)
        return;
      return this.tsParseTypeArguments();
    }
    tsParseTypeArguments() {
      const node = this.startNode();
      node.params = this.tsInType(() => this.tsInNoContext(() => {
        this.expect(47);
        return this.tsParseDelimitedList("TypeParametersOrArguments", this.tsParseType.bind(this));
      }));
      if (node.params.length === 0) {
        this.raise(TSErrors.EmptyTypeArguments, node);
      } else if (!this.state.inType && this.curContext() === types3.brace) {
        this.reScan_lt_gt();
      }
      this.expect(48);
      return this.finishNode(node, "TSTypeParameterInstantiation");
    }
    tsIsDeclarationStart() {
      return tokenIsTSDeclarationStart(this.state.type);
    }
    isExportDefaultSpecifier() {
      if (this.tsIsDeclarationStart())
        return false;
      return super.isExportDefaultSpecifier();
    }
    parseAssignableListItem(flags, decorators) {
      const startLoc = this.state.startLoc;
      const modified = {};
      this.tsParseModifiers({
        allowedModifiers: ["public", "private", "protected", "override", "readonly"]
      }, modified);
      const accessibility = modified.accessibility;
      const override = modified.override;
      const readonly = modified.readonly;
      if (!(flags & 4) && (accessibility || readonly || override)) {
        this.raise(TSErrors.UnexpectedParameterModifier, startLoc);
      }
      const left = this.parseMaybeDefault();
      if (flags & 2) {
        this.parseFunctionParamType(left);
      }
      const elt = this.parseMaybeDefault(left.loc.start, left);
      if (accessibility || readonly || override) {
        const pp = this.startNodeAt(startLoc);
        if (decorators.length) {
          pp.decorators = decorators;
        }
        if (accessibility)
          pp.accessibility = accessibility;
        if (readonly)
          pp.readonly = readonly;
        if (override)
          pp.override = override;
        if (elt.type !== "Identifier" && elt.type !== "AssignmentPattern") {
          this.raise(TSErrors.UnsupportedParameterPropertyKind, pp);
        }
        pp.parameter = elt;
        return this.finishNode(pp, "TSParameterProperty");
      }
      if (decorators.length) {
        left.decorators = decorators;
      }
      return elt;
    }
    isSimpleParameter(node) {
      return node.type === "TSParameterProperty" && super.isSimpleParameter(node.parameter) || super.isSimpleParameter(node);
    }
    tsDisallowOptionalPattern(node) {
      for (const param of node.params) {
        if (param.type !== "Identifier" && param.optional && !this.state.isAmbientContext) {
          this.raise(TSErrors.PatternIsOptional, param);
        }
      }
    }
    setArrowFunctionParameters(node, params, trailingCommaLoc) {
      super.setArrowFunctionParameters(node, params, trailingCommaLoc);
      this.tsDisallowOptionalPattern(node);
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      if (this.match(14)) {
        node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
      }
      const bodilessType = type === "FunctionDeclaration" ? "TSDeclareFunction" : type === "ClassMethod" || type === "ClassPrivateMethod" ? "TSDeclareMethod" : undefined;
      if (bodilessType && !this.match(5) && this.isLineTerminator()) {
        return this.finishNode(node, bodilessType);
      }
      if (bodilessType === "TSDeclareFunction" && this.state.isAmbientContext) {
        this.raise(TSErrors.DeclareFunctionHasImplementation, node);
        if (node.declare) {
          return super.parseFunctionBodyAndFinish(node, bodilessType, isMethod);
        }
      }
      this.tsDisallowOptionalPattern(node);
      return super.parseFunctionBodyAndFinish(node, type, isMethod);
    }
    registerFunctionStatementId(node) {
      if (!node.body && node.id) {
        this.checkIdentifier(node.id, 1024);
      } else {
        super.registerFunctionStatementId(node);
      }
    }
    tsCheckForInvalidTypeCasts(items) {
      items.forEach((node) => {
        if ((node == null ? undefined : node.type) === "TSTypeCastExpression") {
          this.raise(TSErrors.UnexpectedTypeAnnotation, node.typeAnnotation);
        }
      });
    }
    toReferencedList(exprList, isInParens) {
      this.tsCheckForInvalidTypeCasts(exprList);
      return exprList;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      const node = super.parseArrayLike(close, canBePattern, isTuple, refExpressionErrors);
      if (node.type === "ArrayExpression") {
        this.tsCheckForInvalidTypeCasts(node.elements);
      }
      return node;
    }
    parseSubscript(base, startLoc, noCalls, state) {
      if (!this.hasPrecedingLineBreak() && this.match(35)) {
        this.state.canStartJSXElement = false;
        this.next();
        const nonNullExpression = this.startNodeAt(startLoc);
        nonNullExpression.expression = base;
        return this.finishNode(nonNullExpression, "TSNonNullExpression");
      }
      let isOptionalCall = false;
      if (this.match(18) && this.lookaheadCharCode() === 60) {
        if (noCalls) {
          state.stop = true;
          return base;
        }
        state.optionalChainMember = isOptionalCall = true;
        this.next();
      }
      if (this.match(47) || this.match(51)) {
        let missingParenErrorLoc;
        const result2 = this.tsTryParseAndCatch(() => {
          if (!noCalls && this.atPossibleAsyncArrow(base)) {
            const asyncArrowFn = this.tsTryParseGenericAsyncArrowFunction(startLoc);
            if (asyncArrowFn) {
              return asyncArrowFn;
            }
          }
          const typeArguments = this.tsParseTypeArgumentsInExpression();
          if (!typeArguments)
            return;
          if (isOptionalCall && !this.match(10)) {
            missingParenErrorLoc = this.state.curPosition();
            return;
          }
          if (tokenIsTemplate(this.state.type)) {
            const result3 = super.parseTaggedTemplateExpression(base, startLoc, state);
            result3.typeParameters = typeArguments;
            return result3;
          }
          if (!noCalls && this.eat(10)) {
            const node2 = this.startNodeAt(startLoc);
            node2.callee = base;
            node2.arguments = this.parseCallExpressionArguments(11, false);
            this.tsCheckForInvalidTypeCasts(node2.arguments);
            node2.typeParameters = typeArguments;
            if (state.optionalChainMember) {
              node2.optional = isOptionalCall;
            }
            return this.finishCallExpression(node2, state.optionalChainMember);
          }
          const tokenType = this.state.type;
          if (tokenType === 48 || tokenType === 52 || tokenType !== 10 && tokenCanStartExpression(tokenType) && !this.hasPrecedingLineBreak()) {
            return;
          }
          const node = this.startNodeAt(startLoc);
          node.expression = base;
          node.typeParameters = typeArguments;
          return this.finishNode(node, "TSInstantiationExpression");
        });
        if (missingParenErrorLoc) {
          this.unexpected(missingParenErrorLoc, 10);
        }
        if (result2) {
          if (result2.type === "TSInstantiationExpression" && (this.match(16) || this.match(18) && this.lookaheadCharCode() !== 40)) {
            this.raise(TSErrors.InvalidPropertyAccessAfterInstantiationExpression, this.state.startLoc);
          }
          return result2;
        }
      }
      return super.parseSubscript(base, startLoc, noCalls, state);
    }
    parseNewCallee(node) {
      var _callee$extra;
      super.parseNewCallee(node);
      const {
        callee
      } = node;
      if (callee.type === "TSInstantiationExpression" && !((_callee$extra = callee.extra) != null && _callee$extra.parenthesized)) {
        node.typeParameters = callee.typeParameters;
        node.callee = callee.expression;
      }
    }
    parseExprOp(left, leftStartLoc, minPrec) {
      let isSatisfies;
      if (tokenOperatorPrecedence(58) > minPrec && !this.hasPrecedingLineBreak() && (this.isContextual(93) || (isSatisfies = this.isContextual(120)))) {
        const node = this.startNodeAt(leftStartLoc);
        node.expression = left;
        node.typeAnnotation = this.tsInType(() => {
          this.next();
          if (this.match(75)) {
            if (isSatisfies) {
              this.raise(Errors.UnexpectedKeyword, this.state.startLoc, {
                keyword: "const"
              });
            }
            return this.tsParseTypeReference();
          }
          return this.tsParseType();
        });
        this.finishNode(node, isSatisfies ? "TSSatisfiesExpression" : "TSAsExpression");
        this.reScan_lt_gt();
        return this.parseExprOp(node, leftStartLoc, minPrec);
      }
      return super.parseExprOp(left, leftStartLoc, minPrec);
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (!this.state.isAmbientContext) {
        super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
      }
    }
    checkImportReflection(node) {
      super.checkImportReflection(node);
      if (node.module && node.importKind !== "value") {
        this.raise(TSErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
      }
    }
    checkDuplicateExports() {
    }
    isPotentialImportPhase(isExport) {
      if (super.isPotentialImportPhase(isExport))
        return true;
      if (this.isContextual(130)) {
        const ch = this.lookaheadCharCode();
        return isExport ? ch === 123 || ch === 42 : ch !== 61;
      }
      return !isExport && this.isContextual(87);
    }
    applyImportPhase(node, isExport, phase, loc) {
      super.applyImportPhase(node, isExport, phase, loc);
      if (isExport) {
        node.exportKind = phase === "type" ? "type" : "value";
      } else {
        node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
      }
    }
    parseImport(node) {
      if (this.match(133)) {
        node.importKind = "value";
        return super.parseImport(node);
      }
      let importNode;
      if (tokenIsIdentifier(this.state.type) && this.lookaheadCharCode() === 61) {
        node.importKind = "value";
        return this.tsParseImportEqualsDeclaration(node);
      } else if (this.isContextual(130)) {
        const maybeDefaultIdentifier = this.parseMaybeImportPhase(node, false);
        if (this.lookaheadCharCode() === 61) {
          return this.tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier);
        } else {
          importNode = super.parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier);
        }
      } else {
        importNode = super.parseImport(node);
      }
      if (importNode.importKind === "type" && importNode.specifiers.length > 1 && importNode.specifiers[0].type === "ImportDefaultSpecifier") {
        this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, importNode);
      }
      return importNode;
    }
    parseExport(node, decorators) {
      if (this.match(83)) {
        this.next();
        const nodeImportEquals = node;
        let maybeDefaultIdentifier = null;
        if (this.isContextual(130) && this.isPotentialImportPhase(false)) {
          maybeDefaultIdentifier = this.parseMaybeImportPhase(nodeImportEquals, false);
        } else {
          nodeImportEquals.importKind = "value";
        }
        return this.tsParseImportEqualsDeclaration(nodeImportEquals, maybeDefaultIdentifier, true);
      } else if (this.eat(29)) {
        const assign = node;
        assign.expression = super.parseExpression();
        this.semicolon();
        this.sawUnambiguousESM = true;
        return this.finishNode(assign, "TSExportAssignment");
      } else if (this.eatContextual(93)) {
        const decl = node;
        this.expectContextual(128);
        decl.id = this.parseIdentifier();
        this.semicolon();
        return this.finishNode(decl, "TSNamespaceExportDeclaration");
      } else {
        return super.parseExport(node, decorators);
      }
    }
    isAbstractClass() {
      return this.isContextual(124) && this.lookahead().type === 80;
    }
    parseExportDefaultExpression() {
      if (this.isAbstractClass()) {
        const cls = this.startNode();
        this.next();
        cls.abstract = true;
        return this.parseClass(cls, true, true);
      }
      if (this.match(129)) {
        const result2 = this.tsParseInterfaceDeclaration(this.startNode());
        if (result2)
          return result2;
      }
      return super.parseExportDefaultExpression();
    }
    parseVarStatement(node, kind, allowMissingInitializer = false) {
      const {
        isAmbientContext
      } = this.state;
      const declaration = super.parseVarStatement(node, kind, allowMissingInitializer || isAmbientContext);
      if (!isAmbientContext)
        return declaration;
      for (const {
        id,
        init: init22
      } of declaration.declarations) {
        if (!init22)
          continue;
        if (kind !== "const" || !!id.typeAnnotation) {
          this.raise(TSErrors.InitializerNotAllowedInAmbientContext, init22);
        } else if (!isValidAmbientConstInitializer(init22, this.hasPlugin("estree"))) {
          this.raise(TSErrors.ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference, init22);
        }
      }
      return declaration;
    }
    parseStatementContent(flags, decorators) {
      if (this.match(75) && this.isLookaheadContextual("enum")) {
        const node = this.startNode();
        this.expect(75);
        return this.tsParseEnumDeclaration(node, {
          const: true
        });
      }
      if (this.isContextual(126)) {
        return this.tsParseEnumDeclaration(this.startNode());
      }
      if (this.isContextual(129)) {
        const result2 = this.tsParseInterfaceDeclaration(this.startNode());
        if (result2)
          return result2;
      }
      return super.parseStatementContent(flags, decorators);
    }
    parseAccessModifier() {
      return this.tsParseModifier(["public", "protected", "private"]);
    }
    tsHasSomeModifiers(member, modifiers) {
      return modifiers.some((modifier) => {
        if (tsIsAccessModifier(modifier)) {
          return member.accessibility === modifier;
        }
        return !!member[modifier];
      });
    }
    tsIsStartOfStaticBlocks() {
      return this.isContextual(106) && this.lookaheadCharCode() === 123;
    }
    parseClassMember(classBody, member, state) {
      const modifiers = ["declare", "private", "public", "protected", "override", "abstract", "readonly", "static"];
      this.tsParseModifiers({
        allowedModifiers: modifiers,
        disallowedModifiers: ["in", "out"],
        stopOnStartOfClassStaticBlock: true,
        errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
      }, member);
      const callParseClassMemberWithIsStatic = () => {
        if (this.tsIsStartOfStaticBlocks()) {
          this.next();
          this.next();
          if (this.tsHasSomeModifiers(member, modifiers)) {
            this.raise(TSErrors.StaticBlockCannotHaveModifier, this.state.curPosition());
          }
          super.parseClassStaticBlock(classBody, member);
        } else {
          this.parseClassMemberWithIsStatic(classBody, member, state, !!member.static);
        }
      };
      if (member.declare) {
        this.tsInAmbientContext(callParseClassMemberWithIsStatic);
      } else {
        callParseClassMemberWithIsStatic();
      }
    }
    parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
      const idx = this.tsTryParseIndexSignature(member);
      if (idx) {
        classBody.body.push(idx);
        if (member.abstract) {
          this.raise(TSErrors.IndexSignatureHasAbstract, member);
        }
        if (member.accessibility) {
          this.raise(TSErrors.IndexSignatureHasAccessibility, member, {
            modifier: member.accessibility
          });
        }
        if (member.declare) {
          this.raise(TSErrors.IndexSignatureHasDeclare, member);
        }
        if (member.override) {
          this.raise(TSErrors.IndexSignatureHasOverride, member);
        }
        return;
      }
      if (!this.state.inAbstractClass && member.abstract) {
        this.raise(TSErrors.NonAbstractClassHasAbstractMethod, member);
      }
      if (member.override) {
        if (!state.hadSuperClass) {
          this.raise(TSErrors.OverrideNotInSubClass, member);
        }
      }
      super.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
    }
    parsePostMemberNameModifiers(methodOrProp) {
      const optional = this.eat(17);
      if (optional)
        methodOrProp.optional = true;
      if (methodOrProp.readonly && this.match(10)) {
        this.raise(TSErrors.ClassMethodHasReadonly, methodOrProp);
      }
      if (methodOrProp.declare && this.match(10)) {
        this.raise(TSErrors.ClassMethodHasDeclare, methodOrProp);
      }
    }
    parseExpressionStatement(node, expr, decorators) {
      const decl = expr.type === "Identifier" ? this.tsParseExpressionStatement(node, expr, decorators) : undefined;
      return decl || super.parseExpressionStatement(node, expr, decorators);
    }
    shouldParseExportDeclaration() {
      if (this.tsIsDeclarationStart())
        return true;
      return super.shouldParseExportDeclaration();
    }
    parseConditional(expr, startLoc, refExpressionErrors) {
      if (!this.state.maybeInArrowParameters || !this.match(17)) {
        return super.parseConditional(expr, startLoc, refExpressionErrors);
      }
      const result2 = this.tryParse(() => super.parseConditional(expr, startLoc));
      if (!result2.node) {
        if (result2.error) {
          super.setOptionalParametersError(refExpressionErrors, result2.error);
        }
        return expr;
      }
      if (result2.error)
        this.state = result2.failState;
      return result2.node;
    }
    parseParenItem(node, startLoc) {
      const newNode = super.parseParenItem(node, startLoc);
      if (this.eat(17)) {
        newNode.optional = true;
        this.resetEndLocation(node);
      }
      if (this.match(14)) {
        const typeCastNode = this.startNodeAt(startLoc);
        typeCastNode.expression = node;
        typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
        return this.finishNode(typeCastNode, "TSTypeCastExpression");
      }
      return node;
    }
    parseExportDeclaration(node) {
      if (!this.state.isAmbientContext && this.isContextual(125)) {
        return this.tsInAmbientContext(() => this.parseExportDeclaration(node));
      }
      const startLoc = this.state.startLoc;
      const isDeclare = this.eatContextual(125);
      if (isDeclare && (this.isContextual(125) || !this.shouldParseExportDeclaration())) {
        throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, this.state.startLoc);
      }
      const isIdentifier = tokenIsIdentifier(this.state.type);
      const declaration = isIdentifier && this.tsTryParseExportDeclaration() || super.parseExportDeclaration(node);
      if (!declaration)
        return null;
      if (declaration.type === "TSInterfaceDeclaration" || declaration.type === "TSTypeAliasDeclaration" || isDeclare) {
        node.exportKind = "type";
      }
      if (isDeclare) {
        this.resetStartLocation(declaration, startLoc);
        declaration.declare = true;
      }
      return declaration;
    }
    parseClassId(node, isStatement, optionalId, bindingType) {
      if ((!isStatement || optionalId) && this.isContextual(113)) {
        return;
      }
      super.parseClassId(node, isStatement, optionalId, node.declare ? 1024 : 8331);
      const typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
      if (typeParameters)
        node.typeParameters = typeParameters;
    }
    parseClassPropertyAnnotation(node) {
      if (!node.optional) {
        if (this.eat(35)) {
          node.definite = true;
        } else if (this.eat(17)) {
          node.optional = true;
        }
      }
      const type = this.tsTryParseTypeAnnotation();
      if (type)
        node.typeAnnotation = type;
    }
    parseClassProperty(node) {
      this.parseClassPropertyAnnotation(node);
      if (this.state.isAmbientContext && !(node.readonly && !node.typeAnnotation) && this.match(29)) {
        this.raise(TSErrors.DeclareClassFieldHasInitializer, this.state.startLoc);
      }
      if (node.abstract && this.match(29)) {
        const {
          key
        } = node;
        this.raise(TSErrors.AbstractPropertyHasInitializer, this.state.startLoc, {
          propertyName: key.type === "Identifier" && !node.computed ? key.name : `[${this.input.slice(key.start, key.end)}]`
        });
      }
      return super.parseClassProperty(node);
    }
    parseClassPrivateProperty(node) {
      if (node.abstract) {
        this.raise(TSErrors.PrivateElementHasAbstract, node);
      }
      if (node.accessibility) {
        this.raise(TSErrors.PrivateElementHasAccessibility, node, {
          modifier: node.accessibility
        });
      }
      this.parseClassPropertyAnnotation(node);
      return super.parseClassPrivateProperty(node);
    }
    parseClassAccessorProperty(node) {
      this.parseClassPropertyAnnotation(node);
      if (node.optional) {
        this.raise(TSErrors.AccessorCannotBeOptional, node);
      }
      return super.parseClassAccessorProperty(node);
    }
    pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
      const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
      if (typeParameters && isConstructor) {
        this.raise(TSErrors.ConstructorHasTypeParameters, typeParameters);
      }
      const {
        declare = false,
        kind
      } = method;
      if (declare && (kind === "get" || kind === "set")) {
        this.raise(TSErrors.DeclareAccessor, method, {
          kind
        });
      }
      if (typeParameters)
        method.typeParameters = typeParameters;
      super.pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
      if (typeParameters)
        method.typeParameters = typeParameters;
      super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
    }
    declareClassPrivateMethodInScope(node, kind) {
      if (node.type === "TSDeclareMethod")
        return;
      if (node.type === "MethodDefinition" && !hasOwnProperty.call(node.value, "body")) {
        return;
      }
      super.declareClassPrivateMethodInScope(node, kind);
    }
    parseClassSuper(node) {
      super.parseClassSuper(node);
      if (node.superClass && (this.match(47) || this.match(51))) {
        node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
      }
      if (this.eatContextual(113)) {
        node.implements = this.tsParseHeritageClause("implements");
      }
    }
    parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
      const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
      if (typeParameters)
        prop.typeParameters = typeParameters;
      return super.parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors);
    }
    parseFunctionParams(node, isConstructor) {
      const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
      if (typeParameters)
        node.typeParameters = typeParameters;
      super.parseFunctionParams(node, isConstructor);
    }
    parseVarId(decl, kind) {
      super.parseVarId(decl, kind);
      if (decl.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35)) {
        decl.definite = true;
      }
      const type = this.tsTryParseTypeAnnotation();
      if (type) {
        decl.id.typeAnnotation = type;
        this.resetEndLocation(decl.id);
      }
    }
    parseAsyncArrowFromCallExpression(node, call) {
      if (this.match(14)) {
        node.returnType = this.tsParseTypeAnnotation();
      }
      return super.parseAsyncArrowFromCallExpression(node, call);
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      var _jsx, _jsx2, _typeCast, _jsx3, _typeCast2;
      let state;
      let jsx2;
      let typeCast;
      if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
        state = this.state.clone();
        jsx2 = this.tryParse(() => super.parseMaybeAssign(refExpressionErrors, afterLeftParse), state);
        if (!jsx2.error)
          return jsx2.node;
        const {
          context
        } = this.state;
        const currentContext = context[context.length - 1];
        if (currentContext === types3.j_oTag || currentContext === types3.j_expr) {
          context.pop();
        }
      }
      if (!((_jsx = jsx2) != null && _jsx.error) && !this.match(47)) {
        return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
      }
      if (!state || state === this.state)
        state = this.state.clone();
      let typeParameters;
      const arrow = this.tryParse((abort) => {
        var _expr$extra, _typeParameters;
        typeParameters = this.tsParseTypeParameters(this.tsParseConstModifier);
        const expr = super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
        if (expr.type !== "ArrowFunctionExpression" || (_expr$extra = expr.extra) != null && _expr$extra.parenthesized) {
          abort();
        }
        if (((_typeParameters = typeParameters) == null ? undefined : _typeParameters.params.length) !== 0) {
          this.resetStartLocationFromNode(expr, typeParameters);
        }
        expr.typeParameters = typeParameters;
        return expr;
      }, state);
      if (!arrow.error && !arrow.aborted) {
        if (typeParameters)
          this.reportReservedArrowTypeParam(typeParameters);
        return arrow.node;
      }
      if (!jsx2) {
        assert(!this.hasPlugin("jsx"));
        typeCast = this.tryParse(() => super.parseMaybeAssign(refExpressionErrors, afterLeftParse), state);
        if (!typeCast.error)
          return typeCast.node;
      }
      if ((_jsx2 = jsx2) != null && _jsx2.node) {
        this.state = jsx2.failState;
        return jsx2.node;
      }
      if (arrow.node) {
        this.state = arrow.failState;
        if (typeParameters)
          this.reportReservedArrowTypeParam(typeParameters);
        return arrow.node;
      }
      if ((_typeCast = typeCast) != null && _typeCast.node) {
        this.state = typeCast.failState;
        return typeCast.node;
      }
      throw ((_jsx3 = jsx2) == null ? undefined : _jsx3.error) || arrow.error || ((_typeCast2 = typeCast) == null ? undefined : _typeCast2.error);
    }
    reportReservedArrowTypeParam(node) {
      var _node$extra;
      if (node.params.length === 1 && !node.params[0].constraint && !((_node$extra = node.extra) != null && _node$extra.trailingComma) && this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
        this.raise(TSErrors.ReservedArrowTypeParam, node);
      }
    }
    parseMaybeUnary(refExpressionErrors, sawUnary) {
      if (!this.hasPlugin("jsx") && this.match(47)) {
        return this.tsParseTypeAssertion();
      }
      return super.parseMaybeUnary(refExpressionErrors, sawUnary);
    }
    parseArrow(node) {
      if (this.match(14)) {
        const result2 = this.tryParse((abort) => {
          const returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
          if (this.canInsertSemicolon() || !this.match(19))
            abort();
          return returnType;
        });
        if (result2.aborted)
          return;
        if (!result2.thrown) {
          if (result2.error)
            this.state = result2.failState;
          node.returnType = result2.node;
        }
      }
      return super.parseArrow(node);
    }
    parseFunctionParamType(param) {
      if (this.eat(17)) {
        param.optional = true;
      }
      const type = this.tsTryParseTypeAnnotation();
      if (type)
        param.typeAnnotation = type;
      this.resetEndLocation(param);
      return param;
    }
    isAssignable(node, isBinding) {
      switch (node.type) {
        case "TSTypeCastExpression":
          return this.isAssignable(node.expression, isBinding);
        case "TSParameterProperty":
          return true;
        default:
          return super.isAssignable(node, isBinding);
      }
    }
    toAssignable(node, isLHS = false) {
      switch (node.type) {
        case "ParenthesizedExpression":
          this.toAssignableParenthesizedExpression(node, isLHS);
          break;
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSNonNullExpression":
        case "TSTypeAssertion":
          if (isLHS) {
            this.expressionScope.recordArrowParameterBindingError(TSErrors.UnexpectedTypeCastInParameter, node);
          } else {
            this.raise(TSErrors.UnexpectedTypeCastInParameter, node);
          }
          this.toAssignable(node.expression, isLHS);
          break;
        case "AssignmentExpression":
          if (!isLHS && node.left.type === "TSTypeCastExpression") {
            node.left = this.typeCastToParameter(node.left);
          }
        default:
          super.toAssignable(node, isLHS);
      }
    }
    toAssignableParenthesizedExpression(node, isLHS) {
      switch (node.expression.type) {
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSNonNullExpression":
        case "TSTypeAssertion":
        case "ParenthesizedExpression":
          this.toAssignable(node.expression, isLHS);
          break;
        default:
          super.toAssignable(node, isLHS);
      }
    }
    checkToRestConversion(node, allowPattern) {
      switch (node.type) {
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSTypeAssertion":
        case "TSNonNullExpression":
          this.checkToRestConversion(node.expression, false);
          break;
        default:
          super.checkToRestConversion(node, allowPattern);
      }
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      switch (type) {
        case "TSTypeCastExpression":
          return true;
        case "TSParameterProperty":
          return "parameter";
        case "TSNonNullExpression":
        case "TSInstantiationExpression":
          return "expression";
        case "TSAsExpression":
        case "TSSatisfiesExpression":
        case "TSTypeAssertion":
          return (binding !== 64 || !isUnparenthesizedInAssign) && ["expression", true];
        default:
          return super.isValidLVal(type, isUnparenthesizedInAssign, binding);
      }
    }
    parseBindingAtom() {
      if (this.state.type === 78) {
        return this.parseIdentifier(true);
      }
      return super.parseBindingAtom();
    }
    parseMaybeDecoratorArguments(expr) {
      if (this.match(47) || this.match(51)) {
        const typeArguments = this.tsParseTypeArgumentsInExpression();
        if (this.match(10)) {
          const call = super.parseMaybeDecoratorArguments(expr);
          call.typeParameters = typeArguments;
          return call;
        }
        this.unexpected(null, 10);
      }
      return super.parseMaybeDecoratorArguments(expr);
    }
    checkCommaAfterRest(close) {
      if (this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === close) {
        this.next();
        return false;
      }
      return super.checkCommaAfterRest(close);
    }
    isClassMethod() {
      return this.match(47) || super.isClassMethod();
    }
    isClassProperty() {
      return this.match(35) || this.match(14) || super.isClassProperty();
    }
    parseMaybeDefault(startLoc, left) {
      const node = super.parseMaybeDefault(startLoc, left);
      if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
        this.raise(TSErrors.TypeAnnotationAfterAssign, node.typeAnnotation);
      }
      return node;
    }
    getTokenFromCode(code2) {
      if (this.state.inType) {
        if (code2 === 62) {
          this.finishOp(48, 1);
          return;
        }
        if (code2 === 60) {
          this.finishOp(47, 1);
          return;
        }
      }
      super.getTokenFromCode(code2);
    }
    reScan_lt_gt() {
      const {
        type
      } = this.state;
      if (type === 47) {
        this.state.pos -= 1;
        this.readToken_lt();
      } else if (type === 48) {
        this.state.pos -= 1;
        this.readToken_gt();
      }
    }
    reScan_lt() {
      const {
        type
      } = this.state;
      if (type === 51) {
        this.state.pos -= 2;
        this.finishOp(47, 1);
        return 47;
      }
      return type;
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      for (let i = 0;i < exprList.length; i++) {
        const expr = exprList[i];
        if ((expr == null ? undefined : expr.type) === "TSTypeCastExpression") {
          exprList[i] = this.typeCastToParameter(expr);
        }
      }
      super.toAssignableList(exprList, trailingCommaLoc, isLHS);
    }
    typeCastToParameter(node) {
      node.expression.typeAnnotation = node.typeAnnotation;
      this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
      return node.expression;
    }
    shouldParseArrow(params) {
      if (this.match(14)) {
        return params.every((expr) => this.isAssignable(expr, true));
      }
      return super.shouldParseArrow(params);
    }
    shouldParseAsyncArrow() {
      return this.match(14) || super.shouldParseAsyncArrow();
    }
    canHaveLeadingDecorator() {
      return super.canHaveLeadingDecorator() || this.isAbstractClass();
    }
    jsxParseOpeningElementAfterName(node) {
      if (this.match(47) || this.match(51)) {
        const typeArguments = this.tsTryParseAndCatch(() => this.tsParseTypeArgumentsInExpression());
        if (typeArguments)
          node.typeParameters = typeArguments;
      }
      return super.jsxParseOpeningElementAfterName(node);
    }
    getGetterSetterExpectedParamCount(method) {
      const baseCount = super.getGetterSetterExpectedParamCount(method);
      const params = this.getObjectOrClassMethodParams(method);
      const firstParam = params[0];
      const hasContextParam = firstParam && this.isThisParam(firstParam);
      return hasContextParam ? baseCount + 1 : baseCount;
    }
    parseCatchClauseParam() {
      const param = super.parseCatchClauseParam();
      const type = this.tsTryParseTypeAnnotation();
      if (type) {
        param.typeAnnotation = type;
        this.resetEndLocation(param);
      }
      return param;
    }
    tsInAmbientContext(cb) {
      const {
        isAmbientContext: oldIsAmbientContext,
        strict: oldStrict
      } = this.state;
      this.state.isAmbientContext = true;
      this.state.strict = false;
      try {
        return cb();
      } finally {
        this.state.isAmbientContext = oldIsAmbientContext;
        this.state.strict = oldStrict;
      }
    }
    parseClass(node, isStatement, optionalId) {
      const oldInAbstractClass = this.state.inAbstractClass;
      this.state.inAbstractClass = !!node.abstract;
      try {
        return super.parseClass(node, isStatement, optionalId);
      } finally {
        this.state.inAbstractClass = oldInAbstractClass;
      }
    }
    tsParseAbstractDeclaration(node, decorators) {
      if (this.match(80)) {
        node.abstract = true;
        return this.maybeTakeDecorators(decorators, this.parseClass(node, true, false));
      } else if (this.isContextual(129)) {
        if (!this.hasFollowingLineBreak()) {
          node.abstract = true;
          this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, node);
          return this.tsParseInterfaceDeclaration(node);
        }
      } else {
        this.unexpected(null, 80);
      }
    }
    parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope) {
      const method = super.parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
      if (method.abstract) {
        const hasBody = this.hasPlugin("estree") ? !!method.value.body : !!method.body;
        if (hasBody) {
          const {
            key
          } = method;
          this.raise(TSErrors.AbstractMethodHasImplementation, method, {
            methodName: key.type === "Identifier" && !method.computed ? key.name : `[${this.input.slice(key.start, key.end)}]`
          });
        }
      }
      return method;
    }
    tsParseTypeParameterName() {
      const typeName = this.parseIdentifier();
      return typeName.name;
    }
    shouldParseAsAmbientContext() {
      return !!this.getPluginOption("typescript", "dts");
    }
    parse() {
      if (this.shouldParseAsAmbientContext()) {
        this.state.isAmbientContext = true;
      }
      return super.parse();
    }
    getExpression() {
      if (this.shouldParseAsAmbientContext()) {
        this.state.isAmbientContext = true;
      }
      return super.getExpression();
    }
    parseExportSpecifier(node, isString22, isInTypeExport, isMaybeTypeOnly) {
      if (!isString22 && isMaybeTypeOnly) {
        this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
        return this.finishNode(node, "ExportSpecifier");
      }
      node.exportKind = "value";
      return super.parseExportSpecifier(node, isString22, isInTypeExport, isMaybeTypeOnly);
    }
    parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
      if (!importedIsString && isMaybeTypeOnly) {
        this.parseTypeOnlyImportExportSpecifier(specifier, true, isInTypeOnlyImport);
        return this.finishNode(specifier, "ImportSpecifier");
      }
      specifier.importKind = "value";
      return super.parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, isInTypeOnlyImport ? 4098 : 4096);
    }
    parseTypeOnlyImportExportSpecifier(node, isImport, isInTypeOnlyImportExport) {
      const leftOfAsKey = isImport ? "imported" : "local";
      const rightOfAsKey = isImport ? "local" : "exported";
      let leftOfAs = node[leftOfAsKey];
      let rightOfAs;
      let hasTypeSpecifier = false;
      let canParseAsKeyword = true;
      const loc = leftOfAs.loc.start;
      if (this.isContextual(93)) {
        const firstAs = this.parseIdentifier();
        if (this.isContextual(93)) {
          const secondAs = this.parseIdentifier();
          if (tokenIsKeywordOrIdentifier(this.state.type)) {
            hasTypeSpecifier = true;
            leftOfAs = firstAs;
            rightOfAs = isImport ? this.parseIdentifier() : this.parseModuleExportName();
            canParseAsKeyword = false;
          } else {
            rightOfAs = secondAs;
            canParseAsKeyword = false;
          }
        } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
          canParseAsKeyword = false;
          rightOfAs = isImport ? this.parseIdentifier() : this.parseModuleExportName();
        } else {
          hasTypeSpecifier = true;
          leftOfAs = firstAs;
        }
      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
        hasTypeSpecifier = true;
        if (isImport) {
          leftOfAs = this.parseIdentifier(true);
          if (!this.isContextual(93)) {
            this.checkReservedWord(leftOfAs.name, leftOfAs.loc.start, true, true);
          }
        } else {
          leftOfAs = this.parseModuleExportName();
        }
      }
      if (hasTypeSpecifier && isInTypeOnlyImportExport) {
        this.raise(isImport ? TSErrors.TypeModifierIsUsedInTypeImports : TSErrors.TypeModifierIsUsedInTypeExports, loc);
      }
      node[leftOfAsKey] = leftOfAs;
      node[rightOfAsKey] = rightOfAs;
      const kindKey = isImport ? "importKind" : "exportKind";
      node[kindKey] = hasTypeSpecifier ? "type" : "value";
      if (canParseAsKeyword && this.eatContextual(93)) {
        node[rightOfAsKey] = isImport ? this.parseIdentifier() : this.parseModuleExportName();
      }
      if (!node[rightOfAsKey]) {
        node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
      }
      if (isImport) {
        this.checkIdentifier(node[rightOfAsKey], hasTypeSpecifier ? 4098 : 4096);
      }
    }
  };
  function isPossiblyLiteralEnum(expression) {
    if (expression.type !== "MemberExpression")
      return false;
    const {
      computed,
      property
    } = expression;
    if (computed && property.type !== "StringLiteral" && (property.type !== "TemplateLiteral" || property.expressions.length > 0)) {
      return false;
    }
    return isUncomputedMemberExpressionChain(expression.object);
  }
  function isValidAmbientConstInitializer(expression, estree2) {
    var _expression$extra;
    const {
      type
    } = expression;
    if ((_expression$extra = expression.extra) != null && _expression$extra.parenthesized) {
      return false;
    }
    if (estree2) {
      if (type === "Literal") {
        const {
          value
        } = expression;
        if (typeof value === "string" || typeof value === "boolean") {
          return true;
        }
      }
    } else {
      if (type === "StringLiteral" || type === "BooleanLiteral") {
        return true;
      }
    }
    if (isNumber(expression, estree2) || isNegativeNumber(expression, estree2)) {
      return true;
    }
    if (type === "TemplateLiteral" && expression.expressions.length === 0) {
      return true;
    }
    if (isPossiblyLiteralEnum(expression)) {
      return true;
    }
    return false;
  }
  function isNumber(expression, estree2) {
    if (estree2) {
      return expression.type === "Literal" && (typeof expression.value === "number" || ("bigint" in expression));
    }
    return expression.type === "NumericLiteral" || expression.type === "BigIntLiteral";
  }
  function isNegativeNumber(expression, estree2) {
    if (expression.type === "UnaryExpression") {
      const {
        operator,
        argument
      } = expression;
      if (operator === "-" && isNumber(argument, estree2)) {
        return true;
      }
    }
    return false;
  }
  function isUncomputedMemberExpressionChain(expression) {
    if (expression.type === "Identifier")
      return true;
    if (expression.type !== "MemberExpression" || expression.computed) {
      return false;
    }
    return isUncomputedMemberExpressionChain(expression.object);
  }
  var PlaceholderErrors = ParseErrorEnum`placeholders`({
    ClassNameIsRequired: "A class name is required.",
    UnexpectedSpace: "Unexpected space in placeholder."
  });
  var placeholders = (superClass) => class PlaceholdersParserMixin extends superClass {
    parsePlaceholder(expectedNode) {
      if (this.match(144)) {
        const node = this.startNode();
        this.next();
        this.assertNoSpace();
        node.name = super.parseIdentifier(true);
        this.assertNoSpace();
        this.expect(144);
        return this.finishPlaceholder(node, expectedNode);
      }
    }
    finishPlaceholder(node, expectedNode) {
      let placeholder = node;
      if (!placeholder.expectedNode || !placeholder.type) {
        placeholder = this.finishNode(placeholder, "Placeholder");
      }
      placeholder.expectedNode = expectedNode;
      return placeholder;
    }
    getTokenFromCode(code2) {
      if (code2 === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
        this.finishOp(144, 2);
      } else {
        super.getTokenFromCode(code2);
      }
    }
    parseExprAtom(refExpressionErrors) {
      return this.parsePlaceholder("Expression") || super.parseExprAtom(refExpressionErrors);
    }
    parseIdentifier(liberal) {
      return this.parsePlaceholder("Identifier") || super.parseIdentifier(liberal);
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (word !== undefined) {
        super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
      }
    }
    parseBindingAtom() {
      return this.parsePlaceholder("Pattern") || super.parseBindingAtom();
    }
    isValidLVal(type, isParenthesized, binding) {
      return type === "Placeholder" || super.isValidLVal(type, isParenthesized, binding);
    }
    toAssignable(node, isLHS) {
      if (node && node.type === "Placeholder" && node.expectedNode === "Expression") {
        node.expectedNode = "Pattern";
      } else {
        super.toAssignable(node, isLHS);
      }
    }
    chStartsBindingIdentifier(ch, pos) {
      if (super.chStartsBindingIdentifier(ch, pos)) {
        return true;
      }
      const nextToken = this.lookahead();
      if (nextToken.type === 144) {
        return true;
      }
      return false;
    }
    verifyBreakContinue(node, isBreak) {
      if (node.label && node.label.type === "Placeholder")
        return;
      super.verifyBreakContinue(node, isBreak);
    }
    parseExpressionStatement(node, expr) {
      var _expr$extra;
      if (expr.type !== "Placeholder" || (_expr$extra = expr.extra) != null && _expr$extra.parenthesized) {
        return super.parseExpressionStatement(node, expr);
      }
      if (this.match(14)) {
        const stmt = node;
        stmt.label = this.finishPlaceholder(expr, "Identifier");
        this.next();
        stmt.body = super.parseStatementOrSloppyAnnexBFunctionDeclaration();
        return this.finishNode(stmt, "LabeledStatement");
      }
      this.semicolon();
      const stmtPlaceholder = node;
      stmtPlaceholder.name = expr.name;
      return this.finishPlaceholder(stmtPlaceholder, "Statement");
    }
    parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
      return this.parsePlaceholder("BlockStatement") || super.parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse);
    }
    parseFunctionId(requireId) {
      return this.parsePlaceholder("Identifier") || super.parseFunctionId(requireId);
    }
    parseClass(node, isStatement, optionalId) {
      const type = isStatement ? "ClassDeclaration" : "ClassExpression";
      this.next();
      const oldStrict = this.state.strict;
      const placeholder = this.parsePlaceholder("Identifier");
      if (placeholder) {
        if (this.match(81) || this.match(144) || this.match(5)) {
          node.id = placeholder;
        } else if (optionalId || !isStatement) {
          node.id = null;
          node.body = this.finishPlaceholder(placeholder, "ClassBody");
          return this.finishNode(node, type);
        } else {
          throw this.raise(PlaceholderErrors.ClassNameIsRequired, this.state.startLoc);
        }
      } else {
        this.parseClassId(node, isStatement, optionalId);
      }
      super.parseClassSuper(node);
      node.body = this.parsePlaceholder("ClassBody") || super.parseClassBody(!!node.superClass, oldStrict);
      return this.finishNode(node, type);
    }
    parseExport(node, decorators) {
      const placeholder = this.parsePlaceholder("Identifier");
      if (!placeholder)
        return super.parseExport(node, decorators);
      const node2 = node;
      if (!this.isContextual(98) && !this.match(12)) {
        node2.specifiers = [];
        node2.source = null;
        node2.declaration = this.finishPlaceholder(placeholder, "Declaration");
        return this.finishNode(node2, "ExportNamedDeclaration");
      }
      this.expectPlugin("exportDefaultFrom");
      const specifier = this.startNode();
      specifier.exported = placeholder;
      node2.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
      return super.parseExport(node2, decorators);
    }
    isExportDefaultSpecifier() {
      if (this.match(65)) {
        const next = this.nextTokenStart();
        if (this.isUnparsedContextual(next, "from")) {
          if (this.input.startsWith(tokenLabelName(144), this.nextTokenStartSince(next + 4))) {
            return true;
          }
        }
      }
      return super.isExportDefaultSpecifier();
    }
    maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
      var _specifiers;
      if ((_specifiers = node.specifiers) != null && _specifiers.length) {
        return true;
      }
      return super.maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier);
    }
    checkExport(node) {
      const {
        specifiers
      } = node;
      if (specifiers != null && specifiers.length) {
        node.specifiers = specifiers.filter((node2) => node2.exported.type === "Placeholder");
      }
      super.checkExport(node);
      node.specifiers = specifiers;
    }
    parseImport(node) {
      const placeholder = this.parsePlaceholder("Identifier");
      if (!placeholder)
        return super.parseImport(node);
      node.specifiers = [];
      if (!this.isContextual(98) && !this.match(12)) {
        node.source = this.finishPlaceholder(placeholder, "StringLiteral");
        this.semicolon();
        return this.finishNode(node, "ImportDeclaration");
      }
      const specifier = this.startNodeAtNode(placeholder);
      specifier.local = placeholder;
      node.specifiers.push(this.finishNode(specifier, "ImportDefaultSpecifier"));
      if (this.eat(12)) {
        const hasStarImport = this.maybeParseStarImportSpecifier(node);
        if (!hasStarImport)
          this.parseNamedImportSpecifiers(node);
      }
      this.expectContextual(98);
      node.source = this.parseImportSource();
      this.semicolon();
      return this.finishNode(node, "ImportDeclaration");
    }
    parseImportSource() {
      return this.parsePlaceholder("StringLiteral") || super.parseImportSource();
    }
    assertNoSpace() {
      if (this.state.start > this.state.lastTokEndLoc.index) {
        this.raise(PlaceholderErrors.UnexpectedSpace, this.state.lastTokEndLoc);
      }
    }
  };
  var v8intrinsic = (superClass) => class V8IntrinsicMixin extends superClass {
    parseV8Intrinsic() {
      if (this.match(54)) {
        const v8IntrinsicStartLoc = this.state.startLoc;
        const node = this.startNode();
        this.next();
        if (tokenIsIdentifier(this.state.type)) {
          const name = this.parseIdentifierName();
          const identifier = this.createIdentifier(node, name);
          identifier.type = "V8IntrinsicIdentifier";
          if (this.match(10)) {
            return identifier;
          }
        }
        this.unexpected(v8IntrinsicStartLoc);
      }
    }
    parseExprAtom(refExpressionErrors) {
      return this.parseV8Intrinsic() || super.parseExprAtom(refExpressionErrors);
    }
  };
  var PIPELINE_PROPOSALS = ["minimal", "fsharp", "hack", "smart"];
  var TOPIC_TOKENS = ["^^", "@@", "^", "%", "#"];
  function validatePlugins(pluginsMap) {
    if (pluginsMap.has("decorators")) {
      if (pluginsMap.has("decorators-legacy")) {
        throw new Error("Cannot use the decorators and decorators-legacy plugin together");
      }
      const decoratorsBeforeExport = pluginsMap.get("decorators").decoratorsBeforeExport;
      if (decoratorsBeforeExport != null && typeof decoratorsBeforeExport !== "boolean") {
        throw new Error("'decoratorsBeforeExport' must be a boolean, if specified.");
      }
      const allowCallParenthesized = pluginsMap.get("decorators").allowCallParenthesized;
      if (allowCallParenthesized != null && typeof allowCallParenthesized !== "boolean") {
        throw new Error("'allowCallParenthesized' must be a boolean.");
      }
    }
    if (pluginsMap.has("flow") && pluginsMap.has("typescript")) {
      throw new Error("Cannot combine flow and typescript plugins.");
    }
    if (pluginsMap.has("placeholders") && pluginsMap.has("v8intrinsic")) {
      throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
    }
    if (pluginsMap.has("pipelineOperator")) {
      var _pluginsMap$get;
      const proposal = pluginsMap.get("pipelineOperator").proposal;
      if (!PIPELINE_PROPOSALS.includes(proposal)) {
        const proposalList = PIPELINE_PROPOSALS.map((p32) => `"${p32}"`).join(", ");
        throw new Error(`"pipelineOperator" requires "proposal" option whose value must be one of: ${proposalList}.`);
      }
      const tupleSyntaxIsHash = ((_pluginsMap$get = pluginsMap.get("recordAndTuple")) == null ? undefined : _pluginsMap$get.syntaxType) === "hash";
      if (proposal === "hack") {
        if (pluginsMap.has("placeholders")) {
          throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
        }
        if (pluginsMap.has("v8intrinsic")) {
          throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
        }
        const topicToken = pluginsMap.get("pipelineOperator").topicToken;
        if (!TOPIC_TOKENS.includes(topicToken)) {
          const tokenList = TOPIC_TOKENS.map((t) => `"${t}"`).join(", ");
          throw new Error(`"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ${tokenList}.`);
        }
        if (topicToken === "#" && tupleSyntaxIsHash) {
          throw new Error(`Plugin conflict between \`["pipelineOperator", { proposal: "hack", topicToken: "#" }]\` and \`${JSON.stringify(["recordAndTuple", pluginsMap.get("recordAndTuple")])}\`.`);
        }
      } else if (proposal === "smart" && tupleSyntaxIsHash) {
        throw new Error(`Plugin conflict between \`["pipelineOperator", { proposal: "smart" }]\` and \`${JSON.stringify(["recordAndTuple", pluginsMap.get("recordAndTuple")])}\`.`);
      }
    }
    if (pluginsMap.has("moduleAttributes")) {
      {
        if (pluginsMap.has("importAttributes") || pluginsMap.has("importAssertions")) {
          throw new Error("Cannot combine importAssertions, importAttributes and moduleAttributes plugins.");
        }
        const moduleAttributesVersionPluginOption = pluginsMap.get("moduleAttributes").version;
        if (moduleAttributesVersionPluginOption !== "may-2020") {
          throw new Error("The 'moduleAttributes' plugin requires a 'version' option, representing the last proposal update. Currently, the only supported value is 'may-2020'.");
        }
      }
    }
    if (pluginsMap.has("importAssertions")) {
      if (pluginsMap.has("importAttributes")) {
        throw new Error("Cannot combine importAssertions and importAttributes plugins.");
      }
    }
    if (pluginsMap.has("recordAndTuple")) {
      const syntaxType = pluginsMap.get("recordAndTuple").syntaxType;
      if (syntaxType != null) {
        {
          const RECORD_AND_TUPLE_SYNTAX_TYPES = ["hash", "bar"];
          if (!RECORD_AND_TUPLE_SYNTAX_TYPES.includes(syntaxType)) {
            throw new Error("The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " + RECORD_AND_TUPLE_SYNTAX_TYPES.map((p32) => `'${p32}'`).join(", "));
          }
        }
      }
    }
    if (pluginsMap.has("asyncDoExpressions") && !pluginsMap.has("doExpressions")) {
      const error = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
      error.missingPlugins = "doExpressions";
      throw error;
    }
    if (pluginsMap.has("optionalChainingAssign") && pluginsMap.get("optionalChainingAssign").version !== "2023-07") {
      throw new Error("The 'optionalChainingAssign' plugin requires a 'version' option, representing the last proposal update. Currently, the only supported value is '2023-07'.");
    }
  }
  var mixinPlugins = {
    estree,
    jsx,
    flow,
    typescript,
    v8intrinsic,
    placeholders
  };
  var mixinPluginNames = Object.keys(mixinPlugins);
  function createDefaultOptions() {
    return {
      sourceType: "script",
      sourceFilename: undefined,
      startColumn: 0,
      startLine: 1,
      allowAwaitOutsideFunction: false,
      allowReturnOutsideFunction: false,
      allowNewTargetOutsideFunction: false,
      allowImportExportEverywhere: false,
      allowSuperOutsideMethod: false,
      allowUndeclaredExports: false,
      plugins: [],
      strictMode: null,
      ranges: false,
      tokens: false,
      createImportExpressions: false,
      createParenthesizedExpressions: false,
      errorRecovery: false,
      attachComment: true,
      annexB: true
    };
  }
  function getOptions(opts) {
    const options3 = createDefaultOptions();
    if (opts == null) {
      return options3;
    }
    if (opts.annexB != null && opts.annexB !== false) {
      throw new Error("The `annexB` option can only be set to `false`.");
    }
    for (const key of Object.keys(options3)) {
      if (opts[key] != null)
        options3[key] = opts[key];
    }
    return options3;
  }

  class ExpressionParser extends LValParser {
    checkProto(prop, isRecord, protoRef, refExpressionErrors) {
      if (prop.type === "SpreadElement" || this.isObjectMethod(prop) || prop.computed || prop.shorthand) {
        return;
      }
      const key = prop.key;
      const name = key.type === "Identifier" ? key.name : key.value;
      if (name === "__proto__") {
        if (isRecord) {
          this.raise(Errors.RecordNoProto, key);
          return;
        }
        if (protoRef.used) {
          if (refExpressionErrors) {
            if (refExpressionErrors.doubleProtoLoc === null) {
              refExpressionErrors.doubleProtoLoc = key.loc.start;
            }
          } else {
            this.raise(Errors.DuplicateProto, key);
          }
        }
        protoRef.used = true;
      }
    }
    shouldExitDescending(expr, potentialArrowAt) {
      return expr.type === "ArrowFunctionExpression" && expr.start === potentialArrowAt;
    }
    getExpression() {
      this.enterInitialScopes();
      this.nextToken();
      const expr = this.parseExpression();
      if (!this.match(139)) {
        this.unexpected();
      }
      this.finalizeRemainingComments();
      expr.comments = this.comments;
      expr.errors = this.state.errors;
      if (this.options.tokens) {
        expr.tokens = this.tokens;
      }
      return expr;
    }
    parseExpression(disallowIn, refExpressionErrors) {
      if (disallowIn) {
        return this.disallowInAnd(() => this.parseExpressionBase(refExpressionErrors));
      }
      return this.allowInAnd(() => this.parseExpressionBase(refExpressionErrors));
    }
    parseExpressionBase(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const expr = this.parseMaybeAssign(refExpressionErrors);
      if (this.match(12)) {
        const node = this.startNodeAt(startLoc);
        node.expressions = [expr];
        while (this.eat(12)) {
          node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
        }
        this.toReferencedList(node.expressions);
        return this.finishNode(node, "SequenceExpression");
      }
      return expr;
    }
    parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
      return this.disallowInAnd(() => this.parseMaybeAssign(refExpressionErrors, afterLeftParse));
    }
    parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
      return this.allowInAnd(() => this.parseMaybeAssign(refExpressionErrors, afterLeftParse));
    }
    setOptionalParametersError(refExpressionErrors, resultError) {
      var _resultError$loc;
      refExpressionErrors.optionalParametersLoc = (_resultError$loc = resultError == null ? undefined : resultError.loc) != null ? _resultError$loc : this.state.startLoc;
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      const startLoc = this.state.startLoc;
      if (this.isContextual(108)) {
        if (this.prodParam.hasYield) {
          let left2 = this.parseYield();
          if (afterLeftParse) {
            left2 = afterLeftParse.call(this, left2, startLoc);
          }
          return left2;
        }
      }
      let ownExpressionErrors;
      if (refExpressionErrors) {
        ownExpressionErrors = false;
      } else {
        refExpressionErrors = new ExpressionErrors;
        ownExpressionErrors = true;
      }
      const {
        type
      } = this.state;
      if (type === 10 || tokenIsIdentifier(type)) {
        this.state.potentialArrowAt = this.state.start;
      }
      let left = this.parseMaybeConditional(refExpressionErrors);
      if (afterLeftParse) {
        left = afterLeftParse.call(this, left, startLoc);
      }
      if (tokenIsAssignment(this.state.type)) {
        const node = this.startNodeAt(startLoc);
        const operator = this.state.value;
        node.operator = operator;
        if (this.match(29)) {
          this.toAssignable(left, true);
          node.left = left;
          const startIndex = startLoc.index;
          if (refExpressionErrors.doubleProtoLoc != null && refExpressionErrors.doubleProtoLoc.index >= startIndex) {
            refExpressionErrors.doubleProtoLoc = null;
          }
          if (refExpressionErrors.shorthandAssignLoc != null && refExpressionErrors.shorthandAssignLoc.index >= startIndex) {
            refExpressionErrors.shorthandAssignLoc = null;
          }
          if (refExpressionErrors.privateKeyLoc != null && refExpressionErrors.privateKeyLoc.index >= startIndex) {
            this.checkDestructuringPrivate(refExpressionErrors);
            refExpressionErrors.privateKeyLoc = null;
          }
        } else {
          node.left = left;
        }
        this.next();
        node.right = this.parseMaybeAssign();
        this.checkLVal(left, this.finishNode(node, "AssignmentExpression"));
        return node;
      } else if (ownExpressionErrors) {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      return left;
    }
    parseMaybeConditional(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprOps(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseConditional(expr, startLoc, refExpressionErrors);
    }
    parseConditional(expr, startLoc, refExpressionErrors) {
      if (this.eat(17)) {
        const node = this.startNodeAt(startLoc);
        node.test = expr;
        node.consequent = this.parseMaybeAssignAllowIn();
        this.expect(14);
        node.alternate = this.parseMaybeAssign();
        return this.finishNode(node, "ConditionalExpression");
      }
      return expr;
    }
    parseMaybeUnaryOrPrivate(refExpressionErrors) {
      return this.match(138) ? this.parsePrivateName() : this.parseMaybeUnary(refExpressionErrors);
    }
    parseExprOps(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseExprOp(expr, startLoc, -1);
    }
    parseExprOp(left, leftStartLoc, minPrec) {
      if (this.isPrivateName(left)) {
        const value = this.getPrivateNameSV(left);
        if (minPrec >= tokenOperatorPrecedence(58) || !this.prodParam.hasIn || !this.match(58)) {
          this.raise(Errors.PrivateInExpectedIn, left, {
            identifierName: value
          });
        }
        this.classScope.usePrivateName(value, left.loc.start);
      }
      const op = this.state.type;
      if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
        let prec = tokenOperatorPrecedence(op);
        if (prec > minPrec) {
          if (op === 39) {
            this.expectPlugin("pipelineOperator");
            if (this.state.inFSharpPipelineDirectBody) {
              return left;
            }
            this.checkPipelineAtInfixOperator(left, leftStartLoc);
          }
          const node = this.startNodeAt(leftStartLoc);
          node.left = left;
          node.operator = this.state.value;
          const logical = op === 41 || op === 42;
          const coalesce = op === 40;
          if (coalesce) {
            prec = tokenOperatorPrecedence(42);
          }
          this.next();
          if (op === 39 && this.hasPlugin(["pipelineOperator", {
            proposal: "minimal"
          }])) {
            if (this.state.type === 96 && this.prodParam.hasAwait) {
              throw this.raise(Errors.UnexpectedAwaitAfterPipelineBody, this.state.startLoc);
            }
          }
          node.right = this.parseExprOpRightExpr(op, prec);
          const finishedNode = this.finishNode(node, logical || coalesce ? "LogicalExpression" : "BinaryExpression");
          const nextOp = this.state.type;
          if (coalesce && (nextOp === 41 || nextOp === 42) || logical && nextOp === 40) {
            throw this.raise(Errors.MixingCoalesceWithLogical, this.state.startLoc);
          }
          return this.parseExprOp(finishedNode, leftStartLoc, minPrec);
        }
      }
      return left;
    }
    parseExprOpRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      switch (op) {
        case 39:
          switch (this.getPluginOption("pipelineOperator", "proposal")) {
            case "hack":
              return this.withTopicBindingContext(() => {
                return this.parseHackPipeBody();
              });
            case "smart":
              return this.withTopicBindingContext(() => {
                if (this.prodParam.hasYield && this.isContextual(108)) {
                  throw this.raise(Errors.PipeBodyIsTighter, this.state.startLoc);
                }
                return this.parseSmartPipelineBodyInStyle(this.parseExprOpBaseRightExpr(op, prec), startLoc);
              });
            case "fsharp":
              return this.withSoloAwaitPermittingContext(() => {
                return this.parseFSharpPipelineBody(prec);
              });
          }
        default:
          return this.parseExprOpBaseRightExpr(op, prec);
      }
    }
    parseExprOpBaseRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, tokenIsRightAssociative(op) ? prec - 1 : prec);
    }
    parseHackPipeBody() {
      var _body$extra;
      const {
        startLoc
      } = this.state;
      const body = this.parseMaybeAssign();
      const requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(body.type);
      if (requiredParentheses && !((_body$extra = body.extra) != null && _body$extra.parenthesized)) {
        this.raise(Errors.PipeUnparenthesizedBody, startLoc, {
          type: body.type
        });
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipeTopicUnused, startLoc);
      }
      return body;
    }
    checkExponentialAfterUnary(node) {
      if (this.match(57)) {
        this.raise(Errors.UnexpectedTokenUnaryExponentiation, node.argument);
      }
    }
    parseMaybeUnary(refExpressionErrors, sawUnary) {
      const startLoc = this.state.startLoc;
      const isAwait = this.isContextual(96);
      if (isAwait && this.recordAwaitIfAllowed()) {
        this.next();
        const expr2 = this.parseAwait(startLoc);
        if (!sawUnary)
          this.checkExponentialAfterUnary(expr2);
        return expr2;
      }
      const update = this.match(34);
      const node = this.startNode();
      if (tokenIsPrefix(this.state.type)) {
        node.operator = this.state.value;
        node.prefix = true;
        if (this.match(72)) {
          this.expectPlugin("throwExpressions");
        }
        const isDelete = this.match(89);
        this.next();
        node.argument = this.parseMaybeUnary(null, true);
        this.checkExpressionErrors(refExpressionErrors, true);
        if (this.state.strict && isDelete) {
          const arg = node.argument;
          if (arg.type === "Identifier") {
            this.raise(Errors.StrictDelete, node);
          } else if (this.hasPropertyAsPrivateName(arg)) {
            this.raise(Errors.DeletePrivateField, node);
          }
        }
        if (!update) {
          if (!sawUnary) {
            this.checkExponentialAfterUnary(node);
          }
          return this.finishNode(node, "UnaryExpression");
        }
      }
      const expr = this.parseUpdate(node, update, refExpressionErrors);
      if (isAwait) {
        const {
          type
        } = this.state;
        const startsExpr2 = this.hasPlugin("v8intrinsic") ? tokenCanStartExpression(type) : tokenCanStartExpression(type) && !this.match(54);
        if (startsExpr2 && !this.isAmbiguousAwait()) {
          this.raiseOverwrite(Errors.AwaitNotInAsyncContext, startLoc);
          return this.parseAwait(startLoc);
        }
      }
      return expr;
    }
    parseUpdate(node, update, refExpressionErrors) {
      if (update) {
        const updateExpressionNode = node;
        this.checkLVal(updateExpressionNode.argument, this.finishNode(updateExpressionNode, "UpdateExpression"));
        return node;
      }
      const startLoc = this.state.startLoc;
      let expr = this.parseExprSubscripts(refExpressionErrors);
      if (this.checkExpressionErrors(refExpressionErrors, false))
        return expr;
      while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
        const node2 = this.startNodeAt(startLoc);
        node2.operator = this.state.value;
        node2.prefix = false;
        node2.argument = expr;
        this.next();
        this.checkLVal(expr, expr = this.finishNode(node2, "UpdateExpression"));
      }
      return expr;
    }
    parseExprSubscripts(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprAtom(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseSubscripts(expr, startLoc);
    }
    parseSubscripts(base, startLoc, noCalls) {
      const state = {
        optionalChainMember: false,
        maybeAsyncArrow: this.atPossibleAsyncArrow(base),
        stop: false
      };
      do {
        base = this.parseSubscript(base, startLoc, noCalls, state);
        state.maybeAsyncArrow = false;
      } while (!state.stop);
      return base;
    }
    parseSubscript(base, startLoc, noCalls, state) {
      const {
        type
      } = this.state;
      if (!noCalls && type === 15) {
        return this.parseBind(base, startLoc, noCalls, state);
      } else if (tokenIsTemplate(type)) {
        return this.parseTaggedTemplateExpression(base, startLoc, state);
      }
      let optional = false;
      if (type === 18) {
        if (noCalls) {
          this.raise(Errors.OptionalChainingNoNew, this.state.startLoc);
          if (this.lookaheadCharCode() === 40) {
            state.stop = true;
            return base;
          }
        }
        state.optionalChainMember = optional = true;
        this.next();
      }
      if (!noCalls && this.match(10)) {
        return this.parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional);
      } else {
        const computed = this.eat(0);
        if (computed || optional || this.eat(16)) {
          return this.parseMember(base, startLoc, state, computed, optional);
        } else {
          state.stop = true;
          return base;
        }
      }
    }
    parseMember(base, startLoc, state, computed, optional) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      node.computed = computed;
      if (computed) {
        node.property = this.parseExpression();
        this.expect(3);
      } else if (this.match(138)) {
        if (base.type === "Super") {
          this.raise(Errors.SuperPrivateField, startLoc);
        }
        this.classScope.usePrivateName(this.state.value, this.state.startLoc);
        node.property = this.parsePrivateName();
      } else {
        node.property = this.parseIdentifier(true);
      }
      if (state.optionalChainMember) {
        node.optional = optional;
        return this.finishNode(node, "OptionalMemberExpression");
      } else {
        return this.finishNode(node, "MemberExpression");
      }
    }
    parseBind(base, startLoc, noCalls, state) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      this.next();
      node.callee = this.parseNoCallExpr();
      state.stop = true;
      return this.parseSubscripts(this.finishNode(node, "BindExpression"), startLoc, noCalls);
    }
    parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional) {
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      let refExpressionErrors = null;
      this.state.maybeInArrowParameters = true;
      this.next();
      const node = this.startNodeAt(startLoc);
      node.callee = base;
      const {
        maybeAsyncArrow,
        optionalChainMember
      } = state;
      if (maybeAsyncArrow) {
        this.expressionScope.enter(newAsyncArrowScope());
        refExpressionErrors = new ExpressionErrors;
      }
      if (optionalChainMember) {
        node.optional = optional;
      }
      if (optional) {
        node.arguments = this.parseCallExpressionArguments(11);
      } else {
        node.arguments = this.parseCallExpressionArguments(11, base.type === "Import", base.type !== "Super", node, refExpressionErrors);
      }
      let finishedNode = this.finishCallExpression(node, optionalChainMember);
      if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
        state.stop = true;
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        finishedNode = this.parseAsyncArrowFromCallExpression(this.startNodeAt(startLoc), finishedNode);
      } else {
        if (maybeAsyncArrow) {
          this.checkExpressionErrors(refExpressionErrors, true);
          this.expressionScope.exit();
        }
        this.toReferencedArguments(finishedNode);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return finishedNode;
    }
    toReferencedArguments(node, isParenthesizedExpr) {
      this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
    }
    parseTaggedTemplateExpression(base, startLoc, state) {
      const node = this.startNodeAt(startLoc);
      node.tag = base;
      node.quasi = this.parseTemplate(true);
      if (state.optionalChainMember) {
        this.raise(Errors.OptionalChainingNoTemplate, startLoc);
      }
      return this.finishNode(node, "TaggedTemplateExpression");
    }
    atPossibleAsyncArrow(base) {
      return base.type === "Identifier" && base.name === "async" && this.state.lastTokEndLoc.index === base.end && !this.canInsertSemicolon() && base.end - base.start === 5 && base.start === this.state.potentialArrowAt;
    }
    finishCallExpression(node, optional) {
      if (node.callee.type === "Import") {
        if (node.arguments.length === 2) {
          if (!(this.hasPlugin("moduleAttributes") || this.hasPlugin("importAssertions"))) {
            this.expectPlugin("importAttributes");
          }
        }
        if (node.arguments.length === 0 || node.arguments.length > 2) {
          this.raise(Errors.ImportCallArity, node, {
            maxArgumentCount: this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? 2 : 1
          });
        } else {
          for (const arg of node.arguments) {
            if (arg.type === "SpreadElement") {
              this.raise(Errors.ImportCallSpreadArgument, arg);
            }
          }
        }
      }
      return this.finishNode(node, optional ? "OptionalCallExpression" : "CallExpression");
    }
    parseCallExpressionArguments(close, dynamicImport, allowPlaceholder, nodeForExtra, refExpressionErrors) {
      const elts = [];
      let first = true;
      const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (dynamicImport && !this.hasPlugin("importAttributes") && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes")) {
              this.raise(Errors.ImportCallArgumentTrailingComma, this.state.lastTokStartLoc);
            }
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(this.parseExprListItem(false, refExpressionErrors, allowPlaceholder));
      }
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return elts;
    }
    shouldParseAsyncArrow() {
      return this.match(19) && !this.canInsertSemicolon();
    }
    parseAsyncArrowFromCallExpression(node, call) {
      var _call$extra;
      this.resetPreviousNodeTrailingComments(call);
      this.expect(19);
      this.parseArrowExpression(node, call.arguments, true, (_call$extra = call.extra) == null ? undefined : _call$extra.trailingCommaLoc);
      if (call.innerComments) {
        setInnerComments(node, call.innerComments);
      }
      if (call.callee.trailingComments) {
        setInnerComments(node, call.callee.trailingComments);
      }
      return node;
    }
    parseNoCallExpr() {
      const startLoc = this.state.startLoc;
      return this.parseSubscripts(this.parseExprAtom(), startLoc, true);
    }
    parseExprAtom(refExpressionErrors) {
      let node;
      let decorators = null;
      const {
        type
      } = this.state;
      switch (type) {
        case 79:
          return this.parseSuper();
        case 83:
          node = this.startNode();
          this.next();
          if (this.match(16)) {
            return this.parseImportMetaProperty(node);
          }
          if (this.match(10)) {
            if (this.options.createImportExpressions) {
              return this.parseImportCall(node);
            } else {
              return this.finishNode(node, "Import");
            }
          } else {
            this.raise(Errors.UnsupportedImport, this.state.lastTokStartLoc);
            return this.finishNode(node, "Import");
          }
        case 78:
          node = this.startNode();
          this.next();
          return this.finishNode(node, "ThisExpression");
        case 90: {
          return this.parseDo(this.startNode(), false);
        }
        case 56:
        case 31: {
          this.readRegexp();
          return this.parseRegExpLiteral(this.state.value);
        }
        case 134:
          return this.parseNumericLiteral(this.state.value);
        case 135:
          return this.parseBigIntLiteral(this.state.value);
        case 133:
          return this.parseStringLiteral(this.state.value);
        case 84:
          return this.parseNullLiteral();
        case 85:
          return this.parseBooleanLiteral(true);
        case 86:
          return this.parseBooleanLiteral(false);
        case 10: {
          const canBeArrow = this.state.potentialArrowAt === this.state.start;
          return this.parseParenAndDistinguishExpression(canBeArrow);
        }
        case 2:
        case 1: {
          return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
        }
        case 0: {
          return this.parseArrayLike(3, true, false, refExpressionErrors);
        }
        case 6:
        case 7: {
          return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
        }
        case 5: {
          return this.parseObjectLike(8, false, false, refExpressionErrors);
        }
        case 68:
          return this.parseFunctionOrFunctionSent();
        case 26:
          decorators = this.parseDecorators();
        case 80:
          return this.parseClass(this.maybeTakeDecorators(decorators, this.startNode()), false);
        case 77:
          return this.parseNewOrNewTarget();
        case 25:
        case 24:
          return this.parseTemplate(false);
        case 15: {
          node = this.startNode();
          this.next();
          node.object = null;
          const callee = node.callee = this.parseNoCallExpr();
          if (callee.type === "MemberExpression") {
            return this.finishNode(node, "BindExpression");
          } else {
            throw this.raise(Errors.UnsupportedBind, callee);
          }
        }
        case 138: {
          this.raise(Errors.PrivateInExpectedIn, this.state.startLoc, {
            identifierName: this.state.value
          });
          return this.parsePrivateName();
        }
        case 33: {
          return this.parseTopicReferenceThenEqualsSign(54, "%");
        }
        case 32: {
          return this.parseTopicReferenceThenEqualsSign(44, "^");
        }
        case 37:
        case 38: {
          return this.parseTopicReference("hack");
        }
        case 44:
        case 54:
        case 27: {
          const pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
          if (pipeProposal) {
            return this.parseTopicReference(pipeProposal);
          }
          this.unexpected();
          break;
        }
        case 47: {
          const lookaheadCh = this.input.codePointAt(this.nextTokenStart());
          if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
            this.expectOnePlugin(["jsx", "flow", "typescript"]);
          } else {
            this.unexpected();
          }
          break;
        }
        default:
          if (type === 136) {
            return this.parseDecimalLiteral(this.state.value);
          }
          if (tokenIsIdentifier(type)) {
            if (this.isContextual(127) && this.lookaheadInLineCharCode() === 123) {
              return this.parseModuleExpression();
            }
            const canBeArrow = this.state.potentialArrowAt === this.state.start;
            const containsEsc = this.state.containsEsc;
            const id = this.parseIdentifier();
            if (!containsEsc && id.name === "async" && !this.canInsertSemicolon()) {
              const {
                type: type2
              } = this.state;
              if (type2 === 68) {
                this.resetPreviousNodeTrailingComments(id);
                this.next();
                return this.parseAsyncFunctionExpression(this.startNodeAtNode(id));
              } else if (tokenIsIdentifier(type2)) {
                if (this.lookaheadCharCode() === 61) {
                  return this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(id));
                } else {
                  return id;
                }
              } else if (type2 === 90) {
                this.resetPreviousNodeTrailingComments(id);
                return this.parseDo(this.startNodeAtNode(id), true);
              }
            }
            if (canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
              this.next();
              return this.parseArrowExpression(this.startNodeAtNode(id), [id], false);
            }
            return id;
          } else {
            this.unexpected();
          }
      }
    }
    parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
      const pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
      if (pipeProposal) {
        this.state.type = topicTokenType;
        this.state.value = topicTokenValue;
        this.state.pos--;
        this.state.end--;
        this.state.endLoc = createPositionWithColumnOffset(this.state.endLoc, -1);
        return this.parseTopicReference(pipeProposal);
      } else {
        this.unexpected();
      }
    }
    parseTopicReference(pipeProposal) {
      const node = this.startNode();
      const startLoc = this.state.startLoc;
      const tokenType = this.state.type;
      this.next();
      return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
    }
    finishTopicReference(node, startLoc, pipeProposal, tokenType) {
      if (this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)) {
        const nodeType = pipeProposal === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";
        if (!this.topicReferenceIsAllowedInCurrentContext()) {
          this.raise(pipeProposal === "smart" ? Errors.PrimaryTopicNotAllowed : Errors.PipeTopicUnbound, startLoc);
        }
        this.registerTopicReference();
        return this.finishNode(node, nodeType);
      } else {
        throw this.raise(Errors.PipeTopicUnconfiguredToken, startLoc, {
          token: tokenLabelName(tokenType)
        });
      }
    }
    testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
      switch (pipeProposal) {
        case "hack": {
          return this.hasPlugin(["pipelineOperator", {
            topicToken: tokenLabelName(tokenType)
          }]);
        }
        case "smart":
          return tokenType === 27;
        default:
          throw this.raise(Errors.PipeTopicRequiresHackPipes, startLoc);
      }
    }
    parseAsyncArrowUnaryFunction(node) {
      this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
      const params = [this.parseIdentifier()];
      this.prodParam.exit();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.LineTerminatorBeforeArrow, this.state.curPosition());
      }
      this.expect(19);
      return this.parseArrowExpression(node, params, true);
    }
    parseDo(node, isAsync) {
      this.expectPlugin("doExpressions");
      if (isAsync) {
        this.expectPlugin("asyncDoExpressions");
      }
      node.async = isAsync;
      this.next();
      const oldLabels = this.state.labels;
      this.state.labels = [];
      if (isAsync) {
        this.prodParam.enter(2);
        node.body = this.parseBlock();
        this.prodParam.exit();
      } else {
        node.body = this.parseBlock();
      }
      this.state.labels = oldLabels;
      return this.finishNode(node, "DoExpression");
    }
    parseSuper() {
      const node = this.startNode();
      this.next();
      if (this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod) {
        this.raise(Errors.SuperNotAllowed, node);
      } else if (!this.scope.allowSuper && !this.options.allowSuperOutsideMethod) {
        this.raise(Errors.UnexpectedSuper, node);
      }
      if (!this.match(10) && !this.match(0) && !this.match(16)) {
        this.raise(Errors.UnsupportedSuper, node);
      }
      return this.finishNode(node, "Super");
    }
    parsePrivateName() {
      const node = this.startNode();
      const id = this.startNodeAt(createPositionWithColumnOffset(this.state.startLoc, 1));
      const name = this.state.value;
      this.next();
      node.id = this.createIdentifier(id, name);
      return this.finishNode(node, "PrivateName");
    }
    parseFunctionOrFunctionSent() {
      const node = this.startNode();
      this.next();
      if (this.prodParam.hasYield && this.match(16)) {
        const meta = this.createIdentifier(this.startNodeAtNode(node), "function");
        this.next();
        if (this.match(103)) {
          this.expectPlugin("functionSent");
        } else if (!this.hasPlugin("functionSent")) {
          this.unexpected();
        }
        return this.parseMetaProperty(node, meta, "sent");
      }
      return this.parseFunction(node);
    }
    parseMetaProperty(node, meta, propertyName) {
      node.meta = meta;
      const containsEsc = this.state.containsEsc;
      node.property = this.parseIdentifier(true);
      if (node.property.name !== propertyName || containsEsc) {
        this.raise(Errors.UnsupportedMetaProperty, node.property, {
          target: meta.name,
          onlyValidPropertyName: propertyName
        });
      }
      return this.finishNode(node, "MetaProperty");
    }
    parseImportMetaProperty(node) {
      const id = this.createIdentifier(this.startNodeAtNode(node), "import");
      this.next();
      if (this.isContextual(101)) {
        if (!this.inModule) {
          this.raise(Errors.ImportMetaOutsideModule, id);
        }
        this.sawUnambiguousESM = true;
      } else if (this.isContextual(105) || this.isContextual(97)) {
        const isSource = this.isContextual(105);
        if (!isSource)
          this.unexpected();
        this.expectPlugin(isSource ? "sourcePhaseImports" : "deferredImportEvaluation");
        if (!this.options.createImportExpressions) {
          throw this.raise(Errors.DynamicImportPhaseRequiresImportExpressions, this.state.startLoc, {
            phase: this.state.value
          });
        }
        this.next();
        node.phase = isSource ? "source" : "defer";
        return this.parseImportCall(node);
      }
      return this.parseMetaProperty(node, id, "meta");
    }
    parseLiteralAtNode(value, type, node) {
      this.addExtra(node, "rawValue", value);
      this.addExtra(node, "raw", this.input.slice(node.start, this.state.end));
      node.value = value;
      this.next();
      return this.finishNode(node, type);
    }
    parseLiteral(value, type) {
      const node = this.startNode();
      return this.parseLiteralAtNode(value, type, node);
    }
    parseStringLiteral(value) {
      return this.parseLiteral(value, "StringLiteral");
    }
    parseNumericLiteral(value) {
      return this.parseLiteral(value, "NumericLiteral");
    }
    parseBigIntLiteral(value) {
      return this.parseLiteral(value, "BigIntLiteral");
    }
    parseDecimalLiteral(value) {
      return this.parseLiteral(value, "DecimalLiteral");
    }
    parseRegExpLiteral(value) {
      const node = this.startNode();
      this.addExtra(node, "raw", this.input.slice(node.start, this.state.end));
      node.pattern = value.pattern;
      node.flags = value.flags;
      this.next();
      return this.finishNode(node, "RegExpLiteral");
    }
    parseBooleanLiteral(value) {
      const node = this.startNode();
      node.value = value;
      this.next();
      return this.finishNode(node, "BooleanLiteral");
    }
    parseNullLiteral() {
      const node = this.startNode();
      this.next();
      return this.finishNode(node, "NullLiteral");
    }
    parseParenAndDistinguishExpression(canBeArrow) {
      const startLoc = this.state.startLoc;
      let val2;
      this.next();
      this.expressionScope.enter(newArrowHeadScope());
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
      this.state.maybeInArrowParameters = true;
      this.state.inFSharpPipelineDirectBody = false;
      const innerStartLoc = this.state.startLoc;
      const exprList = [];
      const refExpressionErrors = new ExpressionErrors;
      let first = true;
      let spreadStartLoc;
      let optionalCommaStartLoc;
      while (!this.match(11)) {
        if (first) {
          first = false;
        } else {
          this.expect(12, refExpressionErrors.optionalParametersLoc === null ? null : refExpressionErrors.optionalParametersLoc);
          if (this.match(11)) {
            optionalCommaStartLoc = this.state.startLoc;
            break;
          }
        }
        if (this.match(21)) {
          const spreadNodeStartLoc = this.state.startLoc;
          spreadStartLoc = this.state.startLoc;
          exprList.push(this.parseParenItem(this.parseRestBinding(), spreadNodeStartLoc));
          if (!this.checkCommaAfterRest(41)) {
            break;
          }
        } else {
          exprList.push(this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem));
        }
      }
      const innerEndLoc = this.state.lastTokEndLoc;
      this.expect(11);
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let arrowNode = this.startNodeAt(startLoc);
      if (canBeArrow && this.shouldParseArrow(exprList) && (arrowNode = this.parseArrow(arrowNode))) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        this.parseArrowExpression(arrowNode, exprList, false);
        return arrowNode;
      }
      this.expressionScope.exit();
      if (!exprList.length) {
        this.unexpected(this.state.lastTokStartLoc);
      }
      if (optionalCommaStartLoc)
        this.unexpected(optionalCommaStartLoc);
      if (spreadStartLoc)
        this.unexpected(spreadStartLoc);
      this.checkExpressionErrors(refExpressionErrors, true);
      this.toReferencedListDeep(exprList, true);
      if (exprList.length > 1) {
        val2 = this.startNodeAt(innerStartLoc);
        val2.expressions = exprList;
        this.finishNode(val2, "SequenceExpression");
        this.resetEndLocation(val2, innerEndLoc);
      } else {
        val2 = exprList[0];
      }
      return this.wrapParenthesis(startLoc, val2);
    }
    wrapParenthesis(startLoc, expression) {
      if (!this.options.createParenthesizedExpressions) {
        this.addExtra(expression, "parenthesized", true);
        this.addExtra(expression, "parenStart", startLoc.index);
        this.takeSurroundingComments(expression, startLoc.index, this.state.lastTokEndLoc.index);
        return expression;
      }
      const parenExpression = this.startNodeAt(startLoc);
      parenExpression.expression = expression;
      return this.finishNode(parenExpression, "ParenthesizedExpression");
    }
    shouldParseArrow(params) {
      return !this.canInsertSemicolon();
    }
    parseArrow(node) {
      if (this.eat(19)) {
        return node;
      }
    }
    parseParenItem(node, startLoc) {
      return node;
    }
    parseNewOrNewTarget() {
      const node = this.startNode();
      this.next();
      if (this.match(16)) {
        const meta = this.createIdentifier(this.startNodeAtNode(node), "new");
        this.next();
        const metaProp = this.parseMetaProperty(node, meta, "target");
        if (!this.scope.inNonArrowFunction && !this.scope.inClass && !this.options.allowNewTargetOutsideFunction) {
          this.raise(Errors.UnexpectedNewTarget, metaProp);
        }
        return metaProp;
      }
      return this.parseNew(node);
    }
    parseNew(node) {
      this.parseNewCallee(node);
      if (this.eat(10)) {
        const args = this.parseExprList(11);
        this.toReferencedList(args);
        node.arguments = args;
      } else {
        node.arguments = [];
      }
      return this.finishNode(node, "NewExpression");
    }
    parseNewCallee(node) {
      const isImport = this.match(83);
      const callee = this.parseNoCallExpr();
      node.callee = callee;
      if (isImport && (callee.type === "Import" || callee.type === "ImportExpression")) {
        this.raise(Errors.ImportCallNotNewExpression, callee);
      }
    }
    parseTemplateElement(isTagged) {
      const {
        start,
        startLoc,
        end,
        value
      } = this.state;
      const elemStart = start + 1;
      const elem = this.startNodeAt(createPositionWithColumnOffset(startLoc, 1));
      if (value === null) {
        if (!isTagged) {
          this.raise(Errors.InvalidEscapeSequenceTemplate, createPositionWithColumnOffset(this.state.firstInvalidTemplateEscapePos, 1));
        }
      }
      const isTail = this.match(24);
      const endOffset = isTail ? -1 : -2;
      const elemEnd = end + endOffset;
      elem.value = {
        raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, "\n"),
        cooked: value === null ? null : value.slice(1, endOffset)
      };
      elem.tail = isTail;
      this.next();
      const finishedNode = this.finishNode(elem, "TemplateElement");
      this.resetEndLocation(finishedNode, createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset));
      return finishedNode;
    }
    parseTemplate(isTagged) {
      const node = this.startNode();
      let curElt = this.parseTemplateElement(isTagged);
      const quasis = [curElt];
      const substitutions = [];
      while (!curElt.tail) {
        substitutions.push(this.parseTemplateSubstitution());
        this.readTemplateContinuation();
        quasis.push(curElt = this.parseTemplateElement(isTagged));
      }
      node.expressions = substitutions;
      node.quasis = quasis;
      return this.finishNode(node, "TemplateLiteral");
    }
    parseTemplateSubstitution() {
      return this.parseExpression();
    }
    parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
      if (isRecord) {
        this.expectPlugin("recordAndTuple");
      }
      const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const propHash = Object.create(null);
      let first = true;
      const node = this.startNode();
      node.properties = [];
      this.next();
      while (!this.match(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            this.addTrailingCommaExtraToNode(node);
            break;
          }
        }
        let prop;
        if (isPattern) {
          prop = this.parseBindingProperty();
        } else {
          prop = this.parsePropertyDefinition(refExpressionErrors);
          this.checkProto(prop, isRecord, propHash, refExpressionErrors);
        }
        if (isRecord && !this.isObjectProperty(prop) && prop.type !== "SpreadElement") {
          this.raise(Errors.InvalidRecordProperty, prop);
        }
        {
          if (prop.shorthand) {
            this.addExtra(prop, "shorthand", true);
          }
        }
        node.properties.push(prop);
      }
      this.next();
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let type = "ObjectExpression";
      if (isPattern) {
        type = "ObjectPattern";
      } else if (isRecord) {
        type = "RecordExpression";
      }
      return this.finishNode(node, type);
    }
    addTrailingCommaExtraToNode(node) {
      this.addExtra(node, "trailingComma", this.state.lastTokStartLoc.index);
      this.addExtra(node, "trailingCommaLoc", this.state.lastTokStartLoc, false);
    }
    maybeAsyncOrAccessorProp(prop) {
      return !prop.computed && prop.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
    }
    parsePropertyDefinition(refExpressionErrors) {
      let decorators = [];
      if (this.match(26)) {
        if (this.hasPlugin("decorators")) {
          this.raise(Errors.UnsupportedPropertyDecorator, this.state.startLoc);
        }
        while (this.match(26)) {
          decorators.push(this.parseDecorator());
        }
      }
      const prop = this.startNode();
      let isAsync = false;
      let isAccessor = false;
      let startLoc;
      if (this.match(21)) {
        if (decorators.length)
          this.unexpected();
        return this.parseSpread();
      }
      if (decorators.length) {
        prop.decorators = decorators;
        decorators = [];
      }
      prop.method = false;
      if (refExpressionErrors) {
        startLoc = this.state.startLoc;
      }
      let isGenerator = this.eat(55);
      this.parsePropertyNamePrefixOperator(prop);
      const containsEsc = this.state.containsEsc;
      this.parsePropertyName(prop, refExpressionErrors);
      if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
        const {
          key
        } = prop;
        const keyName = key.name;
        if (keyName === "async" && !this.hasPrecedingLineBreak()) {
          isAsync = true;
          this.resetPreviousNodeTrailingComments(key);
          isGenerator = this.eat(55);
          this.parsePropertyName(prop);
        }
        if (keyName === "get" || keyName === "set") {
          isAccessor = true;
          this.resetPreviousNodeTrailingComments(key);
          prop.kind = keyName;
          if (this.match(55)) {
            isGenerator = true;
            this.raise(Errors.AccessorIsGenerator, this.state.curPosition(), {
              kind: keyName
            });
            this.next();
          }
          this.parsePropertyName(prop);
        }
      }
      return this.parseObjPropValue(prop, startLoc, isGenerator, isAsync, false, isAccessor, refExpressionErrors);
    }
    getGetterSetterExpectedParamCount(method) {
      return method.kind === "get" ? 0 : 1;
    }
    getObjectOrClassMethodParams(method) {
      return method.params;
    }
    checkGetterSetterParams(method) {
      var _params;
      const paramCount = this.getGetterSetterExpectedParamCount(method);
      const params = this.getObjectOrClassMethodParams(method);
      if (params.length !== paramCount) {
        this.raise(method.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, method);
      }
      if (method.kind === "set" && ((_params = params[params.length - 1]) == null ? undefined : _params.type) === "RestElement") {
        this.raise(Errors.BadSetterRestParameter, method);
      }
    }
    parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
      if (isAccessor) {
        const finishedProp = this.parseMethod(prop, isGenerator, false, false, false, "ObjectMethod");
        this.checkGetterSetterParams(finishedProp);
        return finishedProp;
      }
      if (isAsync || isGenerator || this.match(10)) {
        if (isPattern)
          this.unexpected();
        prop.kind = "method";
        prop.method = true;
        return this.parseMethod(prop, isGenerator, isAsync, false, false, "ObjectMethod");
      }
    }
    parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
      prop.shorthand = false;
      if (this.eat(14)) {
        prop.value = isPattern ? this.parseMaybeDefault(this.state.startLoc) : this.parseMaybeAssignAllowIn(refExpressionErrors);
        return this.finishNode(prop, "ObjectProperty");
      }
      if (!prop.computed && prop.key.type === "Identifier") {
        this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
        if (isPattern) {
          prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
        } else if (this.match(29)) {
          const shorthandAssignLoc = this.state.startLoc;
          if (refExpressionErrors != null) {
            if (refExpressionErrors.shorthandAssignLoc === null) {
              refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
            }
          } else {
            this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
          }
          prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
        } else {
          prop.value = cloneIdentifier(prop.key);
        }
        prop.shorthand = true;
        return this.finishNode(prop, "ObjectProperty");
      }
    }
    parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
      const node = this.parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) || this.parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors);
      if (!node)
        this.unexpected();
      return node;
    }
    parsePropertyName(prop, refExpressionErrors) {
      if (this.eat(0)) {
        prop.computed = true;
        prop.key = this.parseMaybeAssignAllowIn();
        this.expect(3);
      } else {
        const {
          type,
          value
        } = this.state;
        let key;
        if (tokenIsKeywordOrIdentifier(type)) {
          key = this.parseIdentifier(true);
        } else {
          switch (type) {
            case 134:
              key = this.parseNumericLiteral(value);
              break;
            case 133:
              key = this.parseStringLiteral(value);
              break;
            case 135:
              key = this.parseBigIntLiteral(value);
              break;
            case 138: {
              const privateKeyLoc = this.state.startLoc;
              if (refExpressionErrors != null) {
                if (refExpressionErrors.privateKeyLoc === null) {
                  refExpressionErrors.privateKeyLoc = privateKeyLoc;
                }
              } else {
                this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
              }
              key = this.parsePrivateName();
              break;
            }
            default:
              if (type === 136) {
                key = this.parseDecimalLiteral(value);
                break;
              }
              this.unexpected();
          }
        }
        prop.key = key;
        if (type !== 138) {
          prop.computed = false;
        }
      }
    }
    initFunction(node, isAsync) {
      node.id = null;
      node.generator = false;
      node.async = isAsync;
    }
    parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope = false) {
      this.initFunction(node, isAsync);
      node.generator = isGenerator;
      this.scope.enter(18 | (inClassScope ? 64 : 0) | (allowDirectSuper ? 32 : 0));
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      this.parseFunctionParams(node, isConstructor);
      const finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
      this.prodParam.exit();
      this.scope.exit();
      return finishedNode;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      if (isTuple) {
        this.expectPlugin("recordAndTuple");
      }
      const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const node = this.startNode();
      this.next();
      node.elements = this.parseExprList(close, !isTuple, refExpressionErrors, node);
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return this.finishNode(node, isTuple ? "TupleExpression" : "ArrayExpression");
    }
    parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
      this.scope.enter(6);
      let flags = functionFlags(isAsync, false);
      if (!this.match(5) && this.prodParam.hasIn) {
        flags |= 8;
      }
      this.prodParam.enter(flags);
      this.initFunction(node, isAsync);
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      if (params) {
        this.state.maybeInArrowParameters = true;
        this.setArrowFunctionParameters(node, params, trailingCommaLoc);
      }
      this.state.maybeInArrowParameters = false;
      this.parseFunctionBody(node, true);
      this.prodParam.exit();
      this.scope.exit();
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return this.finishNode(node, "ArrowFunctionExpression");
    }
    setArrowFunctionParameters(node, params, trailingCommaLoc) {
      this.toAssignableList(params, trailingCommaLoc, false);
      node.params = params;
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      this.parseFunctionBody(node, false, isMethod);
      return this.finishNode(node, type);
    }
    parseFunctionBody(node, allowExpression, isMethod = false) {
      const isExpression = allowExpression && !this.match(5);
      this.expressionScope.enter(newExpressionScope());
      if (isExpression) {
        node.body = this.parseMaybeAssign();
        this.checkParams(node, false, allowExpression, false);
      } else {
        const oldStrict = this.state.strict;
        const oldLabels = this.state.labels;
        this.state.labels = [];
        this.prodParam.enter(this.prodParam.currentFlags() | 4);
        node.body = this.parseBlock(true, false, (hasStrictModeDirective) => {
          const nonSimple = !this.isSimpleParamList(node.params);
          if (hasStrictModeDirective && nonSimple) {
            this.raise(Errors.IllegalLanguageModeDirective, (node.kind === "method" || node.kind === "constructor") && !!node.key ? node.key.loc.end : node);
          }
          const strictModeChanged = !oldStrict && this.state.strict;
          this.checkParams(node, !this.state.strict && !allowExpression && !isMethod && !nonSimple, allowExpression, strictModeChanged);
          if (this.state.strict && node.id) {
            this.checkIdentifier(node.id, 65, strictModeChanged);
          }
        });
        this.prodParam.exit();
        this.state.labels = oldLabels;
      }
      this.expressionScope.exit();
    }
    isSimpleParameter(node) {
      return node.type === "Identifier";
    }
    isSimpleParamList(params) {
      for (let i = 0, len = params.length;i < len; i++) {
        if (!this.isSimpleParameter(params[i]))
          return false;
      }
      return true;
    }
    checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged = true) {
      const checkClashes = !allowDuplicates && new Set;
      const formalParameters = {
        type: "FormalParameters"
      };
      for (const param of node.params) {
        this.checkLVal(param, formalParameters, 5, checkClashes, strictModeChanged);
      }
    }
    parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
      }
      return elts;
    }
    parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
      let elt;
      if (this.match(12)) {
        if (!allowEmpty) {
          this.raise(Errors.UnexpectedToken, this.state.curPosition(), {
            unexpected: ","
          });
        }
        elt = null;
      } else if (this.match(21)) {
        const spreadNodeStartLoc = this.state.startLoc;
        elt = this.parseParenItem(this.parseSpread(refExpressionErrors), spreadNodeStartLoc);
      } else if (this.match(17)) {
        this.expectPlugin("partialApplication");
        if (!allowPlaceholder) {
          this.raise(Errors.UnexpectedArgumentPlaceholder, this.state.startLoc);
        }
        const node = this.startNode();
        this.next();
        elt = this.finishNode(node, "ArgumentPlaceholder");
      } else {
        elt = this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem);
      }
      return elt;
    }
    parseIdentifier(liberal) {
      const node = this.startNode();
      const name = this.parseIdentifierName(liberal);
      return this.createIdentifier(node, name);
    }
    createIdentifier(node, name) {
      node.name = name;
      node.loc.identifierName = name;
      return this.finishNode(node, "Identifier");
    }
    parseIdentifierName(liberal) {
      let name;
      const {
        startLoc,
        type
      } = this.state;
      if (tokenIsKeywordOrIdentifier(type)) {
        name = this.state.value;
      } else {
        this.unexpected();
      }
      const tokenIsKeyword2 = tokenKeywordOrIdentifierIsKeyword(type);
      if (liberal) {
        if (tokenIsKeyword2) {
          this.replaceToken(132);
        }
      } else {
        this.checkReservedWord(name, startLoc, tokenIsKeyword2, false);
      }
      this.next();
      return name;
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (word.length > 10) {
        return;
      }
      if (!canBeReservedWord(word)) {
        return;
      }
      if (checkKeywords && isKeyword(word)) {
        this.raise(Errors.UnexpectedKeyword, startLoc, {
          keyword: word
        });
        return;
      }
      const reservedTest = !this.state.strict ? isReservedWord : isBinding ? isStrictBindReservedWord : isStrictReservedWord;
      if (reservedTest(word, this.inModule)) {
        this.raise(Errors.UnexpectedReservedWord, startLoc, {
          reservedWord: word
        });
        return;
      } else if (word === "yield") {
        if (this.prodParam.hasYield) {
          this.raise(Errors.YieldBindingIdentifier, startLoc);
          return;
        }
      } else if (word === "await") {
        if (this.prodParam.hasAwait) {
          this.raise(Errors.AwaitBindingIdentifier, startLoc);
          return;
        }
        if (this.scope.inStaticBlock) {
          this.raise(Errors.AwaitBindingIdentifierInStaticBlock, startLoc);
          return;
        }
        this.expressionScope.recordAsyncArrowParametersError(startLoc);
      } else if (word === "arguments") {
        if (this.scope.inClassAndNotInNonArrowFunction) {
          this.raise(Errors.ArgumentsInClass, startLoc);
          return;
        }
      }
    }
    recordAwaitIfAllowed() {
      const isAwaitAllowed = this.prodParam.hasAwait || this.options.allowAwaitOutsideFunction && !this.scope.inFunction;
      if (isAwaitAllowed && !this.scope.inFunction) {
        this.state.hasTopLevelAwait = true;
      }
      return isAwaitAllowed;
    }
    parseAwait(startLoc) {
      const node = this.startNodeAt(startLoc);
      this.expressionScope.recordParameterInitializerError(Errors.AwaitExpressionFormalParameter, node);
      if (this.eat(55)) {
        this.raise(Errors.ObsoleteAwaitStar, node);
      }
      if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
        if (this.isAmbiguousAwait()) {
          this.ambiguousScriptDifferentAst = true;
        } else {
          this.sawUnambiguousESM = true;
        }
      }
      if (!this.state.soloAwait) {
        node.argument = this.parseMaybeUnary(null, true);
      }
      return this.finishNode(node, "AwaitExpression");
    }
    isAmbiguousAwait() {
      if (this.hasPrecedingLineBreak())
        return true;
      const {
        type
      } = this.state;
      return type === 53 || type === 10 || type === 0 || tokenIsTemplate(type) || type === 102 && !this.state.containsEsc || type === 137 || type === 56 || this.hasPlugin("v8intrinsic") && type === 54;
    }
    parseYield() {
      const node = this.startNode();
      this.expressionScope.recordParameterInitializerError(Errors.YieldInParameter, node);
      this.next();
      let delegating = false;
      let argument = null;
      if (!this.hasPrecedingLineBreak()) {
        delegating = this.eat(55);
        switch (this.state.type) {
          case 13:
          case 139:
          case 8:
          case 11:
          case 3:
          case 9:
          case 14:
          case 12:
            if (!delegating)
              break;
          default:
            argument = this.parseMaybeAssign();
        }
      }
      node.delegate = delegating;
      node.argument = argument;
      return this.finishNode(node, "YieldExpression");
    }
    parseImportCall(node) {
      this.next();
      node.source = this.parseMaybeAssignAllowIn();
      if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
        node.options = null;
      }
      if (this.eat(12)) {
        if (!(this.hasPlugin("moduleAttributes") || this.hasPlugin("importAssertions"))) {
          this.expectPlugin("importAttributes");
        }
        if (!this.match(11)) {
          node.options = this.parseMaybeAssignAllowIn();
          this.eat(12);
        }
      }
      this.expect(11);
      return this.finishNode(node, "ImportExpression");
    }
    checkPipelineAtInfixOperator(left, leftStartLoc) {
      if (this.hasPlugin(["pipelineOperator", {
        proposal: "smart"
      }])) {
        if (left.type === "SequenceExpression") {
          this.raise(Errors.PipelineHeadSequenceExpression, leftStartLoc);
        }
      }
    }
    parseSmartPipelineBodyInStyle(childExpr, startLoc) {
      if (this.isSimpleReference(childExpr)) {
        const bodyNode = this.startNodeAt(startLoc);
        bodyNode.callee = childExpr;
        return this.finishNode(bodyNode, "PipelineBareFunction");
      } else {
        const bodyNode = this.startNodeAt(startLoc);
        this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
        bodyNode.expression = childExpr;
        return this.finishNode(bodyNode, "PipelineTopicExpression");
      }
    }
    isSimpleReference(expression) {
      switch (expression.type) {
        case "MemberExpression":
          return !expression.computed && this.isSimpleReference(expression.object);
        case "Identifier":
          return true;
        default:
          return false;
      }
    }
    checkSmartPipeTopicBodyEarlyErrors(startLoc) {
      if (this.match(19)) {
        throw this.raise(Errors.PipelineBodyNoArrow, this.state.startLoc);
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipelineTopicUnused, startLoc);
      }
    }
    withTopicBindingContext(callback) {
      const outerContextTopicState = this.state.topicContext;
      this.state.topicContext = {
        maxNumOfResolvableTopics: 1,
        maxTopicIndex: null
      };
      try {
        return callback();
      } finally {
        this.state.topicContext = outerContextTopicState;
      }
    }
    withSmartMixTopicForbiddingContext(callback) {
      if (this.hasPlugin(["pipelineOperator", {
        proposal: "smart"
      }])) {
        const outerContextTopicState = this.state.topicContext;
        this.state.topicContext = {
          maxNumOfResolvableTopics: 0,
          maxTopicIndex: null
        };
        try {
          return callback();
        } finally {
          this.state.topicContext = outerContextTopicState;
        }
      } else {
        return callback();
      }
    }
    withSoloAwaitPermittingContext(callback) {
      const outerContextSoloAwaitState = this.state.soloAwait;
      this.state.soloAwait = true;
      try {
        return callback();
      } finally {
        this.state.soloAwait = outerContextSoloAwaitState;
      }
    }
    allowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToSet = 8 & ~flags;
      if (prodParamToSet) {
        this.prodParam.enter(flags | 8);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    disallowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToClear = 8 & flags;
      if (prodParamToClear) {
        this.prodParam.enter(flags & -9);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    registerTopicReference() {
      this.state.topicContext.maxTopicIndex = 0;
    }
    topicReferenceIsAllowedInCurrentContext() {
      return this.state.topicContext.maxNumOfResolvableTopics >= 1;
    }
    topicReferenceWasUsedInCurrentContext() {
      return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
    }
    parseFSharpPipelineBody(prec) {
      const startLoc = this.state.startLoc;
      this.state.potentialArrowAt = this.state.start;
      const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = true;
      const ret = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, prec);
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return ret;
    }
    parseModuleExpression() {
      this.expectPlugin("moduleBlocks");
      const node = this.startNode();
      this.next();
      if (!this.match(5)) {
        this.unexpected(null, 5);
      }
      const program = this.startNodeAt(this.state.endLoc);
      this.next();
      const revertScopes = this.initializeScopes(true);
      this.enterInitialScopes();
      try {
        node.body = this.parseProgram(program, 8, "module");
      } finally {
        revertScopes();
      }
      return this.finishNode(node, "ModuleExpression");
    }
    parsePropertyNamePrefixOperator(prop) {
    }
  }
  var loopLabel = {
    kind: 1
  };
  var switchLabel = {
    kind: 2
  };
  var loneSurrogate = /[\uD800-\uDFFF]/u;
  var keywordRelationalOperator = /in(?:stanceof)?/y;
  function babel7CompatTokens(tokens, input) {
    for (let i = 0;i < tokens.length; i++) {
      const token = tokens[i];
      const {
        type
      } = token;
      if (typeof type === "number") {
        {
          if (type === 138) {
            const {
              loc,
              start,
              value,
              end
            } = token;
            const hashEndPos = start + 1;
            const hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
            tokens.splice(i, 1, new Token({
              type: getExportedToken(27),
              value: "#",
              start,
              end: hashEndPos,
              startLoc: loc.start,
              endLoc: hashEndLoc
            }), new Token({
              type: getExportedToken(132),
              value,
              start: hashEndPos,
              end,
              startLoc: hashEndLoc,
              endLoc: loc.end
            }));
            i++;
            continue;
          }
          if (tokenIsTemplate(type)) {
            const {
              loc,
              start,
              value,
              end
            } = token;
            const backquoteEnd = start + 1;
            const backquoteEndLoc = createPositionWithColumnOffset(loc.start, 1);
            let startToken;
            if (input.charCodeAt(start) === 96) {
              startToken = new Token({
                type: getExportedToken(22),
                value: "`",
                start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc
              });
            } else {
              startToken = new Token({
                type: getExportedToken(8),
                value: "}",
                start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc
              });
            }
            let templateValue, templateElementEnd, templateElementEndLoc, endToken;
            if (type === 24) {
              templateElementEnd = end - 1;
              templateElementEndLoc = createPositionWithColumnOffset(loc.end, -1);
              templateValue = value === null ? null : value.slice(1, -1);
              endToken = new Token({
                type: getExportedToken(22),
                value: "`",
                start: templateElementEnd,
                end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end
              });
            } else {
              templateElementEnd = end - 2;
              templateElementEndLoc = createPositionWithColumnOffset(loc.end, -2);
              templateValue = value === null ? null : value.slice(1, -2);
              endToken = new Token({
                type: getExportedToken(23),
                value: "${",
                start: templateElementEnd,
                end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end
              });
            }
            tokens.splice(i, 1, startToken, new Token({
              type: getExportedToken(20),
              value: templateValue,
              start: backquoteEnd,
              end: templateElementEnd,
              startLoc: backquoteEndLoc,
              endLoc: templateElementEndLoc
            }), endToken);
            i += 2;
            continue;
          }
        }
        token.type = getExportedToken(type);
      }
    }
    return tokens;
  }

  class StatementParser extends ExpressionParser {
    parseTopLevel(file, program) {
      file.program = this.parseProgram(program);
      file.comments = this.comments;
      if (this.options.tokens) {
        file.tokens = babel7CompatTokens(this.tokens, this.input);
      }
      return this.finishNode(file, "File");
    }
    parseProgram(program, end = 139, sourceType = this.options.sourceType) {
      program.sourceType = sourceType;
      program.interpreter = this.parseInterpreterDirective();
      this.parseBlockBody(program, true, true, end);
      if (this.inModule) {
        if (!this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0) {
          for (const [localName, at] of Array.from(this.scope.undefinedExports)) {
            this.raise(Errors.ModuleExportUndefined, at, {
              localName
            });
          }
        }
        this.addExtra(program, "topLevelAwait", this.state.hasTopLevelAwait);
      }
      let finishedProgram;
      if (end === 139) {
        finishedProgram = this.finishNode(program, "Program");
      } else {
        finishedProgram = this.finishNodeAt(program, "Program", createPositionWithColumnOffset(this.state.startLoc, -1));
      }
      return finishedProgram;
    }
    stmtToDirective(stmt) {
      const directive = stmt;
      directive.type = "Directive";
      directive.value = directive.expression;
      delete directive.expression;
      const directiveLiteral = directive.value;
      const expressionValue = directiveLiteral.value;
      const raw = this.input.slice(directiveLiteral.start, directiveLiteral.end);
      const val2 = directiveLiteral.value = raw.slice(1, -1);
      this.addExtra(directiveLiteral, "raw", raw);
      this.addExtra(directiveLiteral, "rawValue", val2);
      this.addExtra(directiveLiteral, "expressionValue", expressionValue);
      directiveLiteral.type = "DirectiveLiteral";
      return directive;
    }
    parseInterpreterDirective() {
      if (!this.match(28)) {
        return null;
      }
      const node = this.startNode();
      node.value = this.state.value;
      this.next();
      return this.finishNode(node, "InterpreterDirective");
    }
    isLet() {
      if (!this.isContextual(100)) {
        return false;
      }
      return this.hasFollowingBindingAtom();
    }
    chStartsBindingIdentifier(ch, pos) {
      if (isIdentifierStart(ch)) {
        keywordRelationalOperator.lastIndex = pos;
        if (keywordRelationalOperator.test(this.input)) {
          const endCh = this.codePointAtPos(keywordRelationalOperator.lastIndex);
          if (!isIdentifierChar(endCh) && endCh !== 92) {
            return false;
          }
        }
        return true;
      } else if (ch === 92) {
        return true;
      } else {
        return false;
      }
    }
    chStartsBindingPattern(ch) {
      return ch === 91 || ch === 123;
    }
    hasFollowingBindingAtom() {
      const next = this.nextTokenStart();
      const nextCh = this.codePointAtPos(next);
      return this.chStartsBindingPattern(nextCh) || this.chStartsBindingIdentifier(nextCh, next);
    }
    hasInLineFollowingBindingIdentifierOrBrace() {
      const next = this.nextTokenInLineStart();
      const nextCh = this.codePointAtPos(next);
      return nextCh === 123 || this.chStartsBindingIdentifier(nextCh, next);
    }
    startsUsingForOf() {
      const {
        type,
        containsEsc
      } = this.lookahead();
      if (type === 102 && !containsEsc) {
        return false;
      } else if (tokenIsIdentifier(type) && !this.hasFollowingLineBreak()) {
        this.expectPlugin("explicitResourceManagement");
        return true;
      }
    }
    startsAwaitUsing() {
      let next = this.nextTokenInLineStart();
      if (this.isUnparsedContextual(next, "using")) {
        next = this.nextTokenInLineStartSince(next + 5);
        const nextCh = this.codePointAtPos(next);
        if (this.chStartsBindingIdentifier(nextCh, next)) {
          this.expectPlugin("explicitResourceManagement");
          return true;
        }
      }
      return false;
    }
    parseModuleItem() {
      return this.parseStatementLike(15);
    }
    parseStatementListItem() {
      return this.parseStatementLike(6 | (!this.options.annexB || this.state.strict ? 0 : 8));
    }
    parseStatementOrSloppyAnnexBFunctionDeclaration(allowLabeledFunction = false) {
      let flags = 0;
      if (this.options.annexB && !this.state.strict) {
        flags |= 4;
        if (allowLabeledFunction) {
          flags |= 8;
        }
      }
      return this.parseStatementLike(flags);
    }
    parseStatement() {
      return this.parseStatementLike(0);
    }
    parseStatementLike(flags) {
      let decorators = null;
      if (this.match(26)) {
        decorators = this.parseDecorators(true);
      }
      return this.parseStatementContent(flags, decorators);
    }
    parseStatementContent(flags, decorators) {
      const startType = this.state.type;
      const node = this.startNode();
      const allowDeclaration = !!(flags & 2);
      const allowFunctionDeclaration = !!(flags & 4);
      const topLevel = flags & 1;
      switch (startType) {
        case 60:
          return this.parseBreakContinueStatement(node, true);
        case 63:
          return this.parseBreakContinueStatement(node, false);
        case 64:
          return this.parseDebuggerStatement(node);
        case 90:
          return this.parseDoWhileStatement(node);
        case 91:
          return this.parseForStatement(node);
        case 68:
          if (this.lookaheadCharCode() === 46)
            break;
          if (!allowFunctionDeclaration) {
            this.raise(this.state.strict ? Errors.StrictFunction : this.options.annexB ? Errors.SloppyFunctionAnnexB : Errors.SloppyFunction, this.state.startLoc);
          }
          return this.parseFunctionStatement(node, false, !allowDeclaration && allowFunctionDeclaration);
        case 80:
          if (!allowDeclaration)
            this.unexpected();
          return this.parseClass(this.maybeTakeDecorators(decorators, node), true);
        case 69:
          return this.parseIfStatement(node);
        case 70:
          return this.parseReturnStatement(node);
        case 71:
          return this.parseSwitchStatement(node);
        case 72:
          return this.parseThrowStatement(node);
        case 73:
          return this.parseTryStatement(node);
        case 96:
          if (!this.state.containsEsc && this.startsAwaitUsing()) {
            if (!this.recordAwaitIfAllowed()) {
              this.raise(Errors.AwaitUsingNotInAsyncContext, node);
            } else if (!allowDeclaration) {
              this.raise(Errors.UnexpectedLexicalDeclaration, node);
            }
            this.next();
            return this.parseVarStatement(node, "await using");
          }
          break;
        case 107:
          if (this.state.containsEsc || !this.hasInLineFollowingBindingIdentifierOrBrace()) {
            break;
          }
          this.expectPlugin("explicitResourceManagement");
          if (!this.scope.inModule && this.scope.inTopLevel) {
            this.raise(Errors.UnexpectedUsingDeclaration, this.state.startLoc);
          } else if (!allowDeclaration) {
            this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
          }
          return this.parseVarStatement(node, "using");
        case 100: {
          if (this.state.containsEsc) {
            break;
          }
          const next = this.nextTokenStart();
          const nextCh = this.codePointAtPos(next);
          if (nextCh !== 91) {
            if (!allowDeclaration && this.hasFollowingLineBreak())
              break;
            if (!this.chStartsBindingIdentifier(nextCh, next) && nextCh !== 123) {
              break;
            }
          }
        }
        case 75: {
          if (!allowDeclaration) {
            this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
          }
        }
        case 74: {
          const kind = this.state.value;
          return this.parseVarStatement(node, kind);
        }
        case 92:
          return this.parseWhileStatement(node);
        case 76:
          return this.parseWithStatement(node);
        case 5:
          return this.parseBlock();
        case 13:
          return this.parseEmptyStatement(node);
        case 83: {
          const nextTokenCharCode = this.lookaheadCharCode();
          if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
            break;
          }
        }
        case 82: {
          if (!this.options.allowImportExportEverywhere && !topLevel) {
            this.raise(Errors.UnexpectedImportExport, this.state.startLoc);
          }
          this.next();
          let result2;
          if (startType === 83) {
            result2 = this.parseImport(node);
            if (result2.type === "ImportDeclaration" && (!result2.importKind || result2.importKind === "value")) {
              this.sawUnambiguousESM = true;
            }
          } else {
            result2 = this.parseExport(node, decorators);
            if (result2.type === "ExportNamedDeclaration" && (!result2.exportKind || result2.exportKind === "value") || result2.type === "ExportAllDeclaration" && (!result2.exportKind || result2.exportKind === "value") || result2.type === "ExportDefaultDeclaration") {
              this.sawUnambiguousESM = true;
            }
          }
          this.assertModuleNodeAllowed(result2);
          return result2;
        }
        default: {
          if (this.isAsyncFunction()) {
            if (!allowDeclaration) {
              this.raise(Errors.AsyncFunctionInSingleStatementContext, this.state.startLoc);
            }
            this.next();
            return this.parseFunctionStatement(node, true, !allowDeclaration && allowFunctionDeclaration);
          }
        }
      }
      const maybeName = this.state.value;
      const expr = this.parseExpression();
      if (tokenIsIdentifier(startType) && expr.type === "Identifier" && this.eat(14)) {
        return this.parseLabeledStatement(node, maybeName, expr, flags);
      } else {
        return this.parseExpressionStatement(node, expr, decorators);
      }
    }
    assertModuleNodeAllowed(node) {
      if (!this.options.allowImportExportEverywhere && !this.inModule) {
        this.raise(Errors.ImportOutsideModule, node);
      }
    }
    decoratorsEnabledBeforeExport() {
      if (this.hasPlugin("decorators-legacy"))
        return true;
      return this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") !== false;
    }
    maybeTakeDecorators(maybeDecorators, classNode, exportNode) {
      if (maybeDecorators) {
        if (classNode.decorators && classNode.decorators.length > 0) {
          if (typeof this.getPluginOption("decorators", "decoratorsBeforeExport") !== "boolean") {
            this.raise(Errors.DecoratorsBeforeAfterExport, classNode.decorators[0]);
          }
          classNode.decorators.unshift(...maybeDecorators);
        } else {
          classNode.decorators = maybeDecorators;
        }
        this.resetStartLocationFromNode(classNode, maybeDecorators[0]);
        if (exportNode)
          this.resetStartLocationFromNode(exportNode, classNode);
      }
      return classNode;
    }
    canHaveLeadingDecorator() {
      return this.match(80);
    }
    parseDecorators(allowExport) {
      const decorators = [];
      do {
        decorators.push(this.parseDecorator());
      } while (this.match(26));
      if (this.match(82)) {
        if (!allowExport) {
          this.unexpected();
        }
        if (!this.decoratorsEnabledBeforeExport()) {
          this.raise(Errors.DecoratorExportClass, this.state.startLoc);
        }
      } else if (!this.canHaveLeadingDecorator()) {
        throw this.raise(Errors.UnexpectedLeadingDecorator, this.state.startLoc);
      }
      return decorators;
    }
    parseDecorator() {
      this.expectOnePlugin(["decorators", "decorators-legacy"]);
      const node = this.startNode();
      this.next();
      if (this.hasPlugin("decorators")) {
        const startLoc = this.state.startLoc;
        let expr;
        if (this.match(10)) {
          const startLoc2 = this.state.startLoc;
          this.next();
          expr = this.parseExpression();
          this.expect(11);
          expr = this.wrapParenthesis(startLoc2, expr);
          const paramsStartLoc = this.state.startLoc;
          node.expression = this.parseMaybeDecoratorArguments(expr);
          if (this.getPluginOption("decorators", "allowCallParenthesized") === false && node.expression !== expr) {
            this.raise(Errors.DecoratorArgumentsOutsideParentheses, paramsStartLoc);
          }
        } else {
          expr = this.parseIdentifier(false);
          while (this.eat(16)) {
            const node2 = this.startNodeAt(startLoc);
            node2.object = expr;
            if (this.match(138)) {
              this.classScope.usePrivateName(this.state.value, this.state.startLoc);
              node2.property = this.parsePrivateName();
            } else {
              node2.property = this.parseIdentifier(true);
            }
            node2.computed = false;
            expr = this.finishNode(node2, "MemberExpression");
          }
          node.expression = this.parseMaybeDecoratorArguments(expr);
        }
      } else {
        node.expression = this.parseExprSubscripts();
      }
      return this.finishNode(node, "Decorator");
    }
    parseMaybeDecoratorArguments(expr) {
      if (this.eat(10)) {
        const node = this.startNodeAtNode(expr);
        node.callee = expr;
        node.arguments = this.parseCallExpressionArguments(11, false);
        this.toReferencedList(node.arguments);
        return this.finishNode(node, "CallExpression");
      }
      return expr;
    }
    parseBreakContinueStatement(node, isBreak) {
      this.next();
      if (this.isLineTerminator()) {
        node.label = null;
      } else {
        node.label = this.parseIdentifier();
        this.semicolon();
      }
      this.verifyBreakContinue(node, isBreak);
      return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
    }
    verifyBreakContinue(node, isBreak) {
      let i;
      for (i = 0;i < this.state.labels.length; ++i) {
        const lab = this.state.labels[i];
        if (node.label == null || lab.name === node.label.name) {
          if (lab.kind != null && (isBreak || lab.kind === 1)) {
            break;
          }
          if (node.label && isBreak)
            break;
        }
      }
      if (i === this.state.labels.length) {
        const type = isBreak ? "BreakStatement" : "ContinueStatement";
        this.raise(Errors.IllegalBreakContinue, node, {
          type
        });
      }
    }
    parseDebuggerStatement(node) {
      this.next();
      this.semicolon();
      return this.finishNode(node, "DebuggerStatement");
    }
    parseHeaderExpression() {
      this.expect(10);
      const val2 = this.parseExpression();
      this.expect(11);
      return val2;
    }
    parseDoWhileStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
      this.state.labels.pop();
      this.expect(92);
      node.test = this.parseHeaderExpression();
      this.eat(13);
      return this.finishNode(node, "DoWhileStatement");
    }
    parseForStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      let awaitAt = null;
      if (this.isContextual(96) && this.recordAwaitIfAllowed()) {
        awaitAt = this.state.startLoc;
        this.next();
      }
      this.scope.enter(0);
      this.expect(10);
      if (this.match(13)) {
        if (awaitAt !== null) {
          this.unexpected(awaitAt);
        }
        return this.parseFor(node, null);
      }
      const startsWithLet = this.isContextual(100);
      {
        const startsWithAwaitUsing = this.isContextual(96) && this.startsAwaitUsing();
        const starsWithUsingDeclaration = startsWithAwaitUsing || this.isContextual(107) && this.startsUsingForOf();
        const isLetOrUsing = startsWithLet && this.hasFollowingBindingAtom() || starsWithUsingDeclaration;
        if (this.match(74) || this.match(75) || isLetOrUsing) {
          const initNode = this.startNode();
          let kind;
          if (startsWithAwaitUsing) {
            kind = "await using";
            if (!this.recordAwaitIfAllowed()) {
              this.raise(Errors.AwaitUsingNotInAsyncContext, this.state.startLoc);
            }
            this.next();
          } else {
            kind = this.state.value;
          }
          this.next();
          this.parseVar(initNode, true, kind);
          const init3 = this.finishNode(initNode, "VariableDeclaration");
          const isForIn = this.match(58);
          if (isForIn && starsWithUsingDeclaration) {
            this.raise(Errors.ForInUsing, init3);
          }
          if ((isForIn || this.isContextual(102)) && init3.declarations.length === 1) {
            return this.parseForIn(node, init3, awaitAt);
          }
          if (awaitAt !== null) {
            this.unexpected(awaitAt);
          }
          return this.parseFor(node, init3);
        }
      }
      const startsWithAsync = this.isContextual(95);
      const refExpressionErrors = new ExpressionErrors;
      const init22 = this.parseExpression(true, refExpressionErrors);
      const isForOf = this.isContextual(102);
      if (isForOf) {
        if (startsWithLet) {
          this.raise(Errors.ForOfLet, init22);
        }
        if (awaitAt === null && startsWithAsync && init22.type === "Identifier") {
          this.raise(Errors.ForOfAsync, init22);
        }
      }
      if (isForOf || this.match(58)) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.toAssignable(init22, true);
        const type = isForOf ? "ForOfStatement" : "ForInStatement";
        this.checkLVal(init22, {
          type
        });
        return this.parseForIn(node, init22, awaitAt);
      } else {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      if (awaitAt !== null) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, init22);
    }
    parseFunctionStatement(node, isAsync, isHangingDeclaration) {
      this.next();
      return this.parseFunction(node, 1 | (isHangingDeclaration ? 2 : 0) | (isAsync ? 8 : 0));
    }
    parseIfStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      node.consequent = this.parseStatementOrSloppyAnnexBFunctionDeclaration();
      node.alternate = this.eat(66) ? this.parseStatementOrSloppyAnnexBFunctionDeclaration() : null;
      return this.finishNode(node, "IfStatement");
    }
    parseReturnStatement(node) {
      if (!this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction) {
        this.raise(Errors.IllegalReturn, this.state.startLoc);
      }
      this.next();
      if (this.isLineTerminator()) {
        node.argument = null;
      } else {
        node.argument = this.parseExpression();
        this.semicolon();
      }
      return this.finishNode(node, "ReturnStatement");
    }
    parseSwitchStatement(node) {
      this.next();
      node.discriminant = this.parseHeaderExpression();
      const cases = node.cases = [];
      this.expect(5);
      this.state.labels.push(switchLabel);
      this.scope.enter(0);
      let cur;
      for (let sawDefault;!this.match(8); ) {
        if (this.match(61) || this.match(65)) {
          const isCase = this.match(61);
          if (cur)
            this.finishNode(cur, "SwitchCase");
          cases.push(cur = this.startNode());
          cur.consequent = [];
          this.next();
          if (isCase) {
            cur.test = this.parseExpression();
          } else {
            if (sawDefault) {
              this.raise(Errors.MultipleDefaultsInSwitch, this.state.lastTokStartLoc);
            }
            sawDefault = true;
            cur.test = null;
          }
          this.expect(14);
        } else {
          if (cur) {
            cur.consequent.push(this.parseStatementListItem());
          } else {
            this.unexpected();
          }
        }
      }
      this.scope.exit();
      if (cur)
        this.finishNode(cur, "SwitchCase");
      this.next();
      this.state.labels.pop();
      return this.finishNode(node, "SwitchStatement");
    }
    parseThrowStatement(node) {
      this.next();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.NewlineAfterThrow, this.state.lastTokEndLoc);
      }
      node.argument = this.parseExpression();
      this.semicolon();
      return this.finishNode(node, "ThrowStatement");
    }
    parseCatchClauseParam() {
      const param = this.parseBindingAtom();
      this.scope.enter(this.options.annexB && param.type === "Identifier" ? 8 : 0);
      this.checkLVal(param, {
        type: "CatchClause"
      }, 9);
      return param;
    }
    parseTryStatement(node) {
      this.next();
      node.block = this.parseBlock();
      node.handler = null;
      if (this.match(62)) {
        const clause = this.startNode();
        this.next();
        if (this.match(10)) {
          this.expect(10);
          clause.param = this.parseCatchClauseParam();
          this.expect(11);
        } else {
          clause.param = null;
          this.scope.enter(0);
        }
        clause.body = this.withSmartMixTopicForbiddingContext(() => this.parseBlock(false, false));
        this.scope.exit();
        node.handler = this.finishNode(clause, "CatchClause");
      }
      node.finalizer = this.eat(67) ? this.parseBlock() : null;
      if (!node.handler && !node.finalizer) {
        this.raise(Errors.NoCatchOrFinally, node);
      }
      return this.finishNode(node, "TryStatement");
    }
    parseVarStatement(node, kind, allowMissingInitializer = false) {
      this.next();
      this.parseVar(node, false, kind, allowMissingInitializer);
      this.semicolon();
      return this.finishNode(node, "VariableDeclaration");
    }
    parseWhileStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
      this.state.labels.pop();
      return this.finishNode(node, "WhileStatement");
    }
    parseWithStatement(node) {
      if (this.state.strict) {
        this.raise(Errors.StrictWith, this.state.startLoc);
      }
      this.next();
      node.object = this.parseHeaderExpression();
      node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
      return this.finishNode(node, "WithStatement");
    }
    parseEmptyStatement(node) {
      this.next();
      return this.finishNode(node, "EmptyStatement");
    }
    parseLabeledStatement(node, maybeName, expr, flags) {
      for (const label of this.state.labels) {
        if (label.name === maybeName) {
          this.raise(Errors.LabelRedeclaration, expr, {
            labelName: maybeName
          });
        }
      }
      const kind = tokenIsLoop(this.state.type) ? 1 : this.match(71) ? 2 : null;
      for (let i = this.state.labels.length - 1;i >= 0; i--) {
        const label = this.state.labels[i];
        if (label.statementStart === node.start) {
          label.statementStart = this.state.start;
          label.kind = kind;
        } else {
          break;
        }
      }
      this.state.labels.push({
        name: maybeName,
        kind,
        statementStart: this.state.start
      });
      node.body = flags & 8 ? this.parseStatementOrSloppyAnnexBFunctionDeclaration(true) : this.parseStatement();
      this.state.labels.pop();
      node.label = expr;
      return this.finishNode(node, "LabeledStatement");
    }
    parseExpressionStatement(node, expr, decorators) {
      node.expression = expr;
      this.semicolon();
      return this.finishNode(node, "ExpressionStatement");
    }
    parseBlock(allowDirectives = false, createNewLexicalScope = true, afterBlockParse) {
      const node = this.startNode();
      if (allowDirectives) {
        this.state.strictErrors.clear();
      }
      this.expect(5);
      if (createNewLexicalScope) {
        this.scope.enter(0);
      }
      this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
      if (createNewLexicalScope) {
        this.scope.exit();
      }
      return this.finishNode(node, "BlockStatement");
    }
    isValidDirective(stmt) {
      return stmt.type === "ExpressionStatement" && stmt.expression.type === "StringLiteral" && !stmt.expression.extra.parenthesized;
    }
    parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
      const body = node.body = [];
      const directives = node.directives = [];
      this.parseBlockOrModuleBlockBody(body, allowDirectives ? directives : undefined, topLevel, end, afterBlockParse);
    }
    parseBlockOrModuleBlockBody(body, directives, topLevel, end, afterBlockParse) {
      const oldStrict = this.state.strict;
      let hasStrictModeDirective = false;
      let parsedNonDirective = false;
      while (!this.match(end)) {
        const stmt = topLevel ? this.parseModuleItem() : this.parseStatementListItem();
        if (directives && !parsedNonDirective) {
          if (this.isValidDirective(stmt)) {
            const directive = this.stmtToDirective(stmt);
            directives.push(directive);
            if (!hasStrictModeDirective && directive.value.value === "use strict") {
              hasStrictModeDirective = true;
              this.setStrict(true);
            }
            continue;
          }
          parsedNonDirective = true;
          this.state.strictErrors.clear();
        }
        body.push(stmt);
      }
      afterBlockParse == null || afterBlockParse.call(this, hasStrictModeDirective);
      if (!oldStrict) {
        this.setStrict(false);
      }
      this.next();
    }
    parseFor(node, init22) {
      node.init = init22;
      this.semicolon(false);
      node.test = this.match(13) ? null : this.parseExpression();
      this.semicolon(false);
      node.update = this.match(11) ? null : this.parseExpression();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(node, "ForStatement");
    }
    parseForIn(node, init22, awaitAt) {
      const isForIn = this.match(58);
      this.next();
      if (isForIn) {
        if (awaitAt !== null)
          this.unexpected(awaitAt);
      } else {
        node.await = awaitAt !== null;
      }
      if (init22.type === "VariableDeclaration" && init22.declarations[0].init != null && (!isForIn || !this.options.annexB || this.state.strict || init22.kind !== "var" || init22.declarations[0].id.type !== "Identifier")) {
        this.raise(Errors.ForInOfLoopInitializer, init22, {
          type: isForIn ? "ForInStatement" : "ForOfStatement"
        });
      }
      if (init22.type === "AssignmentPattern") {
        this.raise(Errors.InvalidLhs, init22, {
          ancestor: {
            type: "ForStatement"
          }
        });
      }
      node.left = init22;
      node.right = isForIn ? this.parseExpression() : this.parseMaybeAssignAllowIn();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement");
    }
    parseVar(node, isFor, kind, allowMissingInitializer = false) {
      const declarations = node.declarations = [];
      node.kind = kind;
      for (;; ) {
        const decl = this.startNode();
        this.parseVarId(decl, kind);
        decl.init = !this.eat(29) ? null : isFor ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn();
        if (decl.init === null && !allowMissingInitializer) {
          if (decl.id.type !== "Identifier" && !(isFor && (this.match(58) || this.isContextual(102)))) {
            this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
              kind: "destructuring"
            });
          } else if ((kind === "const" || kind === "using" || kind === "await using") && !(this.match(58) || this.isContextual(102))) {
            this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
              kind
            });
          }
        }
        declarations.push(this.finishNode(decl, "VariableDeclarator"));
        if (!this.eat(12))
          break;
      }
      return node;
    }
    parseVarId(decl, kind) {
      const id = this.parseBindingAtom();
      if (kind === "using" || kind === "await using") {
        if (id.type === "ArrayPattern" || id.type === "ObjectPattern") {
          this.raise(Errors.UsingDeclarationHasBindingPattern, id.loc.start);
        }
      }
      this.checkLVal(id, {
        type: "VariableDeclarator"
      }, kind === "var" ? 5 : 8201);
      decl.id = id;
    }
    parseAsyncFunctionExpression(node) {
      return this.parseFunction(node, 8);
    }
    parseFunction(node, flags = 0) {
      const hangingDeclaration = flags & 2;
      const isDeclaration = !!(flags & 1);
      const requireId = isDeclaration && !(flags & 4);
      const isAsync = !!(flags & 8);
      this.initFunction(node, isAsync);
      if (this.match(55)) {
        if (hangingDeclaration) {
          this.raise(Errors.GeneratorInSingleStatementContext, this.state.startLoc);
        }
        this.next();
        node.generator = true;
      }
      if (isDeclaration) {
        node.id = this.parseFunctionId(requireId);
      }
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      this.state.maybeInArrowParameters = false;
      this.scope.enter(2);
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      if (!isDeclaration) {
        node.id = this.parseFunctionId();
      }
      this.parseFunctionParams(node, false);
      this.withSmartMixTopicForbiddingContext(() => {
        this.parseFunctionBodyAndFinish(node, isDeclaration ? "FunctionDeclaration" : "FunctionExpression");
      });
      this.prodParam.exit();
      this.scope.exit();
      if (isDeclaration && !hangingDeclaration) {
        this.registerFunctionStatementId(node);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return node;
    }
    parseFunctionId(requireId) {
      return requireId || tokenIsIdentifier(this.state.type) ? this.parseIdentifier() : null;
    }
    parseFunctionParams(node, isConstructor) {
      this.expect(10);
      this.expressionScope.enter(newParameterDeclarationScope());
      node.params = this.parseBindingList(11, 41, 2 | (isConstructor ? 4 : 0));
      this.expressionScope.exit();
    }
    registerFunctionStatementId(node) {
      if (!node.id)
        return;
      this.scope.declareName(node.id.name, !this.options.annexB || this.state.strict || node.generator || node.async ? this.scope.treatFunctionsAsVar ? 5 : 8201 : 17, node.id.loc.start);
    }
    parseClass(node, isStatement, optionalId) {
      this.next();
      const oldStrict = this.state.strict;
      this.state.strict = true;
      this.parseClassId(node, isStatement, optionalId);
      this.parseClassSuper(node);
      node.body = this.parseClassBody(!!node.superClass, oldStrict);
      return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
    }
    isClassProperty() {
      return this.match(29) || this.match(13) || this.match(8);
    }
    isClassMethod() {
      return this.match(10);
    }
    nameIsConstructor(key) {
      return key.type === "Identifier" && key.name === "constructor" || key.type === "StringLiteral" && key.value === "constructor";
    }
    isNonstaticConstructor(method) {
      return !method.computed && !method.static && this.nameIsConstructor(method.key);
    }
    parseClassBody(hadSuperClass, oldStrict) {
      this.classScope.enter();
      const state = {
        hadConstructor: false,
        hadSuperClass
      };
      let decorators = [];
      const classBody = this.startNode();
      classBody.body = [];
      this.expect(5);
      this.withSmartMixTopicForbiddingContext(() => {
        while (!this.match(8)) {
          if (this.eat(13)) {
            if (decorators.length > 0) {
              throw this.raise(Errors.DecoratorSemicolon, this.state.lastTokEndLoc);
            }
            continue;
          }
          if (this.match(26)) {
            decorators.push(this.parseDecorator());
            continue;
          }
          const member = this.startNode();
          if (decorators.length) {
            member.decorators = decorators;
            this.resetStartLocationFromNode(member, decorators[0]);
            decorators = [];
          }
          this.parseClassMember(classBody, member, state);
          if (member.kind === "constructor" && member.decorators && member.decorators.length > 0) {
            this.raise(Errors.DecoratorConstructor, member);
          }
        }
      });
      this.state.strict = oldStrict;
      this.next();
      if (decorators.length) {
        throw this.raise(Errors.TrailingDecorator, this.state.startLoc);
      }
      this.classScope.exit();
      return this.finishNode(classBody, "ClassBody");
    }
    parseClassMemberFromModifier(classBody, member) {
      const key = this.parseIdentifier(true);
      if (this.isClassMethod()) {
        const method = member;
        method.kind = "method";
        method.computed = false;
        method.key = key;
        method.static = false;
        this.pushClassMethod(classBody, method, false, false, false, false);
        return true;
      } else if (this.isClassProperty()) {
        const prop = member;
        prop.computed = false;
        prop.key = key;
        prop.static = false;
        classBody.body.push(this.parseClassProperty(prop));
        return true;
      }
      this.resetPreviousNodeTrailingComments(key);
      return false;
    }
    parseClassMember(classBody, member, state) {
      const isStatic = this.isContextual(106);
      if (isStatic) {
        if (this.parseClassMemberFromModifier(classBody, member)) {
          return;
        }
        if (this.eat(5)) {
          this.parseClassStaticBlock(classBody, member);
          return;
        }
      }
      this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
    }
    parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
      const publicMethod = member;
      const privateMethod = member;
      const publicProp = member;
      const privateProp = member;
      const accessorProp = member;
      const method = publicMethod;
      const publicMember = publicMethod;
      member.static = isStatic;
      this.parsePropertyNamePrefixOperator(member);
      if (this.eat(55)) {
        method.kind = "method";
        const isPrivateName = this.match(138);
        this.parseClassElementName(method);
        if (isPrivateName) {
          this.pushClassPrivateMethod(classBody, privateMethod, true, false);
          return;
        }
        if (this.isNonstaticConstructor(publicMethod)) {
          this.raise(Errors.ConstructorIsGenerator, publicMethod.key);
        }
        this.pushClassMethod(classBody, publicMethod, true, false, false, false);
        return;
      }
      const isContextual = !this.state.containsEsc && tokenIsIdentifier(this.state.type);
      const key = this.parseClassElementName(member);
      const maybeContextualKw = isContextual ? key.name : null;
      const isPrivate = this.isPrivateName(key);
      const maybeQuestionTokenStartLoc = this.state.startLoc;
      this.parsePostMemberNameModifiers(publicMember);
      if (this.isClassMethod()) {
        method.kind = "method";
        if (isPrivate) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
          return;
        }
        const isConstructor = this.isNonstaticConstructor(publicMethod);
        let allowsDirectSuper = false;
        if (isConstructor) {
          publicMethod.kind = "constructor";
          if (state.hadConstructor && !this.hasPlugin("typescript")) {
            this.raise(Errors.DuplicateConstructor, key);
          }
          if (isConstructor && this.hasPlugin("typescript") && member.override) {
            this.raise(Errors.OverrideOnConstructor, key);
          }
          state.hadConstructor = true;
          allowsDirectSuper = state.hadSuperClass;
        }
        this.pushClassMethod(classBody, publicMethod, false, false, isConstructor, allowsDirectSuper);
      } else if (this.isClassProperty()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else if (maybeContextualKw === "async" && !this.isLineTerminator()) {
        this.resetPreviousNodeTrailingComments(key);
        const isGenerator = this.eat(55);
        if (publicMember.optional) {
          this.unexpected(maybeQuestionTokenStartLoc);
        }
        method.kind = "method";
        const isPrivate2 = this.match(138);
        this.parseClassElementName(method);
        this.parsePostMemberNameModifiers(publicMember);
        if (isPrivate2) {
          this.pushClassPrivateMethod(classBody, privateMethod, isGenerator, true);
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAsync, publicMethod.key);
          }
          this.pushClassMethod(classBody, publicMethod, isGenerator, true, false, false);
        }
      } else if ((maybeContextualKw === "get" || maybeContextualKw === "set") && !(this.match(55) && this.isLineTerminator())) {
        this.resetPreviousNodeTrailingComments(key);
        method.kind = maybeContextualKw;
        const isPrivate2 = this.match(138);
        this.parseClassElementName(publicMethod);
        if (isPrivate2) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAccessor, publicMethod.key);
          }
          this.pushClassMethod(classBody, publicMethod, false, false, false, false);
        }
        this.checkGetterSetterParams(publicMethod);
      } else if (maybeContextualKw === "accessor" && !this.isLineTerminator()) {
        this.expectPlugin("decoratorAutoAccessors");
        this.resetPreviousNodeTrailingComments(key);
        const isPrivate2 = this.match(138);
        this.parseClassElementName(publicProp);
        this.pushClassAccessorProperty(classBody, accessorProp, isPrivate2);
      } else if (this.isLineTerminator()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else {
        this.unexpected();
      }
    }
    parseClassElementName(member) {
      const {
        type,
        value
      } = this.state;
      if ((type === 132 || type === 133) && member.static && value === "prototype") {
        this.raise(Errors.StaticPrototype, this.state.startLoc);
      }
      if (type === 138) {
        if (value === "constructor") {
          this.raise(Errors.ConstructorClassPrivateField, this.state.startLoc);
        }
        const key = this.parsePrivateName();
        member.key = key;
        return key;
      }
      this.parsePropertyName(member);
      return member.key;
    }
    parseClassStaticBlock(classBody, member) {
      var _member$decorators;
      this.scope.enter(208);
      const oldLabels = this.state.labels;
      this.state.labels = [];
      this.prodParam.enter(0);
      const body = member.body = [];
      this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
      this.prodParam.exit();
      this.scope.exit();
      this.state.labels = oldLabels;
      classBody.body.push(this.finishNode(member, "StaticBlock"));
      if ((_member$decorators = member.decorators) != null && _member$decorators.length) {
        this.raise(Errors.DecoratorStaticBlock, member);
      }
    }
    pushClassProperty(classBody, prop) {
      if (!prop.computed && this.nameIsConstructor(prop.key)) {
        this.raise(Errors.ConstructorClassField, prop.key);
      }
      classBody.body.push(this.parseClassProperty(prop));
    }
    pushClassPrivateProperty(classBody, prop) {
      const node = this.parseClassPrivateProperty(prop);
      classBody.body.push(node);
      this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), 0, node.key.loc.start);
    }
    pushClassAccessorProperty(classBody, prop, isPrivate) {
      if (!isPrivate && !prop.computed && this.nameIsConstructor(prop.key)) {
        this.raise(Errors.ConstructorClassField, prop.key);
      }
      const node = this.parseClassAccessorProperty(prop);
      classBody.body.push(node);
      if (isPrivate) {
        this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), 0, node.key.loc.start);
      }
    }
    pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
      classBody.body.push(this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true));
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      const node = this.parseMethod(method, isGenerator, isAsync, false, false, "ClassPrivateMethod", true);
      classBody.body.push(node);
      const kind = node.kind === "get" ? node.static ? 6 : 2 : node.kind === "set" ? node.static ? 5 : 1 : 0;
      this.declareClassPrivateMethodInScope(node, kind);
    }
    declareClassPrivateMethodInScope(node, kind) {
      this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), kind, node.key.loc.start);
    }
    parsePostMemberNameModifiers(methodOrProp) {
    }
    parseClassPrivateProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, "ClassPrivateProperty");
    }
    parseClassProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, "ClassProperty");
    }
    parseClassAccessorProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, "ClassAccessorProperty");
    }
    parseInitializer(node) {
      this.scope.enter(80);
      this.expressionScope.enter(newExpressionScope());
      this.prodParam.enter(0);
      node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
      this.expressionScope.exit();
      this.prodParam.exit();
      this.scope.exit();
    }
    parseClassId(node, isStatement, optionalId, bindingType = 8331) {
      if (tokenIsIdentifier(this.state.type)) {
        node.id = this.parseIdentifier();
        if (isStatement) {
          this.declareNameFromIdentifier(node.id, bindingType);
        }
      } else {
        if (optionalId || !isStatement) {
          node.id = null;
        } else {
          throw this.raise(Errors.MissingClassName, this.state.startLoc);
        }
      }
    }
    parseClassSuper(node) {
      node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
    }
    parseExport(node, decorators) {
      const maybeDefaultIdentifier = this.parseMaybeImportPhase(node, true);
      const hasDefault = this.maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier);
      const parseAfterDefault = !hasDefault || this.eat(12);
      const hasStar = parseAfterDefault && this.eatExportStar(node);
      const hasNamespace = hasStar && this.maybeParseExportNamespaceSpecifier(node);
      const parseAfterNamespace = parseAfterDefault && (!hasNamespace || this.eat(12));
      const isFromRequired = hasDefault || hasStar;
      if (hasStar && !hasNamespace) {
        if (hasDefault)
          this.unexpected();
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.parseExportFrom(node, true);
        return this.finishNode(node, "ExportAllDeclaration");
      }
      const hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
      if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) {
        this.unexpected(null, 5);
      }
      if (hasNamespace && parseAfterNamespace) {
        this.unexpected(null, 98);
      }
      let hasDeclaration;
      if (isFromRequired || hasSpecifiers) {
        hasDeclaration = false;
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.parseExportFrom(node, isFromRequired);
      } else {
        hasDeclaration = this.maybeParseExportDeclaration(node);
      }
      if (isFromRequired || hasSpecifiers || hasDeclaration) {
        var _node2$declaration;
        const node2 = node;
        this.checkExport(node2, true, false, !!node2.source);
        if (((_node2$declaration = node2.declaration) == null ? undefined : _node2$declaration.type) === "ClassDeclaration") {
          this.maybeTakeDecorators(decorators, node2.declaration, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        return this.finishNode(node2, "ExportNamedDeclaration");
      }
      if (this.eat(65)) {
        const node2 = node;
        const decl = this.parseExportDefaultExpression();
        node2.declaration = decl;
        if (decl.type === "ClassDeclaration") {
          this.maybeTakeDecorators(decorators, decl, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.checkExport(node2, true, true);
        return this.finishNode(node2, "ExportDefaultDeclaration");
      }
      this.unexpected(null, 5);
    }
    eatExportStar(node) {
      return this.eat(55);
    }
    maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
      if (maybeDefaultIdentifier || this.isExportDefaultSpecifier()) {
        this.expectPlugin("exportDefaultFrom", maybeDefaultIdentifier == null ? undefined : maybeDefaultIdentifier.loc.start);
        const id = maybeDefaultIdentifier || this.parseIdentifier(true);
        const specifier = this.startNodeAtNode(id);
        specifier.exported = id;
        node.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
        return true;
      }
      return false;
    }
    maybeParseExportNamespaceSpecifier(node) {
      if (this.isContextual(93)) {
        var _ref, _ref$specifiers;
        (_ref$specifiers = (_ref = node).specifiers) != null || (_ref.specifiers = []);
        const specifier = this.startNodeAt(this.state.lastTokStartLoc);
        this.next();
        specifier.exported = this.parseModuleExportName();
        node.specifiers.push(this.finishNode(specifier, "ExportNamespaceSpecifier"));
        return true;
      }
      return false;
    }
    maybeParseExportNamedSpecifiers(node) {
      if (this.match(5)) {
        const node2 = node;
        if (!node2.specifiers)
          node2.specifiers = [];
        const isTypeExport = node2.exportKind === "type";
        node2.specifiers.push(...this.parseExportSpecifiers(isTypeExport));
        node2.source = null;
        node2.declaration = null;
        if (this.hasPlugin("importAssertions")) {
          node2.assertions = [];
        }
        return true;
      }
      return false;
    }
    maybeParseExportDeclaration(node) {
      if (this.shouldParseExportDeclaration()) {
        node.specifiers = [];
        node.source = null;
        if (this.hasPlugin("importAssertions")) {
          node.assertions = [];
        }
        node.declaration = this.parseExportDeclaration(node);
        return true;
      }
      return false;
    }
    isAsyncFunction() {
      if (!this.isContextual(95))
        return false;
      const next = this.nextTokenInLineStart();
      return this.isUnparsedContextual(next, "function");
    }
    parseExportDefaultExpression() {
      const expr = this.startNode();
      if (this.match(68)) {
        this.next();
        return this.parseFunction(expr, 5);
      } else if (this.isAsyncFunction()) {
        this.next();
        this.next();
        return this.parseFunction(expr, 13);
      }
      if (this.match(80)) {
        return this.parseClass(expr, true, true);
      }
      if (this.match(26)) {
        if (this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
          this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
        }
        return this.parseClass(this.maybeTakeDecorators(this.parseDecorators(false), this.startNode()), true, true);
      }
      if (this.match(75) || this.match(74) || this.isLet()) {
        throw this.raise(Errors.UnsupportedDefaultExport, this.state.startLoc);
      }
      const res = this.parseMaybeAssignAllowIn();
      this.semicolon();
      return res;
    }
    parseExportDeclaration(node) {
      if (this.match(80)) {
        const node2 = this.parseClass(this.startNode(), true, false);
        return node2;
      }
      return this.parseStatementListItem();
    }
    isExportDefaultSpecifier() {
      const {
        type
      } = this.state;
      if (tokenIsIdentifier(type)) {
        if (type === 95 && !this.state.containsEsc || type === 100) {
          return false;
        }
        if ((type === 130 || type === 129) && !this.state.containsEsc) {
          const {
            type: nextType
          } = this.lookahead();
          if (tokenIsIdentifier(nextType) && nextType !== 98 || nextType === 5) {
            this.expectOnePlugin(["flow", "typescript"]);
            return false;
          }
        }
      } else if (!this.match(65)) {
        return false;
      }
      const next = this.nextTokenStart();
      const hasFrom = this.isUnparsedContextual(next, "from");
      if (this.input.charCodeAt(next) === 44 || tokenIsIdentifier(this.state.type) && hasFrom) {
        return true;
      }
      if (this.match(65) && hasFrom) {
        const nextAfterFrom = this.input.charCodeAt(this.nextTokenStartSince(next + 4));
        return nextAfterFrom === 34 || nextAfterFrom === 39;
      }
      return false;
    }
    parseExportFrom(node, expect) {
      if (this.eatContextual(98)) {
        node.source = this.parseImportSource();
        this.checkExport(node);
        this.maybeParseImportAttributes(node);
        this.checkJSONModuleImport(node);
      } else if (expect) {
        this.unexpected();
      }
      this.semicolon();
    }
    shouldParseExportDeclaration() {
      const {
        type
      } = this.state;
      if (type === 26) {
        this.expectOnePlugin(["decorators", "decorators-legacy"]);
        if (this.hasPlugin("decorators")) {
          if (this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
            this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
          }
          return true;
        }
      }
      if (this.isContextual(107)) {
        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
        return true;
      }
      if (this.isContextual(96) && this.startsAwaitUsing()) {
        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
        return true;
      }
      return type === 74 || type === 75 || type === 68 || type === 80 || this.isLet() || this.isAsyncFunction();
    }
    checkExport(node, checkNames, isDefault, isFrom) {
      if (checkNames) {
        var _node$specifiers;
        if (isDefault) {
          this.checkDuplicateExports(node, "default");
          if (this.hasPlugin("exportDefaultFrom")) {
            var _declaration$extra;
            const declaration = node.declaration;
            if (declaration.type === "Identifier" && declaration.name === "from" && declaration.end - declaration.start === 4 && !((_declaration$extra = declaration.extra) != null && _declaration$extra.parenthesized)) {
              this.raise(Errors.ExportDefaultFromAsIdentifier, declaration);
            }
          }
        } else if ((_node$specifiers = node.specifiers) != null && _node$specifiers.length) {
          for (const specifier of node.specifiers) {
            const {
              exported
            } = specifier;
            const exportName = exported.type === "Identifier" ? exported.name : exported.value;
            this.checkDuplicateExports(specifier, exportName);
            if (!isFrom && specifier.local) {
              const {
                local
              } = specifier;
              if (local.type !== "Identifier") {
                this.raise(Errors.ExportBindingIsString, specifier, {
                  localName: local.value,
                  exportName
                });
              } else {
                this.checkReservedWord(local.name, local.loc.start, true, false);
                this.scope.checkLocalExport(local);
              }
            }
          }
        } else if (node.declaration) {
          const decl = node.declaration;
          if (decl.type === "FunctionDeclaration" || decl.type === "ClassDeclaration") {
            const {
              id
            } = decl;
            if (!id)
              throw new Error("Assertion failure");
            this.checkDuplicateExports(node, id.name);
          } else if (decl.type === "VariableDeclaration") {
            for (const declaration of decl.declarations) {
              this.checkDeclaration(declaration.id);
            }
          }
        }
      }
    }
    checkDeclaration(node) {
      if (node.type === "Identifier") {
        this.checkDuplicateExports(node, node.name);
      } else if (node.type === "ObjectPattern") {
        for (const prop of node.properties) {
          this.checkDeclaration(prop);
        }
      } else if (node.type === "ArrayPattern") {
        for (const elem of node.elements) {
          if (elem) {
            this.checkDeclaration(elem);
          }
        }
      } else if (node.type === "ObjectProperty") {
        this.checkDeclaration(node.value);
      } else if (node.type === "RestElement") {
        this.checkDeclaration(node.argument);
      } else if (node.type === "AssignmentPattern") {
        this.checkDeclaration(node.left);
      }
    }
    checkDuplicateExports(node, exportName) {
      if (this.exportedIdentifiers.has(exportName)) {
        if (exportName === "default") {
          this.raise(Errors.DuplicateDefaultExport, node);
        } else {
          this.raise(Errors.DuplicateExport, node, {
            exportName
          });
        }
      }
      this.exportedIdentifiers.add(exportName);
    }
    parseExportSpecifiers(isInTypeExport) {
      const nodes = [];
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.eat(8))
            break;
        }
        const isMaybeTypeOnly = this.isContextual(130);
        const isString22 = this.match(133);
        const node = this.startNode();
        node.local = this.parseModuleExportName();
        nodes.push(this.parseExportSpecifier(node, isString22, isInTypeExport, isMaybeTypeOnly));
      }
      return nodes;
    }
    parseExportSpecifier(node, isString22, isInTypeExport, isMaybeTypeOnly) {
      if (this.eatContextual(93)) {
        node.exported = this.parseModuleExportName();
      } else if (isString22) {
        node.exported = cloneStringLiteral(node.local);
      } else if (!node.exported) {
        node.exported = cloneIdentifier(node.local);
      }
      return this.finishNode(node, "ExportSpecifier");
    }
    parseModuleExportName() {
      if (this.match(133)) {
        const result2 = this.parseStringLiteral(this.state.value);
        const surrogate = loneSurrogate.exec(result2.value);
        if (surrogate) {
          this.raise(Errors.ModuleExportNameHasLoneSurrogate, result2, {
            surrogateCharCode: surrogate[0].charCodeAt(0)
          });
        }
        return result2;
      }
      return this.parseIdentifier(true);
    }
    isJSONModuleImport(node) {
      if (node.assertions != null) {
        return node.assertions.some(({
          key,
          value
        }) => {
          return value.value === "json" && (key.type === "Identifier" ? key.name === "type" : key.value === "type");
        });
      }
      return false;
    }
    checkImportReflection(node) {
      const {
        specifiers
      } = node;
      const singleBindingType = specifiers.length === 1 ? specifiers[0].type : null;
      if (node.phase === "source") {
        if (singleBindingType !== "ImportDefaultSpecifier") {
          this.raise(Errors.SourcePhaseImportRequiresDefault, specifiers[0].loc.start);
        }
      } else if (node.phase === "defer") {
        if (singleBindingType !== "ImportNamespaceSpecifier") {
          this.raise(Errors.DeferImportRequiresNamespace, specifiers[0].loc.start);
        }
      } else if (node.module) {
        var _node$assertions;
        if (singleBindingType !== "ImportDefaultSpecifier") {
          this.raise(Errors.ImportReflectionNotBinding, specifiers[0].loc.start);
        }
        if (((_node$assertions = node.assertions) == null ? undefined : _node$assertions.length) > 0) {
          this.raise(Errors.ImportReflectionHasAssertion, specifiers[0].loc.start);
        }
      }
    }
    checkJSONModuleImport(node) {
      if (this.isJSONModuleImport(node) && node.type !== "ExportAllDeclaration") {
        const {
          specifiers
        } = node;
        if (specifiers != null) {
          const nonDefaultNamedSpecifier = specifiers.find((specifier) => {
            let imported;
            if (specifier.type === "ExportSpecifier") {
              imported = specifier.local;
            } else if (specifier.type === "ImportSpecifier") {
              imported = specifier.imported;
            }
            if (imported !== undefined) {
              return imported.type === "Identifier" ? imported.name !== "default" : imported.value !== "default";
            }
          });
          if (nonDefaultNamedSpecifier !== undefined) {
            this.raise(Errors.ImportJSONBindingNotDefault, nonDefaultNamedSpecifier.loc.start);
          }
        }
      }
    }
    isPotentialImportPhase(isExport) {
      if (isExport)
        return false;
      return this.isContextual(105) || this.isContextual(97) || this.isContextual(127);
    }
    applyImportPhase(node, isExport, phase, loc) {
      if (isExport) {
        return;
      }
      if (phase === "module") {
        this.expectPlugin("importReflection", loc);
        node.module = true;
      } else if (this.hasPlugin("importReflection")) {
        node.module = false;
      }
      if (phase === "source") {
        this.expectPlugin("sourcePhaseImports", loc);
        node.phase = "source";
      } else if (phase === "defer") {
        this.expectPlugin("deferredImportEvaluation", loc);
        node.phase = "defer";
      } else if (this.hasPlugin("sourcePhaseImports")) {
        node.phase = null;
      }
    }
    parseMaybeImportPhase(node, isExport) {
      if (!this.isPotentialImportPhase(isExport)) {
        this.applyImportPhase(node, isExport, null);
        return null;
      }
      const phaseIdentifier = this.parseIdentifier(true);
      const {
        type
      } = this.state;
      const isImportPhase = tokenIsKeywordOrIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
      if (isImportPhase) {
        this.resetPreviousIdentifierLeadingComments(phaseIdentifier);
        this.applyImportPhase(node, isExport, phaseIdentifier.name, phaseIdentifier.loc.start);
        return null;
      } else {
        this.applyImportPhase(node, isExport, null);
        return phaseIdentifier;
      }
    }
    isPrecedingIdImportPhase(phase) {
      const {
        type
      } = this.state;
      return tokenIsIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
    }
    parseImport(node) {
      if (this.match(133)) {
        return this.parseImportSourceAndAttributes(node);
      }
      return this.parseImportSpecifiersAndAfter(node, this.parseMaybeImportPhase(node, false));
    }
    parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier) {
      node.specifiers = [];
      const hasDefault = this.maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier);
      const parseNext = !hasDefault || this.eat(12);
      const hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
      if (parseNext && !hasStar)
        this.parseNamedImportSpecifiers(node);
      this.expectContextual(98);
      return this.parseImportSourceAndAttributes(node);
    }
    parseImportSourceAndAttributes(node) {
      var _node$specifiers2;
      (_node$specifiers2 = node.specifiers) != null || (node.specifiers = []);
      node.source = this.parseImportSource();
      this.maybeParseImportAttributes(node);
      this.checkImportReflection(node);
      this.checkJSONModuleImport(node);
      this.semicolon();
      return this.finishNode(node, "ImportDeclaration");
    }
    parseImportSource() {
      if (!this.match(133))
        this.unexpected();
      return this.parseExprAtom();
    }
    parseImportSpecifierLocal(node, specifier, type) {
      specifier.local = this.parseIdentifier();
      node.specifiers.push(this.finishImportSpecifier(specifier, type));
    }
    finishImportSpecifier(specifier, type, bindingType = 8201) {
      this.checkLVal(specifier.local, {
        type
      }, bindingType);
      return this.finishNode(specifier, type);
    }
    parseImportAttributes() {
      this.expect(5);
      const attrs = [];
      const attrNames = new Set;
      do {
        if (this.match(8)) {
          break;
        }
        const node = this.startNode();
        const keyName = this.state.value;
        if (attrNames.has(keyName)) {
          this.raise(Errors.ModuleAttributesWithDuplicateKeys, this.state.startLoc, {
            key: keyName
          });
        }
        attrNames.add(keyName);
        if (this.match(133)) {
          node.key = this.parseStringLiteral(keyName);
        } else {
          node.key = this.parseIdentifier(true);
        }
        this.expect(14);
        if (!this.match(133)) {
          throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
        }
        node.value = this.parseStringLiteral(this.state.value);
        attrs.push(this.finishNode(node, "ImportAttribute"));
      } while (this.eat(12));
      this.expect(8);
      return attrs;
    }
    parseModuleAttributes() {
      const attrs = [];
      const attributes = new Set;
      do {
        const node = this.startNode();
        node.key = this.parseIdentifier(true);
        if (node.key.name !== "type") {
          this.raise(Errors.ModuleAttributeDifferentFromType, node.key);
        }
        if (attributes.has(node.key.name)) {
          this.raise(Errors.ModuleAttributesWithDuplicateKeys, node.key, {
            key: node.key.name
          });
        }
        attributes.add(node.key.name);
        this.expect(14);
        if (!this.match(133)) {
          throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
        }
        node.value = this.parseStringLiteral(this.state.value);
        attrs.push(this.finishNode(node, "ImportAttribute"));
      } while (this.eat(12));
      return attrs;
    }
    maybeParseImportAttributes(node) {
      let attributes;
      {
        var useWith = false;
      }
      if (this.match(76)) {
        if (this.hasPrecedingLineBreak() && this.lookaheadCharCode() === 40) {
          return;
        }
        this.next();
        if (this.hasPlugin("moduleAttributes")) {
          attributes = this.parseModuleAttributes();
        } else {
          if (!this.hasPlugin("importAssertions")) {
            this.expectPlugin("importAttributes");
          }
          attributes = this.parseImportAttributes();
        }
        {
          useWith = true;
        }
      } else if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
        if (this.hasPlugin("importAttributes")) {
          if (this.getPluginOption("importAttributes", "deprecatedAssertSyntax") !== true) {
            this.raise(Errors.ImportAttributesUseAssert, this.state.startLoc);
          }
          this.addExtra(node, "deprecatedAssertSyntax", true);
        } else {
          this.expectOnePlugin(["importAttributes", "importAssertions"]);
        }
        this.next();
        attributes = this.parseImportAttributes();
      } else if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
        attributes = [];
      } else {
        if (this.hasPlugin("moduleAttributes")) {
          attributes = [];
        } else
          return;
      }
      if (!useWith && this.hasPlugin("importAssertions")) {
        node.assertions = attributes;
      } else {
        node.attributes = attributes;
      }
    }
    maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier) {
      if (maybeDefaultIdentifier) {
        const specifier = this.startNodeAtNode(maybeDefaultIdentifier);
        specifier.local = maybeDefaultIdentifier;
        node.specifiers.push(this.finishImportSpecifier(specifier, "ImportDefaultSpecifier"));
        return true;
      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
        this.parseImportSpecifierLocal(node, this.startNode(), "ImportDefaultSpecifier");
        return true;
      }
      return false;
    }
    maybeParseStarImportSpecifier(node) {
      if (this.match(55)) {
        const specifier = this.startNode();
        this.next();
        this.expectContextual(93);
        this.parseImportSpecifierLocal(node, specifier, "ImportNamespaceSpecifier");
        return true;
      }
      return false;
    }
    parseNamedImportSpecifiers(node) {
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          if (this.eat(14)) {
            throw this.raise(Errors.DestructureNamedImport, this.state.startLoc);
          }
          this.expect(12);
          if (this.eat(8))
            break;
        }
        const specifier = this.startNode();
        const importedIsString = this.match(133);
        const isMaybeTypeOnly = this.isContextual(130);
        specifier.imported = this.parseModuleExportName();
        const importSpecifier = this.parseImportSpecifier(specifier, importedIsString, node.importKind === "type" || node.importKind === "typeof", isMaybeTypeOnly, undefined);
        node.specifiers.push(importSpecifier);
      }
    }
    parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
      if (this.eatContextual(93)) {
        specifier.local = this.parseIdentifier();
      } else {
        const {
          imported
        } = specifier;
        if (importedIsString) {
          throw this.raise(Errors.ImportBindingIsString, specifier, {
            importName: imported.value
          });
        }
        this.checkReservedWord(imported.name, specifier.loc.start, true, true);
        if (!specifier.local) {
          specifier.local = cloneIdentifier(imported);
        }
      }
      return this.finishImportSpecifier(specifier, "ImportSpecifier", bindingType);
    }
    isThisParam(param) {
      return param.type === "Identifier" && param.name === "this";
    }
  }

  class Parser extends StatementParser {
    constructor(options3, input, pluginsMap) {
      options3 = getOptions(options3);
      super(options3, input);
      this.options = options3;
      this.initializeScopes();
      this.plugins = pluginsMap;
      this.filename = options3.sourceFilename;
    }
    getScopeHandler() {
      return ScopeHandler;
    }
    parse() {
      this.enterInitialScopes();
      const file = this.startNode();
      const program = this.startNode();
      this.nextToken();
      file.errors = null;
      this.parseTopLevel(file, program);
      file.errors = this.state.errors;
      file.comments.length = this.state.commentsLen;
      return file;
    }
  }
  function parse3(input, options3) {
    var _options;
    if (((_options = options3) == null ? undefined : _options.sourceType) === "unambiguous") {
      options3 = Object.assign({}, options3);
      try {
        options3.sourceType = "module";
        const parser = getParser(options3, input);
        const ast = parser.parse();
        if (parser.sawUnambiguousESM) {
          return ast;
        }
        if (parser.ambiguousScriptDifferentAst) {
          try {
            options3.sourceType = "script";
            return getParser(options3, input).parse();
          } catch (_unused) {
          }
        } else {
          ast.program.sourceType = "script";
        }
        return ast;
      } catch (moduleError) {
        try {
          options3.sourceType = "script";
          return getParser(options3, input).parse();
        } catch (_unused2) {
        }
        throw moduleError;
      }
    } else {
      return getParser(options3, input).parse();
    }
  }
  function parseExpression(input, options3) {
    const parser = getParser(options3, input);
    if (parser.options.strictMode) {
      parser.state.strict = true;
    }
    return parser.getExpression();
  }
  function generateExportedTokenTypes(internalTokenTypes) {
    const tokenTypes2 = {};
    for (const typeName of Object.keys(internalTokenTypes)) {
      tokenTypes2[typeName] = getExportedToken(internalTokenTypes[typeName]);
    }
    return tokenTypes2;
  }
  var tokTypes = generateExportedTokenTypes(tt);
  function getParser(options3, input) {
    let cls = Parser;
    const pluginsMap = new Map;
    if (options3 != null && options3.plugins) {
      for (const plugin of options3.plugins) {
        let name, opts;
        if (typeof plugin === "string") {
          name = plugin;
        } else {
          [name, opts] = plugin;
        }
        if (!pluginsMap.has(name)) {
          pluginsMap.set(name, opts || {});
        }
      }
      validatePlugins(pluginsMap);
      cls = getParserClass(pluginsMap);
    }
    return new cls(options3, input, pluginsMap);
  }
  var parserClassCache = new Map;
  function getParserClass(pluginsMap) {
    const pluginList = [];
    for (const name of mixinPluginNames) {
      if (pluginsMap.has(name)) {
        pluginList.push(name);
      }
    }
    const key = pluginList.join("|");
    let cls = parserClassCache.get(key);
    if (!cls) {
      cls = Parser;
      for (const plugin of pluginList) {
        cls = mixinPlugins[plugin](cls);
      }
      parserClassCache.set(key, cls);
    }
    return cls;
  }
  exports.parse = parse3;
  exports.parseExpression = parseExpression;
  exports.tokTypes = tokTypes;
});
var require_virtual_types = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.Var = exports.User = exports.Statement = exports.SpreadProperty = exports.Scope = exports.RestProperty = exports.ReferencedMemberExpression = exports.ReferencedIdentifier = exports.Referenced = exports.Pure = exports.NumericLiteralTypeAnnotation = exports.Generated = exports.ForAwaitStatement = exports.Flow = exports.Expression = exports.ExistentialTypeParam = exports.BlockScoped = exports.BindingIdentifier = undefined;
  var ReferencedIdentifier = exports.ReferencedIdentifier = ["Identifier", "JSXIdentifier"];
  var ReferencedMemberExpression = exports.ReferencedMemberExpression = ["MemberExpression"];
  var BindingIdentifier = exports.BindingIdentifier = ["Identifier"];
  var Statement = exports.Statement = ["Statement"];
  var Expression = exports.Expression = ["Expression"];
  var Scope = exports.Scope = ["Scopable", "Pattern"];
  var Referenced = exports.Referenced = null;
  var BlockScoped = exports.BlockScoped = null;
  var Var = exports.Var = ["VariableDeclaration"];
  var User = exports.User = null;
  var Generated = exports.Generated = null;
  var Pure = exports.Pure = null;
  var Flow = exports.Flow = ["Flow", "ImportDeclaration", "ExportDeclaration", "ImportSpecifier"];
  var RestProperty = exports.RestProperty = ["RestElement"];
  var SpreadProperty = exports.SpreadProperty = ["RestElement"];
  var ExistentialTypeParam = exports.ExistentialTypeParam = ["ExistsTypeAnnotation"];
  var NumericLiteralTypeAnnotation = exports.NumericLiteralTypeAnnotation = ["NumberLiteralTypeAnnotation"];
  var ForAwaitStatement = exports.ForAwaitStatement = ["ForOfStatement"];
});
var require_ms = __commonJS2((exports, module) => {
  var s32 = 1000;
  var m22 = s32 * 60;
  var h22 = m22 * 60;
  var d = h22 * 24;
  var w22 = d * 7;
  var y = d * 365.25;
  module.exports = function(val2, options3) {
    options3 = options3 || {};
    var type = typeof val2;
    if (type === "string" && val2.length > 0) {
      return parse3(val2);
    } else if (type === "number" && isFinite(val2)) {
      return options3.long ? fmtLong(val2) : fmtShort(val2);
    }
    throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val2));
  };
  function parse3(str) {
    str = String(str);
    if (str.length > 100) {
      return;
    }
    var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str);
    if (!match) {
      return;
    }
    var n = parseFloat(match[1]);
    var type = (match[2] || "ms").toLowerCase();
    switch (type) {
      case "years":
      case "year":
      case "yrs":
      case "yr":
      case "y":
        return n * y;
      case "weeks":
      case "week":
      case "w":
        return n * w22;
      case "days":
      case "day":
      case "d":
        return n * d;
      case "hours":
      case "hour":
      case "hrs":
      case "hr":
      case "h":
        return n * h22;
      case "minutes":
      case "minute":
      case "mins":
      case "min":
      case "m":
        return n * m22;
      case "seconds":
      case "second":
      case "secs":
      case "sec":
      case "s":
        return n * s32;
      case "milliseconds":
      case "millisecond":
      case "msecs":
      case "msec":
      case "ms":
        return n;
      default:
        return;
    }
  }
  function fmtShort(ms) {
    var msAbs = Math.abs(ms);
    if (msAbs >= d) {
      return Math.round(ms / d) + "d";
    }
    if (msAbs >= h22) {
      return Math.round(ms / h22) + "h";
    }
    if (msAbs >= m22) {
      return Math.round(ms / m22) + "m";
    }
    if (msAbs >= s32) {
      return Math.round(ms / s32) + "s";
    }
    return ms + "ms";
  }
  function fmtLong(ms) {
    var msAbs = Math.abs(ms);
    if (msAbs >= d) {
      return plural2(ms, msAbs, d, "day");
    }
    if (msAbs >= h22) {
      return plural2(ms, msAbs, h22, "hour");
    }
    if (msAbs >= m22) {
      return plural2(ms, msAbs, m22, "minute");
    }
    if (msAbs >= s32) {
      return plural2(ms, msAbs, s32, "second");
    }
    return ms + " ms";
  }
  function plural2(ms, msAbs, n, name) {
    var isPlural2 = msAbs >= n * 1.5;
    return Math.round(ms / n) + " " + name + (isPlural2 ? "s" : "");
  }
});
var require_common = __commonJS2((exports, module) => {
  function setup(env42) {
    createDebug.debug = createDebug;
    createDebug.default = createDebug;
    createDebug.coerce = coerce;
    createDebug.disable = disable;
    createDebug.enable = enable;
    createDebug.enabled = enabled22;
    createDebug.humanize = require_ms();
    createDebug.destroy = destroy;
    Object.keys(env42).forEach((key) => {
      createDebug[key] = env42[key];
    });
    createDebug.names = [];
    createDebug.skips = [];
    createDebug.formatters = {};
    function selectColor(namespace) {
      let hash = 0;
      for (let i = 0;i < namespace.length; i++) {
        hash = (hash << 5) - hash + namespace.charCodeAt(i);
        hash |= 0;
      }
      return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
    }
    createDebug.selectColor = selectColor;
    function createDebug(namespace) {
      let prevTime;
      let enableOverride = null;
      let namespacesCache;
      let enabledCache;
      function debug(...args) {
        if (!debug.enabled) {
          return;
        }
        const self2 = debug;
        const curr = Number(new Date);
        const ms = curr - (prevTime || curr);
        self2.diff = ms;
        self2.prev = prevTime;
        self2.curr = curr;
        prevTime = curr;
        args[0] = createDebug.coerce(args[0]);
        if (typeof args[0] !== "string") {
          args.unshift("%O");
        }
        let index = 0;
        args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
          if (match === "%%") {
            return "%";
          }
          index++;
          const formatter22 = createDebug.formatters[format];
          if (typeof formatter22 === "function") {
            const val2 = args[index];
            match = formatter22.call(self2, val2);
            args.splice(index, 1);
            index--;
          }
          return match;
        });
        createDebug.formatArgs.call(self2, args);
        const logFn = self2.log || createDebug.log;
        logFn.apply(self2, args);
      }
      debug.namespace = namespace;
      debug.useColors = createDebug.useColors();
      debug.color = createDebug.selectColor(namespace);
      debug.extend = extend;
      debug.destroy = createDebug.destroy;
      Object.defineProperty(debug, "enabled", {
        enumerable: true,
        configurable: false,
        get: () => {
          if (enableOverride !== null) {
            return enableOverride;
          }
          if (namespacesCache !== createDebug.namespaces) {
            namespacesCache = createDebug.namespaces;
            enabledCache = createDebug.enabled(namespace);
          }
          return enabledCache;
        },
        set: (v22) => {
          enableOverride = v22;
        }
      });
      if (typeof createDebug.init === "function") {
        createDebug.init(debug);
      }
      return debug;
    }
    function extend(namespace, delimiter22) {
      const newDebug = createDebug(this.namespace + (typeof delimiter22 === "undefined" ? ":" : delimiter22) + namespace);
      newDebug.log = this.log;
      return newDebug;
    }
    function enable(namespaces) {
      createDebug.save(namespaces);
      createDebug.namespaces = namespaces;
      createDebug.names = [];
      createDebug.skips = [];
      let i;
      const split2 = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
      const len = split2.length;
      for (i = 0;i < len; i++) {
        if (!split2[i]) {
          continue;
        }
        namespaces = split2[i].replace(/\*/g, ".*?");
        if (namespaces[0] === "-") {
          createDebug.skips.push(new RegExp("^" + namespaces.slice(1) + "$"));
        } else {
          createDebug.names.push(new RegExp("^" + namespaces + "$"));
        }
      }
    }
    function disable() {
      const namespaces = [
        ...createDebug.names.map(toNamespace),
        ...createDebug.skips.map(toNamespace).map((namespace) => "-" + namespace)
      ].join(",");
      createDebug.enable("");
      return namespaces;
    }
    function enabled22(name) {
      if (name[name.length - 1] === "*") {
        return true;
      }
      let i;
      let len;
      for (i = 0, len = createDebug.skips.length;i < len; i++) {
        if (createDebug.skips[i].test(name)) {
          return false;
        }
      }
      for (i = 0, len = createDebug.names.length;i < len; i++) {
        if (createDebug.names[i].test(name)) {
          return true;
        }
      }
      return false;
    }
    function toNamespace(regexp) {
      return regexp.toString().substring(2, regexp.toString().length - 2).replace(/\.\*\?$/, "*");
    }
    function coerce(val2) {
      if (val2 instanceof Error) {
        return val2.stack || val2.message;
      }
      return val2;
    }
    function destroy() {
      console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
    }
    createDebug.enable(createDebug.load());
    return createDebug;
  }
  module.exports = setup;
});
var require_browser = __commonJS2((exports, module) => {
  exports.formatArgs = formatArgs;
  exports.save = save;
  exports.load = load2;
  exports.useColors = useColors;
  exports.storage = localstorage();
  exports.destroy = (() => {
    let warned = false;
    return () => {
      if (!warned) {
        warned = true;
        console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
      }
    };
  })();
  exports.colors = [
    "#0000CC",
    "#0000FF",
    "#0033CC",
    "#0033FF",
    "#0066CC",
    "#0066FF",
    "#0099CC",
    "#0099FF",
    "#00CC00",
    "#00CC33",
    "#00CC66",
    "#00CC99",
    "#00CCCC",
    "#00CCFF",
    "#3300CC",
    "#3300FF",
    "#3333CC",
    "#3333FF",
    "#3366CC",
    "#3366FF",
    "#3399CC",
    "#3399FF",
    "#33CC00",
    "#33CC33",
    "#33CC66",
    "#33CC99",
    "#33CCCC",
    "#33CCFF",
    "#6600CC",
    "#6600FF",
    "#6633CC",
    "#6633FF",
    "#66CC00",
    "#66CC33",
    "#9900CC",
    "#9900FF",
    "#9933CC",
    "#9933FF",
    "#99CC00",
    "#99CC33",
    "#CC0000",
    "#CC0033",
    "#CC0066",
    "#CC0099",
    "#CC00CC",
    "#CC00FF",
    "#CC3300",
    "#CC3333",
    "#CC3366",
    "#CC3399",
    "#CC33CC",
    "#CC33FF",
    "#CC6600",
    "#CC6633",
    "#CC9900",
    "#CC9933",
    "#CCCC00",
    "#CCCC33",
    "#FF0000",
    "#FF0033",
    "#FF0066",
    "#FF0099",
    "#FF00CC",
    "#FF00FF",
    "#FF3300",
    "#FF3333",
    "#FF3366",
    "#FF3399",
    "#FF33CC",
    "#FF33FF",
    "#FF6600",
    "#FF6633",
    "#FF9900",
    "#FF9933",
    "#FFCC00",
    "#FFCC33"
  ];
  function useColors() {
    if (typeof window !== "undefined" && window.process && (window.process.type === "renderer" || window.process.__nwjs)) {
      return true;
    }
    if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
      return false;
    }
    let m22;
    return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && (m22 = navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)) && parseInt(m22[1], 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
  }
  function formatArgs(args) {
    args[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + args[0] + (this.useColors ? "%c " : " ") + "+" + module.exports.humanize(this.diff);
    if (!this.useColors) {
      return;
    }
    const c22 = "color: " + this.color;
    args.splice(1, 0, c22, "color: inherit");
    let index = 0;
    let lastC = 0;
    args[0].replace(/%[a-zA-Z%]/g, (match) => {
      if (match === "%%") {
        return;
      }
      index++;
      if (match === "%c") {
        lastC = index;
      }
    });
    args.splice(lastC, 0, c22);
  }
  exports.log = console.debug || console.log || (() => {
  });
  function save(namespaces) {
    try {
      if (namespaces) {
        exports.storage.setItem("debug", namespaces);
      } else {
        exports.storage.removeItem("debug");
      }
    } catch (error) {
    }
  }
  function load2() {
    let r22;
    try {
      r22 = exports.storage.getItem("debug");
    } catch (error) {
    }
    if (!r22 && typeof process !== "undefined" && "env" in process) {
      r22 = "true";
    }
    return r22;
  }
  function localstorage() {
    try {
      return localStorage;
    } catch (error) {
    }
  }
  module.exports = require_common()(exports);
  var { formatters } = module.exports;
  formatters.j = function(v22) {
    try {
      return JSON.stringify(v22);
    } catch (error) {
      return "[UnexpectedJSONParseError]: " + error.message;
    }
  };
});
var exports_supports_color = {};
__export3(exports_supports_color, {
  default: () => supports_color_default2,
  createSupportsColor: () => createSupportsColor2
});
function hasFlag2(flag, argv22 = globalThis.Deno ? globalThis.Deno.args : process9.argv) {
  const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
  const position = argv22.indexOf(prefix + flag);
  const terminatorPosition = argv22.indexOf("--");
  return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
}
function envForceColor2() {
  if ("FORCE_COLOR" in env42) {
    if (env42.FORCE_COLOR === "true") {
      return 1;
    }
    if (env42.FORCE_COLOR === "false") {
      return 0;
    }
    return env42.FORCE_COLOR.length === 0 ? 1 : Math.min(Number.parseInt(env42.FORCE_COLOR, 10), 3);
  }
}
function translateLevel2(level) {
  if (level === 0) {
    return false;
  }
  return {
    level,
    hasBasic: true,
    has256: level >= 2,
    has16m: level >= 3
  };
}
function _supportsColor2(haveStream, { streamIsTTY, sniffFlags = true } = {}) {
  const noFlagForceColor = envForceColor2();
  if (noFlagForceColor !== undefined) {
    flagForceColor2 = noFlagForceColor;
  }
  const forceColor = sniffFlags ? flagForceColor2 : noFlagForceColor;
  if (forceColor === 0) {
    return 0;
  }
  if (sniffFlags) {
    if (hasFlag2("color=16m") || hasFlag2("color=full") || hasFlag2("color=truecolor")) {
      return 3;
    }
    if (hasFlag2("color=256")) {
      return 2;
    }
  }
  if ("TF_BUILD" in env42 && "AGENT_NAME" in env42) {
    return 1;
  }
  if (haveStream && !streamIsTTY && forceColor === undefined) {
    return 0;
  }
  const min = forceColor || 0;
  if (env42.TERM === "dumb") {
    return min;
  }
  if (process9.platform === "win32") {
    const osRelease = os22.release().split(".");
    if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
      return Number(osRelease[2]) >= 14931 ? 3 : 2;
    }
    return 1;
  }
  if ("CI" in env42) {
    if ("GITHUB_ACTIONS" in env42 || "GITEA_ACTIONS" in env42) {
      return 3;
    }
    if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI", "BUILDKITE", "DRONE"].some((sign) => (sign in env42)) || env42.CI_NAME === "codeship") {
      return 1;
    }
    return min;
  }
  if ("TEAMCITY_VERSION" in env42) {
    return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env42.TEAMCITY_VERSION) ? 1 : 0;
  }
  if (env42.COLORTERM === "truecolor") {
    return 3;
  }
  if (env42.TERM === "xterm-kitty") {
    return 3;
  }
  if ("TERM_PROGRAM" in env42) {
    const version2 = Number.parseInt((env42.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
    switch (env42.TERM_PROGRAM) {
      case "iTerm.app": {
        return version2 >= 3 ? 3 : 2;
      }
      case "Apple_Terminal": {
        return 2;
      }
    }
  }
  if (/-256(color)?$/i.test(env42.TERM)) {
    return 2;
  }
  if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env42.TERM)) {
    return 1;
  }
  if ("COLORTERM" in env42) {
    return 1;
  }
  return min;
}
function createSupportsColor2(stream2, options3 = {}) {
  const level = _supportsColor2(stream2, {
    streamIsTTY: stream2 && stream2.isTTY,
    ...options3
  });
  return translateLevel2(level);
}
var env42;
var flagForceColor2;
var supportsColor2;
var supports_color_default2;
var init_supports_color = __esm2(() => {
  ({ env: env42 } = process9);
  if (hasFlag2("no-color") || hasFlag2("no-colors") || hasFlag2("color=false") || hasFlag2("color=never")) {
    flagForceColor2 = 0;
  } else if (hasFlag2("color") || hasFlag2("colors") || hasFlag2("color=true") || hasFlag2("color=always")) {
    flagForceColor2 = 1;
  }
  supportsColor2 = {
    stdout: createSupportsColor2({ isTTY: tty32.isatty(1) }),
    stderr: createSupportsColor2({ isTTY: tty32.isatty(2) })
  };
  supports_color_default2 = supportsColor2;
});
var require_node = __commonJS2((exports, module) => {
  var tty43 = import.meta.require("tty");
  var util = import.meta.require("util");
  exports.init = init22;
  exports.log = log22;
  exports.formatArgs = formatArgs;
  exports.save = save;
  exports.load = load2;
  exports.useColors = useColors;
  exports.destroy = util.deprecate(() => {
  }, "Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
  exports.colors = [6, 2, 3, 4, 5, 1];
  try {
    const supportsColor22 = (init_supports_color(), __toCommonJS(exports_supports_color));
    if (supportsColor22 && (supportsColor22.stderr || supportsColor22).level >= 2) {
      exports.colors = [
        20,
        21,
        26,
        27,
        32,
        33,
        38,
        39,
        40,
        41,
        42,
        43,
        44,
        45,
        56,
        57,
        62,
        63,
        68,
        69,
        74,
        75,
        76,
        77,
        78,
        79,
        80,
        81,
        92,
        93,
        98,
        99,
        112,
        113,
        128,
        129,
        134,
        135,
        148,
        149,
        160,
        161,
        162,
        163,
        164,
        165,
        166,
        167,
        168,
        169,
        170,
        171,
        172,
        173,
        178,
        179,
        184,
        185,
        196,
        197,
        198,
        199,
        200,
        201,
        202,
        203,
        204,
        205,
        206,
        207,
        208,
        209,
        214,
        215,
        220,
        221
      ];
    }
  } catch (error) {
  }
  exports.inspectOpts = Object.keys(process.env).filter((key) => {
    return /^debug_/i.test(key);
  }).reduce((obj, key) => {
    const prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, (_22, k) => {
      return k.toUpperCase();
    });
    let val2 = process.env[key];
    if (/^(yes|on|true|enabled)$/i.test(val2)) {
      val2 = true;
    } else if (/^(no|off|false|disabled)$/i.test(val2)) {
      val2 = false;
    } else if (val2 === "null") {
      val2 = null;
    } else {
      val2 = Number(val2);
    }
    obj[prop] = val2;
    return obj;
  }, {});
  function useColors() {
    return "colors" in exports.inspectOpts ? Boolean(exports.inspectOpts.colors) : tty43.isatty(process.stderr.fd);
  }
  function formatArgs(args) {
    const { namespace: name, useColors: useColors2 } = this;
    if (useColors2) {
      const c22 = this.color;
      const colorCode = "\x1B[3" + (c22 < 8 ? c22 : "8;5;" + c22);
      const prefix = `  ${colorCode};1m${name} \x1B[0m`;
      args[0] = prefix + args[0].split("\n").join("\n" + prefix);
      args.push(colorCode + "m+" + module.exports.humanize(this.diff) + "\x1B[0m");
    } else {
      args[0] = getDate() + name + " " + args[0];
    }
  }
  function getDate() {
    if (exports.inspectOpts.hideDate) {
      return "";
    }
    return new Date().toISOString() + " ";
  }
  function log22(...args) {
    return process.stderr.write(util.formatWithOptions(exports.inspectOpts, ...args) + "\n");
  }
  function save(namespaces) {
    if (namespaces) {
      process.env.DEBUG = namespaces;
    } else {
      delete "true";
    }
  }
  function load2() {
    return "true";
  }
  function init22(debug) {
    debug.inspectOpts = {};
    const keys = Object.keys(exports.inspectOpts);
    for (let i = 0;i < keys.length; i++) {
      debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
    }
  }
  module.exports = require_common()(exports);
  var { formatters } = module.exports;
  formatters.o = function(v22) {
    this.inspectOpts.colors = this.useColors;
    return util.inspect(v22, this.inspectOpts).split("\n").map((str) => str.trim()).join(" ");
  };
  formatters.O = function(v22) {
    this.inspectOpts.colors = this.useColors;
    return util.inspect(v22, this.inspectOpts);
  };
});
var require_src22 = __commonJS2((exports, module) => {
  if (typeof process === "undefined" || process.type === "renderer" || false || process.__nwjs) {
    module.exports = require_browser();
  } else {
    module.exports = require_node();
  }
});
var require_shallowEqual = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = shallowEqual;
  function shallowEqual(actual, expected) {
    const keys = Object.keys(expected);
    for (const key of keys) {
      if (actual[key] !== expected[key]) {
        return false;
      }
    }
    return true;
  }
});
var require_deprecationWarning = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = deprecationWarning;
  var warnings = new Set;
  function deprecationWarning(oldName, newName, prefix = "") {
    if (warnings.has(oldName))
      return;
    warnings.add(oldName);
    const {
      internal,
      trace
    } = captureShortStackTrace(1, 2);
    if (internal) {
      return;
    }
    console.warn(`${prefix}\`${oldName}\` has been deprecated, please migrate to \`${newName}\`\n${trace}`);
  }
  function captureShortStackTrace(skip, length) {
    const {
      stackTraceLimit,
      prepareStackTrace
    } = Error;
    let stackTrace;
    Error.stackTraceLimit = 1 + skip + length;
    Error.prepareStackTrace = function(err22, stack) {
      stackTrace = stack;
    };
    new Error().stack;
    Error.stackTraceLimit = stackTraceLimit;
    Error.prepareStackTrace = prepareStackTrace;
    if (!stackTrace)
      return {
        internal: false,
        trace: ""
      };
    const shortStackTrace = stackTrace.slice(1 + skip, 1 + skip + length);
    return {
      internal: /[\\/]@babel[\\/]/.test(shortStackTrace[1].getFileName()),
      trace: shortStackTrace.map((frame) => `    at ${frame}`).join("\n")
    };
  }
});
var require_generated = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.isAccessor = isAccessor;
  exports.isAnyTypeAnnotation = isAnyTypeAnnotation;
  exports.isArgumentPlaceholder = isArgumentPlaceholder;
  exports.isArrayExpression = isArrayExpression;
  exports.isArrayPattern = isArrayPattern;
  exports.isArrayTypeAnnotation = isArrayTypeAnnotation;
  exports.isArrowFunctionExpression = isArrowFunctionExpression;
  exports.isAssignmentExpression = isAssignmentExpression;
  exports.isAssignmentPattern = isAssignmentPattern;
  exports.isAwaitExpression = isAwaitExpression;
  exports.isBigIntLiteral = isBigIntLiteral;
  exports.isBinary = isBinary;
  exports.isBinaryExpression = isBinaryExpression;
  exports.isBindExpression = isBindExpression;
  exports.isBlock = isBlock;
  exports.isBlockParent = isBlockParent;
  exports.isBlockStatement = isBlockStatement;
  exports.isBooleanLiteral = isBooleanLiteral;
  exports.isBooleanLiteralTypeAnnotation = isBooleanLiteralTypeAnnotation;
  exports.isBooleanTypeAnnotation = isBooleanTypeAnnotation;
  exports.isBreakStatement = isBreakStatement;
  exports.isCallExpression = isCallExpression;
  exports.isCatchClause = isCatchClause;
  exports.isClass = isClass;
  exports.isClassAccessorProperty = isClassAccessorProperty;
  exports.isClassBody = isClassBody;
  exports.isClassDeclaration = isClassDeclaration;
  exports.isClassExpression = isClassExpression;
  exports.isClassImplements = isClassImplements;
  exports.isClassMethod = isClassMethod;
  exports.isClassPrivateMethod = isClassPrivateMethod;
  exports.isClassPrivateProperty = isClassPrivateProperty;
  exports.isClassProperty = isClassProperty;
  exports.isCompletionStatement = isCompletionStatement;
  exports.isConditional = isConditional;
  exports.isConditionalExpression = isConditionalExpression;
  exports.isContinueStatement = isContinueStatement;
  exports.isDebuggerStatement = isDebuggerStatement;
  exports.isDecimalLiteral = isDecimalLiteral;
  exports.isDeclaration = isDeclaration;
  exports.isDeclareClass = isDeclareClass;
  exports.isDeclareExportAllDeclaration = isDeclareExportAllDeclaration;
  exports.isDeclareExportDeclaration = isDeclareExportDeclaration;
  exports.isDeclareFunction = isDeclareFunction;
  exports.isDeclareInterface = isDeclareInterface;
  exports.isDeclareModule = isDeclareModule;
  exports.isDeclareModuleExports = isDeclareModuleExports;
  exports.isDeclareOpaqueType = isDeclareOpaqueType;
  exports.isDeclareTypeAlias = isDeclareTypeAlias;
  exports.isDeclareVariable = isDeclareVariable;
  exports.isDeclaredPredicate = isDeclaredPredicate;
  exports.isDecorator = isDecorator;
  exports.isDirective = isDirective;
  exports.isDirectiveLiteral = isDirectiveLiteral;
  exports.isDoExpression = isDoExpression;
  exports.isDoWhileStatement = isDoWhileStatement;
  exports.isEmptyStatement = isEmptyStatement;
  exports.isEmptyTypeAnnotation = isEmptyTypeAnnotation;
  exports.isEnumBody = isEnumBody;
  exports.isEnumBooleanBody = isEnumBooleanBody;
  exports.isEnumBooleanMember = isEnumBooleanMember;
  exports.isEnumDeclaration = isEnumDeclaration;
  exports.isEnumDefaultedMember = isEnumDefaultedMember;
  exports.isEnumMember = isEnumMember;
  exports.isEnumNumberBody = isEnumNumberBody;
  exports.isEnumNumberMember = isEnumNumberMember;
  exports.isEnumStringBody = isEnumStringBody;
  exports.isEnumStringMember = isEnumStringMember;
  exports.isEnumSymbolBody = isEnumSymbolBody;
  exports.isExistsTypeAnnotation = isExistsTypeAnnotation;
  exports.isExportAllDeclaration = isExportAllDeclaration;
  exports.isExportDeclaration = isExportDeclaration;
  exports.isExportDefaultDeclaration = isExportDefaultDeclaration;
  exports.isExportDefaultSpecifier = isExportDefaultSpecifier;
  exports.isExportNamedDeclaration = isExportNamedDeclaration;
  exports.isExportNamespaceSpecifier = isExportNamespaceSpecifier;
  exports.isExportSpecifier = isExportSpecifier;
  exports.isExpression = isExpression;
  exports.isExpressionStatement = isExpressionStatement;
  exports.isExpressionWrapper = isExpressionWrapper;
  exports.isFile = isFile;
  exports.isFlow = isFlow;
  exports.isFlowBaseAnnotation = isFlowBaseAnnotation;
  exports.isFlowDeclaration = isFlowDeclaration;
  exports.isFlowPredicate = isFlowPredicate;
  exports.isFlowType = isFlowType;
  exports.isFor = isFor;
  exports.isForInStatement = isForInStatement;
  exports.isForOfStatement = isForOfStatement;
  exports.isForStatement = isForStatement;
  exports.isForXStatement = isForXStatement;
  exports.isFunction = isFunction22;
  exports.isFunctionDeclaration = isFunctionDeclaration;
  exports.isFunctionExpression = isFunctionExpression;
  exports.isFunctionParent = isFunctionParent;
  exports.isFunctionTypeAnnotation = isFunctionTypeAnnotation;
  exports.isFunctionTypeParam = isFunctionTypeParam;
  exports.isGenericTypeAnnotation = isGenericTypeAnnotation;
  exports.isIdentifier = isIdentifier;
  exports.isIfStatement = isIfStatement;
  exports.isImmutable = isImmutable;
  exports.isImport = isImport;
  exports.isImportAttribute = isImportAttribute;
  exports.isImportDeclaration = isImportDeclaration;
  exports.isImportDefaultSpecifier = isImportDefaultSpecifier;
  exports.isImportExpression = isImportExpression;
  exports.isImportNamespaceSpecifier = isImportNamespaceSpecifier;
  exports.isImportOrExportDeclaration = isImportOrExportDeclaration;
  exports.isImportSpecifier = isImportSpecifier;
  exports.isIndexedAccessType = isIndexedAccessType;
  exports.isInferredPredicate = isInferredPredicate;
  exports.isInterfaceDeclaration = isInterfaceDeclaration;
  exports.isInterfaceExtends = isInterfaceExtends;
  exports.isInterfaceTypeAnnotation = isInterfaceTypeAnnotation;
  exports.isInterpreterDirective = isInterpreterDirective;
  exports.isIntersectionTypeAnnotation = isIntersectionTypeAnnotation;
  exports.isJSX = isJSX;
  exports.isJSXAttribute = isJSXAttribute;
  exports.isJSXClosingElement = isJSXClosingElement;
  exports.isJSXClosingFragment = isJSXClosingFragment;
  exports.isJSXElement = isJSXElement;
  exports.isJSXEmptyExpression = isJSXEmptyExpression;
  exports.isJSXExpressionContainer = isJSXExpressionContainer;
  exports.isJSXFragment = isJSXFragment;
  exports.isJSXIdentifier = isJSXIdentifier;
  exports.isJSXMemberExpression = isJSXMemberExpression;
  exports.isJSXNamespacedName = isJSXNamespacedName;
  exports.isJSXOpeningElement = isJSXOpeningElement;
  exports.isJSXOpeningFragment = isJSXOpeningFragment;
  exports.isJSXSpreadAttribute = isJSXSpreadAttribute;
  exports.isJSXSpreadChild = isJSXSpreadChild;
  exports.isJSXText = isJSXText;
  exports.isLVal = isLVal;
  exports.isLabeledStatement = isLabeledStatement;
  exports.isLiteral = isLiteral;
  exports.isLogicalExpression = isLogicalExpression;
  exports.isLoop = isLoop;
  exports.isMemberExpression = isMemberExpression;
  exports.isMetaProperty = isMetaProperty;
  exports.isMethod = isMethod;
  exports.isMiscellaneous = isMiscellaneous;
  exports.isMixedTypeAnnotation = isMixedTypeAnnotation;
  exports.isModuleDeclaration = isModuleDeclaration;
  exports.isModuleExpression = isModuleExpression;
  exports.isModuleSpecifier = isModuleSpecifier;
  exports.isNewExpression = isNewExpression;
  exports.isNoop = isNoop;
  exports.isNullLiteral = isNullLiteral;
  exports.isNullLiteralTypeAnnotation = isNullLiteralTypeAnnotation;
  exports.isNullableTypeAnnotation = isNullableTypeAnnotation;
  exports.isNumberLiteral = isNumberLiteral;
  exports.isNumberLiteralTypeAnnotation = isNumberLiteralTypeAnnotation;
  exports.isNumberTypeAnnotation = isNumberTypeAnnotation;
  exports.isNumericLiteral = isNumericLiteral;
  exports.isObjectExpression = isObjectExpression;
  exports.isObjectMember = isObjectMember;
  exports.isObjectMethod = isObjectMethod;
  exports.isObjectPattern = isObjectPattern;
  exports.isObjectProperty = isObjectProperty;
  exports.isObjectTypeAnnotation = isObjectTypeAnnotation;
  exports.isObjectTypeCallProperty = isObjectTypeCallProperty;
  exports.isObjectTypeIndexer = isObjectTypeIndexer;
  exports.isObjectTypeInternalSlot = isObjectTypeInternalSlot;
  exports.isObjectTypeProperty = isObjectTypeProperty;
  exports.isObjectTypeSpreadProperty = isObjectTypeSpreadProperty;
  exports.isOpaqueType = isOpaqueType;
  exports.isOptionalCallExpression = isOptionalCallExpression;
  exports.isOptionalIndexedAccessType = isOptionalIndexedAccessType;
  exports.isOptionalMemberExpression = isOptionalMemberExpression;
  exports.isParenthesizedExpression = isParenthesizedExpression;
  exports.isPattern = isPattern;
  exports.isPatternLike = isPatternLike;
  exports.isPipelineBareFunction = isPipelineBareFunction;
  exports.isPipelinePrimaryTopicReference = isPipelinePrimaryTopicReference;
  exports.isPipelineTopicExpression = isPipelineTopicExpression;
  exports.isPlaceholder = isPlaceholder;
  exports.isPrivate = isPrivate;
  exports.isPrivateName = isPrivateName;
  exports.isProgram = isProgram;
  exports.isProperty = isProperty;
  exports.isPureish = isPureish;
  exports.isQualifiedTypeIdentifier = isQualifiedTypeIdentifier;
  exports.isRecordExpression = isRecordExpression;
  exports.isRegExpLiteral = isRegExpLiteral;
  exports.isRegexLiteral = isRegexLiteral;
  exports.isRestElement = isRestElement;
  exports.isRestProperty = isRestProperty;
  exports.isReturnStatement = isReturnStatement;
  exports.isScopable = isScopable;
  exports.isSequenceExpression = isSequenceExpression;
  exports.isSpreadElement = isSpreadElement;
  exports.isSpreadProperty = isSpreadProperty;
  exports.isStandardized = isStandardized;
  exports.isStatement = isStatement;
  exports.isStaticBlock = isStaticBlock;
  exports.isStringLiteral = isStringLiteral;
  exports.isStringLiteralTypeAnnotation = isStringLiteralTypeAnnotation;
  exports.isStringTypeAnnotation = isStringTypeAnnotation;
  exports.isSuper = isSuper;
  exports.isSwitchCase = isSwitchCase;
  exports.isSwitchStatement = isSwitchStatement;
  exports.isSymbolTypeAnnotation = isSymbolTypeAnnotation;
  exports.isTSAnyKeyword = isTSAnyKeyword;
  exports.isTSArrayType = isTSArrayType;
  exports.isTSAsExpression = isTSAsExpression;
  exports.isTSBaseType = isTSBaseType;
  exports.isTSBigIntKeyword = isTSBigIntKeyword;
  exports.isTSBooleanKeyword = isTSBooleanKeyword;
  exports.isTSCallSignatureDeclaration = isTSCallSignatureDeclaration;
  exports.isTSConditionalType = isTSConditionalType;
  exports.isTSConstructSignatureDeclaration = isTSConstructSignatureDeclaration;
  exports.isTSConstructorType = isTSConstructorType;
  exports.isTSDeclareFunction = isTSDeclareFunction;
  exports.isTSDeclareMethod = isTSDeclareMethod;
  exports.isTSEntityName = isTSEntityName;
  exports.isTSEnumDeclaration = isTSEnumDeclaration;
  exports.isTSEnumMember = isTSEnumMember;
  exports.isTSExportAssignment = isTSExportAssignment;
  exports.isTSExpressionWithTypeArguments = isTSExpressionWithTypeArguments;
  exports.isTSExternalModuleReference = isTSExternalModuleReference;
  exports.isTSFunctionType = isTSFunctionType;
  exports.isTSImportEqualsDeclaration = isTSImportEqualsDeclaration;
  exports.isTSImportType = isTSImportType;
  exports.isTSIndexSignature = isTSIndexSignature;
  exports.isTSIndexedAccessType = isTSIndexedAccessType;
  exports.isTSInferType = isTSInferType;
  exports.isTSInstantiationExpression = isTSInstantiationExpression;
  exports.isTSInterfaceBody = isTSInterfaceBody;
  exports.isTSInterfaceDeclaration = isTSInterfaceDeclaration;
  exports.isTSIntersectionType = isTSIntersectionType;
  exports.isTSIntrinsicKeyword = isTSIntrinsicKeyword;
  exports.isTSLiteralType = isTSLiteralType;
  exports.isTSMappedType = isTSMappedType;
  exports.isTSMethodSignature = isTSMethodSignature;
  exports.isTSModuleBlock = isTSModuleBlock;
  exports.isTSModuleDeclaration = isTSModuleDeclaration;
  exports.isTSNamedTupleMember = isTSNamedTupleMember;
  exports.isTSNamespaceExportDeclaration = isTSNamespaceExportDeclaration;
  exports.isTSNeverKeyword = isTSNeverKeyword;
  exports.isTSNonNullExpression = isTSNonNullExpression;
  exports.isTSNullKeyword = isTSNullKeyword;
  exports.isTSNumberKeyword = isTSNumberKeyword;
  exports.isTSObjectKeyword = isTSObjectKeyword;
  exports.isTSOptionalType = isTSOptionalType;
  exports.isTSParameterProperty = isTSParameterProperty;
  exports.isTSParenthesizedType = isTSParenthesizedType;
  exports.isTSPropertySignature = isTSPropertySignature;
  exports.isTSQualifiedName = isTSQualifiedName;
  exports.isTSRestType = isTSRestType;
  exports.isTSSatisfiesExpression = isTSSatisfiesExpression;
  exports.isTSStringKeyword = isTSStringKeyword;
  exports.isTSSymbolKeyword = isTSSymbolKeyword;
  exports.isTSThisType = isTSThisType;
  exports.isTSTupleType = isTSTupleType;
  exports.isTSType = isTSType;
  exports.isTSTypeAliasDeclaration = isTSTypeAliasDeclaration;
  exports.isTSTypeAnnotation = isTSTypeAnnotation;
  exports.isTSTypeAssertion = isTSTypeAssertion;
  exports.isTSTypeElement = isTSTypeElement;
  exports.isTSTypeLiteral = isTSTypeLiteral;
  exports.isTSTypeOperator = isTSTypeOperator;
  exports.isTSTypeParameter = isTSTypeParameter;
  exports.isTSTypeParameterDeclaration = isTSTypeParameterDeclaration;
  exports.isTSTypeParameterInstantiation = isTSTypeParameterInstantiation;
  exports.isTSTypePredicate = isTSTypePredicate;
  exports.isTSTypeQuery = isTSTypeQuery;
  exports.isTSTypeReference = isTSTypeReference;
  exports.isTSUndefinedKeyword = isTSUndefinedKeyword;
  exports.isTSUnionType = isTSUnionType;
  exports.isTSUnknownKeyword = isTSUnknownKeyword;
  exports.isTSVoidKeyword = isTSVoidKeyword;
  exports.isTaggedTemplateExpression = isTaggedTemplateExpression;
  exports.isTemplateElement = isTemplateElement;
  exports.isTemplateLiteral = isTemplateLiteral;
  exports.isTerminatorless = isTerminatorless;
  exports.isThisExpression = isThisExpression;
  exports.isThisTypeAnnotation = isThisTypeAnnotation;
  exports.isThrowStatement = isThrowStatement;
  exports.isTopicReference = isTopicReference;
  exports.isTryStatement = isTryStatement;
  exports.isTupleExpression = isTupleExpression;
  exports.isTupleTypeAnnotation = isTupleTypeAnnotation;
  exports.isTypeAlias = isTypeAlias;
  exports.isTypeAnnotation = isTypeAnnotation;
  exports.isTypeCastExpression = isTypeCastExpression;
  exports.isTypeParameter = isTypeParameter;
  exports.isTypeParameterDeclaration = isTypeParameterDeclaration;
  exports.isTypeParameterInstantiation = isTypeParameterInstantiation;
  exports.isTypeScript = isTypeScript;
  exports.isTypeofTypeAnnotation = isTypeofTypeAnnotation;
  exports.isUnaryExpression = isUnaryExpression;
  exports.isUnaryLike = isUnaryLike;
  exports.isUnionTypeAnnotation = isUnionTypeAnnotation;
  exports.isUpdateExpression = isUpdateExpression;
  exports.isUserWhitespacable = isUserWhitespacable;
  exports.isV8IntrinsicIdentifier = isV8IntrinsicIdentifier;
  exports.isVariableDeclaration = isVariableDeclaration;
  exports.isVariableDeclarator = isVariableDeclarator;
  exports.isVariance = isVariance;
  exports.isVoidTypeAnnotation = isVoidTypeAnnotation;
  exports.isWhile = isWhile;
  exports.isWhileStatement = isWhileStatement;
  exports.isWithStatement = isWithStatement;
  exports.isYieldExpression = isYieldExpression;
  var _shallowEqual = require_shallowEqual();
  var _deprecationWarning = require_deprecationWarning();
  function isArrayExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ArrayExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isAssignmentExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "AssignmentExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBinaryExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BinaryExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isInterpreterDirective(node, opts) {
    if (!node)
      return false;
    if (node.type !== "InterpreterDirective")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDirective(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Directive")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDirectiveLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DirectiveLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBlockStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BlockStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBreakStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BreakStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isCallExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "CallExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isCatchClause(node, opts) {
    if (!node)
      return false;
    if (node.type !== "CatchClause")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isConditionalExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ConditionalExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isContinueStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ContinueStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDebuggerStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DebuggerStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDoWhileStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DoWhileStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEmptyStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EmptyStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExpressionStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExpressionStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFile(node, opts) {
    if (!node)
      return false;
    if (node.type !== "File")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isForInStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ForInStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isForStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ForStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFunctionDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "FunctionDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFunctionExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "FunctionExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isIdentifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Identifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isIfStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "IfStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isLabeledStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "LabeledStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isStringLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "StringLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNumericLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "NumericLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNullLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "NullLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBooleanLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BooleanLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isRegExpLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "RegExpLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isLogicalExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "LogicalExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isMemberExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "MemberExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNewExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "NewExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isProgram(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Program")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectMethod(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectMethod")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isRestElement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "RestElement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isReturnStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ReturnStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isSequenceExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "SequenceExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isParenthesizedExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ParenthesizedExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isSwitchCase(node, opts) {
    if (!node)
      return false;
    if (node.type !== "SwitchCase")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isSwitchStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "SwitchStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isThisExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ThisExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isThrowStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ThrowStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTryStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TryStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isUnaryExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "UnaryExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isUpdateExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "UpdateExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isVariableDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "VariableDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isVariableDeclarator(node, opts) {
    if (!node)
      return false;
    if (node.type !== "VariableDeclarator")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isWhileStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "WhileStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isWithStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "WithStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isAssignmentPattern(node, opts) {
    if (!node)
      return false;
    if (node.type !== "AssignmentPattern")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isArrayPattern(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ArrayPattern")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isArrowFunctionExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ArrowFunctionExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassBody(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassBody")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExportAllDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExportAllDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExportDefaultDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExportDefaultDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExportNamedDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExportNamedDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExportSpecifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExportSpecifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isForOfStatement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ForOfStatement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImportDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ImportDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImportDefaultSpecifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ImportDefaultSpecifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImportNamespaceSpecifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ImportNamespaceSpecifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImportSpecifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ImportSpecifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImportExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ImportExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isMetaProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "MetaProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassMethod(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassMethod")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectPattern(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectPattern")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isSpreadElement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "SpreadElement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isSuper(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Super")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTaggedTemplateExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TaggedTemplateExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTemplateElement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TemplateElement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTemplateLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TemplateLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isYieldExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "YieldExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isAwaitExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "AwaitExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImport(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Import")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBigIntLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BigIntLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExportNamespaceSpecifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExportNamespaceSpecifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isOptionalMemberExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "OptionalMemberExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isOptionalCallExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "OptionalCallExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassAccessorProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassAccessorProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassPrivateProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassPrivateProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassPrivateMethod(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassPrivateMethod")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPrivateName(node, opts) {
    if (!node)
      return false;
    if (node.type !== "PrivateName")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isStaticBlock(node, opts) {
    if (!node)
      return false;
    if (node.type !== "StaticBlock")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isAnyTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "AnyTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isArrayTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ArrayTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBooleanTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BooleanTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBooleanLiteralTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BooleanLiteralTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNullLiteralTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "NullLiteralTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClassImplements(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ClassImplements")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareClass(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareClass")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareFunction(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareFunction")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareInterface(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareInterface")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareModule(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareModule")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareModuleExports(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareModuleExports")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareTypeAlias(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareTypeAlias")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareOpaqueType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareOpaqueType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareVariable(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareVariable")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareExportDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareExportDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclareExportAllDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclareExportAllDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclaredPredicate(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DeclaredPredicate")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExistsTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExistsTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFunctionTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "FunctionTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFunctionTypeParam(node, opts) {
    if (!node)
      return false;
    if (node.type !== "FunctionTypeParam")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isGenericTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "GenericTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isInferredPredicate(node, opts) {
    if (!node)
      return false;
    if (node.type !== "InferredPredicate")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isInterfaceExtends(node, opts) {
    if (!node)
      return false;
    if (node.type !== "InterfaceExtends")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isInterfaceDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "InterfaceDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isInterfaceTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "InterfaceTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isIntersectionTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "IntersectionTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isMixedTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "MixedTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEmptyTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EmptyTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNullableTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "NullableTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNumberLiteralTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "NumberLiteralTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNumberTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "NumberTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectTypeInternalSlot(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectTypeInternalSlot")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectTypeCallProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectTypeCallProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectTypeIndexer(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectTypeIndexer")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectTypeProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectTypeProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectTypeSpreadProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ObjectTypeSpreadProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isOpaqueType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "OpaqueType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isQualifiedTypeIdentifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "QualifiedTypeIdentifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isStringLiteralTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "StringLiteralTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isStringTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "StringTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isSymbolTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "SymbolTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isThisTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ThisTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTupleTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TupleTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeofTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TypeofTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeAlias(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TypeAlias")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeCastExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TypeCastExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeParameter(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TypeParameter")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeParameterDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TypeParameterDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeParameterInstantiation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TypeParameterInstantiation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isUnionTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "UnionTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isVariance(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Variance")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isVoidTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "VoidTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumBooleanBody(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumBooleanBody")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumNumberBody(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumNumberBody")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumStringBody(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumStringBody")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumSymbolBody(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumSymbolBody")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumBooleanMember(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumBooleanMember")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumNumberMember(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumNumberMember")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumStringMember(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumStringMember")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumDefaultedMember(node, opts) {
    if (!node)
      return false;
    if (node.type !== "EnumDefaultedMember")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isIndexedAccessType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "IndexedAccessType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isOptionalIndexedAccessType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "OptionalIndexedAccessType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXAttribute(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXAttribute")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXClosingElement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXClosingElement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXElement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXElement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXEmptyExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXEmptyExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXExpressionContainer(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXExpressionContainer")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXSpreadChild(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXSpreadChild")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXIdentifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXIdentifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXMemberExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXMemberExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXNamespacedName(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXNamespacedName")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXOpeningElement(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXOpeningElement")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXSpreadAttribute(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXSpreadAttribute")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXText(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXText")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXFragment(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXFragment")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXOpeningFragment(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXOpeningFragment")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSXClosingFragment(node, opts) {
    if (!node)
      return false;
    if (node.type !== "JSXClosingFragment")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNoop(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Noop")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPlaceholder(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Placeholder")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isV8IntrinsicIdentifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "V8IntrinsicIdentifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isArgumentPlaceholder(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ArgumentPlaceholder")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBindExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "BindExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImportAttribute(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ImportAttribute")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDecorator(node, opts) {
    if (!node)
      return false;
    if (node.type !== "Decorator")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDoExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DoExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExportDefaultSpecifier(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ExportDefaultSpecifier")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isRecordExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "RecordExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTupleExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TupleExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDecimalLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "DecimalLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isModuleExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "ModuleExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTopicReference(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TopicReference")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPipelineTopicExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "PipelineTopicExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPipelineBareFunction(node, opts) {
    if (!node)
      return false;
    if (node.type !== "PipelineBareFunction")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPipelinePrimaryTopicReference(node, opts) {
    if (!node)
      return false;
    if (node.type !== "PipelinePrimaryTopicReference")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSParameterProperty(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSParameterProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSDeclareFunction(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSDeclareFunction")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSDeclareMethod(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSDeclareMethod")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSQualifiedName(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSQualifiedName")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSCallSignatureDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSCallSignatureDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSConstructSignatureDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSConstructSignatureDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSPropertySignature(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSPropertySignature")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSMethodSignature(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSMethodSignature")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSIndexSignature(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSIndexSignature")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSAnyKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSAnyKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSBooleanKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSBooleanKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSBigIntKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSBigIntKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSIntrinsicKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSIntrinsicKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSNeverKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSNeverKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSNullKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSNullKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSNumberKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSNumberKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSObjectKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSObjectKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSStringKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSStringKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSSymbolKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSSymbolKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSUndefinedKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSUndefinedKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSUnknownKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSUnknownKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSVoidKeyword(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSVoidKeyword")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSThisType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSThisType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSFunctionType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSFunctionType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSConstructorType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSConstructorType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeReference(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeReference")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypePredicate(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypePredicate")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeQuery(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeQuery")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeLiteral(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSArrayType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSArrayType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTupleType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTupleType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSOptionalType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSOptionalType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSRestType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSRestType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSNamedTupleMember(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSNamedTupleMember")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSUnionType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSUnionType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSIntersectionType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSIntersectionType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSConditionalType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSConditionalType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSInferType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSInferType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSParenthesizedType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSParenthesizedType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeOperator(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeOperator")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSIndexedAccessType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSIndexedAccessType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSMappedType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSMappedType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSLiteralType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSLiteralType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSExpressionWithTypeArguments(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSExpressionWithTypeArguments")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSInterfaceDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSInterfaceDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSInterfaceBody(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSInterfaceBody")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeAliasDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeAliasDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSInstantiationExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSInstantiationExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSAsExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSAsExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSSatisfiesExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSSatisfiesExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeAssertion(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeAssertion")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSEnumDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSEnumDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSEnumMember(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSEnumMember")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSModuleDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSModuleDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSModuleBlock(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSModuleBlock")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSImportType(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSImportType")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSImportEqualsDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSImportEqualsDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSExternalModuleReference(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSExternalModuleReference")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSNonNullExpression(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSNonNullExpression")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSExportAssignment(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSExportAssignment")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSNamespaceExportDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSNamespaceExportDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeAnnotation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeAnnotation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeParameterInstantiation(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeParameterInstantiation")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeParameterDeclaration(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeParameterDeclaration")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeParameter(node, opts) {
    if (!node)
      return false;
    if (node.type !== "TSTypeParameter")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isStandardized(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ArrayExpression":
      case "AssignmentExpression":
      case "BinaryExpression":
      case "InterpreterDirective":
      case "Directive":
      case "DirectiveLiteral":
      case "BlockStatement":
      case "BreakStatement":
      case "CallExpression":
      case "CatchClause":
      case "ConditionalExpression":
      case "ContinueStatement":
      case "DebuggerStatement":
      case "DoWhileStatement":
      case "EmptyStatement":
      case "ExpressionStatement":
      case "File":
      case "ForInStatement":
      case "ForStatement":
      case "FunctionDeclaration":
      case "FunctionExpression":
      case "Identifier":
      case "IfStatement":
      case "LabeledStatement":
      case "StringLiteral":
      case "NumericLiteral":
      case "NullLiteral":
      case "BooleanLiteral":
      case "RegExpLiteral":
      case "LogicalExpression":
      case "MemberExpression":
      case "NewExpression":
      case "Program":
      case "ObjectExpression":
      case "ObjectMethod":
      case "ObjectProperty":
      case "RestElement":
      case "ReturnStatement":
      case "SequenceExpression":
      case "ParenthesizedExpression":
      case "SwitchCase":
      case "SwitchStatement":
      case "ThisExpression":
      case "ThrowStatement":
      case "TryStatement":
      case "UnaryExpression":
      case "UpdateExpression":
      case "VariableDeclaration":
      case "VariableDeclarator":
      case "WhileStatement":
      case "WithStatement":
      case "AssignmentPattern":
      case "ArrayPattern":
      case "ArrowFunctionExpression":
      case "ClassBody":
      case "ClassExpression":
      case "ClassDeclaration":
      case "ExportAllDeclaration":
      case "ExportDefaultDeclaration":
      case "ExportNamedDeclaration":
      case "ExportSpecifier":
      case "ForOfStatement":
      case "ImportDeclaration":
      case "ImportDefaultSpecifier":
      case "ImportNamespaceSpecifier":
      case "ImportSpecifier":
      case "ImportExpression":
      case "MetaProperty":
      case "ClassMethod":
      case "ObjectPattern":
      case "SpreadElement":
      case "Super":
      case "TaggedTemplateExpression":
      case "TemplateElement":
      case "TemplateLiteral":
      case "YieldExpression":
      case "AwaitExpression":
      case "Import":
      case "BigIntLiteral":
      case "ExportNamespaceSpecifier":
      case "OptionalMemberExpression":
      case "OptionalCallExpression":
      case "ClassProperty":
      case "ClassAccessorProperty":
      case "ClassPrivateProperty":
      case "ClassPrivateMethod":
      case "PrivateName":
      case "StaticBlock":
        break;
      case "Placeholder":
        switch (node.expectedNode) {
          case "Identifier":
          case "StringLiteral":
          case "BlockStatement":
          case "ClassBody":
            break;
          default:
            return false;
        }
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExpression(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ArrayExpression":
      case "AssignmentExpression":
      case "BinaryExpression":
      case "CallExpression":
      case "ConditionalExpression":
      case "FunctionExpression":
      case "Identifier":
      case "StringLiteral":
      case "NumericLiteral":
      case "NullLiteral":
      case "BooleanLiteral":
      case "RegExpLiteral":
      case "LogicalExpression":
      case "MemberExpression":
      case "NewExpression":
      case "ObjectExpression":
      case "SequenceExpression":
      case "ParenthesizedExpression":
      case "ThisExpression":
      case "UnaryExpression":
      case "UpdateExpression":
      case "ArrowFunctionExpression":
      case "ClassExpression":
      case "ImportExpression":
      case "MetaProperty":
      case "Super":
      case "TaggedTemplateExpression":
      case "TemplateLiteral":
      case "YieldExpression":
      case "AwaitExpression":
      case "Import":
      case "BigIntLiteral":
      case "OptionalMemberExpression":
      case "OptionalCallExpression":
      case "TypeCastExpression":
      case "JSXElement":
      case "JSXFragment":
      case "BindExpression":
      case "DoExpression":
      case "RecordExpression":
      case "TupleExpression":
      case "DecimalLiteral":
      case "ModuleExpression":
      case "TopicReference":
      case "PipelineTopicExpression":
      case "PipelineBareFunction":
      case "PipelinePrimaryTopicReference":
      case "TSInstantiationExpression":
      case "TSAsExpression":
      case "TSSatisfiesExpression":
      case "TSTypeAssertion":
      case "TSNonNullExpression":
        break;
      case "Placeholder":
        switch (node.expectedNode) {
          case "Expression":
          case "Identifier":
          case "StringLiteral":
            break;
          default:
            return false;
        }
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBinary(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "BinaryExpression":
      case "LogicalExpression":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isScopable(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "BlockStatement":
      case "CatchClause":
      case "DoWhileStatement":
      case "ForInStatement":
      case "ForStatement":
      case "FunctionDeclaration":
      case "FunctionExpression":
      case "Program":
      case "ObjectMethod":
      case "SwitchStatement":
      case "WhileStatement":
      case "ArrowFunctionExpression":
      case "ClassExpression":
      case "ClassDeclaration":
      case "ForOfStatement":
      case "ClassMethod":
      case "ClassPrivateMethod":
      case "StaticBlock":
      case "TSModuleBlock":
        break;
      case "Placeholder":
        if (node.expectedNode === "BlockStatement")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBlockParent(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "BlockStatement":
      case "CatchClause":
      case "DoWhileStatement":
      case "ForInStatement":
      case "ForStatement":
      case "FunctionDeclaration":
      case "FunctionExpression":
      case "Program":
      case "ObjectMethod":
      case "SwitchStatement":
      case "WhileStatement":
      case "ArrowFunctionExpression":
      case "ForOfStatement":
      case "ClassMethod":
      case "ClassPrivateMethod":
      case "StaticBlock":
      case "TSModuleBlock":
        break;
      case "Placeholder":
        if (node.expectedNode === "BlockStatement")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isBlock(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "BlockStatement":
      case "Program":
      case "TSModuleBlock":
        break;
      case "Placeholder":
        if (node.expectedNode === "BlockStatement")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isStatement(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "BlockStatement":
      case "BreakStatement":
      case "ContinueStatement":
      case "DebuggerStatement":
      case "DoWhileStatement":
      case "EmptyStatement":
      case "ExpressionStatement":
      case "ForInStatement":
      case "ForStatement":
      case "FunctionDeclaration":
      case "IfStatement":
      case "LabeledStatement":
      case "ReturnStatement":
      case "SwitchStatement":
      case "ThrowStatement":
      case "TryStatement":
      case "VariableDeclaration":
      case "WhileStatement":
      case "WithStatement":
      case "ClassDeclaration":
      case "ExportAllDeclaration":
      case "ExportDefaultDeclaration":
      case "ExportNamedDeclaration":
      case "ForOfStatement":
      case "ImportDeclaration":
      case "DeclareClass":
      case "DeclareFunction":
      case "DeclareInterface":
      case "DeclareModule":
      case "DeclareModuleExports":
      case "DeclareTypeAlias":
      case "DeclareOpaqueType":
      case "DeclareVariable":
      case "DeclareExportDeclaration":
      case "DeclareExportAllDeclaration":
      case "InterfaceDeclaration":
      case "OpaqueType":
      case "TypeAlias":
      case "EnumDeclaration":
      case "TSDeclareFunction":
      case "TSInterfaceDeclaration":
      case "TSTypeAliasDeclaration":
      case "TSEnumDeclaration":
      case "TSModuleDeclaration":
      case "TSImportEqualsDeclaration":
      case "TSExportAssignment":
      case "TSNamespaceExportDeclaration":
        break;
      case "Placeholder":
        switch (node.expectedNode) {
          case "Statement":
          case "Declaration":
          case "BlockStatement":
            break;
          default:
            return false;
        }
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTerminatorless(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "BreakStatement":
      case "ContinueStatement":
      case "ReturnStatement":
      case "ThrowStatement":
      case "YieldExpression":
      case "AwaitExpression":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isCompletionStatement(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "BreakStatement":
      case "ContinueStatement":
      case "ReturnStatement":
      case "ThrowStatement":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isConditional(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ConditionalExpression":
      case "IfStatement":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isLoop(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "DoWhileStatement":
      case "ForInStatement":
      case "ForStatement":
      case "WhileStatement":
      case "ForOfStatement":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isWhile(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "DoWhileStatement":
      case "WhileStatement":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExpressionWrapper(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ExpressionStatement":
      case "ParenthesizedExpression":
      case "TypeCastExpression":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFor(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ForInStatement":
      case "ForStatement":
      case "ForOfStatement":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isForXStatement(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ForInStatement":
      case "ForOfStatement":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFunction22(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "FunctionDeclaration":
      case "FunctionExpression":
      case "ObjectMethod":
      case "ArrowFunctionExpression":
      case "ClassMethod":
      case "ClassPrivateMethod":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFunctionParent(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "FunctionDeclaration":
      case "FunctionExpression":
      case "ObjectMethod":
      case "ArrowFunctionExpression":
      case "ClassMethod":
      case "ClassPrivateMethod":
      case "StaticBlock":
      case "TSModuleBlock":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPureish(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "FunctionDeclaration":
      case "FunctionExpression":
      case "StringLiteral":
      case "NumericLiteral":
      case "NullLiteral":
      case "BooleanLiteral":
      case "RegExpLiteral":
      case "ArrowFunctionExpression":
      case "BigIntLiteral":
      case "DecimalLiteral":
        break;
      case "Placeholder":
        if (node.expectedNode === "StringLiteral")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isDeclaration(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "FunctionDeclaration":
      case "VariableDeclaration":
      case "ClassDeclaration":
      case "ExportAllDeclaration":
      case "ExportDefaultDeclaration":
      case "ExportNamedDeclaration":
      case "ImportDeclaration":
      case "DeclareClass":
      case "DeclareFunction":
      case "DeclareInterface":
      case "DeclareModule":
      case "DeclareModuleExports":
      case "DeclareTypeAlias":
      case "DeclareOpaqueType":
      case "DeclareVariable":
      case "DeclareExportDeclaration":
      case "DeclareExportAllDeclaration":
      case "InterfaceDeclaration":
      case "OpaqueType":
      case "TypeAlias":
      case "EnumDeclaration":
      case "TSDeclareFunction":
      case "TSInterfaceDeclaration":
      case "TSTypeAliasDeclaration":
      case "TSEnumDeclaration":
      case "TSModuleDeclaration":
        break;
      case "Placeholder":
        if (node.expectedNode === "Declaration")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPatternLike(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "Identifier":
      case "RestElement":
      case "AssignmentPattern":
      case "ArrayPattern":
      case "ObjectPattern":
      case "TSAsExpression":
      case "TSSatisfiesExpression":
      case "TSTypeAssertion":
      case "TSNonNullExpression":
        break;
      case "Placeholder":
        switch (node.expectedNode) {
          case "Pattern":
          case "Identifier":
            break;
          default:
            return false;
        }
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isLVal(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "Identifier":
      case "MemberExpression":
      case "RestElement":
      case "AssignmentPattern":
      case "ArrayPattern":
      case "ObjectPattern":
      case "TSParameterProperty":
      case "TSAsExpression":
      case "TSSatisfiesExpression":
      case "TSTypeAssertion":
      case "TSNonNullExpression":
        break;
      case "Placeholder":
        switch (node.expectedNode) {
          case "Pattern":
          case "Identifier":
            break;
          default:
            return false;
        }
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSEntityName(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "Identifier":
      case "TSQualifiedName":
        break;
      case "Placeholder":
        if (node.expectedNode === "Identifier")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isLiteral(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "StringLiteral":
      case "NumericLiteral":
      case "NullLiteral":
      case "BooleanLiteral":
      case "RegExpLiteral":
      case "TemplateLiteral":
      case "BigIntLiteral":
      case "DecimalLiteral":
        break;
      case "Placeholder":
        if (node.expectedNode === "StringLiteral")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImmutable(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "StringLiteral":
      case "NumericLiteral":
      case "NullLiteral":
      case "BooleanLiteral":
      case "BigIntLiteral":
      case "JSXAttribute":
      case "JSXClosingElement":
      case "JSXElement":
      case "JSXExpressionContainer":
      case "JSXSpreadChild":
      case "JSXOpeningElement":
      case "JSXText":
      case "JSXFragment":
      case "JSXOpeningFragment":
      case "JSXClosingFragment":
      case "DecimalLiteral":
        break;
      case "Placeholder":
        if (node.expectedNode === "StringLiteral")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isUserWhitespacable(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ObjectMethod":
      case "ObjectProperty":
      case "ObjectTypeInternalSlot":
      case "ObjectTypeCallProperty":
      case "ObjectTypeIndexer":
      case "ObjectTypeProperty":
      case "ObjectTypeSpreadProperty":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isMethod(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ObjectMethod":
      case "ClassMethod":
      case "ClassPrivateMethod":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isObjectMember(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ObjectMethod":
      case "ObjectProperty":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isProperty(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ObjectProperty":
      case "ClassProperty":
      case "ClassAccessorProperty":
      case "ClassPrivateProperty":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isUnaryLike(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "UnaryExpression":
      case "SpreadElement":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPattern(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "AssignmentPattern":
      case "ArrayPattern":
      case "ObjectPattern":
        break;
      case "Placeholder":
        if (node.expectedNode === "Pattern")
          break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isClass(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ClassExpression":
      case "ClassDeclaration":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isImportOrExportDeclaration(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ExportAllDeclaration":
      case "ExportDefaultDeclaration":
      case "ExportNamedDeclaration":
      case "ImportDeclaration":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isExportDeclaration(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ExportAllDeclaration":
      case "ExportDefaultDeclaration":
      case "ExportNamedDeclaration":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isModuleSpecifier(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ExportSpecifier":
      case "ImportDefaultSpecifier":
      case "ImportNamespaceSpecifier":
      case "ImportSpecifier":
      case "ExportNamespaceSpecifier":
      case "ExportDefaultSpecifier":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isAccessor(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ClassAccessorProperty":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isPrivate(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "ClassPrivateProperty":
      case "ClassPrivateMethod":
      case "PrivateName":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFlow(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "AnyTypeAnnotation":
      case "ArrayTypeAnnotation":
      case "BooleanTypeAnnotation":
      case "BooleanLiteralTypeAnnotation":
      case "NullLiteralTypeAnnotation":
      case "ClassImplements":
      case "DeclareClass":
      case "DeclareFunction":
      case "DeclareInterface":
      case "DeclareModule":
      case "DeclareModuleExports":
      case "DeclareTypeAlias":
      case "DeclareOpaqueType":
      case "DeclareVariable":
      case "DeclareExportDeclaration":
      case "DeclareExportAllDeclaration":
      case "DeclaredPredicate":
      case "ExistsTypeAnnotation":
      case "FunctionTypeAnnotation":
      case "FunctionTypeParam":
      case "GenericTypeAnnotation":
      case "InferredPredicate":
      case "InterfaceExtends":
      case "InterfaceDeclaration":
      case "InterfaceTypeAnnotation":
      case "IntersectionTypeAnnotation":
      case "MixedTypeAnnotation":
      case "EmptyTypeAnnotation":
      case "NullableTypeAnnotation":
      case "NumberLiteralTypeAnnotation":
      case "NumberTypeAnnotation":
      case "ObjectTypeAnnotation":
      case "ObjectTypeInternalSlot":
      case "ObjectTypeCallProperty":
      case "ObjectTypeIndexer":
      case "ObjectTypeProperty":
      case "ObjectTypeSpreadProperty":
      case "OpaqueType":
      case "QualifiedTypeIdentifier":
      case "StringLiteralTypeAnnotation":
      case "StringTypeAnnotation":
      case "SymbolTypeAnnotation":
      case "ThisTypeAnnotation":
      case "TupleTypeAnnotation":
      case "TypeofTypeAnnotation":
      case "TypeAlias":
      case "TypeAnnotation":
      case "TypeCastExpression":
      case "TypeParameter":
      case "TypeParameterDeclaration":
      case "TypeParameterInstantiation":
      case "UnionTypeAnnotation":
      case "Variance":
      case "VoidTypeAnnotation":
      case "EnumDeclaration":
      case "EnumBooleanBody":
      case "EnumNumberBody":
      case "EnumStringBody":
      case "EnumSymbolBody":
      case "EnumBooleanMember":
      case "EnumNumberMember":
      case "EnumStringMember":
      case "EnumDefaultedMember":
      case "IndexedAccessType":
      case "OptionalIndexedAccessType":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFlowType(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "AnyTypeAnnotation":
      case "ArrayTypeAnnotation":
      case "BooleanTypeAnnotation":
      case "BooleanLiteralTypeAnnotation":
      case "NullLiteralTypeAnnotation":
      case "ExistsTypeAnnotation":
      case "FunctionTypeAnnotation":
      case "GenericTypeAnnotation":
      case "InterfaceTypeAnnotation":
      case "IntersectionTypeAnnotation":
      case "MixedTypeAnnotation":
      case "EmptyTypeAnnotation":
      case "NullableTypeAnnotation":
      case "NumberLiteralTypeAnnotation":
      case "NumberTypeAnnotation":
      case "ObjectTypeAnnotation":
      case "StringLiteralTypeAnnotation":
      case "StringTypeAnnotation":
      case "SymbolTypeAnnotation":
      case "ThisTypeAnnotation":
      case "TupleTypeAnnotation":
      case "TypeofTypeAnnotation":
      case "UnionTypeAnnotation":
      case "VoidTypeAnnotation":
      case "IndexedAccessType":
      case "OptionalIndexedAccessType":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFlowBaseAnnotation(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "AnyTypeAnnotation":
      case "BooleanTypeAnnotation":
      case "NullLiteralTypeAnnotation":
      case "MixedTypeAnnotation":
      case "EmptyTypeAnnotation":
      case "NumberTypeAnnotation":
      case "StringTypeAnnotation":
      case "SymbolTypeAnnotation":
      case "ThisTypeAnnotation":
      case "VoidTypeAnnotation":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFlowDeclaration(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "DeclareClass":
      case "DeclareFunction":
      case "DeclareInterface":
      case "DeclareModule":
      case "DeclareModuleExports":
      case "DeclareTypeAlias":
      case "DeclareOpaqueType":
      case "DeclareVariable":
      case "DeclareExportDeclaration":
      case "DeclareExportAllDeclaration":
      case "InterfaceDeclaration":
      case "OpaqueType":
      case "TypeAlias":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isFlowPredicate(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "DeclaredPredicate":
      case "InferredPredicate":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumBody(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "EnumBooleanBody":
      case "EnumNumberBody":
      case "EnumStringBody":
      case "EnumSymbolBody":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isEnumMember(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "EnumBooleanMember":
      case "EnumNumberMember":
      case "EnumStringMember":
      case "EnumDefaultedMember":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isJSX(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "JSXAttribute":
      case "JSXClosingElement":
      case "JSXElement":
      case "JSXEmptyExpression":
      case "JSXExpressionContainer":
      case "JSXSpreadChild":
      case "JSXIdentifier":
      case "JSXMemberExpression":
      case "JSXNamespacedName":
      case "JSXOpeningElement":
      case "JSXSpreadAttribute":
      case "JSXText":
      case "JSXFragment":
      case "JSXOpeningFragment":
      case "JSXClosingFragment":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isMiscellaneous(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "Noop":
      case "Placeholder":
      case "V8IntrinsicIdentifier":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTypeScript(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "TSParameterProperty":
      case "TSDeclareFunction":
      case "TSDeclareMethod":
      case "TSQualifiedName":
      case "TSCallSignatureDeclaration":
      case "TSConstructSignatureDeclaration":
      case "TSPropertySignature":
      case "TSMethodSignature":
      case "TSIndexSignature":
      case "TSAnyKeyword":
      case "TSBooleanKeyword":
      case "TSBigIntKeyword":
      case "TSIntrinsicKeyword":
      case "TSNeverKeyword":
      case "TSNullKeyword":
      case "TSNumberKeyword":
      case "TSObjectKeyword":
      case "TSStringKeyword":
      case "TSSymbolKeyword":
      case "TSUndefinedKeyword":
      case "TSUnknownKeyword":
      case "TSVoidKeyword":
      case "TSThisType":
      case "TSFunctionType":
      case "TSConstructorType":
      case "TSTypeReference":
      case "TSTypePredicate":
      case "TSTypeQuery":
      case "TSTypeLiteral":
      case "TSArrayType":
      case "TSTupleType":
      case "TSOptionalType":
      case "TSRestType":
      case "TSNamedTupleMember":
      case "TSUnionType":
      case "TSIntersectionType":
      case "TSConditionalType":
      case "TSInferType":
      case "TSParenthesizedType":
      case "TSTypeOperator":
      case "TSIndexedAccessType":
      case "TSMappedType":
      case "TSLiteralType":
      case "TSExpressionWithTypeArguments":
      case "TSInterfaceDeclaration":
      case "TSInterfaceBody":
      case "TSTypeAliasDeclaration":
      case "TSInstantiationExpression":
      case "TSAsExpression":
      case "TSSatisfiesExpression":
      case "TSTypeAssertion":
      case "TSEnumDeclaration":
      case "TSEnumMember":
      case "TSModuleDeclaration":
      case "TSModuleBlock":
      case "TSImportType":
      case "TSImportEqualsDeclaration":
      case "TSExternalModuleReference":
      case "TSNonNullExpression":
      case "TSExportAssignment":
      case "TSNamespaceExportDeclaration":
      case "TSTypeAnnotation":
      case "TSTypeParameterInstantiation":
      case "TSTypeParameterDeclaration":
      case "TSTypeParameter":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSTypeElement(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "TSCallSignatureDeclaration":
      case "TSConstructSignatureDeclaration":
      case "TSPropertySignature":
      case "TSMethodSignature":
      case "TSIndexSignature":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSType(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "TSAnyKeyword":
      case "TSBooleanKeyword":
      case "TSBigIntKeyword":
      case "TSIntrinsicKeyword":
      case "TSNeverKeyword":
      case "TSNullKeyword":
      case "TSNumberKeyword":
      case "TSObjectKeyword":
      case "TSStringKeyword":
      case "TSSymbolKeyword":
      case "TSUndefinedKeyword":
      case "TSUnknownKeyword":
      case "TSVoidKeyword":
      case "TSThisType":
      case "TSFunctionType":
      case "TSConstructorType":
      case "TSTypeReference":
      case "TSTypePredicate":
      case "TSTypeQuery":
      case "TSTypeLiteral":
      case "TSArrayType":
      case "TSTupleType":
      case "TSOptionalType":
      case "TSRestType":
      case "TSUnionType":
      case "TSIntersectionType":
      case "TSConditionalType":
      case "TSInferType":
      case "TSParenthesizedType":
      case "TSTypeOperator":
      case "TSIndexedAccessType":
      case "TSMappedType":
      case "TSLiteralType":
      case "TSExpressionWithTypeArguments":
      case "TSImportType":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isTSBaseType(node, opts) {
    if (!node)
      return false;
    switch (node.type) {
      case "TSAnyKeyword":
      case "TSBooleanKeyword":
      case "TSBigIntKeyword":
      case "TSIntrinsicKeyword":
      case "TSNeverKeyword":
      case "TSNullKeyword":
      case "TSNumberKeyword":
      case "TSObjectKeyword":
      case "TSStringKeyword":
      case "TSSymbolKeyword":
      case "TSUndefinedKeyword":
      case "TSUnknownKeyword":
      case "TSVoidKeyword":
      case "TSThisType":
      case "TSLiteralType":
        break;
      default:
        return false;
    }
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isNumberLiteral(node, opts) {
    (0, _deprecationWarning.default)("isNumberLiteral", "isNumericLiteral");
    if (!node)
      return false;
    if (node.type !== "NumberLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isRegexLiteral(node, opts) {
    (0, _deprecationWarning.default)("isRegexLiteral", "isRegExpLiteral");
    if (!node)
      return false;
    if (node.type !== "RegexLiteral")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isRestProperty(node, opts) {
    (0, _deprecationWarning.default)("isRestProperty", "isRestElement");
    if (!node)
      return false;
    if (node.type !== "RestProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isSpreadProperty(node, opts) {
    (0, _deprecationWarning.default)("isSpreadProperty", "isSpreadElement");
    if (!node)
      return false;
    if (node.type !== "SpreadProperty")
      return false;
    return opts == null || (0, _shallowEqual.default)(node, opts);
  }
  function isModuleDeclaration(node, opts) {
    (0, _deprecationWarning.default)("isModuleDeclaration", "isImportOrExportDeclaration");
    return isImportOrExportDeclaration(node, opts);
  }
});
var require_matchesPattern = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = matchesPattern;
  var _index = require_generated();
  function matchesPattern(member, match, allowPartial) {
    if (!(0, _index.isMemberExpression)(member))
      return false;
    const parts = Array.isArray(match) ? match : match.split(".");
    const nodes = [];
    let node;
    for (node = member;(0, _index.isMemberExpression)(node); node = node.object) {
      nodes.push(node.property);
    }
    nodes.push(node);
    if (nodes.length < parts.length)
      return false;
    if (!allowPartial && nodes.length > parts.length)
      return false;
    for (let i = 0, j22 = nodes.length - 1;i < parts.length; i++, j22--) {
      const node2 = nodes[j22];
      let value;
      if ((0, _index.isIdentifier)(node2)) {
        value = node2.name;
      } else if ((0, _index.isStringLiteral)(node2)) {
        value = node2.value;
      } else if ((0, _index.isThisExpression)(node2)) {
        value = "this";
      } else {
        return false;
      }
      if (parts[i] !== value)
        return false;
    }
    return true;
  }
});
var require_buildMatchMemberExpression = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = buildMatchMemberExpression;
  var _matchesPattern = require_matchesPattern();
  function buildMatchMemberExpression(match, allowPartial) {
    const parts = match.split(".");
    return (member) => (0, _matchesPattern.default)(member, parts, allowPartial);
  }
});
var require_isReactComponent = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _buildMatchMemberExpression = require_buildMatchMemberExpression();
  var isReactComponent = (0, _buildMatchMemberExpression.default)("React.Component");
  var _default = exports.default = isReactComponent;
});
var require_isCompatTag = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isCompatTag;
  function isCompatTag(tagName) {
    return !!tagName && /^[a-z]/.test(tagName);
  }
});
var require_isType = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isType;
  var _index = require_definitions();
  function isType(nodeType, targetType) {
    if (nodeType === targetType)
      return true;
    if (nodeType == null)
      return false;
    if (_index.ALIAS_KEYS[targetType])
      return false;
    const aliases = _index.FLIPPED_ALIAS_KEYS[targetType];
    if (aliases) {
      if (aliases[0] === nodeType)
        return true;
      for (const alias of aliases) {
        if (nodeType === alias)
          return true;
      }
    }
    return false;
  }
});
var require_isPlaceholderType = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isPlaceholderType;
  var _index = require_definitions();
  function isPlaceholderType(placeholderType, targetType) {
    if (placeholderType === targetType)
      return true;
    const aliases = _index.PLACEHOLDERS_ALIAS[placeholderType];
    if (aliases) {
      for (const alias of aliases) {
        if (targetType === alias)
          return true;
      }
    }
    return false;
  }
});
var require_is = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = is3;
  var _shallowEqual = require_shallowEqual();
  var _isType = require_isType();
  var _isPlaceholderType = require_isPlaceholderType();
  var _index = require_definitions();
  function is3(type, node, opts) {
    if (!node)
      return false;
    const matches = (0, _isType.default)(node.type, type);
    if (!matches) {
      if (!opts && node.type === "Placeholder" && type in _index.FLIPPED_ALIAS_KEYS) {
        return (0, _isPlaceholderType.default)(node.expectedNode, type);
      }
      return false;
    }
    if (opts === undefined) {
      return true;
    } else {
      return (0, _shallowEqual.default)(node, opts);
    }
  }
});
var require_identifier = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.isIdentifierChar = isIdentifierChar;
  exports.isIdentifierName = isIdentifierName;
  exports.isIdentifierStart = isIdentifierStart;
  var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C8A\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CD\uA7D0\uA7D1\uA7D3\uA7D5-\uA7DC\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
  var nonASCIIidentifierChars = "\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0897-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0CF3\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECE\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\u30FB\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F\uFF65";
  var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
  var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 4, 51, 13, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 39, 27, 10, 22, 251, 41, 7, 1, 17, 2, 60, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 31, 9, 2, 0, 3, 0, 2, 37, 2, 0, 26, 0, 2, 0, 45, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 200, 32, 32, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 26, 3994, 6, 582, 6842, 29, 1763, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 433, 44, 212, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 42, 9, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 229, 29, 3, 0, 496, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191];
  var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 7, 9, 32, 4, 318, 1, 80, 3, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 68, 8, 2, 0, 3, 0, 2, 3, 2, 4, 2, 0, 15, 1, 83, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 7, 19, 58, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 343, 9, 54, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 10, 5350, 0, 7, 14, 11465, 27, 2343, 9, 87, 9, 39, 4, 60, 6, 26, 9, 535, 9, 470, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4178, 9, 519, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 245, 1, 2, 9, 726, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
  function isInAstralSet(code, set) {
    let pos = 65536;
    for (let i = 0, length = set.length;i < length; i += 2) {
      pos += set[i];
      if (pos > code)
        return false;
      pos += set[i + 1];
      if (pos >= code)
        return true;
    }
    return false;
  }
  function isIdentifierStart(code) {
    if (code < 65)
      return code === 36;
    if (code <= 90)
      return true;
    if (code < 97)
      return code === 95;
    if (code <= 122)
      return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code) {
    if (code < 48)
      return code === 36;
    if (code < 58)
      return true;
    if (code < 65)
      return false;
    if (code <= 90)
      return true;
    if (code < 97)
      return code === 95;
    if (code <= 122)
      return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
  }
  function isIdentifierName(name) {
    let isFirst = true;
    for (let i = 0;i < name.length; i++) {
      let cp = name.charCodeAt(i);
      if ((cp & 64512) === 55296 && i + 1 < name.length) {
        const trail = name.charCodeAt(++i);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      if (isFirst) {
        isFirst = false;
        if (!isIdentifierStart(cp)) {
          return false;
        }
      } else if (!isIdentifierChar(cp)) {
        return false;
      }
    }
    return !isFirst;
  }
});
var require_keyword = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.isKeyword = isKeyword;
  exports.isReservedWord = isReservedWord;
  exports.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
  exports.isStrictBindReservedWord = isStrictBindReservedWord;
  exports.isStrictReservedWord = isStrictReservedWord;
  var reservedWords = {
    keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
    strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
    strictBind: ["eval", "arguments"]
  };
  var keywords = new Set(reservedWords.keyword);
  var reservedWordsStrictSet = new Set(reservedWords.strict);
  var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return inModule && word === "await" || word === "enum";
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
});
var require_lib4 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "isIdentifierChar", {
    enumerable: true,
    get: function() {
      return _identifier.isIdentifierChar;
    }
  });
  Object.defineProperty(exports, "isIdentifierName", {
    enumerable: true,
    get: function() {
      return _identifier.isIdentifierName;
    }
  });
  Object.defineProperty(exports, "isIdentifierStart", {
    enumerable: true,
    get: function() {
      return _identifier.isIdentifierStart;
    }
  });
  Object.defineProperty(exports, "isKeyword", {
    enumerable: true,
    get: function() {
      return _keyword.isKeyword;
    }
  });
  Object.defineProperty(exports, "isReservedWord", {
    enumerable: true,
    get: function() {
      return _keyword.isReservedWord;
    }
  });
  Object.defineProperty(exports, "isStrictBindOnlyReservedWord", {
    enumerable: true,
    get: function() {
      return _keyword.isStrictBindOnlyReservedWord;
    }
  });
  Object.defineProperty(exports, "isStrictBindReservedWord", {
    enumerable: true,
    get: function() {
      return _keyword.isStrictBindReservedWord;
    }
  });
  Object.defineProperty(exports, "isStrictReservedWord", {
    enumerable: true,
    get: function() {
      return _keyword.isStrictReservedWord;
    }
  });
  var _identifier = require_identifier();
  var _keyword = require_keyword();
});
var require_isValidIdentifier = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isValidIdentifier;
  var _helperValidatorIdentifier = require_lib4();
  function isValidIdentifier(name, reserved = true) {
    if (typeof name !== "string")
      return false;
    if (reserved) {
      if ((0, _helperValidatorIdentifier.isKeyword)(name) || (0, _helperValidatorIdentifier.isStrictReservedWord)(name, true)) {
        return false;
      }
    }
    return (0, _helperValidatorIdentifier.isIdentifierName)(name);
  }
});
var require_lib5 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.readCodePoint = readCodePoint;
  exports.readInt = readInt;
  exports.readStringContents = readStringContents;
  var _isDigit = function isDigit(code) {
    return code >= 48 && code <= 57;
  };
  var forbiddenNumericSeparatorSiblings = {
    decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
    hex: new Set([46, 88, 95, 120])
  };
  var isAllowedNumericSeparatorSibling = {
    bin: (ch) => ch === 48 || ch === 49,
    oct: (ch) => ch >= 48 && ch <= 55,
    dec: (ch) => ch >= 48 && ch <= 57,
    hex: (ch) => ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102
  };
  function readStringContents(type, input, pos, lineStart, curLine, errors3) {
    const initialPos = pos;
    const initialLineStart = lineStart;
    const initialCurLine = curLine;
    let out = "";
    let firstInvalidLoc = null;
    let chunkStart = pos;
    const {
      length
    } = input;
    for (;; ) {
      if (pos >= length) {
        errors3.unterminated(initialPos, initialLineStart, initialCurLine);
        out += input.slice(chunkStart, pos);
        break;
      }
      const ch = input.charCodeAt(pos);
      if (isStringEnd(type, ch, input, pos)) {
        out += input.slice(chunkStart, pos);
        break;
      }
      if (ch === 92) {
        out += input.slice(chunkStart, pos);
        const res = readEscapedChar(input, pos, lineStart, curLine, type === "template", errors3);
        if (res.ch === null && !firstInvalidLoc) {
          firstInvalidLoc = {
            pos,
            lineStart,
            curLine
          };
        } else {
          out += res.ch;
        }
        ({
          pos,
          lineStart,
          curLine
        } = res);
        chunkStart = pos;
      } else if (ch === 8232 || ch === 8233) {
        ++pos;
        ++curLine;
        lineStart = pos;
      } else if (ch === 10 || ch === 13) {
        if (type === "template") {
          out += input.slice(chunkStart, pos) + "\n";
          ++pos;
          if (ch === 13 && input.charCodeAt(pos) === 10) {
            ++pos;
          }
          ++curLine;
          chunkStart = lineStart = pos;
        } else {
          errors3.unterminated(initialPos, initialLineStart, initialCurLine);
        }
      } else {
        ++pos;
      }
    }
    return {
      pos,
      str: out,
      firstInvalidLoc,
      lineStart,
      curLine,
      containsInvalid: !!firstInvalidLoc
    };
  }
  function isStringEnd(type, ch, input, pos) {
    if (type === "template") {
      return ch === 96 || ch === 36 && input.charCodeAt(pos + 1) === 123;
    }
    return ch === (type === "double" ? 34 : 39);
  }
  function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors3) {
    const throwOnInvalid = !inTemplate;
    pos++;
    const res = (ch2) => ({
      pos,
      ch: ch2,
      lineStart,
      curLine
    });
    const ch = input.charCodeAt(pos++);
    switch (ch) {
      case 110:
        return res("\n");
      case 114:
        return res("\r");
      case 120: {
        let code;
        ({
          code,
          pos
        } = readHexChar(input, pos, lineStart, curLine, 2, false, throwOnInvalid, errors3));
        return res(code === null ? null : String.fromCharCode(code));
      }
      case 117: {
        let code;
        ({
          code,
          pos
        } = readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors3));
        return res(code === null ? null : String.fromCodePoint(code));
      }
      case 116:
        return res("\t");
      case 98:
        return res("\b");
      case 118:
        return res("\v");
      case 102:
        return res("\f");
      case 13:
        if (input.charCodeAt(pos) === 10) {
          ++pos;
        }
      case 10:
        lineStart = pos;
        ++curLine;
      case 8232:
      case 8233:
        return res("");
      case 56:
      case 57:
        if (inTemplate) {
          return res(null);
        } else {
          errors3.strictNumericEscape(pos - 1, lineStart, curLine);
        }
      default:
        if (ch >= 48 && ch <= 55) {
          const startPos = pos - 1;
          const match = /^[0-7]+/.exec(input.slice(startPos, pos + 2));
          let octalStr = match[0];
          let octal = parseInt(octalStr, 8);
          if (octal > 255) {
            octalStr = octalStr.slice(0, -1);
            octal = parseInt(octalStr, 8);
          }
          pos += octalStr.length - 1;
          const next = input.charCodeAt(pos);
          if (octalStr !== "0" || next === 56 || next === 57) {
            if (inTemplate) {
              return res(null);
            } else {
              errors3.strictNumericEscape(startPos, lineStart, curLine);
            }
          }
          return res(String.fromCharCode(octal));
        }
        return res(String.fromCharCode(ch));
    }
  }
  function readHexChar(input, pos, lineStart, curLine, len, forceLen, throwOnInvalid, errors3) {
    const initialPos = pos;
    let n;
    ({
      n,
      pos
    } = readInt(input, pos, lineStart, curLine, 16, len, forceLen, false, errors3, !throwOnInvalid));
    if (n === null) {
      if (throwOnInvalid) {
        errors3.invalidEscapeSequence(initialPos, lineStart, curLine);
      } else {
        pos = initialPos - 1;
      }
    }
    return {
      code: n,
      pos
    };
  }
  function readInt(input, pos, lineStart, curLine, radix, len, forceLen, allowNumSeparator, errors3, bailOnError) {
    const start = pos;
    const forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
    const isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling.hex : radix === 10 ? isAllowedNumericSeparatorSibling.dec : radix === 8 ? isAllowedNumericSeparatorSibling.oct : isAllowedNumericSeparatorSibling.bin;
    let invalid = false;
    let total = 0;
    for (let i = 0, e = len == null ? Infinity : len;i < e; ++i) {
      const code = input.charCodeAt(pos);
      let val2;
      if (code === 95 && allowNumSeparator !== "bail") {
        const prev = input.charCodeAt(pos - 1);
        const next = input.charCodeAt(pos + 1);
        if (!allowNumSeparator) {
          if (bailOnError)
            return {
              n: null,
              pos
            };
          errors3.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
        } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
          if (bailOnError)
            return {
              n: null,
              pos
            };
          errors3.unexpectedNumericSeparator(pos, lineStart, curLine);
        }
        ++pos;
        continue;
      }
      if (code >= 97) {
        val2 = code - 97 + 10;
      } else if (code >= 65) {
        val2 = code - 65 + 10;
      } else if (_isDigit(code)) {
        val2 = code - 48;
      } else {
        val2 = Infinity;
      }
      if (val2 >= radix) {
        if (val2 <= 9 && bailOnError) {
          return {
            n: null,
            pos
          };
        } else if (val2 <= 9 && errors3.invalidDigit(pos, lineStart, curLine, radix)) {
          val2 = 0;
        } else if (forceLen) {
          val2 = 0;
          invalid = true;
        } else {
          break;
        }
      }
      ++pos;
      total = total * radix + val2;
    }
    if (pos === start || len != null && pos - start !== len || invalid) {
      return {
        n: null,
        pos
      };
    }
    return {
      n: total,
      pos
    };
  }
  function readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors3) {
    const ch = input.charCodeAt(pos);
    let code;
    if (ch === 123) {
      ++pos;
      ({
        code,
        pos
      } = readHexChar(input, pos, lineStart, curLine, input.indexOf("}", pos) - pos, true, throwOnInvalid, errors3));
      ++pos;
      if (code !== null && code > 1114111) {
        if (throwOnInvalid) {
          errors3.invalidCodePoint(pos, lineStart, curLine);
        } else {
          return {
            code: null,
            pos
          };
        }
      }
    } else {
      ({
        code,
        pos
      } = readHexChar(input, pos, lineStart, curLine, 4, false, throwOnInvalid, errors3));
    }
    return {
      code,
      pos
    };
  }
});
var require_constants = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.UPDATE_OPERATORS = exports.UNARY_OPERATORS = exports.STRING_UNARY_OPERATORS = exports.STATEMENT_OR_BLOCK_KEYS = exports.NUMBER_UNARY_OPERATORS = exports.NUMBER_BINARY_OPERATORS = exports.NOT_LOCAL_BINDING = exports.LOGICAL_OPERATORS = exports.INHERIT_KEYS = exports.FOR_INIT_KEYS = exports.FLATTENABLE_KEYS = exports.EQUALITY_BINARY_OPERATORS = exports.COMPARISON_BINARY_OPERATORS = exports.COMMENT_KEYS = exports.BOOLEAN_UNARY_OPERATORS = exports.BOOLEAN_NUMBER_BINARY_OPERATORS = exports.BOOLEAN_BINARY_OPERATORS = exports.BLOCK_SCOPED_SYMBOL = exports.BINARY_OPERATORS = exports.ASSIGNMENT_OPERATORS = undefined;
  var STATEMENT_OR_BLOCK_KEYS = exports.STATEMENT_OR_BLOCK_KEYS = ["consequent", "body", "alternate"];
  var FLATTENABLE_KEYS = exports.FLATTENABLE_KEYS = ["body", "expressions"];
  var FOR_INIT_KEYS = exports.FOR_INIT_KEYS = ["left", "init"];
  var COMMENT_KEYS = exports.COMMENT_KEYS = ["leadingComments", "trailingComments", "innerComments"];
  var LOGICAL_OPERATORS = exports.LOGICAL_OPERATORS = ["||", "&&", "??"];
  var UPDATE_OPERATORS = exports.UPDATE_OPERATORS = ["++", "--"];
  var BOOLEAN_NUMBER_BINARY_OPERATORS = exports.BOOLEAN_NUMBER_BINARY_OPERATORS = [">", "<", ">=", "<="];
  var EQUALITY_BINARY_OPERATORS = exports.EQUALITY_BINARY_OPERATORS = ["==", "===", "!=", "!=="];
  var COMPARISON_BINARY_OPERATORS = exports.COMPARISON_BINARY_OPERATORS = [...EQUALITY_BINARY_OPERATORS, "in", "instanceof"];
  var BOOLEAN_BINARY_OPERATORS = exports.BOOLEAN_BINARY_OPERATORS = [...COMPARISON_BINARY_OPERATORS, ...BOOLEAN_NUMBER_BINARY_OPERATORS];
  var NUMBER_BINARY_OPERATORS = exports.NUMBER_BINARY_OPERATORS = ["-", "/", "%", "*", "**", "&", "|", ">>", ">>>", "<<", "^"];
  var BINARY_OPERATORS = exports.BINARY_OPERATORS = ["+", ...NUMBER_BINARY_OPERATORS, ...BOOLEAN_BINARY_OPERATORS, "|>"];
  var ASSIGNMENT_OPERATORS = exports.ASSIGNMENT_OPERATORS = ["=", "+=", ...NUMBER_BINARY_OPERATORS.map((op) => op + "="), ...LOGICAL_OPERATORS.map((op) => op + "=")];
  var BOOLEAN_UNARY_OPERATORS = exports.BOOLEAN_UNARY_OPERATORS = ["delete", "!"];
  var NUMBER_UNARY_OPERATORS = exports.NUMBER_UNARY_OPERATORS = ["+", "-", "~"];
  var STRING_UNARY_OPERATORS = exports.STRING_UNARY_OPERATORS = ["typeof"];
  var UNARY_OPERATORS = exports.UNARY_OPERATORS = ["void", "throw", ...BOOLEAN_UNARY_OPERATORS, ...NUMBER_UNARY_OPERATORS, ...STRING_UNARY_OPERATORS];
  var INHERIT_KEYS = exports.INHERIT_KEYS = {
    optional: ["typeAnnotation", "typeParameters", "returnType"],
    force: ["start", "loc", "end"]
  };
  var BLOCK_SCOPED_SYMBOL = exports.BLOCK_SCOPED_SYMBOL = Symbol.for("var used to be block scoped");
  var NOT_LOCAL_BINDING = exports.NOT_LOCAL_BINDING = Symbol.for("should not be considered a local binding");
});
var require_utils3 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.VISITOR_KEYS = exports.NODE_PARENT_VALIDATIONS = exports.NODE_FIELDS = exports.FLIPPED_ALIAS_KEYS = exports.DEPRECATED_KEYS = exports.BUILDER_KEYS = exports.ALIAS_KEYS = undefined;
  exports.arrayOf = arrayOf;
  exports.arrayOfType = arrayOfType;
  exports.assertEach = assertEach;
  exports.assertNodeOrValueType = assertNodeOrValueType;
  exports.assertNodeType = assertNodeType;
  exports.assertOneOf = assertOneOf;
  exports.assertOptionalChainStart = assertOptionalChainStart;
  exports.assertShape = assertShape;
  exports.assertValueType = assertValueType;
  exports.chain = chain;
  exports.default = defineType;
  exports.defineAliasedType = defineAliasedType;
  exports.validate = validate2;
  exports.validateArrayOfType = validateArrayOfType;
  exports.validateOptional = validateOptional;
  exports.validateOptionalType = validateOptionalType;
  exports.validateType = validateType;
  var _is = require_is();
  var _validate = require_validate();
  var VISITOR_KEYS = exports.VISITOR_KEYS = {};
  var ALIAS_KEYS = exports.ALIAS_KEYS = {};
  var FLIPPED_ALIAS_KEYS = exports.FLIPPED_ALIAS_KEYS = {};
  var NODE_FIELDS = exports.NODE_FIELDS = {};
  var BUILDER_KEYS = exports.BUILDER_KEYS = {};
  var DEPRECATED_KEYS = exports.DEPRECATED_KEYS = {};
  var NODE_PARENT_VALIDATIONS = exports.NODE_PARENT_VALIDATIONS = {};
  function getType(val2) {
    if (Array.isArray(val2)) {
      return "array";
    } else if (val2 === null) {
      return "null";
    } else {
      return typeof val2;
    }
  }
  function validate2(validate22) {
    return {
      validate: validate22
    };
  }
  function validateType(...typeNames) {
    return validate2(assertNodeType(...typeNames));
  }
  function validateOptional(validate22) {
    return {
      validate: validate22,
      optional: true
    };
  }
  function validateOptionalType(...typeNames) {
    return {
      validate: assertNodeType(...typeNames),
      optional: true
    };
  }
  function arrayOf(elementType) {
    return chain(assertValueType("array"), assertEach(elementType));
  }
  function arrayOfType(...typeNames) {
    return arrayOf(assertNodeType(...typeNames));
  }
  function validateArrayOfType(...typeNames) {
    return validate2(arrayOfType(...typeNames));
  }
  function assertEach(callback) {
    const childValidator = process.env.BABEL_TYPES_8_BREAKING ? _validate.validateChild : () => {
    };
    function validator2(node, key, val2) {
      if (!Array.isArray(val2))
        return;
      for (let i = 0;i < val2.length; i++) {
        const subkey = `${key}[${i}]`;
        const v22 = val2[i];
        callback(node, subkey, v22);
        childValidator(node, subkey, v22);
      }
    }
    validator2.each = callback;
    return validator2;
  }
  function assertOneOf(...values3) {
    function validate22(node, key, val2) {
      if (!values3.includes(val2)) {
        throw new TypeError(`Property ${key} expected value to be one of ${JSON.stringify(values3)} but got ${JSON.stringify(val2)}`);
      }
    }
    validate22.oneOf = values3;
    return validate22;
  }
  function assertNodeType(...types3) {
    function validate22(node, key, val2) {
      for (const type of types3) {
        if ((0, _is.default)(type, val2)) {
          (0, _validate.validateChild)(node, key, val2);
          return;
        }
      }
      throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types3)} but instead got ${JSON.stringify(val2 == null ? undefined : val2.type)}`);
    }
    validate22.oneOfNodeTypes = types3;
    return validate22;
  }
  function assertNodeOrValueType(...types3) {
    function validate22(node, key, val2) {
      for (const type of types3) {
        if (getType(val2) === type || (0, _is.default)(type, val2)) {
          (0, _validate.validateChild)(node, key, val2);
          return;
        }
      }
      throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types3)} but instead got ${JSON.stringify(val2 == null ? undefined : val2.type)}`);
    }
    validate22.oneOfNodeOrValueTypes = types3;
    return validate22;
  }
  function assertValueType(type) {
    function validate22(node, key, val2) {
      const valid = getType(val2) === type;
      if (!valid) {
        throw new TypeError(`Property ${key} expected type of ${type} but got ${getType(val2)}`);
      }
    }
    validate22.type = type;
    return validate22;
  }
  function assertShape(shape) {
    function validate22(node, key, val2) {
      const errors3 = [];
      for (const property of Object.keys(shape)) {
        try {
          (0, _validate.validateField)(node, property, val2[property], shape[property]);
        } catch (error) {
          if (error instanceof TypeError) {
            errors3.push(error.message);
            continue;
          }
          throw error;
        }
      }
      if (errors3.length) {
        throw new TypeError(`Property ${key} of ${node.type} expected to have the following:\n${errors3.join("\n")}`);
      }
    }
    validate22.shapeOf = shape;
    return validate22;
  }
  function assertOptionalChainStart() {
    function validate22(node) {
      var _current;
      let current = node;
      while (node) {
        const {
          type
        } = current;
        if (type === "OptionalCallExpression") {
          if (current.optional)
            return;
          current = current.callee;
          continue;
        }
        if (type === "OptionalMemberExpression") {
          if (current.optional)
            return;
          current = current.object;
          continue;
        }
        break;
      }
      throw new TypeError(`Non-optional ${node.type} must chain from an optional OptionalMemberExpression or OptionalCallExpression. Found chain from ${(_current = current) == null ? undefined : _current.type}`);
    }
    return validate22;
  }
  function chain(...fns) {
    function validate22(...args) {
      for (const fn of fns) {
        fn(...args);
      }
    }
    validate22.chainOf = fns;
    if (fns.length >= 2 && "type" in fns[0] && fns[0].type === "array" && !("each" in fns[1])) {
      throw new Error(`An assertValueType("array") validator can only be followed by an assertEach(...) validator.`);
    }
    return validate22;
  }
  var validTypeOpts = new Set(["aliases", "builder", "deprecatedAlias", "fields", "inherits", "visitor", "validate"]);
  var validFieldKeys = new Set(["default", "optional", "deprecated", "validate"]);
  var store = {};
  function defineAliasedType(...aliases) {
    return (type, opts = {}) => {
      let defined = opts.aliases;
      if (!defined) {
        var _store$opts$inherits$, _defined;
        if (opts.inherits)
          defined = (_store$opts$inherits$ = store[opts.inherits].aliases) == null ? undefined : _store$opts$inherits$.slice();
        (_defined = defined) != null || (defined = []);
        opts.aliases = defined;
      }
      const additional = aliases.filter((a) => !defined.includes(a));
      defined.unshift(...additional);
      defineType(type, opts);
    };
  }
  function defineType(type, opts = {}) {
    const inherits = opts.inherits && store[opts.inherits] || {};
    let fields22 = opts.fields;
    if (!fields22) {
      fields22 = {};
      if (inherits.fields) {
        const keys = Object.getOwnPropertyNames(inherits.fields);
        for (const key of keys) {
          const field = inherits.fields[key];
          const def = field.default;
          if (Array.isArray(def) ? def.length > 0 : def && typeof def === "object") {
            throw new Error("field defaults can only be primitives or empty arrays currently");
          }
          fields22[key] = {
            default: Array.isArray(def) ? [] : def,
            optional: field.optional,
            deprecated: field.deprecated,
            validate: field.validate
          };
        }
      }
    }
    const visitor = opts.visitor || inherits.visitor || [];
    const aliases = opts.aliases || inherits.aliases || [];
    const builder = opts.builder || inherits.builder || opts.visitor || [];
    for (const k of Object.keys(opts)) {
      if (!validTypeOpts.has(k)) {
        throw new Error(`Unknown type option "${k}" on ${type}`);
      }
    }
    if (opts.deprecatedAlias) {
      DEPRECATED_KEYS[opts.deprecatedAlias] = type;
    }
    for (const key of visitor.concat(builder)) {
      fields22[key] = fields22[key] || {};
    }
    for (const key of Object.keys(fields22)) {
      const field = fields22[key];
      if (field.default !== undefined && !builder.includes(key)) {
        field.optional = true;
      }
      if (field.default === undefined) {
        field.default = null;
      } else if (!field.validate && field.default != null) {
        field.validate = assertValueType(getType(field.default));
      }
      for (const k of Object.keys(field)) {
        if (!validFieldKeys.has(k)) {
          throw new Error(`Unknown field key "${k}" on ${type}.${key}`);
        }
      }
    }
    VISITOR_KEYS[type] = opts.visitor = visitor;
    BUILDER_KEYS[type] = opts.builder = builder;
    NODE_FIELDS[type] = opts.fields = fields22;
    ALIAS_KEYS[type] = opts.aliases = aliases;
    aliases.forEach((alias) => {
      FLIPPED_ALIAS_KEYS[alias] = FLIPPED_ALIAS_KEYS[alias] || [];
      FLIPPED_ALIAS_KEYS[alias].push(type);
    });
    if (opts.validate) {
      NODE_PARENT_VALIDATIONS[type] = opts.validate;
    }
    store[type] = opts;
  }
});
var require_core = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.patternLikeCommon = exports.functionTypeAnnotationCommon = exports.functionDeclarationCommon = exports.functionCommon = exports.classMethodOrPropertyCommon = exports.classMethodOrDeclareMethodCommon = undefined;
  var _is = require_is();
  var _isValidIdentifier = require_isValidIdentifier();
  var _helperValidatorIdentifier = require_lib4();
  var _helperStringParser = require_lib5();
  var _index = require_constants();
  var _utils = require_utils3();
  var defineType = (0, _utils.defineAliasedType)("Standardized");
  defineType("ArrayExpression", {
    fields: {
      elements: {
        validate: (0, _utils.arrayOf)((0, _utils.assertNodeOrValueType)("null", "Expression", "SpreadElement")),
        default: !process.env.BABEL_TYPES_8_BREAKING ? [] : undefined
      }
    },
    visitor: ["elements"],
    aliases: ["Expression"]
  });
  defineType("AssignmentExpression", {
    fields: {
      operator: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertValueType)("string") : Object.assign(function() {
          const identifier = (0, _utils.assertOneOf)(..._index.ASSIGNMENT_OPERATORS);
          const pattern = (0, _utils.assertOneOf)("=");
          return function(node, key, val2) {
            const validator2 = (0, _is.default)("Pattern", node.left) ? pattern : identifier;
            validator2(node, key, val2);
          };
        }(), {
          type: "string"
        })
      },
      left: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("LVal", "OptionalMemberExpression") : (0, _utils.assertNodeType)("Identifier", "MemberExpression", "OptionalMemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
      },
      right: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    },
    builder: ["operator", "left", "right"],
    visitor: ["left", "right"],
    aliases: ["Expression"]
  });
  defineType("BinaryExpression", {
    builder: ["operator", "left", "right"],
    fields: {
      operator: {
        validate: (0, _utils.assertOneOf)(..._index.BINARY_OPERATORS)
      },
      left: {
        validate: function() {
          const expression = (0, _utils.assertNodeType)("Expression");
          const inOp = (0, _utils.assertNodeType)("Expression", "PrivateName");
          const validator2 = Object.assign(function(node, key, val2) {
            const validator3 = node.operator === "in" ? inOp : expression;
            validator3(node, key, val2);
          }, {
            oneOfNodeTypes: ["Expression", "PrivateName"]
          });
          return validator2;
        }()
      },
      right: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    },
    visitor: ["left", "right"],
    aliases: ["Binary", "Expression"]
  });
  defineType("InterpreterDirective", {
    builder: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertValueType)("string")
      }
    }
  });
  defineType("Directive", {
    visitor: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertNodeType)("DirectiveLiteral")
      }
    }
  });
  defineType("DirectiveLiteral", {
    builder: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertValueType)("string")
      }
    }
  });
  defineType("BlockStatement", {
    builder: ["body", "directives"],
    visitor: ["directives", "body"],
    fields: {
      directives: {
        validate: (0, _utils.arrayOfType)("Directive"),
        default: []
      },
      body: (0, _utils.validateArrayOfType)("Statement")
    },
    aliases: ["Scopable", "BlockParent", "Block", "Statement"]
  });
  defineType("BreakStatement", {
    visitor: ["label"],
    fields: {
      label: {
        validate: (0, _utils.assertNodeType)("Identifier"),
        optional: true
      }
    },
    aliases: ["Statement", "Terminatorless", "CompletionStatement"]
  });
  defineType("CallExpression", {
    visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
    builder: ["callee", "arguments"],
    aliases: ["Expression"],
    fields: Object.assign({
      callee: {
        validate: (0, _utils.assertNodeType)("Expression", "Super", "V8IntrinsicIdentifier")
      },
      arguments: (0, _utils.validateArrayOfType)("Expression", "SpreadElement", "ArgumentPlaceholder")
    }, !process.env.BABEL_TYPES_8_BREAKING ? {
      optional: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      }
    } : {}, {
      typeArguments: {
        validate: (0, _utils.assertNodeType)("TypeParameterInstantiation"),
        optional: true
      },
      typeParameters: {
        validate: (0, _utils.assertNodeType)("TSTypeParameterInstantiation"),
        optional: true
      }
    })
  });
  defineType("CatchClause", {
    visitor: ["param", "body"],
    fields: {
      param: {
        validate: (0, _utils.assertNodeType)("Identifier", "ArrayPattern", "ObjectPattern"),
        optional: true
      },
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement")
      }
    },
    aliases: ["Scopable", "BlockParent"]
  });
  defineType("ConditionalExpression", {
    visitor: ["test", "consequent", "alternate"],
    fields: {
      test: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      consequent: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      alternate: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    },
    aliases: ["Expression", "Conditional"]
  });
  defineType("ContinueStatement", {
    visitor: ["label"],
    fields: {
      label: {
        validate: (0, _utils.assertNodeType)("Identifier"),
        optional: true
      }
    },
    aliases: ["Statement", "Terminatorless", "CompletionStatement"]
  });
  defineType("DebuggerStatement", {
    aliases: ["Statement"]
  });
  defineType("DoWhileStatement", {
    builder: ["test", "body"],
    visitor: ["body", "test"],
    fields: {
      test: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      body: {
        validate: (0, _utils.assertNodeType)("Statement")
      }
    },
    aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"]
  });
  defineType("EmptyStatement", {
    aliases: ["Statement"]
  });
  defineType("ExpressionStatement", {
    visitor: ["expression"],
    fields: {
      expression: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    },
    aliases: ["Statement", "ExpressionWrapper"]
  });
  defineType("File", {
    builder: ["program", "comments", "tokens"],
    visitor: ["program"],
    fields: {
      program: {
        validate: (0, _utils.assertNodeType)("Program")
      },
      comments: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? Object.assign(() => {
        }, {
          each: {
            oneOfNodeTypes: ["CommentBlock", "CommentLine"]
          }
        }) : (0, _utils.assertEach)((0, _utils.assertNodeType)("CommentBlock", "CommentLine")),
        optional: true
      },
      tokens: {
        validate: (0, _utils.assertEach)(Object.assign(() => {
        }, {
          type: "any"
        })),
        optional: true
      }
    }
  });
  defineType("ForInStatement", {
    visitor: ["left", "right", "body"],
    aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
    fields: {
      left: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("VariableDeclaration", "LVal") : (0, _utils.assertNodeType)("VariableDeclaration", "Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
      },
      right: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      body: {
        validate: (0, _utils.assertNodeType)("Statement")
      }
    }
  });
  defineType("ForStatement", {
    visitor: ["init", "test", "update", "body"],
    aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop"],
    fields: {
      init: {
        validate: (0, _utils.assertNodeType)("VariableDeclaration", "Expression"),
        optional: true
      },
      test: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      },
      update: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      },
      body: {
        validate: (0, _utils.assertNodeType)("Statement")
      }
    }
  });
  var functionCommon = () => ({
    params: (0, _utils.validateArrayOfType)("Identifier", "Pattern", "RestElement"),
    generator: {
      default: false
    },
    async: {
      default: false
    }
  });
  exports.functionCommon = functionCommon;
  var functionTypeAnnotationCommon = () => ({
    returnType: {
      validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
      optional: true
    },
    typeParameters: {
      validate: (0, _utils.assertNodeType)("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
      optional: true
    }
  });
  exports.functionTypeAnnotationCommon = functionTypeAnnotationCommon;
  var functionDeclarationCommon = () => Object.assign({}, functionCommon(), {
    declare: {
      validate: (0, _utils.assertValueType)("boolean"),
      optional: true
    },
    id: {
      validate: (0, _utils.assertNodeType)("Identifier"),
      optional: true
    }
  });
  exports.functionDeclarationCommon = functionDeclarationCommon;
  defineType("FunctionDeclaration", {
    builder: ["id", "params", "body", "generator", "async"],
    visitor: ["id", "typeParameters", "params", "returnType", "body"],
    fields: Object.assign({}, functionDeclarationCommon(), functionTypeAnnotationCommon(), {
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement")
      },
      predicate: {
        validate: (0, _utils.assertNodeType)("DeclaredPredicate", "InferredPredicate"),
        optional: true
      }
    }),
    aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Statement", "Pureish", "Declaration"],
    validate: !process.env.BABEL_TYPES_8_BREAKING ? undefined : function() {
      const identifier = (0, _utils.assertNodeType)("Identifier");
      return function(parent, key, node) {
        if (!(0, _is.default)("ExportDefaultDeclaration", parent)) {
          identifier(node, "id", node.id);
        }
      };
    }()
  });
  defineType("FunctionExpression", {
    inherits: "FunctionDeclaration",
    aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
      id: {
        validate: (0, _utils.assertNodeType)("Identifier"),
        optional: true
      },
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement")
      },
      predicate: {
        validate: (0, _utils.assertNodeType)("DeclaredPredicate", "InferredPredicate"),
        optional: true
      }
    })
  });
  var patternLikeCommon = () => ({
    typeAnnotation: {
      validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
      optional: true
    },
    optional: {
      validate: (0, _utils.assertValueType)("boolean"),
      optional: true
    },
    decorators: {
      validate: (0, _utils.arrayOfType)("Decorator"),
      optional: true
    }
  });
  exports.patternLikeCommon = patternLikeCommon;
  defineType("Identifier", {
    builder: ["name"],
    visitor: ["typeAnnotation", "decorators"],
    aliases: ["Expression", "PatternLike", "LVal", "TSEntityName"],
    fields: Object.assign({}, patternLikeCommon(), {
      name: {
        validate: process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.chain)((0, _utils.assertValueType)("string"), Object.assign(function(node, key, val2) {
          if (!(0, _isValidIdentifier.default)(val2, false)) {
            throw new TypeError(`"${val2}" is not a valid identifier name`);
          }
        }, {
          type: "string"
        })) : (0, _utils.assertValueType)("string")
      }
    }),
    validate: process.env.BABEL_TYPES_8_BREAKING ? function(parent, key, node) {
      const match = /\.(\w+)$/.exec(key);
      if (!match)
        return;
      const [, parentKey] = match;
      const nonComp = {
        computed: false
      };
      if (parentKey === "property") {
        if ((0, _is.default)("MemberExpression", parent, nonComp))
          return;
        if ((0, _is.default)("OptionalMemberExpression", parent, nonComp))
          return;
      } else if (parentKey === "key") {
        if ((0, _is.default)("Property", parent, nonComp))
          return;
        if ((0, _is.default)("Method", parent, nonComp))
          return;
      } else if (parentKey === "exported") {
        if ((0, _is.default)("ExportSpecifier", parent))
          return;
      } else if (parentKey === "imported") {
        if ((0, _is.default)("ImportSpecifier", parent, {
          imported: node
        }))
          return;
      } else if (parentKey === "meta") {
        if ((0, _is.default)("MetaProperty", parent, {
          meta: node
        }))
          return;
      }
      if (((0, _helperValidatorIdentifier.isKeyword)(node.name) || (0, _helperValidatorIdentifier.isReservedWord)(node.name, false)) && node.name !== "this") {
        throw new TypeError(`"${node.name}" is not a valid identifier`);
      }
    } : undefined
  });
  defineType("IfStatement", {
    visitor: ["test", "consequent", "alternate"],
    aliases: ["Statement", "Conditional"],
    fields: {
      test: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      consequent: {
        validate: (0, _utils.assertNodeType)("Statement")
      },
      alternate: {
        optional: true,
        validate: (0, _utils.assertNodeType)("Statement")
      }
    }
  });
  defineType("LabeledStatement", {
    visitor: ["label", "body"],
    aliases: ["Statement"],
    fields: {
      label: {
        validate: (0, _utils.assertNodeType)("Identifier")
      },
      body: {
        validate: (0, _utils.assertNodeType)("Statement")
      }
    }
  });
  defineType("StringLiteral", {
    builder: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertValueType)("string")
      }
    },
    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
  });
  defineType("NumericLiteral", {
    builder: ["value"],
    deprecatedAlias: "NumberLiteral",
    fields: {
      value: {
        validate: (0, _utils.chain)((0, _utils.assertValueType)("number"), Object.assign(function(node, key, val2) {
          if (1 / val2 < 0 || !Number.isFinite(val2)) {
            const error = new Error(`NumericLiterals must be non-negative finite numbers. You can use t.valueToNode(${val2}) instead.`);
            {
            }
          }
        }, {
          type: "number"
        }))
      }
    },
    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
  });
  defineType("NullLiteral", {
    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
  });
  defineType("BooleanLiteral", {
    builder: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertValueType)("boolean")
      }
    },
    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
  });
  defineType("RegExpLiteral", {
    builder: ["pattern", "flags"],
    deprecatedAlias: "RegexLiteral",
    aliases: ["Expression", "Pureish", "Literal"],
    fields: {
      pattern: {
        validate: (0, _utils.assertValueType)("string")
      },
      flags: {
        validate: process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.chain)((0, _utils.assertValueType)("string"), Object.assign(function(node, key, val2) {
          const invalid = /[^gimsuy]/.exec(val2);
          if (invalid) {
            throw new TypeError(`"${invalid[0]}" is not a valid RegExp flag`);
          }
        }, {
          type: "string"
        })) : (0, _utils.assertValueType)("string"),
        default: ""
      }
    }
  });
  defineType("LogicalExpression", {
    builder: ["operator", "left", "right"],
    visitor: ["left", "right"],
    aliases: ["Binary", "Expression"],
    fields: {
      operator: {
        validate: (0, _utils.assertOneOf)(..._index.LOGICAL_OPERATORS)
      },
      left: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      right: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("MemberExpression", {
    builder: ["object", "property", "computed", ...!process.env.BABEL_TYPES_8_BREAKING ? ["optional"] : []],
    visitor: ["object", "property"],
    aliases: ["Expression", "LVal"],
    fields: Object.assign({
      object: {
        validate: (0, _utils.assertNodeType)("Expression", "Super")
      },
      property: {
        validate: function() {
          const normal = (0, _utils.assertNodeType)("Identifier", "PrivateName");
          const computed = (0, _utils.assertNodeType)("Expression");
          const validator2 = function(node, key, val2) {
            const validator3 = node.computed ? computed : normal;
            validator3(node, key, val2);
          };
          validator2.oneOfNodeTypes = ["Expression", "Identifier", "PrivateName"];
          return validator2;
        }()
      },
      computed: {
        default: false
      }
    }, !process.env.BABEL_TYPES_8_BREAKING ? {
      optional: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      }
    } : {})
  });
  defineType("NewExpression", {
    inherits: "CallExpression"
  });
  defineType("Program", {
    visitor: ["directives", "body"],
    builder: ["body", "directives", "sourceType", "interpreter"],
    fields: {
      sourceType: {
        validate: (0, _utils.assertOneOf)("script", "module"),
        default: "script"
      },
      interpreter: {
        validate: (0, _utils.assertNodeType)("InterpreterDirective"),
        default: null,
        optional: true
      },
      directives: {
        validate: (0, _utils.arrayOfType)("Directive"),
        default: []
      },
      body: (0, _utils.validateArrayOfType)("Statement")
    },
    aliases: ["Scopable", "BlockParent", "Block"]
  });
  defineType("ObjectExpression", {
    visitor: ["properties"],
    aliases: ["Expression"],
    fields: {
      properties: (0, _utils.validateArrayOfType)("ObjectMethod", "ObjectProperty", "SpreadElement")
    }
  });
  defineType("ObjectMethod", {
    builder: ["kind", "key", "params", "body", "computed", "generator", "async"],
    visitor: ["decorators", "key", "typeParameters", "params", "returnType", "body"],
    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
      kind: Object.assign({
        validate: (0, _utils.assertOneOf)("method", "get", "set")
      }, !process.env.BABEL_TYPES_8_BREAKING ? {
        default: "method"
      } : {}),
      computed: {
        default: false
      },
      key: {
        validate: function() {
          const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
          const computed = (0, _utils.assertNodeType)("Expression");
          const validator2 = function(node, key, val2) {
            const validator3 = node.computed ? computed : normal;
            validator3(node, key, val2);
          };
          validator2.oneOfNodeTypes = ["Expression", "Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral"];
          return validator2;
        }()
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      },
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement")
      }
    }),
    aliases: ["UserWhitespacable", "Function", "Scopable", "BlockParent", "FunctionParent", "Method", "ObjectMember"]
  });
  defineType("ObjectProperty", {
    builder: ["key", "value", "computed", "shorthand", ...!process.env.BABEL_TYPES_8_BREAKING ? ["decorators"] : []],
    fields: {
      computed: {
        default: false
      },
      key: {
        validate: function() {
          const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "PrivateName");
          const computed = (0, _utils.assertNodeType)("Expression");
          const validator2 = Object.assign(function(node, key, val2) {
            const validator3 = node.computed ? computed : normal;
            validator3(node, key, val2);
          }, {
            oneOfNodeTypes: ["Expression", "Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "PrivateName"]
          });
          return validator2;
        }()
      },
      value: {
        validate: (0, _utils.assertNodeType)("Expression", "PatternLike")
      },
      shorthand: {
        validate: process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.chain)((0, _utils.assertValueType)("boolean"), Object.assign(function(node, key, shorthand) {
          if (!shorthand)
            return;
          if (node.computed) {
            throw new TypeError("Property shorthand of ObjectProperty cannot be true if computed is true");
          }
          if (!(0, _is.default)("Identifier", node.key)) {
            throw new TypeError("Property shorthand of ObjectProperty cannot be true if key is not an Identifier");
          }
        }, {
          type: "boolean"
        })) : (0, _utils.assertValueType)("boolean"),
        default: false
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      }
    },
    visitor: ["key", "value", "decorators"],
    aliases: ["UserWhitespacable", "Property", "ObjectMember"],
    validate: !process.env.BABEL_TYPES_8_BREAKING ? undefined : function() {
      const pattern = (0, _utils.assertNodeType)("Identifier", "Pattern", "TSAsExpression", "TSSatisfiesExpression", "TSNonNullExpression", "TSTypeAssertion");
      const expression = (0, _utils.assertNodeType)("Expression");
      return function(parent, key, node) {
        const validator2 = (0, _is.default)("ObjectPattern", parent) ? pattern : expression;
        validator2(node, "value", node.value);
      };
    }()
  });
  defineType("RestElement", {
    visitor: ["argument", "typeAnnotation"],
    builder: ["argument"],
    aliases: ["LVal", "PatternLike"],
    deprecatedAlias: "RestProperty",
    fields: Object.assign({}, patternLikeCommon(), {
      argument: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("LVal") : (0, _utils.assertNodeType)("Identifier", "ArrayPattern", "ObjectPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
      }
    }),
    validate: process.env.BABEL_TYPES_8_BREAKING ? function(parent, key) {
      const match = /(\w+)\[(\d+)\]/.exec(key);
      if (!match)
        throw new Error("Internal Babel error: malformed key.");
      const [, listKey, index] = match;
      if (parent[listKey].length > +index + 1) {
        throw new TypeError(`RestElement must be last element of ${listKey}`);
      }
    } : undefined
  });
  defineType("ReturnStatement", {
    visitor: ["argument"],
    aliases: ["Statement", "Terminatorless", "CompletionStatement"],
    fields: {
      argument: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      }
    }
  });
  defineType("SequenceExpression", {
    visitor: ["expressions"],
    fields: {
      expressions: (0, _utils.validateArrayOfType)("Expression")
    },
    aliases: ["Expression"]
  });
  defineType("ParenthesizedExpression", {
    visitor: ["expression"],
    aliases: ["Expression", "ExpressionWrapper"],
    fields: {
      expression: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("SwitchCase", {
    visitor: ["test", "consequent"],
    fields: {
      test: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      },
      consequent: (0, _utils.validateArrayOfType)("Statement")
    }
  });
  defineType("SwitchStatement", {
    visitor: ["discriminant", "cases"],
    aliases: ["Statement", "BlockParent", "Scopable"],
    fields: {
      discriminant: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      cases: (0, _utils.validateArrayOfType)("SwitchCase")
    }
  });
  defineType("ThisExpression", {
    aliases: ["Expression"]
  });
  defineType("ThrowStatement", {
    visitor: ["argument"],
    aliases: ["Statement", "Terminatorless", "CompletionStatement"],
    fields: {
      argument: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("TryStatement", {
    visitor: ["block", "handler", "finalizer"],
    aliases: ["Statement"],
    fields: {
      block: {
        validate: process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.chain)((0, _utils.assertNodeType)("BlockStatement"), Object.assign(function(node) {
          if (!node.handler && !node.finalizer) {
            throw new TypeError("TryStatement expects either a handler or finalizer, or both");
          }
        }, {
          oneOfNodeTypes: ["BlockStatement"]
        })) : (0, _utils.assertNodeType)("BlockStatement")
      },
      handler: {
        optional: true,
        validate: (0, _utils.assertNodeType)("CatchClause")
      },
      finalizer: {
        optional: true,
        validate: (0, _utils.assertNodeType)("BlockStatement")
      }
    }
  });
  defineType("UnaryExpression", {
    builder: ["operator", "argument", "prefix"],
    fields: {
      prefix: {
        default: true
      },
      argument: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      operator: {
        validate: (0, _utils.assertOneOf)(..._index.UNARY_OPERATORS)
      }
    },
    visitor: ["argument"],
    aliases: ["UnaryLike", "Expression"]
  });
  defineType("UpdateExpression", {
    builder: ["operator", "argument", "prefix"],
    fields: {
      prefix: {
        default: false
      },
      argument: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("Expression") : (0, _utils.assertNodeType)("Identifier", "MemberExpression")
      },
      operator: {
        validate: (0, _utils.assertOneOf)(..._index.UPDATE_OPERATORS)
      }
    },
    visitor: ["argument"],
    aliases: ["Expression"]
  });
  defineType("VariableDeclaration", {
    builder: ["kind", "declarations"],
    visitor: ["declarations"],
    aliases: ["Statement", "Declaration"],
    fields: {
      declare: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      kind: {
        validate: (0, _utils.assertOneOf)("var", "let", "const", "using", "await using")
      },
      declarations: (0, _utils.validateArrayOfType)("VariableDeclarator")
    },
    validate: process.env.BABEL_TYPES_8_BREAKING ? (() => {
      const withoutInit = (0, _utils.assertNodeType)("Identifier");
      return function(parent, key, node) {
        if ((0, _is.default)("ForXStatement", parent, {
          left: node
        })) {
          if (node.declarations.length !== 1) {
            throw new TypeError(`Exactly one VariableDeclarator is required in the VariableDeclaration of a ${parent.type}`);
          }
        } else {
          node.declarations.forEach((decl) => {
            if (!decl.init)
              withoutInit(decl, "id", decl.id);
          });
        }
      };
    })() : undefined
  });
  defineType("VariableDeclarator", {
    visitor: ["id", "init"],
    fields: {
      id: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("LVal") : (0, _utils.assertNodeType)("Identifier", "ArrayPattern", "ObjectPattern")
      },
      definite: {
        optional: true,
        validate: (0, _utils.assertValueType)("boolean")
      },
      init: {
        optional: true,
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("WhileStatement", {
    visitor: ["test", "body"],
    aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"],
    fields: {
      test: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      body: {
        validate: (0, _utils.assertNodeType)("Statement")
      }
    }
  });
  defineType("WithStatement", {
    visitor: ["object", "body"],
    aliases: ["Statement"],
    fields: {
      object: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      body: {
        validate: (0, _utils.assertNodeType)("Statement")
      }
    }
  });
  defineType("AssignmentPattern", {
    visitor: ["left", "right", "decorators"],
    builder: ["left", "right"],
    aliases: ["Pattern", "PatternLike", "LVal"],
    fields: Object.assign({}, patternLikeCommon(), {
      left: {
        validate: (0, _utils.assertNodeType)("Identifier", "ObjectPattern", "ArrayPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
      },
      right: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      }
    })
  });
  defineType("ArrayPattern", {
    visitor: ["elements", "typeAnnotation"],
    builder: ["elements"],
    aliases: ["Pattern", "PatternLike", "LVal"],
    fields: Object.assign({}, patternLikeCommon(), {
      elements: {
        validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeOrValueType)("null", "PatternLike", "LVal")))
      }
    })
  });
  defineType("ArrowFunctionExpression", {
    builder: ["params", "body", "async"],
    visitor: ["typeParameters", "params", "returnType", "body"],
    aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
      expression: {
        validate: (0, _utils.assertValueType)("boolean")
      },
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement", "Expression")
      },
      predicate: {
        validate: (0, _utils.assertNodeType)("DeclaredPredicate", "InferredPredicate"),
        optional: true
      }
    })
  });
  defineType("ClassBody", {
    visitor: ["body"],
    fields: {
      body: (0, _utils.validateArrayOfType)("ClassMethod", "ClassPrivateMethod", "ClassProperty", "ClassPrivateProperty", "ClassAccessorProperty", "TSDeclareMethod", "TSIndexSignature", "StaticBlock")
    }
  });
  defineType("ClassExpression", {
    builder: ["id", "superClass", "body", "decorators"],
    visitor: ["decorators", "id", "typeParameters", "superClass", "superTypeParameters", "mixins", "implements", "body"],
    aliases: ["Scopable", "Class", "Expression"],
    fields: {
      id: {
        validate: (0, _utils.assertNodeType)("Identifier"),
        optional: true
      },
      typeParameters: {
        validate: (0, _utils.assertNodeType)("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
        optional: true
      },
      body: {
        validate: (0, _utils.assertNodeType)("ClassBody")
      },
      superClass: {
        optional: true,
        validate: (0, _utils.assertNodeType)("Expression")
      },
      superTypeParameters: {
        validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
        optional: true
      },
      implements: {
        validate: (0, _utils.arrayOfType)("TSExpressionWithTypeArguments", "ClassImplements"),
        optional: true
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      },
      mixins: {
        validate: (0, _utils.assertNodeType)("InterfaceExtends"),
        optional: true
      }
    }
  });
  defineType("ClassDeclaration", {
    inherits: "ClassExpression",
    aliases: ["Scopable", "Class", "Statement", "Declaration"],
    fields: {
      id: {
        validate: (0, _utils.assertNodeType)("Identifier"),
        optional: true
      },
      typeParameters: {
        validate: (0, _utils.assertNodeType)("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
        optional: true
      },
      body: {
        validate: (0, _utils.assertNodeType)("ClassBody")
      },
      superClass: {
        optional: true,
        validate: (0, _utils.assertNodeType)("Expression")
      },
      superTypeParameters: {
        validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
        optional: true
      },
      implements: {
        validate: (0, _utils.arrayOfType)("TSExpressionWithTypeArguments", "ClassImplements"),
        optional: true
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      },
      mixins: {
        validate: (0, _utils.assertNodeType)("InterfaceExtends"),
        optional: true
      },
      declare: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      abstract: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      }
    },
    validate: !process.env.BABEL_TYPES_8_BREAKING ? undefined : function() {
      const identifier = (0, _utils.assertNodeType)("Identifier");
      return function(parent, key, node) {
        if (!(0, _is.default)("ExportDefaultDeclaration", parent)) {
          identifier(node, "id", node.id);
        }
      };
    }()
  });
  defineType("ExportAllDeclaration", {
    builder: ["source"],
    visitor: ["source", "attributes", "assertions"],
    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
    fields: {
      source: {
        validate: (0, _utils.assertNodeType)("StringLiteral")
      },
      exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("type", "value")),
      attributes: {
        optional: true,
        validate: (0, _utils.arrayOfType)("ImportAttribute")
      },
      assertions: {
        deprecated: true,
        optional: true,
        validate: (0, _utils.arrayOfType)("ImportAttribute")
      }
    }
  });
  defineType("ExportDefaultDeclaration", {
    visitor: ["declaration"],
    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
    fields: {
      declaration: (0, _utils.validateType)("TSDeclareFunction", "FunctionDeclaration", "ClassDeclaration", "Expression"),
      exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("value"))
    }
  });
  defineType("ExportNamedDeclaration", {
    builder: ["declaration", "specifiers", "source"],
    visitor: process.env ? ["declaration", "specifiers", "source", "attributes"] : ["declaration", "specifiers", "source", "attributes", "assertions"],
    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
    fields: {
      declaration: {
        optional: true,
        validate: process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.chain)((0, _utils.assertNodeType)("Declaration"), Object.assign(function(node, key, val2) {
          if (val2 && node.specifiers.length) {
            throw new TypeError("Only declaration or specifiers is allowed on ExportNamedDeclaration");
          }
          if (val2 && node.source) {
            throw new TypeError("Cannot export a declaration from a source");
          }
        }, {
          oneOfNodeTypes: ["Declaration"]
        })) : (0, _utils.assertNodeType)("Declaration")
      },
      attributes: {
        optional: true,
        validate: (0, _utils.arrayOfType)("ImportAttribute")
      },
      assertions: {
        deprecated: true,
        optional: true,
        validate: (0, _utils.arrayOfType)("ImportAttribute")
      },
      specifiers: {
        default: [],
        validate: (0, _utils.arrayOf)(function() {
          const sourced = (0, _utils.assertNodeType)("ExportSpecifier", "ExportDefaultSpecifier", "ExportNamespaceSpecifier");
          const sourceless = (0, _utils.assertNodeType)("ExportSpecifier");
          if (!process.env.BABEL_TYPES_8_BREAKING)
            return sourced;
          return Object.assign(function(node, key, val2) {
            const validator2 = node.source ? sourced : sourceless;
            validator2(node, key, val2);
          }, {
            oneOfNodeTypes: ["ExportSpecifier", "ExportDefaultSpecifier", "ExportNamespaceSpecifier"]
          });
        }())
      },
      source: {
        validate: (0, _utils.assertNodeType)("StringLiteral"),
        optional: true
      },
      exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("type", "value"))
    }
  });
  defineType("ExportSpecifier", {
    visitor: ["local", "exported"],
    aliases: ["ModuleSpecifier"],
    fields: {
      local: {
        validate: (0, _utils.assertNodeType)("Identifier")
      },
      exported: {
        validate: (0, _utils.assertNodeType)("Identifier", "StringLiteral")
      },
      exportKind: {
        validate: (0, _utils.assertOneOf)("type", "value"),
        optional: true
      }
    }
  });
  defineType("ForOfStatement", {
    visitor: ["left", "right", "body"],
    builder: ["left", "right", "body", "await"],
    aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
    fields: {
      left: {
        validate: function() {
          if (!process.env.BABEL_TYPES_8_BREAKING) {
            return (0, _utils.assertNodeType)("VariableDeclaration", "LVal");
          }
          const declaration = (0, _utils.assertNodeType)("VariableDeclaration");
          const lval = (0, _utils.assertNodeType)("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression");
          return Object.assign(function(node, key, val2) {
            if ((0, _is.default)("VariableDeclaration", val2)) {
              declaration(node, key, val2);
            } else {
              lval(node, key, val2);
            }
          }, {
            oneOfNodeTypes: ["VariableDeclaration", "Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression"]
          });
        }()
      },
      right: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      body: {
        validate: (0, _utils.assertNodeType)("Statement")
      },
      await: {
        default: false
      }
    }
  });
  defineType("ImportDeclaration", {
    builder: ["specifiers", "source"],
    visitor: ["specifiers", "source", "attributes", "assertions"],
    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration"],
    fields: {
      attributes: {
        optional: true,
        validate: (0, _utils.arrayOfType)("ImportAttribute")
      },
      assertions: {
        deprecated: true,
        optional: true,
        validate: (0, _utils.arrayOfType)("ImportAttribute")
      },
      module: {
        optional: true,
        validate: (0, _utils.assertValueType)("boolean")
      },
      phase: {
        default: null,
        validate: (0, _utils.assertOneOf)("source", "defer")
      },
      specifiers: (0, _utils.validateArrayOfType)("ImportSpecifier", "ImportDefaultSpecifier", "ImportNamespaceSpecifier"),
      source: {
        validate: (0, _utils.assertNodeType)("StringLiteral")
      },
      importKind: {
        validate: (0, _utils.assertOneOf)("type", "typeof", "value"),
        optional: true
      }
    }
  });
  defineType("ImportDefaultSpecifier", {
    visitor: ["local"],
    aliases: ["ModuleSpecifier"],
    fields: {
      local: {
        validate: (0, _utils.assertNodeType)("Identifier")
      }
    }
  });
  defineType("ImportNamespaceSpecifier", {
    visitor: ["local"],
    aliases: ["ModuleSpecifier"],
    fields: {
      local: {
        validate: (0, _utils.assertNodeType)("Identifier")
      }
    }
  });
  defineType("ImportSpecifier", {
    visitor: ["imported", "local"],
    builder: ["local", "imported"],
    aliases: ["ModuleSpecifier"],
    fields: {
      local: {
        validate: (0, _utils.assertNodeType)("Identifier")
      },
      imported: {
        validate: (0, _utils.assertNodeType)("Identifier", "StringLiteral")
      },
      importKind: {
        validate: (0, _utils.assertOneOf)("type", "typeof", "value"),
        optional: true
      }
    }
  });
  defineType("ImportExpression", {
    visitor: ["source", "options"],
    aliases: ["Expression"],
    fields: {
      phase: {
        default: null,
        validate: (0, _utils.assertOneOf)("source", "defer")
      },
      source: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      options: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      }
    }
  });
  defineType("MetaProperty", {
    visitor: ["meta", "property"],
    aliases: ["Expression"],
    fields: {
      meta: {
        validate: process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.chain)((0, _utils.assertNodeType)("Identifier"), Object.assign(function(node, key, val2) {
          let property;
          switch (val2.name) {
            case "function":
              property = "sent";
              break;
            case "new":
              property = "target";
              break;
            case "import":
              property = "meta";
              break;
          }
          if (!(0, _is.default)("Identifier", node.property, {
            name: property
          })) {
            throw new TypeError("Unrecognised MetaProperty");
          }
        }, {
          oneOfNodeTypes: ["Identifier"]
        })) : (0, _utils.assertNodeType)("Identifier")
      },
      property: {
        validate: (0, _utils.assertNodeType)("Identifier")
      }
    }
  });
  var classMethodOrPropertyCommon = () => ({
    abstract: {
      validate: (0, _utils.assertValueType)("boolean"),
      optional: true
    },
    accessibility: {
      validate: (0, _utils.assertOneOf)("public", "private", "protected"),
      optional: true
    },
    static: {
      default: false
    },
    override: {
      default: false
    },
    computed: {
      default: false
    },
    optional: {
      validate: (0, _utils.assertValueType)("boolean"),
      optional: true
    },
    key: {
      validate: (0, _utils.chain)(function() {
        const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
        const computed = (0, _utils.assertNodeType)("Expression");
        return function(node, key, val2) {
          const validator2 = node.computed ? computed : normal;
          validator2(node, key, val2);
        };
      }(), (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression"))
    }
  });
  exports.classMethodOrPropertyCommon = classMethodOrPropertyCommon;
  var classMethodOrDeclareMethodCommon = () => Object.assign({}, functionCommon(), classMethodOrPropertyCommon(), {
    params: (0, _utils.validateArrayOfType)("Identifier", "Pattern", "RestElement", "TSParameterProperty"),
    kind: {
      validate: (0, _utils.assertOneOf)("get", "set", "method", "constructor"),
      default: "method"
    },
    access: {
      validate: (0, _utils.chain)((0, _utils.assertValueType)("string"), (0, _utils.assertOneOf)("public", "private", "protected")),
      optional: true
    },
    decorators: {
      validate: (0, _utils.arrayOfType)("Decorator"),
      optional: true
    }
  });
  exports.classMethodOrDeclareMethodCommon = classMethodOrDeclareMethodCommon;
  defineType("ClassMethod", {
    aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method"],
    builder: ["kind", "key", "params", "body", "computed", "static", "generator", "async"],
    visitor: ["decorators", "key", "typeParameters", "params", "returnType", "body"],
    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement")
      }
    })
  });
  defineType("ObjectPattern", {
    visitor: ["properties", "typeAnnotation", "decorators"],
    builder: ["properties"],
    aliases: ["Pattern", "PatternLike", "LVal"],
    fields: Object.assign({}, patternLikeCommon(), {
      properties: (0, _utils.validateArrayOfType)("RestElement", "ObjectProperty")
    })
  });
  defineType("SpreadElement", {
    visitor: ["argument"],
    aliases: ["UnaryLike"],
    deprecatedAlias: "SpreadProperty",
    fields: {
      argument: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("Super", {
    aliases: ["Expression"]
  });
  defineType("TaggedTemplateExpression", {
    visitor: ["tag", "typeParameters", "quasi"],
    builder: ["tag", "quasi"],
    aliases: ["Expression"],
    fields: {
      tag: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      quasi: {
        validate: (0, _utils.assertNodeType)("TemplateLiteral")
      },
      typeParameters: {
        validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
        optional: true
      }
    }
  });
  defineType("TemplateElement", {
    builder: ["value", "tail"],
    fields: {
      value: {
        validate: (0, _utils.chain)((0, _utils.assertShape)({
          raw: {
            validate: (0, _utils.assertValueType)("string")
          },
          cooked: {
            validate: (0, _utils.assertValueType)("string"),
            optional: true
          }
        }), function templateElementCookedValidator(node) {
          const raw = node.value.raw;
          let unterminatedCalled = false;
          const error = () => {
            throw new Error("Internal @babel/types error.");
          };
          const {
            str,
            firstInvalidLoc
          } = (0, _helperStringParser.readStringContents)("template", raw, 0, 0, 0, {
            unterminated() {
              unterminatedCalled = true;
            },
            strictNumericEscape: error,
            invalidEscapeSequence: error,
            numericSeparatorInEscapeSequence: error,
            unexpectedNumericSeparator: error,
            invalidDigit: error,
            invalidCodePoint: error
          });
          if (!unterminatedCalled)
            throw new Error("Invalid raw");
          node.value.cooked = firstInvalidLoc ? null : str;
        })
      },
      tail: {
        default: false
      }
    }
  });
  defineType("TemplateLiteral", {
    visitor: ["quasis", "expressions"],
    aliases: ["Expression", "Literal"],
    fields: {
      quasis: (0, _utils.validateArrayOfType)("TemplateElement"),
      expressions: {
        validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression", "TSType")), function(node, key, val2) {
          if (node.quasis.length !== val2.length + 1) {
            throw new TypeError(`Number of ${node.type} quasis should be exactly one more than the number of expressions.\nExpected ${val2.length + 1} quasis but got ${node.quasis.length}`);
          }
        })
      }
    }
  });
  defineType("YieldExpression", {
    builder: ["argument", "delegate"],
    visitor: ["argument"],
    aliases: ["Expression", "Terminatorless"],
    fields: {
      delegate: {
        validate: process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.chain)((0, _utils.assertValueType)("boolean"), Object.assign(function(node, key, val2) {
          if (val2 && !node.argument) {
            throw new TypeError("Property delegate of YieldExpression cannot be true if there is no argument");
          }
        }, {
          type: "boolean"
        })) : (0, _utils.assertValueType)("boolean"),
        default: false
      },
      argument: {
        optional: true,
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("AwaitExpression", {
    builder: ["argument"],
    visitor: ["argument"],
    aliases: ["Expression", "Terminatorless"],
    fields: {
      argument: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("Import", {
    aliases: ["Expression"]
  });
  defineType("BigIntLiteral", {
    builder: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertValueType)("string")
      }
    },
    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
  });
  defineType("ExportNamespaceSpecifier", {
    visitor: ["exported"],
    aliases: ["ModuleSpecifier"],
    fields: {
      exported: {
        validate: (0, _utils.assertNodeType)("Identifier")
      }
    }
  });
  defineType("OptionalMemberExpression", {
    builder: ["object", "property", "computed", "optional"],
    visitor: ["object", "property"],
    aliases: ["Expression"],
    fields: {
      object: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      property: {
        validate: function() {
          const normal = (0, _utils.assertNodeType)("Identifier");
          const computed = (0, _utils.assertNodeType)("Expression");
          const validator2 = Object.assign(function(node, key, val2) {
            const validator3 = node.computed ? computed : normal;
            validator3(node, key, val2);
          }, {
            oneOfNodeTypes: ["Expression", "Identifier"]
          });
          return validator2;
        }()
      },
      computed: {
        default: false
      },
      optional: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertValueType)("boolean") : (0, _utils.chain)((0, _utils.assertValueType)("boolean"), (0, _utils.assertOptionalChainStart)())
      }
    }
  });
  defineType("OptionalCallExpression", {
    visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
    builder: ["callee", "arguments", "optional"],
    aliases: ["Expression"],
    fields: {
      callee: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      arguments: (0, _utils.validateArrayOfType)("Expression", "SpreadElement", "ArgumentPlaceholder"),
      optional: {
        validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertValueType)("boolean") : (0, _utils.chain)((0, _utils.assertValueType)("boolean"), (0, _utils.assertOptionalChainStart)())
      },
      typeArguments: {
        validate: (0, _utils.assertNodeType)("TypeParameterInstantiation"),
        optional: true
      },
      typeParameters: {
        validate: (0, _utils.assertNodeType)("TSTypeParameterInstantiation"),
        optional: true
      }
    }
  });
  defineType("ClassProperty", {
    visitor: ["decorators", "key", "typeAnnotation", "value"],
    builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
    aliases: ["Property"],
    fields: Object.assign({}, classMethodOrPropertyCommon(), {
      value: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      },
      definite: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      typeAnnotation: {
        validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
        optional: true
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      },
      readonly: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      declare: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      variance: {
        validate: (0, _utils.assertNodeType)("Variance"),
        optional: true
      }
    })
  });
  defineType("ClassAccessorProperty", {
    visitor: ["decorators", "key", "typeAnnotation", "value"],
    builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
    aliases: ["Property", "Accessor"],
    fields: Object.assign({}, classMethodOrPropertyCommon(), {
      key: {
        validate: (0, _utils.chain)(function() {
          const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "PrivateName");
          const computed = (0, _utils.assertNodeType)("Expression");
          return function(node, key, val2) {
            const validator2 = node.computed ? computed : normal;
            validator2(node, key, val2);
          };
        }(), (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression", "PrivateName"))
      },
      value: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      },
      definite: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      typeAnnotation: {
        validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
        optional: true
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      },
      readonly: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      declare: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      variance: {
        validate: (0, _utils.assertNodeType)("Variance"),
        optional: true
      }
    })
  });
  defineType("ClassPrivateProperty", {
    visitor: ["decorators", "key", "typeAnnotation", "value"],
    builder: ["key", "value", "decorators", "static"],
    aliases: ["Property", "Private"],
    fields: {
      key: {
        validate: (0, _utils.assertNodeType)("PrivateName")
      },
      value: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      },
      typeAnnotation: {
        validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
        optional: true
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      },
      static: {
        validate: (0, _utils.assertValueType)("boolean"),
        default: false
      },
      readonly: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      definite: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      variance: {
        validate: (0, _utils.assertNodeType)("Variance"),
        optional: true
      }
    }
  });
  defineType("ClassPrivateMethod", {
    builder: ["kind", "key", "params", "body", "static"],
    visitor: ["decorators", "key", "typeParameters", "params", "returnType", "body"],
    aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method", "Private"],
    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
      kind: {
        validate: (0, _utils.assertOneOf)("get", "set", "method"),
        default: "method"
      },
      key: {
        validate: (0, _utils.assertNodeType)("PrivateName")
      },
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement")
      }
    })
  });
  defineType("PrivateName", {
    visitor: ["id"],
    aliases: ["Private"],
    fields: {
      id: {
        validate: (0, _utils.assertNodeType)("Identifier")
      }
    }
  });
  defineType("StaticBlock", {
    visitor: ["body"],
    fields: {
      body: (0, _utils.validateArrayOfType)("Statement")
    },
    aliases: ["Scopable", "BlockParent", "FunctionParent"]
  });
});
var require_flow = __commonJS2(() => {
  var _utils = require_utils3();
  var defineType = (0, _utils.defineAliasedType)("Flow");
  var defineInterfaceishType = (name) => {
    const isDeclareClass = name === "DeclareClass";
    defineType(name, {
      builder: ["id", "typeParameters", "extends", "body"],
      visitor: ["id", "typeParameters", "extends", ...isDeclareClass ? ["mixins", "implements"] : [], "body"],
      aliases: ["FlowDeclaration", "Statement", "Declaration"],
      fields: Object.assign({
        id: (0, _utils.validateType)("Identifier"),
        typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
        extends: (0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends"))
      }, isDeclareClass ? {
        mixins: (0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends")),
        implements: (0, _utils.validateOptional)((0, _utils.arrayOfType)("ClassImplements"))
      } : {}, {
        body: (0, _utils.validateType)("ObjectTypeAnnotation")
      })
    });
  };
  defineType("AnyTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("ArrayTypeAnnotation", {
    visitor: ["elementType"],
    aliases: ["FlowType"],
    fields: {
      elementType: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("BooleanTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("BooleanLiteralTypeAnnotation", {
    builder: ["value"],
    aliases: ["FlowType"],
    fields: {
      value: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("NullLiteralTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("ClassImplements", {
    visitor: ["id", "typeParameters"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterInstantiation")
    }
  });
  defineInterfaceishType("DeclareClass");
  defineType("DeclareFunction", {
    visitor: ["id"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      predicate: (0, _utils.validateOptionalType)("DeclaredPredicate")
    }
  });
  defineInterfaceishType("DeclareInterface");
  defineType("DeclareModule", {
    builder: ["id", "body", "kind"],
    visitor: ["id", "body"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      id: (0, _utils.validateType)("Identifier", "StringLiteral"),
      body: (0, _utils.validateType)("BlockStatement"),
      kind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("CommonJS", "ES"))
    }
  });
  defineType("DeclareModuleExports", {
    visitor: ["typeAnnotation"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      typeAnnotation: (0, _utils.validateType)("TypeAnnotation")
    }
  });
  defineType("DeclareTypeAlias", {
    visitor: ["id", "typeParameters", "right"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
      right: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("DeclareOpaqueType", {
    visitor: ["id", "typeParameters", "supertype"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
      supertype: (0, _utils.validateOptionalType)("FlowType"),
      impltype: (0, _utils.validateOptionalType)("FlowType")
    }
  });
  defineType("DeclareVariable", {
    visitor: ["id"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      id: (0, _utils.validateType)("Identifier")
    }
  });
  defineType("DeclareExportDeclaration", {
    visitor: ["declaration", "specifiers", "source"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      declaration: (0, _utils.validateOptionalType)("Flow"),
      specifiers: (0, _utils.validateOptional)((0, _utils.arrayOfType)("ExportSpecifier", "ExportNamespaceSpecifier")),
      source: (0, _utils.validateOptionalType)("StringLiteral"),
      default: (0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("DeclareExportAllDeclaration", {
    visitor: ["source"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      source: (0, _utils.validateType)("StringLiteral"),
      exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("type", "value"))
    }
  });
  defineType("DeclaredPredicate", {
    visitor: ["value"],
    aliases: ["FlowPredicate"],
    fields: {
      value: (0, _utils.validateType)("Flow")
    }
  });
  defineType("ExistsTypeAnnotation", {
    aliases: ["FlowType"]
  });
  defineType("FunctionTypeAnnotation", {
    visitor: ["typeParameters", "params", "rest", "returnType"],
    aliases: ["FlowType"],
    fields: {
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
      params: (0, _utils.validateArrayOfType)("FunctionTypeParam"),
      rest: (0, _utils.validateOptionalType)("FunctionTypeParam"),
      this: (0, _utils.validateOptionalType)("FunctionTypeParam"),
      returnType: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("FunctionTypeParam", {
    visitor: ["name", "typeAnnotation"],
    fields: {
      name: (0, _utils.validateOptionalType)("Identifier"),
      typeAnnotation: (0, _utils.validateType)("FlowType"),
      optional: (0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("GenericTypeAnnotation", {
    visitor: ["id", "typeParameters"],
    aliases: ["FlowType"],
    fields: {
      id: (0, _utils.validateType)("Identifier", "QualifiedTypeIdentifier"),
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterInstantiation")
    }
  });
  defineType("InferredPredicate", {
    aliases: ["FlowPredicate"]
  });
  defineType("InterfaceExtends", {
    visitor: ["id", "typeParameters"],
    fields: {
      id: (0, _utils.validateType)("Identifier", "QualifiedTypeIdentifier"),
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterInstantiation")
    }
  });
  defineInterfaceishType("InterfaceDeclaration");
  defineType("InterfaceTypeAnnotation", {
    visitor: ["extends", "body"],
    aliases: ["FlowType"],
    fields: {
      extends: (0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends")),
      body: (0, _utils.validateType)("ObjectTypeAnnotation")
    }
  });
  defineType("IntersectionTypeAnnotation", {
    visitor: ["types"],
    aliases: ["FlowType"],
    fields: {
      types: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
    }
  });
  defineType("MixedTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("EmptyTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("NullableTypeAnnotation", {
    visitor: ["typeAnnotation"],
    aliases: ["FlowType"],
    fields: {
      typeAnnotation: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("NumberLiteralTypeAnnotation", {
    builder: ["value"],
    aliases: ["FlowType"],
    fields: {
      value: (0, _utils.validate)((0, _utils.assertValueType)("number"))
    }
  });
  defineType("NumberTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("ObjectTypeAnnotation", {
    visitor: ["properties", "indexers", "callProperties", "internalSlots"],
    aliases: ["FlowType"],
    builder: ["properties", "indexers", "callProperties", "internalSlots", "exact"],
    fields: {
      properties: (0, _utils.validate)((0, _utils.arrayOfType)("ObjectTypeProperty", "ObjectTypeSpreadProperty")),
      indexers: {
        validate: (0, _utils.arrayOfType)("ObjectTypeIndexer"),
        optional: true,
        default: []
      },
      callProperties: {
        validate: (0, _utils.arrayOfType)("ObjectTypeCallProperty"),
        optional: true,
        default: []
      },
      internalSlots: {
        validate: (0, _utils.arrayOfType)("ObjectTypeInternalSlot"),
        optional: true,
        default: []
      },
      exact: {
        validate: (0, _utils.assertValueType)("boolean"),
        default: false
      },
      inexact: (0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("ObjectTypeInternalSlot", {
    visitor: ["id", "value"],
    builder: ["id", "value", "optional", "static", "method"],
    aliases: ["UserWhitespacable"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      value: (0, _utils.validateType)("FlowType"),
      optional: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      static: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      method: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("ObjectTypeCallProperty", {
    visitor: ["value"],
    aliases: ["UserWhitespacable"],
    fields: {
      value: (0, _utils.validateType)("FlowType"),
      static: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("ObjectTypeIndexer", {
    visitor: ["variance", "id", "key", "value"],
    builder: ["id", "key", "value", "variance"],
    aliases: ["UserWhitespacable"],
    fields: {
      id: (0, _utils.validateOptionalType)("Identifier"),
      key: (0, _utils.validateType)("FlowType"),
      value: (0, _utils.validateType)("FlowType"),
      static: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      variance: (0, _utils.validateOptionalType)("Variance")
    }
  });
  defineType("ObjectTypeProperty", {
    visitor: ["key", "value", "variance"],
    aliases: ["UserWhitespacable"],
    fields: {
      key: (0, _utils.validateType)("Identifier", "StringLiteral"),
      value: (0, _utils.validateType)("FlowType"),
      kind: (0, _utils.validate)((0, _utils.assertOneOf)("init", "get", "set")),
      static: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      proto: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      optional: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      variance: (0, _utils.validateOptionalType)("Variance"),
      method: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("ObjectTypeSpreadProperty", {
    visitor: ["argument"],
    aliases: ["UserWhitespacable"],
    fields: {
      argument: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("OpaqueType", {
    visitor: ["id", "typeParameters", "supertype", "impltype"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
      supertype: (0, _utils.validateOptionalType)("FlowType"),
      impltype: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("QualifiedTypeIdentifier", {
    visitor: ["qualification", "id"],
    builder: ["id", "qualification"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      qualification: (0, _utils.validateType)("Identifier", "QualifiedTypeIdentifier")
    }
  });
  defineType("StringLiteralTypeAnnotation", {
    builder: ["value"],
    aliases: ["FlowType"],
    fields: {
      value: (0, _utils.validate)((0, _utils.assertValueType)("string"))
    }
  });
  defineType("StringTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("SymbolTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("ThisTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("TupleTypeAnnotation", {
    visitor: ["types"],
    aliases: ["FlowType"],
    fields: {
      types: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
    }
  });
  defineType("TypeofTypeAnnotation", {
    visitor: ["argument"],
    aliases: ["FlowType"],
    fields: {
      argument: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("TypeAlias", {
    visitor: ["id", "typeParameters", "right"],
    aliases: ["FlowDeclaration", "Statement", "Declaration"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
      right: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("TypeAnnotation", {
    visitor: ["typeAnnotation"],
    fields: {
      typeAnnotation: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("TypeCastExpression", {
    visitor: ["expression", "typeAnnotation"],
    aliases: ["ExpressionWrapper", "Expression"],
    fields: {
      expression: (0, _utils.validateType)("Expression"),
      typeAnnotation: (0, _utils.validateType)("TypeAnnotation")
    }
  });
  defineType("TypeParameter", {
    visitor: ["bound", "default", "variance"],
    fields: {
      name: (0, _utils.validate)((0, _utils.assertValueType)("string")),
      bound: (0, _utils.validateOptionalType)("TypeAnnotation"),
      default: (0, _utils.validateOptionalType)("FlowType"),
      variance: (0, _utils.validateOptionalType)("Variance")
    }
  });
  defineType("TypeParameterDeclaration", {
    visitor: ["params"],
    fields: {
      params: (0, _utils.validate)((0, _utils.arrayOfType)("TypeParameter"))
    }
  });
  defineType("TypeParameterInstantiation", {
    visitor: ["params"],
    fields: {
      params: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
    }
  });
  defineType("UnionTypeAnnotation", {
    visitor: ["types"],
    aliases: ["FlowType"],
    fields: {
      types: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
    }
  });
  defineType("Variance", {
    builder: ["kind"],
    fields: {
      kind: (0, _utils.validate)((0, _utils.assertOneOf)("minus", "plus"))
    }
  });
  defineType("VoidTypeAnnotation", {
    aliases: ["FlowType", "FlowBaseAnnotation"]
  });
  defineType("EnumDeclaration", {
    aliases: ["Statement", "Declaration"],
    visitor: ["id", "body"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      body: (0, _utils.validateType)("EnumBooleanBody", "EnumNumberBody", "EnumStringBody", "EnumSymbolBody")
    }
  });
  defineType("EnumBooleanBody", {
    aliases: ["EnumBody"],
    visitor: ["members"],
    fields: {
      explicitType: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      members: (0, _utils.validateArrayOfType)("EnumBooleanMember"),
      hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("EnumNumberBody", {
    aliases: ["EnumBody"],
    visitor: ["members"],
    fields: {
      explicitType: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      members: (0, _utils.validateArrayOfType)("EnumNumberMember"),
      hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("EnumStringBody", {
    aliases: ["EnumBody"],
    visitor: ["members"],
    fields: {
      explicitType: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
      members: (0, _utils.validateArrayOfType)("EnumStringMember", "EnumDefaultedMember"),
      hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("EnumSymbolBody", {
    aliases: ["EnumBody"],
    visitor: ["members"],
    fields: {
      members: (0, _utils.validateArrayOfType)("EnumDefaultedMember"),
      hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
  defineType("EnumBooleanMember", {
    aliases: ["EnumMember"],
    visitor: ["id"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      init: (0, _utils.validateType)("BooleanLiteral")
    }
  });
  defineType("EnumNumberMember", {
    aliases: ["EnumMember"],
    visitor: ["id", "init"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      init: (0, _utils.validateType)("NumericLiteral")
    }
  });
  defineType("EnumStringMember", {
    aliases: ["EnumMember"],
    visitor: ["id", "init"],
    fields: {
      id: (0, _utils.validateType)("Identifier"),
      init: (0, _utils.validateType)("StringLiteral")
    }
  });
  defineType("EnumDefaultedMember", {
    aliases: ["EnumMember"],
    visitor: ["id"],
    fields: {
      id: (0, _utils.validateType)("Identifier")
    }
  });
  defineType("IndexedAccessType", {
    visitor: ["objectType", "indexType"],
    aliases: ["FlowType"],
    fields: {
      objectType: (0, _utils.validateType)("FlowType"),
      indexType: (0, _utils.validateType)("FlowType")
    }
  });
  defineType("OptionalIndexedAccessType", {
    visitor: ["objectType", "indexType"],
    aliases: ["FlowType"],
    fields: {
      objectType: (0, _utils.validateType)("FlowType"),
      indexType: (0, _utils.validateType)("FlowType"),
      optional: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
    }
  });
});
var require_jsx = __commonJS2(() => {
  var _utils = require_utils3();
  var defineType = (0, _utils.defineAliasedType)("JSX");
  defineType("JSXAttribute", {
    visitor: ["name", "value"],
    aliases: ["Immutable"],
    fields: {
      name: {
        validate: (0, _utils.assertNodeType)("JSXIdentifier", "JSXNamespacedName")
      },
      value: {
        optional: true,
        validate: (0, _utils.assertNodeType)("JSXElement", "JSXFragment", "StringLiteral", "JSXExpressionContainer")
      }
    }
  });
  defineType("JSXClosingElement", {
    visitor: ["name"],
    aliases: ["Immutable"],
    fields: {
      name: {
        validate: (0, _utils.assertNodeType)("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
      }
    }
  });
  defineType("JSXElement", {
    builder: ["openingElement", "closingElement", "children", "selfClosing"],
    visitor: ["openingElement", "children", "closingElement"],
    aliases: ["Immutable", "Expression"],
    fields: Object.assign({
      openingElement: {
        validate: (0, _utils.assertNodeType)("JSXOpeningElement")
      },
      closingElement: {
        optional: true,
        validate: (0, _utils.assertNodeType)("JSXClosingElement")
      },
      children: (0, _utils.validateArrayOfType)("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")
    }, {
      selfClosing: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      }
    })
  });
  defineType("JSXEmptyExpression", {});
  defineType("JSXExpressionContainer", {
    visitor: ["expression"],
    aliases: ["Immutable"],
    fields: {
      expression: {
        validate: (0, _utils.assertNodeType)("Expression", "JSXEmptyExpression")
      }
    }
  });
  defineType("JSXSpreadChild", {
    visitor: ["expression"],
    aliases: ["Immutable"],
    fields: {
      expression: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("JSXIdentifier", {
    builder: ["name"],
    fields: {
      name: {
        validate: (0, _utils.assertValueType)("string")
      }
    }
  });
  defineType("JSXMemberExpression", {
    visitor: ["object", "property"],
    fields: {
      object: {
        validate: (0, _utils.assertNodeType)("JSXMemberExpression", "JSXIdentifier")
      },
      property: {
        validate: (0, _utils.assertNodeType)("JSXIdentifier")
      }
    }
  });
  defineType("JSXNamespacedName", {
    visitor: ["namespace", "name"],
    fields: {
      namespace: {
        validate: (0, _utils.assertNodeType)("JSXIdentifier")
      },
      name: {
        validate: (0, _utils.assertNodeType)("JSXIdentifier")
      }
    }
  });
  defineType("JSXOpeningElement", {
    builder: ["name", "attributes", "selfClosing"],
    visitor: ["name", "attributes"],
    aliases: ["Immutable"],
    fields: {
      name: {
        validate: (0, _utils.assertNodeType)("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
      },
      selfClosing: {
        default: false
      },
      attributes: (0, _utils.validateArrayOfType)("JSXAttribute", "JSXSpreadAttribute"),
      typeParameters: {
        validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
        optional: true
      }
    }
  });
  defineType("JSXSpreadAttribute", {
    visitor: ["argument"],
    fields: {
      argument: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  defineType("JSXText", {
    aliases: ["Immutable"],
    builder: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertValueType)("string")
      }
    }
  });
  defineType("JSXFragment", {
    builder: ["openingFragment", "closingFragment", "children"],
    visitor: ["openingFragment", "children", "closingFragment"],
    aliases: ["Immutable", "Expression"],
    fields: {
      openingFragment: {
        validate: (0, _utils.assertNodeType)("JSXOpeningFragment")
      },
      closingFragment: {
        validate: (0, _utils.assertNodeType)("JSXClosingFragment")
      },
      children: (0, _utils.validateArrayOfType)("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")
    }
  });
  defineType("JSXOpeningFragment", {
    aliases: ["Immutable"]
  });
  defineType("JSXClosingFragment", {
    aliases: ["Immutable"]
  });
});
var require_placeholders = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.PLACEHOLDERS_FLIPPED_ALIAS = exports.PLACEHOLDERS_ALIAS = exports.PLACEHOLDERS = undefined;
  var _utils = require_utils3();
  var PLACEHOLDERS = exports.PLACEHOLDERS = ["Identifier", "StringLiteral", "Expression", "Statement", "Declaration", "BlockStatement", "ClassBody", "Pattern"];
  var PLACEHOLDERS_ALIAS = exports.PLACEHOLDERS_ALIAS = {
    Declaration: ["Statement"],
    Pattern: ["PatternLike", "LVal"]
  };
  for (const type of PLACEHOLDERS) {
    const alias = _utils.ALIAS_KEYS[type];
    if (alias != null && alias.length)
      PLACEHOLDERS_ALIAS[type] = alias;
  }
  var PLACEHOLDERS_FLIPPED_ALIAS = exports.PLACEHOLDERS_FLIPPED_ALIAS = {};
  Object.keys(PLACEHOLDERS_ALIAS).forEach((type) => {
    PLACEHOLDERS_ALIAS[type].forEach((alias) => {
      if (!hasOwnProperty.call(PLACEHOLDERS_FLIPPED_ALIAS, alias)) {
        PLACEHOLDERS_FLIPPED_ALIAS[alias] = [];
      }
      PLACEHOLDERS_FLIPPED_ALIAS[alias].push(type);
    });
  });
});
var require_misc = __commonJS2(() => {
  var _utils = require_utils3();
  var _placeholders = require_placeholders();
  var _core = require_core();
  var defineType = (0, _utils.defineAliasedType)("Miscellaneous");
  {
    defineType("Noop", {
      visitor: []
    });
  }
  defineType("Placeholder", {
    visitor: [],
    builder: ["expectedNode", "name"],
    fields: Object.assign({
      name: {
        validate: (0, _utils.assertNodeType)("Identifier")
      },
      expectedNode: {
        validate: (0, _utils.assertOneOf)(..._placeholders.PLACEHOLDERS)
      }
    }, (0, _core.patternLikeCommon)())
  });
  defineType("V8IntrinsicIdentifier", {
    builder: ["name"],
    fields: {
      name: {
        validate: (0, _utils.assertValueType)("string")
      }
    }
  });
});
var require_experimental = __commonJS2(() => {
  var _utils = require_utils3();
  (0, _utils.default)("ArgumentPlaceholder", {});
  (0, _utils.default)("BindExpression", {
    visitor: ["object", "callee"],
    aliases: ["Expression"],
    fields: !process.env.BABEL_TYPES_8_BREAKING ? {
      object: {
        validate: Object.assign(() => {
        }, {
          oneOfNodeTypes: ["Expression"]
        })
      },
      callee: {
        validate: Object.assign(() => {
        }, {
          oneOfNodeTypes: ["Expression"]
        })
      }
    } : {
      object: {
        validate: (0, _utils.assertNodeType)("Expression")
      },
      callee: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  (0, _utils.default)("ImportAttribute", {
    visitor: ["key", "value"],
    fields: {
      key: {
        validate: (0, _utils.assertNodeType)("Identifier", "StringLiteral")
      },
      value: {
        validate: (0, _utils.assertNodeType)("StringLiteral")
      }
    }
  });
  (0, _utils.default)("Decorator", {
    visitor: ["expression"],
    fields: {
      expression: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    }
  });
  (0, _utils.default)("DoExpression", {
    visitor: ["body"],
    builder: ["body", "async"],
    aliases: ["Expression"],
    fields: {
      body: {
        validate: (0, _utils.assertNodeType)("BlockStatement")
      },
      async: {
        validate: (0, _utils.assertValueType)("boolean"),
        default: false
      }
    }
  });
  (0, _utils.default)("ExportDefaultSpecifier", {
    visitor: ["exported"],
    aliases: ["ModuleSpecifier"],
    fields: {
      exported: {
        validate: (0, _utils.assertNodeType)("Identifier")
      }
    }
  });
  (0, _utils.default)("RecordExpression", {
    visitor: ["properties"],
    aliases: ["Expression"],
    fields: {
      properties: (0, _utils.validateArrayOfType)("ObjectProperty", "SpreadElement")
    }
  });
  (0, _utils.default)("TupleExpression", {
    fields: {
      elements: {
        validate: (0, _utils.arrayOfType)("Expression", "SpreadElement"),
        default: []
      }
    },
    visitor: ["elements"],
    aliases: ["Expression"]
  });
  {
    (0, _utils.default)("DecimalLiteral", {
      builder: ["value"],
      fields: {
        value: {
          validate: (0, _utils.assertValueType)("string")
        }
      },
      aliases: ["Expression", "Pureish", "Literal", "Immutable"]
    });
  }
  (0, _utils.default)("ModuleExpression", {
    visitor: ["body"],
    fields: {
      body: {
        validate: (0, _utils.assertNodeType)("Program")
      }
    },
    aliases: ["Expression"]
  });
  (0, _utils.default)("TopicReference", {
    aliases: ["Expression"]
  });
  (0, _utils.default)("PipelineTopicExpression", {
    builder: ["expression"],
    visitor: ["expression"],
    fields: {
      expression: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    },
    aliases: ["Expression"]
  });
  (0, _utils.default)("PipelineBareFunction", {
    builder: ["callee"],
    visitor: ["callee"],
    fields: {
      callee: {
        validate: (0, _utils.assertNodeType)("Expression")
      }
    },
    aliases: ["Expression"]
  });
  (0, _utils.default)("PipelinePrimaryTopicReference", {
    aliases: ["Expression"]
  });
});
var require_typescript = __commonJS2(() => {
  var _utils = require_utils3();
  var _core = require_core();
  var _is = require_is();
  var defineType = (0, _utils.defineAliasedType)("TypeScript");
  var bool = (0, _utils.assertValueType)("boolean");
  var tSFunctionTypeAnnotationCommon = () => ({
    returnType: {
      validate: (0, _utils.assertNodeType)("TSTypeAnnotation", "Noop"),
      optional: true
    },
    typeParameters: {
      validate: (0, _utils.assertNodeType)("TSTypeParameterDeclaration", "Noop"),
      optional: true
    }
  });
  defineType("TSParameterProperty", {
    aliases: ["LVal"],
    visitor: ["parameter"],
    fields: {
      accessibility: {
        validate: (0, _utils.assertOneOf)("public", "private", "protected"),
        optional: true
      },
      readonly: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      parameter: {
        validate: (0, _utils.assertNodeType)("Identifier", "AssignmentPattern")
      },
      override: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      decorators: {
        validate: (0, _utils.arrayOfType)("Decorator"),
        optional: true
      }
    }
  });
  defineType("TSDeclareFunction", {
    aliases: ["Statement", "Declaration"],
    visitor: ["id", "typeParameters", "params", "returnType"],
    fields: Object.assign({}, (0, _core.functionDeclarationCommon)(), tSFunctionTypeAnnotationCommon())
  });
  defineType("TSDeclareMethod", {
    visitor: ["decorators", "key", "typeParameters", "params", "returnType"],
    fields: Object.assign({}, (0, _core.classMethodOrDeclareMethodCommon)(), tSFunctionTypeAnnotationCommon())
  });
  defineType("TSQualifiedName", {
    aliases: ["TSEntityName"],
    visitor: ["left", "right"],
    fields: {
      left: (0, _utils.validateType)("TSEntityName"),
      right: (0, _utils.validateType)("Identifier")
    }
  });
  var signatureDeclarationCommon = () => ({
    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),
    ["parameters"]: (0, _utils.validateArrayOfType)("ArrayPattern", "Identifier", "ObjectPattern", "RestElement"),
    ["typeAnnotation"]: (0, _utils.validateOptionalType)("TSTypeAnnotation")
  });
  var callConstructSignatureDeclaration = {
    aliases: ["TSTypeElement"],
    visitor: ["typeParameters", "parameters", "typeAnnotation"],
    fields: signatureDeclarationCommon()
  };
  defineType("TSCallSignatureDeclaration", callConstructSignatureDeclaration);
  defineType("TSConstructSignatureDeclaration", callConstructSignatureDeclaration);
  var namedTypeElementCommon = () => ({
    key: (0, _utils.validateType)("Expression"),
    computed: {
      default: false
    },
    optional: (0, _utils.validateOptional)(bool)
  });
  defineType("TSPropertySignature", {
    aliases: ["TSTypeElement"],
    visitor: ["key", "typeAnnotation"],
    fields: Object.assign({}, namedTypeElementCommon(), {
      readonly: (0, _utils.validateOptional)(bool),
      typeAnnotation: (0, _utils.validateOptionalType)("TSTypeAnnotation"),
      kind: {
        validate: (0, _utils.assertOneOf)("get", "set")
      }
    })
  });
  defineType("TSMethodSignature", {
    aliases: ["TSTypeElement"],
    visitor: ["key", "typeParameters", "parameters", "typeAnnotation"],
    fields: Object.assign({}, signatureDeclarationCommon(), namedTypeElementCommon(), {
      kind: {
        validate: (0, _utils.assertOneOf)("method", "get", "set")
      }
    })
  });
  defineType("TSIndexSignature", {
    aliases: ["TSTypeElement"],
    visitor: ["parameters", "typeAnnotation"],
    fields: {
      readonly: (0, _utils.validateOptional)(bool),
      static: (0, _utils.validateOptional)(bool),
      parameters: (0, _utils.validateArrayOfType)("Identifier"),
      typeAnnotation: (0, _utils.validateOptionalType)("TSTypeAnnotation")
    }
  });
  var tsKeywordTypes = ["TSAnyKeyword", "TSBooleanKeyword", "TSBigIntKeyword", "TSIntrinsicKeyword", "TSNeverKeyword", "TSNullKeyword", "TSNumberKeyword", "TSObjectKeyword", "TSStringKeyword", "TSSymbolKeyword", "TSUndefinedKeyword", "TSUnknownKeyword", "TSVoidKeyword"];
  for (const type of tsKeywordTypes) {
    defineType(type, {
      aliases: ["TSType", "TSBaseType"],
      visitor: [],
      fields: {}
    });
  }
  defineType("TSThisType", {
    aliases: ["TSType", "TSBaseType"],
    visitor: [],
    fields: {}
  });
  var fnOrCtrBase = {
    aliases: ["TSType"],
    visitor: ["typeParameters", "parameters", "typeAnnotation"]
  };
  defineType("TSFunctionType", Object.assign({}, fnOrCtrBase, {
    fields: signatureDeclarationCommon()
  }));
  defineType("TSConstructorType", Object.assign({}, fnOrCtrBase, {
    fields: Object.assign({}, signatureDeclarationCommon(), {
      abstract: (0, _utils.validateOptional)(bool)
    })
  }));
  defineType("TSTypeReference", {
    aliases: ["TSType"],
    visitor: ["typeName", "typeParameters"],
    fields: {
      typeName: (0, _utils.validateType)("TSEntityName"),
      typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
    }
  });
  defineType("TSTypePredicate", {
    aliases: ["TSType"],
    visitor: ["parameterName", "typeAnnotation"],
    builder: ["parameterName", "typeAnnotation", "asserts"],
    fields: {
      parameterName: (0, _utils.validateType)("Identifier", "TSThisType"),
      typeAnnotation: (0, _utils.validateOptionalType)("TSTypeAnnotation"),
      asserts: (0, _utils.validateOptional)(bool)
    }
  });
  defineType("TSTypeQuery", {
    aliases: ["TSType"],
    visitor: ["exprName", "typeParameters"],
    fields: {
      exprName: (0, _utils.validateType)("TSEntityName", "TSImportType"),
      typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
    }
  });
  defineType("TSTypeLiteral", {
    aliases: ["TSType"],
    visitor: ["members"],
    fields: {
      members: (0, _utils.validateArrayOfType)("TSTypeElement")
    }
  });
  defineType("TSArrayType", {
    aliases: ["TSType"],
    visitor: ["elementType"],
    fields: {
      elementType: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSTupleType", {
    aliases: ["TSType"],
    visitor: ["elementTypes"],
    fields: {
      elementTypes: (0, _utils.validateArrayOfType)("TSType", "TSNamedTupleMember")
    }
  });
  defineType("TSOptionalType", {
    aliases: ["TSType"],
    visitor: ["typeAnnotation"],
    fields: {
      typeAnnotation: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSRestType", {
    aliases: ["TSType"],
    visitor: ["typeAnnotation"],
    fields: {
      typeAnnotation: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSNamedTupleMember", {
    visitor: ["label", "elementType"],
    builder: ["label", "elementType", "optional"],
    fields: {
      label: (0, _utils.validateType)("Identifier"),
      optional: {
        validate: bool,
        default: false
      },
      elementType: (0, _utils.validateType)("TSType")
    }
  });
  var unionOrIntersection = {
    aliases: ["TSType"],
    visitor: ["types"],
    fields: {
      types: (0, _utils.validateArrayOfType)("TSType")
    }
  };
  defineType("TSUnionType", unionOrIntersection);
  defineType("TSIntersectionType", unionOrIntersection);
  defineType("TSConditionalType", {
    aliases: ["TSType"],
    visitor: ["checkType", "extendsType", "trueType", "falseType"],
    fields: {
      checkType: (0, _utils.validateType)("TSType"),
      extendsType: (0, _utils.validateType)("TSType"),
      trueType: (0, _utils.validateType)("TSType"),
      falseType: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSInferType", {
    aliases: ["TSType"],
    visitor: ["typeParameter"],
    fields: {
      typeParameter: (0, _utils.validateType)("TSTypeParameter")
    }
  });
  defineType("TSParenthesizedType", {
    aliases: ["TSType"],
    visitor: ["typeAnnotation"],
    fields: {
      typeAnnotation: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSTypeOperator", {
    aliases: ["TSType"],
    visitor: ["typeAnnotation"],
    fields: {
      operator: (0, _utils.validate)((0, _utils.assertValueType)("string")),
      typeAnnotation: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSIndexedAccessType", {
    aliases: ["TSType"],
    visitor: ["objectType", "indexType"],
    fields: {
      objectType: (0, _utils.validateType)("TSType"),
      indexType: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSMappedType", {
    aliases: ["TSType"],
    visitor: ["typeParameter", "nameType", "typeAnnotation"],
    builder: ["typeParameter", "typeAnnotation", "nameType"],
    fields: Object.assign({}, {
      typeParameter: (0, _utils.validateType)("TSTypeParameter")
    }, {
      readonly: (0, _utils.validateOptional)((0, _utils.assertOneOf)(true, false, "+", "-")),
      optional: (0, _utils.validateOptional)((0, _utils.assertOneOf)(true, false, "+", "-")),
      typeAnnotation: (0, _utils.validateOptionalType)("TSType"),
      nameType: (0, _utils.validateOptionalType)("TSType")
    })
  });
  defineType("TSLiteralType", {
    aliases: ["TSType", "TSBaseType"],
    visitor: ["literal"],
    fields: {
      literal: {
        validate: function() {
          const unaryExpression = (0, _utils.assertNodeType)("NumericLiteral", "BigIntLiteral");
          const unaryOperator = (0, _utils.assertOneOf)("-");
          const literal = (0, _utils.assertNodeType)("NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "TemplateLiteral");
          function validator2(parent, key, node) {
            if ((0, _is.default)("UnaryExpression", node)) {
              unaryOperator(node, "operator", node.operator);
              unaryExpression(node, "argument", node.argument);
            } else {
              literal(parent, key, node);
            }
          }
          validator2.oneOfNodeTypes = ["NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "TemplateLiteral", "UnaryExpression"];
          return validator2;
        }()
      }
    }
  });
  var expressionWithTypeArguments = {
    aliases: ["TSType"],
    visitor: ["expression", "typeParameters"],
    fields: {
      expression: (0, _utils.validateType)("TSEntityName"),
      typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
    }
  };
  {
    defineType("TSExpressionWithTypeArguments", expressionWithTypeArguments);
  }
  defineType("TSInterfaceDeclaration", {
    aliases: ["Statement", "Declaration"],
    visitor: ["id", "typeParameters", "extends", "body"],
    fields: {
      declare: (0, _utils.validateOptional)(bool),
      id: (0, _utils.validateType)("Identifier"),
      typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),
      extends: (0, _utils.validateOptional)((0, _utils.arrayOfType)("TSExpressionWithTypeArguments")),
      body: (0, _utils.validateType)("TSInterfaceBody")
    }
  });
  defineType("TSInterfaceBody", {
    visitor: ["body"],
    fields: {
      body: (0, _utils.validateArrayOfType)("TSTypeElement")
    }
  });
  defineType("TSTypeAliasDeclaration", {
    aliases: ["Statement", "Declaration"],
    visitor: ["id", "typeParameters", "typeAnnotation"],
    fields: {
      declare: (0, _utils.validateOptional)(bool),
      id: (0, _utils.validateType)("Identifier"),
      typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),
      typeAnnotation: (0, _utils.validateType)("TSType")
    }
  });
  defineType("TSInstantiationExpression", {
    aliases: ["Expression"],
    visitor: ["expression", "typeParameters"],
    fields: {
      expression: (0, _utils.validateType)("Expression"),
      typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
    }
  });
  var TSTypeExpression = {
    aliases: ["Expression", "LVal", "PatternLike"],
    visitor: ["expression", "typeAnnotation"],
    fields: {
      expression: (0, _utils.validateType)("Expression"),
      typeAnnotation: (0, _utils.validateType)("TSType")
    }
  };
  defineType("TSAsExpression", TSTypeExpression);
  defineType("TSSatisfiesExpression", TSTypeExpression);
  defineType("TSTypeAssertion", {
    aliases: ["Expression", "LVal", "PatternLike"],
    visitor: ["typeAnnotation", "expression"],
    fields: {
      typeAnnotation: (0, _utils.validateType)("TSType"),
      expression: (0, _utils.validateType)("Expression")
    }
  });
  defineType("TSEnumDeclaration", {
    aliases: ["Statement", "Declaration"],
    visitor: ["id", "members"],
    fields: {
      declare: (0, _utils.validateOptional)(bool),
      const: (0, _utils.validateOptional)(bool),
      id: (0, _utils.validateType)("Identifier"),
      members: (0, _utils.validateArrayOfType)("TSEnumMember"),
      initializer: (0, _utils.validateOptionalType)("Expression")
    }
  });
  defineType("TSEnumMember", {
    visitor: ["id", "initializer"],
    fields: {
      id: (0, _utils.validateType)("Identifier", "StringLiteral"),
      initializer: (0, _utils.validateOptionalType)("Expression")
    }
  });
  defineType("TSModuleDeclaration", {
    aliases: ["Statement", "Declaration"],
    visitor: ["id", "body"],
    fields: {
      declare: (0, _utils.validateOptional)(bool),
      global: (0, _utils.validateOptional)(bool),
      id: (0, _utils.validateType)("Identifier", "StringLiteral"),
      body: (0, _utils.validateType)("TSModuleBlock", "TSModuleDeclaration")
    }
  });
  defineType("TSModuleBlock", {
    aliases: ["Scopable", "Block", "BlockParent", "FunctionParent"],
    visitor: ["body"],
    fields: {
      body: (0, _utils.validateArrayOfType)("Statement")
    }
  });
  defineType("TSImportType", {
    aliases: ["TSType"],
    visitor: ["argument", "qualifier", "typeParameters"],
    fields: {
      argument: (0, _utils.validateType)("StringLiteral"),
      qualifier: (0, _utils.validateOptionalType)("TSEntityName"),
      typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation"),
      options: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true
      }
    }
  });
  defineType("TSImportEqualsDeclaration", {
    aliases: ["Statement"],
    visitor: ["id", "moduleReference"],
    fields: {
      isExport: (0, _utils.validate)(bool),
      id: (0, _utils.validateType)("Identifier"),
      moduleReference: (0, _utils.validateType)("TSEntityName", "TSExternalModuleReference"),
      importKind: {
        validate: (0, _utils.assertOneOf)("type", "value"),
        optional: true
      }
    }
  });
  defineType("TSExternalModuleReference", {
    visitor: ["expression"],
    fields: {
      expression: (0, _utils.validateType)("StringLiteral")
    }
  });
  defineType("TSNonNullExpression", {
    aliases: ["Expression", "LVal", "PatternLike"],
    visitor: ["expression"],
    fields: {
      expression: (0, _utils.validateType)("Expression")
    }
  });
  defineType("TSExportAssignment", {
    aliases: ["Statement"],
    visitor: ["expression"],
    fields: {
      expression: (0, _utils.validateType)("Expression")
    }
  });
  defineType("TSNamespaceExportDeclaration", {
    aliases: ["Statement"],
    visitor: ["id"],
    fields: {
      id: (0, _utils.validateType)("Identifier")
    }
  });
  defineType("TSTypeAnnotation", {
    visitor: ["typeAnnotation"],
    fields: {
      typeAnnotation: {
        validate: (0, _utils.assertNodeType)("TSType")
      }
    }
  });
  defineType("TSTypeParameterInstantiation", {
    visitor: ["params"],
    fields: {
      params: (0, _utils.validateArrayOfType)("TSType")
    }
  });
  defineType("TSTypeParameterDeclaration", {
    visitor: ["params"],
    fields: {
      params: (0, _utils.validateArrayOfType)("TSTypeParameter")
    }
  });
  defineType("TSTypeParameter", {
    builder: ["constraint", "default", "name"],
    visitor: ["constraint", "default"],
    fields: {
      name: {
        validate: (0, _utils.assertValueType)("string")
      },
      in: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      out: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      const: {
        validate: (0, _utils.assertValueType)("boolean"),
        optional: true
      },
      constraint: {
        validate: (0, _utils.assertNodeType)("TSType"),
        optional: true
      },
      default: {
        validate: (0, _utils.assertNodeType)("TSType"),
        optional: true
      }
    }
  });
});
var require_deprecated_aliases = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.DEPRECATED_ALIASES = undefined;
  var DEPRECATED_ALIASES = exports.DEPRECATED_ALIASES = {
    ModuleDeclaration: "ImportOrExportDeclaration"
  };
});
var require_definitions = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "ALIAS_KEYS", {
    enumerable: true,
    get: function() {
      return _utils.ALIAS_KEYS;
    }
  });
  Object.defineProperty(exports, "BUILDER_KEYS", {
    enumerable: true,
    get: function() {
      return _utils.BUILDER_KEYS;
    }
  });
  Object.defineProperty(exports, "DEPRECATED_ALIASES", {
    enumerable: true,
    get: function() {
      return _deprecatedAliases.DEPRECATED_ALIASES;
    }
  });
  Object.defineProperty(exports, "DEPRECATED_KEYS", {
    enumerable: true,
    get: function() {
      return _utils.DEPRECATED_KEYS;
    }
  });
  Object.defineProperty(exports, "FLIPPED_ALIAS_KEYS", {
    enumerable: true,
    get: function() {
      return _utils.FLIPPED_ALIAS_KEYS;
    }
  });
  Object.defineProperty(exports, "NODE_FIELDS", {
    enumerable: true,
    get: function() {
      return _utils.NODE_FIELDS;
    }
  });
  Object.defineProperty(exports, "NODE_PARENT_VALIDATIONS", {
    enumerable: true,
    get: function() {
      return _utils.NODE_PARENT_VALIDATIONS;
    }
  });
  Object.defineProperty(exports, "PLACEHOLDERS", {
    enumerable: true,
    get: function() {
      return _placeholders.PLACEHOLDERS;
    }
  });
  Object.defineProperty(exports, "PLACEHOLDERS_ALIAS", {
    enumerable: true,
    get: function() {
      return _placeholders.PLACEHOLDERS_ALIAS;
    }
  });
  Object.defineProperty(exports, "PLACEHOLDERS_FLIPPED_ALIAS", {
    enumerable: true,
    get: function() {
      return _placeholders.PLACEHOLDERS_FLIPPED_ALIAS;
    }
  });
  exports.TYPES = undefined;
  Object.defineProperty(exports, "VISITOR_KEYS", {
    enumerable: true,
    get: function() {
      return _utils.VISITOR_KEYS;
    }
  });
  require_core();
  require_flow();
  require_jsx();
  require_misc();
  require_experimental();
  require_typescript();
  var _utils = require_utils3();
  var _placeholders = require_placeholders();
  var _deprecatedAliases = require_deprecated_aliases();
  Object.keys(_deprecatedAliases.DEPRECATED_ALIASES).forEach((deprecatedAlias) => {
    _utils.FLIPPED_ALIAS_KEYS[deprecatedAlias] = _utils.FLIPPED_ALIAS_KEYS[_deprecatedAliases.DEPRECATED_ALIASES[deprecatedAlias]];
  });
  var TYPES = exports.TYPES = [].concat(Object.keys(_utils.VISITOR_KEYS), Object.keys(_utils.FLIPPED_ALIAS_KEYS), Object.keys(_utils.DEPRECATED_KEYS));
});
var require_validate = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = validate2;
  exports.validateChild = validateChild;
  exports.validateField = validateField2;
  exports.validateInternal = validateInternal;
  var _index = require_definitions();
  function validate2(node, key, val2) {
    if (!node)
      return;
    const fields22 = _index.NODE_FIELDS[node.type];
    if (!fields22)
      return;
    const field = fields22[key];
    validateField2(node, key, val2, field);
    validateChild(node, key, val2);
  }
  function validateInternal(field, node, key, val2, maybeNode) {
    if (!(field != null && field.validate))
      return;
    if (field.optional && val2 == null)
      return;
    field.validate(node, key, val2);
    if (maybeNode) {
      var _NODE_PARENT_VALIDATI;
      const type = val2.type;
      if (type == null)
        return;
      (_NODE_PARENT_VALIDATI = _index.NODE_PARENT_VALIDATIONS[type]) == null || _NODE_PARENT_VALIDATI.call(_index.NODE_PARENT_VALIDATIONS, node, key, val2);
    }
  }
  function validateField2(node, key, val2, field) {
    if (!(field != null && field.validate))
      return;
    if (field.optional && val2 == null)
      return;
    field.validate(node, key, val2);
  }
  function validateChild(node, key, val2) {
    var _NODE_PARENT_VALIDATI2;
    const type = val2 == null ? undefined : val2.type;
    if (type == null)
      return;
    (_NODE_PARENT_VALIDATI2 = _index.NODE_PARENT_VALIDATIONS[type]) == null || _NODE_PARENT_VALIDATI2.call(_index.NODE_PARENT_VALIDATIONS, node, key, val2);
  }
});
var require_generated2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.anyTypeAnnotation = anyTypeAnnotation;
  exports.argumentPlaceholder = argumentPlaceholder;
  exports.arrayExpression = arrayExpression;
  exports.arrayPattern = arrayPattern;
  exports.arrayTypeAnnotation = arrayTypeAnnotation;
  exports.arrowFunctionExpression = arrowFunctionExpression;
  exports.assignmentExpression = assignmentExpression;
  exports.assignmentPattern = assignmentPattern;
  exports.awaitExpression = awaitExpression;
  exports.bigIntLiteral = bigIntLiteral;
  exports.binaryExpression = binaryExpression;
  exports.bindExpression = bindExpression;
  exports.blockStatement = blockStatement;
  exports.booleanLiteral = booleanLiteral;
  exports.booleanLiteralTypeAnnotation = booleanLiteralTypeAnnotation;
  exports.booleanTypeAnnotation = booleanTypeAnnotation;
  exports.breakStatement = breakStatement;
  exports.callExpression = callExpression;
  exports.catchClause = catchClause;
  exports.classAccessorProperty = classAccessorProperty;
  exports.classBody = classBody;
  exports.classDeclaration = classDeclaration;
  exports.classExpression = classExpression;
  exports.classImplements = classImplements;
  exports.classMethod = classMethod;
  exports.classPrivateMethod = classPrivateMethod;
  exports.classPrivateProperty = classPrivateProperty;
  exports.classProperty = classProperty;
  exports.conditionalExpression = conditionalExpression;
  exports.continueStatement = continueStatement;
  exports.debuggerStatement = debuggerStatement;
  exports.decimalLiteral = decimalLiteral;
  exports.declareClass = declareClass;
  exports.declareExportAllDeclaration = declareExportAllDeclaration;
  exports.declareExportDeclaration = declareExportDeclaration;
  exports.declareFunction = declareFunction;
  exports.declareInterface = declareInterface;
  exports.declareModule = declareModule;
  exports.declareModuleExports = declareModuleExports;
  exports.declareOpaqueType = declareOpaqueType;
  exports.declareTypeAlias = declareTypeAlias;
  exports.declareVariable = declareVariable;
  exports.declaredPredicate = declaredPredicate;
  exports.decorator = decorator;
  exports.directive = directive;
  exports.directiveLiteral = directiveLiteral;
  exports.doExpression = doExpression;
  exports.doWhileStatement = doWhileStatement;
  exports.emptyStatement = emptyStatement;
  exports.emptyTypeAnnotation = emptyTypeAnnotation;
  exports.enumBooleanBody = enumBooleanBody;
  exports.enumBooleanMember = enumBooleanMember;
  exports.enumDeclaration = enumDeclaration;
  exports.enumDefaultedMember = enumDefaultedMember;
  exports.enumNumberBody = enumNumberBody;
  exports.enumNumberMember = enumNumberMember;
  exports.enumStringBody = enumStringBody;
  exports.enumStringMember = enumStringMember;
  exports.enumSymbolBody = enumSymbolBody;
  exports.existsTypeAnnotation = existsTypeAnnotation;
  exports.exportAllDeclaration = exportAllDeclaration;
  exports.exportDefaultDeclaration = exportDefaultDeclaration;
  exports.exportDefaultSpecifier = exportDefaultSpecifier;
  exports.exportNamedDeclaration = exportNamedDeclaration;
  exports.exportNamespaceSpecifier = exportNamespaceSpecifier;
  exports.exportSpecifier = exportSpecifier;
  exports.expressionStatement = expressionStatement;
  exports.file = file;
  exports.forInStatement = forInStatement;
  exports.forOfStatement = forOfStatement;
  exports.forStatement = forStatement;
  exports.functionDeclaration = functionDeclaration;
  exports.functionExpression = functionExpression;
  exports.functionTypeAnnotation = functionTypeAnnotation;
  exports.functionTypeParam = functionTypeParam;
  exports.genericTypeAnnotation = genericTypeAnnotation;
  exports.identifier = identifier;
  exports.ifStatement = ifStatement;
  exports.import = _import;
  exports.importAttribute = importAttribute;
  exports.importDeclaration = importDeclaration;
  exports.importDefaultSpecifier = importDefaultSpecifier;
  exports.importExpression = importExpression;
  exports.importNamespaceSpecifier = importNamespaceSpecifier;
  exports.importSpecifier = importSpecifier;
  exports.indexedAccessType = indexedAccessType;
  exports.inferredPredicate = inferredPredicate;
  exports.interfaceDeclaration = interfaceDeclaration;
  exports.interfaceExtends = interfaceExtends;
  exports.interfaceTypeAnnotation = interfaceTypeAnnotation;
  exports.interpreterDirective = interpreterDirective;
  exports.intersectionTypeAnnotation = intersectionTypeAnnotation;
  exports.jSXAttribute = exports.jsxAttribute = jsxAttribute;
  exports.jSXClosingElement = exports.jsxClosingElement = jsxClosingElement;
  exports.jSXClosingFragment = exports.jsxClosingFragment = jsxClosingFragment;
  exports.jSXElement = exports.jsxElement = jsxElement;
  exports.jSXEmptyExpression = exports.jsxEmptyExpression = jsxEmptyExpression;
  exports.jSXExpressionContainer = exports.jsxExpressionContainer = jsxExpressionContainer;
  exports.jSXFragment = exports.jsxFragment = jsxFragment;
  exports.jSXIdentifier = exports.jsxIdentifier = jsxIdentifier;
  exports.jSXMemberExpression = exports.jsxMemberExpression = jsxMemberExpression;
  exports.jSXNamespacedName = exports.jsxNamespacedName = jsxNamespacedName;
  exports.jSXOpeningElement = exports.jsxOpeningElement = jsxOpeningElement;
  exports.jSXOpeningFragment = exports.jsxOpeningFragment = jsxOpeningFragment;
  exports.jSXSpreadAttribute = exports.jsxSpreadAttribute = jsxSpreadAttribute;
  exports.jSXSpreadChild = exports.jsxSpreadChild = jsxSpreadChild;
  exports.jSXText = exports.jsxText = jsxText;
  exports.labeledStatement = labeledStatement;
  exports.logicalExpression = logicalExpression;
  exports.memberExpression = memberExpression;
  exports.metaProperty = metaProperty;
  exports.mixedTypeAnnotation = mixedTypeAnnotation;
  exports.moduleExpression = moduleExpression;
  exports.newExpression = newExpression;
  exports.noop = noop;
  exports.nullLiteral = nullLiteral;
  exports.nullLiteralTypeAnnotation = nullLiteralTypeAnnotation;
  exports.nullableTypeAnnotation = nullableTypeAnnotation;
  exports.numberLiteral = NumberLiteral;
  exports.numberLiteralTypeAnnotation = numberLiteralTypeAnnotation;
  exports.numberTypeAnnotation = numberTypeAnnotation;
  exports.numericLiteral = numericLiteral;
  exports.objectExpression = objectExpression;
  exports.objectMethod = objectMethod;
  exports.objectPattern = objectPattern;
  exports.objectProperty = objectProperty;
  exports.objectTypeAnnotation = objectTypeAnnotation;
  exports.objectTypeCallProperty = objectTypeCallProperty;
  exports.objectTypeIndexer = objectTypeIndexer;
  exports.objectTypeInternalSlot = objectTypeInternalSlot;
  exports.objectTypeProperty = objectTypeProperty;
  exports.objectTypeSpreadProperty = objectTypeSpreadProperty;
  exports.opaqueType = opaqueType;
  exports.optionalCallExpression = optionalCallExpression;
  exports.optionalIndexedAccessType = optionalIndexedAccessType;
  exports.optionalMemberExpression = optionalMemberExpression;
  exports.parenthesizedExpression = parenthesizedExpression;
  exports.pipelineBareFunction = pipelineBareFunction;
  exports.pipelinePrimaryTopicReference = pipelinePrimaryTopicReference;
  exports.pipelineTopicExpression = pipelineTopicExpression;
  exports.placeholder = placeholder;
  exports.privateName = privateName;
  exports.program = program;
  exports.qualifiedTypeIdentifier = qualifiedTypeIdentifier;
  exports.recordExpression = recordExpression;
  exports.regExpLiteral = regExpLiteral;
  exports.regexLiteral = RegexLiteral;
  exports.restElement = restElement;
  exports.restProperty = RestProperty;
  exports.returnStatement = returnStatement;
  exports.sequenceExpression = sequenceExpression;
  exports.spreadElement = spreadElement;
  exports.spreadProperty = SpreadProperty;
  exports.staticBlock = staticBlock;
  exports.stringLiteral = stringLiteral;
  exports.stringLiteralTypeAnnotation = stringLiteralTypeAnnotation;
  exports.stringTypeAnnotation = stringTypeAnnotation;
  exports.super = _super;
  exports.switchCase = switchCase;
  exports.switchStatement = switchStatement;
  exports.symbolTypeAnnotation = symbolTypeAnnotation;
  exports.taggedTemplateExpression = taggedTemplateExpression;
  exports.templateElement = templateElement;
  exports.templateLiteral = templateLiteral;
  exports.thisExpression = thisExpression;
  exports.thisTypeAnnotation = thisTypeAnnotation;
  exports.throwStatement = throwStatement;
  exports.topicReference = topicReference;
  exports.tryStatement = tryStatement;
  exports.tSAnyKeyword = exports.tsAnyKeyword = tsAnyKeyword;
  exports.tSArrayType = exports.tsArrayType = tsArrayType;
  exports.tSAsExpression = exports.tsAsExpression = tsAsExpression;
  exports.tSBigIntKeyword = exports.tsBigIntKeyword = tsBigIntKeyword;
  exports.tSBooleanKeyword = exports.tsBooleanKeyword = tsBooleanKeyword;
  exports.tSCallSignatureDeclaration = exports.tsCallSignatureDeclaration = tsCallSignatureDeclaration;
  exports.tSConditionalType = exports.tsConditionalType = tsConditionalType;
  exports.tSConstructSignatureDeclaration = exports.tsConstructSignatureDeclaration = tsConstructSignatureDeclaration;
  exports.tSConstructorType = exports.tsConstructorType = tsConstructorType;
  exports.tSDeclareFunction = exports.tsDeclareFunction = tsDeclareFunction;
  exports.tSDeclareMethod = exports.tsDeclareMethod = tsDeclareMethod;
  exports.tSEnumDeclaration = exports.tsEnumDeclaration = tsEnumDeclaration;
  exports.tSEnumMember = exports.tsEnumMember = tsEnumMember;
  exports.tSExportAssignment = exports.tsExportAssignment = tsExportAssignment;
  exports.tSExpressionWithTypeArguments = exports.tsExpressionWithTypeArguments = tsExpressionWithTypeArguments;
  exports.tSExternalModuleReference = exports.tsExternalModuleReference = tsExternalModuleReference;
  exports.tSFunctionType = exports.tsFunctionType = tsFunctionType;
  exports.tSImportEqualsDeclaration = exports.tsImportEqualsDeclaration = tsImportEqualsDeclaration;
  exports.tSImportType = exports.tsImportType = tsImportType;
  exports.tSIndexSignature = exports.tsIndexSignature = tsIndexSignature;
  exports.tSIndexedAccessType = exports.tsIndexedAccessType = tsIndexedAccessType;
  exports.tSInferType = exports.tsInferType = tsInferType;
  exports.tSInstantiationExpression = exports.tsInstantiationExpression = tsInstantiationExpression;
  exports.tSInterfaceBody = exports.tsInterfaceBody = tsInterfaceBody;
  exports.tSInterfaceDeclaration = exports.tsInterfaceDeclaration = tsInterfaceDeclaration;
  exports.tSIntersectionType = exports.tsIntersectionType = tsIntersectionType;
  exports.tSIntrinsicKeyword = exports.tsIntrinsicKeyword = tsIntrinsicKeyword;
  exports.tSLiteralType = exports.tsLiteralType = tsLiteralType;
  exports.tSMappedType = exports.tsMappedType = tsMappedType;
  exports.tSMethodSignature = exports.tsMethodSignature = tsMethodSignature;
  exports.tSModuleBlock = exports.tsModuleBlock = tsModuleBlock;
  exports.tSModuleDeclaration = exports.tsModuleDeclaration = tsModuleDeclaration;
  exports.tSNamedTupleMember = exports.tsNamedTupleMember = tsNamedTupleMember;
  exports.tSNamespaceExportDeclaration = exports.tsNamespaceExportDeclaration = tsNamespaceExportDeclaration;
  exports.tSNeverKeyword = exports.tsNeverKeyword = tsNeverKeyword;
  exports.tSNonNullExpression = exports.tsNonNullExpression = tsNonNullExpression;
  exports.tSNullKeyword = exports.tsNullKeyword = tsNullKeyword;
  exports.tSNumberKeyword = exports.tsNumberKeyword = tsNumberKeyword;
  exports.tSObjectKeyword = exports.tsObjectKeyword = tsObjectKeyword;
  exports.tSOptionalType = exports.tsOptionalType = tsOptionalType;
  exports.tSParameterProperty = exports.tsParameterProperty = tsParameterProperty;
  exports.tSParenthesizedType = exports.tsParenthesizedType = tsParenthesizedType;
  exports.tSPropertySignature = exports.tsPropertySignature = tsPropertySignature;
  exports.tSQualifiedName = exports.tsQualifiedName = tsQualifiedName;
  exports.tSRestType = exports.tsRestType = tsRestType;
  exports.tSSatisfiesExpression = exports.tsSatisfiesExpression = tsSatisfiesExpression;
  exports.tSStringKeyword = exports.tsStringKeyword = tsStringKeyword;
  exports.tSSymbolKeyword = exports.tsSymbolKeyword = tsSymbolKeyword;
  exports.tSThisType = exports.tsThisType = tsThisType;
  exports.tSTupleType = exports.tsTupleType = tsTupleType;
  exports.tSTypeAliasDeclaration = exports.tsTypeAliasDeclaration = tsTypeAliasDeclaration;
  exports.tSTypeAnnotation = exports.tsTypeAnnotation = tsTypeAnnotation;
  exports.tSTypeAssertion = exports.tsTypeAssertion = tsTypeAssertion;
  exports.tSTypeLiteral = exports.tsTypeLiteral = tsTypeLiteral;
  exports.tSTypeOperator = exports.tsTypeOperator = tsTypeOperator;
  exports.tSTypeParameter = exports.tsTypeParameter = tsTypeParameter;
  exports.tSTypeParameterDeclaration = exports.tsTypeParameterDeclaration = tsTypeParameterDeclaration;
  exports.tSTypeParameterInstantiation = exports.tsTypeParameterInstantiation = tsTypeParameterInstantiation;
  exports.tSTypePredicate = exports.tsTypePredicate = tsTypePredicate;
  exports.tSTypeQuery = exports.tsTypeQuery = tsTypeQuery;
  exports.tSTypeReference = exports.tsTypeReference = tsTypeReference;
  exports.tSUndefinedKeyword = exports.tsUndefinedKeyword = tsUndefinedKeyword;
  exports.tSUnionType = exports.tsUnionType = tsUnionType;
  exports.tSUnknownKeyword = exports.tsUnknownKeyword = tsUnknownKeyword;
  exports.tSVoidKeyword = exports.tsVoidKeyword = tsVoidKeyword;
  exports.tupleExpression = tupleExpression;
  exports.tupleTypeAnnotation = tupleTypeAnnotation;
  exports.typeAlias = typeAlias;
  exports.typeAnnotation = typeAnnotation;
  exports.typeCastExpression = typeCastExpression;
  exports.typeParameter = typeParameter;
  exports.typeParameterDeclaration = typeParameterDeclaration;
  exports.typeParameterInstantiation = typeParameterInstantiation;
  exports.typeofTypeAnnotation = typeofTypeAnnotation;
  exports.unaryExpression = unaryExpression;
  exports.unionTypeAnnotation = unionTypeAnnotation;
  exports.updateExpression = updateExpression;
  exports.v8IntrinsicIdentifier = v8IntrinsicIdentifier;
  exports.variableDeclaration = variableDeclaration;
  exports.variableDeclarator = variableDeclarator;
  exports.variance = variance;
  exports.voidTypeAnnotation = voidTypeAnnotation;
  exports.whileStatement = whileStatement;
  exports.withStatement = withStatement;
  exports.yieldExpression = yieldExpression;
  var _validate = require_validate();
  var _deprecationWarning = require_deprecationWarning();
  var utils5 = require_utils3();
  var {
    validateInternal: validate2
  } = _validate;
  var {
    NODE_FIELDS
  } = utils5;
  function arrayExpression(elements = []) {
    const node = {
      type: "ArrayExpression",
      elements
    };
    const defs = NODE_FIELDS.ArrayExpression;
    validate2(defs.elements, node, "elements", elements, 1);
    return node;
  }
  function assignmentExpression(operator, left, right) {
    const node = {
      type: "AssignmentExpression",
      operator,
      left,
      right
    };
    const defs = NODE_FIELDS.AssignmentExpression;
    validate2(defs.operator, node, "operator", operator);
    validate2(defs.left, node, "left", left, 1);
    validate2(defs.right, node, "right", right, 1);
    return node;
  }
  function binaryExpression(operator, left, right) {
    const node = {
      type: "BinaryExpression",
      operator,
      left,
      right
    };
    const defs = NODE_FIELDS.BinaryExpression;
    validate2(defs.operator, node, "operator", operator);
    validate2(defs.left, node, "left", left, 1);
    validate2(defs.right, node, "right", right, 1);
    return node;
  }
  function interpreterDirective(value) {
    const node = {
      type: "InterpreterDirective",
      value
    };
    const defs = NODE_FIELDS.InterpreterDirective;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function directive(value) {
    const node = {
      type: "Directive",
      value
    };
    const defs = NODE_FIELDS.Directive;
    validate2(defs.value, node, "value", value, 1);
    return node;
  }
  function directiveLiteral(value) {
    const node = {
      type: "DirectiveLiteral",
      value
    };
    const defs = NODE_FIELDS.DirectiveLiteral;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function blockStatement(body, directives = []) {
    const node = {
      type: "BlockStatement",
      body,
      directives
    };
    const defs = NODE_FIELDS.BlockStatement;
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.directives, node, "directives", directives, 1);
    return node;
  }
  function breakStatement(label = null) {
    const node = {
      type: "BreakStatement",
      label
    };
    const defs = NODE_FIELDS.BreakStatement;
    validate2(defs.label, node, "label", label, 1);
    return node;
  }
  function callExpression(callee, _arguments) {
    const node = {
      type: "CallExpression",
      callee,
      arguments: _arguments
    };
    const defs = NODE_FIELDS.CallExpression;
    validate2(defs.callee, node, "callee", callee, 1);
    validate2(defs.arguments, node, "arguments", _arguments, 1);
    return node;
  }
  function catchClause(param = null, body) {
    const node = {
      type: "CatchClause",
      param,
      body
    };
    const defs = NODE_FIELDS.CatchClause;
    validate2(defs.param, node, "param", param, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function conditionalExpression(test, consequent, alternate) {
    const node = {
      type: "ConditionalExpression",
      test,
      consequent,
      alternate
    };
    const defs = NODE_FIELDS.ConditionalExpression;
    validate2(defs.test, node, "test", test, 1);
    validate2(defs.consequent, node, "consequent", consequent, 1);
    validate2(defs.alternate, node, "alternate", alternate, 1);
    return node;
  }
  function continueStatement(label = null) {
    const node = {
      type: "ContinueStatement",
      label
    };
    const defs = NODE_FIELDS.ContinueStatement;
    validate2(defs.label, node, "label", label, 1);
    return node;
  }
  function debuggerStatement() {
    return {
      type: "DebuggerStatement"
    };
  }
  function doWhileStatement(test, body) {
    const node = {
      type: "DoWhileStatement",
      test,
      body
    };
    const defs = NODE_FIELDS.DoWhileStatement;
    validate2(defs.test, node, "test", test, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function emptyStatement() {
    return {
      type: "EmptyStatement"
    };
  }
  function expressionStatement(expression) {
    const node = {
      type: "ExpressionStatement",
      expression
    };
    const defs = NODE_FIELDS.ExpressionStatement;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function file(program2, comments = null, tokens = null) {
    const node = {
      type: "File",
      program: program2,
      comments,
      tokens
    };
    const defs = NODE_FIELDS.File;
    validate2(defs.program, node, "program", program2, 1);
    validate2(defs.comments, node, "comments", comments, 1);
    validate2(defs.tokens, node, "tokens", tokens);
    return node;
  }
  function forInStatement(left, right, body) {
    const node = {
      type: "ForInStatement",
      left,
      right,
      body
    };
    const defs = NODE_FIELDS.ForInStatement;
    validate2(defs.left, node, "left", left, 1);
    validate2(defs.right, node, "right", right, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function forStatement(init22 = null, test = null, update = null, body) {
    const node = {
      type: "ForStatement",
      init: init22,
      test,
      update,
      body
    };
    const defs = NODE_FIELDS.ForStatement;
    validate2(defs.init, node, "init", init22, 1);
    validate2(defs.test, node, "test", test, 1);
    validate2(defs.update, node, "update", update, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function functionDeclaration(id = null, params, body, generator = false, async = false) {
    const node = {
      type: "FunctionDeclaration",
      id,
      params,
      body,
      generator,
      async
    };
    const defs = NODE_FIELDS.FunctionDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.generator, node, "generator", generator);
    validate2(defs.async, node, "async", async);
    return node;
  }
  function functionExpression(id = null, params, body, generator = false, async = false) {
    const node = {
      type: "FunctionExpression",
      id,
      params,
      body,
      generator,
      async
    };
    const defs = NODE_FIELDS.FunctionExpression;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.generator, node, "generator", generator);
    validate2(defs.async, node, "async", async);
    return node;
  }
  function identifier(name) {
    const node = {
      type: "Identifier",
      name
    };
    const defs = NODE_FIELDS.Identifier;
    validate2(defs.name, node, "name", name);
    return node;
  }
  function ifStatement(test, consequent, alternate = null) {
    const node = {
      type: "IfStatement",
      test,
      consequent,
      alternate
    };
    const defs = NODE_FIELDS.IfStatement;
    validate2(defs.test, node, "test", test, 1);
    validate2(defs.consequent, node, "consequent", consequent, 1);
    validate2(defs.alternate, node, "alternate", alternate, 1);
    return node;
  }
  function labeledStatement(label, body) {
    const node = {
      type: "LabeledStatement",
      label,
      body
    };
    const defs = NODE_FIELDS.LabeledStatement;
    validate2(defs.label, node, "label", label, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function stringLiteral(value) {
    const node = {
      type: "StringLiteral",
      value
    };
    const defs = NODE_FIELDS.StringLiteral;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function numericLiteral(value) {
    const node = {
      type: "NumericLiteral",
      value
    };
    const defs = NODE_FIELDS.NumericLiteral;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function nullLiteral() {
    return {
      type: "NullLiteral"
    };
  }
  function booleanLiteral(value) {
    const node = {
      type: "BooleanLiteral",
      value
    };
    const defs = NODE_FIELDS.BooleanLiteral;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function regExpLiteral(pattern, flags = "") {
    const node = {
      type: "RegExpLiteral",
      pattern,
      flags
    };
    const defs = NODE_FIELDS.RegExpLiteral;
    validate2(defs.pattern, node, "pattern", pattern);
    validate2(defs.flags, node, "flags", flags);
    return node;
  }
  function logicalExpression(operator, left, right) {
    const node = {
      type: "LogicalExpression",
      operator,
      left,
      right
    };
    const defs = NODE_FIELDS.LogicalExpression;
    validate2(defs.operator, node, "operator", operator);
    validate2(defs.left, node, "left", left, 1);
    validate2(defs.right, node, "right", right, 1);
    return node;
  }
  function memberExpression(object, property, computed = false, optional = null) {
    const node = {
      type: "MemberExpression",
      object,
      property,
      computed,
      optional
    };
    const defs = NODE_FIELDS.MemberExpression;
    validate2(defs.object, node, "object", object, 1);
    validate2(defs.property, node, "property", property, 1);
    validate2(defs.computed, node, "computed", computed);
    validate2(defs.optional, node, "optional", optional);
    return node;
  }
  function newExpression(callee, _arguments) {
    const node = {
      type: "NewExpression",
      callee,
      arguments: _arguments
    };
    const defs = NODE_FIELDS.NewExpression;
    validate2(defs.callee, node, "callee", callee, 1);
    validate2(defs.arguments, node, "arguments", _arguments, 1);
    return node;
  }
  function program(body, directives = [], sourceType = "script", interpreter = null) {
    const node = {
      type: "Program",
      body,
      directives,
      sourceType,
      interpreter
    };
    const defs = NODE_FIELDS.Program;
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.directives, node, "directives", directives, 1);
    validate2(defs.sourceType, node, "sourceType", sourceType);
    validate2(defs.interpreter, node, "interpreter", interpreter, 1);
    return node;
  }
  function objectExpression(properties) {
    const node = {
      type: "ObjectExpression",
      properties
    };
    const defs = NODE_FIELDS.ObjectExpression;
    validate2(defs.properties, node, "properties", properties, 1);
    return node;
  }
  function objectMethod(kind = "method", key, params, body, computed = false, generator = false, async = false) {
    const node = {
      type: "ObjectMethod",
      kind,
      key,
      params,
      body,
      computed,
      generator,
      async
    };
    const defs = NODE_FIELDS.ObjectMethod;
    validate2(defs.kind, node, "kind", kind);
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.computed, node, "computed", computed);
    validate2(defs.generator, node, "generator", generator);
    validate2(defs.async, node, "async", async);
    return node;
  }
  function objectProperty(key, value, computed = false, shorthand = false, decorators = null) {
    const node = {
      type: "ObjectProperty",
      key,
      value,
      computed,
      shorthand,
      decorators
    };
    const defs = NODE_FIELDS.ObjectProperty;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.value, node, "value", value, 1);
    validate2(defs.computed, node, "computed", computed);
    validate2(defs.shorthand, node, "shorthand", shorthand);
    validate2(defs.decorators, node, "decorators", decorators, 1);
    return node;
  }
  function restElement(argument) {
    const node = {
      type: "RestElement",
      argument
    };
    const defs = NODE_FIELDS.RestElement;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function returnStatement(argument = null) {
    const node = {
      type: "ReturnStatement",
      argument
    };
    const defs = NODE_FIELDS.ReturnStatement;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function sequenceExpression(expressions) {
    const node = {
      type: "SequenceExpression",
      expressions
    };
    const defs = NODE_FIELDS.SequenceExpression;
    validate2(defs.expressions, node, "expressions", expressions, 1);
    return node;
  }
  function parenthesizedExpression(expression) {
    const node = {
      type: "ParenthesizedExpression",
      expression
    };
    const defs = NODE_FIELDS.ParenthesizedExpression;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function switchCase(test = null, consequent) {
    const node = {
      type: "SwitchCase",
      test,
      consequent
    };
    const defs = NODE_FIELDS.SwitchCase;
    validate2(defs.test, node, "test", test, 1);
    validate2(defs.consequent, node, "consequent", consequent, 1);
    return node;
  }
  function switchStatement(discriminant, cases) {
    const node = {
      type: "SwitchStatement",
      discriminant,
      cases
    };
    const defs = NODE_FIELDS.SwitchStatement;
    validate2(defs.discriminant, node, "discriminant", discriminant, 1);
    validate2(defs.cases, node, "cases", cases, 1);
    return node;
  }
  function thisExpression() {
    return {
      type: "ThisExpression"
    };
  }
  function throwStatement(argument) {
    const node = {
      type: "ThrowStatement",
      argument
    };
    const defs = NODE_FIELDS.ThrowStatement;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function tryStatement(block, handler3 = null, finalizer = null) {
    const node = {
      type: "TryStatement",
      block,
      handler: handler3,
      finalizer
    };
    const defs = NODE_FIELDS.TryStatement;
    validate2(defs.block, node, "block", block, 1);
    validate2(defs.handler, node, "handler", handler3, 1);
    validate2(defs.finalizer, node, "finalizer", finalizer, 1);
    return node;
  }
  function unaryExpression(operator, argument, prefix = true) {
    const node = {
      type: "UnaryExpression",
      operator,
      argument,
      prefix
    };
    const defs = NODE_FIELDS.UnaryExpression;
    validate2(defs.operator, node, "operator", operator);
    validate2(defs.argument, node, "argument", argument, 1);
    validate2(defs.prefix, node, "prefix", prefix);
    return node;
  }
  function updateExpression(operator, argument, prefix = false) {
    const node = {
      type: "UpdateExpression",
      operator,
      argument,
      prefix
    };
    const defs = NODE_FIELDS.UpdateExpression;
    validate2(defs.operator, node, "operator", operator);
    validate2(defs.argument, node, "argument", argument, 1);
    validate2(defs.prefix, node, "prefix", prefix);
    return node;
  }
  function variableDeclaration(kind, declarations) {
    const node = {
      type: "VariableDeclaration",
      kind,
      declarations
    };
    const defs = NODE_FIELDS.VariableDeclaration;
    validate2(defs.kind, node, "kind", kind);
    validate2(defs.declarations, node, "declarations", declarations, 1);
    return node;
  }
  function variableDeclarator(id, init22 = null) {
    const node = {
      type: "VariableDeclarator",
      id,
      init: init22
    };
    const defs = NODE_FIELDS.VariableDeclarator;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.init, node, "init", init22, 1);
    return node;
  }
  function whileStatement(test, body) {
    const node = {
      type: "WhileStatement",
      test,
      body
    };
    const defs = NODE_FIELDS.WhileStatement;
    validate2(defs.test, node, "test", test, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function withStatement(object, body) {
    const node = {
      type: "WithStatement",
      object,
      body
    };
    const defs = NODE_FIELDS.WithStatement;
    validate2(defs.object, node, "object", object, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function assignmentPattern(left, right) {
    const node = {
      type: "AssignmentPattern",
      left,
      right
    };
    const defs = NODE_FIELDS.AssignmentPattern;
    validate2(defs.left, node, "left", left, 1);
    validate2(defs.right, node, "right", right, 1);
    return node;
  }
  function arrayPattern(elements) {
    const node = {
      type: "ArrayPattern",
      elements
    };
    const defs = NODE_FIELDS.ArrayPattern;
    validate2(defs.elements, node, "elements", elements, 1);
    return node;
  }
  function arrowFunctionExpression(params, body, async = false) {
    const node = {
      type: "ArrowFunctionExpression",
      params,
      body,
      async,
      expression: null
    };
    const defs = NODE_FIELDS.ArrowFunctionExpression;
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.async, node, "async", async);
    return node;
  }
  function classBody(body) {
    const node = {
      type: "ClassBody",
      body
    };
    const defs = NODE_FIELDS.ClassBody;
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function classExpression(id = null, superClass = null, body, decorators = null) {
    const node = {
      type: "ClassExpression",
      id,
      superClass,
      body,
      decorators
    };
    const defs = NODE_FIELDS.ClassExpression;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.superClass, node, "superClass", superClass, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.decorators, node, "decorators", decorators, 1);
    return node;
  }
  function classDeclaration(id = null, superClass = null, body, decorators = null) {
    const node = {
      type: "ClassDeclaration",
      id,
      superClass,
      body,
      decorators
    };
    const defs = NODE_FIELDS.ClassDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.superClass, node, "superClass", superClass, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.decorators, node, "decorators", decorators, 1);
    return node;
  }
  function exportAllDeclaration(source) {
    const node = {
      type: "ExportAllDeclaration",
      source
    };
    const defs = NODE_FIELDS.ExportAllDeclaration;
    validate2(defs.source, node, "source", source, 1);
    return node;
  }
  function exportDefaultDeclaration(declaration) {
    const node = {
      type: "ExportDefaultDeclaration",
      declaration
    };
    const defs = NODE_FIELDS.ExportDefaultDeclaration;
    validate2(defs.declaration, node, "declaration", declaration, 1);
    return node;
  }
  function exportNamedDeclaration(declaration = null, specifiers = [], source = null) {
    const node = {
      type: "ExportNamedDeclaration",
      declaration,
      specifiers,
      source
    };
    const defs = NODE_FIELDS.ExportNamedDeclaration;
    validate2(defs.declaration, node, "declaration", declaration, 1);
    validate2(defs.specifiers, node, "specifiers", specifiers, 1);
    validate2(defs.source, node, "source", source, 1);
    return node;
  }
  function exportSpecifier(local, exported) {
    const node = {
      type: "ExportSpecifier",
      local,
      exported
    };
    const defs = NODE_FIELDS.ExportSpecifier;
    validate2(defs.local, node, "local", local, 1);
    validate2(defs.exported, node, "exported", exported, 1);
    return node;
  }
  function forOfStatement(left, right, body, _await = false) {
    const node = {
      type: "ForOfStatement",
      left,
      right,
      body,
      await: _await
    };
    const defs = NODE_FIELDS.ForOfStatement;
    validate2(defs.left, node, "left", left, 1);
    validate2(defs.right, node, "right", right, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.await, node, "await", _await);
    return node;
  }
  function importDeclaration(specifiers, source) {
    const node = {
      type: "ImportDeclaration",
      specifiers,
      source
    };
    const defs = NODE_FIELDS.ImportDeclaration;
    validate2(defs.specifiers, node, "specifiers", specifiers, 1);
    validate2(defs.source, node, "source", source, 1);
    return node;
  }
  function importDefaultSpecifier(local) {
    const node = {
      type: "ImportDefaultSpecifier",
      local
    };
    const defs = NODE_FIELDS.ImportDefaultSpecifier;
    validate2(defs.local, node, "local", local, 1);
    return node;
  }
  function importNamespaceSpecifier(local) {
    const node = {
      type: "ImportNamespaceSpecifier",
      local
    };
    const defs = NODE_FIELDS.ImportNamespaceSpecifier;
    validate2(defs.local, node, "local", local, 1);
    return node;
  }
  function importSpecifier(local, imported) {
    const node = {
      type: "ImportSpecifier",
      local,
      imported
    };
    const defs = NODE_FIELDS.ImportSpecifier;
    validate2(defs.local, node, "local", local, 1);
    validate2(defs.imported, node, "imported", imported, 1);
    return node;
  }
  function importExpression(source, options3 = null) {
    const node = {
      type: "ImportExpression",
      source,
      options: options3
    };
    const defs = NODE_FIELDS.ImportExpression;
    validate2(defs.source, node, "source", source, 1);
    validate2(defs.options, node, "options", options3, 1);
    return node;
  }
  function metaProperty(meta, property) {
    const node = {
      type: "MetaProperty",
      meta,
      property
    };
    const defs = NODE_FIELDS.MetaProperty;
    validate2(defs.meta, node, "meta", meta, 1);
    validate2(defs.property, node, "property", property, 1);
    return node;
  }
  function classMethod(kind = "method", key, params, body, computed = false, _static = false, generator = false, async = false) {
    const node = {
      type: "ClassMethod",
      kind,
      key,
      params,
      body,
      computed,
      static: _static,
      generator,
      async
    };
    const defs = NODE_FIELDS.ClassMethod;
    validate2(defs.kind, node, "kind", kind);
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.computed, node, "computed", computed);
    validate2(defs.static, node, "static", _static);
    validate2(defs.generator, node, "generator", generator);
    validate2(defs.async, node, "async", async);
    return node;
  }
  function objectPattern(properties) {
    const node = {
      type: "ObjectPattern",
      properties
    };
    const defs = NODE_FIELDS.ObjectPattern;
    validate2(defs.properties, node, "properties", properties, 1);
    return node;
  }
  function spreadElement(argument) {
    const node = {
      type: "SpreadElement",
      argument
    };
    const defs = NODE_FIELDS.SpreadElement;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function _super() {
    return {
      type: "Super"
    };
  }
  function taggedTemplateExpression(tag, quasi) {
    const node = {
      type: "TaggedTemplateExpression",
      tag,
      quasi
    };
    const defs = NODE_FIELDS.TaggedTemplateExpression;
    validate2(defs.tag, node, "tag", tag, 1);
    validate2(defs.quasi, node, "quasi", quasi, 1);
    return node;
  }
  function templateElement(value, tail = false) {
    const node = {
      type: "TemplateElement",
      value,
      tail
    };
    const defs = NODE_FIELDS.TemplateElement;
    validate2(defs.value, node, "value", value);
    validate2(defs.tail, node, "tail", tail);
    return node;
  }
  function templateLiteral(quasis, expressions) {
    const node = {
      type: "TemplateLiteral",
      quasis,
      expressions
    };
    const defs = NODE_FIELDS.TemplateLiteral;
    validate2(defs.quasis, node, "quasis", quasis, 1);
    validate2(defs.expressions, node, "expressions", expressions, 1);
    return node;
  }
  function yieldExpression(argument = null, delegate = false) {
    const node = {
      type: "YieldExpression",
      argument,
      delegate
    };
    const defs = NODE_FIELDS.YieldExpression;
    validate2(defs.argument, node, "argument", argument, 1);
    validate2(defs.delegate, node, "delegate", delegate);
    return node;
  }
  function awaitExpression(argument) {
    const node = {
      type: "AwaitExpression",
      argument
    };
    const defs = NODE_FIELDS.AwaitExpression;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function _import() {
    return {
      type: "Import"
    };
  }
  function bigIntLiteral(value) {
    const node = {
      type: "BigIntLiteral",
      value
    };
    const defs = NODE_FIELDS.BigIntLiteral;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function exportNamespaceSpecifier(exported) {
    const node = {
      type: "ExportNamespaceSpecifier",
      exported
    };
    const defs = NODE_FIELDS.ExportNamespaceSpecifier;
    validate2(defs.exported, node, "exported", exported, 1);
    return node;
  }
  function optionalMemberExpression(object, property, computed = false, optional) {
    const node = {
      type: "OptionalMemberExpression",
      object,
      property,
      computed,
      optional
    };
    const defs = NODE_FIELDS.OptionalMemberExpression;
    validate2(defs.object, node, "object", object, 1);
    validate2(defs.property, node, "property", property, 1);
    validate2(defs.computed, node, "computed", computed);
    validate2(defs.optional, node, "optional", optional);
    return node;
  }
  function optionalCallExpression(callee, _arguments, optional) {
    const node = {
      type: "OptionalCallExpression",
      callee,
      arguments: _arguments,
      optional
    };
    const defs = NODE_FIELDS.OptionalCallExpression;
    validate2(defs.callee, node, "callee", callee, 1);
    validate2(defs.arguments, node, "arguments", _arguments, 1);
    validate2(defs.optional, node, "optional", optional);
    return node;
  }
  function classProperty(key, value = null, typeAnnotation2 = null, decorators = null, computed = false, _static = false) {
    const node = {
      type: "ClassProperty",
      key,
      value,
      typeAnnotation: typeAnnotation2,
      decorators,
      computed,
      static: _static
    };
    const defs = NODE_FIELDS.ClassProperty;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.value, node, "value", value, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    validate2(defs.decorators, node, "decorators", decorators, 1);
    validate2(defs.computed, node, "computed", computed);
    validate2(defs.static, node, "static", _static);
    return node;
  }
  function classAccessorProperty(key, value = null, typeAnnotation2 = null, decorators = null, computed = false, _static = false) {
    const node = {
      type: "ClassAccessorProperty",
      key,
      value,
      typeAnnotation: typeAnnotation2,
      decorators,
      computed,
      static: _static
    };
    const defs = NODE_FIELDS.ClassAccessorProperty;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.value, node, "value", value, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    validate2(defs.decorators, node, "decorators", decorators, 1);
    validate2(defs.computed, node, "computed", computed);
    validate2(defs.static, node, "static", _static);
    return node;
  }
  function classPrivateProperty(key, value = null, decorators = null, _static = false) {
    const node = {
      type: "ClassPrivateProperty",
      key,
      value,
      decorators,
      static: _static
    };
    const defs = NODE_FIELDS.ClassPrivateProperty;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.value, node, "value", value, 1);
    validate2(defs.decorators, node, "decorators", decorators, 1);
    validate2(defs.static, node, "static", _static);
    return node;
  }
  function classPrivateMethod(kind = "method", key, params, body, _static = false) {
    const node = {
      type: "ClassPrivateMethod",
      kind,
      key,
      params,
      body,
      static: _static
    };
    const defs = NODE_FIELDS.ClassPrivateMethod;
    validate2(defs.kind, node, "kind", kind);
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.static, node, "static", _static);
    return node;
  }
  function privateName(id) {
    const node = {
      type: "PrivateName",
      id
    };
    const defs = NODE_FIELDS.PrivateName;
    validate2(defs.id, node, "id", id, 1);
    return node;
  }
  function staticBlock(body) {
    const node = {
      type: "StaticBlock",
      body
    };
    const defs = NODE_FIELDS.StaticBlock;
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function anyTypeAnnotation() {
    return {
      type: "AnyTypeAnnotation"
    };
  }
  function arrayTypeAnnotation(elementType) {
    const node = {
      type: "ArrayTypeAnnotation",
      elementType
    };
    const defs = NODE_FIELDS.ArrayTypeAnnotation;
    validate2(defs.elementType, node, "elementType", elementType, 1);
    return node;
  }
  function booleanTypeAnnotation() {
    return {
      type: "BooleanTypeAnnotation"
    };
  }
  function booleanLiteralTypeAnnotation(value) {
    const node = {
      type: "BooleanLiteralTypeAnnotation",
      value
    };
    const defs = NODE_FIELDS.BooleanLiteralTypeAnnotation;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function nullLiteralTypeAnnotation() {
    return {
      type: "NullLiteralTypeAnnotation"
    };
  }
  function classImplements(id, typeParameters = null) {
    const node = {
      type: "ClassImplements",
      id,
      typeParameters
    };
    const defs = NODE_FIELDS.ClassImplements;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function declareClass(id, typeParameters = null, _extends = null, body) {
    const node = {
      type: "DeclareClass",
      id,
      typeParameters,
      extends: _extends,
      body
    };
    const defs = NODE_FIELDS.DeclareClass;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.extends, node, "extends", _extends, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function declareFunction(id) {
    const node = {
      type: "DeclareFunction",
      id
    };
    const defs = NODE_FIELDS.DeclareFunction;
    validate2(defs.id, node, "id", id, 1);
    return node;
  }
  function declareInterface(id, typeParameters = null, _extends = null, body) {
    const node = {
      type: "DeclareInterface",
      id,
      typeParameters,
      extends: _extends,
      body
    };
    const defs = NODE_FIELDS.DeclareInterface;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.extends, node, "extends", _extends, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function declareModule(id, body, kind = null) {
    const node = {
      type: "DeclareModule",
      id,
      body,
      kind
    };
    const defs = NODE_FIELDS.DeclareModule;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.kind, node, "kind", kind);
    return node;
  }
  function declareModuleExports(typeAnnotation2) {
    const node = {
      type: "DeclareModuleExports",
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.DeclareModuleExports;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function declareTypeAlias(id, typeParameters = null, right) {
    const node = {
      type: "DeclareTypeAlias",
      id,
      typeParameters,
      right
    };
    const defs = NODE_FIELDS.DeclareTypeAlias;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.right, node, "right", right, 1);
    return node;
  }
  function declareOpaqueType(id, typeParameters = null, supertype = null) {
    const node = {
      type: "DeclareOpaqueType",
      id,
      typeParameters,
      supertype
    };
    const defs = NODE_FIELDS.DeclareOpaqueType;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.supertype, node, "supertype", supertype, 1);
    return node;
  }
  function declareVariable(id) {
    const node = {
      type: "DeclareVariable",
      id
    };
    const defs = NODE_FIELDS.DeclareVariable;
    validate2(defs.id, node, "id", id, 1);
    return node;
  }
  function declareExportDeclaration(declaration = null, specifiers = null, source = null) {
    const node = {
      type: "DeclareExportDeclaration",
      declaration,
      specifiers,
      source
    };
    const defs = NODE_FIELDS.DeclareExportDeclaration;
    validate2(defs.declaration, node, "declaration", declaration, 1);
    validate2(defs.specifiers, node, "specifiers", specifiers, 1);
    validate2(defs.source, node, "source", source, 1);
    return node;
  }
  function declareExportAllDeclaration(source) {
    const node = {
      type: "DeclareExportAllDeclaration",
      source
    };
    const defs = NODE_FIELDS.DeclareExportAllDeclaration;
    validate2(defs.source, node, "source", source, 1);
    return node;
  }
  function declaredPredicate(value) {
    const node = {
      type: "DeclaredPredicate",
      value
    };
    const defs = NODE_FIELDS.DeclaredPredicate;
    validate2(defs.value, node, "value", value, 1);
    return node;
  }
  function existsTypeAnnotation() {
    return {
      type: "ExistsTypeAnnotation"
    };
  }
  function functionTypeAnnotation(typeParameters = null, params, rest = null, returnType) {
    const node = {
      type: "FunctionTypeAnnotation",
      typeParameters,
      params,
      rest,
      returnType
    };
    const defs = NODE_FIELDS.FunctionTypeAnnotation;
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.rest, node, "rest", rest, 1);
    validate2(defs.returnType, node, "returnType", returnType, 1);
    return node;
  }
  function functionTypeParam(name = null, typeAnnotation2) {
    const node = {
      type: "FunctionTypeParam",
      name,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.FunctionTypeParam;
    validate2(defs.name, node, "name", name, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function genericTypeAnnotation(id, typeParameters = null) {
    const node = {
      type: "GenericTypeAnnotation",
      id,
      typeParameters
    };
    const defs = NODE_FIELDS.GenericTypeAnnotation;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function inferredPredicate() {
    return {
      type: "InferredPredicate"
    };
  }
  function interfaceExtends(id, typeParameters = null) {
    const node = {
      type: "InterfaceExtends",
      id,
      typeParameters
    };
    const defs = NODE_FIELDS.InterfaceExtends;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function interfaceDeclaration(id, typeParameters = null, _extends = null, body) {
    const node = {
      type: "InterfaceDeclaration",
      id,
      typeParameters,
      extends: _extends,
      body
    };
    const defs = NODE_FIELDS.InterfaceDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.extends, node, "extends", _extends, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function interfaceTypeAnnotation(_extends = null, body) {
    const node = {
      type: "InterfaceTypeAnnotation",
      extends: _extends,
      body
    };
    const defs = NODE_FIELDS.InterfaceTypeAnnotation;
    validate2(defs.extends, node, "extends", _extends, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function intersectionTypeAnnotation(types3) {
    const node = {
      type: "IntersectionTypeAnnotation",
      types: types3
    };
    const defs = NODE_FIELDS.IntersectionTypeAnnotation;
    validate2(defs.types, node, "types", types3, 1);
    return node;
  }
  function mixedTypeAnnotation() {
    return {
      type: "MixedTypeAnnotation"
    };
  }
  function emptyTypeAnnotation() {
    return {
      type: "EmptyTypeAnnotation"
    };
  }
  function nullableTypeAnnotation(typeAnnotation2) {
    const node = {
      type: "NullableTypeAnnotation",
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.NullableTypeAnnotation;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function numberLiteralTypeAnnotation(value) {
    const node = {
      type: "NumberLiteralTypeAnnotation",
      value
    };
    const defs = NODE_FIELDS.NumberLiteralTypeAnnotation;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function numberTypeAnnotation() {
    return {
      type: "NumberTypeAnnotation"
    };
  }
  function objectTypeAnnotation(properties, indexers = [], callProperties = [], internalSlots = [], exact = false) {
    const node = {
      type: "ObjectTypeAnnotation",
      properties,
      indexers,
      callProperties,
      internalSlots,
      exact
    };
    const defs = NODE_FIELDS.ObjectTypeAnnotation;
    validate2(defs.properties, node, "properties", properties, 1);
    validate2(defs.indexers, node, "indexers", indexers, 1);
    validate2(defs.callProperties, node, "callProperties", callProperties, 1);
    validate2(defs.internalSlots, node, "internalSlots", internalSlots, 1);
    validate2(defs.exact, node, "exact", exact);
    return node;
  }
  function objectTypeInternalSlot(id, value, optional, _static, method) {
    const node = {
      type: "ObjectTypeInternalSlot",
      id,
      value,
      optional,
      static: _static,
      method
    };
    const defs = NODE_FIELDS.ObjectTypeInternalSlot;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.value, node, "value", value, 1);
    validate2(defs.optional, node, "optional", optional);
    validate2(defs.static, node, "static", _static);
    validate2(defs.method, node, "method", method);
    return node;
  }
  function objectTypeCallProperty(value) {
    const node = {
      type: "ObjectTypeCallProperty",
      value,
      static: null
    };
    const defs = NODE_FIELDS.ObjectTypeCallProperty;
    validate2(defs.value, node, "value", value, 1);
    return node;
  }
  function objectTypeIndexer(id = null, key, value, variance2 = null) {
    const node = {
      type: "ObjectTypeIndexer",
      id,
      key,
      value,
      variance: variance2,
      static: null
    };
    const defs = NODE_FIELDS.ObjectTypeIndexer;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.value, node, "value", value, 1);
    validate2(defs.variance, node, "variance", variance2, 1);
    return node;
  }
  function objectTypeProperty(key, value, variance2 = null) {
    const node = {
      type: "ObjectTypeProperty",
      key,
      value,
      variance: variance2,
      kind: null,
      method: null,
      optional: null,
      proto: null,
      static: null
    };
    const defs = NODE_FIELDS.ObjectTypeProperty;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.value, node, "value", value, 1);
    validate2(defs.variance, node, "variance", variance2, 1);
    return node;
  }
  function objectTypeSpreadProperty(argument) {
    const node = {
      type: "ObjectTypeSpreadProperty",
      argument
    };
    const defs = NODE_FIELDS.ObjectTypeSpreadProperty;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function opaqueType(id, typeParameters = null, supertype = null, impltype) {
    const node = {
      type: "OpaqueType",
      id,
      typeParameters,
      supertype,
      impltype
    };
    const defs = NODE_FIELDS.OpaqueType;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.supertype, node, "supertype", supertype, 1);
    validate2(defs.impltype, node, "impltype", impltype, 1);
    return node;
  }
  function qualifiedTypeIdentifier(id, qualification) {
    const node = {
      type: "QualifiedTypeIdentifier",
      id,
      qualification
    };
    const defs = NODE_FIELDS.QualifiedTypeIdentifier;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.qualification, node, "qualification", qualification, 1);
    return node;
  }
  function stringLiteralTypeAnnotation(value) {
    const node = {
      type: "StringLiteralTypeAnnotation",
      value
    };
    const defs = NODE_FIELDS.StringLiteralTypeAnnotation;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function stringTypeAnnotation() {
    return {
      type: "StringTypeAnnotation"
    };
  }
  function symbolTypeAnnotation() {
    return {
      type: "SymbolTypeAnnotation"
    };
  }
  function thisTypeAnnotation() {
    return {
      type: "ThisTypeAnnotation"
    };
  }
  function tupleTypeAnnotation(types3) {
    const node = {
      type: "TupleTypeAnnotation",
      types: types3
    };
    const defs = NODE_FIELDS.TupleTypeAnnotation;
    validate2(defs.types, node, "types", types3, 1);
    return node;
  }
  function typeofTypeAnnotation(argument) {
    const node = {
      type: "TypeofTypeAnnotation",
      argument
    };
    const defs = NODE_FIELDS.TypeofTypeAnnotation;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function typeAlias(id, typeParameters = null, right) {
    const node = {
      type: "TypeAlias",
      id,
      typeParameters,
      right
    };
    const defs = NODE_FIELDS.TypeAlias;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.right, node, "right", right, 1);
    return node;
  }
  function typeAnnotation(typeAnnotation2) {
    const node = {
      type: "TypeAnnotation",
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TypeAnnotation;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function typeCastExpression(expression, typeAnnotation2) {
    const node = {
      type: "TypeCastExpression",
      expression,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TypeCastExpression;
    validate2(defs.expression, node, "expression", expression, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function typeParameter(bound = null, _default = null, variance2 = null) {
    const node = {
      type: "TypeParameter",
      bound,
      default: _default,
      variance: variance2,
      name: null
    };
    const defs = NODE_FIELDS.TypeParameter;
    validate2(defs.bound, node, "bound", bound, 1);
    validate2(defs.default, node, "default", _default, 1);
    validate2(defs.variance, node, "variance", variance2, 1);
    return node;
  }
  function typeParameterDeclaration(params) {
    const node = {
      type: "TypeParameterDeclaration",
      params
    };
    const defs = NODE_FIELDS.TypeParameterDeclaration;
    validate2(defs.params, node, "params", params, 1);
    return node;
  }
  function typeParameterInstantiation(params) {
    const node = {
      type: "TypeParameterInstantiation",
      params
    };
    const defs = NODE_FIELDS.TypeParameterInstantiation;
    validate2(defs.params, node, "params", params, 1);
    return node;
  }
  function unionTypeAnnotation(types3) {
    const node = {
      type: "UnionTypeAnnotation",
      types: types3
    };
    const defs = NODE_FIELDS.UnionTypeAnnotation;
    validate2(defs.types, node, "types", types3, 1);
    return node;
  }
  function variance(kind) {
    const node = {
      type: "Variance",
      kind
    };
    const defs = NODE_FIELDS.Variance;
    validate2(defs.kind, node, "kind", kind);
    return node;
  }
  function voidTypeAnnotation() {
    return {
      type: "VoidTypeAnnotation"
    };
  }
  function enumDeclaration(id, body) {
    const node = {
      type: "EnumDeclaration",
      id,
      body
    };
    const defs = NODE_FIELDS.EnumDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function enumBooleanBody(members) {
    const node = {
      type: "EnumBooleanBody",
      members,
      explicitType: null,
      hasUnknownMembers: null
    };
    const defs = NODE_FIELDS.EnumBooleanBody;
    validate2(defs.members, node, "members", members, 1);
    return node;
  }
  function enumNumberBody(members) {
    const node = {
      type: "EnumNumberBody",
      members,
      explicitType: null,
      hasUnknownMembers: null
    };
    const defs = NODE_FIELDS.EnumNumberBody;
    validate2(defs.members, node, "members", members, 1);
    return node;
  }
  function enumStringBody(members) {
    const node = {
      type: "EnumStringBody",
      members,
      explicitType: null,
      hasUnknownMembers: null
    };
    const defs = NODE_FIELDS.EnumStringBody;
    validate2(defs.members, node, "members", members, 1);
    return node;
  }
  function enumSymbolBody(members) {
    const node = {
      type: "EnumSymbolBody",
      members,
      hasUnknownMembers: null
    };
    const defs = NODE_FIELDS.EnumSymbolBody;
    validate2(defs.members, node, "members", members, 1);
    return node;
  }
  function enumBooleanMember(id) {
    const node = {
      type: "EnumBooleanMember",
      id,
      init: null
    };
    const defs = NODE_FIELDS.EnumBooleanMember;
    validate2(defs.id, node, "id", id, 1);
    return node;
  }
  function enumNumberMember(id, init22) {
    const node = {
      type: "EnumNumberMember",
      id,
      init: init22
    };
    const defs = NODE_FIELDS.EnumNumberMember;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.init, node, "init", init22, 1);
    return node;
  }
  function enumStringMember(id, init22) {
    const node = {
      type: "EnumStringMember",
      id,
      init: init22
    };
    const defs = NODE_FIELDS.EnumStringMember;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.init, node, "init", init22, 1);
    return node;
  }
  function enumDefaultedMember(id) {
    const node = {
      type: "EnumDefaultedMember",
      id
    };
    const defs = NODE_FIELDS.EnumDefaultedMember;
    validate2(defs.id, node, "id", id, 1);
    return node;
  }
  function indexedAccessType(objectType, indexType) {
    const node = {
      type: "IndexedAccessType",
      objectType,
      indexType
    };
    const defs = NODE_FIELDS.IndexedAccessType;
    validate2(defs.objectType, node, "objectType", objectType, 1);
    validate2(defs.indexType, node, "indexType", indexType, 1);
    return node;
  }
  function optionalIndexedAccessType(objectType, indexType) {
    const node = {
      type: "OptionalIndexedAccessType",
      objectType,
      indexType,
      optional: null
    };
    const defs = NODE_FIELDS.OptionalIndexedAccessType;
    validate2(defs.objectType, node, "objectType", objectType, 1);
    validate2(defs.indexType, node, "indexType", indexType, 1);
    return node;
  }
  function jsxAttribute(name, value = null) {
    const node = {
      type: "JSXAttribute",
      name,
      value
    };
    const defs = NODE_FIELDS.JSXAttribute;
    validate2(defs.name, node, "name", name, 1);
    validate2(defs.value, node, "value", value, 1);
    return node;
  }
  function jsxClosingElement(name) {
    const node = {
      type: "JSXClosingElement",
      name
    };
    const defs = NODE_FIELDS.JSXClosingElement;
    validate2(defs.name, node, "name", name, 1);
    return node;
  }
  function jsxElement(openingElement, closingElement = null, children, selfClosing = null) {
    const node = {
      type: "JSXElement",
      openingElement,
      closingElement,
      children,
      selfClosing
    };
    const defs = NODE_FIELDS.JSXElement;
    validate2(defs.openingElement, node, "openingElement", openingElement, 1);
    validate2(defs.closingElement, node, "closingElement", closingElement, 1);
    validate2(defs.children, node, "children", children, 1);
    validate2(defs.selfClosing, node, "selfClosing", selfClosing);
    return node;
  }
  function jsxEmptyExpression() {
    return {
      type: "JSXEmptyExpression"
    };
  }
  function jsxExpressionContainer(expression) {
    const node = {
      type: "JSXExpressionContainer",
      expression
    };
    const defs = NODE_FIELDS.JSXExpressionContainer;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function jsxSpreadChild(expression) {
    const node = {
      type: "JSXSpreadChild",
      expression
    };
    const defs = NODE_FIELDS.JSXSpreadChild;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function jsxIdentifier(name) {
    const node = {
      type: "JSXIdentifier",
      name
    };
    const defs = NODE_FIELDS.JSXIdentifier;
    validate2(defs.name, node, "name", name);
    return node;
  }
  function jsxMemberExpression(object, property) {
    const node = {
      type: "JSXMemberExpression",
      object,
      property
    };
    const defs = NODE_FIELDS.JSXMemberExpression;
    validate2(defs.object, node, "object", object, 1);
    validate2(defs.property, node, "property", property, 1);
    return node;
  }
  function jsxNamespacedName(namespace, name) {
    const node = {
      type: "JSXNamespacedName",
      namespace,
      name
    };
    const defs = NODE_FIELDS.JSXNamespacedName;
    validate2(defs.namespace, node, "namespace", namespace, 1);
    validate2(defs.name, node, "name", name, 1);
    return node;
  }
  function jsxOpeningElement(name, attributes, selfClosing = false) {
    const node = {
      type: "JSXOpeningElement",
      name,
      attributes,
      selfClosing
    };
    const defs = NODE_FIELDS.JSXOpeningElement;
    validate2(defs.name, node, "name", name, 1);
    validate2(defs.attributes, node, "attributes", attributes, 1);
    validate2(defs.selfClosing, node, "selfClosing", selfClosing);
    return node;
  }
  function jsxSpreadAttribute(argument) {
    const node = {
      type: "JSXSpreadAttribute",
      argument
    };
    const defs = NODE_FIELDS.JSXSpreadAttribute;
    validate2(defs.argument, node, "argument", argument, 1);
    return node;
  }
  function jsxText(value) {
    const node = {
      type: "JSXText",
      value
    };
    const defs = NODE_FIELDS.JSXText;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function jsxFragment(openingFragment, closingFragment, children) {
    const node = {
      type: "JSXFragment",
      openingFragment,
      closingFragment,
      children
    };
    const defs = NODE_FIELDS.JSXFragment;
    validate2(defs.openingFragment, node, "openingFragment", openingFragment, 1);
    validate2(defs.closingFragment, node, "closingFragment", closingFragment, 1);
    validate2(defs.children, node, "children", children, 1);
    return node;
  }
  function jsxOpeningFragment() {
    return {
      type: "JSXOpeningFragment"
    };
  }
  function jsxClosingFragment() {
    return {
      type: "JSXClosingFragment"
    };
  }
  function noop() {
    return {
      type: "Noop"
    };
  }
  function placeholder(expectedNode, name) {
    const node = {
      type: "Placeholder",
      expectedNode,
      name
    };
    const defs = NODE_FIELDS.Placeholder;
    validate2(defs.expectedNode, node, "expectedNode", expectedNode);
    validate2(defs.name, node, "name", name, 1);
    return node;
  }
  function v8IntrinsicIdentifier(name) {
    const node = {
      type: "V8IntrinsicIdentifier",
      name
    };
    const defs = NODE_FIELDS.V8IntrinsicIdentifier;
    validate2(defs.name, node, "name", name);
    return node;
  }
  function argumentPlaceholder() {
    return {
      type: "ArgumentPlaceholder"
    };
  }
  function bindExpression(object, callee) {
    const node = {
      type: "BindExpression",
      object,
      callee
    };
    const defs = NODE_FIELDS.BindExpression;
    validate2(defs.object, node, "object", object, 1);
    validate2(defs.callee, node, "callee", callee, 1);
    return node;
  }
  function importAttribute(key, value) {
    const node = {
      type: "ImportAttribute",
      key,
      value
    };
    const defs = NODE_FIELDS.ImportAttribute;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.value, node, "value", value, 1);
    return node;
  }
  function decorator(expression) {
    const node = {
      type: "Decorator",
      expression
    };
    const defs = NODE_FIELDS.Decorator;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function doExpression(body, async = false) {
    const node = {
      type: "DoExpression",
      body,
      async
    };
    const defs = NODE_FIELDS.DoExpression;
    validate2(defs.body, node, "body", body, 1);
    validate2(defs.async, node, "async", async);
    return node;
  }
  function exportDefaultSpecifier(exported) {
    const node = {
      type: "ExportDefaultSpecifier",
      exported
    };
    const defs = NODE_FIELDS.ExportDefaultSpecifier;
    validate2(defs.exported, node, "exported", exported, 1);
    return node;
  }
  function recordExpression(properties) {
    const node = {
      type: "RecordExpression",
      properties
    };
    const defs = NODE_FIELDS.RecordExpression;
    validate2(defs.properties, node, "properties", properties, 1);
    return node;
  }
  function tupleExpression(elements = []) {
    const node = {
      type: "TupleExpression",
      elements
    };
    const defs = NODE_FIELDS.TupleExpression;
    validate2(defs.elements, node, "elements", elements, 1);
    return node;
  }
  function decimalLiteral(value) {
    const node = {
      type: "DecimalLiteral",
      value
    };
    const defs = NODE_FIELDS.DecimalLiteral;
    validate2(defs.value, node, "value", value);
    return node;
  }
  function moduleExpression(body) {
    const node = {
      type: "ModuleExpression",
      body
    };
    const defs = NODE_FIELDS.ModuleExpression;
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function topicReference() {
    return {
      type: "TopicReference"
    };
  }
  function pipelineTopicExpression(expression) {
    const node = {
      type: "PipelineTopicExpression",
      expression
    };
    const defs = NODE_FIELDS.PipelineTopicExpression;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function pipelineBareFunction(callee) {
    const node = {
      type: "PipelineBareFunction",
      callee
    };
    const defs = NODE_FIELDS.PipelineBareFunction;
    validate2(defs.callee, node, "callee", callee, 1);
    return node;
  }
  function pipelinePrimaryTopicReference() {
    return {
      type: "PipelinePrimaryTopicReference"
    };
  }
  function tsParameterProperty(parameter) {
    const node = {
      type: "TSParameterProperty",
      parameter
    };
    const defs = NODE_FIELDS.TSParameterProperty;
    validate2(defs.parameter, node, "parameter", parameter, 1);
    return node;
  }
  function tsDeclareFunction(id = null, typeParameters = null, params, returnType = null) {
    const node = {
      type: "TSDeclareFunction",
      id,
      typeParameters,
      params,
      returnType
    };
    const defs = NODE_FIELDS.TSDeclareFunction;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.returnType, node, "returnType", returnType, 1);
    return node;
  }
  function tsDeclareMethod(decorators = null, key, typeParameters = null, params, returnType = null) {
    const node = {
      type: "TSDeclareMethod",
      decorators,
      key,
      typeParameters,
      params,
      returnType
    };
    const defs = NODE_FIELDS.TSDeclareMethod;
    validate2(defs.decorators, node, "decorators", decorators, 1);
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.params, node, "params", params, 1);
    validate2(defs.returnType, node, "returnType", returnType, 1);
    return node;
  }
  function tsQualifiedName(left, right) {
    const node = {
      type: "TSQualifiedName",
      left,
      right
    };
    const defs = NODE_FIELDS.TSQualifiedName;
    validate2(defs.left, node, "left", left, 1);
    validate2(defs.right, node, "right", right, 1);
    return node;
  }
  function tsCallSignatureDeclaration(typeParameters = null, parameters, typeAnnotation2 = null) {
    const node = {
      type: "TSCallSignatureDeclaration",
      typeParameters,
      parameters,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSCallSignatureDeclaration;
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.parameters, node, "parameters", parameters, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsConstructSignatureDeclaration(typeParameters = null, parameters, typeAnnotation2 = null) {
    const node = {
      type: "TSConstructSignatureDeclaration",
      typeParameters,
      parameters,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSConstructSignatureDeclaration;
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.parameters, node, "parameters", parameters, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsPropertySignature(key, typeAnnotation2 = null) {
    const node = {
      type: "TSPropertySignature",
      key,
      typeAnnotation: typeAnnotation2,
      kind: null
    };
    const defs = NODE_FIELDS.TSPropertySignature;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsMethodSignature(key, typeParameters = null, parameters, typeAnnotation2 = null) {
    const node = {
      type: "TSMethodSignature",
      key,
      typeParameters,
      parameters,
      typeAnnotation: typeAnnotation2,
      kind: null
    };
    const defs = NODE_FIELDS.TSMethodSignature;
    validate2(defs.key, node, "key", key, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.parameters, node, "parameters", parameters, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsIndexSignature(parameters, typeAnnotation2 = null) {
    const node = {
      type: "TSIndexSignature",
      parameters,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSIndexSignature;
    validate2(defs.parameters, node, "parameters", parameters, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsAnyKeyword() {
    return {
      type: "TSAnyKeyword"
    };
  }
  function tsBooleanKeyword() {
    return {
      type: "TSBooleanKeyword"
    };
  }
  function tsBigIntKeyword() {
    return {
      type: "TSBigIntKeyword"
    };
  }
  function tsIntrinsicKeyword() {
    return {
      type: "TSIntrinsicKeyword"
    };
  }
  function tsNeverKeyword() {
    return {
      type: "TSNeverKeyword"
    };
  }
  function tsNullKeyword() {
    return {
      type: "TSNullKeyword"
    };
  }
  function tsNumberKeyword() {
    return {
      type: "TSNumberKeyword"
    };
  }
  function tsObjectKeyword() {
    return {
      type: "TSObjectKeyword"
    };
  }
  function tsStringKeyword() {
    return {
      type: "TSStringKeyword"
    };
  }
  function tsSymbolKeyword() {
    return {
      type: "TSSymbolKeyword"
    };
  }
  function tsUndefinedKeyword() {
    return {
      type: "TSUndefinedKeyword"
    };
  }
  function tsUnknownKeyword() {
    return {
      type: "TSUnknownKeyword"
    };
  }
  function tsVoidKeyword() {
    return {
      type: "TSVoidKeyword"
    };
  }
  function tsThisType() {
    return {
      type: "TSThisType"
    };
  }
  function tsFunctionType(typeParameters = null, parameters, typeAnnotation2 = null) {
    const node = {
      type: "TSFunctionType",
      typeParameters,
      parameters,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSFunctionType;
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.parameters, node, "parameters", parameters, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsConstructorType(typeParameters = null, parameters, typeAnnotation2 = null) {
    const node = {
      type: "TSConstructorType",
      typeParameters,
      parameters,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSConstructorType;
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.parameters, node, "parameters", parameters, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsTypeReference(typeName, typeParameters = null) {
    const node = {
      type: "TSTypeReference",
      typeName,
      typeParameters
    };
    const defs = NODE_FIELDS.TSTypeReference;
    validate2(defs.typeName, node, "typeName", typeName, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function tsTypePredicate(parameterName, typeAnnotation2 = null, asserts = null) {
    const node = {
      type: "TSTypePredicate",
      parameterName,
      typeAnnotation: typeAnnotation2,
      asserts
    };
    const defs = NODE_FIELDS.TSTypePredicate;
    validate2(defs.parameterName, node, "parameterName", parameterName, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    validate2(defs.asserts, node, "asserts", asserts);
    return node;
  }
  function tsTypeQuery(exprName, typeParameters = null) {
    const node = {
      type: "TSTypeQuery",
      exprName,
      typeParameters
    };
    const defs = NODE_FIELDS.TSTypeQuery;
    validate2(defs.exprName, node, "exprName", exprName, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function tsTypeLiteral(members) {
    const node = {
      type: "TSTypeLiteral",
      members
    };
    const defs = NODE_FIELDS.TSTypeLiteral;
    validate2(defs.members, node, "members", members, 1);
    return node;
  }
  function tsArrayType(elementType) {
    const node = {
      type: "TSArrayType",
      elementType
    };
    const defs = NODE_FIELDS.TSArrayType;
    validate2(defs.elementType, node, "elementType", elementType, 1);
    return node;
  }
  function tsTupleType(elementTypes) {
    const node = {
      type: "TSTupleType",
      elementTypes
    };
    const defs = NODE_FIELDS.TSTupleType;
    validate2(defs.elementTypes, node, "elementTypes", elementTypes, 1);
    return node;
  }
  function tsOptionalType(typeAnnotation2) {
    const node = {
      type: "TSOptionalType",
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSOptionalType;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsRestType(typeAnnotation2) {
    const node = {
      type: "TSRestType",
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSRestType;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsNamedTupleMember(label, elementType, optional = false) {
    const node = {
      type: "TSNamedTupleMember",
      label,
      elementType,
      optional
    };
    const defs = NODE_FIELDS.TSNamedTupleMember;
    validate2(defs.label, node, "label", label, 1);
    validate2(defs.elementType, node, "elementType", elementType, 1);
    validate2(defs.optional, node, "optional", optional);
    return node;
  }
  function tsUnionType(types3) {
    const node = {
      type: "TSUnionType",
      types: types3
    };
    const defs = NODE_FIELDS.TSUnionType;
    validate2(defs.types, node, "types", types3, 1);
    return node;
  }
  function tsIntersectionType(types3) {
    const node = {
      type: "TSIntersectionType",
      types: types3
    };
    const defs = NODE_FIELDS.TSIntersectionType;
    validate2(defs.types, node, "types", types3, 1);
    return node;
  }
  function tsConditionalType(checkType, extendsType, trueType, falseType) {
    const node = {
      type: "TSConditionalType",
      checkType,
      extendsType,
      trueType,
      falseType
    };
    const defs = NODE_FIELDS.TSConditionalType;
    validate2(defs.checkType, node, "checkType", checkType, 1);
    validate2(defs.extendsType, node, "extendsType", extendsType, 1);
    validate2(defs.trueType, node, "trueType", trueType, 1);
    validate2(defs.falseType, node, "falseType", falseType, 1);
    return node;
  }
  function tsInferType(typeParameter2) {
    const node = {
      type: "TSInferType",
      typeParameter: typeParameter2
    };
    const defs = NODE_FIELDS.TSInferType;
    validate2(defs.typeParameter, node, "typeParameter", typeParameter2, 1);
    return node;
  }
  function tsParenthesizedType(typeAnnotation2) {
    const node = {
      type: "TSParenthesizedType",
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSParenthesizedType;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsTypeOperator(typeAnnotation2) {
    const node = {
      type: "TSTypeOperator",
      typeAnnotation: typeAnnotation2,
      operator: null
    };
    const defs = NODE_FIELDS.TSTypeOperator;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsIndexedAccessType(objectType, indexType) {
    const node = {
      type: "TSIndexedAccessType",
      objectType,
      indexType
    };
    const defs = NODE_FIELDS.TSIndexedAccessType;
    validate2(defs.objectType, node, "objectType", objectType, 1);
    validate2(defs.indexType, node, "indexType", indexType, 1);
    return node;
  }
  function tsMappedType(typeParameter2, typeAnnotation2 = null, nameType = null) {
    const node = {
      type: "TSMappedType",
      typeParameter: typeParameter2,
      typeAnnotation: typeAnnotation2,
      nameType
    };
    const defs = NODE_FIELDS.TSMappedType;
    validate2(defs.typeParameter, node, "typeParameter", typeParameter2, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    validate2(defs.nameType, node, "nameType", nameType, 1);
    return node;
  }
  function tsLiteralType(literal) {
    const node = {
      type: "TSLiteralType",
      literal
    };
    const defs = NODE_FIELDS.TSLiteralType;
    validate2(defs.literal, node, "literal", literal, 1);
    return node;
  }
  function tsExpressionWithTypeArguments(expression, typeParameters = null) {
    const node = {
      type: "TSExpressionWithTypeArguments",
      expression,
      typeParameters
    };
    const defs = NODE_FIELDS.TSExpressionWithTypeArguments;
    validate2(defs.expression, node, "expression", expression, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function tsInterfaceDeclaration(id, typeParameters = null, _extends = null, body) {
    const node = {
      type: "TSInterfaceDeclaration",
      id,
      typeParameters,
      extends: _extends,
      body
    };
    const defs = NODE_FIELDS.TSInterfaceDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.extends, node, "extends", _extends, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function tsInterfaceBody(body) {
    const node = {
      type: "TSInterfaceBody",
      body
    };
    const defs = NODE_FIELDS.TSInterfaceBody;
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function tsTypeAliasDeclaration(id, typeParameters = null, typeAnnotation2) {
    const node = {
      type: "TSTypeAliasDeclaration",
      id,
      typeParameters,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSTypeAliasDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsInstantiationExpression(expression, typeParameters = null) {
    const node = {
      type: "TSInstantiationExpression",
      expression,
      typeParameters
    };
    const defs = NODE_FIELDS.TSInstantiationExpression;
    validate2(defs.expression, node, "expression", expression, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function tsAsExpression(expression, typeAnnotation2) {
    const node = {
      type: "TSAsExpression",
      expression,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSAsExpression;
    validate2(defs.expression, node, "expression", expression, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsSatisfiesExpression(expression, typeAnnotation2) {
    const node = {
      type: "TSSatisfiesExpression",
      expression,
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSSatisfiesExpression;
    validate2(defs.expression, node, "expression", expression, 1);
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsTypeAssertion(typeAnnotation2, expression) {
    const node = {
      type: "TSTypeAssertion",
      typeAnnotation: typeAnnotation2,
      expression
    };
    const defs = NODE_FIELDS.TSTypeAssertion;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function tsEnumDeclaration(id, members) {
    const node = {
      type: "TSEnumDeclaration",
      id,
      members
    };
    const defs = NODE_FIELDS.TSEnumDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.members, node, "members", members, 1);
    return node;
  }
  function tsEnumMember(id, initializer = null) {
    const node = {
      type: "TSEnumMember",
      id,
      initializer
    };
    const defs = NODE_FIELDS.TSEnumMember;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.initializer, node, "initializer", initializer, 1);
    return node;
  }
  function tsModuleDeclaration(id, body) {
    const node = {
      type: "TSModuleDeclaration",
      id,
      body
    };
    const defs = NODE_FIELDS.TSModuleDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function tsModuleBlock(body) {
    const node = {
      type: "TSModuleBlock",
      body
    };
    const defs = NODE_FIELDS.TSModuleBlock;
    validate2(defs.body, node, "body", body, 1);
    return node;
  }
  function tsImportType(argument, qualifier = null, typeParameters = null) {
    const node = {
      type: "TSImportType",
      argument,
      qualifier,
      typeParameters
    };
    const defs = NODE_FIELDS.TSImportType;
    validate2(defs.argument, node, "argument", argument, 1);
    validate2(defs.qualifier, node, "qualifier", qualifier, 1);
    validate2(defs.typeParameters, node, "typeParameters", typeParameters, 1);
    return node;
  }
  function tsImportEqualsDeclaration(id, moduleReference) {
    const node = {
      type: "TSImportEqualsDeclaration",
      id,
      moduleReference,
      isExport: null
    };
    const defs = NODE_FIELDS.TSImportEqualsDeclaration;
    validate2(defs.id, node, "id", id, 1);
    validate2(defs.moduleReference, node, "moduleReference", moduleReference, 1);
    return node;
  }
  function tsExternalModuleReference(expression) {
    const node = {
      type: "TSExternalModuleReference",
      expression
    };
    const defs = NODE_FIELDS.TSExternalModuleReference;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function tsNonNullExpression(expression) {
    const node = {
      type: "TSNonNullExpression",
      expression
    };
    const defs = NODE_FIELDS.TSNonNullExpression;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function tsExportAssignment(expression) {
    const node = {
      type: "TSExportAssignment",
      expression
    };
    const defs = NODE_FIELDS.TSExportAssignment;
    validate2(defs.expression, node, "expression", expression, 1);
    return node;
  }
  function tsNamespaceExportDeclaration(id) {
    const node = {
      type: "TSNamespaceExportDeclaration",
      id
    };
    const defs = NODE_FIELDS.TSNamespaceExportDeclaration;
    validate2(defs.id, node, "id", id, 1);
    return node;
  }
  function tsTypeAnnotation(typeAnnotation2) {
    const node = {
      type: "TSTypeAnnotation",
      typeAnnotation: typeAnnotation2
    };
    const defs = NODE_FIELDS.TSTypeAnnotation;
    validate2(defs.typeAnnotation, node, "typeAnnotation", typeAnnotation2, 1);
    return node;
  }
  function tsTypeParameterInstantiation(params) {
    const node = {
      type: "TSTypeParameterInstantiation",
      params
    };
    const defs = NODE_FIELDS.TSTypeParameterInstantiation;
    validate2(defs.params, node, "params", params, 1);
    return node;
  }
  function tsTypeParameterDeclaration(params) {
    const node = {
      type: "TSTypeParameterDeclaration",
      params
    };
    const defs = NODE_FIELDS.TSTypeParameterDeclaration;
    validate2(defs.params, node, "params", params, 1);
    return node;
  }
  function tsTypeParameter(constraint = null, _default = null, name) {
    const node = {
      type: "TSTypeParameter",
      constraint,
      default: _default,
      name
    };
    const defs = NODE_FIELDS.TSTypeParameter;
    validate2(defs.constraint, node, "constraint", constraint, 1);
    validate2(defs.default, node, "default", _default, 1);
    validate2(defs.name, node, "name", name);
    return node;
  }
  function NumberLiteral(value) {
    (0, _deprecationWarning.default)("NumberLiteral", "NumericLiteral", "The node type ");
    return numericLiteral(value);
  }
  function RegexLiteral(pattern, flags = "") {
    (0, _deprecationWarning.default)("RegexLiteral", "RegExpLiteral", "The node type ");
    return regExpLiteral(pattern, flags);
  }
  function RestProperty(argument) {
    (0, _deprecationWarning.default)("RestProperty", "RestElement", "The node type ");
    return restElement(argument);
  }
  function SpreadProperty(argument) {
    (0, _deprecationWarning.default)("SpreadProperty", "SpreadElement", "The node type ");
    return spreadElement(argument);
  }
});
var require_cleanJSXElementLiteralChild = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = cleanJSXElementLiteralChild;
  var _index = require_generated2();
  var _index2 = require_lib6();
  function cleanJSXElementLiteralChild(child, args) {
    const lines = child.value.split(/\r\n|\n|\r/);
    let lastNonEmptyLine = 0;
    for (let i = 0;i < lines.length; i++) {
      if (/[^ \t]/.exec(lines[i])) {
        lastNonEmptyLine = i;
      }
    }
    let str = "";
    for (let i = 0;i < lines.length; i++) {
      const line = lines[i];
      const isFirstLine = i === 0;
      const isLastLine = i === lines.length - 1;
      const isLastNonEmptyLine = i === lastNonEmptyLine;
      let trimmedLine = line.replace(/\t/g, " ");
      if (!isFirstLine) {
        trimmedLine = trimmedLine.replace(/^ +/, "");
      }
      if (!isLastLine) {
        trimmedLine = trimmedLine.replace(/ +$/, "");
      }
      if (trimmedLine) {
        if (!isLastNonEmptyLine) {
          trimmedLine += " ";
        }
        str += trimmedLine;
      }
    }
    if (str)
      args.push((0, _index2.inherits)((0, _index.stringLiteral)(str), child));
  }
});
var require_buildChildren = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = buildChildren;
  var _index = require_generated();
  var _cleanJSXElementLiteralChild = require_cleanJSXElementLiteralChild();
  function buildChildren(node) {
    const elements = [];
    for (let i = 0;i < node.children.length; i++) {
      let child = node.children[i];
      if ((0, _index.isJSXText)(child)) {
        (0, _cleanJSXElementLiteralChild.default)(child, elements);
        continue;
      }
      if ((0, _index.isJSXExpressionContainer)(child))
        child = child.expression;
      if ((0, _index.isJSXEmptyExpression)(child))
        continue;
      elements.push(child);
    }
    return elements;
  }
});
var require_isNode = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isNode;
  var _index = require_definitions();
  function isNode(node) {
    return !!(node && _index.VISITOR_KEYS[node.type]);
  }
});
var require_assertNode = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = assertNode;
  var _isNode = require_isNode();
  function assertNode(node) {
    if (!(0, _isNode.default)(node)) {
      var _node$type;
      const type = (_node$type = node == null ? undefined : node.type) != null ? _node$type : JSON.stringify(node);
      throw new TypeError(`Not a valid node of type "${type}"`);
    }
  }
});
var require_generated3 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.assertAccessor = assertAccessor;
  exports.assertAnyTypeAnnotation = assertAnyTypeAnnotation;
  exports.assertArgumentPlaceholder = assertArgumentPlaceholder;
  exports.assertArrayExpression = assertArrayExpression;
  exports.assertArrayPattern = assertArrayPattern;
  exports.assertArrayTypeAnnotation = assertArrayTypeAnnotation;
  exports.assertArrowFunctionExpression = assertArrowFunctionExpression;
  exports.assertAssignmentExpression = assertAssignmentExpression;
  exports.assertAssignmentPattern = assertAssignmentPattern;
  exports.assertAwaitExpression = assertAwaitExpression;
  exports.assertBigIntLiteral = assertBigIntLiteral;
  exports.assertBinary = assertBinary;
  exports.assertBinaryExpression = assertBinaryExpression;
  exports.assertBindExpression = assertBindExpression;
  exports.assertBlock = assertBlock;
  exports.assertBlockParent = assertBlockParent;
  exports.assertBlockStatement = assertBlockStatement;
  exports.assertBooleanLiteral = assertBooleanLiteral;
  exports.assertBooleanLiteralTypeAnnotation = assertBooleanLiteralTypeAnnotation;
  exports.assertBooleanTypeAnnotation = assertBooleanTypeAnnotation;
  exports.assertBreakStatement = assertBreakStatement;
  exports.assertCallExpression = assertCallExpression;
  exports.assertCatchClause = assertCatchClause;
  exports.assertClass = assertClass;
  exports.assertClassAccessorProperty = assertClassAccessorProperty;
  exports.assertClassBody = assertClassBody;
  exports.assertClassDeclaration = assertClassDeclaration;
  exports.assertClassExpression = assertClassExpression;
  exports.assertClassImplements = assertClassImplements;
  exports.assertClassMethod = assertClassMethod;
  exports.assertClassPrivateMethod = assertClassPrivateMethod;
  exports.assertClassPrivateProperty = assertClassPrivateProperty;
  exports.assertClassProperty = assertClassProperty;
  exports.assertCompletionStatement = assertCompletionStatement;
  exports.assertConditional = assertConditional;
  exports.assertConditionalExpression = assertConditionalExpression;
  exports.assertContinueStatement = assertContinueStatement;
  exports.assertDebuggerStatement = assertDebuggerStatement;
  exports.assertDecimalLiteral = assertDecimalLiteral;
  exports.assertDeclaration = assertDeclaration;
  exports.assertDeclareClass = assertDeclareClass;
  exports.assertDeclareExportAllDeclaration = assertDeclareExportAllDeclaration;
  exports.assertDeclareExportDeclaration = assertDeclareExportDeclaration;
  exports.assertDeclareFunction = assertDeclareFunction;
  exports.assertDeclareInterface = assertDeclareInterface;
  exports.assertDeclareModule = assertDeclareModule;
  exports.assertDeclareModuleExports = assertDeclareModuleExports;
  exports.assertDeclareOpaqueType = assertDeclareOpaqueType;
  exports.assertDeclareTypeAlias = assertDeclareTypeAlias;
  exports.assertDeclareVariable = assertDeclareVariable;
  exports.assertDeclaredPredicate = assertDeclaredPredicate;
  exports.assertDecorator = assertDecorator;
  exports.assertDirective = assertDirective;
  exports.assertDirectiveLiteral = assertDirectiveLiteral;
  exports.assertDoExpression = assertDoExpression;
  exports.assertDoWhileStatement = assertDoWhileStatement;
  exports.assertEmptyStatement = assertEmptyStatement;
  exports.assertEmptyTypeAnnotation = assertEmptyTypeAnnotation;
  exports.assertEnumBody = assertEnumBody;
  exports.assertEnumBooleanBody = assertEnumBooleanBody;
  exports.assertEnumBooleanMember = assertEnumBooleanMember;
  exports.assertEnumDeclaration = assertEnumDeclaration;
  exports.assertEnumDefaultedMember = assertEnumDefaultedMember;
  exports.assertEnumMember = assertEnumMember;
  exports.assertEnumNumberBody = assertEnumNumberBody;
  exports.assertEnumNumberMember = assertEnumNumberMember;
  exports.assertEnumStringBody = assertEnumStringBody;
  exports.assertEnumStringMember = assertEnumStringMember;
  exports.assertEnumSymbolBody = assertEnumSymbolBody;
  exports.assertExistsTypeAnnotation = assertExistsTypeAnnotation;
  exports.assertExportAllDeclaration = assertExportAllDeclaration;
  exports.assertExportDeclaration = assertExportDeclaration;
  exports.assertExportDefaultDeclaration = assertExportDefaultDeclaration;
  exports.assertExportDefaultSpecifier = assertExportDefaultSpecifier;
  exports.assertExportNamedDeclaration = assertExportNamedDeclaration;
  exports.assertExportNamespaceSpecifier = assertExportNamespaceSpecifier;
  exports.assertExportSpecifier = assertExportSpecifier;
  exports.assertExpression = assertExpression;
  exports.assertExpressionStatement = assertExpressionStatement;
  exports.assertExpressionWrapper = assertExpressionWrapper;
  exports.assertFile = assertFile;
  exports.assertFlow = assertFlow;
  exports.assertFlowBaseAnnotation = assertFlowBaseAnnotation;
  exports.assertFlowDeclaration = assertFlowDeclaration;
  exports.assertFlowPredicate = assertFlowPredicate;
  exports.assertFlowType = assertFlowType;
  exports.assertFor = assertFor;
  exports.assertForInStatement = assertForInStatement;
  exports.assertForOfStatement = assertForOfStatement;
  exports.assertForStatement = assertForStatement;
  exports.assertForXStatement = assertForXStatement;
  exports.assertFunction = assertFunction;
  exports.assertFunctionDeclaration = assertFunctionDeclaration;
  exports.assertFunctionExpression = assertFunctionExpression;
  exports.assertFunctionParent = assertFunctionParent;
  exports.assertFunctionTypeAnnotation = assertFunctionTypeAnnotation;
  exports.assertFunctionTypeParam = assertFunctionTypeParam;
  exports.assertGenericTypeAnnotation = assertGenericTypeAnnotation;
  exports.assertIdentifier = assertIdentifier;
  exports.assertIfStatement = assertIfStatement;
  exports.assertImmutable = assertImmutable;
  exports.assertImport = assertImport;
  exports.assertImportAttribute = assertImportAttribute;
  exports.assertImportDeclaration = assertImportDeclaration;
  exports.assertImportDefaultSpecifier = assertImportDefaultSpecifier;
  exports.assertImportExpression = assertImportExpression;
  exports.assertImportNamespaceSpecifier = assertImportNamespaceSpecifier;
  exports.assertImportOrExportDeclaration = assertImportOrExportDeclaration;
  exports.assertImportSpecifier = assertImportSpecifier;
  exports.assertIndexedAccessType = assertIndexedAccessType;
  exports.assertInferredPredicate = assertInferredPredicate;
  exports.assertInterfaceDeclaration = assertInterfaceDeclaration;
  exports.assertInterfaceExtends = assertInterfaceExtends;
  exports.assertInterfaceTypeAnnotation = assertInterfaceTypeAnnotation;
  exports.assertInterpreterDirective = assertInterpreterDirective;
  exports.assertIntersectionTypeAnnotation = assertIntersectionTypeAnnotation;
  exports.assertJSX = assertJSX;
  exports.assertJSXAttribute = assertJSXAttribute;
  exports.assertJSXClosingElement = assertJSXClosingElement;
  exports.assertJSXClosingFragment = assertJSXClosingFragment;
  exports.assertJSXElement = assertJSXElement;
  exports.assertJSXEmptyExpression = assertJSXEmptyExpression;
  exports.assertJSXExpressionContainer = assertJSXExpressionContainer;
  exports.assertJSXFragment = assertJSXFragment;
  exports.assertJSXIdentifier = assertJSXIdentifier;
  exports.assertJSXMemberExpression = assertJSXMemberExpression;
  exports.assertJSXNamespacedName = assertJSXNamespacedName;
  exports.assertJSXOpeningElement = assertJSXOpeningElement;
  exports.assertJSXOpeningFragment = assertJSXOpeningFragment;
  exports.assertJSXSpreadAttribute = assertJSXSpreadAttribute;
  exports.assertJSXSpreadChild = assertJSXSpreadChild;
  exports.assertJSXText = assertJSXText;
  exports.assertLVal = assertLVal;
  exports.assertLabeledStatement = assertLabeledStatement;
  exports.assertLiteral = assertLiteral;
  exports.assertLogicalExpression = assertLogicalExpression;
  exports.assertLoop = assertLoop;
  exports.assertMemberExpression = assertMemberExpression;
  exports.assertMetaProperty = assertMetaProperty;
  exports.assertMethod = assertMethod;
  exports.assertMiscellaneous = assertMiscellaneous;
  exports.assertMixedTypeAnnotation = assertMixedTypeAnnotation;
  exports.assertModuleDeclaration = assertModuleDeclaration;
  exports.assertModuleExpression = assertModuleExpression;
  exports.assertModuleSpecifier = assertModuleSpecifier;
  exports.assertNewExpression = assertNewExpression;
  exports.assertNoop = assertNoop;
  exports.assertNullLiteral = assertNullLiteral;
  exports.assertNullLiteralTypeAnnotation = assertNullLiteralTypeAnnotation;
  exports.assertNullableTypeAnnotation = assertNullableTypeAnnotation;
  exports.assertNumberLiteral = assertNumberLiteral;
  exports.assertNumberLiteralTypeAnnotation = assertNumberLiteralTypeAnnotation;
  exports.assertNumberTypeAnnotation = assertNumberTypeAnnotation;
  exports.assertNumericLiteral = assertNumericLiteral;
  exports.assertObjectExpression = assertObjectExpression;
  exports.assertObjectMember = assertObjectMember;
  exports.assertObjectMethod = assertObjectMethod;
  exports.assertObjectPattern = assertObjectPattern;
  exports.assertObjectProperty = assertObjectProperty;
  exports.assertObjectTypeAnnotation = assertObjectTypeAnnotation;
  exports.assertObjectTypeCallProperty = assertObjectTypeCallProperty;
  exports.assertObjectTypeIndexer = assertObjectTypeIndexer;
  exports.assertObjectTypeInternalSlot = assertObjectTypeInternalSlot;
  exports.assertObjectTypeProperty = assertObjectTypeProperty;
  exports.assertObjectTypeSpreadProperty = assertObjectTypeSpreadProperty;
  exports.assertOpaqueType = assertOpaqueType;
  exports.assertOptionalCallExpression = assertOptionalCallExpression;
  exports.assertOptionalIndexedAccessType = assertOptionalIndexedAccessType;
  exports.assertOptionalMemberExpression = assertOptionalMemberExpression;
  exports.assertParenthesizedExpression = assertParenthesizedExpression;
  exports.assertPattern = assertPattern;
  exports.assertPatternLike = assertPatternLike;
  exports.assertPipelineBareFunction = assertPipelineBareFunction;
  exports.assertPipelinePrimaryTopicReference = assertPipelinePrimaryTopicReference;
  exports.assertPipelineTopicExpression = assertPipelineTopicExpression;
  exports.assertPlaceholder = assertPlaceholder;
  exports.assertPrivate = assertPrivate;
  exports.assertPrivateName = assertPrivateName;
  exports.assertProgram = assertProgram;
  exports.assertProperty = assertProperty;
  exports.assertPureish = assertPureish;
  exports.assertQualifiedTypeIdentifier = assertQualifiedTypeIdentifier;
  exports.assertRecordExpression = assertRecordExpression;
  exports.assertRegExpLiteral = assertRegExpLiteral;
  exports.assertRegexLiteral = assertRegexLiteral;
  exports.assertRestElement = assertRestElement;
  exports.assertRestProperty = assertRestProperty;
  exports.assertReturnStatement = assertReturnStatement;
  exports.assertScopable = assertScopable;
  exports.assertSequenceExpression = assertSequenceExpression;
  exports.assertSpreadElement = assertSpreadElement;
  exports.assertSpreadProperty = assertSpreadProperty;
  exports.assertStandardized = assertStandardized;
  exports.assertStatement = assertStatement;
  exports.assertStaticBlock = assertStaticBlock;
  exports.assertStringLiteral = assertStringLiteral;
  exports.assertStringLiteralTypeAnnotation = assertStringLiteralTypeAnnotation;
  exports.assertStringTypeAnnotation = assertStringTypeAnnotation;
  exports.assertSuper = assertSuper;
  exports.assertSwitchCase = assertSwitchCase;
  exports.assertSwitchStatement = assertSwitchStatement;
  exports.assertSymbolTypeAnnotation = assertSymbolTypeAnnotation;
  exports.assertTSAnyKeyword = assertTSAnyKeyword;
  exports.assertTSArrayType = assertTSArrayType;
  exports.assertTSAsExpression = assertTSAsExpression;
  exports.assertTSBaseType = assertTSBaseType;
  exports.assertTSBigIntKeyword = assertTSBigIntKeyword;
  exports.assertTSBooleanKeyword = assertTSBooleanKeyword;
  exports.assertTSCallSignatureDeclaration = assertTSCallSignatureDeclaration;
  exports.assertTSConditionalType = assertTSConditionalType;
  exports.assertTSConstructSignatureDeclaration = assertTSConstructSignatureDeclaration;
  exports.assertTSConstructorType = assertTSConstructorType;
  exports.assertTSDeclareFunction = assertTSDeclareFunction;
  exports.assertTSDeclareMethod = assertTSDeclareMethod;
  exports.assertTSEntityName = assertTSEntityName;
  exports.assertTSEnumDeclaration = assertTSEnumDeclaration;
  exports.assertTSEnumMember = assertTSEnumMember;
  exports.assertTSExportAssignment = assertTSExportAssignment;
  exports.assertTSExpressionWithTypeArguments = assertTSExpressionWithTypeArguments;
  exports.assertTSExternalModuleReference = assertTSExternalModuleReference;
  exports.assertTSFunctionType = assertTSFunctionType;
  exports.assertTSImportEqualsDeclaration = assertTSImportEqualsDeclaration;
  exports.assertTSImportType = assertTSImportType;
  exports.assertTSIndexSignature = assertTSIndexSignature;
  exports.assertTSIndexedAccessType = assertTSIndexedAccessType;
  exports.assertTSInferType = assertTSInferType;
  exports.assertTSInstantiationExpression = assertTSInstantiationExpression;
  exports.assertTSInterfaceBody = assertTSInterfaceBody;
  exports.assertTSInterfaceDeclaration = assertTSInterfaceDeclaration;
  exports.assertTSIntersectionType = assertTSIntersectionType;
  exports.assertTSIntrinsicKeyword = assertTSIntrinsicKeyword;
  exports.assertTSLiteralType = assertTSLiteralType;
  exports.assertTSMappedType = assertTSMappedType;
  exports.assertTSMethodSignature = assertTSMethodSignature;
  exports.assertTSModuleBlock = assertTSModuleBlock;
  exports.assertTSModuleDeclaration = assertTSModuleDeclaration;
  exports.assertTSNamedTupleMember = assertTSNamedTupleMember;
  exports.assertTSNamespaceExportDeclaration = assertTSNamespaceExportDeclaration;
  exports.assertTSNeverKeyword = assertTSNeverKeyword;
  exports.assertTSNonNullExpression = assertTSNonNullExpression;
  exports.assertTSNullKeyword = assertTSNullKeyword;
  exports.assertTSNumberKeyword = assertTSNumberKeyword;
  exports.assertTSObjectKeyword = assertTSObjectKeyword;
  exports.assertTSOptionalType = assertTSOptionalType;
  exports.assertTSParameterProperty = assertTSParameterProperty;
  exports.assertTSParenthesizedType = assertTSParenthesizedType;
  exports.assertTSPropertySignature = assertTSPropertySignature;
  exports.assertTSQualifiedName = assertTSQualifiedName;
  exports.assertTSRestType = assertTSRestType;
  exports.assertTSSatisfiesExpression = assertTSSatisfiesExpression;
  exports.assertTSStringKeyword = assertTSStringKeyword;
  exports.assertTSSymbolKeyword = assertTSSymbolKeyword;
  exports.assertTSThisType = assertTSThisType;
  exports.assertTSTupleType = assertTSTupleType;
  exports.assertTSType = assertTSType;
  exports.assertTSTypeAliasDeclaration = assertTSTypeAliasDeclaration;
  exports.assertTSTypeAnnotation = assertTSTypeAnnotation;
  exports.assertTSTypeAssertion = assertTSTypeAssertion;
  exports.assertTSTypeElement = assertTSTypeElement;
  exports.assertTSTypeLiteral = assertTSTypeLiteral;
  exports.assertTSTypeOperator = assertTSTypeOperator;
  exports.assertTSTypeParameter = assertTSTypeParameter;
  exports.assertTSTypeParameterDeclaration = assertTSTypeParameterDeclaration;
  exports.assertTSTypeParameterInstantiation = assertTSTypeParameterInstantiation;
  exports.assertTSTypePredicate = assertTSTypePredicate;
  exports.assertTSTypeQuery = assertTSTypeQuery;
  exports.assertTSTypeReference = assertTSTypeReference;
  exports.assertTSUndefinedKeyword = assertTSUndefinedKeyword;
  exports.assertTSUnionType = assertTSUnionType;
  exports.assertTSUnknownKeyword = assertTSUnknownKeyword;
  exports.assertTSVoidKeyword = assertTSVoidKeyword;
  exports.assertTaggedTemplateExpression = assertTaggedTemplateExpression;
  exports.assertTemplateElement = assertTemplateElement;
  exports.assertTemplateLiteral = assertTemplateLiteral;
  exports.assertTerminatorless = assertTerminatorless;
  exports.assertThisExpression = assertThisExpression;
  exports.assertThisTypeAnnotation = assertThisTypeAnnotation;
  exports.assertThrowStatement = assertThrowStatement;
  exports.assertTopicReference = assertTopicReference;
  exports.assertTryStatement = assertTryStatement;
  exports.assertTupleExpression = assertTupleExpression;
  exports.assertTupleTypeAnnotation = assertTupleTypeAnnotation;
  exports.assertTypeAlias = assertTypeAlias;
  exports.assertTypeAnnotation = assertTypeAnnotation;
  exports.assertTypeCastExpression = assertTypeCastExpression;
  exports.assertTypeParameter = assertTypeParameter;
  exports.assertTypeParameterDeclaration = assertTypeParameterDeclaration;
  exports.assertTypeParameterInstantiation = assertTypeParameterInstantiation;
  exports.assertTypeScript = assertTypeScript;
  exports.assertTypeofTypeAnnotation = assertTypeofTypeAnnotation;
  exports.assertUnaryExpression = assertUnaryExpression;
  exports.assertUnaryLike = assertUnaryLike;
  exports.assertUnionTypeAnnotation = assertUnionTypeAnnotation;
  exports.assertUpdateExpression = assertUpdateExpression;
  exports.assertUserWhitespacable = assertUserWhitespacable;
  exports.assertV8IntrinsicIdentifier = assertV8IntrinsicIdentifier;
  exports.assertVariableDeclaration = assertVariableDeclaration;
  exports.assertVariableDeclarator = assertVariableDeclarator;
  exports.assertVariance = assertVariance;
  exports.assertVoidTypeAnnotation = assertVoidTypeAnnotation;
  exports.assertWhile = assertWhile;
  exports.assertWhileStatement = assertWhileStatement;
  exports.assertWithStatement = assertWithStatement;
  exports.assertYieldExpression = assertYieldExpression;
  var _is = require_is();
  var _deprecationWarning = require_deprecationWarning();
  function assert(type, node, opts) {
    if (!(0, _is.default)(type, node, opts)) {
      throw new Error(`Expected type "${type}" with option ${JSON.stringify(opts)}, but instead got "${node.type}".`);
    }
  }
  function assertArrayExpression(node, opts) {
    assert("ArrayExpression", node, opts);
  }
  function assertAssignmentExpression(node, opts) {
    assert("AssignmentExpression", node, opts);
  }
  function assertBinaryExpression(node, opts) {
    assert("BinaryExpression", node, opts);
  }
  function assertInterpreterDirective(node, opts) {
    assert("InterpreterDirective", node, opts);
  }
  function assertDirective(node, opts) {
    assert("Directive", node, opts);
  }
  function assertDirectiveLiteral(node, opts) {
    assert("DirectiveLiteral", node, opts);
  }
  function assertBlockStatement(node, opts) {
    assert("BlockStatement", node, opts);
  }
  function assertBreakStatement(node, opts) {
    assert("BreakStatement", node, opts);
  }
  function assertCallExpression(node, opts) {
    assert("CallExpression", node, opts);
  }
  function assertCatchClause(node, opts) {
    assert("CatchClause", node, opts);
  }
  function assertConditionalExpression(node, opts) {
    assert("ConditionalExpression", node, opts);
  }
  function assertContinueStatement(node, opts) {
    assert("ContinueStatement", node, opts);
  }
  function assertDebuggerStatement(node, opts) {
    assert("DebuggerStatement", node, opts);
  }
  function assertDoWhileStatement(node, opts) {
    assert("DoWhileStatement", node, opts);
  }
  function assertEmptyStatement(node, opts) {
    assert("EmptyStatement", node, opts);
  }
  function assertExpressionStatement(node, opts) {
    assert("ExpressionStatement", node, opts);
  }
  function assertFile(node, opts) {
    assert("File", node, opts);
  }
  function assertForInStatement(node, opts) {
    assert("ForInStatement", node, opts);
  }
  function assertForStatement(node, opts) {
    assert("ForStatement", node, opts);
  }
  function assertFunctionDeclaration(node, opts) {
    assert("FunctionDeclaration", node, opts);
  }
  function assertFunctionExpression(node, opts) {
    assert("FunctionExpression", node, opts);
  }
  function assertIdentifier(node, opts) {
    assert("Identifier", node, opts);
  }
  function assertIfStatement(node, opts) {
    assert("IfStatement", node, opts);
  }
  function assertLabeledStatement(node, opts) {
    assert("LabeledStatement", node, opts);
  }
  function assertStringLiteral(node, opts) {
    assert("StringLiteral", node, opts);
  }
  function assertNumericLiteral(node, opts) {
    assert("NumericLiteral", node, opts);
  }
  function assertNullLiteral(node, opts) {
    assert("NullLiteral", node, opts);
  }
  function assertBooleanLiteral(node, opts) {
    assert("BooleanLiteral", node, opts);
  }
  function assertRegExpLiteral(node, opts) {
    assert("RegExpLiteral", node, opts);
  }
  function assertLogicalExpression(node, opts) {
    assert("LogicalExpression", node, opts);
  }
  function assertMemberExpression(node, opts) {
    assert("MemberExpression", node, opts);
  }
  function assertNewExpression(node, opts) {
    assert("NewExpression", node, opts);
  }
  function assertProgram(node, opts) {
    assert("Program", node, opts);
  }
  function assertObjectExpression(node, opts) {
    assert("ObjectExpression", node, opts);
  }
  function assertObjectMethod(node, opts) {
    assert("ObjectMethod", node, opts);
  }
  function assertObjectProperty(node, opts) {
    assert("ObjectProperty", node, opts);
  }
  function assertRestElement(node, opts) {
    assert("RestElement", node, opts);
  }
  function assertReturnStatement(node, opts) {
    assert("ReturnStatement", node, opts);
  }
  function assertSequenceExpression(node, opts) {
    assert("SequenceExpression", node, opts);
  }
  function assertParenthesizedExpression(node, opts) {
    assert("ParenthesizedExpression", node, opts);
  }
  function assertSwitchCase(node, opts) {
    assert("SwitchCase", node, opts);
  }
  function assertSwitchStatement(node, opts) {
    assert("SwitchStatement", node, opts);
  }
  function assertThisExpression(node, opts) {
    assert("ThisExpression", node, opts);
  }
  function assertThrowStatement(node, opts) {
    assert("ThrowStatement", node, opts);
  }
  function assertTryStatement(node, opts) {
    assert("TryStatement", node, opts);
  }
  function assertUnaryExpression(node, opts) {
    assert("UnaryExpression", node, opts);
  }
  function assertUpdateExpression(node, opts) {
    assert("UpdateExpression", node, opts);
  }
  function assertVariableDeclaration(node, opts) {
    assert("VariableDeclaration", node, opts);
  }
  function assertVariableDeclarator(node, opts) {
    assert("VariableDeclarator", node, opts);
  }
  function assertWhileStatement(node, opts) {
    assert("WhileStatement", node, opts);
  }
  function assertWithStatement(node, opts) {
    assert("WithStatement", node, opts);
  }
  function assertAssignmentPattern(node, opts) {
    assert("AssignmentPattern", node, opts);
  }
  function assertArrayPattern(node, opts) {
    assert("ArrayPattern", node, opts);
  }
  function assertArrowFunctionExpression(node, opts) {
    assert("ArrowFunctionExpression", node, opts);
  }
  function assertClassBody(node, opts) {
    assert("ClassBody", node, opts);
  }
  function assertClassExpression(node, opts) {
    assert("ClassExpression", node, opts);
  }
  function assertClassDeclaration(node, opts) {
    assert("ClassDeclaration", node, opts);
  }
  function assertExportAllDeclaration(node, opts) {
    assert("ExportAllDeclaration", node, opts);
  }
  function assertExportDefaultDeclaration(node, opts) {
    assert("ExportDefaultDeclaration", node, opts);
  }
  function assertExportNamedDeclaration(node, opts) {
    assert("ExportNamedDeclaration", node, opts);
  }
  function assertExportSpecifier(node, opts) {
    assert("ExportSpecifier", node, opts);
  }
  function assertForOfStatement(node, opts) {
    assert("ForOfStatement", node, opts);
  }
  function assertImportDeclaration(node, opts) {
    assert("ImportDeclaration", node, opts);
  }
  function assertImportDefaultSpecifier(node, opts) {
    assert("ImportDefaultSpecifier", node, opts);
  }
  function assertImportNamespaceSpecifier(node, opts) {
    assert("ImportNamespaceSpecifier", node, opts);
  }
  function assertImportSpecifier(node, opts) {
    assert("ImportSpecifier", node, opts);
  }
  function assertImportExpression(node, opts) {
    assert("ImportExpression", node, opts);
  }
  function assertMetaProperty(node, opts) {
    assert("MetaProperty", node, opts);
  }
  function assertClassMethod(node, opts) {
    assert("ClassMethod", node, opts);
  }
  function assertObjectPattern(node, opts) {
    assert("ObjectPattern", node, opts);
  }
  function assertSpreadElement(node, opts) {
    assert("SpreadElement", node, opts);
  }
  function assertSuper(node, opts) {
    assert("Super", node, opts);
  }
  function assertTaggedTemplateExpression(node, opts) {
    assert("TaggedTemplateExpression", node, opts);
  }
  function assertTemplateElement(node, opts) {
    assert("TemplateElement", node, opts);
  }
  function assertTemplateLiteral(node, opts) {
    assert("TemplateLiteral", node, opts);
  }
  function assertYieldExpression(node, opts) {
    assert("YieldExpression", node, opts);
  }
  function assertAwaitExpression(node, opts) {
    assert("AwaitExpression", node, opts);
  }
  function assertImport(node, opts) {
    assert("Import", node, opts);
  }
  function assertBigIntLiteral(node, opts) {
    assert("BigIntLiteral", node, opts);
  }
  function assertExportNamespaceSpecifier(node, opts) {
    assert("ExportNamespaceSpecifier", node, opts);
  }
  function assertOptionalMemberExpression(node, opts) {
    assert("OptionalMemberExpression", node, opts);
  }
  function assertOptionalCallExpression(node, opts) {
    assert("OptionalCallExpression", node, opts);
  }
  function assertClassProperty(node, opts) {
    assert("ClassProperty", node, opts);
  }
  function assertClassAccessorProperty(node, opts) {
    assert("ClassAccessorProperty", node, opts);
  }
  function assertClassPrivateProperty(node, opts) {
    assert("ClassPrivateProperty", node, opts);
  }
  function assertClassPrivateMethod(node, opts) {
    assert("ClassPrivateMethod", node, opts);
  }
  function assertPrivateName(node, opts) {
    assert("PrivateName", node, opts);
  }
  function assertStaticBlock(node, opts) {
    assert("StaticBlock", node, opts);
  }
  function assertAnyTypeAnnotation(node, opts) {
    assert("AnyTypeAnnotation", node, opts);
  }
  function assertArrayTypeAnnotation(node, opts) {
    assert("ArrayTypeAnnotation", node, opts);
  }
  function assertBooleanTypeAnnotation(node, opts) {
    assert("BooleanTypeAnnotation", node, opts);
  }
  function assertBooleanLiteralTypeAnnotation(node, opts) {
    assert("BooleanLiteralTypeAnnotation", node, opts);
  }
  function assertNullLiteralTypeAnnotation(node, opts) {
    assert("NullLiteralTypeAnnotation", node, opts);
  }
  function assertClassImplements(node, opts) {
    assert("ClassImplements", node, opts);
  }
  function assertDeclareClass(node, opts) {
    assert("DeclareClass", node, opts);
  }
  function assertDeclareFunction(node, opts) {
    assert("DeclareFunction", node, opts);
  }
  function assertDeclareInterface(node, opts) {
    assert("DeclareInterface", node, opts);
  }
  function assertDeclareModule(node, opts) {
    assert("DeclareModule", node, opts);
  }
  function assertDeclareModuleExports(node, opts) {
    assert("DeclareModuleExports", node, opts);
  }
  function assertDeclareTypeAlias(node, opts) {
    assert("DeclareTypeAlias", node, opts);
  }
  function assertDeclareOpaqueType(node, opts) {
    assert("DeclareOpaqueType", node, opts);
  }
  function assertDeclareVariable(node, opts) {
    assert("DeclareVariable", node, opts);
  }
  function assertDeclareExportDeclaration(node, opts) {
    assert("DeclareExportDeclaration", node, opts);
  }
  function assertDeclareExportAllDeclaration(node, opts) {
    assert("DeclareExportAllDeclaration", node, opts);
  }
  function assertDeclaredPredicate(node, opts) {
    assert("DeclaredPredicate", node, opts);
  }
  function assertExistsTypeAnnotation(node, opts) {
    assert("ExistsTypeAnnotation", node, opts);
  }
  function assertFunctionTypeAnnotation(node, opts) {
    assert("FunctionTypeAnnotation", node, opts);
  }
  function assertFunctionTypeParam(node, opts) {
    assert("FunctionTypeParam", node, opts);
  }
  function assertGenericTypeAnnotation(node, opts) {
    assert("GenericTypeAnnotation", node, opts);
  }
  function assertInferredPredicate(node, opts) {
    assert("InferredPredicate", node, opts);
  }
  function assertInterfaceExtends(node, opts) {
    assert("InterfaceExtends", node, opts);
  }
  function assertInterfaceDeclaration(node, opts) {
    assert("InterfaceDeclaration", node, opts);
  }
  function assertInterfaceTypeAnnotation(node, opts) {
    assert("InterfaceTypeAnnotation", node, opts);
  }
  function assertIntersectionTypeAnnotation(node, opts) {
    assert("IntersectionTypeAnnotation", node, opts);
  }
  function assertMixedTypeAnnotation(node, opts) {
    assert("MixedTypeAnnotation", node, opts);
  }
  function assertEmptyTypeAnnotation(node, opts) {
    assert("EmptyTypeAnnotation", node, opts);
  }
  function assertNullableTypeAnnotation(node, opts) {
    assert("NullableTypeAnnotation", node, opts);
  }
  function assertNumberLiteralTypeAnnotation(node, opts) {
    assert("NumberLiteralTypeAnnotation", node, opts);
  }
  function assertNumberTypeAnnotation(node, opts) {
    assert("NumberTypeAnnotation", node, opts);
  }
  function assertObjectTypeAnnotation(node, opts) {
    assert("ObjectTypeAnnotation", node, opts);
  }
  function assertObjectTypeInternalSlot(node, opts) {
    assert("ObjectTypeInternalSlot", node, opts);
  }
  function assertObjectTypeCallProperty(node, opts) {
    assert("ObjectTypeCallProperty", node, opts);
  }
  function assertObjectTypeIndexer(node, opts) {
    assert("ObjectTypeIndexer", node, opts);
  }
  function assertObjectTypeProperty(node, opts) {
    assert("ObjectTypeProperty", node, opts);
  }
  function assertObjectTypeSpreadProperty(node, opts) {
    assert("ObjectTypeSpreadProperty", node, opts);
  }
  function assertOpaqueType(node, opts) {
    assert("OpaqueType", node, opts);
  }
  function assertQualifiedTypeIdentifier(node, opts) {
    assert("QualifiedTypeIdentifier", node, opts);
  }
  function assertStringLiteralTypeAnnotation(node, opts) {
    assert("StringLiteralTypeAnnotation", node, opts);
  }
  function assertStringTypeAnnotation(node, opts) {
    assert("StringTypeAnnotation", node, opts);
  }
  function assertSymbolTypeAnnotation(node, opts) {
    assert("SymbolTypeAnnotation", node, opts);
  }
  function assertThisTypeAnnotation(node, opts) {
    assert("ThisTypeAnnotation", node, opts);
  }
  function assertTupleTypeAnnotation(node, opts) {
    assert("TupleTypeAnnotation", node, opts);
  }
  function assertTypeofTypeAnnotation(node, opts) {
    assert("TypeofTypeAnnotation", node, opts);
  }
  function assertTypeAlias(node, opts) {
    assert("TypeAlias", node, opts);
  }
  function assertTypeAnnotation(node, opts) {
    assert("TypeAnnotation", node, opts);
  }
  function assertTypeCastExpression(node, opts) {
    assert("TypeCastExpression", node, opts);
  }
  function assertTypeParameter(node, opts) {
    assert("TypeParameter", node, opts);
  }
  function assertTypeParameterDeclaration(node, opts) {
    assert("TypeParameterDeclaration", node, opts);
  }
  function assertTypeParameterInstantiation(node, opts) {
    assert("TypeParameterInstantiation", node, opts);
  }
  function assertUnionTypeAnnotation(node, opts) {
    assert("UnionTypeAnnotation", node, opts);
  }
  function assertVariance(node, opts) {
    assert("Variance", node, opts);
  }
  function assertVoidTypeAnnotation(node, opts) {
    assert("VoidTypeAnnotation", node, opts);
  }
  function assertEnumDeclaration(node, opts) {
    assert("EnumDeclaration", node, opts);
  }
  function assertEnumBooleanBody(node, opts) {
    assert("EnumBooleanBody", node, opts);
  }
  function assertEnumNumberBody(node, opts) {
    assert("EnumNumberBody", node, opts);
  }
  function assertEnumStringBody(node, opts) {
    assert("EnumStringBody", node, opts);
  }
  function assertEnumSymbolBody(node, opts) {
    assert("EnumSymbolBody", node, opts);
  }
  function assertEnumBooleanMember(node, opts) {
    assert("EnumBooleanMember", node, opts);
  }
  function assertEnumNumberMember(node, opts) {
    assert("EnumNumberMember", node, opts);
  }
  function assertEnumStringMember(node, opts) {
    assert("EnumStringMember", node, opts);
  }
  function assertEnumDefaultedMember(node, opts) {
    assert("EnumDefaultedMember", node, opts);
  }
  function assertIndexedAccessType(node, opts) {
    assert("IndexedAccessType", node, opts);
  }
  function assertOptionalIndexedAccessType(node, opts) {
    assert("OptionalIndexedAccessType", node, opts);
  }
  function assertJSXAttribute(node, opts) {
    assert("JSXAttribute", node, opts);
  }
  function assertJSXClosingElement(node, opts) {
    assert("JSXClosingElement", node, opts);
  }
  function assertJSXElement(node, opts) {
    assert("JSXElement", node, opts);
  }
  function assertJSXEmptyExpression(node, opts) {
    assert("JSXEmptyExpression", node, opts);
  }
  function assertJSXExpressionContainer(node, opts) {
    assert("JSXExpressionContainer", node, opts);
  }
  function assertJSXSpreadChild(node, opts) {
    assert("JSXSpreadChild", node, opts);
  }
  function assertJSXIdentifier(node, opts) {
    assert("JSXIdentifier", node, opts);
  }
  function assertJSXMemberExpression(node, opts) {
    assert("JSXMemberExpression", node, opts);
  }
  function assertJSXNamespacedName(node, opts) {
    assert("JSXNamespacedName", node, opts);
  }
  function assertJSXOpeningElement(node, opts) {
    assert("JSXOpeningElement", node, opts);
  }
  function assertJSXSpreadAttribute(node, opts) {
    assert("JSXSpreadAttribute", node, opts);
  }
  function assertJSXText(node, opts) {
    assert("JSXText", node, opts);
  }
  function assertJSXFragment(node, opts) {
    assert("JSXFragment", node, opts);
  }
  function assertJSXOpeningFragment(node, opts) {
    assert("JSXOpeningFragment", node, opts);
  }
  function assertJSXClosingFragment(node, opts) {
    assert("JSXClosingFragment", node, opts);
  }
  function assertNoop(node, opts) {
    assert("Noop", node, opts);
  }
  function assertPlaceholder(node, opts) {
    assert("Placeholder", node, opts);
  }
  function assertV8IntrinsicIdentifier(node, opts) {
    assert("V8IntrinsicIdentifier", node, opts);
  }
  function assertArgumentPlaceholder(node, opts) {
    assert("ArgumentPlaceholder", node, opts);
  }
  function assertBindExpression(node, opts) {
    assert("BindExpression", node, opts);
  }
  function assertImportAttribute(node, opts) {
    assert("ImportAttribute", node, opts);
  }
  function assertDecorator(node, opts) {
    assert("Decorator", node, opts);
  }
  function assertDoExpression(node, opts) {
    assert("DoExpression", node, opts);
  }
  function assertExportDefaultSpecifier(node, opts) {
    assert("ExportDefaultSpecifier", node, opts);
  }
  function assertRecordExpression(node, opts) {
    assert("RecordExpression", node, opts);
  }
  function assertTupleExpression(node, opts) {
    assert("TupleExpression", node, opts);
  }
  function assertDecimalLiteral(node, opts) {
    assert("DecimalLiteral", node, opts);
  }
  function assertModuleExpression(node, opts) {
    assert("ModuleExpression", node, opts);
  }
  function assertTopicReference(node, opts) {
    assert("TopicReference", node, opts);
  }
  function assertPipelineTopicExpression(node, opts) {
    assert("PipelineTopicExpression", node, opts);
  }
  function assertPipelineBareFunction(node, opts) {
    assert("PipelineBareFunction", node, opts);
  }
  function assertPipelinePrimaryTopicReference(node, opts) {
    assert("PipelinePrimaryTopicReference", node, opts);
  }
  function assertTSParameterProperty(node, opts) {
    assert("TSParameterProperty", node, opts);
  }
  function assertTSDeclareFunction(node, opts) {
    assert("TSDeclareFunction", node, opts);
  }
  function assertTSDeclareMethod(node, opts) {
    assert("TSDeclareMethod", node, opts);
  }
  function assertTSQualifiedName(node, opts) {
    assert("TSQualifiedName", node, opts);
  }
  function assertTSCallSignatureDeclaration(node, opts) {
    assert("TSCallSignatureDeclaration", node, opts);
  }
  function assertTSConstructSignatureDeclaration(node, opts) {
    assert("TSConstructSignatureDeclaration", node, opts);
  }
  function assertTSPropertySignature(node, opts) {
    assert("TSPropertySignature", node, opts);
  }
  function assertTSMethodSignature(node, opts) {
    assert("TSMethodSignature", node, opts);
  }
  function assertTSIndexSignature(node, opts) {
    assert("TSIndexSignature", node, opts);
  }
  function assertTSAnyKeyword(node, opts) {
    assert("TSAnyKeyword", node, opts);
  }
  function assertTSBooleanKeyword(node, opts) {
    assert("TSBooleanKeyword", node, opts);
  }
  function assertTSBigIntKeyword(node, opts) {
    assert("TSBigIntKeyword", node, opts);
  }
  function assertTSIntrinsicKeyword(node, opts) {
    assert("TSIntrinsicKeyword", node, opts);
  }
  function assertTSNeverKeyword(node, opts) {
    assert("TSNeverKeyword", node, opts);
  }
  function assertTSNullKeyword(node, opts) {
    assert("TSNullKeyword", node, opts);
  }
  function assertTSNumberKeyword(node, opts) {
    assert("TSNumberKeyword", node, opts);
  }
  function assertTSObjectKeyword(node, opts) {
    assert("TSObjectKeyword", node, opts);
  }
  function assertTSStringKeyword(node, opts) {
    assert("TSStringKeyword", node, opts);
  }
  function assertTSSymbolKeyword(node, opts) {
    assert("TSSymbolKeyword", node, opts);
  }
  function assertTSUndefinedKeyword(node, opts) {
    assert("TSUndefinedKeyword", node, opts);
  }
  function assertTSUnknownKeyword(node, opts) {
    assert("TSUnknownKeyword", node, opts);
  }
  function assertTSVoidKeyword(node, opts) {
    assert("TSVoidKeyword", node, opts);
  }
  function assertTSThisType(node, opts) {
    assert("TSThisType", node, opts);
  }
  function assertTSFunctionType(node, opts) {
    assert("TSFunctionType", node, opts);
  }
  function assertTSConstructorType(node, opts) {
    assert("TSConstructorType", node, opts);
  }
  function assertTSTypeReference(node, opts) {
    assert("TSTypeReference", node, opts);
  }
  function assertTSTypePredicate(node, opts) {
    assert("TSTypePredicate", node, opts);
  }
  function assertTSTypeQuery(node, opts) {
    assert("TSTypeQuery", node, opts);
  }
  function assertTSTypeLiteral(node, opts) {
    assert("TSTypeLiteral", node, opts);
  }
  function assertTSArrayType(node, opts) {
    assert("TSArrayType", node, opts);
  }
  function assertTSTupleType(node, opts) {
    assert("TSTupleType", node, opts);
  }
  function assertTSOptionalType(node, opts) {
    assert("TSOptionalType", node, opts);
  }
  function assertTSRestType(node, opts) {
    assert("TSRestType", node, opts);
  }
  function assertTSNamedTupleMember(node, opts) {
    assert("TSNamedTupleMember", node, opts);
  }
  function assertTSUnionType(node, opts) {
    assert("TSUnionType", node, opts);
  }
  function assertTSIntersectionType(node, opts) {
    assert("TSIntersectionType", node, opts);
  }
  function assertTSConditionalType(node, opts) {
    assert("TSConditionalType", node, opts);
  }
  function assertTSInferType(node, opts) {
    assert("TSInferType", node, opts);
  }
  function assertTSParenthesizedType(node, opts) {
    assert("TSParenthesizedType", node, opts);
  }
  function assertTSTypeOperator(node, opts) {
    assert("TSTypeOperator", node, opts);
  }
  function assertTSIndexedAccessType(node, opts) {
    assert("TSIndexedAccessType", node, opts);
  }
  function assertTSMappedType(node, opts) {
    assert("TSMappedType", node, opts);
  }
  function assertTSLiteralType(node, opts) {
    assert("TSLiteralType", node, opts);
  }
  function assertTSExpressionWithTypeArguments(node, opts) {
    assert("TSExpressionWithTypeArguments", node, opts);
  }
  function assertTSInterfaceDeclaration(node, opts) {
    assert("TSInterfaceDeclaration", node, opts);
  }
  function assertTSInterfaceBody(node, opts) {
    assert("TSInterfaceBody", node, opts);
  }
  function assertTSTypeAliasDeclaration(node, opts) {
    assert("TSTypeAliasDeclaration", node, opts);
  }
  function assertTSInstantiationExpression(node, opts) {
    assert("TSInstantiationExpression", node, opts);
  }
  function assertTSAsExpression(node, opts) {
    assert("TSAsExpression", node, opts);
  }
  function assertTSSatisfiesExpression(node, opts) {
    assert("TSSatisfiesExpression", node, opts);
  }
  function assertTSTypeAssertion(node, opts) {
    assert("TSTypeAssertion", node, opts);
  }
  function assertTSEnumDeclaration(node, opts) {
    assert("TSEnumDeclaration", node, opts);
  }
  function assertTSEnumMember(node, opts) {
    assert("TSEnumMember", node, opts);
  }
  function assertTSModuleDeclaration(node, opts) {
    assert("TSModuleDeclaration", node, opts);
  }
  function assertTSModuleBlock(node, opts) {
    assert("TSModuleBlock", node, opts);
  }
  function assertTSImportType(node, opts) {
    assert("TSImportType", node, opts);
  }
  function assertTSImportEqualsDeclaration(node, opts) {
    assert("TSImportEqualsDeclaration", node, opts);
  }
  function assertTSExternalModuleReference(node, opts) {
    assert("TSExternalModuleReference", node, opts);
  }
  function assertTSNonNullExpression(node, opts) {
    assert("TSNonNullExpression", node, opts);
  }
  function assertTSExportAssignment(node, opts) {
    assert("TSExportAssignment", node, opts);
  }
  function assertTSNamespaceExportDeclaration(node, opts) {
    assert("TSNamespaceExportDeclaration", node, opts);
  }
  function assertTSTypeAnnotation(node, opts) {
    assert("TSTypeAnnotation", node, opts);
  }
  function assertTSTypeParameterInstantiation(node, opts) {
    assert("TSTypeParameterInstantiation", node, opts);
  }
  function assertTSTypeParameterDeclaration(node, opts) {
    assert("TSTypeParameterDeclaration", node, opts);
  }
  function assertTSTypeParameter(node, opts) {
    assert("TSTypeParameter", node, opts);
  }
  function assertStandardized(node, opts) {
    assert("Standardized", node, opts);
  }
  function assertExpression(node, opts) {
    assert("Expression", node, opts);
  }
  function assertBinary(node, opts) {
    assert("Binary", node, opts);
  }
  function assertScopable(node, opts) {
    assert("Scopable", node, opts);
  }
  function assertBlockParent(node, opts) {
    assert("BlockParent", node, opts);
  }
  function assertBlock(node, opts) {
    assert("Block", node, opts);
  }
  function assertStatement(node, opts) {
    assert("Statement", node, opts);
  }
  function assertTerminatorless(node, opts) {
    assert("Terminatorless", node, opts);
  }
  function assertCompletionStatement(node, opts) {
    assert("CompletionStatement", node, opts);
  }
  function assertConditional(node, opts) {
    assert("Conditional", node, opts);
  }
  function assertLoop(node, opts) {
    assert("Loop", node, opts);
  }
  function assertWhile(node, opts) {
    assert("While", node, opts);
  }
  function assertExpressionWrapper(node, opts) {
    assert("ExpressionWrapper", node, opts);
  }
  function assertFor(node, opts) {
    assert("For", node, opts);
  }
  function assertForXStatement(node, opts) {
    assert("ForXStatement", node, opts);
  }
  function assertFunction(node, opts) {
    assert("Function", node, opts);
  }
  function assertFunctionParent(node, opts) {
    assert("FunctionParent", node, opts);
  }
  function assertPureish(node, opts) {
    assert("Pureish", node, opts);
  }
  function assertDeclaration(node, opts) {
    assert("Declaration", node, opts);
  }
  function assertPatternLike(node, opts) {
    assert("PatternLike", node, opts);
  }
  function assertLVal(node, opts) {
    assert("LVal", node, opts);
  }
  function assertTSEntityName(node, opts) {
    assert("TSEntityName", node, opts);
  }
  function assertLiteral(node, opts) {
    assert("Literal", node, opts);
  }
  function assertImmutable(node, opts) {
    assert("Immutable", node, opts);
  }
  function assertUserWhitespacable(node, opts) {
    assert("UserWhitespacable", node, opts);
  }
  function assertMethod(node, opts) {
    assert("Method", node, opts);
  }
  function assertObjectMember(node, opts) {
    assert("ObjectMember", node, opts);
  }
  function assertProperty(node, opts) {
    assert("Property", node, opts);
  }
  function assertUnaryLike(node, opts) {
    assert("UnaryLike", node, opts);
  }
  function assertPattern(node, opts) {
    assert("Pattern", node, opts);
  }
  function assertClass(node, opts) {
    assert("Class", node, opts);
  }
  function assertImportOrExportDeclaration(node, opts) {
    assert("ImportOrExportDeclaration", node, opts);
  }
  function assertExportDeclaration(node, opts) {
    assert("ExportDeclaration", node, opts);
  }
  function assertModuleSpecifier(node, opts) {
    assert("ModuleSpecifier", node, opts);
  }
  function assertAccessor(node, opts) {
    assert("Accessor", node, opts);
  }
  function assertPrivate(node, opts) {
    assert("Private", node, opts);
  }
  function assertFlow(node, opts) {
    assert("Flow", node, opts);
  }
  function assertFlowType(node, opts) {
    assert("FlowType", node, opts);
  }
  function assertFlowBaseAnnotation(node, opts) {
    assert("FlowBaseAnnotation", node, opts);
  }
  function assertFlowDeclaration(node, opts) {
    assert("FlowDeclaration", node, opts);
  }
  function assertFlowPredicate(node, opts) {
    assert("FlowPredicate", node, opts);
  }
  function assertEnumBody(node, opts) {
    assert("EnumBody", node, opts);
  }
  function assertEnumMember(node, opts) {
    assert("EnumMember", node, opts);
  }
  function assertJSX(node, opts) {
    assert("JSX", node, opts);
  }
  function assertMiscellaneous(node, opts) {
    assert("Miscellaneous", node, opts);
  }
  function assertTypeScript(node, opts) {
    assert("TypeScript", node, opts);
  }
  function assertTSTypeElement(node, opts) {
    assert("TSTypeElement", node, opts);
  }
  function assertTSType(node, opts) {
    assert("TSType", node, opts);
  }
  function assertTSBaseType(node, opts) {
    assert("TSBaseType", node, opts);
  }
  function assertNumberLiteral(node, opts) {
    (0, _deprecationWarning.default)("assertNumberLiteral", "assertNumericLiteral");
    assert("NumberLiteral", node, opts);
  }
  function assertRegexLiteral(node, opts) {
    (0, _deprecationWarning.default)("assertRegexLiteral", "assertRegExpLiteral");
    assert("RegexLiteral", node, opts);
  }
  function assertRestProperty(node, opts) {
    (0, _deprecationWarning.default)("assertRestProperty", "assertRestElement");
    assert("RestProperty", node, opts);
  }
  function assertSpreadProperty(node, opts) {
    (0, _deprecationWarning.default)("assertSpreadProperty", "assertSpreadElement");
    assert("SpreadProperty", node, opts);
  }
  function assertModuleDeclaration(node, opts) {
    (0, _deprecationWarning.default)("assertModuleDeclaration", "assertImportOrExportDeclaration");
    assert("ModuleDeclaration", node, opts);
  }
});
var require_createTypeAnnotationBasedOnTypeof = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _index = require_generated2();
  var _default = exports.default = createTypeAnnotationBasedOnTypeof;
  function createTypeAnnotationBasedOnTypeof(type) {
    switch (type) {
      case "string":
        return (0, _index.stringTypeAnnotation)();
      case "number":
        return (0, _index.numberTypeAnnotation)();
      case "undefined":
        return (0, _index.voidTypeAnnotation)();
      case "boolean":
        return (0, _index.booleanTypeAnnotation)();
      case "function":
        return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Function"));
      case "object":
        return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Object"));
      case "symbol":
        return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Symbol"));
      case "bigint":
        return (0, _index.anyTypeAnnotation)();
    }
    throw new Error("Invalid typeof value: " + type);
  }
});
var require_removeTypeDuplicates = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = removeTypeDuplicates;
  var _index = require_generated();
  function getQualifiedName(node) {
    return (0, _index.isIdentifier)(node) ? node.name : `${node.id.name}.${getQualifiedName(node.qualification)}`;
  }
  function removeTypeDuplicates(nodesIn) {
    const nodes = Array.from(nodesIn);
    const generics = new Map;
    const bases = new Map;
    const typeGroups = new Set;
    const types3 = [];
    for (let i = 0;i < nodes.length; i++) {
      const node = nodes[i];
      if (!node)
        continue;
      if (types3.includes(node)) {
        continue;
      }
      if ((0, _index.isAnyTypeAnnotation)(node)) {
        return [node];
      }
      if ((0, _index.isFlowBaseAnnotation)(node)) {
        bases.set(node.type, node);
        continue;
      }
      if ((0, _index.isUnionTypeAnnotation)(node)) {
        if (!typeGroups.has(node.types)) {
          nodes.push(...node.types);
          typeGroups.add(node.types);
        }
        continue;
      }
      if ((0, _index.isGenericTypeAnnotation)(node)) {
        const name = getQualifiedName(node.id);
        if (generics.has(name)) {
          let existing = generics.get(name);
          if (existing.typeParameters) {
            if (node.typeParameters) {
              existing.typeParameters.params.push(...node.typeParameters.params);
              existing.typeParameters.params = removeTypeDuplicates(existing.typeParameters.params);
            }
          } else {
            existing = node.typeParameters;
          }
        } else {
          generics.set(name, node);
        }
        continue;
      }
      types3.push(node);
    }
    for (const [, baseType] of bases) {
      types3.push(baseType);
    }
    for (const [, genericName] of generics) {
      types3.push(genericName);
    }
    return types3;
  }
});
var require_createFlowUnionType = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = createFlowUnionType;
  var _index = require_generated2();
  var _removeTypeDuplicates = require_removeTypeDuplicates();
  function createFlowUnionType(types3) {
    const flattened = (0, _removeTypeDuplicates.default)(types3);
    if (flattened.length === 1) {
      return flattened[0];
    } else {
      return (0, _index.unionTypeAnnotation)(flattened);
    }
  }
});
var require_removeTypeDuplicates2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = removeTypeDuplicates;
  var _index = require_generated();
  function getQualifiedName(node) {
    return (0, _index.isIdentifier)(node) ? node.name : `${node.right.name}.${getQualifiedName(node.left)}`;
  }
  function removeTypeDuplicates(nodesIn) {
    const nodes = Array.from(nodesIn);
    const generics = new Map;
    const bases = new Map;
    const typeGroups = new Set;
    const types3 = [];
    for (let i = 0;i < nodes.length; i++) {
      const node = nodes[i];
      if (!node)
        continue;
      if (types3.includes(node)) {
        continue;
      }
      if ((0, _index.isTSAnyKeyword)(node)) {
        return [node];
      }
      if ((0, _index.isTSBaseType)(node)) {
        bases.set(node.type, node);
        continue;
      }
      if ((0, _index.isTSUnionType)(node)) {
        if (!typeGroups.has(node.types)) {
          nodes.push(...node.types);
          typeGroups.add(node.types);
        }
        continue;
      }
      if ((0, _index.isTSTypeReference)(node) && node.typeParameters) {
        const name = getQualifiedName(node.typeName);
        if (generics.has(name)) {
          let existing = generics.get(name);
          if (existing.typeParameters) {
            if (node.typeParameters) {
              existing.typeParameters.params.push(...node.typeParameters.params);
              existing.typeParameters.params = removeTypeDuplicates(existing.typeParameters.params);
            }
          } else {
            existing = node.typeParameters;
          }
        } else {
          generics.set(name, node);
        }
        continue;
      }
      types3.push(node);
    }
    for (const [, baseType] of bases) {
      types3.push(baseType);
    }
    for (const [, genericName] of generics) {
      types3.push(genericName);
    }
    return types3;
  }
});
var require_createTSUnionType = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = createTSUnionType;
  var _index = require_generated2();
  var _removeTypeDuplicates = require_removeTypeDuplicates2();
  var _index2 = require_generated();
  function createTSUnionType(typeAnnotations) {
    const types3 = typeAnnotations.map((type) => {
      return (0, _index2.isTSTypeAnnotation)(type) ? type.typeAnnotation : type;
    });
    const flattened = (0, _removeTypeDuplicates.default)(types3);
    if (flattened.length === 1) {
      return flattened[0];
    } else {
      return (0, _index.tsUnionType)(flattened);
    }
  }
});
var require_uppercase = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "AnyTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.anyTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "ArgumentPlaceholder", {
    enumerable: true,
    get: function() {
      return _index.argumentPlaceholder;
    }
  });
  Object.defineProperty(exports, "ArrayExpression", {
    enumerable: true,
    get: function() {
      return _index.arrayExpression;
    }
  });
  Object.defineProperty(exports, "ArrayPattern", {
    enumerable: true,
    get: function() {
      return _index.arrayPattern;
    }
  });
  Object.defineProperty(exports, "ArrayTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.arrayTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "ArrowFunctionExpression", {
    enumerable: true,
    get: function() {
      return _index.arrowFunctionExpression;
    }
  });
  Object.defineProperty(exports, "AssignmentExpression", {
    enumerable: true,
    get: function() {
      return _index.assignmentExpression;
    }
  });
  Object.defineProperty(exports, "AssignmentPattern", {
    enumerable: true,
    get: function() {
      return _index.assignmentPattern;
    }
  });
  Object.defineProperty(exports, "AwaitExpression", {
    enumerable: true,
    get: function() {
      return _index.awaitExpression;
    }
  });
  Object.defineProperty(exports, "BigIntLiteral", {
    enumerable: true,
    get: function() {
      return _index.bigIntLiteral;
    }
  });
  Object.defineProperty(exports, "BinaryExpression", {
    enumerable: true,
    get: function() {
      return _index.binaryExpression;
    }
  });
  Object.defineProperty(exports, "BindExpression", {
    enumerable: true,
    get: function() {
      return _index.bindExpression;
    }
  });
  Object.defineProperty(exports, "BlockStatement", {
    enumerable: true,
    get: function() {
      return _index.blockStatement;
    }
  });
  Object.defineProperty(exports, "BooleanLiteral", {
    enumerable: true,
    get: function() {
      return _index.booleanLiteral;
    }
  });
  Object.defineProperty(exports, "BooleanLiteralTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.booleanLiteralTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "BooleanTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.booleanTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "BreakStatement", {
    enumerable: true,
    get: function() {
      return _index.breakStatement;
    }
  });
  Object.defineProperty(exports, "CallExpression", {
    enumerable: true,
    get: function() {
      return _index.callExpression;
    }
  });
  Object.defineProperty(exports, "CatchClause", {
    enumerable: true,
    get: function() {
      return _index.catchClause;
    }
  });
  Object.defineProperty(exports, "ClassAccessorProperty", {
    enumerable: true,
    get: function() {
      return _index.classAccessorProperty;
    }
  });
  Object.defineProperty(exports, "ClassBody", {
    enumerable: true,
    get: function() {
      return _index.classBody;
    }
  });
  Object.defineProperty(exports, "ClassDeclaration", {
    enumerable: true,
    get: function() {
      return _index.classDeclaration;
    }
  });
  Object.defineProperty(exports, "ClassExpression", {
    enumerable: true,
    get: function() {
      return _index.classExpression;
    }
  });
  Object.defineProperty(exports, "ClassImplements", {
    enumerable: true,
    get: function() {
      return _index.classImplements;
    }
  });
  Object.defineProperty(exports, "ClassMethod", {
    enumerable: true,
    get: function() {
      return _index.classMethod;
    }
  });
  Object.defineProperty(exports, "ClassPrivateMethod", {
    enumerable: true,
    get: function() {
      return _index.classPrivateMethod;
    }
  });
  Object.defineProperty(exports, "ClassPrivateProperty", {
    enumerable: true,
    get: function() {
      return _index.classPrivateProperty;
    }
  });
  Object.defineProperty(exports, "ClassProperty", {
    enumerable: true,
    get: function() {
      return _index.classProperty;
    }
  });
  Object.defineProperty(exports, "ConditionalExpression", {
    enumerable: true,
    get: function() {
      return _index.conditionalExpression;
    }
  });
  Object.defineProperty(exports, "ContinueStatement", {
    enumerable: true,
    get: function() {
      return _index.continueStatement;
    }
  });
  Object.defineProperty(exports, "DebuggerStatement", {
    enumerable: true,
    get: function() {
      return _index.debuggerStatement;
    }
  });
  Object.defineProperty(exports, "DecimalLiteral", {
    enumerable: true,
    get: function() {
      return _index.decimalLiteral;
    }
  });
  Object.defineProperty(exports, "DeclareClass", {
    enumerable: true,
    get: function() {
      return _index.declareClass;
    }
  });
  Object.defineProperty(exports, "DeclareExportAllDeclaration", {
    enumerable: true,
    get: function() {
      return _index.declareExportAllDeclaration;
    }
  });
  Object.defineProperty(exports, "DeclareExportDeclaration", {
    enumerable: true,
    get: function() {
      return _index.declareExportDeclaration;
    }
  });
  Object.defineProperty(exports, "DeclareFunction", {
    enumerable: true,
    get: function() {
      return _index.declareFunction;
    }
  });
  Object.defineProperty(exports, "DeclareInterface", {
    enumerable: true,
    get: function() {
      return _index.declareInterface;
    }
  });
  Object.defineProperty(exports, "DeclareModule", {
    enumerable: true,
    get: function() {
      return _index.declareModule;
    }
  });
  Object.defineProperty(exports, "DeclareModuleExports", {
    enumerable: true,
    get: function() {
      return _index.declareModuleExports;
    }
  });
  Object.defineProperty(exports, "DeclareOpaqueType", {
    enumerable: true,
    get: function() {
      return _index.declareOpaqueType;
    }
  });
  Object.defineProperty(exports, "DeclareTypeAlias", {
    enumerable: true,
    get: function() {
      return _index.declareTypeAlias;
    }
  });
  Object.defineProperty(exports, "DeclareVariable", {
    enumerable: true,
    get: function() {
      return _index.declareVariable;
    }
  });
  Object.defineProperty(exports, "DeclaredPredicate", {
    enumerable: true,
    get: function() {
      return _index.declaredPredicate;
    }
  });
  Object.defineProperty(exports, "Decorator", {
    enumerable: true,
    get: function() {
      return _index.decorator;
    }
  });
  Object.defineProperty(exports, "Directive", {
    enumerable: true,
    get: function() {
      return _index.directive;
    }
  });
  Object.defineProperty(exports, "DirectiveLiteral", {
    enumerable: true,
    get: function() {
      return _index.directiveLiteral;
    }
  });
  Object.defineProperty(exports, "DoExpression", {
    enumerable: true,
    get: function() {
      return _index.doExpression;
    }
  });
  Object.defineProperty(exports, "DoWhileStatement", {
    enumerable: true,
    get: function() {
      return _index.doWhileStatement;
    }
  });
  Object.defineProperty(exports, "EmptyStatement", {
    enumerable: true,
    get: function() {
      return _index.emptyStatement;
    }
  });
  Object.defineProperty(exports, "EmptyTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.emptyTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "EnumBooleanBody", {
    enumerable: true,
    get: function() {
      return _index.enumBooleanBody;
    }
  });
  Object.defineProperty(exports, "EnumBooleanMember", {
    enumerable: true,
    get: function() {
      return _index.enumBooleanMember;
    }
  });
  Object.defineProperty(exports, "EnumDeclaration", {
    enumerable: true,
    get: function() {
      return _index.enumDeclaration;
    }
  });
  Object.defineProperty(exports, "EnumDefaultedMember", {
    enumerable: true,
    get: function() {
      return _index.enumDefaultedMember;
    }
  });
  Object.defineProperty(exports, "EnumNumberBody", {
    enumerable: true,
    get: function() {
      return _index.enumNumberBody;
    }
  });
  Object.defineProperty(exports, "EnumNumberMember", {
    enumerable: true,
    get: function() {
      return _index.enumNumberMember;
    }
  });
  Object.defineProperty(exports, "EnumStringBody", {
    enumerable: true,
    get: function() {
      return _index.enumStringBody;
    }
  });
  Object.defineProperty(exports, "EnumStringMember", {
    enumerable: true,
    get: function() {
      return _index.enumStringMember;
    }
  });
  Object.defineProperty(exports, "EnumSymbolBody", {
    enumerable: true,
    get: function() {
      return _index.enumSymbolBody;
    }
  });
  Object.defineProperty(exports, "ExistsTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.existsTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "ExportAllDeclaration", {
    enumerable: true,
    get: function() {
      return _index.exportAllDeclaration;
    }
  });
  Object.defineProperty(exports, "ExportDefaultDeclaration", {
    enumerable: true,
    get: function() {
      return _index.exportDefaultDeclaration;
    }
  });
  Object.defineProperty(exports, "ExportDefaultSpecifier", {
    enumerable: true,
    get: function() {
      return _index.exportDefaultSpecifier;
    }
  });
  Object.defineProperty(exports, "ExportNamedDeclaration", {
    enumerable: true,
    get: function() {
      return _index.exportNamedDeclaration;
    }
  });
  Object.defineProperty(exports, "ExportNamespaceSpecifier", {
    enumerable: true,
    get: function() {
      return _index.exportNamespaceSpecifier;
    }
  });
  Object.defineProperty(exports, "ExportSpecifier", {
    enumerable: true,
    get: function() {
      return _index.exportSpecifier;
    }
  });
  Object.defineProperty(exports, "ExpressionStatement", {
    enumerable: true,
    get: function() {
      return _index.expressionStatement;
    }
  });
  Object.defineProperty(exports, "File", {
    enumerable: true,
    get: function() {
      return _index.file;
    }
  });
  Object.defineProperty(exports, "ForInStatement", {
    enumerable: true,
    get: function() {
      return _index.forInStatement;
    }
  });
  Object.defineProperty(exports, "ForOfStatement", {
    enumerable: true,
    get: function() {
      return _index.forOfStatement;
    }
  });
  Object.defineProperty(exports, "ForStatement", {
    enumerable: true,
    get: function() {
      return _index.forStatement;
    }
  });
  Object.defineProperty(exports, "FunctionDeclaration", {
    enumerable: true,
    get: function() {
      return _index.functionDeclaration;
    }
  });
  Object.defineProperty(exports, "FunctionExpression", {
    enumerable: true,
    get: function() {
      return _index.functionExpression;
    }
  });
  Object.defineProperty(exports, "FunctionTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.functionTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "FunctionTypeParam", {
    enumerable: true,
    get: function() {
      return _index.functionTypeParam;
    }
  });
  Object.defineProperty(exports, "GenericTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.genericTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "Identifier", {
    enumerable: true,
    get: function() {
      return _index.identifier;
    }
  });
  Object.defineProperty(exports, "IfStatement", {
    enumerable: true,
    get: function() {
      return _index.ifStatement;
    }
  });
  Object.defineProperty(exports, "Import", {
    enumerable: true,
    get: function() {
      return _index.import;
    }
  });
  Object.defineProperty(exports, "ImportAttribute", {
    enumerable: true,
    get: function() {
      return _index.importAttribute;
    }
  });
  Object.defineProperty(exports, "ImportDeclaration", {
    enumerable: true,
    get: function() {
      return _index.importDeclaration;
    }
  });
  Object.defineProperty(exports, "ImportDefaultSpecifier", {
    enumerable: true,
    get: function() {
      return _index.importDefaultSpecifier;
    }
  });
  Object.defineProperty(exports, "ImportExpression", {
    enumerable: true,
    get: function() {
      return _index.importExpression;
    }
  });
  Object.defineProperty(exports, "ImportNamespaceSpecifier", {
    enumerable: true,
    get: function() {
      return _index.importNamespaceSpecifier;
    }
  });
  Object.defineProperty(exports, "ImportSpecifier", {
    enumerable: true,
    get: function() {
      return _index.importSpecifier;
    }
  });
  Object.defineProperty(exports, "IndexedAccessType", {
    enumerable: true,
    get: function() {
      return _index.indexedAccessType;
    }
  });
  Object.defineProperty(exports, "InferredPredicate", {
    enumerable: true,
    get: function() {
      return _index.inferredPredicate;
    }
  });
  Object.defineProperty(exports, "InterfaceDeclaration", {
    enumerable: true,
    get: function() {
      return _index.interfaceDeclaration;
    }
  });
  Object.defineProperty(exports, "InterfaceExtends", {
    enumerable: true,
    get: function() {
      return _index.interfaceExtends;
    }
  });
  Object.defineProperty(exports, "InterfaceTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.interfaceTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "InterpreterDirective", {
    enumerable: true,
    get: function() {
      return _index.interpreterDirective;
    }
  });
  Object.defineProperty(exports, "IntersectionTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.intersectionTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "JSXAttribute", {
    enumerable: true,
    get: function() {
      return _index.jsxAttribute;
    }
  });
  Object.defineProperty(exports, "JSXClosingElement", {
    enumerable: true,
    get: function() {
      return _index.jsxClosingElement;
    }
  });
  Object.defineProperty(exports, "JSXClosingFragment", {
    enumerable: true,
    get: function() {
      return _index.jsxClosingFragment;
    }
  });
  Object.defineProperty(exports, "JSXElement", {
    enumerable: true,
    get: function() {
      return _index.jsxElement;
    }
  });
  Object.defineProperty(exports, "JSXEmptyExpression", {
    enumerable: true,
    get: function() {
      return _index.jsxEmptyExpression;
    }
  });
  Object.defineProperty(exports, "JSXExpressionContainer", {
    enumerable: true,
    get: function() {
      return _index.jsxExpressionContainer;
    }
  });
  Object.defineProperty(exports, "JSXFragment", {
    enumerable: true,
    get: function() {
      return _index.jsxFragment;
    }
  });
  Object.defineProperty(exports, "JSXIdentifier", {
    enumerable: true,
    get: function() {
      return _index.jsxIdentifier;
    }
  });
  Object.defineProperty(exports, "JSXMemberExpression", {
    enumerable: true,
    get: function() {
      return _index.jsxMemberExpression;
    }
  });
  Object.defineProperty(exports, "JSXNamespacedName", {
    enumerable: true,
    get: function() {
      return _index.jsxNamespacedName;
    }
  });
  Object.defineProperty(exports, "JSXOpeningElement", {
    enumerable: true,
    get: function() {
      return _index.jsxOpeningElement;
    }
  });
  Object.defineProperty(exports, "JSXOpeningFragment", {
    enumerable: true,
    get: function() {
      return _index.jsxOpeningFragment;
    }
  });
  Object.defineProperty(exports, "JSXSpreadAttribute", {
    enumerable: true,
    get: function() {
      return _index.jsxSpreadAttribute;
    }
  });
  Object.defineProperty(exports, "JSXSpreadChild", {
    enumerable: true,
    get: function() {
      return _index.jsxSpreadChild;
    }
  });
  Object.defineProperty(exports, "JSXText", {
    enumerable: true,
    get: function() {
      return _index.jsxText;
    }
  });
  Object.defineProperty(exports, "LabeledStatement", {
    enumerable: true,
    get: function() {
      return _index.labeledStatement;
    }
  });
  Object.defineProperty(exports, "LogicalExpression", {
    enumerable: true,
    get: function() {
      return _index.logicalExpression;
    }
  });
  Object.defineProperty(exports, "MemberExpression", {
    enumerable: true,
    get: function() {
      return _index.memberExpression;
    }
  });
  Object.defineProperty(exports, "MetaProperty", {
    enumerable: true,
    get: function() {
      return _index.metaProperty;
    }
  });
  Object.defineProperty(exports, "MixedTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.mixedTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "ModuleExpression", {
    enumerable: true,
    get: function() {
      return _index.moduleExpression;
    }
  });
  Object.defineProperty(exports, "NewExpression", {
    enumerable: true,
    get: function() {
      return _index.newExpression;
    }
  });
  Object.defineProperty(exports, "Noop", {
    enumerable: true,
    get: function() {
      return _index.noop;
    }
  });
  Object.defineProperty(exports, "NullLiteral", {
    enumerable: true,
    get: function() {
      return _index.nullLiteral;
    }
  });
  Object.defineProperty(exports, "NullLiteralTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.nullLiteralTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "NullableTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.nullableTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "NumberLiteral", {
    enumerable: true,
    get: function() {
      return _index.numberLiteral;
    }
  });
  Object.defineProperty(exports, "NumberLiteralTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.numberLiteralTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "NumberTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.numberTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "NumericLiteral", {
    enumerable: true,
    get: function() {
      return _index.numericLiteral;
    }
  });
  Object.defineProperty(exports, "ObjectExpression", {
    enumerable: true,
    get: function() {
      return _index.objectExpression;
    }
  });
  Object.defineProperty(exports, "ObjectMethod", {
    enumerable: true,
    get: function() {
      return _index.objectMethod;
    }
  });
  Object.defineProperty(exports, "ObjectPattern", {
    enumerable: true,
    get: function() {
      return _index.objectPattern;
    }
  });
  Object.defineProperty(exports, "ObjectProperty", {
    enumerable: true,
    get: function() {
      return _index.objectProperty;
    }
  });
  Object.defineProperty(exports, "ObjectTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.objectTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "ObjectTypeCallProperty", {
    enumerable: true,
    get: function() {
      return _index.objectTypeCallProperty;
    }
  });
  Object.defineProperty(exports, "ObjectTypeIndexer", {
    enumerable: true,
    get: function() {
      return _index.objectTypeIndexer;
    }
  });
  Object.defineProperty(exports, "ObjectTypeInternalSlot", {
    enumerable: true,
    get: function() {
      return _index.objectTypeInternalSlot;
    }
  });
  Object.defineProperty(exports, "ObjectTypeProperty", {
    enumerable: true,
    get: function() {
      return _index.objectTypeProperty;
    }
  });
  Object.defineProperty(exports, "ObjectTypeSpreadProperty", {
    enumerable: true,
    get: function() {
      return _index.objectTypeSpreadProperty;
    }
  });
  Object.defineProperty(exports, "OpaqueType", {
    enumerable: true,
    get: function() {
      return _index.opaqueType;
    }
  });
  Object.defineProperty(exports, "OptionalCallExpression", {
    enumerable: true,
    get: function() {
      return _index.optionalCallExpression;
    }
  });
  Object.defineProperty(exports, "OptionalIndexedAccessType", {
    enumerable: true,
    get: function() {
      return _index.optionalIndexedAccessType;
    }
  });
  Object.defineProperty(exports, "OptionalMemberExpression", {
    enumerable: true,
    get: function() {
      return _index.optionalMemberExpression;
    }
  });
  Object.defineProperty(exports, "ParenthesizedExpression", {
    enumerable: true,
    get: function() {
      return _index.parenthesizedExpression;
    }
  });
  Object.defineProperty(exports, "PipelineBareFunction", {
    enumerable: true,
    get: function() {
      return _index.pipelineBareFunction;
    }
  });
  Object.defineProperty(exports, "PipelinePrimaryTopicReference", {
    enumerable: true,
    get: function() {
      return _index.pipelinePrimaryTopicReference;
    }
  });
  Object.defineProperty(exports, "PipelineTopicExpression", {
    enumerable: true,
    get: function() {
      return _index.pipelineTopicExpression;
    }
  });
  Object.defineProperty(exports, "Placeholder", {
    enumerable: true,
    get: function() {
      return _index.placeholder;
    }
  });
  Object.defineProperty(exports, "PrivateName", {
    enumerable: true,
    get: function() {
      return _index.privateName;
    }
  });
  Object.defineProperty(exports, "Program", {
    enumerable: true,
    get: function() {
      return _index.program;
    }
  });
  Object.defineProperty(exports, "QualifiedTypeIdentifier", {
    enumerable: true,
    get: function() {
      return _index.qualifiedTypeIdentifier;
    }
  });
  Object.defineProperty(exports, "RecordExpression", {
    enumerable: true,
    get: function() {
      return _index.recordExpression;
    }
  });
  Object.defineProperty(exports, "RegExpLiteral", {
    enumerable: true,
    get: function() {
      return _index.regExpLiteral;
    }
  });
  Object.defineProperty(exports, "RegexLiteral", {
    enumerable: true,
    get: function() {
      return _index.regexLiteral;
    }
  });
  Object.defineProperty(exports, "RestElement", {
    enumerable: true,
    get: function() {
      return _index.restElement;
    }
  });
  Object.defineProperty(exports, "RestProperty", {
    enumerable: true,
    get: function() {
      return _index.restProperty;
    }
  });
  Object.defineProperty(exports, "ReturnStatement", {
    enumerable: true,
    get: function() {
      return _index.returnStatement;
    }
  });
  Object.defineProperty(exports, "SequenceExpression", {
    enumerable: true,
    get: function() {
      return _index.sequenceExpression;
    }
  });
  Object.defineProperty(exports, "SpreadElement", {
    enumerable: true,
    get: function() {
      return _index.spreadElement;
    }
  });
  Object.defineProperty(exports, "SpreadProperty", {
    enumerable: true,
    get: function() {
      return _index.spreadProperty;
    }
  });
  Object.defineProperty(exports, "StaticBlock", {
    enumerable: true,
    get: function() {
      return _index.staticBlock;
    }
  });
  Object.defineProperty(exports, "StringLiteral", {
    enumerable: true,
    get: function() {
      return _index.stringLiteral;
    }
  });
  Object.defineProperty(exports, "StringLiteralTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.stringLiteralTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "StringTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.stringTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "Super", {
    enumerable: true,
    get: function() {
      return _index.super;
    }
  });
  Object.defineProperty(exports, "SwitchCase", {
    enumerable: true,
    get: function() {
      return _index.switchCase;
    }
  });
  Object.defineProperty(exports, "SwitchStatement", {
    enumerable: true,
    get: function() {
      return _index.switchStatement;
    }
  });
  Object.defineProperty(exports, "SymbolTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.symbolTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "TSAnyKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsAnyKeyword;
    }
  });
  Object.defineProperty(exports, "TSArrayType", {
    enumerable: true,
    get: function() {
      return _index.tsArrayType;
    }
  });
  Object.defineProperty(exports, "TSAsExpression", {
    enumerable: true,
    get: function() {
      return _index.tsAsExpression;
    }
  });
  Object.defineProperty(exports, "TSBigIntKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsBigIntKeyword;
    }
  });
  Object.defineProperty(exports, "TSBooleanKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsBooleanKeyword;
    }
  });
  Object.defineProperty(exports, "TSCallSignatureDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsCallSignatureDeclaration;
    }
  });
  Object.defineProperty(exports, "TSConditionalType", {
    enumerable: true,
    get: function() {
      return _index.tsConditionalType;
    }
  });
  Object.defineProperty(exports, "TSConstructSignatureDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsConstructSignatureDeclaration;
    }
  });
  Object.defineProperty(exports, "TSConstructorType", {
    enumerable: true,
    get: function() {
      return _index.tsConstructorType;
    }
  });
  Object.defineProperty(exports, "TSDeclareFunction", {
    enumerable: true,
    get: function() {
      return _index.tsDeclareFunction;
    }
  });
  Object.defineProperty(exports, "TSDeclareMethod", {
    enumerable: true,
    get: function() {
      return _index.tsDeclareMethod;
    }
  });
  Object.defineProperty(exports, "TSEnumDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsEnumDeclaration;
    }
  });
  Object.defineProperty(exports, "TSEnumMember", {
    enumerable: true,
    get: function() {
      return _index.tsEnumMember;
    }
  });
  Object.defineProperty(exports, "TSExportAssignment", {
    enumerable: true,
    get: function() {
      return _index.tsExportAssignment;
    }
  });
  Object.defineProperty(exports, "TSExpressionWithTypeArguments", {
    enumerable: true,
    get: function() {
      return _index.tsExpressionWithTypeArguments;
    }
  });
  Object.defineProperty(exports, "TSExternalModuleReference", {
    enumerable: true,
    get: function() {
      return _index.tsExternalModuleReference;
    }
  });
  Object.defineProperty(exports, "TSFunctionType", {
    enumerable: true,
    get: function() {
      return _index.tsFunctionType;
    }
  });
  Object.defineProperty(exports, "TSImportEqualsDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsImportEqualsDeclaration;
    }
  });
  Object.defineProperty(exports, "TSImportType", {
    enumerable: true,
    get: function() {
      return _index.tsImportType;
    }
  });
  Object.defineProperty(exports, "TSIndexSignature", {
    enumerable: true,
    get: function() {
      return _index.tsIndexSignature;
    }
  });
  Object.defineProperty(exports, "TSIndexedAccessType", {
    enumerable: true,
    get: function() {
      return _index.tsIndexedAccessType;
    }
  });
  Object.defineProperty(exports, "TSInferType", {
    enumerable: true,
    get: function() {
      return _index.tsInferType;
    }
  });
  Object.defineProperty(exports, "TSInstantiationExpression", {
    enumerable: true,
    get: function() {
      return _index.tsInstantiationExpression;
    }
  });
  Object.defineProperty(exports, "TSInterfaceBody", {
    enumerable: true,
    get: function() {
      return _index.tsInterfaceBody;
    }
  });
  Object.defineProperty(exports, "TSInterfaceDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsInterfaceDeclaration;
    }
  });
  Object.defineProperty(exports, "TSIntersectionType", {
    enumerable: true,
    get: function() {
      return _index.tsIntersectionType;
    }
  });
  Object.defineProperty(exports, "TSIntrinsicKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsIntrinsicKeyword;
    }
  });
  Object.defineProperty(exports, "TSLiteralType", {
    enumerable: true,
    get: function() {
      return _index.tsLiteralType;
    }
  });
  Object.defineProperty(exports, "TSMappedType", {
    enumerable: true,
    get: function() {
      return _index.tsMappedType;
    }
  });
  Object.defineProperty(exports, "TSMethodSignature", {
    enumerable: true,
    get: function() {
      return _index.tsMethodSignature;
    }
  });
  Object.defineProperty(exports, "TSModuleBlock", {
    enumerable: true,
    get: function() {
      return _index.tsModuleBlock;
    }
  });
  Object.defineProperty(exports, "TSModuleDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsModuleDeclaration;
    }
  });
  Object.defineProperty(exports, "TSNamedTupleMember", {
    enumerable: true,
    get: function() {
      return _index.tsNamedTupleMember;
    }
  });
  Object.defineProperty(exports, "TSNamespaceExportDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsNamespaceExportDeclaration;
    }
  });
  Object.defineProperty(exports, "TSNeverKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsNeverKeyword;
    }
  });
  Object.defineProperty(exports, "TSNonNullExpression", {
    enumerable: true,
    get: function() {
      return _index.tsNonNullExpression;
    }
  });
  Object.defineProperty(exports, "TSNullKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsNullKeyword;
    }
  });
  Object.defineProperty(exports, "TSNumberKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsNumberKeyword;
    }
  });
  Object.defineProperty(exports, "TSObjectKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsObjectKeyword;
    }
  });
  Object.defineProperty(exports, "TSOptionalType", {
    enumerable: true,
    get: function() {
      return _index.tsOptionalType;
    }
  });
  Object.defineProperty(exports, "TSParameterProperty", {
    enumerable: true,
    get: function() {
      return _index.tsParameterProperty;
    }
  });
  Object.defineProperty(exports, "TSParenthesizedType", {
    enumerable: true,
    get: function() {
      return _index.tsParenthesizedType;
    }
  });
  Object.defineProperty(exports, "TSPropertySignature", {
    enumerable: true,
    get: function() {
      return _index.tsPropertySignature;
    }
  });
  Object.defineProperty(exports, "TSQualifiedName", {
    enumerable: true,
    get: function() {
      return _index.tsQualifiedName;
    }
  });
  Object.defineProperty(exports, "TSRestType", {
    enumerable: true,
    get: function() {
      return _index.tsRestType;
    }
  });
  Object.defineProperty(exports, "TSSatisfiesExpression", {
    enumerable: true,
    get: function() {
      return _index.tsSatisfiesExpression;
    }
  });
  Object.defineProperty(exports, "TSStringKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsStringKeyword;
    }
  });
  Object.defineProperty(exports, "TSSymbolKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsSymbolKeyword;
    }
  });
  Object.defineProperty(exports, "TSThisType", {
    enumerable: true,
    get: function() {
      return _index.tsThisType;
    }
  });
  Object.defineProperty(exports, "TSTupleType", {
    enumerable: true,
    get: function() {
      return _index.tsTupleType;
    }
  });
  Object.defineProperty(exports, "TSTypeAliasDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsTypeAliasDeclaration;
    }
  });
  Object.defineProperty(exports, "TSTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.tsTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "TSTypeAssertion", {
    enumerable: true,
    get: function() {
      return _index.tsTypeAssertion;
    }
  });
  Object.defineProperty(exports, "TSTypeLiteral", {
    enumerable: true,
    get: function() {
      return _index.tsTypeLiteral;
    }
  });
  Object.defineProperty(exports, "TSTypeOperator", {
    enumerable: true,
    get: function() {
      return _index.tsTypeOperator;
    }
  });
  Object.defineProperty(exports, "TSTypeParameter", {
    enumerable: true,
    get: function() {
      return _index.tsTypeParameter;
    }
  });
  Object.defineProperty(exports, "TSTypeParameterDeclaration", {
    enumerable: true,
    get: function() {
      return _index.tsTypeParameterDeclaration;
    }
  });
  Object.defineProperty(exports, "TSTypeParameterInstantiation", {
    enumerable: true,
    get: function() {
      return _index.tsTypeParameterInstantiation;
    }
  });
  Object.defineProperty(exports, "TSTypePredicate", {
    enumerable: true,
    get: function() {
      return _index.tsTypePredicate;
    }
  });
  Object.defineProperty(exports, "TSTypeQuery", {
    enumerable: true,
    get: function() {
      return _index.tsTypeQuery;
    }
  });
  Object.defineProperty(exports, "TSTypeReference", {
    enumerable: true,
    get: function() {
      return _index.tsTypeReference;
    }
  });
  Object.defineProperty(exports, "TSUndefinedKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsUndefinedKeyword;
    }
  });
  Object.defineProperty(exports, "TSUnionType", {
    enumerable: true,
    get: function() {
      return _index.tsUnionType;
    }
  });
  Object.defineProperty(exports, "TSUnknownKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsUnknownKeyword;
    }
  });
  Object.defineProperty(exports, "TSVoidKeyword", {
    enumerable: true,
    get: function() {
      return _index.tsVoidKeyword;
    }
  });
  Object.defineProperty(exports, "TaggedTemplateExpression", {
    enumerable: true,
    get: function() {
      return _index.taggedTemplateExpression;
    }
  });
  Object.defineProperty(exports, "TemplateElement", {
    enumerable: true,
    get: function() {
      return _index.templateElement;
    }
  });
  Object.defineProperty(exports, "TemplateLiteral", {
    enumerable: true,
    get: function() {
      return _index.templateLiteral;
    }
  });
  Object.defineProperty(exports, "ThisExpression", {
    enumerable: true,
    get: function() {
      return _index.thisExpression;
    }
  });
  Object.defineProperty(exports, "ThisTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.thisTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "ThrowStatement", {
    enumerable: true,
    get: function() {
      return _index.throwStatement;
    }
  });
  Object.defineProperty(exports, "TopicReference", {
    enumerable: true,
    get: function() {
      return _index.topicReference;
    }
  });
  Object.defineProperty(exports, "TryStatement", {
    enumerable: true,
    get: function() {
      return _index.tryStatement;
    }
  });
  Object.defineProperty(exports, "TupleExpression", {
    enumerable: true,
    get: function() {
      return _index.tupleExpression;
    }
  });
  Object.defineProperty(exports, "TupleTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.tupleTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "TypeAlias", {
    enumerable: true,
    get: function() {
      return _index.typeAlias;
    }
  });
  Object.defineProperty(exports, "TypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.typeAnnotation;
    }
  });
  Object.defineProperty(exports, "TypeCastExpression", {
    enumerable: true,
    get: function() {
      return _index.typeCastExpression;
    }
  });
  Object.defineProperty(exports, "TypeParameter", {
    enumerable: true,
    get: function() {
      return _index.typeParameter;
    }
  });
  Object.defineProperty(exports, "TypeParameterDeclaration", {
    enumerable: true,
    get: function() {
      return _index.typeParameterDeclaration;
    }
  });
  Object.defineProperty(exports, "TypeParameterInstantiation", {
    enumerable: true,
    get: function() {
      return _index.typeParameterInstantiation;
    }
  });
  Object.defineProperty(exports, "TypeofTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.typeofTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "UnaryExpression", {
    enumerable: true,
    get: function() {
      return _index.unaryExpression;
    }
  });
  Object.defineProperty(exports, "UnionTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.unionTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "UpdateExpression", {
    enumerable: true,
    get: function() {
      return _index.updateExpression;
    }
  });
  Object.defineProperty(exports, "V8IntrinsicIdentifier", {
    enumerable: true,
    get: function() {
      return _index.v8IntrinsicIdentifier;
    }
  });
  Object.defineProperty(exports, "VariableDeclaration", {
    enumerable: true,
    get: function() {
      return _index.variableDeclaration;
    }
  });
  Object.defineProperty(exports, "VariableDeclarator", {
    enumerable: true,
    get: function() {
      return _index.variableDeclarator;
    }
  });
  Object.defineProperty(exports, "Variance", {
    enumerable: true,
    get: function() {
      return _index.variance;
    }
  });
  Object.defineProperty(exports, "VoidTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _index.voidTypeAnnotation;
    }
  });
  Object.defineProperty(exports, "WhileStatement", {
    enumerable: true,
    get: function() {
      return _index.whileStatement;
    }
  });
  Object.defineProperty(exports, "WithStatement", {
    enumerable: true,
    get: function() {
      return _index.withStatement;
    }
  });
  Object.defineProperty(exports, "YieldExpression", {
    enumerable: true,
    get: function() {
      return _index.yieldExpression;
    }
  });
  var _index = require_generated2();
});
var require_productions = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.buildUndefinedNode = buildUndefinedNode;
  var _index = require_generated2();
  function buildUndefinedNode() {
    return (0, _index.unaryExpression)("void", (0, _index.numericLiteral)(0), true);
  }
});
var require_cloneNode = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = cloneNode;
  var _index = require_definitions();
  var _index2 = require_generated();
  var {
    hasOwn
  } = {
    hasOwn: Function.call.bind(Object.prototype.hasOwnProperty)
  };
  function cloneIfNode(obj, deep, withoutLoc, commentsCache) {
    if (obj && typeof obj.type === "string") {
      return cloneNodeInternal(obj, deep, withoutLoc, commentsCache);
    }
    return obj;
  }
  function cloneIfNodeOrArray(obj, deep, withoutLoc, commentsCache) {
    if (Array.isArray(obj)) {
      return obj.map((node) => cloneIfNode(node, deep, withoutLoc, commentsCache));
    }
    return cloneIfNode(obj, deep, withoutLoc, commentsCache);
  }
  function cloneNode(node, deep = true, withoutLoc = false) {
    return cloneNodeInternal(node, deep, withoutLoc, new Map);
  }
  function cloneNodeInternal(node, deep = true, withoutLoc = false, commentsCache) {
    if (!node)
      return node;
    const {
      type
    } = node;
    const newNode = {
      type: node.type
    };
    if ((0, _index2.isIdentifier)(node)) {
      newNode.name = node.name;
      if (hasOwn(node, "optional") && typeof node.optional === "boolean") {
        newNode.optional = node.optional;
      }
      if (hasOwn(node, "typeAnnotation")) {
        newNode.typeAnnotation = deep ? cloneIfNodeOrArray(node.typeAnnotation, true, withoutLoc, commentsCache) : node.typeAnnotation;
      }
      if (hasOwn(node, "decorators")) {
        newNode.decorators = deep ? cloneIfNodeOrArray(node.decorators, true, withoutLoc, commentsCache) : node.decorators;
      }
    } else if (!hasOwn(_index.NODE_FIELDS, type)) {
      throw new Error(`Unknown node type: "${type}"`);
    } else {
      for (const field of Object.keys(_index.NODE_FIELDS[type])) {
        if (hasOwn(node, field)) {
          if (deep) {
            newNode[field] = (0, _index2.isFile)(node) && field === "comments" ? maybeCloneComments(node.comments, deep, withoutLoc, commentsCache) : cloneIfNodeOrArray(node[field], true, withoutLoc, commentsCache);
          } else {
            newNode[field] = node[field];
          }
        }
      }
    }
    if (hasOwn(node, "loc")) {
      if (withoutLoc) {
        newNode.loc = null;
      } else {
        newNode.loc = node.loc;
      }
    }
    if (hasOwn(node, "leadingComments")) {
      newNode.leadingComments = maybeCloneComments(node.leadingComments, deep, withoutLoc, commentsCache);
    }
    if (hasOwn(node, "innerComments")) {
      newNode.innerComments = maybeCloneComments(node.innerComments, deep, withoutLoc, commentsCache);
    }
    if (hasOwn(node, "trailingComments")) {
      newNode.trailingComments = maybeCloneComments(node.trailingComments, deep, withoutLoc, commentsCache);
    }
    if (hasOwn(node, "extra")) {
      newNode.extra = Object.assign({}, node.extra);
    }
    return newNode;
  }
  function maybeCloneComments(comments, deep, withoutLoc, commentsCache) {
    if (!comments || !deep) {
      return comments;
    }
    return comments.map((comment) => {
      const cache3 = commentsCache.get(comment);
      if (cache3)
        return cache3;
      const {
        type,
        value,
        loc
      } = comment;
      const ret = {
        type,
        value,
        loc
      };
      if (withoutLoc) {
        ret.loc = null;
      }
      commentsCache.set(comment, ret);
      return ret;
    });
  }
});
var require_clone2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = clone3;
  var _cloneNode = require_cloneNode();
  function clone3(node) {
    return (0, _cloneNode.default)(node, false);
  }
});
var require_cloneDeep = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = cloneDeep;
  var _cloneNode = require_cloneNode();
  function cloneDeep(node) {
    return (0, _cloneNode.default)(node);
  }
});
var require_cloneDeepWithoutLoc = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = cloneDeepWithoutLoc;
  var _cloneNode = require_cloneNode();
  function cloneDeepWithoutLoc(node) {
    return (0, _cloneNode.default)(node, true, true);
  }
});
var require_cloneWithoutLoc = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = cloneWithoutLoc;
  var _cloneNode = require_cloneNode();
  function cloneWithoutLoc(node) {
    return (0, _cloneNode.default)(node, false, true);
  }
});
var require_addComments = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = addComments;
  function addComments(node, type, comments) {
    if (!comments || !node)
      return node;
    const key = `${type}Comments`;
    if (node[key]) {
      if (type === "leading") {
        node[key] = comments.concat(node[key]);
      } else {
        node[key].push(...comments);
      }
    } else {
      node[key] = comments;
    }
    return node;
  }
});
var require_addComment = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = addComment;
  var _addComments = require_addComments();
  function addComment(node, type, content, line) {
    return (0, _addComments.default)(node, type, [{
      type: line ? "CommentLine" : "CommentBlock",
      value: content
    }]);
  }
});
var require_inherit = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = inherit;
  function inherit(key, child, parent) {
    if (child && parent) {
      child[key] = Array.from(new Set([].concat(child[key], parent[key]).filter(Boolean)));
    }
  }
});
var require_inheritInnerComments = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = inheritInnerComments;
  var _inherit = require_inherit();
  function inheritInnerComments(child, parent) {
    (0, _inherit.default)("innerComments", child, parent);
  }
});
var require_inheritLeadingComments = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = inheritLeadingComments;
  var _inherit = require_inherit();
  function inheritLeadingComments(child, parent) {
    (0, _inherit.default)("leadingComments", child, parent);
  }
});
var require_inheritTrailingComments = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = inheritTrailingComments;
  var _inherit = require_inherit();
  function inheritTrailingComments(child, parent) {
    (0, _inherit.default)("trailingComments", child, parent);
  }
});
var require_inheritsComments = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = inheritsComments;
  var _inheritTrailingComments = require_inheritTrailingComments();
  var _inheritLeadingComments = require_inheritLeadingComments();
  var _inheritInnerComments = require_inheritInnerComments();
  function inheritsComments(child, parent) {
    (0, _inheritTrailingComments.default)(child, parent);
    (0, _inheritLeadingComments.default)(child, parent);
    (0, _inheritInnerComments.default)(child, parent);
    return child;
  }
});
var require_removeComments = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = removeComments;
  var _index = require_constants();
  function removeComments(node) {
    _index.COMMENT_KEYS.forEach((key) => {
      node[key] = null;
    });
    return node;
  }
});
var require_generated4 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.WHILE_TYPES = exports.USERWHITESPACABLE_TYPES = exports.UNARYLIKE_TYPES = exports.TYPESCRIPT_TYPES = exports.TSTYPE_TYPES = exports.TSTYPEELEMENT_TYPES = exports.TSENTITYNAME_TYPES = exports.TSBASETYPE_TYPES = exports.TERMINATORLESS_TYPES = exports.STATEMENT_TYPES = exports.STANDARDIZED_TYPES = exports.SCOPABLE_TYPES = exports.PUREISH_TYPES = exports.PROPERTY_TYPES = exports.PRIVATE_TYPES = exports.PATTERN_TYPES = exports.PATTERNLIKE_TYPES = exports.OBJECTMEMBER_TYPES = exports.MODULESPECIFIER_TYPES = exports.MODULEDECLARATION_TYPES = exports.MISCELLANEOUS_TYPES = exports.METHOD_TYPES = exports.LVAL_TYPES = exports.LOOP_TYPES = exports.LITERAL_TYPES = exports.JSX_TYPES = exports.IMPORTOREXPORTDECLARATION_TYPES = exports.IMMUTABLE_TYPES = exports.FUNCTION_TYPES = exports.FUNCTIONPARENT_TYPES = exports.FOR_TYPES = exports.FORXSTATEMENT_TYPES = exports.FLOW_TYPES = exports.FLOWTYPE_TYPES = exports.FLOWPREDICATE_TYPES = exports.FLOWDECLARATION_TYPES = exports.FLOWBASEANNOTATION_TYPES = exports.EXPRESSION_TYPES = exports.EXPRESSIONWRAPPER_TYPES = exports.EXPORTDECLARATION_TYPES = exports.ENUMMEMBER_TYPES = exports.ENUMBODY_TYPES = exports.DECLARATION_TYPES = exports.CONDITIONAL_TYPES = exports.COMPLETIONSTATEMENT_TYPES = exports.CLASS_TYPES = exports.BLOCK_TYPES = exports.BLOCKPARENT_TYPES = exports.BINARY_TYPES = exports.ACCESSOR_TYPES = undefined;
  var _index = require_definitions();
  var STANDARDIZED_TYPES = exports.STANDARDIZED_TYPES = _index.FLIPPED_ALIAS_KEYS["Standardized"];
  var EXPRESSION_TYPES = exports.EXPRESSION_TYPES = _index.FLIPPED_ALIAS_KEYS["Expression"];
  var BINARY_TYPES = exports.BINARY_TYPES = _index.FLIPPED_ALIAS_KEYS["Binary"];
  var SCOPABLE_TYPES = exports.SCOPABLE_TYPES = _index.FLIPPED_ALIAS_KEYS["Scopable"];
  var BLOCKPARENT_TYPES = exports.BLOCKPARENT_TYPES = _index.FLIPPED_ALIAS_KEYS["BlockParent"];
  var BLOCK_TYPES = exports.BLOCK_TYPES = _index.FLIPPED_ALIAS_KEYS["Block"];
  var STATEMENT_TYPES = exports.STATEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["Statement"];
  var TERMINATORLESS_TYPES = exports.TERMINATORLESS_TYPES = _index.FLIPPED_ALIAS_KEYS["Terminatorless"];
  var COMPLETIONSTATEMENT_TYPES = exports.COMPLETIONSTATEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["CompletionStatement"];
  var CONDITIONAL_TYPES = exports.CONDITIONAL_TYPES = _index.FLIPPED_ALIAS_KEYS["Conditional"];
  var LOOP_TYPES = exports.LOOP_TYPES = _index.FLIPPED_ALIAS_KEYS["Loop"];
  var WHILE_TYPES = exports.WHILE_TYPES = _index.FLIPPED_ALIAS_KEYS["While"];
  var EXPRESSIONWRAPPER_TYPES = exports.EXPRESSIONWRAPPER_TYPES = _index.FLIPPED_ALIAS_KEYS["ExpressionWrapper"];
  var FOR_TYPES = exports.FOR_TYPES = _index.FLIPPED_ALIAS_KEYS["For"];
  var FORXSTATEMENT_TYPES = exports.FORXSTATEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["ForXStatement"];
  var FUNCTION_TYPES = exports.FUNCTION_TYPES = _index.FLIPPED_ALIAS_KEYS["Function"];
  var FUNCTIONPARENT_TYPES = exports.FUNCTIONPARENT_TYPES = _index.FLIPPED_ALIAS_KEYS["FunctionParent"];
  var PUREISH_TYPES = exports.PUREISH_TYPES = _index.FLIPPED_ALIAS_KEYS["Pureish"];
  var DECLARATION_TYPES = exports.DECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["Declaration"];
  var PATTERNLIKE_TYPES = exports.PATTERNLIKE_TYPES = _index.FLIPPED_ALIAS_KEYS["PatternLike"];
  var LVAL_TYPES = exports.LVAL_TYPES = _index.FLIPPED_ALIAS_KEYS["LVal"];
  var TSENTITYNAME_TYPES = exports.TSENTITYNAME_TYPES = _index.FLIPPED_ALIAS_KEYS["TSEntityName"];
  var LITERAL_TYPES = exports.LITERAL_TYPES = _index.FLIPPED_ALIAS_KEYS["Literal"];
  var IMMUTABLE_TYPES = exports.IMMUTABLE_TYPES = _index.FLIPPED_ALIAS_KEYS["Immutable"];
  var USERWHITESPACABLE_TYPES = exports.USERWHITESPACABLE_TYPES = _index.FLIPPED_ALIAS_KEYS["UserWhitespacable"];
  var METHOD_TYPES = exports.METHOD_TYPES = _index.FLIPPED_ALIAS_KEYS["Method"];
  var OBJECTMEMBER_TYPES = exports.OBJECTMEMBER_TYPES = _index.FLIPPED_ALIAS_KEYS["ObjectMember"];
  var PROPERTY_TYPES = exports.PROPERTY_TYPES = _index.FLIPPED_ALIAS_KEYS["Property"];
  var UNARYLIKE_TYPES = exports.UNARYLIKE_TYPES = _index.FLIPPED_ALIAS_KEYS["UnaryLike"];
  var PATTERN_TYPES = exports.PATTERN_TYPES = _index.FLIPPED_ALIAS_KEYS["Pattern"];
  var CLASS_TYPES = exports.CLASS_TYPES = _index.FLIPPED_ALIAS_KEYS["Class"];
  var IMPORTOREXPORTDECLARATION_TYPES = exports.IMPORTOREXPORTDECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["ImportOrExportDeclaration"];
  var EXPORTDECLARATION_TYPES = exports.EXPORTDECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["ExportDeclaration"];
  var MODULESPECIFIER_TYPES = exports.MODULESPECIFIER_TYPES = _index.FLIPPED_ALIAS_KEYS["ModuleSpecifier"];
  var ACCESSOR_TYPES = exports.ACCESSOR_TYPES = _index.FLIPPED_ALIAS_KEYS["Accessor"];
  var PRIVATE_TYPES = exports.PRIVATE_TYPES = _index.FLIPPED_ALIAS_KEYS["Private"];
  var FLOW_TYPES = exports.FLOW_TYPES = _index.FLIPPED_ALIAS_KEYS["Flow"];
  var FLOWTYPE_TYPES = exports.FLOWTYPE_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowType"];
  var FLOWBASEANNOTATION_TYPES = exports.FLOWBASEANNOTATION_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowBaseAnnotation"];
  var FLOWDECLARATION_TYPES = exports.FLOWDECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowDeclaration"];
  var FLOWPREDICATE_TYPES = exports.FLOWPREDICATE_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowPredicate"];
  var ENUMBODY_TYPES = exports.ENUMBODY_TYPES = _index.FLIPPED_ALIAS_KEYS["EnumBody"];
  var ENUMMEMBER_TYPES = exports.ENUMMEMBER_TYPES = _index.FLIPPED_ALIAS_KEYS["EnumMember"];
  var JSX_TYPES = exports.JSX_TYPES = _index.FLIPPED_ALIAS_KEYS["JSX"];
  var MISCELLANEOUS_TYPES = exports.MISCELLANEOUS_TYPES = _index.FLIPPED_ALIAS_KEYS["Miscellaneous"];
  var TYPESCRIPT_TYPES = exports.TYPESCRIPT_TYPES = _index.FLIPPED_ALIAS_KEYS["TypeScript"];
  var TSTYPEELEMENT_TYPES = exports.TSTYPEELEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["TSTypeElement"];
  var TSTYPE_TYPES = exports.TSTYPE_TYPES = _index.FLIPPED_ALIAS_KEYS["TSType"];
  var TSBASETYPE_TYPES = exports.TSBASETYPE_TYPES = _index.FLIPPED_ALIAS_KEYS["TSBaseType"];
  var MODULEDECLARATION_TYPES = exports.MODULEDECLARATION_TYPES = IMPORTOREXPORTDECLARATION_TYPES;
});
var require_toBlock = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = toBlock;
  var _index = require_generated();
  var _index2 = require_generated2();
  function toBlock(node, parent) {
    if ((0, _index.isBlockStatement)(node)) {
      return node;
    }
    let blockNodes = [];
    if ((0, _index.isEmptyStatement)(node)) {
      blockNodes = [];
    } else {
      if (!(0, _index.isStatement)(node)) {
        if ((0, _index.isFunction)(parent)) {
          node = (0, _index2.returnStatement)(node);
        } else {
          node = (0, _index2.expressionStatement)(node);
        }
      }
      blockNodes = [node];
    }
    return (0, _index2.blockStatement)(blockNodes);
  }
});
var require_ensureBlock = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = ensureBlock;
  var _toBlock = require_toBlock();
  function ensureBlock(node, key = "body") {
    const result2 = (0, _toBlock.default)(node[key], node);
    node[key] = result2;
    return result2;
  }
});
var require_toIdentifier = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = toIdentifier;
  var _isValidIdentifier = require_isValidIdentifier();
  var _helperValidatorIdentifier = require_lib4();
  function toIdentifier(input) {
    input = input + "";
    let name = "";
    for (const c22 of input) {
      name += (0, _helperValidatorIdentifier.isIdentifierChar)(c22.codePointAt(0)) ? c22 : "-";
    }
    name = name.replace(/^[-0-9]+/, "");
    name = name.replace(/[-\s]+(.)?/g, function(match, c22) {
      return c22 ? c22.toUpperCase() : "";
    });
    if (!(0, _isValidIdentifier.default)(name)) {
      name = `_${name}`;
    }
    return name || "_";
  }
});
var require_toBindingIdentifierName = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = toBindingIdentifierName;
  var _toIdentifier = require_toIdentifier();
  function toBindingIdentifierName(name) {
    name = (0, _toIdentifier.default)(name);
    if (name === "eval" || name === "arguments")
      name = "_" + name;
    return name;
  }
});
var require_toComputedKey = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = toComputedKey;
  var _index = require_generated();
  var _index2 = require_generated2();
  function toComputedKey(node, key = node.key || node.property) {
    if (!node.computed && (0, _index.isIdentifier)(key))
      key = (0, _index2.stringLiteral)(key.name);
    return key;
  }
});
var require_toExpression = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _index = require_generated();
  var _default = exports.default = toExpression;
  function toExpression(node) {
    if ((0, _index.isExpressionStatement)(node)) {
      node = node.expression;
    }
    if ((0, _index.isExpression)(node)) {
      return node;
    }
    if ((0, _index.isClass)(node)) {
      node.type = "ClassExpression";
    } else if ((0, _index.isFunction)(node)) {
      node.type = "FunctionExpression";
    }
    if (!(0, _index.isExpression)(node)) {
      throw new Error(`cannot turn ${node.type} to an expression`);
    }
    return node;
  }
});
var require_traverseFast = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = traverseFast;
  var _index = require_definitions();
  function traverseFast(node, enter, opts) {
    if (!node)
      return;
    const keys = _index.VISITOR_KEYS[node.type];
    if (!keys)
      return;
    opts = opts || {};
    enter(node, opts);
    for (const key of keys) {
      const subNode = node[key];
      if (Array.isArray(subNode)) {
        for (const node2 of subNode) {
          traverseFast(node2, enter, opts);
        }
      } else {
        traverseFast(subNode, enter, opts);
      }
    }
  }
});
var require_removeProperties = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = removeProperties;
  var _index = require_constants();
  var CLEAR_KEYS = ["tokens", "start", "end", "loc", "raw", "rawValue"];
  var CLEAR_KEYS_PLUS_COMMENTS = [..._index.COMMENT_KEYS, "comments", ...CLEAR_KEYS];
  function removeProperties(node, opts = {}) {
    const map = opts.preserveComments ? CLEAR_KEYS : CLEAR_KEYS_PLUS_COMMENTS;
    for (const key of map) {
      if (node[key] != null)
        node[key] = undefined;
    }
    for (const key of Object.keys(node)) {
      if (key[0] === "_" && node[key] != null)
        node[key] = undefined;
    }
    const symbols = Object.getOwnPropertySymbols(node);
    for (const sym of symbols) {
      node[sym] = null;
    }
  }
});
var require_removePropertiesDeep = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = removePropertiesDeep;
  var _traverseFast = require_traverseFast();
  var _removeProperties = require_removeProperties();
  function removePropertiesDeep(tree, opts) {
    (0, _traverseFast.default)(tree, _removeProperties.default, opts);
    return tree;
  }
});
var require_toKeyAlias = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = toKeyAlias;
  var _index = require_generated();
  var _cloneNode = require_cloneNode();
  var _removePropertiesDeep = require_removePropertiesDeep();
  function toKeyAlias(node, key = node.key) {
    let alias;
    if (node.kind === "method") {
      return toKeyAlias.increment() + "";
    } else if ((0, _index.isIdentifier)(key)) {
      alias = key.name;
    } else if ((0, _index.isStringLiteral)(key)) {
      alias = JSON.stringify(key.value);
    } else {
      alias = JSON.stringify((0, _removePropertiesDeep.default)((0, _cloneNode.default)(key)));
    }
    if (node.computed) {
      alias = `[${alias}]`;
    }
    if (node.static) {
      alias = `static:${alias}`;
    }
    return alias;
  }
  toKeyAlias.uid = 0;
  toKeyAlias.increment = function() {
    if (toKeyAlias.uid >= Number.MAX_SAFE_INTEGER) {
      return toKeyAlias.uid = 0;
    } else {
      return toKeyAlias.uid++;
    }
  };
});
var require_toStatement = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _index = require_generated();
  var _index2 = require_generated2();
  var _default = exports.default = toStatement;
  function toStatement(node, ignore) {
    if ((0, _index.isStatement)(node)) {
      return node;
    }
    let mustHaveId = false;
    let newType;
    if ((0, _index.isClass)(node)) {
      mustHaveId = true;
      newType = "ClassDeclaration";
    } else if ((0, _index.isFunction)(node)) {
      mustHaveId = true;
      newType = "FunctionDeclaration";
    } else if ((0, _index.isAssignmentExpression)(node)) {
      return (0, _index2.expressionStatement)(node);
    }
    if (mustHaveId && !node.id) {
      newType = false;
    }
    if (!newType) {
      if (ignore) {
        return false;
      } else {
        throw new Error(`cannot turn ${node.type} to a statement`);
      }
    }
    node.type = newType;
    return node;
  }
});
var require_valueToNode = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _isValidIdentifier = require_isValidIdentifier();
  var _index = require_generated2();
  var _default = exports.default = valueToNode;
  var objectToString = Function.call.bind(Object.prototype.toString);
  function isRegExp(value) {
    return objectToString(value) === "[object RegExp]";
  }
  function isPlainObject22(value) {
    if (typeof value !== "object" || value === null || Object.prototype.toString.call(value) !== "[object Object]") {
      return false;
    }
    const proto2 = Object.getPrototypeOf(value);
    return proto2 === null || Object.getPrototypeOf(proto2) === null;
  }
  function valueToNode(value) {
    if (value === undefined) {
      return (0, _index.identifier)("undefined");
    }
    if (value === true || value === false) {
      return (0, _index.booleanLiteral)(value);
    }
    if (value === null) {
      return (0, _index.nullLiteral)();
    }
    if (typeof value === "string") {
      return (0, _index.stringLiteral)(value);
    }
    if (typeof value === "number") {
      let result2;
      if (Number.isFinite(value)) {
        result2 = (0, _index.numericLiteral)(Math.abs(value));
      } else {
        let numerator;
        if (Number.isNaN(value)) {
          numerator = (0, _index.numericLiteral)(0);
        } else {
          numerator = (0, _index.numericLiteral)(1);
        }
        result2 = (0, _index.binaryExpression)("/", numerator, (0, _index.numericLiteral)(0));
      }
      if (value < 0 || Object.is(value, -0)) {
        result2 = (0, _index.unaryExpression)("-", result2);
      }
      return result2;
    }
    if (isRegExp(value)) {
      const pattern = value.source;
      const flags = /\/([a-z]*)$/.exec(value.toString())[1];
      return (0, _index.regExpLiteral)(pattern, flags);
    }
    if (Array.isArray(value)) {
      return (0, _index.arrayExpression)(value.map(valueToNode));
    }
    if (isPlainObject22(value)) {
      const props = [];
      for (const key of Object.keys(value)) {
        let nodeKey;
        if ((0, _isValidIdentifier.default)(key)) {
          nodeKey = (0, _index.identifier)(key);
        } else {
          nodeKey = (0, _index.stringLiteral)(key);
        }
        props.push((0, _index.objectProperty)(nodeKey, valueToNode(value[key])));
      }
      return (0, _index.objectExpression)(props);
    }
    throw new Error("don't know how to turn this value into a node");
  }
});
var require_appendToMemberExpression = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = appendToMemberExpression;
  var _index = require_generated2();
  function appendToMemberExpression(member, append, computed = false) {
    member.object = (0, _index.memberExpression)(member.object, member.property, member.computed);
    member.property = append;
    member.computed = !!computed;
    return member;
  }
});
var require_inherits = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = inherits;
  var _index = require_constants();
  var _inheritsComments = require_inheritsComments();
  function inherits(child, parent) {
    if (!child || !parent)
      return child;
    for (const key of _index.INHERIT_KEYS.optional) {
      if (child[key] == null) {
        child[key] = parent[key];
      }
    }
    for (const key of Object.keys(parent)) {
      if (key[0] === "_" && key !== "__clone") {
        child[key] = parent[key];
      }
    }
    for (const key of _index.INHERIT_KEYS.force) {
      child[key] = parent[key];
    }
    (0, _inheritsComments.default)(child, parent);
    return child;
  }
});
var require_prependToMemberExpression = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = prependToMemberExpression;
  var _index = require_generated2();
  var _index2 = require_lib6();
  function prependToMemberExpression(member, prepend) {
    if ((0, _index2.isSuper)(member.object)) {
      throw new Error("Cannot prepend node to super property access (`super.foo`).");
    }
    member.object = (0, _index.memberExpression)(prepend, member.object);
    return member;
  }
});
var require_getAssignmentIdentifiers = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = getAssignmentIdentifiers;
  function getAssignmentIdentifiers(node) {
    const search = [].concat(node);
    const ids = Object.create(null);
    while (search.length) {
      const id = search.pop();
      if (!id)
        continue;
      switch (id.type) {
        case "ArrayPattern":
          search.push(...id.elements);
          break;
        case "AssignmentExpression":
        case "AssignmentPattern":
        case "ForInStatement":
        case "ForOfStatement":
          search.push(id.left);
          break;
        case "ObjectPattern":
          search.push(...id.properties);
          break;
        case "ObjectProperty":
          search.push(id.value);
          break;
        case "RestElement":
        case "UpdateExpression":
          search.push(id.argument);
          break;
        case "UnaryExpression":
          if (id.operator === "delete") {
            search.push(id.argument);
          }
          break;
        case "Identifier":
          ids[id.name] = id;
          break;
        default:
          break;
      }
    }
    return ids;
  }
});
var require_getBindingIdentifiers = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = getBindingIdentifiers;
  var _index = require_generated();
  function getBindingIdentifiers(node, duplicates, outerOnly, newBindingsOnly) {
    const search = [].concat(node);
    const ids = Object.create(null);
    while (search.length) {
      const id = search.shift();
      if (!id)
        continue;
      if (newBindingsOnly && ((0, _index.isAssignmentExpression)(id) || (0, _index.isUnaryExpression)(id) || (0, _index.isUpdateExpression)(id))) {
        continue;
      }
      if ((0, _index.isIdentifier)(id)) {
        if (duplicates) {
          const _ids = ids[id.name] = ids[id.name] || [];
          _ids.push(id);
        } else {
          ids[id.name] = id;
        }
        continue;
      }
      if ((0, _index.isExportDeclaration)(id) && !(0, _index.isExportAllDeclaration)(id)) {
        if ((0, _index.isDeclaration)(id.declaration)) {
          search.push(id.declaration);
        }
        continue;
      }
      if (outerOnly) {
        if ((0, _index.isFunctionDeclaration)(id)) {
          search.push(id.id);
          continue;
        }
        if ((0, _index.isFunctionExpression)(id)) {
          continue;
        }
      }
      const keys2 = getBindingIdentifiers.keys[id.type];
      if (keys2) {
        for (let i = 0;i < keys2.length; i++) {
          const key = keys2[i];
          const nodes = id[key];
          if (nodes) {
            if (Array.isArray(nodes)) {
              search.push(...nodes);
            } else {
              search.push(nodes);
            }
          }
        }
      }
    }
    return ids;
  }
  var keys = {
    DeclareClass: ["id"],
    DeclareFunction: ["id"],
    DeclareModule: ["id"],
    DeclareVariable: ["id"],
    DeclareInterface: ["id"],
    DeclareTypeAlias: ["id"],
    DeclareOpaqueType: ["id"],
    InterfaceDeclaration: ["id"],
    TypeAlias: ["id"],
    OpaqueType: ["id"],
    CatchClause: ["param"],
    LabeledStatement: ["label"],
    UnaryExpression: ["argument"],
    AssignmentExpression: ["left"],
    ImportSpecifier: ["local"],
    ImportNamespaceSpecifier: ["local"],
    ImportDefaultSpecifier: ["local"],
    ImportDeclaration: ["specifiers"],
    ExportSpecifier: ["exported"],
    ExportNamespaceSpecifier: ["exported"],
    ExportDefaultSpecifier: ["exported"],
    FunctionDeclaration: ["id", "params"],
    FunctionExpression: ["id", "params"],
    ArrowFunctionExpression: ["params"],
    ObjectMethod: ["params"],
    ClassMethod: ["params"],
    ClassPrivateMethod: ["params"],
    ForInStatement: ["left"],
    ForOfStatement: ["left"],
    ClassDeclaration: ["id"],
    ClassExpression: ["id"],
    RestElement: ["argument"],
    UpdateExpression: ["argument"],
    ObjectProperty: ["value"],
    AssignmentPattern: ["left"],
    ArrayPattern: ["elements"],
    ObjectPattern: ["properties"],
    VariableDeclaration: ["declarations"],
    VariableDeclarator: ["id"]
  };
  getBindingIdentifiers.keys = keys;
});
var require_getOuterBindingIdentifiers = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _getBindingIdentifiers = require_getBindingIdentifiers();
  var _default = exports.default = getOuterBindingIdentifiers;
  function getOuterBindingIdentifiers(node, duplicates) {
    return (0, _getBindingIdentifiers.default)(node, duplicates, true);
  }
});
var require_getFunctionName = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = getFunctionName;
  var _index = require_generated();
  function getNameFromLiteralId(id) {
    if ((0, _index.isNullLiteral)(id)) {
      return "null";
    }
    if ((0, _index.isRegExpLiteral)(id)) {
      return `/${id.pattern}/${id.flags}`;
    }
    if ((0, _index.isTemplateLiteral)(id)) {
      return id.quasis.map((quasi) => quasi.value.raw).join("");
    }
    if (id.value !== undefined) {
      return String(id.value);
    }
    return null;
  }
  function getObjectMemberKey(node) {
    if (!node.computed || (0, _index.isLiteral)(node.key)) {
      return node.key;
    }
  }
  function getFunctionName(node, parent) {
    if ("id" in node && node.id) {
      return {
        name: node.id.name,
        originalNode: node.id
      };
    }
    let prefix = "";
    let id;
    if ((0, _index.isObjectProperty)(parent, {
      value: node
    })) {
      id = getObjectMemberKey(parent);
    } else if ((0, _index.isObjectMethod)(node) || (0, _index.isClassMethod)(node)) {
      id = getObjectMemberKey(node);
      if (node.kind === "get")
        prefix = "get ";
      else if (node.kind === "set")
        prefix = "set ";
    } else if ((0, _index.isVariableDeclarator)(parent, {
      init: node
    })) {
      id = parent.id;
    } else if ((0, _index.isAssignmentExpression)(parent, {
      operator: "=",
      right: node
    })) {
      id = parent.left;
    }
    if (!id)
      return null;
    const name = (0, _index.isLiteral)(id) ? getNameFromLiteralId(id) : (0, _index.isIdentifier)(id) ? id.name : (0, _index.isPrivateName)(id) ? id.id.name : null;
    if (name == null)
      return null;
    return {
      name: prefix + name,
      originalNode: id
    };
  }
});
var require_traverse = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = traverse;
  var _index = require_definitions();
  function traverse(node, handlers, state) {
    if (typeof handlers === "function") {
      handlers = {
        enter: handlers
      };
    }
    const {
      enter,
      exit
    } = handlers;
    traverseSimpleImpl(node, enter, exit, state, []);
  }
  function traverseSimpleImpl(node, enter, exit, state, ancestors) {
    const keys = _index.VISITOR_KEYS[node.type];
    if (!keys)
      return;
    if (enter)
      enter(node, ancestors, state);
    for (const key of keys) {
      const subNode = node[key];
      if (Array.isArray(subNode)) {
        for (let i = 0;i < subNode.length; i++) {
          const child = subNode[i];
          if (!child)
            continue;
          ancestors.push({
            node,
            key,
            index: i
          });
          traverseSimpleImpl(child, enter, exit, state, ancestors);
          ancestors.pop();
        }
      } else if (subNode) {
        ancestors.push({
          node,
          key
        });
        traverseSimpleImpl(subNode, enter, exit, state, ancestors);
        ancestors.pop();
      }
    }
    if (exit)
      exit(node, ancestors, state);
  }
});
var require_isBinding = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isBinding;
  var _getBindingIdentifiers = require_getBindingIdentifiers();
  function isBinding(node, parent, grandparent) {
    if (grandparent && node.type === "Identifier" && parent.type === "ObjectProperty" && grandparent.type === "ObjectExpression") {
      return false;
    }
    const keys = _getBindingIdentifiers.default.keys[parent.type];
    if (keys) {
      for (let i = 0;i < keys.length; i++) {
        const key = keys[i];
        const val2 = parent[key];
        if (Array.isArray(val2)) {
          if (val2.includes(node))
            return true;
        } else {
          if (val2 === node)
            return true;
        }
      }
    }
    return false;
  }
});
var require_isLet = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isLet;
  var _index = require_generated();
  var _index2 = require_constants();
  function isLet(node) {
    return (0, _index.isVariableDeclaration)(node) && (node.kind !== "var" || node[_index2.BLOCK_SCOPED_SYMBOL]);
  }
});
var require_isBlockScoped = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isBlockScoped;
  var _index = require_generated();
  var _isLet = require_isLet();
  function isBlockScoped(node) {
    return (0, _index.isFunctionDeclaration)(node) || (0, _index.isClassDeclaration)(node) || (0, _isLet.default)(node);
  }
});
var require_isImmutable = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isImmutable;
  var _isType = require_isType();
  var _index = require_generated();
  function isImmutable(node) {
    if ((0, _isType.default)(node.type, "Immutable"))
      return true;
    if ((0, _index.isIdentifier)(node)) {
      if (node.name === "undefined") {
        return true;
      } else {
        return false;
      }
    }
    return false;
  }
});
var require_isNodesEquivalent = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isNodesEquivalent;
  var _index = require_definitions();
  function isNodesEquivalent(a, b22) {
    if (typeof a !== "object" || typeof b22 !== "object" || a == null || b22 == null) {
      return a === b22;
    }
    if (a.type !== b22.type) {
      return false;
    }
    const fields22 = Object.keys(_index.NODE_FIELDS[a.type] || a.type);
    const visitorKeys = _index.VISITOR_KEYS[a.type];
    for (const field of fields22) {
      const val_a = a[field];
      const val_b = b22[field];
      if (typeof val_a !== typeof val_b) {
        return false;
      }
      if (val_a == null && val_b == null) {
        continue;
      } else if (val_a == null || val_b == null) {
        return false;
      }
      if (Array.isArray(val_a)) {
        if (!Array.isArray(val_b)) {
          return false;
        }
        if (val_a.length !== val_b.length) {
          return false;
        }
        for (let i = 0;i < val_a.length; i++) {
          if (!isNodesEquivalent(val_a[i], val_b[i])) {
            return false;
          }
        }
        continue;
      }
      if (typeof val_a === "object" && !(visitorKeys != null && visitorKeys.includes(field))) {
        for (const key of Object.keys(val_a)) {
          if (val_a[key] !== val_b[key]) {
            return false;
          }
        }
        continue;
      }
      if (!isNodesEquivalent(val_a, val_b)) {
        return false;
      }
    }
    return true;
  }
});
var require_isReferenced = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isReferenced;
  function isReferenced(node, parent, grandparent) {
    switch (parent.type) {
      case "MemberExpression":
      case "OptionalMemberExpression":
        if (parent.property === node) {
          return !!parent.computed;
        }
        return parent.object === node;
      case "JSXMemberExpression":
        return parent.object === node;
      case "VariableDeclarator":
        return parent.init === node;
      case "ArrowFunctionExpression":
        return parent.body === node;
      case "PrivateName":
        return false;
      case "ClassMethod":
      case "ClassPrivateMethod":
      case "ObjectMethod":
        if (parent.key === node) {
          return !!parent.computed;
        }
        return false;
      case "ObjectProperty":
        if (parent.key === node) {
          return !!parent.computed;
        }
        return !grandparent || grandparent.type !== "ObjectPattern";
      case "ClassProperty":
      case "ClassAccessorProperty":
        if (parent.key === node) {
          return !!parent.computed;
        }
        return true;
      case "ClassPrivateProperty":
        return parent.key !== node;
      case "ClassDeclaration":
      case "ClassExpression":
        return parent.superClass === node;
      case "AssignmentExpression":
        return parent.right === node;
      case "AssignmentPattern":
        return parent.right === node;
      case "LabeledStatement":
        return false;
      case "CatchClause":
        return false;
      case "RestElement":
        return false;
      case "BreakStatement":
      case "ContinueStatement":
        return false;
      case "FunctionDeclaration":
      case "FunctionExpression":
        return false;
      case "ExportNamespaceSpecifier":
      case "ExportDefaultSpecifier":
        return false;
      case "ExportSpecifier":
        if (grandparent != null && grandparent.source) {
          return false;
        }
        return parent.local === node;
      case "ImportDefaultSpecifier":
      case "ImportNamespaceSpecifier":
      case "ImportSpecifier":
        return false;
      case "ImportAttribute":
        return false;
      case "JSXAttribute":
        return false;
      case "ObjectPattern":
      case "ArrayPattern":
        return false;
      case "MetaProperty":
        return false;
      case "ObjectTypeProperty":
        return parent.key !== node;
      case "TSEnumMember":
        return parent.id !== node;
      case "TSPropertySignature":
        if (parent.key === node) {
          return !!parent.computed;
        }
        return true;
    }
    return true;
  }
});
var require_isScope = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isScope;
  var _index = require_generated();
  function isScope(node, parent) {
    if ((0, _index.isBlockStatement)(node) && ((0, _index.isFunction)(parent) || (0, _index.isCatchClause)(parent))) {
      return false;
    }
    if ((0, _index.isPattern)(node) && ((0, _index.isFunction)(parent) || (0, _index.isCatchClause)(parent))) {
      return true;
    }
    return (0, _index.isScopable)(node);
  }
});
var require_isSpecifierDefault = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isSpecifierDefault;
  var _index = require_generated();
  function isSpecifierDefault(specifier) {
    return (0, _index.isImportDefaultSpecifier)(specifier) || (0, _index.isIdentifier)(specifier.imported || specifier.exported, {
      name: "default"
    });
  }
});
var require_isValidES3Identifier = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isValidES3Identifier;
  var _isValidIdentifier = require_isValidIdentifier();
  var RESERVED_WORDS_ES3_ONLY = new Set(["abstract", "boolean", "byte", "char", "double", "enum", "final", "float", "goto", "implements", "int", "interface", "long", "native", "package", "private", "protected", "public", "short", "static", "synchronized", "throws", "transient", "volatile"]);
  function isValidES3Identifier(name) {
    return (0, _isValidIdentifier.default)(name) && !RESERVED_WORDS_ES3_ONLY.has(name);
  }
});
var require_isVar = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isVar;
  var _index = require_generated();
  var _index2 = require_constants();
  function isVar(node) {
    return (0, _index.isVariableDeclaration)(node, {
      kind: "var"
    }) && !node[_index2.BLOCK_SCOPED_SYMBOL];
  }
});
var require_gatherSequenceExpressions = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = gatherSequenceExpressions;
  var _getBindingIdentifiers = require_getBindingIdentifiers();
  var _index = require_generated();
  var _index2 = require_generated2();
  var _productions = require_productions();
  var _cloneNode = require_cloneNode();
  function gatherSequenceExpressions(nodes, declars) {
    const exprs = [];
    let ensureLastUndefined = true;
    for (const node of nodes) {
      if (!(0, _index.isEmptyStatement)(node)) {
        ensureLastUndefined = false;
      }
      if ((0, _index.isExpression)(node)) {
        exprs.push(node);
      } else if ((0, _index.isExpressionStatement)(node)) {
        exprs.push(node.expression);
      } else if ((0, _index.isVariableDeclaration)(node)) {
        if (node.kind !== "var")
          return;
        for (const declar of node.declarations) {
          const bindings = (0, _getBindingIdentifiers.default)(declar);
          for (const key of Object.keys(bindings)) {
            declars.push({
              kind: node.kind,
              id: (0, _cloneNode.default)(bindings[key])
            });
          }
          if (declar.init) {
            exprs.push((0, _index2.assignmentExpression)("=", declar.id, declar.init));
          }
        }
        ensureLastUndefined = true;
      } else if ((0, _index.isIfStatement)(node)) {
        const consequent = node.consequent ? gatherSequenceExpressions([node.consequent], declars) : (0, _productions.buildUndefinedNode)();
        const alternate = node.alternate ? gatherSequenceExpressions([node.alternate], declars) : (0, _productions.buildUndefinedNode)();
        if (!consequent || !alternate)
          return;
        exprs.push((0, _index2.conditionalExpression)(node.test, consequent, alternate));
      } else if ((0, _index.isBlockStatement)(node)) {
        const body = gatherSequenceExpressions(node.body, declars);
        if (!body)
          return;
        exprs.push(body);
      } else if ((0, _index.isEmptyStatement)(node)) {
        if (nodes.indexOf(node) === 0) {
          ensureLastUndefined = true;
        }
      } else {
        return;
      }
    }
    if (ensureLastUndefined) {
      exprs.push((0, _productions.buildUndefinedNode)());
    }
    if (exprs.length === 1) {
      return exprs[0];
    } else {
      return (0, _index2.sequenceExpression)(exprs);
    }
  }
});
var require_toSequenceExpression = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = toSequenceExpression;
  var _gatherSequenceExpressions = require_gatherSequenceExpressions();
  function toSequenceExpression(nodes, scope) {
    if (!(nodes != null && nodes.length))
      return;
    const declars = [];
    const result2 = (0, _gatherSequenceExpressions.default)(nodes, declars);
    if (!result2)
      return;
    for (const declar of declars) {
      scope.push(declar);
    }
    return result2;
  }
});
var require_lib6 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _exportNames = {
    react: true,
    assertNode: true,
    createTypeAnnotationBasedOnTypeof: true,
    createUnionTypeAnnotation: true,
    createFlowUnionType: true,
    createTSUnionType: true,
    cloneNode: true,
    clone: true,
    cloneDeep: true,
    cloneDeepWithoutLoc: true,
    cloneWithoutLoc: true,
    addComment: true,
    addComments: true,
    inheritInnerComments: true,
    inheritLeadingComments: true,
    inheritsComments: true,
    inheritTrailingComments: true,
    removeComments: true,
    ensureBlock: true,
    toBindingIdentifierName: true,
    toBlock: true,
    toComputedKey: true,
    toExpression: true,
    toIdentifier: true,
    toKeyAlias: true,
    toStatement: true,
    valueToNode: true,
    appendToMemberExpression: true,
    inherits: true,
    prependToMemberExpression: true,
    removeProperties: true,
    removePropertiesDeep: true,
    removeTypeDuplicates: true,
    getAssignmentIdentifiers: true,
    getBindingIdentifiers: true,
    getOuterBindingIdentifiers: true,
    getFunctionName: true,
    traverse: true,
    traverseFast: true,
    shallowEqual: true,
    is: true,
    isBinding: true,
    isBlockScoped: true,
    isImmutable: true,
    isLet: true,
    isNode: true,
    isNodesEquivalent: true,
    isPlaceholderType: true,
    isReferenced: true,
    isScope: true,
    isSpecifierDefault: true,
    isType: true,
    isValidES3Identifier: true,
    isValidIdentifier: true,
    isVar: true,
    matchesPattern: true,
    validate: true,
    buildMatchMemberExpression: true,
    __internal__deprecationWarning: true
  };
  Object.defineProperty(exports, "__internal__deprecationWarning", {
    enumerable: true,
    get: function() {
      return _deprecationWarning.default;
    }
  });
  Object.defineProperty(exports, "addComment", {
    enumerable: true,
    get: function() {
      return _addComment.default;
    }
  });
  Object.defineProperty(exports, "addComments", {
    enumerable: true,
    get: function() {
      return _addComments.default;
    }
  });
  Object.defineProperty(exports, "appendToMemberExpression", {
    enumerable: true,
    get: function() {
      return _appendToMemberExpression.default;
    }
  });
  Object.defineProperty(exports, "assertNode", {
    enumerable: true,
    get: function() {
      return _assertNode.default;
    }
  });
  Object.defineProperty(exports, "buildMatchMemberExpression", {
    enumerable: true,
    get: function() {
      return _buildMatchMemberExpression.default;
    }
  });
  Object.defineProperty(exports, "clone", {
    enumerable: true,
    get: function() {
      return _clone.default;
    }
  });
  Object.defineProperty(exports, "cloneDeep", {
    enumerable: true,
    get: function() {
      return _cloneDeep.default;
    }
  });
  Object.defineProperty(exports, "cloneDeepWithoutLoc", {
    enumerable: true,
    get: function() {
      return _cloneDeepWithoutLoc.default;
    }
  });
  Object.defineProperty(exports, "cloneNode", {
    enumerable: true,
    get: function() {
      return _cloneNode.default;
    }
  });
  Object.defineProperty(exports, "cloneWithoutLoc", {
    enumerable: true,
    get: function() {
      return _cloneWithoutLoc.default;
    }
  });
  Object.defineProperty(exports, "createFlowUnionType", {
    enumerable: true,
    get: function() {
      return _createFlowUnionType.default;
    }
  });
  Object.defineProperty(exports, "createTSUnionType", {
    enumerable: true,
    get: function() {
      return _createTSUnionType.default;
    }
  });
  Object.defineProperty(exports, "createTypeAnnotationBasedOnTypeof", {
    enumerable: true,
    get: function() {
      return _createTypeAnnotationBasedOnTypeof.default;
    }
  });
  Object.defineProperty(exports, "createUnionTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _createFlowUnionType.default;
    }
  });
  Object.defineProperty(exports, "ensureBlock", {
    enumerable: true,
    get: function() {
      return _ensureBlock.default;
    }
  });
  Object.defineProperty(exports, "getAssignmentIdentifiers", {
    enumerable: true,
    get: function() {
      return _getAssignmentIdentifiers.default;
    }
  });
  Object.defineProperty(exports, "getBindingIdentifiers", {
    enumerable: true,
    get: function() {
      return _getBindingIdentifiers.default;
    }
  });
  Object.defineProperty(exports, "getFunctionName", {
    enumerable: true,
    get: function() {
      return _getFunctionName.default;
    }
  });
  Object.defineProperty(exports, "getOuterBindingIdentifiers", {
    enumerable: true,
    get: function() {
      return _getOuterBindingIdentifiers.default;
    }
  });
  Object.defineProperty(exports, "inheritInnerComments", {
    enumerable: true,
    get: function() {
      return _inheritInnerComments.default;
    }
  });
  Object.defineProperty(exports, "inheritLeadingComments", {
    enumerable: true,
    get: function() {
      return _inheritLeadingComments.default;
    }
  });
  Object.defineProperty(exports, "inheritTrailingComments", {
    enumerable: true,
    get: function() {
      return _inheritTrailingComments.default;
    }
  });
  Object.defineProperty(exports, "inherits", {
    enumerable: true,
    get: function() {
      return _inherits.default;
    }
  });
  Object.defineProperty(exports, "inheritsComments", {
    enumerable: true,
    get: function() {
      return _inheritsComments.default;
    }
  });
  Object.defineProperty(exports, "is", {
    enumerable: true,
    get: function() {
      return _is.default;
    }
  });
  Object.defineProperty(exports, "isBinding", {
    enumerable: true,
    get: function() {
      return _isBinding.default;
    }
  });
  Object.defineProperty(exports, "isBlockScoped", {
    enumerable: true,
    get: function() {
      return _isBlockScoped.default;
    }
  });
  Object.defineProperty(exports, "isImmutable", {
    enumerable: true,
    get: function() {
      return _isImmutable.default;
    }
  });
  Object.defineProperty(exports, "isLet", {
    enumerable: true,
    get: function() {
      return _isLet.default;
    }
  });
  Object.defineProperty(exports, "isNode", {
    enumerable: true,
    get: function() {
      return _isNode.default;
    }
  });
  Object.defineProperty(exports, "isNodesEquivalent", {
    enumerable: true,
    get: function() {
      return _isNodesEquivalent.default;
    }
  });
  Object.defineProperty(exports, "isPlaceholderType", {
    enumerable: true,
    get: function() {
      return _isPlaceholderType.default;
    }
  });
  Object.defineProperty(exports, "isReferenced", {
    enumerable: true,
    get: function() {
      return _isReferenced.default;
    }
  });
  Object.defineProperty(exports, "isScope", {
    enumerable: true,
    get: function() {
      return _isScope.default;
    }
  });
  Object.defineProperty(exports, "isSpecifierDefault", {
    enumerable: true,
    get: function() {
      return _isSpecifierDefault.default;
    }
  });
  Object.defineProperty(exports, "isType", {
    enumerable: true,
    get: function() {
      return _isType.default;
    }
  });
  Object.defineProperty(exports, "isValidES3Identifier", {
    enumerable: true,
    get: function() {
      return _isValidES3Identifier.default;
    }
  });
  Object.defineProperty(exports, "isValidIdentifier", {
    enumerable: true,
    get: function() {
      return _isValidIdentifier.default;
    }
  });
  Object.defineProperty(exports, "isVar", {
    enumerable: true,
    get: function() {
      return _isVar.default;
    }
  });
  Object.defineProperty(exports, "matchesPattern", {
    enumerable: true,
    get: function() {
      return _matchesPattern.default;
    }
  });
  Object.defineProperty(exports, "prependToMemberExpression", {
    enumerable: true,
    get: function() {
      return _prependToMemberExpression.default;
    }
  });
  exports.react = undefined;
  Object.defineProperty(exports, "removeComments", {
    enumerable: true,
    get: function() {
      return _removeComments.default;
    }
  });
  Object.defineProperty(exports, "removeProperties", {
    enumerable: true,
    get: function() {
      return _removeProperties.default;
    }
  });
  Object.defineProperty(exports, "removePropertiesDeep", {
    enumerable: true,
    get: function() {
      return _removePropertiesDeep.default;
    }
  });
  Object.defineProperty(exports, "removeTypeDuplicates", {
    enumerable: true,
    get: function() {
      return _removeTypeDuplicates.default;
    }
  });
  Object.defineProperty(exports, "shallowEqual", {
    enumerable: true,
    get: function() {
      return _shallowEqual.default;
    }
  });
  Object.defineProperty(exports, "toBindingIdentifierName", {
    enumerable: true,
    get: function() {
      return _toBindingIdentifierName.default;
    }
  });
  Object.defineProperty(exports, "toBlock", {
    enumerable: true,
    get: function() {
      return _toBlock.default;
    }
  });
  Object.defineProperty(exports, "toComputedKey", {
    enumerable: true,
    get: function() {
      return _toComputedKey.default;
    }
  });
  Object.defineProperty(exports, "toExpression", {
    enumerable: true,
    get: function() {
      return _toExpression.default;
    }
  });
  Object.defineProperty(exports, "toIdentifier", {
    enumerable: true,
    get: function() {
      return _toIdentifier.default;
    }
  });
  Object.defineProperty(exports, "toKeyAlias", {
    enumerable: true,
    get: function() {
      return _toKeyAlias.default;
    }
  });
  Object.defineProperty(exports, "toStatement", {
    enumerable: true,
    get: function() {
      return _toStatement.default;
    }
  });
  Object.defineProperty(exports, "traverse", {
    enumerable: true,
    get: function() {
      return _traverse.default;
    }
  });
  Object.defineProperty(exports, "traverseFast", {
    enumerable: true,
    get: function() {
      return _traverseFast.default;
    }
  });
  Object.defineProperty(exports, "validate", {
    enumerable: true,
    get: function() {
      return _validate.default;
    }
  });
  Object.defineProperty(exports, "valueToNode", {
    enumerable: true,
    get: function() {
      return _valueToNode.default;
    }
  });
  var _isReactComponent = require_isReactComponent();
  var _isCompatTag = require_isCompatTag();
  var _buildChildren = require_buildChildren();
  var _assertNode = require_assertNode();
  var _index = require_generated3();
  Object.keys(_index).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _index[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _index[key];
      }
    });
  });
  var _createTypeAnnotationBasedOnTypeof = require_createTypeAnnotationBasedOnTypeof();
  var _createFlowUnionType = require_createFlowUnionType();
  var _createTSUnionType = require_createTSUnionType();
  var _index2 = require_generated2();
  Object.keys(_index2).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _index2[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _index2[key];
      }
    });
  });
  var _uppercase = require_uppercase();
  Object.keys(_uppercase).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _uppercase[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _uppercase[key];
      }
    });
  });
  var _productions = require_productions();
  Object.keys(_productions).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _productions[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _productions[key];
      }
    });
  });
  var _cloneNode = require_cloneNode();
  var _clone = require_clone2();
  var _cloneDeep = require_cloneDeep();
  var _cloneDeepWithoutLoc = require_cloneDeepWithoutLoc();
  var _cloneWithoutLoc = require_cloneWithoutLoc();
  var _addComment = require_addComment();
  var _addComments = require_addComments();
  var _inheritInnerComments = require_inheritInnerComments();
  var _inheritLeadingComments = require_inheritLeadingComments();
  var _inheritsComments = require_inheritsComments();
  var _inheritTrailingComments = require_inheritTrailingComments();
  var _removeComments = require_removeComments();
  var _index3 = require_generated4();
  Object.keys(_index3).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _index3[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _index3[key];
      }
    });
  });
  var _index4 = require_constants();
  Object.keys(_index4).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _index4[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _index4[key];
      }
    });
  });
  var _ensureBlock = require_ensureBlock();
  var _toBindingIdentifierName = require_toBindingIdentifierName();
  var _toBlock = require_toBlock();
  var _toComputedKey = require_toComputedKey();
  var _toExpression = require_toExpression();
  var _toIdentifier = require_toIdentifier();
  var _toKeyAlias = require_toKeyAlias();
  var _toStatement = require_toStatement();
  var _valueToNode = require_valueToNode();
  var _index5 = require_definitions();
  Object.keys(_index5).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _index5[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _index5[key];
      }
    });
  });
  var _appendToMemberExpression = require_appendToMemberExpression();
  var _inherits = require_inherits();
  var _prependToMemberExpression = require_prependToMemberExpression();
  var _removeProperties = require_removeProperties();
  var _removePropertiesDeep = require_removePropertiesDeep();
  var _removeTypeDuplicates = require_removeTypeDuplicates();
  var _getAssignmentIdentifiers = require_getAssignmentIdentifiers();
  var _getBindingIdentifiers = require_getBindingIdentifiers();
  var _getOuterBindingIdentifiers = require_getOuterBindingIdentifiers();
  var _getFunctionName = require_getFunctionName();
  var _traverse = require_traverse();
  Object.keys(_traverse).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _traverse[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _traverse[key];
      }
    });
  });
  var _traverseFast = require_traverseFast();
  var _shallowEqual = require_shallowEqual();
  var _is = require_is();
  var _isBinding = require_isBinding();
  var _isBlockScoped = require_isBlockScoped();
  var _isImmutable = require_isImmutable();
  var _isLet = require_isLet();
  var _isNode = require_isNode();
  var _isNodesEquivalent = require_isNodesEquivalent();
  var _isPlaceholderType = require_isPlaceholderType();
  var _isReferenced = require_isReferenced();
  var _isScope = require_isScope();
  var _isSpecifierDefault = require_isSpecifierDefault();
  var _isType = require_isType();
  var _isValidES3Identifier = require_isValidES3Identifier();
  var _isValidIdentifier = require_isValidIdentifier();
  var _isVar = require_isVar();
  var _matchesPattern = require_matchesPattern();
  var _validate = require_validate();
  var _buildMatchMemberExpression = require_buildMatchMemberExpression();
  var _index6 = require_generated();
  Object.keys(_index6).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key))
      return;
    if (key in exports && exports[key] === _index6[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _index6[key];
      }
    });
  });
  var _deprecationWarning = require_deprecationWarning();
  var react = exports.react = {
    isReactComponent: _isReactComponent.default,
    isCompatTag: _isCompatTag.default,
    buildChildren: _buildChildren.default
  };
  {
    exports.toSequenceExpression = require_toSequenceExpression().default;
  }
  if (process.env.BABEL_TYPES_8_BREAKING) {
    console.warn("BABEL_TYPES_8_BREAKING is not supported anymore. Use the latest Babel 8.0.0 pre-release instead!");
  }
});
var require_virtual_types_validator = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.isBindingIdentifier = isBindingIdentifier;
  exports.isBlockScoped = isBlockScoped;
  exports.isExpression = isExpression;
  exports.isFlow = isFlow;
  exports.isForAwaitStatement = isForAwaitStatement;
  exports.isGenerated = isGenerated;
  exports.isPure = isPure;
  exports.isReferenced = isReferenced;
  exports.isReferencedIdentifier = isReferencedIdentifier;
  exports.isReferencedMemberExpression = isReferencedMemberExpression;
  exports.isRestProperty = isRestProperty;
  exports.isScope = isScope;
  exports.isSpreadProperty = isSpreadProperty;
  exports.isStatement = isStatement;
  exports.isUser = isUser;
  exports.isVar = isVar;
  var _t = require_lib6();
  var {
    isBinding,
    isBlockScoped: nodeIsBlockScoped,
    isExportDeclaration,
    isExpression: nodeIsExpression,
    isFlow: nodeIsFlow,
    isForStatement,
    isForXStatement,
    isIdentifier,
    isImportDeclaration,
    isImportSpecifier,
    isJSXIdentifier,
    isJSXMemberExpression,
    isMemberExpression,
    isRestElement: nodeIsRestElement,
    isReferenced: nodeIsReferenced,
    isScope: nodeIsScope,
    isStatement: nodeIsStatement,
    isVar: nodeIsVar,
    isVariableDeclaration,
    react,
    isForOfStatement
  } = _t;
  var {
    isCompatTag
  } = react;
  function isReferencedIdentifier(opts) {
    const {
      node,
      parent
    } = this;
    if (!isIdentifier(node, opts) && !isJSXMemberExpression(parent, opts)) {
      if (isJSXIdentifier(node, opts)) {
        if (isCompatTag(node.name))
          return false;
      } else {
        return false;
      }
    }
    return nodeIsReferenced(node, parent, this.parentPath.parent);
  }
  function isReferencedMemberExpression() {
    const {
      node,
      parent
    } = this;
    return isMemberExpression(node) && nodeIsReferenced(node, parent);
  }
  function isBindingIdentifier() {
    const {
      node,
      parent
    } = this;
    const grandparent = this.parentPath.parent;
    return isIdentifier(node) && isBinding(node, parent, grandparent);
  }
  function isStatement() {
    const {
      node,
      parent
    } = this;
    if (nodeIsStatement(node)) {
      if (isVariableDeclaration(node)) {
        if (isForXStatement(parent, {
          left: node
        }))
          return false;
        if (isForStatement(parent, {
          init: node
        }))
          return false;
      }
      return true;
    } else {
      return false;
    }
  }
  function isExpression() {
    if (this.isIdentifier()) {
      return this.isReferencedIdentifier();
    } else {
      return nodeIsExpression(this.node);
    }
  }
  function isScope() {
    return nodeIsScope(this.node, this.parent);
  }
  function isReferenced() {
    return nodeIsReferenced(this.node, this.parent);
  }
  function isBlockScoped() {
    return nodeIsBlockScoped(this.node);
  }
  function isVar() {
    return nodeIsVar(this.node);
  }
  function isUser() {
    return this.node && !!this.node.loc;
  }
  function isGenerated() {
    return !this.isUser();
  }
  function isPure(constantsOnly) {
    return this.scope.isPure(this.node, constantsOnly);
  }
  function isFlow() {
    const {
      node
    } = this;
    if (nodeIsFlow(node)) {
      return true;
    } else if (isImportDeclaration(node)) {
      return node.importKind === "type" || node.importKind === "typeof";
    } else if (isExportDeclaration(node)) {
      return node.exportKind === "type";
    } else if (isImportSpecifier(node)) {
      return node.importKind === "type" || node.importKind === "typeof";
    } else {
      return false;
    }
  }
  function isRestProperty() {
    var _this$parentPath;
    return nodeIsRestElement(this.node) && ((_this$parentPath = this.parentPath) == null ? undefined : _this$parentPath.isObjectPattern());
  }
  function isSpreadProperty() {
    var _this$parentPath2;
    return nodeIsRestElement(this.node) && ((_this$parentPath2 = this.parentPath) == null ? undefined : _this$parentPath2.isObjectExpression());
  }
  function isForAwaitStatement() {
    return isForOfStatement(this.node, {
      await: true
    });
  }
  {
    exports.isExistentialTypeParam = function isExistentialTypeParam() {
      throw new Error("`path.isExistentialTypeParam` has been renamed to `path.isExistsTypeAnnotation()` in Babel 7.");
    };
    exports.isNumericLiteralTypeAnnotation = function isNumericLiteralTypeAnnotation() {
      throw new Error("`path.isNumericLiteralTypeAnnotation()` has been renamed to `path.isNumberLiteralTypeAnnotation()` in Babel 7.");
    };
  }
});
var require_visitors = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.environmentVisitor = environmentVisitor;
  exports.explode = explode$1;
  exports.isExplodedVisitor = isExplodedVisitor;
  exports.merge = merge;
  exports.verify = verify$1;
  var virtualTypes = require_virtual_types();
  var virtualTypesValidators = require_virtual_types_validator();
  var _t = require_lib6();
  var _context = require_context2();
  var {
    DEPRECATED_KEYS,
    DEPRECATED_ALIASES,
    FLIPPED_ALIAS_KEYS,
    TYPES,
    __internal__deprecationWarning: deprecationWarning
  } = _t;
  function isVirtualType(type) {
    return type in virtualTypes;
  }
  function isExplodedVisitor(visitor) {
    return visitor == null ? undefined : visitor._exploded;
  }
  function explode$1(visitor) {
    if (isExplodedVisitor(visitor))
      return visitor;
    visitor._exploded = true;
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType))
        continue;
      const parts = nodeType.split("|");
      if (parts.length === 1)
        continue;
      const fns = visitor[nodeType];
      delete visitor[nodeType];
      for (const part of parts) {
        visitor[part] = fns;
      }
    }
    verify$1(visitor);
    delete visitor.__esModule;
    ensureEntranceObjects(visitor);
    ensureCallbackArrays(visitor);
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType))
        continue;
      if (!isVirtualType(nodeType))
        continue;
      const fns = visitor[nodeType];
      for (const type of Object.keys(fns)) {
        fns[type] = wrapCheck(nodeType, fns[type]);
      }
      delete visitor[nodeType];
      const types3 = virtualTypes[nodeType];
      if (types3 !== null) {
        for (const type of types3) {
          if (visitor[type]) {
            mergePair(visitor[type], fns);
          } else {
            visitor[type] = fns;
          }
        }
      } else {
        mergePair(visitor, fns);
      }
    }
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType))
        continue;
      let aliases = FLIPPED_ALIAS_KEYS[nodeType];
      if (nodeType in DEPRECATED_KEYS) {
        const deprecatedKey = DEPRECATED_KEYS[nodeType];
        deprecationWarning(nodeType, deprecatedKey, "Visitor ");
        aliases = [deprecatedKey];
      } else if (nodeType in DEPRECATED_ALIASES) {
        const deprecatedAlias = DEPRECATED_ALIASES[nodeType];
        deprecationWarning(nodeType, deprecatedAlias, "Visitor ");
        aliases = FLIPPED_ALIAS_KEYS[deprecatedAlias];
      }
      if (!aliases)
        continue;
      const fns = visitor[nodeType];
      delete visitor[nodeType];
      for (const alias of aliases) {
        const existing = visitor[alias];
        if (existing) {
          mergePair(existing, fns);
        } else {
          visitor[alias] = Object.assign({}, fns);
        }
      }
    }
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType))
        continue;
      ensureCallbackArrays(visitor[nodeType]);
    }
    return visitor;
  }
  function verify$1(visitor) {
    if (visitor._verified)
      return;
    if (typeof visitor === "function") {
      throw new Error("You passed `traverse()` a function when it expected a visitor object, are you sure you didn't mean `{ enter: Function }`?");
    }
    for (const nodeType of Object.keys(visitor)) {
      if (nodeType === "enter" || nodeType === "exit") {
        validateVisitorMethods(nodeType, visitor[nodeType]);
      }
      if (shouldIgnoreKey(nodeType))
        continue;
      if (!TYPES.includes(nodeType)) {
        throw new Error(`You gave us a visitor for the node type ${nodeType} but it's not a valid type in @babel/traverse 7.25.9`);
      }
      const visitors = visitor[nodeType];
      if (typeof visitors === "object") {
        for (const visitorKey of Object.keys(visitors)) {
          if (visitorKey === "enter" || visitorKey === "exit") {
            validateVisitorMethods(`${nodeType}.${visitorKey}`, visitors[visitorKey]);
          } else {
            throw new Error(`You passed \`traverse()\` a visitor object with the property ${nodeType} that has the invalid property ${visitorKey}`);
          }
        }
      }
    }
    visitor._verified = true;
  }
  function validateVisitorMethods(path3, val2) {
    const fns = [].concat(val2);
    for (const fn of fns) {
      if (typeof fn !== "function") {
        throw new TypeError(`Non-function found defined in ${path3} with type ${typeof fn}`);
      }
    }
  }
  function merge(visitors, states = [], wrapper) {
    const mergedVisitor = {
      _verified: true,
      _exploded: true
    };
    {
      Object.defineProperty(mergedVisitor, "_exploded", {
        enumerable: false
      });
      Object.defineProperty(mergedVisitor, "_verified", {
        enumerable: false
      });
    }
    for (let i = 0;i < visitors.length; i++) {
      const visitor = explode$1(visitors[i]);
      const state = states[i];
      let topVisitor = visitor;
      if (state || wrapper) {
        topVisitor = wrapWithStateOrWrapper(topVisitor, state, wrapper);
      }
      mergePair(mergedVisitor, topVisitor);
      for (const key of Object.keys(visitor)) {
        if (shouldIgnoreKey(key))
          continue;
        let typeVisitor = visitor[key];
        if (state || wrapper) {
          typeVisitor = wrapWithStateOrWrapper(typeVisitor, state, wrapper);
        }
        const nodeVisitor = mergedVisitor[key] || (mergedVisitor[key] = {});
        mergePair(nodeVisitor, typeVisitor);
      }
    }
    return mergedVisitor;
  }
  function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
    const newVisitor = {};
    for (const phase of ["enter", "exit"]) {
      let fns = oldVisitor[phase];
      if (!Array.isArray(fns))
        continue;
      fns = fns.map(function(fn) {
        let newFn = fn;
        if (state) {
          newFn = function(path3) {
            fn.call(state, path3, state);
          };
        }
        if (wrapper) {
          newFn = wrapper(state == null ? undefined : state.key, phase, newFn);
        }
        if (newFn !== fn) {
          newFn.toString = () => fn.toString();
        }
        return newFn;
      });
      newVisitor[phase] = fns;
    }
    return newVisitor;
  }
  function ensureEntranceObjects(obj) {
    for (const key of Object.keys(obj)) {
      if (shouldIgnoreKey(key))
        continue;
      const fns = obj[key];
      if (typeof fns === "function") {
        obj[key] = {
          enter: fns
        };
      }
    }
  }
  function ensureCallbackArrays(obj) {
    if (obj.enter && !Array.isArray(obj.enter))
      obj.enter = [obj.enter];
    if (obj.exit && !Array.isArray(obj.exit))
      obj.exit = [obj.exit];
  }
  function wrapCheck(nodeType, fn) {
    const fnKey = `is${nodeType}`;
    const validator2 = virtualTypesValidators[fnKey];
    const newFn = function(path3) {
      if (validator2.call(path3)) {
        return fn.apply(this, arguments);
      }
    };
    newFn.toString = () => fn.toString();
    return newFn;
  }
  function shouldIgnoreKey(key) {
    if (key[0] === "_")
      return true;
    if (key === "enter" || key === "exit" || key === "shouldSkip")
      return true;
    if (key === "denylist" || key === "noScope" || key === "skipKeys") {
      return true;
    }
    {
      if (key === "blacklist") {
        return true;
      }
    }
    return false;
  }
  function mergePair(dest, src22) {
    for (const phase of ["enter", "exit"]) {
      if (!src22[phase])
        continue;
      dest[phase] = [].concat(dest[phase] || [], src22[phase]);
    }
  }
  var _environmentVisitor = {
    FunctionParent(path3) {
      if (path3.isArrowFunctionExpression())
        return;
      path3.skip();
      if (path3.isMethod()) {
        if (!path3.requeueComputedKeyAndDecorators) {
          _context.requeueComputedKeyAndDecorators.call(path3);
        } else {
          path3.requeueComputedKeyAndDecorators();
        }
      }
    },
    Property(path3) {
      if (path3.isObjectProperty())
        return;
      path3.skip();
      if (!path3.requeueComputedKeyAndDecorators) {
        _context.requeueComputedKeyAndDecorators.call(path3);
      } else {
        path3.requeueComputedKeyAndDecorators();
      }
    }
  };
  function environmentVisitor(visitor) {
    return merge([_environmentVisitor, visitor]);
  }
});
var require_renamer = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var t = require_lib6();
  var _t = t;
  var _traverseNode = require_traverse_node();
  var _visitors = require_visitors();
  var _context = require_context2();
  var {
    getAssignmentIdentifiers
  } = _t;
  var renameVisitor = {
    ReferencedIdentifier({
      node
    }, state) {
      if (node.name === state.oldName) {
        node.name = state.newName;
      }
    },
    Scope(path3, state) {
      if (!path3.scope.bindingIdentifierEquals(state.oldName, state.binding.identifier)) {
        path3.skip();
        if (path3.isMethod()) {
          if (!path3.requeueComputedKeyAndDecorators) {
            _context.requeueComputedKeyAndDecorators.call(path3);
          } else {
            path3.requeueComputedKeyAndDecorators();
          }
        }
      }
    },
    ObjectProperty({
      node,
      scope
    }, state) {
      const {
        name
      } = node.key;
      if (node.shorthand && (name === state.oldName || name === state.newName) && scope.getBindingIdentifier(name) === state.binding.identifier) {
        node.shorthand = false;
        {
          var _node$extra;
          if ((_node$extra = node.extra) != null && _node$extra.shorthand)
            node.extra.shorthand = false;
        }
      }
    },
    "AssignmentExpression|Declaration|VariableDeclarator"(path3, state) {
      if (path3.isVariableDeclaration())
        return;
      const ids = path3.isAssignmentExpression() ? getAssignmentIdentifiers(path3.node) : path3.getOuterBindingIdentifiers();
      for (const name in ids) {
        if (name === state.oldName)
          ids[name].name = state.newName;
      }
    }
  };

  class Renamer {
    constructor(binding, oldName, newName) {
      this.newName = newName;
      this.oldName = oldName;
      this.binding = binding;
    }
    maybeConvertFromExportDeclaration(parentDeclar) {
      const maybeExportDeclar = parentDeclar.parentPath;
      if (!maybeExportDeclar.isExportDeclaration()) {
        return;
      }
      if (maybeExportDeclar.isExportDefaultDeclaration()) {
        const {
          declaration
        } = maybeExportDeclar.node;
        if (t.isDeclaration(declaration) && !declaration.id) {
          return;
        }
      }
      if (maybeExportDeclar.isExportAllDeclaration()) {
        return;
      }
      maybeExportDeclar.splitExportDeclaration();
    }
    maybeConvertFromClassFunctionDeclaration(path3) {
      return path3;
    }
    maybeConvertFromClassFunctionExpression(path3) {
      return path3;
    }
    rename() {
      const {
        binding,
        oldName,
        newName
      } = this;
      const {
        scope,
        path: path3
      } = binding;
      const parentDeclar = path3.find((path42) => path42.isDeclaration() || path42.isFunctionExpression() || path42.isClassExpression());
      if (parentDeclar) {
        const bindingIds = parentDeclar.getOuterBindingIdentifiers();
        if (bindingIds[oldName] === binding.identifier) {
          this.maybeConvertFromExportDeclaration(parentDeclar);
        }
      }
      const blockToTraverse = arguments[0] || scope.block;
      const skipKeys = {
        discriminant: true
      };
      if (t.isMethod(blockToTraverse)) {
        if (blockToTraverse.computed) {
          skipKeys.key = true;
        }
        if (!t.isObjectMethod(blockToTraverse)) {
          skipKeys.decorators = true;
        }
      }
      (0, _traverseNode.traverseNode)(blockToTraverse, (0, _visitors.explode)(renameVisitor), scope, this, scope.path, skipKeys);
      if (!arguments[0]) {
        scope.removeOwnBinding(oldName);
        scope.bindings[newName] = binding;
        this.binding.identifier.name = newName;
      }
      if (parentDeclar) {
        this.maybeConvertFromClassFunctionDeclaration(path3);
        this.maybeConvertFromClassFunctionExpression(path3);
      }
    }
  }
  exports.default = Renamer;
});
var require_binding = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;

  class Binding {
    constructor({
      identifier,
      scope,
      path: path3,
      kind
    }) {
      this.identifier = undefined;
      this.scope = undefined;
      this.path = undefined;
      this.kind = undefined;
      this.constantViolations = [];
      this.constant = true;
      this.referencePaths = [];
      this.referenced = false;
      this.references = 0;
      this.identifier = identifier;
      this.scope = scope;
      this.path = path3;
      this.kind = kind;
      if ((kind === "var" || kind === "hoisted") && isDeclaredInLoop(path3)) {
        this.reassign(path3);
      }
      this.clearValue();
    }
    deoptValue() {
      this.clearValue();
      this.hasDeoptedValue = true;
    }
    setValue(value) {
      if (this.hasDeoptedValue)
        return;
      this.hasValue = true;
      this.value = value;
    }
    clearValue() {
      this.hasDeoptedValue = false;
      this.hasValue = false;
      this.value = null;
    }
    reassign(path3) {
      this.constant = false;
      if (this.constantViolations.includes(path3)) {
        return;
      }
      this.constantViolations.push(path3);
    }
    reference(path3) {
      if (this.referencePaths.includes(path3)) {
        return;
      }
      this.referenced = true;
      this.references++;
      this.referencePaths.push(path3);
    }
    dereference() {
      this.references--;
      this.referenced = !!this.references;
    }
  }
  exports.default = Binding;
  function isDeclaredInLoop(path3) {
    for (let {
      parentPath,
      key
    } = path3;parentPath; {
      parentPath,
      key
    } = parentPath) {
      if (parentPath.isFunctionParent())
        return false;
      if (parentPath.isWhile() || parentPath.isForXStatement() || parentPath.isForStatement() && key === "body") {
        return true;
      }
    }
    return false;
  }
});
var require_globals = __commonJS2((exports, module) => {
  module.exports = {
    builtin: {
      Array: false,
      ArrayBuffer: false,
      Atomics: false,
      BigInt: false,
      BigInt64Array: false,
      BigUint64Array: false,
      Boolean: false,
      constructor: false,
      DataView: false,
      Date: false,
      decodeURI: false,
      decodeURIComponent: false,
      encodeURI: false,
      encodeURIComponent: false,
      Error: false,
      escape: false,
      eval: false,
      EvalError: false,
      Float32Array: false,
      Float64Array: false,
      Function: false,
      globalThis: false,
      hasOwnProperty: false,
      Infinity: false,
      Int16Array: false,
      Int32Array: false,
      Int8Array: false,
      isFinite: false,
      isNaN: false,
      isPrototypeOf: false,
      JSON: false,
      Map: false,
      Math: false,
      NaN: false,
      Number: false,
      Object: false,
      parseFloat: false,
      parseInt: false,
      Promise: false,
      propertyIsEnumerable: false,
      Proxy: false,
      RangeError: false,
      ReferenceError: false,
      Reflect: false,
      RegExp: false,
      Set: false,
      SharedArrayBuffer: false,
      String: false,
      Symbol: false,
      SyntaxError: false,
      toLocaleString: false,
      toString: false,
      TypeError: false,
      Uint16Array: false,
      Uint32Array: false,
      Uint8Array: false,
      Uint8ClampedArray: false,
      undefined: false,
      unescape: false,
      URIError: false,
      valueOf: false,
      WeakMap: false,
      WeakSet: false
    },
    es5: {
      Array: false,
      Boolean: false,
      constructor: false,
      Date: false,
      decodeURI: false,
      decodeURIComponent: false,
      encodeURI: false,
      encodeURIComponent: false,
      Error: false,
      escape: false,
      eval: false,
      EvalError: false,
      Function: false,
      hasOwnProperty: false,
      Infinity: false,
      isFinite: false,
      isNaN: false,
      isPrototypeOf: false,
      JSON: false,
      Math: false,
      NaN: false,
      Number: false,
      Object: false,
      parseFloat: false,
      parseInt: false,
      propertyIsEnumerable: false,
      RangeError: false,
      ReferenceError: false,
      RegExp: false,
      String: false,
      SyntaxError: false,
      toLocaleString: false,
      toString: false,
      TypeError: false,
      undefined: false,
      unescape: false,
      URIError: false,
      valueOf: false
    },
    es2015: {
      Array: false,
      ArrayBuffer: false,
      Boolean: false,
      constructor: false,
      DataView: false,
      Date: false,
      decodeURI: false,
      decodeURIComponent: false,
      encodeURI: false,
      encodeURIComponent: false,
      Error: false,
      escape: false,
      eval: false,
      EvalError: false,
      Float32Array: false,
      Float64Array: false,
      Function: false,
      hasOwnProperty: false,
      Infinity: false,
      Int16Array: false,
      Int32Array: false,
      Int8Array: false,
      isFinite: false,
      isNaN: false,
      isPrototypeOf: false,
      JSON: false,
      Map: false,
      Math: false,
      NaN: false,
      Number: false,
      Object: false,
      parseFloat: false,
      parseInt: false,
      Promise: false,
      propertyIsEnumerable: false,
      Proxy: false,
      RangeError: false,
      ReferenceError: false,
      Reflect: false,
      RegExp: false,
      Set: false,
      String: false,
      Symbol: false,
      SyntaxError: false,
      toLocaleString: false,
      toString: false,
      TypeError: false,
      Uint16Array: false,
      Uint32Array: false,
      Uint8Array: false,
      Uint8ClampedArray: false,
      undefined: false,
      unescape: false,
      URIError: false,
      valueOf: false,
      WeakMap: false,
      WeakSet: false
    },
    es2017: {
      Array: false,
      ArrayBuffer: false,
      Atomics: false,
      Boolean: false,
      constructor: false,
      DataView: false,
      Date: false,
      decodeURI: false,
      decodeURIComponent: false,
      encodeURI: false,
      encodeURIComponent: false,
      Error: false,
      escape: false,
      eval: false,
      EvalError: false,
      Float32Array: false,
      Float64Array: false,
      Function: false,
      hasOwnProperty: false,
      Infinity: false,
      Int16Array: false,
      Int32Array: false,
      Int8Array: false,
      isFinite: false,
      isNaN: false,
      isPrototypeOf: false,
      JSON: false,
      Map: false,
      Math: false,
      NaN: false,
      Number: false,
      Object: false,
      parseFloat: false,
      parseInt: false,
      Promise: false,
      propertyIsEnumerable: false,
      Proxy: false,
      RangeError: false,
      ReferenceError: false,
      Reflect: false,
      RegExp: false,
      Set: false,
      SharedArrayBuffer: false,
      String: false,
      Symbol: false,
      SyntaxError: false,
      toLocaleString: false,
      toString: false,
      TypeError: false,
      Uint16Array: false,
      Uint32Array: false,
      Uint8Array: false,
      Uint8ClampedArray: false,
      undefined: false,
      unescape: false,
      URIError: false,
      valueOf: false,
      WeakMap: false,
      WeakSet: false
    },
    browser: {
      AbortController: false,
      AbortSignal: false,
      addEventListener: false,
      alert: false,
      AnalyserNode: false,
      Animation: false,
      AnimationEffectReadOnly: false,
      AnimationEffectTiming: false,
      AnimationEffectTimingReadOnly: false,
      AnimationEvent: false,
      AnimationPlaybackEvent: false,
      AnimationTimeline: false,
      applicationCache: false,
      ApplicationCache: false,
      ApplicationCacheErrorEvent: false,
      atob: false,
      Attr: false,
      Audio: false,
      AudioBuffer: false,
      AudioBufferSourceNode: false,
      AudioContext: false,
      AudioDestinationNode: false,
      AudioListener: false,
      AudioNode: false,
      AudioParam: false,
      AudioProcessingEvent: false,
      AudioScheduledSourceNode: false,
      "AudioWorkletGlobalScope ": false,
      AudioWorkletNode: false,
      AudioWorkletProcessor: false,
      BarProp: false,
      BaseAudioContext: false,
      BatteryManager: false,
      BeforeUnloadEvent: false,
      BiquadFilterNode: false,
      Blob: false,
      BlobEvent: false,
      blur: false,
      BroadcastChannel: false,
      btoa: false,
      BudgetService: false,
      ByteLengthQueuingStrategy: false,
      Cache: false,
      caches: false,
      CacheStorage: false,
      cancelAnimationFrame: false,
      cancelIdleCallback: false,
      CanvasCaptureMediaStreamTrack: false,
      CanvasGradient: false,
      CanvasPattern: false,
      CanvasRenderingContext2D: false,
      ChannelMergerNode: false,
      ChannelSplitterNode: false,
      CharacterData: false,
      clearInterval: false,
      clearTimeout: false,
      clientInformation: false,
      ClipboardEvent: false,
      close: false,
      closed: false,
      CloseEvent: false,
      Comment: false,
      CompositionEvent: false,
      confirm: false,
      console: false,
      ConstantSourceNode: false,
      ConvolverNode: false,
      CountQueuingStrategy: false,
      createImageBitmap: false,
      Credential: false,
      CredentialsContainer: false,
      crypto: false,
      Crypto: false,
      CryptoKey: false,
      CSS: false,
      CSSConditionRule: false,
      CSSFontFaceRule: false,
      CSSGroupingRule: false,
      CSSImportRule: false,
      CSSKeyframeRule: false,
      CSSKeyframesRule: false,
      CSSMediaRule: false,
      CSSNamespaceRule: false,
      CSSPageRule: false,
      CSSRule: false,
      CSSRuleList: false,
      CSSStyleDeclaration: false,
      CSSStyleRule: false,
      CSSStyleSheet: false,
      CSSSupportsRule: false,
      CustomElementRegistry: false,
      customElements: false,
      CustomEvent: false,
      DataTransfer: false,
      DataTransferItem: false,
      DataTransferItemList: false,
      defaultstatus: false,
      defaultStatus: false,
      DelayNode: false,
      DeviceMotionEvent: false,
      DeviceOrientationEvent: false,
      devicePixelRatio: false,
      dispatchEvent: false,
      document: false,
      Document: false,
      DocumentFragment: false,
      DocumentType: false,
      DOMError: false,
      DOMException: false,
      DOMImplementation: false,
      DOMMatrix: false,
      DOMMatrixReadOnly: false,
      DOMParser: false,
      DOMPoint: false,
      DOMPointReadOnly: false,
      DOMQuad: false,
      DOMRect: false,
      DOMRectReadOnly: false,
      DOMStringList: false,
      DOMStringMap: false,
      DOMTokenList: false,
      DragEvent: false,
      DynamicsCompressorNode: false,
      Element: false,
      ErrorEvent: false,
      event: false,
      Event: false,
      EventSource: false,
      EventTarget: false,
      external: false,
      fetch: false,
      File: false,
      FileList: false,
      FileReader: false,
      find: false,
      focus: false,
      FocusEvent: false,
      FontFace: false,
      FontFaceSetLoadEvent: false,
      FormData: false,
      frameElement: false,
      frames: false,
      GainNode: false,
      Gamepad: false,
      GamepadButton: false,
      GamepadEvent: false,
      getComputedStyle: false,
      getSelection: false,
      HashChangeEvent: false,
      Headers: false,
      history: false,
      History: false,
      HTMLAllCollection: false,
      HTMLAnchorElement: false,
      HTMLAreaElement: false,
      HTMLAudioElement: false,
      HTMLBaseElement: false,
      HTMLBodyElement: false,
      HTMLBRElement: false,
      HTMLButtonElement: false,
      HTMLCanvasElement: false,
      HTMLCollection: false,
      HTMLContentElement: false,
      HTMLDataElement: false,
      HTMLDataListElement: false,
      HTMLDetailsElement: false,
      HTMLDialogElement: false,
      HTMLDirectoryElement: false,
      HTMLDivElement: false,
      HTMLDListElement: false,
      HTMLDocument: false,
      HTMLElement: false,
      HTMLEmbedElement: false,
      HTMLFieldSetElement: false,
      HTMLFontElement: false,
      HTMLFormControlsCollection: false,
      HTMLFormElement: false,
      HTMLFrameElement: false,
      HTMLFrameSetElement: false,
      HTMLHeadElement: false,
      HTMLHeadingElement: false,
      HTMLHRElement: false,
      HTMLHtmlElement: false,
      HTMLIFrameElement: false,
      HTMLImageElement: false,
      HTMLInputElement: false,
      HTMLLabelElement: false,
      HTMLLegendElement: false,
      HTMLLIElement: false,
      HTMLLinkElement: false,
      HTMLMapElement: false,
      HTMLMarqueeElement: false,
      HTMLMediaElement: false,
      HTMLMenuElement: false,
      HTMLMetaElement: false,
      HTMLMeterElement: false,
      HTMLModElement: false,
      HTMLObjectElement: false,
      HTMLOListElement: false,
      HTMLOptGroupElement: false,
      HTMLOptionElement: false,
      HTMLOptionsCollection: false,
      HTMLOutputElement: false,
      HTMLParagraphElement: false,
      HTMLParamElement: false,
      HTMLPictureElement: false,
      HTMLPreElement: false,
      HTMLProgressElement: false,
      HTMLQuoteElement: false,
      HTMLScriptElement: false,
      HTMLSelectElement: false,
      HTMLShadowElement: false,
      HTMLSlotElement: false,
      HTMLSourceElement: false,
      HTMLSpanElement: false,
      HTMLStyleElement: false,
      HTMLTableCaptionElement: false,
      HTMLTableCellElement: false,
      HTMLTableColElement: false,
      HTMLTableElement: false,
      HTMLTableRowElement: false,
      HTMLTableSectionElement: false,
      HTMLTemplateElement: false,
      HTMLTextAreaElement: false,
      HTMLTimeElement: false,
      HTMLTitleElement: false,
      HTMLTrackElement: false,
      HTMLUListElement: false,
      HTMLUnknownElement: false,
      HTMLVideoElement: false,
      IDBCursor: false,
      IDBCursorWithValue: false,
      IDBDatabase: false,
      IDBFactory: false,
      IDBIndex: false,
      IDBKeyRange: false,
      IDBObjectStore: false,
      IDBOpenDBRequest: false,
      IDBRequest: false,
      IDBTransaction: false,
      IDBVersionChangeEvent: false,
      IdleDeadline: false,
      IIRFilterNode: false,
      Image: false,
      ImageBitmap: false,
      ImageBitmapRenderingContext: false,
      ImageCapture: false,
      ImageData: false,
      indexedDB: false,
      innerHeight: false,
      innerWidth: false,
      InputEvent: false,
      IntersectionObserver: false,
      IntersectionObserverEntry: false,
      Intl: false,
      isSecureContext: false,
      KeyboardEvent: false,
      KeyframeEffect: false,
      KeyframeEffectReadOnly: false,
      length: false,
      localStorage: false,
      location: true,
      Location: false,
      locationbar: false,
      matchMedia: false,
      MediaDeviceInfo: false,
      MediaDevices: false,
      MediaElementAudioSourceNode: false,
      MediaEncryptedEvent: false,
      MediaError: false,
      MediaKeyMessageEvent: false,
      MediaKeySession: false,
      MediaKeyStatusMap: false,
      MediaKeySystemAccess: false,
      MediaList: false,
      MediaQueryList: false,
      MediaQueryListEvent: false,
      MediaRecorder: false,
      MediaSettingsRange: false,
      MediaSource: false,
      MediaStream: false,
      MediaStreamAudioDestinationNode: false,
      MediaStreamAudioSourceNode: false,
      MediaStreamEvent: false,
      MediaStreamTrack: false,
      MediaStreamTrackEvent: false,
      menubar: false,
      MessageChannel: false,
      MessageEvent: false,
      MessagePort: false,
      MIDIAccess: false,
      MIDIConnectionEvent: false,
      MIDIInput: false,
      MIDIInputMap: false,
      MIDIMessageEvent: false,
      MIDIOutput: false,
      MIDIOutputMap: false,
      MIDIPort: false,
      MimeType: false,
      MimeTypeArray: false,
      MouseEvent: false,
      moveBy: false,
      moveTo: false,
      MutationEvent: false,
      MutationObserver: false,
      MutationRecord: false,
      name: false,
      NamedNodeMap: false,
      NavigationPreloadManager: false,
      navigator: false,
      Navigator: false,
      NetworkInformation: false,
      Node: false,
      NodeFilter: false,
      NodeIterator: false,
      NodeList: false,
      Notification: false,
      OfflineAudioCompletionEvent: false,
      OfflineAudioContext: false,
      offscreenBuffering: false,
      OffscreenCanvas: true,
      onabort: true,
      onafterprint: true,
      onanimationend: true,
      onanimationiteration: true,
      onanimationstart: true,
      onappinstalled: true,
      onauxclick: true,
      onbeforeinstallprompt: true,
      onbeforeprint: true,
      onbeforeunload: true,
      onblur: true,
      oncancel: true,
      oncanplay: true,
      oncanplaythrough: true,
      onchange: true,
      onclick: true,
      onclose: true,
      oncontextmenu: true,
      oncuechange: true,
      ondblclick: true,
      ondevicemotion: true,
      ondeviceorientation: true,
      ondeviceorientationabsolute: true,
      ondrag: true,
      ondragend: true,
      ondragenter: true,
      ondragleave: true,
      ondragover: true,
      ondragstart: true,
      ondrop: true,
      ondurationchange: true,
      onemptied: true,
      onended: true,
      onerror: true,
      onfocus: true,
      ongotpointercapture: true,
      onhashchange: true,
      oninput: true,
      oninvalid: true,
      onkeydown: true,
      onkeypress: true,
      onkeyup: true,
      onlanguagechange: true,
      onload: true,
      onloadeddata: true,
      onloadedmetadata: true,
      onloadstart: true,
      onlostpointercapture: true,
      onmessage: true,
      onmessageerror: true,
      onmousedown: true,
      onmouseenter: true,
      onmouseleave: true,
      onmousemove: true,
      onmouseout: true,
      onmouseover: true,
      onmouseup: true,
      onmousewheel: true,
      onoffline: true,
      ononline: true,
      onpagehide: true,
      onpageshow: true,
      onpause: true,
      onplay: true,
      onplaying: true,
      onpointercancel: true,
      onpointerdown: true,
      onpointerenter: true,
      onpointerleave: true,
      onpointermove: true,
      onpointerout: true,
      onpointerover: true,
      onpointerup: true,
      onpopstate: true,
      onprogress: true,
      onratechange: true,
      onrejectionhandled: true,
      onreset: true,
      onresize: true,
      onscroll: true,
      onsearch: true,
      onseeked: true,
      onseeking: true,
      onselect: true,
      onstalled: true,
      onstorage: true,
      onsubmit: true,
      onsuspend: true,
      ontimeupdate: true,
      ontoggle: true,
      ontransitionend: true,
      onunhandledrejection: true,
      onunload: true,
      onvolumechange: true,
      onwaiting: true,
      onwheel: true,
      open: false,
      openDatabase: false,
      opener: false,
      Option: false,
      origin: false,
      OscillatorNode: false,
      outerHeight: false,
      outerWidth: false,
      PageTransitionEvent: false,
      pageXOffset: false,
      pageYOffset: false,
      PannerNode: false,
      parent: false,
      Path2D: false,
      PaymentAddress: false,
      PaymentRequest: false,
      PaymentRequestUpdateEvent: false,
      PaymentResponse: false,
      performance: false,
      Performance: false,
      PerformanceEntry: false,
      PerformanceLongTaskTiming: false,
      PerformanceMark: false,
      PerformanceMeasure: false,
      PerformanceNavigation: false,
      PerformanceNavigationTiming: false,
      PerformanceObserver: false,
      PerformanceObserverEntryList: false,
      PerformancePaintTiming: false,
      PerformanceResourceTiming: false,
      PerformanceTiming: false,
      PeriodicWave: false,
      Permissions: false,
      PermissionStatus: false,
      personalbar: false,
      PhotoCapabilities: false,
      Plugin: false,
      PluginArray: false,
      PointerEvent: false,
      PopStateEvent: false,
      postMessage: false,
      Presentation: false,
      PresentationAvailability: false,
      PresentationConnection: false,
      PresentationConnectionAvailableEvent: false,
      PresentationConnectionCloseEvent: false,
      PresentationConnectionList: false,
      PresentationReceiver: false,
      PresentationRequest: false,
      print: false,
      ProcessingInstruction: false,
      ProgressEvent: false,
      PromiseRejectionEvent: false,
      prompt: false,
      PushManager: false,
      PushSubscription: false,
      PushSubscriptionOptions: false,
      queueMicrotask: false,
      RadioNodeList: false,
      Range: false,
      ReadableStream: false,
      registerProcessor: false,
      RemotePlayback: false,
      removeEventListener: false,
      Request: false,
      requestAnimationFrame: false,
      requestIdleCallback: false,
      resizeBy: false,
      ResizeObserver: false,
      ResizeObserverEntry: false,
      resizeTo: false,
      Response: false,
      RTCCertificate: false,
      RTCDataChannel: false,
      RTCDataChannelEvent: false,
      RTCDtlsTransport: false,
      RTCIceCandidate: false,
      RTCIceGatherer: false,
      RTCIceTransport: false,
      RTCPeerConnection: false,
      RTCPeerConnectionIceEvent: false,
      RTCRtpContributingSource: false,
      RTCRtpReceiver: false,
      RTCRtpSender: false,
      RTCSctpTransport: false,
      RTCSessionDescription: false,
      RTCStatsReport: false,
      RTCTrackEvent: false,
      screen: false,
      Screen: false,
      screenLeft: false,
      ScreenOrientation: false,
      screenTop: false,
      screenX: false,
      screenY: false,
      ScriptProcessorNode: false,
      scroll: false,
      scrollbars: false,
      scrollBy: false,
      scrollTo: false,
      scrollX: false,
      scrollY: false,
      SecurityPolicyViolationEvent: false,
      Selection: false,
      self: false,
      ServiceWorker: false,
      ServiceWorkerContainer: false,
      ServiceWorkerRegistration: false,
      sessionStorage: false,
      setInterval: false,
      setTimeout: false,
      ShadowRoot: false,
      SharedWorker: false,
      SourceBuffer: false,
      SourceBufferList: false,
      speechSynthesis: false,
      SpeechSynthesisEvent: false,
      SpeechSynthesisUtterance: false,
      StaticRange: false,
      status: false,
      statusbar: false,
      StereoPannerNode: false,
      stop: false,
      Storage: false,
      StorageEvent: false,
      StorageManager: false,
      styleMedia: false,
      StyleSheet: false,
      StyleSheetList: false,
      SubtleCrypto: false,
      SVGAElement: false,
      SVGAngle: false,
      SVGAnimatedAngle: false,
      SVGAnimatedBoolean: false,
      SVGAnimatedEnumeration: false,
      SVGAnimatedInteger: false,
      SVGAnimatedLength: false,
      SVGAnimatedLengthList: false,
      SVGAnimatedNumber: false,
      SVGAnimatedNumberList: false,
      SVGAnimatedPreserveAspectRatio: false,
      SVGAnimatedRect: false,
      SVGAnimatedString: false,
      SVGAnimatedTransformList: false,
      SVGAnimateElement: false,
      SVGAnimateMotionElement: false,
      SVGAnimateTransformElement: false,
      SVGAnimationElement: false,
      SVGCircleElement: false,
      SVGClipPathElement: false,
      SVGComponentTransferFunctionElement: false,
      SVGDefsElement: false,
      SVGDescElement: false,
      SVGDiscardElement: false,
      SVGElement: false,
      SVGEllipseElement: false,
      SVGFEBlendElement: false,
      SVGFEColorMatrixElement: false,
      SVGFEComponentTransferElement: false,
      SVGFECompositeElement: false,
      SVGFEConvolveMatrixElement: false,
      SVGFEDiffuseLightingElement: false,
      SVGFEDisplacementMapElement: false,
      SVGFEDistantLightElement: false,
      SVGFEDropShadowElement: false,
      SVGFEFloodElement: false,
      SVGFEFuncAElement: false,
      SVGFEFuncBElement: false,
      SVGFEFuncGElement: false,
      SVGFEFuncRElement: false,
      SVGFEGaussianBlurElement: false,
      SVGFEImageElement: false,
      SVGFEMergeElement: false,
      SVGFEMergeNodeElement: false,
      SVGFEMorphologyElement: false,
      SVGFEOffsetElement: false,
      SVGFEPointLightElement: false,
      SVGFESpecularLightingElement: false,
      SVGFESpotLightElement: false,
      SVGFETileElement: false,
      SVGFETurbulenceElement: false,
      SVGFilterElement: false,
      SVGForeignObjectElement: false,
      SVGGElement: false,
      SVGGeometryElement: false,
      SVGGradientElement: false,
      SVGGraphicsElement: false,
      SVGImageElement: false,
      SVGLength: false,
      SVGLengthList: false,
      SVGLinearGradientElement: false,
      SVGLineElement: false,
      SVGMarkerElement: false,
      SVGMaskElement: false,
      SVGMatrix: false,
      SVGMetadataElement: false,
      SVGMPathElement: false,
      SVGNumber: false,
      SVGNumberList: false,
      SVGPathElement: false,
      SVGPatternElement: false,
      SVGPoint: false,
      SVGPointList: false,
      SVGPolygonElement: false,
      SVGPolylineElement: false,
      SVGPreserveAspectRatio: false,
      SVGRadialGradientElement: false,
      SVGRect: false,
      SVGRectElement: false,
      SVGScriptElement: false,
      SVGSetElement: false,
      SVGStopElement: false,
      SVGStringList: false,
      SVGStyleElement: false,
      SVGSVGElement: false,
      SVGSwitchElement: false,
      SVGSymbolElement: false,
      SVGTextContentElement: false,
      SVGTextElement: false,
      SVGTextPathElement: false,
      SVGTextPositioningElement: false,
      SVGTitleElement: false,
      SVGTransform: false,
      SVGTransformList: false,
      SVGTSpanElement: false,
      SVGUnitTypes: false,
      SVGUseElement: false,
      SVGViewElement: false,
      TaskAttributionTiming: false,
      Text: false,
      TextDecoder: false,
      TextEncoder: false,
      TextEvent: false,
      TextMetrics: false,
      TextTrack: false,
      TextTrackCue: false,
      TextTrackCueList: false,
      TextTrackList: false,
      TimeRanges: false,
      toolbar: false,
      top: false,
      Touch: false,
      TouchEvent: false,
      TouchList: false,
      TrackEvent: false,
      TransitionEvent: false,
      TreeWalker: false,
      UIEvent: false,
      URL: false,
      URLSearchParams: false,
      ValidityState: false,
      visualViewport: false,
      VisualViewport: false,
      VTTCue: false,
      WaveShaperNode: false,
      WebAssembly: false,
      WebGL2RenderingContext: false,
      WebGLActiveInfo: false,
      WebGLBuffer: false,
      WebGLContextEvent: false,
      WebGLFramebuffer: false,
      WebGLProgram: false,
      WebGLQuery: false,
      WebGLRenderbuffer: false,
      WebGLRenderingContext: false,
      WebGLSampler: false,
      WebGLShader: false,
      WebGLShaderPrecisionFormat: false,
      WebGLSync: false,
      WebGLTexture: false,
      WebGLTransformFeedback: false,
      WebGLUniformLocation: false,
      WebGLVertexArrayObject: false,
      WebSocket: false,
      WheelEvent: false,
      window: false,
      Window: false,
      Worker: false,
      WritableStream: false,
      XMLDocument: false,
      XMLHttpRequest: false,
      XMLHttpRequestEventTarget: false,
      XMLHttpRequestUpload: false,
      XMLSerializer: false,
      XPathEvaluator: false,
      XPathExpression: false,
      XPathResult: false,
      XSLTProcessor: false
    },
    worker: {
      addEventListener: false,
      applicationCache: false,
      atob: false,
      Blob: false,
      BroadcastChannel: false,
      btoa: false,
      Cache: false,
      caches: false,
      clearInterval: false,
      clearTimeout: false,
      close: true,
      console: false,
      fetch: false,
      FileReaderSync: false,
      FormData: false,
      Headers: false,
      IDBCursor: false,
      IDBCursorWithValue: false,
      IDBDatabase: false,
      IDBFactory: false,
      IDBIndex: false,
      IDBKeyRange: false,
      IDBObjectStore: false,
      IDBOpenDBRequest: false,
      IDBRequest: false,
      IDBTransaction: false,
      IDBVersionChangeEvent: false,
      ImageData: false,
      importScripts: true,
      indexedDB: false,
      location: false,
      MessageChannel: false,
      MessagePort: false,
      name: false,
      navigator: false,
      Notification: false,
      onclose: true,
      onconnect: true,
      onerror: true,
      onlanguagechange: true,
      onmessage: true,
      onoffline: true,
      ononline: true,
      onrejectionhandled: true,
      onunhandledrejection: true,
      performance: false,
      Performance: false,
      PerformanceEntry: false,
      PerformanceMark: false,
      PerformanceMeasure: false,
      PerformanceNavigation: false,
      PerformanceResourceTiming: false,
      PerformanceTiming: false,
      postMessage: true,
      Promise: false,
      queueMicrotask: false,
      removeEventListener: false,
      Request: false,
      Response: false,
      self: true,
      ServiceWorkerRegistration: false,
      setInterval: false,
      setTimeout: false,
      TextDecoder: false,
      TextEncoder: false,
      URL: false,
      URLSearchParams: false,
      WebSocket: false,
      Worker: false,
      WorkerGlobalScope: false,
      XMLHttpRequest: false
    },
    node: {
      __dirname: false,
      __filename: false,
      Buffer: false,
      clearImmediate: false,
      clearInterval: false,
      clearTimeout: false,
      console: false,
      exports: true,
      global: false,
      Intl: false,
      module: false,
      process: false,
      queueMicrotask: false,
      require: false,
      setImmediate: false,
      setInterval: false,
      setTimeout: false,
      TextDecoder: false,
      TextEncoder: false,
      URL: false,
      URLSearchParams: false
    },
    commonjs: {
      exports: true,
      global: false,
      module: false,
      require: false
    },
    amd: {
      define: false,
      require: false
    },
    mocha: {
      after: false,
      afterEach: false,
      before: false,
      beforeEach: false,
      context: false,
      describe: false,
      it: false,
      mocha: false,
      run: false,
      setup: false,
      specify: false,
      suite: false,
      suiteSetup: false,
      suiteTeardown: false,
      teardown: false,
      test: false,
      xcontext: false,
      xdescribe: false,
      xit: false,
      xspecify: false
    },
    jasmine: {
      afterAll: false,
      afterEach: false,
      beforeAll: false,
      beforeEach: false,
      describe: false,
      expect: false,
      fail: false,
      fdescribe: false,
      fit: false,
      it: false,
      jasmine: false,
      pending: false,
      runs: false,
      spyOn: false,
      spyOnProperty: false,
      waits: false,
      waitsFor: false,
      xdescribe: false,
      xit: false
    },
    jest: {
      afterAll: false,
      afterEach: false,
      beforeAll: false,
      beforeEach: false,
      describe: false,
      expect: false,
      fdescribe: false,
      fit: false,
      it: false,
      jest: false,
      pit: false,
      require: false,
      test: false,
      xdescribe: false,
      xit: false,
      xtest: false
    },
    qunit: {
      asyncTest: false,
      deepEqual: false,
      equal: false,
      expect: false,
      module: false,
      notDeepEqual: false,
      notEqual: false,
      notOk: false,
      notPropEqual: false,
      notStrictEqual: false,
      ok: false,
      propEqual: false,
      QUnit: false,
      raises: false,
      start: false,
      stop: false,
      strictEqual: false,
      test: false,
      throws: false
    },
    phantomjs: {
      console: true,
      exports: true,
      phantom: true,
      require: true,
      WebPage: true
    },
    couch: {
      emit: false,
      exports: false,
      getRow: false,
      log: false,
      module: false,
      provides: false,
      require: false,
      respond: false,
      send: false,
      start: false,
      sum: false
    },
    rhino: {
      defineClass: false,
      deserialize: false,
      gc: false,
      help: false,
      importClass: false,
      importPackage: false,
      java: false,
      load: false,
      loadClass: false,
      Packages: false,
      print: false,
      quit: false,
      readFile: false,
      readUrl: false,
      runCommand: false,
      seal: false,
      serialize: false,
      spawn: false,
      sync: false,
      toint32: false,
      version: false
    },
    nashorn: {
      __DIR__: false,
      __FILE__: false,
      __LINE__: false,
      com: false,
      edu: false,
      exit: false,
      java: false,
      Java: false,
      javafx: false,
      JavaImporter: false,
      javax: false,
      JSAdapter: false,
      load: false,
      loadWithNewGlobal: false,
      org: false,
      Packages: false,
      print: false,
      quit: false
    },
    wsh: {
      ActiveXObject: true,
      Enumerator: true,
      GetObject: true,
      ScriptEngine: true,
      ScriptEngineBuildVersion: true,
      ScriptEngineMajorVersion: true,
      ScriptEngineMinorVersion: true,
      VBArray: true,
      WScript: true,
      WSH: true,
      XDomainRequest: true
    },
    jquery: {
      $: false,
      jQuery: false
    },
    yui: {
      YAHOO: false,
      YAHOO_config: false,
      YUI: false,
      YUI_config: false
    },
    shelljs: {
      cat: false,
      cd: false,
      chmod: false,
      config: false,
      cp: false,
      dirs: false,
      echo: false,
      env: false,
      error: false,
      exec: false,
      exit: false,
      find: false,
      grep: false,
      ln: false,
      ls: false,
      mkdir: false,
      mv: false,
      popd: false,
      pushd: false,
      pwd: false,
      rm: false,
      sed: false,
      set: false,
      target: false,
      tempdir: false,
      test: false,
      touch: false,
      which: false
    },
    prototypejs: {
      $: false,
      $$: false,
      $A: false,
      $break: false,
      $continue: false,
      $F: false,
      $H: false,
      $R: false,
      $w: false,
      Abstract: false,
      Ajax: false,
      Autocompleter: false,
      Builder: false,
      Class: false,
      Control: false,
      Draggable: false,
      Draggables: false,
      Droppables: false,
      Effect: false,
      Element: false,
      Enumerable: false,
      Event: false,
      Field: false,
      Form: false,
      Hash: false,
      Insertion: false,
      ObjectRange: false,
      PeriodicalExecuter: false,
      Position: false,
      Prototype: false,
      Scriptaculous: false,
      Selector: false,
      Sortable: false,
      SortableObserver: false,
      Sound: false,
      Template: false,
      Toggle: false,
      Try: false
    },
    meteor: {
      _: false,
      $: false,
      Accounts: false,
      AccountsClient: false,
      AccountsCommon: false,
      AccountsServer: false,
      App: false,
      Assets: false,
      Blaze: false,
      check: false,
      Cordova: false,
      DDP: false,
      DDPRateLimiter: false,
      DDPServer: false,
      Deps: false,
      EJSON: false,
      Email: false,
      HTTP: false,
      Log: false,
      Match: false,
      Meteor: false,
      Mongo: false,
      MongoInternals: false,
      Npm: false,
      Package: false,
      Plugin: false,
      process: false,
      Random: false,
      ReactiveDict: false,
      ReactiveVar: false,
      Router: false,
      ServiceConfiguration: false,
      Session: false,
      share: false,
      Spacebars: false,
      Template: false,
      Tinytest: false,
      Tracker: false,
      UI: false,
      Utils: false,
      WebApp: false,
      WebAppInternals: false
    },
    mongo: {
      _isWindows: false,
      _rand: false,
      BulkWriteResult: false,
      cat: false,
      cd: false,
      connect: false,
      db: false,
      getHostName: false,
      getMemInfo: false,
      hostname: false,
      ISODate: false,
      listFiles: false,
      load: false,
      ls: false,
      md5sumFile: false,
      mkdir: false,
      Mongo: false,
      NumberInt: false,
      NumberLong: false,
      ObjectId: false,
      PlanCache: false,
      print: false,
      printjson: false,
      pwd: false,
      quit: false,
      removeFile: false,
      rs: false,
      sh: false,
      UUID: false,
      version: false,
      WriteResult: false
    },
    applescript: {
      $: false,
      Application: false,
      Automation: false,
      console: false,
      delay: false,
      Library: false,
      ObjC: false,
      ObjectSpecifier: false,
      Path: false,
      Progress: false,
      Ref: false
    },
    serviceworker: {
      addEventListener: false,
      applicationCache: false,
      atob: false,
      Blob: false,
      BroadcastChannel: false,
      btoa: false,
      Cache: false,
      caches: false,
      CacheStorage: false,
      clearInterval: false,
      clearTimeout: false,
      Client: false,
      clients: false,
      Clients: false,
      close: true,
      console: false,
      ExtendableEvent: false,
      ExtendableMessageEvent: false,
      fetch: false,
      FetchEvent: false,
      FileReaderSync: false,
      FormData: false,
      Headers: false,
      IDBCursor: false,
      IDBCursorWithValue: false,
      IDBDatabase: false,
      IDBFactory: false,
      IDBIndex: false,
      IDBKeyRange: false,
      IDBObjectStore: false,
      IDBOpenDBRequest: false,
      IDBRequest: false,
      IDBTransaction: false,
      IDBVersionChangeEvent: false,
      ImageData: false,
      importScripts: false,
      indexedDB: false,
      location: false,
      MessageChannel: false,
      MessagePort: false,
      name: false,
      navigator: false,
      Notification: false,
      onclose: true,
      onconnect: true,
      onerror: true,
      onfetch: true,
      oninstall: true,
      onlanguagechange: true,
      onmessage: true,
      onmessageerror: true,
      onnotificationclick: true,
      onnotificationclose: true,
      onoffline: true,
      ononline: true,
      onpush: true,
      onpushsubscriptionchange: true,
      onrejectionhandled: true,
      onsync: true,
      onunhandledrejection: true,
      performance: false,
      Performance: false,
      PerformanceEntry: false,
      PerformanceMark: false,
      PerformanceMeasure: false,
      PerformanceNavigation: false,
      PerformanceResourceTiming: false,
      PerformanceTiming: false,
      postMessage: true,
      Promise: false,
      queueMicrotask: false,
      registration: false,
      removeEventListener: false,
      Request: false,
      Response: false,
      self: false,
      ServiceWorker: false,
      ServiceWorkerContainer: false,
      ServiceWorkerGlobalScope: false,
      ServiceWorkerMessageEvent: false,
      ServiceWorkerRegistration: false,
      setInterval: false,
      setTimeout: false,
      skipWaiting: false,
      TextDecoder: false,
      TextEncoder: false,
      URL: false,
      URLSearchParams: false,
      WebSocket: false,
      WindowClient: false,
      Worker: false,
      WorkerGlobalScope: false,
      XMLHttpRequest: false
    },
    atomtest: {
      advanceClock: false,
      fakeClearInterval: false,
      fakeClearTimeout: false,
      fakeSetInterval: false,
      fakeSetTimeout: false,
      resetTimeouts: false,
      waitsForPromise: false
    },
    embertest: {
      andThen: false,
      click: false,
      currentPath: false,
      currentRouteName: false,
      currentURL: false,
      fillIn: false,
      find: false,
      findAll: false,
      findWithAssert: false,
      keyEvent: false,
      pauseTest: false,
      resumeTest: false,
      triggerEvent: false,
      visit: false,
      wait: false
    },
    protractor: {
      $: false,
      $$: false,
      browser: false,
      by: false,
      By: false,
      DartObject: false,
      element: false,
      protractor: false
    },
    "shared-node-browser": {
      clearInterval: false,
      clearTimeout: false,
      console: false,
      setInterval: false,
      setTimeout: false,
      URL: false,
      URLSearchParams: false
    },
    webextensions: {
      browser: false,
      chrome: false,
      opr: false
    },
    greasemonkey: {
      cloneInto: false,
      createObjectIn: false,
      exportFunction: false,
      GM: false,
      GM_addStyle: false,
      GM_deleteValue: false,
      GM_getResourceText: false,
      GM_getResourceURL: false,
      GM_getValue: false,
      GM_info: false,
      GM_listValues: false,
      GM_log: false,
      GM_openInTab: false,
      GM_registerMenuCommand: false,
      GM_setClipboard: false,
      GM_setValue: false,
      GM_xmlhttpRequest: false,
      unsafeWindow: false
    },
    devtools: {
      $: false,
      $_: false,
      $$: false,
      $0: false,
      $1: false,
      $2: false,
      $3: false,
      $4: false,
      $x: false,
      chrome: false,
      clear: false,
      copy: false,
      debug: false,
      dir: false,
      dirxml: false,
      getEventListeners: false,
      inspect: false,
      keys: false,
      monitor: false,
      monitorEvents: false,
      profile: false,
      profileEnd: false,
      queryObjects: false,
      table: false,
      undebug: false,
      unmonitor: false,
      unmonitorEvents: false,
      values: false
    }
  };
});
var require_cache = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.clear = clear;
  exports.clearPath = clearPath;
  exports.clearScope = clearScope;
  exports.getCachedPaths = getCachedPaths;
  exports.getOrCreateCachedPaths = getOrCreateCachedPaths;
  exports.scope = exports.path = undefined;
  var pathsCache = exports.path = new WeakMap;
  var scope = exports.scope = new WeakMap;
  function clear() {
    clearPath();
    clearScope();
  }
  function clearPath() {
    exports.path = pathsCache = new WeakMap;
  }
  function clearScope() {
    exports.scope = scope = new WeakMap;
  }
  var nullHub = Object.freeze({});
  function getCachedPaths(hub, parent) {
    var _pathsCache$get, _hub;
    {
      hub = null;
    }
    return (_pathsCache$get = pathsCache.get((_hub = hub) != null ? _hub : nullHub)) == null ? undefined : _pathsCache$get.get(parent);
  }
  function getOrCreateCachedPaths(hub, parent) {
    var _hub2, _hub3;
    {
      hub = null;
    }
    let parents = pathsCache.get((_hub2 = hub) != null ? _hub2 : nullHub);
    if (!parents)
      pathsCache.set((_hub3 = hub) != null ? _hub3 : nullHub, parents = new WeakMap);
    let paths = parents.get(parent);
    if (!paths)
      parents.set(parent, paths = new Map);
    return paths;
  }
});
var require_scope = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _renamer = require_renamer();
  var _index = require_lib11();
  var _binding = require_binding();
  var _globals = require_globals();
  var _t = require_lib6();
  var t = _t;
  var _cache = require_cache();
  var _visitors = require_visitors();
  var {
    NOT_LOCAL_BINDING,
    assignmentExpression,
    callExpression,
    cloneNode,
    getBindingIdentifiers,
    identifier,
    isArrayExpression,
    isBinary,
    isCallExpression,
    isClass,
    isClassBody,
    isClassDeclaration,
    isExportAllDeclaration,
    isExportDefaultDeclaration,
    isExportNamedDeclaration,
    isFunctionDeclaration,
    isIdentifier,
    isImportDeclaration,
    isLiteral,
    isMemberExpression,
    isMethod,
    isModuleSpecifier,
    isNullLiteral,
    isObjectExpression,
    isProperty,
    isPureish,
    isRegExpLiteral,
    isSuper,
    isTaggedTemplateExpression,
    isTemplateLiteral,
    isThisExpression,
    isUnaryExpression,
    isVariableDeclaration,
    expressionStatement,
    matchesPattern,
    memberExpression,
    numericLiteral,
    toIdentifier,
    variableDeclaration,
    variableDeclarator,
    isRecordExpression,
    isTupleExpression,
    isObjectProperty,
    isTopicReference,
    isMetaProperty,
    isPrivateName,
    isExportDeclaration,
    buildUndefinedNode,
    sequenceExpression
  } = _t;
  function gatherNodeParts(node, parts) {
    switch (node == null ? undefined : node.type) {
      default:
        if (isImportDeclaration(node) || isExportDeclaration(node)) {
          var _node$specifiers;
          if ((isExportAllDeclaration(node) || isExportNamedDeclaration(node) || isImportDeclaration(node)) && node.source) {
            gatherNodeParts(node.source, parts);
          } else if ((isExportNamedDeclaration(node) || isImportDeclaration(node)) && (_node$specifiers = node.specifiers) != null && _node$specifiers.length) {
            for (const e of node.specifiers)
              gatherNodeParts(e, parts);
          } else if ((isExportDefaultDeclaration(node) || isExportNamedDeclaration(node)) && node.declaration) {
            gatherNodeParts(node.declaration, parts);
          }
        } else if (isModuleSpecifier(node)) {
          gatherNodeParts(node.local, parts);
        } else if (isLiteral(node) && !isNullLiteral(node) && !isRegExpLiteral(node) && !isTemplateLiteral(node)) {
          parts.push(node.value);
        }
        break;
      case "MemberExpression":
      case "OptionalMemberExpression":
      case "JSXMemberExpression":
        gatherNodeParts(node.object, parts);
        gatherNodeParts(node.property, parts);
        break;
      case "Identifier":
      case "JSXIdentifier":
        parts.push(node.name);
        break;
      case "CallExpression":
      case "OptionalCallExpression":
      case "NewExpression":
        gatherNodeParts(node.callee, parts);
        break;
      case "ObjectExpression":
      case "ObjectPattern":
        for (const e of node.properties) {
          gatherNodeParts(e, parts);
        }
        break;
      case "SpreadElement":
      case "RestElement":
        gatherNodeParts(node.argument, parts);
        break;
      case "ObjectProperty":
      case "ObjectMethod":
      case "ClassProperty":
      case "ClassMethod":
      case "ClassPrivateProperty":
      case "ClassPrivateMethod":
        gatherNodeParts(node.key, parts);
        break;
      case "ThisExpression":
        parts.push("this");
        break;
      case "Super":
        parts.push("super");
        break;
      case "Import":
        parts.push("import");
        break;
      case "DoExpression":
        parts.push("do");
        break;
      case "YieldExpression":
        parts.push("yield");
        gatherNodeParts(node.argument, parts);
        break;
      case "AwaitExpression":
        parts.push("await");
        gatherNodeParts(node.argument, parts);
        break;
      case "AssignmentExpression":
        gatherNodeParts(node.left, parts);
        break;
      case "VariableDeclarator":
        gatherNodeParts(node.id, parts);
        break;
      case "FunctionExpression":
      case "FunctionDeclaration":
      case "ClassExpression":
      case "ClassDeclaration":
        gatherNodeParts(node.id, parts);
        break;
      case "PrivateName":
        gatherNodeParts(node.id, parts);
        break;
      case "ParenthesizedExpression":
        gatherNodeParts(node.expression, parts);
        break;
      case "UnaryExpression":
      case "UpdateExpression":
        gatherNodeParts(node.argument, parts);
        break;
      case "MetaProperty":
        gatherNodeParts(node.meta, parts);
        gatherNodeParts(node.property, parts);
        break;
      case "JSXElement":
        gatherNodeParts(node.openingElement, parts);
        break;
      case "JSXOpeningElement":
        gatherNodeParts(node.name, parts);
        break;
      case "JSXFragment":
        gatherNodeParts(node.openingFragment, parts);
        break;
      case "JSXOpeningFragment":
        parts.push("Fragment");
        break;
      case "JSXNamespacedName":
        gatherNodeParts(node.namespace, parts);
        gatherNodeParts(node.name, parts);
        break;
    }
  }
  var collectorVisitor = {
    ForStatement(path3) {
      const declar = path3.get("init");
      if (declar.isVar()) {
        const {
          scope
        } = path3;
        const parentScope = scope.getFunctionParent() || scope.getProgramParent();
        parentScope.registerBinding("var", declar);
      }
    },
    Declaration(path3) {
      if (path3.isBlockScoped())
        return;
      if (path3.isImportDeclaration())
        return;
      if (path3.isExportDeclaration())
        return;
      const parent = path3.scope.getFunctionParent() || path3.scope.getProgramParent();
      parent.registerDeclaration(path3);
    },
    ImportDeclaration(path3) {
      const parent = path3.scope.getBlockParent();
      parent.registerDeclaration(path3);
    },
    ReferencedIdentifier(path3, state) {
      state.references.push(path3);
    },
    ForXStatement(path3, state) {
      const left = path3.get("left");
      if (left.isPattern() || left.isIdentifier()) {
        state.constantViolations.push(path3);
      } else if (left.isVar()) {
        const {
          scope
        } = path3;
        const parentScope = scope.getFunctionParent() || scope.getProgramParent();
        parentScope.registerBinding("var", left);
      }
    },
    ExportDeclaration: {
      exit(path3) {
        const {
          node,
          scope
        } = path3;
        if (isExportAllDeclaration(node))
          return;
        const declar = node.declaration;
        if (isClassDeclaration(declar) || isFunctionDeclaration(declar)) {
          const id = declar.id;
          if (!id)
            return;
          const binding = scope.getBinding(id.name);
          binding == null || binding.reference(path3);
        } else if (isVariableDeclaration(declar)) {
          for (const decl of declar.declarations) {
            for (const name of Object.keys(getBindingIdentifiers(decl))) {
              const binding = scope.getBinding(name);
              binding == null || binding.reference(path3);
            }
          }
        }
      }
    },
    LabeledStatement(path3) {
      path3.scope.getBlockParent().registerDeclaration(path3);
    },
    AssignmentExpression(path3, state) {
      state.assignments.push(path3);
    },
    UpdateExpression(path3, state) {
      state.constantViolations.push(path3);
    },
    UnaryExpression(path3, state) {
      if (path3.node.operator === "delete") {
        state.constantViolations.push(path3);
      }
    },
    BlockScoped(path3) {
      let scope = path3.scope;
      if (scope.path === path3)
        scope = scope.parent;
      const parent = scope.getBlockParent();
      parent.registerDeclaration(path3);
      if (path3.isClassDeclaration() && path3.node.id) {
        const id = path3.node.id;
        const name = id.name;
        path3.scope.bindings[name] = path3.scope.parent.getBinding(name);
      }
    },
    CatchClause(path3) {
      path3.scope.registerBinding("let", path3);
    },
    Function(path3) {
      const params = path3.get("params");
      for (const param of params) {
        path3.scope.registerBinding("param", param);
      }
      if (path3.isFunctionExpression() && path3.node.id && !path3.node.id[NOT_LOCAL_BINDING]) {
        path3.scope.registerBinding("local", path3.get("id"), path3);
      }
    },
    ClassExpression(path3) {
      if (path3.node.id && !path3.node.id[NOT_LOCAL_BINDING]) {
        path3.scope.registerBinding("local", path3.get("id"), path3);
      }
    },
    TSTypeAnnotation(path3) {
      path3.skip();
    }
  };
  var uid = 0;

  class Scope {
    constructor(path3) {
      this.uid = undefined;
      this.path = undefined;
      this.block = undefined;
      this.inited = undefined;
      this.labels = undefined;
      this.bindings = undefined;
      this.references = undefined;
      this.globals = undefined;
      this.uids = undefined;
      this.data = undefined;
      this.crawling = undefined;
      const {
        node
      } = path3;
      const cached = _cache.scope.get(node);
      if ((cached == null ? undefined : cached.path) === path3) {
        return cached;
      }
      _cache.scope.set(node, this);
      this.uid = uid++;
      this.block = node;
      this.path = path3;
      this.labels = new Map;
      this.inited = false;
    }
    get parent() {
      var _parent;
      let parent, path3 = this.path;
      do {
        var _path;
        const shouldSkip = path3.key === "key" || path3.listKey === "decorators";
        path3 = path3.parentPath;
        if (shouldSkip && path3.isMethod())
          path3 = path3.parentPath;
        if ((_path = path3) != null && _path.isScope())
          parent = path3;
      } while (path3 && !parent);
      return (_parent = parent) == null ? undefined : _parent.scope;
    }
    generateDeclaredUidIdentifier(name) {
      const id = this.generateUidIdentifier(name);
      this.push({
        id
      });
      return cloneNode(id);
    }
    generateUidIdentifier(name) {
      return identifier(this.generateUid(name));
    }
    generateUid(name = "temp") {
      name = toIdentifier(name).replace(/^_+/, "").replace(/\d+$/g, "");
      let uid2;
      let i = 1;
      do {
        uid2 = `_${name}`;
        if (i > 1)
          uid2 += i;
        i++;
      } while (this.hasLabel(uid2) || this.hasBinding(uid2) || this.hasGlobal(uid2) || this.hasReference(uid2));
      const program = this.getProgramParent();
      program.references[uid2] = true;
      program.uids[uid2] = true;
      return uid2;
    }
    generateUidBasedOnNode(node, defaultName) {
      const parts = [];
      gatherNodeParts(node, parts);
      let id = parts.join("$");
      id = id.replace(/^_/, "") || defaultName || "ref";
      return this.generateUid(id.slice(0, 20));
    }
    generateUidIdentifierBasedOnNode(node, defaultName) {
      return identifier(this.generateUidBasedOnNode(node, defaultName));
    }
    isStatic(node) {
      if (isThisExpression(node) || isSuper(node) || isTopicReference(node)) {
        return true;
      }
      if (isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (binding) {
          return binding.constant;
        } else {
          return this.hasBinding(node.name);
        }
      }
      return false;
    }
    maybeGenerateMemoised(node, dontPush) {
      if (this.isStatic(node)) {
        return null;
      } else {
        const id = this.generateUidIdentifierBasedOnNode(node);
        if (!dontPush) {
          this.push({
            id
          });
          return cloneNode(id);
        }
        return id;
      }
    }
    checkBlockScopedCollisions(local, kind, name, id) {
      if (kind === "param")
        return;
      if (local.kind === "local")
        return;
      const duplicate = kind === "let" || local.kind === "let" || local.kind === "const" || local.kind === "module" || local.kind === "param" && kind === "const";
      if (duplicate) {
        throw this.path.hub.buildError(id, `Duplicate declaration "${name}"`, TypeError);
      }
    }
    rename(oldName, newName) {
      const binding = this.getBinding(oldName);
      if (binding) {
        newName || (newName = this.generateUidIdentifier(oldName).name);
        const renamer = new _renamer.default(binding, oldName, newName);
        {
          renamer.rename(arguments[2]);
        }
      }
    }
    dump() {
      const sep33 = "-".repeat(60);
      console.log(sep33);
      let scope = this;
      do {
        console.log("#", scope.block.type);
        for (const name of Object.keys(scope.bindings)) {
          const binding = scope.bindings[name];
          console.log(" -", name, {
            constant: binding.constant,
            references: binding.references,
            violations: binding.constantViolations.length,
            kind: binding.kind
          });
        }
      } while (scope = scope.parent);
      console.log(sep33);
    }
    hasLabel(name) {
      return !!this.getLabel(name);
    }
    getLabel(name) {
      return this.labels.get(name);
    }
    registerLabel(path3) {
      this.labels.set(path3.node.label.name, path3);
    }
    registerDeclaration(path3) {
      if (path3.isLabeledStatement()) {
        this.registerLabel(path3);
      } else if (path3.isFunctionDeclaration()) {
        this.registerBinding("hoisted", path3.get("id"), path3);
      } else if (path3.isVariableDeclaration()) {
        const declarations = path3.get("declarations");
        const {
          kind
        } = path3.node;
        for (const declar of declarations) {
          this.registerBinding(kind === "using" || kind === "await using" ? "const" : kind, declar);
        }
      } else if (path3.isClassDeclaration()) {
        if (path3.node.declare)
          return;
        this.registerBinding("let", path3);
      } else if (path3.isImportDeclaration()) {
        const isTypeDeclaration = path3.node.importKind === "type" || path3.node.importKind === "typeof";
        const specifiers = path3.get("specifiers");
        for (const specifier of specifiers) {
          const isTypeSpecifier = isTypeDeclaration || specifier.isImportSpecifier() && (specifier.node.importKind === "type" || specifier.node.importKind === "typeof");
          this.registerBinding(isTypeSpecifier ? "unknown" : "module", specifier);
        }
      } else if (path3.isExportDeclaration()) {
        const declar = path3.get("declaration");
        if (declar.isClassDeclaration() || declar.isFunctionDeclaration() || declar.isVariableDeclaration()) {
          this.registerDeclaration(declar);
        }
      } else {
        this.registerBinding("unknown", path3);
      }
    }
    buildUndefinedNode() {
      return buildUndefinedNode();
    }
    registerConstantViolation(path3) {
      const ids = path3.getAssignmentIdentifiers();
      for (const name of Object.keys(ids)) {
        var _this$getBinding;
        (_this$getBinding = this.getBinding(name)) == null || _this$getBinding.reassign(path3);
      }
    }
    registerBinding(kind, path3, bindingPath = path3) {
      if (!kind)
        throw new ReferenceError("no `kind`");
      if (path3.isVariableDeclaration()) {
        const declarators = path3.get("declarations");
        for (const declar of declarators) {
          this.registerBinding(kind, declar);
        }
        return;
      }
      const parent = this.getProgramParent();
      const ids = path3.getOuterBindingIdentifiers(true);
      for (const name of Object.keys(ids)) {
        parent.references[name] = true;
        for (const id of ids[name]) {
          const local = this.getOwnBinding(name);
          if (local) {
            if (local.identifier === id)
              continue;
            this.checkBlockScopedCollisions(local, kind, name, id);
          }
          if (local) {
            local.reassign(bindingPath);
          } else {
            this.bindings[name] = new _binding.default({
              identifier: id,
              scope: this,
              path: bindingPath,
              kind
            });
          }
        }
      }
    }
    addGlobal(node) {
      this.globals[node.name] = node;
    }
    hasUid(name) {
      let scope = this;
      do {
        if (scope.uids[name])
          return true;
      } while (scope = scope.parent);
      return false;
    }
    hasGlobal(name) {
      let scope = this;
      do {
        if (scope.globals[name])
          return true;
      } while (scope = scope.parent);
      return false;
    }
    hasReference(name) {
      return !!this.getProgramParent().references[name];
    }
    isPure(node, constantsOnly) {
      if (isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (!binding)
          return false;
        if (constantsOnly)
          return binding.constant;
        return true;
      } else if (isThisExpression(node) || isMetaProperty(node) || isTopicReference(node) || isPrivateName(node)) {
        return true;
      } else if (isClass(node)) {
        var _node$decorators;
        if (node.superClass && !this.isPure(node.superClass, constantsOnly)) {
          return false;
        }
        if (((_node$decorators = node.decorators) == null ? undefined : _node$decorators.length) > 0) {
          return false;
        }
        return this.isPure(node.body, constantsOnly);
      } else if (isClassBody(node)) {
        for (const method of node.body) {
          if (!this.isPure(method, constantsOnly))
            return false;
        }
        return true;
      } else if (isBinary(node)) {
        return this.isPure(node.left, constantsOnly) && this.isPure(node.right, constantsOnly);
      } else if (isArrayExpression(node) || isTupleExpression(node)) {
        for (const elem of node.elements) {
          if (elem !== null && !this.isPure(elem, constantsOnly))
            return false;
        }
        return true;
      } else if (isObjectExpression(node) || isRecordExpression(node)) {
        for (const prop of node.properties) {
          if (!this.isPure(prop, constantsOnly))
            return false;
        }
        return true;
      } else if (isMethod(node)) {
        var _node$decorators2;
        if (node.computed && !this.isPure(node.key, constantsOnly))
          return false;
        if (((_node$decorators2 = node.decorators) == null ? undefined : _node$decorators2.length) > 0) {
          return false;
        }
        return true;
      } else if (isProperty(node)) {
        var _node$decorators3;
        if (node.computed && !this.isPure(node.key, constantsOnly))
          return false;
        if (((_node$decorators3 = node.decorators) == null ? undefined : _node$decorators3.length) > 0) {
          return false;
        }
        if (isObjectProperty(node) || node.static) {
          if (node.value !== null && !this.isPure(node.value, constantsOnly)) {
            return false;
          }
        }
        return true;
      } else if (isUnaryExpression(node)) {
        return this.isPure(node.argument, constantsOnly);
      } else if (isTemplateLiteral(node)) {
        for (const expression of node.expressions) {
          if (!this.isPure(expression, constantsOnly))
            return false;
        }
        return true;
      } else if (isTaggedTemplateExpression(node)) {
        return matchesPattern(node.tag, "String.raw") && !this.hasBinding("String", {
          noGlobals: true
        }) && this.isPure(node.quasi, constantsOnly);
      } else if (isMemberExpression(node)) {
        return !node.computed && isIdentifier(node.object) && node.object.name === "Symbol" && isIdentifier(node.property) && node.property.name !== "for" && !this.hasBinding("Symbol", {
          noGlobals: true
        });
      } else if (isCallExpression(node)) {
        return matchesPattern(node.callee, "Symbol.for") && !this.hasBinding("Symbol", {
          noGlobals: true
        }) && node.arguments.length === 1 && t.isStringLiteral(node.arguments[0]);
      } else {
        return isPureish(node);
      }
    }
    setData(key, val2) {
      return this.data[key] = val2;
    }
    getData(key) {
      let scope = this;
      do {
        const data = scope.data[key];
        if (data != null)
          return data;
      } while (scope = scope.parent);
    }
    removeData(key) {
      let scope = this;
      do {
        const data = scope.data[key];
        if (data != null)
          scope.data[key] = null;
      } while (scope = scope.parent);
    }
    init() {
      if (!this.inited) {
        this.inited = true;
        this.crawl();
      }
    }
    crawl() {
      const path3 = this.path;
      this.references = Object.create(null);
      this.bindings = Object.create(null);
      this.globals = Object.create(null);
      this.uids = Object.create(null);
      this.data = Object.create(null);
      const programParent = this.getProgramParent();
      if (programParent.crawling)
        return;
      const state = {
        references: [],
        constantViolations: [],
        assignments: []
      };
      this.crawling = true;
      if (path3.type !== "Program" && (0, _visitors.isExplodedVisitor)(collectorVisitor)) {
        for (const visit of collectorVisitor.enter) {
          visit.call(state, path3, state);
        }
        const typeVisitors = collectorVisitor[path3.type];
        if (typeVisitors) {
          for (const visit of typeVisitors.enter) {
            visit.call(state, path3, state);
          }
        }
      }
      path3.traverse(collectorVisitor, state);
      this.crawling = false;
      for (const path42 of state.assignments) {
        const ids = path42.getAssignmentIdentifiers();
        for (const name of Object.keys(ids)) {
          if (path42.scope.getBinding(name))
            continue;
          programParent.addGlobal(ids[name]);
        }
        path42.scope.registerConstantViolation(path42);
      }
      for (const ref of state.references) {
        const binding = ref.scope.getBinding(ref.node.name);
        if (binding) {
          binding.reference(ref);
        } else {
          programParent.addGlobal(ref.node);
        }
      }
      for (const path42 of state.constantViolations) {
        path42.scope.registerConstantViolation(path42);
      }
    }
    push(opts) {
      let path3 = this.path;
      if (path3.isPattern()) {
        path3 = this.getPatternParent().path;
      } else if (!path3.isBlockStatement() && !path3.isProgram()) {
        path3 = this.getBlockParent().path;
      }
      if (path3.isSwitchStatement()) {
        path3 = (this.getFunctionParent() || this.getProgramParent()).path;
      }
      const {
        init: init22,
        unique,
        kind = "var",
        id
      } = opts;
      if (!init22 && !unique && (kind === "var" || kind === "let") && path3.isFunction() && !path3.node.name && isCallExpression(path3.parent, {
        callee: path3.node
      }) && path3.parent.arguments.length <= path3.node.params.length && isIdentifier(id)) {
        path3.pushContainer("params", id);
        path3.scope.registerBinding("param", path3.get("params")[path3.node.params.length - 1]);
        return;
      }
      if (path3.isLoop() || path3.isCatchClause() || path3.isFunction()) {
        path3.ensureBlock();
        path3 = path3.get("body");
      }
      const blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
      const dataKey = `declaration:${kind}:${blockHoist}`;
      let declarPath = !unique && path3.getData(dataKey);
      if (!declarPath) {
        const declar = variableDeclaration(kind, []);
        declar._blockHoist = blockHoist;
        [declarPath] = path3.unshiftContainer("body", [declar]);
        if (!unique)
          path3.setData(dataKey, declarPath);
      }
      const declarator = variableDeclarator(id, init22);
      const len = declarPath.node.declarations.push(declarator);
      path3.scope.registerBinding(kind, declarPath.get("declarations")[len - 1]);
    }
    getProgramParent() {
      let scope = this;
      do {
        if (scope.path.isProgram()) {
          return scope;
        }
      } while (scope = scope.parent);
      throw new Error("Couldn't find a Program");
    }
    getFunctionParent() {
      let scope = this;
      do {
        if (scope.path.isFunctionParent()) {
          return scope;
        }
      } while (scope = scope.parent);
      return null;
    }
    getBlockParent() {
      let scope = this;
      do {
        if (scope.path.isBlockParent()) {
          return scope;
        }
      } while (scope = scope.parent);
      throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
    }
    getPatternParent() {
      let scope = this;
      do {
        if (!scope.path.isPattern()) {
          return scope.getBlockParent();
        }
      } while (scope = scope.parent.parent);
      throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
    }
    getAllBindings() {
      const ids = Object.create(null);
      let scope = this;
      do {
        for (const key of Object.keys(scope.bindings)) {
          if (key in ids === false) {
            ids[key] = scope.bindings[key];
          }
        }
        scope = scope.parent;
      } while (scope);
      return ids;
    }
    bindingIdentifierEquals(name, node) {
      return this.getBindingIdentifier(name) === node;
    }
    getBinding(name) {
      let scope = this;
      let previousPath;
      do {
        const binding = scope.getOwnBinding(name);
        if (binding) {
          var _previousPath;
          if ((_previousPath = previousPath) != null && _previousPath.isPattern() && binding.kind !== "param" && binding.kind !== "local") {
          } else {
            return binding;
          }
        } else if (!binding && name === "arguments" && scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
          break;
        }
        previousPath = scope.path;
      } while (scope = scope.parent);
    }
    getOwnBinding(name) {
      return this.bindings[name];
    }
    getBindingIdentifier(name) {
      var _this$getBinding2;
      return (_this$getBinding2 = this.getBinding(name)) == null ? undefined : _this$getBinding2.identifier;
    }
    getOwnBindingIdentifier(name) {
      const binding = this.bindings[name];
      return binding == null ? undefined : binding.identifier;
    }
    hasOwnBinding(name) {
      return !!this.getOwnBinding(name);
    }
    hasBinding(name, opts) {
      if (!name)
        return false;
      let scope = this;
      do {
        if (scope.hasOwnBinding(name)) {
          return true;
        }
      } while (scope = scope.parent);
      let noGlobals;
      let noUids;
      if (typeof opts === "object") {
        noGlobals = opts.noGlobals;
        noUids = opts.noUids;
      } else if (typeof opts === "boolean") {
        noGlobals = opts;
      }
      if (!noUids && this.hasUid(name))
        return true;
      if (!noGlobals && Scope.globals.includes(name))
        return true;
      if (!noGlobals && Scope.contextVariables.includes(name))
        return true;
      return false;
    }
    parentHasBinding(name, opts) {
      var _this$parent;
      return (_this$parent = this.parent) == null ? undefined : _this$parent.hasBinding(name, opts);
    }
    moveBindingTo(name, scope) {
      const info = this.getBinding(name);
      if (info) {
        info.scope.removeOwnBinding(name);
        info.scope = scope;
        scope.bindings[name] = info;
      }
    }
    removeOwnBinding(name) {
      delete this.bindings[name];
    }
    removeBinding(name) {
      var _this$getBinding3;
      (_this$getBinding3 = this.getBinding(name)) == null || _this$getBinding3.scope.removeOwnBinding(name);
      let scope = this;
      do {
        if (scope.uids[name]) {
          scope.uids[name] = false;
        }
      } while (scope = scope.parent);
    }
    hoistVariables(emit = (id) => this.push({
      id
    })) {
      this.crawl();
      const seen = new Set;
      for (const name of Object.keys(this.bindings)) {
        const binding = this.bindings[name];
        if (!binding)
          continue;
        const {
          path: path3
        } = binding;
        if (!path3.isVariableDeclarator())
          continue;
        const {
          parent,
          parentPath
        } = path3;
        if (parent.kind !== "var" || seen.has(parent))
          continue;
        seen.add(path3.parent);
        let firstId;
        const init22 = [];
        for (const decl of parent.declarations) {
          var _firstId;
          (_firstId = firstId) != null || (firstId = decl.id);
          if (decl.init) {
            init22.push(assignmentExpression("=", decl.id, decl.init));
          }
          const ids = Object.keys(getBindingIdentifiers(decl, false, true, true));
          for (const name2 of ids) {
            emit(identifier(name2), decl.init != null);
          }
        }
        if (parentPath.parentPath.isFor({
          left: parent
        })) {
          parentPath.replaceWith(firstId);
        } else if (init22.length === 0) {
          parentPath.remove();
        } else {
          const expr = init22.length === 1 ? init22[0] : sequenceExpression(init22);
          if (parentPath.parentPath.isForStatement({
            init: parent
          })) {
            parentPath.replaceWith(expr);
          } else {
            parentPath.replaceWith(expressionStatement(expr));
          }
        }
      }
    }
  }
  exports.default = Scope;
  Scope.globals = Object.keys(_globals.builtin);
  Scope.contextVariables = ["arguments", "undefined", "Infinity", "NaN"];
  {
    Scope.prototype._renameFromMap = function _renameFromMap(map, oldName, newName, value) {
      if (map[oldName]) {
        map[newName] = value;
        map[oldName] = null;
      }
    };
    Scope.prototype.traverse = function(node, opts, state) {
      (0, _index.default)(node, opts, this, state, this.path);
    };
    Scope.prototype._generateUid = function _generateUid(name, i) {
      let id = name;
      if (i > 1)
        id += i;
      return `_${id}`;
    };
    Scope.prototype.toArray = function toArray(node, i, arrayLikeIsIterable) {
      if (isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (binding != null && binding.constant && binding.path.isGenericType("Array")) {
          return node;
        }
      }
      if (isArrayExpression(node)) {
        return node;
      }
      if (isIdentifier(node, {
        name: "arguments"
      })) {
        return callExpression(memberExpression(memberExpression(memberExpression(identifier("Array"), identifier("prototype")), identifier("slice")), identifier("call")), [node]);
      }
      let helperName;
      const args = [node];
      if (i === true) {
        helperName = "toConsumableArray";
      } else if (typeof i === "number") {
        args.push(numericLiteral(i));
        helperName = "slicedToArray";
      } else {
        helperName = "toArray";
      }
      if (arrayLikeIsIterable) {
        args.unshift(this.path.hub.addHelper(helperName));
        helperName = "maybeArrayLike";
      }
      return callExpression(this.path.hub.addHelper(helperName), args);
    };
    Scope.prototype.getAllBindingsOfKind = function getAllBindingsOfKind(...kinds) {
      const ids = Object.create(null);
      for (const kind of kinds) {
        let scope = this;
        do {
          for (const name of Object.keys(scope.bindings)) {
            const binding = scope.bindings[name];
            if (binding.kind === kind)
              ids[name] = binding;
          }
          scope = scope.parent;
        } while (scope);
      }
      return ids;
    };
    Object.defineProperties(Scope.prototype, {
      parentBlock: {
        configurable: true,
        enumerable: true,
        get() {
          return this.path.parent;
        }
      },
      hub: {
        configurable: true,
        enumerable: true,
        get() {
          return this.path.hub;
        }
      }
    });
  }
});
var require_set_array_umd = __commonJS2((exports, module) => {
  (function(global22, factory) {
    typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global22 = typeof globalThis !== "undefined" ? globalThis : global22 || self, factory(global22.setArray = {}));
  })(exports, function(exports2) {

    class SetArray {
      constructor() {
        this._indexes = { __proto__: null };
        this.array = [];
      }
    }
    function cast(set) {
      return set;
    }
    function get(setarr, key) {
      return cast(setarr)._indexes[key];
    }
    function put(setarr, key) {
      const index = get(setarr, key);
      if (index !== undefined)
        return index;
      const { array, _indexes: indexes } = cast(setarr);
      const length = array.push(key);
      return indexes[key] = length - 1;
    }
    function pop(setarr) {
      const { array, _indexes: indexes } = cast(setarr);
      if (array.length === 0)
        return;
      const last = array.pop();
      indexes[last] = undefined;
    }
    function remove(setarr, key) {
      const index = get(setarr, key);
      if (index === undefined)
        return;
      const { array, _indexes: indexes } = cast(setarr);
      for (let i = index + 1;i < array.length; i++) {
        const k = array[i];
        array[i - 1] = k;
        indexes[k]--;
      }
      indexes[key] = undefined;
      array.pop();
    }
    exports2.SetArray = SetArray;
    exports2.get = get;
    exports2.pop = pop;
    exports2.put = put;
    exports2.remove = remove;
    Object.defineProperty(exports2, "__esModule", { value: true });
  });
});
var require_sourcemap_codec_umd = __commonJS2((exports, module) => {
  (function(global22, factory) {
    typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global22 = typeof globalThis !== "undefined" ? globalThis : global22 || self, factory(global22.sourcemapCodec = {}));
  })(exports, function(exports2) {
    const comma = ",".charCodeAt(0);
    const semicolon = ";".charCodeAt(0);
    const chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    const intToChar = new Uint8Array(64);
    const charToInt = new Uint8Array(128);
    for (let i = 0;i < chars.length; i++) {
      const c22 = chars.charCodeAt(i);
      intToChar[i] = c22;
      charToInt[c22] = i;
    }
    function decodeInteger(reader, relative22) {
      let value = 0;
      let shift = 0;
      let integer = 0;
      do {
        const c22 = reader.next();
        integer = charToInt[c22];
        value |= (integer & 31) << shift;
        shift += 5;
      } while (integer & 32);
      const shouldNegate = value & 1;
      value >>>= 1;
      if (shouldNegate) {
        value = -2147483648 | -value;
      }
      return relative22 + value;
    }
    function encodeInteger(builder, num, relative22) {
      let delta = num - relative22;
      delta = delta < 0 ? -delta << 1 | 1 : delta << 1;
      do {
        let clamped = delta & 31;
        delta >>>= 5;
        if (delta > 0)
          clamped |= 32;
        builder.write(intToChar[clamped]);
      } while (delta > 0);
      return num;
    }
    function hasMoreVlq(reader, max) {
      if (reader.pos >= max)
        return false;
      return reader.peek() !== comma;
    }
    const bufLength = 16384;
    const td = typeof TextDecoder !== "undefined" ? /* @__PURE__ */ new TextDecoder : typeof Buffer !== "undefined" ? {
      decode(buf) {
        const out = Buffer.from(buf.buffer, buf.byteOffset, buf.byteLength);
        return out.toString();
      }
    } : {
      decode(buf) {
        let out = "";
        for (let i = 0;i < buf.length; i++) {
          out += String.fromCharCode(buf[i]);
        }
        return out;
      }
    };

    class StringWriter {
      constructor() {
        this.pos = 0;
        this.out = "";
        this.buffer = new Uint8Array(bufLength);
      }
      write(v22) {
        const { buffer } = this;
        buffer[this.pos++] = v22;
        if (this.pos === bufLength) {
          this.out += td.decode(buffer);
          this.pos = 0;
        }
      }
      flush() {
        const { buffer, out, pos } = this;
        return pos > 0 ? out + td.decode(buffer.subarray(0, pos)) : out;
      }
    }

    class StringReader {
      constructor(buffer) {
        this.pos = 0;
        this.buffer = buffer;
      }
      next() {
        return this.buffer.charCodeAt(this.pos++);
      }
      peek() {
        return this.buffer.charCodeAt(this.pos);
      }
      indexOf(char) {
        const { buffer, pos } = this;
        const idx = buffer.indexOf(char, pos);
        return idx === -1 ? buffer.length : idx;
      }
    }
    const EMPTY = [];
    function decodeOriginalScopes(input) {
      const { length } = input;
      const reader = new StringReader(input);
      const scopes = [];
      const stack = [];
      let line = 0;
      for (;reader.pos < length; reader.pos++) {
        line = decodeInteger(reader, line);
        const column = decodeInteger(reader, 0);
        if (!hasMoreVlq(reader, length)) {
          const last = stack.pop();
          last[2] = line;
          last[3] = column;
          continue;
        }
        const kind = decodeInteger(reader, 0);
        const fields22 = decodeInteger(reader, 0);
        const hasName = fields22 & 1;
        const scope = hasName ? [line, column, 0, 0, kind, decodeInteger(reader, 0)] : [line, column, 0, 0, kind];
        let vars = EMPTY;
        if (hasMoreVlq(reader, length)) {
          vars = [];
          do {
            const varsIndex = decodeInteger(reader, 0);
            vars.push(varsIndex);
          } while (hasMoreVlq(reader, length));
        }
        scope.vars = vars;
        scopes.push(scope);
        stack.push(scope);
      }
      return scopes;
    }
    function encodeOriginalScopes(scopes) {
      const writer = new StringWriter;
      for (let i = 0;i < scopes.length; ) {
        i = _encodeOriginalScopes(scopes, i, writer, [0]);
      }
      return writer.flush();
    }
    function _encodeOriginalScopes(scopes, index, writer, state) {
      const scope = scopes[index];
      const { 0: startLine, 1: startColumn, 2: endLine, 3: endColumn, 4: kind, vars } = scope;
      if (index > 0)
        writer.write(comma);
      state[0] = encodeInteger(writer, startLine, state[0]);
      encodeInteger(writer, startColumn, 0);
      encodeInteger(writer, kind, 0);
      const fields22 = scope.length === 6 ? 1 : 0;
      encodeInteger(writer, fields22, 0);
      if (scope.length === 6)
        encodeInteger(writer, scope[5], 0);
      for (const v22 of vars) {
        encodeInteger(writer, v22, 0);
      }
      for (index++;index < scopes.length; ) {
        const next = scopes[index];
        const { 0: l22, 1: c22 } = next;
        if (l22 > endLine || l22 === endLine && c22 >= endColumn) {
          break;
        }
        index = _encodeOriginalScopes(scopes, index, writer, state);
      }
      writer.write(comma);
      state[0] = encodeInteger(writer, endLine, state[0]);
      encodeInteger(writer, endColumn, 0);
      return index;
    }
    function decodeGeneratedRanges(input) {
      const { length } = input;
      const reader = new StringReader(input);
      const ranges = [];
      const stack = [];
      let genLine = 0;
      let definitionSourcesIndex = 0;
      let definitionScopeIndex = 0;
      let callsiteSourcesIndex = 0;
      let callsiteLine = 0;
      let callsiteColumn = 0;
      let bindingLine = 0;
      let bindingColumn = 0;
      do {
        const semi = reader.indexOf(";");
        let genColumn = 0;
        for (;reader.pos < semi; reader.pos++) {
          genColumn = decodeInteger(reader, genColumn);
          if (!hasMoreVlq(reader, semi)) {
            const last = stack.pop();
            last[2] = genLine;
            last[3] = genColumn;
            continue;
          }
          const fields22 = decodeInteger(reader, 0);
          const hasDefinition = fields22 & 1;
          const hasCallsite = fields22 & 2;
          const hasScope = fields22 & 4;
          let callsite = null;
          let bindings = EMPTY;
          let range;
          if (hasDefinition) {
            const defSourcesIndex = decodeInteger(reader, definitionSourcesIndex);
            definitionScopeIndex = decodeInteger(reader, definitionSourcesIndex === defSourcesIndex ? definitionScopeIndex : 0);
            definitionSourcesIndex = defSourcesIndex;
            range = [genLine, genColumn, 0, 0, defSourcesIndex, definitionScopeIndex];
          } else {
            range = [genLine, genColumn, 0, 0];
          }
          range.isScope = !!hasScope;
          if (hasCallsite) {
            const prevCsi = callsiteSourcesIndex;
            const prevLine = callsiteLine;
            callsiteSourcesIndex = decodeInteger(reader, callsiteSourcesIndex);
            const sameSource = prevCsi === callsiteSourcesIndex;
            callsiteLine = decodeInteger(reader, sameSource ? callsiteLine : 0);
            callsiteColumn = decodeInteger(reader, sameSource && prevLine === callsiteLine ? callsiteColumn : 0);
            callsite = [callsiteSourcesIndex, callsiteLine, callsiteColumn];
          }
          range.callsite = callsite;
          if (hasMoreVlq(reader, semi)) {
            bindings = [];
            do {
              bindingLine = genLine;
              bindingColumn = genColumn;
              const expressionsCount = decodeInteger(reader, 0);
              let expressionRanges;
              if (expressionsCount < -1) {
                expressionRanges = [[decodeInteger(reader, 0)]];
                for (let i = -1;i > expressionsCount; i--) {
                  const prevBl = bindingLine;
                  bindingLine = decodeInteger(reader, bindingLine);
                  bindingColumn = decodeInteger(reader, bindingLine === prevBl ? bindingColumn : 0);
                  const expression = decodeInteger(reader, 0);
                  expressionRanges.push([expression, bindingLine, bindingColumn]);
                }
              } else {
                expressionRanges = [[expressionsCount]];
              }
              bindings.push(expressionRanges);
            } while (hasMoreVlq(reader, semi));
          }
          range.bindings = bindings;
          ranges.push(range);
          stack.push(range);
        }
        genLine++;
        reader.pos = semi + 1;
      } while (reader.pos < length);
      return ranges;
    }
    function encodeGeneratedRanges(ranges) {
      if (ranges.length === 0)
        return "";
      const writer = new StringWriter;
      for (let i = 0;i < ranges.length; ) {
        i = _encodeGeneratedRanges(ranges, i, writer, [0, 0, 0, 0, 0, 0, 0]);
      }
      return writer.flush();
    }
    function _encodeGeneratedRanges(ranges, index, writer, state) {
      const range = ranges[index];
      const { 0: startLine, 1: startColumn, 2: endLine, 3: endColumn, isScope, callsite, bindings } = range;
      if (state[0] < startLine) {
        catchupLine(writer, state[0], startLine);
        state[0] = startLine;
        state[1] = 0;
      } else if (index > 0) {
        writer.write(comma);
      }
      state[1] = encodeInteger(writer, range[1], state[1]);
      const fields22 = (range.length === 6 ? 1 : 0) | (callsite ? 2 : 0) | (isScope ? 4 : 0);
      encodeInteger(writer, fields22, 0);
      if (range.length === 6) {
        const { 4: sourcesIndex, 5: scopesIndex } = range;
        if (sourcesIndex !== state[2]) {
          state[3] = 0;
        }
        state[2] = encodeInteger(writer, sourcesIndex, state[2]);
        state[3] = encodeInteger(writer, scopesIndex, state[3]);
      }
      if (callsite) {
        const { 0: sourcesIndex, 1: callLine, 2: callColumn } = range.callsite;
        if (sourcesIndex !== state[4]) {
          state[5] = 0;
          state[6] = 0;
        } else if (callLine !== state[5]) {
          state[6] = 0;
        }
        state[4] = encodeInteger(writer, sourcesIndex, state[4]);
        state[5] = encodeInteger(writer, callLine, state[5]);
        state[6] = encodeInteger(writer, callColumn, state[6]);
      }
      if (bindings) {
        for (const binding of bindings) {
          if (binding.length > 1)
            encodeInteger(writer, -binding.length, 0);
          const expression = binding[0][0];
          encodeInteger(writer, expression, 0);
          let bindingStartLine = startLine;
          let bindingStartColumn = startColumn;
          for (let i = 1;i < binding.length; i++) {
            const expRange = binding[i];
            bindingStartLine = encodeInteger(writer, expRange[1], bindingStartLine);
            bindingStartColumn = encodeInteger(writer, expRange[2], bindingStartColumn);
            encodeInteger(writer, expRange[0], 0);
          }
        }
      }
      for (index++;index < ranges.length; ) {
        const next = ranges[index];
        const { 0: l22, 1: c22 } = next;
        if (l22 > endLine || l22 === endLine && c22 >= endColumn) {
          break;
        }
        index = _encodeGeneratedRanges(ranges, index, writer, state);
      }
      if (state[0] < endLine) {
        catchupLine(writer, state[0], endLine);
        state[0] = endLine;
        state[1] = 0;
      } else {
        writer.write(comma);
      }
      state[1] = encodeInteger(writer, endColumn, state[1]);
      return index;
    }
    function catchupLine(writer, lastLine, line) {
      do {
        writer.write(semicolon);
      } while (++lastLine < line);
    }
    function decode(mappings) {
      const { length } = mappings;
      const reader = new StringReader(mappings);
      const decoded = [];
      let genColumn = 0;
      let sourcesIndex = 0;
      let sourceLine = 0;
      let sourceColumn = 0;
      let namesIndex = 0;
      do {
        const semi = reader.indexOf(";");
        const line = [];
        let sorted = true;
        let lastCol = 0;
        genColumn = 0;
        while (reader.pos < semi) {
          let seg;
          genColumn = decodeInteger(reader, genColumn);
          if (genColumn < lastCol)
            sorted = false;
          lastCol = genColumn;
          if (hasMoreVlq(reader, semi)) {
            sourcesIndex = decodeInteger(reader, sourcesIndex);
            sourceLine = decodeInteger(reader, sourceLine);
            sourceColumn = decodeInteger(reader, sourceColumn);
            if (hasMoreVlq(reader, semi)) {
              namesIndex = decodeInteger(reader, namesIndex);
              seg = [genColumn, sourcesIndex, sourceLine, sourceColumn, namesIndex];
            } else {
              seg = [genColumn, sourcesIndex, sourceLine, sourceColumn];
            }
          } else {
            seg = [genColumn];
          }
          line.push(seg);
          reader.pos++;
        }
        if (!sorted)
          sort(line);
        decoded.push(line);
        reader.pos = semi + 1;
      } while (reader.pos <= length);
      return decoded;
    }
    function sort(line) {
      line.sort(sortComparator);
    }
    function sortComparator(a, b22) {
      return a[0] - b22[0];
    }
    function encode(decoded) {
      const writer = new StringWriter;
      let sourcesIndex = 0;
      let sourceLine = 0;
      let sourceColumn = 0;
      let namesIndex = 0;
      for (let i = 0;i < decoded.length; i++) {
        const line = decoded[i];
        if (i > 0)
          writer.write(semicolon);
        if (line.length === 0)
          continue;
        let genColumn = 0;
        for (let j22 = 0;j22 < line.length; j22++) {
          const segment = line[j22];
          if (j22 > 0)
            writer.write(comma);
          genColumn = encodeInteger(writer, segment[0], genColumn);
          if (segment.length === 1)
            continue;
          sourcesIndex = encodeInteger(writer, segment[1], sourcesIndex);
          sourceLine = encodeInteger(writer, segment[2], sourceLine);
          sourceColumn = encodeInteger(writer, segment[3], sourceColumn);
          if (segment.length === 4)
            continue;
          namesIndex = encodeInteger(writer, segment[4], namesIndex);
        }
      }
      return writer.flush();
    }
    exports2.decode = decode;
    exports2.decodeGeneratedRanges = decodeGeneratedRanges;
    exports2.decodeOriginalScopes = decodeOriginalScopes;
    exports2.encode = encode;
    exports2.encodeGeneratedRanges = encodeGeneratedRanges;
    exports2.encodeOriginalScopes = encodeOriginalScopes;
    Object.defineProperty(exports2, "__esModule", { value: true });
  });
});
var require_resolve_uri_umd = __commonJS2((exports, module) => {
  (function(global22, factory) {
    typeof exports === "object" && typeof module !== "undefined" ? module.exports = factory() : typeof define === "function" && define.amd ? define(factory) : (global22 = typeof globalThis !== "undefined" ? globalThis : global22 || self, global22.resolveURI = factory());
  })(exports, function() {
    const schemeRegex = /^[\w+.-]+:\/\//;
    const urlRegex = /^([\w+.-]+:)\/\/([^@/#?]*@)?([^:/#?]*)(:\d+)?(\/[^#?]*)?(\?[^#]*)?(#.*)?/;
    const fileRegex = /^file:(?:\/\/((?![a-z]:)[^/#?]*)?)?(\/?[^#?]*)(\?[^#]*)?(#.*)?/i;
    function isAbsoluteUrl(input) {
      return schemeRegex.test(input);
    }
    function isSchemeRelativeUrl(input) {
      return input.startsWith("//");
    }
    function isAbsolutePath(input) {
      return input.startsWith("/");
    }
    function isFileUrl(input) {
      return input.startsWith("file:");
    }
    function isRelative(input) {
      return /^[.?#]/.test(input);
    }
    function parseAbsoluteUrl(input) {
      const match = urlRegex.exec(input);
      return makeUrl(match[1], match[2] || "", match[3], match[4] || "", match[5] || "/", match[6] || "", match[7] || "");
    }
    function parseFileUrl(input) {
      const match = fileRegex.exec(input);
      const path3 = match[2];
      return makeUrl("file:", "", match[1] || "", "", isAbsolutePath(path3) ? path3 : "/" + path3, match[3] || "", match[4] || "");
    }
    function makeUrl(scheme, user, host, port, path3, query, hash) {
      return {
        scheme,
        user,
        host,
        port,
        path: path3,
        query,
        hash,
        type: 7
      };
    }
    function parseUrl(input) {
      if (isSchemeRelativeUrl(input)) {
        const url2 = parseAbsoluteUrl("http:" + input);
        url2.scheme = "";
        url2.type = 6;
        return url2;
      }
      if (isAbsolutePath(input)) {
        const url2 = parseAbsoluteUrl("http://foo.com" + input);
        url2.scheme = "";
        url2.host = "";
        url2.type = 5;
        return url2;
      }
      if (isFileUrl(input))
        return parseFileUrl(input);
      if (isAbsoluteUrl(input))
        return parseAbsoluteUrl(input);
      const url = parseAbsoluteUrl("http://foo.com/" + input);
      url.scheme = "";
      url.host = "";
      url.type = input ? input.startsWith("?") ? 3 : input.startsWith("#") ? 2 : 4 : 1;
      return url;
    }
    function stripPathFilename(path3) {
      if (path3.endsWith("/.."))
        return path3;
      const index = path3.lastIndexOf("/");
      return path3.slice(0, index + 1);
    }
    function mergePaths(url, base) {
      normalizePath(base, base.type);
      if (url.path === "/") {
        url.path = base.path;
      } else {
        url.path = stripPathFilename(base.path) + url.path;
      }
    }
    function normalizePath(url, type) {
      const rel = type <= 4;
      const pieces = url.path.split("/");
      let pointer = 1;
      let positive = 0;
      let addTrailingSlash = false;
      for (let i = 1;i < pieces.length; i++) {
        const piece = pieces[i];
        if (!piece) {
          addTrailingSlash = true;
          continue;
        }
        addTrailingSlash = false;
        if (piece === ".")
          continue;
        if (piece === "..") {
          if (positive) {
            addTrailingSlash = true;
            positive--;
            pointer--;
          } else if (rel) {
            pieces[pointer++] = piece;
          }
          continue;
        }
        pieces[pointer++] = piece;
        positive++;
      }
      let path3 = "";
      for (let i = 1;i < pointer; i++) {
        path3 += "/" + pieces[i];
      }
      if (!path3 || addTrailingSlash && !path3.endsWith("/..")) {
        path3 += "/";
      }
      url.path = path3;
    }
    function resolve23(input, base) {
      if (!input && !base)
        return "";
      const url = parseUrl(input);
      let inputType = url.type;
      if (base && inputType !== 7) {
        const baseUrl = parseUrl(base);
        const baseType = baseUrl.type;
        switch (inputType) {
          case 1:
            url.hash = baseUrl.hash;
          case 2:
            url.query = baseUrl.query;
          case 3:
          case 4:
            mergePaths(url, baseUrl);
          case 5:
            url.user = baseUrl.user;
            url.host = baseUrl.host;
            url.port = baseUrl.port;
          case 6:
            url.scheme = baseUrl.scheme;
        }
        if (baseType > inputType)
          inputType = baseType;
      }
      normalizePath(url, inputType);
      const queryHash = url.query + url.hash;
      switch (inputType) {
        case 2:
        case 3:
          return queryHash;
        case 4: {
          const path3 = url.path.slice(1);
          if (!path3)
            return queryHash || ".";
          if (isRelative(base || input) && !isRelative(path3)) {
            return "./" + path3 + queryHash;
          }
          return path3 + queryHash;
        }
        case 5:
          return url.path + queryHash;
        default:
          return url.scheme + "//" + url.user + url.host + url.port + url.path + queryHash;
      }
    }
    return resolve23;
  });
});
var require_trace_mapping_umd = __commonJS2((exports, module) => {
  (function(global22, factory) {
    typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require_sourcemap_codec_umd(), require_resolve_uri_umd()) : typeof define === "function" && define.amd ? define(["exports", "@jridgewell/sourcemap-codec", "@jridgewell/resolve-uri"], factory) : (global22 = typeof globalThis !== "undefined" ? globalThis : global22 || self, factory(global22.traceMapping = {}, global22.sourcemapCodec, global22.resolveURI));
  })(exports, function(exports2, sourcemapCodec, resolveUri) {
    function resolve23(input, base) {
      if (base && !base.endsWith("/"))
        base += "/";
      return resolveUri(input, base);
    }
    function stripFilename(path3) {
      if (!path3)
        return "";
      const index = path3.lastIndexOf("/");
      return path3.slice(0, index + 1);
    }
    const COLUMN = 0;
    const SOURCES_INDEX = 1;
    const SOURCE_LINE = 2;
    const SOURCE_COLUMN = 3;
    const NAMES_INDEX = 4;
    const REV_GENERATED_LINE = 1;
    const REV_GENERATED_COLUMN = 2;
    function maybeSort(mappings, owned) {
      const unsortedIndex = nextUnsortedSegmentLine(mappings, 0);
      if (unsortedIndex === mappings.length)
        return mappings;
      if (!owned)
        mappings = mappings.slice();
      for (let i = unsortedIndex;i < mappings.length; i = nextUnsortedSegmentLine(mappings, i + 1)) {
        mappings[i] = sortSegments(mappings[i], owned);
      }
      return mappings;
    }
    function nextUnsortedSegmentLine(mappings, start) {
      for (let i = start;i < mappings.length; i++) {
        if (!isSorted(mappings[i]))
          return i;
      }
      return mappings.length;
    }
    function isSorted(line) {
      for (let j22 = 1;j22 < line.length; j22++) {
        if (line[j22][COLUMN] < line[j22 - 1][COLUMN]) {
          return false;
        }
      }
      return true;
    }
    function sortSegments(line, owned) {
      if (!owned)
        line = line.slice();
      return line.sort(sortComparator);
    }
    function sortComparator(a, b22) {
      return a[COLUMN] - b22[COLUMN];
    }
    let found = false;
    function binarySearch(haystack, needle, low, high) {
      while (low <= high) {
        const mid = low + (high - low >> 1);
        const cmp = haystack[mid][COLUMN] - needle;
        if (cmp === 0) {
          found = true;
          return mid;
        }
        if (cmp < 0) {
          low = mid + 1;
        } else {
          high = mid - 1;
        }
      }
      found = false;
      return low - 1;
    }
    function upperBound(haystack, needle, index) {
      for (let i = index + 1;i < haystack.length; index = i++) {
        if (haystack[i][COLUMN] !== needle)
          break;
      }
      return index;
    }
    function lowerBound(haystack, needle, index) {
      for (let i = index - 1;i >= 0; index = i--) {
        if (haystack[i][COLUMN] !== needle)
          break;
      }
      return index;
    }
    function memoizedState() {
      return {
        lastKey: -1,
        lastNeedle: -1,
        lastIndex: -1
      };
    }
    function memoizedBinarySearch(haystack, needle, state, key) {
      const { lastKey, lastNeedle, lastIndex } = state;
      let low = 0;
      let high = haystack.length - 1;
      if (key === lastKey) {
        if (needle === lastNeedle) {
          found = lastIndex !== -1 && haystack[lastIndex][COLUMN] === needle;
          return lastIndex;
        }
        if (needle >= lastNeedle) {
          low = lastIndex === -1 ? 0 : lastIndex;
        } else {
          high = lastIndex;
        }
      }
      state.lastKey = key;
      state.lastNeedle = needle;
      return state.lastIndex = binarySearch(haystack, needle, low, high);
    }
    function buildBySources(decoded, memos) {
      const sources = memos.map(buildNullArray);
      for (let i = 0;i < decoded.length; i++) {
        const line = decoded[i];
        for (let j22 = 0;j22 < line.length; j22++) {
          const seg = line[j22];
          if (seg.length === 1)
            continue;
          const sourceIndex2 = seg[SOURCES_INDEX];
          const sourceLine = seg[SOURCE_LINE];
          const sourceColumn = seg[SOURCE_COLUMN];
          const originalSource = sources[sourceIndex2];
          const originalLine = originalSource[sourceLine] || (originalSource[sourceLine] = []);
          const memo = memos[sourceIndex2];
          let index = upperBound(originalLine, sourceColumn, memoizedBinarySearch(originalLine, sourceColumn, memo, sourceLine));
          memo.lastIndex = ++index;
          insert(originalLine, index, [sourceColumn, i, seg[COLUMN]]);
        }
      }
      return sources;
    }
    function insert(array, index, value) {
      for (let i = array.length;i > index; i--) {
        array[i] = array[i - 1];
      }
      array[index] = value;
    }
    function buildNullArray() {
      return { __proto__: null };
    }
    const AnyMap = function(map, mapUrl) {
      const parsed = parse3(map);
      if (!("sections" in parsed)) {
        return new TraceMap(parsed, mapUrl);
      }
      const mappings = [];
      const sources = [];
      const sourcesContent = [];
      const names = [];
      const ignoreList = [];
      recurse(parsed, mapUrl, mappings, sources, sourcesContent, names, ignoreList, 0, 0, Infinity, Infinity);
      const joined = {
        version: 3,
        file: parsed.file,
        names,
        sources,
        sourcesContent,
        mappings,
        ignoreList
      };
      return presortedDecodedMap(joined);
    };
    function parse3(map) {
      return typeof map === "string" ? JSON.parse(map) : map;
    }
    function recurse(input, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset, columnOffset, stopLine, stopColumn) {
      const { sections } = input;
      for (let i = 0;i < sections.length; i++) {
        const { map, offset } = sections[i];
        let sl = stopLine;
        let sc = stopColumn;
        if (i + 1 < sections.length) {
          const nextOffset = sections[i + 1].offset;
          sl = Math.min(stopLine, lineOffset + nextOffset.line);
          if (sl === stopLine) {
            sc = Math.min(stopColumn, columnOffset + nextOffset.column);
          } else if (sl < stopLine) {
            sc = columnOffset + nextOffset.column;
          }
        }
        addSection(map, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset + offset.line, columnOffset + offset.column, sl, sc);
      }
    }
    function addSection(input, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset, columnOffset, stopLine, stopColumn) {
      const parsed = parse3(input);
      if ("sections" in parsed)
        return recurse(...arguments);
      const map = new TraceMap(parsed, mapUrl);
      const sourcesOffset = sources.length;
      const namesOffset = names.length;
      const decoded = decodedMappings(map);
      const { resolvedSources, sourcesContent: contents, ignoreList: ignores } = map;
      append(sources, resolvedSources);
      append(names, map.names);
      if (contents)
        append(sourcesContent, contents);
      else
        for (let i = 0;i < resolvedSources.length; i++)
          sourcesContent.push(null);
      if (ignores)
        for (let i = 0;i < ignores.length; i++)
          ignoreList.push(ignores[i] + sourcesOffset);
      for (let i = 0;i < decoded.length; i++) {
        const lineI = lineOffset + i;
        if (lineI > stopLine)
          return;
        const out = getLine(mappings, lineI);
        const cOffset = i === 0 ? columnOffset : 0;
        const line = decoded[i];
        for (let j22 = 0;j22 < line.length; j22++) {
          const seg = line[j22];
          const column = cOffset + seg[COLUMN];
          if (lineI === stopLine && column >= stopColumn)
            return;
          if (seg.length === 1) {
            out.push([column]);
            continue;
          }
          const sourcesIndex = sourcesOffset + seg[SOURCES_INDEX];
          const sourceLine = seg[SOURCE_LINE];
          const sourceColumn = seg[SOURCE_COLUMN];
          out.push(seg.length === 4 ? [column, sourcesIndex, sourceLine, sourceColumn] : [column, sourcesIndex, sourceLine, sourceColumn, namesOffset + seg[NAMES_INDEX]]);
        }
      }
    }
    function append(arr, other) {
      for (let i = 0;i < other.length; i++)
        arr.push(other[i]);
    }
    function getLine(arr, index) {
      for (let i = arr.length;i <= index; i++)
        arr[i] = [];
      return arr[index];
    }
    const LINE_GTR_ZERO = "`line` must be greater than 0 (lines start at line 1)";
    const COL_GTR_EQ_ZERO = "`column` must be greater than or equal to 0 (columns start at column 0)";
    const LEAST_UPPER_BOUND = -1;
    const GREATEST_LOWER_BOUND = 1;

    class TraceMap {
      constructor(map, mapUrl) {
        const isString22 = typeof map === "string";
        if (!isString22 && map._decodedMemo)
          return map;
        const parsed = isString22 ? JSON.parse(map) : map;
        const { version: version2, file, names, sourceRoot, sources, sourcesContent } = parsed;
        this.version = version2;
        this.file = file;
        this.names = names || [];
        this.sourceRoot = sourceRoot;
        this.sources = sources;
        this.sourcesContent = sourcesContent;
        this.ignoreList = parsed.ignoreList || parsed.x_google_ignoreList || undefined;
        const from = resolve23(sourceRoot || "", stripFilename(mapUrl));
        this.resolvedSources = sources.map((s32) => resolve23(s32 || "", from));
        const { mappings } = parsed;
        if (typeof mappings === "string") {
          this._encoded = mappings;
          this._decoded = undefined;
        } else {
          this._encoded = undefined;
          this._decoded = maybeSort(mappings, isString22);
        }
        this._decodedMemo = memoizedState();
        this._bySources = undefined;
        this._bySourceMemos = undefined;
      }
    }
    function cast(map) {
      return map;
    }
    function encodedMappings(map) {
      var _a;
      var _b;
      return (_a = (_b = cast(map))._encoded) !== null && _a !== undefined ? _a : _b._encoded = sourcemapCodec.encode(cast(map)._decoded);
    }
    function decodedMappings(map) {
      var _a;
      return (_a = cast(map))._decoded || (_a._decoded = sourcemapCodec.decode(cast(map)._encoded));
    }
    function traceSegment(map, line, column) {
      const decoded = decodedMappings(map);
      if (line >= decoded.length)
        return null;
      const segments = decoded[line];
      const index = traceSegmentInternal(segments, cast(map)._decodedMemo, line, column, GREATEST_LOWER_BOUND);
      return index === -1 ? null : segments[index];
    }
    function originalPositionFor(map, needle) {
      let { line, column, bias } = needle;
      line--;
      if (line < 0)
        throw new Error(LINE_GTR_ZERO);
      if (column < 0)
        throw new Error(COL_GTR_EQ_ZERO);
      const decoded = decodedMappings(map);
      if (line >= decoded.length)
        return OMapping(null, null, null, null);
      const segments = decoded[line];
      const index = traceSegmentInternal(segments, cast(map)._decodedMemo, line, column, bias || GREATEST_LOWER_BOUND);
      if (index === -1)
        return OMapping(null, null, null, null);
      const segment = segments[index];
      if (segment.length === 1)
        return OMapping(null, null, null, null);
      const { names, resolvedSources } = map;
      return OMapping(resolvedSources[segment[SOURCES_INDEX]], segment[SOURCE_LINE] + 1, segment[SOURCE_COLUMN], segment.length === 5 ? names[segment[NAMES_INDEX]] : null);
    }
    function generatedPositionFor(map, needle) {
      const { source, line, column, bias } = needle;
      return generatedPosition(map, source, line, column, bias || GREATEST_LOWER_BOUND, false);
    }
    function allGeneratedPositionsFor(map, needle) {
      const { source, line, column, bias } = needle;
      return generatedPosition(map, source, line, column, bias || LEAST_UPPER_BOUND, true);
    }
    function eachMapping(map, cb) {
      const decoded = decodedMappings(map);
      const { names, resolvedSources } = map;
      for (let i = 0;i < decoded.length; i++) {
        const line = decoded[i];
        for (let j22 = 0;j22 < line.length; j22++) {
          const seg = line[j22];
          const generatedLine = i + 1;
          const generatedColumn = seg[0];
          let source = null;
          let originalLine = null;
          let originalColumn = null;
          let name = null;
          if (seg.length !== 1) {
            source = resolvedSources[seg[1]];
            originalLine = seg[2] + 1;
            originalColumn = seg[3];
          }
          if (seg.length === 5)
            name = names[seg[4]];
          cb({
            generatedLine,
            generatedColumn,
            source,
            originalLine,
            originalColumn,
            name
          });
        }
      }
    }
    function sourceIndex(map, source) {
      const { sources, resolvedSources } = map;
      let index = sources.indexOf(source);
      if (index === -1)
        index = resolvedSources.indexOf(source);
      return index;
    }
    function sourceContentFor(map, source) {
      const { sourcesContent } = map;
      if (sourcesContent == null)
        return null;
      const index = sourceIndex(map, source);
      return index === -1 ? null : sourcesContent[index];
    }
    function isIgnored(map, source) {
      const { ignoreList } = map;
      if (ignoreList == null)
        return false;
      const index = sourceIndex(map, source);
      return index === -1 ? false : ignoreList.includes(index);
    }
    function presortedDecodedMap(map, mapUrl) {
      const tracer = new TraceMap(clone3(map, []), mapUrl);
      cast(tracer)._decoded = map.mappings;
      return tracer;
    }
    function decodedMap(map) {
      return clone3(map, decodedMappings(map));
    }
    function encodedMap(map) {
      return clone3(map, encodedMappings(map));
    }
    function clone3(map, mappings) {
      return {
        version: map.version,
        file: map.file,
        names: map.names,
        sourceRoot: map.sourceRoot,
        sources: map.sources,
        sourcesContent: map.sourcesContent,
        mappings,
        ignoreList: map.ignoreList || map.x_google_ignoreList
      };
    }
    function OMapping(source, line, column, name) {
      return { source, line, column, name };
    }
    function GMapping(line, column) {
      return { line, column };
    }
    function traceSegmentInternal(segments, memo, line, column, bias) {
      let index = memoizedBinarySearch(segments, column, memo, line);
      if (found) {
        index = (bias === LEAST_UPPER_BOUND ? upperBound : lowerBound)(segments, column, index);
      } else if (bias === LEAST_UPPER_BOUND)
        index++;
      if (index === -1 || index === segments.length)
        return -1;
      return index;
    }
    function sliceGeneratedPositions(segments, memo, line, column, bias) {
      let min = traceSegmentInternal(segments, memo, line, column, GREATEST_LOWER_BOUND);
      if (!found && bias === LEAST_UPPER_BOUND)
        min++;
      if (min === -1 || min === segments.length)
        return [];
      const matchedColumn = found ? column : segments[min][COLUMN];
      if (!found)
        min = lowerBound(segments, matchedColumn, min);
      const max = upperBound(segments, matchedColumn, min);
      const result2 = [];
      for (;min <= max; min++) {
        const segment = segments[min];
        result2.push(GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]));
      }
      return result2;
    }
    function generatedPosition(map, source, line, column, bias, all) {
      var _a;
      line--;
      if (line < 0)
        throw new Error(LINE_GTR_ZERO);
      if (column < 0)
        throw new Error(COL_GTR_EQ_ZERO);
      const { sources, resolvedSources } = map;
      let sourceIndex2 = sources.indexOf(source);
      if (sourceIndex2 === -1)
        sourceIndex2 = resolvedSources.indexOf(source);
      if (sourceIndex2 === -1)
        return all ? [] : GMapping(null, null);
      const generated = (_a = cast(map))._bySources || (_a._bySources = buildBySources(decodedMappings(map), cast(map)._bySourceMemos = sources.map(memoizedState)));
      const segments = generated[sourceIndex2][line];
      if (segments == null)
        return all ? [] : GMapping(null, null);
      const memo = cast(map)._bySourceMemos[sourceIndex2];
      if (all)
        return sliceGeneratedPositions(segments, memo, line, column, bias);
      const index = traceSegmentInternal(segments, memo, line, column, bias);
      if (index === -1)
        return GMapping(null, null);
      const segment = segments[index];
      return GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]);
    }
    exports2.AnyMap = AnyMap;
    exports2.GREATEST_LOWER_BOUND = GREATEST_LOWER_BOUND;
    exports2.LEAST_UPPER_BOUND = LEAST_UPPER_BOUND;
    exports2.TraceMap = TraceMap;
    exports2.allGeneratedPositionsFor = allGeneratedPositionsFor;
    exports2.decodedMap = decodedMap;
    exports2.decodedMappings = decodedMappings;
    exports2.eachMapping = eachMapping;
    exports2.encodedMap = encodedMap;
    exports2.encodedMappings = encodedMappings;
    exports2.generatedPositionFor = generatedPositionFor;
    exports2.isIgnored = isIgnored;
    exports2.originalPositionFor = originalPositionFor;
    exports2.presortedDecodedMap = presortedDecodedMap;
    exports2.sourceContentFor = sourceContentFor;
    exports2.traceSegment = traceSegment;
  });
});
var require_gen_mapping_umd = __commonJS2((exports, module) => {
  (function(global22, factory) {
    typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require_set_array_umd(), require_sourcemap_codec_umd(), require_trace_mapping_umd()) : typeof define === "function" && define.amd ? define(["exports", "@jridgewell/set-array", "@jridgewell/sourcemap-codec", "@jridgewell/trace-mapping"], factory) : (global22 = typeof globalThis !== "undefined" ? globalThis : global22 || self, factory(global22.genMapping = {}, global22.setArray, global22.sourcemapCodec, global22.traceMapping));
  })(exports, function(exports2, setArray, sourcemapCodec, traceMapping) {
    const COLUMN = 0;
    const SOURCES_INDEX = 1;
    const SOURCE_LINE = 2;
    const SOURCE_COLUMN = 3;
    const NAMES_INDEX = 4;
    const NO_NAME = -1;

    class GenMapping {
      constructor({ file, sourceRoot } = {}) {
        this._names = new setArray.SetArray;
        this._sources = new setArray.SetArray;
        this._sourcesContent = [];
        this._mappings = [];
        this.file = file;
        this.sourceRoot = sourceRoot;
        this._ignoreList = new setArray.SetArray;
      }
    }
    function cast(map) {
      return map;
    }
    function addSegment(map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
      return addSegmentInternal(false, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
    }
    function addMapping(map, mapping) {
      return addMappingInternal(false, map, mapping);
    }
    const maybeAddSegment = (map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) => {
      return addSegmentInternal(true, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
    };
    const maybeAddMapping = (map, mapping) => {
      return addMappingInternal(true, map, mapping);
    };
    function setSourceContent(map, source, content) {
      const { _sources: sources, _sourcesContent: sourcesContent } = cast(map);
      const index = setArray.put(sources, source);
      sourcesContent[index] = content;
    }
    function setIgnore(map, source, ignore = true) {
      const { _sources: sources, _sourcesContent: sourcesContent, _ignoreList: ignoreList } = cast(map);
      const index = setArray.put(sources, source);
      if (index === sourcesContent.length)
        sourcesContent[index] = null;
      if (ignore)
        setArray.put(ignoreList, index);
      else
        setArray.remove(ignoreList, index);
    }
    function toDecodedMap(map) {
      const { _mappings: mappings, _sources: sources, _sourcesContent: sourcesContent, _names: names, _ignoreList: ignoreList } = cast(map);
      removeEmptyFinalLines(mappings);
      return {
        version: 3,
        file: map.file || undefined,
        names: names.array,
        sourceRoot: map.sourceRoot || undefined,
        sources: sources.array,
        sourcesContent,
        mappings,
        ignoreList: ignoreList.array
      };
    }
    function toEncodedMap(map) {
      const decoded = toDecodedMap(map);
      return Object.assign(Object.assign({}, decoded), { mappings: sourcemapCodec.encode(decoded.mappings) });
    }
    function fromMap(input) {
      const map = new traceMapping.TraceMap(input);
      const gen = new GenMapping({ file: map.file, sourceRoot: map.sourceRoot });
      putAll(cast(gen)._names, map.names);
      putAll(cast(gen)._sources, map.sources);
      cast(gen)._sourcesContent = map.sourcesContent || map.sources.map(() => null);
      cast(gen)._mappings = traceMapping.decodedMappings(map);
      if (map.ignoreList)
        putAll(cast(gen)._ignoreList, map.ignoreList);
      return gen;
    }
    function allMappings(map) {
      const out = [];
      const { _mappings: mappings, _sources: sources, _names: names } = cast(map);
      for (let i = 0;i < mappings.length; i++) {
        const line = mappings[i];
        for (let j22 = 0;j22 < line.length; j22++) {
          const seg = line[j22];
          const generated = { line: i + 1, column: seg[COLUMN] };
          let source = undefined;
          let original = undefined;
          let name = undefined;
          if (seg.length !== 1) {
            source = sources.array[seg[SOURCES_INDEX]];
            original = { line: seg[SOURCE_LINE] + 1, column: seg[SOURCE_COLUMN] };
            if (seg.length === 5)
              name = names.array[seg[NAMES_INDEX]];
          }
          out.push({ generated, source, original, name });
        }
      }
      return out;
    }
    function addSegmentInternal(skipable, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
      const { _mappings: mappings, _sources: sources, _sourcesContent: sourcesContent, _names: names } = cast(map);
      const line = getLine(mappings, genLine);
      const index = getColumnIndex(line, genColumn);
      if (!source) {
        if (skipable && skipSourceless(line, index))
          return;
        return insert(line, index, [genColumn]);
      }
      const sourcesIndex = setArray.put(sources, source);
      const namesIndex = name ? setArray.put(names, name) : NO_NAME;
      if (sourcesIndex === sourcesContent.length)
        sourcesContent[sourcesIndex] = content !== null && content !== undefined ? content : null;
      if (skipable && skipSource(line, index, sourcesIndex, sourceLine, sourceColumn, namesIndex)) {
        return;
      }
      return insert(line, index, name ? [genColumn, sourcesIndex, sourceLine, sourceColumn, namesIndex] : [genColumn, sourcesIndex, sourceLine, sourceColumn]);
    }
    function getLine(mappings, index) {
      for (let i = mappings.length;i <= index; i++) {
        mappings[i] = [];
      }
      return mappings[index];
    }
    function getColumnIndex(line, genColumn) {
      let index = line.length;
      for (let i = index - 1;i >= 0; index = i--) {
        const current = line[i];
        if (genColumn >= current[COLUMN])
          break;
      }
      return index;
    }
    function insert(array, index, value) {
      for (let i = array.length;i > index; i--) {
        array[i] = array[i - 1];
      }
      array[index] = value;
    }
    function removeEmptyFinalLines(mappings) {
      const { length } = mappings;
      let len = length;
      for (let i = len - 1;i >= 0; len = i, i--) {
        if (mappings[i].length > 0)
          break;
      }
      if (len < length)
        mappings.length = len;
    }
    function putAll(setarr, array) {
      for (let i = 0;i < array.length; i++)
        setArray.put(setarr, array[i]);
    }
    function skipSourceless(line, index) {
      if (index === 0)
        return true;
      const prev = line[index - 1];
      return prev.length === 1;
    }
    function skipSource(line, index, sourcesIndex, sourceLine, sourceColumn, namesIndex) {
      if (index === 0)
        return false;
      const prev = line[index - 1];
      if (prev.length === 1)
        return false;
      return sourcesIndex === prev[SOURCES_INDEX] && sourceLine === prev[SOURCE_LINE] && sourceColumn === prev[SOURCE_COLUMN] && namesIndex === (prev.length === 5 ? prev[NAMES_INDEX] : NO_NAME);
    }
    function addMappingInternal(skipable, map, mapping) {
      const { generated, source, original, name, content } = mapping;
      if (!source) {
        return addSegmentInternal(skipable, map, generated.line - 1, generated.column, null, null, null, null, null);
      }
      return addSegmentInternal(skipable, map, generated.line - 1, generated.column, source, original.line - 1, original.column, name, content);
    }
    exports2.GenMapping = GenMapping;
    exports2.addMapping = addMapping;
    exports2.addSegment = addSegment;
    exports2.allMappings = allMappings;
    exports2.fromMap = fromMap;
    exports2.maybeAddMapping = maybeAddMapping;
    exports2.maybeAddSegment = maybeAddSegment;
    exports2.setIgnore = setIgnore;
    exports2.setSourceContent = setSourceContent;
    exports2.toDecodedMap = toDecodedMap;
    exports2.toEncodedMap = toEncodedMap;
    Object.defineProperty(exports2, "__esModule", { value: true });
  });
});
var require_source_map = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _genMapping = require_gen_mapping_umd();
  var _traceMapping = require_trace_mapping_umd();

  class SourceMap {
    constructor(opts, code) {
      var _opts$sourceFileName;
      this._map = undefined;
      this._rawMappings = undefined;
      this._sourceFileName = undefined;
      this._lastGenLine = 0;
      this._lastSourceLine = 0;
      this._lastSourceColumn = 0;
      this._inputMap = undefined;
      const map = this._map = new _genMapping.GenMapping({
        sourceRoot: opts.sourceRoot
      });
      this._sourceFileName = (_opts$sourceFileName = opts.sourceFileName) == null ? undefined : _opts$sourceFileName.replace(/\\/g, "/");
      this._rawMappings = undefined;
      if (opts.inputSourceMap) {
        this._inputMap = new _traceMapping.TraceMap(opts.inputSourceMap);
        const resolvedSources = this._inputMap.resolvedSources;
        if (resolvedSources.length) {
          for (let i = 0;i < resolvedSources.length; i++) {
            var _this$_inputMap$sourc;
            (0, _genMapping.setSourceContent)(map, resolvedSources[i], (_this$_inputMap$sourc = this._inputMap.sourcesContent) == null ? undefined : _this$_inputMap$sourc[i]);
          }
        }
      }
      if (typeof code === "string" && !opts.inputSourceMap) {
        (0, _genMapping.setSourceContent)(map, this._sourceFileName, code);
      } else if (typeof code === "object") {
        for (const sourceFileName of Object.keys(code)) {
          (0, _genMapping.setSourceContent)(map, sourceFileName.replace(/\\/g, "/"), code[sourceFileName]);
        }
      }
    }
    get() {
      return (0, _genMapping.toEncodedMap)(this._map);
    }
    getDecoded() {
      return (0, _genMapping.toDecodedMap)(this._map);
    }
    getRawMappings() {
      return this._rawMappings || (this._rawMappings = (0, _genMapping.allMappings)(this._map));
    }
    mark(generated, line, column, identifierName, identifierNamePos, filename2) {
      var _originalMapping;
      this._rawMappings = undefined;
      let originalMapping;
      if (line != null) {
        if (this._inputMap) {
          originalMapping = (0, _traceMapping.originalPositionFor)(this._inputMap, {
            line,
            column
          });
          if (!originalMapping.name && identifierNamePos) {
            const originalIdentifierMapping = (0, _traceMapping.originalPositionFor)(this._inputMap, identifierNamePos);
            if (originalIdentifierMapping.name) {
              identifierName = originalIdentifierMapping.name;
            }
          }
        } else {
          originalMapping = {
            source: (filename2 == null ? undefined : filename2.replace(/\\/g, "/")) || this._sourceFileName,
            line,
            column
          };
        }
      }
      (0, _genMapping.maybeAddMapping)(this._map, {
        name: identifierName,
        generated,
        source: (_originalMapping = originalMapping) == null ? undefined : _originalMapping.source,
        original: originalMapping
      });
    }
  }
  exports.default = SourceMap;
});
var require_buffer = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;

  class Buffer22 {
    constructor(map, indentChar) {
      this._map = null;
      this._buf = "";
      this._str = "";
      this._appendCount = 0;
      this._last = 0;
      this._queue = [];
      this._queueCursor = 0;
      this._canMarkIdName = true;
      this._indentChar = "";
      this._fastIndentations = [];
      this._position = {
        line: 1,
        column: 0
      };
      this._sourcePosition = {
        identifierName: undefined,
        identifierNamePos: undefined,
        line: undefined,
        column: undefined,
        filename: undefined
      };
      this._map = map;
      this._indentChar = indentChar;
      for (let i = 0;i < 64; i++) {
        this._fastIndentations.push(indentChar.repeat(i));
      }
      this._allocQueue();
    }
    _allocQueue() {
      const queue4 = this._queue;
      for (let i = 0;i < 16; i++) {
        queue4.push({
          char: 0,
          repeat: 1,
          line: undefined,
          column: undefined,
          identifierName: undefined,
          identifierNamePos: undefined,
          filename: ""
        });
      }
    }
    _pushQueue(char, repeat, line, column, filename2) {
      const cursor22 = this._queueCursor;
      if (cursor22 === this._queue.length) {
        this._allocQueue();
      }
      const item = this._queue[cursor22];
      item.char = char;
      item.repeat = repeat;
      item.line = line;
      item.column = column;
      item.filename = filename2;
      this._queueCursor++;
    }
    _popQueue() {
      if (this._queueCursor === 0) {
        throw new Error("Cannot pop from empty queue");
      }
      return this._queue[--this._queueCursor];
    }
    get() {
      this._flush();
      const map = this._map;
      const result2 = {
        code: (this._buf + this._str).trimRight(),
        decodedMap: map == null ? undefined : map.getDecoded(),
        get __mergedMap() {
          return this.map;
        },
        get map() {
          const resultMap = map ? map.get() : null;
          result2.map = resultMap;
          return resultMap;
        },
        set map(value) {
          Object.defineProperty(result2, "map", {
            value,
            writable: true
          });
        },
        get rawMappings() {
          const mappings = map == null ? undefined : map.getRawMappings();
          result2.rawMappings = mappings;
          return mappings;
        },
        set rawMappings(value) {
          Object.defineProperty(result2, "rawMappings", {
            value,
            writable: true
          });
        }
      };
      return result2;
    }
    append(str, maybeNewline) {
      this._flush();
      this._append(str, this._sourcePosition, maybeNewline);
    }
    appendChar(char) {
      this._flush();
      this._appendChar(char, 1, this._sourcePosition);
    }
    queue(char) {
      if (char === 10) {
        while (this._queueCursor !== 0) {
          const char2 = this._queue[this._queueCursor - 1].char;
          if (char2 !== 32 && char2 !== 9) {
            break;
          }
          this._queueCursor--;
        }
      }
      const sourcePosition = this._sourcePosition;
      this._pushQueue(char, 1, sourcePosition.line, sourcePosition.column, sourcePosition.filename);
    }
    queueIndentation(repeat) {
      if (repeat === 0)
        return;
      this._pushQueue(-1, repeat, undefined, undefined, undefined);
    }
    _flush() {
      const queueCursor = this._queueCursor;
      const queue4 = this._queue;
      for (let i = 0;i < queueCursor; i++) {
        const item = queue4[i];
        this._appendChar(item.char, item.repeat, item);
      }
      this._queueCursor = 0;
    }
    _appendChar(char, repeat, sourcePos) {
      this._last = char;
      if (char === -1) {
        const fastIndentation = this._fastIndentations[repeat];
        if (fastIndentation !== undefined) {
          this._str += fastIndentation;
        } else {
          this._str += repeat > 1 ? this._indentChar.repeat(repeat) : this._indentChar;
        }
      } else {
        this._str += repeat > 1 ? String.fromCharCode(char).repeat(repeat) : String.fromCharCode(char);
      }
      if (char !== 10) {
        this._mark(sourcePos.line, sourcePos.column, sourcePos.identifierName, sourcePos.identifierNamePos, sourcePos.filename);
        this._position.column += repeat;
      } else {
        this._position.line++;
        this._position.column = 0;
      }
      if (this._canMarkIdName) {
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
    }
    _append(str, sourcePos, maybeNewline) {
      const len = str.length;
      const position = this._position;
      this._last = str.charCodeAt(len - 1);
      if (++this._appendCount > 4096) {
        +this._str;
        this._buf += this._str;
        this._str = str;
        this._appendCount = 0;
      } else {
        this._str += str;
      }
      if (!maybeNewline && !this._map) {
        position.column += len;
        return;
      }
      const {
        column,
        identifierName,
        identifierNamePos,
        filename: filename2
      } = sourcePos;
      let line = sourcePos.line;
      if ((identifierName != null || identifierNamePos != null) && this._canMarkIdName) {
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
      let i = str.indexOf("\n");
      let last = 0;
      if (i !== 0) {
        this._mark(line, column, identifierName, identifierNamePos, filename2);
      }
      while (i !== -1) {
        position.line++;
        position.column = 0;
        last = i + 1;
        if (last < len && line !== undefined) {
          this._mark(++line, 0, null, null, filename2);
        }
        i = str.indexOf("\n", last);
      }
      position.column += len - last;
    }
    _mark(line, column, identifierName, identifierNamePos, filename2) {
      var _this$_map;
      (_this$_map = this._map) == null || _this$_map.mark(this._position, line, column, identifierName, identifierNamePos, filename2);
    }
    removeTrailingNewline() {
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 10) {
        this._queueCursor--;
      }
    }
    removeLastSemicolon() {
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 59) {
        this._queueCursor--;
      }
    }
    getLastChar() {
      const queueCursor = this._queueCursor;
      return queueCursor !== 0 ? this._queue[queueCursor - 1].char : this._last;
    }
    getNewlineCount() {
      const queueCursor = this._queueCursor;
      let count = 0;
      if (queueCursor === 0)
        return this._last === 10 ? 1 : 0;
      for (let i = queueCursor - 1;i >= 0; i--) {
        if (this._queue[i].char !== 10) {
          break;
        }
        count++;
      }
      return count === queueCursor && this._last === 10 ? count + 1 : count;
    }
    endsWithCharAndNewline() {
      const queue4 = this._queue;
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0) {
        const lastCp = queue4[queueCursor - 1].char;
        if (lastCp !== 10)
          return;
        if (queueCursor > 1) {
          return queue4[queueCursor - 2].char;
        } else {
          return this._last;
        }
      }
    }
    hasContent() {
      return this._queueCursor !== 0 || !!this._last;
    }
    exactSource(loc, cb) {
      if (!this._map) {
        cb();
        return;
      }
      this.source("start", loc);
      const identifierName = loc.identifierName;
      const sourcePos = this._sourcePosition;
      if (identifierName) {
        this._canMarkIdName = false;
        sourcePos.identifierName = identifierName;
      }
      cb();
      if (identifierName) {
        this._canMarkIdName = true;
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
      this.source("end", loc);
    }
    source(prop, loc) {
      if (!this._map)
        return;
      this._normalizePosition(prop, loc, 0);
    }
    sourceWithOffset(prop, loc, columnOffset) {
      if (!this._map)
        return;
      this._normalizePosition(prop, loc, columnOffset);
    }
    _normalizePosition(prop, loc, columnOffset) {
      const pos = loc[prop];
      const target = this._sourcePosition;
      if (pos) {
        target.line = pos.line;
        target.column = Math.max(pos.column + columnOffset, 0);
        target.filename = loc.filename;
      }
    }
    getCurrentColumn() {
      const queue4 = this._queue;
      const queueCursor = this._queueCursor;
      let lastIndex = -1;
      let len = 0;
      for (let i = 0;i < queueCursor; i++) {
        const item = queue4[i];
        if (item.char === 10) {
          lastIndex = len;
        }
        len += item.repeat;
      }
      return lastIndex === -1 ? this._position.column + len : len - 1 - lastIndex;
    }
    getCurrentLine() {
      let count = 0;
      const queue4 = this._queue;
      for (let i = 0;i < this._queueCursor; i++) {
        if (queue4[i].char === 10) {
          count++;
        }
      }
      return this._position.line + count;
    }
  }
  exports.default = Buffer22;
});
var require_whitespace = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.nodes = undefined;
  var _t = require_lib6();
  var {
    FLIPPED_ALIAS_KEYS,
    isArrayExpression,
    isAssignmentExpression,
    isBinary,
    isBlockStatement,
    isCallExpression,
    isFunction: isFunction22,
    isIdentifier,
    isLiteral,
    isMemberExpression,
    isObjectExpression,
    isOptionalCallExpression,
    isOptionalMemberExpression,
    isStringLiteral
  } = _t;
  function crawlInternal(node, state) {
    if (!node)
      return state;
    if (isMemberExpression(node) || isOptionalMemberExpression(node)) {
      crawlInternal(node.object, state);
      if (node.computed)
        crawlInternal(node.property, state);
    } else if (isBinary(node) || isAssignmentExpression(node)) {
      crawlInternal(node.left, state);
      crawlInternal(node.right, state);
    } else if (isCallExpression(node) || isOptionalCallExpression(node)) {
      state.hasCall = true;
      crawlInternal(node.callee, state);
    } else if (isFunction22(node)) {
      state.hasFunction = true;
    } else if (isIdentifier(node)) {
      state.hasHelper = state.hasHelper || node.callee && isHelper(node.callee);
    }
    return state;
  }
  function crawl(node) {
    return crawlInternal(node, {
      hasCall: false,
      hasFunction: false,
      hasHelper: false
    });
  }
  function isHelper(node) {
    if (!node)
      return false;
    if (isMemberExpression(node)) {
      return isHelper(node.object) || isHelper(node.property);
    } else if (isIdentifier(node)) {
      return node.name === "require" || node.name.charCodeAt(0) === 95;
    } else if (isCallExpression(node)) {
      return isHelper(node.callee);
    } else if (isBinary(node) || isAssignmentExpression(node)) {
      return isIdentifier(node.left) && isHelper(node.left) || isHelper(node.right);
    } else {
      return false;
    }
  }
  function isType(node) {
    return isLiteral(node) || isObjectExpression(node) || isArrayExpression(node) || isIdentifier(node) || isMemberExpression(node);
  }
  var nodes = exports.nodes = {
    AssignmentExpression(node) {
      const state = crawl(node.right);
      if (state.hasCall && state.hasHelper || state.hasFunction) {
        return state.hasFunction ? 3 : 2;
      }
    },
    SwitchCase(node, parent) {
      return (!!node.consequent.length || parent.cases[0] === node ? 1 : 0) | (!node.consequent.length && parent.cases[parent.cases.length - 1] === node ? 2 : 0);
    },
    LogicalExpression(node) {
      if (isFunction22(node.left) || isFunction22(node.right)) {
        return 2;
      }
    },
    Literal(node) {
      if (isStringLiteral(node) && node.value === "use strict") {
        return 2;
      }
    },
    CallExpression(node) {
      if (isFunction22(node.callee) || isHelper(node)) {
        return 3;
      }
    },
    OptionalCallExpression(node) {
      if (isFunction22(node.callee)) {
        return 3;
      }
    },
    VariableDeclaration(node) {
      for (let i = 0;i < node.declarations.length; i++) {
        const declar = node.declarations[i];
        let enabled22 = isHelper(declar.id) && !isType(declar.init);
        if (!enabled22 && declar.init) {
          const state = crawl(declar.init);
          enabled22 = isHelper(declar.init) && state.hasCall || state.hasFunction;
        }
        if (enabled22) {
          return 3;
        }
      }
    },
    IfStatement(node) {
      if (isBlockStatement(node.consequent)) {
        return 3;
      }
    }
  };
  nodes.ObjectProperty = nodes.ObjectTypeProperty = nodes.ObjectMethod = function(node, parent) {
    if (parent.properties[0] === node) {
      return 1;
    }
  };
  nodes.ObjectTypeCallProperty = function(node, parent) {
    var _parent$properties;
    if (parent.callProperties[0] === node && !((_parent$properties = parent.properties) != null && _parent$properties.length)) {
      return 1;
    }
  };
  nodes.ObjectTypeIndexer = function(node, parent) {
    var _parent$properties2, _parent$callPropertie;
    if (parent.indexers[0] === node && !((_parent$properties2 = parent.properties) != null && _parent$properties2.length) && !((_parent$callPropertie = parent.callProperties) != null && _parent$callPropertie.length)) {
      return 1;
    }
  };
  nodes.ObjectTypeInternalSlot = function(node, parent) {
    var _parent$properties3, _parent$callPropertie2, _parent$indexers;
    if (parent.internalSlots[0] === node && !((_parent$properties3 = parent.properties) != null && _parent$properties3.length) && !((_parent$callPropertie2 = parent.callProperties) != null && _parent$callPropertie2.length) && !((_parent$indexers = parent.indexers) != null && _parent$indexers.length)) {
      return 1;
    }
  };
  [["Function", true], ["Class", true], ["Loop", true], ["LabeledStatement", true], ["SwitchStatement", true], ["TryStatement", true]].forEach(function([type, amounts]) {
    [type].concat(FLIPPED_ALIAS_KEYS[type] || []).forEach(function(type2) {
      const ret = amounts ? 3 : 0;
      nodes[type2] = () => ret;
    });
  });
});
var require_parentheses = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.AssignmentExpression = AssignmentExpression;
  exports.Binary = Binary;
  exports.BinaryExpression = BinaryExpression;
  exports.ClassExpression = ClassExpression;
  exports.ArrowFunctionExpression = exports.ConditionalExpression = ConditionalExpression;
  exports.DoExpression = DoExpression;
  exports.FunctionExpression = FunctionExpression;
  exports.FunctionTypeAnnotation = FunctionTypeAnnotation;
  exports.Identifier = Identifier;
  exports.LogicalExpression = LogicalExpression;
  exports.NullableTypeAnnotation = NullableTypeAnnotation;
  exports.ObjectExpression = ObjectExpression;
  exports.OptionalIndexedAccessType = OptionalIndexedAccessType;
  exports.OptionalCallExpression = exports.OptionalMemberExpression = OptionalMemberExpression;
  exports.SequenceExpression = SequenceExpression;
  exports.TSSatisfiesExpression = exports.TSAsExpression = TSAsExpression;
  exports.TSInferType = TSInferType;
  exports.TSInstantiationExpression = TSInstantiationExpression;
  exports.UnaryLike = exports.TSTypeAssertion = UnaryLike;
  exports.TSIntersectionType = exports.TSUnionType = TSUnionType;
  exports.IntersectionTypeAnnotation = exports.UnionTypeAnnotation = UnionTypeAnnotation;
  exports.UpdateExpression = UpdateExpression;
  exports.AwaitExpression = exports.YieldExpression = YieldExpression;
  var _t = require_lib6();
  var _index = require_node2();
  var {
    isArrayTypeAnnotation,
    isBinaryExpression,
    isCallExpression,
    isForOfStatement,
    isIndexedAccessType,
    isMemberExpression,
    isObjectPattern,
    isOptionalMemberExpression,
    isYieldExpression,
    isStatement
  } = _t;
  var PRECEDENCE = new Map([["||", 0], ["??", 0], ["|>", 0], ["&&", 1], ["|", 2], ["^", 3], ["&", 4], ["==", 5], ["===", 5], ["!=", 5], ["!==", 5], ["<", 6], [">", 6], ["<=", 6], [">=", 6], ["in", 6], ["instanceof", 6], [">>", 7], ["<<", 7], [">>>", 7], ["+", 8], ["-", 8], ["*", 9], ["/", 9], ["%", 9], ["**", 10]]);
  function getBinaryPrecedence(node, nodeType) {
    if (nodeType === "BinaryExpression" || nodeType === "LogicalExpression") {
      return PRECEDENCE.get(node.operator);
    }
    if (nodeType === "TSAsExpression" || nodeType === "TSSatisfiesExpression") {
      return PRECEDENCE.get("in");
    }
  }
  function isTSTypeExpression(nodeType) {
    return nodeType === "TSAsExpression" || nodeType === "TSSatisfiesExpression" || nodeType === "TSTypeAssertion";
  }
  var isClassExtendsClause = (node, parent) => {
    const parentType = parent.type;
    return (parentType === "ClassDeclaration" || parentType === "ClassExpression") && parent.superClass === node;
  };
  var hasPostfixPart = (node, parent) => {
    const parentType = parent.type;
    return (parentType === "MemberExpression" || parentType === "OptionalMemberExpression") && parent.object === node || (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression") && parent.callee === node || parentType === "TaggedTemplateExpression" && parent.tag === node || parentType === "TSNonNullExpression";
  };
  function NullableTypeAnnotation(node, parent) {
    return isArrayTypeAnnotation(parent);
  }
  function FunctionTypeAnnotation(node, parent, tokenContext) {
    const parentType = parent.type;
    return parentType === "UnionTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "ArrayTypeAnnotation" || Boolean(tokenContext & _index.TokenContext.arrowFlowReturnType);
  }
  function UpdateExpression(node, parent) {
    return hasPostfixPart(node, parent) || isClassExtendsClause(node, parent);
  }
  function needsParenBeforeExpressionBrace(tokenContext) {
    return Boolean(tokenContext & (_index.TokenContext.expressionStatement | _index.TokenContext.arrowBody));
  }
  function ObjectExpression(node, parent, tokenContext) {
    return needsParenBeforeExpressionBrace(tokenContext);
  }
  function DoExpression(node, parent, tokenContext) {
    return !node.async && Boolean(tokenContext & _index.TokenContext.expressionStatement);
  }
  function Binary(node, parent) {
    const parentType = parent.type;
    if (node.type === "BinaryExpression" && node.operator === "**" && parentType === "BinaryExpression" && parent.operator === "**") {
      return parent.left === node;
    }
    if (isClassExtendsClause(node, parent)) {
      return true;
    }
    if (hasPostfixPart(node, parent) || parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "AwaitExpression") {
      return true;
    }
    const parentPos = getBinaryPrecedence(parent, parentType);
    if (parentPos != null) {
      const nodePos = getBinaryPrecedence(node, node.type);
      if (parentPos === nodePos && parentType === "BinaryExpression" && parent.right === node || parentPos > nodePos) {
        return true;
      }
    }
    return;
  }
  function UnionTypeAnnotation(node, parent) {
    const parentType = parent.type;
    return parentType === "ArrayTypeAnnotation" || parentType === "NullableTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "UnionTypeAnnotation";
  }
  function OptionalIndexedAccessType(node, parent) {
    return isIndexedAccessType(parent) && parent.objectType === node;
  }
  function TSAsExpression(node, parent) {
    if ((parent.type === "AssignmentExpression" || parent.type === "AssignmentPattern") && parent.left === node) {
      return true;
    }
    if (parent.type === "BinaryExpression" && (parent.operator === "|" || parent.operator === "&") && node === parent.left) {
      return true;
    }
    return Binary(node, parent);
  }
  function TSUnionType(node, parent) {
    const parentType = parent.type;
    return parentType === "TSArrayType" || parentType === "TSOptionalType" || parentType === "TSIntersectionType" || parentType === "TSRestType";
  }
  function TSInferType(node, parent) {
    const parentType = parent.type;
    return parentType === "TSArrayType" || parentType === "TSOptionalType";
  }
  function TSInstantiationExpression(node, parent) {
    const parentType = parent.type;
    return (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression" || parentType === "TSInstantiationExpression") && !!parent.typeParameters;
  }
  function BinaryExpression(node, parent, tokenContext, inForStatementInit) {
    return node.operator === "in" && inForStatementInit;
  }
  function SequenceExpression(node, parent) {
    const parentType = parent.type;
    if (parentType === "SequenceExpression" || parentType === "ParenthesizedExpression" || parentType === "MemberExpression" && parent.property === node || parentType === "OptionalMemberExpression" && parent.property === node || parentType === "TemplateLiteral") {
      return false;
    }
    if (parentType === "ClassDeclaration") {
      return true;
    }
    if (parentType === "ForOfStatement") {
      return parent.right === node;
    }
    if (parentType === "ExportDefaultDeclaration") {
      return true;
    }
    return !isStatement(parent);
  }
  function YieldExpression(node, parent) {
    const parentType = parent.type;
    return parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "UnaryExpression" || parentType === "SpreadElement" || hasPostfixPart(node, parent) || parentType === "AwaitExpression" && isYieldExpression(node) || parentType === "ConditionalExpression" && node === parent.test || isClassExtendsClause(node, parent) || isTSTypeExpression(parentType);
  }
  function ClassExpression(node, parent, tokenContext) {
    return Boolean(tokenContext & (_index.TokenContext.expressionStatement | _index.TokenContext.exportDefault));
  }
  function UnaryLike(node, parent) {
    return hasPostfixPart(node, parent) || isBinaryExpression(parent) && parent.operator === "**" && parent.left === node || isClassExtendsClause(node, parent);
  }
  function FunctionExpression(node, parent, tokenContext) {
    return Boolean(tokenContext & (_index.TokenContext.expressionStatement | _index.TokenContext.exportDefault));
  }
  function ConditionalExpression(node, parent) {
    const parentType = parent.type;
    if (parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "ConditionalExpression" && parent.test === node || parentType === "AwaitExpression" || isTSTypeExpression(parentType)) {
      return true;
    }
    return UnaryLike(node, parent);
  }
  function OptionalMemberExpression(node, parent) {
    return isCallExpression(parent) && parent.callee === node || isMemberExpression(parent) && parent.object === node;
  }
  function AssignmentExpression(node, parent, tokenContext) {
    if (needsParenBeforeExpressionBrace(tokenContext) && isObjectPattern(node.left)) {
      return true;
    } else {
      return ConditionalExpression(node, parent);
    }
  }
  function LogicalExpression(node, parent) {
    const parentType = parent.type;
    if (isTSTypeExpression(parentType))
      return true;
    if (parentType !== "LogicalExpression")
      return false;
    switch (node.operator) {
      case "||":
        return parent.operator === "??" || parent.operator === "&&";
      case "&&":
        return parent.operator === "??";
      case "??":
        return parent.operator !== "??";
    }
  }
  function Identifier(node, parent, tokenContext) {
    var _node$extra;
    const parentType = parent.type;
    if ((_node$extra = node.extra) != null && _node$extra.parenthesized && parentType === "AssignmentExpression" && parent.left === node) {
      const rightType = parent.right.type;
      if ((rightType === "FunctionExpression" || rightType === "ClassExpression") && parent.right.id == null) {
        return true;
      }
    }
    if (node.name === "let") {
      const isFollowedByBracket = isMemberExpression(parent, {
        object: node,
        computed: true
      }) || isOptionalMemberExpression(parent, {
        object: node,
        computed: true,
        optional: false
      });
      if (isFollowedByBracket && tokenContext & (_index.TokenContext.expressionStatement | _index.TokenContext.forHead | _index.TokenContext.forInHead)) {
        return true;
      }
      return Boolean(tokenContext & _index.TokenContext.forOfHead);
    }
    return node.name === "async" && isForOfStatement(parent, {
      left: node,
      await: false
    });
  }
});
var require_node2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.TokenContext = undefined;
  exports.isLastChild = isLastChild;
  exports.needsParens = needsParens;
  exports.needsWhitespace = needsWhitespace;
  exports.needsWhitespaceAfter = needsWhitespaceAfter;
  exports.needsWhitespaceBefore = needsWhitespaceBefore;
  var whitespace = require_whitespace();
  var parens = require_parentheses();
  var _t = require_lib6();
  var {
    FLIPPED_ALIAS_KEYS,
    VISITOR_KEYS,
    isCallExpression,
    isDecorator,
    isExpressionStatement,
    isMemberExpression,
    isNewExpression,
    isParenthesizedExpression
  } = _t;
  var TokenContext = exports.TokenContext = {
    expressionStatement: 1,
    arrowBody: 2,
    exportDefault: 4,
    forHead: 8,
    forInHead: 16,
    forOfHead: 32,
    arrowFlowReturnType: 64
  };
  function expandAliases(obj) {
    const map = new Map;
    function add(type, func) {
      const fn = map.get(type);
      map.set(type, fn ? function(node, parent, stack, inForInit) {
        var _fn;
        return (_fn = fn(node, parent, stack, inForInit)) != null ? _fn : func(node, parent, stack, inForInit);
      } : func);
    }
    for (const type of Object.keys(obj)) {
      const aliases = FLIPPED_ALIAS_KEYS[type];
      if (aliases) {
        for (const alias of aliases) {
          add(alias, obj[type]);
        }
      } else {
        add(type, obj[type]);
      }
    }
    return map;
  }
  var expandedParens = expandAliases(parens);
  var expandedWhitespaceNodes = expandAliases(whitespace.nodes);
  function isOrHasCallExpression(node) {
    if (isCallExpression(node)) {
      return true;
    }
    return isMemberExpression(node) && isOrHasCallExpression(node.object);
  }
  function needsWhitespace(node, parent, type) {
    var _expandedWhitespaceNo;
    if (!node)
      return false;
    if (isExpressionStatement(node)) {
      node = node.expression;
    }
    const flag = (_expandedWhitespaceNo = expandedWhitespaceNodes.get(node.type)) == null ? undefined : _expandedWhitespaceNo(node, parent);
    if (typeof flag === "number") {
      return (flag & type) !== 0;
    }
    return false;
  }
  function needsWhitespaceBefore(node, parent) {
    return needsWhitespace(node, parent, 1);
  }
  function needsWhitespaceAfter(node, parent) {
    return needsWhitespace(node, parent, 2);
  }
  function needsParens(node, parent, tokenContext, inForInit) {
    var _expandedParens$get;
    if (!parent)
      return false;
    if (isNewExpression(parent) && parent.callee === node) {
      if (isOrHasCallExpression(node))
        return true;
    }
    if (isDecorator(parent)) {
      return !isDecoratorMemberExpression(node) && !(isCallExpression(node) && isDecoratorMemberExpression(node.callee)) && !isParenthesizedExpression(node);
    }
    return (_expandedParens$get = expandedParens.get(node.type)) == null ? undefined : _expandedParens$get(node, parent, tokenContext, inForInit);
  }
  function isDecoratorMemberExpression(node) {
    switch (node.type) {
      case "Identifier":
        return true;
      case "MemberExpression":
        return !node.computed && node.property.type === "Identifier" && isDecoratorMemberExpression(node.object);
      default:
        return false;
    }
  }
  function isLastChild(parent, child) {
    const visitorKeys = VISITOR_KEYS[parent.type];
    for (let i = visitorKeys.length - 1;i >= 0; i--) {
      const val2 = parent[visitorKeys[i]];
      if (val2 === child) {
        return true;
      } else if (Array.isArray(val2)) {
        let j22 = val2.length - 1;
        while (j22 >= 0 && val2[j22] === null)
          j22--;
        return j22 >= 0 && val2[j22] === child;
      } else if (val2) {
        return false;
      }
    }
    return false;
  }
});
var require_template_literals = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.TaggedTemplateExpression = TaggedTemplateExpression;
  exports.TemplateElement = TemplateElement;
  exports.TemplateLiteral = TemplateLiteral;
  function TaggedTemplateExpression(node) {
    this.print(node.tag);
    this.print(node.typeParameters);
    this.print(node.quasi);
  }
  function TemplateElement() {
    throw new Error("TemplateElement printing is handled in TemplateLiteral");
  }
  function TemplateLiteral(node) {
    const quasis = node.quasis;
    let partRaw = "`";
    for (let i = 0;i < quasis.length; i++) {
      partRaw += quasis[i].value.raw;
      if (i + 1 < quasis.length) {
        this.token(partRaw + "${", true);
        this.print(node.expressions[i]);
        partRaw = "}";
      }
    }
    this.token(partRaw + "`", true);
  }
});
var require_expressions = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.LogicalExpression = exports.BinaryExpression = exports.AssignmentExpression = AssignmentExpression;
  exports.AssignmentPattern = AssignmentPattern;
  exports.AwaitExpression = AwaitExpression;
  exports.BindExpression = BindExpression;
  exports.CallExpression = CallExpression;
  exports.ConditionalExpression = ConditionalExpression;
  exports.Decorator = Decorator;
  exports.DoExpression = DoExpression;
  exports.EmptyStatement = EmptyStatement;
  exports.ExpressionStatement = ExpressionStatement;
  exports.Import = Import;
  exports.MemberExpression = MemberExpression;
  exports.MetaProperty = MetaProperty;
  exports.ModuleExpression = ModuleExpression;
  exports.NewExpression = NewExpression;
  exports.OptionalCallExpression = OptionalCallExpression;
  exports.OptionalMemberExpression = OptionalMemberExpression;
  exports.ParenthesizedExpression = ParenthesizedExpression;
  exports.PrivateName = PrivateName;
  exports.SequenceExpression = SequenceExpression;
  exports.Super = Super;
  exports.ThisExpression = ThisExpression;
  exports.UnaryExpression = UnaryExpression;
  exports.UpdateExpression = UpdateExpression;
  exports.V8IntrinsicIdentifier = V8IntrinsicIdentifier;
  exports.YieldExpression = YieldExpression;
  exports._shouldPrintDecoratorsBeforeExport = _shouldPrintDecoratorsBeforeExport;
  var _t = require_lib6();
  var _index = require_node2();
  var {
    isCallExpression,
    isLiteral,
    isMemberExpression,
    isNewExpression,
    isPattern
  } = _t;
  function UnaryExpression(node) {
    const {
      operator
    } = node;
    if (operator === "void" || operator === "delete" || operator === "typeof" || operator === "throw") {
      this.word(operator);
      this.space();
    } else {
      this.token(operator);
    }
    this.print(node.argument);
  }
  function DoExpression(node) {
    if (node.async) {
      this.word("async", true);
      this.space();
    }
    this.word("do");
    this.space();
    this.print(node.body);
  }
  function ParenthesizedExpression(node) {
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.print(node.expression);
    exit();
    this.rightParens(node);
  }
  function UpdateExpression(node) {
    if (node.prefix) {
      this.token(node.operator);
      this.print(node.argument);
    } else {
      this.print(node.argument, true);
      this.token(node.operator);
    }
  }
  function ConditionalExpression(node) {
    this.print(node.test);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.consequent);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.alternate);
  }
  function NewExpression(node, parent) {
    this.word("new");
    this.space();
    this.print(node.callee);
    if (this.format.minified && node.arguments.length === 0 && !node.optional && !isCallExpression(parent, {
      callee: node
    }) && !isMemberExpression(parent) && !isNewExpression(parent)) {
      return;
    }
    this.print(node.typeArguments);
    this.print(node.typeParameters);
    if (node.optional) {
      this.token("?.");
    }
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments);
    exit();
    this.rightParens(node);
  }
  function SequenceExpression(node) {
    this.printList(node.expressions);
  }
  function ThisExpression() {
    this.word("this");
  }
  function Super() {
    this.word("super");
  }
  function _shouldPrintDecoratorsBeforeExport(node) {
    if (typeof this.format.decoratorsBeforeExport === "boolean") {
      return this.format.decoratorsBeforeExport;
    }
    return typeof node.start === "number" && node.start === node.declaration.start;
  }
  function Decorator(node) {
    this.tokenChar(64);
    this.print(node.expression);
    this.newline();
  }
  function OptionalMemberExpression(node) {
    let {
      computed
    } = node;
    const {
      optional,
      property
    } = node;
    this.print(node.object);
    if (!computed && isMemberExpression(property)) {
      throw new TypeError("Got a MemberExpression for MemberExpression property");
    }
    if (isLiteral(property) && typeof property.value === "number") {
      computed = true;
    }
    if (optional) {
      this.token("?.");
    }
    if (computed) {
      this.tokenChar(91);
      this.print(property);
      this.tokenChar(93);
    } else {
      if (!optional) {
        this.tokenChar(46);
      }
      this.print(property);
    }
  }
  function OptionalCallExpression(node) {
    this.print(node.callee);
    this.print(node.typeParameters);
    if (node.optional) {
      this.token("?.");
    }
    this.print(node.typeArguments);
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments);
    exit();
    this.rightParens(node);
  }
  function CallExpression(node) {
    this.print(node.callee);
    this.print(node.typeArguments);
    this.print(node.typeParameters);
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments);
    exit();
    this.rightParens(node);
  }
  function Import() {
    this.word("import");
  }
  function AwaitExpression(node) {
    this.word("await");
    if (node.argument) {
      this.space();
      this.printTerminatorless(node.argument);
    }
  }
  function YieldExpression(node) {
    this.word("yield", true);
    if (node.delegate) {
      this.tokenChar(42);
      if (node.argument) {
        this.space();
        this.print(node.argument);
      }
    } else {
      if (node.argument) {
        this.space();
        this.printTerminatorless(node.argument);
      }
    }
  }
  function EmptyStatement() {
    this.semicolon(true);
  }
  function ExpressionStatement(node) {
    this.tokenContext |= _index.TokenContext.expressionStatement;
    this.print(node.expression);
    this.semicolon();
  }
  function AssignmentPattern(node) {
    this.print(node.left);
    if (node.left.type === "Identifier" || isPattern(node.left)) {
      if (node.left.optional)
        this.tokenChar(63);
      this.print(node.left.typeAnnotation);
    }
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.right);
  }
  function AssignmentExpression(node) {
    this.print(node.left);
    this.space();
    if (node.operator === "in" || node.operator === "instanceof") {
      this.word(node.operator);
    } else {
      this.token(node.operator);
      this._endsWithDiv = node.operator === "/";
    }
    this.space();
    this.print(node.right);
  }
  function BindExpression(node) {
    this.print(node.object);
    this.token("::");
    this.print(node.callee);
  }
  function MemberExpression(node) {
    this.print(node.object);
    if (!node.computed && isMemberExpression(node.property)) {
      throw new TypeError("Got a MemberExpression for MemberExpression property");
    }
    let computed = node.computed;
    if (isLiteral(node.property) && typeof node.property.value === "number") {
      computed = true;
    }
    if (computed) {
      const exit = this.enterDelimited();
      this.tokenChar(91);
      this.print(node.property);
      this.tokenChar(93);
      exit();
    } else {
      this.tokenChar(46);
      this.print(node.property);
    }
  }
  function MetaProperty(node) {
    this.print(node.meta);
    this.tokenChar(46);
    this.print(node.property);
  }
  function PrivateName(node) {
    this.tokenChar(35);
    this.print(node.id);
  }
  function V8IntrinsicIdentifier(node) {
    this.tokenChar(37);
    this.word(node.name);
  }
  function ModuleExpression(node) {
    this.word("module", true);
    this.space();
    this.tokenChar(123);
    this.indent();
    const {
      body
    } = node;
    if (body.body.length || body.directives.length) {
      this.newline();
    }
    this.print(body);
    this.dedent();
    this.rightBrace(node);
  }
});
var require_statements = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.BreakStatement = BreakStatement;
  exports.CatchClause = CatchClause;
  exports.ContinueStatement = ContinueStatement;
  exports.DebuggerStatement = DebuggerStatement;
  exports.DoWhileStatement = DoWhileStatement;
  exports.ForOfStatement = exports.ForInStatement = undefined;
  exports.ForStatement = ForStatement;
  exports.IfStatement = IfStatement;
  exports.LabeledStatement = LabeledStatement;
  exports.ReturnStatement = ReturnStatement;
  exports.SwitchCase = SwitchCase;
  exports.SwitchStatement = SwitchStatement;
  exports.ThrowStatement = ThrowStatement;
  exports.TryStatement = TryStatement;
  exports.VariableDeclaration = VariableDeclaration;
  exports.VariableDeclarator = VariableDeclarator;
  exports.WhileStatement = WhileStatement;
  exports.WithStatement = WithStatement;
  var _t = require_lib6();
  var _index = require_node2();
  var {
    isFor,
    isForStatement,
    isIfStatement,
    isStatement
  } = _t;
  function WithStatement(node) {
    this.word("with");
    this.space();
    this.tokenChar(40);
    this.print(node.object);
    this.tokenChar(41);
    this.printBlock(node);
  }
  function IfStatement(node) {
    this.word("if");
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.space();
    const needsBlock = node.alternate && isIfStatement(getLastStatement(node.consequent));
    if (needsBlock) {
      this.tokenChar(123);
      this.newline();
      this.indent();
    }
    this.printAndIndentOnComments(node.consequent);
    if (needsBlock) {
      this.dedent();
      this.newline();
      this.tokenChar(125);
    }
    if (node.alternate) {
      if (this.endsWith(125))
        this.space();
      this.word("else");
      this.space();
      this.printAndIndentOnComments(node.alternate);
    }
  }
  function getLastStatement(statement) {
    const {
      body
    } = statement;
    if (isStatement(body) === false) {
      return statement;
    }
    return getLastStatement(body);
  }
  function ForStatement(node) {
    this.word("for");
    this.space();
    this.tokenChar(40);
    {
      const exit = this.enterForStatementInit();
      this.tokenContext |= _index.TokenContext.forHead;
      this.print(node.init);
      exit();
    }
    this.tokenChar(59);
    if (node.test) {
      this.space();
      this.print(node.test);
    }
    this.tokenChar(59);
    if (node.update) {
      this.space();
      this.print(node.update);
    }
    this.tokenChar(41);
    this.printBlock(node);
  }
  function WhileStatement(node) {
    this.word("while");
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.printBlock(node);
  }
  function ForXStatement(node) {
    this.word("for");
    this.space();
    const isForOf = node.type === "ForOfStatement";
    if (isForOf && node.await) {
      this.word("await");
      this.space();
    }
    this.noIndentInnerCommentsHere();
    this.tokenChar(40);
    {
      const exit = isForOf ? null : this.enterForStatementInit();
      this.tokenContext |= isForOf ? _index.TokenContext.forOfHead : _index.TokenContext.forInHead;
      this.print(node.left);
      exit == null || exit();
    }
    this.space();
    this.word(isForOf ? "of" : "in");
    this.space();
    this.print(node.right);
    this.tokenChar(41);
    this.printBlock(node);
  }
  var ForInStatement = exports.ForInStatement = ForXStatement;
  var ForOfStatement = exports.ForOfStatement = ForXStatement;
  function DoWhileStatement(node) {
    this.word("do");
    this.space();
    this.print(node.body);
    this.space();
    this.word("while");
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.semicolon();
  }
  function printStatementAfterKeyword(printer, node) {
    if (node) {
      printer.space();
      printer.printTerminatorless(node);
    }
    printer.semicolon();
  }
  function BreakStatement(node) {
    this.word("break");
    printStatementAfterKeyword(this, node.label);
  }
  function ContinueStatement(node) {
    this.word("continue");
    printStatementAfterKeyword(this, node.label);
  }
  function ReturnStatement(node) {
    this.word("return");
    printStatementAfterKeyword(this, node.argument);
  }
  function ThrowStatement(node) {
    this.word("throw");
    printStatementAfterKeyword(this, node.argument);
  }
  function LabeledStatement(node) {
    this.print(node.label);
    this.tokenChar(58);
    this.space();
    this.print(node.body);
  }
  function TryStatement(node) {
    this.word("try");
    this.space();
    this.print(node.block);
    this.space();
    if (node.handlers) {
      this.print(node.handlers[0]);
    } else {
      this.print(node.handler);
    }
    if (node.finalizer) {
      this.space();
      this.word("finally");
      this.space();
      this.print(node.finalizer);
    }
  }
  function CatchClause(node) {
    this.word("catch");
    this.space();
    if (node.param) {
      this.tokenChar(40);
      this.print(node.param);
      this.print(node.param.typeAnnotation);
      this.tokenChar(41);
      this.space();
    }
    this.print(node.body);
  }
  function SwitchStatement(node) {
    this.word("switch");
    this.space();
    this.tokenChar(40);
    this.print(node.discriminant);
    this.tokenChar(41);
    this.space();
    this.tokenChar(123);
    this.printSequence(node.cases, {
      indent: true,
      addNewlines(leading, cas) {
        if (!leading && node.cases[node.cases.length - 1] === cas)
          return -1;
      }
    });
    this.rightBrace(node);
  }
  function SwitchCase(node) {
    if (node.test) {
      this.word("case");
      this.space();
      this.print(node.test);
      this.tokenChar(58);
    } else {
      this.word("default");
      this.tokenChar(58);
    }
    if (node.consequent.length) {
      this.newline();
      this.printSequence(node.consequent, {
        indent: true
      });
    }
  }
  function DebuggerStatement() {
    this.word("debugger");
    this.semicolon();
  }
  function VariableDeclaration(node, parent) {
    if (node.declare) {
      this.word("declare");
      this.space();
    }
    const {
      kind
    } = node;
    if (kind === "await using") {
      this.word("await");
      this.space();
      this.word("using", true);
    } else {
      this.word(kind, kind === "using");
    }
    this.space();
    let hasInits = false;
    if (!isFor(parent)) {
      for (const declar of node.declarations) {
        if (declar.init) {
          hasInits = true;
        }
      }
    }
    this.printList(node.declarations, {
      separator: hasInits ? function() {
        this.tokenChar(44);
        this.newline();
      } : undefined,
      indent: node.declarations.length > 1 ? true : false
    });
    if (isFor(parent)) {
      if (isForStatement(parent)) {
        if (parent.init === node)
          return;
      } else {
        if (parent.left === node)
          return;
      }
    }
    this.semicolon();
  }
  function VariableDeclarator(node) {
    this.print(node.id);
    if (node.definite)
      this.tokenChar(33);
    this.print(node.id.typeAnnotation);
    if (node.init) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.init);
    }
  }
});
var require_classes = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ClassAccessorProperty = ClassAccessorProperty;
  exports.ClassBody = ClassBody;
  exports.ClassExpression = exports.ClassDeclaration = ClassDeclaration;
  exports.ClassMethod = ClassMethod;
  exports.ClassPrivateMethod = ClassPrivateMethod;
  exports.ClassPrivateProperty = ClassPrivateProperty;
  exports.ClassProperty = ClassProperty;
  exports.StaticBlock = StaticBlock;
  exports._classMethodHead = _classMethodHead;
  var _t = require_lib6();
  var {
    isExportDefaultDeclaration,
    isExportNamedDeclaration
  } = _t;
  function ClassDeclaration(node, parent) {
    const inExport = isExportDefaultDeclaration(parent) || isExportNamedDeclaration(parent);
    if (!inExport || !this._shouldPrintDecoratorsBeforeExport(parent)) {
      this.printJoin(node.decorators);
    }
    if (node.declare) {
      this.word("declare");
      this.space();
    }
    if (node.abstract) {
      this.word("abstract");
      this.space();
    }
    this.word("class");
    if (node.id) {
      this.space();
      this.print(node.id);
    }
    this.print(node.typeParameters);
    if (node.superClass) {
      this.space();
      this.word("extends");
      this.space();
      this.print(node.superClass);
      this.print(node.superTypeParameters);
    }
    if (node.implements) {
      this.space();
      this.word("implements");
      this.space();
      this.printList(node.implements);
    }
    this.space();
    this.print(node.body);
  }
  function ClassBody(node) {
    this.tokenChar(123);
    if (node.body.length === 0) {
      this.tokenChar(125);
    } else {
      this.newline();
      const exit = this.enterDelimited();
      this.printSequence(node.body, {
        indent: true
      });
      exit();
      if (!this.endsWith(10))
        this.newline();
      this.rightBrace(node);
    }
  }
  function ClassProperty(node) {
    var _node$key$loc;
    this.printJoin(node.decorators);
    const endLine = (_node$key$loc = node.key.loc) == null || (_node$key$loc = _node$key$loc.end) == null ? undefined : _node$key$loc.line;
    if (endLine)
      this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      this._variance(node);
      this.print(node.key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    if (node.definite) {
      this.tokenChar(33);
    }
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassAccessorProperty(node) {
    var _node$key$loc2;
    this.printJoin(node.decorators);
    const endLine = (_node$key$loc2 = node.key.loc) == null || (_node$key$loc2 = _node$key$loc2.end) == null ? undefined : _node$key$loc2.line;
    if (endLine)
      this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    this.word("accessor", true);
    this.space();
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      this._variance(node);
      this.print(node.key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    if (node.definite) {
      this.tokenChar(33);
    }
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassPrivateProperty(node) {
    this.printJoin(node.decorators);
    if (node.static) {
      this.word("static");
      this.space();
    }
    this.print(node.key);
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body);
  }
  function ClassPrivateMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body);
  }
  function _classMethodHead(node) {
    var _node$key$loc3;
    this.printJoin(node.decorators);
    const endLine = (_node$key$loc3 = node.key.loc) == null || (_node$key$loc3 = _node$key$loc3.end) == null ? undefined : _node$key$loc3.line;
    if (endLine)
      this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    this._methodHead(node);
  }
  function StaticBlock(node) {
    this.word("static");
    this.space();
    this.tokenChar(123);
    if (node.body.length === 0) {
      this.tokenChar(125);
    } else {
      this.newline();
      this.printSequence(node.body, {
        indent: true
      });
      this.rightBrace(node);
    }
  }
});
var require_methods = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ArrowFunctionExpression = ArrowFunctionExpression;
  exports.FunctionDeclaration = exports.FunctionExpression = FunctionExpression;
  exports._functionHead = _functionHead;
  exports._methodHead = _methodHead;
  exports._param = _param;
  exports._parameters = _parameters;
  exports._params = _params;
  exports._predicate = _predicate;
  var _t = require_lib6();
  var _index = require_node2();
  var {
    isIdentifier
  } = _t;
  function _params(node, idNode, parentNode) {
    this.print(node.typeParameters);
    const nameInfo = _getFuncIdName.call(this, idNode, parentNode);
    if (nameInfo) {
      this.sourceIdentifierName(nameInfo.name, nameInfo.pos);
    }
    this.tokenChar(40);
    this._parameters(node.params);
    this.tokenChar(41);
    const noLineTerminator = node.type === "ArrowFunctionExpression";
    this.print(node.returnType, noLineTerminator);
    this._noLineTerminator = noLineTerminator;
  }
  function _parameters(parameters) {
    const exit = this.enterDelimited();
    const paramLength = parameters.length;
    for (let i = 0;i < paramLength; i++) {
      this._param(parameters[i]);
      if (i < parameters.length - 1) {
        this.tokenChar(44);
        this.space();
      }
    }
    exit();
  }
  function _param(parameter) {
    this.printJoin(parameter.decorators);
    this.print(parameter);
    if (parameter.optional) {
      this.tokenChar(63);
    }
    this.print(parameter.typeAnnotation);
  }
  function _methodHead(node) {
    const kind = node.kind;
    const key = node.key;
    if (kind === "get" || kind === "set") {
      this.word(kind);
      this.space();
    }
    if (node.async) {
      this.word("async", true);
      this.space();
    }
    if (kind === "method" || kind === "init") {
      if (node.generator) {
        this.tokenChar(42);
      }
    }
    if (node.computed) {
      this.tokenChar(91);
      this.print(key);
      this.tokenChar(93);
    } else {
      this.print(key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    this._params(node, node.computed && node.key.type !== "StringLiteral" ? undefined : node.key, undefined);
  }
  function _predicate(node, noLineTerminatorAfter) {
    if (node.predicate) {
      if (!node.returnType) {
        this.tokenChar(58);
      }
      this.space();
      this.print(node.predicate, noLineTerminatorAfter);
    }
  }
  function _functionHead(node, parent) {
    if (node.async) {
      this.word("async");
      this._endsWithInnerRaw = false;
      this.space();
    }
    this.word("function");
    if (node.generator) {
      this._endsWithInnerRaw = false;
      this.tokenChar(42);
    }
    this.space();
    if (node.id) {
      this.print(node.id);
    }
    this._params(node, node.id, parent);
    if (node.type !== "TSDeclareFunction") {
      this._predicate(node);
    }
  }
  function FunctionExpression(node, parent) {
    this._functionHead(node, parent);
    this.space();
    this.print(node.body);
  }
  function ArrowFunctionExpression(node, parent) {
    if (node.async) {
      this.word("async", true);
      this.space();
    }
    let firstParam;
    if (!this.format.retainLines && node.params.length === 1 && isIdentifier(firstParam = node.params[0]) && !hasTypesOrComments(node, firstParam)) {
      this.print(firstParam, true);
    } else {
      this._params(node, undefined, parent);
    }
    this._predicate(node, true);
    this.space();
    this.printInnerComments();
    this.token("=>");
    this.space();
    this.tokenContext |= _index.TokenContext.arrowBody;
    this.print(node.body);
  }
  function hasTypesOrComments(node, param) {
    var _param$leadingComment, _param$trailingCommen;
    return !!(node.typeParameters || node.returnType || node.predicate || param.typeAnnotation || param.optional || (_param$leadingComment = param.leadingComments) != null && _param$leadingComment.length || (_param$trailingCommen = param.trailingComments) != null && _param$trailingCommen.length);
  }
  function _getFuncIdName(idNode, parent) {
    let id = idNode;
    if (!id && parent) {
      const parentType = parent.type;
      if (parentType === "VariableDeclarator") {
        id = parent.id;
      } else if (parentType === "AssignmentExpression" || parentType === "AssignmentPattern") {
        id = parent.left;
      } else if (parentType === "ObjectProperty" || parentType === "ClassProperty") {
        if (!parent.computed || parent.key.type === "StringLiteral") {
          id = parent.key;
        }
      } else if (parentType === "ClassPrivateProperty" || parentType === "ClassAccessorProperty") {
        id = parent.key;
      }
    }
    if (!id)
      return;
    let nameInfo;
    if (id.type === "Identifier") {
      var _id$loc, _id$loc2;
      nameInfo = {
        pos: (_id$loc = id.loc) == null ? undefined : _id$loc.start,
        name: ((_id$loc2 = id.loc) == null ? undefined : _id$loc2.identifierName) || id.name
      };
    } else if (id.type === "PrivateName") {
      var _id$loc3;
      nameInfo = {
        pos: (_id$loc3 = id.loc) == null ? undefined : _id$loc3.start,
        name: "#" + id.id.name
      };
    } else if (id.type === "StringLiteral") {
      var _id$loc4;
      nameInfo = {
        pos: (_id$loc4 = id.loc) == null ? undefined : _id$loc4.start,
        name: id.value
      };
    }
    return nameInfo;
  }
});
var require_modules = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ExportAllDeclaration = ExportAllDeclaration;
  exports.ExportDefaultDeclaration = ExportDefaultDeclaration;
  exports.ExportDefaultSpecifier = ExportDefaultSpecifier;
  exports.ExportNamedDeclaration = ExportNamedDeclaration;
  exports.ExportNamespaceSpecifier = ExportNamespaceSpecifier;
  exports.ExportSpecifier = ExportSpecifier;
  exports.ImportAttribute = ImportAttribute;
  exports.ImportDeclaration = ImportDeclaration;
  exports.ImportDefaultSpecifier = ImportDefaultSpecifier;
  exports.ImportExpression = ImportExpression;
  exports.ImportNamespaceSpecifier = ImportNamespaceSpecifier;
  exports.ImportSpecifier = ImportSpecifier;
  exports._printAttributes = _printAttributes;
  var _t = require_lib6();
  var _index = require_node2();
  var {
    isClassDeclaration,
    isExportDefaultSpecifier,
    isExportNamespaceSpecifier,
    isImportDefaultSpecifier,
    isImportNamespaceSpecifier,
    isStatement
  } = _t;
  function ImportSpecifier(node) {
    if (node.importKind === "type" || node.importKind === "typeof") {
      this.word(node.importKind);
      this.space();
    }
    this.print(node.imported);
    if (node.local && node.local.name !== node.imported.name) {
      this.space();
      this.word("as");
      this.space();
      this.print(node.local);
    }
  }
  function ImportDefaultSpecifier(node) {
    this.print(node.local);
  }
  function ExportDefaultSpecifier(node) {
    this.print(node.exported);
  }
  function ExportSpecifier(node) {
    if (node.exportKind === "type") {
      this.word("type");
      this.space();
    }
    this.print(node.local);
    if (node.exported && node.local.name !== node.exported.name) {
      this.space();
      this.word("as");
      this.space();
      this.print(node.exported);
    }
  }
  function ExportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word("as");
    this.space();
    this.print(node.exported);
  }
  var warningShown = false;
  function _printAttributes(node) {
    const {
      importAttributesKeyword
    } = this.format;
    const {
      attributes,
      assertions
    } = node;
    if (attributes && !importAttributesKeyword && !warningShown) {
      warningShown = true;
      console.warn(`You are using import attributes, without specifying the desired output syntax.
Please specify the "importAttributesKeyword" generator option, whose value can be one of:
 - "with"        : \`import { a } from "b" with { type: "json" };\`
 - "assert"      : \`import { a } from "b" assert { type: "json" };\`
 - "with-legacy" : \`import { a } from "b" with type: "json";\`
`);
    }
    const useAssertKeyword = importAttributesKeyword === "assert" || !importAttributesKeyword && assertions;
    this.word(useAssertKeyword ? "assert" : "with");
    this.space();
    if (!useAssertKeyword && importAttributesKeyword !== "with") {
      this.printList(attributes || assertions);
      return;
    }
    this.tokenChar(123);
    this.space();
    this.printList(attributes || assertions);
    this.space();
    this.tokenChar(125);
  }
  function ExportAllDeclaration(node) {
    var _node$attributes, _node$assertions;
    this.word("export");
    this.space();
    if (node.exportKind === "type") {
      this.word("type");
      this.space();
    }
    this.tokenChar(42);
    this.space();
    this.word("from");
    this.space();
    if ((_node$attributes = node.attributes) != null && _node$attributes.length || (_node$assertions = node.assertions) != null && _node$assertions.length) {
      this.print(node.source, true);
      this.space();
      this._printAttributes(node);
    } else {
      this.print(node.source);
    }
    this.semicolon();
  }
  function maybePrintDecoratorsBeforeExport(printer, node) {
    if (isClassDeclaration(node.declaration) && printer._shouldPrintDecoratorsBeforeExport(node)) {
      printer.printJoin(node.declaration.decorators);
    }
  }
  function ExportNamedDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word("export");
    this.space();
    if (node.declaration) {
      const declar = node.declaration;
      this.print(declar);
      if (!isStatement(declar))
        this.semicolon();
    } else {
      if (node.exportKind === "type") {
        this.word("type");
        this.space();
      }
      const specifiers = node.specifiers.slice(0);
      let hasSpecial = false;
      for (;; ) {
        const first = specifiers[0];
        if (isExportDefaultSpecifier(first) || isExportNamespaceSpecifier(first)) {
          hasSpecial = true;
          this.print(specifiers.shift());
          if (specifiers.length) {
            this.tokenChar(44);
            this.space();
          }
        } else {
          break;
        }
      }
      if (specifiers.length || !specifiers.length && !hasSpecial) {
        this.tokenChar(123);
        if (specifiers.length) {
          this.space();
          this.printList(specifiers);
          this.space();
        }
        this.tokenChar(125);
      }
      if (node.source) {
        var _node$attributes2, _node$assertions2;
        this.space();
        this.word("from");
        this.space();
        if ((_node$attributes2 = node.attributes) != null && _node$attributes2.length || (_node$assertions2 = node.assertions) != null && _node$assertions2.length) {
          this.print(node.source, true);
          this.space();
          this._printAttributes(node);
        } else {
          this.print(node.source);
        }
      }
      this.semicolon();
    }
  }
  function ExportDefaultDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word("export");
    this.noIndentInnerCommentsHere();
    this.space();
    this.word("default");
    this.space();
    this.tokenContext |= _index.TokenContext.exportDefault;
    const declar = node.declaration;
    this.print(declar);
    if (!isStatement(declar))
      this.semicolon();
  }
  function ImportDeclaration(node) {
    var _node$attributes3, _node$assertions3;
    this.word("import");
    this.space();
    const isTypeKind = node.importKind === "type" || node.importKind === "typeof";
    if (isTypeKind) {
      this.noIndentInnerCommentsHere();
      this.word(node.importKind);
      this.space();
    } else if (node.module) {
      this.noIndentInnerCommentsHere();
      this.word("module");
      this.space();
    } else if (node.phase) {
      this.noIndentInnerCommentsHere();
      this.word(node.phase);
      this.space();
    }
    const specifiers = node.specifiers.slice(0);
    const hasSpecifiers = !!specifiers.length;
    while (hasSpecifiers) {
      const first = specifiers[0];
      if (isImportDefaultSpecifier(first) || isImportNamespaceSpecifier(first)) {
        this.print(specifiers.shift());
        if (specifiers.length) {
          this.tokenChar(44);
          this.space();
        }
      } else {
        break;
      }
    }
    if (specifiers.length) {
      this.tokenChar(123);
      this.space();
      this.printList(specifiers);
      this.space();
      this.tokenChar(125);
    } else if (isTypeKind && !hasSpecifiers) {
      this.tokenChar(123);
      this.tokenChar(125);
    }
    if (hasSpecifiers || isTypeKind) {
      this.space();
      this.word("from");
      this.space();
    }
    if ((_node$attributes3 = node.attributes) != null && _node$attributes3.length || (_node$assertions3 = node.assertions) != null && _node$assertions3.length) {
      this.print(node.source, true);
      this.space();
      this._printAttributes(node);
    } else {
      this.print(node.source);
    }
    this.semicolon();
  }
  function ImportAttribute(node) {
    this.print(node.key);
    this.tokenChar(58);
    this.space();
    this.print(node.value);
  }
  function ImportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word("as");
    this.space();
    this.print(node.local);
  }
  function ImportExpression(node) {
    this.word("import");
    if (node.phase) {
      this.tokenChar(46);
      this.word(node.phase);
    }
    this.tokenChar(40);
    this.print(node.source);
    if (node.options != null) {
      this.tokenChar(44);
      this.space();
      this.print(node.options);
    }
    this.tokenChar(41);
  }
});
var require_jsesc = __commonJS2((exports, module) => {
  var object = {};
  var hasOwnProperty2 = object.hasOwnProperty;
  var forOwn = (object2, callback) => {
    for (const key in object2) {
      if (hasOwnProperty2.call(object2, key)) {
        callback(key, object2[key]);
      }
    }
  };
  var extend = (destination, source) => {
    if (!source) {
      return destination;
    }
    forOwn(source, (key, value) => {
      destination[key] = value;
    });
    return destination;
  };
  var forEach = (array, callback) => {
    const length = array.length;
    let index = -1;
    while (++index < length) {
      callback(array[index]);
    }
  };
  var fourHexEscape = (hex) => {
    return "\\u" + ("0000" + hex).slice(-4);
  };
  var hexadecimal = (code, lowercase) => {
    let hexadecimal2 = code.toString(16);
    if (lowercase)
      return hexadecimal2;
    return hexadecimal2.toUpperCase();
  };
  var toString2 = object.toString;
  var isArray22 = Array.isArray;
  var isBuffer = (value) => {
    return typeof Buffer === "function" && Buffer.isBuffer(value);
  };
  var isObject32 = (value) => {
    return toString2.call(value) == "[object Object]";
  };
  var isString22 = (value) => {
    return typeof value == "string" || toString2.call(value) == "[object String]";
  };
  var isNumber = (value) => {
    return typeof value == "number" || toString2.call(value) == "[object Number]";
  };
  var isFunction22 = (value) => {
    return typeof value == "function";
  };
  var isMap = (value) => {
    return toString2.call(value) == "[object Map]";
  };
  var isSet = (value) => {
    return toString2.call(value) == "[object Set]";
  };
  var singleEscapes = {
    "\\": "\\\\",
    "\b": "\\b",
    "\f": "\\f",
    "\n": "\\n",
    "\r": "\\r",
    "\t": "\\t"
  };
  var regexSingleEscape = /[\\\b\f\n\r\t]/;
  var regexDigit = /[0-9]/;
  var regexWhitespace = /[\xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000]/;
  var escapeEverythingRegex = /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^]/g;
  var escapeNonAsciiRegex = /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^ !#-&\(-\[\]-_a-~]/g;
  var jsesc = (argument, options3) => {
    const increaseIndentation = () => {
      oldIndent = indent;
      ++options3.indentLevel;
      indent = options3.indent.repeat(options3.indentLevel);
    };
    const defaults = {
      escapeEverything: false,
      minimal: false,
      isScriptContext: false,
      quotes: "single",
      wrap: false,
      es6: false,
      json: false,
      compact: true,
      lowercaseHex: false,
      numbers: "decimal",
      indent: "\t",
      indentLevel: 0,
      __inline1__: false,
      __inline2__: false
    };
    const json = options3 && options3.json;
    if (json) {
      defaults.quotes = "double";
      defaults.wrap = true;
    }
    options3 = extend(defaults, options3);
    if (options3.quotes != "single" && options3.quotes != "double" && options3.quotes != "backtick") {
      options3.quotes = "single";
    }
    const quote = options3.quotes == "double" ? '"' : options3.quotes == "backtick" ? "`" : "\'";
    const compact = options3.compact;
    const lowercaseHex = options3.lowercaseHex;
    let indent = options3.indent.repeat(options3.indentLevel);
    let oldIndent = "";
    const inline1 = options3.__inline1__;
    const inline2 = options3.__inline2__;
    const newLine = compact ? "" : "\n";
    let result2;
    let isEmpty = true;
    const useBinNumbers = options3.numbers == "binary";
    const useOctNumbers = options3.numbers == "octal";
    const useDecNumbers = options3.numbers == "decimal";
    const useHexNumbers = options3.numbers == "hexadecimal";
    if (json && argument && isFunction22(argument.toJSON)) {
      argument = argument.toJSON();
    }
    if (!isString22(argument)) {
      if (isMap(argument)) {
        if (argument.size == 0) {
          return "new Map()";
        }
        if (!compact) {
          options3.__inline1__ = true;
          options3.__inline2__ = false;
        }
        return "new Map(" + jsesc(Array.from(argument), options3) + ")";
      }
      if (isSet(argument)) {
        if (argument.size == 0) {
          return "new Set()";
        }
        return "new Set(" + jsesc(Array.from(argument), options3) + ")";
      }
      if (isBuffer(argument)) {
        if (argument.length == 0) {
          return "Buffer.from([])";
        }
        return "Buffer.from(" + jsesc(Array.from(argument), options3) + ")";
      }
      if (isArray22(argument)) {
        result2 = [];
        options3.wrap = true;
        if (inline1) {
          options3.__inline1__ = false;
          options3.__inline2__ = true;
        }
        if (!inline2) {
          increaseIndentation();
        }
        forEach(argument, (value) => {
          isEmpty = false;
          if (inline2) {
            options3.__inline2__ = false;
          }
          result2.push((compact || inline2 ? "" : indent) + jsesc(value, options3));
        });
        if (isEmpty) {
          return "[]";
        }
        if (inline2) {
          return "[" + result2.join(", ") + "]";
        }
        return "[" + newLine + result2.join("," + newLine) + newLine + (compact ? "" : oldIndent) + "]";
      } else if (isNumber(argument)) {
        if (json) {
          return JSON.stringify(argument);
        }
        if (useDecNumbers) {
          return String(argument);
        }
        if (useHexNumbers) {
          let hexadecimal2 = argument.toString(16);
          if (!lowercaseHex) {
            hexadecimal2 = hexadecimal2.toUpperCase();
          }
          return "0x" + hexadecimal2;
        }
        if (useBinNumbers) {
          return "0b" + argument.toString(2);
        }
        if (useOctNumbers) {
          return "0o" + argument.toString(8);
        }
      } else if (!isObject32(argument)) {
        if (json) {
          return JSON.stringify(argument) || "null";
        }
        return String(argument);
      } else {
        result2 = [];
        options3.wrap = true;
        increaseIndentation();
        forOwn(argument, (key, value) => {
          isEmpty = false;
          result2.push((compact ? "" : indent) + jsesc(key, options3) + ":" + (compact ? "" : " ") + jsesc(value, options3));
        });
        if (isEmpty) {
          return "{}";
        }
        return "{" + newLine + result2.join("," + newLine) + newLine + (compact ? "" : oldIndent) + "}";
      }
    }
    const regex22 = options3.escapeEverything ? escapeEverythingRegex : escapeNonAsciiRegex;
    result2 = argument.replace(regex22, (char, pair, lone, quoteChar, index, string2) => {
      if (pair) {
        if (options3.minimal)
          return pair;
        const first = pair.charCodeAt(0);
        const second = pair.charCodeAt(1);
        if (options3.es6) {
          const codePoint = (first - 55296) * 1024 + second - 56320 + 65536;
          const hex2 = hexadecimal(codePoint, lowercaseHex);
          return "\\u{" + hex2 + "}";
        }
        return fourHexEscape(hexadecimal(first, lowercaseHex)) + fourHexEscape(hexadecimal(second, lowercaseHex));
      }
      if (lone) {
        return fourHexEscape(hexadecimal(lone.charCodeAt(0), lowercaseHex));
      }
      if (char == "\0" && !json && !regexDigit.test(string2.charAt(index + 1))) {
        return "\\0";
      }
      if (quoteChar) {
        if (quoteChar == quote || options3.escapeEverything) {
          return "\\" + quoteChar;
        }
        return quoteChar;
      }
      if (regexSingleEscape.test(char)) {
        return singleEscapes[char];
      }
      if (options3.minimal && !regexWhitespace.test(char)) {
        return char;
      }
      const hex = hexadecimal(char.charCodeAt(0), lowercaseHex);
      if (json || hex.length > 2) {
        return fourHexEscape(hex);
      }
      return "\\x" + ("00" + hex).slice(-2);
    });
    if (quote == "`") {
      result2 = result2.replace(/\$\{/g, "\\${");
    }
    if (options3.isScriptContext) {
      result2 = result2.replace(/<\/(script|style)/gi, "<\\/$1").replace(/<!--/g, json ? "\\u003C!--" : "\\x3C!--");
    }
    if (options3.wrap) {
      result2 = quote + result2 + quote;
    }
    return result2;
  };
  jsesc.version = "3.0.2";
  module.exports = jsesc;
});
var require_types = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ArgumentPlaceholder = ArgumentPlaceholder;
  exports.ArrayPattern = exports.ArrayExpression = ArrayExpression;
  exports.BigIntLiteral = BigIntLiteral;
  exports.BooleanLiteral = BooleanLiteral;
  exports.DecimalLiteral = DecimalLiteral;
  exports.Identifier = Identifier;
  exports.NullLiteral = NullLiteral;
  exports.NumericLiteral = NumericLiteral;
  exports.ObjectPattern = exports.ObjectExpression = ObjectExpression;
  exports.ObjectMethod = ObjectMethod;
  exports.ObjectProperty = ObjectProperty;
  exports.PipelineBareFunction = PipelineBareFunction;
  exports.PipelinePrimaryTopicReference = PipelinePrimaryTopicReference;
  exports.PipelineTopicExpression = PipelineTopicExpression;
  exports.RecordExpression = RecordExpression;
  exports.RegExpLiteral = RegExpLiteral;
  exports.SpreadElement = exports.RestElement = RestElement;
  exports.StringLiteral = StringLiteral;
  exports.TopicReference = TopicReference;
  exports.TupleExpression = TupleExpression;
  var _t = require_lib6();
  var _jsesc = require_jsesc();
  var {
    isAssignmentPattern,
    isIdentifier
  } = _t;
  function Identifier(node) {
    var _node$loc;
    this.sourceIdentifierName(((_node$loc = node.loc) == null ? undefined : _node$loc.identifierName) || node.name);
    this.word(node.name);
  }
  function ArgumentPlaceholder() {
    this.tokenChar(63);
  }
  function RestElement(node) {
    this.token("...");
    this.print(node.argument);
  }
  function ObjectExpression(node) {
    const props = node.properties;
    this.tokenChar(123);
    if (props.length) {
      const exit = this.enterDelimited();
      this.space();
      this.printList(props, {
        indent: true,
        statement: true
      });
      this.space();
      exit();
    }
    this.sourceWithOffset("end", node.loc, -1);
    this.tokenChar(125);
  }
  function ObjectMethod(node) {
    this.printJoin(node.decorators);
    this._methodHead(node);
    this.space();
    this.print(node.body);
  }
  function ObjectProperty(node) {
    this.printJoin(node.decorators);
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      if (isAssignmentPattern(node.value) && isIdentifier(node.key) && node.key.name === node.value.left.name) {
        this.print(node.value);
        return;
      }
      this.print(node.key);
      if (node.shorthand && isIdentifier(node.key) && isIdentifier(node.value) && node.key.name === node.value.name) {
        return;
      }
    }
    this.tokenChar(58);
    this.space();
    this.print(node.value);
  }
  function ArrayExpression(node) {
    const elems = node.elements;
    const len = elems.length;
    this.tokenChar(91);
    const exit = this.enterDelimited();
    for (let i = 0;i < elems.length; i++) {
      const elem = elems[i];
      if (elem) {
        if (i > 0)
          this.space();
        this.print(elem);
        if (i < len - 1)
          this.tokenChar(44);
      } else {
        this.tokenChar(44);
      }
    }
    exit();
    this.tokenChar(93);
  }
  function RecordExpression(node) {
    const props = node.properties;
    let startToken;
    let endToken;
    {
      if (this.format.recordAndTupleSyntaxType === "bar") {
        startToken = "{|";
        endToken = "|}";
      } else if (this.format.recordAndTupleSyntaxType !== "hash" && this.format.recordAndTupleSyntaxType != null) {
        throw new Error(`The "recordAndTupleSyntaxType" generator option must be "bar" or "hash" (${JSON.stringify(this.format.recordAndTupleSyntaxType)} received).`);
      } else {
        startToken = "#{";
        endToken = "}";
      }
    }
    this.token(startToken);
    if (props.length) {
      this.space();
      this.printList(props, {
        indent: true,
        statement: true
      });
      this.space();
    }
    this.token(endToken);
  }
  function TupleExpression(node) {
    const elems = node.elements;
    const len = elems.length;
    let startToken;
    let endToken;
    {
      if (this.format.recordAndTupleSyntaxType === "bar") {
        startToken = "[|";
        endToken = "|]";
      } else if (this.format.recordAndTupleSyntaxType === "hash") {
        startToken = "#[";
        endToken = "]";
      } else {
        throw new Error(`${this.format.recordAndTupleSyntaxType} is not a valid recordAndTuple syntax type`);
      }
    }
    this.token(startToken);
    for (let i = 0;i < elems.length; i++) {
      const elem = elems[i];
      if (elem) {
        if (i > 0)
          this.space();
        this.print(elem);
        if (i < len - 1)
          this.tokenChar(44);
      }
    }
    this.token(endToken);
  }
  function RegExpLiteral(node) {
    this.word(`/${node.pattern}/${node.flags}`);
  }
  function BooleanLiteral(node) {
    this.word(node.value ? "true" : "false");
  }
  function NullLiteral() {
    this.word("null");
  }
  function NumericLiteral(node) {
    const raw = this.getPossibleRaw(node);
    const opts = this.format.jsescOption;
    const value = node.value;
    const str = value + "";
    if (opts.numbers) {
      this.number(_jsesc(value, opts), value);
    } else if (raw == null) {
      this.number(str, value);
    } else if (this.format.minified) {
      this.number(raw.length < str.length ? raw : str, value);
    } else {
      this.number(raw, value);
    }
  }
  function StringLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.token(raw);
      return;
    }
    const val2 = _jsesc(node.value, this.format.jsescOption);
    this.token(val2);
  }
  function BigIntLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.word(raw);
      return;
    }
    this.word(node.value + "n");
  }
  function DecimalLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.word(raw);
      return;
    }
    this.word(node.value + "m");
  }
  var validTopicTokenSet = new Set(["^^", "@@", "^", "%", "#"]);
  function TopicReference() {
    const {
      topicToken
    } = this.format;
    if (validTopicTokenSet.has(topicToken)) {
      this.token(topicToken);
    } else {
      const givenTopicTokenJSON = JSON.stringify(topicToken);
      const validTopics = Array.from(validTopicTokenSet, (v22) => JSON.stringify(v22));
      throw new Error(`The "topicToken" generator option must be one of ${validTopics.join(", ")} (${givenTopicTokenJSON} received instead).`);
    }
  }
  function PipelineTopicExpression(node) {
    this.print(node.expression);
  }
  function PipelineBareFunction(node) {
    this.print(node.callee);
  }
  function PipelinePrimaryTopicReference() {
    this.tokenChar(35);
  }
});
var require_flow2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.AnyTypeAnnotation = AnyTypeAnnotation;
  exports.ArrayTypeAnnotation = ArrayTypeAnnotation;
  exports.BooleanLiteralTypeAnnotation = BooleanLiteralTypeAnnotation;
  exports.BooleanTypeAnnotation = BooleanTypeAnnotation;
  exports.DeclareClass = DeclareClass;
  exports.DeclareExportAllDeclaration = DeclareExportAllDeclaration;
  exports.DeclareExportDeclaration = DeclareExportDeclaration;
  exports.DeclareFunction = DeclareFunction;
  exports.DeclareInterface = DeclareInterface;
  exports.DeclareModule = DeclareModule;
  exports.DeclareModuleExports = DeclareModuleExports;
  exports.DeclareOpaqueType = DeclareOpaqueType;
  exports.DeclareTypeAlias = DeclareTypeAlias;
  exports.DeclareVariable = DeclareVariable;
  exports.DeclaredPredicate = DeclaredPredicate;
  exports.EmptyTypeAnnotation = EmptyTypeAnnotation;
  exports.EnumBooleanBody = EnumBooleanBody;
  exports.EnumBooleanMember = EnumBooleanMember;
  exports.EnumDeclaration = EnumDeclaration;
  exports.EnumDefaultedMember = EnumDefaultedMember;
  exports.EnumNumberBody = EnumNumberBody;
  exports.EnumNumberMember = EnumNumberMember;
  exports.EnumStringBody = EnumStringBody;
  exports.EnumStringMember = EnumStringMember;
  exports.EnumSymbolBody = EnumSymbolBody;
  exports.ExistsTypeAnnotation = ExistsTypeAnnotation;
  exports.FunctionTypeAnnotation = FunctionTypeAnnotation;
  exports.FunctionTypeParam = FunctionTypeParam;
  exports.IndexedAccessType = IndexedAccessType;
  exports.InferredPredicate = InferredPredicate;
  exports.InterfaceDeclaration = InterfaceDeclaration;
  exports.GenericTypeAnnotation = exports.ClassImplements = exports.InterfaceExtends = InterfaceExtends;
  exports.InterfaceTypeAnnotation = InterfaceTypeAnnotation;
  exports.IntersectionTypeAnnotation = IntersectionTypeAnnotation;
  exports.MixedTypeAnnotation = MixedTypeAnnotation;
  exports.NullLiteralTypeAnnotation = NullLiteralTypeAnnotation;
  exports.NullableTypeAnnotation = NullableTypeAnnotation;
  Object.defineProperty(exports, "NumberLiteralTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _types2.NumericLiteral;
    }
  });
  exports.NumberTypeAnnotation = NumberTypeAnnotation;
  exports.ObjectTypeAnnotation = ObjectTypeAnnotation;
  exports.ObjectTypeCallProperty = ObjectTypeCallProperty;
  exports.ObjectTypeIndexer = ObjectTypeIndexer;
  exports.ObjectTypeInternalSlot = ObjectTypeInternalSlot;
  exports.ObjectTypeProperty = ObjectTypeProperty;
  exports.ObjectTypeSpreadProperty = ObjectTypeSpreadProperty;
  exports.OpaqueType = OpaqueType;
  exports.OptionalIndexedAccessType = OptionalIndexedAccessType;
  exports.QualifiedTypeIdentifier = QualifiedTypeIdentifier;
  Object.defineProperty(exports, "StringLiteralTypeAnnotation", {
    enumerable: true,
    get: function() {
      return _types2.StringLiteral;
    }
  });
  exports.StringTypeAnnotation = StringTypeAnnotation;
  exports.SymbolTypeAnnotation = SymbolTypeAnnotation;
  exports.ThisTypeAnnotation = ThisTypeAnnotation;
  exports.TupleTypeAnnotation = TupleTypeAnnotation;
  exports.TypeAlias = TypeAlias;
  exports.TypeAnnotation = TypeAnnotation;
  exports.TypeCastExpression = TypeCastExpression;
  exports.TypeParameter = TypeParameter;
  exports.TypeParameterDeclaration = exports.TypeParameterInstantiation = TypeParameterInstantiation;
  exports.TypeofTypeAnnotation = TypeofTypeAnnotation;
  exports.UnionTypeAnnotation = UnionTypeAnnotation;
  exports.Variance = Variance;
  exports.VoidTypeAnnotation = VoidTypeAnnotation;
  exports._interfaceish = _interfaceish;
  exports._variance = _variance;
  var _t = require_lib6();
  var _modules = require_modules();
  var _index = require_node2();
  var _types2 = require_types();
  var {
    isDeclareExportDeclaration,
    isStatement
  } = _t;
  function AnyTypeAnnotation() {
    this.word("any");
  }
  function ArrayTypeAnnotation(node) {
    this.print(node.elementType, true);
    this.tokenChar(91);
    this.tokenChar(93);
  }
  function BooleanTypeAnnotation() {
    this.word("boolean");
  }
  function BooleanLiteralTypeAnnotation(node) {
    this.word(node.value ? "true" : "false");
  }
  function NullLiteralTypeAnnotation() {
    this.word("null");
  }
  function DeclareClass(node, parent) {
    if (!isDeclareExportDeclaration(parent)) {
      this.word("declare");
      this.space();
    }
    this.word("class");
    this.space();
    this._interfaceish(node);
  }
  function DeclareFunction(node, parent) {
    if (!isDeclareExportDeclaration(parent)) {
      this.word("declare");
      this.space();
    }
    this.word("function");
    this.space();
    this.print(node.id);
    this.print(node.id.typeAnnotation.typeAnnotation);
    if (node.predicate) {
      this.space();
      this.print(node.predicate);
    }
    this.semicolon();
  }
  function InferredPredicate() {
    this.tokenChar(37);
    this.word("checks");
  }
  function DeclaredPredicate(node) {
    this.tokenChar(37);
    this.word("checks");
    this.tokenChar(40);
    this.print(node.value);
    this.tokenChar(41);
  }
  function DeclareInterface(node) {
    this.word("declare");
    this.space();
    this.InterfaceDeclaration(node);
  }
  function DeclareModule(node) {
    this.word("declare");
    this.space();
    this.word("module");
    this.space();
    this.print(node.id);
    this.space();
    this.print(node.body);
  }
  function DeclareModuleExports(node) {
    this.word("declare");
    this.space();
    this.word("module");
    this.tokenChar(46);
    this.word("exports");
    this.print(node.typeAnnotation);
  }
  function DeclareTypeAlias(node) {
    this.word("declare");
    this.space();
    this.TypeAlias(node);
  }
  function DeclareOpaqueType(node, parent) {
    if (!isDeclareExportDeclaration(parent)) {
      this.word("declare");
      this.space();
    }
    this.OpaqueType(node);
  }
  function DeclareVariable(node, parent) {
    if (!isDeclareExportDeclaration(parent)) {
      this.word("declare");
      this.space();
    }
    this.word("var");
    this.space();
    this.print(node.id);
    this.print(node.id.typeAnnotation);
    this.semicolon();
  }
  function DeclareExportDeclaration(node) {
    this.word("declare");
    this.space();
    this.word("export");
    this.space();
    if (node.default) {
      this.word("default");
      this.space();
    }
    FlowExportDeclaration.call(this, node);
  }
  function DeclareExportAllDeclaration(node) {
    this.word("declare");
    this.space();
    _modules.ExportAllDeclaration.call(this, node);
  }
  function EnumDeclaration(node) {
    const {
      id,
      body
    } = node;
    this.word("enum");
    this.space();
    this.print(id);
    this.print(body);
  }
  function enumExplicitType(context, name, hasExplicitType) {
    if (hasExplicitType) {
      context.space();
      context.word("of");
      context.space();
      context.word(name);
    }
    context.space();
  }
  function enumBody(context, node) {
    const {
      members
    } = node;
    context.token("{");
    context.indent();
    context.newline();
    for (const member of members) {
      context.print(member);
      context.newline();
    }
    if (node.hasUnknownMembers) {
      context.token("...");
      context.newline();
    }
    context.dedent();
    context.token("}");
  }
  function EnumBooleanBody(node) {
    const {
      explicitType
    } = node;
    enumExplicitType(this, "boolean", explicitType);
    enumBody(this, node);
  }
  function EnumNumberBody(node) {
    const {
      explicitType
    } = node;
    enumExplicitType(this, "number", explicitType);
    enumBody(this, node);
  }
  function EnumStringBody(node) {
    const {
      explicitType
    } = node;
    enumExplicitType(this, "string", explicitType);
    enumBody(this, node);
  }
  function EnumSymbolBody(node) {
    enumExplicitType(this, "symbol", true);
    enumBody(this, node);
  }
  function EnumDefaultedMember(node) {
    const {
      id
    } = node;
    this.print(id);
    this.tokenChar(44);
  }
  function enumInitializedMember(context, node) {
    context.print(node.id);
    context.space();
    context.token("=");
    context.space();
    context.print(node.init);
    context.token(",");
  }
  function EnumBooleanMember(node) {
    enumInitializedMember(this, node);
  }
  function EnumNumberMember(node) {
    enumInitializedMember(this, node);
  }
  function EnumStringMember(node) {
    enumInitializedMember(this, node);
  }
  function FlowExportDeclaration(node) {
    if (node.declaration) {
      const declar = node.declaration;
      this.print(declar);
      if (!isStatement(declar))
        this.semicolon();
    } else {
      this.tokenChar(123);
      if (node.specifiers.length) {
        this.space();
        this.printList(node.specifiers);
        this.space();
      }
      this.tokenChar(125);
      if (node.source) {
        this.space();
        this.word("from");
        this.space();
        this.print(node.source);
      }
      this.semicolon();
    }
  }
  function ExistsTypeAnnotation() {
    this.tokenChar(42);
  }
  function FunctionTypeAnnotation(node, parent) {
    this.print(node.typeParameters);
    this.tokenChar(40);
    if (node.this) {
      this.word("this");
      this.tokenChar(58);
      this.space();
      this.print(node.this.typeAnnotation);
      if (node.params.length || node.rest) {
        this.tokenChar(44);
        this.space();
      }
    }
    this.printList(node.params);
    if (node.rest) {
      if (node.params.length) {
        this.tokenChar(44);
        this.space();
      }
      this.token("...");
      this.print(node.rest);
    }
    this.tokenChar(41);
    const type = parent == null ? undefined : parent.type;
    if (type != null && (type === "ObjectTypeCallProperty" || type === "ObjectTypeInternalSlot" || type === "DeclareFunction" || type === "ObjectTypeProperty" && parent.method)) {
      this.tokenChar(58);
    } else {
      this.space();
      this.token("=>");
    }
    this.space();
    this.print(node.returnType);
  }
  function FunctionTypeParam(node) {
    this.print(node.name);
    if (node.optional)
      this.tokenChar(63);
    if (node.name) {
      this.tokenChar(58);
      this.space();
    }
    this.print(node.typeAnnotation);
  }
  function InterfaceExtends(node) {
    this.print(node.id);
    this.print(node.typeParameters, true);
  }
  function _interfaceish(node) {
    var _node$extends;
    this.print(node.id);
    this.print(node.typeParameters);
    if ((_node$extends = node.extends) != null && _node$extends.length) {
      this.space();
      this.word("extends");
      this.space();
      this.printList(node.extends);
    }
    if (node.type === "DeclareClass") {
      var _node$mixins, _node$implements;
      if ((_node$mixins = node.mixins) != null && _node$mixins.length) {
        this.space();
        this.word("mixins");
        this.space();
        this.printList(node.mixins);
      }
      if ((_node$implements = node.implements) != null && _node$implements.length) {
        this.space();
        this.word("implements");
        this.space();
        this.printList(node.implements);
      }
    }
    this.space();
    this.print(node.body);
  }
  function _variance(node) {
    var _node$variance;
    const kind = (_node$variance = node.variance) == null ? undefined : _node$variance.kind;
    if (kind != null) {
      if (kind === "plus") {
        this.tokenChar(43);
      } else if (kind === "minus") {
        this.tokenChar(45);
      }
    }
  }
  function InterfaceDeclaration(node) {
    this.word("interface");
    this.space();
    this._interfaceish(node);
  }
  function andSeparator() {
    this.space();
    this.tokenChar(38);
    this.space();
  }
  function InterfaceTypeAnnotation(node) {
    var _node$extends2;
    this.word("interface");
    if ((_node$extends2 = node.extends) != null && _node$extends2.length) {
      this.space();
      this.word("extends");
      this.space();
      this.printList(node.extends);
    }
    this.space();
    this.print(node.body);
  }
  function IntersectionTypeAnnotation(node) {
    this.printJoin(node.types, {
      separator: andSeparator
    });
  }
  function MixedTypeAnnotation() {
    this.word("mixed");
  }
  function EmptyTypeAnnotation() {
    this.word("empty");
  }
  function NullableTypeAnnotation(node) {
    this.tokenChar(63);
    this.print(node.typeAnnotation);
  }
  function NumberTypeAnnotation() {
    this.word("number");
  }
  function StringTypeAnnotation() {
    this.word("string");
  }
  function ThisTypeAnnotation() {
    this.word("this");
  }
  function TupleTypeAnnotation(node) {
    this.tokenChar(91);
    this.printList(node.types);
    this.tokenChar(93);
  }
  function TypeofTypeAnnotation(node) {
    this.word("typeof");
    this.space();
    this.print(node.argument);
  }
  function TypeAlias(node) {
    this.word("type");
    this.space();
    this.print(node.id);
    this.print(node.typeParameters);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.right);
    this.semicolon();
  }
  function TypeAnnotation(node, parent) {
    this.tokenChar(58);
    this.space();
    if (parent.type === "ArrowFunctionExpression") {
      this.tokenContext |= _index.TokenContext.arrowFlowReturnType;
    } else if (node.optional) {
      this.tokenChar(63);
    }
    this.print(node.typeAnnotation);
  }
  function TypeParameterInstantiation(node) {
    this.tokenChar(60);
    this.printList(node.params, {});
    this.tokenChar(62);
  }
  function TypeParameter(node) {
    this._variance(node);
    this.word(node.name);
    if (node.bound) {
      this.print(node.bound);
    }
    if (node.default) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.default);
    }
  }
  function OpaqueType(node) {
    this.word("opaque");
    this.space();
    this.word("type");
    this.space();
    this.print(node.id);
    this.print(node.typeParameters);
    if (node.supertype) {
      this.tokenChar(58);
      this.space();
      this.print(node.supertype);
    }
    if (node.impltype) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.impltype);
    }
    this.semicolon();
  }
  function ObjectTypeAnnotation(node) {
    if (node.exact) {
      this.token("{|");
    } else {
      this.tokenChar(123);
    }
    const props = [...node.properties, ...node.callProperties || [], ...node.indexers || [], ...node.internalSlots || []];
    if (props.length) {
      this.newline();
      this.space();
      this.printJoin(props, {
        addNewlines(leading) {
          if (leading && !props[0])
            return 1;
        },
        indent: true,
        statement: true,
        iterator: () => {
          if (props.length !== 1 || node.inexact) {
            this.tokenChar(44);
            this.space();
          }
        }
      });
      this.space();
    }
    if (node.inexact) {
      this.indent();
      this.token("...");
      if (props.length) {
        this.newline();
      }
      this.dedent();
    }
    if (node.exact) {
      this.token("|}");
    } else {
      this.tokenChar(125);
    }
  }
  function ObjectTypeInternalSlot(node) {
    if (node.static) {
      this.word("static");
      this.space();
    }
    this.tokenChar(91);
    this.tokenChar(91);
    this.print(node.id);
    this.tokenChar(93);
    this.tokenChar(93);
    if (node.optional)
      this.tokenChar(63);
    if (!node.method) {
      this.tokenChar(58);
      this.space();
    }
    this.print(node.value);
  }
  function ObjectTypeCallProperty(node) {
    if (node.static) {
      this.word("static");
      this.space();
    }
    this.print(node.value);
  }
  function ObjectTypeIndexer(node) {
    if (node.static) {
      this.word("static");
      this.space();
    }
    this._variance(node);
    this.tokenChar(91);
    if (node.id) {
      this.print(node.id);
      this.tokenChar(58);
      this.space();
    }
    this.print(node.key);
    this.tokenChar(93);
    this.tokenChar(58);
    this.space();
    this.print(node.value);
  }
  function ObjectTypeProperty(node) {
    if (node.proto) {
      this.word("proto");
      this.space();
    }
    if (node.static) {
      this.word("static");
      this.space();
    }
    if (node.kind === "get" || node.kind === "set") {
      this.word(node.kind);
      this.space();
    }
    this._variance(node);
    this.print(node.key);
    if (node.optional)
      this.tokenChar(63);
    if (!node.method) {
      this.tokenChar(58);
      this.space();
    }
    this.print(node.value);
  }
  function ObjectTypeSpreadProperty(node) {
    this.token("...");
    this.print(node.argument);
  }
  function QualifiedTypeIdentifier(node) {
    this.print(node.qualification);
    this.tokenChar(46);
    this.print(node.id);
  }
  function SymbolTypeAnnotation() {
    this.word("symbol");
  }
  function orSeparator() {
    this.space();
    this.tokenChar(124);
    this.space();
  }
  function UnionTypeAnnotation(node) {
    this.printJoin(node.types, {
      separator: orSeparator
    });
  }
  function TypeCastExpression(node) {
    this.tokenChar(40);
    this.print(node.expression);
    this.print(node.typeAnnotation);
    this.tokenChar(41);
  }
  function Variance(node) {
    if (node.kind === "plus") {
      this.tokenChar(43);
    } else {
      this.tokenChar(45);
    }
  }
  function VoidTypeAnnotation() {
    this.word("void");
  }
  function IndexedAccessType(node) {
    this.print(node.objectType, true);
    this.tokenChar(91);
    this.print(node.indexType);
    this.tokenChar(93);
  }
  function OptionalIndexedAccessType(node) {
    this.print(node.objectType);
    if (node.optional) {
      this.token("?.");
    }
    this.tokenChar(91);
    this.print(node.indexType);
    this.tokenChar(93);
  }
});
var require_base = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.BlockStatement = BlockStatement;
  exports.Directive = Directive;
  exports.DirectiveLiteral = DirectiveLiteral;
  exports.File = File;
  exports.InterpreterDirective = InterpreterDirective;
  exports.Placeholder = Placeholder;
  exports.Program = Program;
  function File(node) {
    if (node.program) {
      this.print(node.program.interpreter);
    }
    this.print(node.program);
  }
  function Program(node) {
    var _node$directives;
    this.noIndentInnerCommentsHere();
    this.printInnerComments();
    const directivesLen = (_node$directives = node.directives) == null ? undefined : _node$directives.length;
    if (directivesLen) {
      var _node$directives$trai;
      const newline = node.body.length ? 2 : 1;
      this.printSequence(node.directives, {
        trailingCommentsLineOffset: newline
      });
      if (!((_node$directives$trai = node.directives[directivesLen - 1].trailingComments) != null && _node$directives$trai.length)) {
        this.newline(newline);
      }
    }
    this.printSequence(node.body);
  }
  function BlockStatement(node) {
    var _node$directives2;
    this.tokenChar(123);
    const exit = this.enterDelimited();
    const directivesLen = (_node$directives2 = node.directives) == null ? undefined : _node$directives2.length;
    if (directivesLen) {
      var _node$directives$trai2;
      const newline = node.body.length ? 2 : 1;
      this.printSequence(node.directives, {
        indent: true,
        trailingCommentsLineOffset: newline
      });
      if (!((_node$directives$trai2 = node.directives[directivesLen - 1].trailingComments) != null && _node$directives$trai2.length)) {
        this.newline(newline);
      }
    }
    this.printSequence(node.body, {
      indent: true
    });
    exit();
    this.rightBrace(node);
  }
  function Directive(node) {
    this.print(node.value);
    this.semicolon();
  }
  var unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
  var unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
  function DirectiveLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.token(raw);
      return;
    }
    const {
      value
    } = node;
    if (!unescapedDoubleQuoteRE.test(value)) {
      this.token(`"${value}"`);
    } else if (!unescapedSingleQuoteRE.test(value)) {
      this.token(`'${value}'`);
    } else {
      throw new Error("Malformed AST: it is not possible to print a directive containing both unescaped single and double quotes.");
    }
  }
  function InterpreterDirective(node) {
    this.token(`#!${node.value}`);
    this.newline(1, true);
  }
  function Placeholder(node) {
    this.token("%%");
    this.print(node.name);
    this.token("%%");
    if (node.expectedNode === "Statement") {
      this.semicolon();
    }
  }
});
var require_jsx2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.JSXAttribute = JSXAttribute;
  exports.JSXClosingElement = JSXClosingElement;
  exports.JSXClosingFragment = JSXClosingFragment;
  exports.JSXElement = JSXElement;
  exports.JSXEmptyExpression = JSXEmptyExpression;
  exports.JSXExpressionContainer = JSXExpressionContainer;
  exports.JSXFragment = JSXFragment;
  exports.JSXIdentifier = JSXIdentifier;
  exports.JSXMemberExpression = JSXMemberExpression;
  exports.JSXNamespacedName = JSXNamespacedName;
  exports.JSXOpeningElement = JSXOpeningElement;
  exports.JSXOpeningFragment = JSXOpeningFragment;
  exports.JSXSpreadAttribute = JSXSpreadAttribute;
  exports.JSXSpreadChild = JSXSpreadChild;
  exports.JSXText = JSXText;
  function JSXAttribute(node) {
    this.print(node.name);
    if (node.value) {
      this.tokenChar(61);
      this.print(node.value);
    }
  }
  function JSXIdentifier(node) {
    this.word(node.name);
  }
  function JSXNamespacedName(node) {
    this.print(node.namespace);
    this.tokenChar(58);
    this.print(node.name);
  }
  function JSXMemberExpression(node) {
    this.print(node.object);
    this.tokenChar(46);
    this.print(node.property);
  }
  function JSXSpreadAttribute(node) {
    this.tokenChar(123);
    this.token("...");
    this.print(node.argument);
    this.rightBrace(node);
  }
  function JSXExpressionContainer(node) {
    this.tokenChar(123);
    this.print(node.expression);
    this.rightBrace(node);
  }
  function JSXSpreadChild(node) {
    this.tokenChar(123);
    this.token("...");
    this.print(node.expression);
    this.rightBrace(node);
  }
  function JSXText(node) {
    const raw = this.getPossibleRaw(node);
    if (raw !== undefined) {
      this.token(raw, true);
    } else {
      this.token(node.value, true);
    }
  }
  function JSXElement(node) {
    const open = node.openingElement;
    this.print(open);
    if (open.selfClosing)
      return;
    this.indent();
    for (const child of node.children) {
      this.print(child);
    }
    this.dedent();
    this.print(node.closingElement);
  }
  function spaceSeparator() {
    this.space();
  }
  function JSXOpeningElement(node) {
    this.tokenChar(60);
    this.print(node.name);
    this.print(node.typeParameters);
    if (node.attributes.length > 0) {
      this.space();
      this.printJoin(node.attributes, {
        separator: spaceSeparator
      });
    }
    if (node.selfClosing) {
      this.space();
      this.token("/>");
    } else {
      this.tokenChar(62);
    }
  }
  function JSXClosingElement(node) {
    this.token("</");
    this.print(node.name);
    this.tokenChar(62);
  }
  function JSXEmptyExpression() {
    this.printInnerComments();
  }
  function JSXFragment(node) {
    this.print(node.openingFragment);
    this.indent();
    for (const child of node.children) {
      this.print(child);
    }
    this.dedent();
    this.print(node.closingFragment);
  }
  function JSXOpeningFragment() {
    this.tokenChar(60);
    this.tokenChar(62);
  }
  function JSXClosingFragment() {
    this.token("</");
    this.tokenChar(62);
  }
});
var require_typescript2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.TSAnyKeyword = TSAnyKeyword;
  exports.TSArrayType = TSArrayType;
  exports.TSSatisfiesExpression = exports.TSAsExpression = TSTypeExpression;
  exports.TSBigIntKeyword = TSBigIntKeyword;
  exports.TSBooleanKeyword = TSBooleanKeyword;
  exports.TSCallSignatureDeclaration = TSCallSignatureDeclaration;
  exports.TSInterfaceHeritage = exports.TSExpressionWithTypeArguments = exports.TSClassImplements = TSClassImplements;
  exports.TSConditionalType = TSConditionalType;
  exports.TSConstructSignatureDeclaration = TSConstructSignatureDeclaration;
  exports.TSConstructorType = TSConstructorType;
  exports.TSDeclareFunction = TSDeclareFunction;
  exports.TSDeclareMethod = TSDeclareMethod;
  exports.TSEnumDeclaration = TSEnumDeclaration;
  exports.TSEnumMember = TSEnumMember;
  exports.TSExportAssignment = TSExportAssignment;
  exports.TSExternalModuleReference = TSExternalModuleReference;
  exports.TSFunctionType = TSFunctionType;
  exports.TSImportEqualsDeclaration = TSImportEqualsDeclaration;
  exports.TSImportType = TSImportType;
  exports.TSIndexSignature = TSIndexSignature;
  exports.TSIndexedAccessType = TSIndexedAccessType;
  exports.TSInferType = TSInferType;
  exports.TSInstantiationExpression = TSInstantiationExpression;
  exports.TSInterfaceBody = TSInterfaceBody;
  exports.TSInterfaceDeclaration = TSInterfaceDeclaration;
  exports.TSIntersectionType = TSIntersectionType;
  exports.TSIntrinsicKeyword = TSIntrinsicKeyword;
  exports.TSLiteralType = TSLiteralType;
  exports.TSMappedType = TSMappedType;
  exports.TSMethodSignature = TSMethodSignature;
  exports.TSModuleBlock = TSModuleBlock;
  exports.TSModuleDeclaration = TSModuleDeclaration;
  exports.TSNamedTupleMember = TSNamedTupleMember;
  exports.TSNamespaceExportDeclaration = TSNamespaceExportDeclaration;
  exports.TSNeverKeyword = TSNeverKeyword;
  exports.TSNonNullExpression = TSNonNullExpression;
  exports.TSNullKeyword = TSNullKeyword;
  exports.TSNumberKeyword = TSNumberKeyword;
  exports.TSObjectKeyword = TSObjectKeyword;
  exports.TSOptionalType = TSOptionalType;
  exports.TSParameterProperty = TSParameterProperty;
  exports.TSParenthesizedType = TSParenthesizedType;
  exports.TSPropertySignature = TSPropertySignature;
  exports.TSQualifiedName = TSQualifiedName;
  exports.TSRestType = TSRestType;
  exports.TSStringKeyword = TSStringKeyword;
  exports.TSSymbolKeyword = TSSymbolKeyword;
  exports.TSThisType = TSThisType;
  exports.TSTupleType = TSTupleType;
  exports.TSTypeAliasDeclaration = TSTypeAliasDeclaration;
  exports.TSTypeAnnotation = TSTypeAnnotation;
  exports.TSTypeAssertion = TSTypeAssertion;
  exports.TSTypeLiteral = TSTypeLiteral;
  exports.TSTypeOperator = TSTypeOperator;
  exports.TSTypeParameter = TSTypeParameter;
  exports.TSTypeParameterDeclaration = exports.TSTypeParameterInstantiation = TSTypeParameterInstantiation;
  exports.TSTypePredicate = TSTypePredicate;
  exports.TSTypeQuery = TSTypeQuery;
  exports.TSTypeReference = TSTypeReference;
  exports.TSUndefinedKeyword = TSUndefinedKeyword;
  exports.TSUnionType = TSUnionType;
  exports.TSUnknownKeyword = TSUnknownKeyword;
  exports.TSVoidKeyword = TSVoidKeyword;
  exports.tsPrintClassMemberModifiers = tsPrintClassMemberModifiers;
  exports.tsPrintFunctionOrConstructorType = tsPrintFunctionOrConstructorType;
  exports.tsPrintPropertyOrMethodName = tsPrintPropertyOrMethodName;
  exports.tsPrintSignatureDeclarationBase = tsPrintSignatureDeclarationBase;
  exports.tsPrintTypeLiteralOrInterfaceBody = tsPrintTypeLiteralOrInterfaceBody;
  function TSTypeAnnotation(node) {
    this.tokenChar(58);
    this.space();
    if (node.optional)
      this.tokenChar(63);
    this.print(node.typeAnnotation);
  }
  function TSTypeParameterInstantiation(node, parent) {
    this.tokenChar(60);
    this.printList(node.params, {});
    if (parent.type === "ArrowFunctionExpression" && node.params.length === 1) {
      this.tokenChar(44);
    }
    this.tokenChar(62);
  }
  function TSTypeParameter(node) {
    if (node.in) {
      this.word("in");
      this.space();
    }
    if (node.out) {
      this.word("out");
      this.space();
    }
    this.word(node.name);
    if (node.constraint) {
      this.space();
      this.word("extends");
      this.space();
      this.print(node.constraint);
    }
    if (node.default) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.default);
    }
  }
  function TSParameterProperty(node) {
    if (node.accessibility) {
      this.word(node.accessibility);
      this.space();
    }
    if (node.readonly) {
      this.word("readonly");
      this.space();
    }
    this._param(node.parameter);
  }
  function TSDeclareFunction(node, parent) {
    if (node.declare) {
      this.word("declare");
      this.space();
    }
    this._functionHead(node, parent);
    this.semicolon();
  }
  function TSDeclareMethod(node) {
    this._classMethodHead(node);
    this.semicolon();
  }
  function TSQualifiedName(node) {
    this.print(node.left);
    this.tokenChar(46);
    this.print(node.right);
  }
  function TSCallSignatureDeclaration(node) {
    this.tsPrintSignatureDeclarationBase(node);
    this.semicolon();
  }
  function TSConstructSignatureDeclaration(node) {
    this.word("new");
    this.space();
    this.tsPrintSignatureDeclarationBase(node);
    this.semicolon();
  }
  function TSPropertySignature(node) {
    const {
      readonly
    } = node;
    if (readonly) {
      this.word("readonly");
      this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.print(node.typeAnnotation);
    this.semicolon();
  }
  function tsPrintPropertyOrMethodName(node) {
    if (node.computed) {
      this.tokenChar(91);
    }
    this.print(node.key);
    if (node.computed) {
      this.tokenChar(93);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
  }
  function TSMethodSignature(node) {
    const {
      kind
    } = node;
    if (kind === "set" || kind === "get") {
      this.word(kind);
      this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.tsPrintSignatureDeclarationBase(node);
    this.semicolon();
  }
  function TSIndexSignature(node) {
    const {
      readonly,
      static: isStatic
    } = node;
    if (isStatic) {
      this.word("static");
      this.space();
    }
    if (readonly) {
      this.word("readonly");
      this.space();
    }
    this.tokenChar(91);
    this._parameters(node.parameters);
    this.tokenChar(93);
    this.print(node.typeAnnotation);
    this.semicolon();
  }
  function TSAnyKeyword() {
    this.word("any");
  }
  function TSBigIntKeyword() {
    this.word("bigint");
  }
  function TSUnknownKeyword() {
    this.word("unknown");
  }
  function TSNumberKeyword() {
    this.word("number");
  }
  function TSObjectKeyword() {
    this.word("object");
  }
  function TSBooleanKeyword() {
    this.word("boolean");
  }
  function TSStringKeyword() {
    this.word("string");
  }
  function TSSymbolKeyword() {
    this.word("symbol");
  }
  function TSVoidKeyword() {
    this.word("void");
  }
  function TSUndefinedKeyword() {
    this.word("undefined");
  }
  function TSNullKeyword() {
    this.word("null");
  }
  function TSNeverKeyword() {
    this.word("never");
  }
  function TSIntrinsicKeyword() {
    this.word("intrinsic");
  }
  function TSThisType() {
    this.word("this");
  }
  function TSFunctionType(node) {
    this.tsPrintFunctionOrConstructorType(node);
  }
  function TSConstructorType(node) {
    if (node.abstract) {
      this.word("abstract");
      this.space();
    }
    this.word("new");
    this.space();
    this.tsPrintFunctionOrConstructorType(node);
  }
  function tsPrintFunctionOrConstructorType(node) {
    const {
      typeParameters
    } = node;
    const parameters = node.parameters;
    this.print(typeParameters);
    this.tokenChar(40);
    this._parameters(parameters);
    this.tokenChar(41);
    this.space();
    this.token("=>");
    this.space();
    const returnType = node.typeAnnotation;
    this.print(returnType.typeAnnotation);
  }
  function TSTypeReference(node) {
    this.print(node.typeName, true);
    this.print(node.typeParameters, true);
  }
  function TSTypePredicate(node) {
    if (node.asserts) {
      this.word("asserts");
      this.space();
    }
    this.print(node.parameterName);
    if (node.typeAnnotation) {
      this.space();
      this.word("is");
      this.space();
      this.print(node.typeAnnotation.typeAnnotation);
    }
  }
  function TSTypeQuery(node) {
    this.word("typeof");
    this.space();
    this.print(node.exprName);
    if (node.typeParameters) {
      this.print(node.typeParameters);
    }
  }
  function TSTypeLiteral(node) {
    this.tsPrintTypeLiteralOrInterfaceBody(node.members, node);
  }
  function tsPrintTypeLiteralOrInterfaceBody(members, node) {
    tsPrintBraced(this, members, node);
  }
  function tsPrintBraced(printer, members, node) {
    printer.token("{");
    if (members.length) {
      printer.indent();
      printer.newline();
      for (const member of members) {
        printer.print(member);
        printer.newline();
      }
      printer.dedent();
    }
    printer.rightBrace(node);
  }
  function TSArrayType(node) {
    this.print(node.elementType, true);
    this.tokenChar(91);
    this.tokenChar(93);
  }
  function TSTupleType(node) {
    this.tokenChar(91);
    this.printList(node.elementTypes);
    this.tokenChar(93);
  }
  function TSOptionalType(node) {
    this.print(node.typeAnnotation);
    this.tokenChar(63);
  }
  function TSRestType(node) {
    this.token("...");
    this.print(node.typeAnnotation);
  }
  function TSNamedTupleMember(node) {
    this.print(node.label);
    if (node.optional)
      this.tokenChar(63);
    this.tokenChar(58);
    this.space();
    this.print(node.elementType);
  }
  function TSUnionType(node) {
    tsPrintUnionOrIntersectionType(this, node, "|");
  }
  function TSIntersectionType(node) {
    tsPrintUnionOrIntersectionType(this, node, "&");
  }
  function tsPrintUnionOrIntersectionType(printer, node, sep33) {
    printer.printJoin(node.types, {
      separator() {
        this.space();
        this.token(sep33);
        this.space();
      }
    });
  }
  function TSConditionalType(node) {
    this.print(node.checkType);
    this.space();
    this.word("extends");
    this.space();
    this.print(node.extendsType);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.trueType);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.falseType);
  }
  function TSInferType(node) {
    this.word("infer");
    this.print(node.typeParameter);
  }
  function TSParenthesizedType(node) {
    this.tokenChar(40);
    this.print(node.typeAnnotation);
    this.tokenChar(41);
  }
  function TSTypeOperator(node) {
    this.word(node.operator);
    this.space();
    this.print(node.typeAnnotation);
  }
  function TSIndexedAccessType(node) {
    this.print(node.objectType, true);
    this.tokenChar(91);
    this.print(node.indexType);
    this.tokenChar(93);
  }
  function TSMappedType(node) {
    const {
      nameType,
      optional,
      readonly,
      typeAnnotation
    } = node;
    this.tokenChar(123);
    this.space();
    if (readonly) {
      tokenIfPlusMinus(this, readonly);
      this.word("readonly");
      this.space();
    }
    this.tokenChar(91);
    {
      this.word(node.typeParameter.name);
    }
    this.space();
    this.word("in");
    this.space();
    {
      this.print(node.typeParameter.constraint);
    }
    if (nameType) {
      this.space();
      this.word("as");
      this.space();
      this.print(nameType);
    }
    this.tokenChar(93);
    if (optional) {
      tokenIfPlusMinus(this, optional);
      this.tokenChar(63);
    }
    if (typeAnnotation) {
      this.tokenChar(58);
      this.space();
      this.print(typeAnnotation);
    }
    this.space();
    this.tokenChar(125);
  }
  function tokenIfPlusMinus(self2, tok) {
    if (tok !== true) {
      self2.token(tok);
    }
  }
  function TSLiteralType(node) {
    this.print(node.literal);
  }
  function TSClassImplements(node) {
    this.print(node.expression);
    this.print(node.typeParameters);
  }
  function TSInterfaceDeclaration(node) {
    const {
      declare,
      id,
      typeParameters,
      extends: extendz,
      body
    } = node;
    if (declare) {
      this.word("declare");
      this.space();
    }
    this.word("interface");
    this.space();
    this.print(id);
    this.print(typeParameters);
    if (extendz != null && extendz.length) {
      this.space();
      this.word("extends");
      this.space();
      this.printList(extendz);
    }
    this.space();
    this.print(body);
  }
  function TSInterfaceBody(node) {
    this.tsPrintTypeLiteralOrInterfaceBody(node.body, node);
  }
  function TSTypeAliasDeclaration(node) {
    const {
      declare,
      id,
      typeParameters,
      typeAnnotation
    } = node;
    if (declare) {
      this.word("declare");
      this.space();
    }
    this.word("type");
    this.space();
    this.print(id);
    this.print(typeParameters);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(typeAnnotation);
    this.semicolon();
  }
  function TSTypeExpression(node) {
    const {
      type,
      expression,
      typeAnnotation
    } = node;
    this.print(expression, true);
    this.space();
    this.word(type === "TSAsExpression" ? "as" : "satisfies");
    this.space();
    this.print(typeAnnotation);
  }
  function TSTypeAssertion(node) {
    const {
      typeAnnotation,
      expression
    } = node;
    this.tokenChar(60);
    this.print(typeAnnotation);
    this.tokenChar(62);
    this.space();
    this.print(expression);
  }
  function TSInstantiationExpression(node) {
    this.print(node.expression);
    this.print(node.typeParameters);
  }
  function TSEnumDeclaration(node) {
    const {
      declare,
      const: isConst,
      id,
      members
    } = node;
    if (declare) {
      this.word("declare");
      this.space();
    }
    if (isConst) {
      this.word("const");
      this.space();
    }
    this.word("enum");
    this.space();
    this.print(id);
    this.space();
    tsPrintBraced(this, members, node);
  }
  function TSEnumMember(node) {
    const {
      id,
      initializer
    } = node;
    this.print(id);
    if (initializer) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(initializer);
    }
    this.tokenChar(44);
  }
  function TSModuleDeclaration(node) {
    const {
      declare,
      id
    } = node;
    if (declare) {
      this.word("declare");
      this.space();
    }
    if (!node.global) {
      this.word(id.type === "Identifier" ? "namespace" : "module");
      this.space();
    }
    this.print(id);
    if (!node.body) {
      this.semicolon();
      return;
    }
    let body = node.body;
    while (body.type === "TSModuleDeclaration") {
      this.tokenChar(46);
      this.print(body.id);
      body = body.body;
    }
    this.space();
    this.print(body);
  }
  function TSModuleBlock(node) {
    tsPrintBraced(this, node.body, node);
  }
  function TSImportType(node) {
    const {
      argument,
      qualifier,
      typeParameters
    } = node;
    this.word("import");
    this.tokenChar(40);
    this.print(argument);
    this.tokenChar(41);
    if (qualifier) {
      this.tokenChar(46);
      this.print(qualifier);
    }
    if (typeParameters) {
      this.print(typeParameters);
    }
  }
  function TSImportEqualsDeclaration(node) {
    const {
      isExport,
      id,
      moduleReference
    } = node;
    if (isExport) {
      this.word("export");
      this.space();
    }
    this.word("import");
    this.space();
    this.print(id);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(moduleReference);
    this.semicolon();
  }
  function TSExternalModuleReference(node) {
    this.token("require(");
    this.print(node.expression);
    this.tokenChar(41);
  }
  function TSNonNullExpression(node) {
    this.print(node.expression);
    this.tokenChar(33);
  }
  function TSExportAssignment(node) {
    this.word("export");
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.expression);
    this.semicolon();
  }
  function TSNamespaceExportDeclaration(node) {
    this.word("export");
    this.space();
    this.word("as");
    this.space();
    this.word("namespace");
    this.space();
    this.print(node.id);
    this.semicolon();
  }
  function tsPrintSignatureDeclarationBase(node) {
    const {
      typeParameters
    } = node;
    const parameters = node.parameters;
    this.print(typeParameters);
    this.tokenChar(40);
    this._parameters(parameters);
    this.tokenChar(41);
    const returnType = node.typeAnnotation;
    this.print(returnType);
  }
  function tsPrintClassMemberModifiers(node) {
    const isField = node.type === "ClassAccessorProperty" || node.type === "ClassProperty";
    if (isField && node.declare) {
      this.word("declare");
      this.space();
    }
    if (node.accessibility) {
      this.word(node.accessibility);
      this.space();
    }
    if (node.static) {
      this.word("static");
      this.space();
    }
    if (node.override) {
      this.word("override");
      this.space();
    }
    if (node.abstract) {
      this.word("abstract");
      this.space();
    }
    if (isField && node.readonly) {
      this.word("readonly");
      this.space();
    }
  }
});
var require_generators = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var _templateLiterals = require_template_literals();
  Object.keys(_templateLiterals).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _templateLiterals[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _templateLiterals[key];
      }
    });
  });
  var _expressions = require_expressions();
  Object.keys(_expressions).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _expressions[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _expressions[key];
      }
    });
  });
  var _statements = require_statements();
  Object.keys(_statements).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _statements[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _statements[key];
      }
    });
  });
  var _classes = require_classes();
  Object.keys(_classes).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _classes[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _classes[key];
      }
    });
  });
  var _methods = require_methods();
  Object.keys(_methods).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _methods[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _methods[key];
      }
    });
  });
  var _modules = require_modules();
  Object.keys(_modules).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _modules[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _modules[key];
      }
    });
  });
  var _types = require_types();
  Object.keys(_types).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _types[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _types[key];
      }
    });
  });
  var _flow = require_flow2();
  Object.keys(_flow).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _flow[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _flow[key];
      }
    });
  });
  var _base = require_base();
  Object.keys(_base).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _base[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _base[key];
      }
    });
  });
  var _jsx = require_jsx2();
  Object.keys(_jsx).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _jsx[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _jsx[key];
      }
    });
  });
  var _typescript = require_typescript2();
  Object.keys(_typescript).forEach(function(key) {
    if (key === "default" || key === "__esModule")
      return;
    if (key in exports && exports[key] === _typescript[key])
      return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function() {
        return _typescript[key];
      }
    });
  });
});
var require_printer = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _buffer = require_buffer();
  var n = require_node2();
  var _t = require_lib6();
  var generatorFunctions = require_generators();
  var {
    isExpression,
    isFunction: isFunction22,
    isStatement,
    isClassBody,
    isTSInterfaceBody,
    isTSEnumDeclaration
  } = _t;
  var SCIENTIFIC_NOTATION = /e/i;
  var ZERO_DECIMAL_INTEGER = /\.0+$/;
  var HAS_NEWLINE = /[\n\r\u2028\u2029]/;
  var HAS_NEWLINE_OR_BlOCK_COMMENT_END = /[\n\r\u2028\u2029]|\*\//;
  function commentIsNewline(c22) {
    return c22.type === "CommentLine" || HAS_NEWLINE.test(c22.value);
  }
  var {
    needsParens
  } = n;

  class Printer {
    constructor(format, map) {
      this.inForStatementInit = false;
      this.tokenContext = 0;
      this._currentNode = null;
      this._indent = 0;
      this._indentRepeat = 0;
      this._insideAux = false;
      this._noLineTerminator = false;
      this._noLineTerminatorAfterNode = null;
      this._printAuxAfterOnNextUserNode = false;
      this._printedComments = new Set;
      this._endsWithInteger = false;
      this._endsWithWord = false;
      this._endsWithDiv = false;
      this._lastCommentLine = 0;
      this._endsWithInnerRaw = false;
      this._indentInnerComments = true;
      this.format = format;
      this._indentRepeat = format.indent.style.length;
      this._inputMap = map == null ? undefined : map._inputMap;
      this._buf = new _buffer.default(map, format.indent.style[0]);
    }
    enterForStatementInit() {
      if (this.inForStatementInit)
        return () => {
        };
      this.inForStatementInit = true;
      return () => {
        this.inForStatementInit = false;
      };
    }
    enterDelimited() {
      const oldInForStatementInit = this.inForStatementInit;
      const oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
      if (oldInForStatementInit === false && oldNoLineTerminatorAfterNode === null) {
        return () => {
        };
      }
      this.inForStatementInit = false;
      this._noLineTerminatorAfterNode = null;
      return () => {
        this.inForStatementInit = oldInForStatementInit;
        this._noLineTerminatorAfterNode = oldNoLineTerminatorAfterNode;
      };
    }
    generate(ast) {
      this.print(ast);
      this._maybeAddAuxComment();
      return this._buf.get();
    }
    indent() {
      if (this.format.compact || this.format.concise)
        return;
      this._indent++;
    }
    dedent() {
      if (this.format.compact || this.format.concise)
        return;
      this._indent--;
    }
    semicolon(force = false) {
      this._maybeAddAuxComment();
      if (force) {
        this._appendChar(59);
      } else {
        this._queue(59);
      }
      this._noLineTerminator = false;
    }
    rightBrace(node) {
      if (this.format.minified) {
        this._buf.removeLastSemicolon();
      }
      this.sourceWithOffset("end", node.loc, -1);
      this.tokenChar(125);
    }
    rightParens(node) {
      this.sourceWithOffset("end", node.loc, -1);
      this.tokenChar(41);
    }
    space(force = false) {
      if (this.format.compact)
        return;
      if (force) {
        this._space();
      } else if (this._buf.hasContent()) {
        const lastCp = this.getLastChar();
        if (lastCp !== 32 && lastCp !== 10) {
          this._space();
        }
      }
    }
    word(str, noLineTerminatorAfter = false) {
      this.tokenContext = 0;
      this._maybePrintInnerComments();
      if (this._endsWithWord || this._endsWithDiv && str.charCodeAt(0) === 47) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._append(str, false);
      this._endsWithWord = true;
      this._noLineTerminator = noLineTerminatorAfter;
    }
    number(str, number) {
      function isNonDecimalLiteral(str2) {
        if (str2.length > 2 && str2.charCodeAt(0) === 48) {
          const secondChar = str2.charCodeAt(1);
          return secondChar === 98 || secondChar === 111 || secondChar === 120;
        }
        return false;
      }
      this.word(str);
      this._endsWithInteger = Number.isInteger(number) && !isNonDecimalLiteral(str) && !SCIENTIFIC_NOTATION.test(str) && !ZERO_DECIMAL_INTEGER.test(str) && str.charCodeAt(str.length - 1) !== 46;
    }
    token(str, maybeNewline = false) {
      this.tokenContext = 0;
      this._maybePrintInnerComments();
      const lastChar = this.getLastChar();
      const strFirst = str.charCodeAt(0);
      if (lastChar === 33 && (str === "--" || strFirst === 61) || strFirst === 43 && lastChar === 43 || strFirst === 45 && lastChar === 45 || strFirst === 46 && this._endsWithInteger) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._append(str, maybeNewline);
      this._noLineTerminator = false;
    }
    tokenChar(char) {
      this.tokenContext = 0;
      this._maybePrintInnerComments();
      const lastChar = this.getLastChar();
      if (char === 43 && lastChar === 43 || char === 45 && lastChar === 45 || char === 46 && this._endsWithInteger) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._appendChar(char);
      this._noLineTerminator = false;
    }
    newline(i = 1, force) {
      if (i <= 0)
        return;
      if (!force) {
        if (this.format.retainLines || this.format.compact)
          return;
        if (this.format.concise) {
          this.space();
          return;
        }
      }
      if (i > 2)
        i = 2;
      i -= this._buf.getNewlineCount();
      for (let j22 = 0;j22 < i; j22++) {
        this._newline();
      }
      return;
    }
    endsWith(char) {
      return this.getLastChar() === char;
    }
    getLastChar() {
      return this._buf.getLastChar();
    }
    endsWithCharAndNewline() {
      return this._buf.endsWithCharAndNewline();
    }
    removeTrailingNewline() {
      this._buf.removeTrailingNewline();
    }
    exactSource(loc, cb) {
      if (!loc) {
        cb();
        return;
      }
      this._catchUp("start", loc);
      this._buf.exactSource(loc, cb);
    }
    source(prop, loc) {
      if (!loc)
        return;
      this._catchUp(prop, loc);
      this._buf.source(prop, loc);
    }
    sourceWithOffset(prop, loc, columnOffset) {
      if (!loc)
        return;
      this._catchUp(prop, loc);
      this._buf.sourceWithOffset(prop, loc, columnOffset);
    }
    sourceIdentifierName(identifierName, pos) {
      if (!this._buf._canMarkIdName)
        return;
      const sourcePosition = this._buf._sourcePosition;
      sourcePosition.identifierNamePos = pos;
      sourcePosition.identifierName = identifierName;
    }
    _space() {
      this._queue(32);
    }
    _newline() {
      this._queue(10);
    }
    _append(str, maybeNewline) {
      this._maybeIndent(str.charCodeAt(0));
      this._buf.append(str, maybeNewline);
      this._endsWithWord = false;
      this._endsWithInteger = false;
      this._endsWithDiv = false;
    }
    _appendChar(char) {
      this._maybeIndent(char);
      this._buf.appendChar(char);
      this._endsWithWord = false;
      this._endsWithInteger = false;
      this._endsWithDiv = false;
    }
    _queue(char) {
      this._maybeIndent(char);
      this._buf.queue(char);
      this._endsWithWord = false;
      this._endsWithInteger = false;
    }
    _maybeIndent(firstChar) {
      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
        this._buf.queueIndentation(this._getIndent());
      }
    }
    _shouldIndent(firstChar) {
      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
        return true;
      }
    }
    catchUp(line) {
      if (!this.format.retainLines)
        return;
      const count = line - this._buf.getCurrentLine();
      for (let i = 0;i < count; i++) {
        this._newline();
      }
    }
    _catchUp(prop, loc) {
      var _loc$prop;
      if (!this.format.retainLines)
        return;
      const line = loc == null || (_loc$prop = loc[prop]) == null ? undefined : _loc$prop.line;
      if (line != null) {
        const count = line - this._buf.getCurrentLine();
        for (let i = 0;i < count; i++) {
          this._newline();
        }
      }
    }
    _getIndent() {
      return this._indentRepeat * this._indent;
    }
    printTerminatorless(node) {
      this._noLineTerminator = true;
      this.print(node);
    }
    print(node, noLineTerminatorAfter, trailingCommentsLineOffset) {
      var _node$extra, _node$leadingComments, _node$leadingComments2;
      if (!node)
        return;
      this._endsWithInnerRaw = false;
      const nodeType = node.type;
      const format = this.format;
      const oldConcise = format.concise;
      if (node._compact) {
        format.concise = true;
      }
      const printMethod = this[nodeType];
      if (printMethod === undefined) {
        throw new ReferenceError(`unknown node of type ${JSON.stringify(nodeType)} with constructor ${JSON.stringify(node.constructor.name)}`);
      }
      const parent = this._currentNode;
      this._currentNode = node;
      const oldInAux = this._insideAux;
      this._insideAux = node.loc == null;
      this._maybeAddAuxComment(this._insideAux && !oldInAux);
      const parenthesized = (_node$extra = node.extra) == null ? undefined : _node$extra.parenthesized;
      let shouldPrintParens = parenthesized && format.retainFunctionParens && nodeType === "FunctionExpression" || needsParens(node, parent, this.tokenContext, this.inForStatementInit);
      if (!shouldPrintParens && parenthesized && (_node$leadingComments = node.leadingComments) != null && _node$leadingComments.length && node.leadingComments[0].type === "CommentBlock") {
        const parentType = parent == null ? undefined : parent.type;
        switch (parentType) {
          case "ExpressionStatement":
          case "VariableDeclarator":
          case "AssignmentExpression":
          case "ReturnStatement":
            break;
          case "CallExpression":
          case "OptionalCallExpression":
          case "NewExpression":
            if (parent.callee !== node)
              break;
          default:
            shouldPrintParens = true;
        }
      }
      let indentParenthesized = false;
      if (!shouldPrintParens && this._noLineTerminator && ((_node$leadingComments2 = node.leadingComments) != null && _node$leadingComments2.some(commentIsNewline) || this.format.retainLines && node.loc && node.loc.start.line > this._buf.getCurrentLine())) {
        shouldPrintParens = true;
        indentParenthesized = true;
      }
      let oldNoLineTerminatorAfterNode;
      let oldInForStatementInitWasTrue;
      if (!shouldPrintParens) {
        noLineTerminatorAfter || (noLineTerminatorAfter = parent && this._noLineTerminatorAfterNode === parent && n.isLastChild(parent, node));
        if (noLineTerminatorAfter) {
          var _node$trailingComment;
          if ((_node$trailingComment = node.trailingComments) != null && _node$trailingComment.some(commentIsNewline)) {
            if (isExpression(node))
              shouldPrintParens = true;
          } else {
            oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
            this._noLineTerminatorAfterNode = node;
          }
        }
      }
      if (shouldPrintParens) {
        this.tokenChar(40);
        if (indentParenthesized)
          this.indent();
        this._endsWithInnerRaw = false;
        if (this.inForStatementInit) {
          oldInForStatementInitWasTrue = true;
          this.inForStatementInit = false;
        }
        oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
        this._noLineTerminatorAfterNode = null;
      }
      this._lastCommentLine = 0;
      this._printLeadingComments(node, parent);
      const loc = nodeType === "Program" || nodeType === "File" ? null : node.loc;
      this.exactSource(loc, printMethod.bind(this, node, parent));
      if (shouldPrintParens) {
        this._printTrailingComments(node, parent);
        if (indentParenthesized) {
          this.dedent();
          this.newline();
        }
        this.tokenChar(41);
        this._noLineTerminator = noLineTerminatorAfter;
        if (oldInForStatementInitWasTrue)
          this.inForStatementInit = true;
      } else if (noLineTerminatorAfter && !this._noLineTerminator) {
        this._noLineTerminator = true;
        this._printTrailingComments(node, parent);
      } else {
        this._printTrailingComments(node, parent, trailingCommentsLineOffset);
      }
      this._currentNode = parent;
      format.concise = oldConcise;
      this._insideAux = oldInAux;
      if (oldNoLineTerminatorAfterNode !== undefined) {
        this._noLineTerminatorAfterNode = oldNoLineTerminatorAfterNode;
      }
      this._endsWithInnerRaw = false;
    }
    _maybeAddAuxComment(enteredPositionlessNode) {
      if (enteredPositionlessNode)
        this._printAuxBeforeComment();
      if (!this._insideAux)
        this._printAuxAfterComment();
    }
    _printAuxBeforeComment() {
      if (this._printAuxAfterOnNextUserNode)
        return;
      this._printAuxAfterOnNextUserNode = true;
      const comment = this.format.auxiliaryCommentBefore;
      if (comment) {
        this._printComment({
          type: "CommentBlock",
          value: comment
        }, 0);
      }
    }
    _printAuxAfterComment() {
      if (!this._printAuxAfterOnNextUserNode)
        return;
      this._printAuxAfterOnNextUserNode = false;
      const comment = this.format.auxiliaryCommentAfter;
      if (comment) {
        this._printComment({
          type: "CommentBlock",
          value: comment
        }, 0);
      }
    }
    getPossibleRaw(node) {
      const extra = node.extra;
      if ((extra == null ? undefined : extra.raw) != null && extra.rawValue != null && node.value === extra.rawValue) {
        return extra.raw;
      }
    }
    printJoin(nodes, opts = {}) {
      if (!(nodes != null && nodes.length))
        return;
      let {
        indent
      } = opts;
      if (indent == null && this.format.retainLines) {
        var _nodes$0$loc;
        const startLine = (_nodes$0$loc = nodes[0].loc) == null ? undefined : _nodes$0$loc.start.line;
        if (startLine != null && startLine !== this._buf.getCurrentLine()) {
          indent = true;
        }
      }
      if (indent)
        this.indent();
      const newlineOpts = {
        addNewlines: opts.addNewlines,
        nextNodeStartLine: 0
      };
      const separator = opts.separator ? opts.separator.bind(this) : null;
      const len = nodes.length;
      for (let i = 0;i < len; i++) {
        const node = nodes[i];
        if (!node)
          continue;
        if (opts.statement)
          this._printNewline(i === 0, newlineOpts);
        this.print(node, undefined, opts.trailingCommentsLineOffset || 0);
        opts.iterator == null || opts.iterator(node, i);
        if (i < len - 1)
          separator == null || separator();
        if (opts.statement) {
          var _node$trailingComment2;
          if (!((_node$trailingComment2 = node.trailingComments) != null && _node$trailingComment2.length)) {
            this._lastCommentLine = 0;
          }
          if (i + 1 === len) {
            this.newline(1);
          } else {
            var _nextNode$loc;
            const nextNode = nodes[i + 1];
            newlineOpts.nextNodeStartLine = ((_nextNode$loc = nextNode.loc) == null ? undefined : _nextNode$loc.start.line) || 0;
            this._printNewline(true, newlineOpts);
          }
        }
      }
      if (indent)
        this.dedent();
    }
    printAndIndentOnComments(node) {
      const indent = node.leadingComments && node.leadingComments.length > 0;
      if (indent)
        this.indent();
      this.print(node);
      if (indent)
        this.dedent();
    }
    printBlock(parent) {
      const node = parent.body;
      if (node.type !== "EmptyStatement") {
        this.space();
      }
      this.print(node);
    }
    _printTrailingComments(node, parent, lineOffset) {
      const {
        innerComments,
        trailingComments
      } = node;
      if (innerComments != null && innerComments.length) {
        this._printComments(2, innerComments, node, parent, lineOffset);
      }
      if (trailingComments != null && trailingComments.length) {
        this._printComments(2, trailingComments, node, parent, lineOffset);
      }
    }
    _printLeadingComments(node, parent) {
      const comments = node.leadingComments;
      if (!(comments != null && comments.length))
        return;
      this._printComments(0, comments, node, parent);
    }
    _maybePrintInnerComments() {
      if (this._endsWithInnerRaw)
        this.printInnerComments();
      this._endsWithInnerRaw = true;
      this._indentInnerComments = true;
    }
    printInnerComments() {
      const node = this._currentNode;
      const comments = node.innerComments;
      if (!(comments != null && comments.length))
        return;
      const hasSpace = this.endsWith(32);
      const indent = this._indentInnerComments;
      const printedCommentsCount = this._printedComments.size;
      if (indent)
        this.indent();
      this._printComments(1, comments, node);
      if (hasSpace && printedCommentsCount !== this._printedComments.size) {
        this.space();
      }
      if (indent)
        this.dedent();
    }
    noIndentInnerCommentsHere() {
      this._indentInnerComments = false;
    }
    printSequence(nodes, opts = {}) {
      var _opts$indent;
      opts.statement = true;
      (_opts$indent = opts.indent) != null || (opts.indent = false);
      this.printJoin(nodes, opts);
    }
    printList(items, opts = {}) {
      if (opts.separator == null) {
        opts.separator = commaSeparator;
      }
      this.printJoin(items, opts);
    }
    _printNewline(newLine, opts) {
      const format = this.format;
      if (format.retainLines || format.compact)
        return;
      if (format.concise) {
        this.space();
        return;
      }
      if (!newLine) {
        return;
      }
      const startLine = opts.nextNodeStartLine;
      const lastCommentLine = this._lastCommentLine;
      if (startLine > 0 && lastCommentLine > 0) {
        const offset = startLine - lastCommentLine;
        if (offset >= 0) {
          this.newline(offset || 1);
          return;
        }
      }
      if (this._buf.hasContent()) {
        this.newline(1);
      }
    }
    _shouldPrintComment(comment) {
      if (comment.ignore)
        return 0;
      if (this._printedComments.has(comment))
        return 0;
      if (this._noLineTerminator && HAS_NEWLINE_OR_BlOCK_COMMENT_END.test(comment.value)) {
        return 2;
      }
      this._printedComments.add(comment);
      if (!this.format.shouldPrintComment(comment.value)) {
        return 0;
      }
      return 1;
    }
    _printComment(comment, skipNewLines) {
      const noLineTerminator = this._noLineTerminator;
      const isBlockComment = comment.type === "CommentBlock";
      const printNewLines = isBlockComment && skipNewLines !== 1 && !this._noLineTerminator;
      if (printNewLines && this._buf.hasContent() && skipNewLines !== 2) {
        this.newline(1);
      }
      const lastCharCode = this.getLastChar();
      if (lastCharCode !== 91 && lastCharCode !== 123 && lastCharCode !== 40) {
        this.space();
      }
      let val2;
      if (isBlockComment) {
        val2 = `/*${comment.value}*/`;
        if (this.format.indent.adjustMultilineComment) {
          var _comment$loc;
          const offset = (_comment$loc = comment.loc) == null ? undefined : _comment$loc.start.column;
          if (offset) {
            const newlineRegex = new RegExp("\\n\\s{1," + offset + "}", "g");
            val2 = val2.replace(newlineRegex, "\n");
          }
          if (this.format.concise) {
            val2 = val2.replace(/\n(?!$)/g, `\n`);
          } else {
            let indentSize = this.format.retainLines ? 0 : this._buf.getCurrentColumn();
            if (this._shouldIndent(47) || this.format.retainLines) {
              indentSize += this._getIndent();
            }
            val2 = val2.replace(/\n(?!$)/g, `\n${" ".repeat(indentSize)}`);
          }
        }
      } else if (!noLineTerminator) {
        val2 = `//${comment.value}`;
      } else {
        val2 = `/*${comment.value}*/`;
      }
      if (this._endsWithDiv)
        this._space();
      this.source("start", comment.loc);
      this._append(val2, isBlockComment);
      if (!isBlockComment && !noLineTerminator) {
        this.newline(1, true);
      }
      if (printNewLines && skipNewLines !== 3) {
        this.newline(1);
      }
    }
    _printComments(type, comments, node, parent, lineOffset = 0) {
      const nodeLoc = node.loc;
      const len = comments.length;
      let hasLoc = !!nodeLoc;
      const nodeStartLine = hasLoc ? nodeLoc.start.line : 0;
      const nodeEndLine = hasLoc ? nodeLoc.end.line : 0;
      let lastLine = 0;
      let leadingCommentNewline = 0;
      const maybeNewline = this._noLineTerminator ? function() {
      } : this.newline.bind(this);
      for (let i = 0;i < len; i++) {
        const comment = comments[i];
        const shouldPrint = this._shouldPrintComment(comment);
        if (shouldPrint === 2) {
          hasLoc = false;
          break;
        }
        if (hasLoc && comment.loc && shouldPrint === 1) {
          const commentStartLine = comment.loc.start.line;
          const commentEndLine = comment.loc.end.line;
          if (type === 0) {
            let offset = 0;
            if (i === 0) {
              if (this._buf.hasContent() && (comment.type === "CommentLine" || commentStartLine !== commentEndLine)) {
                offset = leadingCommentNewline = 1;
              }
            } else {
              offset = commentStartLine - lastLine;
            }
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
            if (i + 1 === len) {
              maybeNewline(Math.max(nodeStartLine - lastLine, leadingCommentNewline));
              lastLine = nodeStartLine;
            }
          } else if (type === 1) {
            const offset = commentStartLine - (i === 0 ? nodeStartLine : lastLine);
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
            if (i + 1 === len) {
              maybeNewline(Math.min(1, nodeEndLine - lastLine));
              lastLine = nodeEndLine;
            }
          } else {
            const offset = commentStartLine - (i === 0 ? nodeEndLine - lineOffset : lastLine);
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
          }
        } else {
          hasLoc = false;
          if (shouldPrint !== 1) {
            continue;
          }
          if (len === 1) {
            const singleLine = comment.loc ? comment.loc.start.line === comment.loc.end.line : !HAS_NEWLINE.test(comment.value);
            const shouldSkipNewline = singleLine && !isStatement(node) && !isClassBody(parent) && !isTSInterfaceBody(parent) && !isTSEnumDeclaration(parent);
            if (type === 0) {
              this._printComment(comment, shouldSkipNewline && node.type !== "ObjectExpression" || singleLine && isFunction22(parent, {
                body: node
              }) ? 1 : 0);
            } else if (shouldSkipNewline && type === 2) {
              this._printComment(comment, 1);
            } else {
              this._printComment(comment, 0);
            }
          } else if (type === 1 && !(node.type === "ObjectExpression" && node.properties.length > 1) && node.type !== "ClassBody" && node.type !== "TSInterfaceBody") {
            this._printComment(comment, i === 0 ? 2 : i === len - 1 ? 3 : 0);
          } else {
            this._printComment(comment, 0);
          }
        }
      }
      if (type === 2 && hasLoc && lastLine) {
        this._lastCommentLine = lastLine;
      }
    }
  }
  Object.assign(Printer.prototype, generatorFunctions);
  {
    Printer.prototype.Noop = function Noop() {
    };
  }
  var _default = exports.default = Printer;
  function commaSeparator() {
    this.tokenChar(44);
    this.space();
  }
});
var require_lib7 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = generate;
  var _sourceMap = require_source_map();
  var _printer = require_printer();
  function normalizeOptions(code, opts) {
    const format = {
      auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
      auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
      shouldPrintComment: opts.shouldPrintComment,
      retainLines: opts.retainLines,
      retainFunctionParens: opts.retainFunctionParens,
      comments: opts.comments == null || opts.comments,
      compact: opts.compact,
      minified: opts.minified,
      concise: opts.concise,
      indent: {
        adjustMultilineComment: true,
        style: "  "
      },
      jsescOption: Object.assign({
        quotes: "double",
        wrap: true,
        minimal: false
      }, opts.jsescOption),
      topicToken: opts.topicToken,
      importAttributesKeyword: opts.importAttributesKeyword
    };
    {
      var _opts$recordAndTupleS;
      format.decoratorsBeforeExport = opts.decoratorsBeforeExport;
      format.jsescOption.json = opts.jsonCompatibleStrings;
      format.recordAndTupleSyntaxType = (_opts$recordAndTupleS = opts.recordAndTupleSyntaxType) != null ? _opts$recordAndTupleS : "hash";
    }
    if (format.minified) {
      format.compact = true;
      format.shouldPrintComment = format.shouldPrintComment || (() => format.comments);
    } else {
      format.shouldPrintComment = format.shouldPrintComment || ((value) => format.comments || value.includes("@license") || value.includes("@preserve"));
    }
    if (format.compact === "auto") {
      format.compact = typeof code === "string" && code.length > 500000;
      if (format.compact) {
        console.error(`[BABEL] Note: The code generator has deoptimised the styling of ${opts.filename} as it exceeds the max of 500KB.`);
      }
    }
    if (format.compact) {
      format.indent.adjustMultilineComment = false;
    }
    const {
      auxiliaryCommentBefore,
      auxiliaryCommentAfter,
      shouldPrintComment
    } = format;
    if (auxiliaryCommentBefore && !shouldPrintComment(auxiliaryCommentBefore)) {
      format.auxiliaryCommentBefore = undefined;
    }
    if (auxiliaryCommentAfter && !shouldPrintComment(auxiliaryCommentAfter)) {
      format.auxiliaryCommentAfter = undefined;
    }
    return format;
  }
  {
    exports.CodeGenerator = class CodeGenerator {
      constructor(ast, opts = {}, code) {
        this._ast = undefined;
        this._format = undefined;
        this._map = undefined;
        this._ast = ast;
        this._format = normalizeOptions(code, opts);
        this._map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
      }
      generate() {
        const printer = new _printer.default(this._format, this._map);
        return printer.generate(this._ast);
      }
    };
  }
  function generate(ast, opts = {}, code) {
    const format = normalizeOptions(code, opts);
    const map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
    const printer = new _printer.default(format, map);
    return printer.generate(ast);
  }
});
var require_ancestry = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.find = find;
  exports.findParent = findParent;
  exports.getAncestry = getAncestry;
  exports.getDeepestCommonAncestorFrom = getDeepestCommonAncestorFrom;
  exports.getEarliestCommonAncestorFrom = getEarliestCommonAncestorFrom;
  exports.getFunctionParent = getFunctionParent;
  exports.getStatementParent = getStatementParent;
  exports.inType = inType;
  exports.isAncestor = isAncestor;
  exports.isDescendant = isDescendant;
  var _t = require_lib6();
  var {
    VISITOR_KEYS
  } = _t;
  function findParent(callback) {
    let path3 = this;
    while (path3 = path3.parentPath) {
      if (callback(path3))
        return path3;
    }
    return null;
  }
  function find(callback) {
    let path3 = this;
    do {
      if (callback(path3))
        return path3;
    } while (path3 = path3.parentPath);
    return null;
  }
  function getFunctionParent() {
    return this.findParent((p32) => p32.isFunction());
  }
  function getStatementParent() {
    let path3 = this;
    do {
      if (!path3.parentPath || Array.isArray(path3.container) && path3.isStatement()) {
        break;
      } else {
        path3 = path3.parentPath;
      }
    } while (path3);
    if (path3 && (path3.isProgram() || path3.isFile())) {
      throw new Error("File/Program node, we can't possibly find a statement parent to this");
    }
    return path3;
  }
  function getEarliestCommonAncestorFrom(paths) {
    return this.getDeepestCommonAncestorFrom(paths, function(deepest, i, ancestries) {
      let earliest;
      const keys = VISITOR_KEYS[deepest.type];
      for (const ancestry of ancestries) {
        const path3 = ancestry[i + 1];
        if (!earliest) {
          earliest = path3;
          continue;
        }
        if (path3.listKey && earliest.listKey === path3.listKey) {
          if (path3.key < earliest.key) {
            earliest = path3;
            continue;
          }
        }
        const earliestKeyIndex = keys.indexOf(earliest.parentKey);
        const currentKeyIndex = keys.indexOf(path3.parentKey);
        if (earliestKeyIndex > currentKeyIndex) {
          earliest = path3;
        }
      }
      return earliest;
    });
  }
  function getDeepestCommonAncestorFrom(paths, filter) {
    if (!paths.length) {
      return this;
    }
    if (paths.length === 1) {
      return paths[0];
    }
    let minDepth = Infinity;
    let lastCommonIndex, lastCommon;
    const ancestries = paths.map((path3) => {
      const ancestry = [];
      do {
        ancestry.unshift(path3);
      } while ((path3 = path3.parentPath) && path3 !== this);
      if (ancestry.length < minDepth) {
        minDepth = ancestry.length;
      }
      return ancestry;
    });
    const first = ancestries[0];
    depthLoop:
      for (let i = 0;i < minDepth; i++) {
        const shouldMatch = first[i];
        for (const ancestry of ancestries) {
          if (ancestry[i] !== shouldMatch) {
            break depthLoop;
          }
        }
        lastCommonIndex = i;
        lastCommon = shouldMatch;
      }
    if (lastCommon) {
      if (filter) {
        return filter(lastCommon, lastCommonIndex, ancestries);
      } else {
        return lastCommon;
      }
    } else {
      throw new Error("Couldn't find intersection");
    }
  }
  function getAncestry() {
    let path3 = this;
    const paths = [];
    do {
      paths.push(path3);
    } while (path3 = path3.parentPath);
    return paths;
  }
  function isAncestor(maybeDescendant) {
    return maybeDescendant.isDescendant(this);
  }
  function isDescendant(maybeAncestor) {
    return !!this.findParent((parent) => parent === maybeAncestor);
  }
  function inType(...candidateTypes) {
    let path3 = this;
    while (path3) {
      for (const type of candidateTypes) {
        if (path3.node.type === type)
          return true;
      }
      path3 = path3.parentPath;
    }
    return false;
  }
});
var require_util32 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.createUnionType = createUnionType;
  var _t = require_lib6();
  var {
    createFlowUnionType,
    createTSUnionType,
    createUnionTypeAnnotation,
    isFlowType,
    isTSType
  } = _t;
  function createUnionType(types3) {
    {
      if (types3.every((v22) => isFlowType(v22))) {
        if (createFlowUnionType) {
          return createFlowUnionType(types3);
        }
        return createUnionTypeAnnotation(types3);
      } else if (types3.every((v22) => isTSType(v22))) {
        if (createTSUnionType) {
          return createTSUnionType(types3);
        }
      }
    }
  }
});
var require_inferer_reference = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = _default;
  var _t = require_lib6();
  var _util = require_util32();
  var {
    BOOLEAN_NUMBER_BINARY_OPERATORS,
    createTypeAnnotationBasedOnTypeof,
    numberTypeAnnotation,
    voidTypeAnnotation
  } = _t;
  function _default(node) {
    if (!this.isReferenced())
      return;
    const binding = this.scope.getBinding(node.name);
    if (binding) {
      if (binding.identifier.typeAnnotation) {
        return binding.identifier.typeAnnotation;
      } else {
        return getTypeAnnotationBindingConstantViolations(binding, this, node.name);
      }
    }
    if (node.name === "undefined") {
      return voidTypeAnnotation();
    } else if (node.name === "NaN" || node.name === "Infinity") {
      return numberTypeAnnotation();
    } else if (node.name === "arguments") {
    }
  }
  function getTypeAnnotationBindingConstantViolations(binding, path3, name) {
    const types3 = [];
    const functionConstantViolations = [];
    let constantViolations = getConstantViolationsBefore(binding, path3, functionConstantViolations);
    const testType = getConditionalAnnotation(binding, path3, name);
    if (testType) {
      const testConstantViolations = getConstantViolationsBefore(binding, testType.ifStatement);
      constantViolations = constantViolations.filter((path42) => !testConstantViolations.includes(path42));
      types3.push(testType.typeAnnotation);
    }
    if (constantViolations.length) {
      constantViolations.push(...functionConstantViolations);
      for (const violation of constantViolations) {
        types3.push(violation.getTypeAnnotation());
      }
    }
    if (!types3.length) {
      return;
    }
    return (0, _util.createUnionType)(types3);
  }
  function getConstantViolationsBefore(binding, path3, functions) {
    const violations = binding.constantViolations.slice();
    violations.unshift(binding.path);
    return violations.filter((violation) => {
      violation = violation.resolve();
      const status = violation._guessExecutionStatusRelativeTo(path3);
      if (functions && status === "unknown")
        functions.push(violation);
      return status === "before";
    });
  }
  function inferAnnotationFromBinaryExpression(name, path3) {
    const operator = path3.node.operator;
    const right = path3.get("right").resolve();
    const left = path3.get("left").resolve();
    let target;
    if (left.isIdentifier({
      name
    })) {
      target = right;
    } else if (right.isIdentifier({
      name
    })) {
      target = left;
    }
    if (target) {
      if (operator === "===") {
        return target.getTypeAnnotation();
      }
      if (BOOLEAN_NUMBER_BINARY_OPERATORS.includes(operator)) {
        return numberTypeAnnotation();
      }
      return;
    }
    if (operator !== "===" && operator !== "==")
      return;
    let typeofPath;
    let typePath;
    if (left.isUnaryExpression({
      operator: "typeof"
    })) {
      typeofPath = left;
      typePath = right;
    } else if (right.isUnaryExpression({
      operator: "typeof"
    })) {
      typeofPath = right;
      typePath = left;
    }
    if (!typeofPath)
      return;
    if (!typeofPath.get("argument").isIdentifier({
      name
    }))
      return;
    typePath = typePath.resolve();
    if (!typePath.isLiteral())
      return;
    const typeValue = typePath.node.value;
    if (typeof typeValue !== "string")
      return;
    return createTypeAnnotationBasedOnTypeof(typeValue);
  }
  function getParentConditionalPath(binding, path3, name) {
    let parentPath;
    while (parentPath = path3.parentPath) {
      if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
        if (path3.key === "test") {
          return;
        }
        return parentPath;
      }
      if (parentPath.isFunction()) {
        if (parentPath.parentPath.scope.getBinding(name) !== binding)
          return;
      }
      path3 = parentPath;
    }
  }
  function getConditionalAnnotation(binding, path3, name) {
    const ifStatement = getParentConditionalPath(binding, path3, name);
    if (!ifStatement)
      return;
    const test = ifStatement.get("test");
    const paths = [test];
    const types3 = [];
    for (let i = 0;i < paths.length; i++) {
      const path42 = paths[i];
      if (path42.isLogicalExpression()) {
        if (path42.node.operator === "&&") {
          paths.push(path42.get("left"));
          paths.push(path42.get("right"));
        }
      } else if (path42.isBinaryExpression()) {
        const type = inferAnnotationFromBinaryExpression(name, path42);
        if (type)
          types3.push(type);
      }
    }
    if (types3.length) {
      return {
        typeAnnotation: (0, _util.createUnionType)(types3),
        ifStatement
      };
    }
    return getConditionalAnnotation(binding, ifStatement, name);
  }
});
var require_inferers = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ArrayExpression = ArrayExpression;
  exports.AssignmentExpression = AssignmentExpression;
  exports.BinaryExpression = BinaryExpression;
  exports.BooleanLiteral = BooleanLiteral;
  exports.CallExpression = CallExpression;
  exports.ConditionalExpression = ConditionalExpression;
  exports.ClassDeclaration = exports.ClassExpression = exports.FunctionDeclaration = exports.ArrowFunctionExpression = exports.FunctionExpression = Func;
  Object.defineProperty(exports, "Identifier", {
    enumerable: true,
    get: function() {
      return _infererReference.default;
    }
  });
  exports.LogicalExpression = LogicalExpression;
  exports.NewExpression = NewExpression;
  exports.NullLiteral = NullLiteral;
  exports.NumericLiteral = NumericLiteral;
  exports.ObjectExpression = ObjectExpression;
  exports.ParenthesizedExpression = ParenthesizedExpression;
  exports.RegExpLiteral = RegExpLiteral;
  exports.RestElement = RestElement;
  exports.SequenceExpression = SequenceExpression;
  exports.StringLiteral = StringLiteral;
  exports.TSAsExpression = TSAsExpression;
  exports.TSNonNullExpression = TSNonNullExpression;
  exports.TaggedTemplateExpression = TaggedTemplateExpression;
  exports.TemplateLiteral = TemplateLiteral;
  exports.TypeCastExpression = TypeCastExpression;
  exports.UnaryExpression = UnaryExpression;
  exports.UpdateExpression = UpdateExpression;
  exports.VariableDeclarator = VariableDeclarator;
  var _t = require_lib6();
  var _infererReference = require_inferer_reference();
  var _util = require_util32();
  var {
    BOOLEAN_BINARY_OPERATORS,
    BOOLEAN_UNARY_OPERATORS,
    NUMBER_BINARY_OPERATORS,
    NUMBER_UNARY_OPERATORS,
    STRING_UNARY_OPERATORS,
    anyTypeAnnotation,
    arrayTypeAnnotation,
    booleanTypeAnnotation,
    buildMatchMemberExpression,
    genericTypeAnnotation,
    identifier,
    nullLiteralTypeAnnotation,
    numberTypeAnnotation,
    stringTypeAnnotation,
    tupleTypeAnnotation,
    unionTypeAnnotation,
    voidTypeAnnotation,
    isIdentifier
  } = _t;
  function VariableDeclarator() {
    if (!this.get("id").isIdentifier())
      return;
    return this.get("init").getTypeAnnotation();
  }
  function TypeCastExpression(node) {
    return node.typeAnnotation;
  }
  TypeCastExpression.validParent = true;
  function TSAsExpression(node) {
    return node.typeAnnotation;
  }
  TSAsExpression.validParent = true;
  function TSNonNullExpression() {
    return this.get("expression").getTypeAnnotation();
  }
  function NewExpression(node) {
    if (node.callee.type === "Identifier") {
      return genericTypeAnnotation(node.callee);
    }
  }
  function TemplateLiteral() {
    return stringTypeAnnotation();
  }
  function UnaryExpression(node) {
    const operator = node.operator;
    if (operator === "void") {
      return voidTypeAnnotation();
    } else if (NUMBER_UNARY_OPERATORS.includes(operator)) {
      return numberTypeAnnotation();
    } else if (STRING_UNARY_OPERATORS.includes(operator)) {
      return stringTypeAnnotation();
    } else if (BOOLEAN_UNARY_OPERATORS.includes(operator)) {
      return booleanTypeAnnotation();
    }
  }
  function BinaryExpression(node) {
    const operator = node.operator;
    if (NUMBER_BINARY_OPERATORS.includes(operator)) {
      return numberTypeAnnotation();
    } else if (BOOLEAN_BINARY_OPERATORS.includes(operator)) {
      return booleanTypeAnnotation();
    } else if (operator === "+") {
      const right = this.get("right");
      const left = this.get("left");
      if (left.isBaseType("number") && right.isBaseType("number")) {
        return numberTypeAnnotation();
      } else if (left.isBaseType("string") || right.isBaseType("string")) {
        return stringTypeAnnotation();
      }
      return unionTypeAnnotation([stringTypeAnnotation(), numberTypeAnnotation()]);
    }
  }
  function LogicalExpression() {
    const argumentTypes = [this.get("left").getTypeAnnotation(), this.get("right").getTypeAnnotation()];
    return (0, _util.createUnionType)(argumentTypes);
  }
  function ConditionalExpression() {
    const argumentTypes = [this.get("consequent").getTypeAnnotation(), this.get("alternate").getTypeAnnotation()];
    return (0, _util.createUnionType)(argumentTypes);
  }
  function SequenceExpression() {
    return this.get("expressions").pop().getTypeAnnotation();
  }
  function ParenthesizedExpression() {
    return this.get("expression").getTypeAnnotation();
  }
  function AssignmentExpression() {
    return this.get("right").getTypeAnnotation();
  }
  function UpdateExpression(node) {
    const operator = node.operator;
    if (operator === "++" || operator === "--") {
      return numberTypeAnnotation();
    }
  }
  function StringLiteral() {
    return stringTypeAnnotation();
  }
  function NumericLiteral() {
    return numberTypeAnnotation();
  }
  function BooleanLiteral() {
    return booleanTypeAnnotation();
  }
  function NullLiteral() {
    return nullLiteralTypeAnnotation();
  }
  function RegExpLiteral() {
    return genericTypeAnnotation(identifier("RegExp"));
  }
  function ObjectExpression() {
    return genericTypeAnnotation(identifier("Object"));
  }
  function ArrayExpression() {
    return genericTypeAnnotation(identifier("Array"));
  }
  function RestElement() {
    return ArrayExpression();
  }
  RestElement.validParent = true;
  function Func() {
    return genericTypeAnnotation(identifier("Function"));
  }
  var isArrayFrom = buildMatchMemberExpression("Array.from");
  var isObjectKeys = buildMatchMemberExpression("Object.keys");
  var isObjectValues = buildMatchMemberExpression("Object.values");
  var isObjectEntries = buildMatchMemberExpression("Object.entries");
  function CallExpression() {
    const {
      callee
    } = this.node;
    if (isObjectKeys(callee)) {
      return arrayTypeAnnotation(stringTypeAnnotation());
    } else if (isArrayFrom(callee) || isObjectValues(callee) || isIdentifier(callee, {
      name: "Array"
    })) {
      return arrayTypeAnnotation(anyTypeAnnotation());
    } else if (isObjectEntries(callee)) {
      return arrayTypeAnnotation(tupleTypeAnnotation([stringTypeAnnotation(), anyTypeAnnotation()]));
    }
    return resolveCall(this.get("callee"));
  }
  function TaggedTemplateExpression() {
    return resolveCall(this.get("tag"));
  }
  function resolveCall(callee) {
    callee = callee.resolve();
    if (callee.isFunction()) {
      const {
        node
      } = callee;
      if (node.async) {
        if (node.generator) {
          return genericTypeAnnotation(identifier("AsyncIterator"));
        } else {
          return genericTypeAnnotation(identifier("Promise"));
        }
      } else {
        if (node.generator) {
          return genericTypeAnnotation(identifier("Iterator"));
        } else if (callee.node.returnType) {
          return callee.node.returnType;
        } else {
        }
      }
    }
  }
});
var require_inference = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports._getTypeAnnotation = _getTypeAnnotation;
  exports.baseTypeStrictlyMatches = baseTypeStrictlyMatches;
  exports.couldBeBaseType = couldBeBaseType;
  exports.getTypeAnnotation = getTypeAnnotation;
  exports.isBaseType = isBaseType;
  exports.isGenericType = isGenericType;
  var inferers = require_inferers();
  var _t = require_lib6();
  var {
    anyTypeAnnotation,
    isAnyTypeAnnotation,
    isArrayTypeAnnotation,
    isBooleanTypeAnnotation,
    isEmptyTypeAnnotation,
    isFlowBaseAnnotation,
    isGenericTypeAnnotation,
    isIdentifier,
    isMixedTypeAnnotation,
    isNumberTypeAnnotation,
    isStringTypeAnnotation,
    isTSArrayType,
    isTSTypeAnnotation,
    isTSTypeReference,
    isTupleTypeAnnotation,
    isTypeAnnotation,
    isUnionTypeAnnotation,
    isVoidTypeAnnotation,
    stringTypeAnnotation,
    voidTypeAnnotation
  } = _t;
  function getTypeAnnotation() {
    let type = this.getData("typeAnnotation");
    if (type != null) {
      return type;
    }
    type = _getTypeAnnotation.call(this) || anyTypeAnnotation();
    if (isTypeAnnotation(type) || isTSTypeAnnotation(type)) {
      type = type.typeAnnotation;
    }
    this.setData("typeAnnotation", type);
    return type;
  }
  var typeAnnotationInferringNodes = new WeakSet;
  function _getTypeAnnotation() {
    const node = this.node;
    if (!node) {
      if (this.key === "init" && this.parentPath.isVariableDeclarator()) {
        const declar = this.parentPath.parentPath;
        const declarParent = declar.parentPath;
        if (declar.key === "left" && declarParent.isForInStatement()) {
          return stringTypeAnnotation();
        }
        if (declar.key === "left" && declarParent.isForOfStatement()) {
          return anyTypeAnnotation();
        }
        return voidTypeAnnotation();
      } else {
        return;
      }
    }
    if (node.typeAnnotation) {
      return node.typeAnnotation;
    }
    if (typeAnnotationInferringNodes.has(node)) {
      return;
    }
    typeAnnotationInferringNodes.add(node);
    try {
      var _inferer;
      let inferer = inferers[node.type];
      if (inferer) {
        return inferer.call(this, node);
      }
      inferer = inferers[this.parentPath.type];
      if ((_inferer = inferer) != null && _inferer.validParent) {
        return this.parentPath.getTypeAnnotation();
      }
    } finally {
      typeAnnotationInferringNodes.delete(node);
    }
  }
  function isBaseType(baseName, soft) {
    return _isBaseType(baseName, this.getTypeAnnotation(), soft);
  }
  function _isBaseType(baseName, type, soft) {
    if (baseName === "string") {
      return isStringTypeAnnotation(type);
    } else if (baseName === "number") {
      return isNumberTypeAnnotation(type);
    } else if (baseName === "boolean") {
      return isBooleanTypeAnnotation(type);
    } else if (baseName === "any") {
      return isAnyTypeAnnotation(type);
    } else if (baseName === "mixed") {
      return isMixedTypeAnnotation(type);
    } else if (baseName === "empty") {
      return isEmptyTypeAnnotation(type);
    } else if (baseName === "void") {
      return isVoidTypeAnnotation(type);
    } else {
      if (soft) {
        return false;
      } else {
        throw new Error(`Unknown base type ${baseName}`);
      }
    }
  }
  function couldBeBaseType(name) {
    const type = this.getTypeAnnotation();
    if (isAnyTypeAnnotation(type))
      return true;
    if (isUnionTypeAnnotation(type)) {
      for (const type2 of type.types) {
        if (isAnyTypeAnnotation(type2) || _isBaseType(name, type2, true)) {
          return true;
        }
      }
      return false;
    } else {
      return _isBaseType(name, type, true);
    }
  }
  function baseTypeStrictlyMatches(rightArg) {
    const left = this.getTypeAnnotation();
    const right = rightArg.getTypeAnnotation();
    if (!isAnyTypeAnnotation(left) && isFlowBaseAnnotation(left)) {
      return right.type === left.type;
    }
    return false;
  }
  function isGenericType(genericName) {
    const type = this.getTypeAnnotation();
    if (genericName === "Array") {
      if (isTSArrayType(type) || isArrayTypeAnnotation(type) || isTupleTypeAnnotation(type)) {
        return true;
      }
    }
    return isGenericTypeAnnotation(type) && isIdentifier(type.id, {
      name: genericName
    }) || isTSTypeReference(type) && isIdentifier(type.typeName, {
      name: genericName
    });
  }
});
var require_js_tokens = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
  exports.matchToToken = function(match) {
    var token = { type: "invalid", value: match[0], closed: undefined };
    if (match[1])
      token.type = "string", token.closed = !!(match[3] || match[4]);
    else if (match[5])
      token.type = "comment";
    else if (match[6])
      token.type = "comment", token.closed = !!match[7];
    else if (match[8])
      token.type = "regex";
    else if (match[9])
      token.type = "number";
    else if (match[10])
      token.type = "name";
    else if (match[11])
      token.type = "punctuator";
    else if (match[12])
      token.type = "whitespace";
    return token;
  };
});
var require_picocolors = __commonJS2((exports, module) => {
  var p32 = process || {};
  var argv22 = p32.argv || [];
  var env5 = p32.env || {};
  var isColorSupported32 = !(!!env5.NO_COLOR || argv22.includes("--no-color")) && (!!env5.FORCE_COLOR || argv22.includes("--color") || p32.platform === "win32" || (p32.stdout || {}).isTTY && env5.TERM !== "dumb" || !!env5.CI);
  var formatter22 = (open, close, replace22 = open) => (input) => {
    let string2 = "" + input, index = string2.indexOf(close, open.length);
    return ~index ? open + replaceClose32(string2, close, replace22, index) + close : open + string2 + close;
  };
  var replaceClose32 = (string2, close, replace22, index) => {
    let result2 = "", cursor22 = 0;
    do {
      result2 += string2.substring(cursor22, index) + replace22;
      cursor22 = index + close.length;
      index = string2.indexOf(close, cursor22);
    } while (~index);
    return result2 + string2.substring(cursor22);
  };
  var createColors32 = (enabled22 = isColorSupported32) => {
    let f22 = enabled22 ? formatter22 : () => String;
    return {
      isColorSupported: enabled22,
      reset: f22("\x1B[0m", "\x1B[0m"),
      bold: f22("\x1B[1m", "\x1B[22m", "\x1B[22m\x1B[1m"),
      dim: f22("\x1B[2m", "\x1B[22m", "\x1B[22m\x1B[2m"),
      italic: f22("\x1B[3m", "\x1B[23m"),
      underline: f22("\x1B[4m", "\x1B[24m"),
      inverse: f22("\x1B[7m", "\x1B[27m"),
      hidden: f22("\x1B[8m", "\x1B[28m"),
      strikethrough: f22("\x1B[9m", "\x1B[29m"),
      black: f22("\x1B[30m", "\x1B[39m"),
      red: f22("\x1B[31m", "\x1B[39m"),
      green: f22("\x1B[32m", "\x1B[39m"),
      yellow: f22("\x1B[33m", "\x1B[39m"),
      blue: f22("\x1B[34m", "\x1B[39m"),
      magenta: f22("\x1B[35m", "\x1B[39m"),
      cyan: f22("\x1B[36m", "\x1B[39m"),
      white: f22("\x1B[37m", "\x1B[39m"),
      gray: f22("\x1B[90m", "\x1B[39m"),
      bgBlack: f22("\x1B[40m", "\x1B[49m"),
      bgRed: f22("\x1B[41m", "\x1B[49m"),
      bgGreen: f22("\x1B[42m", "\x1B[49m"),
      bgYellow: f22("\x1B[43m", "\x1B[49m"),
      bgBlue: f22("\x1B[44m", "\x1B[49m"),
      bgMagenta: f22("\x1B[45m", "\x1B[49m"),
      bgCyan: f22("\x1B[46m", "\x1B[49m"),
      bgWhite: f22("\x1B[47m", "\x1B[49m"),
      blackBright: f22("\x1B[90m", "\x1B[39m"),
      redBright: f22("\x1B[91m", "\x1B[39m"),
      greenBright: f22("\x1B[92m", "\x1B[39m"),
      yellowBright: f22("\x1B[93m", "\x1B[39m"),
      blueBright: f22("\x1B[94m", "\x1B[39m"),
      magentaBright: f22("\x1B[95m", "\x1B[39m"),
      cyanBright: f22("\x1B[96m", "\x1B[39m"),
      whiteBright: f22("\x1B[97m", "\x1B[39m"),
      bgBlackBright: f22("\x1B[100m", "\x1B[49m"),
      bgRedBright: f22("\x1B[101m", "\x1B[49m"),
      bgGreenBright: f22("\x1B[102m", "\x1B[49m"),
      bgYellowBright: f22("\x1B[103m", "\x1B[49m"),
      bgBlueBright: f22("\x1B[104m", "\x1B[49m"),
      bgMagentaBright: f22("\x1B[105m", "\x1B[49m"),
      bgCyanBright: f22("\x1B[106m", "\x1B[49m"),
      bgWhiteBright: f22("\x1B[107m", "\x1B[49m")
    };
  };
  module.exports = createColors32();
  module.exports.createColors = createColors32;
});
var require_escape_string_regexp = __commonJS2((exports, module) => {
  var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
  module.exports = function(str) {
    if (typeof str !== "string") {
      throw new TypeError("Expected a string");
    }
    return str.replace(matchOperatorsRe, "\\$&");
  };
});
var require_color_name = __commonJS2((exports, module) => {
  module.exports = {
    aliceblue: [240, 248, 255],
    antiquewhite: [250, 235, 215],
    aqua: [0, 255, 255],
    aquamarine: [127, 255, 212],
    azure: [240, 255, 255],
    beige: [245, 245, 220],
    bisque: [255, 228, 196],
    black: [0, 0, 0],
    blanchedalmond: [255, 235, 205],
    blue: [0, 0, 255],
    blueviolet: [138, 43, 226],
    brown: [165, 42, 42],
    burlywood: [222, 184, 135],
    cadetblue: [95, 158, 160],
    chartreuse: [127, 255, 0],
    chocolate: [210, 105, 30],
    coral: [255, 127, 80],
    cornflowerblue: [100, 149, 237],
    cornsilk: [255, 248, 220],
    crimson: [220, 20, 60],
    cyan: [0, 255, 255],
    darkblue: [0, 0, 139],
    darkcyan: [0, 139, 139],
    darkgoldenrod: [184, 134, 11],
    darkgray: [169, 169, 169],
    darkgreen: [0, 100, 0],
    darkgrey: [169, 169, 169],
    darkkhaki: [189, 183, 107],
    darkmagenta: [139, 0, 139],
    darkolivegreen: [85, 107, 47],
    darkorange: [255, 140, 0],
    darkorchid: [153, 50, 204],
    darkred: [139, 0, 0],
    darksalmon: [233, 150, 122],
    darkseagreen: [143, 188, 143],
    darkslateblue: [72, 61, 139],
    darkslategray: [47, 79, 79],
    darkslategrey: [47, 79, 79],
    darkturquoise: [0, 206, 209],
    darkviolet: [148, 0, 211],
    deeppink: [255, 20, 147],
    deepskyblue: [0, 191, 255],
    dimgray: [105, 105, 105],
    dimgrey: [105, 105, 105],
    dodgerblue: [30, 144, 255],
    firebrick: [178, 34, 34],
    floralwhite: [255, 250, 240],
    forestgreen: [34, 139, 34],
    fuchsia: [255, 0, 255],
    gainsboro: [220, 220, 220],
    ghostwhite: [248, 248, 255],
    gold: [255, 215, 0],
    goldenrod: [218, 165, 32],
    gray: [128, 128, 128],
    green: [0, 128, 0],
    greenyellow: [173, 255, 47],
    grey: [128, 128, 128],
    honeydew: [240, 255, 240],
    hotpink: [255, 105, 180],
    indianred: [205, 92, 92],
    indigo: [75, 0, 130],
    ivory: [255, 255, 240],
    khaki: [240, 230, 140],
    lavender: [230, 230, 250],
    lavenderblush: [255, 240, 245],
    lawngreen: [124, 252, 0],
    lemonchiffon: [255, 250, 205],
    lightblue: [173, 216, 230],
    lightcoral: [240, 128, 128],
    lightcyan: [224, 255, 255],
    lightgoldenrodyellow: [250, 250, 210],
    lightgray: [211, 211, 211],
    lightgreen: [144, 238, 144],
    lightgrey: [211, 211, 211],
    lightpink: [255, 182, 193],
    lightsalmon: [255, 160, 122],
    lightseagreen: [32, 178, 170],
    lightskyblue: [135, 206, 250],
    lightslategray: [119, 136, 153],
    lightslategrey: [119, 136, 153],
    lightsteelblue: [176, 196, 222],
    lightyellow: [255, 255, 224],
    lime: [0, 255, 0],
    limegreen: [50, 205, 50],
    linen: [250, 240, 230],
    magenta: [255, 0, 255],
    maroon: [128, 0, 0],
    mediumaquamarine: [102, 205, 170],
    mediumblue: [0, 0, 205],
    mediumorchid: [186, 85, 211],
    mediumpurple: [147, 112, 219],
    mediumseagreen: [60, 179, 113],
    mediumslateblue: [123, 104, 238],
    mediumspringgreen: [0, 250, 154],
    mediumturquoise: [72, 209, 204],
    mediumvioletred: [199, 21, 133],
    midnightblue: [25, 25, 112],
    mintcream: [245, 255, 250],
    mistyrose: [255, 228, 225],
    moccasin: [255, 228, 181],
    navajowhite: [255, 222, 173],
    navy: [0, 0, 128],
    oldlace: [253, 245, 230],
    olive: [128, 128, 0],
    olivedrab: [107, 142, 35],
    orange: [255, 165, 0],
    orangered: [255, 69, 0],
    orchid: [218, 112, 214],
    palegoldenrod: [238, 232, 170],
    palegreen: [152, 251, 152],
    paleturquoise: [175, 238, 238],
    palevioletred: [219, 112, 147],
    papayawhip: [255, 239, 213],
    peachpuff: [255, 218, 185],
    peru: [205, 133, 63],
    pink: [255, 192, 203],
    plum: [221, 160, 221],
    powderblue: [176, 224, 230],
    purple: [128, 0, 128],
    rebeccapurple: [102, 51, 153],
    red: [255, 0, 0],
    rosybrown: [188, 143, 143],
    royalblue: [65, 105, 225],
    saddlebrown: [139, 69, 19],
    salmon: [250, 128, 114],
    sandybrown: [244, 164, 96],
    seagreen: [46, 139, 87],
    seashell: [255, 245, 238],
    sienna: [160, 82, 45],
    silver: [192, 192, 192],
    skyblue: [135, 206, 235],
    slateblue: [106, 90, 205],
    slategray: [112, 128, 144],
    slategrey: [112, 128, 144],
    snow: [255, 250, 250],
    springgreen: [0, 255, 127],
    steelblue: [70, 130, 180],
    tan: [210, 180, 140],
    teal: [0, 128, 128],
    thistle: [216, 191, 216],
    tomato: [255, 99, 71],
    turquoise: [64, 224, 208],
    violet: [238, 130, 238],
    wheat: [245, 222, 179],
    white: [255, 255, 255],
    whitesmoke: [245, 245, 245],
    yellow: [255, 255, 0],
    yellowgreen: [154, 205, 50]
  };
});
var require_conversions = __commonJS2((exports, module) => {
  var cssKeywords = require_color_name();
  var reverseKeywords = {};
  for (key in cssKeywords) {
    if (cssKeywords.hasOwnProperty(key)) {
      reverseKeywords[cssKeywords[key]] = key;
    }
  }
  var key;
  var convert = module.exports = {
    rgb: { channels: 3, labels: "rgb" },
    hsl: { channels: 3, labels: "hsl" },
    hsv: { channels: 3, labels: "hsv" },
    hwb: { channels: 3, labels: "hwb" },
    cmyk: { channels: 4, labels: "cmyk" },
    xyz: { channels: 3, labels: "xyz" },
    lab: { channels: 3, labels: "lab" },
    lch: { channels: 3, labels: "lch" },
    hex: { channels: 1, labels: ["hex"] },
    keyword: { channels: 1, labels: ["keyword"] },
    ansi16: { channels: 1, labels: ["ansi16"] },
    ansi256: { channels: 1, labels: ["ansi256"] },
    hcg: { channels: 3, labels: ["h", "c", "g"] },
    apple: { channels: 3, labels: ["r16", "g16", "b16"] },
    gray: { channels: 1, labels: ["gray"] }
  };
  for (model2 in convert) {
    if (convert.hasOwnProperty(model2)) {
      if (!("channels" in convert[model2])) {
        throw new Error("missing channels property: " + model2);
      }
      if (!("labels" in convert[model2])) {
        throw new Error("missing channel labels property: " + model2);
      }
      if (convert[model2].labels.length !== convert[model2].channels) {
        throw new Error("channel and label counts mismatch: " + model2);
      }
      channels = convert[model2].channels;
      labels = convert[model2].labels;
      delete convert[model2].channels;
      delete convert[model2].labels;
      Object.defineProperty(convert[model2], "channels", { value: channels });
      Object.defineProperty(convert[model2], "labels", { value: labels });
    }
  }
  var channels;
  var labels;
  var model2;
  convert.rgb.hsl = function(rgb) {
    var r22 = rgb[0] / 255;
    var g22 = rgb[1] / 255;
    var b22 = rgb[2] / 255;
    var min = Math.min(r22, g22, b22);
    var max = Math.max(r22, g22, b22);
    var delta = max - min;
    var h22;
    var s32;
    var l22;
    if (max === min) {
      h22 = 0;
    } else if (r22 === max) {
      h22 = (g22 - b22) / delta;
    } else if (g22 === max) {
      h22 = 2 + (b22 - r22) / delta;
    } else if (b22 === max) {
      h22 = 4 + (r22 - g22) / delta;
    }
    h22 = Math.min(h22 * 60, 360);
    if (h22 < 0) {
      h22 += 360;
    }
    l22 = (min + max) / 2;
    if (max === min) {
      s32 = 0;
    } else if (l22 <= 0.5) {
      s32 = delta / (max + min);
    } else {
      s32 = delta / (2 - max - min);
    }
    return [h22, s32 * 100, l22 * 100];
  };
  convert.rgb.hsv = function(rgb) {
    var rdif;
    var gdif;
    var bdif;
    var h22;
    var s32;
    var r22 = rgb[0] / 255;
    var g22 = rgb[1] / 255;
    var b22 = rgb[2] / 255;
    var v22 = Math.max(r22, g22, b22);
    var diff = v22 - Math.min(r22, g22, b22);
    var diffc = function(c22) {
      return (v22 - c22) / 6 / diff + 0.5;
    };
    if (diff === 0) {
      h22 = s32 = 0;
    } else {
      s32 = diff / v22;
      rdif = diffc(r22);
      gdif = diffc(g22);
      bdif = diffc(b22);
      if (r22 === v22) {
        h22 = bdif - gdif;
      } else if (g22 === v22) {
        h22 = 0.3333333333333333 + rdif - bdif;
      } else if (b22 === v22) {
        h22 = 0.6666666666666666 + gdif - rdif;
      }
      if (h22 < 0) {
        h22 += 1;
      } else if (h22 > 1) {
        h22 -= 1;
      }
    }
    return [
      h22 * 360,
      s32 * 100,
      v22 * 100
    ];
  };
  convert.rgb.hwb = function(rgb) {
    var r22 = rgb[0];
    var g22 = rgb[1];
    var b22 = rgb[2];
    var h22 = convert.rgb.hsl(rgb)[0];
    var w22 = 0.00392156862745098 * Math.min(r22, Math.min(g22, b22));
    b22 = 1 - 0.00392156862745098 * Math.max(r22, Math.max(g22, b22));
    return [h22, w22 * 100, b22 * 100];
  };
  convert.rgb.cmyk = function(rgb) {
    var r22 = rgb[0] / 255;
    var g22 = rgb[1] / 255;
    var b22 = rgb[2] / 255;
    var c22;
    var m22;
    var y;
    var k;
    k = Math.min(1 - r22, 1 - g22, 1 - b22);
    c22 = (1 - r22 - k) / (1 - k) || 0;
    m22 = (1 - g22 - k) / (1 - k) || 0;
    y = (1 - b22 - k) / (1 - k) || 0;
    return [c22 * 100, m22 * 100, y * 100, k * 100];
  };
  function comparativeDistance(x, y) {
    return Math.pow(x[0] - y[0], 2) + Math.pow(x[1] - y[1], 2) + Math.pow(x[2] - y[2], 2);
  }
  convert.rgb.keyword = function(rgb) {
    var reversed = reverseKeywords[rgb];
    if (reversed) {
      return reversed;
    }
    var currentClosestDistance = Infinity;
    var currentClosestKeyword;
    for (var keyword in cssKeywords) {
      if (cssKeywords.hasOwnProperty(keyword)) {
        var value = cssKeywords[keyword];
        var distance = comparativeDistance(rgb, value);
        if (distance < currentClosestDistance) {
          currentClosestDistance = distance;
          currentClosestKeyword = keyword;
        }
      }
    }
    return currentClosestKeyword;
  };
  convert.keyword.rgb = function(keyword) {
    return cssKeywords[keyword];
  };
  convert.rgb.xyz = function(rgb) {
    var r22 = rgb[0] / 255;
    var g22 = rgb[1] / 255;
    var b22 = rgb[2] / 255;
    r22 = r22 > 0.04045 ? Math.pow((r22 + 0.055) / 1.055, 2.4) : r22 / 12.92;
    g22 = g22 > 0.04045 ? Math.pow((g22 + 0.055) / 1.055, 2.4) : g22 / 12.92;
    b22 = b22 > 0.04045 ? Math.pow((b22 + 0.055) / 1.055, 2.4) : b22 / 12.92;
    var x = r22 * 0.4124 + g22 * 0.3576 + b22 * 0.1805;
    var y = r22 * 0.2126 + g22 * 0.7152 + b22 * 0.0722;
    var z22 = r22 * 0.0193 + g22 * 0.1192 + b22 * 0.9505;
    return [x * 100, y * 100, z22 * 100];
  };
  convert.rgb.lab = function(rgb) {
    var xyz = convert.rgb.xyz(rgb);
    var x = xyz[0];
    var y = xyz[1];
    var z22 = xyz[2];
    var l22;
    var a;
    var b22;
    x /= 95.047;
    y /= 100;
    z22 /= 108.883;
    x = x > 0.008856 ? Math.pow(x, 0.3333333333333333) : 7.787 * x + 0.13793103448275862;
    y = y > 0.008856 ? Math.pow(y, 0.3333333333333333) : 7.787 * y + 0.13793103448275862;
    z22 = z22 > 0.008856 ? Math.pow(z22, 0.3333333333333333) : 7.787 * z22 + 0.13793103448275862;
    l22 = 116 * y - 16;
    a = 500 * (x - y);
    b22 = 200 * (y - z22);
    return [l22, a, b22];
  };
  convert.hsl.rgb = function(hsl) {
    var h22 = hsl[0] / 360;
    var s32 = hsl[1] / 100;
    var l22 = hsl[2] / 100;
    var t1;
    var t2;
    var t3;
    var rgb;
    var val2;
    if (s32 === 0) {
      val2 = l22 * 255;
      return [val2, val2, val2];
    }
    if (l22 < 0.5) {
      t2 = l22 * (1 + s32);
    } else {
      t2 = l22 + s32 - l22 * s32;
    }
    t1 = 2 * l22 - t2;
    rgb = [0, 0, 0];
    for (var i = 0;i < 3; i++) {
      t3 = h22 + 0.3333333333333333 * -(i - 1);
      if (t3 < 0) {
        t3++;
      }
      if (t3 > 1) {
        t3--;
      }
      if (6 * t3 < 1) {
        val2 = t1 + (t2 - t1) * 6 * t3;
      } else if (2 * t3 < 1) {
        val2 = t2;
      } else if (3 * t3 < 2) {
        val2 = t1 + (t2 - t1) * (0.6666666666666666 - t3) * 6;
      } else {
        val2 = t1;
      }
      rgb[i] = val2 * 255;
    }
    return rgb;
  };
  convert.hsl.hsv = function(hsl) {
    var h22 = hsl[0];
    var s32 = hsl[1] / 100;
    var l22 = hsl[2] / 100;
    var smin = s32;
    var lmin = Math.max(l22, 0.01);
    var sv;
    var v22;
    l22 *= 2;
    s32 *= l22 <= 1 ? l22 : 2 - l22;
    smin *= lmin <= 1 ? lmin : 2 - lmin;
    v22 = (l22 + s32) / 2;
    sv = l22 === 0 ? 2 * smin / (lmin + smin) : 2 * s32 / (l22 + s32);
    return [h22, sv * 100, v22 * 100];
  };
  convert.hsv.rgb = function(hsv) {
    var h22 = hsv[0] / 60;
    var s32 = hsv[1] / 100;
    var v22 = hsv[2] / 100;
    var hi = Math.floor(h22) % 6;
    var f22 = h22 - Math.floor(h22);
    var p32 = 255 * v22 * (1 - s32);
    var q22 = 255 * v22 * (1 - s32 * f22);
    var t = 255 * v22 * (1 - s32 * (1 - f22));
    v22 *= 255;
    switch (hi) {
      case 0:
        return [v22, t, p32];
      case 1:
        return [q22, v22, p32];
      case 2:
        return [p32, v22, t];
      case 3:
        return [p32, q22, v22];
      case 4:
        return [t, p32, v22];
      case 5:
        return [v22, p32, q22];
    }
  };
  convert.hsv.hsl = function(hsv) {
    var h22 = hsv[0];
    var s32 = hsv[1] / 100;
    var v22 = hsv[2] / 100;
    var vmin = Math.max(v22, 0.01);
    var lmin;
    var sl;
    var l22;
    l22 = (2 - s32) * v22;
    lmin = (2 - s32) * vmin;
    sl = s32 * vmin;
    sl /= lmin <= 1 ? lmin : 2 - lmin;
    sl = sl || 0;
    l22 /= 2;
    return [h22, sl * 100, l22 * 100];
  };
  convert.hwb.rgb = function(hwb) {
    var h22 = hwb[0] / 360;
    var wh = hwb[1] / 100;
    var bl = hwb[2] / 100;
    var ratio = wh + bl;
    var i;
    var v22;
    var f22;
    var n;
    if (ratio > 1) {
      wh /= ratio;
      bl /= ratio;
    }
    i = Math.floor(6 * h22);
    v22 = 1 - bl;
    f22 = 6 * h22 - i;
    if ((i & 1) !== 0) {
      f22 = 1 - f22;
    }
    n = wh + f22 * (v22 - wh);
    var r22;
    var g22;
    var b22;
    switch (i) {
      default:
      case 6:
      case 0:
        r22 = v22;
        g22 = n;
        b22 = wh;
        break;
      case 1:
        r22 = n;
        g22 = v22;
        b22 = wh;
        break;
      case 2:
        r22 = wh;
        g22 = v22;
        b22 = n;
        break;
      case 3:
        r22 = wh;
        g22 = n;
        b22 = v22;
        break;
      case 4:
        r22 = n;
        g22 = wh;
        b22 = v22;
        break;
      case 5:
        r22 = v22;
        g22 = wh;
        b22 = n;
        break;
    }
    return [r22 * 255, g22 * 255, b22 * 255];
  };
  convert.cmyk.rgb = function(cmyk) {
    var c22 = cmyk[0] / 100;
    var m22 = cmyk[1] / 100;
    var y = cmyk[2] / 100;
    var k = cmyk[3] / 100;
    var r22;
    var g22;
    var b22;
    r22 = 1 - Math.min(1, c22 * (1 - k) + k);
    g22 = 1 - Math.min(1, m22 * (1 - k) + k);
    b22 = 1 - Math.min(1, y * (1 - k) + k);
    return [r22 * 255, g22 * 255, b22 * 255];
  };
  convert.xyz.rgb = function(xyz) {
    var x = xyz[0] / 100;
    var y = xyz[1] / 100;
    var z22 = xyz[2] / 100;
    var r22;
    var g22;
    var b22;
    r22 = x * 3.2406 + y * -1.5372 + z22 * -0.4986;
    g22 = x * -0.9689 + y * 1.8758 + z22 * 0.0415;
    b22 = x * 0.0557 + y * -0.204 + z22 * 1.057;
    r22 = r22 > 0.0031308 ? 1.055 * Math.pow(r22, 0.4166666666666667) - 0.055 : r22 * 12.92;
    g22 = g22 > 0.0031308 ? 1.055 * Math.pow(g22, 0.4166666666666667) - 0.055 : g22 * 12.92;
    b22 = b22 > 0.0031308 ? 1.055 * Math.pow(b22, 0.4166666666666667) - 0.055 : b22 * 12.92;
    r22 = Math.min(Math.max(0, r22), 1);
    g22 = Math.min(Math.max(0, g22), 1);
    b22 = Math.min(Math.max(0, b22), 1);
    return [r22 * 255, g22 * 255, b22 * 255];
  };
  convert.xyz.lab = function(xyz) {
    var x = xyz[0];
    var y = xyz[1];
    var z22 = xyz[2];
    var l22;
    var a;
    var b22;
    x /= 95.047;
    y /= 100;
    z22 /= 108.883;
    x = x > 0.008856 ? Math.pow(x, 0.3333333333333333) : 7.787 * x + 0.13793103448275862;
    y = y > 0.008856 ? Math.pow(y, 0.3333333333333333) : 7.787 * y + 0.13793103448275862;
    z22 = z22 > 0.008856 ? Math.pow(z22, 0.3333333333333333) : 7.787 * z22 + 0.13793103448275862;
    l22 = 116 * y - 16;
    a = 500 * (x - y);
    b22 = 200 * (y - z22);
    return [l22, a, b22];
  };
  convert.lab.xyz = function(lab) {
    var l22 = lab[0];
    var a = lab[1];
    var b22 = lab[2];
    var x;
    var y;
    var z22;
    y = (l22 + 16) / 116;
    x = a / 500 + y;
    z22 = y - b22 / 200;
    var y2 = Math.pow(y, 3);
    var x2 = Math.pow(x, 3);
    var z222 = Math.pow(z22, 3);
    y = y2 > 0.008856 ? y2 : (y - 0.13793103448275862) / 7.787;
    x = x2 > 0.008856 ? x2 : (x - 0.13793103448275862) / 7.787;
    z22 = z222 > 0.008856 ? z222 : (z22 - 0.13793103448275862) / 7.787;
    x *= 95.047;
    y *= 100;
    z22 *= 108.883;
    return [x, y, z22];
  };
  convert.lab.lch = function(lab) {
    var l22 = lab[0];
    var a = lab[1];
    var b22 = lab[2];
    var hr;
    var h22;
    var c22;
    hr = Math.atan2(b22, a);
    h22 = hr * 360 / 2 / Math.PI;
    if (h22 < 0) {
      h22 += 360;
    }
    c22 = Math.sqrt(a * a + b22 * b22);
    return [l22, c22, h22];
  };
  convert.lch.lab = function(lch) {
    var l22 = lch[0];
    var c22 = lch[1];
    var h22 = lch[2];
    var a;
    var b22;
    var hr;
    hr = h22 / 360 * 2 * Math.PI;
    a = c22 * Math.cos(hr);
    b22 = c22 * Math.sin(hr);
    return [l22, a, b22];
  };
  convert.rgb.ansi16 = function(args) {
    var r22 = args[0];
    var g22 = args[1];
    var b22 = args[2];
    var value = 1 in arguments ? arguments[1] : convert.rgb.hsv(args)[2];
    value = Math.round(value / 50);
    if (value === 0) {
      return 30;
    }
    var ansi = 30 + (Math.round(b22 / 255) << 2 | Math.round(g22 / 255) << 1 | Math.round(r22 / 255));
    if (value === 2) {
      ansi += 60;
    }
    return ansi;
  };
  convert.hsv.ansi16 = function(args) {
    return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
  };
  convert.rgb.ansi256 = function(args) {
    var r22 = args[0];
    var g22 = args[1];
    var b22 = args[2];
    if (r22 === g22 && g22 === b22) {
      if (r22 < 8) {
        return 16;
      }
      if (r22 > 248) {
        return 231;
      }
      return Math.round((r22 - 8) / 247 * 24) + 232;
    }
    var ansi = 16 + 36 * Math.round(r22 / 255 * 5) + 6 * Math.round(g22 / 255 * 5) + Math.round(b22 / 255 * 5);
    return ansi;
  };
  convert.ansi16.rgb = function(args) {
    var color = args % 10;
    if (color === 0 || color === 7) {
      if (args > 50) {
        color += 3.5;
      }
      color = color / 10.5 * 255;
      return [color, color, color];
    }
    var mult = (~~(args > 50) + 1) * 0.5;
    var r22 = (color & 1) * mult * 255;
    var g22 = (color >> 1 & 1) * mult * 255;
    var b22 = (color >> 2 & 1) * mult * 255;
    return [r22, g22, b22];
  };
  convert.ansi256.rgb = function(args) {
    if (args >= 232) {
      var c22 = (args - 232) * 10 + 8;
      return [c22, c22, c22];
    }
    args -= 16;
    var rem;
    var r22 = Math.floor(args / 36) / 5 * 255;
    var g22 = Math.floor((rem = args % 36) / 6) / 5 * 255;
    var b22 = rem % 6 / 5 * 255;
    return [r22, g22, b22];
  };
  convert.rgb.hex = function(args) {
    var integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
    var string2 = integer.toString(16).toUpperCase();
    return "000000".substring(string2.length) + string2;
  };
  convert.hex.rgb = function(args) {
    var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
    if (!match) {
      return [0, 0, 0];
    }
    var colorString = match[0];
    if (match[0].length === 3) {
      colorString = colorString.split("").map(function(char) {
        return char + char;
      }).join("");
    }
    var integer = parseInt(colorString, 16);
    var r22 = integer >> 16 & 255;
    var g22 = integer >> 8 & 255;
    var b22 = integer & 255;
    return [r22, g22, b22];
  };
  convert.rgb.hcg = function(rgb) {
    var r22 = rgb[0] / 255;
    var g22 = rgb[1] / 255;
    var b22 = rgb[2] / 255;
    var max = Math.max(Math.max(r22, g22), b22);
    var min = Math.min(Math.min(r22, g22), b22);
    var chroma = max - min;
    var grayscale;
    var hue;
    if (chroma < 1) {
      grayscale = min / (1 - chroma);
    } else {
      grayscale = 0;
    }
    if (chroma <= 0) {
      hue = 0;
    } else if (max === r22) {
      hue = (g22 - b22) / chroma % 6;
    } else if (max === g22) {
      hue = 2 + (b22 - r22) / chroma;
    } else {
      hue = 4 + (r22 - g22) / chroma + 4;
    }
    hue /= 6;
    hue %= 1;
    return [hue * 360, chroma * 100, grayscale * 100];
  };
  convert.hsl.hcg = function(hsl) {
    var s32 = hsl[1] / 100;
    var l22 = hsl[2] / 100;
    var c22 = 1;
    var f22 = 0;
    if (l22 < 0.5) {
      c22 = 2 * s32 * l22;
    } else {
      c22 = 2 * s32 * (1 - l22);
    }
    if (c22 < 1) {
      f22 = (l22 - 0.5 * c22) / (1 - c22);
    }
    return [hsl[0], c22 * 100, f22 * 100];
  };
  convert.hsv.hcg = function(hsv) {
    var s32 = hsv[1] / 100;
    var v22 = hsv[2] / 100;
    var c22 = s32 * v22;
    var f22 = 0;
    if (c22 < 1) {
      f22 = (v22 - c22) / (1 - c22);
    }
    return [hsv[0], c22 * 100, f22 * 100];
  };
  convert.hcg.rgb = function(hcg) {
    var h22 = hcg[0] / 360;
    var c22 = hcg[1] / 100;
    var g22 = hcg[2] / 100;
    if (c22 === 0) {
      return [g22 * 255, g22 * 255, g22 * 255];
    }
    var pure = [0, 0, 0];
    var hi = h22 % 1 * 6;
    var v22 = hi % 1;
    var w22 = 1 - v22;
    var mg = 0;
    switch (Math.floor(hi)) {
      case 0:
        pure[0] = 1;
        pure[1] = v22;
        pure[2] = 0;
        break;
      case 1:
        pure[0] = w22;
        pure[1] = 1;
        pure[2] = 0;
        break;
      case 2:
        pure[0] = 0;
        pure[1] = 1;
        pure[2] = v22;
        break;
      case 3:
        pure[0] = 0;
        pure[1] = w22;
        pure[2] = 1;
        break;
      case 4:
        pure[0] = v22;
        pure[1] = 0;
        pure[2] = 1;
        break;
      default:
        pure[0] = 1;
        pure[1] = 0;
        pure[2] = w22;
    }
    mg = (1 - c22) * g22;
    return [
      (c22 * pure[0] + mg) * 255,
      (c22 * pure[1] + mg) * 255,
      (c22 * pure[2] + mg) * 255
    ];
  };
  convert.hcg.hsv = function(hcg) {
    var c22 = hcg[1] / 100;
    var g22 = hcg[2] / 100;
    var v22 = c22 + g22 * (1 - c22);
    var f22 = 0;
    if (v22 > 0) {
      f22 = c22 / v22;
    }
    return [hcg[0], f22 * 100, v22 * 100];
  };
  convert.hcg.hsl = function(hcg) {
    var c22 = hcg[1] / 100;
    var g22 = hcg[2] / 100;
    var l22 = g22 * (1 - c22) + 0.5 * c22;
    var s32 = 0;
    if (l22 > 0 && l22 < 0.5) {
      s32 = c22 / (2 * l22);
    } else if (l22 >= 0.5 && l22 < 1) {
      s32 = c22 / (2 * (1 - l22));
    }
    return [hcg[0], s32 * 100, l22 * 100];
  };
  convert.hcg.hwb = function(hcg) {
    var c22 = hcg[1] / 100;
    var g22 = hcg[2] / 100;
    var v22 = c22 + g22 * (1 - c22);
    return [hcg[0], (v22 - c22) * 100, (1 - v22) * 100];
  };
  convert.hwb.hcg = function(hwb) {
    var w22 = hwb[1] / 100;
    var b22 = hwb[2] / 100;
    var v22 = 1 - b22;
    var c22 = v22 - w22;
    var g22 = 0;
    if (c22 < 1) {
      g22 = (v22 - c22) / (1 - c22);
    }
    return [hwb[0], c22 * 100, g22 * 100];
  };
  convert.apple.rgb = function(apple) {
    return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
  };
  convert.rgb.apple = function(rgb) {
    return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
  };
  convert.gray.rgb = function(args) {
    return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
  };
  convert.gray.hsl = convert.gray.hsv = function(args) {
    return [0, 0, args[0]];
  };
  convert.gray.hwb = function(gray22) {
    return [0, 100, gray22[0]];
  };
  convert.gray.cmyk = function(gray22) {
    return [0, 0, 0, gray22[0]];
  };
  convert.gray.lab = function(gray22) {
    return [gray22[0], 0, 0];
  };
  convert.gray.hex = function(gray22) {
    var val2 = Math.round(gray22[0] / 100 * 255) & 255;
    var integer = (val2 << 16) + (val2 << 8) + val2;
    var string2 = integer.toString(16).toUpperCase();
    return "000000".substring(string2.length) + string2;
  };
  convert.rgb.gray = function(rgb) {
    var val2 = (rgb[0] + rgb[1] + rgb[2]) / 3;
    return [val2 / 255 * 100];
  };
});
var require_route = __commonJS2((exports, module) => {
  var conversions = require_conversions();
  function buildGraph() {
    var graph = {};
    var models = Object.keys(conversions);
    for (var len = models.length, i = 0;i < len; i++) {
      graph[models[i]] = {
        distance: -1,
        parent: null
      };
    }
    return graph;
  }
  function deriveBFS(fromModel) {
    var graph = buildGraph();
    var queue4 = [fromModel];
    graph[fromModel].distance = 0;
    while (queue4.length) {
      var current = queue4.pop();
      var adjacents = Object.keys(conversions[current]);
      for (var len = adjacents.length, i = 0;i < len; i++) {
        var adjacent = adjacents[i];
        var node = graph[adjacent];
        if (node.distance === -1) {
          node.distance = graph[current].distance + 1;
          node.parent = current;
          queue4.unshift(adjacent);
        }
      }
    }
    return graph;
  }
  function link2(from, to) {
    return function(args) {
      return to(from(args));
    };
  }
  function wrapConversion(toModel, graph) {
    var path3 = [graph[toModel].parent, toModel];
    var fn = conversions[graph[toModel].parent][toModel];
    var cur = graph[toModel].parent;
    while (graph[cur].parent) {
      path3.unshift(graph[cur].parent);
      fn = link2(conversions[graph[cur].parent][cur], fn);
      cur = graph[cur].parent;
    }
    fn.conversion = path3;
    return fn;
  }
  module.exports = function(fromModel) {
    var graph = deriveBFS(fromModel);
    var conversion = {};
    var models = Object.keys(graph);
    for (var len = models.length, i = 0;i < len; i++) {
      var toModel = models[i];
      var node = graph[toModel];
      if (node.parent === null) {
        continue;
      }
      conversion[toModel] = wrapConversion(toModel, graph);
    }
    return conversion;
  };
});
var require_color_convert = __commonJS2((exports, module) => {
  var conversions = require_conversions();
  var route = require_route();
  var convert = {};
  var models = Object.keys(conversions);
  function wrapRaw(fn) {
    var wrappedFn = function(args) {
      if (args === undefined || args === null) {
        return args;
      }
      if (arguments.length > 1) {
        args = Array.prototype.slice.call(arguments);
      }
      return fn(args);
    };
    if ("conversion" in fn) {
      wrappedFn.conversion = fn.conversion;
    }
    return wrappedFn;
  }
  function wrapRounded(fn) {
    var wrappedFn = function(args) {
      if (args === undefined || args === null) {
        return args;
      }
      if (arguments.length > 1) {
        args = Array.prototype.slice.call(arguments);
      }
      var result2 = fn(args);
      if (typeof result2 === "object") {
        for (var len = result2.length, i = 0;i < len; i++) {
          result2[i] = Math.round(result2[i]);
        }
      }
      return result2;
    };
    if ("conversion" in fn) {
      wrappedFn.conversion = fn.conversion;
    }
    return wrappedFn;
  }
  models.forEach(function(fromModel) {
    convert[fromModel] = {};
    Object.defineProperty(convert[fromModel], "channels", { value: conversions[fromModel].channels });
    Object.defineProperty(convert[fromModel], "labels", { value: conversions[fromModel].labels });
    var routes = route(fromModel);
    var routeModels = Object.keys(routes);
    routeModels.forEach(function(toModel) {
      var fn = routes[toModel];
      convert[fromModel][toModel] = wrapRounded(fn);
      convert[fromModel][toModel].raw = wrapRaw(fn);
    });
  });
  module.exports = convert;
});
var require_ansi_styles = __commonJS2((exports, module) => {
  var colorConvert = require_color_convert();
  var wrapAnsi162 = (fn, offset) => function() {
    const code = fn.apply(colorConvert, arguments);
    return `\x1B[${code + offset}m`;
  };
  var wrapAnsi2562 = (fn, offset) => function() {
    const code = fn.apply(colorConvert, arguments);
    return `\x1B[${38 + offset};5;${code}m`;
  };
  var wrapAnsi16m2 = (fn, offset) => function() {
    const rgb = fn.apply(colorConvert, arguments);
    return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
  };
  function assembleStyles2() {
    const codes = new Map;
    const styles3 = {
      modifier: {
        reset: [0, 0],
        bold: [1, 22],
        dim: [2, 22],
        italic: [3, 23],
        underline: [4, 24],
        inverse: [7, 27],
        hidden: [8, 28],
        strikethrough: [9, 29]
      },
      color: {
        black: [30, 39],
        red: [31, 39],
        green: [32, 39],
        yellow: [33, 39],
        blue: [34, 39],
        magenta: [35, 39],
        cyan: [36, 39],
        white: [37, 39],
        gray: [90, 39],
        redBright: [91, 39],
        greenBright: [92, 39],
        yellowBright: [93, 39],
        blueBright: [94, 39],
        magentaBright: [95, 39],
        cyanBright: [96, 39],
        whiteBright: [97, 39]
      },
      bgColor: {
        bgBlack: [40, 49],
        bgRed: [41, 49],
        bgGreen: [42, 49],
        bgYellow: [43, 49],
        bgBlue: [44, 49],
        bgMagenta: [45, 49],
        bgCyan: [46, 49],
        bgWhite: [47, 49],
        bgBlackBright: [100, 49],
        bgRedBright: [101, 49],
        bgGreenBright: [102, 49],
        bgYellowBright: [103, 49],
        bgBlueBright: [104, 49],
        bgMagentaBright: [105, 49],
        bgCyanBright: [106, 49],
        bgWhiteBright: [107, 49]
      }
    };
    styles3.color.grey = styles3.color.gray;
    for (const groupName of Object.keys(styles3)) {
      const group22 = styles3[groupName];
      for (const styleName of Object.keys(group22)) {
        const style = group22[styleName];
        styles3[styleName] = {
          open: `\x1B[${style[0]}m`,
          close: `\x1B[${style[1]}m`
        };
        group22[styleName] = styles3[styleName];
        codes.set(style[0], style[1]);
      }
      Object.defineProperty(styles3, groupName, {
        value: group22,
        enumerable: false
      });
      Object.defineProperty(styles3, "codes", {
        value: codes,
        enumerable: false
      });
    }
    const ansi2ansi = (n) => n;
    const rgb2rgb = (r22, g22, b22) => [r22, g22, b22];
    styles3.color.close = "\x1B[39m";
    styles3.bgColor.close = "\x1B[49m";
    styles3.color.ansi = {
      ansi: wrapAnsi162(ansi2ansi, 0)
    };
    styles3.color.ansi256 = {
      ansi256: wrapAnsi2562(ansi2ansi, 0)
    };
    styles3.color.ansi16m = {
      rgb: wrapAnsi16m2(rgb2rgb, 0)
    };
    styles3.bgColor.ansi = {
      ansi: wrapAnsi162(ansi2ansi, 10)
    };
    styles3.bgColor.ansi256 = {
      ansi256: wrapAnsi2562(ansi2ansi, 10)
    };
    styles3.bgColor.ansi16m = {
      rgb: wrapAnsi16m2(rgb2rgb, 10)
    };
    for (let key of Object.keys(colorConvert)) {
      if (typeof colorConvert[key] !== "object") {
        continue;
      }
      const suite = colorConvert[key];
      if (key === "ansi16") {
        key = "ansi";
      }
      if ("ansi16" in suite) {
        styles3.color.ansi[key] = wrapAnsi162(suite.ansi16, 0);
        styles3.bgColor.ansi[key] = wrapAnsi162(suite.ansi16, 10);
      }
      if ("ansi256" in suite) {
        styles3.color.ansi256[key] = wrapAnsi2562(suite.ansi256, 0);
        styles3.bgColor.ansi256[key] = wrapAnsi2562(suite.ansi256, 10);
      }
      if ("rgb" in suite) {
        styles3.color.ansi16m[key] = wrapAnsi16m2(suite.rgb, 0);
        styles3.bgColor.ansi16m[key] = wrapAnsi16m2(suite.rgb, 10);
      }
    }
    return styles3;
  }
  Object.defineProperty(module, "exports", {
    enumerable: true,
    get: assembleStyles2
  });
});
var require_has_flag = __commonJS2((exports, module) => {
  module.exports = (flag, argv22) => {
    argv22 = argv22 || process.argv;
    const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
    const pos = argv22.indexOf(prefix + flag);
    const terminatorPos = argv22.indexOf("--");
    return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
  };
});
var require_supports_color = __commonJS2((exports, module) => {
  var os32 = import.meta.require("os");
  var hasFlag22 = require_has_flag();
  var env5 = process.env;
  var forceColor;
  if (hasFlag22("no-color") || hasFlag22("no-colors") || hasFlag22("color=false")) {
    forceColor = false;
  } else if (hasFlag22("color") || hasFlag22("colors") || hasFlag22("color=true") || hasFlag22("color=always")) {
    forceColor = true;
  }
  if ("FORCE_COLOR" in env5) {
    forceColor = env5.FORCE_COLOR.length === 0 || parseInt(env5.FORCE_COLOR, 10) !== 0;
  }
  function translateLevel22(level) {
    if (level === 0) {
      return false;
    }
    return {
      level,
      hasBasic: true,
      has256: level >= 2,
      has16m: level >= 3
    };
  }
  function supportsColor22(stream2) {
    if (forceColor === false) {
      return 0;
    }
    if (hasFlag22("color=16m") || hasFlag22("color=full") || hasFlag22("color=truecolor")) {
      return 3;
    }
    if (hasFlag22("color=256")) {
      return 2;
    }
    if (stream2 && !stream2.isTTY && forceColor !== true) {
      return 0;
    }
    const min = forceColor ? 1 : 0;
    if (process.platform === "win32") {
      const osRelease = os32.release().split(".");
      if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
        return Number(osRelease[2]) >= 14931 ? 3 : 2;
      }
      return 1;
    }
    if ("CI" in env5) {
      if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => (sign in env5)) || env5.CI_NAME === "codeship") {
        return 1;
      }
      return min;
    }
    if ("TEAMCITY_VERSION" in env5) {
      return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env5.TEAMCITY_VERSION) ? 1 : 0;
    }
    if (env5.COLORTERM === "truecolor") {
      return 3;
    }
    if ("TERM_PROGRAM" in env5) {
      const version2 = parseInt((env5.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
      switch (env5.TERM_PROGRAM) {
        case "iTerm.app":
          return version2 >= 3 ? 3 : 2;
        case "Apple_Terminal":
          return 2;
      }
    }
    if (/-256(color)?$/i.test(env5.TERM)) {
      return 2;
    }
    if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env5.TERM)) {
      return 1;
    }
    if ("COLORTERM" in env5) {
      return 1;
    }
    if (env5.TERM === "dumb") {
      return min;
    }
    return min;
  }
  function getSupportLevel(stream2) {
    const level = supportsColor22(stream2);
    return translateLevel22(level);
  }
  module.exports = {
    supportsColor: getSupportLevel,
    stdout: getSupportLevel(process.stdout),
    stderr: getSupportLevel(process.stderr)
  };
});
var require_templates = __commonJS2((exports, module) => {
  var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
  var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
  var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
  var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
  var ESCAPES = new Map([
    ["n", "\n"],
    ["r", "\r"],
    ["t", "\t"],
    ["b", "\b"],
    ["f", "\f"],
    ["v", "\v"],
    ["0", "\0"],
    ["\\", "\\"],
    ["e", "\x1B"],
    ["a", "\x07"]
  ]);
  function unescape2(c22) {
    if (c22[0] === "u" && c22.length === 5 || c22[0] === "x" && c22.length === 3) {
      return String.fromCharCode(parseInt(c22.slice(1), 16));
    }
    return ESCAPES.get(c22) || c22;
  }
  function parseArguments(name, args) {
    const results = [];
    const chunks = args.trim().split(/\s*,\s*/g);
    let matches;
    for (const chunk of chunks) {
      if (!isNaN(chunk)) {
        results.push(Number(chunk));
      } else if (matches = chunk.match(STRING_REGEX)) {
        results.push(matches[2].replace(ESCAPE_REGEX, (m22, escape3, chr) => escape3 ? unescape2(escape3) : chr));
      } else {
        throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
      }
    }
    return results;
  }
  function parseStyle(style) {
    STYLE_REGEX.lastIndex = 0;
    const results = [];
    let matches;
    while ((matches = STYLE_REGEX.exec(style)) !== null) {
      const name = matches[1];
      if (matches[2]) {
        const args = parseArguments(name, matches[2]);
        results.push([name].concat(args));
      } else {
        results.push([name]);
      }
    }
    return results;
  }
  function buildStyle(chalk2, styles3) {
    const enabled22 = {};
    for (const layer of styles3) {
      for (const style of layer.styles) {
        enabled22[style[0]] = layer.inverse ? null : style.slice(1);
      }
    }
    let current = chalk2;
    for (const styleName of Object.keys(enabled22)) {
      if (Array.isArray(enabled22[styleName])) {
        if (!(styleName in current)) {
          throw new Error(`Unknown Chalk style: ${styleName}`);
        }
        if (enabled22[styleName].length > 0) {
          current = current[styleName].apply(current, enabled22[styleName]);
        } else {
          current = current[styleName];
        }
      }
    }
    return current;
  }
  module.exports = (chalk2, tmp) => {
    const styles3 = [];
    const chunks = [];
    let chunk = [];
    tmp.replace(TEMPLATE_REGEX, (m22, escapeChar, inverse22, style, close, chr) => {
      if (escapeChar) {
        chunk.push(unescape2(escapeChar));
      } else if (style) {
        const str = chunk.join("");
        chunk = [];
        chunks.push(styles3.length === 0 ? str : buildStyle(chalk2, styles3)(str));
        styles3.push({ inverse: inverse22, styles: parseStyle(style) });
      } else if (close) {
        if (styles3.length === 0) {
          throw new Error("Found extraneous } in Chalk template literal");
        }
        chunks.push(buildStyle(chalk2, styles3)(chunk.join("")));
        chunk = [];
        styles3.pop();
      } else {
        chunk.push(chr);
      }
    });
    chunks.push(chunk.join(""));
    if (styles3.length > 0) {
      const errMsg = `Chalk template literal is missing ${styles3.length} closing bracket${styles3.length === 1 ? "" : "s"} (\`}\`)`;
      throw new Error(errMsg);
    }
    return chunks.join("");
  };
});
var require_chalk = __commonJS2((exports, module) => {
  var escapeStringRegexp = require_escape_string_regexp();
  var ansiStyles2 = require_ansi_styles();
  var stdoutColor2 = require_supports_color().stdout;
  var template2 = require_templates();
  var isSimpleWindowsTerm = process.platform === "win32" && !"xterm-256color".toLowerCase().startsWith("xterm");
  var levelMapping2 = ["ansi", "ansi", "ansi256", "ansi16m"];
  var skipModels = new Set(["gray"]);
  var styles3 = Object.create(null);
  function applyOptions2(obj, options3) {
    options3 = options3 || {};
    const scLevel = stdoutColor2 ? stdoutColor2.level : 0;
    obj.level = options3.level === undefined ? scLevel : options3.level;
    obj.enabled = "enabled" in options3 ? options3.enabled : obj.level > 0;
  }
  function Chalk(options3) {
    if (!this || !(this instanceof Chalk) || this.template) {
      const chalk2 = {};
      applyOptions2(chalk2, options3);
      chalk2.template = function() {
        const args = [].slice.call(arguments);
        return chalkTag.apply(null, [chalk2.template].concat(args));
      };
      Object.setPrototypeOf(chalk2, Chalk.prototype);
      Object.setPrototypeOf(chalk2.template, chalk2);
      chalk2.template.constructor = Chalk;
      return chalk2.template;
    }
    applyOptions2(this, options3);
  }
  if (isSimpleWindowsTerm) {
    ansiStyles2.blue.open = "\x1B[94m";
  }
  for (const key of Object.keys(ansiStyles2)) {
    ansiStyles2[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles2[key].close), "g");
    styles3[key] = {
      get() {
        const codes = ansiStyles2[key];
        return build2.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
      }
    };
  }
  styles3.visible = {
    get() {
      return build2.call(this, this._styles || [], true, "visible");
    }
  };
  ansiStyles2.color.closeRe = new RegExp(escapeStringRegexp(ansiStyles2.color.close), "g");
  for (const model2 of Object.keys(ansiStyles2.color.ansi)) {
    if (skipModels.has(model2)) {
      continue;
    }
    styles3[model2] = {
      get() {
        const level = this.level;
        return function() {
          const open = ansiStyles2.color[levelMapping2[level]][model2].apply(null, arguments);
          const codes = {
            open,
            close: ansiStyles2.color.close,
            closeRe: ansiStyles2.color.closeRe
          };
          return build2.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model2);
        };
      }
    };
  }
  ansiStyles2.bgColor.closeRe = new RegExp(escapeStringRegexp(ansiStyles2.bgColor.close), "g");
  for (const model2 of Object.keys(ansiStyles2.bgColor.ansi)) {
    if (skipModels.has(model2)) {
      continue;
    }
    const bgModel = "bg" + model2[0].toUpperCase() + model2.slice(1);
    styles3[bgModel] = {
      get() {
        const level = this.level;
        return function() {
          const open = ansiStyles2.bgColor[levelMapping2[level]][model2].apply(null, arguments);
          const codes = {
            open,
            close: ansiStyles2.bgColor.close,
            closeRe: ansiStyles2.bgColor.closeRe
          };
          return build2.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model2);
        };
      }
    };
  }
  var proto2 = Object.defineProperties(() => {
  }, styles3);
  function build2(_styles, _empty, key) {
    const builder = function() {
      return applyStyle2.apply(builder, arguments);
    };
    builder._styles = _styles;
    builder._empty = _empty;
    const self2 = this;
    Object.defineProperty(builder, "level", {
      enumerable: true,
      get() {
        return self2.level;
      },
      set(level) {
        self2.level = level;
      }
    });
    Object.defineProperty(builder, "enabled", {
      enumerable: true,
      get() {
        return self2.enabled;
      },
      set(enabled22) {
        self2.enabled = enabled22;
      }
    });
    builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
    builder.__proto__ = proto2;
    return builder;
  }
  function applyStyle2() {
    const args = arguments;
    const argsLen = args.length;
    let str = String(arguments[0]);
    if (argsLen === 0) {
      return "";
    }
    if (argsLen > 1) {
      for (let a = 1;a < argsLen; a++) {
        str += " " + args[a];
      }
    }
    if (!this.enabled || this.level <= 0 || !str) {
      return this._empty ? "" : str;
    }
    const originalDim = ansiStyles2.dim.open;
    if (isSimpleWindowsTerm && this.hasGrey) {
      ansiStyles2.dim.open = "";
    }
    for (const code of this._styles.slice().reverse()) {
      str = code.open + str.replace(code.closeRe, code.open) + code.close;
      str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
    }
    ansiStyles2.dim.open = originalDim;
    return str;
  }
  function chalkTag(chalk2, strings) {
    if (!Array.isArray(strings)) {
      return [].slice.call(arguments, 1).join(" ");
    }
    const args = [].slice.call(arguments, 2);
    const parts = [strings.raw[0]];
    for (let i = 1;i < strings.length; i++) {
      parts.push(String(args[i - 1]).replace(/[{}\\]/g, "\\$&"));
      parts.push(String(strings.raw[i]));
    }
    return template2(chalk2, parts.join(""));
  }
  Object.defineProperties(Chalk.prototype, styles3);
  module.exports = Chalk();
  module.exports.supportsColor = stdoutColor2;
  module.exports.default = module.exports;
});
var require_lib8 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = highlight;
  exports.shouldHighlight = shouldHighlight;
  var _jsTokens = require_js_tokens();
  var _helperValidatorIdentifier = require_lib4();
  var _picocolors = _interopRequireWildcard(require_picocolors(), true);
  function _getRequireWildcardCache(e) {
    if (typeof WeakMap != "function")
      return null;
    var r22 = new WeakMap, t = new WeakMap;
    return (_getRequireWildcardCache = function(e2) {
      return e2 ? t : r22;
    })(e);
  }
  function _interopRequireWildcard(e, r22) {
    if (!r22 && e && e.__esModule)
      return e;
    if (e === null || typeof e != "object" && typeof e != "function")
      return { default: e };
    var t = _getRequireWildcardCache(r22);
    if (t && t.has(e))
      return t.get(e);
    var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e)
      if (u !== "default" && {}.hasOwnProperty.call(e, u)) {
        var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
        i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
      }
    return n.default = e, t && t.set(e, n), n;
  }
  var colors22 = typeof process === "object" && (process.env.FORCE_COLOR === "0" || process.env.FORCE_COLOR === "false") ? (0, _picocolors.createColors)(false) : _picocolors.default;
  var compose = (f22, g22) => (v22) => f22(g22(v22));
  var sometimesKeywords = new Set(["as", "async", "from", "get", "of", "set"]);
  function getDefs(colors3) {
    return {
      keyword: colors3.cyan,
      capitalized: colors3.yellow,
      jsxIdentifier: colors3.yellow,
      punctuator: colors3.yellow,
      number: colors3.magenta,
      string: colors3.green,
      regex: colors3.magenta,
      comment: colors3.gray,
      invalid: compose(compose(colors3.white, colors3.bgRed), colors3.bold)
    };
  }
  var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  var BRACKET = /^[()[\]{}]$/;
  var tokenize;
  {
    const JSX_TAG = /^[a-z][\w-]*$/i;
    const getTokenType = function(token, offset, text22) {
      if (token.type === "name") {
        if ((0, _helperValidatorIdentifier.isKeyword)(token.value) || (0, _helperValidatorIdentifier.isStrictReservedWord)(token.value, true) || sometimesKeywords.has(token.value)) {
          return "keyword";
        }
        if (JSX_TAG.test(token.value) && (text22[offset - 1] === "<" || text22.slice(offset - 2, offset) === "</")) {
          return "jsxIdentifier";
        }
        if (token.value[0] !== token.value[0].toLowerCase()) {
          return "capitalized";
        }
      }
      if (token.type === "punctuator" && BRACKET.test(token.value)) {
        return "bracket";
      }
      if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
        return "punctuator";
      }
      return token.type;
    };
    tokenize = function* (text22) {
      let match;
      while (match = _jsTokens.default.exec(text22)) {
        const token = _jsTokens.matchToToken(match);
        yield {
          type: getTokenType(token, match.index, text22),
          value: token.value
        };
      }
    };
  }
  function highlightTokens(defs, text22) {
    let highlighted = "";
    for (const {
      type,
      value
    } of tokenize(text22)) {
      const colorize2 = defs[type];
      if (colorize2) {
        highlighted += value.split(NEWLINE).map((str) => colorize2(str)).join("\n");
      } else {
        highlighted += value;
      }
    }
    return highlighted;
  }
  function shouldHighlight(options3) {
    return colors22.isColorSupported || options3.forceColor;
  }
  var pcWithForcedColor = undefined;
  function getColors(forceColor) {
    if (forceColor) {
      var _pcWithForcedColor;
      (_pcWithForcedColor = pcWithForcedColor) != null || (pcWithForcedColor = (0, _picocolors.createColors)(true));
      return pcWithForcedColor;
    }
    return colors22;
  }
  function highlight(code, options3 = {}) {
    if (code !== "" && shouldHighlight(options3)) {
      const defs = getDefs(getColors(options3.forceColor));
      return highlightTokens(defs, code);
    } else {
      return code;
    }
  }
  {
    let chalk2, chalkWithForcedColor;
    exports.getChalk = ({
      forceColor
    }) => {
      var _chalk;
      (_chalk = chalk2) != null || (chalk2 = require_chalk());
      if (forceColor) {
        var _chalkWithForcedColor;
        (_chalkWithForcedColor = chalkWithForcedColor) != null || (chalkWithForcedColor = new chalk2.constructor({
          enabled: true,
          level: 1
        }));
        return chalkWithForcedColor;
      }
      return chalk2;
    };
  }
});
var require_lib9 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.codeFrameColumns = codeFrameColumns;
  exports.default = _default;
  var _highlight = require_lib8();
  var _picocolors = _interopRequireWildcard(require_picocolors(), true);
  function _getRequireWildcardCache(e) {
    if (typeof WeakMap != "function")
      return null;
    var r22 = new WeakMap, t = new WeakMap;
    return (_getRequireWildcardCache = function(e2) {
      return e2 ? t : r22;
    })(e);
  }
  function _interopRequireWildcard(e, r22) {
    if (!r22 && e && e.__esModule)
      return e;
    if (e === null || typeof e != "object" && typeof e != "function")
      return { default: e };
    var t = _getRequireWildcardCache(r22);
    if (t && t.has(e))
      return t.get(e);
    var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e)
      if (u !== "default" && {}.hasOwnProperty.call(e, u)) {
        var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
        i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
      }
    return n.default = e, t && t.set(e, n), n;
  }
  var colors22 = typeof process === "object" && (process.env.FORCE_COLOR === "0" || process.env.FORCE_COLOR === "false") ? (0, _picocolors.createColors)(false) : _picocolors.default;
  var compose = (f22, g22) => (v22) => f22(g22(v22));
  var pcWithForcedColor = undefined;
  function getColors(forceColor) {
    if (forceColor) {
      var _pcWithForcedColor;
      (_pcWithForcedColor = pcWithForcedColor) != null || (pcWithForcedColor = (0, _picocolors.createColors)(true));
      return pcWithForcedColor;
    }
    return colors22;
  }
  var deprecationWarningShown = false;
  function getDefs(colors3) {
    return {
      gutter: colors3.gray,
      marker: compose(colors3.red, colors3.bold),
      message: compose(colors3.red, colors3.bold)
    };
  }
  var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  function getMarkerLines(loc, source, opts) {
    const startLoc = Object.assign({
      column: 0,
      line: -1
    }, loc.start);
    const endLoc = Object.assign({}, startLoc, loc.end);
    const {
      linesAbove = 2,
      linesBelow = 3
    } = opts || {};
    const startLine = startLoc.line;
    const startColumn = startLoc.column;
    const endLine = endLoc.line;
    const endColumn = endLoc.column;
    let start = Math.max(startLine - (linesAbove + 1), 0);
    let end = Math.min(source.length, endLine + linesBelow);
    if (startLine === -1) {
      start = 0;
    }
    if (endLine === -1) {
      end = source.length;
    }
    const lineDiff = endLine - startLine;
    const markerLines = {};
    if (lineDiff) {
      for (let i = 0;i <= lineDiff; i++) {
        const lineNumber = i + startLine;
        if (!startColumn) {
          markerLines[lineNumber] = true;
        } else if (i === 0) {
          const sourceLength = source[lineNumber - 1].length;
          markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
        } else if (i === lineDiff) {
          markerLines[lineNumber] = [0, endColumn];
        } else {
          const sourceLength = source[lineNumber - i].length;
          markerLines[lineNumber] = [0, sourceLength];
        }
      }
    } else {
      if (startColumn === endColumn) {
        if (startColumn) {
          markerLines[startLine] = [startColumn, 0];
        } else {
          markerLines[startLine] = true;
        }
      } else {
        markerLines[startLine] = [startColumn, endColumn - startColumn];
      }
    }
    return {
      start,
      end,
      markerLines
    };
  }
  function codeFrameColumns(rawLines, loc, opts = {}) {
    const highlighted = (opts.highlightCode || opts.forceColor) && (0, _highlight.shouldHighlight)(opts);
    const colors3 = getColors(opts.forceColor);
    const defs = getDefs(colors3);
    const maybeHighlight = (fmt, string2) => {
      return highlighted ? fmt(string2) : string2;
    };
    const lines = rawLines.split(NEWLINE);
    const {
      start,
      end,
      markerLines
    } = getMarkerLines(loc, lines, opts);
    const hasColumns = loc.start && typeof loc.start.column === "number";
    const numberMaxWidth = String(end).length;
    const highlightedLines = highlighted ? (0, _highlight.default)(rawLines, opts) : rawLines;
    let frame = highlightedLines.split(NEWLINE, end).slice(start, end).map((line, index) => {
      const number = start + 1 + index;
      const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
      const gutter = ` ${paddedNumber} |`;
      const hasMarker = markerLines[number];
      const lastMarkerLine = !markerLines[number + 1];
      if (hasMarker) {
        let markerLine = "";
        if (Array.isArray(hasMarker)) {
          const markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
          const numberOfMarkers = hasMarker[1] || 1;
          markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
          if (lastMarkerLine && opts.message) {
            markerLine += " " + maybeHighlight(defs.message, opts.message);
          }
        }
        return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? ` ${line}` : "", markerLine].join("");
      } else {
        return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ""}`;
      }
    }).join("\n");
    if (opts.message && !hasColumns) {
      frame = `${" ".repeat(numberMaxWidth + 1)}${opts.message}\n${frame}`;
    }
    if (highlighted) {
      return colors3.reset(frame);
    } else {
      return frame;
    }
  }
  function _default(rawLines, lineNumber, colNumber, opts = {}) {
    if (!deprecationWarningShown) {
      deprecationWarningShown = true;
      const message = "Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.";
      if (process.emitWarning) {
        process.emitWarning(message, "DeprecationWarning");
      } else {
        const deprecationError = new Error(message);
        deprecationError.name = "DeprecationWarning";
        console.warn(new Error(message));
      }
    }
    colNumber = Math.max(colNumber, 0);
    const location2 = {
      start: {
        column: colNumber,
        line: lineNumber
      }
    };
    return codeFrameColumns(rawLines, location2, opts);
  }
});
var require_hoister = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _t = require_lib6();
  var _t2 = _t;
  var {
    react
  } = _t;
  var {
    cloneNode,
    jsxExpressionContainer,
    variableDeclaration,
    variableDeclarator
  } = _t2;
  var referenceVisitor = {
    ReferencedIdentifier(path3, state) {
      if (path3.isJSXIdentifier() && react.isCompatTag(path3.node.name) && !path3.parentPath.isJSXMemberExpression()) {
        return;
      }
      if (path3.node.name === "this") {
        let scope = path3.scope;
        do {
          if (scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
            break;
          }
        } while (scope = scope.parent);
        if (scope)
          state.breakOnScopePaths.push(scope.path);
      }
      const binding = path3.scope.getBinding(path3.node.name);
      if (!binding)
        return;
      for (const violation of binding.constantViolations) {
        if (violation.scope !== binding.path.scope) {
          state.mutableBinding = true;
          path3.stop();
          return;
        }
      }
      if (binding !== state.scope.getBinding(path3.node.name))
        return;
      state.bindings[path3.node.name] = binding;
    }
  };

  class PathHoister {
    constructor(path3, scope) {
      this.breakOnScopePaths = undefined;
      this.bindings = undefined;
      this.mutableBinding = undefined;
      this.scopes = undefined;
      this.scope = undefined;
      this.path = undefined;
      this.attachAfter = undefined;
      this.breakOnScopePaths = [];
      this.bindings = {};
      this.mutableBinding = false;
      this.scopes = [];
      this.scope = scope;
      this.path = path3;
      this.attachAfter = false;
    }
    isCompatibleScope(scope) {
      for (const key of Object.keys(this.bindings)) {
        const binding = this.bindings[key];
        if (!scope.bindingIdentifierEquals(key, binding.identifier)) {
          return false;
        }
      }
      return true;
    }
    getCompatibleScopes() {
      let scope = this.path.scope;
      do {
        if (this.isCompatibleScope(scope)) {
          this.scopes.push(scope);
        } else {
          break;
        }
        if (this.breakOnScopePaths.includes(scope.path)) {
          break;
        }
      } while (scope = scope.parent);
    }
    getAttachmentPath() {
      let path3 = this._getAttachmentPath();
      if (!path3)
        return;
      let targetScope = path3.scope;
      if (targetScope.path === path3) {
        targetScope = path3.scope.parent;
      }
      if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
        for (const name of Object.keys(this.bindings)) {
          if (!targetScope.hasOwnBinding(name))
            continue;
          const binding = this.bindings[name];
          if (binding.kind === "param" || binding.path.parentKey === "params") {
            continue;
          }
          const bindingParentPath = this.getAttachmentParentForPath(binding.path);
          if (bindingParentPath.key >= path3.key) {
            this.attachAfter = true;
            path3 = binding.path;
            for (const violationPath of binding.constantViolations) {
              if (this.getAttachmentParentForPath(violationPath).key > path3.key) {
                path3 = violationPath;
              }
            }
          }
        }
      }
      return path3;
    }
    _getAttachmentPath() {
      const scopes = this.scopes;
      const scope = scopes.pop();
      if (!scope)
        return;
      if (scope.path.isFunction()) {
        if (this.hasOwnParamBindings(scope)) {
          if (this.scope === scope)
            return;
          const bodies = scope.path.get("body").get("body");
          for (let i = 0;i < bodies.length; i++) {
            if (bodies[i].node._blockHoist)
              continue;
            return bodies[i];
          }
        } else {
          return this.getNextScopeAttachmentParent();
        }
      } else if (scope.path.isProgram()) {
        return this.getNextScopeAttachmentParent();
      }
    }
    getNextScopeAttachmentParent() {
      const scope = this.scopes.pop();
      if (scope)
        return this.getAttachmentParentForPath(scope.path);
    }
    getAttachmentParentForPath(path3) {
      do {
        if (!path3.parentPath || Array.isArray(path3.container) && path3.isStatement()) {
          return path3;
        }
      } while (path3 = path3.parentPath);
    }
    hasOwnParamBindings(scope) {
      for (const name of Object.keys(this.bindings)) {
        if (!scope.hasOwnBinding(name))
          continue;
        const binding = this.bindings[name];
        if (binding.kind === "param" && binding.constant)
          return true;
      }
      return false;
    }
    run() {
      this.path.traverse(referenceVisitor, this);
      if (this.mutableBinding)
        return;
      this.getCompatibleScopes();
      const attachTo = this.getAttachmentPath();
      if (!attachTo)
        return;
      if (attachTo.getFunctionParent() === this.path.getFunctionParent())
        return;
      let uid = attachTo.scope.generateUidIdentifier("ref");
      const declarator = variableDeclarator(uid, this.path.node);
      const insertFn = this.attachAfter ? "insertAfter" : "insertBefore";
      const [attached] = attachTo[insertFn]([attachTo.isVariableDeclarator() ? declarator : variableDeclaration("var", [declarator])]);
      const parent = this.path.parentPath;
      if (parent.isJSXElement() && this.path.container === parent.node.children) {
        uid = jsxExpressionContainer(uid);
      }
      this.path.replaceWith(cloneNode(uid));
      return attachTo.isVariableDeclarator() ? attached.get("init") : attached.get("declarations.0.init");
    }
  }
  exports.default = PathHoister;
});
var require_removal_hooks = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.hooks = undefined;
  var hooks = exports.hooks = [function(self2, parent) {
    const removeParent = self2.key === "test" && (parent.isWhile() || parent.isSwitchCase()) || self2.key === "declaration" && parent.isExportDeclaration() || self2.key === "body" && parent.isLabeledStatement() || self2.listKey === "declarations" && parent.isVariableDeclaration() && parent.node.declarations.length === 1 || self2.key === "expression" && parent.isExpressionStatement();
    if (removeParent) {
      parent.remove();
      return true;
    }
  }, function(self2, parent) {
    if (parent.isSequenceExpression() && parent.node.expressions.length === 1) {
      parent.replaceWith(parent.node.expressions[0]);
      return true;
    }
  }, function(self2, parent) {
    if (parent.isBinary()) {
      if (self2.key === "left") {
        parent.replaceWith(parent.node.right);
      } else {
        parent.replaceWith(parent.node.left);
      }
      return true;
    }
  }, function(self2, parent) {
    if (parent.isIfStatement() && self2.key === "consequent" || self2.key === "body" && (parent.isLoop() || parent.isArrowFunctionExpression())) {
      self2.replaceWith({
        type: "BlockStatement",
        body: []
      });
      return true;
    }
  }];
});
var require_removal = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports._assertUnremoved = _assertUnremoved;
  exports._callRemovalHooks = _callRemovalHooks;
  exports._markRemoved = _markRemoved;
  exports._remove = _remove;
  exports._removeFromScope = _removeFromScope;
  exports.remove = remove;
  var _removalHooks = require_removal_hooks();
  var _cache = require_cache();
  var _replacement = require_replacement();
  var _index = require_path();
  var _t = require_lib6();
  var _modification = require_modification();
  var _context = require_context2();
  var {
    getBindingIdentifiers
  } = _t;
  function remove() {
    var _this$opts;
    _assertUnremoved.call(this);
    _context.resync.call(this);
    if (_callRemovalHooks.call(this)) {
      _markRemoved.call(this);
      return;
    }
    if (!((_this$opts = this.opts) != null && _this$opts.noScope)) {
      _removeFromScope.call(this);
    }
    this.shareCommentsWithSiblings();
    _remove.call(this);
    _markRemoved.call(this);
  }
  function _removeFromScope() {
    const bindings = getBindingIdentifiers(this.node, false, false, true);
    Object.keys(bindings).forEach((name) => this.scope.removeBinding(name));
  }
  function _callRemovalHooks() {
    if (this.parentPath) {
      for (const fn of _removalHooks.hooks) {
        if (fn(this, this.parentPath))
          return true;
      }
    }
  }
  function _remove() {
    if (Array.isArray(this.container)) {
      this.container.splice(this.key, 1);
      _modification.updateSiblingKeys.call(this, this.key, -1);
    } else {
      _replacement._replaceWith.call(this, null);
    }
  }
  function _markRemoved() {
    this._traverseFlags |= _index.SHOULD_SKIP | _index.REMOVED;
    if (this.parent) {
      (0, _cache.getCachedPaths)(this.hub, this.parent).delete(this.node);
    }
    this.node = null;
  }
  function _assertUnremoved() {
    if (this.removed) {
      throw this.buildCodeFrameError("NodePath has been removed so is read-only.");
    }
  }
});
var require_modification = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports._containerInsert = _containerInsert;
  exports._containerInsertAfter = _containerInsertAfter;
  exports._containerInsertBefore = _containerInsertBefore;
  exports._verifyNodeList = _verifyNodeList;
  exports.insertAfter = insertAfter;
  exports.insertBefore = insertBefore;
  exports.pushContainer = pushContainer;
  exports.unshiftContainer = unshiftContainer;
  exports.updateSiblingKeys = updateSiblingKeys;
  var _cache = require_cache();
  var _hoister = require_hoister();
  var _index = require_path();
  var _context = require_context2();
  var _removal = require_removal();
  var _t = require_lib6();
  var {
    arrowFunctionExpression,
    assertExpression,
    assignmentExpression,
    blockStatement,
    callExpression,
    cloneNode,
    expressionStatement,
    isAssignmentExpression,
    isCallExpression,
    isExportNamedDeclaration,
    isExpression,
    isIdentifier,
    isSequenceExpression,
    isSuper,
    thisExpression
  } = _t;
  function insertBefore(nodes_) {
    _removal._assertUnremoved.call(this);
    const nodes = _verifyNodeList.call(this, nodes_);
    const {
      parentPath,
      parent
    } = this;
    if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
      return parentPath.insertBefore(nodes);
    } else if (this.isNodeType("Expression") && !this.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
      if (this.node)
        nodes.push(this.node);
      return this.replaceExpressionWithStatements(nodes);
    } else if (Array.isArray(this.container)) {
      return _containerInsertBefore.call(this, nodes);
    } else if (this.isStatementOrBlock()) {
      const node = this.node;
      const shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
      this.replaceWith(blockStatement(shouldInsertCurrentNode ? [node] : []));
      return this.unshiftContainer("body", nodes);
    } else {
      throw new Error("We don't know what to do with this node type. We were previously a Statement but we can't fit in here?");
    }
  }
  function _containerInsert(from, nodes) {
    updateSiblingKeys.call(this, from, nodes.length);
    const paths = [];
    this.container.splice(from, 0, ...nodes);
    for (let i = 0;i < nodes.length; i++) {
      var _this$context;
      const to = from + i;
      const path3 = this.getSibling(to);
      paths.push(path3);
      if ((_this$context = this.context) != null && _this$context.queue) {
        _context.pushContext.call(path3, this.context);
      }
    }
    const contexts = _context._getQueueContexts.call(this);
    for (const path3 of paths) {
      _context.setScope.call(path3);
      path3.debug("Inserted.");
      for (const context of contexts) {
        context.maybeQueue(path3, true);
      }
    }
    return paths;
  }
  function _containerInsertBefore(nodes) {
    return _containerInsert.call(this, this.key, nodes);
  }
  function _containerInsertAfter(nodes) {
    return _containerInsert.call(this, this.key + 1, nodes);
  }
  var last = (arr) => arr[arr.length - 1];
  function isHiddenInSequenceExpression(path3) {
    return isSequenceExpression(path3.parent) && (last(path3.parent.expressions) !== path3.node || isHiddenInSequenceExpression(path3.parentPath));
  }
  function isAlmostConstantAssignment(node, scope) {
    if (!isAssignmentExpression(node) || !isIdentifier(node.left)) {
      return false;
    }
    const blockScope = scope.getBlockParent();
    return blockScope.hasOwnBinding(node.left.name) && blockScope.getOwnBinding(node.left.name).constantViolations.length <= 1;
  }
  function insertAfter(nodes_) {
    _removal._assertUnremoved.call(this);
    if (this.isSequenceExpression()) {
      return last(this.get("expressions")).insertAfter(nodes_);
    }
    const nodes = _verifyNodeList.call(this, nodes_);
    const {
      parentPath,
      parent
    } = this;
    if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
      return parentPath.insertAfter(nodes.map((node) => {
        return isExpression(node) ? expressionStatement(node) : node;
      }));
    } else if (this.isNodeType("Expression") && !this.isJSXElement() && !parentPath.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
      const self2 = this;
      if (self2.node) {
        const node = self2.node;
        let {
          scope
        } = this;
        if (scope.path.isPattern()) {
          assertExpression(node);
          self2.replaceWith(callExpression(arrowFunctionExpression([], node), []));
          self2.get("callee.body").insertAfter(nodes);
          return [self2];
        }
        if (isHiddenInSequenceExpression(self2)) {
          nodes.unshift(node);
        } else if (isCallExpression(node) && isSuper(node.callee)) {
          nodes.unshift(node);
          nodes.push(thisExpression());
        } else if (isAlmostConstantAssignment(node, scope)) {
          nodes.unshift(node);
          nodes.push(cloneNode(node.left));
        } else if (scope.isPure(node, true)) {
          nodes.push(node);
        } else {
          if (parentPath.isMethod({
            computed: true,
            key: node
          })) {
            scope = scope.parent;
          }
          const temp = scope.generateDeclaredUidIdentifier();
          nodes.unshift(expressionStatement(assignmentExpression("=", cloneNode(temp), node)));
          nodes.push(expressionStatement(cloneNode(temp)));
        }
      }
      return this.replaceExpressionWithStatements(nodes);
    } else if (Array.isArray(this.container)) {
      return _containerInsertAfter.call(this, nodes);
    } else if (this.isStatementOrBlock()) {
      const node = this.node;
      const shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
      this.replaceWith(blockStatement(shouldInsertCurrentNode ? [node] : []));
      return this.pushContainer("body", nodes);
    } else {
      throw new Error("We don't know what to do with this node type. We were previously a Statement but we can't fit in here?");
    }
  }
  function updateSiblingKeys(fromIndex, incrementBy) {
    if (!this.parent)
      return;
    const paths = (0, _cache.getCachedPaths)(this.hub, this.parent) || [];
    for (const [, path3] of paths) {
      if (typeof path3.key === "number" && path3.container === this.container && path3.key >= fromIndex) {
        path3.key += incrementBy;
      }
    }
  }
  function _verifyNodeList(nodes) {
    if (!nodes) {
      return [];
    }
    if (!Array.isArray(nodes)) {
      nodes = [nodes];
    }
    for (let i = 0;i < nodes.length; i++) {
      const node = nodes[i];
      let msg;
      if (!node) {
        msg = "has falsy node";
      } else if (typeof node !== "object") {
        msg = "contains a non-object node";
      } else if (!node.type) {
        msg = "without a type";
      } else if (node instanceof _index.default) {
        msg = "has a NodePath when it expected a raw object";
      }
      if (msg) {
        const type = Array.isArray(node) ? "array" : typeof node;
        throw new Error(`Node list ${msg} with the index of ${i} and type of ${type}`);
      }
    }
    return nodes;
  }
  function unshiftContainer(listKey, nodes) {
    _removal._assertUnremoved.call(this);
    nodes = _verifyNodeList.call(this, nodes);
    const path3 = _index.default.get({
      parentPath: this,
      parent: this.node,
      container: this.node[listKey],
      listKey,
      key: 0
    }).setContext(this.context);
    return _containerInsertBefore.call(path3, nodes);
  }
  function pushContainer(listKey, nodes) {
    _removal._assertUnremoved.call(this);
    const verifiedNodes = _verifyNodeList.call(this, nodes);
    const container = this.node[listKey];
    const path3 = _index.default.get({
      parentPath: this,
      parent: this.node,
      container,
      listKey,
      key: container.length
    }).setContext(this.context);
    return path3.replaceWithMultiple(verifiedNodes);
  }
  {
    exports.hoist = function hoist(scope = this.scope) {
      const hoister = new _hoister.default(this, scope);
      return hoister.run();
    };
  }
});
var require_replacement = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports._replaceWith = _replaceWith;
  exports.replaceExpressionWithStatements = replaceExpressionWithStatements;
  exports.replaceInline = replaceInline;
  exports.replaceWith = replaceWith;
  exports.replaceWithMultiple = replaceWithMultiple;
  exports.replaceWithSourceString = replaceWithSourceString;
  var _codeFrame = require_lib9();
  var _index = require_lib11();
  var _index2 = require_path();
  var _cache = require_cache();
  var _modification = require_modification();
  var _parser = require_lib3();
  var _t = require_lib6();
  var _context = require_context2();
  var {
    FUNCTION_TYPES,
    arrowFunctionExpression,
    assignmentExpression,
    awaitExpression,
    blockStatement,
    buildUndefinedNode,
    callExpression,
    cloneNode,
    conditionalExpression,
    expressionStatement,
    getBindingIdentifiers,
    identifier,
    inheritLeadingComments,
    inheritTrailingComments,
    inheritsComments,
    isBlockStatement,
    isEmptyStatement,
    isExpression,
    isExpressionStatement,
    isIfStatement,
    isProgram,
    isStatement,
    isVariableDeclaration,
    removeComments,
    returnStatement,
    sequenceExpression,
    validate: validate2,
    yieldExpression
  } = _t;
  function replaceWithMultiple(nodes) {
    var _getCachedPaths;
    _context.resync.call(this);
    nodes = _modification._verifyNodeList.call(this, nodes);
    inheritLeadingComments(nodes[0], this.node);
    inheritTrailingComments(nodes[nodes.length - 1], this.node);
    (_getCachedPaths = (0, _cache.getCachedPaths)(this.hub, this.parent)) == null || _getCachedPaths.delete(this.node);
    this.node = this.container[this.key] = null;
    const paths = this.insertAfter(nodes);
    if (this.node) {
      this.requeue();
    } else {
      this.remove();
    }
    return paths;
  }
  function replaceWithSourceString(replacement) {
    _context.resync.call(this);
    let ast;
    try {
      replacement = `(${replacement})`;
      ast = (0, _parser.parse)(replacement);
    } catch (err22) {
      const loc = err22.loc;
      if (loc) {
        err22.message += " - make sure this is an expression.\n" + (0, _codeFrame.codeFrameColumns)(replacement, {
          start: {
            line: loc.line,
            column: loc.column + 1
          }
        });
        err22.code = "BABEL_REPLACE_SOURCE_ERROR";
      }
      throw err22;
    }
    const expressionAST = ast.program.body[0].expression;
    _index.default.removeProperties(expressionAST);
    return this.replaceWith(expressionAST);
  }
  function replaceWith(replacementPath) {
    _context.resync.call(this);
    if (this.removed) {
      throw new Error("You can't replace this node, we've already removed it");
    }
    let replacement = replacementPath instanceof _index2.default ? replacementPath.node : replacementPath;
    if (!replacement) {
      throw new Error("You passed `path.replaceWith()` a falsy node, use `path.remove()` instead");
    }
    if (this.node === replacement) {
      return [this];
    }
    if (this.isProgram() && !isProgram(replacement)) {
      throw new Error("You can only replace a Program root node with another Program node");
    }
    if (Array.isArray(replacement)) {
      throw new Error("Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`");
    }
    if (typeof replacement === "string") {
      throw new Error("Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`");
    }
    let nodePath = "";
    if (this.isNodeType("Statement") && isExpression(replacement)) {
      if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement) && !this.parentPath.isExportDefaultDeclaration()) {
        replacement = expressionStatement(replacement);
        nodePath = "expression";
      }
    }
    if (this.isNodeType("Expression") && isStatement(replacement)) {
      if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement)) {
        return this.replaceExpressionWithStatements([replacement]);
      }
    }
    const oldNode = this.node;
    if (oldNode) {
      inheritsComments(replacement, oldNode);
      removeComments(oldNode);
    }
    _replaceWith.call(this, replacement);
    this.type = replacement.type;
    _context.setScope.call(this);
    this.requeue();
    return [nodePath ? this.get(nodePath) : this];
  }
  function _replaceWith(node) {
    var _getCachedPaths2;
    if (!this.container) {
      throw new ReferenceError("Container is falsy");
    }
    if (this.inList) {
      validate2(this.parent, this.key, [node]);
    } else {
      validate2(this.parent, this.key, node);
    }
    this.debug(`Replace with ${node == null ? undefined : node.type}`);
    (_getCachedPaths2 = (0, _cache.getCachedPaths)(this.hub, this.parent)) == null || _getCachedPaths2.set(node, this).delete(this.node);
    this.node = this.container[this.key] = node;
  }
  function replaceExpressionWithStatements(nodes) {
    _context.resync.call(this);
    const declars = [];
    const nodesAsSingleExpression = gatherSequenceExpressions(nodes, declars);
    if (nodesAsSingleExpression) {
      for (const id of declars)
        this.scope.push({
          id
        });
      return this.replaceWith(nodesAsSingleExpression)[0].get("expressions");
    }
    const functionParent = this.getFunctionParent();
    const isParentAsync = functionParent == null ? undefined : functionParent.node.async;
    const isParentGenerator = functionParent == null ? undefined : functionParent.node.generator;
    const container = arrowFunctionExpression([], blockStatement(nodes));
    this.replaceWith(callExpression(container, []));
    const callee = this.get("callee");
    callee.get("body").scope.hoistVariables((id) => this.scope.push({
      id
    }));
    const completionRecords = callee.getCompletionRecords();
    for (const path3 of completionRecords) {
      if (!path3.isExpressionStatement())
        continue;
      const loop = path3.findParent((path42) => path42.isLoop());
      if (loop) {
        let uid = loop.getData("expressionReplacementReturnUid");
        if (!uid) {
          uid = callee.scope.generateDeclaredUidIdentifier("ret");
          callee.get("body").pushContainer("body", returnStatement(cloneNode(uid)));
          loop.setData("expressionReplacementReturnUid", uid);
        } else {
          uid = identifier(uid.name);
        }
        path3.get("expression").replaceWith(assignmentExpression("=", cloneNode(uid), path3.node.expression));
      } else {
        path3.replaceWith(returnStatement(path3.node.expression));
      }
    }
    callee.arrowFunctionToExpression();
    const newCallee = callee;
    const needToAwaitFunction = isParentAsync && _index.default.hasType(this.get("callee.body").node, "AwaitExpression", FUNCTION_TYPES);
    const needToYieldFunction = isParentGenerator && _index.default.hasType(this.get("callee.body").node, "YieldExpression", FUNCTION_TYPES);
    if (needToAwaitFunction) {
      newCallee.set("async", true);
      if (!needToYieldFunction) {
        this.replaceWith(awaitExpression(this.node));
      }
    }
    if (needToYieldFunction) {
      newCallee.set("generator", true);
      this.replaceWith(yieldExpression(this.node, true));
    }
    return newCallee.get("body.body");
  }
  function gatherSequenceExpressions(nodes, declars) {
    const exprs = [];
    let ensureLastUndefined = true;
    for (const node of nodes) {
      if (!isEmptyStatement(node)) {
        ensureLastUndefined = false;
      }
      if (isExpression(node)) {
        exprs.push(node);
      } else if (isExpressionStatement(node)) {
        exprs.push(node.expression);
      } else if (isVariableDeclaration(node)) {
        if (node.kind !== "var")
          return;
        for (const declar of node.declarations) {
          const bindings = getBindingIdentifiers(declar);
          for (const key of Object.keys(bindings)) {
            declars.push(cloneNode(bindings[key]));
          }
          if (declar.init) {
            exprs.push(assignmentExpression("=", declar.id, declar.init));
          }
        }
        ensureLastUndefined = true;
      } else if (isIfStatement(node)) {
        const consequent = node.consequent ? gatherSequenceExpressions([node.consequent], declars) : buildUndefinedNode();
        const alternate = node.alternate ? gatherSequenceExpressions([node.alternate], declars) : buildUndefinedNode();
        if (!consequent || !alternate)
          return;
        exprs.push(conditionalExpression(node.test, consequent, alternate));
      } else if (isBlockStatement(node)) {
        const body = gatherSequenceExpressions(node.body, declars);
        if (!body)
          return;
        exprs.push(body);
      } else if (isEmptyStatement(node)) {
        if (nodes.indexOf(node) === 0) {
          ensureLastUndefined = true;
        }
      } else {
        return;
      }
    }
    if (ensureLastUndefined)
      exprs.push(buildUndefinedNode());
    if (exprs.length === 1) {
      return exprs[0];
    } else {
      return sequenceExpression(exprs);
    }
  }
  function replaceInline(nodes) {
    _context.resync.call(this);
    if (Array.isArray(nodes)) {
      if (Array.isArray(this.container)) {
        nodes = _modification._verifyNodeList.call(this, nodes);
        const paths = _modification._containerInsertAfter.call(this, nodes);
        this.remove();
        return paths;
      } else {
        return this.replaceWithMultiple(nodes);
      }
    } else {
      return this.replaceWith(nodes);
    }
  }
});
var require_evaluation = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.evaluate = evaluate;
  exports.evaluateTruthy = evaluateTruthy;
  var VALID_OBJECT_CALLEES = ["Number", "String", "Math"];
  var VALID_IDENTIFIER_CALLEES = ["isFinite", "isNaN", "parseFloat", "parseInt", "decodeURI", "decodeURIComponent", "encodeURI", "encodeURIComponent", null, null];
  var INVALID_METHODS = ["random"];
  function isValidObjectCallee(val2) {
    return VALID_OBJECT_CALLEES.includes(val2);
  }
  function isValidIdentifierCallee(val2) {
    return VALID_IDENTIFIER_CALLEES.includes(val2);
  }
  function isInvalidMethod(val2) {
    return INVALID_METHODS.includes(val2);
  }
  function evaluateTruthy() {
    const res = this.evaluate();
    if (res.confident)
      return !!res.value;
  }
  function deopt(path3, state) {
    if (!state.confident)
      return;
    state.deoptPath = path3;
    state.confident = false;
  }
  var Globals = new Map([["undefined", undefined], ["Infinity", Infinity], ["NaN", NaN]]);
  function evaluateCached(path3, state) {
    const {
      node
    } = path3;
    const {
      seen
    } = state;
    if (seen.has(node)) {
      const existing = seen.get(node);
      if (existing.resolved) {
        return existing.value;
      } else {
        deopt(path3, state);
        return;
      }
    } else {
      const item = {
        resolved: false
      };
      seen.set(node, item);
      const val2 = _evaluate(path3, state);
      if (state.confident) {
        item.resolved = true;
        item.value = val2;
      }
      return val2;
    }
  }
  function _evaluate(path3, state) {
    if (!state.confident)
      return;
    if (path3.isSequenceExpression()) {
      const exprs = path3.get("expressions");
      return evaluateCached(exprs[exprs.length - 1], state);
    }
    if (path3.isStringLiteral() || path3.isNumericLiteral() || path3.isBooleanLiteral()) {
      return path3.node.value;
    }
    if (path3.isNullLiteral()) {
      return null;
    }
    if (path3.isTemplateLiteral()) {
      return evaluateQuasis(path3, path3.node.quasis, state);
    }
    if (path3.isTaggedTemplateExpression() && path3.get("tag").isMemberExpression()) {
      const object = path3.get("tag.object");
      const {
        node: {
          name
        }
      } = object;
      const property = path3.get("tag.property");
      if (object.isIdentifier() && name === "String" && !path3.scope.getBinding(name) && property.isIdentifier() && property.node.name === "raw") {
        return evaluateQuasis(path3, path3.node.quasi.quasis, state, true);
      }
    }
    if (path3.isConditionalExpression()) {
      const testResult = evaluateCached(path3.get("test"), state);
      if (!state.confident)
        return;
      if (testResult) {
        return evaluateCached(path3.get("consequent"), state);
      } else {
        return evaluateCached(path3.get("alternate"), state);
      }
    }
    if (path3.isExpressionWrapper()) {
      return evaluateCached(path3.get("expression"), state);
    }
    if (path3.isMemberExpression() && !path3.parentPath.isCallExpression({
      callee: path3.node
    })) {
      const property = path3.get("property");
      const object = path3.get("object");
      if (object.isLiteral()) {
        const value = object.node.value;
        const type = typeof value;
        let key = null;
        if (path3.node.computed) {
          key = evaluateCached(property, state);
          if (!state.confident)
            return;
        } else if (property.isIdentifier()) {
          key = property.node.name;
        }
        if ((type === "number" || type === "string") && key != null && (typeof key === "number" || typeof key === "string")) {
          return value[key];
        }
      }
    }
    if (path3.isReferencedIdentifier()) {
      const binding = path3.scope.getBinding(path3.node.name);
      if (binding) {
        if (binding.constantViolations.length > 0 || path3.node.start < binding.path.node.end) {
          deopt(binding.path, state);
          return;
        }
        if (binding.hasValue) {
          return binding.value;
        }
      }
      const name = path3.node.name;
      if (Globals.has(name)) {
        if (!binding) {
          return Globals.get(name);
        }
        deopt(binding.path, state);
        return;
      }
      const resolved = path3.resolve();
      if (resolved === path3) {
        deopt(path3, state);
        return;
      } else {
        return evaluateCached(resolved, state);
      }
    }
    if (path3.isUnaryExpression({
      prefix: true
    })) {
      if (path3.node.operator === "void") {
        return;
      }
      const argument = path3.get("argument");
      if (path3.node.operator === "typeof" && (argument.isFunction() || argument.isClass())) {
        return "function";
      }
      const arg = evaluateCached(argument, state);
      if (!state.confident)
        return;
      switch (path3.node.operator) {
        case "!":
          return !arg;
        case "+":
          return +arg;
        case "-":
          return -arg;
        case "~":
          return ~arg;
        case "typeof":
          return typeof arg;
      }
    }
    if (path3.isArrayExpression()) {
      const arr = [];
      const elems = path3.get("elements");
      for (const elem of elems) {
        const elemValue = elem.evaluate();
        if (elemValue.confident) {
          arr.push(elemValue.value);
        } else {
          deopt(elemValue.deopt, state);
          return;
        }
      }
      return arr;
    }
    if (path3.isObjectExpression()) {
      const obj = {};
      const props = path3.get("properties");
      for (const prop of props) {
        if (prop.isObjectMethod() || prop.isSpreadElement()) {
          deopt(prop, state);
          return;
        }
        const keyPath = prop.get("key");
        let key;
        if (prop.node.computed) {
          key = keyPath.evaluate();
          if (!key.confident) {
            deopt(key.deopt, state);
            return;
          }
          key = key.value;
        } else if (keyPath.isIdentifier()) {
          key = keyPath.node.name;
        } else {
          key = keyPath.node.value;
        }
        const valuePath = prop.get("value");
        let value = valuePath.evaluate();
        if (!value.confident) {
          deopt(value.deopt, state);
          return;
        }
        value = value.value;
        obj[key] = value;
      }
      return obj;
    }
    if (path3.isLogicalExpression()) {
      const wasConfident = state.confident;
      const left = evaluateCached(path3.get("left"), state);
      const leftConfident = state.confident;
      state.confident = wasConfident;
      const right = evaluateCached(path3.get("right"), state);
      const rightConfident = state.confident;
      switch (path3.node.operator) {
        case "||":
          state.confident = leftConfident && (!!left || rightConfident);
          if (!state.confident)
            return;
          return left || right;
        case "&&":
          state.confident = leftConfident && (!left || rightConfident);
          if (!state.confident)
            return;
          return left && right;
        case "??":
          state.confident = leftConfident && (left != null || rightConfident);
          if (!state.confident)
            return;
          return left != null ? left : right;
      }
    }
    if (path3.isBinaryExpression()) {
      const left = evaluateCached(path3.get("left"), state);
      if (!state.confident)
        return;
      const right = evaluateCached(path3.get("right"), state);
      if (!state.confident)
        return;
      switch (path3.node.operator) {
        case "-":
          return left - right;
        case "+":
          return left + right;
        case "/":
          return left / right;
        case "*":
          return left * right;
        case "%":
          return left % right;
        case "**":
          return Math.pow(left, right);
        case "<":
          return left < right;
        case ">":
          return left > right;
        case "<=":
          return left <= right;
        case ">=":
          return left >= right;
        case "==":
          return left == right;
        case "!=":
          return left != right;
        case "===":
          return left === right;
        case "!==":
          return left !== right;
        case "|":
          return left | right;
        case "&":
          return left & right;
        case "^":
          return left ^ right;
        case "<<":
          return left << right;
        case ">>":
          return left >> right;
        case ">>>":
          return left >>> right;
      }
    }
    if (path3.isCallExpression()) {
      const callee = path3.get("callee");
      let context;
      let func;
      if (callee.isIdentifier() && !path3.scope.getBinding(callee.node.name) && (isValidObjectCallee(callee.node.name) || isValidIdentifierCallee(callee.node.name))) {
        func = global[callee.node.name];
      }
      if (callee.isMemberExpression()) {
        const object = callee.get("object");
        const property = callee.get("property");
        if (object.isIdentifier() && property.isIdentifier() && isValidObjectCallee(object.node.name) && !isInvalidMethod(property.node.name)) {
          context = global[object.node.name];
          const key = property.node.name;
          if (hasOwnProperty.call(context, key)) {
            func = context[key];
          }
        }
        if (object.isLiteral() && property.isIdentifier()) {
          const type = typeof object.node.value;
          if (type === "string" || type === "number") {
            context = object.node.value;
            func = context[property.node.name];
          }
        }
      }
      if (func) {
        const args = path3.get("arguments").map((arg) => evaluateCached(arg, state));
        if (!state.confident)
          return;
        return func.apply(context, args);
      }
    }
    deopt(path3, state);
  }
  function evaluateQuasis(path3, quasis, state, raw = false) {
    let str = "";
    let i = 0;
    const exprs = path3.isTemplateLiteral() ? path3.get("expressions") : path3.get("quasi.expressions");
    for (const elem of quasis) {
      if (!state.confident)
        break;
      str += raw ? elem.value.raw : elem.value.cooked;
      const expr = exprs[i++];
      if (expr)
        str += String(evaluateCached(expr, state));
    }
    if (!state.confident)
      return;
    return str;
  }
  function evaluate() {
    const state = {
      confident: true,
      deoptPath: null,
      seen: new Map
    };
    let value = evaluateCached(this, state);
    if (!state.confident)
      value = undefined;
    return {
      confident: state.confident,
      deopt: state.deoptPath,
      value
    };
  }
});
var require_formatters = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.statements = exports.statement = exports.smart = exports.program = exports.expression = undefined;
  var _t = require_lib6();
  var {
    assertExpressionStatement
  } = _t;
  function makeStatementFormatter(fn) {
    return {
      code: (str) => `/* @babel/template */;\n${str}`,
      validate: () => {
      },
      unwrap: (ast) => {
        return fn(ast.program.body.slice(1));
      }
    };
  }
  var smart = exports.smart = makeStatementFormatter((body) => {
    if (body.length > 1) {
      return body;
    } else {
      return body[0];
    }
  });
  var statements = exports.statements = makeStatementFormatter((body) => body);
  var statement = exports.statement = makeStatementFormatter((body) => {
    if (body.length === 0) {
      throw new Error("Found nothing to return.");
    }
    if (body.length > 1) {
      throw new Error("Found multiple statements but wanted one");
    }
    return body[0];
  });
  var expression = exports.expression = {
    code: (str) => `(\n${str}\n)`,
    validate: (ast) => {
      if (ast.program.body.length > 1) {
        throw new Error("Found multiple statements but wanted one");
      }
      if (expression.unwrap(ast).start === 0) {
        throw new Error("Parse result included parens.");
      }
    },
    unwrap: ({
      program: program2
    }) => {
      const [stmt] = program2.body;
      assertExpressionStatement(stmt);
      return stmt.expression;
    }
  };
  var program = exports.program = {
    code: (str) => str,
    validate: () => {
    },
    unwrap: (ast) => ast.program
  };
});
var require_options = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.merge = merge;
  exports.normalizeReplacements = normalizeReplacements;
  exports.validate = validate2;
  var _excluded = ["placeholderWhitelist", "placeholderPattern", "preserveComments", "syntacticPlaceholders"];
  function _objectWithoutPropertiesLoose(r22, e) {
    if (r22 == null)
      return {};
    var t = {};
    for (var n in r22)
      if ({}.hasOwnProperty.call(r22, n)) {
        if (e.includes(n))
          continue;
        t[n] = r22[n];
      }
    return t;
  }
  function merge(a, b22) {
    const {
      placeholderWhitelist = a.placeholderWhitelist,
      placeholderPattern = a.placeholderPattern,
      preserveComments = a.preserveComments,
      syntacticPlaceholders = a.syntacticPlaceholders
    } = b22;
    return {
      parser: Object.assign({}, a.parser, b22.parser),
      placeholderWhitelist,
      placeholderPattern,
      preserveComments,
      syntacticPlaceholders
    };
  }
  function validate2(opts) {
    if (opts != null && typeof opts !== "object") {
      throw new Error("Unknown template options.");
    }
    const _ref = opts || {}, {
      placeholderWhitelist,
      placeholderPattern,
      preserveComments,
      syntacticPlaceholders
    } = _ref, parser = _objectWithoutPropertiesLoose(_ref, _excluded);
    if (placeholderWhitelist != null && !(placeholderWhitelist instanceof Set)) {
      throw new Error("'.placeholderWhitelist' must be a Set, null, or undefined");
    }
    if (placeholderPattern != null && !(placeholderPattern instanceof RegExp) && placeholderPattern !== false) {
      throw new Error("'.placeholderPattern' must be a RegExp, false, null, or undefined");
    }
    if (preserveComments != null && typeof preserveComments !== "boolean") {
      throw new Error("'.preserveComments' must be a boolean, null, or undefined");
    }
    if (syntacticPlaceholders != null && typeof syntacticPlaceholders !== "boolean") {
      throw new Error("'.syntacticPlaceholders' must be a boolean, null, or undefined");
    }
    if (syntacticPlaceholders === true && (placeholderWhitelist != null || placeholderPattern != null)) {
      throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible with '.syntacticPlaceholders: true'");
    }
    return {
      parser,
      placeholderWhitelist: placeholderWhitelist || undefined,
      placeholderPattern: placeholderPattern == null ? undefined : placeholderPattern,
      preserveComments: preserveComments == null ? undefined : preserveComments,
      syntacticPlaceholders: syntacticPlaceholders == null ? undefined : syntacticPlaceholders
    };
  }
  function normalizeReplacements(replacements) {
    if (Array.isArray(replacements)) {
      return replacements.reduce((acc, replacement, i) => {
        acc["$" + i] = replacement;
        return acc;
      }, {});
    } else if (typeof replacements === "object" || replacements == null) {
      return replacements || undefined;
    }
    throw new Error("Template replacements must be an array, object, null, or undefined");
  }
});
var require_parse = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = parseAndBuildMetadata;
  var _t = require_lib6();
  var _parser = require_lib3();
  var _codeFrame = require_lib9();
  var {
    isCallExpression,
    isExpressionStatement,
    isFunction: isFunction22,
    isIdentifier,
    isJSXIdentifier,
    isNewExpression,
    isPlaceholder,
    isStatement,
    isStringLiteral,
    removePropertiesDeep,
    traverse
  } = _t;
  var PATTERN = /^[_$A-Z0-9]+$/;
  function parseAndBuildMetadata(formatter22, code, opts) {
    const {
      placeholderWhitelist,
      placeholderPattern,
      preserveComments,
      syntacticPlaceholders
    } = opts;
    const ast = parseWithCodeFrame(code, opts.parser, syntacticPlaceholders);
    removePropertiesDeep(ast, {
      preserveComments
    });
    formatter22.validate(ast);
    const state = {
      syntactic: {
        placeholders: [],
        placeholderNames: new Set
      },
      legacy: {
        placeholders: [],
        placeholderNames: new Set
      },
      placeholderWhitelist,
      placeholderPattern,
      syntacticPlaceholders
    };
    traverse(ast, placeholderVisitorHandler, state);
    return Object.assign({
      ast
    }, state.syntactic.placeholders.length ? state.syntactic : state.legacy);
  }
  function placeholderVisitorHandler(node, ancestors, state) {
    var _state$placeholderWhi;
    let name;
    let hasSyntacticPlaceholders = state.syntactic.placeholders.length > 0;
    if (isPlaceholder(node)) {
      if (state.syntacticPlaceholders === false) {
        throw new Error("%%foo%%-style placeholders can't be used when '.syntacticPlaceholders' is false.");
      }
      name = node.name.name;
      hasSyntacticPlaceholders = true;
    } else if (hasSyntacticPlaceholders || state.syntacticPlaceholders) {
      return;
    } else if (isIdentifier(node) || isJSXIdentifier(node)) {
      name = node.name;
    } else if (isStringLiteral(node)) {
      name = node.value;
    } else {
      return;
    }
    if (hasSyntacticPlaceholders && (state.placeholderPattern != null || state.placeholderWhitelist != null)) {
      throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible with '.syntacticPlaceholders: true'");
    }
    if (!hasSyntacticPlaceholders && (state.placeholderPattern === false || !(state.placeholderPattern || PATTERN).test(name)) && !((_state$placeholderWhi = state.placeholderWhitelist) != null && _state$placeholderWhi.has(name))) {
      return;
    }
    ancestors = ancestors.slice();
    const {
      node: parent,
      key
    } = ancestors[ancestors.length - 1];
    let type;
    if (isStringLiteral(node) || isPlaceholder(node, {
      expectedNode: "StringLiteral"
    })) {
      type = "string";
    } else if (isNewExpression(parent) && key === "arguments" || isCallExpression(parent) && key === "arguments" || isFunction22(parent) && key === "params") {
      type = "param";
    } else if (isExpressionStatement(parent) && !isPlaceholder(node)) {
      type = "statement";
      ancestors = ancestors.slice(0, -1);
    } else if (isStatement(node) && isPlaceholder(node)) {
      type = "statement";
    } else {
      type = "other";
    }
    const {
      placeholders,
      placeholderNames
    } = !hasSyntacticPlaceholders ? state.legacy : state.syntactic;
    placeholders.push({
      name,
      type,
      resolve: (ast) => resolveAncestors(ast, ancestors),
      isDuplicate: placeholderNames.has(name)
    });
    placeholderNames.add(name);
  }
  function resolveAncestors(ast, ancestors) {
    let parent = ast;
    for (let i = 0;i < ancestors.length - 1; i++) {
      const {
        key: key2,
        index: index2
      } = ancestors[i];
      if (index2 === undefined) {
        parent = parent[key2];
      } else {
        parent = parent[key2][index2];
      }
    }
    const {
      key,
      index
    } = ancestors[ancestors.length - 1];
    return {
      parent,
      key,
      index
    };
  }
  function parseWithCodeFrame(code, parserOpts, syntacticPlaceholders) {
    const plugins = (parserOpts.plugins || []).slice();
    if (syntacticPlaceholders !== false) {
      plugins.push("placeholders");
    }
    parserOpts = Object.assign({
      allowReturnOutsideFunction: true,
      allowSuperOutsideMethod: true,
      sourceType: "module"
    }, parserOpts, {
      plugins
    });
    try {
      return (0, _parser.parse)(code, parserOpts);
    } catch (err22) {
      const loc = err22.loc;
      if (loc) {
        err22.message += "\n" + (0, _codeFrame.codeFrameColumns)(code, {
          start: loc
        });
        err22.code = "BABEL_TEMPLATE_PARSE_ERROR";
      }
      throw err22;
    }
  }
});
var require_populate = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = populatePlaceholders;
  var _t = require_lib6();
  var {
    blockStatement,
    cloneNode,
    emptyStatement,
    expressionStatement,
    identifier,
    isStatement,
    isStringLiteral,
    stringLiteral,
    validate: validate2
  } = _t;
  function populatePlaceholders(metadata, replacements) {
    const ast = cloneNode(metadata.ast);
    if (replacements) {
      metadata.placeholders.forEach((placeholder) => {
        if (!hasOwnProperty.call(replacements, placeholder.name)) {
          const placeholderName = placeholder.name;
          throw new Error(`Error: No substitution given for "${placeholderName}". If this is not meant to be a
            placeholder you may want to consider passing one of the following options to @babel/template:
            - { placeholderPattern: false, placeholderWhitelist: new Set(['${placeholderName}'])}
            - { placeholderPattern: /^${placeholderName}$/ }`);
        }
      });
      Object.keys(replacements).forEach((key) => {
        if (!metadata.placeholderNames.has(key)) {
          throw new Error(`Unknown substitution "${key}" given`);
        }
      });
    }
    metadata.placeholders.slice().reverse().forEach((placeholder) => {
      try {
        applyReplacement(placeholder, ast, replacements && replacements[placeholder.name] || null);
      } catch (e) {
        e.message = `@babel/template placeholder "${placeholder.name}": ${e.message}`;
        throw e;
      }
    });
    return ast;
  }
  function applyReplacement(placeholder, ast, replacement) {
    if (placeholder.isDuplicate) {
      if (Array.isArray(replacement)) {
        replacement = replacement.map((node) => cloneNode(node));
      } else if (typeof replacement === "object") {
        replacement = cloneNode(replacement);
      }
    }
    const {
      parent,
      key,
      index
    } = placeholder.resolve(ast);
    if (placeholder.type === "string") {
      if (typeof replacement === "string") {
        replacement = stringLiteral(replacement);
      }
      if (!replacement || !isStringLiteral(replacement)) {
        throw new Error("Expected string substitution");
      }
    } else if (placeholder.type === "statement") {
      if (index === undefined) {
        if (!replacement) {
          replacement = emptyStatement();
        } else if (Array.isArray(replacement)) {
          replacement = blockStatement(replacement);
        } else if (typeof replacement === "string") {
          replacement = expressionStatement(identifier(replacement));
        } else if (!isStatement(replacement)) {
          replacement = expressionStatement(replacement);
        }
      } else {
        if (replacement && !Array.isArray(replacement)) {
          if (typeof replacement === "string") {
            replacement = identifier(replacement);
          }
          if (!isStatement(replacement)) {
            replacement = expressionStatement(replacement);
          }
        }
      }
    } else if (placeholder.type === "param") {
      if (typeof replacement === "string") {
        replacement = identifier(replacement);
      }
      if (index === undefined)
        throw new Error("Assertion failure.");
    } else {
      if (typeof replacement === "string") {
        replacement = identifier(replacement);
      }
      if (Array.isArray(replacement)) {
        throw new Error("Cannot replace single expression with an array.");
      }
    }
    function set(parent2, key2, value) {
      const node = parent2[key2];
      parent2[key2] = value;
      if (node.type === "Identifier" || node.type === "Placeholder") {
        if (node.typeAnnotation) {
          value.typeAnnotation = node.typeAnnotation;
        }
        if (node.optional) {
          value.optional = node.optional;
        }
        if (node.decorators) {
          value.decorators = node.decorators;
        }
      }
    }
    if (index === undefined) {
      validate2(parent, key, replacement);
      set(parent, key, replacement);
    } else {
      const items = parent[key].slice();
      if (placeholder.type === "statement" || placeholder.type === "param") {
        if (replacement == null) {
          items.splice(index, 1);
        } else if (Array.isArray(replacement)) {
          items.splice(index, 1, ...replacement);
        } else {
          set(items, index, replacement);
        }
      } else {
        set(items, index, replacement);
      }
      validate2(parent, key, items);
      parent[key] = items;
    }
  }
});
var require_string = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = stringTemplate;
  var _options = require_options();
  var _parse = require_parse();
  var _populate = require_populate();
  function stringTemplate(formatter22, code, opts) {
    code = formatter22.code(code);
    let metadata;
    return (arg) => {
      const replacements = (0, _options.normalizeReplacements)(arg);
      if (!metadata)
        metadata = (0, _parse.default)(formatter22, code, opts);
      return formatter22.unwrap((0, _populate.default)(metadata, replacements));
    };
  }
});
var require_literal = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = literalTemplate;
  var _options = require_options();
  var _parse = require_parse();
  var _populate = require_populate();
  function literalTemplate(formatter22, tpl, opts) {
    const {
      metadata,
      names
    } = buildLiteralData(formatter22, tpl, opts);
    return (arg) => {
      const defaultReplacements = {};
      arg.forEach((replacement, i) => {
        defaultReplacements[names[i]] = replacement;
      });
      return (arg2) => {
        const replacements = (0, _options.normalizeReplacements)(arg2);
        if (replacements) {
          Object.keys(replacements).forEach((key) => {
            if (hasOwnProperty.call(defaultReplacements, key)) {
              throw new Error("Unexpected replacement overlap.");
            }
          });
        }
        return formatter22.unwrap((0, _populate.default)(metadata, replacements ? Object.assign(replacements, defaultReplacements) : defaultReplacements));
      };
    };
  }
  function buildLiteralData(formatter22, tpl, opts) {
    let prefix = "BABEL_TPL$";
    const raw = tpl.join("");
    do {
      prefix = "$$" + prefix;
    } while (raw.includes(prefix));
    const {
      names,
      code
    } = buildTemplateCode(tpl, prefix);
    const metadata = (0, _parse.default)(formatter22, formatter22.code(code), {
      parser: opts.parser,
      placeholderWhitelist: new Set(names.concat(opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : [])),
      placeholderPattern: opts.placeholderPattern,
      preserveComments: opts.preserveComments,
      syntacticPlaceholders: opts.syntacticPlaceholders
    });
    return {
      metadata,
      names
    };
  }
  function buildTemplateCode(tpl, prefix) {
    const names = [];
    let code = tpl[0];
    for (let i = 1;i < tpl.length; i++) {
      const value = `${prefix}${i - 1}`;
      names.push(value);
      code += value + tpl[i];
    }
    return {
      names,
      code
    };
  }
});
var require_builder = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = createTemplateBuilder;
  var _options = require_options();
  var _string = require_string();
  var _literal = require_literal();
  var NO_PLACEHOLDER = (0, _options.validate)({
    placeholderPattern: false
  });
  function createTemplateBuilder(formatter22, defaultOpts) {
    const templateFnCache = new WeakMap;
    const templateAstCache = new WeakMap;
    const cachedOpts = defaultOpts || (0, _options.validate)(null);
    return Object.assign((tpl, ...args) => {
      if (typeof tpl === "string") {
        if (args.length > 1)
          throw new Error("Unexpected extra params.");
        return extendedTrace((0, _string.default)(formatter22, tpl, (0, _options.merge)(cachedOpts, (0, _options.validate)(args[0]))));
      } else if (Array.isArray(tpl)) {
        let builder = templateFnCache.get(tpl);
        if (!builder) {
          builder = (0, _literal.default)(formatter22, tpl, cachedOpts);
          templateFnCache.set(tpl, builder);
        }
        return extendedTrace(builder(args));
      } else if (typeof tpl === "object" && tpl) {
        if (args.length > 0)
          throw new Error("Unexpected extra params.");
        return createTemplateBuilder(formatter22, (0, _options.merge)(cachedOpts, (0, _options.validate)(tpl)));
      }
      throw new Error(`Unexpected template param ${typeof tpl}`);
    }, {
      ast: (tpl, ...args) => {
        if (typeof tpl === "string") {
          if (args.length > 1)
            throw new Error("Unexpected extra params.");
          return (0, _string.default)(formatter22, tpl, (0, _options.merge)((0, _options.merge)(cachedOpts, (0, _options.validate)(args[0])), NO_PLACEHOLDER))();
        } else if (Array.isArray(tpl)) {
          let builder = templateAstCache.get(tpl);
          if (!builder) {
            builder = (0, _literal.default)(formatter22, tpl, (0, _options.merge)(cachedOpts, NO_PLACEHOLDER));
            templateAstCache.set(tpl, builder);
          }
          return builder(args)();
        }
        throw new Error(`Unexpected template param ${typeof tpl}`);
      }
    });
  }
  function extendedTrace(fn) {
    let rootStack = "";
    try {
      throw new Error;
    } catch (error) {
      if (error.stack) {
        rootStack = error.stack.split("\n").slice(3).join("\n");
      }
    }
    return (arg) => {
      try {
        return fn(arg);
      } catch (err22) {
        err22.stack += `\n    =============\n${rootStack}`;
        throw err22;
      }
    };
  }
});
var require_lib10 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.statements = exports.statement = exports.smart = exports.program = exports.expression = exports.default = undefined;
  var formatters = require_formatters();
  var _builder = require_builder();
  var smart = exports.smart = (0, _builder.default)(formatters.smart);
  var statement = exports.statement = (0, _builder.default)(formatters.statement);
  var statements = exports.statements = (0, _builder.default)(formatters.statements);
  var expression = exports.expression = (0, _builder.default)(formatters.expression);
  var program = exports.program = (0, _builder.default)(formatters.program);
  var _default = exports.default = Object.assign(smart.bind(undefined), {
    smart,
    statement,
    statements,
    expression,
    program,
    ast: smart.ast
  });
});
var require_conversion = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.arrowFunctionToExpression = arrowFunctionToExpression;
  exports.ensureBlock = ensureBlock;
  exports.ensureFunctionName = ensureFunctionName;
  exports.splitExportDeclaration = splitExportDeclaration;
  exports.toComputedKey = toComputedKey;
  exports.unwrapFunctionEnvironment = unwrapFunctionEnvironment;
  var _t = require_lib6();
  var _template = require_lib10();
  var _visitors = require_visitors();
  var _context = require_context2();
  var {
    arrowFunctionExpression,
    assignmentExpression,
    binaryExpression,
    blockStatement,
    callExpression,
    conditionalExpression,
    expressionStatement,
    identifier,
    isIdentifier,
    jsxIdentifier,
    logicalExpression,
    LOGICAL_OPERATORS,
    memberExpression,
    metaProperty,
    numericLiteral,
    objectExpression,
    restElement,
    returnStatement,
    sequenceExpression,
    spreadElement,
    stringLiteral,
    super: _super,
    thisExpression,
    toExpression,
    unaryExpression,
    toBindingIdentifierName,
    isFunction: isFunction22,
    isAssignmentPattern,
    isRestElement,
    getFunctionName,
    cloneNode,
    variableDeclaration,
    variableDeclarator,
    exportNamedDeclaration,
    exportSpecifier,
    inherits
  } = _t;
  function toComputedKey() {
    let key;
    if (this.isMemberExpression()) {
      key = this.node.property;
    } else if (this.isProperty() || this.isMethod()) {
      key = this.node.key;
    } else {
      throw new ReferenceError("todo");
    }
    if (!this.node.computed) {
      if (isIdentifier(key))
        key = stringLiteral(key.name);
    }
    return key;
  }
  function ensureBlock() {
    const body = this.get("body");
    const bodyNode = body.node;
    if (Array.isArray(body)) {
      throw new Error("Can't convert array path to a block statement");
    }
    if (!bodyNode) {
      throw new Error("Can't convert node without a body");
    }
    if (body.isBlockStatement()) {
      return bodyNode;
    }
    const statements = [];
    let stringPath = "body";
    let key;
    let listKey;
    if (body.isStatement()) {
      listKey = "body";
      key = 0;
      statements.push(body.node);
    } else {
      stringPath += ".body.0";
      if (this.isFunction()) {
        key = "argument";
        statements.push(returnStatement(body.node));
      } else {
        key = "expression";
        statements.push(expressionStatement(body.node));
      }
    }
    this.node.body = blockStatement(statements);
    const parentPath = this.get(stringPath);
    _context.setup.call(body, parentPath, listKey ? parentPath.node[listKey] : parentPath.node, listKey, key);
    return this.node;
  }
  {
    exports.arrowFunctionToShadowed = function() {
      if (!this.isArrowFunctionExpression())
        return;
      this.arrowFunctionToExpression();
    };
  }
  function unwrapFunctionEnvironment() {
    if (!this.isArrowFunctionExpression() && !this.isFunctionExpression() && !this.isFunctionDeclaration()) {
      throw this.buildCodeFrameError("Can only unwrap the environment of a function.");
    }
    hoistFunctionEnvironment(this);
  }
  function setType(path3, type) {
    path3.node.type = type;
  }
  function arrowFunctionToExpression({
    allowInsertArrow = true,
    allowInsertArrowWithRest = allowInsertArrow,
    noNewArrows = !((_arguments$) => (_arguments$ = arguments[0]) == null ? undefined : _arguments$.specCompliant)()
  } = {}) {
    if (!this.isArrowFunctionExpression()) {
      throw this.buildCodeFrameError("Cannot convert non-arrow function to a function expression.");
    }
    let self2 = this;
    if (!noNewArrows) {
      var _self$ensureFunctionN;
      self2 = (_self$ensureFunctionN = self2.ensureFunctionName(false)) != null ? _self$ensureFunctionN : self2;
    }
    const {
      thisBinding,
      fnPath: fn
    } = hoistFunctionEnvironment(self2, noNewArrows, allowInsertArrow, allowInsertArrowWithRest);
    fn.ensureBlock();
    setType(fn, "FunctionExpression");
    if (!noNewArrows) {
      const checkBinding = thisBinding ? null : fn.scope.generateUidIdentifier("arrowCheckId");
      if (checkBinding) {
        fn.parentPath.scope.push({
          id: checkBinding,
          init: objectExpression([])
        });
      }
      fn.get("body").unshiftContainer("body", expressionStatement(callExpression(this.hub.addHelper("newArrowCheck"), [thisExpression(), checkBinding ? identifier(checkBinding.name) : identifier(thisBinding)])));
      fn.replaceWith(callExpression(memberExpression(fn.node, identifier("bind")), [checkBinding ? identifier(checkBinding.name) : thisExpression()]));
      return fn.get("callee.object");
    }
    return fn;
  }
  var getSuperCallsVisitor = (0, _visitors.environmentVisitor)({
    CallExpression(child, {
      allSuperCalls
    }) {
      if (!child.get("callee").isSuper())
        return;
      allSuperCalls.push(child);
    }
  });
  function hoistFunctionEnvironment(fnPath, noNewArrows = true, allowInsertArrow = true, allowInsertArrowWithRest = true) {
    let arrowParent;
    let thisEnvFn = fnPath.findParent((p32) => {
      if (p32.isArrowFunctionExpression()) {
        var _arrowParent;
        (_arrowParent = arrowParent) != null || (arrowParent = p32);
        return false;
      }
      return p32.isFunction() || p32.isProgram() || p32.isClassProperty({
        static: false
      }) || p32.isClassPrivateProperty({
        static: false
      });
    });
    const inConstructor = thisEnvFn.isClassMethod({
      kind: "constructor"
    });
    if (thisEnvFn.isClassProperty() || thisEnvFn.isClassPrivateProperty()) {
      if (arrowParent) {
        thisEnvFn = arrowParent;
      } else if (allowInsertArrow) {
        fnPath.replaceWith(callExpression(arrowFunctionExpression([], toExpression(fnPath.node)), []));
        thisEnvFn = fnPath.get("callee");
        fnPath = thisEnvFn.get("body");
      } else {
        throw fnPath.buildCodeFrameError("Unable to transform arrow inside class property");
      }
    }
    const {
      thisPaths,
      argumentsPaths,
      newTargetPaths,
      superProps,
      superCalls
    } = getScopeInformation(fnPath);
    if (inConstructor && superCalls.length > 0) {
      if (!allowInsertArrow) {
        throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', it's not possible to compile `super()` in an arrow function without compiling classes.\nPlease add '@babel/plugin-transform-classes' to your Babel configuration.");
      }
      if (!allowInsertArrowWithRest) {
        throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-parameters', it's not possible to compile `super()` in an arrow function with default or rest parameters without compiling classes.\nPlease add '@babel/plugin-transform-classes' to your Babel configuration.");
      }
      const allSuperCalls = [];
      thisEnvFn.traverse(getSuperCallsVisitor, {
        allSuperCalls
      });
      const superBinding = getSuperBinding(thisEnvFn);
      allSuperCalls.forEach((superCall) => {
        const callee = identifier(superBinding);
        callee.loc = superCall.node.callee.loc;
        superCall.get("callee").replaceWith(callee);
      });
    }
    if (argumentsPaths.length > 0) {
      const argumentsBinding = getBinding(thisEnvFn, "arguments", () => {
        const args = () => identifier("arguments");
        if (thisEnvFn.scope.path.isProgram()) {
          return conditionalExpression(binaryExpression("===", unaryExpression("typeof", args()), stringLiteral("undefined")), thisEnvFn.scope.buildUndefinedNode(), args());
        } else {
          return args();
        }
      });
      argumentsPaths.forEach((argumentsChild) => {
        const argsRef = identifier(argumentsBinding);
        argsRef.loc = argumentsChild.node.loc;
        argumentsChild.replaceWith(argsRef);
      });
    }
    if (newTargetPaths.length > 0) {
      const newTargetBinding = getBinding(thisEnvFn, "newtarget", () => metaProperty(identifier("new"), identifier("target")));
      newTargetPaths.forEach((targetChild) => {
        const targetRef = identifier(newTargetBinding);
        targetRef.loc = targetChild.node.loc;
        targetChild.replaceWith(targetRef);
      });
    }
    if (superProps.length > 0) {
      if (!allowInsertArrow) {
        throw superProps[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', it's not possible to compile `super.prop` in an arrow function without compiling classes.\nPlease add '@babel/plugin-transform-classes' to your Babel configuration.");
      }
      const flatSuperProps = superProps.reduce((acc, superProp) => acc.concat(standardizeSuperProperty(superProp)), []);
      flatSuperProps.forEach((superProp) => {
        const key = superProp.node.computed ? "" : superProp.get("property").node.name;
        const superParentPath = superProp.parentPath;
        const isAssignment = superParentPath.isAssignmentExpression({
          left: superProp.node
        });
        const isCall = superParentPath.isCallExpression({
          callee: superProp.node
        });
        const isTaggedTemplate = superParentPath.isTaggedTemplateExpression({
          tag: superProp.node
        });
        const superBinding = getSuperPropBinding(thisEnvFn, isAssignment, key);
        const args = [];
        if (superProp.node.computed) {
          args.push(superProp.get("property").node);
        }
        if (isAssignment) {
          const value = superParentPath.node.right;
          args.push(value);
        }
        const call = callExpression(identifier(superBinding), args);
        if (isCall) {
          superParentPath.unshiftContainer("arguments", thisExpression());
          superProp.replaceWith(memberExpression(call, identifier("call")));
          thisPaths.push(superParentPath.get("arguments.0"));
        } else if (isAssignment) {
          superParentPath.replaceWith(call);
        } else if (isTaggedTemplate) {
          superProp.replaceWith(callExpression(memberExpression(call, identifier("bind"), false), [thisExpression()]));
          thisPaths.push(superProp.get("arguments.0"));
        } else {
          superProp.replaceWith(call);
        }
      });
    }
    let thisBinding;
    if (thisPaths.length > 0 || !noNewArrows) {
      thisBinding = getThisBinding(thisEnvFn, inConstructor);
      if (noNewArrows || inConstructor && hasSuperClass(thisEnvFn)) {
        thisPaths.forEach((thisChild) => {
          const thisRef = thisChild.isJSX() ? jsxIdentifier(thisBinding) : identifier(thisBinding);
          thisRef.loc = thisChild.node.loc;
          thisChild.replaceWith(thisRef);
        });
        if (!noNewArrows)
          thisBinding = null;
      }
    }
    return {
      thisBinding,
      fnPath
    };
  }
  function isLogicalOp(op) {
    return LOGICAL_OPERATORS.includes(op);
  }
  function standardizeSuperProperty(superProp) {
    if (superProp.parentPath.isAssignmentExpression() && superProp.parentPath.node.operator !== "=") {
      const assignmentPath = superProp.parentPath;
      const op = assignmentPath.node.operator.slice(0, -1);
      const value = assignmentPath.node.right;
      const isLogicalAssignment = isLogicalOp(op);
      if (superProp.node.computed) {
        const tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
        const object = superProp.node.object;
        const property = superProp.node.property;
        assignmentPath.get("left").replaceWith(memberExpression(object, assignmentExpression("=", tmp, property), true));
        assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression(object, identifier(tmp.name), true), value));
      } else {
        const object = superProp.node.object;
        const property = superProp.node.property;
        assignmentPath.get("left").replaceWith(memberExpression(object, property));
        assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression(object, identifier(property.name)), value));
      }
      if (isLogicalAssignment) {
        assignmentPath.replaceWith(logicalExpression(op, assignmentPath.node.left, assignmentPath.node.right));
      } else {
        assignmentPath.node.operator = "=";
      }
      return [assignmentPath.get("left"), assignmentPath.get("right").get("left")];
    } else if (superProp.parentPath.isUpdateExpression()) {
      const updateExpr = superProp.parentPath;
      const tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
      const computedKey = superProp.node.computed ? superProp.scope.generateDeclaredUidIdentifier("prop") : null;
      const parts = [assignmentExpression("=", tmp, memberExpression(superProp.node.object, computedKey ? assignmentExpression("=", computedKey, superProp.node.property) : superProp.node.property, superProp.node.computed)), assignmentExpression("=", memberExpression(superProp.node.object, computedKey ? identifier(computedKey.name) : superProp.node.property, superProp.node.computed), binaryExpression(superProp.parentPath.node.operator[0], identifier(tmp.name), numericLiteral(1)))];
      if (!superProp.parentPath.node.prefix) {
        parts.push(identifier(tmp.name));
      }
      updateExpr.replaceWith(sequenceExpression(parts));
      const left = updateExpr.get("expressions.0.right");
      const right = updateExpr.get("expressions.1.left");
      return [left, right];
    }
    return [superProp];
    function rightExpression(op, left, right) {
      if (op === "=") {
        return assignmentExpression("=", left, right);
      } else {
        return binaryExpression(op, left, right);
      }
    }
  }
  function hasSuperClass(thisEnvFn) {
    return thisEnvFn.isClassMethod() && !!thisEnvFn.parentPath.parentPath.node.superClass;
  }
  var assignSuperThisVisitor = (0, _visitors.environmentVisitor)({
    CallExpression(child, {
      supers,
      thisBinding
    }) {
      if (!child.get("callee").isSuper())
        return;
      if (supers.has(child.node))
        return;
      supers.add(child.node);
      child.replaceWithMultiple([child.node, assignmentExpression("=", identifier(thisBinding), identifier("this"))]);
    }
  });
  function getThisBinding(thisEnvFn, inConstructor) {
    return getBinding(thisEnvFn, "this", (thisBinding) => {
      if (!inConstructor || !hasSuperClass(thisEnvFn))
        return thisExpression();
      thisEnvFn.traverse(assignSuperThisVisitor, {
        supers: new WeakSet,
        thisBinding
      });
    });
  }
  function getSuperBinding(thisEnvFn) {
    return getBinding(thisEnvFn, "supercall", () => {
      const argsBinding = thisEnvFn.scope.generateUidIdentifier("args");
      return arrowFunctionExpression([restElement(argsBinding)], callExpression(_super(), [spreadElement(identifier(argsBinding.name))]));
    });
  }
  function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
    const op = isAssignment ? "set" : "get";
    return getBinding(thisEnvFn, `superprop_${op}:${propName || ""}`, () => {
      const argsList = [];
      let fnBody;
      if (propName) {
        fnBody = memberExpression(_super(), identifier(propName));
      } else {
        const method = thisEnvFn.scope.generateUidIdentifier("prop");
        argsList.unshift(method);
        fnBody = memberExpression(_super(), identifier(method.name), true);
      }
      if (isAssignment) {
        const valueIdent = thisEnvFn.scope.generateUidIdentifier("value");
        argsList.push(valueIdent);
        fnBody = assignmentExpression("=", fnBody, identifier(valueIdent.name));
      }
      return arrowFunctionExpression(argsList, fnBody);
    });
  }
  function getBinding(thisEnvFn, key, init22) {
    const cacheKey = "binding:" + key;
    let data = thisEnvFn.getData(cacheKey);
    if (!data) {
      const id = thisEnvFn.scope.generateUidIdentifier(key);
      data = id.name;
      thisEnvFn.setData(cacheKey, data);
      thisEnvFn.scope.push({
        id,
        init: init22(data)
      });
    }
    return data;
  }
  var getScopeInformationVisitor = (0, _visitors.environmentVisitor)({
    ThisExpression(child, {
      thisPaths
    }) {
      thisPaths.push(child);
    },
    JSXIdentifier(child, {
      thisPaths
    }) {
      if (child.node.name !== "this")
        return;
      if (!child.parentPath.isJSXMemberExpression({
        object: child.node
      }) && !child.parentPath.isJSXOpeningElement({
        name: child.node
      })) {
        return;
      }
      thisPaths.push(child);
    },
    CallExpression(child, {
      superCalls
    }) {
      if (child.get("callee").isSuper())
        superCalls.push(child);
    },
    MemberExpression(child, {
      superProps
    }) {
      if (child.get("object").isSuper())
        superProps.push(child);
    },
    Identifier(child, {
      argumentsPaths
    }) {
      if (!child.isReferencedIdentifier({
        name: "arguments"
      }))
        return;
      let curr = child.scope;
      do {
        if (curr.hasOwnBinding("arguments")) {
          curr.rename("arguments");
          return;
        }
        if (curr.path.isFunction() && !curr.path.isArrowFunctionExpression()) {
          break;
        }
      } while (curr = curr.parent);
      argumentsPaths.push(child);
    },
    MetaProperty(child, {
      newTargetPaths
    }) {
      if (!child.get("meta").isIdentifier({
        name: "new"
      }))
        return;
      if (!child.get("property").isIdentifier({
        name: "target"
      }))
        return;
      newTargetPaths.push(child);
    }
  });
  function getScopeInformation(fnPath) {
    const thisPaths = [];
    const argumentsPaths = [];
    const newTargetPaths = [];
    const superProps = [];
    const superCalls = [];
    fnPath.traverse(getScopeInformationVisitor, {
      thisPaths,
      argumentsPaths,
      newTargetPaths,
      superProps,
      superCalls
    });
    return {
      thisPaths,
      argumentsPaths,
      newTargetPaths,
      superProps,
      superCalls
    };
  }
  function splitExportDeclaration() {
    if (!this.isExportDeclaration() || this.isExportAllDeclaration()) {
      throw new Error("Only default and named export declarations can be split.");
    }
    if (this.isExportNamedDeclaration() && this.get("specifiers").length > 0) {
      throw new Error("It doesn't make sense to split exported specifiers.");
    }
    const declaration = this.get("declaration");
    if (this.isExportDefaultDeclaration()) {
      const standaloneDeclaration = declaration.isFunctionDeclaration() || declaration.isClassDeclaration();
      const exportExpr = declaration.isFunctionExpression() || declaration.isClassExpression();
      const scope = declaration.isScope() ? declaration.scope.parent : declaration.scope;
      let id = declaration.node.id;
      let needBindingRegistration = false;
      if (!id) {
        needBindingRegistration = true;
        id = scope.generateUidIdentifier("default");
        if (standaloneDeclaration || exportExpr) {
          declaration.node.id = cloneNode(id);
        }
      } else if (exportExpr && scope.hasBinding(id.name)) {
        needBindingRegistration = true;
        id = scope.generateUidIdentifier(id.name);
      }
      const updatedDeclaration = standaloneDeclaration ? declaration.node : variableDeclaration("var", [variableDeclarator(cloneNode(id), declaration.node)]);
      const updatedExportDeclaration = exportNamedDeclaration(null, [exportSpecifier(cloneNode(id), identifier("default"))]);
      this.insertAfter(updatedExportDeclaration);
      this.replaceWith(updatedDeclaration);
      if (needBindingRegistration) {
        scope.registerDeclaration(this);
      }
      return this;
    } else if (this.get("specifiers").length > 0) {
      throw new Error("It doesn't make sense to split exported specifiers.");
    }
    const bindingIdentifiers = declaration.getOuterBindingIdentifiers();
    const specifiers = Object.keys(bindingIdentifiers).map((name) => {
      return exportSpecifier(identifier(name), identifier(name));
    });
    const aliasDeclar = exportNamedDeclaration(null, specifiers);
    this.insertAfter(aliasDeclar);
    this.replaceWith(declaration.node);
    return this;
  }
  var refersOuterBindingVisitor = {
    "ReferencedIdentifier|BindingIdentifier"(path3, state) {
      if (path3.node.name !== state.name)
        return;
      state.needsRename = true;
      path3.stop();
    },
    Scope(path3, state) {
      if (path3.scope.hasOwnBinding(state.name)) {
        path3.skip();
      }
    }
  };
  function ensureFunctionName(supportUnicodeId) {
    if (this.node.id)
      return this;
    const res = getFunctionName(this.node, this.parent);
    if (res == null)
      return this;
    let {
      name
    } = res;
    if (!supportUnicodeId && /[\uD800-\uDFFF]/.test(name)) {
      return null;
    }
    if (name.startsWith("get ") || name.startsWith("set ")) {
      return null;
    }
    name = toBindingIdentifierName(name.replace(/[/ ]/g, "_"));
    const id = identifier(name);
    inherits(id, res.originalNode);
    const state = {
      needsRename: false,
      name
    };
    const {
      scope
    } = this;
    const binding = scope.getOwnBinding(name);
    if (binding) {
      if (binding.kind === "param") {
        state.needsRename = true;
      } else {
      }
    } else if (scope.parent.hasBinding(name) || scope.hasGlobal(name)) {
      this.traverse(refersOuterBindingVisitor, state);
    }
    if (!state.needsRename) {
      this.node.id = id;
      scope.getProgramParent().references[id.name] = true;
      return this;
    }
    if (scope.hasBinding(id.name) && !scope.hasGlobal(id.name)) {
      scope.rename(id.name);
      this.node.id = id;
      scope.getProgramParent().references[id.name] = true;
      return this;
    }
    if (!isFunction22(this.node))
      return null;
    const key = scope.generateUidIdentifier(id.name);
    const params = [];
    for (let i = 0, len = getFunctionArity(this.node);i < len; i++) {
      params.push(scope.generateUidIdentifier("x"));
    }
    const call = _template.default.expression.ast`
    (function (${key}) {
      function ${id}(${params}) {
        return ${cloneNode(key)}.apply(this, arguments);
      }

      ${cloneNode(id)}.toString = function () {
        return ${cloneNode(key)}.toString();
      }

      return ${cloneNode(id)};
    })(${toExpression(this.node)})
  `;
    return this.replaceWith(call)[0].get("arguments.0");
  }
  function getFunctionArity(node) {
    const count = node.params.findIndex((param) => isAssignmentPattern(param) || isRestElement(param));
    return count === -1 ? node.params.length : count;
  }
});
var require_introspection = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports._guessExecutionStatusRelativeTo = _guessExecutionStatusRelativeTo;
  exports._resolve = _resolve;
  exports.canHaveVariableDeclarationOrExpression = canHaveVariableDeclarationOrExpression;
  exports.canSwapBetweenExpressionAndStatement = canSwapBetweenExpressionAndStatement;
  exports.getSource = getSource;
  exports.isCompletionRecord = isCompletionRecord;
  exports.isConstantExpression = isConstantExpression;
  exports.isInStrictMode = isInStrictMode;
  exports.isNodeType = isNodeType;
  exports.isStatementOrBlock = isStatementOrBlock;
  exports.isStatic = isStatic;
  exports.matchesPattern = matchesPattern;
  exports.referencesImport = referencesImport;
  exports.resolve = resolve23;
  exports.willIMaybeExecuteBefore = willIMaybeExecuteBefore;
  var _t = require_lib6();
  var {
    STATEMENT_OR_BLOCK_KEYS,
    VISITOR_KEYS,
    isBlockStatement,
    isExpression,
    isIdentifier,
    isLiteral,
    isStringLiteral,
    isType,
    matchesPattern: _matchesPattern
  } = _t;
  function matchesPattern(pattern, allowPartial) {
    return _matchesPattern(this.node, pattern, allowPartial);
  }
  {
    exports.has = function has(key) {
      var _this$node;
      const val2 = (_this$node = this.node) == null ? undefined : _this$node[key];
      if (val2 && Array.isArray(val2)) {
        return !!val2.length;
      } else {
        return !!val2;
      }
    };
  }
  function isStatic() {
    return this.scope.isStatic(this.node);
  }
  {
    exports.is = exports.has;
    exports.isnt = function isnt(key) {
      return !this.has(key);
    };
    exports.equals = function equals(key, value) {
      return this.node[key] === value;
    };
  }
  function isNodeType(type) {
    return isType(this.type, type);
  }
  function canHaveVariableDeclarationOrExpression() {
    return (this.key === "init" || this.key === "left") && this.parentPath.isFor();
  }
  function canSwapBetweenExpressionAndStatement(replacement) {
    if (this.key !== "body" || !this.parentPath.isArrowFunctionExpression()) {
      return false;
    }
    if (this.isExpression()) {
      return isBlockStatement(replacement);
    } else if (this.isBlockStatement()) {
      return isExpression(replacement);
    }
    return false;
  }
  function isCompletionRecord(allowInsideFunction) {
    let path3 = this;
    let first = true;
    do {
      const {
        type,
        container
      } = path3;
      if (!first && (path3.isFunction() || type === "StaticBlock")) {
        return !!allowInsideFunction;
      }
      first = false;
      if (Array.isArray(container) && path3.key !== container.length - 1) {
        return false;
      }
    } while ((path3 = path3.parentPath) && !path3.isProgram() && !path3.isDoExpression());
    return true;
  }
  function isStatementOrBlock() {
    if (this.parentPath.isLabeledStatement() || isBlockStatement(this.container)) {
      return false;
    } else {
      return STATEMENT_OR_BLOCK_KEYS.includes(this.key);
    }
  }
  function referencesImport(moduleSource, importName) {
    if (!this.isReferencedIdentifier()) {
      if (this.isJSXMemberExpression() && this.node.property.name === importName || (this.isMemberExpression() || this.isOptionalMemberExpression()) && (this.node.computed ? isStringLiteral(this.node.property, {
        value: importName
      }) : this.node.property.name === importName)) {
        const object = this.get("object");
        return object.isReferencedIdentifier() && object.referencesImport(moduleSource, "*");
      }
      return false;
    }
    const binding = this.scope.getBinding(this.node.name);
    if (!binding || binding.kind !== "module")
      return false;
    const path3 = binding.path;
    const parent = path3.parentPath;
    if (!parent.isImportDeclaration())
      return false;
    if (parent.node.source.value === moduleSource) {
      if (!importName)
        return true;
    } else {
      return false;
    }
    if (path3.isImportDefaultSpecifier() && importName === "default") {
      return true;
    }
    if (path3.isImportNamespaceSpecifier() && importName === "*") {
      return true;
    }
    if (path3.isImportSpecifier() && isIdentifier(path3.node.imported, {
      name: importName
    })) {
      return true;
    }
    return false;
  }
  function getSource() {
    const node = this.node;
    if (node.end) {
      const code = this.hub.getCode();
      if (code)
        return code.slice(node.start, node.end);
    }
    return "";
  }
  function willIMaybeExecuteBefore(target) {
    return this._guessExecutionStatusRelativeTo(target) !== "after";
  }
  function getOuterFunction(path3) {
    return path3.isProgram() ? path3 : (path3.parentPath.scope.getFunctionParent() || path3.parentPath.scope.getProgramParent()).path;
  }
  function isExecutionUncertain(type, key) {
    switch (type) {
      case "LogicalExpression":
        return key === "right";
      case "ConditionalExpression":
      case "IfStatement":
        return key === "consequent" || key === "alternate";
      case "WhileStatement":
      case "DoWhileStatement":
      case "ForInStatement":
      case "ForOfStatement":
        return key === "body";
      case "ForStatement":
        return key === "body" || key === "update";
      case "SwitchStatement":
        return key === "cases";
      case "TryStatement":
        return key === "handler";
      case "AssignmentPattern":
        return key === "right";
      case "OptionalMemberExpression":
        return key === "property";
      case "OptionalCallExpression":
        return key === "arguments";
      default:
        return false;
    }
  }
  function isExecutionUncertainInList(paths, maxIndex) {
    for (let i = 0;i < maxIndex; i++) {
      const path3 = paths[i];
      if (isExecutionUncertain(path3.parent.type, path3.parentKey)) {
        return true;
      }
    }
    return false;
  }
  var SYMBOL_CHECKING = Symbol();
  function _guessExecutionStatusRelativeTo(target) {
    return _guessExecutionStatusRelativeToCached(this, target, new Map);
  }
  function _guessExecutionStatusRelativeToCached(base, target, cache3) {
    const funcParent = {
      this: getOuterFunction(base),
      target: getOuterFunction(target)
    };
    if (funcParent.target.node !== funcParent.this.node) {
      return _guessExecutionStatusRelativeToDifferentFunctionsCached(base, funcParent.target, cache3);
    }
    const paths = {
      target: target.getAncestry(),
      this: base.getAncestry()
    };
    if (paths.target.includes(base))
      return "after";
    if (paths.this.includes(target))
      return "before";
    let commonPath;
    const commonIndex = {
      target: 0,
      this: 0
    };
    while (!commonPath && commonIndex.this < paths.this.length) {
      const path3 = paths.this[commonIndex.this];
      commonIndex.target = paths.target.indexOf(path3);
      if (commonIndex.target >= 0) {
        commonPath = path3;
      } else {
        commonIndex.this++;
      }
    }
    if (!commonPath) {
      throw new Error("Internal Babel error - The two compared nodes don't appear to belong to the same program.");
    }
    if (isExecutionUncertainInList(paths.this, commonIndex.this - 1) || isExecutionUncertainInList(paths.target, commonIndex.target - 1)) {
      return "unknown";
    }
    const divergence = {
      this: paths.this[commonIndex.this - 1],
      target: paths.target[commonIndex.target - 1]
    };
    if (divergence.target.listKey && divergence.this.listKey && divergence.target.container === divergence.this.container) {
      return divergence.target.key > divergence.this.key ? "before" : "after";
    }
    const keys = VISITOR_KEYS[commonPath.type];
    const keyPosition = {
      this: keys.indexOf(divergence.this.parentKey),
      target: keys.indexOf(divergence.target.parentKey)
    };
    return keyPosition.target > keyPosition.this ? "before" : "after";
  }
  function _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache3) {
    if (!target.isFunctionDeclaration()) {
      if (_guessExecutionStatusRelativeToCached(base, target, cache3) === "before") {
        return "before";
      }
      return "unknown";
    } else if (target.parentPath.isExportDeclaration()) {
      return "unknown";
    }
    const binding = target.scope.getBinding(target.node.id.name);
    if (!binding.references)
      return "before";
    const referencePaths = binding.referencePaths;
    let allStatus;
    for (const path3 of referencePaths) {
      const childOfFunction = !!path3.find((path42) => path42.node === target.node);
      if (childOfFunction)
        continue;
      if (path3.key !== "callee" || !path3.parentPath.isCallExpression()) {
        return "unknown";
      }
      const status = _guessExecutionStatusRelativeToCached(base, path3, cache3);
      if (allStatus && allStatus !== status) {
        return "unknown";
      } else {
        allStatus = status;
      }
    }
    return allStatus;
  }
  function _guessExecutionStatusRelativeToDifferentFunctionsCached(base, target, cache3) {
    let nodeMap = cache3.get(base.node);
    let cached;
    if (!nodeMap) {
      cache3.set(base.node, nodeMap = new Map);
    } else if (cached = nodeMap.get(target.node)) {
      if (cached === SYMBOL_CHECKING) {
        return "unknown";
      }
      return cached;
    }
    nodeMap.set(target.node, SYMBOL_CHECKING);
    const result2 = _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache3);
    nodeMap.set(target.node, result2);
    return result2;
  }
  function resolve23(dangerous, resolved) {
    return _resolve.call(this, dangerous, resolved) || this;
  }
  function _resolve(dangerous, resolved) {
    var _resolved;
    if ((_resolved = resolved) != null && _resolved.includes(this))
      return;
    resolved = resolved || [];
    resolved.push(this);
    if (this.isVariableDeclarator()) {
      if (this.get("id").isIdentifier()) {
        return this.get("init").resolve(dangerous, resolved);
      } else {
      }
    } else if (this.isReferencedIdentifier()) {
      const binding = this.scope.getBinding(this.node.name);
      if (!binding)
        return;
      if (!binding.constant)
        return;
      if (binding.kind === "module")
        return;
      if (binding.path !== this) {
        const ret = binding.path.resolve(dangerous, resolved);
        if (this.find((parent) => parent.node === ret.node))
          return;
        return ret;
      }
    } else if (this.isTypeCastExpression()) {
      return this.get("expression").resolve(dangerous, resolved);
    } else if (dangerous && this.isMemberExpression()) {
      const targetKey = this.toComputedKey();
      if (!isLiteral(targetKey))
        return;
      const targetName = targetKey.value;
      const target = this.get("object").resolve(dangerous, resolved);
      if (target.isObjectExpression()) {
        const props = target.get("properties");
        for (const prop of props) {
          if (!prop.isProperty())
            continue;
          const key = prop.get("key");
          let match = prop.isnt("computed") && key.isIdentifier({
            name: targetName
          });
          match = match || key.isLiteral({
            value: targetName
          });
          if (match)
            return prop.get("value").resolve(dangerous, resolved);
        }
      } else if (target.isArrayExpression() && !isNaN(+targetName)) {
        const elems = target.get("elements");
        const elem = elems[targetName];
        if (elem)
          return elem.resolve(dangerous, resolved);
      }
    }
  }
  function isConstantExpression() {
    if (this.isIdentifier()) {
      const binding = this.scope.getBinding(this.node.name);
      if (!binding)
        return false;
      return binding.constant;
    }
    if (this.isLiteral()) {
      if (this.isRegExpLiteral()) {
        return false;
      }
      if (this.isTemplateLiteral()) {
        return this.get("expressions").every((expression) => expression.isConstantExpression());
      }
      return true;
    }
    if (this.isUnaryExpression()) {
      if (this.node.operator !== "void") {
        return false;
      }
      return this.get("argument").isConstantExpression();
    }
    if (this.isBinaryExpression()) {
      const {
        operator
      } = this.node;
      return operator !== "in" && operator !== "instanceof" && this.get("left").isConstantExpression() && this.get("right").isConstantExpression();
    }
    if (this.isMemberExpression()) {
      return !this.node.computed && this.get("object").isIdentifier({
        name: "Symbol"
      }) && !this.scope.hasBinding("Symbol", {
        noGlobals: true
      });
    }
    if (this.isCallExpression()) {
      return this.node.arguments.length === 1 && this.get("callee").matchesPattern("Symbol.for") && !this.scope.hasBinding("Symbol", {
        noGlobals: true
      }) && this.get("arguments")[0].isStringLiteral();
    }
    return false;
  }
  function isInStrictMode() {
    const start = this.isProgram() ? this : this.parentPath;
    const strictParent = start.find((path3) => {
      if (path3.isProgram({
        sourceType: "module"
      }))
        return true;
      if (path3.isClass())
        return true;
      if (path3.isArrowFunctionExpression() && !path3.get("body").isBlockStatement()) {
        return false;
      }
      let body;
      if (path3.isFunction()) {
        body = path3.node.body;
      } else if (path3.isProgram()) {
        body = path3.node;
      } else {
        return false;
      }
      for (const directive of body.directives) {
        if (directive.value.value === "use strict") {
          return true;
        }
      }
    });
    return !!strictParent;
  }
});
var require_family = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports._getKey = _getKey;
  exports._getPattern = _getPattern;
  exports.get = get;
  exports.getAllNextSiblings = getAllNextSiblings;
  exports.getAllPrevSiblings = getAllPrevSiblings;
  exports.getAssignmentIdentifiers = getAssignmentIdentifiers;
  exports.getBindingIdentifierPaths = getBindingIdentifierPaths;
  exports.getBindingIdentifiers = getBindingIdentifiers;
  exports.getCompletionRecords = getCompletionRecords;
  exports.getNextSibling = getNextSibling;
  exports.getOpposite = getOpposite;
  exports.getOuterBindingIdentifierPaths = getOuterBindingIdentifierPaths;
  exports.getOuterBindingIdentifiers = getOuterBindingIdentifiers;
  exports.getPrevSibling = getPrevSibling;
  exports.getSibling = getSibling;
  var _index = require_path();
  var _t = require_lib6();
  var {
    getAssignmentIdentifiers: _getAssignmentIdentifiers,
    getBindingIdentifiers: _getBindingIdentifiers,
    getOuterBindingIdentifiers: _getOuterBindingIdentifiers,
    numericLiteral,
    unaryExpression
  } = _t;
  var NORMAL_COMPLETION = 0;
  var BREAK_COMPLETION = 1;
  function NormalCompletion(path3) {
    return {
      type: NORMAL_COMPLETION,
      path: path3
    };
  }
  function BreakCompletion(path3) {
    return {
      type: BREAK_COMPLETION,
      path: path3
    };
  }
  function getOpposite() {
    if (this.key === "left") {
      return this.getSibling("right");
    } else if (this.key === "right") {
      return this.getSibling("left");
    }
    return null;
  }
  function addCompletionRecords(path3, records, context) {
    if (path3) {
      records.push(..._getCompletionRecords(path3, context));
    }
    return records;
  }
  function completionRecordForSwitch(cases, records, context) {
    let lastNormalCompletions = [];
    for (let i = 0;i < cases.length; i++) {
      const casePath = cases[i];
      const caseCompletions = _getCompletionRecords(casePath, context);
      const normalCompletions = [];
      const breakCompletions = [];
      for (const c22 of caseCompletions) {
        if (c22.type === NORMAL_COMPLETION) {
          normalCompletions.push(c22);
        }
        if (c22.type === BREAK_COMPLETION) {
          breakCompletions.push(c22);
        }
      }
      if (normalCompletions.length) {
        lastNormalCompletions = normalCompletions;
      }
      records.push(...breakCompletions);
    }
    records.push(...lastNormalCompletions);
    return records;
  }
  function normalCompletionToBreak(completions) {
    completions.forEach((c22) => {
      c22.type = BREAK_COMPLETION;
    });
  }
  function replaceBreakStatementInBreakCompletion(completions, reachable) {
    completions.forEach((c22) => {
      if (c22.path.isBreakStatement({
        label: null
      })) {
        if (reachable) {
          c22.path.replaceWith(unaryExpression("void", numericLiteral(0)));
        } else {
          c22.path.remove();
        }
      }
    });
  }
  function getStatementListCompletion(paths, context) {
    const completions = [];
    if (context.canHaveBreak) {
      let lastNormalCompletions = [];
      for (let i = 0;i < paths.length; i++) {
        const path3 = paths[i];
        const newContext = Object.assign({}, context, {
          inCaseClause: false
        });
        if (path3.isBlockStatement() && (context.inCaseClause || context.shouldPopulateBreak)) {
          newContext.shouldPopulateBreak = true;
        } else {
          newContext.shouldPopulateBreak = false;
        }
        const statementCompletions = _getCompletionRecords(path3, newContext);
        if (statementCompletions.length > 0 && statementCompletions.every((c22) => c22.type === BREAK_COMPLETION)) {
          if (lastNormalCompletions.length > 0 && statementCompletions.every((c22) => c22.path.isBreakStatement({
            label: null
          }))) {
            normalCompletionToBreak(lastNormalCompletions);
            completions.push(...lastNormalCompletions);
            if (lastNormalCompletions.some((c22) => c22.path.isDeclaration())) {
              completions.push(...statementCompletions);
              replaceBreakStatementInBreakCompletion(statementCompletions, true);
            }
            replaceBreakStatementInBreakCompletion(statementCompletions, false);
          } else {
            completions.push(...statementCompletions);
            if (!context.shouldPopulateBreak) {
              replaceBreakStatementInBreakCompletion(statementCompletions, true);
            }
          }
          break;
        }
        if (i === paths.length - 1) {
          completions.push(...statementCompletions);
        } else {
          lastNormalCompletions = [];
          for (let i2 = 0;i2 < statementCompletions.length; i2++) {
            const c22 = statementCompletions[i2];
            if (c22.type === BREAK_COMPLETION) {
              completions.push(c22);
            }
            if (c22.type === NORMAL_COMPLETION) {
              lastNormalCompletions.push(c22);
            }
          }
        }
      }
    } else if (paths.length) {
      for (let i = paths.length - 1;i >= 0; i--) {
        const pathCompletions = _getCompletionRecords(paths[i], context);
        if (pathCompletions.length > 1 || pathCompletions.length === 1 && !pathCompletions[0].path.isVariableDeclaration()) {
          completions.push(...pathCompletions);
          break;
        }
      }
    }
    return completions;
  }
  function _getCompletionRecords(path3, context) {
    let records = [];
    if (path3.isIfStatement()) {
      records = addCompletionRecords(path3.get("consequent"), records, context);
      records = addCompletionRecords(path3.get("alternate"), records, context);
    } else if (path3.isDoExpression() || path3.isFor() || path3.isWhile() || path3.isLabeledStatement()) {
      return addCompletionRecords(path3.get("body"), records, context);
    } else if (path3.isProgram() || path3.isBlockStatement()) {
      return getStatementListCompletion(path3.get("body"), context);
    } else if (path3.isFunction()) {
      return _getCompletionRecords(path3.get("body"), context);
    } else if (path3.isTryStatement()) {
      records = addCompletionRecords(path3.get("block"), records, context);
      records = addCompletionRecords(path3.get("handler"), records, context);
    } else if (path3.isCatchClause()) {
      return addCompletionRecords(path3.get("body"), records, context);
    } else if (path3.isSwitchStatement()) {
      return completionRecordForSwitch(path3.get("cases"), records, context);
    } else if (path3.isSwitchCase()) {
      return getStatementListCompletion(path3.get("consequent"), {
        canHaveBreak: true,
        shouldPopulateBreak: false,
        inCaseClause: true
      });
    } else if (path3.isBreakStatement()) {
      records.push(BreakCompletion(path3));
    } else {
      records.push(NormalCompletion(path3));
    }
    return records;
  }
  function getCompletionRecords() {
    const records = _getCompletionRecords(this, {
      canHaveBreak: false,
      shouldPopulateBreak: false,
      inCaseClause: false
    });
    return records.map((r22) => r22.path);
  }
  function getSibling(key) {
    return _index.default.get({
      parentPath: this.parentPath,
      parent: this.parent,
      container: this.container,
      listKey: this.listKey,
      key
    }).setContext(this.context);
  }
  function getPrevSibling() {
    return this.getSibling(this.key - 1);
  }
  function getNextSibling() {
    return this.getSibling(this.key + 1);
  }
  function getAllNextSiblings() {
    let _key = this.key;
    let sibling = this.getSibling(++_key);
    const siblings = [];
    while (sibling.node) {
      siblings.push(sibling);
      sibling = this.getSibling(++_key);
    }
    return siblings;
  }
  function getAllPrevSiblings() {
    let _key = this.key;
    let sibling = this.getSibling(--_key);
    const siblings = [];
    while (sibling.node) {
      siblings.push(sibling);
      sibling = this.getSibling(--_key);
    }
    return siblings;
  }
  function get(key, context = true) {
    if (context === true)
      context = this.context;
    const parts = key.split(".");
    if (parts.length === 1) {
      return _getKey.call(this, key, context);
    } else {
      return _getPattern.call(this, parts, context);
    }
  }
  function _getKey(key, context) {
    const node = this.node;
    const container = node[key];
    if (Array.isArray(container)) {
      return container.map((_22, i) => {
        return _index.default.get({
          listKey: key,
          parentPath: this,
          parent: node,
          container,
          key: i
        }).setContext(context);
      });
    } else {
      return _index.default.get({
        parentPath: this,
        parent: node,
        container: node,
        key
      }).setContext(context);
    }
  }
  function _getPattern(parts, context) {
    let path3 = this;
    for (const part of parts) {
      if (part === ".") {
        path3 = path3.parentPath;
      } else {
        if (Array.isArray(path3)) {
          path3 = path3[part];
        } else {
          path3 = path3.get(part, context);
        }
      }
    }
    return path3;
  }
  function getAssignmentIdentifiers() {
    return _getAssignmentIdentifiers(this.node);
  }
  function getBindingIdentifiers(duplicates) {
    return _getBindingIdentifiers(this.node, duplicates);
  }
  function getOuterBindingIdentifiers(duplicates) {
    return _getOuterBindingIdentifiers(this.node, duplicates);
  }
  function getBindingIdentifierPaths(duplicates = false, outerOnly = false) {
    const path3 = this;
    const search = [path3];
    const ids = Object.create(null);
    while (search.length) {
      const id = search.shift();
      if (!id)
        continue;
      if (!id.node)
        continue;
      const keys = _getBindingIdentifiers.keys[id.node.type];
      if (id.isIdentifier()) {
        if (duplicates) {
          const _ids = ids[id.node.name] = ids[id.node.name] || [];
          _ids.push(id);
        } else {
          ids[id.node.name] = id;
        }
        continue;
      }
      if (id.isExportDeclaration()) {
        const declaration = id.get("declaration");
        if (declaration.isDeclaration()) {
          search.push(declaration);
        }
        continue;
      }
      if (outerOnly) {
        if (id.isFunctionDeclaration()) {
          search.push(id.get("id"));
          continue;
        }
        if (id.isFunctionExpression()) {
          continue;
        }
      }
      if (keys) {
        for (let i = 0;i < keys.length; i++) {
          const key = keys[i];
          const child = id.get(key);
          if (Array.isArray(child)) {
            search.push(...child);
          } else if (child.node) {
            search.push(child);
          }
        }
      }
    }
    return ids;
  }
  function getOuterBindingIdentifierPaths(duplicates = false) {
    return this.getBindingIdentifierPaths(duplicates, true);
  }
});
var require_comments = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.addComment = addComment;
  exports.addComments = addComments;
  exports.shareCommentsWithSiblings = shareCommentsWithSiblings;
  var _t = require_lib6();
  var {
    addComment: _addComment,
    addComments: _addComments
  } = _t;
  function shareCommentsWithSiblings() {
    if (typeof this.key === "string")
      return;
    const node = this.node;
    if (!node)
      return;
    const trailing = node.trailingComments;
    const leading = node.leadingComments;
    if (!trailing && !leading)
      return;
    const prev = this.getSibling(this.key - 1);
    const next = this.getSibling(this.key + 1);
    const hasPrev = Boolean(prev.node);
    const hasNext = Boolean(next.node);
    if (hasPrev) {
      if (leading) {
        prev.addComments("trailing", removeIfExisting(leading, prev.node.trailingComments));
      }
      if (trailing && !hasNext)
        prev.addComments("trailing", trailing);
    }
    if (hasNext) {
      if (trailing) {
        next.addComments("leading", removeIfExisting(trailing, next.node.leadingComments));
      }
      if (leading && !hasPrev)
        next.addComments("leading", leading);
    }
  }
  function removeIfExisting(list, toRemove) {
    if (!(toRemove != null && toRemove.length))
      return list;
    const set = new Set(toRemove);
    return list.filter((el) => {
      return !set.has(el);
    });
  }
  function addComment(type, content, line) {
    _addComment(this.node, type, content, line);
  }
  function addComments(type, comments) {
    _addComments(this.node, type, comments);
  }
});
var require_path = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = exports.SHOULD_STOP = exports.SHOULD_SKIP = exports.REMOVED = undefined;
  var virtualTypes = require_virtual_types();
  var _debug = require_src22();
  var _index = require_lib11();
  var _index2 = require_scope();
  var _t = require_lib6();
  var t = _t;
  var cache3 = require_cache();
  var _generator = require_lib7();
  var NodePath_ancestry = require_ancestry();
  var NodePath_inference = require_inference();
  var NodePath_replacement = require_replacement();
  var NodePath_evaluation = require_evaluation();
  var NodePath_conversion = require_conversion();
  var NodePath_introspection = require_introspection();
  var _context = require_context2();
  var NodePath_context = _context;
  var NodePath_removal = require_removal();
  var NodePath_modification = require_modification();
  var NodePath_family = require_family();
  var NodePath_comments = require_comments();
  var NodePath_virtual_types_validator = require_virtual_types_validator();
  var {
    validate: validate2
  } = _t;
  var debug = _debug("babel");
  var REMOVED = exports.REMOVED = 1;
  var SHOULD_STOP = exports.SHOULD_STOP = 2;
  var SHOULD_SKIP = exports.SHOULD_SKIP = 4;
  var NodePath_Final = exports.default = class NodePath {
    constructor(hub, parent) {
      this.contexts = [];
      this.state = null;
      this.opts = null;
      this._traverseFlags = 0;
      this.skipKeys = null;
      this.parentPath = null;
      this.container = null;
      this.listKey = null;
      this.key = null;
      this.node = null;
      this.type = null;
      this.parent = parent;
      this.hub = hub;
      this.data = null;
      this.context = null;
      this.scope = null;
    }
    get removed() {
      return (this._traverseFlags & 1) > 0;
    }
    set removed(v22) {
      if (v22)
        this._traverseFlags |= 1;
      else
        this._traverseFlags &= -2;
    }
    get shouldStop() {
      return (this._traverseFlags & 2) > 0;
    }
    set shouldStop(v22) {
      if (v22)
        this._traverseFlags |= 2;
      else
        this._traverseFlags &= -3;
    }
    get shouldSkip() {
      return (this._traverseFlags & 4) > 0;
    }
    set shouldSkip(v22) {
      if (v22)
        this._traverseFlags |= 4;
      else
        this._traverseFlags &= -5;
    }
    static get({
      hub,
      parentPath,
      parent,
      container,
      listKey,
      key
    }) {
      if (!hub && parentPath) {
        hub = parentPath.hub;
      }
      if (!parent) {
        throw new Error("To get a node path the parent needs to exist");
      }
      const targetNode = container[key];
      const paths = cache3.getOrCreateCachedPaths(hub, parent);
      let path3 = paths.get(targetNode);
      if (!path3) {
        path3 = new NodePath(hub, parent);
        if (targetNode)
          paths.set(targetNode, path3);
      }
      _context.setup.call(path3, parentPath, container, listKey, key);
      return path3;
    }
    getScope(scope) {
      return this.isScope() ? new _index2.default(this) : scope;
    }
    setData(key, val2) {
      if (this.data == null) {
        this.data = Object.create(null);
      }
      return this.data[key] = val2;
    }
    getData(key, def) {
      if (this.data == null) {
        this.data = Object.create(null);
      }
      let val2 = this.data[key];
      if (val2 === undefined && def !== undefined)
        val2 = this.data[key] = def;
      return val2;
    }
    hasNode() {
      return this.node != null;
    }
    buildCodeFrameError(msg, Error2 = SyntaxError) {
      return this.hub.buildError(this.node, msg, Error2);
    }
    traverse(visitor, state) {
      (0, _index.default)(this.node, visitor, this.scope, state, this);
    }
    set(key, node) {
      validate2(this.node, key, node);
      this.node[key] = node;
    }
    getPathLocation() {
      const parts = [];
      let path3 = this;
      do {
        let key = path3.key;
        if (path3.inList)
          key = `${path3.listKey}[${key}]`;
        parts.unshift(key);
      } while (path3 = path3.parentPath);
      return parts.join(".");
    }
    debug(message) {
      if (!debug.enabled)
        return;
      debug(`${this.getPathLocation()} ${this.type}: ${message}`);
    }
    toString() {
      return (0, _generator.default)(this.node).code;
    }
    get inList() {
      return !!this.listKey;
    }
    set inList(inList) {
      if (!inList) {
        this.listKey = null;
      }
    }
    get parentKey() {
      return this.listKey || this.key;
    }
  };
  var methods = {
    findParent: NodePath_ancestry.findParent,
    find: NodePath_ancestry.find,
    getFunctionParent: NodePath_ancestry.getFunctionParent,
    getStatementParent: NodePath_ancestry.getStatementParent,
    getEarliestCommonAncestorFrom: NodePath_ancestry.getEarliestCommonAncestorFrom,
    getDeepestCommonAncestorFrom: NodePath_ancestry.getDeepestCommonAncestorFrom,
    getAncestry: NodePath_ancestry.getAncestry,
    isAncestor: NodePath_ancestry.isAncestor,
    isDescendant: NodePath_ancestry.isDescendant,
    inType: NodePath_ancestry.inType,
    getTypeAnnotation: NodePath_inference.getTypeAnnotation,
    isBaseType: NodePath_inference.isBaseType,
    couldBeBaseType: NodePath_inference.couldBeBaseType,
    baseTypeStrictlyMatches: NodePath_inference.baseTypeStrictlyMatches,
    isGenericType: NodePath_inference.isGenericType,
    replaceWithMultiple: NodePath_replacement.replaceWithMultiple,
    replaceWithSourceString: NodePath_replacement.replaceWithSourceString,
    replaceWith: NodePath_replacement.replaceWith,
    replaceExpressionWithStatements: NodePath_replacement.replaceExpressionWithStatements,
    replaceInline: NodePath_replacement.replaceInline,
    evaluateTruthy: NodePath_evaluation.evaluateTruthy,
    evaluate: NodePath_evaluation.evaluate,
    toComputedKey: NodePath_conversion.toComputedKey,
    ensureBlock: NodePath_conversion.ensureBlock,
    unwrapFunctionEnvironment: NodePath_conversion.unwrapFunctionEnvironment,
    arrowFunctionToExpression: NodePath_conversion.arrowFunctionToExpression,
    splitExportDeclaration: NodePath_conversion.splitExportDeclaration,
    ensureFunctionName: NodePath_conversion.ensureFunctionName,
    matchesPattern: NodePath_introspection.matchesPattern,
    isStatic: NodePath_introspection.isStatic,
    isNodeType: NodePath_introspection.isNodeType,
    canHaveVariableDeclarationOrExpression: NodePath_introspection.canHaveVariableDeclarationOrExpression,
    canSwapBetweenExpressionAndStatement: NodePath_introspection.canSwapBetweenExpressionAndStatement,
    isCompletionRecord: NodePath_introspection.isCompletionRecord,
    isStatementOrBlock: NodePath_introspection.isStatementOrBlock,
    referencesImport: NodePath_introspection.referencesImport,
    getSource: NodePath_introspection.getSource,
    willIMaybeExecuteBefore: NodePath_introspection.willIMaybeExecuteBefore,
    _guessExecutionStatusRelativeTo: NodePath_introspection._guessExecutionStatusRelativeTo,
    resolve: NodePath_introspection.resolve,
    isConstantExpression: NodePath_introspection.isConstantExpression,
    isInStrictMode: NodePath_introspection.isInStrictMode,
    isDenylisted: NodePath_context.isDenylisted,
    visit: NodePath_context.visit,
    skip: NodePath_context.skip,
    skipKey: NodePath_context.skipKey,
    stop: NodePath_context.stop,
    setContext: NodePath_context.setContext,
    requeue: NodePath_context.requeue,
    requeueComputedKeyAndDecorators: NodePath_context.requeueComputedKeyAndDecorators,
    remove: NodePath_removal.remove,
    insertBefore: NodePath_modification.insertBefore,
    insertAfter: NodePath_modification.insertAfter,
    unshiftContainer: NodePath_modification.unshiftContainer,
    pushContainer: NodePath_modification.pushContainer,
    getOpposite: NodePath_family.getOpposite,
    getCompletionRecords: NodePath_family.getCompletionRecords,
    getSibling: NodePath_family.getSibling,
    getPrevSibling: NodePath_family.getPrevSibling,
    getNextSibling: NodePath_family.getNextSibling,
    getAllNextSiblings: NodePath_family.getAllNextSiblings,
    getAllPrevSiblings: NodePath_family.getAllPrevSiblings,
    get: NodePath_family.get,
    getAssignmentIdentifiers: NodePath_family.getAssignmentIdentifiers,
    getBindingIdentifiers: NodePath_family.getBindingIdentifiers,
    getOuterBindingIdentifiers: NodePath_family.getOuterBindingIdentifiers,
    getBindingIdentifierPaths: NodePath_family.getBindingIdentifierPaths,
    getOuterBindingIdentifierPaths: NodePath_family.getOuterBindingIdentifierPaths,
    shareCommentsWithSiblings: NodePath_comments.shareCommentsWithSiblings,
    addComment: NodePath_comments.addComment,
    addComments: NodePath_comments.addComments
  };
  Object.assign(NodePath_Final.prototype, methods);
  {
    NodePath_Final.prototype.arrowFunctionToShadowed = NodePath_conversion[String("arrowFunctionToShadowed")];
    Object.assign(NodePath_Final.prototype, {
      has: NodePath_introspection[String("has")],
      is: NodePath_introspection[String("is")],
      isnt: NodePath_introspection[String("isnt")],
      equals: NodePath_introspection[String("equals")],
      hoist: NodePath_modification[String("hoist")],
      updateSiblingKeys: NodePath_modification.updateSiblingKeys,
      call: NodePath_context.call,
      isBlacklisted: NodePath_context[String("isBlacklisted")],
      setScope: NodePath_context.setScope,
      resync: NodePath_context.resync,
      popContext: NodePath_context.popContext,
      pushContext: NodePath_context.pushContext,
      setup: NodePath_context.setup,
      setKey: NodePath_context.setKey
    });
  }
  {
    NodePath_Final.prototype._guessExecutionStatusRelativeToDifferentFunctions = NodePath_introspection._guessExecutionStatusRelativeTo;
    NodePath_Final.prototype._guessExecutionStatusRelativeToDifferentFunctions = NodePath_introspection._guessExecutionStatusRelativeTo;
    Object.assign(NodePath_Final.prototype, {
      _getTypeAnnotation: NodePath_inference._getTypeAnnotation,
      _replaceWith: NodePath_replacement._replaceWith,
      _resolve: NodePath_introspection._resolve,
      _call: NodePath_context._call,
      _resyncParent: NodePath_context._resyncParent,
      _resyncKey: NodePath_context._resyncKey,
      _resyncList: NodePath_context._resyncList,
      _resyncRemoved: NodePath_context._resyncRemoved,
      _getQueueContexts: NodePath_context._getQueueContexts,
      _removeFromScope: NodePath_removal._removeFromScope,
      _callRemovalHooks: NodePath_removal._callRemovalHooks,
      _remove: NodePath_removal._remove,
      _markRemoved: NodePath_removal._markRemoved,
      _assertUnremoved: NodePath_removal._assertUnremoved,
      _containerInsert: NodePath_modification._containerInsert,
      _containerInsertBefore: NodePath_modification._containerInsertBefore,
      _containerInsertAfter: NodePath_modification._containerInsertAfter,
      _verifyNodeList: NodePath_modification._verifyNodeList,
      _getKey: NodePath_family._getKey,
      _getPattern: NodePath_family._getPattern
    });
  }
  for (const type of t.TYPES) {
    const typeKey = `is${type}`;
    const fn = t[typeKey];
    NodePath_Final.prototype[typeKey] = function(opts) {
      return fn(this.node, opts);
    };
    NodePath_Final.prototype[`assert${type}`] = function(opts) {
      if (!fn(this.node, opts)) {
        throw new TypeError(`Expected node path of type ${type}`);
      }
    };
  }
  Object.assign(NodePath_Final.prototype, NodePath_virtual_types_validator);
  for (const type of Object.keys(virtualTypes)) {
    if (type[0] === "_")
      continue;
    if (!t.TYPES.includes(type))
      t.TYPES.push(type);
  }
});
var require_context = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _index = require_path();
  var _t = require_lib6();
  var _context = require_context2();
  var {
    VISITOR_KEYS
  } = _t;

  class TraversalContext {
    constructor(scope, opts, state, parentPath) {
      this.queue = null;
      this.priorityQueue = null;
      this.parentPath = parentPath;
      this.scope = scope;
      this.state = state;
      this.opts = opts;
    }
    shouldVisit(node) {
      const opts = this.opts;
      if (opts.enter || opts.exit)
        return true;
      if (opts[node.type])
        return true;
      const keys = VISITOR_KEYS[node.type];
      if (!(keys != null && keys.length))
        return false;
      for (const key of keys) {
        if (node[key]) {
          return true;
        }
      }
      return false;
    }
    create(node, container, key, listKey) {
      return _index.default.get({
        parentPath: this.parentPath,
        parent: node,
        container,
        key,
        listKey
      });
    }
    maybeQueue(path3, notPriority) {
      if (this.queue) {
        if (notPriority) {
          this.queue.push(path3);
        } else {
          this.priorityQueue.push(path3);
        }
      }
    }
    visitMultiple(container, parent, listKey) {
      if (container.length === 0)
        return false;
      const queue4 = [];
      for (let key = 0;key < container.length; key++) {
        const node = container[key];
        if (node && this.shouldVisit(node)) {
          queue4.push(this.create(parent, container, key, listKey));
        }
      }
      return this.visitQueue(queue4);
    }
    visitSingle(node, key) {
      if (this.shouldVisit(node[key])) {
        return this.visitQueue([this.create(node, node, key)]);
      } else {
        return false;
      }
    }
    visitQueue(queue4) {
      this.queue = queue4;
      this.priorityQueue = [];
      const visited = new WeakSet;
      let stop = false;
      let visitIndex = 0;
      for (;visitIndex < queue4.length; ) {
        const path3 = queue4[visitIndex];
        visitIndex++;
        _context.resync.call(path3);
        if (path3.contexts.length === 0 || path3.contexts[path3.contexts.length - 1] !== this) {
          _context.pushContext.call(path3, this);
        }
        if (path3.key === null)
          continue;
        const {
          node
        } = path3;
        if (visited.has(node))
          continue;
        if (node)
          visited.add(node);
        if (path3.visit()) {
          stop = true;
          break;
        }
        if (this.priorityQueue.length) {
          stop = this.visitQueue(this.priorityQueue);
          this.priorityQueue = [];
          this.queue = queue4;
          if (stop)
            break;
        }
      }
      for (let i = 0;i < visitIndex; i++) {
        _context.popContext.call(queue4[i]);
      }
      this.queue = null;
      return stop;
    }
    visit(node, key) {
      const nodes = node[key];
      if (!nodes)
        return false;
      if (Array.isArray(nodes)) {
        return this.visitMultiple(nodes, node, key);
      } else {
        return this.visitSingle(node, key);
      }
    }
  }
  exports.default = TraversalContext;
});
var require_traverse_node = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.traverseNode = traverseNode;
  var _context = require_context();
  var _t = require_lib6();
  var {
    VISITOR_KEYS
  } = _t;
  function traverseNode(node, opts, scope, state, path3, skipKeys, visitSelf) {
    const keys = VISITOR_KEYS[node.type];
    if (!keys)
      return false;
    const context = new _context.default(scope, opts, state, path3);
    if (visitSelf) {
      if (skipKeys != null && skipKeys[path3.parentKey])
        return false;
      return context.visitQueue([path3]);
    }
    for (const key of keys) {
      if (skipKeys != null && skipKeys[key])
        continue;
      if (context.visit(node, key)) {
        return true;
      }
    }
    return false;
  }
});
var require_context2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports._call = _call;
  exports._getQueueContexts = _getQueueContexts;
  exports._resyncKey = _resyncKey;
  exports._resyncList = _resyncList;
  exports._resyncParent = _resyncParent;
  exports._resyncRemoved = _resyncRemoved;
  exports.call = call;
  exports.isDenylisted = isDenylisted;
  exports.popContext = popContext;
  exports.pushContext = pushContext;
  exports.requeue = requeue;
  exports.requeueComputedKeyAndDecorators = requeueComputedKeyAndDecorators;
  exports.resync = resync;
  exports.setContext = setContext;
  exports.setKey = setKey;
  exports.setScope = setScope;
  exports.setup = setup;
  exports.skip = skip;
  exports.skipKey = skipKey;
  exports.stop = stop;
  exports.visit = visit;
  var _traverseNode = require_traverse_node();
  var _index = require_path();
  var _removal = require_removal();
  var t = require_lib6();
  function call(key) {
    const opts = this.opts;
    this.debug(key);
    if (this.node) {
      if (_call.call(this, opts[key]))
        return true;
    }
    if (this.node) {
      var _opts$this$node$type;
      return _call.call(this, (_opts$this$node$type = opts[this.node.type]) == null ? undefined : _opts$this$node$type[key]);
    }
    return false;
  }
  function _call(fns) {
    if (!fns)
      return false;
    for (const fn of fns) {
      if (!fn)
        continue;
      const node = this.node;
      if (!node)
        return true;
      const ret = fn.call(this.state, this, this.state);
      if (ret && typeof ret === "object" && typeof ret.then === "function") {
        throw new Error(`You appear to be using a plugin with an async traversal visitor, which your current version of Babel does not support. If you're using a published plugin, you may need to upgrade your @babel/core version.`);
      }
      if (ret) {
        throw new Error(`Unexpected return value from visitor method ${fn}`);
      }
      if (this.node !== node)
        return true;
      if (this._traverseFlags > 0)
        return true;
    }
    return false;
  }
  function isDenylisted() {
    var _this$opts$denylist;
    const denylist = (_this$opts$denylist = this.opts.denylist) != null ? _this$opts$denylist : this.opts.blacklist;
    return denylist == null ? undefined : denylist.includes(this.node.type);
  }
  {
    exports.isBlacklisted = isDenylisted;
  }
  function restoreContext(path3, context) {
    if (path3.context !== context) {
      path3.context = context;
      path3.state = context.state;
      path3.opts = context.opts;
    }
  }
  function visit() {
    var _this$opts$shouldSkip, _this$opts;
    if (!this.node) {
      return false;
    }
    if (this.isDenylisted()) {
      return false;
    }
    if ((_this$opts$shouldSkip = (_this$opts = this.opts).shouldSkip) != null && _this$opts$shouldSkip.call(_this$opts, this)) {
      return false;
    }
    const currentContext = this.context;
    if (this.shouldSkip || call.call(this, "enter")) {
      this.debug("Skip...");
      return this.shouldStop;
    }
    restoreContext(this, currentContext);
    this.debug("Recursing into...");
    this.shouldStop = (0, _traverseNode.traverseNode)(this.node, this.opts, this.scope, this.state, this, this.skipKeys);
    restoreContext(this, currentContext);
    call.call(this, "exit");
    return this.shouldStop;
  }
  function skip() {
    this.shouldSkip = true;
  }
  function skipKey(key) {
    if (this.skipKeys == null) {
      this.skipKeys = {};
    }
    this.skipKeys[key] = true;
  }
  function stop() {
    this._traverseFlags |= _index.SHOULD_SKIP | _index.SHOULD_STOP;
  }
  function setScope() {
    var _this$opts2, _this$scope;
    if ((_this$opts2 = this.opts) != null && _this$opts2.noScope)
      return;
    let path3 = this.parentPath;
    if ((this.key === "key" || this.listKey === "decorators") && path3.isMethod() || this.key === "discriminant" && path3.isSwitchStatement()) {
      path3 = path3.parentPath;
    }
    let target;
    while (path3 && !target) {
      var _path$opts;
      if ((_path$opts = path3.opts) != null && _path$opts.noScope)
        return;
      target = path3.scope;
      path3 = path3.parentPath;
    }
    this.scope = this.getScope(target);
    (_this$scope = this.scope) == null || _this$scope.init();
  }
  function setContext(context) {
    if (this.skipKeys != null) {
      this.skipKeys = {};
    }
    this._traverseFlags = 0;
    if (context) {
      this.context = context;
      this.state = context.state;
      this.opts = context.opts;
    }
    setScope.call(this);
    return this;
  }
  function resync() {
    if (this.removed)
      return;
    _resyncParent.call(this);
    _resyncList.call(this);
    _resyncKey.call(this);
  }
  function _resyncParent() {
    if (this.parentPath) {
      this.parent = this.parentPath.node;
    }
  }
  function _resyncKey() {
    if (!this.container)
      return;
    if (this.node === this.container[this.key]) {
      return;
    }
    if (Array.isArray(this.container)) {
      for (let i = 0;i < this.container.length; i++) {
        if (this.container[i] === this.node) {
          setKey.call(this, i);
          return;
        }
      }
    } else {
      for (const key of Object.keys(this.container)) {
        if (this.container[key] === this.node) {
          setKey.call(this, key);
          return;
        }
      }
    }
    this.key = null;
  }
  function _resyncList() {
    if (!this.parent || !this.inList)
      return;
    const newContainer = this.parent[this.listKey];
    if (this.container === newContainer)
      return;
    this.container = newContainer || null;
  }
  function _resyncRemoved() {
    if (this.key == null || !this.container || this.container[this.key] !== this.node) {
      _removal._markRemoved.call(this);
    }
  }
  function popContext() {
    this.contexts.pop();
    if (this.contexts.length > 0) {
      this.setContext(this.contexts[this.contexts.length - 1]);
    } else {
      this.setContext(undefined);
    }
  }
  function pushContext(context) {
    this.contexts.push(context);
    this.setContext(context);
  }
  function setup(parentPath, container, listKey, key) {
    this.listKey = listKey;
    this.container = container;
    this.parentPath = parentPath || this.parentPath;
    setKey.call(this, key);
  }
  function setKey(key) {
    var _this$node;
    this.key = key;
    this.node = this.container[this.key];
    this.type = (_this$node = this.node) == null ? undefined : _this$node.type;
  }
  function requeue(pathToQueue = this) {
    if (pathToQueue.removed)
      return;
    const contexts = this.contexts;
    for (const context of contexts) {
      context.maybeQueue(pathToQueue);
    }
  }
  function requeueComputedKeyAndDecorators() {
    const {
      context,
      node
    } = this;
    if (!t.isPrivate(node) && node.computed) {
      context.maybeQueue(this.get("key"));
    }
    if (node.decorators) {
      for (const decorator of this.get("decorators")) {
        context.maybeQueue(decorator);
      }
    }
  }
  function _getQueueContexts() {
    let path3 = this;
    let contexts = this.contexts;
    while (!contexts.length) {
      path3 = path3.parentPath;
      if (!path3)
        break;
      contexts = path3.contexts;
    }
    return contexts;
  }
});
var require_hub = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;

  class Hub {
    getCode() {
    }
    getScope() {
    }
    addHelper() {
      throw new Error("Helpers are not supported by the default hub.");
    }
    buildError(node, msg, Error2 = TypeError) {
      return new Error2(msg);
    }
  }
  exports.default = Hub;
});
var require_lib11 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "Hub", {
    enumerable: true,
    get: function() {
      return _hub.default;
    }
  });
  Object.defineProperty(exports, "NodePath", {
    enumerable: true,
    get: function() {
      return _index.default;
    }
  });
  Object.defineProperty(exports, "Scope", {
    enumerable: true,
    get: function() {
      return _index2.default;
    }
  });
  exports.visitors = exports.default = undefined;
  require_context2();
  var visitors = require_visitors();
  exports.visitors = visitors;
  var _t = require_lib6();
  var cache3 = require_cache();
  var _traverseNode = require_traverse_node();
  var _index = require_path();
  var _index2 = require_scope();
  var _hub = require_hub();
  var {
    VISITOR_KEYS,
    removeProperties,
    traverseFast
  } = _t;
  function traverse(parent, opts = {}, scope, state, parentPath, visitSelf) {
    if (!parent)
      return;
    if (!opts.noScope && !scope) {
      if (parent.type !== "Program" && parent.type !== "File") {
        throw new Error(`You must pass a scope and parentPath unless traversing a Program/File. Instead of that you tried to traverse a ${parent.type} node without passing scope and parentPath.`);
      }
    }
    if (!parentPath && visitSelf) {
      throw new Error("visitSelf can only be used when providing a NodePath.");
    }
    if (!VISITOR_KEYS[parent.type]) {
      return;
    }
    visitors.explode(opts);
    (0, _traverseNode.traverseNode)(parent, opts, scope, state, parentPath, null, visitSelf);
  }
  var _default = exports.default = traverse;
  traverse.visitors = visitors;
  traverse.verify = visitors.verify;
  traverse.explode = visitors.explode;
  traverse.cheap = function(node, enter) {
    traverseFast(node, enter);
    return;
  };
  traverse.node = function(node, opts, scope, state, path3, skipKeys) {
    (0, _traverseNode.traverseNode)(node, opts, scope, state, path3, skipKeys);
  };
  traverse.clearNode = function(node, opts) {
    removeProperties(node, opts);
  };
  traverse.removeProperties = function(tree, opts) {
    traverseFast(tree, traverse.clearNode, opts);
    return tree;
  };
  function hasDenylistedType(path3, state) {
    if (path3.node.type === state.type) {
      state.has = true;
      path3.stop();
    }
  }
  traverse.hasType = function(tree, type, denylistTypes) {
    if (denylistTypes != null && denylistTypes.includes(tree.type))
      return false;
    if (tree.type === type)
      return true;
    const state = {
      has: false,
      type
    };
    traverse(tree, {
      noScope: true,
      denylist: denylistTypes,
      enter: hasDenylistedType
    }, null, state);
    return state.has;
  };
  traverse.cache = cache3;
});
var require_CachedInputFileSystem = __commonJS2((exports, module) => {
  var nextTick = import.meta.require("process").nextTick;
  var dirname33 = (path3) => {
    let idx = path3.length - 1;
    while (idx >= 0) {
      const c22 = path3.charCodeAt(idx);
      if (c22 === 47 || c22 === 92)
        break;
      idx--;
    }
    if (idx < 0)
      return "";
    return path3.slice(0, idx);
  };
  var runCallbacks = (callbacks, err22, result2) => {
    if (callbacks.length === 1) {
      callbacks[0](err22, result2);
      callbacks.length = 0;
      return;
    }
    let error;
    for (const callback of callbacks) {
      try {
        callback(err22, result2);
      } catch (e) {
        if (!error)
          error = e;
      }
    }
    callbacks.length = 0;
    if (error)
      throw error;
  };

  class OperationMergerBackend {
    constructor(provider, syncProvider, providerContext) {
      this._provider = provider;
      this._syncProvider = syncProvider;
      this._providerContext = providerContext;
      this._activeAsyncOperations = new Map;
      this.provide = this._provider ? (path3, options3, callback) => {
        if (typeof options3 === "function") {
          callback = options3;
          options3 = undefined;
        }
        if (typeof path3 !== "string" && !Buffer.isBuffer(path3) && !(path3 instanceof URL) && typeof path3 !== "number") {
          callback(new TypeError("path must be a string, Buffer, URL or number"));
          return;
        }
        if (options3) {
          return this._provider.call(this._providerContext, path3, options3, callback);
        }
        let callbacks = this._activeAsyncOperations.get(path3);
        if (callbacks) {
          callbacks.push(callback);
          return;
        }
        this._activeAsyncOperations.set(path3, callbacks = [callback]);
        provider(path3, (err22, result2) => {
          this._activeAsyncOperations.delete(path3);
          runCallbacks(callbacks, err22, result2);
        });
      } : null;
      this.provideSync = this._syncProvider ? (path3, options3) => {
        return this._syncProvider.call(this._providerContext, path3, options3);
      } : null;
    }
    purge() {
    }
    purgeParent() {
    }
  }
  var STORAGE_MODE_IDLE = 0;
  var STORAGE_MODE_SYNC = 1;
  var STORAGE_MODE_ASYNC = 2;

  class CacheBackend {
    constructor(duration, provider, syncProvider, providerContext) {
      this._duration = duration;
      this._provider = provider;
      this._syncProvider = syncProvider;
      this._providerContext = providerContext;
      this._activeAsyncOperations = new Map;
      this._data = new Map;
      this._levels = [];
      for (let i = 0;i < 10; i++)
        this._levels.push(new Set);
      for (let i = 5000;i < duration; i += 500)
        this._levels.push(new Set);
      this._currentLevel = 0;
      this._tickInterval = Math.floor(duration / this._levels.length);
      this._mode = STORAGE_MODE_IDLE;
      this._timeout = undefined;
      this._nextDecay = undefined;
      this.provide = provider ? this.provide.bind(this) : null;
      this.provideSync = syncProvider ? this.provideSync.bind(this) : null;
    }
    provide(path3, options3, callback) {
      if (typeof options3 === "function") {
        callback = options3;
        options3 = undefined;
      }
      if (typeof path3 !== "string" && !Buffer.isBuffer(path3) && !(path3 instanceof URL) && typeof path3 !== "number") {
        callback(new TypeError("path must be a string, Buffer, URL or number"));
        return;
      }
      const strPath = typeof path3 !== "string" ? path3.toString() : path3;
      if (options3) {
        return this._provider.call(this._providerContext, path3, options3, callback);
      }
      if (this._mode === STORAGE_MODE_SYNC) {
        this._enterAsyncMode();
      }
      let cacheEntry = this._data.get(strPath);
      if (cacheEntry !== undefined) {
        if (cacheEntry.err)
          return nextTick(callback, cacheEntry.err);
        return nextTick(callback, null, cacheEntry.result);
      }
      let callbacks = this._activeAsyncOperations.get(strPath);
      if (callbacks !== undefined) {
        callbacks.push(callback);
        return;
      }
      this._activeAsyncOperations.set(strPath, callbacks = [callback]);
      this._provider.call(this._providerContext, path3, (err22, result2) => {
        this._activeAsyncOperations.delete(strPath);
        this._storeResult(strPath, err22, result2);
        this._enterAsyncMode();
        runCallbacks(callbacks, err22, result2);
      });
    }
    provideSync(path3, options3) {
      if (typeof path3 !== "string" && !Buffer.isBuffer(path3) && !(path3 instanceof URL) && typeof path3 !== "number") {
        throw new TypeError("path must be a string");
      }
      const strPath = typeof path3 !== "string" ? path3.toString() : path3;
      if (options3) {
        return this._syncProvider.call(this._providerContext, path3, options3);
      }
      if (this._mode === STORAGE_MODE_SYNC) {
        this._runDecays();
      }
      let cacheEntry = this._data.get(strPath);
      if (cacheEntry !== undefined) {
        if (cacheEntry.err)
          throw cacheEntry.err;
        return cacheEntry.result;
      }
      const callbacks = this._activeAsyncOperations.get(strPath);
      this._activeAsyncOperations.delete(strPath);
      let result2;
      try {
        result2 = this._syncProvider.call(this._providerContext, path3);
      } catch (err22) {
        this._storeResult(strPath, err22, undefined);
        this._enterSyncModeWhenIdle();
        if (callbacks) {
          runCallbacks(callbacks, err22, undefined);
        }
        throw err22;
      }
      this._storeResult(strPath, null, result2);
      this._enterSyncModeWhenIdle();
      if (callbacks) {
        runCallbacks(callbacks, null, result2);
      }
      return result2;
    }
    purge(what) {
      if (!what) {
        if (this._mode !== STORAGE_MODE_IDLE) {
          this._data.clear();
          for (const level of this._levels) {
            level.clear();
          }
          this._enterIdleMode();
        }
      } else if (typeof what === "string" || Buffer.isBuffer(what) || what instanceof URL || typeof what === "number") {
        const strWhat = typeof what !== "string" ? what.toString() : what;
        for (let [key, data] of this._data) {
          if (key.startsWith(strWhat)) {
            this._data.delete(key);
            data.level.delete(key);
          }
        }
        if (this._data.size === 0) {
          this._enterIdleMode();
        }
      } else {
        for (let [key, data] of this._data) {
          for (const item of what) {
            const strItem = typeof item !== "string" ? item.toString() : item;
            if (key.startsWith(strItem)) {
              this._data.delete(key);
              data.level.delete(key);
              break;
            }
          }
        }
        if (this._data.size === 0) {
          this._enterIdleMode();
        }
      }
    }
    purgeParent(what) {
      if (!what) {
        this.purge();
      } else if (typeof what === "string" || Buffer.isBuffer(what) || what instanceof URL || typeof what === "number") {
        const strWhat = typeof what !== "string" ? what.toString() : what;
        this.purge(dirname33(strWhat));
      } else {
        const set = new Set;
        for (const item of what) {
          const strItem = typeof item !== "string" ? item.toString() : item;
          set.add(dirname33(strItem));
        }
        this.purge(set);
      }
    }
    _storeResult(path3, err22, result2) {
      if (this._data.has(path3))
        return;
      const level = this._levels[this._currentLevel];
      this._data.set(path3, { err: err22, result: result2, level });
      level.add(path3);
    }
    _decayLevel() {
      const nextLevel = (this._currentLevel + 1) % this._levels.length;
      const decay = this._levels[nextLevel];
      this._currentLevel = nextLevel;
      for (let item of decay) {
        this._data.delete(item);
      }
      decay.clear();
      if (this._data.size === 0) {
        this._enterIdleMode();
      } else {
        this._nextDecay += this._tickInterval;
      }
    }
    _runDecays() {
      while (this._nextDecay <= Date.now() && this._mode !== STORAGE_MODE_IDLE) {
        this._decayLevel();
      }
    }
    _enterAsyncMode() {
      let timeout = 0;
      switch (this._mode) {
        case STORAGE_MODE_ASYNC:
          return;
        case STORAGE_MODE_IDLE:
          this._nextDecay = Date.now() + this._tickInterval;
          timeout = this._tickInterval;
          break;
        case STORAGE_MODE_SYNC:
          this._runDecays();
          if (this._mode === STORAGE_MODE_IDLE)
            return;
          timeout = Math.max(0, this._nextDecay - Date.now());
          break;
      }
      this._mode = STORAGE_MODE_ASYNC;
      const ref = setTimeout(() => {
        this._mode = STORAGE_MODE_SYNC;
        this._runDecays();
      }, timeout);
      if (ref.unref)
        ref.unref();
      this._timeout = ref;
    }
    _enterSyncModeWhenIdle() {
      if (this._mode === STORAGE_MODE_IDLE) {
        this._mode = STORAGE_MODE_SYNC;
        this._nextDecay = Date.now() + this._tickInterval;
      }
    }
    _enterIdleMode() {
      this._mode = STORAGE_MODE_IDLE;
      this._nextDecay = undefined;
      if (this._timeout)
        clearTimeout(this._timeout);
    }
  }
  var createBackend = (duration, provider, syncProvider, providerContext) => {
    if (duration > 0) {
      return new CacheBackend(duration, provider, syncProvider, providerContext);
    }
    return new OperationMergerBackend(provider, syncProvider, providerContext);
  };
  module.exports = class CachedInputFileSystem {
    constructor(fileSystem, duration) {
      this.fileSystem = fileSystem;
      this._lstatBackend = createBackend(duration, this.fileSystem.lstat, this.fileSystem.lstatSync, this.fileSystem);
      const lstat = this._lstatBackend.provide;
      this.lstat = lstat;
      const lstatSync3 = this._lstatBackend.provideSync;
      this.lstatSync = lstatSync3;
      this._statBackend = createBackend(duration, this.fileSystem.stat, this.fileSystem.statSync, this.fileSystem);
      const stat = this._statBackend.provide;
      this.stat = stat;
      const statSync = this._statBackend.provideSync;
      this.statSync = statSync;
      this._readdirBackend = createBackend(duration, this.fileSystem.readdir, this.fileSystem.readdirSync, this.fileSystem);
      const readdir = this._readdirBackend.provide;
      this.readdir = readdir;
      const readdirSync = this._readdirBackend.provideSync;
      this.readdirSync = readdirSync;
      this._readFileBackend = createBackend(duration, this.fileSystem.readFile, this.fileSystem.readFileSync, this.fileSystem);
      const readFile = this._readFileBackend.provide;
      this.readFile = readFile;
      const readFileSync = this._readFileBackend.provideSync;
      this.readFileSync = readFileSync;
      this._readJsonBackend = createBackend(duration, this.fileSystem.readJson || this.readFile && ((path3, callback) => {
        this.readFile(path3, (err22, buffer) => {
          if (err22)
            return callback(err22);
          if (!buffer || buffer.length === 0)
            return callback(new Error("No file content"));
          let data;
          try {
            data = JSON.parse(buffer.toString("utf-8"));
          } catch (e) {
            return callback(e);
          }
          callback(null, data);
        });
      }), this.fileSystem.readJsonSync || this.readFileSync && ((path3) => {
        const buffer = this.readFileSync(path3);
        const data = JSON.parse(buffer.toString("utf-8"));
        return data;
      }), this.fileSystem);
      const readJson = this._readJsonBackend.provide;
      this.readJson = readJson;
      const readJsonSync = this._readJsonBackend.provideSync;
      this.readJsonSync = readJsonSync;
      this._readlinkBackend = createBackend(duration, this.fileSystem.readlink, this.fileSystem.readlinkSync, this.fileSystem);
      const readlink = this._readlinkBackend.provide;
      this.readlink = readlink;
      const readlinkSync = this._readlinkBackend.provideSync;
      this.readlinkSync = readlinkSync;
      this._realpathBackend = createBackend(duration, this.fileSystem.realpath, this.fileSystem.realpathSync, this.fileSystem);
      const realpath = this._realpathBackend.provide;
      this.realpath = realpath;
      const realpathSync2 = this._realpathBackend.provideSync;
      this.realpathSync = realpathSync2;
    }
    purge(what) {
      this._statBackend.purge(what);
      this._lstatBackend.purge(what);
      this._readdirBackend.purgeParent(what);
      this._readFileBackend.purge(what);
      this._readlinkBackend.purge(what);
      this._readJsonBackend.purge(what);
      this._realpathBackend.purge(what);
    }
  };
});
var require_Hook = __commonJS2((exports, module) => {
  var util = import.meta.require("util");
  var deprecateContext = util.deprecate(() => {
  }, "Hook.context is deprecated and will be removed");
  var CALL_DELEGATE = function(...args) {
    this.call = this._createCall("sync");
    return this.call(...args);
  };
  var CALL_ASYNC_DELEGATE = function(...args) {
    this.callAsync = this._createCall("async");
    return this.callAsync(...args);
  };
  var PROMISE_DELEGATE = function(...args) {
    this.promise = this._createCall("promise");
    return this.promise(...args);
  };

  class Hook {
    constructor(args = [], name = undefined) {
      this._args = args;
      this.name = name;
      this.taps = [];
      this.interceptors = [];
      this._call = CALL_DELEGATE;
      this.call = CALL_DELEGATE;
      this._callAsync = CALL_ASYNC_DELEGATE;
      this.callAsync = CALL_ASYNC_DELEGATE;
      this._promise = PROMISE_DELEGATE;
      this.promise = PROMISE_DELEGATE;
      this._x = undefined;
      this.compile = this.compile;
      this.tap = this.tap;
      this.tapAsync = this.tapAsync;
      this.tapPromise = this.tapPromise;
    }
    compile(options3) {
      throw new Error("Abstract: should be overridden");
    }
    _createCall(type) {
      return this.compile({
        taps: this.taps,
        interceptors: this.interceptors,
        args: this._args,
        type
      });
    }
    _tap(type, options3, fn) {
      if (typeof options3 === "string") {
        options3 = {
          name: options3.trim()
        };
      } else if (typeof options3 !== "object" || options3 === null) {
        throw new Error("Invalid tap options");
      }
      if (typeof options3.name !== "string" || options3.name === "") {
        throw new Error("Missing name for tap");
      }
      if (typeof options3.context !== "undefined") {
        deprecateContext();
      }
      options3 = Object.assign({ type, fn }, options3);
      options3 = this._runRegisterInterceptors(options3);
      this._insert(options3);
    }
    tap(options3, fn) {
      this._tap("sync", options3, fn);
    }
    tapAsync(options3, fn) {
      this._tap("async", options3, fn);
    }
    tapPromise(options3, fn) {
      this._tap("promise", options3, fn);
    }
    _runRegisterInterceptors(options3) {
      for (const interceptor of this.interceptors) {
        if (interceptor.register) {
          const newOptions = interceptor.register(options3);
          if (newOptions !== undefined) {
            options3 = newOptions;
          }
        }
      }
      return options3;
    }
    withOptions(options3) {
      const mergeOptions = (opt) => Object.assign({}, options3, typeof opt === "string" ? { name: opt } : opt);
      return {
        name: this.name,
        tap: (opt, fn) => this.tap(mergeOptions(opt), fn),
        tapAsync: (opt, fn) => this.tapAsync(mergeOptions(opt), fn),
        tapPromise: (opt, fn) => this.tapPromise(mergeOptions(opt), fn),
        intercept: (interceptor) => this.intercept(interceptor),
        isUsed: () => this.isUsed(),
        withOptions: (opt) => this.withOptions(mergeOptions(opt))
      };
    }
    isUsed() {
      return this.taps.length > 0 || this.interceptors.length > 0;
    }
    intercept(interceptor) {
      this._resetCompilation();
      this.interceptors.push(Object.assign({}, interceptor));
      if (interceptor.register) {
        for (let i = 0;i < this.taps.length; i++) {
          this.taps[i] = interceptor.register(this.taps[i]);
        }
      }
    }
    _resetCompilation() {
      this.call = this._call;
      this.callAsync = this._callAsync;
      this.promise = this._promise;
    }
    _insert(item) {
      this._resetCompilation();
      let before;
      if (typeof item.before === "string") {
        before = new Set([item.before]);
      } else if (Array.isArray(item.before)) {
        before = new Set(item.before);
      }
      let stage = 0;
      if (typeof item.stage === "number") {
        stage = item.stage;
      }
      let i = this.taps.length;
      while (i > 0) {
        i--;
        const x = this.taps[i];
        this.taps[i + 1] = x;
        const xStage = x.stage || 0;
        if (before) {
          if (before.has(x.name)) {
            before.delete(x.name);
            continue;
          }
          if (before.size > 0) {
            continue;
          }
        }
        if (xStage > stage) {
          continue;
        }
        i++;
        break;
      }
      this.taps[i] = item;
    }
  }
  Object.setPrototypeOf(Hook.prototype, null);
  module.exports = Hook;
});
var require_HookCodeFactory = __commonJS2((exports, module) => {

  class HookCodeFactory {
    constructor(config5) {
      this.config = config5;
      this.options = undefined;
      this._args = undefined;
    }
    create(options3) {
      this.init(options3);
      let fn;
      switch (this.options.type) {
        case "sync":
          fn = new Function(this.args(), '"use strict";\n' + this.header() + this.contentWithInterceptors({
            onError: (err22) => `throw ${err22};\n`,
            onResult: (result2) => `return ${result2};\n`,
            resultReturns: true,
            onDone: () => "",
            rethrowIfPossible: true
          }));
          break;
        case "async":
          fn = new Function(this.args({
            after: "_callback"
          }), '"use strict";\n' + this.header() + this.contentWithInterceptors({
            onError: (err22) => `_callback(${err22});\n`,
            onResult: (result2) => `_callback(null, ${result2});\n`,
            onDone: () => "_callback();\n"
          }));
          break;
        case "promise":
          let errorHelperUsed = false;
          const content = this.contentWithInterceptors({
            onError: (err22) => {
              errorHelperUsed = true;
              return `_error(${err22});\n`;
            },
            onResult: (result2) => `_resolve(${result2});\n`,
            onDone: () => "_resolve();\n"
          });
          let code = "";
          code += '"use strict";\n';
          code += this.header();
          code += "return new Promise((function(_resolve, _reject) {\n";
          if (errorHelperUsed) {
            code += "var _sync = true;\n";
            code += "function _error(_err) {\n";
            code += "if(_sync)\n";
            code += "_resolve(Promise.resolve().then((function() { throw _err; })));\n";
            code += "else\n";
            code += "_reject(_err);\n";
            code += "};\n";
          }
          code += content;
          if (errorHelperUsed) {
            code += "_sync = false;\n";
          }
          code += "}));\n";
          fn = new Function(this.args(), code);
          break;
      }
      this.deinit();
      return fn;
    }
    setup(instance, options3) {
      instance._x = options3.taps.map((t) => t.fn);
    }
    init(options3) {
      this.options = options3;
      this._args = options3.args.slice();
    }
    deinit() {
      this.options = undefined;
      this._args = undefined;
    }
    contentWithInterceptors(options3) {
      if (this.options.interceptors.length > 0) {
        const onError = options3.onError;
        const onResult = options3.onResult;
        const onDone = options3.onDone;
        let code = "";
        for (let i = 0;i < this.options.interceptors.length; i++) {
          const interceptor = this.options.interceptors[i];
          if (interceptor.call) {
            code += `${this.getInterceptor(i)}.call(${this.args({
              before: interceptor.context ? "_context" : undefined
            })});\n`;
          }
        }
        code += this.content(Object.assign(options3, {
          onError: onError && ((err22) => {
            let code2 = "";
            for (let i = 0;i < this.options.interceptors.length; i++) {
              const interceptor = this.options.interceptors[i];
              if (interceptor.error) {
                code2 += `${this.getInterceptor(i)}.error(${err22});\n`;
              }
            }
            code2 += onError(err22);
            return code2;
          }),
          onResult: onResult && ((result2) => {
            let code2 = "";
            for (let i = 0;i < this.options.interceptors.length; i++) {
              const interceptor = this.options.interceptors[i];
              if (interceptor.result) {
                code2 += `${this.getInterceptor(i)}.result(${result2});\n`;
              }
            }
            code2 += onResult(result2);
            return code2;
          }),
          onDone: onDone && (() => {
            let code2 = "";
            for (let i = 0;i < this.options.interceptors.length; i++) {
              const interceptor = this.options.interceptors[i];
              if (interceptor.done) {
                code2 += `${this.getInterceptor(i)}.done();\n`;
              }
            }
            code2 += onDone();
            return code2;
          })
        }));
        return code;
      } else {
        return this.content(options3);
      }
    }
    header() {
      let code = "";
      if (this.needContext()) {
        code += "var _context = {};\n";
      } else {
        code += "var _context;\n";
      }
      code += "var _x = this._x;\n";
      if (this.options.interceptors.length > 0) {
        code += "var _taps = this.taps;\n";
        code += "var _interceptors = this.interceptors;\n";
      }
      return code;
    }
    needContext() {
      for (const tap of this.options.taps)
        if (tap.context)
          return true;
      return false;
    }
    callTap(tapIndex, { onError, onResult, onDone, rethrowIfPossible }) {
      let code = "";
      let hasTapCached = false;
      for (let i = 0;i < this.options.interceptors.length; i++) {
        const interceptor = this.options.interceptors[i];
        if (interceptor.tap) {
          if (!hasTapCached) {
            code += `var _tap${tapIndex} = ${this.getTap(tapIndex)};\n`;
            hasTapCached = true;
          }
          code += `${this.getInterceptor(i)}.tap(${interceptor.context ? "_context, " : ""}_tap${tapIndex});\n`;
        }
      }
      code += `var _fn${tapIndex} = ${this.getTapFn(tapIndex)};\n`;
      const tap = this.options.taps[tapIndex];
      switch (tap.type) {
        case "sync":
          if (!rethrowIfPossible) {
            code += `var _hasError${tapIndex} = false;\n`;
            code += "try {\n";
          }
          if (onResult) {
            code += `var _result${tapIndex} = _fn${tapIndex}(${this.args({
              before: tap.context ? "_context" : undefined
            })});\n`;
          } else {
            code += `_fn${tapIndex}(${this.args({
              before: tap.context ? "_context" : undefined
            })});\n`;
          }
          if (!rethrowIfPossible) {
            code += "} catch(_err) {\n";
            code += `_hasError${tapIndex} = true;\n`;
            code += onError("_err");
            code += "}\n";
            code += `if(!_hasError${tapIndex}) {\n`;
          }
          if (onResult) {
            code += onResult(`_result${tapIndex}`);
          }
          if (onDone) {
            code += onDone();
          }
          if (!rethrowIfPossible) {
            code += "}\n";
          }
          break;
        case "async":
          let cbCode = "";
          if (onResult)
            cbCode += `(function(_err${tapIndex}, _result${tapIndex}) {\n`;
          else
            cbCode += `(function(_err${tapIndex}) {\n`;
          cbCode += `if(_err${tapIndex}) {\n`;
          cbCode += onError(`_err${tapIndex}`);
          cbCode += "} else {\n";
          if (onResult) {
            cbCode += onResult(`_result${tapIndex}`);
          }
          if (onDone) {
            cbCode += onDone();
          }
          cbCode += "}\n";
          cbCode += "})";
          code += `_fn${tapIndex}(${this.args({
            before: tap.context ? "_context" : undefined,
            after: cbCode
          })});\n`;
          break;
        case "promise":
          code += `var _hasResult${tapIndex} = false;\n`;
          code += `var _promise${tapIndex} = _fn${tapIndex}(${this.args({
            before: tap.context ? "_context" : undefined
          })});\n`;
          code += `if (!_promise${tapIndex} || !_promise${tapIndex}.then)\n`;
          code += `  throw new Error('Tap function (tapPromise) did not return promise (returned ' + _promise${tapIndex} + ')');\n`;
          code += `_promise${tapIndex}.then((function(_result${tapIndex}) {\n`;
          code += `_hasResult${tapIndex} = true;\n`;
          if (onResult) {
            code += onResult(`_result${tapIndex}`);
          }
          if (onDone) {
            code += onDone();
          }
          code += `}), function(_err${tapIndex}) {\n`;
          code += `if(_hasResult${tapIndex}) throw _err${tapIndex};\n`;
          code += onError(`_err${tapIndex}`);
          code += "});\n";
          break;
      }
      return code;
    }
    callTapsSeries({
      onError,
      onResult,
      resultReturns,
      onDone,
      doneReturns,
      rethrowIfPossible
    }) {
      if (this.options.taps.length === 0)
        return onDone();
      const firstAsync = this.options.taps.findIndex((t) => t.type !== "sync");
      const somethingReturns = resultReturns || doneReturns;
      let code = "";
      let current = onDone;
      let unrollCounter = 0;
      for (let j22 = this.options.taps.length - 1;j22 >= 0; j22--) {
        const i = j22;
        const unroll = current !== onDone && (this.options.taps[i].type !== "sync" || unrollCounter++ > 20);
        if (unroll) {
          unrollCounter = 0;
          code += `function _next${i}() {\n`;
          code += current();
          code += `}\n`;
          current = () => `${somethingReturns ? "return " : ""}_next${i}();\n`;
        }
        const done = current;
        const doneBreak = (skipDone) => {
          if (skipDone)
            return "";
          return onDone();
        };
        const content = this.callTap(i, {
          onError: (error) => onError(i, error, done, doneBreak),
          onResult: onResult && ((result2) => {
            return onResult(i, result2, done, doneBreak);
          }),
          onDone: !onResult && done,
          rethrowIfPossible: rethrowIfPossible && (firstAsync < 0 || i < firstAsync)
        });
        current = () => content;
      }
      code += current();
      return code;
    }
    callTapsLooping({ onError, onDone, rethrowIfPossible }) {
      if (this.options.taps.length === 0)
        return onDone();
      const syncOnly = this.options.taps.every((t) => t.type === "sync");
      let code = "";
      if (!syncOnly) {
        code += "var _looper = (function() {\n";
        code += "var _loopAsync = false;\n";
      }
      code += "var _loop;\n";
      code += "do {\n";
      code += "_loop = false;\n";
      for (let i = 0;i < this.options.interceptors.length; i++) {
        const interceptor = this.options.interceptors[i];
        if (interceptor.loop) {
          code += `${this.getInterceptor(i)}.loop(${this.args({
            before: interceptor.context ? "_context" : undefined
          })});\n`;
        }
      }
      code += this.callTapsSeries({
        onError,
        onResult: (i, result2, next, doneBreak) => {
          let code2 = "";
          code2 += `if(${result2} !== undefined) {\n`;
          code2 += "_loop = true;\n";
          if (!syncOnly)
            code2 += "if(_loopAsync) _looper();\n";
          code2 += doneBreak(true);
          code2 += `} else {\n`;
          code2 += next();
          code2 += `}\n`;
          return code2;
        },
        onDone: onDone && (() => {
          let code2 = "";
          code2 += "if(!_loop) {\n";
          code2 += onDone();
          code2 += "}\n";
          return code2;
        }),
        rethrowIfPossible: rethrowIfPossible && syncOnly
      });
      code += "} while(_loop);\n";
      if (!syncOnly) {
        code += "_loopAsync = true;\n";
        code += "});\n";
        code += "_looper();\n";
      }
      return code;
    }
    callTapsParallel({
      onError,
      onResult,
      onDone,
      rethrowIfPossible,
      onTap = (i, run2) => run2()
    }) {
      if (this.options.taps.length <= 1) {
        return this.callTapsSeries({
          onError,
          onResult,
          onDone,
          rethrowIfPossible
        });
      }
      let code = "";
      code += "do {\n";
      code += `var _counter = ${this.options.taps.length};\n`;
      if (onDone) {
        code += "var _done = (function() {\n";
        code += onDone();
        code += "});\n";
      }
      for (let i = 0;i < this.options.taps.length; i++) {
        const done = () => {
          if (onDone)
            return "if(--_counter === 0) _done();\n";
          else
            return "--_counter;";
        };
        const doneBreak = (skipDone) => {
          if (skipDone || !onDone)
            return "_counter = 0;\n";
          else
            return "_counter = 0;\n_done();\n";
        };
        code += "if(_counter <= 0) break;\n";
        code += onTap(i, () => this.callTap(i, {
          onError: (error) => {
            let code2 = "";
            code2 += "if(_counter > 0) {\n";
            code2 += onError(i, error, done, doneBreak);
            code2 += "}\n";
            return code2;
          },
          onResult: onResult && ((result2) => {
            let code2 = "";
            code2 += "if(_counter > 0) {\n";
            code2 += onResult(i, result2, done, doneBreak);
            code2 += "}\n";
            return code2;
          }),
          onDone: !onResult && (() => {
            return done();
          }),
          rethrowIfPossible
        }), done, doneBreak);
      }
      code += "} while(false);\n";
      return code;
    }
    args({ before, after } = {}) {
      let allArgs = this._args;
      if (before)
        allArgs = [before].concat(allArgs);
      if (after)
        allArgs = allArgs.concat(after);
      if (allArgs.length === 0) {
        return "";
      } else {
        return allArgs.join(", ");
      }
    }
    getTapFn(idx) {
      return `_x[${idx}]`;
    }
    getTap(idx) {
      return `_taps[${idx}]`;
    }
    getInterceptor(idx) {
      return `_interceptors[${idx}]`;
    }
  }
  module.exports = HookCodeFactory;
});
var require_SyncHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class SyncHookCodeFactory extends HookCodeFactory {
    content({ onError, onDone, rethrowIfPossible }) {
      return this.callTapsSeries({
        onError: (i, err22) => onError(err22),
        onDone,
        rethrowIfPossible
      });
    }
  }
  var factory = new SyncHookCodeFactory;
  var TAP_ASYNC = () => {
    throw new Error("tapAsync is not supported on a SyncHook");
  };
  var TAP_PROMISE = () => {
    throw new Error("tapPromise is not supported on a SyncHook");
  };
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function SyncHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = SyncHook;
    hook.tapAsync = TAP_ASYNC;
    hook.tapPromise = TAP_PROMISE;
    hook.compile = COMPILE;
    return hook;
  }
  SyncHook.prototype = null;
  module.exports = SyncHook;
});
var require_SyncBailHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class SyncBailHookCodeFactory extends HookCodeFactory {
    content({ onError, onResult, resultReturns, onDone, rethrowIfPossible }) {
      return this.callTapsSeries({
        onError: (i, err22) => onError(err22),
        onResult: (i, result2, next) => `if(${result2} !== undefined) {\n${onResult(result2)};\n} else {\n${next()}}\n`,
        resultReturns,
        onDone,
        rethrowIfPossible
      });
    }
  }
  var factory = new SyncBailHookCodeFactory;
  var TAP_ASYNC = () => {
    throw new Error("tapAsync is not supported on a SyncBailHook");
  };
  var TAP_PROMISE = () => {
    throw new Error("tapPromise is not supported on a SyncBailHook");
  };
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function SyncBailHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = SyncBailHook;
    hook.tapAsync = TAP_ASYNC;
    hook.tapPromise = TAP_PROMISE;
    hook.compile = COMPILE;
    return hook;
  }
  SyncBailHook.prototype = null;
  module.exports = SyncBailHook;
});
var require_SyncWaterfallHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class SyncWaterfallHookCodeFactory extends HookCodeFactory {
    content({ onError, onResult, resultReturns, rethrowIfPossible }) {
      return this.callTapsSeries({
        onError: (i, err22) => onError(err22),
        onResult: (i, result2, next) => {
          let code = "";
          code += `if(${result2} !== undefined) {\n`;
          code += `${this._args[0]} = ${result2};\n`;
          code += `}\n`;
          code += next();
          return code;
        },
        onDone: () => onResult(this._args[0]),
        doneReturns: resultReturns,
        rethrowIfPossible
      });
    }
  }
  var factory = new SyncWaterfallHookCodeFactory;
  var TAP_ASYNC = () => {
    throw new Error("tapAsync is not supported on a SyncWaterfallHook");
  };
  var TAP_PROMISE = () => {
    throw new Error("tapPromise is not supported on a SyncWaterfallHook");
  };
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function SyncWaterfallHook(args = [], name = undefined) {
    if (args.length < 1)
      throw new Error("Waterfall hooks must have at least one argument");
    const hook = new Hook(args, name);
    hook.constructor = SyncWaterfallHook;
    hook.tapAsync = TAP_ASYNC;
    hook.tapPromise = TAP_PROMISE;
    hook.compile = COMPILE;
    return hook;
  }
  SyncWaterfallHook.prototype = null;
  module.exports = SyncWaterfallHook;
});
var require_SyncLoopHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class SyncLoopHookCodeFactory extends HookCodeFactory {
    content({ onError, onDone, rethrowIfPossible }) {
      return this.callTapsLooping({
        onError: (i, err22) => onError(err22),
        onDone,
        rethrowIfPossible
      });
    }
  }
  var factory = new SyncLoopHookCodeFactory;
  var TAP_ASYNC = () => {
    throw new Error("tapAsync is not supported on a SyncLoopHook");
  };
  var TAP_PROMISE = () => {
    throw new Error("tapPromise is not supported on a SyncLoopHook");
  };
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function SyncLoopHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = SyncLoopHook;
    hook.tapAsync = TAP_ASYNC;
    hook.tapPromise = TAP_PROMISE;
    hook.compile = COMPILE;
    return hook;
  }
  SyncLoopHook.prototype = null;
  module.exports = SyncLoopHook;
});
var require_AsyncParallelHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class AsyncParallelHookCodeFactory extends HookCodeFactory {
    content({ onError, onDone }) {
      return this.callTapsParallel({
        onError: (i, err22, done, doneBreak) => onError(err22) + doneBreak(true),
        onDone
      });
    }
  }
  var factory = new AsyncParallelHookCodeFactory;
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function AsyncParallelHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = AsyncParallelHook;
    hook.compile = COMPILE;
    hook._call = undefined;
    hook.call = undefined;
    return hook;
  }
  AsyncParallelHook.prototype = null;
  module.exports = AsyncParallelHook;
});
var require_AsyncParallelBailHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class AsyncParallelBailHookCodeFactory extends HookCodeFactory {
    content({ onError, onResult, onDone }) {
      let code = "";
      code += `var _results = new Array(${this.options.taps.length});\n`;
      code += "var _checkDone = function() {\n";
      code += "for(var i = 0; i < _results.length; i++) {\n";
      code += "var item = _results[i];\n";
      code += "if(item === undefined) return false;\n";
      code += "if(item.result !== undefined) {\n";
      code += onResult("item.result");
      code += "return true;\n";
      code += "}\n";
      code += "if(item.error) {\n";
      code += onError("item.error");
      code += "return true;\n";
      code += "}\n";
      code += "}\n";
      code += "return false;\n";
      code += "}\n";
      code += this.callTapsParallel({
        onError: (i, err22, done, doneBreak) => {
          let code2 = "";
          code2 += `if(${i} < _results.length && ((_results.length = ${i + 1}), (_results[${i}] = { error: ${err22} }), _checkDone())) {\n`;
          code2 += doneBreak(true);
          code2 += "} else {\n";
          code2 += done();
          code2 += "}\n";
          return code2;
        },
        onResult: (i, result2, done, doneBreak) => {
          let code2 = "";
          code2 += `if(${i} < _results.length && (${result2} !== undefined && (_results.length = ${i + 1}), (_results[${i}] = { result: ${result2} }), _checkDone())) {\n`;
          code2 += doneBreak(true);
          code2 += "} else {\n";
          code2 += done();
          code2 += "}\n";
          return code2;
        },
        onTap: (i, run2, done, doneBreak) => {
          let code2 = "";
          if (i > 0) {
            code2 += `if(${i} >= _results.length) {\n`;
            code2 += done();
            code2 += "} else {\n";
          }
          code2 += run2();
          if (i > 0)
            code2 += "}\n";
          return code2;
        },
        onDone
      });
      return code;
    }
  }
  var factory = new AsyncParallelBailHookCodeFactory;
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function AsyncParallelBailHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = AsyncParallelBailHook;
    hook.compile = COMPILE;
    hook._call = undefined;
    hook.call = undefined;
    return hook;
  }
  AsyncParallelBailHook.prototype = null;
  module.exports = AsyncParallelBailHook;
});
var require_AsyncSeriesHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class AsyncSeriesHookCodeFactory extends HookCodeFactory {
    content({ onError, onDone }) {
      return this.callTapsSeries({
        onError: (i, err22, next, doneBreak) => onError(err22) + doneBreak(true),
        onDone
      });
    }
  }
  var factory = new AsyncSeriesHookCodeFactory;
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function AsyncSeriesHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = AsyncSeriesHook;
    hook.compile = COMPILE;
    hook._call = undefined;
    hook.call = undefined;
    return hook;
  }
  AsyncSeriesHook.prototype = null;
  module.exports = AsyncSeriesHook;
});
var require_AsyncSeriesBailHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class AsyncSeriesBailHookCodeFactory extends HookCodeFactory {
    content({ onError, onResult, resultReturns, onDone }) {
      return this.callTapsSeries({
        onError: (i, err22, next, doneBreak) => onError(err22) + doneBreak(true),
        onResult: (i, result2, next) => `if(${result2} !== undefined) {\n${onResult(result2)}\n} else {\n${next()}}\n`,
        resultReturns,
        onDone
      });
    }
  }
  var factory = new AsyncSeriesBailHookCodeFactory;
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function AsyncSeriesBailHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = AsyncSeriesBailHook;
    hook.compile = COMPILE;
    hook._call = undefined;
    hook.call = undefined;
    return hook;
  }
  AsyncSeriesBailHook.prototype = null;
  module.exports = AsyncSeriesBailHook;
});
var require_AsyncSeriesLoopHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class AsyncSeriesLoopHookCodeFactory extends HookCodeFactory {
    content({ onError, onDone }) {
      return this.callTapsLooping({
        onError: (i, err22, next, doneBreak) => onError(err22) + doneBreak(true),
        onDone
      });
    }
  }
  var factory = new AsyncSeriesLoopHookCodeFactory;
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function AsyncSeriesLoopHook(args = [], name = undefined) {
    const hook = new Hook(args, name);
    hook.constructor = AsyncSeriesLoopHook;
    hook.compile = COMPILE;
    hook._call = undefined;
    hook.call = undefined;
    return hook;
  }
  AsyncSeriesLoopHook.prototype = null;
  module.exports = AsyncSeriesLoopHook;
});
var require_AsyncSeriesWaterfallHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();
  var HookCodeFactory = require_HookCodeFactory();

  class AsyncSeriesWaterfallHookCodeFactory extends HookCodeFactory {
    content({ onError, onResult, onDone }) {
      return this.callTapsSeries({
        onError: (i, err22, next, doneBreak) => onError(err22) + doneBreak(true),
        onResult: (i, result2, next) => {
          let code = "";
          code += `if(${result2} !== undefined) {\n`;
          code += `${this._args[0]} = ${result2};\n`;
          code += `}\n`;
          code += next();
          return code;
        },
        onDone: () => onResult(this._args[0])
      });
    }
  }
  var factory = new AsyncSeriesWaterfallHookCodeFactory;
  var COMPILE = function(options3) {
    factory.setup(this, options3);
    return factory.create(options3);
  };
  function AsyncSeriesWaterfallHook(args = [], name = undefined) {
    if (args.length < 1)
      throw new Error("Waterfall hooks must have at least one argument");
    const hook = new Hook(args, name);
    hook.constructor = AsyncSeriesWaterfallHook;
    hook.compile = COMPILE;
    hook._call = undefined;
    hook.call = undefined;
    return hook;
  }
  AsyncSeriesWaterfallHook.prototype = null;
  module.exports = AsyncSeriesWaterfallHook;
});
var require_HookMap = __commonJS2((exports, module) => {
  var util = import.meta.require("util");
  var defaultFactory = (key, hook) => hook;

  class HookMap {
    constructor(factory, name = undefined) {
      this._map = new Map;
      this.name = name;
      this._factory = factory;
      this._interceptors = [];
    }
    get(key) {
      return this._map.get(key);
    }
    for(key) {
      const hook = this.get(key);
      if (hook !== undefined) {
        return hook;
      }
      let newHook = this._factory(key);
      const interceptors = this._interceptors;
      for (let i = 0;i < interceptors.length; i++) {
        newHook = interceptors[i].factory(key, newHook);
      }
      this._map.set(key, newHook);
      return newHook;
    }
    intercept(interceptor) {
      this._interceptors.push(Object.assign({
        factory: defaultFactory
      }, interceptor));
    }
  }
  HookMap.prototype.tap = util.deprecate(function(key, options3, fn) {
    return this.for(key).tap(options3, fn);
  }, "HookMap#tap(key,\u2026) is deprecated. Use HookMap#for(key).tap(\u2026) instead.");
  HookMap.prototype.tapAsync = util.deprecate(function(key, options3, fn) {
    return this.for(key).tapAsync(options3, fn);
  }, "HookMap#tapAsync(key,\u2026) is deprecated. Use HookMap#for(key).tapAsync(\u2026) instead.");
  HookMap.prototype.tapPromise = util.deprecate(function(key, options3, fn) {
    return this.for(key).tapPromise(options3, fn);
  }, "HookMap#tapPromise(key,\u2026) is deprecated. Use HookMap#for(key).tapPromise(\u2026) instead.");
  module.exports = HookMap;
});
var require_MultiHook = __commonJS2((exports, module) => {
  var Hook = require_Hook();

  class MultiHook {
    constructor(hooks, name = undefined) {
      this.hooks = hooks;
      this.name = name;
    }
    tap(options3, fn) {
      for (const hook of this.hooks) {
        hook.tap(options3, fn);
      }
    }
    tapAsync(options3, fn) {
      for (const hook of this.hooks) {
        hook.tapAsync(options3, fn);
      }
    }
    tapPromise(options3, fn) {
      for (const hook of this.hooks) {
        hook.tapPromise(options3, fn);
      }
    }
    isUsed() {
      for (const hook of this.hooks) {
        if (hook.isUsed())
          return true;
      }
      return false;
    }
    intercept(interceptor) {
      for (const hook of this.hooks) {
        hook.intercept(interceptor);
      }
    }
    withOptions(options3) {
      return new MultiHook(this.hooks.map((h22) => h22.withOptions(options3)), this.name);
    }
  }
  module.exports = MultiHook;
});
var require_lib12 = __commonJS2((exports) => {
  exports.__esModule = true;
  exports.SyncHook = require_SyncHook();
  exports.SyncBailHook = require_SyncBailHook();
  exports.SyncWaterfallHook = require_SyncWaterfallHook();
  exports.SyncLoopHook = require_SyncLoopHook();
  exports.AsyncParallelHook = require_AsyncParallelHook();
  exports.AsyncParallelBailHook = require_AsyncParallelBailHook();
  exports.AsyncSeriesHook = require_AsyncSeriesHook();
  exports.AsyncSeriesBailHook = require_AsyncSeriesBailHook();
  exports.AsyncSeriesLoopHook = require_AsyncSeriesLoopHook();
  exports.AsyncSeriesWaterfallHook = require_AsyncSeriesWaterfallHook();
  exports.HookMap = require_HookMap();
  exports.MultiHook = require_MultiHook();
});
var require_createInnerContext = __commonJS2((exports, module) => {
  module.exports = function createInnerContext(options3, message) {
    let messageReported = false;
    let innerLog = undefined;
    if (options3.log) {
      if (message) {
        innerLog = (msg) => {
          if (!messageReported) {
            options3.log(message);
            messageReported = true;
          }
          options3.log("  " + msg);
        };
      } else {
        innerLog = options3.log;
      }
    }
    return {
      log: innerLog,
      yield: options3.yield,
      fileDependencies: options3.fileDependencies,
      contextDependencies: options3.contextDependencies,
      missingDependencies: options3.missingDependencies,
      stack: options3.stack
    };
  };
});
var require_identifier2 = __commonJS2((exports, module) => {
  var PATH_QUERY_FRAGMENT_REGEXP = /^(#?(?:\0.|[^?#\0])*)(\?(?:\0.|[^#\0])*)?(#.*)?$/;
  function parseIdentifier(identifier) {
    const match = PATH_QUERY_FRAGMENT_REGEXP.exec(identifier);
    if (!match)
      return null;
    return [
      match[1].replace(/\0(.)/g, "$1"),
      match[2] ? match[2].replace(/\0(.)/g, "$1") : "",
      match[3] || ""
    ];
  }
  exports.parseIdentifier = parseIdentifier;
});
var require_path2 = __commonJS2((exports) => {
  var path3 = import.meta.require("path");
  var CHAR_HASH = "#".charCodeAt(0);
  var CHAR_SLASH = "/".charCodeAt(0);
  var CHAR_BACKSLASH = "\\".charCodeAt(0);
  var CHAR_A = "A".charCodeAt(0);
  var CHAR_Z = "Z".charCodeAt(0);
  var CHAR_LOWER_A = "a".charCodeAt(0);
  var CHAR_LOWER_Z = "z".charCodeAt(0);
  var CHAR_DOT = ".".charCodeAt(0);
  var CHAR_COLON = ":".charCodeAt(0);
  var posixNormalize = path3.posix.normalize;
  var winNormalize = path3.win32.normalize;
  var PathType = Object.freeze({
    Empty: 0,
    Normal: 1,
    Relative: 2,
    AbsoluteWin: 3,
    AbsolutePosix: 4,
    Internal: 5
  });
  exports.PathType = PathType;
  var invalidSegmentRegEx = /(^|\\|\/)((\.|%2e)(\.|%2e)?|(n|%6e|%4e)(o|%6f|%4f)(d|%64|%44)(e|%65|%45)(_|%5f)(m|%6d|%4d)(o|%6f|%4f)(d|%64|%44)(u|%75|%55)(l|%6c|%4c)(e|%65|%45)(s|%73|%53))?(\\|\/|$)/i;
  exports.invalidSegmentRegEx = invalidSegmentRegEx;
  var deprecatedInvalidSegmentRegEx = /(^|\\|\/)((\.|%2e)(\.|%2e)?|(n|%6e|%4e)(o|%6f|%4f)(d|%64|%44)(e|%65|%45)(_|%5f)(m|%6d|%4d)(o|%6f|%4f)(d|%64|%44)(u|%75|%55)(l|%6c|%4c)(e|%65|%45)(s|%73|%53))(\\|\/|$)/i;
  exports.deprecatedInvalidSegmentRegEx = deprecatedInvalidSegmentRegEx;
  var getType = (p32) => {
    switch (p32.length) {
      case 0:
        return PathType.Empty;
      case 1: {
        const c02 = p32.charCodeAt(0);
        switch (c02) {
          case CHAR_DOT:
            return PathType.Relative;
          case CHAR_SLASH:
            return PathType.AbsolutePosix;
          case CHAR_HASH:
            return PathType.Internal;
        }
        return PathType.Normal;
      }
      case 2: {
        const c02 = p32.charCodeAt(0);
        switch (c02) {
          case CHAR_DOT: {
            const c13 = p32.charCodeAt(1);
            switch (c13) {
              case CHAR_DOT:
              case CHAR_SLASH:
                return PathType.Relative;
            }
            return PathType.Normal;
          }
          case CHAR_SLASH:
            return PathType.AbsolutePosix;
          case CHAR_HASH:
            return PathType.Internal;
        }
        const c12 = p32.charCodeAt(1);
        if (c12 === CHAR_COLON) {
          if (c02 >= CHAR_A && c02 <= CHAR_Z || c02 >= CHAR_LOWER_A && c02 <= CHAR_LOWER_Z) {
            return PathType.AbsoluteWin;
          }
        }
        return PathType.Normal;
      }
    }
    const c0 = p32.charCodeAt(0);
    switch (c0) {
      case CHAR_DOT: {
        const c12 = p32.charCodeAt(1);
        switch (c12) {
          case CHAR_SLASH:
            return PathType.Relative;
          case CHAR_DOT: {
            const c22 = p32.charCodeAt(2);
            if (c22 === CHAR_SLASH)
              return PathType.Relative;
            return PathType.Normal;
          }
        }
        return PathType.Normal;
      }
      case CHAR_SLASH:
        return PathType.AbsolutePosix;
      case CHAR_HASH:
        return PathType.Internal;
    }
    const c1 = p32.charCodeAt(1);
    if (c1 === CHAR_COLON) {
      const c22 = p32.charCodeAt(2);
      if ((c22 === CHAR_BACKSLASH || c22 === CHAR_SLASH) && (c0 >= CHAR_A && c0 <= CHAR_Z || c0 >= CHAR_LOWER_A && c0 <= CHAR_LOWER_Z)) {
        return PathType.AbsoluteWin;
      }
    }
    return PathType.Normal;
  };
  exports.getType = getType;
  var normalize22 = (p32) => {
    switch (getType(p32)) {
      case PathType.Empty:
        return p32;
      case PathType.AbsoluteWin:
        return winNormalize(p32);
      case PathType.Relative: {
        const r22 = posixNormalize(p32);
        return getType(r22) === PathType.Relative ? r22 : `./${r22}`;
      }
    }
    return posixNormalize(p32);
  };
  exports.normalize = normalize22;
  var join23 = (rootPath, request2) => {
    if (!request2)
      return normalize22(rootPath);
    const requestType = getType(request2);
    switch (requestType) {
      case PathType.AbsolutePosix:
        return posixNormalize(request2);
      case PathType.AbsoluteWin:
        return winNormalize(request2);
    }
    switch (getType(rootPath)) {
      case PathType.Normal:
      case PathType.Relative:
      case PathType.AbsolutePosix:
        return posixNormalize(`${rootPath}/${request2}`);
      case PathType.AbsoluteWin:
        return winNormalize(`${rootPath}\\${request2}`);
    }
    switch (requestType) {
      case PathType.Empty:
        return rootPath;
      case PathType.Relative: {
        const r22 = posixNormalize(rootPath);
        return getType(r22) === PathType.Relative ? r22 : `./${r22}`;
      }
    }
    return posixNormalize(rootPath);
  };
  exports.join = join23;
  var joinCache = new Map;
  var cachedJoin = (rootPath, request2) => {
    let cacheEntry;
    let cache3 = joinCache.get(rootPath);
    if (cache3 === undefined) {
      joinCache.set(rootPath, cache3 = new Map);
    } else {
      cacheEntry = cache3.get(request2);
      if (cacheEntry !== undefined)
        return cacheEntry;
    }
    cacheEntry = join23(rootPath, request2);
    cache3.set(request2, cacheEntry);
    return cacheEntry;
  };
  exports.cachedJoin = cachedJoin;
});
var require_Resolver = __commonJS2((exports, module) => {
  var { AsyncSeriesBailHook, AsyncSeriesHook, SyncHook } = require_lib12();
  var createInnerContext = require_createInnerContext();
  var { parseIdentifier } = require_identifier2();
  var {
    normalize: normalize22,
    cachedJoin: join23,
    getType,
    PathType
  } = require_path2();
  function toCamelCase(str) {
    return str.replace(/-([a-z])/g, (str2) => str2.slice(1).toUpperCase());
  }

  class Resolver {
    static createStackEntry(hook, request2) {
      return hook.name + ": (" + request2.path + ") " + (request2.request || "") + (request2.query || "") + (request2.fragment || "") + (request2.directory ? " directory" : "") + (request2.module ? " module" : "");
    }
    constructor(fileSystem, options3) {
      this.fileSystem = fileSystem;
      this.options = options3;
      this.hooks = {
        resolveStep: new SyncHook(["hook", "request"], "resolveStep"),
        noResolve: new SyncHook(["request", "error"], "noResolve"),
        resolve: new AsyncSeriesBailHook(["request", "resolveContext"], "resolve"),
        result: new AsyncSeriesHook(["result", "resolveContext"], "result")
      };
    }
    ensureHook(name) {
      if (typeof name !== "string") {
        return name;
      }
      name = toCamelCase(name);
      if (/^before/.test(name)) {
        return this.ensureHook(name[6].toLowerCase() + name.slice(7)).withOptions({
          stage: -10
        });
      }
      if (/^after/.test(name)) {
        return this.ensureHook(name[5].toLowerCase() + name.slice(6)).withOptions({
          stage: 10
        });
      }
      const hook = this.hooks[name];
      if (!hook) {
        this.hooks[name] = new AsyncSeriesBailHook(["request", "resolveContext"], name);
        return this.hooks[name];
      }
      return hook;
    }
    getHook(name) {
      if (typeof name !== "string") {
        return name;
      }
      name = toCamelCase(name);
      if (/^before/.test(name)) {
        return this.getHook(name[6].toLowerCase() + name.slice(7)).withOptions({
          stage: -10
        });
      }
      if (/^after/.test(name)) {
        return this.getHook(name[5].toLowerCase() + name.slice(6)).withOptions({
          stage: 10
        });
      }
      const hook = this.hooks[name];
      if (!hook) {
        throw new Error(`Hook ${name} doesn't exist`);
      }
      return hook;
    }
    resolveSync(context, path3, request2) {
      let err22 = undefined;
      let result2 = undefined;
      let sync = false;
      this.resolve(context, path3, request2, {}, (e, r22) => {
        err22 = e;
        result2 = r22;
        sync = true;
      });
      if (!sync) {
        throw new Error("Cannot 'resolveSync' because the fileSystem is not sync. Use 'resolve'!");
      }
      if (err22)
        throw err22;
      if (result2 === undefined)
        throw new Error("No result");
      return result2;
    }
    resolve(context, path3, request2, resolveContext, callback) {
      if (!context || typeof context !== "object")
        return callback(new Error("context argument is not an object"));
      if (typeof path3 !== "string")
        return callback(new Error("path argument is not a string"));
      if (typeof request2 !== "string")
        return callback(new Error("request argument is not a string"));
      if (!resolveContext)
        return callback(new Error("resolveContext argument is not set"));
      const obj = {
        context,
        path: path3,
        request: request2
      };
      let yield_;
      let yieldCalled = false;
      let finishYield;
      if (typeof resolveContext.yield === "function") {
        const old = resolveContext.yield;
        yield_ = (obj2) => {
          old(obj2);
          yieldCalled = true;
        };
        finishYield = (result2) => {
          if (result2) {
            yield_(result2);
          }
          callback(null);
        };
      }
      const message = `resolve '${request2}' in '${path3}'`;
      const finishResolved = (result2) => {
        return callback(null, result2.path === false ? false : `${result2.path.replace(/#/g, "\0#")}${result2.query ? result2.query.replace(/#/g, "\0#") : ""}${result2.fragment || ""}`, result2);
      };
      const finishWithoutResolve = (log22) => {
        const error = new Error("Can't " + message);
        error.details = log22.join("\n");
        this.hooks.noResolve.call(obj, error);
        return callback(error);
      };
      if (resolveContext.log) {
        const parentLog = resolveContext.log;
        const log22 = [];
        return this.doResolve(this.hooks.resolve, obj, message, {
          log: (msg) => {
            parentLog(msg);
            log22.push(msg);
          },
          yield: yield_,
          fileDependencies: resolveContext.fileDependencies,
          contextDependencies: resolveContext.contextDependencies,
          missingDependencies: resolveContext.missingDependencies,
          stack: resolveContext.stack
        }, (err22, result2) => {
          if (err22)
            return callback(err22);
          if (yieldCalled || result2 && yield_) {
            return finishYield(result2);
          }
          if (result2)
            return finishResolved(result2);
          return finishWithoutResolve(log22);
        });
      } else {
        return this.doResolve(this.hooks.resolve, obj, message, {
          log: undefined,
          yield: yield_,
          fileDependencies: resolveContext.fileDependencies,
          contextDependencies: resolveContext.contextDependencies,
          missingDependencies: resolveContext.missingDependencies,
          stack: resolveContext.stack
        }, (err22, result2) => {
          if (err22)
            return callback(err22);
          if (yieldCalled || result2 && yield_) {
            return finishYield(result2);
          }
          if (result2)
            return finishResolved(result2);
          const log22 = [];
          return this.doResolve(this.hooks.resolve, obj, message, {
            log: (msg) => log22.push(msg),
            yield: yield_,
            stack: resolveContext.stack
          }, (err3, result3) => {
            if (err3)
              return callback(err3);
            if (yieldCalled || result3 && yield_) {
              return finishYield(result3);
            }
            return finishWithoutResolve(log22);
          });
        });
      }
    }
    doResolve(hook, request2, message, resolveContext, callback) {
      const stackEntry = Resolver.createStackEntry(hook, request2);
      let newStack;
      if (resolveContext.stack) {
        newStack = new Set(resolveContext.stack);
        if (resolveContext.stack.has(stackEntry)) {
          const recursionError = new Error("Recursion in resolving\nStack:\n  " + Array.from(newStack).join("\n  "));
          recursionError.recursion = true;
          if (resolveContext.log)
            resolveContext.log("abort resolving because of recursion");
          return callback(recursionError);
        }
        newStack.add(stackEntry);
      } else {
        newStack = new Set;
        newStack.add(stackEntry);
      }
      this.hooks.resolveStep.call(hook, request2);
      if (hook.isUsed()) {
        const innerContext = createInnerContext({
          log: resolveContext.log,
          yield: resolveContext.yield,
          fileDependencies: resolveContext.fileDependencies,
          contextDependencies: resolveContext.contextDependencies,
          missingDependencies: resolveContext.missingDependencies,
          stack: newStack
        }, message);
        return hook.callAsync(request2, innerContext, (err22, result2) => {
          if (err22)
            return callback(err22);
          if (result2)
            return callback(null, result2);
          callback();
        });
      } else {
        callback();
      }
    }
    parse(identifier) {
      const part = {
        request: "",
        query: "",
        fragment: "",
        module: false,
        directory: false,
        file: false,
        internal: false
      };
      const parsedIdentifier = parseIdentifier(identifier);
      if (!parsedIdentifier)
        return part;
      [part.request, part.query, part.fragment] = parsedIdentifier;
      if (part.request.length > 0) {
        part.internal = this.isPrivate(identifier);
        part.module = this.isModule(part.request);
        part.directory = this.isDirectory(part.request);
        if (part.directory) {
          part.request = part.request.slice(0, -1);
        }
      }
      return part;
    }
    isModule(path3) {
      return getType(path3) === PathType.Normal;
    }
    isPrivate(path3) {
      return getType(path3) === PathType.Internal;
    }
    isDirectory(path3) {
      return path3.endsWith("/");
    }
    join(path3, request2) {
      return join23(path3, request2);
    }
    normalize(path3) {
      return normalize22(path3);
    }
  }
  module.exports = Resolver;
});
var require_SyncAsyncFileSystemDecorator = __commonJS2((exports, module) => {
  function SyncAsyncFileSystemDecorator(fs2) {
    this.fs = fs2;
    this.lstat = undefined;
    this.lstatSync = undefined;
    const lstatSync3 = fs2.lstatSync;
    if (lstatSync3) {
      this.lstat = (arg, options3, callback) => {
        let result2;
        try {
          result2 = callback ? lstatSync3.call(fs2, arg, options3) : lstatSync3.call(fs2, arg);
        } catch (e) {
          return (callback || options3)(e);
        }
        (callback || options3)(null, result2);
      };
      this.lstatSync = (arg, options3) => lstatSync3.call(fs2, arg, options3);
    }
    this.stat = (arg, options3, callback) => {
      let result2;
      try {
        result2 = callback ? fs2.statSync(arg, options3) : fs2.statSync(arg);
      } catch (e) {
        return (callback || options3)(e);
      }
      (callback || options3)(null, result2);
    };
    this.statSync = (arg, options3) => fs2.statSync(arg, options3);
    this.readdir = (arg, options3, callback) => {
      let result2;
      try {
        result2 = callback ? fs2.readdirSync(arg, options3) : fs2.readdirSync(arg);
      } catch (e) {
        return (callback || options3)(e);
      }
      (callback || options3)(null, result2);
    };
    this.readdirSync = (arg, options3) => fs2.readdirSync(arg, options3);
    this.readFile = (arg, options3, callback) => {
      let result2;
      try {
        result2 = callback ? fs2.readFileSync(arg, options3) : fs2.readFileSync(arg);
      } catch (e) {
        return (callback || options3)(e);
      }
      (callback || options3)(null, result2);
    };
    this.readFileSync = (arg, options3) => fs2.readFileSync(arg, options3);
    this.readlink = (arg, options3, callback) => {
      let result2;
      try {
        result2 = callback ? fs2.readlinkSync(arg, options3) : fs2.readlinkSync(arg);
      } catch (e) {
        return (callback || options3)(e);
      }
      (callback || options3)(null, result2);
    };
    this.readlinkSync = (arg, options3) => fs2.readlinkSync(arg, options3);
    this.readJson = undefined;
    this.readJsonSync = undefined;
    const readJsonSync = fs2.readJsonSync;
    if (readJsonSync) {
      this.readJson = (arg, callback) => {
        let result2;
        try {
          result2 = readJsonSync.call(fs2, arg);
        } catch (e) {
          return callback(e);
        }
        callback(null, result2);
      };
      this.readJsonSync = (arg) => readJsonSync.call(fs2, arg);
    }
    this.realpath = undefined;
    this.realpathSync = undefined;
    const realpathSync2 = fs2.realpathSync;
    if (realpathSync2) {
      this.realpath = (arg, options3, callback) => {
        let result2;
        try {
          result2 = callback ? realpathSync2.call(fs2, arg, options3) : realpathSync2.call(fs2, arg);
        } catch (e) {
          return (callback || options3)(e);
        }
        (callback || options3)(null, result2);
      };
      this.realpathSync = (arg, options3) => realpathSync2.call(fs2, arg, options3);
    }
  }
  module.exports = SyncAsyncFileSystemDecorator;
});
var require_forEachBail = __commonJS2((exports, module) => {
  module.exports = function forEachBail(array, iterator, callback) {
    if (array.length === 0)
      return callback();
    let i = 0;
    const next = () => {
      let loop = undefined;
      iterator(array[i++], (err22, result2) => {
        if (err22 || result2 !== undefined || i >= array.length) {
          return callback(err22, result2, i);
        }
        if (loop === false)
          while (next())
            ;
        loop = true;
      }, i);
      if (!loop)
        loop = false;
      return loop;
    };
    while (next())
      ;
  };
});
var require_DescriptionFileUtils = __commonJS2((exports) => {
  var forEachBail = require_forEachBail();
  function loadDescriptionFile(resolver, directory, filenames, oldInfo, resolveContext, callback) {
    (function findDescriptionFile() {
      if (oldInfo && oldInfo.directory === directory) {
        return callback(null, oldInfo);
      }
      forEachBail(filenames, (filename2, callback2) => {
        const descriptionFilePath = resolver.join(directory, filename2);
        if (resolver.fileSystem.readJson) {
          resolver.fileSystem.readJson(descriptionFilePath, (err22, content) => {
            if (err22) {
              if (typeof err22.code !== "undefined") {
                if (resolveContext.missingDependencies) {
                  resolveContext.missingDependencies.add(descriptionFilePath);
                }
                return callback2();
              }
              if (resolveContext.fileDependencies) {
                resolveContext.fileDependencies.add(descriptionFilePath);
              }
              return onJson(err22);
            }
            if (resolveContext.fileDependencies) {
              resolveContext.fileDependencies.add(descriptionFilePath);
            }
            onJson(null, content);
          });
        } else {
          resolver.fileSystem.readFile(descriptionFilePath, (err22, content) => {
            if (err22) {
              if (resolveContext.missingDependencies) {
                resolveContext.missingDependencies.add(descriptionFilePath);
              }
              return callback2();
            }
            if (resolveContext.fileDependencies) {
              resolveContext.fileDependencies.add(descriptionFilePath);
            }
            let json;
            if (content) {
              try {
                json = JSON.parse(content.toString());
              } catch (e) {
                return onJson(e);
              }
            } else {
              return onJson(new Error("No content in file"));
            }
            onJson(null, json);
          });
        }
        function onJson(err22, content) {
          if (err22) {
            if (resolveContext.log)
              resolveContext.log(descriptionFilePath + " (directory description file): " + err22);
            else
              err22.message = descriptionFilePath + " (directory description file): " + err22;
            return callback2(err22);
          }
          callback2(null, {
            content,
            directory,
            path: descriptionFilePath
          });
        }
      }, (err22, result2) => {
        if (err22)
          return callback(err22);
        if (result2) {
          return callback(null, result2);
        } else {
          const dir = cdUp(directory);
          if (!dir) {
            return callback();
          } else {
            directory = dir;
            return findDescriptionFile();
          }
        }
      });
    })();
  }
  function getField(content, field) {
    if (!content)
      return;
    if (Array.isArray(field)) {
      let current = content;
      for (let j22 = 0;j22 < field.length; j22++) {
        if (current === null || typeof current !== "object") {
          current = null;
          break;
        }
        current = current[field[j22]];
      }
      return current;
    } else {
      return content[field];
    }
  }
  function cdUp(directory) {
    if (directory === "/")
      return null;
    const i = directory.lastIndexOf("/"), j22 = directory.lastIndexOf("\\");
    const p32 = i < 0 ? j22 : j22 < 0 ? i : i < j22 ? j22 : i;
    if (p32 < 0)
      return null;
    return directory.slice(0, p32 || 1);
  }
  exports.loadDescriptionFile = loadDescriptionFile;
  exports.getField = getField;
  exports.cdUp = cdUp;
});
var require_getInnerRequest = __commonJS2((exports, module) => {
  module.exports = function getInnerRequest(resolver, request2) {
    if (typeof request2.__innerRequest === "string" && request2.__innerRequest_request === request2.request && request2.__innerRequest_relativePath === request2.relativePath)
      return request2.__innerRequest;
    let innerRequest;
    if (request2.request) {
      innerRequest = request2.request;
      if (/^\.\.?(?:\/|$)/.test(innerRequest) && request2.relativePath) {
        innerRequest = resolver.join(request2.relativePath, innerRequest);
      }
    } else {
      innerRequest = request2.relativePath;
    }
    request2.__innerRequest_request = request2.request;
    request2.__innerRequest_relativePath = request2.relativePath;
    return request2.__innerRequest = innerRequest;
  };
});
var require_AliasFieldPlugin = __commonJS2((exports, module) => {
  var DescriptionFileUtils = require_DescriptionFileUtils();
  var getInnerRequest = require_getInnerRequest();
  module.exports = class AliasFieldPlugin {
    constructor(source, field, target) {
      this.source = source;
      this.field = field;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("AliasFieldPlugin", (request2, resolveContext, callback) => {
        if (!request2.descriptionFileData)
          return callback();
        const innerRequest = getInnerRequest(resolver, request2);
        if (!innerRequest)
          return callback();
        const fieldData = DescriptionFileUtils.getField(request2.descriptionFileData, this.field);
        if (fieldData === null || typeof fieldData !== "object") {
          if (resolveContext.log)
            resolveContext.log("Field '" + this.field + "' doesn't contain a valid alias configuration");
          return callback();
        }
        const data = Object.prototype.hasOwnProperty.call(fieldData, innerRequest) ? fieldData[innerRequest] : innerRequest.startsWith("./") ? fieldData[innerRequest.slice(2)] : undefined;
        if (data === innerRequest)
          return callback();
        if (data === undefined)
          return callback();
        if (data === false) {
          const ignoreObj = {
            ...request2,
            path: false
          };
          if (typeof resolveContext.yield === "function") {
            resolveContext.yield(ignoreObj);
            return callback(null, null);
          }
          return callback(null, ignoreObj);
        }
        const obj = {
          ...request2,
          path: request2.descriptionFileRoot,
          request: data,
          fullySpecified: false
        };
        resolver.doResolve(target, obj, "aliased from description file " + request2.descriptionFilePath + " with mapping '" + innerRequest + "' to '" + data + "'", resolveContext, (err22, result2) => {
          if (err22)
            return callback(err22);
          if (result2 === undefined)
            return callback(null, null);
          callback(null, result2);
        });
      });
    }
  };
});
var require_AliasPlugin = __commonJS2((exports, module) => {
  var forEachBail = require_forEachBail();
  var { PathType, getType } = require_path2();
  module.exports = class AliasPlugin {
    constructor(source, options3, target) {
      this.source = source;
      this.options = Array.isArray(options3) ? options3 : [options3];
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      const getAbsolutePathWithSlashEnding = (maybeAbsolutePath) => {
        const type = getType(maybeAbsolutePath);
        if (type === PathType.AbsolutePosix || type === PathType.AbsoluteWin) {
          return resolver.join(maybeAbsolutePath, "_").slice(0, -1);
        }
        return null;
      };
      const isSubPath = (path3, maybeSubPath) => {
        const absolutePath = getAbsolutePathWithSlashEnding(maybeSubPath);
        if (!absolutePath)
          return false;
        return path3.startsWith(absolutePath);
      };
      resolver.getHook(this.source).tapAsync("AliasPlugin", (request2, resolveContext, callback) => {
        const innerRequest = request2.request || request2.path;
        if (!innerRequest)
          return callback();
        forEachBail(this.options, (item, callback2) => {
          let shouldStop = false;
          if (innerRequest === item.name || !item.onlyModule && (request2.request ? innerRequest.startsWith(`${item.name}/`) : isSubPath(innerRequest, item.name))) {
            const remainingRequest = innerRequest.slice(item.name.length);
            const resolveWithAlias = (alias, callback3) => {
              if (alias === false) {
                const ignoreObj = {
                  ...request2,
                  path: false
                };
                if (typeof resolveContext.yield === "function") {
                  resolveContext.yield(ignoreObj);
                  return callback3(null, null);
                }
                return callback3(null, ignoreObj);
              }
              if (innerRequest !== alias && !innerRequest.startsWith(alias + "/")) {
                shouldStop = true;
                const newRequestStr = alias + remainingRequest;
                const obj = {
                  ...request2,
                  request: newRequestStr,
                  fullySpecified: false
                };
                return resolver.doResolve(target, obj, "aliased with mapping '" + item.name + "': '" + alias + "' to '" + newRequestStr + "'", resolveContext, (err22, result2) => {
                  if (err22)
                    return callback3(err22);
                  if (result2)
                    return callback3(null, result2);
                  return callback3();
                });
              }
              return callback3();
            };
            const stoppingCallback = (err22, result2) => {
              if (err22)
                return callback2(err22);
              if (result2)
                return callback2(null, result2);
              if (shouldStop)
                return callback2(null, null);
              return callback2();
            };
            if (Array.isArray(item.alias)) {
              return forEachBail(item.alias, resolveWithAlias, stoppingCallback);
            } else {
              return resolveWithAlias(item.alias, stoppingCallback);
            }
          }
          return callback2();
        }, callback);
      });
    }
  };
});
var require_AppendPlugin = __commonJS2((exports, module) => {
  module.exports = class AppendPlugin {
    constructor(source, appending, target) {
      this.source = source;
      this.appending = appending;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("AppendPlugin", (request2, resolveContext, callback) => {
        const obj = {
          ...request2,
          path: request2.path + this.appending,
          relativePath: request2.relativePath && request2.relativePath + this.appending
        };
        resolver.doResolve(target, obj, this.appending, resolveContext, callback);
      });
    }
  };
});
var require_ConditionalPlugin = __commonJS2((exports, module) => {
  module.exports = class ConditionalPlugin {
    constructor(source, test, message, allowAlternatives, target) {
      this.source = source;
      this.test = test;
      this.message = message;
      this.allowAlternatives = allowAlternatives;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      const { test, message, allowAlternatives } = this;
      const keys = Object.keys(test);
      resolver.getHook(this.source).tapAsync("ConditionalPlugin", (request2, resolveContext, callback) => {
        for (const prop of keys) {
          if (request2[prop] !== test[prop])
            return callback();
        }
        resolver.doResolve(target, request2, message, resolveContext, allowAlternatives ? callback : (err22, result2) => {
          if (err22)
            return callback(err22);
          if (result2 === undefined)
            return callback(null, null);
          callback(null, result2);
        });
      });
    }
  };
});
var require_DescriptionFilePlugin = __commonJS2((exports, module) => {
  var DescriptionFileUtils = require_DescriptionFileUtils();
  module.exports = class DescriptionFilePlugin {
    constructor(source, filenames, pathIsFile, target) {
      this.source = source;
      this.filenames = filenames;
      this.pathIsFile = pathIsFile;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("DescriptionFilePlugin", (request2, resolveContext, callback) => {
        const path3 = request2.path;
        if (!path3)
          return callback();
        const directory = this.pathIsFile ? DescriptionFileUtils.cdUp(path3) : path3;
        if (!directory)
          return callback();
        DescriptionFileUtils.loadDescriptionFile(resolver, directory, this.filenames, request2.descriptionFilePath ? {
          path: request2.descriptionFilePath,
          content: request2.descriptionFileData,
          directory: request2.descriptionFileRoot
        } : undefined, resolveContext, (err22, result2) => {
          if (err22)
            return callback(err22);
          if (!result2) {
            if (resolveContext.log)
              resolveContext.log(`No description file found in ${directory} or above`);
            return callback();
          }
          const relativePath = "." + path3.slice(result2.directory.length).replace(/\\/g, "/");
          const obj = {
            ...request2,
            descriptionFilePath: result2.path,
            descriptionFileData: result2.content,
            descriptionFileRoot: result2.directory,
            relativePath
          };
          resolver.doResolve(target, obj, "using description file: " + result2.path + " (relative path: " + relativePath + ")", resolveContext, (err3, result3) => {
            if (err3)
              return callback(err3);
            if (result3 === undefined)
              return callback(null, null);
            callback(null, result3);
          });
        });
      });
    }
  };
});
var require_DirectoryExistsPlugin = __commonJS2((exports, module) => {
  module.exports = class DirectoryExistsPlugin {
    constructor(source, target) {
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("DirectoryExistsPlugin", (request2, resolveContext, callback) => {
        const fs2 = resolver.fileSystem;
        const directory = request2.path;
        if (!directory)
          return callback();
        fs2.stat(directory, (err22, stat) => {
          if (err22 || !stat) {
            if (resolveContext.missingDependencies)
              resolveContext.missingDependencies.add(directory);
            if (resolveContext.log)
              resolveContext.log(directory + " doesn't exist");
            return callback();
          }
          if (!stat.isDirectory()) {
            if (resolveContext.missingDependencies)
              resolveContext.missingDependencies.add(directory);
            if (resolveContext.log)
              resolveContext.log(directory + " is not a directory");
            return callback();
          }
          if (resolveContext.fileDependencies)
            resolveContext.fileDependencies.add(directory);
          resolver.doResolve(target, request2, `existing directory ${directory}`, resolveContext, callback);
        });
      });
    }
  };
});
var require_entrypoints = __commonJS2((exports, module) => {
  var { parseIdentifier } = require_identifier2();
  var slashCode = "/".charCodeAt(0);
  var dotCode = ".".charCodeAt(0);
  var hashCode = "#".charCodeAt(0);
  var patternRegEx = /\*/g;
  exports.processExportsField = function processExportsField(exportsField) {
    return createFieldProcessor(buildExportsField(exportsField), (request2) => request2.length === 0 ? "." : "./" + request2, assertExportsFieldRequest, assertExportTarget);
  };
  exports.processImportsField = function processImportsField(importsField) {
    return createFieldProcessor(importsField, (request2) => "#" + request2, assertImportsFieldRequest, assertImportTarget);
  };
  function createFieldProcessor(field, normalizeRequest, assertRequest, assertTarget) {
    return function fieldProcessor(request2, conditionNames) {
      request2 = assertRequest(request2);
      const match = findMatch(normalizeRequest(request2), field);
      if (match === null)
        return [[], null];
      const [mapping, remainingRequest, isSubpathMapping, isPattern, usedField] = match;
      let direct = null;
      if (isConditionalMapping(mapping)) {
        direct = conditionalMapping(mapping, conditionNames);
        if (direct === null)
          return [[], null];
      } else {
        direct = mapping;
      }
      return [
        directMapping(remainingRequest, isPattern, isSubpathMapping, direct, conditionNames, assertTarget),
        usedField
      ];
    };
  }
  function assertExportsFieldRequest(request2) {
    if (request2.charCodeAt(0) !== dotCode) {
      throw new Error('Request should be relative path and start with "."');
    }
    if (request2.length === 1)
      return "";
    if (request2.charCodeAt(1) !== slashCode) {
      throw new Error('Request should be relative path and start with "./"');
    }
    if (request2.charCodeAt(request2.length - 1) === slashCode) {
      throw new Error("Only requesting file allowed");
    }
    return request2.slice(2);
  }
  function assertImportsFieldRequest(request2) {
    if (request2.charCodeAt(0) !== hashCode) {
      throw new Error('Request should start with "#"');
    }
    if (request2.length === 1) {
      throw new Error("Request should have at least 2 characters");
    }
    if (request2.charCodeAt(1) === slashCode) {
      throw new Error('Request should not start with "#/"');
    }
    if (request2.charCodeAt(request2.length - 1) === slashCode) {
      throw new Error("Only requesting file allowed");
    }
    return request2.slice(1);
  }
  function assertExportTarget(exp, expectFolder) {
    const parsedIdentifier = parseIdentifier(exp);
    if (!parsedIdentifier) {
      return;
    }
    const [relativePath] = parsedIdentifier;
    const isFolder = relativePath.charCodeAt(relativePath.length - 1) === slashCode;
    if (isFolder !== expectFolder) {
      throw new Error(expectFolder ? `Expecting folder to folder mapping. ${JSON.stringify(exp)} should end with "/"` : `Expecting file to file mapping. ${JSON.stringify(exp)} should not end with "/"`);
    }
  }
  function assertImportTarget(imp, expectFolder) {
    const parsedIdentifier = parseIdentifier(imp);
    if (!parsedIdentifier) {
      return;
    }
    const [relativePath] = parsedIdentifier;
    const isFolder = relativePath.charCodeAt(relativePath.length - 1) === slashCode;
    if (isFolder !== expectFolder) {
      throw new Error(expectFolder ? `Expecting folder to folder mapping. ${JSON.stringify(imp)} should end with "/"` : `Expecting file to file mapping. ${JSON.stringify(imp)} should not end with "/"`);
    }
  }
  function patternKeyCompare(a, b22) {
    const aPatternIndex = a.indexOf("*");
    const bPatternIndex = b22.indexOf("*");
    const baseLenA = aPatternIndex === -1 ? a.length : aPatternIndex + 1;
    const baseLenB = bPatternIndex === -1 ? b22.length : bPatternIndex + 1;
    if (baseLenA > baseLenB)
      return -1;
    if (baseLenB > baseLenA)
      return 1;
    if (aPatternIndex === -1)
      return 1;
    if (bPatternIndex === -1)
      return -1;
    if (a.length > b22.length)
      return -1;
    if (b22.length > a.length)
      return 1;
    return 0;
  }
  function findMatch(request2, field) {
    if (Object.prototype.hasOwnProperty.call(field, request2) && !request2.includes("*") && !request2.endsWith("/")) {
      const target2 = field[request2];
      return [target2, "", false, false, request2];
    }
    let bestMatch = "";
    let bestMatchSubpath;
    const keys = Object.getOwnPropertyNames(field);
    for (let i = 0;i < keys.length; i++) {
      const key = keys[i];
      const patternIndex = key.indexOf("*");
      if (patternIndex !== -1 && request2.startsWith(key.slice(0, patternIndex))) {
        const patternTrailer = key.slice(patternIndex + 1);
        if (request2.length >= key.length && request2.endsWith(patternTrailer) && patternKeyCompare(bestMatch, key) === 1 && key.lastIndexOf("*") === patternIndex) {
          bestMatch = key;
          bestMatchSubpath = request2.slice(patternIndex, request2.length - patternTrailer.length);
        }
      } else if (key[key.length - 1] === "/" && request2.startsWith(key) && patternKeyCompare(bestMatch, key) === 1) {
        bestMatch = key;
        bestMatchSubpath = request2.slice(key.length);
      }
    }
    if (bestMatch === "")
      return null;
    const target = field[bestMatch];
    const isSubpathMapping = bestMatch.endsWith("/");
    const isPattern = bestMatch.includes("*");
    return [
      target,
      bestMatchSubpath,
      isSubpathMapping,
      isPattern,
      bestMatch
    ];
  }
  function isConditionalMapping(mapping) {
    return mapping !== null && typeof mapping === "object" && !Array.isArray(mapping);
  }
  function directMapping(remainingRequest, isPattern, isSubpathMapping, mappingTarget, conditionNames, assert) {
    if (mappingTarget === null)
      return [];
    if (typeof mappingTarget === "string") {
      return [
        targetMapping(remainingRequest, isPattern, isSubpathMapping, mappingTarget, assert)
      ];
    }
    const targets = [];
    for (const exp of mappingTarget) {
      if (typeof exp === "string") {
        targets.push(targetMapping(remainingRequest, isPattern, isSubpathMapping, exp, assert));
        continue;
      }
      const mapping = conditionalMapping(exp, conditionNames);
      if (!mapping)
        continue;
      const innerExports = directMapping(remainingRequest, isPattern, isSubpathMapping, mapping, conditionNames, assert);
      for (const innerExport of innerExports) {
        targets.push(innerExport);
      }
    }
    return targets;
  }
  function targetMapping(remainingRequest, isPattern, isSubpathMapping, mappingTarget, assert) {
    if (remainingRequest === undefined) {
      assert(mappingTarget, false);
      return mappingTarget;
    }
    if (isSubpathMapping) {
      assert(mappingTarget, true);
      return mappingTarget + remainingRequest;
    }
    assert(mappingTarget, false);
    let result2 = mappingTarget;
    if (isPattern) {
      result2 = result2.replace(patternRegEx, remainingRequest.replace(/\$/g, "$$"));
    }
    return result2;
  }
  function conditionalMapping(conditionalMapping_, conditionNames) {
    let lookup2 = [[conditionalMapping_, Object.keys(conditionalMapping_), 0]];
    loop:
      while (lookup2.length > 0) {
        const [mapping, conditions, j22] = lookup2[lookup2.length - 1];
        for (let i = j22;i < conditions.length; i++) {
          const condition = conditions[i];
          if (condition === "default") {
            const innerMapping = mapping[condition];
            if (isConditionalMapping(innerMapping)) {
              const conditionalMapping2 = innerMapping;
              lookup2[lookup2.length - 1][2] = i + 1;
              lookup2.push([conditionalMapping2, Object.keys(conditionalMapping2), 0]);
              continue loop;
            }
            return innerMapping;
          }
          if (conditionNames.has(condition)) {
            const innerMapping = mapping[condition];
            if (isConditionalMapping(innerMapping)) {
              const conditionalMapping2 = innerMapping;
              lookup2[lookup2.length - 1][2] = i + 1;
              lookup2.push([conditionalMapping2, Object.keys(conditionalMapping2), 0]);
              continue loop;
            }
            return innerMapping;
          }
        }
        lookup2.pop();
      }
    return null;
  }
  function buildExportsField(field) {
    if (typeof field === "string" || Array.isArray(field)) {
      return { ".": field };
    }
    const keys = Object.keys(field);
    for (let i = 0;i < keys.length; i++) {
      const key = keys[i];
      if (key.charCodeAt(0) !== dotCode) {
        if (i === 0) {
          while (i < keys.length) {
            const charCode = keys[i].charCodeAt(0);
            if (charCode === dotCode || charCode === slashCode) {
              throw new Error(`Exports field key should be relative path and start with "." (key: ${JSON.stringify(key)})`);
            }
            i++;
          }
          return { ".": field };
        }
        throw new Error(`Exports field key should be relative path and start with "." (key: ${JSON.stringify(key)})`);
      }
      if (key.length === 1) {
        continue;
      }
      if (key.charCodeAt(1) !== slashCode) {
        throw new Error(`Exports field key should be relative path and start with "./" (key: ${JSON.stringify(key)})`);
      }
    }
    return field;
  }
});
var require_ExportsFieldPlugin = __commonJS2((exports, module) => {
  var DescriptionFileUtils = require_DescriptionFileUtils();
  var forEachBail = require_forEachBail();
  var { processExportsField } = require_entrypoints();
  var { parseIdentifier } = require_identifier2();
  var {
    invalidSegmentRegEx,
    deprecatedInvalidSegmentRegEx
  } = require_path2();
  module.exports = class ExportsFieldPlugin {
    constructor(source, conditionNames, fieldNamePath, target) {
      this.source = source;
      this.target = target;
      this.conditionNames = conditionNames;
      this.fieldName = fieldNamePath;
      this.fieldProcessorCache = new WeakMap;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("ExportsFieldPlugin", (request2, resolveContext, callback) => {
        if (!request2.descriptionFilePath)
          return callback();
        if (request2.relativePath !== "." || request2.request === undefined)
          return callback();
        const remainingRequest = request2.query || request2.fragment ? (request2.request === "." ? "./" : request2.request) + request2.query + request2.fragment : request2.request;
        const exportsField = DescriptionFileUtils.getField(request2.descriptionFileData, this.fieldName);
        if (!exportsField)
          return callback();
        if (request2.directory) {
          return callback(new Error(`Resolving to directories is not possible with the exports field (request was ${remainingRequest}/)`));
        }
        let paths;
        let usedField;
        try {
          let fieldProcessor = this.fieldProcessorCache.get(request2.descriptionFileData);
          if (fieldProcessor === undefined) {
            fieldProcessor = processExportsField(exportsField);
            this.fieldProcessorCache.set(request2.descriptionFileData, fieldProcessor);
          }
          [paths, usedField] = fieldProcessor(remainingRequest, this.conditionNames);
        } catch (err22) {
          if (resolveContext.log) {
            resolveContext.log(`Exports field in ${request2.descriptionFilePath} can't be processed: ${err22}`);
          }
          return callback(err22);
        }
        if (paths.length === 0) {
          return callback(new Error(`Package path ${remainingRequest} is not exported from package ${request2.descriptionFileRoot} (see exports field in ${request2.descriptionFilePath})`));
        }
        forEachBail(paths, (p32, callback2, i) => {
          const parsedIdentifier = parseIdentifier(p32);
          if (!parsedIdentifier)
            return callback2();
          const [relativePath, query, fragment] = parsedIdentifier;
          if (relativePath.length === 0 || !relativePath.startsWith("./")) {
            if (paths.length === i) {
              return callback2(new Error(`Invalid "exports" target "${p32}" defined for "${usedField}" in the package config ${request2.descriptionFilePath}, targets must start with "./"`));
            }
            return callback2();
          }
          if (invalidSegmentRegEx.exec(relativePath.slice(2)) !== null && deprecatedInvalidSegmentRegEx.test(relativePath.slice(2)) !== null) {
            if (paths.length === i) {
              return callback2(new Error(`Invalid "exports" target "${p32}" defined for "${usedField}" in the package config ${request2.descriptionFilePath}, targets must start with "./"`));
            }
            return callback2();
          }
          const obj = {
            ...request2,
            request: undefined,
            path: resolver.join(request2.descriptionFileRoot, relativePath),
            relativePath,
            query,
            fragment
          };
          resolver.doResolve(target, obj, "using exports field: " + p32, resolveContext, (err22, result2) => {
            if (err22)
              return callback2(err22);
            if (result2 === undefined)
              return callback2(null, null);
            callback2(null, result2);
          });
        }, (err22, result2) => callback(err22, result2 || null));
      });
    }
  };
});
var require_ExtensionAliasPlugin = __commonJS2((exports, module) => {
  var forEachBail = require_forEachBail();
  module.exports = class ExtensionAliasPlugin {
    constructor(source, options3, target) {
      this.source = source;
      this.options = options3;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      const { extension: extension2, alias } = this.options;
      resolver.getHook(this.source).tapAsync("ExtensionAliasPlugin", (request2, resolveContext, callback) => {
        const requestPath = request2.request;
        if (!requestPath || !requestPath.endsWith(extension2))
          return callback();
        const isAliasString = typeof alias === "string";
        const resolve23 = (alias2, callback2, index) => {
          const newRequest = `${requestPath.slice(0, -extension2.length)}${alias2}`;
          return resolver.doResolve(target, {
            ...request2,
            request: newRequest,
            fullySpecified: true
          }, `aliased from extension alias with mapping '${extension2}' to '${alias2}'`, resolveContext, (err22, result2) => {
            if (!isAliasString && index) {
              if (index !== this.options.alias.length) {
                if (resolveContext.log) {
                  resolveContext.log(`Failed to alias from extension alias with mapping '${extension2}' to '${alias2}' for '${newRequest}': ${err22}`);
                }
                return callback2(null, result2);
              }
              return callback2(err22, result2);
            } else {
              callback2(err22, result2);
            }
          });
        };
        const stoppingCallback = (err22, result2) => {
          if (err22)
            return callback(err22);
          if (result2)
            return callback(null, result2);
          return callback(null, null);
        };
        if (isAliasString) {
          resolve23(alias, stoppingCallback);
        } else if (alias.length > 1) {
          forEachBail(alias, resolve23, stoppingCallback);
        } else {
          resolve23(alias[0], stoppingCallback);
        }
      });
    }
  };
});
var require_FileExistsPlugin = __commonJS2((exports, module) => {
  module.exports = class FileExistsPlugin {
    constructor(source, target) {
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      const fs2 = resolver.fileSystem;
      resolver.getHook(this.source).tapAsync("FileExistsPlugin", (request2, resolveContext, callback) => {
        const file = request2.path;
        if (!file)
          return callback();
        fs2.stat(file, (err22, stat) => {
          if (err22 || !stat) {
            if (resolveContext.missingDependencies)
              resolveContext.missingDependencies.add(file);
            if (resolveContext.log)
              resolveContext.log(file + " doesn't exist");
            return callback();
          }
          if (!stat.isFile()) {
            if (resolveContext.missingDependencies)
              resolveContext.missingDependencies.add(file);
            if (resolveContext.log)
              resolveContext.log(file + " is not a file");
            return callback();
          }
          if (resolveContext.fileDependencies)
            resolveContext.fileDependencies.add(file);
          resolver.doResolve(target, request2, "existing file: " + file, resolveContext, callback);
        });
      });
    }
  };
});
var require_ImportsFieldPlugin = __commonJS2((exports, module) => {
  var DescriptionFileUtils = require_DescriptionFileUtils();
  var forEachBail = require_forEachBail();
  var { processImportsField } = require_entrypoints();
  var { parseIdentifier } = require_identifier2();
  var {
    invalidSegmentRegEx,
    deprecatedInvalidSegmentRegEx
  } = require_path2();
  var dotCode = ".".charCodeAt(0);
  module.exports = class ImportsFieldPlugin {
    constructor(source, conditionNames, fieldNamePath, targetFile, targetPackage) {
      this.source = source;
      this.targetFile = targetFile;
      this.targetPackage = targetPackage;
      this.conditionNames = conditionNames;
      this.fieldName = fieldNamePath;
      this.fieldProcessorCache = new WeakMap;
    }
    apply(resolver) {
      const targetFile = resolver.ensureHook(this.targetFile);
      const targetPackage = resolver.ensureHook(this.targetPackage);
      resolver.getHook(this.source).tapAsync("ImportsFieldPlugin", (request2, resolveContext, callback) => {
        if (!request2.descriptionFilePath || request2.request === undefined) {
          return callback();
        }
        const remainingRequest = request2.request + request2.query + request2.fragment;
        const importsField = DescriptionFileUtils.getField(request2.descriptionFileData, this.fieldName);
        if (!importsField)
          return callback();
        if (request2.directory) {
          return callback(new Error(`Resolving to directories is not possible with the imports field (request was ${remainingRequest}/)`));
        }
        let paths;
        let usedField;
        try {
          let fieldProcessor = this.fieldProcessorCache.get(request2.descriptionFileData);
          if (fieldProcessor === undefined) {
            fieldProcessor = processImportsField(importsField);
            this.fieldProcessorCache.set(request2.descriptionFileData, fieldProcessor);
          }
          [paths, usedField] = fieldProcessor(remainingRequest, this.conditionNames);
        } catch (err22) {
          if (resolveContext.log) {
            resolveContext.log(`Imports field in ${request2.descriptionFilePath} can't be processed: ${err22}`);
          }
          return callback(err22);
        }
        if (paths.length === 0) {
          return callback(new Error(`Package import ${remainingRequest} is not imported from package ${request2.descriptionFileRoot} (see imports field in ${request2.descriptionFilePath})`));
        }
        forEachBail(paths, (p32, callback2, i) => {
          const parsedIdentifier = parseIdentifier(p32);
          if (!parsedIdentifier)
            return callback2();
          const [path_, query, fragment] = parsedIdentifier;
          switch (path_.charCodeAt(0)) {
            case dotCode: {
              if (invalidSegmentRegEx.exec(path_.slice(2)) !== null && deprecatedInvalidSegmentRegEx.test(path_.slice(2)) !== null) {
                if (paths.length === i) {
                  return callback2(new Error(`Invalid "imports" target "${p32}" defined for "${usedField}" in the package config ${request2.descriptionFilePath}, targets must start with "./"`));
                }
                return callback2();
              }
              const obj = {
                ...request2,
                request: undefined,
                path: resolver.join(request2.descriptionFileRoot, path_),
                relativePath: path_,
                query,
                fragment
              };
              resolver.doResolve(targetFile, obj, "using imports field: " + p32, resolveContext, (err22, result2) => {
                if (err22)
                  return callback2(err22);
                if (result2 === undefined)
                  return callback2(null, null);
                callback2(null, result2);
              });
              break;
            }
            default: {
              const obj = {
                ...request2,
                request: path_,
                relativePath: path_,
                fullySpecified: true,
                query,
                fragment
              };
              resolver.doResolve(targetPackage, obj, "using imports field: " + p32, resolveContext, (err22, result2) => {
                if (err22)
                  return callback2(err22);
                if (result2 === undefined)
                  return callback2(null, null);
                callback2(null, result2);
              });
            }
          }
        }, (err22, result2) => callback(err22, result2 || null));
      });
    }
  };
});
var require_JoinRequestPartPlugin = __commonJS2((exports, module) => {
  var namespaceStartCharCode = "@".charCodeAt(0);
  module.exports = class JoinRequestPartPlugin {
    constructor(source, target) {
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("JoinRequestPartPlugin", (request2, resolveContext, callback) => {
        const req = request2.request || "";
        let i = req.indexOf("/", 3);
        if (i >= 0 && req.charCodeAt(2) === namespaceStartCharCode) {
          i = req.indexOf("/", i + 1);
        }
        let moduleName;
        let remainingRequest;
        let fullySpecified;
        if (i < 0) {
          moduleName = req;
          remainingRequest = ".";
          fullySpecified = false;
        } else {
          moduleName = req.slice(0, i);
          remainingRequest = "." + req.slice(i);
          fullySpecified = request2.fullySpecified;
        }
        const obj = {
          ...request2,
          path: resolver.join(request2.path, moduleName),
          relativePath: request2.relativePath && resolver.join(request2.relativePath, moduleName),
          request: remainingRequest,
          fullySpecified
        };
        resolver.doResolve(target, obj, null, resolveContext, callback);
      });
    }
  };
});
var require_JoinRequestPlugin = __commonJS2((exports, module) => {
  module.exports = class JoinRequestPlugin {
    constructor(source, target) {
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("JoinRequestPlugin", (request2, resolveContext, callback) => {
        const requestPath = request2.path;
        const requestRequest = request2.request;
        const obj = {
          ...request2,
          path: resolver.join(requestPath, requestRequest),
          relativePath: request2.relativePath && resolver.join(request2.relativePath, requestRequest),
          request: undefined
        };
        resolver.doResolve(target, obj, null, resolveContext, callback);
      });
    }
  };
});
var require_MainFieldPlugin = __commonJS2((exports, module) => {
  var path3 = import.meta.require("path");
  var DescriptionFileUtils = require_DescriptionFileUtils();
  var alreadyTriedMainField = Symbol("alreadyTriedMainField");
  module.exports = class MainFieldPlugin {
    constructor(source, options3, target) {
      this.source = source;
      this.options = options3;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("MainFieldPlugin", (request2, resolveContext, callback) => {
        if (request2.path !== request2.descriptionFileRoot || request2[alreadyTriedMainField] === request2.descriptionFilePath || !request2.descriptionFilePath)
          return callback();
        const filename2 = path3.basename(request2.descriptionFilePath);
        let mainModule = DescriptionFileUtils.getField(request2.descriptionFileData, this.options.name);
        if (!mainModule || typeof mainModule !== "string" || mainModule === "." || mainModule === "./") {
          return callback();
        }
        if (this.options.forceRelative && !/^\.\.?\//.test(mainModule))
          mainModule = "./" + mainModule;
        const obj = {
          ...request2,
          request: mainModule,
          module: false,
          directory: mainModule.endsWith("/"),
          [alreadyTriedMainField]: request2.descriptionFilePath
        };
        return resolver.doResolve(target, obj, "use " + mainModule + " from " + this.options.name + " in " + filename2, resolveContext, callback);
      });
    }
  };
});
var require_getPaths = __commonJS2((exports, module) => {
  module.exports = function getPaths(path3) {
    if (path3 === "/")
      return { paths: ["/"], segments: [""] };
    const parts = path3.split(/(.*?[\\/]+)/);
    const paths = [path3];
    const segments = [parts[parts.length - 1]];
    let part = parts[parts.length - 1];
    path3 = path3.substring(0, path3.length - part.length - 1);
    for (let i = parts.length - 2;i > 2; i -= 2) {
      paths.push(path3);
      part = parts[i];
      path3 = path3.substring(0, path3.length - part.length) || "/";
      segments.push(part.slice(0, -1));
    }
    part = parts[1];
    segments.push(part);
    paths.push(part);
    return {
      paths,
      segments
    };
  };
  module.exports.basename = function basename(path3) {
    const i = path3.lastIndexOf("/"), j22 = path3.lastIndexOf("\\");
    const p32 = i < 0 ? j22 : j22 < 0 ? i : i < j22 ? j22 : i;
    if (p32 < 0)
      return null;
    const s32 = path3.slice(p32 + 1);
    return s32;
  };
});
var require_ModulesInHierarchicalDirectoriesPlugin = __commonJS2((exports, module) => {
  var forEachBail = require_forEachBail();
  var getPaths = require_getPaths();
  module.exports = class ModulesInHierarchicalDirectoriesPlugin {
    constructor(source, directories, target) {
      this.source = source;
      this.directories = [].concat(directories);
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("ModulesInHierarchicalDirectoriesPlugin", (request2, resolveContext, callback) => {
        const fs2 = resolver.fileSystem;
        const addrs = getPaths(request2.path).paths.map((p32) => {
          return this.directories.map((d) => resolver.join(p32, d));
        }).reduce((array, p32) => {
          array.push.apply(array, p32);
          return array;
        }, []);
        forEachBail(addrs, (addr, callback2) => {
          fs2.stat(addr, (err22, stat) => {
            if (!err22 && stat && stat.isDirectory()) {
              const obj = {
                ...request2,
                path: addr,
                request: "./" + request2.request,
                module: false
              };
              const message = "looking for modules in " + addr;
              return resolver.doResolve(target, obj, message, resolveContext, callback2);
            }
            if (resolveContext.log)
              resolveContext.log(addr + " doesn't exist or is not a directory");
            if (resolveContext.missingDependencies)
              resolveContext.missingDependencies.add(addr);
            return callback2();
          });
        }, callback);
      });
    }
  };
});
var require_ModulesInRootPlugin = __commonJS2((exports, module) => {
  module.exports = class ModulesInRootPlugin {
    constructor(source, path3, target) {
      this.source = source;
      this.path = path3;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("ModulesInRootPlugin", (request2, resolveContext, callback) => {
        const obj = {
          ...request2,
          path: this.path,
          request: "./" + request2.request,
          module: false
        };
        resolver.doResolve(target, obj, "looking for modules in " + this.path, resolveContext, callback);
      });
    }
  };
});
var require_NextPlugin = __commonJS2((exports, module) => {
  module.exports = class NextPlugin {
    constructor(source, target) {
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("NextPlugin", (request2, resolveContext, callback) => {
        resolver.doResolve(target, request2, null, resolveContext, callback);
      });
    }
  };
});
var require_ParsePlugin = __commonJS2((exports, module) => {
  module.exports = class ParsePlugin {
    constructor(source, requestOptions, target) {
      this.source = source;
      this.requestOptions = requestOptions;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("ParsePlugin", (request2, resolveContext, callback) => {
        const parsed = resolver.parse(request2.request);
        const obj = { ...request2, ...parsed, ...this.requestOptions };
        if (request2.query && !parsed.query) {
          obj.query = request2.query;
        }
        if (request2.fragment && !parsed.fragment) {
          obj.fragment = request2.fragment;
        }
        if (parsed && resolveContext.log) {
          if (parsed.module)
            resolveContext.log("Parsed request is a module");
          if (parsed.directory)
            resolveContext.log("Parsed request is a directory");
        }
        if (obj.request && !obj.query && obj.fragment) {
          const directory = obj.fragment.endsWith("/");
          const alternative = {
            ...obj,
            directory,
            request: obj.request + (obj.directory ? "/" : "") + (directory ? obj.fragment.slice(0, -1) : obj.fragment),
            fragment: ""
          };
          resolver.doResolve(target, alternative, null, resolveContext, (err22, result2) => {
            if (err22)
              return callback(err22);
            if (result2)
              return callback(null, result2);
            resolver.doResolve(target, obj, null, resolveContext, callback);
          });
          return;
        }
        resolver.doResolve(target, obj, null, resolveContext, callback);
      });
    }
  };
});
var require_PnpPlugin = __commonJS2((exports, module) => {
  module.exports = class PnpPlugin {
    constructor(source, pnpApi, target, alternateTarget) {
      this.source = source;
      this.pnpApi = pnpApi;
      this.target = target;
      this.alternateTarget = alternateTarget;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      const alternateTarget = resolver.ensureHook(this.alternateTarget);
      resolver.getHook(this.source).tapAsync("PnpPlugin", (request2, resolveContext, callback) => {
        const req = request2.request;
        if (!req)
          return callback();
        const issuer = `${request2.path}/`;
        const packageMatch = /^(@[^/]+\/)?[^/]+/.exec(req);
        if (!packageMatch)
          return callback();
        const packageName = packageMatch[0];
        const innerRequest = `.${req.slice(packageName.length)}`;
        let resolution;
        let apiResolution;
        try {
          resolution = this.pnpApi.resolveToUnqualified(packageName, issuer, {
            considerBuiltins: false
          });
          if (resolution === null) {
            resolver.doResolve(alternateTarget, request2, "issuer is not managed by a pnpapi", resolveContext, (err22, result2) => {
              if (err22)
                return callback(err22);
              if (result2)
                return callback(null, result2);
              return callback(null, null);
            });
            return;
          }
          if (resolveContext.fileDependencies) {
            apiResolution = this.pnpApi.resolveToUnqualified("pnpapi", issuer, {
              considerBuiltins: false
            });
          }
        } catch (error) {
          if (error.code === "MODULE_NOT_FOUND" && error.pnpCode === "UNDECLARED_DEPENDENCY") {
            if (resolveContext.log) {
              resolveContext.log(`request is not managed by the pnpapi`);
              for (const line of error.message.split("\n").filter(Boolean))
                resolveContext.log(`  ${line}`);
            }
            return callback();
          }
          return callback(error);
        }
        if (resolution === packageName)
          return callback();
        if (apiResolution && resolveContext.fileDependencies) {
          resolveContext.fileDependencies.add(apiResolution);
        }
        const obj = {
          ...request2,
          path: resolution,
          request: innerRequest,
          ignoreSymlinks: true,
          fullySpecified: request2.fullySpecified && innerRequest !== "."
        };
        resolver.doResolve(target, obj, `resolved by pnp to ${resolution}`, resolveContext, (err22, result2) => {
          if (err22)
            return callback(err22);
          if (result2)
            return callback(null, result2);
          return callback(null, null);
        });
      });
    }
  };
});
var require_RestrictionsPlugin = __commonJS2((exports, module) => {
  var slashCode = "/".charCodeAt(0);
  var backslashCode = "\\".charCodeAt(0);
  var isInside = (path3, parent) => {
    if (!path3.startsWith(parent))
      return false;
    if (path3.length === parent.length)
      return true;
    const charCode = path3.charCodeAt(parent.length);
    return charCode === slashCode || charCode === backslashCode;
  };
  module.exports = class RestrictionsPlugin {
    constructor(source, restrictions) {
      this.source = source;
      this.restrictions = restrictions;
    }
    apply(resolver) {
      resolver.getHook(this.source).tapAsync("RestrictionsPlugin", (request2, resolveContext, callback) => {
        if (typeof request2.path === "string") {
          const path3 = request2.path;
          for (const rule of this.restrictions) {
            if (typeof rule === "string") {
              if (!isInside(path3, rule)) {
                if (resolveContext.log) {
                  resolveContext.log(`${path3} is not inside of the restriction ${rule}`);
                }
                return callback(null, null);
              }
            } else if (!rule.test(path3)) {
              if (resolveContext.log) {
                resolveContext.log(`${path3} doesn't match the restriction ${rule}`);
              }
              return callback(null, null);
            }
          }
        }
        callback();
      });
    }
  };
});
var require_ResultPlugin = __commonJS2((exports, module) => {
  module.exports = class ResultPlugin {
    constructor(source) {
      this.source = source;
    }
    apply(resolver) {
      this.source.tapAsync("ResultPlugin", (request2, resolverContext, callback) => {
        const obj = { ...request2 };
        if (resolverContext.log)
          resolverContext.log("reporting result " + obj.path);
        resolver.hooks.result.callAsync(obj, resolverContext, (err22) => {
          if (err22)
            return callback(err22);
          if (typeof resolverContext.yield === "function") {
            resolverContext.yield(obj);
            callback(null, null);
          } else {
            callback(null, obj);
          }
        });
      });
    }
  };
});
var require_RootsPlugin = __commonJS2((exports, module) => {
  var forEachBail = require_forEachBail();

  class RootsPlugin {
    constructor(source, roots, target) {
      this.roots = Array.from(roots);
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("RootsPlugin", (request2, resolveContext, callback) => {
        const req = request2.request;
        if (!req)
          return callback();
        if (!req.startsWith("/"))
          return callback();
        forEachBail(this.roots, (root, callback2) => {
          const path3 = resolver.join(root, req.slice(1));
          const obj = {
            ...request2,
            path: path3,
            relativePath: request2.relativePath && path3
          };
          resolver.doResolve(target, obj, `root path ${root}`, resolveContext, callback2);
        }, callback);
      });
    }
  }
  module.exports = RootsPlugin;
});
var require_SelfReferencePlugin = __commonJS2((exports, module) => {
  var DescriptionFileUtils = require_DescriptionFileUtils();
  var slashCode = "/".charCodeAt(0);
  module.exports = class SelfReferencePlugin {
    constructor(source, fieldNamePath, target) {
      this.source = source;
      this.target = target;
      this.fieldName = fieldNamePath;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("SelfReferencePlugin", (request2, resolveContext, callback) => {
        if (!request2.descriptionFilePath)
          return callback();
        const req = request2.request;
        if (!req)
          return callback();
        const exportsField = DescriptionFileUtils.getField(request2.descriptionFileData, this.fieldName);
        if (!exportsField)
          return callback();
        const name = DescriptionFileUtils.getField(request2.descriptionFileData, "name");
        if (typeof name !== "string")
          return callback();
        if (req.startsWith(name) && (req.length === name.length || req.charCodeAt(name.length) === slashCode)) {
          const remainingRequest = `.${req.slice(name.length)}`;
          const obj = {
            ...request2,
            request: remainingRequest,
            path: request2.descriptionFileRoot,
            relativePath: "."
          };
          resolver.doResolve(target, obj, "self reference", resolveContext, callback);
        } else {
          return callback();
        }
      });
    }
  };
});
var require_SymlinkPlugin = __commonJS2((exports, module) => {
  var forEachBail = require_forEachBail();
  var getPaths = require_getPaths();
  var { getType, PathType } = require_path2();
  module.exports = class SymlinkPlugin {
    constructor(source, target) {
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      const fs2 = resolver.fileSystem;
      resolver.getHook(this.source).tapAsync("SymlinkPlugin", (request2, resolveContext, callback) => {
        if (request2.ignoreSymlinks)
          return callback();
        const pathsResult = getPaths(request2.path);
        const pathSegments = pathsResult.segments;
        const paths = pathsResult.paths;
        let containsSymlink = false;
        let idx = -1;
        forEachBail(paths, (path3, callback2) => {
          idx++;
          if (resolveContext.fileDependencies)
            resolveContext.fileDependencies.add(path3);
          fs2.readlink(path3, (err22, result2) => {
            if (!err22 && result2) {
              pathSegments[idx] = result2;
              containsSymlink = true;
              const resultType = getType(result2.toString());
              if (resultType === PathType.AbsoluteWin || resultType === PathType.AbsolutePosix) {
                return callback2(null, idx);
              }
            }
            callback2();
          });
        }, (err22, idx2) => {
          if (!containsSymlink)
            return callback();
          const resultSegments = typeof idx2 === "number" ? pathSegments.slice(0, idx2 + 1) : pathSegments.slice();
          const result2 = resultSegments.reduceRight((a, b22) => {
            return resolver.join(a, b22);
          });
          const obj = {
            ...request2,
            path: result2
          };
          resolver.doResolve(target, obj, "resolved symlink to " + result2, resolveContext, callback);
        });
      });
    }
  };
});
var require_TryNextPlugin = __commonJS2((exports, module) => {
  module.exports = class TryNextPlugin {
    constructor(source, message, target) {
      this.source = source;
      this.message = message;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("TryNextPlugin", (request2, resolveContext, callback) => {
        resolver.doResolve(target, request2, this.message, resolveContext, callback);
      });
    }
  };
});
var require_UnsafeCachePlugin = __commonJS2((exports, module) => {
  function getCacheId(type, request2, withContext) {
    return JSON.stringify({
      type,
      context: withContext ? request2.context : "",
      path: request2.path,
      query: request2.query,
      fragment: request2.fragment,
      request: request2.request
    });
  }
  module.exports = class UnsafeCachePlugin {
    constructor(source, filterPredicate, cache3, withContext, target) {
      this.source = source;
      this.filterPredicate = filterPredicate;
      this.withContext = withContext;
      this.cache = cache3;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("UnsafeCachePlugin", (request2, resolveContext, callback) => {
        if (!this.filterPredicate(request2))
          return callback();
        const isYield = typeof resolveContext.yield === "function";
        const cacheId = getCacheId(isYield ? "yield" : "default", request2, this.withContext);
        const cacheEntry = this.cache[cacheId];
        if (cacheEntry) {
          if (isYield) {
            const yield_2 = resolveContext.yield;
            if (Array.isArray(cacheEntry)) {
              for (const result2 of cacheEntry)
                yield_2(result2);
            } else {
              yield_2(cacheEntry);
            }
            return callback(null, null);
          }
          return callback(null, cacheEntry);
        }
        let yieldFn;
        let yield_;
        const yieldResult = [];
        if (isYield) {
          yieldFn = resolveContext.yield;
          yield_ = (result2) => {
            yieldResult.push(result2);
          };
        }
        resolver.doResolve(target, request2, null, yield_ ? { ...resolveContext, yield: yield_ } : resolveContext, (err22, result2) => {
          if (err22)
            return callback(err22);
          if (isYield) {
            if (result2)
              yieldResult.push(result2);
            for (const result3 of yieldResult) {
              yieldFn(result3);
            }
            this.cache[cacheId] = yieldResult;
            return callback(null, null);
          }
          if (result2)
            return callback(null, this.cache[cacheId] = result2);
          callback();
        });
      });
    }
  };
});
var require_UseFilePlugin = __commonJS2((exports, module) => {
  module.exports = class UseFilePlugin {
    constructor(source, filename2, target) {
      this.source = source;
      this.filename = filename2;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("UseFilePlugin", (request2, resolveContext, callback) => {
        const filePath = resolver.join(request2.path, this.filename);
        const obj = {
          ...request2,
          path: filePath,
          relativePath: request2.relativePath && resolver.join(request2.relativePath, this.filename)
        };
        resolver.doResolve(target, obj, "using path: " + filePath, resolveContext, callback);
      });
    }
  };
});
var require_ResolverFactory = __commonJS2((exports) => {
  var versions = import.meta.require("process").versions;
  var Resolver = require_Resolver();
  var { getType, PathType } = require_path2();
  var SyncAsyncFileSystemDecorator = require_SyncAsyncFileSystemDecorator();
  var AliasFieldPlugin = require_AliasFieldPlugin();
  var AliasPlugin = require_AliasPlugin();
  var AppendPlugin = require_AppendPlugin();
  var ConditionalPlugin = require_ConditionalPlugin();
  var DescriptionFilePlugin = require_DescriptionFilePlugin();
  var DirectoryExistsPlugin = require_DirectoryExistsPlugin();
  var ExportsFieldPlugin = require_ExportsFieldPlugin();
  var ExtensionAliasPlugin = require_ExtensionAliasPlugin();
  var FileExistsPlugin = require_FileExistsPlugin();
  var ImportsFieldPlugin = require_ImportsFieldPlugin();
  var JoinRequestPartPlugin = require_JoinRequestPartPlugin();
  var JoinRequestPlugin = require_JoinRequestPlugin();
  var MainFieldPlugin = require_MainFieldPlugin();
  var ModulesInHierarchicalDirectoriesPlugin = require_ModulesInHierarchicalDirectoriesPlugin();
  var ModulesInRootPlugin = require_ModulesInRootPlugin();
  var NextPlugin = require_NextPlugin();
  var ParsePlugin = require_ParsePlugin();
  var PnpPlugin = require_PnpPlugin();
  var RestrictionsPlugin = require_RestrictionsPlugin();
  var ResultPlugin = require_ResultPlugin();
  var RootsPlugin = require_RootsPlugin();
  var SelfReferencePlugin = require_SelfReferencePlugin();
  var SymlinkPlugin = require_SymlinkPlugin();
  var TryNextPlugin = require_TryNextPlugin();
  var UnsafeCachePlugin = require_UnsafeCachePlugin();
  var UseFilePlugin = require_UseFilePlugin();
  function processPnpApiOption(option) {
    if (option === undefined && versions.pnp) {
      const _findPnpApi = import.meta.require("module").findPnpApi;
      if (_findPnpApi) {
        return {
          resolveToUnqualified(request2, issuer, opts) {
            const pnpapi = _findPnpApi(issuer);
            if (!pnpapi) {
              return null;
            }
            return pnpapi.resolveToUnqualified(request2, issuer, opts);
          }
        };
      }
    }
    return option || null;
  }
  function normalizeAlias(alias) {
    return typeof alias === "object" && !Array.isArray(alias) && alias !== null ? Object.keys(alias).map((key) => {
      const obj = { name: key, onlyModule: false, alias: alias[key] };
      if (/\$$/.test(key)) {
        obj.onlyModule = true;
        obj.name = key.slice(0, -1);
      }
      return obj;
    }) : alias || [];
  }
  function createOptions(options3) {
    const mainFieldsSet = new Set(options3.mainFields || ["main"]);
    const mainFields = [];
    for (const item of mainFieldsSet) {
      if (typeof item === "string") {
        mainFields.push({
          name: [item],
          forceRelative: true
        });
      } else if (Array.isArray(item)) {
        mainFields.push({
          name: item,
          forceRelative: true
        });
      } else {
        mainFields.push({
          name: Array.isArray(item.name) ? item.name : [item.name],
          forceRelative: item.forceRelative
        });
      }
    }
    return {
      alias: normalizeAlias(options3.alias),
      fallback: normalizeAlias(options3.fallback),
      aliasFields: new Set(options3.aliasFields),
      cachePredicate: options3.cachePredicate || function() {
        return true;
      },
      cacheWithContext: typeof options3.cacheWithContext !== "undefined" ? options3.cacheWithContext : true,
      exportsFields: new Set(options3.exportsFields || ["exports"]),
      importsFields: new Set(options3.importsFields || ["imports"]),
      conditionNames: new Set(options3.conditionNames),
      descriptionFiles: Array.from(new Set(options3.descriptionFiles || ["package.json"])),
      enforceExtension: options3.enforceExtension === undefined ? options3.extensions && options3.extensions.includes("") ? true : false : options3.enforceExtension,
      extensions: new Set(options3.extensions || [".js", ".json", ".node"]),
      extensionAlias: options3.extensionAlias ? Object.keys(options3.extensionAlias).map((k) => ({
        extension: k,
        alias: options3.extensionAlias[k]
      })) : [],
      fileSystem: options3.useSyncFileSystemCalls ? new SyncAsyncFileSystemDecorator(options3.fileSystem) : options3.fileSystem,
      unsafeCache: options3.unsafeCache && typeof options3.unsafeCache !== "object" ? {} : options3.unsafeCache || false,
      symlinks: typeof options3.symlinks !== "undefined" ? options3.symlinks : true,
      resolver: options3.resolver,
      modules: mergeFilteredToArray(Array.isArray(options3.modules) ? options3.modules : options3.modules ? [options3.modules] : ["node_modules"], (item) => {
        const type = getType(item);
        return type === PathType.Normal || type === PathType.Relative;
      }),
      mainFields,
      mainFiles: new Set(options3.mainFiles || ["index"]),
      plugins: options3.plugins || [],
      pnpApi: processPnpApiOption(options3.pnpApi),
      roots: new Set(options3.roots || undefined),
      fullySpecified: options3.fullySpecified || false,
      resolveToContext: options3.resolveToContext || false,
      preferRelative: options3.preferRelative || false,
      preferAbsolute: options3.preferAbsolute || false,
      restrictions: new Set(options3.restrictions)
    };
  }
  exports.createResolver = function(options3) {
    const normalizedOptions = createOptions(options3);
    const {
      alias,
      fallback: fallback22,
      aliasFields,
      cachePredicate,
      cacheWithContext,
      conditionNames,
      descriptionFiles,
      enforceExtension,
      exportsFields,
      extensionAlias,
      importsFields,
      extensions,
      fileSystem,
      fullySpecified,
      mainFields,
      mainFiles,
      modules,
      plugins: userPlugins,
      pnpApi,
      resolveToContext,
      preferRelative,
      preferAbsolute,
      symlinks,
      unsafeCache,
      resolver: customResolver,
      restrictions,
      roots
    } = normalizedOptions;
    const plugins = userPlugins.slice();
    const resolver = customResolver ? customResolver : new Resolver(fileSystem, normalizedOptions);
    resolver.ensureHook("resolve");
    resolver.ensureHook("internalResolve");
    resolver.ensureHook("newInternalResolve");
    resolver.ensureHook("parsedResolve");
    resolver.ensureHook("describedResolve");
    resolver.ensureHook("rawResolve");
    resolver.ensureHook("normalResolve");
    resolver.ensureHook("internal");
    resolver.ensureHook("rawModule");
    resolver.ensureHook("alternateRawModule");
    resolver.ensureHook("module");
    resolver.ensureHook("resolveAsModule");
    resolver.ensureHook("undescribedResolveInPackage");
    resolver.ensureHook("resolveInPackage");
    resolver.ensureHook("resolveInExistingDirectory");
    resolver.ensureHook("relative");
    resolver.ensureHook("describedRelative");
    resolver.ensureHook("directory");
    resolver.ensureHook("undescribedExistingDirectory");
    resolver.ensureHook("existingDirectory");
    resolver.ensureHook("undescribedRawFile");
    resolver.ensureHook("rawFile");
    resolver.ensureHook("file");
    resolver.ensureHook("finalFile");
    resolver.ensureHook("existingFile");
    resolver.ensureHook("resolved");
    resolver.hooks.newInteralResolve = resolver.hooks.newInternalResolve;
    for (const { source, resolveOptions } of [
      { source: "resolve", resolveOptions: { fullySpecified } },
      { source: "internal-resolve", resolveOptions: { fullySpecified: false } }
    ]) {
      if (unsafeCache) {
        plugins.push(new UnsafeCachePlugin(source, cachePredicate, unsafeCache, cacheWithContext, `new-${source}`));
        plugins.push(new ParsePlugin(`new-${source}`, resolveOptions, "parsed-resolve"));
      } else {
        plugins.push(new ParsePlugin(source, resolveOptions, "parsed-resolve"));
      }
    }
    plugins.push(new DescriptionFilePlugin("parsed-resolve", descriptionFiles, false, "described-resolve"));
    plugins.push(new NextPlugin("after-parsed-resolve", "described-resolve"));
    plugins.push(new NextPlugin("described-resolve", "raw-resolve"));
    if (fallback22.length > 0) {
      plugins.push(new AliasPlugin("described-resolve", fallback22, "internal-resolve"));
    }
    if (alias.length > 0) {
      plugins.push(new AliasPlugin("raw-resolve", alias, "internal-resolve"));
    }
    aliasFields.forEach((item) => {
      plugins.push(new AliasFieldPlugin("raw-resolve", item, "internal-resolve"));
    });
    extensionAlias.forEach((item) => plugins.push(new ExtensionAliasPlugin("raw-resolve", item, "normal-resolve")));
    plugins.push(new NextPlugin("raw-resolve", "normal-resolve"));
    if (preferRelative) {
      plugins.push(new JoinRequestPlugin("after-normal-resolve", "relative"));
    }
    plugins.push(new ConditionalPlugin("after-normal-resolve", { module: true }, "resolve as module", false, "raw-module"));
    plugins.push(new ConditionalPlugin("after-normal-resolve", { internal: true }, "resolve as internal import", false, "internal"));
    if (preferAbsolute) {
      plugins.push(new JoinRequestPlugin("after-normal-resolve", "relative"));
    }
    if (roots.size > 0) {
      plugins.push(new RootsPlugin("after-normal-resolve", roots, "relative"));
    }
    if (!preferRelative && !preferAbsolute) {
      plugins.push(new JoinRequestPlugin("after-normal-resolve", "relative"));
    }
    importsFields.forEach((importsField) => {
      plugins.push(new ImportsFieldPlugin("internal", conditionNames, importsField, "relative", "internal-resolve"));
    });
    exportsFields.forEach((exportsField) => {
      plugins.push(new SelfReferencePlugin("raw-module", exportsField, "resolve-as-module"));
    });
    modules.forEach((item) => {
      if (Array.isArray(item)) {
        if (item.includes("node_modules") && pnpApi) {
          plugins.push(new ModulesInHierarchicalDirectoriesPlugin("raw-module", item.filter((i) => i !== "node_modules"), "module"));
          plugins.push(new PnpPlugin("raw-module", pnpApi, "undescribed-resolve-in-package", "alternate-raw-module"));
          plugins.push(new ModulesInHierarchicalDirectoriesPlugin("alternate-raw-module", ["node_modules"], "module"));
        } else {
          plugins.push(new ModulesInHierarchicalDirectoriesPlugin("raw-module", item, "module"));
        }
      } else {
        plugins.push(new ModulesInRootPlugin("raw-module", item, "module"));
      }
    });
    plugins.push(new JoinRequestPartPlugin("module", "resolve-as-module"));
    if (!resolveToContext) {
      plugins.push(new ConditionalPlugin("resolve-as-module", { directory: false, request: "." }, "single file module", true, "undescribed-raw-file"));
    }
    plugins.push(new DirectoryExistsPlugin("resolve-as-module", "undescribed-resolve-in-package"));
    plugins.push(new DescriptionFilePlugin("undescribed-resolve-in-package", descriptionFiles, false, "resolve-in-package"));
    plugins.push(new NextPlugin("after-undescribed-resolve-in-package", "resolve-in-package"));
    exportsFields.forEach((exportsField) => {
      plugins.push(new ExportsFieldPlugin("resolve-in-package", conditionNames, exportsField, "relative"));
    });
    plugins.push(new NextPlugin("resolve-in-package", "resolve-in-existing-directory"));
    plugins.push(new JoinRequestPlugin("resolve-in-existing-directory", "relative"));
    plugins.push(new DescriptionFilePlugin("relative", descriptionFiles, true, "described-relative"));
    plugins.push(new NextPlugin("after-relative", "described-relative"));
    if (resolveToContext) {
      plugins.push(new NextPlugin("described-relative", "directory"));
    } else {
      plugins.push(new ConditionalPlugin("described-relative", { directory: false }, null, true, "raw-file"));
      plugins.push(new ConditionalPlugin("described-relative", { fullySpecified: false }, "as directory", true, "directory"));
    }
    plugins.push(new DirectoryExistsPlugin("directory", "undescribed-existing-directory"));
    if (resolveToContext) {
      plugins.push(new NextPlugin("undescribed-existing-directory", "resolved"));
    } else {
      plugins.push(new DescriptionFilePlugin("undescribed-existing-directory", descriptionFiles, false, "existing-directory"));
      mainFiles.forEach((item) => {
        plugins.push(new UseFilePlugin("undescribed-existing-directory", item, "undescribed-raw-file"));
      });
      mainFields.forEach((item) => {
        plugins.push(new MainFieldPlugin("existing-directory", item, "resolve-in-existing-directory"));
      });
      mainFiles.forEach((item) => {
        plugins.push(new UseFilePlugin("existing-directory", item, "undescribed-raw-file"));
      });
      plugins.push(new DescriptionFilePlugin("undescribed-raw-file", descriptionFiles, true, "raw-file"));
      plugins.push(new NextPlugin("after-undescribed-raw-file", "raw-file"));
      plugins.push(new ConditionalPlugin("raw-file", { fullySpecified: true }, null, false, "file"));
      if (!enforceExtension) {
        plugins.push(new TryNextPlugin("raw-file", "no extension", "file"));
      }
      extensions.forEach((item) => {
        plugins.push(new AppendPlugin("raw-file", item, "file"));
      });
      if (alias.length > 0)
        plugins.push(new AliasPlugin("file", alias, "internal-resolve"));
      aliasFields.forEach((item) => {
        plugins.push(new AliasFieldPlugin("file", item, "internal-resolve"));
      });
      plugins.push(new NextPlugin("file", "final-file"));
      plugins.push(new FileExistsPlugin("final-file", "existing-file"));
      if (symlinks)
        plugins.push(new SymlinkPlugin("existing-file", "existing-file"));
      plugins.push(new NextPlugin("existing-file", "resolved"));
    }
    const resolved = resolver.hooks.resolved;
    if (restrictions.size > 0) {
      plugins.push(new RestrictionsPlugin(resolved, restrictions));
    }
    plugins.push(new ResultPlugin(resolved));
    for (const plugin of plugins) {
      if (typeof plugin === "function") {
        plugin.call(resolver, resolver);
      } else if (plugin) {
        plugin.apply(resolver);
      }
    }
    return resolver;
  };
  function mergeFilteredToArray(array, filter) {
    const result2 = [];
    const set = new Set(array);
    for (const item of set) {
      if (filter(item)) {
        const lastElement = result2.length > 0 ? result2[result2.length - 1] : undefined;
        if (Array.isArray(lastElement)) {
          lastElement.push(item);
        } else {
          result2.push([item]);
        }
      } else {
        result2.push(item);
      }
    }
    return result2;
  }
});
var require_CloneBasenamePlugin = __commonJS2((exports, module) => {
  var basename23 = require_getPaths().basename;
  module.exports = class CloneBasenamePlugin {
    constructor(source, target) {
      this.source = source;
      this.target = target;
    }
    apply(resolver) {
      const target = resolver.ensureHook(this.target);
      resolver.getHook(this.source).tapAsync("CloneBasenamePlugin", (request2, resolveContext, callback) => {
        const requestPath = request2.path;
        const filename2 = basename23(requestPath);
        const filePath = resolver.join(requestPath, filename2);
        const obj = {
          ...request2,
          path: filePath,
          relativePath: request2.relativePath && resolver.join(request2.relativePath, filename2)
        };
        resolver.doResolve(target, obj, "using path: " + filePath, resolveContext, callback);
      });
    }
  };
});
var require_LogInfoPlugin = __commonJS2((exports, module) => {
  module.exports = class LogInfoPlugin {
    constructor(source) {
      this.source = source;
    }
    apply(resolver) {
      const source = this.source;
      resolver.getHook(this.source).tapAsync("LogInfoPlugin", (request2, resolveContext, callback) => {
        if (!resolveContext.log)
          return callback();
        const log22 = resolveContext.log;
        const prefix = "[" + source + "] ";
        if (request2.path)
          log22(prefix + "Resolving in directory: " + request2.path);
        if (request2.request)
          log22(prefix + "Resolving request: " + request2.request);
        if (request2.module)
          log22(prefix + "Request is an module request.");
        if (request2.directory)
          log22(prefix + "Request is a directory request.");
        if (request2.query)
          log22(prefix + "Resolving request query: " + request2.query);
        if (request2.fragment)
          log22(prefix + "Resolving request fragment: " + request2.fragment);
        if (request2.descriptionFilePath)
          log22(prefix + "Has description data from " + request2.descriptionFilePath);
        if (request2.relativePath)
          log22(prefix + "Relative path from description file is: " + request2.relativePath);
        callback();
      });
    }
  };
});
var require_lib13 = __commonJS2((exports, module) => {
  var fs2 = require_graceful_fs();
  var CachedInputFileSystem = require_CachedInputFileSystem();
  var ResolverFactory = require_ResolverFactory();
  var nodeFileSystem = new CachedInputFileSystem(fs2, 4000);
  var nodeContext = {
    environments: ["node+es3+es5+process+native"]
  };
  var asyncResolver = ResolverFactory.createResolver({
    conditionNames: ["node"],
    extensions: [".js", ".json", ".node"],
    fileSystem: nodeFileSystem
  });
  var resolve23 = (context, path3, request2, resolveContext, callback) => {
    if (typeof context === "string") {
      callback = resolveContext;
      resolveContext = request2;
      request2 = path3;
      path3 = context;
      context = nodeContext;
    }
    if (typeof callback !== "function") {
      callback = resolveContext;
    }
    asyncResolver.resolve(context, path3, request2, resolveContext, callback);
  };
  var syncResolver = ResolverFactory.createResolver({
    conditionNames: ["node"],
    extensions: [".js", ".json", ".node"],
    useSyncFileSystemCalls: true,
    fileSystem: nodeFileSystem
  });
  var resolveSync = (context, path3, request2) => {
    if (typeof context === "string") {
      request2 = path3;
      path3 = context;
      context = nodeContext;
    }
    return syncResolver.resolveSync(context, path3, request2);
  };
  function create(options3) {
    const resolver = ResolverFactory.createResolver({
      fileSystem: nodeFileSystem,
      ...options3
    });
    return function(context, path3, request2, resolveContext, callback) {
      if (typeof context === "string") {
        callback = resolveContext;
        resolveContext = request2;
        request2 = path3;
        path3 = context;
        context = nodeContext;
      }
      if (typeof callback !== "function") {
        callback = resolveContext;
      }
      resolver.resolve(context, path3, request2, resolveContext, callback);
    };
  }
  function createSync(options3) {
    const resolver = ResolverFactory.createResolver({
      useSyncFileSystemCalls: true,
      fileSystem: nodeFileSystem,
      ...options3
    });
    return function(context, path3, request2) {
      if (typeof context === "string") {
        request2 = path3;
        path3 = context;
        context = nodeContext;
      }
      return resolver.resolveSync(context, path3, request2);
    };
  }
  var mergeExports = (obj, exports2) => {
    const descriptors = Object.getOwnPropertyDescriptors(exports2);
    Object.defineProperties(obj, descriptors);
    return Object.freeze(obj);
  };
  module.exports = mergeExports(resolve23, {
    get sync() {
      return resolveSync;
    },
    create: mergeExports(create, {
      get sync() {
        return createSync;
      }
    }),
    ResolverFactory,
    CachedInputFileSystem,
    get CloneBasenamePlugin() {
      return require_CloneBasenamePlugin();
    },
    get LogInfoPlugin() {
      return require_LogInfoPlugin();
    },
    get forEachBail() {
      return require_forEachBail();
    }
  });
});
var require_main = __commonJS2((exports, module) => {
  var __dirname2 = "/Users/chrisbreuer/Code/stacks/node_modules/export-size/node_modules/esbuild/lib", __filename2 = "/Users/chrisbreuer/Code/stacks/node_modules/export-size/node_modules/esbuild/lib/main.js";
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key) && key !== except)
          __defProp32(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var node_exports = {};
  __export32(node_exports, {
    analyzeMetafile: () => analyzeMetafile,
    analyzeMetafileSync: () => analyzeMetafileSync,
    build: () => build2,
    buildSync: () => buildSync,
    context: () => context,
    default: () => node_default,
    formatMessages: () => formatMessages,
    formatMessagesSync: () => formatMessagesSync,
    initialize: () => initialize,
    stop: () => stop,
    transform: () => transform,
    transformSync: () => transformSync,
    version: () => version2
  });
  module.exports = __toCommonJS2(node_exports);
  function encodePacket(packet) {
    let visit = (value) => {
      if (value === null) {
        bb.write8(0);
      } else if (typeof value === "boolean") {
        bb.write8(1);
        bb.write8(+value);
      } else if (typeof value === "number") {
        bb.write8(2);
        bb.write32(value | 0);
      } else if (typeof value === "string") {
        bb.write8(3);
        bb.write(encodeUTF8(value));
      } else if (value instanceof Uint8Array) {
        bb.write8(4);
        bb.write(value);
      } else if (value instanceof Array) {
        bb.write8(5);
        bb.write32(value.length);
        for (let item of value) {
          visit(item);
        }
      } else {
        let keys = Object.keys(value);
        bb.write8(6);
        bb.write32(keys.length);
        for (let key of keys) {
          bb.write(encodeUTF8(key));
          visit(value[key]);
        }
      }
    };
    let bb = new ByteBuffer;
    bb.write32(0);
    bb.write32(packet.id << 1 | +!packet.isRequest);
    visit(packet.value);
    writeUInt32LE(bb.buf, bb.len - 4, 0);
    return bb.buf.subarray(0, bb.len);
  }
  function decodePacket(bytes) {
    let visit = () => {
      switch (bb.read8()) {
        case 0:
          return null;
        case 1:
          return !!bb.read8();
        case 2:
          return bb.read32();
        case 3:
          return decodeUTF8(bb.read());
        case 4:
          return bb.read();
        case 5: {
          let count = bb.read32();
          let value2 = [];
          for (let i = 0;i < count; i++) {
            value2.push(visit());
          }
          return value2;
        }
        case 6: {
          let count = bb.read32();
          let value2 = {};
          for (let i = 0;i < count; i++) {
            value2[decodeUTF8(bb.read())] = visit();
          }
          return value2;
        }
        default:
          throw new Error("Invalid packet");
      }
    };
    let bb = new ByteBuffer(bytes);
    let id = bb.read32();
    let isRequest = (id & 1) === 0;
    id >>>= 1;
    let value = visit();
    if (bb.ptr !== bytes.length) {
      throw new Error("Invalid packet");
    }
    return { id, isRequest, value };
  }
  var ByteBuffer = class {
    constructor(buf = new Uint8Array(1024)) {
      this.buf = buf;
      this.len = 0;
      this.ptr = 0;
    }
    _write(delta) {
      if (this.len + delta > this.buf.length) {
        let clone3 = new Uint8Array((this.len + delta) * 2);
        clone3.set(this.buf);
        this.buf = clone3;
      }
      this.len += delta;
      return this.len - delta;
    }
    write8(value) {
      let offset = this._write(1);
      this.buf[offset] = value;
    }
    write32(value) {
      let offset = this._write(4);
      writeUInt32LE(this.buf, value, offset);
    }
    write(bytes) {
      let offset = this._write(4 + bytes.length);
      writeUInt32LE(this.buf, bytes.length, offset);
      this.buf.set(bytes, offset + 4);
    }
    _read(delta) {
      if (this.ptr + delta > this.buf.length) {
        throw new Error("Invalid packet");
      }
      this.ptr += delta;
      return this.ptr - delta;
    }
    read8() {
      return this.buf[this._read(1)];
    }
    read32() {
      return readUInt32LE(this.buf, this._read(4));
    }
    read() {
      let length = this.read32();
      let bytes = new Uint8Array(length);
      let ptr = this._read(bytes.length);
      bytes.set(this.buf.subarray(ptr, ptr + length));
      return bytes;
    }
  };
  var encodeUTF8;
  var decodeUTF8;
  var encodeInvariant;
  if (typeof TextEncoder !== "undefined" && typeof TextDecoder !== "undefined") {
    let encoder = new TextEncoder;
    let decoder = new TextDecoder;
    encodeUTF8 = (text22) => encoder.encode(text22);
    decodeUTF8 = (bytes) => decoder.decode(bytes);
    encodeInvariant = 'new TextEncoder().encode("")';
  } else if (typeof Buffer !== "undefined") {
    encodeUTF8 = (text22) => Buffer.from(text22);
    decodeUTF8 = (bytes) => {
      let { buffer, byteOffset, byteLength } = bytes;
      return Buffer.from(buffer, byteOffset, byteLength).toString();
    };
    encodeInvariant = 'Buffer.from("")';
  } else {
    throw new Error("No UTF-8 codec found");
  }
  if (!(encodeUTF8("") instanceof Uint8Array))
    throw new Error(`Invariant violation: "${encodeInvariant} instanceof Uint8Array" is incorrectly false

This indicates that your JavaScript environment is broken. You cannot use
esbuild in this environment because esbuild relies on this invariant. This
is not a problem with esbuild. You need to fix your environment instead.
`);
  function readUInt32LE(buffer, offset) {
    return buffer[offset++] | buffer[offset++] << 8 | buffer[offset++] << 16 | buffer[offset++] << 24;
  }
  function writeUInt32LE(buffer, value, offset) {
    buffer[offset++] = value;
    buffer[offset++] = value >> 8;
    buffer[offset++] = value >> 16;
    buffer[offset++] = value >> 24;
  }
  var quote = JSON.stringify;
  var buildLogLevelDefault = "warning";
  var transformLogLevelDefault = "silent";
  function validateTarget(target) {
    validateStringValue(target, "target");
    if (target.indexOf(",") >= 0)
      throw new Error(`Invalid target: ${target}`);
    return target;
  }
  var canBeAnything = () => null;
  var mustBeBoolean = (value) => typeof value === "boolean" ? null : "a boolean";
  var mustBeString = (value) => typeof value === "string" ? null : "a string";
  var mustBeRegExp = (value) => value instanceof RegExp ? null : "a RegExp object";
  var mustBeInteger = (value) => typeof value === "number" && value === (value | 0) ? null : "an integer";
  var mustBeFunction = (value) => typeof value === "function" ? null : "a function";
  var mustBeArray = (value) => Array.isArray(value) ? null : "an array";
  var mustBeObject = (value) => typeof value === "object" && value !== null && !Array.isArray(value) ? null : "an object";
  var mustBeEntryPoints = (value) => typeof value === "object" && value !== null ? null : "an array or an object";
  var mustBeWebAssemblyModule = (value) => value instanceof WebAssembly.Module ? null : "a WebAssembly.Module";
  var mustBeObjectOrNull = (value) => typeof value === "object" && !Array.isArray(value) ? null : "an object or null";
  var mustBeStringOrBoolean = (value) => typeof value === "string" || typeof value === "boolean" ? null : "a string or a boolean";
  var mustBeStringOrObject = (value) => typeof value === "string" || typeof value === "object" && value !== null && !Array.isArray(value) ? null : "a string or an object";
  var mustBeStringOrArray = (value) => typeof value === "string" || Array.isArray(value) ? null : "a string or an array";
  var mustBeStringOrUint8Array = (value) => typeof value === "string" || value instanceof Uint8Array ? null : "a string or a Uint8Array";
  var mustBeStringOrURL = (value) => typeof value === "string" || value instanceof URL ? null : "a string or a URL";
  function getFlag(object, keys, key, mustBeFn) {
    let value = object[key];
    keys[key + ""] = true;
    if (value === undefined)
      return;
    let mustBe = mustBeFn(value);
    if (mustBe !== null)
      throw new Error(`${quote(key)} must be ${mustBe}`);
    return value;
  }
  function checkForInvalidFlags(object, keys, where) {
    for (let key in object) {
      if (!(key in keys)) {
        throw new Error(`Invalid option ${where}: ${quote(key)}`);
      }
    }
  }
  function validateInitializeOptions(options3) {
    let keys = /* @__PURE__ */ Object.create(null);
    let wasmURL = getFlag(options3, keys, "wasmURL", mustBeStringOrURL);
    let wasmModule = getFlag(options3, keys, "wasmModule", mustBeWebAssemblyModule);
    let worker = getFlag(options3, keys, "worker", mustBeBoolean);
    checkForInvalidFlags(options3, keys, "in initialize() call");
    return {
      wasmURL,
      wasmModule,
      worker
    };
  }
  function validateMangleCache(mangleCache) {
    let validated;
    if (mangleCache !== undefined) {
      validated = /* @__PURE__ */ Object.create(null);
      for (let key in mangleCache) {
        let value = mangleCache[key];
        if (typeof value === "string" || value === false) {
          validated[key] = value;
        } else {
          throw new Error(`Expected ${quote(key)} in mangle cache to map to either a string or false`);
        }
      }
    }
    return validated;
  }
  function pushLogFlags(flags, options3, keys, isTTY2, logLevelDefault) {
    let color = getFlag(options3, keys, "color", mustBeBoolean);
    let logLevel22 = getFlag(options3, keys, "logLevel", mustBeString);
    let logLimit = getFlag(options3, keys, "logLimit", mustBeInteger);
    if (color !== undefined)
      flags.push(`--color=${color}`);
    else if (isTTY2)
      flags.push(`--color=true`);
    flags.push(`--log-level=${logLevel22 || logLevelDefault}`);
    flags.push(`--log-limit=${logLimit || 0}`);
  }
  function validateStringValue(value, what, key) {
    if (typeof value !== "string") {
      throw new Error(`Expected value for ${what}${key !== undefined ? " " + quote(key) : ""} to be a string, got ${typeof value} instead`);
    }
    return value;
  }
  function pushCommonFlags(flags, options3, keys) {
    let legalComments = getFlag(options3, keys, "legalComments", mustBeString);
    let sourceRoot = getFlag(options3, keys, "sourceRoot", mustBeString);
    let sourcesContent = getFlag(options3, keys, "sourcesContent", mustBeBoolean);
    let target = getFlag(options3, keys, "target", mustBeStringOrArray);
    let format = getFlag(options3, keys, "format", mustBeString);
    let globalName = getFlag(options3, keys, "globalName", mustBeString);
    let mangleProps = getFlag(options3, keys, "mangleProps", mustBeRegExp);
    let reserveProps = getFlag(options3, keys, "reserveProps", mustBeRegExp);
    let mangleQuoted = getFlag(options3, keys, "mangleQuoted", mustBeBoolean);
    let minify = getFlag(options3, keys, "minify", mustBeBoolean);
    let minifySyntax = getFlag(options3, keys, "minifySyntax", mustBeBoolean);
    let minifyWhitespace = getFlag(options3, keys, "minifyWhitespace", mustBeBoolean);
    let minifyIdentifiers = getFlag(options3, keys, "minifyIdentifiers", mustBeBoolean);
    let lineLimit = getFlag(options3, keys, "lineLimit", mustBeInteger);
    let drop = getFlag(options3, keys, "drop", mustBeArray);
    let dropLabels = getFlag(options3, keys, "dropLabels", mustBeArray);
    let charset = getFlag(options3, keys, "charset", mustBeString);
    let treeShaking = getFlag(options3, keys, "treeShaking", mustBeBoolean);
    let ignoreAnnotations = getFlag(options3, keys, "ignoreAnnotations", mustBeBoolean);
    let jsx = getFlag(options3, keys, "jsx", mustBeString);
    let jsxFactory = getFlag(options3, keys, "jsxFactory", mustBeString);
    let jsxFragment = getFlag(options3, keys, "jsxFragment", mustBeString);
    let jsxImportSource = getFlag(options3, keys, "jsxImportSource", mustBeString);
    let jsxDev = getFlag(options3, keys, "jsxDev", mustBeBoolean);
    let jsxSideEffects = getFlag(options3, keys, "jsxSideEffects", mustBeBoolean);
    let define2 = getFlag(options3, keys, "define", mustBeObject);
    let logOverride = getFlag(options3, keys, "logOverride", mustBeObject);
    let supported = getFlag(options3, keys, "supported", mustBeObject);
    let pure = getFlag(options3, keys, "pure", mustBeArray);
    let keepNames = getFlag(options3, keys, "keepNames", mustBeBoolean);
    let platform22 = getFlag(options3, keys, "platform", mustBeString);
    let tsconfigRaw = getFlag(options3, keys, "tsconfigRaw", mustBeStringOrObject);
    if (legalComments)
      flags.push(`--legal-comments=${legalComments}`);
    if (sourceRoot !== undefined)
      flags.push(`--source-root=${sourceRoot}`);
    if (sourcesContent !== undefined)
      flags.push(`--sources-content=${sourcesContent}`);
    if (target) {
      if (Array.isArray(target))
        flags.push(`--target=${Array.from(target).map(validateTarget).join(",")}`);
      else
        flags.push(`--target=${validateTarget(target)}`);
    }
    if (format)
      flags.push(`--format=${format}`);
    if (globalName)
      flags.push(`--global-name=${globalName}`);
    if (platform22)
      flags.push(`--platform=${platform22}`);
    if (tsconfigRaw)
      flags.push(`--tsconfig-raw=${typeof tsconfigRaw === "string" ? tsconfigRaw : JSON.stringify(tsconfigRaw)}`);
    if (minify)
      flags.push("--minify");
    if (minifySyntax)
      flags.push("--minify-syntax");
    if (minifyWhitespace)
      flags.push("--minify-whitespace");
    if (minifyIdentifiers)
      flags.push("--minify-identifiers");
    if (lineLimit)
      flags.push(`--line-limit=${lineLimit}`);
    if (charset)
      flags.push(`--charset=${charset}`);
    if (treeShaking !== undefined)
      flags.push(`--tree-shaking=${treeShaking}`);
    if (ignoreAnnotations)
      flags.push(`--ignore-annotations`);
    if (drop)
      for (let what of drop)
        flags.push(`--drop:${validateStringValue(what, "drop")}`);
    if (dropLabels)
      flags.push(`--drop-labels=${Array.from(dropLabels).map((what) => validateStringValue(what, "dropLabels")).join(",")}`);
    if (mangleProps)
      flags.push(`--mangle-props=${mangleProps.source}`);
    if (reserveProps)
      flags.push(`--reserve-props=${reserveProps.source}`);
    if (mangleQuoted !== undefined)
      flags.push(`--mangle-quoted=${mangleQuoted}`);
    if (jsx)
      flags.push(`--jsx=${jsx}`);
    if (jsxFactory)
      flags.push(`--jsx-factory=${jsxFactory}`);
    if (jsxFragment)
      flags.push(`--jsx-fragment=${jsxFragment}`);
    if (jsxImportSource)
      flags.push(`--jsx-import-source=${jsxImportSource}`);
    if (jsxDev)
      flags.push(`--jsx-dev`);
    if (jsxSideEffects)
      flags.push(`--jsx-side-effects`);
    if (define2) {
      for (let key in define2) {
        if (key.indexOf("=") >= 0)
          throw new Error(`Invalid define: ${key}`);
        flags.push(`--define:${key}=${validateStringValue(define2[key], "define", key)}`);
      }
    }
    if (logOverride) {
      for (let key in logOverride) {
        if (key.indexOf("=") >= 0)
          throw new Error(`Invalid log override: ${key}`);
        flags.push(`--log-override:${key}=${validateStringValue(logOverride[key], "log override", key)}`);
      }
    }
    if (supported) {
      for (let key in supported) {
        if (key.indexOf("=") >= 0)
          throw new Error(`Invalid supported: ${key}`);
        const value = supported[key];
        if (typeof value !== "boolean")
          throw new Error(`Expected value for supported ${quote(key)} to be a boolean, got ${typeof value} instead`);
        flags.push(`--supported:${key}=${value}`);
      }
    }
    if (pure)
      for (let fn of pure)
        flags.push(`--pure:${validateStringValue(fn, "pure")}`);
    if (keepNames)
      flags.push(`--keep-names`);
  }
  function flagsForBuildOptions(callName, options3, isTTY2, logLevelDefault, writeDefault) {
    var _a2;
    let flags = [];
    let entries = [];
    let keys = /* @__PURE__ */ Object.create(null);
    let stdinContents = null;
    let stdinResolveDir = null;
    pushLogFlags(flags, options3, keys, isTTY2, logLevelDefault);
    pushCommonFlags(flags, options3, keys);
    let sourcemap = getFlag(options3, keys, "sourcemap", mustBeStringOrBoolean);
    let bundle = getFlag(options3, keys, "bundle", mustBeBoolean);
    let splitting = getFlag(options3, keys, "splitting", mustBeBoolean);
    let preserveSymlinks = getFlag(options3, keys, "preserveSymlinks", mustBeBoolean);
    let metafile = getFlag(options3, keys, "metafile", mustBeBoolean);
    let outfile = getFlag(options3, keys, "outfile", mustBeString);
    let outdir = getFlag(options3, keys, "outdir", mustBeString);
    let outbase = getFlag(options3, keys, "outbase", mustBeString);
    let tsconfig = getFlag(options3, keys, "tsconfig", mustBeString);
    let resolveExtensions = getFlag(options3, keys, "resolveExtensions", mustBeArray);
    let nodePathsInput = getFlag(options3, keys, "nodePaths", mustBeArray);
    let mainFields = getFlag(options3, keys, "mainFields", mustBeArray);
    let conditions = getFlag(options3, keys, "conditions", mustBeArray);
    let external = getFlag(options3, keys, "external", mustBeArray);
    let packages = getFlag(options3, keys, "packages", mustBeString);
    let alias = getFlag(options3, keys, "alias", mustBeObject);
    let loader = getFlag(options3, keys, "loader", mustBeObject);
    let outExtension = getFlag(options3, keys, "outExtension", mustBeObject);
    let publicPath2 = getFlag(options3, keys, "publicPath", mustBeString);
    let entryNames = getFlag(options3, keys, "entryNames", mustBeString);
    let chunkNames = getFlag(options3, keys, "chunkNames", mustBeString);
    let assetNames = getFlag(options3, keys, "assetNames", mustBeString);
    let inject = getFlag(options3, keys, "inject", mustBeArray);
    let banner = getFlag(options3, keys, "banner", mustBeObject);
    let footer = getFlag(options3, keys, "footer", mustBeObject);
    let entryPoints = getFlag(options3, keys, "entryPoints", mustBeEntryPoints);
    let absWorkingDir = getFlag(options3, keys, "absWorkingDir", mustBeString);
    let stdin22 = getFlag(options3, keys, "stdin", mustBeObject);
    let write = (_a2 = getFlag(options3, keys, "write", mustBeBoolean)) != null ? _a2 : writeDefault;
    let allowOverwrite = getFlag(options3, keys, "allowOverwrite", mustBeBoolean);
    let mangleCache = getFlag(options3, keys, "mangleCache", mustBeObject);
    keys.plugins = true;
    checkForInvalidFlags(options3, keys, `in ${callName}() call`);
    if (sourcemap)
      flags.push(`--sourcemap${sourcemap === true ? "" : `=${sourcemap}`}`);
    if (bundle)
      flags.push("--bundle");
    if (allowOverwrite)
      flags.push("--allow-overwrite");
    if (splitting)
      flags.push("--splitting");
    if (preserveSymlinks)
      flags.push("--preserve-symlinks");
    if (metafile)
      flags.push(`--metafile`);
    if (outfile)
      flags.push(`--outfile=${outfile}`);
    if (outdir)
      flags.push(`--outdir=${outdir}`);
    if (outbase)
      flags.push(`--outbase=${outbase}`);
    if (tsconfig)
      flags.push(`--tsconfig=${tsconfig}`);
    if (packages)
      flags.push(`--packages=${packages}`);
    if (resolveExtensions) {
      let values3 = [];
      for (let value of resolveExtensions) {
        validateStringValue(value, "resolve extension");
        if (value.indexOf(",") >= 0)
          throw new Error(`Invalid resolve extension: ${value}`);
        values3.push(value);
      }
      flags.push(`--resolve-extensions=${values3.join(",")}`);
    }
    if (publicPath2)
      flags.push(`--public-path=${publicPath2}`);
    if (entryNames)
      flags.push(`--entry-names=${entryNames}`);
    if (chunkNames)
      flags.push(`--chunk-names=${chunkNames}`);
    if (assetNames)
      flags.push(`--asset-names=${assetNames}`);
    if (mainFields) {
      let values3 = [];
      for (let value of mainFields) {
        validateStringValue(value, "main field");
        if (value.indexOf(",") >= 0)
          throw new Error(`Invalid main field: ${value}`);
        values3.push(value);
      }
      flags.push(`--main-fields=${values3.join(",")}`);
    }
    if (conditions) {
      let values3 = [];
      for (let value of conditions) {
        validateStringValue(value, "condition");
        if (value.indexOf(",") >= 0)
          throw new Error(`Invalid condition: ${value}`);
        values3.push(value);
      }
      flags.push(`--conditions=${values3.join(",")}`);
    }
    if (external)
      for (let name of external)
        flags.push(`--external:${validateStringValue(name, "external")}`);
    if (alias) {
      for (let old in alias) {
        if (old.indexOf("=") >= 0)
          throw new Error(`Invalid package name in alias: ${old}`);
        flags.push(`--alias:${old}=${validateStringValue(alias[old], "alias", old)}`);
      }
    }
    if (banner) {
      for (let type in banner) {
        if (type.indexOf("=") >= 0)
          throw new Error(`Invalid banner file type: ${type}`);
        flags.push(`--banner:${type}=${validateStringValue(banner[type], "banner", type)}`);
      }
    }
    if (footer) {
      for (let type in footer) {
        if (type.indexOf("=") >= 0)
          throw new Error(`Invalid footer file type: ${type}`);
        flags.push(`--footer:${type}=${validateStringValue(footer[type], "footer", type)}`);
      }
    }
    if (inject)
      for (let path32 of inject)
        flags.push(`--inject:${validateStringValue(path32, "inject")}`);
    if (loader) {
      for (let ext2 in loader) {
        if (ext2.indexOf("=") >= 0)
          throw new Error(`Invalid loader extension: ${ext2}`);
        flags.push(`--loader:${ext2}=${validateStringValue(loader[ext2], "loader", ext2)}`);
      }
    }
    if (outExtension) {
      for (let ext2 in outExtension) {
        if (ext2.indexOf("=") >= 0)
          throw new Error(`Invalid out extension: ${ext2}`);
        flags.push(`--out-extension:${ext2}=${validateStringValue(outExtension[ext2], "out extension", ext2)}`);
      }
    }
    if (entryPoints) {
      if (Array.isArray(entryPoints)) {
        for (let i = 0, n = entryPoints.length;i < n; i++) {
          let entryPoint = entryPoints[i];
          if (typeof entryPoint === "object" && entryPoint !== null) {
            let entryPointKeys = /* @__PURE__ */ Object.create(null);
            let input = getFlag(entryPoint, entryPointKeys, "in", mustBeString);
            let output = getFlag(entryPoint, entryPointKeys, "out", mustBeString);
            checkForInvalidFlags(entryPoint, entryPointKeys, "in entry point at index " + i);
            if (input === undefined)
              throw new Error('Missing property "in" for entry point at index ' + i);
            if (output === undefined)
              throw new Error('Missing property "out" for entry point at index ' + i);
            entries.push([output, input]);
          } else {
            entries.push(["", validateStringValue(entryPoint, "entry point at index " + i)]);
          }
        }
      } else {
        for (let key in entryPoints) {
          entries.push([key, validateStringValue(entryPoints[key], "entry point", key)]);
        }
      }
    }
    if (stdin22) {
      let stdinKeys = /* @__PURE__ */ Object.create(null);
      let contents = getFlag(stdin22, stdinKeys, "contents", mustBeStringOrUint8Array);
      let resolveDir = getFlag(stdin22, stdinKeys, "resolveDir", mustBeString);
      let sourcefile = getFlag(stdin22, stdinKeys, "sourcefile", mustBeString);
      let loader2 = getFlag(stdin22, stdinKeys, "loader", mustBeString);
      checkForInvalidFlags(stdin22, stdinKeys, 'in "stdin" object');
      if (sourcefile)
        flags.push(`--sourcefile=${sourcefile}`);
      if (loader2)
        flags.push(`--loader=${loader2}`);
      if (resolveDir)
        stdinResolveDir = resolveDir;
      if (typeof contents === "string")
        stdinContents = encodeUTF8(contents);
      else if (contents instanceof Uint8Array)
        stdinContents = contents;
    }
    let nodePaths = [];
    if (nodePathsInput) {
      for (let value of nodePathsInput) {
        value += "";
        nodePaths.push(value);
      }
    }
    return {
      entries,
      flags,
      write,
      stdinContents,
      stdinResolveDir,
      absWorkingDir,
      nodePaths,
      mangleCache: validateMangleCache(mangleCache)
    };
  }
  function flagsForTransformOptions(callName, options3, isTTY2, logLevelDefault) {
    let flags = [];
    let keys = /* @__PURE__ */ Object.create(null);
    pushLogFlags(flags, options3, keys, isTTY2, logLevelDefault);
    pushCommonFlags(flags, options3, keys);
    let sourcemap = getFlag(options3, keys, "sourcemap", mustBeStringOrBoolean);
    let sourcefile = getFlag(options3, keys, "sourcefile", mustBeString);
    let loader = getFlag(options3, keys, "loader", mustBeString);
    let banner = getFlag(options3, keys, "banner", mustBeString);
    let footer = getFlag(options3, keys, "footer", mustBeString);
    let mangleCache = getFlag(options3, keys, "mangleCache", mustBeObject);
    checkForInvalidFlags(options3, keys, `in ${callName}() call`);
    if (sourcemap)
      flags.push(`--sourcemap=${sourcemap === true ? "external" : sourcemap}`);
    if (sourcefile)
      flags.push(`--sourcefile=${sourcefile}`);
    if (loader)
      flags.push(`--loader=${loader}`);
    if (banner)
      flags.push(`--banner=${banner}`);
    if (footer)
      flags.push(`--footer=${footer}`);
    return {
      flags,
      mangleCache: validateMangleCache(mangleCache)
    };
  }
  function createChannel(streamIn) {
    const requestCallbacksByKey = {};
    const closeData = { didClose: false, reason: "" };
    let responseCallbacks = {};
    let nextRequestID = 0;
    let nextBuildKey = 0;
    let stdout22 = new Uint8Array(16384);
    let stdoutUsed = 0;
    let readFromStdout = (chunk) => {
      let limit = stdoutUsed + chunk.length;
      if (limit > stdout22.length) {
        let swap = new Uint8Array(limit * 2);
        swap.set(stdout22);
        stdout22 = swap;
      }
      stdout22.set(chunk, stdoutUsed);
      stdoutUsed += chunk.length;
      let offset = 0;
      while (offset + 4 <= stdoutUsed) {
        let length = readUInt32LE(stdout22, offset);
        if (offset + 4 + length > stdoutUsed) {
          break;
        }
        offset += 4;
        handleIncomingPacket(stdout22.subarray(offset, offset + length));
        offset += length;
      }
      if (offset > 0) {
        stdout22.copyWithin(0, offset, stdoutUsed);
        stdoutUsed -= offset;
      }
    };
    let afterClose = (error) => {
      closeData.didClose = true;
      if (error)
        closeData.reason = ": " + (error.message || error);
      const text22 = "The service was stopped" + closeData.reason;
      for (let id in responseCallbacks) {
        responseCallbacks[id](text22, null);
      }
      responseCallbacks = {};
    };
    let sendRequest = (refs, value, callback) => {
      if (closeData.didClose)
        return callback("The service is no longer running" + closeData.reason, null);
      let id = nextRequestID++;
      responseCallbacks[id] = (error, response) => {
        try {
          callback(error, response);
        } finally {
          if (refs)
            refs.unref();
        }
      };
      if (refs)
        refs.ref();
      streamIn.writeToStdin(encodePacket({ id, isRequest: true, value }));
    };
    let sendResponse = (id, value) => {
      if (closeData.didClose)
        throw new Error("The service is no longer running" + closeData.reason);
      streamIn.writeToStdin(encodePacket({ id, isRequest: false, value }));
    };
    let handleRequest = async (id, request2) => {
      try {
        if (request2.command === "ping") {
          sendResponse(id, {});
          return;
        }
        if (typeof request2.key === "number") {
          const requestCallbacks = requestCallbacksByKey[request2.key];
          if (!requestCallbacks) {
            return;
          }
          const callback = requestCallbacks[request2.command];
          if (callback) {
            await callback(id, request2);
            return;
          }
        }
        throw new Error(`Invalid command: ` + request2.command);
      } catch (e) {
        const errors3 = [extractErrorMessageV8(e, streamIn, null, undefined, "")];
        try {
          sendResponse(id, { errors: errors3 });
        } catch {
        }
      }
    };
    let isFirstPacket = true;
    let handleIncomingPacket = (bytes) => {
      if (isFirstPacket) {
        isFirstPacket = false;
        let binaryVersion = String.fromCharCode(...bytes);
        if (binaryVersion !== "0.19.12") {
          throw new Error(`Cannot start service: Host version "0.19.12" does not match binary version ${quote(binaryVersion)}`);
        }
        return;
      }
      let packet = decodePacket(bytes);
      if (packet.isRequest) {
        handleRequest(packet.id, packet.value);
      } else {
        let callback = responseCallbacks[packet.id];
        delete responseCallbacks[packet.id];
        if (packet.value.error)
          callback(packet.value.error, {});
        else
          callback(null, packet.value);
      }
    };
    let buildOrContext = ({ callName, refs, options: options3, isTTY: isTTY2, defaultWD: defaultWD2, callback }) => {
      let refCount = 0;
      const buildKey = nextBuildKey++;
      const requestCallbacks = {};
      const buildRefs = {
        ref() {
          if (++refCount === 1) {
            if (refs)
              refs.ref();
          }
        },
        unref() {
          if (--refCount === 0) {
            delete requestCallbacksByKey[buildKey];
            if (refs)
              refs.unref();
          }
        }
      };
      requestCallbacksByKey[buildKey] = requestCallbacks;
      buildRefs.ref();
      buildOrContextImpl(callName, buildKey, sendRequest, sendResponse, buildRefs, streamIn, requestCallbacks, options3, isTTY2, defaultWD2, (err22, res) => {
        try {
          callback(err22, res);
        } finally {
          buildRefs.unref();
        }
      });
    };
    let transform2 = ({ callName, refs, input, options: options3, isTTY: isTTY2, fs: fs32, callback }) => {
      const details = createObjectStash();
      let start = (inputPath) => {
        try {
          if (typeof input !== "string" && !(input instanceof Uint8Array))
            throw new Error('The input to "transform" must be a string or a Uint8Array');
          let {
            flags,
            mangleCache
          } = flagsForTransformOptions(callName, options3, isTTY2, transformLogLevelDefault);
          let request2 = {
            command: "transform",
            flags,
            inputFS: inputPath !== null,
            input: inputPath !== null ? encodeUTF8(inputPath) : typeof input === "string" ? encodeUTF8(input) : input
          };
          if (mangleCache)
            request2.mangleCache = mangleCache;
          sendRequest(refs, request2, (error, response) => {
            if (error)
              return callback(new Error(error), null);
            let errors3 = replaceDetailsInMessages(response.errors, details);
            let warnings = replaceDetailsInMessages(response.warnings, details);
            let outstanding = 1;
            let next = () => {
              if (--outstanding === 0) {
                let result2 = {
                  warnings,
                  code: response.code,
                  map: response.map,
                  mangleCache: undefined,
                  legalComments: undefined
                };
                if ("legalComments" in response)
                  result2.legalComments = response == null ? undefined : response.legalComments;
                if (response.mangleCache)
                  result2.mangleCache = response == null ? undefined : response.mangleCache;
                callback(null, result2);
              }
            };
            if (errors3.length > 0)
              return callback(failureErrorWithLog("Transform failed", errors3, warnings), null);
            if (response.codeFS) {
              outstanding++;
              fs32.readFile(response.code, (err22, contents) => {
                if (err22 !== null) {
                  callback(err22, null);
                } else {
                  response.code = contents;
                  next();
                }
              });
            }
            if (response.mapFS) {
              outstanding++;
              fs32.readFile(response.map, (err22, contents) => {
                if (err22 !== null) {
                  callback(err22, null);
                } else {
                  response.map = contents;
                  next();
                }
              });
            }
            next();
          });
        } catch (e) {
          let flags = [];
          try {
            pushLogFlags(flags, options3, {}, isTTY2, transformLogLevelDefault);
          } catch {
          }
          const error = extractErrorMessageV8(e, streamIn, details, undefined, "");
          sendRequest(refs, { command: "error", flags, error }, () => {
            error.detail = details.load(error.detail);
            callback(failureErrorWithLog("Transform failed", [error], []), null);
          });
        }
      };
      if ((typeof input === "string" || input instanceof Uint8Array) && input.length > 1048576) {
        let next = start;
        start = () => fs32.writeFile(input, next);
      }
      start(null);
    };
    let formatMessages2 = ({ callName, refs, messages: messages3, options: options3, callback }) => {
      if (!options3)
        throw new Error(`Missing second argument in ${callName}() call`);
      let keys = {};
      let kind = getFlag(options3, keys, "kind", mustBeString);
      let color = getFlag(options3, keys, "color", mustBeBoolean);
      let terminalWidth = getFlag(options3, keys, "terminalWidth", mustBeInteger);
      checkForInvalidFlags(options3, keys, `in ${callName}() call`);
      if (kind === undefined)
        throw new Error(`Missing "kind" in ${callName}() call`);
      if (kind !== "error" && kind !== "warning")
        throw new Error(`Expected "kind" to be "error" or "warning" in ${callName}() call`);
      let request2 = {
        command: "format-msgs",
        messages: sanitizeMessages(messages3, "messages", null, "", terminalWidth),
        isWarning: kind === "warning"
      };
      if (color !== undefined)
        request2.color = color;
      if (terminalWidth !== undefined)
        request2.terminalWidth = terminalWidth;
      sendRequest(refs, request2, (error, response) => {
        if (error)
          return callback(new Error(error), null);
        callback(null, response.messages);
      });
    };
    let analyzeMetafile2 = ({ callName, refs, metafile, options: options3, callback }) => {
      if (options3 === undefined)
        options3 = {};
      let keys = {};
      let color = getFlag(options3, keys, "color", mustBeBoolean);
      let verbose = getFlag(options3, keys, "verbose", mustBeBoolean);
      checkForInvalidFlags(options3, keys, `in ${callName}() call`);
      let request2 = {
        command: "analyze-metafile",
        metafile
      };
      if (color !== undefined)
        request2.color = color;
      if (verbose !== undefined)
        request2.verbose = verbose;
      sendRequest(refs, request2, (error, response) => {
        if (error)
          return callback(new Error(error), null);
        callback(null, response.result);
      });
    };
    return {
      readFromStdout,
      afterClose,
      service: {
        buildOrContext,
        transform: transform2,
        formatMessages: formatMessages2,
        analyzeMetafile: analyzeMetafile2
      }
    };
  }
  function buildOrContextImpl(callName, buildKey, sendRequest, sendResponse, refs, streamIn, requestCallbacks, options3, isTTY2, defaultWD2, callback) {
    const details = createObjectStash();
    const isContext = callName === "context";
    const handleError22 = (e, pluginName) => {
      const flags = [];
      try {
        pushLogFlags(flags, options3, {}, isTTY2, buildLogLevelDefault);
      } catch {
      }
      const message = extractErrorMessageV8(e, streamIn, details, undefined, pluginName);
      sendRequest(refs, { command: "error", flags, error: message }, () => {
        message.detail = details.load(message.detail);
        callback(failureErrorWithLog(isContext ? "Context failed" : "Build failed", [message], []), null);
      });
    };
    let plugins;
    if (typeof options3 === "object") {
      const value = options3.plugins;
      if (value !== undefined) {
        if (!Array.isArray(value))
          return handleError22(new Error(`"plugins" must be an array`), "");
        plugins = value;
      }
    }
    if (plugins && plugins.length > 0) {
      if (streamIn.isSync)
        return handleError22(new Error("Cannot use plugins in synchronous API calls"), "");
      handlePlugins(buildKey, sendRequest, sendResponse, refs, streamIn, requestCallbacks, options3, plugins, details).then((result2) => {
        if (!result2.ok)
          return handleError22(result2.error, result2.pluginName);
        try {
          buildOrContextContinue(result2.requestPlugins, result2.runOnEndCallbacks, result2.scheduleOnDisposeCallbacks);
        } catch (e) {
          handleError22(e, "");
        }
      }, (e) => handleError22(e, ""));
      return;
    }
    try {
      buildOrContextContinue(null, (result2, done) => done([], []), () => {
      });
    } catch (e) {
      handleError22(e, "");
    }
    function buildOrContextContinue(requestPlugins, runOnEndCallbacks, scheduleOnDisposeCallbacks) {
      const writeDefault = streamIn.hasFS;
      const {
        entries,
        flags,
        write,
        stdinContents,
        stdinResolveDir,
        absWorkingDir,
        nodePaths,
        mangleCache
      } = flagsForBuildOptions(callName, options3, isTTY2, buildLogLevelDefault, writeDefault);
      if (write && !streamIn.hasFS)
        throw new Error(`The "write" option is unavailable in this environment`);
      const request2 = {
        command: "build",
        key: buildKey,
        entries,
        flags,
        write,
        stdinContents,
        stdinResolveDir,
        absWorkingDir: absWorkingDir || defaultWD2,
        nodePaths,
        context: isContext
      };
      if (requestPlugins)
        request2.plugins = requestPlugins;
      if (mangleCache)
        request2.mangleCache = mangleCache;
      const buildResponseToResult = (response, callback2) => {
        const result2 = {
          errors: replaceDetailsInMessages(response.errors, details),
          warnings: replaceDetailsInMessages(response.warnings, details),
          outputFiles: undefined,
          metafile: undefined,
          mangleCache: undefined
        };
        const originalErrors = result2.errors.slice();
        const originalWarnings = result2.warnings.slice();
        if (response.outputFiles)
          result2.outputFiles = response.outputFiles.map(convertOutputFiles);
        if (response.metafile)
          result2.metafile = JSON.parse(response.metafile);
        if (response.mangleCache)
          result2.mangleCache = response.mangleCache;
        if (response.writeToStdout !== undefined)
          console.log(decodeUTF8(response.writeToStdout).replace(/\n$/, ""));
        runOnEndCallbacks(result2, (onEndErrors, onEndWarnings) => {
          if (originalErrors.length > 0 || onEndErrors.length > 0) {
            const error = failureErrorWithLog("Build failed", originalErrors.concat(onEndErrors), originalWarnings.concat(onEndWarnings));
            return callback2(error, null, onEndErrors, onEndWarnings);
          }
          callback2(null, result2, onEndErrors, onEndWarnings);
        });
      };
      let latestResultPromise;
      let provideLatestResult;
      if (isContext)
        requestCallbacks["on-end"] = (id, request22) => new Promise((resolve23) => {
          buildResponseToResult(request22, (err22, result2, onEndErrors, onEndWarnings) => {
            const response = {
              errors: onEndErrors,
              warnings: onEndWarnings
            };
            if (provideLatestResult)
              provideLatestResult(err22, result2);
            latestResultPromise = undefined;
            provideLatestResult = undefined;
            sendResponse(id, response);
            resolve23();
          });
        });
      sendRequest(refs, request2, (error, response) => {
        if (error)
          return callback(new Error(error), null);
        if (!isContext) {
          return buildResponseToResult(response, (err22, res) => {
            scheduleOnDisposeCallbacks();
            return callback(err22, res);
          });
        }
        if (response.errors.length > 0) {
          return callback(failureErrorWithLog("Context failed", response.errors, response.warnings), null);
        }
        let didDispose = false;
        const result2 = {
          rebuild: () => {
            if (!latestResultPromise)
              latestResultPromise = new Promise((resolve23, reject) => {
                let settlePromise;
                provideLatestResult = (err22, result22) => {
                  if (!settlePromise)
                    settlePromise = () => err22 ? reject(err22) : resolve23(result22);
                };
                const triggerAnotherBuild = () => {
                  const request22 = {
                    command: "rebuild",
                    key: buildKey
                  };
                  sendRequest(refs, request22, (error2, response2) => {
                    if (error2) {
                      reject(new Error(error2));
                    } else if (settlePromise) {
                      settlePromise();
                    } else {
                      triggerAnotherBuild();
                    }
                  });
                };
                triggerAnotherBuild();
              });
            return latestResultPromise;
          },
          watch: (options222 = {}) => new Promise((resolve23, reject) => {
            if (!streamIn.hasFS)
              throw new Error(`Cannot use the "watch" API in this environment`);
            const keys = {};
            checkForInvalidFlags(options222, keys, `in watch() call`);
            const request22 = {
              command: "watch",
              key: buildKey
            };
            sendRequest(refs, request22, (error2) => {
              if (error2)
                reject(new Error(error2));
              else
                resolve23(undefined);
            });
          }),
          serve: (options222 = {}) => new Promise((resolve23, reject) => {
            if (!streamIn.hasFS)
              throw new Error(`Cannot use the "serve" API in this environment`);
            const keys = {};
            const port = getFlag(options222, keys, "port", mustBeInteger);
            const host = getFlag(options222, keys, "host", mustBeString);
            const servedir = getFlag(options222, keys, "servedir", mustBeString);
            const keyfile = getFlag(options222, keys, "keyfile", mustBeString);
            const certfile = getFlag(options222, keys, "certfile", mustBeString);
            const fallback22 = getFlag(options222, keys, "fallback", mustBeString);
            const onRequest = getFlag(options222, keys, "onRequest", mustBeFunction);
            checkForInvalidFlags(options222, keys, `in serve() call`);
            const request22 = {
              command: "serve",
              key: buildKey,
              onRequest: !!onRequest
            };
            if (port !== undefined)
              request22.port = port;
            if (host !== undefined)
              request22.host = host;
            if (servedir !== undefined)
              request22.servedir = servedir;
            if (keyfile !== undefined)
              request22.keyfile = keyfile;
            if (certfile !== undefined)
              request22.certfile = certfile;
            if (fallback22 !== undefined)
              request22.fallback = fallback22;
            sendRequest(refs, request22, (error2, response2) => {
              if (error2)
                return reject(new Error(error2));
              if (onRequest) {
                requestCallbacks["serve-request"] = (id, request3) => {
                  onRequest(request3.args);
                  sendResponse(id, {});
                };
              }
              resolve23(response2);
            });
          }),
          cancel: () => new Promise((resolve23) => {
            if (didDispose)
              return resolve23();
            const request22 = {
              command: "cancel",
              key: buildKey
            };
            sendRequest(refs, request22, () => {
              resolve23();
            });
          }),
          dispose: () => new Promise((resolve23) => {
            if (didDispose)
              return resolve23();
            didDispose = true;
            const request22 = {
              command: "dispose",
              key: buildKey
            };
            sendRequest(refs, request22, () => {
              resolve23();
              scheduleOnDisposeCallbacks();
              refs.unref();
            });
          })
        };
        refs.ref();
        callback(null, result2);
      });
    }
  }
  var handlePlugins = async (buildKey, sendRequest, sendResponse, refs, streamIn, requestCallbacks, initialOptions, plugins, details) => {
    let onStartCallbacks = [];
    let onEndCallbacks = [];
    let onResolveCallbacks = {};
    let onLoadCallbacks = {};
    let onDisposeCallbacks = [];
    let nextCallbackID = 0;
    let i = 0;
    let requestPlugins = [];
    let isSetupDone = false;
    plugins = [...plugins];
    for (let item of plugins) {
      let keys = {};
      if (typeof item !== "object")
        throw new Error(`Plugin at index ${i} must be an object`);
      const name = getFlag(item, keys, "name", mustBeString);
      if (typeof name !== "string" || name === "")
        throw new Error(`Plugin at index ${i} is missing a name`);
      try {
        let setup = getFlag(item, keys, "setup", mustBeFunction);
        if (typeof setup !== "function")
          throw new Error(`Plugin is missing a setup function`);
        checkForInvalidFlags(item, keys, `on plugin ${quote(name)}`);
        let plugin = {
          name,
          onStart: false,
          onEnd: false,
          onResolve: [],
          onLoad: []
        };
        i++;
        let resolve23 = (path32, options3 = {}) => {
          if (!isSetupDone)
            throw new Error('Cannot call "resolve" before plugin setup has completed');
          if (typeof path32 !== "string")
            throw new Error(`The path to resolve must be a string`);
          let keys2 = /* @__PURE__ */ Object.create(null);
          let pluginName = getFlag(options3, keys2, "pluginName", mustBeString);
          let importer = getFlag(options3, keys2, "importer", mustBeString);
          let namespace = getFlag(options3, keys2, "namespace", mustBeString);
          let resolveDir = getFlag(options3, keys2, "resolveDir", mustBeString);
          let kind = getFlag(options3, keys2, "kind", mustBeString);
          let pluginData = getFlag(options3, keys2, "pluginData", canBeAnything);
          checkForInvalidFlags(options3, keys2, "in resolve() call");
          return new Promise((resolve222, reject) => {
            const request2 = {
              command: "resolve",
              path: path32,
              key: buildKey,
              pluginName: name
            };
            if (pluginName != null)
              request2.pluginName = pluginName;
            if (importer != null)
              request2.importer = importer;
            if (namespace != null)
              request2.namespace = namespace;
            if (resolveDir != null)
              request2.resolveDir = resolveDir;
            if (kind != null)
              request2.kind = kind;
            else
              throw new Error(`Must specify "kind" when calling "resolve"`);
            if (pluginData != null)
              request2.pluginData = details.store(pluginData);
            sendRequest(refs, request2, (error, response) => {
              if (error !== null)
                reject(new Error(error));
              else
                resolve222({
                  errors: replaceDetailsInMessages(response.errors, details),
                  warnings: replaceDetailsInMessages(response.warnings, details),
                  path: response.path,
                  external: response.external,
                  sideEffects: response.sideEffects,
                  namespace: response.namespace,
                  suffix: response.suffix,
                  pluginData: details.load(response.pluginData)
                });
            });
          });
        };
        let promise2 = setup({
          initialOptions,
          resolve: resolve23,
          onStart(callback) {
            let registeredText = `This error came from the "onStart" callback registered here:`;
            let registeredNote = extractCallerV8(new Error(registeredText), streamIn, "onStart");
            onStartCallbacks.push({ name, callback, note: registeredNote });
            plugin.onStart = true;
          },
          onEnd(callback) {
            let registeredText = `This error came from the "onEnd" callback registered here:`;
            let registeredNote = extractCallerV8(new Error(registeredText), streamIn, "onEnd");
            onEndCallbacks.push({ name, callback, note: registeredNote });
            plugin.onEnd = true;
          },
          onResolve(options3, callback) {
            let registeredText = `This error came from the "onResolve" callback registered here:`;
            let registeredNote = extractCallerV8(new Error(registeredText), streamIn, "onResolve");
            let keys2 = {};
            let filter = getFlag(options3, keys2, "filter", mustBeRegExp);
            let namespace = getFlag(options3, keys2, "namespace", mustBeString);
            checkForInvalidFlags(options3, keys2, `in onResolve() call for plugin ${quote(name)}`);
            if (filter == null)
              throw new Error(`onResolve() call is missing a filter`);
            let id = nextCallbackID++;
            onResolveCallbacks[id] = { name, callback, note: registeredNote };
            plugin.onResolve.push({ id, filter: filter.source, namespace: namespace || "" });
          },
          onLoad(options3, callback) {
            let registeredText = `This error came from the "onLoad" callback registered here:`;
            let registeredNote = extractCallerV8(new Error(registeredText), streamIn, "onLoad");
            let keys2 = {};
            let filter = getFlag(options3, keys2, "filter", mustBeRegExp);
            let namespace = getFlag(options3, keys2, "namespace", mustBeString);
            checkForInvalidFlags(options3, keys2, `in onLoad() call for plugin ${quote(name)}`);
            if (filter == null)
              throw new Error(`onLoad() call is missing a filter`);
            let id = nextCallbackID++;
            onLoadCallbacks[id] = { name, callback, note: registeredNote };
            plugin.onLoad.push({ id, filter: filter.source, namespace: namespace || "" });
          },
          onDispose(callback) {
            onDisposeCallbacks.push(callback);
          },
          esbuild: streamIn.esbuild
        });
        if (promise2)
          await promise2;
        requestPlugins.push(plugin);
      } catch (e) {
        return { ok: false, error: e, pluginName: name };
      }
    }
    requestCallbacks["on-start"] = async (id, request2) => {
      let response = { errors: [], warnings: [] };
      await Promise.all(onStartCallbacks.map(async ({ name, callback, note }) => {
        try {
          let result2 = await callback();
          if (result2 != null) {
            if (typeof result2 !== "object")
              throw new Error(`Expected onStart() callback in plugin ${quote(name)} to return an object`);
            let keys = {};
            let errors3 = getFlag(result2, keys, "errors", mustBeArray);
            let warnings = getFlag(result2, keys, "warnings", mustBeArray);
            checkForInvalidFlags(result2, keys, `from onStart() callback in plugin ${quote(name)}`);
            if (errors3 != null)
              response.errors.push(...sanitizeMessages(errors3, "errors", details, name, undefined));
            if (warnings != null)
              response.warnings.push(...sanitizeMessages(warnings, "warnings", details, name, undefined));
          }
        } catch (e) {
          response.errors.push(extractErrorMessageV8(e, streamIn, details, note && note(), name));
        }
      }));
      sendResponse(id, response);
    };
    requestCallbacks["on-resolve"] = async (id, request2) => {
      let response = {}, name = "", callback, note;
      for (let id2 of request2.ids) {
        try {
          ({ name, callback, note } = onResolveCallbacks[id2]);
          let result2 = await callback({
            path: request2.path,
            importer: request2.importer,
            namespace: request2.namespace,
            resolveDir: request2.resolveDir,
            kind: request2.kind,
            pluginData: details.load(request2.pluginData)
          });
          if (result2 != null) {
            if (typeof result2 !== "object")
              throw new Error(`Expected onResolve() callback in plugin ${quote(name)} to return an object`);
            let keys = {};
            let pluginName = getFlag(result2, keys, "pluginName", mustBeString);
            let path32 = getFlag(result2, keys, "path", mustBeString);
            let namespace = getFlag(result2, keys, "namespace", mustBeString);
            let suffix = getFlag(result2, keys, "suffix", mustBeString);
            let external = getFlag(result2, keys, "external", mustBeBoolean);
            let sideEffects = getFlag(result2, keys, "sideEffects", mustBeBoolean);
            let pluginData = getFlag(result2, keys, "pluginData", canBeAnything);
            let errors3 = getFlag(result2, keys, "errors", mustBeArray);
            let warnings = getFlag(result2, keys, "warnings", mustBeArray);
            let watchFiles = getFlag(result2, keys, "watchFiles", mustBeArray);
            let watchDirs = getFlag(result2, keys, "watchDirs", mustBeArray);
            checkForInvalidFlags(result2, keys, `from onResolve() callback in plugin ${quote(name)}`);
            response.id = id2;
            if (pluginName != null)
              response.pluginName = pluginName;
            if (path32 != null)
              response.path = path32;
            if (namespace != null)
              response.namespace = namespace;
            if (suffix != null)
              response.suffix = suffix;
            if (external != null)
              response.external = external;
            if (sideEffects != null)
              response.sideEffects = sideEffects;
            if (pluginData != null)
              response.pluginData = details.store(pluginData);
            if (errors3 != null)
              response.errors = sanitizeMessages(errors3, "errors", details, name, undefined);
            if (warnings != null)
              response.warnings = sanitizeMessages(warnings, "warnings", details, name, undefined);
            if (watchFiles != null)
              response.watchFiles = sanitizeStringArray(watchFiles, "watchFiles");
            if (watchDirs != null)
              response.watchDirs = sanitizeStringArray(watchDirs, "watchDirs");
            break;
          }
        } catch (e) {
          response = { id: id2, errors: [extractErrorMessageV8(e, streamIn, details, note && note(), name)] };
          break;
        }
      }
      sendResponse(id, response);
    };
    requestCallbacks["on-load"] = async (id, request2) => {
      let response = {}, name = "", callback, note;
      for (let id2 of request2.ids) {
        try {
          ({ name, callback, note } = onLoadCallbacks[id2]);
          let result2 = await callback({
            path: request2.path,
            namespace: request2.namespace,
            suffix: request2.suffix,
            pluginData: details.load(request2.pluginData),
            with: request2.with
          });
          if (result2 != null) {
            if (typeof result2 !== "object")
              throw new Error(`Expected onLoad() callback in plugin ${quote(name)} to return an object`);
            let keys = {};
            let pluginName = getFlag(result2, keys, "pluginName", mustBeString);
            let contents = getFlag(result2, keys, "contents", mustBeStringOrUint8Array);
            let resolveDir = getFlag(result2, keys, "resolveDir", mustBeString);
            let pluginData = getFlag(result2, keys, "pluginData", canBeAnything);
            let loader = getFlag(result2, keys, "loader", mustBeString);
            let errors3 = getFlag(result2, keys, "errors", mustBeArray);
            let warnings = getFlag(result2, keys, "warnings", mustBeArray);
            let watchFiles = getFlag(result2, keys, "watchFiles", mustBeArray);
            let watchDirs = getFlag(result2, keys, "watchDirs", mustBeArray);
            checkForInvalidFlags(result2, keys, `from onLoad() callback in plugin ${quote(name)}`);
            response.id = id2;
            if (pluginName != null)
              response.pluginName = pluginName;
            if (contents instanceof Uint8Array)
              response.contents = contents;
            else if (contents != null)
              response.contents = encodeUTF8(contents);
            if (resolveDir != null)
              response.resolveDir = resolveDir;
            if (pluginData != null)
              response.pluginData = details.store(pluginData);
            if (loader != null)
              response.loader = loader;
            if (errors3 != null)
              response.errors = sanitizeMessages(errors3, "errors", details, name, undefined);
            if (warnings != null)
              response.warnings = sanitizeMessages(warnings, "warnings", details, name, undefined);
            if (watchFiles != null)
              response.watchFiles = sanitizeStringArray(watchFiles, "watchFiles");
            if (watchDirs != null)
              response.watchDirs = sanitizeStringArray(watchDirs, "watchDirs");
            break;
          }
        } catch (e) {
          response = { id: id2, errors: [extractErrorMessageV8(e, streamIn, details, note && note(), name)] };
          break;
        }
      }
      sendResponse(id, response);
    };
    let runOnEndCallbacks = (result2, done) => done([], []);
    if (onEndCallbacks.length > 0) {
      runOnEndCallbacks = (result2, done) => {
        (async () => {
          const onEndErrors = [];
          const onEndWarnings = [];
          for (const { name, callback, note } of onEndCallbacks) {
            let newErrors;
            let newWarnings;
            try {
              const value = await callback(result2);
              if (value != null) {
                if (typeof value !== "object")
                  throw new Error(`Expected onEnd() callback in plugin ${quote(name)} to return an object`);
                let keys = {};
                let errors3 = getFlag(value, keys, "errors", mustBeArray);
                let warnings = getFlag(value, keys, "warnings", mustBeArray);
                checkForInvalidFlags(value, keys, `from onEnd() callback in plugin ${quote(name)}`);
                if (errors3 != null)
                  newErrors = sanitizeMessages(errors3, "errors", details, name, undefined);
                if (warnings != null)
                  newWarnings = sanitizeMessages(warnings, "warnings", details, name, undefined);
              }
            } catch (e) {
              newErrors = [extractErrorMessageV8(e, streamIn, details, note && note(), name)];
            }
            if (newErrors) {
              onEndErrors.push(...newErrors);
              try {
                result2.errors.push(...newErrors);
              } catch {
              }
            }
            if (newWarnings) {
              onEndWarnings.push(...newWarnings);
              try {
                result2.warnings.push(...newWarnings);
              } catch {
              }
            }
          }
          done(onEndErrors, onEndWarnings);
        })();
      };
    }
    let scheduleOnDisposeCallbacks = () => {
      for (const cb of onDisposeCallbacks) {
        setTimeout(() => cb(), 0);
      }
    };
    isSetupDone = true;
    return {
      ok: true,
      requestPlugins,
      runOnEndCallbacks,
      scheduleOnDisposeCallbacks
    };
  };
  function createObjectStash() {
    const map = /* @__PURE__ */ new Map;
    let nextID = 0;
    return {
      load(id) {
        return map.get(id);
      },
      store(value) {
        if (value === undefined)
          return -1;
        const id = nextID++;
        map.set(id, value);
        return id;
      }
    };
  }
  function extractCallerV8(e, streamIn, ident) {
    let note;
    let tried = false;
    return () => {
      if (tried)
        return note;
      tried = true;
      try {
        let lines = (e.stack + "").split("\n");
        lines.splice(1, 1);
        let location2 = parseStackLinesV8(streamIn, lines, ident);
        if (location2) {
          note = { text: e.message, location: location2 };
          return note;
        }
      } catch {
      }
    };
  }
  function extractErrorMessageV8(e, streamIn, stash, note, pluginName) {
    let text22 = "Internal error";
    let location2 = null;
    try {
      text22 = (e && e.message || e) + "";
    } catch {
    }
    try {
      location2 = parseStackLinesV8(streamIn, (e.stack + "").split("\n"), "");
    } catch {
    }
    return { id: "", pluginName, text: text22, location: location2, notes: note ? [note] : [], detail: stash ? stash.store(e) : -1 };
  }
  function parseStackLinesV8(streamIn, lines, ident) {
    let at = "    at ";
    if (streamIn.readFileSync && !lines[0].startsWith(at) && lines[1].startsWith(at)) {
      for (let i = 1;i < lines.length; i++) {
        let line = lines[i];
        if (!line.startsWith(at))
          continue;
        line = line.slice(at.length);
        while (true) {
          let match = /^(?:new |async )?\S+ \((.*)\)$/.exec(line);
          if (match) {
            line = match[1];
            continue;
          }
          match = /^eval at \S+ \((.*)\)(?:, \S+:\d+:\d+)?$/.exec(line);
          if (match) {
            line = match[1];
            continue;
          }
          match = /^(\S+):(\d+):(\d+)$/.exec(line);
          if (match) {
            let contents;
            try {
              contents = streamIn.readFileSync(match[1], "utf8");
            } catch {
              break;
            }
            let lineText = contents.split(/\r\n|\r|\n|\u2028|\u2029/)[+match[2] - 1] || "";
            let column = +match[3] - 1;
            let length = lineText.slice(column, column + ident.length) === ident ? ident.length : 0;
            return {
              file: match[1],
              namespace: "file",
              line: +match[2],
              column: encodeUTF8(lineText.slice(0, column)).length,
              length: encodeUTF8(lineText.slice(column, column + length)).length,
              lineText: lineText + "\n" + lines.slice(1).join("\n"),
              suggestion: ""
            };
          }
          break;
        }
      }
    }
    return null;
  }
  function failureErrorWithLog(text22, errors3, warnings) {
    let limit = 5;
    text22 += errors3.length < 1 ? "" : ` with ${errors3.length} error${errors3.length < 2 ? "" : "s"}:` + errors3.slice(0, limit + 1).map((e, i) => {
      if (i === limit)
        return "\n...";
      if (!e.location)
        return `
error: ${e.text}`;
      let { file, line, column } = e.location;
      let pluginText = e.pluginName ? `[plugin: ${e.pluginName}] ` : "";
      return `
${file}:${line}:${column}: ERROR: ${pluginText}${e.text}`;
    }).join("");
    let error = new Error(text22);
    for (const [key, value] of [["errors", errors3], ["warnings", warnings]]) {
      Object.defineProperty(error, key, {
        configurable: true,
        enumerable: true,
        get: () => value,
        set: (value2) => Object.defineProperty(error, key, {
          configurable: true,
          enumerable: true,
          value: value2
        })
      });
    }
    return error;
  }
  function replaceDetailsInMessages(messages3, stash) {
    for (const message of messages3) {
      message.detail = stash.load(message.detail);
    }
    return messages3;
  }
  function sanitizeLocation(location2, where, terminalWidth) {
    if (location2 == null)
      return null;
    let keys = {};
    let file = getFlag(location2, keys, "file", mustBeString);
    let namespace = getFlag(location2, keys, "namespace", mustBeString);
    let line = getFlag(location2, keys, "line", mustBeInteger);
    let column = getFlag(location2, keys, "column", mustBeInteger);
    let length = getFlag(location2, keys, "length", mustBeInteger);
    let lineText = getFlag(location2, keys, "lineText", mustBeString);
    let suggestion = getFlag(location2, keys, "suggestion", mustBeString);
    checkForInvalidFlags(location2, keys, where);
    if (lineText) {
      const relevantASCII = lineText.slice(0, (column && column > 0 ? column : 0) + (length && length > 0 ? length : 0) + (terminalWidth && terminalWidth > 0 ? terminalWidth : 80));
      if (!/[\x7F-\uFFFF]/.test(relevantASCII) && !/\n/.test(lineText)) {
        lineText = relevantASCII;
      }
    }
    return {
      file: file || "",
      namespace: namespace || "",
      line: line || 0,
      column: column || 0,
      length: length || 0,
      lineText: lineText || "",
      suggestion: suggestion || ""
    };
  }
  function sanitizeMessages(messages3, property, stash, fallbackPluginName, terminalWidth) {
    let messagesClone = [];
    let index = 0;
    for (const message of messages3) {
      let keys = {};
      let id = getFlag(message, keys, "id", mustBeString);
      let pluginName = getFlag(message, keys, "pluginName", mustBeString);
      let text22 = getFlag(message, keys, "text", mustBeString);
      let location2 = getFlag(message, keys, "location", mustBeObjectOrNull);
      let notes = getFlag(message, keys, "notes", mustBeArray);
      let detail = getFlag(message, keys, "detail", canBeAnything);
      let where = `in element ${index} of "${property}"`;
      checkForInvalidFlags(message, keys, where);
      let notesClone = [];
      if (notes) {
        for (const note of notes) {
          let noteKeys = {};
          let noteText = getFlag(note, noteKeys, "text", mustBeString);
          let noteLocation = getFlag(note, noteKeys, "location", mustBeObjectOrNull);
          checkForInvalidFlags(note, noteKeys, where);
          notesClone.push({
            text: noteText || "",
            location: sanitizeLocation(noteLocation, where, terminalWidth)
          });
        }
      }
      messagesClone.push({
        id: id || "",
        pluginName: pluginName || fallbackPluginName,
        text: text22 || "",
        location: sanitizeLocation(location2, where, terminalWidth),
        notes: notesClone,
        detail: stash ? stash.store(detail) : -1
      });
      index++;
    }
    return messagesClone;
  }
  function sanitizeStringArray(values3, property) {
    const result2 = [];
    for (const value of values3) {
      if (typeof value !== "string")
        throw new Error(`${quote(property)} must be an array of strings`);
      result2.push(value);
    }
    return result2;
  }
  function convertOutputFiles({ path: path32, contents, hash }) {
    let text22 = null;
    return {
      path: path32,
      contents,
      hash,
      get text() {
        const binary2 = this.contents;
        if (text22 === null || binary2 !== contents) {
          contents = binary2;
          text22 = decodeUTF8(binary2);
        }
        return text22;
      }
    };
  }
  var fs2 = import.meta.require("fs");
  var os32 = import.meta.require("os");
  var path3 = import.meta.require("path");
  var ESBUILD_BINARY_PATH = process.env.ESBUILD_BINARY_PATH || ESBUILD_BINARY_PATH;
  var isValidBinaryPath = (x) => !!x && x !== "/usr/bin/esbuild";
  var packageDarwin_arm64 = "@esbuild/darwin-arm64";
  var packageDarwin_x64 = "@esbuild/darwin-x64";
  var knownWindowsPackages = {
    "win32 arm64 LE": "@esbuild/win32-arm64",
    "win32 ia32 LE": "@esbuild/win32-ia32",
    "win32 x64 LE": "@esbuild/win32-x64"
  };
  var knownUnixlikePackages = {
    "aix ppc64 BE": "@esbuild/aix-ppc64",
    "android arm64 LE": "@esbuild/android-arm64",
    "darwin arm64 LE": "@esbuild/darwin-arm64",
    "darwin x64 LE": "@esbuild/darwin-x64",
    "freebsd arm64 LE": "@esbuild/freebsd-arm64",
    "freebsd x64 LE": "@esbuild/freebsd-x64",
    "linux arm LE": "@esbuild/linux-arm",
    "linux arm64 LE": "@esbuild/linux-arm64",
    "linux ia32 LE": "@esbuild/linux-ia32",
    "linux mips64el LE": "@esbuild/linux-mips64el",
    "linux ppc64 LE": "@esbuild/linux-ppc64",
    "linux riscv64 LE": "@esbuild/linux-riscv64",
    "linux s390x BE": "@esbuild/linux-s390x",
    "linux x64 LE": "@esbuild/linux-x64",
    "linux loong64 LE": "@esbuild/linux-loong64",
    "netbsd x64 LE": "@esbuild/netbsd-x64",
    "openbsd x64 LE": "@esbuild/openbsd-x64",
    "sunos x64 LE": "@esbuild/sunos-x64"
  };
  var knownWebAssemblyFallbackPackages = {
    "android arm LE": "@esbuild/android-arm",
    "android x64 LE": "@esbuild/android-x64"
  };
  function pkgAndSubpathForCurrentPlatform() {
    let pkg;
    let subpath;
    let isWASM = false;
    let platformKey = `${process.platform} ${os32.arch()} ${os32.endianness()}`;
    if (platformKey in knownWindowsPackages) {
      pkg = knownWindowsPackages[platformKey];
      subpath = "esbuild.exe";
    } else if (platformKey in knownUnixlikePackages) {
      pkg = knownUnixlikePackages[platformKey];
      subpath = "bin/esbuild";
    } else if (platformKey in knownWebAssemblyFallbackPackages) {
      pkg = knownWebAssemblyFallbackPackages[platformKey];
      subpath = "bin/esbuild";
      isWASM = true;
    } else {
      throw new Error(`Unsupported platform: ${platformKey}`);
    }
    return { pkg, subpath, isWASM };
  }
  function pkgForSomeOtherPlatform() {
    const libMainJS = import.meta.require.resolve("esbuild");
    const nodeModulesDirectory = path3.dirname(path3.dirname(path3.dirname(libMainJS)));
    if (path3.basename(nodeModulesDirectory) === "node_modules") {
      for (const unixKey in knownUnixlikePackages) {
        try {
          const pkg = knownUnixlikePackages[unixKey];
          if (fs2.existsSync(path3.join(nodeModulesDirectory, pkg)))
            return pkg;
        } catch {
        }
      }
      for (const windowsKey in knownWindowsPackages) {
        try {
          const pkg = knownWindowsPackages[windowsKey];
          if (fs2.existsSync(path3.join(nodeModulesDirectory, pkg)))
            return pkg;
        } catch {
        }
      }
    }
    return null;
  }
  function downloadedBinPath(pkg, subpath) {
    const esbuildLibDir = path3.dirname(import.meta.require.resolve("esbuild"));
    return path3.join(esbuildLibDir, `downloaded-${pkg.replace("/", "-")}-${path3.basename(subpath)}`);
  }
  function generateBinPath() {
    if (isValidBinaryPath(ESBUILD_BINARY_PATH)) {
      if (!fs2.existsSync(ESBUILD_BINARY_PATH)) {
        console.warn(`[esbuild] Ignoring bad configuration: ESBUILD_BINARY_PATH=${ESBUILD_BINARY_PATH}`);
      } else {
        return { binPath: ESBUILD_BINARY_PATH, isWASM: false };
      }
    }
    const { pkg, subpath, isWASM } = pkgAndSubpathForCurrentPlatform();
    let binPath;
    try {
      binPath = import.meta.require.resolve(`${pkg}/${subpath}`);
    } catch (e) {
      binPath = downloadedBinPath(pkg, subpath);
      if (!fs2.existsSync(binPath)) {
        try {
          import.meta.require.resolve(pkg);
        } catch {
          const otherPkg = pkgForSomeOtherPlatform();
          if (otherPkg) {
            let suggestions = `
Specifically the "${otherPkg}" package is present but this platform
needs the "${pkg}" package instead. People often get into this
situation by installing esbuild on Windows or macOS and copying "node_modules"
into a Docker image that runs Linux, or by copying "node_modules" between
Windows and WSL environments.

If you are installing with npm, you can try not copying the "node_modules"
directory when you copy the files over, and running "npm ci" or "npm install"
on the destination platform after the copy. Or you could consider using yarn
instead of npm which has built-in support for installing a package on multiple
platforms simultaneously.

If you are installing with yarn, you can try listing both this platform and the
other platform in your ".yarnrc.yml" file using the "supportedArchitectures"
feature: https://yarnpkg.com/configuration/yarnrc/#supportedArchitectures
Keep in mind that this means multiple copies of esbuild will be present.
`;
            if (pkg === packageDarwin_x64 && otherPkg === packageDarwin_arm64 || pkg === packageDarwin_arm64 && otherPkg === packageDarwin_x64) {
              suggestions = `
Specifically the "${otherPkg}" package is present but this platform
needs the "${pkg}" package instead. People often get into this
situation by installing esbuild with npm running inside of Rosetta 2 and then
trying to use it with node running outside of Rosetta 2, or vice versa (Rosetta
2 is Apple's on-the-fly x86_64-to-arm64 translation service).

If you are installing with npm, you can try ensuring that both npm and node are
not running under Rosetta 2 and then reinstalling esbuild. This likely involves
changing how you installed npm and/or node. For example, installing node with
the universal installer here should work: https://nodejs.org/en/download/. Or
you could consider using yarn instead of npm which has built-in support for
installing a package on multiple platforms simultaneously.

If you are installing with yarn, you can try listing both "arm64" and "x64"
in your ".yarnrc.yml" file using the "supportedArchitectures" feature:
https://yarnpkg.com/configuration/yarnrc/#supportedArchitectures
Keep in mind that this means multiple copies of esbuild will be present.
`;
            }
            throw new Error(`
You installed esbuild for another platform than the one you're currently using.
This won't work because esbuild is written with native code and needs to
install a platform-specific binary executable.
${suggestions}
Another alternative is to use the "esbuild-wasm" package instead, which works
the same way on all platforms. But it comes with a heavy performance cost and
can sometimes be 10x slower than the "esbuild" package, so you may also not
want to do that.
`);
          }
          throw new Error(`The package "${pkg}" could not be found, and is needed by esbuild.

If you are installing esbuild with npm, make sure that you don't specify the
"--no-optional" or "--omit=optional" flags. The "optionalDependencies" feature
of "package.json" is used by esbuild to install the correct binary executable
for your current platform.`);
        }
        throw e;
      }
    }
    if (/\.zip\//.test(binPath)) {
      let pnpapi;
      try {
        pnpapi = (() => {
          throw new Error(`Cannot require module "pnpapi"`);
        })();
      } catch (e) {
      }
      if (pnpapi) {
        const root = pnpapi.getPackageInformation(pnpapi.topLevel).packageLocation;
        const binTargetPath = path3.join(root, "node_modules", ".cache", "esbuild", `pnpapi-${pkg.replace("/", "-")}-0.19.12-${path3.basename(subpath)}`);
        if (!fs2.existsSync(binTargetPath)) {
          fs2.mkdirSync(path3.dirname(binTargetPath), { recursive: true });
          fs2.copyFileSync(binPath, binTargetPath);
          fs2.chmodSync(binTargetPath, 493);
        }
        return { binPath: binTargetPath, isWASM };
      }
    }
    return { binPath, isWASM };
  }
  var child_process = import.meta.require("child_process");
  var crypto = import.meta.require("crypto");
  var path22 = import.meta.require("path");
  var fs22 = import.meta.require("fs");
  var os222 = import.meta.require("os");
  var tty43 = import.meta.require("tty");
  var worker_threads;
  if (process.env.ESBUILD_WORKER_THREADS !== "0") {
    try {
      worker_threads = import.meta.require("worker_threads");
    } catch {
    }
    let [major, minor] = process.versions.node.split(".");
    if (+major < 12 || +major === 12 && +minor < 17 || +major === 13 && +minor < 13) {
      worker_threads = undefined;
    }
  }
  var _a;
  var isInternalWorkerThread = ((_a = worker_threads == null ? undefined : worker_threads.workerData) == null ? undefined : _a.esbuildVersion) === "0.19.12";
  var esbuildCommandAndArgs = () => {
    if ((!ESBUILD_BINARY_PATH || false) && (path22.basename(__filename2) !== "main.js" || path22.basename(__dirname2) !== "lib")) {
      throw new Error(`The esbuild JavaScript API cannot be bundled. Please mark the "esbuild" package as external so it's not included in the bundle.

More information: The file containing the code for esbuild's JavaScript API (${__filename2}) does not appear to be inside the esbuild package on the file system, which usually means that the esbuild package was bundled into another file. This is problematic because the API needs to run a binary executable inside the esbuild package which is located using a relative path from the API code to the executable. If the esbuild package is bundled, the relative path will be incorrect and the executable won't be found.`);
    }
    if (false) {
    } else {
      const { binPath, isWASM } = generateBinPath();
      if (isWASM) {
        return ["node", [binPath]];
      } else {
        return [binPath, []];
      }
    }
  };
  var isTTY = () => tty43.isatty(2);
  var fsSync = {
    readFile(tempFile, callback) {
      try {
        let contents = fs22.readFileSync(tempFile, "utf8");
        try {
          fs22.unlinkSync(tempFile);
        } catch {
        }
        callback(null, contents);
      } catch (err22) {
        callback(err22, null);
      }
    },
    writeFile(contents, callback) {
      try {
        let tempFile = randomFileName();
        fs22.writeFileSync(tempFile, contents);
        callback(tempFile);
      } catch {
        callback(null);
      }
    }
  };
  var fsAsync = {
    readFile(tempFile, callback) {
      try {
        fs22.readFile(tempFile, "utf8", (err22, contents) => {
          try {
            fs22.unlink(tempFile, () => callback(err22, contents));
          } catch {
            callback(err22, contents);
          }
        });
      } catch (err22) {
        callback(err22, null);
      }
    },
    writeFile(contents, callback) {
      try {
        let tempFile = randomFileName();
        fs22.writeFile(tempFile, contents, (err22) => err22 !== null ? callback(null) : callback(tempFile));
      } catch {
        callback(null);
      }
    }
  };
  var version2 = "0.19.12";
  var build2 = (options3) => ensureServiceIsRunning().build(options3);
  var context = (buildOptions) => ensureServiceIsRunning().context(buildOptions);
  var transform = (input, options3) => ensureServiceIsRunning().transform(input, options3);
  var formatMessages = (messages3, options3) => ensureServiceIsRunning().formatMessages(messages3, options3);
  var analyzeMetafile = (messages3, options3) => ensureServiceIsRunning().analyzeMetafile(messages3, options3);
  var buildSync = (options3) => {
    if (worker_threads && !isInternalWorkerThread) {
      if (!workerThreadService)
        workerThreadService = startWorkerThreadService(worker_threads);
      return workerThreadService.buildSync(options3);
    }
    let result2;
    runServiceSync((service) => service.buildOrContext({
      callName: "buildSync",
      refs: null,
      options: options3,
      isTTY: isTTY(),
      defaultWD,
      callback: (err22, res) => {
        if (err22)
          throw err22;
        result2 = res;
      }
    }));
    return result2;
  };
  var transformSync = (input, options3) => {
    if (worker_threads && !isInternalWorkerThread) {
      if (!workerThreadService)
        workerThreadService = startWorkerThreadService(worker_threads);
      return workerThreadService.transformSync(input, options3);
    }
    let result2;
    runServiceSync((service) => service.transform({
      callName: "transformSync",
      refs: null,
      input,
      options: options3 || {},
      isTTY: isTTY(),
      fs: fsSync,
      callback: (err22, res) => {
        if (err22)
          throw err22;
        result2 = res;
      }
    }));
    return result2;
  };
  var formatMessagesSync = (messages3, options3) => {
    if (worker_threads && !isInternalWorkerThread) {
      if (!workerThreadService)
        workerThreadService = startWorkerThreadService(worker_threads);
      return workerThreadService.formatMessagesSync(messages3, options3);
    }
    let result2;
    runServiceSync((service) => service.formatMessages({
      callName: "formatMessagesSync",
      refs: null,
      messages: messages3,
      options: options3,
      callback: (err22, res) => {
        if (err22)
          throw err22;
        result2 = res;
      }
    }));
    return result2;
  };
  var analyzeMetafileSync = (metafile, options3) => {
    if (worker_threads && !isInternalWorkerThread) {
      if (!workerThreadService)
        workerThreadService = startWorkerThreadService(worker_threads);
      return workerThreadService.analyzeMetafileSync(metafile, options3);
    }
    let result2;
    runServiceSync((service) => service.analyzeMetafile({
      callName: "analyzeMetafileSync",
      refs: null,
      metafile: typeof metafile === "string" ? metafile : JSON.stringify(metafile),
      options: options3,
      callback: (err22, res) => {
        if (err22)
          throw err22;
        result2 = res;
      }
    }));
    return result2;
  };
  var stop = () => {
    if (stopService)
      stopService();
    if (workerThreadService)
      workerThreadService.stop();
  };
  var initializeWasCalled = false;
  var initialize = (options3) => {
    options3 = validateInitializeOptions(options3 || {});
    if (options3.wasmURL)
      throw new Error(`The "wasmURL" option only works in the browser`);
    if (options3.wasmModule)
      throw new Error(`The "wasmModule" option only works in the browser`);
    if (options3.worker)
      throw new Error(`The "worker" option only works in the browser`);
    if (initializeWasCalled)
      throw new Error('Cannot call "initialize" more than once');
    ensureServiceIsRunning();
    initializeWasCalled = true;
    return Promise.resolve();
  };
  var defaultWD = process.cwd();
  var longLivedService;
  var stopService;
  var ensureServiceIsRunning = () => {
    if (longLivedService)
      return longLivedService;
    let [command2, args] = esbuildCommandAndArgs();
    let child = child_process.spawn(command2, args.concat("--service=0.19.12", "--ping"), {
      windowsHide: true,
      stdio: ["pipe", "pipe", "inherit"],
      cwd: defaultWD
    });
    let { readFromStdout, afterClose, service } = createChannel({
      writeToStdin(bytes) {
        child.stdin.write(bytes, (err22) => {
          if (err22)
            afterClose(err22);
        });
      },
      readFileSync: fs22.readFileSync,
      isSync: false,
      hasFS: true,
      esbuild: node_exports
    });
    child.stdin.on("error", afterClose);
    child.on("error", afterClose);
    const stdin22 = child.stdin;
    const stdout22 = child.stdout;
    stdout22.on("data", readFromStdout);
    stdout22.on("end", afterClose);
    stopService = () => {
      stdin22.destroy();
      stdout22.destroy();
      child.kill();
      initializeWasCalled = false;
      longLivedService = undefined;
      stopService = undefined;
    };
    let refCount = 0;
    child.unref();
    if (stdin22.unref) {
      stdin22.unref();
    }
    if (stdout22.unref) {
      stdout22.unref();
    }
    const refs = {
      ref() {
        if (++refCount === 1)
          child.ref();
      },
      unref() {
        if (--refCount === 0)
          child.unref();
      }
    };
    longLivedService = {
      build: (options3) => new Promise((resolve23, reject) => {
        service.buildOrContext({
          callName: "build",
          refs,
          options: options3,
          isTTY: isTTY(),
          defaultWD,
          callback: (err22, res) => err22 ? reject(err22) : resolve23(res)
        });
      }),
      context: (options3) => new Promise((resolve23, reject) => service.buildOrContext({
        callName: "context",
        refs,
        options: options3,
        isTTY: isTTY(),
        defaultWD,
        callback: (err22, res) => err22 ? reject(err22) : resolve23(res)
      })),
      transform: (input, options3) => new Promise((resolve23, reject) => service.transform({
        callName: "transform",
        refs,
        input,
        options: options3 || {},
        isTTY: isTTY(),
        fs: fsAsync,
        callback: (err22, res) => err22 ? reject(err22) : resolve23(res)
      })),
      formatMessages: (messages3, options3) => new Promise((resolve23, reject) => service.formatMessages({
        callName: "formatMessages",
        refs,
        messages: messages3,
        options: options3,
        callback: (err22, res) => err22 ? reject(err22) : resolve23(res)
      })),
      analyzeMetafile: (metafile, options3) => new Promise((resolve23, reject) => service.analyzeMetafile({
        callName: "analyzeMetafile",
        refs,
        metafile: typeof metafile === "string" ? metafile : JSON.stringify(metafile),
        options: options3,
        callback: (err22, res) => err22 ? reject(err22) : resolve23(res)
      }))
    };
    return longLivedService;
  };
  var runServiceSync = (callback) => {
    let [command2, args] = esbuildCommandAndArgs();
    let stdin22 = new Uint8Array;
    let { readFromStdout, afterClose, service } = createChannel({
      writeToStdin(bytes) {
        if (stdin22.length !== 0)
          throw new Error("Must run at most one command");
        stdin22 = bytes;
      },
      isSync: true,
      hasFS: true,
      esbuild: node_exports
    });
    callback(service);
    let stdout22 = child_process.execFileSync(command2, args.concat("--service=0.19.12"), {
      cwd: defaultWD,
      windowsHide: true,
      input: stdin22,
      maxBuffer: +process.env.ESBUILD_MAX_BUFFER || 16777216
    });
    readFromStdout(stdout22);
    afterClose(null);
  };
  var randomFileName = () => {
    return path22.join(os222.tmpdir(), `esbuild-${crypto.randomBytes(32).toString("hex")}`);
  };
  var workerThreadService = null;
  var startWorkerThreadService = (worker_threads2) => {
    let { port1: mainPort, port2: workerPort } = new worker_threads2.MessageChannel;
    let worker = new worker_threads2.Worker(__filename2, {
      workerData: { workerPort, defaultWD, esbuildVersion: "0.19.12" },
      transferList: [workerPort],
      execArgv: []
    });
    let nextID = 0;
    let fakeBuildError = (text22) => {
      let error = new Error(`Build failed with 1 error:
error: ${text22}`);
      let errors3 = [{ id: "", pluginName: "", text: text22, location: null, notes: [], detail: undefined }];
      error.errors = errors3;
      error.warnings = [];
      return error;
    };
    let validateBuildSyncOptions = (options3) => {
      if (!options3)
        return;
      let plugins = options3.plugins;
      if (plugins && plugins.length > 0)
        throw fakeBuildError(`Cannot use plugins in synchronous API calls`);
    };
    let applyProperties = (object, properties) => {
      for (let key in properties) {
        object[key] = properties[key];
      }
    };
    let runCallSync = (command2, args) => {
      let id = nextID++;
      let sharedBuffer = new SharedArrayBuffer(8);
      let sharedBufferView = new Int32Array(sharedBuffer);
      let msg = { sharedBuffer, id, command: command2, args };
      worker.postMessage(msg);
      let status = Atomics.wait(sharedBufferView, 0, 0);
      if (status !== "ok" && status !== "not-equal")
        throw new Error("Internal error: Atomics.wait() failed: " + status);
      let { message: { id: id2, resolve: resolve23, reject, properties } } = worker_threads2.receiveMessageOnPort(mainPort);
      if (id !== id2)
        throw new Error(`Internal error: Expected id ${id} but got id ${id2}`);
      if (reject) {
        applyProperties(reject, properties);
        throw reject;
      }
      return resolve23;
    };
    worker.unref();
    return {
      buildSync(options3) {
        validateBuildSyncOptions(options3);
        return runCallSync("build", [options3]);
      },
      transformSync(input, options3) {
        return runCallSync("transform", [input, options3]);
      },
      formatMessagesSync(messages3, options3) {
        return runCallSync("formatMessages", [messages3, options3]);
      },
      analyzeMetafileSync(metafile, options3) {
        return runCallSync("analyzeMetafile", [metafile, options3]);
      },
      stop() {
        worker.terminate();
        workerThreadService = null;
      }
    };
  };
  var startSyncServiceWorker = () => {
    let workerPort = worker_threads.workerData.workerPort;
    let parentPort = worker_threads.parentPort;
    let extractProperties = (object) => {
      let properties = {};
      if (object && typeof object === "object") {
        for (let key in object) {
          properties[key] = object[key];
        }
      }
      return properties;
    };
    try {
      let service = ensureServiceIsRunning();
      defaultWD = worker_threads.workerData.defaultWD;
      parentPort.on("message", (msg) => {
        (async () => {
          let { sharedBuffer, id, command: command2, args } = msg;
          let sharedBufferView = new Int32Array(sharedBuffer);
          try {
            switch (command2) {
              case "build":
                workerPort.postMessage({ id, resolve: await service.build(args[0]) });
                break;
              case "transform":
                workerPort.postMessage({ id, resolve: await service.transform(args[0], args[1]) });
                break;
              case "formatMessages":
                workerPort.postMessage({ id, resolve: await service.formatMessages(args[0], args[1]) });
                break;
              case "analyzeMetafile":
                workerPort.postMessage({ id, resolve: await service.analyzeMetafile(args[0], args[1]) });
                break;
              default:
                throw new Error(`Invalid command: ${command2}`);
            }
          } catch (reject) {
            workerPort.postMessage({ id, reject, properties: extractProperties(reject) });
          }
          Atomics.add(sharedBufferView, 0, 1);
          Atomics.notify(sharedBufferView, 0, Infinity);
        })();
      });
    } catch (reject) {
      parentPort.on("message", (msg) => {
        let { sharedBuffer, id } = msg;
        let sharedBufferView = new Int32Array(sharedBuffer);
        workerPort.postMessage({ id, reject, properties: extractProperties(reject) });
        Atomics.add(sharedBufferView, 0, 1);
        Atomics.notify(sharedBufferView, 0, Infinity);
      });
    }
  };
  if (isInternalWorkerThread) {
    startSyncServiceWorker();
  }
  var node_default = node_exports;
});
function relative22(from, to) {
  const fromParts = from.split(ANY_SLASH_REGEX).filter(Boolean);
  const toParts = to.split(ANY_SLASH_REGEX).filter(Boolean);
  if (fromParts[0] === ".")
    fromParts.shift();
  if (toParts[0] === ".")
    toParts.shift();
  while (fromParts[0] && toParts[0] && fromParts[0] === toParts[0]) {
    fromParts.shift();
    toParts.shift();
  }
  while (toParts[0] === ".." && fromParts.length > 0) {
    toParts.shift();
    fromParts.pop();
  }
  while (fromParts.pop()) {
    toParts.unshift("..");
  }
  return toParts.join("/");
}
function escapeId(id) {
  if (!needsEscapeRegEx.test(id))
    return id;
  return id.replace(backSlashRegEx, "\\\\").replace(quoteNewlineRegEx, "\\$1");
}
function isAbsolute22(path3) {
  return ABSOLUTE_PATH_REGEX.test(path3);
}
function relativeId(id) {
  if (!isAbsolute22(id))
    return id;
  return relative22(resolve22(), id);
}
function getOrCreate(map, key, init22) {
  const existing = map.get(key);
  if (existing !== undefined) {
    return existing;
  }
  const value = init22();
  map.set(key, value);
  return value;
}
function getNewSet() {
  return new Set;
}

class PathTracker {
  constructor() {
    this.entityPaths = Object.create(null, {
      [EntitiesKey]: { value: new Set }
    });
  }
  trackEntityAtPathAndGetIfTracked(path3, entity) {
    const trackedEntities = this.getEntities(path3);
    if (trackedEntities.has(entity))
      return true;
    trackedEntities.add(entity);
    return false;
  }
  withTrackedEntityAtPath(path3, entity, onUntracked, returnIfTracked) {
    const trackedEntities = this.getEntities(path3);
    if (trackedEntities.has(entity))
      return returnIfTracked;
    trackedEntities.add(entity);
    const result2 = onUntracked();
    trackedEntities.delete(entity);
    return result2;
  }
  getEntities(path3) {
    let currentPaths = this.entityPaths;
    for (const pathSegment of path3) {
      currentPaths = currentPaths[pathSegment] = currentPaths[pathSegment] || Object.create(null, { [EntitiesKey]: { value: new Set } });
    }
    return currentPaths[EntitiesKey];
  }
}

class DiscriminatedPathTracker {
  constructor() {
    this.entityPaths = Object.create(null, {
      [EntitiesKey]: { value: new Map }
    });
  }
  trackEntityAtPathAndGetIfTracked(path3, discriminator, entity) {
    let currentPaths = this.entityPaths;
    for (const pathSegment of path3) {
      currentPaths = currentPaths[pathSegment] = currentPaths[pathSegment] || Object.create(null, { [EntitiesKey]: { value: new Map } });
    }
    const trackedEntities = getOrCreate(currentPaths[EntitiesKey], discriminator, getNewSet);
    if (trackedEntities.has(entity))
      return true;
    trackedEntities.add(entity);
    return false;
  }
}

class ExpressionEntity {
  constructor() {
    this.included = false;
  }
  deoptimizeArgumentsOnInteractionAtPath(interaction, _path, _recursionTracker) {
    deoptimizeInteraction(interaction);
  }
  deoptimizePath(_path) {
  }
  getLiteralValueAtPath(_path, _recursionTracker, _origin) {
    return UnknownValue;
  }
  getReturnExpressionWhenCalledAtPath(_path, _interaction, _recursionTracker, _origin) {
    return UNKNOWN_RETURN_EXPRESSION;
  }
  hasEffectsOnInteractionAtPath(_path, _interaction, _context) {
    return true;
  }
  include(_context, _includeChildrenRecursively, _options) {
    this.included = true;
  }
  includeCallArguments(context, parameters) {
    for (const argument of parameters) {
      argument.include(context, false);
    }
  }
  shouldBeIncluded(_context) {
    return true;
  }
}
function logIllegalImportReassignment(name, importingId) {
  return {
    code: ILLEGAL_REASSIGNMENT,
    message: `Illegal reassignment of import "${name}" in "${relativeId(importingId)}".`
  };
}
function logModuleLevelDirective(directive, id) {
  return {
    code: MODULE_LEVEL_DIRECTIVE,
    id,
    message: `Module level directives cause errors when bundled, "${directive}" in "${relativeId(id)}" was ignored.`
  };
}
function getDefaultExportFromCjs22(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
function createInclusionContext() {
  return {
    brokenFlow: false,
    hasBreak: false,
    hasContinue: false,
    includedCallArguments: new Set,
    includedLabels: new Set
  };
}
function createHasEffectsContext() {
  return {
    accessed: new PathTracker,
    assigned: new PathTracker,
    brokenFlow: false,
    called: new DiscriminatedPathTracker,
    hasBreak: false,
    hasContinue: false,
    ignore: {
      breaks: false,
      continues: false,
      labels: new Set,
      returnYield: false,
      this: false
    },
    includedLabels: new Set,
    instantiated: new DiscriminatedPathTracker,
    replacedVariableInits: new Map
  };
}
function assembleMemberDescriptions(memberDescriptions, inheritedDescriptions = null) {
  return Object.create(inheritedDescriptions, memberDescriptions);
}
function hasMemberEffectWhenCalled(members, memberName, interaction, context) {
  if (typeof memberName !== "string" || !members[memberName]) {
    return true;
  }
  return members[memberName].hasEffectsWhenCalled?.(interaction, context) || false;
}
function getMemberReturnExpressionWhenCalled(members, memberName) {
  if (typeof memberName !== "string" || !members[memberName])
    return UNKNOWN_RETURN_EXPRESSION;
  return [members[memberName].returns, false];
}
function skipThrough(node, st, c22) {
  c22(node, st);
}
function ignore(_node, _st, _c) {
}
function getAndCreateKeys(esTreeNode) {
  keys[esTreeNode.type] = Object.keys(esTreeNode).filter((key) => typeof esTreeNode[key] === "object" && key.charCodeAt(0) !== 95);
  return keys[esTreeNode.type];
}
function toBase642(value) {
  let outString = "";
  do {
    const currentDigit = value % base;
    value = value / base | 0;
    outString = chars[currentDigit] + outString;
  } while (value !== 0);
  return outString;
}
function getSafeName(baseName, usedNames, forbiddenNames) {
  let safeName = baseName;
  let count = 1;
  while (usedNames.has(safeName) || RESERVED_NAMES$1.has(safeName) || forbiddenNames?.has(safeName)) {
    safeName = `${baseName}$${toBase642(count++)}`;
  }
  usedNames.add(safeName);
  return safeName;
}
function is_reference(node, parent) {
  if (node.type === "MemberExpression") {
    return !node.computed && is_reference(node.object, node);
  }
  if (node.type === "Identifier") {
    if (!parent)
      return true;
    switch (parent.type) {
      case "MemberExpression":
        return parent.computed || node === parent.object;
      case "MethodDefinition":
        return parent.computed;
      case "PropertyDefinition":
        return parent.computed || node === parent.value;
      case "Property":
        return parent.computed || node === parent.value;
      case "ExportSpecifier":
      case "ImportSpecifier":
        return node === parent.local;
      case "LabeledStatement":
      case "BreakStatement":
      case "ContinueStatement":
        return false;
      default:
        return true;
    }
  }
  return false;
}
function getGlobalAtPath(path42) {
  let currentGlobal = knownGlobals;
  for (const pathSegment of path42) {
    if (typeof pathSegment !== "string") {
      return null;
    }
    currentGlobal = currentGlobal[pathSegment];
    if (!currentGlobal) {
      return null;
    }
  }
  return currentGlobal[ValueProperties];
}
function closestParentFunctionOrProgram(node) {
  while (node && !/^Program|Function/.test(node.type)) {
    node = node.parent;
  }
  return node;
}
function treeshakeNode(node, code, start, end) {
  code.remove(start, end);
  if (node.annotations) {
    for (const annotation of node.annotations) {
      if (annotation.start < start) {
        code.remove(annotation.start, annotation.end);
      } else {
        return;
      }
    }
  }
}
function findFirstOccurrenceOutsideComment(code, searchString, start = 0) {
  let searchPos, charCodeAfterSlash;
  searchPos = code.indexOf(searchString, start);
  while (true) {
    start = code.indexOf("/", start);
    if (start === -1 || start >= searchPos)
      return searchPos;
    charCodeAfterSlash = code.charCodeAt(++start);
    ++start;
    start = charCodeAfterSlash === 47 ? code.indexOf("\n", start) + 1 : code.indexOf("*/", start) + 2;
    if (start > searchPos) {
      searchPos = code.indexOf(searchString, start);
    }
  }
}
function findNonWhiteSpace(code, index) {
  NON_WHITESPACE.lastIndex = index;
  const result2 = NON_WHITESPACE.exec(code);
  return result2.index;
}
function findFirstLineBreakOutsideComment(code) {
  let lineBreakPos, charCodeAfterSlash, start = 0;
  lineBreakPos = code.indexOf("\n", start);
  while (true) {
    start = code.indexOf("/", start);
    if (start === -1 || start > lineBreakPos)
      return [lineBreakPos, lineBreakPos + 1];
    charCodeAfterSlash = code.charCodeAt(start + 1);
    if (charCodeAfterSlash === 47)
      return [start, lineBreakPos + 1];
    start = code.indexOf("*/", start + 3) + 2;
    if (start > lineBreakPos) {
      lineBreakPos = code.indexOf("\n", start);
    }
  }
}
function renderStatementList(statements, code, start, end, options3) {
  let currentNode, currentNodeStart, currentNodeNeedsBoundaries, nextNodeStart;
  let nextNode = statements[0];
  let nextNodeNeedsBoundaries = !nextNode.included || nextNode.needsBoundaries;
  if (nextNodeNeedsBoundaries) {
    nextNodeStart = start + findFirstLineBreakOutsideComment(code.original.slice(start, nextNode.start))[1];
  }
  for (let nextIndex = 1;nextIndex <= statements.length; nextIndex++) {
    currentNode = nextNode;
    currentNodeStart = nextNodeStart;
    currentNodeNeedsBoundaries = nextNodeNeedsBoundaries;
    nextNode = statements[nextIndex];
    nextNodeNeedsBoundaries = nextNode === undefined ? false : !nextNode.included || nextNode.needsBoundaries;
    if (currentNodeNeedsBoundaries || nextNodeNeedsBoundaries) {
      nextNodeStart = currentNode.end + findFirstLineBreakOutsideComment(code.original.slice(currentNode.end, nextNode === undefined ? end : nextNode.start))[1];
      if (currentNode.included) {
        currentNodeNeedsBoundaries ? currentNode.render(code, options3, {
          end: nextNodeStart,
          start: currentNodeStart
        }) : currentNode.render(code, options3);
      } else {
        treeshakeNode(currentNode, code, currentNodeStart, nextNodeStart);
      }
    } else {
      currentNode.render(code, options3);
    }
  }
}
function getSystemExportStatement(exportedVariables, { exportNamesByVariable, snippets: { _: _22, getObject, getPropertyAccess } }, modifier = "") {
  if (exportedVariables.length === 1 && exportNamesByVariable.get(exportedVariables[0]).length === 1) {
    const variable = exportedVariables[0];
    return `exports('${exportNamesByVariable.get(variable)}',${_22}${variable.getName(getPropertyAccess)}${modifier})`;
  } else {
    const fields22 = [];
    for (const variable of exportedVariables) {
      for (const exportName of exportNamesByVariable.get(variable)) {
        fields22.push([exportName, variable.getName(getPropertyAccess) + modifier]);
      }
    }
    return `exports(${getObject(fields22, { lineBreakIndent: null })})`;
  }
}
function getDeclarationStart(code, start) {
  return findNonWhiteSpace(code, findFirstOccurrenceOutsideComment(code, "default", start) + 7);
}
function getFunctionIdInsertPosition(code, start) {
  const declarationEnd = findFirstOccurrenceOutsideComment(code, "function", start) + "function".length;
  code = code.slice(declarationEnd, findFirstOccurrenceOutsideComment(code, "(", declarationEnd));
  const generatorStarPos = findFirstOccurrenceOutsideComment(code, "*");
  if (generatorStarPos === -1) {
    return declarationEnd;
  }
  return declarationEnd + generatorStarPos + 1;
}
function getToStringTagValue(getObject) {
  return getObject([["value", "'Module'"]], {
    lineBreakIndent: null
  });
}
function isInAstralSet(code, set) {
  var pos = 65536;
  for (var i = 0;i < set.length; i += 2) {
    pos += set[i];
    if (pos > code) {
      return false;
    }
    pos += set[i + 1];
    if (pos >= code) {
      return true;
    }
  }
  return false;
}
function isIdentifierStart(code, astral) {
  if (code < 65) {
    return code === 36;
  }
  if (code < 91) {
    return true;
  }
  if (code < 97) {
    return code === 95;
  }
  if (code < 123) {
    return true;
  }
  if (code <= 65535) {
    return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
  }
  if (astral === false) {
    return false;
  }
  return isInAstralSet(code, astralIdentifierStartCodes);
}
function isIdentifierChar(code, astral) {
  if (code < 48) {
    return code === 36;
  }
  if (code < 58) {
    return true;
  }
  if (code < 65) {
    return false;
  }
  if (code < 91) {
    return true;
  }
  if (code < 97) {
    return code === 95;
  }
  if (code < 123) {
    return true;
  }
  if (code <= 65535) {
    return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
  }
  if (astral === false) {
    return false;
  }
  return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
}
function binop(name, prec) {
  return new TokenType(name, { beforeExpr: true, binop: prec });
}
function kw(name, options3) {
  if (options3 === undefined)
    options3 = {};
  options3.keyword = name;
  return keywords[name] = new TokenType(name, options3);
}
function isNewLine(code) {
  return code === 10 || code === 13 || code === 8232 || code === 8233;
}
function nextLineBreak(code, from, end) {
  if (end === undefined)
    end = code.length;
  for (var i = from;i < end; i++) {
    var next = code.charCodeAt(i);
    if (isNewLine(next)) {
      return i < end - 1 && next === 13 && code.charCodeAt(i + 1) === 10 ? i + 2 : i + 1;
    }
  }
  return -1;
}
function wordsRegexp(words) {
  return new RegExp("^(?:" + words.replace(/ /g, "|") + ")$");
}
function codePointToString(code) {
  if (code <= 65535) {
    return String.fromCharCode(code);
  }
  code -= 65536;
  return String.fromCharCode((code >> 10) + 55296, (code & 1023) + 56320);
}
function getLineInfo(input, offset2) {
  for (var line = 1, cur = 0;; ) {
    var nextBreak = nextLineBreak(input, cur, offset2);
    if (nextBreak < 0) {
      return new Position(line, offset2 - cur);
    }
    ++line;
    cur = nextBreak;
  }
}
function getOptions(opts) {
  var options3 = {};
  for (var opt in defaultOptions) {
    options3[opt] = opts && hasOwn(opts, opt) ? opts[opt] : defaultOptions[opt];
  }
  if (options3.ecmaVersion === "latest") {
    options3.ecmaVersion = 1e8;
  } else if (options3.ecmaVersion == null) {
    if (!warnedAboutEcmaVersion && typeof console === "object" && console.warn) {
      warnedAboutEcmaVersion = true;
      console.warn("Since Acorn 8.0.0, options.ecmaVersion is required.\nDefaulting to 2020, but this will stop working in the future.");
    }
    options3.ecmaVersion = 11;
  } else if (options3.ecmaVersion >= 2015) {
    options3.ecmaVersion -= 2009;
  }
  if (options3.allowReserved == null) {
    options3.allowReserved = options3.ecmaVersion < 5;
  }
  if (!opts || opts.allowHashBang == null) {
    options3.allowHashBang = options3.ecmaVersion >= 14;
  }
  if (isArray22(options3.onToken)) {
    var tokens = options3.onToken;
    options3.onToken = function(token) {
      return tokens.push(token);
    };
  }
  if (isArray22(options3.onComment)) {
    options3.onComment = pushComment(options3, options3.onComment);
  }
  return options3;
}
function pushComment(options3, array) {
  return function(block, text22, start, end, startLoc, endLoc) {
    var comment = {
      type: block ? "Block" : "Line",
      value: text22,
      start,
      end
    };
    if (options3.locations) {
      comment.loc = new SourceLocation(this, startLoc, endLoc);
    }
    if (options3.ranges) {
      comment.range = [start, end];
    }
    array.push(comment);
  };
}
function functionFlags(async, generator) {
  return SCOPE_FUNCTION | (async ? SCOPE_ASYNC : 0) | (generator ? SCOPE_GENERATOR : 0);
}
function isPrivateNameConflicted(privateNameMap, element) {
  var name = element.key.name;
  var curr = privateNameMap[name];
  var next = "true";
  if (element.type === "MethodDefinition" && (element.kind === "get" || element.kind === "set")) {
    next = (element.static ? "s" : "i") + element.kind;
  }
  if (curr === "iget" && next === "iset" || curr === "iset" && next === "iget" || curr === "sget" && next === "sset" || curr === "sset" && next === "sget") {
    privateNameMap[name] = "true";
    return false;
  } else if (!curr) {
    privateNameMap[name] = next;
    return false;
  } else {
    return true;
  }
}
function checkKeyName(node, name) {
  var computed = node.computed;
  var key = node.key;
  return !computed && (key.type === "Identifier" && key.name === name || key.type === "Literal" && key.value === name);
}
function isPrivateFieldAccess(node) {
  return node.type === "MemberExpression" && node.property.type === "PrivateIdentifier" || node.type === "ChainExpression" && isPrivateFieldAccess(node.expression);
}
function finishNodeAt(node, type, pos, loc) {
  node.type = type;
  node.end = pos;
  if (this.options.locations) {
    node.loc.end = loc;
  }
  if (this.options.ranges) {
    node.range[1] = pos;
  }
  return node;
}
function buildUnicodeData(ecmaVersion) {
  var d = data[ecmaVersion] = {
    binary: wordsRegexp(unicodeBinaryProperties[ecmaVersion] + " " + unicodeGeneralCategoryValues),
    binaryOfStrings: wordsRegexp(unicodeBinaryPropertiesOfStrings[ecmaVersion]),
    nonBinary: {
      General_Category: wordsRegexp(unicodeGeneralCategoryValues),
      Script: wordsRegexp(unicodeScriptValues[ecmaVersion])
    }
  };
  d.nonBinary.Script_Extensions = d.nonBinary.Script;
  d.nonBinary.gc = d.nonBinary.General_Category;
  d.nonBinary.sc = d.nonBinary.Script;
  d.nonBinary.scx = d.nonBinary.Script_Extensions;
}
function isSyntaxCharacter(ch) {
  return ch === 36 || ch >= 40 && ch <= 43 || ch === 46 || ch === 63 || ch >= 91 && ch <= 94 || ch >= 123 && ch <= 125;
}
function isRegExpIdentifierStart(ch) {
  return isIdentifierStart(ch, true) || ch === 36 || ch === 95;
}
function isRegExpIdentifierPart(ch) {
  return isIdentifierChar(ch, true) || ch === 36 || ch === 95 || ch === 8204 || ch === 8205;
}
function isControlLetter(ch) {
  return ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122;
}
function isValidUnicode(ch) {
  return ch >= 0 && ch <= 1114111;
}
function isCharacterClassEscape(ch) {
  return ch === 100 || ch === 68 || ch === 115 || ch === 83 || ch === 119 || ch === 87;
}
function isUnicodePropertyNameCharacter(ch) {
  return isControlLetter(ch) || ch === 95;
}
function isUnicodePropertyValueCharacter(ch) {
  return isUnicodePropertyNameCharacter(ch) || isDecimalDigit(ch);
}
function isClassSetReservedDoublePunctuatorCharacter(ch) {
  return ch === 33 || ch >= 35 && ch <= 38 || ch >= 42 && ch <= 44 || ch === 46 || ch >= 58 && ch <= 64 || ch === 94 || ch === 96 || ch === 126;
}
function isClassSetSyntaxCharacter(ch) {
  return ch === 40 || ch === 41 || ch === 45 || ch === 47 || ch >= 91 && ch <= 93 || ch >= 123 && ch <= 125;
}
function isClassSetReservedPunctuator(ch) {
  return ch === 33 || ch === 35 || ch === 37 || ch === 38 || ch === 44 || ch === 45 || ch >= 58 && ch <= 62 || ch === 64 || ch === 96 || ch === 126;
}
function isDecimalDigit(ch) {
  return ch >= 48 && ch <= 57;
}
function isHexDigit(ch) {
  return ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102;
}
function hexToInt(ch) {
  if (ch >= 65 && ch <= 70) {
    return 10 + (ch - 65);
  }
  if (ch >= 97 && ch <= 102) {
    return 10 + (ch - 97);
  }
  return ch - 48;
}
function isOctalDigit(ch) {
  return ch >= 48 && ch <= 55;
}
function stringToNumber(str, isLegacyOctalNumericLiteral) {
  if (isLegacyOctalNumericLiteral) {
    return parseInt(str, 8);
  }
  return parseFloat(str.replace(/_/g, ""));
}
function stringToBigInt(str) {
  if (typeof BigInt !== "function") {
    return null;
  }
  return BigInt(str.replace(/_/g, ""));
}
var comma;
var semicolon;
var chars$1 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
var intToChar;
var charToInt;
var ANY_SLASH_REGEX;
var needsEscapeRegEx;
var quoteNewlineRegEx;
var backSlashRegEx;
var ABSOLUTE_PATH_REGEX;
var UnknownKey;
var UnknownNonAccessorKey;
var UnknownInteger;
var SymbolToStringTag;
var EMPTY_PATH;
var UNKNOWN_PATH;
var UNKNOWN_NON_ACCESSOR_PATH;
var UNKNOWN_INTEGER_PATH;
var EntitiesKey;
var SHARED_RECURSION_TRACKER;
var UnknownValue;
var UnknownTruthyValue;
var UNKNOWN_EXPRESSION;
var UNKNOWN_RETURN_EXPRESSION;
var deoptimizeInteraction = (interaction) => {
  for (const argument of interaction.args) {
    argument?.deoptimizePath(UNKNOWN_PATH);
  }
};
var INTERACTION_ACCESSED = 0;
var INTERACTION_ASSIGNED = 1;
var INTERACTION_CALLED = 2;
var NODE_INTERACTION_UNKNOWN_ACCESS;
var NODE_INTERACTION_UNKNOWN_ASSIGNMENT;
var NODE_INTERACTION_UNKNOWN_CALL;
var Variable;
var BLANK;
var EMPTY_OBJECT;
var EMPTY_ARRAY;
var EMPTY_SET;
var RESERVED_NAMES;
var RESERVED_NAMES$1;
var LOGLEVEL_SILENT = "silent";
var LOGLEVEL_WARN = "warn";
var LOGLEVEL_INFO = "info";
var LOGLEVEL_DEBUG = "debug";
var logLevelPriority;
var ILLEGAL_REASSIGNMENT = "ILLEGAL_REASSIGNMENT";
var MODULE_LEVEL_DIRECTIVE = "MODULE_LEVEL_DIRECTIVE";
var utils$3;
var path$1;
var WIN_SLASH = "\\\\/";
var WIN_NO_SLASH;
var DOT_LITERAL = "\\.";
var PLUS_LITERAL = "\\+";
var QMARK_LITERAL = "\\?";
var SLASH_LITERAL = "\\/";
var ONE_CHAR = "(?=.)";
var QMARK = "[^/]";
var END_ANCHOR;
var START_ANCHOR;
var DOTS_SLASH;
var NO_DOT;
var NO_DOTS;
var NO_DOT_SLASH;
var NO_DOTS_SLASH;
var QMARK_NO_DOT;
var STAR;
var POSIX_CHARS;
var WINDOWS_CHARS;
var POSIX_REGEX_SOURCE$1;
var constants$2;
var utils$2;
var CHAR_ASTERISK;
var CHAR_AT;
var CHAR_BACKWARD_SLASH;
var CHAR_COMMA;
var CHAR_DOT;
var CHAR_EXCLAMATION_MARK;
var CHAR_FORWARD_SLASH;
var CHAR_LEFT_CURLY_BRACE;
var CHAR_LEFT_PARENTHESES;
var CHAR_LEFT_SQUARE_BRACKET;
var CHAR_PLUS;
var CHAR_QUESTION_MARK;
var CHAR_RIGHT_CURLY_BRACE;
var CHAR_RIGHT_PARENTHESES;
var CHAR_RIGHT_SQUARE_BRACKET;
var isPathSeparator = (code) => {
  return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
};
var depth = (token) => {
  if (token.isPrefix !== true) {
    token.depth = token.isGlobstar ? Infinity : 1;
  }
};
var scan$1 = (input, options3) => {
  const opts = options3 || {};
  const length = input.length - 1;
  const scanToEnd = opts.parts === true || opts.scanToEnd === true;
  const slashes = [];
  const tokens = [];
  const parts = [];
  let str = input;
  let index = -1;
  let start = 0;
  let lastIndex = 0;
  let isBrace = false;
  let isBracket = false;
  let isGlob = false;
  let isExtglob = false;
  let isGlobstar = false;
  let braceEscaped = false;
  let backslashes = false;
  let negated = false;
  let negatedExtglob = false;
  let finished = false;
  let braces = 0;
  let prev;
  let code;
  let token = { value: "", depth: 0, isGlob: false };
  const eos = () => index >= length;
  const peek = () => str.charCodeAt(index + 1);
  const advance = () => {
    prev = code;
    return str.charCodeAt(++index);
  };
  while (index < length) {
    code = advance();
    let next;
    if (code === CHAR_BACKWARD_SLASH) {
      backslashes = token.backslashes = true;
      code = advance();
      if (code === CHAR_LEFT_CURLY_BRACE) {
        braceEscaped = true;
      }
      continue;
    }
    if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE) {
      braces++;
      while (eos() !== true && (code = advance())) {
        if (code === CHAR_BACKWARD_SLASH) {
          backslashes = token.backslashes = true;
          advance();
          continue;
        }
        if (code === CHAR_LEFT_CURLY_BRACE) {
          braces++;
          continue;
        }
        if (braceEscaped !== true && code === CHAR_DOT && (code = advance()) === CHAR_DOT) {
          isBrace = token.isBrace = true;
          isGlob = token.isGlob = true;
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (braceEscaped !== true && code === CHAR_COMMA) {
          isBrace = token.isBrace = true;
          isGlob = token.isGlob = true;
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (code === CHAR_RIGHT_CURLY_BRACE) {
          braces--;
          if (braces === 0) {
            braceEscaped = false;
            isBrace = token.isBrace = true;
            finished = true;
            break;
          }
        }
      }
      if (scanToEnd === true) {
        continue;
      }
      break;
    }
    if (code === CHAR_FORWARD_SLASH) {
      slashes.push(index);
      tokens.push(token);
      token = { value: "", depth: 0, isGlob: false };
      if (finished === true)
        continue;
      if (prev === CHAR_DOT && index === start + 1) {
        start += 2;
        continue;
      }
      lastIndex = index + 1;
      continue;
    }
    if (opts.noext !== true) {
      const isExtglobChar = code === CHAR_PLUS || code === CHAR_AT || code === CHAR_ASTERISK || code === CHAR_QUESTION_MARK || code === CHAR_EXCLAMATION_MARK;
      if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES) {
        isGlob = token.isGlob = true;
        isExtglob = token.isExtglob = true;
        finished = true;
        if (code === CHAR_EXCLAMATION_MARK && index === start) {
          negatedExtglob = true;
        }
        if (scanToEnd === true) {
          while (eos() !== true && (code = advance())) {
            if (code === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              code = advance();
              continue;
            }
            if (code === CHAR_RIGHT_PARENTHESES) {
              isGlob = token.isGlob = true;
              finished = true;
              break;
            }
          }
          continue;
        }
        break;
      }
    }
    if (code === CHAR_ASTERISK) {
      if (prev === CHAR_ASTERISK)
        isGlobstar = token.isGlobstar = true;
      isGlob = token.isGlob = true;
      finished = true;
      if (scanToEnd === true) {
        continue;
      }
      break;
    }
    if (code === CHAR_QUESTION_MARK) {
      isGlob = token.isGlob = true;
      finished = true;
      if (scanToEnd === true) {
        continue;
      }
      break;
    }
    if (code === CHAR_LEFT_SQUARE_BRACKET) {
      while (eos() !== true && (next = advance())) {
        if (next === CHAR_BACKWARD_SLASH) {
          backslashes = token.backslashes = true;
          advance();
          continue;
        }
        if (next === CHAR_RIGHT_SQUARE_BRACKET) {
          isBracket = token.isBracket = true;
          isGlob = token.isGlob = true;
          finished = true;
          break;
        }
      }
      if (scanToEnd === true) {
        continue;
      }
      break;
    }
    if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK && index === start) {
      negated = token.negated = true;
      start++;
      continue;
    }
    if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES) {
      isGlob = token.isGlob = true;
      if (scanToEnd === true) {
        while (eos() !== true && (code = advance())) {
          if (code === CHAR_LEFT_PARENTHESES) {
            backslashes = token.backslashes = true;
            code = advance();
            continue;
          }
          if (code === CHAR_RIGHT_PARENTHESES) {
            finished = true;
            break;
          }
        }
        continue;
      }
      break;
    }
    if (isGlob === true) {
      finished = true;
      if (scanToEnd === true) {
        continue;
      }
      break;
    }
  }
  if (opts.noext === true) {
    isExtglob = false;
    isGlob = false;
  }
  let base = str;
  let prefix = "";
  let glob = "";
  if (start > 0) {
    prefix = str.slice(0, start);
    str = str.slice(start);
    lastIndex -= start;
  }
  if (base && isGlob === true && lastIndex > 0) {
    base = str.slice(0, lastIndex);
    glob = str.slice(lastIndex);
  } else if (isGlob === true) {
    base = "";
    glob = str;
  } else {
    base = str;
  }
  if (base && base !== "" && base !== "/" && base !== str) {
    if (isPathSeparator(base.charCodeAt(base.length - 1))) {
      base = base.slice(0, -1);
    }
  }
  if (opts.unescape === true) {
    if (glob)
      glob = utils$2.removeBackslashes(glob);
    if (base && backslashes === true) {
      base = utils$2.removeBackslashes(base);
    }
  }
  const state = {
    prefix,
    input,
    start,
    base,
    glob,
    isBrace,
    isBracket,
    isGlob,
    isExtglob,
    isGlobstar,
    negated,
    negatedExtglob
  };
  if (opts.tokens === true) {
    state.maxDepth = 0;
    if (!isPathSeparator(code)) {
      tokens.push(token);
    }
    state.tokens = tokens;
  }
  if (opts.parts === true || opts.tokens === true) {
    let prevIndex;
    for (let idx = 0;idx < slashes.length; idx++) {
      const n = prevIndex ? prevIndex + 1 : start;
      const i = slashes[idx];
      const value = input.slice(n, i);
      if (opts.tokens) {
        if (idx === 0 && start !== 0) {
          tokens[idx].isPrefix = true;
          tokens[idx].value = prefix;
        } else {
          tokens[idx].value = value;
        }
        depth(tokens[idx]);
        state.maxDepth += tokens[idx].depth;
      }
      if (idx !== 0 || value !== "") {
        parts.push(value);
      }
      prevIndex = i;
    }
    if (prevIndex && prevIndex + 1 < input.length) {
      const value = input.slice(prevIndex + 1);
      parts.push(value);
      if (opts.tokens) {
        tokens[tokens.length - 1].value = value;
        depth(tokens[tokens.length - 1]);
        state.maxDepth += tokens[tokens.length - 1].depth;
      }
    }
    state.slashes = slashes;
    state.parts = parts;
  }
  return state;
};
var scan_1;
var constants$1;
var utils$1;
var MAX_LENGTH;
var POSIX_REGEX_SOURCE;
var REGEX_NON_SPECIAL_CHARS;
var REGEX_SPECIAL_CHARS_BACKREF;
var REPLACEMENTS;
var expandRange = (args, options3) => {
  if (typeof options3.expandRange === "function") {
    return options3.expandRange(...args, options3);
  }
  args.sort();
  const value = `[${args.join("-")}]`;
  return value;
};
var syntaxError = (type, char) => {
  return `Missing ${type}: "${char}" - use "\\\\${char}" to match literal characters`;
};
var parse$2 = (input, options3) => {
  if (typeof input !== "string") {
    throw new TypeError("Expected a string");
  }
  input = REPLACEMENTS[input] || input;
  const opts = { ...options3 };
  const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
  let len = input.length;
  if (len > max) {
    throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
  }
  const bos = { type: "bos", value: "", output: opts.prepend || "" };
  const tokens = [bos];
  const capture = opts.capture ? "" : "?:";
  const win3222 = utils$1.isWindows(options3);
  const PLATFORM_CHARS = constants$1.globChars(win3222);
  const EXTGLOB_CHARS = constants$1.extglobChars(PLATFORM_CHARS);
  const {
    DOT_LITERAL: DOT_LITERAL2,
    PLUS_LITERAL: PLUS_LITERAL2,
    SLASH_LITERAL: SLASH_LITERAL2,
    ONE_CHAR: ONE_CHAR2,
    DOTS_SLASH: DOTS_SLASH2,
    NO_DOT: NO_DOT2,
    NO_DOT_SLASH: NO_DOT_SLASH2,
    NO_DOTS_SLASH: NO_DOTS_SLASH2,
    QMARK: QMARK2,
    QMARK_NO_DOT: QMARK_NO_DOT2,
    STAR: STAR2,
    START_ANCHOR: START_ANCHOR2
  } = PLATFORM_CHARS;
  const globstar = (opts2) => {
    return `(${capture}(?:(?!${START_ANCHOR2}${opts2.dot ? DOTS_SLASH2 : DOT_LITERAL2}).)*?)`;
  };
  const nodot = opts.dot ? "" : NO_DOT2;
  const qmarkNoDot = opts.dot ? QMARK2 : QMARK_NO_DOT2;
  let star = opts.bash === true ? globstar(opts) : STAR2;
  if (opts.capture) {
    star = `(${star})`;
  }
  if (typeof opts.noext === "boolean") {
    opts.noextglob = opts.noext;
  }
  const state = {
    input,
    index: -1,
    start: 0,
    dot: opts.dot === true,
    consumed: "",
    output: "",
    prefix: "",
    backtrack: false,
    negated: false,
    brackets: 0,
    braces: 0,
    parens: 0,
    quotes: 0,
    globstar: false,
    tokens
  };
  input = utils$1.removePrefix(input, state);
  len = input.length;
  const extglobs = [];
  const braces = [];
  const stack = [];
  let prev = bos;
  let value;
  const eos = () => state.index === len - 1;
  const peek = state.peek = (n = 1) => input[state.index + n];
  const advance = state.advance = () => input[++state.index] || "";
  const remaining = () => input.slice(state.index + 1);
  const consume = (value2 = "", num = 0) => {
    state.consumed += value2;
    state.index += num;
  };
  const append = (token) => {
    state.output += token.output != null ? token.output : token.value;
    consume(token.value);
  };
  const negate = () => {
    let count = 1;
    while (peek() === "!" && (peek(2) !== "(" || peek(3) === "?")) {
      advance();
      state.start++;
      count++;
    }
    if (count % 2 === 0) {
      return false;
    }
    state.negated = true;
    state.start++;
    return true;
  };
  const increment = (type) => {
    state[type]++;
    stack.push(type);
  };
  const decrement = (type) => {
    state[type]--;
    stack.pop();
  };
  const push2 = (tok) => {
    if (prev.type === "globstar") {
      const isBrace = state.braces > 0 && (tok.type === "comma" || tok.type === "brace");
      const isExtglob = tok.extglob === true || extglobs.length && (tok.type === "pipe" || tok.type === "paren");
      if (tok.type !== "slash" && tok.type !== "paren" && !isBrace && !isExtglob) {
        state.output = state.output.slice(0, -prev.output.length);
        prev.type = "star";
        prev.value = "*";
        prev.output = star;
        state.output += prev.output;
      }
    }
    if (extglobs.length && tok.type !== "paren") {
      extglobs[extglobs.length - 1].inner += tok.value;
    }
    if (tok.value || tok.output)
      append(tok);
    if (prev && prev.type === "text" && tok.type === "text") {
      prev.value += tok.value;
      prev.output = (prev.output || "") + tok.value;
      return;
    }
    tok.prev = prev;
    tokens.push(tok);
    prev = tok;
  };
  const extglobOpen = (type, value2) => {
    const token = { ...EXTGLOB_CHARS[value2], conditions: 1, inner: "" };
    token.prev = prev;
    token.parens = state.parens;
    token.output = state.output;
    const output = (opts.capture ? "(" : "") + token.open;
    increment("parens");
    push2({ type, value: value2, output: state.output ? "" : ONE_CHAR2 });
    push2({ type: "paren", extglob: true, value: advance(), output });
    extglobs.push(token);
  };
  const extglobClose = (token) => {
    let output = token.close + (opts.capture ? ")" : "");
    let rest;
    if (token.type === "negate") {
      let extglobStar = star;
      if (token.inner && token.inner.length > 1 && token.inner.includes("/")) {
        extglobStar = globstar(opts);
      }
      if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
        output = token.close = `)$))${extglobStar}`;
      }
      if (token.inner.includes("*") && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
        const expression = parse$2(rest, { ...options3, fastpaths: false }).output;
        output = token.close = `)${expression})${extglobStar})`;
      }
      if (token.prev.type === "bos") {
        state.negatedExtglob = true;
      }
    }
    push2({ type: "paren", extglob: true, value, output });
    decrement("parens");
  };
  if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
    let backslashes = false;
    let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF, (m22, esc, chars, first, rest, index) => {
      if (first === "\\") {
        backslashes = true;
        return m22;
      }
      if (first === "?") {
        if (esc) {
          return esc + first + (rest ? QMARK2.repeat(rest.length) : "");
        }
        if (index === 0) {
          return qmarkNoDot + (rest ? QMARK2.repeat(rest.length) : "");
        }
        return QMARK2.repeat(chars.length);
      }
      if (first === ".") {
        return DOT_LITERAL2.repeat(chars.length);
      }
      if (first === "*") {
        if (esc) {
          return esc + first + (rest ? star : "");
        }
        return star;
      }
      return esc ? m22 : `\\${m22}`;
    });
    if (backslashes === true) {
      if (opts.unescape === true) {
        output = output.replace(/\\/g, "");
      } else {
        output = output.replace(/\\+/g, (m22) => {
          return m22.length % 2 === 0 ? "\\\\" : m22 ? "\\" : "";
        });
      }
    }
    if (output === input && opts.contains === true) {
      state.output = input;
      return state;
    }
    state.output = utils$1.wrapOutput(output, state, options3);
    return state;
  }
  while (!eos()) {
    value = advance();
    if (value === "\0") {
      continue;
    }
    if (value === "\\") {
      const next = peek();
      if (next === "/" && opts.bash !== true) {
        continue;
      }
      if (next === "." || next === ";") {
        continue;
      }
      if (!next) {
        value += "\\";
        push2({ type: "text", value });
        continue;
      }
      const match = /^\\+/.exec(remaining());
      let slashes = 0;
      if (match && match[0].length > 2) {
        slashes = match[0].length;
        state.index += slashes;
        if (slashes % 2 !== 0) {
          value += "\\";
        }
      }
      if (opts.unescape === true) {
        value = advance();
      } else {
        value += advance();
      }
      if (state.brackets === 0) {
        push2({ type: "text", value });
        continue;
      }
    }
    if (state.brackets > 0 && (value !== "]" || prev.value === "[" || prev.value === "[^")) {
      if (opts.posix !== false && value === ":") {
        const inner = prev.value.slice(1);
        if (inner.includes("[")) {
          prev.posix = true;
          if (inner.includes(":")) {
            const idx = prev.value.lastIndexOf("[");
            const pre = prev.value.slice(0, idx);
            const rest2 = prev.value.slice(idx + 2);
            const posix22 = POSIX_REGEX_SOURCE[rest2];
            if (posix22) {
              prev.value = pre + posix22;
              state.backtrack = true;
              advance();
              if (!bos.output && tokens.indexOf(prev) === 1) {
                bos.output = ONE_CHAR2;
              }
              continue;
            }
          }
        }
      }
      if (value === "[" && peek() !== ":" || value === "-" && peek() === "]") {
        value = `\\${value}`;
      }
      if (value === "]" && (prev.value === "[" || prev.value === "[^")) {
        value = `\\${value}`;
      }
      if (opts.posix === true && value === "!" && prev.value === "[") {
        value = "^";
      }
      prev.value += value;
      append({ value });
      continue;
    }
    if (state.quotes === 1 && value !== '"') {
      value = utils$1.escapeRegex(value);
      prev.value += value;
      append({ value });
      continue;
    }
    if (value === '"') {
      state.quotes = state.quotes === 1 ? 0 : 1;
      if (opts.keepQuotes === true) {
        push2({ type: "text", value });
      }
      continue;
    }
    if (value === "(") {
      increment("parens");
      push2({ type: "paren", value });
      continue;
    }
    if (value === ")") {
      if (state.parens === 0 && opts.strictBrackets === true) {
        throw new SyntaxError(syntaxError("opening", "("));
      }
      const extglob = extglobs[extglobs.length - 1];
      if (extglob && state.parens === extglob.parens + 1) {
        extglobClose(extglobs.pop());
        continue;
      }
      push2({ type: "paren", value, output: state.parens ? ")" : "\\)" });
      decrement("parens");
      continue;
    }
    if (value === "[") {
      if (opts.nobracket === true || !remaining().includes("]")) {
        if (opts.nobracket !== true && opts.strictBrackets === true) {
          throw new SyntaxError(syntaxError("closing", "]"));
        }
        value = `\\${value}`;
      } else {
        increment("brackets");
      }
      push2({ type: "bracket", value });
      continue;
    }
    if (value === "]") {
      if (opts.nobracket === true || prev && prev.type === "bracket" && prev.value.length === 1) {
        push2({ type: "text", value, output: `\\${value}` });
        continue;
      }
      if (state.brackets === 0) {
        if (opts.strictBrackets === true) {
          throw new SyntaxError(syntaxError("opening", "["));
        }
        push2({ type: "text", value, output: `\\${value}` });
        continue;
      }
      decrement("brackets");
      const prevValue = prev.value.slice(1);
      if (prev.posix !== true && prevValue[0] === "^" && !prevValue.includes("/")) {
        value = `/${value}`;
      }
      prev.value += value;
      append({ value });
      if (opts.literalBrackets === false || utils$1.hasRegexChars(prevValue)) {
        continue;
      }
      const escaped = utils$1.escapeRegex(prev.value);
      state.output = state.output.slice(0, -prev.value.length);
      if (opts.literalBrackets === true) {
        state.output += escaped;
        prev.value = escaped;
        continue;
      }
      prev.value = `(${capture}${escaped}|${prev.value})`;
      state.output += prev.value;
      continue;
    }
    if (value === "{" && opts.nobrace !== true) {
      increment("braces");
      const open = {
        type: "brace",
        value,
        output: "(",
        outputIndex: state.output.length,
        tokensIndex: state.tokens.length
      };
      braces.push(open);
      push2(open);
      continue;
    }
    if (value === "}") {
      const brace = braces[braces.length - 1];
      if (opts.nobrace === true || !brace) {
        push2({ type: "text", value, output: value });
        continue;
      }
      let output = ")";
      if (brace.dots === true) {
        const arr = tokens.slice();
        const range = [];
        for (let i = arr.length - 1;i >= 0; i--) {
          tokens.pop();
          if (arr[i].type === "brace") {
            break;
          }
          if (arr[i].type !== "dots") {
            range.unshift(arr[i].value);
          }
        }
        output = expandRange(range, opts);
        state.backtrack = true;
      }
      if (brace.comma !== true && brace.dots !== true) {
        const out = state.output.slice(0, brace.outputIndex);
        const toks = state.tokens.slice(brace.tokensIndex);
        brace.value = brace.output = "\\{";
        value = output = "\\}";
        state.output = out;
        for (const t of toks) {
          state.output += t.output || t.value;
        }
      }
      push2({ type: "brace", value, output });
      decrement("braces");
      braces.pop();
      continue;
    }
    if (value === "|") {
      if (extglobs.length > 0) {
        extglobs[extglobs.length - 1].conditions++;
      }
      push2({ type: "text", value });
      continue;
    }
    if (value === ",") {
      let output = value;
      const brace = braces[braces.length - 1];
      if (brace && stack[stack.length - 1] === "braces") {
        brace.comma = true;
        output = "|";
      }
      push2({ type: "comma", value, output });
      continue;
    }
    if (value === "/") {
      if (prev.type === "dot" && state.index === state.start + 1) {
        state.start = state.index + 1;
        state.consumed = "";
        state.output = "";
        tokens.pop();
        prev = bos;
        continue;
      }
      push2({ type: "slash", value, output: SLASH_LITERAL2 });
      continue;
    }
    if (value === ".") {
      if (state.braces > 0 && prev.type === "dot") {
        if (prev.value === ".")
          prev.output = DOT_LITERAL2;
        const brace = braces[braces.length - 1];
        prev.type = "dots";
        prev.output += value;
        prev.value += value;
        brace.dots = true;
        continue;
      }
      if (state.braces + state.parens === 0 && prev.type !== "bos" && prev.type !== "slash") {
        push2({ type: "text", value, output: DOT_LITERAL2 });
        continue;
      }
      push2({ type: "dot", value, output: DOT_LITERAL2 });
      continue;
    }
    if (value === "?") {
      const isGroup = prev && prev.value === "(";
      if (!isGroup && opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
        extglobOpen("qmark", value);
        continue;
      }
      if (prev && prev.type === "paren") {
        const next = peek();
        let output = value;
        if (next === "<" && !utils$1.supportsLookbehinds()) {
          throw new Error("Node.js v10 or higher is required for regex lookbehinds");
        }
        if (prev.value === "(" && !/[!=<:]/.test(next) || next === "<" && !/<([!=]|\w+>)/.test(remaining())) {
          output = `\\${value}`;
        }
        push2({ type: "text", value, output });
        continue;
      }
      if (opts.dot !== true && (prev.type === "slash" || prev.type === "bos")) {
        push2({ type: "qmark", value, output: QMARK_NO_DOT2 });
        continue;
      }
      push2({ type: "qmark", value, output: QMARK2 });
      continue;
    }
    if (value === "!") {
      if (opts.noextglob !== true && peek() === "(") {
        if (peek(2) !== "?" || !/[!=<:]/.test(peek(3))) {
          extglobOpen("negate", value);
          continue;
        }
      }
      if (opts.nonegate !== true && state.index === 0) {
        negate();
        continue;
      }
    }
    if (value === "+") {
      if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
        extglobOpen("plus", value);
        continue;
      }
      if (prev && prev.value === "(" || opts.regex === false) {
        push2({ type: "plus", value, output: PLUS_LITERAL2 });
        continue;
      }
      if (prev && (prev.type === "bracket" || prev.type === "paren" || prev.type === "brace") || state.parens > 0) {
        push2({ type: "plus", value });
        continue;
      }
      push2({ type: "plus", value: PLUS_LITERAL2 });
      continue;
    }
    if (value === "@") {
      if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
        push2({ type: "at", extglob: true, value, output: "" });
        continue;
      }
      push2({ type: "text", value });
      continue;
    }
    if (value !== "*") {
      if (value === "$" || value === "^") {
        value = `\\${value}`;
      }
      const match = REGEX_NON_SPECIAL_CHARS.exec(remaining());
      if (match) {
        value += match[0];
        state.index += match[0].length;
      }
      push2({ type: "text", value });
      continue;
    }
    if (prev && (prev.type === "globstar" || prev.star === true)) {
      prev.type = "star";
      prev.star = true;
      prev.value += value;
      prev.output = star;
      state.backtrack = true;
      state.globstar = true;
      consume(value);
      continue;
    }
    let rest = remaining();
    if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
      extglobOpen("star", value);
      continue;
    }
    if (prev.type === "star") {
      if (opts.noglobstar === true) {
        consume(value);
        continue;
      }
      const prior = prev.prev;
      const before = prior.prev;
      const isStart = prior.type === "slash" || prior.type === "bos";
      const afterStar = before && (before.type === "star" || before.type === "globstar");
      if (opts.bash === true && (!isStart || rest[0] && rest[0] !== "/")) {
        push2({ type: "star", value, output: "" });
        continue;
      }
      const isBrace = state.braces > 0 && (prior.type === "comma" || prior.type === "brace");
      const isExtglob = extglobs.length && (prior.type === "pipe" || prior.type === "paren");
      if (!isStart && prior.type !== "paren" && !isBrace && !isExtglob) {
        push2({ type: "star", value, output: "" });
        continue;
      }
      while (rest.slice(0, 3) === "/**") {
        const after = input[state.index + 4];
        if (after && after !== "/") {
          break;
        }
        rest = rest.slice(3);
        consume("/**", 3);
      }
      if (prior.type === "bos" && eos()) {
        prev.type = "globstar";
        prev.value += value;
        prev.output = globstar(opts);
        state.output = prev.output;
        state.globstar = true;
        consume(value);
        continue;
      }
      if (prior.type === "slash" && prior.prev.type !== "bos" && !afterStar && eos()) {
        state.output = state.output.slice(0, -(prior.output + prev.output).length);
        prior.output = `(?:${prior.output}`;
        prev.type = "globstar";
        prev.output = globstar(opts) + (opts.strictSlashes ? ")" : "|$)");
        prev.value += value;
        state.globstar = true;
        state.output += prior.output + prev.output;
        consume(value);
        continue;
      }
      if (prior.type === "slash" && prior.prev.type !== "bos" && rest[0] === "/") {
        const end = rest[1] !== undefined ? "|$" : "";
        state.output = state.output.slice(0, -(prior.output + prev.output).length);
        prior.output = `(?:${prior.output}`;
        prev.type = "globstar";
        prev.output = `${globstar(opts)}${SLASH_LITERAL2}|${SLASH_LITERAL2}${end})`;
        prev.value += value;
        state.output += prior.output + prev.output;
        state.globstar = true;
        consume(value + advance());
        push2({ type: "slash", value: "/", output: "" });
        continue;
      }
      if (prior.type === "bos" && rest[0] === "/") {
        prev.type = "globstar";
        prev.value += value;
        prev.output = `(?:^|${SLASH_LITERAL2}|${globstar(opts)}${SLASH_LITERAL2})`;
        state.output = prev.output;
        state.globstar = true;
        consume(value + advance());
        push2({ type: "slash", value: "/", output: "" });
        continue;
      }
      state.output = state.output.slice(0, -prev.output.length);
      prev.type = "globstar";
      prev.output = globstar(opts);
      prev.value += value;
      state.output += prev.output;
      state.globstar = true;
      consume(value);
      continue;
    }
    const token = { type: "star", value, output: star };
    if (opts.bash === true) {
      token.output = ".*?";
      if (prev.type === "bos" || prev.type === "slash") {
        token.output = nodot + token.output;
      }
      push2(token);
      continue;
    }
    if (prev && (prev.type === "bracket" || prev.type === "paren") && opts.regex === true) {
      token.output = value;
      push2(token);
      continue;
    }
    if (state.index === state.start || prev.type === "slash" || prev.type === "dot") {
      if (prev.type === "dot") {
        state.output += NO_DOT_SLASH2;
        prev.output += NO_DOT_SLASH2;
      } else if (opts.dot === true) {
        state.output += NO_DOTS_SLASH2;
        prev.output += NO_DOTS_SLASH2;
      } else {
        state.output += nodot;
        prev.output += nodot;
      }
      if (peek() !== "*") {
        state.output += ONE_CHAR2;
        prev.output += ONE_CHAR2;
      }
    }
    push2(token);
  }
  while (state.brackets > 0) {
    if (opts.strictBrackets === true)
      throw new SyntaxError(syntaxError("closing", "]"));
    state.output = utils$1.escapeLast(state.output, "[");
    decrement("brackets");
  }
  while (state.parens > 0) {
    if (opts.strictBrackets === true)
      throw new SyntaxError(syntaxError("closing", ")"));
    state.output = utils$1.escapeLast(state.output, "(");
    decrement("parens");
  }
  while (state.braces > 0) {
    if (opts.strictBrackets === true)
      throw new SyntaxError(syntaxError("closing", "}"));
    state.output = utils$1.escapeLast(state.output, "{");
    decrement("braces");
  }
  if (opts.strictSlashes !== true && (prev.type === "star" || prev.type === "bracket")) {
    push2({ type: "maybe_slash", value: "", output: `${SLASH_LITERAL2}?` });
  }
  if (state.backtrack === true) {
    state.output = "";
    for (const token of state.tokens) {
      state.output += token.output != null ? token.output : token.value;
      if (token.suffix) {
        state.output += token.suffix;
      }
    }
  }
  return state;
};
var parse_1;
var path3;
var scan;
var parse$1;
var utils5;
var constants;
var isObject32 = (val2) => val2 && typeof val2 === "object" && !Array.isArray(val2);
var picomatch$1 = (glob, options3, returnState = false) => {
  if (Array.isArray(glob)) {
    const fns = glob.map((input) => picomatch$1(input, options3, returnState));
    const arrayMatcher = (str) => {
      for (const isMatch of fns) {
        const state2 = isMatch(str);
        if (state2)
          return state2;
      }
      return false;
    };
    return arrayMatcher;
  }
  const isState = isObject32(glob) && glob.tokens && glob.input;
  if (glob === "" || typeof glob !== "string" && !isState) {
    throw new TypeError("Expected pattern to be a non-empty string");
  }
  const opts = options3 || {};
  const posix22 = utils5.isWindows(options3);
  const regex22 = isState ? picomatch$1.compileRe(glob, options3) : picomatch$1.makeRe(glob, options3, false, true);
  const state = regex22.state;
  delete regex22.state;
  let isIgnored = () => false;
  if (opts.ignore) {
    const ignoreOpts = { ...options3, ignore: null, onMatch: null, onResult: null };
    isIgnored = picomatch$1(opts.ignore, ignoreOpts, returnState);
  }
  const matcher = (input, returnObject = false) => {
    const { isMatch, match, output } = picomatch$1.test(input, regex22, options3, { glob, posix: posix22 });
    const result2 = { glob, state, regex: regex22, posix: posix22, input, output, match, isMatch };
    if (typeof opts.onResult === "function") {
      opts.onResult(result2);
    }
    if (isMatch === false) {
      result2.isMatch = false;
      return returnObject ? result2 : false;
    }
    if (isIgnored(input)) {
      if (typeof opts.onIgnore === "function") {
        opts.onIgnore(result2);
      }
      result2.isMatch = false;
      return returnObject ? result2 : false;
    }
    if (typeof opts.onMatch === "function") {
      opts.onMatch(result2);
    }
    return returnObject ? result2 : true;
  };
  if (returnState) {
    matcher.state = state;
  }
  return matcher;
};
var reservedWords$1 = "break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public";
var builtins = "arguments Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl";
var forbiddenIdentifiers;
var UNDEFINED_EXPRESSION;
var returnsUnknown;
var UNKNOWN_LITERAL_BOOLEAN;
var returnsBoolean;
var UNKNOWN_LITERAL_NUMBER;
var returnsNumber;
var UNKNOWN_LITERAL_STRING;
var returnsString;
var stringReplace;
var objectMembers;
var literalBooleanMembers;
var literalNumberMembers;
var literalRegExpMembers;
var literalStringMembers;
var base$1;
var BlockStatement$1 = "BlockStatement";
var CallExpression$1 = "CallExpression";
var ExpressionStatement$1 = "ExpressionStatement";
var Program$1 = "Program";
var ReturnStatement$1 = "ReturnStatement";
var SOURCEMAPPING_URL = "sourceMa";
var whiteSpaceNoNewline = "[ \\f\\r\\t\\v\\u00a0\\u1680\\u2000-\\u200a\\u2028\\u2029\\u202f\\u205f\\u3000\\ufeff]";
var SOURCEMAPPING_URL_RE;
var ANNOTATION_KEY = "_rollupAnnotations";
var INVALID_COMMENT_KEY = "_rollupRemoved";
var keys;
var NodeBase;
var SpreadElement;
var Method;
var METHOD_RETURNS_BOOLEAN;
var METHOD_RETURNS_STRING;
var METHOD_RETURNS_NUMBER;
var METHOD_RETURNS_UNKNOWN;
var INTEGER_REG_EXP;
var ObjectEntity;
var isInteger = (property) => typeof property === "string" && /^\d+$/.test(property);
var OBJECT_PROTOTYPE_FALLBACK;
var OBJECT_PROTOTYPE;
var NEW_ARRAY_PROPERTIES;
var METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_BOOLEAN;
var METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NUMBER;
var METHOD_MUTATES_SELF_RETURNS_NEW_ARRAY;
var METHOD_DEOPTS_SELF_RETURNS_NEW_ARRAY;
var METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NEW_ARRAY;
var METHOD_MUTATES_SELF_RETURNS_NUMBER;
var METHOD_MUTATES_SELF_RETURNS_UNKNOWN;
var METHOD_DEOPTS_SELF_RETURNS_UNKNOWN;
var METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_UNKNOWN;
var METHOD_MUTATES_SELF_RETURNS_SELF;
var METHOD_CALLS_ARG_MUTATES_SELF_RETURNS_SELF;
var ARRAY_PROTOTYPE;
var ArrayExpression;
var LocalVariable;
var MAX_TRACKED_INTERACTIONS = 20;
var NO_INTERACTIONS;
var UNKNOWN_DEOPTIMIZED_FIELD;
var EMPTY_PATH_TRACKER;
var UNKNOWN_DEOPTIMIZED_ENTITY;
var ParameterVariable;
var chars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_$";
var base = 64;
var Scope$1 = class Scope {
  constructor() {
    this.children = [];
    this.variables = new Map;
  }
  addDeclaration(identifier, context, init22, _isHoisted) {
    const name = identifier.name;
    let variable = this.variables.get(name);
    if (variable) {
      variable.addDeclaration(identifier, init22);
    } else {
      variable = new LocalVariable(identifier.name, identifier, init22 || UNDEFINED_EXPRESSION, context);
      this.variables.set(name, variable);
    }
    return variable;
  }
  contains(name) {
    return this.variables.has(name);
  }
  findVariable(_name) {
    throw new Error("Internal Error: findVariable needs to be implemented by a subclass");
  }
};
var ChildScope;
var ParameterScope;
var ReturnValueScope;
var PureFunctionKey;
var doNothing = () => {
};
var ValueProperties;
var getTruthyLiteralValue = () => UnknownTruthyValue;
var returnFalse = () => false;
var returnTrue = () => true;
var PURE;
var IMPURE;
var PURE_WITH_ARRAY;
var GETTER_ACCESS;
var O;
var PF;
var PF_NO_GETTER;
var MUTATES_ARG_WITHOUT_ACCESSOR;
var C;
var PC;
var PC_WITH_ARRAY;
var ARRAY_TYPE;
var INTL_MEMBER;
var knownGlobals;
var GlobalVariable;
var tdzVariableKinds;
var Identifier;
var NON_WHITESPACE;
var BlockScope;
var ExpressionStatement;
var BlockStatement;
var RestElement;
var FunctionBase;
var ArgumentsVariable;
var ThisVariable;
var FunctionScope;
var FunctionNode;
var MethodBase;
var MethodDefinition;
var ObjectMember;
var ClassNode;
var ClassDeclaration;
var ExportAllDeclaration;
var FunctionDeclaration;
var ExportDefaultDeclaration;
var ExportNamedDeclaration;
var unset;
var ImportDeclaration;
var INTEROP_DEFAULT_VARIABLE = "_interopDefault";
var INTEROP_DEFAULT_COMPAT_VARIABLE = "_interopDefaultCompat";
var INTEROP_NAMESPACE_VARIABLE = "_interopNamespace";
var INTEROP_NAMESPACE_COMPAT_VARIABLE = "_interopNamespaceCompat";
var INTEROP_NAMESPACE_DEFAULT_VARIABLE = "_interopNamespaceDefault";
var INTEROP_NAMESPACE_DEFAULT_ONLY_VARIABLE = "_interopNamespaceDefaultOnly";
var MERGE_NAMESPACES_VARIABLE = "_mergeNamespaces";
var DOCUMENT_CURRENT_SCRIPT = "_documentCurrentScript";
var HELPER_GENERATORS;
var getDefaultLiveBinding = ({ _: _22, getObject }) => `e${_22}:${_22}${getObject([["default", "e"]], { lineBreakIndent: null })}`;
var getDefaultStatic = ({ _: _22, getPropertyAccess }) => `e${getPropertyAccess("default")}${_22}:${_22}e`;
var getIsCompatNamespace = ({ _: _22 }) => `e${_22}&&${_22}typeof e${_22}===${_22}'object'${_22}&&${_22}'default'${_22}in e`;
var createNamespaceObject = (t, index, snippets, liveBindings, freeze, namespaceToStringTag) => {
  const { _: _22, cnst, getObject, getPropertyAccess, n, s: s32 } = snippets;
  const copyProperty2 = `{${n}` + (liveBindings ? copyNonDefaultOwnPropertyLiveBinding : copyPropertyStatic)(t, index + t + t, snippets) + `${index}${t}}`;
  return `${index}${cnst} n${_22}=${_22}Object.create(null${namespaceToStringTag ? `,${_22}{${_22}[Symbol.toStringTag]:${_22}${getToStringTagValue(getObject)}${_22}}` : ""});${n}${index}if${_22}(e)${_22}{${n}${index}${t}${loopOverKeys(copyProperty2, !liveBindings, snippets)}${n}${index}}${n}${index}n${getPropertyAccess("default")}${_22}=${_22}e;${n}${index}return ${getFrozen(freeze, "n")}${s32}${n}`;
};
var loopOverKeys = (body, allowVariableLoopVariable, { _: _22, cnst, getFunctionIntro, s: s32 }) => cnst !== "var" || allowVariableLoopVariable ? `for${_22}(${cnst} k in e)${_22}${body}` : `Object.keys(e).forEach(${getFunctionIntro(["k"], {
  isAsync: false,
  name: null
})}${body})${s32}`;
var loopOverNamespaces = (body, useForEach, t, { _: _22, cnst, getDirectReturnFunction, getFunctionIntro, n }) => {
  if (useForEach) {
    const [left, right] = getDirectReturnFunction(["e"], {
      functionReturn: false,
      lineBreakIndent: { base: t, t },
      name: null
    });
    return `m.forEach(${left}e${_22}&&${_22}typeof e${_22}!==${_22}'string'${_22}&&${_22}!Array.isArray(e)${_22}&&${_22}Object.keys(e).forEach(${getFunctionIntro(["k"], {
      isAsync: false,
      name: null
    })}${body})${right});`;
  }
  return `for${_22}(var i${_22}=${_22}0;${_22}i${_22}<${_22}m.length;${_22}i++)${_22}{${n}${t}${t}${cnst} e${_22}=${_22}m[i];${n}${t}${t}if${_22}(typeof e${_22}!==${_22}'string'${_22}&&${_22}!Array.isArray(e))${_22}{${_22}for${_22}(${cnst} k in e)${_22}${body}${_22}}${n}${t}}`;
};
var copyNonDefaultOwnPropertyLiveBinding = (t, index, snippets) => {
  const { _: _22, n } = snippets;
  return `${index}if${_22}(k${_22}!==${_22}'default')${_22}{${n}` + copyOwnPropertyLiveBinding(t, index + t, snippets) + `${index}}${n}`;
};
var copyOwnPropertyLiveBinding = (t, index, { _: _22, cnst, getDirectReturnFunction, n }) => {
  const [left, right] = getDirectReturnFunction([], {
    functionReturn: true,
    lineBreakIndent: null,
    name: null
  });
  return `${index}${cnst} d${_22}=${_22}Object.getOwnPropertyDescriptor(e,${_22}k);${n}${index}Object.defineProperty(n,${_22}k,${_22}d.get${_22}?${_22}d${_22}:${_22}{${n}${index}${t}enumerable:${_22}true,${n}${index}${t}get:${_22}${left}e[k]${right}${n}${index}});${n}`;
};
var copyPropertyLiveBinding = (t, index, { _: _22, cnst, getDirectReturnFunction, n }) => {
  const [left, right] = getDirectReturnFunction([], {
    functionReturn: true,
    lineBreakIndent: null,
    name: null
  });
  return `${index}${cnst} d${_22}=${_22}Object.getOwnPropertyDescriptor(e,${_22}k);${n}${index}if${_22}(d)${_22}{${n}${index}${t}Object.defineProperty(n,${_22}k,${_22}d.get${_22}?${_22}d${_22}:${_22}{${n}${index}${t}${t}enumerable:${_22}true,${n}${index}${t}${t}get:${_22}${left}e[k]${right}${n}${index}${t}});${n}${index}}${n}`;
};
var copyPropertyStatic = (_t, index, { _: _22, n }) => `${index}n[k]${_22}=${_22}e[k];${n}`;
var getFrozen = (freeze, fragment) => freeze ? `Object.freeze(${fragment})` : fragment;
var getWithToStringTag = (namespaceToStringTag, fragment, { _: _22, getObject }) => namespaceToStringTag ? `Object.defineProperty(${fragment},${_22}Symbol.toStringTag,${_22}${getToStringTagValue(getObject)})` : fragment;
var HELPER_NAMES;
var getResolveUrl = (path42, URL2 = "URL") => `new ${URL2}(${path42}).href`;
var getGenericImportMetaMechanism = (getUrl) => (property, { chunkId }) => {
  const urlMechanism = getUrl(chunkId);
  return property === null ? `({ url: ${urlMechanism} })` : property === "url" ? urlMechanism : "undefined";
};
var getFileUrlFromFullPath = (path42) => `require('u' + 'rl').pathToFileURL(${path42}).href`;
var getUrlFromDocument = (chunkId, umd = false) => `${umd ? `typeof document === 'undefined' ? location.href : ` : ""}(${DOCUMENT_CURRENT_SCRIPT} && ${DOCUMENT_CURRENT_SCRIPT}.tagName.toUpperCase() === 'SCRIPT' && ${DOCUMENT_CURRENT_SCRIPT}.src || new URL('${escapeId(chunkId)}', document.baseURI).href)`;
var importMetaMechanisms;
var SwitchCase;
var NamespaceVariable;
var BuildPhase;
var sourceMapCache;
var timers;
var require$$022;
var _static;
var builtinModules;
var nodeBuiltins;
var hashPlaceholderLeft = "!~{";
var hashPlaceholderRight = "}~";
var hashPlaceholderOverhead;
var maxHashSize = 64;
var REPLACER_REGEX;
var lowercaseBundleKeys;
var NON_ASSET_EXTENSIONS;
var astralIdentifierCodes;
var astralIdentifierStartCodes;
var nonASCIIidentifierChars = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0CF3\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECE\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
var reservedWords;
var ecma5AndLessKeywords = "break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this";
var keywords$1;
var keywordRelationalOperator;
var nonASCIIidentifierStart;
var nonASCIIidentifier;
var TokenType = function TokenType2(label, conf) {
  if (conf === undefined)
    conf = {};
  this.label = label;
  this.keyword = conf.keyword;
  this.beforeExpr = !!conf.beforeExpr;
  this.startsExpr = !!conf.startsExpr;
  this.isLoop = !!conf.isLoop;
  this.isAssign = !!conf.isAssign;
  this.prefix = !!conf.prefix;
  this.postfix = !!conf.postfix;
  this.binop = conf.binop || null;
  this.updateContext = null;
};
var beforeExpr;
var startsExpr;
var keywords;
var types$1;
var lineBreak;
var lineBreakG;
var nonASCIIwhitespace;
var skipWhiteSpace;
var ref;
var hasOwnProperty2;
var toString2;
var hasOwn;
var isArray22;
var loneSurrogate;
var Position = function Position2(line, col) {
  this.line = line;
  this.column = col;
};
var SourceLocation = function SourceLocation2(p32, start, end) {
  this.start = start;
  this.end = end;
  if (p32.sourceFile !== null) {
    this.source = p32.sourceFile;
  }
};
var defaultOptions;
var warnedAboutEcmaVersion = false;
var SCOPE_TOP = 1;
var SCOPE_FUNCTION = 2;
var SCOPE_ASYNC = 4;
var SCOPE_GENERATOR = 8;
var SCOPE_ARROW = 16;
var SCOPE_SIMPLE_CATCH = 32;
var SCOPE_SUPER = 64;
var SCOPE_DIRECT_SUPER = 128;
var SCOPE_CLASS_STATIC_BLOCK = 256;
var SCOPE_VAR;
var BIND_NONE = 0;
var BIND_VAR = 1;
var BIND_LEXICAL = 2;
var BIND_FUNCTION = 3;
var BIND_SIMPLE_CATCH = 4;
var BIND_OUTSIDE = 5;
var Parser = function Parser2(options3, input, startPos) {
  this.options = options3 = getOptions(options3);
  this.sourceFile = options3.sourceFile;
  this.keywords = wordsRegexp(keywords$1[options3.ecmaVersion >= 6 ? 6 : options3.sourceType === "module" ? "5module" : 5]);
  var reserved = "";
  if (options3.allowReserved !== true) {
    reserved = reservedWords[options3.ecmaVersion >= 6 ? 6 : options3.ecmaVersion === 5 ? 5 : 3];
    if (options3.sourceType === "module") {
      reserved += " await";
    }
  }
  this.reservedWords = wordsRegexp(reserved);
  var reservedStrict = (reserved ? reserved + " " : "") + reservedWords.strict;
  this.reservedWordsStrict = wordsRegexp(reservedStrict);
  this.reservedWordsStrictBind = wordsRegexp(reservedStrict + " " + reservedWords.strictBind);
  this.input = String(input);
  this.containsEsc = false;
  if (startPos) {
    this.pos = startPos;
    this.lineStart = this.input.lastIndexOf("\n", startPos - 1) + 1;
    this.curLine = this.input.slice(0, this.lineStart).split(lineBreak).length;
  } else {
    this.pos = this.lineStart = 0;
    this.curLine = 1;
  }
  this.type = types$1.eof;
  this.value = null;
  this.start = this.end = this.pos;
  this.startLoc = this.endLoc = this.curPosition();
  this.lastTokEndLoc = this.lastTokStartLoc = null;
  this.lastTokStart = this.lastTokEnd = this.pos;
  this.context = this.initialContext();
  this.exprAllowed = true;
  this.inModule = options3.sourceType === "module";
  this.strict = this.inModule || this.strictDirective(this.pos);
  this.potentialArrowAt = -1;
  this.potentialArrowInForAwait = false;
  this.yieldPos = this.awaitPos = this.awaitIdentPos = 0;
  this.labels = [];
  this.undefinedExports = Object.create(null);
  if (this.pos === 0 && options3.allowHashBang && this.input.slice(0, 2) === "#!") {
    this.skipLineComment(2);
  }
  this.scopeStack = [];
  this.enterScope(SCOPE_TOP);
  this.regexpState = null;
  this.privateNameStack = [];
};
var prototypeAccessors;
var pp$9;
var literal;
var DestructuringErrors = function DestructuringErrors2() {
  this.shorthandAssign = this.trailingComma = this.parenthesizedAssign = this.parenthesizedBind = this.doubleProto = -1;
};
var pp$8;
var loopLabel;
var switchLabel;
var empty$1;
var FUNC_STATEMENT$1 = 1;
var FUNC_HANGING_STATEMENT = 2;
var FUNC_NULLABLE_ID$1 = 4;
var pp$7;
var TokContext = function TokContext2(token, isExpr, preserveSpace, override, generator) {
  this.token = token;
  this.isExpr = !!isExpr;
  this.preserveSpace = !!preserveSpace;
  this.override = override;
  this.generator = !!generator;
};
var types3;
var pp$6;
var pp$5;
var empty;
var pp$4;
var pp$3;
var Scope2 = function Scope3(flags) {
  this.flags = flags;
  this.var = [];
  this.lexical = [];
  this.functions = [];
  this.inClassFieldInit = false;
};
var Node = function Node2(parser, pos, loc) {
  this.type = "";
  this.start = pos;
  this.end = 0;
  if (parser.options.locations) {
    this.loc = new SourceLocation(parser, loc);
  }
  if (parser.options.directSourceFile) {
    this.sourceFile = parser.options.directSourceFile;
  }
  if (parser.options.ranges) {
    this.range = [pos, 0];
  }
};
var pp$2;
var ecma9BinaryProperties = "ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS";
var ecma10BinaryProperties;
var ecma11BinaryProperties;
var ecma12BinaryProperties;
var ecma13BinaryProperties;
var ecma14BinaryProperties;
var unicodeBinaryProperties;
var ecma14BinaryPropertiesOfStrings = "Basic_Emoji Emoji_Keycap_Sequence RGI_Emoji_Modifier_Sequence RGI_Emoji_Flag_Sequence RGI_Emoji_Tag_Sequence RGI_Emoji_ZWJ_Sequence RGI_Emoji";
var unicodeBinaryPropertiesOfStrings;
var unicodeGeneralCategoryValues = "Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu";
var ecma9ScriptValues = "Adlam Adlm Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb";
var ecma10ScriptValues;
var ecma11ScriptValues;
var ecma12ScriptValues;
var ecma13ScriptValues;
var ecma14ScriptValues;
var unicodeScriptValues;
var data;
var ecmaVersion;
var i;
var list;
var pp$1;
var RegExpValidationState = function RegExpValidationState2(parser) {
  this.parser = parser;
  this.validFlags = "gim" + (parser.options.ecmaVersion >= 6 ? "uy" : "") + (parser.options.ecmaVersion >= 9 ? "s" : "") + (parser.options.ecmaVersion >= 13 ? "d" : "") + (parser.options.ecmaVersion >= 15 ? "v" : "");
  this.unicodeProperties = data[parser.options.ecmaVersion >= 14 ? 14 : parser.options.ecmaVersion];
  this.source = "";
  this.flags = "";
  this.start = 0;
  this.switchU = false;
  this.switchV = false;
  this.switchN = false;
  this.pos = 0;
  this.lastIntValue = 0;
  this.lastStringValue = "";
  this.lastAssertionIsQuantifiable = false;
  this.numCapturingParens = 0;
  this.maxBackReference = 0;
  this.groupNames = [];
  this.backReferenceNames = [];
};
var CharSetNone = 0;
var CharSetOk = 1;
var CharSetString = 2;
var Token = function Token2(p32) {
  this.type = p32.type;
  this.value = p32.value;
  this.start = p32.start;
  this.end = p32.end;
  if (p32.options.locations) {
    this.loc = new SourceLocation(p32, p32.startLoc, p32.endLoc);
  }
  if (p32.options.ranges) {
    this.range = [p32.start, p32.end];
  }
};
var pp;
var INVALID_TEMPLATE_ESCAPE_ERROR;
var version2 = "8.10.0";
var emittedFileTypes;
var inputHookNames;
var inputHooks;
var rejectByPluginDriver;
var leftCurlyBrace;
var space;
var ALLOWED_INTEROP_TYPES;
var SortingFileType;
var env5;
var argv22;
var platform22;
var isDisabled22;
var isForced22;
var isWindows22;
var isDumbTerminal22;
var isCompatibleTerminal22;
var isCI32;
var isColorSupported32;
var replaceClose32 = (index, string2, close, replace22, head2 = string2.substring(0, index) + replace22, tail = string2.substring(index + close.length), next = tail.indexOf(close)) => head2 + (next < 0 ? tail : replaceClose32(next, tail, close, replace22));
var clearBleed22 = (index, string2, open, close, replace22) => index < 0 ? open + string2 + close : open + replaceClose32(index, string2, close, replace22) + close;
var filterEmpty22 = (open, close, replace22 = open, at2 = open.length + 1) => (string2) => string2 || !(string2 === "" || string2 === undefined) ? clearBleed22(("" + string2).indexOf(close, at2), string2, open, close, replace22) : "";
var init22 = (open, close, replace22) => filterEmpty22(`\x1B[${open}m`, `\x1B[${close}m`, replace22);
var colors22;
var createColors32 = ({ useColor = isColorSupported32 } = {}) => useColor ? colors22 : Object.keys(colors22).reduce((colors3, key) => ({ ...colors3, [key]: String }), {});
var bold22;
var cyan22;
var dim22;
var gray22;
var green22;
var red22;
var underline22;
var yellow22;
var init_node_entry = __esm2(() => {
  comma = ",".charCodeAt(0);
  semicolon = ";".charCodeAt(0);
  intToChar = new Uint8Array(64);
  charToInt = new Uint8Array(128);
  for (let i2 = 0;i2 < chars$1.length; i2++) {
    const c22 = chars$1.charCodeAt(i2);
    intToChar[i2] = c22;
    charToInt[c22] = i2;
  }
  ANY_SLASH_REGEX = /[/\\]/;
  needsEscapeRegEx = /[\n\r'\\\u2028\u2029]/;
  quoteNewlineRegEx = /([\n\r'\u2028\u2029])/g;
  backSlashRegEx = /\\/g;
  ABSOLUTE_PATH_REGEX = /^(?:\/|(?:[A-Za-z]:)?[/\\|])/;
  UnknownKey = Symbol("Unknown Key");
  UnknownNonAccessorKey = Symbol("Unknown Non-Accessor Key");
  UnknownInteger = Symbol("Unknown Integer");
  SymbolToStringTag = Symbol("Symbol.toStringTag");
  EMPTY_PATH = [];
  UNKNOWN_PATH = [UnknownKey];
  UNKNOWN_NON_ACCESSOR_PATH = [UnknownNonAccessorKey];
  UNKNOWN_INTEGER_PATH = [UnknownInteger];
  EntitiesKey = Symbol("Entities");
  SHARED_RECURSION_TRACKER = new PathTracker;
  UnknownValue = Symbol("Unknown Value");
  UnknownTruthyValue = Symbol("Unknown Truthy Value");
  UNKNOWN_EXPRESSION = new class UnknownExpression extends ExpressionEntity {
  };
  UNKNOWN_RETURN_EXPRESSION = [
    UNKNOWN_EXPRESSION,
    false
  ];
  NODE_INTERACTION_UNKNOWN_ACCESS = {
    args: [null],
    type: INTERACTION_ACCESSED
  };
  NODE_INTERACTION_UNKNOWN_ASSIGNMENT = {
    args: [null, UNKNOWN_EXPRESSION],
    type: INTERACTION_ASSIGNED
  };
  NODE_INTERACTION_UNKNOWN_CALL = {
    args: [null],
    type: INTERACTION_CALLED,
    withNew: false
  };
  Variable = class Variable2 extends ExpressionEntity {
    constructor(name) {
      super();
      this.name = name;
      this.alwaysRendered = false;
      this.forbiddenNames = null;
      this.initReached = false;
      this.isId = false;
      this.isReassigned = false;
      this.kind = null;
      this.renderBaseName = null;
      this.renderName = null;
    }
    addReference(_identifier) {
    }
    forbidName(name) {
      (this.forbiddenNames || (this.forbiddenNames = new Set)).add(name);
    }
    getBaseVariableName() {
      return this.renderBaseName || this.renderName || this.name;
    }
    getName(getPropertyAccess, useOriginalName) {
      if (useOriginalName?.(this)) {
        return this.name;
      }
      const name = this.renderName || this.name;
      return this.renderBaseName ? `${this.renderBaseName}${getPropertyAccess(name)}` : name;
    }
    hasEffectsOnInteractionAtPath(path32, { type }, _context) {
      return type !== INTERACTION_ACCESSED || path32.length > 0;
    }
    include() {
      this.included = true;
    }
    markCalledFromTryStatement() {
    }
    setRenderNames(baseName, name) {
      this.renderBaseName = baseName;
      this.renderName = name;
    }
  };
  BLANK = Object.freeze(Object.create(null));
  EMPTY_OBJECT = Object.freeze({});
  EMPTY_ARRAY = Object.freeze([]);
  EMPTY_SET = Object.freeze(new class extends Set {
    add() {
      throw new Error("Cannot add to empty set");
    }
  });
  RESERVED_NAMES = new Set([
    "await",
    "break",
    "case",
    "catch",
    "class",
    "const",
    "continue",
    "debugger",
    "default",
    "delete",
    "do",
    "else",
    "enum",
    "eval",
    "export",
    "extends",
    "false",
    "finally",
    "for",
    "function",
    "if",
    "implements",
    "import",
    "in",
    "instanceof",
    "interface",
    "let",
    "NaN",
    "new",
    "null",
    "package",
    "private",
    "protected",
    "public",
    "return",
    "static",
    "super",
    "switch",
    "this",
    "throw",
    "true",
    "try",
    "typeof",
    "undefined",
    "var",
    "void",
    "while",
    "with",
    "yield"
  ]);
  RESERVED_NAMES$1 = RESERVED_NAMES;
  logLevelPriority = {
    [LOGLEVEL_DEBUG]: 0,
    [LOGLEVEL_INFO]: 1,
    [LOGLEVEL_SILENT]: 3,
    [LOGLEVEL_WARN]: 2
  };
  utils$3 = {};
  path$1 = require$$0$1;
  WIN_NO_SLASH = `[^${WIN_SLASH}]`;
  END_ANCHOR = `(?:${SLASH_LITERAL}|$)`;
  START_ANCHOR = `(?:^|${SLASH_LITERAL})`;
  DOTS_SLASH = `${DOT_LITERAL}{1,2}${END_ANCHOR}`;
  NO_DOT = `(?!${DOT_LITERAL})`;
  NO_DOTS = `(?!${START_ANCHOR}${DOTS_SLASH})`;
  NO_DOT_SLASH = `(?!${DOT_LITERAL}{0,1}${END_ANCHOR})`;
  NO_DOTS_SLASH = `(?!${DOTS_SLASH})`;
  QMARK_NO_DOT = `[^.${SLASH_LITERAL}]`;
  STAR = `${QMARK}*?`;
  POSIX_CHARS = {
    DOT_LITERAL,
    PLUS_LITERAL,
    QMARK_LITERAL,
    SLASH_LITERAL,
    ONE_CHAR,
    QMARK,
    END_ANCHOR,
    DOTS_SLASH,
    NO_DOT,
    NO_DOTS,
    NO_DOT_SLASH,
    NO_DOTS_SLASH,
    QMARK_NO_DOT,
    STAR,
    START_ANCHOR
  };
  WINDOWS_CHARS = {
    ...POSIX_CHARS,
    SLASH_LITERAL: `[${WIN_SLASH}]`,
    QMARK: WIN_NO_SLASH,
    STAR: `${WIN_NO_SLASH}*?`,
    DOTS_SLASH: `${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$)`,
    NO_DOT: `(?!${DOT_LITERAL})`,
    NO_DOTS: `(?!(?:^|[${WIN_SLASH}])${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
    NO_DOT_SLASH: `(?!${DOT_LITERAL}{0,1}(?:[${WIN_SLASH}]|$))`,
    NO_DOTS_SLASH: `(?!${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
    QMARK_NO_DOT: `[^.${WIN_SLASH}]`,
    START_ANCHOR: `(?:^|[${WIN_SLASH}])`,
    END_ANCHOR: `(?:[${WIN_SLASH}]|$)`
  };
  POSIX_REGEX_SOURCE$1 = {
    alnum: "a-zA-Z0-9",
    alpha: "a-zA-Z",
    ascii: "\\x00-\\x7F",
    blank: " \\t",
    cntrl: "\\x00-\\x1F\\x7F",
    digit: "0-9",
    graph: "\\x21-\\x7E",
    lower: "a-z",
    print: "\\x20-\\x7E ",
    punct: '\\-!"#$%&\'()\\*+,./:;<=>?@[\\]^_`{|}~',
    space: " \\t\\r\\n\\v\\f",
    upper: "A-Z",
    word: "A-Za-z0-9_",
    xdigit: "A-Fa-f0-9"
  };
  constants$2 = {
    MAX_LENGTH: 65536,
    POSIX_REGEX_SOURCE: POSIX_REGEX_SOURCE$1,
    REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
    REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
    REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
    REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
    REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
    REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,
    REPLACEMENTS: {
      "***": "*",
      "**/**": "**",
      "**/**/**": "**"
    },
    CHAR_0: 48,
    CHAR_9: 57,
    CHAR_UPPERCASE_A: 65,
    CHAR_LOWERCASE_A: 97,
    CHAR_UPPERCASE_Z: 90,
    CHAR_LOWERCASE_Z: 122,
    CHAR_LEFT_PARENTHESES: 40,
    CHAR_RIGHT_PARENTHESES: 41,
    CHAR_ASTERISK: 42,
    CHAR_AMPERSAND: 38,
    CHAR_AT: 64,
    CHAR_BACKWARD_SLASH: 92,
    CHAR_CARRIAGE_RETURN: 13,
    CHAR_CIRCUMFLEX_ACCENT: 94,
    CHAR_COLON: 58,
    CHAR_COMMA: 44,
    CHAR_DOT: 46,
    CHAR_DOUBLE_QUOTE: 34,
    CHAR_EQUAL: 61,
    CHAR_EXCLAMATION_MARK: 33,
    CHAR_FORM_FEED: 12,
    CHAR_FORWARD_SLASH: 47,
    CHAR_GRAVE_ACCENT: 96,
    CHAR_HASH: 35,
    CHAR_HYPHEN_MINUS: 45,
    CHAR_LEFT_ANGLE_BRACKET: 60,
    CHAR_LEFT_CURLY_BRACE: 123,
    CHAR_LEFT_SQUARE_BRACKET: 91,
    CHAR_LINE_FEED: 10,
    CHAR_NO_BREAK_SPACE: 160,
    CHAR_PERCENT: 37,
    CHAR_PLUS: 43,
    CHAR_QUESTION_MARK: 63,
    CHAR_RIGHT_ANGLE_BRACKET: 62,
    CHAR_RIGHT_CURLY_BRACE: 125,
    CHAR_RIGHT_SQUARE_BRACKET: 93,
    CHAR_SEMICOLON: 59,
    CHAR_SINGLE_QUOTE: 39,
    CHAR_SPACE: 32,
    CHAR_TAB: 9,
    CHAR_UNDERSCORE: 95,
    CHAR_VERTICAL_LINE: 124,
    CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279,
    SEP: path$1.sep,
    extglobChars(chars2) {
      return {
        "!": { type: "negate", open: "(?:(?!(?:", close: `))${chars2.STAR})` },
        "?": { type: "qmark", open: "(?:", close: ")?" },
        "+": { type: "plus", open: "(?:", close: ")+" },
        "*": { type: "star", open: "(?:", close: ")*" },
        "@": { type: "at", open: "(?:", close: ")" }
      };
    },
    globChars(win3222) {
      return win3222 === true ? WINDOWS_CHARS : POSIX_CHARS;
    }
  };
  (function(exports) {
    const path32 = require$$0$1;
    const win3222 = process.platform === "win32";
    const {
      REGEX_BACKSLASH,
      REGEX_REMOVE_BACKSLASH,
      REGEX_SPECIAL_CHARS,
      REGEX_SPECIAL_CHARS_GLOBAL
    } = constants$2;
    exports.isObject = (val2) => val2 !== null && typeof val2 === "object" && !Array.isArray(val2);
    exports.hasRegexChars = (str) => REGEX_SPECIAL_CHARS.test(str);
    exports.isRegexChar = (str) => str.length === 1 && exports.hasRegexChars(str);
    exports.escapeRegex = (str) => str.replace(REGEX_SPECIAL_CHARS_GLOBAL, "\\$1");
    exports.toPosixSlashes = (str) => str.replace(REGEX_BACKSLASH, "/");
    exports.removeBackslashes = (str) => {
      return str.replace(REGEX_REMOVE_BACKSLASH, (match) => {
        return match === "\\" ? "" : match;
      });
    };
    exports.supportsLookbehinds = () => {
      const segs = process.version.slice(1).split(".").map(Number);
      if (segs.length === 3 && segs[0] >= 9 || segs[0] === 8 && segs[1] >= 10) {
        return true;
      }
      return false;
    };
    exports.isWindows = (options3) => {
      if (options3 && typeof options3.windows === "boolean") {
        return options3.windows;
      }
      return win3222 === true || path32.sep === "\\";
    };
    exports.escapeLast = (input, char, lastIdx) => {
      const idx = input.lastIndexOf(char, lastIdx);
      if (idx === -1)
        return input;
      if (input[idx - 1] === "\\")
        return exports.escapeLast(input, char, idx - 1);
      return `${input.slice(0, idx)}\\${input.slice(idx)}`;
    };
    exports.removePrefix = (input, state = {}) => {
      let output = input;
      if (output.startsWith("./")) {
        output = output.slice(2);
        state.prefix = "./";
      }
      return output;
    };
    exports.wrapOutput = (input, state = {}, options3 = {}) => {
      const prepend = options3.contains ? "" : "^";
      const append = options3.contains ? "" : "$";
      let output = `${prepend}(?:${input})${append}`;
      if (state.negated === true) {
        output = `(?:^(?!${output}).*$)`;
      }
      return output;
    };
  })(utils$3);
  utils$2 = utils$3;
  ({
    CHAR_ASTERISK,
    CHAR_AT,
    CHAR_BACKWARD_SLASH,
    CHAR_COMMA,
    CHAR_DOT,
    CHAR_EXCLAMATION_MARK,
    CHAR_FORWARD_SLASH,
    CHAR_LEFT_CURLY_BRACE,
    CHAR_LEFT_PARENTHESES,
    CHAR_LEFT_SQUARE_BRACKET,
    CHAR_PLUS,
    CHAR_QUESTION_MARK,
    CHAR_RIGHT_CURLY_BRACE,
    CHAR_RIGHT_PARENTHESES,
    CHAR_RIGHT_SQUARE_BRACKET
  } = constants$2);
  scan_1 = scan$1;
  constants$1 = constants$2;
  utils$1 = utils$3;
  ({
    MAX_LENGTH,
    POSIX_REGEX_SOURCE,
    REGEX_NON_SPECIAL_CHARS,
    REGEX_SPECIAL_CHARS_BACKREF,
    REPLACEMENTS
  } = constants$1);
  parse$2.fastpaths = (input, options3) => {
    const opts = { ...options3 };
    const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
    const len = input.length;
    if (len > max) {
      throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
    }
    input = REPLACEMENTS[input] || input;
    const win3222 = utils$1.isWindows(options3);
    const {
      DOT_LITERAL: DOT_LITERAL2,
      SLASH_LITERAL: SLASH_LITERAL2,
      ONE_CHAR: ONE_CHAR2,
      DOTS_SLASH: DOTS_SLASH2,
      NO_DOT: NO_DOT2,
      NO_DOTS: NO_DOTS2,
      NO_DOTS_SLASH: NO_DOTS_SLASH2,
      STAR: STAR2,
      START_ANCHOR: START_ANCHOR2
    } = constants$1.globChars(win3222);
    const nodot = opts.dot ? NO_DOTS2 : NO_DOT2;
    const slashDot = opts.dot ? NO_DOTS_SLASH2 : NO_DOT2;
    const capture = opts.capture ? "" : "?:";
    const state = { negated: false, prefix: "" };
    let star = opts.bash === true ? ".*?" : STAR2;
    if (opts.capture) {
      star = `(${star})`;
    }
    const globstar = (opts2) => {
      if (opts2.noglobstar === true)
        return star;
      return `(${capture}(?:(?!${START_ANCHOR2}${opts2.dot ? DOTS_SLASH2 : DOT_LITERAL2}).)*?)`;
    };
    const create = (str) => {
      switch (str) {
        case "*":
          return `${nodot}${ONE_CHAR2}${star}`;
        case ".*":
          return `${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        case "*.*":
          return `${nodot}${star}${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        case "*/*":
          return `${nodot}${star}${SLASH_LITERAL2}${ONE_CHAR2}${slashDot}${star}`;
        case "**":
          return nodot + globstar(opts);
        case "**/*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL2})?${slashDot}${ONE_CHAR2}${star}`;
        case "**/*.*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL2})?${slashDot}${star}${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        case "**/.*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL2})?${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        default: {
          const match = /^(.*?)\.(\w+)$/.exec(str);
          if (!match)
            return;
          const source2 = create(match[1]);
          if (!source2)
            return;
          return source2 + DOT_LITERAL2 + match[2];
        }
      }
    };
    const output = utils$1.removePrefix(input, state);
    let source = create(output);
    if (source && opts.strictSlashes !== true) {
      source += `${SLASH_LITERAL2}?`;
    }
    return source;
  };
  parse_1 = parse$2;
  path3 = require$$0$1;
  scan = scan_1;
  parse$1 = parse_1;
  utils5 = utils$3;
  constants = constants$2;
  picomatch$1.test = (input, regex22, options3, { glob, posix: posix22 } = {}) => {
    if (typeof input !== "string") {
      throw new TypeError("Expected input to be a string");
    }
    if (input === "") {
      return { isMatch: false, output: "" };
    }
    const opts = options3 || {};
    const format = opts.format || (posix22 ? utils5.toPosixSlashes : null);
    let match = input === glob;
    let output = match && format ? format(input) : input;
    if (match === false) {
      output = format ? format(input) : input;
      match = output === glob;
    }
    if (match === false || opts.capture === true) {
      if (opts.matchBase === true || opts.basename === true) {
        match = picomatch$1.matchBase(input, regex22, options3, posix22);
      } else {
        match = regex22.exec(output);
      }
    }
    return { isMatch: Boolean(match), match, output };
  };
  picomatch$1.matchBase = (input, glob, options3, posix22 = utils5.isWindows(options3)) => {
    const regex22 = glob instanceof RegExp ? glob : picomatch$1.makeRe(glob, options3);
    return regex22.test(path3.basename(input));
  };
  picomatch$1.isMatch = (str, patterns, options3) => picomatch$1(patterns, options3)(str);
  picomatch$1.parse = (pattern, options3) => {
    if (Array.isArray(pattern))
      return pattern.map((p32) => picomatch$1.parse(p32, options3));
    return parse$1(pattern, { ...options3, fastpaths: false });
  };
  picomatch$1.scan = (input, options3) => scan(input, options3);
  picomatch$1.compileRe = (state, options3, returnOutput = false, returnState = false) => {
    if (returnOutput === true) {
      return state.output;
    }
    const opts = options3 || {};
    const prepend = opts.contains ? "" : "^";
    const append = opts.contains ? "" : "$";
    let source = `${prepend}(?:${state.output})${append}`;
    if (state && state.negated === true) {
      source = `^(?!${source}).*$`;
    }
    const regex22 = picomatch$1.toRegex(source, options3);
    if (returnState === true) {
      regex22.state = state;
    }
    return regex22;
  };
  picomatch$1.makeRe = (input, options3 = {}, returnOutput = false, returnState = false) => {
    if (!input || typeof input !== "string") {
      throw new TypeError("Expected a non-empty string");
    }
    let parsed = { negated: false, fastpaths: true };
    if (options3.fastpaths !== false && (input[0] === "." || input[0] === "*")) {
      parsed.output = parse$1.fastpaths(input, options3);
    }
    if (!parsed.output) {
      parsed = parse$1(input, options3);
    }
    return picomatch$1.compileRe(parsed, options3, returnOutput, returnState);
  };
  picomatch$1.toRegex = (source, options3) => {
    try {
      const opts = options3 || {};
      return new RegExp(source, opts.flags || (opts.nocase ? "i" : ""));
    } catch (err22) {
      if (options3 && options3.debug === true)
        throw err22;
      return /$^/;
    }
  };
  picomatch$1.constants = constants;
  forbiddenIdentifiers = new Set(`${reservedWords$1} ${builtins}`.split(" "));
  forbiddenIdentifiers.add("");
  UNDEFINED_EXPRESSION = new class UndefinedExpression extends ExpressionEntity {
    getLiteralValueAtPath() {
      return;
    }
  };
  returnsUnknown = {
    value: {
      hasEffectsWhenCalled: null,
      returns: UNKNOWN_EXPRESSION
    }
  };
  UNKNOWN_LITERAL_BOOLEAN = new class UnknownBoolean extends ExpressionEntity {
    getReturnExpressionWhenCalledAtPath(path42) {
      if (path42.length === 1) {
        return getMemberReturnExpressionWhenCalled(literalBooleanMembers, path42[0]);
      }
      return UNKNOWN_RETURN_EXPRESSION;
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      if (interaction.type === INTERACTION_ACCESSED) {
        return path42.length > 1;
      }
      if (interaction.type === INTERACTION_CALLED && path42.length === 1) {
        return hasMemberEffectWhenCalled(literalBooleanMembers, path42[0], interaction, context);
      }
      return true;
    }
  };
  returnsBoolean = {
    value: {
      hasEffectsWhenCalled: null,
      returns: UNKNOWN_LITERAL_BOOLEAN
    }
  };
  UNKNOWN_LITERAL_NUMBER = new class UnknownNumber extends ExpressionEntity {
    getReturnExpressionWhenCalledAtPath(path42) {
      if (path42.length === 1) {
        return getMemberReturnExpressionWhenCalled(literalNumberMembers, path42[0]);
      }
      return UNKNOWN_RETURN_EXPRESSION;
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      if (interaction.type === INTERACTION_ACCESSED) {
        return path42.length > 1;
      }
      if (interaction.type === INTERACTION_CALLED && path42.length === 1) {
        return hasMemberEffectWhenCalled(literalNumberMembers, path42[0], interaction, context);
      }
      return true;
    }
  };
  returnsNumber = {
    value: {
      hasEffectsWhenCalled: null,
      returns: UNKNOWN_LITERAL_NUMBER
    }
  };
  UNKNOWN_LITERAL_STRING = new class UnknownString extends ExpressionEntity {
    getReturnExpressionWhenCalledAtPath(path42) {
      if (path42.length === 1) {
        return getMemberReturnExpressionWhenCalled(literalStringMembers, path42[0]);
      }
      return UNKNOWN_RETURN_EXPRESSION;
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      if (interaction.type === INTERACTION_ACCESSED) {
        return path42.length > 1;
      }
      if (interaction.type === INTERACTION_CALLED && path42.length === 1) {
        return hasMemberEffectWhenCalled(literalStringMembers, path42[0], interaction, context);
      }
      return true;
    }
  };
  returnsString = {
    value: {
      hasEffectsWhenCalled: null,
      returns: UNKNOWN_LITERAL_STRING
    }
  };
  stringReplace = {
    value: {
      hasEffectsWhenCalled({ args }, context) {
        const argument1 = args[2];
        return args.length < 3 || typeof argument1.getLiteralValueAtPath(EMPTY_PATH, SHARED_RECURSION_TRACKER, {
          deoptimizeCache() {
          }
        }) === "symbol" && argument1.hasEffectsOnInteractionAtPath(EMPTY_PATH, NODE_INTERACTION_UNKNOWN_CALL, context);
      },
      returns: UNKNOWN_LITERAL_STRING
    }
  };
  objectMembers = assembleMemberDescriptions({
    hasOwnProperty: returnsBoolean,
    isPrototypeOf: returnsBoolean,
    propertyIsEnumerable: returnsBoolean,
    toLocaleString: returnsString,
    toString: returnsString,
    valueOf: returnsUnknown
  });
  literalBooleanMembers = assembleMemberDescriptions({
    valueOf: returnsBoolean
  }, objectMembers);
  literalNumberMembers = assembleMemberDescriptions({
    toExponential: returnsString,
    toFixed: returnsString,
    toLocaleString: returnsString,
    toPrecision: returnsString,
    valueOf: returnsNumber
  }, objectMembers);
  literalRegExpMembers = assembleMemberDescriptions({
    exec: returnsUnknown,
    test: returnsBoolean
  }, objectMembers);
  literalStringMembers = assembleMemberDescriptions({
    anchor: returnsString,
    at: returnsUnknown,
    big: returnsString,
    blink: returnsString,
    bold: returnsString,
    charAt: returnsString,
    charCodeAt: returnsNumber,
    codePointAt: returnsUnknown,
    concat: returnsString,
    endsWith: returnsBoolean,
    fixed: returnsString,
    fontcolor: returnsString,
    fontsize: returnsString,
    includes: returnsBoolean,
    indexOf: returnsNumber,
    italics: returnsString,
    lastIndexOf: returnsNumber,
    link: returnsString,
    localeCompare: returnsNumber,
    match: returnsUnknown,
    matchAll: returnsUnknown,
    normalize: returnsString,
    padEnd: returnsString,
    padStart: returnsString,
    repeat: returnsString,
    replace: stringReplace,
    replaceAll: stringReplace,
    search: returnsNumber,
    slice: returnsString,
    small: returnsString,
    split: returnsUnknown,
    startsWith: returnsBoolean,
    strike: returnsString,
    sub: returnsString,
    substr: returnsString,
    substring: returnsString,
    sup: returnsString,
    toLocaleLowerCase: returnsString,
    toLocaleUpperCase: returnsString,
    toLowerCase: returnsString,
    toString: returnsString,
    toUpperCase: returnsString,
    trim: returnsString,
    trimEnd: returnsString,
    trimLeft: returnsString,
    trimRight: returnsString,
    trimStart: returnsString,
    valueOf: returnsString
  }, objectMembers);
  base$1 = {};
  base$1.Program = base$1.BlockStatement = base$1.StaticBlock = function(node, st, c22) {
    for (var i2 = 0, list2 = node.body;i2 < list2.length; i2 += 1) {
      var stmt = list2[i2];
      c22(stmt, st, "Statement");
    }
  };
  base$1.Statement = skipThrough;
  base$1.EmptyStatement = ignore;
  base$1.ExpressionStatement = base$1.ParenthesizedExpression = base$1.ChainExpression = function(node, st, c22) {
    return c22(node.expression, st, "Expression");
  };
  base$1.IfStatement = function(node, st, c22) {
    c22(node.test, st, "Expression");
    c22(node.consequent, st, "Statement");
    if (node.alternate) {
      c22(node.alternate, st, "Statement");
    }
  };
  base$1.LabeledStatement = function(node, st, c22) {
    return c22(node.body, st, "Statement");
  };
  base$1.BreakStatement = base$1.ContinueStatement = ignore;
  base$1.WithStatement = function(node, st, c22) {
    c22(node.object, st, "Expression");
    c22(node.body, st, "Statement");
  };
  base$1.SwitchStatement = function(node, st, c22) {
    c22(node.discriminant, st, "Expression");
    for (var i$1 = 0, list$1 = node.cases;i$1 < list$1.length; i$1 += 1) {
      var cs = list$1[i$1];
      if (cs.test) {
        c22(cs.test, st, "Expression");
      }
      for (var i2 = 0, list2 = cs.consequent;i2 < list2.length; i2 += 1) {
        var cons = list2[i2];
        c22(cons, st, "Statement");
      }
    }
  };
  base$1.SwitchCase = function(node, st, c22) {
    if (node.test) {
      c22(node.test, st, "Expression");
    }
    for (var i2 = 0, list2 = node.consequent;i2 < list2.length; i2 += 1) {
      var cons = list2[i2];
      c22(cons, st, "Statement");
    }
  };
  base$1.ReturnStatement = base$1.YieldExpression = base$1.AwaitExpression = function(node, st, c22) {
    if (node.argument) {
      c22(node.argument, st, "Expression");
    }
  };
  base$1.ThrowStatement = base$1.SpreadElement = function(node, st, c22) {
    return c22(node.argument, st, "Expression");
  };
  base$1.TryStatement = function(node, st, c22) {
    c22(node.block, st, "Statement");
    if (node.handler) {
      c22(node.handler, st);
    }
    if (node.finalizer) {
      c22(node.finalizer, st, "Statement");
    }
  };
  base$1.CatchClause = function(node, st, c22) {
    if (node.param) {
      c22(node.param, st, "Pattern");
    }
    c22(node.body, st, "Statement");
  };
  base$1.WhileStatement = base$1.DoWhileStatement = function(node, st, c22) {
    c22(node.test, st, "Expression");
    c22(node.body, st, "Statement");
  };
  base$1.ForStatement = function(node, st, c22) {
    if (node.init) {
      c22(node.init, st, "ForInit");
    }
    if (node.test) {
      c22(node.test, st, "Expression");
    }
    if (node.update) {
      c22(node.update, st, "Expression");
    }
    c22(node.body, st, "Statement");
  };
  base$1.ForInStatement = base$1.ForOfStatement = function(node, st, c22) {
    c22(node.left, st, "ForInit");
    c22(node.right, st, "Expression");
    c22(node.body, st, "Statement");
  };
  base$1.ForInit = function(node, st, c22) {
    if (node.type === "VariableDeclaration") {
      c22(node, st);
    } else {
      c22(node, st, "Expression");
    }
  };
  base$1.DebuggerStatement = ignore;
  base$1.FunctionDeclaration = function(node, st, c22) {
    return c22(node, st, "Function");
  };
  base$1.VariableDeclaration = function(node, st, c22) {
    for (var i2 = 0, list2 = node.declarations;i2 < list2.length; i2 += 1) {
      var decl = list2[i2];
      c22(decl, st);
    }
  };
  base$1.VariableDeclarator = function(node, st, c22) {
    c22(node.id, st, "Pattern");
    if (node.init) {
      c22(node.init, st, "Expression");
    }
  };
  base$1.Function = function(node, st, c22) {
    if (node.id) {
      c22(node.id, st, "Pattern");
    }
    for (var i2 = 0, list2 = node.params;i2 < list2.length; i2 += 1) {
      var param = list2[i2];
      c22(param, st, "Pattern");
    }
    c22(node.body, st, node.expression ? "Expression" : "Statement");
  };
  base$1.Pattern = function(node, st, c22) {
    if (node.type === "Identifier") {
      c22(node, st, "VariablePattern");
    } else if (node.type === "MemberExpression") {
      c22(node, st, "MemberPattern");
    } else {
      c22(node, st);
    }
  };
  base$1.VariablePattern = ignore;
  base$1.MemberPattern = skipThrough;
  base$1.RestElement = function(node, st, c22) {
    return c22(node.argument, st, "Pattern");
  };
  base$1.ArrayPattern = function(node, st, c22) {
    for (var i2 = 0, list2 = node.elements;i2 < list2.length; i2 += 1) {
      var elt = list2[i2];
      if (elt) {
        c22(elt, st, "Pattern");
      }
    }
  };
  base$1.ObjectPattern = function(node, st, c22) {
    for (var i2 = 0, list2 = node.properties;i2 < list2.length; i2 += 1) {
      var prop = list2[i2];
      if (prop.type === "Property") {
        if (prop.computed) {
          c22(prop.key, st, "Expression");
        }
        c22(prop.value, st, "Pattern");
      } else if (prop.type === "RestElement") {
        c22(prop.argument, st, "Pattern");
      }
    }
  };
  base$1.Expression = skipThrough;
  base$1.ThisExpression = base$1.Super = base$1.MetaProperty = ignore;
  base$1.ArrayExpression = function(node, st, c22) {
    for (var i2 = 0, list2 = node.elements;i2 < list2.length; i2 += 1) {
      var elt = list2[i2];
      if (elt) {
        c22(elt, st, "Expression");
      }
    }
  };
  base$1.ObjectExpression = function(node, st, c22) {
    for (var i2 = 0, list2 = node.properties;i2 < list2.length; i2 += 1) {
      var prop = list2[i2];
      c22(prop, st);
    }
  };
  base$1.FunctionExpression = base$1.ArrowFunctionExpression = base$1.FunctionDeclaration;
  base$1.SequenceExpression = function(node, st, c22) {
    for (var i2 = 0, list2 = node.expressions;i2 < list2.length; i2 += 1) {
      var expr = list2[i2];
      c22(expr, st, "Expression");
    }
  };
  base$1.TemplateLiteral = function(node, st, c22) {
    for (var i2 = 0, list2 = node.quasis;i2 < list2.length; i2 += 1) {
      var quasi = list2[i2];
      c22(quasi, st);
    }
    for (var i$1 = 0, list$1 = node.expressions;i$1 < list$1.length; i$1 += 1) {
      var expr = list$1[i$1];
      c22(expr, st, "Expression");
    }
  };
  base$1.TemplateElement = ignore;
  base$1.UnaryExpression = base$1.UpdateExpression = function(node, st, c22) {
    c22(node.argument, st, "Expression");
  };
  base$1.BinaryExpression = base$1.LogicalExpression = function(node, st, c22) {
    c22(node.left, st, "Expression");
    c22(node.right, st, "Expression");
  };
  base$1.AssignmentExpression = base$1.AssignmentPattern = function(node, st, c22) {
    c22(node.left, st, "Pattern");
    c22(node.right, st, "Expression");
  };
  base$1.ConditionalExpression = function(node, st, c22) {
    c22(node.test, st, "Expression");
    c22(node.consequent, st, "Expression");
    c22(node.alternate, st, "Expression");
  };
  base$1.NewExpression = base$1.CallExpression = function(node, st, c22) {
    c22(node.callee, st, "Expression");
    if (node.arguments) {
      for (var i2 = 0, list2 = node.arguments;i2 < list2.length; i2 += 1) {
        var arg = list2[i2];
        c22(arg, st, "Expression");
      }
    }
  };
  base$1.MemberExpression = function(node, st, c22) {
    c22(node.object, st, "Expression");
    if (node.computed) {
      c22(node.property, st, "Expression");
    }
  };
  base$1.ExportNamedDeclaration = base$1.ExportDefaultDeclaration = function(node, st, c22) {
    if (node.declaration) {
      c22(node.declaration, st, node.type === "ExportNamedDeclaration" || node.declaration.id ? "Statement" : "Expression");
    }
    if (node.source) {
      c22(node.source, st, "Expression");
    }
  };
  base$1.ExportAllDeclaration = function(node, st, c22) {
    if (node.exported) {
      c22(node.exported, st);
    }
    c22(node.source, st, "Expression");
  };
  base$1.ImportDeclaration = function(node, st, c22) {
    for (var i2 = 0, list2 = node.specifiers;i2 < list2.length; i2 += 1) {
      var spec = list2[i2];
      c22(spec, st);
    }
    c22(node.source, st, "Expression");
  };
  base$1.ImportExpression = function(node, st, c22) {
    c22(node.source, st, "Expression");
  };
  base$1.ImportSpecifier = base$1.ImportDefaultSpecifier = base$1.ImportNamespaceSpecifier = base$1.Identifier = base$1.PrivateIdentifier = base$1.Literal = ignore;
  base$1.TaggedTemplateExpression = function(node, st, c22) {
    c22(node.tag, st, "Expression");
    c22(node.quasi, st, "Expression");
  };
  base$1.ClassDeclaration = base$1.ClassExpression = function(node, st, c22) {
    return c22(node, st, "Class");
  };
  base$1.Class = function(node, st, c22) {
    if (node.id) {
      c22(node.id, st, "Pattern");
    }
    if (node.superClass) {
      c22(node.superClass, st, "Expression");
    }
    c22(node.body, st);
  };
  base$1.ClassBody = function(node, st, c22) {
    for (var i2 = 0, list2 = node.body;i2 < list2.length; i2 += 1) {
      var elt = list2[i2];
      c22(elt, st);
    }
  };
  base$1.MethodDefinition = base$1.PropertyDefinition = base$1.Property = function(node, st, c22) {
    if (node.computed) {
      c22(node.key, st, "Expression");
    }
    if (node.value) {
      c22(node.value, st, "Expression");
    }
  };
  SOURCEMAPPING_URL += "ppingURL";
  SOURCEMAPPING_URL_RE = new RegExp(`^#${whiteSpaceNoNewline}+${SOURCEMAPPING_URL}=.+`);
  keys = {
    ImportExpression: ["arguments"],
    Literal: [],
    Program: ["body"]
  };
  NodeBase = class NodeBase2 extends ExpressionEntity {
    constructor(esTreeNode, parent, parentScope, keepEsTreeNode = false) {
      super();
      this.deoptimized = false;
      this.esTreeNode = keepEsTreeNode ? esTreeNode : null;
      this.keys = keys[esTreeNode.type] || getAndCreateKeys(esTreeNode);
      this.parent = parent;
      this.context = parent.context;
      this.createScope(parentScope);
      this.parseNode(esTreeNode);
      this.initialise();
      this.context.magicString.addSourcemapLocation(this.start);
      this.context.magicString.addSourcemapLocation(this.end);
    }
    addExportedVariables(_variables, _exportNamesByVariable) {
    }
    bind() {
      for (const key of this.keys) {
        const value = this[key];
        if (Array.isArray(value)) {
          for (const child of value) {
            child?.bind();
          }
        } else if (value) {
          value.bind();
        }
      }
    }
    createScope(parentScope) {
      this.scope = parentScope;
    }
    hasEffects(context) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      for (const key of this.keys) {
        const value = this[key];
        if (value === null)
          continue;
        if (Array.isArray(value)) {
          for (const child of value) {
            if (child?.hasEffects(context))
              return true;
          }
        } else if (value.hasEffects(context))
          return true;
      }
      return false;
    }
    hasEffectsAsAssignmentTarget(context, _checkAccess) {
      return this.hasEffects(context) || this.hasEffectsOnInteractionAtPath(EMPTY_PATH, this.assignmentInteraction, context);
    }
    include(context, includeChildrenRecursively, _options) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      this.included = true;
      for (const key of this.keys) {
        const value = this[key];
        if (value === null)
          continue;
        if (Array.isArray(value)) {
          for (const child of value) {
            child?.include(context, includeChildrenRecursively);
          }
        } else {
          value.include(context, includeChildrenRecursively);
        }
      }
    }
    includeAsAssignmentTarget(context, includeChildrenRecursively, _deoptimizeAccess) {
      this.include(context, includeChildrenRecursively);
    }
    initialise() {
    }
    insertSemicolon(code) {
      if (code.original[this.end - 1] !== ";") {
        code.appendLeft(this.end, ";");
      }
    }
    parseNode(esTreeNode, keepEsTreeNodeKeys) {
      for (const [key, value] of Object.entries(esTreeNode)) {
        if (this.hasOwnProperty(key))
          continue;
        if (key.charCodeAt(0) === 95) {
          if (key === ANNOTATION_KEY) {
            const annotations = value;
            this.annotations = annotations;
            if (this.context.options.treeshake.annotations) {
              this.annotationNoSideEffects = annotations.some((comment) => comment.annotationType === "noSideEffects");
              this.annotationPure = annotations.some((comment) => comment.annotationType === "pure");
            }
          } else if (key === INVALID_COMMENT_KEY) {
            for (const { start, end } of value)
              this.context.magicString.remove(start, end);
          }
        } else if (typeof value !== "object" || value === null) {
          this[key] = value;
        } else if (Array.isArray(value)) {
          this[key] = [];
          for (const child of value) {
            this[key].push(child === null ? null : new (this.context.getNodeConstructor(child.type))(child, this, this.scope, keepEsTreeNodeKeys?.includes(key)));
          }
        } else {
          this[key] = new (this.context.getNodeConstructor(value.type))(value, this, this.scope, keepEsTreeNodeKeys?.includes(key));
        }
      }
    }
    render(code, options3) {
      for (const key of this.keys) {
        const value = this[key];
        if (value === null)
          continue;
        if (Array.isArray(value)) {
          for (const child of value) {
            child?.render(code, options3);
          }
        } else {
          value.render(code, options3);
        }
      }
    }
    setAssignedValue(value) {
      this.assignmentInteraction = { args: [null, value], type: INTERACTION_ASSIGNED };
    }
    shouldBeIncluded(context) {
      return this.included || !context.brokenFlow && this.hasEffects(createHasEffectsContext());
    }
    applyDeoptimizations() {
      this.deoptimized = true;
      for (const key of this.keys) {
        const value = this[key];
        if (value === null)
          continue;
        if (Array.isArray(value)) {
          for (const child of value) {
            child?.deoptimizePath(UNKNOWN_PATH);
          }
        } else {
          value.deoptimizePath(UNKNOWN_PATH);
        }
      }
      this.context.requestTreeshakingPass();
    }
  };
  SpreadElement = class SpreadElement2 extends NodeBase {
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      if (path42.length > 0) {
        this.argument.deoptimizeArgumentsOnInteractionAtPath(interaction, [UnknownKey, ...path42], recursionTracker);
      }
    }
    hasEffects(context) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      const { propertyReadSideEffects } = this.context.options.treeshake;
      return this.argument.hasEffects(context) || propertyReadSideEffects && (propertyReadSideEffects === "always" || this.argument.hasEffectsOnInteractionAtPath(UNKNOWN_PATH, NODE_INTERACTION_UNKNOWN_ACCESS, context));
    }
    applyDeoptimizations() {
      this.deoptimized = true;
      this.argument.deoptimizePath([UnknownKey, UnknownKey]);
      this.context.requestTreeshakingPass();
    }
  };
  Method = class Method2 extends ExpressionEntity {
    constructor(description) {
      super();
      this.description = description;
    }
    deoptimizeArgumentsOnInteractionAtPath({ args, type }, path42) {
      if (type === INTERACTION_CALLED && path42.length === 0 && this.description.mutatesSelfAsArray) {
        args[0]?.deoptimizePath(UNKNOWN_INTEGER_PATH);
      }
    }
    getReturnExpressionWhenCalledAtPath(path42, { args }) {
      if (path42.length > 0) {
        return UNKNOWN_RETURN_EXPRESSION;
      }
      return [
        this.description.returnsPrimitive || (this.description.returns === "self" ? args[0] || UNKNOWN_EXPRESSION : this.description.returns()),
        false
      ];
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      const { type } = interaction;
      if (path42.length > (type === INTERACTION_ACCESSED ? 1 : 0)) {
        return true;
      }
      if (type === INTERACTION_CALLED) {
        const { args } = interaction;
        if (this.description.mutatesSelfAsArray === true && args[0]?.hasEffectsOnInteractionAtPath(UNKNOWN_INTEGER_PATH, NODE_INTERACTION_UNKNOWN_ASSIGNMENT, context)) {
          return true;
        }
        if (this.description.callsArgs) {
          for (const argumentIndex of this.description.callsArgs) {
            if (args[argumentIndex + 1]?.hasEffectsOnInteractionAtPath(EMPTY_PATH, NODE_INTERACTION_UNKNOWN_CALL, context)) {
              return true;
            }
          }
        }
      }
      return false;
    }
  };
  METHOD_RETURNS_BOOLEAN = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: false,
      returns: null,
      returnsPrimitive: UNKNOWN_LITERAL_BOOLEAN
    })
  ];
  METHOD_RETURNS_STRING = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: false,
      returns: null,
      returnsPrimitive: UNKNOWN_LITERAL_STRING
    })
  ];
  METHOD_RETURNS_NUMBER = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: false,
      returns: null,
      returnsPrimitive: UNKNOWN_LITERAL_NUMBER
    })
  ];
  METHOD_RETURNS_UNKNOWN = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: false,
      returns: null,
      returnsPrimitive: UNKNOWN_EXPRESSION
    })
  ];
  INTEGER_REG_EXP = /^\d+$/;
  ObjectEntity = class ObjectEntity2 extends ExpressionEntity {
    constructor(properties, prototypeExpression, immutable = false) {
      super();
      this.prototypeExpression = prototypeExpression;
      this.immutable = immutable;
      this.additionalExpressionsToBeDeoptimized = new Set;
      this.allProperties = [];
      this.deoptimizedPaths = Object.create(null);
      this.expressionsToBeDeoptimizedByKey = Object.create(null);
      this.gettersByKey = Object.create(null);
      this.hasLostTrack = false;
      this.hasUnknownDeoptimizedInteger = false;
      this.hasUnknownDeoptimizedProperty = false;
      this.propertiesAndGettersByKey = Object.create(null);
      this.propertiesAndSettersByKey = Object.create(null);
      this.settersByKey = Object.create(null);
      this.unknownIntegerProps = [];
      this.unmatchableGetters = [];
      this.unmatchablePropertiesAndGetters = [];
      this.unmatchableSetters = [];
      if (Array.isArray(properties)) {
        this.buildPropertyMaps(properties);
      } else {
        this.propertiesAndGettersByKey = this.propertiesAndSettersByKey = properties;
        for (const propertiesForKey of Object.values(properties)) {
          this.allProperties.push(...propertiesForKey);
        }
      }
    }
    deoptimizeAllProperties(noAccessors) {
      const isDeoptimized = this.hasLostTrack || this.hasUnknownDeoptimizedProperty;
      if (noAccessors) {
        this.hasUnknownDeoptimizedProperty = true;
      } else {
        this.hasLostTrack = true;
      }
      if (isDeoptimized) {
        return;
      }
      for (const properties of [
        ...Object.values(this.propertiesAndGettersByKey),
        ...Object.values(this.settersByKey)
      ]) {
        for (const property of properties) {
          property.deoptimizePath(UNKNOWN_PATH);
        }
      }
      this.prototypeExpression?.deoptimizePath([UnknownKey, UnknownKey]);
      this.deoptimizeCachedEntities();
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      const [key, ...subPath] = path42;
      const { args, type } = interaction;
      if (this.hasLostTrack || (type === INTERACTION_CALLED || path42.length > 1) && (this.hasUnknownDeoptimizedProperty || typeof key === "string" && this.deoptimizedPaths[key])) {
        deoptimizeInteraction(interaction);
        return;
      }
      const [propertiesForExactMatchByKey, relevantPropertiesByKey, relevantUnmatchableProperties] = type === INTERACTION_CALLED || path42.length > 1 ? [
        this.propertiesAndGettersByKey,
        this.propertiesAndGettersByKey,
        this.unmatchablePropertiesAndGetters
      ] : type === INTERACTION_ACCESSED ? [this.propertiesAndGettersByKey, this.gettersByKey, this.unmatchableGetters] : [this.propertiesAndSettersByKey, this.settersByKey, this.unmatchableSetters];
      if (typeof key === "string") {
        if (propertiesForExactMatchByKey[key]) {
          const properties = relevantPropertiesByKey[key];
          if (properties) {
            for (const property of properties) {
              property.deoptimizeArgumentsOnInteractionAtPath(interaction, subPath, recursionTracker);
            }
          }
          if (!this.immutable) {
            for (const argument of args) {
              if (argument) {
                this.additionalExpressionsToBeDeoptimized.add(argument);
              }
            }
          }
          return;
        }
        for (const property of relevantUnmatchableProperties) {
          property.deoptimizeArgumentsOnInteractionAtPath(interaction, subPath, recursionTracker);
        }
        if (INTEGER_REG_EXP.test(key)) {
          for (const property of this.unknownIntegerProps) {
            property.deoptimizeArgumentsOnInteractionAtPath(interaction, subPath, recursionTracker);
          }
        }
      } else {
        for (const properties of [
          ...Object.values(relevantPropertiesByKey),
          relevantUnmatchableProperties
        ]) {
          for (const property of properties) {
            property.deoptimizeArgumentsOnInteractionAtPath(interaction, subPath, recursionTracker);
          }
        }
        for (const property of this.unknownIntegerProps) {
          property.deoptimizeArgumentsOnInteractionAtPath(interaction, subPath, recursionTracker);
        }
      }
      if (!this.immutable) {
        for (const argument of args) {
          if (argument) {
            this.additionalExpressionsToBeDeoptimized.add(argument);
          }
        }
      }
      this.prototypeExpression?.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
    }
    deoptimizeIntegerProperties() {
      if (this.hasLostTrack || this.hasUnknownDeoptimizedProperty || this.hasUnknownDeoptimizedInteger) {
        return;
      }
      this.hasUnknownDeoptimizedInteger = true;
      for (const [key, propertiesAndGetters] of Object.entries(this.propertiesAndGettersByKey)) {
        if (INTEGER_REG_EXP.test(key)) {
          for (const property of propertiesAndGetters) {
            property.deoptimizePath(UNKNOWN_PATH);
          }
        }
      }
      this.deoptimizeCachedIntegerEntities();
    }
    deoptimizePath(path42) {
      if (this.hasLostTrack || this.immutable) {
        return;
      }
      const key = path42[0];
      if (path42.length === 1) {
        if (typeof key !== "string") {
          if (key === UnknownInteger) {
            return this.deoptimizeIntegerProperties();
          }
          return this.deoptimizeAllProperties(key === UnknownNonAccessorKey);
        }
        if (!this.deoptimizedPaths[key]) {
          this.deoptimizedPaths[key] = true;
          const expressionsToBeDeoptimized = this.expressionsToBeDeoptimizedByKey[key];
          if (expressionsToBeDeoptimized) {
            for (const expression of expressionsToBeDeoptimized) {
              expression.deoptimizeCache();
            }
          }
        }
      }
      const subPath = path42.length === 1 ? UNKNOWN_PATH : path42.slice(1);
      for (const property of typeof key === "string" ? [
        ...this.propertiesAndGettersByKey[key] || this.unmatchablePropertiesAndGetters,
        ...this.settersByKey[key] || this.unmatchableSetters
      ] : this.allProperties) {
        property.deoptimizePath(subPath);
      }
      this.prototypeExpression?.deoptimizePath(path42.length === 1 ? [...path42, UnknownKey] : path42);
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      if (path42.length === 0) {
        return UnknownTruthyValue;
      }
      const key = path42[0];
      const expressionAtPath = this.getMemberExpressionAndTrackDeopt(key, origin);
      if (expressionAtPath) {
        return expressionAtPath.getLiteralValueAtPath(path42.slice(1), recursionTracker, origin);
      }
      if (this.prototypeExpression) {
        return this.prototypeExpression.getLiteralValueAtPath(path42, recursionTracker, origin);
      }
      if (path42.length === 1) {
        return;
      }
      return UnknownValue;
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      if (path42.length === 0) {
        return UNKNOWN_RETURN_EXPRESSION;
      }
      const [key, ...subPath] = path42;
      const expressionAtPath = this.getMemberExpressionAndTrackDeopt(key, origin);
      if (expressionAtPath) {
        return expressionAtPath.getReturnExpressionWhenCalledAtPath(subPath, interaction, recursionTracker, origin);
      }
      if (this.prototypeExpression) {
        return this.prototypeExpression.getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin);
      }
      return UNKNOWN_RETURN_EXPRESSION;
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      const [key, ...subPath] = path42;
      if (subPath.length > 0 || interaction.type === INTERACTION_CALLED) {
        const expressionAtPath = this.getMemberExpression(key);
        if (expressionAtPath) {
          return expressionAtPath.hasEffectsOnInteractionAtPath(subPath, interaction, context);
        }
        if (this.prototypeExpression) {
          return this.prototypeExpression.hasEffectsOnInteractionAtPath(path42, interaction, context);
        }
        return true;
      }
      if (key === UnknownNonAccessorKey)
        return false;
      if (this.hasLostTrack)
        return true;
      const [propertiesAndAccessorsByKey, accessorsByKey, unmatchableAccessors] = interaction.type === INTERACTION_ACCESSED ? [this.propertiesAndGettersByKey, this.gettersByKey, this.unmatchableGetters] : [this.propertiesAndSettersByKey, this.settersByKey, this.unmatchableSetters];
      if (typeof key === "string") {
        if (propertiesAndAccessorsByKey[key]) {
          const accessors = accessorsByKey[key];
          if (accessors) {
            for (const accessor of accessors) {
              if (accessor.hasEffectsOnInteractionAtPath(subPath, interaction, context))
                return true;
            }
          }
          return false;
        }
        for (const accessor of unmatchableAccessors) {
          if (accessor.hasEffectsOnInteractionAtPath(subPath, interaction, context)) {
            return true;
          }
        }
      } else {
        for (const accessors of [...Object.values(accessorsByKey), unmatchableAccessors]) {
          for (const accessor of accessors) {
            if (accessor.hasEffectsOnInteractionAtPath(subPath, interaction, context))
              return true;
          }
        }
      }
      if (this.prototypeExpression) {
        return this.prototypeExpression.hasEffectsOnInteractionAtPath(path42, interaction, context);
      }
      return false;
    }
    buildPropertyMaps(properties) {
      const { allProperties, propertiesAndGettersByKey, propertiesAndSettersByKey, settersByKey, gettersByKey, unknownIntegerProps, unmatchablePropertiesAndGetters, unmatchableGetters, unmatchableSetters } = this;
      const unmatchablePropertiesAndSetters = [];
      for (let index = properties.length - 1;index >= 0; index--) {
        const { key, kind, property } = properties[index];
        allProperties.push(property);
        if (typeof key === "string") {
          if (kind === "set") {
            if (!propertiesAndSettersByKey[key]) {
              propertiesAndSettersByKey[key] = [property, ...unmatchablePropertiesAndSetters];
              settersByKey[key] = [property, ...unmatchableSetters];
            }
          } else if (kind === "get") {
            if (!propertiesAndGettersByKey[key]) {
              propertiesAndGettersByKey[key] = [property, ...unmatchablePropertiesAndGetters];
              gettersByKey[key] = [property, ...unmatchableGetters];
            }
          } else {
            if (!propertiesAndSettersByKey[key]) {
              propertiesAndSettersByKey[key] = [property, ...unmatchablePropertiesAndSetters];
            }
            if (!propertiesAndGettersByKey[key]) {
              propertiesAndGettersByKey[key] = [property, ...unmatchablePropertiesAndGetters];
            }
          }
        } else {
          if (key === UnknownInteger) {
            unknownIntegerProps.push(property);
            continue;
          }
          if (kind === "set")
            unmatchableSetters.push(property);
          if (kind === "get")
            unmatchableGetters.push(property);
          if (kind !== "get")
            unmatchablePropertiesAndSetters.push(property);
          if (kind !== "set")
            unmatchablePropertiesAndGetters.push(property);
        }
      }
    }
    deoptimizeCachedEntities() {
      for (const expressionsToBeDeoptimized of Object.values(this.expressionsToBeDeoptimizedByKey)) {
        for (const expression of expressionsToBeDeoptimized) {
          expression.deoptimizeCache();
        }
      }
      for (const expression of this.additionalExpressionsToBeDeoptimized) {
        expression.deoptimizePath(UNKNOWN_PATH);
      }
    }
    deoptimizeCachedIntegerEntities() {
      for (const [key, expressionsToBeDeoptimized] of Object.entries(this.expressionsToBeDeoptimizedByKey)) {
        if (INTEGER_REG_EXP.test(key)) {
          for (const expression of expressionsToBeDeoptimized) {
            expression.deoptimizeCache();
          }
        }
      }
      for (const expression of this.additionalExpressionsToBeDeoptimized) {
        expression.deoptimizePath(UNKNOWN_INTEGER_PATH);
      }
    }
    getMemberExpression(key) {
      if (this.hasLostTrack || this.hasUnknownDeoptimizedProperty || typeof key !== "string" || this.hasUnknownDeoptimizedInteger && INTEGER_REG_EXP.test(key) || this.deoptimizedPaths[key]) {
        return UNKNOWN_EXPRESSION;
      }
      const properties = this.propertiesAndGettersByKey[key];
      if (properties?.length === 1) {
        return properties[0];
      }
      if (properties || this.unmatchablePropertiesAndGetters.length > 0 || this.unknownIntegerProps.length > 0 && INTEGER_REG_EXP.test(key)) {
        return UNKNOWN_EXPRESSION;
      }
      return null;
    }
    getMemberExpressionAndTrackDeopt(key, origin) {
      if (typeof key !== "string") {
        return UNKNOWN_EXPRESSION;
      }
      const expression = this.getMemberExpression(key);
      if (!(expression === UNKNOWN_EXPRESSION || this.immutable)) {
        const expressionsToBeDeoptimized = this.expressionsToBeDeoptimizedByKey[key] = this.expressionsToBeDeoptimizedByKey[key] || [];
        expressionsToBeDeoptimized.push(origin);
      }
      return expression;
    }
  };
  OBJECT_PROTOTYPE_FALLBACK = new class ObjectPrototypeFallbackExpression extends ExpressionEntity {
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42) {
      if (interaction.type === INTERACTION_CALLED && path42.length === 1 && !isInteger(path42[0])) {
        deoptimizeInteraction(interaction);
      }
    }
    getLiteralValueAtPath(path42) {
      return path42.length === 1 && isInteger(path42[0]) ? undefined : UnknownValue;
    }
    hasEffectsOnInteractionAtPath(path42, { type }) {
      return path42.length > 1 || type === INTERACTION_CALLED;
    }
  };
  OBJECT_PROTOTYPE = new ObjectEntity({
    __proto__: null,
    hasOwnProperty: METHOD_RETURNS_BOOLEAN,
    isPrototypeOf: METHOD_RETURNS_BOOLEAN,
    propertyIsEnumerable: METHOD_RETURNS_BOOLEAN,
    toLocaleString: METHOD_RETURNS_STRING,
    toString: METHOD_RETURNS_STRING,
    valueOf: METHOD_RETURNS_UNKNOWN
  }, OBJECT_PROTOTYPE_FALLBACK, true);
  NEW_ARRAY_PROPERTIES = [
    { key: UnknownInteger, kind: "init", property: UNKNOWN_EXPRESSION },
    { key: "length", kind: "init", property: UNKNOWN_LITERAL_NUMBER }
  ];
  METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_BOOLEAN = [
    new Method({
      callsArgs: [0],
      mutatesSelfAsArray: "deopt-only",
      returns: null,
      returnsPrimitive: UNKNOWN_LITERAL_BOOLEAN
    })
  ];
  METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NUMBER = [
    new Method({
      callsArgs: [0],
      mutatesSelfAsArray: "deopt-only",
      returns: null,
      returnsPrimitive: UNKNOWN_LITERAL_NUMBER
    })
  ];
  METHOD_MUTATES_SELF_RETURNS_NEW_ARRAY = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: true,
      returns: () => new ObjectEntity(NEW_ARRAY_PROPERTIES, ARRAY_PROTOTYPE),
      returnsPrimitive: null
    })
  ];
  METHOD_DEOPTS_SELF_RETURNS_NEW_ARRAY = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: "deopt-only",
      returns: () => new ObjectEntity(NEW_ARRAY_PROPERTIES, ARRAY_PROTOTYPE),
      returnsPrimitive: null
    })
  ];
  METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NEW_ARRAY = [
    new Method({
      callsArgs: [0],
      mutatesSelfAsArray: "deopt-only",
      returns: () => new ObjectEntity(NEW_ARRAY_PROPERTIES, ARRAY_PROTOTYPE),
      returnsPrimitive: null
    })
  ];
  METHOD_MUTATES_SELF_RETURNS_NUMBER = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: true,
      returns: null,
      returnsPrimitive: UNKNOWN_LITERAL_NUMBER
    })
  ];
  METHOD_MUTATES_SELF_RETURNS_UNKNOWN = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: true,
      returns: null,
      returnsPrimitive: UNKNOWN_EXPRESSION
    })
  ];
  METHOD_DEOPTS_SELF_RETURNS_UNKNOWN = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: "deopt-only",
      returns: null,
      returnsPrimitive: UNKNOWN_EXPRESSION
    })
  ];
  METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_UNKNOWN = [
    new Method({
      callsArgs: [0],
      mutatesSelfAsArray: "deopt-only",
      returns: null,
      returnsPrimitive: UNKNOWN_EXPRESSION
    })
  ];
  METHOD_MUTATES_SELF_RETURNS_SELF = [
    new Method({
      callsArgs: null,
      mutatesSelfAsArray: true,
      returns: "self",
      returnsPrimitive: null
    })
  ];
  METHOD_CALLS_ARG_MUTATES_SELF_RETURNS_SELF = [
    new Method({
      callsArgs: [0],
      mutatesSelfAsArray: true,
      returns: "self",
      returnsPrimitive: null
    })
  ];
  ARRAY_PROTOTYPE = new ObjectEntity({
    __proto__: null,
    at: METHOD_DEOPTS_SELF_RETURNS_UNKNOWN,
    concat: METHOD_DEOPTS_SELF_RETURNS_NEW_ARRAY,
    copyWithin: METHOD_MUTATES_SELF_RETURNS_SELF,
    entries: METHOD_DEOPTS_SELF_RETURNS_NEW_ARRAY,
    every: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_BOOLEAN,
    fill: METHOD_MUTATES_SELF_RETURNS_SELF,
    filter: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NEW_ARRAY,
    find: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_UNKNOWN,
    findIndex: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NUMBER,
    findLast: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_UNKNOWN,
    findLastIndex: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NUMBER,
    flat: METHOD_DEOPTS_SELF_RETURNS_NEW_ARRAY,
    flatMap: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NEW_ARRAY,
    forEach: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_UNKNOWN,
    includes: METHOD_RETURNS_BOOLEAN,
    indexOf: METHOD_RETURNS_NUMBER,
    join: METHOD_RETURNS_STRING,
    keys: METHOD_RETURNS_UNKNOWN,
    lastIndexOf: METHOD_RETURNS_NUMBER,
    map: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_NEW_ARRAY,
    pop: METHOD_MUTATES_SELF_RETURNS_UNKNOWN,
    push: METHOD_MUTATES_SELF_RETURNS_NUMBER,
    reduce: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_UNKNOWN,
    reduceRight: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_UNKNOWN,
    reverse: METHOD_MUTATES_SELF_RETURNS_SELF,
    shift: METHOD_MUTATES_SELF_RETURNS_UNKNOWN,
    slice: METHOD_DEOPTS_SELF_RETURNS_NEW_ARRAY,
    some: METHOD_CALLS_ARG_DEOPTS_SELF_RETURNS_BOOLEAN,
    sort: METHOD_CALLS_ARG_MUTATES_SELF_RETURNS_SELF,
    splice: METHOD_MUTATES_SELF_RETURNS_NEW_ARRAY,
    toLocaleString: METHOD_RETURNS_STRING,
    toString: METHOD_RETURNS_STRING,
    unshift: METHOD_MUTATES_SELF_RETURNS_NUMBER,
    values: METHOD_DEOPTS_SELF_RETURNS_UNKNOWN
  }, OBJECT_PROTOTYPE, true);
  ArrayExpression = class ArrayExpression2 extends NodeBase {
    constructor() {
      super(...arguments);
      this.objectEntity = null;
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      this.getObjectEntity().deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
    }
    deoptimizePath(path42) {
      this.getObjectEntity().deoptimizePath(path42);
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      return this.getObjectEntity().getLiteralValueAtPath(path42, recursionTracker, origin);
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      return this.getObjectEntity().getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      return this.getObjectEntity().hasEffectsOnInteractionAtPath(path42, interaction, context);
    }
    applyDeoptimizations() {
      this.deoptimized = true;
      let hasSpread = false;
      for (let index = 0;index < this.elements.length; index++) {
        const element = this.elements[index];
        if (element && (hasSpread || element instanceof SpreadElement)) {
          hasSpread = true;
          element.deoptimizePath(UNKNOWN_PATH);
        }
      }
      this.context.requestTreeshakingPass();
    }
    getObjectEntity() {
      if (this.objectEntity !== null) {
        return this.objectEntity;
      }
      const properties = [
        { key: "length", kind: "init", property: UNKNOWN_LITERAL_NUMBER }
      ];
      let hasSpread = false;
      for (let index = 0;index < this.elements.length; index++) {
        const element = this.elements[index];
        if (hasSpread || element instanceof SpreadElement) {
          if (element) {
            hasSpread = true;
            properties.unshift({ key: UnknownInteger, kind: "init", property: element });
          }
        } else if (element) {
          properties.push({ key: String(index), kind: "init", property: element });
        } else {
          properties.push({ key: String(index), kind: "init", property: UNDEFINED_EXPRESSION });
        }
      }
      return this.objectEntity = new ObjectEntity(properties, ARRAY_PROTOTYPE);
    }
  };
  LocalVariable = class LocalVariable2 extends Variable {
    constructor(name, declarator, init23, context) {
      super(name);
      this.init = init23;
      this.calledFromTryStatement = false;
      this.additionalInitializers = null;
      this.expressionsToBeDeoptimized = [];
      this.declarations = declarator ? [declarator] : [];
      this.deoptimizationTracker = context.deoptimizationTracker;
      this.module = context.module;
    }
    addDeclaration(identifier, init23) {
      this.declarations.push(identifier);
      this.markInitializersForDeoptimization().push(init23);
    }
    consolidateInitializers() {
      if (this.additionalInitializers) {
        for (const initializer of this.additionalInitializers) {
          initializer.deoptimizePath(UNKNOWN_PATH);
        }
        this.additionalInitializers = null;
      }
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      if (this.isReassigned) {
        deoptimizeInteraction(interaction);
        return;
      }
      recursionTracker.withTrackedEntityAtPath(path42, this.init, () => this.init.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker), undefined);
    }
    deoptimizePath(path42) {
      if (this.isReassigned || this.deoptimizationTracker.trackEntityAtPathAndGetIfTracked(path42, this)) {
        return;
      }
      if (path42.length === 0) {
        if (!this.isReassigned) {
          this.isReassigned = true;
          const expressionsToBeDeoptimized = this.expressionsToBeDeoptimized;
          this.expressionsToBeDeoptimized = EMPTY_ARRAY;
          for (const expression of expressionsToBeDeoptimized) {
            expression.deoptimizeCache();
          }
          this.init.deoptimizePath(UNKNOWN_PATH);
        }
      } else {
        this.init.deoptimizePath(path42);
      }
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      if (this.isReassigned) {
        return UnknownValue;
      }
      return recursionTracker.withTrackedEntityAtPath(path42, this.init, () => {
        this.expressionsToBeDeoptimized.push(origin);
        return this.init.getLiteralValueAtPath(path42, recursionTracker, origin);
      }, UnknownValue);
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      if (this.isReassigned) {
        return UNKNOWN_RETURN_EXPRESSION;
      }
      return recursionTracker.withTrackedEntityAtPath(path42, this.init, () => {
        this.expressionsToBeDeoptimized.push(origin);
        return this.init.getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin);
      }, UNKNOWN_RETURN_EXPRESSION);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      switch (interaction.type) {
        case INTERACTION_ACCESSED: {
          if (this.isReassigned)
            return true;
          return !context.accessed.trackEntityAtPathAndGetIfTracked(path42, this) && this.init.hasEffectsOnInteractionAtPath(path42, interaction, context);
        }
        case INTERACTION_ASSIGNED: {
          if (this.included)
            return true;
          if (path42.length === 0)
            return false;
          if (this.isReassigned)
            return true;
          return !context.assigned.trackEntityAtPathAndGetIfTracked(path42, this) && this.init.hasEffectsOnInteractionAtPath(path42, interaction, context);
        }
        case INTERACTION_CALLED: {
          if (this.isReassigned)
            return true;
          return !(interaction.withNew ? context.instantiated : context.called).trackEntityAtPathAndGetIfTracked(path42, interaction.args, this) && this.init.hasEffectsOnInteractionAtPath(path42, interaction, context);
        }
      }
    }
    include() {
      if (!this.included) {
        this.included = true;
        for (const declaration of this.declarations) {
          if (!declaration.included)
            declaration.include(createInclusionContext(), false);
          let node = declaration.parent;
          while (!node.included) {
            node.included = true;
            if (node.type === Program$1)
              break;
            node = node.parent;
          }
        }
      }
    }
    includeCallArguments(context, parameters) {
      if (this.isReassigned || context.includedCallArguments.has(this.init)) {
        for (const argument of parameters) {
          argument.include(context, false);
        }
      } else {
        context.includedCallArguments.add(this.init);
        this.init.includeCallArguments(context, parameters);
        context.includedCallArguments.delete(this.init);
      }
    }
    markCalledFromTryStatement() {
      this.calledFromTryStatement = true;
    }
    markInitializersForDeoptimization() {
      if (this.additionalInitializers === null) {
        this.additionalInitializers = [this.init];
        this.init = UNKNOWN_EXPRESSION;
        this.isReassigned = true;
      }
      return this.additionalInitializers;
    }
    mergeDeclarations(variable) {
      const { declarations } = this;
      for (const declaration of variable.declarations) {
        declarations.push(declaration);
      }
      const additionalInitializers = this.markInitializersForDeoptimization();
      additionalInitializers.push(variable.init);
      if (variable.additionalInitializers) {
        for (const initializer of variable.additionalInitializers) {
          additionalInitializers.push(initializer);
        }
      }
    }
  };
  NO_INTERACTIONS = EMPTY_ARRAY;
  UNKNOWN_DEOPTIMIZED_FIELD = new Set([UnknownKey]);
  EMPTY_PATH_TRACKER = new PathTracker;
  UNKNOWN_DEOPTIMIZED_ENTITY = new Set([UNKNOWN_EXPRESSION]);
  ParameterVariable = class ParameterVariable2 extends LocalVariable {
    constructor(name, declarator, context) {
      super(name, declarator, UNKNOWN_EXPRESSION, context);
      this.deoptimizationInteractions = [];
      this.deoptimizations = new PathTracker;
      this.deoptimizedFields = new Set;
      this.entitiesToBeDeoptimized = new Set;
    }
    addEntityToBeDeoptimized(entity) {
      if (entity === UNKNOWN_EXPRESSION) {
        if (!this.entitiesToBeDeoptimized.has(UNKNOWN_EXPRESSION)) {
          this.entitiesToBeDeoptimized.add(UNKNOWN_EXPRESSION);
          for (const { interaction } of this.deoptimizationInteractions) {
            deoptimizeInteraction(interaction);
          }
          this.deoptimizationInteractions = NO_INTERACTIONS;
        }
      } else if (this.deoptimizedFields.has(UnknownKey)) {
        entity.deoptimizePath(UNKNOWN_PATH);
      } else if (!this.entitiesToBeDeoptimized.has(entity)) {
        this.entitiesToBeDeoptimized.add(entity);
        for (const field of this.deoptimizedFields) {
          entity.deoptimizePath([field]);
        }
        for (const { interaction, path: path42 } of this.deoptimizationInteractions) {
          entity.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, SHARED_RECURSION_TRACKER);
        }
      }
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42) {
      if (path42.length >= 2 || this.entitiesToBeDeoptimized.has(UNKNOWN_EXPRESSION) || this.deoptimizationInteractions.length >= MAX_TRACKED_INTERACTIONS || path42.length === 1 && (this.deoptimizedFields.has(UnknownKey) || interaction.type === INTERACTION_CALLED && this.deoptimizedFields.has(path42[0]))) {
        deoptimizeInteraction(interaction);
        return;
      }
      if (!this.deoptimizations.trackEntityAtPathAndGetIfTracked(path42, interaction.args)) {
        for (const entity of this.entitiesToBeDeoptimized) {
          entity.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, SHARED_RECURSION_TRACKER);
        }
        if (!this.entitiesToBeDeoptimized.has(UNKNOWN_EXPRESSION)) {
          this.deoptimizationInteractions.push({
            interaction,
            path: path42
          });
        }
      }
    }
    deoptimizePath(path42) {
      if (path42.length === 0 || this.deoptimizedFields.has(UnknownKey)) {
        return;
      }
      const key = path42[0];
      if (this.deoptimizedFields.has(key)) {
        return;
      }
      this.deoptimizedFields.add(key);
      for (const entity of this.entitiesToBeDeoptimized) {
        entity.deoptimizePath([key]);
      }
      if (key === UnknownKey) {
        this.deoptimizationInteractions = NO_INTERACTIONS;
        this.deoptimizations = EMPTY_PATH_TRACKER;
        this.deoptimizedFields = UNKNOWN_DEOPTIMIZED_FIELD;
        this.entitiesToBeDeoptimized = UNKNOWN_DEOPTIMIZED_ENTITY;
      }
    }
    getReturnExpressionWhenCalledAtPath(path42) {
      if (path42.length === 0) {
        this.deoptimizePath(UNKNOWN_PATH);
      } else if (!this.deoptimizedFields.has(path42[0])) {
        this.deoptimizePath([path42[0]]);
      }
      return UNKNOWN_RETURN_EXPRESSION;
    }
  };
  ChildScope = class ChildScope2 extends Scope$1 {
    constructor(parent) {
      super();
      this.accessedOutsideVariables = new Map;
      this.parent = parent;
      parent.children.push(this);
    }
    addAccessedDynamicImport(importExpression) {
      (this.accessedDynamicImports || (this.accessedDynamicImports = new Set)).add(importExpression);
      if (this.parent instanceof ChildScope2) {
        this.parent.addAccessedDynamicImport(importExpression);
      }
    }
    addAccessedGlobals(globals, accessedGlobalsByScope) {
      const accessedGlobals = accessedGlobalsByScope.get(this) || new Set;
      for (const name of globals) {
        accessedGlobals.add(name);
      }
      accessedGlobalsByScope.set(this, accessedGlobals);
      if (this.parent instanceof ChildScope2) {
        this.parent.addAccessedGlobals(globals, accessedGlobalsByScope);
      }
    }
    addNamespaceMemberAccess(name, variable) {
      this.accessedOutsideVariables.set(name, variable);
      this.parent.addNamespaceMemberAccess(name, variable);
    }
    addReturnExpression(expression) {
      this.parent instanceof ChildScope2 && this.parent.addReturnExpression(expression);
    }
    addUsedOutsideNames(usedNames, format, exportNamesByVariable, accessedGlobalsByScope) {
      for (const variable of this.accessedOutsideVariables.values()) {
        if (variable.included) {
          usedNames.add(variable.getBaseVariableName());
          if (format === "system" && exportNamesByVariable.has(variable)) {
            usedNames.add("exports");
          }
        }
      }
      const accessedGlobals = accessedGlobalsByScope.get(this);
      if (accessedGlobals) {
        for (const name of accessedGlobals) {
          usedNames.add(name);
        }
      }
    }
    contains(name) {
      return this.variables.has(name) || this.parent.contains(name);
    }
    deconflict(format, exportNamesByVariable, accessedGlobalsByScope) {
      const usedNames = new Set;
      this.addUsedOutsideNames(usedNames, format, exportNamesByVariable, accessedGlobalsByScope);
      if (this.accessedDynamicImports) {
        for (const importExpression of this.accessedDynamicImports) {
          if (importExpression.inlineNamespace) {
            usedNames.add(importExpression.inlineNamespace.getBaseVariableName());
          }
        }
      }
      for (const [name, variable] of this.variables) {
        if (variable.included || variable.alwaysRendered) {
          variable.setRenderNames(null, getSafeName(name, usedNames, variable.forbiddenNames));
        }
      }
      for (const scope of this.children) {
        scope.deconflict(format, exportNamesByVariable, accessedGlobalsByScope);
      }
    }
    findLexicalBoundary() {
      return this.parent.findLexicalBoundary();
    }
    findVariable(name) {
      const knownVariable = this.variables.get(name) || this.accessedOutsideVariables.get(name);
      if (knownVariable) {
        return knownVariable;
      }
      const variable = this.parent.findVariable(name);
      this.accessedOutsideVariables.set(name, variable);
      return variable;
    }
  };
  ParameterScope = class ParameterScope2 extends ChildScope {
    constructor(parent, context) {
      super(parent);
      this.parameters = [];
      this.hasRest = false;
      this.context = context;
      this.hoistedBodyVarScope = new ChildScope(this);
    }
    addParameterDeclaration(identifier) {
      const { name } = identifier;
      const variable = new ParameterVariable(name, identifier, this.context);
      const localVariable = this.hoistedBodyVarScope.variables.get(name);
      if (localVariable) {
        this.hoistedBodyVarScope.variables.set(name, variable);
        variable.mergeDeclarations(localVariable);
      }
      this.variables.set(name, variable);
      return variable;
    }
    addParameterVariables(parameters, hasRest) {
      this.parameters = parameters;
      for (const parameterList of parameters) {
        for (const parameter of parameterList) {
          parameter.alwaysRendered = true;
        }
      }
      this.hasRest = hasRest;
    }
    includeCallArguments(context, parameters) {
      let calledFromTryStatement = false;
      let argumentIncluded = false;
      const restParameter = this.hasRest && this.parameters[this.parameters.length - 1];
      for (const checkedArgument of parameters) {
        if (checkedArgument instanceof SpreadElement) {
          for (const argument of parameters) {
            argument.include(context, false);
          }
          break;
        }
      }
      for (let index = parameters.length - 1;index >= 0; index--) {
        const parameterVariables = this.parameters[index] || restParameter;
        const argument = parameters[index];
        if (parameterVariables) {
          calledFromTryStatement = false;
          if (parameterVariables.length === 0) {
            argumentIncluded = true;
          } else {
            for (const variable of parameterVariables) {
              if (variable.included) {
                argumentIncluded = true;
              }
              if (variable.calledFromTryStatement) {
                calledFromTryStatement = true;
              }
            }
          }
        }
        if (!argumentIncluded && argument.shouldBeIncluded(context)) {
          argumentIncluded = true;
        }
        if (argumentIncluded) {
          argument.include(context, calledFromTryStatement);
        }
      }
    }
  };
  ReturnValueScope = class ReturnValueScope2 extends ParameterScope {
    constructor() {
      super(...arguments);
      this.returnExpression = null;
      this.returnExpressions = [];
    }
    addReturnExpression(expression) {
      this.returnExpressions.push(expression);
    }
    getReturnExpression() {
      if (this.returnExpression === null)
        this.updateReturnExpression();
      return this.returnExpression;
    }
    updateReturnExpression() {
      if (this.returnExpressions.length === 1) {
        this.returnExpression = this.returnExpressions[0];
      } else {
        this.returnExpression = UNKNOWN_EXPRESSION;
        for (const expression of this.returnExpressions) {
          expression.deoptimizePath(UNKNOWN_PATH);
        }
      }
    }
  };
  PureFunctionKey = Symbol("PureFunction");
  ValueProperties = Symbol("Value Properties");
  PURE = {
    deoptimizeArgumentsOnCall: doNothing,
    getLiteralValue: getTruthyLiteralValue,
    hasEffectsWhenCalled: returnFalse
  };
  IMPURE = {
    deoptimizeArgumentsOnCall: doNothing,
    getLiteralValue: getTruthyLiteralValue,
    hasEffectsWhenCalled: returnTrue
  };
  PURE_WITH_ARRAY = {
    deoptimizeArgumentsOnCall: doNothing,
    getLiteralValue: getTruthyLiteralValue,
    hasEffectsWhenCalled({ args }) {
      return args.length > 1 && !(args[1] instanceof ArrayExpression);
    }
  };
  GETTER_ACCESS = {
    deoptimizeArgumentsOnCall: doNothing,
    getLiteralValue: getTruthyLiteralValue,
    hasEffectsWhenCalled({ args }, context) {
      const [_thisArgument, firstArgument] = args;
      return !(firstArgument instanceof ExpressionEntity) || firstArgument.hasEffectsOnInteractionAtPath(UNKNOWN_PATH, NODE_INTERACTION_UNKNOWN_ACCESS, context);
    }
  };
  O = {
    __proto__: null,
    [ValueProperties]: IMPURE
  };
  PF = {
    __proto__: null,
    [ValueProperties]: PURE
  };
  PF_NO_GETTER = {
    __proto__: null,
    [ValueProperties]: GETTER_ACCESS
  };
  MUTATES_ARG_WITHOUT_ACCESSOR = {
    __proto__: null,
    [ValueProperties]: {
      deoptimizeArgumentsOnCall({ args: [, firstArgument] }) {
        firstArgument?.deoptimizePath(UNKNOWN_PATH);
      },
      getLiteralValue: getTruthyLiteralValue,
      hasEffectsWhenCalled({ args }, context) {
        return args.length <= 1 || args[1].hasEffectsOnInteractionAtPath(UNKNOWN_NON_ACCESSOR_PATH, NODE_INTERACTION_UNKNOWN_ASSIGNMENT, context);
      }
    }
  };
  C = {
    __proto__: null,
    [ValueProperties]: IMPURE,
    prototype: O
  };
  PC = {
    __proto__: null,
    [ValueProperties]: PURE,
    prototype: O
  };
  PC_WITH_ARRAY = {
    __proto__: null,
    [ValueProperties]: PURE_WITH_ARRAY,
    prototype: O
  };
  ARRAY_TYPE = {
    __proto__: null,
    [ValueProperties]: PURE,
    from: O,
    of: PF,
    prototype: O
  };
  INTL_MEMBER = {
    __proto__: null,
    [ValueProperties]: PURE,
    supportedLocalesOf: PC
  };
  knownGlobals = {
    global: O,
    globalThis: O,
    self: O,
    window: O,
    __proto__: null,
    [ValueProperties]: IMPURE,
    Array: {
      __proto__: null,
      [ValueProperties]: IMPURE,
      from: O,
      isArray: PF,
      of: PF,
      prototype: O
    },
    ArrayBuffer: {
      __proto__: null,
      [ValueProperties]: PURE,
      isView: PF,
      prototype: O
    },
    Atomics: O,
    BigInt: C,
    BigInt64Array: C,
    BigUint64Array: C,
    Boolean: PC,
    constructor: C,
    DataView: PC,
    Date: {
      __proto__: null,
      [ValueProperties]: PURE,
      now: PF,
      parse: PF,
      prototype: O,
      UTC: PF
    },
    decodeURI: PF,
    decodeURIComponent: PF,
    encodeURI: PF,
    encodeURIComponent: PF,
    Error: PC,
    escape: PF,
    eval: O,
    EvalError: PC,
    Float32Array: ARRAY_TYPE,
    Float64Array: ARRAY_TYPE,
    Function: C,
    hasOwnProperty: O,
    Infinity: O,
    Int16Array: ARRAY_TYPE,
    Int32Array: ARRAY_TYPE,
    Int8Array: ARRAY_TYPE,
    isFinite: PF,
    isNaN: PF,
    isPrototypeOf: O,
    JSON: O,
    Map: PC_WITH_ARRAY,
    Math: {
      __proto__: null,
      [ValueProperties]: IMPURE,
      abs: PF,
      acos: PF,
      acosh: PF,
      asin: PF,
      asinh: PF,
      atan: PF,
      atan2: PF,
      atanh: PF,
      cbrt: PF,
      ceil: PF,
      clz32: PF,
      cos: PF,
      cosh: PF,
      exp: PF,
      expm1: PF,
      floor: PF,
      fround: PF,
      hypot: PF,
      imul: PF,
      log: PF,
      log10: PF,
      log1p: PF,
      log2: PF,
      max: PF,
      min: PF,
      pow: PF,
      random: PF,
      round: PF,
      sign: PF,
      sin: PF,
      sinh: PF,
      sqrt: PF,
      tan: PF,
      tanh: PF,
      trunc: PF
    },
    NaN: O,
    Number: {
      __proto__: null,
      [ValueProperties]: PURE,
      isFinite: PF,
      isInteger: PF,
      isNaN: PF,
      isSafeInteger: PF,
      parseFloat: PF,
      parseInt: PF,
      prototype: O
    },
    Object: {
      __proto__: null,
      [ValueProperties]: PURE,
      create: PF,
      defineProperty: MUTATES_ARG_WITHOUT_ACCESSOR,
      defineProperties: MUTATES_ARG_WITHOUT_ACCESSOR,
      freeze: MUTATES_ARG_WITHOUT_ACCESSOR,
      getOwnPropertyDescriptor: PF,
      getOwnPropertyDescriptors: PF,
      getOwnPropertyNames: PF,
      getOwnPropertySymbols: PF,
      getPrototypeOf: PF,
      hasOwn: PF,
      is: PF,
      isExtensible: PF,
      isFrozen: PF,
      isSealed: PF,
      keys: PF,
      fromEntries: O,
      entries: PF_NO_GETTER,
      values: PF_NO_GETTER,
      prototype: O
    },
    parseFloat: PF,
    parseInt: PF,
    Promise: {
      __proto__: null,
      [ValueProperties]: IMPURE,
      all: O,
      allSettled: O,
      any: O,
      prototype: O,
      race: O,
      reject: O,
      resolve: O
    },
    propertyIsEnumerable: O,
    Proxy: O,
    RangeError: PC,
    ReferenceError: PC,
    Reflect: O,
    RegExp: PC,
    Set: PC_WITH_ARRAY,
    SharedArrayBuffer: C,
    String: {
      __proto__: null,
      [ValueProperties]: PURE,
      fromCharCode: PF,
      fromCodePoint: PF,
      prototype: O,
      raw: PF
    },
    Symbol: {
      __proto__: null,
      [ValueProperties]: PURE,
      for: PF,
      keyFor: PF,
      prototype: O,
      toStringTag: {
        __proto__: null,
        [ValueProperties]: {
          deoptimizeArgumentsOnCall: doNothing,
          getLiteralValue() {
            return SymbolToStringTag;
          },
          hasEffectsWhenCalled: returnTrue
        }
      }
    },
    SyntaxError: PC,
    toLocaleString: O,
    toString: O,
    TypeError: PC,
    Uint16Array: ARRAY_TYPE,
    Uint32Array: ARRAY_TYPE,
    Uint8Array: ARRAY_TYPE,
    Uint8ClampedArray: ARRAY_TYPE,
    unescape: PF,
    URIError: PC,
    valueOf: O,
    WeakMap: PC_WITH_ARRAY,
    WeakSet: PC_WITH_ARRAY,
    clearInterval: C,
    clearTimeout: C,
    console: {
      __proto__: null,
      [ValueProperties]: IMPURE,
      assert: C,
      clear: C,
      count: C,
      countReset: C,
      debug: C,
      dir: C,
      dirxml: C,
      error: C,
      exception: C,
      group: C,
      groupCollapsed: C,
      groupEnd: C,
      info: C,
      log: C,
      table: C,
      time: C,
      timeEnd: C,
      timeLog: C,
      trace: C,
      warn: C
    },
    Intl: {
      __proto__: null,
      [ValueProperties]: IMPURE,
      Collator: INTL_MEMBER,
      DateTimeFormat: INTL_MEMBER,
      DisplayNames: INTL_MEMBER,
      ListFormat: INTL_MEMBER,
      Locale: INTL_MEMBER,
      NumberFormat: INTL_MEMBER,
      PluralRules: INTL_MEMBER,
      RelativeTimeFormat: INTL_MEMBER,
      Segmenter: INTL_MEMBER
    },
    setInterval: C,
    setTimeout: C,
    TextDecoder: C,
    TextEncoder: C,
    URL: {
      __proto__: null,
      [ValueProperties]: IMPURE,
      prototype: O,
      canParse: PF
    },
    URLSearchParams: C,
    AbortController: C,
    AbortSignal: C,
    addEventListener: O,
    alert: O,
    AnalyserNode: C,
    Animation: C,
    AnimationEvent: C,
    applicationCache: O,
    ApplicationCache: C,
    ApplicationCacheErrorEvent: C,
    atob: O,
    Attr: C,
    Audio: C,
    AudioBuffer: C,
    AudioBufferSourceNode: C,
    AudioContext: C,
    AudioDestinationNode: C,
    AudioListener: C,
    AudioNode: C,
    AudioParam: C,
    AudioProcessingEvent: C,
    AudioScheduledSourceNode: C,
    AudioWorkletNode: C,
    BarProp: C,
    BaseAudioContext: C,
    BatteryManager: C,
    BeforeUnloadEvent: C,
    BiquadFilterNode: C,
    Blob: C,
    BlobEvent: C,
    blur: O,
    BroadcastChannel: C,
    btoa: O,
    ByteLengthQueuingStrategy: C,
    Cache: C,
    caches: O,
    CacheStorage: C,
    cancelAnimationFrame: O,
    cancelIdleCallback: O,
    CanvasCaptureMediaStreamTrack: C,
    CanvasGradient: C,
    CanvasPattern: C,
    CanvasRenderingContext2D: C,
    ChannelMergerNode: C,
    ChannelSplitterNode: C,
    CharacterData: C,
    clientInformation: O,
    ClipboardEvent: C,
    close: O,
    closed: O,
    CloseEvent: C,
    Comment: C,
    CompositionEvent: C,
    confirm: O,
    ConstantSourceNode: C,
    ConvolverNode: C,
    CountQueuingStrategy: C,
    createImageBitmap: O,
    Credential: C,
    CredentialsContainer: C,
    crypto: O,
    Crypto: C,
    CryptoKey: C,
    CSS: C,
    CSSConditionRule: C,
    CSSFontFaceRule: C,
    CSSGroupingRule: C,
    CSSImportRule: C,
    CSSKeyframeRule: C,
    CSSKeyframesRule: C,
    CSSMediaRule: C,
    CSSNamespaceRule: C,
    CSSPageRule: C,
    CSSRule: C,
    CSSRuleList: C,
    CSSStyleDeclaration: C,
    CSSStyleRule: C,
    CSSStyleSheet: C,
    CSSSupportsRule: C,
    CustomElementRegistry: C,
    customElements: O,
    CustomEvent: {
      __proto__: null,
      [ValueProperties]: {
        deoptimizeArgumentsOnCall({ args }) {
          args[2]?.deoptimizePath(["detail"]);
        },
        getLiteralValue: getTruthyLiteralValue,
        hasEffectsWhenCalled: returnFalse
      },
      prototype: O
    },
    DataTransfer: C,
    DataTransferItem: C,
    DataTransferItemList: C,
    defaultstatus: O,
    defaultStatus: O,
    DelayNode: C,
    DeviceMotionEvent: C,
    DeviceOrientationEvent: C,
    devicePixelRatio: O,
    dispatchEvent: O,
    document: O,
    Document: C,
    DocumentFragment: C,
    DocumentType: C,
    DOMError: C,
    DOMException: C,
    DOMImplementation: C,
    DOMMatrix: C,
    DOMMatrixReadOnly: C,
    DOMParser: C,
    DOMPoint: C,
    DOMPointReadOnly: C,
    DOMQuad: C,
    DOMRect: C,
    DOMRectReadOnly: C,
    DOMStringList: C,
    DOMStringMap: C,
    DOMTokenList: C,
    DragEvent: C,
    DynamicsCompressorNode: C,
    Element: C,
    ErrorEvent: C,
    Event: C,
    EventSource: C,
    EventTarget: C,
    external: O,
    fetch: O,
    File: C,
    FileList: C,
    FileReader: C,
    find: O,
    focus: O,
    FocusEvent: C,
    FontFace: C,
    FontFaceSetLoadEvent: C,
    FormData: C,
    frames: O,
    GainNode: C,
    Gamepad: C,
    GamepadButton: C,
    GamepadEvent: C,
    getComputedStyle: O,
    getSelection: O,
    HashChangeEvent: C,
    Headers: C,
    history: O,
    History: C,
    HTMLAllCollection: C,
    HTMLAnchorElement: C,
    HTMLAreaElement: C,
    HTMLAudioElement: C,
    HTMLBaseElement: C,
    HTMLBodyElement: C,
    HTMLBRElement: C,
    HTMLButtonElement: C,
    HTMLCanvasElement: C,
    HTMLCollection: C,
    HTMLContentElement: C,
    HTMLDataElement: C,
    HTMLDataListElement: C,
    HTMLDetailsElement: C,
    HTMLDialogElement: C,
    HTMLDirectoryElement: C,
    HTMLDivElement: C,
    HTMLDListElement: C,
    HTMLDocument: C,
    HTMLElement: C,
    HTMLEmbedElement: C,
    HTMLFieldSetElement: C,
    HTMLFontElement: C,
    HTMLFormControlsCollection: C,
    HTMLFormElement: C,
    HTMLFrameElement: C,
    HTMLFrameSetElement: C,
    HTMLHeadElement: C,
    HTMLHeadingElement: C,
    HTMLHRElement: C,
    HTMLHtmlElement: C,
    HTMLIFrameElement: C,
    HTMLImageElement: C,
    HTMLInputElement: C,
    HTMLLabelElement: C,
    HTMLLegendElement: C,
    HTMLLIElement: C,
    HTMLLinkElement: C,
    HTMLMapElement: C,
    HTMLMarqueeElement: C,
    HTMLMediaElement: C,
    HTMLMenuElement: C,
    HTMLMetaElement: C,
    HTMLMeterElement: C,
    HTMLModElement: C,
    HTMLObjectElement: C,
    HTMLOListElement: C,
    HTMLOptGroupElement: C,
    HTMLOptionElement: C,
    HTMLOptionsCollection: C,
    HTMLOutputElement: C,
    HTMLParagraphElement: C,
    HTMLParamElement: C,
    HTMLPictureElement: C,
    HTMLPreElement: C,
    HTMLProgressElement: C,
    HTMLQuoteElement: C,
    HTMLScriptElement: C,
    HTMLSelectElement: C,
    HTMLShadowElement: C,
    HTMLSlotElement: C,
    HTMLSourceElement: C,
    HTMLSpanElement: C,
    HTMLStyleElement: C,
    HTMLTableCaptionElement: C,
    HTMLTableCellElement: C,
    HTMLTableColElement: C,
    HTMLTableElement: C,
    HTMLTableRowElement: C,
    HTMLTableSectionElement: C,
    HTMLTemplateElement: C,
    HTMLTextAreaElement: C,
    HTMLTimeElement: C,
    HTMLTitleElement: C,
    HTMLTrackElement: C,
    HTMLUListElement: C,
    HTMLUnknownElement: C,
    HTMLVideoElement: C,
    IDBCursor: C,
    IDBCursorWithValue: C,
    IDBDatabase: C,
    IDBFactory: C,
    IDBIndex: C,
    IDBKeyRange: C,
    IDBObjectStore: C,
    IDBOpenDBRequest: C,
    IDBRequest: C,
    IDBTransaction: C,
    IDBVersionChangeEvent: C,
    IdleDeadline: C,
    IIRFilterNode: C,
    Image: C,
    ImageBitmap: C,
    ImageBitmapRenderingContext: C,
    ImageCapture: C,
    ImageData: C,
    indexedDB: O,
    innerHeight: O,
    innerWidth: O,
    InputEvent: C,
    IntersectionObserver: C,
    IntersectionObserverEntry: C,
    isSecureContext: O,
    KeyboardEvent: C,
    KeyframeEffect: C,
    length: O,
    localStorage: O,
    location: O,
    Location: C,
    locationbar: O,
    matchMedia: O,
    MediaDeviceInfo: C,
    MediaDevices: C,
    MediaElementAudioSourceNode: C,
    MediaEncryptedEvent: C,
    MediaError: C,
    MediaKeyMessageEvent: C,
    MediaKeySession: C,
    MediaKeyStatusMap: C,
    MediaKeySystemAccess: C,
    MediaList: C,
    MediaQueryList: C,
    MediaQueryListEvent: C,
    MediaRecorder: C,
    MediaSettingsRange: C,
    MediaSource: C,
    MediaStream: C,
    MediaStreamAudioDestinationNode: C,
    MediaStreamAudioSourceNode: C,
    MediaStreamEvent: C,
    MediaStreamTrack: C,
    MediaStreamTrackEvent: C,
    menubar: O,
    MessageChannel: C,
    MessageEvent: C,
    MessagePort: C,
    MIDIAccess: C,
    MIDIConnectionEvent: C,
    MIDIInput: C,
    MIDIInputMap: C,
    MIDIMessageEvent: C,
    MIDIOutput: C,
    MIDIOutputMap: C,
    MIDIPort: C,
    MimeType: C,
    MimeTypeArray: C,
    MouseEvent: C,
    moveBy: O,
    moveTo: O,
    MutationEvent: C,
    MutationObserver: C,
    MutationRecord: C,
    name: O,
    NamedNodeMap: C,
    NavigationPreloadManager: C,
    navigator: O,
    Navigator: C,
    NetworkInformation: C,
    Node: C,
    NodeFilter: O,
    NodeIterator: C,
    NodeList: C,
    Notification: C,
    OfflineAudioCompletionEvent: C,
    OfflineAudioContext: C,
    offscreenBuffering: O,
    OffscreenCanvas: C,
    open: O,
    openDatabase: O,
    Option: C,
    origin: O,
    OscillatorNode: C,
    outerHeight: O,
    outerWidth: O,
    PageTransitionEvent: C,
    pageXOffset: O,
    pageYOffset: O,
    PannerNode: C,
    parent: O,
    Path2D: C,
    PaymentAddress: C,
    PaymentRequest: C,
    PaymentRequestUpdateEvent: C,
    PaymentResponse: C,
    performance: O,
    Performance: C,
    PerformanceEntry: C,
    PerformanceLongTaskTiming: C,
    PerformanceMark: C,
    PerformanceMeasure: C,
    PerformanceNavigation: C,
    PerformanceNavigationTiming: C,
    PerformanceObserver: C,
    PerformanceObserverEntryList: C,
    PerformancePaintTiming: C,
    PerformanceResourceTiming: C,
    PerformanceTiming: C,
    PeriodicWave: C,
    Permissions: C,
    PermissionStatus: C,
    personalbar: O,
    PhotoCapabilities: C,
    Plugin: C,
    PluginArray: C,
    PointerEvent: C,
    PopStateEvent: C,
    postMessage: O,
    Presentation: C,
    PresentationAvailability: C,
    PresentationConnection: C,
    PresentationConnectionAvailableEvent: C,
    PresentationConnectionCloseEvent: C,
    PresentationConnectionList: C,
    PresentationReceiver: C,
    PresentationRequest: C,
    print: O,
    ProcessingInstruction: C,
    ProgressEvent: C,
    PromiseRejectionEvent: C,
    prompt: O,
    PushManager: C,
    PushSubscription: C,
    PushSubscriptionOptions: C,
    queueMicrotask: O,
    RadioNodeList: C,
    Range: C,
    ReadableStream: C,
    RemotePlayback: C,
    removeEventListener: O,
    Request: C,
    requestAnimationFrame: O,
    requestIdleCallback: O,
    resizeBy: O,
    ResizeObserver: C,
    ResizeObserverEntry: C,
    resizeTo: O,
    Response: C,
    RTCCertificate: C,
    RTCDataChannel: C,
    RTCDataChannelEvent: C,
    RTCDtlsTransport: C,
    RTCIceCandidate: C,
    RTCIceTransport: C,
    RTCPeerConnection: C,
    RTCPeerConnectionIceEvent: C,
    RTCRtpReceiver: C,
    RTCRtpSender: C,
    RTCSctpTransport: C,
    RTCSessionDescription: C,
    RTCStatsReport: C,
    RTCTrackEvent: C,
    screen: O,
    Screen: C,
    screenLeft: O,
    ScreenOrientation: C,
    screenTop: O,
    screenX: O,
    screenY: O,
    ScriptProcessorNode: C,
    scroll: O,
    scrollbars: O,
    scrollBy: O,
    scrollTo: O,
    scrollX: O,
    scrollY: O,
    SecurityPolicyViolationEvent: C,
    Selection: C,
    ServiceWorker: C,
    ServiceWorkerContainer: C,
    ServiceWorkerRegistration: C,
    sessionStorage: O,
    ShadowRoot: C,
    SharedWorker: C,
    SourceBuffer: C,
    SourceBufferList: C,
    speechSynthesis: O,
    SpeechSynthesisEvent: C,
    SpeechSynthesisUtterance: C,
    StaticRange: C,
    status: O,
    statusbar: O,
    StereoPannerNode: C,
    stop: O,
    Storage: C,
    StorageEvent: C,
    StorageManager: C,
    styleMedia: O,
    StyleSheet: C,
    StyleSheetList: C,
    SubtleCrypto: C,
    SVGAElement: C,
    SVGAngle: C,
    SVGAnimatedAngle: C,
    SVGAnimatedBoolean: C,
    SVGAnimatedEnumeration: C,
    SVGAnimatedInteger: C,
    SVGAnimatedLength: C,
    SVGAnimatedLengthList: C,
    SVGAnimatedNumber: C,
    SVGAnimatedNumberList: C,
    SVGAnimatedPreserveAspectRatio: C,
    SVGAnimatedRect: C,
    SVGAnimatedString: C,
    SVGAnimatedTransformList: C,
    SVGAnimateElement: C,
    SVGAnimateMotionElement: C,
    SVGAnimateTransformElement: C,
    SVGAnimationElement: C,
    SVGCircleElement: C,
    SVGClipPathElement: C,
    SVGComponentTransferFunctionElement: C,
    SVGDefsElement: C,
    SVGDescElement: C,
    SVGDiscardElement: C,
    SVGElement: C,
    SVGEllipseElement: C,
    SVGFEBlendElement: C,
    SVGFEColorMatrixElement: C,
    SVGFEComponentTransferElement: C,
    SVGFECompositeElement: C,
    SVGFEConvolveMatrixElement: C,
    SVGFEDiffuseLightingElement: C,
    SVGFEDisplacementMapElement: C,
    SVGFEDistantLightElement: C,
    SVGFEDropShadowElement: C,
    SVGFEFloodElement: C,
    SVGFEFuncAElement: C,
    SVGFEFuncBElement: C,
    SVGFEFuncGElement: C,
    SVGFEFuncRElement: C,
    SVGFEGaussianBlurElement: C,
    SVGFEImageElement: C,
    SVGFEMergeElement: C,
    SVGFEMergeNodeElement: C,
    SVGFEMorphologyElement: C,
    SVGFEOffsetElement: C,
    SVGFEPointLightElement: C,
    SVGFESpecularLightingElement: C,
    SVGFESpotLightElement: C,
    SVGFETileElement: C,
    SVGFETurbulenceElement: C,
    SVGFilterElement: C,
    SVGForeignObjectElement: C,
    SVGGElement: C,
    SVGGeometryElement: C,
    SVGGradientElement: C,
    SVGGraphicsElement: C,
    SVGImageElement: C,
    SVGLength: C,
    SVGLengthList: C,
    SVGLinearGradientElement: C,
    SVGLineElement: C,
    SVGMarkerElement: C,
    SVGMaskElement: C,
    SVGMatrix: C,
    SVGMetadataElement: C,
    SVGMPathElement: C,
    SVGNumber: C,
    SVGNumberList: C,
    SVGPathElement: C,
    SVGPatternElement: C,
    SVGPoint: C,
    SVGPointList: C,
    SVGPolygonElement: C,
    SVGPolylineElement: C,
    SVGPreserveAspectRatio: C,
    SVGRadialGradientElement: C,
    SVGRect: C,
    SVGRectElement: C,
    SVGScriptElement: C,
    SVGSetElement: C,
    SVGStopElement: C,
    SVGStringList: C,
    SVGStyleElement: C,
    SVGSVGElement: C,
    SVGSwitchElement: C,
    SVGSymbolElement: C,
    SVGTextContentElement: C,
    SVGTextElement: C,
    SVGTextPathElement: C,
    SVGTextPositioningElement: C,
    SVGTitleElement: C,
    SVGTransform: C,
    SVGTransformList: C,
    SVGTSpanElement: C,
    SVGUnitTypes: C,
    SVGUseElement: C,
    SVGViewElement: C,
    TaskAttributionTiming: C,
    Text: C,
    TextEvent: C,
    TextMetrics: C,
    TextTrack: C,
    TextTrackCue: C,
    TextTrackCueList: C,
    TextTrackList: C,
    TimeRanges: C,
    toolbar: O,
    top: O,
    Touch: C,
    TouchEvent: C,
    TouchList: C,
    TrackEvent: C,
    TransitionEvent: C,
    TreeWalker: C,
    UIEvent: C,
    ValidityState: C,
    visualViewport: O,
    VisualViewport: C,
    VTTCue: C,
    WaveShaperNode: C,
    WebAssembly: O,
    WebGL2RenderingContext: C,
    WebGLActiveInfo: C,
    WebGLBuffer: C,
    WebGLContextEvent: C,
    WebGLFramebuffer: C,
    WebGLProgram: C,
    WebGLQuery: C,
    WebGLRenderbuffer: C,
    WebGLRenderingContext: C,
    WebGLSampler: C,
    WebGLShader: C,
    WebGLShaderPrecisionFormat: C,
    WebGLSync: C,
    WebGLTexture: C,
    WebGLTransformFeedback: C,
    WebGLUniformLocation: C,
    WebGLVertexArrayObject: C,
    WebSocket: C,
    WheelEvent: C,
    Window: C,
    Worker: C,
    WritableStream: C,
    XMLDocument: C,
    XMLHttpRequest: C,
    XMLHttpRequestEventTarget: C,
    XMLHttpRequestUpload: C,
    XMLSerializer: C,
    XPathEvaluator: C,
    XPathExpression: C,
    XPathResult: C,
    XSLTProcessor: C
  };
  for (const global22 of ["window", "global", "self", "globalThis"]) {
    knownGlobals[global22] = knownGlobals;
  }
  GlobalVariable = class GlobalVariable2 extends Variable {
    constructor() {
      super(...arguments);
      this.isReassigned = true;
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      switch (interaction.type) {
        case INTERACTION_ACCESSED:
        case INTERACTION_ASSIGNED: {
          if (!getGlobalAtPath([this.name, ...path42].slice(0, -1))) {
            super.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
          }
          return;
        }
        case INTERACTION_CALLED: {
          const globalAtPath = getGlobalAtPath([this.name, ...path42]);
          if (globalAtPath) {
            globalAtPath.deoptimizeArgumentsOnCall(interaction);
          } else {
            super.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
          }
          return;
        }
      }
    }
    getLiteralValueAtPath(path42, _recursionTracker, _origin) {
      const globalAtPath = getGlobalAtPath([this.name, ...path42]);
      return globalAtPath ? globalAtPath.getLiteralValue() : UnknownValue;
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      switch (interaction.type) {
        case INTERACTION_ACCESSED: {
          if (path42.length === 0) {
            return this.name !== "undefined" && !getGlobalAtPath([this.name]);
          }
          return !getGlobalAtPath([this.name, ...path42].slice(0, -1));
        }
        case INTERACTION_ASSIGNED: {
          return true;
        }
        case INTERACTION_CALLED: {
          const globalAtPath = getGlobalAtPath([this.name, ...path42]);
          return !globalAtPath || globalAtPath.hasEffectsWhenCalled(interaction, context);
        }
      }
    }
  };
  tdzVariableKinds = {
    __proto__: null,
    class: true,
    const: true,
    let: true,
    var: true
  };
  Identifier = class Identifier2 extends NodeBase {
    constructor() {
      super(...arguments);
      this.variable = null;
      this.isTDZAccess = null;
    }
    addExportedVariables(variables, exportNamesByVariable) {
      if (exportNamesByVariable.has(this.variable)) {
        variables.push(this.variable);
      }
    }
    bind() {
      if (!this.variable && is_reference(this, this.parent)) {
        this.variable = this.scope.findVariable(this.name);
        this.variable.addReference(this);
      }
    }
    declare(kind, init23) {
      let variable;
      const { treeshake } = this.context.options;
      switch (kind) {
        case "var": {
          variable = this.scope.addDeclaration(this, this.context, init23, true);
          if (treeshake && treeshake.correctVarValueBeforeDeclaration) {
            variable.markInitializersForDeoptimization();
          }
          break;
        }
        case "function": {
          variable = this.scope.addDeclaration(this, this.context, init23, false);
          break;
        }
        case "let":
        case "const":
        case "class": {
          variable = this.scope.addDeclaration(this, this.context, init23, false);
          break;
        }
        case "parameter": {
          variable = this.scope.addParameterDeclaration(this);
          break;
        }
        default: {
          throw new Error(`Internal Error: Unexpected identifier kind ${kind}.`);
        }
      }
      variable.kind = kind;
      return [this.variable = variable];
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      this.variable.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
    }
    deoptimizePath(path42) {
      if (path42.length === 0 && !this.scope.contains(this.name)) {
        this.disallowImportReassignment();
      }
      this.variable?.deoptimizePath(path42);
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      return this.getVariableRespectingTDZ().getLiteralValueAtPath(path42, recursionTracker, origin);
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      const [expression, isPure] = this.getVariableRespectingTDZ().getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin);
      return [expression, isPure || this.isPureFunction(path42)];
    }
    hasEffects(context) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      if (this.isPossibleTDZ() && this.variable.kind !== "var") {
        return true;
      }
      return this.context.options.treeshake.unknownGlobalSideEffects && this.variable instanceof GlobalVariable && !this.isPureFunction(EMPTY_PATH) && this.variable.hasEffectsOnInteractionAtPath(EMPTY_PATH, NODE_INTERACTION_UNKNOWN_ACCESS, context);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      switch (interaction.type) {
        case INTERACTION_ACCESSED: {
          return this.variable !== null && !this.isPureFunction(path42) && this.getVariableRespectingTDZ().hasEffectsOnInteractionAtPath(path42, interaction, context);
        }
        case INTERACTION_ASSIGNED: {
          return (path42.length > 0 ? this.getVariableRespectingTDZ() : this.variable).hasEffectsOnInteractionAtPath(path42, interaction, context);
        }
        case INTERACTION_CALLED: {
          return !this.isPureFunction(path42) && this.getVariableRespectingTDZ().hasEffectsOnInteractionAtPath(path42, interaction, context);
        }
      }
    }
    include() {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      if (!this.included) {
        this.included = true;
        if (this.variable !== null) {
          this.context.includeVariableInModule(this.variable);
        }
      }
    }
    includeCallArguments(context, parameters) {
      this.variable.includeCallArguments(context, parameters);
    }
    isPossibleTDZ() {
      if (this.isTDZAccess !== null)
        return this.isTDZAccess;
      if (!(this.variable instanceof LocalVariable && this.variable.kind && (this.variable.kind in tdzVariableKinds) && this.variable.module === this.context.module)) {
        return this.isTDZAccess = false;
      }
      let decl_id;
      if (this.variable.declarations && this.variable.declarations.length === 1 && (decl_id = this.variable.declarations[0]) && this.start < decl_id.start && closestParentFunctionOrProgram(this) === closestParentFunctionOrProgram(decl_id)) {
        return this.isTDZAccess = true;
      }
      if (!this.variable.initReached) {
        return this.isTDZAccess = true;
      }
      return this.isTDZAccess = false;
    }
    markDeclarationReached() {
      this.variable.initReached = true;
    }
    render(code, { snippets: { getPropertyAccess }, useOriginalName }, { renderedParentType, isCalleeOfRenderedParent, isShorthandProperty } = BLANK) {
      if (this.variable) {
        const name = this.variable.getName(getPropertyAccess, useOriginalName);
        if (name !== this.name) {
          code.overwrite(this.start, this.end, name, {
            contentOnly: true,
            storeName: true
          });
          if (isShorthandProperty) {
            code.prependRight(this.start, `${this.name}: `);
          }
        }
        if (name === "eval" && renderedParentType === CallExpression$1 && isCalleeOfRenderedParent) {
          code.appendRight(this.start, "0, ");
        }
      }
    }
    applyDeoptimizations() {
      this.deoptimized = true;
      if (this.variable instanceof LocalVariable) {
        this.variable.consolidateInitializers();
        this.context.requestTreeshakingPass();
      }
    }
    disallowImportReassignment() {
      return this.context.error(logIllegalImportReassignment(this.name, this.context.module.id), this.start);
    }
    getVariableRespectingTDZ() {
      if (this.isPossibleTDZ()) {
        return UNKNOWN_EXPRESSION;
      }
      return this.variable;
    }
    isPureFunction(path42) {
      let currentPureFunction = this.context.manualPureFunctions[this.name];
      for (const segment of path42) {
        if (currentPureFunction) {
          if (currentPureFunction[PureFunctionKey]) {
            return true;
          }
          currentPureFunction = currentPureFunction[segment];
        } else {
          return false;
        }
      }
      return currentPureFunction?.[PureFunctionKey];
    }
  };
  NON_WHITESPACE = /\S/g;
  BlockScope = class BlockScope2 extends ChildScope {
    addDeclaration(identifier, context, init23, isHoisted) {
      if (isHoisted) {
        const variable = this.parent.addDeclaration(identifier, context, init23, isHoisted);
        variable.markInitializersForDeoptimization();
        return variable;
      } else {
        return super.addDeclaration(identifier, context, init23, false);
      }
    }
  };
  ExpressionStatement = class ExpressionStatement2 extends NodeBase {
    initialise() {
      if (this.directive && this.directive !== "use strict" && this.parent.type === Program$1) {
        this.context.log(LOGLEVEL_WARN, logModuleLevelDirective(this.directive, this.context.module.id), this.start);
      }
    }
    render(code, options3) {
      super.render(code, options3);
      if (this.included)
        this.insertSemicolon(code);
    }
    shouldBeIncluded(context) {
      if (this.directive && this.directive !== "use strict")
        return this.parent.type !== Program$1;
      return super.shouldBeIncluded(context);
    }
    applyDeoptimizations() {
    }
  };
  BlockStatement = class BlockStatement2 extends NodeBase {
    constructor() {
      super(...arguments);
      this.directlyIncluded = false;
    }
    addImplicitReturnExpressionToScope() {
      const lastStatement = this.body[this.body.length - 1];
      if (!lastStatement || lastStatement.type !== ReturnStatement$1) {
        this.scope.addReturnExpression(UNKNOWN_EXPRESSION);
      }
    }
    createScope(parentScope) {
      this.scope = this.parent.preventChildBlockScope ? parentScope : new BlockScope(parentScope);
    }
    hasEffects(context) {
      if (this.deoptimizeBody)
        return true;
      for (const node of this.body) {
        if (context.brokenFlow)
          break;
        if (node.hasEffects(context))
          return true;
      }
      return false;
    }
    include(context, includeChildrenRecursively) {
      if (!(this.deoptimizeBody && this.directlyIncluded)) {
        this.included = true;
        this.directlyIncluded = true;
        if (this.deoptimizeBody)
          includeChildrenRecursively = true;
        for (const node of this.body) {
          if (includeChildrenRecursively || node.shouldBeIncluded(context))
            node.include(context, includeChildrenRecursively);
        }
      }
    }
    initialise() {
      const firstBodyStatement = this.body[0];
      this.deoptimizeBody = firstBodyStatement instanceof ExpressionStatement && firstBodyStatement.directive === "use asm";
    }
    render(code, options3) {
      if (this.body.length > 0) {
        renderStatementList(this.body, code, this.start + 1, this.end - 1, options3);
      } else {
        super.render(code, options3);
      }
    }
  };
  RestElement = class RestElement2 extends NodeBase {
    constructor() {
      super(...arguments);
      this.declarationInit = null;
    }
    addExportedVariables(variables, exportNamesByVariable) {
      this.argument.addExportedVariables(variables, exportNamesByVariable);
    }
    declare(kind, init23) {
      this.declarationInit = init23;
      return this.argument.declare(kind, UNKNOWN_EXPRESSION);
    }
    deoptimizePath(path42) {
      path42.length === 0 && this.argument.deoptimizePath(EMPTY_PATH);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      return path42.length > 0 || this.argument.hasEffectsOnInteractionAtPath(EMPTY_PATH, interaction, context);
    }
    markDeclarationReached() {
      this.argument.markDeclarationReached();
    }
    applyDeoptimizations() {
      this.deoptimized = true;
      if (this.declarationInit !== null) {
        this.declarationInit.deoptimizePath([UnknownKey, UnknownKey]);
        this.context.requestTreeshakingPass();
      }
    }
  };
  FunctionBase = class FunctionBase2 extends NodeBase {
    constructor() {
      super(...arguments);
      this.objectEntity = null;
      this.deoptimizedReturn = false;
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      if (interaction.type === INTERACTION_CALLED) {
        const { parameters } = this.scope;
        const { args } = interaction;
        let hasRest = false;
        for (let position = 0;position < args.length - 1; position++) {
          const parameter = this.params[position];
          const argument = args[position + 1];
          if (hasRest || parameter instanceof RestElement) {
            hasRest = true;
            argument.deoptimizePath(UNKNOWN_PATH);
          } else if (parameter instanceof Identifier) {
            parameters[position][0].addEntityToBeDeoptimized(argument);
            this.addArgumentToBeDeoptimized(argument);
          } else if (parameter) {
            argument.deoptimizePath(UNKNOWN_PATH);
          } else {
            this.addArgumentToBeDeoptimized(argument);
          }
        }
      } else {
        this.getObjectEntity().deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
      }
    }
    deoptimizePath(path42) {
      this.getObjectEntity().deoptimizePath(path42);
      if (path42.length === 1 && path42[0] === UnknownKey) {
        this.scope.getReturnExpression().deoptimizePath(UNKNOWN_PATH);
        for (const parameterList of this.scope.parameters) {
          for (const parameter of parameterList) {
            parameter.deoptimizePath(UNKNOWN_PATH);
          }
        }
      }
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      return this.getObjectEntity().getLiteralValueAtPath(path42, recursionTracker, origin);
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      if (path42.length > 0) {
        return this.getObjectEntity().getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin);
      }
      if (this.async) {
        if (!this.deoptimizedReturn) {
          this.deoptimizedReturn = true;
          this.scope.getReturnExpression().deoptimizePath(UNKNOWN_PATH);
          this.context.requestTreeshakingPass();
        }
        return UNKNOWN_RETURN_EXPRESSION;
      }
      return [this.scope.getReturnExpression(), false];
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      if (path42.length > 0 || interaction.type !== INTERACTION_CALLED) {
        return this.getObjectEntity().hasEffectsOnInteractionAtPath(path42, interaction, context);
      }
      if (this.annotationNoSideEffects) {
        return false;
      }
      if (this.async) {
        const { propertyReadSideEffects } = this.context.options.treeshake;
        const returnExpression = this.scope.getReturnExpression();
        if (returnExpression.hasEffectsOnInteractionAtPath(["then"], NODE_INTERACTION_UNKNOWN_CALL, context) || propertyReadSideEffects && (propertyReadSideEffects === "always" || returnExpression.hasEffectsOnInteractionAtPath(["then"], NODE_INTERACTION_UNKNOWN_ACCESS, context))) {
          return true;
        }
      }
      for (const parameter of this.params) {
        if (parameter.hasEffects(context))
          return true;
      }
      return false;
    }
    include(context, includeChildrenRecursively) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      this.included = true;
      const { brokenFlow } = context;
      context.brokenFlow = false;
      this.body.include(context, includeChildrenRecursively);
      context.brokenFlow = brokenFlow;
    }
    includeCallArguments(context, parameters) {
      this.scope.includeCallArguments(context, parameters);
    }
    initialise() {
      this.scope.addParameterVariables(this.params.map((parameter) => parameter.declare("parameter", UNKNOWN_EXPRESSION)), this.params[this.params.length - 1] instanceof RestElement);
      if (this.body instanceof BlockStatement) {
        this.body.addImplicitReturnExpressionToScope();
      } else {
        this.scope.addReturnExpression(this.body);
      }
    }
    parseNode(esTreeNode) {
      if (esTreeNode.body.type === BlockStatement$1) {
        this.body = new BlockStatement(esTreeNode.body, this, this.scope.hoistedBodyVarScope);
      }
      super.parseNode(esTreeNode);
    }
    addArgumentToBeDeoptimized(_argument) {
    }
    applyDeoptimizations() {
    }
  };
  FunctionBase.prototype.preventChildBlockScope = true;
  ArgumentsVariable = class ArgumentsVariable2 extends LocalVariable {
    constructor(context) {
      super("arguments", null, UNKNOWN_EXPRESSION, context);
      this.deoptimizedArguments = [];
    }
    addArgumentToBeDeoptimized(argument) {
      if (this.included) {
        argument.deoptimizePath(UNKNOWN_PATH);
      } else {
        this.deoptimizedArguments.push(argument);
      }
    }
    hasEffectsOnInteractionAtPath(path42, { type }) {
      return type !== INTERACTION_ACCESSED || path42.length > 1;
    }
    include() {
      super.include();
      for (const argument of this.deoptimizedArguments) {
        argument.deoptimizePath(UNKNOWN_PATH);
      }
      this.deoptimizedArguments.length = 0;
    }
  };
  ThisVariable = class ThisVariable2 extends ParameterVariable {
    constructor(context) {
      super("this", null, context);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      return (context.replacedVariableInits.get(this) || UNKNOWN_EXPRESSION).hasEffectsOnInteractionAtPath(path42, interaction, context);
    }
  };
  FunctionScope = class FunctionScope2 extends ReturnValueScope {
    constructor(parent, context) {
      super(parent, context);
      this.variables.set("arguments", this.argumentsVariable = new ArgumentsVariable(context));
      this.variables.set("this", this.thisVariable = new ThisVariable(context));
    }
    findLexicalBoundary() {
      return this;
    }
    includeCallArguments(context, parameters) {
      super.includeCallArguments(context, parameters);
      if (this.argumentsVariable.included) {
        for (const argument of parameters) {
          if (!argument.included) {
            argument.include(context, false);
          }
        }
      }
    }
  };
  FunctionNode = class FunctionNode2 extends FunctionBase {
    constructor() {
      super(...arguments);
      this.objectEntity = null;
    }
    createScope(parentScope) {
      this.scope = new FunctionScope(parentScope, this.context);
      this.constructedEntity = new ObjectEntity(Object.create(null), OBJECT_PROTOTYPE);
      this.scope.thisVariable.addEntityToBeDeoptimized(this.constructedEntity);
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      super.deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
      if (interaction.type === INTERACTION_CALLED && path42.length === 0 && interaction.args[0]) {
        this.scope.thisVariable.addEntityToBeDeoptimized(interaction.args[0]);
      }
    }
    hasEffects(context) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      if (this.annotationNoSideEffects) {
        return false;
      }
      return !!this.id?.hasEffects(context);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      if (super.hasEffectsOnInteractionAtPath(path42, interaction, context))
        return true;
      if (this.annotationNoSideEffects) {
        return false;
      }
      if (interaction.type === INTERACTION_CALLED) {
        const thisInit = context.replacedVariableInits.get(this.scope.thisVariable);
        context.replacedVariableInits.set(this.scope.thisVariable, interaction.withNew ? this.constructedEntity : UNKNOWN_EXPRESSION);
        const { brokenFlow, ignore: ignore2, replacedVariableInits } = context;
        context.ignore = {
          breaks: false,
          continues: false,
          labels: new Set,
          returnYield: true,
          this: interaction.withNew
        };
        if (this.body.hasEffects(context))
          return true;
        context.brokenFlow = brokenFlow;
        if (thisInit) {
          replacedVariableInits.set(this.scope.thisVariable, thisInit);
        } else {
          replacedVariableInits.delete(this.scope.thisVariable);
        }
        context.ignore = ignore2;
      }
      return false;
    }
    include(context, includeChildrenRecursively) {
      super.include(context, includeChildrenRecursively);
      this.id?.include();
      const hasArguments = this.scope.argumentsVariable.included;
      for (const parameter of this.params) {
        if (!(parameter instanceof Identifier) || hasArguments) {
          parameter.include(context, includeChildrenRecursively);
        }
      }
    }
    initialise() {
      super.initialise();
      this.id?.declare("function", this);
    }
    addArgumentToBeDeoptimized(argument) {
      this.scope.argumentsVariable.addArgumentToBeDeoptimized(argument);
    }
    getObjectEntity() {
      if (this.objectEntity !== null) {
        return this.objectEntity;
      }
      return this.objectEntity = new ObjectEntity([
        {
          key: "prototype",
          kind: "init",
          property: new ObjectEntity([], OBJECT_PROTOTYPE)
        }
      ], OBJECT_PROTOTYPE);
    }
  };
  MethodBase = class MethodBase2 extends NodeBase {
    constructor() {
      super(...arguments);
      this.accessedValue = null;
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      if (interaction.type === INTERACTION_ACCESSED && this.kind === "get" && path42.length === 0) {
        return this.value.deoptimizeArgumentsOnInteractionAtPath({
          args: interaction.args,
          type: INTERACTION_CALLED,
          withNew: false
        }, EMPTY_PATH, recursionTracker);
      }
      if (interaction.type === INTERACTION_ASSIGNED && this.kind === "set" && path42.length === 0) {
        return this.value.deoptimizeArgumentsOnInteractionAtPath({
          args: interaction.args,
          type: INTERACTION_CALLED,
          withNew: false
        }, EMPTY_PATH, recursionTracker);
      }
      this.getAccessedValue()[0].deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
    }
    deoptimizeCache() {
    }
    deoptimizePath(path42) {
      this.getAccessedValue()[0].deoptimizePath(path42);
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      return this.getAccessedValue()[0].getLiteralValueAtPath(path42, recursionTracker, origin);
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      return this.getAccessedValue()[0].getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin);
    }
    hasEffects(context) {
      return this.key.hasEffects(context);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      if (this.kind === "get" && interaction.type === INTERACTION_ACCESSED && path42.length === 0) {
        return this.value.hasEffectsOnInteractionAtPath(EMPTY_PATH, {
          args: interaction.args,
          type: INTERACTION_CALLED,
          withNew: false
        }, context);
      }
      if (this.kind === "set" && interaction.type === INTERACTION_ASSIGNED) {
        return this.value.hasEffectsOnInteractionAtPath(EMPTY_PATH, {
          args: interaction.args,
          type: INTERACTION_CALLED,
          withNew: false
        }, context);
      }
      return this.getAccessedValue()[0].hasEffectsOnInteractionAtPath(path42, interaction, context);
    }
    applyDeoptimizations() {
    }
    getAccessedValue() {
      if (this.accessedValue === null) {
        if (this.kind === "get") {
          this.accessedValue = UNKNOWN_RETURN_EXPRESSION;
          return this.accessedValue = this.value.getReturnExpressionWhenCalledAtPath(EMPTY_PATH, NODE_INTERACTION_UNKNOWN_CALL, SHARED_RECURSION_TRACKER, this);
        } else {
          return this.accessedValue = [this.value, false];
        }
      }
      return this.accessedValue;
    }
  };
  MethodDefinition = class MethodDefinition2 extends MethodBase {
    applyDeoptimizations() {
    }
  };
  ObjectMember = class ObjectMember2 extends ExpressionEntity {
    constructor(object, key) {
      super();
      this.object = object;
      this.key = key;
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      this.object.deoptimizeArgumentsOnInteractionAtPath(interaction, [this.key, ...path42], recursionTracker);
    }
    deoptimizePath(path42) {
      this.object.deoptimizePath([this.key, ...path42]);
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      return this.object.getLiteralValueAtPath([this.key, ...path42], recursionTracker, origin);
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      return this.object.getReturnExpressionWhenCalledAtPath([this.key, ...path42], interaction, recursionTracker, origin);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      return this.object.hasEffectsOnInteractionAtPath([this.key, ...path42], interaction, context);
    }
  };
  ClassNode = class ClassNode2 extends NodeBase {
    constructor() {
      super(...arguments);
      this.objectEntity = null;
    }
    createScope(parentScope) {
      this.scope = new ChildScope(parentScope);
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      this.getObjectEntity().deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker);
    }
    deoptimizeCache() {
      this.getObjectEntity().deoptimizeAllProperties();
    }
    deoptimizePath(path42) {
      this.getObjectEntity().deoptimizePath(path42);
    }
    getLiteralValueAtPath(path42, recursionTracker, origin) {
      return this.getObjectEntity().getLiteralValueAtPath(path42, recursionTracker, origin);
    }
    getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin) {
      return this.getObjectEntity().getReturnExpressionWhenCalledAtPath(path42, interaction, recursionTracker, origin);
    }
    hasEffects(context) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      const initEffect = this.superClass?.hasEffects(context) || this.body.hasEffects(context);
      this.id?.markDeclarationReached();
      return initEffect || super.hasEffects(context);
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      return interaction.type === INTERACTION_CALLED && path42.length === 0 ? !interaction.withNew || (this.classConstructor === null ? this.superClass?.hasEffectsOnInteractionAtPath(path42, interaction, context) : this.classConstructor.hasEffectsOnInteractionAtPath(path42, interaction, context)) || false : this.getObjectEntity().hasEffectsOnInteractionAtPath(path42, interaction, context);
    }
    include(context, includeChildrenRecursively) {
      if (!this.deoptimized)
        this.applyDeoptimizations();
      this.included = true;
      this.superClass?.include(context, includeChildrenRecursively);
      this.body.include(context, includeChildrenRecursively);
      if (this.id) {
        this.id.markDeclarationReached();
        this.id.include();
      }
    }
    initialise() {
      this.id?.declare("class", this);
      for (const method of this.body.body) {
        if (method instanceof MethodDefinition && method.kind === "constructor") {
          this.classConstructor = method;
          return;
        }
      }
      this.classConstructor = null;
    }
    applyDeoptimizations() {
      this.deoptimized = true;
      for (const definition of this.body.body) {
        if (!(definition.static || definition instanceof MethodDefinition && definition.kind === "constructor")) {
          definition.deoptimizePath(UNKNOWN_PATH);
        }
      }
      this.context.requestTreeshakingPass();
    }
    getObjectEntity() {
      if (this.objectEntity !== null) {
        return this.objectEntity;
      }
      const staticProperties = [];
      const dynamicMethods = [];
      for (const definition of this.body.body) {
        const properties = definition.static ? staticProperties : dynamicMethods;
        const definitionKind = definition.kind;
        if (properties === dynamicMethods && !definitionKind)
          continue;
        const kind = definitionKind === "set" || definitionKind === "get" ? definitionKind : "init";
        let key;
        if (definition.computed) {
          const keyValue = definition.key.getLiteralValueAtPath(EMPTY_PATH, SHARED_RECURSION_TRACKER, this);
          if (typeof keyValue === "symbol") {
            properties.push({ key: UnknownKey, kind, property: definition });
            continue;
          } else {
            key = String(keyValue);
          }
        } else {
          key = definition.key instanceof Identifier ? definition.key.name : String(definition.key.value);
        }
        properties.push({ key, kind, property: definition });
      }
      staticProperties.unshift({
        key: "prototype",
        kind: "init",
        property: new ObjectEntity(dynamicMethods, this.superClass ? new ObjectMember(this.superClass, "prototype") : OBJECT_PROTOTYPE)
      });
      return this.objectEntity = new ObjectEntity(staticProperties, this.superClass || OBJECT_PROTOTYPE);
    }
  };
  ClassDeclaration = class ClassDeclaration2 extends ClassNode {
    initialise() {
      super.initialise();
      if (this.id !== null) {
        this.id.variable.isId = true;
      }
    }
    parseNode(esTreeNode) {
      if (esTreeNode.id !== null) {
        this.id = new Identifier(esTreeNode.id, this, this.scope.parent);
      }
      super.parseNode(esTreeNode);
    }
    render(code, options3) {
      const { exportNamesByVariable, format, snippets: { _: _22, getPropertyAccess } } = options3;
      if (this.id) {
        const { variable, name } = this.id;
        if (format === "system" && exportNamesByVariable.has(variable)) {
          code.appendLeft(this.end, `${_22}${getSystemExportStatement([variable], options3)};`);
        }
        const renderedVariable = variable.getName(getPropertyAccess);
        if (renderedVariable !== name) {
          this.superClass?.render(code, options3);
          this.body.render(code, {
            ...options3,
            useOriginalName: (_variable) => _variable === variable
          });
          code.prependRight(this.start, `let ${renderedVariable}${_22}=${_22}`);
          code.prependLeft(this.end, ";");
          return;
        }
      }
      super.render(code, options3);
    }
    applyDeoptimizations() {
      super.applyDeoptimizations();
      const { id, scope } = this;
      if (id) {
        const { name, variable } = id;
        for (const accessedVariable of scope.accessedOutsideVariables.values()) {
          if (accessedVariable !== variable) {
            accessedVariable.forbidName(name);
          }
        }
      }
    }
  };
  ExportAllDeclaration = class ExportAllDeclaration2 extends NodeBase {
    hasEffects() {
      return false;
    }
    initialise() {
      this.context.addExport(this);
    }
    render(code, _options, nodeRenderOptions) {
      code.remove(nodeRenderOptions.start, nodeRenderOptions.end);
    }
    applyDeoptimizations() {
    }
  };
  ExportAllDeclaration.prototype.needsBoundaries = true;
  FunctionDeclaration = class FunctionDeclaration2 extends FunctionNode {
    initialise() {
      super.initialise();
      if (this.id !== null) {
        this.id.variable.isId = true;
      }
    }
    parseNode(esTreeNode) {
      if (esTreeNode.id !== null) {
        this.id = new Identifier(esTreeNode.id, this, this.scope.parent);
      }
      super.parseNode(esTreeNode);
    }
  };
  ExportDefaultDeclaration = class ExportDefaultDeclaration2 extends NodeBase {
    include(context, includeChildrenRecursively) {
      super.include(context, includeChildrenRecursively);
      if (includeChildrenRecursively) {
        this.context.includeVariableInModule(this.variable);
      }
    }
    initialise() {
      const declaration = this.declaration;
      this.declarationName = declaration.id && declaration.id.name || this.declaration.name;
      this.variable = this.scope.addExportDefaultDeclaration(this.declarationName || this.context.getModuleName(), this, this.context);
      this.context.addExport(this);
    }
    render(code, options3, nodeRenderOptions) {
      const { start, end } = nodeRenderOptions;
      const declarationStart = getDeclarationStart(code.original, this.start);
      if (this.declaration instanceof FunctionDeclaration) {
        this.renderNamedDeclaration(code, declarationStart, this.declaration.id === null ? getFunctionIdInsertPosition(code.original, declarationStart) : null, options3);
      } else if (this.declaration instanceof ClassDeclaration) {
        this.renderNamedDeclaration(code, declarationStart, this.declaration.id === null ? findFirstOccurrenceOutsideComment(code.original, "class", start) + "class".length : null, options3);
      } else if (this.variable.getOriginalVariable() !== this.variable) {
        treeshakeNode(this, code, start, end);
        return;
      } else if (this.variable.included) {
        this.renderVariableDeclaration(code, declarationStart, options3);
      } else {
        code.remove(this.start, declarationStart);
        this.declaration.render(code, options3, {
          renderedSurroundingElement: ExpressionStatement$1
        });
        if (code.original[this.end - 1] !== ";") {
          code.appendLeft(this.end, ";");
        }
        return;
      }
      this.declaration.render(code, options3);
    }
    applyDeoptimizations() {
    }
    renderNamedDeclaration(code, declarationStart, idInsertPosition, options3) {
      const { exportNamesByVariable, format, snippets: { getPropertyAccess } } = options3;
      const name = this.variable.getName(getPropertyAccess);
      code.remove(this.start, declarationStart);
      if (idInsertPosition !== null) {
        code.appendLeft(idInsertPosition, ` ${name}`);
      }
      if (format === "system" && this.declaration instanceof ClassDeclaration && exportNamesByVariable.has(this.variable)) {
        code.appendLeft(this.end, ` ${getSystemExportStatement([this.variable], options3)};`);
      }
    }
    renderVariableDeclaration(code, declarationStart, { format, exportNamesByVariable, snippets: { cnst, getPropertyAccess } }) {
      const hasTrailingSemicolon = code.original.charCodeAt(this.end - 1) === 59;
      const systemExportNames = format === "system" && exportNamesByVariable.get(this.variable);
      if (systemExportNames) {
        code.overwrite(this.start, declarationStart, `${cnst} ${this.variable.getName(getPropertyAccess)} = exports('${systemExportNames[0]}', `);
        code.appendRight(hasTrailingSemicolon ? this.end - 1 : this.end, ")" + (hasTrailingSemicolon ? "" : ";"));
      } else {
        code.overwrite(this.start, declarationStart, `${cnst} ${this.variable.getName(getPropertyAccess)} = `);
        if (!hasTrailingSemicolon) {
          code.appendLeft(this.end, ";");
        }
      }
    }
  };
  ExportDefaultDeclaration.prototype.needsBoundaries = true;
  ExportNamedDeclaration = class ExportNamedDeclaration2 extends NodeBase {
    bind() {
      this.declaration?.bind();
    }
    hasEffects(context) {
      return !!this.declaration?.hasEffects(context);
    }
    initialise() {
      this.context.addExport(this);
    }
    render(code, options3, nodeRenderOptions) {
      const { start, end } = nodeRenderOptions;
      if (this.declaration === null) {
        code.remove(start, end);
      } else {
        code.remove(this.start, this.declaration.start);
        this.declaration.render(code, options3, { end, start });
      }
    }
    applyDeoptimizations() {
    }
  };
  ExportNamedDeclaration.prototype.needsBoundaries = true;
  unset = Symbol("unset");
  ImportDeclaration = class ImportDeclaration2 extends NodeBase {
    bind() {
    }
    hasEffects() {
      return false;
    }
    initialise() {
      this.context.addImport(this);
    }
    render(code, _options, nodeRenderOptions) {
      code.remove(nodeRenderOptions.start, nodeRenderOptions.end);
    }
    applyDeoptimizations() {
    }
  };
  ImportDeclaration.prototype.needsBoundaries = true;
  HELPER_GENERATORS = {
    [DOCUMENT_CURRENT_SCRIPT](_t, { _: _22, n }) {
      return `var${_22}${DOCUMENT_CURRENT_SCRIPT}${_22}=${_22}typeof${_22}document${_22}!==${_22}'undefined'${_22}?${_22}document.currentScript${_22}:${_22}null;${n}`;
    },
    [INTEROP_DEFAULT_COMPAT_VARIABLE](_t, snippets, liveBindings) {
      const { _: _22, getDirectReturnFunction, n } = snippets;
      const [left, right] = getDirectReturnFunction(["e"], {
        functionReturn: true,
        lineBreakIndent: null,
        name: INTEROP_DEFAULT_COMPAT_VARIABLE
      });
      return `${left}${getIsCompatNamespace(snippets)}${_22}?${_22}${liveBindings ? getDefaultLiveBinding(snippets) : getDefaultStatic(snippets)}${right}${n}${n}`;
    },
    [INTEROP_DEFAULT_VARIABLE](_t, snippets, liveBindings) {
      const { _: _22, getDirectReturnFunction, n } = snippets;
      const [left, right] = getDirectReturnFunction(["e"], {
        functionReturn: true,
        lineBreakIndent: null,
        name: INTEROP_DEFAULT_VARIABLE
      });
      return `${left}e${_22}&&${_22}e.__esModule${_22}?${_22}${liveBindings ? getDefaultLiveBinding(snippets) : getDefaultStatic(snippets)}${right}${n}${n}`;
    },
    [INTEROP_NAMESPACE_COMPAT_VARIABLE](t, snippets, liveBindings, freeze, namespaceToStringTag, usedHelpers) {
      const { _: _22, getDirectReturnFunction, n } = snippets;
      if (usedHelpers.has(INTEROP_NAMESPACE_DEFAULT_VARIABLE)) {
        const [left, right] = getDirectReturnFunction(["e"], {
          functionReturn: true,
          lineBreakIndent: null,
          name: INTEROP_NAMESPACE_COMPAT_VARIABLE
        });
        return `${left}${getIsCompatNamespace(snippets)}${_22}?${_22}e${_22}:${_22}${INTEROP_NAMESPACE_DEFAULT_VARIABLE}(e)${right}${n}${n}`;
      }
      return `function ${INTEROP_NAMESPACE_COMPAT_VARIABLE}(e)${_22}{${n}${t}if${_22}(${getIsCompatNamespace(snippets)})${_22}return e;${n}` + createNamespaceObject(t, t, snippets, liveBindings, freeze, namespaceToStringTag) + `}${n}${n}`;
    },
    [INTEROP_NAMESPACE_DEFAULT_ONLY_VARIABLE](_t, snippets, _liveBindings, freeze, namespaceToStringTag) {
      const { getDirectReturnFunction, getObject, n } = snippets;
      const [left, right] = getDirectReturnFunction(["e"], {
        functionReturn: true,
        lineBreakIndent: null,
        name: INTEROP_NAMESPACE_DEFAULT_ONLY_VARIABLE
      });
      return `${left}${getFrozen(freeze, getWithToStringTag(namespaceToStringTag, getObject([
        ["__proto__", "null"],
        ["default", "e"]
      ], { lineBreakIndent: null }), snippets))}${right}${n}${n}`;
    },
    [INTEROP_NAMESPACE_DEFAULT_VARIABLE](t, snippets, liveBindings, freeze, namespaceToStringTag) {
      const { _: _22, n } = snippets;
      return `function ${INTEROP_NAMESPACE_DEFAULT_VARIABLE}(e)${_22}{${n}` + createNamespaceObject(t, t, snippets, liveBindings, freeze, namespaceToStringTag) + `}${n}${n}`;
    },
    [INTEROP_NAMESPACE_VARIABLE](t, snippets, liveBindings, freeze, namespaceToStringTag, usedHelpers) {
      const { _: _22, getDirectReturnFunction, n } = snippets;
      if (usedHelpers.has(INTEROP_NAMESPACE_DEFAULT_VARIABLE)) {
        const [left, right] = getDirectReturnFunction(["e"], {
          functionReturn: true,
          lineBreakIndent: null,
          name: INTEROP_NAMESPACE_VARIABLE
        });
        return `${left}e${_22}&&${_22}e.__esModule${_22}?${_22}e${_22}:${_22}${INTEROP_NAMESPACE_DEFAULT_VARIABLE}(e)${right}${n}${n}`;
      }
      return `function ${INTEROP_NAMESPACE_VARIABLE}(e)${_22}{${n}${t}if${_22}(e${_22}&&${_22}e.__esModule)${_22}return e;${n}` + createNamespaceObject(t, t, snippets, liveBindings, freeze, namespaceToStringTag) + `}${n}${n}`;
    },
    [MERGE_NAMESPACES_VARIABLE](t, snippets, liveBindings, freeze, namespaceToStringTag) {
      const { _: _22, cnst, n } = snippets;
      const useForEach = cnst === "var" && liveBindings;
      return `function ${MERGE_NAMESPACES_VARIABLE}(n, m)${_22}{${n}${t}${loopOverNamespaces(`{${n}${t}${t}${t}if${_22}(k${_22}!==${_22}'default'${_22}&&${_22}!(k in n))${_22}{${n}` + (liveBindings ? useForEach ? copyOwnPropertyLiveBinding : copyPropertyLiveBinding : copyPropertyStatic)(t, t + t + t + t, snippets) + `${t}${t}${t}}${n}${t}${t}}`, useForEach, t, snippets)}${n}${t}return ${getFrozen(freeze, getWithToStringTag(namespaceToStringTag, "n", snippets))};${n}}${n}${n}`;
    }
  };
  HELPER_NAMES = Object.keys(HELPER_GENERATORS);
  importMetaMechanisms = {
    amd: getGenericImportMetaMechanism(() => getResolveUrl(`module.uri, document.baseURI`)),
    cjs: getGenericImportMetaMechanism((chunkId) => `(typeof document === 'undefined' ? ${getFileUrlFromFullPath("__filename")} : ${getUrlFromDocument(chunkId)})`),
    iife: getGenericImportMetaMechanism((chunkId) => getUrlFromDocument(chunkId)),
    system: (property, { snippets: { getPropertyAccess } }) => property === null ? `module.meta` : `module.meta${getPropertyAccess(property)}`,
    umd: getGenericImportMetaMechanism((chunkId) => `(typeof document === 'undefined' && typeof location === 'undefined' ? ${getFileUrlFromFullPath("__filename")} : ${getUrlFromDocument(chunkId, true)})`)
  };
  SwitchCase = class SwitchCase2 extends NodeBase {
    hasEffects(context) {
      if (this.test?.hasEffects(context))
        return true;
      for (const node of this.consequent) {
        if (context.brokenFlow)
          break;
        if (node.hasEffects(context))
          return true;
      }
      return false;
    }
    include(context, includeChildrenRecursively) {
      this.included = true;
      this.test?.include(context, includeChildrenRecursively);
      for (const node of this.consequent) {
        if (includeChildrenRecursively || node.shouldBeIncluded(context))
          node.include(context, includeChildrenRecursively);
      }
    }
    render(code, options3, nodeRenderOptions) {
      if (this.consequent.length > 0) {
        this.test && this.test.render(code, options3);
        const testEnd = this.test ? this.test.end : findFirstOccurrenceOutsideComment(code.original, "default", this.start) + 7;
        const consequentStart = findFirstOccurrenceOutsideComment(code.original, ":", testEnd) + 1;
        renderStatementList(this.consequent, code, consequentStart, nodeRenderOptions.end, options3);
      } else {
        super.render(code, options3);
      }
    }
  };
  SwitchCase.prototype.needsBoundaries = true;
  NamespaceVariable = class NamespaceVariable2 extends Variable {
    constructor(context) {
      super(context.getModuleName());
      this.memberVariables = null;
      this.mergedNamespaces = [];
      this.referencedEarly = false;
      this.references = [];
      this.context = context;
      this.module = context.module;
    }
    addReference(identifier) {
      this.references.push(identifier);
      this.name = identifier.name;
    }
    deoptimizeArgumentsOnInteractionAtPath(interaction, path42, recursionTracker) {
      if (path42.length > 1 || path42.length === 1 && interaction.type === INTERACTION_CALLED) {
        const key = path42[0];
        if (typeof key === "string") {
          this.getMemberVariables()[key]?.deoptimizeArgumentsOnInteractionAtPath(interaction, path42.slice(1), recursionTracker);
        } else {
          deoptimizeInteraction(interaction);
        }
      }
    }
    deoptimizePath(path42) {
      if (path42.length > 1) {
        const key = path42[0];
        if (typeof key === "string") {
          this.getMemberVariables()[key]?.deoptimizePath(path42.slice(1));
        }
      }
    }
    getLiteralValueAtPath(path42) {
      if (path42[0] === SymbolToStringTag) {
        return "Module";
      }
      return UnknownValue;
    }
    getMemberVariables() {
      if (this.memberVariables) {
        return this.memberVariables;
      }
      const memberVariables = Object.create(null);
      const sortedExports = [...this.context.getExports(), ...this.context.getReexports()].sort();
      for (const name of sortedExports) {
        if (name[0] !== "*" && name !== this.module.info.syntheticNamedExports) {
          const exportedVariable = this.context.traceExport(name);
          if (exportedVariable) {
            memberVariables[name] = exportedVariable;
          }
        }
      }
      return this.memberVariables = memberVariables;
    }
    hasEffectsOnInteractionAtPath(path42, interaction, context) {
      const { type } = interaction;
      if (path42.length === 0) {
        return true;
      }
      if (path42.length === 1 && type !== INTERACTION_CALLED) {
        return type === INTERACTION_ASSIGNED;
      }
      const key = path42[0];
      if (typeof key !== "string") {
        return true;
      }
      const memberVariable = this.getMemberVariables()[key];
      return !memberVariable || memberVariable.hasEffectsOnInteractionAtPath(path42.slice(1), interaction, context);
    }
    include() {
      this.included = true;
      this.context.includeAllExports();
    }
    prepare(accessedGlobalsByScope) {
      if (this.mergedNamespaces.length > 0) {
        this.module.scope.addAccessedGlobals([MERGE_NAMESPACES_VARIABLE], accessedGlobalsByScope);
      }
    }
    renderBlock(options3) {
      const { exportNamesByVariable, format, freeze, indent: t, namespaceToStringTag, snippets: { _: _22, cnst, getObject, getPropertyAccess, n, s: s32 } } = options3;
      const memberVariables = this.getMemberVariables();
      const members = Object.entries(memberVariables).filter(([_3, variable]) => variable.included).map(([name2, variable]) => {
        if (this.referencedEarly || variable.isReassigned || variable === this) {
          return [
            null,
            `get ${name2}${_22}()${_22}{${_22}return ${variable.getName(getPropertyAccess)}${s32}${_22}}`
          ];
        }
        return [name2, variable.getName(getPropertyAccess)];
      });
      members.unshift([null, `__proto__:${_22}null`]);
      let output = getObject(members, { lineBreakIndent: { base: "", t } });
      if (this.mergedNamespaces.length > 0) {
        const assignmentArguments = this.mergedNamespaces.map((variable) => variable.getName(getPropertyAccess));
        output = `/*#__PURE__*/${MERGE_NAMESPACES_VARIABLE}(${output},${_22}[${assignmentArguments.join(`,${_22}`)}])`;
      } else {
        if (namespaceToStringTag) {
          output = `/*#__PURE__*/Object.defineProperty(${output},${_22}Symbol.toStringTag,${_22}${getToStringTagValue(getObject)})`;
        }
        if (freeze) {
          output = `/*#__PURE__*/Object.freeze(${output})`;
        }
      }
      const name = this.getName(getPropertyAccess);
      output = `${cnst} ${name}${_22}=${_22}${output};`;
      if (format === "system" && exportNamesByVariable.has(this)) {
        output += `${n}${getSystemExportStatement([this], options3)};`;
      }
      return output;
    }
    renderFirst() {
      return this.referencedEarly;
    }
    setMergedNamespaces(mergedNamespaces) {
      this.mergedNamespaces = mergedNamespaces;
      const moduleExecIndex = this.context.getModuleExecIndex();
      for (const identifier of this.references) {
        if (identifier.context.getModuleExecIndex() <= moduleExecIndex) {
          this.referencedEarly = true;
          break;
        }
      }
    }
  };
  NamespaceVariable.prototype.isNamespace = true;
  (function(BuildPhase2) {
    BuildPhase2[BuildPhase2["LOAD_AND_PARSE"] = 0] = "LOAD_AND_PARSE";
    BuildPhase2[BuildPhase2["ANALYSE"] = 1] = "ANALYSE";
    BuildPhase2[BuildPhase2["GENERATE"] = 2] = "GENERATE";
  })(BuildPhase || (BuildPhase = {}));
  sourceMapCache = new WeakMap;
  timers = new Map;
  require$$022 = [
    "assert",
    "async_hooks",
    "buffer",
    "child_process",
    "cluster",
    "console",
    "constants",
    "crypto",
    "dgram",
    "diagnostics_channel",
    "dns",
    "domain",
    "events",
    "fs",
    "http",
    "http2",
    "https",
    "inspector",
    "module",
    "net",
    "os",
    "path",
    "perf_hooks",
    "process",
    "punycode",
    "querystring",
    "readline",
    "repl",
    "stream",
    "string_decoder",
    "timers",
    "tls",
    "trace_events",
    "tty",
    "url",
    "util",
    "v8",
    "vm",
    "wasi",
    "worker_threads",
    "zlib"
  ];
  _static = require$$022;
  builtinModules = /* @__PURE__ */ getDefaultExportFromCjs22(_static);
  nodeBuiltins = new Set([
    ...builtinModules,
    "assert/strict",
    "dns/promises",
    "fs/promises",
    "path/posix",
    "path/win32",
    "readline/promises",
    "stream/consumers",
    "stream/promises",
    "stream/web",
    "timers/promises",
    "util/types"
  ]);
  hashPlaceholderOverhead = hashPlaceholderLeft.length + hashPlaceholderRight.length;
  REPLACER_REGEX = new RegExp(`${hashPlaceholderLeft}[0-9a-zA-Z_$]{1,${maxHashSize - hashPlaceholderOverhead}}${hashPlaceholderRight}`, "g");
  lowercaseBundleKeys = Symbol("bundleKeys");
  NON_ASSET_EXTENSIONS = new Set([
    ".js",
    ".jsx",
    ".ts",
    ".tsx",
    ".mjs",
    ".mts",
    ".cjs",
    ".cts"
  ]);
  astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
  astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938, 6, 4191];
  reservedWords = {
    3: "abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",
    5: "class enum extends super const export import",
    6: "enum",
    strict: "implements interface let package private protected public static yield",
    strictBind: "eval arguments"
  };
  keywords$1 = {
    5: ecma5AndLessKeywords,
    "5module": ecma5AndLessKeywords + " export import",
    6: ecma5AndLessKeywords + " const class extends export import super"
  };
  keywordRelationalOperator = /^in(stanceof)?$/;
  nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
  nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
  beforeExpr = { beforeExpr: true };
  startsExpr = { startsExpr: true };
  keywords = {};
  types$1 = {
    num: new TokenType("num", startsExpr),
    regexp: new TokenType("regexp", startsExpr),
    string: new TokenType("string", startsExpr),
    name: new TokenType("name", startsExpr),
    privateId: new TokenType("privateId", startsExpr),
    eof: new TokenType("eof"),
    bracketL: new TokenType("[", { beforeExpr: true, startsExpr: true }),
    bracketR: new TokenType("]"),
    braceL: new TokenType("{", { beforeExpr: true, startsExpr: true }),
    braceR: new TokenType("}"),
    parenL: new TokenType("(", { beforeExpr: true, startsExpr: true }),
    parenR: new TokenType(")"),
    comma: new TokenType(",", beforeExpr),
    semi: new TokenType(";", beforeExpr),
    colon: new TokenType(":", beforeExpr),
    dot: new TokenType("."),
    question: new TokenType("?", beforeExpr),
    questionDot: new TokenType("?."),
    arrow: new TokenType("=>", beforeExpr),
    template: new TokenType("template"),
    invalidTemplate: new TokenType("invalidTemplate"),
    ellipsis: new TokenType("...", beforeExpr),
    backQuote: new TokenType("`", startsExpr),
    dollarBraceL: new TokenType("${", { beforeExpr: true, startsExpr: true }),
    eq: new TokenType("=", { beforeExpr: true, isAssign: true }),
    assign: new TokenType("_=", { beforeExpr: true, isAssign: true }),
    incDec: new TokenType("++/--", { prefix: true, postfix: true, startsExpr: true }),
    prefix: new TokenType("!/~", { beforeExpr: true, prefix: true, startsExpr: true }),
    logicalOR: binop("||", 1),
    logicalAND: binop("&&", 2),
    bitwiseOR: binop("|", 3),
    bitwiseXOR: binop("^", 4),
    bitwiseAND: binop("&", 5),
    equality: binop("==/!=/===/!==", 6),
    relational: binop("</>/<=/>=", 7),
    bitShift: binop("<</>>/>>>", 8),
    plusMin: new TokenType("+/-", { beforeExpr: true, binop: 9, prefix: true, startsExpr: true }),
    modulo: binop("%", 10),
    star: binop("*", 10),
    slash: binop("/", 10),
    starstar: new TokenType("**", { beforeExpr: true }),
    coalesce: binop("??", 1),
    _break: kw("break"),
    _case: kw("case", beforeExpr),
    _catch: kw("catch"),
    _continue: kw("continue"),
    _debugger: kw("debugger"),
    _default: kw("default", beforeExpr),
    _do: kw("do", { isLoop: true, beforeExpr: true }),
    _else: kw("else", beforeExpr),
    _finally: kw("finally"),
    _for: kw("for", { isLoop: true }),
    _function: kw("function", startsExpr),
    _if: kw("if"),
    _return: kw("return", beforeExpr),
    _switch: kw("switch"),
    _throw: kw("throw", beforeExpr),
    _try: kw("try"),
    _var: kw("var"),
    _const: kw("const"),
    _while: kw("while", { isLoop: true }),
    _with: kw("with"),
    _new: kw("new", { beforeExpr: true, startsExpr: true }),
    _this: kw("this", startsExpr),
    _super: kw("super", startsExpr),
    _class: kw("class", startsExpr),
    _extends: kw("extends", beforeExpr),
    _export: kw("export"),
    _import: kw("import", startsExpr),
    _null: kw("null", startsExpr),
    _true: kw("true", startsExpr),
    _false: kw("false", startsExpr),
    _in: kw("in", { beforeExpr: true, binop: 7 }),
    _instanceof: kw("instanceof", { beforeExpr: true, binop: 7 }),
    _typeof: kw("typeof", { beforeExpr: true, prefix: true, startsExpr: true }),
    _void: kw("void", { beforeExpr: true, prefix: true, startsExpr: true }),
    _delete: kw("delete", { beforeExpr: true, prefix: true, startsExpr: true })
  };
  lineBreak = /\r\n?|\n|\u2028|\u2029/;
  lineBreakG = new RegExp(lineBreak.source, "g");
  nonASCIIwhitespace = /[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/;
  skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
  ref = Object.prototype;
  hasOwnProperty2 = ref.hasOwnProperty;
  toString2 = ref.toString;
  hasOwn = Object.hasOwn || function(obj, propName) {
    return hasOwnProperty2.call(obj, propName);
  };
  isArray22 = Array.isArray || function(obj) {
    return toString2.call(obj) === "[object Array]";
  };
  loneSurrogate = /(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/;
  Position.prototype.offset = function offset(n) {
    return new Position(this.line, this.column + n);
  };
  defaultOptions = {
    ecmaVersion: null,
    sourceType: "script",
    onInsertedSemicolon: null,
    onTrailingComma: null,
    allowReserved: null,
    allowReturnOutsideFunction: false,
    allowImportExportEverywhere: false,
    allowAwaitOutsideFunction: null,
    allowSuperOutsideMethod: null,
    allowHashBang: false,
    checkPrivateFields: true,
    locations: false,
    onToken: null,
    onComment: null,
    ranges: false,
    program: null,
    sourceFile: null,
    directSourceFile: null,
    preserveParens: false
  };
  SCOPE_VAR = SCOPE_TOP | SCOPE_FUNCTION | SCOPE_CLASS_STATIC_BLOCK;
  prototypeAccessors = { inFunction: { configurable: true }, inGenerator: { configurable: true }, inAsync: { configurable: true }, canAwait: { configurable: true }, allowSuper: { configurable: true }, allowDirectSuper: { configurable: true }, treatFunctionsAsVar: { configurable: true }, allowNewDotTarget: { configurable: true }, inClassStaticBlock: { configurable: true } };
  Parser.prototype.parse = function parse3() {
    var node = this.options.program || this.startNode();
    this.nextToken();
    return this.parseTopLevel(node);
  };
  prototypeAccessors.inFunction.get = function() {
    return (this.currentVarScope().flags & SCOPE_FUNCTION) > 0;
  };
  prototypeAccessors.inGenerator.get = function() {
    return (this.currentVarScope().flags & SCOPE_GENERATOR) > 0 && !this.currentVarScope().inClassFieldInit;
  };
  prototypeAccessors.inAsync.get = function() {
    return (this.currentVarScope().flags & SCOPE_ASYNC) > 0 && !this.currentVarScope().inClassFieldInit;
  };
  prototypeAccessors.canAwait.get = function() {
    for (var i2 = this.scopeStack.length - 1;i2 >= 0; i2--) {
      var scope = this.scopeStack[i2];
      if (scope.inClassFieldInit || scope.flags & SCOPE_CLASS_STATIC_BLOCK) {
        return false;
      }
      if (scope.flags & SCOPE_FUNCTION) {
        return (scope.flags & SCOPE_ASYNC) > 0;
      }
    }
    return this.inModule && this.options.ecmaVersion >= 13 || this.options.allowAwaitOutsideFunction;
  };
  prototypeAccessors.allowSuper.get = function() {
    var ref2 = this.currentThisScope();
    var flags = ref2.flags;
    var inClassFieldInit = ref2.inClassFieldInit;
    return (flags & SCOPE_SUPER) > 0 || inClassFieldInit || this.options.allowSuperOutsideMethod;
  };
  prototypeAccessors.allowDirectSuper.get = function() {
    return (this.currentThisScope().flags & SCOPE_DIRECT_SUPER) > 0;
  };
  prototypeAccessors.treatFunctionsAsVar.get = function() {
    return this.treatFunctionsAsVarInScope(this.currentScope());
  };
  prototypeAccessors.allowNewDotTarget.get = function() {
    var ref2 = this.currentThisScope();
    var flags = ref2.flags;
    var inClassFieldInit = ref2.inClassFieldInit;
    return (flags & (SCOPE_FUNCTION | SCOPE_CLASS_STATIC_BLOCK)) > 0 || inClassFieldInit;
  };
  prototypeAccessors.inClassStaticBlock.get = function() {
    return (this.currentVarScope().flags & SCOPE_CLASS_STATIC_BLOCK) > 0;
  };
  Parser.extend = function extend() {
    var plugins = [], len = arguments.length;
    while (len--)
      plugins[len] = arguments[len];
    var cls = this;
    for (var i2 = 0;i2 < plugins.length; i2++) {
      cls = plugins[i2](cls);
    }
    return cls;
  };
  Parser.parse = function parse4(input, options3) {
    return new this(options3, input).parse();
  };
  Parser.parseExpressionAt = function parseExpressionAt(input, pos, options3) {
    var parser = new this(options3, input, pos);
    parser.nextToken();
    return parser.parseExpression();
  };
  Parser.tokenizer = function tokenizer(input, options3) {
    return new this(options3, input);
  };
  Object.defineProperties(Parser.prototype, prototypeAccessors);
  pp$9 = Parser.prototype;
  literal = /^(?:'((?:\\.|[^'\\])*?)'|"((?:\\.|[^"\\])*?)")/;
  pp$9.strictDirective = function(start) {
    if (this.options.ecmaVersion < 5) {
      return false;
    }
    for (;; ) {
      skipWhiteSpace.lastIndex = start;
      start += skipWhiteSpace.exec(this.input)[0].length;
      var match = literal.exec(this.input.slice(start));
      if (!match) {
        return false;
      }
      if ((match[1] || match[2]) === "use strict") {
        skipWhiteSpace.lastIndex = start + match[0].length;
        var spaceAfter = skipWhiteSpace.exec(this.input), end = spaceAfter.index + spaceAfter[0].length;
        var next = this.input.charAt(end);
        return next === ";" || next === "}" || lineBreak.test(spaceAfter[0]) && !(/[(`.[+\-/*%<>=,?^&]/.test(next) || next === "!" && this.input.charAt(end + 1) === "=");
      }
      start += match[0].length;
      skipWhiteSpace.lastIndex = start;
      start += skipWhiteSpace.exec(this.input)[0].length;
      if (this.input[start] === ";") {
        start++;
      }
    }
  };
  pp$9.eat = function(type) {
    if (this.type === type) {
      this.next();
      return true;
    } else {
      return false;
    }
  };
  pp$9.isContextual = function(name) {
    return this.type === types$1.name && this.value === name && !this.containsEsc;
  };
  pp$9.eatContextual = function(name) {
    if (!this.isContextual(name)) {
      return false;
    }
    this.next();
    return true;
  };
  pp$9.expectContextual = function(name) {
    if (!this.eatContextual(name)) {
      this.unexpected();
    }
  };
  pp$9.canInsertSemicolon = function() {
    return this.type === types$1.eof || this.type === types$1.braceR || lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
  };
  pp$9.insertSemicolon = function() {
    if (this.canInsertSemicolon()) {
      if (this.options.onInsertedSemicolon) {
        this.options.onInsertedSemicolon(this.lastTokEnd, this.lastTokEndLoc);
      }
      return true;
    }
  };
  pp$9.semicolon = function() {
    if (!this.eat(types$1.semi) && !this.insertSemicolon()) {
      this.unexpected();
    }
  };
  pp$9.afterTrailingComma = function(tokType, notNext) {
    if (this.type === tokType) {
      if (this.options.onTrailingComma) {
        this.options.onTrailingComma(this.lastTokStart, this.lastTokStartLoc);
      }
      if (!notNext) {
        this.next();
      }
      return true;
    }
  };
  pp$9.expect = function(type) {
    this.eat(type) || this.unexpected();
  };
  pp$9.unexpected = function(pos) {
    this.raise(pos != null ? pos : this.start, "Unexpected token");
  };
  pp$9.checkPatternErrors = function(refDestructuringErrors, isAssign) {
    if (!refDestructuringErrors) {
      return;
    }
    if (refDestructuringErrors.trailingComma > -1) {
      this.raiseRecoverable(refDestructuringErrors.trailingComma, "Comma is not permitted after the rest element");
    }
    var parens = isAssign ? refDestructuringErrors.parenthesizedAssign : refDestructuringErrors.parenthesizedBind;
    if (parens > -1) {
      this.raiseRecoverable(parens, isAssign ? "Assigning to rvalue" : "Parenthesized pattern");
    }
  };
  pp$9.checkExpressionErrors = function(refDestructuringErrors, andThrow) {
    if (!refDestructuringErrors) {
      return false;
    }
    var shorthandAssign = refDestructuringErrors.shorthandAssign;
    var doubleProto = refDestructuringErrors.doubleProto;
    if (!andThrow) {
      return shorthandAssign >= 0 || doubleProto >= 0;
    }
    if (shorthandAssign >= 0) {
      this.raise(shorthandAssign, "Shorthand property assignments are valid only in destructuring patterns");
    }
    if (doubleProto >= 0) {
      this.raiseRecoverable(doubleProto, "Redefinition of __proto__ property");
    }
  };
  pp$9.checkYieldAwaitInDefaultParams = function() {
    if (this.yieldPos && (!this.awaitPos || this.yieldPos < this.awaitPos)) {
      this.raise(this.yieldPos, "Yield expression cannot be a default value");
    }
    if (this.awaitPos) {
      this.raise(this.awaitPos, "Await expression cannot be a default value");
    }
  };
  pp$9.isSimpleAssignTarget = function(expr) {
    if (expr.type === "ParenthesizedExpression") {
      return this.isSimpleAssignTarget(expr.expression);
    }
    return expr.type === "Identifier" || expr.type === "MemberExpression";
  };
  pp$8 = Parser.prototype;
  pp$8.parseTopLevel = function(node) {
    var exports = Object.create(null);
    if (!node.body) {
      node.body = [];
    }
    while (this.type !== types$1.eof) {
      var stmt = this.parseStatement(null, true, exports);
      node.body.push(stmt);
    }
    if (this.inModule) {
      for (var i2 = 0, list2 = Object.keys(this.undefinedExports);i2 < list2.length; i2 += 1) {
        var name = list2[i2];
        this.raiseRecoverable(this.undefinedExports[name].start, "Export '" + name + "' is not defined");
      }
    }
    this.adaptDirectivePrologue(node.body);
    this.next();
    node.sourceType = this.options.sourceType;
    return this.finishNode(node, "Program");
  };
  loopLabel = { kind: "loop" };
  switchLabel = { kind: "switch" };
  pp$8.isLet = function(context) {
    if (this.options.ecmaVersion < 6 || !this.isContextual("let")) {
      return false;
    }
    skipWhiteSpace.lastIndex = this.pos;
    var skip = skipWhiteSpace.exec(this.input);
    var next = this.pos + skip[0].length, nextCh = this.input.charCodeAt(next);
    if (nextCh === 91 || nextCh === 92) {
      return true;
    }
    if (context) {
      return false;
    }
    if (nextCh === 123 || nextCh > 55295 && nextCh < 56320) {
      return true;
    }
    if (isIdentifierStart(nextCh, true)) {
      var pos = next + 1;
      while (isIdentifierChar(nextCh = this.input.charCodeAt(pos), true)) {
        ++pos;
      }
      if (nextCh === 92 || nextCh > 55295 && nextCh < 56320) {
        return true;
      }
      var ident = this.input.slice(next, pos);
      if (!keywordRelationalOperator.test(ident)) {
        return true;
      }
    }
    return false;
  };
  pp$8.isAsyncFunction = function() {
    if (this.options.ecmaVersion < 8 || !this.isContextual("async")) {
      return false;
    }
    skipWhiteSpace.lastIndex = this.pos;
    var skip = skipWhiteSpace.exec(this.input);
    var next = this.pos + skip[0].length, after;
    return !lineBreak.test(this.input.slice(this.pos, next)) && this.input.slice(next, next + 8) === "function" && (next + 8 === this.input.length || !(isIdentifierChar(after = this.input.charCodeAt(next + 8)) || after > 55295 && after < 56320));
  };
  pp$8.parseStatement = function(context, topLevel, exports) {
    var starttype = this.type, node = this.startNode(), kind;
    if (this.isLet(context)) {
      starttype = types$1._var;
      kind = "let";
    }
    switch (starttype) {
      case types$1._break:
      case types$1._continue:
        return this.parseBreakContinueStatement(node, starttype.keyword);
      case types$1._debugger:
        return this.parseDebuggerStatement(node);
      case types$1._do:
        return this.parseDoStatement(node);
      case types$1._for:
        return this.parseForStatement(node);
      case types$1._function:
        if (context && (this.strict || context !== "if" && context !== "label") && this.options.ecmaVersion >= 6) {
          this.unexpected();
        }
        return this.parseFunctionStatement(node, false, !context);
      case types$1._class:
        if (context) {
          this.unexpected();
        }
        return this.parseClass(node, true);
      case types$1._if:
        return this.parseIfStatement(node);
      case types$1._return:
        return this.parseReturnStatement(node);
      case types$1._switch:
        return this.parseSwitchStatement(node);
      case types$1._throw:
        return this.parseThrowStatement(node);
      case types$1._try:
        return this.parseTryStatement(node);
      case types$1._const:
      case types$1._var:
        kind = kind || this.value;
        if (context && kind !== "var") {
          this.unexpected();
        }
        return this.parseVarStatement(node, kind);
      case types$1._while:
        return this.parseWhileStatement(node);
      case types$1._with:
        return this.parseWithStatement(node);
      case types$1.braceL:
        return this.parseBlock(true, node);
      case types$1.semi:
        return this.parseEmptyStatement(node);
      case types$1._export:
      case types$1._import:
        if (this.options.ecmaVersion > 10 && starttype === types$1._import) {
          skipWhiteSpace.lastIndex = this.pos;
          var skip = skipWhiteSpace.exec(this.input);
          var next = this.pos + skip[0].length, nextCh = this.input.charCodeAt(next);
          if (nextCh === 40 || nextCh === 46) {
            return this.parseExpressionStatement(node, this.parseExpression());
          }
        }
        if (!this.options.allowImportExportEverywhere) {
          if (!topLevel) {
            this.raise(this.start, "'import' and 'export' may only appear at the top level");
          }
          if (!this.inModule) {
            this.raise(this.start, "'import' and 'export' may appear only with 'sourceType: module'");
          }
        }
        return starttype === types$1._import ? this.parseImport(node) : this.parseExport(node, exports);
      default:
        if (this.isAsyncFunction()) {
          if (context) {
            this.unexpected();
          }
          this.next();
          return this.parseFunctionStatement(node, true, !context);
        }
        var maybeName = this.value, expr = this.parseExpression();
        if (starttype === types$1.name && expr.type === "Identifier" && this.eat(types$1.colon)) {
          return this.parseLabeledStatement(node, maybeName, expr, context);
        } else {
          return this.parseExpressionStatement(node, expr);
        }
    }
  };
  pp$8.parseBreakContinueStatement = function(node, keyword) {
    var isBreak = keyword === "break";
    this.next();
    if (this.eat(types$1.semi) || this.insertSemicolon()) {
      node.label = null;
    } else if (this.type !== types$1.name) {
      this.unexpected();
    } else {
      node.label = this.parseIdent();
      this.semicolon();
    }
    var i2 = 0;
    for (;i2 < this.labels.length; ++i2) {
      var lab = this.labels[i2];
      if (node.label == null || lab.name === node.label.name) {
        if (lab.kind != null && (isBreak || lab.kind === "loop")) {
          break;
        }
        if (node.label && isBreak) {
          break;
        }
      }
    }
    if (i2 === this.labels.length) {
      this.raise(node.start, "Unsyntactic " + keyword);
    }
    return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
  };
  pp$8.parseDebuggerStatement = function(node) {
    this.next();
    this.semicolon();
    return this.finishNode(node, "DebuggerStatement");
  };
  pp$8.parseDoStatement = function(node) {
    this.next();
    this.labels.push(loopLabel);
    node.body = this.parseStatement("do");
    this.labels.pop();
    this.expect(types$1._while);
    node.test = this.parseParenExpression();
    if (this.options.ecmaVersion >= 6) {
      this.eat(types$1.semi);
    } else {
      this.semicolon();
    }
    return this.finishNode(node, "DoWhileStatement");
  };
  pp$8.parseForStatement = function(node) {
    this.next();
    var awaitAt = this.options.ecmaVersion >= 9 && this.canAwait && this.eatContextual("await") ? this.lastTokStart : -1;
    this.labels.push(loopLabel);
    this.enterScope(0);
    this.expect(types$1.parenL);
    if (this.type === types$1.semi) {
      if (awaitAt > -1) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, null);
    }
    var isLet = this.isLet();
    if (this.type === types$1._var || this.type === types$1._const || isLet) {
      var init$1 = this.startNode(), kind = isLet ? "let" : this.value;
      this.next();
      this.parseVar(init$1, true, kind);
      this.finishNode(init$1, "VariableDeclaration");
      if ((this.type === types$1._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) && init$1.declarations.length === 1) {
        if (this.options.ecmaVersion >= 9) {
          if (this.type === types$1._in) {
            if (awaitAt > -1) {
              this.unexpected(awaitAt);
            }
          } else {
            node.await = awaitAt > -1;
          }
        }
        return this.parseForIn(node, init$1);
      }
      if (awaitAt > -1) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, init$1);
    }
    var startsWithLet = this.isContextual("let"), isForOf = false;
    var refDestructuringErrors = new DestructuringErrors;
    var init23 = this.parseExpression(awaitAt > -1 ? "await" : true, refDestructuringErrors);
    if (this.type === types$1._in || (isForOf = this.options.ecmaVersion >= 6 && this.isContextual("of"))) {
      if (this.options.ecmaVersion >= 9) {
        if (this.type === types$1._in) {
          if (awaitAt > -1) {
            this.unexpected(awaitAt);
          }
        } else {
          node.await = awaitAt > -1;
        }
      }
      if (startsWithLet && isForOf) {
        this.raise(init23.start, "The left-hand side of a for-of loop may not start with 'let'.");
      }
      this.toAssignable(init23, false, refDestructuringErrors);
      this.checkLValPattern(init23);
      return this.parseForIn(node, init23);
    } else {
      this.checkExpressionErrors(refDestructuringErrors, true);
    }
    if (awaitAt > -1) {
      this.unexpected(awaitAt);
    }
    return this.parseFor(node, init23);
  };
  pp$8.parseFunctionStatement = function(node, isAsync, declarationPosition) {
    this.next();
    return this.parseFunction(node, FUNC_STATEMENT$1 | (declarationPosition ? 0 : FUNC_HANGING_STATEMENT), false, isAsync);
  };
  pp$8.parseIfStatement = function(node) {
    this.next();
    node.test = this.parseParenExpression();
    node.consequent = this.parseStatement("if");
    node.alternate = this.eat(types$1._else) ? this.parseStatement("if") : null;
    return this.finishNode(node, "IfStatement");
  };
  pp$8.parseReturnStatement = function(node) {
    if (!this.inFunction && !this.options.allowReturnOutsideFunction) {
      this.raise(this.start, "'return' outside of function");
    }
    this.next();
    if (this.eat(types$1.semi) || this.insertSemicolon()) {
      node.argument = null;
    } else {
      node.argument = this.parseExpression();
      this.semicolon();
    }
    return this.finishNode(node, "ReturnStatement");
  };
  pp$8.parseSwitchStatement = function(node) {
    this.next();
    node.discriminant = this.parseParenExpression();
    node.cases = [];
    this.expect(types$1.braceL);
    this.labels.push(switchLabel);
    this.enterScope(0);
    var cur;
    for (var sawDefault = false;this.type !== types$1.braceR; ) {
      if (this.type === types$1._case || this.type === types$1._default) {
        var isCase = this.type === types$1._case;
        if (cur) {
          this.finishNode(cur, "SwitchCase");
        }
        node.cases.push(cur = this.startNode());
        cur.consequent = [];
        this.next();
        if (isCase) {
          cur.test = this.parseExpression();
        } else {
          if (sawDefault) {
            this.raiseRecoverable(this.lastTokStart, "Multiple default clauses");
          }
          sawDefault = true;
          cur.test = null;
        }
        this.expect(types$1.colon);
      } else {
        if (!cur) {
          this.unexpected();
        }
        cur.consequent.push(this.parseStatement(null));
      }
    }
    this.exitScope();
    if (cur) {
      this.finishNode(cur, "SwitchCase");
    }
    this.next();
    this.labels.pop();
    return this.finishNode(node, "SwitchStatement");
  };
  pp$8.parseThrowStatement = function(node) {
    this.next();
    if (lineBreak.test(this.input.slice(this.lastTokEnd, this.start))) {
      this.raise(this.lastTokEnd, "Illegal newline after throw");
    }
    node.argument = this.parseExpression();
    this.semicolon();
    return this.finishNode(node, "ThrowStatement");
  };
  empty$1 = [];
  pp$8.parseCatchClauseParam = function() {
    var param = this.parseBindingAtom();
    var simple = param.type === "Identifier";
    this.enterScope(simple ? SCOPE_SIMPLE_CATCH : 0);
    this.checkLValPattern(param, simple ? BIND_SIMPLE_CATCH : BIND_LEXICAL);
    this.expect(types$1.parenR);
    return param;
  };
  pp$8.parseTryStatement = function(node) {
    this.next();
    node.block = this.parseBlock();
    node.handler = null;
    if (this.type === types$1._catch) {
      var clause = this.startNode();
      this.next();
      if (this.eat(types$1.parenL)) {
        clause.param = this.parseCatchClauseParam();
      } else {
        if (this.options.ecmaVersion < 10) {
          this.unexpected();
        }
        clause.param = null;
        this.enterScope(0);
      }
      clause.body = this.parseBlock(false);
      this.exitScope();
      node.handler = this.finishNode(clause, "CatchClause");
    }
    node.finalizer = this.eat(types$1._finally) ? this.parseBlock() : null;
    if (!node.handler && !node.finalizer) {
      this.raise(node.start, "Missing catch or finally clause");
    }
    return this.finishNode(node, "TryStatement");
  };
  pp$8.parseVarStatement = function(node, kind, allowMissingInitializer) {
    this.next();
    this.parseVar(node, false, kind, allowMissingInitializer);
    this.semicolon();
    return this.finishNode(node, "VariableDeclaration");
  };
  pp$8.parseWhileStatement = function(node) {
    this.next();
    node.test = this.parseParenExpression();
    this.labels.push(loopLabel);
    node.body = this.parseStatement("while");
    this.labels.pop();
    return this.finishNode(node, "WhileStatement");
  };
  pp$8.parseWithStatement = function(node) {
    if (this.strict) {
      this.raise(this.start, "'with' in strict mode");
    }
    this.next();
    node.object = this.parseParenExpression();
    node.body = this.parseStatement("with");
    return this.finishNode(node, "WithStatement");
  };
  pp$8.parseEmptyStatement = function(node) {
    this.next();
    return this.finishNode(node, "EmptyStatement");
  };
  pp$8.parseLabeledStatement = function(node, maybeName, expr, context) {
    for (var i$1 = 0, list2 = this.labels;i$1 < list2.length; i$1 += 1) {
      var label = list2[i$1];
      if (label.name === maybeName) {
        this.raise(expr.start, "Label '" + maybeName + "' is already declared");
      }
    }
    var kind = this.type.isLoop ? "loop" : this.type === types$1._switch ? "switch" : null;
    for (var i2 = this.labels.length - 1;i2 >= 0; i2--) {
      var label$1 = this.labels[i2];
      if (label$1.statementStart === node.start) {
        label$1.statementStart = this.start;
        label$1.kind = kind;
      } else {
        break;
      }
    }
    this.labels.push({ name: maybeName, kind, statementStart: this.start });
    node.body = this.parseStatement(context ? context.indexOf("label") === -1 ? context + "label" : context : "label");
    this.labels.pop();
    node.label = expr;
    return this.finishNode(node, "LabeledStatement");
  };
  pp$8.parseExpressionStatement = function(node, expr) {
    node.expression = expr;
    this.semicolon();
    return this.finishNode(node, "ExpressionStatement");
  };
  pp$8.parseBlock = function(createNewLexicalScope, node, exitStrict) {
    if (createNewLexicalScope === undefined)
      createNewLexicalScope = true;
    if (node === undefined)
      node = this.startNode();
    node.body = [];
    this.expect(types$1.braceL);
    if (createNewLexicalScope) {
      this.enterScope(0);
    }
    while (this.type !== types$1.braceR) {
      var stmt = this.parseStatement(null);
      node.body.push(stmt);
    }
    if (exitStrict) {
      this.strict = false;
    }
    this.next();
    if (createNewLexicalScope) {
      this.exitScope();
    }
    return this.finishNode(node, "BlockStatement");
  };
  pp$8.parseFor = function(node, init23) {
    node.init = init23;
    this.expect(types$1.semi);
    node.test = this.type === types$1.semi ? null : this.parseExpression();
    this.expect(types$1.semi);
    node.update = this.type === types$1.parenR ? null : this.parseExpression();
    this.expect(types$1.parenR);
    node.body = this.parseStatement("for");
    this.exitScope();
    this.labels.pop();
    return this.finishNode(node, "ForStatement");
  };
  pp$8.parseForIn = function(node, init23) {
    var isForIn = this.type === types$1._in;
    this.next();
    if (init23.type === "VariableDeclaration" && init23.declarations[0].init != null && (!isForIn || this.options.ecmaVersion < 8 || this.strict || init23.kind !== "var" || init23.declarations[0].id.type !== "Identifier")) {
      this.raise(init23.start, (isForIn ? "for-in" : "for-of") + " loop variable declaration may not have an initializer");
    }
    node.left = init23;
    node.right = isForIn ? this.parseExpression() : this.parseMaybeAssign();
    this.expect(types$1.parenR);
    node.body = this.parseStatement("for");
    this.exitScope();
    this.labels.pop();
    return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement");
  };
  pp$8.parseVar = function(node, isFor, kind, allowMissingInitializer) {
    node.declarations = [];
    node.kind = kind;
    for (;; ) {
      var decl = this.startNode();
      this.parseVarId(decl, kind);
      if (this.eat(types$1.eq)) {
        decl.init = this.parseMaybeAssign(isFor);
      } else if (!allowMissingInitializer && kind === "const" && !(this.type === types$1._in || this.options.ecmaVersion >= 6 && this.isContextual("of"))) {
        this.unexpected();
      } else if (!allowMissingInitializer && decl.id.type !== "Identifier" && !(isFor && (this.type === types$1._in || this.isContextual("of")))) {
        this.raise(this.lastTokEnd, "Complex binding patterns require an initialization value");
      } else {
        decl.init = null;
      }
      node.declarations.push(this.finishNode(decl, "VariableDeclarator"));
      if (!this.eat(types$1.comma)) {
        break;
      }
    }
    return node;
  };
  pp$8.parseVarId = function(decl, kind) {
    decl.id = this.parseBindingAtom();
    this.checkLValPattern(decl.id, kind === "var" ? BIND_VAR : BIND_LEXICAL, false);
  };
  pp$8.parseFunction = function(node, statement, allowExpressionBody, isAsync, forInit) {
    this.initFunction(node);
    if (this.options.ecmaVersion >= 9 || this.options.ecmaVersion >= 6 && !isAsync) {
      if (this.type === types$1.star && statement & FUNC_HANGING_STATEMENT) {
        this.unexpected();
      }
      node.generator = this.eat(types$1.star);
    }
    if (this.options.ecmaVersion >= 8) {
      node.async = !!isAsync;
    }
    if (statement & FUNC_STATEMENT$1) {
      node.id = statement & FUNC_NULLABLE_ID$1 && this.type !== types$1.name ? null : this.parseIdent();
      if (node.id && !(statement & FUNC_HANGING_STATEMENT)) {
        this.checkLValSimple(node.id, this.strict || node.generator || node.async ? this.treatFunctionsAsVar ? BIND_VAR : BIND_LEXICAL : BIND_FUNCTION);
      }
    }
    var oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
    this.yieldPos = 0;
    this.awaitPos = 0;
    this.awaitIdentPos = 0;
    this.enterScope(functionFlags(node.async, node.generator));
    if (!(statement & FUNC_STATEMENT$1)) {
      node.id = this.type === types$1.name ? this.parseIdent() : null;
    }
    this.parseFunctionParams(node);
    this.parseFunctionBody(node, allowExpressionBody, false, forInit);
    this.yieldPos = oldYieldPos;
    this.awaitPos = oldAwaitPos;
    this.awaitIdentPos = oldAwaitIdentPos;
    return this.finishNode(node, statement & FUNC_STATEMENT$1 ? "FunctionDeclaration" : "FunctionExpression");
  };
  pp$8.parseFunctionParams = function(node) {
    this.expect(types$1.parenL);
    node.params = this.parseBindingList(types$1.parenR, false, this.options.ecmaVersion >= 8);
    this.checkYieldAwaitInDefaultParams();
  };
  pp$8.parseClass = function(node, isStatement) {
    this.next();
    var oldStrict = this.strict;
    this.strict = true;
    this.parseClassId(node, isStatement);
    this.parseClassSuper(node);
    var privateNameMap = this.enterClassBody();
    var classBody = this.startNode();
    var hadConstructor = false;
    classBody.body = [];
    this.expect(types$1.braceL);
    while (this.type !== types$1.braceR) {
      var element = this.parseClassElement(node.superClass !== null);
      if (element) {
        classBody.body.push(element);
        if (element.type === "MethodDefinition" && element.kind === "constructor") {
          if (hadConstructor) {
            this.raiseRecoverable(element.start, "Duplicate constructor in the same class");
          }
          hadConstructor = true;
        } else if (element.key && element.key.type === "PrivateIdentifier" && isPrivateNameConflicted(privateNameMap, element)) {
          this.raiseRecoverable(element.key.start, "Identifier '#" + element.key.name + "' has already been declared");
        }
      }
    }
    this.strict = oldStrict;
    this.next();
    node.body = this.finishNode(classBody, "ClassBody");
    this.exitClassBody();
    return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
  };
  pp$8.parseClassElement = function(constructorAllowsSuper) {
    if (this.eat(types$1.semi)) {
      return null;
    }
    var ecmaVersion2 = this.options.ecmaVersion;
    var node = this.startNode();
    var keyName = "";
    var isGenerator = false;
    var isAsync = false;
    var kind = "method";
    var isStatic = false;
    if (this.eatContextual("static")) {
      if (ecmaVersion2 >= 13 && this.eat(types$1.braceL)) {
        this.parseClassStaticBlock(node);
        return node;
      }
      if (this.isClassElementNameStart() || this.type === types$1.star) {
        isStatic = true;
      } else {
        keyName = "static";
      }
    }
    node.static = isStatic;
    if (!keyName && ecmaVersion2 >= 8 && this.eatContextual("async")) {
      if ((this.isClassElementNameStart() || this.type === types$1.star) && !this.canInsertSemicolon()) {
        isAsync = true;
      } else {
        keyName = "async";
      }
    }
    if (!keyName && (ecmaVersion2 >= 9 || !isAsync) && this.eat(types$1.star)) {
      isGenerator = true;
    }
    if (!keyName && !isAsync && !isGenerator) {
      var lastValue = this.value;
      if (this.eatContextual("get") || this.eatContextual("set")) {
        if (this.isClassElementNameStart()) {
          kind = lastValue;
        } else {
          keyName = lastValue;
        }
      }
    }
    if (keyName) {
      node.computed = false;
      node.key = this.startNodeAt(this.lastTokStart, this.lastTokStartLoc);
      node.key.name = keyName;
      this.finishNode(node.key, "Identifier");
    } else {
      this.parseClassElementName(node);
    }
    if (ecmaVersion2 < 13 || this.type === types$1.parenL || kind !== "method" || isGenerator || isAsync) {
      var isConstructor = !node.static && checkKeyName(node, "constructor");
      var allowsDirectSuper = isConstructor && constructorAllowsSuper;
      if (isConstructor && kind !== "method") {
        this.raise(node.key.start, "Constructor can't have get/set modifier");
      }
      node.kind = isConstructor ? "constructor" : kind;
      this.parseClassMethod(node, isGenerator, isAsync, allowsDirectSuper);
    } else {
      this.parseClassField(node);
    }
    return node;
  };
  pp$8.isClassElementNameStart = function() {
    return this.type === types$1.name || this.type === types$1.privateId || this.type === types$1.num || this.type === types$1.string || this.type === types$1.bracketL || this.type.keyword;
  };
  pp$8.parseClassElementName = function(element) {
    if (this.type === types$1.privateId) {
      if (this.value === "constructor") {
        this.raise(this.start, "Classes can't have an element named '#constructor'");
      }
      element.computed = false;
      element.key = this.parsePrivateIdent();
    } else {
      this.parsePropertyName(element);
    }
  };
  pp$8.parseClassMethod = function(method, isGenerator, isAsync, allowsDirectSuper) {
    var key = method.key;
    if (method.kind === "constructor") {
      if (isGenerator) {
        this.raise(key.start, "Constructor can't be a generator");
      }
      if (isAsync) {
        this.raise(key.start, "Constructor can't be an async method");
      }
    } else if (method.static && checkKeyName(method, "prototype")) {
      this.raise(key.start, "Classes may not have a static property named prototype");
    }
    var value = method.value = this.parseMethod(isGenerator, isAsync, allowsDirectSuper);
    if (method.kind === "get" && value.params.length !== 0) {
      this.raiseRecoverable(value.start, "getter should have no params");
    }
    if (method.kind === "set" && value.params.length !== 1) {
      this.raiseRecoverable(value.start, "setter should have exactly one param");
    }
    if (method.kind === "set" && value.params[0].type === "RestElement") {
      this.raiseRecoverable(value.params[0].start, "Setter cannot use rest params");
    }
    return this.finishNode(method, "MethodDefinition");
  };
  pp$8.parseClassField = function(field) {
    if (checkKeyName(field, "constructor")) {
      this.raise(field.key.start, "Classes can't have a field named 'constructor'");
    } else if (field.static && checkKeyName(field, "prototype")) {
      this.raise(field.key.start, "Classes can't have a static field named 'prototype'");
    }
    if (this.eat(types$1.eq)) {
      var scope = this.currentThisScope();
      var inClassFieldInit = scope.inClassFieldInit;
      scope.inClassFieldInit = true;
      field.value = this.parseMaybeAssign();
      scope.inClassFieldInit = inClassFieldInit;
    } else {
      field.value = null;
    }
    this.semicolon();
    return this.finishNode(field, "PropertyDefinition");
  };
  pp$8.parseClassStaticBlock = function(node) {
    node.body = [];
    var oldLabels = this.labels;
    this.labels = [];
    this.enterScope(SCOPE_CLASS_STATIC_BLOCK | SCOPE_SUPER);
    while (this.type !== types$1.braceR) {
      var stmt = this.parseStatement(null);
      node.body.push(stmt);
    }
    this.next();
    this.exitScope();
    this.labels = oldLabels;
    return this.finishNode(node, "StaticBlock");
  };
  pp$8.parseClassId = function(node, isStatement) {
    if (this.type === types$1.name) {
      node.id = this.parseIdent();
      if (isStatement) {
        this.checkLValSimple(node.id, BIND_LEXICAL, false);
      }
    } else {
      if (isStatement === true) {
        this.unexpected();
      }
      node.id = null;
    }
  };
  pp$8.parseClassSuper = function(node) {
    node.superClass = this.eat(types$1._extends) ? this.parseExprSubscripts(null, false) : null;
  };
  pp$8.enterClassBody = function() {
    var element = { declared: Object.create(null), used: [] };
    this.privateNameStack.push(element);
    return element.declared;
  };
  pp$8.exitClassBody = function() {
    var ref2 = this.privateNameStack.pop();
    var declared = ref2.declared;
    var used = ref2.used;
    if (!this.options.checkPrivateFields) {
      return;
    }
    var len = this.privateNameStack.length;
    var parent = len === 0 ? null : this.privateNameStack[len - 1];
    for (var i2 = 0;i2 < used.length; ++i2) {
      var id = used[i2];
      if (!hasOwn(declared, id.name)) {
        if (parent) {
          parent.used.push(id);
        } else {
          this.raiseRecoverable(id.start, "Private field '#" + id.name + "' must be declared in an enclosing class");
        }
      }
    }
  };
  pp$8.parseExportAllDeclaration = function(node, exports) {
    if (this.options.ecmaVersion >= 11) {
      if (this.eatContextual("as")) {
        node.exported = this.parseModuleExportName();
        this.checkExport(exports, node.exported, this.lastTokStart);
      } else {
        node.exported = null;
      }
    }
    this.expectContextual("from");
    if (this.type !== types$1.string) {
      this.unexpected();
    }
    node.source = this.parseExprAtom();
    this.semicolon();
    return this.finishNode(node, "ExportAllDeclaration");
  };
  pp$8.parseExport = function(node, exports) {
    this.next();
    if (this.eat(types$1.star)) {
      return this.parseExportAllDeclaration(node, exports);
    }
    if (this.eat(types$1._default)) {
      this.checkExport(exports, "default", this.lastTokStart);
      node.declaration = this.parseExportDefaultDeclaration();
      return this.finishNode(node, "ExportDefaultDeclaration");
    }
    if (this.shouldParseExportStatement()) {
      node.declaration = this.parseExportDeclaration(node);
      if (node.declaration.type === "VariableDeclaration") {
        this.checkVariableExport(exports, node.declaration.declarations);
      } else {
        this.checkExport(exports, node.declaration.id, node.declaration.id.start);
      }
      node.specifiers = [];
      node.source = null;
    } else {
      node.declaration = null;
      node.specifiers = this.parseExportSpecifiers(exports);
      if (this.eatContextual("from")) {
        if (this.type !== types$1.string) {
          this.unexpected();
        }
        node.source = this.parseExprAtom();
      } else {
        for (var i2 = 0, list2 = node.specifiers;i2 < list2.length; i2 += 1) {
          var spec = list2[i2];
          this.checkUnreserved(spec.local);
          this.checkLocalExport(spec.local);
          if (spec.local.type === "Literal") {
            this.raise(spec.local.start, "A string literal cannot be used as an exported binding without `from`.");
          }
        }
        node.source = null;
      }
      this.semicolon();
    }
    return this.finishNode(node, "ExportNamedDeclaration");
  };
  pp$8.parseExportDeclaration = function(node) {
    return this.parseStatement(null);
  };
  pp$8.parseExportDefaultDeclaration = function() {
    var isAsync;
    if (this.type === types$1._function || (isAsync = this.isAsyncFunction())) {
      var fNode = this.startNode();
      this.next();
      if (isAsync) {
        this.next();
      }
      return this.parseFunction(fNode, FUNC_STATEMENT$1 | FUNC_NULLABLE_ID$1, false, isAsync);
    } else if (this.type === types$1._class) {
      var cNode = this.startNode();
      return this.parseClass(cNode, "nullableID");
    } else {
      var declaration = this.parseMaybeAssign();
      this.semicolon();
      return declaration;
    }
  };
  pp$8.checkExport = function(exports, name, pos) {
    if (!exports) {
      return;
    }
    if (typeof name !== "string") {
      name = name.type === "Identifier" ? name.name : name.value;
    }
    if (hasOwn(exports, name)) {
      this.raiseRecoverable(pos, "Duplicate export '" + name + "'");
    }
    exports[name] = true;
  };
  pp$8.checkPatternExport = function(exports, pat) {
    var type = pat.type;
    if (type === "Identifier") {
      this.checkExport(exports, pat, pat.start);
    } else if (type === "ObjectPattern") {
      for (var i2 = 0, list2 = pat.properties;i2 < list2.length; i2 += 1) {
        var prop = list2[i2];
        this.checkPatternExport(exports, prop);
      }
    } else if (type === "ArrayPattern") {
      for (var i$1 = 0, list$1 = pat.elements;i$1 < list$1.length; i$1 += 1) {
        var elt = list$1[i$1];
        if (elt) {
          this.checkPatternExport(exports, elt);
        }
      }
    } else if (type === "Property") {
      this.checkPatternExport(exports, pat.value);
    } else if (type === "AssignmentPattern") {
      this.checkPatternExport(exports, pat.left);
    } else if (type === "RestElement") {
      this.checkPatternExport(exports, pat.argument);
    } else if (type === "ParenthesizedExpression") {
      this.checkPatternExport(exports, pat.expression);
    }
  };
  pp$8.checkVariableExport = function(exports, decls) {
    if (!exports) {
      return;
    }
    for (var i2 = 0, list2 = decls;i2 < list2.length; i2 += 1) {
      var decl = list2[i2];
      this.checkPatternExport(exports, decl.id);
    }
  };
  pp$8.shouldParseExportStatement = function() {
    return this.type.keyword === "var" || this.type.keyword === "const" || this.type.keyword === "class" || this.type.keyword === "function" || this.isLet() || this.isAsyncFunction();
  };
  pp$8.parseExportSpecifier = function(exports) {
    var node = this.startNode();
    node.local = this.parseModuleExportName();
    node.exported = this.eatContextual("as") ? this.parseModuleExportName() : node.local;
    this.checkExport(exports, node.exported, node.exported.start);
    return this.finishNode(node, "ExportSpecifier");
  };
  pp$8.parseExportSpecifiers = function(exports) {
    var nodes = [], first = true;
    this.expect(types$1.braceL);
    while (!this.eat(types$1.braceR)) {
      if (!first) {
        this.expect(types$1.comma);
        if (this.afterTrailingComma(types$1.braceR)) {
          break;
        }
      } else {
        first = false;
      }
      nodes.push(this.parseExportSpecifier(exports));
    }
    return nodes;
  };
  pp$8.parseImport = function(node) {
    this.next();
    if (this.type === types$1.string) {
      node.specifiers = empty$1;
      node.source = this.parseExprAtom();
    } else {
      node.specifiers = this.parseImportSpecifiers();
      this.expectContextual("from");
      node.source = this.type === types$1.string ? this.parseExprAtom() : this.unexpected();
    }
    this.semicolon();
    return this.finishNode(node, "ImportDeclaration");
  };
  pp$8.parseImportSpecifier = function() {
    var node = this.startNode();
    node.imported = this.parseModuleExportName();
    if (this.eatContextual("as")) {
      node.local = this.parseIdent();
    } else {
      this.checkUnreserved(node.imported);
      node.local = node.imported;
    }
    this.checkLValSimple(node.local, BIND_LEXICAL);
    return this.finishNode(node, "ImportSpecifier");
  };
  pp$8.parseImportDefaultSpecifier = function() {
    var node = this.startNode();
    node.local = this.parseIdent();
    this.checkLValSimple(node.local, BIND_LEXICAL);
    return this.finishNode(node, "ImportDefaultSpecifier");
  };
  pp$8.parseImportNamespaceSpecifier = function() {
    var node = this.startNode();
    this.next();
    this.expectContextual("as");
    node.local = this.parseIdent();
    this.checkLValSimple(node.local, BIND_LEXICAL);
    return this.finishNode(node, "ImportNamespaceSpecifier");
  };
  pp$8.parseImportSpecifiers = function() {
    var nodes = [], first = true;
    if (this.type === types$1.name) {
      nodes.push(this.parseImportDefaultSpecifier());
      if (!this.eat(types$1.comma)) {
        return nodes;
      }
    }
    if (this.type === types$1.star) {
      nodes.push(this.parseImportNamespaceSpecifier());
      return nodes;
    }
    this.expect(types$1.braceL);
    while (!this.eat(types$1.braceR)) {
      if (!first) {
        this.expect(types$1.comma);
        if (this.afterTrailingComma(types$1.braceR)) {
          break;
        }
      } else {
        first = false;
      }
      nodes.push(this.parseImportSpecifier());
    }
    return nodes;
  };
  pp$8.parseModuleExportName = function() {
    if (this.options.ecmaVersion >= 13 && this.type === types$1.string) {
      var stringLiteral = this.parseLiteral(this.value);
      if (loneSurrogate.test(stringLiteral.value)) {
        this.raise(stringLiteral.start, "An export name cannot include a lone surrogate.");
      }
      return stringLiteral;
    }
    return this.parseIdent(true);
  };
  pp$8.adaptDirectivePrologue = function(statements) {
    for (var i2 = 0;i2 < statements.length && this.isDirectiveCandidate(statements[i2]); ++i2) {
      statements[i2].directive = statements[i2].expression.raw.slice(1, -1);
    }
  };
  pp$8.isDirectiveCandidate = function(statement) {
    return this.options.ecmaVersion >= 5 && statement.type === "ExpressionStatement" && statement.expression.type === "Literal" && typeof statement.expression.value === "string" && (this.input[statement.start] === "\"" || this.input[statement.start] === "'");
  };
  pp$7 = Parser.prototype;
  pp$7.toAssignable = function(node, isBinding, refDestructuringErrors) {
    if (this.options.ecmaVersion >= 6 && node) {
      switch (node.type) {
        case "Identifier":
          if (this.inAsync && node.name === "await") {
            this.raise(node.start, "Cannot use 'await' as identifier inside an async function");
          }
          break;
        case "ObjectPattern":
        case "ArrayPattern":
        case "AssignmentPattern":
        case "RestElement":
          break;
        case "ObjectExpression":
          node.type = "ObjectPattern";
          if (refDestructuringErrors) {
            this.checkPatternErrors(refDestructuringErrors, true);
          }
          for (var i2 = 0, list2 = node.properties;i2 < list2.length; i2 += 1) {
            var prop = list2[i2];
            this.toAssignable(prop, isBinding);
            if (prop.type === "RestElement" && (prop.argument.type === "ArrayPattern" || prop.argument.type === "ObjectPattern")) {
              this.raise(prop.argument.start, "Unexpected token");
            }
          }
          break;
        case "Property":
          if (node.kind !== "init") {
            this.raise(node.key.start, "Object pattern can't contain getter or setter");
          }
          this.toAssignable(node.value, isBinding);
          break;
        case "ArrayExpression":
          node.type = "ArrayPattern";
          if (refDestructuringErrors) {
            this.checkPatternErrors(refDestructuringErrors, true);
          }
          this.toAssignableList(node.elements, isBinding);
          break;
        case "SpreadElement":
          node.type = "RestElement";
          this.toAssignable(node.argument, isBinding);
          if (node.argument.type === "AssignmentPattern") {
            this.raise(node.argument.start, "Rest elements cannot have a default value");
          }
          break;
        case "AssignmentExpression":
          if (node.operator !== "=") {
            this.raise(node.left.end, "Only '=' operator can be used for specifying default value.");
          }
          node.type = "AssignmentPattern";
          delete node.operator;
          this.toAssignable(node.left, isBinding);
          break;
        case "ParenthesizedExpression":
          this.toAssignable(node.expression, isBinding, refDestructuringErrors);
          break;
        case "ChainExpression":
          this.raiseRecoverable(node.start, "Optional chaining cannot appear in left-hand side");
          break;
        case "MemberExpression":
          if (!isBinding) {
            break;
          }
        default:
          this.raise(node.start, "Assigning to rvalue");
      }
    } else if (refDestructuringErrors) {
      this.checkPatternErrors(refDestructuringErrors, true);
    }
    return node;
  };
  pp$7.toAssignableList = function(exprList, isBinding) {
    var end = exprList.length;
    for (var i2 = 0;i2 < end; i2++) {
      var elt = exprList[i2];
      if (elt) {
        this.toAssignable(elt, isBinding);
      }
    }
    if (end) {
      var last = exprList[end - 1];
      if (this.options.ecmaVersion === 6 && isBinding && last && last.type === "RestElement" && last.argument.type !== "Identifier") {
        this.unexpected(last.argument.start);
      }
    }
    return exprList;
  };
  pp$7.parseSpread = function(refDestructuringErrors) {
    var node = this.startNode();
    this.next();
    node.argument = this.parseMaybeAssign(false, refDestructuringErrors);
    return this.finishNode(node, "SpreadElement");
  };
  pp$7.parseRestBinding = function() {
    var node = this.startNode();
    this.next();
    if (this.options.ecmaVersion === 6 && this.type !== types$1.name) {
      this.unexpected();
    }
    node.argument = this.parseBindingAtom();
    return this.finishNode(node, "RestElement");
  };
  pp$7.parseBindingAtom = function() {
    if (this.options.ecmaVersion >= 6) {
      switch (this.type) {
        case types$1.bracketL:
          var node = this.startNode();
          this.next();
          node.elements = this.parseBindingList(types$1.bracketR, true, true);
          return this.finishNode(node, "ArrayPattern");
        case types$1.braceL:
          return this.parseObj(true);
      }
    }
    return this.parseIdent();
  };
  pp$7.parseBindingList = function(close, allowEmpty, allowTrailingComma, allowModifiers) {
    var elts = [], first = true;
    while (!this.eat(close)) {
      if (first) {
        first = false;
      } else {
        this.expect(types$1.comma);
      }
      if (allowEmpty && this.type === types$1.comma) {
        elts.push(null);
      } else if (allowTrailingComma && this.afterTrailingComma(close)) {
        break;
      } else if (this.type === types$1.ellipsis) {
        var rest = this.parseRestBinding();
        this.parseBindingListItem(rest);
        elts.push(rest);
        if (this.type === types$1.comma) {
          this.raiseRecoverable(this.start, "Comma is not permitted after the rest element");
        }
        this.expect(close);
        break;
      } else {
        elts.push(this.parseAssignableListItem(allowModifiers));
      }
    }
    return elts;
  };
  pp$7.parseAssignableListItem = function(allowModifiers) {
    var elem = this.parseMaybeDefault(this.start, this.startLoc);
    this.parseBindingListItem(elem);
    return elem;
  };
  pp$7.parseBindingListItem = function(param) {
    return param;
  };
  pp$7.parseMaybeDefault = function(startPos, startLoc, left) {
    left = left || this.parseBindingAtom();
    if (this.options.ecmaVersion < 6 || !this.eat(types$1.eq)) {
      return left;
    }
    var node = this.startNodeAt(startPos, startLoc);
    node.left = left;
    node.right = this.parseMaybeAssign();
    return this.finishNode(node, "AssignmentPattern");
  };
  pp$7.checkLValSimple = function(expr, bindingType, checkClashes) {
    if (bindingType === undefined)
      bindingType = BIND_NONE;
    var isBind = bindingType !== BIND_NONE;
    switch (expr.type) {
      case "Identifier":
        if (this.strict && this.reservedWordsStrictBind.test(expr.name)) {
          this.raiseRecoverable(expr.start, (isBind ? "Binding " : "Assigning to ") + expr.name + " in strict mode");
        }
        if (isBind) {
          if (bindingType === BIND_LEXICAL && expr.name === "let") {
            this.raiseRecoverable(expr.start, "let is disallowed as a lexically bound name");
          }
          if (checkClashes) {
            if (hasOwn(checkClashes, expr.name)) {
              this.raiseRecoverable(expr.start, "Argument name clash");
            }
            checkClashes[expr.name] = true;
          }
          if (bindingType !== BIND_OUTSIDE) {
            this.declareName(expr.name, bindingType, expr.start);
          }
        }
        break;
      case "ChainExpression":
        this.raiseRecoverable(expr.start, "Optional chaining cannot appear in left-hand side");
        break;
      case "MemberExpression":
        if (isBind) {
          this.raiseRecoverable(expr.start, "Binding member expression");
        }
        break;
      case "ParenthesizedExpression":
        if (isBind) {
          this.raiseRecoverable(expr.start, "Binding parenthesized expression");
        }
        return this.checkLValSimple(expr.expression, bindingType, checkClashes);
      default:
        this.raise(expr.start, (isBind ? "Binding" : "Assigning to") + " rvalue");
    }
  };
  pp$7.checkLValPattern = function(expr, bindingType, checkClashes) {
    if (bindingType === undefined)
      bindingType = BIND_NONE;
    switch (expr.type) {
      case "ObjectPattern":
        for (var i2 = 0, list2 = expr.properties;i2 < list2.length; i2 += 1) {
          var prop = list2[i2];
          this.checkLValInnerPattern(prop, bindingType, checkClashes);
        }
        break;
      case "ArrayPattern":
        for (var i$1 = 0, list$1 = expr.elements;i$1 < list$1.length; i$1 += 1) {
          var elem = list$1[i$1];
          if (elem) {
            this.checkLValInnerPattern(elem, bindingType, checkClashes);
          }
        }
        break;
      default:
        this.checkLValSimple(expr, bindingType, checkClashes);
    }
  };
  pp$7.checkLValInnerPattern = function(expr, bindingType, checkClashes) {
    if (bindingType === undefined)
      bindingType = BIND_NONE;
    switch (expr.type) {
      case "Property":
        this.checkLValInnerPattern(expr.value, bindingType, checkClashes);
        break;
      case "AssignmentPattern":
        this.checkLValPattern(expr.left, bindingType, checkClashes);
        break;
      case "RestElement":
        this.checkLValPattern(expr.argument, bindingType, checkClashes);
        break;
      default:
        this.checkLValPattern(expr, bindingType, checkClashes);
    }
  };
  types3 = {
    b_stat: new TokContext("{", false),
    b_expr: new TokContext("{", true),
    b_tmpl: new TokContext("${", false),
    p_stat: new TokContext("(", false),
    p_expr: new TokContext("(", true),
    q_tmpl: new TokContext("`", true, true, function(p32) {
      return p32.tryReadTemplateToken();
    }),
    f_stat: new TokContext("function", false),
    f_expr: new TokContext("function", true),
    f_expr_gen: new TokContext("function", true, false, null, true),
    f_gen: new TokContext("function", false, false, null, true)
  };
  pp$6 = Parser.prototype;
  pp$6.initialContext = function() {
    return [types3.b_stat];
  };
  pp$6.curContext = function() {
    return this.context[this.context.length - 1];
  };
  pp$6.braceIsBlock = function(prevType) {
    var parent = this.curContext();
    if (parent === types3.f_expr || parent === types3.f_stat) {
      return true;
    }
    if (prevType === types$1.colon && (parent === types3.b_stat || parent === types3.b_expr)) {
      return !parent.isExpr;
    }
    if (prevType === types$1._return || prevType === types$1.name && this.exprAllowed) {
      return lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
    }
    if (prevType === types$1._else || prevType === types$1.semi || prevType === types$1.eof || prevType === types$1.parenR || prevType === types$1.arrow) {
      return true;
    }
    if (prevType === types$1.braceL) {
      return parent === types3.b_stat;
    }
    if (prevType === types$1._var || prevType === types$1._const || prevType === types$1.name) {
      return false;
    }
    return !this.exprAllowed;
  };
  pp$6.inGeneratorContext = function() {
    for (var i2 = this.context.length - 1;i2 >= 1; i2--) {
      var context = this.context[i2];
      if (context.token === "function") {
        return context.generator;
      }
    }
    return false;
  };
  pp$6.updateContext = function(prevType) {
    var update, type = this.type;
    if (type.keyword && prevType === types$1.dot) {
      this.exprAllowed = false;
    } else if (update = type.updateContext) {
      update.call(this, prevType);
    } else {
      this.exprAllowed = type.beforeExpr;
    }
  };
  pp$6.overrideContext = function(tokenCtx) {
    if (this.curContext() !== tokenCtx) {
      this.context[this.context.length - 1] = tokenCtx;
    }
  };
  types$1.parenR.updateContext = types$1.braceR.updateContext = function() {
    if (this.context.length === 1) {
      this.exprAllowed = true;
      return;
    }
    var out = this.context.pop();
    if (out === types3.b_stat && this.curContext().token === "function") {
      out = this.context.pop();
    }
    this.exprAllowed = !out.isExpr;
  };
  types$1.braceL.updateContext = function(prevType) {
    this.context.push(this.braceIsBlock(prevType) ? types3.b_stat : types3.b_expr);
    this.exprAllowed = true;
  };
  types$1.dollarBraceL.updateContext = function() {
    this.context.push(types3.b_tmpl);
    this.exprAllowed = true;
  };
  types$1.parenL.updateContext = function(prevType) {
    var statementParens = prevType === types$1._if || prevType === types$1._for || prevType === types$1._with || prevType === types$1._while;
    this.context.push(statementParens ? types3.p_stat : types3.p_expr);
    this.exprAllowed = true;
  };
  types$1.incDec.updateContext = function() {
  };
  types$1._function.updateContext = types$1._class.updateContext = function(prevType) {
    if (prevType.beforeExpr && prevType !== types$1._else && !(prevType === types$1.semi && this.curContext() !== types3.p_stat) && !(prevType === types$1._return && lineBreak.test(this.input.slice(this.lastTokEnd, this.start))) && !((prevType === types$1.colon || prevType === types$1.braceL) && this.curContext() === types3.b_stat)) {
      this.context.push(types3.f_expr);
    } else {
      this.context.push(types3.f_stat);
    }
    this.exprAllowed = false;
  };
  types$1.backQuote.updateContext = function() {
    if (this.curContext() === types3.q_tmpl) {
      this.context.pop();
    } else {
      this.context.push(types3.q_tmpl);
    }
    this.exprAllowed = false;
  };
  types$1.star.updateContext = function(prevType) {
    if (prevType === types$1._function) {
      var index = this.context.length - 1;
      if (this.context[index] === types3.f_expr) {
        this.context[index] = types3.f_expr_gen;
      } else {
        this.context[index] = types3.f_gen;
      }
    }
    this.exprAllowed = true;
  };
  types$1.name.updateContext = function(prevType) {
    var allowed = false;
    if (this.options.ecmaVersion >= 6 && prevType !== types$1.dot) {
      if (this.value === "of" && !this.exprAllowed || this.value === "yield" && this.inGeneratorContext()) {
        allowed = true;
      }
    }
    this.exprAllowed = allowed;
  };
  pp$5 = Parser.prototype;
  pp$5.checkPropClash = function(prop, propHash, refDestructuringErrors) {
    if (this.options.ecmaVersion >= 9 && prop.type === "SpreadElement") {
      return;
    }
    if (this.options.ecmaVersion >= 6 && (prop.computed || prop.method || prop.shorthand)) {
      return;
    }
    var key = prop.key;
    var name;
    switch (key.type) {
      case "Identifier":
        name = key.name;
        break;
      case "Literal":
        name = String(key.value);
        break;
      default:
        return;
    }
    var kind = prop.kind;
    if (this.options.ecmaVersion >= 6) {
      if (name === "__proto__" && kind === "init") {
        if (propHash.proto) {
          if (refDestructuringErrors) {
            if (refDestructuringErrors.doubleProto < 0) {
              refDestructuringErrors.doubleProto = key.start;
            }
          } else {
            this.raiseRecoverable(key.start, "Redefinition of __proto__ property");
          }
        }
        propHash.proto = true;
      }
      return;
    }
    name = "$" + name;
    var other = propHash[name];
    if (other) {
      var redefinition;
      if (kind === "init") {
        redefinition = this.strict && other.init || other.get || other.set;
      } else {
        redefinition = other.init || other[kind];
      }
      if (redefinition) {
        this.raiseRecoverable(key.start, "Redefinition of property");
      }
    } else {
      other = propHash[name] = {
        init: false,
        get: false,
        set: false
      };
    }
    other[kind] = true;
  };
  pp$5.parseExpression = function(forInit, refDestructuringErrors) {
    var startPos = this.start, startLoc = this.startLoc;
    var expr = this.parseMaybeAssign(forInit, refDestructuringErrors);
    if (this.type === types$1.comma) {
      var node = this.startNodeAt(startPos, startLoc);
      node.expressions = [expr];
      while (this.eat(types$1.comma)) {
        node.expressions.push(this.parseMaybeAssign(forInit, refDestructuringErrors));
      }
      return this.finishNode(node, "SequenceExpression");
    }
    return expr;
  };
  pp$5.parseMaybeAssign = function(forInit, refDestructuringErrors, afterLeftParse) {
    if (this.isContextual("yield")) {
      if (this.inGenerator) {
        return this.parseYield(forInit);
      } else {
        this.exprAllowed = false;
      }
    }
    var ownDestructuringErrors = false, oldParenAssign = -1, oldTrailingComma = -1, oldDoubleProto = -1;
    if (refDestructuringErrors) {
      oldParenAssign = refDestructuringErrors.parenthesizedAssign;
      oldTrailingComma = refDestructuringErrors.trailingComma;
      oldDoubleProto = refDestructuringErrors.doubleProto;
      refDestructuringErrors.parenthesizedAssign = refDestructuringErrors.trailingComma = -1;
    } else {
      refDestructuringErrors = new DestructuringErrors;
      ownDestructuringErrors = true;
    }
    var startPos = this.start, startLoc = this.startLoc;
    if (this.type === types$1.parenL || this.type === types$1.name) {
      this.potentialArrowAt = this.start;
      this.potentialArrowInForAwait = forInit === "await";
    }
    var left = this.parseMaybeConditional(forInit, refDestructuringErrors);
    if (afterLeftParse) {
      left = afterLeftParse.call(this, left, startPos, startLoc);
    }
    if (this.type.isAssign) {
      var node = this.startNodeAt(startPos, startLoc);
      node.operator = this.value;
      if (this.type === types$1.eq) {
        left = this.toAssignable(left, false, refDestructuringErrors);
      }
      if (!ownDestructuringErrors) {
        refDestructuringErrors.parenthesizedAssign = refDestructuringErrors.trailingComma = refDestructuringErrors.doubleProto = -1;
      }
      if (refDestructuringErrors.shorthandAssign >= left.start) {
        refDestructuringErrors.shorthandAssign = -1;
      }
      if (this.type === types$1.eq) {
        this.checkLValPattern(left);
      } else {
        this.checkLValSimple(left);
      }
      node.left = left;
      this.next();
      node.right = this.parseMaybeAssign(forInit);
      if (oldDoubleProto > -1) {
        refDestructuringErrors.doubleProto = oldDoubleProto;
      }
      return this.finishNode(node, "AssignmentExpression");
    } else {
      if (ownDestructuringErrors) {
        this.checkExpressionErrors(refDestructuringErrors, true);
      }
    }
    if (oldParenAssign > -1) {
      refDestructuringErrors.parenthesizedAssign = oldParenAssign;
    }
    if (oldTrailingComma > -1) {
      refDestructuringErrors.trailingComma = oldTrailingComma;
    }
    return left;
  };
  pp$5.parseMaybeConditional = function(forInit, refDestructuringErrors) {
    var startPos = this.start, startLoc = this.startLoc;
    var expr = this.parseExprOps(forInit, refDestructuringErrors);
    if (this.checkExpressionErrors(refDestructuringErrors)) {
      return expr;
    }
    if (this.eat(types$1.question)) {
      var node = this.startNodeAt(startPos, startLoc);
      node.test = expr;
      node.consequent = this.parseMaybeAssign();
      this.expect(types$1.colon);
      node.alternate = this.parseMaybeAssign(forInit);
      return this.finishNode(node, "ConditionalExpression");
    }
    return expr;
  };
  pp$5.parseExprOps = function(forInit, refDestructuringErrors) {
    var startPos = this.start, startLoc = this.startLoc;
    var expr = this.parseMaybeUnary(refDestructuringErrors, false, false, forInit);
    if (this.checkExpressionErrors(refDestructuringErrors)) {
      return expr;
    }
    return expr.start === startPos && expr.type === "ArrowFunctionExpression" ? expr : this.parseExprOp(expr, startPos, startLoc, -1, forInit);
  };
  pp$5.parseExprOp = function(left, leftStartPos, leftStartLoc, minPrec, forInit) {
    var prec = this.type.binop;
    if (prec != null && (!forInit || this.type !== types$1._in)) {
      if (prec > minPrec) {
        var logical = this.type === types$1.logicalOR || this.type === types$1.logicalAND;
        var coalesce = this.type === types$1.coalesce;
        if (coalesce) {
          prec = types$1.logicalAND.binop;
        }
        var op = this.value;
        this.next();
        var startPos = this.start, startLoc = this.startLoc;
        var right = this.parseExprOp(this.parseMaybeUnary(null, false, false, forInit), startPos, startLoc, prec, forInit);
        var node = this.buildBinary(leftStartPos, leftStartLoc, left, right, op, logical || coalesce);
        if (logical && this.type === types$1.coalesce || coalesce && (this.type === types$1.logicalOR || this.type === types$1.logicalAND)) {
          this.raiseRecoverable(this.start, "Logical expressions and coalesce expressions cannot be mixed. Wrap either by parentheses");
        }
        return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec, forInit);
      }
    }
    return left;
  };
  pp$5.buildBinary = function(startPos, startLoc, left, right, op, logical) {
    if (right.type === "PrivateIdentifier") {
      this.raise(right.start, "Private identifier can only be left side of binary expression");
    }
    var node = this.startNodeAt(startPos, startLoc);
    node.left = left;
    node.operator = op;
    node.right = right;
    return this.finishNode(node, logical ? "LogicalExpression" : "BinaryExpression");
  };
  pp$5.parseMaybeUnary = function(refDestructuringErrors, sawUnary, incDec, forInit) {
    var startPos = this.start, startLoc = this.startLoc, expr;
    if (this.isContextual("await") && this.canAwait) {
      expr = this.parseAwait(forInit);
      sawUnary = true;
    } else if (this.type.prefix) {
      var node = this.startNode(), update = this.type === types$1.incDec;
      node.operator = this.value;
      node.prefix = true;
      this.next();
      node.argument = this.parseMaybeUnary(null, true, update, forInit);
      this.checkExpressionErrors(refDestructuringErrors, true);
      if (update) {
        this.checkLValSimple(node.argument);
      } else if (this.strict && node.operator === "delete" && node.argument.type === "Identifier") {
        this.raiseRecoverable(node.start, "Deleting local variable in strict mode");
      } else if (node.operator === "delete" && isPrivateFieldAccess(node.argument)) {
        this.raiseRecoverable(node.start, "Private fields can not be deleted");
      } else {
        sawUnary = true;
      }
      expr = this.finishNode(node, update ? "UpdateExpression" : "UnaryExpression");
    } else if (!sawUnary && this.type === types$1.privateId) {
      if ((forInit || this.privateNameStack.length === 0) && this.options.checkPrivateFields) {
        this.unexpected();
      }
      expr = this.parsePrivateIdent();
      if (this.type !== types$1._in) {
        this.unexpected();
      }
    } else {
      expr = this.parseExprSubscripts(refDestructuringErrors, forInit);
      if (this.checkExpressionErrors(refDestructuringErrors)) {
        return expr;
      }
      while (this.type.postfix && !this.canInsertSemicolon()) {
        var node$1 = this.startNodeAt(startPos, startLoc);
        node$1.operator = this.value;
        node$1.prefix = false;
        node$1.argument = expr;
        this.checkLValSimple(expr);
        this.next();
        expr = this.finishNode(node$1, "UpdateExpression");
      }
    }
    if (!incDec && this.eat(types$1.starstar)) {
      if (sawUnary) {
        this.unexpected(this.lastTokStart);
      } else {
        return this.buildBinary(startPos, startLoc, expr, this.parseMaybeUnary(null, false, false, forInit), "**", false);
      }
    } else {
      return expr;
    }
  };
  pp$5.parseExprSubscripts = function(refDestructuringErrors, forInit) {
    var startPos = this.start, startLoc = this.startLoc;
    var expr = this.parseExprAtom(refDestructuringErrors, forInit);
    if (expr.type === "ArrowFunctionExpression" && this.input.slice(this.lastTokStart, this.lastTokEnd) !== ")") {
      return expr;
    }
    var result2 = this.parseSubscripts(expr, startPos, startLoc, false, forInit);
    if (refDestructuringErrors && result2.type === "MemberExpression") {
      if (refDestructuringErrors.parenthesizedAssign >= result2.start) {
        refDestructuringErrors.parenthesizedAssign = -1;
      }
      if (refDestructuringErrors.parenthesizedBind >= result2.start) {
        refDestructuringErrors.parenthesizedBind = -1;
      }
      if (refDestructuringErrors.trailingComma >= result2.start) {
        refDestructuringErrors.trailingComma = -1;
      }
    }
    return result2;
  };
  pp$5.parseSubscripts = function(base2, startPos, startLoc, noCalls, forInit) {
    var maybeAsyncArrow = this.options.ecmaVersion >= 8 && base2.type === "Identifier" && base2.name === "async" && this.lastTokEnd === base2.end && !this.canInsertSemicolon() && base2.end - base2.start === 5 && this.potentialArrowAt === base2.start;
    var optionalChained = false;
    while (true) {
      var element = this.parseSubscript(base2, startPos, startLoc, noCalls, maybeAsyncArrow, optionalChained, forInit);
      if (element.optional) {
        optionalChained = true;
      }
      if (element === base2 || element.type === "ArrowFunctionExpression") {
        if (optionalChained) {
          var chainNode = this.startNodeAt(startPos, startLoc);
          chainNode.expression = element;
          element = this.finishNode(chainNode, "ChainExpression");
        }
        return element;
      }
      base2 = element;
    }
  };
  pp$5.shouldParseAsyncArrow = function() {
    return !this.canInsertSemicolon() && this.eat(types$1.arrow);
  };
  pp$5.parseSubscriptAsyncArrow = function(startPos, startLoc, exprList, forInit) {
    return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList, true, forInit);
  };
  pp$5.parseSubscript = function(base2, startPos, startLoc, noCalls, maybeAsyncArrow, optionalChained, forInit) {
    var optionalSupported = this.options.ecmaVersion >= 11;
    var optional = optionalSupported && this.eat(types$1.questionDot);
    if (noCalls && optional) {
      this.raise(this.lastTokStart, "Optional chaining cannot appear in the callee of new expressions");
    }
    var computed = this.eat(types$1.bracketL);
    if (computed || optional && this.type !== types$1.parenL && this.type !== types$1.backQuote || this.eat(types$1.dot)) {
      var node = this.startNodeAt(startPos, startLoc);
      node.object = base2;
      if (computed) {
        node.property = this.parseExpression();
        this.expect(types$1.bracketR);
      } else if (this.type === types$1.privateId && base2.type !== "Super") {
        node.property = this.parsePrivateIdent();
      } else {
        node.property = this.parseIdent(this.options.allowReserved !== "never");
      }
      node.computed = !!computed;
      if (optionalSupported) {
        node.optional = optional;
      }
      base2 = this.finishNode(node, "MemberExpression");
    } else if (!noCalls && this.eat(types$1.parenL)) {
      var refDestructuringErrors = new DestructuringErrors, oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
      this.yieldPos = 0;
      this.awaitPos = 0;
      this.awaitIdentPos = 0;
      var exprList = this.parseExprList(types$1.parenR, this.options.ecmaVersion >= 8, false, refDestructuringErrors);
      if (maybeAsyncArrow && !optional && this.shouldParseAsyncArrow()) {
        this.checkPatternErrors(refDestructuringErrors, false);
        this.checkYieldAwaitInDefaultParams();
        if (this.awaitIdentPos > 0) {
          this.raise(this.awaitIdentPos, "Cannot use 'await' as identifier inside an async function");
        }
        this.yieldPos = oldYieldPos;
        this.awaitPos = oldAwaitPos;
        this.awaitIdentPos = oldAwaitIdentPos;
        return this.parseSubscriptAsyncArrow(startPos, startLoc, exprList, forInit);
      }
      this.checkExpressionErrors(refDestructuringErrors, true);
      this.yieldPos = oldYieldPos || this.yieldPos;
      this.awaitPos = oldAwaitPos || this.awaitPos;
      this.awaitIdentPos = oldAwaitIdentPos || this.awaitIdentPos;
      var node$1 = this.startNodeAt(startPos, startLoc);
      node$1.callee = base2;
      node$1.arguments = exprList;
      if (optionalSupported) {
        node$1.optional = optional;
      }
      base2 = this.finishNode(node$1, "CallExpression");
    } else if (this.type === types$1.backQuote) {
      if (optional || optionalChained) {
        this.raise(this.start, "Optional chaining cannot appear in the tag of tagged template expressions");
      }
      var node$2 = this.startNodeAt(startPos, startLoc);
      node$2.tag = base2;
      node$2.quasi = this.parseTemplate({ isTagged: true });
      base2 = this.finishNode(node$2, "TaggedTemplateExpression");
    }
    return base2;
  };
  pp$5.parseExprAtom = function(refDestructuringErrors, forInit, forNew) {
    if (this.type === types$1.slash) {
      this.readRegexp();
    }
    var node, canBeArrow = this.potentialArrowAt === this.start;
    switch (this.type) {
      case types$1._super:
        if (!this.allowSuper) {
          this.raise(this.start, "'super' keyword outside a method");
        }
        node = this.startNode();
        this.next();
        if (this.type === types$1.parenL && !this.allowDirectSuper) {
          this.raise(node.start, "super() call outside constructor of a subclass");
        }
        if (this.type !== types$1.dot && this.type !== types$1.bracketL && this.type !== types$1.parenL) {
          this.unexpected();
        }
        return this.finishNode(node, "Super");
      case types$1._this:
        node = this.startNode();
        this.next();
        return this.finishNode(node, "ThisExpression");
      case types$1.name:
        var startPos = this.start, startLoc = this.startLoc, containsEsc = this.containsEsc;
        var id = this.parseIdent(false);
        if (this.options.ecmaVersion >= 8 && !containsEsc && id.name === "async" && !this.canInsertSemicolon() && this.eat(types$1._function)) {
          this.overrideContext(types3.f_expr);
          return this.parseFunction(this.startNodeAt(startPos, startLoc), 0, false, true, forInit);
        }
        if (canBeArrow && !this.canInsertSemicolon()) {
          if (this.eat(types$1.arrow)) {
            return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id], false, forInit);
          }
          if (this.options.ecmaVersion >= 8 && id.name === "async" && this.type === types$1.name && !containsEsc && (!this.potentialArrowInForAwait || this.value !== "of" || this.containsEsc)) {
            id = this.parseIdent(false);
            if (this.canInsertSemicolon() || !this.eat(types$1.arrow)) {
              this.unexpected();
            }
            return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id], true, forInit);
          }
        }
        return id;
      case types$1.regexp:
        var value = this.value;
        node = this.parseLiteral(value.value);
        node.regex = { pattern: value.pattern, flags: value.flags };
        return node;
      case types$1.num:
      case types$1.string:
        return this.parseLiteral(this.value);
      case types$1._null:
      case types$1._true:
      case types$1._false:
        node = this.startNode();
        node.value = this.type === types$1._null ? null : this.type === types$1._true;
        node.raw = this.type.keyword;
        this.next();
        return this.finishNode(node, "Literal");
      case types$1.parenL:
        var start = this.start, expr = this.parseParenAndDistinguishExpression(canBeArrow, forInit);
        if (refDestructuringErrors) {
          if (refDestructuringErrors.parenthesizedAssign < 0 && !this.isSimpleAssignTarget(expr)) {
            refDestructuringErrors.parenthesizedAssign = start;
          }
          if (refDestructuringErrors.parenthesizedBind < 0) {
            refDestructuringErrors.parenthesizedBind = start;
          }
        }
        return expr;
      case types$1.bracketL:
        node = this.startNode();
        this.next();
        node.elements = this.parseExprList(types$1.bracketR, true, true, refDestructuringErrors);
        return this.finishNode(node, "ArrayExpression");
      case types$1.braceL:
        this.overrideContext(types3.b_expr);
        return this.parseObj(false, refDestructuringErrors);
      case types$1._function:
        node = this.startNode();
        this.next();
        return this.parseFunction(node, 0);
      case types$1._class:
        return this.parseClass(this.startNode(), false);
      case types$1._new:
        return this.parseNew();
      case types$1.backQuote:
        return this.parseTemplate();
      case types$1._import:
        if (this.options.ecmaVersion >= 11) {
          return this.parseExprImport(forNew);
        } else {
          return this.unexpected();
        }
      default:
        return this.parseExprAtomDefault();
    }
  };
  pp$5.parseExprAtomDefault = function() {
    this.unexpected();
  };
  pp$5.parseExprImport = function(forNew) {
    var node = this.startNode();
    if (this.containsEsc) {
      this.raiseRecoverable(this.start, "Escape sequence in keyword import");
    }
    var meta = this.parseIdent(true);
    if (this.type === types$1.parenL && !forNew) {
      return this.parseDynamicImport(node);
    } else if (this.type === types$1.dot) {
      node.meta = meta;
      return this.parseImportMeta(node);
    } else {
      this.unexpected();
    }
  };
  pp$5.parseDynamicImport = function(node) {
    this.next();
    node.source = this.parseMaybeAssign();
    if (!this.eat(types$1.parenR)) {
      var errorPos = this.start;
      if (this.eat(types$1.comma) && this.eat(types$1.parenR)) {
        this.raiseRecoverable(errorPos, "Trailing comma is not allowed in import()");
      } else {
        this.unexpected(errorPos);
      }
    }
    return this.finishNode(node, "ImportExpression");
  };
  pp$5.parseImportMeta = function(node) {
    this.next();
    var containsEsc = this.containsEsc;
    node.property = this.parseIdent(true);
    if (node.property.name !== "meta") {
      this.raiseRecoverable(node.property.start, "The only valid meta property for import is 'import.meta'");
    }
    if (containsEsc) {
      this.raiseRecoverable(node.start, "'import.meta' must not contain escaped characters");
    }
    if (this.options.sourceType !== "module" && !this.options.allowImportExportEverywhere) {
      this.raiseRecoverable(node.start, "Cannot use 'import.meta' outside a module");
    }
    return this.finishNode(node, "MetaProperty");
  };
  pp$5.parseLiteral = function(value) {
    var node = this.startNode();
    node.value = value;
    node.raw = this.input.slice(this.start, this.end);
    if (node.raw.charCodeAt(node.raw.length - 1) === 110) {
      node.bigint = node.raw.slice(0, -1).replace(/_/g, "");
    }
    this.next();
    return this.finishNode(node, "Literal");
  };
  pp$5.parseParenExpression = function() {
    this.expect(types$1.parenL);
    var val2 = this.parseExpression();
    this.expect(types$1.parenR);
    return val2;
  };
  pp$5.shouldParseArrow = function(exprList) {
    return !this.canInsertSemicolon();
  };
  pp$5.parseParenAndDistinguishExpression = function(canBeArrow, forInit) {
    var startPos = this.start, startLoc = this.startLoc, val2, allowTrailingComma = this.options.ecmaVersion >= 8;
    if (this.options.ecmaVersion >= 6) {
      this.next();
      var innerStartPos = this.start, innerStartLoc = this.startLoc;
      var exprList = [], first = true, lastIsComma = false;
      var refDestructuringErrors = new DestructuringErrors, oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, spreadStart;
      this.yieldPos = 0;
      this.awaitPos = 0;
      while (this.type !== types$1.parenR) {
        first ? first = false : this.expect(types$1.comma);
        if (allowTrailingComma && this.afterTrailingComma(types$1.parenR, true)) {
          lastIsComma = true;
          break;
        } else if (this.type === types$1.ellipsis) {
          spreadStart = this.start;
          exprList.push(this.parseParenItem(this.parseRestBinding()));
          if (this.type === types$1.comma) {
            this.raiseRecoverable(this.start, "Comma is not permitted after the rest element");
          }
          break;
        } else {
          exprList.push(this.parseMaybeAssign(false, refDestructuringErrors, this.parseParenItem));
        }
      }
      var innerEndPos = this.lastTokEnd, innerEndLoc = this.lastTokEndLoc;
      this.expect(types$1.parenR);
      if (canBeArrow && this.shouldParseArrow(exprList) && this.eat(types$1.arrow)) {
        this.checkPatternErrors(refDestructuringErrors, false);
        this.checkYieldAwaitInDefaultParams();
        this.yieldPos = oldYieldPos;
        this.awaitPos = oldAwaitPos;
        return this.parseParenArrowList(startPos, startLoc, exprList, forInit);
      }
      if (!exprList.length || lastIsComma) {
        this.unexpected(this.lastTokStart);
      }
      if (spreadStart) {
        this.unexpected(spreadStart);
      }
      this.checkExpressionErrors(refDestructuringErrors, true);
      this.yieldPos = oldYieldPos || this.yieldPos;
      this.awaitPos = oldAwaitPos || this.awaitPos;
      if (exprList.length > 1) {
        val2 = this.startNodeAt(innerStartPos, innerStartLoc);
        val2.expressions = exprList;
        this.finishNodeAt(val2, "SequenceExpression", innerEndPos, innerEndLoc);
      } else {
        val2 = exprList[0];
      }
    } else {
      val2 = this.parseParenExpression();
    }
    if (this.options.preserveParens) {
      var par = this.startNodeAt(startPos, startLoc);
      par.expression = val2;
      return this.finishNode(par, "ParenthesizedExpression");
    } else {
      return val2;
    }
  };
  pp$5.parseParenItem = function(item) {
    return item;
  };
  pp$5.parseParenArrowList = function(startPos, startLoc, exprList, forInit) {
    return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList, false, forInit);
  };
  empty = [];
  pp$5.parseNew = function() {
    if (this.containsEsc) {
      this.raiseRecoverable(this.start, "Escape sequence in keyword new");
    }
    var node = this.startNode();
    var meta = this.parseIdent(true);
    if (this.options.ecmaVersion >= 6 && this.eat(types$1.dot)) {
      node.meta = meta;
      var containsEsc = this.containsEsc;
      node.property = this.parseIdent(true);
      if (node.property.name !== "target") {
        this.raiseRecoverable(node.property.start, "The only valid meta property for new is 'new.target'");
      }
      if (containsEsc) {
        this.raiseRecoverable(node.start, "'new.target' must not contain escaped characters");
      }
      if (!this.allowNewDotTarget) {
        this.raiseRecoverable(node.start, "'new.target' can only be used in functions and class static block");
      }
      return this.finishNode(node, "MetaProperty");
    }
    var startPos = this.start, startLoc = this.startLoc;
    node.callee = this.parseSubscripts(this.parseExprAtom(null, false, true), startPos, startLoc, true, false);
    if (this.eat(types$1.parenL)) {
      node.arguments = this.parseExprList(types$1.parenR, this.options.ecmaVersion >= 8, false);
    } else {
      node.arguments = empty;
    }
    return this.finishNode(node, "NewExpression");
  };
  pp$5.parseTemplateElement = function(ref2) {
    var isTagged = ref2.isTagged;
    var elem = this.startNode();
    if (this.type === types$1.invalidTemplate) {
      if (!isTagged) {
        this.raiseRecoverable(this.start, "Bad escape sequence in untagged template literal");
      }
      elem.value = {
        raw: this.value,
        cooked: null
      };
    } else {
      elem.value = {
        raw: this.input.slice(this.start, this.end).replace(/\r\n?/g, "\n"),
        cooked: this.value
      };
    }
    this.next();
    elem.tail = this.type === types$1.backQuote;
    return this.finishNode(elem, "TemplateElement");
  };
  pp$5.parseTemplate = function(ref2) {
    if (ref2 === undefined)
      ref2 = {};
    var isTagged = ref2.isTagged;
    if (isTagged === undefined)
      isTagged = false;
    var node = this.startNode();
    this.next();
    node.expressions = [];
    var curElt = this.parseTemplateElement({ isTagged });
    node.quasis = [curElt];
    while (!curElt.tail) {
      if (this.type === types$1.eof) {
        this.raise(this.pos, "Unterminated template literal");
      }
      this.expect(types$1.dollarBraceL);
      node.expressions.push(this.parseExpression());
      this.expect(types$1.braceR);
      node.quasis.push(curElt = this.parseTemplateElement({ isTagged }));
    }
    this.next();
    return this.finishNode(node, "TemplateLiteral");
  };
  pp$5.isAsyncProp = function(prop) {
    return !prop.computed && prop.key.type === "Identifier" && prop.key.name === "async" && (this.type === types$1.name || this.type === types$1.num || this.type === types$1.string || this.type === types$1.bracketL || this.type.keyword || this.options.ecmaVersion >= 9 && this.type === types$1.star) && !lineBreak.test(this.input.slice(this.lastTokEnd, this.start));
  };
  pp$5.parseObj = function(isPattern, refDestructuringErrors) {
    var node = this.startNode(), first = true, propHash = {};
    node.properties = [];
    this.next();
    while (!this.eat(types$1.braceR)) {
      if (!first) {
        this.expect(types$1.comma);
        if (this.options.ecmaVersion >= 5 && this.afterTrailingComma(types$1.braceR)) {
          break;
        }
      } else {
        first = false;
      }
      var prop = this.parseProperty(isPattern, refDestructuringErrors);
      if (!isPattern) {
        this.checkPropClash(prop, propHash, refDestructuringErrors);
      }
      node.properties.push(prop);
    }
    return this.finishNode(node, isPattern ? "ObjectPattern" : "ObjectExpression");
  };
  pp$5.parseProperty = function(isPattern, refDestructuringErrors) {
    var prop = this.startNode(), isGenerator, isAsync, startPos, startLoc;
    if (this.options.ecmaVersion >= 9 && this.eat(types$1.ellipsis)) {
      if (isPattern) {
        prop.argument = this.parseIdent(false);
        if (this.type === types$1.comma) {
          this.raiseRecoverable(this.start, "Comma is not permitted after the rest element");
        }
        return this.finishNode(prop, "RestElement");
      }
      prop.argument = this.parseMaybeAssign(false, refDestructuringErrors);
      if (this.type === types$1.comma && refDestructuringErrors && refDestructuringErrors.trailingComma < 0) {
        refDestructuringErrors.trailingComma = this.start;
      }
      return this.finishNode(prop, "SpreadElement");
    }
    if (this.options.ecmaVersion >= 6) {
      prop.method = false;
      prop.shorthand = false;
      if (isPattern || refDestructuringErrors) {
        startPos = this.start;
        startLoc = this.startLoc;
      }
      if (!isPattern) {
        isGenerator = this.eat(types$1.star);
      }
    }
    var containsEsc = this.containsEsc;
    this.parsePropertyName(prop);
    if (!isPattern && !containsEsc && this.options.ecmaVersion >= 8 && !isGenerator && this.isAsyncProp(prop)) {
      isAsync = true;
      isGenerator = this.options.ecmaVersion >= 9 && this.eat(types$1.star);
      this.parsePropertyName(prop);
    } else {
      isAsync = false;
    }
    this.parsePropertyValue(prop, isPattern, isGenerator, isAsync, startPos, startLoc, refDestructuringErrors, containsEsc);
    return this.finishNode(prop, "Property");
  };
  pp$5.parseGetterSetter = function(prop) {
    prop.kind = prop.key.name;
    this.parsePropertyName(prop);
    prop.value = this.parseMethod(false);
    var paramCount = prop.kind === "get" ? 0 : 1;
    if (prop.value.params.length !== paramCount) {
      var start = prop.value.start;
      if (prop.kind === "get") {
        this.raiseRecoverable(start, "getter should have no params");
      } else {
        this.raiseRecoverable(start, "setter should have exactly one param");
      }
    } else {
      if (prop.kind === "set" && prop.value.params[0].type === "RestElement") {
        this.raiseRecoverable(prop.value.params[0].start, "Setter cannot use rest params");
      }
    }
  };
  pp$5.parsePropertyValue = function(prop, isPattern, isGenerator, isAsync, startPos, startLoc, refDestructuringErrors, containsEsc) {
    if ((isGenerator || isAsync) && this.type === types$1.colon) {
      this.unexpected();
    }
    if (this.eat(types$1.colon)) {
      prop.value = isPattern ? this.parseMaybeDefault(this.start, this.startLoc) : this.parseMaybeAssign(false, refDestructuringErrors);
      prop.kind = "init";
    } else if (this.options.ecmaVersion >= 6 && this.type === types$1.parenL) {
      if (isPattern) {
        this.unexpected();
      }
      prop.kind = "init";
      prop.method = true;
      prop.value = this.parseMethod(isGenerator, isAsync);
    } else if (!isPattern && !containsEsc && this.options.ecmaVersion >= 5 && !prop.computed && prop.key.type === "Identifier" && (prop.key.name === "get" || prop.key.name === "set") && (this.type !== types$1.comma && this.type !== types$1.braceR && this.type !== types$1.eq)) {
      if (isGenerator || isAsync) {
        this.unexpected();
      }
      this.parseGetterSetter(prop);
    } else if (this.options.ecmaVersion >= 6 && !prop.computed && prop.key.type === "Identifier") {
      if (isGenerator || isAsync) {
        this.unexpected();
      }
      this.checkUnreserved(prop.key);
      if (prop.key.name === "await" && !this.awaitIdentPos) {
        this.awaitIdentPos = startPos;
      }
      prop.kind = "init";
      if (isPattern) {
        prop.value = this.parseMaybeDefault(startPos, startLoc, this.copyNode(prop.key));
      } else if (this.type === types$1.eq && refDestructuringErrors) {
        if (refDestructuringErrors.shorthandAssign < 0) {
          refDestructuringErrors.shorthandAssign = this.start;
        }
        prop.value = this.parseMaybeDefault(startPos, startLoc, this.copyNode(prop.key));
      } else {
        prop.value = this.copyNode(prop.key);
      }
      prop.shorthand = true;
    } else {
      this.unexpected();
    }
  };
  pp$5.parsePropertyName = function(prop) {
    if (this.options.ecmaVersion >= 6) {
      if (this.eat(types$1.bracketL)) {
        prop.computed = true;
        prop.key = this.parseMaybeAssign();
        this.expect(types$1.bracketR);
        return prop.key;
      } else {
        prop.computed = false;
      }
    }
    return prop.key = this.type === types$1.num || this.type === types$1.string ? this.parseExprAtom() : this.parseIdent(this.options.allowReserved !== "never");
  };
  pp$5.initFunction = function(node) {
    node.id = null;
    if (this.options.ecmaVersion >= 6) {
      node.generator = node.expression = false;
    }
    if (this.options.ecmaVersion >= 8) {
      node.async = false;
    }
  };
  pp$5.parseMethod = function(isGenerator, isAsync, allowDirectSuper) {
    var node = this.startNode(), oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
    this.initFunction(node);
    if (this.options.ecmaVersion >= 6) {
      node.generator = isGenerator;
    }
    if (this.options.ecmaVersion >= 8) {
      node.async = !!isAsync;
    }
    this.yieldPos = 0;
    this.awaitPos = 0;
    this.awaitIdentPos = 0;
    this.enterScope(functionFlags(isAsync, node.generator) | SCOPE_SUPER | (allowDirectSuper ? SCOPE_DIRECT_SUPER : 0));
    this.expect(types$1.parenL);
    node.params = this.parseBindingList(types$1.parenR, false, this.options.ecmaVersion >= 8);
    this.checkYieldAwaitInDefaultParams();
    this.parseFunctionBody(node, false, true, false);
    this.yieldPos = oldYieldPos;
    this.awaitPos = oldAwaitPos;
    this.awaitIdentPos = oldAwaitIdentPos;
    return this.finishNode(node, "FunctionExpression");
  };
  pp$5.parseArrowExpression = function(node, params, isAsync, forInit) {
    var oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
    this.enterScope(functionFlags(isAsync, false) | SCOPE_ARROW);
    this.initFunction(node);
    if (this.options.ecmaVersion >= 8) {
      node.async = !!isAsync;
    }
    this.yieldPos = 0;
    this.awaitPos = 0;
    this.awaitIdentPos = 0;
    node.params = this.toAssignableList(params, true);
    this.parseFunctionBody(node, true, false, forInit);
    this.yieldPos = oldYieldPos;
    this.awaitPos = oldAwaitPos;
    this.awaitIdentPos = oldAwaitIdentPos;
    return this.finishNode(node, "ArrowFunctionExpression");
  };
  pp$5.parseFunctionBody = function(node, isArrowFunction, isMethod, forInit) {
    var isExpression = isArrowFunction && this.type !== types$1.braceL;
    var oldStrict = this.strict, useStrict = false;
    if (isExpression) {
      node.body = this.parseMaybeAssign(forInit);
      node.expression = true;
      this.checkParams(node, false);
    } else {
      var nonSimple = this.options.ecmaVersion >= 7 && !this.isSimpleParamList(node.params);
      if (!oldStrict || nonSimple) {
        useStrict = this.strictDirective(this.end);
        if (useStrict && nonSimple) {
          this.raiseRecoverable(node.start, "Illegal 'use strict' directive in function with non-simple parameter list");
        }
      }
      var oldLabels = this.labels;
      this.labels = [];
      if (useStrict) {
        this.strict = true;
      }
      this.checkParams(node, !oldStrict && !useStrict && !isArrowFunction && !isMethod && this.isSimpleParamList(node.params));
      if (this.strict && node.id) {
        this.checkLValSimple(node.id, BIND_OUTSIDE);
      }
      node.body = this.parseBlock(false, undefined, useStrict && !oldStrict);
      node.expression = false;
      this.adaptDirectivePrologue(node.body.body);
      this.labels = oldLabels;
    }
    this.exitScope();
  };
  pp$5.isSimpleParamList = function(params) {
    for (var i2 = 0, list2 = params;i2 < list2.length; i2 += 1) {
      var param = list2[i2];
      if (param.type !== "Identifier") {
        return false;
      }
    }
    return true;
  };
  pp$5.checkParams = function(node, allowDuplicates) {
    var nameHash = Object.create(null);
    for (var i2 = 0, list2 = node.params;i2 < list2.length; i2 += 1) {
      var param = list2[i2];
      this.checkLValInnerPattern(param, BIND_VAR, allowDuplicates ? null : nameHash);
    }
  };
  pp$5.parseExprList = function(close, allowTrailingComma, allowEmpty, refDestructuringErrors) {
    var elts = [], first = true;
    while (!this.eat(close)) {
      if (!first) {
        this.expect(types$1.comma);
        if (allowTrailingComma && this.afterTrailingComma(close)) {
          break;
        }
      } else {
        first = false;
      }
      var elt = undefined;
      if (allowEmpty && this.type === types$1.comma) {
        elt = null;
      } else if (this.type === types$1.ellipsis) {
        elt = this.parseSpread(refDestructuringErrors);
        if (refDestructuringErrors && this.type === types$1.comma && refDestructuringErrors.trailingComma < 0) {
          refDestructuringErrors.trailingComma = this.start;
        }
      } else {
        elt = this.parseMaybeAssign(false, refDestructuringErrors);
      }
      elts.push(elt);
    }
    return elts;
  };
  pp$5.checkUnreserved = function(ref2) {
    var start = ref2.start;
    var end = ref2.end;
    var name = ref2.name;
    if (this.inGenerator && name === "yield") {
      this.raiseRecoverable(start, "Cannot use 'yield' as identifier inside a generator");
    }
    if (this.inAsync && name === "await") {
      this.raiseRecoverable(start, "Cannot use 'await' as identifier inside an async function");
    }
    if (this.currentThisScope().inClassFieldInit && name === "arguments") {
      this.raiseRecoverable(start, "Cannot use 'arguments' in class field initializer");
    }
    if (this.inClassStaticBlock && (name === "arguments" || name === "await")) {
      this.raise(start, "Cannot use " + name + " in class static initialization block");
    }
    if (this.keywords.test(name)) {
      this.raise(start, "Unexpected keyword '" + name + "'");
    }
    if (this.options.ecmaVersion < 6 && this.input.slice(start, end).indexOf("\\") !== -1) {
      return;
    }
    var re = this.strict ? this.reservedWordsStrict : this.reservedWords;
    if (re.test(name)) {
      if (!this.inAsync && name === "await") {
        this.raiseRecoverable(start, "Cannot use keyword 'await' outside an async function");
      }
      this.raiseRecoverable(start, "The keyword '" + name + "' is reserved");
    }
  };
  pp$5.parseIdent = function(liberal) {
    var node = this.parseIdentNode();
    this.next(!!liberal);
    this.finishNode(node, "Identifier");
    if (!liberal) {
      this.checkUnreserved(node);
      if (node.name === "await" && !this.awaitIdentPos) {
        this.awaitIdentPos = node.start;
      }
    }
    return node;
  };
  pp$5.parseIdentNode = function() {
    var node = this.startNode();
    if (this.type === types$1.name) {
      node.name = this.value;
    } else if (this.type.keyword) {
      node.name = this.type.keyword;
      if ((node.name === "class" || node.name === "function") && (this.lastTokEnd !== this.lastTokStart + 1 || this.input.charCodeAt(this.lastTokStart) !== 46)) {
        this.context.pop();
      }
    } else {
      this.unexpected();
    }
    return node;
  };
  pp$5.parsePrivateIdent = function() {
    var node = this.startNode();
    if (this.type === types$1.privateId) {
      node.name = this.value;
    } else {
      this.unexpected();
    }
    this.next();
    this.finishNode(node, "PrivateIdentifier");
    if (this.options.checkPrivateFields) {
      if (this.privateNameStack.length === 0) {
        this.raise(node.start, "Private field '#" + node.name + "' must be declared in an enclosing class");
      } else {
        this.privateNameStack[this.privateNameStack.length - 1].used.push(node);
      }
    }
    return node;
  };
  pp$5.parseYield = function(forInit) {
    if (!this.yieldPos) {
      this.yieldPos = this.start;
    }
    var node = this.startNode();
    this.next();
    if (this.type === types$1.semi || this.canInsertSemicolon() || this.type !== types$1.star && !this.type.startsExpr) {
      node.delegate = false;
      node.argument = null;
    } else {
      node.delegate = this.eat(types$1.star);
      node.argument = this.parseMaybeAssign(forInit);
    }
    return this.finishNode(node, "YieldExpression");
  };
  pp$5.parseAwait = function(forInit) {
    if (!this.awaitPos) {
      this.awaitPos = this.start;
    }
    var node = this.startNode();
    this.next();
    node.argument = this.parseMaybeUnary(null, true, false, forInit);
    return this.finishNode(node, "AwaitExpression");
  };
  pp$4 = Parser.prototype;
  pp$4.raise = function(pos, message) {
    var loc = getLineInfo(this.input, pos);
    message += " (" + loc.line + ":" + loc.column + ")";
    var err22 = new SyntaxError(message);
    err22.pos = pos;
    err22.loc = loc;
    err22.raisedAt = this.pos;
    throw err22;
  };
  pp$4.raiseRecoverable = pp$4.raise;
  pp$4.curPosition = function() {
    if (this.options.locations) {
      return new Position(this.curLine, this.pos - this.lineStart);
    }
  };
  pp$3 = Parser.prototype;
  pp$3.enterScope = function(flags) {
    this.scopeStack.push(new Scope2(flags));
  };
  pp$3.exitScope = function() {
    this.scopeStack.pop();
  };
  pp$3.treatFunctionsAsVarInScope = function(scope) {
    return scope.flags & SCOPE_FUNCTION || !this.inModule && scope.flags & SCOPE_TOP;
  };
  pp$3.declareName = function(name, bindingType, pos) {
    var redeclared = false;
    if (bindingType === BIND_LEXICAL) {
      var scope = this.currentScope();
      redeclared = scope.lexical.indexOf(name) > -1 || scope.functions.indexOf(name) > -1 || scope.var.indexOf(name) > -1;
      scope.lexical.push(name);
      if (this.inModule && scope.flags & SCOPE_TOP) {
        delete this.undefinedExports[name];
      }
    } else if (bindingType === BIND_SIMPLE_CATCH) {
      var scope$1 = this.currentScope();
      scope$1.lexical.push(name);
    } else if (bindingType === BIND_FUNCTION) {
      var scope$2 = this.currentScope();
      if (this.treatFunctionsAsVar) {
        redeclared = scope$2.lexical.indexOf(name) > -1;
      } else {
        redeclared = scope$2.lexical.indexOf(name) > -1 || scope$2.var.indexOf(name) > -1;
      }
      scope$2.functions.push(name);
    } else {
      for (var i2 = this.scopeStack.length - 1;i2 >= 0; --i2) {
        var scope$3 = this.scopeStack[i2];
        if (scope$3.lexical.indexOf(name) > -1 && !(scope$3.flags & SCOPE_SIMPLE_CATCH && scope$3.lexical[0] === name) || !this.treatFunctionsAsVarInScope(scope$3) && scope$3.functions.indexOf(name) > -1) {
          redeclared = true;
          break;
        }
        scope$3.var.push(name);
        if (this.inModule && scope$3.flags & SCOPE_TOP) {
          delete this.undefinedExports[name];
        }
        if (scope$3.flags & SCOPE_VAR) {
          break;
        }
      }
    }
    if (redeclared) {
      this.raiseRecoverable(pos, "Identifier '" + name + "' has already been declared");
    }
  };
  pp$3.checkLocalExport = function(id) {
    if (this.scopeStack[0].lexical.indexOf(id.name) === -1 && this.scopeStack[0].var.indexOf(id.name) === -1) {
      this.undefinedExports[id.name] = id;
    }
  };
  pp$3.currentScope = function() {
    return this.scopeStack[this.scopeStack.length - 1];
  };
  pp$3.currentVarScope = function() {
    for (var i2 = this.scopeStack.length - 1;; i2--) {
      var scope = this.scopeStack[i2];
      if (scope.flags & SCOPE_VAR) {
        return scope;
      }
    }
  };
  pp$3.currentThisScope = function() {
    for (var i2 = this.scopeStack.length - 1;; i2--) {
      var scope = this.scopeStack[i2];
      if (scope.flags & SCOPE_VAR && !(scope.flags & SCOPE_ARROW)) {
        return scope;
      }
    }
  };
  pp$2 = Parser.prototype;
  pp$2.startNode = function() {
    return new Node(this, this.start, this.startLoc);
  };
  pp$2.startNodeAt = function(pos, loc) {
    return new Node(this, pos, loc);
  };
  pp$2.finishNode = function(node, type) {
    return finishNodeAt.call(this, node, type, this.lastTokEnd, this.lastTokEndLoc);
  };
  pp$2.finishNodeAt = function(node, type, pos, loc) {
    return finishNodeAt.call(this, node, type, pos, loc);
  };
  pp$2.copyNode = function(node) {
    var newNode = new Node(this, node.start, this.startLoc);
    for (var prop in node) {
      newNode[prop] = node[prop];
    }
    return newNode;
  };
  ecma10BinaryProperties = ecma9BinaryProperties + " Extended_Pictographic";
  ecma11BinaryProperties = ecma10BinaryProperties;
  ecma12BinaryProperties = ecma11BinaryProperties + " EBase EComp EMod EPres ExtPict";
  ecma13BinaryProperties = ecma12BinaryProperties;
  ecma14BinaryProperties = ecma13BinaryProperties;
  unicodeBinaryProperties = {
    9: ecma9BinaryProperties,
    10: ecma10BinaryProperties,
    11: ecma11BinaryProperties,
    12: ecma12BinaryProperties,
    13: ecma13BinaryProperties,
    14: ecma14BinaryProperties
  };
  unicodeBinaryPropertiesOfStrings = {
    9: "",
    10: "",
    11: "",
    12: "",
    13: "",
    14: ecma14BinaryPropertiesOfStrings
  };
  ecma10ScriptValues = ecma9ScriptValues + " Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd";
  ecma11ScriptValues = ecma10ScriptValues + " Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho";
  ecma12ScriptValues = ecma11ScriptValues + " Chorasmian Chrs Diak Dives_Akuru Khitan_Small_Script Kits Yezi Yezidi";
  ecma13ScriptValues = ecma12ScriptValues + " Cypro_Minoan Cpmn Old_Uyghur Ougr Tangsa Tnsa Toto Vithkuqi Vith";
  ecma14ScriptValues = ecma13ScriptValues + " Hrkt Katakana_Or_Hiragana Kawi Nag_Mundari Nagm Unknown Zzzz";
  unicodeScriptValues = {
    9: ecma9ScriptValues,
    10: ecma10ScriptValues,
    11: ecma11ScriptValues,
    12: ecma12ScriptValues,
    13: ecma13ScriptValues,
    14: ecma14ScriptValues
  };
  data = {};
  for (i = 0, list = [9, 10, 11, 12, 13, 14];i < list.length; i += 1) {
    ecmaVersion = list[i];
    buildUnicodeData(ecmaVersion);
  }
  pp$1 = Parser.prototype;
  RegExpValidationState.prototype.reset = function reset2(start, pattern, flags) {
    var unicodeSets = flags.indexOf("v") !== -1;
    var unicode32 = flags.indexOf("u") !== -1;
    this.start = start | 0;
    this.source = pattern + "";
    this.flags = flags;
    if (unicodeSets && this.parser.options.ecmaVersion >= 15) {
      this.switchU = true;
      this.switchV = true;
      this.switchN = true;
    } else {
      this.switchU = unicode32 && this.parser.options.ecmaVersion >= 6;
      this.switchV = false;
      this.switchN = unicode32 && this.parser.options.ecmaVersion >= 9;
    }
  };
  RegExpValidationState.prototype.raise = function raise(message) {
    this.parser.raiseRecoverable(this.start, "Invalid regular expression: /" + this.source + "/: " + message);
  };
  RegExpValidationState.prototype.at = function at(i2, forceU) {
    if (forceU === undefined)
      forceU = false;
    var s32 = this.source;
    var l22 = s32.length;
    if (i2 >= l22) {
      return -1;
    }
    var c22 = s32.charCodeAt(i2);
    if (!(forceU || this.switchU) || c22 <= 55295 || c22 >= 57344 || i2 + 1 >= l22) {
      return c22;
    }
    var next = s32.charCodeAt(i2 + 1);
    return next >= 56320 && next <= 57343 ? (c22 << 10) + next - 56613888 : c22;
  };
  RegExpValidationState.prototype.nextIndex = function nextIndex(i2, forceU) {
    if (forceU === undefined)
      forceU = false;
    var s32 = this.source;
    var l22 = s32.length;
    if (i2 >= l22) {
      return l22;
    }
    var c22 = s32.charCodeAt(i2), next;
    if (!(forceU || this.switchU) || c22 <= 55295 || c22 >= 57344 || i2 + 1 >= l22 || (next = s32.charCodeAt(i2 + 1)) < 56320 || next > 57343) {
      return i2 + 1;
    }
    return i2 + 2;
  };
  RegExpValidationState.prototype.current = function current(forceU) {
    if (forceU === undefined)
      forceU = false;
    return this.at(this.pos, forceU);
  };
  RegExpValidationState.prototype.lookahead = function lookahead(forceU) {
    if (forceU === undefined)
      forceU = false;
    return this.at(this.nextIndex(this.pos, forceU), forceU);
  };
  RegExpValidationState.prototype.advance = function advance(forceU) {
    if (forceU === undefined)
      forceU = false;
    this.pos = this.nextIndex(this.pos, forceU);
  };
  RegExpValidationState.prototype.eat = function eat(ch, forceU) {
    if (forceU === undefined)
      forceU = false;
    if (this.current(forceU) === ch) {
      this.advance(forceU);
      return true;
    }
    return false;
  };
  RegExpValidationState.prototype.eatChars = function eatChars(chs, forceU) {
    if (forceU === undefined)
      forceU = false;
    var pos = this.pos;
    for (var i2 = 0, list2 = chs;i2 < list2.length; i2 += 1) {
      var ch = list2[i2];
      var current2 = this.at(pos, forceU);
      if (current2 === -1 || current2 !== ch) {
        return false;
      }
      pos = this.nextIndex(pos, forceU);
    }
    this.pos = pos;
    return true;
  };
  pp$1.validateRegExpFlags = function(state) {
    var validFlags = state.validFlags;
    var flags = state.flags;
    var u = false;
    var v22 = false;
    for (var i2 = 0;i2 < flags.length; i2++) {
      var flag = flags.charAt(i2);
      if (validFlags.indexOf(flag) === -1) {
        this.raise(state.start, "Invalid regular expression flag");
      }
      if (flags.indexOf(flag, i2 + 1) > -1) {
        this.raise(state.start, "Duplicate regular expression flag");
      }
      if (flag === "u") {
        u = true;
      }
      if (flag === "v") {
        v22 = true;
      }
    }
    if (this.options.ecmaVersion >= 15 && u && v22) {
      this.raise(state.start, "Invalid regular expression flag");
    }
  };
  pp$1.validateRegExpPattern = function(state) {
    this.regexp_pattern(state);
    if (!state.switchN && this.options.ecmaVersion >= 9 && state.groupNames.length > 0) {
      state.switchN = true;
      this.regexp_pattern(state);
    }
  };
  pp$1.regexp_pattern = function(state) {
    state.pos = 0;
    state.lastIntValue = 0;
    state.lastStringValue = "";
    state.lastAssertionIsQuantifiable = false;
    state.numCapturingParens = 0;
    state.maxBackReference = 0;
    state.groupNames.length = 0;
    state.backReferenceNames.length = 0;
    this.regexp_disjunction(state);
    if (state.pos !== state.source.length) {
      if (state.eat(41)) {
        state.raise("Unmatched ')'");
      }
      if (state.eat(93) || state.eat(125)) {
        state.raise("Lone quantifier brackets");
      }
    }
    if (state.maxBackReference > state.numCapturingParens) {
      state.raise("Invalid escape");
    }
    for (var i2 = 0, list2 = state.backReferenceNames;i2 < list2.length; i2 += 1) {
      var name = list2[i2];
      if (state.groupNames.indexOf(name) === -1) {
        state.raise("Invalid named capture referenced");
      }
    }
  };
  pp$1.regexp_disjunction = function(state) {
    this.regexp_alternative(state);
    while (state.eat(124)) {
      this.regexp_alternative(state);
    }
    if (this.regexp_eatQuantifier(state, true)) {
      state.raise("Nothing to repeat");
    }
    if (state.eat(123)) {
      state.raise("Lone quantifier brackets");
    }
  };
  pp$1.regexp_alternative = function(state) {
    while (state.pos < state.source.length && this.regexp_eatTerm(state)) {
    }
  };
  pp$1.regexp_eatTerm = function(state) {
    if (this.regexp_eatAssertion(state)) {
      if (state.lastAssertionIsQuantifiable && this.regexp_eatQuantifier(state)) {
        if (state.switchU) {
          state.raise("Invalid quantifier");
        }
      }
      return true;
    }
    if (state.switchU ? this.regexp_eatAtom(state) : this.regexp_eatExtendedAtom(state)) {
      this.regexp_eatQuantifier(state);
      return true;
    }
    return false;
  };
  pp$1.regexp_eatAssertion = function(state) {
    var start = state.pos;
    state.lastAssertionIsQuantifiable = false;
    if (state.eat(94) || state.eat(36)) {
      return true;
    }
    if (state.eat(92)) {
      if (state.eat(66) || state.eat(98)) {
        return true;
      }
      state.pos = start;
    }
    if (state.eat(40) && state.eat(63)) {
      var lookbehind = false;
      if (this.options.ecmaVersion >= 9) {
        lookbehind = state.eat(60);
      }
      if (state.eat(61) || state.eat(33)) {
        this.regexp_disjunction(state);
        if (!state.eat(41)) {
          state.raise("Unterminated group");
        }
        state.lastAssertionIsQuantifiable = !lookbehind;
        return true;
      }
    }
    state.pos = start;
    return false;
  };
  pp$1.regexp_eatQuantifier = function(state, noError) {
    if (noError === undefined)
      noError = false;
    if (this.regexp_eatQuantifierPrefix(state, noError)) {
      state.eat(63);
      return true;
    }
    return false;
  };
  pp$1.regexp_eatQuantifierPrefix = function(state, noError) {
    return state.eat(42) || state.eat(43) || state.eat(63) || this.regexp_eatBracedQuantifier(state, noError);
  };
  pp$1.regexp_eatBracedQuantifier = function(state, noError) {
    var start = state.pos;
    if (state.eat(123)) {
      var min = 0, max = -1;
      if (this.regexp_eatDecimalDigits(state)) {
        min = state.lastIntValue;
        if (state.eat(44) && this.regexp_eatDecimalDigits(state)) {
          max = state.lastIntValue;
        }
        if (state.eat(125)) {
          if (max !== -1 && max < min && !noError) {
            state.raise("numbers out of order in {} quantifier");
          }
          return true;
        }
      }
      if (state.switchU && !noError) {
        state.raise("Incomplete quantifier");
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatAtom = function(state) {
    return this.regexp_eatPatternCharacters(state) || state.eat(46) || this.regexp_eatReverseSolidusAtomEscape(state) || this.regexp_eatCharacterClass(state) || this.regexp_eatUncapturingGroup(state) || this.regexp_eatCapturingGroup(state);
  };
  pp$1.regexp_eatReverseSolidusAtomEscape = function(state) {
    var start = state.pos;
    if (state.eat(92)) {
      if (this.regexp_eatAtomEscape(state)) {
        return true;
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatUncapturingGroup = function(state) {
    var start = state.pos;
    if (state.eat(40)) {
      if (state.eat(63) && state.eat(58)) {
        this.regexp_disjunction(state);
        if (state.eat(41)) {
          return true;
        }
        state.raise("Unterminated group");
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatCapturingGroup = function(state) {
    if (state.eat(40)) {
      if (this.options.ecmaVersion >= 9) {
        this.regexp_groupSpecifier(state);
      } else if (state.current() === 63) {
        state.raise("Invalid group");
      }
      this.regexp_disjunction(state);
      if (state.eat(41)) {
        state.numCapturingParens += 1;
        return true;
      }
      state.raise("Unterminated group");
    }
    return false;
  };
  pp$1.regexp_eatExtendedAtom = function(state) {
    return state.eat(46) || this.regexp_eatReverseSolidusAtomEscape(state) || this.regexp_eatCharacterClass(state) || this.regexp_eatUncapturingGroup(state) || this.regexp_eatCapturingGroup(state) || this.regexp_eatInvalidBracedQuantifier(state) || this.regexp_eatExtendedPatternCharacter(state);
  };
  pp$1.regexp_eatInvalidBracedQuantifier = function(state) {
    if (this.regexp_eatBracedQuantifier(state, true)) {
      state.raise("Nothing to repeat");
    }
    return false;
  };
  pp$1.regexp_eatSyntaxCharacter = function(state) {
    var ch = state.current();
    if (isSyntaxCharacter(ch)) {
      state.lastIntValue = ch;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatPatternCharacters = function(state) {
    var start = state.pos;
    var ch = 0;
    while ((ch = state.current()) !== -1 && !isSyntaxCharacter(ch)) {
      state.advance();
    }
    return state.pos !== start;
  };
  pp$1.regexp_eatExtendedPatternCharacter = function(state) {
    var ch = state.current();
    if (ch !== -1 && ch !== 36 && !(ch >= 40 && ch <= 43) && ch !== 46 && ch !== 63 && ch !== 91 && ch !== 94 && ch !== 124) {
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_groupSpecifier = function(state) {
    if (state.eat(63)) {
      if (this.regexp_eatGroupName(state)) {
        if (state.groupNames.indexOf(state.lastStringValue) !== -1) {
          state.raise("Duplicate capture group name");
        }
        state.groupNames.push(state.lastStringValue);
        return;
      }
      state.raise("Invalid group");
    }
  };
  pp$1.regexp_eatGroupName = function(state) {
    state.lastStringValue = "";
    if (state.eat(60)) {
      if (this.regexp_eatRegExpIdentifierName(state) && state.eat(62)) {
        return true;
      }
      state.raise("Invalid capture group name");
    }
    return false;
  };
  pp$1.regexp_eatRegExpIdentifierName = function(state) {
    state.lastStringValue = "";
    if (this.regexp_eatRegExpIdentifierStart(state)) {
      state.lastStringValue += codePointToString(state.lastIntValue);
      while (this.regexp_eatRegExpIdentifierPart(state)) {
        state.lastStringValue += codePointToString(state.lastIntValue);
      }
      return true;
    }
    return false;
  };
  pp$1.regexp_eatRegExpIdentifierStart = function(state) {
    var start = state.pos;
    var forceU = this.options.ecmaVersion >= 11;
    var ch = state.current(forceU);
    state.advance(forceU);
    if (ch === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(state, forceU)) {
      ch = state.lastIntValue;
    }
    if (isRegExpIdentifierStart(ch)) {
      state.lastIntValue = ch;
      return true;
    }
    state.pos = start;
    return false;
  };
  pp$1.regexp_eatRegExpIdentifierPart = function(state) {
    var start = state.pos;
    var forceU = this.options.ecmaVersion >= 11;
    var ch = state.current(forceU);
    state.advance(forceU);
    if (ch === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(state, forceU)) {
      ch = state.lastIntValue;
    }
    if (isRegExpIdentifierPart(ch)) {
      state.lastIntValue = ch;
      return true;
    }
    state.pos = start;
    return false;
  };
  pp$1.regexp_eatAtomEscape = function(state) {
    if (this.regexp_eatBackReference(state) || this.regexp_eatCharacterClassEscape(state) || this.regexp_eatCharacterEscape(state) || state.switchN && this.regexp_eatKGroupName(state)) {
      return true;
    }
    if (state.switchU) {
      if (state.current() === 99) {
        state.raise("Invalid unicode escape");
      }
      state.raise("Invalid escape");
    }
    return false;
  };
  pp$1.regexp_eatBackReference = function(state) {
    var start = state.pos;
    if (this.regexp_eatDecimalEscape(state)) {
      var n = state.lastIntValue;
      if (state.switchU) {
        if (n > state.maxBackReference) {
          state.maxBackReference = n;
        }
        return true;
      }
      if (n <= state.numCapturingParens) {
        return true;
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatKGroupName = function(state) {
    if (state.eat(107)) {
      if (this.regexp_eatGroupName(state)) {
        state.backReferenceNames.push(state.lastStringValue);
        return true;
      }
      state.raise("Invalid named reference");
    }
    return false;
  };
  pp$1.regexp_eatCharacterEscape = function(state) {
    return this.regexp_eatControlEscape(state) || this.regexp_eatCControlLetter(state) || this.regexp_eatZero(state) || this.regexp_eatHexEscapeSequence(state) || this.regexp_eatRegExpUnicodeEscapeSequence(state, false) || !state.switchU && this.regexp_eatLegacyOctalEscapeSequence(state) || this.regexp_eatIdentityEscape(state);
  };
  pp$1.regexp_eatCControlLetter = function(state) {
    var start = state.pos;
    if (state.eat(99)) {
      if (this.regexp_eatControlLetter(state)) {
        return true;
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatZero = function(state) {
    if (state.current() === 48 && !isDecimalDigit(state.lookahead())) {
      state.lastIntValue = 0;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatControlEscape = function(state) {
    var ch = state.current();
    if (ch === 116) {
      state.lastIntValue = 9;
      state.advance();
      return true;
    }
    if (ch === 110) {
      state.lastIntValue = 10;
      state.advance();
      return true;
    }
    if (ch === 118) {
      state.lastIntValue = 11;
      state.advance();
      return true;
    }
    if (ch === 102) {
      state.lastIntValue = 12;
      state.advance();
      return true;
    }
    if (ch === 114) {
      state.lastIntValue = 13;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatControlLetter = function(state) {
    var ch = state.current();
    if (isControlLetter(ch)) {
      state.lastIntValue = ch % 32;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatRegExpUnicodeEscapeSequence = function(state, forceU) {
    if (forceU === undefined)
      forceU = false;
    var start = state.pos;
    var switchU = forceU || state.switchU;
    if (state.eat(117)) {
      if (this.regexp_eatFixedHexDigits(state, 4)) {
        var lead = state.lastIntValue;
        if (switchU && lead >= 55296 && lead <= 56319) {
          var leadSurrogateEnd = state.pos;
          if (state.eat(92) && state.eat(117) && this.regexp_eatFixedHexDigits(state, 4)) {
            var trail = state.lastIntValue;
            if (trail >= 56320 && trail <= 57343) {
              state.lastIntValue = (lead - 55296) * 1024 + (trail - 56320) + 65536;
              return true;
            }
          }
          state.pos = leadSurrogateEnd;
          state.lastIntValue = lead;
        }
        return true;
      }
      if (switchU && state.eat(123) && this.regexp_eatHexDigits(state) && state.eat(125) && isValidUnicode(state.lastIntValue)) {
        return true;
      }
      if (switchU) {
        state.raise("Invalid unicode escape");
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatIdentityEscape = function(state) {
    if (state.switchU) {
      if (this.regexp_eatSyntaxCharacter(state)) {
        return true;
      }
      if (state.eat(47)) {
        state.lastIntValue = 47;
        return true;
      }
      return false;
    }
    var ch = state.current();
    if (ch !== 99 && (!state.switchN || ch !== 107)) {
      state.lastIntValue = ch;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatDecimalEscape = function(state) {
    state.lastIntValue = 0;
    var ch = state.current();
    if (ch >= 49 && ch <= 57) {
      do {
        state.lastIntValue = 10 * state.lastIntValue + (ch - 48);
        state.advance();
      } while ((ch = state.current()) >= 48 && ch <= 57);
      return true;
    }
    return false;
  };
  pp$1.regexp_eatCharacterClassEscape = function(state) {
    var ch = state.current();
    if (isCharacterClassEscape(ch)) {
      state.lastIntValue = -1;
      state.advance();
      return CharSetOk;
    }
    var negate = false;
    if (state.switchU && this.options.ecmaVersion >= 9 && ((negate = ch === 80) || ch === 112)) {
      state.lastIntValue = -1;
      state.advance();
      var result2;
      if (state.eat(123) && (result2 = this.regexp_eatUnicodePropertyValueExpression(state)) && state.eat(125)) {
        if (negate && result2 === CharSetString) {
          state.raise("Invalid property name");
        }
        return result2;
      }
      state.raise("Invalid property name");
    }
    return CharSetNone;
  };
  pp$1.regexp_eatUnicodePropertyValueExpression = function(state) {
    var start = state.pos;
    if (this.regexp_eatUnicodePropertyName(state) && state.eat(61)) {
      var name = state.lastStringValue;
      if (this.regexp_eatUnicodePropertyValue(state)) {
        var value = state.lastStringValue;
        this.regexp_validateUnicodePropertyNameAndValue(state, name, value);
        return CharSetOk;
      }
    }
    state.pos = start;
    if (this.regexp_eatLoneUnicodePropertyNameOrValue(state)) {
      var nameOrValue = state.lastStringValue;
      return this.regexp_validateUnicodePropertyNameOrValue(state, nameOrValue);
    }
    return CharSetNone;
  };
  pp$1.regexp_validateUnicodePropertyNameAndValue = function(state, name, value) {
    if (!hasOwn(state.unicodeProperties.nonBinary, name)) {
      state.raise("Invalid property name");
    }
    if (!state.unicodeProperties.nonBinary[name].test(value)) {
      state.raise("Invalid property value");
    }
  };
  pp$1.regexp_validateUnicodePropertyNameOrValue = function(state, nameOrValue) {
    if (state.unicodeProperties.binary.test(nameOrValue)) {
      return CharSetOk;
    }
    if (state.switchV && state.unicodeProperties.binaryOfStrings.test(nameOrValue)) {
      return CharSetString;
    }
    state.raise("Invalid property name");
  };
  pp$1.regexp_eatUnicodePropertyName = function(state) {
    var ch = 0;
    state.lastStringValue = "";
    while (isUnicodePropertyNameCharacter(ch = state.current())) {
      state.lastStringValue += codePointToString(ch);
      state.advance();
    }
    return state.lastStringValue !== "";
  };
  pp$1.regexp_eatUnicodePropertyValue = function(state) {
    var ch = 0;
    state.lastStringValue = "";
    while (isUnicodePropertyValueCharacter(ch = state.current())) {
      state.lastStringValue += codePointToString(ch);
      state.advance();
    }
    return state.lastStringValue !== "";
  };
  pp$1.regexp_eatLoneUnicodePropertyNameOrValue = function(state) {
    return this.regexp_eatUnicodePropertyValue(state);
  };
  pp$1.regexp_eatCharacterClass = function(state) {
    if (state.eat(91)) {
      var negate = state.eat(94);
      var result2 = this.regexp_classContents(state);
      if (!state.eat(93)) {
        state.raise("Unterminated character class");
      }
      if (negate && result2 === CharSetString) {
        state.raise("Negated character class may contain strings");
      }
      return true;
    }
    return false;
  };
  pp$1.regexp_classContents = function(state) {
    if (state.current() === 93) {
      return CharSetOk;
    }
    if (state.switchV) {
      return this.regexp_classSetExpression(state);
    }
    this.regexp_nonEmptyClassRanges(state);
    return CharSetOk;
  };
  pp$1.regexp_nonEmptyClassRanges = function(state) {
    while (this.regexp_eatClassAtom(state)) {
      var left = state.lastIntValue;
      if (state.eat(45) && this.regexp_eatClassAtom(state)) {
        var right = state.lastIntValue;
        if (state.switchU && (left === -1 || right === -1)) {
          state.raise("Invalid character class");
        }
        if (left !== -1 && right !== -1 && left > right) {
          state.raise("Range out of order in character class");
        }
      }
    }
  };
  pp$1.regexp_eatClassAtom = function(state) {
    var start = state.pos;
    if (state.eat(92)) {
      if (this.regexp_eatClassEscape(state)) {
        return true;
      }
      if (state.switchU) {
        var ch$1 = state.current();
        if (ch$1 === 99 || isOctalDigit(ch$1)) {
          state.raise("Invalid class escape");
        }
        state.raise("Invalid escape");
      }
      state.pos = start;
    }
    var ch = state.current();
    if (ch !== 93) {
      state.lastIntValue = ch;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatClassEscape = function(state) {
    var start = state.pos;
    if (state.eat(98)) {
      state.lastIntValue = 8;
      return true;
    }
    if (state.switchU && state.eat(45)) {
      state.lastIntValue = 45;
      return true;
    }
    if (!state.switchU && state.eat(99)) {
      if (this.regexp_eatClassControlLetter(state)) {
        return true;
      }
      state.pos = start;
    }
    return this.regexp_eatCharacterClassEscape(state) || this.regexp_eatCharacterEscape(state);
  };
  pp$1.regexp_classSetExpression = function(state) {
    var result2 = CharSetOk, subResult;
    if (this.regexp_eatClassSetRange(state))
      ;
    else if (subResult = this.regexp_eatClassSetOperand(state)) {
      if (subResult === CharSetString) {
        result2 = CharSetString;
      }
      var start = state.pos;
      while (state.eatChars([38, 38])) {
        if (state.current() !== 38 && (subResult = this.regexp_eatClassSetOperand(state))) {
          if (subResult !== CharSetString) {
            result2 = CharSetOk;
          }
          continue;
        }
        state.raise("Invalid character in character class");
      }
      if (start !== state.pos) {
        return result2;
      }
      while (state.eatChars([45, 45])) {
        if (this.regexp_eatClassSetOperand(state)) {
          continue;
        }
        state.raise("Invalid character in character class");
      }
      if (start !== state.pos) {
        return result2;
      }
    } else {
      state.raise("Invalid character in character class");
    }
    for (;; ) {
      if (this.regexp_eatClassSetRange(state)) {
        continue;
      }
      subResult = this.regexp_eatClassSetOperand(state);
      if (!subResult) {
        return result2;
      }
      if (subResult === CharSetString) {
        result2 = CharSetString;
      }
    }
  };
  pp$1.regexp_eatClassSetRange = function(state) {
    var start = state.pos;
    if (this.regexp_eatClassSetCharacter(state)) {
      var left = state.lastIntValue;
      if (state.eat(45) && this.regexp_eatClassSetCharacter(state)) {
        var right = state.lastIntValue;
        if (left !== -1 && right !== -1 && left > right) {
          state.raise("Range out of order in character class");
        }
        return true;
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatClassSetOperand = function(state) {
    if (this.regexp_eatClassSetCharacter(state)) {
      return CharSetOk;
    }
    return this.regexp_eatClassStringDisjunction(state) || this.regexp_eatNestedClass(state);
  };
  pp$1.regexp_eatNestedClass = function(state) {
    var start = state.pos;
    if (state.eat(91)) {
      var negate = state.eat(94);
      var result2 = this.regexp_classContents(state);
      if (state.eat(93)) {
        if (negate && result2 === CharSetString) {
          state.raise("Negated character class may contain strings");
        }
        return result2;
      }
      state.pos = start;
    }
    if (state.eat(92)) {
      var result$1 = this.regexp_eatCharacterClassEscape(state);
      if (result$1) {
        return result$1;
      }
      state.pos = start;
    }
    return null;
  };
  pp$1.regexp_eatClassStringDisjunction = function(state) {
    var start = state.pos;
    if (state.eatChars([92, 113])) {
      if (state.eat(123)) {
        var result2 = this.regexp_classStringDisjunctionContents(state);
        if (state.eat(125)) {
          return result2;
        }
      } else {
        state.raise("Invalid escape");
      }
      state.pos = start;
    }
    return null;
  };
  pp$1.regexp_classStringDisjunctionContents = function(state) {
    var result2 = this.regexp_classString(state);
    while (state.eat(124)) {
      if (this.regexp_classString(state) === CharSetString) {
        result2 = CharSetString;
      }
    }
    return result2;
  };
  pp$1.regexp_classString = function(state) {
    var count = 0;
    while (this.regexp_eatClassSetCharacter(state)) {
      count++;
    }
    return count === 1 ? CharSetOk : CharSetString;
  };
  pp$1.regexp_eatClassSetCharacter = function(state) {
    var start = state.pos;
    if (state.eat(92)) {
      if (this.regexp_eatCharacterEscape(state) || this.regexp_eatClassSetReservedPunctuator(state)) {
        return true;
      }
      if (state.eat(98)) {
        state.lastIntValue = 8;
        return true;
      }
      state.pos = start;
      return false;
    }
    var ch = state.current();
    if (ch < 0 || ch === state.lookahead() && isClassSetReservedDoublePunctuatorCharacter(ch)) {
      return false;
    }
    if (isClassSetSyntaxCharacter(ch)) {
      return false;
    }
    state.advance();
    state.lastIntValue = ch;
    return true;
  };
  pp$1.regexp_eatClassSetReservedPunctuator = function(state) {
    var ch = state.current();
    if (isClassSetReservedPunctuator(ch)) {
      state.lastIntValue = ch;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatClassControlLetter = function(state) {
    var ch = state.current();
    if (isDecimalDigit(ch) || ch === 95) {
      state.lastIntValue = ch % 32;
      state.advance();
      return true;
    }
    return false;
  };
  pp$1.regexp_eatHexEscapeSequence = function(state) {
    var start = state.pos;
    if (state.eat(120)) {
      if (this.regexp_eatFixedHexDigits(state, 2)) {
        return true;
      }
      if (state.switchU) {
        state.raise("Invalid escape");
      }
      state.pos = start;
    }
    return false;
  };
  pp$1.regexp_eatDecimalDigits = function(state) {
    var start = state.pos;
    var ch = 0;
    state.lastIntValue = 0;
    while (isDecimalDigit(ch = state.current())) {
      state.lastIntValue = 10 * state.lastIntValue + (ch - 48);
      state.advance();
    }
    return state.pos !== start;
  };
  pp$1.regexp_eatHexDigits = function(state) {
    var start = state.pos;
    var ch = 0;
    state.lastIntValue = 0;
    while (isHexDigit(ch = state.current())) {
      state.lastIntValue = 16 * state.lastIntValue + hexToInt(ch);
      state.advance();
    }
    return state.pos !== start;
  };
  pp$1.regexp_eatLegacyOctalEscapeSequence = function(state) {
    if (this.regexp_eatOctalDigit(state)) {
      var n1 = state.lastIntValue;
      if (this.regexp_eatOctalDigit(state)) {
        var n2 = state.lastIntValue;
        if (n1 <= 3 && this.regexp_eatOctalDigit(state)) {
          state.lastIntValue = n1 * 64 + n2 * 8 + state.lastIntValue;
        } else {
          state.lastIntValue = n1 * 8 + n2;
        }
      } else {
        state.lastIntValue = n1;
      }
      return true;
    }
    return false;
  };
  pp$1.regexp_eatOctalDigit = function(state) {
    var ch = state.current();
    if (isOctalDigit(ch)) {
      state.lastIntValue = ch - 48;
      state.advance();
      return true;
    }
    state.lastIntValue = 0;
    return false;
  };
  pp$1.regexp_eatFixedHexDigits = function(state, length) {
    var start = state.pos;
    state.lastIntValue = 0;
    for (var i2 = 0;i2 < length; ++i2) {
      var ch = state.current();
      if (!isHexDigit(ch)) {
        state.pos = start;
        return false;
      }
      state.lastIntValue = 16 * state.lastIntValue + hexToInt(ch);
      state.advance();
    }
    return true;
  };
  pp = Parser.prototype;
  pp.next = function(ignoreEscapeSequenceInKeyword) {
    if (!ignoreEscapeSequenceInKeyword && this.type.keyword && this.containsEsc) {
      this.raiseRecoverable(this.start, "Escape sequence in keyword " + this.type.keyword);
    }
    if (this.options.onToken) {
      this.options.onToken(new Token(this));
    }
    this.lastTokEnd = this.end;
    this.lastTokStart = this.start;
    this.lastTokEndLoc = this.endLoc;
    this.lastTokStartLoc = this.startLoc;
    this.nextToken();
  };
  pp.getToken = function() {
    this.next();
    return new Token(this);
  };
  if (typeof Symbol !== "undefined") {
    pp[Symbol.iterator] = function() {
      var this$1$1 = this;
      return {
        next: function() {
          var token = this$1$1.getToken();
          return {
            done: token.type === types$1.eof,
            value: token
          };
        }
      };
    };
  }
  pp.nextToken = function() {
    var curContext = this.curContext();
    if (!curContext || !curContext.preserveSpace) {
      this.skipSpace();
    }
    this.start = this.pos;
    if (this.options.locations) {
      this.startLoc = this.curPosition();
    }
    if (this.pos >= this.input.length) {
      return this.finishToken(types$1.eof);
    }
    if (curContext.override) {
      return curContext.override(this);
    } else {
      this.readToken(this.fullCharCodeAtPos());
    }
  };
  pp.readToken = function(code) {
    if (isIdentifierStart(code, this.options.ecmaVersion >= 6) || code === 92) {
      return this.readWord();
    }
    return this.getTokenFromCode(code);
  };
  pp.fullCharCodeAtPos = function() {
    var code = this.input.charCodeAt(this.pos);
    if (code <= 55295 || code >= 56320) {
      return code;
    }
    var next = this.input.charCodeAt(this.pos + 1);
    return next <= 56319 || next >= 57344 ? code : (code << 10) + next - 56613888;
  };
  pp.skipBlockComment = function() {
    var startLoc = this.options.onComment && this.curPosition();
    var start = this.pos, end = this.input.indexOf("*/", this.pos += 2);
    if (end === -1) {
      this.raise(this.pos - 2, "Unterminated comment");
    }
    this.pos = end + 2;
    if (this.options.locations) {
      for (var nextBreak = undefined, pos = start;(nextBreak = nextLineBreak(this.input, pos, this.pos)) > -1; ) {
        ++this.curLine;
        pos = this.lineStart = nextBreak;
      }
    }
    if (this.options.onComment) {
      this.options.onComment(true, this.input.slice(start + 2, end), start, this.pos, startLoc, this.curPosition());
    }
  };
  pp.skipLineComment = function(startSkip) {
    var start = this.pos;
    var startLoc = this.options.onComment && this.curPosition();
    var ch = this.input.charCodeAt(this.pos += startSkip);
    while (this.pos < this.input.length && !isNewLine(ch)) {
      ch = this.input.charCodeAt(++this.pos);
    }
    if (this.options.onComment) {
      this.options.onComment(false, this.input.slice(start + startSkip, this.pos), start, this.pos, startLoc, this.curPosition());
    }
  };
  pp.skipSpace = function() {
    loop:
      while (this.pos < this.input.length) {
        var ch = this.input.charCodeAt(this.pos);
        switch (ch) {
          case 32:
          case 160:
            ++this.pos;
            break;
          case 13:
            if (this.input.charCodeAt(this.pos + 1) === 10) {
              ++this.pos;
            }
          case 10:
          case 8232:
          case 8233:
            ++this.pos;
            if (this.options.locations) {
              ++this.curLine;
              this.lineStart = this.pos;
            }
            break;
          case 47:
            switch (this.input.charCodeAt(this.pos + 1)) {
              case 42:
                this.skipBlockComment();
                break;
              case 47:
                this.skipLineComment(2);
                break;
              default:
                break loop;
            }
            break;
          default:
            if (ch > 8 && ch < 14 || ch >= 5760 && nonASCIIwhitespace.test(String.fromCharCode(ch))) {
              ++this.pos;
            } else {
              break loop;
            }
        }
      }
  };
  pp.finishToken = function(type, val2) {
    this.end = this.pos;
    if (this.options.locations) {
      this.endLoc = this.curPosition();
    }
    var prevType = this.type;
    this.type = type;
    this.value = val2;
    this.updateContext(prevType);
  };
  pp.readToken_dot = function() {
    var next = this.input.charCodeAt(this.pos + 1);
    if (next >= 48 && next <= 57) {
      return this.readNumber(true);
    }
    var next2 = this.input.charCodeAt(this.pos + 2);
    if (this.options.ecmaVersion >= 6 && next === 46 && next2 === 46) {
      this.pos += 3;
      return this.finishToken(types$1.ellipsis);
    } else {
      ++this.pos;
      return this.finishToken(types$1.dot);
    }
  };
  pp.readToken_slash = function() {
    var next = this.input.charCodeAt(this.pos + 1);
    if (this.exprAllowed) {
      ++this.pos;
      return this.readRegexp();
    }
    if (next === 61) {
      return this.finishOp(types$1.assign, 2);
    }
    return this.finishOp(types$1.slash, 1);
  };
  pp.readToken_mult_modulo_exp = function(code) {
    var next = this.input.charCodeAt(this.pos + 1);
    var size = 1;
    var tokentype = code === 42 ? types$1.star : types$1.modulo;
    if (this.options.ecmaVersion >= 7 && code === 42 && next === 42) {
      ++size;
      tokentype = types$1.starstar;
      next = this.input.charCodeAt(this.pos + 2);
    }
    if (next === 61) {
      return this.finishOp(types$1.assign, size + 1);
    }
    return this.finishOp(tokentype, size);
  };
  pp.readToken_pipe_amp = function(code) {
    var next = this.input.charCodeAt(this.pos + 1);
    if (next === code) {
      if (this.options.ecmaVersion >= 12) {
        var next2 = this.input.charCodeAt(this.pos + 2);
        if (next2 === 61) {
          return this.finishOp(types$1.assign, 3);
        }
      }
      return this.finishOp(code === 124 ? types$1.logicalOR : types$1.logicalAND, 2);
    }
    if (next === 61) {
      return this.finishOp(types$1.assign, 2);
    }
    return this.finishOp(code === 124 ? types$1.bitwiseOR : types$1.bitwiseAND, 1);
  };
  pp.readToken_caret = function() {
    var next = this.input.charCodeAt(this.pos + 1);
    if (next === 61) {
      return this.finishOp(types$1.assign, 2);
    }
    return this.finishOp(types$1.bitwiseXOR, 1);
  };
  pp.readToken_plus_min = function(code) {
    var next = this.input.charCodeAt(this.pos + 1);
    if (next === code) {
      if (next === 45 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 62 && (this.lastTokEnd === 0 || lineBreak.test(this.input.slice(this.lastTokEnd, this.pos)))) {
        this.skipLineComment(3);
        this.skipSpace();
        return this.nextToken();
      }
      return this.finishOp(types$1.incDec, 2);
    }
    if (next === 61) {
      return this.finishOp(types$1.assign, 2);
    }
    return this.finishOp(types$1.plusMin, 1);
  };
  pp.readToken_lt_gt = function(code) {
    var next = this.input.charCodeAt(this.pos + 1);
    var size = 1;
    if (next === code) {
      size = code === 62 && this.input.charCodeAt(this.pos + 2) === 62 ? 3 : 2;
      if (this.input.charCodeAt(this.pos + size) === 61) {
        return this.finishOp(types$1.assign, size + 1);
      }
      return this.finishOp(types$1.bitShift, size);
    }
    if (next === 33 && code === 60 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 45 && this.input.charCodeAt(this.pos + 3) === 45) {
      this.skipLineComment(4);
      this.skipSpace();
      return this.nextToken();
    }
    if (next === 61) {
      size = 2;
    }
    return this.finishOp(types$1.relational, size);
  };
  pp.readToken_eq_excl = function(code) {
    var next = this.input.charCodeAt(this.pos + 1);
    if (next === 61) {
      return this.finishOp(types$1.equality, this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2);
    }
    if (code === 61 && next === 62 && this.options.ecmaVersion >= 6) {
      this.pos += 2;
      return this.finishToken(types$1.arrow);
    }
    return this.finishOp(code === 61 ? types$1.eq : types$1.prefix, 1);
  };
  pp.readToken_question = function() {
    var ecmaVersion2 = this.options.ecmaVersion;
    if (ecmaVersion2 >= 11) {
      var next = this.input.charCodeAt(this.pos + 1);
      if (next === 46) {
        var next2 = this.input.charCodeAt(this.pos + 2);
        if (next2 < 48 || next2 > 57) {
          return this.finishOp(types$1.questionDot, 2);
        }
      }
      if (next === 63) {
        if (ecmaVersion2 >= 12) {
          var next2$1 = this.input.charCodeAt(this.pos + 2);
          if (next2$1 === 61) {
            return this.finishOp(types$1.assign, 3);
          }
        }
        return this.finishOp(types$1.coalesce, 2);
      }
    }
    return this.finishOp(types$1.question, 1);
  };
  pp.readToken_numberSign = function() {
    var ecmaVersion2 = this.options.ecmaVersion;
    var code = 35;
    if (ecmaVersion2 >= 13) {
      ++this.pos;
      code = this.fullCharCodeAtPos();
      if (isIdentifierStart(code, true) || code === 92) {
        return this.finishToken(types$1.privateId, this.readWord1());
      }
    }
    this.raise(this.pos, "Unexpected character '" + codePointToString(code) + "'");
  };
  pp.getTokenFromCode = function(code) {
    switch (code) {
      case 46:
        return this.readToken_dot();
      case 40:
        ++this.pos;
        return this.finishToken(types$1.parenL);
      case 41:
        ++this.pos;
        return this.finishToken(types$1.parenR);
      case 59:
        ++this.pos;
        return this.finishToken(types$1.semi);
      case 44:
        ++this.pos;
        return this.finishToken(types$1.comma);
      case 91:
        ++this.pos;
        return this.finishToken(types$1.bracketL);
      case 93:
        ++this.pos;
        return this.finishToken(types$1.bracketR);
      case 123:
        ++this.pos;
        return this.finishToken(types$1.braceL);
      case 125:
        ++this.pos;
        return this.finishToken(types$1.braceR);
      case 58:
        ++this.pos;
        return this.finishToken(types$1.colon);
      case 96:
        if (this.options.ecmaVersion < 6) {
          break;
        }
        ++this.pos;
        return this.finishToken(types$1.backQuote);
      case 48:
        var next = this.input.charCodeAt(this.pos + 1);
        if (next === 120 || next === 88) {
          return this.readRadixNumber(16);
        }
        if (this.options.ecmaVersion >= 6) {
          if (next === 111 || next === 79) {
            return this.readRadixNumber(8);
          }
          if (next === 98 || next === 66) {
            return this.readRadixNumber(2);
          }
        }
      case 49:
      case 50:
      case 51:
      case 52:
      case 53:
      case 54:
      case 55:
      case 56:
      case 57:
        return this.readNumber(false);
      case 34:
      case 39:
        return this.readString(code);
      case 47:
        return this.readToken_slash();
      case 37:
      case 42:
        return this.readToken_mult_modulo_exp(code);
      case 124:
      case 38:
        return this.readToken_pipe_amp(code);
      case 94:
        return this.readToken_caret();
      case 43:
      case 45:
        return this.readToken_plus_min(code);
      case 60:
      case 62:
        return this.readToken_lt_gt(code);
      case 61:
      case 33:
        return this.readToken_eq_excl(code);
      case 63:
        return this.readToken_question();
      case 126:
        return this.finishOp(types$1.prefix, 1);
      case 35:
        return this.readToken_numberSign();
    }
    this.raise(this.pos, "Unexpected character '" + codePointToString(code) + "'");
  };
  pp.finishOp = function(type, size) {
    var str = this.input.slice(this.pos, this.pos + size);
    this.pos += size;
    return this.finishToken(type, str);
  };
  pp.readRegexp = function() {
    var escaped, inClass, start = this.pos;
    for (;; ) {
      if (this.pos >= this.input.length) {
        this.raise(start, "Unterminated regular expression");
      }
      var ch = this.input.charAt(this.pos);
      if (lineBreak.test(ch)) {
        this.raise(start, "Unterminated regular expression");
      }
      if (!escaped) {
        if (ch === "[") {
          inClass = true;
        } else if (ch === "]" && inClass) {
          inClass = false;
        } else if (ch === "/" && !inClass) {
          break;
        }
        escaped = ch === "\\";
      } else {
        escaped = false;
      }
      ++this.pos;
    }
    var pattern = this.input.slice(start, this.pos);
    ++this.pos;
    var flagsStart = this.pos;
    var flags = this.readWord1();
    if (this.containsEsc) {
      this.unexpected(flagsStart);
    }
    var state = this.regexpState || (this.regexpState = new RegExpValidationState(this));
    state.reset(start, pattern, flags);
    this.validateRegExpFlags(state);
    this.validateRegExpPattern(state);
    var value = null;
    try {
      value = new RegExp(pattern, flags);
    } catch (e) {
    }
    return this.finishToken(types$1.regexp, { pattern, flags, value });
  };
  pp.readInt = function(radix, len, maybeLegacyOctalNumericLiteral) {
    var allowSeparators = this.options.ecmaVersion >= 12 && len === undefined;
    var isLegacyOctalNumericLiteral = maybeLegacyOctalNumericLiteral && this.input.charCodeAt(this.pos) === 48;
    var start = this.pos, total = 0, lastCode = 0;
    for (var i2 = 0, e = len == null ? Infinity : len;i2 < e; ++i2, ++this.pos) {
      var code = this.input.charCodeAt(this.pos), val2 = undefined;
      if (allowSeparators && code === 95) {
        if (isLegacyOctalNumericLiteral) {
          this.raiseRecoverable(this.pos, "Numeric separator is not allowed in legacy octal numeric literals");
        }
        if (lastCode === 95) {
          this.raiseRecoverable(this.pos, "Numeric separator must be exactly one underscore");
        }
        if (i2 === 0) {
          this.raiseRecoverable(this.pos, "Numeric separator is not allowed at the first of digits");
        }
        lastCode = code;
        continue;
      }
      if (code >= 97) {
        val2 = code - 97 + 10;
      } else if (code >= 65) {
        val2 = code - 65 + 10;
      } else if (code >= 48 && code <= 57) {
        val2 = code - 48;
      } else {
        val2 = Infinity;
      }
      if (val2 >= radix) {
        break;
      }
      lastCode = code;
      total = total * radix + val2;
    }
    if (allowSeparators && lastCode === 95) {
      this.raiseRecoverable(this.pos - 1, "Numeric separator is not allowed at the last of digits");
    }
    if (this.pos === start || len != null && this.pos - start !== len) {
      return null;
    }
    return total;
  };
  pp.readRadixNumber = function(radix) {
    var start = this.pos;
    this.pos += 2;
    var val2 = this.readInt(radix);
    if (val2 == null) {
      this.raise(this.start + 2, "Expected number in radix " + radix);
    }
    if (this.options.ecmaVersion >= 11 && this.input.charCodeAt(this.pos) === 110) {
      val2 = stringToBigInt(this.input.slice(start, this.pos));
      ++this.pos;
    } else if (isIdentifierStart(this.fullCharCodeAtPos())) {
      this.raise(this.pos, "Identifier directly after number");
    }
    return this.finishToken(types$1.num, val2);
  };
  pp.readNumber = function(startsWithDot) {
    var start = this.pos;
    if (!startsWithDot && this.readInt(10, undefined, true) === null) {
      this.raise(start, "Invalid number");
    }
    var octal = this.pos - start >= 2 && this.input.charCodeAt(start) === 48;
    if (octal && this.strict) {
      this.raise(start, "Invalid number");
    }
    var next = this.input.charCodeAt(this.pos);
    if (!octal && !startsWithDot && this.options.ecmaVersion >= 11 && next === 110) {
      var val$1 = stringToBigInt(this.input.slice(start, this.pos));
      ++this.pos;
      if (isIdentifierStart(this.fullCharCodeAtPos())) {
        this.raise(this.pos, "Identifier directly after number");
      }
      return this.finishToken(types$1.num, val$1);
    }
    if (octal && /[89]/.test(this.input.slice(start, this.pos))) {
      octal = false;
    }
    if (next === 46 && !octal) {
      ++this.pos;
      this.readInt(10);
      next = this.input.charCodeAt(this.pos);
    }
    if ((next === 69 || next === 101) && !octal) {
      next = this.input.charCodeAt(++this.pos);
      if (next === 43 || next === 45) {
        ++this.pos;
      }
      if (this.readInt(10) === null) {
        this.raise(start, "Invalid number");
      }
    }
    if (isIdentifierStart(this.fullCharCodeAtPos())) {
      this.raise(this.pos, "Identifier directly after number");
    }
    var val2 = stringToNumber(this.input.slice(start, this.pos), octal);
    return this.finishToken(types$1.num, val2);
  };
  pp.readCodePoint = function() {
    var ch = this.input.charCodeAt(this.pos), code;
    if (ch === 123) {
      if (this.options.ecmaVersion < 6) {
        this.unexpected();
      }
      var codePos = ++this.pos;
      code = this.readHexChar(this.input.indexOf("}", this.pos) - this.pos);
      ++this.pos;
      if (code > 1114111) {
        this.invalidStringToken(codePos, "Code point out of bounds");
      }
    } else {
      code = this.readHexChar(4);
    }
    return code;
  };
  pp.readString = function(quote) {
    var out = "", chunkStart = ++this.pos;
    for (;; ) {
      if (this.pos >= this.input.length) {
        this.raise(this.start, "Unterminated string constant");
      }
      var ch = this.input.charCodeAt(this.pos);
      if (ch === quote) {
        break;
      }
      if (ch === 92) {
        out += this.input.slice(chunkStart, this.pos);
        out += this.readEscapedChar(false);
        chunkStart = this.pos;
      } else if (ch === 8232 || ch === 8233) {
        if (this.options.ecmaVersion < 10) {
          this.raise(this.start, "Unterminated string constant");
        }
        ++this.pos;
        if (this.options.locations) {
          this.curLine++;
          this.lineStart = this.pos;
        }
      } else {
        if (isNewLine(ch)) {
          this.raise(this.start, "Unterminated string constant");
        }
        ++this.pos;
      }
    }
    out += this.input.slice(chunkStart, this.pos++);
    return this.finishToken(types$1.string, out);
  };
  INVALID_TEMPLATE_ESCAPE_ERROR = {};
  pp.tryReadTemplateToken = function() {
    this.inTemplateElement = true;
    try {
      this.readTmplToken();
    } catch (err22) {
      if (err22 === INVALID_TEMPLATE_ESCAPE_ERROR) {
        this.readInvalidTemplateToken();
      } else {
        throw err22;
      }
    }
    this.inTemplateElement = false;
  };
  pp.invalidStringToken = function(position, message) {
    if (this.inTemplateElement && this.options.ecmaVersion >= 9) {
      throw INVALID_TEMPLATE_ESCAPE_ERROR;
    } else {
      this.raise(position, message);
    }
  };
  pp.readTmplToken = function() {
    var out = "", chunkStart = this.pos;
    for (;; ) {
      if (this.pos >= this.input.length) {
        this.raise(this.start, "Unterminated template");
      }
      var ch = this.input.charCodeAt(this.pos);
      if (ch === 96 || ch === 36 && this.input.charCodeAt(this.pos + 1) === 123) {
        if (this.pos === this.start && (this.type === types$1.template || this.type === types$1.invalidTemplate)) {
          if (ch === 36) {
            this.pos += 2;
            return this.finishToken(types$1.dollarBraceL);
          } else {
            ++this.pos;
            return this.finishToken(types$1.backQuote);
          }
        }
        out += this.input.slice(chunkStart, this.pos);
        return this.finishToken(types$1.template, out);
      }
      if (ch === 92) {
        out += this.input.slice(chunkStart, this.pos);
        out += this.readEscapedChar(true);
        chunkStart = this.pos;
      } else if (isNewLine(ch)) {
        out += this.input.slice(chunkStart, this.pos);
        ++this.pos;
        switch (ch) {
          case 13:
            if (this.input.charCodeAt(this.pos) === 10) {
              ++this.pos;
            }
          case 10:
            out += "\n";
            break;
          default:
            out += String.fromCharCode(ch);
            break;
        }
        if (this.options.locations) {
          ++this.curLine;
          this.lineStart = this.pos;
        }
        chunkStart = this.pos;
      } else {
        ++this.pos;
      }
    }
  };
  pp.readInvalidTemplateToken = function() {
    for (;this.pos < this.input.length; this.pos++) {
      switch (this.input[this.pos]) {
        case "\\":
          ++this.pos;
          break;
        case "$":
          if (this.input[this.pos + 1] !== "{") {
            break;
          }
        case "`":
          return this.finishToken(types$1.invalidTemplate, this.input.slice(this.start, this.pos));
      }
    }
    this.raise(this.start, "Unterminated template");
  };
  pp.readEscapedChar = function(inTemplate) {
    var ch = this.input.charCodeAt(++this.pos);
    ++this.pos;
    switch (ch) {
      case 110:
        return "\n";
      case 114:
        return "\r";
      case 120:
        return String.fromCharCode(this.readHexChar(2));
      case 117:
        return codePointToString(this.readCodePoint());
      case 116:
        return "\t";
      case 98:
        return "\b";
      case 118:
        return "\v";
      case 102:
        return "\f";
      case 13:
        if (this.input.charCodeAt(this.pos) === 10) {
          ++this.pos;
        }
      case 10:
        if (this.options.locations) {
          this.lineStart = this.pos;
          ++this.curLine;
        }
        return "";
      case 56:
      case 57:
        if (this.strict) {
          this.invalidStringToken(this.pos - 1, "Invalid escape sequence");
        }
        if (inTemplate) {
          var codePos = this.pos - 1;
          this.invalidStringToken(codePos, "Invalid escape sequence in template string");
        }
      default:
        if (ch >= 48 && ch <= 55) {
          var octalStr = this.input.substr(this.pos - 1, 3).match(/^[0-7]+/)[0];
          var octal = parseInt(octalStr, 8);
          if (octal > 255) {
            octalStr = octalStr.slice(0, -1);
            octal = parseInt(octalStr, 8);
          }
          this.pos += octalStr.length - 1;
          ch = this.input.charCodeAt(this.pos);
          if ((octalStr !== "0" || ch === 56 || ch === 57) && (this.strict || inTemplate)) {
            this.invalidStringToken(this.pos - 1 - octalStr.length, inTemplate ? "Octal literal in template string" : "Octal literal in strict mode");
          }
          return String.fromCharCode(octal);
        }
        if (isNewLine(ch)) {
          return "";
        }
        return String.fromCharCode(ch);
    }
  };
  pp.readHexChar = function(len) {
    var codePos = this.pos;
    var n = this.readInt(16, len);
    if (n === null) {
      this.invalidStringToken(codePos, "Bad character escape sequence");
    }
    return n;
  };
  pp.readWord1 = function() {
    this.containsEsc = false;
    var word = "", first = true, chunkStart = this.pos;
    var astral = this.options.ecmaVersion >= 6;
    while (this.pos < this.input.length) {
      var ch = this.fullCharCodeAtPos();
      if (isIdentifierChar(ch, astral)) {
        this.pos += ch <= 65535 ? 1 : 2;
      } else if (ch === 92) {
        this.containsEsc = true;
        word += this.input.slice(chunkStart, this.pos);
        var escStart = this.pos;
        if (this.input.charCodeAt(++this.pos) !== 117) {
          this.invalidStringToken(this.pos, "Expecting Unicode escape sequence \\uXXXX");
        }
        ++this.pos;
        var esc = this.readCodePoint();
        if (!(first ? isIdentifierStart : isIdentifierChar)(esc, astral)) {
          this.invalidStringToken(escStart, "Invalid Unicode escape");
        }
        word += codePointToString(esc);
        chunkStart = this.pos;
      } else {
        break;
      }
      first = false;
    }
    return word + this.input.slice(chunkStart, this.pos);
  };
  pp.readWord = function() {
    var word = this.readWord1();
    var type = types$1.name;
    if (this.keywords.test(word)) {
      type = keywords[word];
    }
    return this.finishToken(type, word);
  };
  Parser.acorn = {
    Parser,
    version: version2,
    defaultOptions,
    Position,
    SourceLocation,
    getLineInfo,
    Node,
    TokenType,
    tokTypes: types$1,
    keywordTypes: keywords,
    TokContext,
    tokContexts: types3,
    isIdentifierChar,
    isIdentifierStart,
    Token,
    isNewLine,
    lineBreak,
    lineBreakG,
    nonASCIIwhitespace
  };
  emittedFileTypes = new Set(["chunk", "asset", "prebuilt-chunk"]);
  inputHookNames = {
    buildEnd: 1,
    buildStart: 1,
    closeBundle: 1,
    closeWatcher: 1,
    load: 1,
    moduleParsed: 1,
    onLog: 1,
    options: 1,
    resolveDynamicImport: 1,
    resolveId: 1,
    shouldTransformCachedModule: 1,
    transform: 1,
    watchChange: 1
  };
  inputHooks = Object.keys(inputHookNames);
  rejectByPluginDriver = new Map;
  leftCurlyBrace = "{".charCodeAt(0);
  space = " ".charCodeAt(0);
  ALLOWED_INTEROP_TYPES = new Set([
    "compat",
    "auto",
    "esModule",
    "default",
    "defaultOnly"
  ]);
  (function(SortingFileType2) {
    SortingFileType2[SortingFileType2["ENTRY_CHUNK"] = 0] = "ENTRY_CHUNK";
    SortingFileType2[SortingFileType2["SECONDARY_CHUNK"] = 1] = "SECONDARY_CHUNK";
    SortingFileType2[SortingFileType2["ASSET"] = 2] = "ASSET";
  })(SortingFileType || (SortingFileType = {}));
  ({
    env: env5 = {},
    argv: argv22 = [],
    platform: platform22 = ""
  } = typeof process === "undefined" ? {} : process);
  isDisabled22 = "NO_COLOR" in env5 || argv22.includes("--no-color");
  isForced22 = "FORCE_COLOR" in env5 || argv22.includes("--color");
  isWindows22 = platform22 === "win32";
  isDumbTerminal22 = env5.TERM === "dumb";
  isCompatibleTerminal22 = tty42 && tty42.isatty && tty42.isatty(1) && env5.TERM && !isDumbTerminal22;
  isCI32 = "CI" in env5 && (("GITHUB_ACTIONS" in env5) || ("GITLAB_CI" in env5) || ("CIRCLECI" in env5));
  isColorSupported32 = !isDisabled22 && (isForced22 || isWindows22 && !isDumbTerminal22 || isCompatibleTerminal22 || isCI32);
  colors22 = {
    reset: init22(0, 0),
    bold: init22(1, 22, "\x1B[22m\x1B[1m"),
    dim: init22(2, 22, "\x1B[22m\x1B[2m"),
    italic: init22(3, 23),
    underline: init22(4, 24),
    inverse: init22(7, 27),
    hidden: init22(8, 28),
    strikethrough: init22(9, 29),
    black: init22(30, 39),
    red: init22(31, 39),
    green: init22(32, 39),
    yellow: init22(33, 39),
    blue: init22(34, 39),
    magenta: init22(35, 39),
    cyan: init22(36, 39),
    white: init22(37, 39),
    gray: init22(90, 39),
    bgBlack: init22(40, 49),
    bgRed: init22(41, 49),
    bgGreen: init22(42, 49),
    bgYellow: init22(43, 49),
    bgBlue: init22(44, 49),
    bgMagenta: init22(45, 49),
    bgCyan: init22(46, 49),
    bgWhite: init22(47, 49),
    blackBright: init22(90, 39),
    redBright: init22(91, 39),
    greenBright: init22(92, 39),
    yellowBright: init22(93, 39),
    blueBright: init22(94, 39),
    magentaBright: init22(95, 39),
    cyanBright: init22(96, 39),
    whiteBright: init22(97, 39),
    bgBlackBright: init22(100, 49),
    bgRedBright: init22(101, 49),
    bgGreenBright: init22(102, 49),
    bgYellowBright: init22(103, 49),
    bgBlueBright: init22(104, 49),
    bgMagentaBright: init22(105, 49),
    bgCyanBright: init22(106, 49),
    bgWhiteBright: init22(107, 49)
  };
  createColors32();
  ({ bold: bold22, cyan: cyan22, dim: dim22, gray: gray22, green: green22, red: red22, underline: underline22, yellow: yellow22 } = createColors32({
    useColor: env$1.FORCE_COLOR !== "0" && !env$1.NO_COLOR
  }));
});
var init_rollup = __esm2(() => {
  init_node_entry();
});
var require_cjs = __commonJS2((exports, module) => {
  var isMergeableObject = function isMergeableObject(value) {
    return isNonNullObject(value) && !isSpecial(value);
  };
  function isNonNullObject(value) {
    return !!value && typeof value === "object";
  }
  function isSpecial(value) {
    var stringValue = Object.prototype.toString.call(value);
    return stringValue === "[object RegExp]" || stringValue === "[object Date]" || isReactElement(value);
  }
  var canUseSymbol = typeof Symbol === "function" && Symbol.for;
  var REACT_ELEMENT_TYPE = canUseSymbol ? Symbol.for("react.element") : 60103;
  function isReactElement(value) {
    return value.$$typeof === REACT_ELEMENT_TYPE;
  }
  function emptyTarget(val2) {
    return Array.isArray(val2) ? [] : {};
  }
  function cloneUnlessOtherwiseSpecified(value, options3) {
    return options3.clone !== false && options3.isMergeableObject(value) ? deepmerge(emptyTarget(value), value, options3) : value;
  }
  function defaultArrayMerge(target, source, options3) {
    return target.concat(source).map(function(element) {
      return cloneUnlessOtherwiseSpecified(element, options3);
    });
  }
  function getMergeFunction(key, options3) {
    if (!options3.customMerge) {
      return deepmerge;
    }
    var customMerge = options3.customMerge(key);
    return typeof customMerge === "function" ? customMerge : deepmerge;
  }
  function getEnumerableOwnPropertySymbols(target) {
    return Object.getOwnPropertySymbols ? Object.getOwnPropertySymbols(target).filter(function(symbol22) {
      return Object.propertyIsEnumerable.call(target, symbol22);
    }) : [];
  }
  function getKeys(target) {
    return Object.keys(target).concat(getEnumerableOwnPropertySymbols(target));
  }
  function propertyIsOnObject(object, property) {
    try {
      return property in object;
    } catch (_22) {
      return false;
    }
  }
  function propertyIsUnsafe(target, key) {
    return propertyIsOnObject(target, key) && !(Object.hasOwnProperty.call(target, key) && Object.propertyIsEnumerable.call(target, key));
  }
  function mergeObject(target, source, options3) {
    var destination = {};
    if (options3.isMergeableObject(target)) {
      getKeys(target).forEach(function(key) {
        destination[key] = cloneUnlessOtherwiseSpecified(target[key], options3);
      });
    }
    getKeys(source).forEach(function(key) {
      if (propertyIsUnsafe(target, key)) {
        return;
      }
      if (propertyIsOnObject(target, key) && options3.isMergeableObject(source[key])) {
        destination[key] = getMergeFunction(key, options3)(target[key], source[key], options3);
      } else {
        destination[key] = cloneUnlessOtherwiseSpecified(source[key], options3);
      }
    });
    return destination;
  }
  function deepmerge(target, source, options3) {
    options3 = options3 || {};
    options3.arrayMerge = options3.arrayMerge || defaultArrayMerge;
    options3.isMergeableObject = options3.isMergeableObject || isMergeableObject;
    options3.cloneUnlessOtherwiseSpecified = cloneUnlessOtherwiseSpecified;
    var sourceIsArray = Array.isArray(source);
    var targetIsArray = Array.isArray(target);
    var sourceAndTargetTypesMatch = sourceIsArray === targetIsArray;
    if (!sourceAndTargetTypesMatch) {
      return cloneUnlessOtherwiseSpecified(source, options3);
    } else if (sourceIsArray) {
      return options3.arrayMerge(target, source, options3);
    } else {
      return mergeObject(target, source, options3);
    }
  }
  deepmerge.all = function deepmergeAll(array, options3) {
    if (!Array.isArray(array)) {
      throw new Error("first argument should be an array");
    }
    return array.reduce(function(prev, next) {
      return deepmerge(prev, next, options3);
    }, {});
  };
  var deepmerge_1 = deepmerge;
  module.exports = deepmerge_1;
});
var require_is_module = __commonJS2((exports, module) => {
  var ES6ImportExportRegExp = /(?:^\s*|[}{\(\);,\n]\s*)(import\s+['"]|(import|module)\s+[^"'\(\)\n;]+\s+from\s+['"]|export\s+(\*|\{|default|function|var|const|let|[_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*))/;
  var ES6AliasRegExp = /(?:^\s*|[}{\(\);,\n]\s*)(export\s*\*\s*from\s*(?:'([^']+)'|"([^"]+)"))/;
  module.exports = function(sauce) {
    return ES6ImportExportRegExp.test(sauce) || ES6AliasRegExp.test(sauce);
  };
});
var require_homedir = __commonJS2((exports, module) => {
  var os32 = import.meta.require("os");
  module.exports = os32.homedir || function homedir() {
    var home = "/Users/chrisbreuer";
    var user = "chrisbreuer";
    if (process.platform === "win32") {
      return process.env.USERPROFILE || process.env.HOMEDRIVE + process.env.HOMEPATH || home || null;
    }
    if (process.platform === "darwin") {
      return home || (user ? "/Users/" + user : null);
    }
    if (process.platform === "linux") {
      return home || (process.getuid() === 0 ? "/root" : user ? "/home/" + user : null);
    }
    return home || null;
  };
});
var require_caller = __commonJS2((exports, module) => {
  module.exports = function() {
    var origPrepareStackTrace = Error.prepareStackTrace;
    Error.prepareStackTrace = function(_22, stack2) {
      return stack2;
    };
    var stack = new Error().stack;
    Error.prepareStackTrace = origPrepareStackTrace;
    return stack[2].getFileName();
  };
});
var require_path_parse = __commonJS2((exports, module) => {
  var isWindows3 = process.platform === "win32";
  var splitWindowsRe = /^(((?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?[\\\/]?)(?:[^\\\/]*[\\\/])*)((\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))[\\\/]*$/;
  var win3222 = {};
  function win32SplitPath(filename2) {
    return splitWindowsRe.exec(filename2).slice(1);
  }
  win3222.parse = function(pathString) {
    if (typeof pathString !== "string") {
      throw new TypeError("Parameter 'pathString' must be a string, not " + typeof pathString);
    }
    var allParts = win32SplitPath(pathString);
    if (!allParts || allParts.length !== 5) {
      throw new TypeError("Invalid path '" + pathString + "'");
    }
    return {
      root: allParts[1],
      dir: allParts[0] === allParts[1] ? allParts[0] : allParts[0].slice(0, -1),
      base: allParts[2],
      ext: allParts[4],
      name: allParts[3]
    };
  };
  var splitPathRe = /^((\/?)(?:[^\/]*\/)*)((\.{1,2}|[^\/]+?|)(\.[^.\/]*|))[\/]*$/;
  var posix22 = {};
  function posixSplitPath(filename2) {
    return splitPathRe.exec(filename2).slice(1);
  }
  posix22.parse = function(pathString) {
    if (typeof pathString !== "string") {
      throw new TypeError("Parameter 'pathString' must be a string, not " + typeof pathString);
    }
    var allParts = posixSplitPath(pathString);
    if (!allParts || allParts.length !== 5) {
      throw new TypeError("Invalid path '" + pathString + "'");
    }
    return {
      root: allParts[1],
      dir: allParts[0].slice(0, -1),
      base: allParts[2],
      ext: allParts[4],
      name: allParts[3]
    };
  };
  if (isWindows3)
    module.exports = win3222.parse;
  else
    module.exports = posix22.parse;
  module.exports.posix = posix22.parse;
  module.exports.win32 = win3222.parse;
});
var require_node_modules_paths = __commonJS2((exports, module) => {
  var path42 = import.meta.require("path");
  var parse5 = path42.parse || require_path_parse();
  var getNodeModulesDirs = function getNodeModulesDirs(absoluteStart, modules) {
    var prefix = "/";
    if (/^([A-Za-z]:)/.test(absoluteStart)) {
      prefix = "";
    } else if (/^\\\\/.test(absoluteStart)) {
      prefix = "\\\\";
    }
    var paths = [absoluteStart];
    var parsed = parse5(absoluteStart);
    while (parsed.dir !== paths[paths.length - 1]) {
      paths.push(parsed.dir);
      parsed = parse5(parsed.dir);
    }
    return paths.reduce(function(dirs, aPath) {
      return dirs.concat(modules.map(function(moduleDir) {
        return path42.resolve(prefix, aPath, moduleDir);
      }));
    }, []);
  };
  module.exports = function nodeModulesPaths(start, opts, request2) {
    var modules = opts && opts.moduleDirectory ? [].concat(opts.moduleDirectory) : ["node_modules"];
    if (opts && typeof opts.paths === "function") {
      return opts.paths(request2, start, function() {
        return getNodeModulesDirs(start, modules);
      }, opts);
    }
    var dirs = getNodeModulesDirs(start, modules);
    return opts && opts.paths ? dirs.concat(opts.paths) : dirs;
  };
});
var require_normalize_options = __commonJS2((exports, module) => {
  module.exports = function(x, opts) {
    return opts || {};
  };
});
var require_implementation = __commonJS2((exports, module) => {
  var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ";
  var toStr = Object.prototype.toString;
  var max = Math.max;
  var funcType = "[object Function]";
  var concatty = function concatty(a, b22) {
    var arr = [];
    for (var i2 = 0;i2 < a.length; i2 += 1) {
      arr[i2] = a[i2];
    }
    for (var j22 = 0;j22 < b22.length; j22 += 1) {
      arr[j22 + a.length] = b22[j22];
    }
    return arr;
  };
  var slicy = function slicy(arrLike, offset2) {
    var arr = [];
    for (var i2 = offset2 || 0, j22 = 0;i2 < arrLike.length; i2 += 1, j22 += 1) {
      arr[j22] = arrLike[i2];
    }
    return arr;
  };
  var joiny = function(arr, joiner) {
    var str = "";
    for (var i2 = 0;i2 < arr.length; i2 += 1) {
      str += arr[i2];
      if (i2 + 1 < arr.length) {
        str += joiner;
      }
    }
    return str;
  };
  module.exports = function bind(that) {
    var target = this;
    if (typeof target !== "function" || toStr.apply(target) !== funcType) {
      throw new TypeError(ERROR_MESSAGE + target);
    }
    var args = slicy(arguments, 1);
    var bound;
    var binder = function() {
      if (this instanceof bound) {
        var result2 = target.apply(this, concatty(args, arguments));
        if (Object(result2) === result2) {
          return result2;
        }
        return this;
      }
      return target.apply(that, concatty(args, arguments));
    };
    var boundLength = max(0, target.length - args.length);
    var boundArgs = [];
    for (var i2 = 0;i2 < boundLength; i2++) {
      boundArgs[i2] = "$" + i2;
    }
    bound = Function("binder", "return function (" + joiny(boundArgs, ",") + "){ return binder.apply(this,arguments); }")(binder);
    if (target.prototype) {
      var Empty = function Empty() {
      };
      Empty.prototype = target.prototype;
      bound.prototype = new Empty;
      Empty.prototype = null;
    }
    return bound;
  };
});
var require_function_bind = __commonJS2((exports, module) => {
  var implementation = require_implementation();
  module.exports = Function.prototype.bind || implementation;
});
var require_hasown = __commonJS2((exports, module) => {
  var call = Function.prototype.call;
  var $hasOwn = Object.prototype.hasOwnProperty;
  var bind = require_function_bind();
  module.exports = bind.call(call, $hasOwn);
});
var require_core2 = __commonJS2((exports, module) => {
  module.exports = {
    assert: true,
    "node:assert": [">= 14.18 && < 15", ">= 16"],
    "assert/strict": ">= 15",
    "node:assert/strict": ">= 16",
    async_hooks: ">= 8",
    "node:async_hooks": [">= 14.18 && < 15", ">= 16"],
    buffer_ieee754: ">= 0.5 && < 0.9.7",
    buffer: true,
    "node:buffer": [">= 14.18 && < 15", ">= 16"],
    child_process: true,
    "node:child_process": [">= 14.18 && < 15", ">= 16"],
    cluster: ">= 0.5",
    "node:cluster": [">= 14.18 && < 15", ">= 16"],
    console: true,
    "node:console": [">= 14.18 && < 15", ">= 16"],
    constants: true,
    "node:constants": [">= 14.18 && < 15", ">= 16"],
    crypto: true,
    "node:crypto": [">= 14.18 && < 15", ">= 16"],
    _debug_agent: ">= 1 && < 8",
    _debugger: "< 8",
    dgram: true,
    "node:dgram": [">= 14.18 && < 15", ">= 16"],
    diagnostics_channel: [">= 14.17 && < 15", ">= 15.1"],
    "node:diagnostics_channel": [">= 14.18 && < 15", ">= 16"],
    dns: true,
    "node:dns": [">= 14.18 && < 15", ">= 16"],
    "dns/promises": ">= 15",
    "node:dns/promises": ">= 16",
    domain: ">= 0.7.12",
    "node:domain": [">= 14.18 && < 15", ">= 16"],
    events: true,
    "node:events": [">= 14.18 && < 15", ">= 16"],
    freelist: "< 6",
    fs: true,
    "node:fs": [">= 14.18 && < 15", ">= 16"],
    "fs/promises": [">= 10 && < 10.1", ">= 14"],
    "node:fs/promises": [">= 14.18 && < 15", ">= 16"],
    _http_agent: ">= 0.11.1",
    "node:_http_agent": [">= 14.18 && < 15", ">= 16"],
    _http_client: ">= 0.11.1",
    "node:_http_client": [">= 14.18 && < 15", ">= 16"],
    _http_common: ">= 0.11.1",
    "node:_http_common": [">= 14.18 && < 15", ">= 16"],
    _http_incoming: ">= 0.11.1",
    "node:_http_incoming": [">= 14.18 && < 15", ">= 16"],
    _http_outgoing: ">= 0.11.1",
    "node:_http_outgoing": [">= 14.18 && < 15", ">= 16"],
    _http_server: ">= 0.11.1",
    "node:_http_server": [">= 14.18 && < 15", ">= 16"],
    http: true,
    "node:http": [">= 14.18 && < 15", ">= 16"],
    http2: ">= 8.8",
    "node:http2": [">= 14.18 && < 15", ">= 16"],
    https: true,
    "node:https": [">= 14.18 && < 15", ">= 16"],
    inspector: ">= 8",
    "node:inspector": [">= 14.18 && < 15", ">= 16"],
    "inspector/promises": [">= 19"],
    "node:inspector/promises": [">= 19"],
    _linklist: "< 8",
    module: true,
    "node:module": [">= 14.18 && < 15", ">= 16"],
    net: true,
    "node:net": [">= 14.18 && < 15", ">= 16"],
    "node-inspect/lib/_inspect": ">= 7.6 && < 12",
    "node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
    "node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
    os: true,
    "node:os": [">= 14.18 && < 15", ">= 16"],
    path: true,
    "node:path": [">= 14.18 && < 15", ">= 16"],
    "path/posix": ">= 15.3",
    "node:path/posix": ">= 16",
    "path/win32": ">= 15.3",
    "node:path/win32": ">= 16",
    perf_hooks: ">= 8.5",
    "node:perf_hooks": [">= 14.18 && < 15", ">= 16"],
    process: ">= 1",
    "node:process": [">= 14.18 && < 15", ">= 16"],
    punycode: ">= 0.5",
    "node:punycode": [">= 14.18 && < 15", ">= 16"],
    querystring: true,
    "node:querystring": [">= 14.18 && < 15", ">= 16"],
    readline: true,
    "node:readline": [">= 14.18 && < 15", ">= 16"],
    "readline/promises": ">= 17",
    "node:readline/promises": ">= 17",
    repl: true,
    "node:repl": [">= 14.18 && < 15", ">= 16"],
    "node:sea": [">= 20.12 && < 21", ">= 21.7"],
    smalloc: ">= 0.11.5 && < 3",
    _stream_duplex: ">= 0.9.4",
    "node:_stream_duplex": [">= 14.18 && < 15", ">= 16"],
    _stream_transform: ">= 0.9.4",
    "node:_stream_transform": [">= 14.18 && < 15", ">= 16"],
    _stream_wrap: ">= 1.4.1",
    "node:_stream_wrap": [">= 14.18 && < 15", ">= 16"],
    _stream_passthrough: ">= 0.9.4",
    "node:_stream_passthrough": [">= 14.18 && < 15", ">= 16"],
    _stream_readable: ">= 0.9.4",
    "node:_stream_readable": [">= 14.18 && < 15", ">= 16"],
    _stream_writable: ">= 0.9.4",
    "node:_stream_writable": [">= 14.18 && < 15", ">= 16"],
    stream: true,
    "node:stream": [">= 14.18 && < 15", ">= 16"],
    "stream/consumers": ">= 16.7",
    "node:stream/consumers": ">= 16.7",
    "stream/promises": ">= 15",
    "node:stream/promises": ">= 16",
    "stream/web": ">= 16.5",
    "node:stream/web": ">= 16.5",
    string_decoder: true,
    "node:string_decoder": [">= 14.18 && < 15", ">= 16"],
    sys: [">= 0.4 && < 0.7", ">= 0.8"],
    "node:sys": [">= 14.18 && < 15", ">= 16"],
    "test/reporters": ">= 19.9 && < 20.2",
    "node:test/reporters": [">= 18.17 && < 19", ">= 19.9", ">= 20"],
    "test/mock_loader": ">= 22.3 && < 22.7",
    "node:test/mock_loader": ">= 22.3 && < 22.7",
    "node:test": [">= 16.17 && < 17", ">= 18"],
    timers: true,
    "node:timers": [">= 14.18 && < 15", ">= 16"],
    "timers/promises": ">= 15",
    "node:timers/promises": ">= 16",
    _tls_common: ">= 0.11.13",
    "node:_tls_common": [">= 14.18 && < 15", ">= 16"],
    _tls_legacy: ">= 0.11.3 && < 10",
    _tls_wrap: ">= 0.11.3",
    "node:_tls_wrap": [">= 14.18 && < 15", ">= 16"],
    tls: true,
    "node:tls": [">= 14.18 && < 15", ">= 16"],
    trace_events: ">= 10",
    "node:trace_events": [">= 14.18 && < 15", ">= 16"],
    tty: true,
    "node:tty": [">= 14.18 && < 15", ">= 16"],
    url: true,
    "node:url": [">= 14.18 && < 15", ">= 16"],
    util: true,
    "node:util": [">= 14.18 && < 15", ">= 16"],
    "util/types": ">= 15.3",
    "node:util/types": ">= 16",
    "v8/tools/arguments": ">= 10 && < 12",
    "v8/tools/codemap": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/consarray": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/csvparser": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/logreader": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/profile_view": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/splaytree": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    v8: ">= 1",
    "node:v8": [">= 14.18 && < 15", ">= 16"],
    vm: true,
    "node:vm": [">= 14.18 && < 15", ">= 16"],
    wasi: [">= 13.4 && < 13.5", ">= 18.17 && < 19", ">= 20"],
    "node:wasi": [">= 18.17 && < 19", ">= 20"],
    worker_threads: ">= 11.7",
    "node:worker_threads": [">= 14.18 && < 15", ">= 16"],
    zlib: ">= 0.5",
    "node:zlib": [">= 14.18 && < 15", ">= 16"]
  };
});
var require_is_core_module = __commonJS2((exports, module) => {
  var hasOwn2 = require_hasown();
  function specifierIncluded(current2, specifier) {
    var nodeParts = current2.split(".");
    var parts = specifier.split(" ");
    var op = parts.length > 1 ? parts[0] : "=";
    var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split(".");
    for (var i2 = 0;i2 < 3; ++i2) {
      var cur = parseInt(nodeParts[i2] || 0, 10);
      var ver = parseInt(versionParts[i2] || 0, 10);
      if (cur === ver) {
        continue;
      }
      if (op === "<") {
        return cur < ver;
      }
      if (op === ">=") {
        return cur >= ver;
      }
      return false;
    }
    return op === ">=";
  }
  function matchesRange(current2, range) {
    var specifiers = range.split(/ ?&& ?/);
    if (specifiers.length === 0) {
      return false;
    }
    for (var i2 = 0;i2 < specifiers.length; ++i2) {
      if (!specifierIncluded(current2, specifiers[i2])) {
        return false;
      }
    }
    return true;
  }
  function versionIncluded(nodeVersion, specifierValue) {
    if (typeof specifierValue === "boolean") {
      return specifierValue;
    }
    var current2 = typeof nodeVersion === "undefined" ? process.versions && process.versions.node : nodeVersion;
    if (typeof current2 !== "string") {
      throw new TypeError(typeof nodeVersion === "undefined" ? "Unable to determine current node version" : "If provided, a valid node version is required");
    }
    if (specifierValue && typeof specifierValue === "object") {
      for (var i2 = 0;i2 < specifierValue.length; ++i2) {
        if (matchesRange(current2, specifierValue[i2])) {
          return true;
        }
      }
      return false;
    }
    return matchesRange(current2, specifierValue);
  }
  var data2 = require_core2();
  module.exports = function isCore(x, nodeVersion) {
    return hasOwn2(data2, x) && versionIncluded(nodeVersion, data2[x]);
  };
});
var require_async = __commonJS2((exports, module) => {
  var fs2 = import.meta.require("fs");
  var getHomedir = require_homedir();
  var path42 = import.meta.require("path");
  var caller = require_caller();
  var nodeModulesPaths = require_node_modules_paths();
  var normalizeOptions = require_normalize_options();
  var isCore = require_is_core_module();
  var realpathFS = process.platform !== "win32" && fs2.realpath && typeof fs2.realpath.native === "function" ? fs2.realpath.native : fs2.realpath;
  var homedir2 = getHomedir();
  var defaultPaths = function() {
    return [
      path42.join(homedir2, ".node_modules"),
      path42.join(homedir2, ".node_libraries")
    ];
  };
  var defaultIsFile = function isFile(file, cb) {
    fs2.stat(file, function(err22, stat) {
      if (!err22) {
        return cb(null, stat.isFile() || stat.isFIFO());
      }
      if (err22.code === "ENOENT" || err22.code === "ENOTDIR")
        return cb(null, false);
      return cb(err22);
    });
  };
  var defaultIsDir = function isDirectory(dir, cb) {
    fs2.stat(dir, function(err22, stat) {
      if (!err22) {
        return cb(null, stat.isDirectory());
      }
      if (err22.code === "ENOENT" || err22.code === "ENOTDIR")
        return cb(null, false);
      return cb(err22);
    });
  };
  var defaultRealpath = function realpath(x, cb) {
    realpathFS(x, function(realpathErr, realPath) {
      if (realpathErr && realpathErr.code !== "ENOENT")
        cb(realpathErr);
      else
        cb(null, realpathErr ? x : realPath);
    });
  };
  var maybeRealpath = function maybeRealpath(realpath, x, opts, cb) {
    if (opts && opts.preserveSymlinks === false) {
      realpath(x, cb);
    } else {
      cb(null, x);
    }
  };
  var defaultReadPackage = function defaultReadPackage(readFile, pkgfile, cb) {
    readFile(pkgfile, function(readFileErr, body) {
      if (readFileErr)
        cb(readFileErr);
      else {
        try {
          var pkg = JSON.parse(body);
          cb(null, pkg);
        } catch (jsonErr) {
          cb(null);
        }
      }
    });
  };
  var getPackageCandidates = function getPackageCandidates(x, start, opts) {
    var dirs = nodeModulesPaths(start, opts, x);
    for (var i2 = 0;i2 < dirs.length; i2++) {
      dirs[i2] = path42.join(dirs[i2], x);
    }
    return dirs;
  };
  module.exports = function resolve(x, options3, callback) {
    var cb = callback;
    var opts = options3;
    if (typeof options3 === "function") {
      cb = opts;
      opts = {};
    }
    if (typeof x !== "string") {
      var err22 = new TypeError("Path must be a string.");
      return process.nextTick(function() {
        cb(err22);
      });
    }
    opts = normalizeOptions(x, opts);
    var isFile = opts.isFile || defaultIsFile;
    var isDirectory = opts.isDirectory || defaultIsDir;
    var readFile = opts.readFile || fs2.readFile;
    var realpath = opts.realpath || defaultRealpath;
    var readPackage = opts.readPackage || defaultReadPackage;
    if (opts.readFile && opts.readPackage) {
      var conflictErr = new TypeError("`readFile` and `readPackage` are mutually exclusive.");
      return process.nextTick(function() {
        cb(conflictErr);
      });
    }
    var packageIterator = opts.packageIterator;
    var extensions = opts.extensions || [".js"];
    var includeCoreModules = opts.includeCoreModules !== false;
    var basedir = opts.basedir || path42.dirname(caller());
    var parent = opts.filename || basedir;
    opts.paths = opts.paths || defaultPaths();
    var absoluteStart = path42.resolve(basedir);
    maybeRealpath(realpath, absoluteStart, opts, function(err3, realStart) {
      if (err3)
        cb(err3);
      else
        init3(realStart);
    });
    var res;
    function init3(basedir2) {
      if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x)) {
        res = path42.resolve(basedir2, x);
        if (x === "." || x === ".." || x.slice(-1) === "/")
          res += "/";
        if (/\/$/.test(x) && res === basedir2) {
          loadAsDirectory(res, opts.package, onfile);
        } else
          loadAsFile(res, opts.package, onfile);
      } else if (includeCoreModules && isCore(x)) {
        return cb(null, x);
      } else
        loadNodeModules(x, basedir2, function(err3, n, pkg) {
          if (err3)
            cb(err3);
          else if (n) {
            return maybeRealpath(realpath, n, opts, function(err4, realN) {
              if (err4) {
                cb(err4);
              } else {
                cb(null, realN, pkg);
              }
            });
          } else {
            var moduleError = new Error("Cannot find module '" + x + "' from '" + parent + "'");
            moduleError.code = "MODULE_NOT_FOUND";
            cb(moduleError);
          }
        });
    }
    function onfile(err3, m22, pkg) {
      if (err3)
        cb(err3);
      else if (m22)
        cb(null, m22, pkg);
      else
        loadAsDirectory(res, function(err4, d, pkg2) {
          if (err4)
            cb(err4);
          else if (d) {
            maybeRealpath(realpath, d, opts, function(err5, realD) {
              if (err5) {
                cb(err5);
              } else {
                cb(null, realD, pkg2);
              }
            });
          } else {
            var moduleError = new Error("Cannot find module '" + x + "' from '" + parent + "'");
            moduleError.code = "MODULE_NOT_FOUND";
            cb(moduleError);
          }
        });
    }
    function loadAsFile(x2, thePackage, callback2) {
      var loadAsFilePackage = thePackage;
      var cb2 = callback2;
      if (typeof loadAsFilePackage === "function") {
        cb2 = loadAsFilePackage;
        loadAsFilePackage = undefined;
      }
      var exts = [""].concat(extensions);
      load2(exts, x2, loadAsFilePackage);
      function load2(exts2, x3, loadPackage) {
        if (exts2.length === 0)
          return cb2(null, undefined, loadPackage);
        var file = x3 + exts2[0];
        var pkg = loadPackage;
        if (pkg)
          onpkg(null, pkg);
        else
          loadpkg(path42.dirname(file), onpkg);
        function onpkg(err3, pkg_, dir) {
          pkg = pkg_;
          if (err3)
            return cb2(err3);
          if (dir && pkg && opts.pathFilter) {
            var rfile = path42.relative(dir, file);
            var rel = rfile.slice(0, rfile.length - exts2[0].length);
            var r22 = opts.pathFilter(pkg, x3, rel);
            if (r22)
              return load2([""].concat(extensions.slice()), path42.resolve(dir, r22), pkg);
          }
          isFile(file, onex);
        }
        function onex(err3, ex) {
          if (err3)
            return cb2(err3);
          if (ex)
            return cb2(null, file, pkg);
          load2(exts2.slice(1), x3, pkg);
        }
      }
    }
    function loadpkg(dir, cb2) {
      if (dir === "" || dir === "/")
        return cb2(null);
      if (process.platform === "win32" && /^\w:[/\\]*$/.test(dir)) {
        return cb2(null);
      }
      if (/[/\\]node_modules[/\\]*$/.test(dir))
        return cb2(null);
      maybeRealpath(realpath, dir, opts, function(unwrapErr, pkgdir) {
        if (unwrapErr)
          return loadpkg(path42.dirname(dir), cb2);
        var pkgfile = path42.join(pkgdir, "package.json");
        isFile(pkgfile, function(err3, ex) {
          if (!ex)
            return loadpkg(path42.dirname(dir), cb2);
          readPackage(readFile, pkgfile, function(err4, pkgParam) {
            if (err4)
              cb2(err4);
            var pkg = pkgParam;
            if (pkg && opts.packageFilter) {
              pkg = opts.packageFilter(pkg, pkgfile);
            }
            cb2(null, pkg, dir);
          });
        });
      });
    }
    function loadAsDirectory(x2, loadAsDirectoryPackage, callback2) {
      var cb2 = callback2;
      var fpkg = loadAsDirectoryPackage;
      if (typeof fpkg === "function") {
        cb2 = fpkg;
        fpkg = opts.package;
      }
      maybeRealpath(realpath, x2, opts, function(unwrapErr, pkgdir) {
        if (unwrapErr)
          return cb2(unwrapErr);
        var pkgfile = path42.join(pkgdir, "package.json");
        isFile(pkgfile, function(err3, ex) {
          if (err3)
            return cb2(err3);
          if (!ex)
            return loadAsFile(path42.join(x2, "index"), fpkg, cb2);
          readPackage(readFile, pkgfile, function(err4, pkgParam) {
            if (err4)
              return cb2(err4);
            var pkg = pkgParam;
            if (pkg && opts.packageFilter) {
              pkg = opts.packageFilter(pkg, pkgfile);
            }
            if (pkg && pkg.main) {
              if (typeof pkg.main !== "string") {
                var mainError = new TypeError("package \u201C" + pkg.name + "\u201D `main` must be a string");
                mainError.code = "INVALID_PACKAGE_MAIN";
                return cb2(mainError);
              }
              if (pkg.main === "." || pkg.main === "./") {
                pkg.main = "index";
              }
              loadAsFile(path42.resolve(x2, pkg.main), pkg, function(err5, m22, pkg2) {
                if (err5)
                  return cb2(err5);
                if (m22)
                  return cb2(null, m22, pkg2);
                if (!pkg2)
                  return loadAsFile(path42.join(x2, "index"), pkg2, cb2);
                var dir = path42.resolve(x2, pkg2.main);
                loadAsDirectory(dir, pkg2, function(err6, n, pkg3) {
                  if (err6)
                    return cb2(err6);
                  if (n)
                    return cb2(null, n, pkg3);
                  loadAsFile(path42.join(x2, "index"), pkg3, cb2);
                });
              });
              return;
            }
            loadAsFile(path42.join(x2, "/index"), pkg, cb2);
          });
        });
      });
    }
    function processDirs(cb2, dirs) {
      if (dirs.length === 0)
        return cb2(null, undefined);
      var dir = dirs[0];
      isDirectory(path42.dirname(dir), isdir);
      function isdir(err3, isdir2) {
        if (err3)
          return cb2(err3);
        if (!isdir2)
          return processDirs(cb2, dirs.slice(1));
        loadAsFile(dir, opts.package, onfile2);
      }
      function onfile2(err3, m22, pkg) {
        if (err3)
          return cb2(err3);
        if (m22)
          return cb2(null, m22, pkg);
        loadAsDirectory(dir, opts.package, ondir);
      }
      function ondir(err3, n, pkg) {
        if (err3)
          return cb2(err3);
        if (n)
          return cb2(null, n, pkg);
        processDirs(cb2, dirs.slice(1));
      }
    }
    function loadNodeModules(x2, start, cb2) {
      var thunk = function() {
        return getPackageCandidates(x2, start, opts);
      };
      processDirs(cb2, packageIterator ? packageIterator(x2, start, thunk, opts) : thunk());
    }
  };
});
var require_core3 = __commonJS2((exports, module) => {
  module.exports = {
    assert: true,
    "node:assert": [">= 14.18 && < 15", ">= 16"],
    "assert/strict": ">= 15",
    "node:assert/strict": ">= 16",
    async_hooks: ">= 8",
    "node:async_hooks": [">= 14.18 && < 15", ">= 16"],
    buffer_ieee754: ">= 0.5 && < 0.9.7",
    buffer: true,
    "node:buffer": [">= 14.18 && < 15", ">= 16"],
    child_process: true,
    "node:child_process": [">= 14.18 && < 15", ">= 16"],
    cluster: ">= 0.5",
    "node:cluster": [">= 14.18 && < 15", ">= 16"],
    console: true,
    "node:console": [">= 14.18 && < 15", ">= 16"],
    constants: true,
    "node:constants": [">= 14.18 && < 15", ">= 16"],
    crypto: true,
    "node:crypto": [">= 14.18 && < 15", ">= 16"],
    _debug_agent: ">= 1 && < 8",
    _debugger: "< 8",
    dgram: true,
    "node:dgram": [">= 14.18 && < 15", ">= 16"],
    diagnostics_channel: [">= 14.17 && < 15", ">= 15.1"],
    "node:diagnostics_channel": [">= 14.18 && < 15", ">= 16"],
    dns: true,
    "node:dns": [">= 14.18 && < 15", ">= 16"],
    "dns/promises": ">= 15",
    "node:dns/promises": ">= 16",
    domain: ">= 0.7.12",
    "node:domain": [">= 14.18 && < 15", ">= 16"],
    events: true,
    "node:events": [">= 14.18 && < 15", ">= 16"],
    freelist: "< 6",
    fs: true,
    "node:fs": [">= 14.18 && < 15", ">= 16"],
    "fs/promises": [">= 10 && < 10.1", ">= 14"],
    "node:fs/promises": [">= 14.18 && < 15", ">= 16"],
    _http_agent: ">= 0.11.1",
    "node:_http_agent": [">= 14.18 && < 15", ">= 16"],
    _http_client: ">= 0.11.1",
    "node:_http_client": [">= 14.18 && < 15", ">= 16"],
    _http_common: ">= 0.11.1",
    "node:_http_common": [">= 14.18 && < 15", ">= 16"],
    _http_incoming: ">= 0.11.1",
    "node:_http_incoming": [">= 14.18 && < 15", ">= 16"],
    _http_outgoing: ">= 0.11.1",
    "node:_http_outgoing": [">= 14.18 && < 15", ">= 16"],
    _http_server: ">= 0.11.1",
    "node:_http_server": [">= 14.18 && < 15", ">= 16"],
    http: true,
    "node:http": [">= 14.18 && < 15", ">= 16"],
    http2: ">= 8.8",
    "node:http2": [">= 14.18 && < 15", ">= 16"],
    https: true,
    "node:https": [">= 14.18 && < 15", ">= 16"],
    inspector: ">= 8",
    "node:inspector": [">= 14.18 && < 15", ">= 16"],
    "inspector/promises": [">= 19"],
    "node:inspector/promises": [">= 19"],
    _linklist: "< 8",
    module: true,
    "node:module": [">= 14.18 && < 15", ">= 16"],
    net: true,
    "node:net": [">= 14.18 && < 15", ">= 16"],
    "node-inspect/lib/_inspect": ">= 7.6 && < 12",
    "node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
    "node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
    os: true,
    "node:os": [">= 14.18 && < 15", ">= 16"],
    path: true,
    "node:path": [">= 14.18 && < 15", ">= 16"],
    "path/posix": ">= 15.3",
    "node:path/posix": ">= 16",
    "path/win32": ">= 15.3",
    "node:path/win32": ">= 16",
    perf_hooks: ">= 8.5",
    "node:perf_hooks": [">= 14.18 && < 15", ">= 16"],
    process: ">= 1",
    "node:process": [">= 14.18 && < 15", ">= 16"],
    punycode: ">= 0.5",
    "node:punycode": [">= 14.18 && < 15", ">= 16"],
    querystring: true,
    "node:querystring": [">= 14.18 && < 15", ">= 16"],
    readline: true,
    "node:readline": [">= 14.18 && < 15", ">= 16"],
    "readline/promises": ">= 17",
    "node:readline/promises": ">= 17",
    repl: true,
    "node:repl": [">= 14.18 && < 15", ">= 16"],
    smalloc: ">= 0.11.5 && < 3",
    _stream_duplex: ">= 0.9.4",
    "node:_stream_duplex": [">= 14.18 && < 15", ">= 16"],
    _stream_transform: ">= 0.9.4",
    "node:_stream_transform": [">= 14.18 && < 15", ">= 16"],
    _stream_wrap: ">= 1.4.1",
    "node:_stream_wrap": [">= 14.18 && < 15", ">= 16"],
    _stream_passthrough: ">= 0.9.4",
    "node:_stream_passthrough": [">= 14.18 && < 15", ">= 16"],
    _stream_readable: ">= 0.9.4",
    "node:_stream_readable": [">= 14.18 && < 15", ">= 16"],
    _stream_writable: ">= 0.9.4",
    "node:_stream_writable": [">= 14.18 && < 15", ">= 16"],
    stream: true,
    "node:stream": [">= 14.18 && < 15", ">= 16"],
    "stream/consumers": ">= 16.7",
    "node:stream/consumers": ">= 16.7",
    "stream/promises": ">= 15",
    "node:stream/promises": ">= 16",
    "stream/web": ">= 16.5",
    "node:stream/web": ">= 16.5",
    string_decoder: true,
    "node:string_decoder": [">= 14.18 && < 15", ">= 16"],
    sys: [">= 0.4 && < 0.7", ">= 0.8"],
    "node:sys": [">= 14.18 && < 15", ">= 16"],
    "test/reporters": ">= 19.9 && < 20.2",
    "node:test/reporters": [">= 18.17 && < 19", ">= 19.9", ">= 20"],
    "node:test": [">= 16.17 && < 17", ">= 18"],
    timers: true,
    "node:timers": [">= 14.18 && < 15", ">= 16"],
    "timers/promises": ">= 15",
    "node:timers/promises": ">= 16",
    _tls_common: ">= 0.11.13",
    "node:_tls_common": [">= 14.18 && < 15", ">= 16"],
    _tls_legacy: ">= 0.11.3 && < 10",
    _tls_wrap: ">= 0.11.3",
    "node:_tls_wrap": [">= 14.18 && < 15", ">= 16"],
    tls: true,
    "node:tls": [">= 14.18 && < 15", ">= 16"],
    trace_events: ">= 10",
    "node:trace_events": [">= 14.18 && < 15", ">= 16"],
    tty: true,
    "node:tty": [">= 14.18 && < 15", ">= 16"],
    url: true,
    "node:url": [">= 14.18 && < 15", ">= 16"],
    util: true,
    "node:util": [">= 14.18 && < 15", ">= 16"],
    "util/types": ">= 15.3",
    "node:util/types": ">= 16",
    "v8/tools/arguments": ">= 10 && < 12",
    "v8/tools/codemap": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/consarray": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/csvparser": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/logreader": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/profile_view": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    "v8/tools/splaytree": [">= 4.4 && < 5", ">= 5.2 && < 12"],
    v8: ">= 1",
    "node:v8": [">= 14.18 && < 15", ">= 16"],
    vm: true,
    "node:vm": [">= 14.18 && < 15", ">= 16"],
    wasi: [">= 13.4 && < 13.5", ">= 18.17 && < 19", ">= 20"],
    "node:wasi": [">= 18.17 && < 19", ">= 20"],
    worker_threads: ">= 11.7",
    "node:worker_threads": [">= 14.18 && < 15", ">= 16"],
    zlib: ">= 0.5",
    "node:zlib": [">= 14.18 && < 15", ">= 16"]
  };
});
var require_core4 = __commonJS2((exports, module) => {
  var isCoreModule = require_is_core_module();
  var data2 = require_core3();
  var core = {};
  for (mod in data2) {
    if (Object.prototype.hasOwnProperty.call(data2, mod)) {
      core[mod] = isCoreModule(mod);
    }
  }
  var mod;
  module.exports = core;
});
var require_is_core = __commonJS2((exports, module) => {
  var isCoreModule = require_is_core_module();
  module.exports = function isCore(x) {
    return isCoreModule(x);
  };
});
var require_sync = __commonJS2((exports, module) => {
  var isCore = require_is_core_module();
  var fs2 = import.meta.require("fs");
  var path42 = import.meta.require("path");
  var getHomedir = require_homedir();
  var caller = require_caller();
  var nodeModulesPaths = require_node_modules_paths();
  var normalizeOptions = require_normalize_options();
  var realpathFS = process.platform !== "win32" && fs2.realpathSync && typeof fs2.realpathSync.native === "function" ? fs2.realpathSync.native : fs2.realpathSync;
  var homedir2 = getHomedir();
  var defaultPaths = function() {
    return [
      path42.join(homedir2, ".node_modules"),
      path42.join(homedir2, ".node_libraries")
    ];
  };
  var defaultIsFile = function isFile(file) {
    try {
      var stat = fs2.statSync(file, { throwIfNoEntry: false });
    } catch (e) {
      if (e && (e.code === "ENOENT" || e.code === "ENOTDIR"))
        return false;
      throw e;
    }
    return !!stat && (stat.isFile() || stat.isFIFO());
  };
  var defaultIsDir = function isDirectory(dir) {
    try {
      var stat = fs2.statSync(dir, { throwIfNoEntry: false });
    } catch (e) {
      if (e && (e.code === "ENOENT" || e.code === "ENOTDIR"))
        return false;
      throw e;
    }
    return !!stat && stat.isDirectory();
  };
  var defaultRealpathSync = function realpathSync(x) {
    try {
      return realpathFS(x);
    } catch (realpathErr) {
      if (realpathErr.code !== "ENOENT") {
        throw realpathErr;
      }
    }
    return x;
  };
  var maybeRealpathSync = function maybeRealpathSync(realpathSync2, x, opts) {
    if (opts && opts.preserveSymlinks === false) {
      return realpathSync2(x);
    }
    return x;
  };
  var defaultReadPackageSync = function defaultReadPackageSync(readFileSync, pkgfile) {
    var body = readFileSync(pkgfile);
    try {
      var pkg = JSON.parse(body);
      return pkg;
    } catch (jsonErr) {
    }
  };
  var getPackageCandidates = function getPackageCandidates(x, start, opts) {
    var dirs = nodeModulesPaths(start, opts, x);
    for (var i2 = 0;i2 < dirs.length; i2++) {
      dirs[i2] = path42.join(dirs[i2], x);
    }
    return dirs;
  };
  module.exports = function resolveSync(x, options3) {
    if (typeof x !== "string") {
      throw new TypeError("Path must be a string.");
    }
    var opts = normalizeOptions(x, options3);
    var isFile = opts.isFile || defaultIsFile;
    var readFileSync = opts.readFileSync || fs2.readFileSync;
    var isDirectory = opts.isDirectory || defaultIsDir;
    var realpathSync2 = opts.realpathSync || defaultRealpathSync;
    var readPackageSync = opts.readPackageSync || defaultReadPackageSync;
    if (opts.readFileSync && opts.readPackageSync) {
      throw new TypeError("`readFileSync` and `readPackageSync` are mutually exclusive.");
    }
    var packageIterator = opts.packageIterator;
    var extensions = opts.extensions || [".js"];
    var includeCoreModules = opts.includeCoreModules !== false;
    var basedir = opts.basedir || path42.dirname(caller());
    var parent = opts.filename || basedir;
    opts.paths = opts.paths || defaultPaths();
    var absoluteStart = maybeRealpathSync(realpathSync2, path42.resolve(basedir), opts);
    if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x)) {
      var res = path42.resolve(absoluteStart, x);
      if (x === "." || x === ".." || x.slice(-1) === "/")
        res += "/";
      var m22 = loadAsFileSync(res) || loadAsDirectorySync(res);
      if (m22)
        return maybeRealpathSync(realpathSync2, m22, opts);
    } else if (includeCoreModules && isCore(x)) {
      return x;
    } else {
      var n = loadNodeModulesSync(x, absoluteStart);
      if (n)
        return maybeRealpathSync(realpathSync2, n, opts);
    }
    var err22 = new Error("Cannot find module '" + x + "' from '" + parent + "'");
    err22.code = "MODULE_NOT_FOUND";
    throw err22;
    function loadAsFileSync(x2) {
      var pkg = loadpkg(path42.dirname(x2));
      if (pkg && pkg.dir && pkg.pkg && opts.pathFilter) {
        var rfile = path42.relative(pkg.dir, x2);
        var r22 = opts.pathFilter(pkg.pkg, x2, rfile);
        if (r22) {
          x2 = path42.resolve(pkg.dir, r22);
        }
      }
      if (isFile(x2)) {
        return x2;
      }
      for (var i2 = 0;i2 < extensions.length; i2++) {
        var file = x2 + extensions[i2];
        if (isFile(file)) {
          return file;
        }
      }
    }
    function loadpkg(dir) {
      if (dir === "" || dir === "/")
        return;
      if (process.platform === "win32" && /^\w:[/\\]*$/.test(dir)) {
        return;
      }
      if (/[/\\]node_modules[/\\]*$/.test(dir))
        return;
      var pkgfile = path42.join(maybeRealpathSync(realpathSync2, dir, opts), "package.json");
      if (!isFile(pkgfile)) {
        return loadpkg(path42.dirname(dir));
      }
      var pkg = readPackageSync(readFileSync, pkgfile);
      if (pkg && opts.packageFilter) {
        pkg = opts.packageFilter(pkg, dir);
      }
      return { pkg, dir };
    }
    function loadAsDirectorySync(x2) {
      var pkgfile = path42.join(maybeRealpathSync(realpathSync2, x2, opts), "/package.json");
      if (isFile(pkgfile)) {
        try {
          var pkg = readPackageSync(readFileSync, pkgfile);
        } catch (e) {
        }
        if (pkg && opts.packageFilter) {
          pkg = opts.packageFilter(pkg, x2);
        }
        if (pkg && pkg.main) {
          if (typeof pkg.main !== "string") {
            var mainError = new TypeError("package \u201C" + pkg.name + "\u201D `main` must be a string");
            mainError.code = "INVALID_PACKAGE_MAIN";
            throw mainError;
          }
          if (pkg.main === "." || pkg.main === "./") {
            pkg.main = "index";
          }
          try {
            var m3 = loadAsFileSync(path42.resolve(x2, pkg.main));
            if (m3)
              return m3;
            var n2 = loadAsDirectorySync(path42.resolve(x2, pkg.main));
            if (n2)
              return n2;
          } catch (e) {
          }
        }
      }
      return loadAsFileSync(path42.join(x2, "/index"));
    }
    function loadNodeModulesSync(x2, start) {
      var thunk = function() {
        return getPackageCandidates(x2, start, opts);
      };
      var dirs = packageIterator ? packageIterator(x2, start, thunk, opts) : thunk();
      for (var i2 = 0;i2 < dirs.length; i2++) {
        var dir = dirs[i2];
        if (isDirectory(path42.dirname(dir))) {
          var m3 = loadAsFileSync(dir);
          if (m3)
            return m3;
          var n2 = loadAsDirectorySync(dir);
          if (n2)
            return n2;
        }
      }
    }
  };
});
var require_resolve = __commonJS2((exports, module) => {
  var async = require_async();
  async.core = require_core4();
  async.isCore = require_is_core();
  async.sync = require_sync();
  module.exports = async;
});
var init_estree_walker = () => {
};
var require_constants2 = __commonJS2((exports, module) => {
  var WIN_SLASH2 = "\\\\/";
  var WIN_NO_SLASH2 = `[^${WIN_SLASH2}]`;
  var DOT_LITERAL2 = "\\.";
  var PLUS_LITERAL2 = "\\+";
  var QMARK_LITERAL2 = "\\?";
  var SLASH_LITERAL2 = "\\/";
  var ONE_CHAR2 = "(?=.)";
  var QMARK2 = "[^/]";
  var END_ANCHOR2 = `(?:${SLASH_LITERAL2}|$)`;
  var START_ANCHOR2 = `(?:^|${SLASH_LITERAL2})`;
  var DOTS_SLASH2 = `${DOT_LITERAL2}{1,2}${END_ANCHOR2}`;
  var NO_DOT2 = `(?!${DOT_LITERAL2})`;
  var NO_DOTS2 = `(?!${START_ANCHOR2}${DOTS_SLASH2})`;
  var NO_DOT_SLASH2 = `(?!${DOT_LITERAL2}{0,1}${END_ANCHOR2})`;
  var NO_DOTS_SLASH2 = `(?!${DOTS_SLASH2})`;
  var QMARK_NO_DOT2 = `[^.${SLASH_LITERAL2}]`;
  var STAR2 = `${QMARK2}*?`;
  var SEP2 = "/";
  var POSIX_CHARS2 = {
    DOT_LITERAL: DOT_LITERAL2,
    PLUS_LITERAL: PLUS_LITERAL2,
    QMARK_LITERAL: QMARK_LITERAL2,
    SLASH_LITERAL: SLASH_LITERAL2,
    ONE_CHAR: ONE_CHAR2,
    QMARK: QMARK2,
    END_ANCHOR: END_ANCHOR2,
    DOTS_SLASH: DOTS_SLASH2,
    NO_DOT: NO_DOT2,
    NO_DOTS: NO_DOTS2,
    NO_DOT_SLASH: NO_DOT_SLASH2,
    NO_DOTS_SLASH: NO_DOTS_SLASH2,
    QMARK_NO_DOT: QMARK_NO_DOT2,
    STAR: STAR2,
    START_ANCHOR: START_ANCHOR2,
    SEP: SEP2
  };
  var WINDOWS_CHARS2 = {
    ...POSIX_CHARS2,
    SLASH_LITERAL: `[${WIN_SLASH2}]`,
    QMARK: WIN_NO_SLASH2,
    STAR: `${WIN_NO_SLASH2}*?`,
    DOTS_SLASH: `${DOT_LITERAL2}{1,2}(?:[${WIN_SLASH2}]|$)`,
    NO_DOT: `(?!${DOT_LITERAL2})`,
    NO_DOTS: `(?!(?:^|[${WIN_SLASH2}])${DOT_LITERAL2}{1,2}(?:[${WIN_SLASH2}]|$))`,
    NO_DOT_SLASH: `(?!${DOT_LITERAL2}{0,1}(?:[${WIN_SLASH2}]|$))`,
    NO_DOTS_SLASH: `(?!${DOT_LITERAL2}{1,2}(?:[${WIN_SLASH2}]|$))`,
    QMARK_NO_DOT: `[^.${WIN_SLASH2}]`,
    START_ANCHOR: `(?:^|[${WIN_SLASH2}])`,
    END_ANCHOR: `(?:[${WIN_SLASH2}]|$)`,
    SEP: "\\"
  };
  var POSIX_REGEX_SOURCE2 = {
    alnum: "a-zA-Z0-9",
    alpha: "a-zA-Z",
    ascii: "\\x00-\\x7F",
    blank: " \\t",
    cntrl: "\\x00-\\x1F\\x7F",
    digit: "0-9",
    graph: "\\x21-\\x7E",
    lower: "a-z",
    print: "\\x20-\\x7E ",
    punct: '\\-!"#$%&\'()\\*+,./:;<=>?@[\\]^_`{|}~',
    space: " \\t\\r\\n\\v\\f",
    upper: "A-Z",
    word: "A-Za-z0-9_",
    xdigit: "A-Fa-f0-9"
  };
  module.exports = {
    MAX_LENGTH: 65536,
    POSIX_REGEX_SOURCE: POSIX_REGEX_SOURCE2,
    REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
    REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
    REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
    REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
    REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
    REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,
    REPLACEMENTS: {
      "***": "*",
      "**/**": "**",
      "**/**/**": "**"
    },
    CHAR_0: 48,
    CHAR_9: 57,
    CHAR_UPPERCASE_A: 65,
    CHAR_LOWERCASE_A: 97,
    CHAR_UPPERCASE_Z: 90,
    CHAR_LOWERCASE_Z: 122,
    CHAR_LEFT_PARENTHESES: 40,
    CHAR_RIGHT_PARENTHESES: 41,
    CHAR_ASTERISK: 42,
    CHAR_AMPERSAND: 38,
    CHAR_AT: 64,
    CHAR_BACKWARD_SLASH: 92,
    CHAR_CARRIAGE_RETURN: 13,
    CHAR_CIRCUMFLEX_ACCENT: 94,
    CHAR_COLON: 58,
    CHAR_COMMA: 44,
    CHAR_DOT: 46,
    CHAR_DOUBLE_QUOTE: 34,
    CHAR_EQUAL: 61,
    CHAR_EXCLAMATION_MARK: 33,
    CHAR_FORM_FEED: 12,
    CHAR_FORWARD_SLASH: 47,
    CHAR_GRAVE_ACCENT: 96,
    CHAR_HASH: 35,
    CHAR_HYPHEN_MINUS: 45,
    CHAR_LEFT_ANGLE_BRACKET: 60,
    CHAR_LEFT_CURLY_BRACE: 123,
    CHAR_LEFT_SQUARE_BRACKET: 91,
    CHAR_LINE_FEED: 10,
    CHAR_NO_BREAK_SPACE: 160,
    CHAR_PERCENT: 37,
    CHAR_PLUS: 43,
    CHAR_QUESTION_MARK: 63,
    CHAR_RIGHT_ANGLE_BRACKET: 62,
    CHAR_RIGHT_CURLY_BRACE: 125,
    CHAR_RIGHT_SQUARE_BRACKET: 93,
    CHAR_SEMICOLON: 59,
    CHAR_SINGLE_QUOTE: 39,
    CHAR_SPACE: 32,
    CHAR_TAB: 9,
    CHAR_UNDERSCORE: 95,
    CHAR_VERTICAL_LINE: 124,
    CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279,
    extglobChars(chars2) {
      return {
        "!": { type: "negate", open: "(?:(?!(?:", close: `))${chars2.STAR})` },
        "?": { type: "qmark", open: "(?:", close: ")?" },
        "+": { type: "plus", open: "(?:", close: ")+" },
        "*": { type: "star", open: "(?:", close: ")*" },
        "@": { type: "at", open: "(?:", close: ")" }
      };
    },
    globChars(win3222) {
      return win3222 === true ? WINDOWS_CHARS2 : POSIX_CHARS2;
    }
  };
});
var require_utils4 = __commonJS2((exports) => {
  var {
    REGEX_BACKSLASH,
    REGEX_REMOVE_BACKSLASH,
    REGEX_SPECIAL_CHARS,
    REGEX_SPECIAL_CHARS_GLOBAL
  } = require_constants2();
  exports.isObject = (val2) => val2 !== null && typeof val2 === "object" && !Array.isArray(val2);
  exports.hasRegexChars = (str) => REGEX_SPECIAL_CHARS.test(str);
  exports.isRegexChar = (str) => str.length === 1 && exports.hasRegexChars(str);
  exports.escapeRegex = (str) => str.replace(REGEX_SPECIAL_CHARS_GLOBAL, "\\$1");
  exports.toPosixSlashes = (str) => str.replace(REGEX_BACKSLASH, "/");
  exports.isWindows = () => {
    if (typeof navigator !== "undefined" && navigator.platform) {
      const platform32 = navigator.platform.toLowerCase();
      return platform32 === "win32" || platform32 === "windows";
    }
    if (typeof process !== "undefined" && process.platform) {
      return process.platform === "win32";
    }
    return false;
  };
  exports.removeBackslashes = (str) => {
    return str.replace(REGEX_REMOVE_BACKSLASH, (match) => {
      return match === "\\" ? "" : match;
    });
  };
  exports.escapeLast = (input, char, lastIdx) => {
    const idx = input.lastIndexOf(char, lastIdx);
    if (idx === -1)
      return input;
    if (input[idx - 1] === "\\")
      return exports.escapeLast(input, char, idx - 1);
    return `${input.slice(0, idx)}\\${input.slice(idx)}`;
  };
  exports.removePrefix = (input, state = {}) => {
    let output = input;
    if (output.startsWith("./")) {
      output = output.slice(2);
      state.prefix = "./";
    }
    return output;
  };
  exports.wrapOutput = (input, state = {}, options3 = {}) => {
    const prepend = options3.contains ? "" : "^";
    const append = options3.contains ? "" : "$";
    let output = `${prepend}(?:${input})${append}`;
    if (state.negated === true) {
      output = `(?:^(?!${output}).*$)`;
    }
    return output;
  };
  exports.basename = (path42, { windows } = {}) => {
    const segs = path42.split(windows ? /[\\/]/ : "/");
    const last = segs[segs.length - 1];
    if (last === "") {
      return segs[segs.length - 2];
    }
    return last;
  };
});
var require_scan = __commonJS2((exports, module) => {
  var utils6 = require_utils4();
  var {
    CHAR_ASTERISK: CHAR_ASTERISK2,
    CHAR_AT: CHAR_AT2,
    CHAR_BACKWARD_SLASH: CHAR_BACKWARD_SLASH2,
    CHAR_COMMA: CHAR_COMMA2,
    CHAR_DOT: CHAR_DOT2,
    CHAR_EXCLAMATION_MARK: CHAR_EXCLAMATION_MARK2,
    CHAR_FORWARD_SLASH: CHAR_FORWARD_SLASH2,
    CHAR_LEFT_CURLY_BRACE: CHAR_LEFT_CURLY_BRACE2,
    CHAR_LEFT_PARENTHESES: CHAR_LEFT_PARENTHESES2,
    CHAR_LEFT_SQUARE_BRACKET: CHAR_LEFT_SQUARE_BRACKET2,
    CHAR_PLUS: CHAR_PLUS2,
    CHAR_QUESTION_MARK: CHAR_QUESTION_MARK2,
    CHAR_RIGHT_CURLY_BRACE: CHAR_RIGHT_CURLY_BRACE2,
    CHAR_RIGHT_PARENTHESES: CHAR_RIGHT_PARENTHESES2,
    CHAR_RIGHT_SQUARE_BRACKET: CHAR_RIGHT_SQUARE_BRACKET2
  } = require_constants2();
  var isPathSeparator2 = (code) => {
    return code === CHAR_FORWARD_SLASH2 || code === CHAR_BACKWARD_SLASH2;
  };
  var depth2 = (token) => {
    if (token.isPrefix !== true) {
      token.depth = token.isGlobstar ? Infinity : 1;
    }
  };
  var scan2 = (input, options3) => {
    const opts = options3 || {};
    const length = input.length - 1;
    const scanToEnd = opts.parts === true || opts.scanToEnd === true;
    const slashes = [];
    const tokens = [];
    const parts = [];
    let str = input;
    let index = -1;
    let start = 0;
    let lastIndex = 0;
    let isBrace = false;
    let isBracket = false;
    let isGlob = false;
    let isExtglob = false;
    let isGlobstar = false;
    let braceEscaped = false;
    let backslashes = false;
    let negated = false;
    let negatedExtglob = false;
    let finished = false;
    let braces = 0;
    let prev;
    let code;
    let token = { value: "", depth: 0, isGlob: false };
    const eos = () => index >= length;
    const peek = () => str.charCodeAt(index + 1);
    const advance2 = () => {
      prev = code;
      return str.charCodeAt(++index);
    };
    while (index < length) {
      code = advance2();
      let next;
      if (code === CHAR_BACKWARD_SLASH2) {
        backslashes = token.backslashes = true;
        code = advance2();
        if (code === CHAR_LEFT_CURLY_BRACE2) {
          braceEscaped = true;
        }
        continue;
      }
      if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE2) {
        braces++;
        while (eos() !== true && (code = advance2())) {
          if (code === CHAR_BACKWARD_SLASH2) {
            backslashes = token.backslashes = true;
            advance2();
            continue;
          }
          if (code === CHAR_LEFT_CURLY_BRACE2) {
            braces++;
            continue;
          }
          if (braceEscaped !== true && code === CHAR_DOT2 && (code = advance2()) === CHAR_DOT2) {
            isBrace = token.isBrace = true;
            isGlob = token.isGlob = true;
            finished = true;
            if (scanToEnd === true) {
              continue;
            }
            break;
          }
          if (braceEscaped !== true && code === CHAR_COMMA2) {
            isBrace = token.isBrace = true;
            isGlob = token.isGlob = true;
            finished = true;
            if (scanToEnd === true) {
              continue;
            }
            break;
          }
          if (code === CHAR_RIGHT_CURLY_BRACE2) {
            braces--;
            if (braces === 0) {
              braceEscaped = false;
              isBrace = token.isBrace = true;
              finished = true;
              break;
            }
          }
        }
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (code === CHAR_FORWARD_SLASH2) {
        slashes.push(index);
        tokens.push(token);
        token = { value: "", depth: 0, isGlob: false };
        if (finished === true)
          continue;
        if (prev === CHAR_DOT2 && index === start + 1) {
          start += 2;
          continue;
        }
        lastIndex = index + 1;
        continue;
      }
      if (opts.noext !== true) {
        const isExtglobChar = code === CHAR_PLUS2 || code === CHAR_AT2 || code === CHAR_ASTERISK2 || code === CHAR_QUESTION_MARK2 || code === CHAR_EXCLAMATION_MARK2;
        if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES2) {
          isGlob = token.isGlob = true;
          isExtglob = token.isExtglob = true;
          finished = true;
          if (code === CHAR_EXCLAMATION_MARK2 && index === start) {
            negatedExtglob = true;
          }
          if (scanToEnd === true) {
            while (eos() !== true && (code = advance2())) {
              if (code === CHAR_BACKWARD_SLASH2) {
                backslashes = token.backslashes = true;
                code = advance2();
                continue;
              }
              if (code === CHAR_RIGHT_PARENTHESES2) {
                isGlob = token.isGlob = true;
                finished = true;
                break;
              }
            }
            continue;
          }
          break;
        }
      }
      if (code === CHAR_ASTERISK2) {
        if (prev === CHAR_ASTERISK2)
          isGlobstar = token.isGlobstar = true;
        isGlob = token.isGlob = true;
        finished = true;
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (code === CHAR_QUESTION_MARK2) {
        isGlob = token.isGlob = true;
        finished = true;
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (code === CHAR_LEFT_SQUARE_BRACKET2) {
        while (eos() !== true && (next = advance2())) {
          if (next === CHAR_BACKWARD_SLASH2) {
            backslashes = token.backslashes = true;
            advance2();
            continue;
          }
          if (next === CHAR_RIGHT_SQUARE_BRACKET2) {
            isBracket = token.isBracket = true;
            isGlob = token.isGlob = true;
            finished = true;
            break;
          }
        }
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
      if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK2 && index === start) {
        negated = token.negated = true;
        start++;
        continue;
      }
      if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES2) {
        isGlob = token.isGlob = true;
        if (scanToEnd === true) {
          while (eos() !== true && (code = advance2())) {
            if (code === CHAR_LEFT_PARENTHESES2) {
              backslashes = token.backslashes = true;
              code = advance2();
              continue;
            }
            if (code === CHAR_RIGHT_PARENTHESES2) {
              finished = true;
              break;
            }
          }
          continue;
        }
        break;
      }
      if (isGlob === true) {
        finished = true;
        if (scanToEnd === true) {
          continue;
        }
        break;
      }
    }
    if (opts.noext === true) {
      isExtglob = false;
      isGlob = false;
    }
    let base2 = str;
    let prefix = "";
    let glob = "";
    if (start > 0) {
      prefix = str.slice(0, start);
      str = str.slice(start);
      lastIndex -= start;
    }
    if (base2 && isGlob === true && lastIndex > 0) {
      base2 = str.slice(0, lastIndex);
      glob = str.slice(lastIndex);
    } else if (isGlob === true) {
      base2 = "";
      glob = str;
    } else {
      base2 = str;
    }
    if (base2 && base2 !== "" && base2 !== "/" && base2 !== str) {
      if (isPathSeparator2(base2.charCodeAt(base2.length - 1))) {
        base2 = base2.slice(0, -1);
      }
    }
    if (opts.unescape === true) {
      if (glob)
        glob = utils6.removeBackslashes(glob);
      if (base2 && backslashes === true) {
        base2 = utils6.removeBackslashes(base2);
      }
    }
    const state = {
      prefix,
      input,
      start,
      base: base2,
      glob,
      isBrace,
      isBracket,
      isGlob,
      isExtglob,
      isGlobstar,
      negated,
      negatedExtglob
    };
    if (opts.tokens === true) {
      state.maxDepth = 0;
      if (!isPathSeparator2(code)) {
        tokens.push(token);
      }
      state.tokens = tokens;
    }
    if (opts.parts === true || opts.tokens === true) {
      let prevIndex;
      for (let idx = 0;idx < slashes.length; idx++) {
        const n = prevIndex ? prevIndex + 1 : start;
        const i2 = slashes[idx];
        const value = input.slice(n, i2);
        if (opts.tokens) {
          if (idx === 0 && start !== 0) {
            tokens[idx].isPrefix = true;
            tokens[idx].value = prefix;
          } else {
            tokens[idx].value = value;
          }
          depth2(tokens[idx]);
          state.maxDepth += tokens[idx].depth;
        }
        if (idx !== 0 || value !== "") {
          parts.push(value);
        }
        prevIndex = i2;
      }
      if (prevIndex && prevIndex + 1 < input.length) {
        const value = input.slice(prevIndex + 1);
        parts.push(value);
        if (opts.tokens) {
          tokens[tokens.length - 1].value = value;
          depth2(tokens[tokens.length - 1]);
          state.maxDepth += tokens[tokens.length - 1].depth;
        }
      }
      state.slashes = slashes;
      state.parts = parts;
    }
    return state;
  };
  module.exports = scan2;
});
var require_parse2 = __commonJS2((exports, module) => {
  var constants2 = require_constants2();
  var utils6 = require_utils4();
  var {
    MAX_LENGTH: MAX_LENGTH2,
    POSIX_REGEX_SOURCE: POSIX_REGEX_SOURCE2,
    REGEX_NON_SPECIAL_CHARS: REGEX_NON_SPECIAL_CHARS2,
    REGEX_SPECIAL_CHARS_BACKREF: REGEX_SPECIAL_CHARS_BACKREF2,
    REPLACEMENTS: REPLACEMENTS2
  } = constants2;
  var expandRange2 = (args, options3) => {
    if (typeof options3.expandRange === "function") {
      return options3.expandRange(...args, options3);
    }
    args.sort();
    const value = `[${args.join("-")}]`;
    try {
      new RegExp(value);
    } catch (ex) {
      return args.map((v22) => utils6.escapeRegex(v22)).join("..");
    }
    return value;
  };
  var syntaxError2 = (type, char) => {
    return `Missing ${type}: "${char}" - use "\\\\${char}" to match literal characters`;
  };
  var parse5 = (input, options3) => {
    if (typeof input !== "string") {
      throw new TypeError("Expected a string");
    }
    input = REPLACEMENTS2[input] || input;
    const opts = { ...options3 };
    const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH2, opts.maxLength) : MAX_LENGTH2;
    let len = input.length;
    if (len > max) {
      throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
    }
    const bos = { type: "bos", value: "", output: opts.prepend || "" };
    const tokens = [bos];
    const capture = opts.capture ? "" : "?:";
    const PLATFORM_CHARS = constants2.globChars(opts.windows);
    const EXTGLOB_CHARS = constants2.extglobChars(PLATFORM_CHARS);
    const {
      DOT_LITERAL: DOT_LITERAL2,
      PLUS_LITERAL: PLUS_LITERAL2,
      SLASH_LITERAL: SLASH_LITERAL2,
      ONE_CHAR: ONE_CHAR2,
      DOTS_SLASH: DOTS_SLASH2,
      NO_DOT: NO_DOT2,
      NO_DOT_SLASH: NO_DOT_SLASH2,
      NO_DOTS_SLASH: NO_DOTS_SLASH2,
      QMARK: QMARK2,
      QMARK_NO_DOT: QMARK_NO_DOT2,
      STAR: STAR2,
      START_ANCHOR: START_ANCHOR2
    } = PLATFORM_CHARS;
    const globstar = (opts2) => {
      return `(${capture}(?:(?!${START_ANCHOR2}${opts2.dot ? DOTS_SLASH2 : DOT_LITERAL2}).)*?)`;
    };
    const nodot = opts.dot ? "" : NO_DOT2;
    const qmarkNoDot = opts.dot ? QMARK2 : QMARK_NO_DOT2;
    let star = opts.bash === true ? globstar(opts) : STAR2;
    if (opts.capture) {
      star = `(${star})`;
    }
    if (typeof opts.noext === "boolean") {
      opts.noextglob = opts.noext;
    }
    const state = {
      input,
      index: -1,
      start: 0,
      dot: opts.dot === true,
      consumed: "",
      output: "",
      prefix: "",
      backtrack: false,
      negated: false,
      brackets: 0,
      braces: 0,
      parens: 0,
      quotes: 0,
      globstar: false,
      tokens
    };
    input = utils6.removePrefix(input, state);
    len = input.length;
    const extglobs = [];
    const braces = [];
    const stack = [];
    let prev = bos;
    let value;
    const eos = () => state.index === len - 1;
    const peek = state.peek = (n = 1) => input[state.index + n];
    const advance2 = state.advance = () => input[++state.index] || "";
    const remaining = () => input.slice(state.index + 1);
    const consume = (value2 = "", num = 0) => {
      state.consumed += value2;
      state.index += num;
    };
    const append = (token) => {
      state.output += token.output != null ? token.output : token.value;
      consume(token.value);
    };
    const negate = () => {
      let count = 1;
      while (peek() === "!" && (peek(2) !== "(" || peek(3) === "?")) {
        advance2();
        state.start++;
        count++;
      }
      if (count % 2 === 0) {
        return false;
      }
      state.negated = true;
      state.start++;
      return true;
    };
    const increment = (type) => {
      state[type]++;
      stack.push(type);
    };
    const decrement = (type) => {
      state[type]--;
      stack.pop();
    };
    const push2 = (tok) => {
      if (prev.type === "globstar") {
        const isBrace = state.braces > 0 && (tok.type === "comma" || tok.type === "brace");
        const isExtglob = tok.extglob === true || extglobs.length && (tok.type === "pipe" || tok.type === "paren");
        if (tok.type !== "slash" && tok.type !== "paren" && !isBrace && !isExtglob) {
          state.output = state.output.slice(0, -prev.output.length);
          prev.type = "star";
          prev.value = "*";
          prev.output = star;
          state.output += prev.output;
        }
      }
      if (extglobs.length && tok.type !== "paren") {
        extglobs[extglobs.length - 1].inner += tok.value;
      }
      if (tok.value || tok.output)
        append(tok);
      if (prev && prev.type === "text" && tok.type === "text") {
        prev.output = (prev.output || prev.value) + tok.value;
        prev.value += tok.value;
        return;
      }
      tok.prev = prev;
      tokens.push(tok);
      prev = tok;
    };
    const extglobOpen = (type, value2) => {
      const token = { ...EXTGLOB_CHARS[value2], conditions: 1, inner: "" };
      token.prev = prev;
      token.parens = state.parens;
      token.output = state.output;
      const output = (opts.capture ? "(" : "") + token.open;
      increment("parens");
      push2({ type, value: value2, output: state.output ? "" : ONE_CHAR2 });
      push2({ type: "paren", extglob: true, value: advance2(), output });
      extglobs.push(token);
    };
    const extglobClose = (token) => {
      let output = token.close + (opts.capture ? ")" : "");
      let rest;
      if (token.type === "negate") {
        let extglobStar = star;
        if (token.inner && token.inner.length > 1 && token.inner.includes("/")) {
          extglobStar = globstar(opts);
        }
        if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
          output = token.close = `)$))${extglobStar}`;
        }
        if (token.inner.includes("*") && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
          const expression = parse5(rest, { ...options3, fastpaths: false }).output;
          output = token.close = `)${expression})${extglobStar})`;
        }
        if (token.prev.type === "bos") {
          state.negatedExtglob = true;
        }
      }
      push2({ type: "paren", extglob: true, value, output });
      decrement("parens");
    };
    if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
      let backslashes = false;
      let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF2, (m22, esc, chars2, first, rest, index) => {
        if (first === "\\") {
          backslashes = true;
          return m22;
        }
        if (first === "?") {
          if (esc) {
            return esc + first + (rest ? QMARK2.repeat(rest.length) : "");
          }
          if (index === 0) {
            return qmarkNoDot + (rest ? QMARK2.repeat(rest.length) : "");
          }
          return QMARK2.repeat(chars2.length);
        }
        if (first === ".") {
          return DOT_LITERAL2.repeat(chars2.length);
        }
        if (first === "*") {
          if (esc) {
            return esc + first + (rest ? star : "");
          }
          return star;
        }
        return esc ? m22 : `\\${m22}`;
      });
      if (backslashes === true) {
        if (opts.unescape === true) {
          output = output.replace(/\\/g, "");
        } else {
          output = output.replace(/\\+/g, (m22) => {
            return m22.length % 2 === 0 ? "\\\\" : m22 ? "\\" : "";
          });
        }
      }
      if (output === input && opts.contains === true) {
        state.output = input;
        return state;
      }
      state.output = utils6.wrapOutput(output, state, options3);
      return state;
    }
    while (!eos()) {
      value = advance2();
      if (value === "\0") {
        continue;
      }
      if (value === "\\") {
        const next = peek();
        if (next === "/" && opts.bash !== true) {
          continue;
        }
        if (next === "." || next === ";") {
          continue;
        }
        if (!next) {
          value += "\\";
          push2({ type: "text", value });
          continue;
        }
        const match = /^\\+/.exec(remaining());
        let slashes = 0;
        if (match && match[0].length > 2) {
          slashes = match[0].length;
          state.index += slashes;
          if (slashes % 2 !== 0) {
            value += "\\";
          }
        }
        if (opts.unescape === true) {
          value = advance2();
        } else {
          value += advance2();
        }
        if (state.brackets === 0) {
          push2({ type: "text", value });
          continue;
        }
      }
      if (state.brackets > 0 && (value !== "]" || prev.value === "[" || prev.value === "[^")) {
        if (opts.posix !== false && value === ":") {
          const inner = prev.value.slice(1);
          if (inner.includes("[")) {
            prev.posix = true;
            if (inner.includes(":")) {
              const idx = prev.value.lastIndexOf("[");
              const pre = prev.value.slice(0, idx);
              const rest2 = prev.value.slice(idx + 2);
              const posix22 = POSIX_REGEX_SOURCE2[rest2];
              if (posix22) {
                prev.value = pre + posix22;
                state.backtrack = true;
                advance2();
                if (!bos.output && tokens.indexOf(prev) === 1) {
                  bos.output = ONE_CHAR2;
                }
                continue;
              }
            }
          }
        }
        if (value === "[" && peek() !== ":" || value === "-" && peek() === "]") {
          value = `\\${value}`;
        }
        if (value === "]" && (prev.value === "[" || prev.value === "[^")) {
          value = `\\${value}`;
        }
        if (opts.posix === true && value === "!" && prev.value === "[") {
          value = "^";
        }
        prev.value += value;
        append({ value });
        continue;
      }
      if (state.quotes === 1 && value !== '"') {
        value = utils6.escapeRegex(value);
        prev.value += value;
        append({ value });
        continue;
      }
      if (value === '"') {
        state.quotes = state.quotes === 1 ? 0 : 1;
        if (opts.keepQuotes === true) {
          push2({ type: "text", value });
        }
        continue;
      }
      if (value === "(") {
        increment("parens");
        push2({ type: "paren", value });
        continue;
      }
      if (value === ")") {
        if (state.parens === 0 && opts.strictBrackets === true) {
          throw new SyntaxError(syntaxError2("opening", "("));
        }
        const extglob = extglobs[extglobs.length - 1];
        if (extglob && state.parens === extglob.parens + 1) {
          extglobClose(extglobs.pop());
          continue;
        }
        push2({ type: "paren", value, output: state.parens ? ")" : "\\)" });
        decrement("parens");
        continue;
      }
      if (value === "[") {
        if (opts.nobracket === true || !remaining().includes("]")) {
          if (opts.nobracket !== true && opts.strictBrackets === true) {
            throw new SyntaxError(syntaxError2("closing", "]"));
          }
          value = `\\${value}`;
        } else {
          increment("brackets");
        }
        push2({ type: "bracket", value });
        continue;
      }
      if (value === "]") {
        if (opts.nobracket === true || prev && prev.type === "bracket" && prev.value.length === 1) {
          push2({ type: "text", value, output: `\\${value}` });
          continue;
        }
        if (state.brackets === 0) {
          if (opts.strictBrackets === true) {
            throw new SyntaxError(syntaxError2("opening", "["));
          }
          push2({ type: "text", value, output: `\\${value}` });
          continue;
        }
        decrement("brackets");
        const prevValue = prev.value.slice(1);
        if (prev.posix !== true && prevValue[0] === "^" && !prevValue.includes("/")) {
          value = `/${value}`;
        }
        prev.value += value;
        append({ value });
        if (opts.literalBrackets === false || utils6.hasRegexChars(prevValue)) {
          continue;
        }
        const escaped = utils6.escapeRegex(prev.value);
        state.output = state.output.slice(0, -prev.value.length);
        if (opts.literalBrackets === true) {
          state.output += escaped;
          prev.value = escaped;
          continue;
        }
        prev.value = `(${capture}${escaped}|${prev.value})`;
        state.output += prev.value;
        continue;
      }
      if (value === "{" && opts.nobrace !== true) {
        increment("braces");
        const open = {
          type: "brace",
          value,
          output: "(",
          outputIndex: state.output.length,
          tokensIndex: state.tokens.length
        };
        braces.push(open);
        push2(open);
        continue;
      }
      if (value === "}") {
        const brace = braces[braces.length - 1];
        if (opts.nobrace === true || !brace) {
          push2({ type: "text", value, output: value });
          continue;
        }
        let output = ")";
        if (brace.dots === true) {
          const arr = tokens.slice();
          const range = [];
          for (let i2 = arr.length - 1;i2 >= 0; i2--) {
            tokens.pop();
            if (arr[i2].type === "brace") {
              break;
            }
            if (arr[i2].type !== "dots") {
              range.unshift(arr[i2].value);
            }
          }
          output = expandRange2(range, opts);
          state.backtrack = true;
        }
        if (brace.comma !== true && brace.dots !== true) {
          const out = state.output.slice(0, brace.outputIndex);
          const toks = state.tokens.slice(brace.tokensIndex);
          brace.value = brace.output = "\\{";
          value = output = "\\}";
          state.output = out;
          for (const t of toks) {
            state.output += t.output || t.value;
          }
        }
        push2({ type: "brace", value, output });
        decrement("braces");
        braces.pop();
        continue;
      }
      if (value === "|") {
        if (extglobs.length > 0) {
          extglobs[extglobs.length - 1].conditions++;
        }
        push2({ type: "text", value });
        continue;
      }
      if (value === ",") {
        let output = value;
        const brace = braces[braces.length - 1];
        if (brace && stack[stack.length - 1] === "braces") {
          brace.comma = true;
          output = "|";
        }
        push2({ type: "comma", value, output });
        continue;
      }
      if (value === "/") {
        if (prev.type === "dot" && state.index === state.start + 1) {
          state.start = state.index + 1;
          state.consumed = "";
          state.output = "";
          tokens.pop();
          prev = bos;
          continue;
        }
        push2({ type: "slash", value, output: SLASH_LITERAL2 });
        continue;
      }
      if (value === ".") {
        if (state.braces > 0 && prev.type === "dot") {
          if (prev.value === ".")
            prev.output = DOT_LITERAL2;
          const brace = braces[braces.length - 1];
          prev.type = "dots";
          prev.output += value;
          prev.value += value;
          brace.dots = true;
          continue;
        }
        if (state.braces + state.parens === 0 && prev.type !== "bos" && prev.type !== "slash") {
          push2({ type: "text", value, output: DOT_LITERAL2 });
          continue;
        }
        push2({ type: "dot", value, output: DOT_LITERAL2 });
        continue;
      }
      if (value === "?") {
        const isGroup = prev && prev.value === "(";
        if (!isGroup && opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
          extglobOpen("qmark", value);
          continue;
        }
        if (prev && prev.type === "paren") {
          const next = peek();
          let output = value;
          if (prev.value === "(" && !/[!=<:]/.test(next) || next === "<" && !/<([!=]|\w+>)/.test(remaining())) {
            output = `\\${value}`;
          }
          push2({ type: "text", value, output });
          continue;
        }
        if (opts.dot !== true && (prev.type === "slash" || prev.type === "bos")) {
          push2({ type: "qmark", value, output: QMARK_NO_DOT2 });
          continue;
        }
        push2({ type: "qmark", value, output: QMARK2 });
        continue;
      }
      if (value === "!") {
        if (opts.noextglob !== true && peek() === "(") {
          if (peek(2) !== "?" || !/[!=<:]/.test(peek(3))) {
            extglobOpen("negate", value);
            continue;
          }
        }
        if (opts.nonegate !== true && state.index === 0) {
          negate();
          continue;
        }
      }
      if (value === "+") {
        if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
          extglobOpen("plus", value);
          continue;
        }
        if (prev && prev.value === "(" || opts.regex === false) {
          push2({ type: "plus", value, output: PLUS_LITERAL2 });
          continue;
        }
        if (prev && (prev.type === "bracket" || prev.type === "paren" || prev.type === "brace") || state.parens > 0) {
          push2({ type: "plus", value });
          continue;
        }
        push2({ type: "plus", value: PLUS_LITERAL2 });
        continue;
      }
      if (value === "@") {
        if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
          push2({ type: "at", extglob: true, value, output: "" });
          continue;
        }
        push2({ type: "text", value });
        continue;
      }
      if (value !== "*") {
        if (value === "$" || value === "^") {
          value = `\\${value}`;
        }
        const match = REGEX_NON_SPECIAL_CHARS2.exec(remaining());
        if (match) {
          value += match[0];
          state.index += match[0].length;
        }
        push2({ type: "text", value });
        continue;
      }
      if (prev && (prev.type === "globstar" || prev.star === true)) {
        prev.type = "star";
        prev.star = true;
        prev.value += value;
        prev.output = star;
        state.backtrack = true;
        state.globstar = true;
        consume(value);
        continue;
      }
      let rest = remaining();
      if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
        extglobOpen("star", value);
        continue;
      }
      if (prev.type === "star") {
        if (opts.noglobstar === true) {
          consume(value);
          continue;
        }
        const prior = prev.prev;
        const before = prior.prev;
        const isStart = prior.type === "slash" || prior.type === "bos";
        const afterStar = before && (before.type === "star" || before.type === "globstar");
        if (opts.bash === true && (!isStart || rest[0] && rest[0] !== "/")) {
          push2({ type: "star", value, output: "" });
          continue;
        }
        const isBrace = state.braces > 0 && (prior.type === "comma" || prior.type === "brace");
        const isExtglob = extglobs.length && (prior.type === "pipe" || prior.type === "paren");
        if (!isStart && prior.type !== "paren" && !isBrace && !isExtglob) {
          push2({ type: "star", value, output: "" });
          continue;
        }
        while (rest.slice(0, 3) === "/**") {
          const after = input[state.index + 4];
          if (after && after !== "/") {
            break;
          }
          rest = rest.slice(3);
          consume("/**", 3);
        }
        if (prior.type === "bos" && eos()) {
          prev.type = "globstar";
          prev.value += value;
          prev.output = globstar(opts);
          state.output = prev.output;
          state.globstar = true;
          consume(value);
          continue;
        }
        if (prior.type === "slash" && prior.prev.type !== "bos" && !afterStar && eos()) {
          state.output = state.output.slice(0, -(prior.output + prev.output).length);
          prior.output = `(?:${prior.output}`;
          prev.type = "globstar";
          prev.output = globstar(opts) + (opts.strictSlashes ? ")" : "|$)");
          prev.value += value;
          state.globstar = true;
          state.output += prior.output + prev.output;
          consume(value);
          continue;
        }
        if (prior.type === "slash" && prior.prev.type !== "bos" && rest[0] === "/") {
          const end = rest[1] !== undefined ? "|$" : "";
          state.output = state.output.slice(0, -(prior.output + prev.output).length);
          prior.output = `(?:${prior.output}`;
          prev.type = "globstar";
          prev.output = `${globstar(opts)}${SLASH_LITERAL2}|${SLASH_LITERAL2}${end})`;
          prev.value += value;
          state.output += prior.output + prev.output;
          state.globstar = true;
          consume(value + advance2());
          push2({ type: "slash", value: "/", output: "" });
          continue;
        }
        if (prior.type === "bos" && rest[0] === "/") {
          prev.type = "globstar";
          prev.value += value;
          prev.output = `(?:^|${SLASH_LITERAL2}|${globstar(opts)}${SLASH_LITERAL2})`;
          state.output = prev.output;
          state.globstar = true;
          consume(value + advance2());
          push2({ type: "slash", value: "/", output: "" });
          continue;
        }
        state.output = state.output.slice(0, -prev.output.length);
        prev.type = "globstar";
        prev.output = globstar(opts);
        prev.value += value;
        state.output += prev.output;
        state.globstar = true;
        consume(value);
        continue;
      }
      const token = { type: "star", value, output: star };
      if (opts.bash === true) {
        token.output = ".*?";
        if (prev.type === "bos" || prev.type === "slash") {
          token.output = nodot + token.output;
        }
        push2(token);
        continue;
      }
      if (prev && (prev.type === "bracket" || prev.type === "paren") && opts.regex === true) {
        token.output = value;
        push2(token);
        continue;
      }
      if (state.index === state.start || prev.type === "slash" || prev.type === "dot") {
        if (prev.type === "dot") {
          state.output += NO_DOT_SLASH2;
          prev.output += NO_DOT_SLASH2;
        } else if (opts.dot === true) {
          state.output += NO_DOTS_SLASH2;
          prev.output += NO_DOTS_SLASH2;
        } else {
          state.output += nodot;
          prev.output += nodot;
        }
        if (peek() !== "*") {
          state.output += ONE_CHAR2;
          prev.output += ONE_CHAR2;
        }
      }
      push2(token);
    }
    while (state.brackets > 0) {
      if (opts.strictBrackets === true)
        throw new SyntaxError(syntaxError2("closing", "]"));
      state.output = utils6.escapeLast(state.output, "[");
      decrement("brackets");
    }
    while (state.parens > 0) {
      if (opts.strictBrackets === true)
        throw new SyntaxError(syntaxError2("closing", ")"));
      state.output = utils6.escapeLast(state.output, "(");
      decrement("parens");
    }
    while (state.braces > 0) {
      if (opts.strictBrackets === true)
        throw new SyntaxError(syntaxError2("closing", "}"));
      state.output = utils6.escapeLast(state.output, "{");
      decrement("braces");
    }
    if (opts.strictSlashes !== true && (prev.type === "star" || prev.type === "bracket")) {
      push2({ type: "maybe_slash", value: "", output: `${SLASH_LITERAL2}?` });
    }
    if (state.backtrack === true) {
      state.output = "";
      for (const token of state.tokens) {
        state.output += token.output != null ? token.output : token.value;
        if (token.suffix) {
          state.output += token.suffix;
        }
      }
    }
    return state;
  };
  parse5.fastpaths = (input, options3) => {
    const opts = { ...options3 };
    const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH2, opts.maxLength) : MAX_LENGTH2;
    const len = input.length;
    if (len > max) {
      throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
    }
    input = REPLACEMENTS2[input] || input;
    const {
      DOT_LITERAL: DOT_LITERAL2,
      SLASH_LITERAL: SLASH_LITERAL2,
      ONE_CHAR: ONE_CHAR2,
      DOTS_SLASH: DOTS_SLASH2,
      NO_DOT: NO_DOT2,
      NO_DOTS: NO_DOTS2,
      NO_DOTS_SLASH: NO_DOTS_SLASH2,
      STAR: STAR2,
      START_ANCHOR: START_ANCHOR2
    } = constants2.globChars(opts.windows);
    const nodot = opts.dot ? NO_DOTS2 : NO_DOT2;
    const slashDot = opts.dot ? NO_DOTS_SLASH2 : NO_DOT2;
    const capture = opts.capture ? "" : "?:";
    const state = { negated: false, prefix: "" };
    let star = opts.bash === true ? ".*?" : STAR2;
    if (opts.capture) {
      star = `(${star})`;
    }
    const globstar = (opts2) => {
      if (opts2.noglobstar === true)
        return star;
      return `(${capture}(?:(?!${START_ANCHOR2}${opts2.dot ? DOTS_SLASH2 : DOT_LITERAL2}).)*?)`;
    };
    const create = (str) => {
      switch (str) {
        case "*":
          return `${nodot}${ONE_CHAR2}${star}`;
        case ".*":
          return `${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        case "*.*":
          return `${nodot}${star}${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        case "*/*":
          return `${nodot}${star}${SLASH_LITERAL2}${ONE_CHAR2}${slashDot}${star}`;
        case "**":
          return nodot + globstar(opts);
        case "**/*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL2})?${slashDot}${ONE_CHAR2}${star}`;
        case "**/*.*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL2})?${slashDot}${star}${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        case "**/.*":
          return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL2})?${DOT_LITERAL2}${ONE_CHAR2}${star}`;
        default: {
          const match = /^(.*?)\.(\w+)$/.exec(str);
          if (!match)
            return;
          const source2 = create(match[1]);
          if (!source2)
            return;
          return source2 + DOT_LITERAL2 + match[2];
        }
      }
    };
    const output = utils6.removePrefix(input, state);
    let source = create(output);
    if (source && opts.strictSlashes !== true) {
      source += `${SLASH_LITERAL2}?`;
    }
    return source;
  };
  module.exports = parse5;
});
var require_picomatch = __commonJS2((exports, module) => {
  var scan2 = require_scan();
  var parse5 = require_parse2();
  var utils6 = require_utils4();
  var constants2 = require_constants2();
  var isObject4 = (val2) => val2 && typeof val2 === "object" && !Array.isArray(val2);
  var picomatch = (glob, options3, returnState = false) => {
    if (Array.isArray(glob)) {
      const fns = glob.map((input) => picomatch(input, options3, returnState));
      const arrayMatcher = (str) => {
        for (const isMatch of fns) {
          const state2 = isMatch(str);
          if (state2)
            return state2;
        }
        return false;
      };
      return arrayMatcher;
    }
    const isState = isObject4(glob) && glob.tokens && glob.input;
    if (glob === "" || typeof glob !== "string" && !isState) {
      throw new TypeError("Expected pattern to be a non-empty string");
    }
    const opts = options3 || {};
    const posix22 = opts.windows;
    const regex22 = isState ? picomatch.compileRe(glob, options3) : picomatch.makeRe(glob, options3, false, true);
    const state = regex22.state;
    delete regex22.state;
    let isIgnored = () => false;
    if (opts.ignore) {
      const ignoreOpts = { ...options3, ignore: null, onMatch: null, onResult: null };
      isIgnored = picomatch(opts.ignore, ignoreOpts, returnState);
    }
    const matcher = (input, returnObject = false) => {
      const { isMatch, match, output } = picomatch.test(input, regex22, options3, { glob, posix: posix22 });
      const result2 = { glob, state, regex: regex22, posix: posix22, input, output, match, isMatch };
      if (typeof opts.onResult === "function") {
        opts.onResult(result2);
      }
      if (isMatch === false) {
        result2.isMatch = false;
        return returnObject ? result2 : false;
      }
      if (isIgnored(input)) {
        if (typeof opts.onIgnore === "function") {
          opts.onIgnore(result2);
        }
        result2.isMatch = false;
        return returnObject ? result2 : false;
      }
      if (typeof opts.onMatch === "function") {
        opts.onMatch(result2);
      }
      return returnObject ? result2 : true;
    };
    if (returnState) {
      matcher.state = state;
    }
    return matcher;
  };
  picomatch.test = (input, regex22, options3, { glob, posix: posix22 } = {}) => {
    if (typeof input !== "string") {
      throw new TypeError("Expected input to be a string");
    }
    if (input === "") {
      return { isMatch: false, output: "" };
    }
    const opts = options3 || {};
    const format = opts.format || (posix22 ? utils6.toPosixSlashes : null);
    let match = input === glob;
    let output = match && format ? format(input) : input;
    if (match === false) {
      output = format ? format(input) : input;
      match = output === glob;
    }
    if (match === false || opts.capture === true) {
      if (opts.matchBase === true || opts.basename === true) {
        match = picomatch.matchBase(input, regex22, options3, posix22);
      } else {
        match = regex22.exec(output);
      }
    }
    return { isMatch: Boolean(match), match, output };
  };
  picomatch.matchBase = (input, glob, options3) => {
    const regex22 = glob instanceof RegExp ? glob : picomatch.makeRe(glob, options3);
    return regex22.test(utils6.basename(input));
  };
  picomatch.isMatch = (str, patterns, options3) => picomatch(patterns, options3)(str);
  picomatch.parse = (pattern, options3) => {
    if (Array.isArray(pattern))
      return pattern.map((p32) => picomatch.parse(p32, options3));
    return parse5(pattern, { ...options3, fastpaths: false });
  };
  picomatch.scan = (input, options3) => scan2(input, options3);
  picomatch.compileRe = (state, options3, returnOutput = false, returnState = false) => {
    if (returnOutput === true) {
      return state.output;
    }
    const opts = options3 || {};
    const prepend = opts.contains ? "" : "^";
    const append = opts.contains ? "" : "$";
    let source = `${prepend}(?:${state.output})${append}`;
    if (state && state.negated === true) {
      source = `^(?!${source}).*$`;
    }
    const regex22 = picomatch.toRegex(source, options3);
    if (returnState === true) {
      regex22.state = state;
    }
    return regex22;
  };
  picomatch.makeRe = (input, options3 = {}, returnOutput = false, returnState = false) => {
    if (!input || typeof input !== "string") {
      throw new TypeError("Expected a non-empty string");
    }
    let parsed = { negated: false, fastpaths: true };
    if (options3.fastpaths !== false && (input[0] === "." || input[0] === "*")) {
      parsed.output = parse5.fastpaths(input, options3);
    }
    if (!parsed.output) {
      parsed = parse5(input, options3);
    }
    return picomatch.compileRe(parsed, options3, returnOutput, returnState);
  };
  picomatch.toRegex = (source, options3) => {
    try {
      const opts = options3 || {};
      return new RegExp(source, opts.flags || (opts.nocase ? "i" : ""));
    } catch (err22) {
      if (options3 && options3.debug === true)
        throw err22;
      return /$^/;
    }
  };
  picomatch.constants = constants2;
  module.exports = picomatch;
});
var require_picomatch2 = __commonJS2((exports, module) => {
  var pico = require_picomatch();
  var utils6 = require_utils4();
  function picomatch(glob, options3, returnState = false) {
    if (options3 && (options3.windows === null || options3.windows === undefined)) {
      options3 = { ...options3, windows: utils6.isWindows() };
    }
    return pico(glob, options3, returnState);
  }
  Object.assign(picomatch, pico);
  module.exports = picomatch;
});
var normalizePathRegExp;
var reservedWords2 = "break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public";
var builtins2 = "arguments Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl";
var forbiddenIdentifiers2;
var hasStringIsWellFormed;
var init_es = __esm2(() => {
  init_estree_walker();
  normalizePathRegExp = new RegExp(`\\${win322.sep}`, "g");
  forbiddenIdentifiers2 = new Set(`${reservedWords2} ${builtins2}`.split(" "));
  forbiddenIdentifiers2.add("");
  hasStringIsWellFormed = "isWellFormed" in String.prototype;
});
var import_deepmerge;
var import_is_module;
var import_resolve;
var readFile$1;
var realpath;
var stat;
var onError = (error) => {
  if (error.code === "ENOENT") {
    return false;
  }
  throw error;
};
var makeCache = (fn) => {
  const cache3 = new Map;
  const wrapped = async (param, done) => {
    if (cache3.has(param) === false) {
      cache3.set(param, fn(param).catch((err22) => {
        cache3.delete(param);
        throw err22;
      }));
    }
    try {
      const result2 = cache3.get(param);
      const value = await result2;
      return done(null, value);
    } catch (error) {
      return done(error);
    }
  };
  wrapped.clear = () => cache3.clear();
  return wrapped;
};
var isDirCached;
var isFileCached;
var readCachedFile;
var resolveImportPath;
var readFile;
var deepFreeze = (object) => {
  Object.freeze(object);
  for (const value of Object.values(object)) {
    if (typeof value === "object" && !Object.isFrozen(value)) {
      deepFreeze(value);
    }
  }
  return object;
};
var baseConditions;
var baseConditionsEsm;
var baseConditionsCjs;
var defaults;
var DEFAULTS;
var init_es2 = __esm2(() => {
  import_deepmerge = __toESM3(require_cjs(), 1);
  import_is_module = __toESM3(require_is_module(), 1);
  import_resolve = __toESM3(require_resolve(), 1);
  init_es();
  promisify(fs.access);
  readFile$1 = promisify(fs.readFile);
  realpath = promisify(fs.realpath);
  stat = promisify(fs.stat);
  isDirCached = makeCache(async (file) => {
    try {
      const stats = await stat(file);
      return stats.isDirectory();
    } catch (error) {
      return onError(error);
    }
  });
  isFileCached = makeCache(async (file) => {
    try {
      const stats = await stat(file);
      return stats.isFile();
    } catch (error) {
      return onError(error);
    }
  });
  readCachedFile = makeCache(readFile$1);
  resolveImportPath = promisify(import_resolve.default);
  readFile = promisify(fs.readFile);
  baseConditions = ["default", "module"];
  baseConditionsEsm = [...baseConditions, "import"];
  baseConditionsCjs = [...baseConditions, "require"];
  defaults = {
    dedupe: [],
    extensions: [".mjs", ".js", ".json", ".node"],
    resolveOnly: [],
    moduleDirectories: ["node_modules"],
    modulePaths: [],
    ignoreSideEffectsForRoot: false,
    allowExportsFolderMapping: true
  };
  DEFAULTS = deepFreeze(import_deepmerge.default({}, defaults));
});
function characters(str) {
  return str.split("");
}
function member(name, array) {
  return array.includes(name);
}
function defaults2(args, defs, croak) {
  if (args === true) {
    args = {};
  } else if (args != null && typeof args === "object") {
    args = { ...args };
  }
  const ret = args || {};
  if (croak) {
    for (const i2 in ret)
      if (HOP(ret, i2) && !HOP(defs, i2)) {
        throw new DefaultsError("`" + i2 + "` is not a supported option", defs);
      }
  }
  for (const i2 in defs)
    if (HOP(defs, i2)) {
      if (!args || !HOP(args, i2)) {
        ret[i2] = defs[i2];
      } else if (i2 === "ecma") {
        let ecma = args[i2] | 0;
        if (ecma > 5 && ecma < 2015)
          ecma += 2009;
        ret[i2] = ecma;
      } else {
        ret[i2] = args && HOP(args, i2) ? args[i2] : defs[i2];
      }
    }
  return ret;
}
function noop() {
}
function return_false() {
  return false;
}
function return_true() {
  return true;
}
function return_this() {
  return this;
}
function return_null() {
  return null;
}
function make_node(ctor, orig, props) {
  if (!props)
    props = {};
  if (orig) {
    if (!props.start)
      props.start = orig.start;
    if (!props.end)
      props.end = orig.end;
  }
  return new ctor(props);
}
function push_uniq(array, el) {
  if (!array.includes(el))
    array.push(el);
}
function string_template(text22, props) {
  return text22.replace(/{(.+?)}/g, function(str, p32) {
    return props && props[p32];
  });
}
function remove(array, el) {
  for (var i2 = array.length;--i2 >= 0; ) {
    if (array[i2] === el)
      array.splice(i2, 1);
  }
}
function mergeSort(array, cmp) {
  if (array.length < 2)
    return array.slice();
  function merge(a, b22) {
    var r22 = [], ai3 = 0, bi = 0, i2 = 0;
    while (ai3 < a.length && bi < b22.length) {
      cmp(a[ai3], b22[bi]) <= 0 ? r22[i2++] = a[ai3++] : r22[i2++] = b22[bi++];
    }
    if (ai3 < a.length)
      r22.push.apply(r22, a.slice(ai3));
    if (bi < b22.length)
      r22.push.apply(r22, b22.slice(bi));
    return r22;
  }
  function _ms(a) {
    if (a.length <= 1)
      return a;
    var m22 = Math.floor(a.length / 2), left = a.slice(0, m22), right = a.slice(m22);
    left = _ms(left);
    right = _ms(right);
    return merge(left, right);
  }
  return _ms(array);
}
function makePredicate(words) {
  if (!Array.isArray(words))
    words = words.split(" ");
  return new Set(words.sort());
}
function map_add(map, key, value) {
  if (map.has(key)) {
    map.get(key).push(value);
  } else {
    map.set(key, [value]);
  }
}
function HOP(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}
function keep_name(keep_setting, name) {
  return keep_setting === true || keep_setting instanceof RegExp && keep_setting.test(name);
}
function regexp_source_fix(source) {
  return source.replace(/[\0\n\r\u2028\u2029]/g, function(match, offset2) {
    var escaped = source[offset2 - 1] == "\\" && (source[offset2 - 2] != "\\" || /(?:^|[^\\])(?:\\{2})*$/.test(source.slice(0, offset2 - 1)));
    return (escaped ? "" : "\\") + lineTerminatorEscape[match];
  });
}
function sort_regexp_flags(flags) {
  const existing_flags = new Set(flags.split(""));
  let out = "";
  for (const flag of all_flags) {
    if (existing_flags.has(flag)) {
      out += flag;
      existing_flags.delete(flag);
    }
  }
  if (existing_flags.size) {
    existing_flags.forEach((flag) => {
      out += flag;
    });
  }
  return out;
}
function has_annotation(node, annotation) {
  return node._annotations & annotation;
}
function set_annotation(node, annotation) {
  node._annotations |= annotation;
}
var DefaultsError;
var MAP;
var lineTerminatorEscape;
var re_safe_regexp;
var regexp_is_safe = (source) => re_safe_regexp.test(source);
var all_flags = "dgimsuyv";
var init_utils5 = __esm2(() => {
  init_ast();
  DefaultsError = class DefaultsError2 extends Error {
    constructor(msg, defs) {
      super();
      this.name = "DefaultsError";
      this.message = msg;
      this.defs = defs;
    }
  };
  MAP = function() {
    function MAP2(a, tw, allow_splicing = true) {
      const new_a = [];
      for (let i2 = 0;i2 < a.length; ++i2) {
        let item = a[i2];
        let ret = item.transform(tw, allow_splicing);
        if (ret instanceof AST_Node) {
          new_a.push(ret);
        } else if (ret instanceof Splice) {
          new_a.push(...ret.v);
        }
      }
      return new_a;
    }
    MAP2.splice = function(val2) {
      return new Splice(val2);
    };
    MAP2.skip = {};
    function Splice(val2) {
      this.v = val2;
    }
    return MAP2;
  }();
  lineTerminatorEscape = {
    "\0": "0",
    "\n": "n",
    "\r": "r",
    "\u2028": "u2028",
    "\u2029": "u2029"
  };
  re_safe_regexp = /^[\\/|\0\s\w^$.[\]()]*$/;
});
function get_full_char(str, pos) {
  if (is_surrogate_pair_head(str.charCodeAt(pos))) {
    if (is_surrogate_pair_tail(str.charCodeAt(pos + 1))) {
      return str.charAt(pos) + str.charAt(pos + 1);
    }
  } else if (is_surrogate_pair_tail(str.charCodeAt(pos))) {
    if (is_surrogate_pair_head(str.charCodeAt(pos - 1))) {
      return str.charAt(pos - 1) + str.charAt(pos);
    }
  }
  return str.charAt(pos);
}
function get_full_char_code(str, pos) {
  if (is_surrogate_pair_head(str.charCodeAt(pos))) {
    return 65536 + (str.charCodeAt(pos) - 55296 << 10) + str.charCodeAt(pos + 1) - 56320;
  }
  return str.charCodeAt(pos);
}
function get_full_char_length(str) {
  var surrogates = 0;
  for (var i2 = 0;i2 < str.length; i2++) {
    if (is_surrogate_pair_head(str.charCodeAt(i2)) && is_surrogate_pair_tail(str.charCodeAt(i2 + 1))) {
      surrogates++;
      i2++;
    }
  }
  return str.length - surrogates;
}
function from_char_code(code) {
  if (code > 65535) {
    code -= 65536;
    return String.fromCharCode((code >> 10) + 55296) + String.fromCharCode(code % 1024 + 56320);
  }
  return String.fromCharCode(code);
}
function is_surrogate_pair_head(code) {
  return code >= 55296 && code <= 56319;
}
function is_surrogate_pair_tail(code) {
  return code >= 56320 && code <= 57343;
}
function is_digit(code) {
  return code >= 48 && code <= 57;
}
function is_identifier_start(ch) {
  return UNICODE.ID_Start.test(ch);
}
function is_identifier_char(ch) {
  return UNICODE.ID_Continue.test(ch);
}
function is_basic_identifier_string(str) {
  return BASIC_IDENT.test(str);
}
function is_identifier_string(str, allow_surrogates) {
  if (BASIC_IDENT.test(str)) {
    return true;
  }
  if (!allow_surrogates && /[\ud800-\udfff]/.test(str)) {
    return false;
  }
  var match = UNICODE.ID_Start.exec(str);
  if (!match || match.index !== 0) {
    return false;
  }
  str = str.slice(match[0].length);
  if (!str) {
    return true;
  }
  match = UNICODE.ID_Continue.exec(str);
  return !!match && match[0].length === str.length;
}
function parse_js_number(num, allow_e = true) {
  if (!allow_e && num.includes("e")) {
    return NaN;
  }
  if (RE_HEX_NUMBER.test(num)) {
    return parseInt(num.substr(2), 16);
  } else if (RE_OCT_NUMBER.test(num)) {
    return parseInt(num.substr(1), 8);
  } else if (RE_ES6_OCT_NUMBER.test(num)) {
    return parseInt(num.substr(2), 8);
  } else if (RE_BIN_NUMBER.test(num)) {
    return parseInt(num.substr(2), 2);
  } else if (RE_DEC_NUMBER.test(num)) {
    return parseFloat(num);
  } else {
    var val2 = parseFloat(num);
    if (val2 == num)
      return val2;
  }
}
function js_error(message, filename2, line, col, pos) {
  throw new JS_Parse_Error(message, filename2, line, col, pos);
}
function is_token(token, type, val2) {
  return token.type == type && (val2 == null || token.value == val2);
}
function tokenizer2($TEXT, filename2, html5_comments, shebang) {
  var S = {
    text: $TEXT,
    filename: filename2,
    pos: 0,
    tokpos: 0,
    line: 1,
    tokline: 0,
    col: 0,
    tokcol: 0,
    newline_before: false,
    regex_allowed: false,
    brace_counter: 0,
    template_braces: [],
    comments_before: [],
    directives: {},
    directive_stack: []
  };
  function peek() {
    return get_full_char(S.text, S.pos);
  }
  function is_option_chain_op() {
    const must_be_dot = S.text.charCodeAt(S.pos + 1) === 46;
    if (!must_be_dot)
      return false;
    const cannot_be_digit = S.text.charCodeAt(S.pos + 2);
    return cannot_be_digit < 48 || cannot_be_digit > 57;
  }
  function next(signal_eof, in_string) {
    var ch = get_full_char(S.text, S.pos++);
    if (signal_eof && !ch)
      throw EX_EOF;
    if (NEWLINE_CHARS.has(ch)) {
      S.newline_before = S.newline_before || !in_string;
      ++S.line;
      S.col = 0;
      if (ch == "\r" && peek() == "\n") {
        ++S.pos;
        ch = "\n";
      }
    } else {
      if (ch.length > 1) {
        ++S.pos;
        ++S.col;
      }
      ++S.col;
    }
    return ch;
  }
  function forward(i2) {
    while (i2--)
      next();
  }
  function looking_at(str) {
    return S.text.substr(S.pos, str.length) == str;
  }
  function find_eol() {
    var text22 = S.text;
    for (var i2 = S.pos, n = S.text.length;i2 < n; ++i2) {
      var ch = text22[i2];
      if (NEWLINE_CHARS.has(ch))
        return i2;
    }
    return -1;
  }
  function find(what, signal_eof) {
    var pos = S.text.indexOf(what, S.pos);
    if (signal_eof && pos == -1)
      throw EX_EOF;
    return pos;
  }
  function start_token() {
    S.tokline = S.line;
    S.tokcol = S.col;
    S.tokpos = S.pos;
  }
  var prev_was_dot = false;
  var previous_token = null;
  function token(type, value, is_comment) {
    S.regex_allowed = type == "operator" && !UNARY_POSTFIX.has(value) || type == "keyword" && KEYWORDS_BEFORE_EXPRESSION.has(value) || type == "punc" && PUNC_BEFORE_EXPRESSION.has(value) || type == "arrow";
    if (type == "punc" && (value == "." || value == "?.")) {
      prev_was_dot = true;
    } else if (!is_comment) {
      prev_was_dot = false;
    }
    const line = S.tokline;
    const col = S.tokcol;
    const pos = S.tokpos;
    const nlb = S.newline_before;
    const file = filename2;
    let comments_before = [];
    let comments_after = [];
    if (!is_comment) {
      comments_before = S.comments_before;
      comments_after = S.comments_before = [];
    }
    S.newline_before = false;
    const tok = new AST_Token(type, value, line, col, pos, nlb, comments_before, comments_after, file);
    if (!is_comment)
      previous_token = tok;
    return tok;
  }
  function skip_whitespace() {
    while (WHITESPACE_CHARS.has(peek()))
      next();
  }
  function read_while(pred) {
    var ret = "", ch, i2 = 0;
    while ((ch = peek()) && pred(ch, i2++))
      ret += next();
    return ret;
  }
  function parse_error(err22) {
    js_error(err22, filename2, S.tokline, S.tokcol, S.tokpos);
  }
  function read_num(prefix) {
    var has_e = false, after_e = false, has_x = false, has_dot = prefix == ".", is_big_int = false, numeric_separator = false;
    var num = read_while(function(ch, i2) {
      if (is_big_int)
        return false;
      var code = ch.charCodeAt(0);
      switch (code) {
        case 95:
          return numeric_separator = true;
        case 98:
        case 66:
          return has_x = true;
        case 111:
        case 79:
        case 120:
        case 88:
          return has_x ? false : has_x = true;
        case 101:
        case 69:
          return has_x ? true : has_e ? false : has_e = after_e = true;
        case 45:
          return after_e || i2 == 0 && !prefix;
        case 43:
          return after_e;
        case (after_e = false, 46):
          return !has_dot && !has_x && !has_e ? has_dot = true : false;
      }
      if (ch === "n") {
        is_big_int = true;
        return true;
      }
      return RE_NUM_LITERAL.test(ch);
    });
    if (prefix)
      num = prefix + num;
    LATEST_RAW = num;
    if (RE_OCT_NUMBER.test(num) && next_token.has_directive("use strict")) {
      parse_error("Legacy octal literals are not allowed in strict mode");
    }
    if (numeric_separator) {
      if (num.endsWith("_")) {
        parse_error("Numeric separators are not allowed at the end of numeric literals");
      } else if (num.includes("__")) {
        parse_error("Only one underscore is allowed as numeric separator");
      }
      num = num.replace(/_/g, "");
    }
    if (num.endsWith("n")) {
      const without_n = num.slice(0, -1);
      const allow_e = RE_HEX_NUMBER.test(without_n);
      const valid2 = parse_js_number(without_n, allow_e);
      if (!has_dot && RE_BIG_INT.test(num) && !isNaN(valid2))
        return token("big_int", without_n);
      parse_error("Invalid or unexpected token");
    }
    var valid = parse_js_number(num);
    if (!isNaN(valid)) {
      return token("num", valid);
    } else {
      parse_error("Invalid syntax: " + num);
    }
  }
  function is_octal(ch) {
    return ch >= "0" && ch <= "7";
  }
  function read_escaped_char(in_string, strict_hex, template_string) {
    var ch = next(true, in_string);
    switch (ch.charCodeAt(0)) {
      case 110:
        return "\n";
      case 114:
        return "\r";
      case 116:
        return "\t";
      case 98:
        return "\b";
      case 118:
        return "\v";
      case 102:
        return "\f";
      case 120:
        return String.fromCharCode(hex_bytes(2, strict_hex));
      case 117:
        if (peek() == "{") {
          next(true);
          if (peek() === "}")
            parse_error("Expecting hex-character between {}");
          while (peek() == "0")
            next(true);
          var result2, length = find("}", true) - S.pos;
          if (length > 6 || (result2 = hex_bytes(length, strict_hex)) > 1114111) {
            parse_error("Unicode reference out of bounds");
          }
          next(true);
          return from_char_code(result2);
        }
        return String.fromCharCode(hex_bytes(4, strict_hex));
      case 10:
        return "";
      case 13:
        if (peek() == "\n") {
          next(true, in_string);
          return "";
        }
    }
    if (is_octal(ch)) {
      if (template_string && strict_hex) {
        const represents_null_character = ch === "0" && !is_octal(peek());
        if (!represents_null_character) {
          parse_error("Octal escape sequences are not allowed in template strings");
        }
      }
      return read_octal_escape_sequence(ch, strict_hex);
    }
    return ch;
  }
  function read_octal_escape_sequence(ch, strict_octal) {
    var p32 = peek();
    if (p32 >= "0" && p32 <= "7") {
      ch += next(true);
      if (ch[0] <= "3" && (p32 = peek()) >= "0" && p32 <= "7")
        ch += next(true);
    }
    if (ch === "0")
      return "\0";
    if (ch.length > 0 && next_token.has_directive("use strict") && strict_octal)
      parse_error("Legacy octal escape sequences are not allowed in strict mode");
    return String.fromCharCode(parseInt(ch, 8));
  }
  function hex_bytes(n, strict_hex) {
    var num = 0;
    for (;n > 0; --n) {
      if (!strict_hex && isNaN(parseInt(peek(), 16))) {
        return parseInt(num, 16) || "";
      }
      var digit = next(true);
      if (isNaN(parseInt(digit, 16)))
        parse_error("Invalid hex-character pattern in string");
      num += digit;
    }
    return parseInt(num, 16);
  }
  var read_string = with_eof_error("Unterminated string constant", function() {
    const start_pos = S.pos;
    var quote = next(), ret = [];
    for (;; ) {
      var ch = next(true, true);
      if (ch == "\\")
        ch = read_escaped_char(true, true);
      else if (ch == "\r" || ch == "\n")
        parse_error("Unterminated string constant");
      else if (ch == quote)
        break;
      ret.push(ch);
    }
    var tok = token("string", ret.join(""));
    LATEST_RAW = S.text.slice(start_pos, S.pos);
    tok.quote = quote;
    return tok;
  });
  var read_template_characters = with_eof_error("Unterminated template", function(begin) {
    if (begin) {
      S.template_braces.push(S.brace_counter);
    }
    var content = "", raw = "", ch, tok;
    next(true, true);
    while ((ch = next(true, true)) != "`") {
      if (ch == "\r") {
        if (peek() == "\n")
          ++S.pos;
        ch = "\n";
      } else if (ch == "$" && peek() == "{") {
        next(true, true);
        S.brace_counter++;
        tok = token(begin ? "template_head" : "template_substitution", content);
        TEMPLATE_RAWS.set(tok, raw);
        tok.template_end = false;
        return tok;
      }
      raw += ch;
      if (ch == "\\") {
        var tmp = S.pos;
        var prev_is_tag = previous_token && (previous_token.type === "name" || previous_token.type === "punc" && (previous_token.value === ")" || previous_token.value === "]"));
        ch = read_escaped_char(true, !prev_is_tag, true);
        raw += S.text.substr(tmp, S.pos - tmp);
      }
      content += ch;
    }
    S.template_braces.pop();
    tok = token(begin ? "template_head" : "template_substitution", content);
    TEMPLATE_RAWS.set(tok, raw);
    tok.template_end = true;
    return tok;
  });
  function skip_line_comment(type) {
    var regex_allowed = S.regex_allowed;
    var i2 = find_eol(), ret;
    if (i2 == -1) {
      ret = S.text.substr(S.pos);
      S.pos = S.text.length;
    } else {
      ret = S.text.substring(S.pos, i2);
      S.pos = i2;
    }
    S.col = S.tokcol + (S.pos - S.tokpos);
    S.comments_before.push(token(type, ret, true));
    S.regex_allowed = regex_allowed;
    return next_token;
  }
  var skip_multiline_comment = with_eof_error("Unterminated multiline comment", function() {
    var regex_allowed = S.regex_allowed;
    var i2 = find("*/", true);
    var text22 = S.text.substring(S.pos, i2).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
    forward(get_full_char_length(text22) + 2);
    S.comments_before.push(token("comment2", text22, true));
    S.newline_before = S.newline_before || text22.includes("\n");
    S.regex_allowed = regex_allowed;
    return next_token;
  });
  var read_name = with_eof_error("Unterminated identifier name", function() {
    var name = [], ch, escaped = false;
    var read_escaped_identifier_char = function() {
      escaped = true;
      next();
      if (peek() !== "u") {
        parse_error("Expecting UnicodeEscapeSequence -- uXXXX or u{XXXX}");
      }
      return read_escaped_char(false, true);
    };
    if ((ch = peek()) === "\\") {
      ch = read_escaped_identifier_char();
      if (!is_identifier_start(ch)) {
        parse_error("First identifier char is an invalid identifier char");
      }
    } else if (is_identifier_start(ch)) {
      next();
    } else {
      return "";
    }
    name.push(ch);
    while ((ch = peek()) != null) {
      if ((ch = peek()) === "\\") {
        ch = read_escaped_identifier_char();
        if (!is_identifier_char(ch)) {
          parse_error("Invalid escaped identifier char");
        }
      } else {
        if (!is_identifier_char(ch)) {
          break;
        }
        next();
      }
      name.push(ch);
    }
    const name_str = name.join("");
    if (RESERVED_WORDS.has(name_str) && escaped) {
      parse_error("Escaped characters are not allowed in keywords");
    }
    return name_str;
  });
  var read_regexp = with_eof_error("Unterminated regular expression", function(source) {
    var prev_backslash = false, ch, in_class = false;
    while (ch = next(true))
      if (NEWLINE_CHARS.has(ch)) {
        parse_error("Unexpected line terminator");
      } else if (prev_backslash) {
        if (/^[\u0000-\u007F]$/.test(ch)) {
          source += "\\" + ch;
        } else {
          source += ch;
        }
        prev_backslash = false;
      } else if (ch == "[") {
        in_class = true;
        source += ch;
      } else if (ch == "]" && in_class) {
        in_class = false;
        source += ch;
      } else if (ch == "/" && !in_class) {
        break;
      } else if (ch == "\\") {
        prev_backslash = true;
      } else {
        source += ch;
      }
    const flags = read_name();
    return token("regexp", "/" + source + "/" + flags);
  });
  function read_operator(prefix) {
    function grow(op) {
      if (!peek())
        return op;
      var bigger = op + peek();
      if (OPERATORS.has(bigger)) {
        next();
        return grow(bigger);
      } else {
        return op;
      }
    }
    return token("operator", grow(prefix || next()));
  }
  function handle_slash() {
    next();
    switch (peek()) {
      case "/":
        next();
        return skip_line_comment("comment1");
      case "*":
        next();
        return skip_multiline_comment();
    }
    return S.regex_allowed ? read_regexp("") : read_operator("/");
  }
  function handle_eq_sign() {
    next();
    if (peek() === ">") {
      next();
      return token("arrow", "=>");
    } else {
      return read_operator("=");
    }
  }
  function handle_dot() {
    next();
    if (is_digit(peek().charCodeAt(0))) {
      return read_num(".");
    }
    if (peek() === ".") {
      next();
      next();
      return token("expand", "...");
    }
    return token("punc", ".");
  }
  function read_word() {
    var word = read_name();
    if (prev_was_dot)
      return token("name", word);
    return KEYWORDS_ATOM.has(word) ? token("atom", word) : !KEYWORDS.has(word) ? token("name", word) : OPERATORS.has(word) ? token("operator", word) : token("keyword", word);
  }
  function read_private_word() {
    next();
    return token("privatename", read_name());
  }
  function with_eof_error(eof_error, cont) {
    return function(x) {
      try {
        return cont(x);
      } catch (ex) {
        if (ex === EX_EOF)
          parse_error(eof_error);
        else
          throw ex;
      }
    };
  }
  function next_token(force_regexp) {
    if (force_regexp != null)
      return read_regexp(force_regexp);
    if (shebang && S.pos == 0 && looking_at("#!")) {
      start_token();
      forward(2);
      skip_line_comment("comment5");
    }
    for (;; ) {
      skip_whitespace();
      start_token();
      if (html5_comments) {
        if (looking_at("<!--")) {
          forward(4);
          skip_line_comment("comment3");
          continue;
        }
        if (looking_at("-->") && S.newline_before) {
          forward(3);
          skip_line_comment("comment4");
          continue;
        }
      }
      var ch = peek();
      if (!ch)
        return token("eof");
      var code = ch.charCodeAt(0);
      switch (code) {
        case 34:
        case 39:
          return read_string();
        case 46:
          return handle_dot();
        case 47: {
          var tok = handle_slash();
          if (tok === next_token)
            continue;
          return tok;
        }
        case 61:
          return handle_eq_sign();
        case 63: {
          if (!is_option_chain_op())
            break;
          next();
          next();
          return token("punc", "?.");
        }
        case 96:
          return read_template_characters(true);
        case 123:
          S.brace_counter++;
          break;
        case 125:
          S.brace_counter--;
          if (S.template_braces.length > 0 && S.template_braces[S.template_braces.length - 1] === S.brace_counter)
            return read_template_characters(false);
          break;
      }
      if (is_digit(code))
        return read_num();
      if (PUNC_CHARS.has(ch))
        return token("punc", next());
      if (OPERATOR_CHARS.has(ch))
        return read_operator();
      if (code == 92 || is_identifier_start(ch))
        return read_word();
      if (code == 35)
        return read_private_word();
      break;
    }
    parse_error("Unexpected character '" + ch + "'");
  }
  next_token.next = next;
  next_token.peek = peek;
  next_token.context = function(nc) {
    if (nc)
      S = nc;
    return S;
  };
  next_token.add_directive = function(directive) {
    S.directive_stack[S.directive_stack.length - 1].push(directive);
    if (S.directives[directive] === undefined) {
      S.directives[directive] = 1;
    } else {
      S.directives[directive]++;
    }
  };
  next_token.push_directives_stack = function() {
    S.directive_stack.push([]);
  };
  next_token.pop_directives_stack = function() {
    var directives = S.directive_stack[S.directive_stack.length - 1];
    for (var i2 = 0;i2 < directives.length; i2++) {
      S.directives[directives[i2]]--;
    }
    S.directive_stack.pop();
  };
  next_token.has_directive = function(directive) {
    return S.directives[directive] > 0;
  };
  return next_token;
}
function parse5($TEXT, options3) {
  const outer_comments_before_counts = new WeakMap;
  options3 = defaults2(options3, {
    bare_returns: false,
    ecma: null,
    expression: false,
    filename: null,
    html5_comments: true,
    module: false,
    shebang: true,
    strict: false,
    toplevel: null
  }, true);
  var S = {
    input: typeof $TEXT == "string" ? tokenizer2($TEXT, options3.filename, options3.html5_comments, options3.shebang) : $TEXT,
    token: null,
    prev: null,
    peeked: null,
    in_function: 0,
    in_async: -1,
    in_generator: -1,
    in_directives: true,
    in_loop: 0,
    labels: []
  };
  S.token = next();
  function is3(type, value) {
    return is_token(S.token, type, value);
  }
  function peek() {
    return S.peeked || (S.peeked = S.input());
  }
  function next() {
    S.prev = S.token;
    if (!S.peeked)
      peek();
    S.token = S.peeked;
    S.peeked = null;
    S.in_directives = S.in_directives && (S.token.type == "string" || is3("punc", ";"));
    return S.token;
  }
  function prev() {
    return S.prev;
  }
  function croak(msg, line, col, pos) {
    var ctx = S.input.context();
    js_error(msg, ctx.filename, line != null ? line : ctx.tokline, col != null ? col : ctx.tokcol, pos != null ? pos : ctx.tokpos);
  }
  function token_error(token, msg) {
    croak(msg, token.line, token.col);
  }
  function unexpected(token) {
    if (token == null)
      token = S.token;
    token_error(token, "Unexpected token: " + token.type + " (" + token.value + ")");
  }
  function expect_token(type, val2) {
    if (is3(type, val2)) {
      return next();
    }
    token_error(S.token, "Unexpected token " + S.token.type + " \xAB" + S.token.value + "\xBB" + ", expected " + type + " \xAB" + val2 + "\xBB");
  }
  function expect(punc) {
    return expect_token("punc", punc);
  }
  function has_newline_before(token) {
    return token.nlb || !token.comments_before.every((comment) => !comment.nlb);
  }
  function can_insert_semicolon() {
    return !options3.strict && (is3("eof") || is3("punc", "}") || has_newline_before(S.token));
  }
  function is_in_generator() {
    return S.in_generator === S.in_function;
  }
  function is_in_async() {
    return S.in_async === S.in_function;
  }
  function can_await() {
    return S.in_async === S.in_function || S.in_function === 0 && S.input.has_directive("use strict");
  }
  function semicolon2(optional) {
    if (is3("punc", ";"))
      next();
    else if (!optional && !can_insert_semicolon())
      unexpected();
  }
  function parenthesised() {
    expect("(");
    var exp = expression(true);
    expect(")");
    return exp;
  }
  function embed_tokens(parser) {
    return function _embed_tokens_wrapper(...args) {
      const start = S.token;
      const expr = parser(...args);
      expr.start = start;
      expr.end = prev();
      return expr;
    };
  }
  function handle_regexp() {
    if (is3("operator", "/") || is3("operator", "/=")) {
      S.peeked = null;
      S.token = S.input(S.token.value.substr(1));
    }
  }
  var statement = embed_tokens(function statement(is_export_default, is_for_body, is_if_body) {
    handle_regexp();
    switch (S.token.type) {
      case "string":
        if (S.in_directives) {
          var token = peek();
          if (!LATEST_RAW.includes("\\") && (is_token(token, "punc", ";") || is_token(token, "punc", "}") || has_newline_before(token) || is_token(token, "eof"))) {
            S.input.add_directive(S.token.value);
          } else {
            S.in_directives = false;
          }
        }
        var dir = S.in_directives, stat22 = simple_statement();
        return dir && stat22.body instanceof AST_String ? new AST_Directive(stat22.body) : stat22;
      case "template_head":
      case "num":
      case "big_int":
      case "regexp":
      case "operator":
      case "atom":
        return simple_statement();
      case "name":
      case "privatename":
        if (is3("privatename") && !S.in_class)
          croak("Private field must be used in an enclosing class");
        if (S.token.value == "async" && is_token(peek(), "keyword", "function")) {
          next();
          next();
          if (is_for_body) {
            croak("functions are not allowed as the body of a loop");
          }
          return function_(AST_Defun, false, true, is_export_default);
        }
        if (S.token.value == "import" && !is_token(peek(), "punc", "(") && !is_token(peek(), "punc", ".")) {
          next();
          var node = import_statement();
          semicolon2();
          return node;
        }
        return is_token(peek(), "punc", ":") ? labeled_statement() : simple_statement();
      case "punc":
        switch (S.token.value) {
          case "{":
            return new AST_BlockStatement({
              start: S.token,
              body: block_(),
              end: prev()
            });
          case "[":
          case "(":
            return simple_statement();
          case ";":
            S.in_directives = false;
            next();
            return new AST_EmptyStatement;
          default:
            unexpected();
        }
      case "keyword":
        switch (S.token.value) {
          case "break":
            next();
            return break_cont(AST_Break);
          case "continue":
            next();
            return break_cont(AST_Continue);
          case "debugger":
            next();
            semicolon2();
            return new AST_Debugger;
          case "do":
            next();
            var body = in_loop(statement);
            expect_token("keyword", "while");
            var condition = parenthesised();
            semicolon2(true);
            return new AST_Do({
              body,
              condition
            });
          case "while":
            next();
            return new AST_While({
              condition: parenthesised(),
              body: in_loop(function() {
                return statement(false, true);
              })
            });
          case "for":
            next();
            return for_();
          case "class":
            next();
            if (is_for_body) {
              croak("classes are not allowed as the body of a loop");
            }
            if (is_if_body) {
              croak("classes are not allowed as the body of an if");
            }
            return class_(AST_DefClass, is_export_default);
          case "function":
            next();
            if (is_for_body) {
              croak("functions are not allowed as the body of a loop");
            }
            return function_(AST_Defun, false, false, is_export_default);
          case "if":
            next();
            return if_();
          case "return":
            if (S.in_function == 0 && !options3.bare_returns)
              croak("'return' outside of function");
            next();
            var value = null;
            if (is3("punc", ";")) {
              next();
            } else if (!can_insert_semicolon()) {
              value = expression(true);
              semicolon2();
            }
            return new AST_Return({
              value
            });
          case "switch":
            next();
            return new AST_Switch({
              expression: parenthesised(),
              body: in_loop(switch_body_)
            });
          case "throw":
            next();
            if (has_newline_before(S.token))
              croak("Illegal newline after 'throw'");
            var value = expression(true);
            semicolon2();
            return new AST_Throw({
              value
            });
          case "try":
            next();
            return try_();
          case "var":
            next();
            var node = var_();
            semicolon2();
            return node;
          case "let":
            next();
            var node = let_();
            semicolon2();
            return node;
          case "const":
            next();
            var node = const_();
            semicolon2();
            return node;
          case "with":
            if (S.input.has_directive("use strict")) {
              croak("Strict mode may not include a with statement");
            }
            next();
            return new AST_With({
              expression: parenthesised(),
              body: statement()
            });
          case "export":
            if (!is_token(peek(), "punc", "(")) {
              next();
              var node = export_statement();
              if (is3("punc", ";"))
                semicolon2();
              return node;
            }
        }
    }
    unexpected();
  });
  function labeled_statement() {
    var label = as_symbol(AST_Label);
    if (label.name === "await" && is_in_async()) {
      token_error(S.prev, "await cannot be used as label inside async function");
    }
    if (S.labels.some((l22) => l22.name === label.name)) {
      croak("Label " + label.name + " defined twice");
    }
    expect(":");
    S.labels.push(label);
    var stat22 = statement();
    S.labels.pop();
    if (!(stat22 instanceof AST_IterationStatement)) {
      label.references.forEach(function(ref2) {
        if (ref2 instanceof AST_Continue) {
          ref2 = ref2.label.start;
          croak("Continue label `" + label.name + "` refers to non-IterationStatement.", ref2.line, ref2.col, ref2.pos);
        }
      });
    }
    return new AST_LabeledStatement({ body: stat22, label });
  }
  function simple_statement(tmp) {
    return new AST_SimpleStatement({ body: (tmp = expression(true), semicolon2(), tmp) });
  }
  function break_cont(type) {
    var label = null, ldef;
    if (!can_insert_semicolon()) {
      label = as_symbol(AST_LabelRef, true);
    }
    if (label != null) {
      ldef = S.labels.find((l22) => l22.name === label.name);
      if (!ldef)
        croak("Undefined label " + label.name);
      label.thedef = ldef;
    } else if (S.in_loop == 0)
      croak(type.TYPE + " not inside a loop or switch");
    semicolon2();
    var stat22 = new type({ label });
    if (ldef)
      ldef.references.push(stat22);
    return stat22;
  }
  function for_() {
    var for_await_error = "`for await` invalid in this context";
    var await_tok = S.token;
    if (await_tok.type == "name" && await_tok.value == "await") {
      if (!can_await()) {
        token_error(await_tok, for_await_error);
      }
      next();
    } else {
      await_tok = false;
    }
    expect("(");
    var init3 = null;
    if (!is3("punc", ";")) {
      init3 = is3("keyword", "var") ? (next(), var_(true)) : is3("keyword", "let") ? (next(), let_(true)) : is3("keyword", "const") ? (next(), const_(true)) : expression(true, true);
      var is_in = is3("operator", "in");
      var is_of = is3("name", "of");
      if (await_tok && !is_of) {
        token_error(await_tok, for_await_error);
      }
      if (is_in || is_of) {
        if (init3 instanceof AST_Definitions) {
          if (init3.definitions.length > 1)
            token_error(init3.start, "Only one variable declaration allowed in for..in loop");
        } else if (!(is_assignable(init3) || (init3 = to_destructuring(init3)) instanceof AST_Destructuring)) {
          token_error(init3.start, "Invalid left-hand side in for..in loop");
        }
        next();
        if (is_in) {
          return for_in(init3);
        } else {
          return for_of(init3, !!await_tok);
        }
      }
    } else if (await_tok) {
      token_error(await_tok, for_await_error);
    }
    return regular_for(init3);
  }
  function regular_for(init3) {
    expect(";");
    var test = is3("punc", ";") ? null : expression(true);
    expect(";");
    var step = is3("punc", ")") ? null : expression(true);
    expect(")");
    return new AST_For({
      init: init3,
      condition: test,
      step,
      body: in_loop(function() {
        return statement(false, true);
      })
    });
  }
  function for_of(init3, is_await) {
    var lhs = init3 instanceof AST_Definitions ? init3.definitions[0].name : null;
    var obj = expression(true);
    expect(")");
    return new AST_ForOf({
      await: is_await,
      init: init3,
      name: lhs,
      object: obj,
      body: in_loop(function() {
        return statement(false, true);
      })
    });
  }
  function for_in(init3) {
    var obj = expression(true);
    expect(")");
    return new AST_ForIn({
      init: init3,
      object: obj,
      body: in_loop(function() {
        return statement(false, true);
      })
    });
  }
  var arrow_function = function(start, argnames, is_async) {
    if (has_newline_before(S.token)) {
      croak("Unexpected newline before arrow (=>)");
    }
    expect_token("arrow", "=>");
    var body = _function_body(is3("punc", "{"), false, is_async);
    var end = body instanceof Array && body.length ? body[body.length - 1].end : body instanceof Array ? start : body.end;
    return new AST_Arrow({
      start,
      end,
      async: is_async,
      argnames,
      body
    });
  };
  var function_ = function(ctor, is_generator_property, is_async, is_export_default) {
    var in_statement = ctor === AST_Defun;
    var is_generator = is3("operator", "*");
    if (is_generator) {
      next();
    }
    var name = is3("name") ? as_symbol(in_statement ? AST_SymbolDefun : AST_SymbolLambda) : null;
    if (in_statement && !name) {
      if (is_export_default) {
        ctor = AST_Function;
      } else {
        unexpected();
      }
    }
    if (name && ctor !== AST_Accessor && !(name instanceof AST_SymbolDeclaration))
      unexpected(prev());
    var args = [];
    var body = _function_body(true, is_generator || is_generator_property, is_async, name, args);
    return new ctor({
      start: args.start,
      end: body.end,
      is_generator,
      async: is_async,
      name,
      argnames: args,
      body
    });
  };

  class UsedParametersTracker {
    constructor(is_parameter, strict, duplicates_ok = false) {
      this.is_parameter = is_parameter;
      this.duplicates_ok = duplicates_ok;
      this.parameters = new Set;
      this.duplicate = null;
      this.default_assignment = false;
      this.spread = false;
      this.strict_mode = !!strict;
    }
    add_parameter(token) {
      if (this.parameters.has(token.value)) {
        if (this.duplicate === null) {
          this.duplicate = token;
        }
        this.check_strict();
      } else {
        this.parameters.add(token.value);
        if (this.is_parameter) {
          switch (token.value) {
            case "arguments":
            case "eval":
            case "yield":
              if (this.strict_mode) {
                token_error(token, "Unexpected " + token.value + " identifier as parameter inside strict mode");
              }
              break;
            default:
              if (RESERVED_WORDS.has(token.value)) {
                unexpected();
              }
          }
        }
      }
    }
    mark_default_assignment(token) {
      if (this.default_assignment === false) {
        this.default_assignment = token;
      }
    }
    mark_spread(token) {
      if (this.spread === false) {
        this.spread = token;
      }
    }
    mark_strict_mode() {
      this.strict_mode = true;
    }
    is_strict() {
      return this.default_assignment !== false || this.spread !== false || this.strict_mode;
    }
    check_strict() {
      if (this.is_strict() && this.duplicate !== null && !this.duplicates_ok) {
        token_error(this.duplicate, "Parameter " + this.duplicate.value + " was used already");
      }
    }
  }
  function parameters(params) {
    var used_parameters = new UsedParametersTracker(true, S.input.has_directive("use strict"));
    expect("(");
    while (!is3("punc", ")")) {
      var param = parameter(used_parameters);
      params.push(param);
      if (!is3("punc", ")")) {
        expect(",");
      }
      if (param instanceof AST_Expansion) {
        break;
      }
    }
    next();
  }
  function parameter(used_parameters, symbol_type) {
    var param;
    var expand = false;
    if (used_parameters === undefined) {
      used_parameters = new UsedParametersTracker(true, S.input.has_directive("use strict"));
    }
    if (is3("expand", "...")) {
      expand = S.token;
      used_parameters.mark_spread(S.token);
      next();
    }
    param = binding_element(used_parameters, symbol_type);
    if (is3("operator", "=") && expand === false) {
      used_parameters.mark_default_assignment(S.token);
      next();
      param = new AST_DefaultAssign({
        start: param.start,
        left: param,
        operator: "=",
        right: expression(false),
        end: S.token
      });
    }
    if (expand !== false) {
      if (!is3("punc", ")")) {
        unexpected();
      }
      param = new AST_Expansion({
        start: expand,
        expression: param,
        end: expand
      });
    }
    used_parameters.check_strict();
    return param;
  }
  function binding_element(used_parameters, symbol_type) {
    var elements = [];
    var first = true;
    var is_expand = false;
    var expand_token;
    var first_token = S.token;
    if (used_parameters === undefined) {
      const strict = S.input.has_directive("use strict");
      const duplicates_ok = symbol_type === AST_SymbolVar;
      used_parameters = new UsedParametersTracker(false, strict, duplicates_ok);
    }
    symbol_type = symbol_type === undefined ? AST_SymbolFunarg : symbol_type;
    if (is3("punc", "[")) {
      next();
      while (!is3("punc", "]")) {
        if (first) {
          first = false;
        } else {
          expect(",");
        }
        if (is3("expand", "...")) {
          is_expand = true;
          expand_token = S.token;
          used_parameters.mark_spread(S.token);
          next();
        }
        if (is3("punc")) {
          switch (S.token.value) {
            case ",":
              elements.push(new AST_Hole({
                start: S.token,
                end: S.token
              }));
              continue;
            case "]":
              break;
            case "[":
            case "{":
              elements.push(binding_element(used_parameters, symbol_type));
              break;
            default:
              unexpected();
          }
        } else if (is3("name")) {
          used_parameters.add_parameter(S.token);
          elements.push(as_symbol(symbol_type));
        } else {
          croak("Invalid function parameter");
        }
        if (is3("operator", "=") && is_expand === false) {
          used_parameters.mark_default_assignment(S.token);
          next();
          elements[elements.length - 1] = new AST_DefaultAssign({
            start: elements[elements.length - 1].start,
            left: elements[elements.length - 1],
            operator: "=",
            right: expression(false),
            end: S.token
          });
        }
        if (is_expand) {
          if (!is3("punc", "]")) {
            croak("Rest element must be last element");
          }
          elements[elements.length - 1] = new AST_Expansion({
            start: expand_token,
            expression: elements[elements.length - 1],
            end: expand_token
          });
        }
      }
      expect("]");
      used_parameters.check_strict();
      return new AST_Destructuring({
        start: first_token,
        names: elements,
        is_array: true,
        end: prev()
      });
    } else if (is3("punc", "{")) {
      next();
      while (!is3("punc", "}")) {
        if (first) {
          first = false;
        } else {
          expect(",");
        }
        if (is3("expand", "...")) {
          is_expand = true;
          expand_token = S.token;
          used_parameters.mark_spread(S.token);
          next();
        }
        if (is3("name") && (is_token(peek(), "punc") || is_token(peek(), "operator")) && [",", "}", "="].includes(peek().value)) {
          used_parameters.add_parameter(S.token);
          var start = prev();
          var value = as_symbol(symbol_type);
          if (is_expand) {
            elements.push(new AST_Expansion({
              start: expand_token,
              expression: value,
              end: value.end
            }));
          } else {
            elements.push(new AST_ObjectKeyVal({
              start,
              key: value.name,
              value,
              end: value.end
            }));
          }
        } else if (is3("punc", "}")) {
          continue;
        } else {
          var property_token = S.token;
          var property = as_property_name();
          if (property === null) {
            unexpected(prev());
          } else if (prev().type === "name" && !is3("punc", ":")) {
            elements.push(new AST_ObjectKeyVal({
              start: prev(),
              key: property,
              value: new symbol_type({
                start: prev(),
                name: property,
                end: prev()
              }),
              end: prev()
            }));
          } else {
            expect(":");
            elements.push(new AST_ObjectKeyVal({
              start: property_token,
              quote: property_token.quote,
              key: property,
              value: binding_element(used_parameters, symbol_type),
              end: prev()
            }));
          }
        }
        if (is_expand) {
          if (!is3("punc", "}")) {
            croak("Rest element must be last element");
          }
        } else if (is3("operator", "=")) {
          used_parameters.mark_default_assignment(S.token);
          next();
          elements[elements.length - 1].value = new AST_DefaultAssign({
            start: elements[elements.length - 1].value.start,
            left: elements[elements.length - 1].value,
            operator: "=",
            right: expression(false),
            end: S.token
          });
        }
      }
      expect("}");
      used_parameters.check_strict();
      return new AST_Destructuring({
        start: first_token,
        names: elements,
        is_array: false,
        end: prev()
      });
    } else if (is3("name")) {
      used_parameters.add_parameter(S.token);
      return as_symbol(symbol_type);
    } else {
      croak("Invalid function parameter");
    }
  }
  function params_or_seq_(allow_arrows, maybe_sequence) {
    var spread_token;
    var invalid_sequence;
    var trailing_comma;
    var a = [];
    expect("(");
    while (!is3("punc", ")")) {
      if (spread_token)
        unexpected(spread_token);
      if (is3("expand", "...")) {
        spread_token = S.token;
        if (maybe_sequence)
          invalid_sequence = S.token;
        next();
        a.push(new AST_Expansion({
          start: prev(),
          expression: expression(),
          end: S.token
        }));
      } else {
        a.push(expression());
      }
      if (!is3("punc", ")")) {
        expect(",");
        if (is3("punc", ")")) {
          trailing_comma = prev();
          if (maybe_sequence)
            invalid_sequence = trailing_comma;
        }
      }
    }
    expect(")");
    if (allow_arrows && is3("arrow", "=>")) {
      if (spread_token && trailing_comma)
        unexpected(trailing_comma);
    } else if (invalid_sequence) {
      unexpected(invalid_sequence);
    }
    return a;
  }
  function _function_body(block, generator, is_async, name, args) {
    var loop = S.in_loop;
    var labels = S.labels;
    var current_generator = S.in_generator;
    var current_async = S.in_async;
    ++S.in_function;
    if (generator)
      S.in_generator = S.in_function;
    if (is_async)
      S.in_async = S.in_function;
    if (args)
      parameters(args);
    if (block)
      S.in_directives = true;
    S.in_loop = 0;
    S.labels = [];
    if (block) {
      S.input.push_directives_stack();
      var a = block_();
      if (name)
        _verify_symbol(name);
      if (args)
        args.forEach(_verify_symbol);
      S.input.pop_directives_stack();
    } else {
      var a = [new AST_Return({
        start: S.token,
        value: expression(false),
        end: S.token
      })];
    }
    --S.in_function;
    S.in_loop = loop;
    S.labels = labels;
    S.in_generator = current_generator;
    S.in_async = current_async;
    return a;
  }
  function _await_expression() {
    if (!can_await()) {
      croak("Unexpected await expression outside async function", S.prev.line, S.prev.col, S.prev.pos);
    }
    return new AST_Await({
      start: prev(),
      end: S.token,
      expression: maybe_unary(true)
    });
  }
  function _yield_expression() {
    if (!is_in_generator()) {
      croak("Unexpected yield expression outside generator function", S.prev.line, S.prev.col, S.prev.pos);
    }
    var start = S.token;
    var star = false;
    var has_expression = true;
    if (can_insert_semicolon() || is3("punc") && PUNC_AFTER_EXPRESSION.has(S.token.value)) {
      has_expression = false;
    } else if (is3("operator", "*")) {
      star = true;
      next();
    }
    return new AST_Yield({
      start,
      is_star: star,
      expression: has_expression ? expression() : null,
      end: prev()
    });
  }
  function if_() {
    var cond = parenthesised(), body = statement(false, false, true), belse = null;
    if (is3("keyword", "else")) {
      next();
      belse = statement(false, false, true);
    }
    return new AST_If({
      condition: cond,
      body,
      alternative: belse
    });
  }
  function block_() {
    expect("{");
    var a = [];
    while (!is3("punc", "}")) {
      if (is3("eof"))
        unexpected();
      a.push(statement());
    }
    next();
    return a;
  }
  function switch_body_() {
    expect("{");
    var a = [], cur = null, branch = null, tmp;
    while (!is3("punc", "}")) {
      if (is3("eof"))
        unexpected();
      if (is3("keyword", "case")) {
        if (branch)
          branch.end = prev();
        cur = [];
        branch = new AST_Case({
          start: (tmp = S.token, next(), tmp),
          expression: expression(true),
          body: cur
        });
        a.push(branch);
        expect(":");
      } else if (is3("keyword", "default")) {
        if (branch)
          branch.end = prev();
        cur = [];
        branch = new AST_Default({
          start: (tmp = S.token, next(), expect(":"), tmp),
          body: cur
        });
        a.push(branch);
      } else {
        if (!cur)
          unexpected();
        cur.push(statement());
      }
    }
    if (branch)
      branch.end = prev();
    next();
    return a;
  }
  function try_() {
    var body, bcatch = null, bfinally = null;
    body = new AST_TryBlock({
      start: S.token,
      body: block_(),
      end: prev()
    });
    if (is3("keyword", "catch")) {
      var start = S.token;
      next();
      if (is3("punc", "{")) {
        var name = null;
      } else {
        expect("(");
        var name = parameter(undefined, AST_SymbolCatch);
        expect(")");
      }
      bcatch = new AST_Catch({
        start,
        argname: name,
        body: block_(),
        end: prev()
      });
    }
    if (is3("keyword", "finally")) {
      var start = S.token;
      next();
      bfinally = new AST_Finally({
        start,
        body: block_(),
        end: prev()
      });
    }
    if (!bcatch && !bfinally)
      croak("Missing catch/finally blocks");
    return new AST_Try({
      body,
      bcatch,
      bfinally
    });
  }
  function vardefs(no_in, kind) {
    var var_defs = [];
    var def;
    for (;; ) {
      var sym_type = kind === "var" ? AST_SymbolVar : kind === "const" ? AST_SymbolConst : kind === "let" ? AST_SymbolLet : null;
      if (is3("punc", "{") || is3("punc", "[")) {
        def = new AST_VarDef({
          start: S.token,
          name: binding_element(undefined, sym_type),
          value: is3("operator", "=") ? (expect_token("operator", "="), expression(false, no_in)) : null,
          end: prev()
        });
      } else {
        def = new AST_VarDef({
          start: S.token,
          name: as_symbol(sym_type),
          value: is3("operator", "=") ? (next(), expression(false, no_in)) : !no_in && kind === "const" ? croak("Missing initializer in const declaration") : null,
          end: prev()
        });
        if (def.name.name == "import")
          croak("Unexpected token: import");
      }
      var_defs.push(def);
      if (!is3("punc", ","))
        break;
      next();
    }
    return var_defs;
  }
  var var_ = function(no_in) {
    return new AST_Var({
      start: prev(),
      definitions: vardefs(no_in, "var"),
      end: prev()
    });
  };
  var let_ = function(no_in) {
    return new AST_Let({
      start: prev(),
      definitions: vardefs(no_in, "let"),
      end: prev()
    });
  };
  var const_ = function(no_in) {
    return new AST_Const({
      start: prev(),
      definitions: vardefs(no_in, "const"),
      end: prev()
    });
  };
  var new_ = function(allow_calls) {
    var start = S.token;
    expect_token("operator", "new");
    if (is3("punc", ".")) {
      next();
      expect_token("name", "target");
      return subscripts(new AST_NewTarget({
        start,
        end: prev()
      }), allow_calls);
    }
    var newexp = expr_atom(false), args;
    if (is3("punc", "(")) {
      next();
      args = expr_list(")", true);
    } else {
      args = [];
    }
    var call = new AST_New({
      start,
      expression: newexp,
      args,
      end: prev()
    });
    annotate(call);
    return subscripts(call, allow_calls);
  };
  function as_atom_node() {
    var tok = S.token, ret;
    switch (tok.type) {
      case "name":
        ret = _make_symbol(AST_SymbolRef);
        break;
      case "num":
        ret = new AST_Number({
          start: tok,
          end: tok,
          value: tok.value,
          raw: LATEST_RAW
        });
        break;
      case "big_int":
        ret = new AST_BigInt({ start: tok, end: tok, value: tok.value });
        break;
      case "string":
        ret = new AST_String({
          start: tok,
          end: tok,
          value: tok.value,
          quote: tok.quote
        });
        annotate(ret);
        break;
      case "regexp":
        const [_22, source, flags] = tok.value.match(/^\/(.*)\/(\w*)$/);
        ret = new AST_RegExp({ start: tok, end: tok, value: { source, flags } });
        break;
      case "atom":
        switch (tok.value) {
          case "false":
            ret = new AST_False({ start: tok, end: tok });
            break;
          case "true":
            ret = new AST_True({ start: tok, end: tok });
            break;
          case "null":
            ret = new AST_Null({ start: tok, end: tok });
            break;
        }
        break;
    }
    next();
    return ret;
  }
  function to_fun_args(ex, default_seen_above) {
    var insert_default = function(ex2, default_value) {
      if (default_value) {
        return new AST_DefaultAssign({
          start: ex2.start,
          left: ex2,
          operator: "=",
          right: default_value,
          end: default_value.end
        });
      }
      return ex2;
    };
    if (ex instanceof AST_Object) {
      return insert_default(new AST_Destructuring({
        start: ex.start,
        end: ex.end,
        is_array: false,
        names: ex.properties.map((prop) => to_fun_args(prop))
      }), default_seen_above);
    } else if (ex instanceof AST_ObjectKeyVal) {
      ex.value = to_fun_args(ex.value);
      return insert_default(ex, default_seen_above);
    } else if (ex instanceof AST_Hole) {
      return ex;
    } else if (ex instanceof AST_Destructuring) {
      ex.names = ex.names.map((name) => to_fun_args(name));
      return insert_default(ex, default_seen_above);
    } else if (ex instanceof AST_SymbolRef) {
      return insert_default(new AST_SymbolFunarg({
        name: ex.name,
        start: ex.start,
        end: ex.end
      }), default_seen_above);
    } else if (ex instanceof AST_Expansion) {
      ex.expression = to_fun_args(ex.expression);
      return insert_default(ex, default_seen_above);
    } else if (ex instanceof AST_Array) {
      return insert_default(new AST_Destructuring({
        start: ex.start,
        end: ex.end,
        is_array: true,
        names: ex.elements.map((elm) => to_fun_args(elm))
      }), default_seen_above);
    } else if (ex instanceof AST_Assign) {
      return insert_default(to_fun_args(ex.left, ex.right), default_seen_above);
    } else if (ex instanceof AST_DefaultAssign) {
      ex.left = to_fun_args(ex.left);
      return ex;
    } else {
      croak("Invalid function parameter", ex.start.line, ex.start.col);
    }
  }
  var expr_atom = function(allow_calls, allow_arrows) {
    if (is3("operator", "new")) {
      return new_(allow_calls);
    }
    if (is3("name", "import") && is_token(peek(), "punc", ".")) {
      return import_meta(allow_calls);
    }
    var start = S.token;
    var peeked;
    var async = is3("name", "async") && (peeked = peek()).value != "[" && peeked.type != "arrow" && as_atom_node();
    if (is3("punc")) {
      switch (S.token.value) {
        case "(":
          if (async && !allow_calls)
            break;
          var exprs = params_or_seq_(allow_arrows, !async);
          if (allow_arrows && is3("arrow", "=>")) {
            return arrow_function(start, exprs.map((e) => to_fun_args(e)), !!async);
          }
          var ex = async ? new AST_Call({
            expression: async,
            args: exprs
          }) : to_expr_or_sequence(start, exprs);
          if (ex.start) {
            const outer_comments_before = start.comments_before.length;
            outer_comments_before_counts.set(start, outer_comments_before);
            ex.start.comments_before.unshift(...start.comments_before);
            start.comments_before = ex.start.comments_before;
            if (outer_comments_before == 0 && start.comments_before.length > 0) {
              var comment = start.comments_before[0];
              if (!comment.nlb) {
                comment.nlb = start.nlb;
                start.nlb = false;
              }
            }
            start.comments_after = ex.start.comments_after;
          }
          ex.start = start;
          var end = prev();
          if (ex.end) {
            end.comments_before = ex.end.comments_before;
            ex.end.comments_after.push(...end.comments_after);
            end.comments_after = ex.end.comments_after;
          }
          ex.end = end;
          if (ex instanceof AST_Call)
            annotate(ex);
          return subscripts(ex, allow_calls);
        case "[":
          return subscripts(array_(), allow_calls);
        case "{":
          return subscripts(object_or_destructuring_(), allow_calls);
      }
      if (!async)
        unexpected();
    }
    if (allow_arrows && is3("name") && is_token(peek(), "arrow")) {
      var param = new AST_SymbolFunarg({
        name: S.token.value,
        start,
        end: start
      });
      next();
      return arrow_function(start, [param], !!async);
    }
    if (is3("keyword", "function")) {
      next();
      var func = function_(AST_Function, false, !!async);
      func.start = start;
      func.end = prev();
      return subscripts(func, allow_calls);
    }
    if (async)
      return subscripts(async, allow_calls);
    if (is3("keyword", "class")) {
      next();
      var cls = class_(AST_ClassExpression);
      cls.start = start;
      cls.end = prev();
      return subscripts(cls, allow_calls);
    }
    if (is3("template_head")) {
      return subscripts(template_string(), allow_calls);
    }
    if (ATOMIC_START_TOKEN.has(S.token.type)) {
      return subscripts(as_atom_node(), allow_calls);
    }
    unexpected();
  };
  function template_string() {
    var segments = [], start = S.token;
    segments.push(new AST_TemplateSegment({
      start: S.token,
      raw: TEMPLATE_RAWS.get(S.token),
      value: S.token.value,
      end: S.token
    }));
    while (!S.token.template_end) {
      next();
      handle_regexp();
      segments.push(expression(true));
      segments.push(new AST_TemplateSegment({
        start: S.token,
        raw: TEMPLATE_RAWS.get(S.token),
        value: S.token.value,
        end: S.token
      }));
    }
    next();
    return new AST_TemplateString({
      start,
      segments,
      end: S.token
    });
  }
  function expr_list(closing, allow_trailing_comma, allow_empty) {
    var first = true, a = [];
    while (!is3("punc", closing)) {
      if (first)
        first = false;
      else
        expect(",");
      if (allow_trailing_comma && is3("punc", closing))
        break;
      if (is3("punc", ",") && allow_empty) {
        a.push(new AST_Hole({ start: S.token, end: S.token }));
      } else if (is3("expand", "...")) {
        next();
        a.push(new AST_Expansion({ start: prev(), expression: expression(), end: S.token }));
      } else {
        a.push(expression(false));
      }
    }
    next();
    return a;
  }
  var array_ = embed_tokens(function() {
    expect("[");
    return new AST_Array({
      elements: expr_list("]", !options3.strict, true)
    });
  });
  var create_accessor = embed_tokens((is_generator, is_async) => {
    return function_(AST_Accessor, is_generator, is_async);
  });
  var object_or_destructuring_ = embed_tokens(function object_or_destructuring_() {
    var start = S.token, first = true, a = [];
    expect("{");
    while (!is3("punc", "}")) {
      if (first)
        first = false;
      else
        expect(",");
      if (!options3.strict && is3("punc", "}"))
        break;
      start = S.token;
      if (start.type == "expand") {
        next();
        a.push(new AST_Expansion({
          start,
          expression: expression(false),
          end: prev()
        }));
        continue;
      }
      if (is3("privatename")) {
        croak("private fields are not allowed in an object");
      }
      var name = as_property_name();
      var value;
      if (!is3("punc", ":")) {
        var concise = concise_method_or_getset(name, start);
        if (concise) {
          a.push(concise);
          continue;
        }
        value = new AST_SymbolRef({
          start: prev(),
          name,
          end: prev()
        });
      } else if (name === null) {
        unexpected(prev());
      } else {
        next();
        value = expression(false);
      }
      if (is3("operator", "=")) {
        next();
        value = new AST_Assign({
          start,
          left: value,
          operator: "=",
          right: expression(false),
          logical: false,
          end: prev()
        });
      }
      const kv = new AST_ObjectKeyVal({
        start,
        quote: start.quote,
        key: name instanceof AST_Node ? name : "" + name,
        value,
        end: prev()
      });
      a.push(annotate(kv));
    }
    next();
    return new AST_Object({ properties: a });
  });
  function class_(KindOfClass, is_export_default) {
    var start, method, class_name, extends_, a = [];
    S.input.push_directives_stack();
    S.input.add_directive("use strict");
    if (S.token.type == "name" && S.token.value != "extends") {
      class_name = as_symbol(KindOfClass === AST_DefClass ? AST_SymbolDefClass : AST_SymbolClass);
    }
    if (KindOfClass === AST_DefClass && !class_name) {
      if (is_export_default) {
        KindOfClass = AST_ClassExpression;
      } else {
        unexpected();
      }
    }
    if (S.token.value == "extends") {
      next();
      extends_ = expression(true);
    }
    expect("{");
    const save_in_class = S.in_class;
    S.in_class = true;
    while (is3("punc", ";")) {
      next();
    }
    while (!is3("punc", "}")) {
      start = S.token;
      method = concise_method_or_getset(as_property_name(), start, true);
      if (!method) {
        unexpected();
      }
      a.push(method);
      while (is3("punc", ";")) {
        next();
      }
    }
    S.in_class = save_in_class;
    S.input.pop_directives_stack();
    next();
    return new KindOfClass({
      start,
      name: class_name,
      extends: extends_,
      properties: a,
      end: prev()
    });
  }
  function concise_method_or_getset(name, start, is_class) {
    const get_symbol_ast = (name2, SymbolClass = AST_SymbolMethod) => {
      if (typeof name2 === "string" || typeof name2 === "number") {
        return new SymbolClass({
          start,
          name: "" + name2,
          end: prev()
        });
      } else if (name2 === null) {
        unexpected();
      }
      return name2;
    };
    const is_not_method_start = () => !is3("punc", "(") && !is3("punc", ",") && !is3("punc", "}") && !is3("punc", ";") && !is3("operator", "=");
    var is_async = false;
    var is_static = false;
    var is_generator = false;
    var is_private = false;
    var accessor_type = null;
    if (is_class && name === "static" && is_not_method_start()) {
      const static_block = class_static_block();
      if (static_block != null) {
        return static_block;
      }
      is_static = true;
      name = as_property_name();
    }
    if (name === "async" && is_not_method_start()) {
      is_async = true;
      name = as_property_name();
    }
    if (prev().type === "operator" && prev().value === "*") {
      is_generator = true;
      name = as_property_name();
    }
    if ((name === "get" || name === "set") && is_not_method_start()) {
      accessor_type = name;
      name = as_property_name();
    }
    if (prev().type === "privatename") {
      is_private = true;
    }
    const property_token = prev();
    if (accessor_type != null) {
      if (!is_private) {
        const AccessorClass = accessor_type === "get" ? AST_ObjectGetter : AST_ObjectSetter;
        name = get_symbol_ast(name);
        return annotate(new AccessorClass({
          start,
          static: is_static,
          key: name,
          quote: name instanceof AST_SymbolMethod ? property_token.quote : undefined,
          value: create_accessor(),
          end: prev()
        }));
      } else {
        const AccessorClass = accessor_type === "get" ? AST_PrivateGetter : AST_PrivateSetter;
        return annotate(new AccessorClass({
          start,
          static: is_static,
          key: get_symbol_ast(name),
          value: create_accessor(),
          end: prev()
        }));
      }
    }
    if (is3("punc", "(")) {
      name = get_symbol_ast(name);
      const AST_MethodVariant = is_private ? AST_PrivateMethod : AST_ConciseMethod;
      var node = new AST_MethodVariant({
        start,
        static: is_static,
        is_generator,
        async: is_async,
        key: name,
        quote: name instanceof AST_SymbolMethod ? property_token.quote : undefined,
        value: create_accessor(is_generator, is_async),
        end: prev()
      });
      return annotate(node);
    }
    if (is_class) {
      const key = get_symbol_ast(name, AST_SymbolClassProperty);
      const quote = key instanceof AST_SymbolClassProperty ? property_token.quote : undefined;
      const AST_ClassPropertyVariant = is_private ? AST_ClassPrivateProperty : AST_ClassProperty;
      if (is3("operator", "=")) {
        next();
        return annotate(new AST_ClassPropertyVariant({
          start,
          static: is_static,
          quote,
          key,
          value: expression(false),
          end: prev()
        }));
      } else if (is3("name") || is3("privatename") || is3("operator", "*") || is3("punc", ";") || is3("punc", "}")) {
        return annotate(new AST_ClassPropertyVariant({
          start,
          static: is_static,
          quote,
          key,
          end: prev()
        }));
      }
    }
  }
  function class_static_block() {
    if (!is3("punc", "{")) {
      return null;
    }
    const start = S.token;
    const body = [];
    next();
    while (!is3("punc", "}")) {
      body.push(statement());
    }
    next();
    return new AST_ClassStaticBlock({ start, body, end: prev() });
  }
  function maybe_import_attributes() {
    if ((is3("keyword", "with") || is3("name", "assert")) && !has_newline_before(S.token)) {
      next();
      return object_or_destructuring_();
    }
    return null;
  }
  function import_statement() {
    var start = prev();
    var imported_name;
    var imported_names;
    if (is3("name")) {
      imported_name = as_symbol(AST_SymbolImport);
    }
    if (is3("punc", ",")) {
      next();
    }
    imported_names = map_names(true);
    if (imported_names || imported_name) {
      expect_token("name", "from");
    }
    var mod_str = S.token;
    if (mod_str.type !== "string") {
      unexpected();
    }
    next();
    const attributes = maybe_import_attributes();
    return new AST_Import({
      start,
      imported_name,
      imported_names,
      module_name: new AST_String({
        start: mod_str,
        value: mod_str.value,
        quote: mod_str.quote,
        end: mod_str
      }),
      attributes,
      end: S.token
    });
  }
  function import_meta(allow_calls) {
    var start = S.token;
    expect_token("name", "import");
    expect_token("punc", ".");
    expect_token("name", "meta");
    return subscripts(new AST_ImportMeta({
      start,
      end: prev()
    }), allow_calls);
  }
  function map_name(is_import) {
    function make_symbol(type2, quote) {
      return new type2({
        name: as_property_name(),
        quote: quote || undefined,
        start: prev(),
        end: prev()
      });
    }
    var foreign_type = is_import ? AST_SymbolImportForeign : AST_SymbolExportForeign;
    var type = is_import ? AST_SymbolImport : AST_SymbolExport;
    var start = S.token;
    var foreign_name;
    var name;
    if (is_import) {
      foreign_name = make_symbol(foreign_type, start.quote);
    } else {
      name = make_symbol(type, start.quote);
    }
    if (is3("name", "as")) {
      next();
      if (is_import) {
        name = make_symbol(type);
      } else {
        foreign_name = make_symbol(foreign_type, S.token.quote);
      }
    } else if (is_import) {
      name = new type(foreign_name);
    } else {
      foreign_name = new foreign_type(name);
    }
    return new AST_NameMapping({
      start,
      foreign_name,
      name,
      end: prev()
    });
  }
  function map_nameAsterisk(is_import, import_or_export_foreign_name) {
    var foreign_type = is_import ? AST_SymbolImportForeign : AST_SymbolExportForeign;
    var type = is_import ? AST_SymbolImport : AST_SymbolExport;
    var start = S.token;
    var name, foreign_name;
    var end = prev();
    if (is_import) {
      name = import_or_export_foreign_name;
    } else {
      foreign_name = import_or_export_foreign_name;
    }
    name = name || new type({
      start,
      name: "*",
      end
    });
    foreign_name = foreign_name || new foreign_type({
      start,
      name: "*",
      end
    });
    return new AST_NameMapping({
      start,
      foreign_name,
      name,
      end
    });
  }
  function map_names(is_import) {
    var names;
    if (is3("punc", "{")) {
      next();
      names = [];
      while (!is3("punc", "}")) {
        names.push(map_name(is_import));
        if (is3("punc", ",")) {
          next();
        }
      }
      next();
    } else if (is3("operator", "*")) {
      var name;
      next();
      if (is3("name", "as")) {
        next();
        name = is_import ? as_symbol(AST_SymbolImport) : as_symbol_or_string(AST_SymbolExportForeign);
      }
      names = [map_nameAsterisk(is_import, name)];
    }
    return names;
  }
  function export_statement() {
    var start = S.token;
    var is_default;
    var exported_names;
    if (is3("keyword", "default")) {
      is_default = true;
      next();
    } else if (exported_names = map_names(false)) {
      if (is3("name", "from")) {
        next();
        var mod_str = S.token;
        if (mod_str.type !== "string") {
          unexpected();
        }
        next();
        const attributes = maybe_import_attributes();
        return new AST_Export({
          start,
          is_default,
          exported_names,
          module_name: new AST_String({
            start: mod_str,
            value: mod_str.value,
            quote: mod_str.quote,
            end: mod_str
          }),
          end: prev(),
          attributes
        });
      } else {
        return new AST_Export({
          start,
          is_default,
          exported_names,
          end: prev()
        });
      }
    }
    var node;
    var exported_value;
    var exported_definition;
    if (is3("punc", "{") || is_default && (is3("keyword", "class") || is3("keyword", "function")) && is_token(peek(), "punc")) {
      exported_value = expression(false);
      semicolon2();
    } else if ((node = statement(is_default)) instanceof AST_Definitions && is_default) {
      unexpected(node.start);
    } else if (node instanceof AST_Definitions || node instanceof AST_Defun || node instanceof AST_DefClass) {
      exported_definition = node;
    } else if (node instanceof AST_ClassExpression || node instanceof AST_Function) {
      exported_value = node;
    } else if (node instanceof AST_SimpleStatement) {
      exported_value = node.body;
    } else {
      unexpected(node.start);
    }
    return new AST_Export({
      start,
      is_default,
      exported_value,
      exported_definition,
      end: prev(),
      attributes: null
    });
  }
  function as_property_name() {
    var tmp = S.token;
    switch (tmp.type) {
      case "punc":
        if (tmp.value === "[") {
          next();
          var ex = expression(false);
          expect("]");
          return ex;
        } else
          unexpected(tmp);
      case "operator":
        if (tmp.value === "*") {
          next();
          return null;
        }
        if (!["delete", "in", "instanceof", "new", "typeof", "void"].includes(tmp.value)) {
          unexpected(tmp);
        }
      case "name":
      case "privatename":
      case "string":
      case "num":
      case "big_int":
      case "keyword":
      case "atom":
        next();
        return tmp.value;
      default:
        unexpected(tmp);
    }
  }
  function as_name() {
    var tmp = S.token;
    if (tmp.type != "name" && tmp.type != "privatename")
      unexpected();
    next();
    return tmp.value;
  }
  function _make_symbol(type) {
    var name = S.token.value;
    return new (name == "this" ? AST_This : name == "super" ? AST_Super : type)({
      name: String(name),
      start: S.token,
      end: S.token
    });
  }
  function _verify_symbol(sym) {
    var name = sym.name;
    if (is_in_generator() && name == "yield") {
      token_error(sym.start, "Yield cannot be used as identifier inside generators");
    }
    if (S.input.has_directive("use strict")) {
      if (name == "yield") {
        token_error(sym.start, "Unexpected yield identifier inside strict mode");
      }
      if (sym instanceof AST_SymbolDeclaration && (name == "arguments" || name == "eval")) {
        token_error(sym.start, "Unexpected " + name + " in strict mode");
      }
    }
  }
  function as_symbol(type, noerror) {
    if (!is3("name")) {
      if (!noerror)
        croak("Name expected");
      return null;
    }
    var sym = _make_symbol(type);
    _verify_symbol(sym);
    next();
    return sym;
  }
  function as_symbol_or_string(type) {
    if (!is3("name")) {
      if (!is3("string")) {
        croak("Name or string expected");
      }
      var tok = S.token;
      var ret = new type({
        start: tok,
        end: tok,
        name: tok.value,
        quote: tok.quote
      });
      next();
      return ret;
    }
    var sym = _make_symbol(type);
    _verify_symbol(sym);
    next();
    return sym;
  }
  function annotate(node, before_token = node.start) {
    var comments = before_token.comments_before;
    const comments_outside_parens = outer_comments_before_counts.get(before_token);
    var i2 = comments_outside_parens != null ? comments_outside_parens : comments.length;
    while (--i2 >= 0) {
      var comment = comments[i2];
      if (/[@#]__/.test(comment.value)) {
        if (/[@#]__PURE__/.test(comment.value)) {
          set_annotation(node, _PURE);
          break;
        }
        if (/[@#]__INLINE__/.test(comment.value)) {
          set_annotation(node, _INLINE);
          break;
        }
        if (/[@#]__NOINLINE__/.test(comment.value)) {
          set_annotation(node, _NOINLINE);
          break;
        }
        if (/[@#]__KEY__/.test(comment.value)) {
          set_annotation(node, _KEY);
          break;
        }
        if (/[@#]__MANGLE_PROP__/.test(comment.value)) {
          set_annotation(node, _MANGLEPROP);
          break;
        }
      }
    }
    return node;
  }
  var subscripts = function(expr, allow_calls, is_chain) {
    var start = expr.start;
    if (is3("punc", ".")) {
      next();
      if (is3("privatename") && !S.in_class)
        croak("Private field must be used in an enclosing class");
      const AST_DotVariant = is3("privatename") ? AST_DotHash : AST_Dot;
      return annotate(subscripts(new AST_DotVariant({
        start,
        expression: expr,
        optional: false,
        property: as_name(),
        end: prev()
      }), allow_calls, is_chain));
    }
    if (is3("punc", "[")) {
      next();
      var prop = expression(true);
      expect("]");
      return annotate(subscripts(new AST_Sub({
        start,
        expression: expr,
        optional: false,
        property: prop,
        end: prev()
      }), allow_calls, is_chain));
    }
    if (allow_calls && is3("punc", "(")) {
      next();
      var call = new AST_Call({
        start,
        expression: expr,
        optional: false,
        args: call_args(),
        end: prev()
      });
      annotate(call);
      return subscripts(call, true, is_chain);
    }
    if (is3("punc", "?.")) {
      next();
      let chain_contents;
      if (allow_calls && is3("punc", "(")) {
        next();
        const call2 = new AST_Call({
          start,
          optional: true,
          expression: expr,
          args: call_args(),
          end: prev()
        });
        annotate(call2);
        chain_contents = subscripts(call2, true, true);
      } else if (is3("name") || is3("privatename")) {
        if (is3("privatename") && !S.in_class)
          croak("Private field must be used in an enclosing class");
        const AST_DotVariant = is3("privatename") ? AST_DotHash : AST_Dot;
        chain_contents = annotate(subscripts(new AST_DotVariant({
          start,
          expression: expr,
          optional: true,
          property: as_name(),
          end: prev()
        }), allow_calls, true));
      } else if (is3("punc", "[")) {
        next();
        const property = expression(true);
        expect("]");
        chain_contents = annotate(subscripts(new AST_Sub({
          start,
          expression: expr,
          optional: true,
          property,
          end: prev()
        }), allow_calls, true));
      }
      if (!chain_contents)
        unexpected();
      if (chain_contents instanceof AST_Chain)
        return chain_contents;
      return new AST_Chain({
        start,
        expression: chain_contents,
        end: prev()
      });
    }
    if (is3("template_head")) {
      if (is_chain) {
        unexpected();
      }
      return subscripts(new AST_PrefixedTemplateString({
        start,
        prefix: expr,
        template_string: template_string(),
        end: prev()
      }), allow_calls);
    }
    return expr;
  };
  function call_args() {
    var args = [];
    while (!is3("punc", ")")) {
      if (is3("expand", "...")) {
        next();
        args.push(new AST_Expansion({
          start: prev(),
          expression: expression(false),
          end: prev()
        }));
      } else {
        args.push(expression(false));
      }
      if (!is3("punc", ")")) {
        expect(",");
      }
    }
    next();
    return args;
  }
  var maybe_unary = function(allow_calls, allow_arrows) {
    var start = S.token;
    if (start.type == "name" && start.value == "await" && can_await()) {
      next();
      return _await_expression();
    }
    if (is3("operator") && UNARY_PREFIX.has(start.value)) {
      next();
      handle_regexp();
      var ex = make_unary(AST_UnaryPrefix, start, maybe_unary(allow_calls));
      ex.start = start;
      ex.end = prev();
      return ex;
    }
    var val2 = expr_atom(allow_calls, allow_arrows);
    while (is3("operator") && UNARY_POSTFIX.has(S.token.value) && !has_newline_before(S.token)) {
      if (val2 instanceof AST_Arrow)
        unexpected();
      val2 = make_unary(AST_UnaryPostfix, S.token, val2);
      val2.start = start;
      val2.end = S.token;
      next();
    }
    return val2;
  };
  function make_unary(ctor, token, expr) {
    var op = token.value;
    switch (op) {
      case "++":
      case "--":
        if (!is_assignable(expr))
          croak("Invalid use of " + op + " operator", token.line, token.col, token.pos);
        break;
      case "delete":
        if (expr instanceof AST_SymbolRef && S.input.has_directive("use strict"))
          croak("Calling delete on expression not allowed in strict mode", expr.start.line, expr.start.col, expr.start.pos);
        break;
    }
    return new ctor({ operator: op, expression: expr });
  }
  var expr_op = function(left, min_prec, no_in) {
    var op = is3("operator") ? S.token.value : null;
    if (op == "in" && no_in)
      op = null;
    if (op == "**" && left instanceof AST_UnaryPrefix && !is_token(left.start, "punc", "(") && left.operator !== "--" && left.operator !== "++")
      unexpected(left.start);
    var prec = op != null ? PRECEDENCE[op] : null;
    if (prec != null && (prec > min_prec || op === "**" && min_prec === prec)) {
      next();
      var right = expr_ops(no_in, prec, true);
      return expr_op(new AST_Binary({
        start: left.start,
        left,
        operator: op,
        right,
        end: right.end
      }), min_prec, no_in);
    }
    return left;
  };
  function expr_ops(no_in, min_prec, allow_calls, allow_arrows) {
    if (!no_in && min_prec < PRECEDENCE["in"] && is3("privatename")) {
      if (!S.in_class) {
        croak("Private field must be used in an enclosing class");
      }
      const start = S.token;
      const key = new AST_SymbolPrivateProperty({
        start,
        name: start.value,
        end: start
      });
      next();
      expect_token("operator", "in");
      const private_in = new AST_PrivateIn({
        start,
        key,
        value: expr_ops(no_in, PRECEDENCE["in"], true),
        end: prev()
      });
      return expr_op(private_in, 0, no_in);
    } else {
      return expr_op(maybe_unary(allow_calls, allow_arrows), min_prec, no_in);
    }
  }
  var maybe_conditional = function(no_in) {
    var start = S.token;
    var expr = expr_ops(no_in, 0, true, true);
    if (is3("operator", "?")) {
      next();
      var yes = expression(false);
      expect(":");
      return new AST_Conditional({
        start,
        condition: expr,
        consequent: yes,
        alternative: expression(false, no_in),
        end: prev()
      });
    }
    return expr;
  };
  function is_assignable(expr) {
    return expr instanceof AST_PropAccess || expr instanceof AST_SymbolRef;
  }
  function to_destructuring(node) {
    if (node instanceof AST_Object) {
      node = new AST_Destructuring({
        start: node.start,
        names: node.properties.map(to_destructuring),
        is_array: false,
        end: node.end
      });
    } else if (node instanceof AST_Array) {
      var names = [];
      for (var i2 = 0;i2 < node.elements.length; i2++) {
        if (node.elements[i2] instanceof AST_Expansion) {
          if (i2 + 1 !== node.elements.length) {
            token_error(node.elements[i2].start, "Spread must the be last element in destructuring array");
          }
          node.elements[i2].expression = to_destructuring(node.elements[i2].expression);
        }
        names.push(to_destructuring(node.elements[i2]));
      }
      node = new AST_Destructuring({
        start: node.start,
        names,
        is_array: true,
        end: node.end
      });
    } else if (node instanceof AST_ObjectProperty) {
      node.value = to_destructuring(node.value);
    } else if (node instanceof AST_Assign) {
      node = new AST_DefaultAssign({
        start: node.start,
        left: node.left,
        operator: "=",
        right: node.right,
        end: node.end
      });
    }
    return node;
  }
  var maybe_assign = function(no_in) {
    handle_regexp();
    var start = S.token;
    if (start.type == "name" && start.value == "yield") {
      if (is_in_generator()) {
        next();
        return _yield_expression();
      } else if (S.input.has_directive("use strict")) {
        token_error(S.token, "Unexpected yield identifier inside strict mode");
      }
    }
    var left = maybe_conditional(no_in);
    var val2 = S.token.value;
    if (is3("operator") && ASSIGNMENT.has(val2)) {
      if (is_assignable(left) || (left = to_destructuring(left)) instanceof AST_Destructuring) {
        next();
        return new AST_Assign({
          start,
          left,
          operator: val2,
          right: maybe_assign(no_in),
          logical: LOGICAL_ASSIGNMENT.has(val2),
          end: prev()
        });
      }
      croak("Invalid assignment");
    }
    return left;
  };
  var to_expr_or_sequence = function(start, exprs) {
    if (exprs.length === 1) {
      return exprs[0];
    } else if (exprs.length > 1) {
      return new AST_Sequence({ start, expressions: exprs, end: peek() });
    } else {
      croak("Invalid parenthesized expression");
    }
  };
  var expression = function(commas, no_in) {
    var start = S.token;
    var exprs = [];
    while (true) {
      exprs.push(maybe_assign(no_in));
      if (!commas || !is3("punc", ","))
        break;
      next();
      commas = true;
    }
    return to_expr_or_sequence(start, exprs);
  };
  function in_loop(cont) {
    ++S.in_loop;
    var ret = cont();
    --S.in_loop;
    return ret;
  }
  if (options3.expression) {
    return expression(true);
  }
  return function parse_toplevel() {
    var start = S.token;
    var body = [];
    S.input.push_directives_stack();
    if (options3.module)
      S.input.add_directive("use strict");
    while (!is3("eof")) {
      body.push(statement());
    }
    S.input.pop_directives_stack();
    var end = prev();
    var toplevel = options3.toplevel;
    if (toplevel) {
      toplevel.body = toplevel.body.concat(body);
      toplevel.end = end;
    } else {
      toplevel = new AST_Toplevel({ start, body, end });
    }
    TEMPLATE_RAWS = new Map;
    return toplevel;
  }();
}
var LATEST_RAW = "";
var TEMPLATE_RAWS;
var KEYWORDS = "break case catch class const continue debugger default delete do else export extends finally for function if in instanceof let new return switch throw try typeof var void while with";
var KEYWORDS_ATOM = "false null true";
var RESERVED_WORDS;
var ALL_RESERVED_WORDS;
var KEYWORDS_BEFORE_EXPRESSION = "return new delete throw else case yield await";
var OPERATOR_CHARS;
var RE_NUM_LITERAL;
var RE_HEX_NUMBER;
var RE_OCT_NUMBER;
var RE_ES6_OCT_NUMBER;
var RE_BIN_NUMBER;
var RE_DEC_NUMBER;
var RE_BIG_INT;
var OPERATORS;
var WHITESPACE_CHARS;
var NEWLINE_CHARS;
var PUNC_AFTER_EXPRESSION;
var PUNC_BEFORE_EXPRESSION;
var PUNC_CHARS;
var UNICODE;
var BASIC_IDENT;
var JS_Parse_Error;
var EX_EOF;
var UNARY_PREFIX;
var UNARY_POSTFIX;
var ASSIGNMENT;
var LOGICAL_ASSIGNMENT;
var PRECEDENCE;
var ATOMIC_START_TOKEN;
var init_parse2 = __esm2(() => {
  init_utils5();
  init_ast();
  TEMPLATE_RAWS = new Map;
  RESERVED_WORDS = "enum import super this " + KEYWORDS_ATOM + " " + KEYWORDS;
  ALL_RESERVED_WORDS = "implements interface package private protected public static " + RESERVED_WORDS;
  KEYWORDS = makePredicate(KEYWORDS);
  RESERVED_WORDS = makePredicate(RESERVED_WORDS);
  KEYWORDS_BEFORE_EXPRESSION = makePredicate(KEYWORDS_BEFORE_EXPRESSION);
  KEYWORDS_ATOM = makePredicate(KEYWORDS_ATOM);
  ALL_RESERVED_WORDS = makePredicate(ALL_RESERVED_WORDS);
  OPERATOR_CHARS = makePredicate(characters("+-*&%=<>!?|~^"));
  RE_NUM_LITERAL = /[0-9a-f]/i;
  RE_HEX_NUMBER = /^0x[0-9a-f]+$/i;
  RE_OCT_NUMBER = /^0[0-7]+$/;
  RE_ES6_OCT_NUMBER = /^0o[0-7]+$/i;
  RE_BIN_NUMBER = /^0b[01]+$/i;
  RE_DEC_NUMBER = /^\d*\.?\d*(?:e[+-]?\d*(?:\d\.?|\.?\d)\d*)?$/i;
  RE_BIG_INT = /^(0[xob])?[0-9a-f]+n$/i;
  OPERATORS = makePredicate([
    "in",
    "instanceof",
    "typeof",
    "new",
    "void",
    "delete",
    "++",
    "--",
    "+",
    "-",
    "!",
    "~",
    "&",
    "|",
    "^",
    "*",
    "**",
    "/",
    "%",
    ">>",
    "<<",
    ">>>",
    "<",
    ">",
    "<=",
    ">=",
    "==",
    "===",
    "!=",
    "!==",
    "?",
    "=",
    "+=",
    "-=",
    "||=",
    "&&=",
    "??=",
    "/=",
    "*=",
    "**=",
    "%=",
    ">>=",
    "<<=",
    ">>>=",
    "|=",
    "^=",
    "&=",
    "&&",
    "??",
    "||"
  ]);
  WHITESPACE_CHARS = makePredicate(characters(` \xA0
\r	\u200B\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF`));
  NEWLINE_CHARS = makePredicate(characters(`
\r\u2028\u2029`));
  PUNC_AFTER_EXPRESSION = makePredicate(characters(";]),:"));
  PUNC_BEFORE_EXPRESSION = makePredicate(characters("[{(,;:"));
  PUNC_CHARS = makePredicate(characters("[]{}(),;:"));
  UNICODE = {
    ID_Start: /[$A-Z_a-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,
    ID_Continue: /(?:[$0-9A-Z_a-z\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFC-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C4\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF])+/
  };
  BASIC_IDENT = /^[a-z_$][a-z0-9_$]*$/i;
  JS_Parse_Error = class JS_Parse_Error2 extends Error {
    constructor(message, filename2, line, col, pos) {
      super();
      this.name = "SyntaxError";
      this.message = message;
      this.filename = filename2;
      this.line = line;
      this.col = col;
      this.pos = pos;
    }
  };
  EX_EOF = {};
  UNARY_PREFIX = makePredicate([
    "typeof",
    "void",
    "delete",
    "--",
    "++",
    "!",
    "~",
    "-",
    "+"
  ]);
  UNARY_POSTFIX = makePredicate(["--", "++"]);
  ASSIGNMENT = makePredicate(["=", "+=", "-=", "??=", "&&=", "||=", "/=", "*=", "**=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&="]);
  LOGICAL_ASSIGNMENT = makePredicate(["??=", "&&=", "||="]);
  PRECEDENCE = function(a, ret) {
    for (var i2 = 0;i2 < a.length; ++i2) {
      for (const op of a[i2]) {
        ret[op] = i2 + 1;
      }
    }
    return ret;
  }([
    ["||"],
    ["??"],
    ["&&"],
    ["|"],
    ["^"],
    ["&"],
    ["==", "===", "!=", "!=="],
    ["<", ">", "<=", ">=", "in", "instanceof"],
    [">>", "<<", ">>>"],
    ["+", "-"],
    ["*", "/", "%"],
    ["**"]
  ], {});
  ATOMIC_START_TOKEN = makePredicate(["atom", "num", "big_int", "string", "regexp", "name"]);
});
function DEFNODE(type, props, ctor, methods, base2 = AST_Node) {
  if (!props)
    props = [];
  else
    props = props.split(/\s+/);
  var self_props = props;
  if (base2 && base2.PROPS)
    props = props.concat(base2.PROPS);
  const proto2 = base2 && Object.create(base2.prototype);
  if (proto2) {
    ctor.prototype = proto2;
    ctor.BASE = base2;
  }
  if (base2)
    base2.SUBCLASSES.push(ctor);
  ctor.prototype.CTOR = ctor;
  ctor.prototype.constructor = ctor;
  ctor.PROPS = props || null;
  ctor.SELF_PROPS = self_props;
  ctor.SUBCLASSES = [];
  if (type) {
    ctor.prototype.TYPE = ctor.TYPE = type;
  }
  if (methods) {
    for (let i2 in methods)
      if (HOP(methods, i2)) {
        if (i2[0] === "$") {
          ctor[i2.substr(1)] = methods[i2];
        } else {
          ctor.prototype[i2] = methods[i2];
        }
      }
  }
  ctor.DEFMETHOD = function(name, method) {
    this.prototype[name] = method;
  };
  return ctor;
}
function walk_body(node, visitor) {
  const body = node.body;
  for (var i2 = 0, len = body.length;i2 < len; i2++) {
    body[i2]._walk(visitor);
  }
}
function clone_block_scope(deep) {
  var clone3 = this._clone(deep);
  if (this.block_scope) {
    clone3.block_scope = this.block_scope.clone();
  }
  return clone3;
}
function walk2(node, cb, to_visit = [node]) {
  const push2 = to_visit.push.bind(to_visit);
  while (to_visit.length) {
    const node2 = to_visit.pop();
    const ret = cb(node2, to_visit);
    if (ret) {
      if (ret === walk_abort)
        return true;
      continue;
    }
    node2._children_backwards(push2);
  }
  return false;
}
function walk_parent(node, cb, initial_stack) {
  const to_visit = [node];
  const push2 = to_visit.push.bind(to_visit);
  const stack = initial_stack ? initial_stack.slice() : [];
  const parent_pop_indices = [];
  let current2;
  const info = {
    parent: (n = 0) => {
      if (n === -1) {
        return current2;
      }
      if (initial_stack && n >= stack.length) {
        n -= stack.length;
        return initial_stack[initial_stack.length - (n + 1)];
      }
      return stack[stack.length - (1 + n)];
    }
  };
  while (to_visit.length) {
    current2 = to_visit.pop();
    while (parent_pop_indices.length && to_visit.length == parent_pop_indices[parent_pop_indices.length - 1]) {
      stack.pop();
      parent_pop_indices.pop();
    }
    const ret = cb(current2, info);
    if (ret) {
      if (ret === walk_abort)
        return true;
      continue;
    }
    const visit_length = to_visit.length;
    current2._children_backwards(push2);
    if (to_visit.length > visit_length) {
      stack.push(current2);
      parent_pop_indices.push(visit_length - 1);
    }
  }
  return false;
}

class TreeWalker {
  constructor(callback) {
    this.visit = callback;
    this.stack = [];
    this.directives = Object.create(null);
  }
  _visit(node, descend) {
    this.push(node);
    var ret = this.visit(node, descend ? function() {
      descend.call(node);
    } : noop);
    if (!ret && descend) {
      descend.call(node);
    }
    this.pop();
    return ret;
  }
  parent(n) {
    return this.stack[this.stack.length - 2 - (n || 0)];
  }
  push(node) {
    if (node instanceof AST_Lambda) {
      this.directives = Object.create(this.directives);
    } else if (node instanceof AST_Directive && !this.directives[node.value]) {
      this.directives[node.value] = node;
    } else if (node instanceof AST_Class) {
      this.directives = Object.create(this.directives);
      if (!this.directives["use strict"]) {
        this.directives["use strict"] = node;
      }
    }
    this.stack.push(node);
  }
  pop() {
    var node = this.stack.pop();
    if (node instanceof AST_Lambda || node instanceof AST_Class) {
      this.directives = Object.getPrototypeOf(this.directives);
    }
  }
  self() {
    return this.stack[this.stack.length - 1];
  }
  find_parent(type) {
    var stack = this.stack;
    for (var i2 = stack.length;--i2 >= 0; ) {
      var x = stack[i2];
      if (x instanceof type)
        return x;
    }
  }
  find_scope() {
    var stack = this.stack;
    for (var i2 = stack.length;--i2 >= 0; ) {
      const p32 = stack[i2];
      if (p32 instanceof AST_Toplevel)
        return p32;
      if (p32 instanceof AST_Lambda)
        return p32;
      if (p32.block_scope)
        return p32.block_scope;
    }
  }
  has_directive(type) {
    var dir = this.directives[type];
    if (dir)
      return dir;
    var node = this.stack[this.stack.length - 1];
    if (node instanceof AST_Scope && node.body) {
      for (var i2 = 0;i2 < node.body.length; ++i2) {
        var st = node.body[i2];
        if (!(st instanceof AST_Directive))
          break;
        if (st.value == type)
          return st;
      }
    }
  }
  loopcontrol_target(node) {
    var stack = this.stack;
    if (node.label)
      for (var i2 = stack.length;--i2 >= 0; ) {
        var x = stack[i2];
        if (x instanceof AST_LabeledStatement && x.label.name == node.label.name)
          return x.body;
      }
    else
      for (var i2 = stack.length;--i2 >= 0; ) {
        var x = stack[i2];
        if (x instanceof AST_IterationStatement || node instanceof AST_Break && x instanceof AST_Switch)
          return x;
      }
  }
}
var has_tok_flag = (tok, flag) => Boolean(tok.flags & flag);
var set_tok_flag = (tok, flag, truth) => {
  if (truth) {
    tok.flags |= flag;
  } else {
    tok.flags &= ~flag;
  }
};
var TOK_FLAG_NLB = 1;
var TOK_FLAG_QUOTE_SINGLE = 2;
var TOK_FLAG_QUOTE_EXISTS = 4;
var TOK_FLAG_TEMPLATE_END = 8;
var AST_Token;
var AST_Node;
var AST_Statement;
var AST_Debugger;
var AST_Directive;
var AST_SimpleStatement;
var AST_Block;
var AST_BlockStatement;
var AST_EmptyStatement;
var AST_StatementWithBody;
var AST_LabeledStatement;
var AST_IterationStatement;
var AST_DWLoop;
var AST_Do;
var AST_While;
var AST_For;
var AST_ForIn;
var AST_ForOf;
var AST_With;
var AST_Scope;
var AST_Toplevel;
var AST_Expansion;
var AST_Lambda;
var AST_Accessor;
var AST_Function;
var AST_Arrow;
var AST_Defun;
var AST_Destructuring;
var AST_PrefixedTemplateString;
var AST_TemplateString;
var AST_TemplateSegment;
var AST_Jump;
var AST_Exit;
var AST_Return;
var AST_Throw;
var AST_LoopControl;
var AST_Break;
var AST_Continue;
var AST_Await;
var AST_Yield;
var AST_If;
var AST_Switch;
var AST_SwitchBranch;
var AST_Default;
var AST_Case;
var AST_Try;
var AST_TryBlock;
var AST_Catch;
var AST_Finally;
var AST_Definitions;
var AST_Var;
var AST_Let;
var AST_Const;
var AST_VarDef;
var AST_NameMapping;
var AST_Import;
var AST_ImportMeta;
var AST_Export;
var AST_Call;
var AST_New;
var AST_Sequence;
var AST_PropAccess;
var AST_Dot;
var AST_DotHash;
var AST_Sub;
var AST_Chain;
var AST_Unary;
var AST_UnaryPrefix;
var AST_UnaryPostfix;
var AST_Binary;
var AST_Conditional;
var AST_Assign;
var AST_DefaultAssign;
var AST_Array;
var AST_Object;
var AST_ObjectProperty;
var AST_ObjectKeyVal;
var AST_PrivateSetter;
var AST_PrivateGetter;
var AST_ObjectSetter;
var AST_ObjectGetter;
var AST_ConciseMethod;
var AST_PrivateMethod;
var AST_Class;
var AST_ClassProperty;
var AST_ClassPrivateProperty;
var AST_PrivateIn;
var AST_DefClass;
var AST_ClassStaticBlock;
var AST_ClassExpression;
var AST_Symbol;
var AST_NewTarget;
var AST_SymbolDeclaration;
var AST_SymbolVar;
var AST_SymbolBlockDeclaration;
var AST_SymbolConst;
var AST_SymbolLet;
var AST_SymbolFunarg;
var AST_SymbolDefun;
var AST_SymbolMethod;
var AST_SymbolClassProperty;
var AST_SymbolLambda;
var AST_SymbolDefClass;
var AST_SymbolClass;
var AST_SymbolCatch;
var AST_SymbolImport;
var AST_SymbolImportForeign;
var AST_Label;
var AST_SymbolRef;
var AST_SymbolExport;
var AST_SymbolExportForeign;
var AST_LabelRef;
var AST_SymbolPrivateProperty;
var AST_This;
var AST_Super;
var AST_Constant;
var AST_String;
var AST_Number;
var AST_BigInt;
var AST_RegExp;
var AST_Atom;
var AST_Null;
var AST_NaN;
var AST_Undefined;
var AST_Hole;
var AST_Infinity;
var AST_Boolean;
var AST_False;
var AST_True;
var walk_abort;
var TreeTransformer;
var _PURE = 1;
var _INLINE = 2;
var _NOINLINE = 4;
var _KEY = 8;
var _MANGLEPROP = 16;
var init_ast = __esm2(() => {
  init_utils5();
  init_parse2();
  AST_Token = class AST_Token2 {
    constructor(type, value, line, col, pos, nlb, comments_before, comments_after, file) {
      this.flags = nlb ? 1 : 0;
      this.type = type;
      this.value = value;
      this.line = line;
      this.col = col;
      this.pos = pos;
      this.comments_before = comments_before;
      this.comments_after = comments_after;
      this.file = file;
      Object.seal(this);
    }
    [Symbol.for("nodejs.util.inspect.custom")](_depth, options3) {
      const special = (str) => options3.stylize(str, "special");
      const quote = typeof this.value === "string" && this.value.includes("`") ? "'" : "`";
      const value = `${quote}${this.value}${quote}`;
      return `${special("[AST_Token")} ${value} at ${this.line}:${this.col}${special("]")}`;
    }
    get nlb() {
      return has_tok_flag(this, TOK_FLAG_NLB);
    }
    set nlb(new_nlb) {
      set_tok_flag(this, TOK_FLAG_NLB, new_nlb);
    }
    get quote() {
      return !has_tok_flag(this, TOK_FLAG_QUOTE_EXISTS) ? "" : has_tok_flag(this, TOK_FLAG_QUOTE_SINGLE) ? "'" : '"';
    }
    set quote(quote_type) {
      set_tok_flag(this, TOK_FLAG_QUOTE_SINGLE, quote_type === "'");
      set_tok_flag(this, TOK_FLAG_QUOTE_EXISTS, !!quote_type);
    }
    get template_end() {
      return has_tok_flag(this, TOK_FLAG_TEMPLATE_END);
    }
    set template_end(new_template_end) {
      set_tok_flag(this, TOK_FLAG_TEMPLATE_END, new_template_end);
    }
  };
  AST_Node = DEFNODE("Node", "start end", function AST_Node2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    _clone: function(deep) {
      if (deep) {
        var self2 = this.clone();
        return self2.transform(new TreeTransformer(function(node) {
          if (node !== self2) {
            return node.clone(true);
          }
        }));
      }
      return new this.CTOR(this);
    },
    clone: function(deep) {
      return this._clone(deep);
    },
    $documentation: "Base class of all AST nodes",
    $propdoc: {
      start: "[AST_Token] The first token of this node",
      end: "[AST_Token] The last token of this node"
    },
    _walk: function(visitor) {
      return visitor._visit(this);
    },
    walk: function(visitor) {
      return this._walk(visitor);
    },
    _children_backwards: () => {
    }
  }, null);
  AST_Statement = DEFNODE("Statement", null, function AST_Statement2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class of all statements"
  });
  AST_Debugger = DEFNODE("Debugger", null, function AST_Debugger2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Represents a debugger statement"
  }, AST_Statement);
  AST_Directive = DEFNODE("Directive", "value quote", function AST_Directive2(props) {
    if (props) {
      this.value = props.value;
      this.quote = props.quote;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Represents a directive, like \"use strict\";",
    $propdoc: {
      value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
      quote: "[string] the original quote character"
    }
  }, AST_Statement);
  AST_SimpleStatement = DEFNODE("SimpleStatement", "body", function AST_SimpleStatement2(props) {
    if (props) {
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
    $propdoc: {
      body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.body._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.body);
    }
  }, AST_Statement);
  AST_Block = DEFNODE("Block", "body block_scope", function AST_Block2(props) {
    if (props) {
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A body of statements (usually braced)",
    $propdoc: {
      body: "[AST_Statement*] an array of statements",
      block_scope: "[AST_Scope] the block scope"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        walk_body(this, visitor);
      });
    },
    _children_backwards(push2) {
      let i2 = this.body.length;
      while (i2--)
        push2(this.body[i2]);
    },
    clone: clone_block_scope
  }, AST_Statement);
  AST_BlockStatement = DEFNODE("BlockStatement", null, function AST_BlockStatement2(props) {
    if (props) {
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A block statement"
  }, AST_Block);
  AST_EmptyStatement = DEFNODE("EmptyStatement", null, function AST_EmptyStatement2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The empty statement (empty block or simply a semicolon)"
  }, AST_Statement);
  AST_StatementWithBody = DEFNODE("StatementWithBody", "body", function AST_StatementWithBody2(props) {
    if (props) {
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
    $propdoc: {
      body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
    }
  }, AST_Statement);
  AST_LabeledStatement = DEFNODE("LabeledStatement", "label", function AST_LabeledStatement2(props) {
    if (props) {
      this.label = props.label;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Statement with a label",
    $propdoc: {
      label: "[AST_Label] a label definition"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.label._walk(visitor);
        this.body._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.body);
      push2(this.label);
    },
    clone: function(deep) {
      var node = this._clone(deep);
      if (deep) {
        var label = node.label;
        var def = this.label;
        node.walk(new TreeWalker(function(node2) {
          if (node2 instanceof AST_LoopControl && node2.label && node2.label.thedef === def) {
            node2.label.thedef = label;
            label.references.push(node2);
          }
        }));
      }
      return node;
    }
  }, AST_StatementWithBody);
  AST_IterationStatement = DEFNODE("IterationStatement", "block_scope", function AST_IterationStatement2(props) {
    if (props) {
      this.block_scope = props.block_scope;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Internal class.  All loops inherit from it.",
    $propdoc: {
      block_scope: "[AST_Scope] the block scope for this iteration statement."
    },
    clone: clone_block_scope
  }, AST_StatementWithBody);
  AST_DWLoop = DEFNODE("DWLoop", "condition", function AST_DWLoop2(props) {
    if (props) {
      this.condition = props.condition;
      this.block_scope = props.block_scope;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for do/while statements",
    $propdoc: {
      condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
    }
  }, AST_IterationStatement);
  AST_Do = DEFNODE("Do", null, function AST_Do2(props) {
    if (props) {
      this.condition = props.condition;
      this.block_scope = props.block_scope;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `do` statement",
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.body._walk(visitor);
        this.condition._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.condition);
      push2(this.body);
    }
  }, AST_DWLoop);
  AST_While = DEFNODE("While", null, function AST_While2(props) {
    if (props) {
      this.condition = props.condition;
      this.block_scope = props.block_scope;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `while` statement",
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.condition._walk(visitor);
        this.body._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.body);
      push2(this.condition);
    }
  }, AST_DWLoop);
  AST_For = DEFNODE("For", "init condition step", function AST_For2(props) {
    if (props) {
      this.init = props.init;
      this.condition = props.condition;
      this.step = props.step;
      this.block_scope = props.block_scope;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `for` statement",
    $propdoc: {
      init: "[AST_Node?] the `for` initialization code, or null if empty",
      condition: "[AST_Node?] the `for` termination clause, or null if empty",
      step: "[AST_Node?] the `for` update clause, or null if empty"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.init)
          this.init._walk(visitor);
        if (this.condition)
          this.condition._walk(visitor);
        if (this.step)
          this.step._walk(visitor);
        this.body._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.body);
      if (this.step)
        push2(this.step);
      if (this.condition)
        push2(this.condition);
      if (this.init)
        push2(this.init);
    }
  }, AST_IterationStatement);
  AST_ForIn = DEFNODE("ForIn", "init object", function AST_ForIn2(props) {
    if (props) {
      this.init = props.init;
      this.object = props.object;
      this.block_scope = props.block_scope;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `for ... in` statement",
    $propdoc: {
      init: "[AST_Node] the `for/in` initialization code",
      object: "[AST_Node] the object that we're looping through"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.init._walk(visitor);
        this.object._walk(visitor);
        this.body._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.body);
      if (this.object)
        push2(this.object);
      if (this.init)
        push2(this.init);
    }
  }, AST_IterationStatement);
  AST_ForOf = DEFNODE("ForOf", "await", function AST_ForOf2(props) {
    if (props) {
      this.await = props.await;
      this.init = props.init;
      this.object = props.object;
      this.block_scope = props.block_scope;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `for ... of` statement"
  }, AST_ForIn);
  AST_With = DEFNODE("With", "expression", function AST_With2(props) {
    if (props) {
      this.expression = props.expression;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `with` statement",
    $propdoc: {
      expression: "[AST_Node] the `with` expression"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
        this.body._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.body);
      push2(this.expression);
    }
  }, AST_StatementWithBody);
  AST_Scope = DEFNODE("Scope", "variables uses_with uses_eval parent_scope enclosed cname", function AST_Scope2(props) {
    if (props) {
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for all statements introducing a lexical scope",
    $propdoc: {
      variables: "[Map/S] a map of name -> SymbolDef for all variables/functions defined in this scope",
      uses_with: "[boolean/S] tells whether this scope uses the `with` statement",
      uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
      parent_scope: "[AST_Scope?/S] link to the parent scope",
      enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
      cname: "[integer/S] current index for mangling variables (used internally by the mangler)"
    },
    get_defun_scope: function() {
      var self2 = this;
      while (self2.is_block_scope()) {
        self2 = self2.parent_scope;
      }
      return self2;
    },
    clone: function(deep, toplevel) {
      var node = this._clone(deep);
      if (deep && this.variables && toplevel && !this._block_scope) {
        node.figure_out_scope({}, {
          toplevel,
          parent_scope: this.parent_scope
        });
      } else {
        if (this.variables)
          node.variables = new Map(this.variables);
        if (this.enclosed)
          node.enclosed = this.enclosed.slice();
        if (this._block_scope)
          node._block_scope = this._block_scope;
      }
      return node;
    },
    pinned: function() {
      return this.uses_eval || this.uses_with;
    }
  }, AST_Block);
  AST_Toplevel = DEFNODE("Toplevel", "globals", function AST_Toplevel2(props) {
    if (props) {
      this.globals = props.globals;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The toplevel scope",
    $propdoc: {
      globals: "[Map/S] a map of name -> SymbolDef for all undeclared names"
    },
    wrap_commonjs: function(name) {
      var body = this.body;
      var wrapped_tl = "(function(exports){'$ORIG';})(typeof " + name + "=='undefined'?(" + name + "={}):" + name + ");";
      wrapped_tl = parse5(wrapped_tl);
      wrapped_tl = wrapped_tl.transform(new TreeTransformer(function(node) {
        if (node instanceof AST_Directive && node.value == "$ORIG") {
          return MAP.splice(body);
        }
      }));
      return wrapped_tl;
    },
    wrap_enclose: function(args_values) {
      if (typeof args_values != "string")
        args_values = "";
      var index = args_values.indexOf(":");
      if (index < 0)
        index = args_values.length;
      var body = this.body;
      return parse5([
        "(function(",
        args_values.slice(0, index),
        '){"$ORIG"})(',
        args_values.slice(index + 1),
        ")"
      ].join("")).transform(new TreeTransformer(function(node) {
        if (node instanceof AST_Directive && node.value == "$ORIG") {
          return MAP.splice(body);
        }
      }));
    }
  }, AST_Scope);
  AST_Expansion = DEFNODE("Expansion", "expression", function AST_Expansion2(props) {
    if (props) {
      this.expression = props.expression;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An expandible argument, such as ...rest, a splat, such as [1,2,...all], or an expansion in a variable declaration, such as var [first, ...rest] = list",
    $propdoc: {
      expression: "[AST_Node] the thing to be expanded"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression.walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.expression);
    }
  });
  AST_Lambda = DEFNODE("Lambda", "name argnames uses_arguments is_generator async", function AST_Lambda2(props) {
    if (props) {
      this.name = props.name;
      this.argnames = props.argnames;
      this.uses_arguments = props.uses_arguments;
      this.is_generator = props.is_generator;
      this.async = props.async;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for functions",
    $propdoc: {
      name: "[AST_SymbolDeclaration?] the name of this function",
      argnames: "[AST_SymbolFunarg|AST_Destructuring|AST_Expansion|AST_DefaultAssign*] array of function arguments, destructurings, or expanding arguments",
      uses_arguments: "[boolean/S] tells whether this function accesses the arguments array",
      is_generator: "[boolean] is this a generator method",
      async: "[boolean] is this method async"
    },
    args_as_names: function() {
      var out = [];
      for (var i2 = 0;i2 < this.argnames.length; i2++) {
        if (this.argnames[i2] instanceof AST_Destructuring) {
          out.push(...this.argnames[i2].all_symbols());
        } else {
          out.push(this.argnames[i2]);
        }
      }
      return out;
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.name)
          this.name._walk(visitor);
        var argnames = this.argnames;
        for (var i2 = 0, len = argnames.length;i2 < len; i2++) {
          argnames[i2]._walk(visitor);
        }
        walk_body(this, visitor);
      });
    },
    _children_backwards(push2) {
      let i2 = this.body.length;
      while (i2--)
        push2(this.body[i2]);
      i2 = this.argnames.length;
      while (i2--)
        push2(this.argnames[i2]);
      if (this.name)
        push2(this.name);
    },
    is_braceless() {
      return this.body[0] instanceof AST_Return && this.body[0].value;
    },
    length_property() {
      let length = 0;
      for (const arg of this.argnames) {
        if (arg instanceof AST_SymbolFunarg || arg instanceof AST_Destructuring) {
          length++;
        }
      }
      return length;
    }
  }, AST_Scope);
  AST_Accessor = DEFNODE("Accessor", null, function AST_Accessor2(props) {
    if (props) {
      this.name = props.name;
      this.argnames = props.argnames;
      this.uses_arguments = props.uses_arguments;
      this.is_generator = props.is_generator;
      this.async = props.async;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A setter/getter function.  The `name` property is always null."
  }, AST_Lambda);
  AST_Function = DEFNODE("Function", null, function AST_Function2(props) {
    if (props) {
      this.name = props.name;
      this.argnames = props.argnames;
      this.uses_arguments = props.uses_arguments;
      this.is_generator = props.is_generator;
      this.async = props.async;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A function expression"
  }, AST_Lambda);
  AST_Arrow = DEFNODE("Arrow", null, function AST_Arrow2(props) {
    if (props) {
      this.name = props.name;
      this.argnames = props.argnames;
      this.uses_arguments = props.uses_arguments;
      this.is_generator = props.is_generator;
      this.async = props.async;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An ES6 Arrow function ((a) => b)"
  }, AST_Lambda);
  AST_Defun = DEFNODE("Defun", null, function AST_Defun2(props) {
    if (props) {
      this.name = props.name;
      this.argnames = props.argnames;
      this.uses_arguments = props.uses_arguments;
      this.is_generator = props.is_generator;
      this.async = props.async;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A function definition"
  }, AST_Lambda);
  AST_Destructuring = DEFNODE("Destructuring", "names is_array", function AST_Destructuring2(props) {
    if (props) {
      this.names = props.names;
      this.is_array = props.is_array;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A destructuring of several names. Used in destructuring assignment and with destructuring function argument names",
    $propdoc: {
      names: "[AST_Node*] Array of properties or elements",
      is_array: "[Boolean] Whether the destructuring represents an object or array"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.names.forEach(function(name) {
          name._walk(visitor);
        });
      });
    },
    _children_backwards(push2) {
      let i2 = this.names.length;
      while (i2--)
        push2(this.names[i2]);
    },
    all_symbols: function() {
      var out = [];
      walk2(this, (node) => {
        if (node instanceof AST_SymbolDeclaration) {
          out.push(node);
        }
        if (node instanceof AST_Lambda) {
          return true;
        }
      });
      return out;
    }
  });
  AST_PrefixedTemplateString = DEFNODE("PrefixedTemplateString", "template_string prefix", function AST_PrefixedTemplateString2(props) {
    if (props) {
      this.template_string = props.template_string;
      this.prefix = props.prefix;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A templatestring with a prefix, such as String.raw`foobarbaz`",
    $propdoc: {
      template_string: "[AST_TemplateString] The template string",
      prefix: "[AST_Node] The prefix, which will get called."
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.prefix._walk(visitor);
        this.template_string._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.template_string);
      push2(this.prefix);
    }
  });
  AST_TemplateString = DEFNODE("TemplateString", "segments", function AST_TemplateString2(props) {
    if (props) {
      this.segments = props.segments;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A template string literal",
    $propdoc: {
      segments: "[AST_Node*] One or more segments, starting with AST_TemplateSegment. AST_Node may follow AST_TemplateSegment, but each AST_Node must be followed by AST_TemplateSegment."
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.segments.forEach(function(seg) {
          seg._walk(visitor);
        });
      });
    },
    _children_backwards(push2) {
      let i2 = this.segments.length;
      while (i2--)
        push2(this.segments[i2]);
    }
  });
  AST_TemplateSegment = DEFNODE("TemplateSegment", "value raw", function AST_TemplateSegment2(props) {
    if (props) {
      this.value = props.value;
      this.raw = props.raw;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A segment of a template string literal",
    $propdoc: {
      value: "Content of the segment",
      raw: "Raw source of the segment"
    }
  });
  AST_Jump = DEFNODE("Jump", null, function AST_Jump2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for \u201Cjumps\u201D (for now that's `return`, `throw`, `break` and `continue`)"
  }, AST_Statement);
  AST_Exit = DEFNODE("Exit", "value", function AST_Exit2(props) {
    if (props) {
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for \u201Cexits\u201D (`return` and `throw`)",
    $propdoc: {
      value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
    },
    _walk: function(visitor) {
      return visitor._visit(this, this.value && function() {
        this.value._walk(visitor);
      });
    },
    _children_backwards(push2) {
      if (this.value)
        push2(this.value);
    }
  }, AST_Jump);
  AST_Return = DEFNODE("Return", null, function AST_Return2(props) {
    if (props) {
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `return` statement"
  }, AST_Exit);
  AST_Throw = DEFNODE("Throw", null, function AST_Throw2(props) {
    if (props) {
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `throw` statement"
  }, AST_Exit);
  AST_LoopControl = DEFNODE("LoopControl", "label", function AST_LoopControl2(props) {
    if (props) {
      this.label = props.label;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for loop control statements (`break` and `continue`)",
    $propdoc: {
      label: "[AST_LabelRef?] the label, or null if none"
    },
    _walk: function(visitor) {
      return visitor._visit(this, this.label && function() {
        this.label._walk(visitor);
      });
    },
    _children_backwards(push2) {
      if (this.label)
        push2(this.label);
    }
  }, AST_Jump);
  AST_Break = DEFNODE("Break", null, function AST_Break2(props) {
    if (props) {
      this.label = props.label;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `break` statement"
  }, AST_LoopControl);
  AST_Continue = DEFNODE("Continue", null, function AST_Continue2(props) {
    if (props) {
      this.label = props.label;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `continue` statement"
  }, AST_LoopControl);
  AST_Await = DEFNODE("Await", "expression", function AST_Await2(props) {
    if (props) {
      this.expression = props.expression;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An `await` statement",
    $propdoc: {
      expression: "[AST_Node] the mandatory expression being awaited"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.expression);
    }
  });
  AST_Yield = DEFNODE("Yield", "expression is_star", function AST_Yield2(props) {
    if (props) {
      this.expression = props.expression;
      this.is_star = props.is_star;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `yield` statement",
    $propdoc: {
      expression: "[AST_Node?] the value returned or thrown by this statement; could be null (representing undefined) but only when is_star is set to false",
      is_star: "[Boolean] Whether this is a yield or yield* statement"
    },
    _walk: function(visitor) {
      return visitor._visit(this, this.expression && function() {
        this.expression._walk(visitor);
      });
    },
    _children_backwards(push2) {
      if (this.expression)
        push2(this.expression);
    }
  });
  AST_If = DEFNODE("If", "condition alternative", function AST_If2(props) {
    if (props) {
      this.condition = props.condition;
      this.alternative = props.alternative;
      this.body = props.body;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `if` statement",
    $propdoc: {
      condition: "[AST_Node] the `if` condition",
      alternative: "[AST_Statement?] the `else` part, or null if not present"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.condition._walk(visitor);
        this.body._walk(visitor);
        if (this.alternative)
          this.alternative._walk(visitor);
      });
    },
    _children_backwards(push2) {
      if (this.alternative) {
        push2(this.alternative);
      }
      push2(this.body);
      push2(this.condition);
    }
  }, AST_StatementWithBody);
  AST_Switch = DEFNODE("Switch", "expression", function AST_Switch2(props) {
    if (props) {
      this.expression = props.expression;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `switch` statement",
    $propdoc: {
      expression: "[AST_Node] the `switch` \u201Cdiscriminant\u201D"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
        walk_body(this, visitor);
      });
    },
    _children_backwards(push2) {
      let i2 = this.body.length;
      while (i2--)
        push2(this.body[i2]);
      push2(this.expression);
    }
  }, AST_Block);
  AST_SwitchBranch = DEFNODE("SwitchBranch", null, function AST_SwitchBranch2(props) {
    if (props) {
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for `switch` branches"
  }, AST_Block);
  AST_Default = DEFNODE("Default", null, function AST_Default2(props) {
    if (props) {
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `default` switch branch"
  }, AST_SwitchBranch);
  AST_Case = DEFNODE("Case", "expression", function AST_Case2(props) {
    if (props) {
      this.expression = props.expression;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `case` switch branch",
    $propdoc: {
      expression: "[AST_Node] the `case` expression"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
        walk_body(this, visitor);
      });
    },
    _children_backwards(push2) {
      let i2 = this.body.length;
      while (i2--)
        push2(this.body[i2]);
      push2(this.expression);
    }
  }, AST_SwitchBranch);
  AST_Try = DEFNODE("Try", "body bcatch bfinally", function AST_Try2(props) {
    if (props) {
      this.body = props.body;
      this.bcatch = props.bcatch;
      this.bfinally = props.bfinally;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `try` statement",
    $propdoc: {
      body: "[AST_TryBlock] the try block",
      bcatch: "[AST_Catch?] the catch block, or null if not present",
      bfinally: "[AST_Finally?] the finally block, or null if not present"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.body._walk(visitor);
        if (this.bcatch)
          this.bcatch._walk(visitor);
        if (this.bfinally)
          this.bfinally._walk(visitor);
      });
    },
    _children_backwards(push2) {
      if (this.bfinally)
        push2(this.bfinally);
      if (this.bcatch)
        push2(this.bcatch);
      push2(this.body);
    }
  }, AST_Statement);
  AST_TryBlock = DEFNODE("TryBlock", null, function AST_TryBlock2(props) {
    if (props) {
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `try` block of a try statement"
  }, AST_Block);
  AST_Catch = DEFNODE("Catch", "argname", function AST_Catch2(props) {
    if (props) {
      this.argname = props.argname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `catch` node; only makes sense as part of a `try` statement",
    $propdoc: {
      argname: "[AST_SymbolCatch|AST_Destructuring|AST_Expansion|AST_DefaultAssign] symbol for the exception"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.argname)
          this.argname._walk(visitor);
        walk_body(this, visitor);
      });
    },
    _children_backwards(push2) {
      let i2 = this.body.length;
      while (i2--)
        push2(this.body[i2]);
      if (this.argname)
        push2(this.argname);
    }
  }, AST_Block);
  AST_Finally = DEFNODE("Finally", null, function AST_Finally2(props) {
    if (props) {
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `finally` node; only makes sense as part of a `try` statement"
  }, AST_Block);
  AST_Definitions = DEFNODE("Definitions", "definitions", function AST_Definitions2(props) {
    if (props) {
      this.definitions = props.definitions;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for `var` or `const` nodes (variable declarations/initializations)",
    $propdoc: {
      definitions: "[AST_VarDef*] array of variable definitions"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        var definitions = this.definitions;
        for (var i2 = 0, len = definitions.length;i2 < len; i2++) {
          definitions[i2]._walk(visitor);
        }
      });
    },
    _children_backwards(push2) {
      let i2 = this.definitions.length;
      while (i2--)
        push2(this.definitions[i2]);
    }
  }, AST_Statement);
  AST_Var = DEFNODE("Var", null, function AST_Var2(props) {
    if (props) {
      this.definitions = props.definitions;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `var` statement"
  }, AST_Definitions);
  AST_Let = DEFNODE("Let", null, function AST_Let2(props) {
    if (props) {
      this.definitions = props.definitions;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `let` statement"
  }, AST_Definitions);
  AST_Const = DEFNODE("Const", null, function AST_Const2(props) {
    if (props) {
      this.definitions = props.definitions;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A `const` statement"
  }, AST_Definitions);
  AST_VarDef = DEFNODE("VarDef", "name value", function AST_VarDef2(props) {
    if (props) {
      this.name = props.name;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A variable declaration; only appears in a AST_Definitions node",
    $propdoc: {
      name: "[AST_Destructuring|AST_SymbolConst|AST_SymbolLet|AST_SymbolVar] name of the variable",
      value: "[AST_Node?] initializer, or null of there's no initializer"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.name._walk(visitor);
        if (this.value)
          this.value._walk(visitor);
      });
    },
    _children_backwards(push2) {
      if (this.value)
        push2(this.value);
      push2(this.name);
    },
    declarations_as_names() {
      if (this.name instanceof AST_SymbolDeclaration) {
        return [this];
      } else {
        return this.name.all_symbols();
      }
    }
  });
  AST_NameMapping = DEFNODE("NameMapping", "foreign_name name", function AST_NameMapping2(props) {
    if (props) {
      this.foreign_name = props.foreign_name;
      this.name = props.name;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The part of the export/import statement that declare names from a module.",
    $propdoc: {
      foreign_name: "[AST_SymbolExportForeign|AST_SymbolImportForeign] The name being exported/imported (as specified in the module)",
      name: "[AST_SymbolExport|AST_SymbolImport] The name as it is visible to this module."
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.foreign_name._walk(visitor);
        this.name._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.name);
      push2(this.foreign_name);
    }
  });
  AST_Import = DEFNODE("Import", "imported_name imported_names module_name attributes", function AST_Import2(props) {
    if (props) {
      this.imported_name = props.imported_name;
      this.imported_names = props.imported_names;
      this.module_name = props.module_name;
      this.attributes = props.attributes;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An `import` statement",
    $propdoc: {
      imported_name: "[AST_SymbolImport] The name of the variable holding the module's default export.",
      imported_names: "[AST_NameMapping*] The names of non-default imported variables",
      module_name: "[AST_String] String literal describing where this module came from",
      attributes: "[AST_Object?] The import attributes (with {...})"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.imported_name) {
          this.imported_name._walk(visitor);
        }
        if (this.imported_names) {
          this.imported_names.forEach(function(name_import) {
            name_import._walk(visitor);
          });
        }
        this.module_name._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.module_name);
      if (this.imported_names) {
        let i2 = this.imported_names.length;
        while (i2--)
          push2(this.imported_names[i2]);
      }
      if (this.imported_name)
        push2(this.imported_name);
    }
  });
  AST_ImportMeta = DEFNODE("ImportMeta", null, function AST_ImportMeta2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A reference to import.meta"
  });
  AST_Export = DEFNODE("Export", "exported_definition exported_value is_default exported_names module_name attributes", function AST_Export2(props) {
    if (props) {
      this.exported_definition = props.exported_definition;
      this.exported_value = props.exported_value;
      this.is_default = props.is_default;
      this.exported_names = props.exported_names;
      this.module_name = props.module_name;
      this.attributes = props.attributes;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An `export` statement",
    $propdoc: {
      exported_definition: "[AST_Defun|AST_Definitions|AST_DefClass?] An exported definition",
      exported_value: "[AST_Node?] An exported value",
      exported_names: "[AST_NameMapping*?] List of exported names",
      module_name: "[AST_String?] Name of the file to load exports from",
      is_default: "[Boolean] Whether this is the default exported value of this module",
      attributes: "[AST_Object?] The import attributes"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.exported_definition) {
          this.exported_definition._walk(visitor);
        }
        if (this.exported_value) {
          this.exported_value._walk(visitor);
        }
        if (this.exported_names) {
          this.exported_names.forEach(function(name_export) {
            name_export._walk(visitor);
          });
        }
        if (this.module_name) {
          this.module_name._walk(visitor);
        }
      });
    },
    _children_backwards(push2) {
      if (this.module_name)
        push2(this.module_name);
      if (this.exported_names) {
        let i2 = this.exported_names.length;
        while (i2--)
          push2(this.exported_names[i2]);
      }
      if (this.exported_value)
        push2(this.exported_value);
      if (this.exported_definition)
        push2(this.exported_definition);
    }
  }, AST_Statement);
  AST_Call = DEFNODE("Call", "expression args optional _annotations", function AST_Call2(props) {
    if (props) {
      this.expression = props.expression;
      this.args = props.args;
      this.optional = props.optional;
      this._annotations = props._annotations;
      this.start = props.start;
      this.end = props.end;
      this.initialize();
    }
    this.flags = 0;
  }, {
    $documentation: "A function call expression",
    $propdoc: {
      expression: "[AST_Node] expression to invoke as function",
      args: "[AST_Node*] array of arguments",
      optional: "[boolean] whether this is an optional call (IE ?.() )",
      _annotations: "[number] bitfield containing information about the call"
    },
    initialize() {
      if (this._annotations == null)
        this._annotations = 0;
    },
    _walk(visitor) {
      return visitor._visit(this, function() {
        var args = this.args;
        for (var i2 = 0, len = args.length;i2 < len; i2++) {
          args[i2]._walk(visitor);
        }
        this.expression._walk(visitor);
      });
    },
    _children_backwards(push2) {
      let i2 = this.args.length;
      while (i2--)
        push2(this.args[i2]);
      push2(this.expression);
    }
  });
  AST_New = DEFNODE("New", null, function AST_New2(props) {
    if (props) {
      this.expression = props.expression;
      this.args = props.args;
      this.optional = props.optional;
      this._annotations = props._annotations;
      this.start = props.start;
      this.end = props.end;
      this.initialize();
    }
    this.flags = 0;
  }, {
    $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
  }, AST_Call);
  AST_Sequence = DEFNODE("Sequence", "expressions", function AST_Sequence2(props) {
    if (props) {
      this.expressions = props.expressions;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A sequence expression (comma-separated expressions)",
    $propdoc: {
      expressions: "[AST_Node*] array of expressions (at least two)"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expressions.forEach(function(node) {
          node._walk(visitor);
        });
      });
    },
    _children_backwards(push2) {
      let i2 = this.expressions.length;
      while (i2--)
        push2(this.expressions[i2]);
    }
  });
  AST_PropAccess = DEFNODE("PropAccess", "expression property optional", function AST_PropAccess2(props) {
    if (props) {
      this.expression = props.expression;
      this.property = props.property;
      this.optional = props.optional;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for property access expressions, i.e. `a.foo` or `a[\"foo\"]`",
    $propdoc: {
      expression: "[AST_Node] the \u201Ccontainer\u201D expression",
      property: "[AST_Node|string] the property to access.  For AST_Dot & AST_DotHash this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",
      optional: "[boolean] whether this is an optional property access (IE ?.)"
    }
  });
  AST_Dot = DEFNODE("Dot", "quote", function AST_Dot2(props) {
    if (props) {
      this.quote = props.quote;
      this.expression = props.expression;
      this.property = props.property;
      this.optional = props.optional;
      this._annotations = props._annotations;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A dotted property access expression",
    $propdoc: {
      quote: "[string] the original quote character when transformed from AST_Sub"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.expression);
    }
  }, AST_PropAccess);
  AST_DotHash = DEFNODE("DotHash", "", function AST_DotHash2(props) {
    if (props) {
      this.expression = props.expression;
      this.property = props.property;
      this.optional = props.optional;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A dotted property access to a private property",
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.expression);
    }
  }, AST_PropAccess);
  AST_Sub = DEFNODE("Sub", null, function AST_Sub2(props) {
    if (props) {
      this.expression = props.expression;
      this.property = props.property;
      this.optional = props.optional;
      this._annotations = props._annotations;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Index-style property access, i.e. `a[\"foo\"]`",
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
        this.property._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.property);
      push2(this.expression);
    }
  }, AST_PropAccess);
  AST_Chain = DEFNODE("Chain", "expression", function AST_Chain2(props) {
    if (props) {
      this.expression = props.expression;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A chain expression like a?.b?.(c)?.[d]",
    $propdoc: {
      expression: "[AST_Call|AST_Dot|AST_DotHash|AST_Sub] chain element."
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.expression);
    }
  });
  AST_Unary = DEFNODE("Unary", "operator expression", function AST_Unary2(props) {
    if (props) {
      this.operator = props.operator;
      this.expression = props.expression;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for unary expressions",
    $propdoc: {
      operator: "[string] the operator",
      expression: "[AST_Node] expression that this unary operator applies to"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.expression._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.expression);
    }
  });
  AST_UnaryPrefix = DEFNODE("UnaryPrefix", null, function AST_UnaryPrefix2(props) {
    if (props) {
      this.operator = props.operator;
      this.expression = props.expression;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
  }, AST_Unary);
  AST_UnaryPostfix = DEFNODE("UnaryPostfix", null, function AST_UnaryPostfix2(props) {
    if (props) {
      this.operator = props.operator;
      this.expression = props.expression;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Unary postfix expression, i.e. `i++`"
  }, AST_Unary);
  AST_Binary = DEFNODE("Binary", "operator left right", function AST_Binary2(props) {
    if (props) {
      this.operator = props.operator;
      this.left = props.left;
      this.right = props.right;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Binary expression, i.e. `a + b`",
    $propdoc: {
      left: "[AST_Node] left-hand side expression",
      operator: "[string] the operator",
      right: "[AST_Node] right-hand side expression"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.left._walk(visitor);
        this.right._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.right);
      push2(this.left);
    }
  });
  AST_Conditional = DEFNODE("Conditional", "condition consequent alternative", function AST_Conditional2(props) {
    if (props) {
      this.condition = props.condition;
      this.consequent = props.consequent;
      this.alternative = props.alternative;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
    $propdoc: {
      condition: "[AST_Node]",
      consequent: "[AST_Node]",
      alternative: "[AST_Node]"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.condition._walk(visitor);
        this.consequent._walk(visitor);
        this.alternative._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.alternative);
      push2(this.consequent);
      push2(this.condition);
    }
  });
  AST_Assign = DEFNODE("Assign", "logical", function AST_Assign2(props) {
    if (props) {
      this.logical = props.logical;
      this.operator = props.operator;
      this.left = props.left;
      this.right = props.right;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An assignment expression \u2014 `a = b + 5`",
    $propdoc: {
      logical: "Whether it's a logical assignment"
    }
  }, AST_Binary);
  AST_DefaultAssign = DEFNODE("DefaultAssign", null, function AST_DefaultAssign2(props) {
    if (props) {
      this.operator = props.operator;
      this.left = props.left;
      this.right = props.right;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A default assignment expression like in `(a = 3) => a`"
  }, AST_Binary);
  AST_Array = DEFNODE("Array", "elements", function AST_Array2(props) {
    if (props) {
      this.elements = props.elements;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An array literal",
    $propdoc: {
      elements: "[AST_Node*] array of elements"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        var elements = this.elements;
        for (var i2 = 0, len = elements.length;i2 < len; i2++) {
          elements[i2]._walk(visitor);
        }
      });
    },
    _children_backwards(push2) {
      let i2 = this.elements.length;
      while (i2--)
        push2(this.elements[i2]);
    }
  });
  AST_Object = DEFNODE("Object", "properties", function AST_Object2(props) {
    if (props) {
      this.properties = props.properties;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An object literal",
    $propdoc: {
      properties: "[AST_ObjectProperty*] array of properties"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        var properties = this.properties;
        for (var i2 = 0, len = properties.length;i2 < len; i2++) {
          properties[i2]._walk(visitor);
        }
      });
    },
    _children_backwards(push2) {
      let i2 = this.properties.length;
      while (i2--)
        push2(this.properties[i2]);
    }
  });
  AST_ObjectProperty = DEFNODE("ObjectProperty", "key value", function AST_ObjectProperty2(props) {
    if (props) {
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
      this._annotations = props._annotations;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for literal object properties",
    $propdoc: {
      key: "[string|AST_Node] property name. For ObjectKeyVal this is a string. For getters, setters and computed property this is an AST_Node.",
      value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.key instanceof AST_Node)
          this.key._walk(visitor);
        this.value._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.value);
      if (this.key instanceof AST_Node)
        push2(this.key);
    }
  });
  AST_ObjectKeyVal = DEFNODE("ObjectKeyVal", "quote", function AST_ObjectKeyVal2(props) {
    if (props) {
      this.quote = props.quote;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
      this._annotations = props._annotations;
    }
    this.flags = 0;
  }, {
    $documentation: "A key: value object property",
    $propdoc: {
      quote: "[string] the original quote character"
    },
    computed_key() {
      return this.key instanceof AST_Node;
    }
  }, AST_ObjectProperty);
  AST_PrivateSetter = DEFNODE("PrivateSetter", "static", function AST_PrivateSetter2(props) {
    if (props) {
      this.static = props.static;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $propdoc: {
      static: "[boolean] whether this is a static private setter"
    },
    $documentation: "A private setter property",
    computed_key() {
      return false;
    }
  }, AST_ObjectProperty);
  AST_PrivateGetter = DEFNODE("PrivateGetter", "static", function AST_PrivateGetter2(props) {
    if (props) {
      this.static = props.static;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $propdoc: {
      static: "[boolean] whether this is a static private getter"
    },
    $documentation: "A private getter property",
    computed_key() {
      return false;
    }
  }, AST_ObjectProperty);
  AST_ObjectSetter = DEFNODE("ObjectSetter", "quote static", function AST_ObjectSetter2(props) {
    if (props) {
      this.quote = props.quote;
      this.static = props.static;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
      this._annotations = props._annotations;
    }
    this.flags = 0;
  }, {
    $propdoc: {
      quote: "[string|undefined] the original quote character, if any",
      static: "[boolean] whether this is a static setter (classes only)"
    },
    $documentation: "An object setter property",
    computed_key() {
      return !(this.key instanceof AST_SymbolMethod);
    }
  }, AST_ObjectProperty);
  AST_ObjectGetter = DEFNODE("ObjectGetter", "quote static", function AST_ObjectGetter2(props) {
    if (props) {
      this.quote = props.quote;
      this.static = props.static;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
      this._annotations = props._annotations;
    }
    this.flags = 0;
  }, {
    $propdoc: {
      quote: "[string|undefined] the original quote character, if any",
      static: "[boolean] whether this is a static getter (classes only)"
    },
    $documentation: "An object getter property",
    computed_key() {
      return !(this.key instanceof AST_SymbolMethod);
    }
  }, AST_ObjectProperty);
  AST_ConciseMethod = DEFNODE("ConciseMethod", "quote static is_generator async", function AST_ConciseMethod2(props) {
    if (props) {
      this.quote = props.quote;
      this.static = props.static;
      this.is_generator = props.is_generator;
      this.async = props.async;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
      this._annotations = props._annotations;
    }
    this.flags = 0;
  }, {
    $propdoc: {
      quote: "[string|undefined] the original quote character, if any",
      static: "[boolean] is this method static (classes only)",
      is_generator: "[boolean] is this a generator method",
      async: "[boolean] is this method async"
    },
    $documentation: "An ES6 concise method inside an object or class",
    computed_key() {
      return !(this.key instanceof AST_SymbolMethod);
    }
  }, AST_ObjectProperty);
  AST_PrivateMethod = DEFNODE("PrivateMethod", "", function AST_PrivateMethod2(props) {
    if (props) {
      this.quote = props.quote;
      this.static = props.static;
      this.is_generator = props.is_generator;
      this.async = props.async;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A private class method inside a class"
  }, AST_ConciseMethod);
  AST_Class = DEFNODE("Class", "name extends properties", function AST_Class2(props) {
    if (props) {
      this.name = props.name;
      this.extends = props.extends;
      this.properties = props.properties;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $propdoc: {
      name: "[AST_SymbolClass|AST_SymbolDefClass?] optional class name.",
      extends: "[AST_Node]? optional parent class",
      properties: "[AST_ObjectProperty*] array of properties"
    },
    $documentation: "An ES6 class",
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.name) {
          this.name._walk(visitor);
        }
        if (this.extends) {
          this.extends._walk(visitor);
        }
        this.properties.forEach((prop) => prop._walk(visitor));
      });
    },
    _children_backwards(push2) {
      let i2 = this.properties.length;
      while (i2--)
        push2(this.properties[i2]);
      if (this.extends)
        push2(this.extends);
      if (this.name)
        push2(this.name);
    },
    visit_nondeferred_class_parts(visitor) {
      if (this.extends) {
        this.extends._walk(visitor);
      }
      this.properties.forEach((prop) => {
        if (prop instanceof AST_ClassStaticBlock) {
          prop._walk(visitor);
          return;
        }
        if (prop.computed_key()) {
          visitor.push(prop);
          prop.key._walk(visitor);
          visitor.pop();
        }
        if ((prop instanceof AST_ClassPrivateProperty || prop instanceof AST_ClassProperty) && prop.static && prop.value) {
          visitor.push(prop);
          prop.value._walk(visitor);
          visitor.pop();
        }
      });
    },
    visit_deferred_class_parts(visitor) {
      this.properties.forEach((prop) => {
        if (prop instanceof AST_ConciseMethod) {
          prop.walk(visitor);
        } else if (prop instanceof AST_ClassProperty && !prop.static && prop.value) {
          visitor.push(prop);
          prop.value._walk(visitor);
          visitor.pop();
        }
      });
    },
    is_self_referential: function() {
      const this_id = this.name && this.name.definition().id;
      let found = false;
      let class_this = true;
      this.visit_nondeferred_class_parts(new TreeWalker((node, descend) => {
        if (found)
          return true;
        if (node instanceof AST_This)
          return found = class_this;
        if (node instanceof AST_SymbolRef)
          return found = node.definition().id === this_id;
        if (node instanceof AST_Lambda && !(node instanceof AST_Arrow)) {
          const class_this_save = class_this;
          class_this = false;
          descend();
          class_this = class_this_save;
          return true;
        }
      }));
      return found;
    }
  }, AST_Scope);
  AST_ClassProperty = DEFNODE("ClassProperty", "static quote", function AST_ClassProperty2(props) {
    if (props) {
      this.static = props.static;
      this.quote = props.quote;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
      this._annotations = props._annotations;
    }
    this.flags = 0;
  }, {
    $documentation: "A class property",
    $propdoc: {
      static: "[boolean] whether this is a static key",
      quote: "[string] which quote is being used"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        if (this.key instanceof AST_Node)
          this.key._walk(visitor);
        if (this.value instanceof AST_Node)
          this.value._walk(visitor);
      });
    },
    _children_backwards(push2) {
      if (this.value instanceof AST_Node)
        push2(this.value);
      if (this.key instanceof AST_Node)
        push2(this.key);
    },
    computed_key() {
      return !(this.key instanceof AST_SymbolClassProperty);
    }
  }, AST_ObjectProperty);
  AST_ClassPrivateProperty = DEFNODE("ClassPrivateProperty", "", function AST_ClassPrivateProperty2(props) {
    if (props) {
      this.static = props.static;
      this.quote = props.quote;
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A class property for a private property"
  }, AST_ClassProperty);
  AST_PrivateIn = DEFNODE("PrivateIn", "key value", function AST_PrivateIn2(props) {
    if (props) {
      this.key = props.key;
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "An `in` binop when the key is private, eg #x in this",
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        this.key._walk(visitor);
        this.value._walk(visitor);
      });
    },
    _children_backwards(push2) {
      push2(this.value);
      push2(this.key);
    }
  });
  AST_DefClass = DEFNODE("DefClass", null, function AST_DefClass2(props) {
    if (props) {
      this.name = props.name;
      this.extends = props.extends;
      this.properties = props.properties;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A class definition"
  }, AST_Class);
  AST_ClassStaticBlock = DEFNODE("ClassStaticBlock", "body block_scope", function AST_ClassStaticBlock2(props) {
    this.body = props.body;
    this.block_scope = props.block_scope;
    this.start = props.start;
    this.end = props.end;
  }, {
    $documentation: "A block containing statements to be executed in the context of the class",
    $propdoc: {
      body: "[AST_Statement*] an array of statements"
    },
    _walk: function(visitor) {
      return visitor._visit(this, function() {
        walk_body(this, visitor);
      });
    },
    _children_backwards(push2) {
      let i2 = this.body.length;
      while (i2--)
        push2(this.body[i2]);
    },
    clone: clone_block_scope,
    computed_key: () => false
  }, AST_Scope);
  AST_ClassExpression = DEFNODE("ClassExpression", null, function AST_ClassExpression2(props) {
    if (props) {
      this.name = props.name;
      this.extends = props.extends;
      this.properties = props.properties;
      this.variables = props.variables;
      this.uses_with = props.uses_with;
      this.uses_eval = props.uses_eval;
      this.parent_scope = props.parent_scope;
      this.enclosed = props.enclosed;
      this.cname = props.cname;
      this.body = props.body;
      this.block_scope = props.block_scope;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A class expression."
  }, AST_Class);
  AST_Symbol = DEFNODE("Symbol", "scope name thedef", function AST_Symbol2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $propdoc: {
      name: "[string] name of this symbol",
      scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
      thedef: "[SymbolDef/S] the definition of this symbol"
    },
    $documentation: "Base class for all symbols"
  });
  AST_NewTarget = DEFNODE("NewTarget", null, function AST_NewTarget2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A reference to new.target"
  });
  AST_SymbolDeclaration = DEFNODE("SymbolDeclaration", "init", function AST_SymbolDeclaration2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A declaration symbol (symbol in var/const, function name or argument, symbol in catch)"
  }, AST_Symbol);
  AST_SymbolVar = DEFNODE("SymbolVar", null, function AST_SymbolVar2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol defining a variable"
  }, AST_SymbolDeclaration);
  AST_SymbolBlockDeclaration = DEFNODE("SymbolBlockDeclaration", null, function AST_SymbolBlockDeclaration2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for block-scoped declaration symbols"
  }, AST_SymbolDeclaration);
  AST_SymbolConst = DEFNODE("SymbolConst", null, function AST_SymbolConst2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A constant declaration"
  }, AST_SymbolBlockDeclaration);
  AST_SymbolLet = DEFNODE("SymbolLet", null, function AST_SymbolLet2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A block-scoped `let` declaration"
  }, AST_SymbolBlockDeclaration);
  AST_SymbolFunarg = DEFNODE("SymbolFunarg", null, function AST_SymbolFunarg2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol naming a function argument"
  }, AST_SymbolVar);
  AST_SymbolDefun = DEFNODE("SymbolDefun", null, function AST_SymbolDefun2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol defining a function"
  }, AST_SymbolDeclaration);
  AST_SymbolMethod = DEFNODE("SymbolMethod", null, function AST_SymbolMethod2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol in an object defining a method"
  }, AST_Symbol);
  AST_SymbolClassProperty = DEFNODE("SymbolClassProperty", null, function AST_SymbolClassProperty2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol for a class property"
  }, AST_Symbol);
  AST_SymbolLambda = DEFNODE("SymbolLambda", null, function AST_SymbolLambda2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol naming a function expression"
  }, AST_SymbolDeclaration);
  AST_SymbolDefClass = DEFNODE("SymbolDefClass", null, function AST_SymbolDefClass2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol naming a class's name in a class declaration. Lexically scoped to its containing scope, and accessible within the class."
  }, AST_SymbolBlockDeclaration);
  AST_SymbolClass = DEFNODE("SymbolClass", null, function AST_SymbolClass2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol naming a class's name. Lexically scoped to the class."
  }, AST_SymbolDeclaration);
  AST_SymbolCatch = DEFNODE("SymbolCatch", null, function AST_SymbolCatch2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol naming the exception in catch"
  }, AST_SymbolBlockDeclaration);
  AST_SymbolImport = DEFNODE("SymbolImport", null, function AST_SymbolImport2(props) {
    if (props) {
      this.init = props.init;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol referring to an imported name"
  }, AST_SymbolBlockDeclaration);
  AST_SymbolImportForeign = DEFNODE("SymbolImportForeign", null, function AST_SymbolImportForeign2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.quote = props.quote;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A symbol imported from a module, but it is defined in the other module, and its real name is irrelevant for this module's purposes"
  }, AST_Symbol);
  AST_Label = DEFNODE("Label", "references", function AST_Label2(props) {
    if (props) {
      this.references = props.references;
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
      this.initialize();
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol naming a label (declaration)",
    $propdoc: {
      references: "[AST_LoopControl*] a list of nodes referring to this label"
    },
    initialize: function() {
      this.references = [];
      this.thedef = this;
    }
  }, AST_Symbol);
  AST_SymbolRef = DEFNODE("SymbolRef", null, function AST_SymbolRef2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Reference to some symbol (not definition/declaration)"
  }, AST_Symbol);
  AST_SymbolExport = DEFNODE("SymbolExport", null, function AST_SymbolExport2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.quote = props.quote;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Symbol referring to a name to export"
  }, AST_SymbolRef);
  AST_SymbolExportForeign = DEFNODE("SymbolExportForeign", null, function AST_SymbolExportForeign2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.quote = props.quote;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A symbol exported from this module, but it is used in the other module, and its real name is irrelevant for this module's purposes"
  }, AST_Symbol);
  AST_LabelRef = DEFNODE("LabelRef", null, function AST_LabelRef2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Reference to a label symbol"
  }, AST_Symbol);
  AST_SymbolPrivateProperty = DEFNODE("SymbolPrivateProperty", null, function AST_SymbolPrivateProperty2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A symbol that refers to a private property"
  }, AST_Symbol);
  AST_This = DEFNODE("This", null, function AST_This2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `this` symbol"
  }, AST_Symbol);
  AST_Super = DEFNODE("Super", null, function AST_Super2(props) {
    if (props) {
      this.scope = props.scope;
      this.name = props.name;
      this.thedef = props.thedef;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `super` symbol"
  }, AST_This);
  AST_Constant = DEFNODE("Constant", null, function AST_Constant2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for all constants",
    getValue: function() {
      return this.value;
    }
  });
  AST_String = DEFNODE("String", "value quote", function AST_String2(props) {
    if (props) {
      this.value = props.value;
      this.quote = props.quote;
      this.start = props.start;
      this.end = props.end;
      this._annotations = props._annotations;
    }
    this.flags = 0;
  }, {
    $documentation: "A string literal",
    $propdoc: {
      value: "[string] the contents of this string",
      quote: "[string] the original quote character"
    }
  }, AST_Constant);
  AST_Number = DEFNODE("Number", "value raw", function AST_Number2(props) {
    if (props) {
      this.value = props.value;
      this.raw = props.raw;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A number literal",
    $propdoc: {
      value: "[number] the numeric value",
      raw: "[string] numeric value as string"
    }
  }, AST_Constant);
  AST_BigInt = DEFNODE("BigInt", "value", function AST_BigInt2(props) {
    if (props) {
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A big int literal",
    $propdoc: {
      value: "[string] big int value"
    }
  }, AST_Constant);
  AST_RegExp = DEFNODE("RegExp", "value", function AST_RegExp2(props) {
    if (props) {
      this.value = props.value;
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A regexp literal",
    $propdoc: {
      value: "[RegExp] the actual regexp"
    }
  }, AST_Constant);
  AST_Atom = DEFNODE("Atom", null, function AST_Atom2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for atoms"
  }, AST_Constant);
  AST_Null = DEFNODE("Null", null, function AST_Null2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `null` atom",
    value: null
  }, AST_Atom);
  AST_NaN = DEFNODE("NaN", null, function AST_NaN2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The impossible value",
    value: NaN
  }, AST_Atom);
  AST_Undefined = DEFNODE("Undefined", null, function AST_Undefined2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `undefined` value",
    value: function() {
    }()
  }, AST_Atom);
  AST_Hole = DEFNODE("Hole", null, function AST_Hole2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "A hole in an array",
    value: function() {
    }()
  }, AST_Atom);
  AST_Infinity = DEFNODE("Infinity", null, function AST_Infinity2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `Infinity` value",
    value: Infinity
  }, AST_Atom);
  AST_Boolean = DEFNODE("Boolean", null, function AST_Boolean2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "Base class for booleans"
  }, AST_Atom);
  AST_False = DEFNODE("False", null, function AST_False2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `false` atom",
    value: false
  }, AST_Boolean);
  AST_True = DEFNODE("True", null, function AST_True2(props) {
    if (props) {
      this.start = props.start;
      this.end = props.end;
    }
    this.flags = 0;
  }, {
    $documentation: "The `true` atom",
    value: true
  }, AST_Boolean);
  walk_abort = Symbol("abort walk");
  TreeTransformer = class TreeTransformer2 extends TreeWalker {
    constructor(before, after) {
      super();
      this.before = before;
      this.after = after;
    }
  };
});
function def_transform(node, descend) {
  node.DEFMETHOD("transform", function(tw, in_list) {
    let transformed = undefined;
    tw.push(this);
    if (tw.before)
      transformed = tw.before(this, descend, in_list);
    if (transformed === undefined) {
      transformed = this;
      descend(transformed, tw);
      if (tw.after) {
        const after_ret = tw.after(transformed, in_list);
        if (after_ret !== undefined)
          transformed = after_ret;
      }
    }
    tw.pop();
    return transformed;
  });
}
var init_transform = __esm2(() => {
  init_ast();
  init_utils5();
  def_transform(AST_Node, noop);
  def_transform(AST_LabeledStatement, function(self2, tw) {
    self2.label = self2.label.transform(tw);
    self2.body = self2.body.transform(tw);
  });
  def_transform(AST_SimpleStatement, function(self2, tw) {
    self2.body = self2.body.transform(tw);
  });
  def_transform(AST_Block, function(self2, tw) {
    self2.body = MAP(self2.body, tw);
  });
  def_transform(AST_Do, function(self2, tw) {
    self2.body = self2.body.transform(tw);
    self2.condition = self2.condition.transform(tw);
  });
  def_transform(AST_While, function(self2, tw) {
    self2.condition = self2.condition.transform(tw);
    self2.body = self2.body.transform(tw);
  });
  def_transform(AST_For, function(self2, tw) {
    if (self2.init)
      self2.init = self2.init.transform(tw);
    if (self2.condition)
      self2.condition = self2.condition.transform(tw);
    if (self2.step)
      self2.step = self2.step.transform(tw);
    self2.body = self2.body.transform(tw);
  });
  def_transform(AST_ForIn, function(self2, tw) {
    self2.init = self2.init.transform(tw);
    self2.object = self2.object.transform(tw);
    self2.body = self2.body.transform(tw);
  });
  def_transform(AST_With, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
    self2.body = self2.body.transform(tw);
  });
  def_transform(AST_Exit, function(self2, tw) {
    if (self2.value)
      self2.value = self2.value.transform(tw);
  });
  def_transform(AST_LoopControl, function(self2, tw) {
    if (self2.label)
      self2.label = self2.label.transform(tw);
  });
  def_transform(AST_If, function(self2, tw) {
    self2.condition = self2.condition.transform(tw);
    self2.body = self2.body.transform(tw);
    if (self2.alternative)
      self2.alternative = self2.alternative.transform(tw);
  });
  def_transform(AST_Switch, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
    self2.body = MAP(self2.body, tw);
  });
  def_transform(AST_Case, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
    self2.body = MAP(self2.body, tw);
  });
  def_transform(AST_Try, function(self2, tw) {
    self2.body = self2.body.transform(tw);
    if (self2.bcatch)
      self2.bcatch = self2.bcatch.transform(tw);
    if (self2.bfinally)
      self2.bfinally = self2.bfinally.transform(tw);
  });
  def_transform(AST_Catch, function(self2, tw) {
    if (self2.argname)
      self2.argname = self2.argname.transform(tw);
    self2.body = MAP(self2.body, tw);
  });
  def_transform(AST_Definitions, function(self2, tw) {
    self2.definitions = MAP(self2.definitions, tw);
  });
  def_transform(AST_VarDef, function(self2, tw) {
    self2.name = self2.name.transform(tw);
    if (self2.value)
      self2.value = self2.value.transform(tw);
  });
  def_transform(AST_Destructuring, function(self2, tw) {
    self2.names = MAP(self2.names, tw);
  });
  def_transform(AST_Lambda, function(self2, tw) {
    if (self2.name)
      self2.name = self2.name.transform(tw);
    self2.argnames = MAP(self2.argnames, tw, false);
    if (self2.body instanceof AST_Node) {
      self2.body = self2.body.transform(tw);
    } else {
      self2.body = MAP(self2.body, tw);
    }
  });
  def_transform(AST_Call, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
    self2.args = MAP(self2.args, tw, false);
  });
  def_transform(AST_Sequence, function(self2, tw) {
    const result2 = MAP(self2.expressions, tw);
    self2.expressions = result2.length ? result2 : [new AST_Number({ value: 0 })];
  });
  def_transform(AST_PropAccess, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
  });
  def_transform(AST_Sub, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
    self2.property = self2.property.transform(tw);
  });
  def_transform(AST_Chain, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
  });
  def_transform(AST_Yield, function(self2, tw) {
    if (self2.expression)
      self2.expression = self2.expression.transform(tw);
  });
  def_transform(AST_Await, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
  });
  def_transform(AST_Unary, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
  });
  def_transform(AST_Binary, function(self2, tw) {
    self2.left = self2.left.transform(tw);
    self2.right = self2.right.transform(tw);
  });
  def_transform(AST_PrivateIn, function(self2, tw) {
    self2.key = self2.key.transform(tw);
    self2.value = self2.value.transform(tw);
  });
  def_transform(AST_Conditional, function(self2, tw) {
    self2.condition = self2.condition.transform(tw);
    self2.consequent = self2.consequent.transform(tw);
    self2.alternative = self2.alternative.transform(tw);
  });
  def_transform(AST_Array, function(self2, tw) {
    self2.elements = MAP(self2.elements, tw);
  });
  def_transform(AST_Object, function(self2, tw) {
    self2.properties = MAP(self2.properties, tw);
  });
  def_transform(AST_ObjectProperty, function(self2, tw) {
    if (self2.key instanceof AST_Node) {
      self2.key = self2.key.transform(tw);
    }
    if (self2.value)
      self2.value = self2.value.transform(tw);
  });
  def_transform(AST_Class, function(self2, tw) {
    if (self2.name)
      self2.name = self2.name.transform(tw);
    if (self2.extends)
      self2.extends = self2.extends.transform(tw);
    self2.properties = MAP(self2.properties, tw);
  });
  def_transform(AST_ClassStaticBlock, function(self2, tw) {
    self2.body = MAP(self2.body, tw);
  });
  def_transform(AST_Expansion, function(self2, tw) {
    self2.expression = self2.expression.transform(tw);
  });
  def_transform(AST_NameMapping, function(self2, tw) {
    self2.foreign_name = self2.foreign_name.transform(tw);
    self2.name = self2.name.transform(tw);
  });
  def_transform(AST_Import, function(self2, tw) {
    if (self2.imported_name)
      self2.imported_name = self2.imported_name.transform(tw);
    if (self2.imported_names)
      MAP(self2.imported_names, tw);
    self2.module_name = self2.module_name.transform(tw);
  });
  def_transform(AST_Export, function(self2, tw) {
    if (self2.exported_definition)
      self2.exported_definition = self2.exported_definition.transform(tw);
    if (self2.exported_value)
      self2.exported_value = self2.exported_value.transform(tw);
    if (self2.exported_names)
      MAP(self2.exported_names, tw);
    if (self2.module_name)
      self2.module_name = self2.module_name.transform(tw);
  });
  def_transform(AST_TemplateString, function(self2, tw) {
    self2.segments = MAP(self2.segments, tw);
  });
  def_transform(AST_PrefixedTemplateString, function(self2, tw) {
    self2.prefix = self2.prefix.transform(tw);
    self2.template_string = self2.template_string.transform(tw);
  });
});
var init_mozilla_ast = __esm2(() => {
  init_utils5();
  init_ast();
  init_parse2();
  (function() {
    var normalize_directives = function(body) {
      for (var i2 = 0;i2 < body.length; i2++) {
        if (body[i2] instanceof AST_Statement && body[i2].body instanceof AST_String) {
          body[i2] = new AST_Directive({
            start: body[i2].start,
            end: body[i2].end,
            value: body[i2].body.value
          });
        } else {
          return body;
        }
      }
      return body;
    };
    function import_attributes_from_moz(attributes) {
      if (attributes && attributes.length > 0) {
        return new AST_Object({
          start: my_start_token(attributes),
          end: my_end_token(attributes),
          properties: attributes.map((attr) => new AST_ObjectKeyVal({
            start: my_start_token(attr),
            end: my_end_token(attr),
            key: attr.key.name || attr.key.value,
            value: from_moz(attr.value)
          }))
        });
      }
      return null;
    }
    var MOZ_TO_ME = {
      Program: function(M22) {
        return new AST_Toplevel({
          start: my_start_token(M22),
          end: my_end_token(M22),
          body: normalize_directives(M22.body.map(from_moz))
        });
      },
      ArrayPattern: function(M22) {
        return new AST_Destructuring({
          start: my_start_token(M22),
          end: my_end_token(M22),
          names: M22.elements.map(function(elm) {
            if (elm === null) {
              return new AST_Hole;
            }
            return from_moz(elm);
          }),
          is_array: true
        });
      },
      ObjectPattern: function(M22) {
        return new AST_Destructuring({
          start: my_start_token(M22),
          end: my_end_token(M22),
          names: M22.properties.map(from_moz),
          is_array: false
        });
      },
      AssignmentPattern: function(M22) {
        return new AST_DefaultAssign({
          start: my_start_token(M22),
          end: my_end_token(M22),
          left: from_moz(M22.left),
          operator: "=",
          right: from_moz(M22.right)
        });
      },
      SpreadElement: function(M22) {
        return new AST_Expansion({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.argument)
        });
      },
      RestElement: function(M22) {
        return new AST_Expansion({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.argument)
        });
      },
      TemplateElement: function(M22) {
        return new AST_TemplateSegment({
          start: my_start_token(M22),
          end: my_end_token(M22),
          value: M22.value.cooked,
          raw: M22.value.raw
        });
      },
      TemplateLiteral: function(M22) {
        var segments = [];
        for (var i2 = 0;i2 < M22.quasis.length; i2++) {
          segments.push(from_moz(M22.quasis[i2]));
          if (M22.expressions[i2]) {
            segments.push(from_moz(M22.expressions[i2]));
          }
        }
        return new AST_TemplateString({
          start: my_start_token(M22),
          end: my_end_token(M22),
          segments
        });
      },
      TaggedTemplateExpression: function(M22) {
        return new AST_PrefixedTemplateString({
          start: my_start_token(M22),
          end: my_end_token(M22),
          template_string: from_moz(M22.quasi),
          prefix: from_moz(M22.tag)
        });
      },
      FunctionDeclaration: function(M22) {
        return new AST_Defun({
          start: my_start_token(M22),
          end: my_end_token(M22),
          name: from_moz(M22.id),
          argnames: M22.params.map(from_moz),
          is_generator: M22.generator,
          async: M22.async,
          body: normalize_directives(from_moz(M22.body).body)
        });
      },
      FunctionExpression: function(M22) {
        return new AST_Function({
          start: my_start_token(M22),
          end: my_end_token(M22),
          name: from_moz(M22.id),
          argnames: M22.params.map(from_moz),
          is_generator: M22.generator,
          async: M22.async,
          body: normalize_directives(from_moz(M22.body).body)
        });
      },
      ArrowFunctionExpression: function(M22) {
        const body = M22.body.type === "BlockStatement" ? from_moz(M22.body).body : [make_node(AST_Return, {}, { value: from_moz(M22.body) })];
        return new AST_Arrow({
          start: my_start_token(M22),
          end: my_end_token(M22),
          argnames: M22.params.map(from_moz),
          body,
          async: M22.async
        });
      },
      ExpressionStatement: function(M22) {
        return new AST_SimpleStatement({
          start: my_start_token(M22),
          end: my_end_token(M22),
          body: from_moz(M22.expression)
        });
      },
      TryStatement: function(M22) {
        var handlers = M22.handlers || [M22.handler];
        if (handlers.length > 1 || M22.guardedHandlers && M22.guardedHandlers.length) {
          throw new Error("Multiple catch clauses are not supported.");
        }
        return new AST_Try({
          start: my_start_token(M22),
          end: my_end_token(M22),
          body: new AST_TryBlock(from_moz(M22.block)),
          bcatch: from_moz(handlers[0]),
          bfinally: M22.finalizer ? new AST_Finally(from_moz(M22.finalizer)) : null
        });
      },
      Property: function(M22) {
        var key = M22.key;
        var args = {
          start: my_start_token(key || M22.value),
          end: my_end_token(M22.value),
          key: key.type == "Identifier" ? key.name : key.value,
          value: from_moz(M22.value)
        };
        if (M22.computed) {
          args.key = from_moz(M22.key);
        }
        if (M22.method) {
          args.is_generator = M22.value.generator;
          args.async = M22.value.async;
          if (!M22.computed) {
            args.key = new AST_SymbolMethod({ name: args.key });
          } else {
            args.key = from_moz(M22.key);
          }
          return new AST_ConciseMethod(args);
        }
        if (M22.kind == "init") {
          if (key.type != "Identifier" && key.type != "Literal") {
            args.key = from_moz(key);
          }
          return new AST_ObjectKeyVal(args);
        }
        if (typeof args.key === "string" || typeof args.key === "number") {
          args.key = new AST_SymbolMethod({
            name: args.key
          });
        }
        args.value = new AST_Accessor(args.value);
        if (M22.kind == "get")
          return new AST_ObjectGetter(args);
        if (M22.kind == "set")
          return new AST_ObjectSetter(args);
        if (M22.kind == "method") {
          args.async = M22.value.async;
          args.is_generator = M22.value.generator;
          args.quote = M22.computed ? "\"" : null;
          return new AST_ConciseMethod(args);
        }
      },
      MethodDefinition: function(M22) {
        const is_private = M22.key.type === "PrivateIdentifier";
        const key = M22.computed ? from_moz(M22.key) : new AST_SymbolMethod({ name: M22.key.name || M22.key.value });
        var args = {
          start: my_start_token(M22),
          end: my_end_token(M22),
          key,
          value: from_moz(M22.value),
          static: M22.static
        };
        if (M22.kind == "get") {
          return new (is_private ? AST_PrivateGetter : AST_ObjectGetter)(args);
        }
        if (M22.kind == "set") {
          return new (is_private ? AST_PrivateSetter : AST_ObjectSetter)(args);
        }
        args.is_generator = M22.value.generator;
        args.async = M22.value.async;
        return new (is_private ? AST_PrivateMethod : AST_ConciseMethod)(args);
      },
      FieldDefinition: function(M22) {
        let key;
        if (M22.computed) {
          key = from_moz(M22.key);
        } else {
          if (M22.key.type !== "Identifier")
            throw new Error("Non-Identifier key in FieldDefinition");
          key = from_moz(M22.key);
        }
        return new AST_ClassProperty({
          start: my_start_token(M22),
          end: my_end_token(M22),
          key,
          value: from_moz(M22.value),
          static: M22.static
        });
      },
      PropertyDefinition: function(M22) {
        let key;
        if (M22.computed) {
          key = from_moz(M22.key);
        } else if (M22.key.type === "PrivateIdentifier") {
          return new AST_ClassPrivateProperty({
            start: my_start_token(M22),
            end: my_end_token(M22),
            key: from_moz(M22.key),
            value: from_moz(M22.value),
            static: M22.static
          });
        } else {
          if (M22.key.type !== "Identifier") {
            throw new Error("Non-Identifier key in PropertyDefinition");
          }
          key = from_moz(M22.key);
        }
        return new AST_ClassProperty({
          start: my_start_token(M22),
          end: my_end_token(M22),
          key,
          value: from_moz(M22.value),
          static: M22.static
        });
      },
      PrivateIdentifier: function(M22) {
        return new AST_SymbolPrivateProperty({
          start: my_start_token(M22),
          end: my_end_token(M22),
          name: M22.name
        });
      },
      StaticBlock: function(M22) {
        return new AST_ClassStaticBlock({
          start: my_start_token(M22),
          end: my_end_token(M22),
          body: M22.body.map(from_moz)
        });
      },
      ArrayExpression: function(M22) {
        return new AST_Array({
          start: my_start_token(M22),
          end: my_end_token(M22),
          elements: M22.elements.map(function(elem) {
            return elem === null ? new AST_Hole : from_moz(elem);
          })
        });
      },
      ObjectExpression: function(M22) {
        return new AST_Object({
          start: my_start_token(M22),
          end: my_end_token(M22),
          properties: M22.properties.map(function(prop) {
            if (prop.type === "SpreadElement") {
              return from_moz(prop);
            }
            prop.type = "Property";
            return from_moz(prop);
          })
        });
      },
      SequenceExpression: function(M22) {
        return new AST_Sequence({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expressions: M22.expressions.map(from_moz)
        });
      },
      MemberExpression: function(M22) {
        if (M22.property.type === "PrivateIdentifier") {
          return new AST_DotHash({
            start: my_start_token(M22),
            end: my_end_token(M22),
            property: M22.property.name,
            expression: from_moz(M22.object),
            optional: M22.optional || false
          });
        }
        return new (M22.computed ? AST_Sub : AST_Dot)({
          start: my_start_token(M22),
          end: my_end_token(M22),
          property: M22.computed ? from_moz(M22.property) : M22.property.name,
          expression: from_moz(M22.object),
          optional: M22.optional || false
        });
      },
      ChainExpression: function(M22) {
        return new AST_Chain({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.expression)
        });
      },
      SwitchCase: function(M22) {
        return new (M22.test ? AST_Case : AST_Default)({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.test),
          body: M22.consequent.map(from_moz)
        });
      },
      VariableDeclaration: function(M22) {
        return new (M22.kind === "const" ? AST_Const : M22.kind === "let" ? AST_Let : AST_Var)({
          start: my_start_token(M22),
          end: my_end_token(M22),
          definitions: M22.declarations.map(from_moz)
        });
      },
      ImportDeclaration: function(M22) {
        var imported_name = null;
        var imported_names = null;
        M22.specifiers.forEach(function(specifier) {
          if (specifier.type === "ImportSpecifier" || specifier.type === "ImportNamespaceSpecifier") {
            if (!imported_names) {
              imported_names = [];
            }
            imported_names.push(from_moz(specifier));
          } else if (specifier.type === "ImportDefaultSpecifier") {
            imported_name = from_moz(specifier);
          }
        });
        return new AST_Import({
          start: my_start_token(M22),
          end: my_end_token(M22),
          imported_name,
          imported_names,
          module_name: from_moz(M22.source),
          attributes: import_attributes_from_moz(M22.attributes || M22.assertions)
        });
      },
      ImportSpecifier: function(M22) {
        return new AST_NameMapping({
          start: my_start_token(M22),
          end: my_end_token(M22),
          foreign_name: from_moz(M22.imported),
          name: from_moz(M22.local)
        });
      },
      ImportDefaultSpecifier: function(M22) {
        return from_moz(M22.local);
      },
      ImportNamespaceSpecifier: function(M22) {
        return new AST_NameMapping({
          start: my_start_token(M22),
          end: my_end_token(M22),
          foreign_name: new AST_SymbolImportForeign({ name: "*" }),
          name: from_moz(M22.local)
        });
      },
      ImportExpression: function(M22) {
        const args = [from_moz(M22.source)];
        if (M22.options) {
          args.push(from_moz(M22.options));
        }
        return new AST_Call({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz({
            type: "Identifier",
            name: "import"
          }),
          optional: false,
          args
        });
      },
      ExportAllDeclaration: function(M22) {
        var foreign_name = M22.exported == null ? new AST_SymbolExportForeign({ name: "*" }) : from_moz(M22.exported);
        return new AST_Export({
          start: my_start_token(M22),
          end: my_end_token(M22),
          exported_names: [
            new AST_NameMapping({
              name: new AST_SymbolExportForeign({ name: "*" }),
              foreign_name
            })
          ],
          module_name: from_moz(M22.source),
          attributes: import_attributes_from_moz(M22.attributes || M22.assertions)
        });
      },
      ExportNamedDeclaration: function(M22) {
        return new AST_Export({
          start: my_start_token(M22),
          end: my_end_token(M22),
          exported_definition: from_moz(M22.declaration),
          exported_names: M22.specifiers && M22.specifiers.length ? M22.specifiers.map(from_moz) : null,
          module_name: from_moz(M22.source),
          attributes: import_attributes_from_moz(M22.attributes || M22.assertions)
        });
      },
      ExportDefaultDeclaration: function(M22) {
        return new AST_Export({
          start: my_start_token(M22),
          end: my_end_token(M22),
          exported_value: from_moz(M22.declaration),
          is_default: true
        });
      },
      ExportSpecifier: function(M22) {
        return new AST_NameMapping({
          foreign_name: from_moz(M22.exported),
          name: from_moz(M22.local)
        });
      },
      Literal: function(M22) {
        var val2 = M22.value, args = {
          start: my_start_token(M22),
          end: my_end_token(M22)
        };
        var rx = M22.regex;
        if (rx && rx.pattern) {
          args.value = {
            source: rx.pattern,
            flags: rx.flags
          };
          return new AST_RegExp(args);
        } else if (rx) {
          const rx_source = M22.raw || val2;
          const match = rx_source.match(/^\/(.*)\/(\w*)$/);
          if (!match)
            throw new Error("Invalid regex source " + rx_source);
          const [_22, source, flags] = match;
          args.value = { source, flags };
          return new AST_RegExp(args);
        }
        const bi = typeof M22.value === "bigint" ? M22.value.toString() : M22.bigint;
        if (typeof bi === "string") {
          args.value = bi;
          return new AST_BigInt(args);
        }
        if (val2 === null)
          return new AST_Null(args);
        switch (typeof val2) {
          case "string":
            args.quote = "\"";
            var p32 = FROM_MOZ_STACK[FROM_MOZ_STACK.length - 2];
            if (p32.type == "ImportSpecifier") {
              args.name = val2;
              return new AST_SymbolImportForeign(args);
            } else if (p32.type == "ExportSpecifier") {
              args.name = val2;
              if (M22 == p32.exported) {
                return new AST_SymbolExportForeign(args);
              } else {
                return new AST_SymbolExport(args);
              }
            } else if (p32.type == "ExportAllDeclaration" && M22 == p32.exported) {
              args.name = val2;
              return new AST_SymbolExportForeign(args);
            }
            args.value = val2;
            return new AST_String(args);
          case "number":
            args.value = val2;
            args.raw = M22.raw || val2.toString();
            return new AST_Number(args);
          case "boolean":
            return new (val2 ? AST_True : AST_False)(args);
        }
      },
      MetaProperty: function(M22) {
        if (M22.meta.name === "new" && M22.property.name === "target") {
          return new AST_NewTarget({
            start: my_start_token(M22),
            end: my_end_token(M22)
          });
        } else if (M22.meta.name === "import" && M22.property.name === "meta") {
          return new AST_ImportMeta({
            start: my_start_token(M22),
            end: my_end_token(M22)
          });
        }
      },
      Identifier: function(M22) {
        var p32 = FROM_MOZ_STACK[FROM_MOZ_STACK.length - 2];
        return new (p32.type == "LabeledStatement" ? AST_Label : p32.type == "VariableDeclarator" && p32.id === M22 ? p32.kind == "const" ? AST_SymbolConst : p32.kind == "let" ? AST_SymbolLet : AST_SymbolVar : (/Import.*Specifier/.test(p32.type)) ? p32.local === M22 ? AST_SymbolImport : AST_SymbolImportForeign : p32.type == "ExportSpecifier" ? p32.local === M22 ? AST_SymbolExport : AST_SymbolExportForeign : p32.type == "FunctionExpression" ? p32.id === M22 ? AST_SymbolLambda : AST_SymbolFunarg : p32.type == "FunctionDeclaration" ? p32.id === M22 ? AST_SymbolDefun : AST_SymbolFunarg : p32.type == "ArrowFunctionExpression" ? p32.params.includes(M22) ? AST_SymbolFunarg : AST_SymbolRef : p32.type == "ClassExpression" ? p32.id === M22 ? AST_SymbolClass : AST_SymbolRef : p32.type == "Property" ? p32.key === M22 && p32.computed || p32.value === M22 ? AST_SymbolRef : AST_SymbolMethod : p32.type == "PropertyDefinition" || p32.type === "FieldDefinition" ? p32.key === M22 && p32.computed || p32.value === M22 ? AST_SymbolRef : AST_SymbolClassProperty : p32.type == "ClassDeclaration" ? p32.id === M22 ? AST_SymbolDefClass : AST_SymbolRef : p32.type == "MethodDefinition" ? p32.computed ? AST_SymbolRef : AST_SymbolMethod : p32.type == "CatchClause" ? AST_SymbolCatch : p32.type == "BreakStatement" || p32.type == "ContinueStatement" ? AST_LabelRef : AST_SymbolRef)({
          start: my_start_token(M22),
          end: my_end_token(M22),
          name: M22.name
        });
      },
      EmptyStatement: function(M22) {
        return new AST_EmptyStatement({
          start: my_start_token(M22),
          end: my_end_token(M22)
        });
      },
      BlockStatement: function(M22) {
        return new AST_BlockStatement({
          start: my_start_token(M22),
          end: my_end_token(M22),
          body: M22.body.map(from_moz)
        });
      },
      IfStatement: function(M22) {
        return new AST_If({
          start: my_start_token(M22),
          end: my_end_token(M22),
          condition: from_moz(M22.test),
          body: from_moz(M22.consequent),
          alternative: from_moz(M22.alternate)
        });
      },
      LabeledStatement: function(M22) {
        return new AST_LabeledStatement({
          start: my_start_token(M22),
          end: my_end_token(M22),
          label: from_moz(M22.label),
          body: from_moz(M22.body)
        });
      },
      BreakStatement: function(M22) {
        return new AST_Break({
          start: my_start_token(M22),
          end: my_end_token(M22),
          label: from_moz(M22.label)
        });
      },
      ContinueStatement: function(M22) {
        return new AST_Continue({
          start: my_start_token(M22),
          end: my_end_token(M22),
          label: from_moz(M22.label)
        });
      },
      WithStatement: function(M22) {
        return new AST_With({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.object),
          body: from_moz(M22.body)
        });
      },
      SwitchStatement: function(M22) {
        return new AST_Switch({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.discriminant),
          body: M22.cases.map(from_moz)
        });
      },
      ReturnStatement: function(M22) {
        return new AST_Return({
          start: my_start_token(M22),
          end: my_end_token(M22),
          value: from_moz(M22.argument)
        });
      },
      ThrowStatement: function(M22) {
        return new AST_Throw({
          start: my_start_token(M22),
          end: my_end_token(M22),
          value: from_moz(M22.argument)
        });
      },
      WhileStatement: function(M22) {
        return new AST_While({
          start: my_start_token(M22),
          end: my_end_token(M22),
          condition: from_moz(M22.test),
          body: from_moz(M22.body)
        });
      },
      DoWhileStatement: function(M22) {
        return new AST_Do({
          start: my_start_token(M22),
          end: my_end_token(M22),
          condition: from_moz(M22.test),
          body: from_moz(M22.body)
        });
      },
      ForStatement: function(M22) {
        return new AST_For({
          start: my_start_token(M22),
          end: my_end_token(M22),
          init: from_moz(M22.init),
          condition: from_moz(M22.test),
          step: from_moz(M22.update),
          body: from_moz(M22.body)
        });
      },
      ForInStatement: function(M22) {
        return new AST_ForIn({
          start: my_start_token(M22),
          end: my_end_token(M22),
          init: from_moz(M22.left),
          object: from_moz(M22.right),
          body: from_moz(M22.body)
        });
      },
      ForOfStatement: function(M22) {
        return new AST_ForOf({
          start: my_start_token(M22),
          end: my_end_token(M22),
          init: from_moz(M22.left),
          object: from_moz(M22.right),
          body: from_moz(M22.body),
          await: M22.await
        });
      },
      AwaitExpression: function(M22) {
        return new AST_Await({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.argument)
        });
      },
      YieldExpression: function(M22) {
        return new AST_Yield({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.argument),
          is_star: M22.delegate
        });
      },
      DebuggerStatement: function(M22) {
        return new AST_Debugger({
          start: my_start_token(M22),
          end: my_end_token(M22)
        });
      },
      VariableDeclarator: function(M22) {
        return new AST_VarDef({
          start: my_start_token(M22),
          end: my_end_token(M22),
          name: from_moz(M22.id),
          value: from_moz(M22.init)
        });
      },
      CatchClause: function(M22) {
        return new AST_Catch({
          start: my_start_token(M22),
          end: my_end_token(M22),
          argname: from_moz(M22.param),
          body: from_moz(M22.body).body
        });
      },
      ThisExpression: function(M22) {
        return new AST_This({
          start: my_start_token(M22),
          end: my_end_token(M22)
        });
      },
      Super: function(M22) {
        return new AST_Super({
          start: my_start_token(M22),
          end: my_end_token(M22)
        });
      },
      BinaryExpression: function(M22) {
        if (M22.left.type === "PrivateIdentifier") {
          return new AST_PrivateIn({
            start: my_start_token(M22),
            end: my_end_token(M22),
            key: new AST_SymbolPrivateProperty({
              start: my_start_token(M22.left),
              end: my_end_token(M22.left),
              name: M22.left.name
            }),
            value: from_moz(M22.right)
          });
        }
        return new AST_Binary({
          start: my_start_token(M22),
          end: my_end_token(M22),
          operator: M22.operator,
          left: from_moz(M22.left),
          right: from_moz(M22.right)
        });
      },
      LogicalExpression: function(M22) {
        return new AST_Binary({
          start: my_start_token(M22),
          end: my_end_token(M22),
          operator: M22.operator,
          left: from_moz(M22.left),
          right: from_moz(M22.right)
        });
      },
      AssignmentExpression: function(M22) {
        return new AST_Assign({
          start: my_start_token(M22),
          end: my_end_token(M22),
          operator: M22.operator,
          left: from_moz(M22.left),
          right: from_moz(M22.right)
        });
      },
      ConditionalExpression: function(M22) {
        return new AST_Conditional({
          start: my_start_token(M22),
          end: my_end_token(M22),
          condition: from_moz(M22.test),
          consequent: from_moz(M22.consequent),
          alternative: from_moz(M22.alternate)
        });
      },
      NewExpression: function(M22) {
        return new AST_New({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.callee),
          args: M22.arguments.map(from_moz)
        });
      },
      CallExpression: function(M22) {
        return new AST_Call({
          start: my_start_token(M22),
          end: my_end_token(M22),
          expression: from_moz(M22.callee),
          optional: M22.optional,
          args: M22.arguments.map(from_moz)
        });
      }
    };
    MOZ_TO_ME.UpdateExpression = MOZ_TO_ME.UnaryExpression = function To_Moz_Unary(M22) {
      var prefix = "prefix" in M22 ? M22.prefix : M22.type == "UnaryExpression" ? true : false;
      return new (prefix ? AST_UnaryPrefix : AST_UnaryPostfix)({
        start: my_start_token(M22),
        end: my_end_token(M22),
        operator: M22.operator,
        expression: from_moz(M22.argument)
      });
    };
    MOZ_TO_ME.ClassDeclaration = MOZ_TO_ME.ClassExpression = function From_Moz_Class(M22) {
      return new (M22.type === "ClassDeclaration" ? AST_DefClass : AST_ClassExpression)({
        start: my_start_token(M22),
        end: my_end_token(M22),
        name: from_moz(M22.id),
        extends: from_moz(M22.superClass),
        properties: M22.body.body.map(from_moz)
      });
    };
    def_to_moz(AST_EmptyStatement, function To_Moz_EmptyStatement() {
      return {
        type: "EmptyStatement"
      };
    });
    def_to_moz(AST_BlockStatement, function To_Moz_BlockStatement(M22) {
      return {
        type: "BlockStatement",
        body: M22.body.map(to_moz)
      };
    });
    def_to_moz(AST_If, function To_Moz_IfStatement(M22) {
      return {
        type: "IfStatement",
        test: to_moz(M22.condition),
        consequent: to_moz(M22.body),
        alternate: to_moz(M22.alternative)
      };
    });
    def_to_moz(AST_LabeledStatement, function To_Moz_LabeledStatement(M22) {
      return {
        type: "LabeledStatement",
        label: to_moz(M22.label),
        body: to_moz(M22.body)
      };
    });
    def_to_moz(AST_Break, function To_Moz_BreakStatement(M22) {
      return {
        type: "BreakStatement",
        label: to_moz(M22.label)
      };
    });
    def_to_moz(AST_Continue, function To_Moz_ContinueStatement(M22) {
      return {
        type: "ContinueStatement",
        label: to_moz(M22.label)
      };
    });
    def_to_moz(AST_With, function To_Moz_WithStatement(M22) {
      return {
        type: "WithStatement",
        object: to_moz(M22.expression),
        body: to_moz(M22.body)
      };
    });
    def_to_moz(AST_Switch, function To_Moz_SwitchStatement(M22) {
      return {
        type: "SwitchStatement",
        discriminant: to_moz(M22.expression),
        cases: M22.body.map(to_moz)
      };
    });
    def_to_moz(AST_Return, function To_Moz_ReturnStatement(M22) {
      return {
        type: "ReturnStatement",
        argument: to_moz(M22.value)
      };
    });
    def_to_moz(AST_Throw, function To_Moz_ThrowStatement(M22) {
      return {
        type: "ThrowStatement",
        argument: to_moz(M22.value)
      };
    });
    def_to_moz(AST_While, function To_Moz_WhileStatement(M22) {
      return {
        type: "WhileStatement",
        test: to_moz(M22.condition),
        body: to_moz(M22.body)
      };
    });
    def_to_moz(AST_Do, function To_Moz_DoWhileStatement(M22) {
      return {
        type: "DoWhileStatement",
        test: to_moz(M22.condition),
        body: to_moz(M22.body)
      };
    });
    def_to_moz(AST_For, function To_Moz_ForStatement(M22) {
      return {
        type: "ForStatement",
        init: to_moz(M22.init),
        test: to_moz(M22.condition),
        update: to_moz(M22.step),
        body: to_moz(M22.body)
      };
    });
    def_to_moz(AST_ForIn, function To_Moz_ForInStatement(M22) {
      return {
        type: "ForInStatement",
        left: to_moz(M22.init),
        right: to_moz(M22.object),
        body: to_moz(M22.body)
      };
    });
    def_to_moz(AST_ForOf, function To_Moz_ForOfStatement(M22) {
      return {
        type: "ForOfStatement",
        left: to_moz(M22.init),
        right: to_moz(M22.object),
        body: to_moz(M22.body),
        await: M22.await
      };
    });
    def_to_moz(AST_Await, function To_Moz_AwaitExpression(M22) {
      return {
        type: "AwaitExpression",
        argument: to_moz(M22.expression)
      };
    });
    def_to_moz(AST_Yield, function To_Moz_YieldExpression(M22) {
      return {
        type: "YieldExpression",
        argument: to_moz(M22.expression),
        delegate: M22.is_star
      };
    });
    def_to_moz(AST_Debugger, function To_Moz_DebuggerStatement() {
      return {
        type: "DebuggerStatement"
      };
    });
    def_to_moz(AST_VarDef, function To_Moz_VariableDeclarator(M22) {
      return {
        type: "VariableDeclarator",
        id: to_moz(M22.name),
        init: to_moz(M22.value)
      };
    });
    def_to_moz(AST_Catch, function To_Moz_CatchClause(M22) {
      return {
        type: "CatchClause",
        param: to_moz(M22.argname),
        body: to_moz_block(M22)
      };
    });
    def_to_moz(AST_This, function To_Moz_ThisExpression() {
      return {
        type: "ThisExpression"
      };
    });
    def_to_moz(AST_Super, function To_Moz_Super() {
      return {
        type: "Super"
      };
    });
    def_to_moz(AST_Binary, function To_Moz_BinaryExpression(M22) {
      return {
        type: "BinaryExpression",
        operator: M22.operator,
        left: to_moz(M22.left),
        right: to_moz(M22.right)
      };
    });
    def_to_moz(AST_Binary, function To_Moz_LogicalExpression(M22) {
      return {
        type: "LogicalExpression",
        operator: M22.operator,
        left: to_moz(M22.left),
        right: to_moz(M22.right)
      };
    });
    def_to_moz(AST_Assign, function To_Moz_AssignmentExpression(M22) {
      return {
        type: "AssignmentExpression",
        operator: M22.operator,
        left: to_moz(M22.left),
        right: to_moz(M22.right)
      };
    });
    def_to_moz(AST_Conditional, function To_Moz_ConditionalExpression(M22) {
      return {
        type: "ConditionalExpression",
        test: to_moz(M22.condition),
        consequent: to_moz(M22.consequent),
        alternate: to_moz(M22.alternative)
      };
    });
    def_to_moz(AST_New, function To_Moz_NewExpression(M22) {
      return {
        type: "NewExpression",
        callee: to_moz(M22.expression),
        arguments: M22.args.map(to_moz)
      };
    });
    def_to_moz(AST_Call, function To_Moz_CallExpression(M22) {
      if (M22.expression instanceof AST_SymbolRef && M22.expression.name === "import") {
        const [source, options3] = M22.args.map(to_moz);
        return {
          type: "ImportExpression",
          source,
          options: options3
        };
      }
      return {
        type: "CallExpression",
        callee: to_moz(M22.expression),
        optional: M22.optional,
        arguments: M22.args.map(to_moz)
      };
    });
    def_to_moz(AST_Toplevel, function To_Moz_Program(M22) {
      return to_moz_scope("Program", M22);
    });
    def_to_moz(AST_Expansion, function To_Moz_Spread(M22) {
      return {
        type: to_moz_in_destructuring() ? "RestElement" : "SpreadElement",
        argument: to_moz(M22.expression)
      };
    });
    def_to_moz(AST_PrefixedTemplateString, function To_Moz_TaggedTemplateExpression(M22) {
      return {
        type: "TaggedTemplateExpression",
        tag: to_moz(M22.prefix),
        quasi: to_moz(M22.template_string)
      };
    });
    def_to_moz(AST_TemplateString, function To_Moz_TemplateLiteral(M22) {
      var quasis = [];
      var expressions = [];
      for (var i2 = 0;i2 < M22.segments.length; i2++) {
        if (i2 % 2 !== 0) {
          expressions.push(to_moz(M22.segments[i2]));
        } else {
          quasis.push({
            type: "TemplateElement",
            value: {
              raw: M22.segments[i2].raw,
              cooked: M22.segments[i2].value
            },
            tail: i2 === M22.segments.length - 1
          });
        }
      }
      return {
        type: "TemplateLiteral",
        quasis,
        expressions
      };
    });
    def_to_moz(AST_Defun, function To_Moz_FunctionDeclaration(M22) {
      return {
        type: "FunctionDeclaration",
        id: to_moz(M22.name),
        params: M22.argnames.map(to_moz),
        generator: M22.is_generator,
        async: M22.async,
        body: to_moz_scope("BlockStatement", M22)
      };
    });
    def_to_moz(AST_Function, function To_Moz_FunctionExpression(M22, parent) {
      var is_generator = parent.is_generator !== undefined ? parent.is_generator : M22.is_generator;
      return {
        type: "FunctionExpression",
        id: to_moz(M22.name),
        params: M22.argnames.map(to_moz),
        generator: is_generator,
        async: M22.async,
        body: to_moz_scope("BlockStatement", M22)
      };
    });
    def_to_moz(AST_Arrow, function To_Moz_ArrowFunctionExpression(M22) {
      var body = {
        type: "BlockStatement",
        body: M22.body.map(to_moz)
      };
      return {
        type: "ArrowFunctionExpression",
        params: M22.argnames.map(to_moz),
        async: M22.async,
        body
      };
    });
    def_to_moz(AST_Destructuring, function To_Moz_ObjectPattern(M22) {
      if (M22.is_array) {
        return {
          type: "ArrayPattern",
          elements: M22.names.map(to_moz)
        };
      }
      return {
        type: "ObjectPattern",
        properties: M22.names.map(to_moz)
      };
    });
    def_to_moz(AST_Directive, function To_Moz_Directive(M22) {
      return {
        type: "ExpressionStatement",
        expression: {
          type: "Literal",
          value: M22.value,
          raw: M22.print_to_string()
        },
        directive: M22.value
      };
    });
    def_to_moz(AST_SimpleStatement, function To_Moz_ExpressionStatement(M22) {
      return {
        type: "ExpressionStatement",
        expression: to_moz(M22.body)
      };
    });
    def_to_moz(AST_SwitchBranch, function To_Moz_SwitchCase(M22) {
      return {
        type: "SwitchCase",
        test: to_moz(M22.expression),
        consequent: M22.body.map(to_moz)
      };
    });
    def_to_moz(AST_Try, function To_Moz_TryStatement(M22) {
      return {
        type: "TryStatement",
        block: to_moz_block(M22.body),
        handler: to_moz(M22.bcatch),
        guardedHandlers: [],
        finalizer: to_moz(M22.bfinally)
      };
    });
    def_to_moz(AST_Catch, function To_Moz_CatchClause(M22) {
      return {
        type: "CatchClause",
        param: to_moz(M22.argname),
        guard: null,
        body: to_moz_block(M22)
      };
    });
    def_to_moz(AST_Definitions, function To_Moz_VariableDeclaration(M22) {
      return {
        type: "VariableDeclaration",
        kind: M22 instanceof AST_Const ? "const" : M22 instanceof AST_Let ? "let" : "var",
        declarations: M22.definitions.map(to_moz)
      };
    });
    function import_attributes_to_moz(attribute) {
      const import_attributes = [];
      if (attribute) {
        for (const { key, value } of attribute.properties) {
          const key_moz = is_basic_identifier_string(key) ? { type: "Identifier", name: key } : { type: "Literal", value: key, raw: JSON.stringify(key) };
          import_attributes.push({
            type: "ImportAttribute",
            key: key_moz,
            value: to_moz(value)
          });
        }
      }
      return import_attributes;
    }
    def_to_moz(AST_Export, function To_Moz_ExportDeclaration(M22) {
      if (M22.exported_names) {
        var first_exported = M22.exported_names[0];
        var first_exported_name = first_exported.name;
        if (first_exported_name.name === "*" && !first_exported_name.quote) {
          var foreign_name = first_exported.foreign_name;
          var exported = foreign_name.name === "*" && !foreign_name.quote ? null : to_moz(foreign_name);
          return {
            type: "ExportAllDeclaration",
            source: to_moz(M22.module_name),
            exported,
            attributes: import_attributes_to_moz(M22.attributes)
          };
        }
        return {
          type: "ExportNamedDeclaration",
          specifiers: M22.exported_names.map(function(name_mapping) {
            return {
              type: "ExportSpecifier",
              exported: to_moz(name_mapping.foreign_name),
              local: to_moz(name_mapping.name)
            };
          }),
          declaration: to_moz(M22.exported_definition),
          source: to_moz(M22.module_name),
          attributes: import_attributes_to_moz(M22.attributes)
        };
      }
      return {
        type: M22.is_default ? "ExportDefaultDeclaration" : "ExportNamedDeclaration",
        declaration: to_moz(M22.exported_value || M22.exported_definition)
      };
    });
    def_to_moz(AST_Import, function To_Moz_ImportDeclaration(M22) {
      var specifiers = [];
      if (M22.imported_name) {
        specifiers.push({
          type: "ImportDefaultSpecifier",
          local: to_moz(M22.imported_name)
        });
      }
      if (M22.imported_names) {
        var first_imported_foreign_name = M22.imported_names[0].foreign_name;
        if (first_imported_foreign_name.name === "*" && !first_imported_foreign_name.quote) {
          specifiers.push({
            type: "ImportNamespaceSpecifier",
            local: to_moz(M22.imported_names[0].name)
          });
        } else {
          M22.imported_names.forEach(function(name_mapping) {
            specifiers.push({
              type: "ImportSpecifier",
              local: to_moz(name_mapping.name),
              imported: to_moz(name_mapping.foreign_name)
            });
          });
        }
      }
      return {
        type: "ImportDeclaration",
        specifiers,
        source: to_moz(M22.module_name),
        attributes: import_attributes_to_moz(M22.attributes)
      };
    });
    def_to_moz(AST_ImportMeta, function To_Moz_MetaProperty() {
      return {
        type: "MetaProperty",
        meta: {
          type: "Identifier",
          name: "import"
        },
        property: {
          type: "Identifier",
          name: "meta"
        }
      };
    });
    def_to_moz(AST_Sequence, function To_Moz_SequenceExpression(M22) {
      return {
        type: "SequenceExpression",
        expressions: M22.expressions.map(to_moz)
      };
    });
    def_to_moz(AST_DotHash, function To_Moz_PrivateMemberExpression(M22) {
      return {
        type: "MemberExpression",
        object: to_moz(M22.expression),
        computed: false,
        property: {
          type: "PrivateIdentifier",
          name: M22.property
        },
        optional: M22.optional
      };
    });
    def_to_moz(AST_PropAccess, function To_Moz_MemberExpression(M22) {
      var isComputed = M22 instanceof AST_Sub;
      return {
        type: "MemberExpression",
        object: to_moz(M22.expression),
        computed: isComputed,
        property: isComputed ? to_moz(M22.property) : { type: "Identifier", name: M22.property },
        optional: M22.optional
      };
    });
    def_to_moz(AST_Chain, function To_Moz_ChainExpression(M22) {
      return {
        type: "ChainExpression",
        expression: to_moz(M22.expression)
      };
    });
    def_to_moz(AST_Unary, function To_Moz_Unary(M22) {
      return {
        type: M22.operator == "++" || M22.operator == "--" ? "UpdateExpression" : "UnaryExpression",
        operator: M22.operator,
        prefix: M22 instanceof AST_UnaryPrefix,
        argument: to_moz(M22.expression)
      };
    });
    def_to_moz(AST_Binary, function To_Moz_BinaryExpression(M22) {
      if (M22.operator == "=" && to_moz_in_destructuring()) {
        return {
          type: "AssignmentPattern",
          left: to_moz(M22.left),
          right: to_moz(M22.right)
        };
      }
      const type = M22.operator == "&&" || M22.operator == "||" || M22.operator === "??" ? "LogicalExpression" : "BinaryExpression";
      return {
        type,
        left: to_moz(M22.left),
        operator: M22.operator,
        right: to_moz(M22.right)
      };
    });
    def_to_moz(AST_PrivateIn, function To_Moz_BinaryExpression_PrivateIn(M22) {
      return {
        type: "BinaryExpression",
        left: { type: "PrivateIdentifier", name: M22.key.name },
        operator: "in",
        right: to_moz(M22.value)
      };
    });
    def_to_moz(AST_Array, function To_Moz_ArrayExpression(M22) {
      return {
        type: "ArrayExpression",
        elements: M22.elements.map(to_moz)
      };
    });
    def_to_moz(AST_Object, function To_Moz_ObjectExpression(M22) {
      return {
        type: "ObjectExpression",
        properties: M22.properties.map(to_moz)
      };
    });
    def_to_moz(AST_ObjectProperty, function To_Moz_Property(M22, parent) {
      var key = M22.key instanceof AST_Node ? to_moz(M22.key) : {
        type: "Identifier",
        value: M22.key
      };
      if (typeof M22.key === "number") {
        key = {
          type: "Literal",
          value: Number(M22.key)
        };
      }
      if (typeof M22.key === "string") {
        key = {
          type: "Identifier",
          name: M22.key
        };
      }
      var kind;
      var string_or_num = typeof M22.key === "string" || typeof M22.key === "number";
      var computed = string_or_num ? false : !(M22.key instanceof AST_Symbol) || M22.key instanceof AST_SymbolRef;
      if (M22 instanceof AST_ObjectKeyVal) {
        kind = "init";
        computed = !string_or_num;
      } else if (M22 instanceof AST_ObjectGetter) {
        kind = "get";
      } else if (M22 instanceof AST_ObjectSetter) {
        kind = "set";
      }
      if (M22 instanceof AST_PrivateGetter || M22 instanceof AST_PrivateSetter) {
        const kind2 = M22 instanceof AST_PrivateGetter ? "get" : "set";
        return {
          type: "MethodDefinition",
          computed: false,
          kind: kind2,
          static: M22.static,
          key: {
            type: "PrivateIdentifier",
            name: M22.key.name
          },
          value: to_moz(M22.value)
        };
      }
      if (M22 instanceof AST_ClassPrivateProperty) {
        return {
          type: "PropertyDefinition",
          key: {
            type: "PrivateIdentifier",
            name: M22.key.name
          },
          value: to_moz(M22.value),
          computed: false,
          static: M22.static
        };
      }
      if (M22 instanceof AST_ClassProperty) {
        return {
          type: "PropertyDefinition",
          key,
          value: to_moz(M22.value),
          computed,
          static: M22.static
        };
      }
      if (parent instanceof AST_Class) {
        return {
          type: "MethodDefinition",
          computed,
          kind,
          static: M22.static,
          key: to_moz(M22.key),
          value: to_moz(M22.value)
        };
      }
      return {
        type: "Property",
        computed,
        kind,
        key,
        value: to_moz(M22.value)
      };
    });
    def_to_moz(AST_ConciseMethod, function To_Moz_MethodDefinition(M22, parent) {
      if (parent instanceof AST_Object) {
        return {
          type: "Property",
          computed: !(M22.key instanceof AST_Symbol) || M22.key instanceof AST_SymbolRef,
          kind: "init",
          method: true,
          shorthand: false,
          key: to_moz(M22.key),
          value: to_moz(M22.value)
        };
      }
      const key = M22 instanceof AST_PrivateMethod ? {
        type: "PrivateIdentifier",
        name: M22.key.name
      } : to_moz(M22.key);
      return {
        type: "MethodDefinition",
        kind: M22.key === "constructor" ? "constructor" : "method",
        key,
        value: to_moz(M22.value),
        computed: !(M22.key instanceof AST_Symbol) || M22.key instanceof AST_SymbolRef,
        static: M22.static
      };
    });
    def_to_moz(AST_Class, function To_Moz_Class(M22) {
      var type = M22 instanceof AST_ClassExpression ? "ClassExpression" : "ClassDeclaration";
      return {
        type,
        superClass: to_moz(M22.extends),
        id: M22.name ? to_moz(M22.name) : null,
        body: {
          type: "ClassBody",
          body: M22.properties.map(to_moz)
        }
      };
    });
    def_to_moz(AST_ClassStaticBlock, function To_Moz_StaticBlock(M22) {
      return {
        type: "StaticBlock",
        body: M22.body.map(to_moz)
      };
    });
    def_to_moz(AST_NewTarget, function To_Moz_MetaProperty() {
      return {
        type: "MetaProperty",
        meta: {
          type: "Identifier",
          name: "new"
        },
        property: {
          type: "Identifier",
          name: "target"
        }
      };
    });
    def_to_moz(AST_Symbol, function To_Moz_Identifier(M22, parent) {
      if (M22 instanceof AST_SymbolMethod && parent.quote || (M22 instanceof AST_SymbolImportForeign || M22 instanceof AST_SymbolExportForeign || M22 instanceof AST_SymbolExport) && M22.quote) {
        return {
          type: "Literal",
          value: M22.name
        };
      }
      var def = M22.definition();
      return {
        type: "Identifier",
        name: def ? def.mangled_name || def.name : M22.name
      };
    });
    def_to_moz(AST_RegExp, function To_Moz_RegExpLiteral(M22) {
      const pattern = M22.value.source;
      const flags = M22.value.flags;
      return {
        type: "Literal",
        value: null,
        raw: M22.print_to_string(),
        regex: { pattern, flags }
      };
    });
    def_to_moz(AST_Constant, function To_Moz_Literal(M22) {
      var value = M22.value;
      return {
        type: "Literal",
        value,
        raw: M22.raw || M22.print_to_string()
      };
    });
    def_to_moz(AST_Atom, function To_Moz_Atom(M22) {
      return {
        type: "Identifier",
        name: String(M22.value)
      };
    });
    def_to_moz(AST_BigInt, (M22) => ({
      type: "Literal",
      value: null,
      bigint: typeof BigInt === "function" ? BigInt(M22.value).toString() : M22.value
    }));
    AST_Boolean.DEFMETHOD("to_mozilla_ast", AST_Constant.prototype.to_mozilla_ast);
    AST_Null.DEFMETHOD("to_mozilla_ast", AST_Constant.prototype.to_mozilla_ast);
    AST_Hole.DEFMETHOD("to_mozilla_ast", function To_Moz_ArrayHole() {
      return null;
    });
    AST_Block.DEFMETHOD("to_mozilla_ast", AST_BlockStatement.prototype.to_mozilla_ast);
    AST_Lambda.DEFMETHOD("to_mozilla_ast", AST_Function.prototype.to_mozilla_ast);
    function my_start_token(moznode) {
      var loc = moznode.loc, start = loc && loc.start;
      var range = moznode.range;
      return new AST_Token("", "", start && start.line || 0, start && start.column || 0, range ? range[0] : moznode.start, false, [], [], loc && loc.source);
    }
    function my_end_token(moznode) {
      var loc = moznode.loc, end = loc && loc.end;
      var range = moznode.range;
      return new AST_Token("", "", end && end.line || 0, end && end.column || 0, range ? range[0] : moznode.end, false, [], [], loc && loc.source);
    }
    var FROM_MOZ_STACK = null;
    function from_moz(node) {
      FROM_MOZ_STACK.push(node);
      var ret = node != null ? MOZ_TO_ME[node.type](node) : null;
      FROM_MOZ_STACK.pop();
      return ret;
    }
    AST_Node.from_mozilla_ast = function(node) {
      var save_stack = FROM_MOZ_STACK;
      FROM_MOZ_STACK = [];
      var ast = from_moz(node);
      FROM_MOZ_STACK = save_stack;
      return ast;
    };
    function set_moz_loc(mynode, moznode) {
      var start = mynode.start;
      var end = mynode.end;
      if (!(start && end)) {
        return moznode;
      }
      if (start.pos != null && end.endpos != null) {
        moznode.range = [start.pos, end.endpos];
      }
      if (start.line) {
        moznode.loc = {
          start: { line: start.line, column: start.col },
          end: end.endline ? { line: end.endline, column: end.endcol } : null
        };
        if (start.file) {
          moznode.loc.source = start.file;
        }
      }
      return moznode;
    }
    function def_to_moz(mytype, handler3) {
      mytype.DEFMETHOD("to_mozilla_ast", function(parent) {
        return set_moz_loc(this, handler3(this, parent));
      });
    }
    var TO_MOZ_STACK = null;
    function to_moz(node) {
      if (TO_MOZ_STACK === null) {
        TO_MOZ_STACK = [];
      }
      TO_MOZ_STACK.push(node);
      var ast = node != null ? node.to_mozilla_ast(TO_MOZ_STACK[TO_MOZ_STACK.length - 2]) : null;
      TO_MOZ_STACK.pop();
      if (TO_MOZ_STACK.length === 0) {
        TO_MOZ_STACK = null;
      }
      return ast;
    }
    function to_moz_in_destructuring() {
      var i2 = TO_MOZ_STACK.length;
      while (i2--) {
        if (TO_MOZ_STACK[i2] instanceof AST_Destructuring) {
          return true;
        }
      }
      return false;
    }
    function to_moz_block(node) {
      return {
        type: "BlockStatement",
        body: node.body.map(to_moz)
      };
    }
    function to_moz_scope(type, node) {
      var body = node.body.map(to_moz);
      if (node.body[0] instanceof AST_SimpleStatement && node.body[0].body instanceof AST_String) {
        body.unshift(to_moz(new AST_EmptyStatement(node.body[0])));
      }
      return {
        type,
        body
      };
    }
  })();
});
function first_in_statement(stack) {
  let node = stack.parent(-1);
  for (let i2 = 0, p32;p32 = stack.parent(i2); i2++) {
    if (p32 instanceof AST_Statement && p32.body === node)
      return true;
    if (p32 instanceof AST_Sequence && p32.expressions[0] === node || p32.TYPE === "Call" && p32.expression === node || p32 instanceof AST_PrefixedTemplateString && p32.prefix === node || p32 instanceof AST_Dot && p32.expression === node || p32 instanceof AST_Sub && p32.expression === node || p32 instanceof AST_Chain && p32.expression === node || p32 instanceof AST_Conditional && p32.condition === node || p32 instanceof AST_Binary && p32.left === node || p32 instanceof AST_UnaryPostfix && p32.expression === node) {
      node = p32;
    } else {
      return false;
    }
  }
}
function left_is_object(node) {
  if (node instanceof AST_Object)
    return true;
  if (node instanceof AST_Sequence)
    return left_is_object(node.expressions[0]);
  if (node.TYPE === "Call")
    return left_is_object(node.expression);
  if (node instanceof AST_PrefixedTemplateString)
    return left_is_object(node.prefix);
  if (node instanceof AST_Dot || node instanceof AST_Sub)
    return left_is_object(node.expression);
  if (node instanceof AST_Chain)
    return left_is_object(node.expression);
  if (node instanceof AST_Conditional)
    return left_is_object(node.condition);
  if (node instanceof AST_Binary)
    return left_is_object(node.left);
  if (node instanceof AST_UnaryPostfix)
    return left_is_object(node.expression);
  return false;
}
var init_first_in_statement = __esm2(() => {
  init_ast();
});
function is_some_comments(comment) {
  return (comment.type === "comment2" || comment.type === "comment1") && /@preserve|@copyright|@lic|@cc_on|^\**!/i.test(comment.value);
}

class Rope {
  constructor() {
    this.committed = "";
    this.current = "";
  }
  append(str) {
    if (this.current.length > ROPE_COMMIT_WHEN) {
      this.committed += this.current + str;
      this.current = "";
    } else {
      this.current += str;
    }
  }
  insertAt(char, index) {
    const { committed, current: current2 } = this;
    if (index < committed.length) {
      this.committed = committed.slice(0, index) + char + committed.slice(index);
    } else if (index === committed.length) {
      this.committed += char;
    } else {
      index -= committed.length;
      this.committed += current2.slice(0, index) + char;
      this.current = current2.slice(index);
    }
  }
  charAt(index) {
    const { committed } = this;
    if (index < committed.length)
      return committed[index];
    return this.current[index - committed.length];
  }
  charCodeAt(index) {
    const { committed } = this;
    if (index < committed.length)
      return committed.charCodeAt(index);
    return this.current.charCodeAt(index - committed.length);
  }
  length() {
    return this.committed.length + this.current.length;
  }
  expectDirective() {
    let ch, n = this.length();
    if (n <= 0)
      return true;
    while ((ch = this.charCodeAt(--n)) && (ch == CODE_SPACE || ch == CODE_LINE_BREAK))
      ;
    return !ch || ch === 59 || ch === 123;
  }
  hasNLB() {
    let n = this.length() - 1;
    while (n >= 0) {
      const code = this.charCodeAt(n--);
      if (code === CODE_LINE_BREAK)
        return true;
      if (code !== CODE_SPACE)
        return false;
    }
    return true;
  }
  toString() {
    return this.committed + this.current;
  }
}
function OutputStream(options3) {
  var readonly = !options3;
  options3 = defaults2(options3, {
    ascii_only: false,
    beautify: false,
    braces: false,
    comments: "some",
    ecma: 5,
    ie8: false,
    indent_level: 4,
    indent_start: 0,
    inline_script: true,
    keep_numbers: false,
    keep_quoted_props: false,
    max_line_len: false,
    preamble: null,
    preserve_annotations: false,
    quote_keys: false,
    quote_style: 0,
    safari10: false,
    semicolons: true,
    shebang: true,
    shorthand: undefined,
    source_map: null,
    webkit: false,
    width: 80,
    wrap_iife: false,
    wrap_func_args: true,
    _destroy_ast: false
  }, true);
  if (options3.shorthand === undefined)
    options3.shorthand = options3.ecma > 5;
  var comment_filter = return_false;
  if (options3.comments) {
    let comments = options3.comments;
    if (typeof options3.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(options3.comments)) {
      var regex_pos = options3.comments.lastIndexOf("/");
      comments = new RegExp(options3.comments.substr(1, regex_pos - 1), options3.comments.substr(regex_pos + 1));
    }
    if (comments instanceof RegExp) {
      comment_filter = function(comment) {
        return comment.type != "comment5" && comments.test(comment.value);
      };
    } else if (typeof comments === "function") {
      comment_filter = function(comment) {
        return comment.type != "comment5" && comments(this, comment);
      };
    } else if (comments === "some") {
      comment_filter = is_some_comments;
    } else {
      comment_filter = return_true;
    }
  }
  if (options3.preserve_annotations) {
    let prev_comment_filter = comment_filter;
    comment_filter = function(comment) {
      return r_annotation.test(comment.value) || prev_comment_filter.apply(this, arguments);
    };
  }
  var indentation = 0;
  var current_col = 0;
  var current_line = 1;
  var current_pos = 0;
  var OUTPUT = new Rope;
  let printed_comments = new Set;
  var to_utf8 = options3.ascii_only ? function(str, identifier = false, regexp = false) {
    if (options3.ecma >= 2015 && !options3.safari10 && !regexp) {
      str = str.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(ch) {
        var code = get_full_char_code(ch, 0).toString(16);
        return "\\u{" + code + "}";
      });
    }
    return str.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(ch) {
      var code = ch.charCodeAt(0).toString(16);
      if (code.length <= 2 && !identifier) {
        while (code.length < 2)
          code = "0" + code;
        return "\\x" + code;
      } else {
        while (code.length < 4)
          code = "0" + code;
        return "\\u" + code;
      }
    });
  } : function(str) {
    return str.replace(/[\ud800-\udbff][\udc00-\udfff]|([\ud800-\udbff]|[\udc00-\udfff])/g, function(match, lone) {
      if (lone) {
        return "\\u" + lone.charCodeAt(0).toString(16);
      }
      return match;
    });
  };
  function make_string(str, quote) {
    var dq = 0, sq = 0;
    str = str.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(s32, i2) {
      switch (s32) {
        case '"':
          ++dq;
          return '"';
        case "'":
          ++sq;
          return "'";
        case "\\":
          return "\\\\";
        case "\n":
          return "\\n";
        case "\r":
          return "\\r";
        case "\t":
          return "\\t";
        case "\b":
          return "\\b";
        case "\f":
          return "\\f";
        case "\v":
          return options3.ie8 ? "\\x0B" : "\\v";
        case "\u2028":
          return "\\u2028";
        case "\u2029":
          return "\\u2029";
        case "\uFEFF":
          return "\\ufeff";
        case "\0":
          return /[0-9]/.test(get_full_char(str, i2 + 1)) ? "\\x00" : "\\0";
      }
      return s32;
    });
    function quote_single() {
      return "'" + str.replace(/\x27/g, "\\'") + "'";
    }
    function quote_double() {
      return '"' + str.replace(/\x22/g, '\\"') + '"';
    }
    function quote_template() {
      return "`" + str.replace(/`/g, "\\`") + "`";
    }
    str = to_utf8(str);
    if (quote === "`")
      return quote_template();
    switch (options3.quote_style) {
      case 1:
        return quote_single();
      case 2:
        return quote_double();
      case 3:
        return quote == "'" ? quote_single() : quote_double();
      default:
        return dq > sq ? quote_single() : quote_double();
    }
  }
  function encode_string(str, quote) {
    var ret = make_string(str, quote);
    if (options3.inline_script) {
      ret = ret.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
      ret = ret.replace(/\x3c!--/g, "\\x3c!--");
      ret = ret.replace(/--\x3e/g, "--\\x3e");
    }
    return ret;
  }
  function make_name(name) {
    name = name.toString();
    name = to_utf8(name, true);
    return name;
  }
  function make_indent(back) {
    return " ".repeat(options3.indent_start + indentation - back * options3.indent_level);
  }
  var has_parens = false;
  var might_need_space = false;
  var might_need_semicolon = false;
  var might_add_newline = 0;
  var need_newline_indented = false;
  var need_space = false;
  var newline_insert = -1;
  var last = "";
  var mapping_token, mapping_name, mappings = options3.source_map && [];
  var do_add_mapping = mappings ? function() {
    mappings.forEach(function(mapping) {
      try {
        let { name, token } = mapping;
        if (name !== false) {
          if (token.type == "name" || token.type === "privatename") {
            name = token.value;
          } else if (name instanceof AST_Symbol) {
            name = token.type === "string" ? token.value : name.name;
          }
        }
        options3.source_map.add(mapping.token.file, mapping.line, mapping.col, mapping.token.line, mapping.token.col, is_basic_identifier_string(name) ? name : undefined);
      } catch (ex) {
      }
    });
    mappings = [];
  } : noop;
  var ensure_line_len = options3.max_line_len ? function() {
    if (current_col > options3.max_line_len) {
      if (might_add_newline) {
        OUTPUT.insertAt("\n", might_add_newline);
        const len_after_newline = OUTPUT.length() - might_add_newline - 1;
        if (mappings) {
          var delta = len_after_newline - current_col;
          mappings.forEach(function(mapping) {
            mapping.line++;
            mapping.col += delta;
          });
        }
        current_line++;
        current_pos++;
        current_col = len_after_newline;
      }
    }
    if (might_add_newline) {
      might_add_newline = 0;
      do_add_mapping();
    }
  } : noop;
  var requireSemicolonChars = makePredicate("( [ + * / - , . `");
  function print(str) {
    str = String(str);
    var ch = get_full_char(str, 0);
    if (need_newline_indented && ch) {
      need_newline_indented = false;
      if (ch !== "\n") {
        print("\n");
        indent();
      }
    }
    if (need_space && ch) {
      need_space = false;
      if (!/[\s;})]/.test(ch)) {
        space2();
      }
    }
    newline_insert = -1;
    var prev = last.charAt(last.length - 1);
    if (might_need_semicolon) {
      might_need_semicolon = false;
      if (prev === ":" && ch === "}" || (!ch || !";}".includes(ch)) && prev !== ";") {
        if (options3.semicolons || requireSemicolonChars.has(ch)) {
          OUTPUT.append(";");
          current_col++;
          current_pos++;
        } else {
          ensure_line_len();
          if (current_col > 0) {
            OUTPUT.append("\n");
            current_pos++;
            current_line++;
            current_col = 0;
          }
          if (/^\s+$/.test(str)) {
            might_need_semicolon = true;
          }
        }
        if (!options3.beautify)
          might_need_space = false;
      }
    }
    if (might_need_space) {
      if (is_identifier_char(prev) && (is_identifier_char(ch) || ch == "\\") || ch == "/" && ch == prev || (ch == "+" || ch == "-") && ch == last) {
        OUTPUT.append(" ");
        current_col++;
        current_pos++;
      }
      might_need_space = false;
    }
    if (mapping_token) {
      mappings.push({
        token: mapping_token,
        name: mapping_name,
        line: current_line,
        col: current_col
      });
      mapping_token = false;
      if (!might_add_newline)
        do_add_mapping();
    }
    OUTPUT.append(str);
    has_parens = str[str.length - 1] == "(";
    current_pos += str.length;
    var a = str.split(/\r?\n/), n = a.length - 1;
    current_line += n;
    current_col += a[0].length;
    if (n > 0) {
      ensure_line_len();
      current_col = a[n].length;
    }
    last = str;
  }
  var star = function() {
    print("*");
  };
  var space2 = options3.beautify ? function() {
    print(" ");
  } : function() {
    might_need_space = true;
  };
  var indent = options3.beautify ? function(half) {
    if (options3.beautify) {
      print(make_indent(half ? 0.5 : 0));
    }
  } : noop;
  var with_indent = options3.beautify ? function(col, cont) {
    if (col === true)
      col = next_indent();
    var save_indentation = indentation;
    indentation = col;
    var ret = cont();
    indentation = save_indentation;
    return ret;
  } : function(col, cont) {
    return cont();
  };
  var newline = options3.beautify ? function() {
    if (newline_insert < 0)
      return print("\n");
    if (OUTPUT.charAt(newline_insert) != "\n") {
      OUTPUT.insertAt("\n", newline_insert);
      current_pos++;
      current_line++;
    }
    newline_insert++;
  } : options3.max_line_len ? function() {
    ensure_line_len();
    might_add_newline = OUTPUT.length();
  } : noop;
  var semicolon2 = options3.beautify ? function() {
    print(";");
  } : function() {
    might_need_semicolon = true;
  };
  function force_semicolon() {
    might_need_semicolon = false;
    print(";");
  }
  function next_indent() {
    return indentation + options3.indent_level;
  }
  function with_block(cont) {
    var ret;
    print("{");
    newline();
    with_indent(next_indent(), function() {
      ret = cont();
    });
    indent();
    print("}");
    return ret;
  }
  function with_parens(cont) {
    print("(");
    var ret = cont();
    print(")");
    return ret;
  }
  function with_square(cont) {
    print("[");
    var ret = cont();
    print("]");
    return ret;
  }
  function comma2() {
    print(",");
    space2();
  }
  function colon() {
    print(":");
    space2();
  }
  var add_mapping = mappings ? function(token, name) {
    mapping_token = token;
    mapping_name = name;
  } : noop;
  function get() {
    if (might_add_newline) {
      ensure_line_len();
    }
    return OUTPUT.toString();
  }
  function filter_comment(comment) {
    if (!options3.preserve_annotations) {
      comment = comment.replace(r_annotation, " ");
    }
    if (/^\s*$/.test(comment)) {
      return "";
    }
    return comment.replace(/(<\s*\/\s*)(script)/i, "<\\/$2");
  }
  function prepend_comments(node) {
    var self2 = this;
    var start = node.start;
    if (!start)
      return;
    var printed_comments2 = self2.printed_comments;
    const keyword_with_value = node instanceof AST_Exit && node.value || (node instanceof AST_Await || node instanceof AST_Yield) && node.expression;
    if (start.comments_before && printed_comments2.has(start.comments_before)) {
      if (keyword_with_value) {
        start.comments_before = [];
      } else {
        return;
      }
    }
    var comments = start.comments_before;
    if (!comments) {
      comments = start.comments_before = [];
    }
    printed_comments2.add(comments);
    if (keyword_with_value) {
      var tw = new TreeWalker(function(node2) {
        var parent = tw.parent();
        if (parent instanceof AST_Exit || parent instanceof AST_Await || parent instanceof AST_Yield || parent instanceof AST_Binary && parent.left === node2 || parent.TYPE == "Call" && parent.expression === node2 || parent instanceof AST_Conditional && parent.condition === node2 || parent instanceof AST_Dot && parent.expression === node2 || parent instanceof AST_Sequence && parent.expressions[0] === node2 || parent instanceof AST_Sub && parent.expression === node2 || parent instanceof AST_UnaryPostfix) {
          if (!node2.start)
            return;
          var text22 = node2.start.comments_before;
          if (text22 && !printed_comments2.has(text22)) {
            printed_comments2.add(text22);
            comments = comments.concat(text22);
          }
        } else {
          return true;
        }
      });
      tw.push(node);
      keyword_with_value.walk(tw);
    }
    if (current_pos == 0) {
      if (comments.length > 0 && options3.shebang && comments[0].type === "comment5" && !printed_comments2.has(comments[0])) {
        print("#!" + comments.shift().value + "\n");
        indent();
      }
      var preamble = options3.preamble;
      if (preamble) {
        print(preamble.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
      }
    }
    comments = comments.filter(comment_filter, node).filter((c22) => !printed_comments2.has(c22));
    if (comments.length == 0)
      return;
    var last_nlb = OUTPUT.hasNLB();
    comments.forEach(function(c22, i2) {
      printed_comments2.add(c22);
      if (!last_nlb) {
        if (c22.nlb) {
          print("\n");
          indent();
          last_nlb = true;
        } else if (i2 > 0) {
          space2();
        }
      }
      if (/comment[134]/.test(c22.type)) {
        var value = filter_comment(c22.value);
        if (value) {
          print("//" + value + "\n");
          indent();
        }
        last_nlb = true;
      } else if (c22.type == "comment2") {
        var value = filter_comment(c22.value);
        if (value) {
          print("/*" + value + "*/");
        }
        last_nlb = false;
      }
    });
    if (!last_nlb) {
      if (start.nlb) {
        print("\n");
        indent();
      } else {
        space2();
      }
    }
  }
  function append_comments(node, tail) {
    var self2 = this;
    var token = node.end;
    if (!token)
      return;
    var printed_comments2 = self2.printed_comments;
    var comments = token[tail ? "comments_before" : "comments_after"];
    if (!comments || printed_comments2.has(comments))
      return;
    if (!(node instanceof AST_Statement || comments.every((c22) => !/comment[134]/.test(c22.type))))
      return;
    printed_comments2.add(comments);
    var insert = OUTPUT.length();
    comments.filter(comment_filter, node).forEach(function(c22, i2) {
      if (printed_comments2.has(c22))
        return;
      printed_comments2.add(c22);
      need_space = false;
      if (need_newline_indented) {
        print("\n");
        indent();
        need_newline_indented = false;
      } else if (c22.nlb && (i2 > 0 || !OUTPUT.hasNLB())) {
        print("\n");
        indent();
      } else if (i2 > 0 || !tail) {
        space2();
      }
      if (/comment[134]/.test(c22.type)) {
        const value = filter_comment(c22.value);
        if (value) {
          print("//" + value);
        }
        need_newline_indented = true;
      } else if (c22.type == "comment2") {
        const value = filter_comment(c22.value);
        if (value) {
          print("/*" + value + "*/");
        }
        need_space = true;
      }
    });
    if (OUTPUT.length() > insert)
      newline_insert = insert;
  }
  const gc_scope = options3["_destroy_ast"] ? function gc_scope(scope) {
    scope.body.length = 0;
    scope.argnames.length = 0;
  } : noop;
  var stack = [];
  return {
    get,
    toString: get,
    indent,
    in_directive: false,
    use_asm: null,
    active_scope: null,
    indentation: function() {
      return indentation;
    },
    current_width: function() {
      return current_col - indentation;
    },
    should_break: function() {
      return options3.width && this.current_width() >= options3.width;
    },
    has_parens: function() {
      return has_parens;
    },
    newline,
    print,
    star,
    space: space2,
    comma: comma2,
    colon,
    last: function() {
      return last;
    },
    semicolon: semicolon2,
    force_semicolon,
    to_utf8,
    print_name: function(name) {
      print(make_name(name));
    },
    print_string: function(str, quote, escape_directive) {
      var encoded = encode_string(str, quote);
      if (escape_directive === true && !encoded.includes("\\")) {
        if (!OUTPUT.expectDirective()) {
          force_semicolon();
        }
        force_semicolon();
      }
      print(encoded);
    },
    print_template_string_chars: function(str) {
      var encoded = encode_string(str, "`").replace(/\${/g, "\\${");
      return print(encoded.substr(1, encoded.length - 2));
    },
    encode_string,
    next_indent,
    with_indent,
    with_block,
    with_parens,
    with_square,
    add_mapping,
    option: function(opt) {
      return options3[opt];
    },
    gc_scope,
    printed_comments,
    prepend_comments: readonly ? noop : prepend_comments,
    append_comments: readonly || comment_filter === return_false ? noop : append_comments,
    line: function() {
      return current_line;
    },
    col: function() {
      return current_col;
    },
    pos: function() {
      return current_pos;
    },
    push_node: function(node) {
      stack.push(node);
    },
    pop_node: function() {
      return stack.pop();
    },
    parent: function(n) {
      return stack[stack.length - 2 - (n || 0)];
    }
  };
}
var CODE_LINE_BREAK = 10;
var CODE_SPACE = 32;
var r_annotation;
var ROPE_COMMIT_WHEN;
var init_output = __esm2(() => {
  init_utils5();
  init_first_in_statement();
  init_ast();
  init_parse2();
  r_annotation = /[@#]__(PURE|INLINE|NOINLINE)__/;
  ROPE_COMMIT_WHEN = 8000;
  (function() {
    function DEFPRINT(nodetype, generator) {
      nodetype.DEFMETHOD("_codegen", generator);
    }
    AST_Node.DEFMETHOD("print", function(output, force_parens) {
      var self2 = this, generator = self2._codegen;
      if (self2 instanceof AST_Scope) {
        output.active_scope = self2;
      } else if (!output.use_asm && self2 instanceof AST_Directive && self2.value == "use asm") {
        output.use_asm = output.active_scope;
      }
      function doit() {
        output.prepend_comments(self2);
        self2.add_source_map(output);
        generator(self2, output);
        output.append_comments(self2);
      }
      output.push_node(self2);
      if (force_parens || self2.needs_parens(output)) {
        output.with_parens(doit);
      } else {
        doit();
      }
      output.pop_node();
      if (self2 === output.use_asm) {
        output.use_asm = null;
      }
    });
    AST_Node.DEFMETHOD("_print", AST_Node.prototype.print);
    AST_Node.DEFMETHOD("print_to_string", function(options3) {
      var output = OutputStream(options3);
      this.print(output);
      return output.get();
    });
    function PARENS(nodetype, func) {
      if (Array.isArray(nodetype)) {
        nodetype.forEach(function(nodetype2) {
          PARENS(nodetype2, func);
        });
      } else {
        nodetype.DEFMETHOD("needs_parens", func);
      }
    }
    PARENS(AST_Node, return_false);
    PARENS(AST_Function, function(output) {
      if (!output.has_parens() && first_in_statement(output)) {
        return true;
      }
      if (output.option("webkit")) {
        var p32 = output.parent();
        if (p32 instanceof AST_PropAccess && p32.expression === this) {
          return true;
        }
      }
      if (output.option("wrap_iife")) {
        var p32 = output.parent();
        if (p32 instanceof AST_Call && p32.expression === this) {
          return true;
        }
      }
      if (output.option("wrap_func_args")) {
        var p32 = output.parent();
        if (p32 instanceof AST_Call && p32.args.includes(this)) {
          return true;
        }
      }
      return false;
    });
    PARENS(AST_Arrow, function(output) {
      var p32 = output.parent();
      if (output.option("wrap_func_args") && p32 instanceof AST_Call && p32.args.includes(this)) {
        return true;
      }
      return p32 instanceof AST_PropAccess && p32.expression === this || p32 instanceof AST_Conditional && p32.condition === this;
    });
    PARENS(AST_Object, function(output) {
      return !output.has_parens() && first_in_statement(output);
    });
    PARENS(AST_ClassExpression, first_in_statement);
    PARENS(AST_Unary, function(output) {
      var p32 = output.parent();
      return p32 instanceof AST_PropAccess && p32.expression === this || p32 instanceof AST_Call && p32.expression === this || p32 instanceof AST_Binary && p32.operator === "**" && this instanceof AST_UnaryPrefix && p32.left === this && this.operator !== "++" && this.operator !== "--";
    });
    PARENS(AST_Await, function(output) {
      var p32 = output.parent();
      return p32 instanceof AST_PropAccess && p32.expression === this || p32 instanceof AST_Call && p32.expression === this || p32 instanceof AST_Binary && p32.operator === "**" && p32.left === this || output.option("safari10") && p32 instanceof AST_UnaryPrefix;
    });
    PARENS(AST_Sequence, function(output) {
      var p32 = output.parent();
      return p32 instanceof AST_Call || p32 instanceof AST_Unary || p32 instanceof AST_Binary || p32 instanceof AST_VarDef || p32 instanceof AST_PropAccess || p32 instanceof AST_Array || p32 instanceof AST_ObjectProperty || p32 instanceof AST_Conditional || p32 instanceof AST_Arrow || p32 instanceof AST_DefaultAssign || p32 instanceof AST_Expansion || p32 instanceof AST_ForOf && this === p32.object || p32 instanceof AST_Yield || p32 instanceof AST_Export;
    });
    PARENS(AST_Binary, function(output) {
      var p32 = output.parent();
      if (p32 instanceof AST_Call && p32.expression === this)
        return true;
      if (p32 instanceof AST_Unary)
        return true;
      if (p32 instanceof AST_PropAccess && p32.expression === this)
        return true;
      if (p32 instanceof AST_Binary) {
        const parent_op = p32.operator;
        const op = this.operator;
        if (op === "??" && (parent_op === "||" || parent_op === "&&")) {
          return true;
        }
        if (parent_op === "??" && (op === "||" || op === "&&")) {
          return true;
        }
        const pp2 = PRECEDENCE[parent_op];
        const sp = PRECEDENCE[op];
        if (pp2 > sp || pp2 == sp && (this === p32.right || parent_op == "**")) {
          return true;
        }
      }
      if (p32 instanceof AST_PrivateIn) {
        const op = this.operator;
        const pp2 = PRECEDENCE["in"];
        const sp = PRECEDENCE[op];
        if (pp2 > sp || pp2 == sp && this === p32.value) {
          return true;
        }
      }
    });
    PARENS(AST_PrivateIn, function(output) {
      var p32 = output.parent();
      if (p32 instanceof AST_Call && p32.expression === this) {
        return true;
      }
      if (p32 instanceof AST_Unary) {
        return true;
      }
      if (p32 instanceof AST_PropAccess && p32.expression === this) {
        return true;
      }
      if (p32 instanceof AST_Binary) {
        const parent_op = p32.operator;
        const pp2 = PRECEDENCE[parent_op];
        const sp = PRECEDENCE["in"];
        if (pp2 > sp || pp2 == sp && (this === p32.right || parent_op == "**")) {
          return true;
        }
      }
      if (p32 instanceof AST_PrivateIn && this === p32.value) {
        return true;
      }
    });
    PARENS(AST_Yield, function(output) {
      var p32 = output.parent();
      if (p32 instanceof AST_Binary && p32.operator !== "=")
        return true;
      if (p32 instanceof AST_Call && p32.expression === this)
        return true;
      if (p32 instanceof AST_Conditional && p32.condition === this)
        return true;
      if (p32 instanceof AST_Unary)
        return true;
      if (p32 instanceof AST_PropAccess && p32.expression === this)
        return true;
    });
    PARENS(AST_Chain, function(output) {
      var p32 = output.parent();
      if (!(p32 instanceof AST_Call || p32 instanceof AST_PropAccess))
        return false;
      return p32.expression === this;
    });
    PARENS(AST_PropAccess, function(output) {
      var p32 = output.parent();
      if (p32 instanceof AST_New && p32.expression === this) {
        return walk2(this, (node) => {
          if (node instanceof AST_Scope)
            return true;
          if (node instanceof AST_Call) {
            return walk_abort;
          }
        });
      }
    });
    PARENS(AST_Call, function(output) {
      var p32 = output.parent(), p1;
      if (p32 instanceof AST_New && p32.expression === this || p32 instanceof AST_Export && p32.is_default && this.expression instanceof AST_Function)
        return true;
      return this.expression instanceof AST_Function && p32 instanceof AST_PropAccess && p32.expression === this && (p1 = output.parent(1)) instanceof AST_Assign && p1.left === p32;
    });
    PARENS(AST_New, function(output) {
      var p32 = output.parent();
      if (this.args.length === 0 && (p32 instanceof AST_PropAccess || p32 instanceof AST_Call && p32.expression === this || p32 instanceof AST_PrefixedTemplateString && p32.prefix === this))
        return true;
    });
    PARENS(AST_Number, function(output) {
      var p32 = output.parent();
      if (p32 instanceof AST_PropAccess && p32.expression === this) {
        var value = this.getValue();
        if (value < 0 || /^0/.test(make_num(value))) {
          return true;
        }
      }
    });
    PARENS(AST_BigInt, function(output) {
      var p32 = output.parent();
      if (p32 instanceof AST_PropAccess && p32.expression === this) {
        var value = this.getValue();
        if (value.startsWith("-")) {
          return true;
        }
      }
    });
    PARENS([AST_Assign, AST_Conditional], function(output) {
      var p32 = output.parent();
      if (p32 instanceof AST_Unary)
        return true;
      if (p32 instanceof AST_Binary && !(p32 instanceof AST_Assign))
        return true;
      if (p32 instanceof AST_Call && p32.expression === this)
        return true;
      if (p32 instanceof AST_Conditional && p32.condition === this)
        return true;
      if (p32 instanceof AST_PropAccess && p32.expression === this)
        return true;
      if (this instanceof AST_Assign && this.left instanceof AST_Destructuring && this.left.is_array === false)
        return true;
    });
    DEFPRINT(AST_Directive, function(self2, output) {
      output.print_string(self2.value, self2.quote);
      output.semicolon();
    });
    DEFPRINT(AST_Expansion, function(self2, output) {
      output.print("...");
      self2.expression.print(output);
    });
    DEFPRINT(AST_Destructuring, function(self2, output) {
      output.print(self2.is_array ? "[" : "{");
      var len = self2.names.length;
      self2.names.forEach(function(name, i2) {
        if (i2 > 0)
          output.comma();
        name.print(output);
        if (i2 == len - 1 && name instanceof AST_Hole)
          output.comma();
      });
      output.print(self2.is_array ? "]" : "}");
    });
    DEFPRINT(AST_Debugger, function(self2, output) {
      output.print("debugger");
      output.semicolon();
    });
    function display_body(body, is_toplevel, output, allow_directives) {
      var last = body.length - 1;
      output.in_directive = allow_directives;
      body.forEach(function(stmt, i2) {
        if (output.in_directive === true && !(stmt instanceof AST_Directive || stmt instanceof AST_EmptyStatement || stmt instanceof AST_SimpleStatement && stmt.body instanceof AST_String)) {
          output.in_directive = false;
        }
        if (!(stmt instanceof AST_EmptyStatement)) {
          output.indent();
          stmt.print(output);
          if (!(i2 == last && is_toplevel)) {
            output.newline();
            if (is_toplevel)
              output.newline();
          }
        }
        if (output.in_directive === true && stmt instanceof AST_SimpleStatement && stmt.body instanceof AST_String) {
          output.in_directive = false;
        }
      });
      output.in_directive = false;
    }
    AST_StatementWithBody.DEFMETHOD("_do_print_body", function(output) {
      print_maybe_braced_body(this.body, output);
    });
    DEFPRINT(AST_Statement, function(self2, output) {
      self2.body.print(output);
      output.semicolon();
    });
    DEFPRINT(AST_Toplevel, function(self2, output) {
      display_body(self2.body, true, output, true);
      output.print("");
    });
    DEFPRINT(AST_LabeledStatement, function(self2, output) {
      self2.label.print(output);
      output.colon();
      self2.body.print(output);
    });
    DEFPRINT(AST_SimpleStatement, function(self2, output) {
      self2.body.print(output);
      output.semicolon();
    });
    function print_braced_empty(self2, output) {
      output.print("{");
      output.with_indent(output.next_indent(), function() {
        output.append_comments(self2, true);
      });
      output.add_mapping(self2.end);
      output.print("}");
    }
    function print_braced(self2, output, allow_directives) {
      if (self2.body.length > 0) {
        output.with_block(function() {
          display_body(self2.body, false, output, allow_directives);
          output.add_mapping(self2.end);
        });
      } else
        print_braced_empty(self2, output);
    }
    DEFPRINT(AST_BlockStatement, function(self2, output) {
      print_braced(self2, output);
    });
    DEFPRINT(AST_EmptyStatement, function(self2, output) {
      output.semicolon();
    });
    DEFPRINT(AST_Do, function(self2, output) {
      output.print("do");
      output.space();
      make_block(self2.body, output);
      output.space();
      output.print("while");
      output.space();
      output.with_parens(function() {
        self2.condition.print(output);
      });
      output.semicolon();
    });
    DEFPRINT(AST_While, function(self2, output) {
      output.print("while");
      output.space();
      output.with_parens(function() {
        self2.condition.print(output);
      });
      output.space();
      self2._do_print_body(output);
    });
    DEFPRINT(AST_For, function(self2, output) {
      output.print("for");
      output.space();
      output.with_parens(function() {
        if (self2.init) {
          if (self2.init instanceof AST_Definitions) {
            self2.init.print(output);
          } else {
            parenthesize_for_noin(self2.init, output, true);
          }
          output.print(";");
          output.space();
        } else {
          output.print(";");
        }
        if (self2.condition) {
          self2.condition.print(output);
          output.print(";");
          output.space();
        } else {
          output.print(";");
        }
        if (self2.step) {
          self2.step.print(output);
        }
      });
      output.space();
      self2._do_print_body(output);
    });
    DEFPRINT(AST_ForIn, function(self2, output) {
      output.print("for");
      if (self2.await) {
        output.space();
        output.print("await");
      }
      output.space();
      output.with_parens(function() {
        self2.init.print(output);
        output.space();
        output.print(self2 instanceof AST_ForOf ? "of" : "in");
        output.space();
        self2.object.print(output);
      });
      output.space();
      self2._do_print_body(output);
    });
    DEFPRINT(AST_With, function(self2, output) {
      output.print("with");
      output.space();
      output.with_parens(function() {
        self2.expression.print(output);
      });
      output.space();
      self2._do_print_body(output);
    });
    AST_Lambda.DEFMETHOD("_do_print", function(output, nokeyword) {
      var self2 = this;
      if (!nokeyword) {
        if (self2.async) {
          output.print("async");
          output.space();
        }
        output.print("function");
        if (self2.is_generator) {
          output.star();
        }
        if (self2.name) {
          output.space();
        }
      }
      if (self2.name instanceof AST_Symbol) {
        self2.name.print(output);
      } else if (nokeyword && self2.name instanceof AST_Node) {
        output.with_square(function() {
          self2.name.print(output);
        });
      }
      output.with_parens(function() {
        self2.argnames.forEach(function(arg, i2) {
          if (i2)
            output.comma();
          arg.print(output);
        });
      });
      output.space();
      print_braced(self2, output, true);
    });
    DEFPRINT(AST_Lambda, function(self2, output) {
      self2._do_print(output);
      output.gc_scope(self2);
    });
    DEFPRINT(AST_PrefixedTemplateString, function(self2, output) {
      var tag = self2.prefix;
      var parenthesize_tag = tag instanceof AST_Lambda || tag instanceof AST_Binary || tag instanceof AST_Conditional || tag instanceof AST_Sequence || tag instanceof AST_Unary || tag instanceof AST_Dot && tag.expression instanceof AST_Object;
      if (parenthesize_tag)
        output.print("(");
      self2.prefix.print(output);
      if (parenthesize_tag)
        output.print(")");
      self2.template_string.print(output);
    });
    DEFPRINT(AST_TemplateString, function(self2, output) {
      var is_tagged = output.parent() instanceof AST_PrefixedTemplateString;
      output.print("`");
      for (var i2 = 0;i2 < self2.segments.length; i2++) {
        if (!(self2.segments[i2] instanceof AST_TemplateSegment)) {
          output.print("${");
          self2.segments[i2].print(output);
          output.print("}");
        } else if (is_tagged) {
          output.print(self2.segments[i2].raw);
        } else {
          output.print_template_string_chars(self2.segments[i2].value);
        }
      }
      output.print("`");
    });
    DEFPRINT(AST_TemplateSegment, function(self2, output) {
      output.print_template_string_chars(self2.value);
    });
    AST_Arrow.DEFMETHOD("_do_print", function(output) {
      var self2 = this;
      var parent = output.parent();
      var needs_parens = parent instanceof AST_Binary && !(parent instanceof AST_Assign) && !(parent instanceof AST_DefaultAssign) || parent instanceof AST_Unary || parent instanceof AST_Call && self2 === parent.expression;
      if (needs_parens) {
        output.print("(");
      }
      if (self2.async) {
        output.print("async");
        output.space();
      }
      if (self2.argnames.length === 1 && self2.argnames[0] instanceof AST_Symbol) {
        self2.argnames[0].print(output);
      } else {
        output.with_parens(function() {
          self2.argnames.forEach(function(arg, i2) {
            if (i2)
              output.comma();
            arg.print(output);
          });
        });
      }
      output.space();
      output.print("=>");
      output.space();
      const first_statement = self2.body[0];
      if (self2.body.length === 1 && first_statement instanceof AST_Return) {
        const returned = first_statement.value;
        if (!returned) {
          output.print("{}");
        } else if (left_is_object(returned)) {
          output.print("(");
          returned.print(output);
          output.print(")");
        } else {
          returned.print(output);
        }
      } else {
        print_braced(self2, output);
      }
      if (needs_parens) {
        output.print(")");
      }
      output.gc_scope(self2);
    });
    AST_Exit.DEFMETHOD("_do_print", function(output, kind) {
      output.print(kind);
      if (this.value) {
        output.space();
        const comments = this.value.start.comments_before;
        if (comments && comments.length && !output.printed_comments.has(comments)) {
          output.print("(");
          this.value.print(output);
          output.print(")");
        } else {
          this.value.print(output);
        }
      }
      output.semicolon();
    });
    DEFPRINT(AST_Return, function(self2, output) {
      self2._do_print(output, "return");
    });
    DEFPRINT(AST_Throw, function(self2, output) {
      self2._do_print(output, "throw");
    });
    DEFPRINT(AST_Yield, function(self2, output) {
      var star = self2.is_star ? "*" : "";
      output.print("yield" + star);
      if (self2.expression) {
        output.space();
        self2.expression.print(output);
      }
    });
    DEFPRINT(AST_Await, function(self2, output) {
      output.print("await");
      output.space();
      var e = self2.expression;
      var parens = !(e instanceof AST_Call || e instanceof AST_SymbolRef || e instanceof AST_PropAccess || e instanceof AST_Unary || e instanceof AST_Constant || e instanceof AST_Await || e instanceof AST_Object);
      if (parens)
        output.print("(");
      self2.expression.print(output);
      if (parens)
        output.print(")");
    });
    AST_LoopControl.DEFMETHOD("_do_print", function(output, kind) {
      output.print(kind);
      if (this.label) {
        output.space();
        this.label.print(output);
      }
      output.semicolon();
    });
    DEFPRINT(AST_Break, function(self2, output) {
      self2._do_print(output, "break");
    });
    DEFPRINT(AST_Continue, function(self2, output) {
      self2._do_print(output, "continue");
    });
    function make_then(self2, output) {
      var b22 = self2.body;
      if (output.option("braces") || output.option("ie8") && b22 instanceof AST_Do)
        return make_block(b22, output);
      if (!b22)
        return output.force_semicolon();
      while (true) {
        if (b22 instanceof AST_If) {
          if (!b22.alternative) {
            make_block(self2.body, output);
            return;
          }
          b22 = b22.alternative;
        } else if (b22 instanceof AST_StatementWithBody) {
          b22 = b22.body;
        } else
          break;
      }
      print_maybe_braced_body(self2.body, output);
    }
    DEFPRINT(AST_If, function(self2, output) {
      output.print("if");
      output.space();
      output.with_parens(function() {
        self2.condition.print(output);
      });
      output.space();
      if (self2.alternative) {
        make_then(self2, output);
        output.space();
        output.print("else");
        output.space();
        if (self2.alternative instanceof AST_If)
          self2.alternative.print(output);
        else
          print_maybe_braced_body(self2.alternative, output);
      } else {
        self2._do_print_body(output);
      }
    });
    DEFPRINT(AST_Switch, function(self2, output) {
      output.print("switch");
      output.space();
      output.with_parens(function() {
        self2.expression.print(output);
      });
      output.space();
      var last = self2.body.length - 1;
      if (last < 0)
        print_braced_empty(self2, output);
      else
        output.with_block(function() {
          self2.body.forEach(function(branch, i2) {
            output.indent(true);
            branch.print(output);
            if (i2 < last && branch.body.length > 0)
              output.newline();
          });
        });
    });
    AST_SwitchBranch.DEFMETHOD("_do_print_body", function(output) {
      output.newline();
      this.body.forEach(function(stmt) {
        output.indent();
        stmt.print(output);
        output.newline();
      });
    });
    DEFPRINT(AST_Default, function(self2, output) {
      output.print("default:");
      self2._do_print_body(output);
    });
    DEFPRINT(AST_Case, function(self2, output) {
      output.print("case");
      output.space();
      self2.expression.print(output);
      output.print(":");
      self2._do_print_body(output);
    });
    DEFPRINT(AST_Try, function(self2, output) {
      output.print("try");
      output.space();
      self2.body.print(output);
      if (self2.bcatch) {
        output.space();
        self2.bcatch.print(output);
      }
      if (self2.bfinally) {
        output.space();
        self2.bfinally.print(output);
      }
    });
    DEFPRINT(AST_TryBlock, function(self2, output) {
      print_braced(self2, output);
    });
    DEFPRINT(AST_Catch, function(self2, output) {
      output.print("catch");
      if (self2.argname) {
        output.space();
        output.with_parens(function() {
          self2.argname.print(output);
        });
      }
      output.space();
      print_braced(self2, output);
    });
    DEFPRINT(AST_Finally, function(self2, output) {
      output.print("finally");
      output.space();
      print_braced(self2, output);
    });
    AST_Definitions.DEFMETHOD("_do_print", function(output, kind) {
      output.print(kind);
      output.space();
      this.definitions.forEach(function(def, i2) {
        if (i2)
          output.comma();
        def.print(output);
      });
      var p32 = output.parent();
      var in_for = p32 instanceof AST_For || p32 instanceof AST_ForIn;
      var output_semicolon = !in_for || p32 && p32.init !== this;
      if (output_semicolon)
        output.semicolon();
    });
    DEFPRINT(AST_Let, function(self2, output) {
      self2._do_print(output, "let");
    });
    DEFPRINT(AST_Var, function(self2, output) {
      self2._do_print(output, "var");
    });
    DEFPRINT(AST_Const, function(self2, output) {
      self2._do_print(output, "const");
    });
    DEFPRINT(AST_Import, function(self2, output) {
      output.print("import");
      output.space();
      if (self2.imported_name) {
        self2.imported_name.print(output);
      }
      if (self2.imported_name && self2.imported_names) {
        output.print(",");
        output.space();
      }
      if (self2.imported_names) {
        if (self2.imported_names.length === 1 && self2.imported_names[0].foreign_name.name === "*" && !self2.imported_names[0].foreign_name.quote) {
          self2.imported_names[0].print(output);
        } else {
          output.print("{");
          self2.imported_names.forEach(function(name_import, i2) {
            output.space();
            name_import.print(output);
            if (i2 < self2.imported_names.length - 1) {
              output.print(",");
            }
          });
          output.space();
          output.print("}");
        }
      }
      if (self2.imported_name || self2.imported_names) {
        output.space();
        output.print("from");
        output.space();
      }
      self2.module_name.print(output);
      if (self2.attributes) {
        output.print("with");
        self2.attributes.print(output);
      }
      output.semicolon();
    });
    DEFPRINT(AST_ImportMeta, function(self2, output) {
      output.print("import.meta");
    });
    DEFPRINT(AST_NameMapping, function(self2, output) {
      var is_import = output.parent() instanceof AST_Import;
      var definition = self2.name.definition();
      var foreign_name = self2.foreign_name;
      var names_are_different = (definition && definition.mangled_name || self2.name.name) !== foreign_name.name;
      if (!names_are_different && foreign_name.name === "*" && foreign_name.quote != self2.name.quote) {
        names_are_different = true;
      }
      var foreign_name_is_name = foreign_name.quote == null;
      if (names_are_different) {
        if (is_import) {
          if (foreign_name_is_name) {
            output.print(foreign_name.name);
          } else {
            output.print_string(foreign_name.name, foreign_name.quote);
          }
        } else {
          if (self2.name.quote == null) {
            self2.name.print(output);
          } else {
            output.print_string(self2.name.name, self2.name.quote);
          }
        }
        output.space();
        output.print("as");
        output.space();
        if (is_import) {
          self2.name.print(output);
        } else {
          if (foreign_name_is_name) {
            output.print(foreign_name.name);
          } else {
            output.print_string(foreign_name.name, foreign_name.quote);
          }
        }
      } else {
        if (self2.name.quote == null) {
          self2.name.print(output);
        } else {
          output.print_string(self2.name.name, self2.name.quote);
        }
      }
    });
    DEFPRINT(AST_Export, function(self2, output) {
      output.print("export");
      output.space();
      if (self2.is_default) {
        output.print("default");
        output.space();
      }
      if (self2.exported_names) {
        if (self2.exported_names.length === 1 && self2.exported_names[0].name.name === "*" && !self2.exported_names[0].name.quote) {
          self2.exported_names[0].print(output);
        } else {
          output.print("{");
          self2.exported_names.forEach(function(name_export, i2) {
            output.space();
            name_export.print(output);
            if (i2 < self2.exported_names.length - 1) {
              output.print(",");
            }
          });
          output.space();
          output.print("}");
        }
      } else if (self2.exported_value) {
        self2.exported_value.print(output);
      } else if (self2.exported_definition) {
        self2.exported_definition.print(output);
        if (self2.exported_definition instanceof AST_Definitions)
          return;
      }
      if (self2.module_name) {
        output.space();
        output.print("from");
        output.space();
        self2.module_name.print(output);
      }
      if (self2.attributes) {
        output.print("with");
        self2.attributes.print(output);
      }
      if (self2.exported_value && !(self2.exported_value instanceof AST_Defun || self2.exported_value instanceof AST_Function || self2.exported_value instanceof AST_Class) || self2.module_name || self2.exported_names) {
        output.semicolon();
      }
    });
    function parenthesize_for_noin(node, output, noin) {
      var parens = false;
      if (noin) {
        parens = walk2(node, (node2) => {
          if (node2 instanceof AST_Scope && !(node2 instanceof AST_Arrow)) {
            return true;
          }
          if (node2 instanceof AST_Binary && node2.operator == "in" || node2 instanceof AST_PrivateIn) {
            return walk_abort;
          }
        });
      }
      node.print(output, parens);
    }
    DEFPRINT(AST_VarDef, function(self2, output) {
      self2.name.print(output);
      if (self2.value) {
        output.space();
        output.print("=");
        output.space();
        var p32 = output.parent(1);
        var noin = p32 instanceof AST_For || p32 instanceof AST_ForIn;
        parenthesize_for_noin(self2.value, output, noin);
      }
    });
    DEFPRINT(AST_Call, function(self2, output) {
      self2.expression.print(output);
      if (self2 instanceof AST_New && self2.args.length === 0)
        return;
      if (self2.expression instanceof AST_Call || self2.expression instanceof AST_Lambda) {
        output.add_mapping(self2.start);
      }
      if (self2.optional)
        output.print("?.");
      output.with_parens(function() {
        self2.args.forEach(function(expr, i2) {
          if (i2)
            output.comma();
          expr.print(output);
        });
      });
    });
    DEFPRINT(AST_New, function(self2, output) {
      output.print("new");
      output.space();
      AST_Call.prototype._codegen(self2, output);
    });
    AST_Sequence.DEFMETHOD("_do_print", function(output) {
      this.expressions.forEach(function(node, index) {
        if (index > 0) {
          output.comma();
          if (output.should_break()) {
            output.newline();
            output.indent();
          }
        }
        node.print(output);
      });
    });
    DEFPRINT(AST_Sequence, function(self2, output) {
      self2._do_print(output);
    });
    DEFPRINT(AST_Dot, function(self2, output) {
      var expr = self2.expression;
      expr.print(output);
      var prop = self2.property;
      var print_computed = ALL_RESERVED_WORDS.has(prop) ? output.option("ie8") : !is_identifier_string(prop, output.option("ecma") >= 2015 && !output.option("safari10"));
      if (self2.optional)
        output.print("?.");
      if (print_computed) {
        output.print("[");
        output.add_mapping(self2.end);
        output.print_string(prop);
        output.print("]");
      } else {
        if (expr instanceof AST_Number && expr.getValue() >= 0) {
          if (!/[xa-f.)]/i.test(output.last())) {
            output.print(".");
          }
        }
        if (!self2.optional)
          output.print(".");
        output.add_mapping(self2.end);
        output.print_name(prop);
      }
    });
    DEFPRINT(AST_DotHash, function(self2, output) {
      var expr = self2.expression;
      expr.print(output);
      var prop = self2.property;
      if (self2.optional)
        output.print("?");
      output.print(".#");
      output.add_mapping(self2.end);
      output.print_name(prop);
    });
    DEFPRINT(AST_Sub, function(self2, output) {
      self2.expression.print(output);
      if (self2.optional)
        output.print("?.");
      output.print("[");
      self2.property.print(output);
      output.print("]");
    });
    DEFPRINT(AST_Chain, function(self2, output) {
      self2.expression.print(output);
    });
    DEFPRINT(AST_UnaryPrefix, function(self2, output) {
      var op = self2.operator;
      if (op === "--" && output.last().endsWith("!")) {
        output.print(" ");
      }
      output.print(op);
      if (/^[a-z]/i.test(op) || /[+-]$/.test(op) && self2.expression instanceof AST_UnaryPrefix && /^[+-]/.test(self2.expression.operator)) {
        output.space();
      }
      self2.expression.print(output);
    });
    DEFPRINT(AST_UnaryPostfix, function(self2, output) {
      self2.expression.print(output);
      output.print(self2.operator);
    });
    DEFPRINT(AST_Binary, function(self2, output) {
      var op = self2.operator;
      self2.left.print(output);
      if (op[0] == ">" && output.last().endsWith("--")) {
        output.print(" ");
      } else {
        output.space();
      }
      output.print(op);
      output.space();
      self2.right.print(output);
    });
    DEFPRINT(AST_Conditional, function(self2, output) {
      self2.condition.print(output);
      output.space();
      output.print("?");
      output.space();
      self2.consequent.print(output);
      output.space();
      output.colon();
      self2.alternative.print(output);
    });
    DEFPRINT(AST_Array, function(self2, output) {
      output.with_square(function() {
        var a = self2.elements, len = a.length;
        if (len > 0)
          output.space();
        a.forEach(function(exp, i2) {
          if (i2)
            output.comma();
          exp.print(output);
          if (i2 === len - 1 && exp instanceof AST_Hole)
            output.comma();
        });
        if (len > 0)
          output.space();
      });
    });
    DEFPRINT(AST_Object, function(self2, output) {
      if (self2.properties.length > 0)
        output.with_block(function() {
          self2.properties.forEach(function(prop, i2) {
            if (i2) {
              output.print(",");
              output.newline();
            }
            output.indent();
            prop.print(output);
          });
          output.newline();
        });
      else
        print_braced_empty(self2, output);
    });
    DEFPRINT(AST_Class, function(self2, output) {
      output.print("class");
      output.space();
      if (self2.name) {
        self2.name.print(output);
        output.space();
      }
      if (self2.extends) {
        var parens = !(self2.extends instanceof AST_SymbolRef) && !(self2.extends instanceof AST_PropAccess) && !(self2.extends instanceof AST_ClassExpression) && !(self2.extends instanceof AST_Function);
        output.print("extends");
        if (parens) {
          output.print("(");
        } else {
          output.space();
        }
        self2.extends.print(output);
        if (parens) {
          output.print(")");
        } else {
          output.space();
        }
      }
      if (self2.properties.length > 0)
        output.with_block(function() {
          self2.properties.forEach(function(prop, i2) {
            if (i2) {
              output.newline();
            }
            output.indent();
            prop.print(output);
          });
          output.newline();
        });
      else
        output.print("{}");
    });
    DEFPRINT(AST_NewTarget, function(self2, output) {
      output.print("new.target");
    });
    function print_property_name(key, quote, output) {
      if (output.option("quote_keys")) {
        output.print_string(key);
        return false;
      }
      if ("" + +key == key && key >= 0) {
        if (output.option("keep_numbers")) {
          output.print(key);
          return false;
        }
        output.print(make_num(key));
        return false;
      }
      var print_string = ALL_RESERVED_WORDS.has(key) ? output.option("ie8") : output.option("ecma") < 2015 || output.option("safari10") ? !is_basic_identifier_string(key) : !is_identifier_string(key, true);
      if (print_string || quote && output.option("keep_quoted_props")) {
        output.print_string(key, quote);
        return false;
      }
      output.print_name(key);
      return true;
    }
    DEFPRINT(AST_ObjectKeyVal, function(self2, output) {
      function get_name(self3) {
        var def = self3.definition();
        return def ? def.mangled_name || def.name : self3.name;
      }
      const try_shorthand = output.option("shorthand") && !(self2.key instanceof AST_Node);
      if (try_shorthand && self2.value instanceof AST_Symbol && get_name(self2.value) === self2.key && !ALL_RESERVED_WORDS.has(self2.key)) {
        const was_shorthand = print_property_name(self2.key, self2.quote, output);
        if (!was_shorthand) {
          output.colon();
          self2.value.print(output);
        }
      } else if (try_shorthand && self2.value instanceof AST_DefaultAssign && self2.value.left instanceof AST_Symbol && get_name(self2.value.left) === self2.key) {
        const was_shorthand = print_property_name(self2.key, self2.quote, output);
        if (!was_shorthand) {
          output.colon();
          self2.value.left.print(output);
        }
        output.space();
        output.print("=");
        output.space();
        self2.value.right.print(output);
      } else {
        if (!(self2.key instanceof AST_Node)) {
          print_property_name(self2.key, self2.quote, output);
        } else {
          output.with_square(function() {
            self2.key.print(output);
          });
        }
        output.colon();
        self2.value.print(output);
      }
    });
    DEFPRINT(AST_ClassPrivateProperty, (self2, output) => {
      if (self2.static) {
        output.print("static");
        output.space();
      }
      output.print("#");
      print_property_name(self2.key.name, self2.quote, output);
      if (self2.value) {
        output.print("=");
        self2.value.print(output);
      }
      output.semicolon();
    });
    DEFPRINT(AST_ClassProperty, (self2, output) => {
      if (self2.static) {
        output.print("static");
        output.space();
      }
      if (self2.key instanceof AST_SymbolClassProperty) {
        print_property_name(self2.key.name, self2.quote, output);
      } else {
        output.print("[");
        self2.key.print(output);
        output.print("]");
      }
      if (self2.value) {
        output.print("=");
        self2.value.print(output);
      }
      output.semicolon();
    });
    AST_ObjectProperty.DEFMETHOD("_print_getter_setter", function(type, is_private, output) {
      var self2 = this;
      if (self2.static) {
        output.print("static");
        output.space();
      }
      if (type) {
        output.print(type);
        output.space();
      }
      if (self2.key instanceof AST_SymbolMethod) {
        if (is_private)
          output.print("#");
        print_property_name(self2.key.name, self2.quote, output);
        self2.key.add_source_map(output);
      } else {
        output.with_square(function() {
          self2.key.print(output);
        });
      }
      self2.value._do_print(output, true);
    });
    DEFPRINT(AST_ObjectSetter, function(self2, output) {
      self2._print_getter_setter("set", false, output);
    });
    DEFPRINT(AST_ObjectGetter, function(self2, output) {
      self2._print_getter_setter("get", false, output);
    });
    DEFPRINT(AST_PrivateSetter, function(self2, output) {
      self2._print_getter_setter("set", true, output);
    });
    DEFPRINT(AST_PrivateGetter, function(self2, output) {
      self2._print_getter_setter("get", true, output);
    });
    DEFPRINT(AST_PrivateMethod, function(self2, output) {
      var type;
      if (self2.is_generator && self2.async) {
        type = "async*";
      } else if (self2.is_generator) {
        type = "*";
      } else if (self2.async) {
        type = "async";
      }
      self2._print_getter_setter(type, true, output);
    });
    DEFPRINT(AST_PrivateIn, function(self2, output) {
      self2.key.print(output);
      output.space();
      output.print("in");
      output.space();
      self2.value.print(output);
    });
    DEFPRINT(AST_SymbolPrivateProperty, function(self2, output) {
      output.print("#" + self2.name);
    });
    DEFPRINT(AST_ConciseMethod, function(self2, output) {
      var type;
      if (self2.is_generator && self2.async) {
        type = "async*";
      } else if (self2.is_generator) {
        type = "*";
      } else if (self2.async) {
        type = "async";
      }
      self2._print_getter_setter(type, false, output);
    });
    DEFPRINT(AST_ClassStaticBlock, function(self2, output) {
      output.print("static");
      output.space();
      print_braced(self2, output);
    });
    AST_Symbol.DEFMETHOD("_do_print", function(output) {
      var def = this.definition();
      output.print_name(def ? def.mangled_name || def.name : this.name);
    });
    DEFPRINT(AST_Symbol, function(self2, output) {
      self2._do_print(output);
    });
    DEFPRINT(AST_Hole, noop);
    DEFPRINT(AST_This, function(self2, output) {
      output.print("this");
    });
    DEFPRINT(AST_Super, function(self2, output) {
      output.print("super");
    });
    DEFPRINT(AST_Constant, function(self2, output) {
      output.print(self2.getValue());
    });
    DEFPRINT(AST_String, function(self2, output) {
      output.print_string(self2.getValue(), self2.quote, output.in_directive);
    });
    DEFPRINT(AST_Number, function(self2, output) {
      if ((output.option("keep_numbers") || output.use_asm) && self2.raw) {
        output.print(self2.raw);
      } else {
        output.print(make_num(self2.getValue()));
      }
    });
    DEFPRINT(AST_BigInt, function(self2, output) {
      output.print(self2.getValue() + "n");
    });
    const r_slash_script = /(<\s*\/\s*script)/i;
    const r_starts_with_script = /^\s*script/i;
    const slash_script_replace = (_22, $1) => $1.replace("/", "\\/");
    DEFPRINT(AST_RegExp, function(self2, output) {
      let { source, flags } = self2.getValue();
      source = regexp_source_fix(source);
      flags = flags ? sort_regexp_flags(flags) : "";
      source = source.replace(r_slash_script, slash_script_replace);
      if (r_starts_with_script.test(source) && output.last().endsWith("<")) {
        output.print(" ");
      }
      output.print(output.to_utf8(`/${source}/${flags}`, false, true));
      const parent = output.parent();
      if (parent instanceof AST_Binary && /^\w/.test(parent.operator) && parent.left === self2) {
        output.print(" ");
      }
    });
    function print_maybe_braced_body(stat22, output) {
      if (output.option("braces")) {
        make_block(stat22, output);
      } else {
        if (!stat22 || stat22 instanceof AST_EmptyStatement)
          output.force_semicolon();
        else if (stat22 instanceof AST_Let || stat22 instanceof AST_Const || stat22 instanceof AST_Class)
          make_block(stat22, output);
        else
          stat22.print(output);
      }
    }
    function best_of(a) {
      var best = a[0], len = best.length;
      for (var i2 = 1;i2 < a.length; ++i2) {
        if (a[i2].length < len) {
          best = a[i2];
          len = best.length;
        }
      }
      return best;
    }
    function make_num(num) {
      var str = num.toString(10).replace(/^0\./, ".").replace("e+", "e");
      var candidates = [str];
      if (Math.floor(num) === num) {
        if (num < 0) {
          candidates.push("-0x" + (-num).toString(16).toLowerCase());
        } else {
          candidates.push("0x" + num.toString(16).toLowerCase());
        }
      }
      var match, len, digits;
      if (match = /^\.0+/.exec(str)) {
        len = match[0].length;
        digits = str.slice(len);
        candidates.push(digits + "e-" + (digits.length + len - 1));
      } else if (match = /0+$/.exec(str)) {
        len = match[0].length;
        candidates.push(str.slice(0, -len) + "e" + len);
      } else if (match = /^(\d)\.(\d+)e(-?\d+)$/.exec(str)) {
        candidates.push(match[1] + match[2] + "e" + (match[3] - match[2].length));
      }
      return best_of(candidates);
    }
    function make_block(stmt, output) {
      if (!stmt || stmt instanceof AST_EmptyStatement)
        output.print("{}");
      else if (stmt instanceof AST_BlockStatement)
        stmt.print(output);
      else
        output.with_block(function() {
          output.indent();
          stmt.print(output);
          output.newline();
        });
    }
    function DEFMAP(nodetype, generator) {
      nodetype.forEach(function(nodetype2) {
        nodetype2.DEFMETHOD("add_source_map", generator);
      });
    }
    DEFMAP([
      AST_Node,
      AST_LabeledStatement,
      AST_Toplevel
    ], noop);
    DEFMAP([
      AST_Array,
      AST_BlockStatement,
      AST_Catch,
      AST_Class,
      AST_Constant,
      AST_Debugger,
      AST_Definitions,
      AST_Directive,
      AST_Finally,
      AST_Jump,
      AST_Lambda,
      AST_New,
      AST_Object,
      AST_StatementWithBody,
      AST_Symbol,
      AST_Switch,
      AST_SwitchBranch,
      AST_TemplateString,
      AST_TemplateSegment,
      AST_Try
    ], function(output) {
      output.add_mapping(this.start);
    });
    DEFMAP([
      AST_ObjectGetter,
      AST_ObjectSetter,
      AST_PrivateGetter,
      AST_PrivateSetter,
      AST_ConciseMethod,
      AST_PrivateMethod
    ], function(output) {
      output.add_mapping(this.start, false);
    });
    DEFMAP([
      AST_SymbolMethod,
      AST_SymbolPrivateProperty
    ], function(output) {
      const tok_type = this.end && this.end.type;
      if (tok_type === "name" || tok_type === "privatename") {
        output.add_mapping(this.end, this.name);
      } else {
        output.add_mapping(this.end);
      }
    });
    DEFMAP([AST_ObjectProperty], function(output) {
      output.add_mapping(this.start, this.key);
    });
  })();
});
var shallow_cmp = (node1, node2) => {
  return node1 === null && node2 === null || node1.TYPE === node2.TYPE && node1.shallow_cmp(node2);
};
var equivalent_to = (tree1, tree2) => {
  if (!shallow_cmp(tree1, tree2))
    return false;
  const walk_1_state = [tree1];
  const walk_2_state = [tree2];
  const walk_1_push = walk_1_state.push.bind(walk_1_state);
  const walk_2_push = walk_2_state.push.bind(walk_2_state);
  while (walk_1_state.length && walk_2_state.length) {
    const node_1 = walk_1_state.pop();
    const node_2 = walk_2_state.pop();
    if (!shallow_cmp(node_1, node_2))
      return false;
    node_1._children_backwards(walk_1_push);
    node_2._children_backwards(walk_2_push);
    if (walk_1_state.length !== walk_2_state.length) {
      return false;
    }
  }
  return walk_1_state.length == 0 && walk_2_state.length == 0;
};
var pass_through = () => true;
var init_equivalent_to = __esm2(() => {
  init_ast();
  AST_Node.prototype.shallow_cmp = function() {
    throw new Error("did not find a shallow_cmp function for " + this.constructor.name);
  };
  AST_Debugger.prototype.shallow_cmp = pass_through;
  AST_Directive.prototype.shallow_cmp = function(other) {
    return this.value === other.value;
  };
  AST_SimpleStatement.prototype.shallow_cmp = pass_through;
  AST_Block.prototype.shallow_cmp = pass_through;
  AST_EmptyStatement.prototype.shallow_cmp = pass_through;
  AST_LabeledStatement.prototype.shallow_cmp = function(other) {
    return this.label.name === other.label.name;
  };
  AST_Do.prototype.shallow_cmp = pass_through;
  AST_While.prototype.shallow_cmp = pass_through;
  AST_For.prototype.shallow_cmp = function(other) {
    return (this.init == null ? other.init == null : this.init === other.init) && (this.condition == null ? other.condition == null : this.condition === other.condition) && (this.step == null ? other.step == null : this.step === other.step);
  };
  AST_ForIn.prototype.shallow_cmp = pass_through;
  AST_ForOf.prototype.shallow_cmp = pass_through;
  AST_With.prototype.shallow_cmp = pass_through;
  AST_Toplevel.prototype.shallow_cmp = pass_through;
  AST_Expansion.prototype.shallow_cmp = pass_through;
  AST_Lambda.prototype.shallow_cmp = function(other) {
    return this.is_generator === other.is_generator && this.async === other.async;
  };
  AST_Destructuring.prototype.shallow_cmp = function(other) {
    return this.is_array === other.is_array;
  };
  AST_PrefixedTemplateString.prototype.shallow_cmp = pass_through;
  AST_TemplateString.prototype.shallow_cmp = pass_through;
  AST_TemplateSegment.prototype.shallow_cmp = function(other) {
    return this.value === other.value;
  };
  AST_Jump.prototype.shallow_cmp = pass_through;
  AST_LoopControl.prototype.shallow_cmp = pass_through;
  AST_Await.prototype.shallow_cmp = pass_through;
  AST_Yield.prototype.shallow_cmp = function(other) {
    return this.is_star === other.is_star;
  };
  AST_If.prototype.shallow_cmp = function(other) {
    return this.alternative == null ? other.alternative == null : this.alternative === other.alternative;
  };
  AST_Switch.prototype.shallow_cmp = pass_through;
  AST_SwitchBranch.prototype.shallow_cmp = pass_through;
  AST_Try.prototype.shallow_cmp = function(other) {
    return this.body === other.body && (this.bcatch == null ? other.bcatch == null : this.bcatch === other.bcatch) && (this.bfinally == null ? other.bfinally == null : this.bfinally === other.bfinally);
  };
  AST_Catch.prototype.shallow_cmp = function(other) {
    return this.argname == null ? other.argname == null : this.argname === other.argname;
  };
  AST_Finally.prototype.shallow_cmp = pass_through;
  AST_Definitions.prototype.shallow_cmp = pass_through;
  AST_VarDef.prototype.shallow_cmp = function(other) {
    return this.value == null ? other.value == null : this.value === other.value;
  };
  AST_NameMapping.prototype.shallow_cmp = pass_through;
  AST_Import.prototype.shallow_cmp = function(other) {
    return (this.imported_name == null ? other.imported_name == null : this.imported_name === other.imported_name) && (this.imported_names == null ? other.imported_names == null : this.imported_names === other.imported_names);
  };
  AST_ImportMeta.prototype.shallow_cmp = pass_through;
  AST_Export.prototype.shallow_cmp = function(other) {
    return (this.exported_definition == null ? other.exported_definition == null : this.exported_definition === other.exported_definition) && (this.exported_value == null ? other.exported_value == null : this.exported_value === other.exported_value) && (this.exported_names == null ? other.exported_names == null : this.exported_names === other.exported_names) && this.module_name === other.module_name && this.is_default === other.is_default;
  };
  AST_Call.prototype.shallow_cmp = pass_through;
  AST_Sequence.prototype.shallow_cmp = pass_through;
  AST_PropAccess.prototype.shallow_cmp = pass_through;
  AST_Chain.prototype.shallow_cmp = pass_through;
  AST_Dot.prototype.shallow_cmp = function(other) {
    return this.property === other.property;
  };
  AST_DotHash.prototype.shallow_cmp = function(other) {
    return this.property === other.property;
  };
  AST_Unary.prototype.shallow_cmp = function(other) {
    return this.operator === other.operator;
  };
  AST_Binary.prototype.shallow_cmp = function(other) {
    return this.operator === other.operator;
  };
  AST_Conditional.prototype.shallow_cmp = pass_through;
  AST_Array.prototype.shallow_cmp = pass_through;
  AST_Object.prototype.shallow_cmp = pass_through;
  AST_ObjectProperty.prototype.shallow_cmp = pass_through;
  AST_ObjectKeyVal.prototype.shallow_cmp = function(other) {
    return this.key === other.key;
  };
  AST_ObjectSetter.prototype.shallow_cmp = function(other) {
    return this.static === other.static;
  };
  AST_ObjectGetter.prototype.shallow_cmp = function(other) {
    return this.static === other.static;
  };
  AST_ConciseMethod.prototype.shallow_cmp = function(other) {
    return this.static === other.static && this.is_generator === other.is_generator && this.async === other.async;
  };
  AST_Class.prototype.shallow_cmp = function(other) {
    return (this.name == null ? other.name == null : this.name === other.name) && (this.extends == null ? other.extends == null : this.extends === other.extends);
  };
  AST_ClassProperty.prototype.shallow_cmp = function(other) {
    return this.static === other.static;
  };
  AST_Symbol.prototype.shallow_cmp = function(other) {
    return this.name === other.name;
  };
  AST_NewTarget.prototype.shallow_cmp = pass_through;
  AST_This.prototype.shallow_cmp = pass_through;
  AST_Super.prototype.shallow_cmp = pass_through;
  AST_String.prototype.shallow_cmp = function(other) {
    return this.value === other.value;
  };
  AST_Number.prototype.shallow_cmp = function(other) {
    return this.value === other.value;
  };
  AST_BigInt.prototype.shallow_cmp = function(other) {
    return this.value === other.value;
  };
  AST_RegExp.prototype.shallow_cmp = function(other) {
    return this.value.flags === other.value.flags && this.value.source === other.value.source;
  };
  AST_Atom.prototype.shallow_cmp = pass_through;
});

class SymbolDef {
  constructor(scope, orig, init3) {
    this.name = orig.name;
    this.orig = [orig];
    this.init = init3;
    this.eliminated = 0;
    this.assignments = 0;
    this.scope = scope;
    this.replaced = 0;
    this.global = false;
    this.export = 0;
    this.mangled_name = null;
    this.undeclared = false;
    this.id = SymbolDef.next_id++;
    this.chained = false;
    this.direct_access = false;
    this.escaped = 0;
    this.recursive_refs = 0;
    this.references = [];
    this.should_replace = undefined;
    this.single_use = false;
    this.fixed = false;
    Object.seal(this);
  }
  fixed_value() {
    if (!this.fixed || this.fixed instanceof AST_Node)
      return this.fixed;
    return this.fixed();
  }
  unmangleable(options3) {
    if (!options3)
      options3 = {};
    if (function_defs && function_defs.has(this.id) && keep_name(options3.keep_fnames, this.orig[0].name))
      return true;
    return this.global && !options3.toplevel || this.export & MASK_EXPORT_DONT_MANGLE || this.undeclared || !options3.eval && this.scope.pinned() || (this.orig[0] instanceof AST_SymbolLambda || this.orig[0] instanceof AST_SymbolDefun) && keep_name(options3.keep_fnames, this.orig[0].name) || this.orig[0] instanceof AST_SymbolMethod || (this.orig[0] instanceof AST_SymbolClass || this.orig[0] instanceof AST_SymbolDefClass) && keep_name(options3.keep_classnames, this.orig[0].name);
  }
  mangle(options3) {
    const cache3 = options3.cache && options3.cache.props;
    if (this.global && cache3 && cache3.has(this.name)) {
      this.mangled_name = cache3.get(this.name);
    } else if (!this.mangled_name && !this.unmangleable(options3)) {
      var s32 = this.scope;
      var sym = this.orig[0];
      if (options3.ie8 && sym instanceof AST_SymbolLambda)
        s32 = s32.parent_scope;
      const redefinition = redefined_catch_def(this);
      this.mangled_name = redefinition ? redefinition.mangled_name || redefinition.name : s32.next_mangled(options3, this);
      if (this.global && cache3) {
        cache3.set(this.name, this.mangled_name);
      }
    }
  }
}
function redefined_catch_def(def) {
  if (def.orig[0] instanceof AST_SymbolCatch && def.scope.is_block_scope()) {
    return def.scope.get_defun_scope().variables.get(def.name);
  }
}
function find_scopes_visible_from(scopes) {
  const found_scopes = new Set;
  for (const scope of new Set(scopes)) {
    (function bubble_up(scope2) {
      if (scope2 == null || found_scopes.has(scope2))
        return;
      found_scopes.add(scope2);
      bubble_up(scope2.parent_scope);
    })(scope);
  }
  return [...found_scopes];
}
function next_mangled(scope, options3) {
  let defun_scope;
  if (scopes_with_block_defuns && (defun_scope = scope.get_defun_scope()) && scopes_with_block_defuns.has(defun_scope)) {
    scope = defun_scope;
  }
  var ext2 = scope.enclosed;
  var nth_identifier = options3.nth_identifier;
  out:
    while (true) {
      var m22 = nth_identifier.get(++scope.cname);
      if (ALL_RESERVED_WORDS.has(m22))
        continue;
      if (options3.reserved.has(m22))
        continue;
      if (unmangleable_names && unmangleable_names.has(m22))
        continue out;
      for (let i2 = ext2.length;--i2 >= 0; ) {
        const def = ext2[i2];
        const name = def.mangled_name || def.unmangleable(options3) && def.name;
        if (m22 == name)
          continue out;
      }
      return m22;
    }
}
function format_mangler_options(options3) {
  options3 = defaults2(options3, {
    eval: false,
    nth_identifier: base54,
    ie8: false,
    keep_classnames: false,
    keep_fnames: false,
    module: false,
    reserved: [],
    toplevel: false
  });
  if (options3.module)
    options3.toplevel = true;
  if (!Array.isArray(options3.reserved) && !(options3.reserved instanceof Set)) {
    options3.reserved = [];
  }
  options3.reserved = new Set(options3.reserved);
  options3.reserved.add("arguments");
  return options3;
}
var MASK_EXPORT_DONT_MANGLE;
var MASK_EXPORT_WANT_MANGLE;
var function_defs = null;
var unmangleable_names = null;
var scopes_with_block_defuns = null;
var base54;
var init_scope = __esm2(() => {
  init_utils5();
  init_ast();
  init_parse2();
  MASK_EXPORT_DONT_MANGLE = 1;
  MASK_EXPORT_WANT_MANGLE = 2;
  SymbolDef.next_id = 1;
  AST_Scope.DEFMETHOD("figure_out_scope", function(options3, { parent_scope = undefined, toplevel = this } = {}) {
    options3 = defaults2(options3, {
      cache: null,
      ie8: false,
      safari10: false,
      module: false
    });
    if (!(toplevel instanceof AST_Toplevel)) {
      throw new Error("Invalid toplevel scope");
    }
    var scope = this.parent_scope = parent_scope;
    var labels = new Map;
    var defun = null;
    var in_destructuring = null;
    var for_scopes = [];
    var tw = new TreeWalker((node, descend) => {
      if (node.is_block_scope()) {
        const save_scope2 = scope;
        node.block_scope = scope = new AST_Scope(node);
        scope._block_scope = true;
        scope.init_scope_vars(save_scope2);
        scope.uses_with = save_scope2.uses_with;
        scope.uses_eval = save_scope2.uses_eval;
        if (options3.safari10) {
          if (node instanceof AST_For || node instanceof AST_ForIn || node instanceof AST_ForOf) {
            for_scopes.push(scope);
          }
        }
        if (node instanceof AST_Switch) {
          const the_block_scope = scope;
          scope = save_scope2;
          node.expression.walk(tw);
          scope = the_block_scope;
          for (let i2 = 0;i2 < node.body.length; i2++) {
            node.body[i2].walk(tw);
          }
        } else {
          descend();
        }
        scope = save_scope2;
        return true;
      }
      if (node instanceof AST_Destructuring) {
        const save_destructuring = in_destructuring;
        in_destructuring = node;
        descend();
        in_destructuring = save_destructuring;
        return true;
      }
      if (node instanceof AST_Scope) {
        node.init_scope_vars(scope);
        var save_scope = scope;
        var save_defun = defun;
        var save_labels = labels;
        defun = scope = node;
        labels = new Map;
        descend();
        scope = save_scope;
        defun = save_defun;
        labels = save_labels;
        return true;
      }
      if (node instanceof AST_LabeledStatement) {
        var l22 = node.label;
        if (labels.has(l22.name)) {
          throw new Error(string_template("Label {name} defined twice", l22));
        }
        labels.set(l22.name, l22);
        descend();
        labels.delete(l22.name);
        return true;
      }
      if (node instanceof AST_With) {
        for (var s32 = scope;s32; s32 = s32.parent_scope)
          s32.uses_with = true;
        return;
      }
      if (node instanceof AST_Symbol) {
        node.scope = scope;
      }
      if (node instanceof AST_Label) {
        node.thedef = node;
        node.references = [];
      }
      if (node instanceof AST_SymbolLambda) {
        defun.def_function(node, node.name == "arguments" ? undefined : defun);
      } else if (node instanceof AST_SymbolDefun) {
        const closest_scope = defun.parent_scope;
        node.scope = tw.directives["use strict"] ? closest_scope : closest_scope.get_defun_scope();
        mark_export(node.scope.def_function(node, defun), 1);
      } else if (node instanceof AST_SymbolClass) {
        mark_export(defun.def_variable(node, defun), 1);
      } else if (node instanceof AST_SymbolImport) {
        scope.def_variable(node);
      } else if (node instanceof AST_SymbolDefClass) {
        mark_export((node.scope = defun.parent_scope).def_function(node, defun), 1);
      } else if (node instanceof AST_SymbolVar || node instanceof AST_SymbolLet || node instanceof AST_SymbolConst || node instanceof AST_SymbolCatch) {
        var def;
        if (node instanceof AST_SymbolBlockDeclaration) {
          def = scope.def_variable(node, null);
        } else {
          def = defun.def_variable(node, node.TYPE == "SymbolVar" ? null : undefined);
        }
        if (!def.orig.every((sym2) => {
          if (sym2 === node)
            return true;
          if (node instanceof AST_SymbolBlockDeclaration) {
            return sym2 instanceof AST_SymbolLambda;
          }
          return !(sym2 instanceof AST_SymbolLet || sym2 instanceof AST_SymbolConst);
        })) {
          js_error(`"${node.name}" is redeclared`, node.start.file, node.start.line, node.start.col, node.start.pos);
        }
        if (!(node instanceof AST_SymbolFunarg))
          mark_export(def, 2);
        if (defun !== scope) {
          node.mark_enclosed();
          var def = scope.find_variable(node);
          if (node.thedef !== def) {
            node.thedef = def;
            node.reference();
          }
        }
      } else if (node instanceof AST_LabelRef) {
        var sym = labels.get(node.name);
        if (!sym)
          throw new Error(string_template("Undefined label {name} [{line},{col}]", {
            name: node.name,
            line: node.start.line,
            col: node.start.col
          }));
        node.thedef = sym;
      }
      if (!(scope instanceof AST_Toplevel) && (node instanceof AST_Export || node instanceof AST_Import)) {
        js_error(`"${node.TYPE}" statement may only appear at the top level`, node.start.file, node.start.line, node.start.col, node.start.pos);
      }
    });
    if (options3.module) {
      tw.directives["use strict"] = true;
    }
    this.walk(tw);
    function mark_export(def, level) {
      if (in_destructuring) {
        var i2 = 0;
        do {
          level++;
        } while (tw.parent(i2++) !== in_destructuring);
      }
      var node = tw.parent(level);
      if (def.export = node instanceof AST_Export ? MASK_EXPORT_DONT_MANGLE : 0) {
        var exported = node.exported_definition;
        if ((exported instanceof AST_Defun || exported instanceof AST_DefClass) && node.is_default) {
          def.export = MASK_EXPORT_WANT_MANGLE;
        }
      }
    }
    const is_toplevel = this instanceof AST_Toplevel;
    if (is_toplevel) {
      this.globals = new Map;
    }
    var tw = new TreeWalker((node) => {
      if (node instanceof AST_LoopControl && node.label) {
        node.label.thedef.references.push(node);
        return true;
      }
      if (node instanceof AST_SymbolRef) {
        var name = node.name;
        if (name == "eval" && tw.parent() instanceof AST_Call) {
          for (var s32 = node.scope;s32 && !s32.uses_eval; s32 = s32.parent_scope) {
            s32.uses_eval = true;
          }
        }
        var sym;
        if (tw.parent() instanceof AST_NameMapping && tw.parent(1).module_name || !(sym = node.scope.find_variable(name))) {
          sym = toplevel.def_global(node);
          if (node instanceof AST_SymbolExport)
            sym.export = MASK_EXPORT_DONT_MANGLE;
        } else if (sym.scope instanceof AST_Lambda && name == "arguments") {
          sym.scope.get_defun_scope().uses_arguments = true;
        }
        node.thedef = sym;
        node.reference();
        if (node.scope.is_block_scope() && !(sym.orig[0] instanceof AST_SymbolBlockDeclaration)) {
          node.scope = node.scope.get_defun_scope();
        }
        return true;
      }
      var def;
      if (node instanceof AST_SymbolCatch && (def = redefined_catch_def(node.definition()))) {
        var s32 = node.scope;
        while (s32) {
          push_uniq(s32.enclosed, def);
          if (s32 === def.scope)
            break;
          s32 = s32.parent_scope;
        }
      }
    });
    this.walk(tw);
    if (options3.ie8 || options3.safari10) {
      walk2(this, (node) => {
        if (node instanceof AST_SymbolCatch) {
          var name = node.name;
          var refs = node.thedef.references;
          var scope2 = node.scope.get_defun_scope();
          var def = scope2.find_variable(name) || toplevel.globals.get(name) || scope2.def_variable(node);
          refs.forEach(function(ref2) {
            ref2.thedef = def;
            ref2.reference();
          });
          node.thedef = def;
          node.reference();
          return true;
        }
      });
    }
    if (options3.safari10) {
      for (const scope2 of for_scopes) {
        scope2.parent_scope.variables.forEach(function(def) {
          push_uniq(scope2.enclosed, def);
        });
      }
    }
  });
  AST_Toplevel.DEFMETHOD("def_global", function(node) {
    var globals = this.globals, name = node.name;
    if (globals.has(name)) {
      return globals.get(name);
    } else {
      var g22 = new SymbolDef(this, node);
      g22.undeclared = true;
      g22.global = true;
      globals.set(name, g22);
      return g22;
    }
  });
  AST_Scope.DEFMETHOD("init_scope_vars", function(parent_scope) {
    this.variables = new Map;
    this.uses_with = false;
    this.uses_eval = false;
    this.parent_scope = parent_scope;
    this.enclosed = [];
    this.cname = -1;
  });
  AST_Scope.DEFMETHOD("conflicting_def", function(name) {
    return this.enclosed.find((def) => def.name === name) || this.variables.has(name) || this.parent_scope && this.parent_scope.conflicting_def(name);
  });
  AST_Scope.DEFMETHOD("conflicting_def_shallow", function(name) {
    return this.enclosed.find((def) => def.name === name) || this.variables.has(name);
  });
  AST_Scope.DEFMETHOD("add_child_scope", function(scope) {
    if (scope.parent_scope === this)
      return;
    scope.parent_scope = this;
    if (scope instanceof AST_Arrow && (this instanceof AST_Lambda && !this.uses_arguments)) {
      this.uses_arguments = walk2(scope, (node) => {
        if (node instanceof AST_SymbolRef && node.scope instanceof AST_Lambda && node.name === "arguments") {
          return walk_abort;
        }
        if (node instanceof AST_Lambda && !(node instanceof AST_Arrow)) {
          return true;
        }
      });
    }
    this.uses_with = this.uses_with || scope.uses_with;
    this.uses_eval = this.uses_eval || scope.uses_eval;
    const scope_ancestry = (() => {
      const ancestry = [];
      let cur = this;
      do {
        ancestry.push(cur);
      } while (cur = cur.parent_scope);
      ancestry.reverse();
      return ancestry;
    })();
    const new_scope_enclosed_set = new Set(scope.enclosed);
    const to_enclose = [];
    for (const scope_topdown of scope_ancestry) {
      to_enclose.forEach((e) => push_uniq(scope_topdown.enclosed, e));
      for (const def of scope_topdown.variables.values()) {
        if (new_scope_enclosed_set.has(def)) {
          push_uniq(to_enclose, def);
          push_uniq(scope_topdown.enclosed, def);
        }
      }
    }
  });
  AST_Scope.DEFMETHOD("create_symbol", function(SymClass, {
    source,
    tentative_name,
    scope,
    conflict_scopes = [scope],
    init: init3 = null
  } = {}) {
    let symbol_name;
    conflict_scopes = find_scopes_visible_from(conflict_scopes);
    if (tentative_name) {
      tentative_name = symbol_name = tentative_name.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/ig, "_");
      let i2 = 0;
      while (conflict_scopes.find((s32) => s32.conflicting_def_shallow(symbol_name))) {
        symbol_name = tentative_name + "$" + i2++;
      }
    }
    if (!symbol_name) {
      throw new Error("No symbol name could be generated in create_symbol()");
    }
    const symbol22 = make_node(SymClass, source, {
      name: symbol_name,
      scope
    });
    this.def_variable(symbol22, init3 || null);
    symbol22.mark_enclosed();
    return symbol22;
  });
  AST_Node.DEFMETHOD("is_block_scope", return_false);
  AST_Class.DEFMETHOD("is_block_scope", return_false);
  AST_Lambda.DEFMETHOD("is_block_scope", return_false);
  AST_Toplevel.DEFMETHOD("is_block_scope", return_false);
  AST_SwitchBranch.DEFMETHOD("is_block_scope", return_false);
  AST_Block.DEFMETHOD("is_block_scope", return_true);
  AST_Scope.DEFMETHOD("is_block_scope", function() {
    return this._block_scope || false;
  });
  AST_IterationStatement.DEFMETHOD("is_block_scope", return_true);
  AST_Lambda.DEFMETHOD("init_scope_vars", function() {
    AST_Scope.prototype.init_scope_vars.apply(this, arguments);
    this.uses_arguments = false;
    this.def_variable(new AST_SymbolFunarg({
      name: "arguments",
      start: this.start,
      end: this.end
    }));
  });
  AST_Arrow.DEFMETHOD("init_scope_vars", function() {
    AST_Scope.prototype.init_scope_vars.apply(this, arguments);
    this.uses_arguments = false;
  });
  AST_Symbol.DEFMETHOD("mark_enclosed", function() {
    var def = this.definition();
    var s32 = this.scope;
    while (s32) {
      push_uniq(s32.enclosed, def);
      if (s32 === def.scope)
        break;
      s32 = s32.parent_scope;
    }
  });
  AST_Symbol.DEFMETHOD("reference", function() {
    this.definition().references.push(this);
    this.mark_enclosed();
  });
  AST_Scope.DEFMETHOD("find_variable", function(name) {
    if (name instanceof AST_Symbol)
      name = name.name;
    return this.variables.get(name) || this.parent_scope && this.parent_scope.find_variable(name);
  });
  AST_Scope.DEFMETHOD("def_function", function(symbol22, init3) {
    var def = this.def_variable(symbol22, init3);
    if (!def.init || def.init instanceof AST_Defun)
      def.init = init3;
    return def;
  });
  AST_Scope.DEFMETHOD("def_variable", function(symbol22, init3) {
    var def = this.variables.get(symbol22.name);
    if (def) {
      def.orig.push(symbol22);
      if (def.init && (def.scope !== symbol22.scope || def.init instanceof AST_Function)) {
        def.init = init3;
      }
    } else {
      def = new SymbolDef(this, symbol22, init3);
      this.variables.set(symbol22.name, def);
      def.global = !this.parent_scope;
    }
    return symbol22.thedef = def;
  });
  AST_Scope.DEFMETHOD("next_mangled", function(options3) {
    return next_mangled(this, options3);
  });
  AST_Toplevel.DEFMETHOD("next_mangled", function(options3) {
    let name;
    const mangled_names = this.mangled_names;
    do {
      name = next_mangled(this, options3);
    } while (mangled_names.has(name));
    return name;
  });
  AST_Function.DEFMETHOD("next_mangled", function(options3, def) {
    var tricky_def = def.orig[0] instanceof AST_SymbolFunarg && this.name && this.name.definition();
    var tricky_name = tricky_def ? tricky_def.mangled_name || tricky_def.name : null;
    while (true) {
      var name = next_mangled(this, options3);
      if (!tricky_name || tricky_name != name)
        return name;
    }
  });
  AST_Symbol.DEFMETHOD("unmangleable", function(options3) {
    var def = this.definition();
    return !def || def.unmangleable(options3);
  });
  AST_Label.DEFMETHOD("unmangleable", return_false);
  AST_Symbol.DEFMETHOD("unreferenced", function() {
    return !this.definition().references.length && !this.scope.pinned();
  });
  AST_Symbol.DEFMETHOD("definition", function() {
    return this.thedef;
  });
  AST_Symbol.DEFMETHOD("global", function() {
    return this.thedef.global;
  });
  AST_Toplevel.DEFMETHOD("mangle_names", function(options3) {
    options3 = format_mangler_options(options3);
    var nth_identifier = options3.nth_identifier;
    var lname = -1;
    var to_mangle = [];
    if (options3.keep_fnames) {
      function_defs = new Set;
    }
    const mangled_names = this.mangled_names = new Set;
    unmangleable_names = new Set;
    if (options3.cache) {
      this.globals.forEach(collect22);
      if (options3.cache.props) {
        options3.cache.props.forEach(function(mangled_name) {
          mangled_names.add(mangled_name);
        });
      }
    }
    var tw = new TreeWalker(function(node, descend) {
      if (node instanceof AST_LabeledStatement) {
        var save_nesting = lname;
        descend();
        lname = save_nesting;
        return true;
      }
      if (node instanceof AST_Defun && !(tw.parent() instanceof AST_Scope)) {
        scopes_with_block_defuns = scopes_with_block_defuns || new Set;
        scopes_with_block_defuns.add(node.parent_scope.get_defun_scope());
      }
      if (node instanceof AST_Scope) {
        node.variables.forEach(collect22);
        return;
      }
      if (node.is_block_scope()) {
        node.block_scope.variables.forEach(collect22);
        return;
      }
      if (function_defs && node instanceof AST_VarDef && node.value instanceof AST_Lambda && !node.value.name && keep_name(options3.keep_fnames, node.name.name)) {
        function_defs.add(node.name.definition().id);
        return;
      }
      if (node instanceof AST_Label) {
        let name;
        do {
          name = nth_identifier.get(++lname);
        } while (ALL_RESERVED_WORDS.has(name));
        node.mangled_name = name;
        return true;
      }
      if (!(options3.ie8 || options3.safari10) && node instanceof AST_SymbolCatch) {
        to_mangle.push(node.definition());
        return;
      }
    });
    this.walk(tw);
    if (options3.keep_fnames || options3.keep_classnames) {
      to_mangle.forEach((def) => {
        if (def.name.length < 6 && def.unmangleable(options3)) {
          unmangleable_names.add(def.name);
        }
      });
    }
    to_mangle.forEach((def) => {
      def.mangle(options3);
    });
    function_defs = null;
    unmangleable_names = null;
    scopes_with_block_defuns = null;
    function collect22(symbol22) {
      if (symbol22.export & MASK_EXPORT_DONT_MANGLE) {
        unmangleable_names.add(symbol22.name);
      } else if (!options3.reserved.has(symbol22.name)) {
        to_mangle.push(symbol22);
      }
    }
  });
  AST_Toplevel.DEFMETHOD("find_colliding_names", function(options3) {
    const cache3 = options3.cache && options3.cache.props;
    const avoid = new Set;
    options3.reserved.forEach(to_avoid);
    this.globals.forEach(add_def);
    this.walk(new TreeWalker(function(node) {
      if (node instanceof AST_Scope)
        node.variables.forEach(add_def);
      if (node instanceof AST_SymbolCatch)
        add_def(node.definition());
    }));
    return avoid;
    function to_avoid(name) {
      avoid.add(name);
    }
    function add_def(def) {
      var name = def.name;
      if (def.global && cache3 && cache3.has(name))
        name = cache3.get(name);
      else if (!def.unmangleable(options3))
        return;
      to_avoid(name);
    }
  });
  AST_Toplevel.DEFMETHOD("expand_names", function(options3) {
    options3 = format_mangler_options(options3);
    var nth_identifier = options3.nth_identifier;
    if (nth_identifier.reset && nth_identifier.sort) {
      nth_identifier.reset();
      nth_identifier.sort();
    }
    var avoid = this.find_colliding_names(options3);
    var cname = 0;
    this.globals.forEach(rename2);
    this.walk(new TreeWalker(function(node) {
      if (node instanceof AST_Scope)
        node.variables.forEach(rename2);
      if (node instanceof AST_SymbolCatch)
        rename2(node.definition());
    }));
    function next_name() {
      var name;
      do {
        name = nth_identifier.get(cname++);
      } while (avoid.has(name) || ALL_RESERVED_WORDS.has(name));
      return name;
    }
    function rename2(def) {
      if (def.global && options3.cache)
        return;
      if (def.unmangleable(options3))
        return;
      if (options3.reserved.has(def.name))
        return;
      const redefinition = redefined_catch_def(def);
      const name = def.name = redefinition ? redefinition.name : next_name();
      def.orig.forEach(function(sym) {
        sym.name = name;
      });
      def.references.forEach(function(sym) {
        sym.name = name;
      });
    }
  });
  AST_Node.DEFMETHOD("tail_node", return_this);
  AST_Sequence.DEFMETHOD("tail_node", function() {
    return this.expressions[this.expressions.length - 1];
  });
  AST_Toplevel.DEFMETHOD("compute_char_frequency", function(options3) {
    options3 = format_mangler_options(options3);
    var nth_identifier = options3.nth_identifier;
    if (!nth_identifier.reset || !nth_identifier.consider || !nth_identifier.sort) {
      return;
    }
    nth_identifier.reset();
    try {
      AST_Node.prototype.print = function(stream2, force_parens) {
        this._print(stream2, force_parens);
        if (this instanceof AST_Symbol && !this.unmangleable(options3)) {
          nth_identifier.consider(this.name, -1);
        } else if (options3.properties) {
          if (this instanceof AST_DotHash) {
            nth_identifier.consider("#" + this.property, -1);
          } else if (this instanceof AST_Dot) {
            nth_identifier.consider(this.property, -1);
          } else if (this instanceof AST_Sub) {
            skip_string(this.property);
          }
        }
      };
      nth_identifier.consider(this.print_to_string(), 1);
    } finally {
      AST_Node.prototype.print = AST_Node.prototype._print;
    }
    nth_identifier.sort();
    function skip_string(node) {
      if (node instanceof AST_String) {
        nth_identifier.consider(node.value, -1);
      } else if (node instanceof AST_Conditional) {
        skip_string(node.consequent);
        skip_string(node.alternative);
      } else if (node instanceof AST_Sequence) {
        skip_string(node.tail_node());
      }
    }
  });
  base54 = (() => {
    const leading = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".split("");
    const digits = "0123456789".split("");
    let chars2;
    let frequency;
    function reset3() {
      frequency = new Map;
      leading.forEach(function(ch) {
        frequency.set(ch, 0);
      });
      digits.forEach(function(ch) {
        frequency.set(ch, 0);
      });
    }
    function consider(str, delta) {
      for (var i2 = str.length;--i2 >= 0; ) {
        frequency.set(str[i2], frequency.get(str[i2]) + delta);
      }
    }
    function compare(a, b22) {
      return frequency.get(b22) - frequency.get(a);
    }
    function sort() {
      chars2 = mergeSort(leading, compare).concat(mergeSort(digits, compare));
    }
    reset3();
    sort();
    function base542(num) {
      var ret = "", base2 = 54;
      num++;
      do {
        num--;
        ret += chars2[num % base2];
        num = Math.floor(num / base2);
        base2 = 64;
      } while (num > 0);
      return ret;
    }
    return {
      get: base542,
      consider,
      reset: reset3,
      sort
    };
  })();
});
var mangle_options = undefined;
var list_overhead = (array) => array.length && array.length - 1;
var lambda_modifiers = (func) => (func.is_generator ? 1 : 0) + (func.async ? 6 : 0);
var key_size = (key) => typeof key === "string" ? key.length : 0;
var static_size = (is_static) => is_static ? 7 : 0;
var init_size = __esm2(() => {
  init_ast();
  init_first_in_statement();
  AST_Node.prototype.size = function(compressor, stack) {
    mangle_options = compressor && compressor._mangle_options;
    let size = 0;
    walk_parent(this, (node, info) => {
      size += node._size(info);
      if (node instanceof AST_Arrow && node.is_braceless()) {
        size += node.body[0].value._size(info);
        return true;
      }
    }, stack || compressor && compressor.stack);
    mangle_options = undefined;
    return size;
  };
  AST_Node.prototype._size = () => 0;
  AST_Debugger.prototype._size = () => 8;
  AST_Directive.prototype._size = function() {
    return 2 + this.value.length;
  };
  AST_Block.prototype._size = function() {
    return 2 + list_overhead(this.body);
  };
  AST_Toplevel.prototype._size = function() {
    return list_overhead(this.body);
  };
  AST_EmptyStatement.prototype._size = () => 1;
  AST_LabeledStatement.prototype._size = () => 2;
  AST_Do.prototype._size = () => 9;
  AST_While.prototype._size = () => 7;
  AST_For.prototype._size = () => 8;
  AST_ForIn.prototype._size = () => 8;
  AST_With.prototype._size = () => 6;
  AST_Expansion.prototype._size = () => 3;
  AST_Accessor.prototype._size = function() {
    return lambda_modifiers(this) + 4 + list_overhead(this.argnames) + list_overhead(this.body);
  };
  AST_Function.prototype._size = function(info) {
    const first = !!first_in_statement(info);
    return first * 2 + lambda_modifiers(this) + 12 + list_overhead(this.argnames) + list_overhead(this.body);
  };
  AST_Defun.prototype._size = function() {
    return lambda_modifiers(this) + 13 + list_overhead(this.argnames) + list_overhead(this.body);
  };
  AST_Arrow.prototype._size = function() {
    let args_and_arrow = 2 + list_overhead(this.argnames);
    if (!(this.argnames.length === 1 && this.argnames[0] instanceof AST_Symbol)) {
      args_and_arrow += 2;
    }
    const body_overhead = this.is_braceless() ? 0 : list_overhead(this.body) + 2;
    return lambda_modifiers(this) + args_and_arrow + body_overhead;
  };
  AST_Destructuring.prototype._size = () => 2;
  AST_TemplateString.prototype._size = function() {
    return 2 + Math.floor(this.segments.length / 2) * 3;
  };
  AST_TemplateSegment.prototype._size = function() {
    return this.value.length;
  };
  AST_Return.prototype._size = function() {
    return this.value ? 7 : 6;
  };
  AST_Throw.prototype._size = () => 6;
  AST_Break.prototype._size = function() {
    return this.label ? 6 : 5;
  };
  AST_Continue.prototype._size = function() {
    return this.label ? 9 : 8;
  };
  AST_If.prototype._size = () => 4;
  AST_Switch.prototype._size = function() {
    return 8 + list_overhead(this.body);
  };
  AST_Case.prototype._size = function() {
    return 5 + list_overhead(this.body);
  };
  AST_Default.prototype._size = function() {
    return 8 + list_overhead(this.body);
  };
  AST_Try.prototype._size = () => 3;
  AST_Catch.prototype._size = function() {
    let size = 7 + list_overhead(this.body);
    if (this.argname) {
      size += 2;
    }
    return size;
  };
  AST_Finally.prototype._size = function() {
    return 7 + list_overhead(this.body);
  };
  AST_Var.prototype._size = function() {
    return 4 + list_overhead(this.definitions);
  };
  AST_Let.prototype._size = function() {
    return 4 + list_overhead(this.definitions);
  };
  AST_Const.prototype._size = function() {
    return 6 + list_overhead(this.definitions);
  };
  AST_VarDef.prototype._size = function() {
    return this.value ? 1 : 0;
  };
  AST_NameMapping.prototype._size = function() {
    return this.name ? 4 : 0;
  };
  AST_Import.prototype._size = function() {
    let size = 6;
    if (this.imported_name)
      size += 1;
    if (this.imported_name || this.imported_names)
      size += 5;
    if (this.imported_names) {
      size += 2 + list_overhead(this.imported_names);
    }
    return size;
  };
  AST_ImportMeta.prototype._size = () => 11;
  AST_Export.prototype._size = function() {
    let size = 7 + (this.is_default ? 8 : 0);
    if (this.exported_value) {
      size += this.exported_value._size();
    }
    if (this.exported_names) {
      size += 2 + list_overhead(this.exported_names);
    }
    if (this.module_name) {
      size += 5;
    }
    return size;
  };
  AST_Call.prototype._size = function() {
    if (this.optional) {
      return 4 + list_overhead(this.args);
    }
    return 2 + list_overhead(this.args);
  };
  AST_New.prototype._size = function() {
    return 6 + list_overhead(this.args);
  };
  AST_Sequence.prototype._size = function() {
    return list_overhead(this.expressions);
  };
  AST_Dot.prototype._size = function() {
    if (this.optional) {
      return this.property.length + 2;
    }
    return this.property.length + 1;
  };
  AST_DotHash.prototype._size = function() {
    if (this.optional) {
      return this.property.length + 3;
    }
    return this.property.length + 2;
  };
  AST_Sub.prototype._size = function() {
    return this.optional ? 4 : 2;
  };
  AST_Unary.prototype._size = function() {
    if (this.operator === "typeof")
      return 7;
    if (this.operator === "void")
      return 5;
    return this.operator.length;
  };
  AST_Binary.prototype._size = function(info) {
    if (this.operator === "in")
      return 4;
    let size = this.operator.length;
    if ((this.operator === "+" || this.operator === "-") && this.right instanceof AST_Unary && this.right.operator === this.operator) {
      size += 1;
    }
    if (this.needs_parens(info)) {
      size += 2;
    }
    return size;
  };
  AST_Conditional.prototype._size = () => 3;
  AST_Array.prototype._size = function() {
    return 2 + list_overhead(this.elements);
  };
  AST_Object.prototype._size = function(info) {
    let base2 = 2;
    if (first_in_statement(info)) {
      base2 += 2;
    }
    return base2 + list_overhead(this.properties);
  };
  AST_ObjectKeyVal.prototype._size = function() {
    return key_size(this.key) + 1;
  };
  AST_ObjectGetter.prototype._size = function() {
    return 5 + static_size(this.static) + key_size(this.key);
  };
  AST_ObjectSetter.prototype._size = function() {
    return 5 + static_size(this.static) + key_size(this.key);
  };
  AST_ConciseMethod.prototype._size = function() {
    return static_size(this.static) + key_size(this.key) + lambda_modifiers(this);
  };
  AST_PrivateMethod.prototype._size = function() {
    return AST_ConciseMethod.prototype._size.call(this) + 1;
  };
  AST_PrivateGetter.prototype._size = AST_PrivateSetter.prototype._size = function() {
    return AST_ConciseMethod.prototype._size.call(this) + 4;
  };
  AST_PrivateIn.prototype._size = function() {
    return 5;
  };
  AST_Class.prototype._size = function() {
    return (this.name ? 8 : 7) + (this.extends ? 8 : 0);
  };
  AST_ClassStaticBlock.prototype._size = function() {
    return 8 + list_overhead(this.body);
  };
  AST_ClassProperty.prototype._size = function() {
    return static_size(this.static) + (typeof this.key === "string" ? this.key.length + 2 : 0) + (this.value ? 1 : 0);
  };
  AST_ClassPrivateProperty.prototype._size = function() {
    return AST_ClassProperty.prototype._size.call(this) + 1;
  };
  AST_Symbol.prototype._size = function() {
    if (!(mangle_options && this.thedef && !this.thedef.unmangleable(mangle_options))) {
      return this.name.length;
    } else {
      return 1;
    }
  };
  AST_SymbolClassProperty.prototype._size = function() {
    return this.name.length;
  };
  AST_SymbolRef.prototype._size = AST_SymbolDeclaration.prototype._size = function() {
    if (this.name === "arguments")
      return 9;
    return AST_Symbol.prototype._size.call(this);
  };
  AST_NewTarget.prototype._size = () => 10;
  AST_SymbolImportForeign.prototype._size = function() {
    return this.name.length;
  };
  AST_SymbolExportForeign.prototype._size = function() {
    return this.name.length;
  };
  AST_This.prototype._size = () => 4;
  AST_Super.prototype._size = () => 5;
  AST_String.prototype._size = function() {
    return this.value.length + 2;
  };
  AST_Number.prototype._size = function() {
    const { value } = this;
    if (value === 0)
      return 1;
    if (value > 0 && Math.floor(value) === value) {
      return Math.floor(Math.log10(value) + 1);
    }
    return value.toString().length;
  };
  AST_BigInt.prototype._size = function() {
    return this.value.length;
  };
  AST_RegExp.prototype._size = function() {
    return this.value.toString().length;
  };
  AST_Null.prototype._size = () => 4;
  AST_NaN.prototype._size = () => 3;
  AST_Undefined.prototype._size = () => 6;
  AST_Hole.prototype._size = () => 0;
  AST_Infinity.prototype._size = () => 8;
  AST_True.prototype._size = () => 4;
  AST_False.prototype._size = () => 5;
  AST_Await.prototype._size = () => 6;
  AST_Yield.prototype._size = () => 6;
});
var UNUSED = 1;
var TRUTHY = 2;
var FALSY = 4;
var UNDEFINED = 8;
var INLINED = 16;
var WRITE_ONLY = 32;
var SQUEEZED = 256;
var OPTIMIZED = 512;
var TOP = 1024;
var CLEAR_BETWEEN_PASSES;
var has_flag = (node, flag) => node.flags & flag;
var set_flag = (node, flag) => {
  node.flags |= flag;
};
var clear_flag = (node, flag) => {
  node.flags &= ~flag;
};
var init_compressor_flags = __esm2(() => {
  CLEAR_BETWEEN_PASSES = SQUEEZED | OPTIMIZED | TOP;
});
function merge_sequence(array, node) {
  if (node instanceof AST_Sequence) {
    array.push(...node.expressions);
  } else {
    array.push(node);
  }
  return array;
}
function make_sequence(orig, expressions) {
  if (expressions.length == 1)
    return expressions[0];
  if (expressions.length == 0)
    throw new Error("trying to create a sequence with length zero!");
  return make_node(AST_Sequence, orig, {
    expressions: expressions.reduce(merge_sequence, [])
  });
}
function make_empty_function(self2) {
  return make_node(AST_Function, self2, {
    uses_arguments: false,
    argnames: [],
    body: [],
    is_generator: false,
    async: false,
    variables: new Map,
    uses_with: false,
    uses_eval: false,
    parent_scope: null,
    enclosed: [],
    cname: 0,
    block_scope: undefined
  });
}
function make_node_from_constant(val2, orig) {
  switch (typeof val2) {
    case "string":
      return make_node(AST_String, orig, {
        value: val2
      });
    case "number":
      if (isNaN(val2))
        return make_node(AST_NaN, orig);
      if (isFinite(val2)) {
        return 1 / val2 < 0 ? make_node(AST_UnaryPrefix, orig, {
          operator: "-",
          expression: make_node(AST_Number, orig, { value: -val2 })
        }) : make_node(AST_Number, orig, { value: val2 });
      }
      return val2 < 0 ? make_node(AST_UnaryPrefix, orig, {
        operator: "-",
        expression: make_node(AST_Infinity, orig)
      }) : make_node(AST_Infinity, orig);
    case "bigint":
      return make_node(AST_BigInt, orig, { value: val2.toString() });
    case "boolean":
      return make_node(val2 ? AST_True : AST_False, orig);
    case "undefined":
      return make_node(AST_Undefined, orig);
    default:
      if (val2 === null) {
        return make_node(AST_Null, orig, { value: null });
      }
      if (val2 instanceof RegExp) {
        return make_node(AST_RegExp, orig, {
          value: {
            source: regexp_source_fix(val2.source),
            flags: val2.flags
          }
        });
      }
      throw new Error(string_template("Can't handle constant of type: {type}", {
        type: typeof val2
      }));
  }
}
function best_of_expression(ast1, ast2) {
  return ast1.size() > ast2.size() ? ast2 : ast1;
}
function best_of_statement(ast1, ast2) {
  return best_of_expression(make_node(AST_SimpleStatement, ast1, {
    body: ast1
  }), make_node(AST_SimpleStatement, ast2, {
    body: ast2
  })).body;
}
function best_of(compressor, ast1, ast2) {
  if (first_in_statement(compressor)) {
    return best_of_statement(ast1, ast2);
  } else {
    return best_of_expression(ast1, ast2);
  }
}
function get_simple_key(key) {
  if (key instanceof AST_Constant) {
    return key.getValue();
  }
  if (key instanceof AST_UnaryPrefix && key.operator == "void" && key.expression instanceof AST_Constant) {
    return;
  }
  return key;
}
function read_property(obj, key) {
  key = get_simple_key(key);
  if (key instanceof AST_Node)
    return;
  var value;
  if (obj instanceof AST_Array) {
    var elements = obj.elements;
    if (key == "length")
      return make_node_from_constant(elements.length, obj);
    if (typeof key == "number" && key in elements)
      value = elements[key];
  } else if (obj instanceof AST_Object) {
    key = "" + key;
    var props = obj.properties;
    for (var i2 = props.length;--i2 >= 0; ) {
      var prop = props[i2];
      if (!(prop instanceof AST_ObjectKeyVal))
        return;
      if (!value && props[i2].key === key)
        value = props[i2].value;
    }
  }
  return value instanceof AST_SymbolRef && value.fixed_value() || value;
}
function has_break_or_continue(loop, parent) {
  var found = false;
  var tw = new TreeWalker(function(node) {
    if (found || node instanceof AST_Scope)
      return true;
    if (node instanceof AST_LoopControl && tw.loopcontrol_target(node) === loop) {
      return found = true;
    }
  });
  if (parent instanceof AST_LabeledStatement)
    tw.push(parent);
  tw.push(loop);
  loop.body.walk(tw);
  return found;
}
function maintain_this_binding(parent, orig, val2) {
  if (requires_sequence_to_maintain_binding(parent, orig, val2)) {
    const zero = make_node(AST_Number, orig, { value: 0 });
    return make_sequence(orig, [zero, val2]);
  } else {
    return val2;
  }
}
function requires_sequence_to_maintain_binding(parent, orig, val2) {
  return parent instanceof AST_UnaryPrefix && parent.operator == "delete" || parent instanceof AST_Call && parent.expression === orig && (val2 instanceof AST_Chain || val2 instanceof AST_PropAccess || val2 instanceof AST_SymbolRef && val2.name == "eval");
}
function is_func_expr(node) {
  return node instanceof AST_Arrow || node instanceof AST_Function;
}
function is_iife_call(node) {
  if (node.TYPE != "Call")
    return false;
  return node.expression instanceof AST_Function || is_iife_call(node.expression);
}
function is_empty(thing) {
  if (thing === null)
    return true;
  if (thing instanceof AST_EmptyStatement)
    return true;
  if (thing instanceof AST_BlockStatement)
    return thing.body.length == 0;
  return false;
}
function is_identifier_atom(node) {
  return node instanceof AST_Infinity || node instanceof AST_NaN || node instanceof AST_Undefined;
}
function is_ref_of(ref2, type) {
  if (!(ref2 instanceof AST_SymbolRef))
    return false;
  var orig = ref2.definition().orig;
  for (var i2 = orig.length;--i2 >= 0; ) {
    if (orig[i2] instanceof type)
      return true;
  }
}
function can_be_evicted_from_block(node) {
  return !(node instanceof AST_DefClass || node instanceof AST_Defun || node instanceof AST_Let || node instanceof AST_Const || node instanceof AST_Export || node instanceof AST_Import);
}
function as_statement_array(thing) {
  if (thing === null)
    return [];
  if (thing instanceof AST_BlockStatement)
    return thing.body;
  if (thing instanceof AST_EmptyStatement)
    return [];
  if (thing instanceof AST_Statement)
    return [thing];
  throw new Error("Can't convert thing to statement array");
}
function is_reachable(scope_node, defs) {
  const find_ref = (node) => {
    if (node instanceof AST_SymbolRef && defs.includes(node.definition())) {
      return walk_abort;
    }
  };
  return walk_parent(scope_node, (node, info) => {
    if (node instanceof AST_Scope && node !== scope_node) {
      var parent = info.parent();
      if (parent instanceof AST_Call && parent.expression === node && !(node.async || node.is_generator)) {
        return;
      }
      if (walk2(node, find_ref))
        return walk_abort;
      return true;
    }
  });
}
function is_recursive_ref(tw, def) {
  var node;
  for (var i2 = 0;node = tw.parent(i2); i2++) {
    if (node instanceof AST_Lambda || node instanceof AST_Class) {
      var name = node.name;
      if (name && name.definition() === def) {
        return true;
      }
    }
  }
  return false;
}
function retain_top_func(fn, compressor) {
  return compressor.top_retain && fn instanceof AST_Defun && has_flag(fn, TOP) && fn.name && compressor.top_retain(fn.name.definition());
}
var identifier_atom;
var init_common = __esm2(() => {
  init_ast();
  init_utils5();
  init_first_in_statement();
  init_compressor_flags();
  identifier_atom = makePredicate("Infinity NaN undefined");
});
function make_nested_lookup(obj) {
  const out = new Map;
  for (var key of Object.keys(obj)) {
    out.set(key, makePredicate(obj[key]));
  }
  const does_have = (global_name, fname) => {
    const inner_map = out.get(global_name);
    return inner_map != null && inner_map.has(fname);
  };
  return does_have;
}
var pure_prop_access_globals;
var object_methods;
var is_pure_native_method;
var is_pure_native_fn;
var is_pure_native_value;
var init_native_objects = __esm2(() => {
  init_utils5();
  pure_prop_access_globals = new Set([
    "Number",
    "String",
    "Array",
    "Object",
    "Function",
    "Promise"
  ]);
  object_methods = [
    "constructor",
    "toString",
    "valueOf"
  ];
  is_pure_native_method = make_nested_lookup({
    Array: [
      "at",
      "flat",
      "includes",
      "indexOf",
      "join",
      "lastIndexOf",
      "slice",
      ...object_methods
    ],
    Boolean: object_methods,
    Function: object_methods,
    Number: [
      "toExponential",
      "toFixed",
      "toPrecision",
      ...object_methods
    ],
    Object: object_methods,
    RegExp: [
      "test",
      ...object_methods
    ],
    String: [
      "at",
      "charAt",
      "charCodeAt",
      "charPointAt",
      "concat",
      "endsWith",
      "fromCharCode",
      "fromCodePoint",
      "includes",
      "indexOf",
      "italics",
      "lastIndexOf",
      "localeCompare",
      "match",
      "matchAll",
      "normalize",
      "padStart",
      "padEnd",
      "repeat",
      "replace",
      "replaceAll",
      "search",
      "slice",
      "split",
      "startsWith",
      "substr",
      "substring",
      "repeat",
      "toLocaleLowerCase",
      "toLocaleUpperCase",
      "toLowerCase",
      "toUpperCase",
      "trim",
      "trimEnd",
      "trimStart",
      ...object_methods
    ]
  });
  is_pure_native_fn = make_nested_lookup({
    Array: [
      "isArray"
    ],
    Math: [
      "abs",
      "acos",
      "asin",
      "atan",
      "ceil",
      "cos",
      "exp",
      "floor",
      "log",
      "round",
      "sin",
      "sqrt",
      "tan",
      "atan2",
      "pow",
      "max",
      "min"
    ],
    Number: [
      "isFinite",
      "isNaN"
    ],
    Object: [
      "create",
      "getOwnPropertyDescriptor",
      "getOwnPropertyNames",
      "getPrototypeOf",
      "isExtensible",
      "isFrozen",
      "isSealed",
      "hasOwn",
      "keys"
    ],
    String: [
      "fromCharCode"
    ]
  });
  is_pure_native_value = make_nested_lookup({
    Math: [
      "E",
      "LN10",
      "LN2",
      "LOG2E",
      "LOG10E",
      "PI",
      "SQRT1_2",
      "SQRT2"
    ],
    Number: [
      "MAX_VALUE",
      "MIN_VALUE",
      "NaN",
      "NEGATIVE_INFINITY",
      "POSITIVE_INFINITY"
    ]
  });
});
function is_undefined(node, compressor) {
  return has_flag(node, UNDEFINED) || node instanceof AST_Undefined || node instanceof AST_UnaryPrefix && node.operator == "void" && !node.expression.has_side_effects(compressor);
}
function is_null_or_undefined(node, compressor) {
  let fixed;
  return node instanceof AST_Null || is_undefined(node, compressor) || node instanceof AST_SymbolRef && (fixed = node.definition().fixed) instanceof AST_Node && is_nullish(fixed, compressor);
}
function is_nullish_shortcircuited(node, compressor) {
  if (node instanceof AST_PropAccess || node instanceof AST_Call) {
    return node.optional && is_null_or_undefined(node.expression, compressor) || is_nullish_shortcircuited(node.expression, compressor);
  }
  if (node instanceof AST_Chain)
    return is_nullish_shortcircuited(node.expression, compressor);
  return false;
}
function is_nullish(node, compressor) {
  if (is_null_or_undefined(node, compressor))
    return true;
  return is_nullish_shortcircuited(node, compressor);
}
function is_lhs(node, parent) {
  if (parent instanceof AST_Unary && unary_side_effects.has(parent.operator))
    return parent.expression;
  if (parent instanceof AST_Assign && parent.left === node)
    return node;
  if (parent instanceof AST_ForIn && parent.init === node)
    return node;
}
function is_modified(compressor, tw, node, value, level, immutable) {
  var parent = tw.parent(level);
  var lhs = is_lhs(node, parent);
  if (lhs)
    return lhs;
  if (!immutable && parent instanceof AST_Call && parent.expression === node && !(value instanceof AST_Arrow) && !(value instanceof AST_Class) && !parent.is_callee_pure(compressor) && (!(value instanceof AST_Function) || !(parent instanceof AST_New) && value.contains_this())) {
    return true;
  }
  if (parent instanceof AST_Array) {
    return is_modified(compressor, tw, parent, parent, level + 1);
  }
  if (parent instanceof AST_ObjectKeyVal && node === parent.value) {
    var obj = tw.parent(level + 1);
    return is_modified(compressor, tw, obj, obj, level + 2);
  }
  if (parent instanceof AST_PropAccess && parent.expression === node) {
    var prop = read_property(value, parent.property);
    return !immutable && is_modified(compressor, tw, parent, prop, level + 1);
  }
}
function is_used_in_expression(tw) {
  for (let p32 = -1, node, parent;node = tw.parent(p32), parent = tw.parent(p32 + 1); p32++) {
    if (parent instanceof AST_Sequence) {
      const nth_expression = parent.expressions.indexOf(node);
      if (nth_expression !== parent.expressions.length - 1) {
        const grandparent = tw.parent(p32 + 2);
        if (parent.expressions.length > 2 || parent.expressions.length === 1 || !requires_sequence_to_maintain_binding(grandparent, parent, parent.expressions[1])) {
          return false;
        }
        return true;
      } else {
        continue;
      }
    }
    if (parent instanceof AST_Unary) {
      const op = parent.operator;
      if (op === "void") {
        return false;
      }
      if (op === "typeof" || op === "+" || op === "-" || op === "!" || op === "~") {
        continue;
      }
    }
    if (parent instanceof AST_SimpleStatement || parent instanceof AST_LabeledStatement) {
      return false;
    }
    if (parent instanceof AST_Scope) {
      return false;
    }
    return true;
  }
  return true;
}
var is_undeclared_ref = (node) => node instanceof AST_SymbolRef && node.definition().undeclared;
var bitwise_binop;
var lazy_op;
var unary_side_effects;
var global_pure_fns;
var aborts = (thing) => thing && thing.aborts();
var init_inference = __esm2(() => {
  init_ast();
  init_utils5();
  init_common();
  init_compressor_flags();
  init_native_objects();
  bitwise_binop = makePredicate("<<< >> << & | ^ ~");
  lazy_op = makePredicate("&& || ??");
  unary_side_effects = makePredicate("delete ++ --");
  (function(def_is_boolean) {
    const unary_bool = makePredicate("! delete");
    const binary_bool = makePredicate("in instanceof == != === !== < <= >= >");
    def_is_boolean(AST_Node, return_false);
    def_is_boolean(AST_UnaryPrefix, function() {
      return unary_bool.has(this.operator);
    });
    def_is_boolean(AST_Binary, function() {
      return binary_bool.has(this.operator) || lazy_op.has(this.operator) && this.left.is_boolean() && this.right.is_boolean();
    });
    def_is_boolean(AST_Conditional, function() {
      return this.consequent.is_boolean() && this.alternative.is_boolean();
    });
    def_is_boolean(AST_Assign, function() {
      return this.operator == "=" && this.right.is_boolean();
    });
    def_is_boolean(AST_Sequence, function() {
      return this.tail_node().is_boolean();
    });
    def_is_boolean(AST_True, return_true);
    def_is_boolean(AST_False, return_true);
  })(function(node, func) {
    node.DEFMETHOD("is_boolean", func);
  });
  (function(def_is_number) {
    def_is_number(AST_Node, return_false);
    def_is_number(AST_Number, return_true);
    const unary = makePredicate("+ - ~ ++ --");
    def_is_number(AST_Unary, function() {
      return unary.has(this.operator) && !(this.expression instanceof AST_BigInt);
    });
    const numeric_ops = makePredicate("- * / % & | ^ << >> >>>");
    def_is_number(AST_Binary, function(compressor) {
      return numeric_ops.has(this.operator) || this.operator == "+" && this.left.is_number(compressor) && this.right.is_number(compressor);
    });
    def_is_number(AST_Assign, function(compressor) {
      return numeric_ops.has(this.operator.slice(0, -1)) || this.operator == "=" && this.right.is_number(compressor);
    });
    def_is_number(AST_Sequence, function(compressor) {
      return this.tail_node().is_number(compressor);
    });
    def_is_number(AST_Conditional, function(compressor) {
      return this.consequent.is_number(compressor) && this.alternative.is_number(compressor);
    });
  })(function(node, func) {
    node.DEFMETHOD("is_number", func);
  });
  (function(def_is_32_bit_integer) {
    def_is_32_bit_integer(AST_Node, return_false);
    def_is_32_bit_integer(AST_Number, function() {
      return this.value === (this.value | 0);
    });
    def_is_32_bit_integer(AST_UnaryPrefix, function() {
      return this.operator == "~" ? this.expression.is_number() : this.operator === "+" ? this.expression.is_32_bit_integer() : false;
    });
    def_is_32_bit_integer(AST_Binary, function() {
      return bitwise_binop.has(this.operator);
    });
  })(function(node, func) {
    node.DEFMETHOD("is_32_bit_integer", func);
  });
  (function(def_is_string) {
    def_is_string(AST_Node, return_false);
    def_is_string(AST_String, return_true);
    def_is_string(AST_TemplateString, return_true);
    def_is_string(AST_UnaryPrefix, function() {
      return this.operator == "typeof";
    });
    def_is_string(AST_Binary, function(compressor) {
      return this.operator == "+" && (this.left.is_string(compressor) || this.right.is_string(compressor));
    });
    def_is_string(AST_Assign, function(compressor) {
      return (this.operator == "=" || this.operator == "+=") && this.right.is_string(compressor);
    });
    def_is_string(AST_Sequence, function(compressor) {
      return this.tail_node().is_string(compressor);
    });
    def_is_string(AST_Conditional, function(compressor) {
      return this.consequent.is_string(compressor) && this.alternative.is_string(compressor);
    });
  })(function(node, func) {
    node.DEFMETHOD("is_string", func);
  });
  (function(def_has_side_effects) {
    def_has_side_effects(AST_Node, return_true);
    def_has_side_effects(AST_EmptyStatement, return_false);
    def_has_side_effects(AST_Constant, return_false);
    def_has_side_effects(AST_This, return_false);
    function any(list2, compressor) {
      for (var i2 = list2.length;--i2 >= 0; )
        if (list2[i2].has_side_effects(compressor))
          return true;
      return false;
    }
    def_has_side_effects(AST_Block, function(compressor) {
      return any(this.body, compressor);
    });
    def_has_side_effects(AST_Call, function(compressor) {
      if (!this.is_callee_pure(compressor) && (!this.expression.is_call_pure(compressor) || this.expression.has_side_effects(compressor))) {
        return true;
      }
      return any(this.args, compressor);
    });
    def_has_side_effects(AST_Switch, function(compressor) {
      return this.expression.has_side_effects(compressor) || any(this.body, compressor);
    });
    def_has_side_effects(AST_Case, function(compressor) {
      return this.expression.has_side_effects(compressor) || any(this.body, compressor);
    });
    def_has_side_effects(AST_Try, function(compressor) {
      return this.body.has_side_effects(compressor) || this.bcatch && this.bcatch.has_side_effects(compressor) || this.bfinally && this.bfinally.has_side_effects(compressor);
    });
    def_has_side_effects(AST_If, function(compressor) {
      return this.condition.has_side_effects(compressor) || this.body && this.body.has_side_effects(compressor) || this.alternative && this.alternative.has_side_effects(compressor);
    });
    def_has_side_effects(AST_ImportMeta, return_false);
    def_has_side_effects(AST_LabeledStatement, function(compressor) {
      return this.body.has_side_effects(compressor);
    });
    def_has_side_effects(AST_SimpleStatement, function(compressor) {
      return this.body.has_side_effects(compressor);
    });
    def_has_side_effects(AST_Lambda, return_false);
    def_has_side_effects(AST_Class, function(compressor) {
      if (this.extends && this.extends.has_side_effects(compressor)) {
        return true;
      }
      return any(this.properties, compressor);
    });
    def_has_side_effects(AST_ClassStaticBlock, function(compressor) {
      return any(this.body, compressor);
    });
    def_has_side_effects(AST_Binary, function(compressor) {
      return this.left.has_side_effects(compressor) || this.right.has_side_effects(compressor);
    });
    def_has_side_effects(AST_Assign, return_true);
    def_has_side_effects(AST_Conditional, function(compressor) {
      return this.condition.has_side_effects(compressor) || this.consequent.has_side_effects(compressor) || this.alternative.has_side_effects(compressor);
    });
    def_has_side_effects(AST_Unary, function(compressor) {
      return unary_side_effects.has(this.operator) || this.expression.has_side_effects(compressor);
    });
    def_has_side_effects(AST_SymbolRef, function(compressor) {
      return !this.is_declared(compressor) && !pure_prop_access_globals.has(this.name);
    });
    def_has_side_effects(AST_SymbolClassProperty, return_false);
    def_has_side_effects(AST_SymbolDeclaration, return_false);
    def_has_side_effects(AST_Object, function(compressor) {
      return any(this.properties, compressor);
    });
    def_has_side_effects(AST_ObjectProperty, function(compressor) {
      return this.computed_key() && this.key.has_side_effects(compressor) || this.value && this.value.has_side_effects(compressor);
    });
    def_has_side_effects(AST_ClassProperty, function(compressor) {
      return this.computed_key() && this.key.has_side_effects(compressor) || this.static && this.value && this.value.has_side_effects(compressor);
    });
    def_has_side_effects(AST_ConciseMethod, function(compressor) {
      return this.computed_key() && this.key.has_side_effects(compressor);
    });
    def_has_side_effects(AST_ObjectGetter, function(compressor) {
      return this.computed_key() && this.key.has_side_effects(compressor);
    });
    def_has_side_effects(AST_ObjectSetter, function(compressor) {
      return this.computed_key() && this.key.has_side_effects(compressor);
    });
    def_has_side_effects(AST_Array, function(compressor) {
      return any(this.elements, compressor);
    });
    def_has_side_effects(AST_Dot, function(compressor) {
      if (is_nullish(this, compressor)) {
        return this.expression.has_side_effects(compressor);
      }
      if (!this.optional && this.expression.may_throw_on_access(compressor)) {
        return true;
      }
      return this.expression.has_side_effects(compressor);
    });
    def_has_side_effects(AST_Sub, function(compressor) {
      if (is_nullish(this, compressor)) {
        return this.expression.has_side_effects(compressor);
      }
      if (!this.optional && this.expression.may_throw_on_access(compressor)) {
        return true;
      }
      var property = this.property.has_side_effects(compressor);
      if (property && this.optional)
        return true;
      return property || this.expression.has_side_effects(compressor);
    });
    def_has_side_effects(AST_Chain, function(compressor) {
      return this.expression.has_side_effects(compressor);
    });
    def_has_side_effects(AST_Sequence, function(compressor) {
      return any(this.expressions, compressor);
    });
    def_has_side_effects(AST_Definitions, function(compressor) {
      return any(this.definitions, compressor);
    });
    def_has_side_effects(AST_VarDef, function() {
      return this.value != null;
    });
    def_has_side_effects(AST_TemplateSegment, return_false);
    def_has_side_effects(AST_TemplateString, function(compressor) {
      return any(this.segments, compressor);
    });
  })(function(node, func) {
    node.DEFMETHOD("has_side_effects", func);
  });
  (function(def_may_throw) {
    def_may_throw(AST_Node, return_true);
    def_may_throw(AST_Constant, return_false);
    def_may_throw(AST_EmptyStatement, return_false);
    def_may_throw(AST_Lambda, return_false);
    def_may_throw(AST_SymbolDeclaration, return_false);
    def_may_throw(AST_This, return_false);
    def_may_throw(AST_ImportMeta, return_false);
    function any(list2, compressor) {
      for (var i2 = list2.length;--i2 >= 0; )
        if (list2[i2].may_throw(compressor))
          return true;
      return false;
    }
    def_may_throw(AST_Class, function(compressor) {
      if (this.extends && this.extends.may_throw(compressor))
        return true;
      return any(this.properties, compressor);
    });
    def_may_throw(AST_ClassStaticBlock, function(compressor) {
      return any(this.body, compressor);
    });
    def_may_throw(AST_Array, function(compressor) {
      return any(this.elements, compressor);
    });
    def_may_throw(AST_Assign, function(compressor) {
      if (this.right.may_throw(compressor))
        return true;
      if (!compressor.has_directive("use strict") && this.operator == "=" && this.left instanceof AST_SymbolRef) {
        return false;
      }
      return this.left.may_throw(compressor);
    });
    def_may_throw(AST_Binary, function(compressor) {
      return this.left.may_throw(compressor) || this.right.may_throw(compressor);
    });
    def_may_throw(AST_Block, function(compressor) {
      return any(this.body, compressor);
    });
    def_may_throw(AST_Call, function(compressor) {
      if (is_nullish(this, compressor))
        return false;
      if (any(this.args, compressor))
        return true;
      if (this.is_callee_pure(compressor))
        return false;
      if (this.expression.may_throw(compressor))
        return true;
      return !(this.expression instanceof AST_Lambda) || any(this.expression.body, compressor);
    });
    def_may_throw(AST_Case, function(compressor) {
      return this.expression.may_throw(compressor) || any(this.body, compressor);
    });
    def_may_throw(AST_Conditional, function(compressor) {
      return this.condition.may_throw(compressor) || this.consequent.may_throw(compressor) || this.alternative.may_throw(compressor);
    });
    def_may_throw(AST_Definitions, function(compressor) {
      return any(this.definitions, compressor);
    });
    def_may_throw(AST_If, function(compressor) {
      return this.condition.may_throw(compressor) || this.body && this.body.may_throw(compressor) || this.alternative && this.alternative.may_throw(compressor);
    });
    def_may_throw(AST_LabeledStatement, function(compressor) {
      return this.body.may_throw(compressor);
    });
    def_may_throw(AST_Object, function(compressor) {
      return any(this.properties, compressor);
    });
    def_may_throw(AST_ObjectProperty, function(compressor) {
      return this.value ? this.value.may_throw(compressor) : false;
    });
    def_may_throw(AST_ClassProperty, function(compressor) {
      return this.computed_key() && this.key.may_throw(compressor) || this.static && this.value && this.value.may_throw(compressor);
    });
    def_may_throw(AST_ConciseMethod, function(compressor) {
      return this.computed_key() && this.key.may_throw(compressor);
    });
    def_may_throw(AST_ObjectGetter, function(compressor) {
      return this.computed_key() && this.key.may_throw(compressor);
    });
    def_may_throw(AST_ObjectSetter, function(compressor) {
      return this.computed_key() && this.key.may_throw(compressor);
    });
    def_may_throw(AST_Return, function(compressor) {
      return this.value && this.value.may_throw(compressor);
    });
    def_may_throw(AST_Sequence, function(compressor) {
      return any(this.expressions, compressor);
    });
    def_may_throw(AST_SimpleStatement, function(compressor) {
      return this.body.may_throw(compressor);
    });
    def_may_throw(AST_Dot, function(compressor) {
      if (is_nullish(this, compressor))
        return false;
      return !this.optional && this.expression.may_throw_on_access(compressor) || this.expression.may_throw(compressor);
    });
    def_may_throw(AST_Sub, function(compressor) {
      if (is_nullish(this, compressor))
        return false;
      return !this.optional && this.expression.may_throw_on_access(compressor) || this.expression.may_throw(compressor) || this.property.may_throw(compressor);
    });
    def_may_throw(AST_Chain, function(compressor) {
      return this.expression.may_throw(compressor);
    });
    def_may_throw(AST_Switch, function(compressor) {
      return this.expression.may_throw(compressor) || any(this.body, compressor);
    });
    def_may_throw(AST_SymbolRef, function(compressor) {
      return !this.is_declared(compressor) && !pure_prop_access_globals.has(this.name);
    });
    def_may_throw(AST_SymbolClassProperty, return_false);
    def_may_throw(AST_Try, function(compressor) {
      return this.bcatch ? this.bcatch.may_throw(compressor) : this.body.may_throw(compressor) || this.bfinally && this.bfinally.may_throw(compressor);
    });
    def_may_throw(AST_Unary, function(compressor) {
      if (this.operator == "typeof" && this.expression instanceof AST_SymbolRef)
        return false;
      return this.expression.may_throw(compressor);
    });
    def_may_throw(AST_VarDef, function(compressor) {
      if (!this.value)
        return false;
      return this.value.may_throw(compressor);
    });
  })(function(node, func) {
    node.DEFMETHOD("may_throw", func);
  });
  (function(def_is_constant_expression) {
    function all_refs_local(scope) {
      let result2 = true;
      walk2(this, (node) => {
        if (node instanceof AST_SymbolRef) {
          if (has_flag(this, INLINED)) {
            result2 = false;
            return walk_abort;
          }
          var def = node.definition();
          if (member(def, this.enclosed) && !this.variables.has(def.name)) {
            if (scope) {
              var scope_def = scope.find_variable(node);
              if (def.undeclared ? !scope_def : scope_def === def) {
                result2 = "f";
                return true;
              }
            }
            result2 = false;
            return walk_abort;
          }
          return true;
        }
        if (node instanceof AST_This && this instanceof AST_Arrow) {
          result2 = false;
          return walk_abort;
        }
      });
      return result2;
    }
    def_is_constant_expression(AST_Node, return_false);
    def_is_constant_expression(AST_Constant, return_true);
    def_is_constant_expression(AST_Class, function(scope) {
      if (this.extends && !this.extends.is_constant_expression(scope)) {
        return false;
      }
      for (const prop of this.properties) {
        if (prop.computed_key() && !prop.key.is_constant_expression(scope)) {
          return false;
        }
        if (prop.static && prop.value && !prop.value.is_constant_expression(scope)) {
          return false;
        }
        if (prop instanceof AST_ClassStaticBlock) {
          return false;
        }
      }
      return all_refs_local.call(this, scope);
    });
    def_is_constant_expression(AST_Lambda, all_refs_local);
    def_is_constant_expression(AST_Unary, function() {
      return this.expression.is_constant_expression();
    });
    def_is_constant_expression(AST_Binary, function() {
      return this.left.is_constant_expression() && this.right.is_constant_expression();
    });
    def_is_constant_expression(AST_Array, function() {
      return this.elements.every((l22) => l22.is_constant_expression());
    });
    def_is_constant_expression(AST_Object, function() {
      return this.properties.every((l22) => l22.is_constant_expression());
    });
    def_is_constant_expression(AST_ObjectProperty, function() {
      return !!(!(this.key instanceof AST_Node) && this.value && this.value.is_constant_expression());
    });
  })(function(node, func) {
    node.DEFMETHOD("is_constant_expression", func);
  });
  (function(def_may_throw_on_access) {
    AST_Node.DEFMETHOD("may_throw_on_access", function(compressor) {
      return !compressor.option("pure_getters") || this._dot_throw(compressor);
    });
    function is_strict(compressor) {
      return /strict/.test(compressor.option("pure_getters"));
    }
    def_may_throw_on_access(AST_Node, is_strict);
    def_may_throw_on_access(AST_Null, return_true);
    def_may_throw_on_access(AST_Undefined, return_true);
    def_may_throw_on_access(AST_Constant, return_false);
    def_may_throw_on_access(AST_Array, return_false);
    def_may_throw_on_access(AST_Object, function(compressor) {
      if (!is_strict(compressor))
        return false;
      for (var i2 = this.properties.length;--i2 >= 0; )
        if (this.properties[i2]._dot_throw(compressor))
          return true;
      return false;
    });
    def_may_throw_on_access(AST_Class, return_false);
    def_may_throw_on_access(AST_ObjectProperty, return_false);
    def_may_throw_on_access(AST_ObjectGetter, return_true);
    def_may_throw_on_access(AST_Expansion, function(compressor) {
      return this.expression._dot_throw(compressor);
    });
    def_may_throw_on_access(AST_Function, return_false);
    def_may_throw_on_access(AST_Arrow, return_false);
    def_may_throw_on_access(AST_UnaryPostfix, return_false);
    def_may_throw_on_access(AST_UnaryPrefix, function() {
      return this.operator == "void";
    });
    def_may_throw_on_access(AST_Binary, function(compressor) {
      return (this.operator == "&&" || this.operator == "||" || this.operator == "??") && (this.left._dot_throw(compressor) || this.right._dot_throw(compressor));
    });
    def_may_throw_on_access(AST_Assign, function(compressor) {
      if (this.logical)
        return true;
      return this.operator == "=" && this.right._dot_throw(compressor);
    });
    def_may_throw_on_access(AST_Conditional, function(compressor) {
      return this.consequent._dot_throw(compressor) || this.alternative._dot_throw(compressor);
    });
    def_may_throw_on_access(AST_Dot, function(compressor) {
      if (!is_strict(compressor))
        return false;
      if (this.property == "prototype") {
        return !(this.expression instanceof AST_Function || this.expression instanceof AST_Class);
      }
      return true;
    });
    def_may_throw_on_access(AST_Chain, function(compressor) {
      return this.expression._dot_throw(compressor);
    });
    def_may_throw_on_access(AST_Sequence, function(compressor) {
      return this.tail_node()._dot_throw(compressor);
    });
    def_may_throw_on_access(AST_SymbolRef, function(compressor) {
      if (this.name === "arguments" && this.scope instanceof AST_Lambda)
        return false;
      if (has_flag(this, UNDEFINED))
        return true;
      if (!is_strict(compressor))
        return false;
      if (is_undeclared_ref(this) && this.is_declared(compressor))
        return false;
      if (this.is_immutable())
        return false;
      var fixed = this.fixed_value();
      return !fixed || fixed._dot_throw(compressor);
    });
  })(function(node, func) {
    node.DEFMETHOD("_dot_throw", func);
  });
  (function(def_negate) {
    function basic_negation(exp) {
      return make_node(AST_UnaryPrefix, exp, {
        operator: "!",
        expression: exp
      });
    }
    function best(orig, alt, first_in_statement2) {
      var negated = basic_negation(orig);
      if (first_in_statement2) {
        var stat22 = make_node(AST_SimpleStatement, alt, {
          body: alt
        });
        return best_of_expression(negated, stat22) === stat22 ? alt : negated;
      }
      return best_of_expression(negated, alt);
    }
    def_negate(AST_Node, function() {
      return basic_negation(this);
    });
    def_negate(AST_Statement, function() {
      throw new Error("Cannot negate a statement");
    });
    def_negate(AST_Function, function() {
      return basic_negation(this);
    });
    def_negate(AST_Class, function() {
      return basic_negation(this);
    });
    def_negate(AST_Arrow, function() {
      return basic_negation(this);
    });
    def_negate(AST_UnaryPrefix, function() {
      if (this.operator == "!")
        return this.expression;
      return basic_negation(this);
    });
    def_negate(AST_Sequence, function(compressor) {
      var expressions = this.expressions.slice();
      expressions.push(expressions.pop().negate(compressor));
      return make_sequence(this, expressions);
    });
    def_negate(AST_Conditional, function(compressor, first_in_statement2) {
      var self2 = this.clone();
      self2.consequent = self2.consequent.negate(compressor);
      self2.alternative = self2.alternative.negate(compressor);
      return best(this, self2, first_in_statement2);
    });
    def_negate(AST_Binary, function(compressor, first_in_statement2) {
      var self2 = this.clone(), op = this.operator;
      if (compressor.option("unsafe_comps")) {
        switch (op) {
          case "<=":
            self2.operator = ">";
            return self2;
          case "<":
            self2.operator = ">=";
            return self2;
          case ">=":
            self2.operator = "<";
            return self2;
          case ">":
            self2.operator = "<=";
            return self2;
        }
      }
      switch (op) {
        case "==":
          self2.operator = "!=";
          return self2;
        case "!=":
          self2.operator = "==";
          return self2;
        case "===":
          self2.operator = "!==";
          return self2;
        case "!==":
          self2.operator = "===";
          return self2;
        case "&&":
          self2.operator = "||";
          self2.left = self2.left.negate(compressor, first_in_statement2);
          self2.right = self2.right.negate(compressor);
          return best(this, self2, first_in_statement2);
        case "||":
          self2.operator = "&&";
          self2.left = self2.left.negate(compressor, first_in_statement2);
          self2.right = self2.right.negate(compressor);
          return best(this, self2, first_in_statement2);
      }
      return basic_negation(this);
    });
  })(function(node, func) {
    node.DEFMETHOD("negate", function(compressor, first_in_statement2) {
      return func.call(this, compressor, first_in_statement2);
    });
  });
  (function(def_bitwise_negate) {
    function basic_negation(exp) {
      return make_node(AST_UnaryPrefix, exp, {
        operator: "~",
        expression: exp
      });
    }
    def_bitwise_negate(AST_Node, function() {
      return basic_negation(this);
    });
    def_bitwise_negate(AST_Number, function() {
      const neg = ~this.value;
      if (neg.toString().length > this.value.toString().length) {
        return basic_negation(this);
      }
      return make_node(AST_Number, this, { value: neg });
    });
    def_bitwise_negate(AST_UnaryPrefix, function(in_32_bit_context) {
      if (this.operator == "~" && (in_32_bit_context || this.expression.is_32_bit_integer())) {
        return this.expression;
      } else {
        return basic_negation(this);
      }
    });
  })(function(node, func) {
    node.DEFMETHOD("bitwise_negate", func);
  });
  global_pure_fns = makePredicate("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
  AST_Call.DEFMETHOD("is_callee_pure", function(compressor) {
    if (compressor.option("unsafe")) {
      var expr = this.expression;
      var first_arg = this.args && this.args[0] && this.args[0].evaluate(compressor);
      if (expr.expression && expr.expression.name === "hasOwnProperty" && (first_arg == null || first_arg.thedef && first_arg.thedef.undeclared)) {
        return false;
      }
      if (is_undeclared_ref(expr) && global_pure_fns.has(expr.name))
        return true;
      if (expr instanceof AST_Dot && is_undeclared_ref(expr.expression) && is_pure_native_fn(expr.expression.name, expr.property)) {
        return true;
      }
    }
    if (this instanceof AST_New && compressor.option("pure_new")) {
      return true;
    }
    if (compressor.option("side_effects") && has_annotation(this, _PURE)) {
      return true;
    }
    return !compressor.pure_funcs(this);
  });
  AST_Node.DEFMETHOD("is_call_pure", return_false);
  AST_Dot.DEFMETHOD("is_call_pure", function(compressor) {
    if (!compressor.option("unsafe"))
      return;
    const expr = this.expression;
    let native_obj;
    if (expr instanceof AST_Array) {
      native_obj = "Array";
    } else if (expr.is_boolean()) {
      native_obj = "Boolean";
    } else if (expr.is_number(compressor)) {
      native_obj = "Number";
    } else if (expr instanceof AST_RegExp) {
      native_obj = "RegExp";
    } else if (expr.is_string(compressor)) {
      native_obj = "String";
    } else if (!this.may_throw_on_access(compressor)) {
      native_obj = "Object";
    }
    return native_obj != null && is_pure_native_method(native_obj, this.property);
  });
  (function(def_aborts) {
    def_aborts(AST_Statement, return_null);
    def_aborts(AST_Jump, return_this);
    function block_aborts() {
      for (var i2 = 0;i2 < this.body.length; i2++) {
        if (aborts(this.body[i2])) {
          return this.body[i2];
        }
      }
      return null;
    }
    def_aborts(AST_Import, return_null);
    def_aborts(AST_BlockStatement, block_aborts);
    def_aborts(AST_SwitchBranch, block_aborts);
    def_aborts(AST_DefClass, function() {
      for (const prop of this.properties) {
        if (prop instanceof AST_ClassStaticBlock) {
          if (prop.aborts())
            return prop;
        }
      }
      return null;
    });
    def_aborts(AST_ClassStaticBlock, block_aborts);
    def_aborts(AST_If, function() {
      return this.alternative && aborts(this.body) && aborts(this.alternative) && this;
    });
  })(function(node, func) {
    node.DEFMETHOD("aborts", func);
  });
  AST_Node.DEFMETHOD("contains_this", function() {
    return walk2(this, (node) => {
      if (node instanceof AST_This)
        return walk_abort;
      if (node !== this && node instanceof AST_Scope && !(node instanceof AST_Arrow)) {
        return true;
      }
    });
  });
});
function def_eval(node, func) {
  node.DEFMETHOD("_eval", func);
}
var nullish;
var unaryPrefix;
var supports_bigint;
var non_converting_unary;
var non_converting_binary;
var identity_comparison;
var has_identity = (value) => typeof value === "object" || typeof value === "function" || typeof value === "symbol";
var reentrant_ref_eval;
var global_objs;
var regexp_flags;
var init_evaluate = __esm2(() => {
  init_utils5();
  init_ast();
  init_inference();
  init_native_objects();
  nullish = Symbol("This AST_Chain is nullish");
  AST_Node.DEFMETHOD("evaluate", function(compressor) {
    if (!compressor.option("evaluate"))
      return this;
    var val2 = this._eval(compressor, 1);
    if (!val2 || val2 instanceof RegExp)
      return val2;
    if (typeof val2 == "function" || typeof val2 == "object" || val2 == nullish)
      return this;
    if (typeof val2 === "string") {
      const unevaluated_size = this.size(compressor);
      if (val2.length + 2 > unevaluated_size)
        return this;
    }
    return val2;
  });
  unaryPrefix = makePredicate("! ~ - + void");
  AST_Node.DEFMETHOD("is_constant", function() {
    if (this instanceof AST_Constant) {
      return !(this instanceof AST_RegExp);
    } else {
      return this instanceof AST_UnaryPrefix && this.expression instanceof AST_Constant && unaryPrefix.has(this.operator);
    }
  });
  def_eval(AST_Statement, function() {
    throw new Error(string_template("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
  });
  def_eval(AST_Lambda, return_this);
  def_eval(AST_Class, return_this);
  def_eval(AST_Node, return_this);
  def_eval(AST_Constant, function() {
    return this.getValue();
  });
  supports_bigint = typeof BigInt === "function";
  def_eval(AST_BigInt, function() {
    if (supports_bigint) {
      return BigInt(this.value);
    } else {
      return this;
    }
  });
  def_eval(AST_RegExp, function(compressor) {
    let evaluated = compressor.evaluated_regexps.get(this.value);
    if (evaluated === undefined && regexp_is_safe(this.value.source)) {
      try {
        const { source, flags } = this.value;
        evaluated = new RegExp(source, flags);
      } catch (e) {
        evaluated = null;
      }
      compressor.evaluated_regexps.set(this.value, evaluated);
    }
    return evaluated || this;
  });
  def_eval(AST_TemplateString, function() {
    if (this.segments.length !== 1)
      return this;
    return this.segments[0].value;
  });
  def_eval(AST_Function, function(compressor) {
    if (compressor.option("unsafe")) {
      var fn = function() {
      };
      fn.node = this;
      fn.toString = () => this.print_to_string();
      return fn;
    }
    return this;
  });
  def_eval(AST_Array, function(compressor, depth2) {
    if (compressor.option("unsafe")) {
      var elements = [];
      for (var i2 = 0, len = this.elements.length;i2 < len; i2++) {
        var element = this.elements[i2];
        var value = element._eval(compressor, depth2);
        if (element === value)
          return this;
        elements.push(value);
      }
      return elements;
    }
    return this;
  });
  def_eval(AST_Object, function(compressor, depth2) {
    if (compressor.option("unsafe")) {
      var val2 = {};
      for (var i2 = 0, len = this.properties.length;i2 < len; i2++) {
        var prop = this.properties[i2];
        if (prop instanceof AST_Expansion)
          return this;
        var key = prop.key;
        if (key instanceof AST_Symbol) {
          key = key.name;
        } else if (key instanceof AST_Node) {
          key = key._eval(compressor, depth2);
          if (key === prop.key)
            return this;
        }
        if (typeof Object.prototype[key] === "function") {
          return this;
        }
        if (prop.value instanceof AST_Function)
          continue;
        val2[key] = prop.value._eval(compressor, depth2);
        if (val2[key] === prop.value)
          return this;
      }
      return val2;
    }
    return this;
  });
  non_converting_unary = makePredicate("! typeof void");
  def_eval(AST_UnaryPrefix, function(compressor, depth2) {
    var e = this.expression;
    if (compressor.option("typeofs") && this.operator == "typeof") {
      if (e instanceof AST_Lambda || e instanceof AST_SymbolRef && e.fixed_value() instanceof AST_Lambda) {
        return "function";
      }
      if ((e instanceof AST_Object || e instanceof AST_Array || e instanceof AST_SymbolRef && (e.fixed_value() instanceof AST_Object || e.fixed_value() instanceof AST_Array)) && !e.has_side_effects(compressor)) {
        return "object";
      }
    }
    if (!non_converting_unary.has(this.operator))
      depth2++;
    e = e._eval(compressor, depth2);
    if (e === this.expression)
      return this;
    switch (this.operator) {
      case "!":
        return !e;
      case "typeof":
        if (e instanceof RegExp)
          return this;
        return typeof e;
      case "void":
        return;
      case "~":
        return ~e;
      case "-":
        return -e;
      case "+":
        return +e;
    }
    return this;
  });
  non_converting_binary = makePredicate("&& || ?? === !==");
  identity_comparison = makePredicate("== != === !==");
  def_eval(AST_Binary, function(compressor, depth2) {
    if (!non_converting_binary.has(this.operator))
      depth2++;
    var left = this.left._eval(compressor, depth2);
    if (left === this.left)
      return this;
    var right = this.right._eval(compressor, depth2);
    if (right === this.right)
      return this;
    if (left != null && right != null && identity_comparison.has(this.operator) && has_identity(left) && has_identity(right) && typeof left === typeof right) {
      return this;
    }
    if (typeof left === "bigint" !== (typeof right === "bigint") || typeof left === "bigint" && (this.operator === ">>>" || this.operator === "/" && Number(right) === 0)) {
      return this;
    }
    var result2;
    switch (this.operator) {
      case "&&":
        result2 = left && right;
        break;
      case "||":
        result2 = left || right;
        break;
      case "??":
        result2 = left != null ? left : right;
        break;
      case "|":
        result2 = left | right;
        break;
      case "&":
        result2 = left & right;
        break;
      case "^":
        result2 = left ^ right;
        break;
      case "+":
        result2 = left + right;
        break;
      case "*":
        result2 = left * right;
        break;
      case "**":
        result2 = left ** right;
        break;
      case "/":
        result2 = left / right;
        break;
      case "%":
        result2 = left % right;
        break;
      case "-":
        result2 = left - right;
        break;
      case "<<":
        result2 = left << right;
        break;
      case ">>":
        result2 = left >> right;
        break;
      case ">>>":
        result2 = left >>> right;
        break;
      case "==":
        result2 = left == right;
        break;
      case "===":
        result2 = left === right;
        break;
      case "!=":
        result2 = left != right;
        break;
      case "!==":
        result2 = left !== right;
        break;
      case "<":
        result2 = left < right;
        break;
      case "<=":
        result2 = left <= right;
        break;
      case ">":
        result2 = left > right;
        break;
      case ">=":
        result2 = left >= right;
        break;
      default:
        return this;
    }
    if (typeof result2 === "number" && isNaN(result2) && compressor.find_parent(AST_With)) {
      return this;
    }
    return result2;
  });
  def_eval(AST_Conditional, function(compressor, depth2) {
    var condition = this.condition._eval(compressor, depth2);
    if (condition === this.condition)
      return this;
    var node = condition ? this.consequent : this.alternative;
    var value = node._eval(compressor, depth2);
    return value === node ? this : value;
  });
  reentrant_ref_eval = new Set;
  def_eval(AST_SymbolRef, function(compressor, depth2) {
    if (reentrant_ref_eval.has(this))
      return this;
    var fixed = this.fixed_value();
    if (!fixed)
      return this;
    reentrant_ref_eval.add(this);
    const value = fixed._eval(compressor, depth2);
    reentrant_ref_eval.delete(this);
    if (value === fixed)
      return this;
    if (value && typeof value == "object") {
      var escaped = this.definition().escaped;
      if (escaped && depth2 > escaped)
        return this;
    }
    return value;
  });
  global_objs = { Array, Math, Number, Object, String };
  regexp_flags = new Set([
    "dotAll",
    "global",
    "ignoreCase",
    "multiline",
    "sticky",
    "unicode"
  ]);
  def_eval(AST_PropAccess, function(compressor, depth2) {
    let obj = this.expression._eval(compressor, depth2 + 1);
    if (obj === nullish || this.optional && obj == null)
      return nullish;
    if (this.property === "length") {
      if (typeof obj === "string") {
        return obj.length;
      }
      const is_spreadless_array = obj instanceof AST_Array && obj.elements.every((el) => !(el instanceof AST_Expansion));
      if (is_spreadless_array && obj.elements.every((el) => !el.has_side_effects(compressor))) {
        return obj.elements.length;
      }
    }
    if (compressor.option("unsafe")) {
      var key = this.property;
      if (key instanceof AST_Node) {
        key = key._eval(compressor, depth2);
        if (key === this.property)
          return this;
      }
      var exp = this.expression;
      if (is_undeclared_ref(exp)) {
        var aa;
        var first_arg = exp.name === "hasOwnProperty" && key === "call" && (aa = compressor.parent() && compressor.parent().args) && (aa && aa[0] && aa[0].evaluate(compressor));
        first_arg = first_arg instanceof AST_Dot ? first_arg.expression : first_arg;
        if (first_arg == null || first_arg.thedef && first_arg.thedef.undeclared) {
          return this.clone();
        }
        if (!is_pure_native_value(exp.name, key))
          return this;
        obj = global_objs[exp.name];
      } else {
        if (obj instanceof RegExp) {
          if (key == "source") {
            return regexp_source_fix(obj.source);
          } else if (key == "flags" || regexp_flags.has(key)) {
            return obj[key];
          }
        }
        if (!obj || obj === exp || !HOP(obj, key))
          return this;
        if (typeof obj == "function")
          switch (key) {
            case "name":
              return obj.node.name ? obj.node.name.name : "";
            case "length":
              return obj.node.length_property();
            default:
              return this;
          }
      }
      return obj[key];
    }
    return this;
  });
  def_eval(AST_Chain, function(compressor, depth2) {
    const evaluated = this.expression._eval(compressor, depth2);
    return evaluated === nullish ? undefined : evaluated === this.expression ? this : evaluated;
  });
  def_eval(AST_Call, function(compressor, depth2) {
    var exp = this.expression;
    const callee = exp._eval(compressor, depth2);
    if (callee === nullish || this.optional && callee == null)
      return nullish;
    if (compressor.option("unsafe") && exp instanceof AST_PropAccess) {
      var key = exp.property;
      if (key instanceof AST_Node) {
        key = key._eval(compressor, depth2);
        if (key === exp.property)
          return this;
      }
      var val2;
      var e = exp.expression;
      if (is_undeclared_ref(e)) {
        var first_arg = e.name === "hasOwnProperty" && key === "call" && (this.args[0] && this.args[0].evaluate(compressor));
        first_arg = first_arg instanceof AST_Dot ? first_arg.expression : first_arg;
        if (first_arg == null || first_arg.thedef && first_arg.thedef.undeclared) {
          return this.clone();
        }
        if (!is_pure_native_fn(e.name, key))
          return this;
        val2 = global_objs[e.name];
      } else {
        val2 = e._eval(compressor, depth2 + 1);
        if (val2 === e || !val2)
          return this;
        if (!is_pure_native_method(val2.constructor.name, key))
          return this;
      }
      var args = [];
      for (var i2 = 0, len = this.args.length;i2 < len; i2++) {
        var arg = this.args[i2];
        var value = arg._eval(compressor, depth2);
        if (arg === value)
          return this;
        if (arg instanceof AST_Lambda)
          return this;
        args.push(value);
      }
      try {
        return val2[key].apply(val2, args);
      } catch (ex) {
      }
    }
    return this;
  });
  def_eval(AST_New, return_this);
});
function def_drop_side_effect_free(node, func) {
  node.DEFMETHOD("drop_side_effect_free", func);
}
function trim(nodes, compressor, first_in_statement2) {
  var len = nodes.length;
  if (!len)
    return null;
  var ret = [], changed = false;
  for (var i2 = 0;i2 < len; i2++) {
    var node = nodes[i2].drop_side_effect_free(compressor, first_in_statement2);
    changed |= node !== nodes[i2];
    if (node) {
      ret.push(node);
      first_in_statement2 = false;
    }
  }
  return changed ? ret.length ? ret : null : nodes;
}
var init_drop_side_effect_free = __esm2(() => {
  init_ast();
  init_utils5();
  init_first_in_statement();
  init_native_objects();
  init_inference();
  init_compressor_flags();
  init_common();
  def_drop_side_effect_free(AST_Node, return_this);
  def_drop_side_effect_free(AST_Constant, return_null);
  def_drop_side_effect_free(AST_This, return_null);
  def_drop_side_effect_free(AST_Call, function(compressor, first_in_statement2) {
    if (is_nullish_shortcircuited(this, compressor)) {
      return this.expression.drop_side_effect_free(compressor, first_in_statement2);
    }
    if (!this.is_callee_pure(compressor)) {
      if (this.expression.is_call_pure(compressor)) {
        var exprs = this.args.slice();
        exprs.unshift(this.expression.expression);
        exprs = trim(exprs, compressor, first_in_statement2);
        return exprs && make_sequence(this, exprs);
      }
      if (is_func_expr(this.expression) && (!this.expression.name || !this.expression.name.definition().references.length)) {
        var node = this.clone();
        node.expression.process_expression(false, compressor);
        return node;
      }
      return this;
    }
    var args = trim(this.args, compressor, first_in_statement2);
    return args && make_sequence(this, args);
  });
  def_drop_side_effect_free(AST_Accessor, return_null);
  def_drop_side_effect_free(AST_Function, return_null);
  def_drop_side_effect_free(AST_Arrow, return_null);
  def_drop_side_effect_free(AST_Class, function(compressor) {
    const with_effects = [];
    if (this.is_self_referential() && this.has_side_effects(compressor)) {
      return this;
    }
    const trimmed_extends = this.extends && this.extends.drop_side_effect_free(compressor);
    if (trimmed_extends)
      with_effects.push(trimmed_extends);
    for (const prop of this.properties) {
      if (prop instanceof AST_ClassStaticBlock) {
        if (prop.has_side_effects(compressor)) {
          return this;
        }
      } else {
        const trimmed_prop = prop.drop_side_effect_free(compressor);
        if (trimmed_prop)
          with_effects.push(trimmed_prop);
      }
    }
    if (!with_effects.length)
      return null;
    const exprs = make_sequence(this, with_effects);
    if (this instanceof AST_DefClass) {
      return make_node(AST_SimpleStatement, this, { body: exprs });
    } else {
      return exprs;
    }
  });
  def_drop_side_effect_free(AST_ClassProperty, function(compressor) {
    const key = this.computed_key() && this.key.drop_side_effect_free(compressor);
    const value = this.static && this.value && this.value.drop_side_effect_free(compressor);
    if (key && value)
      return make_sequence(this, [key, value]);
    return key || value || null;
  });
  def_drop_side_effect_free(AST_Binary, function(compressor, first_in_statement2) {
    var right = this.right.drop_side_effect_free(compressor);
    if (!right)
      return this.left.drop_side_effect_free(compressor, first_in_statement2);
    if (lazy_op.has(this.operator)) {
      if (right === this.right)
        return this;
      var node = this.clone();
      node.right = right;
      return node;
    } else {
      var left = this.left.drop_side_effect_free(compressor, first_in_statement2);
      if (!left)
        return this.right.drop_side_effect_free(compressor, first_in_statement2);
      return make_sequence(this, [left, right]);
    }
  });
  def_drop_side_effect_free(AST_Assign, function(compressor) {
    if (this.logical)
      return this;
    var left = this.left;
    if (left.has_side_effects(compressor) || compressor.has_directive("use strict") && left instanceof AST_PropAccess && left.expression.is_constant()) {
      return this;
    }
    set_flag(this, WRITE_ONLY);
    while (left instanceof AST_PropAccess) {
      left = left.expression;
    }
    if (left.is_constant_expression(compressor.find_parent(AST_Scope))) {
      return this.right.drop_side_effect_free(compressor);
    }
    return this;
  });
  def_drop_side_effect_free(AST_Conditional, function(compressor) {
    var consequent = this.consequent.drop_side_effect_free(compressor);
    var alternative = this.alternative.drop_side_effect_free(compressor);
    if (consequent === this.consequent && alternative === this.alternative)
      return this;
    if (!consequent)
      return alternative ? make_node(AST_Binary, this, {
        operator: "||",
        left: this.condition,
        right: alternative
      }) : this.condition.drop_side_effect_free(compressor);
    if (!alternative)
      return make_node(AST_Binary, this, {
        operator: "&&",
        left: this.condition,
        right: consequent
      });
    var node = this.clone();
    node.consequent = consequent;
    node.alternative = alternative;
    return node;
  });
  def_drop_side_effect_free(AST_Unary, function(compressor, first_in_statement2) {
    if (unary_side_effects.has(this.operator)) {
      if (!this.expression.has_side_effects(compressor)) {
        set_flag(this, WRITE_ONLY);
      } else {
        clear_flag(this, WRITE_ONLY);
      }
      return this;
    }
    if (this.operator == "typeof" && this.expression instanceof AST_SymbolRef)
      return null;
    var expression = this.expression.drop_side_effect_free(compressor, first_in_statement2);
    if (first_in_statement2 && expression && is_iife_call(expression)) {
      if (expression === this.expression && this.operator == "!")
        return this;
      return expression.negate(compressor, first_in_statement2);
    }
    return expression;
  });
  def_drop_side_effect_free(AST_SymbolRef, function(compressor) {
    const safe_access = this.is_declared(compressor) || pure_prop_access_globals.has(this.name);
    return safe_access ? null : this;
  });
  def_drop_side_effect_free(AST_Object, function(compressor, first_in_statement2) {
    var values3 = trim(this.properties, compressor, first_in_statement2);
    return values3 && make_sequence(this, values3);
  });
  def_drop_side_effect_free(AST_ObjectProperty, function(compressor, first_in_statement2) {
    const computed_key = this instanceof AST_ObjectKeyVal && this.key instanceof AST_Node;
    const key = computed_key && this.key.drop_side_effect_free(compressor, first_in_statement2);
    const value = this.value && this.value.drop_side_effect_free(compressor, first_in_statement2);
    if (key && value) {
      return make_sequence(this, [key, value]);
    }
    return key || value;
  });
  def_drop_side_effect_free(AST_ConciseMethod, function() {
    return this.computed_key() ? this.key : null;
  });
  def_drop_side_effect_free(AST_ObjectGetter, function() {
    return this.computed_key() ? this.key : null;
  });
  def_drop_side_effect_free(AST_ObjectSetter, function() {
    return this.computed_key() ? this.key : null;
  });
  def_drop_side_effect_free(AST_Array, function(compressor, first_in_statement2) {
    var values3 = trim(this.elements, compressor, first_in_statement2);
    return values3 && make_sequence(this, values3);
  });
  def_drop_side_effect_free(AST_Dot, function(compressor, first_in_statement2) {
    if (is_nullish_shortcircuited(this, compressor)) {
      return this.expression.drop_side_effect_free(compressor, first_in_statement2);
    }
    if (!this.optional && this.expression.may_throw_on_access(compressor)) {
      return this;
    }
    return this.expression.drop_side_effect_free(compressor, first_in_statement2);
  });
  def_drop_side_effect_free(AST_Sub, function(compressor, first_in_statement2) {
    if (is_nullish_shortcircuited(this, compressor)) {
      return this.expression.drop_side_effect_free(compressor, first_in_statement2);
    }
    if (!this.optional && this.expression.may_throw_on_access(compressor)) {
      return this;
    }
    var property = this.property.drop_side_effect_free(compressor);
    if (property && this.optional)
      return this;
    var expression = this.expression.drop_side_effect_free(compressor, first_in_statement2);
    if (expression && property)
      return make_sequence(this, [expression, property]);
    return expression || property;
  });
  def_drop_side_effect_free(AST_Chain, function(compressor, first_in_statement2) {
    return this.expression.drop_side_effect_free(compressor, first_in_statement2);
  });
  def_drop_side_effect_free(AST_Sequence, function(compressor) {
    var last = this.tail_node();
    var expr = last.drop_side_effect_free(compressor);
    if (expr === last)
      return this;
    var expressions = this.expressions.slice(0, -1);
    if (expr)
      expressions.push(expr);
    if (!expressions.length) {
      return make_node(AST_Number, this, { value: 0 });
    }
    return make_sequence(this, expressions);
  });
  def_drop_side_effect_free(AST_Expansion, function(compressor, first_in_statement2) {
    return this.expression.drop_side_effect_free(compressor, first_in_statement2);
  });
  def_drop_side_effect_free(AST_TemplateSegment, return_null);
  def_drop_side_effect_free(AST_TemplateString, function(compressor) {
    var values3 = trim(this.segments, compressor, first_in_statement);
    return values3 && make_sequence(this, values3);
  });
});
var r_keep_assign;
var init_drop_unused = __esm2(() => {
  init_ast();
  init_utils5();
  init_scope();
  init_compressor_flags();
  init_common();
  init_inference();
  r_keep_assign = /keep_assign/;
  AST_Scope.DEFMETHOD("drop_unused", function(compressor) {
    if (!compressor.option("unused"))
      return;
    if (compressor.has_directive("use asm"))
      return;
    if (!this.variables)
      return;
    var self2 = this;
    if (self2.pinned())
      return;
    var drop_funcs = !(self2 instanceof AST_Toplevel) || compressor.toplevel.funcs;
    var drop_vars = !(self2 instanceof AST_Toplevel) || compressor.toplevel.vars;
    const assign_as_unused = r_keep_assign.test(compressor.option("unused")) ? return_false : function(node) {
      if (node instanceof AST_Assign && !node.logical && (has_flag(node, WRITE_ONLY) || node.operator == "=")) {
        return node.left;
      }
      if (node instanceof AST_Unary && has_flag(node, WRITE_ONLY)) {
        return node.expression;
      }
    };
    var in_use_ids = new Map;
    var fixed_ids = new Map;
    if (self2 instanceof AST_Toplevel && compressor.top_retain) {
      self2.variables.forEach(function(def) {
        if (compressor.top_retain(def)) {
          in_use_ids.set(def.id, def);
        }
      });
    }
    var var_defs_by_id = new Map;
    var initializations = new Map;
    var scope = this;
    var tw = new TreeWalker(function(node, descend) {
      if (node instanceof AST_Lambda && node.uses_arguments && !tw.has_directive("use strict")) {
        node.argnames.forEach(function(argname) {
          if (!(argname instanceof AST_SymbolDeclaration))
            return;
          var def = argname.definition();
          in_use_ids.set(def.id, def);
        });
      }
      if (node === self2)
        return;
      if (node instanceof AST_Class && node.has_side_effects(compressor)) {
        if (node.is_self_referential()) {
          descend();
        } else {
          node.visit_nondeferred_class_parts(tw);
        }
      }
      if (node instanceof AST_Defun || node instanceof AST_DefClass) {
        var node_def = node.name.definition();
        const in_export = tw.parent() instanceof AST_Export;
        if (in_export || !drop_funcs && scope === self2) {
          if (node_def.global) {
            in_use_ids.set(node_def.id, node_def);
          }
        }
        map_add(initializations, node_def.id, node);
        return true;
      }
      const in_root_scope = scope === self2;
      if (node instanceof AST_SymbolFunarg && in_root_scope) {
        map_add(var_defs_by_id, node.definition().id, node);
      }
      if (node instanceof AST_Definitions && in_root_scope) {
        const in_export = tw.parent() instanceof AST_Export;
        node.definitions.forEach(function(def) {
          if (def.name instanceof AST_SymbolVar) {
            map_add(var_defs_by_id, def.name.definition().id, def);
          }
          if (in_export || !drop_vars) {
            walk2(def.name, (node2) => {
              if (node2 instanceof AST_SymbolDeclaration) {
                const def2 = node2.definition();
                if (def2.global) {
                  in_use_ids.set(def2.id, def2);
                }
              }
            });
          }
          if (def.name instanceof AST_Destructuring) {
            def.walk(tw);
          }
          if (def.name instanceof AST_SymbolDeclaration && def.value) {
            var node_def2 = def.name.definition();
            map_add(initializations, node_def2.id, def.value);
            if (!node_def2.chained && def.name.fixed_value() === def.value) {
              fixed_ids.set(node_def2.id, def);
            }
            if (def.value.has_side_effects(compressor)) {
              def.value.walk(tw);
            }
          }
        });
        return true;
      }
      return scan_ref_scoped(node, descend);
    });
    self2.walk(tw);
    tw = new TreeWalker(scan_ref_scoped);
    in_use_ids.forEach(function(def) {
      var init3 = initializations.get(def.id);
      if (init3)
        init3.forEach(function(init4) {
          init4.walk(tw);
        });
    });
    var tt = new TreeTransformer(function before(node, descend, in_list) {
      var parent = tt.parent();
      if (drop_vars) {
        const sym2 = assign_as_unused(node);
        if (sym2 instanceof AST_SymbolRef) {
          var def = sym2.definition();
          var in_use = in_use_ids.has(def.id);
          if (node instanceof AST_Assign) {
            if (!in_use || fixed_ids.has(def.id) && fixed_ids.get(def.id) !== node) {
              const assignee = node.right.transform(tt);
              if (!in_use && !assignee.has_side_effects(compressor) && !is_used_in_expression(tt)) {
                return in_list ? MAP.skip : make_node(AST_Number, node, { value: 0 });
              }
              return maintain_this_binding(parent, node, assignee);
            }
          } else if (!in_use) {
            return in_list ? MAP.skip : make_node(AST_Number, node, { value: 0 });
          }
        }
      }
      if (scope !== self2)
        return;
      var def;
      if (node.name && (node instanceof AST_ClassExpression && !keep_name(compressor.option("keep_classnames"), (def = node.name.definition()).name) || node instanceof AST_Function && !keep_name(compressor.option("keep_fnames"), (def = node.name.definition()).name))) {
        if (!in_use_ids.has(def.id) || def.orig.length > 1)
          node.name = null;
      }
      if (node instanceof AST_Lambda && !(node instanceof AST_Accessor)) {
        var trim2 = !compressor.option("keep_fargs") || parent instanceof AST_Call && parent.expression === node && !node.pinned() && (!node.name || node.name.unreferenced());
        for (var a = node.argnames, i2 = a.length;--i2 >= 0; ) {
          var sym = a[i2];
          if (sym instanceof AST_Expansion) {
            sym = sym.expression;
          }
          if (sym instanceof AST_DefaultAssign) {
            sym = sym.left;
          }
          if (!(sym instanceof AST_Destructuring) && !in_use_ids.has(sym.definition().id)) {
            set_flag(sym, UNUSED);
            if (trim2) {
              a.pop();
            }
          } else {
            trim2 = false;
          }
        }
      }
      if (node instanceof AST_DefClass && node !== self2) {
        const def2 = node.name.definition();
        descend(node, this);
        const keep_class = def2.global && !drop_funcs || in_use_ids.has(def2.id);
        if (!keep_class) {
          const kept = node.drop_side_effect_free(compressor);
          if (kept == null) {
            def2.eliminated++;
            return in_list ? MAP.skip : make_node(AST_EmptyStatement, node);
          }
          return kept;
        }
        return node;
      }
      if (node instanceof AST_Defun && node !== self2) {
        const def2 = node.name.definition();
        const keep = def2.global && !drop_funcs || in_use_ids.has(def2.id);
        if (!keep) {
          def2.eliminated++;
          return in_list ? MAP.skip : make_node(AST_EmptyStatement, node);
        }
      }
      if (node instanceof AST_Definitions && !(parent instanceof AST_ForIn && parent.init === node)) {
        var drop_block = !(parent instanceof AST_Toplevel) && !(node instanceof AST_Var);
        var body = [], head2 = [], tail = [];
        var side_effects = [];
        node.definitions.forEach(function(def2) {
          if (def2.value)
            def2.value = def2.value.transform(tt);
          var is_destructure = def2.name instanceof AST_Destructuring;
          var sym2 = is_destructure ? new SymbolDef(null, { name: "<destructure>" }) : def2.name.definition();
          if (drop_block && sym2.global)
            return tail.push(def2);
          if (!(drop_vars || drop_block) || is_destructure && (def2.name.names.length || def2.name.is_array || compressor.option("pure_getters") != true) || in_use_ids.has(sym2.id)) {
            if (def2.value && fixed_ids.has(sym2.id) && fixed_ids.get(sym2.id) !== def2) {
              def2.value = def2.value.drop_side_effect_free(compressor);
            }
            if (def2.name instanceof AST_SymbolVar) {
              var var_defs = var_defs_by_id.get(sym2.id);
              if (var_defs.length > 1 && (!def2.value || sym2.orig.indexOf(def2.name) > sym2.eliminated)) {
                if (def2.value) {
                  var ref2 = make_node(AST_SymbolRef, def2.name, def2.name);
                  sym2.references.push(ref2);
                  var assign = make_node(AST_Assign, def2, {
                    operator: "=",
                    logical: false,
                    left: ref2,
                    right: def2.value
                  });
                  if (fixed_ids.get(sym2.id) === def2) {
                    fixed_ids.set(sym2.id, assign);
                  }
                  side_effects.push(assign.transform(tt));
                }
                remove(var_defs, def2);
                sym2.eliminated++;
                return;
              }
            }
            if (def2.value) {
              if (side_effects.length > 0) {
                if (tail.length > 0) {
                  side_effects.push(def2.value);
                  def2.value = make_sequence(def2.value, side_effects);
                } else {
                  body.push(make_node(AST_SimpleStatement, node, {
                    body: make_sequence(node, side_effects)
                  }));
                }
                side_effects = [];
              }
              tail.push(def2);
            } else {
              head2.push(def2);
            }
          } else if (sym2.orig[0] instanceof AST_SymbolCatch) {
            var value = def2.value && def2.value.drop_side_effect_free(compressor);
            if (value)
              side_effects.push(value);
            def2.value = null;
            head2.push(def2);
          } else {
            var value = def2.value && def2.value.drop_side_effect_free(compressor);
            if (value) {
              side_effects.push(value);
            }
            sym2.eliminated++;
          }
        });
        if (head2.length > 0 || tail.length > 0) {
          node.definitions = head2.concat(tail);
          body.push(node);
        }
        if (side_effects.length > 0) {
          body.push(make_node(AST_SimpleStatement, node, {
            body: make_sequence(node, side_effects)
          }));
        }
        switch (body.length) {
          case 0:
            return in_list ? MAP.skip : make_node(AST_EmptyStatement, node);
          case 1:
            return body[0];
          default:
            return in_list ? MAP.splice(body) : make_node(AST_BlockStatement, node, { body });
        }
      }
      if (node instanceof AST_For) {
        descend(node, this);
        var block;
        if (node.init instanceof AST_BlockStatement) {
          block = node.init;
          node.init = block.body.pop();
          block.body.push(node);
        }
        if (node.init instanceof AST_SimpleStatement) {
          node.init = node.init.body;
        } else if (is_empty(node.init)) {
          node.init = null;
        }
        return !block ? node : in_list ? MAP.splice(block.body) : block;
      }
      if (node instanceof AST_LabeledStatement && node.body instanceof AST_For) {
        descend(node, this);
        if (node.body instanceof AST_BlockStatement) {
          var block = node.body;
          node.body = block.body.pop();
          block.body.push(node);
          return in_list ? MAP.splice(block.body) : block;
        }
        return node;
      }
      if (node instanceof AST_BlockStatement) {
        descend(node, this);
        if (in_list && node.body.every(can_be_evicted_from_block)) {
          return MAP.splice(node.body);
        }
        return node;
      }
      if (node instanceof AST_Scope && !(node instanceof AST_ClassStaticBlock)) {
        const save_scope = scope;
        scope = node;
        descend(node, this);
        scope = save_scope;
        return node;
      }
    }, function after(node, in_list) {
      if (node instanceof AST_Sequence) {
        switch (node.expressions.length) {
          case 0:
            return in_list ? MAP.skip : make_node(AST_Number, node, { value: 0 });
          case 1:
            return node.expressions[0];
        }
      }
    });
    self2.transform(tt);
    function scan_ref_scoped(node, descend) {
      var node_def;
      const sym = assign_as_unused(node);
      if (sym instanceof AST_SymbolRef && !is_ref_of(node.left, AST_SymbolBlockDeclaration) && self2.variables.get(sym.name) === (node_def = sym.definition())) {
        if (node instanceof AST_Assign) {
          node.right.walk(tw);
          if (!node_def.chained && node.left.fixed_value() === node.right) {
            fixed_ids.set(node_def.id, node);
          }
        }
        return true;
      }
      if (node instanceof AST_SymbolRef) {
        node_def = node.definition();
        if (!in_use_ids.has(node_def.id)) {
          in_use_ids.set(node_def.id, node_def);
          if (node_def.orig[0] instanceof AST_SymbolCatch) {
            const redef = node_def.scope.is_block_scope() && node_def.scope.get_defun_scope().variables.get(node_def.name);
            if (redef)
              in_use_ids.set(redef.id, redef);
          }
        }
        return true;
      }
      if (node instanceof AST_Class) {
        descend();
        return true;
      }
      if (node instanceof AST_Scope && !(node instanceof AST_ClassStaticBlock)) {
        var save_scope = scope;
        scope = node;
        descend();
        scope = save_scope;
        return true;
      }
    }
  });
});
function def_reduce_vars(node, func) {
  node.DEFMETHOD("reduce_vars", func);
}
function reset_def(compressor, def) {
  def.assignments = 0;
  def.chained = false;
  def.direct_access = false;
  def.escaped = 0;
  def.recursive_refs = 0;
  def.references = [];
  def.single_use = undefined;
  if (def.scope.pinned() || def.orig[0] instanceof AST_SymbolFunarg && def.scope.uses_arguments) {
    def.fixed = false;
  } else if (def.orig[0] instanceof AST_SymbolConst || !compressor.exposed(def)) {
    def.fixed = def.init;
  } else {
    def.fixed = false;
  }
}
function reset_variables(tw, compressor, node) {
  node.variables.forEach(function(def) {
    reset_def(compressor, def);
    if (def.fixed === null) {
      tw.defs_to_safe_ids.set(def.id, tw.safe_ids);
      mark(tw, def, true);
    } else if (def.fixed) {
      tw.loop_ids.set(def.id, tw.in_loop);
      mark(tw, def, true);
    }
  });
}
function reset_block_variables(compressor, node) {
  if (node.block_scope)
    node.block_scope.variables.forEach((def) => {
      reset_def(compressor, def);
    });
}
function push2(tw) {
  tw.safe_ids = Object.create(tw.safe_ids);
}
function pop(tw) {
  tw.safe_ids = Object.getPrototypeOf(tw.safe_ids);
}
function mark(tw, def, safe) {
  tw.safe_ids[def.id] = safe;
}
function safe_to_read(tw, def) {
  if (def.single_use == "m")
    return false;
  if (tw.safe_ids[def.id]) {
    if (def.fixed == null) {
      var orig = def.orig[0];
      if (orig instanceof AST_SymbolFunarg || orig.name == "arguments")
        return false;
      def.fixed = make_node(AST_Undefined, orig);
    }
    return true;
  }
  return def.fixed instanceof AST_Defun;
}
function safe_to_assign(tw, def, scope, value) {
  if (def.fixed === undefined)
    return true;
  let def_safe_ids;
  if (def.fixed === null && (def_safe_ids = tw.defs_to_safe_ids.get(def.id))) {
    def_safe_ids[def.id] = false;
    tw.defs_to_safe_ids.delete(def.id);
    return true;
  }
  if (!HOP(tw.safe_ids, def.id))
    return false;
  if (!safe_to_read(tw, def))
    return false;
  if (def.fixed === false)
    return false;
  if (def.fixed != null && (!value || def.references.length > def.assignments))
    return false;
  if (def.fixed instanceof AST_Defun) {
    return value instanceof AST_Node && def.fixed.parent_scope === scope;
  }
  return def.orig.every((sym) => {
    return !(sym instanceof AST_SymbolConst || sym instanceof AST_SymbolDefun || sym instanceof AST_SymbolLambda);
  });
}
function ref_once(tw, compressor, def) {
  return compressor.option("unused") && !def.scope.pinned() && def.references.length - def.recursive_refs == 1 && tw.loop_ids.get(def.id) === tw.in_loop;
}
function is_immutable(value) {
  if (!value)
    return false;
  return value.is_constant() || value instanceof AST_Lambda || value instanceof AST_This;
}
function mark_escaped(tw, d, scope, node, value, level = 0, depth2 = 1) {
  var parent = tw.parent(level);
  if (value) {
    if (value.is_constant())
      return;
    if (value instanceof AST_ClassExpression)
      return;
  }
  if (parent instanceof AST_Assign && (parent.operator === "=" || parent.logical) && node === parent.right || parent instanceof AST_Call && (node !== parent.expression || parent instanceof AST_New) || parent instanceof AST_Exit && node === parent.value && node.scope !== d.scope || parent instanceof AST_VarDef && node === parent.value || parent instanceof AST_Yield && node === parent.value && node.scope !== d.scope) {
    if (depth2 > 1 && !(value && value.is_constant_expression(scope)))
      depth2 = 1;
    if (!d.escaped || d.escaped > depth2)
      d.escaped = depth2;
    return;
  } else if (parent instanceof AST_Array || parent instanceof AST_Await || parent instanceof AST_Binary && lazy_op.has(parent.operator) || parent instanceof AST_Conditional && node !== parent.condition || parent instanceof AST_Expansion || parent instanceof AST_Sequence && node === parent.tail_node()) {
    mark_escaped(tw, d, scope, parent, parent, level + 1, depth2);
  } else if (parent instanceof AST_ObjectKeyVal && node === parent.value) {
    var obj = tw.parent(level + 1);
    mark_escaped(tw, d, scope, obj, obj, level + 2, depth2);
  } else if (parent instanceof AST_PropAccess && node === parent.expression) {
    value = read_property(value, parent.property);
    mark_escaped(tw, d, scope, parent, value, level + 1, depth2 + 1);
    if (value)
      return;
  }
  if (level > 0)
    return;
  if (parent instanceof AST_Sequence && node !== parent.tail_node())
    return;
  if (parent instanceof AST_SimpleStatement)
    return;
  d.direct_access = true;
}
function mark_lambda(tw, descend, compressor) {
  clear_flag(this, INLINED);
  push2(tw);
  reset_variables(tw, compressor, this);
  var iife;
  if (!this.name && !this.uses_arguments && !this.pinned() && (iife = tw.parent()) instanceof AST_Call && iife.expression === this && !iife.args.some((arg) => arg instanceof AST_Expansion) && this.argnames.every((arg_name) => arg_name instanceof AST_Symbol)) {
    this.argnames.forEach((arg, i2) => {
      if (!arg.definition)
        return;
      var d = arg.definition();
      if (d.orig.length > 1)
        return;
      if (d.fixed === undefined && (!this.uses_arguments || tw.has_directive("use strict"))) {
        d.fixed = function() {
          return iife.args[i2] || make_node(AST_Undefined, iife);
        };
        tw.loop_ids.set(d.id, tw.in_loop);
        mark(tw, d, true);
      } else {
        d.fixed = false;
      }
    });
  }
  descend();
  pop(tw);
  handle_defined_after_hoist(this);
  return true;
}
function handle_defined_after_hoist(parent) {
  const defuns = [];
  walk2(parent, (node) => {
    if (node === parent)
      return;
    if (node instanceof AST_Defun) {
      defuns.push(node);
      return true;
    }
    if (node instanceof AST_Scope || node instanceof AST_SimpleStatement)
      return true;
  });
  const defun_dependencies_map = new Map;
  const dependencies_map = new Map;
  const symbols_of_interest = new Set;
  const defuns_of_interest = new Set;
  for (const defun of defuns) {
    const fname_def = defun.name.definition();
    const enclosing_defs = [];
    for (const def of defun.enclosed) {
      if (def.fixed === false || def === fname_def || def.scope.get_defun_scope() !== parent) {
        continue;
      }
      symbols_of_interest.add(def.id);
      if (def.assignments === 0 && def.orig.length === 1 && def.orig[0] instanceof AST_SymbolDefun) {
        defuns_of_interest.add(def.id);
        symbols_of_interest.add(def.id);
        defuns_of_interest.add(fname_def.id);
        symbols_of_interest.add(fname_def.id);
        if (!defun_dependencies_map.has(fname_def.id)) {
          defun_dependencies_map.set(fname_def.id, []);
        }
        defun_dependencies_map.get(fname_def.id).push(def.id);
        continue;
      }
      enclosing_defs.push(def);
    }
    if (enclosing_defs.length) {
      dependencies_map.set(fname_def.id, enclosing_defs);
      defuns_of_interest.add(fname_def.id);
      symbols_of_interest.add(fname_def.id);
    }
  }
  if (!dependencies_map.size) {
    return;
  }
  let symbol_index = 1;
  const defun_first_read_map = new Map;
  const symbol_last_write_map = new Map;
  walk_parent(parent, (node, walk_info) => {
    if (node instanceof AST_Symbol && node.thedef) {
      const id = node.definition().id;
      symbol_index++;
      if (symbols_of_interest.has(id)) {
        if (node instanceof AST_SymbolDeclaration || is_lhs(node, walk_info.parent())) {
          symbol_last_write_map.set(id, symbol_index);
        }
      }
      if (defuns_of_interest.has(id)) {
        if (!defun_first_read_map.has(id) && !is_recursive_ref(walk_info, id)) {
          defun_first_read_map.set(id, symbol_index);
        }
      }
    }
  });
  for (const [defun, defun_first_read] of defun_first_read_map) {
    const queue4 = new Set(defun_dependencies_map.get(defun));
    for (const enclosed_defun of queue4) {
      let enclosed_defun_first_read = defun_first_read_map.get(enclosed_defun);
      if (enclosed_defun_first_read != null && enclosed_defun_first_read < defun_first_read) {
        continue;
      }
      defun_first_read_map.set(enclosed_defun, defun_first_read);
      for (const enclosed_enclosed_defun of defun_dependencies_map.get(enclosed_defun) || []) {
        queue4.add(enclosed_enclosed_defun);
      }
    }
  }
  for (const [defun, defs] of dependencies_map) {
    const defun_first_read = defun_first_read_map.get(defun);
    if (defun_first_read === undefined) {
      continue;
    }
    for (const def of defs) {
      if (def.fixed === false) {
        continue;
      }
      let def_last_write = symbol_last_write_map.get(def.id) || 0;
      if (defun_first_read < def_last_write) {
        def.fixed = false;
      }
    }
  }
}
var suppress = (node) => walk2(node, (node2) => {
  if (!(node2 instanceof AST_Symbol))
    return;
  var d = node2.definition();
  if (!d)
    return;
  if (node2 instanceof AST_SymbolRef)
    d.references.push(node2);
  d.fixed = false;
});
var init_reduce_vars = __esm2(() => {
  init_ast();
  init_utils5();
  init_inference();
  init_compressor_flags();
  init_common();
  def_reduce_vars(AST_Node, noop);
  def_reduce_vars(AST_Accessor, function(tw, descend, compressor) {
    push2(tw);
    reset_variables(tw, compressor, this);
    descend();
    pop(tw);
    return true;
  });
  def_reduce_vars(AST_Assign, function(tw, descend, compressor) {
    var node = this;
    if (node.left instanceof AST_Destructuring) {
      suppress(node.left);
      return;
    }
    const finish_walk = () => {
      if (node.logical) {
        node.left.walk(tw);
        push2(tw);
        node.right.walk(tw);
        pop(tw);
        return true;
      }
    };
    var sym = node.left;
    if (!(sym instanceof AST_SymbolRef))
      return finish_walk();
    var def = sym.definition();
    var safe = safe_to_assign(tw, def, sym.scope, node.right);
    def.assignments++;
    if (!safe)
      return finish_walk();
    var fixed = def.fixed;
    if (!fixed && node.operator != "=" && !node.logical)
      return finish_walk();
    var eq = node.operator == "=";
    var value = eq ? node.right : node;
    if (is_modified(compressor, tw, node, value, 0))
      return finish_walk();
    def.references.push(sym);
    if (!node.logical) {
      if (!eq)
        def.chained = true;
      def.fixed = eq ? function() {
        return node.right;
      } : function() {
        return make_node(AST_Binary, node, {
          operator: node.operator.slice(0, -1),
          left: fixed instanceof AST_Node ? fixed : fixed(),
          right: node.right
        });
      };
    }
    if (node.logical) {
      mark(tw, def, false);
      push2(tw);
      node.right.walk(tw);
      pop(tw);
      return true;
    }
    mark(tw, def, false);
    node.right.walk(tw);
    mark(tw, def, true);
    mark_escaped(tw, def, sym.scope, node, value, 0, 1);
    return true;
  });
  def_reduce_vars(AST_Binary, function(tw) {
    if (!lazy_op.has(this.operator))
      return;
    this.left.walk(tw);
    push2(tw);
    this.right.walk(tw);
    pop(tw);
    return true;
  });
  def_reduce_vars(AST_Block, function(tw, descend, compressor) {
    reset_block_variables(compressor, this);
  });
  def_reduce_vars(AST_Case, function(tw) {
    push2(tw);
    this.expression.walk(tw);
    pop(tw);
    push2(tw);
    walk_body(this, tw);
    pop(tw);
    return true;
  });
  def_reduce_vars(AST_Class, function(tw, descend) {
    clear_flag(this, INLINED);
    push2(tw);
    descend();
    pop(tw);
    return true;
  });
  def_reduce_vars(AST_ClassStaticBlock, function(tw, descend, compressor) {
    reset_block_variables(compressor, this);
  });
  def_reduce_vars(AST_Conditional, function(tw) {
    this.condition.walk(tw);
    push2(tw);
    this.consequent.walk(tw);
    pop(tw);
    push2(tw);
    this.alternative.walk(tw);
    pop(tw);
    return true;
  });
  def_reduce_vars(AST_Chain, function(tw, descend) {
    const safe_ids = tw.safe_ids;
    descend();
    tw.safe_ids = safe_ids;
    return true;
  });
  def_reduce_vars(AST_Call, function(tw) {
    this.expression.walk(tw);
    if (this.optional) {
      push2(tw);
    }
    for (const arg of this.args)
      arg.walk(tw);
    return true;
  });
  def_reduce_vars(AST_PropAccess, function(tw) {
    if (!this.optional)
      return;
    this.expression.walk(tw);
    push2(tw);
    if (this.property instanceof AST_Node)
      this.property.walk(tw);
    return true;
  });
  def_reduce_vars(AST_Default, function(tw, descend) {
    push2(tw);
    descend();
    pop(tw);
    return true;
  });
  def_reduce_vars(AST_Lambda, mark_lambda);
  def_reduce_vars(AST_Do, function(tw, descend, compressor) {
    reset_block_variables(compressor, this);
    const saved_loop = tw.in_loop;
    tw.in_loop = this;
    push2(tw);
    this.body.walk(tw);
    if (has_break_or_continue(this)) {
      pop(tw);
      push2(tw);
    }
    this.condition.walk(tw);
    pop(tw);
    tw.in_loop = saved_loop;
    return true;
  });
  def_reduce_vars(AST_For, function(tw, descend, compressor) {
    reset_block_variables(compressor, this);
    if (this.init)
      this.init.walk(tw);
    const saved_loop = tw.in_loop;
    tw.in_loop = this;
    push2(tw);
    if (this.condition)
      this.condition.walk(tw);
    this.body.walk(tw);
    if (this.step) {
      if (has_break_or_continue(this)) {
        pop(tw);
        push2(tw);
      }
      this.step.walk(tw);
    }
    pop(tw);
    tw.in_loop = saved_loop;
    return true;
  });
  def_reduce_vars(AST_ForIn, function(tw, descend, compressor) {
    reset_block_variables(compressor, this);
    suppress(this.init);
    this.object.walk(tw);
    const saved_loop = tw.in_loop;
    tw.in_loop = this;
    push2(tw);
    this.body.walk(tw);
    pop(tw);
    tw.in_loop = saved_loop;
    return true;
  });
  def_reduce_vars(AST_If, function(tw) {
    this.condition.walk(tw);
    push2(tw);
    this.body.walk(tw);
    pop(tw);
    if (this.alternative) {
      push2(tw);
      this.alternative.walk(tw);
      pop(tw);
    }
    return true;
  });
  def_reduce_vars(AST_LabeledStatement, function(tw) {
    push2(tw);
    this.body.walk(tw);
    pop(tw);
    return true;
  });
  def_reduce_vars(AST_SymbolCatch, function() {
    this.definition().fixed = false;
  });
  def_reduce_vars(AST_SymbolRef, function(tw, descend, compressor) {
    var d = this.definition();
    d.references.push(this);
    if (d.references.length == 1 && !d.fixed && d.orig[0] instanceof AST_SymbolDefun) {
      tw.loop_ids.set(d.id, tw.in_loop);
    }
    var fixed_value;
    if (d.fixed === undefined || !safe_to_read(tw, d)) {
      d.fixed = false;
    } else if (d.fixed) {
      fixed_value = this.fixed_value();
      if (fixed_value instanceof AST_Lambda && is_recursive_ref(tw, d)) {
        d.recursive_refs++;
      } else if (fixed_value && !compressor.exposed(d) && ref_once(tw, compressor, d)) {
        d.single_use = fixed_value instanceof AST_Lambda && !fixed_value.pinned() || fixed_value instanceof AST_Class || d.scope === this.scope && fixed_value.is_constant_expression();
      } else {
        d.single_use = false;
      }
      if (is_modified(compressor, tw, this, fixed_value, 0, is_immutable(fixed_value))) {
        if (d.single_use) {
          d.single_use = "m";
        } else {
          d.fixed = false;
        }
      }
    }
    mark_escaped(tw, d, this.scope, this, fixed_value, 0, 1);
  });
  def_reduce_vars(AST_Toplevel, function(tw, descend, compressor) {
    this.globals.forEach(function(def) {
      reset_def(compressor, def);
    });
    reset_variables(tw, compressor, this);
    descend();
    handle_defined_after_hoist(this);
    return true;
  });
  def_reduce_vars(AST_Try, function(tw, descend, compressor) {
    reset_block_variables(compressor, this);
    push2(tw);
    this.body.walk(tw);
    pop(tw);
    if (this.bcatch) {
      push2(tw);
      this.bcatch.walk(tw);
      pop(tw);
    }
    if (this.bfinally)
      this.bfinally.walk(tw);
    return true;
  });
  def_reduce_vars(AST_Unary, function(tw) {
    var node = this;
    if (node.operator !== "++" && node.operator !== "--")
      return;
    var exp = node.expression;
    if (!(exp instanceof AST_SymbolRef))
      return;
    var def = exp.definition();
    var safe = safe_to_assign(tw, def, exp.scope, true);
    def.assignments++;
    if (!safe)
      return;
    var fixed = def.fixed;
    if (!fixed)
      return;
    def.references.push(exp);
    def.chained = true;
    def.fixed = function() {
      return make_node(AST_Binary, node, {
        operator: node.operator.slice(0, -1),
        left: make_node(AST_UnaryPrefix, node, {
          operator: "+",
          expression: fixed instanceof AST_Node ? fixed : fixed()
        }),
        right: make_node(AST_Number, node, {
          value: 1
        })
      });
    };
    mark(tw, def, true);
    return true;
  });
  def_reduce_vars(AST_VarDef, function(tw, descend) {
    var node = this;
    if (node.name instanceof AST_Destructuring) {
      suppress(node.name);
      return;
    }
    var d = node.name.definition();
    if (node.value) {
      if (safe_to_assign(tw, d, node.name.scope, node.value)) {
        d.fixed = function() {
          return node.value;
        };
        tw.loop_ids.set(d.id, tw.in_loop);
        mark(tw, d, false);
        descend();
        mark(tw, d, true);
        return true;
      } else {
        d.fixed = false;
      }
    }
  });
  def_reduce_vars(AST_While, function(tw, descend, compressor) {
    reset_block_variables(compressor, this);
    const saved_loop = tw.in_loop;
    tw.in_loop = this;
    push2(tw);
    descend();
    pop(tw);
    tw.in_loop = saved_loop;
    return true;
  });
});
function loop_body(x) {
  if (x instanceof AST_IterationStatement) {
    return x.body instanceof AST_BlockStatement ? x.body : x;
  }
  return x;
}
function is_lhs_read_only(lhs) {
  if (lhs instanceof AST_This)
    return true;
  if (lhs instanceof AST_SymbolRef)
    return lhs.definition().orig[0] instanceof AST_SymbolLambda;
  if (lhs instanceof AST_PropAccess) {
    lhs = lhs.expression;
    if (lhs instanceof AST_SymbolRef) {
      if (lhs.is_immutable())
        return false;
      lhs = lhs.fixed_value();
    }
    if (!lhs)
      return true;
    if (lhs instanceof AST_RegExp)
      return false;
    if (lhs instanceof AST_Constant)
      return true;
    return is_lhs_read_only(lhs);
  }
  return false;
}
function remove_initializers(var_statement) {
  var decls = [];
  var_statement.definitions.forEach(function(def) {
    if (def.name instanceof AST_SymbolDeclaration) {
      def.value = null;
      decls.push(def);
    } else {
      def.declarations_as_names().forEach((name) => {
        decls.push(make_node(AST_VarDef, def, {
          name,
          value: null
        }));
      });
    }
  });
  return decls.length ? make_node(AST_Var, var_statement, { definitions: decls }) : null;
}
function trim_unreachable_code(compressor, stat22, target) {
  walk2(stat22, (node) => {
    if (node instanceof AST_Var) {
      const no_initializers = remove_initializers(node);
      if (no_initializers)
        target.push(no_initializers);
      return true;
    }
    if (node instanceof AST_Defun && (node === stat22 || !compressor.has_directive("use strict"))) {
      target.push(node === stat22 ? node : make_node(AST_Var, node, {
        definitions: [
          make_node(AST_VarDef, node, {
            name: make_node(AST_SymbolVar, node.name, node.name),
            value: null
          })
        ]
      }));
      return true;
    }
    if (node instanceof AST_Export || node instanceof AST_Import) {
      target.push(node);
      return true;
    }
    if (node instanceof AST_Scope) {
      return true;
    }
  });
}
function tighten_body(statements, compressor) {
  const nearest_scope = compressor.find_scope();
  const defun_scope = nearest_scope.get_defun_scope();
  const { in_loop, in_try } = find_loop_scope_try();
  var CHANGED, max_iter = 10;
  do {
    CHANGED = false;
    eliminate_spurious_blocks(statements);
    if (compressor.option("dead_code")) {
      eliminate_dead_code(statements, compressor);
    }
    if (compressor.option("if_return")) {
      handle_if_return(statements, compressor);
    }
    if (compressor.sequences_limit > 0) {
      sequencesize(statements, compressor);
      sequencesize_2(statements, compressor);
    }
    if (compressor.option("join_vars")) {
      join_consecutive_vars(statements);
    }
    if (compressor.option("collapse_vars")) {
      collapse(statements, compressor);
    }
  } while (CHANGED && max_iter-- > 0);
  function find_loop_scope_try() {
    var node = compressor.self(), level = 0, in_loop2 = false, in_try2 = false;
    do {
      if (node instanceof AST_IterationStatement) {
        in_loop2 = true;
      } else if (node instanceof AST_Scope) {
        break;
      } else if (node instanceof AST_TryBlock) {
        in_try2 = true;
      }
    } while (node = compressor.parent(level++));
    return { in_loop: in_loop2, in_try: in_try2 };
  }
  function collapse(statements2, compressor2) {
    if (nearest_scope.pinned() || defun_scope.pinned())
      return statements2;
    var args;
    var candidates = [];
    var stat_index = statements2.length;
    var scanner = new TreeTransformer(function(node) {
      if (abort)
        return node;
      if (!hit) {
        if (node !== hit_stack[hit_index])
          return node;
        hit_index++;
        if (hit_index < hit_stack.length)
          return handle_custom_scan_order(node);
        hit = true;
        stop_after = find_stop(node, 0);
        if (stop_after === node)
          abort = true;
        return node;
      }
      var parent = scanner.parent();
      if (node instanceof AST_Assign && (node.logical || node.operator != "=" && lhs.equivalent_to(node.left)) || node instanceof AST_Await || node instanceof AST_Call && lhs instanceof AST_PropAccess && lhs.equivalent_to(node.expression) || (node instanceof AST_Call || node instanceof AST_PropAccess) && node.optional || node instanceof AST_Debugger || node instanceof AST_Destructuring || node instanceof AST_Expansion && node.expression instanceof AST_Symbol && (node.expression instanceof AST_This || node.expression.definition().references.length > 1) || node instanceof AST_IterationStatement && !(node instanceof AST_For) || node instanceof AST_LoopControl || node instanceof AST_Try || node instanceof AST_With || node instanceof AST_Yield || node instanceof AST_Export || node instanceof AST_Class || parent instanceof AST_For && node !== parent.init || !replace_all && (node instanceof AST_SymbolRef && !node.is_declared(compressor2) && !pure_prop_access_globals.has(node)) || node instanceof AST_SymbolRef && parent instanceof AST_Call && has_annotation(parent, _NOINLINE) || node instanceof AST_ObjectProperty && node.key instanceof AST_Node) {
        abort = true;
        return node;
      }
      if (!stop_if_hit && (!lhs_local || !replace_all) && (parent instanceof AST_Binary && lazy_op.has(parent.operator) && parent.left !== node || parent instanceof AST_Conditional && parent.condition !== node || parent instanceof AST_If && parent.condition !== node)) {
        stop_if_hit = parent;
      }
      if (can_replace && !(node instanceof AST_SymbolDeclaration) && lhs.equivalent_to(node) && !shadows(scanner.find_scope() || nearest_scope, lvalues)) {
        if (stop_if_hit) {
          abort = true;
          return node;
        }
        if (is_lhs(node, parent)) {
          if (value_def)
            replaced++;
          return node;
        } else {
          replaced++;
          if (value_def && candidate instanceof AST_VarDef)
            return node;
        }
        CHANGED = abort = true;
        if (candidate instanceof AST_UnaryPostfix) {
          return make_node(AST_UnaryPrefix, candidate, candidate);
        }
        if (candidate instanceof AST_VarDef) {
          var def2 = candidate.name.definition();
          var value = candidate.value;
          if (def2.references.length - def2.replaced == 1 && !compressor2.exposed(def2)) {
            def2.replaced++;
            if (funarg && is_identifier_atom(value)) {
              return value.transform(compressor2);
            } else {
              return maintain_this_binding(parent, node, value);
            }
          }
          return make_node(AST_Assign, candidate, {
            operator: "=",
            logical: false,
            left: make_node(AST_SymbolRef, candidate.name, candidate.name),
            right: value
          });
        }
        clear_flag(candidate, WRITE_ONLY);
        return candidate;
      }
      var sym;
      if (node instanceof AST_Call || node instanceof AST_Exit && (side_effects || lhs instanceof AST_PropAccess || may_modify(lhs)) || node instanceof AST_PropAccess && (side_effects || node.expression.may_throw_on_access(compressor2)) || node instanceof AST_SymbolRef && (lvalues.has(node.name) && lvalues.get(node.name).modified || side_effects && may_modify(node)) || node instanceof AST_VarDef && node.value && (lvalues.has(node.name.name) || side_effects && may_modify(node.name)) || (sym = is_lhs(node.left, node)) && (sym instanceof AST_PropAccess || lvalues.has(sym.name)) || may_throw && (in_try ? node.has_side_effects(compressor2) : side_effects_external(node))) {
        stop_after = node;
        if (node instanceof AST_Scope)
          abort = true;
      }
      return handle_custom_scan_order(node);
    }, function(node) {
      if (abort)
        return;
      if (stop_after === node)
        abort = true;
      if (stop_if_hit === node)
        stop_if_hit = null;
    });
    var multi_replacer = new TreeTransformer(function(node) {
      if (abort)
        return node;
      if (!hit) {
        if (node !== hit_stack[hit_index])
          return node;
        hit_index++;
        if (hit_index < hit_stack.length)
          return;
        hit = true;
        return node;
      }
      if (node instanceof AST_SymbolRef && node.name == def.name) {
        if (!--replaced)
          abort = true;
        if (is_lhs(node, multi_replacer.parent()))
          return node;
        def.replaced++;
        value_def.replaced--;
        return candidate.value;
      }
      if (node instanceof AST_Default || node instanceof AST_Scope)
        return node;
    });
    while (--stat_index >= 0) {
      if (stat_index == 0 && compressor2.option("unused"))
        extract_args();
      var hit_stack = [];
      extract_candidates(statements2[stat_index]);
      while (candidates.length > 0) {
        hit_stack = candidates.pop();
        var hit_index = 0;
        var candidate = hit_stack[hit_stack.length - 1];
        var value_def = null;
        var stop_after = null;
        var stop_if_hit = null;
        var lhs = get_lhs(candidate);
        if (!lhs || is_lhs_read_only(lhs) || lhs.has_side_effects(compressor2))
          continue;
        var lvalues = get_lvalues(candidate);
        var lhs_local = is_lhs_local(lhs);
        if (lhs instanceof AST_SymbolRef) {
          lvalues.set(lhs.name, { def: lhs.definition(), modified: false });
        }
        var side_effects = value_has_side_effects(candidate);
        var replace_all = replace_all_symbols();
        var may_throw = candidate.may_throw(compressor2);
        var funarg = candidate.name instanceof AST_SymbolFunarg;
        var hit = funarg;
        var abort = false, replaced = 0, can_replace = !args || !hit;
        if (!can_replace) {
          for (let j22 = compressor2.self().argnames.lastIndexOf(candidate.name) + 1;!abort && j22 < args.length; j22++) {
            args[j22].transform(scanner);
          }
          can_replace = true;
        }
        for (var i2 = stat_index;!abort && i2 < statements2.length; i2++) {
          statements2[i2].transform(scanner);
        }
        if (value_def) {
          var def = candidate.name.definition();
          if (abort && def.references.length - def.replaced > replaced)
            replaced = false;
          else {
            abort = false;
            hit_index = 0;
            hit = funarg;
            for (var i2 = stat_index;!abort && i2 < statements2.length; i2++) {
              statements2[i2].transform(multi_replacer);
            }
            value_def.single_use = false;
          }
        }
        if (replaced && !remove_candidate(candidate))
          statements2.splice(stat_index, 1);
      }
    }
    function handle_custom_scan_order(node) {
      if (node instanceof AST_Scope)
        return node;
      if (node instanceof AST_Switch) {
        node.expression = node.expression.transform(scanner);
        for (var i22 = 0, len = node.body.length;!abort && i22 < len; i22++) {
          var branch = node.body[i22];
          if (branch instanceof AST_Case) {
            if (!hit) {
              if (branch !== hit_stack[hit_index])
                continue;
              hit_index++;
            }
            branch.expression = branch.expression.transform(scanner);
            if (!replace_all)
              break;
          }
        }
        abort = true;
        return node;
      }
    }
    function redefined_within_scope(def2, scope) {
      if (def2.global)
        return false;
      let cur_scope = def2.scope;
      while (cur_scope && cur_scope !== scope) {
        if (cur_scope.variables.has(def2.name)) {
          return true;
        }
        cur_scope = cur_scope.parent_scope;
      }
      return false;
    }
    function has_overlapping_symbol(fn, arg, fn_strict) {
      var found = false, scan_this = !(fn instanceof AST_Arrow);
      arg.walk(new TreeWalker(function(node, descend) {
        if (found)
          return true;
        if (node instanceof AST_SymbolRef && (fn.variables.has(node.name) || redefined_within_scope(node.definition(), fn))) {
          var s32 = node.definition().scope;
          if (s32 !== defun_scope)
            while (s32 = s32.parent_scope) {
              if (s32 === defun_scope)
                return true;
            }
          return found = true;
        }
        if ((fn_strict || scan_this) && node instanceof AST_This) {
          return found = true;
        }
        if (node instanceof AST_Scope && !(node instanceof AST_Arrow)) {
          var prev = scan_this;
          scan_this = false;
          descend();
          scan_this = prev;
          return true;
        }
      }));
      return found;
    }
    function arg_is_injectable(arg) {
      if (arg instanceof AST_Expansion)
        return false;
      const contains_await = walk2(arg, (node) => {
        if (node instanceof AST_Await)
          return walk_abort;
      });
      if (contains_await)
        return false;
      return true;
    }
    function extract_args() {
      var iife, fn = compressor2.self();
      if (is_func_expr(fn) && !fn.name && !fn.uses_arguments && !fn.pinned() && (iife = compressor2.parent()) instanceof AST_Call && iife.expression === fn && iife.args.every(arg_is_injectable)) {
        var fn_strict = compressor2.has_directive("use strict");
        if (fn_strict && !member(fn_strict, fn.body))
          fn_strict = false;
        var len = fn.argnames.length;
        args = iife.args.slice(len);
        var names = new Set;
        for (var i22 = len;--i22 >= 0; ) {
          var sym = fn.argnames[i22];
          var arg = iife.args[i22];
          const def2 = sym.definition && sym.definition();
          const is_reassigned = def2 && def2.orig.length > 1;
          if (is_reassigned)
            continue;
          args.unshift(make_node(AST_VarDef, sym, {
            name: sym,
            value: arg
          }));
          if (names.has(sym.name))
            continue;
          names.add(sym.name);
          if (sym instanceof AST_Expansion) {
            var elements = iife.args.slice(i22);
            if (elements.every((arg2) => !has_overlapping_symbol(fn, arg2, fn_strict))) {
              candidates.unshift([make_node(AST_VarDef, sym, {
                name: sym.expression,
                value: make_node(AST_Array, iife, {
                  elements
                })
              })]);
            }
          } else {
            if (!arg) {
              arg = make_node(AST_Undefined, sym).transform(compressor2);
            } else if (arg instanceof AST_Lambda && arg.pinned() || has_overlapping_symbol(fn, arg, fn_strict)) {
              arg = null;
            }
            if (arg)
              candidates.unshift([make_node(AST_VarDef, sym, {
                name: sym,
                value: arg
              })]);
          }
        }
      }
    }
    function extract_candidates(expr) {
      hit_stack.push(expr);
      if (expr instanceof AST_Assign) {
        if (!expr.left.has_side_effects(compressor2) && !(expr.right instanceof AST_Chain)) {
          candidates.push(hit_stack.slice());
        }
        extract_candidates(expr.right);
      } else if (expr instanceof AST_Binary) {
        extract_candidates(expr.left);
        extract_candidates(expr.right);
      } else if (expr instanceof AST_Call && !has_annotation(expr, _NOINLINE)) {
        extract_candidates(expr.expression);
        expr.args.forEach(extract_candidates);
      } else if (expr instanceof AST_Case) {
        extract_candidates(expr.expression);
      } else if (expr instanceof AST_Conditional) {
        extract_candidates(expr.condition);
        extract_candidates(expr.consequent);
        extract_candidates(expr.alternative);
      } else if (expr instanceof AST_Definitions) {
        var len = expr.definitions.length;
        var i22 = len - 200;
        if (i22 < 0)
          i22 = 0;
        for (;i22 < len; i22++) {
          extract_candidates(expr.definitions[i22]);
        }
      } else if (expr instanceof AST_DWLoop) {
        extract_candidates(expr.condition);
        if (!(expr.body instanceof AST_Block)) {
          extract_candidates(expr.body);
        }
      } else if (expr instanceof AST_Exit) {
        if (expr.value)
          extract_candidates(expr.value);
      } else if (expr instanceof AST_For) {
        if (expr.init)
          extract_candidates(expr.init);
        if (expr.condition)
          extract_candidates(expr.condition);
        if (expr.step)
          extract_candidates(expr.step);
        if (!(expr.body instanceof AST_Block)) {
          extract_candidates(expr.body);
        }
      } else if (expr instanceof AST_ForIn) {
        extract_candidates(expr.object);
        if (!(expr.body instanceof AST_Block)) {
          extract_candidates(expr.body);
        }
      } else if (expr instanceof AST_If) {
        extract_candidates(expr.condition);
        if (!(expr.body instanceof AST_Block)) {
          extract_candidates(expr.body);
        }
        if (expr.alternative && !(expr.alternative instanceof AST_Block)) {
          extract_candidates(expr.alternative);
        }
      } else if (expr instanceof AST_Sequence) {
        expr.expressions.forEach(extract_candidates);
      } else if (expr instanceof AST_SimpleStatement) {
        extract_candidates(expr.body);
      } else if (expr instanceof AST_Switch) {
        extract_candidates(expr.expression);
        expr.body.forEach(extract_candidates);
      } else if (expr instanceof AST_Unary) {
        if (expr.operator == "++" || expr.operator == "--") {
          candidates.push(hit_stack.slice());
        }
      } else if (expr instanceof AST_VarDef) {
        if (expr.value && !(expr.value instanceof AST_Chain)) {
          candidates.push(hit_stack.slice());
          extract_candidates(expr.value);
        }
      }
      hit_stack.pop();
    }
    function find_stop(node, level, write_only) {
      var parent = scanner.parent(level);
      if (parent instanceof AST_Assign) {
        if (write_only && !parent.logical && !(parent.left instanceof AST_PropAccess || lvalues.has(parent.left.name))) {
          return find_stop(parent, level + 1, write_only);
        }
        return node;
      }
      if (parent instanceof AST_Binary) {
        if (write_only && (!lazy_op.has(parent.operator) || parent.left === node)) {
          return find_stop(parent, level + 1, write_only);
        }
        return node;
      }
      if (parent instanceof AST_Call)
        return node;
      if (parent instanceof AST_Case)
        return node;
      if (parent instanceof AST_Conditional) {
        if (write_only && parent.condition === node) {
          return find_stop(parent, level + 1, write_only);
        }
        return node;
      }
      if (parent instanceof AST_Definitions) {
        return find_stop(parent, level + 1, true);
      }
      if (parent instanceof AST_Exit) {
        return write_only ? find_stop(parent, level + 1, write_only) : node;
      }
      if (parent instanceof AST_If) {
        if (write_only && parent.condition === node) {
          return find_stop(parent, level + 1, write_only);
        }
        return node;
      }
      if (parent instanceof AST_IterationStatement)
        return node;
      if (parent instanceof AST_Sequence) {
        return find_stop(parent, level + 1, parent.tail_node() !== node);
      }
      if (parent instanceof AST_SimpleStatement) {
        return find_stop(parent, level + 1, true);
      }
      if (parent instanceof AST_Switch)
        return node;
      if (parent instanceof AST_VarDef)
        return node;
      return null;
    }
    function mangleable_var(var_def) {
      var value = var_def.value;
      if (!(value instanceof AST_SymbolRef))
        return;
      if (value.name == "arguments")
        return;
      var def2 = value.definition();
      if (def2.undeclared)
        return;
      return value_def = def2;
    }
    function get_lhs(expr) {
      if (expr instanceof AST_Assign && expr.logical) {
        return false;
      } else if (expr instanceof AST_VarDef && expr.name instanceof AST_SymbolDeclaration) {
        var def2 = expr.name.definition();
        if (!member(expr.name, def2.orig))
          return;
        var referenced = def2.references.length - def2.replaced;
        if (!referenced)
          return;
        var declared = def2.orig.length - def2.eliminated;
        if (declared > 1 && !(expr.name instanceof AST_SymbolFunarg) || (referenced > 1 ? mangleable_var(expr) : !compressor2.exposed(def2))) {
          return make_node(AST_SymbolRef, expr.name, expr.name);
        }
      } else {
        const lhs2 = expr instanceof AST_Assign ? expr.left : expr.expression;
        return !is_ref_of(lhs2, AST_SymbolConst) && !is_ref_of(lhs2, AST_SymbolLet) && lhs2;
      }
    }
    function get_rvalue(expr) {
      if (expr instanceof AST_Assign) {
        return expr.right;
      } else {
        return expr.value;
      }
    }
    function get_lvalues(expr) {
      var lvalues2 = new Map;
      if (expr instanceof AST_Unary)
        return lvalues2;
      var tw = new TreeWalker(function(node) {
        var sym = node;
        while (sym instanceof AST_PropAccess)
          sym = sym.expression;
        if (sym instanceof AST_SymbolRef) {
          const prev = lvalues2.get(sym.name);
          if (!prev || !prev.modified) {
            lvalues2.set(sym.name, {
              def: sym.definition(),
              modified: is_modified(compressor2, tw, node, node, 0)
            });
          }
        }
      });
      get_rvalue(expr).walk(tw);
      return lvalues2;
    }
    function remove_candidate(expr) {
      if (expr.name instanceof AST_SymbolFunarg) {
        var iife = compressor2.parent(), argnames = compressor2.self().argnames;
        var index = argnames.indexOf(expr.name);
        if (index < 0) {
          iife.args.length = Math.min(iife.args.length, argnames.length - 1);
        } else {
          var args2 = iife.args;
          if (args2[index])
            args2[index] = make_node(AST_Number, args2[index], {
              value: 0
            });
        }
        return true;
      }
      var found = false;
      return statements2[stat_index].transform(new TreeTransformer(function(node, descend, in_list) {
        if (found)
          return node;
        if (node === expr || node.body === expr) {
          found = true;
          if (node instanceof AST_VarDef) {
            node.value = node.name instanceof AST_SymbolConst ? make_node(AST_Undefined, node.value) : null;
            return node;
          }
          return in_list ? MAP.skip : null;
        }
      }, function(node) {
        if (node instanceof AST_Sequence)
          switch (node.expressions.length) {
            case 0:
              return null;
            case 1:
              return node.expressions[0];
          }
      }));
    }
    function is_lhs_local(lhs2) {
      while (lhs2 instanceof AST_PropAccess)
        lhs2 = lhs2.expression;
      return lhs2 instanceof AST_SymbolRef && lhs2.definition().scope.get_defun_scope() === defun_scope && !(in_loop && (lvalues.has(lhs2.name) || candidate instanceof AST_Unary || candidate instanceof AST_Assign && !candidate.logical && candidate.operator != "="));
    }
    function value_has_side_effects(expr) {
      if (expr instanceof AST_Unary)
        return unary_side_effects.has(expr.operator);
      return get_rvalue(expr).has_side_effects(compressor2);
    }
    function replace_all_symbols() {
      if (side_effects)
        return false;
      if (value_def)
        return true;
      if (lhs instanceof AST_SymbolRef) {
        var def2 = lhs.definition();
        if (def2.references.length - def2.replaced == (candidate instanceof AST_VarDef ? 1 : 2)) {
          return true;
        }
      }
      return false;
    }
    function may_modify(sym) {
      if (!sym.definition)
        return true;
      var def2 = sym.definition();
      if (def2.orig.length == 1 && def2.orig[0] instanceof AST_SymbolDefun)
        return false;
      if (def2.scope.get_defun_scope() !== defun_scope)
        return true;
      return def2.references.some((ref2) => ref2.scope.get_defun_scope() !== defun_scope);
    }
    function side_effects_external(node, lhs2) {
      if (node instanceof AST_Assign)
        return side_effects_external(node.left, true);
      if (node instanceof AST_Unary)
        return side_effects_external(node.expression, true);
      if (node instanceof AST_VarDef)
        return node.value && side_effects_external(node.value);
      if (lhs2) {
        if (node instanceof AST_Dot)
          return side_effects_external(node.expression, true);
        if (node instanceof AST_Sub)
          return side_effects_external(node.expression, true);
        if (node instanceof AST_SymbolRef)
          return node.definition().scope.get_defun_scope() !== defun_scope;
      }
      return false;
    }
    function shadows(my_scope, lvalues2) {
      for (const { def: def2 } of lvalues2.values()) {
        const looked_up = my_scope.find_variable(def2.name);
        if (looked_up) {
          if (looked_up === def2)
            continue;
          return true;
        }
      }
      return false;
    }
  }
  function eliminate_spurious_blocks(statements2) {
    var seen_dirs = [];
    for (var i2 = 0;i2 < statements2.length; ) {
      var stat22 = statements2[i2];
      if (stat22 instanceof AST_BlockStatement && stat22.body.every(can_be_evicted_from_block)) {
        CHANGED = true;
        eliminate_spurious_blocks(stat22.body);
        statements2.splice(i2, 1, ...stat22.body);
        i2 += stat22.body.length;
      } else if (stat22 instanceof AST_EmptyStatement) {
        CHANGED = true;
        statements2.splice(i2, 1);
      } else if (stat22 instanceof AST_Directive) {
        if (seen_dirs.indexOf(stat22.value) < 0) {
          i2++;
          seen_dirs.push(stat22.value);
        } else {
          CHANGED = true;
          statements2.splice(i2, 1);
        }
      } else
        i2++;
    }
  }
  function handle_if_return(statements2, compressor2) {
    var self2 = compressor2.self();
    var multiple_if_returns = has_multiple_if_returns(statements2);
    var in_lambda = self2 instanceof AST_Lambda;
    const iteration_start = Math.min(statements2.length, 500);
    for (var i2 = iteration_start;--i2 >= 0; ) {
      var stat22 = statements2[i2];
      var j22 = next_index(i2);
      var next = statements2[j22];
      if (in_lambda && !next && stat22 instanceof AST_Return) {
        if (!stat22.value) {
          CHANGED = true;
          statements2.splice(i2, 1);
          continue;
        }
        if (stat22.value instanceof AST_UnaryPrefix && stat22.value.operator == "void") {
          CHANGED = true;
          statements2[i2] = make_node(AST_SimpleStatement, stat22, {
            body: stat22.value.expression
          });
          continue;
        }
      }
      if (stat22 instanceof AST_If) {
        let ab, new_else;
        ab = aborts(stat22.body);
        if (can_merge_flow(ab) && (new_else = as_statement_array_with_return(stat22.body, ab))) {
          if (ab.label) {
            remove(ab.label.thedef.references, ab);
          }
          CHANGED = true;
          stat22 = stat22.clone();
          stat22.condition = stat22.condition.negate(compressor2);
          stat22.body = make_node(AST_BlockStatement, stat22, {
            body: as_statement_array(stat22.alternative).concat(extract_functions())
          });
          stat22.alternative = make_node(AST_BlockStatement, stat22, {
            body: new_else
          });
          statements2[i2] = stat22.transform(compressor2);
          continue;
        }
        ab = aborts(stat22.alternative);
        if (can_merge_flow(ab) && (new_else = as_statement_array_with_return(stat22.alternative, ab))) {
          if (ab.label) {
            remove(ab.label.thedef.references, ab);
          }
          CHANGED = true;
          stat22 = stat22.clone();
          stat22.body = make_node(AST_BlockStatement, stat22.body, {
            body: as_statement_array(stat22.body).concat(extract_functions())
          });
          stat22.alternative = make_node(AST_BlockStatement, stat22.alternative, {
            body: new_else
          });
          statements2[i2] = stat22.transform(compressor2);
          continue;
        }
      }
      if (stat22 instanceof AST_If && stat22.body instanceof AST_Return) {
        var value = stat22.body.value;
        if (!value && !stat22.alternative && (in_lambda && !next || next instanceof AST_Return && !next.value)) {
          CHANGED = true;
          statements2[i2] = make_node(AST_SimpleStatement, stat22.condition, {
            body: stat22.condition
          });
          continue;
        }
        if (value && !stat22.alternative && next instanceof AST_Return && next.value) {
          CHANGED = true;
          stat22 = stat22.clone();
          stat22.alternative = next;
          statements2[i2] = stat22.transform(compressor2);
          statements2.splice(j22, 1);
          continue;
        }
        if (value && !stat22.alternative && (!next && in_lambda && multiple_if_returns || next instanceof AST_Return)) {
          CHANGED = true;
          stat22 = stat22.clone();
          stat22.alternative = next || make_node(AST_Return, stat22, {
            value: null
          });
          statements2[i2] = stat22.transform(compressor2);
          if (next)
            statements2.splice(j22, 1);
          continue;
        }
        var prev = statements2[prev_index(i2)];
        if (compressor2.option("sequences") && in_lambda && !stat22.alternative && prev instanceof AST_If && prev.body instanceof AST_Return && next_index(j22) == statements2.length && next instanceof AST_SimpleStatement) {
          CHANGED = true;
          stat22 = stat22.clone();
          stat22.alternative = make_node(AST_BlockStatement, next, {
            body: [
              next,
              make_node(AST_Return, next, {
                value: null
              })
            ]
          });
          statements2[i2] = stat22.transform(compressor2);
          statements2.splice(j22, 1);
          continue;
        }
      }
    }
    function has_multiple_if_returns(statements3) {
      var n = 0;
      for (var i22 = statements3.length;--i22 >= 0; ) {
        var stat3 = statements3[i22];
        if (stat3 instanceof AST_If && stat3.body instanceof AST_Return) {
          if (++n > 1)
            return true;
        }
      }
      return false;
    }
    function is_return_void(value2) {
      return !value2 || value2 instanceof AST_UnaryPrefix && value2.operator == "void";
    }
    function can_merge_flow(ab) {
      if (!ab)
        return false;
      for (var j3 = i2 + 1, len = statements2.length;j3 < len; j3++) {
        var stat3 = statements2[j3];
        if (stat3 instanceof AST_Const || stat3 instanceof AST_Let)
          return false;
      }
      var lct = ab instanceof AST_LoopControl ? compressor2.loopcontrol_target(ab) : null;
      return ab instanceof AST_Return && in_lambda && is_return_void(ab.value) || ab instanceof AST_Continue && self2 === loop_body(lct) || ab instanceof AST_Break && lct instanceof AST_BlockStatement && self2 === lct;
    }
    function extract_functions() {
      var tail = statements2.slice(i2 + 1);
      statements2.length = i2 + 1;
      return tail.filter(function(stat3) {
        if (stat3 instanceof AST_Defun) {
          statements2.push(stat3);
          return false;
        }
        return true;
      });
    }
    function as_statement_array_with_return(node, ab) {
      var body = as_statement_array(node);
      if (ab !== body[body.length - 1]) {
        return;
      }
      body = body.slice(0, -1);
      if (ab.value) {
        body.push(make_node(AST_SimpleStatement, ab.value, {
          body: ab.value.expression
        }));
      }
      return body;
    }
    function next_index(i22) {
      for (var j3 = i22 + 1, len = statements2.length;j3 < len; j3++) {
        var stat3 = statements2[j3];
        if (!(stat3 instanceof AST_Var && declarations_only(stat3))) {
          break;
        }
      }
      return j3;
    }
    function prev_index(i22) {
      for (var j3 = i22;--j3 >= 0; ) {
        var stat3 = statements2[j3];
        if (!(stat3 instanceof AST_Var && declarations_only(stat3))) {
          break;
        }
      }
      return j3;
    }
  }
  function eliminate_dead_code(statements2, compressor2) {
    var has_quit;
    var self2 = compressor2.self();
    for (var i2 = 0, n = 0, len = statements2.length;i2 < len; i2++) {
      var stat22 = statements2[i2];
      if (stat22 instanceof AST_LoopControl) {
        var lct = compressor2.loopcontrol_target(stat22);
        if (stat22 instanceof AST_Break && !(lct instanceof AST_IterationStatement) && loop_body(lct) === self2 || stat22 instanceof AST_Continue && loop_body(lct) === self2) {
          if (stat22.label) {
            remove(stat22.label.thedef.references, stat22);
          }
        } else {
          statements2[n++] = stat22;
        }
      } else {
        statements2[n++] = stat22;
      }
      if (aborts(stat22)) {
        has_quit = statements2.slice(i2 + 1);
        break;
      }
    }
    statements2.length = n;
    CHANGED = n != len;
    if (has_quit)
      has_quit.forEach(function(stat3) {
        trim_unreachable_code(compressor2, stat3, statements2);
      });
  }
  function declarations_only(node) {
    return node.definitions.every((var_def) => !var_def.value);
  }
  function sequencesize(statements2, compressor2) {
    if (statements2.length < 2)
      return;
    var seq = [], n = 0;
    function push_seq() {
      if (!seq.length)
        return;
      var body2 = make_sequence(seq[0], seq);
      statements2[n++] = make_node(AST_SimpleStatement, body2, { body: body2 });
      seq = [];
    }
    for (var i2 = 0, len = statements2.length;i2 < len; i2++) {
      var stat22 = statements2[i2];
      if (stat22 instanceof AST_SimpleStatement) {
        if (seq.length >= compressor2.sequences_limit)
          push_seq();
        var body = stat22.body;
        if (seq.length > 0)
          body = body.drop_side_effect_free(compressor2);
        if (body)
          merge_sequence(seq, body);
      } else if (stat22 instanceof AST_Definitions && declarations_only(stat22) || stat22 instanceof AST_Defun) {
        statements2[n++] = stat22;
      } else {
        push_seq();
        statements2[n++] = stat22;
      }
    }
    push_seq();
    statements2.length = n;
    if (n != len)
      CHANGED = true;
  }
  function to_simple_statement(block, decls) {
    if (!(block instanceof AST_BlockStatement))
      return block;
    var stat22 = null;
    for (var i2 = 0, len = block.body.length;i2 < len; i2++) {
      var line = block.body[i2];
      if (line instanceof AST_Var && declarations_only(line)) {
        decls.push(line);
      } else if (stat22 || line instanceof AST_Const || line instanceof AST_Let) {
        return false;
      } else {
        stat22 = line;
      }
    }
    return stat22;
  }
  function sequencesize_2(statements2, compressor2) {
    function cons_seq(right) {
      n--;
      CHANGED = true;
      var left = prev.body;
      return make_sequence(left, [left, right]).transform(compressor2);
    }
    var n = 0, prev;
    for (var i2 = 0;i2 < statements2.length; i2++) {
      var stat22 = statements2[i2];
      if (prev) {
        if (stat22 instanceof AST_Exit) {
          stat22.value = cons_seq(stat22.value || make_node(AST_Undefined, stat22).transform(compressor2));
        } else if (stat22 instanceof AST_For) {
          if (!(stat22.init instanceof AST_Definitions)) {
            const abort = walk2(prev.body, (node) => {
              if (node instanceof AST_Scope)
                return true;
              if (node instanceof AST_Binary && node.operator === "in") {
                return walk_abort;
              }
            });
            if (!abort) {
              if (stat22.init)
                stat22.init = cons_seq(stat22.init);
              else {
                stat22.init = prev.body;
                n--;
                CHANGED = true;
              }
            }
          }
        } else if (stat22 instanceof AST_ForIn) {
          if (!(stat22.init instanceof AST_Const) && !(stat22.init instanceof AST_Let)) {
            stat22.object = cons_seq(stat22.object);
          }
        } else if (stat22 instanceof AST_If) {
          stat22.condition = cons_seq(stat22.condition);
        } else if (stat22 instanceof AST_Switch) {
          stat22.expression = cons_seq(stat22.expression);
        } else if (stat22 instanceof AST_With) {
          stat22.expression = cons_seq(stat22.expression);
        }
      }
      if (compressor2.option("conditionals") && stat22 instanceof AST_If) {
        var decls = [];
        var body = to_simple_statement(stat22.body, decls);
        var alt = to_simple_statement(stat22.alternative, decls);
        if (body !== false && alt !== false && decls.length > 0) {
          var len = decls.length;
          decls.push(make_node(AST_If, stat22, {
            condition: stat22.condition,
            body: body || make_node(AST_EmptyStatement, stat22.body),
            alternative: alt
          }));
          decls.unshift(n, 1);
          [].splice.apply(statements2, decls);
          i2 += len;
          n += len + 1;
          prev = null;
          CHANGED = true;
          continue;
        }
      }
      statements2[n++] = stat22;
      prev = stat22 instanceof AST_SimpleStatement ? stat22 : null;
    }
    statements2.length = n;
  }
  function join_object_assignments(defn, body) {
    if (!(defn instanceof AST_Definitions))
      return;
    var def = defn.definitions[defn.definitions.length - 1];
    if (!(def.value instanceof AST_Object))
      return;
    var exprs;
    if (body instanceof AST_Assign && !body.logical) {
      exprs = [body];
    } else if (body instanceof AST_Sequence) {
      exprs = body.expressions.slice();
    }
    if (!exprs)
      return;
    var trimmed = false;
    do {
      var node = exprs[0];
      if (!(node instanceof AST_Assign))
        break;
      if (node.operator != "=")
        break;
      if (!(node.left instanceof AST_PropAccess))
        break;
      var sym = node.left.expression;
      if (!(sym instanceof AST_SymbolRef))
        break;
      if (def.name.name != sym.name)
        break;
      if (!node.right.is_constant_expression(nearest_scope))
        break;
      var prop = node.left.property;
      if (prop instanceof AST_Node) {
        prop = prop.evaluate(compressor);
      }
      if (prop instanceof AST_Node)
        break;
      prop = "" + prop;
      var diff = compressor.option("ecma") < 2015 && compressor.has_directive("use strict") ? function(node2) {
        return node2.key != prop && (node2.key && node2.key.name != prop);
      } : function(node2) {
        return node2.key && node2.key.name != prop;
      };
      if (!def.value.properties.every(diff))
        break;
      var p32 = def.value.properties.filter(function(p4) {
        return p4.key === prop;
      })[0];
      if (!p32) {
        def.value.properties.push(make_node(AST_ObjectKeyVal, node, {
          key: prop,
          value: node.right
        }));
      } else {
        p32.value = new AST_Sequence({
          start: p32.start,
          expressions: [p32.value.clone(), node.right.clone()],
          end: p32.end
        });
      }
      exprs.shift();
      trimmed = true;
    } while (exprs.length);
    return trimmed && exprs;
  }
  function join_consecutive_vars(statements2) {
    var defs;
    for (var i2 = 0, j22 = -1, len = statements2.length;i2 < len; i2++) {
      var stat22 = statements2[i2];
      var prev = statements2[j22];
      if (stat22 instanceof AST_Definitions) {
        if (prev && prev.TYPE == stat22.TYPE) {
          prev.definitions = prev.definitions.concat(stat22.definitions);
          CHANGED = true;
        } else if (defs && defs.TYPE == stat22.TYPE && declarations_only(stat22)) {
          defs.definitions = defs.definitions.concat(stat22.definitions);
          CHANGED = true;
        } else {
          statements2[++j22] = stat22;
          defs = stat22;
        }
      } else if (stat22 instanceof AST_Exit) {
        stat22.value = extract_object_assignments(stat22.value);
      } else if (stat22 instanceof AST_For) {
        var exprs = join_object_assignments(prev, stat22.init);
        if (exprs) {
          CHANGED = true;
          stat22.init = exprs.length ? make_sequence(stat22.init, exprs) : null;
          statements2[++j22] = stat22;
        } else if (prev instanceof AST_Var && (!stat22.init || stat22.init.TYPE == prev.TYPE)) {
          if (stat22.init) {
            prev.definitions = prev.definitions.concat(stat22.init.definitions);
          }
          stat22.init = prev;
          statements2[j22] = stat22;
          CHANGED = true;
        } else if (defs instanceof AST_Var && stat22.init instanceof AST_Var && declarations_only(stat22.init)) {
          defs.definitions = defs.definitions.concat(stat22.init.definitions);
          stat22.init = null;
          statements2[++j22] = stat22;
          CHANGED = true;
        } else {
          statements2[++j22] = stat22;
        }
      } else if (stat22 instanceof AST_ForIn) {
        stat22.object = extract_object_assignments(stat22.object);
      } else if (stat22 instanceof AST_If) {
        stat22.condition = extract_object_assignments(stat22.condition);
      } else if (stat22 instanceof AST_SimpleStatement) {
        var exprs = join_object_assignments(prev, stat22.body);
        if (exprs) {
          CHANGED = true;
          if (!exprs.length)
            continue;
          stat22.body = make_sequence(stat22.body, exprs);
        }
        statements2[++j22] = stat22;
      } else if (stat22 instanceof AST_Switch) {
        stat22.expression = extract_object_assignments(stat22.expression);
      } else if (stat22 instanceof AST_With) {
        stat22.expression = extract_object_assignments(stat22.expression);
      } else {
        statements2[++j22] = stat22;
      }
    }
    statements2.length = j22 + 1;
    function extract_object_assignments(value) {
      statements2[++j22] = stat22;
      var exprs2 = join_object_assignments(prev, value);
      if (exprs2) {
        CHANGED = true;
        if (exprs2.length) {
          return make_sequence(value, exprs2);
        } else if (value instanceof AST_Sequence) {
          return value.tail_node().left;
        } else {
          return value.left;
        }
      }
      return value;
    }
  }
}
var init_tighten_body = __esm2(() => {
  init_ast();
  init_utils5();
  init_native_objects();
  init_inference();
  init_compressor_flags();
  init_common();
});
function within_array_or_object_literal(compressor) {
  var node, level = 0;
  while (node = compressor.parent(level++)) {
    if (node instanceof AST_Statement)
      return false;
    if (node instanceof AST_Array || node instanceof AST_ObjectKeyVal || node instanceof AST_Object) {
      return true;
    }
  }
  return false;
}
function scope_encloses_variables_in_this_scope(scope, pulled_scope) {
  for (const enclosed of pulled_scope.enclosed) {
    if (pulled_scope.variables.has(enclosed.name)) {
      continue;
    }
    const looked_up = scope.find_variable(enclosed.name);
    if (looked_up) {
      if (looked_up === enclosed)
        continue;
      return true;
    }
  }
  return false;
}
function is_const_symbol_short_than_init_value(def, fixed_value) {
  if (def.orig.length === 1 && fixed_value) {
    const init_value_length = fixed_value.size();
    const identifer_length = def.name.length;
    return init_value_length > identifer_length;
  }
  return true;
}
function inline_into_symbolref(self2, compressor) {
  if (compressor.in_computed_key())
    return self2;
  const parent = compressor.parent();
  const def = self2.definition();
  const nearest_scope = compressor.find_scope();
  let fixed = self2.fixed_value();
  if (compressor.top_retain && def.global && compressor.top_retain(def) && is_const_symbol_short_than_init_value(def, fixed)) {
    def.fixed = false;
    def.single_use = false;
    return self2;
  }
  let single_use = def.single_use && !(parent instanceof AST_Call && parent.is_callee_pure(compressor) || has_annotation(parent, _NOINLINE)) && !(parent instanceof AST_Export && fixed instanceof AST_Lambda && fixed.name);
  if (single_use && fixed instanceof AST_Node) {
    single_use = !fixed.has_side_effects(compressor) && !fixed.may_throw(compressor);
  }
  if (fixed instanceof AST_Class && def.scope !== self2.scope) {
    return self2;
  }
  if (single_use && (fixed instanceof AST_Lambda || fixed instanceof AST_Class)) {
    if (retain_top_func(fixed, compressor)) {
      single_use = false;
    } else if (def.scope !== self2.scope && (def.escaped == 1 || has_flag(fixed, INLINED) || within_array_or_object_literal(compressor) || !compressor.option("reduce_funcs"))) {
      single_use = false;
    } else if (is_recursive_ref(compressor, def)) {
      single_use = false;
    } else if (def.scope !== self2.scope || def.orig[0] instanceof AST_SymbolFunarg) {
      single_use = fixed.is_constant_expression(self2.scope);
      if (single_use == "f") {
        var scope = self2.scope;
        do {
          if (scope instanceof AST_Defun || is_func_expr(scope)) {
            set_flag(scope, INLINED);
          }
        } while (scope = scope.parent_scope);
      }
    }
  }
  if (single_use && (fixed instanceof AST_Lambda || fixed instanceof AST_Class)) {
    single_use = def.scope === self2.scope && !scope_encloses_variables_in_this_scope(nearest_scope, fixed) || parent instanceof AST_Call && parent.expression === self2 && !scope_encloses_variables_in_this_scope(nearest_scope, fixed) && !(fixed.name && fixed.name.definition().recursive_refs > 0);
  }
  if (single_use && fixed) {
    if (fixed instanceof AST_DefClass) {
      set_flag(fixed, SQUEEZED);
      fixed = make_node(AST_ClassExpression, fixed, fixed);
    }
    if (fixed instanceof AST_Defun) {
      set_flag(fixed, SQUEEZED);
      fixed = make_node(AST_Function, fixed, fixed);
    }
    if (def.recursive_refs > 0 && fixed.name instanceof AST_SymbolDefun) {
      const defun_def = fixed.name.definition();
      let lambda_def = fixed.variables.get(fixed.name.name);
      let name = lambda_def && lambda_def.orig[0];
      if (!(name instanceof AST_SymbolLambda)) {
        name = make_node(AST_SymbolLambda, fixed.name, fixed.name);
        name.scope = fixed;
        fixed.name = name;
        lambda_def = fixed.def_function(name);
      }
      walk2(fixed, (node) => {
        if (node instanceof AST_SymbolRef && node.definition() === defun_def) {
          node.thedef = lambda_def;
          lambda_def.references.push(node);
        }
      });
    }
    if ((fixed instanceof AST_Lambda || fixed instanceof AST_Class) && fixed.parent_scope !== nearest_scope) {
      fixed = fixed.clone(true, compressor.get_toplevel());
      nearest_scope.add_child_scope(fixed);
    }
    return fixed.optimize(compressor);
  }
  if (fixed) {
    let replace22;
    if (fixed instanceof AST_This) {
      if (!(def.orig[0] instanceof AST_SymbolFunarg) && def.references.every((ref2) => def.scope === ref2.scope)) {
        replace22 = fixed;
      }
    } else {
      var ev = fixed.evaluate(compressor);
      if (ev !== fixed && (compressor.option("unsafe_regexp") || !(ev instanceof RegExp))) {
        replace22 = make_node_from_constant(ev, fixed);
      }
    }
    if (replace22) {
      const name_length = self2.size(compressor);
      const replace_size = replace22.size(compressor);
      let overhead = 0;
      if (compressor.option("unused") && !compressor.exposed(def)) {
        overhead = (name_length + 2 + fixed.size(compressor)) / (def.references.length - def.assignments);
      }
      if (replace_size <= name_length + overhead) {
        return replace22;
      }
    }
  }
  return self2;
}
function inline_into_call(self2, compressor) {
  if (compressor.in_computed_key())
    return self2;
  var exp = self2.expression;
  var fn = exp;
  var simple_args = self2.args.every((arg) => !(arg instanceof AST_Expansion));
  if (compressor.option("reduce_vars") && fn instanceof AST_SymbolRef && !has_annotation(self2, _NOINLINE)) {
    const fixed = fn.fixed_value();
    if (retain_top_func(fixed, compressor) || !compressor.toplevel.funcs && exp.definition().global) {
      return self2;
    }
    fn = fixed;
  }
  var is_func = fn instanceof AST_Lambda;
  var stat22 = is_func && fn.body[0];
  var is_regular_func = is_func && !fn.is_generator && !fn.async;
  var can_inline = is_regular_func && compressor.option("inline") && !self2.is_callee_pure(compressor);
  if (can_inline && stat22 instanceof AST_Return) {
    let returned = stat22.value;
    if (!returned || returned.is_constant_expression()) {
      if (returned) {
        returned = returned.clone(true);
      } else {
        returned = make_node(AST_Undefined, self2);
      }
      const args2 = self2.args.concat(returned);
      return make_sequence(self2, args2).optimize(compressor);
    }
    if (fn.argnames.length === 1 && fn.argnames[0] instanceof AST_SymbolFunarg && self2.args.length < 2 && !(self2.args[0] instanceof AST_Expansion) && returned instanceof AST_SymbolRef && returned.name === fn.argnames[0].name) {
      const replacement = (self2.args[0] || make_node(AST_Undefined)).optimize(compressor);
      let parent;
      if (replacement instanceof AST_PropAccess && (parent = compressor.parent()) instanceof AST_Call && parent.expression === self2) {
        return make_sequence(self2, [
          make_node(AST_Number, self2, { value: 0 }),
          replacement
        ]);
      }
      return replacement;
    }
  }
  if (can_inline) {
    var scope, in_loop, level = -1;
    let def;
    let returned_value;
    let nearest_scope;
    if (simple_args && !fn.uses_arguments && !(compressor.parent() instanceof AST_Class) && !(fn.name && fn instanceof AST_Function) && (returned_value = can_flatten_body(stat22)) && (exp === fn || has_annotation(self2, _INLINE) || compressor.option("unused") && (def = exp.definition()).references.length == 1 && !is_recursive_ref(compressor, def) && fn.is_constant_expression(exp.scope)) && !has_annotation(self2, _PURE | _NOINLINE) && !fn.contains_this() && can_inject_symbols() && (nearest_scope = compressor.find_scope()) && !scope_encloses_variables_in_this_scope(nearest_scope, fn) && !function in_default_assign() {
      let i2 = 0;
      let p32;
      while (p32 = compressor.parent(i2++)) {
        if (p32 instanceof AST_DefaultAssign)
          return true;
        if (p32 instanceof AST_Block)
          break;
      }
      return false;
    }() && !(scope instanceof AST_Class)) {
      set_flag(fn, SQUEEZED);
      nearest_scope.add_child_scope(fn);
      return make_sequence(self2, flatten_fn(returned_value)).optimize(compressor);
    }
  }
  if (can_inline && has_annotation(self2, _INLINE)) {
    set_flag(fn, SQUEEZED);
    fn = make_node(fn.CTOR === AST_Defun ? AST_Function : fn.CTOR, fn, fn);
    fn = fn.clone(true);
    fn.figure_out_scope({}, {
      parent_scope: compressor.find_scope(),
      toplevel: compressor.get_toplevel()
    });
    return make_node(AST_Call, self2, {
      expression: fn,
      args: self2.args
    }).optimize(compressor);
  }
  const can_drop_this_call = is_regular_func && compressor.option("side_effects") && fn.body.every(is_empty);
  if (can_drop_this_call) {
    var args = self2.args.concat(make_node(AST_Undefined, self2));
    return make_sequence(self2, args).optimize(compressor);
  }
  if (compressor.option("negate_iife") && compressor.parent() instanceof AST_SimpleStatement && is_iife_call(self2)) {
    return self2.negate(compressor, true);
  }
  var ev = self2.evaluate(compressor);
  if (ev !== self2) {
    ev = make_node_from_constant(ev, self2).optimize(compressor);
    return best_of(compressor, ev, self2);
  }
  return self2;
  function return_value(stat3) {
    if (!stat3)
      return make_node(AST_Undefined, self2);
    if (stat3 instanceof AST_Return) {
      if (!stat3.value)
        return make_node(AST_Undefined, self2);
      return stat3.value.clone(true);
    }
    if (stat3 instanceof AST_SimpleStatement) {
      return make_node(AST_UnaryPrefix, stat3, {
        operator: "void",
        expression: stat3.body.clone(true)
      });
    }
  }
  function can_flatten_body(stat3) {
    var body = fn.body;
    var len = body.length;
    if (compressor.option("inline") < 3) {
      return len == 1 && return_value(stat3);
    }
    stat3 = null;
    for (var i2 = 0;i2 < len; i2++) {
      var line = body[i2];
      if (line instanceof AST_Var) {
        if (stat3 && !line.definitions.every((var_def) => !var_def.value)) {
          return false;
        }
      } else if (stat3) {
        return false;
      } else if (!(line instanceof AST_EmptyStatement)) {
        stat3 = line;
      }
    }
    return return_value(stat3);
  }
  function can_inject_args(block_scoped, safe_to_inject) {
    for (var i2 = 0, len = fn.argnames.length;i2 < len; i2++) {
      var arg = fn.argnames[i2];
      if (arg instanceof AST_DefaultAssign) {
        if (has_flag(arg.left, UNUSED))
          continue;
        return false;
      }
      if (arg instanceof AST_Destructuring)
        return false;
      if (arg instanceof AST_Expansion) {
        if (has_flag(arg.expression, UNUSED))
          continue;
        return false;
      }
      if (has_flag(arg, UNUSED))
        continue;
      if (!safe_to_inject || block_scoped.has(arg.name) || identifier_atom.has(arg.name) || scope.conflicting_def(arg.name)) {
        return false;
      }
      if (in_loop)
        in_loop.push(arg.definition());
    }
    return true;
  }
  function can_inject_vars(block_scoped, safe_to_inject) {
    var len = fn.body.length;
    for (var i2 = 0;i2 < len; i2++) {
      var stat3 = fn.body[i2];
      if (!(stat3 instanceof AST_Var))
        continue;
      if (!safe_to_inject)
        return false;
      for (var j22 = stat3.definitions.length;--j22 >= 0; ) {
        var name = stat3.definitions[j22].name;
        if (name instanceof AST_Destructuring || block_scoped.has(name.name) || identifier_atom.has(name.name) || scope.conflicting_def(name.name)) {
          return false;
        }
        if (in_loop)
          in_loop.push(name.definition());
      }
    }
    return true;
  }
  function can_inject_symbols() {
    var block_scoped = new Set;
    do {
      scope = compressor.parent(++level);
      if (scope.is_block_scope() && scope.block_scope) {
        scope.block_scope.variables.forEach(function(variable) {
          block_scoped.add(variable.name);
        });
      }
      if (scope instanceof AST_Catch) {
        if (scope.argname) {
          block_scoped.add(scope.argname.name);
        }
      } else if (scope instanceof AST_IterationStatement) {
        in_loop = [];
      } else if (scope instanceof AST_SymbolRef) {
        if (scope.fixed_value() instanceof AST_Scope)
          return false;
      }
    } while (!(scope instanceof AST_Scope));
    var safe_to_inject = !(scope instanceof AST_Toplevel) || compressor.toplevel.vars;
    var inline = compressor.option("inline");
    if (!can_inject_vars(block_scoped, inline >= 3 && safe_to_inject))
      return false;
    if (!can_inject_args(block_scoped, inline >= 2 && safe_to_inject))
      return false;
    return !in_loop || in_loop.length == 0 || !is_reachable(fn, in_loop);
  }
  function append_var(decls, expressions, name, value) {
    var def = name.definition();
    const already_appended = scope.variables.has(name.name);
    if (!already_appended) {
      scope.variables.set(name.name, def);
      scope.enclosed.push(def);
      decls.push(make_node(AST_VarDef, name, {
        name,
        value: null
      }));
    }
    var sym = make_node(AST_SymbolRef, name, name);
    def.references.push(sym);
    if (value)
      expressions.push(make_node(AST_Assign, self2, {
        operator: "=",
        logical: false,
        left: sym,
        right: value.clone()
      }));
  }
  function flatten_args(decls, expressions) {
    var len = fn.argnames.length;
    for (var i2 = self2.args.length;--i2 >= len; ) {
      expressions.push(self2.args[i2]);
    }
    for (i2 = len;--i2 >= 0; ) {
      var name = fn.argnames[i2];
      var value = self2.args[i2];
      if (has_flag(name, UNUSED) || !name.name || scope.conflicting_def(name.name)) {
        if (value)
          expressions.push(value);
      } else {
        var symbol22 = make_node(AST_SymbolVar, name, name);
        name.definition().orig.push(symbol22);
        if (!value && in_loop)
          value = make_node(AST_Undefined, self2);
        append_var(decls, expressions, symbol22, value);
      }
    }
    decls.reverse();
    expressions.reverse();
  }
  function flatten_vars(decls, expressions) {
    var pos = expressions.length;
    for (var i2 = 0, lines = fn.body.length;i2 < lines; i2++) {
      var stat3 = fn.body[i2];
      if (!(stat3 instanceof AST_Var))
        continue;
      for (var j22 = 0, defs = stat3.definitions.length;j22 < defs; j22++) {
        var var_def = stat3.definitions[j22];
        var name = var_def.name;
        append_var(decls, expressions, name, var_def.value);
        if (in_loop && fn.argnames.every((argname) => argname.name != name.name)) {
          var def = fn.variables.get(name.name);
          var sym = make_node(AST_SymbolRef, name, name);
          def.references.push(sym);
          expressions.splice(pos++, 0, make_node(AST_Assign, var_def, {
            operator: "=",
            logical: false,
            left: sym,
            right: make_node(AST_Undefined, name)
          }));
        }
      }
    }
  }
  function flatten_fn(returned_value) {
    var decls = [];
    var expressions = [];
    flatten_args(decls, expressions);
    flatten_vars(decls, expressions);
    expressions.push(returned_value);
    if (decls.length) {
      const i2 = scope.body.indexOf(compressor.parent(level - 1)) + 1;
      scope.body.splice(i2, 0, make_node(AST_Var, fn, {
        definitions: decls
      }));
    }
    return expressions.map((exp2) => exp2.clone(true));
  }
}
var init_inline = __esm2(() => {
  init_ast();
  init_utils5();
  init_size();
  init_evaluate();
  init_drop_side_effect_free();
  init_reduce_vars();
  init_compressor_flags();
  init_common();
});
var init_global_defs = __esm2(() => {
  init_ast();
  init_utils5();
  init_common();
  init_inference();
  (function(def_find_defs) {
    function to_node(value, orig) {
      if (value instanceof AST_Node) {
        if (!(value instanceof AST_Constant)) {
          value = value.clone(true);
        }
        return make_node(value.CTOR, orig, value);
      }
      if (Array.isArray(value))
        return make_node(AST_Array, orig, {
          elements: value.map(function(value2) {
            return to_node(value2, orig);
          })
        });
      if (value && typeof value == "object") {
        var props = [];
        for (var key in value)
          if (HOP(value, key)) {
            props.push(make_node(AST_ObjectKeyVal, orig, {
              key,
              value: to_node(value[key], orig)
            }));
          }
        return make_node(AST_Object, orig, {
          properties: props
        });
      }
      return make_node_from_constant(value, orig);
    }
    AST_Toplevel.DEFMETHOD("resolve_defines", function(compressor) {
      if (!compressor.option("global_defs"))
        return this;
      this.figure_out_scope({ ie8: compressor.option("ie8") });
      return this.transform(new TreeTransformer(function(node) {
        var def = node._find_defs(compressor, "");
        if (!def)
          return;
        var level = 0, child = node, parent;
        while (parent = this.parent(level++)) {
          if (!(parent instanceof AST_PropAccess))
            break;
          if (parent.expression !== child)
            break;
          child = parent;
        }
        if (is_lhs(child, parent)) {
          return;
        }
        return def;
      }));
    });
    def_find_defs(AST_Node, noop);
    def_find_defs(AST_Chain, function(compressor, suffix) {
      return this.expression._find_defs(compressor, suffix);
    });
    def_find_defs(AST_Dot, function(compressor, suffix) {
      return this.expression._find_defs(compressor, "." + this.property + suffix);
    });
    def_find_defs(AST_SymbolDeclaration, function() {
      if (!this.global())
        return;
    });
    def_find_defs(AST_SymbolRef, function(compressor, suffix) {
      if (!this.global())
        return;
      var defines = compressor.option("global_defs");
      var name = this.name + suffix;
      if (HOP(defines, name))
        return to_node(defines[name], this);
    });
    def_find_defs(AST_ImportMeta, function(compressor, suffix) {
      var defines = compressor.option("global_defs");
      var name = "import.meta" + suffix;
      if (HOP(defines, name))
        return to_node(defines[name], this);
    });
  })(function(node, func) {
    node.DEFMETHOD("_find_defs", func);
  });
});
function def_optimize(node, optimizer) {
  node.DEFMETHOD("optimize", function(compressor) {
    var self2 = this;
    if (has_flag(self2, OPTIMIZED))
      return self2;
    if (compressor.has_directive("use asm"))
      return self2;
    var opt = optimizer(self2, compressor);
    set_flag(opt, OPTIMIZED);
    return opt;
  });
}
function find_variable(compressor, name) {
  var scope, i2 = 0;
  while (scope = compressor.parent(i2++)) {
    if (scope instanceof AST_Scope)
      break;
    if (scope instanceof AST_Catch && scope.argname) {
      scope = scope.argname.definition().scope;
      break;
    }
  }
  return scope.find_variable(name);
}
function can_be_extracted_from_if_block(node) {
  return !(node instanceof AST_Const || node instanceof AST_Let || node instanceof AST_Class);
}
function opt_AST_Lambda(self2, compressor) {
  tighten_body(self2.body, compressor);
  if (compressor.option("side_effects") && self2.body.length == 1 && self2.body[0] === compressor.has_directive("use strict")) {
    self2.body.length = 0;
  }
  return self2;
}
function if_break_in_loop(self2, compressor) {
  var first = self2.body instanceof AST_BlockStatement ? self2.body.body[0] : self2.body;
  if (compressor.option("dead_code") && is_break(first)) {
    var body = [];
    if (self2.init instanceof AST_Statement) {
      body.push(self2.init);
    } else if (self2.init) {
      body.push(make_node(AST_SimpleStatement, self2.init, {
        body: self2.init
      }));
    }
    if (self2.condition) {
      body.push(make_node(AST_SimpleStatement, self2.condition, {
        body: self2.condition
      }));
    }
    trim_unreachable_code(compressor, self2.body, body);
    return make_node(AST_BlockStatement, self2, {
      body
    });
  }
  if (first instanceof AST_If) {
    if (is_break(first.body)) {
      if (self2.condition) {
        self2.condition = make_node(AST_Binary, self2.condition, {
          left: self2.condition,
          operator: "&&",
          right: first.condition.negate(compressor)
        });
      } else {
        self2.condition = first.condition.negate(compressor);
      }
      drop_it(first.alternative);
    } else if (is_break(first.alternative)) {
      if (self2.condition) {
        self2.condition = make_node(AST_Binary, self2.condition, {
          left: self2.condition,
          operator: "&&",
          right: first.condition
        });
      } else {
        self2.condition = first.condition;
      }
      drop_it(first.body);
    }
  }
  return self2;
  function is_break(node) {
    return node instanceof AST_Break && compressor.loopcontrol_target(node) === compressor.self();
  }
  function drop_it(rest) {
    rest = as_statement_array(rest);
    if (self2.body instanceof AST_BlockStatement) {
      self2.body = self2.body.clone();
      self2.body.body = rest.concat(self2.body.body.slice(1));
      self2.body = self2.body.transform(compressor);
    } else {
      self2.body = make_node(AST_BlockStatement, self2.body, {
        body: rest
      }).transform(compressor);
    }
    self2 = if_break_in_loop(self2, compressor);
  }
}
function is_object(node) {
  return node instanceof AST_Array || node instanceof AST_Lambda || node instanceof AST_Object || node instanceof AST_Class;
}
function is_atomic(lhs, self2) {
  return lhs instanceof AST_SymbolRef || lhs.TYPE === self2.TYPE;
}
function is_nullish_check(check, check_subject, compressor) {
  if (check_subject.may_throw(compressor))
    return false;
  let nullish_side;
  if (check instanceof AST_Binary && check.operator === "==" && ((nullish_side = is_nullish(check.left, compressor) && check.left) || (nullish_side = is_nullish(check.right, compressor) && check.right)) && (nullish_side === check.left ? check.right : check.left).equivalent_to(check_subject)) {
    return true;
  }
  if (check instanceof AST_Binary && check.operator === "||") {
    let null_cmp;
    let undefined_cmp;
    const find_comparison = (cmp) => {
      if (!(cmp instanceof AST_Binary && (cmp.operator === "===" || cmp.operator === "=="))) {
        return false;
      }
      let found = 0;
      let defined_side;
      if (cmp.left instanceof AST_Null) {
        found++;
        null_cmp = cmp;
        defined_side = cmp.right;
      }
      if (cmp.right instanceof AST_Null) {
        found++;
        null_cmp = cmp;
        defined_side = cmp.left;
      }
      if (is_undefined(cmp.left, compressor)) {
        found++;
        undefined_cmp = cmp;
        defined_side = cmp.right;
      }
      if (is_undefined(cmp.right, compressor)) {
        found++;
        undefined_cmp = cmp;
        defined_side = cmp.left;
      }
      if (found !== 1) {
        return false;
      }
      if (!defined_side.equivalent_to(check_subject)) {
        return false;
      }
      return true;
    };
    if (!find_comparison(check.left))
      return false;
    if (!find_comparison(check.right))
      return false;
    if (null_cmp && undefined_cmp && null_cmp !== undefined_cmp) {
      return true;
    }
  }
  return false;
}
function safe_to_flatten(value, compressor) {
  if (value instanceof AST_SymbolRef) {
    value = value.fixed_value();
  }
  if (!value)
    return false;
  if (!(value instanceof AST_Lambda || value instanceof AST_Class))
    return true;
  if (!(value instanceof AST_Lambda && value.contains_this()))
    return true;
  return compressor.parent() instanceof AST_New;
}
function literals_in_boolean_context(self2, compressor) {
  if (compressor.in_boolean_context()) {
    return best_of(compressor, self2, make_sequence(self2, [
      self2,
      make_node(AST_True, self2)
    ]).optimize(compressor));
  }
  return self2;
}
function inline_array_like_spread(elements) {
  for (var i2 = 0;i2 < elements.length; i2++) {
    var el = elements[i2];
    if (el instanceof AST_Expansion) {
      var expr = el.expression;
      if (expr instanceof AST_Array && !expr.elements.some((elm) => elm instanceof AST_Hole)) {
        elements.splice(i2, 1, ...expr.elements);
        i2--;
      }
    }
  }
}
function inline_object_prop_spread(props) {
  for (var i2 = 0;i2 < props.length; i2++) {
    var prop = props[i2];
    if (prop instanceof AST_Expansion) {
      const expr = prop.expression;
      if (expr instanceof AST_Object && expr.properties.every((prop2) => prop2 instanceof AST_ObjectKeyVal)) {
        props.splice(i2, 1, ...expr.properties);
        i2--;
      } else if ((expr instanceof AST_Constant || expr.is_constant()) && !(expr instanceof AST_String)) {
        props.splice(i2, 1);
        i2--;
      }
    }
  }
}
function lift_key(self2, compressor) {
  if (!compressor.option("computed_props"))
    return self2;
  if (!(self2.key instanceof AST_Constant))
    return self2;
  if (self2.key instanceof AST_String || self2.key instanceof AST_Number) {
    const key = self2.key.value.toString();
    if (key === "__proto__")
      return self2;
    if (key == "constructor" && compressor.parent() instanceof AST_Class)
      return self2;
    if (self2 instanceof AST_ObjectKeyVal) {
      self2.quote = self2.key.quote;
      self2.key = key;
    } else if (self2 instanceof AST_ClassProperty) {
      self2.quote = self2.key.quote;
      self2.key = make_node(AST_SymbolClassProperty, self2.key, {
        name: key
      });
    } else {
      self2.quote = self2.key.quote;
      self2.key = make_node(AST_SymbolMethod, self2.key, {
        name: key
      });
    }
  }
  return self2;
}
var Compressor;
var global_names;
var directives;
var commutativeOperators;
var ASSIGN_OPS;
var ASSIGN_OPS_COMMUTATIVE;
var init_compress = __esm2(() => {
  init_ast();
  init_utils5();
  init_first_in_statement();
  init_equivalent_to();
  init_parse2();
  init_output();
  init_scope();
  init_size();
  init_evaluate();
  init_drop_side_effect_free();
  init_drop_unused();
  init_reduce_vars();
  init_inference();
  init_compressor_flags();
  init_common();
  init_tighten_body();
  init_inline();
  init_global_defs();
  Compressor = class Compressor2 extends TreeWalker {
    constructor(options3, { false_by_default = false, mangle_options: mangle_options2 = false }) {
      super();
      if (options3.defaults !== undefined && !options3.defaults)
        false_by_default = true;
      this.options = defaults2(options3, {
        arguments: false,
        arrows: !false_by_default,
        booleans: !false_by_default,
        booleans_as_integers: false,
        collapse_vars: !false_by_default,
        comparisons: !false_by_default,
        computed_props: !false_by_default,
        conditionals: !false_by_default,
        dead_code: !false_by_default,
        defaults: true,
        directives: !false_by_default,
        drop_console: false,
        drop_debugger: !false_by_default,
        ecma: 5,
        evaluate: !false_by_default,
        expression: false,
        global_defs: false,
        hoist_funs: false,
        hoist_props: !false_by_default,
        hoist_vars: false,
        ie8: false,
        if_return: !false_by_default,
        inline: !false_by_default,
        join_vars: !false_by_default,
        keep_classnames: false,
        keep_fargs: true,
        keep_fnames: false,
        keep_infinity: false,
        lhs_constants: !false_by_default,
        loops: !false_by_default,
        module: false,
        negate_iife: !false_by_default,
        passes: 1,
        properties: !false_by_default,
        pure_getters: !false_by_default && "strict",
        pure_funcs: null,
        pure_new: false,
        reduce_funcs: !false_by_default,
        reduce_vars: !false_by_default,
        sequences: !false_by_default,
        side_effects: !false_by_default,
        switches: !false_by_default,
        top_retain: null,
        toplevel: !!(options3 && options3["top_retain"]),
        typeofs: !false_by_default,
        unsafe: false,
        unsafe_arrows: false,
        unsafe_comps: false,
        unsafe_Function: false,
        unsafe_math: false,
        unsafe_symbols: false,
        unsafe_methods: false,
        unsafe_proto: false,
        unsafe_regexp: false,
        unsafe_undefined: false,
        unused: !false_by_default,
        warnings: false
      }, true);
      var global_defs = this.options["global_defs"];
      if (typeof global_defs == "object")
        for (var key in global_defs) {
          if (key[0] === "@" && HOP(global_defs, key)) {
            global_defs[key.slice(1)] = parse5(global_defs[key], {
              expression: true
            });
          }
        }
      if (this.options["inline"] === true)
        this.options["inline"] = 3;
      var pure_funcs = this.options["pure_funcs"];
      if (typeof pure_funcs == "function") {
        this.pure_funcs = pure_funcs;
      } else {
        this.pure_funcs = pure_funcs ? function(node) {
          return !pure_funcs.includes(node.expression.print_to_string());
        } : return_true;
      }
      var top_retain = this.options["top_retain"];
      if (top_retain instanceof RegExp) {
        this.top_retain = function(def) {
          return top_retain.test(def.name);
        };
      } else if (typeof top_retain == "function") {
        this.top_retain = top_retain;
      } else if (top_retain) {
        if (typeof top_retain == "string") {
          top_retain = top_retain.split(/,/);
        }
        this.top_retain = function(def) {
          return top_retain.includes(def.name);
        };
      }
      if (this.options["module"]) {
        this.directives["use strict"] = true;
        this.options["toplevel"] = true;
      }
      var toplevel = this.options["toplevel"];
      this.toplevel = typeof toplevel == "string" ? {
        funcs: /funcs/.test(toplevel),
        vars: /vars/.test(toplevel)
      } : {
        funcs: toplevel,
        vars: toplevel
      };
      var sequences = this.options["sequences"];
      this.sequences_limit = sequences == 1 ? 800 : sequences | 0;
      this.evaluated_regexps = new Map;
      this._toplevel = undefined;
      this._mangle_options = mangle_options2 ? format_mangler_options(mangle_options2) : mangle_options2;
    }
    mangle_options() {
      var nth_identifier = this._mangle_options && this._mangle_options.nth_identifier || base54;
      var module = this._mangle_options && this._mangle_options.module || this.option("module");
      return { ie8: this.option("ie8"), nth_identifier, module };
    }
    option(key) {
      return this.options[key];
    }
    exposed(def) {
      if (def.export)
        return true;
      if (def.global) {
        for (var i2 = 0, len = def.orig.length;i2 < len; i2++)
          if (!this.toplevel[def.orig[i2] instanceof AST_SymbolDefun ? "funcs" : "vars"])
            return true;
      }
      return false;
    }
    in_boolean_context() {
      if (!this.option("booleans"))
        return false;
      var self2 = this.self();
      for (var i2 = 0, p32;p32 = this.parent(i2); i2++) {
        if (p32 instanceof AST_SimpleStatement || p32 instanceof AST_Conditional && p32.condition === self2 || p32 instanceof AST_DWLoop && p32.condition === self2 || p32 instanceof AST_For && p32.condition === self2 || p32 instanceof AST_If && p32.condition === self2 || p32 instanceof AST_UnaryPrefix && p32.operator == "!" && p32.expression === self2) {
          return true;
        }
        if (p32 instanceof AST_Binary && (p32.operator == "&&" || p32.operator == "||" || p32.operator == "??") || p32 instanceof AST_Conditional || p32.tail_node() === self2) {
          self2 = p32;
        } else {
          return false;
        }
      }
    }
    in_32_bit_context() {
      if (!this.option("evaluate"))
        return false;
      var self2 = this.self();
      for (var i2 = 0, p32;p32 = this.parent(i2); i2++) {
        if (p32 instanceof AST_Binary && bitwise_binop.has(p32.operator)) {
          return true;
        }
        if (p32 instanceof AST_UnaryPrefix) {
          return p32.operator === "~";
        }
        if (p32 instanceof AST_Binary && (p32.operator == "&&" || p32.operator == "||" || p32.operator == "??") || p32 instanceof AST_Conditional && p32.condition !== self2 || p32.tail_node() === self2) {
          self2 = p32;
        } else {
          return false;
        }
      }
    }
    in_computed_key() {
      if (!this.option("evaluate"))
        return false;
      var self2 = this.self();
      for (var i2 = 0, p32;p32 = this.parent(i2); i2++) {
        if (p32 instanceof AST_ObjectProperty && p32.key === self2) {
          return true;
        }
      }
      return false;
    }
    get_toplevel() {
      return this._toplevel;
    }
    compress(toplevel) {
      toplevel = toplevel.resolve_defines(this);
      this._toplevel = toplevel;
      if (this.option("expression")) {
        this._toplevel.process_expression(true);
      }
      var passes = +this.options.passes || 1;
      var min_count = Infinity;
      var stopping = false;
      var mangle = this.mangle_options();
      for (var pass = 0;pass < passes; pass++) {
        this._toplevel.figure_out_scope(mangle);
        if (pass === 0 && this.option("drop_console")) {
          this._toplevel = this._toplevel.drop_console(this.option("drop_console"));
        }
        if (pass > 0 || this.option("reduce_vars")) {
          this._toplevel.reset_opt_flags(this);
        }
        this._toplevel = this._toplevel.transform(this);
        if (passes > 1) {
          let count = 0;
          walk2(this._toplevel, () => {
            count++;
          });
          if (count < min_count) {
            min_count = count;
            stopping = false;
          } else if (stopping) {
            break;
          } else {
            stopping = true;
          }
        }
      }
      if (this.option("expression")) {
        this._toplevel.process_expression(false);
      }
      toplevel = this._toplevel;
      this._toplevel = undefined;
      return toplevel;
    }
    before(node, descend) {
      if (has_flag(node, SQUEEZED))
        return node;
      var was_scope = false;
      if (node instanceof AST_Scope) {
        node = node.hoist_properties(this);
        node = node.hoist_declarations(this);
        was_scope = true;
      }
      descend(node, this);
      descend(node, this);
      var opt = node.optimize(this);
      if (was_scope && opt instanceof AST_Scope) {
        opt.drop_unused(this);
        descend(opt, this);
      }
      if (opt === node)
        set_flag(opt, SQUEEZED);
      return opt;
    }
    is_lhs() {
      const self2 = this.stack[this.stack.length - 1];
      const parent = this.stack[this.stack.length - 2];
      return is_lhs(self2, parent);
    }
  };
  def_optimize(AST_Node, function(self2) {
    return self2;
  });
  AST_Toplevel.DEFMETHOD("drop_console", function(options3) {
    const isArray3 = Array.isArray(options3);
    const tt = new TreeTransformer(function(self2) {
      if (self2.TYPE !== "Call") {
        return;
      }
      var exp = self2.expression;
      if (!(exp instanceof AST_PropAccess)) {
        return;
      }
      if (isArray3 && !options3.includes(exp.property)) {
        return;
      }
      var name = exp.expression;
      var depth2 = 2;
      while (name.expression) {
        name = name.expression;
        depth2++;
      }
      if (is_undeclared_ref(name) && name.name == "console") {
        if (depth2 === 3 && !["call", "apply"].includes(exp.property) && is_used_in_expression(tt)) {
          exp.expression = make_empty_function(self2);
          set_flag(exp.expression, SQUEEZED);
          self2.args = [];
        } else {
          return make_node(AST_Undefined, self2);
        }
      }
    });
    return this.transform(tt);
  });
  AST_Node.DEFMETHOD("equivalent_to", function(node) {
    return equivalent_to(this, node);
  });
  AST_Scope.DEFMETHOD("process_expression", function(insert, compressor) {
    var self2 = this;
    var tt = new TreeTransformer(function(node) {
      if (insert && node instanceof AST_SimpleStatement) {
        return make_node(AST_Return, node, {
          value: node.body
        });
      }
      if (!insert && node instanceof AST_Return) {
        if (compressor) {
          var value = node.value && node.value.drop_side_effect_free(compressor, true);
          return value ? make_node(AST_SimpleStatement, node, { body: value }) : make_node(AST_EmptyStatement, node);
        }
        return make_node(AST_SimpleStatement, node, {
          body: node.value || make_node(AST_UnaryPrefix, node, {
            operator: "void",
            expression: make_node(AST_Number, node, {
              value: 0
            })
          })
        });
      }
      if (node instanceof AST_Class || node instanceof AST_Lambda && node !== self2) {
        return node;
      }
      if (node instanceof AST_Block) {
        var index = node.body.length - 1;
        if (index >= 0) {
          node.body[index] = node.body[index].transform(tt);
        }
      } else if (node instanceof AST_If) {
        node.body = node.body.transform(tt);
        if (node.alternative) {
          node.alternative = node.alternative.transform(tt);
        }
      } else if (node instanceof AST_With) {
        node.body = node.body.transform(tt);
      }
      return node;
    });
    self2.transform(tt);
  });
  AST_Toplevel.DEFMETHOD("reset_opt_flags", function(compressor) {
    const self2 = this;
    const reduce_vars = compressor.option("reduce_vars");
    const preparation = new TreeWalker(function(node, descend) {
      clear_flag(node, CLEAR_BETWEEN_PASSES);
      if (reduce_vars) {
        if (compressor.top_retain && node instanceof AST_Defun && preparation.parent() === self2) {
          set_flag(node, TOP);
        }
        return node.reduce_vars(preparation, descend, compressor);
      }
    });
    preparation.safe_ids = Object.create(null);
    preparation.in_loop = null;
    preparation.loop_ids = new Map;
    preparation.defs_to_safe_ids = new Map;
    self2.walk(preparation);
  });
  AST_Symbol.DEFMETHOD("fixed_value", function() {
    var fixed = this.thedef.fixed;
    if (!fixed || fixed instanceof AST_Node)
      return fixed;
    return fixed();
  });
  AST_SymbolRef.DEFMETHOD("is_immutable", function() {
    var orig = this.definition().orig;
    return orig.length == 1 && orig[0] instanceof AST_SymbolLambda;
  });
  global_names = makePredicate("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
  AST_SymbolRef.DEFMETHOD("is_declared", function(compressor) {
    return !this.definition().undeclared || compressor.option("unsafe") && global_names.has(this.name);
  });
  directives = new Set(["use asm", "use strict"]);
  def_optimize(AST_Directive, function(self2, compressor) {
    if (compressor.option("directives") && (!directives.has(self2.value) || compressor.has_directive(self2.value) !== self2)) {
      return make_node(AST_EmptyStatement, self2);
    }
    return self2;
  });
  def_optimize(AST_Debugger, function(self2, compressor) {
    if (compressor.option("drop_debugger"))
      return make_node(AST_EmptyStatement, self2);
    return self2;
  });
  def_optimize(AST_LabeledStatement, function(self2, compressor) {
    if (self2.body instanceof AST_Break && compressor.loopcontrol_target(self2.body) === self2.body) {
      return make_node(AST_EmptyStatement, self2);
    }
    return self2.label.references.length == 0 ? self2.body : self2;
  });
  def_optimize(AST_Block, function(self2, compressor) {
    tighten_body(self2.body, compressor);
    return self2;
  });
  def_optimize(AST_BlockStatement, function(self2, compressor) {
    tighten_body(self2.body, compressor);
    switch (self2.body.length) {
      case 1:
        if (!compressor.has_directive("use strict") && compressor.parent() instanceof AST_If && can_be_extracted_from_if_block(self2.body[0]) || can_be_evicted_from_block(self2.body[0])) {
          return self2.body[0];
        }
        break;
      case 0:
        return make_node(AST_EmptyStatement, self2);
    }
    return self2;
  });
  def_optimize(AST_Lambda, opt_AST_Lambda);
  AST_Scope.DEFMETHOD("hoist_declarations", function(compressor) {
    var self2 = this;
    if (compressor.has_directive("use asm"))
      return self2;
    var hoist_funs = compressor.option("hoist_funs");
    var hoist_vars = compressor.option("hoist_vars");
    if (hoist_funs || hoist_vars) {
      var dirs = [];
      var hoisted = [];
      var vars = new Map, vars_found = 0, var_decl = 0;
      walk2(self2, (node) => {
        if (node instanceof AST_Scope && node !== self2)
          return true;
        if (node instanceof AST_Var) {
          ++var_decl;
          return true;
        }
      });
      hoist_vars = hoist_vars && var_decl > 1;
      var tt = new TreeTransformer(function before(node) {
        if (node !== self2) {
          if (node instanceof AST_Directive) {
            dirs.push(node);
            return make_node(AST_EmptyStatement, node);
          }
          if (hoist_funs && node instanceof AST_Defun && !(tt.parent() instanceof AST_Export) && tt.parent() === self2) {
            hoisted.push(node);
            return make_node(AST_EmptyStatement, node);
          }
          if (hoist_vars && node instanceof AST_Var && !node.definitions.some((def3) => def3.name instanceof AST_Destructuring)) {
            node.definitions.forEach(function(def3) {
              vars.set(def3.name.name, def3);
              ++vars_found;
            });
            var seq = node.to_assignments(compressor);
            var p32 = tt.parent();
            if (p32 instanceof AST_ForIn && p32.init === node) {
              if (seq == null) {
                var def2 = node.definitions[0].name;
                return make_node(AST_SymbolRef, def2, def2);
              }
              return seq;
            }
            if (p32 instanceof AST_For && p32.init === node) {
              return seq;
            }
            if (!seq)
              return make_node(AST_EmptyStatement, node);
            return make_node(AST_SimpleStatement, node, {
              body: seq
            });
          }
          if (node instanceof AST_Scope)
            return node;
        }
      });
      self2 = self2.transform(tt);
      if (vars_found > 0) {
        var defs = [];
        const is_lambda = self2 instanceof AST_Lambda;
        const args_as_names = is_lambda ? self2.args_as_names() : null;
        vars.forEach((def2, name) => {
          if (is_lambda && args_as_names.some((x) => x.name === def2.name.name)) {
            vars.delete(name);
          } else {
            def2 = def2.clone();
            def2.value = null;
            defs.push(def2);
            vars.set(name, def2);
          }
        });
        if (defs.length > 0) {
          for (var i2 = 0;i2 < self2.body.length; ) {
            if (self2.body[i2] instanceof AST_SimpleStatement) {
              var expr = self2.body[i2].body, sym, assign;
              if (expr instanceof AST_Assign && expr.operator == "=" && (sym = expr.left) instanceof AST_Symbol && vars.has(sym.name)) {
                var def = vars.get(sym.name);
                if (def.value)
                  break;
                def.value = expr.right;
                remove(defs, def);
                defs.push(def);
                self2.body.splice(i2, 1);
                continue;
              }
              if (expr instanceof AST_Sequence && (assign = expr.expressions[0]) instanceof AST_Assign && assign.operator == "=" && (sym = assign.left) instanceof AST_Symbol && vars.has(sym.name)) {
                var def = vars.get(sym.name);
                if (def.value)
                  break;
                def.value = assign.right;
                remove(defs, def);
                defs.push(def);
                self2.body[i2].body = make_sequence(expr, expr.expressions.slice(1));
                continue;
              }
            }
            if (self2.body[i2] instanceof AST_EmptyStatement) {
              self2.body.splice(i2, 1);
              continue;
            }
            if (self2.body[i2] instanceof AST_BlockStatement) {
              self2.body.splice(i2, 1, ...self2.body[i2].body);
              continue;
            }
            break;
          }
          defs = make_node(AST_Var, self2, {
            definitions: defs
          });
          hoisted.push(defs);
        }
      }
      self2.body = dirs.concat(hoisted, self2.body);
    }
    return self2;
  });
  AST_Scope.DEFMETHOD("hoist_properties", function(compressor) {
    var self2 = this;
    if (!compressor.option("hoist_props") || compressor.has_directive("use asm"))
      return self2;
    var top_retain = self2 instanceof AST_Toplevel && compressor.top_retain || return_false;
    var defs_by_id = new Map;
    var hoister = new TreeTransformer(function(node, descend) {
      if (node instanceof AST_VarDef) {
        const sym = node.name;
        let def;
        let value;
        if (sym.scope === self2 && (def = sym.definition()).escaped != 1 && !def.assignments && !def.direct_access && !def.single_use && !compressor.exposed(def) && !top_retain(def) && (value = sym.fixed_value()) === node.value && value instanceof AST_Object && !value.properties.some((prop) => prop instanceof AST_Expansion || prop.computed_key())) {
          descend(node, this);
          const defs = new Map;
          const assignments = [];
          value.properties.forEach(({ key, value: value2 }) => {
            const scope = hoister.find_scope();
            const symbol22 = self2.create_symbol(sym.CTOR, {
              source: sym,
              scope,
              conflict_scopes: new Set([
                scope,
                ...sym.definition().references.map((ref2) => ref2.scope)
              ]),
              tentative_name: sym.name + "_" + key
            });
            defs.set(String(key), symbol22.definition());
            assignments.push(make_node(AST_VarDef, node, {
              name: symbol22,
              value: value2
            }));
          });
          defs_by_id.set(def.id, defs);
          return MAP.splice(assignments);
        }
      } else if (node instanceof AST_PropAccess && node.expression instanceof AST_SymbolRef) {
        const defs = defs_by_id.get(node.expression.definition().id);
        if (defs) {
          const def = defs.get(String(get_simple_key(node.property)));
          const sym = make_node(AST_SymbolRef, node, {
            name: def.name,
            scope: node.expression.scope,
            thedef: def
          });
          sym.reference({});
          return sym;
        }
      }
    });
    return self2.transform(hoister);
  });
  def_optimize(AST_SimpleStatement, function(self2, compressor) {
    if (compressor.option("side_effects")) {
      var body = self2.body;
      var node = body.drop_side_effect_free(compressor, true);
      if (!node) {
        return make_node(AST_EmptyStatement, self2);
      }
      if (node !== body) {
        return make_node(AST_SimpleStatement, self2, { body: node });
      }
    }
    return self2;
  });
  def_optimize(AST_While, function(self2, compressor) {
    return compressor.option("loops") ? make_node(AST_For, self2, self2).optimize(compressor) : self2;
  });
  def_optimize(AST_Do, function(self2, compressor) {
    if (!compressor.option("loops"))
      return self2;
    var cond = self2.condition.tail_node().evaluate(compressor);
    if (!(cond instanceof AST_Node)) {
      if (cond)
        return make_node(AST_For, self2, {
          body: make_node(AST_BlockStatement, self2.body, {
            body: [
              self2.body,
              make_node(AST_SimpleStatement, self2.condition, {
                body: self2.condition
              })
            ]
          })
        }).optimize(compressor);
      if (!has_break_or_continue(self2, compressor.parent())) {
        return make_node(AST_BlockStatement, self2.body, {
          body: [
            self2.body,
            make_node(AST_SimpleStatement, self2.condition, {
              body: self2.condition
            })
          ]
        }).optimize(compressor);
      }
    }
    return self2;
  });
  def_optimize(AST_For, function(self2, compressor) {
    if (!compressor.option("loops"))
      return self2;
    if (compressor.option("side_effects") && self2.init) {
      self2.init = self2.init.drop_side_effect_free(compressor);
    }
    if (self2.condition) {
      var cond = self2.condition.evaluate(compressor);
      if (!(cond instanceof AST_Node)) {
        if (cond)
          self2.condition = null;
        else if (!compressor.option("dead_code")) {
          var orig = self2.condition;
          self2.condition = make_node_from_constant(cond, self2.condition);
          self2.condition = best_of_expression(self2.condition.transform(compressor), orig);
        }
      }
      if (compressor.option("dead_code")) {
        if (cond instanceof AST_Node)
          cond = self2.condition.tail_node().evaluate(compressor);
        if (!cond) {
          var body = [];
          trim_unreachable_code(compressor, self2.body, body);
          if (self2.init instanceof AST_Statement) {
            body.push(self2.init);
          } else if (self2.init) {
            body.push(make_node(AST_SimpleStatement, self2.init, {
              body: self2.init
            }));
          }
          body.push(make_node(AST_SimpleStatement, self2.condition, {
            body: self2.condition
          }));
          return make_node(AST_BlockStatement, self2, { body }).optimize(compressor);
        }
      }
    }
    return if_break_in_loop(self2, compressor);
  });
  def_optimize(AST_If, function(self2, compressor) {
    if (is_empty(self2.alternative))
      self2.alternative = null;
    if (!compressor.option("conditionals"))
      return self2;
    var cond = self2.condition.evaluate(compressor);
    if (!compressor.option("dead_code") && !(cond instanceof AST_Node)) {
      var orig = self2.condition;
      self2.condition = make_node_from_constant(cond, orig);
      self2.condition = best_of_expression(self2.condition.transform(compressor), orig);
    }
    if (compressor.option("dead_code")) {
      if (cond instanceof AST_Node)
        cond = self2.condition.tail_node().evaluate(compressor);
      if (!cond) {
        var body = [];
        trim_unreachable_code(compressor, self2.body, body);
        body.push(make_node(AST_SimpleStatement, self2.condition, {
          body: self2.condition
        }));
        if (self2.alternative)
          body.push(self2.alternative);
        return make_node(AST_BlockStatement, self2, { body }).optimize(compressor);
      } else if (!(cond instanceof AST_Node)) {
        var body = [];
        body.push(make_node(AST_SimpleStatement, self2.condition, {
          body: self2.condition
        }));
        body.push(self2.body);
        if (self2.alternative) {
          trim_unreachable_code(compressor, self2.alternative, body);
        }
        return make_node(AST_BlockStatement, self2, { body }).optimize(compressor);
      }
    }
    var negated = self2.condition.negate(compressor);
    var self_condition_length = self2.condition.size();
    var negated_length = negated.size();
    var negated_is_best = negated_length < self_condition_length;
    if (self2.alternative && negated_is_best) {
      negated_is_best = false;
      self2.condition = negated;
      var tmp = self2.body;
      self2.body = self2.alternative || make_node(AST_EmptyStatement, self2);
      self2.alternative = tmp;
    }
    if (is_empty(self2.body) && is_empty(self2.alternative)) {
      return make_node(AST_SimpleStatement, self2.condition, {
        body: self2.condition.clone()
      }).optimize(compressor);
    }
    if (self2.body instanceof AST_SimpleStatement && self2.alternative instanceof AST_SimpleStatement) {
      return make_node(AST_SimpleStatement, self2, {
        body: make_node(AST_Conditional, self2, {
          condition: self2.condition,
          consequent: self2.body.body,
          alternative: self2.alternative.body
        })
      }).optimize(compressor);
    }
    if (is_empty(self2.alternative) && self2.body instanceof AST_SimpleStatement) {
      if (self_condition_length === negated_length && !negated_is_best && self2.condition instanceof AST_Binary && self2.condition.operator == "||") {
        negated_is_best = true;
      }
      if (negated_is_best)
        return make_node(AST_SimpleStatement, self2, {
          body: make_node(AST_Binary, self2, {
            operator: "||",
            left: negated,
            right: self2.body.body
          })
        }).optimize(compressor);
      return make_node(AST_SimpleStatement, self2, {
        body: make_node(AST_Binary, self2, {
          operator: "&&",
          left: self2.condition,
          right: self2.body.body
        })
      }).optimize(compressor);
    }
    if (self2.body instanceof AST_EmptyStatement && self2.alternative instanceof AST_SimpleStatement) {
      return make_node(AST_SimpleStatement, self2, {
        body: make_node(AST_Binary, self2, {
          operator: "||",
          left: self2.condition,
          right: self2.alternative.body
        })
      }).optimize(compressor);
    }
    if (self2.body instanceof AST_Exit && self2.alternative instanceof AST_Exit && self2.body.TYPE == self2.alternative.TYPE) {
      return make_node(self2.body.CTOR, self2, {
        value: make_node(AST_Conditional, self2, {
          condition: self2.condition,
          consequent: self2.body.value || make_node(AST_Undefined, self2.body),
          alternative: self2.alternative.value || make_node(AST_Undefined, self2.alternative)
        }).transform(compressor)
      }).optimize(compressor);
    }
    if (self2.body instanceof AST_If && !self2.body.alternative && !self2.alternative) {
      self2 = make_node(AST_If, self2, {
        condition: make_node(AST_Binary, self2.condition, {
          operator: "&&",
          left: self2.condition,
          right: self2.body.condition
        }),
        body: self2.body.body,
        alternative: null
      });
    }
    if (aborts(self2.body)) {
      if (self2.alternative) {
        var alt = self2.alternative;
        self2.alternative = null;
        return make_node(AST_BlockStatement, self2, {
          body: [self2, alt]
        }).optimize(compressor);
      }
    }
    if (aborts(self2.alternative)) {
      var body = self2.body;
      self2.body = self2.alternative;
      self2.condition = negated_is_best ? negated : self2.condition.negate(compressor);
      self2.alternative = null;
      return make_node(AST_BlockStatement, self2, {
        body: [self2, body]
      }).optimize(compressor);
    }
    return self2;
  });
  def_optimize(AST_Switch, function(self2, compressor) {
    if (!compressor.option("switches"))
      return self2;
    var branch;
    var value = self2.expression.evaluate(compressor);
    if (!(value instanceof AST_Node)) {
      var orig = self2.expression;
      self2.expression = make_node_from_constant(value, orig);
      self2.expression = best_of_expression(self2.expression.transform(compressor), orig);
    }
    if (!compressor.option("dead_code"))
      return self2;
    if (value instanceof AST_Node) {
      value = self2.expression.tail_node().evaluate(compressor);
    }
    var decl = [];
    var body = [];
    var default_branch;
    var exact_match;
    for (var i2 = 0, len = self2.body.length;i2 < len && !exact_match; i2++) {
      branch = self2.body[i2];
      if (branch instanceof AST_Default) {
        if (!default_branch) {
          default_branch = branch;
        } else {
          eliminate_branch(branch, body[body.length - 1]);
        }
      } else if (!(value instanceof AST_Node)) {
        var exp = branch.expression.evaluate(compressor);
        if (!(exp instanceof AST_Node) && exp !== value) {
          eliminate_branch(branch, body[body.length - 1]);
          continue;
        }
        if (exp instanceof AST_Node && !exp.has_side_effects(compressor)) {
          exp = branch.expression.tail_node().evaluate(compressor);
        }
        if (exp === value) {
          exact_match = branch;
          if (default_branch) {
            var default_index = body.indexOf(default_branch);
            body.splice(default_index, 1);
            eliminate_branch(default_branch, body[default_index - 1]);
            default_branch = null;
          }
        }
      }
      body.push(branch);
    }
    while (i2 < len)
      eliminate_branch(self2.body[i2++], body[body.length - 1]);
    self2.body = body;
    let default_or_exact = default_branch || exact_match;
    default_branch = null;
    exact_match = null;
    if (body.every((branch2, i22) => (branch2 === default_or_exact || branch2.expression instanceof AST_Constant) && (branch2.body.length === 0 || aborts(branch2) || body.length - 1 === i22))) {
      for (let i22 = 0;i22 < body.length; i22++) {
        const branch2 = body[i22];
        for (let j22 = i22 + 1;j22 < body.length; j22++) {
          const next = body[j22];
          if (next.body.length === 0)
            continue;
          const last_branch = j22 === body.length - 1;
          const equivalentBranch = branches_equivalent(next, branch2, false);
          if (equivalentBranch || last_branch && branches_equivalent(next, branch2, true)) {
            if (!equivalentBranch && last_branch) {
              next.body.push(make_node(AST_Break));
            }
            let x = j22 - 1;
            let fallthroughDepth = 0;
            while (x > i22) {
              if (is_inert_body(body[x--])) {
                fallthroughDepth++;
              } else {
                break;
              }
            }
            const plucked = body.splice(j22 - fallthroughDepth, 1 + fallthroughDepth);
            body.splice(i22 + 1, 0, ...plucked);
            i22 += plucked.length;
          }
        }
      }
    }
    for (let i22 = 0;i22 < body.length; i22++) {
      let branch2 = body[i22];
      if (branch2.body.length === 0)
        continue;
      if (!aborts(branch2))
        continue;
      for (let j22 = i22 + 1;j22 < body.length; i22++, j22++) {
        let next = body[j22];
        if (next.body.length === 0)
          continue;
        if (branches_equivalent(next, branch2, false) || j22 === body.length - 1 && branches_equivalent(next, branch2, true)) {
          branch2.body = [];
          branch2 = next;
          continue;
        }
        break;
      }
    }
    {
      let i22 = body.length - 1;
      for (;i22 >= 0; i22--) {
        let bbody = body[i22].body;
        if (is_break(bbody[bbody.length - 1], compressor))
          bbody.pop();
        if (!is_inert_body(body[i22]))
          break;
      }
      i22++;
      if (!default_or_exact || body.indexOf(default_or_exact) >= i22) {
        for (let j22 = body.length - 1;j22 >= i22; j22--) {
          let branch2 = body[j22];
          if (branch2 === default_or_exact) {
            default_or_exact = null;
            body.pop();
          } else if (!branch2.expression.has_side_effects(compressor)) {
            body.pop();
          } else {
            break;
          }
        }
      }
    }
    DEFAULT:
      if (default_or_exact) {
        let default_index2 = body.indexOf(default_or_exact);
        let default_body_index = default_index2;
        for (;default_body_index < body.length - 1; default_body_index++) {
          if (!is_inert_body(body[default_body_index]))
            break;
        }
        if (default_body_index < body.length - 1) {
          break DEFAULT;
        }
        let side_effect_index = body.length - 1;
        for (;side_effect_index >= 0; side_effect_index--) {
          let branch2 = body[side_effect_index];
          if (branch2 === default_or_exact)
            continue;
          if (branch2.expression.has_side_effects(compressor))
            break;
        }
        if (default_body_index > side_effect_index) {
          let prev_body_index = default_index2 - 1;
          for (;prev_body_index >= 0; prev_body_index--) {
            if (!is_inert_body(body[prev_body_index]))
              break;
          }
          let before = Math.max(side_effect_index, prev_body_index) + 1;
          let after = default_index2;
          if (side_effect_index > default_index2) {
            after = side_effect_index;
            body[side_effect_index].body = body[default_body_index].body;
          } else {
            default_or_exact.body = body[default_body_index].body;
          }
          body.splice(after + 1, default_body_index - after);
          body.splice(before, default_index2 - before);
        }
      }
    DEFAULT:
      if (default_or_exact) {
        let i22 = body.findIndex((branch2) => !is_inert_body(branch2));
        let caseBody;
        if (i22 === body.length - 1) {
          let branch2 = body[i22];
          if (has_nested_break(self2))
            break DEFAULT;
          caseBody = make_node(AST_BlockStatement, branch2, {
            body: branch2.body
          });
          branch2.body = [];
        } else if (i22 !== -1) {
          break DEFAULT;
        }
        let sideEffect = body.find((branch2) => branch2 !== default_or_exact && branch2.expression.has_side_effects(compressor));
        if (!sideEffect) {
          return make_node(AST_BlockStatement, self2, {
            body: decl.concat(statement(self2.expression), default_or_exact.expression ? statement(default_or_exact.expression) : [], caseBody || [])
          }).optimize(compressor);
        }
        const default_index2 = body.indexOf(default_or_exact);
        body.splice(default_index2, 1);
        default_or_exact = null;
        if (caseBody) {
          return make_node(AST_BlockStatement, self2, {
            body: decl.concat(self2, caseBody)
          }).optimize(compressor);
        }
      }
    if (body.length > 0) {
      body[0].body = decl.concat(body[0].body);
    }
    if (body.length == 0) {
      return make_node(AST_BlockStatement, self2, {
        body: decl.concat(statement(self2.expression))
      }).optimize(compressor);
    }
    if (body.length == 1 && !has_nested_break(self2)) {
      let branch2 = body[0];
      return make_node(AST_If, self2, {
        condition: make_node(AST_Binary, self2, {
          operator: "===",
          left: self2.expression,
          right: branch2.expression
        }),
        body: make_node(AST_BlockStatement, branch2, {
          body: branch2.body
        }),
        alternative: null
      }).optimize(compressor);
    }
    if (body.length === 2 && default_or_exact && !has_nested_break(self2)) {
      let branch2 = body[0] === default_or_exact ? body[1] : body[0];
      let exact_exp = default_or_exact.expression && statement(default_or_exact.expression);
      if (aborts(body[0])) {
        let first = body[0];
        if (is_break(first.body[first.body.length - 1], compressor)) {
          first.body.pop();
        }
        return make_node(AST_If, self2, {
          condition: make_node(AST_Binary, self2, {
            operator: "===",
            left: self2.expression,
            right: branch2.expression
          }),
          body: make_node(AST_BlockStatement, branch2, {
            body: branch2.body
          }),
          alternative: make_node(AST_BlockStatement, default_or_exact, {
            body: [].concat(exact_exp || [], default_or_exact.body)
          })
        }).optimize(compressor);
      }
      let operator = "===";
      let consequent = make_node(AST_BlockStatement, branch2, {
        body: branch2.body
      });
      let always = make_node(AST_BlockStatement, default_or_exact, {
        body: [].concat(exact_exp || [], default_or_exact.body)
      });
      if (body[0] === default_or_exact) {
        operator = "!==";
        let tmp = always;
        always = consequent;
        consequent = tmp;
      }
      return make_node(AST_BlockStatement, self2, {
        body: [
          make_node(AST_If, self2, {
            condition: make_node(AST_Binary, self2, {
              operator,
              left: self2.expression,
              right: branch2.expression
            }),
            body: consequent,
            alternative: null
          }),
          always
        ]
      }).optimize(compressor);
    }
    return self2;
    function eliminate_branch(branch2, prev) {
      if (prev && !aborts(prev)) {
        prev.body = prev.body.concat(branch2.body);
      } else {
        trim_unreachable_code(compressor, branch2, decl);
      }
    }
    function branches_equivalent(branch2, prev, insertBreak) {
      let bbody = branch2.body;
      let pbody = prev.body;
      if (insertBreak) {
        bbody = bbody.concat(make_node(AST_Break));
      }
      if (bbody.length !== pbody.length)
        return false;
      let bblock = make_node(AST_BlockStatement, branch2, { body: bbody });
      let pblock = make_node(AST_BlockStatement, prev, { body: pbody });
      return bblock.equivalent_to(pblock);
    }
    function statement(body2) {
      return make_node(AST_SimpleStatement, body2, { body: body2 });
    }
    function has_nested_break(root) {
      let has_break = false;
      let tw = new TreeWalker((node) => {
        if (has_break)
          return true;
        if (node instanceof AST_Lambda)
          return true;
        if (node instanceof AST_SimpleStatement)
          return true;
        if (!is_break(node, tw))
          return;
        let parent = tw.parent();
        if (parent instanceof AST_SwitchBranch && parent.body[parent.body.length - 1] === node) {
          return;
        }
        has_break = true;
      });
      root.walk(tw);
      return has_break;
    }
    function is_break(node, stack) {
      return node instanceof AST_Break && stack.loopcontrol_target(node) === self2;
    }
    function is_inert_body(branch2) {
      return !aborts(branch2) && !make_node(AST_BlockStatement, branch2, {
        body: branch2.body
      }).has_side_effects(compressor);
    }
  });
  def_optimize(AST_Try, function(self2, compressor) {
    if (self2.bcatch && self2.bfinally && self2.bfinally.body.every(is_empty))
      self2.bfinally = null;
    if (compressor.option("dead_code") && self2.body.body.every(is_empty)) {
      var body = [];
      if (self2.bcatch) {
        trim_unreachable_code(compressor, self2.bcatch, body);
      }
      if (self2.bfinally)
        body.push(...self2.bfinally.body);
      return make_node(AST_BlockStatement, self2, {
        body
      }).optimize(compressor);
    }
    return self2;
  });
  AST_Definitions.DEFMETHOD("to_assignments", function(compressor) {
    var reduce_vars = compressor.option("reduce_vars");
    var assignments = [];
    for (const def of this.definitions) {
      if (def.value) {
        var name = make_node(AST_SymbolRef, def.name, def.name);
        assignments.push(make_node(AST_Assign, def, {
          operator: "=",
          logical: false,
          left: name,
          right: def.value
        }));
        if (reduce_vars)
          name.definition().fixed = false;
      }
      const thedef = def.name.definition();
      thedef.eliminated++;
      thedef.replaced--;
    }
    if (assignments.length == 0)
      return null;
    return make_sequence(this, assignments);
  });
  def_optimize(AST_Definitions, function(self2) {
    if (self2.definitions.length == 0) {
      return make_node(AST_EmptyStatement, self2);
    }
    return self2;
  });
  def_optimize(AST_VarDef, function(self2, compressor) {
    if (self2.name instanceof AST_SymbolLet && self2.value != null && is_undefined(self2.value, compressor)) {
      self2.value = null;
    }
    return self2;
  });
  def_optimize(AST_Import, function(self2) {
    return self2;
  });
  def_optimize(AST_Call, function(self2, compressor) {
    var exp = self2.expression;
    var fn = exp;
    inline_array_like_spread(self2.args);
    var simple_args = self2.args.every((arg2) => !(arg2 instanceof AST_Expansion));
    if (compressor.option("reduce_vars") && fn instanceof AST_SymbolRef) {
      fn = fn.fixed_value();
    }
    var is_func = fn instanceof AST_Lambda;
    if (is_func && fn.pinned())
      return self2;
    if (compressor.option("unused") && simple_args && is_func && !fn.uses_arguments) {
      var pos = 0, last = 0;
      for (var i2 = 0, len = self2.args.length;i2 < len; i2++) {
        if (fn.argnames[i2] instanceof AST_Expansion) {
          if (has_flag(fn.argnames[i2].expression, UNUSED))
            while (i2 < len) {
              var node = self2.args[i2++].drop_side_effect_free(compressor);
              if (node) {
                self2.args[pos++] = node;
              }
            }
          else
            while (i2 < len) {
              self2.args[pos++] = self2.args[i2++];
            }
          last = pos;
          break;
        }
        var trim2 = i2 >= fn.argnames.length;
        if (trim2 || has_flag(fn.argnames[i2], UNUSED)) {
          var node = self2.args[i2].drop_side_effect_free(compressor);
          if (node) {
            self2.args[pos++] = node;
          } else if (!trim2) {
            self2.args[pos++] = make_node(AST_Number, self2.args[i2], {
              value: 0
            });
            continue;
          }
        } else {
          self2.args[pos++] = self2.args[i2];
        }
        last = pos;
      }
      self2.args.length = last;
    }
    if (compressor.option("unsafe") && !exp.contains_optional()) {
      if (exp instanceof AST_Dot && exp.start.value === "Array" && exp.property === "from" && self2.args.length === 1) {
        const [argument] = self2.args;
        if (argument instanceof AST_Array) {
          return make_node(AST_Array, argument, {
            elements: argument.elements
          }).optimize(compressor);
        }
      }
      if (is_undeclared_ref(exp))
        switch (exp.name) {
          case "Array":
            if (self2.args.length != 1) {
              return make_node(AST_Array, self2, {
                elements: self2.args
              }).optimize(compressor);
            } else if (self2.args[0] instanceof AST_Number && self2.args[0].value <= 11) {
              const elements2 = [];
              for (let i22 = 0;i22 < self2.args[0].value; i22++)
                elements2.push(new AST_Hole);
              return new AST_Array({ elements: elements2 });
            }
            break;
          case "Object":
            if (self2.args.length == 0) {
              return make_node(AST_Object, self2, {
                properties: []
              });
            }
            break;
          case "String":
            if (self2.args.length == 0)
              return make_node(AST_String, self2, {
                value: ""
              });
            if (self2.args.length <= 1)
              return make_node(AST_Binary, self2, {
                left: self2.args[0],
                operator: "+",
                right: make_node(AST_String, self2, { value: "" })
              }).optimize(compressor);
            break;
          case "Number":
            if (self2.args.length == 0)
              return make_node(AST_Number, self2, {
                value: 0
              });
            if (self2.args.length == 1 && compressor.option("unsafe_math")) {
              return make_node(AST_UnaryPrefix, self2, {
                expression: self2.args[0],
                operator: "+"
              }).optimize(compressor);
            }
            break;
          case "Symbol":
            if (self2.args.length == 1 && self2.args[0] instanceof AST_String && compressor.option("unsafe_symbols"))
              self2.args.length = 0;
            break;
          case "Boolean":
            if (self2.args.length == 0)
              return make_node(AST_False, self2);
            if (self2.args.length == 1)
              return make_node(AST_UnaryPrefix, self2, {
                expression: make_node(AST_UnaryPrefix, self2, {
                  expression: self2.args[0],
                  operator: "!"
                }),
                operator: "!"
              }).optimize(compressor);
            break;
          case "RegExp":
            var params = [];
            if (self2.args.length >= 1 && self2.args.length <= 2 && self2.args.every((arg2) => {
              var value2 = arg2.evaluate(compressor);
              params.push(value2);
              return arg2 !== value2;
            }) && regexp_is_safe(params[0])) {
              let [source, flags] = params;
              source = regexp_source_fix(new RegExp(source).source);
              const rx = make_node(AST_RegExp, self2, {
                value: { source, flags }
              });
              if (rx._eval(compressor) !== rx) {
                return rx;
              }
            }
            break;
        }
      else if (exp instanceof AST_Dot)
        switch (exp.property) {
          case "toString":
            if (self2.args.length == 0 && !exp.expression.may_throw_on_access(compressor)) {
              return make_node(AST_Binary, self2, {
                left: make_node(AST_String, self2, { value: "" }),
                operator: "+",
                right: exp.expression
              }).optimize(compressor);
            }
            break;
          case "join":
            if (exp.expression instanceof AST_Array)
              EXIT: {
                var separator;
                if (self2.args.length > 0) {
                  separator = self2.args[0].evaluate(compressor);
                  if (separator === self2.args[0])
                    break EXIT;
                }
                var elements = [];
                var consts = [];
                for (var i2 = 0, len = exp.expression.elements.length;i2 < len; i2++) {
                  var el = exp.expression.elements[i2];
                  if (el instanceof AST_Expansion)
                    break EXIT;
                  var value = el.evaluate(compressor);
                  if (value !== el) {
                    consts.push(value);
                  } else {
                    if (consts.length > 0) {
                      elements.push(make_node(AST_String, self2, {
                        value: consts.join(separator)
                      }));
                      consts.length = 0;
                    }
                    elements.push(el);
                  }
                }
                if (consts.length > 0) {
                  elements.push(make_node(AST_String, self2, {
                    value: consts.join(separator)
                  }));
                }
                if (elements.length == 0)
                  return make_node(AST_String, self2, { value: "" });
                if (elements.length == 1) {
                  if (elements[0].is_string(compressor)) {
                    return elements[0];
                  }
                  return make_node(AST_Binary, elements[0], {
                    operator: "+",
                    left: make_node(AST_String, self2, { value: "" }),
                    right: elements[0]
                  });
                }
                if (separator == "") {
                  var first;
                  if (elements[0].is_string(compressor) || elements[1].is_string(compressor)) {
                    first = elements.shift();
                  } else {
                    first = make_node(AST_String, self2, { value: "" });
                  }
                  return elements.reduce(function(prev, el2) {
                    return make_node(AST_Binary, el2, {
                      operator: "+",
                      left: prev,
                      right: el2
                    });
                  }, first).optimize(compressor);
                }
                var node = self2.clone();
                node.expression = node.expression.clone();
                node.expression.expression = node.expression.expression.clone();
                node.expression.expression.elements = elements;
                return best_of(compressor, self2, node);
              }
            break;
          case "charAt":
            if (exp.expression.is_string(compressor)) {
              var arg = self2.args[0];
              var index = arg ? arg.evaluate(compressor) : 0;
              if (index !== arg) {
                return make_node(AST_Sub, exp, {
                  expression: exp.expression,
                  property: make_node_from_constant(index | 0, arg || exp)
                }).optimize(compressor);
              }
            }
            break;
          case "apply":
            if (self2.args.length == 2 && self2.args[1] instanceof AST_Array) {
              var args = self2.args[1].elements.slice();
              args.unshift(self2.args[0]);
              return make_node(AST_Call, self2, {
                expression: make_node(AST_Dot, exp, {
                  expression: exp.expression,
                  optional: false,
                  property: "call"
                }),
                args
              }).optimize(compressor);
            }
            break;
          case "call":
            var func = exp.expression;
            if (func instanceof AST_SymbolRef) {
              func = func.fixed_value();
            }
            if (func instanceof AST_Lambda && !func.contains_this()) {
              return (self2.args.length ? make_sequence(this, [
                self2.args[0],
                make_node(AST_Call, self2, {
                  expression: exp.expression,
                  args: self2.args.slice(1)
                })
              ]) : make_node(AST_Call, self2, {
                expression: exp.expression,
                args: []
              })).optimize(compressor);
            }
            break;
        }
    }
    if (compressor.option("unsafe_Function") && is_undeclared_ref(exp) && exp.name == "Function") {
      if (self2.args.length == 0)
        return make_empty_function(self2).optimize(compressor);
      if (self2.args.every((x) => x instanceof AST_String)) {
        try {
          var code = "n(function(" + self2.args.slice(0, -1).map(function(arg2) {
            return arg2.value;
          }).join(",") + "){" + self2.args[self2.args.length - 1].value + "})";
          var ast = parse5(code);
          var mangle = compressor.mangle_options();
          ast.figure_out_scope(mangle);
          var comp = new Compressor(compressor.options, {
            mangle_options: compressor._mangle_options
          });
          ast = ast.transform(comp);
          ast.figure_out_scope(mangle);
          ast.compute_char_frequency(mangle);
          ast.mangle_names(mangle);
          var fun;
          walk2(ast, (node2) => {
            if (is_func_expr(node2)) {
              fun = node2;
              return walk_abort;
            }
          });
          var code = OutputStream();
          AST_BlockStatement.prototype._codegen.call(fun, fun, code);
          self2.args = [
            make_node(AST_String, self2, {
              value: fun.argnames.map(function(arg2) {
                return arg2.print_to_string();
              }).join(",")
            }),
            make_node(AST_String, self2.args[self2.args.length - 1], {
              value: code.get().replace(/^{|}$/g, "")
            })
          ];
          return self2;
        } catch (ex) {
          if (!(ex instanceof JS_Parse_Error)) {
            throw ex;
          }
        }
      }
    }
    return inline_into_call(self2, compressor);
  });
  AST_Node.DEFMETHOD("contains_optional", function() {
    if (this instanceof AST_PropAccess || this instanceof AST_Call || this instanceof AST_Chain) {
      if (this.optional) {
        return true;
      } else {
        return this.expression.contains_optional();
      }
    } else {
      return false;
    }
  });
  def_optimize(AST_New, function(self2, compressor) {
    if (compressor.option("unsafe") && is_undeclared_ref(self2.expression) && ["Object", "RegExp", "Function", "Error", "Array"].includes(self2.expression.name))
      return make_node(AST_Call, self2, self2).transform(compressor);
    return self2;
  });
  def_optimize(AST_Sequence, function(self2, compressor) {
    if (!compressor.option("side_effects"))
      return self2;
    var expressions = [];
    filter_for_side_effects();
    var end = expressions.length - 1;
    trim_right_for_undefined();
    if (end == 0) {
      self2 = maintain_this_binding(compressor.parent(), compressor.self(), expressions[0]);
      if (!(self2 instanceof AST_Sequence))
        self2 = self2.optimize(compressor);
      return self2;
    }
    self2.expressions = expressions;
    return self2;
    function filter_for_side_effects() {
      var first = first_in_statement(compressor);
      var last = self2.expressions.length - 1;
      self2.expressions.forEach(function(expr, index) {
        if (index < last)
          expr = expr.drop_side_effect_free(compressor, first);
        if (expr) {
          merge_sequence(expressions, expr);
          first = false;
        }
      });
    }
    function trim_right_for_undefined() {
      while (end > 0 && is_undefined(expressions[end], compressor))
        end--;
      if (end < expressions.length - 1) {
        expressions[end] = make_node(AST_UnaryPrefix, self2, {
          operator: "void",
          expression: expressions[end]
        });
        expressions.length = end + 1;
      }
    }
  });
  AST_Unary.DEFMETHOD("lift_sequences", function(compressor) {
    if (compressor.option("sequences")) {
      if (this.expression instanceof AST_Sequence) {
        var x = this.expression.expressions.slice();
        var e = this.clone();
        e.expression = x.pop();
        x.push(e);
        return make_sequence(this, x).optimize(compressor);
      }
    }
    return this;
  });
  def_optimize(AST_UnaryPostfix, function(self2, compressor) {
    return self2.lift_sequences(compressor);
  });
  def_optimize(AST_UnaryPrefix, function(self2, compressor) {
    var e = self2.expression;
    if (self2.operator == "delete" && !(e instanceof AST_SymbolRef || e instanceof AST_PropAccess || e instanceof AST_Chain || is_identifier_atom(e))) {
      return make_sequence(self2, [e, make_node(AST_True, self2)]).optimize(compressor);
    }
    var seq = self2.lift_sequences(compressor);
    if (seq !== self2) {
      return seq;
    }
    if (compressor.option("side_effects") && self2.operator == "void") {
      e = e.drop_side_effect_free(compressor);
      if (e) {
        self2.expression = e;
        return self2;
      } else {
        return make_node(AST_Undefined, self2).optimize(compressor);
      }
    }
    if (compressor.in_boolean_context()) {
      switch (self2.operator) {
        case "!":
          if (e instanceof AST_UnaryPrefix && e.operator == "!") {
            return e.expression;
          }
          if (e instanceof AST_Binary) {
            self2 = best_of(compressor, self2, e.negate(compressor, first_in_statement(compressor)));
          }
          break;
        case "typeof":
          return (e instanceof AST_SymbolRef ? make_node(AST_True, self2) : make_sequence(self2, [
            e,
            make_node(AST_True, self2)
          ])).optimize(compressor);
      }
    }
    if (self2.operator == "-" && e instanceof AST_Infinity) {
      e = e.transform(compressor);
    }
    if (e instanceof AST_Binary && (self2.operator == "+" || self2.operator == "-") && (e.operator == "*" || e.operator == "/" || e.operator == "%")) {
      return make_node(AST_Binary, self2, {
        operator: e.operator,
        left: make_node(AST_UnaryPrefix, e.left, {
          operator: self2.operator,
          expression: e.left
        }),
        right: e.right
      });
    }
    if (compressor.option("evaluate")) {
      if (self2.operator === "~" && self2.expression instanceof AST_UnaryPrefix && self2.expression.operator === "~" && (compressor.in_32_bit_context() || self2.expression.expression.is_32_bit_integer())) {
        return self2.expression.expression;
      }
      if (self2.operator === "~" && e instanceof AST_Binary && e.operator === "^") {
        if (e.left instanceof AST_UnaryPrefix && e.left.operator === "~") {
          e.left = e.left.bitwise_negate(true);
        } else {
          e.right = e.right.bitwise_negate(true);
        }
        return e;
      }
    }
    if (self2.operator != "-" || !(e instanceof AST_Number || e instanceof AST_Infinity || e instanceof AST_BigInt)) {
      var ev = self2.evaluate(compressor);
      if (ev !== self2) {
        ev = make_node_from_constant(ev, self2).optimize(compressor);
        return best_of(compressor, ev, self2);
      }
    }
    return self2;
  });
  AST_Binary.DEFMETHOD("lift_sequences", function(compressor) {
    if (compressor.option("sequences")) {
      if (this.left instanceof AST_Sequence) {
        var x = this.left.expressions.slice();
        var e = this.clone();
        e.left = x.pop();
        x.push(e);
        return make_sequence(this, x).optimize(compressor);
      }
      if (this.right instanceof AST_Sequence && !this.left.has_side_effects(compressor)) {
        var assign = this.operator == "=" && this.left instanceof AST_SymbolRef;
        var x = this.right.expressions;
        var last = x.length - 1;
        for (var i2 = 0;i2 < last; i2++) {
          if (!assign && x[i2].has_side_effects(compressor))
            break;
        }
        if (i2 == last) {
          x = x.slice();
          var e = this.clone();
          e.right = x.pop();
          x.push(e);
          return make_sequence(this, x).optimize(compressor);
        } else if (i2 > 0) {
          var e = this.clone();
          e.right = make_sequence(this.right, x.slice(i2));
          x = x.slice(0, i2);
          x.push(e);
          return make_sequence(this, x).optimize(compressor);
        }
      }
    }
    return this;
  });
  commutativeOperators = makePredicate("== === != !== * & | ^");
  def_optimize(AST_Binary, function(self2, compressor) {
    function reversible() {
      return self2.left.is_constant() || self2.right.is_constant() || !self2.left.has_side_effects(compressor) && !self2.right.has_side_effects(compressor);
    }
    function reverse(op) {
      if (reversible()) {
        if (op)
          self2.operator = op;
        var tmp = self2.left;
        self2.left = self2.right;
        self2.right = tmp;
      }
    }
    if (compressor.option("lhs_constants") && commutativeOperators.has(self2.operator)) {
      if (self2.right.is_constant() && !self2.left.is_constant()) {
        if (!(self2.left instanceof AST_Binary && PRECEDENCE[self2.left.operator] >= PRECEDENCE[self2.operator])) {
          reverse();
        }
      }
    }
    self2 = self2.lift_sequences(compressor);
    if (compressor.option("comparisons"))
      switch (self2.operator) {
        case "===":
        case "!==":
          var is_strict_comparison = true;
          if (self2.left.is_string(compressor) && self2.right.is_string(compressor) || self2.left.is_number(compressor) && self2.right.is_number(compressor) || self2.left.is_boolean() && self2.right.is_boolean() || self2.left.equivalent_to(self2.right)) {
            self2.operator = self2.operator.substr(0, 2);
          }
        case "==":
        case "!=":
          if (!is_strict_comparison && is_undefined(self2.left, compressor)) {
            self2.left = make_node(AST_Null, self2.left);
          } else if (!is_strict_comparison && is_undefined(self2.right, compressor)) {
            self2.right = make_node(AST_Null, self2.right);
          } else if (compressor.option("typeofs") && self2.left instanceof AST_String && self2.left.value == "undefined" && self2.right instanceof AST_UnaryPrefix && self2.right.operator == "typeof") {
            var expr = self2.right.expression;
            if (expr instanceof AST_SymbolRef ? expr.is_declared(compressor) : !(expr instanceof AST_PropAccess && compressor.option("ie8"))) {
              self2.right = expr;
              self2.left = make_node(AST_Undefined, self2.left).optimize(compressor);
              if (self2.operator.length == 2)
                self2.operator += "=";
            }
          } else if (compressor.option("typeofs") && self2.left instanceof AST_UnaryPrefix && self2.left.operator == "typeof" && self2.right instanceof AST_String && self2.right.value == "undefined") {
            var expr = self2.left.expression;
            if (expr instanceof AST_SymbolRef ? expr.is_declared(compressor) : !(expr instanceof AST_PropAccess && compressor.option("ie8"))) {
              self2.left = expr;
              self2.right = make_node(AST_Undefined, self2.right).optimize(compressor);
              if (self2.operator.length == 2)
                self2.operator += "=";
            }
          } else if (self2.left instanceof AST_SymbolRef && self2.right instanceof AST_SymbolRef && self2.left.definition() === self2.right.definition() && is_object(self2.left.fixed_value())) {
            return make_node(self2.operator[0] == "=" ? AST_True : AST_False, self2);
          } else if (self2.left.is_32_bit_integer() && self2.right.is_32_bit_integer()) {
            const not = (node) => make_node(AST_UnaryPrefix, node, {
              operator: "!",
              expression: node
            });
            const booleanify = (node, truthy) => {
              if (truthy) {
                return compressor.in_boolean_context() ? node : not(not(node));
              } else {
                return not(node);
              }
            };
            if (self2.left instanceof AST_Number && self2.left.value === 0) {
              return booleanify(self2.right, self2.operator[0] === "!");
            }
            if (self2.right instanceof AST_Number && self2.right.value === 0) {
              return booleanify(self2.left, self2.operator[0] === "!");
            }
            let and_op, x, mask;
            if ((and_op = self2.left instanceof AST_Binary ? self2.left : self2.right instanceof AST_Binary ? self2.right : null) && (mask = and_op === self2.left ? self2.right : self2.left) && and_op.operator === "&" && mask instanceof AST_Number && mask.is_32_bit_integer() && (x = and_op.left.equivalent_to(mask) ? and_op.right : and_op.right.equivalent_to(mask) ? and_op.left : null)) {
              let optimized = booleanify(make_node(AST_Binary, self2, {
                operator: "&",
                left: mask,
                right: make_node(AST_UnaryPrefix, self2, {
                  operator: "~",
                  expression: x
                })
              }), self2.operator[0] === "!");
              return best_of(compressor, optimized, self2);
            }
          }
          break;
        case "&&":
        case "||":
          var lhs = self2.left;
          if (lhs.operator == self2.operator) {
            lhs = lhs.right;
          }
          if (lhs instanceof AST_Binary && lhs.operator == (self2.operator == "&&" ? "!==" : "===") && self2.right instanceof AST_Binary && lhs.operator == self2.right.operator && (is_undefined(lhs.left, compressor) && self2.right.left instanceof AST_Null || lhs.left instanceof AST_Null && is_undefined(self2.right.left, compressor)) && !lhs.right.has_side_effects(compressor) && lhs.right.equivalent_to(self2.right.right)) {
            var combined = make_node(AST_Binary, self2, {
              operator: lhs.operator.slice(0, -1),
              left: make_node(AST_Null, self2),
              right: lhs.right
            });
            if (lhs !== self2.left) {
              combined = make_node(AST_Binary, self2, {
                operator: self2.operator,
                left: self2.left.left,
                right: combined
              });
            }
            return combined;
          }
          break;
      }
    if (self2.operator == "+" && compressor.in_boolean_context()) {
      var ll = self2.left.evaluate(compressor);
      var rr = self2.right.evaluate(compressor);
      if (ll && typeof ll == "string") {
        return make_sequence(self2, [
          self2.right,
          make_node(AST_True, self2)
        ]).optimize(compressor);
      }
      if (rr && typeof rr == "string") {
        return make_sequence(self2, [
          self2.left,
          make_node(AST_True, self2)
        ]).optimize(compressor);
      }
    }
    if (compressor.option("comparisons") && self2.is_boolean()) {
      if (!(compressor.parent() instanceof AST_Binary) || compressor.parent() instanceof AST_Assign) {
        var negated = make_node(AST_UnaryPrefix, self2, {
          operator: "!",
          expression: self2.negate(compressor, first_in_statement(compressor))
        });
        self2 = best_of(compressor, self2, negated);
      }
      if (compressor.option("unsafe_comps")) {
        switch (self2.operator) {
          case "<":
            reverse(">");
            break;
          case "<=":
            reverse(">=");
            break;
        }
      }
    }
    if (self2.operator == "+") {
      if (self2.right instanceof AST_String && self2.right.getValue() == "" && self2.left.is_string(compressor)) {
        return self2.left;
      }
      if (self2.left instanceof AST_String && self2.left.getValue() == "" && self2.right.is_string(compressor)) {
        return self2.right;
      }
      if (self2.left instanceof AST_Binary && self2.left.operator == "+" && self2.left.left instanceof AST_String && self2.left.left.getValue() == "" && self2.right.is_string(compressor)) {
        self2.left = self2.left.right;
        return self2;
      }
    }
    if (compressor.option("evaluate")) {
      switch (self2.operator) {
        case "&&":
          var ll = has_flag(self2.left, TRUTHY) ? true : has_flag(self2.left, FALSY) ? false : self2.left.evaluate(compressor);
          if (!ll) {
            return maintain_this_binding(compressor.parent(), compressor.self(), self2.left).optimize(compressor);
          } else if (!(ll instanceof AST_Node)) {
            return make_sequence(self2, [self2.left, self2.right]).optimize(compressor);
          }
          var rr = self2.right.evaluate(compressor);
          if (!rr) {
            if (compressor.in_boolean_context()) {
              return make_sequence(self2, [
                self2.left,
                make_node(AST_False, self2)
              ]).optimize(compressor);
            } else {
              set_flag(self2, FALSY);
            }
          } else if (!(rr instanceof AST_Node)) {
            var parent = compressor.parent();
            if (parent.operator == "&&" && parent.left === compressor.self() || compressor.in_boolean_context()) {
              return self2.left.optimize(compressor);
            }
          }
          if (self2.left.operator == "||") {
            var lr = self2.left.right.evaluate(compressor);
            if (!lr)
              return make_node(AST_Conditional, self2, {
                condition: self2.left.left,
                consequent: self2.right,
                alternative: self2.left.right
              }).optimize(compressor);
          }
          break;
        case "||":
          var ll = has_flag(self2.left, TRUTHY) ? true : has_flag(self2.left, FALSY) ? false : self2.left.evaluate(compressor);
          if (!ll) {
            return make_sequence(self2, [self2.left, self2.right]).optimize(compressor);
          } else if (!(ll instanceof AST_Node)) {
            return maintain_this_binding(compressor.parent(), compressor.self(), self2.left).optimize(compressor);
          }
          var rr = self2.right.evaluate(compressor);
          if (!rr) {
            var parent = compressor.parent();
            if (parent.operator == "||" && parent.left === compressor.self() || compressor.in_boolean_context()) {
              return self2.left.optimize(compressor);
            }
          } else if (!(rr instanceof AST_Node)) {
            if (compressor.in_boolean_context()) {
              return make_sequence(self2, [
                self2.left,
                make_node(AST_True, self2)
              ]).optimize(compressor);
            } else {
              set_flag(self2, TRUTHY);
            }
          }
          if (self2.left.operator == "&&") {
            var lr = self2.left.right.evaluate(compressor);
            if (lr && !(lr instanceof AST_Node))
              return make_node(AST_Conditional, self2, {
                condition: self2.left.left,
                consequent: self2.left.right,
                alternative: self2.right
              }).optimize(compressor);
          }
          break;
        case "??":
          if (is_nullish(self2.left, compressor)) {
            return self2.right;
          }
          var ll = self2.left.evaluate(compressor);
          if (!(ll instanceof AST_Node)) {
            return ll == null ? self2.right : self2.left;
          }
          if (compressor.in_boolean_context()) {
            const rr2 = self2.right.evaluate(compressor);
            if (!(rr2 instanceof AST_Node) && !rr2) {
              return self2.left;
            }
          }
      }
      var associative = true;
      switch (self2.operator) {
        case "+":
          if (self2.right instanceof AST_Constant && self2.left instanceof AST_Binary && self2.left.operator == "+" && self2.left.is_string(compressor)) {
            var binary2 = make_node(AST_Binary, self2, {
              operator: "+",
              left: self2.left.right,
              right: self2.right
            });
            var r22 = binary2.optimize(compressor);
            if (binary2 !== r22) {
              self2 = make_node(AST_Binary, self2, {
                operator: "+",
                left: self2.left.left,
                right: r22
              });
            }
          }
          if (self2.left instanceof AST_Binary && self2.left.operator == "+" && self2.left.is_string(compressor) && self2.right instanceof AST_Binary && self2.right.operator == "+" && self2.right.is_string(compressor)) {
            var binary2 = make_node(AST_Binary, self2, {
              operator: "+",
              left: self2.left.right,
              right: self2.right.left
            });
            var m22 = binary2.optimize(compressor);
            if (binary2 !== m22) {
              self2 = make_node(AST_Binary, self2, {
                operator: "+",
                left: make_node(AST_Binary, self2.left, {
                  operator: "+",
                  left: self2.left.left,
                  right: m22
                }),
                right: self2.right.right
              });
            }
          }
          if (self2.right instanceof AST_UnaryPrefix && self2.right.operator == "-" && self2.left.is_number(compressor)) {
            self2 = make_node(AST_Binary, self2, {
              operator: "-",
              left: self2.left,
              right: self2.right.expression
            });
            break;
          }
          if (self2.left instanceof AST_UnaryPrefix && self2.left.operator == "-" && reversible() && self2.right.is_number(compressor)) {
            self2 = make_node(AST_Binary, self2, {
              operator: "-",
              left: self2.right,
              right: self2.left.expression
            });
            break;
          }
          if (self2.left instanceof AST_TemplateString) {
            var l22 = self2.left;
            var r22 = self2.right.evaluate(compressor);
            if (r22 != self2.right) {
              l22.segments[l22.segments.length - 1].value += String(r22);
              return l22;
            }
          }
          if (self2.right instanceof AST_TemplateString) {
            var r22 = self2.right;
            var l22 = self2.left.evaluate(compressor);
            if (l22 != self2.left) {
              r22.segments[0].value = String(l22) + r22.segments[0].value;
              return r22;
            }
          }
          if (self2.left instanceof AST_TemplateString && self2.right instanceof AST_TemplateString) {
            var l22 = self2.left;
            var segments = l22.segments;
            var r22 = self2.right;
            segments[segments.length - 1].value += r22.segments[0].value;
            for (var i2 = 1;i2 < r22.segments.length; i2++) {
              segments.push(r22.segments[i2]);
            }
            return l22;
          }
        case "*":
          associative = compressor.option("unsafe_math");
        case "&":
        case "|":
        case "^":
          if (self2.left.is_number(compressor) && self2.right.is_number(compressor) && reversible() && !(self2.left instanceof AST_Binary && self2.left.operator != self2.operator && PRECEDENCE[self2.left.operator] >= PRECEDENCE[self2.operator])) {
            var reversed = make_node(AST_Binary, self2, {
              operator: self2.operator,
              left: self2.right,
              right: self2.left
            });
            if (self2.right instanceof AST_Constant && !(self2.left instanceof AST_Constant)) {
              self2 = best_of(compressor, reversed, self2);
            } else {
              self2 = best_of(compressor, self2, reversed);
            }
          }
          if (associative && self2.is_number(compressor)) {
            if (self2.right instanceof AST_Binary && self2.right.operator == self2.operator) {
              self2 = make_node(AST_Binary, self2, {
                operator: self2.operator,
                left: make_node(AST_Binary, self2.left, {
                  operator: self2.operator,
                  left: self2.left,
                  right: self2.right.left,
                  start: self2.left.start,
                  end: self2.right.left.end
                }),
                right: self2.right.right
              });
            }
            if (self2.right instanceof AST_Constant && self2.left instanceof AST_Binary && self2.left.operator == self2.operator) {
              if (self2.left.left instanceof AST_Constant) {
                self2 = make_node(AST_Binary, self2, {
                  operator: self2.operator,
                  left: make_node(AST_Binary, self2.left, {
                    operator: self2.operator,
                    left: self2.left.left,
                    right: self2.right,
                    start: self2.left.left.start,
                    end: self2.right.end
                  }),
                  right: self2.left.right
                });
              } else if (self2.left.right instanceof AST_Constant) {
                self2 = make_node(AST_Binary, self2, {
                  operator: self2.operator,
                  left: make_node(AST_Binary, self2.left, {
                    operator: self2.operator,
                    left: self2.left.right,
                    right: self2.right,
                    start: self2.left.right.start,
                    end: self2.right.end
                  }),
                  right: self2.left.left
                });
              }
            }
            if (self2.left instanceof AST_Binary && self2.left.operator == self2.operator && self2.left.right instanceof AST_Constant && self2.right instanceof AST_Binary && self2.right.operator == self2.operator && self2.right.left instanceof AST_Constant) {
              self2 = make_node(AST_Binary, self2, {
                operator: self2.operator,
                left: make_node(AST_Binary, self2.left, {
                  operator: self2.operator,
                  left: make_node(AST_Binary, self2.left.left, {
                    operator: self2.operator,
                    left: self2.left.right,
                    right: self2.right.left,
                    start: self2.left.right.start,
                    end: self2.right.left.end
                  }),
                  right: self2.left.left
                }),
                right: self2.right.right
              });
            }
          }
      }
      if (bitwise_binop.has(self2.operator)) {
        let y, z22, x_node, y_node, z_node = self2.left;
        if (self2.operator === "&" && self2.right instanceof AST_Binary && self2.right.operator === "|" && typeof (z22 = self2.left.evaluate(compressor)) === "number") {
          if (typeof (y = self2.right.right.evaluate(compressor)) === "number") {
            x_node = self2.right.left;
            y_node = self2.right.right;
          } else if (typeof (y = self2.right.left.evaluate(compressor)) === "number") {
            x_node = self2.right.right;
            y_node = self2.right.left;
          }
          if (x_node && y_node) {
            if ((y & z22) === 0) {
              self2 = make_node(AST_Binary, self2, {
                operator: self2.operator,
                left: z_node,
                right: x_node
              });
            } else {
              const reordered_ops = make_node(AST_Binary, self2, {
                operator: "|",
                left: make_node(AST_Binary, self2, {
                  operator: "&",
                  left: x_node,
                  right: z_node
                }),
                right: make_node_from_constant(y & z22, y_node)
              });
              self2 = best_of(compressor, self2, reordered_ops);
            }
          }
        }
        const same_operands = self2.left.equivalent_to(self2.right) && !self2.left.has_side_effects(compressor);
        if (same_operands) {
          if (self2.operator === "^") {
            return make_node(AST_Number, self2, { value: 0 });
          }
          if (self2.operator === "|" || self2.operator === "&") {
            self2.left = make_node(AST_Number, self2, { value: 0 });
            self2.operator = "|";
          }
        }
        if ((self2.operator === "<<" || self2.operator === ">>") && self2.right instanceof AST_Number && self2.right.value === 0) {
          self2.operator = "|";
        }
        const zero_side = self2.right instanceof AST_Number && self2.right.value === 0 ? self2.right : self2.left instanceof AST_Number && self2.left.value === 0 ? self2.left : null;
        const non_zero_side = zero_side && (zero_side === self2.right ? self2.left : self2.right);
        if (zero_side && (self2.operator === "|" || self2.operator === "^") && (non_zero_side.is_32_bit_integer() || compressor.in_32_bit_context())) {
          return non_zero_side;
        }
        if (zero_side && self2.operator === "&" && !non_zero_side.has_side_effects(compressor)) {
          return zero_side;
        }
        const is_full_mask = (node) => node instanceof AST_Number && node.value === -1 || node instanceof AST_UnaryPrefix && (node.operator === "-" && node.expression instanceof AST_Number && node.expression.value === 1 || node.operator === "~" && node.expression instanceof AST_Number && node.expression.value === 0);
        const full_mask = is_full_mask(self2.right) ? self2.right : is_full_mask(self2.left) ? self2.left : null;
        const non_full_mask_side = full_mask && (full_mask === self2.right ? self2.left : self2.right);
        switch (self2.operator) {
          case "|":
            if (full_mask && !non_full_mask_side.has_side_effects(compressor)) {
              return full_mask;
            }
            break;
          case "&":
            if (full_mask && (non_full_mask_side.is_32_bit_integer() || compressor.in_32_bit_context())) {
              return non_full_mask_side;
            }
            break;
          case "^":
            if (full_mask) {
              return non_full_mask_side.bitwise_negate(compressor.in_32_bit_context());
            }
            if (self2.left instanceof AST_UnaryPrefix && self2.left.operator === "~" && self2.right instanceof AST_UnaryPrefix && self2.right.operator === "~") {
              self2 = make_node(AST_Binary, self2, {
                operator: "^",
                left: self2.left.expression,
                right: self2.right.expression
              });
            }
            break;
        }
      }
    }
    if (self2.right instanceof AST_Binary && self2.right.operator == self2.operator && (lazy_op.has(self2.operator) || self2.operator == "+" && (self2.right.left.is_string(compressor) || self2.left.is_string(compressor) && self2.right.right.is_string(compressor)))) {
      self2.left = make_node(AST_Binary, self2.left, {
        operator: self2.operator,
        left: self2.left.transform(compressor),
        right: self2.right.left.transform(compressor)
      });
      self2.right = self2.right.right.transform(compressor);
      return self2.transform(compressor);
    }
    var ev = self2.evaluate(compressor);
    if (ev !== self2) {
      ev = make_node_from_constant(ev, self2).optimize(compressor);
      return best_of(compressor, ev, self2);
    }
    return self2;
  });
  def_optimize(AST_SymbolExport, function(self2) {
    return self2;
  });
  def_optimize(AST_SymbolRef, function(self2, compressor) {
    if (!compressor.option("ie8") && is_undeclared_ref(self2) && !compressor.find_parent(AST_With)) {
      switch (self2.name) {
        case "undefined":
          return make_node(AST_Undefined, self2).optimize(compressor);
        case "NaN":
          return make_node(AST_NaN, self2).optimize(compressor);
        case "Infinity":
          return make_node(AST_Infinity, self2).optimize(compressor);
      }
    }
    if (compressor.option("reduce_vars") && !compressor.is_lhs()) {
      return inline_into_symbolref(self2, compressor);
    } else {
      return self2;
    }
  });
  def_optimize(AST_Undefined, function(self2, compressor) {
    if (compressor.option("unsafe_undefined")) {
      var undef = find_variable(compressor, "undefined");
      if (undef) {
        var ref2 = make_node(AST_SymbolRef, self2, {
          name: "undefined",
          scope: undef.scope,
          thedef: undef
        });
        set_flag(ref2, UNDEFINED);
        return ref2;
      }
    }
    var lhs = compressor.is_lhs();
    if (lhs && is_atomic(lhs, self2))
      return self2;
    return make_node(AST_UnaryPrefix, self2, {
      operator: "void",
      expression: make_node(AST_Number, self2, {
        value: 0
      })
    });
  });
  def_optimize(AST_Infinity, function(self2, compressor) {
    var lhs = compressor.is_lhs();
    if (lhs && is_atomic(lhs, self2))
      return self2;
    if (compressor.option("keep_infinity") && !(lhs && !is_atomic(lhs, self2)) && !find_variable(compressor, "Infinity")) {
      return self2;
    }
    return make_node(AST_Binary, self2, {
      operator: "/",
      left: make_node(AST_Number, self2, {
        value: 1
      }),
      right: make_node(AST_Number, self2, {
        value: 0
      })
    });
  });
  def_optimize(AST_NaN, function(self2, compressor) {
    var lhs = compressor.is_lhs();
    if (lhs && !is_atomic(lhs, self2) || find_variable(compressor, "NaN")) {
      return make_node(AST_Binary, self2, {
        operator: "/",
        left: make_node(AST_Number, self2, {
          value: 0
        }),
        right: make_node(AST_Number, self2, {
          value: 0
        })
      });
    }
    return self2;
  });
  ASSIGN_OPS = makePredicate("+ - / * % >> << >>> | ^ &");
  ASSIGN_OPS_COMMUTATIVE = makePredicate("* | ^ &");
  def_optimize(AST_Assign, function(self2, compressor) {
    if (self2.logical) {
      return self2.lift_sequences(compressor);
    }
    var def;
    if (self2.operator === "=" && self2.left instanceof AST_SymbolRef && self2.left.name !== "arguments" && !(def = self2.left.definition()).undeclared && self2.right.equivalent_to(self2.left)) {
      return self2.right;
    }
    if (compressor.option("dead_code") && self2.left instanceof AST_SymbolRef && (def = self2.left.definition()).scope === compressor.find_parent(AST_Lambda)) {
      var level = 0, node, parent = self2;
      do {
        node = parent;
        parent = compressor.parent(level++);
        if (parent instanceof AST_Exit) {
          if (in_try(level, parent))
            break;
          if (is_reachable(def.scope, [def]))
            break;
          if (self2.operator == "=")
            return self2.right;
          def.fixed = false;
          return make_node(AST_Binary, self2, {
            operator: self2.operator.slice(0, -1),
            left: self2.left,
            right: self2.right
          }).optimize(compressor);
        }
      } while (parent instanceof AST_Binary && parent.right === node || parent instanceof AST_Sequence && parent.tail_node() === node);
    }
    self2 = self2.lift_sequences(compressor);
    if (self2.operator == "=" && self2.left instanceof AST_SymbolRef && self2.right instanceof AST_Binary) {
      if (self2.right.left instanceof AST_SymbolRef && self2.right.left.name == self2.left.name && ASSIGN_OPS.has(self2.right.operator)) {
        self2.operator = self2.right.operator + "=";
        self2.right = self2.right.right;
      } else if (self2.right.right instanceof AST_SymbolRef && self2.right.right.name == self2.left.name && ASSIGN_OPS_COMMUTATIVE.has(self2.right.operator) && !self2.right.left.has_side_effects(compressor)) {
        self2.operator = self2.right.operator + "=";
        self2.right = self2.right.left;
      }
    }
    return self2;
    function in_try(level2, node2) {
      function may_assignment_throw() {
        const right = self2.right;
        self2.right = make_node(AST_Null, right);
        const may_throw = node2.may_throw(compressor);
        self2.right = right;
        return may_throw;
      }
      var stop_at = self2.left.definition().scope.get_defun_scope();
      var parent2;
      while ((parent2 = compressor.parent(level2++)) !== stop_at) {
        if (parent2 instanceof AST_Try) {
          if (parent2.bfinally)
            return true;
          if (parent2.bcatch && may_assignment_throw())
            return true;
        }
      }
    }
  });
  def_optimize(AST_DefaultAssign, function(self2, compressor) {
    if (!compressor.option("evaluate")) {
      return self2;
    }
    var evaluateRight = self2.right.evaluate(compressor);
    let lambda, iife;
    if (evaluateRight === undefined) {
      if ((lambda = compressor.parent()) instanceof AST_Lambda ? compressor.option("keep_fargs") === false || (iife = compressor.parent(1)).TYPE === "Call" && iife.expression === lambda : true) {
        self2 = self2.left;
      }
    } else if (evaluateRight !== self2.right) {
      evaluateRight = make_node_from_constant(evaluateRight, self2.right);
      self2.right = best_of_expression(evaluateRight, self2.right);
    }
    return self2;
  });
  def_optimize(AST_Conditional, function(self2, compressor) {
    if (!compressor.option("conditionals"))
      return self2;
    if (self2.condition instanceof AST_Sequence) {
      var expressions = self2.condition.expressions.slice();
      self2.condition = expressions.pop();
      expressions.push(self2);
      return make_sequence(self2, expressions);
    }
    var cond = self2.condition.evaluate(compressor);
    if (cond !== self2.condition) {
      if (cond) {
        return maintain_this_binding(compressor.parent(), compressor.self(), self2.consequent);
      } else {
        return maintain_this_binding(compressor.parent(), compressor.self(), self2.alternative);
      }
    }
    var negated = cond.negate(compressor, first_in_statement(compressor));
    if (best_of(compressor, cond, negated) === negated) {
      self2 = make_node(AST_Conditional, self2, {
        condition: negated,
        consequent: self2.alternative,
        alternative: self2.consequent
      });
    }
    var condition = self2.condition;
    var consequent = self2.consequent;
    var alternative = self2.alternative;
    if (condition instanceof AST_SymbolRef && consequent instanceof AST_SymbolRef && condition.definition() === consequent.definition()) {
      return make_node(AST_Binary, self2, {
        operator: "||",
        left: condition,
        right: alternative
      });
    }
    if (consequent instanceof AST_Assign && alternative instanceof AST_Assign && consequent.operator === alternative.operator && consequent.logical === alternative.logical && consequent.left.equivalent_to(alternative.left) && (!self2.condition.has_side_effects(compressor) || consequent.operator == "=" && !consequent.left.has_side_effects(compressor))) {
      return make_node(AST_Assign, self2, {
        operator: consequent.operator,
        left: consequent.left,
        logical: consequent.logical,
        right: make_node(AST_Conditional, self2, {
          condition: self2.condition,
          consequent: consequent.right,
          alternative: alternative.right
        })
      });
    }
    var arg_index;
    if (consequent instanceof AST_Call && alternative.TYPE === consequent.TYPE && consequent.args.length > 0 && consequent.args.length == alternative.args.length && consequent.expression.equivalent_to(alternative.expression) && !self2.condition.has_side_effects(compressor) && !consequent.expression.has_side_effects(compressor) && typeof (arg_index = single_arg_diff()) == "number") {
      var node = consequent.clone();
      node.args[arg_index] = make_node(AST_Conditional, self2, {
        condition: self2.condition,
        consequent: consequent.args[arg_index],
        alternative: alternative.args[arg_index]
      });
      return node;
    }
    if (alternative instanceof AST_Conditional && consequent.equivalent_to(alternative.consequent)) {
      return make_node(AST_Conditional, self2, {
        condition: make_node(AST_Binary, self2, {
          operator: "||",
          left: condition,
          right: alternative.condition
        }),
        consequent,
        alternative: alternative.alternative
      }).optimize(compressor);
    }
    if (compressor.option("ecma") >= 2020 && is_nullish_check(condition, alternative, compressor)) {
      return make_node(AST_Binary, self2, {
        operator: "??",
        left: alternative,
        right: consequent
      }).optimize(compressor);
    }
    if (alternative instanceof AST_Sequence && consequent.equivalent_to(alternative.expressions[alternative.expressions.length - 1])) {
      return make_sequence(self2, [
        make_node(AST_Binary, self2, {
          operator: "||",
          left: condition,
          right: make_sequence(self2, alternative.expressions.slice(0, -1))
        }),
        consequent
      ]).optimize(compressor);
    }
    if (alternative instanceof AST_Binary && alternative.operator == "&&" && consequent.equivalent_to(alternative.right)) {
      return make_node(AST_Binary, self2, {
        operator: "&&",
        left: make_node(AST_Binary, self2, {
          operator: "||",
          left: condition,
          right: alternative.left
        }),
        right: consequent
      }).optimize(compressor);
    }
    if (consequent instanceof AST_Conditional && consequent.alternative.equivalent_to(alternative)) {
      return make_node(AST_Conditional, self2, {
        condition: make_node(AST_Binary, self2, {
          left: self2.condition,
          operator: "&&",
          right: consequent.condition
        }),
        consequent: consequent.consequent,
        alternative
      });
    }
    if (consequent.equivalent_to(alternative)) {
      return make_sequence(self2, [
        self2.condition,
        consequent
      ]).optimize(compressor);
    }
    if (consequent instanceof AST_Binary && consequent.operator == "||" && consequent.right.equivalent_to(alternative)) {
      return make_node(AST_Binary, self2, {
        operator: "||",
        left: make_node(AST_Binary, self2, {
          operator: "&&",
          left: self2.condition,
          right: consequent.left
        }),
        right: alternative
      }).optimize(compressor);
    }
    const in_bool = compressor.in_boolean_context();
    if (is_true(self2.consequent)) {
      if (is_false(self2.alternative)) {
        return booleanize(self2.condition);
      }
      return make_node(AST_Binary, self2, {
        operator: "||",
        left: booleanize(self2.condition),
        right: self2.alternative
      });
    }
    if (is_false(self2.consequent)) {
      if (is_true(self2.alternative)) {
        return booleanize(self2.condition.negate(compressor));
      }
      return make_node(AST_Binary, self2, {
        operator: "&&",
        left: booleanize(self2.condition.negate(compressor)),
        right: self2.alternative
      });
    }
    if (is_true(self2.alternative)) {
      return make_node(AST_Binary, self2, {
        operator: "||",
        left: booleanize(self2.condition.negate(compressor)),
        right: self2.consequent
      });
    }
    if (is_false(self2.alternative)) {
      return make_node(AST_Binary, self2, {
        operator: "&&",
        left: booleanize(self2.condition),
        right: self2.consequent
      });
    }
    return self2;
    function booleanize(node2) {
      if (node2.is_boolean())
        return node2;
      return make_node(AST_UnaryPrefix, node2, {
        operator: "!",
        expression: node2.negate(compressor)
      });
    }
    function is_true(node2) {
      return node2 instanceof AST_True || in_bool && node2 instanceof AST_Constant && node2.getValue() || node2 instanceof AST_UnaryPrefix && node2.operator == "!" && node2.expression instanceof AST_Constant && !node2.expression.getValue();
    }
    function is_false(node2) {
      return node2 instanceof AST_False || in_bool && node2 instanceof AST_Constant && !node2.getValue() || node2 instanceof AST_UnaryPrefix && node2.operator == "!" && node2.expression instanceof AST_Constant && node2.expression.getValue();
    }
    function single_arg_diff() {
      var a = consequent.args;
      var b22 = alternative.args;
      for (var i2 = 0, len = a.length;i2 < len; i2++) {
        if (a[i2] instanceof AST_Expansion)
          return;
        if (!a[i2].equivalent_to(b22[i2])) {
          if (b22[i2] instanceof AST_Expansion)
            return;
          for (var j22 = i2 + 1;j22 < len; j22++) {
            if (a[j22] instanceof AST_Expansion)
              return;
            if (!a[j22].equivalent_to(b22[j22]))
              return;
          }
          return i2;
        }
      }
    }
  });
  def_optimize(AST_Boolean, function(self2, compressor) {
    if (compressor.in_boolean_context())
      return make_node(AST_Number, self2, {
        value: +self2.value
      });
    var p32 = compressor.parent();
    if (compressor.option("booleans_as_integers")) {
      if (p32 instanceof AST_Binary && (p32.operator == "===" || p32.operator == "!==")) {
        p32.operator = p32.operator.replace(/=$/, "");
      }
      return make_node(AST_Number, self2, {
        value: +self2.value
      });
    }
    if (compressor.option("booleans")) {
      if (p32 instanceof AST_Binary && (p32.operator == "==" || p32.operator == "!=")) {
        return make_node(AST_Number, self2, {
          value: +self2.value
        });
      }
      return make_node(AST_UnaryPrefix, self2, {
        operator: "!",
        expression: make_node(AST_Number, self2, {
          value: 1 - self2.value
        })
      });
    }
    return self2;
  });
  AST_PropAccess.DEFMETHOD("flatten_object", function(key, compressor) {
    if (!compressor.option("properties"))
      return;
    if (key === "__proto__")
      return;
    var arrows = compressor.option("unsafe_arrows") && compressor.option("ecma") >= 2015;
    var expr = this.expression;
    if (expr instanceof AST_Object) {
      var props = expr.properties;
      for (var i2 = props.length;--i2 >= 0; ) {
        var prop = props[i2];
        if ("" + (prop instanceof AST_ConciseMethod ? prop.key.name : prop.key) == key) {
          const all_props_flattenable = props.every((p32) => (p32 instanceof AST_ObjectKeyVal || arrows && p32 instanceof AST_ConciseMethod && !p32.is_generator) && !p32.computed_key());
          if (!all_props_flattenable)
            return;
          if (!safe_to_flatten(prop.value, compressor))
            return;
          return make_node(AST_Sub, this, {
            expression: make_node(AST_Array, expr, {
              elements: props.map(function(prop2) {
                var v22 = prop2.value;
                if (v22 instanceof AST_Accessor) {
                  v22 = make_node(AST_Function, v22, v22);
                }
                var k = prop2.key;
                if (k instanceof AST_Node && !(k instanceof AST_SymbolMethod)) {
                  return make_sequence(prop2, [k, v22]);
                }
                return v22;
              })
            }),
            property: make_node(AST_Number, this, {
              value: i2
            })
          });
        }
      }
    }
  });
  def_optimize(AST_Sub, function(self2, compressor) {
    var expr = self2.expression;
    var prop = self2.property;
    if (compressor.option("properties")) {
      var key = prop.evaluate(compressor);
      if (key !== prop) {
        if (typeof key == "string") {
          if (key == "undefined") {
            key = undefined;
          } else {
            var value = parseFloat(key);
            if (value.toString() == key) {
              key = value;
            }
          }
        }
        prop = self2.property = best_of_expression(prop, make_node_from_constant(key, prop).transform(compressor));
        var property = "" + key;
        if (is_basic_identifier_string(property) && property.length <= prop.size() + 1) {
          return make_node(AST_Dot, self2, {
            expression: expr,
            optional: self2.optional,
            property,
            quote: prop.quote
          }).optimize(compressor);
        }
      }
    }
    var fn;
    OPT_ARGUMENTS:
      if (compressor.option("arguments") && expr instanceof AST_SymbolRef && expr.name == "arguments" && expr.definition().orig.length == 1 && (fn = expr.scope) instanceof AST_Lambda && fn.uses_arguments && !(fn instanceof AST_Arrow) && prop instanceof AST_Number) {
        var index = prop.getValue();
        var params = new Set;
        var argnames = fn.argnames;
        for (var n = 0;n < argnames.length; n++) {
          if (!(argnames[n] instanceof AST_SymbolFunarg)) {
            break OPT_ARGUMENTS;
          }
          var param = argnames[n].name;
          if (params.has(param)) {
            break OPT_ARGUMENTS;
          }
          params.add(param);
        }
        var argname = fn.argnames[index];
        if (argname && compressor.has_directive("use strict")) {
          var def = argname.definition();
          if (!compressor.option("reduce_vars") || def.assignments || def.orig.length > 1) {
            argname = null;
          }
        } else if (!argname && !compressor.option("keep_fargs") && index < fn.argnames.length + 5) {
          while (index >= fn.argnames.length) {
            argname = fn.create_symbol(AST_SymbolFunarg, {
              source: fn,
              scope: fn,
              tentative_name: "argument_" + fn.argnames.length
            });
            fn.argnames.push(argname);
          }
        }
        if (argname) {
          var sym = make_node(AST_SymbolRef, self2, argname);
          sym.reference({});
          clear_flag(argname, UNUSED);
          return sym;
        }
      }
    if (compressor.is_lhs())
      return self2;
    if (key !== prop) {
      var sub = self2.flatten_object(property, compressor);
      if (sub) {
        expr = self2.expression = sub.expression;
        prop = self2.property = sub.property;
      }
    }
    if (compressor.option("properties") && compressor.option("side_effects") && prop instanceof AST_Number && expr instanceof AST_Array) {
      var index = prop.getValue();
      var elements = expr.elements;
      var retValue = elements[index];
      FLATTEN:
        if (safe_to_flatten(retValue, compressor)) {
          var flatten = true;
          var values3 = [];
          for (var i2 = elements.length;--i2 > index; ) {
            var value = elements[i2].drop_side_effect_free(compressor);
            if (value) {
              values3.unshift(value);
              if (flatten && value.has_side_effects(compressor))
                flatten = false;
            }
          }
          if (retValue instanceof AST_Expansion)
            break FLATTEN;
          retValue = retValue instanceof AST_Hole ? make_node(AST_Undefined, retValue) : retValue;
          if (!flatten)
            values3.unshift(retValue);
          while (--i2 >= 0) {
            var value = elements[i2];
            if (value instanceof AST_Expansion)
              break FLATTEN;
            value = value.drop_side_effect_free(compressor);
            if (value)
              values3.unshift(value);
            else
              index--;
          }
          if (flatten) {
            values3.push(retValue);
            return make_sequence(self2, values3).optimize(compressor);
          } else
            return make_node(AST_Sub, self2, {
              expression: make_node(AST_Array, expr, {
                elements: values3
              }),
              property: make_node(AST_Number, prop, {
                value: index
              })
            });
        }
    }
    var ev = self2.evaluate(compressor);
    if (ev !== self2) {
      ev = make_node_from_constant(ev, self2).optimize(compressor);
      return best_of(compressor, ev, self2);
    }
    return self2;
  });
  def_optimize(AST_Chain, function(self2, compressor) {
    if (is_nullish(self2.expression, compressor)) {
      let parent = compressor.parent();
      if (parent instanceof AST_UnaryPrefix && parent.operator === "delete") {
        return make_node_from_constant(0, self2);
      }
      return make_node(AST_Undefined, self2);
    }
    return self2;
  });
  def_optimize(AST_Dot, function(self2, compressor) {
    const parent = compressor.parent();
    if (compressor.is_lhs())
      return self2;
    if (compressor.option("unsafe_proto") && self2.expression instanceof AST_Dot && self2.expression.property == "prototype") {
      var exp = self2.expression.expression;
      if (is_undeclared_ref(exp))
        switch (exp.name) {
          case "Array":
            self2.expression = make_node(AST_Array, self2.expression, {
              elements: []
            });
            break;
          case "Function":
            self2.expression = make_empty_function(self2.expression);
            break;
          case "Number":
            self2.expression = make_node(AST_Number, self2.expression, {
              value: 0
            });
            break;
          case "Object":
            self2.expression = make_node(AST_Object, self2.expression, {
              properties: []
            });
            break;
          case "RegExp":
            self2.expression = make_node(AST_RegExp, self2.expression, {
              value: { source: "t", flags: "" }
            });
            break;
          case "String":
            self2.expression = make_node(AST_String, self2.expression, {
              value: ""
            });
            break;
        }
    }
    if (!(parent instanceof AST_Call) || !has_annotation(parent, _NOINLINE)) {
      const sub = self2.flatten_object(self2.property, compressor);
      if (sub)
        return sub.optimize(compressor);
    }
    if (self2.expression instanceof AST_PropAccess && parent instanceof AST_PropAccess) {
      return self2;
    }
    let ev = self2.evaluate(compressor);
    if (ev !== self2) {
      ev = make_node_from_constant(ev, self2).optimize(compressor);
      return best_of(compressor, ev, self2);
    }
    return self2;
  });
  def_optimize(AST_Array, function(self2, compressor) {
    var optimized = literals_in_boolean_context(self2, compressor);
    if (optimized !== self2) {
      return optimized;
    }
    inline_array_like_spread(self2.elements);
    return self2;
  });
  def_optimize(AST_Object, function(self2, compressor) {
    var optimized = literals_in_boolean_context(self2, compressor);
    if (optimized !== self2) {
      return optimized;
    }
    inline_object_prop_spread(self2.properties);
    return self2;
  });
  def_optimize(AST_RegExp, literals_in_boolean_context);
  def_optimize(AST_Return, function(self2, compressor) {
    if (self2.value && is_undefined(self2.value, compressor)) {
      self2.value = null;
    }
    return self2;
  });
  def_optimize(AST_Arrow, opt_AST_Lambda);
  def_optimize(AST_Function, function(self2, compressor) {
    self2 = opt_AST_Lambda(self2, compressor);
    if (compressor.option("unsafe_arrows") && compressor.option("ecma") >= 2015 && !self2.name && !self2.is_generator && !self2.uses_arguments && !self2.pinned()) {
      const uses_this = walk2(self2, (node) => {
        if (node instanceof AST_This)
          return walk_abort;
      });
      if (!uses_this)
        return make_node(AST_Arrow, self2, self2).optimize(compressor);
    }
    return self2;
  });
  def_optimize(AST_Class, function(self2) {
    for (let i2 = 0;i2 < self2.properties.length; i2++) {
      const prop = self2.properties[i2];
      if (prop instanceof AST_ClassStaticBlock && prop.body.length == 0) {
        self2.properties.splice(i2, 1);
        i2--;
      }
    }
    return self2;
  });
  def_optimize(AST_ClassStaticBlock, function(self2, compressor) {
    tighten_body(self2.body, compressor);
    return self2;
  });
  def_optimize(AST_Yield, function(self2, compressor) {
    if (self2.expression && !self2.is_star && is_undefined(self2.expression, compressor)) {
      self2.expression = null;
    }
    return self2;
  });
  def_optimize(AST_TemplateString, function(self2, compressor) {
    if (!compressor.option("evaluate") || compressor.parent() instanceof AST_PrefixedTemplateString) {
      return self2;
    }
    var segments = [];
    for (var i2 = 0;i2 < self2.segments.length; i2++) {
      var segment = self2.segments[i2];
      if (segment instanceof AST_Node) {
        var result2 = segment.evaluate(compressor);
        if (result2 !== segment && (result2 + "").length <= segment.size() + "${}".length) {
          segments[segments.length - 1].value = segments[segments.length - 1].value + result2 + self2.segments[++i2].value;
          continue;
        }
        if (segment instanceof AST_TemplateString) {
          var inners = segment.segments;
          segments[segments.length - 1].value += inners[0].value;
          for (var j22 = 1;j22 < inners.length; j22++) {
            segment = inners[j22];
            segments.push(segment);
          }
          continue;
        }
      }
      segments.push(segment);
    }
    self2.segments = segments;
    if (segments.length == 1) {
      return make_node(AST_String, self2, segments[0]);
    }
    if (segments.length === 3 && segments[1] instanceof AST_Node && (segments[1].is_string(compressor) || segments[1].is_number(compressor) || is_nullish(segments[1], compressor) || compressor.option("unsafe"))) {
      if (segments[2].value === "") {
        return make_node(AST_Binary, self2, {
          operator: "+",
          left: make_node(AST_String, self2, {
            value: segments[0].value
          }),
          right: segments[1]
        });
      }
      if (segments[0].value === "") {
        return make_node(AST_Binary, self2, {
          operator: "+",
          left: segments[1],
          right: make_node(AST_String, self2, {
            value: segments[2].value
          })
        });
      }
    }
    return self2;
  });
  def_optimize(AST_PrefixedTemplateString, function(self2) {
    return self2;
  });
  def_optimize(AST_ObjectProperty, lift_key);
  def_optimize(AST_ConciseMethod, function(self2, compressor) {
    lift_key(self2, compressor);
    if (compressor.option("arrows") && compressor.parent() instanceof AST_Object && !self2.is_generator && !self2.value.uses_arguments && !self2.value.pinned() && self2.value.body.length == 1 && self2.value.body[0] instanceof AST_Return && self2.value.body[0].value && !self2.value.contains_this()) {
      var arrow = make_node(AST_Arrow, self2.value, self2.value);
      arrow.async = self2.async;
      arrow.is_generator = self2.is_generator;
      return make_node(AST_ObjectKeyVal, self2, {
        key: self2.key instanceof AST_SymbolMethod ? self2.key.name : self2.key,
        value: arrow,
        quote: self2.quote
      });
    }
    return self2;
  });
  def_optimize(AST_ObjectKeyVal, function(self2, compressor) {
    lift_key(self2, compressor);
    var unsafe_methods = compressor.option("unsafe_methods");
    if (unsafe_methods && compressor.option("ecma") >= 2015 && (!(unsafe_methods instanceof RegExp) || unsafe_methods.test(self2.key + ""))) {
      var key = self2.key;
      var value = self2.value;
      var is_arrow_with_block = value instanceof AST_Arrow && Array.isArray(value.body) && !value.contains_this();
      if ((is_arrow_with_block || value instanceof AST_Function) && !value.name) {
        return make_node(AST_ConciseMethod, self2, {
          async: value.async,
          is_generator: value.is_generator,
          key: key instanceof AST_Node ? key : make_node(AST_SymbolMethod, self2, {
            name: key
          }),
          value: make_node(AST_Accessor, value, value),
          quote: self2.quote
        });
      }
    }
    return self2;
  });
  def_optimize(AST_Destructuring, function(self2, compressor) {
    if (compressor.option("pure_getters") == true && compressor.option("unused") && !self2.is_array && Array.isArray(self2.names) && !is_destructuring_export_decl(compressor) && !(self2.names[self2.names.length - 1] instanceof AST_Expansion)) {
      var keep = [];
      for (var i2 = 0;i2 < self2.names.length; i2++) {
        var elem = self2.names[i2];
        if (!(elem instanceof AST_ObjectKeyVal && typeof elem.key == "string" && elem.value instanceof AST_SymbolDeclaration && !should_retain(compressor, elem.value.definition()))) {
          keep.push(elem);
        }
      }
      if (keep.length != self2.names.length) {
        self2.names = keep;
      }
    }
    return self2;
    function is_destructuring_export_decl(compressor2) {
      var ancestors = [/^VarDef$/, /^(Const|Let|Var)$/, /^Export$/];
      for (var a = 0, p32 = 0, len = ancestors.length;a < len; p32++) {
        var parent = compressor2.parent(p32);
        if (!parent)
          return false;
        if (a === 0 && parent.TYPE == "Destructuring")
          continue;
        if (!ancestors[a].test(parent.TYPE)) {
          return false;
        }
        a++;
      }
      return true;
    }
    function should_retain(compressor2, def) {
      if (def.references.length)
        return true;
      if (!def.global)
        return false;
      if (compressor2.toplevel.vars) {
        if (compressor2.top_retain) {
          return compressor2.top_retain(def);
        }
        return false;
      }
      return true;
    }
  });
});
var comma2;
var semicolon2;
var chars2 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
var intToChar2;
var charToInt2;
var bufLength;
var init_sourcemap_codec = __esm2(() => {
  comma2 = ",".charCodeAt(0);
  semicolon2 = ";".charCodeAt(0);
  intToChar2 = new Uint8Array(64);
  charToInt2 = new Uint8Array(128);
  for (let i2 = 0;i2 < chars2.length; i2++) {
    const c22 = chars2.charCodeAt(i2);
    intToChar2[i2] = c22;
    charToInt2[c22] = i2;
  }
  bufLength = 16384;
});
var init_resolve_uri = () => {
};
var init_trace_mapping = __esm2(() => {
  init_sourcemap_codec();
  init_resolve_uri();
});
var init_set_array = () => {
};
var init_gen_mapping = __esm2(() => {
  init_set_array();
  init_sourcemap_codec();
  init_trace_mapping();
});
var init_source_map = __esm2(() => {
  init_trace_mapping();
  init_gen_mapping();
});
var init_sourcemap = __esm2(() => {
  init_source_map();
  init_utils5();
});
var init_domprops = () => {
};
var init_propmangle = __esm2(() => {
  init_utils5();
  init_scope();
  init_ast();
  init_domprops();
});
var init_minify = __esm2(() => {
  init_utils5();
  init_ast();
  init_parse2();
  init_output();
  init_compress();
  init_scope();
  init_sourcemap();
  init_propmangle();
});
var init_cli3 = __esm2(() => {
  init_main();
  init_parse2();
  init_ast();
  init_output();
});
var init_main = __esm2(() => {
  init_transform();
  init_mozilla_ast();
  init_minify();
  init_minify();
  init_cli3();
});
var init_filesize_esm = () => {
};
var import_parser;
var import_traverse;
var import_enhanced_resolve;
var import_esbuild;
var resolver;
var init_chunk_4N7CVFQJ = __esm2(() => {
  import_parser = __toESM3(require_lib3(), 1);
  import_traverse = __toESM3(require_lib11(), 1);
  import_enhanced_resolve = __toESM3(require_lib13(), 1);
  import_esbuild = __toESM3(require_main(), 1);
  init_rollup();
  init_es2();
  init_main();
  init_filesize_esm();
  resolver = import_enhanced_resolve.default.create.sync({
    extensions: [
      ".web.mjs",
      ".mjs",
      ".web.js",
      ".js",
      ".mjs",
      ".json"
    ],
    modules: ["node_modules"],
    conditionNames: ["import", "require"],
    mainFields: ["module", "main"]
  });
});
var init_dist3 = __esm2(() => {
  init_chunk_4N7CVFQJ();
});
var init_export_size = __esm2(() => {
  init_dist3();
});
var excludePatterns;
var init_find = __esm2(() => {
  init_src10();
  init_src8();
  excludePatterns = [
    "node_modules",
    "dist",
    "vendor",
    "storage/framework",
    `${os3.homedir()}/Documents`,
    `${os3.homedir()}/Pictures`,
    `${os3.homedir()}/Library`,
    `${os3.homedir()}/.Trash`,
    /.*out.*/,
    /.*\/\..*/
  ];
});
var init_git2 = __esm2(() => {
  init_src7();
});
var docsSrc;
var init_hash = __esm2(() => {
  init_src6();
  init_src8();
  init_src11();
  init_src23();
  docsSrc = [path2.projectPath("docs"), path2.frameworkPath("docs/dist")];
});
var init_add = __esm2(() => {
  init_src10();
});
var init_src12 = () => {
};
var init_commit = __esm2(() => {
  init_src12();
  init_src8();
  init_src21();
});
var init_utils6 = __esm2(() => {
  init_src10();
  init_src7();
  init_src8();
  init_src11();
  init_src23();
});
var init_helpers5 = __esm2(() => {
  init_utils6();
});
var init_dev = __esm2(() => {
  init_src12();
  init_src8();
  init_helpers5();
});
var init_middleware = __esm2(() => {
  init_src11();
});

class Request2 {
  query = {};
  params = null;
  headers = {};
  addQuery(url) {
    this.query = Object.fromEntries(url.searchParams);
  }
  addBodies(params) {
    this.query = params;
  }
  addParam(param) {
    this.params = param;
  }
  addHeaders(headerParams) {
    this.headers = headerParams;
  }
  get(element) {
    return this.query[element];
  }
  all() {
    return this.query;
  }
  async validate(attributes) {
    if (attributes === undefined || attributes === null) {
      await validateField("Release", this.all());
    } else {
      await customValidate(attributes, this.all());
    }
  }
  has(element) {
    return element in this.query;
  }
  isEmpty() {
    return Object.keys(this.query).length === 0;
  }
  extractParamsFromRoute(routePattern, pathname) {
    const pattern = new RegExp(`^${routePattern.replace(/:(\w+)/g, (match2, paramName) => `(?<${paramName}>\\w+)`)}$`);
    const match = pattern.exec(pathname);
    if (match?.groups)
      this.params = match.groups;
  }
  header(headerParam) {
    return this.headers.get(headerParam);
  }
  getHeaders() {
    return this.headers;
  }
  Header(headerParam) {
    return this.headers.get(headerParam);
  }
  getParam(key) {
    return this.params ? this.params[key] || null : null;
  }
  bearerToken() {
    const authorizationHeader = this.headers.get("authorization");
    if (authorizationHeader?.startsWith("Bearer ")) {
      return authorizationHeader.substring(7);
    }
    return null;
  }
  getParams() {
    return this.params;
  }
  getParamAsInt(key) {
    const value = this.getParam(key);
    return value ? Number.parseInt(value.toString()) : null;
  }
}
var request2;
var init_request = __esm2(() => {
  init_src3();
  request2 = new Request2;
});
var import_generator;
var import_parser2;
var import_traverse2;
var init_utils7 = __esm2(() => {
  import_generator = __toESM3(require_lib7(), 1);
  import_parser2 = __toESM3(require_lib3(), 1);
  import_traverse2 = __toESM3(require_lib11(), 1);
});
var init_src13 = __esm2(() => {
  init_src10();
  init_src11();
  init_src23();
  init_utils7();
});
var init_utils8 = __esm2(() => {
  init_src13();
  init_src10();
  init_src7();
  init_src11();
  init_src23();
  init_src();
  init_src3();
});
var init_src14 = __esm2(() => {
  init_utils8();
});
var init_mysql = __esm2(() => {
  init_src10();
  init_src16();
  init_src7();
  init_src14();
  init_src11();
  init_src23();
  init_src();
  init_drivers();
});
var init_postgres = __esm2(() => {
  init_src10();
  init_src16();
  init_src7();
  init_src14();
  init_src11();
  init_src23();
  init_src();
  init_drivers();
});
var init_sqlite = __esm2(() => {
  init_src10();
  init_src6();
  init_src16();
  init_src7();
  init_src14();
  init_src11();
  init_src23();
  init_src();
  init_drivers();
});
var init_drivers = __esm2(() => {
  init_src10();
  init_src16();
  init_src7();
  init_src14();
  init_src11();
  init_src23();
  init_src();
  init_mysql();
  init_postgres();
  init_sqlite();
});
function isUndefined(obj) {
  return typeof obj === "undefined" || obj === undefined;
}
function isString22(obj) {
  return typeof obj === "string";
}
function isNumber(obj) {
  return typeof obj === "number";
}
function isBoolean(obj) {
  return typeof obj === "boolean";
}
function isNull(obj) {
  return obj === null;
}
function isDate(obj) {
  return obj instanceof Date;
}
function isBigInt(obj) {
  return typeof obj === "bigint";
}
function isBuffer(obj) {
  return typeof Buffer !== "undefined" && Buffer.isBuffer(obj);
}
function isFunction22(obj) {
  return typeof obj === "function";
}
function isObject4(obj) {
  return typeof obj === "object" && obj !== null;
}
function isPlainObject22(obj) {
  if (!isObject4(obj) || getTag(obj) !== "[object Object]") {
    return false;
  }
  if (Object.getPrototypeOf(obj) === null) {
    return true;
  }
  let proto2 = obj;
  while (Object.getPrototypeOf(proto2) !== null) {
    proto2 = Object.getPrototypeOf(proto2);
  }
  return Object.getPrototypeOf(obj) === proto2;
}
function getLast(arr) {
  return arr[arr.length - 1];
}
function freeze(obj) {
  return Object.freeze(obj);
}
function asArray(arg) {
  if (isReadonlyArray(arg)) {
    return arg;
  } else {
    return [arg];
  }
}
function isReadonlyArray(arg) {
  return Array.isArray(arg);
}
function noop2(obj) {
  return obj;
}
function compare(obj1, obj2) {
  if (isReadonlyArray(obj1) && isReadonlyArray(obj2)) {
    return compareArrays(obj1, obj2);
  } else if (isObject4(obj1) && isObject4(obj2)) {
    return compareObjects(obj1, obj2);
  }
  return obj1 === obj2;
}
function compareArrays(arr1, arr2) {
  if (arr1.length !== arr2.length) {
    return false;
  }
  for (let i2 = 0;i2 < arr1.length; ++i2) {
    if (!compare(arr1[i2], arr2[i2])) {
      return false;
    }
  }
  return true;
}
function compareObjects(obj1, obj2) {
  if (isBuffer(obj1) && isBuffer(obj2)) {
    return compareBuffers(obj1, obj2);
  } else if (isDate(obj1) && isDate(obj2)) {
    return compareDates(obj1, obj2);
  }
  return compareGenericObjects(obj1, obj2);
}
function compareBuffers(buf1, buf2) {
  return Buffer.compare(buf1, buf2) === 0;
}
function compareDates(date1, date2) {
  return date1.getTime() === date2.getTime();
}
function compareGenericObjects(obj1, obj2) {
  const keys1 = Object.keys(obj1);
  const keys2 = Object.keys(obj2);
  if (keys1.length !== keys2.length) {
    return false;
  }
  for (const key of keys1) {
    if (!compare(obj1[key], obj2[key])) {
      return false;
    }
  }
  return true;
}
function getTag(value) {
  if (value == null) {
    return value === undefined ? "[object Undefined]" : "[object Null]";
  }
  return toString3.call(value);
}
var toString3;
var init_object_utils = __esm2(() => {
  toString3 = Object.prototype.toString;
});
var AlterTableNode;
var init_alter_table_node = __esm2(() => {
  init_object_utils();
  AlterTableNode = freeze({
    is(node) {
      return node.kind === "AlterTableNode";
    },
    create(table) {
      return freeze({
        kind: "AlterTableNode",
        table
      });
    },
    cloneWithTableProps(node, props) {
      return freeze({
        ...node,
        ...props
      });
    },
    cloneWithColumnAlteration(node, columnAlteration) {
      return freeze({
        ...node,
        columnAlterations: node.columnAlterations ? [...node.columnAlterations, columnAlteration] : [columnAlteration]
      });
    }
  });
});
var IdentifierNode;
var init_identifier_node = __esm2(() => {
  init_object_utils();
  IdentifierNode = freeze({
    is(node) {
      return node.kind === "IdentifierNode";
    },
    create(name) {
      return freeze({
        kind: "IdentifierNode",
        name
      });
    }
  });
});
var CreateIndexNode;
var init_create_index_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  CreateIndexNode = freeze({
    is(node) {
      return node.kind === "CreateIndexNode";
    },
    create(name) {
      return freeze({
        kind: "CreateIndexNode",
        name: IdentifierNode.create(name)
      });
    },
    cloneWith(node, props) {
      return freeze({
        ...node,
        ...props
      });
    },
    cloneWithColumns(node, columns) {
      return freeze({
        ...node,
        columns: [...node.columns || [], ...columns]
      });
    }
  });
});
var CreateSchemaNode;
var init_create_schema_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  CreateSchemaNode = freeze({
    is(node) {
      return node.kind === "CreateSchemaNode";
    },
    create(schema2, params) {
      return freeze({
        kind: "CreateSchemaNode",
        schema: IdentifierNode.create(schema2),
        ...params
      });
    },
    cloneWith(createSchema, params) {
      return freeze({
        ...createSchema,
        ...params
      });
    }
  });
});
var ON_COMMIT_ACTIONS;
var CreateTableNode;
var init_create_table_node = __esm2(() => {
  init_object_utils();
  ON_COMMIT_ACTIONS = ["preserve rows", "delete rows", "drop"];
  CreateTableNode = freeze({
    is(node) {
      return node.kind === "CreateTableNode";
    },
    create(table) {
      return freeze({
        kind: "CreateTableNode",
        table,
        columns: freeze([])
      });
    },
    cloneWithColumn(createTable, column) {
      return freeze({
        ...createTable,
        columns: freeze([...createTable.columns, column])
      });
    },
    cloneWithConstraint(createTable, constraint) {
      return freeze({
        ...createTable,
        constraints: createTable.constraints ? freeze([...createTable.constraints, constraint]) : freeze([constraint])
      });
    },
    cloneWithFrontModifier(createTable, modifier) {
      return freeze({
        ...createTable,
        frontModifiers: createTable.frontModifiers ? freeze([...createTable.frontModifiers, modifier]) : freeze([modifier])
      });
    },
    cloneWithEndModifier(createTable, modifier) {
      return freeze({
        ...createTable,
        endModifiers: createTable.endModifiers ? freeze([...createTable.endModifiers, modifier]) : freeze([modifier])
      });
    },
    cloneWith(createTable, params) {
      return freeze({
        ...createTable,
        ...params
      });
    }
  });
});
var SchemableIdentifierNode;
var init_schemable_identifier_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  SchemableIdentifierNode = freeze({
    is(node) {
      return node.kind === "SchemableIdentifierNode";
    },
    create(identifier) {
      return freeze({
        kind: "SchemableIdentifierNode",
        identifier: IdentifierNode.create(identifier)
      });
    },
    createWithSchema(schema2, identifier) {
      return freeze({
        kind: "SchemableIdentifierNode",
        schema: IdentifierNode.create(schema2),
        identifier: IdentifierNode.create(identifier)
      });
    }
  });
});
var DropIndexNode;
var init_drop_index_node = __esm2(() => {
  init_object_utils();
  init_schemable_identifier_node();
  DropIndexNode = freeze({
    is(node) {
      return node.kind === "DropIndexNode";
    },
    create(name, params) {
      return freeze({
        kind: "DropIndexNode",
        name: SchemableIdentifierNode.create(name),
        ...params
      });
    },
    cloneWith(dropIndex, props) {
      return freeze({
        ...dropIndex,
        ...props
      });
    }
  });
});
var DropSchemaNode;
var init_drop_schema_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  DropSchemaNode = freeze({
    is(node) {
      return node.kind === "DropSchemaNode";
    },
    create(schema2, params) {
      return freeze({
        kind: "DropSchemaNode",
        schema: IdentifierNode.create(schema2),
        ...params
      });
    },
    cloneWith(dropSchema, params) {
      return freeze({
        ...dropSchema,
        ...params
      });
    }
  });
});
var DropTableNode;
var init_drop_table_node = __esm2(() => {
  init_object_utils();
  DropTableNode = freeze({
    is(node) {
      return node.kind === "DropTableNode";
    },
    create(table, params) {
      return freeze({
        kind: "DropTableNode",
        table,
        ...params
      });
    },
    cloneWith(dropIndex, params) {
      return freeze({
        ...dropIndex,
        ...params
      });
    }
  });
});
var AliasNode;
var init_alias_node = __esm2(() => {
  init_object_utils();
  AliasNode = freeze({
    is(node) {
      return node.kind === "AliasNode";
    },
    create(node, alias) {
      return freeze({
        kind: "AliasNode",
        node,
        alias
      });
    }
  });
});
var TableNode;
var init_table_node = __esm2(() => {
  init_object_utils();
  init_schemable_identifier_node();
  TableNode = freeze({
    is(node) {
      return node.kind === "TableNode";
    },
    create(table) {
      return freeze({
        kind: "TableNode",
        table: SchemableIdentifierNode.create(table)
      });
    },
    createWithSchema(schema2, table) {
      return freeze({
        kind: "TableNode",
        table: SchemableIdentifierNode.createWithSchema(schema2, table)
      });
    }
  });
});
function isOperationNodeSource(obj) {
  return isObject4(obj) && isFunction22(obj.toOperationNode);
}
var init_operation_node_source = __esm2(() => {
  init_object_utils();
});
function isExpression(obj) {
  return isObject4(obj) && "expressionType" in obj && isOperationNodeSource(obj);
}
function isAliasedExpression(obj) {
  return isObject4(obj) && "expression" in obj && isString22(obj.alias) && isOperationNodeSource(obj);
}
var init_expression = __esm2(() => {
  init_operation_node_source();
  init_object_utils();
});
var SelectModifierNode;
var init_select_modifier_node = __esm2(() => {
  init_object_utils();
  SelectModifierNode = freeze({
    is(node) {
      return node.kind === "SelectModifierNode";
    },
    create(modifier, of) {
      return freeze({
        kind: "SelectModifierNode",
        modifier,
        of
      });
    },
    createWithExpression(modifier) {
      return freeze({
        kind: "SelectModifierNode",
        rawModifier: modifier
      });
    }
  });
});
var AndNode;
var init_and_node = __esm2(() => {
  init_object_utils();
  AndNode = freeze({
    is(node) {
      return node.kind === "AndNode";
    },
    create(left, right) {
      return freeze({
        kind: "AndNode",
        left,
        right
      });
    }
  });
});
var OrNode;
var init_or_node = __esm2(() => {
  init_object_utils();
  OrNode = freeze({
    is(node) {
      return node.kind === "OrNode";
    },
    create(left, right) {
      return freeze({
        kind: "OrNode",
        left,
        right
      });
    }
  });
});
var OnNode;
var init_on_node = __esm2(() => {
  init_object_utils();
  init_and_node();
  init_or_node();
  OnNode = freeze({
    is(node) {
      return node.kind === "OnNode";
    },
    create(filter) {
      return freeze({
        kind: "OnNode",
        on: filter
      });
    },
    cloneWithOperation(onNode, operator, operation) {
      return freeze({
        ...onNode,
        on: operator === "And" ? AndNode.create(onNode.on, operation) : OrNode.create(onNode.on, operation)
      });
    }
  });
});
var JoinNode;
var init_join_node = __esm2(() => {
  init_object_utils();
  init_on_node();
  JoinNode = freeze({
    is(node) {
      return node.kind === "JoinNode";
    },
    create(joinType, table) {
      return freeze({
        kind: "JoinNode",
        joinType,
        table,
        on: undefined
      });
    },
    createWithOn(joinType, table, on) {
      return freeze({
        kind: "JoinNode",
        joinType,
        table,
        on: OnNode.create(on)
      });
    },
    cloneWithOn(joinNode, operation) {
      return freeze({
        ...joinNode,
        on: joinNode.on ? OnNode.cloneWithOperation(joinNode.on, "And", operation) : OnNode.create(operation)
      });
    }
  });
});
var BinaryOperationNode;
var init_binary_operation_node = __esm2(() => {
  init_object_utils();
  BinaryOperationNode = freeze({
    is(node) {
      return node.kind === "BinaryOperationNode";
    },
    create(leftOperand, operator, rightOperand) {
      return freeze({
        kind: "BinaryOperationNode",
        leftOperand,
        operator,
        rightOperand
      });
    }
  });
});
function isJSONOperator(op) {
  return isString22(op) && JSON_OPERATORS.includes(op);
}
var COMPARISON_OPERATORS;
var ARITHMETIC_OPERATORS;
var JSON_OPERATORS;
var BINARY_OPERATORS;
var UNARY_FILTER_OPERATORS;
var UNARY_OPERATORS;
var OPERATORS2;
var OperatorNode;
var init_operator_node = __esm2(() => {
  init_object_utils();
  COMPARISON_OPERATORS = [
    "=",
    "==",
    "!=",
    "<>",
    ">",
    ">=",
    "<",
    "<=",
    "in",
    "not in",
    "is",
    "is not",
    "like",
    "not like",
    "match",
    "ilike",
    "not ilike",
    "@>",
    "<@",
    "^@",
    "&&",
    "?",
    "?&",
    "?|",
    "!<",
    "!>",
    "<=>",
    "!~",
    "~",
    "~*",
    "!~*",
    "@@",
    "@@@",
    "!!",
    "<->",
    "regexp",
    "is distinct from",
    "is not distinct from"
  ];
  ARITHMETIC_OPERATORS = [
    "+",
    "-",
    "*",
    "/",
    "%",
    "^",
    "&",
    "|",
    "#",
    "<<",
    ">>"
  ];
  JSON_OPERATORS = ["->", "->>"];
  BINARY_OPERATORS = [
    ...COMPARISON_OPERATORS,
    ...ARITHMETIC_OPERATORS,
    "&&",
    "||"
  ];
  UNARY_FILTER_OPERATORS = ["exists", "not exists"];
  UNARY_OPERATORS = ["not", "-", ...UNARY_FILTER_OPERATORS];
  OPERATORS2 = [
    ...BINARY_OPERATORS,
    ...JSON_OPERATORS,
    ...UNARY_OPERATORS,
    "between",
    "between symmetric"
  ];
  OperatorNode = freeze({
    is(node) {
      return node.kind === "OperatorNode";
    },
    create(operator) {
      return freeze({
        kind: "OperatorNode",
        operator
      });
    }
  });
});
var ColumnNode;
var init_column_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  ColumnNode = freeze({
    is(node) {
      return node.kind === "ColumnNode";
    },
    create(column) {
      return freeze({
        kind: "ColumnNode",
        column: IdentifierNode.create(column)
      });
    }
  });
});
var SelectAllNode;
var init_select_all_node = __esm2(() => {
  init_object_utils();
  SelectAllNode = freeze({
    is(node) {
      return node.kind === "SelectAllNode";
    },
    create() {
      return freeze({
        kind: "SelectAllNode"
      });
    }
  });
});
var ReferenceNode;
var init_reference_node = __esm2(() => {
  init_select_all_node();
  init_object_utils();
  ReferenceNode = freeze({
    is(node) {
      return node.kind === "ReferenceNode";
    },
    create(column, table) {
      return freeze({
        kind: "ReferenceNode",
        table,
        column
      });
    },
    createSelectAll(table) {
      return freeze({
        kind: "ReferenceNode",
        table,
        column: SelectAllNode.create()
      });
    }
  });
});

class DynamicReferenceBuilder {
  #dynamicReference;
  get dynamicReference() {
    return this.#dynamicReference;
  }
  get refType() {
    return;
  }
  constructor(reference) {
    this.#dynamicReference = reference;
  }
  toOperationNode() {
    return parseSimpleReferenceExpression(this.#dynamicReference);
  }
}
function isDynamicReferenceBuilder(obj) {
  return isObject4(obj) && isOperationNodeSource(obj) && isString22(obj.dynamicReference);
}
var init_dynamic_reference_builder = __esm2(() => {
  init_operation_node_source();
  init_reference_parser();
  init_object_utils();
});
var OrderByItemNode;
var init_order_by_item_node = __esm2(() => {
  init_object_utils();
  OrderByItemNode = freeze({
    is(node) {
      return node.kind === "OrderByItemNode";
    },
    create(orderBy, direction) {
      return freeze({
        kind: "OrderByItemNode",
        orderBy,
        direction
      });
    }
  });
});
var RawNode;
var init_raw_node = __esm2(() => {
  init_object_utils();
  RawNode = freeze({
    is(node) {
      return node.kind === "RawNode";
    },
    create(sqlFragments, parameters) {
      return freeze({
        kind: "RawNode",
        sqlFragments: freeze(sqlFragments),
        parameters: freeze(parameters)
      });
    },
    createWithSql(sql) {
      return RawNode.create([sql], []);
    },
    createWithChild(child) {
      return RawNode.create(["", ""], [child]);
    },
    createWithChildren(children) {
      return RawNode.create(new Array(children.length + 1).fill(""), children);
    }
  });
});
function isOrderByDirection(thing) {
  return thing === "asc" || thing === "desc";
}
function parseOrderBy(args) {
  if (args.length === 2) {
    return [parseOrderByItem(args[0], args[1])];
  }
  if (args.length === 1) {
    const [orderBy] = args;
    if (Array.isArray(orderBy)) {
      return orderBy.map((item) => parseOrderByItem(item));
    }
    return [parseOrderByItem(orderBy)];
  }
  throw new Error(`Invalid number of arguments at order by! expected 1-2, received ${args.length}`);
}
function parseOrderByItem(ref2, direction) {
  const parsedRef = parseOrderByExpression(ref2);
  if (OrderByItemNode.is(parsedRef)) {
    if (direction) {
      throw new Error("Cannot specify direction twice!");
    }
    return parsedRef;
  }
  return OrderByItemNode.create(parsedRef, parseOrderByDirectionExpression(direction));
}
function parseOrderByExpression(expr) {
  if (isExpressionOrFactory(expr)) {
    return parseExpression(expr);
  }
  if (isDynamicReferenceBuilder(expr)) {
    return expr.toOperationNode();
  }
  const [ref2, direction] = expr.split(" ");
  if (direction) {
    if (!isOrderByDirection(direction)) {
      throw new Error(`Invalid order by direction: ${direction}`);
    }
    return OrderByItemNode.create(parseStringReference(ref2), parseOrderByDirectionExpression(direction));
  }
  return parseStringReference(expr);
}
function parseOrderByDirectionExpression(expr) {
  if (!expr) {
    return;
  }
  if (expr === "asc" || expr === "desc") {
    return RawNode.createWithSql(expr);
  }
  return expr.toOperationNode();
}
var init_order_by_parser = __esm2(() => {
  init_dynamic_reference_builder();
  init_order_by_item_node();
  init_raw_node();
  init_expression_parser();
  init_reference_parser();
});
var JSONReferenceNode;
var init_json_reference_node = __esm2(() => {
  init_object_utils();
  JSONReferenceNode = freeze({
    is(node) {
      return node.kind === "JSONReferenceNode";
    },
    create(reference, traversal) {
      return freeze({
        kind: "JSONReferenceNode",
        reference,
        traversal
      });
    },
    cloneWithTraversal(node, traversal) {
      return freeze({
        ...node,
        traversal
      });
    }
  });
});
var JSONOperatorChainNode;
var init_json_operator_chain_node = __esm2(() => {
  init_object_utils();
  JSONOperatorChainNode = freeze({
    is(node) {
      return node.kind === "JSONOperatorChainNode";
    },
    create(operator) {
      return freeze({
        kind: "JSONOperatorChainNode",
        operator,
        values: freeze([])
      });
    },
    cloneWithValue(node, value) {
      return freeze({
        ...node,
        values: freeze([...node.values, value])
      });
    }
  });
});
var JSONPathNode;
var init_json_path_node = __esm2(() => {
  init_object_utils();
  JSONPathNode = freeze({
    is(node) {
      return node.kind === "JSONPathNode";
    },
    create(inOperator) {
      return freeze({
        kind: "JSONPathNode",
        inOperator,
        pathLegs: freeze([])
      });
    },
    cloneWithLeg(jsonPathNode, pathLeg) {
      return freeze({
        ...jsonPathNode,
        pathLegs: freeze([...jsonPathNode.pathLegs, pathLeg])
      });
    }
  });
});
function parseSimpleReferenceExpression(exp) {
  if (isString22(exp)) {
    return parseStringReference(exp);
  }
  return exp.toOperationNode();
}
function parseReferenceExpressionOrList(arg) {
  if (isReadonlyArray(arg)) {
    return arg.map((it) => parseReferenceExpression(it));
  } else {
    return [parseReferenceExpression(arg)];
  }
}
function parseReferenceExpression(exp) {
  if (isExpressionOrFactory(exp)) {
    return parseExpression(exp);
  }
  return parseSimpleReferenceExpression(exp);
}
function parseJSONReference(ref2, op) {
  const referenceNode = parseStringReference(ref2);
  if (isJSONOperator(op)) {
    return JSONReferenceNode.create(referenceNode, JSONOperatorChainNode.create(OperatorNode.create(op)));
  }
  const opWithoutLastChar = op.slice(0, -1);
  if (isJSONOperator(opWithoutLastChar)) {
    return JSONReferenceNode.create(referenceNode, JSONPathNode.create(OperatorNode.create(opWithoutLastChar)));
  }
  throw new Error(`Invalid JSON operator: ${op}`);
}
function parseStringReference(ref2) {
  const COLUMN_SEPARATOR = ".";
  if (!ref2.includes(COLUMN_SEPARATOR)) {
    return ReferenceNode.create(ColumnNode.create(ref2));
  }
  const parts = ref2.split(COLUMN_SEPARATOR).map(trim2);
  if (parts.length === 3) {
    return parseStringReferenceWithTableAndSchema(parts);
  }
  if (parts.length === 2) {
    return parseStringReferenceWithTable(parts);
  }
  throw new Error(`invalid column reference ${ref2}`);
}
function parseAliasedStringReference(ref2) {
  const ALIAS_SEPARATOR = " as ";
  if (ref2.includes(ALIAS_SEPARATOR)) {
    const [columnRef, alias] = ref2.split(ALIAS_SEPARATOR).map(trim2);
    return AliasNode.create(parseStringReference(columnRef), IdentifierNode.create(alias));
  } else {
    return parseStringReference(ref2);
  }
}
function parseColumnName(column) {
  return ColumnNode.create(column);
}
function parseOrderedColumnName(column) {
  const ORDER_SEPARATOR = " ";
  if (column.includes(ORDER_SEPARATOR)) {
    const [columnName, order] = column.split(ORDER_SEPARATOR).map(trim2);
    if (!isOrderByDirection(order)) {
      throw new Error(`invalid order direction "${order}" next to "${columnName}"`);
    }
    return parseOrderBy([columnName, order])[0];
  } else {
    return parseColumnName(column);
  }
}
function parseStringReferenceWithTableAndSchema(parts) {
  const [schema2, table, column] = parts;
  return ReferenceNode.create(ColumnNode.create(column), TableNode.createWithSchema(schema2, table));
}
function parseStringReferenceWithTable(parts) {
  const [table, column] = parts;
  return ReferenceNode.create(ColumnNode.create(column), TableNode.create(table));
}
function trim2(str) {
  return str.trim();
}
var init_reference_parser = __esm2(() => {
  init_alias_node();
  init_column_node();
  init_reference_node();
  init_table_node();
  init_object_utils();
  init_expression_parser();
  init_identifier_node();
  init_order_by_parser();
  init_operator_node();
  init_json_reference_node();
  init_json_operator_chain_node();
  init_json_path_node();
});
var PrimitiveValueListNode;
var init_primitive_value_list_node = __esm2(() => {
  init_object_utils();
  PrimitiveValueListNode = freeze({
    is(node) {
      return node.kind === "PrimitiveValueListNode";
    },
    create(values3) {
      return freeze({
        kind: "PrimitiveValueListNode",
        values: freeze([...values3])
      });
    }
  });
});
var ValueListNode;
var init_value_list_node = __esm2(() => {
  init_object_utils();
  ValueListNode = freeze({
    is(node) {
      return node.kind === "ValueListNode";
    },
    create(values3) {
      return freeze({
        kind: "ValueListNode",
        values: freeze(values3)
      });
    }
  });
});
var ValueNode;
var init_value_node = __esm2(() => {
  init_object_utils();
  ValueNode = freeze({
    is(node) {
      return node.kind === "ValueNode";
    },
    create(value) {
      return freeze({
        kind: "ValueNode",
        value
      });
    },
    createImmediate(value) {
      return freeze({
        kind: "ValueNode",
        value,
        immediate: true
      });
    }
  });
});
function parseValueExpressionOrList(arg) {
  if (isReadonlyArray(arg)) {
    return parseValueExpressionList(arg);
  }
  return parseValueExpression(arg);
}
function parseValueExpression(exp) {
  if (isExpressionOrFactory(exp)) {
    return parseExpression(exp);
  }
  return ValueNode.create(exp);
}
function isSafeImmediateValue(value) {
  return isNumber(value) || isBoolean(value) || isNull(value);
}
function parseSafeImmediateValue(value) {
  if (!isSafeImmediateValue(value)) {
    throw new Error(`unsafe immediate value ${JSON.stringify(value)}`);
  }
  return ValueNode.createImmediate(value);
}
function parseValueExpressionList(arg) {
  if (arg.some(isExpressionOrFactory)) {
    return ValueListNode.create(arg.map((it) => parseValueExpression(it)));
  }
  return PrimitiveValueListNode.create(arg);
}
var init_value_parser = __esm2(() => {
  init_primitive_value_list_node();
  init_value_list_node();
  init_value_node();
  init_object_utils();
  init_expression_parser();
});
var ParensNode;
var init_parens_node = __esm2(() => {
  init_object_utils();
  ParensNode = freeze({
    is(node) {
      return node.kind === "ParensNode";
    },
    create(node) {
      return freeze({
        kind: "ParensNode",
        node
      });
    }
  });
});
function parseValueBinaryOperationOrExpression(args) {
  if (args.length === 3) {
    return parseValueBinaryOperation(args[0], args[1], args[2]);
  } else if (args.length === 1) {
    return parseValueExpression(args[0]);
  }
  throw new Error(`invalid arguments: ${JSON.stringify(args)}`);
}
function parseValueBinaryOperation(left, operator, right) {
  if (isIsOperator(operator) && needsIsOperator(right)) {
    return BinaryOperationNode.create(parseReferenceExpression(left), parseOperator(operator), ValueNode.createImmediate(right));
  }
  return BinaryOperationNode.create(parseReferenceExpression(left), parseOperator(operator), parseValueExpressionOrList(right));
}
function parseReferentialBinaryOperation(left, operator, right) {
  return BinaryOperationNode.create(parseReferenceExpression(left), parseOperator(operator), parseReferenceExpression(right));
}
function parseFilterObject(obj, combinator) {
  return parseFilterList(Object.entries(obj).filter(([, v22]) => !isUndefined(v22)).map(([k, v22]) => parseValueBinaryOperation(k, needsIsOperator(v22) ? "is" : "=", v22)), combinator);
}
function parseFilterList(list2, combinator, withParens = true) {
  const combine = combinator === "and" ? AndNode.create : OrNode.create;
  if (list2.length === 0) {
    return BinaryOperationNode.create(ValueNode.createImmediate(1), OperatorNode.create("="), ValueNode.createImmediate(combinator === "and" ? 1 : 0));
  }
  let node = toOperationNode(list2[0]);
  for (let i2 = 1;i2 < list2.length; ++i2) {
    node = combine(node, toOperationNode(list2[i2]));
  }
  if (list2.length > 1 && withParens) {
    return ParensNode.create(node);
  }
  return node;
}
function isIsOperator(operator) {
  return operator === "is" || operator === "is not";
}
function needsIsOperator(value) {
  return isNull(value) || isBoolean(value);
}
function parseOperator(operator) {
  if (isString22(operator) && OPERATORS2.includes(operator)) {
    return OperatorNode.create(operator);
  }
  if (isOperationNodeSource(operator)) {
    return operator.toOperationNode();
  }
  throw new Error(`invalid operator ${JSON.stringify(operator)}`);
}
function toOperationNode(nodeOrSource) {
  return isOperationNodeSource(nodeOrSource) ? nodeOrSource.toOperationNode() : nodeOrSource;
}
var init_binary_operation_parser = __esm2(() => {
  init_binary_operation_node();
  init_object_utils();
  init_operation_node_source();
  init_operator_node();
  init_reference_parser();
  init_value_parser();
  init_value_node();
  init_and_node();
  init_parens_node();
  init_or_node();
});
var OrderByNode;
var init_order_by_node = __esm2(() => {
  init_object_utils();
  OrderByNode = freeze({
    is(node) {
      return node.kind === "OrderByNode";
    },
    create(items) {
      return freeze({
        kind: "OrderByNode",
        items: freeze([...items])
      });
    },
    cloneWithItems(orderBy, items) {
      return freeze({
        ...orderBy,
        items: freeze([...orderBy.items, ...items])
      });
    }
  });
});
var PartitionByNode;
var init_partition_by_node = __esm2(() => {
  init_object_utils();
  PartitionByNode = freeze({
    is(node) {
      return node.kind === "PartitionByNode";
    },
    create(items) {
      return freeze({
        kind: "PartitionByNode",
        items: freeze(items)
      });
    },
    cloneWithItems(partitionBy, items) {
      return freeze({
        ...partitionBy,
        items: freeze([...partitionBy.items, ...items])
      });
    }
  });
});
var OverNode;
var init_over_node = __esm2(() => {
  init_object_utils();
  init_order_by_node();
  init_partition_by_node();
  OverNode = freeze({
    is(node) {
      return node.kind === "OverNode";
    },
    create() {
      return freeze({
        kind: "OverNode"
      });
    },
    cloneWithOrderByItems(overNode, items) {
      return freeze({
        ...overNode,
        orderBy: overNode.orderBy ? OrderByNode.cloneWithItems(overNode.orderBy, items) : OrderByNode.create(items)
      });
    },
    cloneWithPartitionByItems(overNode, items) {
      return freeze({
        ...overNode,
        partitionBy: overNode.partitionBy ? PartitionByNode.cloneWithItems(overNode.partitionBy, items) : PartitionByNode.create(items)
      });
    }
  });
});
var FromNode;
var init_from_node = __esm2(() => {
  init_object_utils();
  FromNode = freeze({
    is(node) {
      return node.kind === "FromNode";
    },
    create(froms) {
      return freeze({
        kind: "FromNode",
        froms: freeze(froms)
      });
    },
    cloneWithFroms(from, froms) {
      return freeze({
        ...from,
        froms: freeze([...from.froms, ...froms])
      });
    }
  });
});
var GroupByNode;
var init_group_by_node = __esm2(() => {
  init_object_utils();
  GroupByNode = freeze({
    is(node) {
      return node.kind === "GroupByNode";
    },
    create(items) {
      return freeze({
        kind: "GroupByNode",
        items: freeze(items)
      });
    },
    cloneWithItems(groupBy, items) {
      return freeze({
        ...groupBy,
        items: freeze([...groupBy.items, ...items])
      });
    }
  });
});
var HavingNode;
var init_having_node = __esm2(() => {
  init_object_utils();
  init_and_node();
  init_or_node();
  HavingNode = freeze({
    is(node) {
      return node.kind === "HavingNode";
    },
    create(filter) {
      return freeze({
        kind: "HavingNode",
        having: filter
      });
    },
    cloneWithOperation(havingNode, operator, operation) {
      return freeze({
        ...havingNode,
        having: operator === "And" ? AndNode.create(havingNode.having, operation) : OrNode.create(havingNode.having, operation)
      });
    }
  });
});
var SelectQueryNode;
var init_select_query_node = __esm2(() => {
  init_object_utils();
  init_from_node();
  init_group_by_node();
  init_having_node();
  init_order_by_node();
  SelectQueryNode = freeze({
    is(node) {
      return node.kind === "SelectQueryNode";
    },
    create(withNode) {
      return freeze({
        kind: "SelectQueryNode",
        ...withNode && { with: withNode }
      });
    },
    createFrom(fromItems, withNode) {
      return freeze({
        kind: "SelectQueryNode",
        from: FromNode.create(fromItems),
        ...withNode && { with: withNode }
      });
    },
    cloneWithSelections(select22, selections) {
      return freeze({
        ...select22,
        selections: select22.selections ? freeze([...select22.selections, ...selections]) : freeze(selections)
      });
    },
    cloneWithDistinctOn(select22, expressions) {
      return freeze({
        ...select22,
        distinctOn: select22.distinctOn ? freeze([...select22.distinctOn, ...expressions]) : freeze(expressions)
      });
    },
    cloneWithFrontModifier(select22, modifier) {
      return freeze({
        ...select22,
        frontModifiers: select22.frontModifiers ? freeze([...select22.frontModifiers, modifier]) : freeze([modifier])
      });
    },
    cloneWithEndModifier(select22, modifier) {
      return freeze({
        ...select22,
        endModifiers: select22.endModifiers ? freeze([...select22.endModifiers, modifier]) : freeze([modifier])
      });
    },
    cloneWithOrderByItems(selectNode, items) {
      return freeze({
        ...selectNode,
        orderBy: selectNode.orderBy ? OrderByNode.cloneWithItems(selectNode.orderBy, items) : OrderByNode.create(items)
      });
    },
    cloneWithGroupByItems(selectNode, items) {
      return freeze({
        ...selectNode,
        groupBy: selectNode.groupBy ? GroupByNode.cloneWithItems(selectNode.groupBy, items) : GroupByNode.create(items)
      });
    },
    cloneWithLimit(selectNode, limit) {
      return freeze({
        ...selectNode,
        limit
      });
    },
    cloneWithOffset(selectNode, offset2) {
      return freeze({
        ...selectNode,
        offset: offset2
      });
    },
    cloneWithFetch(selectNode, fetch2) {
      return freeze({
        ...selectNode,
        fetch: fetch2
      });
    },
    cloneWithHaving(selectNode, operation) {
      return freeze({
        ...selectNode,
        having: selectNode.having ? HavingNode.cloneWithOperation(selectNode.having, "And", operation) : HavingNode.create(operation)
      });
    },
    cloneWithSetOperations(selectNode, setOperations) {
      return freeze({
        ...selectNode,
        setOperations: selectNode.setOperations ? freeze([...selectNode.setOperations, ...setOperations]) : freeze([...setOperations])
      });
    },
    cloneWithoutSelections(select22) {
      return freeze({
        ...select22,
        selections: []
      });
    },
    cloneWithoutLimit(select22) {
      return freeze({
        ...select22,
        limit: undefined
      });
    },
    cloneWithoutOffset(select22) {
      return freeze({
        ...select22,
        offset: undefined
      });
    },
    cloneWithoutOrderBy(select22) {
      return freeze({
        ...select22,
        orderBy: undefined
      });
    },
    cloneWithoutGroupBy(select22) {
      return freeze({
        ...select22,
        groupBy: undefined
      });
    }
  });
});
function preventAwait(clazz, message) {
  Object.defineProperties(clazz.prototype, {
    then: {
      enumerable: false,
      value: () => {
        throw new Error(message);
      }
    }
  });
}

class JoinBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  on(...args) {
    return new JoinBuilder({
      ...this.#props,
      joinNode: JoinNode.cloneWithOn(this.#props.joinNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  onRef(lhs, op, rhs) {
    return new JoinBuilder({
      ...this.#props,
      joinNode: JoinNode.cloneWithOn(this.#props.joinNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  onTrue() {
    return new JoinBuilder({
      ...this.#props,
      joinNode: JoinNode.cloneWithOn(this.#props.joinNode, RawNode.createWithSql("true"))
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.joinNode;
  }
}
var init_join_builder = __esm2(() => {
  init_join_node();
  init_raw_node();
  init_binary_operation_parser();
  init_object_utils();
  preventAwait(JoinBuilder, "don't await JoinBuilder instances. They are never executed directly and are always just a part of a query.");
});
var PartitionByItemNode;
var init_partition_by_item_node = __esm2(() => {
  init_object_utils();
  PartitionByItemNode = freeze({
    is(node) {
      return node.kind === "PartitionByItemNode";
    },
    create(partitionBy) {
      return freeze({
        kind: "PartitionByItemNode",
        partitionBy
      });
    }
  });
});
function parsePartitionBy(partitionBy) {
  return parseReferenceExpressionOrList(partitionBy).map(PartitionByItemNode.create);
}
var init_partition_by_parser = __esm2(() => {
  init_partition_by_item_node();
  init_reference_parser();
});

class OverBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  orderBy(orderBy, direction) {
    return new OverBuilder({
      overNode: OverNode.cloneWithOrderByItems(this.#props.overNode, parseOrderBy([orderBy, direction]))
    });
  }
  partitionBy(partitionBy) {
    return new OverBuilder({
      overNode: OverNode.cloneWithPartitionByItems(this.#props.overNode, parsePartitionBy(partitionBy))
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.overNode;
  }
}
var init_over_builder = __esm2(() => {
  init_over_node();
  init_order_by_parser();
  init_partition_by_parser();
  init_object_utils();
  preventAwait(OverBuilder, "don't await OverBuilder instances. They are never executed directly and are always just a part of a query.");
});
var SelectionNode;
var init_selection_node = __esm2(() => {
  init_object_utils();
  init_reference_node();
  init_select_all_node();
  SelectionNode = freeze({
    is(node) {
      return node.kind === "SelectionNode";
    },
    create(selection) {
      return freeze({
        kind: "SelectionNode",
        selection
      });
    },
    createSelectAll() {
      return freeze({
        kind: "SelectionNode",
        selection: SelectAllNode.create()
      });
    },
    createSelectAllFromTable(table) {
      return freeze({
        kind: "SelectionNode",
        selection: ReferenceNode.createSelectAll(table)
      });
    }
  });
});
function parseSelectArg(selection) {
  if (isFunction22(selection)) {
    return parseSelectArg(selection(expressionBuilder()));
  } else if (isReadonlyArray(selection)) {
    return selection.map((it) => parseSelectExpression(it));
  } else {
    return [parseSelectExpression(selection)];
  }
}
function parseSelectExpression(selection) {
  if (isString22(selection)) {
    return SelectionNode.create(parseAliasedStringReference(selection));
  } else if (isDynamicReferenceBuilder(selection)) {
    return SelectionNode.create(selection.toOperationNode());
  } else {
    return SelectionNode.create(parseAliasedExpression(selection));
  }
}
function parseSelectAll(table) {
  if (!table) {
    return [SelectionNode.createSelectAll()];
  } else if (Array.isArray(table)) {
    return table.map(parseSelectAllArg);
  } else {
    return [parseSelectAllArg(table)];
  }
}
function parseSelectAllArg(table) {
  if (isString22(table)) {
    return SelectionNode.createSelectAllFromTable(parseTable(table));
  }
  throw new Error(`invalid value selectAll expression: ${JSON.stringify(table)}`);
}
var init_select_parser = __esm2(() => {
  init_object_utils();
  init_selection_node();
  init_reference_parser();
  init_dynamic_reference_builder();
  init_expression_parser();
  init_table_parser();
  init_expression_builder();
});
var ValuesNode;
var init_values_node = __esm2(() => {
  init_object_utils();
  ValuesNode = freeze({
    is(node) {
      return node.kind === "ValuesNode";
    },
    create(values3) {
      return freeze({
        kind: "ValuesNode",
        values: freeze(values3)
      });
    }
  });
});
var DefaultInsertValueNode;
var init_default_insert_value_node = __esm2(() => {
  init_object_utils();
  DefaultInsertValueNode = freeze({
    is(node) {
      return node.kind === "DefaultInsertValueNode";
    },
    create() {
      return freeze({
        kind: "DefaultInsertValueNode"
      });
    }
  });
});
function parseInsertExpression(arg) {
  const objectOrList = isFunction22(arg) ? arg(expressionBuilder()) : arg;
  const list2 = isReadonlyArray(objectOrList) ? objectOrList : freeze([objectOrList]);
  return parseInsertColumnsAndValues(list2);
}
function parseInsertColumnsAndValues(rows) {
  const columns = parseColumnNamesAndIndexes(rows);
  return [
    freeze([...columns.keys()].map(ColumnNode.create)),
    ValuesNode.create(rows.map((row) => parseRowValues(row, columns)))
  ];
}
function parseColumnNamesAndIndexes(rows) {
  const columns = new Map;
  for (const row of rows) {
    const cols = Object.keys(row);
    for (const col of cols) {
      if (!columns.has(col) && row[col] !== undefined) {
        columns.set(col, columns.size);
      }
    }
  }
  return columns;
}
function parseRowValues(row, columns) {
  const rowColumns = Object.keys(row);
  const rowValues = Array.from({
    length: columns.size
  });
  let hasUndefinedOrComplexColumns = false;
  for (const col of rowColumns) {
    const columnIdx = columns.get(col);
    if (isUndefined(columnIdx)) {
      continue;
    }
    const value = row[col];
    if (isUndefined(value) || isExpressionOrFactory(value)) {
      hasUndefinedOrComplexColumns = true;
    }
    rowValues[columnIdx] = value;
  }
  const hasMissingColumns = rowColumns.length < columns.size;
  if (hasMissingColumns || hasUndefinedOrComplexColumns) {
    const defaultValue = DefaultInsertValueNode.create();
    return ValueListNode.create(rowValues.map((it) => isUndefined(it) ? defaultValue : parseValueExpression(it)));
  }
  return PrimitiveValueListNode.create(rowValues);
}
var init_insert_values_parser = __esm2(() => {
  init_column_node();
  init_primitive_value_list_node();
  init_value_list_node();
  init_object_utils();
  init_value_parser();
  init_values_node();
  init_expression_parser();
  init_default_insert_value_node();
  init_expression_builder();
});
var InsertQueryNode;
var init_insert_query_node = __esm2(() => {
  init_object_utils();
  InsertQueryNode = freeze({
    is(node) {
      return node.kind === "InsertQueryNode";
    },
    create(into, withNode, replace22) {
      return freeze({
        kind: "InsertQueryNode",
        into,
        ...withNode && { with: withNode },
        replace: replace22
      });
    },
    createWithoutInto() {
      return freeze({
        kind: "InsertQueryNode"
      });
    },
    cloneWith(insertQuery, props) {
      return freeze({
        ...insertQuery,
        ...props
      });
    }
  });
});
var UpdateQueryNode;
var init_update_query_node = __esm2(() => {
  init_object_utils();
  init_from_node();
  UpdateQueryNode = freeze({
    is(node) {
      return node.kind === "UpdateQueryNode";
    },
    create(table, withNode) {
      return freeze({
        kind: "UpdateQueryNode",
        table,
        ...withNode && { with: withNode }
      });
    },
    createWithoutTable() {
      return freeze({
        kind: "UpdateQueryNode"
      });
    },
    cloneWithFromItems(updateQuery, fromItems) {
      return freeze({
        ...updateQuery,
        from: updateQuery.from ? FromNode.cloneWithFroms(updateQuery.from, fromItems) : FromNode.create(fromItems)
      });
    },
    cloneWithUpdates(updateQuery, updates) {
      return freeze({
        ...updateQuery,
        updates: updateQuery.updates ? freeze([...updateQuery.updates, ...updates]) : updates
      });
    },
    cloneWithLimit(updateQuery, limit) {
      return freeze({
        ...updateQuery,
        limit
      });
    }
  });
});
var UsingNode;
var init_using_node = __esm2(() => {
  init_object_utils();
  UsingNode = freeze({
    is(node) {
      return node.kind === "UsingNode";
    },
    create(tables2) {
      return freeze({
        kind: "UsingNode",
        tables: freeze(tables2)
      });
    },
    cloneWithTables(using, tables2) {
      return freeze({
        ...using,
        tables: freeze([...using.tables, ...tables2])
      });
    }
  });
});
var DeleteQueryNode;
var init_delete_query_node = __esm2(() => {
  init_object_utils();
  init_from_node();
  init_order_by_node();
  init_using_node();
  DeleteQueryNode = freeze({
    is(node) {
      return node.kind === "DeleteQueryNode";
    },
    create(fromItems, withNode) {
      return freeze({
        kind: "DeleteQueryNode",
        from: FromNode.create(fromItems),
        ...withNode && { with: withNode }
      });
    },
    cloneWithOrderByItems(deleteNode, items) {
      return freeze({
        ...deleteNode,
        orderBy: deleteNode.orderBy ? OrderByNode.cloneWithItems(deleteNode.orderBy, items) : OrderByNode.create(items)
      });
    },
    cloneWithoutOrderBy(deleteNode) {
      return freeze({
        ...deleteNode,
        orderBy: undefined
      });
    },
    cloneWithLimit(deleteNode, limit) {
      return freeze({
        ...deleteNode,
        limit
      });
    },
    cloneWithoutLimit(deleteNode) {
      return freeze({
        ...deleteNode,
        limit: undefined
      });
    },
    cloneWithUsing(deleteNode, tables2) {
      return freeze({
        ...deleteNode,
        using: deleteNode.using !== undefined ? UsingNode.cloneWithTables(deleteNode.using, tables2) : UsingNode.create(tables2)
      });
    }
  });
});
var WhereNode;
var init_where_node = __esm2(() => {
  init_object_utils();
  init_and_node();
  init_or_node();
  WhereNode = freeze({
    is(node) {
      return node.kind === "WhereNode";
    },
    create(filter) {
      return freeze({
        kind: "WhereNode",
        where: filter
      });
    },
    cloneWithOperation(whereNode, operator, operation) {
      return freeze({
        ...whereNode,
        where: operator === "And" ? AndNode.create(whereNode.where, operation) : OrNode.create(whereNode.where, operation)
      });
    }
  });
});
var ReturningNode;
var init_returning_node = __esm2(() => {
  init_object_utils();
  ReturningNode = freeze({
    is(node) {
      return node.kind === "ReturningNode";
    },
    create(selections) {
      return freeze({
        kind: "ReturningNode",
        selections: freeze(selections)
      });
    },
    cloneWithSelections(returning, selections) {
      return freeze({
        ...returning,
        selections: returning.selections ? freeze([...returning.selections, ...selections]) : freeze(selections)
      });
    }
  });
});
var ExplainNode;
var init_explain_node = __esm2(() => {
  init_object_utils();
  ExplainNode = freeze({
    is(node) {
      return node.kind === "ExplainNode";
    },
    create(format, options3) {
      return freeze({
        kind: "ExplainNode",
        format,
        options: options3
      });
    }
  });
});
var WhenNode;
var init_when_node = __esm2(() => {
  init_object_utils();
  WhenNode = freeze({
    is(node) {
      return node.kind === "WhenNode";
    },
    create(condition) {
      return freeze({
        kind: "WhenNode",
        condition
      });
    },
    cloneWithResult(whenNode, result2) {
      return freeze({
        ...whenNode,
        result: result2
      });
    }
  });
});
var MergeQueryNode;
var init_merge_query_node = __esm2(() => {
  init_object_utils();
  init_when_node();
  MergeQueryNode = freeze({
    is(node) {
      return node.kind === "MergeQueryNode";
    },
    create(into, withNode) {
      return freeze({
        kind: "MergeQueryNode",
        into,
        ...withNode && { with: withNode }
      });
    },
    cloneWithUsing(mergeNode, using) {
      return freeze({
        ...mergeNode,
        using
      });
    },
    cloneWithWhen(mergeNode, when) {
      return freeze({
        ...mergeNode,
        whens: mergeNode.whens ? freeze([...mergeNode.whens, when]) : freeze([when])
      });
    },
    cloneWithThen(mergeNode, then) {
      return freeze({
        ...mergeNode,
        whens: mergeNode.whens ? freeze([
          ...mergeNode.whens.slice(0, -1),
          WhenNode.cloneWithResult(mergeNode.whens[mergeNode.whens.length - 1], then)
        ]) : undefined
      });
    }
  });
});
var OutputNode;
var init_output_node = __esm2(() => {
  init_object_utils();
  OutputNode = freeze({
    is(node) {
      return node.kind === "OutputNode";
    },
    create(selections) {
      return freeze({
        kind: "OutputNode",
        selections: freeze(selections)
      });
    },
    cloneWithSelections(output, selections) {
      return freeze({
        ...output,
        selections: output.selections ? freeze([...output.selections, ...selections]) : freeze(selections)
      });
    }
  });
});
var QueryNode;
var init_query_node = __esm2(() => {
  init_insert_query_node();
  init_select_query_node();
  init_update_query_node();
  init_delete_query_node();
  init_where_node();
  init_object_utils();
  init_returning_node();
  init_explain_node();
  init_merge_query_node();
  init_output_node();
  QueryNode = freeze({
    is(node) {
      return SelectQueryNode.is(node) || InsertQueryNode.is(node) || UpdateQueryNode.is(node) || DeleteQueryNode.is(node) || MergeQueryNode.is(node);
    },
    cloneWithWhere(node, operation) {
      return freeze({
        ...node,
        where: node.where ? WhereNode.cloneWithOperation(node.where, "And", operation) : WhereNode.create(operation)
      });
    },
    cloneWithJoin(node, join23) {
      return freeze({
        ...node,
        joins: node.joins ? freeze([...node.joins, join23]) : freeze([join23])
      });
    },
    cloneWithReturning(node, selections) {
      return freeze({
        ...node,
        returning: node.returning ? ReturningNode.cloneWithSelections(node.returning, selections) : ReturningNode.create(selections)
      });
    },
    cloneWithoutReturning(node) {
      return freeze({
        ...node,
        returning: undefined
      });
    },
    cloneWithoutWhere(node) {
      return freeze({
        ...node,
        where: undefined
      });
    },
    cloneWithExplain(node, format, options3) {
      return freeze({
        ...node,
        explain: ExplainNode.create(format, options3?.toOperationNode())
      });
    },
    cloneWithTop(node, top) {
      return freeze({
        ...node,
        top
      });
    },
    cloneWithOutput(node, selections) {
      return freeze({
        ...node,
        output: node.output ? OutputNode.cloneWithSelections(node.output, selections) : OutputNode.create(selections)
      });
    }
  });
});
var ColumnUpdateNode;
var init_column_update_node = __esm2(() => {
  init_object_utils();
  ColumnUpdateNode = freeze({
    is(node) {
      return node.kind === "ColumnUpdateNode";
    },
    create(column, value) {
      return freeze({
        kind: "ColumnUpdateNode",
        column,
        value
      });
    }
  });
});
function parseUpdate(...args) {
  if (args.length === 2) {
    return [
      ColumnUpdateNode.create(parseReferenceExpression(args[0]), parseValueExpression(args[1]))
    ];
  }
  return parseUpdateObjectExpression(args[0]);
}
function parseUpdateObjectExpression(update) {
  const updateObj = isFunction22(update) ? update(expressionBuilder()) : update;
  return Object.entries(updateObj).filter(([_22, value]) => value !== undefined).map(([key, value]) => {
    return ColumnUpdateNode.create(ColumnNode.create(key), parseValueExpression(value));
  });
}
var init_update_set_parser = __esm2(() => {
  init_column_node();
  init_column_update_node();
  init_expression_builder();
  init_object_utils();
  init_value_parser();
  init_reference_parser();
});
var OnDuplicateKeyNode;
var init_on_duplicate_key_node = __esm2(() => {
  init_object_utils();
  OnDuplicateKeyNode = freeze({
    is(node) {
      return node.kind === "OnDuplicateKeyNode";
    },
    create(updates) {
      return freeze({
        kind: "OnDuplicateKeyNode",
        updates
      });
    }
  });
});

class InsertResult {
  insertId;
  numInsertedOrUpdatedRows;
  constructor(insertId, numInsertedOrUpdatedRows) {
    this.insertId = insertId;
    this.numInsertedOrUpdatedRows = numInsertedOrUpdatedRows;
  }
}
function isNoResultErrorConstructor(fn) {
  return Object.prototype.hasOwnProperty.call(fn, "prototype");
}
var NoResultError;
var init_no_result_error = __esm2(() => {
  NoResultError = class NoResultError2 extends Error {
    node;
    constructor(node) {
      super("no result");
      this.node = node;
    }
  };
});
var OnConflictNode;
var init_on_conflict_node = __esm2(() => {
  init_object_utils();
  init_where_node();
  OnConflictNode = freeze({
    is(node) {
      return node.kind === "OnConflictNode";
    },
    create() {
      return freeze({
        kind: "OnConflictNode"
      });
    },
    cloneWith(node, props) {
      return freeze({
        ...node,
        ...props
      });
    },
    cloneWithIndexWhere(node, operation) {
      return freeze({
        ...node,
        indexWhere: node.indexWhere ? WhereNode.cloneWithOperation(node.indexWhere, "And", operation) : WhereNode.create(operation)
      });
    },
    cloneWithIndexOrWhere(node, operation) {
      return freeze({
        ...node,
        indexWhere: node.indexWhere ? WhereNode.cloneWithOperation(node.indexWhere, "Or", operation) : WhereNode.create(operation)
      });
    },
    cloneWithUpdateWhere(node, operation) {
      return freeze({
        ...node,
        updateWhere: node.updateWhere ? WhereNode.cloneWithOperation(node.updateWhere, "And", operation) : WhereNode.create(operation)
      });
    },
    cloneWithUpdateOrWhere(node, operation) {
      return freeze({
        ...node,
        updateWhere: node.updateWhere ? WhereNode.cloneWithOperation(node.updateWhere, "Or", operation) : WhereNode.create(operation)
      });
    },
    cloneWithoutIndexWhere(node) {
      return freeze({
        ...node,
        indexWhere: undefined
      });
    },
    cloneWithoutUpdateWhere(node) {
      return freeze({
        ...node,
        updateWhere: undefined
      });
    }
  });
});

class OnConflictBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  column(column) {
    const columnNode = ColumnNode.create(column);
    return new OnConflictBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWith(this.#props.onConflictNode, {
        columns: this.#props.onConflictNode.columns ? freeze([...this.#props.onConflictNode.columns, columnNode]) : freeze([columnNode])
      })
    });
  }
  columns(columns) {
    const columnNodes = columns.map(ColumnNode.create);
    return new OnConflictBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWith(this.#props.onConflictNode, {
        columns: this.#props.onConflictNode.columns ? freeze([...this.#props.onConflictNode.columns, ...columnNodes]) : freeze(columnNodes)
      })
    });
  }
  constraint(constraintName) {
    return new OnConflictBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWith(this.#props.onConflictNode, {
        constraint: IdentifierNode.create(constraintName)
      })
    });
  }
  expression(expression) {
    return new OnConflictBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWith(this.#props.onConflictNode, {
        indexExpression: expression.toOperationNode()
      })
    });
  }
  where(...args) {
    return new OnConflictBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWithIndexWhere(this.#props.onConflictNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  whereRef(lhs, op, rhs) {
    return new OnConflictBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWithIndexWhere(this.#props.onConflictNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  clearWhere() {
    return new OnConflictBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWithoutIndexWhere(this.#props.onConflictNode)
    });
  }
  doNothing() {
    return new OnConflictDoNothingBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWith(this.#props.onConflictNode, {
        doNothing: true
      })
    });
  }
  doUpdateSet(update) {
    return new OnConflictUpdateBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWith(this.#props.onConflictNode, {
        updates: parseUpdateObjectExpression(update)
      })
    });
  }
  $call(func) {
    return func(this);
  }
}

class OnConflictDoNothingBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  toOperationNode() {
    return this.#props.onConflictNode;
  }
}

class OnConflictUpdateBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  where(...args) {
    return new OnConflictUpdateBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWithUpdateWhere(this.#props.onConflictNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  whereRef(lhs, op, rhs) {
    return new OnConflictUpdateBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWithUpdateWhere(this.#props.onConflictNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  clearWhere() {
    return new OnConflictUpdateBuilder({
      ...this.#props,
      onConflictNode: OnConflictNode.cloneWithoutUpdateWhere(this.#props.onConflictNode)
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.onConflictNode;
  }
}
var init_on_conflict_builder = __esm2(() => {
  init_column_node();
  init_identifier_node();
  init_on_conflict_node();
  init_binary_operation_parser();
  init_update_set_parser();
  init_object_utils();
  preventAwait(OnConflictBuilder, "don't await OnConflictBuilder instances.");
  preventAwait(OnConflictDoNothingBuilder, "don't await OnConflictDoNothingBuilder instances.");
  preventAwait(OnConflictUpdateBuilder, "don't await OnConflictUpdateBuilder instances.");
});
var TopNode;
var init_top_node = __esm2(() => {
  init_object_utils();
  TopNode = freeze({
    is(node) {
      return node.kind === "TopNode";
    },
    create(expression, modifiers) {
      return freeze({
        kind: "TopNode",
        expression,
        modifiers
      });
    }
  });
});
function parseTop(expression, modifiers) {
  if (!isNumber(expression) && !isBigInt(expression)) {
    throw new Error(`Invalid top expression: ${expression}`);
  }
  if (!isUndefined(modifiers) && !isTopModifiers(modifiers)) {
    throw new Error(`Invalid top modifiers: ${modifiers}`);
  }
  return TopNode.create(expression, modifiers);
}
function isTopModifiers(modifiers) {
  return modifiers === "percent" || modifiers === "with ties" || modifiers === "percent with ties";
}
var init_top_parser = __esm2(() => {
  init_top_node();
  init_object_utils();
});

class InsertQueryBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  values(insert) {
    const [columns, values3] = parseInsertExpression(insert);
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: InsertQueryNode.cloneWith(this.#props.queryNode, {
        columns,
        values: values3
      })
    });
  }
  columns(columns) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: InsertQueryNode.cloneWith(this.#props.queryNode, {
        columns: freeze(columns.map(ColumnNode.create))
      })
    });
  }
  expression(expression) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: InsertQueryNode.cloneWith(this.#props.queryNode, {
        values: parseExpression(expression)
      })
    });
  }
  defaultValues() {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: InsertQueryNode.cloneWith(this.#props.queryNode, {
        defaultValues: true
      })
    });
  }
  ignore() {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: InsertQueryNode.cloneWith(this.#props.queryNode, {
        ignore: true
      })
    });
  }
  top(expression, modifiers) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithTop(this.#props.queryNode, parseTop(expression, modifiers))
    });
  }
  onConflict(callback) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: InsertQueryNode.cloneWith(this.#props.queryNode, {
        onConflict: callback(new OnConflictBuilder({
          onConflictNode: OnConflictNode.create()
        })).toOperationNode()
      })
    });
  }
  onDuplicateKeyUpdate(update) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: InsertQueryNode.cloneWith(this.#props.queryNode, {
        onDuplicateKey: OnDuplicateKeyNode.create(parseUpdateObjectExpression(update))
      })
    });
  }
  returning(selection) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithReturning(this.#props.queryNode, parseSelectArg(selection))
    });
  }
  returningAll() {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithReturning(this.#props.queryNode, parseSelectAll())
    });
  }
  output(args) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectArg(args))
    });
  }
  outputAll(table) {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectAll(table))
    });
  }
  clearReturning() {
    return new InsertQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithoutReturning(this.#props.queryNode)
    });
  }
  $call(func) {
    return func(this);
  }
  $if(condition, func) {
    if (condition) {
      return func(this);
    }
    return new InsertQueryBuilder({
      ...this.#props
    });
  }
  $castTo() {
    return new InsertQueryBuilder(this.#props);
  }
  $narrowType() {
    return new InsertQueryBuilder(this.#props);
  }
  $assertType() {
    return new InsertQueryBuilder(this.#props);
  }
  withPlugin(plugin) {
    return new InsertQueryBuilder({
      ...this.#props,
      executor: this.#props.executor.withPlugin(plugin)
    });
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.queryNode, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    const compiledQuery = this.compile();
    const result2 = await this.#props.executor.executeQuery(compiledQuery, this.#props.queryId);
    const { adapter } = this.#props.executor;
    const query = compiledQuery.query;
    if (query.returning && adapter.supportsReturning || query.output && adapter.supportsOutput) {
      return result2.rows;
    }
    return [
      new InsertResult(result2.insertId, result2.numAffectedRows ?? result2.numUpdatedOrDeletedRows)
    ];
  }
  async executeTakeFirst() {
    const [result2] = await this.execute();
    return result2;
  }
  async executeTakeFirstOrThrow(errorConstructor = NoResultError) {
    const result2 = await this.executeTakeFirst();
    if (result2 === undefined) {
      const error = isNoResultErrorConstructor(errorConstructor) ? new errorConstructor(this.toOperationNode()) : errorConstructor(this.toOperationNode());
      throw error;
    }
    return result2;
  }
  async* stream(chunkSize = 100) {
    const compiledQuery = this.compile();
    const stream2 = this.#props.executor.stream(compiledQuery, chunkSize, this.#props.queryId);
    for await (const item of stream2) {
      yield* item.rows;
    }
  }
  async explain(format, options3) {
    const builder = new InsertQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithExplain(this.#props.queryNode, format, options3)
    });
    return await builder.execute();
  }
}
var init_insert_query_builder = __esm2(() => {
  init_select_parser();
  init_insert_values_parser();
  init_insert_query_node();
  init_query_node();
  init_update_set_parser();
  init_object_utils();
  init_on_duplicate_key_node();
  init_no_result_error();
  init_expression_parser();
  init_column_node();
  init_on_conflict_builder();
  init_on_conflict_node();
  init_top_parser();
  preventAwait(InsertQueryBuilder, "don't await InsertQueryBuilder instances directly. To execute the query you need to call `execute` or `executeTakeFirst`.");
});

class DeleteResult {
  numDeletedRows;
  constructor(numDeletedRows) {
    this.numDeletedRows = numDeletedRows;
  }
}
var LimitNode;
var init_limit_node = __esm2(() => {
  init_object_utils();
  LimitNode = freeze({
    is(node) {
      return node.kind === "LimitNode";
    },
    create(limit) {
      return freeze({
        kind: "LimitNode",
        limit
      });
    }
  });
});

class DeleteQueryBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  where(...args) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithWhere(this.#props.queryNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  whereRef(lhs, op, rhs) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithWhere(this.#props.queryNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  clearWhere() {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithoutWhere(this.#props.queryNode)
    });
  }
  top(expression, modifiers) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithTop(this.#props.queryNode, parseTop(expression, modifiers))
    });
  }
  using(tables2) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: DeleteQueryNode.cloneWithUsing(this.#props.queryNode, parseTableExpressionOrList(tables2))
    });
  }
  innerJoin(...args) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("InnerJoin", args))
    });
  }
  leftJoin(...args) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("LeftJoin", args))
    });
  }
  rightJoin(...args) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("RightJoin", args))
    });
  }
  fullJoin(...args) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("FullJoin", args))
    });
  }
  returning(selection) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithReturning(this.#props.queryNode, parseSelectArg(selection))
    });
  }
  returningAll(table) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithReturning(this.#props.queryNode, parseSelectAll(table))
    });
  }
  output(args) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectArg(args))
    });
  }
  outputAll(table) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectAll(table))
    });
  }
  clearReturning() {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithoutReturning(this.#props.queryNode)
    });
  }
  clearLimit() {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: DeleteQueryNode.cloneWithoutLimit(this.#props.queryNode)
    });
  }
  clearOrderBy() {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: DeleteQueryNode.cloneWithoutOrderBy(this.#props.queryNode)
    });
  }
  orderBy(orderBy, direction) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: DeleteQueryNode.cloneWithOrderByItems(this.#props.queryNode, parseOrderBy([orderBy, direction]))
    });
  }
  limit(limit) {
    return new DeleteQueryBuilder({
      ...this.#props,
      queryNode: DeleteQueryNode.cloneWithLimit(this.#props.queryNode, LimitNode.create(parseValueExpression(limit)))
    });
  }
  $call(func) {
    return func(this);
  }
  $if(condition, func) {
    if (condition) {
      return func(this);
    }
    return new DeleteQueryBuilder({
      ...this.#props
    });
  }
  $castTo() {
    return new DeleteQueryBuilder(this.#props);
  }
  $narrowType() {
    return new DeleteQueryBuilder(this.#props);
  }
  $assertType() {
    return new DeleteQueryBuilder(this.#props);
  }
  withPlugin(plugin) {
    return new DeleteQueryBuilder({
      ...this.#props,
      executor: this.#props.executor.withPlugin(plugin)
    });
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.queryNode, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    const compiledQuery = this.compile();
    const result2 = await this.#props.executor.executeQuery(compiledQuery, this.#props.queryId);
    const { adapter } = this.#props.executor;
    const query = compiledQuery.query;
    if (query.returning && adapter.supportsReturning || query.output && adapter.supportsOutput) {
      return result2.rows;
    }
    return [
      new DeleteResult(result2.numAffectedRows ?? result2.numUpdatedOrDeletedRows ?? BigInt(0))
    ];
  }
  async executeTakeFirst() {
    const [result2] = await this.execute();
    return result2;
  }
  async executeTakeFirstOrThrow(errorConstructor = NoResultError) {
    const result2 = await this.executeTakeFirst();
    if (result2 === undefined) {
      const error = isNoResultErrorConstructor(errorConstructor) ? new errorConstructor(this.toOperationNode()) : errorConstructor(this.toOperationNode());
      throw error;
    }
    return result2;
  }
  async* stream(chunkSize = 100) {
    const compiledQuery = this.compile();
    const stream2 = this.#props.executor.stream(compiledQuery, chunkSize, this.#props.queryId);
    for await (const item of stream2) {
      yield* item.rows;
    }
  }
  async explain(format, options3) {
    const builder = new DeleteQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithExplain(this.#props.queryNode, format, options3)
    });
    return await builder.execute();
  }
}
var init_delete_query_builder = __esm2(() => {
  init_join_parser();
  init_table_parser();
  init_select_parser();
  init_query_node();
  init_object_utils();
  init_no_result_error();
  init_delete_query_node();
  init_limit_node();
  init_order_by_parser();
  init_binary_operation_parser();
  init_value_parser();
  init_top_parser();
  preventAwait(DeleteQueryBuilder, "don't await DeleteQueryBuilder instances directly. To execute the query you need to call `execute` or `executeTakeFirst`.");
});

class UpdateResult {
  numUpdatedRows;
  numChangedRows;
  constructor(numUpdatedRows, numChangedRows) {
    this.numUpdatedRows = numUpdatedRows;
    this.numChangedRows = numChangedRows;
  }
}

class UpdateQueryBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  where(...args) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithWhere(this.#props.queryNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  whereRef(lhs, op, rhs) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithWhere(this.#props.queryNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  clearWhere() {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithoutWhere(this.#props.queryNode)
    });
  }
  top(expression, modifiers) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithTop(this.#props.queryNode, parseTop(expression, modifiers))
    });
  }
  from(from) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: UpdateQueryNode.cloneWithFromItems(this.#props.queryNode, parseTableExpressionOrList(from))
    });
  }
  innerJoin(...args) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("InnerJoin", args))
    });
  }
  leftJoin(...args) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("LeftJoin", args))
    });
  }
  rightJoin(...args) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("RightJoin", args))
    });
  }
  fullJoin(...args) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("FullJoin", args))
    });
  }
  limit(limit) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: UpdateQueryNode.cloneWithLimit(this.#props.queryNode, LimitNode.create(parseValueExpression(limit)))
    });
  }
  set(...args) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: UpdateQueryNode.cloneWithUpdates(this.#props.queryNode, parseUpdate(...args))
    });
  }
  returning(selection) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithReturning(this.#props.queryNode, parseSelectArg(selection))
    });
  }
  returningAll(table) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithReturning(this.#props.queryNode, parseSelectAll(table))
    });
  }
  output(args) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectArg(args))
    });
  }
  outputAll(table) {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectAll(table))
    });
  }
  clearReturning() {
    return new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithoutReturning(this.#props.queryNode)
    });
  }
  $call(func) {
    return func(this);
  }
  $if(condition, func) {
    if (condition) {
      return func(this);
    }
    return new UpdateQueryBuilder({
      ...this.#props
    });
  }
  $castTo() {
    return new UpdateQueryBuilder(this.#props);
  }
  $narrowType() {
    return new UpdateQueryBuilder(this.#props);
  }
  $assertType() {
    return new UpdateQueryBuilder(this.#props);
  }
  withPlugin(plugin) {
    return new UpdateQueryBuilder({
      ...this.#props,
      executor: this.#props.executor.withPlugin(plugin)
    });
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.queryNode, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    const compiledQuery = this.compile();
    const result2 = await this.#props.executor.executeQuery(compiledQuery, this.#props.queryId);
    const { adapter } = this.#props.executor;
    const query = compiledQuery.query;
    if (query.returning && adapter.supportsReturning || query.output && adapter.supportsOutput) {
      return result2.rows;
    }
    return [
      new UpdateResult(result2.numAffectedRows ?? result2.numUpdatedOrDeletedRows ?? BigInt(0), result2.numChangedRows)
    ];
  }
  async executeTakeFirst() {
    const [result2] = await this.execute();
    return result2;
  }
  async executeTakeFirstOrThrow(errorConstructor = NoResultError) {
    const result2 = await this.executeTakeFirst();
    if (result2 === undefined) {
      const error = isNoResultErrorConstructor(errorConstructor) ? new errorConstructor(this.toOperationNode()) : errorConstructor(this.toOperationNode());
      throw error;
    }
    return result2;
  }
  async* stream(chunkSize = 100) {
    const compiledQuery = this.compile();
    const stream2 = this.#props.executor.stream(compiledQuery, chunkSize, this.#props.queryId);
    for await (const item of stream2) {
      yield* item.rows;
    }
  }
  async explain(format, options3) {
    const builder = new UpdateQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithExplain(this.#props.queryNode, format, options3)
    });
    return await builder.execute();
  }
}
var init_update_query_builder = __esm2(() => {
  init_join_parser();
  init_table_parser();
  init_select_parser();
  init_query_node();
  init_update_query_node();
  init_update_set_parser();
  init_object_utils();
  init_no_result_error();
  init_binary_operation_parser();
  init_value_parser();
  init_limit_node();
  init_top_parser();
  preventAwait(UpdateQueryBuilder, "don't await UpdateQueryBuilder instances directly. To execute the query you need to call `execute` or `executeTakeFirst`.");
});
var CommonTableExpressionNameNode;
var init_common_table_expression_name_node = __esm2(() => {
  init_object_utils();
  init_column_node();
  init_table_node();
  CommonTableExpressionNameNode = freeze({
    is(node) {
      return node.kind === "CommonTableExpressionNameNode";
    },
    create(tableName, columnNames) {
      return freeze({
        kind: "CommonTableExpressionNameNode",
        table: TableNode.create(tableName),
        columns: columnNames ? freeze(columnNames.map(ColumnNode.create)) : undefined
      });
    }
  });
});
var CommonTableExpressionNode;
var init_common_table_expression_node = __esm2(() => {
  init_object_utils();
  CommonTableExpressionNode = freeze({
    is(node) {
      return node.kind === "CommonTableExpressionNode";
    },
    create(name, expression) {
      return freeze({
        kind: "CommonTableExpressionNode",
        name,
        expression
      });
    },
    cloneWith(node, props) {
      return freeze({
        ...node,
        ...props
      });
    }
  });
});

class CTEBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  materialized() {
    return new CTEBuilder({
      ...this.#props,
      node: CommonTableExpressionNode.cloneWith(this.#props.node, {
        materialized: true
      })
    });
  }
  notMaterialized() {
    return new CTEBuilder({
      ...this.#props,
      node: CommonTableExpressionNode.cloneWith(this.#props.node, {
        materialized: false
      })
    });
  }
  toOperationNode() {
    return this.#props.node;
  }
}
var init_cte_builder = __esm2(() => {
  init_common_table_expression_node();
  init_object_utils();
  preventAwait(CTEBuilder, "don't await CTEBuilder instances. They are never executed directly and are always just a part of a query.");
});
function parseCommonTableExpression(nameOrBuilderCallback, expression) {
  const expressionNode = expression(createQueryCreator()).toOperationNode();
  if (isFunction22(nameOrBuilderCallback)) {
    return nameOrBuilderCallback(cteBuilderFactory(expressionNode)).toOperationNode();
  }
  return CommonTableExpressionNode.create(parseCommonTableExpressionName(nameOrBuilderCallback), expressionNode);
}
function cteBuilderFactory(expressionNode) {
  return (name) => {
    return new CTEBuilder({
      node: CommonTableExpressionNode.create(parseCommonTableExpressionName(name), expressionNode)
    });
  };
}
function parseCommonTableExpressionName(name) {
  if (name.includes("(")) {
    const parts = name.split(/[\(\)]/);
    const table = parts[0];
    const columns = parts[1].split(",").map((it) => it.trim());
    return CommonTableExpressionNameNode.create(table, columns);
  } else {
    return CommonTableExpressionNameNode.create(name);
  }
}
var init_with_parser = __esm2(() => {
  init_common_table_expression_name_node();
  init_parse_utils();
  init_object_utils();
  init_cte_builder();
  init_common_table_expression_node();
});
var WithNode;
var init_with_node = __esm2(() => {
  init_object_utils();
  WithNode = freeze({
    is(node) {
      return node.kind === "WithNode";
    },
    create(expression, params) {
      return freeze({
        kind: "WithNode",
        expressions: freeze([expression]),
        ...params
      });
    },
    cloneWithExpression(withNode, expression) {
      return freeze({
        ...withNode,
        expressions: freeze([...withNode.expressions, expression])
      });
    }
  });
});
function randomString(length) {
  let chars3 = "";
  for (let i2 = 0;i2 < length; ++i2) {
    chars3 += randomChar();
  }
  return chars3;
}
function randomChar() {
  return CHARS[~~(Math.random() * CHARS.length)];
}
var CHARS;
var init_random_string = __esm2(() => {
  CHARS = [
    "A",
    "B",
    "C",
    "D",
    "E",
    "F",
    "G",
    "H",
    "I",
    "J",
    "K",
    "L",
    "M",
    "N",
    "O",
    "P",
    "Q",
    "R",
    "S",
    "T",
    "U",
    "V",
    "W",
    "X",
    "Y",
    "Z",
    "a",
    "b",
    "c",
    "d",
    "e",
    "f",
    "g",
    "h",
    "i",
    "j",
    "k",
    "l",
    "m",
    "n",
    "o",
    "p",
    "q",
    "r",
    "s",
    "t",
    "u",
    "v",
    "w",
    "x",
    "y",
    "z",
    "0",
    "1",
    "2",
    "3",
    "4",
    "5",
    "6",
    "7",
    "8",
    "9"
  ];
});
function createQueryId() {
  return new LazyQueryId;
}

class LazyQueryId {
  #queryId;
  get queryId() {
    if (this.#queryId === undefined) {
      this.#queryId = randomString(8);
    }
    return this.#queryId;
  }
}
var init_query_id = __esm2(() => {
  init_random_string();
});
function requireAllProps(obj) {
  return obj;
}

class OperationNodeTransformer {
  nodeStack = [];
  #transformers = freeze({
    AliasNode: this.transformAlias.bind(this),
    ColumnNode: this.transformColumn.bind(this),
    IdentifierNode: this.transformIdentifier.bind(this),
    SchemableIdentifierNode: this.transformSchemableIdentifier.bind(this),
    RawNode: this.transformRaw.bind(this),
    ReferenceNode: this.transformReference.bind(this),
    SelectQueryNode: this.transformSelectQuery.bind(this),
    SelectionNode: this.transformSelection.bind(this),
    TableNode: this.transformTable.bind(this),
    FromNode: this.transformFrom.bind(this),
    SelectAllNode: this.transformSelectAll.bind(this),
    AndNode: this.transformAnd.bind(this),
    OrNode: this.transformOr.bind(this),
    ValueNode: this.transformValue.bind(this),
    ValueListNode: this.transformValueList.bind(this),
    PrimitiveValueListNode: this.transformPrimitiveValueList.bind(this),
    ParensNode: this.transformParens.bind(this),
    JoinNode: this.transformJoin.bind(this),
    OperatorNode: this.transformOperator.bind(this),
    WhereNode: this.transformWhere.bind(this),
    InsertQueryNode: this.transformInsertQuery.bind(this),
    DeleteQueryNode: this.transformDeleteQuery.bind(this),
    ReturningNode: this.transformReturning.bind(this),
    CreateTableNode: this.transformCreateTable.bind(this),
    AddColumnNode: this.transformAddColumn.bind(this),
    ColumnDefinitionNode: this.transformColumnDefinition.bind(this),
    DropTableNode: this.transformDropTable.bind(this),
    DataTypeNode: this.transformDataType.bind(this),
    OrderByNode: this.transformOrderBy.bind(this),
    OrderByItemNode: this.transformOrderByItem.bind(this),
    GroupByNode: this.transformGroupBy.bind(this),
    GroupByItemNode: this.transformGroupByItem.bind(this),
    UpdateQueryNode: this.transformUpdateQuery.bind(this),
    ColumnUpdateNode: this.transformColumnUpdate.bind(this),
    LimitNode: this.transformLimit.bind(this),
    OffsetNode: this.transformOffset.bind(this),
    OnConflictNode: this.transformOnConflict.bind(this),
    OnDuplicateKeyNode: this.transformOnDuplicateKey.bind(this),
    CreateIndexNode: this.transformCreateIndex.bind(this),
    DropIndexNode: this.transformDropIndex.bind(this),
    ListNode: this.transformList.bind(this),
    PrimaryKeyConstraintNode: this.transformPrimaryKeyConstraint.bind(this),
    UniqueConstraintNode: this.transformUniqueConstraint.bind(this),
    ReferencesNode: this.transformReferences.bind(this),
    CheckConstraintNode: this.transformCheckConstraint.bind(this),
    WithNode: this.transformWith.bind(this),
    CommonTableExpressionNode: this.transformCommonTableExpression.bind(this),
    CommonTableExpressionNameNode: this.transformCommonTableExpressionName.bind(this),
    HavingNode: this.transformHaving.bind(this),
    CreateSchemaNode: this.transformCreateSchema.bind(this),
    DropSchemaNode: this.transformDropSchema.bind(this),
    AlterTableNode: this.transformAlterTable.bind(this),
    DropColumnNode: this.transformDropColumn.bind(this),
    RenameColumnNode: this.transformRenameColumn.bind(this),
    AlterColumnNode: this.transformAlterColumn.bind(this),
    ModifyColumnNode: this.transformModifyColumn.bind(this),
    AddConstraintNode: this.transformAddConstraint.bind(this),
    DropConstraintNode: this.transformDropConstraint.bind(this),
    ForeignKeyConstraintNode: this.transformForeignKeyConstraint.bind(this),
    CreateViewNode: this.transformCreateView.bind(this),
    DropViewNode: this.transformDropView.bind(this),
    GeneratedNode: this.transformGenerated.bind(this),
    DefaultValueNode: this.transformDefaultValue.bind(this),
    OnNode: this.transformOn.bind(this),
    ValuesNode: this.transformValues.bind(this),
    SelectModifierNode: this.transformSelectModifier.bind(this),
    CreateTypeNode: this.transformCreateType.bind(this),
    DropTypeNode: this.transformDropType.bind(this),
    ExplainNode: this.transformExplain.bind(this),
    DefaultInsertValueNode: this.transformDefaultInsertValue.bind(this),
    AggregateFunctionNode: this.transformAggregateFunction.bind(this),
    OverNode: this.transformOver.bind(this),
    PartitionByNode: this.transformPartitionBy.bind(this),
    PartitionByItemNode: this.transformPartitionByItem.bind(this),
    SetOperationNode: this.transformSetOperation.bind(this),
    BinaryOperationNode: this.transformBinaryOperation.bind(this),
    UnaryOperationNode: this.transformUnaryOperation.bind(this),
    UsingNode: this.transformUsing.bind(this),
    FunctionNode: this.transformFunction.bind(this),
    CaseNode: this.transformCase.bind(this),
    WhenNode: this.transformWhen.bind(this),
    JSONReferenceNode: this.transformJSONReference.bind(this),
    JSONPathNode: this.transformJSONPath.bind(this),
    JSONPathLegNode: this.transformJSONPathLeg.bind(this),
    JSONOperatorChainNode: this.transformJSONOperatorChain.bind(this),
    TupleNode: this.transformTuple.bind(this),
    MergeQueryNode: this.transformMergeQuery.bind(this),
    MatchedNode: this.transformMatched.bind(this),
    AddIndexNode: this.transformAddIndex.bind(this),
    CastNode: this.transformCast.bind(this),
    FetchNode: this.transformFetch.bind(this),
    TopNode: this.transformTop.bind(this),
    OutputNode: this.transformOutput.bind(this)
  });
  transformNode(node) {
    if (!node) {
      return node;
    }
    this.nodeStack.push(node);
    const out = this.transformNodeImpl(node);
    this.nodeStack.pop();
    return freeze(out);
  }
  transformNodeImpl(node) {
    return this.#transformers[node.kind](node);
  }
  transformNodeList(list2) {
    if (!list2) {
      return list2;
    }
    return freeze(list2.map((node) => this.transformNode(node)));
  }
  transformSelectQuery(node) {
    return requireAllProps({
      kind: "SelectQueryNode",
      from: this.transformNode(node.from),
      selections: this.transformNodeList(node.selections),
      distinctOn: this.transformNodeList(node.distinctOn),
      joins: this.transformNodeList(node.joins),
      groupBy: this.transformNode(node.groupBy),
      orderBy: this.transformNode(node.orderBy),
      where: this.transformNode(node.where),
      frontModifiers: this.transformNodeList(node.frontModifiers),
      endModifiers: this.transformNodeList(node.endModifiers),
      limit: this.transformNode(node.limit),
      offset: this.transformNode(node.offset),
      with: this.transformNode(node.with),
      having: this.transformNode(node.having),
      explain: this.transformNode(node.explain),
      setOperations: this.transformNodeList(node.setOperations),
      fetch: this.transformNode(node.fetch),
      top: this.transformNode(node.top)
    });
  }
  transformSelection(node) {
    return requireAllProps({
      kind: "SelectionNode",
      selection: this.transformNode(node.selection)
    });
  }
  transformColumn(node) {
    return requireAllProps({
      kind: "ColumnNode",
      column: this.transformNode(node.column)
    });
  }
  transformAlias(node) {
    return requireAllProps({
      kind: "AliasNode",
      node: this.transformNode(node.node),
      alias: this.transformNode(node.alias)
    });
  }
  transformTable(node) {
    return requireAllProps({
      kind: "TableNode",
      table: this.transformNode(node.table)
    });
  }
  transformFrom(node) {
    return requireAllProps({
      kind: "FromNode",
      froms: this.transformNodeList(node.froms)
    });
  }
  transformReference(node) {
    return requireAllProps({
      kind: "ReferenceNode",
      column: this.transformNode(node.column),
      table: this.transformNode(node.table)
    });
  }
  transformAnd(node) {
    return requireAllProps({
      kind: "AndNode",
      left: this.transformNode(node.left),
      right: this.transformNode(node.right)
    });
  }
  transformOr(node) {
    return requireAllProps({
      kind: "OrNode",
      left: this.transformNode(node.left),
      right: this.transformNode(node.right)
    });
  }
  transformValueList(node) {
    return requireAllProps({
      kind: "ValueListNode",
      values: this.transformNodeList(node.values)
    });
  }
  transformParens(node) {
    return requireAllProps({
      kind: "ParensNode",
      node: this.transformNode(node.node)
    });
  }
  transformJoin(node) {
    return requireAllProps({
      kind: "JoinNode",
      joinType: node.joinType,
      table: this.transformNode(node.table),
      on: this.transformNode(node.on)
    });
  }
  transformRaw(node) {
    return requireAllProps({
      kind: "RawNode",
      sqlFragments: freeze([...node.sqlFragments]),
      parameters: this.transformNodeList(node.parameters)
    });
  }
  transformWhere(node) {
    return requireAllProps({
      kind: "WhereNode",
      where: this.transformNode(node.where)
    });
  }
  transformInsertQuery(node) {
    return requireAllProps({
      kind: "InsertQueryNode",
      into: this.transformNode(node.into),
      columns: this.transformNodeList(node.columns),
      values: this.transformNode(node.values),
      returning: this.transformNode(node.returning),
      onConflict: this.transformNode(node.onConflict),
      onDuplicateKey: this.transformNode(node.onDuplicateKey),
      with: this.transformNode(node.with),
      ignore: node.ignore,
      replace: node.replace,
      explain: this.transformNode(node.explain),
      defaultValues: node.defaultValues,
      top: this.transformNode(node.top),
      output: this.transformNode(node.output)
    });
  }
  transformValues(node) {
    return requireAllProps({
      kind: "ValuesNode",
      values: this.transformNodeList(node.values)
    });
  }
  transformDeleteQuery(node) {
    return requireAllProps({
      kind: "DeleteQueryNode",
      from: this.transformNode(node.from),
      using: this.transformNode(node.using),
      joins: this.transformNodeList(node.joins),
      where: this.transformNode(node.where),
      returning: this.transformNode(node.returning),
      with: this.transformNode(node.with),
      orderBy: this.transformNode(node.orderBy),
      limit: this.transformNode(node.limit),
      explain: this.transformNode(node.explain),
      top: this.transformNode(node.top),
      output: this.transformNode(node.output)
    });
  }
  transformReturning(node) {
    return requireAllProps({
      kind: "ReturningNode",
      selections: this.transformNodeList(node.selections)
    });
  }
  transformCreateTable(node) {
    return requireAllProps({
      kind: "CreateTableNode",
      table: this.transformNode(node.table),
      columns: this.transformNodeList(node.columns),
      constraints: this.transformNodeList(node.constraints),
      temporary: node.temporary,
      ifNotExists: node.ifNotExists,
      onCommit: node.onCommit,
      frontModifiers: this.transformNodeList(node.frontModifiers),
      endModifiers: this.transformNodeList(node.endModifiers),
      selectQuery: this.transformNode(node.selectQuery)
    });
  }
  transformColumnDefinition(node) {
    return requireAllProps({
      kind: "ColumnDefinitionNode",
      column: this.transformNode(node.column),
      dataType: this.transformNode(node.dataType),
      references: this.transformNode(node.references),
      primaryKey: node.primaryKey,
      autoIncrement: node.autoIncrement,
      unique: node.unique,
      notNull: node.notNull,
      unsigned: node.unsigned,
      defaultTo: this.transformNode(node.defaultTo),
      check: this.transformNode(node.check),
      generated: this.transformNode(node.generated),
      frontModifiers: this.transformNodeList(node.frontModifiers),
      endModifiers: this.transformNodeList(node.endModifiers),
      nullsNotDistinct: node.nullsNotDistinct,
      identity: node.identity,
      ifNotExists: node.ifNotExists
    });
  }
  transformAddColumn(node) {
    return requireAllProps({
      kind: "AddColumnNode",
      column: this.transformNode(node.column)
    });
  }
  transformDropTable(node) {
    return requireAllProps({
      kind: "DropTableNode",
      table: this.transformNode(node.table),
      ifExists: node.ifExists,
      cascade: node.cascade
    });
  }
  transformOrderBy(node) {
    return requireAllProps({
      kind: "OrderByNode",
      items: this.transformNodeList(node.items)
    });
  }
  transformOrderByItem(node) {
    return requireAllProps({
      kind: "OrderByItemNode",
      orderBy: this.transformNode(node.orderBy),
      direction: this.transformNode(node.direction)
    });
  }
  transformGroupBy(node) {
    return requireAllProps({
      kind: "GroupByNode",
      items: this.transformNodeList(node.items)
    });
  }
  transformGroupByItem(node) {
    return requireAllProps({
      kind: "GroupByItemNode",
      groupBy: this.transformNode(node.groupBy)
    });
  }
  transformUpdateQuery(node) {
    return requireAllProps({
      kind: "UpdateQueryNode",
      table: this.transformNode(node.table),
      from: this.transformNode(node.from),
      joins: this.transformNodeList(node.joins),
      where: this.transformNode(node.where),
      updates: this.transformNodeList(node.updates),
      returning: this.transformNode(node.returning),
      with: this.transformNode(node.with),
      explain: this.transformNode(node.explain),
      limit: this.transformNode(node.limit),
      top: this.transformNode(node.top),
      output: this.transformNode(node.output)
    });
  }
  transformColumnUpdate(node) {
    return requireAllProps({
      kind: "ColumnUpdateNode",
      column: this.transformNode(node.column),
      value: this.transformNode(node.value)
    });
  }
  transformLimit(node) {
    return requireAllProps({
      kind: "LimitNode",
      limit: this.transformNode(node.limit)
    });
  }
  transformOffset(node) {
    return requireAllProps({
      kind: "OffsetNode",
      offset: this.transformNode(node.offset)
    });
  }
  transformOnConflict(node) {
    return requireAllProps({
      kind: "OnConflictNode",
      columns: this.transformNodeList(node.columns),
      constraint: this.transformNode(node.constraint),
      indexExpression: this.transformNode(node.indexExpression),
      indexWhere: this.transformNode(node.indexWhere),
      updates: this.transformNodeList(node.updates),
      updateWhere: this.transformNode(node.updateWhere),
      doNothing: node.doNothing
    });
  }
  transformOnDuplicateKey(node) {
    return requireAllProps({
      kind: "OnDuplicateKeyNode",
      updates: this.transformNodeList(node.updates)
    });
  }
  transformCreateIndex(node) {
    return requireAllProps({
      kind: "CreateIndexNode",
      name: this.transformNode(node.name),
      table: this.transformNode(node.table),
      columns: this.transformNodeList(node.columns),
      unique: node.unique,
      using: this.transformNode(node.using),
      ifNotExists: node.ifNotExists,
      where: this.transformNode(node.where),
      nullsNotDistinct: node.nullsNotDistinct
    });
  }
  transformList(node) {
    return requireAllProps({
      kind: "ListNode",
      items: this.transformNodeList(node.items)
    });
  }
  transformDropIndex(node) {
    return requireAllProps({
      kind: "DropIndexNode",
      name: this.transformNode(node.name),
      table: this.transformNode(node.table),
      ifExists: node.ifExists,
      cascade: node.cascade
    });
  }
  transformPrimaryKeyConstraint(node) {
    return requireAllProps({
      kind: "PrimaryKeyConstraintNode",
      columns: this.transformNodeList(node.columns),
      name: this.transformNode(node.name)
    });
  }
  transformUniqueConstraint(node) {
    return requireAllProps({
      kind: "UniqueConstraintNode",
      columns: this.transformNodeList(node.columns),
      name: this.transformNode(node.name),
      nullsNotDistinct: node.nullsNotDistinct
    });
  }
  transformForeignKeyConstraint(node) {
    return requireAllProps({
      kind: "ForeignKeyConstraintNode",
      columns: this.transformNodeList(node.columns),
      references: this.transformNode(node.references),
      name: this.transformNode(node.name),
      onDelete: node.onDelete,
      onUpdate: node.onUpdate
    });
  }
  transformSetOperation(node) {
    return requireAllProps({
      kind: "SetOperationNode",
      operator: node.operator,
      expression: this.transformNode(node.expression),
      all: node.all
    });
  }
  transformReferences(node) {
    return requireAllProps({
      kind: "ReferencesNode",
      table: this.transformNode(node.table),
      columns: this.transformNodeList(node.columns),
      onDelete: node.onDelete,
      onUpdate: node.onUpdate
    });
  }
  transformCheckConstraint(node) {
    return requireAllProps({
      kind: "CheckConstraintNode",
      expression: this.transformNode(node.expression),
      name: this.transformNode(node.name)
    });
  }
  transformWith(node) {
    return requireAllProps({
      kind: "WithNode",
      expressions: this.transformNodeList(node.expressions),
      recursive: node.recursive
    });
  }
  transformCommonTableExpression(node) {
    return requireAllProps({
      kind: "CommonTableExpressionNode",
      name: this.transformNode(node.name),
      materialized: node.materialized,
      expression: this.transformNode(node.expression)
    });
  }
  transformCommonTableExpressionName(node) {
    return requireAllProps({
      kind: "CommonTableExpressionNameNode",
      table: this.transformNode(node.table),
      columns: this.transformNodeList(node.columns)
    });
  }
  transformHaving(node) {
    return requireAllProps({
      kind: "HavingNode",
      having: this.transformNode(node.having)
    });
  }
  transformCreateSchema(node) {
    return requireAllProps({
      kind: "CreateSchemaNode",
      schema: this.transformNode(node.schema),
      ifNotExists: node.ifNotExists
    });
  }
  transformDropSchema(node) {
    return requireAllProps({
      kind: "DropSchemaNode",
      schema: this.transformNode(node.schema),
      ifExists: node.ifExists,
      cascade: node.cascade
    });
  }
  transformAlterTable(node) {
    return requireAllProps({
      kind: "AlterTableNode",
      table: this.transformNode(node.table),
      renameTo: this.transformNode(node.renameTo),
      setSchema: this.transformNode(node.setSchema),
      columnAlterations: this.transformNodeList(node.columnAlterations),
      addConstraint: this.transformNode(node.addConstraint),
      dropConstraint: this.transformNode(node.dropConstraint),
      addIndex: this.transformNode(node.addIndex),
      dropIndex: this.transformNode(node.dropIndex)
    });
  }
  transformDropColumn(node) {
    return requireAllProps({
      kind: "DropColumnNode",
      column: this.transformNode(node.column)
    });
  }
  transformRenameColumn(node) {
    return requireAllProps({
      kind: "RenameColumnNode",
      column: this.transformNode(node.column),
      renameTo: this.transformNode(node.renameTo)
    });
  }
  transformAlterColumn(node) {
    return requireAllProps({
      kind: "AlterColumnNode",
      column: this.transformNode(node.column),
      dataType: this.transformNode(node.dataType),
      dataTypeExpression: this.transformNode(node.dataTypeExpression),
      setDefault: this.transformNode(node.setDefault),
      dropDefault: node.dropDefault,
      setNotNull: node.setNotNull,
      dropNotNull: node.dropNotNull
    });
  }
  transformModifyColumn(node) {
    return requireAllProps({
      kind: "ModifyColumnNode",
      column: this.transformNode(node.column)
    });
  }
  transformAddConstraint(node) {
    return requireAllProps({
      kind: "AddConstraintNode",
      constraint: this.transformNode(node.constraint)
    });
  }
  transformDropConstraint(node) {
    return requireAllProps({
      kind: "DropConstraintNode",
      constraintName: this.transformNode(node.constraintName),
      ifExists: node.ifExists,
      modifier: node.modifier
    });
  }
  transformCreateView(node) {
    return requireAllProps({
      kind: "CreateViewNode",
      name: this.transformNode(node.name),
      temporary: node.temporary,
      orReplace: node.orReplace,
      ifNotExists: node.ifNotExists,
      materialized: node.materialized,
      columns: this.transformNodeList(node.columns),
      as: this.transformNode(node.as)
    });
  }
  transformDropView(node) {
    return requireAllProps({
      kind: "DropViewNode",
      name: this.transformNode(node.name),
      ifExists: node.ifExists,
      materialized: node.materialized,
      cascade: node.cascade
    });
  }
  transformGenerated(node) {
    return requireAllProps({
      kind: "GeneratedNode",
      byDefault: node.byDefault,
      always: node.always,
      identity: node.identity,
      stored: node.stored,
      expression: this.transformNode(node.expression)
    });
  }
  transformDefaultValue(node) {
    return requireAllProps({
      kind: "DefaultValueNode",
      defaultValue: this.transformNode(node.defaultValue)
    });
  }
  transformOn(node) {
    return requireAllProps({
      kind: "OnNode",
      on: this.transformNode(node.on)
    });
  }
  transformSelectModifier(node) {
    return requireAllProps({
      kind: "SelectModifierNode",
      modifier: node.modifier,
      rawModifier: this.transformNode(node.rawModifier),
      of: this.transformNodeList(node.of)
    });
  }
  transformCreateType(node) {
    return requireAllProps({
      kind: "CreateTypeNode",
      name: this.transformNode(node.name),
      enum: this.transformNode(node.enum)
    });
  }
  transformDropType(node) {
    return requireAllProps({
      kind: "DropTypeNode",
      name: this.transformNode(node.name),
      ifExists: node.ifExists
    });
  }
  transformExplain(node) {
    return requireAllProps({
      kind: "ExplainNode",
      format: node.format,
      options: this.transformNode(node.options)
    });
  }
  transformSchemableIdentifier(node) {
    return requireAllProps({
      kind: "SchemableIdentifierNode",
      schema: this.transformNode(node.schema),
      identifier: this.transformNode(node.identifier)
    });
  }
  transformAggregateFunction(node) {
    return requireAllProps({
      kind: "AggregateFunctionNode",
      aggregated: this.transformNodeList(node.aggregated),
      distinct: node.distinct,
      filter: this.transformNode(node.filter),
      func: node.func,
      over: this.transformNode(node.over)
    });
  }
  transformOver(node) {
    return requireAllProps({
      kind: "OverNode",
      orderBy: this.transformNode(node.orderBy),
      partitionBy: this.transformNode(node.partitionBy)
    });
  }
  transformPartitionBy(node) {
    return requireAllProps({
      kind: "PartitionByNode",
      items: this.transformNodeList(node.items)
    });
  }
  transformPartitionByItem(node) {
    return requireAllProps({
      kind: "PartitionByItemNode",
      partitionBy: this.transformNode(node.partitionBy)
    });
  }
  transformBinaryOperation(node) {
    return requireAllProps({
      kind: "BinaryOperationNode",
      leftOperand: this.transformNode(node.leftOperand),
      operator: this.transformNode(node.operator),
      rightOperand: this.transformNode(node.rightOperand)
    });
  }
  transformUnaryOperation(node) {
    return requireAllProps({
      kind: "UnaryOperationNode",
      operator: this.transformNode(node.operator),
      operand: this.transformNode(node.operand)
    });
  }
  transformUsing(node) {
    return requireAllProps({
      kind: "UsingNode",
      tables: this.transformNodeList(node.tables)
    });
  }
  transformFunction(node) {
    return requireAllProps({
      kind: "FunctionNode",
      func: node.func,
      arguments: this.transformNodeList(node.arguments)
    });
  }
  transformCase(node) {
    return requireAllProps({
      kind: "CaseNode",
      value: this.transformNode(node.value),
      when: this.transformNodeList(node.when),
      else: this.transformNode(node.else),
      isStatement: node.isStatement
    });
  }
  transformWhen(node) {
    return requireAllProps({
      kind: "WhenNode",
      condition: this.transformNode(node.condition),
      result: this.transformNode(node.result)
    });
  }
  transformJSONReference(node) {
    return requireAllProps({
      kind: "JSONReferenceNode",
      reference: this.transformNode(node.reference),
      traversal: this.transformNode(node.traversal)
    });
  }
  transformJSONPath(node) {
    return requireAllProps({
      kind: "JSONPathNode",
      inOperator: this.transformNode(node.inOperator),
      pathLegs: this.transformNodeList(node.pathLegs)
    });
  }
  transformJSONPathLeg(node) {
    return requireAllProps({
      kind: "JSONPathLegNode",
      type: node.type,
      value: node.value
    });
  }
  transformJSONOperatorChain(node) {
    return requireAllProps({
      kind: "JSONOperatorChainNode",
      operator: this.transformNode(node.operator),
      values: this.transformNodeList(node.values)
    });
  }
  transformTuple(node) {
    return requireAllProps({
      kind: "TupleNode",
      values: this.transformNodeList(node.values)
    });
  }
  transformMergeQuery(node) {
    return requireAllProps({
      kind: "MergeQueryNode",
      into: this.transformNode(node.into),
      using: this.transformNode(node.using),
      whens: this.transformNodeList(node.whens),
      with: this.transformNode(node.with),
      top: this.transformNode(node.top),
      output: this.transformNode(node.output)
    });
  }
  transformMatched(node) {
    return requireAllProps({
      kind: "MatchedNode",
      not: node.not,
      bySource: node.bySource
    });
  }
  transformAddIndex(node) {
    return requireAllProps({
      kind: "AddIndexNode",
      name: this.transformNode(node.name),
      columns: this.transformNodeList(node.columns),
      unique: node.unique,
      using: this.transformNode(node.using),
      ifNotExists: node.ifNotExists
    });
  }
  transformCast(node) {
    return requireAllProps({
      kind: "CastNode",
      expression: this.transformNode(node.expression),
      dataType: this.transformNode(node.dataType)
    });
  }
  transformFetch(node) {
    return requireAllProps({
      kind: "FetchNode",
      rowCount: this.transformNode(node.rowCount),
      modifier: node.modifier
    });
  }
  transformTop(node) {
    return requireAllProps({
      kind: "TopNode",
      expression: node.expression,
      modifiers: node.modifiers
    });
  }
  transformOutput(node) {
    return requireAllProps({
      kind: "OutputNode",
      selections: this.transformNodeList(node.selections)
    });
  }
  transformDataType(node) {
    return node;
  }
  transformSelectAll(node) {
    return node;
  }
  transformIdentifier(node) {
    return node;
  }
  transformValue(node) {
    return node;
  }
  transformPrimitiveValueList(node) {
    return node;
  }
  transformOperator(node) {
    return node;
  }
  transformDefaultInsertValue(node) {
    return node;
  }
}
var init_operation_node_transformer = __esm2(() => {
  init_object_utils();
});
var ROOT_OPERATION_NODES;
var WithSchemaTransformer;
var init_with_schema_transformer = __esm2(() => {
  init_alias_node();
  init_identifier_node();
  init_operation_node_transformer();
  init_schemable_identifier_node();
  init_table_node();
  init_object_utils();
  ROOT_OPERATION_NODES = freeze({
    AlterTableNode: true,
    CreateIndexNode: true,
    CreateSchemaNode: true,
    CreateTableNode: true,
    CreateTypeNode: true,
    CreateViewNode: true,
    DeleteQueryNode: true,
    DropIndexNode: true,
    DropSchemaNode: true,
    DropTableNode: true,
    DropTypeNode: true,
    DropViewNode: true,
    InsertQueryNode: true,
    RawNode: true,
    SelectQueryNode: true,
    UpdateQueryNode: true,
    MergeQueryNode: true
  });
  WithSchemaTransformer = class WithSchemaTransformer2 extends OperationNodeTransformer {
    #schema;
    #schemableIds = new Set;
    #ctes = new Set;
    constructor(schema2) {
      super();
      this.#schema = schema2;
    }
    transformNodeImpl(node) {
      if (!this.#isRootOperationNode(node)) {
        return super.transformNodeImpl(node);
      }
      const ctes = this.#collectCTEs(node);
      for (const cte of ctes) {
        this.#ctes.add(cte);
      }
      const tables2 = this.#collectSchemableIds(node);
      for (const table of tables2) {
        this.#schemableIds.add(table);
      }
      const transformed = super.transformNodeImpl(node);
      for (const table of tables2) {
        this.#schemableIds.delete(table);
      }
      for (const cte of ctes) {
        this.#ctes.delete(cte);
      }
      return transformed;
    }
    transformSchemableIdentifier(node) {
      const transformed = super.transformSchemableIdentifier(node);
      if (transformed.schema || !this.#schemableIds.has(node.identifier.name)) {
        return transformed;
      }
      return {
        ...transformed,
        schema: IdentifierNode.create(this.#schema)
      };
    }
    transformReferences(node) {
      const transformed = super.transformReferences(node);
      if (transformed.table.table.schema) {
        return transformed;
      }
      return {
        ...transformed,
        table: TableNode.createWithSchema(this.#schema, transformed.table.table.identifier.name)
      };
    }
    #isRootOperationNode(node) {
      return node.kind in ROOT_OPERATION_NODES;
    }
    #collectSchemableIds(node) {
      const schemableIds = new Set;
      if ("name" in node && node.name && SchemableIdentifierNode.is(node.name)) {
        this.#collectSchemableId(node.name, schemableIds);
      }
      if ("from" in node && node.from) {
        for (const from of node.from.froms) {
          this.#collectSchemableIdsFromTableExpr(from, schemableIds);
        }
      }
      if ("into" in node && node.into) {
        this.#collectSchemableIdsFromTableExpr(node.into, schemableIds);
      }
      if ("table" in node && node.table) {
        this.#collectSchemableIdsFromTableExpr(node.table, schemableIds);
      }
      if ("joins" in node && node.joins) {
        for (const join23 of node.joins) {
          this.#collectSchemableIdsFromTableExpr(join23.table, schemableIds);
        }
      }
      if ("using" in node && node.using) {
        this.#collectSchemableIdsFromTableExpr(node.using, schemableIds);
      }
      return schemableIds;
    }
    #collectCTEs(node) {
      const ctes = new Set;
      if ("with" in node && node.with) {
        this.#collectCTEIds(node.with, ctes);
      }
      return ctes;
    }
    #collectSchemableIdsFromTableExpr(node, schemableIds) {
      const table = TableNode.is(node) ? node : AliasNode.is(node) && TableNode.is(node.node) ? node.node : null;
      if (table) {
        this.#collectSchemableId(table.table, schemableIds);
      }
    }
    #collectSchemableId(node, schemableIds) {
      const id = node.identifier.name;
      if (!this.#schemableIds.has(id) && !this.#ctes.has(id)) {
        schemableIds.add(id);
      }
    }
    #collectCTEIds(node, ctes) {
      for (const expr of node.expressions) {
        const cteId = expr.name.table.table.identifier.name;
        if (!this.#ctes.has(cteId)) {
          ctes.add(cteId);
        }
      }
    }
  };
});

class WithSchemaPlugin {
  #transformer;
  constructor(schema2) {
    this.#transformer = new WithSchemaTransformer(schema2);
  }
  transformQuery(args) {
    return this.#transformer.transformNode(args.node);
  }
  async transformResult(args) {
    return args.result;
  }
}
var init_with_schema_plugin = __esm2(() => {
  init_with_schema_transformer();
});
var MatchedNode;
var init_matched_node = __esm2(() => {
  init_object_utils();
  MatchedNode = freeze({
    is(node) {
      return node.kind === "MatchedNode";
    },
    create(not, bySource = false) {
      return freeze({
        kind: "MatchedNode",
        not,
        bySource
      });
    }
  });
});
function parseMergeWhen(type, args, refRight) {
  return WhenNode.create(parseFilterList([
    MatchedNode.create(!type.isMatched, type.bySource),
    ...args && args.length > 0 ? [
      args.length === 3 && refRight ? parseReferentialBinaryOperation(args[0], args[1], args[2]) : parseValueBinaryOperationOrExpression(args)
    ] : []
  ], "and", false));
}
function parseMergeThen(result2) {
  if (isString22(result2)) {
    return RawNode.create([result2], []);
  }
  if (isOperationNodeSource(result2)) {
    return result2.toOperationNode();
  }
  return result2;
}
var init_merge_parser = __esm2(() => {
  init_matched_node();
  init_operation_node_source();
  init_raw_node();
  init_when_node();
  init_object_utils();
  init_binary_operation_parser();
});

class Deferred {
  #promise;
  #resolve;
  #reject;
  constructor() {
    this.#promise = new Promise((resolve5, reject) => {
      this.#reject = reject;
      this.#resolve = resolve5;
    });
  }
  get promise() {
    return this.#promise;
  }
  resolve = (value) => {
    if (this.#resolve) {
      this.#resolve(value);
    }
  };
  reject = (reason) => {
    if (this.#reject) {
      this.#reject(reason);
    }
  };
}
function logOnce(message) {
  if (LOGGED_MESSAGES.has(message)) {
    return;
  }
  LOGGED_MESSAGES.add(message);
  console.log(message);
}
var LOGGED_MESSAGES;
var init_log_once = __esm2(() => {
  LOGGED_MESSAGES = new Set;
});

class QueryExecutorBase {
  #plugins;
  constructor(plugins = NO_PLUGINS) {
    this.#plugins = plugins;
  }
  get plugins() {
    return this.#plugins;
  }
  transformQuery(node, queryId) {
    for (const plugin of this.#plugins) {
      const transformedNode = plugin.transformQuery({ node, queryId });
      if (transformedNode.kind === node.kind) {
        node = transformedNode;
      } else {
        throw new Error([
          `KyselyPlugin.transformQuery must return a node`,
          `of the same kind that was given to it.`,
          `The plugin was given a ${node.kind}`,
          `but it returned a ${transformedNode.kind}`
        ].join(" "));
      }
    }
    return node;
  }
  async executeQuery(compiledQuery, queryId) {
    return await this.provideConnection(async (connection) => {
      const result2 = await connection.executeQuery(compiledQuery);
      const transformedResult = await this.#transformResult(result2, queryId);
      warnOfOutdatedDriverOrPlugins(result2, transformedResult);
      return transformedResult;
    });
  }
  async* stream(compiledQuery, chunkSize, queryId) {
    const connectionDefer = new Deferred;
    const connectionReleaseDefer = new Deferred;
    this.provideConnection(async (connection2) => {
      connectionDefer.resolve(connection2);
      return await connectionReleaseDefer.promise;
    }).catch((ex) => connectionDefer.reject(ex));
    const connection = await connectionDefer.promise;
    try {
      for await (const result2 of connection.streamQuery(compiledQuery, chunkSize)) {
        yield await this.#transformResult(result2, queryId);
      }
    } finally {
      connectionReleaseDefer.resolve();
    }
  }
  async#transformResult(result2, queryId) {
    for (const plugin of this.#plugins) {
      result2 = await plugin.transformResult({ result: result2, queryId });
    }
    return result2;
  }
}
function warnOfOutdatedDriverOrPlugins(result2, transformedResult) {
  const { numAffectedRows } = result2;
  if (numAffectedRows === undefined && result2.numUpdatedOrDeletedRows === undefined || numAffectedRows !== undefined && transformedResult.numAffectedRows !== undefined) {
    return;
  }
  logOnce("kysely:warning: outdated driver/plugin detected! QueryResult.numUpdatedOrDeletedRows is deprecated and will be removed in a future release.");
}
var NO_PLUGINS;
var init_query_executor_base = __esm2(() => {
  init_object_utils();
  init_log_once();
  NO_PLUGINS = freeze([]);
});
var NoopQueryExecutor;
var NOOP_QUERY_EXECUTOR;
var init_noop_query_executor = __esm2(() => {
  init_query_executor_base();
  NoopQueryExecutor = class NoopQueryExecutor2 extends QueryExecutorBase {
    get adapter() {
      throw new Error("this query cannot be compiled to SQL");
    }
    compileQuery() {
      throw new Error("this query cannot be compiled to SQL");
    }
    provideConnection() {
      throw new Error("this query cannot be executed");
    }
    withConnectionProvider() {
      throw new Error("this query cannot have a connection provider");
    }
    withPlugin(plugin) {
      return new NoopQueryExecutor2([...this.plugins, plugin]);
    }
    withPlugins(plugins) {
      return new NoopQueryExecutor2([...this.plugins, ...plugins]);
    }
    withPluginAtFront(plugin) {
      return new NoopQueryExecutor2([plugin, ...this.plugins]);
    }
    withoutPlugins() {
      return new NoopQueryExecutor2([]);
    }
  };
  NOOP_QUERY_EXECUTOR = new NoopQueryExecutor;
});

class MergeResult {
  numChangedRows;
  constructor(numChangedRows) {
    this.numChangedRows = numChangedRows;
  }
}

class MergeQueryBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  top(expression, modifiers) {
    return new MergeQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithTop(this.#props.queryNode, parseTop(expression, modifiers))
    });
  }
  using(...args) {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithUsing(this.#props.queryNode, parseJoin("Using", args))
    });
  }
  output(args) {
    return new MergeQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectArg(args))
    });
  }
  outputAll(table) {
    return new MergeQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectAll(table))
    });
  }
}

class WheneableMergeQueryBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  top(expression, modifiers) {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithTop(this.#props.queryNode, parseTop(expression, modifiers))
    });
  }
  whenMatched() {
    return this.#whenMatched([]);
  }
  whenMatchedAnd(...args) {
    return this.#whenMatched(args);
  }
  whenMatchedAndRef(lhs, op, rhs) {
    return this.#whenMatched([lhs, op, rhs], true);
  }
  #whenMatched(args, refRight) {
    return new MatchedThenableMergeQueryBuilder({
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithWhen(this.#props.queryNode, parseMergeWhen({ isMatched: true }, args, refRight))
    });
  }
  whenNotMatched() {
    return this.#whenNotMatched([]);
  }
  whenNotMatchedAnd(...args) {
    return this.#whenNotMatched(args);
  }
  whenNotMatchedAndRef(lhs, op, rhs) {
    return this.#whenNotMatched([lhs, op, rhs], true);
  }
  whenNotMatchedBySource() {
    return this.#whenNotMatched([], false, true);
  }
  whenNotMatchedBySourceAnd(...args) {
    return this.#whenNotMatched(args, false, true);
  }
  whenNotMatchedBySourceAndRef(lhs, op, rhs) {
    return this.#whenNotMatched([lhs, op, rhs], true, true);
  }
  output(args) {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectArg(args))
    });
  }
  outputAll(table) {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: QueryNode.cloneWithOutput(this.#props.queryNode, parseSelectAll(table))
    });
  }
  #whenNotMatched(args, refRight = false, bySource = false) {
    const props = {
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithWhen(this.#props.queryNode, parseMergeWhen({ isMatched: false, bySource }, args, refRight))
    };
    const Builder = bySource ? MatchedThenableMergeQueryBuilder : NotMatchedThenableMergeQueryBuilder;
    return new Builder(props);
  }
  $call(func) {
    return func(this);
  }
  $if(condition, func) {
    if (condition) {
      return func(this);
    }
    return new WheneableMergeQueryBuilder({
      ...this.#props
    });
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.queryNode, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    const compiledQuery = this.compile();
    const result2 = await this.#props.executor.executeQuery(compiledQuery, this.#props.queryId);
    if (compiledQuery.query.output && this.#props.executor.adapter.supportsOutput) {
      return result2.rows;
    }
    return [new MergeResult(result2.numAffectedRows)];
  }
  async executeTakeFirst() {
    const [result2] = await this.execute();
    return result2;
  }
  async executeTakeFirstOrThrow(errorConstructor = NoResultError) {
    const result2 = await this.executeTakeFirst();
    if (result2 === undefined) {
      const error = isNoResultErrorConstructor(errorConstructor) ? new errorConstructor(this.toOperationNode()) : errorConstructor(this.toOperationNode());
      throw error;
    }
    return result2;
  }
}

class MatchedThenableMergeQueryBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  thenDelete() {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithThen(this.#props.queryNode, parseMergeThen("delete"))
    });
  }
  thenDoNothing() {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithThen(this.#props.queryNode, parseMergeThen("do nothing"))
    });
  }
  thenUpdate(set) {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithThen(this.#props.queryNode, parseMergeThen(set(new UpdateQueryBuilder({
        queryId: this.#props.queryId,
        executor: NOOP_QUERY_EXECUTOR,
        queryNode: UpdateQueryNode.createWithoutTable()
      }))))
    });
  }
  thenUpdateSet(...args) {
    return this.thenUpdate((ub) => ub.set(...args));
  }
}

class NotMatchedThenableMergeQueryBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  thenDoNothing() {
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithThen(this.#props.queryNode, parseMergeThen("do nothing"))
    });
  }
  thenInsertValues(insert) {
    const [columns, values3] = parseInsertExpression(insert);
    return new WheneableMergeQueryBuilder({
      ...this.#props,
      queryNode: MergeQueryNode.cloneWithThen(this.#props.queryNode, parseMergeThen(InsertQueryNode.cloneWith(InsertQueryNode.createWithoutInto(), {
        columns,
        values: values3
      })))
    });
  }
}
var init_merge_query_builder = __esm2(() => {
  init_insert_query_node();
  init_merge_query_node();
  init_query_node();
  init_update_query_node();
  init_insert_values_parser();
  init_join_parser();
  init_merge_parser();
  init_select_parser();
  init_top_parser();
  init_noop_query_executor();
  init_object_utils();
  init_no_result_error();
  init_update_query_builder();
  preventAwait(MergeQueryBuilder, "don't await MergeQueryBuilder instances directly. To execute the query you need to call `execute` when available.");
  preventAwait(WheneableMergeQueryBuilder, "don't await WheneableMergeQueryBuilder instances directly. To execute the query you need to call `execute`.");
  preventAwait(MatchedThenableMergeQueryBuilder, "don't await MatchedThenableMergeQueryBuilder instances directly. To execute the query you need to call `execute` when available.");
  preventAwait(NotMatchedThenableMergeQueryBuilder, "don't await NotMatchedThenableMergeQueryBuilder instances directly. To execute the query you need to call `execute` when available.");
});

class QueryCreator {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  selectFrom(from) {
    return createSelectQueryBuilder({
      queryId: createQueryId(),
      executor: this.#props.executor,
      queryNode: SelectQueryNode.createFrom(parseTableExpressionOrList(from), this.#props.withNode)
    });
  }
  selectNoFrom(selection) {
    return createSelectQueryBuilder({
      queryId: createQueryId(),
      executor: this.#props.executor,
      queryNode: SelectQueryNode.cloneWithSelections(SelectQueryNode.create(this.#props.withNode), parseSelectArg(selection))
    });
  }
  insertInto(table) {
    return new InsertQueryBuilder({
      queryId: createQueryId(),
      executor: this.#props.executor,
      queryNode: InsertQueryNode.create(parseTable(table), this.#props.withNode)
    });
  }
  replaceInto(table) {
    return new InsertQueryBuilder({
      queryId: createQueryId(),
      executor: this.#props.executor,
      queryNode: InsertQueryNode.create(parseTable(table), this.#props.withNode, true)
    });
  }
  deleteFrom(tables2) {
    return new DeleteQueryBuilder({
      queryId: createQueryId(),
      executor: this.#props.executor,
      queryNode: DeleteQueryNode.create(parseTableExpressionOrList(tables2), this.#props.withNode)
    });
  }
  updateTable(table) {
    return new UpdateQueryBuilder({
      queryId: createQueryId(),
      executor: this.#props.executor,
      queryNode: UpdateQueryNode.create(parseTableExpression(table), this.#props.withNode)
    });
  }
  mergeInto(targetTable) {
    return new MergeQueryBuilder({
      queryId: createQueryId(),
      executor: this.#props.executor,
      queryNode: MergeQueryNode.create(parseAliasedTable(targetTable), this.#props.withNode)
    });
  }
  with(nameOrBuilder, expression) {
    const cte = parseCommonTableExpression(nameOrBuilder, expression);
    return new QueryCreator({
      ...this.#props,
      withNode: this.#props.withNode ? WithNode.cloneWithExpression(this.#props.withNode, cte) : WithNode.create(cte)
    });
  }
  withRecursive(nameOrBuilder, expression) {
    const cte = parseCommonTableExpression(nameOrBuilder, expression);
    return new QueryCreator({
      ...this.#props,
      withNode: this.#props.withNode ? WithNode.cloneWithExpression(this.#props.withNode, cte) : WithNode.create(cte, { recursive: true })
    });
  }
  withPlugin(plugin) {
    return new QueryCreator({
      ...this.#props,
      executor: this.#props.executor.withPlugin(plugin)
    });
  }
  withoutPlugins() {
    return new QueryCreator({
      ...this.#props,
      executor: this.#props.executor.withoutPlugins()
    });
  }
  withSchema(schema2) {
    return new QueryCreator({
      ...this.#props,
      executor: this.#props.executor.withPluginAtFront(new WithSchemaPlugin(schema2))
    });
  }
}
var init_query_creator = __esm2(() => {
  init_select_query_builder();
  init_insert_query_builder();
  init_delete_query_builder();
  init_update_query_builder();
  init_delete_query_node();
  init_insert_query_node();
  init_select_query_node();
  init_update_query_node();
  init_table_parser();
  init_with_parser();
  init_with_node();
  init_query_id();
  init_with_schema_plugin();
  init_object_utils();
  init_select_parser();
  init_merge_query_builder();
  init_merge_query_node();
});
function createQueryCreator() {
  return new QueryCreator({
    executor: NOOP_QUERY_EXECUTOR
  });
}
function createJoinBuilder(joinType, table) {
  return new JoinBuilder({
    joinNode: JoinNode.create(joinType, parseTableExpression(table))
  });
}
function createOverBuilder() {
  return new OverBuilder({
    overNode: OverNode.create()
  });
}
var init_parse_utils = __esm2(() => {
  init_join_node();
  init_over_node();
  init_select_query_node();
  init_join_builder();
  init_over_builder();
  init_select_query_builder();
  init_query_creator();
  init_noop_query_executor();
  init_query_id();
  init_table_parser();
});
function parseJoin(joinType, args) {
  if (args.length === 3) {
    return parseSingleOnJoin(joinType, args[0], args[1], args[2]);
  } else if (args.length === 2) {
    return parseCallbackJoin(joinType, args[0], args[1]);
  } else {
    throw new Error("not implemented");
  }
}
function parseCallbackJoin(joinType, from, callback) {
  return callback(createJoinBuilder(joinType, from)).toOperationNode();
}
function parseSingleOnJoin(joinType, from, lhsColumn, rhsColumn) {
  return JoinNode.createWithOn(joinType, parseTableExpression(from), parseReferentialBinaryOperation(lhsColumn, "=", rhsColumn));
}
var init_join_parser = __esm2(() => {
  init_join_node();
  init_table_parser();
  init_binary_operation_parser();
  init_parse_utils();
});
var OffsetNode;
var init_offset_node = __esm2(() => {
  init_object_utils();
  OffsetNode = freeze({
    is(node) {
      return node.kind === "OffsetNode";
    },
    create(offset2) {
      return freeze({
        kind: "OffsetNode",
        offset: offset2
      });
    }
  });
});
var GroupByItemNode;
var init_group_by_item_node = __esm2(() => {
  init_object_utils();
  GroupByItemNode = freeze({
    is(node) {
      return node.kind === "GroupByItemNode";
    },
    create(groupBy) {
      return freeze({
        kind: "GroupByItemNode",
        groupBy
      });
    }
  });
});
function parseGroupBy(groupBy) {
  groupBy = isFunction22(groupBy) ? groupBy(expressionBuilder()) : groupBy;
  return parseReferenceExpressionOrList(groupBy).map(GroupByItemNode.create);
}
var init_group_by_parser = __esm2(() => {
  init_group_by_item_node();
  init_expression_builder();
  init_object_utils();
  init_reference_parser();
});
var SetOperationNode;
var init_set_operation_node = __esm2(() => {
  init_object_utils();
  SetOperationNode = freeze({
    is(node) {
      return node.kind === "SetOperationNode";
    },
    create(operator, expression, all) {
      return freeze({
        kind: "SetOperationNode",
        operator,
        expression,
        all
      });
    }
  });
});
function parseSetOperations(operator, expression, all) {
  if (isFunction22(expression)) {
    expression = expression(createExpressionBuilder());
  }
  if (!isReadonlyArray(expression)) {
    expression = [expression];
  }
  return expression.map((expr) => SetOperationNode.create(operator, parseExpression(expr), all));
}
var init_set_operation_parser = __esm2(() => {
  init_expression_builder();
  init_set_operation_node();
  init_object_utils();
  init_expression_parser();
});

class ExpressionWrapper {
  #node;
  constructor(node) {
    this.#node = node;
  }
  get expressionType() {
    return;
  }
  as(alias) {
    return new AliasedExpressionWrapper(this, alias);
  }
  or(...args) {
    return new OrWrapper(OrNode.create(this.#node, parseValueBinaryOperationOrExpression(args)));
  }
  and(...args) {
    return new AndWrapper(AndNode.create(this.#node, parseValueBinaryOperationOrExpression(args)));
  }
  $castTo() {
    return new ExpressionWrapper(this.#node);
  }
  $notNull() {
    return new ExpressionWrapper(this.#node);
  }
  toOperationNode() {
    return this.#node;
  }
}

class AliasedExpressionWrapper {
  #expr;
  #alias;
  constructor(expr, alias) {
    this.#expr = expr;
    this.#alias = alias;
  }
  get expression() {
    return this.#expr;
  }
  get alias() {
    return this.#alias;
  }
  toOperationNode() {
    return AliasNode.create(this.#expr.toOperationNode(), isOperationNodeSource(this.#alias) ? this.#alias.toOperationNode() : IdentifierNode.create(this.#alias));
  }
}

class OrWrapper {
  #node;
  constructor(node) {
    this.#node = node;
  }
  get expressionType() {
    return;
  }
  as(alias) {
    return new AliasedExpressionWrapper(this, alias);
  }
  or(...args) {
    return new OrWrapper(OrNode.create(this.#node, parseValueBinaryOperationOrExpression(args)));
  }
  $castTo() {
    return new OrWrapper(this.#node);
  }
  toOperationNode() {
    return ParensNode.create(this.#node);
  }
}

class AndWrapper {
  #node;
  constructor(node) {
    this.#node = node;
  }
  get expressionType() {
    return;
  }
  as(alias) {
    return new AliasedExpressionWrapper(this, alias);
  }
  and(...args) {
    return new AndWrapper(AndNode.create(this.#node, parseValueBinaryOperationOrExpression(args)));
  }
  $castTo() {
    return new AndWrapper(this.#node);
  }
  toOperationNode() {
    return ParensNode.create(this.#node);
  }
}
var init_expression_wrapper = __esm2(() => {
  init_alias_node();
  init_and_node();
  init_identifier_node();
  init_operation_node_source();
  init_or_node();
  init_parens_node();
  init_binary_operation_parser();
});
var FetchNode;
var init_fetch_node = __esm2(() => {
  init_value_node();
  FetchNode = {
    is(node) {
      return node.kind === "FetchNode";
    },
    create(rowCount, modifier) {
      return {
        kind: "FetchNode",
        rowCount: ValueNode.create(rowCount),
        modifier
      };
    }
  };
});
function parseFetch(rowCount, modifier) {
  if (!isNumber(rowCount) && !isBigInt(rowCount)) {
    throw new Error(`Invalid fetch row count: ${rowCount}`);
  }
  if (!isFetchModifier(modifier)) {
    throw new Error(`Invalid fetch modifier: ${modifier}`);
  }
  return FetchNode.create(rowCount, modifier);
}
function isFetchModifier(value) {
  return value === "only" || value === "with ties";
}
var init_fetch_parser = __esm2(() => {
  init_fetch_node();
  init_object_utils();
});

class SelectQueryBuilderImpl {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  get expressionType() {
    return;
  }
  get isSelectQueryBuilder() {
    return true;
  }
  where(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithWhere(this.#props.queryNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  whereRef(lhs, op, rhs) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithWhere(this.#props.queryNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  having(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithHaving(this.#props.queryNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  havingRef(lhs, op, rhs) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithHaving(this.#props.queryNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  select(selection) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSelections(this.#props.queryNode, parseSelectArg(selection))
    });
  }
  distinctOn(selection) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithDistinctOn(this.#props.queryNode, parseReferenceExpressionOrList(selection))
    });
  }
  modifyFront(modifier) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithFrontModifier(this.#props.queryNode, SelectModifierNode.createWithExpression(modifier.toOperationNode()))
    });
  }
  modifyEnd(modifier) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithEndModifier(this.#props.queryNode, SelectModifierNode.createWithExpression(modifier.toOperationNode()))
    });
  }
  distinct() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithFrontModifier(this.#props.queryNode, SelectModifierNode.create("Distinct"))
    });
  }
  forUpdate(of) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithEndModifier(this.#props.queryNode, SelectModifierNode.create("ForUpdate", of ? asArray(of).map(parseTable) : undefined))
    });
  }
  forShare(of) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithEndModifier(this.#props.queryNode, SelectModifierNode.create("ForShare", of ? asArray(of).map(parseTable) : undefined))
    });
  }
  forKeyShare(of) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithEndModifier(this.#props.queryNode, SelectModifierNode.create("ForKeyShare", of ? asArray(of).map(parseTable) : undefined))
    });
  }
  forNoKeyUpdate(of) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithEndModifier(this.#props.queryNode, SelectModifierNode.create("ForNoKeyUpdate", of ? asArray(of).map(parseTable) : undefined))
    });
  }
  skipLocked() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithEndModifier(this.#props.queryNode, SelectModifierNode.create("SkipLocked"))
    });
  }
  noWait() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithEndModifier(this.#props.queryNode, SelectModifierNode.create("NoWait"))
    });
  }
  selectAll(table) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSelections(this.#props.queryNode, parseSelectAll(table))
    });
  }
  innerJoin(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("InnerJoin", args))
    });
  }
  leftJoin(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("LeftJoin", args))
    });
  }
  rightJoin(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("RightJoin", args))
    });
  }
  fullJoin(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("FullJoin", args))
    });
  }
  innerJoinLateral(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("LateralInnerJoin", args))
    });
  }
  leftJoinLateral(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithJoin(this.#props.queryNode, parseJoin("LateralLeftJoin", args))
    });
  }
  orderBy(...args) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithOrderByItems(this.#props.queryNode, parseOrderBy(args))
    });
  }
  groupBy(groupBy) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithGroupByItems(this.#props.queryNode, parseGroupBy(groupBy))
    });
  }
  limit(limit) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithLimit(this.#props.queryNode, LimitNode.create(parseValueExpression(limit)))
    });
  }
  offset(offset2) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithOffset(this.#props.queryNode, OffsetNode.create(parseValueExpression(offset2)))
    });
  }
  fetch(rowCount, modifier = "only") {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithFetch(this.#props.queryNode, parseFetch(rowCount, modifier))
    });
  }
  top(expression, modifiers) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithTop(this.#props.queryNode, parseTop(expression, modifiers))
    });
  }
  union(expression) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSetOperations(this.#props.queryNode, parseSetOperations("union", expression, false))
    });
  }
  unionAll(expression) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSetOperations(this.#props.queryNode, parseSetOperations("union", expression, true))
    });
  }
  intersect(expression) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSetOperations(this.#props.queryNode, parseSetOperations("intersect", expression, false))
    });
  }
  intersectAll(expression) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSetOperations(this.#props.queryNode, parseSetOperations("intersect", expression, true))
    });
  }
  except(expression) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSetOperations(this.#props.queryNode, parseSetOperations("except", expression, false))
    });
  }
  exceptAll(expression) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithSetOperations(this.#props.queryNode, parseSetOperations("except", expression, true))
    });
  }
  as(alias) {
    return new AliasedSelectQueryBuilderImpl(this, alias);
  }
  clearSelect() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithoutSelections(this.#props.queryNode)
    });
  }
  clearWhere() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithoutWhere(this.#props.queryNode)
    });
  }
  clearLimit() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithoutLimit(this.#props.queryNode)
    });
  }
  clearOffset() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithoutOffset(this.#props.queryNode)
    });
  }
  clearOrderBy() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithoutOrderBy(this.#props.queryNode)
    });
  }
  clearGroupBy() {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: SelectQueryNode.cloneWithoutGroupBy(this.#props.queryNode)
    });
  }
  $call(func) {
    return func(this);
  }
  $if(condition, func) {
    if (condition) {
      return func(this);
    }
    return new SelectQueryBuilderImpl({
      ...this.#props
    });
  }
  $castTo() {
    return new SelectQueryBuilderImpl(this.#props);
  }
  $narrowType() {
    return new SelectQueryBuilderImpl(this.#props);
  }
  $assertType() {
    return new SelectQueryBuilderImpl(this.#props);
  }
  $asTuple() {
    return new ExpressionWrapper(this.toOperationNode());
  }
  withPlugin(plugin) {
    return new SelectQueryBuilderImpl({
      ...this.#props,
      executor: this.#props.executor.withPlugin(plugin)
    });
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.queryNode, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    const compiledQuery = this.compile();
    const result2 = await this.#props.executor.executeQuery(compiledQuery, this.#props.queryId);
    return result2.rows;
  }
  async executeTakeFirst() {
    const [result2] = await this.execute();
    return result2;
  }
  async executeTakeFirstOrThrow(errorConstructor = NoResultError) {
    const result2 = await this.executeTakeFirst();
    if (result2 === undefined) {
      const error = isNoResultErrorConstructor(errorConstructor) ? new errorConstructor(this.toOperationNode()) : errorConstructor(this.toOperationNode());
      throw error;
    }
    return result2;
  }
  async* stream(chunkSize = 100) {
    const compiledQuery = this.compile();
    const stream2 = this.#props.executor.stream(compiledQuery, chunkSize, this.#props.queryId);
    for await (const item of stream2) {
      yield* item.rows;
    }
  }
  async explain(format, options3) {
    const builder = new SelectQueryBuilderImpl({
      ...this.#props,
      queryNode: QueryNode.cloneWithExplain(this.#props.queryNode, format, options3)
    });
    return await builder.execute();
  }
}
function createSelectQueryBuilder(props) {
  return new SelectQueryBuilderImpl(props);
}

class AliasedSelectQueryBuilderImpl {
  #queryBuilder;
  #alias;
  constructor(queryBuilder, alias) {
    this.#queryBuilder = queryBuilder;
    this.#alias = alias;
  }
  get expression() {
    return this.#queryBuilder;
  }
  get alias() {
    return this.#alias;
  }
  get isAliasedSelectQueryBuilder() {
    return true;
  }
  toOperationNode() {
    return AliasNode.create(this.#queryBuilder.toOperationNode(), IdentifierNode.create(this.#alias));
  }
}
var init_select_query_builder = __esm2(() => {
  init_alias_node();
  init_select_modifier_node();
  init_join_parser();
  init_table_parser();
  init_select_parser();
  init_reference_parser();
  init_select_query_node();
  init_query_node();
  init_order_by_parser();
  init_limit_node();
  init_offset_node();
  init_object_utils();
  init_group_by_parser();
  init_no_result_error();
  init_identifier_node();
  init_set_operation_parser();
  init_binary_operation_parser();
  init_expression_wrapper();
  init_value_parser();
  init_fetch_parser();
  init_top_parser();
  preventAwait(SelectQueryBuilderImpl, "don't await SelectQueryBuilder instances directly. To execute the query you need to call `execute` or `executeTakeFirst`.");
  preventAwait(AliasedSelectQueryBuilderImpl, "don't await AliasedSelectQueryBuilder instances directly. AliasedSelectQueryBuilder should never be executed directly since it's always a part of another query.");
});
var AggregateFunctionNode;
var init_aggregate_function_node = __esm2(() => {
  init_object_utils();
  init_where_node();
  AggregateFunctionNode = freeze({
    is(node) {
      return node.kind === "AggregateFunctionNode";
    },
    create(aggregateFunction, aggregated = []) {
      return freeze({
        kind: "AggregateFunctionNode",
        func: aggregateFunction,
        aggregated
      });
    },
    cloneWithDistinct(aggregateFunctionNode) {
      return freeze({
        ...aggregateFunctionNode,
        distinct: true
      });
    },
    cloneWithFilter(aggregateFunctionNode, filter) {
      return freeze({
        ...aggregateFunctionNode,
        filter: aggregateFunctionNode.filter ? WhereNode.cloneWithOperation(aggregateFunctionNode.filter, "And", filter) : WhereNode.create(filter)
      });
    },
    cloneWithOrFilter(aggregateFunctionNode, filter) {
      return freeze({
        ...aggregateFunctionNode,
        filter: aggregateFunctionNode.filter ? WhereNode.cloneWithOperation(aggregateFunctionNode.filter, "Or", filter) : WhereNode.create(filter)
      });
    },
    cloneWithOver(aggregateFunctionNode, over) {
      return freeze({
        ...aggregateFunctionNode,
        over
      });
    }
  });
});
var FunctionNode2;
var init_function_node = __esm2(() => {
  init_object_utils();
  FunctionNode2 = freeze({
    is(node) {
      return node.kind === "FunctionNode";
    },
    create(func, args) {
      return freeze({
        kind: "FunctionNode",
        func,
        arguments: args
      });
    }
  });
});

class AggregateFunctionBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  get expressionType() {
    return;
  }
  as(alias) {
    return new AliasedAggregateFunctionBuilder(this, alias);
  }
  distinct() {
    return new AggregateFunctionBuilder({
      ...this.#props,
      aggregateFunctionNode: AggregateFunctionNode.cloneWithDistinct(this.#props.aggregateFunctionNode)
    });
  }
  filterWhere(...args) {
    return new AggregateFunctionBuilder({
      ...this.#props,
      aggregateFunctionNode: AggregateFunctionNode.cloneWithFilter(this.#props.aggregateFunctionNode, parseValueBinaryOperationOrExpression(args))
    });
  }
  filterWhereRef(lhs, op, rhs) {
    return new AggregateFunctionBuilder({
      ...this.#props,
      aggregateFunctionNode: AggregateFunctionNode.cloneWithFilter(this.#props.aggregateFunctionNode, parseReferentialBinaryOperation(lhs, op, rhs))
    });
  }
  over(over) {
    const builder = createOverBuilder();
    return new AggregateFunctionBuilder({
      ...this.#props,
      aggregateFunctionNode: AggregateFunctionNode.cloneWithOver(this.#props.aggregateFunctionNode, (over ? over(builder) : builder).toOperationNode())
    });
  }
  $call(func) {
    return func(this);
  }
  $castTo() {
    return new AggregateFunctionBuilder(this.#props);
  }
  $notNull() {
    return new AggregateFunctionBuilder(this.#props);
  }
  toOperationNode() {
    return this.#props.aggregateFunctionNode;
  }
}

class AliasedAggregateFunctionBuilder {
  #aggregateFunctionBuilder;
  #alias;
  constructor(aggregateFunctionBuilder, alias) {
    this.#aggregateFunctionBuilder = aggregateFunctionBuilder;
    this.#alias = alias;
  }
  get expression() {
    return this.#aggregateFunctionBuilder;
  }
  get alias() {
    return this.#alias;
  }
  toOperationNode() {
    return AliasNode.create(this.#aggregateFunctionBuilder.toOperationNode(), IdentifierNode.create(this.#alias));
  }
}
var init_aggregate_function_builder = __esm2(() => {
  init_object_utils();
  init_aggregate_function_node();
  init_alias_node();
  init_identifier_node();
  init_parse_utils();
  init_binary_operation_parser();
  preventAwait(AggregateFunctionBuilder, "don't await AggregateFunctionBuilder instances. They are never executed directly and are always just a part of a query.");
});
function createFunctionModule() {
  const fn = (name, args) => {
    return new ExpressionWrapper(FunctionNode2.create(name, parseReferenceExpressionOrList(args ?? [])));
  };
  const agg = (name, args) => {
    return new AggregateFunctionBuilder({
      aggregateFunctionNode: AggregateFunctionNode.create(name, args ? parseReferenceExpressionOrList(args) : undefined)
    });
  };
  return Object.assign(fn, {
    agg,
    avg(column) {
      return agg("avg", [column]);
    },
    coalesce(...values3) {
      return fn("coalesce", values3);
    },
    count(column) {
      return agg("count", [column]);
    },
    countAll(table) {
      return new AggregateFunctionBuilder({
        aggregateFunctionNode: AggregateFunctionNode.create("count", parseSelectAll(table))
      });
    },
    max(column) {
      return agg("max", [column]);
    },
    min(column) {
      return agg("min", [column]);
    },
    sum(column) {
      return agg("sum", [column]);
    },
    any(column) {
      return fn("any", [column]);
    },
    jsonAgg(table) {
      return new AggregateFunctionBuilder({
        aggregateFunctionNode: AggregateFunctionNode.create("json_agg", [
          isString22(table) ? parseTable(table) : table.toOperationNode()
        ])
      });
    },
    toJson(table) {
      return new ExpressionWrapper(FunctionNode2.create("to_json", [
        isString22(table) ? parseTable(table) : table.toOperationNode()
      ]));
    }
  });
}
var init_function_module = __esm2(() => {
  init_expression_wrapper();
  init_aggregate_function_node();
  init_function_node();
  init_reference_parser();
  init_select_parser();
  init_aggregate_function_builder();
  init_object_utils();
  init_table_parser();
});
var UnaryOperationNode;
var init_unary_operation_node = __esm2(() => {
  init_object_utils();
  UnaryOperationNode = freeze({
    is(node) {
      return node.kind === "UnaryOperationNode";
    },
    create(operator, operand) {
      return freeze({
        kind: "UnaryOperationNode",
        operator,
        operand
      });
    }
  });
});
function parseUnaryOperation(operator, operand) {
  return UnaryOperationNode.create(OperatorNode.create(operator), parseReferenceExpression(operand));
}
var init_unary_operation_parser = __esm2(() => {
  init_operator_node();
  init_unary_operation_node();
  init_reference_parser();
});
var CaseNode;
var init_case_node = __esm2(() => {
  init_object_utils();
  init_when_node();
  CaseNode = freeze({
    is(node) {
      return node.kind === "CaseNode";
    },
    create(value) {
      return freeze({
        kind: "CaseNode",
        value
      });
    },
    cloneWithWhen(caseNode, when) {
      return freeze({
        ...caseNode,
        when: freeze(caseNode.when ? [...caseNode.when, when] : [when])
      });
    },
    cloneWithThen(caseNode, then) {
      return freeze({
        ...caseNode,
        when: caseNode.when ? freeze([
          ...caseNode.when.slice(0, -1),
          WhenNode.cloneWithResult(caseNode.when[caseNode.when.length - 1], then)
        ]) : undefined
      });
    },
    cloneWith(caseNode, props) {
      return freeze({
        ...caseNode,
        ...props
      });
    }
  });
});

class CaseBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  when(...args) {
    return new CaseThenBuilder({
      ...this.#props,
      node: CaseNode.cloneWithWhen(this.#props.node, WhenNode.create(parseValueBinaryOperationOrExpression(args)))
    });
  }
}

class CaseThenBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  then(valueExpression) {
    return new CaseWhenBuilder({
      ...this.#props,
      node: CaseNode.cloneWithThen(this.#props.node, isSafeImmediateValue(valueExpression) ? parseSafeImmediateValue(valueExpression) : parseValueExpression(valueExpression))
    });
  }
}

class CaseWhenBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  when(...args) {
    return new CaseThenBuilder({
      ...this.#props,
      node: CaseNode.cloneWithWhen(this.#props.node, WhenNode.create(parseValueBinaryOperationOrExpression(args)))
    });
  }
  else(valueExpression) {
    return new CaseEndBuilder({
      ...this.#props,
      node: CaseNode.cloneWith(this.#props.node, {
        else: isSafeImmediateValue(valueExpression) ? parseSafeImmediateValue(valueExpression) : parseValueExpression(valueExpression)
      })
    });
  }
  end() {
    return new ExpressionWrapper(CaseNode.cloneWith(this.#props.node, { isStatement: false }));
  }
  endCase() {
    return new ExpressionWrapper(CaseNode.cloneWith(this.#props.node, { isStatement: true }));
  }
}

class CaseEndBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  end() {
    return new ExpressionWrapper(CaseNode.cloneWith(this.#props.node, { isStatement: false }));
  }
  endCase() {
    return new ExpressionWrapper(CaseNode.cloneWith(this.#props.node, { isStatement: true }));
  }
}
var init_case_builder = __esm2(() => {
  init_expression_wrapper();
  init_object_utils();
  init_case_node();
  init_when_node();
  init_binary_operation_parser();
  init_value_parser();
});
var JSONPathLegNode;
var init_json_path_leg_node = __esm2(() => {
  init_object_utils();
  JSONPathLegNode = freeze({
    is(node) {
      return node.kind === "JSONPathLegNode";
    },
    create(type, value) {
      return freeze({
        kind: "JSONPathLegNode",
        type,
        value
      });
    }
  });
});

class JSONPathBuilder {
  #node;
  constructor(node) {
    this.#node = node;
  }
  at(index) {
    return this.#createBuilderWithPathLeg("ArrayLocation", index);
  }
  key(key) {
    return this.#createBuilderWithPathLeg("Member", key);
  }
  #createBuilderWithPathLeg(legType, value) {
    if (JSONReferenceNode.is(this.#node)) {
      return new TraversedJSONPathBuilder(JSONReferenceNode.cloneWithTraversal(this.#node, JSONPathNode.is(this.#node.traversal) ? JSONPathNode.cloneWithLeg(this.#node.traversal, JSONPathLegNode.create(legType, value)) : JSONOperatorChainNode.cloneWithValue(this.#node.traversal, ValueNode.createImmediate(value))));
    }
    return new TraversedJSONPathBuilder(JSONPathNode.cloneWithLeg(this.#node, JSONPathLegNode.create(legType, value)));
  }
}

class AliasedJSONPathBuilder {
  #jsonPath;
  #alias;
  constructor(jsonPath, alias) {
    this.#jsonPath = jsonPath;
    this.#alias = alias;
  }
  get expression() {
    return this.#jsonPath;
  }
  get alias() {
    return this.#alias;
  }
  toOperationNode() {
    return AliasNode.create(this.#jsonPath.toOperationNode(), isOperationNodeSource(this.#alias) ? this.#alias.toOperationNode() : IdentifierNode.create(this.#alias));
  }
}
var TraversedJSONPathBuilder;
var init_json_path_builder = __esm2(() => {
  init_alias_node();
  init_identifier_node();
  init_json_operator_chain_node();
  init_json_path_leg_node();
  init_json_path_node();
  init_json_reference_node();
  init_operation_node_source();
  init_value_node();
  TraversedJSONPathBuilder = class TraversedJSONPathBuilder2 extends JSONPathBuilder {
    #node;
    constructor(node) {
      super(node);
      this.#node = node;
    }
    get expressionType() {
      return;
    }
    as(alias) {
      return new AliasedJSONPathBuilder(this, alias);
    }
    $castTo() {
      return new JSONPathBuilder(this.#node);
    }
    $notNull() {
      return new JSONPathBuilder(this.#node);
    }
    toOperationNode() {
      return this.#node;
    }
  };
});
var TupleNode;
var init_tuple_node = __esm2(() => {
  init_object_utils();
  TupleNode = freeze({
    is(node) {
      return node.kind === "TupleNode";
    },
    create(values3) {
      return freeze({
        kind: "TupleNode",
        values: freeze(values3)
      });
    }
  });
});
function isColumnDataType(dataType) {
  if (SIMPLE_COLUMN_DATA_TYPES.includes(dataType)) {
    return true;
  }
  if (COLUMN_DATA_TYPE_REGEX.some((r22) => r22.test(dataType))) {
    return true;
  }
  return false;
}
var SIMPLE_COLUMN_DATA_TYPES;
var COLUMN_DATA_TYPE_REGEX;
var DataTypeNode;
var init_data_type_node = __esm2(() => {
  init_object_utils();
  SIMPLE_COLUMN_DATA_TYPES = [
    "varchar",
    "char",
    "text",
    "integer",
    "int2",
    "int4",
    "int8",
    "smallint",
    "bigint",
    "boolean",
    "real",
    "double precision",
    "float4",
    "float8",
    "decimal",
    "numeric",
    "binary",
    "bytea",
    "date",
    "datetime",
    "time",
    "timetz",
    "timestamp",
    "timestamptz",
    "serial",
    "bigserial",
    "uuid",
    "json",
    "jsonb",
    "blob",
    "varbinary"
  ];
  COLUMN_DATA_TYPE_REGEX = [
    /^varchar\(\d+\)$/,
    /^char\(\d+\)$/,
    /^decimal\(\d+, \d+\)$/,
    /^numeric\(\d+, \d+\)$/,
    /^binary\(\d+\)$/,
    /^datetime\(\d+\)$/,
    /^time\(\d+\)$/,
    /^timetz\(\d+\)$/,
    /^timestamp\(\d+\)$/,
    /^timestamptz\(\d+\)$/,
    /^varbinary\(\d+\)$/
  ];
  DataTypeNode = freeze({
    is(node) {
      return node.kind === "DataTypeNode";
    },
    create(dataType) {
      return freeze({
        kind: "DataTypeNode",
        dataType
      });
    }
  });
});
function parseDataTypeExpression(dataType) {
  if (isOperationNodeSource(dataType)) {
    return dataType.toOperationNode();
  }
  if (isColumnDataType(dataType)) {
    return DataTypeNode.create(dataType);
  }
  throw new Error(`invalid column data type ${JSON.stringify(dataType)}`);
}
var init_data_type_parser = __esm2(() => {
  init_data_type_node();
  init_operation_node_source();
});
var CastNode;
var init_cast_node = __esm2(() => {
  init_object_utils();
  CastNode = freeze({
    is(node) {
      return node.kind === "CastNode";
    },
    create(expression, dataType) {
      return freeze({
        kind: "CastNode",
        expression,
        dataType
      });
    }
  });
});
function createExpressionBuilder(executor = NOOP_QUERY_EXECUTOR) {
  function binary2(lhs, op, rhs) {
    return new ExpressionWrapper(parseValueBinaryOperation(lhs, op, rhs));
  }
  function unary(op, expr) {
    return new ExpressionWrapper(parseUnaryOperation(op, expr));
  }
  const eb = Object.assign(binary2, {
    fn: undefined,
    eb: undefined,
    selectFrom(table) {
      return createSelectQueryBuilder({
        queryId: createQueryId(),
        executor,
        queryNode: SelectQueryNode.createFrom(parseTableExpressionOrList(table))
      });
    },
    case(reference) {
      return new CaseBuilder({
        node: CaseNode.create(isUndefined(reference) ? undefined : parseReferenceExpression(reference))
      });
    },
    ref(reference, op) {
      if (isUndefined(op)) {
        return new ExpressionWrapper(parseStringReference(reference));
      }
      return new JSONPathBuilder(parseJSONReference(reference, op));
    },
    jsonPath() {
      return new JSONPathBuilder(JSONPathNode.create());
    },
    table(table) {
      return new ExpressionWrapper(parseTable(table));
    },
    val(value) {
      return new ExpressionWrapper(parseValueExpression(value));
    },
    refTuple(...values3) {
      return new ExpressionWrapper(TupleNode.create(values3.map(parseReferenceExpression)));
    },
    tuple(...values3) {
      return new ExpressionWrapper(TupleNode.create(values3.map(parseValueExpression)));
    },
    lit(value) {
      return new ExpressionWrapper(parseSafeImmediateValue(value));
    },
    unary,
    not(expr) {
      return unary("not", expr);
    },
    exists(expr) {
      return unary("exists", expr);
    },
    neg(expr) {
      return unary("-", expr);
    },
    between(expr, start, end) {
      return new ExpressionWrapper(BinaryOperationNode.create(parseReferenceExpression(expr), OperatorNode.create("between"), AndNode.create(parseValueExpression(start), parseValueExpression(end))));
    },
    betweenSymmetric(expr, start, end) {
      return new ExpressionWrapper(BinaryOperationNode.create(parseReferenceExpression(expr), OperatorNode.create("between symmetric"), AndNode.create(parseValueExpression(start), parseValueExpression(end))));
    },
    and(exprs) {
      if (isReadonlyArray(exprs)) {
        return new ExpressionWrapper(parseFilterList(exprs, "and"));
      }
      return new ExpressionWrapper(parseFilterObject(exprs, "and"));
    },
    or(exprs) {
      if (isReadonlyArray(exprs)) {
        return new ExpressionWrapper(parseFilterList(exprs, "or"));
      }
      return new ExpressionWrapper(parseFilterObject(exprs, "or"));
    },
    parens(...args) {
      const node = parseValueBinaryOperationOrExpression(args);
      if (ParensNode.is(node)) {
        return new ExpressionWrapper(node);
      } else {
        return new ExpressionWrapper(ParensNode.create(node));
      }
    },
    cast(expr, dataType) {
      return new ExpressionWrapper(CastNode.create(parseReferenceExpression(expr), parseDataTypeExpression(dataType)));
    },
    withSchema(schema2) {
      return createExpressionBuilder(executor.withPluginAtFront(new WithSchemaPlugin(schema2)));
    }
  });
  eb.fn = createFunctionModule();
  eb.eb = eb;
  return eb;
}
function expressionBuilder(_22) {
  return createExpressionBuilder();
}
var init_expression_builder = __esm2(() => {
  init_select_query_builder();
  init_select_query_node();
  init_table_parser();
  init_with_schema_plugin();
  init_query_id();
  init_function_module();
  init_reference_parser();
  init_binary_operation_parser();
  init_parens_node();
  init_expression_wrapper();
  init_operator_node();
  init_unary_operation_parser();
  init_value_parser();
  init_noop_query_executor();
  init_case_builder();
  init_case_node();
  init_object_utils();
  init_json_path_builder();
  init_binary_operation_node();
  init_and_node();
  init_tuple_node();
  init_json_path_node();
  init_data_type_parser();
  init_cast_node();
});
function parseExpression(exp) {
  if (isOperationNodeSource(exp)) {
    return exp.toOperationNode();
  } else if (isFunction22(exp)) {
    return exp(expressionBuilder()).toOperationNode();
  }
  throw new Error(`invalid expression: ${JSON.stringify(exp)}`);
}
function parseAliasedExpression(exp) {
  if (isOperationNodeSource(exp)) {
    return exp.toOperationNode();
  } else if (isFunction22(exp)) {
    return exp(expressionBuilder()).toOperationNode();
  }
  throw new Error(`invalid aliased expression: ${JSON.stringify(exp)}`);
}
function isExpressionOrFactory(obj) {
  return isExpression(obj) || isAliasedExpression(obj) || isFunction22(obj);
}
var init_expression_parser = __esm2(() => {
  init_expression();
  init_operation_node_source();
  init_expression_builder();
  init_object_utils();
});
function parseTableExpressionOrList(table) {
  if (isReadonlyArray(table)) {
    return table.map((it) => parseTableExpression(it));
  } else {
    return [parseTableExpression(table)];
  }
}
function parseTableExpression(table) {
  if (isString22(table)) {
    return parseAliasedTable(table);
  } else {
    return parseAliasedExpression(table);
  }
}
function parseAliasedTable(from) {
  const ALIAS_SEPARATOR = " as ";
  if (from.includes(ALIAS_SEPARATOR)) {
    const [table, alias] = from.split(ALIAS_SEPARATOR).map(trim3);
    return AliasNode.create(parseTable(table), IdentifierNode.create(alias));
  } else {
    return parseTable(from);
  }
}
function parseTable(from) {
  const SCHEMA_SEPARATOR = ".";
  if (from.includes(SCHEMA_SEPARATOR)) {
    const [schema2, table] = from.split(SCHEMA_SEPARATOR).map(trim3);
    return TableNode.createWithSchema(schema2, table);
  } else {
    return TableNode.create(from);
  }
}
function trim3(str) {
  return str.trim();
}
var init_table_parser = __esm2(() => {
  init_object_utils();
  init_alias_node();
  init_table_node();
  init_expression_parser();
  init_identifier_node();
});
var AddColumnNode;
var init_add_column_node = __esm2(() => {
  init_object_utils();
  AddColumnNode = freeze({
    is(node) {
      return node.kind === "AddColumnNode";
    },
    create(column) {
      return freeze({
        kind: "AddColumnNode",
        column
      });
    }
  });
});
var ColumnDefinitionNode;
var init_column_definition_node = __esm2(() => {
  init_object_utils();
  init_column_node();
  ColumnDefinitionNode = freeze({
    is(node) {
      return node.kind === "ColumnDefinitionNode";
    },
    create(column, dataType) {
      return freeze({
        kind: "ColumnDefinitionNode",
        column: ColumnNode.create(column),
        dataType
      });
    },
    cloneWithFrontModifier(node, modifier) {
      return freeze({
        ...node,
        frontModifiers: node.frontModifiers ? freeze([...node.frontModifiers, modifier]) : [modifier]
      });
    },
    cloneWithEndModifier(node, modifier) {
      return freeze({
        ...node,
        endModifiers: node.endModifiers ? freeze([...node.endModifiers, modifier]) : [modifier]
      });
    },
    cloneWith(node, props) {
      return freeze({
        ...node,
        ...props
      });
    }
  });
});
var DropColumnNode;
var init_drop_column_node = __esm2(() => {
  init_object_utils();
  init_column_node();
  DropColumnNode = freeze({
    is(node) {
      return node.kind === "DropColumnNode";
    },
    create(column) {
      return freeze({
        kind: "DropColumnNode",
        column: ColumnNode.create(column)
      });
    }
  });
});
var RenameColumnNode;
var init_rename_column_node = __esm2(() => {
  init_object_utils();
  init_column_node();
  RenameColumnNode = freeze({
    is(node) {
      return node.kind === "RenameColumnNode";
    },
    create(column, newColumn) {
      return freeze({
        kind: "RenameColumnNode",
        column: ColumnNode.create(column),
        renameTo: ColumnNode.create(newColumn)
      });
    }
  });
});
var CheckConstraintNode;
var init_check_constraint_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  CheckConstraintNode = freeze({
    is(node) {
      return node.kind === "CheckConstraintNode";
    },
    create(expression, constraintName) {
      return freeze({
        kind: "CheckConstraintNode",
        expression,
        name: constraintName ? IdentifierNode.create(constraintName) : undefined
      });
    }
  });
});
var ON_MODIFY_FOREIGN_ACTIONS;
var ReferencesNode;
var init_references_node = __esm2(() => {
  init_object_utils();
  ON_MODIFY_FOREIGN_ACTIONS = [
    "no action",
    "restrict",
    "cascade",
    "set null",
    "set default"
  ];
  ReferencesNode = freeze({
    is(node) {
      return node.kind === "ReferencesNode";
    },
    create(table, columns) {
      return freeze({
        kind: "ReferencesNode",
        table,
        columns: freeze([...columns])
      });
    },
    cloneWithOnDelete(references, onDelete) {
      return freeze({
        ...references,
        onDelete
      });
    },
    cloneWithOnUpdate(references, onUpdate) {
      return freeze({
        ...references,
        onUpdate
      });
    }
  });
});
function parseDefaultValueExpression(value) {
  return isOperationNodeSource(value) ? value.toOperationNode() : ValueNode.createImmediate(value);
}
var init_default_value_parser = __esm2(() => {
  init_operation_node_source();
  init_value_node();
});
var GeneratedNode;
var init_generated_node = __esm2(() => {
  init_object_utils();
  GeneratedNode = freeze({
    is(node) {
      return node.kind === "GeneratedNode";
    },
    create(params) {
      return freeze({
        kind: "GeneratedNode",
        ...params
      });
    },
    createWithExpression(expression) {
      return freeze({
        kind: "GeneratedNode",
        always: true,
        expression
      });
    },
    cloneWith(node, params) {
      return freeze({
        ...node,
        ...params
      });
    }
  });
});
var DefaultValueNode;
var init_default_value_node = __esm2(() => {
  init_object_utils();
  DefaultValueNode = freeze({
    is(node) {
      return node.kind === "DefaultValueNode";
    },
    create(defaultValue) {
      return freeze({
        kind: "DefaultValueNode",
        defaultValue
      });
    }
  });
});
function parseOnModifyForeignAction(action) {
  if (ON_MODIFY_FOREIGN_ACTIONS.includes(action)) {
    return action;
  }
  throw new Error(`invalid OnModifyForeignAction ${action}`);
}
var init_on_modify_action_parser = __esm2(() => {
  init_references_node();
});

class ColumnDefinitionBuilder {
  #node;
  constructor(node) {
    this.#node = node;
  }
  autoIncrement() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { autoIncrement: true }));
  }
  identity() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { identity: true }));
  }
  primaryKey() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { primaryKey: true }));
  }
  references(ref2) {
    const references = parseStringReference(ref2);
    if (!references.table || SelectAllNode.is(references.column)) {
      throw new Error(`invalid call references('${ref2}'). The reference must have format table.column or schema.table.column`);
    }
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      references: ReferencesNode.create(references.table, [
        references.column
      ])
    }));
  }
  onDelete(onDelete) {
    if (!this.#node.references) {
      throw new Error("on delete constraint can only be added for foreign keys");
    }
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      references: ReferencesNode.cloneWithOnDelete(this.#node.references, parseOnModifyForeignAction(onDelete))
    }));
  }
  onUpdate(onUpdate) {
    if (!this.#node.references) {
      throw new Error("on update constraint can only be added for foreign keys");
    }
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      references: ReferencesNode.cloneWithOnUpdate(this.#node.references, parseOnModifyForeignAction(onUpdate))
    }));
  }
  unique() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { unique: true }));
  }
  notNull() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { notNull: true }));
  }
  unsigned() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { unsigned: true }));
  }
  defaultTo(value) {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      defaultTo: DefaultValueNode.create(parseDefaultValueExpression(value))
    }));
  }
  check(expression) {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      check: CheckConstraintNode.create(expression.toOperationNode())
    }));
  }
  generatedAlwaysAs(expression) {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      generated: GeneratedNode.createWithExpression(expression.toOperationNode())
    }));
  }
  generatedAlwaysAsIdentity() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      generated: GeneratedNode.create({ identity: true, always: true })
    }));
  }
  generatedByDefaultAsIdentity() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      generated: GeneratedNode.create({ identity: true, byDefault: true })
    }));
  }
  stored() {
    if (!this.#node.generated) {
      throw new Error("stored() can only be called after generatedAlwaysAs");
    }
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, {
      generated: GeneratedNode.cloneWith(this.#node.generated, {
        stored: true
      })
    }));
  }
  modifyFront(modifier) {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWithFrontModifier(this.#node, modifier.toOperationNode()));
  }
  nullsNotDistinct() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { nullsNotDistinct: true }));
  }
  ifNotExists() {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWith(this.#node, { ifNotExists: true }));
  }
  modifyEnd(modifier) {
    return new ColumnDefinitionBuilder(ColumnDefinitionNode.cloneWithEndModifier(this.#node, modifier.toOperationNode()));
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#node;
  }
}
var init_column_definition_builder = __esm2(() => {
  init_check_constraint_node();
  init_references_node();
  init_select_all_node();
  init_reference_parser();
  init_column_definition_node();
  init_default_value_parser();
  init_generated_node();
  init_default_value_node();
  init_on_modify_action_parser();
  preventAwait(ColumnDefinitionBuilder, "don't await ColumnDefinitionBuilder instances directly.");
});
var ModifyColumnNode;
var init_modify_column_node = __esm2(() => {
  init_object_utils();
  ModifyColumnNode = freeze({
    is(node) {
      return node.kind === "ModifyColumnNode";
    },
    create(column) {
      return freeze({
        kind: "ModifyColumnNode",
        column
      });
    }
  });
});
var ForeignKeyConstraintNode;
var init_foreign_key_constraint_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  init_references_node();
  ForeignKeyConstraintNode = freeze({
    is(node) {
      return node.kind === "ForeignKeyConstraintNode";
    },
    create(sourceColumns, targetTable, targetColumns, constraintName) {
      return freeze({
        kind: "ForeignKeyConstraintNode",
        columns: sourceColumns,
        references: ReferencesNode.create(targetTable, targetColumns),
        name: constraintName ? IdentifierNode.create(constraintName) : undefined
      });
    },
    cloneWith(node, props) {
      return freeze({
        ...node,
        ...props
      });
    }
  });
});

class ForeignKeyConstraintBuilder {
  #node;
  constructor(node) {
    this.#node = node;
  }
  onDelete(onDelete) {
    return new ForeignKeyConstraintBuilder(ForeignKeyConstraintNode.cloneWith(this.#node, {
      onDelete: parseOnModifyForeignAction(onDelete)
    }));
  }
  onUpdate(onUpdate) {
    return new ForeignKeyConstraintBuilder(ForeignKeyConstraintNode.cloneWith(this.#node, {
      onUpdate: parseOnModifyForeignAction(onUpdate)
    }));
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#node;
  }
}
var init_foreign_key_constraint_builder = __esm2(() => {
  init_foreign_key_constraint_node();
  init_on_modify_action_parser();
  preventAwait(ForeignKeyConstraintBuilder, "don't await ForeignKeyConstraintBuilder instances directly.");
});
var AddConstraintNode;
var init_add_constraint_node = __esm2(() => {
  init_object_utils();
  AddConstraintNode = freeze({
    is(node) {
      return node.kind === "AddConstraintNode";
    },
    create(constraint) {
      return freeze({
        kind: "AddConstraintNode",
        constraint
      });
    }
  });
});
var UniqueConstraintNode;
var init_unique_constraint_node = __esm2(() => {
  init_object_utils();
  init_column_node();
  init_identifier_node();
  UniqueConstraintNode = freeze({
    is(node) {
      return node.kind === "UniqueConstraintNode";
    },
    create(columns, constraintName, nullsNotDistinct) {
      return freeze({
        kind: "UniqueConstraintNode",
        columns: freeze(columns.map(ColumnNode.create)),
        name: constraintName ? IdentifierNode.create(constraintName) : undefined,
        nullsNotDistinct
      });
    },
    cloneWith(node, props) {
      return freeze({
        ...node,
        ...props
      });
    }
  });
});
var DropConstraintNode;
var init_drop_constraint_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  DropConstraintNode = freeze({
    is(node) {
      return node.kind === "DropConstraintNode";
    },
    create(constraintName) {
      return freeze({
        kind: "DropConstraintNode",
        constraintName: IdentifierNode.create(constraintName)
      });
    },
    cloneWith(dropConstraint, props) {
      return freeze({
        ...dropConstraint,
        ...props
      });
    }
  });
});
var AlterColumnNode;
var init_alter_column_node = __esm2(() => {
  init_object_utils();
  init_column_node();
  AlterColumnNode = freeze({
    is(node) {
      return node.kind === "AlterColumnNode";
    },
    create(column, prop, value) {
      return freeze({
        kind: "AlterColumnNode",
        column: ColumnNode.create(column),
        [prop]: value
      });
    }
  });
});

class AlterColumnBuilder {
  #column;
  constructor(column) {
    this.#column = column;
  }
  setDataType(dataType) {
    return new AlteredColumnBuilder(AlterColumnNode.create(this.#column, "dataType", parseDataTypeExpression(dataType)));
  }
  setDefault(value) {
    return new AlteredColumnBuilder(AlterColumnNode.create(this.#column, "setDefault", parseDefaultValueExpression(value)));
  }
  dropDefault() {
    return new AlteredColumnBuilder(AlterColumnNode.create(this.#column, "dropDefault", true));
  }
  setNotNull() {
    return new AlteredColumnBuilder(AlterColumnNode.create(this.#column, "setNotNull", true));
  }
  dropNotNull() {
    return new AlteredColumnBuilder(AlterColumnNode.create(this.#column, "dropNotNull", true));
  }
  $call(func) {
    return func(this);
  }
}

class AlteredColumnBuilder {
  #alterColumnNode;
  constructor(alterColumnNode) {
    this.#alterColumnNode = alterColumnNode;
  }
  toOperationNode() {
    return this.#alterColumnNode;
  }
}
var init_alter_column_builder = __esm2(() => {
  init_alter_column_node();
  init_data_type_parser();
  init_default_value_parser();
  preventAwait(AlterColumnBuilder, "don't await AlterColumnBuilder instances");
  preventAwait(AlteredColumnBuilder, "don't await AlteredColumnBuilder instances");
});

class AlterTableExecutor {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_alter_table_executor = __esm2(() => {
  init_object_utils();
  preventAwait(AlterTableExecutor, "don't await AlterTableExecutor instances directly. To execute the query you need to call `execute`");
});

class AlterTableAddForeignKeyConstraintBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  onDelete(onDelete) {
    return new AlterTableAddForeignKeyConstraintBuilder({
      ...this.#props,
      constraintBuilder: this.#props.constraintBuilder.onDelete(onDelete)
    });
  }
  onUpdate(onUpdate) {
    return new AlterTableAddForeignKeyConstraintBuilder({
      ...this.#props,
      constraintBuilder: this.#props.constraintBuilder.onUpdate(onUpdate)
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(AlterTableNode.cloneWithTableProps(this.#props.node, {
      addConstraint: AddConstraintNode.create(this.#props.constraintBuilder.toOperationNode())
    }), this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_alter_table_add_foreign_key_constraint_builder = __esm2(() => {
  init_add_constraint_node();
  init_alter_table_node();
  init_object_utils();
  preventAwait(AlterTableAddForeignKeyConstraintBuilder, "don't await AlterTableAddForeignKeyConstraintBuilder instances directly. To execute the query you need to call `execute`");
});

class AlterTableDropConstraintBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  ifExists() {
    return new AlterTableDropConstraintBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        dropConstraint: DropConstraintNode.cloneWith(this.#props.node.dropConstraint, {
          ifExists: true
        })
      })
    });
  }
  cascade() {
    return new AlterTableDropConstraintBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        dropConstraint: DropConstraintNode.cloneWith(this.#props.node.dropConstraint, {
          modifier: "cascade"
        })
      })
    });
  }
  restrict() {
    return new AlterTableDropConstraintBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        dropConstraint: DropConstraintNode.cloneWith(this.#props.node.dropConstraint, {
          modifier: "restrict"
        })
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_alter_table_drop_constraint_builder = __esm2(() => {
  init_alter_table_node();
  init_drop_constraint_node();
  init_object_utils();
  preventAwait(AlterTableDropConstraintBuilder, "don't await AlterTableDropConstraintBuilder instances directly. To execute the query you need to call `execute`");
});
var PrimaryConstraintNode;
var init_primary_constraint_node = __esm2(() => {
  init_object_utils();
  init_column_node();
  init_identifier_node();
  PrimaryConstraintNode = freeze({
    is(node) {
      return node.kind === "PrimaryKeyConstraintNode";
    },
    create(columns, constraintName) {
      return freeze({
        kind: "PrimaryKeyConstraintNode",
        columns: freeze(columns.map(ColumnNode.create)),
        name: constraintName ? IdentifierNode.create(constraintName) : undefined
      });
    }
  });
});
var AddIndexNode;
var init_add_index_node = __esm2(() => {
  init_object_utils();
  init_identifier_node();
  AddIndexNode = freeze({
    is(node) {
      return node.kind === "AddIndexNode";
    },
    create(name) {
      return freeze({
        kind: "AddIndexNode",
        name: IdentifierNode.create(name)
      });
    },
    cloneWith(node, props) {
      return freeze({
        ...node,
        ...props
      });
    },
    cloneWithColumns(node, columns) {
      return freeze({
        ...node,
        columns: [...node.columns || [], ...columns]
      });
    }
  });
});

class AlterTableAddIndexBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  unique() {
    return new AlterTableAddIndexBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addIndex: AddIndexNode.cloneWith(this.#props.node.addIndex, {
          unique: true
        })
      })
    });
  }
  column(column) {
    return new AlterTableAddIndexBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addIndex: AddIndexNode.cloneWithColumns(this.#props.node.addIndex, [
          parseOrderedColumnName(column)
        ])
      })
    });
  }
  columns(columns) {
    return new AlterTableAddIndexBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addIndex: AddIndexNode.cloneWithColumns(this.#props.node.addIndex, columns.map(parseOrderedColumnName))
      })
    });
  }
  expression(expression) {
    return new AlterTableAddIndexBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addIndex: AddIndexNode.cloneWithColumns(this.#props.node.addIndex, [
          expression.toOperationNode()
        ])
      })
    });
  }
  using(indexType) {
    return new AlterTableAddIndexBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addIndex: AddIndexNode.cloneWith(this.#props.node.addIndex, {
          using: RawNode.createWithSql(indexType)
        })
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_alter_table_add_index_builder = __esm2(() => {
  init_add_index_node();
  init_alter_table_node();
  init_raw_node();
  init_reference_parser();
  init_object_utils();
  preventAwait(AlterTableAddIndexBuilder, "don't await AlterTableAddIndexBuilder instances directly. To execute the query you need to call `execute`");
});

class UniqueConstraintNodeBuilder {
  #node;
  constructor(node) {
    this.#node = node;
  }
  toOperationNode() {
    return this.#node;
  }
  nullsNotDistinct() {
    return new UniqueConstraintNodeBuilder(UniqueConstraintNode.cloneWith(this.#node, { nullsNotDistinct: true }));
  }
}
var init_unique_constraint_builder = __esm2(() => {
  init_unique_constraint_node();
  preventAwait(UniqueConstraintNodeBuilder, "don't await UniqueConstraintNodeBuilder instances directly.");
});

class AlterTableBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  renameTo(newTableName) {
    return new AlterTableExecutor({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        renameTo: parseTable(newTableName)
      })
    });
  }
  setSchema(newSchema) {
    return new AlterTableExecutor({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        setSchema: IdentifierNode.create(newSchema)
      })
    });
  }
  alterColumn(column, alteration) {
    const builder = alteration(new AlterColumnBuilder(column));
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, builder.toOperationNode())
    });
  }
  dropColumn(column) {
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, DropColumnNode.create(column))
    });
  }
  renameColumn(column, newColumn) {
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, RenameColumnNode.create(column, newColumn))
    });
  }
  addColumn(columnName, dataType, build3 = noop2) {
    const builder = build3(new ColumnDefinitionBuilder(ColumnDefinitionNode.create(columnName, parseDataTypeExpression(dataType))));
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, AddColumnNode.create(builder.toOperationNode()))
    });
  }
  modifyColumn(columnName, dataType, build3 = noop2) {
    const builder = build3(new ColumnDefinitionBuilder(ColumnDefinitionNode.create(columnName, parseDataTypeExpression(dataType))));
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, ModifyColumnNode.create(builder.toOperationNode()))
    });
  }
  addUniqueConstraint(constraintName, columns, build3 = noop2) {
    const uniqueConstraintBuilder = build3(new UniqueConstraintNodeBuilder(UniqueConstraintNode.create(columns, constraintName)));
    return new AlterTableExecutor({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addConstraint: AddConstraintNode.create(uniqueConstraintBuilder.toOperationNode())
      })
    });
  }
  addCheckConstraint(constraintName, checkExpression) {
    return new AlterTableExecutor({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addConstraint: AddConstraintNode.create(CheckConstraintNode.create(checkExpression.toOperationNode(), constraintName))
      })
    });
  }
  addForeignKeyConstraint(constraintName, columns, targetTable, targetColumns) {
    return new AlterTableAddForeignKeyConstraintBuilder({
      ...this.#props,
      constraintBuilder: new ForeignKeyConstraintBuilder(ForeignKeyConstraintNode.create(columns.map(ColumnNode.create), parseTable(targetTable), targetColumns.map(ColumnNode.create), constraintName))
    });
  }
  addPrimaryKeyConstraint(constraintName, columns) {
    return new AlterTableExecutor({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addConstraint: AddConstraintNode.create(PrimaryConstraintNode.create(columns, constraintName))
      })
    });
  }
  dropConstraint(constraintName) {
    return new AlterTableDropConstraintBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        dropConstraint: DropConstraintNode.create(constraintName)
      })
    });
  }
  addIndex(indexName) {
    return new AlterTableAddIndexBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        addIndex: AddIndexNode.create(indexName)
      })
    });
  }
  dropIndex(indexName) {
    return new AlterTableExecutor({
      ...this.#props,
      node: AlterTableNode.cloneWithTableProps(this.#props.node, {
        dropIndex: DropIndexNode.create(indexName)
      })
    });
  }
  $call(func) {
    return func(this);
  }
}

class AlterTableColumnAlteringBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  alterColumn(column, alteration) {
    const builder = alteration(new AlterColumnBuilder(column));
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, builder.toOperationNode())
    });
  }
  dropColumn(column) {
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, DropColumnNode.create(column))
    });
  }
  renameColumn(column, newColumn) {
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, RenameColumnNode.create(column, newColumn))
    });
  }
  addColumn(columnName, dataType, build3 = noop2) {
    const builder = build3(new ColumnDefinitionBuilder(ColumnDefinitionNode.create(columnName, parseDataTypeExpression(dataType))));
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, AddColumnNode.create(builder.toOperationNode()))
    });
  }
  modifyColumn(columnName, dataType, build3 = noop2) {
    const builder = build3(new ColumnDefinitionBuilder(ColumnDefinitionNode.create(columnName, parseDataTypeExpression(dataType))));
    return new AlterTableColumnAlteringBuilder({
      ...this.#props,
      node: AlterTableNode.cloneWithColumnAlteration(this.#props.node, ModifyColumnNode.create(builder.toOperationNode()))
    });
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_alter_table_builder = __esm2(() => {
  init_add_column_node();
  init_alter_table_node();
  init_column_definition_node();
  init_drop_column_node();
  init_identifier_node();
  init_rename_column_node();
  init_object_utils();
  init_column_definition_builder();
  init_modify_column_node();
  init_data_type_parser();
  init_foreign_key_constraint_builder();
  init_add_constraint_node();
  init_unique_constraint_node();
  init_check_constraint_node();
  init_foreign_key_constraint_node();
  init_column_node();
  init_table_parser();
  init_drop_constraint_node();
  init_alter_column_builder();
  init_alter_table_executor();
  init_alter_table_add_foreign_key_constraint_builder();
  init_alter_table_drop_constraint_builder();
  init_primary_constraint_node();
  init_drop_index_node();
  init_add_index_node();
  init_alter_table_add_index_builder();
  init_unique_constraint_builder();
  preventAwait(AlterTableBuilder, "don't await AlterTableBuilder instances");
  preventAwait(AlterTableColumnAlteringBuilder, "don't await AlterTableColumnAlteringBuilder instances directly. To execute the query you need to call `execute`");
});
var ImmediateValueTransformer;
var init_immediate_value_transformer = __esm2(() => {
  init_operation_node_transformer();
  ImmediateValueTransformer = class ImmediateValueTransformer2 extends OperationNodeTransformer {
    transformValue(node) {
      return {
        ...super.transformValue(node),
        immediate: true
      };
    }
  };
});

class CreateIndexBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  ifNotExists() {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWith(this.#props.node, {
        ifNotExists: true
      })
    });
  }
  unique() {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWith(this.#props.node, {
        unique: true
      })
    });
  }
  nullsNotDistinct() {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWith(this.#props.node, {
        nullsNotDistinct: true
      })
    });
  }
  on(table) {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWith(this.#props.node, {
        table: parseTable(table)
      })
    });
  }
  column(column) {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWithColumns(this.#props.node, [
        parseOrderedColumnName(column)
      ])
    });
  }
  columns(columns) {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWithColumns(this.#props.node, columns.map(parseOrderedColumnName))
    });
  }
  expression(expression) {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWithColumns(this.#props.node, [
        expression.toOperationNode()
      ])
    });
  }
  using(indexType) {
    return new CreateIndexBuilder({
      ...this.#props,
      node: CreateIndexNode.cloneWith(this.#props.node, {
        using: RawNode.createWithSql(indexType)
      })
    });
  }
  where(...args) {
    const transformer = new ImmediateValueTransformer;
    return new CreateIndexBuilder({
      ...this.#props,
      node: QueryNode.cloneWithWhere(this.#props.node, transformer.transformNode(parseValueBinaryOperationOrExpression(args)))
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_create_index_builder = __esm2(() => {
  init_create_index_node();
  init_raw_node();
  init_reference_parser();
  init_table_parser();
  init_object_utils();
  init_binary_operation_parser();
  init_query_node();
  init_immediate_value_transformer();
  preventAwait(CreateIndexBuilder, "don't await CreateIndexBuilder instances directly. To execute the query you need to call `execute`");
});

class CreateSchemaBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  ifNotExists() {
    return new CreateSchemaBuilder({
      ...this.#props,
      node: CreateSchemaNode.cloneWith(this.#props.node, { ifNotExists: true })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_create_schema_builder = __esm2(() => {
  init_create_schema_node();
  init_object_utils();
  preventAwait(CreateSchemaBuilder, "don't await CreateSchemaBuilder instances directly. To execute the query you need to call `execute`");
});
function parseOnCommitAction(action) {
  if (ON_COMMIT_ACTIONS.includes(action)) {
    return action;
  }
  throw new Error(`invalid OnCommitAction ${action}`);
}
var init_on_commit_action_parse = __esm2(() => {
  init_create_table_node();
});

class CreateTableBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  temporary() {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWith(this.#props.node, {
        temporary: true
      })
    });
  }
  onCommit(onCommit) {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWith(this.#props.node, {
        onCommit: parseOnCommitAction(onCommit)
      })
    });
  }
  ifNotExists() {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWith(this.#props.node, {
        ifNotExists: true
      })
    });
  }
  addColumn(columnName, dataType, build3 = noop2) {
    const columnBuilder = build3(new ColumnDefinitionBuilder(ColumnDefinitionNode.create(columnName, parseDataTypeExpression(dataType))));
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWithColumn(this.#props.node, columnBuilder.toOperationNode())
    });
  }
  addPrimaryKeyConstraint(constraintName, columns) {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWithConstraint(this.#props.node, PrimaryConstraintNode.create(columns, constraintName))
    });
  }
  addUniqueConstraint(constraintName, columns, build3 = noop2) {
    const uniqueConstraintBuilder = build3(new UniqueConstraintNodeBuilder(UniqueConstraintNode.create(columns, constraintName)));
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWithConstraint(this.#props.node, uniqueConstraintBuilder.toOperationNode())
    });
  }
  addCheckConstraint(constraintName, checkExpression) {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWithConstraint(this.#props.node, CheckConstraintNode.create(checkExpression.toOperationNode(), constraintName))
    });
  }
  addForeignKeyConstraint(constraintName, columns, targetTable, targetColumns, build3 = noop2) {
    const builder = build3(new ForeignKeyConstraintBuilder(ForeignKeyConstraintNode.create(columns.map(ColumnNode.create), parseTable(targetTable), targetColumns.map(ColumnNode.create), constraintName)));
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWithConstraint(this.#props.node, builder.toOperationNode())
    });
  }
  modifyFront(modifier) {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWithFrontModifier(this.#props.node, modifier.toOperationNode())
    });
  }
  modifyEnd(modifier) {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWithEndModifier(this.#props.node, modifier.toOperationNode())
    });
  }
  as(expression) {
    return new CreateTableBuilder({
      ...this.#props,
      node: CreateTableNode.cloneWith(this.#props.node, {
        selectQuery: parseExpression(expression)
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_create_table_builder = __esm2(() => {
  init_column_definition_node();
  init_create_table_node();
  init_column_definition_builder();
  init_object_utils();
  init_foreign_key_constraint_node();
  init_column_node();
  init_foreign_key_constraint_builder();
  init_data_type_parser();
  init_primary_constraint_node();
  init_unique_constraint_node();
  init_check_constraint_node();
  init_table_parser();
  init_on_commit_action_parse();
  init_unique_constraint_builder();
  init_expression_parser();
  preventAwait(CreateTableBuilder, "don't await CreateTableBuilder instances directly. To execute the query you need to call `execute`");
});

class DropIndexBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  on(table) {
    return new DropIndexBuilder({
      ...this.#props,
      node: DropIndexNode.cloneWith(this.#props.node, {
        table: parseTable(table)
      })
    });
  }
  ifExists() {
    return new DropIndexBuilder({
      ...this.#props,
      node: DropIndexNode.cloneWith(this.#props.node, {
        ifExists: true
      })
    });
  }
  cascade() {
    return new DropIndexBuilder({
      ...this.#props,
      node: DropIndexNode.cloneWith(this.#props.node, {
        cascade: true
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_drop_index_builder = __esm2(() => {
  init_drop_index_node();
  init_table_parser();
  init_object_utils();
  preventAwait(DropIndexBuilder, "don't await DropIndexBuilder instances directly. To execute the query you need to call `execute`");
});

class DropSchemaBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  ifExists() {
    return new DropSchemaBuilder({
      ...this.#props,
      node: DropSchemaNode.cloneWith(this.#props.node, {
        ifExists: true
      })
    });
  }
  cascade() {
    return new DropSchemaBuilder({
      ...this.#props,
      node: DropSchemaNode.cloneWith(this.#props.node, {
        cascade: true
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_drop_schema_builder = __esm2(() => {
  init_drop_schema_node();
  init_object_utils();
  preventAwait(DropSchemaBuilder, "don't await DropSchemaBuilder instances directly. To execute the query you need to call `execute`");
});

class DropTableBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  ifExists() {
    return new DropTableBuilder({
      ...this.#props,
      node: DropTableNode.cloneWith(this.#props.node, {
        ifExists: true
      })
    });
  }
  cascade() {
    return new DropTableBuilder({
      ...this.#props,
      node: DropTableNode.cloneWith(this.#props.node, {
        cascade: true
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_drop_table_builder = __esm2(() => {
  init_drop_table_node();
  init_object_utils();
  preventAwait(DropTableBuilder, "don't await DropTableBuilder instances directly. To execute the query you need to call `execute`");
});
var CreateViewNode;
var init_create_view_node = __esm2(() => {
  init_object_utils();
  init_schemable_identifier_node();
  CreateViewNode = freeze({
    is(node) {
      return node.kind === "CreateViewNode";
    },
    create(name) {
      return freeze({
        kind: "CreateViewNode",
        name: SchemableIdentifierNode.create(name)
      });
    },
    cloneWith(createView, params) {
      return freeze({
        ...createView,
        ...params
      });
    }
  });
});

class ImmediateValuePlugin {
  #transformer = new ImmediateValueTransformer;
  transformQuery(args) {
    return this.#transformer.transformNode(args.node);
  }
  transformResult(args) {
    return Promise.resolve(args.result);
  }
}
var init_immediate_value_plugin = __esm2(() => {
  init_immediate_value_transformer();
});

class CreateViewBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  temporary() {
    return new CreateViewBuilder({
      ...this.#props,
      node: CreateViewNode.cloneWith(this.#props.node, {
        temporary: true
      })
    });
  }
  materialized() {
    return new CreateViewBuilder({
      ...this.#props,
      node: CreateViewNode.cloneWith(this.#props.node, {
        materialized: true
      })
    });
  }
  ifNotExists() {
    return new CreateViewBuilder({
      ...this.#props,
      node: CreateViewNode.cloneWith(this.#props.node, {
        ifNotExists: true
      })
    });
  }
  orReplace() {
    return new CreateViewBuilder({
      ...this.#props,
      node: CreateViewNode.cloneWith(this.#props.node, {
        orReplace: true
      })
    });
  }
  columns(columns) {
    return new CreateViewBuilder({
      ...this.#props,
      node: CreateViewNode.cloneWith(this.#props.node, {
        columns: columns.map(parseColumnName)
      })
    });
  }
  as(query) {
    const queryNode = query.withPlugin(new ImmediateValuePlugin).toOperationNode();
    return new CreateViewBuilder({
      ...this.#props,
      node: CreateViewNode.cloneWith(this.#props.node, {
        as: queryNode
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_create_view_builder = __esm2(() => {
  init_object_utils();
  init_create_view_node();
  init_reference_parser();
  init_immediate_value_plugin();
  preventAwait(CreateViewBuilder, "don't await CreateViewBuilder instances directly. To execute the query you need to call `execute`");
});
var DropViewNode;
var init_drop_view_node = __esm2(() => {
  init_object_utils();
  init_schemable_identifier_node();
  DropViewNode = freeze({
    is(node) {
      return node.kind === "DropViewNode";
    },
    create(name) {
      return freeze({
        kind: "DropViewNode",
        name: SchemableIdentifierNode.create(name)
      });
    },
    cloneWith(dropView, params) {
      return freeze({
        ...dropView,
        ...params
      });
    }
  });
});

class DropViewBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  materialized() {
    return new DropViewBuilder({
      ...this.#props,
      node: DropViewNode.cloneWith(this.#props.node, {
        materialized: true
      })
    });
  }
  ifExists() {
    return new DropViewBuilder({
      ...this.#props,
      node: DropViewNode.cloneWith(this.#props.node, {
        ifExists: true
      })
    });
  }
  cascade() {
    return new DropViewBuilder({
      ...this.#props,
      node: DropViewNode.cloneWith(this.#props.node, {
        cascade: true
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_drop_view_builder = __esm2(() => {
  init_object_utils();
  init_drop_view_node();
  preventAwait(DropViewBuilder, "don't await DropViewBuilder instances directly. To execute the query you need to call `execute`");
});
var CreateTypeNode;
var init_create_type_node = __esm2(() => {
  init_object_utils();
  init_value_list_node();
  init_value_node();
  CreateTypeNode = freeze({
    is(node) {
      return node.kind === "CreateTypeNode";
    },
    create(name) {
      return freeze({
        kind: "CreateTypeNode",
        name
      });
    },
    cloneWithEnum(createType, values3) {
      return freeze({
        ...createType,
        enum: ValueListNode.create(values3.map((value) => ValueNode.createImmediate(value)))
      });
    }
  });
});

class CreateTypeBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  asEnum(values3) {
    return new CreateTypeBuilder({
      ...this.#props,
      node: CreateTypeNode.cloneWithEnum(this.#props.node, values3)
    });
  }
  $call(func) {
    return func(this);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_create_type_builder = __esm2(() => {
  init_object_utils();
  init_create_type_node();
  preventAwait(CreateTypeBuilder, "don't await CreateTypeBuilder instances directly. To execute the query you need to call `execute`");
});
var DropTypeNode;
var init_drop_type_node = __esm2(() => {
  init_object_utils();
  DropTypeNode = freeze({
    is(node) {
      return node.kind === "DropTypeNode";
    },
    create(name) {
      return freeze({
        kind: "DropTypeNode",
        name
      });
    },
    cloneWith(dropType, params) {
      return freeze({
        ...dropType,
        ...params
      });
    }
  });
});

class DropTypeBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  ifExists() {
    return new DropTypeBuilder({
      ...this.#props,
      node: DropTypeNode.cloneWith(this.#props.node, {
        ifExists: true
      })
    });
  }
  $call(func) {
    return func(this);
  }
  toOperationNode() {
    return this.#props.executor.transformQuery(this.#props.node, this.#props.queryId);
  }
  compile() {
    return this.#props.executor.compileQuery(this.toOperationNode(), this.#props.queryId);
  }
  async execute() {
    await this.#props.executor.executeQuery(this.compile(), this.#props.queryId);
  }
}
var init_drop_type_builder = __esm2(() => {
  init_drop_type_node();
  init_object_utils();
  preventAwait(DropTypeBuilder, "don't await DropTypeBuilder instances directly. To execute the query you need to call `execute`");
});
function parseSchemableIdentifier(id) {
  const SCHEMA_SEPARATOR = ".";
  if (id.includes(SCHEMA_SEPARATOR)) {
    const parts = id.split(SCHEMA_SEPARATOR).map(trim4);
    if (parts.length === 2) {
      return SchemableIdentifierNode.createWithSchema(parts[0], parts[1]);
    } else {
      throw new Error(`invalid schemable identifier ${id}`);
    }
  } else {
    return SchemableIdentifierNode.create(id);
  }
}
function trim4(str) {
  return str.trim();
}
var init_identifier_parser = __esm2(() => {
  init_schemable_identifier_node();
});

class SchemaModule {
  #executor;
  constructor(executor) {
    this.#executor = executor;
  }
  createTable(table) {
    return new CreateTableBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: CreateTableNode.create(parseTable(table))
    });
  }
  dropTable(table) {
    return new DropTableBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: DropTableNode.create(parseTable(table))
    });
  }
  createIndex(indexName) {
    return new CreateIndexBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: CreateIndexNode.create(indexName)
    });
  }
  dropIndex(indexName) {
    return new DropIndexBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: DropIndexNode.create(indexName)
    });
  }
  createSchema(schema2) {
    return new CreateSchemaBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: CreateSchemaNode.create(schema2)
    });
  }
  dropSchema(schema2) {
    return new DropSchemaBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: DropSchemaNode.create(schema2)
    });
  }
  alterTable(table) {
    return new AlterTableBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: AlterTableNode.create(parseTable(table))
    });
  }
  createView(viewName) {
    return new CreateViewBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: CreateViewNode.create(viewName)
    });
  }
  dropView(viewName) {
    return new DropViewBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: DropViewNode.create(viewName)
    });
  }
  createType(typeName) {
    return new CreateTypeBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: CreateTypeNode.create(parseSchemableIdentifier(typeName))
    });
  }
  dropType(typeName) {
    return new DropTypeBuilder({
      queryId: createQueryId(),
      executor: this.#executor,
      node: DropTypeNode.create(parseSchemableIdentifier(typeName))
    });
  }
  withPlugin(plugin) {
    return new SchemaModule(this.#executor.withPlugin(plugin));
  }
  withoutPlugins() {
    return new SchemaModule(this.#executor.withoutPlugins());
  }
  withSchema(schema2) {
    return new SchemaModule(this.#executor.withPluginAtFront(new WithSchemaPlugin(schema2)));
  }
}
var init_schema2 = __esm2(() => {
  init_alter_table_node();
  init_create_index_node();
  init_create_schema_node();
  init_create_table_node();
  init_drop_index_node();
  init_drop_schema_node();
  init_drop_table_node();
  init_table_parser();
  init_alter_table_builder();
  init_create_index_builder();
  init_create_schema_builder();
  init_create_table_builder();
  init_drop_index_builder();
  init_drop_schema_builder();
  init_drop_table_builder();
  init_query_id();
  init_with_schema_plugin();
  init_create_view_builder();
  init_create_view_node();
  init_drop_view_builder();
  init_drop_view_node();
  init_create_type_builder();
  init_drop_type_builder();
  init_create_type_node();
  init_drop_type_node();
  init_identifier_parser();
});

class DynamicModule {
  ref(reference) {
    return new DynamicReferenceBuilder(reference);
  }
}
var init_dynamic = __esm2(() => {
  init_dynamic_reference_builder();
});

class DefaultConnectionProvider {
  #driver;
  constructor(driver) {
    this.#driver = driver;
  }
  async provideConnection(consumer) {
    const connection = await this.#driver.acquireConnection();
    try {
      return await consumer(connection);
    } finally {
      await this.#driver.releaseConnection(connection);
    }
  }
}
var DefaultQueryExecutor;
var init_default_query_executor = __esm2(() => {
  init_query_executor_base();
  DefaultQueryExecutor = class DefaultQueryExecutor2 extends QueryExecutorBase {
    #compiler;
    #adapter;
    #connectionProvider;
    constructor(compiler, adapter, connectionProvider, plugins = []) {
      super(plugins);
      this.#compiler = compiler;
      this.#adapter = adapter;
      this.#connectionProvider = connectionProvider;
    }
    get adapter() {
      return this.#adapter;
    }
    compileQuery(node) {
      return this.#compiler.compileQuery(node);
    }
    provideConnection(consumer) {
      return this.#connectionProvider.provideConnection(consumer);
    }
    withPlugins(plugins) {
      return new DefaultQueryExecutor2(this.#compiler, this.#adapter, this.#connectionProvider, [...this.plugins, ...plugins]);
    }
    withPlugin(plugin) {
      return new DefaultQueryExecutor2(this.#compiler, this.#adapter, this.#connectionProvider, [...this.plugins, plugin]);
    }
    withPluginAtFront(plugin) {
      return new DefaultQueryExecutor2(this.#compiler, this.#adapter, this.#connectionProvider, [plugin, ...this.plugins]);
    }
    withConnectionProvider(connectionProvider) {
      return new DefaultQueryExecutor2(this.#compiler, this.#adapter, connectionProvider, [...this.plugins]);
    }
    withoutPlugins() {
      return new DefaultQueryExecutor2(this.#compiler, this.#adapter, this.#connectionProvider, []);
    }
  };
});
function performanceNow() {
  if (typeof performance !== "undefined" && isFunction22(performance.now)) {
    return performance.now();
  } else {
    return Date.now();
  }
}
var init_performance_now = __esm2(() => {
  init_object_utils();
});

class RuntimeDriver {
  #driver;
  #log;
  #initPromise;
  #initDone;
  #destroyPromise;
  #connections = new WeakSet;
  constructor(driver, log22) {
    this.#initDone = false;
    this.#driver = driver;
    this.#log = log22;
  }
  async init() {
    if (this.#destroyPromise) {
      throw new Error("driver has already been destroyed");
    }
    if (!this.#initPromise) {
      this.#initPromise = this.#driver.init().then(() => {
        this.#initDone = true;
      }).catch((err22) => {
        this.#initPromise = undefined;
        return Promise.reject(err22);
      });
    }
    await this.#initPromise;
  }
  async acquireConnection() {
    if (this.#destroyPromise) {
      throw new Error("driver has already been destroyed");
    }
    if (!this.#initDone) {
      await this.init();
    }
    const connection = await this.#driver.acquireConnection();
    if (!this.#connections.has(connection)) {
      if (this.#needsLogging()) {
        this.#addLogging(connection);
      }
      this.#connections.add(connection);
    }
    return connection;
  }
  async releaseConnection(connection) {
    await this.#driver.releaseConnection(connection);
  }
  beginTransaction(connection, settings) {
    return this.#driver.beginTransaction(connection, settings);
  }
  commitTransaction(connection) {
    return this.#driver.commitTransaction(connection);
  }
  rollbackTransaction(connection) {
    return this.#driver.rollbackTransaction(connection);
  }
  async destroy() {
    if (!this.#initPromise) {
      return;
    }
    await this.#initPromise;
    if (!this.#destroyPromise) {
      this.#destroyPromise = this.#driver.destroy().catch((err22) => {
        this.#destroyPromise = undefined;
        return Promise.reject(err22);
      });
    }
    await this.#destroyPromise;
  }
  #needsLogging() {
    return this.#log.isLevelEnabled("query") || this.#log.isLevelEnabled("error");
  }
  #addLogging(connection) {
    const executeQuery = connection.executeQuery;
    connection.executeQuery = async (compiledQuery) => {
      let caughtError;
      const startTime = performanceNow();
      try {
        return await executeQuery.call(connection, compiledQuery);
      } catch (error) {
        caughtError = error;
        await this.#logError(error, compiledQuery, startTime);
        throw error;
      } finally {
        if (!caughtError) {
          await this.#logQuery(compiledQuery, startTime);
        }
      }
    };
  }
  async#logError(error, compiledQuery, startTime) {
    await this.#log.error(() => ({
      level: "error",
      error,
      query: compiledQuery,
      queryDurationMillis: this.#calculateDurationMillis(startTime)
    }));
  }
  async#logQuery(compiledQuery, startTime) {
    await this.#log.query(() => ({
      level: "query",
      query: compiledQuery,
      queryDurationMillis: this.#calculateDurationMillis(startTime)
    }));
  }
  #calculateDurationMillis(startTime) {
    return performanceNow() - startTime;
  }
}
var init_runtime_driver = __esm2(() => {
  init_performance_now();
});

class SingleConnectionProvider {
  #connection;
  #runningPromise;
  constructor(connection) {
    this.#connection = connection;
  }
  async provideConnection(consumer) {
    while (this.#runningPromise) {
      await this.#runningPromise.catch(ignoreError);
    }
    this.#runningPromise = this.#run(consumer).finally(() => {
      this.#runningPromise = undefined;
    });
    return this.#runningPromise;
  }
  async#run(runner) {
    return await runner(this.#connection);
  }
}
var ignoreError = () => {
};
var TRANSACTION_ISOLATION_LEVELS;
var init_driver = __esm2(() => {
  TRANSACTION_ISOLATION_LEVELS = [
    "read uncommitted",
    "read committed",
    "repeatable read",
    "serializable",
    "snapshot"
  ];
});

class Log {
  #levels;
  #logger;
  constructor(config5) {
    if (isFunction22(config5)) {
      this.#logger = config5;
      this.#levels = freeze({
        query: true,
        error: true
      });
    } else {
      this.#logger = defaultLogger;
      this.#levels = freeze({
        query: config5.includes("query"),
        error: config5.includes("error")
      });
    }
  }
  isLevelEnabled(level) {
    return this.#levels[level];
  }
  async query(getEvent) {
    if (this.#levels.query) {
      await this.#logger(getEvent());
    }
  }
  async error(getEvent) {
    if (this.#levels.error) {
      await this.#logger(getEvent());
    }
  }
}
function defaultLogger(event) {
  if (event.level === "query") {
    console.log(`kysely:query: ${event.query.sql}`);
    console.log(`kysely:query: duration: ${event.queryDurationMillis.toFixed(1)}ms`);
  } else if (event.level === "error") {
    if (event.error instanceof Error) {
      console.error(`kysely:error: ${event.error.stack ?? event.error.message}`);
    } else {
      console.error(`kysely:error: ${JSON.stringify({
        error: event.error,
        query: event.query.sql,
        queryDurationMillis: event.queryDurationMillis
      })}`);
    }
  }
}
var LOG_LEVELS;
var init_log = __esm2(() => {
  init_object_utils();
  LOG_LEVELS = freeze(["query", "error"]);
});
function isCompilable(value) {
  return isObject4(value) && isFunction22(value.compile);
}
var init_compilable = __esm2(() => {
  init_object_utils();
});
function isKyselyProps(obj) {
  return isObject4(obj) && isObject4(obj.config) && isObject4(obj.driver) && isObject4(obj.executor) && isObject4(obj.dialect);
}

class ConnectionBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  async execute(callback) {
    return this.#props.executor.provideConnection(async (connection) => {
      const executor = this.#props.executor.withConnectionProvider(new SingleConnectionProvider(connection));
      const db2 = new Kysely({
        ...this.#props,
        executor
      });
      return await callback(db2);
    });
  }
}

class TransactionBuilder {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  setIsolationLevel(isolationLevel) {
    return new TransactionBuilder({
      ...this.#props,
      isolationLevel
    });
  }
  async execute(callback) {
    const { isolationLevel, ...kyselyProps } = this.#props;
    const settings = { isolationLevel };
    validateTransactionSettings(settings);
    return this.#props.executor.provideConnection(async (connection) => {
      const executor = this.#props.executor.withConnectionProvider(new SingleConnectionProvider(connection));
      const transaction = new Transaction({
        ...kyselyProps,
        executor
      });
      try {
        await this.#props.driver.beginTransaction(connection, settings);
        const result2 = await callback(transaction);
        await this.#props.driver.commitTransaction(connection);
        return result2;
      } catch (error) {
        await this.#props.driver.rollbackTransaction(connection);
        throw error;
      }
    });
  }
}
function validateTransactionSettings(settings) {
  if (settings.isolationLevel && !TRANSACTION_ISOLATION_LEVELS.includes(settings.isolationLevel)) {
    throw new Error(`invalid transaction isolation level ${settings.isolationLevel}`);
  }
}
var Kysely;
var Transaction;
var init_kysely = __esm2(() => {
  init_schema2();
  init_dynamic();
  init_query_creator();
  init_default_query_executor();
  init_object_utils();
  init_runtime_driver();
  init_driver();
  init_function_module();
  init_log();
  init_query_id();
  init_compilable();
  init_case_builder();
  init_case_node();
  init_expression_parser();
  init_with_schema_plugin();
  Kysely = class Kysely2 extends QueryCreator {
    #props;
    constructor(args) {
      let superProps;
      let props;
      if (isKyselyProps(args)) {
        superProps = { executor: args.executor };
        props = { ...args };
      } else {
        const dialect = args.dialect;
        const driver = dialect.createDriver();
        const compiler = dialect.createQueryCompiler();
        const adapter = dialect.createAdapter();
        const log22 = new Log(args.log ?? []);
        const runtimeDriver = new RuntimeDriver(driver, log22);
        const connectionProvider = new DefaultConnectionProvider(runtimeDriver);
        const executor = new DefaultQueryExecutor(compiler, adapter, connectionProvider, args.plugins ?? []);
        superProps = { executor };
        props = {
          config: args,
          executor,
          dialect,
          driver: runtimeDriver
        };
      }
      super(superProps);
      this.#props = freeze(props);
    }
    get schema() {
      return new SchemaModule(this.#props.executor);
    }
    get dynamic() {
      return new DynamicModule;
    }
    get introspection() {
      return this.#props.dialect.createIntrospector(this.withoutPlugins());
    }
    case(value) {
      return new CaseBuilder({
        node: CaseNode.create(isUndefined(value) ? undefined : parseExpression(value))
      });
    }
    get fn() {
      return createFunctionModule();
    }
    transaction() {
      return new TransactionBuilder({ ...this.#props });
    }
    connection() {
      return new ConnectionBuilder({ ...this.#props });
    }
    withPlugin(plugin) {
      return new Kysely2({
        ...this.#props,
        executor: this.#props.executor.withPlugin(plugin)
      });
    }
    withoutPlugins() {
      return new Kysely2({
        ...this.#props,
        executor: this.#props.executor.withoutPlugins()
      });
    }
    withSchema(schema2) {
      return new Kysely2({
        ...this.#props,
        executor: this.#props.executor.withPluginAtFront(new WithSchemaPlugin(schema2))
      });
    }
    withTables() {
      return new Kysely2({ ...this.#props });
    }
    async destroy() {
      await this.#props.driver.destroy();
    }
    get isTransaction() {
      return false;
    }
    getExecutor() {
      return this.#props.executor;
    }
    executeQuery(query, queryId = createQueryId()) {
      const compiledQuery = isCompilable(query) ? query.compile() : query;
      return this.getExecutor().executeQuery(compiledQuery, queryId);
    }
  };
  Transaction = class Transaction2 extends Kysely {
    #props;
    constructor(props) {
      super(props);
      this.#props = props;
    }
    get isTransaction() {
      return true;
    }
    transaction() {
      throw new Error("calling the transaction method for a Transaction is not supported");
    }
    connection() {
      throw new Error("calling the connection method for a Transaction is not supported");
    }
    async destroy() {
      throw new Error("calling the destroy method for a Transaction is not supported");
    }
    withPlugin(plugin) {
      return new Transaction2({
        ...this.#props,
        executor: this.#props.executor.withPlugin(plugin)
      });
    }
    withoutPlugins() {
      return new Transaction2({
        ...this.#props,
        executor: this.#props.executor.withoutPlugins()
      });
    }
    withSchema(schema2) {
      return new Transaction2({
        ...this.#props,
        executor: this.#props.executor.withPluginAtFront(new WithSchemaPlugin(schema2))
      });
    }
    withTables() {
      return new Transaction2({ ...this.#props });
    }
  };
  preventAwait(ConnectionBuilder, "don't await ConnectionBuilder instances directly. To execute the query you need to call the `execute` method");
  preventAwait(TransactionBuilder, "don't await TransactionBuilder instances directly. To execute the transaction you need to call the `execute` method");
});
var init_where_interface = () => {
};
var init_returning_interface = () => {
};
var init_output_interface = () => {
};
var init_having_interface = () => {
};

class RawBuilderImpl {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  get expressionType() {
    return;
  }
  get isRawBuilder() {
    return true;
  }
  as(alias) {
    return new AliasedRawBuilderImpl(this, alias);
  }
  $castTo() {
    return new RawBuilderImpl({ ...this.#props });
  }
  $notNull() {
    return new RawBuilderImpl(this.#props);
  }
  withPlugin(plugin) {
    return new RawBuilderImpl({
      ...this.#props,
      plugins: this.#props.plugins !== undefined ? freeze([...this.#props.plugins, plugin]) : freeze([plugin])
    });
  }
  toOperationNode() {
    return this.#toOperationNode(this.#getExecutor());
  }
  compile(executorProvider) {
    return this.#compile(this.#getExecutor(executorProvider));
  }
  async execute(executorProvider) {
    const executor = this.#getExecutor(executorProvider);
    return executor.executeQuery(this.#compile(executor), this.#props.queryId);
  }
  #getExecutor(executorProvider) {
    const executor = executorProvider !== undefined ? executorProvider.getExecutor() : NOOP_QUERY_EXECUTOR;
    return this.#props.plugins !== undefined ? executor.withPlugins(this.#props.plugins) : executor;
  }
  #toOperationNode(executor) {
    return executor.transformQuery(this.#props.rawNode, this.#props.queryId);
  }
  #compile(executor) {
    return executor.compileQuery(this.#toOperationNode(executor), this.#props.queryId);
  }
}
function createRawBuilder(props) {
  return new RawBuilderImpl(props);
}

class AliasedRawBuilderImpl {
  #rawBuilder;
  #alias;
  constructor(rawBuilder, alias) {
    this.#rawBuilder = rawBuilder;
    this.#alias = alias;
  }
  get expression() {
    return this.#rawBuilder;
  }
  get alias() {
    return this.#alias;
  }
  get rawBuilder() {
    return this.#rawBuilder;
  }
  toOperationNode() {
    return AliasNode.create(this.#rawBuilder.toOperationNode(), isOperationNodeSource(this.#alias) ? this.#alias.toOperationNode() : IdentifierNode.create(this.#alias));
  }
}
var init_raw_builder = __esm2(() => {
  init_alias_node();
  init_object_utils();
  init_noop_query_executor();
  init_identifier_node();
  init_operation_node_source();
  preventAwait(RawBuilderImpl, "don't await RawBuilder instances directly. To execute the query you need to call `execute`");
  preventAwait(AliasedRawBuilderImpl, "don't await AliasedRawBuilder instances directly. AliasedRawBuilder should never be executed directly since it's always a part of another query.");
});
function parseParameter(param) {
  if (isOperationNodeSource(param)) {
    return param.toOperationNode();
  }
  return parseValueExpression(param);
}
var sql;
var init_sql = __esm2(() => {
  init_identifier_node();
  init_operation_node_source();
  init_raw_node();
  init_value_node();
  init_reference_parser();
  init_table_parser();
  init_value_parser();
  init_query_id();
  init_raw_builder();
  sql = Object.assign((sqlFragments, ...parameters) => {
    return createRawBuilder({
      queryId: createQueryId(),
      rawNode: RawNode.create(sqlFragments, parameters?.map(parseParameter) ?? [])
    });
  }, {
    ref(columnReference) {
      return createRawBuilder({
        queryId: createQueryId(),
        rawNode: RawNode.createWithChild(parseStringReference(columnReference))
      });
    },
    val(value) {
      return createRawBuilder({
        queryId: createQueryId(),
        rawNode: RawNode.createWithChild(parseValueExpression(value))
      });
    },
    value(value) {
      return this.val(value);
    },
    table(tableReference) {
      return createRawBuilder({
        queryId: createQueryId(),
        rawNode: RawNode.createWithChild(parseTable(tableReference))
      });
    },
    id(...ids) {
      const fragments = new Array(ids.length + 1).fill(".");
      fragments[0] = "";
      fragments[fragments.length - 1] = "";
      return createRawBuilder({
        queryId: createQueryId(),
        rawNode: RawNode.create(fragments, ids.map(IdentifierNode.create))
      });
    },
    lit(value) {
      return createRawBuilder({
        queryId: createQueryId(),
        rawNode: RawNode.createWithChild(ValueNode.createImmediate(value))
      });
    },
    literal(value) {
      return this.lit(value);
    },
    raw(sql2) {
      return createRawBuilder({
        queryId: createQueryId(),
        rawNode: RawNode.createWithSql(sql2)
      });
    },
    join(array, separator = sql`, `) {
      const nodes = new Array(2 * array.length - 1);
      const sep33 = separator.toOperationNode();
      for (let i2 = 0;i2 < array.length; ++i2) {
        nodes[2 * i2] = parseParameter(array[i2]);
        if (i2 !== array.length - 1) {
          nodes[2 * i2 + 1] = sep33;
        }
      }
      return createRawBuilder({
        queryId: createQueryId(),
        rawNode: RawNode.createWithChildren(nodes)
      });
    }
  });
});
var init_query_executor = () => {
};
var init_query_executor_provider = () => {
};

class OperationNodeVisitor {
  nodeStack = [];
  get parentNode() {
    return this.nodeStack[this.nodeStack.length - 2];
  }
  #visitors = freeze({
    AliasNode: this.visitAlias.bind(this),
    ColumnNode: this.visitColumn.bind(this),
    IdentifierNode: this.visitIdentifier.bind(this),
    SchemableIdentifierNode: this.visitSchemableIdentifier.bind(this),
    RawNode: this.visitRaw.bind(this),
    ReferenceNode: this.visitReference.bind(this),
    SelectQueryNode: this.visitSelectQuery.bind(this),
    SelectionNode: this.visitSelection.bind(this),
    TableNode: this.visitTable.bind(this),
    FromNode: this.visitFrom.bind(this),
    SelectAllNode: this.visitSelectAll.bind(this),
    AndNode: this.visitAnd.bind(this),
    OrNode: this.visitOr.bind(this),
    ValueNode: this.visitValue.bind(this),
    ValueListNode: this.visitValueList.bind(this),
    PrimitiveValueListNode: this.visitPrimitiveValueList.bind(this),
    ParensNode: this.visitParens.bind(this),
    JoinNode: this.visitJoin.bind(this),
    OperatorNode: this.visitOperator.bind(this),
    WhereNode: this.visitWhere.bind(this),
    InsertQueryNode: this.visitInsertQuery.bind(this),
    DeleteQueryNode: this.visitDeleteQuery.bind(this),
    ReturningNode: this.visitReturning.bind(this),
    CreateTableNode: this.visitCreateTable.bind(this),
    AddColumnNode: this.visitAddColumn.bind(this),
    ColumnDefinitionNode: this.visitColumnDefinition.bind(this),
    DropTableNode: this.visitDropTable.bind(this),
    DataTypeNode: this.visitDataType.bind(this),
    OrderByNode: this.visitOrderBy.bind(this),
    OrderByItemNode: this.visitOrderByItem.bind(this),
    GroupByNode: this.visitGroupBy.bind(this),
    GroupByItemNode: this.visitGroupByItem.bind(this),
    UpdateQueryNode: this.visitUpdateQuery.bind(this),
    ColumnUpdateNode: this.visitColumnUpdate.bind(this),
    LimitNode: this.visitLimit.bind(this),
    OffsetNode: this.visitOffset.bind(this),
    OnConflictNode: this.visitOnConflict.bind(this),
    OnDuplicateKeyNode: this.visitOnDuplicateKey.bind(this),
    CreateIndexNode: this.visitCreateIndex.bind(this),
    DropIndexNode: this.visitDropIndex.bind(this),
    ListNode: this.visitList.bind(this),
    PrimaryKeyConstraintNode: this.visitPrimaryKeyConstraint.bind(this),
    UniqueConstraintNode: this.visitUniqueConstraint.bind(this),
    ReferencesNode: this.visitReferences.bind(this),
    CheckConstraintNode: this.visitCheckConstraint.bind(this),
    WithNode: this.visitWith.bind(this),
    CommonTableExpressionNode: this.visitCommonTableExpression.bind(this),
    CommonTableExpressionNameNode: this.visitCommonTableExpressionName.bind(this),
    HavingNode: this.visitHaving.bind(this),
    CreateSchemaNode: this.visitCreateSchema.bind(this),
    DropSchemaNode: this.visitDropSchema.bind(this),
    AlterTableNode: this.visitAlterTable.bind(this),
    DropColumnNode: this.visitDropColumn.bind(this),
    RenameColumnNode: this.visitRenameColumn.bind(this),
    AlterColumnNode: this.visitAlterColumn.bind(this),
    ModifyColumnNode: this.visitModifyColumn.bind(this),
    AddConstraintNode: this.visitAddConstraint.bind(this),
    DropConstraintNode: this.visitDropConstraint.bind(this),
    ForeignKeyConstraintNode: this.visitForeignKeyConstraint.bind(this),
    CreateViewNode: this.visitCreateView.bind(this),
    DropViewNode: this.visitDropView.bind(this),
    GeneratedNode: this.visitGenerated.bind(this),
    DefaultValueNode: this.visitDefaultValue.bind(this),
    OnNode: this.visitOn.bind(this),
    ValuesNode: this.visitValues.bind(this),
    SelectModifierNode: this.visitSelectModifier.bind(this),
    CreateTypeNode: this.visitCreateType.bind(this),
    DropTypeNode: this.visitDropType.bind(this),
    ExplainNode: this.visitExplain.bind(this),
    DefaultInsertValueNode: this.visitDefaultInsertValue.bind(this),
    AggregateFunctionNode: this.visitAggregateFunction.bind(this),
    OverNode: this.visitOver.bind(this),
    PartitionByNode: this.visitPartitionBy.bind(this),
    PartitionByItemNode: this.visitPartitionByItem.bind(this),
    SetOperationNode: this.visitSetOperation.bind(this),
    BinaryOperationNode: this.visitBinaryOperation.bind(this),
    UnaryOperationNode: this.visitUnaryOperation.bind(this),
    UsingNode: this.visitUsing.bind(this),
    FunctionNode: this.visitFunction.bind(this),
    CaseNode: this.visitCase.bind(this),
    WhenNode: this.visitWhen.bind(this),
    JSONReferenceNode: this.visitJSONReference.bind(this),
    JSONPathNode: this.visitJSONPath.bind(this),
    JSONPathLegNode: this.visitJSONPathLeg.bind(this),
    JSONOperatorChainNode: this.visitJSONOperatorChain.bind(this),
    TupleNode: this.visitTuple.bind(this),
    MergeQueryNode: this.visitMergeQuery.bind(this),
    MatchedNode: this.visitMatched.bind(this),
    AddIndexNode: this.visitAddIndex.bind(this),
    CastNode: this.visitCast.bind(this),
    FetchNode: this.visitFetch.bind(this),
    TopNode: this.visitTop.bind(this),
    OutputNode: this.visitOutput.bind(this)
  });
  visitNode = (node) => {
    this.nodeStack.push(node);
    this.#visitors[node.kind](node);
    this.nodeStack.pop();
  };
}
var init_operation_node_visitor = __esm2(() => {
  init_object_utils();
});
var DefaultQueryCompiler;
var SELECT_MODIFIER_SQL;
var SELECT_MODIFIER_PRIORITY;
var JOIN_TYPE_SQL;
var init_default_query_compiler = __esm2(() => {
  init_create_table_node();
  init_insert_query_node();
  init_operation_node_visitor();
  init_operator_node();
  init_parens_node();
  init_query_node();
  init_object_utils();
  init_create_view_node();
  init_set_operation_node();
  init_merge_query_node();
  DefaultQueryCompiler = class DefaultQueryCompiler2 extends OperationNodeVisitor {
    #sql = "";
    #parameters = [];
    get numParameters() {
      return this.#parameters.length;
    }
    compileQuery(node) {
      this.#sql = "";
      this.#parameters = [];
      this.nodeStack.splice(0, this.nodeStack.length);
      this.visitNode(node);
      return freeze({
        query: node,
        sql: this.getSql(),
        parameters: [...this.#parameters]
      });
    }
    getSql() {
      return this.#sql;
    }
    visitSelectQuery(node) {
      const wrapInParens = this.parentNode !== undefined && !ParensNode.is(this.parentNode) && !InsertQueryNode.is(this.parentNode) && !CreateTableNode.is(this.parentNode) && !CreateViewNode.is(this.parentNode) && !SetOperationNode.is(this.parentNode);
      if (this.parentNode === undefined && node.explain) {
        this.visitNode(node.explain);
        this.append(" ");
      }
      if (wrapInParens) {
        this.append("(");
      }
      if (node.with) {
        this.visitNode(node.with);
        this.append(" ");
      }
      this.append("select");
      if (node.distinctOn) {
        this.append(" ");
        this.compileDistinctOn(node.distinctOn);
      }
      if (node.frontModifiers?.length) {
        this.append(" ");
        this.compileList(node.frontModifiers, " ");
      }
      if (node.top) {
        this.append(" ");
        this.visitNode(node.top);
      }
      if (node.selections) {
        this.append(" ");
        this.compileList(node.selections);
      }
      if (node.from) {
        this.append(" ");
        this.visitNode(node.from);
      }
      if (node.joins) {
        this.append(" ");
        this.compileList(node.joins, " ");
      }
      if (node.where) {
        this.append(" ");
        this.visitNode(node.where);
      }
      if (node.groupBy) {
        this.append(" ");
        this.visitNode(node.groupBy);
      }
      if (node.having) {
        this.append(" ");
        this.visitNode(node.having);
      }
      if (node.setOperations) {
        this.append(" ");
        this.compileList(node.setOperations, " ");
      }
      if (node.orderBy) {
        this.append(" ");
        this.visitNode(node.orderBy);
      }
      if (node.limit) {
        this.append(" ");
        this.visitNode(node.limit);
      }
      if (node.offset) {
        this.append(" ");
        this.visitNode(node.offset);
      }
      if (node.fetch) {
        this.append(" ");
        this.visitNode(node.fetch);
      }
      if (node.endModifiers?.length) {
        this.append(" ");
        this.compileList(this.sortSelectModifiers([...node.endModifiers]), " ");
      }
      if (wrapInParens) {
        this.append(")");
      }
    }
    visitFrom(node) {
      this.append("from ");
      this.compileList(node.froms);
    }
    visitSelection(node) {
      this.visitNode(node.selection);
    }
    visitColumn(node) {
      this.visitNode(node.column);
    }
    compileDistinctOn(expressions) {
      this.append("distinct on (");
      this.compileList(expressions);
      this.append(")");
    }
    compileList(nodes, separator = ", ") {
      const lastIndex = nodes.length - 1;
      for (let i2 = 0;i2 <= lastIndex; i2++) {
        this.visitNode(nodes[i2]);
        if (i2 < lastIndex) {
          this.append(separator);
        }
      }
    }
    visitWhere(node) {
      this.append("where ");
      this.visitNode(node.where);
    }
    visitHaving(node) {
      this.append("having ");
      this.visitNode(node.having);
    }
    visitInsertQuery(node) {
      const rootQueryNode = this.nodeStack.find(QueryNode.is);
      const isSubQuery = rootQueryNode !== node;
      if (!isSubQuery && node.explain) {
        this.visitNode(node.explain);
        this.append(" ");
      }
      if (isSubQuery && !MergeQueryNode.is(rootQueryNode)) {
        this.append("(");
      }
      if (node.with) {
        this.visitNode(node.with);
        this.append(" ");
      }
      this.append(node.replace ? "replace" : "insert");
      if (node.ignore) {
        this.append(" ignore");
      }
      if (node.top) {
        this.append(" ");
        this.visitNode(node.top);
      }
      if (node.into) {
        this.append(" into ");
        this.visitNode(node.into);
      }
      if (node.columns) {
        this.append(" (");
        this.compileList(node.columns);
        this.append(")");
      }
      if (node.output) {
        this.append(" ");
        this.visitNode(node.output);
      }
      if (node.values) {
        this.append(" ");
        this.visitNode(node.values);
      }
      if (node.defaultValues) {
        this.append(" ");
        this.append("default values");
      }
      if (node.onConflict) {
        this.append(" ");
        this.visitNode(node.onConflict);
      }
      if (node.onDuplicateKey) {
        this.append(" ");
        this.visitNode(node.onDuplicateKey);
      }
      if (node.returning) {
        this.append(" ");
        this.visitNode(node.returning);
      }
      if (isSubQuery && !MergeQueryNode.is(rootQueryNode)) {
        this.append(")");
      }
    }
    visitValues(node) {
      this.append("values ");
      this.compileList(node.values);
    }
    visitDeleteQuery(node) {
      const isSubQuery = this.nodeStack.find(QueryNode.is) !== node;
      if (!isSubQuery && node.explain) {
        this.visitNode(node.explain);
        this.append(" ");
      }
      if (isSubQuery) {
        this.append("(");
      }
      if (node.with) {
        this.visitNode(node.with);
        this.append(" ");
      }
      this.append("delete ");
      if (node.top) {
        this.visitNode(node.top);
        this.append(" ");
      }
      this.visitNode(node.from);
      if (node.output) {
        this.append(" ");
        this.visitNode(node.output);
      }
      if (node.using) {
        this.append(" ");
        this.visitNode(node.using);
      }
      if (node.joins) {
        this.append(" ");
        this.compileList(node.joins, " ");
      }
      if (node.where) {
        this.append(" ");
        this.visitNode(node.where);
      }
      if (node.orderBy) {
        this.append(" ");
        this.visitNode(node.orderBy);
      }
      if (node.limit) {
        this.append(" ");
        this.visitNode(node.limit);
      }
      if (node.returning) {
        this.append(" ");
        this.visitNode(node.returning);
      }
      if (isSubQuery) {
        this.append(")");
      }
    }
    visitReturning(node) {
      this.append("returning ");
      this.compileList(node.selections);
    }
    visitAlias(node) {
      this.visitNode(node.node);
      this.append(" as ");
      this.visitNode(node.alias);
    }
    visitReference(node) {
      if (node.table) {
        this.visitNode(node.table);
        this.append(".");
      }
      this.visitNode(node.column);
    }
    visitSelectAll(_22) {
      this.append("*");
    }
    visitIdentifier(node) {
      this.append(this.getLeftIdentifierWrapper());
      this.compileUnwrappedIdentifier(node);
      this.append(this.getRightIdentifierWrapper());
    }
    compileUnwrappedIdentifier(node) {
      if (!isString22(node.name)) {
        throw new Error("a non-string identifier was passed to compileUnwrappedIdentifier.");
      }
      this.append(this.sanitizeIdentifier(node.name));
    }
    visitAnd(node) {
      this.visitNode(node.left);
      this.append(" and ");
      this.visitNode(node.right);
    }
    visitOr(node) {
      this.visitNode(node.left);
      this.append(" or ");
      this.visitNode(node.right);
    }
    visitValue(node) {
      if (node.immediate) {
        this.appendImmediateValue(node.value);
      } else {
        this.appendValue(node.value);
      }
    }
    visitValueList(node) {
      this.append("(");
      this.compileList(node.values);
      this.append(")");
    }
    visitTuple(node) {
      this.append("(");
      this.compileList(node.values);
      this.append(")");
    }
    visitPrimitiveValueList(node) {
      this.append("(");
      const { values: values3 } = node;
      for (let i2 = 0;i2 < values3.length; ++i2) {
        this.appendValue(values3[i2]);
        if (i2 !== values3.length - 1) {
          this.append(", ");
        }
      }
      this.append(")");
    }
    visitParens(node) {
      this.append("(");
      this.visitNode(node.node);
      this.append(")");
    }
    visitJoin(node) {
      this.append(JOIN_TYPE_SQL[node.joinType]);
      this.append(" ");
      this.visitNode(node.table);
      if (node.on) {
        this.append(" ");
        this.visitNode(node.on);
      }
    }
    visitOn(node) {
      this.append("on ");
      this.visitNode(node.on);
    }
    visitRaw(node) {
      const { sqlFragments, parameters: params } = node;
      for (let i2 = 0;i2 < sqlFragments.length; ++i2) {
        this.append(sqlFragments[i2]);
        if (params.length > i2) {
          this.visitNode(params[i2]);
        }
      }
    }
    visitOperator(node) {
      this.append(node.operator);
    }
    visitTable(node) {
      this.visitNode(node.table);
    }
    visitSchemableIdentifier(node) {
      if (node.schema) {
        this.visitNode(node.schema);
        this.append(".");
      }
      this.visitNode(node.identifier);
    }
    visitCreateTable(node) {
      this.append("create ");
      if (node.frontModifiers && node.frontModifiers.length > 0) {
        this.compileList(node.frontModifiers, " ");
        this.append(" ");
      }
      if (node.temporary) {
        this.append("temporary ");
      }
      this.append("table ");
      if (node.ifNotExists) {
        this.append("if not exists ");
      }
      this.visitNode(node.table);
      if (node.selectQuery) {
        this.append(" as ");
        this.visitNode(node.selectQuery);
      } else {
        this.append(" (");
        this.compileList([...node.columns, ...node.constraints ?? []]);
        this.append(")");
        if (node.onCommit) {
          this.append(" on commit ");
          this.append(node.onCommit);
        }
        if (node.endModifiers && node.endModifiers.length > 0) {
          this.append(" ");
          this.compileList(node.endModifiers, " ");
        }
      }
    }
    visitColumnDefinition(node) {
      if (node.ifNotExists) {
        this.append("if not exists ");
      }
      this.visitNode(node.column);
      this.append(" ");
      this.visitNode(node.dataType);
      if (node.unsigned) {
        this.append(" unsigned");
      }
      if (node.frontModifiers && node.frontModifiers.length > 0) {
        this.append(" ");
        this.compileList(node.frontModifiers, " ");
      }
      if (node.generated) {
        this.append(" ");
        this.visitNode(node.generated);
      }
      if (node.identity) {
        this.append(" identity");
      }
      if (node.defaultTo) {
        this.append(" ");
        this.visitNode(node.defaultTo);
      }
      if (node.notNull) {
        this.append(" not null");
      }
      if (node.unique) {
        this.append(" unique");
      }
      if (node.nullsNotDistinct) {
        this.append(" nulls not distinct");
      }
      if (node.primaryKey) {
        this.append(" primary key");
      }
      if (node.autoIncrement) {
        this.append(" ");
        this.append(this.getAutoIncrement());
      }
      if (node.references) {
        this.append(" ");
        this.visitNode(node.references);
      }
      if (node.check) {
        this.append(" ");
        this.visitNode(node.check);
      }
      if (node.endModifiers && node.endModifiers.length > 0) {
        this.append(" ");
        this.compileList(node.endModifiers, " ");
      }
    }
    getAutoIncrement() {
      return "auto_increment";
    }
    visitReferences(node) {
      this.append("references ");
      this.visitNode(node.table);
      this.append(" (");
      this.compileList(node.columns);
      this.append(")");
      if (node.onDelete) {
        this.append(" on delete ");
        this.append(node.onDelete);
      }
      if (node.onUpdate) {
        this.append(" on update ");
        this.append(node.onUpdate);
      }
    }
    visitDropTable(node) {
      this.append("drop table ");
      if (node.ifExists) {
        this.append("if exists ");
      }
      this.visitNode(node.table);
      if (node.cascade) {
        this.append(" cascade");
      }
    }
    visitDataType(node) {
      this.append(node.dataType);
    }
    visitOrderBy(node) {
      this.append("order by ");
      this.compileList(node.items);
    }
    visitOrderByItem(node) {
      this.visitNode(node.orderBy);
      if (node.direction) {
        this.append(" ");
        this.visitNode(node.direction);
      }
    }
    visitGroupBy(node) {
      this.append("group by ");
      this.compileList(node.items);
    }
    visitGroupByItem(node) {
      this.visitNode(node.groupBy);
    }
    visitUpdateQuery(node) {
      const rootQueryNode = this.nodeStack.find(QueryNode.is);
      const isSubQuery = rootQueryNode !== node;
      if (!isSubQuery && node.explain) {
        this.visitNode(node.explain);
        this.append(" ");
      }
      if (isSubQuery && !MergeQueryNode.is(rootQueryNode)) {
        this.append("(");
      }
      if (node.with) {
        this.visitNode(node.with);
        this.append(" ");
      }
      this.append("update ");
      if (node.top) {
        this.visitNode(node.top);
        this.append(" ");
      }
      if (node.table) {
        this.visitNode(node.table);
        this.append(" ");
      }
      this.append("set ");
      if (node.updates) {
        this.compileList(node.updates);
      }
      if (node.output) {
        this.append(" ");
        this.visitNode(node.output);
      }
      if (node.from) {
        this.append(" ");
        this.visitNode(node.from);
      }
      if (node.joins) {
        this.append(" ");
        this.compileList(node.joins, " ");
      }
      if (node.where) {
        this.append(" ");
        this.visitNode(node.where);
      }
      if (node.limit) {
        this.append(" ");
        this.visitNode(node.limit);
      }
      if (node.returning) {
        this.append(" ");
        this.visitNode(node.returning);
      }
      if (isSubQuery && !MergeQueryNode.is(rootQueryNode)) {
        this.append(")");
      }
    }
    visitColumnUpdate(node) {
      this.visitNode(node.column);
      this.append(" = ");
      this.visitNode(node.value);
    }
    visitLimit(node) {
      this.append("limit ");
      this.visitNode(node.limit);
    }
    visitOffset(node) {
      this.append("offset ");
      this.visitNode(node.offset);
    }
    visitOnConflict(node) {
      this.append("on conflict");
      if (node.columns) {
        this.append(" (");
        this.compileList(node.columns);
        this.append(")");
      } else if (node.constraint) {
        this.append(" on constraint ");
        this.visitNode(node.constraint);
      } else if (node.indexExpression) {
        this.append(" (");
        this.visitNode(node.indexExpression);
        this.append(")");
      }
      if (node.indexWhere) {
        this.append(" ");
        this.visitNode(node.indexWhere);
      }
      if (node.doNothing === true) {
        this.append(" do nothing");
      } else if (node.updates) {
        this.append(" do update set ");
        this.compileList(node.updates);
        if (node.updateWhere) {
          this.append(" ");
          this.visitNode(node.updateWhere);
        }
      }
    }
    visitOnDuplicateKey(node) {
      this.append("on duplicate key update ");
      this.compileList(node.updates);
    }
    visitCreateIndex(node) {
      this.append("create ");
      if (node.unique) {
        this.append("unique ");
      }
      this.append("index ");
      if (node.ifNotExists) {
        this.append("if not exists ");
      }
      this.visitNode(node.name);
      if (node.table) {
        this.append(" on ");
        this.visitNode(node.table);
      }
      if (node.using) {
        this.append(" using ");
        this.visitNode(node.using);
      }
      if (node.columns) {
        this.append(" (");
        this.compileList(node.columns);
        this.append(")");
      }
      if (node.nullsNotDistinct) {
        this.append(" nulls not distinct");
      }
      if (node.where) {
        this.append(" ");
        this.visitNode(node.where);
      }
    }
    visitDropIndex(node) {
      this.append("drop index ");
      if (node.ifExists) {
        this.append("if exists ");
      }
      this.visitNode(node.name);
      if (node.table) {
        this.append(" on ");
        this.visitNode(node.table);
      }
      if (node.cascade) {
        this.append(" cascade");
      }
    }
    visitCreateSchema(node) {
      this.append("create schema ");
      if (node.ifNotExists) {
        this.append("if not exists ");
      }
      this.visitNode(node.schema);
    }
    visitDropSchema(node) {
      this.append("drop schema ");
      if (node.ifExists) {
        this.append("if exists ");
      }
      this.visitNode(node.schema);
      if (node.cascade) {
        this.append(" cascade");
      }
    }
    visitPrimaryKeyConstraint(node) {
      if (node.name) {
        this.append("constraint ");
        this.visitNode(node.name);
        this.append(" ");
      }
      this.append("primary key (");
      this.compileList(node.columns);
      this.append(")");
    }
    visitUniqueConstraint(node) {
      if (node.name) {
        this.append("constraint ");
        this.visitNode(node.name);
        this.append(" ");
      }
      this.append("unique");
      if (node.nullsNotDistinct) {
        this.append(" nulls not distinct");
      }
      this.append(" (");
      this.compileList(node.columns);
      this.append(")");
    }
    visitCheckConstraint(node) {
      if (node.name) {
        this.append("constraint ");
        this.visitNode(node.name);
        this.append(" ");
      }
      this.append("check (");
      this.visitNode(node.expression);
      this.append(")");
    }
    visitForeignKeyConstraint(node) {
      if (node.name) {
        this.append("constraint ");
        this.visitNode(node.name);
        this.append(" ");
      }
      this.append("foreign key (");
      this.compileList(node.columns);
      this.append(") ");
      this.visitNode(node.references);
      if (node.onDelete) {
        this.append(" on delete ");
        this.append(node.onDelete);
      }
      if (node.onUpdate) {
        this.append(" on update ");
        this.append(node.onUpdate);
      }
    }
    visitList(node) {
      this.compileList(node.items);
    }
    visitWith(node) {
      this.append("with ");
      if (node.recursive) {
        this.append("recursive ");
      }
      this.compileList(node.expressions);
    }
    visitCommonTableExpression(node) {
      this.visitNode(node.name);
      this.append(" as ");
      if (isBoolean(node.materialized)) {
        if (!node.materialized) {
          this.append("not ");
        }
        this.append("materialized ");
      }
      this.visitNode(node.expression);
    }
    visitCommonTableExpressionName(node) {
      this.visitNode(node.table);
      if (node.columns) {
        this.append("(");
        this.compileList(node.columns);
        this.append(")");
      }
    }
    visitAlterTable(node) {
      this.append("alter table ");
      this.visitNode(node.table);
      this.append(" ");
      if (node.renameTo) {
        this.append("rename to ");
        this.visitNode(node.renameTo);
      }
      if (node.setSchema) {
        this.append("set schema ");
        this.visitNode(node.setSchema);
      }
      if (node.addConstraint) {
        this.visitNode(node.addConstraint);
      }
      if (node.dropConstraint) {
        this.visitNode(node.dropConstraint);
      }
      if (node.columnAlterations) {
        this.compileColumnAlterations(node.columnAlterations);
      }
      if (node.addIndex) {
        this.visitNode(node.addIndex);
      }
      if (node.dropIndex) {
        this.visitNode(node.dropIndex);
      }
    }
    visitAddColumn(node) {
      this.append("add column ");
      this.visitNode(node.column);
    }
    visitRenameColumn(node) {
      this.append("rename column ");
      this.visitNode(node.column);
      this.append(" to ");
      this.visitNode(node.renameTo);
    }
    visitDropColumn(node) {
      this.append("drop column ");
      this.visitNode(node.column);
    }
    visitAlterColumn(node) {
      this.append("alter column ");
      this.visitNode(node.column);
      this.append(" ");
      if (node.dataType) {
        if (this.announcesNewColumnDataType()) {
          this.append("type ");
        }
        this.visitNode(node.dataType);
        if (node.dataTypeExpression) {
          this.append("using ");
          this.visitNode(node.dataTypeExpression);
        }
      }
      if (node.setDefault) {
        this.append("set default ");
        this.visitNode(node.setDefault);
      }
      if (node.dropDefault) {
        this.append("drop default");
      }
      if (node.setNotNull) {
        this.append("set not null");
      }
      if (node.dropNotNull) {
        this.append("drop not null");
      }
    }
    visitModifyColumn(node) {
      this.append("modify column ");
      this.visitNode(node.column);
    }
    visitAddConstraint(node) {
      this.append("add ");
      this.visitNode(node.constraint);
    }
    visitDropConstraint(node) {
      this.append("drop constraint ");
      if (node.ifExists) {
        this.append("if exists ");
      }
      this.visitNode(node.constraintName);
      if (node.modifier === "cascade") {
        this.append(" cascade");
      } else if (node.modifier === "restrict") {
        this.append(" restrict");
      }
    }
    visitSetOperation(node) {
      this.append(node.operator);
      this.append(" ");
      if (node.all) {
        this.append("all ");
      }
      this.visitNode(node.expression);
    }
    visitCreateView(node) {
      this.append("create ");
      if (node.orReplace) {
        this.append("or replace ");
      }
      if (node.materialized) {
        this.append("materialized ");
      }
      if (node.temporary) {
        this.append("temporary ");
      }
      this.append("view ");
      if (node.ifNotExists) {
        this.append("if not exists ");
      }
      this.visitNode(node.name);
      this.append(" ");
      if (node.columns) {
        this.append("(");
        this.compileList(node.columns);
        this.append(") ");
      }
      if (node.as) {
        this.append("as ");
        this.visitNode(node.as);
      }
    }
    visitDropView(node) {
      this.append("drop ");
      if (node.materialized) {
        this.append("materialized ");
      }
      this.append("view ");
      if (node.ifExists) {
        this.append("if exists ");
      }
      this.visitNode(node.name);
      if (node.cascade) {
        this.append(" cascade");
      }
    }
    visitGenerated(node) {
      this.append("generated ");
      if (node.always) {
        this.append("always ");
      }
      if (node.byDefault) {
        this.append("by default ");
      }
      this.append("as ");
      if (node.identity) {
        this.append("identity");
      }
      if (node.expression) {
        this.append("(");
        this.visitNode(node.expression);
        this.append(")");
      }
      if (node.stored) {
        this.append(" stored");
      }
    }
    visitDefaultValue(node) {
      this.append("default ");
      this.visitNode(node.defaultValue);
    }
    visitSelectModifier(node) {
      if (node.rawModifier) {
        this.visitNode(node.rawModifier);
      } else {
        this.append(SELECT_MODIFIER_SQL[node.modifier]);
      }
      if (node.of) {
        this.append(" of ");
        this.compileList(node.of, ", ");
      }
    }
    visitCreateType(node) {
      this.append("create type ");
      this.visitNode(node.name);
      if (node.enum) {
        this.append(" as enum ");
        this.visitNode(node.enum);
      }
    }
    visitDropType(node) {
      this.append("drop type ");
      if (node.ifExists) {
        this.append("if exists ");
      }
      this.visitNode(node.name);
    }
    visitExplain(node) {
      this.append("explain");
      if (node.options || node.format) {
        this.append(" ");
        this.append(this.getLeftExplainOptionsWrapper());
        if (node.options) {
          this.visitNode(node.options);
          if (node.format) {
            this.append(this.getExplainOptionsDelimiter());
          }
        }
        if (node.format) {
          this.append("format");
          this.append(this.getExplainOptionAssignment());
          this.append(node.format);
        }
        this.append(this.getRightExplainOptionsWrapper());
      }
    }
    visitDefaultInsertValue(_22) {
      this.append("default");
    }
    visitAggregateFunction(node) {
      this.append(node.func);
      this.append("(");
      if (node.distinct) {
        this.append("distinct ");
      }
      this.compileList(node.aggregated);
      this.append(")");
      if (node.filter) {
        this.append(" filter(");
        this.visitNode(node.filter);
        this.append(")");
      }
      if (node.over) {
        this.append(" ");
        this.visitNode(node.over);
      }
    }
    visitOver(node) {
      this.append("over(");
      if (node.partitionBy) {
        this.visitNode(node.partitionBy);
        if (node.orderBy) {
          this.append(" ");
        }
      }
      if (node.orderBy) {
        this.visitNode(node.orderBy);
      }
      this.append(")");
    }
    visitPartitionBy(node) {
      this.append("partition by ");
      this.compileList(node.items);
    }
    visitPartitionByItem(node) {
      this.visitNode(node.partitionBy);
    }
    visitBinaryOperation(node) {
      this.visitNode(node.leftOperand);
      this.append(" ");
      this.visitNode(node.operator);
      this.append(" ");
      this.visitNode(node.rightOperand);
    }
    visitUnaryOperation(node) {
      this.visitNode(node.operator);
      if (!this.isMinusOperator(node.operator)) {
        this.append(" ");
      }
      this.visitNode(node.operand);
    }
    isMinusOperator(node) {
      return OperatorNode.is(node) && node.operator === "-";
    }
    visitUsing(node) {
      this.append("using ");
      this.compileList(node.tables);
    }
    visitFunction(node) {
      this.append(node.func);
      this.append("(");
      this.compileList(node.arguments);
      this.append(")");
    }
    visitCase(node) {
      this.append("case");
      if (node.value) {
        this.append(" ");
        this.visitNode(node.value);
      }
      if (node.when) {
        this.append(" ");
        this.compileList(node.when, " ");
      }
      if (node.else) {
        this.append(" else ");
        this.visitNode(node.else);
      }
      this.append(" end");
      if (node.isStatement) {
        this.append(" case");
      }
    }
    visitWhen(node) {
      this.append("when ");
      this.visitNode(node.condition);
      if (node.result) {
        this.append(" then ");
        this.visitNode(node.result);
      }
    }
    visitJSONReference(node) {
      this.visitNode(node.reference);
      this.visitNode(node.traversal);
    }
    visitJSONPath(node) {
      if (node.inOperator) {
        this.visitNode(node.inOperator);
      }
      this.append("'$");
      for (const pathLeg of node.pathLegs) {
        this.visitNode(pathLeg);
      }
      this.append("'");
    }
    visitJSONPathLeg(node) {
      const isArrayLocation = node.type === "ArrayLocation";
      this.append(isArrayLocation ? "[" : ".");
      this.append(String(node.value));
      if (isArrayLocation) {
        this.append("]");
      }
    }
    visitJSONOperatorChain(node) {
      for (let i2 = 0, len = node.values.length;i2 < len; i2++) {
        if (i2 === len - 1) {
          this.visitNode(node.operator);
        } else {
          this.append("->");
        }
        this.visitNode(node.values[i2]);
      }
    }
    visitMergeQuery(node) {
      if (node.with) {
        this.visitNode(node.with);
        this.append(" ");
      }
      this.append("merge ");
      if (node.top) {
        this.visitNode(node.top);
        this.append(" ");
      }
      this.append("into ");
      this.visitNode(node.into);
      if (node.using) {
        this.append(" ");
        this.visitNode(node.using);
      }
      if (node.whens) {
        this.append(" ");
        this.compileList(node.whens, " ");
      }
      if (node.output) {
        this.append(" ");
        this.visitNode(node.output);
      }
    }
    visitMatched(node) {
      if (node.not) {
        this.append("not ");
      }
      this.append("matched");
      if (node.bySource) {
        this.append(" by source");
      }
    }
    visitAddIndex(node) {
      this.append("add ");
      if (node.unique) {
        this.append("unique ");
      }
      this.append("index ");
      this.visitNode(node.name);
      if (node.columns) {
        this.append(" (");
        this.compileList(node.columns);
        this.append(")");
      }
      if (node.using) {
        this.append(" using ");
        this.visitNode(node.using);
      }
    }
    visitCast(node) {
      this.append("cast(");
      this.visitNode(node.expression);
      this.append(" as ");
      this.visitNode(node.dataType);
      this.append(")");
    }
    visitFetch(node) {
      this.append("fetch next ");
      this.visitNode(node.rowCount);
      this.append(` rows ${node.modifier}`);
    }
    visitOutput(node) {
      this.append("output ");
      this.compileList(node.selections);
    }
    visitTop(node) {
      this.append(`top(${node.expression})`);
      if (node.modifiers) {
        this.append(` ${node.modifiers}`);
      }
    }
    append(str) {
      this.#sql += str;
    }
    appendValue(parameter) {
      this.addParameter(parameter);
      this.append(this.getCurrentParameterPlaceholder());
    }
    getLeftIdentifierWrapper() {
      return '"';
    }
    getRightIdentifierWrapper() {
      return '"';
    }
    getCurrentParameterPlaceholder() {
      return "$" + this.numParameters;
    }
    getLeftExplainOptionsWrapper() {
      return "(";
    }
    getExplainOptionAssignment() {
      return " ";
    }
    getExplainOptionsDelimiter() {
      return ", ";
    }
    getRightExplainOptionsWrapper() {
      return ")";
    }
    sanitizeIdentifier(identifier) {
      const leftWrap = this.getLeftIdentifierWrapper();
      const rightWrap = this.getRightIdentifierWrapper();
      let sanitized = "";
      for (const c22 of identifier) {
        sanitized += c22;
        if (c22 === leftWrap) {
          sanitized += leftWrap;
        } else if (c22 === rightWrap) {
          sanitized += rightWrap;
        }
      }
      return sanitized;
    }
    addParameter(parameter) {
      this.#parameters.push(parameter);
    }
    appendImmediateValue(value) {
      if (isString22(value)) {
        this.append(`'${value}'`);
      } else if (isNumber(value) || isBoolean(value)) {
        this.append(value.toString());
      } else if (isNull(value)) {
        this.append("null");
      } else if (isDate(value)) {
        this.appendImmediateValue(value.toISOString());
      } else if (isBigInt(value)) {
        this.appendImmediateValue(value.toString());
      } else {
        throw new Error(`invalid immediate value ${value}`);
      }
    }
    sortSelectModifiers(arr) {
      arr.sort((left, right) => left.modifier && right.modifier ? SELECT_MODIFIER_PRIORITY[left.modifier] - SELECT_MODIFIER_PRIORITY[right.modifier] : 1);
      return freeze(arr);
    }
    compileColumnAlterations(columnAlterations) {
      this.compileList(columnAlterations);
    }
    announcesNewColumnDataType() {
      return true;
    }
  };
  SELECT_MODIFIER_SQL = freeze({
    ForKeyShare: "for key share",
    ForNoKeyUpdate: "for no key update",
    ForUpdate: "for update",
    ForShare: "for share",
    NoWait: "nowait",
    SkipLocked: "skip locked",
    Distinct: "distinct"
  });
  SELECT_MODIFIER_PRIORITY = freeze({
    ForKeyShare: 1,
    ForNoKeyUpdate: 1,
    ForUpdate: 1,
    ForShare: 1,
    NoWait: 2,
    SkipLocked: 2,
    Distinct: 0
  });
  JOIN_TYPE_SQL = freeze({
    InnerJoin: "inner join",
    LeftJoin: "left join",
    RightJoin: "right join",
    FullJoin: "full join",
    LateralInnerJoin: "inner join lateral",
    LateralLeftJoin: "left join lateral",
    Using: "using"
  });
});
var CompiledQuery;
var init_compiled_query = __esm2(() => {
  init_raw_node();
  init_object_utils();
  CompiledQuery = freeze({
    raw(sql2, parameters = []) {
      return freeze({
        sql: sql2,
        query: RawNode.createWithSql(sql2),
        parameters: freeze(parameters)
      });
    }
  });
});
var init_database_connection = () => {
};
var init_connection_provider = () => {
};
var init_dialect = () => {
};
var init_dialect_adapter = () => {
};

class DialectAdapterBase {
  get supportsCreateIfNotExists() {
    return true;
  }
  get supportsTransactionalDdl() {
    return false;
  }
  get supportsReturning() {
    return false;
  }
  get supportsOutput() {
    return false;
  }
}
var init_database_introspector = () => {
};

class SqliteDriver {
  #config;
  #connectionMutex = new ConnectionMutex;
  #db;
  #connection;
  constructor(config5) {
    this.#config = freeze({ ...config5 });
  }
  async init() {
    this.#db = isFunction22(this.#config.database) ? await this.#config.database() : this.#config.database;
    this.#connection = new SqliteConnection(this.#db);
    if (this.#config.onCreateConnection) {
      await this.#config.onCreateConnection(this.#connection);
    }
  }
  async acquireConnection() {
    await this.#connectionMutex.lock();
    return this.#connection;
  }
  async beginTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("begin"));
  }
  async commitTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("commit"));
  }
  async rollbackTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("rollback"));
  }
  async releaseConnection() {
    this.#connectionMutex.unlock();
  }
  async destroy() {
    this.#db?.close();
  }
}

class SqliteConnection {
  #db;
  constructor(db2) {
    this.#db = db2;
  }
  executeQuery(compiledQuery) {
    const { sql: sql2, parameters } = compiledQuery;
    const stmt = this.#db.prepare(sql2);
    if (stmt.reader) {
      return Promise.resolve({
        rows: stmt.all(parameters)
      });
    } else {
      const { changes, lastInsertRowid } = stmt.run(parameters);
      const numAffectedRows = changes !== undefined && changes !== null ? BigInt(changes) : undefined;
      return Promise.resolve({
        numUpdatedOrDeletedRows: numAffectedRows,
        numAffectedRows,
        insertId: lastInsertRowid !== undefined && lastInsertRowid !== null ? BigInt(lastInsertRowid) : undefined,
        rows: []
      });
    }
  }
  async* streamQuery(compiledQuery, _chunkSize) {
    const { sql: sql2, parameters, query } = compiledQuery;
    const stmt = this.#db.prepare(sql2);
    if (SelectQueryNode.is(query)) {
      const iter = stmt.iterate(parameters);
      for (const row of iter) {
        yield {
          rows: [row]
        };
      }
    } else {
      throw new Error("Sqlite driver only supports streaming of select queries");
    }
  }
}

class ConnectionMutex {
  #promise;
  #resolve;
  async lock() {
    while (this.#promise) {
      await this.#promise;
    }
    this.#promise = new Promise((resolve5) => {
      this.#resolve = resolve5;
    });
  }
  unlock() {
    const resolve5 = this.#resolve;
    this.#promise = undefined;
    this.#resolve = undefined;
    resolve5?.();
  }
}
var init_sqlite_driver = __esm2(() => {
  init_select_query_node();
  init_compiled_query();
  init_object_utils();
});
var ID_WRAP_REGEX;
var SqliteQueryCompiler;
var init_sqlite_query_compiler = __esm2(() => {
  init_default_query_compiler();
  ID_WRAP_REGEX = /"/g;
  SqliteQueryCompiler = class SqliteQueryCompiler2 extends DefaultQueryCompiler {
    getCurrentParameterPlaceholder() {
      return "?";
    }
    getLeftExplainOptionsWrapper() {
      return "";
    }
    getRightExplainOptionsWrapper() {
      return "";
    }
    getLeftIdentifierWrapper() {
      return '"';
    }
    getRightIdentifierWrapper() {
      return '"';
    }
    getAutoIncrement() {
      return "autoincrement";
    }
    sanitizeIdentifier(identifier) {
      return identifier.replace(ID_WRAP_REGEX, '""');
    }
    visitDefaultInsertValue(_22) {
      this.append("null");
    }
  };
});

class NoopPlugin {
  transformQuery(args) {
    return args.node;
  }
  async transformResult(args) {
    return args.result;
  }
}

class Migrator {
  #props;
  constructor(props) {
    this.#props = freeze(props);
  }
  async getMigrations() {
    const executedMigrations = await this.#doesTableExists(this.#migrationTable) ? await this.#props.db.withPlugin(this.#schemaPlugin).selectFrom(this.#migrationTable).select(["name", "timestamp"]).execute() : [];
    const migrations = await this.#resolveMigrations();
    return migrations.map(({ name, ...migration }) => {
      const executed = executedMigrations.find((it) => it.name === name);
      return {
        name,
        migration,
        executedAt: executed ? new Date(executed.timestamp) : undefined
      };
    });
  }
  async migrateToLatest() {
    return this.#migrate(() => ({ direction: "Up", step: Infinity }));
  }
  async migrateTo(targetMigrationName) {
    return this.#migrate(({ migrations, executedMigrations, pendingMigrations }) => {
      if (targetMigrationName === NO_MIGRATIONS) {
        return { direction: "Down", step: Infinity };
      }
      if (!migrations.find((m22) => m22.name === targetMigrationName)) {
        throw new Error(`migration "${targetMigrationName}" doesn't exist`);
      }
      const executedIndex = executedMigrations.indexOf(targetMigrationName);
      const pendingIndex = pendingMigrations.findIndex((m22) => m22.name === targetMigrationName);
      if (executedIndex !== -1) {
        return {
          direction: "Down",
          step: executedMigrations.length - executedIndex - 1
        };
      } else if (pendingIndex !== -1) {
        return { direction: "Up", step: pendingIndex + 1 };
      } else {
        throw new Error(`migration "${targetMigrationName}" isn't executed or pending`);
      }
    });
  }
  async migrateUp() {
    return this.#migrate(() => ({ direction: "Up", step: 1 }));
  }
  async migrateDown() {
    return this.#migrate(() => ({ direction: "Down", step: 1 }));
  }
  async#migrate(getMigrationDirectionAndStep) {
    try {
      await this.#ensureMigrationTablesExists();
      return await this.#runMigrations(getMigrationDirectionAndStep);
    } catch (error) {
      if (error instanceof MigrationResultSetError) {
        return error.resultSet;
      }
      return { error };
    }
  }
  get #migrationTableSchema() {
    return this.#props.migrationTableSchema;
  }
  get #migrationTable() {
    return this.#props.migrationTableName ?? DEFAULT_MIGRATION_TABLE;
  }
  get #migrationLockTable() {
    return this.#props.migrationLockTableName ?? DEFAULT_MIGRATION_LOCK_TABLE;
  }
  get #allowUnorderedMigrations() {
    return this.#props.allowUnorderedMigrations ?? DEFAULT_ALLOW_UNORDERED_MIGRATIONS;
  }
  get #schemaPlugin() {
    if (this.#migrationTableSchema) {
      return new WithSchemaPlugin(this.#migrationTableSchema);
    }
    return new NoopPlugin;
  }
  async#ensureMigrationTablesExists() {
    await this.#ensureMigrationTableSchemaExists();
    await this.#ensureMigrationTableExists();
    await this.#ensureMigrationLockTableExists();
    await this.#ensureLockRowExists();
  }
  async#ensureMigrationTableSchemaExists() {
    if (!this.#migrationTableSchema) {
      return;
    }
    if (!await this.#doesSchemaExists()) {
      try {
        await this.#createIfNotExists(this.#props.db.schema.createSchema(this.#migrationTableSchema));
      } catch (error) {
        if (!await this.#doesSchemaExists()) {
          throw error;
        }
      }
    }
  }
  async#ensureMigrationTableExists() {
    if (!await this.#doesTableExists(this.#migrationTable)) {
      try {
        if (this.#migrationTableSchema) {
          await this.#createIfNotExists(this.#props.db.schema.createSchema(this.#migrationTableSchema));
        }
        await this.#createIfNotExists(this.#props.db.schema.withPlugin(this.#schemaPlugin).createTable(this.#migrationTable).addColumn("name", "varchar(255)", (col) => col.notNull().primaryKey()).addColumn("timestamp", "varchar(255)", (col) => col.notNull()));
      } catch (error) {
        if (!await this.#doesTableExists(this.#migrationTable)) {
          throw error;
        }
      }
    }
  }
  async#ensureMigrationLockTableExists() {
    if (!await this.#doesTableExists(this.#migrationLockTable)) {
      try {
        await this.#createIfNotExists(this.#props.db.schema.withPlugin(this.#schemaPlugin).createTable(this.#migrationLockTable).addColumn("id", "varchar(255)", (col) => col.notNull().primaryKey()).addColumn("is_locked", "integer", (col) => col.notNull().defaultTo(0)));
      } catch (error) {
        if (!await this.#doesTableExists(this.#migrationLockTable)) {
          throw error;
        }
      }
    }
  }
  async#ensureLockRowExists() {
    if (!await this.#doesLockRowExists()) {
      try {
        await this.#props.db.withPlugin(this.#schemaPlugin).insertInto(this.#migrationLockTable).values({ id: MIGRATION_LOCK_ID, is_locked: 0 }).execute();
      } catch (error) {
        if (!await this.#doesLockRowExists()) {
          throw error;
        }
      }
    }
  }
  async#doesSchemaExists() {
    const schemas = await this.#props.db.introspection.getSchemas();
    return schemas.some((it) => it.name === this.#migrationTableSchema);
  }
  async#doesTableExists(tableName) {
    const schema2 = this.#migrationTableSchema;
    const tables2 = await this.#props.db.introspection.getTables({
      withInternalKyselyTables: true
    });
    return tables2.some((it) => it.name === tableName && (!schema2 || it.schema === schema2));
  }
  async#doesLockRowExists() {
    const lockRow = await this.#props.db.withPlugin(this.#schemaPlugin).selectFrom(this.#migrationLockTable).where("id", "=", MIGRATION_LOCK_ID).select("id").executeTakeFirst();
    return !!lockRow;
  }
  async#runMigrations(getMigrationDirectionAndStep) {
    const adapter = this.#props.db.getExecutor().adapter;
    const lockOptions = freeze({
      lockTable: this.#props.migrationLockTableName ?? DEFAULT_MIGRATION_LOCK_TABLE,
      lockRowId: MIGRATION_LOCK_ID,
      lockTableSchema: this.#props.migrationTableSchema
    });
    const run2 = async (db2) => {
      try {
        await adapter.acquireMigrationLock(db2, lockOptions);
        const state = await this.#getState(db2);
        if (state.migrations.length === 0) {
          return { results: [] };
        }
        const { direction, step } = getMigrationDirectionAndStep(state);
        if (step <= 0) {
          return { results: [] };
        }
        if (direction === "Down") {
          return await this.#migrateDown(db2, state, step);
        } else if (direction === "Up") {
          return await this.#migrateUp(db2, state, step);
        }
        return { results: [] };
      } finally {
        await adapter.releaseMigrationLock(db2, lockOptions);
      }
    };
    if (adapter.supportsTransactionalDdl) {
      return this.#props.db.transaction().execute(run2);
    } else {
      return this.#props.db.connection().execute(run2);
    }
  }
  async#getState(db2) {
    const migrations = await this.#resolveMigrations();
    const executedMigrations = await this.#getExecutedMigrations(db2);
    this.#ensureNoMissingMigrations(migrations, executedMigrations);
    if (!this.#allowUnorderedMigrations) {
      this.#ensureMigrationsInOrder(migrations, executedMigrations);
    }
    const pendingMigrations = this.#getPendingMigrations(migrations, executedMigrations);
    return freeze({
      migrations,
      executedMigrations,
      lastMigration: getLast(executedMigrations),
      pendingMigrations
    });
  }
  #getPendingMigrations(migrations, executedMigrations) {
    return migrations.filter((migration) => {
      return !executedMigrations.includes(migration.name);
    });
  }
  async#resolveMigrations() {
    const allMigrations = await this.#props.provider.getMigrations();
    return Object.keys(allMigrations).sort().map((name) => ({
      ...allMigrations[name],
      name
    }));
  }
  async#getExecutedMigrations(db2) {
    const executedMigrations = await db2.withPlugin(this.#schemaPlugin).selectFrom(this.#migrationTable).select("name").orderBy(["timestamp", "name"]).execute();
    return executedMigrations.map((it) => it.name);
  }
  #ensureNoMissingMigrations(migrations, executedMigrations) {
    for (const executed of executedMigrations) {
      if (!migrations.some((it) => it.name === executed)) {
        throw new Error(`corrupted migrations: previously executed migration ${executed} is missing`);
      }
    }
  }
  #ensureMigrationsInOrder(migrations, executedMigrations) {
    for (let i2 = 0;i2 < executedMigrations.length; ++i2) {
      if (migrations[i2].name !== executedMigrations[i2]) {
        throw new Error(`corrupted migrations: expected previously executed migration ${executedMigrations[i2]} to be at index ${i2} but ${migrations[i2].name} was found in its place. New migrations must always have a name that comes alphabetically after the last executed migration.`);
      }
    }
  }
  async#migrateDown(db2, state, step) {
    const migrationsToRollback = state.executedMigrations.slice().reverse().slice(0, step).map((name) => {
      return state.migrations.find((it) => it.name === name);
    });
    const results = migrationsToRollback.map((migration) => {
      return {
        migrationName: migration.name,
        direction: "Down",
        status: "NotExecuted"
      };
    });
    for (let i2 = 0;i2 < results.length; ++i2) {
      const migration = migrationsToRollback[i2];
      try {
        if (migration.down) {
          await migration.down(db2);
          await db2.withPlugin(this.#schemaPlugin).deleteFrom(this.#migrationTable).where("name", "=", migration.name).execute();
          results[i2] = {
            migrationName: migration.name,
            direction: "Down",
            status: "Success"
          };
        }
      } catch (error) {
        results[i2] = {
          migrationName: migration.name,
          direction: "Down",
          status: "Error"
        };
        throw new MigrationResultSetError({
          error,
          results
        });
      }
    }
    return { results };
  }
  async#migrateUp(db2, state, step) {
    const migrationsToRun = state.pendingMigrations.slice(0, step);
    const results = migrationsToRun.map((migration) => {
      return {
        migrationName: migration.name,
        direction: "Up",
        status: "NotExecuted"
      };
    });
    for (let i2 = 0;i2 < results.length; i2++) {
      const migration = state.pendingMigrations[i2];
      try {
        await migration.up(db2);
        await db2.withPlugin(this.#schemaPlugin).insertInto(this.#migrationTable).values({
          name: migration.name,
          timestamp: new Date().toISOString()
        }).execute();
        results[i2] = {
          migrationName: migration.name,
          direction: "Up",
          status: "Success"
        };
      } catch (error) {
        results[i2] = {
          migrationName: migration.name,
          direction: "Up",
          status: "Error"
        };
        throw new MigrationResultSetError({
          error,
          results
        });
      }
    }
    return { results };
  }
  async#createIfNotExists(qb) {
    if (this.#props.db.getExecutor().adapter.supportsCreateIfNotExists) {
      qb = qb.ifNotExists();
    }
    await qb.execute();
  }
}
var DEFAULT_MIGRATION_TABLE = "kysely_migration";
var DEFAULT_MIGRATION_LOCK_TABLE = "kysely_migration_lock";
var DEFAULT_ALLOW_UNORDERED_MIGRATIONS = false;
var MIGRATION_LOCK_ID = "migration_lock";
var NO_MIGRATIONS;
var MigrationResultSetError;
var init_migrator = __esm2(() => {
  init_with_schema_plugin();
  init_object_utils();
  NO_MIGRATIONS = freeze({ __noMigrations__: true });
  MigrationResultSetError = class MigrationResultSetError2 extends Error {
    #resultSet;
    constructor(result2) {
      super();
      this.#resultSet = result2;
    }
    get resultSet() {
      return this.#resultSet;
    }
  };
});

class SqliteIntrospector {
  #db;
  constructor(db2) {
    this.#db = db2;
  }
  async getSchemas() {
    return [];
  }
  async getTables(options3 = { withInternalKyselyTables: false }) {
    let query = this.#db.selectFrom("sqlite_master").where("type", "in", ["table", "view"]).where("name", "not like", "sqlite_%").select("name").orderBy("name").$castTo();
    if (!options3.withInternalKyselyTables) {
      query = query.where("name", "!=", DEFAULT_MIGRATION_TABLE).where("name", "!=", DEFAULT_MIGRATION_LOCK_TABLE);
    }
    const tables2 = await query.execute();
    return Promise.all(tables2.map(({ name }) => this.#getTableMetadata(name)));
  }
  async getMetadata(options3) {
    return {
      tables: await this.getTables(options3)
    };
  }
  async#getTableMetadata(table) {
    const db2 = this.#db;
    const tableDefinition = await db2.selectFrom("sqlite_master").where("name", "=", table).select(["sql", "type"]).$castTo().executeTakeFirstOrThrow();
    const autoIncrementCol = tableDefinition.sql?.split(/[\(\),]/)?.find((it) => it.toLowerCase().includes("autoincrement"))?.trimStart()?.split(/\s+/)?.[0]?.replace(/["`]/g, "");
    const columns = await db2.selectFrom(sql`pragma_table_info(${table})`.as("table_info")).select(["name", "type", "notnull", "dflt_value"]).orderBy("cid").execute();
    return {
      name: table,
      isView: tableDefinition.type === "view",
      columns: columns.map((col) => ({
        name: col.name,
        dataType: col.type,
        isNullable: !col.notnull,
        isAutoIncrementing: col.name === autoIncrementCol,
        hasDefaultValue: col.dflt_value != null,
        comment: undefined
      }))
    };
  }
}
var init_sqlite_introspector = __esm2(() => {
  init_migrator();
  init_sql();
});
var SqliteAdapter;
var init_sqlite_adapter = __esm2(() => {
  SqliteAdapter = class SqliteAdapter2 extends DialectAdapterBase {
    get supportsTransactionalDdl() {
      return false;
    }
    get supportsReturning() {
      return true;
    }
    async acquireMigrationLock(_db, _opt) {
    }
    async releaseMigrationLock(_db, _opt) {
    }
  };
});

class SqliteDialect {
  #config;
  constructor(config5) {
    this.#config = freeze({ ...config5 });
  }
  createDriver() {
    return new SqliteDriver(this.#config);
  }
  createQueryCompiler() {
    return new SqliteQueryCompiler;
  }
  createAdapter() {
    return new SqliteAdapter;
  }
  createIntrospector(db2) {
    return new SqliteIntrospector(db2);
  }
}
var init_sqlite_dialect = __esm2(() => {
  init_sqlite_driver();
  init_sqlite_query_compiler();
  init_sqlite_introspector();
  init_sqlite_adapter();
  init_object_utils();
});
var init_sqlite_dialect_config = () => {
};
var ID_WRAP_REGEX2;
var PostgresQueryCompiler;
var init_postgres_query_compiler = __esm2(() => {
  init_default_query_compiler();
  ID_WRAP_REGEX2 = /"/g;
  PostgresQueryCompiler = class PostgresQueryCompiler2 extends DefaultQueryCompiler {
    sanitizeIdentifier(identifier) {
      return identifier.replace(ID_WRAP_REGEX2, '""');
    }
  };
});

class PostgresIntrospector {
  #db;
  constructor(db2) {
    this.#db = db2;
  }
  async getSchemas() {
    let rawSchemas = await this.#db.selectFrom("pg_catalog.pg_namespace").select("nspname").$castTo().execute();
    return rawSchemas.map((it) => ({ name: it.nspname }));
  }
  async getTables(options3 = { withInternalKyselyTables: false }) {
    let query = this.#db.selectFrom("pg_catalog.pg_attribute as a").innerJoin("pg_catalog.pg_class as c", "a.attrelid", "c.oid").innerJoin("pg_catalog.pg_namespace as ns", "c.relnamespace", "ns.oid").innerJoin("pg_catalog.pg_type as typ", "a.atttypid", "typ.oid").innerJoin("pg_catalog.pg_namespace as dtns", "typ.typnamespace", "dtns.oid").select([
      "a.attname as column",
      "a.attnotnull as not_null",
      "a.atthasdef as has_default",
      "c.relname as table",
      "c.relkind as table_type",
      "ns.nspname as schema",
      "typ.typname as type",
      "dtns.nspname as type_schema",
      sql`col_description(a.attrelid, a.attnum)`.as("column_description"),
      this.#db.selectFrom("pg_class").select(sql`true`.as("auto_incrementing")).whereRef("relnamespace", "=", "c.relnamespace").where("relkind", "=", "S").where("relname", "=", sql`c.relname || '_' || a.attname || '_seq'`).as("auto_incrementing")
    ]).where((eb) => eb.or([eb("c.relkind", "=", "r"), eb("c.relkind", "=", "v"), eb("c.relkind", "=", "p")])).where("ns.nspname", "!~", "^pg_").where("ns.nspname", "!=", "information_schema").where("a.attnum", ">=", 0).where("a.attisdropped", "!=", true).orderBy("ns.nspname").orderBy("c.relname").orderBy("a.attnum").$castTo();
    if (!options3.withInternalKyselyTables) {
      query = query.where("c.relname", "!=", DEFAULT_MIGRATION_TABLE).where("c.relname", "!=", DEFAULT_MIGRATION_LOCK_TABLE);
    }
    const rawColumns = await query.execute();
    return this.#parseTableMetadata(rawColumns);
  }
  async getMetadata(options3) {
    return {
      tables: await this.getTables(options3)
    };
  }
  #parseTableMetadata(columns) {
    return columns.reduce((tables2, it) => {
      let table = tables2.find((tbl) => tbl.name === it.table && tbl.schema === it.schema);
      if (!table) {
        table = freeze({
          name: it.table,
          isView: it.table_type === "v",
          schema: it.schema,
          columns: []
        });
        tables2.push(table);
      }
      table.columns.push(freeze({
        name: it.column,
        dataType: it.type,
        dataTypeSchema: it.type_schema,
        isNullable: !it.not_null,
        isAutoIncrementing: !!it.auto_incrementing,
        hasDefaultValue: it.has_default,
        comment: it.column_description ?? undefined
      }));
      return tables2;
    }, []);
  }
}
var init_postgres_introspector = __esm2(() => {
  init_migrator();
  init_object_utils();
  init_sql();
});
var LOCK_ID;
var PostgresAdapter;
var init_postgres_adapter = __esm2(() => {
  init_sql();
  LOCK_ID = BigInt("3853314791062309107");
  PostgresAdapter = class PostgresAdapter2 extends DialectAdapterBase {
    get supportsTransactionalDdl() {
      return true;
    }
    get supportsReturning() {
      return true;
    }
    async acquireMigrationLock(db2, _opt) {
      await sql`select pg_advisory_xact_lock(${sql.lit(LOCK_ID)})`.execute(db2);
    }
    async releaseMigrationLock(_db, _opt) {
    }
  };
});
function extendStackTrace(err22, stackError) {
  if (isStackHolder(err22) && stackError.stack) {
    const stackExtension = stackError.stack.split("\n").slice(1).join("\n");
    err22.stack += `\n${stackExtension}`;
    return err22;
  }
  return err22;
}
function isStackHolder(obj) {
  return isObject4(obj) && isString22(obj.stack);
}
var init_stack_trace_utils = __esm2(() => {
  init_object_utils();
});

class MysqlDriver {
  #config;
  #connections = new WeakMap;
  #pool;
  constructor(configOrPool) {
    this.#config = freeze({ ...configOrPool });
  }
  async init() {
    this.#pool = isFunction22(this.#config.pool) ? await this.#config.pool() : this.#config.pool;
  }
  async acquireConnection() {
    const rawConnection = await this.#acquireConnection();
    let connection = this.#connections.get(rawConnection);
    if (!connection) {
      connection = new MysqlConnection(rawConnection);
      this.#connections.set(rawConnection, connection);
      if (this.#config?.onCreateConnection) {
        await this.#config.onCreateConnection(connection);
      }
    }
    return connection;
  }
  async#acquireConnection() {
    return new Promise((resolve5, reject) => {
      this.#pool.getConnection(async (err22, rawConnection) => {
        if (err22) {
          reject(err22);
        } else {
          resolve5(rawConnection);
        }
      });
    });
  }
  async beginTransaction(connection, settings) {
    if (settings.isolationLevel) {
      await connection.executeQuery(CompiledQuery.raw(`set transaction isolation level ${settings.isolationLevel}`));
    }
    await connection.executeQuery(CompiledQuery.raw("begin"));
  }
  async commitTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("commit"));
  }
  async rollbackTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("rollback"));
  }
  async releaseConnection(connection) {
    connection[PRIVATE_RELEASE_METHOD]();
  }
  async destroy() {
    return new Promise((resolve5, reject) => {
      this.#pool.end((err22) => {
        if (err22) {
          reject(err22);
        } else {
          resolve5();
        }
      });
    });
  }
}
function isOkPacket(obj) {
  return isObject4(obj) && "insertId" in obj && "affectedRows" in obj;
}
var PRIVATE_RELEASE_METHOD;
var MysqlConnection;
var init_mysql_driver = __esm2(() => {
  init_compiled_query();
  init_object_utils();
  init_stack_trace_utils();
  PRIVATE_RELEASE_METHOD = Symbol();
  MysqlConnection = class MysqlConnection2 {
    #rawConnection;
    constructor(rawConnection) {
      this.#rawConnection = rawConnection;
    }
    async executeQuery(compiledQuery) {
      try {
        const result2 = await this.#executeQuery(compiledQuery);
        if (isOkPacket(result2)) {
          const { insertId, affectedRows, changedRows } = result2;
          const numAffectedRows = affectedRows !== undefined && affectedRows !== null ? BigInt(affectedRows) : undefined;
          const numChangedRows = changedRows !== undefined && changedRows !== null ? BigInt(changedRows) : undefined;
          return {
            insertId: insertId !== undefined && insertId !== null && insertId.toString() !== "0" ? BigInt(insertId) : undefined,
            numUpdatedOrDeletedRows: numAffectedRows,
            numAffectedRows,
            numChangedRows,
            rows: []
          };
        } else if (Array.isArray(result2)) {
          return {
            rows: result2
          };
        }
        return {
          rows: []
        };
      } catch (err22) {
        throw extendStackTrace(err22, new Error);
      }
    }
    #executeQuery(compiledQuery) {
      return new Promise((resolve5, reject) => {
        this.#rawConnection.query(compiledQuery.sql, compiledQuery.parameters, (err22, result2) => {
          if (err22) {
            reject(err22);
          } else {
            resolve5(result2);
          }
        });
      });
    }
    async* streamQuery(compiledQuery, _chunkSize) {
      const stream2 = this.#rawConnection.query(compiledQuery.sql, compiledQuery.parameters).stream({
        objectMode: true
      });
      try {
        for await (const row of stream2) {
          yield {
            rows: [row]
          };
        }
      } catch (ex) {
        if (ex && typeof ex === "object" && "code" in ex && ex.code === "ERR_STREAM_PREMATURE_CLOSE") {
          return;
        }
        throw ex;
      }
    }
    [PRIVATE_RELEASE_METHOD]() {
      this.#rawConnection.release();
    }
  };
});
var ID_WRAP_REGEX3;
var MysqlQueryCompiler;
var init_mysql_query_compiler = __esm2(() => {
  init_default_query_compiler();
  ID_WRAP_REGEX3 = /`/g;
  MysqlQueryCompiler = class MysqlQueryCompiler2 extends DefaultQueryCompiler {
    getCurrentParameterPlaceholder() {
      return "?";
    }
    getLeftExplainOptionsWrapper() {
      return "";
    }
    getExplainOptionAssignment() {
      return "=";
    }
    getExplainOptionsDelimiter() {
      return " ";
    }
    getRightExplainOptionsWrapper() {
      return "";
    }
    getLeftIdentifierWrapper() {
      return "`";
    }
    getRightIdentifierWrapper() {
      return "`";
    }
    sanitizeIdentifier(identifier) {
      return identifier.replace(ID_WRAP_REGEX3, "``");
    }
    visitCreateIndex(node) {
      this.append("create ");
      if (node.unique) {
        this.append("unique ");
      }
      this.append("index ");
      if (node.ifNotExists) {
        this.append("if not exists ");
      }
      this.visitNode(node.name);
      if (node.using) {
        this.append(" using ");
        this.visitNode(node.using);
      }
      if (node.table) {
        this.append(" on ");
        this.visitNode(node.table);
      }
      if (node.columns) {
        this.append(" (");
        this.compileList(node.columns);
        this.append(")");
      }
      if (node.where) {
        this.append(" ");
        this.visitNode(node.where);
      }
    }
  };
});

class MysqlIntrospector {
  #db;
  constructor(db2) {
    this.#db = db2;
  }
  async getSchemas() {
    let rawSchemas = await this.#db.selectFrom("information_schema.schemata").select("schema_name").$castTo().execute();
    return rawSchemas.map((it) => ({ name: it.SCHEMA_NAME }));
  }
  async getTables(options3 = { withInternalKyselyTables: false }) {
    let query = this.#db.selectFrom("information_schema.columns as columns").innerJoin("information_schema.tables as tables", (b22) => b22.onRef("columns.TABLE_CATALOG", "=", "tables.TABLE_CATALOG").onRef("columns.TABLE_SCHEMA", "=", "tables.TABLE_SCHEMA").onRef("columns.TABLE_NAME", "=", "tables.TABLE_NAME")).select([
      "columns.COLUMN_NAME",
      "columns.COLUMN_DEFAULT",
      "columns.TABLE_NAME",
      "columns.TABLE_SCHEMA",
      "tables.TABLE_TYPE",
      "columns.IS_NULLABLE",
      "columns.DATA_TYPE",
      "columns.EXTRA",
      "columns.COLUMN_COMMENT"
    ]).where("columns.TABLE_SCHEMA", "=", sql`database()`).orderBy("columns.TABLE_NAME").orderBy("columns.ORDINAL_POSITION").$castTo();
    if (!options3.withInternalKyselyTables) {
      query = query.where("columns.TABLE_NAME", "!=", DEFAULT_MIGRATION_TABLE).where("columns.TABLE_NAME", "!=", DEFAULT_MIGRATION_LOCK_TABLE);
    }
    const rawColumns = await query.execute();
    return this.#parseTableMetadata(rawColumns);
  }
  async getMetadata(options3) {
    return {
      tables: await this.getTables(options3)
    };
  }
  #parseTableMetadata(columns) {
    return columns.reduce((tables2, it) => {
      let table = tables2.find((tbl) => tbl.name === it.TABLE_NAME);
      if (!table) {
        table = freeze({
          name: it.TABLE_NAME,
          isView: it.TABLE_TYPE === "VIEW",
          schema: it.TABLE_SCHEMA,
          columns: []
        });
        tables2.push(table);
      }
      table.columns.push(freeze({
        name: it.COLUMN_NAME,
        dataType: it.DATA_TYPE,
        isNullable: it.IS_NULLABLE === "YES",
        isAutoIncrementing: it.EXTRA.toLowerCase().includes("auto_increment"),
        hasDefaultValue: it.COLUMN_DEFAULT !== null,
        comment: it.COLUMN_COMMENT === "" ? undefined : it.COLUMN_COMMENT
      }));
      return tables2;
    }, []);
  }
}
var init_mysql_introspector = __esm2(() => {
  init_migrator();
  init_object_utils();
  init_sql();
});
var LOCK_ID2 = "ea586330-2c93-47c8-908d-981d9d270f9d";
var LOCK_TIMEOUT_SECONDS;
var MysqlAdapter;
var init_mysql_adapter = __esm2(() => {
  init_sql();
  LOCK_TIMEOUT_SECONDS = 3600;
  MysqlAdapter = class MysqlAdapter2 extends DialectAdapterBase {
    get supportsTransactionalDdl() {
      return false;
    }
    get supportsReturning() {
      return false;
    }
    async acquireMigrationLock(db2, _opt) {
      await sql`select get_lock(${sql.lit(LOCK_ID2)}, ${sql.lit(LOCK_TIMEOUT_SECONDS)})`.execute(db2);
    }
    async releaseMigrationLock(db2, _opt) {
      await sql`select release_lock(${sql.lit(LOCK_ID2)})`.execute(db2);
    }
  };
});

class MysqlDialect {
  #config;
  constructor(config5) {
    this.#config = config5;
  }
  createDriver() {
    return new MysqlDriver(this.#config);
  }
  createQueryCompiler() {
    return new MysqlQueryCompiler;
  }
  createAdapter() {
    return new MysqlAdapter;
  }
  createIntrospector(db2) {
    return new MysqlIntrospector(db2);
  }
}
var init_mysql_dialect = __esm2(() => {
  init_mysql_driver();
  init_mysql_query_compiler();
  init_mysql_introspector();
  init_mysql_adapter();
});
var init_mysql_dialect_config = () => {
};

class PostgresDriver {
  #config;
  #connections = new WeakMap;
  #pool;
  constructor(config5) {
    this.#config = freeze({ ...config5 });
  }
  async init() {
    this.#pool = isFunction22(this.#config.pool) ? await this.#config.pool() : this.#config.pool;
  }
  async acquireConnection() {
    const client = await this.#pool.connect();
    let connection = this.#connections.get(client);
    if (!connection) {
      connection = new PostgresConnection(client, {
        cursor: this.#config.cursor ?? null
      });
      this.#connections.set(client, connection);
      if (this.#config.onCreateConnection) {
        await this.#config.onCreateConnection(connection);
      }
    }
    return connection;
  }
  async beginTransaction(connection, settings) {
    if (settings.isolationLevel) {
      await connection.executeQuery(CompiledQuery.raw(`start transaction isolation level ${settings.isolationLevel}`));
    } else {
      await connection.executeQuery(CompiledQuery.raw("begin"));
    }
  }
  async commitTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("commit"));
  }
  async rollbackTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("rollback"));
  }
  async releaseConnection(connection) {
    connection[PRIVATE_RELEASE_METHOD2]();
  }
  async destroy() {
    if (this.#pool) {
      const pool = this.#pool;
      this.#pool = undefined;
      await pool.end();
    }
  }
}
var PRIVATE_RELEASE_METHOD2;
var PostgresConnection;
var init_postgres_driver = __esm2(() => {
  init_compiled_query();
  init_object_utils();
  init_stack_trace_utils();
  PRIVATE_RELEASE_METHOD2 = Symbol();
  PostgresConnection = class PostgresConnection2 {
    #client;
    #options;
    constructor(client, options3) {
      this.#client = client;
      this.#options = options3;
    }
    async executeQuery(compiledQuery) {
      try {
        const result2 = await this.#client.query(compiledQuery.sql, [
          ...compiledQuery.parameters
        ]);
        if (result2.command === "INSERT" || result2.command === "UPDATE" || result2.command === "DELETE" || result2.command === "MERGE") {
          const numAffectedRows = BigInt(result2.rowCount);
          return {
            numUpdatedOrDeletedRows: numAffectedRows,
            numAffectedRows,
            rows: result2.rows ?? []
          };
        }
        return {
          rows: result2.rows ?? []
        };
      } catch (err22) {
        throw extendStackTrace(err22, new Error);
      }
    }
    async* streamQuery(compiledQuery, chunkSize) {
      if (!this.#options.cursor) {
        throw new Error("'cursor' is not present in your postgres dialect config. It's required to make streaming work in postgres.");
      }
      if (!Number.isInteger(chunkSize) || chunkSize <= 0) {
        throw new Error("chunkSize must be a positive integer");
      }
      const cursor22 = this.#client.query(new this.#options.cursor(compiledQuery.sql, compiledQuery.parameters.slice()));
      try {
        while (true) {
          const rows = await cursor22.read(chunkSize);
          if (rows.length === 0) {
            break;
          }
          yield {
            rows
          };
        }
      } finally {
        await cursor22.close();
      }
    }
    [PRIVATE_RELEASE_METHOD2]() {
      this.#client.release();
    }
  };
});
var init_postgres_dialect_config = () => {
};

class PostgresDialect {
  #config;
  constructor(config5) {
    this.#config = config5;
  }
  createDriver() {
    return new PostgresDriver(this.#config);
  }
  createQueryCompiler() {
    return new PostgresQueryCompiler;
  }
  createAdapter() {
    return new PostgresAdapter;
  }
  createIntrospector(db2) {
    return new PostgresIntrospector(db2);
  }
}
var init_postgres_dialect = __esm2(() => {
  init_postgres_driver();
  init_postgres_introspector();
  init_postgres_query_compiler();
  init_postgres_adapter();
});
var MssqlAdapter;
var init_mssql_adapter = __esm2(() => {
  init_migrator();
  init_sql();
  MssqlAdapter = class MssqlAdapter2 extends DialectAdapterBase {
    get supportsCreateIfNotExists() {
      return false;
    }
    get supportsTransactionalDdl() {
      return true;
    }
    get supportsOutput() {
      return true;
    }
    async acquireMigrationLock(db2) {
      await sql`exec sp_getapplock @DbPrincipal = ${sql.lit("dbo")}, @Resource = ${sql.lit(DEFAULT_MIGRATION_TABLE)}, @LockMode = ${sql.lit("Exclusive")}`.execute(db2);
    }
    async releaseMigrationLock() {
    }
  };
});
var init_mssql_dialect_config = () => {
};

class MssqlDriver {
  #config;
  #pool;
  constructor(config5) {
    this.#config = freeze({ ...config5 });
    this.#pool = new this.#config.tarn.Pool({
      ...this.#config.tarn.options,
      create: async () => {
        const connection = await this.#config.tedious.connectionFactory();
        return await new MssqlConnection(connection, this.#config.tedious).connect();
      },
      destroy: async (connection) => {
        await connection[PRIVATE_DESTROY_METHOD]();
      },
      validate: (connection) => connection.validate()
    });
  }
  async init() {
  }
  async acquireConnection() {
    return await this.#pool.acquire().promise;
  }
  async beginTransaction(connection, settings) {
    await connection.beginTransaction(settings);
  }
  async commitTransaction(connection) {
    await connection.commitTransaction();
  }
  async rollbackTransaction(connection) {
    await connection.rollbackTransaction();
  }
  async releaseConnection(connection) {
    await connection[PRIVATE_RELEASE_METHOD3]();
    this.#pool.release(connection);
  }
  async destroy() {
    await this.#pool.destroy();
  }
}

class MssqlRequest {
  #request;
  #rows;
  #streamChunkSize;
  #subscribers;
  #tedious;
  #error;
  #rowCount;
  constructor(props) {
    const { compiledQuery, onDone, streamChunkSize, tedious } = props;
    this.#rows = [];
    this.#streamChunkSize = streamChunkSize;
    this.#subscribers = {};
    this.#tedious = tedious;
    if (onDone) {
      const subscriptionKey = "onDone";
      this.#subscribers[subscriptionKey] = (event, error) => {
        if (event === "chunkReady") {
          return;
        }
        delete this.#subscribers[subscriptionKey];
        if (event === "error") {
          onDone.reject(error);
        } else {
          onDone.resolve({
            rowCount: this.#rowCount,
            rows: this.#rows
          });
        }
      };
    }
    this.#request = new this.#tedious.Request(compiledQuery.sql, (err22, rowCount) => {
      if (err22) {
        Object.values(this.#subscribers).forEach((subscriber) => subscriber("error", err22 instanceof AggregateError ? err22.errors : err22));
      } else {
        this.#rowCount = rowCount;
      }
    });
    this.#addParametersToRequest(compiledQuery.parameters);
    this.#attachListeners();
  }
  get request() {
    return this.#request;
  }
  readChunk() {
    const subscriptionKey = this.readChunk.name;
    return new Promise((resolve5, reject) => {
      this.#subscribers[subscriptionKey] = (event, error) => {
        delete this.#subscribers[subscriptionKey];
        if (event === "error") {
          reject(error);
        } else {
          resolve5(this.#rows.splice(0, this.#streamChunkSize));
        }
      };
      this.#request.resume();
    });
  }
  #addParametersToRequest(parameters) {
    for (let i2 = 0;i2 < parameters.length; i2++) {
      const parameter = parameters[i2];
      this.#request.addParameter(String(i2 + 1), this.#getTediousDataType(parameter), parameter);
    }
  }
  #attachListeners() {
    const pauseAndEmitChunkReady = this.#streamChunkSize ? () => {
      if (this.#streamChunkSize <= this.#rows.length) {
        this.#request.pause();
        Object.values(this.#subscribers).forEach((subscriber) => subscriber("chunkReady"));
      }
    } : () => {
    };
    const rowListener = (columns) => {
      const row = {};
      for (const column of columns) {
        row[column.metadata.colName] = column.value;
      }
      this.#rows.push(row);
      pauseAndEmitChunkReady();
    };
    this.#request.on("row", rowListener);
    this.#request.once("requestCompleted", () => {
      Object.values(this.#subscribers).forEach((subscriber) => subscriber("completed"));
      this.#request.off("row", rowListener);
    });
  }
  #getTediousDataType(value) {
    if (isNull(value) || isUndefined(value) || isString22(value)) {
      return this.#tedious.TYPES.NVarChar;
    }
    if (isBigInt(value) || isNumber(value) && value % 1 === 0) {
      if (value < -2147483648 || value > 2147483647) {
        return this.#tedious.TYPES.BigInt;
      } else {
        return this.#tedious.TYPES.Int;
      }
    }
    if (isNumber(value)) {
      return this.#tedious.TYPES.Float;
    }
    if (isBoolean(value)) {
      return this.#tedious.TYPES.Bit;
    }
    if (isDate(value)) {
      return this.#tedious.TYPES.DateTime;
    }
    if (isBuffer(value)) {
      return this.#tedious.TYPES.VarBinary;
    }
    return this.#tedious.TYPES.NVarChar;
  }
}
var PRIVATE_RELEASE_METHOD3;
var PRIVATE_DESTROY_METHOD;
var MssqlConnection;
var init_mssql_driver = __esm2(() => {
  init_object_utils();
  init_compiled_query();
  init_stack_trace_utils();
  init_random_string();
  PRIVATE_RELEASE_METHOD3 = Symbol();
  PRIVATE_DESTROY_METHOD = Symbol();
  MssqlConnection = class MssqlConnection2 {
    #connection;
    #tedious;
    constructor(connection, tedious) {
      this.#connection = connection;
      this.#tedious = tedious;
      this.#connection.on("error", console.error);
      this.#connection.once("end", () => {
        this.#connection.off("error", console.error);
      });
    }
    async beginTransaction(settings) {
      const { isolationLevel } = settings;
      await new Promise((resolve5, reject) => this.#connection.beginTransaction((error) => {
        if (error)
          reject(error);
        else
          resolve5(undefined);
      }, isolationLevel ? randomString(8) : undefined, isolationLevel ? this.#getTediousIsolationLevel(isolationLevel) : undefined));
    }
    async commitTransaction() {
      await new Promise((resolve5, reject) => this.#connection.commitTransaction((error) => {
        if (error)
          reject(error);
        else
          resolve5(undefined);
      }));
    }
    async connect() {
      await new Promise((resolve5, reject) => {
        this.#connection.connect((error) => {
          if (error) {
            console.error(error);
            reject(error);
          } else {
            resolve5(undefined);
          }
        });
      });
      return this;
    }
    async executeQuery(compiledQuery) {
      try {
        const deferred = new Deferred;
        const request3 = new MssqlRequest({
          compiledQuery,
          tedious: this.#tedious,
          onDone: deferred
        });
        this.#connection.execSql(request3.request);
        const { rowCount, rows } = await deferred.promise;
        return {
          numAffectedRows: rowCount !== undefined ? BigInt(rowCount) : undefined,
          rows
        };
      } catch (err22) {
        throw extendStackTrace(err22, new Error);
      }
    }
    async rollbackTransaction() {
      await new Promise((resolve5, reject) => this.#connection.rollbackTransaction((error) => {
        if (error)
          reject(error);
        else
          resolve5(undefined);
      }));
    }
    async* streamQuery(compiledQuery, chunkSize) {
      if (!Number.isInteger(chunkSize) || chunkSize <= 0) {
        throw new Error("chunkSize must be a positive integer");
      }
      const request3 = new MssqlRequest({
        compiledQuery,
        streamChunkSize: chunkSize,
        tedious: this.#tedious
      });
      this.#connection.execSql(request3.request);
      try {
        while (true) {
          const rows = await request3.readChunk();
          if (rows.length === 0) {
            break;
          }
          yield { rows };
          if (rows.length < chunkSize) {
            break;
          }
        }
      } finally {
        await this.#cancelRequest(request3);
      }
    }
    async validate() {
      try {
        const deferred = new Deferred;
        const request3 = new MssqlRequest({
          compiledQuery: CompiledQuery.raw("select 1"),
          onDone: deferred,
          tedious: this.#tedious
        });
        this.#connection.execSql(request3.request);
        await deferred.promise;
        return true;
      } catch {
        return false;
      }
    }
    #getTediousIsolationLevel(isolationLevel) {
      const { ISOLATION_LEVEL } = this.#tedious;
      const mapper = {
        "read committed": ISOLATION_LEVEL.READ_COMMITTED,
        "read uncommitted": ISOLATION_LEVEL.READ_UNCOMMITTED,
        "repeatable read": ISOLATION_LEVEL.REPEATABLE_READ,
        serializable: ISOLATION_LEVEL.SERIALIZABLE,
        snapshot: ISOLATION_LEVEL.SNAPSHOT
      };
      const tediousIsolationLevel = mapper[isolationLevel];
      if (tediousIsolationLevel === undefined) {
        throw new Error(`Unknown isolation level: ${isolationLevel}`);
      }
      return tediousIsolationLevel;
    }
    #cancelRequest(request3) {
      return new Promise((resolve5) => {
        request3.request.once("requestCompleted", resolve5);
        const wasCanceled = this.#connection.cancel();
        if (!wasCanceled) {
          request3.request.off("requestCompleted", resolve5);
          resolve5(undefined);
        }
      });
    }
    [PRIVATE_RELEASE_METHOD3]() {
      return new Promise((resolve5, reject) => {
        this.#connection.reset((error) => {
          if (error)
            reject(error);
          else
            resolve5(undefined);
        });
      });
    }
    [PRIVATE_DESTROY_METHOD]() {
      return new Promise((resolve5) => {
        this.#connection.once("end", () => {
          resolve5(undefined);
        });
        this.#connection.close();
      });
    }
  };
});

class MssqlIntrospector {
  #db;
  constructor(db2) {
    this.#db = db2;
  }
  async getSchemas() {
    return await this.#db.selectFrom("sys.schemas").select("name").execute();
  }
  async getTables(options3 = { withInternalKyselyTables: false }) {
    const rawColumns = await this.#db.selectFrom("sys.tables as tables").leftJoin("sys.schemas as table_schemas", "table_schemas.schema_id", "tables.schema_id").innerJoin("sys.columns as columns", "columns.object_id", "tables.object_id").innerJoin("sys.types as types", "types.user_type_id", "columns.user_type_id").leftJoin("sys.schemas as type_schemas", "type_schemas.schema_id", "types.schema_id").leftJoin("sys.extended_properties as comments", (join23) => join23.onRef("comments.major_id", "=", "tables.object_id").onRef("comments.minor_id", "=", "columns.column_id").on("comments.name", "=", "MS_Description")).$if(!options3.withInternalKyselyTables, (qb) => qb.where("tables.name", "!=", DEFAULT_MIGRATION_TABLE).where("tables.name", "!=", DEFAULT_MIGRATION_LOCK_TABLE)).select([
      "tables.name as table_name",
      (eb) => eb.ref("tables.type").$castTo().as("table_type"),
      "table_schemas.name as table_schema_name",
      "columns.default_object_id as column_default_object_id",
      "columns.generated_always_type_desc as column_generated_always_type",
      "columns.is_computed as column_is_computed",
      "columns.is_identity as column_is_identity",
      "columns.is_nullable as column_is_nullable",
      "columns.is_rowguidcol as column_is_rowguidcol",
      "columns.name as column_name",
      "types.is_nullable as type_is_nullable",
      "types.name as type_name",
      "type_schemas.name as type_schema_name",
      "comments.value as column_comment"
    ]).unionAll(this.#db.selectFrom("sys.views as views").leftJoin("sys.schemas as view_schemas", "view_schemas.schema_id", "views.schema_id").innerJoin("sys.columns as columns", "columns.object_id", "views.object_id").innerJoin("sys.types as types", "types.user_type_id", "columns.user_type_id").leftJoin("sys.schemas as type_schemas", "type_schemas.schema_id", "types.schema_id").leftJoin("sys.extended_properties as comments", (join23) => join23.onRef("comments.major_id", "=", "views.object_id").onRef("comments.minor_id", "=", "columns.column_id").on("comments.name", "=", "MS_Description")).select([
      "views.name as table_name",
      "views.type as table_type",
      "view_schemas.name as table_schema_name",
      "columns.default_object_id as column_default_object_id",
      "columns.generated_always_type_desc as column_generated_always_type",
      "columns.is_computed as column_is_computed",
      "columns.is_identity as column_is_identity",
      "columns.is_nullable as column_is_nullable",
      "columns.is_rowguidcol as column_is_rowguidcol",
      "columns.name as column_name",
      "types.is_nullable as type_is_nullable",
      "types.name as type_name",
      "type_schemas.name as type_schema_name",
      "comments.value as column_comment"
    ])).orderBy("table_schema_name").orderBy("table_name").orderBy("column_name").execute();
    const tableDictionary = {};
    for (const rawColumn of rawColumns) {
      const key = `${rawColumn.table_schema_name}.${rawColumn.table_name}`;
      const table = tableDictionary[key] = tableDictionary[key] || freeze({
        columns: [],
        isView: rawColumn.table_type === "V ",
        name: rawColumn.table_name,
        schema: rawColumn.table_schema_name ?? undefined
      });
      table.columns.push(freeze({
        dataType: rawColumn.type_name,
        dataTypeSchema: rawColumn.type_schema_name ?? undefined,
        hasDefaultValue: rawColumn.column_default_object_id > 0 || rawColumn.column_generated_always_type !== "NOT_APPLICABLE" || rawColumn.column_is_identity || rawColumn.column_is_computed || rawColumn.column_is_rowguidcol,
        isAutoIncrementing: rawColumn.column_is_identity,
        isNullable: rawColumn.column_is_nullable && rawColumn.type_is_nullable,
        name: rawColumn.column_name,
        comment: rawColumn.column_comment ?? undefined
      }));
    }
    return Object.values(tableDictionary);
  }
  async getMetadata(options3) {
    return {
      tables: await this.getTables(options3)
    };
  }
}
var init_mssql_introspector = __esm2(() => {
  init_migrator();
  init_object_utils();
});
var MssqlQueryCompiler;
var init_mssql_query_compiler = __esm2(() => {
  init_default_query_compiler();
  MssqlQueryCompiler = class MssqlQueryCompiler2 extends DefaultQueryCompiler {
    getCurrentParameterPlaceholder() {
      return `@${this.numParameters}`;
    }
    visitOffset(node) {
      super.visitOffset(node);
      this.append(" rows");
    }
    compileColumnAlterations(columnAlterations) {
      const nodesByKind = {};
      for (const columnAlteration of columnAlterations) {
        if (!nodesByKind[columnAlteration.kind]) {
          nodesByKind[columnAlteration.kind] = [];
        }
        nodesByKind[columnAlteration.kind].push(columnAlteration);
      }
      let first = true;
      if (nodesByKind.AddColumnNode) {
        this.append("add ");
        this.compileList(nodesByKind.AddColumnNode);
        first = false;
      }
      if (nodesByKind.AlterColumnNode) {
        if (!first)
          this.append(", ");
        this.compileList(nodesByKind.AlterColumnNode);
      }
      if (nodesByKind.DropColumnNode) {
        if (!first)
          this.append(", ");
        this.append("drop column ");
        this.compileList(nodesByKind.DropColumnNode);
      }
      if (nodesByKind.ModifyColumnNode) {
        if (!first)
          this.append(", ");
        this.compileList(nodesByKind.ModifyColumnNode);
      }
      if (nodesByKind.RenameColumnNode) {
        if (!first)
          this.append(", ");
        this.compileList(nodesByKind.RenameColumnNode);
      }
    }
    visitAddColumn(node) {
      this.visitNode(node.column);
    }
    visitDropColumn(node) {
      this.visitNode(node.column);
    }
    visitMergeQuery(node) {
      super.visitMergeQuery(node);
      this.append(";");
    }
    announcesNewColumnDataType() {
      return false;
    }
  };
});

class MssqlDialect {
  #config;
  constructor(config5) {
    this.#config = config5;
  }
  createDriver() {
    return new MssqlDriver(this.#config);
  }
  createQueryCompiler() {
    return new MssqlQueryCompiler;
  }
  createAdapter() {
    return new MssqlAdapter;
  }
  createIntrospector(db2) {
    return new MssqlIntrospector(db2);
  }
}
var init_mssql_dialect = __esm2(() => {
  init_mssql_adapter();
  init_mssql_driver();
  init_mssql_introspector();
  init_mssql_query_compiler();
});
var init_query_compiler = () => {
};

class FileMigrationProvider {
  #props;
  constructor(props) {
    this.#props = props;
  }
  async getMigrations() {
    const migrations = {};
    const files = await this.#props.fs.readdir(this.#props.migrationFolder);
    for (const fileName of files) {
      if (fileName.endsWith(".js") || fileName.endsWith(".ts") && !fileName.endsWith(".d.ts") || fileName.endsWith(".mjs") || fileName.endsWith(".mts") && !fileName.endsWith(".d.mts")) {
        const migration = await import(this.#props.path.join(this.#props.migrationFolder, fileName));
        const migrationKey = fileName.substring(0, fileName.lastIndexOf("."));
        if (isMigration(migration?.default)) {
          migrations[migrationKey] = migration.default;
        } else if (isMigration(migration)) {
          migrations[migrationKey] = migration;
        }
      }
    }
    return migrations;
  }
}
function isMigration(obj) {
  return isObject4(obj) && isFunction22(obj.up);
}
var init_file_migration_provider = __esm2(() => {
  init_object_utils();
});
var init_kysely_plugin = () => {
};
var SnakeCaseTransformer;
var init_camel_case_transformer = __esm2(() => {
  init_operation_node_transformer();
  SnakeCaseTransformer = class SnakeCaseTransformer2 extends OperationNodeTransformer {
    #snakeCase;
    constructor(snakeCase2) {
      super();
      this.#snakeCase = snakeCase2;
    }
    transformIdentifier(node) {
      node = super.transformIdentifier(node);
      return {
        ...node,
        name: this.#snakeCase(node.name)
      };
    }
  };
});
function createSnakeCaseMapper({ upperCase = false, underscoreBeforeDigits = false, underscoreBetweenUppercaseLetters = false } = {}) {
  return memoize((str) => {
    if (str.length === 0) {
      return str;
    }
    const upper = str.toUpperCase();
    const lower = str.toLowerCase();
    let out = lower[0];
    for (let i2 = 1, l22 = str.length;i2 < l22; ++i2) {
      const char = str[i2];
      const prevChar = str[i2 - 1];
      const upperChar = upper[i2];
      const prevUpperChar = upper[i2 - 1];
      const lowerChar = lower[i2];
      const prevLowerChar = lower[i2 - 1];
      if (underscoreBeforeDigits && isDigit(char) && !isDigit(prevChar)) {
        out += "_" + char;
        continue;
      }
      if (char === upperChar && upperChar !== lowerChar) {
        const prevCharacterIsUppercase = prevChar === prevUpperChar && prevUpperChar !== prevLowerChar;
        if (underscoreBetweenUppercaseLetters || !prevCharacterIsUppercase) {
          out += "_" + lowerChar;
        } else {
          out += lowerChar;
        }
      } else {
        out += char;
      }
    }
    if (upperCase) {
      return out.toUpperCase();
    } else {
      return out;
    }
  });
}
function createCamelCaseMapper({ upperCase = false } = {}) {
  return memoize((str) => {
    if (str.length === 0) {
      return str;
    }
    if (upperCase && isAllUpperCaseSnakeCase(str)) {
      str = str.toLowerCase();
    }
    let out = str[0];
    for (let i2 = 1, l22 = str.length;i2 < l22; ++i2) {
      const char = str[i2];
      const prevChar = str[i2 - 1];
      if (char !== "_") {
        if (prevChar === "_") {
          out += char.toUpperCase();
        } else {
          out += char;
        }
      }
    }
    return out;
  });
}
function isAllUpperCaseSnakeCase(str) {
  for (let i2 = 1, l22 = str.length;i2 < l22; ++i2) {
    const char = str[i2];
    if (char !== "_" && char !== char.toUpperCase()) {
      return false;
    }
  }
  return true;
}
function isDigit(char) {
  return char >= "0" && char <= "9";
}
function memoize(func) {
  const cache3 = new Map;
  return (str) => {
    let mapped = cache3.get(str);
    if (!mapped) {
      mapped = func(str);
      cache3.set(str, mapped);
    }
    return mapped;
  };
}

class CamelCasePlugin {
  opt;
  #camelCase;
  #snakeCase;
  #snakeCaseTransformer;
  constructor(opt = {}) {
    this.opt = opt;
    this.#camelCase = createCamelCaseMapper(opt);
    this.#snakeCase = createSnakeCaseMapper(opt);
    this.#snakeCaseTransformer = new SnakeCaseTransformer(this.snakeCase.bind(this));
  }
  transformQuery(args) {
    return this.#snakeCaseTransformer.transformNode(args.node);
  }
  async transformResult(args) {
    if (args.result.rows && Array.isArray(args.result.rows)) {
      return {
        ...args.result,
        rows: args.result.rows.map((row) => this.mapRow(row))
      };
    }
    return args.result;
  }
  mapRow(row) {
    return Object.keys(row).reduce((obj, key) => {
      let value = row[key];
      if (Array.isArray(value)) {
        value = value.map((it) => canMap(it, this.opt) ? this.mapRow(it) : it);
      } else if (canMap(value, this.opt)) {
        value = this.mapRow(value);
      }
      obj[this.camelCase(key)] = value;
      return obj;
    }, {});
  }
  snakeCase(str) {
    return this.#snakeCase(str);
  }
  camelCase(str) {
    return this.#camelCase(str);
  }
}
function canMap(obj, opt) {
  return isPlainObject22(obj) && !opt?.maintainNestedObjectKeys;
}
var init_camel_case_plugin = __esm2(() => {
  init_object_utils();
  init_camel_case_transformer();
});
var DeduplicateJoinsTransformer;
var init_deduplicate_joins_transformer = __esm2(() => {
  init_operation_node_transformer();
  init_object_utils();
  DeduplicateJoinsTransformer = class DeduplicateJoinsTransformer2 extends OperationNodeTransformer {
    transformSelectQuery(node) {
      return this.#transformQuery(super.transformSelectQuery(node));
    }
    transformUpdateQuery(node) {
      return this.#transformQuery(super.transformUpdateQuery(node));
    }
    transformDeleteQuery(node) {
      return this.#transformQuery(super.transformDeleteQuery(node));
    }
    #transformQuery(node) {
      if (!node.joins || node.joins.length === 0) {
        return node;
      }
      return freeze({
        ...node,
        joins: this.#deduplicateJoins(node.joins)
      });
    }
    #deduplicateJoins(joins) {
      const out = [];
      for (let i2 = 0;i2 < joins.length; ++i2) {
        let foundDuplicate = false;
        for (let j22 = i2 + 1;j22 < joins.length; ++j22) {
          if (compare(joins[i2], joins[j22])) {
            foundDuplicate = true;
            break;
          }
        }
        if (!foundDuplicate) {
          out.push(joins[i2]);
        }
      }
      return freeze(out);
    }
  };
});

class DeduplicateJoinsPlugin {
  #transformer = new DeduplicateJoinsTransformer;
  transformQuery(args) {
    return this.#transformer.transformNode(args.node);
  }
  transformResult(args) {
    return Promise.resolve(args.result);
  }
}
var init_deduplicate_joins_plugin = __esm2(() => {
  init_deduplicate_joins_transformer();
});

class ParseJSONResultsPlugin {
  opt;
  #objectStrategy;
  constructor(opt = {}) {
    this.opt = opt;
    this.#objectStrategy = opt.objectStrategy || "in-place";
  }
  transformQuery(args) {
    return args.node;
  }
  async transformResult(args) {
    return {
      ...args.result,
      rows: parseArray(args.result.rows, this.#objectStrategy)
    };
  }
}
function parseArray(arr, objectStrategy) {
  const target = objectStrategy === "create" ? new Array(arr.length) : arr;
  for (let i2 = 0;i2 < arr.length; ++i2) {
    target[i2] = parse7(arr[i2], objectStrategy);
  }
  return target;
}
function parse7(obj, objectStrategy) {
  if (isString22(obj)) {
    return parseString(obj);
  }
  if (Array.isArray(obj)) {
    return parseArray(obj, objectStrategy);
  }
  if (isPlainObject22(obj)) {
    return parseObject(obj, objectStrategy);
  }
  return obj;
}
function parseString(str) {
  if (maybeJson(str)) {
    try {
      return parse7(JSON.parse(str), "in-place");
    } catch (err22) {
    }
  }
  return str;
}
function maybeJson(value) {
  return value.match(/^[\[\{]/) != null;
}
function parseObject(obj, objectStrategy) {
  const target = objectStrategy === "create" ? {} : obj;
  for (const key in obj) {
    target[key] = parse7(obj[key], objectStrategy);
  }
  return target;
}
var init_parse_json_results_plugin = __esm2(() => {
  init_object_utils();
});
var init_constraint_node = () => {
};
var ListNode;
var init_list_node = __esm2(() => {
  init_object_utils();
  ListNode = freeze({
    is(node) {
      return node.kind === "ListNode";
    },
    create(items) {
      return freeze({
        kind: "ListNode",
        items: freeze(items)
      });
    }
  });
});
var init_operation_node = () => {
};
var init_simple_reference_expression_node = () => {
};
var init_column_type = () => {
};
var init_explainable = () => {
};
var init_streamable = () => {
};
var init_infer_result = () => {
};
var init_esm2 = __esm2(() => {
  init_kysely();
  init_query_creator();
  init_expression();
  init_expression_builder();
  init_expression_wrapper();
  init_where_interface();
  init_returning_interface();
  init_output_interface();
  init_having_interface();
  init_select_query_builder();
  init_insert_query_builder();
  init_update_query_builder();
  init_delete_query_builder();
  init_no_result_error();
  init_join_builder();
  init_function_module();
  init_on_conflict_builder();
  init_aggregate_function_builder();
  init_case_builder();
  init_json_path_builder();
  init_merge_query_builder();
  init_raw_builder();
  init_sql();
  init_query_executor();
  init_default_query_executor();
  init_noop_query_executor();
  init_query_executor_provider();
  init_default_query_compiler();
  init_compiled_query();
  init_schema2();
  init_create_table_builder();
  init_create_type_builder();
  init_drop_table_builder();
  init_drop_type_builder();
  init_create_index_builder();
  init_drop_index_builder();
  init_create_schema_builder();
  init_drop_schema_builder();
  init_column_definition_builder();
  init_foreign_key_constraint_builder();
  init_alter_table_builder();
  init_create_view_builder();
  init_drop_view_builder();
  init_alter_column_builder();
  init_dynamic();
  init_driver();
  init_database_connection();
  init_connection_provider();
  init_dialect();
  init_dialect_adapter();
  init_database_introspector();
  init_sqlite_dialect();
  init_sqlite_dialect_config();
  init_sqlite_driver();
  init_postgres_query_compiler();
  init_postgres_introspector();
  init_postgres_adapter();
  init_mysql_dialect();
  init_mysql_dialect_config();
  init_mysql_driver();
  init_mysql_query_compiler();
  init_mysql_introspector();
  init_mysql_adapter();
  init_postgres_driver();
  init_postgres_dialect_config();
  init_postgres_dialect();
  init_sqlite_query_compiler();
  init_sqlite_introspector();
  init_sqlite_adapter();
  init_mssql_adapter();
  init_mssql_dialect_config();
  init_mssql_dialect();
  init_mssql_driver();
  init_mssql_introspector();
  init_mssql_query_compiler();
  init_default_query_compiler();
  init_query_compiler();
  init_migrator();
  init_file_migration_provider();
  init_kysely_plugin();
  init_camel_case_plugin();
  init_deduplicate_joins_plugin();
  init_with_schema_plugin();
  init_parse_json_results_plugin();
  init_add_column_node();
  init_add_constraint_node();
  init_add_index_node();
  init_aggregate_function_node();
  init_alias_node();
  init_alter_column_node();
  init_alter_table_node();
  init_and_node();
  init_binary_operation_node();
  init_case_node();
  init_cast_node();
  init_check_constraint_node();
  init_column_definition_node();
  init_column_node();
  init_column_update_node();
  init_common_table_expression_name_node();
  init_common_table_expression_node();
  init_constraint_node();
  init_create_index_node();
  init_create_schema_node();
  init_create_table_node();
  init_create_type_node();
  init_create_view_node();
  init_data_type_node();
  init_default_insert_value_node();
  init_default_value_node();
  init_delete_query_node();
  init_drop_column_node();
  init_drop_constraint_node();
  init_drop_index_node();
  init_drop_schema_node();
  init_drop_table_node();
  init_drop_type_node();
  init_drop_view_node();
  init_explain_node();
  init_fetch_node();
  init_foreign_key_constraint_node();
  init_from_node();
  init_function_node();
  init_generated_node();
  init_group_by_item_node();
  init_group_by_node();
  init_having_node();
  init_identifier_node();
  init_insert_query_node();
  init_join_node();
  init_json_operator_chain_node();
  init_json_path_leg_node();
  init_json_path_node();
  init_json_reference_node();
  init_limit_node();
  init_list_node();
  init_matched_node();
  init_merge_query_node();
  init_modify_column_node();
  init_offset_node();
  init_on_conflict_node();
  init_on_duplicate_key_node();
  init_on_node();
  init_operation_node_source();
  init_operation_node_transformer();
  init_operation_node_visitor();
  init_operation_node();
  init_operator_node();
  init_or_node();
  init_order_by_item_node();
  init_order_by_node();
  init_output_node();
  init_over_node();
  init_parens_node();
  init_partition_by_item_node();
  init_partition_by_node();
  init_primary_constraint_node();
  init_primitive_value_list_node();
  init_query_node();
  init_raw_node();
  init_reference_node();
  init_references_node();
  init_rename_column_node();
  init_returning_node();
  init_schemable_identifier_node();
  init_select_all_node();
  init_select_modifier_node();
  init_select_query_node();
  init_selection_node();
  init_set_operation_node();
  init_simple_reference_expression_node();
  init_table_node();
  init_top_node();
  init_tuple_node();
  init_unary_operation_node();
  init_unique_constraint_node();
  init_update_query_node();
  init_using_node();
  init_value_list_node();
  init_value_node();
  init_values_node();
  init_when_node();
  init_where_node();
  init_with_node();
  init_column_type();
  init_compilable();
  init_explainable();
  init_streamable();
  init_log();
  init_infer_result();
  init_log_once();
});
var BunWorkerDriver = class {
  config;
  worker;
  connection;
  connectionMutex = new ConnectionMutex2;
  mitt;
  constructor(config5) {
    this.config = config5;
  }
  async init() {
    this.worker = this.config?.worker ?? new Worker(new URL("./worker", import.meta.url), { type: "module" });
    this.mitt = new EventEmitter2;
    this.worker.onmessage = ({ data: [type, data2, err22] }) => {
      this.mitt?.emit(type, data2, err22);
    };
    this.worker.postMessage([
      0,
      this.config?.url,
      this.config?.cacheStatment
    ]);
    await new Promise((resolve5, reject) => {
      this.mitt?.once(0, (_22, err22) => err22 ? reject(err22) : resolve5());
    });
    this.connection = new BunWorkerConnection(this.worker, this.mitt);
    await this.config?.onCreateConnection?.(this.connection);
  }
  async acquireConnection() {
    await this.connectionMutex.lock();
    return this.connection;
  }
  async beginTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("begin"));
  }
  async commitTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("commit"));
  }
  async rollbackTransaction(connection) {
    await connection.executeQuery(CompiledQuery.raw("rollback"));
  }
  async releaseConnection() {
    this.connectionMutex.unlock();
  }
  async destroy() {
    if (!this.worker) {
      return;
    }
    this.worker.postMessage([2]);
    return new Promise((resolve5, reject) => {
      this.mitt?.once(2, (_22, err22) => {
        if (err22) {
          reject(err22);
        } else {
          this.worker?.terminate();
          this.mitt?.removeAllListeners();
          this.mitt = undefined;
          resolve5();
        }
      });
    });
  }
};
var ConnectionMutex2 = class {
  promise;
  resolve;
  async lock() {
    while (this.promise) {
      await this.promise;
    }
    this.promise = new Promise((resolve5) => {
      this.resolve = resolve5;
    });
  }
  unlock() {
    const resolve5 = this.resolve;
    this.promise = undefined;
    this.resolve = undefined;
    resolve5?.();
  }
};
var BunWorkerConnection = class {
  constructor(worker, mitt) {
    this.worker = worker;
    this.mitt = mitt;
  }
  streamQuery() {
    throw new Error("Bun:sqlite-worker driver doesn't support streaming");
  }
  async executeQuery(compiledQuery) {
    const { parameters, sql: sql3, query } = compiledQuery;
    const isSelect = SelectQueryNode.is(query);
    this.worker.postMessage([1, isSelect, sql3, parameters]);
    return new Promise((resolve5, reject) => {
      if (!this.mitt) {
        reject(new Error("kysely instance has been destroyed"));
      }
      this.mitt.once(1, (data2, err22) => !err22 && data2 ? resolve5(data2) : reject(err22));
    });
  }
};
var BunWorkerDialect = class {
  config;
  constructor(config5) {
    this.config = config5;
  }
  createDriver() {
    return new BunWorkerDriver(this.config);
  }
  createQueryCompiler() {
    return new SqliteQueryCompiler;
  }
  createAdapter() {
    return new SqliteAdapter;
  }
  createIntrospector(db2) {
    return new SqliteIntrospector(db2);
  }
};
var init_dist4 = __esm2(() => {
  init_esm2();
});
var require_SqlString = __commonJS2((exports) => {
  var SqlString = exports;
  var ID_GLOBAL_REGEXP = /`/g;
  var QUAL_GLOBAL_REGEXP = /\./g;
  var CHARS_GLOBAL_REGEXP = /[\0\b\t\n\r\x1a\"\'\\]/g;
  var CHARS_ESCAPE_MAP = {
    "\0": "\\0",
    "\b": "\\b",
    "\t": "\\t",
    "\n": "\\n",
    "\r": "\\r",
    "\x1A": "\\Z",
    '"': '\\"',
    "\'": "\\\'",
    "\\": "\\\\"
  };
  SqlString.escapeId = function escapeId(val2, forbidQualified) {
    if (Array.isArray(val2)) {
      var sql3 = "";
      for (var i2 = 0;i2 < val2.length; i2++) {
        sql3 += (i2 === 0 ? "" : ", ") + SqlString.escapeId(val2[i2], forbidQualified);
      }
      return sql3;
    } else if (forbidQualified) {
      return "`" + String(val2).replace(ID_GLOBAL_REGEXP, "``") + "`";
    } else {
      return "`" + String(val2).replace(ID_GLOBAL_REGEXP, "``").replace(QUAL_GLOBAL_REGEXP, "`.`") + "`";
    }
  };
  SqlString.escape = function escape(val2, stringifyObjects, timeZone) {
    if (val2 === undefined || val2 === null) {
      return "NULL";
    }
    switch (typeof val2) {
      case "boolean":
        return val2 ? "true" : "false";
      case "number":
        return val2 + "";
      case "object":
        if (Object.prototype.toString.call(val2) === "[object Date]") {
          return SqlString.dateToString(val2, timeZone || "local");
        } else if (Array.isArray(val2)) {
          return SqlString.arrayToList(val2, timeZone);
        } else if (Buffer.isBuffer(val2)) {
          return SqlString.bufferToString(val2);
        } else if (typeof val2.toSqlString === "function") {
          return String(val2.toSqlString());
        } else if (stringifyObjects) {
          return escapeString(val2.toString());
        } else {
          return SqlString.objectToValues(val2, timeZone);
        }
      default:
        return escapeString(val2);
    }
  };
  SqlString.arrayToList = function arrayToList(array, timeZone) {
    var sql3 = "";
    for (var i2 = 0;i2 < array.length; i2++) {
      var val2 = array[i2];
      if (Array.isArray(val2)) {
        sql3 += (i2 === 0 ? "" : ", ") + "(" + SqlString.arrayToList(val2, timeZone) + ")";
      } else {
        sql3 += (i2 === 0 ? "" : ", ") + SqlString.escape(val2, true, timeZone);
      }
    }
    return sql3;
  };
  SqlString.format = function format(sql3, values3, stringifyObjects, timeZone) {
    if (values3 == null) {
      return sql3;
    }
    if (!Array.isArray(values3)) {
      values3 = [values3];
    }
    var chunkIndex = 0;
    var placeholdersRegex = /\?+/g;
    var result2 = "";
    var valuesIndex = 0;
    var match;
    while (valuesIndex < values3.length && (match = placeholdersRegex.exec(sql3))) {
      var len = match[0].length;
      if (len > 2) {
        continue;
      }
      var value = len === 2 ? SqlString.escapeId(values3[valuesIndex]) : SqlString.escape(values3[valuesIndex], stringifyObjects, timeZone);
      result2 += sql3.slice(chunkIndex, match.index) + value;
      chunkIndex = placeholdersRegex.lastIndex;
      valuesIndex++;
    }
    if (chunkIndex === 0) {
      return sql3;
    }
    if (chunkIndex < sql3.length) {
      return result2 + sql3.slice(chunkIndex);
    }
    return result2;
  };
  SqlString.dateToString = function dateToString(date, timeZone) {
    var dt2 = new Date(date);
    if (isNaN(dt2.getTime())) {
      return "NULL";
    }
    var year;
    var month;
    var day;
    var hour;
    var minute;
    var second;
    var millisecond;
    if (timeZone === "local") {
      year = dt2.getFullYear();
      month = dt2.getMonth() + 1;
      day = dt2.getDate();
      hour = dt2.getHours();
      minute = dt2.getMinutes();
      second = dt2.getSeconds();
      millisecond = dt2.getMilliseconds();
    } else {
      var tz = convertTimezone(timeZone);
      if (tz !== false && tz !== 0) {
        dt2.setTime(dt2.getTime() + tz * 60000);
      }
      year = dt2.getUTCFullYear();
      month = dt2.getUTCMonth() + 1;
      day = dt2.getUTCDate();
      hour = dt2.getUTCHours();
      minute = dt2.getUTCMinutes();
      second = dt2.getUTCSeconds();
      millisecond = dt2.getUTCMilliseconds();
    }
    var str = zeroPad(year, 4) + "-" + zeroPad(month, 2) + "-" + zeroPad(day, 2) + " " + zeroPad(hour, 2) + ":" + zeroPad(minute, 2) + ":" + zeroPad(second, 2) + "." + zeroPad(millisecond, 3);
    return escapeString(str);
  };
  SqlString.bufferToString = function bufferToString(buffer) {
    return "X" + escapeString(buffer.toString("hex"));
  };
  SqlString.objectToValues = function objectToValues(object, timeZone) {
    var sql3 = "";
    for (var key in object) {
      var val2 = object[key];
      if (typeof val2 === "function") {
        continue;
      }
      sql3 += (sql3.length === 0 ? "" : ", ") + SqlString.escapeId(key) + " = " + SqlString.escape(val2, true, timeZone);
    }
    return sql3;
  };
  SqlString.raw = function raw(sql3) {
    if (typeof sql3 !== "string") {
      throw new TypeError("argument sql must be a string");
    }
    return {
      toSqlString: function toSqlString() {
        return sql3;
      }
    };
  };
  function escapeString(val2) {
    var chunkIndex = CHARS_GLOBAL_REGEXP.lastIndex = 0;
    var escapedVal = "";
    var match;
    while (match = CHARS_GLOBAL_REGEXP.exec(val2)) {
      escapedVal += val2.slice(chunkIndex, match.index) + CHARS_ESCAPE_MAP[match[0]];
      chunkIndex = CHARS_GLOBAL_REGEXP.lastIndex;
    }
    if (chunkIndex === 0) {
      return "'" + val2 + "'";
    }
    if (chunkIndex < val2.length) {
      return "'" + escapedVal + val2.slice(chunkIndex) + "'";
    }
    return "'" + escapedVal + "'";
  }
  function zeroPad(number, length) {
    number = number.toString();
    while (number.length < length) {
      number = "0" + number;
    }
    return number;
  }
  function convertTimezone(tz) {
    if (tz === "Z") {
      return 0;
    }
    var m22 = tz.match(/([\+\-\s])(\d\d):?(\d\d)?/);
    if (m22) {
      return (m22[1] === "-" ? -1 : 1) * (parseInt(m22[2], 10) + (m22[3] ? parseInt(m22[3], 10) : 0) / 60) * 60;
    }
    return false;
  }
});
var require_denque = __commonJS2((exports, module) => {
  function Denque(array, options3) {
    var options3 = options3 || {};
    this._capacity = options3.capacity;
    this._head = 0;
    this._tail = 0;
    if (Array.isArray(array)) {
      this._fromArray(array);
    } else {
      this._capacityMask = 3;
      this._list = new Array(4);
    }
  }
  Denque.prototype.peekAt = function peekAt(index) {
    var i2 = index;
    if (i2 !== (i2 | 0)) {
      return;
    }
    var len = this.size();
    if (i2 >= len || i2 < -len)
      return;
    if (i2 < 0)
      i2 += len;
    i2 = this._head + i2 & this._capacityMask;
    return this._list[i2];
  };
  Denque.prototype.get = function get(i2) {
    return this.peekAt(i2);
  };
  Denque.prototype.peek = function peek() {
    if (this._head === this._tail)
      return;
    return this._list[this._head];
  };
  Denque.prototype.peekFront = function peekFront() {
    return this.peek();
  };
  Denque.prototype.peekBack = function peekBack() {
    return this.peekAt(-1);
  };
  Object.defineProperty(Denque.prototype, "length", {
    get: function length() {
      return this.size();
    }
  });
  Denque.prototype.size = function size() {
    if (this._head === this._tail)
      return 0;
    if (this._head < this._tail)
      return this._tail - this._head;
    else
      return this._capacityMask + 1 - (this._head - this._tail);
  };
  Denque.prototype.unshift = function unshift(item) {
    if (arguments.length === 0)
      return this.size();
    var len = this._list.length;
    this._head = this._head - 1 + len & this._capacityMask;
    this._list[this._head] = item;
    if (this._tail === this._head)
      this._growArray();
    if (this._capacity && this.size() > this._capacity)
      this.pop();
    if (this._head < this._tail)
      return this._tail - this._head;
    else
      return this._capacityMask + 1 - (this._head - this._tail);
  };
  Denque.prototype.shift = function shift() {
    var head2 = this._head;
    if (head2 === this._tail)
      return;
    var item = this._list[head2];
    this._list[head2] = undefined;
    this._head = head2 + 1 & this._capacityMask;
    if (head2 < 2 && this._tail > 1e4 && this._tail <= this._list.length >>> 2)
      this._shrinkArray();
    return item;
  };
  Denque.prototype.push = function push(item) {
    if (arguments.length === 0)
      return this.size();
    var tail = this._tail;
    this._list[tail] = item;
    this._tail = tail + 1 & this._capacityMask;
    if (this._tail === this._head) {
      this._growArray();
    }
    if (this._capacity && this.size() > this._capacity) {
      this.shift();
    }
    if (this._head < this._tail)
      return this._tail - this._head;
    else
      return this._capacityMask + 1 - (this._head - this._tail);
  };
  Denque.prototype.pop = function pop() {
    var tail = this._tail;
    if (tail === this._head)
      return;
    var len = this._list.length;
    this._tail = tail - 1 + len & this._capacityMask;
    var item = this._list[this._tail];
    this._list[this._tail] = undefined;
    if (this._head < 2 && tail > 1e4 && tail <= len >>> 2)
      this._shrinkArray();
    return item;
  };
  Denque.prototype.removeOne = function removeOne(index) {
    var i2 = index;
    if (i2 !== (i2 | 0)) {
      return;
    }
    if (this._head === this._tail)
      return;
    var size = this.size();
    var len = this._list.length;
    if (i2 >= size || i2 < -size)
      return;
    if (i2 < 0)
      i2 += size;
    i2 = this._head + i2 & this._capacityMask;
    var item = this._list[i2];
    var k;
    if (index < size / 2) {
      for (k = index;k > 0; k--) {
        this._list[i2] = this._list[i2 = i2 - 1 + len & this._capacityMask];
      }
      this._list[i2] = undefined;
      this._head = this._head + 1 + len & this._capacityMask;
    } else {
      for (k = size - 1 - index;k > 0; k--) {
        this._list[i2] = this._list[i2 = i2 + 1 + len & this._capacityMask];
      }
      this._list[i2] = undefined;
      this._tail = this._tail - 1 + len & this._capacityMask;
    }
    return item;
  };
  Denque.prototype.remove = function remove(index, count) {
    var i2 = index;
    var removed;
    var del_count = count;
    if (i2 !== (i2 | 0)) {
      return;
    }
    if (this._head === this._tail)
      return;
    var size = this.size();
    var len = this._list.length;
    if (i2 >= size || i2 < -size || count < 1)
      return;
    if (i2 < 0)
      i2 += size;
    if (count === 1 || !count) {
      removed = new Array(1);
      removed[0] = this.removeOne(i2);
      return removed;
    }
    if (i2 === 0 && i2 + count >= size) {
      removed = this.toArray();
      this.clear();
      return removed;
    }
    if (i2 + count > size)
      count = size - i2;
    var k;
    removed = new Array(count);
    for (k = 0;k < count; k++) {
      removed[k] = this._list[this._head + i2 + k & this._capacityMask];
    }
    i2 = this._head + i2 & this._capacityMask;
    if (index + count === size) {
      this._tail = this._tail - count + len & this._capacityMask;
      for (k = count;k > 0; k--) {
        this._list[i2 = i2 + 1 + len & this._capacityMask] = undefined;
      }
      return removed;
    }
    if (index === 0) {
      this._head = this._head + count + len & this._capacityMask;
      for (k = count - 1;k > 0; k--) {
        this._list[i2 = i2 + 1 + len & this._capacityMask] = undefined;
      }
      return removed;
    }
    if (i2 < size / 2) {
      this._head = this._head + index + count + len & this._capacityMask;
      for (k = index;k > 0; k--) {
        this.unshift(this._list[i2 = i2 - 1 + len & this._capacityMask]);
      }
      i2 = this._head - 1 + len & this._capacityMask;
      while (del_count > 0) {
        this._list[i2 = i2 - 1 + len & this._capacityMask] = undefined;
        del_count--;
      }
      if (index < 0)
        this._tail = i2;
    } else {
      this._tail = i2;
      i2 = i2 + count + len & this._capacityMask;
      for (k = size - (count + index);k > 0; k--) {
        this.push(this._list[i2++]);
      }
      i2 = this._tail;
      while (del_count > 0) {
        this._list[i2 = i2 + 1 + len & this._capacityMask] = undefined;
        del_count--;
      }
    }
    if (this._head < 2 && this._tail > 1e4 && this._tail <= len >>> 2)
      this._shrinkArray();
    return removed;
  };
  Denque.prototype.splice = function splice(index, count) {
    var i2 = index;
    if (i2 !== (i2 | 0)) {
      return;
    }
    var size = this.size();
    if (i2 < 0)
      i2 += size;
    if (i2 > size)
      return;
    if (arguments.length > 2) {
      var k;
      var temp;
      var removed;
      var arg_len = arguments.length;
      var len = this._list.length;
      var arguments_index = 2;
      if (!size || i2 < size / 2) {
        temp = new Array(i2);
        for (k = 0;k < i2; k++) {
          temp[k] = this._list[this._head + k & this._capacityMask];
        }
        if (count === 0) {
          removed = [];
          if (i2 > 0) {
            this._head = this._head + i2 + len & this._capacityMask;
          }
        } else {
          removed = this.remove(i2, count);
          this._head = this._head + i2 + len & this._capacityMask;
        }
        while (arg_len > arguments_index) {
          this.unshift(arguments[--arg_len]);
        }
        for (k = i2;k > 0; k--) {
          this.unshift(temp[k - 1]);
        }
      } else {
        temp = new Array(size - (i2 + count));
        var leng = temp.length;
        for (k = 0;k < leng; k++) {
          temp[k] = this._list[this._head + i2 + count + k & this._capacityMask];
        }
        if (count === 0) {
          removed = [];
          if (i2 != size) {
            this._tail = this._head + i2 + len & this._capacityMask;
          }
        } else {
          removed = this.remove(i2, count);
          this._tail = this._tail - leng + len & this._capacityMask;
        }
        while (arguments_index < arg_len) {
          this.push(arguments[arguments_index++]);
        }
        for (k = 0;k < leng; k++) {
          this.push(temp[k]);
        }
      }
      return removed;
    } else {
      return this.remove(i2, count);
    }
  };
  Denque.prototype.clear = function clear() {
    this._list = new Array(this._list.length);
    this._head = 0;
    this._tail = 0;
  };
  Denque.prototype.isEmpty = function isEmpty() {
    return this._head === this._tail;
  };
  Denque.prototype.toArray = function toArray() {
    return this._copyArray(false);
  };
  Denque.prototype._fromArray = function _fromArray(array) {
    var length = array.length;
    var capacity = this._nextPowerOf2(length);
    this._list = new Array(capacity);
    this._capacityMask = capacity - 1;
    this._tail = length;
    for (var i2 = 0;i2 < length; i2++)
      this._list[i2] = array[i2];
  };
  Denque.prototype._copyArray = function _copyArray(fullCopy, size) {
    var src22 = this._list;
    var capacity = src22.length;
    var length = this.length;
    size = size | length;
    if (size == length && this._head < this._tail) {
      return this._list.slice(this._head, this._tail);
    }
    var dest = new Array(size);
    var k = 0;
    var i2;
    if (fullCopy || this._head > this._tail) {
      for (i2 = this._head;i2 < capacity; i2++)
        dest[k++] = src22[i2];
      for (i2 = 0;i2 < this._tail; i2++)
        dest[k++] = src22[i2];
    } else {
      for (i2 = this._head;i2 < this._tail; i2++)
        dest[k++] = src22[i2];
    }
    return dest;
  };
  Denque.prototype._growArray = function _growArray() {
    if (this._head != 0) {
      var newList = this._copyArray(true, this._list.length << 1);
      this._tail = this._list.length;
      this._head = 0;
      this._list = newList;
    } else {
      this._tail = this._list.length;
      this._list.length <<= 1;
    }
    this._capacityMask = this._capacityMask << 1 | 1;
  };
  Denque.prototype._shrinkArray = function _shrinkArray() {
    this._list.length >>>= 1;
    this._capacityMask >>>= 1;
  };
  Denque.prototype._nextPowerOf2 = function _nextPowerOf2(num) {
    var log22 = Math.log(num) / Math.log(2);
    var nextPow2 = 1 << log22 + 1;
    return Math.max(nextPow2, 4);
  };
  module.exports = Denque;
});
var require_lib14 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.createLRU = undefined;
  var createLRU = (options3) => {
    let { max, onEviction } = options3;
    if (!(Number.isInteger(max) && max > 0))
      throw new TypeError("`max` must be a positive integer");
    let size = 0;
    let head2 = 0;
    let tail = 0;
    let free = [];
    const keyMap = new Map;
    const keyList = new Array(max).fill(undefined);
    const valList = new Array(max).fill(undefined);
    const next = new Array(max).fill(0);
    const prev = new Array(max).fill(0);
    const setTail = (index, type) => {
      if (index === tail)
        return;
      const nextIndex2 = next[index];
      const prevIndex = prev[index];
      if (index === head2)
        head2 = nextIndex2;
      else if (type === "get" || prevIndex !== 0)
        next[prevIndex] = nextIndex2;
      if (nextIndex2 !== 0)
        prev[nextIndex2] = prevIndex;
      next[tail] = index;
      prev[index] = tail;
      next[index] = 0;
      tail = index;
    };
    const _evict = () => {
      const evictHead = head2;
      const key = keyList[evictHead];
      onEviction === null || onEviction === undefined || onEviction(key, valList[evictHead]);
      keyMap.delete(key);
      keyList[evictHead] = undefined;
      valList[evictHead] = undefined;
      head2 = next[evictHead];
      if (head2 !== 0)
        prev[head2] = 0;
      size--;
      if (size === 0)
        head2 = tail = 0;
      free.push(evictHead);
      return evictHead;
    };
    return {
      set(key, value) {
        if (key === undefined)
          return;
        let index = keyMap.get(key);
        if (index === undefined) {
          index = size === max ? _evict() : free.length > 0 ? free.pop() : size;
          keyMap.set(key, index);
          keyList[index] = key;
          size++;
        } else
          onEviction === null || onEviction === undefined || onEviction(key, valList[index]);
        valList[index] = value;
        if (size === 1)
          head2 = tail = index;
        else
          setTail(index, "set");
      },
      get(key) {
        const index = keyMap.get(key);
        if (index === undefined)
          return;
        if (index !== tail)
          setTail(index, "get");
        return valList[index];
      },
      peek: (key) => {
        const index = keyMap.get(key);
        return index !== undefined ? valList[index] : undefined;
      },
      has: (key) => keyMap.has(key),
      *keys() {
        let current2 = tail;
        for (let i2 = 0;i2 < size; i2++) {
          yield keyList[current2];
          current2 = prev[current2];
        }
      },
      *values() {
        let current2 = tail;
        for (let i2 = 0;i2 < size; i2++) {
          yield valList[current2];
          current2 = prev[current2];
        }
      },
      *entries() {
        let current2 = tail;
        for (let i2 = 0;i2 < size; i2++) {
          yield [keyList[current2], valList[current2]];
          current2 = prev[current2];
        }
      },
      forEach: (callback) => {
        let current2 = tail;
        for (let i2 = 0;i2 < size; i2++) {
          const key = keyList[current2];
          const value = valList[current2];
          callback(value, key);
          current2 = prev[current2];
        }
      },
      delete(key) {
        const index = keyMap.get(key);
        if (index === undefined)
          return false;
        onEviction === null || onEviction === undefined || onEviction(key, valList[index]);
        keyMap.delete(key);
        free.push(index);
        keyList[index] = undefined;
        valList[index] = undefined;
        const prevIndex = prev[index];
        const nextIndex2 = next[index];
        if (prevIndex !== 0)
          next[prevIndex] = nextIndex2;
        if (nextIndex2 !== 0)
          prev[nextIndex2] = prevIndex;
        if (index === head2)
          head2 = nextIndex2;
        if (index === tail)
          tail = prevIndex;
        size--;
        return true;
      },
      evict: (number) => {
        let toPrune = Math.min(number, size);
        while (toPrune > 0) {
          _evict();
          toPrune--;
        }
      },
      clear() {
        if (typeof onEviction === "function") {
          const iterator = keyMap.values();
          for (let result2 = iterator.next();!result2.done; result2 = iterator.next())
            onEviction(keyList[result2.value], valList[result2.value]);
        }
        keyMap.clear();
        keyList.fill(undefined);
        valList.fill(undefined);
        free = [];
        size = 0;
        head2 = tail = 0;
      },
      resize: (newMax) => {
        if (!(Number.isInteger(newMax) && newMax > 0))
          throw new TypeError("`max` must be a positive integer");
        if (newMax === max)
          return;
        if (newMax < max) {
          let current2 = tail;
          const preserve = Math.min(size, newMax);
          const remove3 = size - preserve;
          const newKeyList = new Array(newMax);
          const newValList = new Array(newMax);
          const newNext = new Array(newMax);
          const newPrev = new Array(newMax);
          for (let i2 = 1;i2 <= remove3; i2++)
            onEviction === null || onEviction === undefined || onEviction(keyList[i2], valList[i2]);
          for (let i2 = preserve - 1;i2 >= 0; i2--) {
            newKeyList[i2] = keyList[current2];
            newValList[i2] = valList[current2];
            newNext[i2] = i2 + 1;
            newPrev[i2] = i2 - 1;
            keyMap.set(newKeyList[i2], i2);
            current2 = prev[current2];
          }
          head2 = 0;
          tail = preserve - 1;
          size = preserve;
          keyList.length = newMax;
          valList.length = newMax;
          next.length = newMax;
          prev.length = newMax;
          for (let i2 = 0;i2 < preserve; i2++) {
            keyList[i2] = newKeyList[i2];
            valList[i2] = newValList[i2];
            next[i2] = newNext[i2];
            prev[i2] = newPrev[i2];
          }
          free = [];
          for (let i2 = preserve;i2 < newMax; i2++)
            free.push(i2);
        } else {
          const fill = newMax - max;
          keyList.push(...new Array(fill).fill(undefined));
          valList.push(...new Array(fill).fill(undefined));
          next.push(...new Array(fill).fill(0));
          prev.push(...new Array(fill).fill(0));
        }
        max = newMax;
      },
      get max() {
        return max;
      },
      get size() {
        return size;
      },
      get available() {
        return max - size;
      }
    };
  };
  exports.createLRU = createLRU;
});
var require_errors = __commonJS2((exports) => {
  exports.EE_CANTCREATEFILE = 1;
  exports.EE_READ = 2;
  exports.EE_WRITE = 3;
  exports.EE_BADCLOSE = 4;
  exports.EE_OUTOFMEMORY = 5;
  exports.EE_DELETE = 6;
  exports.EE_LINK = 7;
  exports.EE_EOFERR = 9;
  exports.EE_CANTLOCK = 10;
  exports.EE_CANTUNLOCK = 11;
  exports.EE_DIR = 12;
  exports.EE_STAT = 13;
  exports.EE_CANT_CHSIZE = 14;
  exports.EE_CANT_OPEN_STREAM = 15;
  exports.EE_GETWD = 16;
  exports.EE_SETWD = 17;
  exports.EE_LINK_WARNING = 18;
  exports.EE_OPEN_WARNING = 19;
  exports.EE_DISK_FULL = 20;
  exports.EE_CANT_MKDIR = 21;
  exports.EE_UNKNOWN_CHARSET = 22;
  exports.EE_OUT_OF_FILERESOURCES = 23;
  exports.EE_CANT_READLINK = 24;
  exports.EE_CANT_SYMLINK = 25;
  exports.EE_REALPATH = 26;
  exports.EE_SYNC = 27;
  exports.EE_UNKNOWN_COLLATION = 28;
  exports.EE_FILENOTFOUND = 29;
  exports.EE_FILE_NOT_CLOSED = 30;
  exports.EE_CHANGE_OWNERSHIP = 31;
  exports.EE_CHANGE_PERMISSIONS = 32;
  exports.EE_CANT_SEEK = 33;
  exports.EE_CAPACITY_EXCEEDED = 34;
  exports.EE_DISK_FULL_WITH_RETRY_MSG = 35;
  exports.EE_FAILED_TO_CREATE_TIMER = 36;
  exports.EE_FAILED_TO_DELETE_TIMER = 37;
  exports.EE_FAILED_TO_CREATE_TIMER_QUEUE = 38;
  exports.EE_FAILED_TO_START_TIMER_NOTIFY_THREAD = 39;
  exports.EE_FAILED_TO_CREATE_TIMER_NOTIFY_THREAD_INTERRUPT_EVENT = 40;
  exports.EE_EXITING_TIMER_NOTIFY_THREAD = 41;
  exports.EE_WIN_LIBRARY_LOAD_FAILED = 42;
  exports.EE_WIN_RUN_TIME_ERROR_CHECK = 43;
  exports.EE_FAILED_TO_DETERMINE_LARGE_PAGE_SIZE = 44;
  exports.EE_FAILED_TO_KILL_ALL_THREADS = 45;
  exports.EE_FAILED_TO_CREATE_IO_COMPLETION_PORT = 46;
  exports.EE_FAILED_TO_OPEN_DEFAULTS_FILE = 47;
  exports.EE_FAILED_TO_HANDLE_DEFAULTS_FILE = 48;
  exports.EE_WRONG_DIRECTIVE_IN_CONFIG_FILE = 49;
  exports.EE_SKIPPING_DIRECTIVE_DUE_TO_MAX_INCLUDE_RECURSION = 50;
  exports.EE_INCORRECT_GRP_DEFINITION_IN_CONFIG_FILE = 51;
  exports.EE_OPTION_WITHOUT_GRP_IN_CONFIG_FILE = 52;
  exports.EE_CONFIG_FILE_PERMISSION_ERROR = 53;
  exports.EE_IGNORE_WORLD_WRITABLE_CONFIG_FILE = 54;
  exports.EE_USING_DISABLED_OPTION = 55;
  exports.EE_USING_DISABLED_SHORT_OPTION = 56;
  exports.EE_USING_PASSWORD_ON_CLI_IS_INSECURE = 57;
  exports.EE_UNKNOWN_SUFFIX_FOR_VARIABLE = 58;
  exports.EE_SSL_ERROR_FROM_FILE = 59;
  exports.EE_SSL_ERROR = 60;
  exports.EE_NET_SEND_ERROR_IN_BOOTSTRAP = 61;
  exports.EE_PACKETS_OUT_OF_ORDER = 62;
  exports.EE_UNKNOWN_PROTOCOL_OPTION = 63;
  exports.EE_FAILED_TO_LOCATE_SERVER_PUBLIC_KEY = 64;
  exports.EE_PUBLIC_KEY_NOT_IN_PEM_FORMAT = 65;
  exports.EE_DEBUG_INFO = 66;
  exports.EE_UNKNOWN_VARIABLE = 67;
  exports.EE_UNKNOWN_OPTION = 68;
  exports.EE_UNKNOWN_SHORT_OPTION = 69;
  exports.EE_OPTION_WITHOUT_ARGUMENT = 70;
  exports.EE_OPTION_REQUIRES_ARGUMENT = 71;
  exports.EE_SHORT_OPTION_REQUIRES_ARGUMENT = 72;
  exports.EE_OPTION_IGNORED_DUE_TO_INVALID_VALUE = 73;
  exports.EE_OPTION_WITH_EMPTY_VALUE = 74;
  exports.EE_FAILED_TO_ASSIGN_MAX_VALUE_TO_OPTION = 75;
  exports.EE_INCORRECT_BOOLEAN_VALUE_FOR_OPTION = 76;
  exports.EE_FAILED_TO_SET_OPTION_VALUE = 77;
  exports.EE_INCORRECT_INT_VALUE_FOR_OPTION = 78;
  exports.EE_INCORRECT_UINT_VALUE_FOR_OPTION = 79;
  exports.EE_ADJUSTED_SIGNED_VALUE_FOR_OPTION = 80;
  exports.EE_ADJUSTED_UNSIGNED_VALUE_FOR_OPTION = 81;
  exports.EE_ADJUSTED_ULONGLONG_VALUE_FOR_OPTION = 82;
  exports.EE_ADJUSTED_DOUBLE_VALUE_FOR_OPTION = 83;
  exports.EE_INVALID_DECIMAL_VALUE_FOR_OPTION = 84;
  exports.EE_COLLATION_PARSER_ERROR = 85;
  exports.EE_FAILED_TO_RESET_BEFORE_PRIMARY_IGNORABLE_CHAR = 86;
  exports.EE_FAILED_TO_RESET_BEFORE_TERTIARY_IGNORABLE_CHAR = 87;
  exports.EE_SHIFT_CHAR_OUT_OF_RANGE = 88;
  exports.EE_RESET_CHAR_OUT_OF_RANGE = 89;
  exports.EE_UNKNOWN_LDML_TAG = 90;
  exports.EE_FAILED_TO_RESET_BEFORE_SECONDARY_IGNORABLE_CHAR = 91;
  exports.EE_FAILED_PROCESSING_DIRECTIVE = 92;
  exports.EE_PTHREAD_KILL_FAILED = 93;
  exports.HA_ERR_KEY_NOT_FOUND = 120;
  exports.HA_ERR_FOUND_DUPP_KEY = 121;
  exports.HA_ERR_INTERNAL_ERROR = 122;
  exports.HA_ERR_RECORD_CHANGED = 123;
  exports.HA_ERR_WRONG_INDEX = 124;
  exports.HA_ERR_ROLLED_BACK = 125;
  exports.HA_ERR_CRASHED = 126;
  exports.HA_ERR_WRONG_IN_RECORD = 127;
  exports.HA_ERR_OUT_OF_MEM = 128;
  exports.HA_ERR_NOT_A_TABLE = 130;
  exports.HA_ERR_WRONG_COMMAND = 131;
  exports.HA_ERR_OLD_FILE = 132;
  exports.HA_ERR_NO_ACTIVE_RECORD = 133;
  exports.HA_ERR_RECORD_DELETED = 134;
  exports.HA_ERR_RECORD_FILE_FULL = 135;
  exports.HA_ERR_INDEX_FILE_FULL = 136;
  exports.HA_ERR_END_OF_FILE = 137;
  exports.HA_ERR_UNSUPPORTED = 138;
  exports.HA_ERR_TOO_BIG_ROW = 139;
  exports.HA_WRONG_CREATE_OPTION = 140;
  exports.HA_ERR_FOUND_DUPP_UNIQUE = 141;
  exports.HA_ERR_UNKNOWN_CHARSET = 142;
  exports.HA_ERR_WRONG_MRG_TABLE_DEF = 143;
  exports.HA_ERR_CRASHED_ON_REPAIR = 144;
  exports.HA_ERR_CRASHED_ON_USAGE = 145;
  exports.HA_ERR_LOCK_WAIT_TIMEOUT = 146;
  exports.HA_ERR_LOCK_TABLE_FULL = 147;
  exports.HA_ERR_READ_ONLY_TRANSACTION = 148;
  exports.HA_ERR_LOCK_DEADLOCK = 149;
  exports.HA_ERR_CANNOT_ADD_FOREIGN = 150;
  exports.HA_ERR_NO_REFERENCED_ROW = 151;
  exports.HA_ERR_ROW_IS_REFERENCED = 152;
  exports.HA_ERR_NO_SAVEPOINT = 153;
  exports.HA_ERR_NON_UNIQUE_BLOCK_SIZE = 154;
  exports.HA_ERR_NO_SUCH_TABLE = 155;
  exports.HA_ERR_TABLE_EXIST = 156;
  exports.HA_ERR_NO_CONNECTION = 157;
  exports.HA_ERR_NULL_IN_SPATIAL = 158;
  exports.HA_ERR_TABLE_DEF_CHANGED = 159;
  exports.HA_ERR_NO_PARTITION_FOUND = 160;
  exports.HA_ERR_RBR_LOGGING_FAILED = 161;
  exports.HA_ERR_DROP_INDEX_FK = 162;
  exports.HA_ERR_FOREIGN_DUPLICATE_KEY = 163;
  exports.HA_ERR_TABLE_NEEDS_UPGRADE = 164;
  exports.HA_ERR_TABLE_READONLY = 165;
  exports.HA_ERR_AUTOINC_READ_FAILED = 166;
  exports.HA_ERR_AUTOINC_ERANGE = 167;
  exports.HA_ERR_GENERIC = 168;
  exports.HA_ERR_RECORD_IS_THE_SAME = 169;
  exports.HA_ERR_LOGGING_IMPOSSIBLE = 170;
  exports.HA_ERR_CORRUPT_EVENT = 171;
  exports.HA_ERR_NEW_FILE = 172;
  exports.HA_ERR_ROWS_EVENT_APPLY = 173;
  exports.HA_ERR_INITIALIZATION = 174;
  exports.HA_ERR_FILE_TOO_SHORT = 175;
  exports.HA_ERR_WRONG_CRC = 176;
  exports.HA_ERR_TOO_MANY_CONCURRENT_TRXS = 177;
  exports.HA_ERR_NOT_IN_LOCK_PARTITIONS = 178;
  exports.HA_ERR_INDEX_COL_TOO_LONG = 179;
  exports.HA_ERR_INDEX_CORRUPT = 180;
  exports.HA_ERR_UNDO_REC_TOO_BIG = 181;
  exports.HA_FTS_INVALID_DOCID = 182;
  exports.HA_ERR_TABLE_IN_FK_CHECK = 183;
  exports.HA_ERR_TABLESPACE_EXISTS = 184;
  exports.HA_ERR_TOO_MANY_FIELDS = 185;
  exports.HA_ERR_ROW_IN_WRONG_PARTITION = 186;
  exports.HA_ERR_INNODB_READ_ONLY = 187;
  exports.HA_ERR_FTS_EXCEED_RESULT_CACHE_LIMIT = 188;
  exports.HA_ERR_TEMP_FILE_WRITE_FAILURE = 189;
  exports.HA_ERR_INNODB_FORCED_RECOVERY = 190;
  exports.HA_ERR_FTS_TOO_MANY_WORDS_IN_PHRASE = 191;
  exports.HA_ERR_FK_DEPTH_EXCEEDED = 192;
  exports.HA_MISSING_CREATE_OPTION = 193;
  exports.HA_ERR_SE_OUT_OF_MEMORY = 194;
  exports.HA_ERR_TABLE_CORRUPT = 195;
  exports.HA_ERR_QUERY_INTERRUPTED = 196;
  exports.HA_ERR_TABLESPACE_MISSING = 197;
  exports.HA_ERR_TABLESPACE_IS_NOT_EMPTY = 198;
  exports.HA_ERR_WRONG_FILE_NAME = 199;
  exports.HA_ERR_NOT_ALLOWED_COMMAND = 200;
  exports.HA_ERR_COMPUTE_FAILED = 201;
  exports.HA_ERR_ROW_FORMAT_CHANGED = 202;
  exports.HA_ERR_NO_WAIT_LOCK = 203;
  exports.HA_ERR_DISK_FULL_NOWAIT = 204;
  exports.HA_ERR_NO_SESSION_TEMP = 205;
  exports.HA_ERR_WRONG_TABLE_NAME = 206;
  exports.HA_ERR_TOO_LONG_PATH = 207;
  exports.HA_ERR_SAMPLING_INIT_FAILED = 208;
  exports.HA_ERR_FTS_TOO_MANY_NESTED_EXP = 209;
  exports.ER_HASHCHK = 1000;
  exports.ER_NISAMCHK = 1001;
  exports.ER_NO = 1002;
  exports.ER_YES = 1003;
  exports.ER_CANT_CREATE_FILE = 1004;
  exports.ER_CANT_CREATE_TABLE = 1005;
  exports.ER_CANT_CREATE_DB = 1006;
  exports.ER_DB_CREATE_EXISTS = 1007;
  exports.ER_DB_DROP_EXISTS = 1008;
  exports.ER_DB_DROP_DELETE = 1009;
  exports.ER_DB_DROP_RMDIR = 1010;
  exports.ER_CANT_DELETE_FILE = 1011;
  exports.ER_CANT_FIND_SYSTEM_REC = 1012;
  exports.ER_CANT_GET_STAT = 1013;
  exports.ER_CANT_GET_WD = 1014;
  exports.ER_CANT_LOCK = 1015;
  exports.ER_CANT_OPEN_FILE = 1016;
  exports.ER_FILE_NOT_FOUND = 1017;
  exports.ER_CANT_READ_DIR = 1018;
  exports.ER_CANT_SET_WD = 1019;
  exports.ER_CHECKREAD = 1020;
  exports.ER_DISK_FULL = 1021;
  exports.ER_DUP_KEY = 1022;
  exports.ER_ERROR_ON_CLOSE = 1023;
  exports.ER_ERROR_ON_READ = 1024;
  exports.ER_ERROR_ON_RENAME = 1025;
  exports.ER_ERROR_ON_WRITE = 1026;
  exports.ER_FILE_USED = 1027;
  exports.ER_FILSORT_ABORT = 1028;
  exports.ER_FORM_NOT_FOUND = 1029;
  exports.ER_GET_ERRNO = 1030;
  exports.ER_ILLEGAL_HA = 1031;
  exports.ER_KEY_NOT_FOUND = 1032;
  exports.ER_NOT_FORM_FILE = 1033;
  exports.ER_NOT_KEYFILE = 1034;
  exports.ER_OLD_KEYFILE = 1035;
  exports.ER_OPEN_AS_READONLY = 1036;
  exports.ER_OUTOFMEMORY = 1037;
  exports.ER_OUT_OF_SORTMEMORY = 1038;
  exports.ER_UNEXPECTED_EOF = 1039;
  exports.ER_CON_COUNT_ERROR = 1040;
  exports.ER_OUT_OF_RESOURCES = 1041;
  exports.ER_BAD_HOST_ERROR = 1042;
  exports.ER_HANDSHAKE_ERROR = 1043;
  exports.ER_DBACCESS_DENIED_ERROR = 1044;
  exports.ER_ACCESS_DENIED_ERROR = 1045;
  exports.ER_NO_DB_ERROR = 1046;
  exports.ER_UNKNOWN_COM_ERROR = 1047;
  exports.ER_BAD_NULL_ERROR = 1048;
  exports.ER_BAD_DB_ERROR = 1049;
  exports.ER_TABLE_EXISTS_ERROR = 1050;
  exports.ER_BAD_TABLE_ERROR = 1051;
  exports.ER_NON_UNIQ_ERROR = 1052;
  exports.ER_SERVER_SHUTDOWN = 1053;
  exports.ER_BAD_FIELD_ERROR = 1054;
  exports.ER_WRONG_FIELD_WITH_GROUP = 1055;
  exports.ER_WRONG_GROUP_FIELD = 1056;
  exports.ER_WRONG_SUM_SELECT = 1057;
  exports.ER_WRONG_VALUE_COUNT = 1058;
  exports.ER_TOO_LONG_IDENT = 1059;
  exports.ER_DUP_FIELDNAME = 1060;
  exports.ER_DUP_KEYNAME = 1061;
  exports.ER_DUP_ENTRY = 1062;
  exports.ER_WRONG_FIELD_SPEC = 1063;
  exports.ER_PARSE_ERROR = 1064;
  exports.ER_EMPTY_QUERY = 1065;
  exports.ER_NONUNIQ_TABLE = 1066;
  exports.ER_INVALID_DEFAULT = 1067;
  exports.ER_MULTIPLE_PRI_KEY = 1068;
  exports.ER_TOO_MANY_KEYS = 1069;
  exports.ER_TOO_MANY_KEY_PARTS = 1070;
  exports.ER_TOO_LONG_KEY = 1071;
  exports.ER_KEY_COLUMN_DOES_NOT_EXITS = 1072;
  exports.ER_BLOB_USED_AS_KEY = 1073;
  exports.ER_TOO_BIG_FIELDLENGTH = 1074;
  exports.ER_WRONG_AUTO_KEY = 1075;
  exports.ER_READY = 1076;
  exports.ER_NORMAL_SHUTDOWN = 1077;
  exports.ER_GOT_SIGNAL = 1078;
  exports.ER_SHUTDOWN_COMPLETE = 1079;
  exports.ER_FORCING_CLOSE = 1080;
  exports.ER_IPSOCK_ERROR = 1081;
  exports.ER_NO_SUCH_INDEX = 1082;
  exports.ER_WRONG_FIELD_TERMINATORS = 1083;
  exports.ER_BLOBS_AND_NO_TERMINATED = 1084;
  exports.ER_TEXTFILE_NOT_READABLE = 1085;
  exports.ER_FILE_EXISTS_ERROR = 1086;
  exports.ER_LOAD_INFO = 1087;
  exports.ER_ALTER_INFO = 1088;
  exports.ER_WRONG_SUB_KEY = 1089;
  exports.ER_CANT_REMOVE_ALL_FIELDS = 1090;
  exports.ER_CANT_DROP_FIELD_OR_KEY = 1091;
  exports.ER_INSERT_INFO = 1092;
  exports.ER_UPDATE_TABLE_USED = 1093;
  exports.ER_NO_SUCH_THREAD = 1094;
  exports.ER_KILL_DENIED_ERROR = 1095;
  exports.ER_NO_TABLES_USED = 1096;
  exports.ER_TOO_BIG_SET = 1097;
  exports.ER_NO_UNIQUE_LOGFILE = 1098;
  exports.ER_TABLE_NOT_LOCKED_FOR_WRITE = 1099;
  exports.ER_TABLE_NOT_LOCKED = 1100;
  exports.ER_BLOB_CANT_HAVE_DEFAULT = 1101;
  exports.ER_WRONG_DB_NAME = 1102;
  exports.ER_WRONG_TABLE_NAME = 1103;
  exports.ER_TOO_BIG_SELECT = 1104;
  exports.ER_UNKNOWN_ERROR = 1105;
  exports.ER_UNKNOWN_PROCEDURE = 1106;
  exports.ER_WRONG_PARAMCOUNT_TO_PROCEDURE = 1107;
  exports.ER_WRONG_PARAMETERS_TO_PROCEDURE = 1108;
  exports.ER_UNKNOWN_TABLE = 1109;
  exports.ER_FIELD_SPECIFIED_TWICE = 1110;
  exports.ER_INVALID_GROUP_FUNC_USE = 1111;
  exports.ER_UNSUPPORTED_EXTENSION = 1112;
  exports.ER_TABLE_MUST_HAVE_COLUMNS = 1113;
  exports.ER_RECORD_FILE_FULL = 1114;
  exports.ER_UNKNOWN_CHARACTER_SET = 1115;
  exports.ER_TOO_MANY_TABLES = 1116;
  exports.ER_TOO_MANY_FIELDS = 1117;
  exports.ER_TOO_BIG_ROWSIZE = 1118;
  exports.ER_STACK_OVERRUN = 1119;
  exports.ER_WRONG_OUTER_JOIN = 1120;
  exports.ER_NULL_COLUMN_IN_INDEX = 1121;
  exports.ER_CANT_FIND_UDF = 1122;
  exports.ER_CANT_INITIALIZE_UDF = 1123;
  exports.ER_UDF_NO_PATHS = 1124;
  exports.ER_UDF_EXISTS = 1125;
  exports.ER_CANT_OPEN_LIBRARY = 1126;
  exports.ER_CANT_FIND_DL_ENTRY = 1127;
  exports.ER_FUNCTION_NOT_DEFINED = 1128;
  exports.ER_HOST_IS_BLOCKED = 1129;
  exports.ER_HOST_NOT_PRIVILEGED = 1130;
  exports.ER_PASSWORD_ANONYMOUS_USER = 1131;
  exports.ER_PASSWORD_NOT_ALLOWED = 1132;
  exports.ER_PASSWORD_NO_MATCH = 1133;
  exports.ER_UPDATE_INFO = 1134;
  exports.ER_CANT_CREATE_THREAD = 1135;
  exports.ER_WRONG_VALUE_COUNT_ON_ROW = 1136;
  exports.ER_CANT_REOPEN_TABLE = 1137;
  exports.ER_INVALID_USE_OF_NULL = 1138;
  exports.ER_REGEXP_ERROR = 1139;
  exports.ER_MIX_OF_GROUP_FUNC_AND_FIELDS = 1140;
  exports.ER_NONEXISTING_GRANT = 1141;
  exports.ER_TABLEACCESS_DENIED_ERROR = 1142;
  exports.ER_COLUMNACCESS_DENIED_ERROR = 1143;
  exports.ER_ILLEGAL_GRANT_FOR_TABLE = 1144;
  exports.ER_GRANT_WRONG_HOST_OR_USER = 1145;
  exports.ER_NO_SUCH_TABLE = 1146;
  exports.ER_NONEXISTING_TABLE_GRANT = 1147;
  exports.ER_NOT_ALLOWED_COMMAND = 1148;
  exports.ER_SYNTAX_ERROR = 1149;
  exports.ER_UNUSED1 = 1150;
  exports.ER_UNUSED2 = 1151;
  exports.ER_ABORTING_CONNECTION = 1152;
  exports.ER_NET_PACKET_TOO_LARGE = 1153;
  exports.ER_NET_READ_ERROR_FROM_PIPE = 1154;
  exports.ER_NET_FCNTL_ERROR = 1155;
  exports.ER_NET_PACKETS_OUT_OF_ORDER = 1156;
  exports.ER_NET_UNCOMPRESS_ERROR = 1157;
  exports.ER_NET_READ_ERROR = 1158;
  exports.ER_NET_READ_INTERRUPTED = 1159;
  exports.ER_NET_ERROR_ON_WRITE = 1160;
  exports.ER_NET_WRITE_INTERRUPTED = 1161;
  exports.ER_TOO_LONG_STRING = 1162;
  exports.ER_TABLE_CANT_HANDLE_BLOB = 1163;
  exports.ER_TABLE_CANT_HANDLE_AUTO_INCREMENT = 1164;
  exports.ER_UNUSED3 = 1165;
  exports.ER_WRONG_COLUMN_NAME = 1166;
  exports.ER_WRONG_KEY_COLUMN = 1167;
  exports.ER_WRONG_MRG_TABLE = 1168;
  exports.ER_DUP_UNIQUE = 1169;
  exports.ER_BLOB_KEY_WITHOUT_LENGTH = 1170;
  exports.ER_PRIMARY_CANT_HAVE_NULL = 1171;
  exports.ER_TOO_MANY_ROWS = 1172;
  exports.ER_REQUIRES_PRIMARY_KEY = 1173;
  exports.ER_NO_RAID_COMPILED = 1174;
  exports.ER_UPDATE_WITHOUT_KEY_IN_SAFE_MODE = 1175;
  exports.ER_KEY_DOES_NOT_EXITS = 1176;
  exports.ER_CHECK_NO_SUCH_TABLE = 1177;
  exports.ER_CHECK_NOT_IMPLEMENTED = 1178;
  exports.ER_CANT_DO_THIS_DURING_AN_TRANSACTION = 1179;
  exports.ER_ERROR_DURING_COMMIT = 1180;
  exports.ER_ERROR_DURING_ROLLBACK = 1181;
  exports.ER_ERROR_DURING_FLUSH_LOGS = 1182;
  exports.ER_ERROR_DURING_CHECKPOINT = 1183;
  exports.ER_NEW_ABORTING_CONNECTION = 1184;
  exports.ER_DUMP_NOT_IMPLEMENTED = 1185;
  exports.ER_FLUSH_MASTER_BINLOG_CLOSED = 1186;
  exports.ER_INDEX_REBUILD = 1187;
  exports.ER_SOURCE = 1188;
  exports.ER_SOURCE_NET_READ = 1189;
  exports.ER_SOURCE_NET_WRITE = 1190;
  exports.ER_FT_MATCHING_KEY_NOT_FOUND = 1191;
  exports.ER_LOCK_OR_ACTIVE_TRANSACTION = 1192;
  exports.ER_UNKNOWN_SYSTEM_VARIABLE = 1193;
  exports.ER_CRASHED_ON_USAGE = 1194;
  exports.ER_CRASHED_ON_REPAIR = 1195;
  exports.ER_WARNING_NOT_COMPLETE_ROLLBACK = 1196;
  exports.ER_TRANS_CACHE_FULL = 1197;
  exports.ER_SLAVE_MUST_STOP = 1198;
  exports.ER_REPLICA_NOT_RUNNING = 1199;
  exports.ER_BAD_REPLICA = 1200;
  exports.ER_CONNECTION_METADATA = 1201;
  exports.ER_REPLICA_THREAD = 1202;
  exports.ER_TOO_MANY_USER_CONNECTIONS = 1203;
  exports.ER_SET_CONSTANTS_ONLY = 1204;
  exports.ER_LOCK_WAIT_TIMEOUT = 1205;
  exports.ER_LOCK_TABLE_FULL = 1206;
  exports.ER_READ_ONLY_TRANSACTION = 1207;
  exports.ER_DROP_DB_WITH_READ_LOCK = 1208;
  exports.ER_CREATE_DB_WITH_READ_LOCK = 1209;
  exports.ER_WRONG_ARGUMENTS = 1210;
  exports.ER_NO_PERMISSION_TO_CREATE_USER = 1211;
  exports.ER_UNION_TABLES_IN_DIFFERENT_DIR = 1212;
  exports.ER_LOCK_DEADLOCK = 1213;
  exports.ER_TABLE_CANT_HANDLE_FT = 1214;
  exports.ER_CANNOT_ADD_FOREIGN = 1215;
  exports.ER_NO_REFERENCED_ROW = 1216;
  exports.ER_ROW_IS_REFERENCED = 1217;
  exports.ER_CONNECT_TO_SOURCE = 1218;
  exports.ER_QUERY_ON_MASTER = 1219;
  exports.ER_ERROR_WHEN_EXECUTING_COMMAND = 1220;
  exports.ER_WRONG_USAGE = 1221;
  exports.ER_WRONG_NUMBER_OF_COLUMNS_IN_SELECT = 1222;
  exports.ER_CANT_UPDATE_WITH_READLOCK = 1223;
  exports.ER_MIXING_NOT_ALLOWED = 1224;
  exports.ER_DUP_ARGUMENT = 1225;
  exports.ER_USER_LIMIT_REACHED = 1226;
  exports.ER_SPECIFIC_ACCESS_DENIED_ERROR = 1227;
  exports.ER_LOCAL_VARIABLE = 1228;
  exports.ER_GLOBAL_VARIABLE = 1229;
  exports.ER_NO_DEFAULT = 1230;
  exports.ER_WRONG_VALUE_FOR_VAR = 1231;
  exports.ER_WRONG_TYPE_FOR_VAR = 1232;
  exports.ER_VAR_CANT_BE_READ = 1233;
  exports.ER_CANT_USE_OPTION_HERE = 1234;
  exports.ER_NOT_SUPPORTED_YET = 1235;
  exports.ER_SOURCE_FATAL_ERROR_READING_BINLOG = 1236;
  exports.ER_REPLICA_IGNORED_TABLE = 1237;
  exports.ER_INCORRECT_GLOBAL_LOCAL_VAR = 1238;
  exports.ER_WRONG_FK_DEF = 1239;
  exports.ER_KEY_REF_DO_NOT_MATCH_TABLE_REF = 1240;
  exports.ER_OPERAND_COLUMNS = 1241;
  exports.ER_SUBQUERY_NO_1_ROW = 1242;
  exports.ER_UNKNOWN_STMT_HANDLER = 1243;
  exports.ER_CORRUPT_HELP_DB = 1244;
  exports.ER_CYCLIC_REFERENCE = 1245;
  exports.ER_AUTO_CONVERT = 1246;
  exports.ER_ILLEGAL_REFERENCE = 1247;
  exports.ER_DERIVED_MUST_HAVE_ALIAS = 1248;
  exports.ER_SELECT_REDUCED = 1249;
  exports.ER_TABLENAME_NOT_ALLOWED_HERE = 1250;
  exports.ER_NOT_SUPPORTED_AUTH_MODE = 1251;
  exports.ER_SPATIAL_CANT_HAVE_NULL = 1252;
  exports.ER_COLLATION_CHARSET_MISMATCH = 1253;
  exports.ER_SLAVE_WAS_RUNNING = 1254;
  exports.ER_SLAVE_WAS_NOT_RUNNING = 1255;
  exports.ER_TOO_BIG_FOR_UNCOMPRESS = 1256;
  exports.ER_ZLIB_Z_MEM_ERROR = 1257;
  exports.ER_ZLIB_Z_BUF_ERROR = 1258;
  exports.ER_ZLIB_Z_DATA_ERROR = 1259;
  exports.ER_CUT_VALUE_GROUP_CONCAT = 1260;
  exports.ER_WARN_TOO_FEW_RECORDS = 1261;
  exports.ER_WARN_TOO_MANY_RECORDS = 1262;
  exports.ER_WARN_NULL_TO_NOTNULL = 1263;
  exports.ER_WARN_DATA_OUT_OF_RANGE = 1264;
  exports.WARN_DATA_TRUNCATED = 1265;
  exports.ER_WARN_USING_OTHER_HANDLER = 1266;
  exports.ER_CANT_AGGREGATE_2COLLATIONS = 1267;
  exports.ER_DROP_USER = 1268;
  exports.ER_REVOKE_GRANTS = 1269;
  exports.ER_CANT_AGGREGATE_3COLLATIONS = 1270;
  exports.ER_CANT_AGGREGATE_NCOLLATIONS = 1271;
  exports.ER_VARIABLE_IS_NOT_STRUCT = 1272;
  exports.ER_UNKNOWN_COLLATION = 1273;
  exports.ER_REPLICA_IGNORED_SSL_PARAMS = 1274;
  exports.ER_SERVER_IS_IN_SECURE_AUTH_MODE = 1275;
  exports.ER_WARN_FIELD_RESOLVED = 1276;
  exports.ER_BAD_REPLICA_UNTIL_COND = 1277;
  exports.ER_MISSING_SKIP_REPLICA = 1278;
  exports.ER_UNTIL_COND_IGNORED = 1279;
  exports.ER_WRONG_NAME_FOR_INDEX = 1280;
  exports.ER_WRONG_NAME_FOR_CATALOG = 1281;
  exports.ER_WARN_QC_RESIZE = 1282;
  exports.ER_BAD_FT_COLUMN = 1283;
  exports.ER_UNKNOWN_KEY_CACHE = 1284;
  exports.ER_WARN_HOSTNAME_WONT_WORK = 1285;
  exports.ER_UNKNOWN_STORAGE_ENGINE = 1286;
  exports.ER_WARN_DEPRECATED_SYNTAX = 1287;
  exports.ER_NON_UPDATABLE_TABLE = 1288;
  exports.ER_FEATURE_DISABLED = 1289;
  exports.ER_OPTION_PREVENTS_STATEMENT = 1290;
  exports.ER_DUPLICATED_VALUE_IN_TYPE = 1291;
  exports.ER_TRUNCATED_WRONG_VALUE = 1292;
  exports.ER_TOO_MUCH_AUTO_TIMESTAMP_COLS = 1293;
  exports.ER_INVALID_ON_UPDATE = 1294;
  exports.ER_UNSUPPORTED_PS = 1295;
  exports.ER_GET_ERRMSG = 1296;
  exports.ER_GET_TEMPORARY_ERRMSG = 1297;
  exports.ER_UNKNOWN_TIME_ZONE = 1298;
  exports.ER_WARN_INVALID_TIMESTAMP = 1299;
  exports.ER_INVALID_CHARACTER_STRING = 1300;
  exports.ER_WARN_ALLOWED_PACKET_OVERFLOWED = 1301;
  exports.ER_CONFLICTING_DECLARATIONS = 1302;
  exports.ER_SP_NO_RECURSIVE_CREATE = 1303;
  exports.ER_SP_ALREADY_EXISTS = 1304;
  exports.ER_SP_DOES_NOT_EXIST = 1305;
  exports.ER_SP_DROP_FAILED = 1306;
  exports.ER_SP_STORE_FAILED = 1307;
  exports.ER_SP_LILABEL_MISMATCH = 1308;
  exports.ER_SP_LABEL_REDEFINE = 1309;
  exports.ER_SP_LABEL_MISMATCH = 1310;
  exports.ER_SP_UNINIT_VAR = 1311;
  exports.ER_SP_BADSELECT = 1312;
  exports.ER_SP_BADRETURN = 1313;
  exports.ER_SP_BADSTATEMENT = 1314;
  exports.ER_UPDATE_LOG_DEPRECATED_IGNORED = 1315;
  exports.ER_UPDATE_LOG_DEPRECATED_TRANSLATED = 1316;
  exports.ER_QUERY_INTERRUPTED = 1317;
  exports.ER_SP_WRONG_NO_OF_ARGS = 1318;
  exports.ER_SP_COND_MISMATCH = 1319;
  exports.ER_SP_NORETURN = 1320;
  exports.ER_SP_NORETURNEND = 1321;
  exports.ER_SP_BAD_CURSOR_QUERY = 1322;
  exports.ER_SP_BAD_CURSOR_SELECT = 1323;
  exports.ER_SP_CURSOR_MISMATCH = 1324;
  exports.ER_SP_CURSOR_ALREADY_OPEN = 1325;
  exports.ER_SP_CURSOR_NOT_OPEN = 1326;
  exports.ER_SP_UNDECLARED_VAR = 1327;
  exports.ER_SP_WRONG_NO_OF_FETCH_ARGS = 1328;
  exports.ER_SP_FETCH_NO_DATA = 1329;
  exports.ER_SP_DUP_PARAM = 1330;
  exports.ER_SP_DUP_VAR = 1331;
  exports.ER_SP_DUP_COND = 1332;
  exports.ER_SP_DUP_CURS = 1333;
  exports.ER_SP_CANT_ALTER = 1334;
  exports.ER_SP_SUBSELECT_NYI = 1335;
  exports.ER_STMT_NOT_ALLOWED_IN_SF_OR_TRG = 1336;
  exports.ER_SP_VARCOND_AFTER_CURSHNDLR = 1337;
  exports.ER_SP_CURSOR_AFTER_HANDLER = 1338;
  exports.ER_SP_CASE_NOT_FOUND = 1339;
  exports.ER_FPARSER_TOO_BIG_FILE = 1340;
  exports.ER_FPARSER_BAD_HEADER = 1341;
  exports.ER_FPARSER_EOF_IN_COMMENT = 1342;
  exports.ER_FPARSER_ERROR_IN_PARAMETER = 1343;
  exports.ER_FPARSER_EOF_IN_UNKNOWN_PARAMETER = 1344;
  exports.ER_VIEW_NO_EXPLAIN = 1345;
  exports.ER_FRM_UNKNOWN_TYPE = 1346;
  exports.ER_WRONG_OBJECT = 1347;
  exports.ER_NONUPDATEABLE_COLUMN = 1348;
  exports.ER_VIEW_SELECT_DERIVED = 1349;
  exports.ER_VIEW_SELECT_CLAUSE = 1350;
  exports.ER_VIEW_SELECT_VARIABLE = 1351;
  exports.ER_VIEW_SELECT_TMPTABLE = 1352;
  exports.ER_VIEW_WRONG_LIST = 1353;
  exports.ER_WARN_VIEW_MERGE = 1354;
  exports.ER_WARN_VIEW_WITHOUT_KEY = 1355;
  exports.ER_VIEW_INVALID = 1356;
  exports.ER_SP_NO_DROP_SP = 1357;
  exports.ER_SP_GOTO_IN_HNDLR = 1358;
  exports.ER_TRG_ALREADY_EXISTS = 1359;
  exports.ER_TRG_DOES_NOT_EXIST = 1360;
  exports.ER_TRG_ON_VIEW_OR_TEMP_TABLE = 1361;
  exports.ER_TRG_CANT_CHANGE_ROW = 1362;
  exports.ER_TRG_NO_SUCH_ROW_IN_TRG = 1363;
  exports.ER_NO_DEFAULT_FOR_FIELD = 1364;
  exports.ER_DIVISION_BY_ZERO = 1365;
  exports.ER_TRUNCATED_WRONG_VALUE_FOR_FIELD = 1366;
  exports.ER_ILLEGAL_VALUE_FOR_TYPE = 1367;
  exports.ER_VIEW_NONUPD_CHECK = 1368;
  exports.ER_VIEW_CHECK_FAILED = 1369;
  exports.ER_PROCACCESS_DENIED_ERROR = 1370;
  exports.ER_RELAY_LOG_FAIL = 1371;
  exports.ER_PASSWD_LENGTH = 1372;
  exports.ER_UNKNOWN_TARGET_BINLOG = 1373;
  exports.ER_IO_ERR_LOG_INDEX_READ = 1374;
  exports.ER_BINLOG_PURGE_PROHIBITED = 1375;
  exports.ER_FSEEK_FAIL = 1376;
  exports.ER_BINLOG_PURGE_FATAL_ERR = 1377;
  exports.ER_LOG_IN_USE = 1378;
  exports.ER_LOG_PURGE_UNKNOWN_ERR = 1379;
  exports.ER_RELAY_LOG_INIT = 1380;
  exports.ER_NO_BINARY_LOGGING = 1381;
  exports.ER_RESERVED_SYNTAX = 1382;
  exports.ER_WSAS_FAILED = 1383;
  exports.ER_DIFF_GROUPS_PROC = 1384;
  exports.ER_NO_GROUP_FOR_PROC = 1385;
  exports.ER_ORDER_WITH_PROC = 1386;
  exports.ER_LOGGING_PROHIBIT_CHANGING_OF = 1387;
  exports.ER_NO_FILE_MAPPING = 1388;
  exports.ER_WRONG_MAGIC = 1389;
  exports.ER_PS_MANY_PARAM = 1390;
  exports.ER_KEY_PART_0 = 1391;
  exports.ER_VIEW_CHECKSUM = 1392;
  exports.ER_VIEW_MULTIUPDATE = 1393;
  exports.ER_VIEW_NO_INSERT_FIELD_LIST = 1394;
  exports.ER_VIEW_DELETE_MERGE_VIEW = 1395;
  exports.ER_CANNOT_USER = 1396;
  exports.ER_XAER_NOTA = 1397;
  exports.ER_XAER_INVAL = 1398;
  exports.ER_XAER_RMFAIL = 1399;
  exports.ER_XAER_OUTSIDE = 1400;
  exports.ER_XAER_RMERR = 1401;
  exports.ER_XA_RBROLLBACK = 1402;
  exports.ER_NONEXISTING_PROC_GRANT = 1403;
  exports.ER_PROC_AUTO_GRANT_FAIL = 1404;
  exports.ER_PROC_AUTO_REVOKE_FAIL = 1405;
  exports.ER_DATA_TOO_LONG = 1406;
  exports.ER_SP_BAD_SQLSTATE = 1407;
  exports.ER_STARTUP = 1408;
  exports.ER_LOAD_FROM_FIXED_SIZE_ROWS_TO_VAR = 1409;
  exports.ER_CANT_CREATE_USER_WITH_GRANT = 1410;
  exports.ER_WRONG_VALUE_FOR_TYPE = 1411;
  exports.ER_TABLE_DEF_CHANGED = 1412;
  exports.ER_SP_DUP_HANDLER = 1413;
  exports.ER_SP_NOT_VAR_ARG = 1414;
  exports.ER_SP_NO_RETSET = 1415;
  exports.ER_CANT_CREATE_GEOMETRY_OBJECT = 1416;
  exports.ER_FAILED_ROUTINE_BREAK_BINLOG = 1417;
  exports.ER_BINLOG_UNSAFE_ROUTINE = 1418;
  exports.ER_BINLOG_CREATE_ROUTINE_NEED_SUPER = 1419;
  exports.ER_EXEC_STMT_WITH_OPEN_CURSOR = 1420;
  exports.ER_STMT_HAS_NO_OPEN_CURSOR = 1421;
  exports.ER_COMMIT_NOT_ALLOWED_IN_SF_OR_TRG = 1422;
  exports.ER_NO_DEFAULT_FOR_VIEW_FIELD = 1423;
  exports.ER_SP_NO_RECURSION = 1424;
  exports.ER_TOO_BIG_SCALE = 1425;
  exports.ER_TOO_BIG_PRECISION = 1426;
  exports.ER_M_BIGGER_THAN_D = 1427;
  exports.ER_WRONG_LOCK_OF_SYSTEM_TABLE = 1428;
  exports.ER_CONNECT_TO_FOREIGN_DATA_SOURCE = 1429;
  exports.ER_QUERY_ON_FOREIGN_DATA_SOURCE = 1430;
  exports.ER_FOREIGN_DATA_SOURCE_DOESNT_EXIST = 1431;
  exports.ER_FOREIGN_DATA_STRING_INVALID_CANT_CREATE = 1432;
  exports.ER_FOREIGN_DATA_STRING_INVALID = 1433;
  exports.ER_CANT_CREATE_FEDERATED_TABLE = 1434;
  exports.ER_TRG_IN_WRONG_SCHEMA = 1435;
  exports.ER_STACK_OVERRUN_NEED_MORE = 1436;
  exports.ER_TOO_LONG_BODY = 1437;
  exports.ER_WARN_CANT_DROP_DEFAULT_KEYCACHE = 1438;
  exports.ER_TOO_BIG_DISPLAYWIDTH = 1439;
  exports.ER_XAER_DUPID = 1440;
  exports.ER_DATETIME_FUNCTION_OVERFLOW = 1441;
  exports.ER_CANT_UPDATE_USED_TABLE_IN_SF_OR_TRG = 1442;
  exports.ER_VIEW_PREVENT_UPDATE = 1443;
  exports.ER_PS_NO_RECURSION = 1444;
  exports.ER_SP_CANT_SET_AUTOCOMMIT = 1445;
  exports.ER_MALFORMED_DEFINER = 1446;
  exports.ER_VIEW_FRM_NO_USER = 1447;
  exports.ER_VIEW_OTHER_USER = 1448;
  exports.ER_NO_SUCH_USER = 1449;
  exports.ER_FORBID_SCHEMA_CHANGE = 1450;
  exports.ER_ROW_IS_REFERENCED_2 = 1451;
  exports.ER_NO_REFERENCED_ROW_2 = 1452;
  exports.ER_SP_BAD_VAR_SHADOW = 1453;
  exports.ER_TRG_NO_DEFINER = 1454;
  exports.ER_OLD_FILE_FORMAT = 1455;
  exports.ER_SP_RECURSION_LIMIT = 1456;
  exports.ER_SP_PROC_TABLE_CORRUPT = 1457;
  exports.ER_SP_WRONG_NAME = 1458;
  exports.ER_TABLE_NEEDS_UPGRADE = 1459;
  exports.ER_SP_NO_AGGREGATE = 1460;
  exports.ER_MAX_PREPARED_STMT_COUNT_REACHED = 1461;
  exports.ER_VIEW_RECURSIVE = 1462;
  exports.ER_NON_GROUPING_FIELD_USED = 1463;
  exports.ER_TABLE_CANT_HANDLE_SPKEYS = 1464;
  exports.ER_NO_TRIGGERS_ON_SYSTEM_SCHEMA = 1465;
  exports.ER_REMOVED_SPACES = 1466;
  exports.ER_AUTOINC_READ_FAILED = 1467;
  exports.ER_USERNAME = 1468;
  exports.ER_HOSTNAME = 1469;
  exports.ER_WRONG_STRING_LENGTH = 1470;
  exports.ER_NON_INSERTABLE_TABLE = 1471;
  exports.ER_ADMIN_WRONG_MRG_TABLE = 1472;
  exports.ER_TOO_HIGH_LEVEL_OF_NESTING_FOR_SELECT = 1473;
  exports.ER_NAME_BECOMES_EMPTY = 1474;
  exports.ER_AMBIGUOUS_FIELD_TERM = 1475;
  exports.ER_FOREIGN_SERVER_EXISTS = 1476;
  exports.ER_FOREIGN_SERVER_DOESNT_EXIST = 1477;
  exports.ER_ILLEGAL_HA_CREATE_OPTION = 1478;
  exports.ER_PARTITION_REQUIRES_VALUES_ERROR = 1479;
  exports.ER_PARTITION_WRONG_VALUES_ERROR = 1480;
  exports.ER_PARTITION_MAXVALUE_ERROR = 1481;
  exports.ER_PARTITION_SUBPARTITION_ERROR = 1482;
  exports.ER_PARTITION_SUBPART_MIX_ERROR = 1483;
  exports.ER_PARTITION_WRONG_NO_PART_ERROR = 1484;
  exports.ER_PARTITION_WRONG_NO_SUBPART_ERROR = 1485;
  exports.ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR = 1486;
  exports.ER_NO_CONST_EXPR_IN_RANGE_OR_LIST_ERROR = 1487;
  exports.ER_FIELD_NOT_FOUND_PART_ERROR = 1488;
  exports.ER_LIST_OF_FIELDS_ONLY_IN_HASH_ERROR = 1489;
  exports.ER_INCONSISTENT_PARTITION_INFO_ERROR = 1490;
  exports.ER_PARTITION_FUNC_NOT_ALLOWED_ERROR = 1491;
  exports.ER_PARTITIONS_MUST_BE_DEFINED_ERROR = 1492;
  exports.ER_RANGE_NOT_INCREASING_ERROR = 1493;
  exports.ER_INCONSISTENT_TYPE_OF_FUNCTIONS_ERROR = 1494;
  exports.ER_MULTIPLE_DEF_CONST_IN_LIST_PART_ERROR = 1495;
  exports.ER_PARTITION_ENTRY_ERROR = 1496;
  exports.ER_MIX_HANDLER_ERROR = 1497;
  exports.ER_PARTITION_NOT_DEFINED_ERROR = 1498;
  exports.ER_TOO_MANY_PARTITIONS_ERROR = 1499;
  exports.ER_SUBPARTITION_ERROR = 1500;
  exports.ER_CANT_CREATE_HANDLER_FILE = 1501;
  exports.ER_BLOB_FIELD_IN_PART_FUNC_ERROR = 1502;
  exports.ER_UNIQUE_KEY_NEED_ALL_FIELDS_IN_PF = 1503;
  exports.ER_NO_PARTS_ERROR = 1504;
  exports.ER_PARTITION_MGMT_ON_NONPARTITIONED = 1505;
  exports.ER_FOREIGN_KEY_ON_PARTITIONED = 1506;
  exports.ER_DROP_PARTITION_NON_EXISTENT = 1507;
  exports.ER_DROP_LAST_PARTITION = 1508;
  exports.ER_COALESCE_ONLY_ON_HASH_PARTITION = 1509;
  exports.ER_REORG_HASH_ONLY_ON_SAME_NO = 1510;
  exports.ER_REORG_NO_PARAM_ERROR = 1511;
  exports.ER_ONLY_ON_RANGE_LIST_PARTITION = 1512;
  exports.ER_ADD_PARTITION_SUBPART_ERROR = 1513;
  exports.ER_ADD_PARTITION_NO_NEW_PARTITION = 1514;
  exports.ER_COALESCE_PARTITION_NO_PARTITION = 1515;
  exports.ER_REORG_PARTITION_NOT_EXIST = 1516;
  exports.ER_SAME_NAME_PARTITION = 1517;
  exports.ER_NO_BINLOG_ERROR = 1518;
  exports.ER_CONSECUTIVE_REORG_PARTITIONS = 1519;
  exports.ER_REORG_OUTSIDE_RANGE = 1520;
  exports.ER_PARTITION_FUNCTION_FAILURE = 1521;
  exports.ER_PART_STATE_ERROR = 1522;
  exports.ER_LIMITED_PART_RANGE = 1523;
  exports.ER_PLUGIN_IS_NOT_LOADED = 1524;
  exports.ER_WRONG_VALUE = 1525;
  exports.ER_NO_PARTITION_FOR_GIVEN_VALUE = 1526;
  exports.ER_FILEGROUP_OPTION_ONLY_ONCE = 1527;
  exports.ER_CREATE_FILEGROUP_FAILED = 1528;
  exports.ER_DROP_FILEGROUP_FAILED = 1529;
  exports.ER_TABLESPACE_AUTO_EXTEND_ERROR = 1530;
  exports.ER_WRONG_SIZE_NUMBER = 1531;
  exports.ER_SIZE_OVERFLOW_ERROR = 1532;
  exports.ER_ALTER_FILEGROUP_FAILED = 1533;
  exports.ER_BINLOG_ROW_LOGGING_FAILED = 1534;
  exports.ER_BINLOG_ROW_WRONG_TABLE_DEF = 1535;
  exports.ER_BINLOG_ROW_RBR_TO_SBR = 1536;
  exports.ER_EVENT_ALREADY_EXISTS = 1537;
  exports.ER_EVENT_STORE_FAILED = 1538;
  exports.ER_EVENT_DOES_NOT_EXIST = 1539;
  exports.ER_EVENT_CANT_ALTER = 1540;
  exports.ER_EVENT_DROP_FAILED = 1541;
  exports.ER_EVENT_INTERVAL_NOT_POSITIVE_OR_TOO_BIG = 1542;
  exports.ER_EVENT_ENDS_BEFORE_STARTS = 1543;
  exports.ER_EVENT_EXEC_TIME_IN_THE_PAST = 1544;
  exports.ER_EVENT_OPEN_TABLE_FAILED = 1545;
  exports.ER_EVENT_NEITHER_M_EXPR_NOR_M_AT = 1546;
  exports.ER_COL_COUNT_DOESNT_MATCH_CORRUPTED = 1547;
  exports.ER_CANNOT_LOAD_FROM_TABLE = 1548;
  exports.ER_EVENT_CANNOT_DELETE = 1549;
  exports.ER_EVENT_COMPILE_ERROR = 1550;
  exports.ER_EVENT_SAME_NAME = 1551;
  exports.ER_EVENT_DATA_TOO_LONG = 1552;
  exports.ER_DROP_INDEX_FK = 1553;
  exports.ER_WARN_DEPRECATED_SYNTAX_WITH_VER = 1554;
  exports.ER_CANT_WRITE_LOCK_LOG_TABLE = 1555;
  exports.ER_CANT_LOCK_LOG_TABLE = 1556;
  exports.ER_FOREIGN_DUPLICATE_KEY = 1557;
  exports.ER_COL_COUNT_DOESNT_MATCH_PLEASE_UPDATE = 1558;
  exports.ER_TEMP_TABLE_PREVENTS_SWITCH_OUT_OF_RBR = 1559;
  exports.ER_STORED_FUNCTION_PREVENTS_SWITCH_BINLOG_FORMAT = 1560;
  exports.ER_NDB_CANT_SWITCH_BINLOG_FORMAT = 1561;
  exports.ER_PARTITION_NO_TEMPORARY = 1562;
  exports.ER_PARTITION_CONST_DOMAIN_ERROR = 1563;
  exports.ER_PARTITION_FUNCTION_IS_NOT_ALLOWED = 1564;
  exports.ER_DDL_LOG_ERROR = 1565;
  exports.ER_NULL_IN_VALUES_LESS_THAN = 1566;
  exports.ER_WRONG_PARTITION_NAME = 1567;
  exports.ER_CANT_CHANGE_TX_CHARACTERISTICS = 1568;
  exports.ER_DUP_ENTRY_AUTOINCREMENT_CASE = 1569;
  exports.ER_EVENT_MODIFY_QUEUE_ERROR = 1570;
  exports.ER_EVENT_SET_VAR_ERROR = 1571;
  exports.ER_PARTITION_MERGE_ERROR = 1572;
  exports.ER_CANT_ACTIVATE_LOG = 1573;
  exports.ER_RBR_NOT_AVAILABLE = 1574;
  exports.ER_BASE64_DECODE_ERROR = 1575;
  exports.ER_EVENT_RECURSION_FORBIDDEN = 1576;
  exports.ER_EVENTS_DB_ERROR = 1577;
  exports.ER_ONLY_INTEGERS_ALLOWED = 1578;
  exports.ER_UNSUPORTED_LOG_ENGINE = 1579;
  exports.ER_BAD_LOG_STATEMENT = 1580;
  exports.ER_CANT_RENAME_LOG_TABLE = 1581;
  exports.ER_WRONG_PARAMCOUNT_TO_NATIVE_FCT = 1582;
  exports.ER_WRONG_PARAMETERS_TO_NATIVE_FCT = 1583;
  exports.ER_WRONG_PARAMETERS_TO_STORED_FCT = 1584;
  exports.ER_NATIVE_FCT_NAME_COLLISION = 1585;
  exports.ER_DUP_ENTRY_WITH_KEY_NAME = 1586;
  exports.ER_BINLOG_PURGE_EMFILE = 1587;
  exports.ER_EVENT_CANNOT_CREATE_IN_THE_PAST = 1588;
  exports.ER_EVENT_CANNOT_ALTER_IN_THE_PAST = 1589;
  exports.ER_SLAVE_INCIDENT = 1590;
  exports.ER_NO_PARTITION_FOR_GIVEN_VALUE_SILENT = 1591;
  exports.ER_BINLOG_UNSAFE_STATEMENT = 1592;
  exports.ER_BINLOG_FATAL_ERROR = 1593;
  exports.ER_SLAVE_RELAY_LOG_READ_FAILURE = 1594;
  exports.ER_SLAVE_RELAY_LOG_WRITE_FAILURE = 1595;
  exports.ER_SLAVE_CREATE_EVENT_FAILURE = 1596;
  exports.ER_SLAVE_MASTER_COM_FAILURE = 1597;
  exports.ER_BINLOG_LOGGING_IMPOSSIBLE = 1598;
  exports.ER_VIEW_NO_CREATION_CTX = 1599;
  exports.ER_VIEW_INVALID_CREATION_CTX = 1600;
  exports.ER_SR_INVALID_CREATION_CTX = 1601;
  exports.ER_TRG_CORRUPTED_FILE = 1602;
  exports.ER_TRG_NO_CREATION_CTX = 1603;
  exports.ER_TRG_INVALID_CREATION_CTX = 1604;
  exports.ER_EVENT_INVALID_CREATION_CTX = 1605;
  exports.ER_TRG_CANT_OPEN_TABLE = 1606;
  exports.ER_CANT_CREATE_SROUTINE = 1607;
  exports.ER_NEVER_USED = 1608;
  exports.ER_NO_FORMAT_DESCRIPTION_EVENT_BEFORE_BINLOG_STATEMENT = 1609;
  exports.ER_REPLICA_CORRUPT_EVENT = 1610;
  exports.ER_LOAD_DATA_INVALID_COLUMN = 1611;
  exports.ER_LOG_PURGE_NO_FILE = 1612;
  exports.ER_XA_RBTIMEOUT = 1613;
  exports.ER_XA_RBDEADLOCK = 1614;
  exports.ER_NEED_REPREPARE = 1615;
  exports.ER_DELAYED_NOT_SUPPORTED = 1616;
  exports.WARN_NO_CONNECTION_METADATA = 1617;
  exports.WARN_OPTION_IGNORED = 1618;
  exports.ER_PLUGIN_DELETE_BUILTIN = 1619;
  exports.WARN_PLUGIN_BUSY = 1620;
  exports.ER_VARIABLE_IS_READONLY = 1621;
  exports.ER_WARN_ENGINE_TRANSACTION_ROLLBACK = 1622;
  exports.ER_SLAVE_HEARTBEAT_FAILURE = 1623;
  exports.ER_REPLICA_HEARTBEAT_VALUE_OUT_OF_RANGE = 1624;
  exports.ER_NDB_REPLICATION_SCHEMA_ERROR = 1625;
  exports.ER_CONFLICT_FN_PARSE_ERROR = 1626;
  exports.ER_EXCEPTIONS_WRITE_ERROR = 1627;
  exports.ER_TOO_LONG_TABLE_COMMENT = 1628;
  exports.ER_TOO_LONG_FIELD_COMMENT = 1629;
  exports.ER_FUNC_INEXISTENT_NAME_COLLISION = 1630;
  exports.ER_DATABASE_NAME = 1631;
  exports.ER_TABLE_NAME = 1632;
  exports.ER_PARTITION_NAME = 1633;
  exports.ER_SUBPARTITION_NAME = 1634;
  exports.ER_TEMPORARY_NAME = 1635;
  exports.ER_RENAMED_NAME = 1636;
  exports.ER_TOO_MANY_CONCURRENT_TRXS = 1637;
  exports.WARN_NON_ASCII_SEPARATOR_NOT_IMPLEMENTED = 1638;
  exports.ER_DEBUG_SYNC_TIMEOUT = 1639;
  exports.ER_DEBUG_SYNC_HIT_LIMIT = 1640;
  exports.ER_DUP_SIGNAL_SET = 1641;
  exports.ER_SIGNAL_WARN = 1642;
  exports.ER_SIGNAL_NOT_FOUND = 1643;
  exports.ER_SIGNAL_EXCEPTION = 1644;
  exports.ER_RESIGNAL_WITHOUT_ACTIVE_HANDLER = 1645;
  exports.ER_SIGNAL_BAD_CONDITION_TYPE = 1646;
  exports.WARN_COND_ITEM_TRUNCATED = 1647;
  exports.ER_COND_ITEM_TOO_LONG = 1648;
  exports.ER_UNKNOWN_LOCALE = 1649;
  exports.ER_REPLICA_IGNORE_SERVER_IDS = 1650;
  exports.ER_QUERY_CACHE_DISABLED = 1651;
  exports.ER_SAME_NAME_PARTITION_FIELD = 1652;
  exports.ER_PARTITION_COLUMN_LIST_ERROR = 1653;
  exports.ER_WRONG_TYPE_COLUMN_VALUE_ERROR = 1654;
  exports.ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR = 1655;
  exports.ER_MAXVALUE_IN_VALUES_IN = 1656;
  exports.ER_TOO_MANY_VALUES_ERROR = 1657;
  exports.ER_ROW_SINGLE_PARTITION_FIELD_ERROR = 1658;
  exports.ER_FIELD_TYPE_NOT_ALLOWED_AS_PARTITION_FIELD = 1659;
  exports.ER_PARTITION_FIELDS_TOO_LONG = 1660;
  exports.ER_BINLOG_ROW_ENGINE_AND_STMT_ENGINE = 1661;
  exports.ER_BINLOG_ROW_MODE_AND_STMT_ENGINE = 1662;
  exports.ER_BINLOG_UNSAFE_AND_STMT_ENGINE = 1663;
  exports.ER_BINLOG_ROW_INJECTION_AND_STMT_ENGINE = 1664;
  exports.ER_BINLOG_STMT_MODE_AND_ROW_ENGINE = 1665;
  exports.ER_BINLOG_ROW_INJECTION_AND_STMT_MODE = 1666;
  exports.ER_BINLOG_MULTIPLE_ENGINES_AND_SELF_LOGGING_ENGINE = 1667;
  exports.ER_BINLOG_UNSAFE_LIMIT = 1668;
  exports.ER_UNUSED4 = 1669;
  exports.ER_BINLOG_UNSAFE_SYSTEM_TABLE = 1670;
  exports.ER_BINLOG_UNSAFE_AUTOINC_COLUMNS = 1671;
  exports.ER_BINLOG_UNSAFE_UDF = 1672;
  exports.ER_BINLOG_UNSAFE_SYSTEM_VARIABLE = 1673;
  exports.ER_BINLOG_UNSAFE_SYSTEM_FUNCTION = 1674;
  exports.ER_BINLOG_UNSAFE_NONTRANS_AFTER_TRANS = 1675;
  exports.ER_MESSAGE_AND_STATEMENT = 1676;
  exports.ER_SLAVE_CONVERSION_FAILED = 1677;
  exports.ER_REPLICA_CANT_CREATE_CONVERSION = 1678;
  exports.ER_INSIDE_TRANSACTION_PREVENTS_SWITCH_BINLOG_FORMAT = 1679;
  exports.ER_PATH_LENGTH = 1680;
  exports.ER_WARN_DEPRECATED_SYNTAX_NO_REPLACEMENT = 1681;
  exports.ER_WRONG_NATIVE_TABLE_STRUCTURE = 1682;
  exports.ER_WRONG_PERFSCHEMA_USAGE = 1683;
  exports.ER_WARN_I_S_SKIPPED_TABLE = 1684;
  exports.ER_INSIDE_TRANSACTION_PREVENTS_SWITCH_BINLOG_DIRECT = 1685;
  exports.ER_STORED_FUNCTION_PREVENTS_SWITCH_BINLOG_DIRECT = 1686;
  exports.ER_SPATIAL_MUST_HAVE_GEOM_COL = 1687;
  exports.ER_TOO_LONG_INDEX_COMMENT = 1688;
  exports.ER_LOCK_ABORTED = 1689;
  exports.ER_DATA_OUT_OF_RANGE = 1690;
  exports.ER_WRONG_SPVAR_TYPE_IN_LIMIT = 1691;
  exports.ER_BINLOG_UNSAFE_MULTIPLE_ENGINES_AND_SELF_LOGGING_ENGINE = 1692;
  exports.ER_BINLOG_UNSAFE_MIXED_STATEMENT = 1693;
  exports.ER_INSIDE_TRANSACTION_PREVENTS_SWITCH_SQL_LOG_BIN = 1694;
  exports.ER_STORED_FUNCTION_PREVENTS_SWITCH_SQL_LOG_BIN = 1695;
  exports.ER_FAILED_READ_FROM_PAR_FILE = 1696;
  exports.ER_VALUES_IS_NOT_INT_TYPE_ERROR = 1697;
  exports.ER_ACCESS_DENIED_NO_PASSWORD_ERROR = 1698;
  exports.ER_SET_PASSWORD_AUTH_PLUGIN = 1699;
  exports.ER_GRANT_PLUGIN_USER_EXISTS = 1700;
  exports.ER_TRUNCATE_ILLEGAL_FK = 1701;
  exports.ER_PLUGIN_IS_PERMANENT = 1702;
  exports.ER_REPLICA_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN = 1703;
  exports.ER_REPLICA_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX = 1704;
  exports.ER_STMT_CACHE_FULL = 1705;
  exports.ER_MULTI_UPDATE_KEY_CONFLICT = 1706;
  exports.ER_TABLE_NEEDS_REBUILD = 1707;
  exports.WARN_OPTION_BELOW_LIMIT = 1708;
  exports.ER_INDEX_COLUMN_TOO_LONG = 1709;
  exports.ER_ERROR_IN_TRIGGER_BODY = 1710;
  exports.ER_ERROR_IN_UNKNOWN_TRIGGER_BODY = 1711;
  exports.ER_INDEX_CORRUPT = 1712;
  exports.ER_UNDO_RECORD_TOO_BIG = 1713;
  exports.ER_BINLOG_UNSAFE_INSERT_IGNORE_SELECT = 1714;
  exports.ER_BINLOG_UNSAFE_INSERT_SELECT_UPDATE = 1715;
  exports.ER_BINLOG_UNSAFE_REPLACE_SELECT = 1716;
  exports.ER_BINLOG_UNSAFE_CREATE_IGNORE_SELECT = 1717;
  exports.ER_BINLOG_UNSAFE_CREATE_REPLACE_SELECT = 1718;
  exports.ER_BINLOG_UNSAFE_UPDATE_IGNORE = 1719;
  exports.ER_PLUGIN_NO_UNINSTALL = 1720;
  exports.ER_PLUGIN_NO_INSTALL = 1721;
  exports.ER_BINLOG_UNSAFE_WRITE_AUTOINC_SELECT = 1722;
  exports.ER_BINLOG_UNSAFE_CREATE_SELECT_AUTOINC = 1723;
  exports.ER_BINLOG_UNSAFE_INSERT_TWO_KEYS = 1724;
  exports.ER_TABLE_IN_FK_CHECK = 1725;
  exports.ER_UNSUPPORTED_ENGINE = 1726;
  exports.ER_BINLOG_UNSAFE_AUTOINC_NOT_FIRST = 1727;
  exports.ER_CANNOT_LOAD_FROM_TABLE_V2 = 1728;
  exports.ER_SOURCE_DELAY_VALUE_OUT_OF_RANGE = 1729;
  exports.ER_ONLY_FD_AND_RBR_EVENTS_ALLOWED_IN_BINLOG_STATEMENT = 1730;
  exports.ER_PARTITION_EXCHANGE_DIFFERENT_OPTION = 1731;
  exports.ER_PARTITION_EXCHANGE_PART_TABLE = 1732;
  exports.ER_PARTITION_EXCHANGE_TEMP_TABLE = 1733;
  exports.ER_PARTITION_INSTEAD_OF_SUBPARTITION = 1734;
  exports.ER_UNKNOWN_PARTITION = 1735;
  exports.ER_TABLES_DIFFERENT_METADATA = 1736;
  exports.ER_ROW_DOES_NOT_MATCH_PARTITION = 1737;
  exports.ER_BINLOG_CACHE_SIZE_GREATER_THAN_MAX = 1738;
  exports.ER_WARN_INDEX_NOT_APPLICABLE = 1739;
  exports.ER_PARTITION_EXCHANGE_FOREIGN_KEY = 1740;
  exports.ER_NO_SUCH_KEY_VALUE = 1741;
  exports.ER_RPL_INFO_DATA_TOO_LONG = 1742;
  exports.ER_NETWORK_READ_EVENT_CHECKSUM_FAILURE = 1743;
  exports.ER_BINLOG_READ_EVENT_CHECKSUM_FAILURE = 1744;
  exports.ER_BINLOG_STMT_CACHE_SIZE_GREATER_THAN_MAX = 1745;
  exports.ER_CANT_UPDATE_TABLE_IN_CREATE_TABLE_SELECT = 1746;
  exports.ER_PARTITION_CLAUSE_ON_NONPARTITIONED = 1747;
  exports.ER_ROW_DOES_NOT_MATCH_GIVEN_PARTITION_SET = 1748;
  exports.ER_NO_SUCH_PARTITION = 1749;
  exports.ER_CHANGE_RPL_INFO_REPOSITORY_FAILURE = 1750;
  exports.ER_WARNING_NOT_COMPLETE_ROLLBACK_WITH_CREATED_TEMP_TABLE = 1751;
  exports.ER_WARNING_NOT_COMPLETE_ROLLBACK_WITH_DROPPED_TEMP_TABLE = 1752;
  exports.ER_MTA_FEATURE_IS_NOT_SUPPORTED = 1753;
  exports.ER_MTA_UPDATED_DBS_GREATER_MAX = 1754;
  exports.ER_MTA_CANT_PARALLEL = 1755;
  exports.ER_MTA_INCONSISTENT_DATA = 1756;
  exports.ER_FULLTEXT_NOT_SUPPORTED_WITH_PARTITIONING = 1757;
  exports.ER_DA_INVALID_CONDITION_NUMBER = 1758;
  exports.ER_INSECURE_PLAIN_TEXT = 1759;
  exports.ER_INSECURE_CHANGE_SOURCE = 1760;
  exports.ER_FOREIGN_DUPLICATE_KEY_WITH_CHILD_INFO = 1761;
  exports.ER_FOREIGN_DUPLICATE_KEY_WITHOUT_CHILD_INFO = 1762;
  exports.ER_SQLTHREAD_WITH_SECURE_REPLICA = 1763;
  exports.ER_TABLE_HAS_NO_FT = 1764;
  exports.ER_VARIABLE_NOT_SETTABLE_IN_SF_OR_TRIGGER = 1765;
  exports.ER_VARIABLE_NOT_SETTABLE_IN_TRANSACTION = 1766;
  exports.ER_GTID_NEXT_IS_NOT_IN_GTID_NEXT_LIST = 1767;
  exports.ER_CANT_CHANGE_GTID_NEXT_IN_TRANSACTION = 1768;
  exports.ER_SET_STATEMENT_CANNOT_INVOKE_FUNCTION = 1769;
  exports.ER_GTID_NEXT_CANT_BE_AUTOMATIC_IF_GTID_NEXT_LIST_IS_NON_NULL = 1770;
  exports.ER_SKIPPING_LOGGED_TRANSACTION = 1771;
  exports.ER_MALFORMED_GTID_SET_SPECIFICATION = 1772;
  exports.ER_MALFORMED_GTID_SET_ENCODING = 1773;
  exports.ER_MALFORMED_GTID_SPECIFICATION = 1774;
  exports.ER_GNO_EXHAUSTED = 1775;
  exports.ER_BAD_REPLICA_AUTO_POSITION = 1776;
  exports.ER_AUTO_POSITION_REQUIRES_GTID_MODE_NOT_OFF = 1777;
  exports.ER_CANT_DO_IMPLICIT_COMMIT_IN_TRX_WHEN_GTID_NEXT_IS_SET = 1778;
  exports.ER_GTID_MODE_ON_REQUIRES_ENFORCE_GTID_CONSISTENCY_ON = 1779;
  exports.ER_GTID_MODE_REQUIRES_BINLOG = 1780;
  exports.ER_CANT_SET_GTID_NEXT_TO_GTID_WHEN_GTID_MODE_IS_OFF = 1781;
  exports.ER_CANT_SET_GTID_NEXT_TO_ANONYMOUS_WHEN_GTID_MODE_IS_ON = 1782;
  exports.ER_CANT_SET_GTID_NEXT_LIST_TO_NON_NULL_WHEN_GTID_MODE_IS_OFF = 1783;
  exports.ER_FOUND_GTID_EVENT_WHEN_GTID_MODE_IS_OFF = 1784;
  exports.ER_GTID_UNSAFE_NON_TRANSACTIONAL_TABLE = 1785;
  exports.ER_GTID_UNSAFE_CREATE_SELECT = 1786;
  exports.ER_GTID_UNSAFE_CREATE_DROP_TEMP_TABLE_IN_TRANSACTION = 1787;
  exports.ER_GTID_MODE_CAN_ONLY_CHANGE_ONE_STEP_AT_A_TIME = 1788;
  exports.ER_SOURCE_HAS_PURGED_REQUIRED_GTIDS = 1789;
  exports.ER_CANT_SET_GTID_NEXT_WHEN_OWNING_GTID = 1790;
  exports.ER_UNKNOWN_EXPLAIN_FORMAT = 1791;
  exports.ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION = 1792;
  exports.ER_TOO_LONG_TABLE_PARTITION_COMMENT = 1793;
  exports.ER_REPLICA_CONFIGURATION = 1794;
  exports.ER_INNODB_FT_LIMIT = 1795;
  exports.ER_INNODB_NO_FT_TEMP_TABLE = 1796;
  exports.ER_INNODB_FT_WRONG_DOCID_COLUMN = 1797;
  exports.ER_INNODB_FT_WRONG_DOCID_INDEX = 1798;
  exports.ER_INNODB_ONLINE_LOG_TOO_BIG = 1799;
  exports.ER_UNKNOWN_ALTER_ALGORITHM = 1800;
  exports.ER_UNKNOWN_ALTER_LOCK = 1801;
  exports.ER_MTA_CHANGE_SOURCE_CANT_RUN_WITH_GAPS = 1802;
  exports.ER_MTA_RECOVERY_FAILURE = 1803;
  exports.ER_MTA_RESET_WORKERS = 1804;
  exports.ER_COL_COUNT_DOESNT_MATCH_CORRUPTED_V2 = 1805;
  exports.ER_REPLICA_SILENT_RETRY_TRANSACTION = 1806;
  exports.ER_DISCARD_FK_CHECKS_RUNNING = 1807;
  exports.ER_TABLE_SCHEMA_MISMATCH = 1808;
  exports.ER_TABLE_IN_SYSTEM_TABLESPACE = 1809;
  exports.ER_IO_READ_ERROR = 1810;
  exports.ER_IO_WRITE_ERROR = 1811;
  exports.ER_TABLESPACE_MISSING = 1812;
  exports.ER_TABLESPACE_EXISTS = 1813;
  exports.ER_TABLESPACE_DISCARDED = 1814;
  exports.ER_INTERNAL_ERROR = 1815;
  exports.ER_INNODB_IMPORT_ERROR = 1816;
  exports.ER_INNODB_INDEX_CORRUPT = 1817;
  exports.ER_INVALID_YEAR_COLUMN_LENGTH = 1818;
  exports.ER_NOT_VALID_PASSWORD = 1819;
  exports.ER_MUST_CHANGE_PASSWORD = 1820;
  exports.ER_FK_NO_INDEX_CHILD = 1821;
  exports.ER_FK_NO_INDEX_PARENT = 1822;
  exports.ER_FK_FAIL_ADD_SYSTEM = 1823;
  exports.ER_FK_CANNOT_OPEN_PARENT = 1824;
  exports.ER_FK_INCORRECT_OPTION = 1825;
  exports.ER_FK_DUP_NAME = 1826;
  exports.ER_PASSWORD_FORMAT = 1827;
  exports.ER_FK_COLUMN_CANNOT_DROP = 1828;
  exports.ER_FK_COLUMN_CANNOT_DROP_CHILD = 1829;
  exports.ER_FK_COLUMN_NOT_NULL = 1830;
  exports.ER_DUP_INDEX = 1831;
  exports.ER_FK_COLUMN_CANNOT_CHANGE = 1832;
  exports.ER_FK_COLUMN_CANNOT_CHANGE_CHILD = 1833;
  exports.ER_UNUSED5 = 1834;
  exports.ER_MALFORMED_PACKET = 1835;
  exports.ER_READ_ONLY_MODE = 1836;
  exports.ER_GTID_NEXT_TYPE_UNDEFINED_GTID = 1837;
  exports.ER_VARIABLE_NOT_SETTABLE_IN_SP = 1838;
  exports.ER_CANT_SET_GTID_PURGED_WHEN_GTID_MODE_IS_OFF = 1839;
  exports.ER_CANT_SET_GTID_PURGED_WHEN_GTID_EXECUTED_IS_NOT_EMPTY = 1840;
  exports.ER_CANT_SET_GTID_PURGED_WHEN_OWNED_GTIDS_IS_NOT_EMPTY = 1841;
  exports.ER_GTID_PURGED_WAS_CHANGED = 1842;
  exports.ER_GTID_EXECUTED_WAS_CHANGED = 1843;
  exports.ER_BINLOG_STMT_MODE_AND_NO_REPL_TABLES = 1844;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED = 1845;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON = 1846;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_COPY = 1847;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_PARTITION = 1848;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_FK_RENAME = 1849;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_COLUMN_TYPE = 1850;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_FK_CHECK = 1851;
  exports.ER_UNUSED6 = 1852;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_NOPK = 1853;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_AUTOINC = 1854;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_HIDDEN_FTS = 1855;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_CHANGE_FTS = 1856;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_FTS = 1857;
  exports.ER_SQL_REPLICA_SKIP_COUNTER_NOT_SETTABLE_IN_GTID_MODE = 1858;
  exports.ER_DUP_UNKNOWN_IN_INDEX = 1859;
  exports.ER_IDENT_CAUSES_TOO_LONG_PATH = 1860;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_NOT_NULL = 1861;
  exports.ER_MUST_CHANGE_PASSWORD_LOGIN = 1862;
  exports.ER_ROW_IN_WRONG_PARTITION = 1863;
  exports.ER_MTA_EVENT_BIGGER_PENDING_JOBS_SIZE_MAX = 1864;
  exports.ER_INNODB_NO_FT_USES_PARSER = 1865;
  exports.ER_BINLOG_LOGICAL_CORRUPTION = 1866;
  exports.ER_WARN_PURGE_LOG_IN_USE = 1867;
  exports.ER_WARN_PURGE_LOG_IS_ACTIVE = 1868;
  exports.ER_AUTO_INCREMENT_CONFLICT = 1869;
  exports.WARN_ON_BLOCKHOLE_IN_RBR = 1870;
  exports.ER_REPLICA_CM_INIT_REPOSITORY = 1871;
  exports.ER_REPLICA_AM_INIT_REPOSITORY = 1872;
  exports.ER_ACCESS_DENIED_CHANGE_USER_ERROR = 1873;
  exports.ER_INNODB_READ_ONLY = 1874;
  exports.ER_STOP_REPLICA_SQL_THREAD_TIMEOUT = 1875;
  exports.ER_STOP_REPLICA_IO_THREAD_TIMEOUT = 1876;
  exports.ER_TABLE_CORRUPT = 1877;
  exports.ER_TEMP_FILE_WRITE_FAILURE = 1878;
  exports.ER_INNODB_FT_AUX_NOT_HEX_ID = 1879;
  exports.ER_OLD_TEMPORALS_UPGRADED = 1880;
  exports.ER_INNODB_FORCED_RECOVERY = 1881;
  exports.ER_AES_INVALID_IV = 1882;
  exports.ER_PLUGIN_CANNOT_BE_UNINSTALLED = 1883;
  exports.ER_GTID_UNSAFE_BINLOG_SPLITTABLE_STATEMENT_AND_ASSIGNED_GTID = 1884;
  exports.ER_REPLICA_HAS_MORE_GTIDS_THAN_SOURCE = 1885;
  exports.ER_MISSING_KEY = 1886;
  exports.WARN_NAMED_PIPE_ACCESS_EVERYONE = 1887;
  exports.ER_FILE_CORRUPT = 3000;
  exports.ER_ERROR_ON_SOURCE = 3001;
  exports.ER_INCONSISTENT_ERROR = 3002;
  exports.ER_STORAGE_ENGINE_NOT_LOADED = 3003;
  exports.ER_GET_STACKED_DA_WITHOUT_ACTIVE_HANDLER = 3004;
  exports.ER_WARN_LEGACY_SYNTAX_CONVERTED = 3005;
  exports.ER_BINLOG_UNSAFE_FULLTEXT_PLUGIN = 3006;
  exports.ER_CANNOT_DISCARD_TEMPORARY_TABLE = 3007;
  exports.ER_FK_DEPTH_EXCEEDED = 3008;
  exports.ER_COL_COUNT_DOESNT_MATCH_PLEASE_UPDATE_V2 = 3009;
  exports.ER_WARN_TRIGGER_DOESNT_HAVE_CREATED = 3010;
  exports.ER_REFERENCED_TRG_DOES_NOT_EXIST = 3011;
  exports.ER_EXPLAIN_NOT_SUPPORTED = 3012;
  exports.ER_INVALID_FIELD_SIZE = 3013;
  exports.ER_MISSING_HA_CREATE_OPTION = 3014;
  exports.ER_ENGINE_OUT_OF_MEMORY = 3015;
  exports.ER_PASSWORD_EXPIRE_ANONYMOUS_USER = 3016;
  exports.ER_REPLICA_SQL_THREAD_MUST_STOP = 3017;
  exports.ER_NO_FT_MATERIALIZED_SUBQUERY = 3018;
  exports.ER_INNODB_UNDO_LOG_FULL = 3019;
  exports.ER_INVALID_ARGUMENT_FOR_LOGARITHM = 3020;
  exports.ER_REPLICA_CHANNEL_IO_THREAD_MUST_STOP = 3021;
  exports.ER_WARN_OPEN_TEMP_TABLES_MUST_BE_ZERO = 3022;
  exports.ER_WARN_ONLY_SOURCE_LOG_FILE_NO_POS = 3023;
  exports.ER_QUERY_TIMEOUT = 3024;
  exports.ER_NON_RO_SELECT_DISABLE_TIMER = 3025;
  exports.ER_DUP_LIST_ENTRY = 3026;
  exports.ER_SQL_MODE_NO_EFFECT = 3027;
  exports.ER_AGGREGATE_ORDER_FOR_UNION = 3028;
  exports.ER_AGGREGATE_ORDER_NON_AGG_QUERY = 3029;
  exports.ER_REPLICA_WORKER_STOPPED_PREVIOUS_THD_ERROR = 3030;
  exports.ER_DONT_SUPPORT_REPLICA_PRESERVE_COMMIT_ORDER = 3031;
  exports.ER_SERVER_OFFLINE_MODE = 3032;
  exports.ER_GIS_DIFFERENT_SRIDS = 3033;
  exports.ER_GIS_UNSUPPORTED_ARGUMENT = 3034;
  exports.ER_GIS_UNKNOWN_ERROR = 3035;
  exports.ER_GIS_UNKNOWN_EXCEPTION = 3036;
  exports.ER_GIS_INVALID_DATA = 3037;
  exports.ER_BOOST_GEOMETRY_EMPTY_INPUT_EXCEPTION = 3038;
  exports.ER_BOOST_GEOMETRY_CENTROID_EXCEPTION = 3039;
  exports.ER_BOOST_GEOMETRY_OVERLAY_INVALID_INPUT_EXCEPTION = 3040;
  exports.ER_BOOST_GEOMETRY_TURN_INFO_EXCEPTION = 3041;
  exports.ER_BOOST_GEOMETRY_SELF_INTERSECTION_POINT_EXCEPTION = 3042;
  exports.ER_BOOST_GEOMETRY_UNKNOWN_EXCEPTION = 3043;
  exports.ER_STD_BAD_ALLOC_ERROR = 3044;
  exports.ER_STD_DOMAIN_ERROR = 3045;
  exports.ER_STD_LENGTH_ERROR = 3046;
  exports.ER_STD_INVALID_ARGUMENT = 3047;
  exports.ER_STD_OUT_OF_RANGE_ERROR = 3048;
  exports.ER_STD_OVERFLOW_ERROR = 3049;
  exports.ER_STD_RANGE_ERROR = 3050;
  exports.ER_STD_UNDERFLOW_ERROR = 3051;
  exports.ER_STD_LOGIC_ERROR = 3052;
  exports.ER_STD_RUNTIME_ERROR = 3053;
  exports.ER_STD_UNKNOWN_EXCEPTION = 3054;
  exports.ER_GIS_DATA_WRONG_ENDIANESS = 3055;
  exports.ER_CHANGE_SOURCE_PASSWORD_LENGTH = 3056;
  exports.ER_USER_LOCK_WRONG_NAME = 3057;
  exports.ER_USER_LOCK_DEADLOCK = 3058;
  exports.ER_REPLACE_INACCESSIBLE_ROWS = 3059;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_GIS = 3060;
  exports.ER_ILLEGAL_USER_VAR = 3061;
  exports.ER_GTID_MODE_OFF = 3062;
  exports.ER_UNSUPPORTED_BY_REPLICATION_THREAD = 3063;
  exports.ER_INCORRECT_TYPE = 3064;
  exports.ER_FIELD_IN_ORDER_NOT_SELECT = 3065;
  exports.ER_AGGREGATE_IN_ORDER_NOT_SELECT = 3066;
  exports.ER_INVALID_RPL_WILD_TABLE_FILTER_PATTERN = 3067;
  exports.ER_NET_OK_PACKET_TOO_LARGE = 3068;
  exports.ER_INVALID_JSON_DATA = 3069;
  exports.ER_INVALID_GEOJSON_MISSING_MEMBER = 3070;
  exports.ER_INVALID_GEOJSON_WRONG_TYPE = 3071;
  exports.ER_INVALID_GEOJSON_UNSPECIFIED = 3072;
  exports.ER_DIMENSION_UNSUPPORTED = 3073;
  exports.ER_REPLICA_CHANNEL_DOES_NOT_EXIST = 3074;
  exports.ER_SLAVE_MULTIPLE_CHANNELS_HOST_PORT = 3075;
  exports.ER_REPLICA_CHANNEL_NAME_INVALID_OR_TOO_LONG = 3076;
  exports.ER_REPLICA_NEW_CHANNEL_WRONG_REPOSITORY = 3077;
  exports.ER_SLAVE_CHANNEL_DELETE = 3078;
  exports.ER_REPLICA_MULTIPLE_CHANNELS_CMD = 3079;
  exports.ER_REPLICA_MAX_CHANNELS_EXCEEDED = 3080;
  exports.ER_REPLICA_CHANNEL_MUST_STOP = 3081;
  exports.ER_REPLICA_CHANNEL_NOT_RUNNING = 3082;
  exports.ER_REPLICA_CHANNEL_WAS_RUNNING = 3083;
  exports.ER_REPLICA_CHANNEL_WAS_NOT_RUNNING = 3084;
  exports.ER_REPLICA_CHANNEL_SQL_THREAD_MUST_STOP = 3085;
  exports.ER_REPLICA_CHANNEL_SQL_SKIP_COUNTER = 3086;
  exports.ER_WRONG_FIELD_WITH_GROUP_V2 = 3087;
  exports.ER_MIX_OF_GROUP_FUNC_AND_FIELDS_V2 = 3088;
  exports.ER_WARN_DEPRECATED_SYSVAR_UPDATE = 3089;
  exports.ER_WARN_DEPRECATED_SQLMODE = 3090;
  exports.ER_CANNOT_LOG_PARTIAL_DROP_DATABASE_WITH_GTID = 3091;
  exports.ER_GROUP_REPLICATION_CONFIGURATION = 3092;
  exports.ER_GROUP_REPLICATION_RUNNING = 3093;
  exports.ER_GROUP_REPLICATION_APPLIER_INIT_ERROR = 3094;
  exports.ER_GROUP_REPLICATION_STOP_APPLIER_THREAD_TIMEOUT = 3095;
  exports.ER_GROUP_REPLICATION_COMMUNICATION_LAYER_SESSION_ERROR = 3096;
  exports.ER_GROUP_REPLICATION_COMMUNICATION_LAYER_JOIN_ERROR = 3097;
  exports.ER_BEFORE_DML_VALIDATION_ERROR = 3098;
  exports.ER_PREVENTS_VARIABLE_WITHOUT_RBR = 3099;
  exports.ER_RUN_HOOK_ERROR = 3100;
  exports.ER_TRANSACTION_ROLLBACK_DURING_COMMIT = 3101;
  exports.ER_GENERATED_COLUMN_FUNCTION_IS_NOT_ALLOWED = 3102;
  exports.ER_UNSUPPORTED_ALTER_INPLACE_ON_VIRTUAL_COLUMN = 3103;
  exports.ER_WRONG_FK_OPTION_FOR_GENERATED_COLUMN = 3104;
  exports.ER_NON_DEFAULT_VALUE_FOR_GENERATED_COLUMN = 3105;
  exports.ER_UNSUPPORTED_ACTION_ON_GENERATED_COLUMN = 3106;
  exports.ER_GENERATED_COLUMN_NON_PRIOR = 3107;
  exports.ER_DEPENDENT_BY_GENERATED_COLUMN = 3108;
  exports.ER_GENERATED_COLUMN_REF_AUTO_INC = 3109;
  exports.ER_FEATURE_NOT_AVAILABLE = 3110;
  exports.ER_CANT_SET_GTID_MODE = 3111;
  exports.ER_CANT_USE_AUTO_POSITION_WITH_GTID_MODE_OFF = 3112;
  exports.ER_CANT_REPLICATE_ANONYMOUS_WITH_AUTO_POSITION = 3113;
  exports.ER_CANT_REPLICATE_ANONYMOUS_WITH_GTID_MODE_ON = 3114;
  exports.ER_CANT_REPLICATE_GTID_WITH_GTID_MODE_OFF = 3115;
  exports.ER_CANT_ENFORCE_GTID_CONSISTENCY_WITH_ONGOING_GTID_VIOLATING_TX = 3116;
  exports.ER_ENFORCE_GTID_CONSISTENCY_WARN_WITH_ONGOING_GTID_VIOLATING_TX = 3117;
  exports.ER_ACCOUNT_HAS_BEEN_LOCKED = 3118;
  exports.ER_WRONG_TABLESPACE_NAME = 3119;
  exports.ER_TABLESPACE_IS_NOT_EMPTY = 3120;
  exports.ER_WRONG_FILE_NAME = 3121;
  exports.ER_BOOST_GEOMETRY_INCONSISTENT_TURNS_EXCEPTION = 3122;
  exports.ER_WARN_OPTIMIZER_HINT_SYNTAX_ERROR = 3123;
  exports.ER_WARN_BAD_MAX_EXECUTION_TIME = 3124;
  exports.ER_WARN_UNSUPPORTED_MAX_EXECUTION_TIME = 3125;
  exports.ER_WARN_CONFLICTING_HINT = 3126;
  exports.ER_WARN_UNKNOWN_QB_NAME = 3127;
  exports.ER_UNRESOLVED_HINT_NAME = 3128;
  exports.ER_WARN_ON_MODIFYING_GTID_EXECUTED_TABLE = 3129;
  exports.ER_PLUGGABLE_PROTOCOL_COMMAND_NOT_SUPPORTED = 3130;
  exports.ER_LOCKING_SERVICE_WRONG_NAME = 3131;
  exports.ER_LOCKING_SERVICE_DEADLOCK = 3132;
  exports.ER_LOCKING_SERVICE_TIMEOUT = 3133;
  exports.ER_GIS_MAX_POINTS_IN_GEOMETRY_OVERFLOWED = 3134;
  exports.ER_SQL_MODE_MERGED = 3135;
  exports.ER_VTOKEN_PLUGIN_TOKEN_MISMATCH = 3136;
  exports.ER_VTOKEN_PLUGIN_TOKEN_NOT_FOUND = 3137;
  exports.ER_CANT_SET_VARIABLE_WHEN_OWNING_GTID = 3138;
  exports.ER_REPLICA_CHANNEL_OPERATION_NOT_ALLOWED = 3139;
  exports.ER_INVALID_JSON_TEXT = 3140;
  exports.ER_INVALID_JSON_TEXT_IN_PARAM = 3141;
  exports.ER_INVALID_JSON_BINARY_DATA = 3142;
  exports.ER_INVALID_JSON_PATH = 3143;
  exports.ER_INVALID_JSON_CHARSET = 3144;
  exports.ER_INVALID_JSON_CHARSET_IN_FUNCTION = 3145;
  exports.ER_INVALID_TYPE_FOR_JSON = 3146;
  exports.ER_INVALID_CAST_TO_JSON = 3147;
  exports.ER_INVALID_JSON_PATH_CHARSET = 3148;
  exports.ER_INVALID_JSON_PATH_WILDCARD = 3149;
  exports.ER_JSON_VALUE_TOO_BIG = 3150;
  exports.ER_JSON_KEY_TOO_BIG = 3151;
  exports.ER_JSON_USED_AS_KEY = 3152;
  exports.ER_JSON_VACUOUS_PATH = 3153;
  exports.ER_JSON_BAD_ONE_OR_ALL_ARG = 3154;
  exports.ER_NUMERIC_JSON_VALUE_OUT_OF_RANGE = 3155;
  exports.ER_INVALID_JSON_VALUE_FOR_CAST = 3156;
  exports.ER_JSON_DOCUMENT_TOO_DEEP = 3157;
  exports.ER_JSON_DOCUMENT_NULL_KEY = 3158;
  exports.ER_SECURE_TRANSPORT_REQUIRED = 3159;
  exports.ER_NO_SECURE_TRANSPORTS_CONFIGURED = 3160;
  exports.ER_DISABLED_STORAGE_ENGINE = 3161;
  exports.ER_USER_DOES_NOT_EXIST = 3162;
  exports.ER_USER_ALREADY_EXISTS = 3163;
  exports.ER_AUDIT_API_ABORT = 3164;
  exports.ER_INVALID_JSON_PATH_ARRAY_CELL = 3165;
  exports.ER_BUFPOOL_RESIZE_INPROGRESS = 3166;
  exports.ER_FEATURE_DISABLED_SEE_DOC = 3167;
  exports.ER_SERVER_ISNT_AVAILABLE = 3168;
  exports.ER_SESSION_WAS_KILLED = 3169;
  exports.ER_CAPACITY_EXCEEDED = 3170;
  exports.ER_CAPACITY_EXCEEDED_IN_RANGE_OPTIMIZER = 3171;
  exports.ER_TABLE_NEEDS_UPG_PART = 3172;
  exports.ER_CANT_WAIT_FOR_EXECUTED_GTID_SET_WHILE_OWNING_A_GTID = 3173;
  exports.ER_CANNOT_ADD_FOREIGN_BASE_COL_VIRTUAL = 3174;
  exports.ER_CANNOT_CREATE_VIRTUAL_INDEX_CONSTRAINT = 3175;
  exports.ER_ERROR_ON_MODIFYING_GTID_EXECUTED_TABLE = 3176;
  exports.ER_LOCK_REFUSED_BY_ENGINE = 3177;
  exports.ER_UNSUPPORTED_ALTER_ONLINE_ON_VIRTUAL_COLUMN = 3178;
  exports.ER_MASTER_KEY_ROTATION_NOT_SUPPORTED_BY_SE = 3179;
  exports.ER_MASTER_KEY_ROTATION_ERROR_BY_SE = 3180;
  exports.ER_MASTER_KEY_ROTATION_BINLOG_FAILED = 3181;
  exports.ER_MASTER_KEY_ROTATION_SE_UNAVAILABLE = 3182;
  exports.ER_TABLESPACE_CANNOT_ENCRYPT = 3183;
  exports.ER_INVALID_ENCRYPTION_OPTION = 3184;
  exports.ER_CANNOT_FIND_KEY_IN_KEYRING = 3185;
  exports.ER_CAPACITY_EXCEEDED_IN_PARSER = 3186;
  exports.ER_UNSUPPORTED_ALTER_ENCRYPTION_INPLACE = 3187;
  exports.ER_KEYRING_UDF_KEYRING_SERVICE_ERROR = 3188;
  exports.ER_USER_COLUMN_OLD_LENGTH = 3189;
  exports.ER_CANT_RESET_SOURCE = 3190;
  exports.ER_GROUP_REPLICATION_MAX_GROUP_SIZE = 3191;
  exports.ER_CANNOT_ADD_FOREIGN_BASE_COL_STORED = 3192;
  exports.ER_TABLE_REFERENCED = 3193;
  exports.ER_PARTITION_ENGINE_DEPRECATED_FOR_TABLE = 3194;
  exports.ER_WARN_USING_GEOMFROMWKB_TO_SET_SRID_ZERO = 3195;
  exports.ER_WARN_USING_GEOMFROMWKB_TO_SET_SRID = 3196;
  exports.ER_XA_RETRY = 3197;
  exports.ER_KEYRING_AWS_UDF_AWS_KMS_ERROR = 3198;
  exports.ER_BINLOG_UNSAFE_XA = 3199;
  exports.ER_UDF_ERROR = 3200;
  exports.ER_KEYRING_MIGRATION_FAILURE = 3201;
  exports.ER_KEYRING_ACCESS_DENIED_ERROR = 3202;
  exports.ER_KEYRING_MIGRATION_STATUS = 3203;
  exports.ER_PLUGIN_FAILED_TO_OPEN_TABLES = 3204;
  exports.ER_PLUGIN_FAILED_TO_OPEN_TABLE = 3205;
  exports.ER_AUDIT_LOG_NO_KEYRING_PLUGIN_INSTALLED = 3206;
  exports.ER_AUDIT_LOG_ENCRYPTION_PASSWORD_HAS_NOT_BEEN_SET = 3207;
  exports.ER_AUDIT_LOG_COULD_NOT_CREATE_AES_KEY = 3208;
  exports.ER_AUDIT_LOG_ENCRYPTION_PASSWORD_CANNOT_BE_FETCHED = 3209;
  exports.ER_AUDIT_LOG_JSON_FILTERING_NOT_ENABLED = 3210;
  exports.ER_AUDIT_LOG_UDF_INSUFFICIENT_PRIVILEGE = 3211;
  exports.ER_AUDIT_LOG_SUPER_PRIVILEGE_REQUIRED = 3212;
  exports.ER_COULD_NOT_REINITIALIZE_AUDIT_LOG_FILTERS = 3213;
  exports.ER_AUDIT_LOG_UDF_INVALID_ARGUMENT_TYPE = 3214;
  exports.ER_AUDIT_LOG_UDF_INVALID_ARGUMENT_COUNT = 3215;
  exports.ER_AUDIT_LOG_HAS_NOT_BEEN_INSTALLED = 3216;
  exports.ER_AUDIT_LOG_UDF_READ_INVALID_MAX_ARRAY_LENGTH_ARG_TYPE = 3217;
  exports.ER_AUDIT_LOG_UDF_READ_INVALID_MAX_ARRAY_LENGTH_ARG_VALUE = 3218;
  exports.ER_AUDIT_LOG_JSON_FILTER_PARSING_ERROR = 3219;
  exports.ER_AUDIT_LOG_JSON_FILTER_NAME_CANNOT_BE_EMPTY = 3220;
  exports.ER_AUDIT_LOG_JSON_USER_NAME_CANNOT_BE_EMPTY = 3221;
  exports.ER_AUDIT_LOG_JSON_FILTER_DOES_NOT_EXISTS = 3222;
  exports.ER_AUDIT_LOG_USER_FIRST_CHARACTER_MUST_BE_ALPHANUMERIC = 3223;
  exports.ER_AUDIT_LOG_USER_NAME_INVALID_CHARACTER = 3224;
  exports.ER_AUDIT_LOG_HOST_NAME_INVALID_CHARACTER = 3225;
  exports.WARN_DEPRECATED_MAXDB_SQL_MODE_FOR_TIMESTAMP = 3226;
  exports.ER_XA_REPLICATION_FILTERS = 3227;
  exports.ER_CANT_OPEN_ERROR_LOG = 3228;
  exports.ER_GROUPING_ON_TIMESTAMP_IN_DST = 3229;
  exports.ER_CANT_START_SERVER_NAMED_PIPE = 3230;
  exports.ER_WRITE_SET_EXCEEDS_LIMIT = 3231;
  exports.ER_DEPRECATED_TLS_VERSION_SESSION_57 = 3232;
  exports.ER_WARN_DEPRECATED_TLS_VERSION_57 = 3233;
  exports.ER_WARN_WRONG_NATIVE_TABLE_STRUCTURE = 3234;
  exports.ER_AES_INVALID_KDF_NAME = 3235;
  exports.ER_AES_INVALID_KDF_ITERATIONS = 3236;
  exports.WARN_AES_KEY_SIZE = 3237;
  exports.ER_AES_INVALID_KDF_OPTION_SIZE = 3238;
  exports.ER_UNSUPPORT_COMPRESSED_TEMPORARY_TABLE = 3500;
  exports.ER_ACL_OPERATION_FAILED = 3501;
  exports.ER_UNSUPPORTED_INDEX_ALGORITHM = 3502;
  exports.ER_NO_SUCH_DB = 3503;
  exports.ER_TOO_BIG_ENUM = 3504;
  exports.ER_TOO_LONG_SET_ENUM_VALUE = 3505;
  exports.ER_INVALID_DD_OBJECT = 3506;
  exports.ER_UPDATING_DD_TABLE = 3507;
  exports.ER_INVALID_DD_OBJECT_ID = 3508;
  exports.ER_INVALID_DD_OBJECT_NAME = 3509;
  exports.ER_TABLESPACE_MISSING_WITH_NAME = 3510;
  exports.ER_TOO_LONG_ROUTINE_COMMENT = 3511;
  exports.ER_SP_LOAD_FAILED = 3512;
  exports.ER_INVALID_BITWISE_OPERANDS_SIZE = 3513;
  exports.ER_INVALID_BITWISE_AGGREGATE_OPERANDS_SIZE = 3514;
  exports.ER_WARN_UNSUPPORTED_HINT = 3515;
  exports.ER_UNEXPECTED_GEOMETRY_TYPE = 3516;
  exports.ER_SRS_PARSE_ERROR = 3517;
  exports.ER_SRS_PROJ_PARAMETER_MISSING = 3518;
  exports.ER_WARN_SRS_NOT_FOUND = 3519;
  exports.ER_SRS_NOT_CARTESIAN = 3520;
  exports.ER_SRS_NOT_CARTESIAN_UNDEFINED = 3521;
  exports.ER_PK_INDEX_CANT_BE_INVISIBLE = 3522;
  exports.ER_UNKNOWN_AUTHID = 3523;
  exports.ER_FAILED_ROLE_GRANT = 3524;
  exports.ER_OPEN_ROLE_TABLES = 3525;
  exports.ER_FAILED_DEFAULT_ROLES = 3526;
  exports.ER_COMPONENTS_NO_SCHEME = 3527;
  exports.ER_COMPONENTS_NO_SCHEME_SERVICE = 3528;
  exports.ER_COMPONENTS_CANT_LOAD = 3529;
  exports.ER_ROLE_NOT_GRANTED = 3530;
  exports.ER_FAILED_REVOKE_ROLE = 3531;
  exports.ER_RENAME_ROLE = 3532;
  exports.ER_COMPONENTS_CANT_ACQUIRE_SERVICE_IMPLEMENTATION = 3533;
  exports.ER_COMPONENTS_CANT_SATISFY_DEPENDENCY = 3534;
  exports.ER_COMPONENTS_LOAD_CANT_REGISTER_SERVICE_IMPLEMENTATION = 3535;
  exports.ER_COMPONENTS_LOAD_CANT_INITIALIZE = 3536;
  exports.ER_COMPONENTS_UNLOAD_NOT_LOADED = 3537;
  exports.ER_COMPONENTS_UNLOAD_CANT_DEINITIALIZE = 3538;
  exports.ER_COMPONENTS_CANT_RELEASE_SERVICE = 3539;
  exports.ER_COMPONENTS_UNLOAD_CANT_UNREGISTER_SERVICE = 3540;
  exports.ER_COMPONENTS_CANT_UNLOAD = 3541;
  exports.ER_WARN_UNLOAD_THE_NOT_PERSISTED = 3542;
  exports.ER_COMPONENT_TABLE_INCORRECT = 3543;
  exports.ER_COMPONENT_MANIPULATE_ROW_FAILED = 3544;
  exports.ER_COMPONENTS_UNLOAD_DUPLICATE_IN_GROUP = 3545;
  exports.ER_CANT_SET_GTID_PURGED_DUE_SETS_CONSTRAINTS = 3546;
  exports.ER_CANNOT_LOCK_USER_MANAGEMENT_CACHES = 3547;
  exports.ER_SRS_NOT_FOUND = 3548;
  exports.ER_VARIABLE_NOT_PERSISTED = 3549;
  exports.ER_IS_QUERY_INVALID_CLAUSE = 3550;
  exports.ER_UNABLE_TO_STORE_STATISTICS = 3551;
  exports.ER_NO_SYSTEM_SCHEMA_ACCESS = 3552;
  exports.ER_NO_SYSTEM_TABLESPACE_ACCESS = 3553;
  exports.ER_NO_SYSTEM_TABLE_ACCESS = 3554;
  exports.ER_NO_SYSTEM_TABLE_ACCESS_FOR_DICTIONARY_TABLE = 3555;
  exports.ER_NO_SYSTEM_TABLE_ACCESS_FOR_SYSTEM_TABLE = 3556;
  exports.ER_NO_SYSTEM_TABLE_ACCESS_FOR_TABLE = 3557;
  exports.ER_INVALID_OPTION_KEY = 3558;
  exports.ER_INVALID_OPTION_VALUE = 3559;
  exports.ER_INVALID_OPTION_KEY_VALUE_PAIR = 3560;
  exports.ER_INVALID_OPTION_START_CHARACTER = 3561;
  exports.ER_INVALID_OPTION_END_CHARACTER = 3562;
  exports.ER_INVALID_OPTION_CHARACTERS = 3563;
  exports.ER_DUPLICATE_OPTION_KEY = 3564;
  exports.ER_WARN_SRS_NOT_FOUND_AXIS_ORDER = 3565;
  exports.ER_NO_ACCESS_TO_NATIVE_FCT = 3566;
  exports.ER_RESET_SOURCE_TO_VALUE_OUT_OF_RANGE = 3567;
  exports.ER_UNRESOLVED_TABLE_LOCK = 3568;
  exports.ER_DUPLICATE_TABLE_LOCK = 3569;
  exports.ER_BINLOG_UNSAFE_SKIP_LOCKED = 3570;
  exports.ER_BINLOG_UNSAFE_NOWAIT = 3571;
  exports.ER_LOCK_NOWAIT = 3572;
  exports.ER_CTE_RECURSIVE_REQUIRES_UNION = 3573;
  exports.ER_CTE_RECURSIVE_REQUIRES_NONRECURSIVE_FIRST = 3574;
  exports.ER_CTE_RECURSIVE_FORBIDS_AGGREGATION = 3575;
  exports.ER_CTE_RECURSIVE_FORBIDDEN_JOIN_ORDER = 3576;
  exports.ER_CTE_RECURSIVE_REQUIRES_SINGLE_REFERENCE = 3577;
  exports.ER_SWITCH_TMP_ENGINE = 3578;
  exports.ER_WINDOW_NO_SUCH_WINDOW = 3579;
  exports.ER_WINDOW_CIRCULARITY_IN_WINDOW_GRAPH = 3580;
  exports.ER_WINDOW_NO_CHILD_PARTITIONING = 3581;
  exports.ER_WINDOW_NO_INHERIT_FRAME = 3582;
  exports.ER_WINDOW_NO_REDEFINE_ORDER_BY = 3583;
  exports.ER_WINDOW_FRAME_START_ILLEGAL = 3584;
  exports.ER_WINDOW_FRAME_END_ILLEGAL = 3585;
  exports.ER_WINDOW_FRAME_ILLEGAL = 3586;
  exports.ER_WINDOW_RANGE_FRAME_ORDER_TYPE = 3587;
  exports.ER_WINDOW_RANGE_FRAME_TEMPORAL_TYPE = 3588;
  exports.ER_WINDOW_RANGE_FRAME_NUMERIC_TYPE = 3589;
  exports.ER_WINDOW_RANGE_BOUND_NOT_CONSTANT = 3590;
  exports.ER_WINDOW_DUPLICATE_NAME = 3591;
  exports.ER_WINDOW_ILLEGAL_ORDER_BY = 3592;
  exports.ER_WINDOW_INVALID_WINDOW_FUNC_USE = 3593;
  exports.ER_WINDOW_INVALID_WINDOW_FUNC_ALIAS_USE = 3594;
  exports.ER_WINDOW_NESTED_WINDOW_FUNC_USE_IN_WINDOW_SPEC = 3595;
  exports.ER_WINDOW_ROWS_INTERVAL_USE = 3596;
  exports.ER_WINDOW_NO_GROUP_ORDER = 3597;
  exports.ER_WINDOW_EXPLAIN_JSON = 3598;
  exports.ER_WINDOW_FUNCTION_IGNORES_FRAME = 3599;
  exports.ER_WL9236_NOW = 3600;
  exports.ER_INVALID_NO_OF_ARGS = 3601;
  exports.ER_FIELD_IN_GROUPING_NOT_GROUP_BY = 3602;
  exports.ER_TOO_LONG_TABLESPACE_COMMENT = 3603;
  exports.ER_ENGINE_CANT_DROP_TABLE = 3604;
  exports.ER_ENGINE_CANT_DROP_MISSING_TABLE = 3605;
  exports.ER_TABLESPACE_DUP_FILENAME = 3606;
  exports.ER_DB_DROP_RMDIR2 = 3607;
  exports.ER_IMP_NO_FILES_MATCHED = 3608;
  exports.ER_IMP_SCHEMA_DOES_NOT_EXIST = 3609;
  exports.ER_IMP_TABLE_ALREADY_EXISTS = 3610;
  exports.ER_IMP_INCOMPATIBLE_MYSQLD_VERSION = 3611;
  exports.ER_IMP_INCOMPATIBLE_DD_VERSION = 3612;
  exports.ER_IMP_INCOMPATIBLE_SDI_VERSION = 3613;
  exports.ER_WARN_INVALID_HINT = 3614;
  exports.ER_VAR_DOES_NOT_EXIST = 3615;
  exports.ER_LONGITUDE_OUT_OF_RANGE = 3616;
  exports.ER_LATITUDE_OUT_OF_RANGE = 3617;
  exports.ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS = 3618;
  exports.ER_ILLEGAL_PRIVILEGE_LEVEL = 3619;
  exports.ER_NO_SYSTEM_VIEW_ACCESS = 3620;
  exports.ER_COMPONENT_FILTER_FLABBERGASTED = 3621;
  exports.ER_PART_EXPR_TOO_LONG = 3622;
  exports.ER_UDF_DROP_DYNAMICALLY_REGISTERED = 3623;
  exports.ER_UNABLE_TO_STORE_COLUMN_STATISTICS = 3624;
  exports.ER_UNABLE_TO_UPDATE_COLUMN_STATISTICS = 3625;
  exports.ER_UNABLE_TO_DROP_COLUMN_STATISTICS = 3626;
  exports.ER_UNABLE_TO_BUILD_HISTOGRAM = 3627;
  exports.ER_MANDATORY_ROLE = 3628;
  exports.ER_MISSING_TABLESPACE_FILE = 3629;
  exports.ER_PERSIST_ONLY_ACCESS_DENIED_ERROR = 3630;
  exports.ER_CMD_NEED_SUPER = 3631;
  exports.ER_PATH_IN_DATADIR = 3632;
  exports.ER_CLONE_DDL_IN_PROGRESS = 3633;
  exports.ER_CLONE_TOO_MANY_CONCURRENT_CLONES = 3634;
  exports.ER_APPLIER_LOG_EVENT_VALIDATION_ERROR = 3635;
  exports.ER_CTE_MAX_RECURSION_DEPTH = 3636;
  exports.ER_NOT_HINT_UPDATABLE_VARIABLE = 3637;
  exports.ER_CREDENTIALS_CONTRADICT_TO_HISTORY = 3638;
  exports.ER_WARNING_PASSWORD_HISTORY_CLAUSES_VOID = 3639;
  exports.ER_CLIENT_DOES_NOT_SUPPORT = 3640;
  exports.ER_I_S_SKIPPED_TABLESPACE = 3641;
  exports.ER_TABLESPACE_ENGINE_MISMATCH = 3642;
  exports.ER_WRONG_SRID_FOR_COLUMN = 3643;
  exports.ER_CANNOT_ALTER_SRID_DUE_TO_INDEX = 3644;
  exports.ER_WARN_BINLOG_PARTIAL_UPDATES_DISABLED = 3645;
  exports.ER_WARN_BINLOG_V1_ROW_EVENTS_DISABLED = 3646;
  exports.ER_WARN_BINLOG_PARTIAL_UPDATES_SUGGESTS_PARTIAL_IMAGES = 3647;
  exports.ER_COULD_NOT_APPLY_JSON_DIFF = 3648;
  exports.ER_CORRUPTED_JSON_DIFF = 3649;
  exports.ER_RESOURCE_GROUP_EXISTS = 3650;
  exports.ER_RESOURCE_GROUP_NOT_EXISTS = 3651;
  exports.ER_INVALID_VCPU_ID = 3652;
  exports.ER_INVALID_VCPU_RANGE = 3653;
  exports.ER_INVALID_THREAD_PRIORITY = 3654;
  exports.ER_DISALLOWED_OPERATION = 3655;
  exports.ER_RESOURCE_GROUP_BUSY = 3656;
  exports.ER_RESOURCE_GROUP_DISABLED = 3657;
  exports.ER_FEATURE_UNSUPPORTED = 3658;
  exports.ER_ATTRIBUTE_IGNORED = 3659;
  exports.ER_INVALID_THREAD_ID = 3660;
  exports.ER_RESOURCE_GROUP_BIND_FAILED = 3661;
  exports.ER_INVALID_USE_OF_FORCE_OPTION = 3662;
  exports.ER_GROUP_REPLICATION_COMMAND_FAILURE = 3663;
  exports.ER_SDI_OPERATION_FAILED = 3664;
  exports.ER_MISSING_JSON_TABLE_VALUE = 3665;
  exports.ER_WRONG_JSON_TABLE_VALUE = 3666;
  exports.ER_TF_MUST_HAVE_ALIAS = 3667;
  exports.ER_TF_FORBIDDEN_JOIN_TYPE = 3668;
  exports.ER_JT_VALUE_OUT_OF_RANGE = 3669;
  exports.ER_JT_MAX_NESTED_PATH = 3670;
  exports.ER_PASSWORD_EXPIRATION_NOT_SUPPORTED_BY_AUTH_METHOD = 3671;
  exports.ER_INVALID_GEOJSON_CRS_NOT_TOP_LEVEL = 3672;
  exports.ER_BAD_NULL_ERROR_NOT_IGNORED = 3673;
  exports.WARN_USELESS_SPATIAL_INDEX = 3674;
  exports.ER_DISK_FULL_NOWAIT = 3675;
  exports.ER_PARSE_ERROR_IN_DIGEST_FN = 3676;
  exports.ER_UNDISCLOSED_PARSE_ERROR_IN_DIGEST_FN = 3677;
  exports.ER_SCHEMA_DIR_EXISTS = 3678;
  exports.ER_SCHEMA_DIR_MISSING = 3679;
  exports.ER_SCHEMA_DIR_CREATE_FAILED = 3680;
  exports.ER_SCHEMA_DIR_UNKNOWN = 3681;
  exports.ER_ONLY_IMPLEMENTED_FOR_SRID_0_AND_4326 = 3682;
  exports.ER_BINLOG_EXPIRE_LOG_DAYS_AND_SECS_USED_TOGETHER = 3683;
  exports.ER_REGEXP_BUFFER_OVERFLOW = 3684;
  exports.ER_REGEXP_ILLEGAL_ARGUMENT = 3685;
  exports.ER_REGEXP_INDEX_OUTOFBOUNDS_ERROR = 3686;
  exports.ER_REGEXP_INTERNAL_ERROR = 3687;
  exports.ER_REGEXP_RULE_SYNTAX = 3688;
  exports.ER_REGEXP_BAD_ESCAPE_SEQUENCE = 3689;
  exports.ER_REGEXP_UNIMPLEMENTED = 3690;
  exports.ER_REGEXP_MISMATCHED_PAREN = 3691;
  exports.ER_REGEXP_BAD_INTERVAL = 3692;
  exports.ER_REGEXP_MAX_LT_MIN = 3693;
  exports.ER_REGEXP_INVALID_BACK_REF = 3694;
  exports.ER_REGEXP_LOOK_BEHIND_LIMIT = 3695;
  exports.ER_REGEXP_MISSING_CLOSE_BRACKET = 3696;
  exports.ER_REGEXP_INVALID_RANGE = 3697;
  exports.ER_REGEXP_STACK_OVERFLOW = 3698;
  exports.ER_REGEXP_TIME_OUT = 3699;
  exports.ER_REGEXP_PATTERN_TOO_BIG = 3700;
  exports.ER_CANT_SET_ERROR_LOG_SERVICE = 3701;
  exports.ER_EMPTY_PIPELINE_FOR_ERROR_LOG_SERVICE = 3702;
  exports.ER_COMPONENT_FILTER_DIAGNOSTICS = 3703;
  exports.ER_NOT_IMPLEMENTED_FOR_CARTESIAN_SRS = 3704;
  exports.ER_NOT_IMPLEMENTED_FOR_PROJECTED_SRS = 3705;
  exports.ER_NONPOSITIVE_RADIUS = 3706;
  exports.ER_RESTART_SERVER_FAILED = 3707;
  exports.ER_SRS_MISSING_MANDATORY_ATTRIBUTE = 3708;
  exports.ER_SRS_MULTIPLE_ATTRIBUTE_DEFINITIONS = 3709;
  exports.ER_SRS_NAME_CANT_BE_EMPTY_OR_WHITESPACE = 3710;
  exports.ER_SRS_ORGANIZATION_CANT_BE_EMPTY_OR_WHITESPACE = 3711;
  exports.ER_SRS_ID_ALREADY_EXISTS = 3712;
  exports.ER_WARN_SRS_ID_ALREADY_EXISTS = 3713;
  exports.ER_CANT_MODIFY_SRID_0 = 3714;
  exports.ER_WARN_RESERVED_SRID_RANGE = 3715;
  exports.ER_CANT_MODIFY_SRS_USED_BY_COLUMN = 3716;
  exports.ER_SRS_INVALID_CHARACTER_IN_ATTRIBUTE = 3717;
  exports.ER_SRS_ATTRIBUTE_STRING_TOO_LONG = 3718;
  exports.ER_DEPRECATED_UTF8_ALIAS = 3719;
  exports.ER_DEPRECATED_NATIONAL = 3720;
  exports.ER_INVALID_DEFAULT_UTF8MB4_COLLATION = 3721;
  exports.ER_UNABLE_TO_COLLECT_LOG_STATUS = 3722;
  exports.ER_RESERVED_TABLESPACE_NAME = 3723;
  exports.ER_UNABLE_TO_SET_OPTION = 3724;
  exports.ER_REPLICA_POSSIBLY_DIVERGED_AFTER_DDL = 3725;
  exports.ER_SRS_NOT_GEOGRAPHIC = 3726;
  exports.ER_POLYGON_TOO_LARGE = 3727;
  exports.ER_SPATIAL_UNIQUE_INDEX = 3728;
  exports.ER_INDEX_TYPE_NOT_SUPPORTED_FOR_SPATIAL_INDEX = 3729;
  exports.ER_FK_CANNOT_DROP_PARENT = 3730;
  exports.ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE = 3731;
  exports.ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE = 3732;
  exports.ER_FK_CANNOT_USE_VIRTUAL_COLUMN = 3733;
  exports.ER_FK_NO_COLUMN_PARENT = 3734;
  exports.ER_CANT_SET_ERROR_SUPPRESSION_LIST = 3735;
  exports.ER_SRS_GEOGCS_INVALID_AXES = 3736;
  exports.ER_SRS_INVALID_SEMI_MAJOR_AXIS = 3737;
  exports.ER_SRS_INVALID_INVERSE_FLATTENING = 3738;
  exports.ER_SRS_INVALID_ANGULAR_UNIT = 3739;
  exports.ER_SRS_INVALID_PRIME_MERIDIAN = 3740;
  exports.ER_TRANSFORM_SOURCE_SRS_NOT_SUPPORTED = 3741;
  exports.ER_TRANSFORM_TARGET_SRS_NOT_SUPPORTED = 3742;
  exports.ER_TRANSFORM_SOURCE_SRS_MISSING_TOWGS84 = 3743;
  exports.ER_TRANSFORM_TARGET_SRS_MISSING_TOWGS84 = 3744;
  exports.ER_TEMP_TABLE_PREVENTS_SWITCH_SESSION_BINLOG_FORMAT = 3745;
  exports.ER_TEMP_TABLE_PREVENTS_SWITCH_GLOBAL_BINLOG_FORMAT = 3746;
  exports.ER_RUNNING_APPLIER_PREVENTS_SWITCH_GLOBAL_BINLOG_FORMAT = 3747;
  exports.ER_CLIENT_GTID_UNSAFE_CREATE_DROP_TEMP_TABLE_IN_TRX_IN_SBR = 3748;
  exports.ER_XA_CANT_CREATE_MDL_BACKUP = 3749;
  exports.ER_TABLE_WITHOUT_PK = 3750;
  exports.ER_WARN_DATA_TRUNCATED_FUNCTIONAL_INDEX = 3751;
  exports.ER_WARN_DATA_OUT_OF_RANGE_FUNCTIONAL_INDEX = 3752;
  exports.ER_FUNCTIONAL_INDEX_ON_JSON_OR_GEOMETRY_FUNCTION = 3753;
  exports.ER_FUNCTIONAL_INDEX_REF_AUTO_INCREMENT = 3754;
  exports.ER_CANNOT_DROP_COLUMN_FUNCTIONAL_INDEX = 3755;
  exports.ER_FUNCTIONAL_INDEX_PRIMARY_KEY = 3756;
  exports.ER_FUNCTIONAL_INDEX_ON_LOB = 3757;
  exports.ER_FUNCTIONAL_INDEX_FUNCTION_IS_NOT_ALLOWED = 3758;
  exports.ER_FULLTEXT_FUNCTIONAL_INDEX = 3759;
  exports.ER_SPATIAL_FUNCTIONAL_INDEX = 3760;
  exports.ER_WRONG_KEY_COLUMN_FUNCTIONAL_INDEX = 3761;
  exports.ER_FUNCTIONAL_INDEX_ON_FIELD = 3762;
  exports.ER_GENERATED_COLUMN_NAMED_FUNCTION_IS_NOT_ALLOWED = 3763;
  exports.ER_GENERATED_COLUMN_ROW_VALUE = 3764;
  exports.ER_GENERATED_COLUMN_VARIABLES = 3765;
  exports.ER_DEPENDENT_BY_DEFAULT_GENERATED_VALUE = 3766;
  exports.ER_DEFAULT_VAL_GENERATED_NON_PRIOR = 3767;
  exports.ER_DEFAULT_VAL_GENERATED_REF_AUTO_INC = 3768;
  exports.ER_DEFAULT_VAL_GENERATED_FUNCTION_IS_NOT_ALLOWED = 3769;
  exports.ER_DEFAULT_VAL_GENERATED_NAMED_FUNCTION_IS_NOT_ALLOWED = 3770;
  exports.ER_DEFAULT_VAL_GENERATED_ROW_VALUE = 3771;
  exports.ER_DEFAULT_VAL_GENERATED_VARIABLES = 3772;
  exports.ER_DEFAULT_AS_VAL_GENERATED = 3773;
  exports.ER_UNSUPPORTED_ACTION_ON_DEFAULT_VAL_GENERATED = 3774;
  exports.ER_GTID_UNSAFE_ALTER_ADD_COL_WITH_DEFAULT_EXPRESSION = 3775;
  exports.ER_FK_CANNOT_CHANGE_ENGINE = 3776;
  exports.ER_WARN_DEPRECATED_USER_SET_EXPR = 3777;
  exports.ER_WARN_DEPRECATED_UTF8MB3_COLLATION = 3778;
  exports.ER_WARN_DEPRECATED_NESTED_COMMENT_SYNTAX = 3779;
  exports.ER_FK_INCOMPATIBLE_COLUMNS = 3780;
  exports.ER_GR_HOLD_WAIT_TIMEOUT = 3781;
  exports.ER_GR_HOLD_KILLED = 3782;
  exports.ER_GR_HOLD_MEMBER_STATUS_ERROR = 3783;
  exports.ER_RPL_ENCRYPTION_FAILED_TO_FETCH_KEY = 3784;
  exports.ER_RPL_ENCRYPTION_KEY_NOT_FOUND = 3785;
  exports.ER_RPL_ENCRYPTION_KEYRING_INVALID_KEY = 3786;
  exports.ER_RPL_ENCRYPTION_HEADER_ERROR = 3787;
  exports.ER_RPL_ENCRYPTION_FAILED_TO_ROTATE_LOGS = 3788;
  exports.ER_RPL_ENCRYPTION_KEY_EXISTS_UNEXPECTED = 3789;
  exports.ER_RPL_ENCRYPTION_FAILED_TO_GENERATE_KEY = 3790;
  exports.ER_RPL_ENCRYPTION_FAILED_TO_STORE_KEY = 3791;
  exports.ER_RPL_ENCRYPTION_FAILED_TO_REMOVE_KEY = 3792;
  exports.ER_RPL_ENCRYPTION_UNABLE_TO_CHANGE_OPTION = 3793;
  exports.ER_RPL_ENCRYPTION_MASTER_KEY_RECOVERY_FAILED = 3794;
  exports.ER_SLOW_LOG_MODE_IGNORED_WHEN_NOT_LOGGING_TO_FILE = 3795;
  exports.ER_GRP_TRX_CONSISTENCY_NOT_ALLOWED = 3796;
  exports.ER_GRP_TRX_CONSISTENCY_BEFORE = 3797;
  exports.ER_GRP_TRX_CONSISTENCY_AFTER_ON_TRX_BEGIN = 3798;
  exports.ER_GRP_TRX_CONSISTENCY_BEGIN_NOT_ALLOWED = 3799;
  exports.ER_FUNCTIONAL_INDEX_ROW_VALUE_IS_NOT_ALLOWED = 3800;
  exports.ER_RPL_ENCRYPTION_FAILED_TO_ENCRYPT = 3801;
  exports.ER_PAGE_TRACKING_NOT_STARTED = 3802;
  exports.ER_PAGE_TRACKING_RANGE_NOT_TRACKED = 3803;
  exports.ER_PAGE_TRACKING_CANNOT_PURGE = 3804;
  exports.ER_RPL_ENCRYPTION_CANNOT_ROTATE_BINLOG_MASTER_KEY = 3805;
  exports.ER_BINLOG_MASTER_KEY_RECOVERY_OUT_OF_COMBINATION = 3806;
  exports.ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_OPERATE_KEY = 3807;
  exports.ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_ROTATE_LOGS = 3808;
  exports.ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_REENCRYPT_LOG = 3809;
  exports.ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_CLEANUP_UNUSED_KEYS = 3810;
  exports.ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_CLEANUP_AUX_KEY = 3811;
  exports.ER_NON_BOOLEAN_EXPR_FOR_CHECK_CONSTRAINT = 3812;
  exports.ER_COLUMN_CHECK_CONSTRAINT_REFERENCES_OTHER_COLUMN = 3813;
  exports.ER_CHECK_CONSTRAINT_NAMED_FUNCTION_IS_NOT_ALLOWED = 3814;
  exports.ER_CHECK_CONSTRAINT_FUNCTION_IS_NOT_ALLOWED = 3815;
  exports.ER_CHECK_CONSTRAINT_VARIABLES = 3816;
  exports.ER_CHECK_CONSTRAINT_ROW_VALUE = 3817;
  exports.ER_CHECK_CONSTRAINT_REFERS_AUTO_INCREMENT_COLUMN = 3818;
  exports.ER_CHECK_CONSTRAINT_VIOLATED = 3819;
  exports.ER_CHECK_CONSTRAINT_REFERS_UNKNOWN_COLUMN = 3820;
  exports.ER_CHECK_CONSTRAINT_NOT_FOUND = 3821;
  exports.ER_CHECK_CONSTRAINT_DUP_NAME = 3822;
  exports.ER_CHECK_CONSTRAINT_CLAUSE_USING_FK_REFER_ACTION_COLUMN = 3823;
  exports.WARN_UNENCRYPTED_TABLE_IN_ENCRYPTED_DB = 3824;
  exports.ER_INVALID_ENCRYPTION_REQUEST = 3825;
  exports.ER_CANNOT_SET_TABLE_ENCRYPTION = 3826;
  exports.ER_CANNOT_SET_DATABASE_ENCRYPTION = 3827;
  exports.ER_CANNOT_SET_TABLESPACE_ENCRYPTION = 3828;
  exports.ER_TABLESPACE_CANNOT_BE_ENCRYPTED = 3829;
  exports.ER_TABLESPACE_CANNOT_BE_DECRYPTED = 3830;
  exports.ER_TABLESPACE_TYPE_UNKNOWN = 3831;
  exports.ER_TARGET_TABLESPACE_UNENCRYPTED = 3832;
  exports.ER_CANNOT_USE_ENCRYPTION_CLAUSE = 3833;
  exports.ER_INVALID_MULTIPLE_CLAUSES = 3834;
  exports.ER_UNSUPPORTED_USE_OF_GRANT_AS = 3835;
  exports.ER_UKNOWN_AUTH_ID_OR_ACCESS_DENIED_FOR_GRANT_AS = 3836;
  exports.ER_DEPENDENT_BY_FUNCTIONAL_INDEX = 3837;
  exports.ER_PLUGIN_NOT_EARLY = 3838;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_START_SUBDIR_PATH = 3839;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_START_TIMEOUT = 3840;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_DIRS_INVALID = 3841;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_LABEL_NOT_FOUND = 3842;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_DIR_EMPTY = 3843;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_NO_SUCH_DIR = 3844;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_DIR_CLASH = 3845;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_DIR_PERMISSIONS = 3846;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_FILE_CREATE = 3847;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_ACTIVE = 3848;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_INACTIVE = 3849;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_FAILED = 3850;
  exports.ER_INNODB_REDO_LOG_ARCHIVE_SESSION = 3851;
  exports.ER_STD_REGEX_ERROR = 3852;
  exports.ER_INVALID_JSON_TYPE = 3853;
  exports.ER_CANNOT_CONVERT_STRING = 3854;
  exports.ER_DEPENDENT_BY_PARTITION_FUNC = 3855;
  exports.ER_WARN_DEPRECATED_FLOAT_AUTO_INCREMENT = 3856;
  exports.ER_RPL_CANT_STOP_REPLICA_WHILE_LOCKED_BACKUP = 3857;
  exports.ER_WARN_DEPRECATED_FLOAT_DIGITS = 3858;
  exports.ER_WARN_DEPRECATED_FLOAT_UNSIGNED = 3859;
  exports.ER_WARN_DEPRECATED_INTEGER_DISPLAY_WIDTH = 3860;
  exports.ER_WARN_DEPRECATED_ZEROFILL = 3861;
  exports.ER_CLONE_DONOR = 3862;
  exports.ER_CLONE_PROTOCOL = 3863;
  exports.ER_CLONE_DONOR_VERSION = 3864;
  exports.ER_CLONE_OS = 3865;
  exports.ER_CLONE_PLATFORM = 3866;
  exports.ER_CLONE_CHARSET = 3867;
  exports.ER_CLONE_CONFIG = 3868;
  exports.ER_CLONE_SYS_CONFIG = 3869;
  exports.ER_CLONE_PLUGIN_MATCH = 3870;
  exports.ER_CLONE_LOOPBACK = 3871;
  exports.ER_CLONE_ENCRYPTION = 3872;
  exports.ER_CLONE_DISK_SPACE = 3873;
  exports.ER_CLONE_IN_PROGRESS = 3874;
  exports.ER_CLONE_DISALLOWED = 3875;
  exports.ER_CANNOT_GRANT_ROLES_TO_ANONYMOUS_USER = 3876;
  exports.ER_SECONDARY_ENGINE_PLUGIN = 3877;
  exports.ER_SECOND_PASSWORD_CANNOT_BE_EMPTY = 3878;
  exports.ER_DB_ACCESS_DENIED = 3879;
  exports.ER_DA_AUTH_ID_WITH_SYSTEM_USER_PRIV_IN_MANDATORY_ROLES = 3880;
  exports.ER_DA_RPL_GTID_TABLE_CANNOT_OPEN = 3881;
  exports.ER_GEOMETRY_IN_UNKNOWN_LENGTH_UNIT = 3882;
  exports.ER_DA_PLUGIN_INSTALL_ERROR = 3883;
  exports.ER_NO_SESSION_TEMP = 3884;
  exports.ER_DA_UNKNOWN_ERROR_NUMBER = 3885;
  exports.ER_COLUMN_CHANGE_SIZE = 3886;
  exports.ER_REGEXP_INVALID_CAPTURE_GROUP_NAME = 3887;
  exports.ER_DA_SSL_LIBRARY_ERROR = 3888;
  exports.ER_SECONDARY_ENGINE = 3889;
  exports.ER_SECONDARY_ENGINE_DDL = 3890;
  exports.ER_INCORRECT_CURRENT_PASSWORD = 3891;
  exports.ER_MISSING_CURRENT_PASSWORD = 3892;
  exports.ER_CURRENT_PASSWORD_NOT_REQUIRED = 3893;
  exports.ER_PASSWORD_CANNOT_BE_RETAINED_ON_PLUGIN_CHANGE = 3894;
  exports.ER_CURRENT_PASSWORD_CANNOT_BE_RETAINED = 3895;
  exports.ER_PARTIAL_REVOKES_EXIST = 3896;
  exports.ER_CANNOT_GRANT_SYSTEM_PRIV_TO_MANDATORY_ROLE = 3897;
  exports.ER_XA_REPLICATION_FILTERS = 3898;
  exports.ER_UNSUPPORTED_SQL_MODE = 3899;
  exports.ER_REGEXP_INVALID_FLAG = 3900;
  exports.ER_PARTIAL_REVOKE_AND_DB_GRANT_BOTH_EXISTS = 3901;
  exports.ER_UNIT_NOT_FOUND = 3902;
  exports.ER_INVALID_JSON_VALUE_FOR_FUNC_INDEX = 3903;
  exports.ER_JSON_VALUE_OUT_OF_RANGE_FOR_FUNC_INDEX = 3904;
  exports.ER_EXCEEDED_MV_KEYS_NUM = 3905;
  exports.ER_EXCEEDED_MV_KEYS_SPACE = 3906;
  exports.ER_FUNCTIONAL_INDEX_DATA_IS_TOO_LONG = 3907;
  exports.ER_WRONG_MVI_VALUE = 3908;
  exports.ER_WARN_FUNC_INDEX_NOT_APPLICABLE = 3909;
  exports.ER_GRP_RPL_UDF_ERROR = 3910;
  exports.ER_UPDATE_GTID_PURGED_WITH_GR = 3911;
  exports.ER_GROUPING_ON_TIMESTAMP_IN_DST = 3912;
  exports.ER_TABLE_NAME_CAUSES_TOO_LONG_PATH = 3913;
  exports.ER_AUDIT_LOG_INSUFFICIENT_PRIVILEGE = 3914;
  exports.ER_AUDIT_LOG_PASSWORD_HAS_BEEN_COPIED = 3915;
  exports.ER_DA_GRP_RPL_STARTED_AUTO_REJOIN = 3916;
  exports.ER_SYSVAR_CHANGE_DURING_QUERY = 3917;
  exports.ER_GLOBSTAT_CHANGE_DURING_QUERY = 3918;
  exports.ER_GRP_RPL_MESSAGE_SERVICE_INIT_FAILURE = 3919;
  exports.ER_CHANGE_SOURCE_WRONG_COMPRESSION_ALGORITHM_CLIENT = 3920;
  exports.ER_CHANGE_SOURCE_WRONG_COMPRESSION_LEVEL_CLIENT = 3921;
  exports.ER_WRONG_COMPRESSION_ALGORITHM_CLIENT = 3922;
  exports.ER_WRONG_COMPRESSION_LEVEL_CLIENT = 3923;
  exports.ER_CHANGE_SOURCE_WRONG_COMPRESSION_ALGORITHM_LIST_CLIENT = 3924;
  exports.ER_CLIENT_PRIVILEGE_CHECKS_USER_CANNOT_BE_ANONYMOUS = 3925;
  exports.ER_CLIENT_PRIVILEGE_CHECKS_USER_DOES_NOT_EXIST = 3926;
  exports.ER_CLIENT_PRIVILEGE_CHECKS_USER_CORRUPT = 3927;
  exports.ER_CLIENT_PRIVILEGE_CHECKS_USER_NEEDS_RPL_APPLIER_PRIV = 3928;
  exports.ER_WARN_DA_PRIVILEGE_NOT_REGISTERED = 3929;
  exports.ER_CLIENT_KEYRING_UDF_KEY_INVALID = 3930;
  exports.ER_CLIENT_KEYRING_UDF_KEY_TYPE_INVALID = 3931;
  exports.ER_CLIENT_KEYRING_UDF_KEY_TOO_LONG = 3932;
  exports.ER_CLIENT_KEYRING_UDF_KEY_TYPE_TOO_LONG = 3933;
  exports.ER_JSON_SCHEMA_VALIDATION_ERROR_WITH_DETAILED_REPORT = 3934;
  exports.ER_DA_UDF_INVALID_CHARSET_SPECIFIED = 3935;
  exports.ER_DA_UDF_INVALID_CHARSET = 3936;
  exports.ER_DA_UDF_INVALID_COLLATION = 3937;
  exports.ER_DA_UDF_INVALID_EXTENSION_ARGUMENT_TYPE = 3938;
  exports.ER_MULTIPLE_CONSTRAINTS_WITH_SAME_NAME = 3939;
  exports.ER_CONSTRAINT_NOT_FOUND = 3940;
  exports.ER_ALTER_CONSTRAINT_ENFORCEMENT_NOT_SUPPORTED = 3941;
  exports.ER_TABLE_VALUE_CONSTRUCTOR_MUST_HAVE_COLUMNS = 3942;
  exports.ER_TABLE_VALUE_CONSTRUCTOR_CANNOT_HAVE_DEFAULT = 3943;
  exports.ER_CLIENT_QUERY_FAILURE_INVALID_NON_ROW_FORMAT = 3944;
  exports.ER_REQUIRE_ROW_FORMAT_INVALID_VALUE = 3945;
  exports.ER_FAILED_TO_DETERMINE_IF_ROLE_IS_MANDATORY = 3946;
  exports.ER_FAILED_TO_FETCH_MANDATORY_ROLE_LIST = 3947;
  exports.ER_CLIENT_LOCAL_FILES_DISABLED = 3948;
  exports.ER_IMP_INCOMPATIBLE_CFG_VERSION = 3949;
  exports.ER_DA_OOM = 3950;
  exports.ER_DA_UDF_INVALID_ARGUMENT_TO_SET_CHARSET = 3951;
  exports.ER_DA_UDF_INVALID_RETURN_TYPE_TO_SET_CHARSET = 3952;
  exports.ER_MULTIPLE_INTO_CLAUSES = 3953;
  exports.ER_MISPLACED_INTO = 3954;
  exports.ER_USER_ACCESS_DENIED_FOR_USER_ACCOUNT_BLOCKED_BY_PASSWORD_LOCK = 3955;
  exports.ER_WARN_DEPRECATED_YEAR_UNSIGNED = 3956;
  exports.ER_CLONE_NETWORK_PACKET = 3957;
  exports.ER_SDI_OPERATION_FAILED_MISSING_RECORD = 3958;
  exports.ER_DEPENDENT_BY_CHECK_CONSTRAINT = 3959;
  exports.ER_GRP_OPERATION_NOT_ALLOWED_GR_MUST_STOP = 3960;
  exports.ER_WARN_DEPRECATED_JSON_TABLE_ON_ERROR_ON_EMPTY = 3961;
  exports.ER_WARN_DEPRECATED_INNER_INTO = 3962;
  exports.ER_WARN_DEPRECATED_VALUES_FUNCTION_ALWAYS_NULL = 3963;
  exports.ER_WARN_DEPRECATED_SQL_CALC_FOUND_ROWS = 3964;
  exports.ER_WARN_DEPRECATED_FOUND_ROWS = 3965;
  exports.ER_MISSING_JSON_VALUE = 3966;
  exports.ER_MULTIPLE_JSON_VALUES = 3967;
  exports.ER_HOSTNAME_TOO_LONG = 3968;
  exports.ER_WARN_CLIENT_DEPRECATED_PARTITION_PREFIX_KEY = 3969;
  exports.ER_GROUP_REPLICATION_USER_EMPTY_MSG = 3970;
  exports.ER_GROUP_REPLICATION_USER_MANDATORY_MSG = 3971;
  exports.ER_GROUP_REPLICATION_PASSWORD_LENGTH = 3972;
  exports.ER_SUBQUERY_TRANSFORM_REJECTED = 3973;
  exports.ER_DA_GRP_RPL_RECOVERY_ENDPOINT_FORMAT = 3974;
  exports.ER_DA_GRP_RPL_RECOVERY_ENDPOINT_INVALID = 3975;
  exports.ER_WRONG_VALUE_FOR_VAR_PLUS_ACTIONABLE_PART = 3976;
  exports.ER_STATEMENT_NOT_ALLOWED_AFTER_START_TRANSACTION = 3977;
  exports.ER_FOREIGN_KEY_WITH_ATOMIC_CREATE_SELECT = 3978;
  exports.ER_NOT_ALLOWED_WITH_START_TRANSACTION = 3979;
  exports.ER_INVALID_JSON_ATTRIBUTE = 3980;
  exports.ER_ENGINE_ATTRIBUTE_NOT_SUPPORTED = 3981;
  exports.ER_INVALID_USER_ATTRIBUTE_JSON = 3982;
  exports.ER_INNODB_REDO_DISABLED = 3983;
  exports.ER_INNODB_REDO_ARCHIVING_ENABLED = 3984;
  exports.ER_MDL_OUT_OF_RESOURCES = 3985;
  exports.ER_IMPLICIT_COMPARISON_FOR_JSON = 3986;
  exports.ER_FUNCTION_DOES_NOT_SUPPORT_CHARACTER_SET = 3987;
  exports.ER_IMPOSSIBLE_STRING_CONVERSION = 3988;
  exports.ER_SCHEMA_READ_ONLY = 3989;
  exports.ER_RPL_ASYNC_RECONNECT_GTID_MODE_OFF = 3990;
  exports.ER_RPL_ASYNC_RECONNECT_AUTO_POSITION_OFF = 3991;
  exports.ER_DISABLE_GTID_MODE_REQUIRES_ASYNC_RECONNECT_OFF = 3992;
  exports.ER_DISABLE_AUTO_POSITION_REQUIRES_ASYNC_RECONNECT_OFF = 3993;
  exports.ER_INVALID_PARAMETER_USE = 3994;
  exports.ER_CHARACTER_SET_MISMATCH = 3995;
  exports.ER_WARN_VAR_VALUE_CHANGE_NOT_SUPPORTED = 3996;
  exports.ER_INVALID_TIME_ZONE_INTERVAL = 3997;
  exports.ER_INVALID_CAST = 3998;
  exports.ER_HYPERGRAPH_NOT_SUPPORTED_YET = 3999;
  exports.ER_WARN_HYPERGRAPH_EXPERIMENTAL = 4000;
  exports.ER_DA_NO_ERROR_LOG_PARSER_CONFIGURED = 4001;
  exports.ER_DA_ERROR_LOG_TABLE_DISABLED = 4002;
  exports.ER_DA_ERROR_LOG_MULTIPLE_FILTERS = 4003;
  exports.ER_DA_CANT_OPEN_ERROR_LOG = 4004;
  exports.ER_USER_REFERENCED_AS_DEFINER = 4005;
  exports.ER_CANNOT_USER_REFERENCED_AS_DEFINER = 4006;
  exports.ER_REGEX_NUMBER_TOO_BIG = 4007;
  exports.ER_SPVAR_NONINTEGER_TYPE = 4008;
  exports.WARN_UNSUPPORTED_ACL_TABLES_READ = 4009;
  exports.ER_BINLOG_UNSAFE_ACL_TABLE_READ_IN_DML_DDL = 4010;
  exports.ER_STOP_REPLICA_MONITOR_IO_THREAD_TIMEOUT = 4011;
  exports.ER_STARTING_REPLICA_MONITOR_IO_THREAD = 4012;
  exports.ER_CANT_USE_ANONYMOUS_TO_GTID_WITH_GTID_MODE_NOT_ON = 4013;
  exports.ER_CANT_COMBINE_ANONYMOUS_TO_GTID_AND_AUTOPOSITION = 4014;
  exports.ER_ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS_REQUIRES_GTID_MODE_ON = 4015;
  exports.ER_SQL_REPLICA_SKIP_COUNTER_USED_WITH_GTID_MODE_ON = 4016;
  exports.ER_USING_ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS_AS_LOCAL_OR_UUID = 4017;
  exports.ER_CANT_SET_ANONYMOUS_TO_GTID_AND_WAIT_UNTIL_SQL_THD_AFTER_GTIDS = 4018;
  exports.ER_CANT_SET_SQL_AFTER_OR_BEFORE_GTIDS_WITH_ANONYMOUS_TO_GTID = 4019;
  exports.ER_ANONYMOUS_TO_GTID_UUID_SAME_AS_GROUP_NAME = 4020;
  exports.ER_CANT_USE_SAME_UUID_AS_GROUP_NAME = 4021;
  exports.ER_GRP_RPL_RECOVERY_CHANNEL_STILL_RUNNING = 4022;
  exports.ER_INNODB_INVALID_AUTOEXTEND_SIZE_VALUE = 4023;
  exports.ER_INNODB_INCOMPATIBLE_WITH_TABLESPACE = 4024;
  exports.ER_INNODB_AUTOEXTEND_SIZE_OUT_OF_RANGE = 4025;
  exports.ER_CANNOT_USE_AUTOEXTEND_SIZE_CLAUSE = 4026;
  exports.ER_ROLE_GRANTED_TO_ITSELF = 4027;
  exports.ER_TABLE_MUST_HAVE_A_VISIBLE_COLUMN = 4028;
  exports.ER_INNODB_COMPRESSION_FAILURE = 4029;
  exports.ER_WARN_ASYNC_CONN_FAILOVER_NETWORK_NAMESPACE = 4030;
  exports.ER_CLIENT_INTERACTION_TIMEOUT = 4031;
  exports.ER_INVALID_CAST_TO_GEOMETRY = 4032;
  exports.ER_INVALID_CAST_POLYGON_RING_DIRECTION = 4033;
  exports.ER_GIS_DIFFERENT_SRIDS_AGGREGATION = 4034;
  exports.ER_RELOAD_KEYRING_FAILURE = 4035;
  exports.ER_SDI_GET_KEYS_INVALID_TABLESPACE = 4036;
  exports.ER_CHANGE_RPL_SRC_WRONG_COMPRESSION_ALGORITHM_SIZE = 4037;
  exports.ER_WARN_DEPRECATED_TLS_VERSION_FOR_CHANNEL_CLI = 4038;
  exports.ER_CANT_USE_SAME_UUID_AS_VIEW_CHANGE_UUID = 4039;
  exports.ER_ANONYMOUS_TO_GTID_UUID_SAME_AS_VIEW_CHANGE_UUID = 4040;
  exports.ER_GRP_RPL_VIEW_CHANGE_UUID_FAIL_GET_VARIABLE = 4041;
  exports.ER_WARN_ADUIT_LOG_MAX_SIZE_AND_PRUNE_SECONDS = 4042;
  exports.ER_WARN_ADUIT_LOG_MAX_SIZE_CLOSE_TO_ROTATE_ON_SIZE = 4043;
  exports.ER_KERBEROS_CREATE_USER = 4044;
  exports.ER_INSTALL_PLUGIN_CONFLICT_CLIENT = 4045;
  exports.ER_DA_ERROR_LOG_COMPONENT_FLUSH_FAILED = 4046;
  exports.ER_WARN_SQL_AFTER_MTS_GAPS_GAP_NOT_CALCULATED = 4047;
  exports.ER_INVALID_ASSIGNMENT_TARGET = 4048;
  exports.ER_OPERATION_NOT_ALLOWED_ON_GR_SECONDARY = 4049;
  exports.ER_GRP_RPL_FAILOVER_CHANNEL_STATUS_PROPAGATION = 4050;
  exports.ER_WARN_AUDIT_LOG_FORMAT_UNIX_TIMESTAMP_ONLY_WHEN_JSON = 4051;
  exports.ER_INVALID_MFA_PLUGIN_SPECIFIED = 4052;
  exports.ER_IDENTIFIED_BY_UNSUPPORTED = 4053;
  exports.ER_INVALID_PLUGIN_FOR_REGISTRATION = 4054;
  exports.ER_PLUGIN_REQUIRES_REGISTRATION = 4055;
  exports.ER_MFA_METHOD_EXISTS = 4056;
  exports.ER_MFA_METHOD_NOT_EXISTS = 4057;
  exports.ER_AUTHENTICATION_POLICY_MISMATCH = 4058;
  exports.ER_PLUGIN_REGISTRATION_DONE = 4059;
  exports.ER_INVALID_USER_FOR_REGISTRATION = 4060;
  exports.ER_USER_REGISTRATION_FAILED = 4061;
  exports.ER_MFA_METHODS_INVALID_ORDER = 4062;
  exports.ER_MFA_METHODS_IDENTICAL = 4063;
  exports.ER_INVALID_MFA_OPERATIONS_FOR_PASSWORDLESS_USER = 4064;
  exports.ER_CHANGE_REPLICATION_SOURCE_NO_OPTIONS_FOR_GTID_ONLY = 4065;
  exports.ER_CHANGE_REP_SOURCE_CANT_DISABLE_REQ_ROW_FORMAT_WITH_GTID_ONLY = 4066;
  exports.ER_CHANGE_REP_SOURCE_CANT_DISABLE_AUTO_POSITION_WITH_GTID_ONLY = 4067;
  exports.ER_CHANGE_REP_SOURCE_CANT_DISABLE_GTID_ONLY_WITHOUT_POSITIONS = 4068;
  exports.ER_CHANGE_REP_SOURCE_CANT_DISABLE_AUTO_POS_WITHOUT_POSITIONS = 4069;
  exports.ER_CHANGE_REP_SOURCE_GR_CHANNEL_WITH_GTID_MODE_NOT_ON = 4070;
  exports.ER_CANT_USE_GTID_ONLY_WITH_GTID_MODE_NOT_ON = 4071;
  exports.ER_WARN_C_DISABLE_GTID_ONLY_WITH_SOURCE_AUTO_POS_INVALID_POS = 4072;
  exports.ER_DA_SSL_FIPS_MODE_ERROR = 4073;
  exports.ER_VALUE_OUT_OF_RANGE = 4074;
  exports.ER_FULLTEXT_WITH_ROLLUP = 4075;
  exports.ER_REGEXP_MISSING_RESOURCE = 4076;
  exports.ER_WARN_REGEXP_USING_DEFAULT = 4077;
  exports.ER_REGEXP_MISSING_FILE = 4078;
  exports.ER_WARN_DEPRECATED_COLLATION = 4079;
  exports.ER_CONCURRENT_PROCEDURE_USAGE = 4080;
  exports.ER_DA_GLOBAL_CONN_LIMIT = 4081;
  exports.ER_DA_CONN_LIMIT = 4082;
  exports.ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_COLUMN_TYPE_INSTANT = 4083;
  exports.ER_WARN_SF_UDF_NAME_COLLISION = 4084;
  exports.ER_CANNOT_PURGE_BINLOG_WITH_BACKUP_LOCK = 4085;
  exports.ER_TOO_MANY_WINDOWS = 4086;
  exports.ER_MYSQLBACKUP_CLIENT_MSG = 4087;
  exports.ER_COMMENT_CONTAINS_INVALID_STRING = 4088;
  exports.ER_DEFINITION_CONTAINS_INVALID_STRING = 4089;
  exports.ER_CANT_EXECUTE_COMMAND_WITH_ASSIGNED_GTID_NEXT = 4090;
  exports.ER_XA_TEMP_TABLE = 4091;
  exports.ER_INNODB_MAX_ROW_VERSION = 4092;
  exports.ER_INNODB_INSTANT_ADD_NOT_SUPPORTED_MAX_SIZE = 4093;
  exports.ER_OPERATION_NOT_ALLOWED_WHILE_PRIMARY_CHANGE_IS_RUNNING = 4094;
  exports.ER_WARN_DEPRECATED_DATETIME_DELIMITER = 4095;
  exports.ER_WARN_DEPRECATED_SUPERFLUOUS_DELIMITER = 4096;
  exports.ER_CANNOT_PERSIST_SENSITIVE_VARIABLES = 4097;
  exports.ER_WARN_CANNOT_SECURELY_PERSIST_SENSITIVE_VARIABLES = 4098;
  exports.ER_WARN_TRG_ALREADY_EXISTS = 4099;
  exports.ER_IF_NOT_EXISTS_UNSUPPORTED_TRG_EXISTS_ON_DIFFERENT_TABLE = 4100;
  exports.ER_IF_NOT_EXISTS_UNSUPPORTED_UDF_NATIVE_FCT_NAME_COLLISION = 4101;
  exports.ER_SET_PASSWORD_AUTH_PLUGIN_ERROR = 4102;
  exports.ER_REDUCED_DBLWR_FILE_CORRUPTED = 4103;
  exports.ER_REDUCED_DBLWR_PAGE_FOUND = 4104;
  exports.ER_SRS_INVALID_LATITUDE_OF_ORIGIN = 4105;
  exports.ER_SRS_INVALID_LONGITUDE_OF_ORIGIN = 4106;
  exports.ER_SRS_UNUSED_PROJ_PARAMETER_PRESENT = 4107;
  exports.ER_GIPK_COLUMN_EXISTS = 4108;
  exports.ER_GIPK_FAILED_AUTOINC_COLUMN_EXISTS = 4109;
  exports.ER_GIPK_COLUMN_ALTER_NOT_ALLOWED = 4110;
  exports.ER_DROP_PK_COLUMN_TO_DROP_GIPK = 4111;
  exports.ER_CREATE_SELECT_WITH_GIPK_DISALLOWED_IN_SBR = 4112;
  exports.ER_DA_EXPIRE_LOGS_DAYS_IGNORED = 4113;
  exports.ER_CTE_RECURSIVE_NOT_UNION = 4114;
  exports.ER_COMMAND_BACKEND_FAILED_TO_FETCH_SECURITY_CTX = 4115;
  exports.ER_COMMAND_SERVICE_BACKEND_FAILED = 4116;
  exports.ER_CLIENT_FILE_PRIVILEGE_FOR_REPLICATION_CHECKS = 4117;
  exports.ER_GROUP_REPLICATION_FORCE_MEMBERS_COMMAND_FAILURE = 4118;
  exports.ER_WARN_DEPRECATED_IDENT = 4119;
  exports.ER_INTERSECT_ALL_MAX_DUPLICATES_EXCEEDED = 4120;
  exports.ER_TP_QUERY_THRS_PER_GRP_EXCEEDS_TXN_THR_LIMIT = 4121;
  exports.ER_BAD_TIMESTAMP_FORMAT = 4122;
  exports.ER_SHAPE_PRIDICTION_UDF = 4123;
  exports.ER_SRS_INVALID_HEIGHT = 4124;
  exports.ER_SRS_INVALID_SCALING = 4125;
  exports.ER_SRS_INVALID_ZONE_WIDTH = 4126;
  exports.ER_SRS_INVALID_LATITUDE_POLAR_STERE_VAR_A = 4127;
  exports.ER_WARN_DEPRECATED_CLIENT_NO_SCHEMA_OPTION = 4128;
  exports.ER_TABLE_NOT_EMPTY = 4129;
  exports.ER_TABLE_NO_PRIMARY_KEY = 4130;
  exports.ER_TABLE_IN_SHARED_TABLESPACE = 4131;
  exports.ER_INDEX_OTHER_THAN_PK = 4132;
  exports.ER_LOAD_BULK_DATA_UNSORTED = 4133;
  exports.ER_BULK_EXECUTOR_ERROR = 4134;
  exports.ER_BULK_READER_LIBCURL_INIT_FAILED = 4135;
  exports.ER_BULK_READER_LIBCURL_ERROR = 4136;
  exports.ER_BULK_READER_SERVER_ERROR = 4137;
  exports.ER_BULK_READER_COMMUNICATION_ERROR = 4138;
  exports.ER_BULK_LOAD_DATA_FAILED = 4139;
  exports.ER_BULK_LOADER_COLUMN_TOO_BIG_FOR_LEFTOVER_BUFFER = 4140;
  exports.ER_BULK_LOADER_COMPONENT_ERROR = 4141;
  exports.ER_BULK_LOADER_FILE_CONTAINS_LESS_LINES_THAN_IGNORE_CLAUSE = 4142;
  exports.ER_BULK_PARSER_MISSING_ENCLOSED_BY = 4143;
  exports.ER_BULK_PARSER_ROW_BUFFER_MAX_TOTAL_COLS_EXCEEDED = 4144;
  exports.ER_BULK_PARSER_COPY_BUFFER_SIZE_EXCEEDED = 4145;
  exports.ER_BULK_PARSER_UNEXPECTED_END_OF_INPUT = 4146;
  exports.ER_BULK_PARSER_UNEXPECTED_ROW_TERMINATOR = 4147;
  exports.ER_BULK_PARSER_UNEXPECTED_CHAR_AFTER_ENDING_ENCLOSED_BY = 4148;
  exports.ER_BULK_PARSER_UNEXPECTED_CHAR_AFTER_NULL_ESCAPE = 4149;
  exports.ER_BULK_PARSER_UNEXPECTED_CHAR_AFTER_COLUMN_TERMINATOR = 4150;
  exports.ER_BULK_PARSER_INCOMPLETE_ESCAPE_SEQUENCE = 4151;
  exports.ER_LOAD_BULK_DATA_FAILED = 4152;
  exports.ER_LOAD_BULK_DATA_WRONG_VALUE_FOR_FIELD = 4153;
  exports.ER_LOAD_BULK_DATA_WARN_NULL_TO_NOTNULL = 4154;
  exports.ER_REQUIRE_TABLE_PRIMARY_KEY_CHECK_GENERATE_WITH_GR = 4155;
  exports.ER_CANT_CHANGE_SYS_VAR_IN_READ_ONLY_MODE = 4156;
  exports.ER_INNODB_INSTANT_ADD_DROP_NOT_SUPPORTED_MAX_SIZE = 4157;
  exports.ER_INNODB_INSTANT_ADD_NOT_SUPPORTED_MAX_FIELDS = 4158;
  exports.ER_CANT_SET_PERSISTED = 4159;
  exports.ER_INSTALL_COMPONENT_SET_NULL_VALUE = 4160;
  exports.ER_INSTALL_COMPONENT_SET_UNUSED_VALUE = 4161;
  exports.ER_WARN_DEPRECATED_USER_DEFINED_COLLATIONS = 4162;
  exports[1] = "EE_CANTCREATEFILE";
  exports[2] = "EE_READ";
  exports[3] = "EE_WRITE";
  exports[4] = "EE_BADCLOSE";
  exports[5] = "EE_OUTOFMEMORY";
  exports[6] = "EE_DELETE";
  exports[7] = "EE_LINK";
  exports[9] = "EE_EOFERR";
  exports[10] = "EE_CANTLOCK";
  exports[11] = "EE_CANTUNLOCK";
  exports[12] = "EE_DIR";
  exports[13] = "EE_STAT";
  exports[14] = "EE_CANT_CHSIZE";
  exports[15] = "EE_CANT_OPEN_STREAM";
  exports[16] = "EE_GETWD";
  exports[17] = "EE_SETWD";
  exports[18] = "EE_LINK_WARNING";
  exports[19] = "EE_OPEN_WARNING";
  exports[20] = "EE_DISK_FULL";
  exports[21] = "EE_CANT_MKDIR";
  exports[22] = "EE_UNKNOWN_CHARSET";
  exports[23] = "EE_OUT_OF_FILERESOURCES";
  exports[24] = "EE_CANT_READLINK";
  exports[25] = "EE_CANT_SYMLINK";
  exports[26] = "EE_REALPATH";
  exports[27] = "EE_SYNC";
  exports[28] = "EE_UNKNOWN_COLLATION";
  exports[29] = "EE_FILENOTFOUND";
  exports[30] = "EE_FILE_NOT_CLOSED";
  exports[31] = "EE_CHANGE_OWNERSHIP";
  exports[32] = "EE_CHANGE_PERMISSIONS";
  exports[33] = "EE_CANT_SEEK";
  exports[34] = "EE_CAPACITY_EXCEEDED";
  exports[35] = "EE_DISK_FULL_WITH_RETRY_MSG";
  exports[36] = "EE_FAILED_TO_CREATE_TIMER";
  exports[37] = "EE_FAILED_TO_DELETE_TIMER";
  exports[38] = "EE_FAILED_TO_CREATE_TIMER_QUEUE";
  exports[39] = "EE_FAILED_TO_START_TIMER_NOTIFY_THREAD";
  exports[40] = "EE_FAILED_TO_CREATE_TIMER_NOTIFY_THREAD_INTERRUPT_EVENT";
  exports[41] = "EE_EXITING_TIMER_NOTIFY_THREAD";
  exports[42] = "EE_WIN_LIBRARY_LOAD_FAILED";
  exports[43] = "EE_WIN_RUN_TIME_ERROR_CHECK";
  exports[44] = "EE_FAILED_TO_DETERMINE_LARGE_PAGE_SIZE";
  exports[45] = "EE_FAILED_TO_KILL_ALL_THREADS";
  exports[46] = "EE_FAILED_TO_CREATE_IO_COMPLETION_PORT";
  exports[47] = "EE_FAILED_TO_OPEN_DEFAULTS_FILE";
  exports[48] = "EE_FAILED_TO_HANDLE_DEFAULTS_FILE";
  exports[49] = "EE_WRONG_DIRECTIVE_IN_CONFIG_FILE";
  exports[50] = "EE_SKIPPING_DIRECTIVE_DUE_TO_MAX_INCLUDE_RECURSION";
  exports[51] = "EE_INCORRECT_GRP_DEFINITION_IN_CONFIG_FILE";
  exports[52] = "EE_OPTION_WITHOUT_GRP_IN_CONFIG_FILE";
  exports[53] = "EE_CONFIG_FILE_PERMISSION_ERROR";
  exports[54] = "EE_IGNORE_WORLD_WRITABLE_CONFIG_FILE";
  exports[55] = "EE_USING_DISABLED_OPTION";
  exports[56] = "EE_USING_DISABLED_SHORT_OPTION";
  exports[57] = "EE_USING_PASSWORD_ON_CLI_IS_INSECURE";
  exports[58] = "EE_UNKNOWN_SUFFIX_FOR_VARIABLE";
  exports[59] = "EE_SSL_ERROR_FROM_FILE";
  exports[60] = "EE_SSL_ERROR";
  exports[61] = "EE_NET_SEND_ERROR_IN_BOOTSTRAP";
  exports[62] = "EE_PACKETS_OUT_OF_ORDER";
  exports[63] = "EE_UNKNOWN_PROTOCOL_OPTION";
  exports[64] = "EE_FAILED_TO_LOCATE_SERVER_PUBLIC_KEY";
  exports[65] = "EE_PUBLIC_KEY_NOT_IN_PEM_FORMAT";
  exports[66] = "EE_DEBUG_INFO";
  exports[67] = "EE_UNKNOWN_VARIABLE";
  exports[68] = "EE_UNKNOWN_OPTION";
  exports[69] = "EE_UNKNOWN_SHORT_OPTION";
  exports[70] = "EE_OPTION_WITHOUT_ARGUMENT";
  exports[71] = "EE_OPTION_REQUIRES_ARGUMENT";
  exports[72] = "EE_SHORT_OPTION_REQUIRES_ARGUMENT";
  exports[73] = "EE_OPTION_IGNORED_DUE_TO_INVALID_VALUE";
  exports[74] = "EE_OPTION_WITH_EMPTY_VALUE";
  exports[75] = "EE_FAILED_TO_ASSIGN_MAX_VALUE_TO_OPTION";
  exports[76] = "EE_INCORRECT_BOOLEAN_VALUE_FOR_OPTION";
  exports[77] = "EE_FAILED_TO_SET_OPTION_VALUE";
  exports[78] = "EE_INCORRECT_INT_VALUE_FOR_OPTION";
  exports[79] = "EE_INCORRECT_UINT_VALUE_FOR_OPTION";
  exports[80] = "EE_ADJUSTED_SIGNED_VALUE_FOR_OPTION";
  exports[81] = "EE_ADJUSTED_UNSIGNED_VALUE_FOR_OPTION";
  exports[82] = "EE_ADJUSTED_ULONGLONG_VALUE_FOR_OPTION";
  exports[83] = "EE_ADJUSTED_DOUBLE_VALUE_FOR_OPTION";
  exports[84] = "EE_INVALID_DECIMAL_VALUE_FOR_OPTION";
  exports[85] = "EE_COLLATION_PARSER_ERROR";
  exports[86] = "EE_FAILED_TO_RESET_BEFORE_PRIMARY_IGNORABLE_CHAR";
  exports[87] = "EE_FAILED_TO_RESET_BEFORE_TERTIARY_IGNORABLE_CHAR";
  exports[88] = "EE_SHIFT_CHAR_OUT_OF_RANGE";
  exports[89] = "EE_RESET_CHAR_OUT_OF_RANGE";
  exports[90] = "EE_UNKNOWN_LDML_TAG";
  exports[91] = "EE_FAILED_TO_RESET_BEFORE_SECONDARY_IGNORABLE_CHAR";
  exports[92] = "EE_FAILED_PROCESSING_DIRECTIVE";
  exports[93] = "EE_PTHREAD_KILL_FAILED";
  exports[120] = "HA_ERR_KEY_NOT_FOUND";
  exports[121] = "HA_ERR_FOUND_DUPP_KEY";
  exports[122] = "HA_ERR_INTERNAL_ERROR";
  exports[123] = "HA_ERR_RECORD_CHANGED";
  exports[124] = "HA_ERR_WRONG_INDEX";
  exports[125] = "HA_ERR_ROLLED_BACK";
  exports[126] = "HA_ERR_CRASHED";
  exports[127] = "HA_ERR_WRONG_IN_RECORD";
  exports[128] = "HA_ERR_OUT_OF_MEM";
  exports[130] = "HA_ERR_NOT_A_TABLE";
  exports[131] = "HA_ERR_WRONG_COMMAND";
  exports[132] = "HA_ERR_OLD_FILE";
  exports[133] = "HA_ERR_NO_ACTIVE_RECORD";
  exports[134] = "HA_ERR_RECORD_DELETED";
  exports[135] = "HA_ERR_RECORD_FILE_FULL";
  exports[136] = "HA_ERR_INDEX_FILE_FULL";
  exports[137] = "HA_ERR_END_OF_FILE";
  exports[138] = "HA_ERR_UNSUPPORTED";
  exports[139] = "HA_ERR_TOO_BIG_ROW";
  exports[140] = "HA_WRONG_CREATE_OPTION";
  exports[141] = "HA_ERR_FOUND_DUPP_UNIQUE";
  exports[142] = "HA_ERR_UNKNOWN_CHARSET";
  exports[143] = "HA_ERR_WRONG_MRG_TABLE_DEF";
  exports[144] = "HA_ERR_CRASHED_ON_REPAIR";
  exports[145] = "HA_ERR_CRASHED_ON_USAGE";
  exports[146] = "HA_ERR_LOCK_WAIT_TIMEOUT";
  exports[147] = "HA_ERR_LOCK_TABLE_FULL";
  exports[148] = "HA_ERR_READ_ONLY_TRANSACTION";
  exports[149] = "HA_ERR_LOCK_DEADLOCK";
  exports[150] = "HA_ERR_CANNOT_ADD_FOREIGN";
  exports[151] = "HA_ERR_NO_REFERENCED_ROW";
  exports[152] = "HA_ERR_ROW_IS_REFERENCED";
  exports[153] = "HA_ERR_NO_SAVEPOINT";
  exports[154] = "HA_ERR_NON_UNIQUE_BLOCK_SIZE";
  exports[155] = "HA_ERR_NO_SUCH_TABLE";
  exports[156] = "HA_ERR_TABLE_EXIST";
  exports[157] = "HA_ERR_NO_CONNECTION";
  exports[158] = "HA_ERR_NULL_IN_SPATIAL";
  exports[159] = "HA_ERR_TABLE_DEF_CHANGED";
  exports[160] = "HA_ERR_NO_PARTITION_FOUND";
  exports[161] = "HA_ERR_RBR_LOGGING_FAILED";
  exports[162] = "HA_ERR_DROP_INDEX_FK";
  exports[163] = "HA_ERR_FOREIGN_DUPLICATE_KEY";
  exports[164] = "HA_ERR_TABLE_NEEDS_UPGRADE";
  exports[165] = "HA_ERR_TABLE_READONLY";
  exports[166] = "HA_ERR_AUTOINC_READ_FAILED";
  exports[167] = "HA_ERR_AUTOINC_ERANGE";
  exports[168] = "HA_ERR_GENERIC";
  exports[169] = "HA_ERR_RECORD_IS_THE_SAME";
  exports[170] = "HA_ERR_LOGGING_IMPOSSIBLE";
  exports[171] = "HA_ERR_CORRUPT_EVENT";
  exports[172] = "HA_ERR_NEW_FILE";
  exports[173] = "HA_ERR_ROWS_EVENT_APPLY";
  exports[174] = "HA_ERR_INITIALIZATION";
  exports[175] = "HA_ERR_FILE_TOO_SHORT";
  exports[176] = "HA_ERR_WRONG_CRC";
  exports[177] = "HA_ERR_TOO_MANY_CONCURRENT_TRXS";
  exports[178] = "HA_ERR_NOT_IN_LOCK_PARTITIONS";
  exports[179] = "HA_ERR_INDEX_COL_TOO_LONG";
  exports[180] = "HA_ERR_INDEX_CORRUPT";
  exports[181] = "HA_ERR_UNDO_REC_TOO_BIG";
  exports[182] = "HA_FTS_INVALID_DOCID";
  exports[183] = "HA_ERR_TABLE_IN_FK_CHECK";
  exports[184] = "HA_ERR_TABLESPACE_EXISTS";
  exports[185] = "HA_ERR_TOO_MANY_FIELDS";
  exports[186] = "HA_ERR_ROW_IN_WRONG_PARTITION";
  exports[187] = "HA_ERR_INNODB_READ_ONLY";
  exports[188] = "HA_ERR_FTS_EXCEED_RESULT_CACHE_LIMIT";
  exports[189] = "HA_ERR_TEMP_FILE_WRITE_FAILURE";
  exports[190] = "HA_ERR_INNODB_FORCED_RECOVERY";
  exports[191] = "HA_ERR_FTS_TOO_MANY_WORDS_IN_PHRASE";
  exports[192] = "HA_ERR_FK_DEPTH_EXCEEDED";
  exports[193] = "HA_MISSING_CREATE_OPTION";
  exports[194] = "HA_ERR_SE_OUT_OF_MEMORY";
  exports[195] = "HA_ERR_TABLE_CORRUPT";
  exports[196] = "HA_ERR_QUERY_INTERRUPTED";
  exports[197] = "HA_ERR_TABLESPACE_MISSING";
  exports[198] = "HA_ERR_TABLESPACE_IS_NOT_EMPTY";
  exports[199] = "HA_ERR_WRONG_FILE_NAME";
  exports[200] = "HA_ERR_NOT_ALLOWED_COMMAND";
  exports[201] = "HA_ERR_COMPUTE_FAILED";
  exports[202] = "HA_ERR_ROW_FORMAT_CHANGED";
  exports[203] = "HA_ERR_NO_WAIT_LOCK";
  exports[204] = "HA_ERR_DISK_FULL_NOWAIT";
  exports[205] = "HA_ERR_NO_SESSION_TEMP";
  exports[206] = "HA_ERR_WRONG_TABLE_NAME";
  exports[207] = "HA_ERR_TOO_LONG_PATH";
  exports[208] = "HA_ERR_SAMPLING_INIT_FAILED";
  exports[209] = "HA_ERR_FTS_TOO_MANY_NESTED_EXP";
  exports[1000] = "ER_HASHCHK";
  exports[1001] = "ER_NISAMCHK";
  exports[1002] = "ER_NO";
  exports[1003] = "ER_YES";
  exports[1004] = "ER_CANT_CREATE_FILE";
  exports[1005] = "ER_CANT_CREATE_TABLE";
  exports[1006] = "ER_CANT_CREATE_DB";
  exports[1007] = "ER_DB_CREATE_EXISTS";
  exports[1008] = "ER_DB_DROP_EXISTS";
  exports[1009] = "ER_DB_DROP_DELETE";
  exports[1010] = "ER_DB_DROP_RMDIR";
  exports[1011] = "ER_CANT_DELETE_FILE";
  exports[1012] = "ER_CANT_FIND_SYSTEM_REC";
  exports[1013] = "ER_CANT_GET_STAT";
  exports[1014] = "ER_CANT_GET_WD";
  exports[1015] = "ER_CANT_LOCK";
  exports[1016] = "ER_CANT_OPEN_FILE";
  exports[1017] = "ER_FILE_NOT_FOUND";
  exports[1018] = "ER_CANT_READ_DIR";
  exports[1019] = "ER_CANT_SET_WD";
  exports[1020] = "ER_CHECKREAD";
  exports[1021] = "ER_DISK_FULL";
  exports[1022] = "ER_DUP_KEY";
  exports[1023] = "ER_ERROR_ON_CLOSE";
  exports[1024] = "ER_ERROR_ON_READ";
  exports[1025] = "ER_ERROR_ON_RENAME";
  exports[1026] = "ER_ERROR_ON_WRITE";
  exports[1027] = "ER_FILE_USED";
  exports[1028] = "ER_FILSORT_ABORT";
  exports[1029] = "ER_FORM_NOT_FOUND";
  exports[1030] = "ER_GET_ERRNO";
  exports[1031] = "ER_ILLEGAL_HA";
  exports[1032] = "ER_KEY_NOT_FOUND";
  exports[1033] = "ER_NOT_FORM_FILE";
  exports[1034] = "ER_NOT_KEYFILE";
  exports[1035] = "ER_OLD_KEYFILE";
  exports[1036] = "ER_OPEN_AS_READONLY";
  exports[1037] = "ER_OUTOFMEMORY";
  exports[1038] = "ER_OUT_OF_SORTMEMORY";
  exports[1039] = "ER_UNEXPECTED_EOF";
  exports[1040] = "ER_CON_COUNT_ERROR";
  exports[1041] = "ER_OUT_OF_RESOURCES";
  exports[1042] = "ER_BAD_HOST_ERROR";
  exports[1043] = "ER_HANDSHAKE_ERROR";
  exports[1044] = "ER_DBACCESS_DENIED_ERROR";
  exports[1045] = "ER_ACCESS_DENIED_ERROR";
  exports[1046] = "ER_NO_DB_ERROR";
  exports[1047] = "ER_UNKNOWN_COM_ERROR";
  exports[1048] = "ER_BAD_NULL_ERROR";
  exports[1049] = "ER_BAD_DB_ERROR";
  exports[1050] = "ER_TABLE_EXISTS_ERROR";
  exports[1051] = "ER_BAD_TABLE_ERROR";
  exports[1052] = "ER_NON_UNIQ_ERROR";
  exports[1053] = "ER_SERVER_SHUTDOWN";
  exports[1054] = "ER_BAD_FIELD_ERROR";
  exports[1055] = "ER_WRONG_FIELD_WITH_GROUP";
  exports[1056] = "ER_WRONG_GROUP_FIELD";
  exports[1057] = "ER_WRONG_SUM_SELECT";
  exports[1058] = "ER_WRONG_VALUE_COUNT";
  exports[1059] = "ER_TOO_LONG_IDENT";
  exports[1060] = "ER_DUP_FIELDNAME";
  exports[1061] = "ER_DUP_KEYNAME";
  exports[1062] = "ER_DUP_ENTRY";
  exports[1063] = "ER_WRONG_FIELD_SPEC";
  exports[1064] = "ER_PARSE_ERROR";
  exports[1065] = "ER_EMPTY_QUERY";
  exports[1066] = "ER_NONUNIQ_TABLE";
  exports[1067] = "ER_INVALID_DEFAULT";
  exports[1068] = "ER_MULTIPLE_PRI_KEY";
  exports[1069] = "ER_TOO_MANY_KEYS";
  exports[1070] = "ER_TOO_MANY_KEY_PARTS";
  exports[1071] = "ER_TOO_LONG_KEY";
  exports[1072] = "ER_KEY_COLUMN_DOES_NOT_EXITS";
  exports[1073] = "ER_BLOB_USED_AS_KEY";
  exports[1074] = "ER_TOO_BIG_FIELDLENGTH";
  exports[1075] = "ER_WRONG_AUTO_KEY";
  exports[1076] = "ER_READY";
  exports[1077] = "ER_NORMAL_SHUTDOWN";
  exports[1078] = "ER_GOT_SIGNAL";
  exports[1079] = "ER_SHUTDOWN_COMPLETE";
  exports[1080] = "ER_FORCING_CLOSE";
  exports[1081] = "ER_IPSOCK_ERROR";
  exports[1082] = "ER_NO_SUCH_INDEX";
  exports[1083] = "ER_WRONG_FIELD_TERMINATORS";
  exports[1084] = "ER_BLOBS_AND_NO_TERMINATED";
  exports[1085] = "ER_TEXTFILE_NOT_READABLE";
  exports[1086] = "ER_FILE_EXISTS_ERROR";
  exports[1087] = "ER_LOAD_INFO";
  exports[1088] = "ER_ALTER_INFO";
  exports[1089] = "ER_WRONG_SUB_KEY";
  exports[1090] = "ER_CANT_REMOVE_ALL_FIELDS";
  exports[1091] = "ER_CANT_DROP_FIELD_OR_KEY";
  exports[1092] = "ER_INSERT_INFO";
  exports[1093] = "ER_UPDATE_TABLE_USED";
  exports[1094] = "ER_NO_SUCH_THREAD";
  exports[1095] = "ER_KILL_DENIED_ERROR";
  exports[1096] = "ER_NO_TABLES_USED";
  exports[1097] = "ER_TOO_BIG_SET";
  exports[1098] = "ER_NO_UNIQUE_LOGFILE";
  exports[1099] = "ER_TABLE_NOT_LOCKED_FOR_WRITE";
  exports[1100] = "ER_TABLE_NOT_LOCKED";
  exports[1101] = "ER_BLOB_CANT_HAVE_DEFAULT";
  exports[1102] = "ER_WRONG_DB_NAME";
  exports[1103] = "ER_WRONG_TABLE_NAME";
  exports[1104] = "ER_TOO_BIG_SELECT";
  exports[1105] = "ER_UNKNOWN_ERROR";
  exports[1106] = "ER_UNKNOWN_PROCEDURE";
  exports[1107] = "ER_WRONG_PARAMCOUNT_TO_PROCEDURE";
  exports[1108] = "ER_WRONG_PARAMETERS_TO_PROCEDURE";
  exports[1109] = "ER_UNKNOWN_TABLE";
  exports[1110] = "ER_FIELD_SPECIFIED_TWICE";
  exports[1111] = "ER_INVALID_GROUP_FUNC_USE";
  exports[1112] = "ER_UNSUPPORTED_EXTENSION";
  exports[1113] = "ER_TABLE_MUST_HAVE_COLUMNS";
  exports[1114] = "ER_RECORD_FILE_FULL";
  exports[1115] = "ER_UNKNOWN_CHARACTER_SET";
  exports[1116] = "ER_TOO_MANY_TABLES";
  exports[1117] = "ER_TOO_MANY_FIELDS";
  exports[1118] = "ER_TOO_BIG_ROWSIZE";
  exports[1119] = "ER_STACK_OVERRUN";
  exports[1120] = "ER_WRONG_OUTER_JOIN";
  exports[1121] = "ER_NULL_COLUMN_IN_INDEX";
  exports[1122] = "ER_CANT_FIND_UDF";
  exports[1123] = "ER_CANT_INITIALIZE_UDF";
  exports[1124] = "ER_UDF_NO_PATHS";
  exports[1125] = "ER_UDF_EXISTS";
  exports[1126] = "ER_CANT_OPEN_LIBRARY";
  exports[1127] = "ER_CANT_FIND_DL_ENTRY";
  exports[1128] = "ER_FUNCTION_NOT_DEFINED";
  exports[1129] = "ER_HOST_IS_BLOCKED";
  exports[1130] = "ER_HOST_NOT_PRIVILEGED";
  exports[1131] = "ER_PASSWORD_ANONYMOUS_USER";
  exports[1132] = "ER_PASSWORD_NOT_ALLOWED";
  exports[1133] = "ER_PASSWORD_NO_MATCH";
  exports[1134] = "ER_UPDATE_INFO";
  exports[1135] = "ER_CANT_CREATE_THREAD";
  exports[1136] = "ER_WRONG_VALUE_COUNT_ON_ROW";
  exports[1137] = "ER_CANT_REOPEN_TABLE";
  exports[1138] = "ER_INVALID_USE_OF_NULL";
  exports[1139] = "ER_REGEXP_ERROR";
  exports[1140] = "ER_MIX_OF_GROUP_FUNC_AND_FIELDS";
  exports[1141] = "ER_NONEXISTING_GRANT";
  exports[1142] = "ER_TABLEACCESS_DENIED_ERROR";
  exports[1143] = "ER_COLUMNACCESS_DENIED_ERROR";
  exports[1144] = "ER_ILLEGAL_GRANT_FOR_TABLE";
  exports[1145] = "ER_GRANT_WRONG_HOST_OR_USER";
  exports[1146] = "ER_NO_SUCH_TABLE";
  exports[1147] = "ER_NONEXISTING_TABLE_GRANT";
  exports[1148] = "ER_NOT_ALLOWED_COMMAND";
  exports[1149] = "ER_SYNTAX_ERROR";
  exports[1150] = "ER_UNUSED1";
  exports[1151] = "ER_UNUSED2";
  exports[1152] = "ER_ABORTING_CONNECTION";
  exports[1153] = "ER_NET_PACKET_TOO_LARGE";
  exports[1154] = "ER_NET_READ_ERROR_FROM_PIPE";
  exports[1155] = "ER_NET_FCNTL_ERROR";
  exports[1156] = "ER_NET_PACKETS_OUT_OF_ORDER";
  exports[1157] = "ER_NET_UNCOMPRESS_ERROR";
  exports[1158] = "ER_NET_READ_ERROR";
  exports[1159] = "ER_NET_READ_INTERRUPTED";
  exports[1160] = "ER_NET_ERROR_ON_WRITE";
  exports[1161] = "ER_NET_WRITE_INTERRUPTED";
  exports[1162] = "ER_TOO_LONG_STRING";
  exports[1163] = "ER_TABLE_CANT_HANDLE_BLOB";
  exports[1164] = "ER_TABLE_CANT_HANDLE_AUTO_INCREMENT";
  exports[1165] = "ER_UNUSED3";
  exports[1166] = "ER_WRONG_COLUMN_NAME";
  exports[1167] = "ER_WRONG_KEY_COLUMN";
  exports[1168] = "ER_WRONG_MRG_TABLE";
  exports[1169] = "ER_DUP_UNIQUE";
  exports[1170] = "ER_BLOB_KEY_WITHOUT_LENGTH";
  exports[1171] = "ER_PRIMARY_CANT_HAVE_NULL";
  exports[1172] = "ER_TOO_MANY_ROWS";
  exports[1173] = "ER_REQUIRES_PRIMARY_KEY";
  exports[1174] = "ER_NO_RAID_COMPILED";
  exports[1175] = "ER_UPDATE_WITHOUT_KEY_IN_SAFE_MODE";
  exports[1176] = "ER_KEY_DOES_NOT_EXITS";
  exports[1177] = "ER_CHECK_NO_SUCH_TABLE";
  exports[1178] = "ER_CHECK_NOT_IMPLEMENTED";
  exports[1179] = "ER_CANT_DO_THIS_DURING_AN_TRANSACTION";
  exports[1180] = "ER_ERROR_DURING_COMMIT";
  exports[1181] = "ER_ERROR_DURING_ROLLBACK";
  exports[1182] = "ER_ERROR_DURING_FLUSH_LOGS";
  exports[1183] = "ER_ERROR_DURING_CHECKPOINT";
  exports[1184] = "ER_NEW_ABORTING_CONNECTION";
  exports[1185] = "ER_DUMP_NOT_IMPLEMENTED";
  exports[1186] = "ER_FLUSH_MASTER_BINLOG_CLOSED";
  exports[1187] = "ER_INDEX_REBUILD";
  exports[1188] = "ER_SOURCE";
  exports[1189] = "ER_SOURCE_NET_READ";
  exports[1190] = "ER_SOURCE_NET_WRITE";
  exports[1191] = "ER_FT_MATCHING_KEY_NOT_FOUND";
  exports[1192] = "ER_LOCK_OR_ACTIVE_TRANSACTION";
  exports[1193] = "ER_UNKNOWN_SYSTEM_VARIABLE";
  exports[1194] = "ER_CRASHED_ON_USAGE";
  exports[1195] = "ER_CRASHED_ON_REPAIR";
  exports[1196] = "ER_WARNING_NOT_COMPLETE_ROLLBACK";
  exports[1197] = "ER_TRANS_CACHE_FULL";
  exports[1198] = "ER_SLAVE_MUST_STOP";
  exports[1199] = "ER_REPLICA_NOT_RUNNING";
  exports[1200] = "ER_BAD_REPLICA";
  exports[1201] = "ER_CONNECTION_METADATA";
  exports[1202] = "ER_REPLICA_THREAD";
  exports[1203] = "ER_TOO_MANY_USER_CONNECTIONS";
  exports[1204] = "ER_SET_CONSTANTS_ONLY";
  exports[1205] = "ER_LOCK_WAIT_TIMEOUT";
  exports[1206] = "ER_LOCK_TABLE_FULL";
  exports[1207] = "ER_READ_ONLY_TRANSACTION";
  exports[1208] = "ER_DROP_DB_WITH_READ_LOCK";
  exports[1209] = "ER_CREATE_DB_WITH_READ_LOCK";
  exports[1210] = "ER_WRONG_ARGUMENTS";
  exports[1211] = "ER_NO_PERMISSION_TO_CREATE_USER";
  exports[1212] = "ER_UNION_TABLES_IN_DIFFERENT_DIR";
  exports[1213] = "ER_LOCK_DEADLOCK";
  exports[1214] = "ER_TABLE_CANT_HANDLE_FT";
  exports[1215] = "ER_CANNOT_ADD_FOREIGN";
  exports[1216] = "ER_NO_REFERENCED_ROW";
  exports[1217] = "ER_ROW_IS_REFERENCED";
  exports[1218] = "ER_CONNECT_TO_SOURCE";
  exports[1219] = "ER_QUERY_ON_MASTER";
  exports[1220] = "ER_ERROR_WHEN_EXECUTING_COMMAND";
  exports[1221] = "ER_WRONG_USAGE";
  exports[1222] = "ER_WRONG_NUMBER_OF_COLUMNS_IN_SELECT";
  exports[1223] = "ER_CANT_UPDATE_WITH_READLOCK";
  exports[1224] = "ER_MIXING_NOT_ALLOWED";
  exports[1225] = "ER_DUP_ARGUMENT";
  exports[1226] = "ER_USER_LIMIT_REACHED";
  exports[1227] = "ER_SPECIFIC_ACCESS_DENIED_ERROR";
  exports[1228] = "ER_LOCAL_VARIABLE";
  exports[1229] = "ER_GLOBAL_VARIABLE";
  exports[1230] = "ER_NO_DEFAULT";
  exports[1231] = "ER_WRONG_VALUE_FOR_VAR";
  exports[1232] = "ER_WRONG_TYPE_FOR_VAR";
  exports[1233] = "ER_VAR_CANT_BE_READ";
  exports[1234] = "ER_CANT_USE_OPTION_HERE";
  exports[1235] = "ER_NOT_SUPPORTED_YET";
  exports[1236] = "ER_SOURCE_FATAL_ERROR_READING_BINLOG";
  exports[1237] = "ER_REPLICA_IGNORED_TABLE";
  exports[1238] = "ER_INCORRECT_GLOBAL_LOCAL_VAR";
  exports[1239] = "ER_WRONG_FK_DEF";
  exports[1240] = "ER_KEY_REF_DO_NOT_MATCH_TABLE_REF";
  exports[1241] = "ER_OPERAND_COLUMNS";
  exports[1242] = "ER_SUBQUERY_NO_1_ROW";
  exports[1243] = "ER_UNKNOWN_STMT_HANDLER";
  exports[1244] = "ER_CORRUPT_HELP_DB";
  exports[1245] = "ER_CYCLIC_REFERENCE";
  exports[1246] = "ER_AUTO_CONVERT";
  exports[1247] = "ER_ILLEGAL_REFERENCE";
  exports[1248] = "ER_DERIVED_MUST_HAVE_ALIAS";
  exports[1249] = "ER_SELECT_REDUCED";
  exports[1250] = "ER_TABLENAME_NOT_ALLOWED_HERE";
  exports[1251] = "ER_NOT_SUPPORTED_AUTH_MODE";
  exports[1252] = "ER_SPATIAL_CANT_HAVE_NULL";
  exports[1253] = "ER_COLLATION_CHARSET_MISMATCH";
  exports[1254] = "ER_SLAVE_WAS_RUNNING";
  exports[1255] = "ER_SLAVE_WAS_NOT_RUNNING";
  exports[1256] = "ER_TOO_BIG_FOR_UNCOMPRESS";
  exports[1257] = "ER_ZLIB_Z_MEM_ERROR";
  exports[1258] = "ER_ZLIB_Z_BUF_ERROR";
  exports[1259] = "ER_ZLIB_Z_DATA_ERROR";
  exports[1260] = "ER_CUT_VALUE_GROUP_CONCAT";
  exports[1261] = "ER_WARN_TOO_FEW_RECORDS";
  exports[1262] = "ER_WARN_TOO_MANY_RECORDS";
  exports[1263] = "ER_WARN_NULL_TO_NOTNULL";
  exports[1264] = "ER_WARN_DATA_OUT_OF_RANGE";
  exports[1265] = "WARN_DATA_TRUNCATED";
  exports[1266] = "ER_WARN_USING_OTHER_HANDLER";
  exports[1267] = "ER_CANT_AGGREGATE_2COLLATIONS";
  exports[1268] = "ER_DROP_USER";
  exports[1269] = "ER_REVOKE_GRANTS";
  exports[1270] = "ER_CANT_AGGREGATE_3COLLATIONS";
  exports[1271] = "ER_CANT_AGGREGATE_NCOLLATIONS";
  exports[1272] = "ER_VARIABLE_IS_NOT_STRUCT";
  exports[1273] = "ER_UNKNOWN_COLLATION";
  exports[1274] = "ER_REPLICA_IGNORED_SSL_PARAMS";
  exports[1275] = "ER_SERVER_IS_IN_SECURE_AUTH_MODE";
  exports[1276] = "ER_WARN_FIELD_RESOLVED";
  exports[1277] = "ER_BAD_REPLICA_UNTIL_COND";
  exports[1278] = "ER_MISSING_SKIP_REPLICA";
  exports[1279] = "ER_UNTIL_COND_IGNORED";
  exports[1280] = "ER_WRONG_NAME_FOR_INDEX";
  exports[1281] = "ER_WRONG_NAME_FOR_CATALOG";
  exports[1282] = "ER_WARN_QC_RESIZE";
  exports[1283] = "ER_BAD_FT_COLUMN";
  exports[1284] = "ER_UNKNOWN_KEY_CACHE";
  exports[1285] = "ER_WARN_HOSTNAME_WONT_WORK";
  exports[1286] = "ER_UNKNOWN_STORAGE_ENGINE";
  exports[1287] = "ER_WARN_DEPRECATED_SYNTAX";
  exports[1288] = "ER_NON_UPDATABLE_TABLE";
  exports[1289] = "ER_FEATURE_DISABLED";
  exports[1290] = "ER_OPTION_PREVENTS_STATEMENT";
  exports[1291] = "ER_DUPLICATED_VALUE_IN_TYPE";
  exports[1292] = "ER_TRUNCATED_WRONG_VALUE";
  exports[1293] = "ER_TOO_MUCH_AUTO_TIMESTAMP_COLS";
  exports[1294] = "ER_INVALID_ON_UPDATE";
  exports[1295] = "ER_UNSUPPORTED_PS";
  exports[1296] = "ER_GET_ERRMSG";
  exports[1297] = "ER_GET_TEMPORARY_ERRMSG";
  exports[1298] = "ER_UNKNOWN_TIME_ZONE";
  exports[1299] = "ER_WARN_INVALID_TIMESTAMP";
  exports[1300] = "ER_INVALID_CHARACTER_STRING";
  exports[1301] = "ER_WARN_ALLOWED_PACKET_OVERFLOWED";
  exports[1302] = "ER_CONFLICTING_DECLARATIONS";
  exports[1303] = "ER_SP_NO_RECURSIVE_CREATE";
  exports[1304] = "ER_SP_ALREADY_EXISTS";
  exports[1305] = "ER_SP_DOES_NOT_EXIST";
  exports[1306] = "ER_SP_DROP_FAILED";
  exports[1307] = "ER_SP_STORE_FAILED";
  exports[1308] = "ER_SP_LILABEL_MISMATCH";
  exports[1309] = "ER_SP_LABEL_REDEFINE";
  exports[1310] = "ER_SP_LABEL_MISMATCH";
  exports[1311] = "ER_SP_UNINIT_VAR";
  exports[1312] = "ER_SP_BADSELECT";
  exports[1313] = "ER_SP_BADRETURN";
  exports[1314] = "ER_SP_BADSTATEMENT";
  exports[1315] = "ER_UPDATE_LOG_DEPRECATED_IGNORED";
  exports[1316] = "ER_UPDATE_LOG_DEPRECATED_TRANSLATED";
  exports[1317] = "ER_QUERY_INTERRUPTED";
  exports[1318] = "ER_SP_WRONG_NO_OF_ARGS";
  exports[1319] = "ER_SP_COND_MISMATCH";
  exports[1320] = "ER_SP_NORETURN";
  exports[1321] = "ER_SP_NORETURNEND";
  exports[1322] = "ER_SP_BAD_CURSOR_QUERY";
  exports[1323] = "ER_SP_BAD_CURSOR_SELECT";
  exports[1324] = "ER_SP_CURSOR_MISMATCH";
  exports[1325] = "ER_SP_CURSOR_ALREADY_OPEN";
  exports[1326] = "ER_SP_CURSOR_NOT_OPEN";
  exports[1327] = "ER_SP_UNDECLARED_VAR";
  exports[1328] = "ER_SP_WRONG_NO_OF_FETCH_ARGS";
  exports[1329] = "ER_SP_FETCH_NO_DATA";
  exports[1330] = "ER_SP_DUP_PARAM";
  exports[1331] = "ER_SP_DUP_VAR";
  exports[1332] = "ER_SP_DUP_COND";
  exports[1333] = "ER_SP_DUP_CURS";
  exports[1334] = "ER_SP_CANT_ALTER";
  exports[1335] = "ER_SP_SUBSELECT_NYI";
  exports[1336] = "ER_STMT_NOT_ALLOWED_IN_SF_OR_TRG";
  exports[1337] = "ER_SP_VARCOND_AFTER_CURSHNDLR";
  exports[1338] = "ER_SP_CURSOR_AFTER_HANDLER";
  exports[1339] = "ER_SP_CASE_NOT_FOUND";
  exports[1340] = "ER_FPARSER_TOO_BIG_FILE";
  exports[1341] = "ER_FPARSER_BAD_HEADER";
  exports[1342] = "ER_FPARSER_EOF_IN_COMMENT";
  exports[1343] = "ER_FPARSER_ERROR_IN_PARAMETER";
  exports[1344] = "ER_FPARSER_EOF_IN_UNKNOWN_PARAMETER";
  exports[1345] = "ER_VIEW_NO_EXPLAIN";
  exports[1346] = "ER_FRM_UNKNOWN_TYPE";
  exports[1347] = "ER_WRONG_OBJECT";
  exports[1348] = "ER_NONUPDATEABLE_COLUMN";
  exports[1349] = "ER_VIEW_SELECT_DERIVED";
  exports[1350] = "ER_VIEW_SELECT_CLAUSE";
  exports[1351] = "ER_VIEW_SELECT_VARIABLE";
  exports[1352] = "ER_VIEW_SELECT_TMPTABLE";
  exports[1353] = "ER_VIEW_WRONG_LIST";
  exports[1354] = "ER_WARN_VIEW_MERGE";
  exports[1355] = "ER_WARN_VIEW_WITHOUT_KEY";
  exports[1356] = "ER_VIEW_INVALID";
  exports[1357] = "ER_SP_NO_DROP_SP";
  exports[1358] = "ER_SP_GOTO_IN_HNDLR";
  exports[1359] = "ER_TRG_ALREADY_EXISTS";
  exports[1360] = "ER_TRG_DOES_NOT_EXIST";
  exports[1361] = "ER_TRG_ON_VIEW_OR_TEMP_TABLE";
  exports[1362] = "ER_TRG_CANT_CHANGE_ROW";
  exports[1363] = "ER_TRG_NO_SUCH_ROW_IN_TRG";
  exports[1364] = "ER_NO_DEFAULT_FOR_FIELD";
  exports[1365] = "ER_DIVISION_BY_ZERO";
  exports[1366] = "ER_TRUNCATED_WRONG_VALUE_FOR_FIELD";
  exports[1367] = "ER_ILLEGAL_VALUE_FOR_TYPE";
  exports[1368] = "ER_VIEW_NONUPD_CHECK";
  exports[1369] = "ER_VIEW_CHECK_FAILED";
  exports[1370] = "ER_PROCACCESS_DENIED_ERROR";
  exports[1371] = "ER_RELAY_LOG_FAIL";
  exports[1372] = "ER_PASSWD_LENGTH";
  exports[1373] = "ER_UNKNOWN_TARGET_BINLOG";
  exports[1374] = "ER_IO_ERR_LOG_INDEX_READ";
  exports[1375] = "ER_BINLOG_PURGE_PROHIBITED";
  exports[1376] = "ER_FSEEK_FAIL";
  exports[1377] = "ER_BINLOG_PURGE_FATAL_ERR";
  exports[1378] = "ER_LOG_IN_USE";
  exports[1379] = "ER_LOG_PURGE_UNKNOWN_ERR";
  exports[1380] = "ER_RELAY_LOG_INIT";
  exports[1381] = "ER_NO_BINARY_LOGGING";
  exports[1382] = "ER_RESERVED_SYNTAX";
  exports[1383] = "ER_WSAS_FAILED";
  exports[1384] = "ER_DIFF_GROUPS_PROC";
  exports[1385] = "ER_NO_GROUP_FOR_PROC";
  exports[1386] = "ER_ORDER_WITH_PROC";
  exports[1387] = "ER_LOGGING_PROHIBIT_CHANGING_OF";
  exports[1388] = "ER_NO_FILE_MAPPING";
  exports[1389] = "ER_WRONG_MAGIC";
  exports[1390] = "ER_PS_MANY_PARAM";
  exports[1391] = "ER_KEY_PART_0";
  exports[1392] = "ER_VIEW_CHECKSUM";
  exports[1393] = "ER_VIEW_MULTIUPDATE";
  exports[1394] = "ER_VIEW_NO_INSERT_FIELD_LIST";
  exports[1395] = "ER_VIEW_DELETE_MERGE_VIEW";
  exports[1396] = "ER_CANNOT_USER";
  exports[1397] = "ER_XAER_NOTA";
  exports[1398] = "ER_XAER_INVAL";
  exports[1399] = "ER_XAER_RMFAIL";
  exports[1400] = "ER_XAER_OUTSIDE";
  exports[1401] = "ER_XAER_RMERR";
  exports[1402] = "ER_XA_RBROLLBACK";
  exports[1403] = "ER_NONEXISTING_PROC_GRANT";
  exports[1404] = "ER_PROC_AUTO_GRANT_FAIL";
  exports[1405] = "ER_PROC_AUTO_REVOKE_FAIL";
  exports[1406] = "ER_DATA_TOO_LONG";
  exports[1407] = "ER_SP_BAD_SQLSTATE";
  exports[1408] = "ER_STARTUP";
  exports[1409] = "ER_LOAD_FROM_FIXED_SIZE_ROWS_TO_VAR";
  exports[1410] = "ER_CANT_CREATE_USER_WITH_GRANT";
  exports[1411] = "ER_WRONG_VALUE_FOR_TYPE";
  exports[1412] = "ER_TABLE_DEF_CHANGED";
  exports[1413] = "ER_SP_DUP_HANDLER";
  exports[1414] = "ER_SP_NOT_VAR_ARG";
  exports[1415] = "ER_SP_NO_RETSET";
  exports[1416] = "ER_CANT_CREATE_GEOMETRY_OBJECT";
  exports[1417] = "ER_FAILED_ROUTINE_BREAK_BINLOG";
  exports[1418] = "ER_BINLOG_UNSAFE_ROUTINE";
  exports[1419] = "ER_BINLOG_CREATE_ROUTINE_NEED_SUPER";
  exports[1420] = "ER_EXEC_STMT_WITH_OPEN_CURSOR";
  exports[1421] = "ER_STMT_HAS_NO_OPEN_CURSOR";
  exports[1422] = "ER_COMMIT_NOT_ALLOWED_IN_SF_OR_TRG";
  exports[1423] = "ER_NO_DEFAULT_FOR_VIEW_FIELD";
  exports[1424] = "ER_SP_NO_RECURSION";
  exports[1425] = "ER_TOO_BIG_SCALE";
  exports[1426] = "ER_TOO_BIG_PRECISION";
  exports[1427] = "ER_M_BIGGER_THAN_D";
  exports[1428] = "ER_WRONG_LOCK_OF_SYSTEM_TABLE";
  exports[1429] = "ER_CONNECT_TO_FOREIGN_DATA_SOURCE";
  exports[1430] = "ER_QUERY_ON_FOREIGN_DATA_SOURCE";
  exports[1431] = "ER_FOREIGN_DATA_SOURCE_DOESNT_EXIST";
  exports[1432] = "ER_FOREIGN_DATA_STRING_INVALID_CANT_CREATE";
  exports[1433] = "ER_FOREIGN_DATA_STRING_INVALID";
  exports[1434] = "ER_CANT_CREATE_FEDERATED_TABLE";
  exports[1435] = "ER_TRG_IN_WRONG_SCHEMA";
  exports[1436] = "ER_STACK_OVERRUN_NEED_MORE";
  exports[1437] = "ER_TOO_LONG_BODY";
  exports[1438] = "ER_WARN_CANT_DROP_DEFAULT_KEYCACHE";
  exports[1439] = "ER_TOO_BIG_DISPLAYWIDTH";
  exports[1440] = "ER_XAER_DUPID";
  exports[1441] = "ER_DATETIME_FUNCTION_OVERFLOW";
  exports[1442] = "ER_CANT_UPDATE_USED_TABLE_IN_SF_OR_TRG";
  exports[1443] = "ER_VIEW_PREVENT_UPDATE";
  exports[1444] = "ER_PS_NO_RECURSION";
  exports[1445] = "ER_SP_CANT_SET_AUTOCOMMIT";
  exports[1446] = "ER_MALFORMED_DEFINER";
  exports[1447] = "ER_VIEW_FRM_NO_USER";
  exports[1448] = "ER_VIEW_OTHER_USER";
  exports[1449] = "ER_NO_SUCH_USER";
  exports[1450] = "ER_FORBID_SCHEMA_CHANGE";
  exports[1451] = "ER_ROW_IS_REFERENCED_2";
  exports[1452] = "ER_NO_REFERENCED_ROW_2";
  exports[1453] = "ER_SP_BAD_VAR_SHADOW";
  exports[1454] = "ER_TRG_NO_DEFINER";
  exports[1455] = "ER_OLD_FILE_FORMAT";
  exports[1456] = "ER_SP_RECURSION_LIMIT";
  exports[1457] = "ER_SP_PROC_TABLE_CORRUPT";
  exports[1458] = "ER_SP_WRONG_NAME";
  exports[1459] = "ER_TABLE_NEEDS_UPGRADE";
  exports[1460] = "ER_SP_NO_AGGREGATE";
  exports[1461] = "ER_MAX_PREPARED_STMT_COUNT_REACHED";
  exports[1462] = "ER_VIEW_RECURSIVE";
  exports[1463] = "ER_NON_GROUPING_FIELD_USED";
  exports[1464] = "ER_TABLE_CANT_HANDLE_SPKEYS";
  exports[1465] = "ER_NO_TRIGGERS_ON_SYSTEM_SCHEMA";
  exports[1466] = "ER_REMOVED_SPACES";
  exports[1467] = "ER_AUTOINC_READ_FAILED";
  exports[1468] = "ER_USERNAME";
  exports[1469] = "ER_HOSTNAME";
  exports[1470] = "ER_WRONG_STRING_LENGTH";
  exports[1471] = "ER_NON_INSERTABLE_TABLE";
  exports[1472] = "ER_ADMIN_WRONG_MRG_TABLE";
  exports[1473] = "ER_TOO_HIGH_LEVEL_OF_NESTING_FOR_SELECT";
  exports[1474] = "ER_NAME_BECOMES_EMPTY";
  exports[1475] = "ER_AMBIGUOUS_FIELD_TERM";
  exports[1476] = "ER_FOREIGN_SERVER_EXISTS";
  exports[1477] = "ER_FOREIGN_SERVER_DOESNT_EXIST";
  exports[1478] = "ER_ILLEGAL_HA_CREATE_OPTION";
  exports[1479] = "ER_PARTITION_REQUIRES_VALUES_ERROR";
  exports[1480] = "ER_PARTITION_WRONG_VALUES_ERROR";
  exports[1481] = "ER_PARTITION_MAXVALUE_ERROR";
  exports[1482] = "ER_PARTITION_SUBPARTITION_ERROR";
  exports[1483] = "ER_PARTITION_SUBPART_MIX_ERROR";
  exports[1484] = "ER_PARTITION_WRONG_NO_PART_ERROR";
  exports[1485] = "ER_PARTITION_WRONG_NO_SUBPART_ERROR";
  exports[1486] = "ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR";
  exports[1487] = "ER_NO_CONST_EXPR_IN_RANGE_OR_LIST_ERROR";
  exports[1488] = "ER_FIELD_NOT_FOUND_PART_ERROR";
  exports[1489] = "ER_LIST_OF_FIELDS_ONLY_IN_HASH_ERROR";
  exports[1490] = "ER_INCONSISTENT_PARTITION_INFO_ERROR";
  exports[1491] = "ER_PARTITION_FUNC_NOT_ALLOWED_ERROR";
  exports[1492] = "ER_PARTITIONS_MUST_BE_DEFINED_ERROR";
  exports[1493] = "ER_RANGE_NOT_INCREASING_ERROR";
  exports[1494] = "ER_INCONSISTENT_TYPE_OF_FUNCTIONS_ERROR";
  exports[1495] = "ER_MULTIPLE_DEF_CONST_IN_LIST_PART_ERROR";
  exports[1496] = "ER_PARTITION_ENTRY_ERROR";
  exports[1497] = "ER_MIX_HANDLER_ERROR";
  exports[1498] = "ER_PARTITION_NOT_DEFINED_ERROR";
  exports[1499] = "ER_TOO_MANY_PARTITIONS_ERROR";
  exports[1500] = "ER_SUBPARTITION_ERROR";
  exports[1501] = "ER_CANT_CREATE_HANDLER_FILE";
  exports[1502] = "ER_BLOB_FIELD_IN_PART_FUNC_ERROR";
  exports[1503] = "ER_UNIQUE_KEY_NEED_ALL_FIELDS_IN_PF";
  exports[1504] = "ER_NO_PARTS_ERROR";
  exports[1505] = "ER_PARTITION_MGMT_ON_NONPARTITIONED";
  exports[1506] = "ER_FOREIGN_KEY_ON_PARTITIONED";
  exports[1507] = "ER_DROP_PARTITION_NON_EXISTENT";
  exports[1508] = "ER_DROP_LAST_PARTITION";
  exports[1509] = "ER_COALESCE_ONLY_ON_HASH_PARTITION";
  exports[1510] = "ER_REORG_HASH_ONLY_ON_SAME_NO";
  exports[1511] = "ER_REORG_NO_PARAM_ERROR";
  exports[1512] = "ER_ONLY_ON_RANGE_LIST_PARTITION";
  exports[1513] = "ER_ADD_PARTITION_SUBPART_ERROR";
  exports[1514] = "ER_ADD_PARTITION_NO_NEW_PARTITION";
  exports[1515] = "ER_COALESCE_PARTITION_NO_PARTITION";
  exports[1516] = "ER_REORG_PARTITION_NOT_EXIST";
  exports[1517] = "ER_SAME_NAME_PARTITION";
  exports[1518] = "ER_NO_BINLOG_ERROR";
  exports[1519] = "ER_CONSECUTIVE_REORG_PARTITIONS";
  exports[1520] = "ER_REORG_OUTSIDE_RANGE";
  exports[1521] = "ER_PARTITION_FUNCTION_FAILURE";
  exports[1522] = "ER_PART_STATE_ERROR";
  exports[1523] = "ER_LIMITED_PART_RANGE";
  exports[1524] = "ER_PLUGIN_IS_NOT_LOADED";
  exports[1525] = "ER_WRONG_VALUE";
  exports[1526] = "ER_NO_PARTITION_FOR_GIVEN_VALUE";
  exports[1527] = "ER_FILEGROUP_OPTION_ONLY_ONCE";
  exports[1528] = "ER_CREATE_FILEGROUP_FAILED";
  exports[1529] = "ER_DROP_FILEGROUP_FAILED";
  exports[1530] = "ER_TABLESPACE_AUTO_EXTEND_ERROR";
  exports[1531] = "ER_WRONG_SIZE_NUMBER";
  exports[1532] = "ER_SIZE_OVERFLOW_ERROR";
  exports[1533] = "ER_ALTER_FILEGROUP_FAILED";
  exports[1534] = "ER_BINLOG_ROW_LOGGING_FAILED";
  exports[1535] = "ER_BINLOG_ROW_WRONG_TABLE_DEF";
  exports[1536] = "ER_BINLOG_ROW_RBR_TO_SBR";
  exports[1537] = "ER_EVENT_ALREADY_EXISTS";
  exports[1538] = "ER_EVENT_STORE_FAILED";
  exports[1539] = "ER_EVENT_DOES_NOT_EXIST";
  exports[1540] = "ER_EVENT_CANT_ALTER";
  exports[1541] = "ER_EVENT_DROP_FAILED";
  exports[1542] = "ER_EVENT_INTERVAL_NOT_POSITIVE_OR_TOO_BIG";
  exports[1543] = "ER_EVENT_ENDS_BEFORE_STARTS";
  exports[1544] = "ER_EVENT_EXEC_TIME_IN_THE_PAST";
  exports[1545] = "ER_EVENT_OPEN_TABLE_FAILED";
  exports[1546] = "ER_EVENT_NEITHER_M_EXPR_NOR_M_AT";
  exports[1547] = "ER_COL_COUNT_DOESNT_MATCH_CORRUPTED";
  exports[1548] = "ER_CANNOT_LOAD_FROM_TABLE";
  exports[1549] = "ER_EVENT_CANNOT_DELETE";
  exports[1550] = "ER_EVENT_COMPILE_ERROR";
  exports[1551] = "ER_EVENT_SAME_NAME";
  exports[1552] = "ER_EVENT_DATA_TOO_LONG";
  exports[1553] = "ER_DROP_INDEX_FK";
  exports[1554] = "ER_WARN_DEPRECATED_SYNTAX_WITH_VER";
  exports[1555] = "ER_CANT_WRITE_LOCK_LOG_TABLE";
  exports[1556] = "ER_CANT_LOCK_LOG_TABLE";
  exports[1557] = "ER_FOREIGN_DUPLICATE_KEY";
  exports[1558] = "ER_COL_COUNT_DOESNT_MATCH_PLEASE_UPDATE";
  exports[1559] = "ER_TEMP_TABLE_PREVENTS_SWITCH_OUT_OF_RBR";
  exports[1560] = "ER_STORED_FUNCTION_PREVENTS_SWITCH_BINLOG_FORMAT";
  exports[1561] = "ER_NDB_CANT_SWITCH_BINLOG_FORMAT";
  exports[1562] = "ER_PARTITION_NO_TEMPORARY";
  exports[1563] = "ER_PARTITION_CONST_DOMAIN_ERROR";
  exports[1564] = "ER_PARTITION_FUNCTION_IS_NOT_ALLOWED";
  exports[1565] = "ER_DDL_LOG_ERROR";
  exports[1566] = "ER_NULL_IN_VALUES_LESS_THAN";
  exports[1567] = "ER_WRONG_PARTITION_NAME";
  exports[1568] = "ER_CANT_CHANGE_TX_CHARACTERISTICS";
  exports[1569] = "ER_DUP_ENTRY_AUTOINCREMENT_CASE";
  exports[1570] = "ER_EVENT_MODIFY_QUEUE_ERROR";
  exports[1571] = "ER_EVENT_SET_VAR_ERROR";
  exports[1572] = "ER_PARTITION_MERGE_ERROR";
  exports[1573] = "ER_CANT_ACTIVATE_LOG";
  exports[1574] = "ER_RBR_NOT_AVAILABLE";
  exports[1575] = "ER_BASE64_DECODE_ERROR";
  exports[1576] = "ER_EVENT_RECURSION_FORBIDDEN";
  exports[1577] = "ER_EVENTS_DB_ERROR";
  exports[1578] = "ER_ONLY_INTEGERS_ALLOWED";
  exports[1579] = "ER_UNSUPORTED_LOG_ENGINE";
  exports[1580] = "ER_BAD_LOG_STATEMENT";
  exports[1581] = "ER_CANT_RENAME_LOG_TABLE";
  exports[1582] = "ER_WRONG_PARAMCOUNT_TO_NATIVE_FCT";
  exports[1583] = "ER_WRONG_PARAMETERS_TO_NATIVE_FCT";
  exports[1584] = "ER_WRONG_PARAMETERS_TO_STORED_FCT";
  exports[1585] = "ER_NATIVE_FCT_NAME_COLLISION";
  exports[1586] = "ER_DUP_ENTRY_WITH_KEY_NAME";
  exports[1587] = "ER_BINLOG_PURGE_EMFILE";
  exports[1588] = "ER_EVENT_CANNOT_CREATE_IN_THE_PAST";
  exports[1589] = "ER_EVENT_CANNOT_ALTER_IN_THE_PAST";
  exports[1590] = "ER_SLAVE_INCIDENT";
  exports[1591] = "ER_NO_PARTITION_FOR_GIVEN_VALUE_SILENT";
  exports[1592] = "ER_BINLOG_UNSAFE_STATEMENT";
  exports[1593] = "ER_BINLOG_FATAL_ERROR";
  exports[1594] = "ER_SLAVE_RELAY_LOG_READ_FAILURE";
  exports[1595] = "ER_SLAVE_RELAY_LOG_WRITE_FAILURE";
  exports[1596] = "ER_SLAVE_CREATE_EVENT_FAILURE";
  exports[1597] = "ER_SLAVE_MASTER_COM_FAILURE";
  exports[1598] = "ER_BINLOG_LOGGING_IMPOSSIBLE";
  exports[1599] = "ER_VIEW_NO_CREATION_CTX";
  exports[1600] = "ER_VIEW_INVALID_CREATION_CTX";
  exports[1601] = "ER_SR_INVALID_CREATION_CTX";
  exports[1602] = "ER_TRG_CORRUPTED_FILE";
  exports[1603] = "ER_TRG_NO_CREATION_CTX";
  exports[1604] = "ER_TRG_INVALID_CREATION_CTX";
  exports[1605] = "ER_EVENT_INVALID_CREATION_CTX";
  exports[1606] = "ER_TRG_CANT_OPEN_TABLE";
  exports[1607] = "ER_CANT_CREATE_SROUTINE";
  exports[1608] = "ER_NEVER_USED";
  exports[1609] = "ER_NO_FORMAT_DESCRIPTION_EVENT_BEFORE_BINLOG_STATEMENT";
  exports[1610] = "ER_REPLICA_CORRUPT_EVENT";
  exports[1611] = "ER_LOAD_DATA_INVALID_COLUMN";
  exports[1612] = "ER_LOG_PURGE_NO_FILE";
  exports[1613] = "ER_XA_RBTIMEOUT";
  exports[1614] = "ER_XA_RBDEADLOCK";
  exports[1615] = "ER_NEED_REPREPARE";
  exports[1616] = "ER_DELAYED_NOT_SUPPORTED";
  exports[1617] = "WARN_NO_CONNECTION_METADATA";
  exports[1618] = "WARN_OPTION_IGNORED";
  exports[1619] = "ER_PLUGIN_DELETE_BUILTIN";
  exports[1620] = "WARN_PLUGIN_BUSY";
  exports[1621] = "ER_VARIABLE_IS_READONLY";
  exports[1622] = "ER_WARN_ENGINE_TRANSACTION_ROLLBACK";
  exports[1623] = "ER_SLAVE_HEARTBEAT_FAILURE";
  exports[1624] = "ER_REPLICA_HEARTBEAT_VALUE_OUT_OF_RANGE";
  exports[1625] = "ER_NDB_REPLICATION_SCHEMA_ERROR";
  exports[1626] = "ER_CONFLICT_FN_PARSE_ERROR";
  exports[1627] = "ER_EXCEPTIONS_WRITE_ERROR";
  exports[1628] = "ER_TOO_LONG_TABLE_COMMENT";
  exports[1629] = "ER_TOO_LONG_FIELD_COMMENT";
  exports[1630] = "ER_FUNC_INEXISTENT_NAME_COLLISION";
  exports[1631] = "ER_DATABASE_NAME";
  exports[1632] = "ER_TABLE_NAME";
  exports[1633] = "ER_PARTITION_NAME";
  exports[1634] = "ER_SUBPARTITION_NAME";
  exports[1635] = "ER_TEMPORARY_NAME";
  exports[1636] = "ER_RENAMED_NAME";
  exports[1637] = "ER_TOO_MANY_CONCURRENT_TRXS";
  exports[1638] = "WARN_NON_ASCII_SEPARATOR_NOT_IMPLEMENTED";
  exports[1639] = "ER_DEBUG_SYNC_TIMEOUT";
  exports[1640] = "ER_DEBUG_SYNC_HIT_LIMIT";
  exports[1641] = "ER_DUP_SIGNAL_SET";
  exports[1642] = "ER_SIGNAL_WARN";
  exports[1643] = "ER_SIGNAL_NOT_FOUND";
  exports[1644] = "ER_SIGNAL_EXCEPTION";
  exports[1645] = "ER_RESIGNAL_WITHOUT_ACTIVE_HANDLER";
  exports[1646] = "ER_SIGNAL_BAD_CONDITION_TYPE";
  exports[1647] = "WARN_COND_ITEM_TRUNCATED";
  exports[1648] = "ER_COND_ITEM_TOO_LONG";
  exports[1649] = "ER_UNKNOWN_LOCALE";
  exports[1650] = "ER_REPLICA_IGNORE_SERVER_IDS";
  exports[1651] = "ER_QUERY_CACHE_DISABLED";
  exports[1652] = "ER_SAME_NAME_PARTITION_FIELD";
  exports[1653] = "ER_PARTITION_COLUMN_LIST_ERROR";
  exports[1654] = "ER_WRONG_TYPE_COLUMN_VALUE_ERROR";
  exports[1655] = "ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR";
  exports[1656] = "ER_MAXVALUE_IN_VALUES_IN";
  exports[1657] = "ER_TOO_MANY_VALUES_ERROR";
  exports[1658] = "ER_ROW_SINGLE_PARTITION_FIELD_ERROR";
  exports[1659] = "ER_FIELD_TYPE_NOT_ALLOWED_AS_PARTITION_FIELD";
  exports[1660] = "ER_PARTITION_FIELDS_TOO_LONG";
  exports[1661] = "ER_BINLOG_ROW_ENGINE_AND_STMT_ENGINE";
  exports[1662] = "ER_BINLOG_ROW_MODE_AND_STMT_ENGINE";
  exports[1663] = "ER_BINLOG_UNSAFE_AND_STMT_ENGINE";
  exports[1664] = "ER_BINLOG_ROW_INJECTION_AND_STMT_ENGINE";
  exports[1665] = "ER_BINLOG_STMT_MODE_AND_ROW_ENGINE";
  exports[1666] = "ER_BINLOG_ROW_INJECTION_AND_STMT_MODE";
  exports[1667] = "ER_BINLOG_MULTIPLE_ENGINES_AND_SELF_LOGGING_ENGINE";
  exports[1668] = "ER_BINLOG_UNSAFE_LIMIT";
  exports[1669] = "ER_UNUSED4";
  exports[1670] = "ER_BINLOG_UNSAFE_SYSTEM_TABLE";
  exports[1671] = "ER_BINLOG_UNSAFE_AUTOINC_COLUMNS";
  exports[1672] = "ER_BINLOG_UNSAFE_UDF";
  exports[1673] = "ER_BINLOG_UNSAFE_SYSTEM_VARIABLE";
  exports[1674] = "ER_BINLOG_UNSAFE_SYSTEM_FUNCTION";
  exports[1675] = "ER_BINLOG_UNSAFE_NONTRANS_AFTER_TRANS";
  exports[1676] = "ER_MESSAGE_AND_STATEMENT";
  exports[1677] = "ER_SLAVE_CONVERSION_FAILED";
  exports[1678] = "ER_REPLICA_CANT_CREATE_CONVERSION";
  exports[1679] = "ER_INSIDE_TRANSACTION_PREVENTS_SWITCH_BINLOG_FORMAT";
  exports[1680] = "ER_PATH_LENGTH";
  exports[1681] = "ER_WARN_DEPRECATED_SYNTAX_NO_REPLACEMENT";
  exports[1682] = "ER_WRONG_NATIVE_TABLE_STRUCTURE";
  exports[1683] = "ER_WRONG_PERFSCHEMA_USAGE";
  exports[1684] = "ER_WARN_I_S_SKIPPED_TABLE";
  exports[1685] = "ER_INSIDE_TRANSACTION_PREVENTS_SWITCH_BINLOG_DIRECT";
  exports[1686] = "ER_STORED_FUNCTION_PREVENTS_SWITCH_BINLOG_DIRECT";
  exports[1687] = "ER_SPATIAL_MUST_HAVE_GEOM_COL";
  exports[1688] = "ER_TOO_LONG_INDEX_COMMENT";
  exports[1689] = "ER_LOCK_ABORTED";
  exports[1690] = "ER_DATA_OUT_OF_RANGE";
  exports[1691] = "ER_WRONG_SPVAR_TYPE_IN_LIMIT";
  exports[1692] = "ER_BINLOG_UNSAFE_MULTIPLE_ENGINES_AND_SELF_LOGGING_ENGINE";
  exports[1693] = "ER_BINLOG_UNSAFE_MIXED_STATEMENT";
  exports[1694] = "ER_INSIDE_TRANSACTION_PREVENTS_SWITCH_SQL_LOG_BIN";
  exports[1695] = "ER_STORED_FUNCTION_PREVENTS_SWITCH_SQL_LOG_BIN";
  exports[1696] = "ER_FAILED_READ_FROM_PAR_FILE";
  exports[1697] = "ER_VALUES_IS_NOT_INT_TYPE_ERROR";
  exports[1698] = "ER_ACCESS_DENIED_NO_PASSWORD_ERROR";
  exports[1699] = "ER_SET_PASSWORD_AUTH_PLUGIN";
  exports[1700] = "ER_GRANT_PLUGIN_USER_EXISTS";
  exports[1701] = "ER_TRUNCATE_ILLEGAL_FK";
  exports[1702] = "ER_PLUGIN_IS_PERMANENT";
  exports[1703] = "ER_REPLICA_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN";
  exports[1704] = "ER_REPLICA_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX";
  exports[1705] = "ER_STMT_CACHE_FULL";
  exports[1706] = "ER_MULTI_UPDATE_KEY_CONFLICT";
  exports[1707] = "ER_TABLE_NEEDS_REBUILD";
  exports[1708] = "WARN_OPTION_BELOW_LIMIT";
  exports[1709] = "ER_INDEX_COLUMN_TOO_LONG";
  exports[1710] = "ER_ERROR_IN_TRIGGER_BODY";
  exports[1711] = "ER_ERROR_IN_UNKNOWN_TRIGGER_BODY";
  exports[1712] = "ER_INDEX_CORRUPT";
  exports[1713] = "ER_UNDO_RECORD_TOO_BIG";
  exports[1714] = "ER_BINLOG_UNSAFE_INSERT_IGNORE_SELECT";
  exports[1715] = "ER_BINLOG_UNSAFE_INSERT_SELECT_UPDATE";
  exports[1716] = "ER_BINLOG_UNSAFE_REPLACE_SELECT";
  exports[1717] = "ER_BINLOG_UNSAFE_CREATE_IGNORE_SELECT";
  exports[1718] = "ER_BINLOG_UNSAFE_CREATE_REPLACE_SELECT";
  exports[1719] = "ER_BINLOG_UNSAFE_UPDATE_IGNORE";
  exports[1720] = "ER_PLUGIN_NO_UNINSTALL";
  exports[1721] = "ER_PLUGIN_NO_INSTALL";
  exports[1722] = "ER_BINLOG_UNSAFE_WRITE_AUTOINC_SELECT";
  exports[1723] = "ER_BINLOG_UNSAFE_CREATE_SELECT_AUTOINC";
  exports[1724] = "ER_BINLOG_UNSAFE_INSERT_TWO_KEYS";
  exports[1725] = "ER_TABLE_IN_FK_CHECK";
  exports[1726] = "ER_UNSUPPORTED_ENGINE";
  exports[1727] = "ER_BINLOG_UNSAFE_AUTOINC_NOT_FIRST";
  exports[1728] = "ER_CANNOT_LOAD_FROM_TABLE_V2";
  exports[1729] = "ER_SOURCE_DELAY_VALUE_OUT_OF_RANGE";
  exports[1730] = "ER_ONLY_FD_AND_RBR_EVENTS_ALLOWED_IN_BINLOG_STATEMENT";
  exports[1731] = "ER_PARTITION_EXCHANGE_DIFFERENT_OPTION";
  exports[1732] = "ER_PARTITION_EXCHANGE_PART_TABLE";
  exports[1733] = "ER_PARTITION_EXCHANGE_TEMP_TABLE";
  exports[1734] = "ER_PARTITION_INSTEAD_OF_SUBPARTITION";
  exports[1735] = "ER_UNKNOWN_PARTITION";
  exports[1736] = "ER_TABLES_DIFFERENT_METADATA";
  exports[1737] = "ER_ROW_DOES_NOT_MATCH_PARTITION";
  exports[1738] = "ER_BINLOG_CACHE_SIZE_GREATER_THAN_MAX";
  exports[1739] = "ER_WARN_INDEX_NOT_APPLICABLE";
  exports[1740] = "ER_PARTITION_EXCHANGE_FOREIGN_KEY";
  exports[1741] = "ER_NO_SUCH_KEY_VALUE";
  exports[1742] = "ER_RPL_INFO_DATA_TOO_LONG";
  exports[1743] = "ER_NETWORK_READ_EVENT_CHECKSUM_FAILURE";
  exports[1744] = "ER_BINLOG_READ_EVENT_CHECKSUM_FAILURE";
  exports[1745] = "ER_BINLOG_STMT_CACHE_SIZE_GREATER_THAN_MAX";
  exports[1746] = "ER_CANT_UPDATE_TABLE_IN_CREATE_TABLE_SELECT";
  exports[1747] = "ER_PARTITION_CLAUSE_ON_NONPARTITIONED";
  exports[1748] = "ER_ROW_DOES_NOT_MATCH_GIVEN_PARTITION_SET";
  exports[1749] = "ER_NO_SUCH_PARTITION";
  exports[1750] = "ER_CHANGE_RPL_INFO_REPOSITORY_FAILURE";
  exports[1751] = "ER_WARNING_NOT_COMPLETE_ROLLBACK_WITH_CREATED_TEMP_TABLE";
  exports[1752] = "ER_WARNING_NOT_COMPLETE_ROLLBACK_WITH_DROPPED_TEMP_TABLE";
  exports[1753] = "ER_MTA_FEATURE_IS_NOT_SUPPORTED";
  exports[1754] = "ER_MTA_UPDATED_DBS_GREATER_MAX";
  exports[1755] = "ER_MTA_CANT_PARALLEL";
  exports[1756] = "ER_MTA_INCONSISTENT_DATA";
  exports[1757] = "ER_FULLTEXT_NOT_SUPPORTED_WITH_PARTITIONING";
  exports[1758] = "ER_DA_INVALID_CONDITION_NUMBER";
  exports[1759] = "ER_INSECURE_PLAIN_TEXT";
  exports[1760] = "ER_INSECURE_CHANGE_SOURCE";
  exports[1761] = "ER_FOREIGN_DUPLICATE_KEY_WITH_CHILD_INFO";
  exports[1762] = "ER_FOREIGN_DUPLICATE_KEY_WITHOUT_CHILD_INFO";
  exports[1763] = "ER_SQLTHREAD_WITH_SECURE_REPLICA";
  exports[1764] = "ER_TABLE_HAS_NO_FT";
  exports[1765] = "ER_VARIABLE_NOT_SETTABLE_IN_SF_OR_TRIGGER";
  exports[1766] = "ER_VARIABLE_NOT_SETTABLE_IN_TRANSACTION";
  exports[1767] = "ER_GTID_NEXT_IS_NOT_IN_GTID_NEXT_LIST";
  exports[1768] = "ER_CANT_CHANGE_GTID_NEXT_IN_TRANSACTION";
  exports[1769] = "ER_SET_STATEMENT_CANNOT_INVOKE_FUNCTION";
  exports[1770] = "ER_GTID_NEXT_CANT_BE_AUTOMATIC_IF_GTID_NEXT_LIST_IS_NON_NULL";
  exports[1771] = "ER_SKIPPING_LOGGED_TRANSACTION";
  exports[1772] = "ER_MALFORMED_GTID_SET_SPECIFICATION";
  exports[1773] = "ER_MALFORMED_GTID_SET_ENCODING";
  exports[1774] = "ER_MALFORMED_GTID_SPECIFICATION";
  exports[1775] = "ER_GNO_EXHAUSTED";
  exports[1776] = "ER_BAD_REPLICA_AUTO_POSITION";
  exports[1777] = "ER_AUTO_POSITION_REQUIRES_GTID_MODE_NOT_OFF";
  exports[1778] = "ER_CANT_DO_IMPLICIT_COMMIT_IN_TRX_WHEN_GTID_NEXT_IS_SET";
  exports[1779] = "ER_GTID_MODE_ON_REQUIRES_ENFORCE_GTID_CONSISTENCY_ON";
  exports[1780] = "ER_GTID_MODE_REQUIRES_BINLOG";
  exports[1781] = "ER_CANT_SET_GTID_NEXT_TO_GTID_WHEN_GTID_MODE_IS_OFF";
  exports[1782] = "ER_CANT_SET_GTID_NEXT_TO_ANONYMOUS_WHEN_GTID_MODE_IS_ON";
  exports[1783] = "ER_CANT_SET_GTID_NEXT_LIST_TO_NON_NULL_WHEN_GTID_MODE_IS_OFF";
  exports[1784] = "ER_FOUND_GTID_EVENT_WHEN_GTID_MODE_IS_OFF";
  exports[1785] = "ER_GTID_UNSAFE_NON_TRANSACTIONAL_TABLE";
  exports[1786] = "ER_GTID_UNSAFE_CREATE_SELECT";
  exports[1787] = "ER_GTID_UNSAFE_CREATE_DROP_TEMP_TABLE_IN_TRANSACTION";
  exports[1788] = "ER_GTID_MODE_CAN_ONLY_CHANGE_ONE_STEP_AT_A_TIME";
  exports[1789] = "ER_SOURCE_HAS_PURGED_REQUIRED_GTIDS";
  exports[1790] = "ER_CANT_SET_GTID_NEXT_WHEN_OWNING_GTID";
  exports[1791] = "ER_UNKNOWN_EXPLAIN_FORMAT";
  exports[1792] = "ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION";
  exports[1793] = "ER_TOO_LONG_TABLE_PARTITION_COMMENT";
  exports[1794] = "ER_REPLICA_CONFIGURATION";
  exports[1795] = "ER_INNODB_FT_LIMIT";
  exports[1796] = "ER_INNODB_NO_FT_TEMP_TABLE";
  exports[1797] = "ER_INNODB_FT_WRONG_DOCID_COLUMN";
  exports[1798] = "ER_INNODB_FT_WRONG_DOCID_INDEX";
  exports[1799] = "ER_INNODB_ONLINE_LOG_TOO_BIG";
  exports[1800] = "ER_UNKNOWN_ALTER_ALGORITHM";
  exports[1801] = "ER_UNKNOWN_ALTER_LOCK";
  exports[1802] = "ER_MTA_CHANGE_SOURCE_CANT_RUN_WITH_GAPS";
  exports[1803] = "ER_MTA_RECOVERY_FAILURE";
  exports[1804] = "ER_MTA_RESET_WORKERS";
  exports[1805] = "ER_COL_COUNT_DOESNT_MATCH_CORRUPTED_V2";
  exports[1806] = "ER_REPLICA_SILENT_RETRY_TRANSACTION";
  exports[1807] = "ER_DISCARD_FK_CHECKS_RUNNING";
  exports[1808] = "ER_TABLE_SCHEMA_MISMATCH";
  exports[1809] = "ER_TABLE_IN_SYSTEM_TABLESPACE";
  exports[1810] = "ER_IO_READ_ERROR";
  exports[1811] = "ER_IO_WRITE_ERROR";
  exports[1812] = "ER_TABLESPACE_MISSING";
  exports[1813] = "ER_TABLESPACE_EXISTS";
  exports[1814] = "ER_TABLESPACE_DISCARDED";
  exports[1815] = "ER_INTERNAL_ERROR";
  exports[1816] = "ER_INNODB_IMPORT_ERROR";
  exports[1817] = "ER_INNODB_INDEX_CORRUPT";
  exports[1818] = "ER_INVALID_YEAR_COLUMN_LENGTH";
  exports[1819] = "ER_NOT_VALID_PASSWORD";
  exports[1820] = "ER_MUST_CHANGE_PASSWORD";
  exports[1821] = "ER_FK_NO_INDEX_CHILD";
  exports[1822] = "ER_FK_NO_INDEX_PARENT";
  exports[1823] = "ER_FK_FAIL_ADD_SYSTEM";
  exports[1824] = "ER_FK_CANNOT_OPEN_PARENT";
  exports[1825] = "ER_FK_INCORRECT_OPTION";
  exports[1826] = "ER_FK_DUP_NAME";
  exports[1827] = "ER_PASSWORD_FORMAT";
  exports[1828] = "ER_FK_COLUMN_CANNOT_DROP";
  exports[1829] = "ER_FK_COLUMN_CANNOT_DROP_CHILD";
  exports[1830] = "ER_FK_COLUMN_NOT_NULL";
  exports[1831] = "ER_DUP_INDEX";
  exports[1832] = "ER_FK_COLUMN_CANNOT_CHANGE";
  exports[1833] = "ER_FK_COLUMN_CANNOT_CHANGE_CHILD";
  exports[1834] = "ER_UNUSED5";
  exports[1835] = "ER_MALFORMED_PACKET";
  exports[1836] = "ER_READ_ONLY_MODE";
  exports[1837] = "ER_GTID_NEXT_TYPE_UNDEFINED_GTID";
  exports[1838] = "ER_VARIABLE_NOT_SETTABLE_IN_SP";
  exports[1839] = "ER_CANT_SET_GTID_PURGED_WHEN_GTID_MODE_IS_OFF";
  exports[1840] = "ER_CANT_SET_GTID_PURGED_WHEN_GTID_EXECUTED_IS_NOT_EMPTY";
  exports[1841] = "ER_CANT_SET_GTID_PURGED_WHEN_OWNED_GTIDS_IS_NOT_EMPTY";
  exports[1842] = "ER_GTID_PURGED_WAS_CHANGED";
  exports[1843] = "ER_GTID_EXECUTED_WAS_CHANGED";
  exports[1844] = "ER_BINLOG_STMT_MODE_AND_NO_REPL_TABLES";
  exports[1845] = "ER_ALTER_OPERATION_NOT_SUPPORTED";
  exports[1846] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON";
  exports[1847] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_COPY";
  exports[1848] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_PARTITION";
  exports[1849] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_FK_RENAME";
  exports[1850] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_COLUMN_TYPE";
  exports[1851] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_FK_CHECK";
  exports[1852] = "ER_UNUSED6";
  exports[1853] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_NOPK";
  exports[1854] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_AUTOINC";
  exports[1855] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_HIDDEN_FTS";
  exports[1856] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_CHANGE_FTS";
  exports[1857] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_FTS";
  exports[1858] = "ER_SQL_REPLICA_SKIP_COUNTER_NOT_SETTABLE_IN_GTID_MODE";
  exports[1859] = "ER_DUP_UNKNOWN_IN_INDEX";
  exports[1860] = "ER_IDENT_CAUSES_TOO_LONG_PATH";
  exports[1861] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_NOT_NULL";
  exports[1862] = "ER_MUST_CHANGE_PASSWORD_LOGIN";
  exports[1863] = "ER_ROW_IN_WRONG_PARTITION";
  exports[1864] = "ER_MTA_EVENT_BIGGER_PENDING_JOBS_SIZE_MAX";
  exports[1865] = "ER_INNODB_NO_FT_USES_PARSER";
  exports[1866] = "ER_BINLOG_LOGICAL_CORRUPTION";
  exports[1867] = "ER_WARN_PURGE_LOG_IN_USE";
  exports[1868] = "ER_WARN_PURGE_LOG_IS_ACTIVE";
  exports[1869] = "ER_AUTO_INCREMENT_CONFLICT";
  exports[1870] = "WARN_ON_BLOCKHOLE_IN_RBR";
  exports[1871] = "ER_REPLICA_CM_INIT_REPOSITORY";
  exports[1872] = "ER_REPLICA_AM_INIT_REPOSITORY";
  exports[1873] = "ER_ACCESS_DENIED_CHANGE_USER_ERROR";
  exports[1874] = "ER_INNODB_READ_ONLY";
  exports[1875] = "ER_STOP_REPLICA_SQL_THREAD_TIMEOUT";
  exports[1876] = "ER_STOP_REPLICA_IO_THREAD_TIMEOUT";
  exports[1877] = "ER_TABLE_CORRUPT";
  exports[1878] = "ER_TEMP_FILE_WRITE_FAILURE";
  exports[1879] = "ER_INNODB_FT_AUX_NOT_HEX_ID";
  exports[1880] = "ER_OLD_TEMPORALS_UPGRADED";
  exports[1881] = "ER_INNODB_FORCED_RECOVERY";
  exports[1882] = "ER_AES_INVALID_IV";
  exports[1883] = "ER_PLUGIN_CANNOT_BE_UNINSTALLED";
  exports[1884] = "ER_GTID_UNSAFE_BINLOG_SPLITTABLE_STATEMENT_AND_ASSIGNED_GTID";
  exports[1885] = "ER_REPLICA_HAS_MORE_GTIDS_THAN_SOURCE";
  exports[1886] = "ER_MISSING_KEY";
  exports[1887] = "WARN_NAMED_PIPE_ACCESS_EVERYONE";
  exports[3000] = "ER_FILE_CORRUPT";
  exports[3001] = "ER_ERROR_ON_SOURCE";
  exports[3002] = "ER_INCONSISTENT_ERROR";
  exports[3003] = "ER_STORAGE_ENGINE_NOT_LOADED";
  exports[3004] = "ER_GET_STACKED_DA_WITHOUT_ACTIVE_HANDLER";
  exports[3005] = "ER_WARN_LEGACY_SYNTAX_CONVERTED";
  exports[3006] = "ER_BINLOG_UNSAFE_FULLTEXT_PLUGIN";
  exports[3007] = "ER_CANNOT_DISCARD_TEMPORARY_TABLE";
  exports[3008] = "ER_FK_DEPTH_EXCEEDED";
  exports[3009] = "ER_COL_COUNT_DOESNT_MATCH_PLEASE_UPDATE_V2";
  exports[3010] = "ER_WARN_TRIGGER_DOESNT_HAVE_CREATED";
  exports[3011] = "ER_REFERENCED_TRG_DOES_NOT_EXIST";
  exports[3012] = "ER_EXPLAIN_NOT_SUPPORTED";
  exports[3013] = "ER_INVALID_FIELD_SIZE";
  exports[3014] = "ER_MISSING_HA_CREATE_OPTION";
  exports[3015] = "ER_ENGINE_OUT_OF_MEMORY";
  exports[3016] = "ER_PASSWORD_EXPIRE_ANONYMOUS_USER";
  exports[3017] = "ER_REPLICA_SQL_THREAD_MUST_STOP";
  exports[3018] = "ER_NO_FT_MATERIALIZED_SUBQUERY";
  exports[3019] = "ER_INNODB_UNDO_LOG_FULL";
  exports[3020] = "ER_INVALID_ARGUMENT_FOR_LOGARITHM";
  exports[3021] = "ER_REPLICA_CHANNEL_IO_THREAD_MUST_STOP";
  exports[3022] = "ER_WARN_OPEN_TEMP_TABLES_MUST_BE_ZERO";
  exports[3023] = "ER_WARN_ONLY_SOURCE_LOG_FILE_NO_POS";
  exports[3024] = "ER_QUERY_TIMEOUT";
  exports[3025] = "ER_NON_RO_SELECT_DISABLE_TIMER";
  exports[3026] = "ER_DUP_LIST_ENTRY";
  exports[3027] = "ER_SQL_MODE_NO_EFFECT";
  exports[3028] = "ER_AGGREGATE_ORDER_FOR_UNION";
  exports[3029] = "ER_AGGREGATE_ORDER_NON_AGG_QUERY";
  exports[3030] = "ER_REPLICA_WORKER_STOPPED_PREVIOUS_THD_ERROR";
  exports[3031] = "ER_DONT_SUPPORT_REPLICA_PRESERVE_COMMIT_ORDER";
  exports[3032] = "ER_SERVER_OFFLINE_MODE";
  exports[3033] = "ER_GIS_DIFFERENT_SRIDS";
  exports[3034] = "ER_GIS_UNSUPPORTED_ARGUMENT";
  exports[3035] = "ER_GIS_UNKNOWN_ERROR";
  exports[3036] = "ER_GIS_UNKNOWN_EXCEPTION";
  exports[3037] = "ER_GIS_INVALID_DATA";
  exports[3038] = "ER_BOOST_GEOMETRY_EMPTY_INPUT_EXCEPTION";
  exports[3039] = "ER_BOOST_GEOMETRY_CENTROID_EXCEPTION";
  exports[3040] = "ER_BOOST_GEOMETRY_OVERLAY_INVALID_INPUT_EXCEPTION";
  exports[3041] = "ER_BOOST_GEOMETRY_TURN_INFO_EXCEPTION";
  exports[3042] = "ER_BOOST_GEOMETRY_SELF_INTERSECTION_POINT_EXCEPTION";
  exports[3043] = "ER_BOOST_GEOMETRY_UNKNOWN_EXCEPTION";
  exports[3044] = "ER_STD_BAD_ALLOC_ERROR";
  exports[3045] = "ER_STD_DOMAIN_ERROR";
  exports[3046] = "ER_STD_LENGTH_ERROR";
  exports[3047] = "ER_STD_INVALID_ARGUMENT";
  exports[3048] = "ER_STD_OUT_OF_RANGE_ERROR";
  exports[3049] = "ER_STD_OVERFLOW_ERROR";
  exports[3050] = "ER_STD_RANGE_ERROR";
  exports[3051] = "ER_STD_UNDERFLOW_ERROR";
  exports[3052] = "ER_STD_LOGIC_ERROR";
  exports[3053] = "ER_STD_RUNTIME_ERROR";
  exports[3054] = "ER_STD_UNKNOWN_EXCEPTION";
  exports[3055] = "ER_GIS_DATA_WRONG_ENDIANESS";
  exports[3056] = "ER_CHANGE_SOURCE_PASSWORD_LENGTH";
  exports[3057] = "ER_USER_LOCK_WRONG_NAME";
  exports[3058] = "ER_USER_LOCK_DEADLOCK";
  exports[3059] = "ER_REPLACE_INACCESSIBLE_ROWS";
  exports[3060] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_GIS";
  exports[3061] = "ER_ILLEGAL_USER_VAR";
  exports[3062] = "ER_GTID_MODE_OFF";
  exports[3063] = "ER_UNSUPPORTED_BY_REPLICATION_THREAD";
  exports[3064] = "ER_INCORRECT_TYPE";
  exports[3065] = "ER_FIELD_IN_ORDER_NOT_SELECT";
  exports[3066] = "ER_AGGREGATE_IN_ORDER_NOT_SELECT";
  exports[3067] = "ER_INVALID_RPL_WILD_TABLE_FILTER_PATTERN";
  exports[3068] = "ER_NET_OK_PACKET_TOO_LARGE";
  exports[3069] = "ER_INVALID_JSON_DATA";
  exports[3070] = "ER_INVALID_GEOJSON_MISSING_MEMBER";
  exports[3071] = "ER_INVALID_GEOJSON_WRONG_TYPE";
  exports[3072] = "ER_INVALID_GEOJSON_UNSPECIFIED";
  exports[3073] = "ER_DIMENSION_UNSUPPORTED";
  exports[3074] = "ER_REPLICA_CHANNEL_DOES_NOT_EXIST";
  exports[3075] = "ER_SLAVE_MULTIPLE_CHANNELS_HOST_PORT";
  exports[3076] = "ER_REPLICA_CHANNEL_NAME_INVALID_OR_TOO_LONG";
  exports[3077] = "ER_REPLICA_NEW_CHANNEL_WRONG_REPOSITORY";
  exports[3078] = "ER_SLAVE_CHANNEL_DELETE";
  exports[3079] = "ER_REPLICA_MULTIPLE_CHANNELS_CMD";
  exports[3080] = "ER_REPLICA_MAX_CHANNELS_EXCEEDED";
  exports[3081] = "ER_REPLICA_CHANNEL_MUST_STOP";
  exports[3082] = "ER_REPLICA_CHANNEL_NOT_RUNNING";
  exports[3083] = "ER_REPLICA_CHANNEL_WAS_RUNNING";
  exports[3084] = "ER_REPLICA_CHANNEL_WAS_NOT_RUNNING";
  exports[3085] = "ER_REPLICA_CHANNEL_SQL_THREAD_MUST_STOP";
  exports[3086] = "ER_REPLICA_CHANNEL_SQL_SKIP_COUNTER";
  exports[3087] = "ER_WRONG_FIELD_WITH_GROUP_V2";
  exports[3088] = "ER_MIX_OF_GROUP_FUNC_AND_FIELDS_V2";
  exports[3089] = "ER_WARN_DEPRECATED_SYSVAR_UPDATE";
  exports[3090] = "ER_WARN_DEPRECATED_SQLMODE";
  exports[3091] = "ER_CANNOT_LOG_PARTIAL_DROP_DATABASE_WITH_GTID";
  exports[3092] = "ER_GROUP_REPLICATION_CONFIGURATION";
  exports[3093] = "ER_GROUP_REPLICATION_RUNNING";
  exports[3094] = "ER_GROUP_REPLICATION_APPLIER_INIT_ERROR";
  exports[3095] = "ER_GROUP_REPLICATION_STOP_APPLIER_THREAD_TIMEOUT";
  exports[3096] = "ER_GROUP_REPLICATION_COMMUNICATION_LAYER_SESSION_ERROR";
  exports[3097] = "ER_GROUP_REPLICATION_COMMUNICATION_LAYER_JOIN_ERROR";
  exports[3098] = "ER_BEFORE_DML_VALIDATION_ERROR";
  exports[3099] = "ER_PREVENTS_VARIABLE_WITHOUT_RBR";
  exports[3100] = "ER_RUN_HOOK_ERROR";
  exports[3101] = "ER_TRANSACTION_ROLLBACK_DURING_COMMIT";
  exports[3102] = "ER_GENERATED_COLUMN_FUNCTION_IS_NOT_ALLOWED";
  exports[3103] = "ER_UNSUPPORTED_ALTER_INPLACE_ON_VIRTUAL_COLUMN";
  exports[3104] = "ER_WRONG_FK_OPTION_FOR_GENERATED_COLUMN";
  exports[3105] = "ER_NON_DEFAULT_VALUE_FOR_GENERATED_COLUMN";
  exports[3106] = "ER_UNSUPPORTED_ACTION_ON_GENERATED_COLUMN";
  exports[3107] = "ER_GENERATED_COLUMN_NON_PRIOR";
  exports[3108] = "ER_DEPENDENT_BY_GENERATED_COLUMN";
  exports[3109] = "ER_GENERATED_COLUMN_REF_AUTO_INC";
  exports[3110] = "ER_FEATURE_NOT_AVAILABLE";
  exports[3111] = "ER_CANT_SET_GTID_MODE";
  exports[3112] = "ER_CANT_USE_AUTO_POSITION_WITH_GTID_MODE_OFF";
  exports[3113] = "ER_CANT_REPLICATE_ANONYMOUS_WITH_AUTO_POSITION";
  exports[3114] = "ER_CANT_REPLICATE_ANONYMOUS_WITH_GTID_MODE_ON";
  exports[3115] = "ER_CANT_REPLICATE_GTID_WITH_GTID_MODE_OFF";
  exports[3116] = "ER_CANT_ENFORCE_GTID_CONSISTENCY_WITH_ONGOING_GTID_VIOLATING_TX";
  exports[3117] = "ER_ENFORCE_GTID_CONSISTENCY_WARN_WITH_ONGOING_GTID_VIOLATING_TX";
  exports[3118] = "ER_ACCOUNT_HAS_BEEN_LOCKED";
  exports[3119] = "ER_WRONG_TABLESPACE_NAME";
  exports[3120] = "ER_TABLESPACE_IS_NOT_EMPTY";
  exports[3121] = "ER_WRONG_FILE_NAME";
  exports[3122] = "ER_BOOST_GEOMETRY_INCONSISTENT_TURNS_EXCEPTION";
  exports[3123] = "ER_WARN_OPTIMIZER_HINT_SYNTAX_ERROR";
  exports[3124] = "ER_WARN_BAD_MAX_EXECUTION_TIME";
  exports[3125] = "ER_WARN_UNSUPPORTED_MAX_EXECUTION_TIME";
  exports[3126] = "ER_WARN_CONFLICTING_HINT";
  exports[3127] = "ER_WARN_UNKNOWN_QB_NAME";
  exports[3128] = "ER_UNRESOLVED_HINT_NAME";
  exports[3129] = "ER_WARN_ON_MODIFYING_GTID_EXECUTED_TABLE";
  exports[3130] = "ER_PLUGGABLE_PROTOCOL_COMMAND_NOT_SUPPORTED";
  exports[3131] = "ER_LOCKING_SERVICE_WRONG_NAME";
  exports[3132] = "ER_LOCKING_SERVICE_DEADLOCK";
  exports[3133] = "ER_LOCKING_SERVICE_TIMEOUT";
  exports[3134] = "ER_GIS_MAX_POINTS_IN_GEOMETRY_OVERFLOWED";
  exports[3135] = "ER_SQL_MODE_MERGED";
  exports[3136] = "ER_VTOKEN_PLUGIN_TOKEN_MISMATCH";
  exports[3137] = "ER_VTOKEN_PLUGIN_TOKEN_NOT_FOUND";
  exports[3138] = "ER_CANT_SET_VARIABLE_WHEN_OWNING_GTID";
  exports[3139] = "ER_REPLICA_CHANNEL_OPERATION_NOT_ALLOWED";
  exports[3140] = "ER_INVALID_JSON_TEXT";
  exports[3141] = "ER_INVALID_JSON_TEXT_IN_PARAM";
  exports[3142] = "ER_INVALID_JSON_BINARY_DATA";
  exports[3143] = "ER_INVALID_JSON_PATH";
  exports[3144] = "ER_INVALID_JSON_CHARSET";
  exports[3145] = "ER_INVALID_JSON_CHARSET_IN_FUNCTION";
  exports[3146] = "ER_INVALID_TYPE_FOR_JSON";
  exports[3147] = "ER_INVALID_CAST_TO_JSON";
  exports[3148] = "ER_INVALID_JSON_PATH_CHARSET";
  exports[3149] = "ER_INVALID_JSON_PATH_WILDCARD";
  exports[3150] = "ER_JSON_VALUE_TOO_BIG";
  exports[3151] = "ER_JSON_KEY_TOO_BIG";
  exports[3152] = "ER_JSON_USED_AS_KEY";
  exports[3153] = "ER_JSON_VACUOUS_PATH";
  exports[3154] = "ER_JSON_BAD_ONE_OR_ALL_ARG";
  exports[3155] = "ER_NUMERIC_JSON_VALUE_OUT_OF_RANGE";
  exports[3156] = "ER_INVALID_JSON_VALUE_FOR_CAST";
  exports[3157] = "ER_JSON_DOCUMENT_TOO_DEEP";
  exports[3158] = "ER_JSON_DOCUMENT_NULL_KEY";
  exports[3159] = "ER_SECURE_TRANSPORT_REQUIRED";
  exports[3160] = "ER_NO_SECURE_TRANSPORTS_CONFIGURED";
  exports[3161] = "ER_DISABLED_STORAGE_ENGINE";
  exports[3162] = "ER_USER_DOES_NOT_EXIST";
  exports[3163] = "ER_USER_ALREADY_EXISTS";
  exports[3164] = "ER_AUDIT_API_ABORT";
  exports[3165] = "ER_INVALID_JSON_PATH_ARRAY_CELL";
  exports[3166] = "ER_BUFPOOL_RESIZE_INPROGRESS";
  exports[3167] = "ER_FEATURE_DISABLED_SEE_DOC";
  exports[3168] = "ER_SERVER_ISNT_AVAILABLE";
  exports[3169] = "ER_SESSION_WAS_KILLED";
  exports[3170] = "ER_CAPACITY_EXCEEDED";
  exports[3171] = "ER_CAPACITY_EXCEEDED_IN_RANGE_OPTIMIZER";
  exports[3172] = "ER_TABLE_NEEDS_UPG_PART";
  exports[3173] = "ER_CANT_WAIT_FOR_EXECUTED_GTID_SET_WHILE_OWNING_A_GTID";
  exports[3174] = "ER_CANNOT_ADD_FOREIGN_BASE_COL_VIRTUAL";
  exports[3175] = "ER_CANNOT_CREATE_VIRTUAL_INDEX_CONSTRAINT";
  exports[3176] = "ER_ERROR_ON_MODIFYING_GTID_EXECUTED_TABLE";
  exports[3177] = "ER_LOCK_REFUSED_BY_ENGINE";
  exports[3178] = "ER_UNSUPPORTED_ALTER_ONLINE_ON_VIRTUAL_COLUMN";
  exports[3179] = "ER_MASTER_KEY_ROTATION_NOT_SUPPORTED_BY_SE";
  exports[3180] = "ER_MASTER_KEY_ROTATION_ERROR_BY_SE";
  exports[3181] = "ER_MASTER_KEY_ROTATION_BINLOG_FAILED";
  exports[3182] = "ER_MASTER_KEY_ROTATION_SE_UNAVAILABLE";
  exports[3183] = "ER_TABLESPACE_CANNOT_ENCRYPT";
  exports[3184] = "ER_INVALID_ENCRYPTION_OPTION";
  exports[3185] = "ER_CANNOT_FIND_KEY_IN_KEYRING";
  exports[3186] = "ER_CAPACITY_EXCEEDED_IN_PARSER";
  exports[3187] = "ER_UNSUPPORTED_ALTER_ENCRYPTION_INPLACE";
  exports[3188] = "ER_KEYRING_UDF_KEYRING_SERVICE_ERROR";
  exports[3189] = "ER_USER_COLUMN_OLD_LENGTH";
  exports[3190] = "ER_CANT_RESET_SOURCE";
  exports[3191] = "ER_GROUP_REPLICATION_MAX_GROUP_SIZE";
  exports[3192] = "ER_CANNOT_ADD_FOREIGN_BASE_COL_STORED";
  exports[3193] = "ER_TABLE_REFERENCED";
  exports[3194] = "ER_PARTITION_ENGINE_DEPRECATED_FOR_TABLE";
  exports[3195] = "ER_WARN_USING_GEOMFROMWKB_TO_SET_SRID_ZERO";
  exports[3196] = "ER_WARN_USING_GEOMFROMWKB_TO_SET_SRID";
  exports[3197] = "ER_XA_RETRY";
  exports[3198] = "ER_KEYRING_AWS_UDF_AWS_KMS_ERROR";
  exports[3199] = "ER_BINLOG_UNSAFE_XA";
  exports[3200] = "ER_UDF_ERROR";
  exports[3201] = "ER_KEYRING_MIGRATION_FAILURE";
  exports[3202] = "ER_KEYRING_ACCESS_DENIED_ERROR";
  exports[3203] = "ER_KEYRING_MIGRATION_STATUS";
  exports[3204] = "ER_PLUGIN_FAILED_TO_OPEN_TABLES";
  exports[3205] = "ER_PLUGIN_FAILED_TO_OPEN_TABLE";
  exports[3206] = "ER_AUDIT_LOG_NO_KEYRING_PLUGIN_INSTALLED";
  exports[3207] = "ER_AUDIT_LOG_ENCRYPTION_PASSWORD_HAS_NOT_BEEN_SET";
  exports[3208] = "ER_AUDIT_LOG_COULD_NOT_CREATE_AES_KEY";
  exports[3209] = "ER_AUDIT_LOG_ENCRYPTION_PASSWORD_CANNOT_BE_FETCHED";
  exports[3210] = "ER_AUDIT_LOG_JSON_FILTERING_NOT_ENABLED";
  exports[3211] = "ER_AUDIT_LOG_UDF_INSUFFICIENT_PRIVILEGE";
  exports[3212] = "ER_AUDIT_LOG_SUPER_PRIVILEGE_REQUIRED";
  exports[3213] = "ER_COULD_NOT_REINITIALIZE_AUDIT_LOG_FILTERS";
  exports[3214] = "ER_AUDIT_LOG_UDF_INVALID_ARGUMENT_TYPE";
  exports[3215] = "ER_AUDIT_LOG_UDF_INVALID_ARGUMENT_COUNT";
  exports[3216] = "ER_AUDIT_LOG_HAS_NOT_BEEN_INSTALLED";
  exports[3217] = "ER_AUDIT_LOG_UDF_READ_INVALID_MAX_ARRAY_LENGTH_ARG_TYPE";
  exports[3218] = "ER_AUDIT_LOG_UDF_READ_INVALID_MAX_ARRAY_LENGTH_ARG_VALUE";
  exports[3219] = "ER_AUDIT_LOG_JSON_FILTER_PARSING_ERROR";
  exports[3220] = "ER_AUDIT_LOG_JSON_FILTER_NAME_CANNOT_BE_EMPTY";
  exports[3221] = "ER_AUDIT_LOG_JSON_USER_NAME_CANNOT_BE_EMPTY";
  exports[3222] = "ER_AUDIT_LOG_JSON_FILTER_DOES_NOT_EXISTS";
  exports[3223] = "ER_AUDIT_LOG_USER_FIRST_CHARACTER_MUST_BE_ALPHANUMERIC";
  exports[3224] = "ER_AUDIT_LOG_USER_NAME_INVALID_CHARACTER";
  exports[3225] = "ER_AUDIT_LOG_HOST_NAME_INVALID_CHARACTER";
  exports[3226] = "WARN_DEPRECATED_MAXDB_SQL_MODE_FOR_TIMESTAMP";
  exports[3227] = "ER_XA_REPLICATION_FILTERS";
  exports[3228] = "ER_CANT_OPEN_ERROR_LOG";
  exports[3229] = "ER_GROUPING_ON_TIMESTAMP_IN_DST";
  exports[3230] = "ER_CANT_START_SERVER_NAMED_PIPE";
  exports[3231] = "ER_WRITE_SET_EXCEEDS_LIMIT";
  exports[3232] = "ER_DEPRECATED_TLS_VERSION_SESSION_57";
  exports[3233] = "ER_WARN_DEPRECATED_TLS_VERSION_57";
  exports[3234] = "ER_WARN_WRONG_NATIVE_TABLE_STRUCTURE";
  exports[3235] = "ER_AES_INVALID_KDF_NAME";
  exports[3236] = "ER_AES_INVALID_KDF_ITERATIONS";
  exports[3237] = "WARN_AES_KEY_SIZE";
  exports[3238] = "ER_AES_INVALID_KDF_OPTION_SIZE";
  exports[3500] = "ER_UNSUPPORT_COMPRESSED_TEMPORARY_TABLE";
  exports[3501] = "ER_ACL_OPERATION_FAILED";
  exports[3502] = "ER_UNSUPPORTED_INDEX_ALGORITHM";
  exports[3503] = "ER_NO_SUCH_DB";
  exports[3504] = "ER_TOO_BIG_ENUM";
  exports[3505] = "ER_TOO_LONG_SET_ENUM_VALUE";
  exports[3506] = "ER_INVALID_DD_OBJECT";
  exports[3507] = "ER_UPDATING_DD_TABLE";
  exports[3508] = "ER_INVALID_DD_OBJECT_ID";
  exports[3509] = "ER_INVALID_DD_OBJECT_NAME";
  exports[3510] = "ER_TABLESPACE_MISSING_WITH_NAME";
  exports[3511] = "ER_TOO_LONG_ROUTINE_COMMENT";
  exports[3512] = "ER_SP_LOAD_FAILED";
  exports[3513] = "ER_INVALID_BITWISE_OPERANDS_SIZE";
  exports[3514] = "ER_INVALID_BITWISE_AGGREGATE_OPERANDS_SIZE";
  exports[3515] = "ER_WARN_UNSUPPORTED_HINT";
  exports[3516] = "ER_UNEXPECTED_GEOMETRY_TYPE";
  exports[3517] = "ER_SRS_PARSE_ERROR";
  exports[3518] = "ER_SRS_PROJ_PARAMETER_MISSING";
  exports[3519] = "ER_WARN_SRS_NOT_FOUND";
  exports[3520] = "ER_SRS_NOT_CARTESIAN";
  exports[3521] = "ER_SRS_NOT_CARTESIAN_UNDEFINED";
  exports[3522] = "ER_PK_INDEX_CANT_BE_INVISIBLE";
  exports[3523] = "ER_UNKNOWN_AUTHID";
  exports[3524] = "ER_FAILED_ROLE_GRANT";
  exports[3525] = "ER_OPEN_ROLE_TABLES";
  exports[3526] = "ER_FAILED_DEFAULT_ROLES";
  exports[3527] = "ER_COMPONENTS_NO_SCHEME";
  exports[3528] = "ER_COMPONENTS_NO_SCHEME_SERVICE";
  exports[3529] = "ER_COMPONENTS_CANT_LOAD";
  exports[3530] = "ER_ROLE_NOT_GRANTED";
  exports[3531] = "ER_FAILED_REVOKE_ROLE";
  exports[3532] = "ER_RENAME_ROLE";
  exports[3533] = "ER_COMPONENTS_CANT_ACQUIRE_SERVICE_IMPLEMENTATION";
  exports[3534] = "ER_COMPONENTS_CANT_SATISFY_DEPENDENCY";
  exports[3535] = "ER_COMPONENTS_LOAD_CANT_REGISTER_SERVICE_IMPLEMENTATION";
  exports[3536] = "ER_COMPONENTS_LOAD_CANT_INITIALIZE";
  exports[3537] = "ER_COMPONENTS_UNLOAD_NOT_LOADED";
  exports[3538] = "ER_COMPONENTS_UNLOAD_CANT_DEINITIALIZE";
  exports[3539] = "ER_COMPONENTS_CANT_RELEASE_SERVICE";
  exports[3540] = "ER_COMPONENTS_UNLOAD_CANT_UNREGISTER_SERVICE";
  exports[3541] = "ER_COMPONENTS_CANT_UNLOAD";
  exports[3542] = "ER_WARN_UNLOAD_THE_NOT_PERSISTED";
  exports[3543] = "ER_COMPONENT_TABLE_INCORRECT";
  exports[3544] = "ER_COMPONENT_MANIPULATE_ROW_FAILED";
  exports[3545] = "ER_COMPONENTS_UNLOAD_DUPLICATE_IN_GROUP";
  exports[3546] = "ER_CANT_SET_GTID_PURGED_DUE_SETS_CONSTRAINTS";
  exports[3547] = "ER_CANNOT_LOCK_USER_MANAGEMENT_CACHES";
  exports[3548] = "ER_SRS_NOT_FOUND";
  exports[3549] = "ER_VARIABLE_NOT_PERSISTED";
  exports[3550] = "ER_IS_QUERY_INVALID_CLAUSE";
  exports[3551] = "ER_UNABLE_TO_STORE_STATISTICS";
  exports[3552] = "ER_NO_SYSTEM_SCHEMA_ACCESS";
  exports[3553] = "ER_NO_SYSTEM_TABLESPACE_ACCESS";
  exports[3554] = "ER_NO_SYSTEM_TABLE_ACCESS";
  exports[3555] = "ER_NO_SYSTEM_TABLE_ACCESS_FOR_DICTIONARY_TABLE";
  exports[3556] = "ER_NO_SYSTEM_TABLE_ACCESS_FOR_SYSTEM_TABLE";
  exports[3557] = "ER_NO_SYSTEM_TABLE_ACCESS_FOR_TABLE";
  exports[3558] = "ER_INVALID_OPTION_KEY";
  exports[3559] = "ER_INVALID_OPTION_VALUE";
  exports[3560] = "ER_INVALID_OPTION_KEY_VALUE_PAIR";
  exports[3561] = "ER_INVALID_OPTION_START_CHARACTER";
  exports[3562] = "ER_INVALID_OPTION_END_CHARACTER";
  exports[3563] = "ER_INVALID_OPTION_CHARACTERS";
  exports[3564] = "ER_DUPLICATE_OPTION_KEY";
  exports[3565] = "ER_WARN_SRS_NOT_FOUND_AXIS_ORDER";
  exports[3566] = "ER_NO_ACCESS_TO_NATIVE_FCT";
  exports[3567] = "ER_RESET_SOURCE_TO_VALUE_OUT_OF_RANGE";
  exports[3568] = "ER_UNRESOLVED_TABLE_LOCK";
  exports[3569] = "ER_DUPLICATE_TABLE_LOCK";
  exports[3570] = "ER_BINLOG_UNSAFE_SKIP_LOCKED";
  exports[3571] = "ER_BINLOG_UNSAFE_NOWAIT";
  exports[3572] = "ER_LOCK_NOWAIT";
  exports[3573] = "ER_CTE_RECURSIVE_REQUIRES_UNION";
  exports[3574] = "ER_CTE_RECURSIVE_REQUIRES_NONRECURSIVE_FIRST";
  exports[3575] = "ER_CTE_RECURSIVE_FORBIDS_AGGREGATION";
  exports[3576] = "ER_CTE_RECURSIVE_FORBIDDEN_JOIN_ORDER";
  exports[3577] = "ER_CTE_RECURSIVE_REQUIRES_SINGLE_REFERENCE";
  exports[3578] = "ER_SWITCH_TMP_ENGINE";
  exports[3579] = "ER_WINDOW_NO_SUCH_WINDOW";
  exports[3580] = "ER_WINDOW_CIRCULARITY_IN_WINDOW_GRAPH";
  exports[3581] = "ER_WINDOW_NO_CHILD_PARTITIONING";
  exports[3582] = "ER_WINDOW_NO_INHERIT_FRAME";
  exports[3583] = "ER_WINDOW_NO_REDEFINE_ORDER_BY";
  exports[3584] = "ER_WINDOW_FRAME_START_ILLEGAL";
  exports[3585] = "ER_WINDOW_FRAME_END_ILLEGAL";
  exports[3586] = "ER_WINDOW_FRAME_ILLEGAL";
  exports[3587] = "ER_WINDOW_RANGE_FRAME_ORDER_TYPE";
  exports[3588] = "ER_WINDOW_RANGE_FRAME_TEMPORAL_TYPE";
  exports[3589] = "ER_WINDOW_RANGE_FRAME_NUMERIC_TYPE";
  exports[3590] = "ER_WINDOW_RANGE_BOUND_NOT_CONSTANT";
  exports[3591] = "ER_WINDOW_DUPLICATE_NAME";
  exports[3592] = "ER_WINDOW_ILLEGAL_ORDER_BY";
  exports[3593] = "ER_WINDOW_INVALID_WINDOW_FUNC_USE";
  exports[3594] = "ER_WINDOW_INVALID_WINDOW_FUNC_ALIAS_USE";
  exports[3595] = "ER_WINDOW_NESTED_WINDOW_FUNC_USE_IN_WINDOW_SPEC";
  exports[3596] = "ER_WINDOW_ROWS_INTERVAL_USE";
  exports[3597] = "ER_WINDOW_NO_GROUP_ORDER";
  exports[3598] = "ER_WINDOW_EXPLAIN_JSON";
  exports[3599] = "ER_WINDOW_FUNCTION_IGNORES_FRAME";
  exports[3600] = "ER_WL9236_NOW";
  exports[3601] = "ER_INVALID_NO_OF_ARGS";
  exports[3602] = "ER_FIELD_IN_GROUPING_NOT_GROUP_BY";
  exports[3603] = "ER_TOO_LONG_TABLESPACE_COMMENT";
  exports[3604] = "ER_ENGINE_CANT_DROP_TABLE";
  exports[3605] = "ER_ENGINE_CANT_DROP_MISSING_TABLE";
  exports[3606] = "ER_TABLESPACE_DUP_FILENAME";
  exports[3607] = "ER_DB_DROP_RMDIR2";
  exports[3608] = "ER_IMP_NO_FILES_MATCHED";
  exports[3609] = "ER_IMP_SCHEMA_DOES_NOT_EXIST";
  exports[3610] = "ER_IMP_TABLE_ALREADY_EXISTS";
  exports[3611] = "ER_IMP_INCOMPATIBLE_MYSQLD_VERSION";
  exports[3612] = "ER_IMP_INCOMPATIBLE_DD_VERSION";
  exports[3613] = "ER_IMP_INCOMPATIBLE_SDI_VERSION";
  exports[3614] = "ER_WARN_INVALID_HINT";
  exports[3615] = "ER_VAR_DOES_NOT_EXIST";
  exports[3616] = "ER_LONGITUDE_OUT_OF_RANGE";
  exports[3617] = "ER_LATITUDE_OUT_OF_RANGE";
  exports[3618] = "ER_NOT_IMPLEMENTED_FOR_GEOGRAPHIC_SRS";
  exports[3619] = "ER_ILLEGAL_PRIVILEGE_LEVEL";
  exports[3620] = "ER_NO_SYSTEM_VIEW_ACCESS";
  exports[3621] = "ER_COMPONENT_FILTER_FLABBERGASTED";
  exports[3622] = "ER_PART_EXPR_TOO_LONG";
  exports[3623] = "ER_UDF_DROP_DYNAMICALLY_REGISTERED";
  exports[3624] = "ER_UNABLE_TO_STORE_COLUMN_STATISTICS";
  exports[3625] = "ER_UNABLE_TO_UPDATE_COLUMN_STATISTICS";
  exports[3626] = "ER_UNABLE_TO_DROP_COLUMN_STATISTICS";
  exports[3627] = "ER_UNABLE_TO_BUILD_HISTOGRAM";
  exports[3628] = "ER_MANDATORY_ROLE";
  exports[3629] = "ER_MISSING_TABLESPACE_FILE";
  exports[3630] = "ER_PERSIST_ONLY_ACCESS_DENIED_ERROR";
  exports[3631] = "ER_CMD_NEED_SUPER";
  exports[3632] = "ER_PATH_IN_DATADIR";
  exports[3633] = "ER_CLONE_DDL_IN_PROGRESS";
  exports[3634] = "ER_CLONE_TOO_MANY_CONCURRENT_CLONES";
  exports[3635] = "ER_APPLIER_LOG_EVENT_VALIDATION_ERROR";
  exports[3636] = "ER_CTE_MAX_RECURSION_DEPTH";
  exports[3637] = "ER_NOT_HINT_UPDATABLE_VARIABLE";
  exports[3638] = "ER_CREDENTIALS_CONTRADICT_TO_HISTORY";
  exports[3639] = "ER_WARNING_PASSWORD_HISTORY_CLAUSES_VOID";
  exports[3640] = "ER_CLIENT_DOES_NOT_SUPPORT";
  exports[3641] = "ER_I_S_SKIPPED_TABLESPACE";
  exports[3642] = "ER_TABLESPACE_ENGINE_MISMATCH";
  exports[3643] = "ER_WRONG_SRID_FOR_COLUMN";
  exports[3644] = "ER_CANNOT_ALTER_SRID_DUE_TO_INDEX";
  exports[3645] = "ER_WARN_BINLOG_PARTIAL_UPDATES_DISABLED";
  exports[3646] = "ER_WARN_BINLOG_V1_ROW_EVENTS_DISABLED";
  exports[3647] = "ER_WARN_BINLOG_PARTIAL_UPDATES_SUGGESTS_PARTIAL_IMAGES";
  exports[3648] = "ER_COULD_NOT_APPLY_JSON_DIFF";
  exports[3649] = "ER_CORRUPTED_JSON_DIFF";
  exports[3650] = "ER_RESOURCE_GROUP_EXISTS";
  exports[3651] = "ER_RESOURCE_GROUP_NOT_EXISTS";
  exports[3652] = "ER_INVALID_VCPU_ID";
  exports[3653] = "ER_INVALID_VCPU_RANGE";
  exports[3654] = "ER_INVALID_THREAD_PRIORITY";
  exports[3655] = "ER_DISALLOWED_OPERATION";
  exports[3656] = "ER_RESOURCE_GROUP_BUSY";
  exports[3657] = "ER_RESOURCE_GROUP_DISABLED";
  exports[3658] = "ER_FEATURE_UNSUPPORTED";
  exports[3659] = "ER_ATTRIBUTE_IGNORED";
  exports[3660] = "ER_INVALID_THREAD_ID";
  exports[3661] = "ER_RESOURCE_GROUP_BIND_FAILED";
  exports[3662] = "ER_INVALID_USE_OF_FORCE_OPTION";
  exports[3663] = "ER_GROUP_REPLICATION_COMMAND_FAILURE";
  exports[3664] = "ER_SDI_OPERATION_FAILED";
  exports[3665] = "ER_MISSING_JSON_TABLE_VALUE";
  exports[3666] = "ER_WRONG_JSON_TABLE_VALUE";
  exports[3667] = "ER_TF_MUST_HAVE_ALIAS";
  exports[3668] = "ER_TF_FORBIDDEN_JOIN_TYPE";
  exports[3669] = "ER_JT_VALUE_OUT_OF_RANGE";
  exports[3670] = "ER_JT_MAX_NESTED_PATH";
  exports[3671] = "ER_PASSWORD_EXPIRATION_NOT_SUPPORTED_BY_AUTH_METHOD";
  exports[3672] = "ER_INVALID_GEOJSON_CRS_NOT_TOP_LEVEL";
  exports[3673] = "ER_BAD_NULL_ERROR_NOT_IGNORED";
  exports[3674] = "WARN_USELESS_SPATIAL_INDEX";
  exports[3675] = "ER_DISK_FULL_NOWAIT";
  exports[3676] = "ER_PARSE_ERROR_IN_DIGEST_FN";
  exports[3677] = "ER_UNDISCLOSED_PARSE_ERROR_IN_DIGEST_FN";
  exports[3678] = "ER_SCHEMA_DIR_EXISTS";
  exports[3679] = "ER_SCHEMA_DIR_MISSING";
  exports[3680] = "ER_SCHEMA_DIR_CREATE_FAILED";
  exports[3681] = "ER_SCHEMA_DIR_UNKNOWN";
  exports[3682] = "ER_ONLY_IMPLEMENTED_FOR_SRID_0_AND_4326";
  exports[3683] = "ER_BINLOG_EXPIRE_LOG_DAYS_AND_SECS_USED_TOGETHER";
  exports[3684] = "ER_REGEXP_BUFFER_OVERFLOW";
  exports[3685] = "ER_REGEXP_ILLEGAL_ARGUMENT";
  exports[3686] = "ER_REGEXP_INDEX_OUTOFBOUNDS_ERROR";
  exports[3687] = "ER_REGEXP_INTERNAL_ERROR";
  exports[3688] = "ER_REGEXP_RULE_SYNTAX";
  exports[3689] = "ER_REGEXP_BAD_ESCAPE_SEQUENCE";
  exports[3690] = "ER_REGEXP_UNIMPLEMENTED";
  exports[3691] = "ER_REGEXP_MISMATCHED_PAREN";
  exports[3692] = "ER_REGEXP_BAD_INTERVAL";
  exports[3693] = "ER_REGEXP_MAX_LT_MIN";
  exports[3694] = "ER_REGEXP_INVALID_BACK_REF";
  exports[3695] = "ER_REGEXP_LOOK_BEHIND_LIMIT";
  exports[3696] = "ER_REGEXP_MISSING_CLOSE_BRACKET";
  exports[3697] = "ER_REGEXP_INVALID_RANGE";
  exports[3698] = "ER_REGEXP_STACK_OVERFLOW";
  exports[3699] = "ER_REGEXP_TIME_OUT";
  exports[3700] = "ER_REGEXP_PATTERN_TOO_BIG";
  exports[3701] = "ER_CANT_SET_ERROR_LOG_SERVICE";
  exports[3702] = "ER_EMPTY_PIPELINE_FOR_ERROR_LOG_SERVICE";
  exports[3703] = "ER_COMPONENT_FILTER_DIAGNOSTICS";
  exports[3704] = "ER_NOT_IMPLEMENTED_FOR_CARTESIAN_SRS";
  exports[3705] = "ER_NOT_IMPLEMENTED_FOR_PROJECTED_SRS";
  exports[3706] = "ER_NONPOSITIVE_RADIUS";
  exports[3707] = "ER_RESTART_SERVER_FAILED";
  exports[3708] = "ER_SRS_MISSING_MANDATORY_ATTRIBUTE";
  exports[3709] = "ER_SRS_MULTIPLE_ATTRIBUTE_DEFINITIONS";
  exports[3710] = "ER_SRS_NAME_CANT_BE_EMPTY_OR_WHITESPACE";
  exports[3711] = "ER_SRS_ORGANIZATION_CANT_BE_EMPTY_OR_WHITESPACE";
  exports[3712] = "ER_SRS_ID_ALREADY_EXISTS";
  exports[3713] = "ER_WARN_SRS_ID_ALREADY_EXISTS";
  exports[3714] = "ER_CANT_MODIFY_SRID_0";
  exports[3715] = "ER_WARN_RESERVED_SRID_RANGE";
  exports[3716] = "ER_CANT_MODIFY_SRS_USED_BY_COLUMN";
  exports[3717] = "ER_SRS_INVALID_CHARACTER_IN_ATTRIBUTE";
  exports[3718] = "ER_SRS_ATTRIBUTE_STRING_TOO_LONG";
  exports[3719] = "ER_DEPRECATED_UTF8_ALIAS";
  exports[3720] = "ER_DEPRECATED_NATIONAL";
  exports[3721] = "ER_INVALID_DEFAULT_UTF8MB4_COLLATION";
  exports[3722] = "ER_UNABLE_TO_COLLECT_LOG_STATUS";
  exports[3723] = "ER_RESERVED_TABLESPACE_NAME";
  exports[3724] = "ER_UNABLE_TO_SET_OPTION";
  exports[3725] = "ER_REPLICA_POSSIBLY_DIVERGED_AFTER_DDL";
  exports[3726] = "ER_SRS_NOT_GEOGRAPHIC";
  exports[3727] = "ER_POLYGON_TOO_LARGE";
  exports[3728] = "ER_SPATIAL_UNIQUE_INDEX";
  exports[3729] = "ER_INDEX_TYPE_NOT_SUPPORTED_FOR_SPATIAL_INDEX";
  exports[3730] = "ER_FK_CANNOT_DROP_PARENT";
  exports[3731] = "ER_GEOMETRY_PARAM_LONGITUDE_OUT_OF_RANGE";
  exports[3732] = "ER_GEOMETRY_PARAM_LATITUDE_OUT_OF_RANGE";
  exports[3733] = "ER_FK_CANNOT_USE_VIRTUAL_COLUMN";
  exports[3734] = "ER_FK_NO_COLUMN_PARENT";
  exports[3735] = "ER_CANT_SET_ERROR_SUPPRESSION_LIST";
  exports[3736] = "ER_SRS_GEOGCS_INVALID_AXES";
  exports[3737] = "ER_SRS_INVALID_SEMI_MAJOR_AXIS";
  exports[3738] = "ER_SRS_INVALID_INVERSE_FLATTENING";
  exports[3739] = "ER_SRS_INVALID_ANGULAR_UNIT";
  exports[3740] = "ER_SRS_INVALID_PRIME_MERIDIAN";
  exports[3741] = "ER_TRANSFORM_SOURCE_SRS_NOT_SUPPORTED";
  exports[3742] = "ER_TRANSFORM_TARGET_SRS_NOT_SUPPORTED";
  exports[3743] = "ER_TRANSFORM_SOURCE_SRS_MISSING_TOWGS84";
  exports[3744] = "ER_TRANSFORM_TARGET_SRS_MISSING_TOWGS84";
  exports[3745] = "ER_TEMP_TABLE_PREVENTS_SWITCH_SESSION_BINLOG_FORMAT";
  exports[3746] = "ER_TEMP_TABLE_PREVENTS_SWITCH_GLOBAL_BINLOG_FORMAT";
  exports[3747] = "ER_RUNNING_APPLIER_PREVENTS_SWITCH_GLOBAL_BINLOG_FORMAT";
  exports[3748] = "ER_CLIENT_GTID_UNSAFE_CREATE_DROP_TEMP_TABLE_IN_TRX_IN_SBR";
  exports[3749] = "ER_XA_CANT_CREATE_MDL_BACKUP";
  exports[3750] = "ER_TABLE_WITHOUT_PK";
  exports[3751] = "ER_WARN_DATA_TRUNCATED_FUNCTIONAL_INDEX";
  exports[3752] = "ER_WARN_DATA_OUT_OF_RANGE_FUNCTIONAL_INDEX";
  exports[3753] = "ER_FUNCTIONAL_INDEX_ON_JSON_OR_GEOMETRY_FUNCTION";
  exports[3754] = "ER_FUNCTIONAL_INDEX_REF_AUTO_INCREMENT";
  exports[3755] = "ER_CANNOT_DROP_COLUMN_FUNCTIONAL_INDEX";
  exports[3756] = "ER_FUNCTIONAL_INDEX_PRIMARY_KEY";
  exports[3757] = "ER_FUNCTIONAL_INDEX_ON_LOB";
  exports[3758] = "ER_FUNCTIONAL_INDEX_FUNCTION_IS_NOT_ALLOWED";
  exports[3759] = "ER_FULLTEXT_FUNCTIONAL_INDEX";
  exports[3760] = "ER_SPATIAL_FUNCTIONAL_INDEX";
  exports[3761] = "ER_WRONG_KEY_COLUMN_FUNCTIONAL_INDEX";
  exports[3762] = "ER_FUNCTIONAL_INDEX_ON_FIELD";
  exports[3763] = "ER_GENERATED_COLUMN_NAMED_FUNCTION_IS_NOT_ALLOWED";
  exports[3764] = "ER_GENERATED_COLUMN_ROW_VALUE";
  exports[3765] = "ER_GENERATED_COLUMN_VARIABLES";
  exports[3766] = "ER_DEPENDENT_BY_DEFAULT_GENERATED_VALUE";
  exports[3767] = "ER_DEFAULT_VAL_GENERATED_NON_PRIOR";
  exports[3768] = "ER_DEFAULT_VAL_GENERATED_REF_AUTO_INC";
  exports[3769] = "ER_DEFAULT_VAL_GENERATED_FUNCTION_IS_NOT_ALLOWED";
  exports[3770] = "ER_DEFAULT_VAL_GENERATED_NAMED_FUNCTION_IS_NOT_ALLOWED";
  exports[3771] = "ER_DEFAULT_VAL_GENERATED_ROW_VALUE";
  exports[3772] = "ER_DEFAULT_VAL_GENERATED_VARIABLES";
  exports[3773] = "ER_DEFAULT_AS_VAL_GENERATED";
  exports[3774] = "ER_UNSUPPORTED_ACTION_ON_DEFAULT_VAL_GENERATED";
  exports[3775] = "ER_GTID_UNSAFE_ALTER_ADD_COL_WITH_DEFAULT_EXPRESSION";
  exports[3776] = "ER_FK_CANNOT_CHANGE_ENGINE";
  exports[3777] = "ER_WARN_DEPRECATED_USER_SET_EXPR";
  exports[3778] = "ER_WARN_DEPRECATED_UTF8MB3_COLLATION";
  exports[3779] = "ER_WARN_DEPRECATED_NESTED_COMMENT_SYNTAX";
  exports[3780] = "ER_FK_INCOMPATIBLE_COLUMNS";
  exports[3781] = "ER_GR_HOLD_WAIT_TIMEOUT";
  exports[3782] = "ER_GR_HOLD_KILLED";
  exports[3783] = "ER_GR_HOLD_MEMBER_STATUS_ERROR";
  exports[3784] = "ER_RPL_ENCRYPTION_FAILED_TO_FETCH_KEY";
  exports[3785] = "ER_RPL_ENCRYPTION_KEY_NOT_FOUND";
  exports[3786] = "ER_RPL_ENCRYPTION_KEYRING_INVALID_KEY";
  exports[3787] = "ER_RPL_ENCRYPTION_HEADER_ERROR";
  exports[3788] = "ER_RPL_ENCRYPTION_FAILED_TO_ROTATE_LOGS";
  exports[3789] = "ER_RPL_ENCRYPTION_KEY_EXISTS_UNEXPECTED";
  exports[3790] = "ER_RPL_ENCRYPTION_FAILED_TO_GENERATE_KEY";
  exports[3791] = "ER_RPL_ENCRYPTION_FAILED_TO_STORE_KEY";
  exports[3792] = "ER_RPL_ENCRYPTION_FAILED_TO_REMOVE_KEY";
  exports[3793] = "ER_RPL_ENCRYPTION_UNABLE_TO_CHANGE_OPTION";
  exports[3794] = "ER_RPL_ENCRYPTION_MASTER_KEY_RECOVERY_FAILED";
  exports[3795] = "ER_SLOW_LOG_MODE_IGNORED_WHEN_NOT_LOGGING_TO_FILE";
  exports[3796] = "ER_GRP_TRX_CONSISTENCY_NOT_ALLOWED";
  exports[3797] = "ER_GRP_TRX_CONSISTENCY_BEFORE";
  exports[3798] = "ER_GRP_TRX_CONSISTENCY_AFTER_ON_TRX_BEGIN";
  exports[3799] = "ER_GRP_TRX_CONSISTENCY_BEGIN_NOT_ALLOWED";
  exports[3800] = "ER_FUNCTIONAL_INDEX_ROW_VALUE_IS_NOT_ALLOWED";
  exports[3801] = "ER_RPL_ENCRYPTION_FAILED_TO_ENCRYPT";
  exports[3802] = "ER_PAGE_TRACKING_NOT_STARTED";
  exports[3803] = "ER_PAGE_TRACKING_RANGE_NOT_TRACKED";
  exports[3804] = "ER_PAGE_TRACKING_CANNOT_PURGE";
  exports[3805] = "ER_RPL_ENCRYPTION_CANNOT_ROTATE_BINLOG_MASTER_KEY";
  exports[3806] = "ER_BINLOG_MASTER_KEY_RECOVERY_OUT_OF_COMBINATION";
  exports[3807] = "ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_OPERATE_KEY";
  exports[3808] = "ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_ROTATE_LOGS";
  exports[3809] = "ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_REENCRYPT_LOG";
  exports[3810] = "ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_CLEANUP_UNUSED_KEYS";
  exports[3811] = "ER_BINLOG_MASTER_KEY_ROTATION_FAIL_TO_CLEANUP_AUX_KEY";
  exports[3812] = "ER_NON_BOOLEAN_EXPR_FOR_CHECK_CONSTRAINT";
  exports[3813] = "ER_COLUMN_CHECK_CONSTRAINT_REFERENCES_OTHER_COLUMN";
  exports[3814] = "ER_CHECK_CONSTRAINT_NAMED_FUNCTION_IS_NOT_ALLOWED";
  exports[3815] = "ER_CHECK_CONSTRAINT_FUNCTION_IS_NOT_ALLOWED";
  exports[3816] = "ER_CHECK_CONSTRAINT_VARIABLES";
  exports[3817] = "ER_CHECK_CONSTRAINT_ROW_VALUE";
  exports[3818] = "ER_CHECK_CONSTRAINT_REFERS_AUTO_INCREMENT_COLUMN";
  exports[3819] = "ER_CHECK_CONSTRAINT_VIOLATED";
  exports[3820] = "ER_CHECK_CONSTRAINT_REFERS_UNKNOWN_COLUMN";
  exports[3821] = "ER_CHECK_CONSTRAINT_NOT_FOUND";
  exports[3822] = "ER_CHECK_CONSTRAINT_DUP_NAME";
  exports[3823] = "ER_CHECK_CONSTRAINT_CLAUSE_USING_FK_REFER_ACTION_COLUMN";
  exports[3824] = "WARN_UNENCRYPTED_TABLE_IN_ENCRYPTED_DB";
  exports[3825] = "ER_INVALID_ENCRYPTION_REQUEST";
  exports[3826] = "ER_CANNOT_SET_TABLE_ENCRYPTION";
  exports[3827] = "ER_CANNOT_SET_DATABASE_ENCRYPTION";
  exports[3828] = "ER_CANNOT_SET_TABLESPACE_ENCRYPTION";
  exports[3829] = "ER_TABLESPACE_CANNOT_BE_ENCRYPTED";
  exports[3830] = "ER_TABLESPACE_CANNOT_BE_DECRYPTED";
  exports[3831] = "ER_TABLESPACE_TYPE_UNKNOWN";
  exports[3832] = "ER_TARGET_TABLESPACE_UNENCRYPTED";
  exports[3833] = "ER_CANNOT_USE_ENCRYPTION_CLAUSE";
  exports[3834] = "ER_INVALID_MULTIPLE_CLAUSES";
  exports[3835] = "ER_UNSUPPORTED_USE_OF_GRANT_AS";
  exports[3836] = "ER_UKNOWN_AUTH_ID_OR_ACCESS_DENIED_FOR_GRANT_AS";
  exports[3837] = "ER_DEPENDENT_BY_FUNCTIONAL_INDEX";
  exports[3838] = "ER_PLUGIN_NOT_EARLY";
  exports[3839] = "ER_INNODB_REDO_LOG_ARCHIVE_START_SUBDIR_PATH";
  exports[3840] = "ER_INNODB_REDO_LOG_ARCHIVE_START_TIMEOUT";
  exports[3841] = "ER_INNODB_REDO_LOG_ARCHIVE_DIRS_INVALID";
  exports[3842] = "ER_INNODB_REDO_LOG_ARCHIVE_LABEL_NOT_FOUND";
  exports[3843] = "ER_INNODB_REDO_LOG_ARCHIVE_DIR_EMPTY";
  exports[3844] = "ER_INNODB_REDO_LOG_ARCHIVE_NO_SUCH_DIR";
  exports[3845] = "ER_INNODB_REDO_LOG_ARCHIVE_DIR_CLASH";
  exports[3846] = "ER_INNODB_REDO_LOG_ARCHIVE_DIR_PERMISSIONS";
  exports[3847] = "ER_INNODB_REDO_LOG_ARCHIVE_FILE_CREATE";
  exports[3848] = "ER_INNODB_REDO_LOG_ARCHIVE_ACTIVE";
  exports[3849] = "ER_INNODB_REDO_LOG_ARCHIVE_INACTIVE";
  exports[3850] = "ER_INNODB_REDO_LOG_ARCHIVE_FAILED";
  exports[3851] = "ER_INNODB_REDO_LOG_ARCHIVE_SESSION";
  exports[3852] = "ER_STD_REGEX_ERROR";
  exports[3853] = "ER_INVALID_JSON_TYPE";
  exports[3854] = "ER_CANNOT_CONVERT_STRING";
  exports[3855] = "ER_DEPENDENT_BY_PARTITION_FUNC";
  exports[3856] = "ER_WARN_DEPRECATED_FLOAT_AUTO_INCREMENT";
  exports[3857] = "ER_RPL_CANT_STOP_REPLICA_WHILE_LOCKED_BACKUP";
  exports[3858] = "ER_WARN_DEPRECATED_FLOAT_DIGITS";
  exports[3859] = "ER_WARN_DEPRECATED_FLOAT_UNSIGNED";
  exports[3860] = "ER_WARN_DEPRECATED_INTEGER_DISPLAY_WIDTH";
  exports[3861] = "ER_WARN_DEPRECATED_ZEROFILL";
  exports[3862] = "ER_CLONE_DONOR";
  exports[3863] = "ER_CLONE_PROTOCOL";
  exports[3864] = "ER_CLONE_DONOR_VERSION";
  exports[3865] = "ER_CLONE_OS";
  exports[3866] = "ER_CLONE_PLATFORM";
  exports[3867] = "ER_CLONE_CHARSET";
  exports[3868] = "ER_CLONE_CONFIG";
  exports[3869] = "ER_CLONE_SYS_CONFIG";
  exports[3870] = "ER_CLONE_PLUGIN_MATCH";
  exports[3871] = "ER_CLONE_LOOPBACK";
  exports[3872] = "ER_CLONE_ENCRYPTION";
  exports[3873] = "ER_CLONE_DISK_SPACE";
  exports[3874] = "ER_CLONE_IN_PROGRESS";
  exports[3875] = "ER_CLONE_DISALLOWED";
  exports[3876] = "ER_CANNOT_GRANT_ROLES_TO_ANONYMOUS_USER";
  exports[3877] = "ER_SECONDARY_ENGINE_PLUGIN";
  exports[3878] = "ER_SECOND_PASSWORD_CANNOT_BE_EMPTY";
  exports[3879] = "ER_DB_ACCESS_DENIED";
  exports[3880] = "ER_DA_AUTH_ID_WITH_SYSTEM_USER_PRIV_IN_MANDATORY_ROLES";
  exports[3881] = "ER_DA_RPL_GTID_TABLE_CANNOT_OPEN";
  exports[3882] = "ER_GEOMETRY_IN_UNKNOWN_LENGTH_UNIT";
  exports[3883] = "ER_DA_PLUGIN_INSTALL_ERROR";
  exports[3884] = "ER_NO_SESSION_TEMP";
  exports[3885] = "ER_DA_UNKNOWN_ERROR_NUMBER";
  exports[3886] = "ER_COLUMN_CHANGE_SIZE";
  exports[3887] = "ER_REGEXP_INVALID_CAPTURE_GROUP_NAME";
  exports[3888] = "ER_DA_SSL_LIBRARY_ERROR";
  exports[3889] = "ER_SECONDARY_ENGINE";
  exports[3890] = "ER_SECONDARY_ENGINE_DDL";
  exports[3891] = "ER_INCORRECT_CURRENT_PASSWORD";
  exports[3892] = "ER_MISSING_CURRENT_PASSWORD";
  exports[3893] = "ER_CURRENT_PASSWORD_NOT_REQUIRED";
  exports[3894] = "ER_PASSWORD_CANNOT_BE_RETAINED_ON_PLUGIN_CHANGE";
  exports[3895] = "ER_CURRENT_PASSWORD_CANNOT_BE_RETAINED";
  exports[3896] = "ER_PARTIAL_REVOKES_EXIST";
  exports[3897] = "ER_CANNOT_GRANT_SYSTEM_PRIV_TO_MANDATORY_ROLE";
  exports[3898] = "ER_XA_REPLICATION_FILTERS";
  exports[3899] = "ER_UNSUPPORTED_SQL_MODE";
  exports[3900] = "ER_REGEXP_INVALID_FLAG";
  exports[3901] = "ER_PARTIAL_REVOKE_AND_DB_GRANT_BOTH_EXISTS";
  exports[3902] = "ER_UNIT_NOT_FOUND";
  exports[3903] = "ER_INVALID_JSON_VALUE_FOR_FUNC_INDEX";
  exports[3904] = "ER_JSON_VALUE_OUT_OF_RANGE_FOR_FUNC_INDEX";
  exports[3905] = "ER_EXCEEDED_MV_KEYS_NUM";
  exports[3906] = "ER_EXCEEDED_MV_KEYS_SPACE";
  exports[3907] = "ER_FUNCTIONAL_INDEX_DATA_IS_TOO_LONG";
  exports[3908] = "ER_WRONG_MVI_VALUE";
  exports[3909] = "ER_WARN_FUNC_INDEX_NOT_APPLICABLE";
  exports[3910] = "ER_GRP_RPL_UDF_ERROR";
  exports[3911] = "ER_UPDATE_GTID_PURGED_WITH_GR";
  exports[3912] = "ER_GROUPING_ON_TIMESTAMP_IN_DST";
  exports[3913] = "ER_TABLE_NAME_CAUSES_TOO_LONG_PATH";
  exports[3914] = "ER_AUDIT_LOG_INSUFFICIENT_PRIVILEGE";
  exports[3915] = "ER_AUDIT_LOG_PASSWORD_HAS_BEEN_COPIED";
  exports[3916] = "ER_DA_GRP_RPL_STARTED_AUTO_REJOIN";
  exports[3917] = "ER_SYSVAR_CHANGE_DURING_QUERY";
  exports[3918] = "ER_GLOBSTAT_CHANGE_DURING_QUERY";
  exports[3919] = "ER_GRP_RPL_MESSAGE_SERVICE_INIT_FAILURE";
  exports[3920] = "ER_CHANGE_SOURCE_WRONG_COMPRESSION_ALGORITHM_CLIENT";
  exports[3921] = "ER_CHANGE_SOURCE_WRONG_COMPRESSION_LEVEL_CLIENT";
  exports[3922] = "ER_WRONG_COMPRESSION_ALGORITHM_CLIENT";
  exports[3923] = "ER_WRONG_COMPRESSION_LEVEL_CLIENT";
  exports[3924] = "ER_CHANGE_SOURCE_WRONG_COMPRESSION_ALGORITHM_LIST_CLIENT";
  exports[3925] = "ER_CLIENT_PRIVILEGE_CHECKS_USER_CANNOT_BE_ANONYMOUS";
  exports[3926] = "ER_CLIENT_PRIVILEGE_CHECKS_USER_DOES_NOT_EXIST";
  exports[3927] = "ER_CLIENT_PRIVILEGE_CHECKS_USER_CORRUPT";
  exports[3928] = "ER_CLIENT_PRIVILEGE_CHECKS_USER_NEEDS_RPL_APPLIER_PRIV";
  exports[3929] = "ER_WARN_DA_PRIVILEGE_NOT_REGISTERED";
  exports[3930] = "ER_CLIENT_KEYRING_UDF_KEY_INVALID";
  exports[3931] = "ER_CLIENT_KEYRING_UDF_KEY_TYPE_INVALID";
  exports[3932] = "ER_CLIENT_KEYRING_UDF_KEY_TOO_LONG";
  exports[3933] = "ER_CLIENT_KEYRING_UDF_KEY_TYPE_TOO_LONG";
  exports[3934] = "ER_JSON_SCHEMA_VALIDATION_ERROR_WITH_DETAILED_REPORT";
  exports[3935] = "ER_DA_UDF_INVALID_CHARSET_SPECIFIED";
  exports[3936] = "ER_DA_UDF_INVALID_CHARSET";
  exports[3937] = "ER_DA_UDF_INVALID_COLLATION";
  exports[3938] = "ER_DA_UDF_INVALID_EXTENSION_ARGUMENT_TYPE";
  exports[3939] = "ER_MULTIPLE_CONSTRAINTS_WITH_SAME_NAME";
  exports[3940] = "ER_CONSTRAINT_NOT_FOUND";
  exports[3941] = "ER_ALTER_CONSTRAINT_ENFORCEMENT_NOT_SUPPORTED";
  exports[3942] = "ER_TABLE_VALUE_CONSTRUCTOR_MUST_HAVE_COLUMNS";
  exports[3943] = "ER_TABLE_VALUE_CONSTRUCTOR_CANNOT_HAVE_DEFAULT";
  exports[3944] = "ER_CLIENT_QUERY_FAILURE_INVALID_NON_ROW_FORMAT";
  exports[3945] = "ER_REQUIRE_ROW_FORMAT_INVALID_VALUE";
  exports[3946] = "ER_FAILED_TO_DETERMINE_IF_ROLE_IS_MANDATORY";
  exports[3947] = "ER_FAILED_TO_FETCH_MANDATORY_ROLE_LIST";
  exports[3948] = "ER_CLIENT_LOCAL_FILES_DISABLED";
  exports[3949] = "ER_IMP_INCOMPATIBLE_CFG_VERSION";
  exports[3950] = "ER_DA_OOM";
  exports[3951] = "ER_DA_UDF_INVALID_ARGUMENT_TO_SET_CHARSET";
  exports[3952] = "ER_DA_UDF_INVALID_RETURN_TYPE_TO_SET_CHARSET";
  exports[3953] = "ER_MULTIPLE_INTO_CLAUSES";
  exports[3954] = "ER_MISPLACED_INTO";
  exports[3955] = "ER_USER_ACCESS_DENIED_FOR_USER_ACCOUNT_BLOCKED_BY_PASSWORD_LOCK";
  exports[3956] = "ER_WARN_DEPRECATED_YEAR_UNSIGNED";
  exports[3957] = "ER_CLONE_NETWORK_PACKET";
  exports[3958] = "ER_SDI_OPERATION_FAILED_MISSING_RECORD";
  exports[3959] = "ER_DEPENDENT_BY_CHECK_CONSTRAINT";
  exports[3960] = "ER_GRP_OPERATION_NOT_ALLOWED_GR_MUST_STOP";
  exports[3961] = "ER_WARN_DEPRECATED_JSON_TABLE_ON_ERROR_ON_EMPTY";
  exports[3962] = "ER_WARN_DEPRECATED_INNER_INTO";
  exports[3963] = "ER_WARN_DEPRECATED_VALUES_FUNCTION_ALWAYS_NULL";
  exports[3964] = "ER_WARN_DEPRECATED_SQL_CALC_FOUND_ROWS";
  exports[3965] = "ER_WARN_DEPRECATED_FOUND_ROWS";
  exports[3966] = "ER_MISSING_JSON_VALUE";
  exports[3967] = "ER_MULTIPLE_JSON_VALUES";
  exports[3968] = "ER_HOSTNAME_TOO_LONG";
  exports[3969] = "ER_WARN_CLIENT_DEPRECATED_PARTITION_PREFIX_KEY";
  exports[3970] = "ER_GROUP_REPLICATION_USER_EMPTY_MSG";
  exports[3971] = "ER_GROUP_REPLICATION_USER_MANDATORY_MSG";
  exports[3972] = "ER_GROUP_REPLICATION_PASSWORD_LENGTH";
  exports[3973] = "ER_SUBQUERY_TRANSFORM_REJECTED";
  exports[3974] = "ER_DA_GRP_RPL_RECOVERY_ENDPOINT_FORMAT";
  exports[3975] = "ER_DA_GRP_RPL_RECOVERY_ENDPOINT_INVALID";
  exports[3976] = "ER_WRONG_VALUE_FOR_VAR_PLUS_ACTIONABLE_PART";
  exports[3977] = "ER_STATEMENT_NOT_ALLOWED_AFTER_START_TRANSACTION";
  exports[3978] = "ER_FOREIGN_KEY_WITH_ATOMIC_CREATE_SELECT";
  exports[3979] = "ER_NOT_ALLOWED_WITH_START_TRANSACTION";
  exports[3980] = "ER_INVALID_JSON_ATTRIBUTE";
  exports[3981] = "ER_ENGINE_ATTRIBUTE_NOT_SUPPORTED";
  exports[3982] = "ER_INVALID_USER_ATTRIBUTE_JSON";
  exports[3983] = "ER_INNODB_REDO_DISABLED";
  exports[3984] = "ER_INNODB_REDO_ARCHIVING_ENABLED";
  exports[3985] = "ER_MDL_OUT_OF_RESOURCES";
  exports[3986] = "ER_IMPLICIT_COMPARISON_FOR_JSON";
  exports[3987] = "ER_FUNCTION_DOES_NOT_SUPPORT_CHARACTER_SET";
  exports[3988] = "ER_IMPOSSIBLE_STRING_CONVERSION";
  exports[3989] = "ER_SCHEMA_READ_ONLY";
  exports[3990] = "ER_RPL_ASYNC_RECONNECT_GTID_MODE_OFF";
  exports[3991] = "ER_RPL_ASYNC_RECONNECT_AUTO_POSITION_OFF";
  exports[3992] = "ER_DISABLE_GTID_MODE_REQUIRES_ASYNC_RECONNECT_OFF";
  exports[3993] = "ER_DISABLE_AUTO_POSITION_REQUIRES_ASYNC_RECONNECT_OFF";
  exports[3994] = "ER_INVALID_PARAMETER_USE";
  exports[3995] = "ER_CHARACTER_SET_MISMATCH";
  exports[3996] = "ER_WARN_VAR_VALUE_CHANGE_NOT_SUPPORTED";
  exports[3997] = "ER_INVALID_TIME_ZONE_INTERVAL";
  exports[3998] = "ER_INVALID_CAST";
  exports[3999] = "ER_HYPERGRAPH_NOT_SUPPORTED_YET";
  exports[4000] = "ER_WARN_HYPERGRAPH_EXPERIMENTAL";
  exports[4001] = "ER_DA_NO_ERROR_LOG_PARSER_CONFIGURED";
  exports[4002] = "ER_DA_ERROR_LOG_TABLE_DISABLED";
  exports[4003] = "ER_DA_ERROR_LOG_MULTIPLE_FILTERS";
  exports[4004] = "ER_DA_CANT_OPEN_ERROR_LOG";
  exports[4005] = "ER_USER_REFERENCED_AS_DEFINER";
  exports[4006] = "ER_CANNOT_USER_REFERENCED_AS_DEFINER";
  exports[4007] = "ER_REGEX_NUMBER_TOO_BIG";
  exports[4008] = "ER_SPVAR_NONINTEGER_TYPE";
  exports[4009] = "WARN_UNSUPPORTED_ACL_TABLES_READ";
  exports[4010] = "ER_BINLOG_UNSAFE_ACL_TABLE_READ_IN_DML_DDL";
  exports[4011] = "ER_STOP_REPLICA_MONITOR_IO_THREAD_TIMEOUT";
  exports[4012] = "ER_STARTING_REPLICA_MONITOR_IO_THREAD";
  exports[4013] = "ER_CANT_USE_ANONYMOUS_TO_GTID_WITH_GTID_MODE_NOT_ON";
  exports[4014] = "ER_CANT_COMBINE_ANONYMOUS_TO_GTID_AND_AUTOPOSITION";
  exports[4015] = "ER_ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS_REQUIRES_GTID_MODE_ON";
  exports[4016] = "ER_SQL_REPLICA_SKIP_COUNTER_USED_WITH_GTID_MODE_ON";
  exports[4017] = "ER_USING_ASSIGN_GTIDS_TO_ANONYMOUS_TRANSACTIONS_AS_LOCAL_OR_UUID";
  exports[4018] = "ER_CANT_SET_ANONYMOUS_TO_GTID_AND_WAIT_UNTIL_SQL_THD_AFTER_GTIDS";
  exports[4019] = "ER_CANT_SET_SQL_AFTER_OR_BEFORE_GTIDS_WITH_ANONYMOUS_TO_GTID";
  exports[4020] = "ER_ANONYMOUS_TO_GTID_UUID_SAME_AS_GROUP_NAME";
  exports[4021] = "ER_CANT_USE_SAME_UUID_AS_GROUP_NAME";
  exports[4022] = "ER_GRP_RPL_RECOVERY_CHANNEL_STILL_RUNNING";
  exports[4023] = "ER_INNODB_INVALID_AUTOEXTEND_SIZE_VALUE";
  exports[4024] = "ER_INNODB_INCOMPATIBLE_WITH_TABLESPACE";
  exports[4025] = "ER_INNODB_AUTOEXTEND_SIZE_OUT_OF_RANGE";
  exports[4026] = "ER_CANNOT_USE_AUTOEXTEND_SIZE_CLAUSE";
  exports[4027] = "ER_ROLE_GRANTED_TO_ITSELF";
  exports[4028] = "ER_TABLE_MUST_HAVE_A_VISIBLE_COLUMN";
  exports[4029] = "ER_INNODB_COMPRESSION_FAILURE";
  exports[4030] = "ER_WARN_ASYNC_CONN_FAILOVER_NETWORK_NAMESPACE";
  exports[4031] = "ER_CLIENT_INTERACTION_TIMEOUT";
  exports[4032] = "ER_INVALID_CAST_TO_GEOMETRY";
  exports[4033] = "ER_INVALID_CAST_POLYGON_RING_DIRECTION";
  exports[4034] = "ER_GIS_DIFFERENT_SRIDS_AGGREGATION";
  exports[4035] = "ER_RELOAD_KEYRING_FAILURE";
  exports[4036] = "ER_SDI_GET_KEYS_INVALID_TABLESPACE";
  exports[4037] = "ER_CHANGE_RPL_SRC_WRONG_COMPRESSION_ALGORITHM_SIZE";
  exports[4038] = "ER_WARN_DEPRECATED_TLS_VERSION_FOR_CHANNEL_CLI";
  exports[4039] = "ER_CANT_USE_SAME_UUID_AS_VIEW_CHANGE_UUID";
  exports[4040] = "ER_ANONYMOUS_TO_GTID_UUID_SAME_AS_VIEW_CHANGE_UUID";
  exports[4041] = "ER_GRP_RPL_VIEW_CHANGE_UUID_FAIL_GET_VARIABLE";
  exports[4042] = "ER_WARN_ADUIT_LOG_MAX_SIZE_AND_PRUNE_SECONDS";
  exports[4043] = "ER_WARN_ADUIT_LOG_MAX_SIZE_CLOSE_TO_ROTATE_ON_SIZE";
  exports[4044] = "ER_KERBEROS_CREATE_USER";
  exports[4045] = "ER_INSTALL_PLUGIN_CONFLICT_CLIENT";
  exports[4046] = "ER_DA_ERROR_LOG_COMPONENT_FLUSH_FAILED";
  exports[4047] = "ER_WARN_SQL_AFTER_MTS_GAPS_GAP_NOT_CALCULATED";
  exports[4048] = "ER_INVALID_ASSIGNMENT_TARGET";
  exports[4049] = "ER_OPERATION_NOT_ALLOWED_ON_GR_SECONDARY";
  exports[4050] = "ER_GRP_RPL_FAILOVER_CHANNEL_STATUS_PROPAGATION";
  exports[4051] = "ER_WARN_AUDIT_LOG_FORMAT_UNIX_TIMESTAMP_ONLY_WHEN_JSON";
  exports[4052] = "ER_INVALID_MFA_PLUGIN_SPECIFIED";
  exports[4053] = "ER_IDENTIFIED_BY_UNSUPPORTED";
  exports[4054] = "ER_INVALID_PLUGIN_FOR_REGISTRATION";
  exports[4055] = "ER_PLUGIN_REQUIRES_REGISTRATION";
  exports[4056] = "ER_MFA_METHOD_EXISTS";
  exports[4057] = "ER_MFA_METHOD_NOT_EXISTS";
  exports[4058] = "ER_AUTHENTICATION_POLICY_MISMATCH";
  exports[4059] = "ER_PLUGIN_REGISTRATION_DONE";
  exports[4060] = "ER_INVALID_USER_FOR_REGISTRATION";
  exports[4061] = "ER_USER_REGISTRATION_FAILED";
  exports[4062] = "ER_MFA_METHODS_INVALID_ORDER";
  exports[4063] = "ER_MFA_METHODS_IDENTICAL";
  exports[4064] = "ER_INVALID_MFA_OPERATIONS_FOR_PASSWORDLESS_USER";
  exports[4065] = "ER_CHANGE_REPLICATION_SOURCE_NO_OPTIONS_FOR_GTID_ONLY";
  exports[4066] = "ER_CHANGE_REP_SOURCE_CANT_DISABLE_REQ_ROW_FORMAT_WITH_GTID_ONLY";
  exports[4067] = "ER_CHANGE_REP_SOURCE_CANT_DISABLE_AUTO_POSITION_WITH_GTID_ONLY";
  exports[4068] = "ER_CHANGE_REP_SOURCE_CANT_DISABLE_GTID_ONLY_WITHOUT_POSITIONS";
  exports[4069] = "ER_CHANGE_REP_SOURCE_CANT_DISABLE_AUTO_POS_WITHOUT_POSITIONS";
  exports[4070] = "ER_CHANGE_REP_SOURCE_GR_CHANNEL_WITH_GTID_MODE_NOT_ON";
  exports[4071] = "ER_CANT_USE_GTID_ONLY_WITH_GTID_MODE_NOT_ON";
  exports[4072] = "ER_WARN_C_DISABLE_GTID_ONLY_WITH_SOURCE_AUTO_POS_INVALID_POS";
  exports[4073] = "ER_DA_SSL_FIPS_MODE_ERROR";
  exports[4074] = "ER_VALUE_OUT_OF_RANGE";
  exports[4075] = "ER_FULLTEXT_WITH_ROLLUP";
  exports[4076] = "ER_REGEXP_MISSING_RESOURCE";
  exports[4077] = "ER_WARN_REGEXP_USING_DEFAULT";
  exports[4078] = "ER_REGEXP_MISSING_FILE";
  exports[4079] = "ER_WARN_DEPRECATED_COLLATION";
  exports[4080] = "ER_CONCURRENT_PROCEDURE_USAGE";
  exports[4081] = "ER_DA_GLOBAL_CONN_LIMIT";
  exports[4082] = "ER_DA_CONN_LIMIT";
  exports[4083] = "ER_ALTER_OPERATION_NOT_SUPPORTED_REASON_COLUMN_TYPE_INSTANT";
  exports[4084] = "ER_WARN_SF_UDF_NAME_COLLISION";
  exports[4085] = "ER_CANNOT_PURGE_BINLOG_WITH_BACKUP_LOCK";
  exports[4086] = "ER_TOO_MANY_WINDOWS";
  exports[4087] = "ER_MYSQLBACKUP_CLIENT_MSG";
  exports[4088] = "ER_COMMENT_CONTAINS_INVALID_STRING";
  exports[4089] = "ER_DEFINITION_CONTAINS_INVALID_STRING";
  exports[4090] = "ER_CANT_EXECUTE_COMMAND_WITH_ASSIGNED_GTID_NEXT";
  exports[4091] = "ER_XA_TEMP_TABLE";
  exports[4092] = "ER_INNODB_MAX_ROW_VERSION";
  exports[4093] = "ER_INNODB_INSTANT_ADD_NOT_SUPPORTED_MAX_SIZE";
  exports[4094] = "ER_OPERATION_NOT_ALLOWED_WHILE_PRIMARY_CHANGE_IS_RUNNING";
  exports[4095] = "ER_WARN_DEPRECATED_DATETIME_DELIMITER";
  exports[4096] = "ER_WARN_DEPRECATED_SUPERFLUOUS_DELIMITER";
  exports[4097] = "ER_CANNOT_PERSIST_SENSITIVE_VARIABLES";
  exports[4098] = "ER_WARN_CANNOT_SECURELY_PERSIST_SENSITIVE_VARIABLES";
  exports[4099] = "ER_WARN_TRG_ALREADY_EXISTS";
  exports[4100] = "ER_IF_NOT_EXISTS_UNSUPPORTED_TRG_EXISTS_ON_DIFFERENT_TABLE";
  exports[4101] = "ER_IF_NOT_EXISTS_UNSUPPORTED_UDF_NATIVE_FCT_NAME_COLLISION";
  exports[4102] = "ER_SET_PASSWORD_AUTH_PLUGIN_ERROR";
  exports[4103] = "ER_REDUCED_DBLWR_FILE_CORRUPTED";
  exports[4104] = "ER_REDUCED_DBLWR_PAGE_FOUND";
  exports[4105] = "ER_SRS_INVALID_LATITUDE_OF_ORIGIN";
  exports[4106] = "ER_SRS_INVALID_LONGITUDE_OF_ORIGIN";
  exports[4107] = "ER_SRS_UNUSED_PROJ_PARAMETER_PRESENT";
  exports[4108] = "ER_GIPK_COLUMN_EXISTS";
  exports[4109] = "ER_GIPK_FAILED_AUTOINC_COLUMN_EXISTS";
  exports[4110] = "ER_GIPK_COLUMN_ALTER_NOT_ALLOWED";
  exports[4111] = "ER_DROP_PK_COLUMN_TO_DROP_GIPK";
  exports[4112] = "ER_CREATE_SELECT_WITH_GIPK_DISALLOWED_IN_SBR";
  exports[4113] = "ER_DA_EXPIRE_LOGS_DAYS_IGNORED";
  exports[4114] = "ER_CTE_RECURSIVE_NOT_UNION";
  exports[4115] = "ER_COMMAND_BACKEND_FAILED_TO_FETCH_SECURITY_CTX";
  exports[4116] = "ER_COMMAND_SERVICE_BACKEND_FAILED";
  exports[4117] = "ER_CLIENT_FILE_PRIVILEGE_FOR_REPLICATION_CHECKS";
  exports[4118] = "ER_GROUP_REPLICATION_FORCE_MEMBERS_COMMAND_FAILURE";
  exports[4119] = "ER_WARN_DEPRECATED_IDENT";
  exports[4120] = "ER_INTERSECT_ALL_MAX_DUPLICATES_EXCEEDED";
  exports[4121] = "ER_TP_QUERY_THRS_PER_GRP_EXCEEDS_TXN_THR_LIMIT";
  exports[4122] = "ER_BAD_TIMESTAMP_FORMAT";
  exports[4123] = "ER_SHAPE_PRIDICTION_UDF";
  exports[4124] = "ER_SRS_INVALID_HEIGHT";
  exports[4125] = "ER_SRS_INVALID_SCALING";
  exports[4126] = "ER_SRS_INVALID_ZONE_WIDTH";
  exports[4127] = "ER_SRS_INVALID_LATITUDE_POLAR_STERE_VAR_A";
  exports[4128] = "ER_WARN_DEPRECATED_CLIENT_NO_SCHEMA_OPTION";
  exports[4129] = "ER_TABLE_NOT_EMPTY";
  exports[4130] = "ER_TABLE_NO_PRIMARY_KEY";
  exports[4131] = "ER_TABLE_IN_SHARED_TABLESPACE";
  exports[4132] = "ER_INDEX_OTHER_THAN_PK";
  exports[4133] = "ER_LOAD_BULK_DATA_UNSORTED";
  exports[4134] = "ER_BULK_EXECUTOR_ERROR";
  exports[4135] = "ER_BULK_READER_LIBCURL_INIT_FAILED";
  exports[4136] = "ER_BULK_READER_LIBCURL_ERROR";
  exports[4137] = "ER_BULK_READER_SERVER_ERROR";
  exports[4138] = "ER_BULK_READER_COMMUNICATION_ERROR";
  exports[4139] = "ER_BULK_LOAD_DATA_FAILED";
  exports[4140] = "ER_BULK_LOADER_COLUMN_TOO_BIG_FOR_LEFTOVER_BUFFER";
  exports[4141] = "ER_BULK_LOADER_COMPONENT_ERROR";
  exports[4142] = "ER_BULK_LOADER_FILE_CONTAINS_LESS_LINES_THAN_IGNORE_CLAUSE";
  exports[4143] = "ER_BULK_PARSER_MISSING_ENCLOSED_BY";
  exports[4144] = "ER_BULK_PARSER_ROW_BUFFER_MAX_TOTAL_COLS_EXCEEDED";
  exports[4145] = "ER_BULK_PARSER_COPY_BUFFER_SIZE_EXCEEDED";
  exports[4146] = "ER_BULK_PARSER_UNEXPECTED_END_OF_INPUT";
  exports[4147] = "ER_BULK_PARSER_UNEXPECTED_ROW_TERMINATOR";
  exports[4148] = "ER_BULK_PARSER_UNEXPECTED_CHAR_AFTER_ENDING_ENCLOSED_BY";
  exports[4149] = "ER_BULK_PARSER_UNEXPECTED_CHAR_AFTER_NULL_ESCAPE";
  exports[4150] = "ER_BULK_PARSER_UNEXPECTED_CHAR_AFTER_COLUMN_TERMINATOR";
  exports[4151] = "ER_BULK_PARSER_INCOMPLETE_ESCAPE_SEQUENCE";
  exports[4152] = "ER_LOAD_BULK_DATA_FAILED";
  exports[4153] = "ER_LOAD_BULK_DATA_WRONG_VALUE_FOR_FIELD";
  exports[4154] = "ER_LOAD_BULK_DATA_WARN_NULL_TO_NOTNULL";
  exports[4155] = "ER_REQUIRE_TABLE_PRIMARY_KEY_CHECK_GENERATE_WITH_GR";
  exports[4156] = "ER_CANT_CHANGE_SYS_VAR_IN_READ_ONLY_MODE";
  exports[4157] = "ER_INNODB_INSTANT_ADD_DROP_NOT_SUPPORTED_MAX_SIZE";
  exports[4158] = "ER_INNODB_INSTANT_ADD_NOT_SUPPORTED_MAX_FIELDS";
  exports[4159] = "ER_CANT_SET_PERSISTED";
  exports[4160] = "ER_INSTALL_COMPONENT_SET_NULL_VALUE";
  exports[4161] = "ER_INSTALL_COMPONENT_SET_UNUSED_VALUE";
  exports[4162] = "ER_WARN_DEPRECATED_USER_DEFINED_COLLATIONS";
});
var require_umd = __commonJS2((exports, module) => {
  var Long = function(exports2) {
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    exports2.default = undefined;
    var wasm = null;
    try {
      wasm = new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 13, 2, 96, 0, 1, 127, 96, 4, 127, 127, 127, 127, 1, 127, 3, 7, 6, 0, 1, 1, 1, 1, 1, 6, 6, 1, 127, 1, 65, 0, 11, 7, 50, 6, 3, 109, 117, 108, 0, 1, 5, 100, 105, 118, 95, 115, 0, 2, 5, 100, 105, 118, 95, 117, 0, 3, 5, 114, 101, 109, 95, 115, 0, 4, 5, 114, 101, 109, 95, 117, 0, 5, 8, 103, 101, 116, 95, 104, 105, 103, 104, 0, 0, 10, 191, 1, 6, 4, 0, 35, 0, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 126, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 127, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 128, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 129, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 130, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11])), {}).exports;
    } catch (e) {
    }
    function Long2(low, high, unsigned) {
      this.low = low | 0;
      this.high = high | 0;
      this.unsigned = !!unsigned;
    }
    Long2.prototype.__isLong__;
    Object.defineProperty(Long2.prototype, "__isLong__", {
      value: true
    });
    function isLong(obj) {
      return (obj && obj["__isLong__"]) === true;
    }
    function ctz32(value) {
      var c22 = Math.clz32(value & -value);
      return value ? 31 - c22 : c22;
    }
    Long2.isLong = isLong;
    var INT_CACHE = {};
    var UINT_CACHE = {};
    function fromInt(value, unsigned) {
      var obj, cachedObj, cache3;
      if (unsigned) {
        value >>>= 0;
        if (cache3 = 0 <= value && value < 256) {
          cachedObj = UINT_CACHE[value];
          if (cachedObj)
            return cachedObj;
        }
        obj = fromBits(value, 0, true);
        if (cache3)
          UINT_CACHE[value] = obj;
        return obj;
      } else {
        value |= 0;
        if (cache3 = -128 <= value && value < 128) {
          cachedObj = INT_CACHE[value];
          if (cachedObj)
            return cachedObj;
        }
        obj = fromBits(value, value < 0 ? -1 : 0, false);
        if (cache3)
          INT_CACHE[value] = obj;
        return obj;
      }
    }
    Long2.fromInt = fromInt;
    function fromNumber(value, unsigned) {
      if (isNaN(value))
        return unsigned ? UZERO : ZERO;
      if (unsigned) {
        if (value < 0)
          return UZERO;
        if (value >= TWO_PWR_64_DBL)
          return MAX_UNSIGNED_VALUE;
      } else {
        if (value <= -TWO_PWR_63_DBL)
          return MIN_VALUE;
        if (value + 1 >= TWO_PWR_63_DBL)
          return MAX_VALUE;
      }
      if (value < 0)
        return fromNumber(-value, unsigned).neg();
      return fromBits(value % TWO_PWR_32_DBL | 0, value / TWO_PWR_32_DBL | 0, unsigned);
    }
    Long2.fromNumber = fromNumber;
    function fromBits(lowBits, highBits, unsigned) {
      return new Long2(lowBits, highBits, unsigned);
    }
    Long2.fromBits = fromBits;
    var pow_dbl = Math.pow;
    function fromString(str, unsigned, radix) {
      if (str.length === 0)
        throw Error("empty string");
      if (typeof unsigned === "number") {
        radix = unsigned;
        unsigned = false;
      } else {
        unsigned = !!unsigned;
      }
      if (str === "NaN" || str === "Infinity" || str === "+Infinity" || str === "-Infinity")
        return unsigned ? UZERO : ZERO;
      radix = radix || 10;
      if (radix < 2 || 36 < radix)
        throw RangeError("radix");
      var p32;
      if ((p32 = str.indexOf("-")) > 0)
        throw Error("interior hyphen");
      else if (p32 === 0) {
        return fromString(str.substring(1), unsigned, radix).neg();
      }
      var radixToPower = fromNumber(pow_dbl(radix, 8));
      var result2 = ZERO;
      for (var i2 = 0;i2 < str.length; i2 += 8) {
        var size = Math.min(8, str.length - i2), value = parseInt(str.substring(i2, i2 + size), radix);
        if (size < 8) {
          var power = fromNumber(pow_dbl(radix, size));
          result2 = result2.mul(power).add(fromNumber(value));
        } else {
          result2 = result2.mul(radixToPower);
          result2 = result2.add(fromNumber(value));
        }
      }
      result2.unsigned = unsigned;
      return result2;
    }
    Long2.fromString = fromString;
    function fromValue(val2, unsigned) {
      if (typeof val2 === "number")
        return fromNumber(val2, unsigned);
      if (typeof val2 === "string")
        return fromString(val2, unsigned);
      return fromBits(val2.low, val2.high, typeof unsigned === "boolean" ? unsigned : val2.unsigned);
    }
    Long2.fromValue = fromValue;
    var TWO_PWR_16_DBL = 65536;
    var TWO_PWR_24_DBL = 16777216;
    var TWO_PWR_32_DBL = TWO_PWR_16_DBL * TWO_PWR_16_DBL;
    var TWO_PWR_64_DBL = TWO_PWR_32_DBL * TWO_PWR_32_DBL;
    var TWO_PWR_63_DBL = TWO_PWR_64_DBL / 2;
    var TWO_PWR_24 = fromInt(TWO_PWR_24_DBL);
    var ZERO = fromInt(0);
    Long2.ZERO = ZERO;
    var UZERO = fromInt(0, true);
    Long2.UZERO = UZERO;
    var ONE = fromInt(1);
    Long2.ONE = ONE;
    var UONE = fromInt(1, true);
    Long2.UONE = UONE;
    var NEG_ONE = fromInt(-1);
    Long2.NEG_ONE = NEG_ONE;
    var MAX_VALUE = fromBits(-1, 2147483647, false);
    Long2.MAX_VALUE = MAX_VALUE;
    var MAX_UNSIGNED_VALUE = fromBits(-1, -1, true);
    Long2.MAX_UNSIGNED_VALUE = MAX_UNSIGNED_VALUE;
    var MIN_VALUE = fromBits(0, -2147483648, false);
    Long2.MIN_VALUE = MIN_VALUE;
    var LongPrototype = Long2.prototype;
    LongPrototype.toInt = function toInt() {
      return this.unsigned ? this.low >>> 0 : this.low;
    };
    LongPrototype.toNumber = function toNumber() {
      if (this.unsigned)
        return (this.high >>> 0) * TWO_PWR_32_DBL + (this.low >>> 0);
      return this.high * TWO_PWR_32_DBL + (this.low >>> 0);
    };
    LongPrototype.toString = function toString(radix) {
      radix = radix || 10;
      if (radix < 2 || 36 < radix)
        throw RangeError("radix");
      if (this.isZero())
        return "0";
      if (this.isNegative()) {
        if (this.eq(MIN_VALUE)) {
          var radixLong = fromNumber(radix), div = this.div(radixLong), rem1 = div.mul(radixLong).sub(this);
          return div.toString(radix) + rem1.toInt().toString(radix);
        } else
          return "-" + this.neg().toString(radix);
      }
      var radixToPower = fromNumber(pow_dbl(radix, 6), this.unsigned), rem = this;
      var result2 = "";
      while (true) {
        var remDiv = rem.div(radixToPower), intval = rem.sub(remDiv.mul(radixToPower)).toInt() >>> 0, digits = intval.toString(radix);
        rem = remDiv;
        if (rem.isZero())
          return digits + result2;
        else {
          while (digits.length < 6)
            digits = "0" + digits;
          result2 = "" + digits + result2;
        }
      }
    };
    LongPrototype.getHighBits = function getHighBits() {
      return this.high;
    };
    LongPrototype.getHighBitsUnsigned = function getHighBitsUnsigned() {
      return this.high >>> 0;
    };
    LongPrototype.getLowBits = function getLowBits() {
      return this.low;
    };
    LongPrototype.getLowBitsUnsigned = function getLowBitsUnsigned() {
      return this.low >>> 0;
    };
    LongPrototype.getNumBitsAbs = function getNumBitsAbs() {
      if (this.isNegative())
        return this.eq(MIN_VALUE) ? 64 : this.neg().getNumBitsAbs();
      var val2 = this.high != 0 ? this.high : this.low;
      for (var bit = 31;bit > 0; bit--)
        if ((val2 & 1 << bit) != 0)
          break;
      return this.high != 0 ? bit + 33 : bit + 1;
    };
    LongPrototype.isZero = function isZero() {
      return this.high === 0 && this.low === 0;
    };
    LongPrototype.eqz = LongPrototype.isZero;
    LongPrototype.isNegative = function isNegative() {
      return !this.unsigned && this.high < 0;
    };
    LongPrototype.isPositive = function isPositive() {
      return this.unsigned || this.high >= 0;
    };
    LongPrototype.isOdd = function isOdd() {
      return (this.low & 1) === 1;
    };
    LongPrototype.isEven = function isEven() {
      return (this.low & 1) === 0;
    };
    LongPrototype.equals = function equals(other) {
      if (!isLong(other))
        other = fromValue(other);
      if (this.unsigned !== other.unsigned && this.high >>> 31 === 1 && other.high >>> 31 === 1)
        return false;
      return this.high === other.high && this.low === other.low;
    };
    LongPrototype.eq = LongPrototype.equals;
    LongPrototype.notEquals = function notEquals(other) {
      return !this.eq(other);
    };
    LongPrototype.neq = LongPrototype.notEquals;
    LongPrototype.ne = LongPrototype.notEquals;
    LongPrototype.lessThan = function lessThan(other) {
      return this.comp(other) < 0;
    };
    LongPrototype.lt = LongPrototype.lessThan;
    LongPrototype.lessThanOrEqual = function lessThanOrEqual(other) {
      return this.comp(other) <= 0;
    };
    LongPrototype.lte = LongPrototype.lessThanOrEqual;
    LongPrototype.le = LongPrototype.lessThanOrEqual;
    LongPrototype.greaterThan = function greaterThan(other) {
      return this.comp(other) > 0;
    };
    LongPrototype.gt = LongPrototype.greaterThan;
    LongPrototype.greaterThanOrEqual = function greaterThanOrEqual(other) {
      return this.comp(other) >= 0;
    };
    LongPrototype.gte = LongPrototype.greaterThanOrEqual;
    LongPrototype.ge = LongPrototype.greaterThanOrEqual;
    LongPrototype.compare = function compare(other) {
      if (!isLong(other))
        other = fromValue(other);
      if (this.eq(other))
        return 0;
      var thisNeg = this.isNegative(), otherNeg = other.isNegative();
      if (thisNeg && !otherNeg)
        return -1;
      if (!thisNeg && otherNeg)
        return 1;
      if (!this.unsigned)
        return this.sub(other).isNegative() ? -1 : 1;
      return other.high >>> 0 > this.high >>> 0 || other.high === this.high && other.low >>> 0 > this.low >>> 0 ? -1 : 1;
    };
    LongPrototype.comp = LongPrototype.compare;
    LongPrototype.negate = function negate() {
      if (!this.unsigned && this.eq(MIN_VALUE))
        return MIN_VALUE;
      return this.not().add(ONE);
    };
    LongPrototype.neg = LongPrototype.negate;
    LongPrototype.add = function add(addend) {
      if (!isLong(addend))
        addend = fromValue(addend);
      var a48 = this.high >>> 16;
      var a32 = this.high & 65535;
      var a16 = this.low >>> 16;
      var a00 = this.low & 65535;
      var b48 = addend.high >>> 16;
      var b32 = addend.high & 65535;
      var b16 = addend.low >>> 16;
      var b00 = addend.low & 65535;
      var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
      c00 += a00 + b00;
      c16 += c00 >>> 16;
      c00 &= 65535;
      c16 += a16 + b16;
      c32 += c16 >>> 16;
      c16 &= 65535;
      c32 += a32 + b32;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c48 += a48 + b48;
      c48 &= 65535;
      return fromBits(c16 << 16 | c00, c48 << 16 | c32, this.unsigned);
    };
    LongPrototype.subtract = function subtract(subtrahend) {
      if (!isLong(subtrahend))
        subtrahend = fromValue(subtrahend);
      return this.add(subtrahend.neg());
    };
    LongPrototype.sub = LongPrototype.subtract;
    LongPrototype.multiply = function multiply(multiplier) {
      if (this.isZero())
        return this;
      if (!isLong(multiplier))
        multiplier = fromValue(multiplier);
      if (wasm) {
        var low = wasm["mul"](this.low, this.high, multiplier.low, multiplier.high);
        return fromBits(low, wasm["get_high"](), this.unsigned);
      }
      if (multiplier.isZero())
        return this.unsigned ? UZERO : ZERO;
      if (this.eq(MIN_VALUE))
        return multiplier.isOdd() ? MIN_VALUE : ZERO;
      if (multiplier.eq(MIN_VALUE))
        return this.isOdd() ? MIN_VALUE : ZERO;
      if (this.isNegative()) {
        if (multiplier.isNegative())
          return this.neg().mul(multiplier.neg());
        else
          return this.neg().mul(multiplier).neg();
      } else if (multiplier.isNegative())
        return this.mul(multiplier.neg()).neg();
      if (this.lt(TWO_PWR_24) && multiplier.lt(TWO_PWR_24))
        return fromNumber(this.toNumber() * multiplier.toNumber(), this.unsigned);
      var a48 = this.high >>> 16;
      var a32 = this.high & 65535;
      var a16 = this.low >>> 16;
      var a00 = this.low & 65535;
      var b48 = multiplier.high >>> 16;
      var b32 = multiplier.high & 65535;
      var b16 = multiplier.low >>> 16;
      var b00 = multiplier.low & 65535;
      var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
      c00 += a00 * b00;
      c16 += c00 >>> 16;
      c00 &= 65535;
      c16 += a16 * b00;
      c32 += c16 >>> 16;
      c16 &= 65535;
      c16 += a00 * b16;
      c32 += c16 >>> 16;
      c16 &= 65535;
      c32 += a32 * b00;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c32 += a16 * b16;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c32 += a00 * b32;
      c48 += c32 >>> 16;
      c32 &= 65535;
      c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
      c48 &= 65535;
      return fromBits(c16 << 16 | c00, c48 << 16 | c32, this.unsigned);
    };
    LongPrototype.mul = LongPrototype.multiply;
    LongPrototype.divide = function divide(divisor) {
      if (!isLong(divisor))
        divisor = fromValue(divisor);
      if (divisor.isZero())
        throw Error("division by zero");
      if (wasm) {
        if (!this.unsigned && this.high === -2147483648 && divisor.low === -1 && divisor.high === -1) {
          return this;
        }
        var low = (this.unsigned ? wasm["div_u"] : wasm["div_s"])(this.low, this.high, divisor.low, divisor.high);
        return fromBits(low, wasm["get_high"](), this.unsigned);
      }
      if (this.isZero())
        return this.unsigned ? UZERO : ZERO;
      var approx, rem, res;
      if (!this.unsigned) {
        if (this.eq(MIN_VALUE)) {
          if (divisor.eq(ONE) || divisor.eq(NEG_ONE))
            return MIN_VALUE;
          else if (divisor.eq(MIN_VALUE))
            return ONE;
          else {
            var halfThis = this.shr(1);
            approx = halfThis.div(divisor).shl(1);
            if (approx.eq(ZERO)) {
              return divisor.isNegative() ? ONE : NEG_ONE;
            } else {
              rem = this.sub(divisor.mul(approx));
              res = approx.add(rem.div(divisor));
              return res;
            }
          }
        } else if (divisor.eq(MIN_VALUE))
          return this.unsigned ? UZERO : ZERO;
        if (this.isNegative()) {
          if (divisor.isNegative())
            return this.neg().div(divisor.neg());
          return this.neg().div(divisor).neg();
        } else if (divisor.isNegative())
          return this.div(divisor.neg()).neg();
        res = ZERO;
      } else {
        if (!divisor.unsigned)
          divisor = divisor.toUnsigned();
        if (divisor.gt(this))
          return UZERO;
        if (divisor.gt(this.shru(1)))
          return UONE;
        res = UZERO;
      }
      rem = this;
      while (rem.gte(divisor)) {
        approx = Math.max(1, Math.floor(rem.toNumber() / divisor.toNumber()));
        var log22 = Math.ceil(Math.log(approx) / Math.LN2), delta = log22 <= 48 ? 1 : pow_dbl(2, log22 - 48), approxRes = fromNumber(approx), approxRem = approxRes.mul(divisor);
        while (approxRem.isNegative() || approxRem.gt(rem)) {
          approx -= delta;
          approxRes = fromNumber(approx, this.unsigned);
          approxRem = approxRes.mul(divisor);
        }
        if (approxRes.isZero())
          approxRes = ONE;
        res = res.add(approxRes);
        rem = rem.sub(approxRem);
      }
      return res;
    };
    LongPrototype.div = LongPrototype.divide;
    LongPrototype.modulo = function modulo(divisor) {
      if (!isLong(divisor))
        divisor = fromValue(divisor);
      if (wasm) {
        var low = (this.unsigned ? wasm["rem_u"] : wasm["rem_s"])(this.low, this.high, divisor.low, divisor.high);
        return fromBits(low, wasm["get_high"](), this.unsigned);
      }
      return this.sub(this.div(divisor).mul(divisor));
    };
    LongPrototype.mod = LongPrototype.modulo;
    LongPrototype.rem = LongPrototype.modulo;
    LongPrototype.not = function not() {
      return fromBits(~this.low, ~this.high, this.unsigned);
    };
    LongPrototype.countLeadingZeros = function countLeadingZeros() {
      return this.high ? Math.clz32(this.high) : Math.clz32(this.low) + 32;
    };
    LongPrototype.clz = LongPrototype.countLeadingZeros;
    LongPrototype.countTrailingZeros = function countTrailingZeros() {
      return this.low ? ctz32(this.low) : ctz32(this.high) + 32;
    };
    LongPrototype.ctz = LongPrototype.countTrailingZeros;
    LongPrototype.and = function and(other) {
      if (!isLong(other))
        other = fromValue(other);
      return fromBits(this.low & other.low, this.high & other.high, this.unsigned);
    };
    LongPrototype.or = function or(other) {
      if (!isLong(other))
        other = fromValue(other);
      return fromBits(this.low | other.low, this.high | other.high, this.unsigned);
    };
    LongPrototype.xor = function xor(other) {
      if (!isLong(other))
        other = fromValue(other);
      return fromBits(this.low ^ other.low, this.high ^ other.high, this.unsigned);
    };
    LongPrototype.shiftLeft = function shiftLeft(numBits) {
      if (isLong(numBits))
        numBits = numBits.toInt();
      if ((numBits &= 63) === 0)
        return this;
      else if (numBits < 32)
        return fromBits(this.low << numBits, this.high << numBits | this.low >>> 32 - numBits, this.unsigned);
      else
        return fromBits(0, this.low << numBits - 32, this.unsigned);
    };
    LongPrototype.shl = LongPrototype.shiftLeft;
    LongPrototype.shiftRight = function shiftRight(numBits) {
      if (isLong(numBits))
        numBits = numBits.toInt();
      if ((numBits &= 63) === 0)
        return this;
      else if (numBits < 32)
        return fromBits(this.low >>> numBits | this.high << 32 - numBits, this.high >> numBits, this.unsigned);
      else
        return fromBits(this.high >> numBits - 32, this.high >= 0 ? 0 : -1, this.unsigned);
    };
    LongPrototype.shr = LongPrototype.shiftRight;
    LongPrototype.shiftRightUnsigned = function shiftRightUnsigned(numBits) {
      if (isLong(numBits))
        numBits = numBits.toInt();
      if ((numBits &= 63) === 0)
        return this;
      if (numBits < 32)
        return fromBits(this.low >>> numBits | this.high << 32 - numBits, this.high >>> numBits, this.unsigned);
      if (numBits === 32)
        return fromBits(this.high, 0, this.unsigned);
      return fromBits(this.high >>> numBits - 32, 0, this.unsigned);
    };
    LongPrototype.shru = LongPrototype.shiftRightUnsigned;
    LongPrototype.shr_u = LongPrototype.shiftRightUnsigned;
    LongPrototype.rotateLeft = function rotateLeft(numBits) {
      var b22;
      if (isLong(numBits))
        numBits = numBits.toInt();
      if ((numBits &= 63) === 0)
        return this;
      if (numBits === 32)
        return fromBits(this.high, this.low, this.unsigned);
      if (numBits < 32) {
        b22 = 32 - numBits;
        return fromBits(this.low << numBits | this.high >>> b22, this.high << numBits | this.low >>> b22, this.unsigned);
      }
      numBits -= 32;
      b22 = 32 - numBits;
      return fromBits(this.high << numBits | this.low >>> b22, this.low << numBits | this.high >>> b22, this.unsigned);
    };
    LongPrototype.rotl = LongPrototype.rotateLeft;
    LongPrototype.rotateRight = function rotateRight(numBits) {
      var b22;
      if (isLong(numBits))
        numBits = numBits.toInt();
      if ((numBits &= 63) === 0)
        return this;
      if (numBits === 32)
        return fromBits(this.high, this.low, this.unsigned);
      if (numBits < 32) {
        b22 = 32 - numBits;
        return fromBits(this.high << b22 | this.low >>> numBits, this.low << b22 | this.high >>> numBits, this.unsigned);
      }
      numBits -= 32;
      b22 = 32 - numBits;
      return fromBits(this.low << b22 | this.high >>> numBits, this.high << b22 | this.low >>> numBits, this.unsigned);
    };
    LongPrototype.rotr = LongPrototype.rotateRight;
    LongPrototype.toSigned = function toSigned() {
      if (!this.unsigned)
        return this;
      return fromBits(this.low, this.high, false);
    };
    LongPrototype.toUnsigned = function toUnsigned() {
      if (this.unsigned)
        return this;
      return fromBits(this.low, this.high, true);
    };
    LongPrototype.toBytes = function toBytes(le) {
      return le ? this.toBytesLE() : this.toBytesBE();
    };
    LongPrototype.toBytesLE = function toBytesLE() {
      var hi = this.high, lo = this.low;
      return [lo & 255, lo >>> 8 & 255, lo >>> 16 & 255, lo >>> 24, hi & 255, hi >>> 8 & 255, hi >>> 16 & 255, hi >>> 24];
    };
    LongPrototype.toBytesBE = function toBytesBE() {
      var hi = this.high, lo = this.low;
      return [hi >>> 24, hi >>> 16 & 255, hi >>> 8 & 255, hi & 255, lo >>> 24, lo >>> 16 & 255, lo >>> 8 & 255, lo & 255];
    };
    Long2.fromBytes = function fromBytes(bytes, unsigned, le) {
      return le ? Long2.fromBytesLE(bytes, unsigned) : Long2.fromBytesBE(bytes, unsigned);
    };
    Long2.fromBytesLE = function fromBytesLE(bytes, unsigned) {
      return new Long2(bytes[0] | bytes[1] << 8 | bytes[2] << 16 | bytes[3] << 24, bytes[4] | bytes[5] << 8 | bytes[6] << 16 | bytes[7] << 24, unsigned);
    };
    Long2.fromBytesBE = function fromBytesBE(bytes, unsigned) {
      return new Long2(bytes[4] << 24 | bytes[5] << 16 | bytes[6] << 8 | bytes[7], bytes[0] << 24 | bytes[1] << 16 | bytes[2] << 8 | bytes[3], unsigned);
    };
    var _default = Long2;
    exports2.default = _default;
    return "default" in exports2 ? exports2.default : exports2;
  }({});
  if (typeof define === "function" && define.amd)
    define([], function() {
      return Long;
    });
  else if (typeof module === "object" && typeof exports === "object")
    module.exports = Long;
});
var require_safer = __commonJS2((exports, module) => {
  var buffer = import.meta.require("buffer");
  var Buffer22 = buffer.Buffer;
  var safer = {};
  var key;
  for (key in buffer) {
    if (!buffer.hasOwnProperty(key))
      continue;
    if (key === "SlowBuffer" || key === "Buffer")
      continue;
    safer[key] = buffer[key];
  }
  var Safer = safer.Buffer = {};
  for (key in Buffer22) {
    if (!Buffer22.hasOwnProperty(key))
      continue;
    if (key === "allocUnsafe" || key === "allocUnsafeSlow")
      continue;
    Safer[key] = Buffer22[key];
  }
  safer.Buffer.prototype = Buffer22.prototype;
  if (!Safer.from || Safer.from === Uint8Array.from) {
    Safer.from = function(value, encodingOrOffset, length) {
      if (typeof value === "number") {
        throw new TypeError('The "value" argument must not be of type number. Received type ' + typeof value);
      }
      if (value && typeof value.length === "undefined") {
        throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + typeof value);
      }
      return Buffer22(value, encodingOrOffset, length);
    };
  }
  if (!Safer.alloc) {
    Safer.alloc = function(size, fill, encoding) {
      if (typeof size !== "number") {
        throw new TypeError('The "size" argument must be of type number. Received type ' + typeof size);
      }
      if (size < 0 || size >= 2147483648) {
        throw new RangeError('The value "' + size + '" is invalid for option "size"');
      }
      var buf = Buffer22(size);
      if (!fill || fill.length === 0) {
        buf.fill(0);
      } else if (typeof encoding === "string") {
        buf.fill(fill, encoding);
      } else {
        buf.fill(fill);
      }
      return buf;
    };
  }
  if (!safer.kStringMaxLength) {
    try {
      safer.kStringMaxLength = process.binding("buffer").kStringMaxLength;
    } catch (e) {
    }
  }
  if (!safer.constants) {
    safer.constants = {
      MAX_LENGTH: safer.kMaxLength
    };
    if (safer.kStringMaxLength) {
      safer.constants.MAX_STRING_LENGTH = safer.kStringMaxLength;
    }
  }
  module.exports = safer;
});
var require_bom_handling = __commonJS2((exports) => {
  var BOMChar = "\uFEFF";
  exports.PrependBOM = PrependBOMWrapper;
  function PrependBOMWrapper(encoder, options3) {
    this.encoder = encoder;
    this.addBOM = true;
  }
  PrependBOMWrapper.prototype.write = function(str) {
    if (this.addBOM) {
      str = BOMChar + str;
      this.addBOM = false;
    }
    return this.encoder.write(str);
  };
  PrependBOMWrapper.prototype.end = function() {
    return this.encoder.end();
  };
  exports.StripBOM = StripBOMWrapper;
  function StripBOMWrapper(decoder, options3) {
    this.decoder = decoder;
    this.pass = false;
    this.options = options3 || {};
  }
  StripBOMWrapper.prototype.write = function(buf) {
    var res = this.decoder.write(buf);
    if (this.pass || !res)
      return res;
    if (res[0] === BOMChar) {
      res = res.slice(1);
      if (typeof this.options.stripBOM === "function")
        this.options.stripBOM();
    }
    this.pass = true;
    return res;
  };
  StripBOMWrapper.prototype.end = function() {
    return this.decoder.end();
  };
});
var require_internal = __commonJS2((exports, module) => {
  var Buffer22 = require_safer().Buffer;
  module.exports = {
    utf8: { type: "_internal", bomAware: true },
    cesu8: { type: "_internal", bomAware: true },
    unicode11utf8: "utf8",
    ucs2: { type: "_internal", bomAware: true },
    utf16le: "ucs2",
    binary: { type: "_internal" },
    base64: { type: "_internal" },
    hex: { type: "_internal" },
    _internal: InternalCodec
  };
  function InternalCodec(codecOptions, iconv) {
    this.enc = codecOptions.encodingName;
    this.bomAware = codecOptions.bomAware;
    if (this.enc === "base64")
      this.encoder = InternalEncoderBase64;
    else if (this.enc === "cesu8") {
      this.enc = "utf8";
      this.encoder = InternalEncoderCesu8;
      if (Buffer22.from("eda0bdedb2a9", "hex").toString() !== "\uD83D\uDCA9") {
        this.decoder = InternalDecoderCesu8;
        this.defaultCharUnicode = iconv.defaultCharUnicode;
      }
    }
  }
  InternalCodec.prototype.encoder = InternalEncoder;
  InternalCodec.prototype.decoder = InternalDecoder;
  var StringDecoder = import.meta.require("string_decoder").StringDecoder;
  if (!StringDecoder.prototype.end)
    StringDecoder.prototype.end = function() {
    };
  function InternalDecoder(options3, codec) {
    this.decoder = new StringDecoder(codec.enc);
  }
  InternalDecoder.prototype.write = function(buf) {
    if (!Buffer22.isBuffer(buf)) {
      buf = Buffer22.from(buf);
    }
    return this.decoder.write(buf);
  };
  InternalDecoder.prototype.end = function() {
    return this.decoder.end();
  };
  function InternalEncoder(options3, codec) {
    this.enc = codec.enc;
  }
  InternalEncoder.prototype.write = function(str) {
    return Buffer22.from(str, this.enc);
  };
  InternalEncoder.prototype.end = function() {
  };
  function InternalEncoderBase64(options3, codec) {
    this.prevStr = "";
  }
  InternalEncoderBase64.prototype.write = function(str) {
    str = this.prevStr + str;
    var completeQuads = str.length - str.length % 4;
    this.prevStr = str.slice(completeQuads);
    str = str.slice(0, completeQuads);
    return Buffer22.from(str, "base64");
  };
  InternalEncoderBase64.prototype.end = function() {
    return Buffer22.from(this.prevStr, "base64");
  };
  function InternalEncoderCesu8(options3, codec) {
  }
  InternalEncoderCesu8.prototype.write = function(str) {
    var buf = Buffer22.alloc(str.length * 3), bufIdx = 0;
    for (var i2 = 0;i2 < str.length; i2++) {
      var charCode = str.charCodeAt(i2);
      if (charCode < 128)
        buf[bufIdx++] = charCode;
      else if (charCode < 2048) {
        buf[bufIdx++] = 192 + (charCode >>> 6);
        buf[bufIdx++] = 128 + (charCode & 63);
      } else {
        buf[bufIdx++] = 224 + (charCode >>> 12);
        buf[bufIdx++] = 128 + (charCode >>> 6 & 63);
        buf[bufIdx++] = 128 + (charCode & 63);
      }
    }
    return buf.slice(0, bufIdx);
  };
  InternalEncoderCesu8.prototype.end = function() {
  };
  function InternalDecoderCesu8(options3, codec) {
    this.acc = 0;
    this.contBytes = 0;
    this.accBytes = 0;
    this.defaultCharUnicode = codec.defaultCharUnicode;
  }
  InternalDecoderCesu8.prototype.write = function(buf) {
    var acc = this.acc, contBytes = this.contBytes, accBytes = this.accBytes, res = "";
    for (var i2 = 0;i2 < buf.length; i2++) {
      var curByte = buf[i2];
      if ((curByte & 192) !== 128) {
        if (contBytes > 0) {
          res += this.defaultCharUnicode;
          contBytes = 0;
        }
        if (curByte < 128) {
          res += String.fromCharCode(curByte);
        } else if (curByte < 224) {
          acc = curByte & 31;
          contBytes = 1;
          accBytes = 1;
        } else if (curByte < 240) {
          acc = curByte & 15;
          contBytes = 2;
          accBytes = 1;
        } else {
          res += this.defaultCharUnicode;
        }
      } else {
        if (contBytes > 0) {
          acc = acc << 6 | curByte & 63;
          contBytes--;
          accBytes++;
          if (contBytes === 0) {
            if (accBytes === 2 && acc < 128 && acc > 0)
              res += this.defaultCharUnicode;
            else if (accBytes === 3 && acc < 2048)
              res += this.defaultCharUnicode;
            else
              res += String.fromCharCode(acc);
          }
        } else {
          res += this.defaultCharUnicode;
        }
      }
    }
    this.acc = acc;
    this.contBytes = contBytes;
    this.accBytes = accBytes;
    return res;
  };
  InternalDecoderCesu8.prototype.end = function() {
    var res = 0;
    if (this.contBytes > 0)
      res += this.defaultCharUnicode;
    return res;
  };
});
var require_utf32 = __commonJS2((exports) => {
  var Buffer22 = require_safer().Buffer;
  exports._utf32 = Utf32Codec;
  function Utf32Codec(codecOptions, iconv) {
    this.iconv = iconv;
    this.bomAware = true;
    this.isLE = codecOptions.isLE;
  }
  exports.utf32le = { type: "_utf32", isLE: true };
  exports.utf32be = { type: "_utf32", isLE: false };
  exports.ucs4le = "utf32le";
  exports.ucs4be = "utf32be";
  Utf32Codec.prototype.encoder = Utf32Encoder;
  Utf32Codec.prototype.decoder = Utf32Decoder;
  function Utf32Encoder(options3, codec) {
    this.isLE = codec.isLE;
    this.highSurrogate = 0;
  }
  Utf32Encoder.prototype.write = function(str) {
    var src22 = Buffer22.from(str, "ucs2");
    var dst = Buffer22.alloc(src22.length * 2);
    var write32 = this.isLE ? dst.writeUInt32LE : dst.writeUInt32BE;
    var offset2 = 0;
    for (var i2 = 0;i2 < src22.length; i2 += 2) {
      var code = src22.readUInt16LE(i2);
      var isHighSurrogate = 55296 <= code && code < 56320;
      var isLowSurrogate = 56320 <= code && code < 57344;
      if (this.highSurrogate) {
        if (isHighSurrogate || !isLowSurrogate) {
          write32.call(dst, this.highSurrogate, offset2);
          offset2 += 4;
        } else {
          var codepoint = (this.highSurrogate - 55296 << 10 | code - 56320) + 65536;
          write32.call(dst, codepoint, offset2);
          offset2 += 4;
          this.highSurrogate = 0;
          continue;
        }
      }
      if (isHighSurrogate)
        this.highSurrogate = code;
      else {
        write32.call(dst, code, offset2);
        offset2 += 4;
        this.highSurrogate = 0;
      }
    }
    if (offset2 < dst.length)
      dst = dst.slice(0, offset2);
    return dst;
  };
  Utf32Encoder.prototype.end = function() {
    if (!this.highSurrogate)
      return;
    var buf = Buffer22.alloc(4);
    if (this.isLE)
      buf.writeUInt32LE(this.highSurrogate, 0);
    else
      buf.writeUInt32BE(this.highSurrogate, 0);
    this.highSurrogate = 0;
    return buf;
  };
  function Utf32Decoder(options3, codec) {
    this.isLE = codec.isLE;
    this.badChar = codec.iconv.defaultCharUnicode.charCodeAt(0);
    this.overflow = [];
  }
  Utf32Decoder.prototype.write = function(src22) {
    if (src22.length === 0)
      return "";
    var i2 = 0;
    var codepoint = 0;
    var dst = Buffer22.alloc(src22.length + 4);
    var offset2 = 0;
    var isLE = this.isLE;
    var overflow = this.overflow;
    var badChar = this.badChar;
    if (overflow.length > 0) {
      for (;i2 < src22.length && overflow.length < 4; i2++)
        overflow.push(src22[i2]);
      if (overflow.length === 4) {
        if (isLE) {
          codepoint = overflow[i2] | overflow[i2 + 1] << 8 | overflow[i2 + 2] << 16 | overflow[i2 + 3] << 24;
        } else {
          codepoint = overflow[i2 + 3] | overflow[i2 + 2] << 8 | overflow[i2 + 1] << 16 | overflow[i2] << 24;
        }
        overflow.length = 0;
        offset2 = _writeCodepoint(dst, offset2, codepoint, badChar);
      }
    }
    for (;i2 < src22.length - 3; i2 += 4) {
      if (isLE) {
        codepoint = src22[i2] | src22[i2 + 1] << 8 | src22[i2 + 2] << 16 | src22[i2 + 3] << 24;
      } else {
        codepoint = src22[i2 + 3] | src22[i2 + 2] << 8 | src22[i2 + 1] << 16 | src22[i2] << 24;
      }
      offset2 = _writeCodepoint(dst, offset2, codepoint, badChar);
    }
    for (;i2 < src22.length; i2++) {
      overflow.push(src22[i2]);
    }
    return dst.slice(0, offset2).toString("ucs2");
  };
  function _writeCodepoint(dst, offset2, codepoint, badChar) {
    if (codepoint < 0 || codepoint > 1114111) {
      codepoint = badChar;
    }
    if (codepoint >= 65536) {
      codepoint -= 65536;
      var high = 55296 | codepoint >> 10;
      dst[offset2++] = high & 255;
      dst[offset2++] = high >> 8;
      var codepoint = 56320 | codepoint & 1023;
    }
    dst[offset2++] = codepoint & 255;
    dst[offset2++] = codepoint >> 8;
    return offset2;
  }
  Utf32Decoder.prototype.end = function() {
    this.overflow.length = 0;
  };
  exports.utf32 = Utf32AutoCodec;
  exports.ucs4 = "utf32";
  function Utf32AutoCodec(options3, iconv) {
    this.iconv = iconv;
  }
  Utf32AutoCodec.prototype.encoder = Utf32AutoEncoder;
  Utf32AutoCodec.prototype.decoder = Utf32AutoDecoder;
  function Utf32AutoEncoder(options3, codec) {
    options3 = options3 || {};
    if (options3.addBOM === undefined)
      options3.addBOM = true;
    this.encoder = codec.iconv.getEncoder(options3.defaultEncoding || "utf-32le", options3);
  }
  Utf32AutoEncoder.prototype.write = function(str) {
    return this.encoder.write(str);
  };
  Utf32AutoEncoder.prototype.end = function() {
    return this.encoder.end();
  };
  function Utf32AutoDecoder(options3, codec) {
    this.decoder = null;
    this.initialBufs = [];
    this.initialBufsLen = 0;
    this.options = options3 || {};
    this.iconv = codec.iconv;
  }
  Utf32AutoDecoder.prototype.write = function(buf) {
    if (!this.decoder) {
      this.initialBufs.push(buf);
      this.initialBufsLen += buf.length;
      if (this.initialBufsLen < 32)
        return "";
      var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
      this.decoder = this.iconv.getDecoder(encoding, this.options);
      var resStr = "";
      for (var i2 = 0;i2 < this.initialBufs.length; i2++)
        resStr += this.decoder.write(this.initialBufs[i2]);
      this.initialBufs.length = this.initialBufsLen = 0;
      return resStr;
    }
    return this.decoder.write(buf);
  };
  Utf32AutoDecoder.prototype.end = function() {
    if (!this.decoder) {
      var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
      this.decoder = this.iconv.getDecoder(encoding, this.options);
      var resStr = "";
      for (var i2 = 0;i2 < this.initialBufs.length; i2++)
        resStr += this.decoder.write(this.initialBufs[i2]);
      var trail = this.decoder.end();
      if (trail)
        resStr += trail;
      this.initialBufs.length = this.initialBufsLen = 0;
      return resStr;
    }
    return this.decoder.end();
  };
  function detectEncoding(bufs, defaultEncoding) {
    var b22 = [];
    var charsProcessed = 0;
    var invalidLE = 0, invalidBE = 0;
    var bmpCharsLE = 0, bmpCharsBE = 0;
    outer_loop:
      for (var i2 = 0;i2 < bufs.length; i2++) {
        var buf = bufs[i2];
        for (var j22 = 0;j22 < buf.length; j22++) {
          b22.push(buf[j22]);
          if (b22.length === 4) {
            if (charsProcessed === 0) {
              if (b22[0] === 255 && b22[1] === 254 && b22[2] === 0 && b22[3] === 0) {
                return "utf-32le";
              }
              if (b22[0] === 0 && b22[1] === 0 && b22[2] === 254 && b22[3] === 255) {
                return "utf-32be";
              }
            }
            if (b22[0] !== 0 || b22[1] > 16)
              invalidBE++;
            if (b22[3] !== 0 || b22[2] > 16)
              invalidLE++;
            if (b22[0] === 0 && b22[1] === 0 && (b22[2] !== 0 || b22[3] !== 0))
              bmpCharsBE++;
            if ((b22[0] !== 0 || b22[1] !== 0) && b22[2] === 0 && b22[3] === 0)
              bmpCharsLE++;
            b22.length = 0;
            charsProcessed++;
            if (charsProcessed >= 100) {
              break outer_loop;
            }
          }
        }
      }
    if (bmpCharsBE - invalidBE > bmpCharsLE - invalidLE)
      return "utf-32be";
    if (bmpCharsBE - invalidBE < bmpCharsLE - invalidLE)
      return "utf-32le";
    return defaultEncoding || "utf-32le";
  }
});
var require_utf16 = __commonJS2((exports) => {
  var Buffer22 = require_safer().Buffer;
  exports.utf16be = Utf16BECodec;
  function Utf16BECodec() {
  }
  Utf16BECodec.prototype.encoder = Utf16BEEncoder;
  Utf16BECodec.prototype.decoder = Utf16BEDecoder;
  Utf16BECodec.prototype.bomAware = true;
  function Utf16BEEncoder() {
  }
  Utf16BEEncoder.prototype.write = function(str) {
    var buf = Buffer22.from(str, "ucs2");
    for (var i2 = 0;i2 < buf.length; i2 += 2) {
      var tmp = buf[i2];
      buf[i2] = buf[i2 + 1];
      buf[i2 + 1] = tmp;
    }
    return buf;
  };
  Utf16BEEncoder.prototype.end = function() {
  };
  function Utf16BEDecoder() {
    this.overflowByte = -1;
  }
  Utf16BEDecoder.prototype.write = function(buf) {
    if (buf.length == 0)
      return "";
    var buf2 = Buffer22.alloc(buf.length + 1), i2 = 0, j22 = 0;
    if (this.overflowByte !== -1) {
      buf2[0] = buf[0];
      buf2[1] = this.overflowByte;
      i2 = 1;
      j22 = 2;
    }
    for (;i2 < buf.length - 1; i2 += 2, j22 += 2) {
      buf2[j22] = buf[i2 + 1];
      buf2[j22 + 1] = buf[i2];
    }
    this.overflowByte = i2 == buf.length - 1 ? buf[buf.length - 1] : -1;
    return buf2.slice(0, j22).toString("ucs2");
  };
  Utf16BEDecoder.prototype.end = function() {
    this.overflowByte = -1;
  };
  exports.utf16 = Utf16Codec;
  function Utf16Codec(codecOptions, iconv) {
    this.iconv = iconv;
  }
  Utf16Codec.prototype.encoder = Utf16Encoder;
  Utf16Codec.prototype.decoder = Utf16Decoder;
  function Utf16Encoder(options3, codec) {
    options3 = options3 || {};
    if (options3.addBOM === undefined)
      options3.addBOM = true;
    this.encoder = codec.iconv.getEncoder("utf-16le", options3);
  }
  Utf16Encoder.prototype.write = function(str) {
    return this.encoder.write(str);
  };
  Utf16Encoder.prototype.end = function() {
    return this.encoder.end();
  };
  function Utf16Decoder(options3, codec) {
    this.decoder = null;
    this.initialBufs = [];
    this.initialBufsLen = 0;
    this.options = options3 || {};
    this.iconv = codec.iconv;
  }
  Utf16Decoder.prototype.write = function(buf) {
    if (!this.decoder) {
      this.initialBufs.push(buf);
      this.initialBufsLen += buf.length;
      if (this.initialBufsLen < 16)
        return "";
      var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
      this.decoder = this.iconv.getDecoder(encoding, this.options);
      var resStr = "";
      for (var i2 = 0;i2 < this.initialBufs.length; i2++)
        resStr += this.decoder.write(this.initialBufs[i2]);
      this.initialBufs.length = this.initialBufsLen = 0;
      return resStr;
    }
    return this.decoder.write(buf);
  };
  Utf16Decoder.prototype.end = function() {
    if (!this.decoder) {
      var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
      this.decoder = this.iconv.getDecoder(encoding, this.options);
      var resStr = "";
      for (var i2 = 0;i2 < this.initialBufs.length; i2++)
        resStr += this.decoder.write(this.initialBufs[i2]);
      var trail = this.decoder.end();
      if (trail)
        resStr += trail;
      this.initialBufs.length = this.initialBufsLen = 0;
      return resStr;
    }
    return this.decoder.end();
  };
  function detectEncoding(bufs, defaultEncoding) {
    var b22 = [];
    var charsProcessed = 0;
    var asciiCharsLE = 0, asciiCharsBE = 0;
    outer_loop:
      for (var i2 = 0;i2 < bufs.length; i2++) {
        var buf = bufs[i2];
        for (var j22 = 0;j22 < buf.length; j22++) {
          b22.push(buf[j22]);
          if (b22.length === 2) {
            if (charsProcessed === 0) {
              if (b22[0] === 255 && b22[1] === 254)
                return "utf-16le";
              if (b22[0] === 254 && b22[1] === 255)
                return "utf-16be";
            }
            if (b22[0] === 0 && b22[1] !== 0)
              asciiCharsBE++;
            if (b22[0] !== 0 && b22[1] === 0)
              asciiCharsLE++;
            b22.length = 0;
            charsProcessed++;
            if (charsProcessed >= 100) {
              break outer_loop;
            }
          }
        }
      }
    if (asciiCharsBE > asciiCharsLE)
      return "utf-16be";
    if (asciiCharsBE < asciiCharsLE)
      return "utf-16le";
    return defaultEncoding || "utf-16le";
  }
});
var require_utf7 = __commonJS2((exports) => {
  var Buffer22 = require_safer().Buffer;
  exports.utf7 = Utf7Codec;
  exports.unicode11utf7 = "utf7";
  function Utf7Codec(codecOptions, iconv) {
    this.iconv = iconv;
  }
  Utf7Codec.prototype.encoder = Utf7Encoder;
  Utf7Codec.prototype.decoder = Utf7Decoder;
  Utf7Codec.prototype.bomAware = true;
  var nonDirectChars = /[^A-Za-z0-9'\(\),-\.\/:\? \n\r\t]+/g;
  function Utf7Encoder(options3, codec) {
    this.iconv = codec.iconv;
  }
  Utf7Encoder.prototype.write = function(str) {
    return Buffer22.from(str.replace(nonDirectChars, function(chunk) {
      return "+" + (chunk === "+" ? "" : this.iconv.encode(chunk, "utf16-be").toString("base64").replace(/=+$/, "")) + "-";
    }.bind(this)));
  };
  Utf7Encoder.prototype.end = function() {
  };
  function Utf7Decoder(options3, codec) {
    this.iconv = codec.iconv;
    this.inBase64 = false;
    this.base64Accum = "";
  }
  var base64Regex = /[A-Za-z0-9\/+]/;
  var base64Chars = [];
  for (i2 = 0;i2 < 256; i2++)
    base64Chars[i2] = base64Regex.test(String.fromCharCode(i2));
  var i2;
  var plusChar = "+".charCodeAt(0);
  var minusChar = "-".charCodeAt(0);
  var andChar = "&".charCodeAt(0);
  Utf7Decoder.prototype.write = function(buf) {
    var res = "", lastI = 0, inBase64 = this.inBase64, base64Accum = this.base64Accum;
    for (var i22 = 0;i22 < buf.length; i22++) {
      if (!inBase64) {
        if (buf[i22] == plusChar) {
          res += this.iconv.decode(buf.slice(lastI, i22), "ascii");
          lastI = i22 + 1;
          inBase64 = true;
        }
      } else {
        if (!base64Chars[buf[i22]]) {
          if (i22 == lastI && buf[i22] == minusChar) {
            res += "+";
          } else {
            var b64str = base64Accum + this.iconv.decode(buf.slice(lastI, i22), "ascii");
            res += this.iconv.decode(Buffer22.from(b64str, "base64"), "utf16-be");
          }
          if (buf[i22] != minusChar)
            i22--;
          lastI = i22 + 1;
          inBase64 = false;
          base64Accum = "";
        }
      }
    }
    if (!inBase64) {
      res += this.iconv.decode(buf.slice(lastI), "ascii");
    } else {
      var b64str = base64Accum + this.iconv.decode(buf.slice(lastI), "ascii");
      var canBeDecoded = b64str.length - b64str.length % 8;
      base64Accum = b64str.slice(canBeDecoded);
      b64str = b64str.slice(0, canBeDecoded);
      res += this.iconv.decode(Buffer22.from(b64str, "base64"), "utf16-be");
    }
    this.inBase64 = inBase64;
    this.base64Accum = base64Accum;
    return res;
  };
  Utf7Decoder.prototype.end = function() {
    var res = "";
    if (this.inBase64 && this.base64Accum.length > 0)
      res = this.iconv.decode(Buffer22.from(this.base64Accum, "base64"), "utf16-be");
    this.inBase64 = false;
    this.base64Accum = "";
    return res;
  };
  exports.utf7imap = Utf7IMAPCodec;
  function Utf7IMAPCodec(codecOptions, iconv) {
    this.iconv = iconv;
  }
  Utf7IMAPCodec.prototype.encoder = Utf7IMAPEncoder;
  Utf7IMAPCodec.prototype.decoder = Utf7IMAPDecoder;
  Utf7IMAPCodec.prototype.bomAware = true;
  function Utf7IMAPEncoder(options3, codec) {
    this.iconv = codec.iconv;
    this.inBase64 = false;
    this.base64Accum = Buffer22.alloc(6);
    this.base64AccumIdx = 0;
  }
  Utf7IMAPEncoder.prototype.write = function(str) {
    var inBase64 = this.inBase64, base64Accum = this.base64Accum, base64AccumIdx = this.base64AccumIdx, buf = Buffer22.alloc(str.length * 5 + 10), bufIdx = 0;
    for (var i22 = 0;i22 < str.length; i22++) {
      var uChar = str.charCodeAt(i22);
      if (32 <= uChar && uChar <= 126) {
        if (inBase64) {
          if (base64AccumIdx > 0) {
            bufIdx += buf.write(base64Accum.slice(0, base64AccumIdx).toString("base64").replace(/\//g, ",").replace(/=+$/, ""), bufIdx);
            base64AccumIdx = 0;
          }
          buf[bufIdx++] = minusChar;
          inBase64 = false;
        }
        if (!inBase64) {
          buf[bufIdx++] = uChar;
          if (uChar === andChar)
            buf[bufIdx++] = minusChar;
        }
      } else {
        if (!inBase64) {
          buf[bufIdx++] = andChar;
          inBase64 = true;
        }
        if (inBase64) {
          base64Accum[base64AccumIdx++] = uChar >> 8;
          base64Accum[base64AccumIdx++] = uChar & 255;
          if (base64AccumIdx == base64Accum.length) {
            bufIdx += buf.write(base64Accum.toString("base64").replace(/\//g, ","), bufIdx);
            base64AccumIdx = 0;
          }
        }
      }
    }
    this.inBase64 = inBase64;
    this.base64AccumIdx = base64AccumIdx;
    return buf.slice(0, bufIdx);
  };
  Utf7IMAPEncoder.prototype.end = function() {
    var buf = Buffer22.alloc(10), bufIdx = 0;
    if (this.inBase64) {
      if (this.base64AccumIdx > 0) {
        bufIdx += buf.write(this.base64Accum.slice(0, this.base64AccumIdx).toString("base64").replace(/\//g, ",").replace(/=+$/, ""), bufIdx);
        this.base64AccumIdx = 0;
      }
      buf[bufIdx++] = minusChar;
      this.inBase64 = false;
    }
    return buf.slice(0, bufIdx);
  };
  function Utf7IMAPDecoder(options3, codec) {
    this.iconv = codec.iconv;
    this.inBase64 = false;
    this.base64Accum = "";
  }
  var base64IMAPChars = base64Chars.slice();
  base64IMAPChars[",".charCodeAt(0)] = true;
  Utf7IMAPDecoder.prototype.write = function(buf) {
    var res = "", lastI = 0, inBase64 = this.inBase64, base64Accum = this.base64Accum;
    for (var i22 = 0;i22 < buf.length; i22++) {
      if (!inBase64) {
        if (buf[i22] == andChar) {
          res += this.iconv.decode(buf.slice(lastI, i22), "ascii");
          lastI = i22 + 1;
          inBase64 = true;
        }
      } else {
        if (!base64IMAPChars[buf[i22]]) {
          if (i22 == lastI && buf[i22] == minusChar) {
            res += "&";
          } else {
            var b64str = base64Accum + this.iconv.decode(buf.slice(lastI, i22), "ascii").replace(/,/g, "/");
            res += this.iconv.decode(Buffer22.from(b64str, "base64"), "utf16-be");
          }
          if (buf[i22] != minusChar)
            i22--;
          lastI = i22 + 1;
          inBase64 = false;
          base64Accum = "";
        }
      }
    }
    if (!inBase64) {
      res += this.iconv.decode(buf.slice(lastI), "ascii");
    } else {
      var b64str = base64Accum + this.iconv.decode(buf.slice(lastI), "ascii").replace(/,/g, "/");
      var canBeDecoded = b64str.length - b64str.length % 8;
      base64Accum = b64str.slice(canBeDecoded);
      b64str = b64str.slice(0, canBeDecoded);
      res += this.iconv.decode(Buffer22.from(b64str, "base64"), "utf16-be");
    }
    this.inBase64 = inBase64;
    this.base64Accum = base64Accum;
    return res;
  };
  Utf7IMAPDecoder.prototype.end = function() {
    var res = "";
    if (this.inBase64 && this.base64Accum.length > 0)
      res = this.iconv.decode(Buffer22.from(this.base64Accum, "base64"), "utf16-be");
    this.inBase64 = false;
    this.base64Accum = "";
    return res;
  };
});
var require_sbcs_codec = __commonJS2((exports) => {
  var Buffer22 = require_safer().Buffer;
  exports._sbcs = SBCSCodec;
  function SBCSCodec(codecOptions, iconv) {
    if (!codecOptions)
      throw new Error("SBCS codec is called without the data.");
    if (!codecOptions.chars || codecOptions.chars.length !== 128 && codecOptions.chars.length !== 256)
      throw new Error("Encoding '" + codecOptions.type + "' has incorrect 'chars' (must be of len 128 or 256)");
    if (codecOptions.chars.length === 128) {
      var asciiString = "";
      for (var i2 = 0;i2 < 128; i2++)
        asciiString += String.fromCharCode(i2);
      codecOptions.chars = asciiString + codecOptions.chars;
    }
    this.decodeBuf = Buffer22.from(codecOptions.chars, "ucs2");
    var encodeBuf = Buffer22.alloc(65536, iconv.defaultCharSingleByte.charCodeAt(0));
    for (var i2 = 0;i2 < codecOptions.chars.length; i2++)
      encodeBuf[codecOptions.chars.charCodeAt(i2)] = i2;
    this.encodeBuf = encodeBuf;
  }
  SBCSCodec.prototype.encoder = SBCSEncoder;
  SBCSCodec.prototype.decoder = SBCSDecoder;
  function SBCSEncoder(options3, codec) {
    this.encodeBuf = codec.encodeBuf;
  }
  SBCSEncoder.prototype.write = function(str) {
    var buf = Buffer22.alloc(str.length);
    for (var i2 = 0;i2 < str.length; i2++)
      buf[i2] = this.encodeBuf[str.charCodeAt(i2)];
    return buf;
  };
  SBCSEncoder.prototype.end = function() {
  };
  function SBCSDecoder(options3, codec) {
    this.decodeBuf = codec.decodeBuf;
  }
  SBCSDecoder.prototype.write = function(buf) {
    var decodeBuf = this.decodeBuf;
    var newBuf = Buffer22.alloc(buf.length * 2);
    var idx1 = 0, idx2 = 0;
    for (var i2 = 0;i2 < buf.length; i2++) {
      idx1 = buf[i2] * 2;
      idx2 = i2 * 2;
      newBuf[idx2] = decodeBuf[idx1];
      newBuf[idx2 + 1] = decodeBuf[idx1 + 1];
    }
    return newBuf.toString("ucs2");
  };
  SBCSDecoder.prototype.end = function() {
  };
});
var require_sbcs_data = __commonJS2((exports, module) => {
  module.exports = {
    "10029": "maccenteuro",
    maccenteuro: {
      type: "_sbcs",
      chars: "\xC4\u0100\u0101\xC9\u0104\xD6\xDC\xE1\u0105\u010C\xE4\u010D\u0106\u0107\xE9\u0179\u017A\u010E\xED\u010F\u0112\u0113\u0116\xF3\u0117\xF4\xF6\xF5\xFA\u011A\u011B\xFC\u2020\xB0\u0118\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\u0119\xA8\u2260\u0123\u012E\u012F\u012A\u2264\u2265\u012B\u0136\u2202\u2211\u0142\u013B\u013C\u013D\u013E\u0139\u013A\u0145\u0146\u0143\xAC\u221A\u0144\u0147\u2206\xAB\xBB\u2026\xA0\u0148\u0150\xD5\u0151\u014C\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\u014D\u0154\u0155\u0158\u2039\u203A\u0159\u0156\u0157\u0160\u201A\u201E\u0161\u015A\u015B\xC1\u0164\u0165\xCD\u017D\u017E\u016A\xD3\xD4\u016B\u016E\xDA\u016F\u0170\u0171\u0172\u0173\xDD\xFD\u0137\u017B\u0141\u017C\u0122\u02C7"
    },
    "808": "cp808",
    ibm808: "cp808",
    cp808: {
      type: "_sbcs",
      chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u0401\u0451\u0404\u0454\u0407\u0457\u040E\u045E\xB0\u2219\xB7\u221A\u2116\u20AC\u25A0\xA0"
    },
    mik: {
      type: "_sbcs",
      chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u2514\u2534\u252C\u251C\u2500\u253C\u2563\u2551\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2510\u2591\u2592\u2593\u2502\u2524\u2116\xA7\u2557\u255D\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    cp720: {
      type: "_sbcs",
      chars: "\x80\x81\xE9\xE2\x84\xE0\x86\xE7\xEA\xEB\xE8\xEF\xEE\x8D\x8E\x8F\x90\u0651\u0652\xF4\xA4\u0640\xFB\xF9\u0621\u0622\u0623\u0624\xA3\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u0636\u0637\u0638\u0639\u063A\u0641\xB5\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u2261\u064B\u064C\u064D\u064E\u064F\u0650\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ascii8bit: "ascii",
    usascii: "ascii",
    ansix34: "ascii",
    ansix341968: "ascii",
    ansix341986: "ascii",
    csascii: "ascii",
    cp367: "ascii",
    ibm367: "ascii",
    isoir6: "ascii",
    iso646us: "ascii",
    iso646irv: "ascii",
    us: "ascii",
    latin1: "iso88591",
    latin2: "iso88592",
    latin3: "iso88593",
    latin4: "iso88594",
    latin5: "iso88599",
    latin6: "iso885910",
    latin7: "iso885913",
    latin8: "iso885914",
    latin9: "iso885915",
    latin10: "iso885916",
    csisolatin1: "iso88591",
    csisolatin2: "iso88592",
    csisolatin3: "iso88593",
    csisolatin4: "iso88594",
    csisolatincyrillic: "iso88595",
    csisolatinarabic: "iso88596",
    csisolatingreek: "iso88597",
    csisolatinhebrew: "iso88598",
    csisolatin5: "iso88599",
    csisolatin6: "iso885910",
    l1: "iso88591",
    l2: "iso88592",
    l3: "iso88593",
    l4: "iso88594",
    l5: "iso88599",
    l6: "iso885910",
    l7: "iso885913",
    l8: "iso885914",
    l9: "iso885915",
    l10: "iso885916",
    isoir14: "iso646jp",
    isoir57: "iso646cn",
    isoir100: "iso88591",
    isoir101: "iso88592",
    isoir109: "iso88593",
    isoir110: "iso88594",
    isoir144: "iso88595",
    isoir127: "iso88596",
    isoir126: "iso88597",
    isoir138: "iso88598",
    isoir148: "iso88599",
    isoir157: "iso885910",
    isoir166: "tis620",
    isoir179: "iso885913",
    isoir199: "iso885914",
    isoir203: "iso885915",
    isoir226: "iso885916",
    cp819: "iso88591",
    ibm819: "iso88591",
    cyrillic: "iso88595",
    arabic: "iso88596",
    arabic8: "iso88596",
    ecma114: "iso88596",
    asmo708: "iso88596",
    greek: "iso88597",
    greek8: "iso88597",
    ecma118: "iso88597",
    elot928: "iso88597",
    hebrew: "iso88598",
    hebrew8: "iso88598",
    turkish: "iso88599",
    turkish8: "iso88599",
    thai: "iso885911",
    thai8: "iso885911",
    celtic: "iso885914",
    celtic8: "iso885914",
    isoceltic: "iso885914",
    tis6200: "tis620",
    tis62025291: "tis620",
    tis62025330: "tis620",
    "10000": "macroman",
    "10006": "macgreek",
    "10007": "maccyrillic",
    "10079": "maciceland",
    "10081": "macturkish",
    cspc8codepage437: "cp437",
    cspc775baltic: "cp775",
    cspc850multilingual: "cp850",
    cspcp852: "cp852",
    cspc862latinhebrew: "cp862",
    cpgr: "cp869",
    msee: "cp1250",
    mscyrl: "cp1251",
    msansi: "cp1252",
    msgreek: "cp1253",
    msturk: "cp1254",
    mshebr: "cp1255",
    msarab: "cp1256",
    winbaltrim: "cp1257",
    cp20866: "koi8r",
    "20866": "koi8r",
    ibm878: "koi8r",
    cskoi8r: "koi8r",
    cp21866: "koi8u",
    "21866": "koi8u",
    ibm1168: "koi8u",
    strk10482002: "rk1048",
    tcvn5712: "tcvn",
    tcvn57121: "tcvn",
    gb198880: "iso646cn",
    cn: "iso646cn",
    csiso14jisc6220ro: "iso646jp",
    jisc62201969ro: "iso646jp",
    jp: "iso646jp",
    cshproman8: "hproman8",
    r8: "hproman8",
    roman8: "hproman8",
    xroman8: "hproman8",
    ibm1051: "hproman8",
    mac: "macintosh",
    csmacintosh: "macintosh"
  };
});
var require_sbcs_data_generated = __commonJS2((exports, module) => {
  module.exports = {
    "437": "cp437",
    "737": "cp737",
    "775": "cp775",
    "850": "cp850",
    "852": "cp852",
    "855": "cp855",
    "856": "cp856",
    "857": "cp857",
    "858": "cp858",
    "860": "cp860",
    "861": "cp861",
    "862": "cp862",
    "863": "cp863",
    "864": "cp864",
    "865": "cp865",
    "866": "cp866",
    "869": "cp869",
    "874": "windows874",
    "922": "cp922",
    "1046": "cp1046",
    "1124": "cp1124",
    "1125": "cp1125",
    "1129": "cp1129",
    "1133": "cp1133",
    "1161": "cp1161",
    "1162": "cp1162",
    "1163": "cp1163",
    "1250": "windows1250",
    "1251": "windows1251",
    "1252": "windows1252",
    "1253": "windows1253",
    "1254": "windows1254",
    "1255": "windows1255",
    "1256": "windows1256",
    "1257": "windows1257",
    "1258": "windows1258",
    "28591": "iso88591",
    "28592": "iso88592",
    "28593": "iso88593",
    "28594": "iso88594",
    "28595": "iso88595",
    "28596": "iso88596",
    "28597": "iso88597",
    "28598": "iso88598",
    "28599": "iso88599",
    "28600": "iso885910",
    "28601": "iso885911",
    "28603": "iso885913",
    "28604": "iso885914",
    "28605": "iso885915",
    "28606": "iso885916",
    windows874: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\uFFFD\uFFFD\uFFFD\u2026\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
    },
    win874: "windows874",
    cp874: "windows874",
    windows1250: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\u201A\uFFFD\u201E\u2026\u2020\u2021\uFFFD\u2030\u0160\u2039\u015A\u0164\u017D\u0179\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0161\u203A\u015B\u0165\u017E\u017A\xA0\u02C7\u02D8\u0141\xA4\u0104\xA6\xA7\xA8\xA9\u015E\xAB\xAC\xAD\xAE\u017B\xB0\xB1\u02DB\u0142\xB4\xB5\xB6\xB7\xB8\u0105\u015F\xBB\u013D\u02DD\u013E\u017C\u0154\xC1\xC2\u0102\xC4\u0139\u0106\xC7\u010C\xC9\u0118\xCB\u011A\xCD\xCE\u010E\u0110\u0143\u0147\xD3\xD4\u0150\xD6\xD7\u0158\u016E\xDA\u0170\xDC\xDD\u0162\xDF\u0155\xE1\xE2\u0103\xE4\u013A\u0107\xE7\u010D\xE9\u0119\xEB\u011B\xED\xEE\u010F\u0111\u0144\u0148\xF3\xF4\u0151\xF6\xF7\u0159\u016F\xFA\u0171\xFC\xFD\u0163\u02D9"
    },
    win1250: "windows1250",
    cp1250: "windows1250",
    windows1251: {
      type: "_sbcs",
      chars: "\u0402\u0403\u201A\u0453\u201E\u2026\u2020\u2021\u20AC\u2030\u0409\u2039\u040A\u040C\u040B\u040F\u0452\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0459\u203A\u045A\u045C\u045B\u045F\xA0\u040E\u045E\u0408\xA4\u0490\xA6\xA7\u0401\xA9\u0404\xAB\xAC\xAD\xAE\u0407\xB0\xB1\u0406\u0456\u0491\xB5\xB6\xB7\u0451\u2116\u0454\xBB\u0458\u0405\u0455\u0457\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F"
    },
    win1251: "windows1251",
    cp1251: "windows1251",
    windows1252: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\uFFFD\u017D\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\uFFFD\u017E\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
    },
    win1252: "windows1252",
    cp1252: "windows1252",
    windows1253: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\uFFFD\u2030\uFFFD\u2039\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\uFFFD\u203A\uFFFD\uFFFD\uFFFD\uFFFD\xA0\u0385\u0386\xA3\xA4\xA5\xA6\xA7\xA8\xA9\uFFFD\xAB\xAC\xAD\xAE\u2015\xB0\xB1\xB2\xB3\u0384\xB5\xB6\xB7\u0388\u0389\u038A\xBB\u038C\xBD\u038E\u038F\u0390\u0391\u0392\u0393\u0394\u0395\u0396\u0397\u0398\u0399\u039A\u039B\u039C\u039D\u039E\u039F\u03A0\u03A1\uFFFD\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03AA\u03AB\u03AC\u03AD\u03AE\u03AF\u03B0\u03B1\u03B2\u03B3\u03B4\u03B5\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C2\u03C3\u03C4\u03C5\u03C6\u03C7\u03C8\u03C9\u03CA\u03CB\u03CC\u03CD\u03CE\uFFFD"
    },
    win1253: "windows1253",
    cp1253: "windows1253",
    windows1254: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\uFFFD\uFFFD\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u011E\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u0130\u015E\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u011F\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u0131\u015F\xFF"
    },
    win1254: "windows1254",
    cp1254: "windows1254",
    windows1255: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\uFFFD\u2039\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\uFFFD\u203A\uFFFD\uFFFD\uFFFD\uFFFD\xA0\xA1\xA2\xA3\u20AA\xA5\xA6\xA7\xA8\xA9\xD7\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xF7\xBB\xBC\xBD\xBE\xBF\u05B0\u05B1\u05B2\u05B3\u05B4\u05B5\u05B6\u05B7\u05B8\u05B9\u05BA\u05BB\u05BC\u05BD\u05BE\u05BF\u05C0\u05C1\u05C2\u05C3\u05F0\u05F1\u05F2\u05F3\u05F4\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\uFFFD\uFFFD\u200E\u200F\uFFFD"
    },
    win1255: "windows1255",
    cp1255: "windows1255",
    windows1256: {
      type: "_sbcs",
      chars: "\u20AC\u067E\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0679\u2039\u0152\u0686\u0698\u0688\u06AF\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u06A9\u2122\u0691\u203A\u0153\u200C\u200D\u06BA\xA0\u060C\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\u06BE\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\u061B\xBB\xBC\xBD\xBE\u061F\u06C1\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\xD7\u0637\u0638\u0639\u063A\u0640\u0641\u0642\u0643\xE0\u0644\xE2\u0645\u0646\u0647\u0648\xE7\xE8\xE9\xEA\xEB\u0649\u064A\xEE\xEF\u064B\u064C\u064D\u064E\xF4\u064F\u0650\xF7\u0651\xF9\u0652\xFB\xFC\u200E\u200F\u06D2"
    },
    win1256: "windows1256",
    cp1256: "windows1256",
    windows1257: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\u201A\uFFFD\u201E\u2026\u2020\u2021\uFFFD\u2030\uFFFD\u2039\uFFFD\xA8\u02C7\xB8\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\uFFFD\u203A\uFFFD\xAF\u02DB\uFFFD\xA0\uFFFD\xA2\xA3\xA4\uFFFD\xA6\xA7\xD8\xA9\u0156\xAB\xAC\xAD\xAE\xC6\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xF8\xB9\u0157\xBB\xBC\xBD\xBE\xE6\u0104\u012E\u0100\u0106\xC4\xC5\u0118\u0112\u010C\xC9\u0179\u0116\u0122\u0136\u012A\u013B\u0160\u0143\u0145\xD3\u014C\xD5\xD6\xD7\u0172\u0141\u015A\u016A\xDC\u017B\u017D\xDF\u0105\u012F\u0101\u0107\xE4\xE5\u0119\u0113\u010D\xE9\u017A\u0117\u0123\u0137\u012B\u013C\u0161\u0144\u0146\xF3\u014D\xF5\xF6\xF7\u0173\u0142\u015B\u016B\xFC\u017C\u017E\u02D9"
    },
    win1257: "windows1257",
    cp1257: "windows1257",
    windows1258: {
      type: "_sbcs",
      chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\uFFFD\u2039\u0152\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\uFFFD\u203A\u0153\uFFFD\uFFFD\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\u0102\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\u0300\xCD\xCE\xCF\u0110\xD1\u0309\xD3\xD4\u01A0\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u01AF\u0303\xDF\xE0\xE1\xE2\u0103\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\u0301\xED\xEE\xEF\u0111\xF1\u0323\xF3\xF4\u01A1\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u01B0\u20AB\xFF"
    },
    win1258: "windows1258",
    cp1258: "windows1258",
    iso88591: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
    },
    cp28591: "iso88591",
    iso88592: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u02D8\u0141\xA4\u013D\u015A\xA7\xA8\u0160\u015E\u0164\u0179\xAD\u017D\u017B\xB0\u0105\u02DB\u0142\xB4\u013E\u015B\u02C7\xB8\u0161\u015F\u0165\u017A\u02DD\u017E\u017C\u0154\xC1\xC2\u0102\xC4\u0139\u0106\xC7\u010C\xC9\u0118\xCB\u011A\xCD\xCE\u010E\u0110\u0143\u0147\xD3\xD4\u0150\xD6\xD7\u0158\u016E\xDA\u0170\xDC\xDD\u0162\xDF\u0155\xE1\xE2\u0103\xE4\u013A\u0107\xE7\u010D\xE9\u0119\xEB\u011B\xED\xEE\u010F\u0111\u0144\u0148\xF3\xF4\u0151\xF6\xF7\u0159\u016F\xFA\u0171\xFC\xFD\u0163\u02D9"
    },
    cp28592: "iso88592",
    iso88593: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0126\u02D8\xA3\xA4\uFFFD\u0124\xA7\xA8\u0130\u015E\u011E\u0134\xAD\uFFFD\u017B\xB0\u0127\xB2\xB3\xB4\xB5\u0125\xB7\xB8\u0131\u015F\u011F\u0135\xBD\uFFFD\u017C\xC0\xC1\xC2\uFFFD\xC4\u010A\u0108\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\uFFFD\xD1\xD2\xD3\xD4\u0120\xD6\xD7\u011C\xD9\xDA\xDB\xDC\u016C\u015C\xDF\xE0\xE1\xE2\uFFFD\xE4\u010B\u0109\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\uFFFD\xF1\xF2\xF3\xF4\u0121\xF6\xF7\u011D\xF9\xFA\xFB\xFC\u016D\u015D\u02D9"
    },
    cp28593: "iso88593",
    iso88594: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u0138\u0156\xA4\u0128\u013B\xA7\xA8\u0160\u0112\u0122\u0166\xAD\u017D\xAF\xB0\u0105\u02DB\u0157\xB4\u0129\u013C\u02C7\xB8\u0161\u0113\u0123\u0167\u014A\u017E\u014B\u0100\xC1\xC2\xC3\xC4\xC5\xC6\u012E\u010C\xC9\u0118\xCB\u0116\xCD\xCE\u012A\u0110\u0145\u014C\u0136\xD4\xD5\xD6\xD7\xD8\u0172\xDA\xDB\xDC\u0168\u016A\xDF\u0101\xE1\xE2\xE3\xE4\xE5\xE6\u012F\u010D\xE9\u0119\xEB\u0117\xED\xEE\u012B\u0111\u0146\u014D\u0137\xF4\xF5\xF6\xF7\xF8\u0173\xFA\xFB\xFC\u0169\u016B\u02D9"
    },
    cp28594: "iso88594",
    iso88595: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0401\u0402\u0403\u0404\u0405\u0406\u0407\u0408\u0409\u040A\u040B\u040C\xAD\u040E\u040F\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u2116\u0451\u0452\u0453\u0454\u0455\u0456\u0457\u0458\u0459\u045A\u045B\u045C\xA7\u045E\u045F"
    },
    cp28595: "iso88595",
    iso88596: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\uFFFD\uFFFD\uFFFD\xA4\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u060C\xAD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u061B\uFFFD\uFFFD\uFFFD\u061F\uFFFD\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0640\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"
    },
    cp28596: "iso88596",
    iso88597: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u2018\u2019\xA3\u20AC\u20AF\xA6\xA7\xA8\xA9\u037A\xAB\xAC\xAD\uFFFD\u2015\xB0\xB1\xB2\xB3\u0384\u0385\u0386\xB7\u0388\u0389\u038A\xBB\u038C\xBD\u038E\u038F\u0390\u0391\u0392\u0393\u0394\u0395\u0396\u0397\u0398\u0399\u039A\u039B\u039C\u039D\u039E\u039F\u03A0\u03A1\uFFFD\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03AA\u03AB\u03AC\u03AD\u03AE\u03AF\u03B0\u03B1\u03B2\u03B3\u03B4\u03B5\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C2\u03C3\u03C4\u03C5\u03C6\u03C7\u03C8\u03C9\u03CA\u03CB\u03CC\u03CD\u03CE\uFFFD"
    },
    cp28597: "iso88597",
    iso88598: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\uFFFD\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xD7\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xF7\xBB\xBC\xBD\xBE\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2017\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\uFFFD\uFFFD\u200E\u200F\uFFFD"
    },
    cp28598: "iso88598",
    iso88599: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u011E\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u0130\u015E\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u011F\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u0131\u015F\xFF"
    },
    cp28599: "iso88599",
    iso885910: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u0112\u0122\u012A\u0128\u0136\xA7\u013B\u0110\u0160\u0166\u017D\xAD\u016A\u014A\xB0\u0105\u0113\u0123\u012B\u0129\u0137\xB7\u013C\u0111\u0161\u0167\u017E\u2015\u016B\u014B\u0100\xC1\xC2\xC3\xC4\xC5\xC6\u012E\u010C\xC9\u0118\xCB\u0116\xCD\xCE\xCF\xD0\u0145\u014C\xD3\xD4\xD5\xD6\u0168\xD8\u0172\xDA\xDB\xDC\xDD\xDE\xDF\u0101\xE1\xE2\xE3\xE4\xE5\xE6\u012F\u010D\xE9\u0119\xEB\u0117\xED\xEE\xEF\xF0\u0146\u014D\xF3\xF4\xF5\xF6\u0169\xF8\u0173\xFA\xFB\xFC\xFD\xFE\u0138"
    },
    cp28600: "iso885910",
    iso885911: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
    },
    cp28601: "iso885911",
    iso885913: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u201D\xA2\xA3\xA4\u201E\xA6\xA7\xD8\xA9\u0156\xAB\xAC\xAD\xAE\xC6\xB0\xB1\xB2\xB3\u201C\xB5\xB6\xB7\xF8\xB9\u0157\xBB\xBC\xBD\xBE\xE6\u0104\u012E\u0100\u0106\xC4\xC5\u0118\u0112\u010C\xC9\u0179\u0116\u0122\u0136\u012A\u013B\u0160\u0143\u0145\xD3\u014C\xD5\xD6\xD7\u0172\u0141\u015A\u016A\xDC\u017B\u017D\xDF\u0105\u012F\u0101\u0107\xE4\xE5\u0119\u0113\u010D\xE9\u017A\u0117\u0123\u0137\u012B\u013C\u0161\u0144\u0146\xF3\u014D\xF5\xF6\xF7\u0173\u0142\u015B\u016B\xFC\u017C\u017E\u2019"
    },
    cp28603: "iso885913",
    iso885914: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u1E02\u1E03\xA3\u010A\u010B\u1E0A\xA7\u1E80\xA9\u1E82\u1E0B\u1EF2\xAD\xAE\u0178\u1E1E\u1E1F\u0120\u0121\u1E40\u1E41\xB6\u1E56\u1E81\u1E57\u1E83\u1E60\u1EF3\u1E84\u1E85\u1E61\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u0174\xD1\xD2\xD3\xD4\xD5\xD6\u1E6A\xD8\xD9\xDA\xDB\xDC\xDD\u0176\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u0175\xF1\xF2\xF3\xF4\xF5\xF6\u1E6B\xF8\xF9\xFA\xFB\xFC\xFD\u0177\xFF"
    },
    cp28604: "iso885914",
    iso885915: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\u20AC\xA5\u0160\xA7\u0161\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\u017D\xB5\xB6\xB7\u017E\xB9\xBA\xBB\u0152\u0153\u0178\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
    },
    cp28605: "iso885915",
    iso885916: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u0105\u0141\u20AC\u201E\u0160\xA7\u0161\xA9\u0218\xAB\u0179\xAD\u017A\u017B\xB0\xB1\u010C\u0142\u017D\u201D\xB6\xB7\u017E\u010D\u0219\xBB\u0152\u0153\u0178\u017C\xC0\xC1\xC2\u0102\xC4\u0106\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u0110\u0143\xD2\xD3\xD4\u0150\xD6\u015A\u0170\xD9\xDA\xDB\xDC\u0118\u021A\xDF\xE0\xE1\xE2\u0103\xE4\u0107\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u0111\u0144\xF2\xF3\xF4\u0151\xF6\u015B\u0171\xF9\xFA\xFB\xFC\u0119\u021B\xFF"
    },
    cp28606: "iso885916",
    cp437: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xA2\xA3\xA5\u20A7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ibm437: "cp437",
    csibm437: "cp437",
    cp737: {
      type: "_sbcs",
      chars: "\u0391\u0392\u0393\u0394\u0395\u0396\u0397\u0398\u0399\u039A\u039B\u039C\u039D\u039E\u039F\u03A0\u03A1\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03B1\u03B2\u03B3\u03B4\u03B5\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C3\u03C2\u03C4\u03C5\u03C6\u03C7\u03C8\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03C9\u03AC\u03AD\u03AE\u03CA\u03AF\u03CC\u03CD\u03CB\u03CE\u0386\u0388\u0389\u038A\u038C\u038E\u038F\xB1\u2265\u2264\u03AA\u03AB\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ibm737: "cp737",
    csibm737: "cp737",
    cp775: {
      type: "_sbcs",
      chars: "\u0106\xFC\xE9\u0101\xE4\u0123\xE5\u0107\u0142\u0113\u0156\u0157\u012B\u0179\xC4\xC5\xC9\xE6\xC6\u014D\xF6\u0122\xA2\u015A\u015B\xD6\xDC\xF8\xA3\xD8\xD7\xA4\u0100\u012A\xF3\u017B\u017C\u017A\u201D\xA6\xA9\xAE\xAC\xBD\xBC\u0141\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u0104\u010C\u0118\u0116\u2563\u2551\u2557\u255D\u012E\u0160\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u0172\u016A\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u017D\u0105\u010D\u0119\u0117\u012F\u0161\u0173\u016B\u017E\u2518\u250C\u2588\u2584\u258C\u2590\u2580\xD3\xDF\u014C\u0143\xF5\xD5\xB5\u0144\u0136\u0137\u013B\u013C\u0146\u0112\u0145\u2019\xAD\xB1\u201C\xBE\xB6\xA7\xF7\u201E\xB0\u2219\xB7\xB9\xB3\xB2\u25A0\xA0"
    },
    ibm775: "cp775",
    csibm775: "cp775",
    cp850: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xF8\xA3\xD8\xD7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\xAE\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\xC0\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\xE3\xC3\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\xF0\xD0\xCA\xCB\xC8\u0131\xCD\xCE\xCF\u2518\u250C\u2588\u2584\xA6\xCC\u2580\xD3\xDF\xD4\xD2\xF5\xD5\xB5\xFE\xDE\xDA\xDB\xD9\xFD\xDD\xAF\xB4\xAD\xB1\u2017\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
    },
    ibm850: "cp850",
    csibm850: "cp850",
    cp852: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE4\u016F\u0107\xE7\u0142\xEB\u0150\u0151\xEE\u0179\xC4\u0106\xC9\u0139\u013A\xF4\xF6\u013D\u013E\u015A\u015B\xD6\xDC\u0164\u0165\u0141\xD7\u010D\xE1\xED\xF3\xFA\u0104\u0105\u017D\u017E\u0118\u0119\xAC\u017A\u010C\u015F\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\u011A\u015E\u2563\u2551\u2557\u255D\u017B\u017C\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u0102\u0103\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\u0111\u0110\u010E\xCB\u010F\u0147\xCD\xCE\u011B\u2518\u250C\u2588\u2584\u0162\u016E\u2580\xD3\xDF\xD4\u0143\u0144\u0148\u0160\u0161\u0154\xDA\u0155\u0170\xFD\xDD\u0163\xB4\xAD\u02DD\u02DB\u02C7\u02D8\xA7\xF7\xB8\xB0\xA8\u02D9\u0171\u0158\u0159\u25A0\xA0"
    },
    ibm852: "cp852",
    csibm852: "cp852",
    cp855: {
      type: "_sbcs",
      chars: "\u0452\u0402\u0453\u0403\u0451\u0401\u0454\u0404\u0455\u0405\u0456\u0406\u0457\u0407\u0458\u0408\u0459\u0409\u045A\u040A\u045B\u040B\u045C\u040C\u045E\u040E\u045F\u040F\u044E\u042E\u044A\u042A\u0430\u0410\u0431\u0411\u0446\u0426\u0434\u0414\u0435\u0415\u0444\u0424\u0433\u0413\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u0445\u0425\u0438\u0418\u2563\u2551\u2557\u255D\u0439\u0419\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u043A\u041A\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\u043B\u041B\u043C\u041C\u043D\u041D\u043E\u041E\u043F\u2518\u250C\u2588\u2584\u041F\u044F\u2580\u042F\u0440\u0420\u0441\u0421\u0442\u0422\u0443\u0423\u0436\u0416\u0432\u0412\u044C\u042C\u2116\xAD\u044B\u042B\u0437\u0417\u0448\u0428\u044D\u042D\u0449\u0429\u0447\u0427\xA7\u25A0\xA0"
    },
    ibm855: "cp855",
    csibm855: "cp855",
    cp856: {
      type: "_sbcs",
      chars: "\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\uFFFD\xA3\uFFFD\xD7\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xAE\xAC\xBD\xBC\uFFFD\xAB\xBB\u2591\u2592\u2593\u2502\u2524\uFFFD\uFFFD\uFFFD\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\uFFFD\uFFFD\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2518\u250C\u2588\u2584\xA6\uFFFD\u2580\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xB5\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xAF\xB4\xAD\xB1\u2017\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
    },
    ibm856: "cp856",
    csibm856: "cp856",
    cp857: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\u0131\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\u0130\xD6\xDC\xF8\xA3\xD8\u015E\u015F\xE1\xED\xF3\xFA\xF1\xD1\u011E\u011F\xBF\xAE\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\xC0\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\xE3\xC3\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\xBA\xAA\xCA\xCB\xC8\uFFFD\xCD\xCE\xCF\u2518\u250C\u2588\u2584\xA6\xCC\u2580\xD3\xDF\xD4\xD2\xF5\xD5\xB5\uFFFD\xD7\xDA\xDB\xD9\xEC\xFF\xAF\xB4\xAD\xB1\uFFFD\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
    },
    ibm857: "cp857",
    csibm857: "cp857",
    cp858: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xF8\xA3\xD8\xD7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\xAE\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\xC0\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\xE3\xC3\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\xF0\xD0\xCA\xCB\xC8\u20AC\xCD\xCE\xCF\u2518\u250C\u2588\u2584\xA6\xCC\u2580\xD3\xDF\xD4\xD2\xF5\xD5\xB5\xFE\xDE\xDA\xDB\xD9\xFD\xDD\xAF\xB4\xAD\xB1\u2017\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
    },
    ibm858: "cp858",
    csibm858: "cp858",
    cp860: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE3\xE0\xC1\xE7\xEA\xCA\xE8\xCD\xD4\xEC\xC3\xC2\xC9\xC0\xC8\xF4\xF5\xF2\xDA\xF9\xCC\xD5\xDC\xA2\xA3\xD9\u20A7\xD3\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\xD2\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ibm860: "cp860",
    csibm860: "cp860",
    cp861: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xD0\xF0\xDE\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xFE\xFB\xDD\xFD\xD6\xDC\xF8\xA3\xD8\u20A7\u0192\xE1\xED\xF3\xFA\xC1\xCD\xD3\xDA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ibm861: "cp861",
    csibm861: "cp861",
    cp862: {
      type: "_sbcs",
      chars: "\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\xA2\xA3\xA5\u20A7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ibm862: "cp862",
    csibm862: "cp862",
    cp863: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xC2\xE0\xB6\xE7\xEA\xEB\xE8\xEF\xEE\u2017\xC0\xA7\xC9\xC8\xCA\xF4\xCB\xCF\xFB\xF9\xA4\xD4\xDC\xA2\xA3\xD9\xDB\u0192\xA6\xB4\xF3\xFA\xA8\xB8\xB3\xAF\xCE\u2310\xAC\xBD\xBC\xBE\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ibm863: "cp863",
    csibm863: "cp863",
    cp864: {
      type: "_sbcs",
      chars: `\0\x01\x02\x03\x04\x05\x06\x07	
\r\x0E\x0F\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F !"#$\u066A&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}~\x7F\xB0\xB7\u2219\u221A\u2592\u2500\u2502\u253C\u2524\u252C\u251C\u2534\u2510\u250C\u2514\u2518\u03B2\u221E\u03C6\xB1\xBD\xBC\u2248\xAB\xBB\uFEF7\uFEF8\uFFFD\uFFFD\uFEFB\uFEFC\uFFFD\xA0\xAD\uFE82\xA3\xA4\uFE84\uFFFD\uFFFD\uFE8E\uFE8F\uFE95\uFE99\u060C\uFE9D\uFEA1\uFEA5\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u0669\uFED1\u061B\uFEB1\uFEB5\uFEB9\u061F\xA2\uFE80\uFE81\uFE83\uFE85\uFECA\uFE8B\uFE8D\uFE91\uFE93\uFE97\uFE9B\uFE9F\uFEA3\uFEA7\uFEA9\uFEAB\uFEAD\uFEAF\uFEB3\uFEB7\uFEBB\uFEBF\uFEC1\uFEC5\uFECB\uFECF\xA6\xAC\xF7\xD7\uFEC9\u0640\uFED3\uFED7\uFEDB\uFEDF\uFEE3\uFEE7\uFEEB\uFEED\uFEEF\uFEF3\uFEBD\uFECC\uFECE\uFECD\uFEE1\uFE7D\u0651\uFEE5\uFEE9\uFEEC\uFEF0\uFEF2\uFED0\uFED5\uFEF5\uFEF6\uFEDD\uFED9\uFEF1\u25A0\uFFFD`
    },
    ibm864: "cp864",
    csibm864: "cp864",
    cp865: {
      type: "_sbcs",
      chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xF8\xA3\xD8\u20A7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xA4\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
    },
    ibm865: "cp865",
    csibm865: "cp865",
    cp866: {
      type: "_sbcs",
      chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u0401\u0451\u0404\u0454\u0407\u0457\u040E\u045E\xB0\u2219\xB7\u221A\u2116\xA4\u25A0\xA0"
    },
    ibm866: "cp866",
    csibm866: "cp866",
    cp869: {
      type: "_sbcs",
      chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0386\uFFFD\xB7\xAC\xA6\u2018\u2019\u0388\u2015\u0389\u038A\u03AA\u038C\uFFFD\uFFFD\u038E\u03AB\xA9\u038F\xB2\xB3\u03AC\xA3\u03AD\u03AE\u03AF\u03CA\u0390\u03CC\u03CD\u0391\u0392\u0393\u0394\u0395\u0396\u0397\xBD\u0398\u0399\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u039A\u039B\u039C\u039D\u2563\u2551\u2557\u255D\u039E\u039F\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u03A0\u03A1\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03B1\u03B2\u03B3\u2518\u250C\u2588\u2584\u03B4\u03B5\u2580\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C3\u03C2\u03C4\u0384\xAD\xB1\u03C5\u03C6\u03C7\xA7\u03C8\u0385\xB0\xA8\u03C9\u03CB\u03B0\u03CE\u25A0\xA0"
    },
    ibm869: "cp869",
    csibm869: "cp869",
    cp922: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\u203E\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u0160\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\u017D\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u0161\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\u017E\xFF"
    },
    ibm922: "cp922",
    csibm922: "cp922",
    cp1046: {
      type: "_sbcs",
      chars: "\uFE88\xD7\xF7\uF8F6\uF8F5\uF8F4\uF8F7\uFE71\x88\u25A0\u2502\u2500\u2510\u250C\u2514\u2518\uFE79\uFE7B\uFE7D\uFE7F\uFE77\uFE8A\uFEF0\uFEF3\uFEF2\uFECE\uFECF\uFED0\uFEF6\uFEF8\uFEFA\uFEFC\xA0\uF8FA\uF8F9\uF8F8\xA4\uF8FB\uFE8B\uFE91\uFE97\uFE9B\uFE9F\uFEA3\u060C\xAD\uFEA7\uFEB3\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u0669\uFEB7\u061B\uFEBB\uFEBF\uFECA\u061F\uFECB\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\uFEC7\u0639\u063A\uFECC\uFE82\uFE84\uFE8E\uFED3\u0640\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\uFED7\uFEDB\uFEDF\uF8FC\uFEF5\uFEF7\uFEF9\uFEFB\uFEE3\uFEE7\uFEEC\uFEE9\uFFFD"
    },
    ibm1046: "cp1046",
    csibm1046: "cp1046",
    cp1124: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0401\u0402\u0490\u0404\u0405\u0406\u0407\u0408\u0409\u040A\u040B\u040C\xAD\u040E\u040F\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u2116\u0451\u0452\u0491\u0454\u0455\u0456\u0457\u0458\u0459\u045A\u045B\u045C\xA7\u045E\u045F"
    },
    ibm1124: "cp1124",
    csibm1124: "cp1124",
    cp1125: {
      type: "_sbcs",
      chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u0401\u0451\u0490\u0491\u0404\u0454\u0406\u0456\u0407\u0457\xB7\u221A\u2116\xA4\u25A0\xA0"
    },
    ibm1125: "cp1125",
    csibm1125: "cp1125",
    cp1129: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\u0153\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\u0178\xB5\xB6\xB7\u0152\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\u0102\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\u0300\xCD\xCE\xCF\u0110\xD1\u0309\xD3\xD4\u01A0\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u01AF\u0303\xDF\xE0\xE1\xE2\u0103\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\u0301\xED\xEE\xEF\u0111\xF1\u0323\xF3\xF4\u01A1\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u01B0\u20AB\xFF"
    },
    ibm1129: "cp1129",
    csibm1129: "cp1129",
    cp1133: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0E81\u0E82\u0E84\u0E87\u0E88\u0EAA\u0E8A\u0E8D\u0E94\u0E95\u0E96\u0E97\u0E99\u0E9A\u0E9B\u0E9C\u0E9D\u0E9E\u0E9F\u0EA1\u0EA2\u0EA3\u0EA5\u0EA7\u0EAB\u0EAD\u0EAE\uFFFD\uFFFD\uFFFD\u0EAF\u0EB0\u0EB2\u0EB3\u0EB4\u0EB5\u0EB6\u0EB7\u0EB8\u0EB9\u0EBC\u0EB1\u0EBB\u0EBD\uFFFD\uFFFD\uFFFD\u0EC0\u0EC1\u0EC2\u0EC3\u0EC4\u0EC8\u0EC9\u0ECA\u0ECB\u0ECC\u0ECD\u0EC6\uFFFD\u0EDC\u0EDD\u20AD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0ED0\u0ED1\u0ED2\u0ED3\u0ED4\u0ED5\u0ED6\u0ED7\u0ED8\u0ED9\uFFFD\uFFFD\xA2\xAC\xA6\uFFFD"
    },
    ibm1133: "cp1133",
    csibm1133: "cp1133",
    cp1161: {
      type: "_sbcs",
      chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0E48\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\u0E49\u0E4A\u0E4B\u20AC\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\xA2\xAC\xA6\xA0"
    },
    ibm1161: "cp1161",
    csibm1161: "cp1161",
    cp1162: {
      type: "_sbcs",
      chars: "\u20AC\x81\x82\x83\x84\u2026\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\u2018\u2019\u201C\u201D\u2022\u2013\u2014\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
    },
    ibm1162: "cp1162",
    csibm1162: "cp1162",
    cp1163: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\u20AC\xA5\xA6\xA7\u0153\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\u0178\xB5\xB6\xB7\u0152\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\u0102\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\u0300\xCD\xCE\xCF\u0110\xD1\u0309\xD3\xD4\u01A0\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u01AF\u0303\xDF\xE0\xE1\xE2\u0103\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\u0301\xED\xEE\xEF\u0111\xF1\u0323\xF3\xF4\u01A1\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u01B0\u20AB\xFF"
    },
    ibm1163: "cp1163",
    csibm1163: "cp1163",
    maccroatian: {
      type: "_sbcs",
      chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\u0160\u2122\xB4\xA8\u2260\u017D\xD8\u221E\xB1\u2264\u2265\u2206\xB5\u2202\u2211\u220F\u0161\u222B\xAA\xBA\u2126\u017E\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u0106\xAB\u010C\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u0110\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\uFFFD\xA9\u2044\xA4\u2039\u203A\xC6\xBB\u2013\xB7\u201A\u201E\u2030\xC2\u0107\xC1\u010D\xC8\xCD\xCE\xCF\xCC\xD3\xD4\u0111\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u03C0\xCB\u02DA\xB8\xCA\xE6\u02C7"
    },
    maccyrillic: {
      type: "_sbcs",
      chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u2020\xB0\xA2\xA3\xA7\u2022\xB6\u0406\xAE\xA9\u2122\u0402\u0452\u2260\u0403\u0453\u221E\xB1\u2264\u2265\u0456\xB5\u2202\u0408\u0404\u0454\u0407\u0457\u0409\u0459\u040A\u045A\u0458\u0405\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\u040B\u045B\u040C\u045C\u0455\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u201E\u040E\u045E\u040F\u045F\u2116\u0401\u0451\u044F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\xA4"
    },
    macgreek: {
      type: "_sbcs",
      chars: "\xC4\xB9\xB2\xC9\xB3\xD6\xDC\u0385\xE0\xE2\xE4\u0384\xA8\xE7\xE9\xE8\xEA\xEB\xA3\u2122\xEE\xEF\u2022\xBD\u2030\xF4\xF6\xA6\xAD\xF9\xFB\xFC\u2020\u0393\u0394\u0398\u039B\u039E\u03A0\xDF\xAE\xA9\u03A3\u03AA\xA7\u2260\xB0\u0387\u0391\xB1\u2264\u2265\xA5\u0392\u0395\u0396\u0397\u0399\u039A\u039C\u03A6\u03AB\u03A8\u03A9\u03AC\u039D\xAC\u039F\u03A1\u2248\u03A4\xAB\xBB\u2026\xA0\u03A5\u03A7\u0386\u0388\u0153\u2013\u2015\u201C\u201D\u2018\u2019\xF7\u0389\u038A\u038C\u038E\u03AD\u03AE\u03AF\u03CC\u038F\u03CD\u03B1\u03B2\u03C8\u03B4\u03B5\u03C6\u03B3\u03B7\u03B9\u03BE\u03BA\u03BB\u03BC\u03BD\u03BF\u03C0\u03CE\u03C1\u03C3\u03C4\u03B8\u03C9\u03C2\u03C7\u03C5\u03B6\u03CA\u03CB\u0390\u03B0\uFFFD"
    },
    maciceland: {
      type: "_sbcs",
      chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\xDD\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\xD0\xF0\xDE\xFE\xFD\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
    },
    macroman: {
      type: "_sbcs",
      chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\u2039\u203A\uFB01\uFB02\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
    },
    macromania: {
      type: "_sbcs",
      chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\u0102\u015E\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\u0103\u015F\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\u2039\u203A\u0162\u0163\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
    },
    macthai: {
      type: "_sbcs",
      chars: "\xAB\xBB\u2026\uF88C\uF88F\uF892\uF895\uF898\uF88B\uF88E\uF891\uF894\uF897\u201C\u201D\uF899\uFFFD\u2022\uF884\uF889\uF885\uF886\uF887\uF888\uF88A\uF88D\uF890\uF893\uF896\u2018\u2019\uFFFD\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFEFF\u200B\u2013\u2014\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u2122\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\xAE\xA9\uFFFD\uFFFD\uFFFD\uFFFD"
    },
    macturkish: {
      type: "_sbcs",
      chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u011E\u011F\u0130\u0131\u015E\u015F\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\uFFFD\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
    },
    macukraine: {
      type: "_sbcs",
      chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u2020\xB0\u0490\xA3\xA7\u2022\xB6\u0406\xAE\xA9\u2122\u0402\u0452\u2260\u0403\u0453\u221E\xB1\u2264\u2265\u0456\xB5\u0491\u0408\u0404\u0454\u0407\u0457\u0409\u0459\u040A\u045A\u0458\u0405\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\u040B\u045B\u040C\u045C\u0455\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u201E\u040E\u045E\u040F\u045F\u2116\u0401\u0451\u044F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\xA4"
    },
    koi8r: {
      type: "_sbcs",
      chars: "\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2580\u2584\u2588\u258C\u2590\u2591\u2592\u2593\u2320\u25A0\u2219\u221A\u2248\u2264\u2265\xA0\u2321\xB0\xB2\xB7\xF7\u2550\u2551\u2552\u0451\u2553\u2554\u2555\u2556\u2557\u2558\u2559\u255A\u255B\u255C\u255D\u255E\u255F\u2560\u2561\u0401\u2562\u2563\u2564\u2565\u2566\u2567\u2568\u2569\u256A\u256B\u256C\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
    },
    koi8u: {
      type: "_sbcs",
      chars: "\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2580\u2584\u2588\u258C\u2590\u2591\u2592\u2593\u2320\u25A0\u2219\u221A\u2248\u2264\u2265\xA0\u2321\xB0\xB2\xB7\xF7\u2550\u2551\u2552\u0451\u0454\u2554\u0456\u0457\u2557\u2558\u2559\u255A\u255B\u0491\u255D\u255E\u255F\u2560\u2561\u0401\u0404\u2563\u0406\u0407\u2566\u2567\u2568\u2569\u256A\u0490\u256C\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
    },
    koi8ru: {
      type: "_sbcs",
      chars: "\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2580\u2584\u2588\u258C\u2590\u2591\u2592\u2593\u2320\u25A0\u2219\u221A\u2248\u2264\u2265\xA0\u2321\xB0\xB2\xB7\xF7\u2550\u2551\u2552\u0451\u0454\u2554\u0456\u0457\u2557\u2558\u2559\u255A\u255B\u0491\u045E\u255E\u255F\u2560\u2561\u0401\u0404\u2563\u0406\u0407\u2566\u2567\u2568\u2569\u256A\u0490\u040E\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
    },
    koi8t: {
      type: "_sbcs",
      chars: "\u049B\u0493\u201A\u0492\u201E\u2026\u2020\u2021\uFFFD\u2030\u04B3\u2039\u04B2\u04B7\u04B6\uFFFD\u049A\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\uFFFD\u203A\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u04EF\u04EE\u0451\xA4\u04E3\xA6\xA7\uFFFD\uFFFD\uFFFD\xAB\xAC\xAD\xAE\uFFFD\xB0\xB1\xB2\u0401\uFFFD\u04E2\xB6\xB7\uFFFD\u2116\uFFFD\xBB\uFFFD\uFFFD\uFFFD\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
    },
    armscii8: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\uFFFD\u0587\u0589)(\xBB\xAB\u2014.\u055D,-\u058A\u2026\u055C\u055B\u055E\u0531\u0561\u0532\u0562\u0533\u0563\u0534\u0564\u0535\u0565\u0536\u0566\u0537\u0567\u0538\u0568\u0539\u0569\u053A\u056A\u053B\u056B\u053C\u056C\u053D\u056D\u053E\u056E\u053F\u056F\u0540\u0570\u0541\u0571\u0542\u0572\u0543\u0573\u0544\u0574\u0545\u0575\u0546\u0576\u0547\u0577\u0548\u0578\u0549\u0579\u054A\u057A\u054B\u057B\u054C\u057C\u054D\u057D\u054E\u057E\u054F\u057F\u0550\u0580\u0551\u0581\u0552\u0582\u0553\u0583\u0554\u0584\u0555\u0585\u0556\u0586\u055A\uFFFD"
    },
    rk1048: {
      type: "_sbcs",
      chars: "\u0402\u0403\u201A\u0453\u201E\u2026\u2020\u2021\u20AC\u2030\u0409\u2039\u040A\u049A\u04BA\u040F\u0452\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0459\u203A\u045A\u049B\u04BB\u045F\xA0\u04B0\u04B1\u04D8\xA4\u04E8\xA6\xA7\u0401\xA9\u0492\xAB\xAC\xAD\xAE\u04AE\xB0\xB1\u0406\u0456\u04E9\xB5\xB6\xB7\u0451\u2116\u0493\xBB\u04D9\u04A2\u04A3\u04AF\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F"
    },
    tcvn: {
      type: "_sbcs",
      chars: `\0\xDA\u1EE4\x03\u1EEA\u1EEC\u1EEE\x07	
\r\x0E\x0F\x10\u1EE8\u1EF0\u1EF2\u1EF6\u1EF8\xDD\u1EF4\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}~\x7F\xC0\u1EA2\xC3\xC1\u1EA0\u1EB6\u1EAC\xC8\u1EBA\u1EBC\xC9\u1EB8\u1EC6\xCC\u1EC8\u0128\xCD\u1ECA\xD2\u1ECE\xD5\xD3\u1ECC\u1ED8\u1EDC\u1EDE\u1EE0\u1EDA\u1EE2\xD9\u1EE6\u0168\xA0\u0102\xC2\xCA\xD4\u01A0\u01AF\u0110\u0103\xE2\xEA\xF4\u01A1\u01B0\u0111\u1EB0\u0300\u0309\u0303\u0301\u0323\xE0\u1EA3\xE3\xE1\u1EA1\u1EB2\u1EB1\u1EB3\u1EB5\u1EAF\u1EB4\u1EAE\u1EA6\u1EA8\u1EAA\u1EA4\u1EC0\u1EB7\u1EA7\u1EA9\u1EAB\u1EA5\u1EAD\xE8\u1EC2\u1EBB\u1EBD\xE9\u1EB9\u1EC1\u1EC3\u1EC5\u1EBF\u1EC7\xEC\u1EC9\u1EC4\u1EBE\u1ED2\u0129\xED\u1ECB\xF2\u1ED4\u1ECF\xF5\xF3\u1ECD\u1ED3\u1ED5\u1ED7\u1ED1\u1ED9\u1EDD\u1EDF\u1EE1\u1EDB\u1EE3\xF9\u1ED6\u1EE7\u0169\xFA\u1EE5\u1EEB\u1EED\u1EEF\u1EE9\u1EF1\u1EF3\u1EF7\u1EF9\xFD\u1EF5\u1ED0`
    },
    georgianacademy: {
      type: "_sbcs",
      chars: "\x80\x81\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\x8D\x8E\x8F\x90\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\x9D\x9E\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\u10D0\u10D1\u10D2\u10D3\u10D4\u10D5\u10D6\u10D7\u10D8\u10D9\u10DA\u10DB\u10DC\u10DD\u10DE\u10DF\u10E0\u10E1\u10E2\u10E3\u10E4\u10E5\u10E6\u10E7\u10E8\u10E9\u10EA\u10EB\u10EC\u10ED\u10EE\u10EF\u10F0\u10F1\u10F2\u10F3\u10F4\u10F5\u10F6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
    },
    georgianps: {
      type: "_sbcs",
      chars: "\x80\x81\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\x8D\x8E\x8F\x90\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\x9D\x9E\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\u10D0\u10D1\u10D2\u10D3\u10D4\u10D5\u10D6\u10F1\u10D7\u10D8\u10D9\u10DA\u10DB\u10DC\u10F2\u10DD\u10DE\u10DF\u10E0\u10E1\u10E2\u10F3\u10E3\u10E4\u10E5\u10E6\u10E7\u10E8\u10E9\u10EA\u10EB\u10EC\u10ED\u10EE\u10F4\u10EF\u10F0\u10F5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
    },
    pt154: {
      type: "_sbcs",
      chars: "\u0496\u0492\u04EE\u0493\u201E\u2026\u04B6\u04AE\u04B2\u04AF\u04A0\u04E2\u04A2\u049A\u04BA\u04B8\u0497\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u04B3\u04B7\u04A1\u04E3\u04A3\u049B\u04BB\u04B9\xA0\u040E\u045E\u0408\u04E8\u0498\u04B0\xA7\u0401\xA9\u04D8\xAB\xAC\u04EF\xAE\u049C\xB0\u04B1\u0406\u0456\u0499\u04E9\xB6\xB7\u0451\u2116\u04D9\xBB\u0458\u04AA\u04AB\u049D\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F"
    },
    viscii: {
      type: "_sbcs",
      chars: `\0\x01\u1EB2\x03\x04\u1EB4\u1EAA\x07	
\r\x0E\x0F\x10\x11\x12\x13\u1EF6\x15\x16\x17\x18\u1EF8\x1A\x1B\x1C\x1D\u1EF4\x1F !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}~\x7F\u1EA0\u1EAE\u1EB0\u1EB6\u1EA4\u1EA6\u1EA8\u1EAC\u1EBC\u1EB8\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EE2\u1EDA\u1EDC\u1EDE\u1ECA\u1ECE\u1ECC\u1EC8\u1EE6\u0168\u1EE4\u1EF2\xD5\u1EAF\u1EB1\u1EB7\u1EA5\u1EA7\u1EA9\u1EAD\u1EBD\u1EB9\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1ED1\u1ED3\u1ED5\u1ED7\u1EE0\u01A0\u1ED9\u1EDD\u1EDF\u1ECB\u1EF0\u1EE8\u1EEA\u1EEC\u01A1\u1EDB\u01AF\xC0\xC1\xC2\xC3\u1EA2\u0102\u1EB3\u1EB5\xC8\xC9\xCA\u1EBA\xCC\xCD\u0128\u1EF3\u0110\u1EE9\xD2\xD3\xD4\u1EA1\u1EF7\u1EEB\u1EED\xD9\xDA\u1EF9\u1EF5\xDD\u1EE1\u01B0\xE0\xE1\xE2\xE3\u1EA3\u0103\u1EEF\u1EAB\xE8\xE9\xEA\u1EBB\xEC\xED\u0129\u1EC9\u0111\u1EF1\xF2\xF3\xF4\xF5\u1ECF\u1ECD\u1EE5\xF9\xFA\u0169\u1EE7\xFD\u1EE3\u1EEE`
    },
    iso646cn: {
      type: "_sbcs",
      chars: `\0\x01\x02\x03\x04\x05\x06\x07	
\r\x0E\x0F\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F !"#\xA5%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}\u203E\x7F\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD`
    },
    iso646jp: {
      type: "_sbcs",
      chars: `\0\x01\x02\x03\x04\x05\x06\x07	
\r\x0E\x0F\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\xA5]^_\`abcdefghijklmnopqrstuvwxyz{|}\u203E\x7F\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD`
    },
    hproman8: {
      type: "_sbcs",
      chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xC0\xC2\xC8\xCA\xCB\xCE\xCF\xB4\u02CB\u02C6\xA8\u02DC\xD9\xDB\u20A4\xAF\xDD\xFD\xB0\xC7\xE7\xD1\xF1\xA1\xBF\xA4\xA3\xA5\xA7\u0192\xA2\xE2\xEA\xF4\xFB\xE1\xE9\xF3\xFA\xE0\xE8\xF2\xF9\xE4\xEB\xF6\xFC\xC5\xEE\xD8\xC6\xE5\xED\xF8\xE6\xC4\xEC\xD6\xDC\xC9\xEF\xDF\xD4\xC1\xC3\xE3\xD0\xF0\xCD\xCC\xD3\xD2\xD5\xF5\u0160\u0161\xDA\u0178\xFF\xDE\xFE\xB7\xB5\xB6\xBE\u2014\xBC\xBD\xAA\xBA\xAB\u25A0\xBB\xB1\uFFFD"
    },
    macintosh: {
      type: "_sbcs",
      chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\u2039\u203A\uFB01\uFB02\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
    },
    ascii: {
      type: "_sbcs",
      chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"
    },
    tis620: {
      type: "_sbcs",
      chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
    }
  };
});
var require_dbcs_codec = __commonJS2((exports) => {
  var Buffer22 = require_safer().Buffer;
  exports._dbcs = DBCSCodec;
  var UNASSIGNED = -1;
  var GB18030_CODE = -2;
  var SEQ_START = -10;
  var NODE_START = -1000;
  var UNASSIGNED_NODE = new Array(256);
  var DEF_CHAR = -1;
  for (i2 = 0;i2 < 256; i2++)
    UNASSIGNED_NODE[i2] = UNASSIGNED;
  var i2;
  function DBCSCodec(codecOptions, iconv) {
    this.encodingName = codecOptions.encodingName;
    if (!codecOptions)
      throw new Error("DBCS codec is called without the data.");
    if (!codecOptions.table)
      throw new Error("Encoding '" + this.encodingName + "' has no data.");
    var mappingTable = codecOptions.table();
    this.decodeTables = [];
    this.decodeTables[0] = UNASSIGNED_NODE.slice(0);
    this.decodeTableSeq = [];
    for (var i22 = 0;i22 < mappingTable.length; i22++)
      this._addDecodeChunk(mappingTable[i22]);
    if (typeof codecOptions.gb18030 === "function") {
      this.gb18030 = codecOptions.gb18030();
      var commonThirdByteNodeIdx = this.decodeTables.length;
      this.decodeTables.push(UNASSIGNED_NODE.slice(0));
      var commonFourthByteNodeIdx = this.decodeTables.length;
      this.decodeTables.push(UNASSIGNED_NODE.slice(0));
      var firstByteNode = this.decodeTables[0];
      for (var i22 = 129;i22 <= 254; i22++) {
        var secondByteNode = this.decodeTables[NODE_START - firstByteNode[i22]];
        for (var j22 = 48;j22 <= 57; j22++) {
          if (secondByteNode[j22] === UNASSIGNED) {
            secondByteNode[j22] = NODE_START - commonThirdByteNodeIdx;
          } else if (secondByteNode[j22] > NODE_START) {
            throw new Error("gb18030 decode tables conflict at byte 2");
          }
          var thirdByteNode = this.decodeTables[NODE_START - secondByteNode[j22]];
          for (var k = 129;k <= 254; k++) {
            if (thirdByteNode[k] === UNASSIGNED) {
              thirdByteNode[k] = NODE_START - commonFourthByteNodeIdx;
            } else if (thirdByteNode[k] === NODE_START - commonFourthByteNodeIdx) {
              continue;
            } else if (thirdByteNode[k] > NODE_START) {
              throw new Error("gb18030 decode tables conflict at byte 3");
            }
            var fourthByteNode = this.decodeTables[NODE_START - thirdByteNode[k]];
            for (var l22 = 48;l22 <= 57; l22++) {
              if (fourthByteNode[l22] === UNASSIGNED)
                fourthByteNode[l22] = GB18030_CODE;
            }
          }
        }
      }
    }
    this.defaultCharUnicode = iconv.defaultCharUnicode;
    this.encodeTable = [];
    this.encodeTableSeq = [];
    var skipEncodeChars = {};
    if (codecOptions.encodeSkipVals)
      for (var i22 = 0;i22 < codecOptions.encodeSkipVals.length; i22++) {
        var val2 = codecOptions.encodeSkipVals[i22];
        if (typeof val2 === "number")
          skipEncodeChars[val2] = true;
        else
          for (var j22 = val2.from;j22 <= val2.to; j22++)
            skipEncodeChars[j22] = true;
      }
    this._fillEncodeTable(0, 0, skipEncodeChars);
    if (codecOptions.encodeAdd) {
      for (var uChar in codecOptions.encodeAdd)
        if (Object.prototype.hasOwnProperty.call(codecOptions.encodeAdd, uChar))
          this._setEncodeChar(uChar.charCodeAt(0), codecOptions.encodeAdd[uChar]);
    }
    this.defCharSB = this.encodeTable[0][iconv.defaultCharSingleByte.charCodeAt(0)];
    if (this.defCharSB === UNASSIGNED)
      this.defCharSB = this.encodeTable[0]["?"];
    if (this.defCharSB === UNASSIGNED)
      this.defCharSB = "?".charCodeAt(0);
  }
  DBCSCodec.prototype.encoder = DBCSEncoder;
  DBCSCodec.prototype.decoder = DBCSDecoder;
  DBCSCodec.prototype._getDecodeTrieNode = function(addr) {
    var bytes = [];
    for (;addr > 0; addr >>>= 8)
      bytes.push(addr & 255);
    if (bytes.length == 0)
      bytes.push(0);
    var node = this.decodeTables[0];
    for (var i22 = bytes.length - 1;i22 > 0; i22--) {
      var val2 = node[bytes[i22]];
      if (val2 == UNASSIGNED) {
        node[bytes[i22]] = NODE_START - this.decodeTables.length;
        this.decodeTables.push(node = UNASSIGNED_NODE.slice(0));
      } else if (val2 <= NODE_START) {
        node = this.decodeTables[NODE_START - val2];
      } else
        throw new Error("Overwrite byte in " + this.encodingName + ", addr: " + addr.toString(16));
    }
    return node;
  };
  DBCSCodec.prototype._addDecodeChunk = function(chunk) {
    var curAddr = parseInt(chunk[0], 16);
    var writeTable = this._getDecodeTrieNode(curAddr);
    curAddr = curAddr & 255;
    for (var k = 1;k < chunk.length; k++) {
      var part = chunk[k];
      if (typeof part === "string") {
        for (var l22 = 0;l22 < part.length; ) {
          var code = part.charCodeAt(l22++);
          if (55296 <= code && code < 56320) {
            var codeTrail = part.charCodeAt(l22++);
            if (56320 <= codeTrail && codeTrail < 57344)
              writeTable[curAddr++] = 65536 + (code - 55296) * 1024 + (codeTrail - 56320);
            else
              throw new Error("Incorrect surrogate pair in " + this.encodingName + " at chunk " + chunk[0]);
          } else if (4080 < code && code <= 4095) {
            var len = 4095 - code + 2;
            var seq = [];
            for (var m22 = 0;m22 < len; m22++)
              seq.push(part.charCodeAt(l22++));
            writeTable[curAddr++] = SEQ_START - this.decodeTableSeq.length;
            this.decodeTableSeq.push(seq);
          } else
            writeTable[curAddr++] = code;
        }
      } else if (typeof part === "number") {
        var charCode = writeTable[curAddr - 1] + 1;
        for (var l22 = 0;l22 < part; l22++)
          writeTable[curAddr++] = charCode++;
      } else
        throw new Error("Incorrect type '" + typeof part + "' given in " + this.encodingName + " at chunk " + chunk[0]);
    }
    if (curAddr > 255)
      throw new Error("Incorrect chunk in " + this.encodingName + " at addr " + chunk[0] + ": too long" + curAddr);
  };
  DBCSCodec.prototype._getEncodeBucket = function(uCode) {
    var high = uCode >> 8;
    if (this.encodeTable[high] === undefined)
      this.encodeTable[high] = UNASSIGNED_NODE.slice(0);
    return this.encodeTable[high];
  };
  DBCSCodec.prototype._setEncodeChar = function(uCode, dbcsCode) {
    var bucket = this._getEncodeBucket(uCode);
    var low = uCode & 255;
    if (bucket[low] <= SEQ_START)
      this.encodeTableSeq[SEQ_START - bucket[low]][DEF_CHAR] = dbcsCode;
    else if (bucket[low] == UNASSIGNED)
      bucket[low] = dbcsCode;
  };
  DBCSCodec.prototype._setEncodeSequence = function(seq, dbcsCode) {
    var uCode = seq[0];
    var bucket = this._getEncodeBucket(uCode);
    var low = uCode & 255;
    var node;
    if (bucket[low] <= SEQ_START) {
      node = this.encodeTableSeq[SEQ_START - bucket[low]];
    } else {
      node = {};
      if (bucket[low] !== UNASSIGNED)
        node[DEF_CHAR] = bucket[low];
      bucket[low] = SEQ_START - this.encodeTableSeq.length;
      this.encodeTableSeq.push(node);
    }
    for (var j22 = 1;j22 < seq.length - 1; j22++) {
      var oldVal = node[uCode];
      if (typeof oldVal === "object")
        node = oldVal;
      else {
        node = node[uCode] = {};
        if (oldVal !== undefined)
          node[DEF_CHAR] = oldVal;
      }
    }
    uCode = seq[seq.length - 1];
    node[uCode] = dbcsCode;
  };
  DBCSCodec.prototype._fillEncodeTable = function(nodeIdx, prefix, skipEncodeChars) {
    var node = this.decodeTables[nodeIdx];
    var hasValues = false;
    var subNodeEmpty = {};
    for (var i22 = 0;i22 < 256; i22++) {
      var uCode = node[i22];
      var mbCode = prefix + i22;
      if (skipEncodeChars[mbCode])
        continue;
      if (uCode >= 0) {
        this._setEncodeChar(uCode, mbCode);
        hasValues = true;
      } else if (uCode <= NODE_START) {
        var subNodeIdx = NODE_START - uCode;
        if (!subNodeEmpty[subNodeIdx]) {
          var newPrefix = mbCode << 8 >>> 0;
          if (this._fillEncodeTable(subNodeIdx, newPrefix, skipEncodeChars))
            hasValues = true;
          else
            subNodeEmpty[subNodeIdx] = true;
        }
      } else if (uCode <= SEQ_START) {
        this._setEncodeSequence(this.decodeTableSeq[SEQ_START - uCode], mbCode);
        hasValues = true;
      }
    }
    return hasValues;
  };
  function DBCSEncoder(options3, codec) {
    this.leadSurrogate = -1;
    this.seqObj = undefined;
    this.encodeTable = codec.encodeTable;
    this.encodeTableSeq = codec.encodeTableSeq;
    this.defaultCharSingleByte = codec.defCharSB;
    this.gb18030 = codec.gb18030;
  }
  DBCSEncoder.prototype.write = function(str) {
    var newBuf = Buffer22.alloc(str.length * (this.gb18030 ? 4 : 3)), leadSurrogate = this.leadSurrogate, seqObj = this.seqObj, nextChar = -1, i22 = 0, j22 = 0;
    while (true) {
      if (nextChar === -1) {
        if (i22 == str.length)
          break;
        var uCode = str.charCodeAt(i22++);
      } else {
        var uCode = nextChar;
        nextChar = -1;
      }
      if (55296 <= uCode && uCode < 57344) {
        if (uCode < 56320) {
          if (leadSurrogate === -1) {
            leadSurrogate = uCode;
            continue;
          } else {
            leadSurrogate = uCode;
            uCode = UNASSIGNED;
          }
        } else {
          if (leadSurrogate !== -1) {
            uCode = 65536 + (leadSurrogate - 55296) * 1024 + (uCode - 56320);
            leadSurrogate = -1;
          } else {
            uCode = UNASSIGNED;
          }
        }
      } else if (leadSurrogate !== -1) {
        nextChar = uCode;
        uCode = UNASSIGNED;
        leadSurrogate = -1;
      }
      var dbcsCode = UNASSIGNED;
      if (seqObj !== undefined && uCode != UNASSIGNED) {
        var resCode = seqObj[uCode];
        if (typeof resCode === "object") {
          seqObj = resCode;
          continue;
        } else if (typeof resCode == "number") {
          dbcsCode = resCode;
        } else if (resCode == undefined) {
          resCode = seqObj[DEF_CHAR];
          if (resCode !== undefined) {
            dbcsCode = resCode;
            nextChar = uCode;
          } else {
          }
        }
        seqObj = undefined;
      } else if (uCode >= 0) {
        var subtable = this.encodeTable[uCode >> 8];
        if (subtable !== undefined)
          dbcsCode = subtable[uCode & 255];
        if (dbcsCode <= SEQ_START) {
          seqObj = this.encodeTableSeq[SEQ_START - dbcsCode];
          continue;
        }
        if (dbcsCode == UNASSIGNED && this.gb18030) {
          var idx = findIdx(this.gb18030.uChars, uCode);
          if (idx != -1) {
            var dbcsCode = this.gb18030.gbChars[idx] + (uCode - this.gb18030.uChars[idx]);
            newBuf[j22++] = 129 + Math.floor(dbcsCode / 12600);
            dbcsCode = dbcsCode % 12600;
            newBuf[j22++] = 48 + Math.floor(dbcsCode / 1260);
            dbcsCode = dbcsCode % 1260;
            newBuf[j22++] = 129 + Math.floor(dbcsCode / 10);
            dbcsCode = dbcsCode % 10;
            newBuf[j22++] = 48 + dbcsCode;
            continue;
          }
        }
      }
      if (dbcsCode === UNASSIGNED)
        dbcsCode = this.defaultCharSingleByte;
      if (dbcsCode < 256) {
        newBuf[j22++] = dbcsCode;
      } else if (dbcsCode < 65536) {
        newBuf[j22++] = dbcsCode >> 8;
        newBuf[j22++] = dbcsCode & 255;
      } else if (dbcsCode < 16777216) {
        newBuf[j22++] = dbcsCode >> 16;
        newBuf[j22++] = dbcsCode >> 8 & 255;
        newBuf[j22++] = dbcsCode & 255;
      } else {
        newBuf[j22++] = dbcsCode >>> 24;
        newBuf[j22++] = dbcsCode >>> 16 & 255;
        newBuf[j22++] = dbcsCode >>> 8 & 255;
        newBuf[j22++] = dbcsCode & 255;
      }
    }
    this.seqObj = seqObj;
    this.leadSurrogate = leadSurrogate;
    return newBuf.slice(0, j22);
  };
  DBCSEncoder.prototype.end = function() {
    if (this.leadSurrogate === -1 && this.seqObj === undefined)
      return;
    var newBuf = Buffer22.alloc(10), j22 = 0;
    if (this.seqObj) {
      var dbcsCode = this.seqObj[DEF_CHAR];
      if (dbcsCode !== undefined) {
        if (dbcsCode < 256) {
          newBuf[j22++] = dbcsCode;
        } else {
          newBuf[j22++] = dbcsCode >> 8;
          newBuf[j22++] = dbcsCode & 255;
        }
      } else {
      }
      this.seqObj = undefined;
    }
    if (this.leadSurrogate !== -1) {
      newBuf[j22++] = this.defaultCharSingleByte;
      this.leadSurrogate = -1;
    }
    return newBuf.slice(0, j22);
  };
  DBCSEncoder.prototype.findIdx = findIdx;
  function DBCSDecoder(options3, codec) {
    this.nodeIdx = 0;
    this.prevBytes = [];
    this.decodeTables = codec.decodeTables;
    this.decodeTableSeq = codec.decodeTableSeq;
    this.defaultCharUnicode = codec.defaultCharUnicode;
    this.gb18030 = codec.gb18030;
  }
  DBCSDecoder.prototype.write = function(buf) {
    var newBuf = Buffer22.alloc(buf.length * 2), nodeIdx = this.nodeIdx, prevBytes = this.prevBytes, prevOffset = this.prevBytes.length, seqStart = -this.prevBytes.length, uCode;
    for (var i22 = 0, j22 = 0;i22 < buf.length; i22++) {
      var curByte = i22 >= 0 ? buf[i22] : prevBytes[i22 + prevOffset];
      var uCode = this.decodeTables[nodeIdx][curByte];
      if (uCode >= 0) {
      } else if (uCode === UNASSIGNED) {
        uCode = this.defaultCharUnicode.charCodeAt(0);
        i22 = seqStart;
      } else if (uCode === GB18030_CODE) {
        if (i22 >= 3) {
          var ptr = (buf[i22 - 3] - 129) * 12600 + (buf[i22 - 2] - 48) * 1260 + (buf[i22 - 1] - 129) * 10 + (curByte - 48);
        } else {
          var ptr = (prevBytes[i22 - 3 + prevOffset] - 129) * 12600 + ((i22 - 2 >= 0 ? buf[i22 - 2] : prevBytes[i22 - 2 + prevOffset]) - 48) * 1260 + ((i22 - 1 >= 0 ? buf[i22 - 1] : prevBytes[i22 - 1 + prevOffset]) - 129) * 10 + (curByte - 48);
        }
        var idx = findIdx(this.gb18030.gbChars, ptr);
        uCode = this.gb18030.uChars[idx] + ptr - this.gb18030.gbChars[idx];
      } else if (uCode <= NODE_START) {
        nodeIdx = NODE_START - uCode;
        continue;
      } else if (uCode <= SEQ_START) {
        var seq = this.decodeTableSeq[SEQ_START - uCode];
        for (var k = 0;k < seq.length - 1; k++) {
          uCode = seq[k];
          newBuf[j22++] = uCode & 255;
          newBuf[j22++] = uCode >> 8;
        }
        uCode = seq[seq.length - 1];
      } else
        throw new Error("iconv-lite internal error: invalid decoding table value " + uCode + " at " + nodeIdx + "/" + curByte);
      if (uCode >= 65536) {
        uCode -= 65536;
        var uCodeLead = 55296 | uCode >> 10;
        newBuf[j22++] = uCodeLead & 255;
        newBuf[j22++] = uCodeLead >> 8;
        uCode = 56320 | uCode & 1023;
      }
      newBuf[j22++] = uCode & 255;
      newBuf[j22++] = uCode >> 8;
      nodeIdx = 0;
      seqStart = i22 + 1;
    }
    this.nodeIdx = nodeIdx;
    this.prevBytes = seqStart >= 0 ? Array.prototype.slice.call(buf, seqStart) : prevBytes.slice(seqStart + prevOffset).concat(Array.prototype.slice.call(buf));
    return newBuf.slice(0, j22).toString("ucs2");
  };
  DBCSDecoder.prototype.end = function() {
    var ret = "";
    while (this.prevBytes.length > 0) {
      ret += this.defaultCharUnicode;
      var bytesArr = this.prevBytes.slice(1);
      this.prevBytes = [];
      this.nodeIdx = 0;
      if (bytesArr.length > 0)
        ret += this.write(bytesArr);
    }
    this.prevBytes = [];
    this.nodeIdx = 0;
    return ret;
  };
  function findIdx(table, val2) {
    if (table[0] > val2)
      return -1;
    var l22 = 0, r22 = table.length;
    while (l22 < r22 - 1) {
      var mid = l22 + (r22 - l22 + 1 >> 1);
      if (table[mid] <= val2)
        l22 = mid;
      else
        r22 = mid;
    }
    return l22;
  }
});
var require_shiftjis = __commonJS2((exports, module) => {
  module.exports = [
    ["0", "\0", 128],
    ["a1", "\uFF61", 62],
    ["8140", "\u3000\u3001\u3002\uFF0C\uFF0E\u30FB\uFF1A\uFF1B\uFF1F\uFF01\u309B\u309C\xB4\uFF40\xA8\uFF3E\uFFE3\uFF3F\u30FD\u30FE\u309D\u309E\u3003\u4EDD\u3005\u3006\u3007\u30FC\u2015\u2010\uFF0F\uFF3C\uFF5E\u2225\uFF5C\u2026\u2025\u2018\u2019\u201C\u201D\uFF08\uFF09\u3014\u3015\uFF3B\uFF3D\uFF5B\uFF5D\u3008", 9, "\uFF0B\uFF0D\xB1\xD7"],
    ["8180", "\xF7\uFF1D\u2260\uFF1C\uFF1E\u2266\u2267\u221E\u2234\u2642\u2640\xB0\u2032\u2033\u2103\uFFE5\uFF04\uFFE0\uFFE1\uFF05\uFF03\uFF06\uFF0A\uFF20\xA7\u2606\u2605\u25CB\u25CF\u25CE\u25C7\u25C6\u25A1\u25A0\u25B3\u25B2\u25BD\u25BC\u203B\u3012\u2192\u2190\u2191\u2193\u3013"],
    ["81b8", "\u2208\u220B\u2286\u2287\u2282\u2283\u222A\u2229"],
    ["81c8", "\u2227\u2228\uFFE2\u21D2\u21D4\u2200\u2203"],
    ["81da", "\u2220\u22A5\u2312\u2202\u2207\u2261\u2252\u226A\u226B\u221A\u223D\u221D\u2235\u222B\u222C"],
    ["81f0", "\u212B\u2030\u266F\u266D\u266A\u2020\u2021\xB6"],
    ["81fc", "\u25EF"],
    ["824f", "\uFF10", 9],
    ["8260", "\uFF21", 25],
    ["8281", "\uFF41", 25],
    ["829f", "\u3041", 82],
    ["8340", "\u30A1", 62],
    ["8380", "\u30E0", 22],
    ["839f", "\u0391", 16, "\u03A3", 6],
    ["83bf", "\u03B1", 16, "\u03C3", 6],
    ["8440", "\u0410", 5, "\u0401\u0416", 25],
    ["8470", "\u0430", 5, "\u0451\u0436", 7],
    ["8480", "\u043E", 17],
    ["849f", "\u2500\u2502\u250C\u2510\u2518\u2514\u251C\u252C\u2524\u2534\u253C\u2501\u2503\u250F\u2513\u251B\u2517\u2523\u2533\u252B\u253B\u254B\u2520\u252F\u2528\u2537\u253F\u251D\u2530\u2525\u2538\u2542"],
    ["8740", "\u2460", 19, "\u2160", 9],
    ["875f", "\u3349\u3314\u3322\u334D\u3318\u3327\u3303\u3336\u3351\u3357\u330D\u3326\u3323\u332B\u334A\u333B\u339C\u339D\u339E\u338E\u338F\u33C4\u33A1"],
    ["877e", "\u337B"],
    ["8780", "\u301D\u301F\u2116\u33CD\u2121\u32A4", 4, "\u3231\u3232\u3239\u337E\u337D\u337C\u2252\u2261\u222B\u222E\u2211\u221A\u22A5\u2220\u221F\u22BF\u2235\u2229\u222A"],
    ["889f", "\u4E9C\u5516\u5A03\u963F\u54C0\u611B\u6328\u59F6\u9022\u8475\u831C\u7A50\u60AA\u63E1\u6E25\u65ED\u8466\u82A6\u9BF5\u6893\u5727\u65A1\u6271\u5B9B\u59D0\u867B\u98F4\u7D62\u7DBE\u9B8E\u6216\u7C9F\u88B7\u5B89\u5EB5\u6309\u6697\u6848\u95C7\u978D\u674F\u4EE5\u4F0A\u4F4D\u4F9D\u5049\u56F2\u5937\u59D4\u5A01\u5C09\u60DF\u610F\u6170\u6613\u6905\u70BA\u754F\u7570\u79FB\u7DAD\u7DEF\u80C3\u840E\u8863\u8B02\u9055\u907A\u533B\u4E95\u4EA5\u57DF\u80B2\u90C1\u78EF\u4E00\u58F1\u6EA2\u9038\u7A32\u8328\u828B\u9C2F\u5141\u5370\u54BD\u54E1\u56E0\u59FB\u5F15\u98F2\u6DEB\u80E4\u852D"],
    ["8940", "\u9662\u9670\u96A0\u97FB\u540B\u53F3\u5B87\u70CF\u7FBD\u8FC2\u96E8\u536F\u9D5C\u7ABA\u4E11\u7893\u81FC\u6E26\u5618\u5504\u6B1D\u851A\u9C3B\u59E5\u53A9\u6D66\u74DC\u958F\u5642\u4E91\u904B\u96F2\u834F\u990C\u53E1\u55B6\u5B30\u5F71\u6620\u66F3\u6804\u6C38\u6CF3\u6D29\u745B\u76C8\u7A4E\u9834\u82F1\u885B\u8A60\u92ED\u6DB2\u75AB\u76CA\u99C5\u60A6\u8B01\u8D8A\u95B2\u698E\u53AD\u5186"],
    ["8980", "\u5712\u5830\u5944\u5BB4\u5EF6\u6028\u63A9\u63F4\u6CBF\u6F14\u708E\u7114\u7159\u71D5\u733F\u7E01\u8276\u82D1\u8597\u9060\u925B\u9D1B\u5869\u65BC\u6C5A\u7525\u51F9\u592E\u5965\u5F80\u5FDC\u62BC\u65FA\u6A2A\u6B27\u6BB4\u738B\u7FC1\u8956\u9D2C\u9D0E\u9EC4\u5CA1\u6C96\u837B\u5104\u5C4B\u61B6\u81C6\u6876\u7261\u4E59\u4FFA\u5378\u6069\u6E29\u7A4F\u97F3\u4E0B\u5316\u4EEE\u4F55\u4F3D\u4FA1\u4F73\u52A0\u53EF\u5609\u590F\u5AC1\u5BB6\u5BE1\u79D1\u6687\u679C\u67B6\u6B4C\u6CB3\u706B\u73C2\u798D\u79BE\u7A3C\u7B87\u82B1\u82DB\u8304\u8377\u83EF\u83D3\u8766\u8AB2\u5629\u8CA8\u8FE6\u904E\u971E\u868A\u4FC4\u5CE8\u6211\u7259\u753B\u81E5\u82BD\u86FE\u8CC0\u96C5\u9913\u99D5\u4ECB\u4F1A\u89E3\u56DE\u584A\u58CA\u5EFB\u5FEB\u602A\u6094\u6062\u61D0\u6212\u62D0\u6539"],
    ["8a40", "\u9B41\u6666\u68B0\u6D77\u7070\u754C\u7686\u7D75\u82A5\u87F9\u958B\u968E\u8C9D\u51F1\u52BE\u5916\u54B3\u5BB3\u5D16\u6168\u6982\u6DAF\u788D\u84CB\u8857\u8A72\u93A7\u9AB8\u6D6C\u99A8\u86D9\u57A3\u67FF\u86CE\u920E\u5283\u5687\u5404\u5ED3\u62E1\u64B9\u683C\u6838\u6BBB\u7372\u78BA\u7A6B\u899A\u89D2\u8D6B\u8F03\u90ED\u95A3\u9694\u9769\u5B66\u5CB3\u697D\u984D\u984E\u639B\u7B20\u6A2B"],
    ["8a80", "\u6A7F\u68B6\u9C0D\u6F5F\u5272\u559D\u6070\u62EC\u6D3B\u6E07\u6ED1\u845B\u8910\u8F44\u4E14\u9C39\u53F6\u691B\u6A3A\u9784\u682A\u515C\u7AC3\u84B2\u91DC\u938C\u565B\u9D28\u6822\u8305\u8431\u7CA5\u5208\u82C5\u74E6\u4E7E\u4F83\u51A0\u5BD2\u520A\u52D8\u52E7\u5DFB\u559A\u582A\u59E6\u5B8C\u5B98\u5BDB\u5E72\u5E79\u60A3\u611F\u6163\u61BE\u63DB\u6562\u67D1\u6853\u68FA\u6B3E\u6B53\u6C57\u6F22\u6F97\u6F45\u74B0\u7518\u76E3\u770B\u7AFF\u7BA1\u7C21\u7DE9\u7F36\u7FF0\u809D\u8266\u839E\u89B3\u8ACC\u8CAB\u9084\u9451\u9593\u9591\u95A2\u9665\u97D3\u9928\u8218\u4E38\u542B\u5CB8\u5DCC\u73A9\u764C\u773C\u5CA9\u7FEB\u8D0B\u96C1\u9811\u9854\u9858\u4F01\u4F0E\u5371\u559C\u5668\u57FA\u5947\u5B09\u5BC4\u5C90\u5E0C\u5E7E\u5FCC\u63EE\u673A\u65D7\u65E2\u671F\u68CB\u68C4"],
    ["8b40", "\u6A5F\u5E30\u6BC5\u6C17\u6C7D\u757F\u7948\u5B63\u7A00\u7D00\u5FBD\u898F\u8A18\u8CB4\u8D77\u8ECC\u8F1D\u98E2\u9A0E\u9B3C\u4E80\u507D\u5100\u5993\u5B9C\u622F\u6280\u64EC\u6B3A\u72A0\u7591\u7947\u7FA9\u87FB\u8ABC\u8B70\u63AC\u83CA\u97A0\u5409\u5403\u55AB\u6854\u6A58\u8A70\u7827\u6775\u9ECD\u5374\u5BA2\u811A\u8650\u9006\u4E18\u4E45\u4EC7\u4F11\u53CA\u5438\u5BAE\u5F13\u6025\u6551"],
    ["8b80", "\u673D\u6C42\u6C72\u6CE3\u7078\u7403\u7A76\u7AAE\u7B08\u7D1A\u7CFE\u7D66\u65E7\u725B\u53BB\u5C45\u5DE8\u62D2\u62E0\u6319\u6E20\u865A\u8A31\u8DDD\u92F8\u6F01\u79A6\u9B5A\u4EA8\u4EAB\u4EAC\u4F9B\u4FA0\u50D1\u5147\u7AF6\u5171\u51F6\u5354\u5321\u537F\u53EB\u55AC\u5883\u5CE1\u5F37\u5F4A\u602F\u6050\u606D\u631F\u6559\u6A4B\u6CC1\u72C2\u72ED\u77EF\u80F8\u8105\u8208\u854E\u90F7\u93E1\u97FF\u9957\u9A5A\u4EF0\u51DD\u5C2D\u6681\u696D\u5C40\u66F2\u6975\u7389\u6850\u7C81\u50C5\u52E4\u5747\u5DFE\u9326\u65A4\u6B23\u6B3D\u7434\u7981\u79BD\u7B4B\u7DCA\u82B9\u83CC\u887F\u895F\u8B39\u8FD1\u91D1\u541F\u9280\u4E5D\u5036\u53E5\u533A\u72D7\u7396\u77E9\u82E6\u8EAF\u99C6\u99C8\u99D2\u5177\u611A\u865E\u55B0\u7A7A\u5076\u5BD3\u9047\u9685\u4E32\u6ADB\u91E7\u5C51\u5C48"],
    ["8c40", "\u6398\u7A9F\u6C93\u9774\u8F61\u7AAA\u718A\u9688\u7C82\u6817\u7E70\u6851\u936C\u52F2\u541B\u85AB\u8A13\u7FA4\u8ECD\u90E1\u5366\u8888\u7941\u4FC2\u50BE\u5211\u5144\u5553\u572D\u73EA\u578B\u5951\u5F62\u5F84\u6075\u6176\u6167\u61A9\u63B2\u643A\u656C\u666F\u6842\u6E13\u7566\u7A3D\u7CFB\u7D4C\u7D99\u7E4B\u7F6B\u830E\u834A\u86CD\u8A08\u8A63\u8B66\u8EFD\u981A\u9D8F\u82B8\u8FCE\u9BE8"],
    ["8c80", "\u5287\u621F\u6483\u6FC0\u9699\u6841\u5091\u6B20\u6C7A\u6F54\u7A74\u7D50\u8840\u8A23\u6708\u4EF6\u5039\u5026\u5065\u517C\u5238\u5263\u55A7\u570F\u5805\u5ACC\u5EFA\u61B2\u61F8\u62F3\u6372\u691C\u6A29\u727D\u72AC\u732E\u7814\u786F\u7D79\u770C\u80A9\u898B\u8B19\u8CE2\u8ED2\u9063\u9375\u967A\u9855\u9A13\u9E78\u5143\u539F\u53B3\u5E7B\u5F26\u6E1B\u6E90\u7384\u73FE\u7D43\u8237\u8A00\u8AFA\u9650\u4E4E\u500B\u53E4\u547C\u56FA\u59D1\u5B64\u5DF1\u5EAB\u5F27\u6238\u6545\u67AF\u6E56\u72D0\u7CCA\u88B4\u80A1\u80E1\u83F0\u864E\u8A87\u8DE8\u9237\u96C7\u9867\u9F13\u4E94\u4E92\u4F0D\u5348\u5449\u543E\u5A2F\u5F8C\u5FA1\u609F\u68A7\u6A8E\u745A\u7881\u8A9E\u8AA4\u8B77\u9190\u4E5E\u9BC9\u4EA4\u4F7C\u4FAF\u5019\u5016\u5149\u516C\u529F\u52B9\u52FE\u539A\u53E3\u5411"],
    ["8d40", "\u540E\u5589\u5751\u57A2\u597D\u5B54\u5B5D\u5B8F\u5DE5\u5DE7\u5DF7\u5E78\u5E83\u5E9A\u5EB7\u5F18\u6052\u614C\u6297\u62D8\u63A7\u653B\u6602\u6643\u66F4\u676D\u6821\u6897\u69CB\u6C5F\u6D2A\u6D69\u6E2F\u6E9D\u7532\u7687\u786C\u7A3F\u7CE0\u7D05\u7D18\u7D5E\u7DB1\u8015\u8003\u80AF\u80B1\u8154\u818F\u822A\u8352\u884C\u8861\u8B1B\u8CA2\u8CFC\u90CA\u9175\u9271\u783F\u92FC\u95A4\u964D"],
    ["8d80", "\u9805\u9999\u9AD8\u9D3B\u525B\u52AB\u53F7\u5408\u58D5\u62F7\u6FE0\u8C6A\u8F5F\u9EB9\u514B\u523B\u544A\u56FD\u7A40\u9177\u9D60\u9ED2\u7344\u6F09\u8170\u7511\u5FFD\u60DA\u9AA8\u72DB\u8FBC\u6B64\u9803\u4ECA\u56F0\u5764\u58BE\u5A5A\u6068\u61C7\u660F\u6606\u6839\u68B1\u6DF7\u75D5\u7D3A\u826E\u9B42\u4E9B\u4F50\u53C9\u5506\u5D6F\u5DE6\u5DEE\u67FB\u6C99\u7473\u7802\u8A50\u9396\u88DF\u5750\u5EA7\u632B\u50B5\u50AC\u518D\u6700\u54C9\u585E\u59BB\u5BB0\u5F69\u624D\u63A1\u683D\u6B73\u6E08\u707D\u91C7\u7280\u7815\u7826\u796D\u658E\u7D30\u83DC\u88C1\u8F09\u969B\u5264\u5728\u6750\u7F6A\u8CA1\u51B4\u5742\u962A\u583A\u698A\u80B4\u54B2\u5D0E\u57FC\u7895\u9DFA\u4F5C\u524A\u548B\u643E\u6628\u6714\u67F5\u7A84\u7B56\u7D22\u932F\u685C\u9BAD\u7B39\u5319\u518A\u5237"],
    ["8e40", "\u5BDF\u62F6\u64AE\u64E6\u672D\u6BBA\u85A9\u96D1\u7690\u9BD6\u634C\u9306\u9BAB\u76BF\u6652\u4E09\u5098\u53C2\u5C71\u60E8\u6492\u6563\u685F\u71E6\u73CA\u7523\u7B97\u7E82\u8695\u8B83\u8CDB\u9178\u9910\u65AC\u66AB\u6B8B\u4ED5\u4ED4\u4F3A\u4F7F\u523A\u53F8\u53F2\u55E3\u56DB\u58EB\u59CB\u59C9\u59FF\u5B50\u5C4D\u5E02\u5E2B\u5FD7\u601D\u6307\u652F\u5B5C\u65AF\u65BD\u65E8\u679D\u6B62"],
    ["8e80", "\u6B7B\u6C0F\u7345\u7949\u79C1\u7CF8\u7D19\u7D2B\u80A2\u8102\u81F3\u8996\u8A5E\u8A69\u8A66\u8A8C\u8AEE\u8CC7\u8CDC\u96CC\u98FC\u6B6F\u4E8B\u4F3C\u4F8D\u5150\u5B57\u5BFA\u6148\u6301\u6642\u6B21\u6ECB\u6CBB\u723E\u74BD\u75D4\u78C1\u793A\u800C\u8033\u81EA\u8494\u8F9E\u6C50\u9E7F\u5F0F\u8B58\u9D2B\u7AFA\u8EF8\u5B8D\u96EB\u4E03\u53F1\u57F7\u5931\u5AC9\u5BA4\u6089\u6E7F\u6F06\u75BE\u8CEA\u5B9F\u8500\u7BE0\u5072\u67F4\u829D\u5C61\u854A\u7E1E\u820E\u5199\u5C04\u6368\u8D66\u659C\u716E\u793E\u7D17\u8005\u8B1D\u8ECA\u906E\u86C7\u90AA\u501F\u52FA\u5C3A\u6753\u707C\u7235\u914C\u91C8\u932B\u82E5\u5BC2\u5F31\u60F9\u4E3B\u53D6\u5B88\u624B\u6731\u6B8A\u72E9\u73E0\u7A2E\u816B\u8DA3\u9152\u9996\u5112\u53D7\u546A\u5BFF\u6388\u6A39\u7DAC\u9700\u56DA\u53CE\u5468"],
    ["8f40", "\u5B97\u5C31\u5DDE\u4FEE\u6101\u62FE\u6D32\u79C0\u79CB\u7D42\u7E4D\u7FD2\u81ED\u821F\u8490\u8846\u8972\u8B90\u8E74\u8F2F\u9031\u914B\u916C\u96C6\u919C\u4EC0\u4F4F\u5145\u5341\u5F93\u620E\u67D4\u6C41\u6E0B\u7363\u7E26\u91CD\u9283\u53D4\u5919\u5BBF\u6DD1\u795D\u7E2E\u7C9B\u587E\u719F\u51FA\u8853\u8FF0\u4FCA\u5CFB\u6625\u77AC\u7AE3\u821C\u99FF\u51C6\u5FAA\u65EC\u696F\u6B89\u6DF3"],
    ["8f80", "\u6E96\u6F64\u76FE\u7D14\u5DE1\u9075\u9187\u9806\u51E6\u521D\u6240\u6691\u66D9\u6E1A\u5EB6\u7DD2\u7F72\u66F8\u85AF\u85F7\u8AF8\u52A9\u53D9\u5973\u5E8F\u5F90\u6055\u92E4\u9664\u50B7\u511F\u52DD\u5320\u5347\u53EC\u54E8\u5546\u5531\u5617\u5968\u59BE\u5A3C\u5BB5\u5C06\u5C0F\u5C11\u5C1A\u5E84\u5E8A\u5EE0\u5F70\u627F\u6284\u62DB\u638C\u6377\u6607\u660C\u662D\u6676\u677E\u68A2\u6A1F\u6A35\u6CBC\u6D88\u6E09\u6E58\u713C\u7126\u7167\u75C7\u7701\u785D\u7901\u7965\u79F0\u7AE0\u7B11\u7CA7\u7D39\u8096\u83D6\u848B\u8549\u885D\u88F3\u8A1F\u8A3C\u8A54\u8A73\u8C61\u8CDE\u91A4\u9266\u937E\u9418\u969C\u9798\u4E0A\u4E08\u4E1E\u4E57\u5197\u5270\u57CE\u5834\u58CC\u5B22\u5E38\u60C5\u64FE\u6761\u6756\u6D44\u72B6\u7573\u7A63\u84B8\u8B72\u91B8\u9320\u5631\u57F4\u98FE"],
    ["9040", "\u62ED\u690D\u6B96\u71ED\u7E54\u8077\u8272\u89E6\u98DF\u8755\u8FB1\u5C3B\u4F38\u4FE1\u4FB5\u5507\u5A20\u5BDD\u5BE9\u5FC3\u614E\u632F\u65B0\u664B\u68EE\u699B\u6D78\u6DF1\u7533\u75B9\u771F\u795E\u79E6\u7D33\u81E3\u82AF\u85AA\u89AA\u8A3A\u8EAB\u8F9B\u9032\u91DD\u9707\u4EBA\u4EC1\u5203\u5875\u58EC\u5C0B\u751A\u5C3D\u814E\u8A0A\u8FC5\u9663\u976D\u7B25\u8ACF\u9808\u9162\u56F3\u53A8"],
    ["9080", "\u9017\u5439\u5782\u5E25\u63A8\u6C34\u708A\u7761\u7C8B\u7FE0\u8870\u9042\u9154\u9310\u9318\u968F\u745E\u9AC4\u5D07\u5D69\u6570\u67A2\u8DA8\u96DB\u636E\u6749\u6919\u83C5\u9817\u96C0\u88FE\u6F84\u647A\u5BF8\u4E16\u702C\u755D\u662F\u51C4\u5236\u52E2\u59D3\u5F81\u6027\u6210\u653F\u6574\u661F\u6674\u68F2\u6816\u6B63\u6E05\u7272\u751F\u76DB\u7CBE\u8056\u58F0\u88FD\u897F\u8AA0\u8A93\u8ACB\u901D\u9192\u9752\u9759\u6589\u7A0E\u8106\u96BB\u5E2D\u60DC\u621A\u65A5\u6614\u6790\u77F3\u7A4D\u7C4D\u7E3E\u810A\u8CAC\u8D64\u8DE1\u8E5F\u78A9\u5207\u62D9\u63A5\u6442\u6298\u8A2D\u7A83\u7BC0\u8AAC\u96EA\u7D76\u820C\u8749\u4ED9\u5148\u5343\u5360\u5BA3\u5C02\u5C16\u5DDD\u6226\u6247\u64B0\u6813\u6834\u6CC9\u6D45\u6D17\u67D3\u6F5C\u714E\u717D\u65CB\u7A7F\u7BAD\u7DDA"],
    ["9140", "\u7E4A\u7FA8\u817A\u821B\u8239\u85A6\u8A6E\u8CCE\u8DF5\u9078\u9077\u92AD\u9291\u9583\u9BAE\u524D\u5584\u6F38\u7136\u5168\u7985\u7E55\u81B3\u7CCE\u564C\u5851\u5CA8\u63AA\u66FE\u66FD\u695A\u72D9\u758F\u758E\u790E\u7956\u79DF\u7C97\u7D20\u7D44\u8607\u8A34\u963B\u9061\u9F20\u50E7\u5275\u53CC\u53E2\u5009\u55AA\u58EE\u594F\u723D\u5B8B\u5C64\u531D\u60E3\u60F3\u635C\u6383\u633F\u63BB"],
    ["9180", "\u64CD\u65E9\u66F9\u5DE3\u69CD\u69FD\u6F15\u71E5\u4E89\u75E9\u76F8\u7A93\u7CDF\u7DCF\u7D9C\u8061\u8349\u8358\u846C\u84BC\u85FB\u88C5\u8D70\u9001\u906D\u9397\u971C\u9A12\u50CF\u5897\u618E\u81D3\u8535\u8D08\u9020\u4FC3\u5074\u5247\u5373\u606F\u6349\u675F\u6E2C\u8DB3\u901F\u4FD7\u5C5E\u8CCA\u65CF\u7D9A\u5352\u8896\u5176\u63C3\u5B58\u5B6B\u5C0A\u640D\u6751\u905C\u4ED6\u591A\u592A\u6C70\u8A51\u553E\u5815\u59A5\u60F0\u6253\u67C1\u8235\u6955\u9640\u99C4\u9A28\u4F53\u5806\u5BFE\u8010\u5CB1\u5E2F\u5F85\u6020\u614B\u6234\u66FF\u6CF0\u6EDE\u80CE\u817F\u82D4\u888B\u8CB8\u9000\u902E\u968A\u9EDB\u9BDB\u4EE3\u53F0\u5927\u7B2C\u918D\u984C\u9DF9\u6EDD\u7027\u5353\u5544\u5B85\u6258\u629E\u62D3\u6CA2\u6FEF\u7422\u8A17\u9438\u6FC1\u8AFE\u8338\u51E7\u86F8\u53EA"],
    ["9240", "\u53E9\u4F46\u9054\u8FB0\u596A\u8131\u5DFD\u7AEA\u8FBF\u68DA\u8C37\u72F8\u9C48\u6A3D\u8AB0\u4E39\u5358\u5606\u5766\u62C5\u63A2\u65E6\u6B4E\u6DE1\u6E5B\u70AD\u77ED\u7AEF\u7BAA\u7DBB\u803D\u80C6\u86CB\u8A95\u935B\u56E3\u58C7\u5F3E\u65AD\u6696\u6A80\u6BB5\u7537\u8AC7\u5024\u77E5\u5730\u5F1B\u6065\u667A\u6C60\u75F4\u7A1A\u7F6E\u81F4\u8718\u9045\u99B3\u7BC9\u755C\u7AF9\u7B51\u84C4"],
    ["9280", "\u9010\u79E9\u7A92\u8336\u5AE1\u7740\u4E2D\u4EF2\u5B99\u5FE0\u62BD\u663C\u67F1\u6CE8\u866B\u8877\u8A3B\u914E\u92F3\u99D0\u6A17\u7026\u732A\u82E7\u8457\u8CAF\u4E01\u5146\u51CB\u558B\u5BF5\u5E16\u5E33\u5E81\u5F14\u5F35\u5F6B\u5FB4\u61F2\u6311\u66A2\u671D\u6F6E\u7252\u753A\u773A\u8074\u8139\u8178\u8776\u8ABF\u8ADC\u8D85\u8DF3\u929A\u9577\u9802\u9CE5\u52C5\u6357\u76F4\u6715\u6C88\u73CD\u8CC3\u93AE\u9673\u6D25\u589C\u690E\u69CC\u8FFD\u939A\u75DB\u901A\u585A\u6802\u63B4\u69FB\u4F43\u6F2C\u67D8\u8FBB\u8526\u7DB4\u9354\u693F\u6F70\u576A\u58F7\u5B2C\u7D2C\u722A\u540A\u91E3\u9DB4\u4EAD\u4F4E\u505C\u5075\u5243\u8C9E\u5448\u5824\u5B9A\u5E1D\u5E95\u5EAD\u5EF7\u5F1F\u608C\u62B5\u633A\u63D0\u68AF\u6C40\u7887\u798E\u7A0B\u7DE0\u8247\u8A02\u8AE6\u8E44\u9013"],
    ["9340", "\u90B8\u912D\u91D8\u9F0E\u6CE5\u6458\u64E2\u6575\u6EF4\u7684\u7B1B\u9069\u93D1\u6EBA\u54F2\u5FB9\u64A4\u8F4D\u8FED\u9244\u5178\u586B\u5929\u5C55\u5E97\u6DFB\u7E8F\u751C\u8CBC\u8EE2\u985B\u70B9\u4F1D\u6BBF\u6FB1\u7530\u96FB\u514E\u5410\u5835\u5857\u59AC\u5C60\u5F92\u6597\u675C\u6E21\u767B\u83DF\u8CED\u9014\u90FD\u934D\u7825\u783A\u52AA\u5EA6\u571F\u5974\u6012\u5012\u515A\u51AC"],
    ["9380", "\u51CD\u5200\u5510\u5854\u5858\u5957\u5B95\u5CF6\u5D8B\u60BC\u6295\u642D\u6771\u6843\u68BC\u68DF\u76D7\u6DD8\u6E6F\u6D9B\u706F\u71C8\u5F53\u75D8\u7977\u7B49\u7B54\u7B52\u7CD6\u7D71\u5230\u8463\u8569\u85E4\u8A0E\u8B04\u8C46\u8E0F\u9003\u900F\u9419\u9676\u982D\u9A30\u95D8\u50CD\u52D5\u540C\u5802\u5C0E\u61A7\u649E\u6D1E\u77B3\u7AE5\u80F4\u8404\u9053\u9285\u5CE0\u9D07\u533F\u5F97\u5FB3\u6D9C\u7279\u7763\u79BF\u7BE4\u6BD2\u72EC\u8AAD\u6803\u6A61\u51F8\u7A81\u6934\u5C4A\u9CF6\u82EB\u5BC5\u9149\u701E\u5678\u5C6F\u60C7\u6566\u6C8C\u8C5A\u9041\u9813\u5451\u66C7\u920D\u5948\u90A3\u5185\u4E4D\u51EA\u8599\u8B0E\u7058\u637A\u934B\u6962\u99B4\u7E04\u7577\u5357\u6960\u8EDF\u96E3\u6C5D\u4E8C\u5C3C\u5F10\u8FE9\u5302\u8CD1\u8089\u8679\u5EFF\u65E5\u4E73\u5165"],
    ["9440", "\u5982\u5C3F\u97EE\u4EFB\u598A\u5FCD\u8A8D\u6FE1\u79B0\u7962\u5BE7\u8471\u732B\u71B1\u5E74\u5FF5\u637B\u649A\u71C3\u7C98\u4E43\u5EFC\u4E4B\u57DC\u56A2\u60A9\u6FC3\u7D0D\u80FD\u8133\u81BF\u8FB2\u8997\u86A4\u5DF4\u628A\u64AD\u8987\u6777\u6CE2\u6D3E\u7436\u7834\u5A46\u7F75\u82AD\u99AC\u4FF3\u5EC3\u62DD\u6392\u6557\u676F\u76C3\u724C\u80CC\u80BA\u8F29\u914D\u500D\u57F9\u5A92\u6885"],
    ["9480", "\u6973\u7164\u72FD\u8CB7\u58F2\u8CE0\u966A\u9019\u877F\u79E4\u77E7\u8429\u4F2F\u5265\u535A\u62CD\u67CF\u6CCA\u767D\u7B94\u7C95\u8236\u8584\u8FEB\u66DD\u6F20\u7206\u7E1B\u83AB\u99C1\u9EA6\u51FD\u7BB1\u7872\u7BB8\u8087\u7B48\u6AE8\u5E61\u808C\u7551\u7560\u516B\u9262\u6E8C\u767A\u9197\u9AEA\u4F10\u7F70\u629C\u7B4F\u95A5\u9CE9\u567A\u5859\u86E4\u96BC\u4F34\u5224\u534A\u53CD\u53DB\u5E06\u642C\u6591\u677F\u6C3E\u6C4E\u7248\u72AF\u73ED\u7554\u7E41\u822C\u85E9\u8CA9\u7BC4\u91C6\u7169\u9812\u98EF\u633D\u6669\u756A\u76E4\u78D0\u8543\u86EE\u532A\u5351\u5426\u5983\u5E87\u5F7C\u60B2\u6249\u6279\u62AB\u6590\u6BD4\u6CCC\u75B2\u76AE\u7891\u79D8\u7DCB\u7F77\u80A5\u88AB\u8AB9\u8CBB\u907F\u975E\u98DB\u6A0B\u7C38\u5099\u5C3E\u5FAE\u6787\u6BD8\u7435\u7709\u7F8E"],
    ["9540", "\u9F3B\u67CA\u7A17\u5339\u758B\u9AED\u5F66\u819D\u83F1\u8098\u5F3C\u5FC5\u7562\u7B46\u903C\u6867\u59EB\u5A9B\u7D10\u767E\u8B2C\u4FF5\u5F6A\u6A19\u6C37\u6F02\u74E2\u7968\u8868\u8A55\u8C79\u5EDF\u63CF\u75C5\u79D2\u82D7\u9328\u92F2\u849C\u86ED\u9C2D\u54C1\u5F6C\u658C\u6D5C\u7015\u8CA7\u8CD3\u983B\u654F\u74F6\u4E0D\u4ED8\u57E0\u592B\u5A66\u5BCC\u51A8\u5E03\u5E9C\u6016\u6276\u6577"],
    ["9580", "\u65A7\u666E\u6D6E\u7236\u7B26\u8150\u819A\u8299\u8B5C\u8CA0\u8CE6\u8D74\u961C\u9644\u4FAE\u64AB\u6B66\u821E\u8461\u856A\u90E8\u5C01\u6953\u98A8\u847A\u8557\u4F0F\u526F\u5FA9\u5E45\u670D\u798F\u8179\u8907\u8986\u6DF5\u5F17\u6255\u6CB8\u4ECF\u7269\u9B92\u5206\u543B\u5674\u58B3\u61A4\u626E\u711A\u596E\u7C89\u7CDE\u7D1B\u96F0\u6587\u805E\u4E19\u4F75\u5175\u5840\u5E63\u5E73\u5F0A\u67C4\u4E26\u853D\u9589\u965B\u7C73\u9801\u50FB\u58C1\u7656\u78A7\u5225\u77A5\u8511\u7B86\u504F\u5909\u7247\u7BC7\u7DE8\u8FBA\u8FD4\u904D\u4FBF\u52C9\u5A29\u5F01\u97AD\u4FDD\u8217\u92EA\u5703\u6355\u6B69\u752B\u88DC\u8F14\u7A42\u52DF\u5893\u6155\u620A\u66AE\u6BCD\u7C3F\u83E9\u5023\u4FF8\u5305\u5446\u5831\u5949\u5B9D\u5CF0\u5CEF\u5D29\u5E96\u62B1\u6367\u653E\u65B9\u670B"],
    ["9640", "\u6CD5\u6CE1\u70F9\u7832\u7E2B\u80DE\u82B3\u840C\u84EC\u8702\u8912\u8A2A\u8C4A\u90A6\u92D2\u98FD\u9CF3\u9D6C\u4E4F\u4EA1\u508D\u5256\u574A\u59A8\u5E3D\u5FD8\u5FD9\u623F\u66B4\u671B\u67D0\u68D2\u5192\u7D21\u80AA\u81A8\u8B00\u8C8C\u8CBF\u927E\u9632\u5420\u982C\u5317\u50D5\u535C\u58A8\u64B2\u6734\u7267\u7766\u7A46\u91E6\u52C3\u6CA1\u6B86\u5800\u5E4C\u5954\u672C\u7FFB\u51E1\u76C6"],
    ["9680", "\u6469\u78E8\u9B54\u9EBB\u57CB\u59B9\u6627\u679A\u6BCE\u54E9\u69D9\u5E55\u819C\u6795\u9BAA\u67FE\u9C52\u685D\u4EA6\u4FE3\u53C8\u62B9\u672B\u6CAB\u8FC4\u4FAD\u7E6D\u9EBF\u4E07\u6162\u6E80\u6F2B\u8513\u5473\u672A\u9B45\u5DF3\u7B95\u5CAC\u5BC6\u871C\u6E4A\u84D1\u7A14\u8108\u5999\u7C8D\u6C11\u7720\u52D9\u5922\u7121\u725F\u77DB\u9727\u9D61\u690B\u5A7F\u5A18\u51A5\u540D\u547D\u660E\u76DF\u8FF7\u9298\u9CF4\u59EA\u725D\u6EC5\u514D\u68C9\u7DBF\u7DEC\u9762\u9EBA\u6478\u6A21\u8302\u5984\u5B5F\u6BDB\u731B\u76F2\u7DB2\u8017\u8499\u5132\u6728\u9ED9\u76EE\u6762\u52FF\u9905\u5C24\u623B\u7C7E\u8CB0\u554F\u60B6\u7D0B\u9580\u5301\u4E5F\u51B6\u591C\u723A\u8036\u91CE\u5F25\u77E2\u5384\u5F79\u7D04\u85AC\u8A33\u8E8D\u9756\u67F3\u85AE\u9453\u6109\u6108\u6CB9\u7652"],
    ["9740", "\u8AED\u8F38\u552F\u4F51\u512A\u52C7\u53CB\u5BA5\u5E7D\u60A0\u6182\u63D6\u6709\u67DA\u6E67\u6D8C\u7336\u7337\u7531\u7950\u88D5\u8A98\u904A\u9091\u90F5\u96C4\u878D\u5915\u4E88\u4F59\u4E0E\u8A89\u8F3F\u9810\u50AD\u5E7C\u5996\u5BB9\u5EB8\u63DA\u63FA\u64C1\u66DC\u694A\u69D8\u6D0B\u6EB6\u7194\u7528\u7AAF\u7F8A\u8000\u8449\u84C9\u8981\u8B21\u8E0A\u9065\u967D\u990A\u617E\u6291\u6B32"],
    ["9780", "\u6C83\u6D74\u7FCC\u7FFC\u6DC0\u7F85\u87BA\u88F8\u6765\u83B1\u983C\u96F7\u6D1B\u7D61\u843D\u916A\u4E71\u5375\u5D50\u6B04\u6FEB\u85CD\u862D\u89A7\u5229\u540F\u5C65\u674E\u68A8\u7406\u7483\u75E2\u88CF\u88E1\u91CC\u96E2\u9678\u5F8B\u7387\u7ACB\u844E\u63A0\u7565\u5289\u6D41\u6E9C\u7409\u7559\u786B\u7C92\u9686\u7ADC\u9F8D\u4FB6\u616E\u65C5\u865C\u4E86\u4EAE\u50DA\u4E21\u51CC\u5BEE\u6599\u6881\u6DBC\u731F\u7642\u77AD\u7A1C\u7CE7\u826F\u8AD2\u907C\u91CF\u9675\u9818\u529B\u7DD1\u502B\u5398\u6797\u6DCB\u71D0\u7433\u81E8\u8F2A\u96A3\u9C57\u9E9F\u7460\u5841\u6D99\u7D2F\u985E\u4EE4\u4F36\u4F8B\u51B7\u52B1\u5DBA\u601C\u73B2\u793C\u82D3\u9234\u96B7\u96F6\u970A\u9E97\u9F62\u66A6\u6B74\u5217\u52A3\u70C8\u88C2\u5EC9\u604B\u6190\u6F23\u7149\u7C3E\u7DF4\u806F"],
    ["9840", "\u84EE\u9023\u932C\u5442\u9B6F\u6AD3\u7089\u8CC2\u8DEF\u9732\u52B4\u5A41\u5ECA\u5F04\u6717\u697C\u6994\u6D6A\u6F0F\u7262\u72FC\u7BED\u8001\u807E\u874B\u90CE\u516D\u9E93\u7984\u808B\u9332\u8AD6\u502D\u548C\u8A71\u6B6A\u8CC4\u8107\u60D1\u67A0\u9DF2\u4E99\u4E98\u9C10\u8A6B\u85C1\u8568\u6900\u6E7E\u7897\u8155"],
    ["989f", "\u5F0C\u4E10\u4E15\u4E2A\u4E31\u4E36\u4E3C\u4E3F\u4E42\u4E56\u4E58\u4E82\u4E85\u8C6B\u4E8A\u8212\u5F0D\u4E8E\u4E9E\u4E9F\u4EA0\u4EA2\u4EB0\u4EB3\u4EB6\u4ECE\u4ECD\u4EC4\u4EC6\u4EC2\u4ED7\u4EDE\u4EED\u4EDF\u4EF7\u4F09\u4F5A\u4F30\u4F5B\u4F5D\u4F57\u4F47\u4F76\u4F88\u4F8F\u4F98\u4F7B\u4F69\u4F70\u4F91\u4F6F\u4F86\u4F96\u5118\u4FD4\u4FDF\u4FCE\u4FD8\u4FDB\u4FD1\u4FDA\u4FD0\u4FE4\u4FE5\u501A\u5028\u5014\u502A\u5025\u5005\u4F1C\u4FF6\u5021\u5029\u502C\u4FFE\u4FEF\u5011\u5006\u5043\u5047\u6703\u5055\u5050\u5048\u505A\u5056\u506C\u5078\u5080\u509A\u5085\u50B4\u50B2"],
    ["9940", "\u50C9\u50CA\u50B3\u50C2\u50D6\u50DE\u50E5\u50ED\u50E3\u50EE\u50F9\u50F5\u5109\u5101\u5102\u5116\u5115\u5114\u511A\u5121\u513A\u5137\u513C\u513B\u513F\u5140\u5152\u514C\u5154\u5162\u7AF8\u5169\u516A\u516E\u5180\u5182\u56D8\u518C\u5189\u518F\u5191\u5193\u5195\u5196\u51A4\u51A6\u51A2\u51A9\u51AA\u51AB\u51B3\u51B1\u51B2\u51B0\u51B5\u51BD\u51C5\u51C9\u51DB\u51E0\u8655\u51E9\u51ED"],
    ["9980", "\u51F0\u51F5\u51FE\u5204\u520B\u5214\u520E\u5227\u522A\u522E\u5233\u5239\u524F\u5244\u524B\u524C\u525E\u5254\u526A\u5274\u5269\u5273\u527F\u527D\u528D\u5294\u5292\u5271\u5288\u5291\u8FA8\u8FA7\u52AC\u52AD\u52BC\u52B5\u52C1\u52CD\u52D7\u52DE\u52E3\u52E6\u98ED\u52E0\u52F3\u52F5\u52F8\u52F9\u5306\u5308\u7538\u530D\u5310\u530F\u5315\u531A\u5323\u532F\u5331\u5333\u5338\u5340\u5346\u5345\u4E17\u5349\u534D\u51D6\u535E\u5369\u536E\u5918\u537B\u5377\u5382\u5396\u53A0\u53A6\u53A5\u53AE\u53B0\u53B6\u53C3\u7C12\u96D9\u53DF\u66FC\u71EE\u53EE\u53E8\u53ED\u53FA\u5401\u543D\u5440\u542C\u542D\u543C\u542E\u5436\u5429\u541D\u544E\u548F\u5475\u548E\u545F\u5471\u5477\u5470\u5492\u547B\u5480\u5476\u5484\u5490\u5486\u54C7\u54A2\u54B8\u54A5\u54AC\u54C4\u54C8\u54A8"],
    ["9a40", "\u54AB\u54C2\u54A4\u54BE\u54BC\u54D8\u54E5\u54E6\u550F\u5514\u54FD\u54EE\u54ED\u54FA\u54E2\u5539\u5540\u5563\u554C\u552E\u555C\u5545\u5556\u5557\u5538\u5533\u555D\u5599\u5580\u54AF\u558A\u559F\u557B\u557E\u5598\u559E\u55AE\u557C\u5583\u55A9\u5587\u55A8\u55DA\u55C5\u55DF\u55C4\u55DC\u55E4\u55D4\u5614\u55F7\u5616\u55FE\u55FD\u561B\u55F9\u564E\u5650\u71DF\u5634\u5636\u5632\u5638"],
    ["9a80", "\u566B\u5664\u562F\u566C\u566A\u5686\u5680\u568A\u56A0\u5694\u568F\u56A5\u56AE\u56B6\u56B4\u56C2\u56BC\u56C1\u56C3\u56C0\u56C8\u56CE\u56D1\u56D3\u56D7\u56EE\u56F9\u5700\u56FF\u5704\u5709\u5708\u570B\u570D\u5713\u5718\u5716\u55C7\u571C\u5726\u5737\u5738\u574E\u573B\u5740\u574F\u5769\u57C0\u5788\u5761\u577F\u5789\u5793\u57A0\u57B3\u57A4\u57AA\u57B0\u57C3\u57C6\u57D4\u57D2\u57D3\u580A\u57D6\u57E3\u580B\u5819\u581D\u5872\u5821\u5862\u584B\u5870\u6BC0\u5852\u583D\u5879\u5885\u58B9\u589F\u58AB\u58BA\u58DE\u58BB\u58B8\u58AE\u58C5\u58D3\u58D1\u58D7\u58D9\u58D8\u58E5\u58DC\u58E4\u58DF\u58EF\u58FA\u58F9\u58FB\u58FC\u58FD\u5902\u590A\u5910\u591B\u68A6\u5925\u592C\u592D\u5932\u5938\u593E\u7AD2\u5955\u5950\u594E\u595A\u5958\u5962\u5960\u5967\u596C\u5969"],
    ["9b40", "\u5978\u5981\u599D\u4F5E\u4FAB\u59A3\u59B2\u59C6\u59E8\u59DC\u598D\u59D9\u59DA\u5A25\u5A1F\u5A11\u5A1C\u5A09\u5A1A\u5A40\u5A6C\u5A49\u5A35\u5A36\u5A62\u5A6A\u5A9A\u5ABC\u5ABE\u5ACB\u5AC2\u5ABD\u5AE3\u5AD7\u5AE6\u5AE9\u5AD6\u5AFA\u5AFB\u5B0C\u5B0B\u5B16\u5B32\u5AD0\u5B2A\u5B36\u5B3E\u5B43\u5B45\u5B40\u5B51\u5B55\u5B5A\u5B5B\u5B65\u5B69\u5B70\u5B73\u5B75\u5B78\u6588\u5B7A\u5B80"],
    ["9b80", "\u5B83\u5BA6\u5BB8\u5BC3\u5BC7\u5BC9\u5BD4\u5BD0\u5BE4\u5BE6\u5BE2\u5BDE\u5BE5\u5BEB\u5BF0\u5BF6\u5BF3\u5C05\u5C07\u5C08\u5C0D\u5C13\u5C20\u5C22\u5C28\u5C38\u5C39\u5C41\u5C46\u5C4E\u5C53\u5C50\u5C4F\u5B71\u5C6C\u5C6E\u4E62\u5C76\u5C79\u5C8C\u5C91\u5C94\u599B\u5CAB\u5CBB\u5CB6\u5CBC\u5CB7\u5CC5\u5CBE\u5CC7\u5CD9\u5CE9\u5CFD\u5CFA\u5CED\u5D8C\u5CEA\u5D0B\u5D15\u5D17\u5D5C\u5D1F\u5D1B\u5D11\u5D14\u5D22\u5D1A\u5D19\u5D18\u5D4C\u5D52\u5D4E\u5D4B\u5D6C\u5D73\u5D76\u5D87\u5D84\u5D82\u5DA2\u5D9D\u5DAC\u5DAE\u5DBD\u5D90\u5DB7\u5DBC\u5DC9\u5DCD\u5DD3\u5DD2\u5DD6\u5DDB\u5DEB\u5DF2\u5DF5\u5E0B\u5E1A\u5E19\u5E11\u5E1B\u5E36\u5E37\u5E44\u5E43\u5E40\u5E4E\u5E57\u5E54\u5E5F\u5E62\u5E64\u5E47\u5E75\u5E76\u5E7A\u9EBC\u5E7F\u5EA0\u5EC1\u5EC2\u5EC8\u5ED0\u5ECF"],
    ["9c40", "\u5ED6\u5EE3\u5EDD\u5EDA\u5EDB\u5EE2\u5EE1\u5EE8\u5EE9\u5EEC\u5EF1\u5EF3\u5EF0\u5EF4\u5EF8\u5EFE\u5F03\u5F09\u5F5D\u5F5C\u5F0B\u5F11\u5F16\u5F29\u5F2D\u5F38\u5F41\u5F48\u5F4C\u5F4E\u5F2F\u5F51\u5F56\u5F57\u5F59\u5F61\u5F6D\u5F73\u5F77\u5F83\u5F82\u5F7F\u5F8A\u5F88\u5F91\u5F87\u5F9E\u5F99\u5F98\u5FA0\u5FA8\u5FAD\u5FBC\u5FD6\u5FFB\u5FE4\u5FF8\u5FF1\u5FDD\u60B3\u5FFF\u6021\u6060"],
    ["9c80", "\u6019\u6010\u6029\u600E\u6031\u601B\u6015\u602B\u6026\u600F\u603A\u605A\u6041\u606A\u6077\u605F\u604A\u6046\u604D\u6063\u6043\u6064\u6042\u606C\u606B\u6059\u6081\u608D\u60E7\u6083\u609A\u6084\u609B\u6096\u6097\u6092\u60A7\u608B\u60E1\u60B8\u60E0\u60D3\u60B4\u5FF0\u60BD\u60C6\u60B5\u60D8\u614D\u6115\u6106\u60F6\u60F7\u6100\u60F4\u60FA\u6103\u6121\u60FB\u60F1\u610D\u610E\u6147\u613E\u6128\u6127\u614A\u613F\u613C\u612C\u6134\u613D\u6142\u6144\u6173\u6177\u6158\u6159\u615A\u616B\u6174\u616F\u6165\u6171\u615F\u615D\u6153\u6175\u6199\u6196\u6187\u61AC\u6194\u619A\u618A\u6191\u61AB\u61AE\u61CC\u61CA\u61C9\u61F7\u61C8\u61C3\u61C6\u61BA\u61CB\u7F79\u61CD\u61E6\u61E3\u61F6\u61FA\u61F4\u61FF\u61FD\u61FC\u61FE\u6200\u6208\u6209\u620D\u620C\u6214\u621B"],
    ["9d40", "\u621E\u6221\u622A\u622E\u6230\u6232\u6233\u6241\u624E\u625E\u6263\u625B\u6260\u6268\u627C\u6282\u6289\u627E\u6292\u6293\u6296\u62D4\u6283\u6294\u62D7\u62D1\u62BB\u62CF\u62FF\u62C6\u64D4\u62C8\u62DC\u62CC\u62CA\u62C2\u62C7\u629B\u62C9\u630C\u62EE\u62F1\u6327\u6302\u6308\u62EF\u62F5\u6350\u633E\u634D\u641C\u634F\u6396\u638E\u6380\u63AB\u6376\u63A3\u638F\u6389\u639F\u63B5\u636B"],
    ["9d80", "\u6369\u63BE\u63E9\u63C0\u63C6\u63E3\u63C9\u63D2\u63F6\u63C4\u6416\u6434\u6406\u6413\u6426\u6436\u651D\u6417\u6428\u640F\u6467\u646F\u6476\u644E\u652A\u6495\u6493\u64A5\u64A9\u6488\u64BC\u64DA\u64D2\u64C5\u64C7\u64BB\u64D8\u64C2\u64F1\u64E7\u8209\u64E0\u64E1\u62AC\u64E3\u64EF\u652C\u64F6\u64F4\u64F2\u64FA\u6500\u64FD\u6518\u651C\u6505\u6524\u6523\u652B\u6534\u6535\u6537\u6536\u6538\u754B\u6548\u6556\u6555\u654D\u6558\u655E\u655D\u6572\u6578\u6582\u6583\u8B8A\u659B\u659F\u65AB\u65B7\u65C3\u65C6\u65C1\u65C4\u65CC\u65D2\u65DB\u65D9\u65E0\u65E1\u65F1\u6772\u660A\u6603\u65FB\u6773\u6635\u6636\u6634\u661C\u664F\u6644\u6649\u6641\u665E\u665D\u6664\u6667\u6668\u665F\u6662\u6670\u6683\u6688\u668E\u6689\u6684\u6698\u669D\u66C1\u66B9\u66C9\u66BE\u66BC"],
    ["9e40", "\u66C4\u66B8\u66D6\u66DA\u66E0\u663F\u66E6\u66E9\u66F0\u66F5\u66F7\u670F\u6716\u671E\u6726\u6727\u9738\u672E\u673F\u6736\u6741\u6738\u6737\u6746\u675E\u6760\u6759\u6763\u6764\u6789\u6770\u67A9\u677C\u676A\u678C\u678B\u67A6\u67A1\u6785\u67B7\u67EF\u67B4\u67EC\u67B3\u67E9\u67B8\u67E4\u67DE\u67DD\u67E2\u67EE\u67B9\u67CE\u67C6\u67E7\u6A9C\u681E\u6846\u6829\u6840\u684D\u6832\u684E"],
    ["9e80", "\u68B3\u682B\u6859\u6863\u6877\u687F\u689F\u688F\u68AD\u6894\u689D\u689B\u6883\u6AAE\u68B9\u6874\u68B5\u68A0\u68BA\u690F\u688D\u687E\u6901\u68CA\u6908\u68D8\u6922\u6926\u68E1\u690C\u68CD\u68D4\u68E7\u68D5\u6936\u6912\u6904\u68D7\u68E3\u6925\u68F9\u68E0\u68EF\u6928\u692A\u691A\u6923\u6921\u68C6\u6979\u6977\u695C\u6978\u696B\u6954\u697E\u696E\u6939\u6974\u693D\u6959\u6930\u6961\u695E\u695D\u6981\u696A\u69B2\u69AE\u69D0\u69BF\u69C1\u69D3\u69BE\u69CE\u5BE8\u69CA\u69DD\u69BB\u69C3\u69A7\u6A2E\u6991\u69A0\u699C\u6995\u69B4\u69DE\u69E8\u6A02\u6A1B\u69FF\u6B0A\u69F9\u69F2\u69E7\u6A05\u69B1\u6A1E\u69ED\u6A14\u69EB\u6A0A\u6A12\u6AC1\u6A23\u6A13\u6A44\u6A0C\u6A72\u6A36\u6A78\u6A47\u6A62\u6A59\u6A66\u6A48\u6A38\u6A22\u6A90\u6A8D\u6AA0\u6A84\u6AA2\u6AA3"],
    ["9f40", "\u6A97\u8617\u6ABB\u6AC3\u6AC2\u6AB8\u6AB3\u6AAC\u6ADE\u6AD1\u6ADF\u6AAA\u6ADA\u6AEA\u6AFB\u6B05\u8616\u6AFA\u6B12\u6B16\u9B31\u6B1F\u6B38\u6B37\u76DC\u6B39\u98EE\u6B47\u6B43\u6B49\u6B50\u6B59\u6B54\u6B5B\u6B5F\u6B61\u6B78\u6B79\u6B7F\u6B80\u6B84\u6B83\u6B8D\u6B98\u6B95\u6B9E\u6BA4\u6BAA\u6BAB\u6BAF\u6BB2\u6BB1\u6BB3\u6BB7\u6BBC\u6BC6\u6BCB\u6BD3\u6BDF\u6BEC\u6BEB\u6BF3\u6BEF"],
    ["9f80", "\u9EBE\u6C08\u6C13\u6C14\u6C1B\u6C24\u6C23\u6C5E\u6C55\u6C62\u6C6A\u6C82\u6C8D\u6C9A\u6C81\u6C9B\u6C7E\u6C68\u6C73\u6C92\u6C90\u6CC4\u6CF1\u6CD3\u6CBD\u6CD7\u6CC5\u6CDD\u6CAE\u6CB1\u6CBE\u6CBA\u6CDB\u6CEF\u6CD9\u6CEA\u6D1F\u884D\u6D36\u6D2B\u6D3D\u6D38\u6D19\u6D35\u6D33\u6D12\u6D0C\u6D63\u6D93\u6D64\u6D5A\u6D79\u6D59\u6D8E\u6D95\u6FE4\u6D85\u6DF9\u6E15\u6E0A\u6DB5\u6DC7\u6DE6\u6DB8\u6DC6\u6DEC\u6DDE\u6DCC\u6DE8\u6DD2\u6DC5\u6DFA\u6DD9\u6DE4\u6DD5\u6DEA\u6DEE\u6E2D\u6E6E\u6E2E\u6E19\u6E72\u6E5F\u6E3E\u6E23\u6E6B\u6E2B\u6E76\u6E4D\u6E1F\u6E43\u6E3A\u6E4E\u6E24\u6EFF\u6E1D\u6E38\u6E82\u6EAA\u6E98\u6EC9\u6EB7\u6ED3\u6EBD\u6EAF\u6EC4\u6EB2\u6ED4\u6ED5\u6E8F\u6EA5\u6EC2\u6E9F\u6F41\u6F11\u704C\u6EEC\u6EF8\u6EFE\u6F3F\u6EF2\u6F31\u6EEF\u6F32\u6ECC"],
    ["e040", "\u6F3E\u6F13\u6EF7\u6F86\u6F7A\u6F78\u6F81\u6F80\u6F6F\u6F5B\u6FF3\u6F6D\u6F82\u6F7C\u6F58\u6F8E\u6F91\u6FC2\u6F66\u6FB3\u6FA3\u6FA1\u6FA4\u6FB9\u6FC6\u6FAA\u6FDF\u6FD5\u6FEC\u6FD4\u6FD8\u6FF1\u6FEE\u6FDB\u7009\u700B\u6FFA\u7011\u7001\u700F\u6FFE\u701B\u701A\u6F74\u701D\u7018\u701F\u7030\u703E\u7032\u7051\u7063\u7099\u7092\u70AF\u70F1\u70AC\u70B8\u70B3\u70AE\u70DF\u70CB\u70DD"],
    ["e080", "\u70D9\u7109\u70FD\u711C\u7119\u7165\u7155\u7188\u7166\u7162\u714C\u7156\u716C\u718F\u71FB\u7184\u7195\u71A8\u71AC\u71D7\u71B9\u71BE\u71D2\u71C9\u71D4\u71CE\u71E0\u71EC\u71E7\u71F5\u71FC\u71F9\u71FF\u720D\u7210\u721B\u7228\u722D\u722C\u7230\u7232\u723B\u723C\u723F\u7240\u7246\u724B\u7258\u7274\u727E\u7282\u7281\u7287\u7292\u7296\u72A2\u72A7\u72B9\u72B2\u72C3\u72C6\u72C4\u72CE\u72D2\u72E2\u72E0\u72E1\u72F9\u72F7\u500F\u7317\u730A\u731C\u7316\u731D\u7334\u732F\u7329\u7325\u733E\u734E\u734F\u9ED8\u7357\u736A\u7368\u7370\u7378\u7375\u737B\u737A\u73C8\u73B3\u73CE\u73BB\u73C0\u73E5\u73EE\u73DE\u74A2\u7405\u746F\u7425\u73F8\u7432\u743A\u7455\u743F\u745F\u7459\u7441\u745C\u7469\u7470\u7463\u746A\u7476\u747E\u748B\u749E\u74A7\u74CA\u74CF\u74D4\u73F1"],
    ["e140", "\u74E0\u74E3\u74E7\u74E9\u74EE\u74F2\u74F0\u74F1\u74F8\u74F7\u7504\u7503\u7505\u750C\u750E\u750D\u7515\u7513\u751E\u7526\u752C\u753C\u7544\u754D\u754A\u7549\u755B\u7546\u755A\u7569\u7564\u7567\u756B\u756D\u7578\u7576\u7586\u7587\u7574\u758A\u7589\u7582\u7594\u759A\u759D\u75A5\u75A3\u75C2\u75B3\u75C3\u75B5\u75BD\u75B8\u75BC\u75B1\u75CD\u75CA\u75D2\u75D9\u75E3\u75DE\u75FE\u75FF"],
    ["e180", "\u75FC\u7601\u75F0\u75FA\u75F2\u75F3\u760B\u760D\u7609\u761F\u7627\u7620\u7621\u7622\u7624\u7634\u7630\u763B\u7647\u7648\u7646\u765C\u7658\u7661\u7662\u7668\u7669\u766A\u7667\u766C\u7670\u7672\u7676\u7678\u767C\u7680\u7683\u7688\u768B\u768E\u7696\u7693\u7699\u769A\u76B0\u76B4\u76B8\u76B9\u76BA\u76C2\u76CD\u76D6\u76D2\u76DE\u76E1\u76E5\u76E7\u76EA\u862F\u76FB\u7708\u7707\u7704\u7729\u7724\u771E\u7725\u7726\u771B\u7737\u7738\u7747\u775A\u7768\u776B\u775B\u7765\u777F\u777E\u7779\u778E\u778B\u7791\u77A0\u779E\u77B0\u77B6\u77B9\u77BF\u77BC\u77BD\u77BB\u77C7\u77CD\u77D7\u77DA\u77DC\u77E3\u77EE\u77FC\u780C\u7812\u7926\u7820\u792A\u7845\u788E\u7874\u7886\u787C\u789A\u788C\u78A3\u78B5\u78AA\u78AF\u78D1\u78C6\u78CB\u78D4\u78BE\u78BC\u78C5\u78CA\u78EC"],
    ["e240", "\u78E7\u78DA\u78FD\u78F4\u7907\u7912\u7911\u7919\u792C\u792B\u7940\u7960\u7957\u795F\u795A\u7955\u7953\u797A\u797F\u798A\u799D\u79A7\u9F4B\u79AA\u79AE\u79B3\u79B9\u79BA\u79C9\u79D5\u79E7\u79EC\u79E1\u79E3\u7A08\u7A0D\u7A18\u7A19\u7A20\u7A1F\u7980\u7A31\u7A3B\u7A3E\u7A37\u7A43\u7A57\u7A49\u7A61\u7A62\u7A69\u9F9D\u7A70\u7A79\u7A7D\u7A88\u7A97\u7A95\u7A98\u7A96\u7AA9\u7AC8\u7AB0"],
    ["e280", "\u7AB6\u7AC5\u7AC4\u7ABF\u9083\u7AC7\u7ACA\u7ACD\u7ACF\u7AD5\u7AD3\u7AD9\u7ADA\u7ADD\u7AE1\u7AE2\u7AE6\u7AED\u7AF0\u7B02\u7B0F\u7B0A\u7B06\u7B33\u7B18\u7B19\u7B1E\u7B35\u7B28\u7B36\u7B50\u7B7A\u7B04\u7B4D\u7B0B\u7B4C\u7B45\u7B75\u7B65\u7B74\u7B67\u7B70\u7B71\u7B6C\u7B6E\u7B9D\u7B98\u7B9F\u7B8D\u7B9C\u7B9A\u7B8B\u7B92\u7B8F\u7B5D\u7B99\u7BCB\u7BC1\u7BCC\u7BCF\u7BB4\u7BC6\u7BDD\u7BE9\u7C11\u7C14\u7BE6\u7BE5\u7C60\u7C00\u7C07\u7C13\u7BF3\u7BF7\u7C17\u7C0D\u7BF6\u7C23\u7C27\u7C2A\u7C1F\u7C37\u7C2B\u7C3D\u7C4C\u7C43\u7C54\u7C4F\u7C40\u7C50\u7C58\u7C5F\u7C64\u7C56\u7C65\u7C6C\u7C75\u7C83\u7C90\u7CA4\u7CAD\u7CA2\u7CAB\u7CA1\u7CA8\u7CB3\u7CB2\u7CB1\u7CAE\u7CB9\u7CBD\u7CC0\u7CC5\u7CC2\u7CD8\u7CD2\u7CDC\u7CE2\u9B3B\u7CEF\u7CF2\u7CF4\u7CF6\u7CFA\u7D06"],
    ["e340", "\u7D02\u7D1C\u7D15\u7D0A\u7D45\u7D4B\u7D2E\u7D32\u7D3F\u7D35\u7D46\u7D73\u7D56\u7D4E\u7D72\u7D68\u7D6E\u7D4F\u7D63\u7D93\u7D89\u7D5B\u7D8F\u7D7D\u7D9B\u7DBA\u7DAE\u7DA3\u7DB5\u7DC7\u7DBD\u7DAB\u7E3D\u7DA2\u7DAF\u7DDC\u7DB8\u7D9F\u7DB0\u7DD8\u7DDD\u7DE4\u7DDE\u7DFB\u7DF2\u7DE1\u7E05\u7E0A\u7E23\u7E21\u7E12\u7E31\u7E1F\u7E09\u7E0B\u7E22\u7E46\u7E66\u7E3B\u7E35\u7E39\u7E43\u7E37"],
    ["e380", "\u7E32\u7E3A\u7E67\u7E5D\u7E56\u7E5E\u7E59\u7E5A\u7E79\u7E6A\u7E69\u7E7C\u7E7B\u7E83\u7DD5\u7E7D\u8FAE\u7E7F\u7E88\u7E89\u7E8C\u7E92\u7E90\u7E93\u7E94\u7E96\u7E8E\u7E9B\u7E9C\u7F38\u7F3A\u7F45\u7F4C\u7F4D\u7F4E\u7F50\u7F51\u7F55\u7F54\u7F58\u7F5F\u7F60\u7F68\u7F69\u7F67\u7F78\u7F82\u7F86\u7F83\u7F88\u7F87\u7F8C\u7F94\u7F9E\u7F9D\u7F9A\u7FA3\u7FAF\u7FB2\u7FB9\u7FAE\u7FB6\u7FB8\u8B71\u7FC5\u7FC6\u7FCA\u7FD5\u7FD4\u7FE1\u7FE6\u7FE9\u7FF3\u7FF9\u98DC\u8006\u8004\u800B\u8012\u8018\u8019\u801C\u8021\u8028\u803F\u803B\u804A\u8046\u8052\u8058\u805A\u805F\u8062\u8068\u8073\u8072\u8070\u8076\u8079\u807D\u807F\u8084\u8086\u8085\u809B\u8093\u809A\u80AD\u5190\u80AC\u80DB\u80E5\u80D9\u80DD\u80C4\u80DA\u80D6\u8109\u80EF\u80F1\u811B\u8129\u8123\u812F\u814B"],
    ["e440", "\u968B\u8146\u813E\u8153\u8151\u80FC\u8171\u816E\u8165\u8166\u8174\u8183\u8188\u818A\u8180\u8182\u81A0\u8195\u81A4\u81A3\u815F\u8193\u81A9\u81B0\u81B5\u81BE\u81B8\u81BD\u81C0\u81C2\u81BA\u81C9\u81CD\u81D1\u81D9\u81D8\u81C8\u81DA\u81DF\u81E0\u81E7\u81FA\u81FB\u81FE\u8201\u8202\u8205\u8207\u820A\u820D\u8210\u8216\u8229\u822B\u8238\u8233\u8240\u8259\u8258\u825D\u825A\u825F\u8264"],
    ["e480", "\u8262\u8268\u826A\u826B\u822E\u8271\u8277\u8278\u827E\u828D\u8292\u82AB\u829F\u82BB\u82AC\u82E1\u82E3\u82DF\u82D2\u82F4\u82F3\u82FA\u8393\u8303\u82FB\u82F9\u82DE\u8306\u82DC\u8309\u82D9\u8335\u8334\u8316\u8332\u8331\u8340\u8339\u8350\u8345\u832F\u832B\u8317\u8318\u8385\u839A\u83AA\u839F\u83A2\u8396\u8323\u838E\u8387\u838A\u837C\u83B5\u8373\u8375\u83A0\u8389\u83A8\u83F4\u8413\u83EB\u83CE\u83FD\u8403\u83D8\u840B\u83C1\u83F7\u8407\u83E0\u83F2\u840D\u8422\u8420\u83BD\u8438\u8506\u83FB\u846D\u842A\u843C\u855A\u8484\u8477\u846B\u84AD\u846E\u8482\u8469\u8446\u842C\u846F\u8479\u8435\u84CA\u8462\u84B9\u84BF\u849F\u84D9\u84CD\u84BB\u84DA\u84D0\u84C1\u84C6\u84D6\u84A1\u8521\u84FF\u84F4\u8517\u8518\u852C\u851F\u8515\u8514\u84FC\u8540\u8563\u8558\u8548"],
    ["e540", "\u8541\u8602\u854B\u8555\u8580\u85A4\u8588\u8591\u858A\u85A8\u856D\u8594\u859B\u85EA\u8587\u859C\u8577\u857E\u8590\u85C9\u85BA\u85CF\u85B9\u85D0\u85D5\u85DD\u85E5\u85DC\u85F9\u860A\u8613\u860B\u85FE\u85FA\u8606\u8622\u861A\u8630\u863F\u864D\u4E55\u8654\u865F\u8667\u8671\u8693\u86A3\u86A9\u86AA\u868B\u868C\u86B6\u86AF\u86C4\u86C6\u86B0\u86C9\u8823\u86AB\u86D4\u86DE\u86E9\u86EC"],
    ["e580", "\u86DF\u86DB\u86EF\u8712\u8706\u8708\u8700\u8703\u86FB\u8711\u8709\u870D\u86F9\u870A\u8734\u873F\u8737\u873B\u8725\u8729\u871A\u8760\u875F\u8778\u874C\u874E\u8774\u8757\u8768\u876E\u8759\u8753\u8763\u876A\u8805\u87A2\u879F\u8782\u87AF\u87CB\u87BD\u87C0\u87D0\u96D6\u87AB\u87C4\u87B3\u87C7\u87C6\u87BB\u87EF\u87F2\u87E0\u880F\u880D\u87FE\u87F6\u87F7\u880E\u87D2\u8811\u8816\u8815\u8822\u8821\u8831\u8836\u8839\u8827\u883B\u8844\u8842\u8852\u8859\u885E\u8862\u886B\u8881\u887E\u889E\u8875\u887D\u88B5\u8872\u8882\u8897\u8892\u88AE\u8899\u88A2\u888D\u88A4\u88B0\u88BF\u88B1\u88C3\u88C4\u88D4\u88D8\u88D9\u88DD\u88F9\u8902\u88FC\u88F4\u88E8\u88F2\u8904\u890C\u890A\u8913\u8943\u891E\u8925\u892A\u892B\u8941\u8944\u893B\u8936\u8938\u894C\u891D\u8960\u895E"],
    ["e640", "\u8966\u8964\u896D\u896A\u896F\u8974\u8977\u897E\u8983\u8988\u898A\u8993\u8998\u89A1\u89A9\u89A6\u89AC\u89AF\u89B2\u89BA\u89BD\u89BF\u89C0\u89DA\u89DC\u89DD\u89E7\u89F4\u89F8\u8A03\u8A16\u8A10\u8A0C\u8A1B\u8A1D\u8A25\u8A36\u8A41\u8A5B\u8A52\u8A46\u8A48\u8A7C\u8A6D\u8A6C\u8A62\u8A85\u8A82\u8A84\u8AA8\u8AA1\u8A91\u8AA5\u8AA6\u8A9A\u8AA3\u8AC4\u8ACD\u8AC2\u8ADA\u8AEB\u8AF3\u8AE7"],
    ["e680", "\u8AE4\u8AF1\u8B14\u8AE0\u8AE2\u8AF7\u8ADE\u8ADB\u8B0C\u8B07\u8B1A\u8AE1\u8B16\u8B10\u8B17\u8B20\u8B33\u97AB\u8B26\u8B2B\u8B3E\u8B28\u8B41\u8B4C\u8B4F\u8B4E\u8B49\u8B56\u8B5B\u8B5A\u8B6B\u8B5F\u8B6C\u8B6F\u8B74\u8B7D\u8B80\u8B8C\u8B8E\u8B92\u8B93\u8B96\u8B99\u8B9A\u8C3A\u8C41\u8C3F\u8C48\u8C4C\u8C4E\u8C50\u8C55\u8C62\u8C6C\u8C78\u8C7A\u8C82\u8C89\u8C85\u8C8A\u8C8D\u8C8E\u8C94\u8C7C\u8C98\u621D\u8CAD\u8CAA\u8CBD\u8CB2\u8CB3\u8CAE\u8CB6\u8CC8\u8CC1\u8CE4\u8CE3\u8CDA\u8CFD\u8CFA\u8CFB\u8D04\u8D05\u8D0A\u8D07\u8D0F\u8D0D\u8D10\u9F4E\u8D13\u8CCD\u8D14\u8D16\u8D67\u8D6D\u8D71\u8D73\u8D81\u8D99\u8DC2\u8DBE\u8DBA\u8DCF\u8DDA\u8DD6\u8DCC\u8DDB\u8DCB\u8DEA\u8DEB\u8DDF\u8DE3\u8DFC\u8E08\u8E09\u8DFF\u8E1D\u8E1E\u8E10\u8E1F\u8E42\u8E35\u8E30\u8E34\u8E4A"],
    ["e740", "\u8E47\u8E49\u8E4C\u8E50\u8E48\u8E59\u8E64\u8E60\u8E2A\u8E63\u8E55\u8E76\u8E72\u8E7C\u8E81\u8E87\u8E85\u8E84\u8E8B\u8E8A\u8E93\u8E91\u8E94\u8E99\u8EAA\u8EA1\u8EAC\u8EB0\u8EC6\u8EB1\u8EBE\u8EC5\u8EC8\u8ECB\u8EDB\u8EE3\u8EFC\u8EFB\u8EEB\u8EFE\u8F0A\u8F05\u8F15\u8F12\u8F19\u8F13\u8F1C\u8F1F\u8F1B\u8F0C\u8F26\u8F33\u8F3B\u8F39\u8F45\u8F42\u8F3E\u8F4C\u8F49\u8F46\u8F4E\u8F57\u8F5C"],
    ["e780", "\u8F62\u8F63\u8F64\u8F9C\u8F9F\u8FA3\u8FAD\u8FAF\u8FB7\u8FDA\u8FE5\u8FE2\u8FEA\u8FEF\u9087\u8FF4\u9005\u8FF9\u8FFA\u9011\u9015\u9021\u900D\u901E\u9016\u900B\u9027\u9036\u9035\u9039\u8FF8\u904F\u9050\u9051\u9052\u900E\u9049\u903E\u9056\u9058\u905E\u9068\u906F\u9076\u96A8\u9072\u9082\u907D\u9081\u9080\u908A\u9089\u908F\u90A8\u90AF\u90B1\u90B5\u90E2\u90E4\u6248\u90DB\u9102\u9112\u9119\u9132\u9130\u914A\u9156\u9158\u9163\u9165\u9169\u9173\u9172\u918B\u9189\u9182\u91A2\u91AB\u91AF\u91AA\u91B5\u91B4\u91BA\u91C0\u91C1\u91C9\u91CB\u91D0\u91D6\u91DF\u91E1\u91DB\u91FC\u91F5\u91F6\u921E\u91FF\u9214\u922C\u9215\u9211\u925E\u9257\u9245\u9249\u9264\u9248\u9295\u923F\u924B\u9250\u929C\u9296\u9293\u929B\u925A\u92CF\u92B9\u92B7\u92E9\u930F\u92FA\u9344\u932E"],
    ["e840", "\u9319\u9322\u931A\u9323\u933A\u9335\u933B\u935C\u9360\u937C\u936E\u9356\u93B0\u93AC\u93AD\u9394\u93B9\u93D6\u93D7\u93E8\u93E5\u93D8\u93C3\u93DD\u93D0\u93C8\u93E4\u941A\u9414\u9413\u9403\u9407\u9410\u9436\u942B\u9435\u9421\u943A\u9441\u9452\u9444\u945B\u9460\u9462\u945E\u946A\u9229\u9470\u9475\u9477\u947D\u945A\u947C\u947E\u9481\u947F\u9582\u9587\u958A\u9594\u9596\u9598\u9599"],
    ["e880", "\u95A0\u95A8\u95A7\u95AD\u95BC\u95BB\u95B9\u95BE\u95CA\u6FF6\u95C3\u95CD\u95CC\u95D5\u95D4\u95D6\u95DC\u95E1\u95E5\u95E2\u9621\u9628\u962E\u962F\u9642\u964C\u964F\u964B\u9677\u965C\u965E\u965D\u965F\u9666\u9672\u966C\u968D\u9698\u9695\u9697\u96AA\u96A7\u96B1\u96B2\u96B0\u96B4\u96B6\u96B8\u96B9\u96CE\u96CB\u96C9\u96CD\u894D\u96DC\u970D\u96D5\u96F9\u9704\u9706\u9708\u9713\u970E\u9711\u970F\u9716\u9719\u9724\u972A\u9730\u9739\u973D\u973E\u9744\u9746\u9748\u9742\u9749\u975C\u9760\u9764\u9766\u9768\u52D2\u976B\u9771\u9779\u9785\u977C\u9781\u977A\u9786\u978B\u978F\u9790\u979C\u97A8\u97A6\u97A3\u97B3\u97B4\u97C3\u97C6\u97C8\u97CB\u97DC\u97ED\u9F4F\u97F2\u7ADF\u97F6\u97F5\u980F\u980C\u9838\u9824\u9821\u9837\u983D\u9846\u984F\u984B\u986B\u986F\u9870"],
    ["e940", "\u9871\u9874\u9873\u98AA\u98AF\u98B1\u98B6\u98C4\u98C3\u98C6\u98E9\u98EB\u9903\u9909\u9912\u9914\u9918\u9921\u991D\u991E\u9924\u9920\u992C\u992E\u993D\u993E\u9942\u9949\u9945\u9950\u994B\u9951\u9952\u994C\u9955\u9997\u9998\u99A5\u99AD\u99AE\u99BC\u99DF\u99DB\u99DD\u99D8\u99D1\u99ED\u99EE\u99F1\u99F2\u99FB\u99F8\u9A01\u9A0F\u9A05\u99E2\u9A19\u9A2B\u9A37\u9A45\u9A42\u9A40\u9A43"],
    ["e980", "\u9A3E\u9A55\u9A4D\u9A5B\u9A57\u9A5F\u9A62\u9A65\u9A64\u9A69\u9A6B\u9A6A\u9AAD\u9AB0\u9ABC\u9AC0\u9ACF\u9AD1\u9AD3\u9AD4\u9ADE\u9ADF\u9AE2\u9AE3\u9AE6\u9AEF\u9AEB\u9AEE\u9AF4\u9AF1\u9AF7\u9AFB\u9B06\u9B18\u9B1A\u9B1F\u9B22\u9B23\u9B25\u9B27\u9B28\u9B29\u9B2A\u9B2E\u9B2F\u9B32\u9B44\u9B43\u9B4F\u9B4D\u9B4E\u9B51\u9B58\u9B74\u9B93\u9B83\u9B91\u9B96\u9B97\u9B9F\u9BA0\u9BA8\u9BB4\u9BC0\u9BCA\u9BB9\u9BC6\u9BCF\u9BD1\u9BD2\u9BE3\u9BE2\u9BE4\u9BD4\u9BE1\u9C3A\u9BF2\u9BF1\u9BF0\u9C15\u9C14\u9C09\u9C13\u9C0C\u9C06\u9C08\u9C12\u9C0A\u9C04\u9C2E\u9C1B\u9C25\u9C24\u9C21\u9C30\u9C47\u9C32\u9C46\u9C3E\u9C5A\u9C60\u9C67\u9C76\u9C78\u9CE7\u9CEC\u9CF0\u9D09\u9D08\u9CEB\u9D03\u9D06\u9D2A\u9D26\u9DAF\u9D23\u9D1F\u9D44\u9D15\u9D12\u9D41\u9D3F\u9D3E\u9D46\u9D48"],
    ["ea40", "\u9D5D\u9D5E\u9D64\u9D51\u9D50\u9D59\u9D72\u9D89\u9D87\u9DAB\u9D6F\u9D7A\u9D9A\u9DA4\u9DA9\u9DB2\u9DC4\u9DC1\u9DBB\u9DB8\u9DBA\u9DC6\u9DCF\u9DC2\u9DD9\u9DD3\u9DF8\u9DE6\u9DED\u9DEF\u9DFD\u9E1A\u9E1B\u9E1E\u9E75\u9E79\u9E7D\u9E81\u9E88\u9E8B\u9E8C\u9E92\u9E95\u9E91\u9E9D\u9EA5\u9EA9\u9EB8\u9EAA\u9EAD\u9761\u9ECC\u9ECE\u9ECF\u9ED0\u9ED4\u9EDC\u9EDE\u9EDD\u9EE0\u9EE5\u9EE8\u9EEF"],
    ["ea80", "\u9EF4\u9EF6\u9EF7\u9EF9\u9EFB\u9EFC\u9EFD\u9F07\u9F08\u76B7\u9F15\u9F21\u9F2C\u9F3E\u9F4A\u9F52\u9F54\u9F63\u9F5F\u9F60\u9F61\u9F66\u9F67\u9F6C\u9F6A\u9F77\u9F72\u9F76\u9F95\u9F9C\u9FA0\u582F\u69C7\u9059\u7464\u51DC\u7199"],
    ["ed40", "\u7E8A\u891C\u9348\u9288\u84DC\u4FC9\u70BB\u6631\u68C8\u92F9\u66FB\u5F45\u4E28\u4EE1\u4EFC\u4F00\u4F03\u4F39\u4F56\u4F92\u4F8A\u4F9A\u4F94\u4FCD\u5040\u5022\u4FFF\u501E\u5046\u5070\u5042\u5094\u50F4\u50D8\u514A\u5164\u519D\u51BE\u51EC\u5215\u529C\u52A6\u52C0\u52DB\u5300\u5307\u5324\u5372\u5393\u53B2\u53DD\uFA0E\u549C\u548A\u54A9\u54FF\u5586\u5759\u5765\u57AC\u57C8\u57C7\uFA0F"],
    ["ed80", "\uFA10\u589E\u58B2\u590B\u5953\u595B\u595D\u5963\u59A4\u59BA\u5B56\u5BC0\u752F\u5BD8\u5BEC\u5C1E\u5CA6\u5CBA\u5CF5\u5D27\u5D53\uFA11\u5D42\u5D6D\u5DB8\u5DB9\u5DD0\u5F21\u5F34\u5F67\u5FB7\u5FDE\u605D\u6085\u608A\u60DE\u60D5\u6120\u60F2\u6111\u6137\u6130\u6198\u6213\u62A6\u63F5\u6460\u649D\u64CE\u654E\u6600\u6615\u663B\u6609\u662E\u661E\u6624\u6665\u6657\u6659\uFA12\u6673\u6699\u66A0\u66B2\u66BF\u66FA\u670E\uF929\u6766\u67BB\u6852\u67C0\u6801\u6844\u68CF\uFA13\u6968\uFA14\u6998\u69E2\u6A30\u6A6B\u6A46\u6A73\u6A7E\u6AE2\u6AE4\u6BD6\u6C3F\u6C5C\u6C86\u6C6F\u6CDA\u6D04\u6D87\u6D6F\u6D96\u6DAC\u6DCF\u6DF8\u6DF2\u6DFC\u6E39\u6E5C\u6E27\u6E3C\u6EBF\u6F88\u6FB5\u6FF5\u7005\u7007\u7028\u7085\u70AB\u710F\u7104\u715C\u7146\u7147\uFA15\u71C1\u71FE\u72B1"],
    ["ee40", "\u72BE\u7324\uFA16\u7377\u73BD\u73C9\u73D6\u73E3\u73D2\u7407\u73F5\u7426\u742A\u7429\u742E\u7462\u7489\u749F\u7501\u756F\u7682\u769C\u769E\u769B\u76A6\uFA17\u7746\u52AF\u7821\u784E\u7864\u787A\u7930\uFA18\uFA19\uFA1A\u7994\uFA1B\u799B\u7AD1\u7AE7\uFA1C\u7AEB\u7B9E\uFA1D\u7D48\u7D5C\u7DB7\u7DA0\u7DD6\u7E52\u7F47\u7FA1\uFA1E\u8301\u8362\u837F\u83C7\u83F6\u8448\u84B4\u8553\u8559"],
    ["ee80", "\u856B\uFA1F\u85B0\uFA20\uFA21\u8807\u88F5\u8A12\u8A37\u8A79\u8AA7\u8ABE\u8ADF\uFA22\u8AF6\u8B53\u8B7F\u8CF0\u8CF4\u8D12\u8D76\uFA23\u8ECF\uFA24\uFA25\u9067\u90DE\uFA26\u9115\u9127\u91DA\u91D7\u91DE\u91ED\u91EE\u91E4\u91E5\u9206\u9210\u920A\u923A\u9240\u923C\u924E\u9259\u9251\u9239\u9267\u92A7\u9277\u9278\u92E7\u92D7\u92D9\u92D0\uFA27\u92D5\u92E0\u92D3\u9325\u9321\u92FB\uFA28\u931E\u92FF\u931D\u9302\u9370\u9357\u93A4\u93C6\u93DE\u93F8\u9431\u9445\u9448\u9592\uF9DC\uFA29\u969D\u96AF\u9733\u973B\u9743\u974D\u974F\u9751\u9755\u9857\u9865\uFA2A\uFA2B\u9927\uFA2C\u999E\u9A4E\u9AD9\u9ADC\u9B75\u9B72\u9B8F\u9BB1\u9BBB\u9C00\u9D70\u9D6B\uFA2D\u9E19\u9ED1"],
    ["eeef", "\u2170", 9, "\uFFE2\uFFE4\uFF07\uFF02"],
    ["f040", "\uE000", 62],
    ["f080", "\uE03F", 124],
    ["f140", "\uE0BC", 62],
    ["f180", "\uE0FB", 124],
    ["f240", "\uE178", 62],
    ["f280", "\uE1B7", 124],
    ["f340", "\uE234", 62],
    ["f380", "\uE273", 124],
    ["f440", "\uE2F0", 62],
    ["f480", "\uE32F", 124],
    ["f540", "\uE3AC", 62],
    ["f580", "\uE3EB", 124],
    ["f640", "\uE468", 62],
    ["f680", "\uE4A7", 124],
    ["f740", "\uE524", 62],
    ["f780", "\uE563", 124],
    ["f840", "\uE5E0", 62],
    ["f880", "\uE61F", 124],
    ["f940", "\uE69C"],
    ["fa40", "\u2170", 9, "\u2160", 9, "\uFFE2\uFFE4\uFF07\uFF02\u3231\u2116\u2121\u2235\u7E8A\u891C\u9348\u9288\u84DC\u4FC9\u70BB\u6631\u68C8\u92F9\u66FB\u5F45\u4E28\u4EE1\u4EFC\u4F00\u4F03\u4F39\u4F56\u4F92\u4F8A\u4F9A\u4F94\u4FCD\u5040\u5022\u4FFF\u501E\u5046\u5070\u5042\u5094\u50F4\u50D8\u514A"],
    ["fa80", "\u5164\u519D\u51BE\u51EC\u5215\u529C\u52A6\u52C0\u52DB\u5300\u5307\u5324\u5372\u5393\u53B2\u53DD\uFA0E\u549C\u548A\u54A9\u54FF\u5586\u5759\u5765\u57AC\u57C8\u57C7\uFA0F\uFA10\u589E\u58B2\u590B\u5953\u595B\u595D\u5963\u59A4\u59BA\u5B56\u5BC0\u752F\u5BD8\u5BEC\u5C1E\u5CA6\u5CBA\u5CF5\u5D27\u5D53\uFA11\u5D42\u5D6D\u5DB8\u5DB9\u5DD0\u5F21\u5F34\u5F67\u5FB7\u5FDE\u605D\u6085\u608A\u60DE\u60D5\u6120\u60F2\u6111\u6137\u6130\u6198\u6213\u62A6\u63F5\u6460\u649D\u64CE\u654E\u6600\u6615\u663B\u6609\u662E\u661E\u6624\u6665\u6657\u6659\uFA12\u6673\u6699\u66A0\u66B2\u66BF\u66FA\u670E\uF929\u6766\u67BB\u6852\u67C0\u6801\u6844\u68CF\uFA13\u6968\uFA14\u6998\u69E2\u6A30\u6A6B\u6A46\u6A73\u6A7E\u6AE2\u6AE4\u6BD6\u6C3F\u6C5C\u6C86\u6C6F\u6CDA\u6D04\u6D87\u6D6F"],
    ["fb40", "\u6D96\u6DAC\u6DCF\u6DF8\u6DF2\u6DFC\u6E39\u6E5C\u6E27\u6E3C\u6EBF\u6F88\u6FB5\u6FF5\u7005\u7007\u7028\u7085\u70AB\u710F\u7104\u715C\u7146\u7147\uFA15\u71C1\u71FE\u72B1\u72BE\u7324\uFA16\u7377\u73BD\u73C9\u73D6\u73E3\u73D2\u7407\u73F5\u7426\u742A\u7429\u742E\u7462\u7489\u749F\u7501\u756F\u7682\u769C\u769E\u769B\u76A6\uFA17\u7746\u52AF\u7821\u784E\u7864\u787A\u7930\uFA18\uFA19"],
    ["fb80", "\uFA1A\u7994\uFA1B\u799B\u7AD1\u7AE7\uFA1C\u7AEB\u7B9E\uFA1D\u7D48\u7D5C\u7DB7\u7DA0\u7DD6\u7E52\u7F47\u7FA1\uFA1E\u8301\u8362\u837F\u83C7\u83F6\u8448\u84B4\u8553\u8559\u856B\uFA1F\u85B0\uFA20\uFA21\u8807\u88F5\u8A12\u8A37\u8A79\u8AA7\u8ABE\u8ADF\uFA22\u8AF6\u8B53\u8B7F\u8CF0\u8CF4\u8D12\u8D76\uFA23\u8ECF\uFA24\uFA25\u9067\u90DE\uFA26\u9115\u9127\u91DA\u91D7\u91DE\u91ED\u91EE\u91E4\u91E5\u9206\u9210\u920A\u923A\u9240\u923C\u924E\u9259\u9251\u9239\u9267\u92A7\u9277\u9278\u92E7\u92D7\u92D9\u92D0\uFA27\u92D5\u92E0\u92D3\u9325\u9321\u92FB\uFA28\u931E\u92FF\u931D\u9302\u9370\u9357\u93A4\u93C6\u93DE\u93F8\u9431\u9445\u9448\u9592\uF9DC\uFA29\u969D\u96AF\u9733\u973B\u9743\u974D\u974F\u9751\u9755\u9857\u9865\uFA2A\uFA2B\u9927\uFA2C\u999E\u9A4E\u9AD9"],
    ["fc40", "\u9ADC\u9B75\u9B72\u9B8F\u9BB1\u9BBB\u9C00\u9D70\u9D6B\uFA2D\u9E19\u9ED1"]
  ];
});
var require_eucjp = __commonJS2((exports, module) => {
  module.exports = [
    ["0", "\0", 127],
    ["8ea1", "\uFF61", 62],
    ["a1a1", "\u3000\u3001\u3002\uFF0C\uFF0E\u30FB\uFF1A\uFF1B\uFF1F\uFF01\u309B\u309C\xB4\uFF40\xA8\uFF3E\uFFE3\uFF3F\u30FD\u30FE\u309D\u309E\u3003\u4EDD\u3005\u3006\u3007\u30FC\u2015\u2010\uFF0F\uFF3C\uFF5E\u2225\uFF5C\u2026\u2025\u2018\u2019\u201C\u201D\uFF08\uFF09\u3014\u3015\uFF3B\uFF3D\uFF5B\uFF5D\u3008", 9, "\uFF0B\uFF0D\xB1\xD7\xF7\uFF1D\u2260\uFF1C\uFF1E\u2266\u2267\u221E\u2234\u2642\u2640\xB0\u2032\u2033\u2103\uFFE5\uFF04\uFFE0\uFFE1\uFF05\uFF03\uFF06\uFF0A\uFF20\xA7\u2606\u2605\u25CB\u25CF\u25CE\u25C7"],
    ["a2a1", "\u25C6\u25A1\u25A0\u25B3\u25B2\u25BD\u25BC\u203B\u3012\u2192\u2190\u2191\u2193\u3013"],
    ["a2ba", "\u2208\u220B\u2286\u2287\u2282\u2283\u222A\u2229"],
    ["a2ca", "\u2227\u2228\uFFE2\u21D2\u21D4\u2200\u2203"],
    ["a2dc", "\u2220\u22A5\u2312\u2202\u2207\u2261\u2252\u226A\u226B\u221A\u223D\u221D\u2235\u222B\u222C"],
    ["a2f2", "\u212B\u2030\u266F\u266D\u266A\u2020\u2021\xB6"],
    ["a2fe", "\u25EF"],
    ["a3b0", "\uFF10", 9],
    ["a3c1", "\uFF21", 25],
    ["a3e1", "\uFF41", 25],
    ["a4a1", "\u3041", 82],
    ["a5a1", "\u30A1", 85],
    ["a6a1", "\u0391", 16, "\u03A3", 6],
    ["a6c1", "\u03B1", 16, "\u03C3", 6],
    ["a7a1", "\u0410", 5, "\u0401\u0416", 25],
    ["a7d1", "\u0430", 5, "\u0451\u0436", 25],
    ["a8a1", "\u2500\u2502\u250C\u2510\u2518\u2514\u251C\u252C\u2524\u2534\u253C\u2501\u2503\u250F\u2513\u251B\u2517\u2523\u2533\u252B\u253B\u254B\u2520\u252F\u2528\u2537\u253F\u251D\u2530\u2525\u2538\u2542"],
    ["ada1", "\u2460", 19, "\u2160", 9],
    ["adc0", "\u3349\u3314\u3322\u334D\u3318\u3327\u3303\u3336\u3351\u3357\u330D\u3326\u3323\u332B\u334A\u333B\u339C\u339D\u339E\u338E\u338F\u33C4\u33A1"],
    ["addf", "\u337B\u301D\u301F\u2116\u33CD\u2121\u32A4", 4, "\u3231\u3232\u3239\u337E\u337D\u337C\u2252\u2261\u222B\u222E\u2211\u221A\u22A5\u2220\u221F\u22BF\u2235\u2229\u222A"],
    ["b0a1", "\u4E9C\u5516\u5A03\u963F\u54C0\u611B\u6328\u59F6\u9022\u8475\u831C\u7A50\u60AA\u63E1\u6E25\u65ED\u8466\u82A6\u9BF5\u6893\u5727\u65A1\u6271\u5B9B\u59D0\u867B\u98F4\u7D62\u7DBE\u9B8E\u6216\u7C9F\u88B7\u5B89\u5EB5\u6309\u6697\u6848\u95C7\u978D\u674F\u4EE5\u4F0A\u4F4D\u4F9D\u5049\u56F2\u5937\u59D4\u5A01\u5C09\u60DF\u610F\u6170\u6613\u6905\u70BA\u754F\u7570\u79FB\u7DAD\u7DEF\u80C3\u840E\u8863\u8B02\u9055\u907A\u533B\u4E95\u4EA5\u57DF\u80B2\u90C1\u78EF\u4E00\u58F1\u6EA2\u9038\u7A32\u8328\u828B\u9C2F\u5141\u5370\u54BD\u54E1\u56E0\u59FB\u5F15\u98F2\u6DEB\u80E4\u852D"],
    ["b1a1", "\u9662\u9670\u96A0\u97FB\u540B\u53F3\u5B87\u70CF\u7FBD\u8FC2\u96E8\u536F\u9D5C\u7ABA\u4E11\u7893\u81FC\u6E26\u5618\u5504\u6B1D\u851A\u9C3B\u59E5\u53A9\u6D66\u74DC\u958F\u5642\u4E91\u904B\u96F2\u834F\u990C\u53E1\u55B6\u5B30\u5F71\u6620\u66F3\u6804\u6C38\u6CF3\u6D29\u745B\u76C8\u7A4E\u9834\u82F1\u885B\u8A60\u92ED\u6DB2\u75AB\u76CA\u99C5\u60A6\u8B01\u8D8A\u95B2\u698E\u53AD\u5186\u5712\u5830\u5944\u5BB4\u5EF6\u6028\u63A9\u63F4\u6CBF\u6F14\u708E\u7114\u7159\u71D5\u733F\u7E01\u8276\u82D1\u8597\u9060\u925B\u9D1B\u5869\u65BC\u6C5A\u7525\u51F9\u592E\u5965\u5F80\u5FDC"],
    ["b2a1", "\u62BC\u65FA\u6A2A\u6B27\u6BB4\u738B\u7FC1\u8956\u9D2C\u9D0E\u9EC4\u5CA1\u6C96\u837B\u5104\u5C4B\u61B6\u81C6\u6876\u7261\u4E59\u4FFA\u5378\u6069\u6E29\u7A4F\u97F3\u4E0B\u5316\u4EEE\u4F55\u4F3D\u4FA1\u4F73\u52A0\u53EF\u5609\u590F\u5AC1\u5BB6\u5BE1\u79D1\u6687\u679C\u67B6\u6B4C\u6CB3\u706B\u73C2\u798D\u79BE\u7A3C\u7B87\u82B1\u82DB\u8304\u8377\u83EF\u83D3\u8766\u8AB2\u5629\u8CA8\u8FE6\u904E\u971E\u868A\u4FC4\u5CE8\u6211\u7259\u753B\u81E5\u82BD\u86FE\u8CC0\u96C5\u9913\u99D5\u4ECB\u4F1A\u89E3\u56DE\u584A\u58CA\u5EFB\u5FEB\u602A\u6094\u6062\u61D0\u6212\u62D0\u6539"],
    ["b3a1", "\u9B41\u6666\u68B0\u6D77\u7070\u754C\u7686\u7D75\u82A5\u87F9\u958B\u968E\u8C9D\u51F1\u52BE\u5916\u54B3\u5BB3\u5D16\u6168\u6982\u6DAF\u788D\u84CB\u8857\u8A72\u93A7\u9AB8\u6D6C\u99A8\u86D9\u57A3\u67FF\u86CE\u920E\u5283\u5687\u5404\u5ED3\u62E1\u64B9\u683C\u6838\u6BBB\u7372\u78BA\u7A6B\u899A\u89D2\u8D6B\u8F03\u90ED\u95A3\u9694\u9769\u5B66\u5CB3\u697D\u984D\u984E\u639B\u7B20\u6A2B\u6A7F\u68B6\u9C0D\u6F5F\u5272\u559D\u6070\u62EC\u6D3B\u6E07\u6ED1\u845B\u8910\u8F44\u4E14\u9C39\u53F6\u691B\u6A3A\u9784\u682A\u515C\u7AC3\u84B2\u91DC\u938C\u565B\u9D28\u6822\u8305\u8431"],
    ["b4a1", "\u7CA5\u5208\u82C5\u74E6\u4E7E\u4F83\u51A0\u5BD2\u520A\u52D8\u52E7\u5DFB\u559A\u582A\u59E6\u5B8C\u5B98\u5BDB\u5E72\u5E79\u60A3\u611F\u6163\u61BE\u63DB\u6562\u67D1\u6853\u68FA\u6B3E\u6B53\u6C57\u6F22\u6F97\u6F45\u74B0\u7518\u76E3\u770B\u7AFF\u7BA1\u7C21\u7DE9\u7F36\u7FF0\u809D\u8266\u839E\u89B3\u8ACC\u8CAB\u9084\u9451\u9593\u9591\u95A2\u9665\u97D3\u9928\u8218\u4E38\u542B\u5CB8\u5DCC\u73A9\u764C\u773C\u5CA9\u7FEB\u8D0B\u96C1\u9811\u9854\u9858\u4F01\u4F0E\u5371\u559C\u5668\u57FA\u5947\u5B09\u5BC4\u5C90\u5E0C\u5E7E\u5FCC\u63EE\u673A\u65D7\u65E2\u671F\u68CB\u68C4"],
    ["b5a1", "\u6A5F\u5E30\u6BC5\u6C17\u6C7D\u757F\u7948\u5B63\u7A00\u7D00\u5FBD\u898F\u8A18\u8CB4\u8D77\u8ECC\u8F1D\u98E2\u9A0E\u9B3C\u4E80\u507D\u5100\u5993\u5B9C\u622F\u6280\u64EC\u6B3A\u72A0\u7591\u7947\u7FA9\u87FB\u8ABC\u8B70\u63AC\u83CA\u97A0\u5409\u5403\u55AB\u6854\u6A58\u8A70\u7827\u6775\u9ECD\u5374\u5BA2\u811A\u8650\u9006\u4E18\u4E45\u4EC7\u4F11\u53CA\u5438\u5BAE\u5F13\u6025\u6551\u673D\u6C42\u6C72\u6CE3\u7078\u7403\u7A76\u7AAE\u7B08\u7D1A\u7CFE\u7D66\u65E7\u725B\u53BB\u5C45\u5DE8\u62D2\u62E0\u6319\u6E20\u865A\u8A31\u8DDD\u92F8\u6F01\u79A6\u9B5A\u4EA8\u4EAB\u4EAC"],
    ["b6a1", "\u4F9B\u4FA0\u50D1\u5147\u7AF6\u5171\u51F6\u5354\u5321\u537F\u53EB\u55AC\u5883\u5CE1\u5F37\u5F4A\u602F\u6050\u606D\u631F\u6559\u6A4B\u6CC1\u72C2\u72ED\u77EF\u80F8\u8105\u8208\u854E\u90F7\u93E1\u97FF\u9957\u9A5A\u4EF0\u51DD\u5C2D\u6681\u696D\u5C40\u66F2\u6975\u7389\u6850\u7C81\u50C5\u52E4\u5747\u5DFE\u9326\u65A4\u6B23\u6B3D\u7434\u7981\u79BD\u7B4B\u7DCA\u82B9\u83CC\u887F\u895F\u8B39\u8FD1\u91D1\u541F\u9280\u4E5D\u5036\u53E5\u533A\u72D7\u7396\u77E9\u82E6\u8EAF\u99C6\u99C8\u99D2\u5177\u611A\u865E\u55B0\u7A7A\u5076\u5BD3\u9047\u9685\u4E32\u6ADB\u91E7\u5C51\u5C48"],
    ["b7a1", "\u6398\u7A9F\u6C93\u9774\u8F61\u7AAA\u718A\u9688\u7C82\u6817\u7E70\u6851\u936C\u52F2\u541B\u85AB\u8A13\u7FA4\u8ECD\u90E1\u5366\u8888\u7941\u4FC2\u50BE\u5211\u5144\u5553\u572D\u73EA\u578B\u5951\u5F62\u5F84\u6075\u6176\u6167\u61A9\u63B2\u643A\u656C\u666F\u6842\u6E13\u7566\u7A3D\u7CFB\u7D4C\u7D99\u7E4B\u7F6B\u830E\u834A\u86CD\u8A08\u8A63\u8B66\u8EFD\u981A\u9D8F\u82B8\u8FCE\u9BE8\u5287\u621F\u6483\u6FC0\u9699\u6841\u5091\u6B20\u6C7A\u6F54\u7A74\u7D50\u8840\u8A23\u6708\u4EF6\u5039\u5026\u5065\u517C\u5238\u5263\u55A7\u570F\u5805\u5ACC\u5EFA\u61B2\u61F8\u62F3\u6372"],
    ["b8a1", "\u691C\u6A29\u727D\u72AC\u732E\u7814\u786F\u7D79\u770C\u80A9\u898B\u8B19\u8CE2\u8ED2\u9063\u9375\u967A\u9855\u9A13\u9E78\u5143\u539F\u53B3\u5E7B\u5F26\u6E1B\u6E90\u7384\u73FE\u7D43\u8237\u8A00\u8AFA\u9650\u4E4E\u500B\u53E4\u547C\u56FA\u59D1\u5B64\u5DF1\u5EAB\u5F27\u6238\u6545\u67AF\u6E56\u72D0\u7CCA\u88B4\u80A1\u80E1\u83F0\u864E\u8A87\u8DE8\u9237\u96C7\u9867\u9F13\u4E94\u4E92\u4F0D\u5348\u5449\u543E\u5A2F\u5F8C\u5FA1\u609F\u68A7\u6A8E\u745A\u7881\u8A9E\u8AA4\u8B77\u9190\u4E5E\u9BC9\u4EA4\u4F7C\u4FAF\u5019\u5016\u5149\u516C\u529F\u52B9\u52FE\u539A\u53E3\u5411"],
    ["b9a1", "\u540E\u5589\u5751\u57A2\u597D\u5B54\u5B5D\u5B8F\u5DE5\u5DE7\u5DF7\u5E78\u5E83\u5E9A\u5EB7\u5F18\u6052\u614C\u6297\u62D8\u63A7\u653B\u6602\u6643\u66F4\u676D\u6821\u6897\u69CB\u6C5F\u6D2A\u6D69\u6E2F\u6E9D\u7532\u7687\u786C\u7A3F\u7CE0\u7D05\u7D18\u7D5E\u7DB1\u8015\u8003\u80AF\u80B1\u8154\u818F\u822A\u8352\u884C\u8861\u8B1B\u8CA2\u8CFC\u90CA\u9175\u9271\u783F\u92FC\u95A4\u964D\u9805\u9999\u9AD8\u9D3B\u525B\u52AB\u53F7\u5408\u58D5\u62F7\u6FE0\u8C6A\u8F5F\u9EB9\u514B\u523B\u544A\u56FD\u7A40\u9177\u9D60\u9ED2\u7344\u6F09\u8170\u7511\u5FFD\u60DA\u9AA8\u72DB\u8FBC"],
    ["baa1", "\u6B64\u9803\u4ECA\u56F0\u5764\u58BE\u5A5A\u6068\u61C7\u660F\u6606\u6839\u68B1\u6DF7\u75D5\u7D3A\u826E\u9B42\u4E9B\u4F50\u53C9\u5506\u5D6F\u5DE6\u5DEE\u67FB\u6C99\u7473\u7802\u8A50\u9396\u88DF\u5750\u5EA7\u632B\u50B5\u50AC\u518D\u6700\u54C9\u585E\u59BB\u5BB0\u5F69\u624D\u63A1\u683D\u6B73\u6E08\u707D\u91C7\u7280\u7815\u7826\u796D\u658E\u7D30\u83DC\u88C1\u8F09\u969B\u5264\u5728\u6750\u7F6A\u8CA1\u51B4\u5742\u962A\u583A\u698A\u80B4\u54B2\u5D0E\u57FC\u7895\u9DFA\u4F5C\u524A\u548B\u643E\u6628\u6714\u67F5\u7A84\u7B56\u7D22\u932F\u685C\u9BAD\u7B39\u5319\u518A\u5237"],
    ["bba1", "\u5BDF\u62F6\u64AE\u64E6\u672D\u6BBA\u85A9\u96D1\u7690\u9BD6\u634C\u9306\u9BAB\u76BF\u6652\u4E09\u5098\u53C2\u5C71\u60E8\u6492\u6563\u685F\u71E6\u73CA\u7523\u7B97\u7E82\u8695\u8B83\u8CDB\u9178\u9910\u65AC\u66AB\u6B8B\u4ED5\u4ED4\u4F3A\u4F7F\u523A\u53F8\u53F2\u55E3\u56DB\u58EB\u59CB\u59C9\u59FF\u5B50\u5C4D\u5E02\u5E2B\u5FD7\u601D\u6307\u652F\u5B5C\u65AF\u65BD\u65E8\u679D\u6B62\u6B7B\u6C0F\u7345\u7949\u79C1\u7CF8\u7D19\u7D2B\u80A2\u8102\u81F3\u8996\u8A5E\u8A69\u8A66\u8A8C\u8AEE\u8CC7\u8CDC\u96CC\u98FC\u6B6F\u4E8B\u4F3C\u4F8D\u5150\u5B57\u5BFA\u6148\u6301\u6642"],
    ["bca1", "\u6B21\u6ECB\u6CBB\u723E\u74BD\u75D4\u78C1\u793A\u800C\u8033\u81EA\u8494\u8F9E\u6C50\u9E7F\u5F0F\u8B58\u9D2B\u7AFA\u8EF8\u5B8D\u96EB\u4E03\u53F1\u57F7\u5931\u5AC9\u5BA4\u6089\u6E7F\u6F06\u75BE\u8CEA\u5B9F\u8500\u7BE0\u5072\u67F4\u829D\u5C61\u854A\u7E1E\u820E\u5199\u5C04\u6368\u8D66\u659C\u716E\u793E\u7D17\u8005\u8B1D\u8ECA\u906E\u86C7\u90AA\u501F\u52FA\u5C3A\u6753\u707C\u7235\u914C\u91C8\u932B\u82E5\u5BC2\u5F31\u60F9\u4E3B\u53D6\u5B88\u624B\u6731\u6B8A\u72E9\u73E0\u7A2E\u816B\u8DA3\u9152\u9996\u5112\u53D7\u546A\u5BFF\u6388\u6A39\u7DAC\u9700\u56DA\u53CE\u5468"],
    ["bda1", "\u5B97\u5C31\u5DDE\u4FEE\u6101\u62FE\u6D32\u79C0\u79CB\u7D42\u7E4D\u7FD2\u81ED\u821F\u8490\u8846\u8972\u8B90\u8E74\u8F2F\u9031\u914B\u916C\u96C6\u919C\u4EC0\u4F4F\u5145\u5341\u5F93\u620E\u67D4\u6C41\u6E0B\u7363\u7E26\u91CD\u9283\u53D4\u5919\u5BBF\u6DD1\u795D\u7E2E\u7C9B\u587E\u719F\u51FA\u8853\u8FF0\u4FCA\u5CFB\u6625\u77AC\u7AE3\u821C\u99FF\u51C6\u5FAA\u65EC\u696F\u6B89\u6DF3\u6E96\u6F64\u76FE\u7D14\u5DE1\u9075\u9187\u9806\u51E6\u521D\u6240\u6691\u66D9\u6E1A\u5EB6\u7DD2\u7F72\u66F8\u85AF\u85F7\u8AF8\u52A9\u53D9\u5973\u5E8F\u5F90\u6055\u92E4\u9664\u50B7\u511F"],
    ["bea1", "\u52DD\u5320\u5347\u53EC\u54E8\u5546\u5531\u5617\u5968\u59BE\u5A3C\u5BB5\u5C06\u5C0F\u5C11\u5C1A\u5E84\u5E8A\u5EE0\u5F70\u627F\u6284\u62DB\u638C\u6377\u6607\u660C\u662D\u6676\u677E\u68A2\u6A1F\u6A35\u6CBC\u6D88\u6E09\u6E58\u713C\u7126\u7167\u75C7\u7701\u785D\u7901\u7965\u79F0\u7AE0\u7B11\u7CA7\u7D39\u8096\u83D6\u848B\u8549\u885D\u88F3\u8A1F\u8A3C\u8A54\u8A73\u8C61\u8CDE\u91A4\u9266\u937E\u9418\u969C\u9798\u4E0A\u4E08\u4E1E\u4E57\u5197\u5270\u57CE\u5834\u58CC\u5B22\u5E38\u60C5\u64FE\u6761\u6756\u6D44\u72B6\u7573\u7A63\u84B8\u8B72\u91B8\u9320\u5631\u57F4\u98FE"],
    ["bfa1", "\u62ED\u690D\u6B96\u71ED\u7E54\u8077\u8272\u89E6\u98DF\u8755\u8FB1\u5C3B\u4F38\u4FE1\u4FB5\u5507\u5A20\u5BDD\u5BE9\u5FC3\u614E\u632F\u65B0\u664B\u68EE\u699B\u6D78\u6DF1\u7533\u75B9\u771F\u795E\u79E6\u7D33\u81E3\u82AF\u85AA\u89AA\u8A3A\u8EAB\u8F9B\u9032\u91DD\u9707\u4EBA\u4EC1\u5203\u5875\u58EC\u5C0B\u751A\u5C3D\u814E\u8A0A\u8FC5\u9663\u976D\u7B25\u8ACF\u9808\u9162\u56F3\u53A8\u9017\u5439\u5782\u5E25\u63A8\u6C34\u708A\u7761\u7C8B\u7FE0\u8870\u9042\u9154\u9310\u9318\u968F\u745E\u9AC4\u5D07\u5D69\u6570\u67A2\u8DA8\u96DB\u636E\u6749\u6919\u83C5\u9817\u96C0\u88FE"],
    ["c0a1", "\u6F84\u647A\u5BF8\u4E16\u702C\u755D\u662F\u51C4\u5236\u52E2\u59D3\u5F81\u6027\u6210\u653F\u6574\u661F\u6674\u68F2\u6816\u6B63\u6E05\u7272\u751F\u76DB\u7CBE\u8056\u58F0\u88FD\u897F\u8AA0\u8A93\u8ACB\u901D\u9192\u9752\u9759\u6589\u7A0E\u8106\u96BB\u5E2D\u60DC\u621A\u65A5\u6614\u6790\u77F3\u7A4D\u7C4D\u7E3E\u810A\u8CAC\u8D64\u8DE1\u8E5F\u78A9\u5207\u62D9\u63A5\u6442\u6298\u8A2D\u7A83\u7BC0\u8AAC\u96EA\u7D76\u820C\u8749\u4ED9\u5148\u5343\u5360\u5BA3\u5C02\u5C16\u5DDD\u6226\u6247\u64B0\u6813\u6834\u6CC9\u6D45\u6D17\u67D3\u6F5C\u714E\u717D\u65CB\u7A7F\u7BAD\u7DDA"],
    ["c1a1", "\u7E4A\u7FA8\u817A\u821B\u8239\u85A6\u8A6E\u8CCE\u8DF5\u9078\u9077\u92AD\u9291\u9583\u9BAE\u524D\u5584\u6F38\u7136\u5168\u7985\u7E55\u81B3\u7CCE\u564C\u5851\u5CA8\u63AA\u66FE\u66FD\u695A\u72D9\u758F\u758E\u790E\u7956\u79DF\u7C97\u7D20\u7D44\u8607\u8A34\u963B\u9061\u9F20\u50E7\u5275\u53CC\u53E2\u5009\u55AA\u58EE\u594F\u723D\u5B8B\u5C64\u531D\u60E3\u60F3\u635C\u6383\u633F\u63BB\u64CD\u65E9\u66F9\u5DE3\u69CD\u69FD\u6F15\u71E5\u4E89\u75E9\u76F8\u7A93\u7CDF\u7DCF\u7D9C\u8061\u8349\u8358\u846C\u84BC\u85FB\u88C5\u8D70\u9001\u906D\u9397\u971C\u9A12\u50CF\u5897\u618E"],
    ["c2a1", "\u81D3\u8535\u8D08\u9020\u4FC3\u5074\u5247\u5373\u606F\u6349\u675F\u6E2C\u8DB3\u901F\u4FD7\u5C5E\u8CCA\u65CF\u7D9A\u5352\u8896\u5176\u63C3\u5B58\u5B6B\u5C0A\u640D\u6751\u905C\u4ED6\u591A\u592A\u6C70\u8A51\u553E\u5815\u59A5\u60F0\u6253\u67C1\u8235\u6955\u9640\u99C4\u9A28\u4F53\u5806\u5BFE\u8010\u5CB1\u5E2F\u5F85\u6020\u614B\u6234\u66FF\u6CF0\u6EDE\u80CE\u817F\u82D4\u888B\u8CB8\u9000\u902E\u968A\u9EDB\u9BDB\u4EE3\u53F0\u5927\u7B2C\u918D\u984C\u9DF9\u6EDD\u7027\u5353\u5544\u5B85\u6258\u629E\u62D3\u6CA2\u6FEF\u7422\u8A17\u9438\u6FC1\u8AFE\u8338\u51E7\u86F8\u53EA"],
    ["c3a1", "\u53E9\u4F46\u9054\u8FB0\u596A\u8131\u5DFD\u7AEA\u8FBF\u68DA\u8C37\u72F8\u9C48\u6A3D\u8AB0\u4E39\u5358\u5606\u5766\u62C5\u63A2\u65E6\u6B4E\u6DE1\u6E5B\u70AD\u77ED\u7AEF\u7BAA\u7DBB\u803D\u80C6\u86CB\u8A95\u935B\u56E3\u58C7\u5F3E\u65AD\u6696\u6A80\u6BB5\u7537\u8AC7\u5024\u77E5\u5730\u5F1B\u6065\u667A\u6C60\u75F4\u7A1A\u7F6E\u81F4\u8718\u9045\u99B3\u7BC9\u755C\u7AF9\u7B51\u84C4\u9010\u79E9\u7A92\u8336\u5AE1\u7740\u4E2D\u4EF2\u5B99\u5FE0\u62BD\u663C\u67F1\u6CE8\u866B\u8877\u8A3B\u914E\u92F3\u99D0\u6A17\u7026\u732A\u82E7\u8457\u8CAF\u4E01\u5146\u51CB\u558B\u5BF5"],
    ["c4a1", "\u5E16\u5E33\u5E81\u5F14\u5F35\u5F6B\u5FB4\u61F2\u6311\u66A2\u671D\u6F6E\u7252\u753A\u773A\u8074\u8139\u8178\u8776\u8ABF\u8ADC\u8D85\u8DF3\u929A\u9577\u9802\u9CE5\u52C5\u6357\u76F4\u6715\u6C88\u73CD\u8CC3\u93AE\u9673\u6D25\u589C\u690E\u69CC\u8FFD\u939A\u75DB\u901A\u585A\u6802\u63B4\u69FB\u4F43\u6F2C\u67D8\u8FBB\u8526\u7DB4\u9354\u693F\u6F70\u576A\u58F7\u5B2C\u7D2C\u722A\u540A\u91E3\u9DB4\u4EAD\u4F4E\u505C\u5075\u5243\u8C9E\u5448\u5824\u5B9A\u5E1D\u5E95\u5EAD\u5EF7\u5F1F\u608C\u62B5\u633A\u63D0\u68AF\u6C40\u7887\u798E\u7A0B\u7DE0\u8247\u8A02\u8AE6\u8E44\u9013"],
    ["c5a1", "\u90B8\u912D\u91D8\u9F0E\u6CE5\u6458\u64E2\u6575\u6EF4\u7684\u7B1B\u9069\u93D1\u6EBA\u54F2\u5FB9\u64A4\u8F4D\u8FED\u9244\u5178\u586B\u5929\u5C55\u5E97\u6DFB\u7E8F\u751C\u8CBC\u8EE2\u985B\u70B9\u4F1D\u6BBF\u6FB1\u7530\u96FB\u514E\u5410\u5835\u5857\u59AC\u5C60\u5F92\u6597\u675C\u6E21\u767B\u83DF\u8CED\u9014\u90FD\u934D\u7825\u783A\u52AA\u5EA6\u571F\u5974\u6012\u5012\u515A\u51AC\u51CD\u5200\u5510\u5854\u5858\u5957\u5B95\u5CF6\u5D8B\u60BC\u6295\u642D\u6771\u6843\u68BC\u68DF\u76D7\u6DD8\u6E6F\u6D9B\u706F\u71C8\u5F53\u75D8\u7977\u7B49\u7B54\u7B52\u7CD6\u7D71\u5230"],
    ["c6a1", "\u8463\u8569\u85E4\u8A0E\u8B04\u8C46\u8E0F\u9003\u900F\u9419\u9676\u982D\u9A30\u95D8\u50CD\u52D5\u540C\u5802\u5C0E\u61A7\u649E\u6D1E\u77B3\u7AE5\u80F4\u8404\u9053\u9285\u5CE0\u9D07\u533F\u5F97\u5FB3\u6D9C\u7279\u7763\u79BF\u7BE4\u6BD2\u72EC\u8AAD\u6803\u6A61\u51F8\u7A81\u6934\u5C4A\u9CF6\u82EB\u5BC5\u9149\u701E\u5678\u5C6F\u60C7\u6566\u6C8C\u8C5A\u9041\u9813\u5451\u66C7\u920D\u5948\u90A3\u5185\u4E4D\u51EA\u8599\u8B0E\u7058\u637A\u934B\u6962\u99B4\u7E04\u7577\u5357\u6960\u8EDF\u96E3\u6C5D\u4E8C\u5C3C\u5F10\u8FE9\u5302\u8CD1\u8089\u8679\u5EFF\u65E5\u4E73\u5165"],
    ["c7a1", "\u5982\u5C3F\u97EE\u4EFB\u598A\u5FCD\u8A8D\u6FE1\u79B0\u7962\u5BE7\u8471\u732B\u71B1\u5E74\u5FF5\u637B\u649A\u71C3\u7C98\u4E43\u5EFC\u4E4B\u57DC\u56A2\u60A9\u6FC3\u7D0D\u80FD\u8133\u81BF\u8FB2\u8997\u86A4\u5DF4\u628A\u64AD\u8987\u6777\u6CE2\u6D3E\u7436\u7834\u5A46\u7F75\u82AD\u99AC\u4FF3\u5EC3\u62DD\u6392\u6557\u676F\u76C3\u724C\u80CC\u80BA\u8F29\u914D\u500D\u57F9\u5A92\u6885\u6973\u7164\u72FD\u8CB7\u58F2\u8CE0\u966A\u9019\u877F\u79E4\u77E7\u8429\u4F2F\u5265\u535A\u62CD\u67CF\u6CCA\u767D\u7B94\u7C95\u8236\u8584\u8FEB\u66DD\u6F20\u7206\u7E1B\u83AB\u99C1\u9EA6"],
    ["c8a1", "\u51FD\u7BB1\u7872\u7BB8\u8087\u7B48\u6AE8\u5E61\u808C\u7551\u7560\u516B\u9262\u6E8C\u767A\u9197\u9AEA\u4F10\u7F70\u629C\u7B4F\u95A5\u9CE9\u567A\u5859\u86E4\u96BC\u4F34\u5224\u534A\u53CD\u53DB\u5E06\u642C\u6591\u677F\u6C3E\u6C4E\u7248\u72AF\u73ED\u7554\u7E41\u822C\u85E9\u8CA9\u7BC4\u91C6\u7169\u9812\u98EF\u633D\u6669\u756A\u76E4\u78D0\u8543\u86EE\u532A\u5351\u5426\u5983\u5E87\u5F7C\u60B2\u6249\u6279\u62AB\u6590\u6BD4\u6CCC\u75B2\u76AE\u7891\u79D8\u7DCB\u7F77\u80A5\u88AB\u8AB9\u8CBB\u907F\u975E\u98DB\u6A0B\u7C38\u5099\u5C3E\u5FAE\u6787\u6BD8\u7435\u7709\u7F8E"],
    ["c9a1", "\u9F3B\u67CA\u7A17\u5339\u758B\u9AED\u5F66\u819D\u83F1\u8098\u5F3C\u5FC5\u7562\u7B46\u903C\u6867\u59EB\u5A9B\u7D10\u767E\u8B2C\u4FF5\u5F6A\u6A19\u6C37\u6F02\u74E2\u7968\u8868\u8A55\u8C79\u5EDF\u63CF\u75C5\u79D2\u82D7\u9328\u92F2\u849C\u86ED\u9C2D\u54C1\u5F6C\u658C\u6D5C\u7015\u8CA7\u8CD3\u983B\u654F\u74F6\u4E0D\u4ED8\u57E0\u592B\u5A66\u5BCC\u51A8\u5E03\u5E9C\u6016\u6276\u6577\u65A7\u666E\u6D6E\u7236\u7B26\u8150\u819A\u8299\u8B5C\u8CA0\u8CE6\u8D74\u961C\u9644\u4FAE\u64AB\u6B66\u821E\u8461\u856A\u90E8\u5C01\u6953\u98A8\u847A\u8557\u4F0F\u526F\u5FA9\u5E45\u670D"],
    ["caa1", "\u798F\u8179\u8907\u8986\u6DF5\u5F17\u6255\u6CB8\u4ECF\u7269\u9B92\u5206\u543B\u5674\u58B3\u61A4\u626E\u711A\u596E\u7C89\u7CDE\u7D1B\u96F0\u6587\u805E\u4E19\u4F75\u5175\u5840\u5E63\u5E73\u5F0A\u67C4\u4E26\u853D\u9589\u965B\u7C73\u9801\u50FB\u58C1\u7656\u78A7\u5225\u77A5\u8511\u7B86\u504F\u5909\u7247\u7BC7\u7DE8\u8FBA\u8FD4\u904D\u4FBF\u52C9\u5A29\u5F01\u97AD\u4FDD\u8217\u92EA\u5703\u6355\u6B69\u752B\u88DC\u8F14\u7A42\u52DF\u5893\u6155\u620A\u66AE\u6BCD\u7C3F\u83E9\u5023\u4FF8\u5305\u5446\u5831\u5949\u5B9D\u5CF0\u5CEF\u5D29\u5E96\u62B1\u6367\u653E\u65B9\u670B"],
    ["cba1", "\u6CD5\u6CE1\u70F9\u7832\u7E2B\u80DE\u82B3\u840C\u84EC\u8702\u8912\u8A2A\u8C4A\u90A6\u92D2\u98FD\u9CF3\u9D6C\u4E4F\u4EA1\u508D\u5256\u574A\u59A8\u5E3D\u5FD8\u5FD9\u623F\u66B4\u671B\u67D0\u68D2\u5192\u7D21\u80AA\u81A8\u8B00\u8C8C\u8CBF\u927E\u9632\u5420\u982C\u5317\u50D5\u535C\u58A8\u64B2\u6734\u7267\u7766\u7A46\u91E6\u52C3\u6CA1\u6B86\u5800\u5E4C\u5954\u672C\u7FFB\u51E1\u76C6\u6469\u78E8\u9B54\u9EBB\u57CB\u59B9\u6627\u679A\u6BCE\u54E9\u69D9\u5E55\u819C\u6795\u9BAA\u67FE\u9C52\u685D\u4EA6\u4FE3\u53C8\u62B9\u672B\u6CAB\u8FC4\u4FAD\u7E6D\u9EBF\u4E07\u6162\u6E80"],
    ["cca1", "\u6F2B\u8513\u5473\u672A\u9B45\u5DF3\u7B95\u5CAC\u5BC6\u871C\u6E4A\u84D1\u7A14\u8108\u5999\u7C8D\u6C11\u7720\u52D9\u5922\u7121\u725F\u77DB\u9727\u9D61\u690B\u5A7F\u5A18\u51A5\u540D\u547D\u660E\u76DF\u8FF7\u9298\u9CF4\u59EA\u725D\u6EC5\u514D\u68C9\u7DBF\u7DEC\u9762\u9EBA\u6478\u6A21\u8302\u5984\u5B5F\u6BDB\u731B\u76F2\u7DB2\u8017\u8499\u5132\u6728\u9ED9\u76EE\u6762\u52FF\u9905\u5C24\u623B\u7C7E\u8CB0\u554F\u60B6\u7D0B\u9580\u5301\u4E5F\u51B6\u591C\u723A\u8036\u91CE\u5F25\u77E2\u5384\u5F79\u7D04\u85AC\u8A33\u8E8D\u9756\u67F3\u85AE\u9453\u6109\u6108\u6CB9\u7652"],
    ["cda1", "\u8AED\u8F38\u552F\u4F51\u512A\u52C7\u53CB\u5BA5\u5E7D\u60A0\u6182\u63D6\u6709\u67DA\u6E67\u6D8C\u7336\u7337\u7531\u7950\u88D5\u8A98\u904A\u9091\u90F5\u96C4\u878D\u5915\u4E88\u4F59\u4E0E\u8A89\u8F3F\u9810\u50AD\u5E7C\u5996\u5BB9\u5EB8\u63DA\u63FA\u64C1\u66DC\u694A\u69D8\u6D0B\u6EB6\u7194\u7528\u7AAF\u7F8A\u8000\u8449\u84C9\u8981\u8B21\u8E0A\u9065\u967D\u990A\u617E\u6291\u6B32\u6C83\u6D74\u7FCC\u7FFC\u6DC0\u7F85\u87BA\u88F8\u6765\u83B1\u983C\u96F7\u6D1B\u7D61\u843D\u916A\u4E71\u5375\u5D50\u6B04\u6FEB\u85CD\u862D\u89A7\u5229\u540F\u5C65\u674E\u68A8\u7406\u7483"],
    ["cea1", "\u75E2\u88CF\u88E1\u91CC\u96E2\u9678\u5F8B\u7387\u7ACB\u844E\u63A0\u7565\u5289\u6D41\u6E9C\u7409\u7559\u786B\u7C92\u9686\u7ADC\u9F8D\u4FB6\u616E\u65C5\u865C\u4E86\u4EAE\u50DA\u4E21\u51CC\u5BEE\u6599\u6881\u6DBC\u731F\u7642\u77AD\u7A1C\u7CE7\u826F\u8AD2\u907C\u91CF\u9675\u9818\u529B\u7DD1\u502B\u5398\u6797\u6DCB\u71D0\u7433\u81E8\u8F2A\u96A3\u9C57\u9E9F\u7460\u5841\u6D99\u7D2F\u985E\u4EE4\u4F36\u4F8B\u51B7\u52B1\u5DBA\u601C\u73B2\u793C\u82D3\u9234\u96B7\u96F6\u970A\u9E97\u9F62\u66A6\u6B74\u5217\u52A3\u70C8\u88C2\u5EC9\u604B\u6190\u6F23\u7149\u7C3E\u7DF4\u806F"],
    ["cfa1", "\u84EE\u9023\u932C\u5442\u9B6F\u6AD3\u7089\u8CC2\u8DEF\u9732\u52B4\u5A41\u5ECA\u5F04\u6717\u697C\u6994\u6D6A\u6F0F\u7262\u72FC\u7BED\u8001\u807E\u874B\u90CE\u516D\u9E93\u7984\u808B\u9332\u8AD6\u502D\u548C\u8A71\u6B6A\u8CC4\u8107\u60D1\u67A0\u9DF2\u4E99\u4E98\u9C10\u8A6B\u85C1\u8568\u6900\u6E7E\u7897\u8155"],
    ["d0a1", "\u5F0C\u4E10\u4E15\u4E2A\u4E31\u4E36\u4E3C\u4E3F\u4E42\u4E56\u4E58\u4E82\u4E85\u8C6B\u4E8A\u8212\u5F0D\u4E8E\u4E9E\u4E9F\u4EA0\u4EA2\u4EB0\u4EB3\u4EB6\u4ECE\u4ECD\u4EC4\u4EC6\u4EC2\u4ED7\u4EDE\u4EED\u4EDF\u4EF7\u4F09\u4F5A\u4F30\u4F5B\u4F5D\u4F57\u4F47\u4F76\u4F88\u4F8F\u4F98\u4F7B\u4F69\u4F70\u4F91\u4F6F\u4F86\u4F96\u5118\u4FD4\u4FDF\u4FCE\u4FD8\u4FDB\u4FD1\u4FDA\u4FD0\u4FE4\u4FE5\u501A\u5028\u5014\u502A\u5025\u5005\u4F1C\u4FF6\u5021\u5029\u502C\u4FFE\u4FEF\u5011\u5006\u5043\u5047\u6703\u5055\u5050\u5048\u505A\u5056\u506C\u5078\u5080\u509A\u5085\u50B4\u50B2"],
    ["d1a1", "\u50C9\u50CA\u50B3\u50C2\u50D6\u50DE\u50E5\u50ED\u50E3\u50EE\u50F9\u50F5\u5109\u5101\u5102\u5116\u5115\u5114\u511A\u5121\u513A\u5137\u513C\u513B\u513F\u5140\u5152\u514C\u5154\u5162\u7AF8\u5169\u516A\u516E\u5180\u5182\u56D8\u518C\u5189\u518F\u5191\u5193\u5195\u5196\u51A4\u51A6\u51A2\u51A9\u51AA\u51AB\u51B3\u51B1\u51B2\u51B0\u51B5\u51BD\u51C5\u51C9\u51DB\u51E0\u8655\u51E9\u51ED\u51F0\u51F5\u51FE\u5204\u520B\u5214\u520E\u5227\u522A\u522E\u5233\u5239\u524F\u5244\u524B\u524C\u525E\u5254\u526A\u5274\u5269\u5273\u527F\u527D\u528D\u5294\u5292\u5271\u5288\u5291\u8FA8"],
    ["d2a1", "\u8FA7\u52AC\u52AD\u52BC\u52B5\u52C1\u52CD\u52D7\u52DE\u52E3\u52E6\u98ED\u52E0\u52F3\u52F5\u52F8\u52F9\u5306\u5308\u7538\u530D\u5310\u530F\u5315\u531A\u5323\u532F\u5331\u5333\u5338\u5340\u5346\u5345\u4E17\u5349\u534D\u51D6\u535E\u5369\u536E\u5918\u537B\u5377\u5382\u5396\u53A0\u53A6\u53A5\u53AE\u53B0\u53B6\u53C3\u7C12\u96D9\u53DF\u66FC\u71EE\u53EE\u53E8\u53ED\u53FA\u5401\u543D\u5440\u542C\u542D\u543C\u542E\u5436\u5429\u541D\u544E\u548F\u5475\u548E\u545F\u5471\u5477\u5470\u5492\u547B\u5480\u5476\u5484\u5490\u5486\u54C7\u54A2\u54B8\u54A5\u54AC\u54C4\u54C8\u54A8"],
    ["d3a1", "\u54AB\u54C2\u54A4\u54BE\u54BC\u54D8\u54E5\u54E6\u550F\u5514\u54FD\u54EE\u54ED\u54FA\u54E2\u5539\u5540\u5563\u554C\u552E\u555C\u5545\u5556\u5557\u5538\u5533\u555D\u5599\u5580\u54AF\u558A\u559F\u557B\u557E\u5598\u559E\u55AE\u557C\u5583\u55A9\u5587\u55A8\u55DA\u55C5\u55DF\u55C4\u55DC\u55E4\u55D4\u5614\u55F7\u5616\u55FE\u55FD\u561B\u55F9\u564E\u5650\u71DF\u5634\u5636\u5632\u5638\u566B\u5664\u562F\u566C\u566A\u5686\u5680\u568A\u56A0\u5694\u568F\u56A5\u56AE\u56B6\u56B4\u56C2\u56BC\u56C1\u56C3\u56C0\u56C8\u56CE\u56D1\u56D3\u56D7\u56EE\u56F9\u5700\u56FF\u5704\u5709"],
    ["d4a1", "\u5708\u570B\u570D\u5713\u5718\u5716\u55C7\u571C\u5726\u5737\u5738\u574E\u573B\u5740\u574F\u5769\u57C0\u5788\u5761\u577F\u5789\u5793\u57A0\u57B3\u57A4\u57AA\u57B0\u57C3\u57C6\u57D4\u57D2\u57D3\u580A\u57D6\u57E3\u580B\u5819\u581D\u5872\u5821\u5862\u584B\u5870\u6BC0\u5852\u583D\u5879\u5885\u58B9\u589F\u58AB\u58BA\u58DE\u58BB\u58B8\u58AE\u58C5\u58D3\u58D1\u58D7\u58D9\u58D8\u58E5\u58DC\u58E4\u58DF\u58EF\u58FA\u58F9\u58FB\u58FC\u58FD\u5902\u590A\u5910\u591B\u68A6\u5925\u592C\u592D\u5932\u5938\u593E\u7AD2\u5955\u5950\u594E\u595A\u5958\u5962\u5960\u5967\u596C\u5969"],
    ["d5a1", "\u5978\u5981\u599D\u4F5E\u4FAB\u59A3\u59B2\u59C6\u59E8\u59DC\u598D\u59D9\u59DA\u5A25\u5A1F\u5A11\u5A1C\u5A09\u5A1A\u5A40\u5A6C\u5A49\u5A35\u5A36\u5A62\u5A6A\u5A9A\u5ABC\u5ABE\u5ACB\u5AC2\u5ABD\u5AE3\u5AD7\u5AE6\u5AE9\u5AD6\u5AFA\u5AFB\u5B0C\u5B0B\u5B16\u5B32\u5AD0\u5B2A\u5B36\u5B3E\u5B43\u5B45\u5B40\u5B51\u5B55\u5B5A\u5B5B\u5B65\u5B69\u5B70\u5B73\u5B75\u5B78\u6588\u5B7A\u5B80\u5B83\u5BA6\u5BB8\u5BC3\u5BC7\u5BC9\u5BD4\u5BD0\u5BE4\u5BE6\u5BE2\u5BDE\u5BE5\u5BEB\u5BF0\u5BF6\u5BF3\u5C05\u5C07\u5C08\u5C0D\u5C13\u5C20\u5C22\u5C28\u5C38\u5C39\u5C41\u5C46\u5C4E\u5C53"],
    ["d6a1", "\u5C50\u5C4F\u5B71\u5C6C\u5C6E\u4E62\u5C76\u5C79\u5C8C\u5C91\u5C94\u599B\u5CAB\u5CBB\u5CB6\u5CBC\u5CB7\u5CC5\u5CBE\u5CC7\u5CD9\u5CE9\u5CFD\u5CFA\u5CED\u5D8C\u5CEA\u5D0B\u5D15\u5D17\u5D5C\u5D1F\u5D1B\u5D11\u5D14\u5D22\u5D1A\u5D19\u5D18\u5D4C\u5D52\u5D4E\u5D4B\u5D6C\u5D73\u5D76\u5D87\u5D84\u5D82\u5DA2\u5D9D\u5DAC\u5DAE\u5DBD\u5D90\u5DB7\u5DBC\u5DC9\u5DCD\u5DD3\u5DD2\u5DD6\u5DDB\u5DEB\u5DF2\u5DF5\u5E0B\u5E1A\u5E19\u5E11\u5E1B\u5E36\u5E37\u5E44\u5E43\u5E40\u5E4E\u5E57\u5E54\u5E5F\u5E62\u5E64\u5E47\u5E75\u5E76\u5E7A\u9EBC\u5E7F\u5EA0\u5EC1\u5EC2\u5EC8\u5ED0\u5ECF"],
    ["d7a1", "\u5ED6\u5EE3\u5EDD\u5EDA\u5EDB\u5EE2\u5EE1\u5EE8\u5EE9\u5EEC\u5EF1\u5EF3\u5EF0\u5EF4\u5EF8\u5EFE\u5F03\u5F09\u5F5D\u5F5C\u5F0B\u5F11\u5F16\u5F29\u5F2D\u5F38\u5F41\u5F48\u5F4C\u5F4E\u5F2F\u5F51\u5F56\u5F57\u5F59\u5F61\u5F6D\u5F73\u5F77\u5F83\u5F82\u5F7F\u5F8A\u5F88\u5F91\u5F87\u5F9E\u5F99\u5F98\u5FA0\u5FA8\u5FAD\u5FBC\u5FD6\u5FFB\u5FE4\u5FF8\u5FF1\u5FDD\u60B3\u5FFF\u6021\u6060\u6019\u6010\u6029\u600E\u6031\u601B\u6015\u602B\u6026\u600F\u603A\u605A\u6041\u606A\u6077\u605F\u604A\u6046\u604D\u6063\u6043\u6064\u6042\u606C\u606B\u6059\u6081\u608D\u60E7\u6083\u609A"],
    ["d8a1", "\u6084\u609B\u6096\u6097\u6092\u60A7\u608B\u60E1\u60B8\u60E0\u60D3\u60B4\u5FF0\u60BD\u60C6\u60B5\u60D8\u614D\u6115\u6106\u60F6\u60F7\u6100\u60F4\u60FA\u6103\u6121\u60FB\u60F1\u610D\u610E\u6147\u613E\u6128\u6127\u614A\u613F\u613C\u612C\u6134\u613D\u6142\u6144\u6173\u6177\u6158\u6159\u615A\u616B\u6174\u616F\u6165\u6171\u615F\u615D\u6153\u6175\u6199\u6196\u6187\u61AC\u6194\u619A\u618A\u6191\u61AB\u61AE\u61CC\u61CA\u61C9\u61F7\u61C8\u61C3\u61C6\u61BA\u61CB\u7F79\u61CD\u61E6\u61E3\u61F6\u61FA\u61F4\u61FF\u61FD\u61FC\u61FE\u6200\u6208\u6209\u620D\u620C\u6214\u621B"],
    ["d9a1", "\u621E\u6221\u622A\u622E\u6230\u6232\u6233\u6241\u624E\u625E\u6263\u625B\u6260\u6268\u627C\u6282\u6289\u627E\u6292\u6293\u6296\u62D4\u6283\u6294\u62D7\u62D1\u62BB\u62CF\u62FF\u62C6\u64D4\u62C8\u62DC\u62CC\u62CA\u62C2\u62C7\u629B\u62C9\u630C\u62EE\u62F1\u6327\u6302\u6308\u62EF\u62F5\u6350\u633E\u634D\u641C\u634F\u6396\u638E\u6380\u63AB\u6376\u63A3\u638F\u6389\u639F\u63B5\u636B\u6369\u63BE\u63E9\u63C0\u63C6\u63E3\u63C9\u63D2\u63F6\u63C4\u6416\u6434\u6406\u6413\u6426\u6436\u651D\u6417\u6428\u640F\u6467\u646F\u6476\u644E\u652A\u6495\u6493\u64A5\u64A9\u6488\u64BC"],
    ["daa1", "\u64DA\u64D2\u64C5\u64C7\u64BB\u64D8\u64C2\u64F1\u64E7\u8209\u64E0\u64E1\u62AC\u64E3\u64EF\u652C\u64F6\u64F4\u64F2\u64FA\u6500\u64FD\u6518\u651C\u6505\u6524\u6523\u652B\u6534\u6535\u6537\u6536\u6538\u754B\u6548\u6556\u6555\u654D\u6558\u655E\u655D\u6572\u6578\u6582\u6583\u8B8A\u659B\u659F\u65AB\u65B7\u65C3\u65C6\u65C1\u65C4\u65CC\u65D2\u65DB\u65D9\u65E0\u65E1\u65F1\u6772\u660A\u6603\u65FB\u6773\u6635\u6636\u6634\u661C\u664F\u6644\u6649\u6641\u665E\u665D\u6664\u6667\u6668\u665F\u6662\u6670\u6683\u6688\u668E\u6689\u6684\u6698\u669D\u66C1\u66B9\u66C9\u66BE\u66BC"],
    ["dba1", "\u66C4\u66B8\u66D6\u66DA\u66E0\u663F\u66E6\u66E9\u66F0\u66F5\u66F7\u670F\u6716\u671E\u6726\u6727\u9738\u672E\u673F\u6736\u6741\u6738\u6737\u6746\u675E\u6760\u6759\u6763\u6764\u6789\u6770\u67A9\u677C\u676A\u678C\u678B\u67A6\u67A1\u6785\u67B7\u67EF\u67B4\u67EC\u67B3\u67E9\u67B8\u67E4\u67DE\u67DD\u67E2\u67EE\u67B9\u67CE\u67C6\u67E7\u6A9C\u681E\u6846\u6829\u6840\u684D\u6832\u684E\u68B3\u682B\u6859\u6863\u6877\u687F\u689F\u688F\u68AD\u6894\u689D\u689B\u6883\u6AAE\u68B9\u6874\u68B5\u68A0\u68BA\u690F\u688D\u687E\u6901\u68CA\u6908\u68D8\u6922\u6926\u68E1\u690C\u68CD"],
    ["dca1", "\u68D4\u68E7\u68D5\u6936\u6912\u6904\u68D7\u68E3\u6925\u68F9\u68E0\u68EF\u6928\u692A\u691A\u6923\u6921\u68C6\u6979\u6977\u695C\u6978\u696B\u6954\u697E\u696E\u6939\u6974\u693D\u6959\u6930\u6961\u695E\u695D\u6981\u696A\u69B2\u69AE\u69D0\u69BF\u69C1\u69D3\u69BE\u69CE\u5BE8\u69CA\u69DD\u69BB\u69C3\u69A7\u6A2E\u6991\u69A0\u699C\u6995\u69B4\u69DE\u69E8\u6A02\u6A1B\u69FF\u6B0A\u69F9\u69F2\u69E7\u6A05\u69B1\u6A1E\u69ED\u6A14\u69EB\u6A0A\u6A12\u6AC1\u6A23\u6A13\u6A44\u6A0C\u6A72\u6A36\u6A78\u6A47\u6A62\u6A59\u6A66\u6A48\u6A38\u6A22\u6A90\u6A8D\u6AA0\u6A84\u6AA2\u6AA3"],
    ["dda1", "\u6A97\u8617\u6ABB\u6AC3\u6AC2\u6AB8\u6AB3\u6AAC\u6ADE\u6AD1\u6ADF\u6AAA\u6ADA\u6AEA\u6AFB\u6B05\u8616\u6AFA\u6B12\u6B16\u9B31\u6B1F\u6B38\u6B37\u76DC\u6B39\u98EE\u6B47\u6B43\u6B49\u6B50\u6B59\u6B54\u6B5B\u6B5F\u6B61\u6B78\u6B79\u6B7F\u6B80\u6B84\u6B83\u6B8D\u6B98\u6B95\u6B9E\u6BA4\u6BAA\u6BAB\u6BAF\u6BB2\u6BB1\u6BB3\u6BB7\u6BBC\u6BC6\u6BCB\u6BD3\u6BDF\u6BEC\u6BEB\u6BF3\u6BEF\u9EBE\u6C08\u6C13\u6C14\u6C1B\u6C24\u6C23\u6C5E\u6C55\u6C62\u6C6A\u6C82\u6C8D\u6C9A\u6C81\u6C9B\u6C7E\u6C68\u6C73\u6C92\u6C90\u6CC4\u6CF1\u6CD3\u6CBD\u6CD7\u6CC5\u6CDD\u6CAE\u6CB1\u6CBE"],
    ["dea1", "\u6CBA\u6CDB\u6CEF\u6CD9\u6CEA\u6D1F\u884D\u6D36\u6D2B\u6D3D\u6D38\u6D19\u6D35\u6D33\u6D12\u6D0C\u6D63\u6D93\u6D64\u6D5A\u6D79\u6D59\u6D8E\u6D95\u6FE4\u6D85\u6DF9\u6E15\u6E0A\u6DB5\u6DC7\u6DE6\u6DB8\u6DC6\u6DEC\u6DDE\u6DCC\u6DE8\u6DD2\u6DC5\u6DFA\u6DD9\u6DE4\u6DD5\u6DEA\u6DEE\u6E2D\u6E6E\u6E2E\u6E19\u6E72\u6E5F\u6E3E\u6E23\u6E6B\u6E2B\u6E76\u6E4D\u6E1F\u6E43\u6E3A\u6E4E\u6E24\u6EFF\u6E1D\u6E38\u6E82\u6EAA\u6E98\u6EC9\u6EB7\u6ED3\u6EBD\u6EAF\u6EC4\u6EB2\u6ED4\u6ED5\u6E8F\u6EA5\u6EC2\u6E9F\u6F41\u6F11\u704C\u6EEC\u6EF8\u6EFE\u6F3F\u6EF2\u6F31\u6EEF\u6F32\u6ECC"],
    ["dfa1", "\u6F3E\u6F13\u6EF7\u6F86\u6F7A\u6F78\u6F81\u6F80\u6F6F\u6F5B\u6FF3\u6F6D\u6F82\u6F7C\u6F58\u6F8E\u6F91\u6FC2\u6F66\u6FB3\u6FA3\u6FA1\u6FA4\u6FB9\u6FC6\u6FAA\u6FDF\u6FD5\u6FEC\u6FD4\u6FD8\u6FF1\u6FEE\u6FDB\u7009\u700B\u6FFA\u7011\u7001\u700F\u6FFE\u701B\u701A\u6F74\u701D\u7018\u701F\u7030\u703E\u7032\u7051\u7063\u7099\u7092\u70AF\u70F1\u70AC\u70B8\u70B3\u70AE\u70DF\u70CB\u70DD\u70D9\u7109\u70FD\u711C\u7119\u7165\u7155\u7188\u7166\u7162\u714C\u7156\u716C\u718F\u71FB\u7184\u7195\u71A8\u71AC\u71D7\u71B9\u71BE\u71D2\u71C9\u71D4\u71CE\u71E0\u71EC\u71E7\u71F5\u71FC"],
    ["e0a1", "\u71F9\u71FF\u720D\u7210\u721B\u7228\u722D\u722C\u7230\u7232\u723B\u723C\u723F\u7240\u7246\u724B\u7258\u7274\u727E\u7282\u7281\u7287\u7292\u7296\u72A2\u72A7\u72B9\u72B2\u72C3\u72C6\u72C4\u72CE\u72D2\u72E2\u72E0\u72E1\u72F9\u72F7\u500F\u7317\u730A\u731C\u7316\u731D\u7334\u732F\u7329\u7325\u733E\u734E\u734F\u9ED8\u7357\u736A\u7368\u7370\u7378\u7375\u737B\u737A\u73C8\u73B3\u73CE\u73BB\u73C0\u73E5\u73EE\u73DE\u74A2\u7405\u746F\u7425\u73F8\u7432\u743A\u7455\u743F\u745F\u7459\u7441\u745C\u7469\u7470\u7463\u746A\u7476\u747E\u748B\u749E\u74A7\u74CA\u74CF\u74D4\u73F1"],
    ["e1a1", "\u74E0\u74E3\u74E7\u74E9\u74EE\u74F2\u74F0\u74F1\u74F8\u74F7\u7504\u7503\u7505\u750C\u750E\u750D\u7515\u7513\u751E\u7526\u752C\u753C\u7544\u754D\u754A\u7549\u755B\u7546\u755A\u7569\u7564\u7567\u756B\u756D\u7578\u7576\u7586\u7587\u7574\u758A\u7589\u7582\u7594\u759A\u759D\u75A5\u75A3\u75C2\u75B3\u75C3\u75B5\u75BD\u75B8\u75BC\u75B1\u75CD\u75CA\u75D2\u75D9\u75E3\u75DE\u75FE\u75FF\u75FC\u7601\u75F0\u75FA\u75F2\u75F3\u760B\u760D\u7609\u761F\u7627\u7620\u7621\u7622\u7624\u7634\u7630\u763B\u7647\u7648\u7646\u765C\u7658\u7661\u7662\u7668\u7669\u766A\u7667\u766C\u7670"],
    ["e2a1", "\u7672\u7676\u7678\u767C\u7680\u7683\u7688\u768B\u768E\u7696\u7693\u7699\u769A\u76B0\u76B4\u76B8\u76B9\u76BA\u76C2\u76CD\u76D6\u76D2\u76DE\u76E1\u76E5\u76E7\u76EA\u862F\u76FB\u7708\u7707\u7704\u7729\u7724\u771E\u7725\u7726\u771B\u7737\u7738\u7747\u775A\u7768\u776B\u775B\u7765\u777F\u777E\u7779\u778E\u778B\u7791\u77A0\u779E\u77B0\u77B6\u77B9\u77BF\u77BC\u77BD\u77BB\u77C7\u77CD\u77D7\u77DA\u77DC\u77E3\u77EE\u77FC\u780C\u7812\u7926\u7820\u792A\u7845\u788E\u7874\u7886\u787C\u789A\u788C\u78A3\u78B5\u78AA\u78AF\u78D1\u78C6\u78CB\u78D4\u78BE\u78BC\u78C5\u78CA\u78EC"],
    ["e3a1", "\u78E7\u78DA\u78FD\u78F4\u7907\u7912\u7911\u7919\u792C\u792B\u7940\u7960\u7957\u795F\u795A\u7955\u7953\u797A\u797F\u798A\u799D\u79A7\u9F4B\u79AA\u79AE\u79B3\u79B9\u79BA\u79C9\u79D5\u79E7\u79EC\u79E1\u79E3\u7A08\u7A0D\u7A18\u7A19\u7A20\u7A1F\u7980\u7A31\u7A3B\u7A3E\u7A37\u7A43\u7A57\u7A49\u7A61\u7A62\u7A69\u9F9D\u7A70\u7A79\u7A7D\u7A88\u7A97\u7A95\u7A98\u7A96\u7AA9\u7AC8\u7AB0\u7AB6\u7AC5\u7AC4\u7ABF\u9083\u7AC7\u7ACA\u7ACD\u7ACF\u7AD5\u7AD3\u7AD9\u7ADA\u7ADD\u7AE1\u7AE2\u7AE6\u7AED\u7AF0\u7B02\u7B0F\u7B0A\u7B06\u7B33\u7B18\u7B19\u7B1E\u7B35\u7B28\u7B36\u7B50"],
    ["e4a1", "\u7B7A\u7B04\u7B4D\u7B0B\u7B4C\u7B45\u7B75\u7B65\u7B74\u7B67\u7B70\u7B71\u7B6C\u7B6E\u7B9D\u7B98\u7B9F\u7B8D\u7B9C\u7B9A\u7B8B\u7B92\u7B8F\u7B5D\u7B99\u7BCB\u7BC1\u7BCC\u7BCF\u7BB4\u7BC6\u7BDD\u7BE9\u7C11\u7C14\u7BE6\u7BE5\u7C60\u7C00\u7C07\u7C13\u7BF3\u7BF7\u7C17\u7C0D\u7BF6\u7C23\u7C27\u7C2A\u7C1F\u7C37\u7C2B\u7C3D\u7C4C\u7C43\u7C54\u7C4F\u7C40\u7C50\u7C58\u7C5F\u7C64\u7C56\u7C65\u7C6C\u7C75\u7C83\u7C90\u7CA4\u7CAD\u7CA2\u7CAB\u7CA1\u7CA8\u7CB3\u7CB2\u7CB1\u7CAE\u7CB9\u7CBD\u7CC0\u7CC5\u7CC2\u7CD8\u7CD2\u7CDC\u7CE2\u9B3B\u7CEF\u7CF2\u7CF4\u7CF6\u7CFA\u7D06"],
    ["e5a1", "\u7D02\u7D1C\u7D15\u7D0A\u7D45\u7D4B\u7D2E\u7D32\u7D3F\u7D35\u7D46\u7D73\u7D56\u7D4E\u7D72\u7D68\u7D6E\u7D4F\u7D63\u7D93\u7D89\u7D5B\u7D8F\u7D7D\u7D9B\u7DBA\u7DAE\u7DA3\u7DB5\u7DC7\u7DBD\u7DAB\u7E3D\u7DA2\u7DAF\u7DDC\u7DB8\u7D9F\u7DB0\u7DD8\u7DDD\u7DE4\u7DDE\u7DFB\u7DF2\u7DE1\u7E05\u7E0A\u7E23\u7E21\u7E12\u7E31\u7E1F\u7E09\u7E0B\u7E22\u7E46\u7E66\u7E3B\u7E35\u7E39\u7E43\u7E37\u7E32\u7E3A\u7E67\u7E5D\u7E56\u7E5E\u7E59\u7E5A\u7E79\u7E6A\u7E69\u7E7C\u7E7B\u7E83\u7DD5\u7E7D\u8FAE\u7E7F\u7E88\u7E89\u7E8C\u7E92\u7E90\u7E93\u7E94\u7E96\u7E8E\u7E9B\u7E9C\u7F38\u7F3A"],
    ["e6a1", "\u7F45\u7F4C\u7F4D\u7F4E\u7F50\u7F51\u7F55\u7F54\u7F58\u7F5F\u7F60\u7F68\u7F69\u7F67\u7F78\u7F82\u7F86\u7F83\u7F88\u7F87\u7F8C\u7F94\u7F9E\u7F9D\u7F9A\u7FA3\u7FAF\u7FB2\u7FB9\u7FAE\u7FB6\u7FB8\u8B71\u7FC5\u7FC6\u7FCA\u7FD5\u7FD4\u7FE1\u7FE6\u7FE9\u7FF3\u7FF9\u98DC\u8006\u8004\u800B\u8012\u8018\u8019\u801C\u8021\u8028\u803F\u803B\u804A\u8046\u8052\u8058\u805A\u805F\u8062\u8068\u8073\u8072\u8070\u8076\u8079\u807D\u807F\u8084\u8086\u8085\u809B\u8093\u809A\u80AD\u5190\u80AC\u80DB\u80E5\u80D9\u80DD\u80C4\u80DA\u80D6\u8109\u80EF\u80F1\u811B\u8129\u8123\u812F\u814B"],
    ["e7a1", "\u968B\u8146\u813E\u8153\u8151\u80FC\u8171\u816E\u8165\u8166\u8174\u8183\u8188\u818A\u8180\u8182\u81A0\u8195\u81A4\u81A3\u815F\u8193\u81A9\u81B0\u81B5\u81BE\u81B8\u81BD\u81C0\u81C2\u81BA\u81C9\u81CD\u81D1\u81D9\u81D8\u81C8\u81DA\u81DF\u81E0\u81E7\u81FA\u81FB\u81FE\u8201\u8202\u8205\u8207\u820A\u820D\u8210\u8216\u8229\u822B\u8238\u8233\u8240\u8259\u8258\u825D\u825A\u825F\u8264\u8262\u8268\u826A\u826B\u822E\u8271\u8277\u8278\u827E\u828D\u8292\u82AB\u829F\u82BB\u82AC\u82E1\u82E3\u82DF\u82D2\u82F4\u82F3\u82FA\u8393\u8303\u82FB\u82F9\u82DE\u8306\u82DC\u8309\u82D9"],
    ["e8a1", "\u8335\u8334\u8316\u8332\u8331\u8340\u8339\u8350\u8345\u832F\u832B\u8317\u8318\u8385\u839A\u83AA\u839F\u83A2\u8396\u8323\u838E\u8387\u838A\u837C\u83B5\u8373\u8375\u83A0\u8389\u83A8\u83F4\u8413\u83EB\u83CE\u83FD\u8403\u83D8\u840B\u83C1\u83F7\u8407\u83E0\u83F2\u840D\u8422\u8420\u83BD\u8438\u8506\u83FB\u846D\u842A\u843C\u855A\u8484\u8477\u846B\u84AD\u846E\u8482\u8469\u8446\u842C\u846F\u8479\u8435\u84CA\u8462\u84B9\u84BF\u849F\u84D9\u84CD\u84BB\u84DA\u84D0\u84C1\u84C6\u84D6\u84A1\u8521\u84FF\u84F4\u8517\u8518\u852C\u851F\u8515\u8514\u84FC\u8540\u8563\u8558\u8548"],
    ["e9a1", "\u8541\u8602\u854B\u8555\u8580\u85A4\u8588\u8591\u858A\u85A8\u856D\u8594\u859B\u85EA\u8587\u859C\u8577\u857E\u8590\u85C9\u85BA\u85CF\u85B9\u85D0\u85D5\u85DD\u85E5\u85DC\u85F9\u860A\u8613\u860B\u85FE\u85FA\u8606\u8622\u861A\u8630\u863F\u864D\u4E55\u8654\u865F\u8667\u8671\u8693\u86A3\u86A9\u86AA\u868B\u868C\u86B6\u86AF\u86C4\u86C6\u86B0\u86C9\u8823\u86AB\u86D4\u86DE\u86E9\u86EC\u86DF\u86DB\u86EF\u8712\u8706\u8708\u8700\u8703\u86FB\u8711\u8709\u870D\u86F9\u870A\u8734\u873F\u8737\u873B\u8725\u8729\u871A\u8760\u875F\u8778\u874C\u874E\u8774\u8757\u8768\u876E\u8759"],
    ["eaa1", "\u8753\u8763\u876A\u8805\u87A2\u879F\u8782\u87AF\u87CB\u87BD\u87C0\u87D0\u96D6\u87AB\u87C4\u87B3\u87C7\u87C6\u87BB\u87EF\u87F2\u87E0\u880F\u880D\u87FE\u87F6\u87F7\u880E\u87D2\u8811\u8816\u8815\u8822\u8821\u8831\u8836\u8839\u8827\u883B\u8844\u8842\u8852\u8859\u885E\u8862\u886B\u8881\u887E\u889E\u8875\u887D\u88B5\u8872\u8882\u8897\u8892\u88AE\u8899\u88A2\u888D\u88A4\u88B0\u88BF\u88B1\u88C3\u88C4\u88D4\u88D8\u88D9\u88DD\u88F9\u8902\u88FC\u88F4\u88E8\u88F2\u8904\u890C\u890A\u8913\u8943\u891E\u8925\u892A\u892B\u8941\u8944\u893B\u8936\u8938\u894C\u891D\u8960\u895E"],
    ["eba1", "\u8966\u8964\u896D\u896A\u896F\u8974\u8977\u897E\u8983\u8988\u898A\u8993\u8998\u89A1\u89A9\u89A6\u89AC\u89AF\u89B2\u89BA\u89BD\u89BF\u89C0\u89DA\u89DC\u89DD\u89E7\u89F4\u89F8\u8A03\u8A16\u8A10\u8A0C\u8A1B\u8A1D\u8A25\u8A36\u8A41\u8A5B\u8A52\u8A46\u8A48\u8A7C\u8A6D\u8A6C\u8A62\u8A85\u8A82\u8A84\u8AA8\u8AA1\u8A91\u8AA5\u8AA6\u8A9A\u8AA3\u8AC4\u8ACD\u8AC2\u8ADA\u8AEB\u8AF3\u8AE7\u8AE4\u8AF1\u8B14\u8AE0\u8AE2\u8AF7\u8ADE\u8ADB\u8B0C\u8B07\u8B1A\u8AE1\u8B16\u8B10\u8B17\u8B20\u8B33\u97AB\u8B26\u8B2B\u8B3E\u8B28\u8B41\u8B4C\u8B4F\u8B4E\u8B49\u8B56\u8B5B\u8B5A\u8B6B"],
    ["eca1", "\u8B5F\u8B6C\u8B6F\u8B74\u8B7D\u8B80\u8B8C\u8B8E\u8B92\u8B93\u8B96\u8B99\u8B9A\u8C3A\u8C41\u8C3F\u8C48\u8C4C\u8C4E\u8C50\u8C55\u8C62\u8C6C\u8C78\u8C7A\u8C82\u8C89\u8C85\u8C8A\u8C8D\u8C8E\u8C94\u8C7C\u8C98\u621D\u8CAD\u8CAA\u8CBD\u8CB2\u8CB3\u8CAE\u8CB6\u8CC8\u8CC1\u8CE4\u8CE3\u8CDA\u8CFD\u8CFA\u8CFB\u8D04\u8D05\u8D0A\u8D07\u8D0F\u8D0D\u8D10\u9F4E\u8D13\u8CCD\u8D14\u8D16\u8D67\u8D6D\u8D71\u8D73\u8D81\u8D99\u8DC2\u8DBE\u8DBA\u8DCF\u8DDA\u8DD6\u8DCC\u8DDB\u8DCB\u8DEA\u8DEB\u8DDF\u8DE3\u8DFC\u8E08\u8E09\u8DFF\u8E1D\u8E1E\u8E10\u8E1F\u8E42\u8E35\u8E30\u8E34\u8E4A"],
    ["eda1", "\u8E47\u8E49\u8E4C\u8E50\u8E48\u8E59\u8E64\u8E60\u8E2A\u8E63\u8E55\u8E76\u8E72\u8E7C\u8E81\u8E87\u8E85\u8E84\u8E8B\u8E8A\u8E93\u8E91\u8E94\u8E99\u8EAA\u8EA1\u8EAC\u8EB0\u8EC6\u8EB1\u8EBE\u8EC5\u8EC8\u8ECB\u8EDB\u8EE3\u8EFC\u8EFB\u8EEB\u8EFE\u8F0A\u8F05\u8F15\u8F12\u8F19\u8F13\u8F1C\u8F1F\u8F1B\u8F0C\u8F26\u8F33\u8F3B\u8F39\u8F45\u8F42\u8F3E\u8F4C\u8F49\u8F46\u8F4E\u8F57\u8F5C\u8F62\u8F63\u8F64\u8F9C\u8F9F\u8FA3\u8FAD\u8FAF\u8FB7\u8FDA\u8FE5\u8FE2\u8FEA\u8FEF\u9087\u8FF4\u9005\u8FF9\u8FFA\u9011\u9015\u9021\u900D\u901E\u9016\u900B\u9027\u9036\u9035\u9039\u8FF8"],
    ["eea1", "\u904F\u9050\u9051\u9052\u900E\u9049\u903E\u9056\u9058\u905E\u9068\u906F\u9076\u96A8\u9072\u9082\u907D\u9081\u9080\u908A\u9089\u908F\u90A8\u90AF\u90B1\u90B5\u90E2\u90E4\u6248\u90DB\u9102\u9112\u9119\u9132\u9130\u914A\u9156\u9158\u9163\u9165\u9169\u9173\u9172\u918B\u9189\u9182\u91A2\u91AB\u91AF\u91AA\u91B5\u91B4\u91BA\u91C0\u91C1\u91C9\u91CB\u91D0\u91D6\u91DF\u91E1\u91DB\u91FC\u91F5\u91F6\u921E\u91FF\u9214\u922C\u9215\u9211\u925E\u9257\u9245\u9249\u9264\u9248\u9295\u923F\u924B\u9250\u929C\u9296\u9293\u929B\u925A\u92CF\u92B9\u92B7\u92E9\u930F\u92FA\u9344\u932E"],
    ["efa1", "\u9319\u9322\u931A\u9323\u933A\u9335\u933B\u935C\u9360\u937C\u936E\u9356\u93B0\u93AC\u93AD\u9394\u93B9\u93D6\u93D7\u93E8\u93E5\u93D8\u93C3\u93DD\u93D0\u93C8\u93E4\u941A\u9414\u9413\u9403\u9407\u9410\u9436\u942B\u9435\u9421\u943A\u9441\u9452\u9444\u945B\u9460\u9462\u945E\u946A\u9229\u9470\u9475\u9477\u947D\u945A\u947C\u947E\u9481\u947F\u9582\u9587\u958A\u9594\u9596\u9598\u9599\u95A0\u95A8\u95A7\u95AD\u95BC\u95BB\u95B9\u95BE\u95CA\u6FF6\u95C3\u95CD\u95CC\u95D5\u95D4\u95D6\u95DC\u95E1\u95E5\u95E2\u9621\u9628\u962E\u962F\u9642\u964C\u964F\u964B\u9677\u965C\u965E"],
    ["f0a1", "\u965D\u965F\u9666\u9672\u966C\u968D\u9698\u9695\u9697\u96AA\u96A7\u96B1\u96B2\u96B0\u96B4\u96B6\u96B8\u96B9\u96CE\u96CB\u96C9\u96CD\u894D\u96DC\u970D\u96D5\u96F9\u9704\u9706\u9708\u9713\u970E\u9711\u970F\u9716\u9719\u9724\u972A\u9730\u9739\u973D\u973E\u9744\u9746\u9748\u9742\u9749\u975C\u9760\u9764\u9766\u9768\u52D2\u976B\u9771\u9779\u9785\u977C\u9781\u977A\u9786\u978B\u978F\u9790\u979C\u97A8\u97A6\u97A3\u97B3\u97B4\u97C3\u97C6\u97C8\u97CB\u97DC\u97ED\u9F4F\u97F2\u7ADF\u97F6\u97F5\u980F\u980C\u9838\u9824\u9821\u9837\u983D\u9846\u984F\u984B\u986B\u986F\u9870"],
    ["f1a1", "\u9871\u9874\u9873\u98AA\u98AF\u98B1\u98B6\u98C4\u98C3\u98C6\u98E9\u98EB\u9903\u9909\u9912\u9914\u9918\u9921\u991D\u991E\u9924\u9920\u992C\u992E\u993D\u993E\u9942\u9949\u9945\u9950\u994B\u9951\u9952\u994C\u9955\u9997\u9998\u99A5\u99AD\u99AE\u99BC\u99DF\u99DB\u99DD\u99D8\u99D1\u99ED\u99EE\u99F1\u99F2\u99FB\u99F8\u9A01\u9A0F\u9A05\u99E2\u9A19\u9A2B\u9A37\u9A45\u9A42\u9A40\u9A43\u9A3E\u9A55\u9A4D\u9A5B\u9A57\u9A5F\u9A62\u9A65\u9A64\u9A69\u9A6B\u9A6A\u9AAD\u9AB0\u9ABC\u9AC0\u9ACF\u9AD1\u9AD3\u9AD4\u9ADE\u9ADF\u9AE2\u9AE3\u9AE6\u9AEF\u9AEB\u9AEE\u9AF4\u9AF1\u9AF7"],
    ["f2a1", "\u9AFB\u9B06\u9B18\u9B1A\u9B1F\u9B22\u9B23\u9B25\u9B27\u9B28\u9B29\u9B2A\u9B2E\u9B2F\u9B32\u9B44\u9B43\u9B4F\u9B4D\u9B4E\u9B51\u9B58\u9B74\u9B93\u9B83\u9B91\u9B96\u9B97\u9B9F\u9BA0\u9BA8\u9BB4\u9BC0\u9BCA\u9BB9\u9BC6\u9BCF\u9BD1\u9BD2\u9BE3\u9BE2\u9BE4\u9BD4\u9BE1\u9C3A\u9BF2\u9BF1\u9BF0\u9C15\u9C14\u9C09\u9C13\u9C0C\u9C06\u9C08\u9C12\u9C0A\u9C04\u9C2E\u9C1B\u9C25\u9C24\u9C21\u9C30\u9C47\u9C32\u9C46\u9C3E\u9C5A\u9C60\u9C67\u9C76\u9C78\u9CE7\u9CEC\u9CF0\u9D09\u9D08\u9CEB\u9D03\u9D06\u9D2A\u9D26\u9DAF\u9D23\u9D1F\u9D44\u9D15\u9D12\u9D41\u9D3F\u9D3E\u9D46\u9D48"],
    ["f3a1", "\u9D5D\u9D5E\u9D64\u9D51\u9D50\u9D59\u9D72\u9D89\u9D87\u9DAB\u9D6F\u9D7A\u9D9A\u9DA4\u9DA9\u9DB2\u9DC4\u9DC1\u9DBB\u9DB8\u9DBA\u9DC6\u9DCF\u9DC2\u9DD9\u9DD3\u9DF8\u9DE6\u9DED\u9DEF\u9DFD\u9E1A\u9E1B\u9E1E\u9E75\u9E79\u9E7D\u9E81\u9E88\u9E8B\u9E8C\u9E92\u9E95\u9E91\u9E9D\u9EA5\u9EA9\u9EB8\u9EAA\u9EAD\u9761\u9ECC\u9ECE\u9ECF\u9ED0\u9ED4\u9EDC\u9EDE\u9EDD\u9EE0\u9EE5\u9EE8\u9EEF\u9EF4\u9EF6\u9EF7\u9EF9\u9EFB\u9EFC\u9EFD\u9F07\u9F08\u76B7\u9F15\u9F21\u9F2C\u9F3E\u9F4A\u9F52\u9F54\u9F63\u9F5F\u9F60\u9F61\u9F66\u9F67\u9F6C\u9F6A\u9F77\u9F72\u9F76\u9F95\u9F9C\u9FA0"],
    ["f4a1", "\u582F\u69C7\u9059\u7464\u51DC\u7199"],
    ["f9a1", "\u7E8A\u891C\u9348\u9288\u84DC\u4FC9\u70BB\u6631\u68C8\u92F9\u66FB\u5F45\u4E28\u4EE1\u4EFC\u4F00\u4F03\u4F39\u4F56\u4F92\u4F8A\u4F9A\u4F94\u4FCD\u5040\u5022\u4FFF\u501E\u5046\u5070\u5042\u5094\u50F4\u50D8\u514A\u5164\u519D\u51BE\u51EC\u5215\u529C\u52A6\u52C0\u52DB\u5300\u5307\u5324\u5372\u5393\u53B2\u53DD\uFA0E\u549C\u548A\u54A9\u54FF\u5586\u5759\u5765\u57AC\u57C8\u57C7\uFA0F\uFA10\u589E\u58B2\u590B\u5953\u595B\u595D\u5963\u59A4\u59BA\u5B56\u5BC0\u752F\u5BD8\u5BEC\u5C1E\u5CA6\u5CBA\u5CF5\u5D27\u5D53\uFA11\u5D42\u5D6D\u5DB8\u5DB9\u5DD0\u5F21\u5F34\u5F67\u5FB7"],
    ["faa1", "\u5FDE\u605D\u6085\u608A\u60DE\u60D5\u6120\u60F2\u6111\u6137\u6130\u6198\u6213\u62A6\u63F5\u6460\u649D\u64CE\u654E\u6600\u6615\u663B\u6609\u662E\u661E\u6624\u6665\u6657\u6659\uFA12\u6673\u6699\u66A0\u66B2\u66BF\u66FA\u670E\uF929\u6766\u67BB\u6852\u67C0\u6801\u6844\u68CF\uFA13\u6968\uFA14\u6998\u69E2\u6A30\u6A6B\u6A46\u6A73\u6A7E\u6AE2\u6AE4\u6BD6\u6C3F\u6C5C\u6C86\u6C6F\u6CDA\u6D04\u6D87\u6D6F\u6D96\u6DAC\u6DCF\u6DF8\u6DF2\u6DFC\u6E39\u6E5C\u6E27\u6E3C\u6EBF\u6F88\u6FB5\u6FF5\u7005\u7007\u7028\u7085\u70AB\u710F\u7104\u715C\u7146\u7147\uFA15\u71C1\u71FE\u72B1"],
    ["fba1", "\u72BE\u7324\uFA16\u7377\u73BD\u73C9\u73D6\u73E3\u73D2\u7407\u73F5\u7426\u742A\u7429\u742E\u7462\u7489\u749F\u7501\u756F\u7682\u769C\u769E\u769B\u76A6\uFA17\u7746\u52AF\u7821\u784E\u7864\u787A\u7930\uFA18\uFA19\uFA1A\u7994\uFA1B\u799B\u7AD1\u7AE7\uFA1C\u7AEB\u7B9E\uFA1D\u7D48\u7D5C\u7DB7\u7DA0\u7DD6\u7E52\u7F47\u7FA1\uFA1E\u8301\u8362\u837F\u83C7\u83F6\u8448\u84B4\u8553\u8559\u856B\uFA1F\u85B0\uFA20\uFA21\u8807\u88F5\u8A12\u8A37\u8A79\u8AA7\u8ABE\u8ADF\uFA22\u8AF6\u8B53\u8B7F\u8CF0\u8CF4\u8D12\u8D76\uFA23\u8ECF\uFA24\uFA25\u9067\u90DE\uFA26\u9115\u9127\u91DA"],
    ["fca1", "\u91D7\u91DE\u91ED\u91EE\u91E4\u91E5\u9206\u9210\u920A\u923A\u9240\u923C\u924E\u9259\u9251\u9239\u9267\u92A7\u9277\u9278\u92E7\u92D7\u92D9\u92D0\uFA27\u92D5\u92E0\u92D3\u9325\u9321\u92FB\uFA28\u931E\u92FF\u931D\u9302\u9370\u9357\u93A4\u93C6\u93DE\u93F8\u9431\u9445\u9448\u9592\uF9DC\uFA29\u969D\u96AF\u9733\u973B\u9743\u974D\u974F\u9751\u9755\u9857\u9865\uFA2A\uFA2B\u9927\uFA2C\u999E\u9A4E\u9AD9\u9ADC\u9B75\u9B72\u9B8F\u9BB1\u9BBB\u9C00\u9D70\u9D6B\uFA2D\u9E19\u9ED1"],
    ["fcf1", "\u2170", 9, "\uFFE2\uFFE4\uFF07\uFF02"],
    ["8fa2af", "\u02D8\u02C7\xB8\u02D9\u02DD\xAF\u02DB\u02DA\uFF5E\u0384\u0385"],
    ["8fa2c2", "\xA1\xA6\xBF"],
    ["8fa2eb", "\xBA\xAA\xA9\xAE\u2122\xA4\u2116"],
    ["8fa6e1", "\u0386\u0388\u0389\u038A\u03AA"],
    ["8fa6e7", "\u038C"],
    ["8fa6e9", "\u038E\u03AB"],
    ["8fa6ec", "\u038F"],
    ["8fa6f1", "\u03AC\u03AD\u03AE\u03AF\u03CA\u0390\u03CC\u03C2\u03CD\u03CB\u03B0\u03CE"],
    ["8fa7c2", "\u0402", 10, "\u040E\u040F"],
    ["8fa7f2", "\u0452", 10, "\u045E\u045F"],
    ["8fa9a1", "\xC6\u0110"],
    ["8fa9a4", "\u0126"],
    ["8fa9a6", "\u0132"],
    ["8fa9a8", "\u0141\u013F"],
    ["8fa9ab", "\u014A\xD8\u0152"],
    ["8fa9af", "\u0166\xDE"],
    ["8fa9c1", "\xE6\u0111\xF0\u0127\u0131\u0133\u0138\u0142\u0140\u0149\u014B\xF8\u0153\xDF\u0167\xFE"],
    ["8faaa1", "\xC1\xC0\xC4\xC2\u0102\u01CD\u0100\u0104\xC5\xC3\u0106\u0108\u010C\xC7\u010A\u010E\xC9\xC8\xCB\xCA\u011A\u0116\u0112\u0118"],
    ["8faaba", "\u011C\u011E\u0122\u0120\u0124\xCD\xCC\xCF\xCE\u01CF\u0130\u012A\u012E\u0128\u0134\u0136\u0139\u013D\u013B\u0143\u0147\u0145\xD1\xD3\xD2\xD6\xD4\u01D1\u0150\u014C\xD5\u0154\u0158\u0156\u015A\u015C\u0160\u015E\u0164\u0162\xDA\xD9\xDC\xDB\u016C\u01D3\u0170\u016A\u0172\u016E\u0168\u01D7\u01DB\u01D9\u01D5\u0174\xDD\u0178\u0176\u0179\u017D\u017B"],
    ["8faba1", "\xE1\xE0\xE4\xE2\u0103\u01CE\u0101\u0105\xE5\xE3\u0107\u0109\u010D\xE7\u010B\u010F\xE9\xE8\xEB\xEA\u011B\u0117\u0113\u0119\u01F5\u011D\u011F"],
    ["8fabbd", "\u0121\u0125\xED\xEC\xEF\xEE\u01D0"],
    ["8fabc5", "\u012B\u012F\u0129\u0135\u0137\u013A\u013E\u013C\u0144\u0148\u0146\xF1\xF3\xF2\xF6\xF4\u01D2\u0151\u014D\xF5\u0155\u0159\u0157\u015B\u015D\u0161\u015F\u0165\u0163\xFA\xF9\xFC\xFB\u016D\u01D4\u0171\u016B\u0173\u016F\u0169\u01D8\u01DC\u01DA\u01D6\u0175\xFD\xFF\u0177\u017A\u017E\u017C"],
    ["8fb0a1", "\u4E02\u4E04\u4E05\u4E0C\u4E12\u4E1F\u4E23\u4E24\u4E28\u4E2B\u4E2E\u4E2F\u4E30\u4E35\u4E40\u4E41\u4E44\u4E47\u4E51\u4E5A\u4E5C\u4E63\u4E68\u4E69\u4E74\u4E75\u4E79\u4E7F\u4E8D\u4E96\u4E97\u4E9D\u4EAF\u4EB9\u4EC3\u4ED0\u4EDA\u4EDB\u4EE0\u4EE1\u4EE2\u4EE8\u4EEF\u4EF1\u4EF3\u4EF5\u4EFD\u4EFE\u4EFF\u4F00\u4F02\u4F03\u4F08\u4F0B\u4F0C\u4F12\u4F15\u4F16\u4F17\u4F19\u4F2E\u4F31\u4F60\u4F33\u4F35\u4F37\u4F39\u4F3B\u4F3E\u4F40\u4F42\u4F48\u4F49\u4F4B\u4F4C\u4F52\u4F54\u4F56\u4F58\u4F5F\u4F63\u4F6A\u4F6C\u4F6E\u4F71\u4F77\u4F78\u4F79\u4F7A\u4F7D\u4F7E\u4F81\u4F82\u4F84"],
    ["8fb1a1", "\u4F85\u4F89\u4F8A\u4F8C\u4F8E\u4F90\u4F92\u4F93\u4F94\u4F97\u4F99\u4F9A\u4F9E\u4F9F\u4FB2\u4FB7\u4FB9\u4FBB\u4FBC\u4FBD\u4FBE\u4FC0\u4FC1\u4FC5\u4FC6\u4FC8\u4FC9\u4FCB\u4FCC\u4FCD\u4FCF\u4FD2\u4FDC\u4FE0\u4FE2\u4FF0\u4FF2\u4FFC\u4FFD\u4FFF\u5000\u5001\u5004\u5007\u500A\u500C\u500E\u5010\u5013\u5017\u5018\u501B\u501C\u501D\u501E\u5022\u5027\u502E\u5030\u5032\u5033\u5035\u5040\u5041\u5042\u5045\u5046\u504A\u504C\u504E\u5051\u5052\u5053\u5057\u5059\u505F\u5060\u5062\u5063\u5066\u5067\u506A\u506D\u5070\u5071\u503B\u5081\u5083\u5084\u5086\u508A\u508E\u508F\u5090"],
    ["8fb2a1", "\u5092\u5093\u5094\u5096\u509B\u509C\u509E", 4, "\u50AA\u50AF\u50B0\u50B9\u50BA\u50BD\u50C0\u50C3\u50C4\u50C7\u50CC\u50CE\u50D0\u50D3\u50D4\u50D8\u50DC\u50DD\u50DF\u50E2\u50E4\u50E6\u50E8\u50E9\u50EF\u50F1\u50F6\u50FA\u50FE\u5103\u5106\u5107\u5108\u510B\u510C\u510D\u510E\u50F2\u5110\u5117\u5119\u511B\u511C\u511D\u511E\u5123\u5127\u5128\u512C\u512D\u512F\u5131\u5133\u5134\u5135\u5138\u5139\u5142\u514A\u514F\u5153\u5155\u5157\u5158\u515F\u5164\u5166\u517E\u5183\u5184\u518B\u518E\u5198\u519D\u51A1\u51A3\u51AD\u51B8\u51BA\u51BC\u51BE\u51BF\u51C2"],
    ["8fb3a1", "\u51C8\u51CF\u51D1\u51D2\u51D3\u51D5\u51D8\u51DE\u51E2\u51E5\u51EE\u51F2\u51F3\u51F4\u51F7\u5201\u5202\u5205\u5212\u5213\u5215\u5216\u5218\u5222\u5228\u5231\u5232\u5235\u523C\u5245\u5249\u5255\u5257\u5258\u525A\u525C\u525F\u5260\u5261\u5266\u526E\u5277\u5278\u5279\u5280\u5282\u5285\u528A\u528C\u5293\u5295\u5296\u5297\u5298\u529A\u529C\u52A4\u52A5\u52A6\u52A7\u52AF\u52B0\u52B6\u52B7\u52B8\u52BA\u52BB\u52BD\u52C0\u52C4\u52C6\u52C8\u52CC\u52CF\u52D1\u52D4\u52D6\u52DB\u52DC\u52E1\u52E5\u52E8\u52E9\u52EA\u52EC\u52F0\u52F1\u52F4\u52F6\u52F7\u5300\u5303\u530A\u530B"],
    ["8fb4a1", "\u530C\u5311\u5313\u5318\u531B\u531C\u531E\u531F\u5325\u5327\u5328\u5329\u532B\u532C\u532D\u5330\u5332\u5335\u533C\u533D\u533E\u5342\u534C\u534B\u5359\u535B\u5361\u5363\u5365\u536C\u536D\u5372\u5379\u537E\u5383\u5387\u5388\u538E\u5393\u5394\u5399\u539D\u53A1\u53A4\u53AA\u53AB\u53AF\u53B2\u53B4\u53B5\u53B7\u53B8\u53BA\u53BD\u53C0\u53C5\u53CF\u53D2\u53D3\u53D5\u53DA\u53DD\u53DE\u53E0\u53E6\u53E7\u53F5\u5402\u5413\u541A\u5421\u5427\u5428\u542A\u542F\u5431\u5434\u5435\u5443\u5444\u5447\u544D\u544F\u545E\u5462\u5464\u5466\u5467\u5469\u546B\u546D\u546E\u5474\u547F"],
    ["8fb5a1", "\u5481\u5483\u5485\u5488\u5489\u548D\u5491\u5495\u5496\u549C\u549F\u54A1\u54A6\u54A7\u54A9\u54AA\u54AD\u54AE\u54B1\u54B7\u54B9\u54BA\u54BB\u54BF\u54C6\u54CA\u54CD\u54CE\u54E0\u54EA\u54EC\u54EF\u54F6\u54FC\u54FE\u54FF\u5500\u5501\u5505\u5508\u5509\u550C\u550D\u550E\u5515\u552A\u552B\u5532\u5535\u5536\u553B\u553C\u553D\u5541\u5547\u5549\u554A\u554D\u5550\u5551\u5558\u555A\u555B\u555E\u5560\u5561\u5564\u5566\u557F\u5581\u5582\u5586\u5588\u558E\u558F\u5591\u5592\u5593\u5594\u5597\u55A3\u55A4\u55AD\u55B2\u55BF\u55C1\u55C3\u55C6\u55C9\u55CB\u55CC\u55CE\u55D1\u55D2"],
    ["8fb6a1", "\u55D3\u55D7\u55D8\u55DB\u55DE\u55E2\u55E9\u55F6\u55FF\u5605\u5608\u560A\u560D", 5, "\u5619\u562C\u5630\u5633\u5635\u5637\u5639\u563B\u563C\u563D\u563F\u5640\u5641\u5643\u5644\u5646\u5649\u564B\u564D\u564F\u5654\u565E\u5660\u5661\u5662\u5663\u5666\u5669\u566D\u566F\u5671\u5672\u5675\u5684\u5685\u5688\u568B\u568C\u5695\u5699\u569A\u569D\u569E\u569F\u56A6\u56A7\u56A8\u56A9\u56AB\u56AC\u56AD\u56B1\u56B3\u56B7\u56BE\u56C5\u56C9\u56CA\u56CB\u56CF\u56D0\u56CC\u56CD\u56D9\u56DC\u56DD\u56DF\u56E1\u56E4", 4, "\u56F1\u56EB\u56ED"],
    ["8fb7a1", "\u56F6\u56F7\u5701\u5702\u5707\u570A\u570C\u5711\u5715\u571A\u571B\u571D\u5720\u5722\u5723\u5724\u5725\u5729\u572A\u572C\u572E\u572F\u5733\u5734\u573D\u573E\u573F\u5745\u5746\u574C\u574D\u5752\u5762\u5765\u5767\u5768\u576B\u576D", 4, "\u5773\u5774\u5775\u5777\u5779\u577A\u577B\u577C\u577E\u5781\u5783\u578C\u5794\u5797\u5799\u579A\u579C\u579D\u579E\u579F\u57A1\u5795\u57A7\u57A8\u57A9\u57AC\u57B8\u57BD\u57C7\u57C8\u57CC\u57CF\u57D5\u57DD\u57DE\u57E4\u57E6\u57E7\u57E9\u57ED\u57F0\u57F5\u57F6\u57F8\u57FD\u57FE\u57FF\u5803\u5804\u5808\u5809\u57E1"],
    ["8fb8a1", "\u580C\u580D\u581B\u581E\u581F\u5820\u5826\u5827\u582D\u5832\u5839\u583F\u5849\u584C\u584D\u584F\u5850\u5855\u585F\u5861\u5864\u5867\u5868\u5878\u587C\u587F\u5880\u5881\u5887\u5888\u5889\u588A\u588C\u588D\u588F\u5890\u5894\u5896\u589D\u58A0\u58A1\u58A2\u58A6\u58A9\u58B1\u58B2\u58C4\u58BC\u58C2\u58C8\u58CD\u58CE\u58D0\u58D2\u58D4\u58D6\u58DA\u58DD\u58E1\u58E2\u58E9\u58F3\u5905\u5906\u590B\u590C\u5912\u5913\u5914\u8641\u591D\u5921\u5923\u5924\u5928\u592F\u5930\u5933\u5935\u5936\u593F\u5943\u5946\u5952\u5953\u5959\u595B\u595D\u595E\u595F\u5961\u5963\u596B\u596D"],
    ["8fb9a1", "\u596F\u5972\u5975\u5976\u5979\u597B\u597C\u598B\u598C\u598E\u5992\u5995\u5997\u599F\u59A4\u59A7\u59AD\u59AE\u59AF\u59B0\u59B3\u59B7\u59BA\u59BC\u59C1\u59C3\u59C4\u59C8\u59CA\u59CD\u59D2\u59DD\u59DE\u59DF\u59E3\u59E4\u59E7\u59EE\u59EF\u59F1\u59F2\u59F4\u59F7\u5A00\u5A04\u5A0C\u5A0D\u5A0E\u5A12\u5A13\u5A1E\u5A23\u5A24\u5A27\u5A28\u5A2A\u5A2D\u5A30\u5A44\u5A45\u5A47\u5A48\u5A4C\u5A50\u5A55\u5A5E\u5A63\u5A65\u5A67\u5A6D\u5A77\u5A7A\u5A7B\u5A7E\u5A8B\u5A90\u5A93\u5A96\u5A99\u5A9C\u5A9E\u5A9F\u5AA0\u5AA2\u5AA7\u5AAC\u5AB1\u5AB2\u5AB3\u5AB5\u5AB8\u5ABA\u5ABB\u5ABF"],
    ["8fbaa1", "\u5AC4\u5AC6\u5AC8\u5ACF\u5ADA\u5ADC\u5AE0\u5AE5\u5AEA\u5AEE\u5AF5\u5AF6\u5AFD\u5B00\u5B01\u5B08\u5B17\u5B34\u5B19\u5B1B\u5B1D\u5B21\u5B25\u5B2D\u5B38\u5B41\u5B4B\u5B4C\u5B52\u5B56\u5B5E\u5B68\u5B6E\u5B6F\u5B7C\u5B7D\u5B7E\u5B7F\u5B81\u5B84\u5B86\u5B8A\u5B8E\u5B90\u5B91\u5B93\u5B94\u5B96\u5BA8\u5BA9\u5BAC\u5BAD\u5BAF\u5BB1\u5BB2\u5BB7\u5BBA\u5BBC\u5BC0\u5BC1\u5BCD\u5BCF\u5BD6", 4, "\u5BE0\u5BEF\u5BF1\u5BF4\u5BFD\u5C0C\u5C17\u5C1E\u5C1F\u5C23\u5C26\u5C29\u5C2B\u5C2C\u5C2E\u5C30\u5C32\u5C35\u5C36\u5C59\u5C5A\u5C5C\u5C62\u5C63\u5C67\u5C68\u5C69"],
    ["8fbba1", "\u5C6D\u5C70\u5C74\u5C75\u5C7A\u5C7B\u5C7C\u5C7D\u5C87\u5C88\u5C8A\u5C8F\u5C92\u5C9D\u5C9F\u5CA0\u5CA2\u5CA3\u5CA6\u5CAA\u5CB2\u5CB4\u5CB5\u5CBA\u5CC9\u5CCB\u5CD2\u5CDD\u5CD7\u5CEE\u5CF1\u5CF2\u5CF4\u5D01\u5D06\u5D0D\u5D12\u5D2B\u5D23\u5D24\u5D26\u5D27\u5D31\u5D34\u5D39\u5D3D\u5D3F\u5D42\u5D43\u5D46\u5D48\u5D55\u5D51\u5D59\u5D4A\u5D5F\u5D60\u5D61\u5D62\u5D64\u5D6A\u5D6D\u5D70\u5D79\u5D7A\u5D7E\u5D7F\u5D81\u5D83\u5D88\u5D8A\u5D92\u5D93\u5D94\u5D95\u5D99\u5D9B\u5D9F\u5DA0\u5DA7\u5DAB\u5DB0\u5DB4\u5DB8\u5DB9\u5DC3\u5DC7\u5DCB\u5DD0\u5DCE\u5DD8\u5DD9\u5DE0\u5DE4"],
    ["8fbca1", "\u5DE9\u5DF8\u5DF9\u5E00\u5E07\u5E0D\u5E12\u5E14\u5E15\u5E18\u5E1F\u5E20\u5E2E\u5E28\u5E32\u5E35\u5E3E\u5E4B\u5E50\u5E49\u5E51\u5E56\u5E58\u5E5B\u5E5C\u5E5E\u5E68\u5E6A", 4, "\u5E70\u5E80\u5E8B\u5E8E\u5EA2\u5EA4\u5EA5\u5EA8\u5EAA\u5EAC\u5EB1\u5EB3\u5EBD\u5EBE\u5EBF\u5EC6\u5ECC\u5ECB\u5ECE\u5ED1\u5ED2\u5ED4\u5ED5\u5EDC\u5EDE\u5EE5\u5EEB\u5F02\u5F06\u5F07\u5F08\u5F0E\u5F19\u5F1C\u5F1D\u5F21\u5F22\u5F23\u5F24\u5F28\u5F2B\u5F2C\u5F2E\u5F30\u5F34\u5F36\u5F3B\u5F3D\u5F3F\u5F40\u5F44\u5F45\u5F47\u5F4D\u5F50\u5F54\u5F58\u5F5B\u5F60\u5F63\u5F64\u5F67"],
    ["8fbda1", "\u5F6F\u5F72\u5F74\u5F75\u5F78\u5F7A\u5F7D\u5F7E\u5F89\u5F8D\u5F8F\u5F96\u5F9C\u5F9D\u5FA2\u5FA7\u5FAB\u5FA4\u5FAC\u5FAF\u5FB0\u5FB1\u5FB8\u5FC4\u5FC7\u5FC8\u5FC9\u5FCB\u5FD0", 4, "\u5FDE\u5FE1\u5FE2\u5FE8\u5FE9\u5FEA\u5FEC\u5FED\u5FEE\u5FEF\u5FF2\u5FF3\u5FF6\u5FFA\u5FFC\u6007\u600A\u600D\u6013\u6014\u6017\u6018\u601A\u601F\u6024\u602D\u6033\u6035\u6040\u6047\u6048\u6049\u604C\u6051\u6054\u6056\u6057\u605D\u6061\u6067\u6071\u607E\u607F\u6082\u6086\u6088\u608A\u608E\u6091\u6093\u6095\u6098\u609D\u609E\u60A2\u60A4\u60A5\u60A8\u60B0\u60B1\u60B7"],
    ["8fbea1", "\u60BB\u60BE\u60C2\u60C4\u60C8\u60C9\u60CA\u60CB\u60CE\u60CF\u60D4\u60D5\u60D9\u60DB\u60DD\u60DE\u60E2\u60E5\u60F2\u60F5\u60F8\u60FC\u60FD\u6102\u6107\u610A\u610C\u6110", 4, "\u6116\u6117\u6119\u611C\u611E\u6122\u612A\u612B\u6130\u6131\u6135\u6136\u6137\u6139\u6141\u6145\u6146\u6149\u615E\u6160\u616C\u6172\u6178\u617B\u617C\u617F\u6180\u6181\u6183\u6184\u618B\u618D\u6192\u6193\u6197\u6198\u619C\u619D\u619F\u61A0\u61A5\u61A8\u61AA\u61AD\u61B8\u61B9\u61BC\u61C0\u61C1\u61C2\u61CE\u61CF\u61D5\u61DC\u61DD\u61DE\u61DF\u61E1\u61E2\u61E7\u61E9\u61E5"],
    ["8fbfa1", "\u61EC\u61ED\u61EF\u6201\u6203\u6204\u6207\u6213\u6215\u621C\u6220\u6222\u6223\u6227\u6229\u622B\u6239\u623D\u6242\u6243\u6244\u6246\u624C\u6250\u6251\u6252\u6254\u6256\u625A\u625C\u6264\u626D\u626F\u6273\u627A\u627D\u628D\u628E\u628F\u6290\u62A6\u62A8\u62B3\u62B6\u62B7\u62BA\u62BE\u62BF\u62C4\u62CE\u62D5\u62D6\u62DA\u62EA\u62F2\u62F4\u62FC\u62FD\u6303\u6304\u630A\u630B\u630D\u6310\u6313\u6316\u6318\u6329\u632A\u632D\u6335\u6336\u6339\u633C\u6341\u6342\u6343\u6344\u6346\u634A\u634B\u634E\u6352\u6353\u6354\u6358\u635B\u6365\u6366\u636C\u636D\u6371\u6374\u6375"],
    ["8fc0a1", "\u6378\u637C\u637D\u637F\u6382\u6384\u6387\u638A\u6390\u6394\u6395\u6399\u639A\u639E\u63A4\u63A6\u63AD\u63AE\u63AF\u63BD\u63C1\u63C5\u63C8\u63CE\u63D1\u63D3\u63D4\u63D5\u63DC\u63E0\u63E5\u63EA\u63EC\u63F2\u63F3\u63F5\u63F8\u63F9\u6409\u640A\u6410\u6412\u6414\u6418\u641E\u6420\u6422\u6424\u6425\u6429\u642A\u642F\u6430\u6435\u643D\u643F\u644B\u644F\u6451\u6452\u6453\u6454\u645A\u645B\u645C\u645D\u645F\u6460\u6461\u6463\u646D\u6473\u6474\u647B\u647D\u6485\u6487\u648F\u6490\u6491\u6498\u6499\u649B\u649D\u649F\u64A1\u64A3\u64A6\u64A8\u64AC\u64B3\u64BD\u64BE\u64BF"],
    ["8fc1a1", "\u64C4\u64C9\u64CA\u64CB\u64CC\u64CE\u64D0\u64D1\u64D5\u64D7\u64E4\u64E5\u64E9\u64EA\u64ED\u64F0\u64F5\u64F7\u64FB\u64FF\u6501\u6504\u6508\u6509\u650A\u650F\u6513\u6514\u6516\u6519\u651B\u651E\u651F\u6522\u6526\u6529\u652E\u6531\u653A\u653C\u653D\u6543\u6547\u6549\u6550\u6552\u6554\u655F\u6560\u6567\u656B\u657A\u657D\u6581\u6585\u658A\u6592\u6595\u6598\u659D\u65A0\u65A3\u65A6\u65AE\u65B2\u65B3\u65B4\u65BF\u65C2\u65C8\u65C9\u65CE\u65D0\u65D4\u65D6\u65D8\u65DF\u65F0\u65F2\u65F4\u65F5\u65F9\u65FE\u65FF\u6600\u6604\u6608\u6609\u660D\u6611\u6612\u6615\u6616\u661D"],
    ["8fc2a1", "\u661E\u6621\u6622\u6623\u6624\u6626\u6629\u662A\u662B\u662C\u662E\u6630\u6631\u6633\u6639\u6637\u6640\u6645\u6646\u664A\u664C\u6651\u664E\u6657\u6658\u6659\u665B\u665C\u6660\u6661\u66FB\u666A\u666B\u666C\u667E\u6673\u6675\u667F\u6677\u6678\u6679\u667B\u6680\u667C\u668B\u668C\u668D\u6690\u6692\u6699\u669A\u669B\u669C\u669F\u66A0\u66A4\u66AD\u66B1\u66B2\u66B5\u66BB\u66BF\u66C0\u66C2\u66C3\u66C8\u66CC\u66CE\u66CF\u66D4\u66DB\u66DF\u66E8\u66EB\u66EC\u66EE\u66FA\u6705\u6707\u670E\u6713\u6719\u671C\u6720\u6722\u6733\u673E\u6745\u6747\u6748\u674C\u6754\u6755\u675D"],
    ["8fc3a1", "\u6766\u676C\u676E\u6774\u6776\u677B\u6781\u6784\u678E\u678F\u6791\u6793\u6796\u6798\u6799\u679B\u67B0\u67B1\u67B2\u67B5\u67BB\u67BC\u67BD\u67F9\u67C0\u67C2\u67C3\u67C5\u67C8\u67C9\u67D2\u67D7\u67D9\u67DC\u67E1\u67E6\u67F0\u67F2\u67F6\u67F7\u6852\u6814\u6819\u681D\u681F\u6828\u6827\u682C\u682D\u682F\u6830\u6831\u6833\u683B\u683F\u6844\u6845\u684A\u684C\u6855\u6857\u6858\u685B\u686B\u686E", 4, "\u6875\u6879\u687A\u687B\u687C\u6882\u6884\u6886\u6888\u6896\u6898\u689A\u689C\u68A1\u68A3\u68A5\u68A9\u68AA\u68AE\u68B2\u68BB\u68C5\u68C8\u68CC\u68CF"],
    ["8fc4a1", "\u68D0\u68D1\u68D3\u68D6\u68D9\u68DC\u68DD\u68E5\u68E8\u68EA\u68EB\u68EC\u68ED\u68F0\u68F1\u68F5\u68F6\u68FB\u68FC\u68FD\u6906\u6909\u690A\u6910\u6911\u6913\u6916\u6917\u6931\u6933\u6935\u6938\u693B\u6942\u6945\u6949\u694E\u6957\u695B\u6963\u6964\u6965\u6966\u6968\u6969\u696C\u6970\u6971\u6972\u697A\u697B\u697F\u6980\u698D\u6992\u6996\u6998\u69A1\u69A5\u69A6\u69A8\u69AB\u69AD\u69AF\u69B7\u69B8\u69BA\u69BC\u69C5\u69C8\u69D1\u69D6\u69D7\u69E2\u69E5\u69EE\u69EF\u69F1\u69F3\u69F5\u69FE\u6A00\u6A01\u6A03\u6A0F\u6A11\u6A15\u6A1A\u6A1D\u6A20\u6A24\u6A28\u6A30\u6A32"],
    ["8fc5a1", "\u6A34\u6A37\u6A3B\u6A3E\u6A3F\u6A45\u6A46\u6A49\u6A4A\u6A4E\u6A50\u6A51\u6A52\u6A55\u6A56\u6A5B\u6A64\u6A67\u6A6A\u6A71\u6A73\u6A7E\u6A81\u6A83\u6A86\u6A87\u6A89\u6A8B\u6A91\u6A9B\u6A9D\u6A9E\u6A9F\u6AA5\u6AAB\u6AAF\u6AB0\u6AB1\u6AB4\u6ABD\u6ABE\u6ABF\u6AC6\u6AC9\u6AC8\u6ACC\u6AD0\u6AD4\u6AD5\u6AD6\u6ADC\u6ADD\u6AE4\u6AE7\u6AEC\u6AF0\u6AF1\u6AF2\u6AFC\u6AFD\u6B02\u6B03\u6B06\u6B07\u6B09\u6B0F\u6B10\u6B11\u6B17\u6B1B\u6B1E\u6B24\u6B28\u6B2B\u6B2C\u6B2F\u6B35\u6B36\u6B3B\u6B3F\u6B46\u6B4A\u6B4D\u6B52\u6B56\u6B58\u6B5D\u6B60\u6B67\u6B6B\u6B6E\u6B70\u6B75\u6B7D"],
    ["8fc6a1", "\u6B7E\u6B82\u6B85\u6B97\u6B9B\u6B9F\u6BA0\u6BA2\u6BA3\u6BA8\u6BA9\u6BAC\u6BAD\u6BAE\u6BB0\u6BB8\u6BB9\u6BBD\u6BBE\u6BC3\u6BC4\u6BC9\u6BCC\u6BD6\u6BDA\u6BE1\u6BE3\u6BE6\u6BE7\u6BEE\u6BF1\u6BF7\u6BF9\u6BFF\u6C02\u6C04\u6C05\u6C09\u6C0D\u6C0E\u6C10\u6C12\u6C19\u6C1F\u6C26\u6C27\u6C28\u6C2C\u6C2E\u6C33\u6C35\u6C36\u6C3A\u6C3B\u6C3F\u6C4A\u6C4B\u6C4D\u6C4F\u6C52\u6C54\u6C59\u6C5B\u6C5C\u6C6B\u6C6D\u6C6F\u6C74\u6C76\u6C78\u6C79\u6C7B\u6C85\u6C86\u6C87\u6C89\u6C94\u6C95\u6C97\u6C98\u6C9C\u6C9F\u6CB0\u6CB2\u6CB4\u6CC2\u6CC6\u6CCD\u6CCF\u6CD0\u6CD1\u6CD2\u6CD4\u6CD6"],
    ["8fc7a1", "\u6CDA\u6CDC\u6CE0\u6CE7\u6CE9\u6CEB\u6CEC\u6CEE\u6CF2\u6CF4\u6D04\u6D07\u6D0A\u6D0E\u6D0F\u6D11\u6D13\u6D1A\u6D26\u6D27\u6D28\u6C67\u6D2E\u6D2F\u6D31\u6D39\u6D3C\u6D3F\u6D57\u6D5E\u6D5F\u6D61\u6D65\u6D67\u6D6F\u6D70\u6D7C\u6D82\u6D87\u6D91\u6D92\u6D94\u6D96\u6D97\u6D98\u6DAA\u6DAC\u6DB4\u6DB7\u6DB9\u6DBD\u6DBF\u6DC4\u6DC8\u6DCA\u6DCE\u6DCF\u6DD6\u6DDB\u6DDD\u6DDF\u6DE0\u6DE2\u6DE5\u6DE9\u6DEF\u6DF0\u6DF4\u6DF6\u6DFC\u6E00\u6E04\u6E1E\u6E22\u6E27\u6E32\u6E36\u6E39\u6E3B\u6E3C\u6E44\u6E45\u6E48\u6E49\u6E4B\u6E4F\u6E51\u6E52\u6E53\u6E54\u6E57\u6E5C\u6E5D\u6E5E"],
    ["8fc8a1", "\u6E62\u6E63\u6E68\u6E73\u6E7B\u6E7D\u6E8D\u6E93\u6E99\u6EA0\u6EA7\u6EAD\u6EAE\u6EB1\u6EB3\u6EBB\u6EBF\u6EC0\u6EC1\u6EC3\u6EC7\u6EC8\u6ECA\u6ECD\u6ECE\u6ECF\u6EEB\u6EED\u6EEE\u6EF9\u6EFB\u6EFD\u6F04\u6F08\u6F0A\u6F0C\u6F0D\u6F16\u6F18\u6F1A\u6F1B\u6F26\u6F29\u6F2A\u6F2F\u6F30\u6F33\u6F36\u6F3B\u6F3C\u6F2D\u6F4F\u6F51\u6F52\u6F53\u6F57\u6F59\u6F5A\u6F5D\u6F5E\u6F61\u6F62\u6F68\u6F6C\u6F7D\u6F7E\u6F83\u6F87\u6F88\u6F8B\u6F8C\u6F8D\u6F90\u6F92\u6F93\u6F94\u6F96\u6F9A\u6F9F\u6FA0\u6FA5\u6FA6\u6FA7\u6FA8\u6FAE\u6FAF\u6FB0\u6FB5\u6FB6\u6FBC\u6FC5\u6FC7\u6FC8\u6FCA"],
    ["8fc9a1", "\u6FDA\u6FDE\u6FE8\u6FE9\u6FF0\u6FF5\u6FF9\u6FFC\u6FFD\u7000\u7005\u7006\u7007\u700D\u7017\u7020\u7023\u702F\u7034\u7037\u7039\u703C\u7043\u7044\u7048\u7049\u704A\u704B\u7054\u7055\u705D\u705E\u704E\u7064\u7065\u706C\u706E\u7075\u7076\u707E\u7081\u7085\u7086\u7094", 4, "\u709B\u70A4\u70AB\u70B0\u70B1\u70B4\u70B7\u70CA\u70D1\u70D3\u70D4\u70D5\u70D6\u70D8\u70DC\u70E4\u70FA\u7103", 4, "\u710B\u710C\u710F\u711E\u7120\u712B\u712D\u712F\u7130\u7131\u7138\u7141\u7145\u7146\u7147\u714A\u714B\u7150\u7152\u7157\u715A\u715C\u715E\u7160"],
    ["8fcaa1", "\u7168\u7179\u7180\u7185\u7187\u718C\u7192\u719A\u719B\u71A0\u71A2\u71AF\u71B0\u71B2\u71B3\u71BA\u71BF\u71C0\u71C1\u71C4\u71CB\u71CC\u71D3\u71D6\u71D9\u71DA\u71DC\u71F8\u71FE\u7200\u7207\u7208\u7209\u7213\u7217\u721A\u721D\u721F\u7224\u722B\u722F\u7234\u7238\u7239\u7241\u7242\u7243\u7245\u724E\u724F\u7250\u7253\u7255\u7256\u725A\u725C\u725E\u7260\u7263\u7268\u726B\u726E\u726F\u7271\u7277\u7278\u727B\u727C\u727F\u7284\u7289\u728D\u728E\u7293\u729B\u72A8\u72AD\u72AE\u72B1\u72B4\u72BE\u72C1\u72C7\u72C9\u72CC\u72D5\u72D6\u72D8\u72DF\u72E5\u72F3\u72F4\u72FA\u72FB"],
    ["8fcba1", "\u72FE\u7302\u7304\u7305\u7307\u730B\u730D\u7312\u7313\u7318\u7319\u731E\u7322\u7324\u7327\u7328\u732C\u7331\u7332\u7335\u733A\u733B\u733D\u7343\u734D\u7350\u7352\u7356\u7358\u735D\u735E\u735F\u7360\u7366\u7367\u7369\u736B\u736C\u736E\u736F\u7371\u7377\u7379\u737C\u7380\u7381\u7383\u7385\u7386\u738E\u7390\u7393\u7395\u7397\u7398\u739C\u739E\u739F\u73A0\u73A2\u73A5\u73A6\u73AA\u73AB\u73AD\u73B5\u73B7\u73B9\u73BC\u73BD\u73BF\u73C5\u73C6\u73C9\u73CB\u73CC\u73CF\u73D2\u73D3\u73D6\u73D9\u73DD\u73E1\u73E3\u73E6\u73E7\u73E9\u73F4\u73F5\u73F7\u73F9\u73FA\u73FB\u73FD"],
    ["8fcca1", "\u73FF\u7400\u7401\u7404\u7407\u740A\u7411\u741A\u741B\u7424\u7426\u7428", 9, "\u7439\u7440\u7443\u7444\u7446\u7447\u744B\u744D\u7451\u7452\u7457\u745D\u7462\u7466\u7467\u7468\u746B\u746D\u746E\u7471\u7472\u7480\u7481\u7485\u7486\u7487\u7489\u748F\u7490\u7491\u7492\u7498\u7499\u749A\u749C\u749F\u74A0\u74A1\u74A3\u74A6\u74A8\u74A9\u74AA\u74AB\u74AE\u74AF\u74B1\u74B2\u74B5\u74B9\u74BB\u74BF\u74C8\u74C9\u74CC\u74D0\u74D3\u74D8\u74DA\u74DB\u74DE\u74DF\u74E4\u74E8\u74EA\u74EB\u74EF\u74F4\u74FA\u74FB\u74FC\u74FF\u7506"],
    ["8fcda1", "\u7512\u7516\u7517\u7520\u7521\u7524\u7527\u7529\u752A\u752F\u7536\u7539\u753D\u753E\u753F\u7540\u7543\u7547\u7548\u754E\u7550\u7552\u7557\u755E\u755F\u7561\u756F\u7571\u7579", 5, "\u7581\u7585\u7590\u7592\u7593\u7595\u7599\u759C\u75A2\u75A4\u75B4\u75BA\u75BF\u75C0\u75C1\u75C4\u75C6\u75CC\u75CE\u75CF\u75D7\u75DC\u75DF\u75E0\u75E1\u75E4\u75E7\u75EC\u75EE\u75EF\u75F1\u75F9\u7600\u7602\u7603\u7604\u7607\u7608\u760A\u760C\u760F\u7612\u7613\u7615\u7616\u7619\u761B\u761C\u761D\u761E\u7623\u7625\u7626\u7629\u762D\u7632\u7633\u7635\u7638\u7639"],
    ["8fcea1", "\u763A\u763C\u764A\u7640\u7641\u7643\u7644\u7645\u7649\u764B\u7655\u7659\u765F\u7664\u7665\u766D\u766E\u766F\u7671\u7674\u7681\u7685\u768C\u768D\u7695\u769B\u769C\u769D\u769F\u76A0\u76A2", 6, "\u76AA\u76AD\u76BD\u76C1\u76C5\u76C9\u76CB\u76CC\u76CE\u76D4\u76D9\u76E0\u76E6\u76E8\u76EC\u76F0\u76F1\u76F6\u76F9\u76FC\u7700\u7706\u770A\u770E\u7712\u7714\u7715\u7717\u7719\u771A\u771C\u7722\u7728\u772D\u772E\u772F\u7734\u7735\u7736\u7739\u773D\u773E\u7742\u7745\u7746\u774A\u774D\u774E\u774F\u7752\u7756\u7757\u775C\u775E\u775F\u7760\u7762"],
    ["8fcfa1", "\u7764\u7767\u776A\u776C\u7770\u7772\u7773\u7774\u777A\u777D\u7780\u7784\u778C\u778D\u7794\u7795\u7796\u779A\u779F\u77A2\u77A7\u77AA\u77AE\u77AF\u77B1\u77B5\u77BE\u77C3\u77C9\u77D1\u77D2\u77D5\u77D9\u77DE\u77DF\u77E0\u77E4\u77E6\u77EA\u77EC\u77F0\u77F1\u77F4\u77F8\u77FB\u7805\u7806\u7809\u780D\u780E\u7811\u781D\u7821\u7822\u7823\u782D\u782E\u7830\u7835\u7837\u7843\u7844\u7847\u7848\u784C\u784E\u7852\u785C\u785E\u7860\u7861\u7863\u7864\u7868\u786A\u786E\u787A\u787E\u788A\u788F\u7894\u7898\u78A1\u789D\u789E\u789F\u78A4\u78A8\u78AC\u78AD\u78B0\u78B1\u78B2\u78B3"],
    ["8fd0a1", "\u78BB\u78BD\u78BF\u78C7\u78C8\u78C9\u78CC\u78CE\u78D2\u78D3\u78D5\u78D6\u78E4\u78DB\u78DF\u78E0\u78E1\u78E6\u78EA\u78F2\u78F3\u7900\u78F6\u78F7\u78FA\u78FB\u78FF\u7906\u790C\u7910\u791A\u791C\u791E\u791F\u7920\u7925\u7927\u7929\u792D\u7931\u7934\u7935\u793B\u793D\u793F\u7944\u7945\u7946\u794A\u794B\u794F\u7951\u7954\u7958\u795B\u795C\u7967\u7969\u796B\u7972\u7979\u797B\u797C\u797E\u798B\u798C\u7991\u7993\u7994\u7995\u7996\u7998\u799B\u799C\u79A1\u79A8\u79A9\u79AB\u79AF\u79B1\u79B4\u79B8\u79BB\u79C2\u79C4\u79C7\u79C8\u79CA\u79CF\u79D4\u79D6\u79DA\u79DD\u79DE"],
    ["8fd1a1", "\u79E0\u79E2\u79E5\u79EA\u79EB\u79ED\u79F1\u79F8\u79FC\u7A02\u7A03\u7A07\u7A09\u7A0A\u7A0C\u7A11\u7A15\u7A1B\u7A1E\u7A21\u7A27\u7A2B\u7A2D\u7A2F\u7A30\u7A34\u7A35\u7A38\u7A39\u7A3A\u7A44\u7A45\u7A47\u7A48\u7A4C\u7A55\u7A56\u7A59\u7A5C\u7A5D\u7A5F\u7A60\u7A65\u7A67\u7A6A\u7A6D\u7A75\u7A78\u7A7E\u7A80\u7A82\u7A85\u7A86\u7A8A\u7A8B\u7A90\u7A91\u7A94\u7A9E\u7AA0\u7AA3\u7AAC\u7AB3\u7AB5\u7AB9\u7ABB\u7ABC\u7AC6\u7AC9\u7ACC\u7ACE\u7AD1\u7ADB\u7AE8\u7AE9\u7AEB\u7AEC\u7AF1\u7AF4\u7AFB\u7AFD\u7AFE\u7B07\u7B14\u7B1F\u7B23\u7B27\u7B29\u7B2A\u7B2B\u7B2D\u7B2E\u7B2F\u7B30"],
    ["8fd2a1", "\u7B31\u7B34\u7B3D\u7B3F\u7B40\u7B41\u7B47\u7B4E\u7B55\u7B60\u7B64\u7B66\u7B69\u7B6A\u7B6D\u7B6F\u7B72\u7B73\u7B77\u7B84\u7B89\u7B8E\u7B90\u7B91\u7B96\u7B9B\u7B9E\u7BA0\u7BA5\u7BAC\u7BAF\u7BB0\u7BB2\u7BB5\u7BB6\u7BBA\u7BBB\u7BBC\u7BBD\u7BC2\u7BC5\u7BC8\u7BCA\u7BD4\u7BD6\u7BD7\u7BD9\u7BDA\u7BDB\u7BE8\u7BEA\u7BF2\u7BF4\u7BF5\u7BF8\u7BF9\u7BFA\u7BFC\u7BFE\u7C01\u7C02\u7C03\u7C04\u7C06\u7C09\u7C0B\u7C0C\u7C0E\u7C0F\u7C19\u7C1B\u7C20\u7C25\u7C26\u7C28\u7C2C\u7C31\u7C33\u7C34\u7C36\u7C39\u7C3A\u7C46\u7C4A\u7C55\u7C51\u7C52\u7C53\u7C59", 5],
    ["8fd3a1", "\u7C61\u7C63\u7C67\u7C69\u7C6D\u7C6E\u7C70\u7C72\u7C79\u7C7C\u7C7D\u7C86\u7C87\u7C8F\u7C94\u7C9E\u7CA0\u7CA6\u7CB0\u7CB6\u7CB7\u7CBA\u7CBB\u7CBC\u7CBF\u7CC4\u7CC7\u7CC8\u7CC9\u7CCD\u7CCF\u7CD3\u7CD4\u7CD5\u7CD7\u7CD9\u7CDA\u7CDD\u7CE6\u7CE9\u7CEB\u7CF5\u7D03\u7D07\u7D08\u7D09\u7D0F\u7D11\u7D12\u7D13\u7D16\u7D1D\u7D1E\u7D23\u7D26\u7D2A\u7D2D\u7D31\u7D3C\u7D3D\u7D3E\u7D40\u7D41\u7D47\u7D48\u7D4D\u7D51\u7D53\u7D57\u7D59\u7D5A\u7D5C\u7D5D\u7D65\u7D67\u7D6A\u7D70\u7D78\u7D7A\u7D7B\u7D7F\u7D81\u7D82\u7D83\u7D85\u7D86\u7D88\u7D8B\u7D8C\u7D8D\u7D91\u7D96\u7D97\u7D9D"],
    ["8fd4a1", "\u7D9E\u7DA6\u7DA7\u7DAA\u7DB3\u7DB6\u7DB7\u7DB9\u7DC2", 4, "\u7DCC\u7DCD\u7DCE\u7DD7\u7DD9\u7E00\u7DE2\u7DE5\u7DE6\u7DEA\u7DEB\u7DED\u7DF1\u7DF5\u7DF6\u7DF9\u7DFA\u7E08\u7E10\u7E11\u7E15\u7E17\u7E1C\u7E1D\u7E20\u7E27\u7E28\u7E2C\u7E2D\u7E2F\u7E33\u7E36\u7E3F\u7E44\u7E45\u7E47\u7E4E\u7E50\u7E52\u7E58\u7E5F\u7E61\u7E62\u7E65\u7E6B\u7E6E\u7E6F\u7E73\u7E78\u7E7E\u7E81\u7E86\u7E87\u7E8A\u7E8D\u7E91\u7E95\u7E98\u7E9A\u7E9D\u7E9E\u7F3C\u7F3B\u7F3D\u7F3E\u7F3F\u7F43\u7F44\u7F47\u7F4F\u7F52\u7F53\u7F5B\u7F5C\u7F5D\u7F61\u7F63\u7F64\u7F65\u7F66\u7F6D"],
    ["8fd5a1", "\u7F71\u7F7D\u7F7E\u7F7F\u7F80\u7F8B\u7F8D\u7F8F\u7F90\u7F91\u7F96\u7F97\u7F9C\u7FA1\u7FA2\u7FA6\u7FAA\u7FAD\u7FB4\u7FBC\u7FBF\u7FC0\u7FC3\u7FC8\u7FCE\u7FCF\u7FDB\u7FDF\u7FE3\u7FE5\u7FE8\u7FEC\u7FEE\u7FEF\u7FF2\u7FFA\u7FFD\u7FFE\u7FFF\u8007\u8008\u800A\u800D\u800E\u800F\u8011\u8013\u8014\u8016\u801D\u801E\u801F\u8020\u8024\u8026\u802C\u802E\u8030\u8034\u8035\u8037\u8039\u803A\u803C\u803E\u8040\u8044\u8060\u8064\u8066\u806D\u8071\u8075\u8081\u8088\u808E\u809C\u809E\u80A6\u80A7\u80AB\u80B8\u80B9\u80C8\u80CD\u80CF\u80D2\u80D4\u80D5\u80D7\u80D8\u80E0\u80ED\u80EE"],
    ["8fd6a1", "\u80F0\u80F2\u80F3\u80F6\u80F9\u80FA\u80FE\u8103\u810B\u8116\u8117\u8118\u811C\u811E\u8120\u8124\u8127\u812C\u8130\u8135\u813A\u813C\u8145\u8147\u814A\u814C\u8152\u8157\u8160\u8161\u8167\u8168\u8169\u816D\u816F\u8177\u8181\u8190\u8184\u8185\u8186\u818B\u818E\u8196\u8198\u819B\u819E\u81A2\u81AE\u81B2\u81B4\u81BB\u81CB\u81C3\u81C5\u81CA\u81CE\u81CF\u81D5\u81D7\u81DB\u81DD\u81DE\u81E1\u81E4\u81EB\u81EC\u81F0\u81F1\u81F2\u81F5\u81F6\u81F8\u81F9\u81FD\u81FF\u8200\u8203\u820F\u8213\u8214\u8219\u821A\u821D\u8221\u8222\u8228\u8232\u8234\u823A\u8243\u8244\u8245\u8246"],
    ["8fd7a1", "\u824B\u824E\u824F\u8251\u8256\u825C\u8260\u8263\u8267\u826D\u8274\u827B\u827D\u827F\u8280\u8281\u8283\u8284\u8287\u8289\u828A\u828E\u8291\u8294\u8296\u8298\u829A\u829B\u82A0\u82A1\u82A3\u82A4\u82A7\u82A8\u82A9\u82AA\u82AE\u82B0\u82B2\u82B4\u82B7\u82BA\u82BC\u82BE\u82BF\u82C6\u82D0\u82D5\u82DA\u82E0\u82E2\u82E4\u82E8\u82EA\u82ED\u82EF\u82F6\u82F7\u82FD\u82FE\u8300\u8301\u8307\u8308\u830A\u830B\u8354\u831B\u831D\u831E\u831F\u8321\u8322\u832C\u832D\u832E\u8330\u8333\u8337\u833A\u833C\u833D\u8342\u8343\u8344\u8347\u834D\u834E\u8351\u8355\u8356\u8357\u8370\u8378"],
    ["8fd8a1", "\u837D\u837F\u8380\u8382\u8384\u8386\u838D\u8392\u8394\u8395\u8398\u8399\u839B\u839C\u839D\u83A6\u83A7\u83A9\u83AC\u83BE\u83BF\u83C0\u83C7\u83C9\u83CF\u83D0\u83D1\u83D4\u83DD\u8353\u83E8\u83EA\u83F6\u83F8\u83F9\u83FC\u8401\u8406\u840A\u840F\u8411\u8415\u8419\u83AD\u842F\u8439\u8445\u8447\u8448\u844A\u844D\u844F\u8451\u8452\u8456\u8458\u8459\u845A\u845C\u8460\u8464\u8465\u8467\u846A\u8470\u8473\u8474\u8476\u8478\u847C\u847D\u8481\u8485\u8492\u8493\u8495\u849E\u84A6\u84A8\u84A9\u84AA\u84AF\u84B1\u84B4\u84BA\u84BD\u84BE\u84C0\u84C2\u84C7\u84C8\u84CC\u84CF\u84D3"],
    ["8fd9a1", "\u84DC\u84E7\u84EA\u84EF\u84F0\u84F1\u84F2\u84F7\u8532\u84FA\u84FB\u84FD\u8502\u8503\u8507\u850C\u850E\u8510\u851C\u851E\u8522\u8523\u8524\u8525\u8527\u852A\u852B\u852F\u8533\u8534\u8536\u853F\u8546\u854F", 4, "\u8556\u8559\u855C", 6, "\u8564\u856B\u856F\u8579\u857A\u857B\u857D\u857F\u8581\u8585\u8586\u8589\u858B\u858C\u858F\u8593\u8598\u859D\u859F\u85A0\u85A2\u85A5\u85A7\u85B4\u85B6\u85B7\u85B8\u85BC\u85BD\u85BE\u85BF\u85C2\u85C7\u85CA\u85CB\u85CE\u85AD\u85D8\u85DA\u85DF\u85E0\u85E6\u85E8\u85ED\u85F3\u85F6\u85FC"],
    ["8fdaa1", "\u85FF\u8600\u8604\u8605\u860D\u860E\u8610\u8611\u8612\u8618\u8619\u861B\u861E\u8621\u8627\u8629\u8636\u8638\u863A\u863C\u863D\u8640\u8642\u8646\u8652\u8653\u8656\u8657\u8658\u8659\u865D\u8660", 4, "\u8669\u866C\u866F\u8675\u8676\u8677\u867A\u868D\u8691\u8696\u8698\u869A\u869C\u86A1\u86A6\u86A7\u86A8\u86AD\u86B1\u86B3\u86B4\u86B5\u86B7\u86B8\u86B9\u86BF\u86C0\u86C1\u86C3\u86C5\u86D1\u86D2\u86D5\u86D7\u86DA\u86DC\u86E0\u86E3\u86E5\u86E7\u8688\u86FA\u86FC\u86FD\u8704\u8705\u8707\u870B\u870E\u870F\u8710\u8713\u8714\u8719\u871E\u871F\u8721\u8723"],
    ["8fdba1", "\u8728\u872E\u872F\u8731\u8732\u8739\u873A\u873C\u873D\u873E\u8740\u8743\u8745\u874D\u8758\u875D\u8761\u8764\u8765\u876F\u8771\u8772\u877B\u8783", 6, "\u878B\u878C\u8790\u8793\u8795\u8797\u8798\u8799\u879E\u87A0\u87A3\u87A7\u87AC\u87AD\u87AE\u87B1\u87B5\u87BE\u87BF\u87C1\u87C8\u87C9\u87CA\u87CE\u87D5\u87D6\u87D9\u87DA\u87DC\u87DF\u87E2\u87E3\u87E4\u87EA\u87EB\u87ED\u87F1\u87F3\u87F8\u87FA\u87FF\u8801\u8803\u8806\u8809\u880A\u880B\u8810\u8819\u8812\u8813\u8814\u8818\u881A\u881B\u881C\u881E\u881F\u8828\u882D\u882E\u8830\u8832\u8835"],
    ["8fdca1", "\u883A\u883C\u8841\u8843\u8845\u8848\u8849\u884A\u884B\u884E\u8851\u8855\u8856\u8858\u885A\u885C\u885F\u8860\u8864\u8869\u8871\u8879\u887B\u8880\u8898\u889A\u889B\u889C\u889F\u88A0\u88A8\u88AA\u88BA\u88BD\u88BE\u88C0\u88CA", 4, "\u88D1\u88D2\u88D3\u88DB\u88DE\u88E7\u88EF\u88F0\u88F1\u88F5\u88F7\u8901\u8906\u890D\u890E\u890F\u8915\u8916\u8918\u8919\u891A\u891C\u8920\u8926\u8927\u8928\u8930\u8931\u8932\u8935\u8939\u893A\u893E\u8940\u8942\u8945\u8946\u8949\u894F\u8952\u8957\u895A\u895B\u895C\u8961\u8962\u8963\u896B\u896E\u8970\u8973\u8975\u897A"],
    ["8fdda1", "\u897B\u897C\u897D\u8989\u898D\u8990\u8994\u8995\u899B\u899C\u899F\u89A0\u89A5\u89B0\u89B4\u89B5\u89B6\u89B7\u89BC\u89D4", 4, "\u89E5\u89E9\u89EB\u89ED\u89F1\u89F3\u89F6\u89F9\u89FD\u89FF\u8A04\u8A05\u8A07\u8A0F\u8A11\u8A12\u8A14\u8A15\u8A1E\u8A20\u8A22\u8A24\u8A26\u8A2B\u8A2C\u8A2F\u8A35\u8A37\u8A3D\u8A3E\u8A40\u8A43\u8A45\u8A47\u8A49\u8A4D\u8A4E\u8A53\u8A56\u8A57\u8A58\u8A5C\u8A5D\u8A61\u8A65\u8A67\u8A75\u8A76\u8A77\u8A79\u8A7A\u8A7B\u8A7E\u8A7F\u8A80\u8A83\u8A86\u8A8B\u8A8F\u8A90\u8A92\u8A96\u8A97\u8A99\u8A9F\u8AA7\u8AA9\u8AAE\u8AAF\u8AB3"],
    ["8fdea1", "\u8AB6\u8AB7\u8ABB\u8ABE\u8AC3\u8AC6\u8AC8\u8AC9\u8ACA\u8AD1\u8AD3\u8AD4\u8AD5\u8AD7\u8ADD\u8ADF\u8AEC\u8AF0\u8AF4\u8AF5\u8AF6\u8AFC\u8AFF\u8B05\u8B06\u8B0B\u8B11\u8B1C\u8B1E\u8B1F\u8B0A\u8B2D\u8B30\u8B37\u8B3C\u8B42", 4, "\u8B48\u8B52\u8B53\u8B54\u8B59\u8B4D\u8B5E\u8B63\u8B6D\u8B76\u8B78\u8B79\u8B7C\u8B7E\u8B81\u8B84\u8B85\u8B8B\u8B8D\u8B8F\u8B94\u8B95\u8B9C\u8B9E\u8B9F\u8C38\u8C39\u8C3D\u8C3E\u8C45\u8C47\u8C49\u8C4B\u8C4F\u8C51\u8C53\u8C54\u8C57\u8C58\u8C5B\u8C5D\u8C59\u8C63\u8C64\u8C66\u8C68\u8C69\u8C6D\u8C73\u8C75\u8C76\u8C7B\u8C7E\u8C86"],
    ["8fdfa1", "\u8C87\u8C8B\u8C90\u8C92\u8C93\u8C99\u8C9B\u8C9C\u8CA4\u8CB9\u8CBA\u8CC5\u8CC6\u8CC9\u8CCB\u8CCF\u8CD6\u8CD5\u8CD9\u8CDD\u8CE1\u8CE8\u8CEC\u8CEF\u8CF0\u8CF2\u8CF5\u8CF7\u8CF8\u8CFE\u8CFF\u8D01\u8D03\u8D09\u8D12\u8D17\u8D1B\u8D65\u8D69\u8D6C\u8D6E\u8D7F\u8D82\u8D84\u8D88\u8D8D\u8D90\u8D91\u8D95\u8D9E\u8D9F\u8DA0\u8DA6\u8DAB\u8DAC\u8DAF\u8DB2\u8DB5\u8DB7\u8DB9\u8DBB\u8DC0\u8DC5\u8DC6\u8DC7\u8DC8\u8DCA\u8DCE\u8DD1\u8DD4\u8DD5\u8DD7\u8DD9\u8DE4\u8DE5\u8DE7\u8DEC\u8DF0\u8DBC\u8DF1\u8DF2\u8DF4\u8DFD\u8E01\u8E04\u8E05\u8E06\u8E0B\u8E11\u8E14\u8E16\u8E20\u8E21\u8E22"],
    ["8fe0a1", "\u8E23\u8E26\u8E27\u8E31\u8E33\u8E36\u8E37\u8E38\u8E39\u8E3D\u8E40\u8E41\u8E4B\u8E4D\u8E4E\u8E4F\u8E54\u8E5B\u8E5C\u8E5D\u8E5E\u8E61\u8E62\u8E69\u8E6C\u8E6D\u8E6F\u8E70\u8E71\u8E79\u8E7A\u8E7B\u8E82\u8E83\u8E89\u8E90\u8E92\u8E95\u8E9A\u8E9B\u8E9D\u8E9E\u8EA2\u8EA7\u8EA9\u8EAD\u8EAE\u8EB3\u8EB5\u8EBA\u8EBB\u8EC0\u8EC1\u8EC3\u8EC4\u8EC7\u8ECF\u8ED1\u8ED4\u8EDC\u8EE8\u8EEE\u8EF0\u8EF1\u8EF7\u8EF9\u8EFA\u8EED\u8F00\u8F02\u8F07\u8F08\u8F0F\u8F10\u8F16\u8F17\u8F18\u8F1E\u8F20\u8F21\u8F23\u8F25\u8F27\u8F28\u8F2C\u8F2D\u8F2E\u8F34\u8F35\u8F36\u8F37\u8F3A\u8F40\u8F41"],
    ["8fe1a1", "\u8F43\u8F47\u8F4F\u8F51", 4, "\u8F58\u8F5D\u8F5E\u8F65\u8F9D\u8FA0\u8FA1\u8FA4\u8FA5\u8FA6\u8FB5\u8FB6\u8FB8\u8FBE\u8FC0\u8FC1\u8FC6\u8FCA\u8FCB\u8FCD\u8FD0\u8FD2\u8FD3\u8FD5\u8FE0\u8FE3\u8FE4\u8FE8\u8FEE\u8FF1\u8FF5\u8FF6\u8FFB\u8FFE\u9002\u9004\u9008\u900C\u9018\u901B\u9028\u9029\u902F\u902A\u902C\u902D\u9033\u9034\u9037\u903F\u9043\u9044\u904C\u905B\u905D\u9062\u9066\u9067\u906C\u9070\u9074\u9079\u9085\u9088\u908B\u908C\u908E\u9090\u9095\u9097\u9098\u9099\u909B\u90A0\u90A1\u90A2\u90A5\u90B0\u90B2\u90B3\u90B4\u90B6\u90BD\u90CC\u90BE\u90C3"],
    ["8fe2a1", "\u90C4\u90C5\u90C7\u90C8\u90D5\u90D7\u90D8\u90D9\u90DC\u90DD\u90DF\u90E5\u90D2\u90F6\u90EB\u90EF\u90F0\u90F4\u90FE\u90FF\u9100\u9104\u9105\u9106\u9108\u910D\u9110\u9114\u9116\u9117\u9118\u911A\u911C\u911E\u9120\u9125\u9122\u9123\u9127\u9129\u912E\u912F\u9131\u9134\u9136\u9137\u9139\u913A\u913C\u913D\u9143\u9147\u9148\u914F\u9153\u9157\u9159\u915A\u915B\u9161\u9164\u9167\u916D\u9174\u9179\u917A\u917B\u9181\u9183\u9185\u9186\u918A\u918E\u9191\u9193\u9194\u9195\u9198\u919E\u91A1\u91A6\u91A8\u91AC\u91AD\u91AE\u91B0\u91B1\u91B2\u91B3\u91B6\u91BB\u91BC\u91BD\u91BF"],
    ["8fe3a1", "\u91C2\u91C3\u91C5\u91D3\u91D4\u91D7\u91D9\u91DA\u91DE\u91E4\u91E5\u91E9\u91EA\u91EC", 5, "\u91F7\u91F9\u91FB\u91FD\u9200\u9201\u9204\u9205\u9206\u9207\u9209\u920A\u920C\u9210\u9212\u9213\u9216\u9218\u921C\u921D\u9223\u9224\u9225\u9226\u9228\u922E\u922F\u9230\u9233\u9235\u9236\u9238\u9239\u923A\u923C\u923E\u9240\u9242\u9243\u9246\u9247\u924A\u924D\u924E\u924F\u9251\u9258\u9259\u925C\u925D\u9260\u9261\u9265\u9267\u9268\u9269\u926E\u926F\u9270\u9275", 4, "\u927B\u927C\u927D\u927F\u9288\u9289\u928A\u928D\u928E\u9292\u9297"],
    ["8fe4a1", "\u9299\u929F\u92A0\u92A4\u92A5\u92A7\u92A8\u92AB\u92AF\u92B2\u92B6\u92B8\u92BA\u92BB\u92BC\u92BD\u92BF", 4, "\u92C5\u92C6\u92C7\u92C8\u92CB\u92CC\u92CD\u92CE\u92D0\u92D3\u92D5\u92D7\u92D8\u92D9\u92DC\u92DD\u92DF\u92E0\u92E1\u92E3\u92E5\u92E7\u92E8\u92EC\u92EE\u92F0\u92F9\u92FB\u92FF\u9300\u9302\u9308\u930D\u9311\u9314\u9315\u931C\u931D\u931E\u931F\u9321\u9324\u9325\u9327\u9329\u932A\u9333\u9334\u9336\u9337\u9347\u9348\u9349\u9350\u9351\u9352\u9355\u9357\u9358\u935A\u935E\u9364\u9365\u9367\u9369\u936A\u936D\u936F\u9370\u9371\u9373\u9374\u9376"],
    ["8fe5a1", "\u937A\u937D\u937F\u9380\u9381\u9382\u9388\u938A\u938B\u938D\u938F\u9392\u9395\u9398\u939B\u939E\u93A1\u93A3\u93A4\u93A6\u93A8\u93AB\u93B4\u93B5\u93B6\u93BA\u93A9\u93C1\u93C4\u93C5\u93C6\u93C7\u93C9", 4, "\u93D3\u93D9\u93DC\u93DE\u93DF\u93E2\u93E6\u93E7\u93F9\u93F7\u93F8\u93FA\u93FB\u93FD\u9401\u9402\u9404\u9408\u9409\u940D\u940E\u940F\u9415\u9416\u9417\u941F\u942E\u942F\u9431\u9432\u9433\u9434\u943B\u943F\u943D\u9443\u9445\u9448\u944A\u944C\u9455\u9459\u945C\u945F\u9461\u9463\u9468\u946B\u946D\u946E\u946F\u9471\u9472\u9484\u9483\u9578\u9579"],
    ["8fe6a1", "\u957E\u9584\u9588\u958C\u958D\u958E\u959D\u959E\u959F\u95A1\u95A6\u95A9\u95AB\u95AC\u95B4\u95B6\u95BA\u95BD\u95BF\u95C6\u95C8\u95C9\u95CB\u95D0\u95D1\u95D2\u95D3\u95D9\u95DA\u95DD\u95DE\u95DF\u95E0\u95E4\u95E6\u961D\u961E\u9622\u9624\u9625\u9626\u962C\u9631\u9633\u9637\u9638\u9639\u963A\u963C\u963D\u9641\u9652\u9654\u9656\u9657\u9658\u9661\u966E\u9674\u967B\u967C\u967E\u967F\u9681\u9682\u9683\u9684\u9689\u9691\u9696\u969A\u969D\u969F\u96A4\u96A5\u96A6\u96A9\u96AE\u96AF\u96B3\u96BA\u96CA\u96D2\u5DB2\u96D8\u96DA\u96DD\u96DE\u96DF\u96E9\u96EF\u96F1\u96FA\u9702"],
    ["8fe7a1", "\u9703\u9705\u9709\u971A\u971B\u971D\u9721\u9722\u9723\u9728\u9731\u9733\u9741\u9743\u974A\u974E\u974F\u9755\u9757\u9758\u975A\u975B\u9763\u9767\u976A\u976E\u9773\u9776\u9777\u9778\u977B\u977D\u977F\u9780\u9789\u9795\u9796\u9797\u9799\u979A\u979E\u979F\u97A2\u97AC\u97AE\u97B1\u97B2\u97B5\u97B6\u97B8\u97B9\u97BA\u97BC\u97BE\u97BF\u97C1\u97C4\u97C5\u97C7\u97C9\u97CA\u97CC\u97CD\u97CE\u97D0\u97D1\u97D4\u97D7\u97D8\u97D9\u97DD\u97DE\u97E0\u97DB\u97E1\u97E4\u97EF\u97F1\u97F4\u97F7\u97F8\u97FA\u9807\u980A\u9819\u980D\u980E\u9814\u9816\u981C\u981E\u9820\u9823\u9826"],
    ["8fe8a1", "\u982B\u982E\u982F\u9830\u9832\u9833\u9835\u9825\u983E\u9844\u9847\u984A\u9851\u9852\u9853\u9856\u9857\u9859\u985A\u9862\u9863\u9865\u9866\u986A\u986C\u98AB\u98AD\u98AE\u98B0\u98B4\u98B7\u98B8\u98BA\u98BB\u98BF\u98C2\u98C5\u98C8\u98CC\u98E1\u98E3\u98E5\u98E6\u98E7\u98EA\u98F3\u98F6\u9902\u9907\u9908\u9911\u9915\u9916\u9917\u991A\u991B\u991C\u991F\u9922\u9926\u9927\u992B\u9931", 4, "\u9939\u993A\u993B\u993C\u9940\u9941\u9946\u9947\u9948\u994D\u994E\u9954\u9958\u9959\u995B\u995C\u995E\u995F\u9960\u999B\u999D\u999F\u99A6\u99B0\u99B1\u99B2\u99B5"],
    ["8fe9a1", "\u99B9\u99BA\u99BD\u99BF\u99C3\u99C9\u99D3\u99D4\u99D9\u99DA\u99DC\u99DE\u99E7\u99EA\u99EB\u99EC\u99F0\u99F4\u99F5\u99F9\u99FD\u99FE\u9A02\u9A03\u9A04\u9A0B\u9A0C\u9A10\u9A11\u9A16\u9A1E\u9A20\u9A22\u9A23\u9A24\u9A27\u9A2D\u9A2E\u9A33\u9A35\u9A36\u9A38\u9A47\u9A41\u9A44\u9A4A\u9A4B\u9A4C\u9A4E\u9A51\u9A54\u9A56\u9A5D\u9AAA\u9AAC\u9AAE\u9AAF\u9AB2\u9AB4\u9AB5\u9AB6\u9AB9\u9ABB\u9ABE\u9ABF\u9AC1\u9AC3\u9AC6\u9AC8\u9ACE\u9AD0\u9AD2\u9AD5\u9AD6\u9AD7\u9ADB\u9ADC\u9AE0\u9AE4\u9AE5\u9AE7\u9AE9\u9AEC\u9AF2\u9AF3\u9AF5\u9AF9\u9AFA\u9AFD\u9AFF", 4],
    ["8feaa1", "\u9B04\u9B05\u9B08\u9B09\u9B0B\u9B0C\u9B0D\u9B0E\u9B10\u9B12\u9B16\u9B19\u9B1B\u9B1C\u9B20\u9B26\u9B2B\u9B2D\u9B33\u9B34\u9B35\u9B37\u9B39\u9B3A\u9B3D\u9B48\u9B4B\u9B4C\u9B55\u9B56\u9B57\u9B5B\u9B5E\u9B61\u9B63\u9B65\u9B66\u9B68\u9B6A", 4, "\u9B73\u9B75\u9B77\u9B78\u9B79\u9B7F\u9B80\u9B84\u9B85\u9B86\u9B87\u9B89\u9B8A\u9B8B\u9B8D\u9B8F\u9B90\u9B94\u9B9A\u9B9D\u9B9E\u9BA6\u9BA7\u9BA9\u9BAC\u9BB0\u9BB1\u9BB2\u9BB7\u9BB8\u9BBB\u9BBC\u9BBE\u9BBF\u9BC1\u9BC7\u9BC8\u9BCE\u9BD0\u9BD7\u9BD8\u9BDD\u9BDF\u9BE5\u9BE7\u9BEA\u9BEB\u9BEF\u9BF3\u9BF7\u9BF8"],
    ["8feba1", "\u9BF9\u9BFA\u9BFD\u9BFF\u9C00\u9C02\u9C0B\u9C0F\u9C11\u9C16\u9C18\u9C19\u9C1A\u9C1C\u9C1E\u9C22\u9C23\u9C26", 4, "\u9C31\u9C35\u9C36\u9C37\u9C3D\u9C41\u9C43\u9C44\u9C45\u9C49\u9C4A\u9C4E\u9C4F\u9C50\u9C53\u9C54\u9C56\u9C58\u9C5B\u9C5D\u9C5E\u9C5F\u9C63\u9C69\u9C6A\u9C5C\u9C6B\u9C68\u9C6E\u9C70\u9C72\u9C75\u9C77\u9C7B\u9CE6\u9CF2\u9CF7\u9CF9\u9D0B\u9D02\u9D11\u9D17\u9D18\u9D1C\u9D1D\u9D1E\u9D2F\u9D30\u9D32\u9D33\u9D34\u9D3A\u9D3C\u9D45\u9D3D\u9D42\u9D43\u9D47\u9D4A\u9D53\u9D54\u9D5F\u9D63\u9D62\u9D65\u9D69\u9D6A\u9D6B\u9D70\u9D76\u9D77\u9D7B"],
    ["8feca1", "\u9D7C\u9D7E\u9D83\u9D84\u9D86\u9D8A\u9D8D\u9D8E\u9D92\u9D93\u9D95\u9D96\u9D97\u9D98\u9DA1\u9DAA\u9DAC\u9DAE\u9DB1\u9DB5\u9DB9\u9DBC\u9DBF\u9DC3\u9DC7\u9DC9\u9DCA\u9DD4\u9DD5\u9DD6\u9DD7\u9DDA\u9DDE\u9DDF\u9DE0\u9DE5\u9DE7\u9DE9\u9DEB\u9DEE\u9DF0\u9DF3\u9DF4\u9DFE\u9E0A\u9E02\u9E07\u9E0E\u9E10\u9E11\u9E12\u9E15\u9E16\u9E19\u9E1C\u9E1D\u9E7A\u9E7B\u9E7C\u9E80\u9E82\u9E83\u9E84\u9E85\u9E87\u9E8E\u9E8F\u9E96\u9E98\u9E9B\u9E9E\u9EA4\u9EA8\u9EAC\u9EAE\u9EAF\u9EB0\u9EB3\u9EB4\u9EB5\u9EC6\u9EC8\u9ECB\u9ED5\u9EDF\u9EE4\u9EE7\u9EEC\u9EED\u9EEE\u9EF0\u9EF1\u9EF2\u9EF5"],
    ["8feda1", "\u9EF8\u9EFF\u9F02\u9F03\u9F09\u9F0F\u9F10\u9F11\u9F12\u9F14\u9F16\u9F17\u9F19\u9F1A\u9F1B\u9F1F\u9F22\u9F26\u9F2A\u9F2B\u9F2F\u9F31\u9F32\u9F34\u9F37\u9F39\u9F3A\u9F3C\u9F3D\u9F3F\u9F41\u9F43", 4, "\u9F53\u9F55\u9F56\u9F57\u9F58\u9F5A\u9F5D\u9F5E\u9F68\u9F69\u9F6D", 4, "\u9F73\u9F75\u9F7A\u9F7D\u9F8F\u9F90\u9F91\u9F92\u9F94\u9F96\u9F97\u9F9E\u9FA1\u9FA2\u9FA3\u9FA5"]
  ];
});
var require_cp936 = __commonJS2((exports, module) => {
  module.exports = [
    ["0", "\0", 127, "\u20AC"],
    ["8140", "\u4E02\u4E04\u4E05\u4E06\u4E0F\u4E12\u4E17\u4E1F\u4E20\u4E21\u4E23\u4E26\u4E29\u4E2E\u4E2F\u4E31\u4E33\u4E35\u4E37\u4E3C\u4E40\u4E41\u4E42\u4E44\u4E46\u4E4A\u4E51\u4E55\u4E57\u4E5A\u4E5B\u4E62\u4E63\u4E64\u4E65\u4E67\u4E68\u4E6A", 5, "\u4E72\u4E74", 9, "\u4E7F", 6, "\u4E87\u4E8A"],
    ["8180", "\u4E90\u4E96\u4E97\u4E99\u4E9C\u4E9D\u4E9E\u4EA3\u4EAA\u4EAF\u4EB0\u4EB1\u4EB4\u4EB6\u4EB7\u4EB8\u4EB9\u4EBC\u4EBD\u4EBE\u4EC8\u4ECC\u4ECF\u4ED0\u4ED2\u4EDA\u4EDB\u4EDC\u4EE0\u4EE2\u4EE6\u4EE7\u4EE9\u4EED\u4EEE\u4EEF\u4EF1\u4EF4\u4EF8\u4EF9\u4EFA\u4EFC\u4EFE\u4F00\u4F02", 6, "\u4F0B\u4F0C\u4F12", 4, "\u4F1C\u4F1D\u4F21\u4F23\u4F28\u4F29\u4F2C\u4F2D\u4F2E\u4F31\u4F33\u4F35\u4F37\u4F39\u4F3B\u4F3E", 4, "\u4F44\u4F45\u4F47", 5, "\u4F52\u4F54\u4F56\u4F61\u4F62\u4F66\u4F68\u4F6A\u4F6B\u4F6D\u4F6E\u4F71\u4F72\u4F75\u4F77\u4F78\u4F79\u4F7A\u4F7D\u4F80\u4F81\u4F82\u4F85\u4F86\u4F87\u4F8A\u4F8C\u4F8E\u4F90\u4F92\u4F93\u4F95\u4F96\u4F98\u4F99\u4F9A\u4F9C\u4F9E\u4F9F\u4FA1\u4FA2"],
    ["8240", "\u4FA4\u4FAB\u4FAD\u4FB0", 4, "\u4FB6", 8, "\u4FC0\u4FC1\u4FC2\u4FC6\u4FC7\u4FC8\u4FC9\u4FCB\u4FCC\u4FCD\u4FD2", 4, "\u4FD9\u4FDB\u4FE0\u4FE2\u4FE4\u4FE5\u4FE7\u4FEB\u4FEC\u4FF0\u4FF2\u4FF4\u4FF5\u4FF6\u4FF7\u4FF9\u4FFB\u4FFC\u4FFD\u4FFF", 11],
    ["8280", "\u500B\u500E\u5010\u5011\u5013\u5015\u5016\u5017\u501B\u501D\u501E\u5020\u5022\u5023\u5024\u5027\u502B\u502F", 10, "\u503B\u503D\u503F\u5040\u5041\u5042\u5044\u5045\u5046\u5049\u504A\u504B\u504D\u5050", 4, "\u5056\u5057\u5058\u5059\u505B\u505D", 7, "\u5066", 5, "\u506D", 8, "\u5078\u5079\u507A\u507C\u507D\u5081\u5082\u5083\u5084\u5086\u5087\u5089\u508A\u508B\u508C\u508E", 20, "\u50A4\u50A6\u50AA\u50AB\u50AD", 4, "\u50B3", 6, "\u50BC"],
    ["8340", "\u50BD", 17, "\u50D0", 5, "\u50D7\u50D8\u50D9\u50DB", 10, "\u50E8\u50E9\u50EA\u50EB\u50EF\u50F0\u50F1\u50F2\u50F4\u50F6", 4, "\u50FC", 9, "\u5108"],
    ["8380", "\u5109\u510A\u510C", 5, "\u5113", 13, "\u5122", 28, "\u5142\u5147\u514A\u514C\u514E\u514F\u5150\u5152\u5153\u5157\u5158\u5159\u515B\u515D", 4, "\u5163\u5164\u5166\u5167\u5169\u516A\u516F\u5172\u517A\u517E\u517F\u5183\u5184\u5186\u5187\u518A\u518B\u518E\u518F\u5190\u5191\u5193\u5194\u5198\u519A\u519D\u519E\u519F\u51A1\u51A3\u51A6", 4, "\u51AD\u51AE\u51B4\u51B8\u51B9\u51BA\u51BE\u51BF\u51C1\u51C2\u51C3\u51C5\u51C8\u51CA\u51CD\u51CE\u51D0\u51D2", 5],
    ["8440", "\u51D8\u51D9\u51DA\u51DC\u51DE\u51DF\u51E2\u51E3\u51E5", 5, "\u51EC\u51EE\u51F1\u51F2\u51F4\u51F7\u51FE\u5204\u5205\u5209\u520B\u520C\u520F\u5210\u5213\u5214\u5215\u521C\u521E\u521F\u5221\u5222\u5223\u5225\u5226\u5227\u522A\u522C\u522F\u5231\u5232\u5234\u5235\u523C\u523E\u5244", 5, "\u524B\u524E\u524F\u5252\u5253\u5255\u5257\u5258"],
    ["8480", "\u5259\u525A\u525B\u525D\u525F\u5260\u5262\u5263\u5264\u5266\u5268\u526B\u526C\u526D\u526E\u5270\u5271\u5273", 9, "\u527E\u5280\u5283", 4, "\u5289", 6, "\u5291\u5292\u5294", 6, "\u529C\u52A4\u52A5\u52A6\u52A7\u52AE\u52AF\u52B0\u52B4", 9, "\u52C0\u52C1\u52C2\u52C4\u52C5\u52C6\u52C8\u52CA\u52CC\u52CD\u52CE\u52CF\u52D1\u52D3\u52D4\u52D5\u52D7\u52D9", 5, "\u52E0\u52E1\u52E2\u52E3\u52E5", 10, "\u52F1", 7, "\u52FB\u52FC\u52FD\u5301\u5302\u5303\u5304\u5307\u5309\u530A\u530B\u530C\u530E"],
    ["8540", "\u5311\u5312\u5313\u5314\u5318\u531B\u531C\u531E\u531F\u5322\u5324\u5325\u5327\u5328\u5329\u532B\u532C\u532D\u532F", 9, "\u533C\u533D\u5340\u5342\u5344\u5346\u534B\u534C\u534D\u5350\u5354\u5358\u5359\u535B\u535D\u5365\u5368\u536A\u536C\u536D\u5372\u5376\u5379\u537B\u537C\u537D\u537E\u5380\u5381\u5383\u5387\u5388\u538A\u538E\u538F"],
    ["8580", "\u5390", 4, "\u5396\u5397\u5399\u539B\u539C\u539E\u53A0\u53A1\u53A4\u53A7\u53AA\u53AB\u53AC\u53AD\u53AF", 6, "\u53B7\u53B8\u53B9\u53BA\u53BC\u53BD\u53BE\u53C0\u53C3", 4, "\u53CE\u53CF\u53D0\u53D2\u53D3\u53D5\u53DA\u53DC\u53DD\u53DE\u53E1\u53E2\u53E7\u53F4\u53FA\u53FE\u53FF\u5400\u5402\u5405\u5407\u540B\u5414\u5418\u5419\u541A\u541C\u5422\u5424\u5425\u542A\u5430\u5433\u5436\u5437\u543A\u543D\u543F\u5441\u5442\u5444\u5445\u5447\u5449\u544C\u544D\u544E\u544F\u5451\u545A\u545D", 4, "\u5463\u5465\u5467\u5469", 7, "\u5474\u5479\u547A\u547E\u547F\u5481\u5483\u5485\u5487\u5488\u5489\u548A\u548D\u5491\u5493\u5497\u5498\u549C\u549E\u549F\u54A0\u54A1"],
    ["8640", "\u54A2\u54A5\u54AE\u54B0\u54B2\u54B5\u54B6\u54B7\u54B9\u54BA\u54BC\u54BE\u54C3\u54C5\u54CA\u54CB\u54D6\u54D8\u54DB\u54E0", 4, "\u54EB\u54EC\u54EF\u54F0\u54F1\u54F4", 5, "\u54FB\u54FE\u5500\u5502\u5503\u5504\u5505\u5508\u550A", 4, "\u5512\u5513\u5515", 5, "\u551C\u551D\u551E\u551F\u5521\u5525\u5526"],
    ["8680", "\u5528\u5529\u552B\u552D\u5532\u5534\u5535\u5536\u5538\u5539\u553A\u553B\u553D\u5540\u5542\u5545\u5547\u5548\u554B", 4, "\u5551\u5552\u5553\u5554\u5557", 4, "\u555D\u555E\u555F\u5560\u5562\u5563\u5568\u5569\u556B\u556F", 5, "\u5579\u557A\u557D\u557F\u5585\u5586\u558C\u558D\u558E\u5590\u5592\u5593\u5595\u5596\u5597\u559A\u559B\u559E\u55A0", 6, "\u55A8", 8, "\u55B2\u55B4\u55B6\u55B8\u55BA\u55BC\u55BF", 4, "\u55C6\u55C7\u55C8\u55CA\u55CB\u55CE\u55CF\u55D0\u55D5\u55D7", 4, "\u55DE\u55E0\u55E2\u55E7\u55E9\u55ED\u55EE\u55F0\u55F1\u55F4\u55F6\u55F8", 4, "\u55FF\u5602\u5603\u5604\u5605"],
    ["8740", "\u5606\u5607\u560A\u560B\u560D\u5610", 7, "\u5619\u561A\u561C\u561D\u5620\u5621\u5622\u5625\u5626\u5628\u5629\u562A\u562B\u562E\u562F\u5630\u5633\u5635\u5637\u5638\u563A\u563C\u563D\u563E\u5640", 11, "\u564F", 4, "\u5655\u5656\u565A\u565B\u565D", 4],
    ["8780", "\u5663\u5665\u5666\u5667\u566D\u566E\u566F\u5670\u5672\u5673\u5674\u5675\u5677\u5678\u5679\u567A\u567D", 7, "\u5687", 6, "\u5690\u5691\u5692\u5694", 14, "\u56A4", 10, "\u56B0", 6, "\u56B8\u56B9\u56BA\u56BB\u56BD", 12, "\u56CB", 8, "\u56D5\u56D6\u56D8\u56D9\u56DC\u56E3\u56E5", 5, "\u56EC\u56EE\u56EF\u56F2\u56F3\u56F6\u56F7\u56F8\u56FB\u56FC\u5700\u5701\u5702\u5705\u5707\u570B", 6],
    ["8840", "\u5712", 9, "\u571D\u571E\u5720\u5721\u5722\u5724\u5725\u5726\u5727\u572B\u5731\u5732\u5734", 4, "\u573C\u573D\u573F\u5741\u5743\u5744\u5745\u5746\u5748\u5749\u574B\u5752", 4, "\u5758\u5759\u5762\u5763\u5765\u5767\u576C\u576E\u5770\u5771\u5772\u5774\u5775\u5778\u5779\u577A\u577D\u577E\u577F\u5780"],
    ["8880", "\u5781\u5787\u5788\u5789\u578A\u578D", 4, "\u5794", 6, "\u579C\u579D\u579E\u579F\u57A5\u57A8\u57AA\u57AC\u57AF\u57B0\u57B1\u57B3\u57B5\u57B6\u57B7\u57B9", 8, "\u57C4", 6, "\u57CC\u57CD\u57D0\u57D1\u57D3\u57D6\u57D7\u57DB\u57DC\u57DE\u57E1\u57E2\u57E3\u57E5", 7, "\u57EE\u57F0\u57F1\u57F2\u57F3\u57F5\u57F6\u57F7\u57FB\u57FC\u57FE\u57FF\u5801\u5803\u5804\u5805\u5808\u5809\u580A\u580C\u580E\u580F\u5810\u5812\u5813\u5814\u5816\u5817\u5818\u581A\u581B\u581C\u581D\u581F\u5822\u5823\u5825", 4, "\u582B", 4, "\u5831\u5832\u5833\u5834\u5836", 7],
    ["8940", "\u583E", 5, "\u5845", 6, "\u584E\u584F\u5850\u5852\u5853\u5855\u5856\u5857\u5859", 4, "\u585F", 5, "\u5866", 4, "\u586D", 16, "\u587F\u5882\u5884\u5886\u5887\u5888\u588A\u588B\u588C"],
    ["8980", "\u588D", 4, "\u5894", 4, "\u589B\u589C\u589D\u58A0", 7, "\u58AA", 17, "\u58BD\u58BE\u58BF\u58C0\u58C2\u58C3\u58C4\u58C6", 10, "\u58D2\u58D3\u58D4\u58D6", 13, "\u58E5", 5, "\u58ED\u58EF\u58F1\u58F2\u58F4\u58F5\u58F7\u58F8\u58FA", 7, "\u5903\u5905\u5906\u5908", 4, "\u590E\u5910\u5911\u5912\u5913\u5917\u5918\u591B\u591D\u591E\u5920\u5921\u5922\u5923\u5926\u5928\u592C\u5930\u5932\u5933\u5935\u5936\u593B"],
    ["8a40", "\u593D\u593E\u593F\u5940\u5943\u5945\u5946\u594A\u594C\u594D\u5950\u5952\u5953\u5959\u595B", 4, "\u5961\u5963\u5964\u5966", 12, "\u5975\u5977\u597A\u597B\u597C\u597E\u597F\u5980\u5985\u5989\u598B\u598C\u598E\u598F\u5990\u5991\u5994\u5995\u5998\u599A\u599B\u599C\u599D\u599F\u59A0\u59A1\u59A2\u59A6"],
    ["8a80", "\u59A7\u59AC\u59AD\u59B0\u59B1\u59B3", 5, "\u59BA\u59BC\u59BD\u59BF", 6, "\u59C7\u59C8\u59C9\u59CC\u59CD\u59CE\u59CF\u59D5\u59D6\u59D9\u59DB\u59DE", 4, "\u59E4\u59E6\u59E7\u59E9\u59EA\u59EB\u59ED", 11, "\u59FA\u59FC\u59FD\u59FE\u5A00\u5A02\u5A0A\u5A0B\u5A0D\u5A0E\u5A0F\u5A10\u5A12\u5A14\u5A15\u5A16\u5A17\u5A19\u5A1A\u5A1B\u5A1D\u5A1E\u5A21\u5A22\u5A24\u5A26\u5A27\u5A28\u5A2A", 6, "\u5A33\u5A35\u5A37", 4, "\u5A3D\u5A3E\u5A3F\u5A41", 4, "\u5A47\u5A48\u5A4B", 9, "\u5A56\u5A57\u5A58\u5A59\u5A5B", 5],
    ["8b40", "\u5A61\u5A63\u5A64\u5A65\u5A66\u5A68\u5A69\u5A6B", 8, "\u5A78\u5A79\u5A7B\u5A7C\u5A7D\u5A7E\u5A80", 17, "\u5A93", 6, "\u5A9C", 13, "\u5AAB\u5AAC"],
    ["8b80", "\u5AAD", 4, "\u5AB4\u5AB6\u5AB7\u5AB9", 4, "\u5ABF\u5AC0\u5AC3", 5, "\u5ACA\u5ACB\u5ACD", 4, "\u5AD3\u5AD5\u5AD7\u5AD9\u5ADA\u5ADB\u5ADD\u5ADE\u5ADF\u5AE2\u5AE4\u5AE5\u5AE7\u5AE8\u5AEA\u5AEC", 4, "\u5AF2", 22, "\u5B0A", 11, "\u5B18", 25, "\u5B33\u5B35\u5B36\u5B38", 7, "\u5B41", 6],
    ["8c40", "\u5B48", 7, "\u5B52\u5B56\u5B5E\u5B60\u5B61\u5B67\u5B68\u5B6B\u5B6D\u5B6E\u5B6F\u5B72\u5B74\u5B76\u5B77\u5B78\u5B79\u5B7B\u5B7C\u5B7E\u5B7F\u5B82\u5B86\u5B8A\u5B8D\u5B8E\u5B90\u5B91\u5B92\u5B94\u5B96\u5B9F\u5BA7\u5BA8\u5BA9\u5BAC\u5BAD\u5BAE\u5BAF\u5BB1\u5BB2\u5BB7\u5BBA\u5BBB\u5BBC\u5BC0\u5BC1\u5BC3\u5BC8\u5BC9\u5BCA\u5BCB\u5BCD\u5BCE\u5BCF"],
    ["8c80", "\u5BD1\u5BD4", 8, "\u5BE0\u5BE2\u5BE3\u5BE6\u5BE7\u5BE9", 4, "\u5BEF\u5BF1", 6, "\u5BFD\u5BFE\u5C00\u5C02\u5C03\u5C05\u5C07\u5C08\u5C0B\u5C0C\u5C0D\u5C0E\u5C10\u5C12\u5C13\u5C17\u5C19\u5C1B\u5C1E\u5C1F\u5C20\u5C21\u5C23\u5C26\u5C28\u5C29\u5C2A\u5C2B\u5C2D\u5C2E\u5C2F\u5C30\u5C32\u5C33\u5C35\u5C36\u5C37\u5C43\u5C44\u5C46\u5C47\u5C4C\u5C4D\u5C52\u5C53\u5C54\u5C56\u5C57\u5C58\u5C5A\u5C5B\u5C5C\u5C5D\u5C5F\u5C62\u5C64\u5C67", 6, "\u5C70\u5C72", 6, "\u5C7B\u5C7C\u5C7D\u5C7E\u5C80\u5C83", 4, "\u5C89\u5C8A\u5C8B\u5C8E\u5C8F\u5C92\u5C93\u5C95\u5C9D", 4, "\u5CA4", 4],
    ["8d40", "\u5CAA\u5CAE\u5CAF\u5CB0\u5CB2\u5CB4\u5CB6\u5CB9\u5CBA\u5CBB\u5CBC\u5CBE\u5CC0\u5CC2\u5CC3\u5CC5", 5, "\u5CCC", 5, "\u5CD3", 5, "\u5CDA", 6, "\u5CE2\u5CE3\u5CE7\u5CE9\u5CEB\u5CEC\u5CEE\u5CEF\u5CF1", 9, "\u5CFC", 4],
    ["8d80", "\u5D01\u5D04\u5D05\u5D08", 5, "\u5D0F", 4, "\u5D15\u5D17\u5D18\u5D19\u5D1A\u5D1C\u5D1D\u5D1F", 4, "\u5D25\u5D28\u5D2A\u5D2B\u5D2C\u5D2F", 4, "\u5D35", 7, "\u5D3F", 7, "\u5D48\u5D49\u5D4D", 10, "\u5D59\u5D5A\u5D5C\u5D5E", 10, "\u5D6A\u5D6D\u5D6E\u5D70\u5D71\u5D72\u5D73\u5D75", 12, "\u5D83", 21, "\u5D9A\u5D9B\u5D9C\u5D9E\u5D9F\u5DA0"],
    ["8e40", "\u5DA1", 21, "\u5DB8", 12, "\u5DC6", 6, "\u5DCE", 12, "\u5DDC\u5DDF\u5DE0\u5DE3\u5DE4\u5DEA\u5DEC\u5DED"],
    ["8e80", "\u5DF0\u5DF5\u5DF6\u5DF8", 4, "\u5DFF\u5E00\u5E04\u5E07\u5E09\u5E0A\u5E0B\u5E0D\u5E0E\u5E12\u5E13\u5E17\u5E1E", 7, "\u5E28", 4, "\u5E2F\u5E30\u5E32", 4, "\u5E39\u5E3A\u5E3E\u5E3F\u5E40\u5E41\u5E43\u5E46", 5, "\u5E4D", 6, "\u5E56", 4, "\u5E5C\u5E5D\u5E5F\u5E60\u5E63", 14, "\u5E75\u5E77\u5E79\u5E7E\u5E81\u5E82\u5E83\u5E85\u5E88\u5E89\u5E8C\u5E8D\u5E8E\u5E92\u5E98\u5E9B\u5E9D\u5EA1\u5EA2\u5EA3\u5EA4\u5EA8", 4, "\u5EAE", 4, "\u5EB4\u5EBA\u5EBB\u5EBC\u5EBD\u5EBF", 6],
    ["8f40", "\u5EC6\u5EC7\u5EC8\u5ECB", 5, "\u5ED4\u5ED5\u5ED7\u5ED8\u5ED9\u5EDA\u5EDC", 11, "\u5EE9\u5EEB", 8, "\u5EF5\u5EF8\u5EF9\u5EFB\u5EFC\u5EFD\u5F05\u5F06\u5F07\u5F09\u5F0C\u5F0D\u5F0E\u5F10\u5F12\u5F14\u5F16\u5F19\u5F1A\u5F1C\u5F1D\u5F1E\u5F21\u5F22\u5F23\u5F24"],
    ["8f80", "\u5F28\u5F2B\u5F2C\u5F2E\u5F30\u5F32", 6, "\u5F3B\u5F3D\u5F3E\u5F3F\u5F41", 14, "\u5F51\u5F54\u5F59\u5F5A\u5F5B\u5F5C\u5F5E\u5F5F\u5F60\u5F63\u5F65\u5F67\u5F68\u5F6B\u5F6E\u5F6F\u5F72\u5F74\u5F75\u5F76\u5F78\u5F7A\u5F7D\u5F7E\u5F7F\u5F83\u5F86\u5F8D\u5F8E\u5F8F\u5F91\u5F93\u5F94\u5F96\u5F9A\u5F9B\u5F9D\u5F9E\u5F9F\u5FA0\u5FA2", 5, "\u5FA9\u5FAB\u5FAC\u5FAF", 5, "\u5FB6\u5FB8\u5FB9\u5FBA\u5FBB\u5FBE", 4, "\u5FC7\u5FC8\u5FCA\u5FCB\u5FCE\u5FD3\u5FD4\u5FD5\u5FDA\u5FDB\u5FDC\u5FDE\u5FDF\u5FE2\u5FE3\u5FE5\u5FE6\u5FE8\u5FE9\u5FEC\u5FEF\u5FF0\u5FF2\u5FF3\u5FF4\u5FF6\u5FF7\u5FF9\u5FFA\u5FFC\u6007"],
    ["9040", "\u6008\u6009\u600B\u600C\u6010\u6011\u6013\u6017\u6018\u601A\u601E\u601F\u6022\u6023\u6024\u602C\u602D\u602E\u6030", 4, "\u6036", 4, "\u603D\u603E\u6040\u6044", 6, "\u604C\u604E\u604F\u6051\u6053\u6054\u6056\u6057\u6058\u605B\u605C\u605E\u605F\u6060\u6061\u6065\u6066\u606E\u6071\u6072\u6074\u6075\u6077\u607E\u6080"],
    ["9080", "\u6081\u6082\u6085\u6086\u6087\u6088\u608A\u608B\u608E\u608F\u6090\u6091\u6093\u6095\u6097\u6098\u6099\u609C\u609E\u60A1\u60A2\u60A4\u60A5\u60A7\u60A9\u60AA\u60AE\u60B0\u60B3\u60B5\u60B6\u60B7\u60B9\u60BA\u60BD", 7, "\u60C7\u60C8\u60C9\u60CC", 4, "\u60D2\u60D3\u60D4\u60D6\u60D7\u60D9\u60DB\u60DE\u60E1", 4, "\u60EA\u60F1\u60F2\u60F5\u60F7\u60F8\u60FB", 4, "\u6102\u6103\u6104\u6105\u6107\u610A\u610B\u610C\u6110", 4, "\u6116\u6117\u6118\u6119\u611B\u611C\u611D\u611E\u6121\u6122\u6125\u6128\u6129\u612A\u612C", 18, "\u6140", 6],
    ["9140", "\u6147\u6149\u614B\u614D\u614F\u6150\u6152\u6153\u6154\u6156", 6, "\u615E\u615F\u6160\u6161\u6163\u6164\u6165\u6166\u6169", 6, "\u6171\u6172\u6173\u6174\u6176\u6178", 18, "\u618C\u618D\u618F", 4, "\u6195"],
    ["9180", "\u6196", 6, "\u619E", 8, "\u61AA\u61AB\u61AD", 9, "\u61B8", 5, "\u61BF\u61C0\u61C1\u61C3", 4, "\u61C9\u61CC", 4, "\u61D3\u61D5", 16, "\u61E7", 13, "\u61F6", 8, "\u6200", 5, "\u6207\u6209\u6213\u6214\u6219\u621C\u621D\u621E\u6220\u6223\u6226\u6227\u6228\u6229\u622B\u622D\u622F\u6230\u6231\u6232\u6235\u6236\u6238", 4, "\u6242\u6244\u6245\u6246\u624A"],
    ["9240", "\u624F\u6250\u6255\u6256\u6257\u6259\u625A\u625C", 6, "\u6264\u6265\u6268\u6271\u6272\u6274\u6275\u6277\u6278\u627A\u627B\u627D\u6281\u6282\u6283\u6285\u6286\u6287\u6288\u628B", 5, "\u6294\u6299\u629C\u629D\u629E\u62A3\u62A6\u62A7\u62A9\u62AA\u62AD\u62AE\u62AF\u62B0\u62B2\u62B3\u62B4\u62B6\u62B7\u62B8\u62BA\u62BE\u62C0\u62C1"],
    ["9280", "\u62C3\u62CB\u62CF\u62D1\u62D5\u62DD\u62DE\u62E0\u62E1\u62E4\u62EA\u62EB\u62F0\u62F2\u62F5\u62F8\u62F9\u62FA\u62FB\u6300\u6303\u6304\u6305\u6306\u630A\u630B\u630C\u630D\u630F\u6310\u6312\u6313\u6314\u6315\u6317\u6318\u6319\u631C\u6326\u6327\u6329\u632C\u632D\u632E\u6330\u6331\u6333", 5, "\u633B\u633C\u633E\u633F\u6340\u6341\u6344\u6347\u6348\u634A\u6351\u6352\u6353\u6354\u6356", 7, "\u6360\u6364\u6365\u6366\u6368\u636A\u636B\u636C\u636F\u6370\u6372\u6373\u6374\u6375\u6378\u6379\u637C\u637D\u637E\u637F\u6381\u6383\u6384\u6385\u6386\u638B\u638D\u6391\u6393\u6394\u6395\u6397\u6399", 6, "\u63A1\u63A4\u63A6\u63AB\u63AF\u63B1\u63B2\u63B5\u63B6\u63B9\u63BB\u63BD\u63BF\u63C0"],
    ["9340", "\u63C1\u63C2\u63C3\u63C5\u63C7\u63C8\u63CA\u63CB\u63CC\u63D1\u63D3\u63D4\u63D5\u63D7", 6, "\u63DF\u63E2\u63E4", 4, "\u63EB\u63EC\u63EE\u63EF\u63F0\u63F1\u63F3\u63F5\u63F7\u63F9\u63FA\u63FB\u63FC\u63FE\u6403\u6404\u6406", 4, "\u640D\u640E\u6411\u6412\u6415", 5, "\u641D\u641F\u6422\u6423\u6424"],
    ["9380", "\u6425\u6427\u6428\u6429\u642B\u642E", 5, "\u6435", 4, "\u643B\u643C\u643E\u6440\u6442\u6443\u6449\u644B", 6, "\u6453\u6455\u6456\u6457\u6459", 4, "\u645F", 7, "\u6468\u646A\u646B\u646C\u646E", 9, "\u647B", 6, "\u6483\u6486\u6488", 8, "\u6493\u6494\u6497\u6498\u649A\u649B\u649C\u649D\u649F", 4, "\u64A5\u64A6\u64A7\u64A8\u64AA\u64AB\u64AF\u64B1\u64B2\u64B3\u64B4\u64B6\u64B9\u64BB\u64BD\u64BE\u64BF\u64C1\u64C3\u64C4\u64C6", 6, "\u64CF\u64D1\u64D3\u64D4\u64D5\u64D6\u64D9\u64DA"],
    ["9440", "\u64DB\u64DC\u64DD\u64DF\u64E0\u64E1\u64E3\u64E5\u64E7", 24, "\u6501", 7, "\u650A", 7, "\u6513", 4, "\u6519", 8],
    ["9480", "\u6522\u6523\u6524\u6526", 4, "\u652C\u652D\u6530\u6531\u6532\u6533\u6537\u653A\u653C\u653D\u6540", 4, "\u6546\u6547\u654A\u654B\u654D\u654E\u6550\u6552\u6553\u6554\u6557\u6558\u655A\u655C\u655F\u6560\u6561\u6564\u6565\u6567\u6568\u6569\u656A\u656D\u656E\u656F\u6571\u6573\u6575\u6576\u6578", 14, "\u6588\u6589\u658A\u658D\u658E\u658F\u6592\u6594\u6595\u6596\u6598\u659A\u659D\u659E\u65A0\u65A2\u65A3\u65A6\u65A8\u65AA\u65AC\u65AE\u65B1", 7, "\u65BA\u65BB\u65BE\u65BF\u65C0\u65C2\u65C7\u65C8\u65C9\u65CA\u65CD\u65D0\u65D1\u65D3\u65D4\u65D5\u65D8", 7, "\u65E1\u65E3\u65E4\u65EA\u65EB"],
    ["9540", "\u65F2\u65F3\u65F4\u65F5\u65F8\u65F9\u65FB", 4, "\u6601\u6604\u6605\u6607\u6608\u6609\u660B\u660D\u6610\u6611\u6612\u6616\u6617\u6618\u661A\u661B\u661C\u661E\u6621\u6622\u6623\u6624\u6626\u6629\u662A\u662B\u662C\u662E\u6630\u6632\u6633\u6637", 4, "\u663D\u663F\u6640\u6642\u6644", 6, "\u664D\u664E\u6650\u6651\u6658"],
    ["9580", "\u6659\u665B\u665C\u665D\u665E\u6660\u6662\u6663\u6665\u6667\u6669", 4, "\u6671\u6672\u6673\u6675\u6678\u6679\u667B\u667C\u667D\u667F\u6680\u6681\u6683\u6685\u6686\u6688\u6689\u668A\u668B\u668D\u668E\u668F\u6690\u6692\u6693\u6694\u6695\u6698", 4, "\u669E", 8, "\u66A9", 4, "\u66AF", 4, "\u66B5\u66B6\u66B7\u66B8\u66BA\u66BB\u66BC\u66BD\u66BF", 25, "\u66DA\u66DE", 7, "\u66E7\u66E8\u66EA", 5, "\u66F1\u66F5\u66F6\u66F8\u66FA\u66FB\u66FD\u6701\u6702\u6703"],
    ["9640", "\u6704\u6705\u6706\u6707\u670C\u670E\u670F\u6711\u6712\u6713\u6716\u6718\u6719\u671A\u671C\u671E\u6720", 5, "\u6727\u6729\u672E\u6730\u6732\u6733\u6736\u6737\u6738\u6739\u673B\u673C\u673E\u673F\u6741\u6744\u6745\u6747\u674A\u674B\u674D\u6752\u6754\u6755\u6757", 4, "\u675D\u6762\u6763\u6764\u6766\u6767\u676B\u676C\u676E\u6771\u6774\u6776"],
    ["9680", "\u6778\u6779\u677A\u677B\u677D\u6780\u6782\u6783\u6785\u6786\u6788\u678A\u678C\u678D\u678E\u678F\u6791\u6792\u6793\u6794\u6796\u6799\u679B\u679F\u67A0\u67A1\u67A4\u67A6\u67A9\u67AC\u67AE\u67B1\u67B2\u67B4\u67B9", 7, "\u67C2\u67C5", 9, "\u67D5\u67D6\u67D7\u67DB\u67DF\u67E1\u67E3\u67E4\u67E6\u67E7\u67E8\u67EA\u67EB\u67ED\u67EE\u67F2\u67F5", 7, "\u67FE\u6801\u6802\u6803\u6804\u6806\u680D\u6810\u6812\u6814\u6815\u6818", 4, "\u681E\u681F\u6820\u6822", 6, "\u682B", 6, "\u6834\u6835\u6836\u683A\u683B\u683F\u6847\u684B\u684D\u684F\u6852\u6856", 5],
    ["9740", "\u685C\u685D\u685E\u685F\u686A\u686C", 7, "\u6875\u6878", 8, "\u6882\u6884\u6887", 7, "\u6890\u6891\u6892\u6894\u6895\u6896\u6898", 9, "\u68A3\u68A4\u68A5\u68A9\u68AA\u68AB\u68AC\u68AE\u68B1\u68B2\u68B4\u68B6\u68B7\u68B8"],
    ["9780", "\u68B9", 6, "\u68C1\u68C3", 5, "\u68CA\u68CC\u68CE\u68CF\u68D0\u68D1\u68D3\u68D4\u68D6\u68D7\u68D9\u68DB", 4, "\u68E1\u68E2\u68E4", 9, "\u68EF\u68F2\u68F3\u68F4\u68F6\u68F7\u68F8\u68FB\u68FD\u68FE\u68FF\u6900\u6902\u6903\u6904\u6906", 4, "\u690C\u690F\u6911\u6913", 11, "\u6921\u6922\u6923\u6925", 7, "\u692E\u692F\u6931\u6932\u6933\u6935\u6936\u6937\u6938\u693A\u693B\u693C\u693E\u6940\u6941\u6943", 16, "\u6955\u6956\u6958\u6959\u695B\u695C\u695F"],
    ["9840", "\u6961\u6962\u6964\u6965\u6967\u6968\u6969\u696A\u696C\u696D\u696F\u6970\u6972", 4, "\u697A\u697B\u697D\u697E\u697F\u6981\u6983\u6985\u698A\u698B\u698C\u698E", 5, "\u6996\u6997\u6999\u699A\u699D", 9, "\u69A9\u69AA\u69AC\u69AE\u69AF\u69B0\u69B2\u69B3\u69B5\u69B6\u69B8\u69B9\u69BA\u69BC\u69BD"],
    ["9880", "\u69BE\u69BF\u69C0\u69C2", 7, "\u69CB\u69CD\u69CF\u69D1\u69D2\u69D3\u69D5", 5, "\u69DC\u69DD\u69DE\u69E1", 11, "\u69EE\u69EF\u69F0\u69F1\u69F3", 9, "\u69FE\u6A00", 9, "\u6A0B", 11, "\u6A19", 5, "\u6A20\u6A22", 5, "\u6A29\u6A2B\u6A2C\u6A2D\u6A2E\u6A30\u6A32\u6A33\u6A34\u6A36", 6, "\u6A3F", 4, "\u6A45\u6A46\u6A48", 7, "\u6A51", 6, "\u6A5A"],
    ["9940", "\u6A5C", 4, "\u6A62\u6A63\u6A64\u6A66", 10, "\u6A72", 6, "\u6A7A\u6A7B\u6A7D\u6A7E\u6A7F\u6A81\u6A82\u6A83\u6A85", 8, "\u6A8F\u6A92", 4, "\u6A98", 7, "\u6AA1", 5],
    ["9980", "\u6AA7\u6AA8\u6AAA\u6AAD", 114, "\u6B25\u6B26\u6B28", 6],
    ["9a40", "\u6B2F\u6B30\u6B31\u6B33\u6B34\u6B35\u6B36\u6B38\u6B3B\u6B3C\u6B3D\u6B3F\u6B40\u6B41\u6B42\u6B44\u6B45\u6B48\u6B4A\u6B4B\u6B4D", 11, "\u6B5A", 7, "\u6B68\u6B69\u6B6B", 13, "\u6B7A\u6B7D\u6B7E\u6B7F\u6B80\u6B85\u6B88"],
    ["9a80", "\u6B8C\u6B8E\u6B8F\u6B90\u6B91\u6B94\u6B95\u6B97\u6B98\u6B99\u6B9C", 4, "\u6BA2", 7, "\u6BAB", 7, "\u6BB6\u6BB8", 6, "\u6BC0\u6BC3\u6BC4\u6BC6", 4, "\u6BCC\u6BCE\u6BD0\u6BD1\u6BD8\u6BDA\u6BDC", 4, "\u6BE2", 7, "\u6BEC\u6BED\u6BEE\u6BF0\u6BF1\u6BF2\u6BF4\u6BF6\u6BF7\u6BF8\u6BFA\u6BFB\u6BFC\u6BFE", 6, "\u6C08", 4, "\u6C0E\u6C12\u6C17\u6C1C\u6C1D\u6C1E\u6C20\u6C23\u6C25\u6C2B\u6C2C\u6C2D\u6C31\u6C33\u6C36\u6C37\u6C39\u6C3A\u6C3B\u6C3C\u6C3E\u6C3F\u6C43\u6C44\u6C45\u6C48\u6C4B", 4, "\u6C51\u6C52\u6C53\u6C56\u6C58"],
    ["9b40", "\u6C59\u6C5A\u6C62\u6C63\u6C65\u6C66\u6C67\u6C6B", 4, "\u6C71\u6C73\u6C75\u6C77\u6C78\u6C7A\u6C7B\u6C7C\u6C7F\u6C80\u6C84\u6C87\u6C8A\u6C8B\u6C8D\u6C8E\u6C91\u6C92\u6C95\u6C96\u6C97\u6C98\u6C9A\u6C9C\u6C9D\u6C9E\u6CA0\u6CA2\u6CA8\u6CAC\u6CAF\u6CB0\u6CB4\u6CB5\u6CB6\u6CB7\u6CBA\u6CC0\u6CC1\u6CC2\u6CC3\u6CC6\u6CC7\u6CC8\u6CCB\u6CCD\u6CCE\u6CCF\u6CD1\u6CD2\u6CD8"],
    ["9b80", "\u6CD9\u6CDA\u6CDC\u6CDD\u6CDF\u6CE4\u6CE6\u6CE7\u6CE9\u6CEC\u6CED\u6CF2\u6CF4\u6CF9\u6CFF\u6D00\u6D02\u6D03\u6D05\u6D06\u6D08\u6D09\u6D0A\u6D0D\u6D0F\u6D10\u6D11\u6D13\u6D14\u6D15\u6D16\u6D18\u6D1C\u6D1D\u6D1F", 5, "\u6D26\u6D28\u6D29\u6D2C\u6D2D\u6D2F\u6D30\u6D34\u6D36\u6D37\u6D38\u6D3A\u6D3F\u6D40\u6D42\u6D44\u6D49\u6D4C\u6D50\u6D55\u6D56\u6D57\u6D58\u6D5B\u6D5D\u6D5F\u6D61\u6D62\u6D64\u6D65\u6D67\u6D68\u6D6B\u6D6C\u6D6D\u6D70\u6D71\u6D72\u6D73\u6D75\u6D76\u6D79\u6D7A\u6D7B\u6D7D", 4, "\u6D83\u6D84\u6D86\u6D87\u6D8A\u6D8B\u6D8D\u6D8F\u6D90\u6D92\u6D96", 4, "\u6D9C\u6DA2\u6DA5\u6DAC\u6DAD\u6DB0\u6DB1\u6DB3\u6DB4\u6DB6\u6DB7\u6DB9", 5, "\u6DC1\u6DC2\u6DC3\u6DC8\u6DC9\u6DCA"],
    ["9c40", "\u6DCD\u6DCE\u6DCF\u6DD0\u6DD2\u6DD3\u6DD4\u6DD5\u6DD7\u6DDA\u6DDB\u6DDC\u6DDF\u6DE2\u6DE3\u6DE5\u6DE7\u6DE8\u6DE9\u6DEA\u6DED\u6DEF\u6DF0\u6DF2\u6DF4\u6DF5\u6DF6\u6DF8\u6DFA\u6DFD", 7, "\u6E06\u6E07\u6E08\u6E09\u6E0B\u6E0F\u6E12\u6E13\u6E15\u6E18\u6E19\u6E1B\u6E1C\u6E1E\u6E1F\u6E22\u6E26\u6E27\u6E28\u6E2A\u6E2C\u6E2E\u6E30\u6E31\u6E33\u6E35"],
    ["9c80", "\u6E36\u6E37\u6E39\u6E3B", 7, "\u6E45", 7, "\u6E4F\u6E50\u6E51\u6E52\u6E55\u6E57\u6E59\u6E5A\u6E5C\u6E5D\u6E5E\u6E60", 10, "\u6E6C\u6E6D\u6E6F", 14, "\u6E80\u6E81\u6E82\u6E84\u6E87\u6E88\u6E8A", 4, "\u6E91", 6, "\u6E99\u6E9A\u6E9B\u6E9D\u6E9E\u6EA0\u6EA1\u6EA3\u6EA4\u6EA6\u6EA8\u6EA9\u6EAB\u6EAC\u6EAD\u6EAE\u6EB0\u6EB3\u6EB5\u6EB8\u6EB9\u6EBC\u6EBE\u6EBF\u6EC0\u6EC3\u6EC4\u6EC5\u6EC6\u6EC8\u6EC9\u6ECA\u6ECC\u6ECD\u6ECE\u6ED0\u6ED2\u6ED6\u6ED8\u6ED9\u6EDB\u6EDC\u6EDD\u6EE3\u6EE7\u6EEA", 5],
    ["9d40", "\u6EF0\u6EF1\u6EF2\u6EF3\u6EF5\u6EF6\u6EF7\u6EF8\u6EFA", 7, "\u6F03\u6F04\u6F05\u6F07\u6F08\u6F0A", 4, "\u6F10\u6F11\u6F12\u6F16", 9, "\u6F21\u6F22\u6F23\u6F25\u6F26\u6F27\u6F28\u6F2C\u6F2E\u6F30\u6F32\u6F34\u6F35\u6F37", 6, "\u6F3F\u6F40\u6F41\u6F42"],
    ["9d80", "\u6F43\u6F44\u6F45\u6F48\u6F49\u6F4A\u6F4C\u6F4E", 9, "\u6F59\u6F5A\u6F5B\u6F5D\u6F5F\u6F60\u6F61\u6F63\u6F64\u6F65\u6F67", 5, "\u6F6F\u6F70\u6F71\u6F73\u6F75\u6F76\u6F77\u6F79\u6F7B\u6F7D", 6, "\u6F85\u6F86\u6F87\u6F8A\u6F8B\u6F8F", 12, "\u6F9D\u6F9E\u6F9F\u6FA0\u6FA2", 4, "\u6FA8", 10, "\u6FB4\u6FB5\u6FB7\u6FB8\u6FBA", 5, "\u6FC1\u6FC3", 5, "\u6FCA", 6, "\u6FD3", 10, "\u6FDF\u6FE2\u6FE3\u6FE4\u6FE5"],
    ["9e40", "\u6FE6", 7, "\u6FF0", 32, "\u7012", 7, "\u701C", 6, "\u7024", 6],
    ["9e80", "\u702B", 9, "\u7036\u7037\u7038\u703A", 17, "\u704D\u704E\u7050", 13, "\u705F", 11, "\u706E\u7071\u7072\u7073\u7074\u7077\u7079\u707A\u707B\u707D\u7081\u7082\u7083\u7084\u7086\u7087\u7088\u708B\u708C\u708D\u708F\u7090\u7091\u7093\u7097\u7098\u709A\u709B\u709E", 12, "\u70B0\u70B2\u70B4\u70B5\u70B6\u70BA\u70BE\u70BF\u70C4\u70C5\u70C6\u70C7\u70C9\u70CB", 12, "\u70DA"],
    ["9f40", "\u70DC\u70DD\u70DE\u70E0\u70E1\u70E2\u70E3\u70E5\u70EA\u70EE\u70F0", 6, "\u70F8\u70FA\u70FB\u70FC\u70FE", 10, "\u710B", 4, "\u7111\u7112\u7114\u7117\u711B", 10, "\u7127", 7, "\u7132\u7133\u7134"],
    ["9f80", "\u7135\u7137", 13, "\u7146\u7147\u7148\u7149\u714B\u714D\u714F", 12, "\u715D\u715F", 4, "\u7165\u7169", 4, "\u716F\u7170\u7171\u7174\u7175\u7176\u7177\u7179\u717B\u717C\u717E", 5, "\u7185", 4, "\u718B\u718C\u718D\u718E\u7190\u7191\u7192\u7193\u7195\u7196\u7197\u719A", 4, "\u71A1", 6, "\u71A9\u71AA\u71AB\u71AD", 5, "\u71B4\u71B6\u71B7\u71B8\u71BA", 8, "\u71C4", 9, "\u71CF", 4],
    ["a040", "\u71D6", 9, "\u71E1\u71E2\u71E3\u71E4\u71E6\u71E8", 5, "\u71EF", 9, "\u71FA", 11, "\u7207", 19],
    ["a080", "\u721B\u721C\u721E", 9, "\u7229\u722B\u722D\u722E\u722F\u7232\u7233\u7234\u723A\u723C\u723E\u7240", 6, "\u7249\u724A\u724B\u724E\u724F\u7250\u7251\u7253\u7254\u7255\u7257\u7258\u725A\u725C\u725E\u7260\u7263\u7264\u7265\u7268\u726A\u726B\u726C\u726D\u7270\u7271\u7273\u7274\u7276\u7277\u7278\u727B\u727C\u727D\u7282\u7283\u7285", 4, "\u728C\u728E\u7290\u7291\u7293", 11, "\u72A0", 11, "\u72AE\u72B1\u72B2\u72B3\u72B5\u72BA", 6, "\u72C5\u72C6\u72C7\u72C9\u72CA\u72CB\u72CC\u72CF\u72D1\u72D3\u72D4\u72D5\u72D6\u72D8\u72DA\u72DB"],
    ["a1a1", "\u3000\u3001\u3002\xB7\u02C9\u02C7\xA8\u3003\u3005\u2014\uFF5E\u2016\u2026\u2018\u2019\u201C\u201D\u3014\u3015\u3008", 7, "\u3016\u3017\u3010\u3011\xB1\xD7\xF7\u2236\u2227\u2228\u2211\u220F\u222A\u2229\u2208\u2237\u221A\u22A5\u2225\u2220\u2312\u2299\u222B\u222E\u2261\u224C\u2248\u223D\u221D\u2260\u226E\u226F\u2264\u2265\u221E\u2235\u2234\u2642\u2640\xB0\u2032\u2033\u2103\uFF04\xA4\uFFE0\uFFE1\u2030\xA7\u2116\u2606\u2605\u25CB\u25CF\u25CE\u25C7\u25C6\u25A1\u25A0\u25B3\u25B2\u203B\u2192\u2190\u2191\u2193\u3013"],
    ["a2a1", "\u2170", 9],
    ["a2b1", "\u2488", 19, "\u2474", 19, "\u2460", 9],
    ["a2e5", "\u3220", 9],
    ["a2f1", "\u2160", 11],
    ["a3a1", "\uFF01\uFF02\uFF03\uFFE5\uFF05", 88, "\uFFE3"],
    ["a4a1", "\u3041", 82],
    ["a5a1", "\u30A1", 85],
    ["a6a1", "\u0391", 16, "\u03A3", 6],
    ["a6c1", "\u03B1", 16, "\u03C3", 6],
    ["a6e0", "\uFE35\uFE36\uFE39\uFE3A\uFE3F\uFE40\uFE3D\uFE3E\uFE41\uFE42\uFE43\uFE44"],
    ["a6ee", "\uFE3B\uFE3C\uFE37\uFE38\uFE31"],
    ["a6f4", "\uFE33\uFE34"],
    ["a7a1", "\u0410", 5, "\u0401\u0416", 25],
    ["a7d1", "\u0430", 5, "\u0451\u0436", 25],
    ["a840", "\u02CA\u02CB\u02D9\u2013\u2015\u2025\u2035\u2105\u2109\u2196\u2197\u2198\u2199\u2215\u221F\u2223\u2252\u2266\u2267\u22BF\u2550", 35, "\u2581", 6],
    ["a880", "\u2588", 7, "\u2593\u2594\u2595\u25BC\u25BD\u25E2\u25E3\u25E4\u25E5\u2609\u2295\u3012\u301D\u301E"],
    ["a8a1", "\u0101\xE1\u01CE\xE0\u0113\xE9\u011B\xE8\u012B\xED\u01D0\xEC\u014D\xF3\u01D2\xF2\u016B\xFA\u01D4\xF9\u01D6\u01D8\u01DA\u01DC\xFC\xEA\u0251"],
    ["a8bd", "\u0144\u0148"],
    ["a8c0", "\u0261"],
    ["a8c5", "\u3105", 36],
    ["a940", "\u3021", 8, "\u32A3\u338E\u338F\u339C\u339D\u339E\u33A1\u33C4\u33CE\u33D1\u33D2\u33D5\uFE30\uFFE2\uFFE4"],
    ["a959", "\u2121\u3231"],
    ["a95c", "\u2010"],
    ["a960", "\u30FC\u309B\u309C\u30FD\u30FE\u3006\u309D\u309E\uFE49", 9, "\uFE54\uFE55\uFE56\uFE57\uFE59", 8],
    ["a980", "\uFE62", 4, "\uFE68\uFE69\uFE6A\uFE6B"],
    ["a996", "\u3007"],
    ["a9a4", "\u2500", 75],
    ["aa40", "\u72DC\u72DD\u72DF\u72E2", 5, "\u72EA\u72EB\u72F5\u72F6\u72F9\u72FD\u72FE\u72FF\u7300\u7302\u7304", 5, "\u730B\u730C\u730D\u730F\u7310\u7311\u7312\u7314\u7318\u7319\u731A\u731F\u7320\u7323\u7324\u7326\u7327\u7328\u732D\u732F\u7330\u7332\u7333\u7335\u7336\u733A\u733B\u733C\u733D\u7340", 8],
    ["aa80", "\u7349\u734A\u734B\u734C\u734E\u734F\u7351\u7353\u7354\u7355\u7356\u7358", 7, "\u7361", 10, "\u736E\u7370\u7371"],
    ["ab40", "\u7372", 11, "\u737F", 4, "\u7385\u7386\u7388\u738A\u738C\u738D\u738F\u7390\u7392\u7393\u7394\u7395\u7397\u7398\u7399\u739A\u739C\u739D\u739E\u73A0\u73A1\u73A3", 5, "\u73AA\u73AC\u73AD\u73B1\u73B4\u73B5\u73B6\u73B8\u73B9\u73BC\u73BD\u73BE\u73BF\u73C1\u73C3", 4],
    ["ab80", "\u73CB\u73CC\u73CE\u73D2", 6, "\u73DA\u73DB\u73DC\u73DD\u73DF\u73E1\u73E2\u73E3\u73E4\u73E6\u73E8\u73EA\u73EB\u73EC\u73EE\u73EF\u73F0\u73F1\u73F3", 4],
    ["ac40", "\u73F8", 10, "\u7404\u7407\u7408\u740B\u740C\u740D\u740E\u7411", 8, "\u741C", 5, "\u7423\u7424\u7427\u7429\u742B\u742D\u742F\u7431\u7432\u7437", 4, "\u743D\u743E\u743F\u7440\u7442", 11],
    ["ac80", "\u744E", 6, "\u7456\u7458\u745D\u7460", 12, "\u746E\u746F\u7471", 4, "\u7478\u7479\u747A"],
    ["ad40", "\u747B\u747C\u747D\u747F\u7482\u7484\u7485\u7486\u7488\u7489\u748A\u748C\u748D\u748F\u7491", 10, "\u749D\u749F", 7, "\u74AA", 15, "\u74BB", 12],
    ["ad80", "\u74C8", 9, "\u74D3", 8, "\u74DD\u74DF\u74E1\u74E5\u74E7", 6, "\u74F0\u74F1\u74F2"],
    ["ae40", "\u74F3\u74F5\u74F8", 6, "\u7500\u7501\u7502\u7503\u7505", 7, "\u750E\u7510\u7512\u7514\u7515\u7516\u7517\u751B\u751D\u751E\u7520", 4, "\u7526\u7527\u752A\u752E\u7534\u7536\u7539\u753C\u753D\u753F\u7541\u7542\u7543\u7544\u7546\u7547\u7549\u754A\u754D\u7550\u7551\u7552\u7553\u7555\u7556\u7557\u7558"],
    ["ae80", "\u755D", 7, "\u7567\u7568\u7569\u756B", 6, "\u7573\u7575\u7576\u7577\u757A", 4, "\u7580\u7581\u7582\u7584\u7585\u7587"],
    ["af40", "\u7588\u7589\u758A\u758C\u758D\u758E\u7590\u7593\u7595\u7598\u759B\u759C\u759E\u75A2\u75A6", 4, "\u75AD\u75B6\u75B7\u75BA\u75BB\u75BF\u75C0\u75C1\u75C6\u75CB\u75CC\u75CE\u75CF\u75D0\u75D1\u75D3\u75D7\u75D9\u75DA\u75DC\u75DD\u75DF\u75E0\u75E1\u75E5\u75E9\u75EC\u75ED\u75EE\u75EF\u75F2\u75F3\u75F5\u75F6\u75F7\u75F8\u75FA\u75FB\u75FD\u75FE\u7602\u7604\u7606\u7607"],
    ["af80", "\u7608\u7609\u760B\u760D\u760E\u760F\u7611\u7612\u7613\u7614\u7616\u761A\u761C\u761D\u761E\u7621\u7623\u7627\u7628\u762C\u762E\u762F\u7631\u7632\u7636\u7637\u7639\u763A\u763B\u763D\u7641\u7642\u7644"],
    ["b040", "\u7645", 6, "\u764E", 5, "\u7655\u7657", 4, "\u765D\u765F\u7660\u7661\u7662\u7664", 6, "\u766C\u766D\u766E\u7670", 7, "\u7679\u767A\u767C\u767F\u7680\u7681\u7683\u7685\u7689\u768A\u768C\u768D\u768F\u7690\u7692\u7694\u7695\u7697\u7698\u769A\u769B"],
    ["b080", "\u769C", 7, "\u76A5", 8, "\u76AF\u76B0\u76B3\u76B5", 9, "\u76C0\u76C1\u76C3\u554A\u963F\u57C3\u6328\u54CE\u5509\u54C0\u7691\u764C\u853C\u77EE\u827E\u788D\u7231\u9698\u978D\u6C28\u5B89\u4FFA\u6309\u6697\u5CB8\u80FA\u6848\u80AE\u6602\u76CE\u51F9\u6556\u71AC\u7FF1\u8884\u50B2\u5965\u61CA\u6FB3\u82AD\u634C\u6252\u53ED\u5427\u7B06\u516B\u75A4\u5DF4\u62D4\u8DCB\u9776\u628A\u8019\u575D\u9738\u7F62\u7238\u767D\u67CF\u767E\u6446\u4F70\u8D25\u62DC\u7A17\u6591\u73ED\u642C\u6273\u822C\u9881\u677F\u7248\u626E\u62CC\u4F34\u74E3\u534A\u529E\u7ECA\u90A6\u5E2E\u6886\u699C\u8180\u7ED1\u68D2\u78C5\u868C\u9551\u508D\u8C24\u82DE\u80DE\u5305\u8912\u5265"],
    ["b140", "\u76C4\u76C7\u76C9\u76CB\u76CC\u76D3\u76D5\u76D9\u76DA\u76DC\u76DD\u76DE\u76E0", 4, "\u76E6", 7, "\u76F0\u76F3\u76F5\u76F6\u76F7\u76FA\u76FB\u76FD\u76FF\u7700\u7702\u7703\u7705\u7706\u770A\u770C\u770E", 10, "\u771B\u771C\u771D\u771E\u7721\u7723\u7724\u7725\u7727\u772A\u772B"],
    ["b180", "\u772C\u772E\u7730", 4, "\u7739\u773B\u773D\u773E\u773F\u7742\u7744\u7745\u7746\u7748", 7, "\u7752", 7, "\u775C\u8584\u96F9\u4FDD\u5821\u9971\u5B9D\u62B1\u62A5\u66B4\u8C79\u9C8D\u7206\u676F\u7891\u60B2\u5351\u5317\u8F88\u80CC\u8D1D\u94A1\u500D\u72C8\u5907\u60EB\u7119\u88AB\u5954\u82EF\u672C\u7B28\u5D29\u7EF7\u752D\u6CF5\u8E66\u8FF8\u903C\u9F3B\u6BD4\u9119\u7B14\u5F7C\u78A7\u84D6\u853D\u6BD5\u6BD9\u6BD6\u5E01\u5E87\u75F9\u95ED\u655D\u5F0A\u5FC5\u8F9F\u58C1\u81C2\u907F\u965B\u97AD\u8FB9\u7F16\u8D2C\u6241\u4FBF\u53D8\u535E\u8FA8\u8FA9\u8FAB\u904D\u6807\u5F6A\u8198\u8868\u9CD6\u618B\u522B\u762A\u5F6C\u658C\u6FD2\u6EE8\u5BBE\u6448\u5175\u51B0\u67C4\u4E19\u79C9\u997C\u70B3"],
    ["b240", "\u775D\u775E\u775F\u7760\u7764\u7767\u7769\u776A\u776D", 11, "\u777A\u777B\u777C\u7781\u7782\u7783\u7786", 5, "\u778F\u7790\u7793", 11, "\u77A1\u77A3\u77A4\u77A6\u77A8\u77AB\u77AD\u77AE\u77AF\u77B1\u77B2\u77B4\u77B6", 4],
    ["b280", "\u77BC\u77BE\u77C0", 12, "\u77CE", 8, "\u77D8\u77D9\u77DA\u77DD", 4, "\u77E4\u75C5\u5E76\u73BB\u83E0\u64AD\u62E8\u94B5\u6CE2\u535A\u52C3\u640F\u94C2\u7B94\u4F2F\u5E1B\u8236\u8116\u818A\u6E24\u6CCA\u9A73\u6355\u535C\u54FA\u8865\u57E0\u4E0D\u5E03\u6B65\u7C3F\u90E8\u6016\u64E6\u731C\u88C1\u6750\u624D\u8D22\u776C\u8E29\u91C7\u5F69\u83DC\u8521\u9910\u53C2\u8695\u6B8B\u60ED\u60E8\u707F\u82CD\u8231\u4ED3\u6CA7\u85CF\u64CD\u7CD9\u69FD\u66F9\u8349\u5395\u7B56\u4FA7\u518C\u6D4B\u5C42\u8E6D\u63D2\u53C9\u832C\u8336\u67E5\u78B4\u643D\u5BDF\u5C94\u5DEE\u8BE7\u62C6\u67F4\u8C7A\u6400\u63BA\u8749\u998B\u8C17\u7F20\u94F2\u4EA7\u9610\u98A4\u660C\u7316"],
    ["b340", "\u77E6\u77E8\u77EA\u77EF\u77F0\u77F1\u77F2\u77F4\u77F5\u77F7\u77F9\u77FA\u77FB\u77FC\u7803", 5, "\u780A\u780B\u780E\u780F\u7810\u7813\u7815\u7819\u781B\u781E\u7820\u7821\u7822\u7824\u7828\u782A\u782B\u782E\u782F\u7831\u7832\u7833\u7835\u7836\u783D\u783F\u7841\u7842\u7843\u7844\u7846\u7848\u7849\u784A\u784B\u784D\u784F\u7851\u7853\u7854\u7858\u7859\u785A"],
    ["b380", "\u785B\u785C\u785E", 11, "\u786F", 7, "\u7878\u7879\u787A\u787B\u787D", 6, "\u573A\u5C1D\u5E38\u957F\u507F\u80A0\u5382\u655E\u7545\u5531\u5021\u8D85\u6284\u949E\u671D\u5632\u6F6E\u5DE2\u5435\u7092\u8F66\u626F\u64A4\u63A3\u5F7B\u6F88\u90F4\u81E3\u8FB0\u5C18\u6668\u5FF1\u6C89\u9648\u8D81\u886C\u6491\u79F0\u57CE\u6A59\u6210\u5448\u4E58\u7A0B\u60E9\u6F84\u8BDA\u627F\u901E\u9A8B\u79E4\u5403\u75F4\u6301\u5319\u6C60\u8FDF\u5F1B\u9A70\u803B\u9F7F\u4F88\u5C3A\u8D64\u7FC5\u65A5\u70BD\u5145\u51B2\u866B\u5D07\u5BA0\u62BD\u916C\u7574\u8E0C\u7A20\u6101\u7B79\u4EC7\u7EF8\u7785\u4E11\u81ED\u521D\u51FA\u6A71\u53A8\u8E87\u9504\u96CF\u6EC1\u9664\u695A"],
    ["b440", "\u7884\u7885\u7886\u7888\u788A\u788B\u788F\u7890\u7892\u7894\u7895\u7896\u7899\u789D\u789E\u78A0\u78A2\u78A4\u78A6\u78A8", 7, "\u78B5\u78B6\u78B7\u78B8\u78BA\u78BB\u78BC\u78BD\u78BF\u78C0\u78C2\u78C3\u78C4\u78C6\u78C7\u78C8\u78CC\u78CD\u78CE\u78CF\u78D1\u78D2\u78D3\u78D6\u78D7\u78D8\u78DA", 9],
    ["b480", "\u78E4\u78E5\u78E6\u78E7\u78E9\u78EA\u78EB\u78ED", 4, "\u78F3\u78F5\u78F6\u78F8\u78F9\u78FB", 5, "\u7902\u7903\u7904\u7906", 6, "\u7840\u50A8\u77D7\u6410\u89E6\u5904\u63E3\u5DDD\u7A7F\u693D\u4F20\u8239\u5598\u4E32\u75AE\u7A97\u5E62\u5E8A\u95EF\u521B\u5439\u708A\u6376\u9524\u5782\u6625\u693F\u9187\u5507\u6DF3\u7EAF\u8822\u6233\u7EF0\u75B5\u8328\u78C1\u96CC\u8F9E\u6148\u74F7\u8BCD\u6B64\u523A\u8D50\u6B21\u806A\u8471\u56F1\u5306\u4ECE\u4E1B\u51D1\u7C97\u918B\u7C07\u4FC3\u8E7F\u7BE1\u7A9C\u6467\u5D14\u50AC\u8106\u7601\u7CB9\u6DEC\u7FE0\u6751\u5B58\u5BF8\u78CB\u64AE\u6413\u63AA\u632B\u9519\u642D\u8FBE\u7B54\u7629\u6253\u5927\u5446\u6B79\u50A3\u6234\u5E26\u6B86\u4EE3\u8D37\u888B\u5F85\u902E"],
    ["b540", "\u790D", 5, "\u7914", 9, "\u791F", 4, "\u7925", 14, "\u7935", 4, "\u793D\u793F\u7942\u7943\u7944\u7945\u7947\u794A", 8, "\u7954\u7955\u7958\u7959\u7961\u7963"],
    ["b580", "\u7964\u7966\u7969\u796A\u796B\u796C\u796E\u7970", 6, "\u7979\u797B", 4, "\u7982\u7983\u7986\u7987\u7988\u7989\u798B\u798C\u798D\u798E\u7990\u7991\u7992\u6020\u803D\u62C5\u4E39\u5355\u90F8\u63B8\u80C6\u65E6\u6C2E\u4F46\u60EE\u6DE1\u8BDE\u5F39\u86CB\u5F53\u6321\u515A\u8361\u6863\u5200\u6363\u8E48\u5012\u5C9B\u7977\u5BFC\u5230\u7A3B\u60BC\u9053\u76D7\u5FB7\u5F97\u7684\u8E6C\u706F\u767B\u7B49\u77AA\u51F3\u9093\u5824\u4F4E\u6EF4\u8FEA\u654C\u7B1B\u72C4\u6DA4\u7FDF\u5AE1\u62B5\u5E95\u5730\u8482\u7B2C\u5E1D\u5F1F\u9012\u7F14\u98A0\u6382\u6EC7\u7898\u70B9\u5178\u975B\u57AB\u7535\u4F43\u7538\u5E97\u60E6\u5960\u6DC0\u6BBF\u7889\u53FC\u96D5\u51CB\u5201\u6389\u540A\u9493\u8C03\u8DCC\u7239\u789F\u8776\u8FED\u8C0D\u53E0"],
    ["b640", "\u7993", 6, "\u799B", 11, "\u79A8", 10, "\u79B4", 4, "\u79BC\u79BF\u79C2\u79C4\u79C5\u79C7\u79C8\u79CA\u79CC\u79CE\u79CF\u79D0\u79D3\u79D4\u79D6\u79D7\u79D9", 5, "\u79E0\u79E1\u79E2\u79E5\u79E8\u79EA"],
    ["b680", "\u79EC\u79EE\u79F1", 6, "\u79F9\u79FA\u79FC\u79FE\u79FF\u7A01\u7A04\u7A05\u7A07\u7A08\u7A09\u7A0A\u7A0C\u7A0F", 4, "\u7A15\u7A16\u7A18\u7A19\u7A1B\u7A1C\u4E01\u76EF\u53EE\u9489\u9876\u9F0E\u952D\u5B9A\u8BA2\u4E22\u4E1C\u51AC\u8463\u61C2\u52A8\u680B\u4F97\u606B\u51BB\u6D1E\u515C\u6296\u6597\u9661\u8C46\u9017\u75D8\u90FD\u7763\u6BD2\u728A\u72EC\u8BFB\u5835\u7779\u8D4C\u675C\u9540\u809A\u5EA6\u6E21\u5992\u7AEF\u77ED\u953B\u6BB5\u65AD\u7F0E\u5806\u5151\u961F\u5BF9\u58A9\u5428\u8E72\u6566\u987F\u56E4\u949D\u76FE\u9041\u6387\u54C6\u591A\u593A\u579B\u8EB2\u6735\u8DFA\u8235\u5241\u60F0\u5815\u86FE\u5CE8\u9E45\u4FC4\u989D\u8BB9\u5A25\u6076\u5384\u627C\u904F\u9102\u997F\u6069\u800C\u513F\u8033\u5C14\u9975\u6D31\u4E8C"],
    ["b740", "\u7A1D\u7A1F\u7A21\u7A22\u7A24", 14, "\u7A34\u7A35\u7A36\u7A38\u7A3A\u7A3E\u7A40", 5, "\u7A47", 9, "\u7A52", 4, "\u7A58", 16],
    ["b780", "\u7A69", 6, "\u7A71\u7A72\u7A73\u7A75\u7A7B\u7A7C\u7A7D\u7A7E\u7A82\u7A85\u7A87\u7A89\u7A8A\u7A8B\u7A8C\u7A8E\u7A8F\u7A90\u7A93\u7A94\u7A99\u7A9A\u7A9B\u7A9E\u7AA1\u7AA2\u8D30\u53D1\u7F5A\u7B4F\u4F10\u4E4F\u9600\u6CD5\u73D0\u85E9\u5E06\u756A\u7FFB\u6A0A\u77FE\u9492\u7E41\u51E1\u70E6\u53CD\u8FD4\u8303\u8D29\u72AF\u996D\u6CDB\u574A\u82B3\u65B9\u80AA\u623F\u9632\u59A8\u4EFF\u8BBF\u7EBA\u653E\u83F2\u975E\u5561\u98DE\u80A5\u532A\u8BFD\u5420\u80BA\u5E9F\u6CB8\u8D39\u82AC\u915A\u5429\u6C1B\u5206\u7EB7\u575F\u711A\u6C7E\u7C89\u594B\u4EFD\u5FFF\u6124\u7CAA\u4E30\u5C01\u67AB\u8702\u5CF0\u950B\u98CE\u75AF\u70FD\u9022\u51AF\u7F1D\u8BBD\u5949\u51E4\u4F5B\u5426\u592B\u6577\u80A4\u5B75\u6276\u62C2\u8F90\u5E45\u6C1F\u7B26\u4F0F\u4FD8\u670D"],
    ["b840", "\u7AA3\u7AA4\u7AA7\u7AA9\u7AAA\u7AAB\u7AAE", 4, "\u7AB4", 10, "\u7AC0", 10, "\u7ACC", 9, "\u7AD7\u7AD8\u7ADA\u7ADB\u7ADC\u7ADD\u7AE1\u7AE2\u7AE4\u7AE7", 5, "\u7AEE\u7AF0\u7AF1\u7AF2\u7AF3"],
    ["b880", "\u7AF4", 4, "\u7AFB\u7AFC\u7AFE\u7B00\u7B01\u7B02\u7B05\u7B07\u7B09\u7B0C\u7B0D\u7B0E\u7B10\u7B12\u7B13\u7B16\u7B17\u7B18\u7B1A\u7B1C\u7B1D\u7B1F\u7B21\u7B22\u7B23\u7B27\u7B29\u7B2D\u6D6E\u6DAA\u798F\u88B1\u5F17\u752B\u629A\u8F85\u4FEF\u91DC\u65A7\u812F\u8151\u5E9C\u8150\u8D74\u526F\u8986\u8D4B\u590D\u5085\u4ED8\u961C\u7236\u8179\u8D1F\u5BCC\u8BA3\u9644\u5987\u7F1A\u5490\u5676\u560E\u8BE5\u6539\u6982\u9499\u76D6\u6E89\u5E72\u7518\u6746\u67D1\u7AFF\u809D\u8D76\u611F\u79C6\u6562\u8D63\u5188\u521A\u94A2\u7F38\u809B\u7EB2\u5C97\u6E2F\u6760\u7BD9\u768B\u9AD8\u818F\u7F94\u7CD5\u641E\u9550\u7A3F\u544A\u54E5\u6B4C\u6401\u6208\u9E3D\u80F3\u7599\u5272\u9769\u845B\u683C\u86E4\u9601\u9694\u94EC\u4E2A\u5404\u7ED9\u6839\u8DDF\u8015\u66F4\u5E9A\u7FB9"],
    ["b940", "\u7B2F\u7B30\u7B32\u7B34\u7B35\u7B36\u7B37\u7B39\u7B3B\u7B3D\u7B3F", 5, "\u7B46\u7B48\u7B4A\u7B4D\u7B4E\u7B53\u7B55\u7B57\u7B59\u7B5C\u7B5E\u7B5F\u7B61\u7B63", 10, "\u7B6F\u7B70\u7B73\u7B74\u7B76\u7B78\u7B7A\u7B7C\u7B7D\u7B7F\u7B81\u7B82\u7B83\u7B84\u7B86", 6, "\u7B8E\u7B8F"],
    ["b980", "\u7B91\u7B92\u7B93\u7B96\u7B98\u7B99\u7B9A\u7B9B\u7B9E\u7B9F\u7BA0\u7BA3\u7BA4\u7BA5\u7BAE\u7BAF\u7BB0\u7BB2\u7BB3\u7BB5\u7BB6\u7BB7\u7BB9", 7, "\u7BC2\u7BC3\u7BC4\u57C2\u803F\u6897\u5DE5\u653B\u529F\u606D\u9F9A\u4F9B\u8EAC\u516C\u5BAB\u5F13\u5DE9\u6C5E\u62F1\u8D21\u5171\u94A9\u52FE\u6C9F\u82DF\u72D7\u57A2\u6784\u8D2D\u591F\u8F9C\u83C7\u5495\u7B8D\u4F30\u6CBD\u5B64\u59D1\u9F13\u53E4\u86CA\u9AA8\u8C37\u80A1\u6545\u987E\u56FA\u96C7\u522E\u74DC\u5250\u5BE1\u6302\u8902\u4E56\u62D0\u602A\u68FA\u5173\u5B98\u51A0\u89C2\u7BA1\u9986\u7F50\u60EF\u704C\u8D2F\u5149\u5E7F\u901B\u7470\u89C4\u572D\u7845\u5F52\u9F9F\u95FA\u8F68\u9B3C\u8BE1\u7678\u6842\u67DC\u8DEA\u8D35\u523D\u8F8A\u6EDA\u68CD\u9505\u90ED\u56FD\u679C\u88F9\u8FC7\u54C8"],
    ["ba40", "\u7BC5\u7BC8\u7BC9\u7BCA\u7BCB\u7BCD\u7BCE\u7BCF\u7BD0\u7BD2\u7BD4", 4, "\u7BDB\u7BDC\u7BDE\u7BDF\u7BE0\u7BE2\u7BE3\u7BE4\u7BE7\u7BE8\u7BE9\u7BEB\u7BEC\u7BED\u7BEF\u7BF0\u7BF2", 4, "\u7BF8\u7BF9\u7BFA\u7BFB\u7BFD\u7BFF", 7, "\u7C08\u7C09\u7C0A\u7C0D\u7C0E\u7C10", 5, "\u7C17\u7C18\u7C19"],
    ["ba80", "\u7C1A", 4, "\u7C20", 5, "\u7C28\u7C29\u7C2B", 12, "\u7C39", 5, "\u7C42\u9AB8\u5B69\u6D77\u6C26\u4EA5\u5BB3\u9A87\u9163\u61A8\u90AF\u97E9\u542B\u6DB5\u5BD2\u51FD\u558A\u7F55\u7FF0\u64BC\u634D\u65F1\u61BE\u608D\u710A\u6C57\u6C49\u592F\u676D\u822A\u58D5\u568E\u8C6A\u6BEB\u90DD\u597D\u8017\u53F7\u6D69\u5475\u559D\u8377\u83CF\u6838\u79BE\u548C\u4F55\u5408\u76D2\u8C89\u9602\u6CB3\u6DB8\u8D6B\u8910\u9E64\u8D3A\u563F\u9ED1\u75D5\u5F88\u72E0\u6068\u54FC\u4EA8\u6A2A\u8861\u6052\u8F70\u54C4\u70D8\u8679\u9E3F\u6D2A\u5B8F\u5F18\u7EA2\u5589\u4FAF\u7334\u543C\u539A\u5019\u540E\u547C\u4E4E\u5FFD\u745A\u58F6\u846B\u80E1\u8774\u72D0\u7CCA\u6E56"],
    ["bb40", "\u7C43", 9, "\u7C4E", 36, "\u7C75", 5, "\u7C7E", 9],
    ["bb80", "\u7C88\u7C8A", 6, "\u7C93\u7C94\u7C96\u7C99\u7C9A\u7C9B\u7CA0\u7CA1\u7CA3\u7CA6\u7CA7\u7CA8\u7CA9\u7CAB\u7CAC\u7CAD\u7CAF\u7CB0\u7CB4", 4, "\u7CBA\u7CBB\u5F27\u864E\u552C\u62A4\u4E92\u6CAA\u6237\u82B1\u54D7\u534E\u733E\u6ED1\u753B\u5212\u5316\u8BDD\u69D0\u5F8A\u6000\u6DEE\u574F\u6B22\u73AF\u6853\u8FD8\u7F13\u6362\u60A3\u5524\u75EA\u8C62\u7115\u6DA3\u5BA6\u5E7B\u8352\u614C\u9EC4\u78FA\u8757\u7C27\u7687\u51F0\u60F6\u714C\u6643\u5E4C\u604D\u8C0E\u7070\u6325\u8F89\u5FBD\u6062\u86D4\u56DE\u6BC1\u6094\u6167\u5349\u60E0\u6666\u8D3F\u79FD\u4F1A\u70E9\u6C47\u8BB3\u8BF2\u7ED8\u8364\u660F\u5A5A\u9B42\u6D51\u6DF7\u8C41\u6D3B\u4F19\u706B\u83B7\u6216\u60D1\u970D\u8D27\u7978\u51FB\u573E\u57FA\u673A\u7578\u7A3D\u79EF\u7B95"],
    ["bc40", "\u7CBF\u7CC0\u7CC2\u7CC3\u7CC4\u7CC6\u7CC9\u7CCB\u7CCE", 6, "\u7CD8\u7CDA\u7CDB\u7CDD\u7CDE\u7CE1", 6, "\u7CE9", 5, "\u7CF0", 7, "\u7CF9\u7CFA\u7CFC", 13, "\u7D0B", 5],
    ["bc80", "\u7D11", 14, "\u7D21\u7D23\u7D24\u7D25\u7D26\u7D28\u7D29\u7D2A\u7D2C\u7D2D\u7D2E\u7D30", 6, "\u808C\u9965\u8FF9\u6FC0\u8BA5\u9E21\u59EC\u7EE9\u7F09\u5409\u6781\u68D8\u8F91\u7C4D\u96C6\u53CA\u6025\u75BE\u6C72\u5373\u5AC9\u7EA7\u6324\u51E0\u810A\u5DF1\u84DF\u6280\u5180\u5B63\u4F0E\u796D\u5242\u60B8\u6D4E\u5BC4\u5BC2\u8BA1\u8BB0\u65E2\u5FCC\u9645\u5993\u7EE7\u7EAA\u5609\u67B7\u5939\u4F73\u5BB6\u52A0\u835A\u988A\u8D3E\u7532\u94BE\u5047\u7A3C\u4EF7\u67B6\u9A7E\u5AC1\u6B7C\u76D1\u575A\u5C16\u7B3A\u95F4\u714E\u517C\u80A9\u8270\u5978\u7F04\u8327\u68C0\u67EC\u78B1\u7877\u62E3\u6361\u7B80\u4FED\u526A\u51CF\u8350\u69DB\u9274\u8DF5\u8D31\u89C1\u952E\u7BAD\u4EF6"],
    ["bd40", "\u7D37", 54, "\u7D6F", 7],
    ["bd80", "\u7D78", 32, "\u5065\u8230\u5251\u996F\u6E10\u6E85\u6DA7\u5EFA\u50F5\u59DC\u5C06\u6D46\u6C5F\u7586\u848B\u6868\u5956\u8BB2\u5320\u9171\u964D\u8549\u6912\u7901\u7126\u80F6\u4EA4\u90CA\u6D47\u9A84\u5A07\u56BC\u6405\u94F0\u77EB\u4FA5\u811A\u72E1\u89D2\u997A\u7F34\u7EDE\u527F\u6559\u9175\u8F7F\u8F83\u53EB\u7A96\u63ED\u63A5\u7686\u79F8\u8857\u9636\u622A\u52AB\u8282\u6854\u6770\u6377\u776B\u7AED\u6D01\u7ED3\u89E3\u59D0\u6212\u85C9\u82A5\u754C\u501F\u4ECB\u75A5\u8BEB\u5C4A\u5DFE\u7B4B\u65A4\u91D1\u4ECA\u6D25\u895F\u7D27\u9526\u4EC5\u8C28\u8FDB\u9773\u664B\u7981\u8FD1\u70EC\u6D78"],
    ["be40", "\u7D99", 12, "\u7DA7", 6, "\u7DAF", 42],
    ["be80", "\u7DDA", 32, "\u5C3D\u52B2\u8346\u5162\u830E\u775B\u6676\u9CB8\u4EAC\u60CA\u7CBE\u7CB3\u7ECF\u4E95\u8B66\u666F\u9888\u9759\u5883\u656C\u955C\u5F84\u75C9\u9756\u7ADF\u7ADE\u51C0\u70AF\u7A98\u63EA\u7A76\u7EA0\u7396\u97ED\u4E45\u7078\u4E5D\u9152\u53A9\u6551\u65E7\u81FC\u8205\u548E\u5C31\u759A\u97A0\u62D8\u72D9\u75BD\u5C45\u9A79\u83CA\u5C40\u5480\u77E9\u4E3E\u6CAE\u805A\u62D2\u636E\u5DE8\u5177\u8DDD\u8E1E\u952F\u4FF1\u53E5\u60E7\u70AC\u5267\u6350\u9E43\u5A1F\u5026\u7737\u5377\u7EE2\u6485\u652B\u6289\u6398\u5014\u7235\u89C9\u51B3\u8BC0\u7EDD\u5747\u83CC\u94A7\u519B\u541B\u5CFB"],
    ["bf40", "\u7DFB", 62],
    ["bf80", "\u7E3A\u7E3C", 4, "\u7E42", 4, "\u7E48", 21, "\u4FCA\u7AE3\u6D5A\u90E1\u9A8F\u5580\u5496\u5361\u54AF\u5F00\u63E9\u6977\u51EF\u6168\u520A\u582A\u52D8\u574E\u780D\u770B\u5EB7\u6177\u7CE0\u625B\u6297\u4EA2\u7095\u8003\u62F7\u70E4\u9760\u5777\u82DB\u67EF\u68F5\u78D5\u9897\u79D1\u58F3\u54B3\u53EF\u6E34\u514B\u523B\u5BA2\u8BFE\u80AF\u5543\u57A6\u6073\u5751\u542D\u7A7A\u6050\u5B54\u63A7\u62A0\u53E3\u6263\u5BC7\u67AF\u54ED\u7A9F\u82E6\u9177\u5E93\u88E4\u5938\u57AE\u630E\u8DE8\u80EF\u5757\u7B77\u4FA9\u5FEB\u5BBD\u6B3E\u5321\u7B50\u72C2\u6846\u77FF\u7736\u65F7\u51B5\u4E8F\u76D4\u5CBF\u7AA5\u8475\u594E\u9B41\u5080"],
    ["c040", "\u7E5E", 35, "\u7E83", 23, "\u7E9C\u7E9D\u7E9E"],
    ["c080", "\u7EAE\u7EB4\u7EBB\u7EBC\u7ED6\u7EE4\u7EEC\u7EF9\u7F0A\u7F10\u7F1E\u7F37\u7F39\u7F3B", 6, "\u7F43\u7F46", 9, "\u7F52\u7F53\u9988\u6127\u6E83\u5764\u6606\u6346\u56F0\u62EC\u6269\u5ED3\u9614\u5783\u62C9\u5587\u8721\u814A\u8FA3\u5566\u83B1\u6765\u8D56\u84DD\u5A6A\u680F\u62E6\u7BEE\u9611\u5170\u6F9C\u8C30\u63FD\u89C8\u61D2\u7F06\u70C2\u6EE5\u7405\u6994\u72FC\u5ECA\u90CE\u6717\u6D6A\u635E\u52B3\u7262\u8001\u4F6C\u59E5\u916A\u70D9\u6D9D\u52D2\u4E50\u96F7\u956D\u857E\u78CA\u7D2F\u5121\u5792\u64C2\u808B\u7C7B\u6CEA\u68F1\u695E\u51B7\u5398\u68A8\u7281\u9ECE\u7BF1\u72F8\u79BB\u6F13\u7406\u674E\u91CC\u9CA4\u793C\u8389\u8354\u540F\u6817\u4E3D\u5389\u52B1\u783E\u5386\u5229\u5088\u4F8B\u4FD0"],
    ["c140", "\u7F56\u7F59\u7F5B\u7F5C\u7F5D\u7F5E\u7F60\u7F63", 4, "\u7F6B\u7F6C\u7F6D\u7F6F\u7F70\u7F73\u7F75\u7F76\u7F77\u7F78\u7F7A\u7F7B\u7F7C\u7F7D\u7F7F\u7F80\u7F82", 7, "\u7F8B\u7F8D\u7F8F", 4, "\u7F95", 4, "\u7F9B\u7F9C\u7FA0\u7FA2\u7FA3\u7FA5\u7FA6\u7FA8", 6, "\u7FB1"],
    ["c180", "\u7FB3", 4, "\u7FBA\u7FBB\u7FBE\u7FC0\u7FC2\u7FC3\u7FC4\u7FC6\u7FC7\u7FC8\u7FC9\u7FCB\u7FCD\u7FCF", 4, "\u7FD6\u7FD7\u7FD9", 5, "\u7FE2\u7FE3\u75E2\u7ACB\u7C92\u6CA5\u96B6\u529B\u7483\u54E9\u4FE9\u8054\u83B2\u8FDE\u9570\u5EC9\u601C\u6D9F\u5E18\u655B\u8138\u94FE\u604B\u70BC\u7EC3\u7CAE\u51C9\u6881\u7CB1\u826F\u4E24\u8F86\u91CF\u667E\u4EAE\u8C05\u64A9\u804A\u50DA\u7597\u71CE\u5BE5\u8FBD\u6F66\u4E86\u6482\u9563\u5ED6\u6599\u5217\u88C2\u70C8\u52A3\u730E\u7433\u6797\u78F7\u9716\u4E34\u90BB\u9CDE\u6DCB\u51DB\u8D41\u541D\u62CE\u73B2\u83F1\u96F6\u9F84\u94C3\u4F36\u7F9A\u51CC\u7075\u9675\u5CAD\u9886\u53E6\u4EE4\u6E9C\u7409\u69B4\u786B\u998F\u7559\u5218\u7624\u6D41\u67F3\u516D\u9F99\u804B\u5499\u7B3C\u7ABF"],
    ["c240", "\u7FE4\u7FE7\u7FE8\u7FEA\u7FEB\u7FEC\u7FED\u7FEF\u7FF2\u7FF4", 6, "\u7FFD\u7FFE\u7FFF\u8002\u8007\u8008\u8009\u800A\u800E\u800F\u8011\u8013\u801A\u801B\u801D\u801E\u801F\u8021\u8023\u8024\u802B", 5, "\u8032\u8034\u8039\u803A\u803C\u803E\u8040\u8041\u8044\u8045\u8047\u8048\u8049\u804E\u804F\u8050\u8051\u8053\u8055\u8056\u8057"],
    ["c280", "\u8059\u805B", 13, "\u806B", 5, "\u8072", 11, "\u9686\u5784\u62E2\u9647\u697C\u5A04\u6402\u7BD3\u6F0F\u964B\u82A6\u5362\u9885\u5E90\u7089\u63B3\u5364\u864F\u9C81\u9E93\u788C\u9732\u8DEF\u8D42\u9E7F\u6F5E\u7984\u5F55\u9646\u622E\u9A74\u5415\u94DD\u4FA3\u65C5\u5C65\u5C61\u7F15\u8651\u6C2F\u5F8B\u7387\u6EE4\u7EFF\u5CE6\u631B\u5B6A\u6EE6\u5375\u4E71\u63A0\u7565\u62A1\u8F6E\u4F26\u4ED1\u6CA6\u7EB6\u8BBA\u841D\u87BA\u7F57\u903B\u9523\u7BA9\u9AA1\u88F8\u843D\u6D1B\u9A86\u7EDC\u5988\u9EBB\u739B\u7801\u8682\u9A6C\u9A82\u561B\u5417\u57CB\u4E70\u9EA6\u5356\u8FC8\u8109\u7792\u9992\u86EE\u6EE1\u8513\u66FC\u6162\u6F2B"],
    ["c340", "\u807E\u8081\u8082\u8085\u8088\u808A\u808D", 5, "\u8094\u8095\u8097\u8099\u809E\u80A3\u80A6\u80A7\u80A8\u80AC\u80B0\u80B3\u80B5\u80B6\u80B8\u80B9\u80BB\u80C5\u80C7", 4, "\u80CF", 6, "\u80D8\u80DF\u80E0\u80E2\u80E3\u80E6\u80EE\u80F5\u80F7\u80F9\u80FB\u80FE\u80FF\u8100\u8101\u8103\u8104\u8105\u8107\u8108\u810B"],
    ["c380", "\u810C\u8115\u8117\u8119\u811B\u811C\u811D\u811F", 12, "\u812D\u812E\u8130\u8133\u8134\u8135\u8137\u8139", 4, "\u813F\u8C29\u8292\u832B\u76F2\u6C13\u5FD9\u83BD\u732B\u8305\u951A\u6BDB\u77DB\u94C6\u536F\u8302\u5192\u5E3D\u8C8C\u8D38\u4E48\u73AB\u679A\u6885\u9176\u9709\u7164\u6CA1\u7709\u5A92\u9541\u6BCF\u7F8E\u6627\u5BD0\u59B9\u5A9A\u95E8\u95F7\u4EEC\u840C\u8499\u6AAC\u76DF\u9530\u731B\u68A6\u5B5F\u772F\u919A\u9761\u7CDC\u8FF7\u8C1C\u5F25\u7C73\u79D8\u89C5\u6CCC\u871C\u5BC6\u5E42\u68C9\u7720\u7EF5\u5195\u514D\u52C9\u5A29\u7F05\u9762\u82D7\u63CF\u7784\u85D0\u79D2\u6E3A\u5E99\u5999\u8511\u706D\u6C11\u62BF\u76BF\u654F\u60AF\u95FD\u660E\u879F\u9E23\u94ED\u540D\u547D\u8C2C\u6478"],
    ["c440", "\u8140", 5, "\u8147\u8149\u814D\u814E\u814F\u8152\u8156\u8157\u8158\u815B", 4, "\u8161\u8162\u8163\u8164\u8166\u8168\u816A\u816B\u816C\u816F\u8172\u8173\u8175\u8176\u8177\u8178\u8181\u8183", 4, "\u8189\u818B\u818C\u818D\u818E\u8190\u8192", 5, "\u8199\u819A\u819E", 4, "\u81A4\u81A5"],
    ["c480", "\u81A7\u81A9\u81AB", 7, "\u81B4", 5, "\u81BC\u81BD\u81BE\u81BF\u81C4\u81C5\u81C7\u81C8\u81C9\u81CB\u81CD", 6, "\u6479\u8611\u6A21\u819C\u78E8\u6469\u9B54\u62B9\u672B\u83AB\u58A8\u9ED8\u6CAB\u6F20\u5BDE\u964C\u8C0B\u725F\u67D0\u62C7\u7261\u4EA9\u59C6\u6BCD\u5893\u66AE\u5E55\u52DF\u6155\u6728\u76EE\u7766\u7267\u7A46\u62FF\u54EA\u5450\u94A0\u90A3\u5A1C\u7EB3\u6C16\u4E43\u5976\u8010\u5948\u5357\u7537\u96BE\u56CA\u6320\u8111\u607C\u95F9\u6DD6\u5462\u9981\u5185\u5AE9\u80FD\u59AE\u9713\u502A\u6CE5\u5C3C\u62DF\u4F60\u533F\u817B\u9006\u6EBA\u852B\u62C8\u5E74\u78BE\u64B5\u637B\u5FF5\u5A18\u917F\u9E1F\u5C3F\u634F\u8042\u5B7D\u556E\u954A\u954D\u6D85\u60A8\u67E0\u72DE\u51DD\u5B81"],
    ["c540", "\u81D4", 14, "\u81E4\u81E5\u81E6\u81E8\u81E9\u81EB\u81EE", 4, "\u81F5", 5, "\u81FD\u81FF\u8203\u8207", 4, "\u820E\u820F\u8211\u8213\u8215", 5, "\u821D\u8220\u8224\u8225\u8226\u8227\u8229\u822E\u8232\u823A\u823C\u823D\u823F"],
    ["c580", "\u8240\u8241\u8242\u8243\u8245\u8246\u8248\u824A\u824C\u824D\u824E\u8250", 7, "\u8259\u825B\u825C\u825D\u825E\u8260", 7, "\u8269\u62E7\u6CDE\u725B\u626D\u94AE\u7EBD\u8113\u6D53\u519C\u5F04\u5974\u52AA\u6012\u5973\u6696\u8650\u759F\u632A\u61E6\u7CEF\u8BFA\u54E6\u6B27\u9E25\u6BB4\u85D5\u5455\u5076\u6CA4\u556A\u8DB4\u722C\u5E15\u6015\u7436\u62CD\u6392\u724C\u5F98\u6E43\u6D3E\u6500\u6F58\u76D8\u78D0\u76FC\u7554\u5224\u53DB\u4E53\u5E9E\u65C1\u802A\u80D6\u629B\u5486\u5228\u70AE\u888D\u8DD1\u6CE1\u5478\u80DA\u57F9\u88F4\u8D54\u966A\u914D\u4F69\u6C9B\u55B7\u76C6\u7830\u62A8\u70F9\u6F8E\u5F6D\u84EC\u68DA\u787C\u7BF7\u81A8\u670B\u9E4F\u6367\u78B0\u576F\u7812\u9739\u6279\u62AB\u5288\u7435\u6BD7"],
    ["c640", "\u826A\u826B\u826C\u826D\u8271\u8275\u8276\u8277\u8278\u827B\u827C\u8280\u8281\u8283\u8285\u8286\u8287\u8289\u828C\u8290\u8293\u8294\u8295\u8296\u829A\u829B\u829E\u82A0\u82A2\u82A3\u82A7\u82B2\u82B5\u82B6\u82BA\u82BB\u82BC\u82BF\u82C0\u82C2\u82C3\u82C5\u82C6\u82C9\u82D0\u82D6\u82D9\u82DA\u82DD\u82E2\u82E7\u82E8\u82E9\u82EA\u82EC\u82ED\u82EE\u82F0\u82F2\u82F3\u82F5\u82F6\u82F8"],
    ["c680", "\u82FA\u82FC", 4, "\u830A\u830B\u830D\u8310\u8312\u8313\u8316\u8318\u8319\u831D", 9, "\u8329\u832A\u832E\u8330\u8332\u8337\u833B\u833D\u5564\u813E\u75B2\u76AE\u5339\u75DE\u50FB\u5C41\u8B6C\u7BC7\u504F\u7247\u9A97\u98D8\u6F02\u74E2\u7968\u6487\u77A5\u62FC\u9891\u8D2B\u54C1\u8058\u4E52\u576A\u82F9\u840D\u5E73\u51ED\u74F6\u8BC4\u5C4F\u5761\u6CFC\u9887\u5A46\u7834\u9B44\u8FEB\u7C95\u5256\u6251\u94FA\u4EC6\u8386\u8461\u83E9\u84B2\u57D4\u6734\u5703\u666E\u6D66\u8C31\u66DD\u7011\u671F\u6B3A\u6816\u621A\u59BB\u4E03\u51C4\u6F06\u67D2\u6C8F\u5176\u68CB\u5947\u6B67\u7566\u5D0E\u8110\u9F50\u65D7\u7948\u7941\u9A91\u8D77\u5C82\u4E5E\u4F01\u542F\u5951\u780C\u5668\u6C14\u8FC4\u5F03\u6C7D\u6CE3\u8BAB\u6390"],
    ["c740", "\u833E\u833F\u8341\u8342\u8344\u8345\u8348\u834A", 4, "\u8353\u8355", 4, "\u835D\u8362\u8370", 6, "\u8379\u837A\u837E", 6, "\u8387\u8388\u838A\u838B\u838C\u838D\u838F\u8390\u8391\u8394\u8395\u8396\u8397\u8399\u839A\u839D\u839F\u83A1", 6, "\u83AC\u83AD\u83AE"],
    ["c780", "\u83AF\u83B5\u83BB\u83BE\u83BF\u83C2\u83C3\u83C4\u83C6\u83C8\u83C9\u83CB\u83CD\u83CE\u83D0\u83D1\u83D2\u83D3\u83D5\u83D7\u83D9\u83DA\u83DB\u83DE\u83E2\u83E3\u83E4\u83E6\u83E7\u83E8\u83EB\u83EC\u83ED\u6070\u6D3D\u7275\u6266\u948E\u94C5\u5343\u8FC1\u7B7E\u4EDF\u8C26\u4E7E\u9ED4\u94B1\u94B3\u524D\u6F5C\u9063\u6D45\u8C34\u5811\u5D4C\u6B20\u6B49\u67AA\u545B\u8154\u7F8C\u5899\u8537\u5F3A\u62A2\u6A47\u9539\u6572\u6084\u6865\u77A7\u4E54\u4FA8\u5DE7\u9798\u64AC\u7FD8\u5CED\u4FCF\u7A8D\u5207\u8304\u4E14\u602F\u7A83\u94A6\u4FB5\u4EB2\u79E6\u7434\u52E4\u82B9\u64D2\u79BD\u5BDD\u6C81\u9752\u8F7B\u6C22\u503E\u537F\u6E05\u64CE\u6674\u6C30\u60C5\u9877\u8BF7\u5E86\u743C\u7A77\u79CB\u4E18\u90B1\u7403\u6C42\u56DA\u914B\u6CC5\u8D8B\u533A\u86C6\u66F2\u8EAF\u5C48\u9A71\u6E20"],
    ["c840", "\u83EE\u83EF\u83F3", 4, "\u83FA\u83FB\u83FC\u83FE\u83FF\u8400\u8402\u8405\u8407\u8408\u8409\u840A\u8410\u8412", 5, "\u8419\u841A\u841B\u841E", 5, "\u8429", 7, "\u8432", 5, "\u8439\u843A\u843B\u843E", 7, "\u8447\u8448\u8449"],
    ["c880", "\u844A", 6, "\u8452", 4, "\u8458\u845D\u845E\u845F\u8460\u8462\u8464", 4, "\u846A\u846E\u846F\u8470\u8472\u8474\u8477\u8479\u847B\u847C\u53D6\u5A36\u9F8B\u8DA3\u53BB\u5708\u98A7\u6743\u919B\u6CC9\u5168\u75CA\u62F3\u72AC\u5238\u529D\u7F3A\u7094\u7638\u5374\u9E4A\u69B7\u786E\u96C0\u88D9\u7FA4\u7136\u71C3\u5189\u67D3\u74E4\u58E4\u6518\u56B7\u8BA9\u9976\u6270\u7ED5\u60F9\u70ED\u58EC\u4EC1\u4EBA\u5FCD\u97E7\u4EFB\u8BA4\u5203\u598A\u7EAB\u6254\u4ECD\u65E5\u620E\u8338\u84C9\u8363\u878D\u7194\u6EB6\u5BB9\u7ED2\u5197\u63C9\u67D4\u8089\u8339\u8815\u5112\u5B7A\u5982\u8FB1\u4E73\u6C5D\u5165\u8925\u8F6F\u962E\u854A\u745E\u9510\u95F0\u6DA6\u82E5\u5F31\u6492\u6D12\u8428\u816E\u9CC3\u585E\u8D5B\u4E09\u53C1"],
    ["c940", "\u847D", 4, "\u8483\u8484\u8485\u8486\u848A\u848D\u848F", 7, "\u8498\u849A\u849B\u849D\u849E\u849F\u84A0\u84A2", 12, "\u84B0\u84B1\u84B3\u84B5\u84B6\u84B7\u84BB\u84BC\u84BE\u84C0\u84C2\u84C3\u84C5\u84C6\u84C7\u84C8\u84CB\u84CC\u84CE\u84CF\u84D2\u84D4\u84D5\u84D7"],
    ["c980", "\u84D8", 4, "\u84DE\u84E1\u84E2\u84E4\u84E7", 4, "\u84ED\u84EE\u84EF\u84F1", 10, "\u84FD\u84FE\u8500\u8501\u8502\u4F1E\u6563\u6851\u55D3\u4E27\u6414\u9A9A\u626B\u5AC2\u745F\u8272\u6DA9\u68EE\u50E7\u838E\u7802\u6740\u5239\u6C99\u7EB1\u50BB\u5565\u715E\u7B5B\u6652\u73CA\u82EB\u6749\u5C71\u5220\u717D\u886B\u95EA\u9655\u64C5\u8D61\u81B3\u5584\u6C55\u6247\u7F2E\u5892\u4F24\u5546\u8D4F\u664C\u4E0A\u5C1A\u88F3\u68A2\u634E\u7A0D\u70E7\u828D\u52FA\u97F6\u5C11\u54E8\u90B5\u7ECD\u5962\u8D4A\u86C7\u820C\u820D\u8D66\u6444\u5C04\u6151\u6D89\u793E\u8BBE\u7837\u7533\u547B\u4F38\u8EAB\u6DF1\u5A20\u7EC5\u795E\u6C88\u5BA1\u5A76\u751A\u80BE\u614E\u6E17\u58F0\u751F\u7525\u7272\u5347\u7EF3"],
    ["ca40", "\u8503", 8, "\u850D\u850E\u850F\u8510\u8512\u8514\u8515\u8516\u8518\u8519\u851B\u851C\u851D\u851E\u8520\u8522", 8, "\u852D", 9, "\u853E", 4, "\u8544\u8545\u8546\u8547\u854B", 10],
    ["ca80", "\u8557\u8558\u855A\u855B\u855C\u855D\u855F", 4, "\u8565\u8566\u8567\u8569", 8, "\u8573\u8575\u8576\u8577\u8578\u857C\u857D\u857F\u8580\u8581\u7701\u76DB\u5269\u80DC\u5723\u5E08\u5931\u72EE\u65BD\u6E7F\u8BD7\u5C38\u8671\u5341\u77F3\u62FE\u65F6\u4EC0\u98DF\u8680\u5B9E\u8BC6\u53F2\u77E2\u4F7F\u5C4E\u9A76\u59CB\u5F0F\u793A\u58EB\u4E16\u67FF\u4E8B\u62ED\u8A93\u901D\u52BF\u662F\u55DC\u566C\u9002\u4ED5\u4F8D\u91CA\u9970\u6C0F\u5E02\u6043\u5BA4\u89C6\u8BD5\u6536\u624B\u9996\u5B88\u5BFF\u6388\u552E\u53D7\u7626\u517D\u852C\u67A2\u68B3\u6B8A\u6292\u8F93\u53D4\u8212\u6DD1\u758F\u4E66\u8D4E\u5B70\u719F\u85AF\u6691\u66D9\u7F72\u8700\u9ECD\u9F20\u5C5E\u672F\u8FF0\u6811\u675F\u620D\u7AD6\u5885\u5EB6\u6570\u6F31"],
    ["cb40", "\u8582\u8583\u8586\u8588", 6, "\u8590", 10, "\u859D", 6, "\u85A5\u85A6\u85A7\u85A9\u85AB\u85AC\u85AD\u85B1", 5, "\u85B8\u85BA", 6, "\u85C2", 6, "\u85CA", 4, "\u85D1\u85D2"],
    ["cb80", "\u85D4\u85D6", 5, "\u85DD", 6, "\u85E5\u85E6\u85E7\u85E8\u85EA", 14, "\u6055\u5237\u800D\u6454\u8870\u7529\u5E05\u6813\u62F4\u971C\u53CC\u723D\u8C01\u6C34\u7761\u7A0E\u542E\u77AC\u987A\u821C\u8BF4\u7855\u6714\u70C1\u65AF\u6495\u5636\u601D\u79C1\u53F8\u4E1D\u6B7B\u8086\u5BFA\u55E3\u56DB\u4F3A\u4F3C\u9972\u5DF3\u677E\u8038\u6002\u9882\u9001\u5B8B\u8BBC\u8BF5\u641C\u8258\u64DE\u55FD\u82CF\u9165\u4FD7\u7D20\u901F\u7C9F\u50F3\u5851\u6EAF\u5BBF\u8BC9\u8083\u9178\u849C\u7B97\u867D\u968B\u968F\u7EE5\u9AD3\u788E\u5C81\u7A57\u9042\u96A7\u795F\u5B59\u635F\u7B0B\u84D1\u68AD\u5506\u7F29\u7410\u7D22\u9501\u6240\u584C\u4ED6\u5B83\u5979\u5854"],
    ["cc40", "\u85F9\u85FA\u85FC\u85FD\u85FE\u8600", 4, "\u8606", 10, "\u8612\u8613\u8614\u8615\u8617", 15, "\u8628\u862A", 13, "\u8639\u863A\u863B\u863D\u863E\u863F\u8640"],
    ["cc80", "\u8641", 11, "\u8652\u8653\u8655", 4, "\u865B\u865C\u865D\u865F\u8660\u8661\u8663", 7, "\u736D\u631E\u8E4B\u8E0F\u80CE\u82D4\u62AC\u53F0\u6CF0\u915E\u592A\u6001\u6C70\u574D\u644A\u8D2A\u762B\u6EE9\u575B\u6A80\u75F0\u6F6D\u8C2D\u8C08\u5766\u6BEF\u8892\u78B3\u63A2\u53F9\u70AD\u6C64\u5858\u642A\u5802\u68E0\u819B\u5510\u7CD6\u5018\u8EBA\u6DCC\u8D9F\u70EB\u638F\u6D9B\u6ED4\u7EE6\u8404\u6843\u9003\u6DD8\u9676\u8BA8\u5957\u7279\u85E4\u817E\u75BC\u8A8A\u68AF\u5254\u8E22\u9511\u63D0\u9898\u8E44\u557C\u4F53\u66FF\u568F\u60D5\u6D95\u5243\u5C49\u5929\u6DFB\u586B\u7530\u751C\u606C\u8214\u8146\u6311\u6761\u8FE2\u773A\u8DF3\u8D34\u94C1\u5E16\u5385\u542C\u70C3"],
    ["cd40", "\u866D\u866F\u8670\u8672", 6, "\u8683", 6, "\u868E", 4, "\u8694\u8696", 5, "\u869E", 4, "\u86A5\u86A6\u86AB\u86AD\u86AE\u86B2\u86B3\u86B7\u86B8\u86B9\u86BB", 4, "\u86C1\u86C2\u86C3\u86C5\u86C8\u86CC\u86CD\u86D2\u86D3\u86D5\u86D6\u86D7\u86DA\u86DC"],
    ["cd80", "\u86DD\u86E0\u86E1\u86E2\u86E3\u86E5\u86E6\u86E7\u86E8\u86EA\u86EB\u86EC\u86EF\u86F5\u86F6\u86F7\u86FA\u86FB\u86FC\u86FD\u86FF\u8701\u8704\u8705\u8706\u870B\u870C\u870E\u870F\u8710\u8711\u8714\u8716\u6C40\u5EF7\u505C\u4EAD\u5EAD\u633A\u8247\u901A\u6850\u916E\u77B3\u540C\u94DC\u5F64\u7AE5\u6876\u6345\u7B52\u7EDF\u75DB\u5077\u6295\u5934\u900F\u51F8\u79C3\u7A81\u56FE\u5F92\u9014\u6D82\u5C60\u571F\u5410\u5154\u6E4D\u56E2\u63A8\u9893\u817F\u8715\u892A\u9000\u541E\u5C6F\u81C0\u62D6\u6258\u8131\u9E35\u9640\u9A6E\u9A7C\u692D\u59A5\u62D3\u553E\u6316\u54C7\u86D9\u6D3C\u5A03\u74E6\u889C\u6B6A\u5916\u8C4C\u5F2F\u6E7E\u73A9\u987D\u4E38\u70F7\u5B8C\u7897\u633D\u665A\u7696\u60CB\u5B9B\u5A49\u4E07\u8155\u6C6A\u738B\u4EA1\u6789\u7F51\u5F80\u65FA\u671B\u5FD8\u5984\u5A01"],
    ["ce40", "\u8719\u871B\u871D\u871F\u8720\u8724\u8726\u8727\u8728\u872A\u872B\u872C\u872D\u872F\u8730\u8732\u8733\u8735\u8736\u8738\u8739\u873A\u873C\u873D\u8740", 6, "\u874A\u874B\u874D\u874F\u8750\u8751\u8752\u8754\u8755\u8756\u8758\u875A", 5, "\u8761\u8762\u8766", 7, "\u876F\u8771\u8772\u8773\u8775"],
    ["ce80", "\u8777\u8778\u8779\u877A\u877F\u8780\u8781\u8784\u8786\u8787\u8789\u878A\u878C\u878E", 4, "\u8794\u8795\u8796\u8798", 6, "\u87A0", 4, "\u5DCD\u5FAE\u5371\u97E6\u8FDD\u6845\u56F4\u552F\u60DF\u4E3A\u6F4D\u7EF4\u82C7\u840E\u59D4\u4F1F\u4F2A\u5C3E\u7EAC\u672A\u851A\u5473\u754F\u80C3\u5582\u9B4F\u4F4D\u6E2D\u8C13\u5C09\u6170\u536B\u761F\u6E29\u868A\u6587\u95FB\u7EB9\u543B\u7A33\u7D0A\u95EE\u55E1\u7FC1\u74EE\u631D\u8717\u6DA1\u7A9D\u6211\u65A1\u5367\u63E1\u6C83\u5DEB\u545C\u94A8\u4E4C\u6C61\u8BEC\u5C4B\u65E0\u829C\u68A7\u543E\u5434\u6BCB\u6B66\u4E94\u6342\u5348\u821E\u4F0D\u4FAE\u575E\u620A\u96FE\u6664\u7269\u52FF\u52A1\u609F\u8BEF\u6614\u7199\u6790\u897F\u7852\u77FD\u6670\u563B\u5438\u9521\u727A"],
    ["cf40", "\u87A5\u87A6\u87A7\u87A9\u87AA\u87AE\u87B0\u87B1\u87B2\u87B4\u87B6\u87B7\u87B8\u87B9\u87BB\u87BC\u87BE\u87BF\u87C1", 4, "\u87C7\u87C8\u87C9\u87CC", 4, "\u87D4", 6, "\u87DC\u87DD\u87DE\u87DF\u87E1\u87E2\u87E3\u87E4\u87E6\u87E7\u87E8\u87E9\u87EB\u87EC\u87ED\u87EF", 9],
    ["cf80", "\u87FA\u87FB\u87FC\u87FD\u87FF\u8800\u8801\u8802\u8804", 5, "\u880B", 7, "\u8814\u8817\u8818\u8819\u881A\u881C", 4, "\u8823\u7A00\u606F\u5E0C\u6089\u819D\u5915\u60DC\u7184\u70EF\u6EAA\u6C50\u7280\u6A84\u88AD\u5E2D\u4E60\u5AB3\u559C\u94E3\u6D17\u7CFB\u9699\u620F\u7EC6\u778E\u867E\u5323\u971E\u8F96\u6687\u5CE1\u4FA0\u72ED\u4E0B\u53A6\u590F\u5413\u6380\u9528\u5148\u4ED9\u9C9C\u7EA4\u54B8\u8D24\u8854\u8237\u95F2\u6D8E\u5F26\u5ACC\u663E\u9669\u73B0\u732E\u53BF\u817A\u9985\u7FA1\u5BAA\u9677\u9650\u7EBF\u76F8\u53A2\u9576\u9999\u7BB1\u8944\u6E58\u4E61\u7FD4\u7965\u8BE6\u60F3\u54CD\u4EAB\u9879\u5DF7\u6A61\u50CF\u5411\u8C61\u8427\u785D\u9704\u524A\u54EE\u56A3\u9500\u6D88\u5BB5\u6DC6\u6653"],
    ["d040", "\u8824", 13, "\u8833", 5, "\u883A\u883B\u883D\u883E\u883F\u8841\u8842\u8843\u8846", 5, "\u884E", 5, "\u8855\u8856\u8858\u885A", 6, "\u8866\u8867\u886A\u886D\u886F\u8871\u8873\u8874\u8875\u8876\u8878\u8879\u887A"],
    ["d080", "\u887B\u887C\u8880\u8883\u8886\u8887\u8889\u888A\u888C\u888E\u888F\u8890\u8891\u8893\u8894\u8895\u8897", 4, "\u889D", 4, "\u88A3\u88A5", 5, "\u5C0F\u5B5D\u6821\u8096\u5578\u7B11\u6548\u6954\u4E9B\u6B47\u874E\u978B\u534F\u631F\u643A\u90AA\u659C\u80C1\u8C10\u5199\u68B0\u5378\u87F9\u61C8\u6CC4\u6CFB\u8C22\u5C51\u85AA\u82AF\u950C\u6B23\u8F9B\u65B0\u5FFB\u5FC3\u4FE1\u8845\u661F\u8165\u7329\u60FA\u5174\u5211\u578B\u5F62\u90A2\u884C\u9192\u5E78\u674F\u6027\u59D3\u5144\u51F6\u80F8\u5308\u6C79\u96C4\u718A\u4F11\u4FEE\u7F9E\u673D\u55C5\u9508\u79C0\u8896\u7EE3\u589F\u620C\u9700\u865A\u5618\u987B\u5F90\u8BB8\u84C4\u9157\u53D9\u65ED\u5E8F\u755C\u6064\u7D6E\u5A7F\u7EEA\u7EED\u8F69\u55A7\u5BA3\u60AC\u65CB\u7384"],
    ["d140", "\u88AC\u88AE\u88AF\u88B0\u88B2", 4, "\u88B8\u88B9\u88BA\u88BB\u88BD\u88BE\u88BF\u88C0\u88C3\u88C4\u88C7\u88C8\u88CA\u88CB\u88CC\u88CD\u88CF\u88D0\u88D1\u88D3\u88D6\u88D7\u88DA", 4, "\u88E0\u88E1\u88E6\u88E7\u88E9", 6, "\u88F2\u88F5\u88F6\u88F7\u88FA\u88FB\u88FD\u88FF\u8900\u8901\u8903", 5],
    ["d180", "\u8909\u890B", 4, "\u8911\u8914", 4, "\u891C", 4, "\u8922\u8923\u8924\u8926\u8927\u8928\u8929\u892C\u892D\u892E\u892F\u8931\u8932\u8933\u8935\u8937\u9009\u7663\u7729\u7EDA\u9774\u859B\u5B66\u7A74\u96EA\u8840\u52CB\u718F\u5FAA\u65EC\u8BE2\u5BFB\u9A6F\u5DE1\u6B89\u6C5B\u8BAD\u8BAF\u900A\u8FC5\u538B\u62BC\u9E26\u9E2D\u5440\u4E2B\u82BD\u7259\u869C\u5D16\u8859\u6DAF\u96C5\u54D1\u4E9A\u8BB6\u7109\u54BD\u9609\u70DF\u6DF9\u76D0\u4E25\u7814\u8712\u5CA9\u5EF6\u8A00\u989C\u960E\u708E\u6CBF\u5944\u63A9\u773C\u884D\u6F14\u8273\u5830\u71D5\u538C\u781A\u96C1\u5501\u5F66\u7130\u5BB4\u8C1A\u9A8C\u6B83\u592E\u9E2F\u79E7\u6768\u626C\u4F6F\u75A1\u7F8A\u6D0B\u9633\u6C27\u4EF0\u75D2\u517B\u6837\u6F3E\u9080\u8170\u5996\u7476"],
    ["d240", "\u8938", 8, "\u8942\u8943\u8945", 24, "\u8960", 5, "\u8967", 19, "\u897C"],
    ["d280", "\u897D\u897E\u8980\u8982\u8984\u8985\u8987", 26, "\u6447\u5C27\u9065\u7A91\u8C23\u59DA\u54AC\u8200\u836F\u8981\u8000\u6930\u564E\u8036\u7237\u91CE\u51B6\u4E5F\u9875\u6396\u4E1A\u53F6\u66F3\u814B\u591C\u6DB2\u4E00\u58F9\u533B\u63D6\u94F1\u4F9D\u4F0A\u8863\u9890\u5937\u9057\u79FB\u4EEA\u80F0\u7591\u6C82\u5B9C\u59E8\u5F5D\u6905\u8681\u501A\u5DF2\u4E59\u77E3\u4EE5\u827A\u6291\u6613\u9091\u5C79\u4EBF\u5F79\u81C6\u9038\u8084\u75AB\u4EA6\u88D4\u610F\u6BC5\u5FC6\u4E49\u76CA\u6EA2\u8BE3\u8BAE\u8C0A\u8BD1\u5F02\u7FFC\u7FCC\u7ECE\u8335\u836B\u56E0\u6BB7\u97F3\u9634\u59FB\u541F\u94F6\u6DEB\u5BC5\u996E\u5C39\u5F15\u9690"],
    ["d340", "\u89A2", 30, "\u89C3\u89CD\u89D3\u89D4\u89D5\u89D7\u89D8\u89D9\u89DB\u89DD\u89DF\u89E0\u89E1\u89E2\u89E4\u89E7\u89E8\u89E9\u89EA\u89EC\u89ED\u89EE\u89F0\u89F1\u89F2\u89F4", 6],
    ["d380", "\u89FB", 4, "\u8A01", 5, "\u8A08", 21, "\u5370\u82F1\u6A31\u5A74\u9E70\u5E94\u7F28\u83B9\u8424\u8425\u8367\u8747\u8FCE\u8D62\u76C8\u5F71\u9896\u786C\u6620\u54DF\u62E5\u4F63\u81C3\u75C8\u5EB8\u96CD\u8E0A\u86F9\u548F\u6CF3\u6D8C\u6C38\u607F\u52C7\u7528\u5E7D\u4F18\u60A0\u5FE7\u5C24\u7531\u90AE\u94C0\u72B9\u6CB9\u6E38\u9149\u6709\u53CB\u53F3\u4F51\u91C9\u8BF1\u53C8\u5E7C\u8FC2\u6DE4\u4E8E\u76C2\u6986\u865E\u611A\u8206\u4F59\u4FDE\u903E\u9C7C\u6109\u6E1D\u6E14\u9685\u4E88\u5A31\u96E8\u4E0E\u5C7F\u79B9\u5B87\u8BED\u7FBD\u7389\u57DF\u828B\u90C1\u5401\u9047\u55BB\u5CEA\u5FA1\u6108\u6B32\u72F1\u80B2\u8A89"],
    ["d440", "\u8A1E", 31, "\u8A3F", 8, "\u8A49", 21],
    ["d480", "\u8A5F", 25, "\u8A7A", 6, "\u6D74\u5BD3\u88D5\u9884\u8C6B\u9A6D\u9E33\u6E0A\u51A4\u5143\u57A3\u8881\u539F\u63F4\u8F95\u56ED\u5458\u5706\u733F\u6E90\u7F18\u8FDC\u82D1\u613F\u6028\u9662\u66F0\u7EA6\u8D8A\u8DC3\u94A5\u5CB3\u7CA4\u6708\u60A6\u9605\u8018\u4E91\u90E7\u5300\u9668\u5141\u8FD0\u8574\u915D\u6655\u97F5\u5B55\u531D\u7838\u6742\u683D\u54C9\u707E\u5BB0\u8F7D\u518D\u5728\u54B1\u6512\u6682\u8D5E\u8D43\u810F\u846C\u906D\u7CDF\u51FF\u85FB\u67A3\u65E9\u6FA1\u86A4\u8E81\u566A\u9020\u7682\u7076\u71E5\u8D23\u62E9\u5219\u6CFD\u8D3C\u600E\u589E\u618E\u66FE\u8D60\u624E\u55B3\u6E23\u672D\u8F67"],
    ["d540", "\u8A81", 7, "\u8A8B", 7, "\u8A94", 46],
    ["d580", "\u8AC3", 32, "\u94E1\u95F8\u7728\u6805\u69A8\u548B\u4E4D\u70B8\u8BC8\u6458\u658B\u5B85\u7A84\u503A\u5BE8\u77BB\u6BE1\u8A79\u7C98\u6CBE\u76CF\u65A9\u8F97\u5D2D\u5C55\u8638\u6808\u5360\u6218\u7AD9\u6E5B\u7EFD\u6A1F\u7AE0\u5F70\u6F33\u5F20\u638C\u6DA8\u6756\u4E08\u5E10\u8D26\u4ED7\u80C0\u7634\u969C\u62DB\u662D\u627E\u6CBC\u8D75\u7167\u7F69\u5146\u8087\u53EC\u906E\u6298\u54F2\u86F0\u8F99\u8005\u9517\u8517\u8FD9\u6D59\u73CD\u659F\u771F\u7504\u7827\u81FB\u8D1E\u9488\u4FA6\u6795\u75B9\u8BCA\u9707\u632F\u9547\u9635\u84B8\u6323\u7741\u5F81\u72F0\u4E89\u6014\u6574\u62EF\u6B63\u653F"],
    ["d640", "\u8AE4", 34, "\u8B08", 27],
    ["d680", "\u8B24\u8B25\u8B27", 30, "\u5E27\u75C7\u90D1\u8BC1\u829D\u679D\u652F\u5431\u8718\u77E5\u80A2\u8102\u6C41\u4E4B\u7EC7\u804C\u76F4\u690D\u6B96\u6267\u503C\u4F84\u5740\u6307\u6B62\u8DBE\u53EA\u65E8\u7EB8\u5FD7\u631A\u63B7\u81F3\u81F4\u7F6E\u5E1C\u5CD9\u5236\u667A\u79E9\u7A1A\u8D28\u7099\u75D4\u6EDE\u6CBB\u7A92\u4E2D\u76C5\u5FE0\u949F\u8877\u7EC8\u79CD\u80BF\u91CD\u4EF2\u4F17\u821F\u5468\u5DDE\u6D32\u8BCC\u7CA5\u8F74\u8098\u5E1A\u5492\u76B1\u5B99\u663C\u9AA4\u73E0\u682A\u86DB\u6731\u732A\u8BF8\u8BDB\u9010\u7AF9\u70DB\u716E\u62C4\u77A9\u5631\u4E3B\u8457\u67F1\u52A9\u86C0\u8D2E\u94F8\u7B51"],
    ["d740", "\u8B46", 31, "\u8B67", 4, "\u8B6D", 25],
    ["d780", "\u8B87", 24, "\u8BAC\u8BB1\u8BBB\u8BC7\u8BD0\u8BEA\u8C09\u8C1E\u4F4F\u6CE8\u795D\u9A7B\u6293\u722A\u62FD\u4E13\u7816\u8F6C\u64B0\u8D5A\u7BC6\u6869\u5E84\u88C5\u5986\u649E\u58EE\u72B6\u690E\u9525\u8FFD\u8D58\u5760\u7F00\u8C06\u51C6\u6349\u62D9\u5353\u684C\u7422\u8301\u914C\u5544\u7740\u707C\u6D4A\u5179\u54A8\u8D44\u59FF\u6ECB\u6DC4\u5B5C\u7D2B\u4ED4\u7C7D\u6ED3\u5B50\u81EA\u6E0D\u5B57\u9B03\u68D5\u8E2A\u5B97\u7EFC\u603B\u7EB5\u90B9\u8D70\u594F\u63CD\u79DF\u8DB3\u5352\u65CF\u7956\u8BC5\u963B\u7EC4\u94BB\u7E82\u5634\u9189\u6700\u7F6A\u5C0A\u9075\u6628\u5DE6\u4F50\u67DE\u505A\u4F5C\u5750\u5EA7"],
    ["d840", "\u8C38", 8, "\u8C42\u8C43\u8C44\u8C45\u8C48\u8C4A\u8C4B\u8C4D", 7, "\u8C56\u8C57\u8C58\u8C59\u8C5B", 5, "\u8C63", 6, "\u8C6C", 6, "\u8C74\u8C75\u8C76\u8C77\u8C7B", 6, "\u8C83\u8C84\u8C86\u8C87"],
    ["d880", "\u8C88\u8C8B\u8C8D", 6, "\u8C95\u8C96\u8C97\u8C99", 20, "\u4E8D\u4E0C\u5140\u4E10\u5EFF\u5345\u4E15\u4E98\u4E1E\u9B32\u5B6C\u5669\u4E28\u79BA\u4E3F\u5315\u4E47\u592D\u723B\u536E\u6C10\u56DF\u80E4\u9997\u6BD3\u777E\u9F17\u4E36\u4E9F\u9F10\u4E5C\u4E69\u4E93\u8288\u5B5B\u556C\u560F\u4EC4\u538D\u539D\u53A3\u53A5\u53AE\u9765\u8D5D\u531A\u53F5\u5326\u532E\u533E\u8D5C\u5366\u5363\u5202\u5208\u520E\u522D\u5233\u523F\u5240\u524C\u525E\u5261\u525C\u84AF\u527D\u5282\u5281\u5290\u5293\u5182\u7F54\u4EBB\u4EC3\u4EC9\u4EC2\u4EE8\u4EE1\u4EEB\u4EDE\u4F1B\u4EF3\u4F22\u4F64\u4EF5\u4F25\u4F27\u4F09\u4F2B\u4F5E\u4F67\u6538\u4F5A\u4F5D"],
    ["d940", "\u8CAE", 62],
    ["d980", "\u8CED", 32, "\u4F5F\u4F57\u4F32\u4F3D\u4F76\u4F74\u4F91\u4F89\u4F83\u4F8F\u4F7E\u4F7B\u4FAA\u4F7C\u4FAC\u4F94\u4FE6\u4FE8\u4FEA\u4FC5\u4FDA\u4FE3\u4FDC\u4FD1\u4FDF\u4FF8\u5029\u504C\u4FF3\u502C\u500F\u502E\u502D\u4FFE\u501C\u500C\u5025\u5028\u507E\u5043\u5055\u5048\u504E\u506C\u507B\u50A5\u50A7\u50A9\u50BA\u50D6\u5106\u50ED\u50EC\u50E6\u50EE\u5107\u510B\u4EDD\u6C3D\u4F58\u4F65\u4FCE\u9FA0\u6C46\u7C74\u516E\u5DFD\u9EC9\u9998\u5181\u5914\u52F9\u530D\u8A07\u5310\u51EB\u5919\u5155\u4EA0\u5156\u4EB3\u886E\u88A4\u4EB5\u8114\u88D2\u7980\u5B34\u8803\u7FB8\u51AB\u51B1\u51BD\u51BC"],
    ["da40", "\u8D0E", 14, "\u8D20\u8D51\u8D52\u8D57\u8D5F\u8D65\u8D68\u8D69\u8D6A\u8D6C\u8D6E\u8D6F\u8D71\u8D72\u8D78", 8, "\u8D82\u8D83\u8D86\u8D87\u8D88\u8D89\u8D8C", 4, "\u8D92\u8D93\u8D95", 9, "\u8DA0\u8DA1"],
    ["da80", "\u8DA2\u8DA4", 12, "\u8DB2\u8DB6\u8DB7\u8DB9\u8DBB\u8DBD\u8DC0\u8DC1\u8DC2\u8DC5\u8DC7\u8DC8\u8DC9\u8DCA\u8DCD\u8DD0\u8DD2\u8DD3\u8DD4\u51C7\u5196\u51A2\u51A5\u8BA0\u8BA6\u8BA7\u8BAA\u8BB4\u8BB5\u8BB7\u8BC2\u8BC3\u8BCB\u8BCF\u8BCE\u8BD2\u8BD3\u8BD4\u8BD6\u8BD8\u8BD9\u8BDC\u8BDF\u8BE0\u8BE4\u8BE8\u8BE9\u8BEE\u8BF0\u8BF3\u8BF6\u8BF9\u8BFC\u8BFF\u8C00\u8C02\u8C04\u8C07\u8C0C\u8C0F\u8C11\u8C12\u8C14\u8C15\u8C16\u8C19\u8C1B\u8C18\u8C1D\u8C1F\u8C20\u8C21\u8C25\u8C27\u8C2A\u8C2B\u8C2E\u8C2F\u8C32\u8C33\u8C35\u8C36\u5369\u537A\u961D\u9622\u9621\u9631\u962A\u963D\u963C\u9642\u9649\u9654\u965F\u9667\u966C\u9672\u9674\u9688\u968D\u9697\u96B0\u9097\u909B\u909D\u9099\u90AC\u90A1\u90B4\u90B3\u90B6\u90BA"],
    ["db40", "\u8DD5\u8DD8\u8DD9\u8DDC\u8DE0\u8DE1\u8DE2\u8DE5\u8DE6\u8DE7\u8DE9\u8DED\u8DEE\u8DF0\u8DF1\u8DF2\u8DF4\u8DF6\u8DFC\u8DFE", 6, "\u8E06\u8E07\u8E08\u8E0B\u8E0D\u8E0E\u8E10\u8E11\u8E12\u8E13\u8E15", 7, "\u8E20\u8E21\u8E24", 4, "\u8E2B\u8E2D\u8E30\u8E32\u8E33\u8E34\u8E36\u8E37\u8E38\u8E3B\u8E3C\u8E3E"],
    ["db80", "\u8E3F\u8E43\u8E45\u8E46\u8E4C", 4, "\u8E53", 5, "\u8E5A", 11, "\u8E67\u8E68\u8E6A\u8E6B\u8E6E\u8E71\u90B8\u90B0\u90CF\u90C5\u90BE\u90D0\u90C4\u90C7\u90D3\u90E6\u90E2\u90DC\u90D7\u90DB\u90EB\u90EF\u90FE\u9104\u9122\u911E\u9123\u9131\u912F\u9139\u9143\u9146\u520D\u5942\u52A2\u52AC\u52AD\u52BE\u54FF\u52D0\u52D6\u52F0\u53DF\u71EE\u77CD\u5EF4\u51F5\u51FC\u9B2F\u53B6\u5F01\u755A\u5DEF\u574C\u57A9\u57A1\u587E\u58BC\u58C5\u58D1\u5729\u572C\u572A\u5733\u5739\u572E\u572F\u575C\u573B\u5742\u5769\u5785\u576B\u5786\u577C\u577B\u5768\u576D\u5776\u5773\u57AD\u57A4\u578C\u57B2\u57CF\u57A7\u57B4\u5793\u57A0\u57D5\u57D8\u57DA\u57D9\u57D2\u57B8\u57F4\u57EF\u57F8\u57E4\u57DD"],
    ["dc40", "\u8E73\u8E75\u8E77", 4, "\u8E7D\u8E7E\u8E80\u8E82\u8E83\u8E84\u8E86\u8E88", 6, "\u8E91\u8E92\u8E93\u8E95", 6, "\u8E9D\u8E9F", 11, "\u8EAD\u8EAE\u8EB0\u8EB1\u8EB3", 6, "\u8EBB", 7],
    ["dc80", "\u8EC3", 10, "\u8ECF", 21, "\u580B\u580D\u57FD\u57ED\u5800\u581E\u5819\u5844\u5820\u5865\u586C\u5881\u5889\u589A\u5880\u99A8\u9F19\u61FF\u8279\u827D\u827F\u828F\u828A\u82A8\u8284\u828E\u8291\u8297\u8299\u82AB\u82B8\u82BE\u82B0\u82C8\u82CA\u82E3\u8298\u82B7\u82AE\u82CB\u82CC\u82C1\u82A9\u82B4\u82A1\u82AA\u829F\u82C4\u82CE\u82A4\u82E1\u8309\u82F7\u82E4\u830F\u8307\u82DC\u82F4\u82D2\u82D8\u830C\u82FB\u82D3\u8311\u831A\u8306\u8314\u8315\u82E0\u82D5\u831C\u8351\u835B\u835C\u8308\u8392\u833C\u8334\u8331\u839B\u835E\u832F\u834F\u8347\u8343\u835F\u8340\u8317\u8360\u832D\u833A\u8333\u8366\u8365"],
    ["dd40", "\u8EE5", 62],
    ["dd80", "\u8F24", 32, "\u8368\u831B\u8369\u836C\u836A\u836D\u836E\u83B0\u8378\u83B3\u83B4\u83A0\u83AA\u8393\u839C\u8385\u837C\u83B6\u83A9\u837D\u83B8\u837B\u8398\u839E\u83A8\u83BA\u83BC\u83C1\u8401\u83E5\u83D8\u5807\u8418\u840B\u83DD\u83FD\u83D6\u841C\u8438\u8411\u8406\u83D4\u83DF\u840F\u8403\u83F8\u83F9\u83EA\u83C5\u83C0\u8426\u83F0\u83E1\u845C\u8451\u845A\u8459\u8473\u8487\u8488\u847A\u8489\u8478\u843C\u8446\u8469\u8476\u848C\u848E\u8431\u846D\u84C1\u84CD\u84D0\u84E6\u84BD\u84D3\u84CA\u84BF\u84BA\u84E0\u84A1\u84B9\u84B4\u8497\u84E5\u84E3\u850C\u750D\u8538\u84F0\u8539\u851F\u853A"],
    ["de40", "\u8F45", 32, "\u8F6A\u8F80\u8F8C\u8F92\u8F9D\u8FA0\u8FA1\u8FA2\u8FA4\u8FA5\u8FA6\u8FA7\u8FAA\u8FAC\u8FAD\u8FAE\u8FAF\u8FB2\u8FB3\u8FB4\u8FB5\u8FB7\u8FB8\u8FBA\u8FBB\u8FBC\u8FBF\u8FC0\u8FC3\u8FC6"],
    ["de80", "\u8FC9", 4, "\u8FCF\u8FD2\u8FD6\u8FD7\u8FDA\u8FE0\u8FE1\u8FE3\u8FE7\u8FEC\u8FEF\u8FF1\u8FF2\u8FF4\u8FF5\u8FF6\u8FFA\u8FFB\u8FFC\u8FFE\u8FFF\u9007\u9008\u900C\u900E\u9013\u9015\u9018\u8556\u853B\u84FF\u84FC\u8559\u8548\u8568\u8564\u855E\u857A\u77A2\u8543\u8572\u857B\u85A4\u85A8\u8587\u858F\u8579\u85AE\u859C\u8585\u85B9\u85B7\u85B0\u85D3\u85C1\u85DC\u85FF\u8627\u8605\u8629\u8616\u863C\u5EFE\u5F08\u593C\u5941\u8037\u5955\u595A\u5958\u530F\u5C22\u5C25\u5C2C\u5C34\u624C\u626A\u629F\u62BB\u62CA\u62DA\u62D7\u62EE\u6322\u62F6\u6339\u634B\u6343\u63AD\u63F6\u6371\u637A\u638E\u63B4\u636D\u63AC\u638A\u6369\u63AE\u63BC\u63F2\u63F8\u63E0\u63FF\u63C4\u63DE\u63CE\u6452\u63C6\u63BE\u6445\u6441\u640B\u641B\u6420\u640C\u6426\u6421\u645E\u6484\u646D\u6496"],
    ["df40", "\u9019\u901C\u9023\u9024\u9025\u9027", 5, "\u9030", 4, "\u9037\u9039\u903A\u903D\u903F\u9040\u9043\u9045\u9046\u9048", 4, "\u904E\u9054\u9055\u9056\u9059\u905A\u905C", 5, "\u9064\u9066\u9067\u9069\u906A\u906B\u906C\u906F", 4, "\u9076", 6, "\u907E\u9081"],
    ["df80", "\u9084\u9085\u9086\u9087\u9089\u908A\u908C", 4, "\u9092\u9094\u9096\u9098\u909A\u909C\u909E\u909F\u90A0\u90A4\u90A5\u90A7\u90A8\u90A9\u90AB\u90AD\u90B2\u90B7\u90BC\u90BD\u90BF\u90C0\u647A\u64B7\u64B8\u6499\u64BA\u64C0\u64D0\u64D7\u64E4\u64E2\u6509\u6525\u652E\u5F0B\u5FD2\u7519\u5F11\u535F\u53F1\u53FD\u53E9\u53E8\u53FB\u5412\u5416\u5406\u544B\u5452\u5453\u5454\u5456\u5443\u5421\u5457\u5459\u5423\u5432\u5482\u5494\u5477\u5471\u5464\u549A\u549B\u5484\u5476\u5466\u549D\u54D0\u54AD\u54C2\u54B4\u54D2\u54A7\u54A6\u54D3\u54D4\u5472\u54A3\u54D5\u54BB\u54BF\u54CC\u54D9\u54DA\u54DC\u54A9\u54AA\u54A4\u54DD\u54CF\u54DE\u551B\u54E7\u5520\u54FD\u5514\u54F3\u5522\u5523\u550F\u5511\u5527\u552A\u5567\u558F\u55B5\u5549\u556D\u5541\u5555\u553F\u5550\u553C"],
    ["e040", "\u90C2\u90C3\u90C6\u90C8\u90C9\u90CB\u90CC\u90CD\u90D2\u90D4\u90D5\u90D6\u90D8\u90D9\u90DA\u90DE\u90DF\u90E0\u90E3\u90E4\u90E5\u90E9\u90EA\u90EC\u90EE\u90F0\u90F1\u90F2\u90F3\u90F5\u90F6\u90F7\u90F9\u90FA\u90FB\u90FC\u90FF\u9100\u9101\u9103\u9105", 19, "\u911A\u911B\u911C"],
    ["e080", "\u911D\u911F\u9120\u9121\u9124", 10, "\u9130\u9132", 6, "\u913A", 8, "\u9144\u5537\u5556\u5575\u5576\u5577\u5533\u5530\u555C\u558B\u55D2\u5583\u55B1\u55B9\u5588\u5581\u559F\u557E\u55D6\u5591\u557B\u55DF\u55BD\u55BE\u5594\u5599\u55EA\u55F7\u55C9\u561F\u55D1\u55EB\u55EC\u55D4\u55E6\u55DD\u55C4\u55EF\u55E5\u55F2\u55F3\u55CC\u55CD\u55E8\u55F5\u55E4\u8F94\u561E\u5608\u560C\u5601\u5624\u5623\u55FE\u5600\u5627\u562D\u5658\u5639\u5657\u562C\u564D\u5662\u5659\u565C\u564C\u5654\u5686\u5664\u5671\u566B\u567B\u567C\u5685\u5693\u56AF\u56D4\u56D7\u56DD\u56E1\u56F5\u56EB\u56F9\u56FF\u5704\u570A\u5709\u571C\u5E0F\u5E19\u5E14\u5E11\u5E31\u5E3B\u5E3C"],
    ["e140", "\u9145\u9147\u9148\u9151\u9153\u9154\u9155\u9156\u9158\u9159\u915B\u915C\u915F\u9160\u9166\u9167\u9168\u916B\u916D\u9173\u917A\u917B\u917C\u9180", 4, "\u9186\u9188\u918A\u918E\u918F\u9193", 6, "\u919C", 5, "\u91A4", 5, "\u91AB\u91AC\u91B0\u91B1\u91B2\u91B3\u91B6\u91B7\u91B8\u91B9\u91BB"],
    ["e180", "\u91BC", 10, "\u91C8\u91CB\u91D0\u91D2", 9, "\u91DD", 8, "\u5E37\u5E44\u5E54\u5E5B\u5E5E\u5E61\u5C8C\u5C7A\u5C8D\u5C90\u5C96\u5C88\u5C98\u5C99\u5C91\u5C9A\u5C9C\u5CB5\u5CA2\u5CBD\u5CAC\u5CAB\u5CB1\u5CA3\u5CC1\u5CB7\u5CC4\u5CD2\u5CE4\u5CCB\u5CE5\u5D02\u5D03\u5D27\u5D26\u5D2E\u5D24\u5D1E\u5D06\u5D1B\u5D58\u5D3E\u5D34\u5D3D\u5D6C\u5D5B\u5D6F\u5D5D\u5D6B\u5D4B\u5D4A\u5D69\u5D74\u5D82\u5D99\u5D9D\u8C73\u5DB7\u5DC5\u5F73\u5F77\u5F82\u5F87\u5F89\u5F8C\u5F95\u5F99\u5F9C\u5FA8\u5FAD\u5FB5\u5FBC\u8862\u5F61\u72AD\u72B0\u72B4\u72B7\u72B8\u72C3\u72C1\u72CE\u72CD\u72D2\u72E8\u72EF\u72E9\u72F2\u72F4\u72F7\u7301\u72F3\u7303\u72FA"],
    ["e240", "\u91E6", 62],
    ["e280", "\u9225", 32, "\u72FB\u7317\u7313\u7321\u730A\u731E\u731D\u7315\u7322\u7339\u7325\u732C\u7338\u7331\u7350\u734D\u7357\u7360\u736C\u736F\u737E\u821B\u5925\u98E7\u5924\u5902\u9963\u9967", 5, "\u9974\u9977\u997D\u9980\u9984\u9987\u998A\u998D\u9990\u9991\u9993\u9994\u9995\u5E80\u5E91\u5E8B\u5E96\u5EA5\u5EA0\u5EB9\u5EB5\u5EBE\u5EB3\u8D53\u5ED2\u5ED1\u5EDB\u5EE8\u5EEA\u81BA\u5FC4\u5FC9\u5FD6\u5FCF\u6003\u5FEE\u6004\u5FE1\u5FE4\u5FFE\u6005\u6006\u5FEA\u5FED\u5FF8\u6019\u6035\u6026\u601B\u600F\u600D\u6029\u602B\u600A\u603F\u6021\u6078\u6079\u607B\u607A\u6042"],
    ["e340", "\u9246", 45, "\u9275", 16],
    ["e380", "\u9286", 7, "\u928F", 24, "\u606A\u607D\u6096\u609A\u60AD\u609D\u6083\u6092\u608C\u609B\u60EC\u60BB\u60B1\u60DD\u60D8\u60C6\u60DA\u60B4\u6120\u6126\u6115\u6123\u60F4\u6100\u610E\u612B\u614A\u6175\u61AC\u6194\u61A7\u61B7\u61D4\u61F5\u5FDD\u96B3\u95E9\u95EB\u95F1\u95F3\u95F5\u95F6\u95FC\u95FE\u9603\u9604\u9606\u9608\u960A\u960B\u960C\u960D\u960F\u9612\u9615\u9616\u9617\u9619\u961A\u4E2C\u723F\u6215\u6C35\u6C54\u6C5C\u6C4A\u6CA3\u6C85\u6C90\u6C94\u6C8C\u6C68\u6C69\u6C74\u6C76\u6C86\u6CA9\u6CD0\u6CD4\u6CAD\u6CF7\u6CF8\u6CF1\u6CD7\u6CB2\u6CE0\u6CD6\u6CFA\u6CEB\u6CEE\u6CB1\u6CD3\u6CEF\u6CFE"],
    ["e440", "\u92A8", 5, "\u92AF", 24, "\u92C9", 31],
    ["e480", "\u92E9", 32, "\u6D39\u6D27\u6D0C\u6D43\u6D48\u6D07\u6D04\u6D19\u6D0E\u6D2B\u6D4D\u6D2E\u6D35\u6D1A\u6D4F\u6D52\u6D54\u6D33\u6D91\u6D6F\u6D9E\u6DA0\u6D5E\u6D93\u6D94\u6D5C\u6D60\u6D7C\u6D63\u6E1A\u6DC7\u6DC5\u6DDE\u6E0E\u6DBF\u6DE0\u6E11\u6DE6\u6DDD\u6DD9\u6E16\u6DAB\u6E0C\u6DAE\u6E2B\u6E6E\u6E4E\u6E6B\u6EB2\u6E5F\u6E86\u6E53\u6E54\u6E32\u6E25\u6E44\u6EDF\u6EB1\u6E98\u6EE0\u6F2D\u6EE2\u6EA5\u6EA7\u6EBD\u6EBB\u6EB7\u6ED7\u6EB4\u6ECF\u6E8F\u6EC2\u6E9F\u6F62\u6F46\u6F47\u6F24\u6F15\u6EF9\u6F2F\u6F36\u6F4B\u6F74\u6F2A\u6F09\u6F29\u6F89\u6F8D\u6F8C\u6F78\u6F72\u6F7C\u6F7A\u6FD1"],
    ["e540", "\u930A", 51, "\u933F", 10],
    ["e580", "\u934A", 31, "\u936B\u6FC9\u6FA7\u6FB9\u6FB6\u6FC2\u6FE1\u6FEE\u6FDE\u6FE0\u6FEF\u701A\u7023\u701B\u7039\u7035\u704F\u705E\u5B80\u5B84\u5B95\u5B93\u5BA5\u5BB8\u752F\u9A9E\u6434\u5BE4\u5BEE\u8930\u5BF0\u8E47\u8B07\u8FB6\u8FD3\u8FD5\u8FE5\u8FEE\u8FE4\u8FE9\u8FE6\u8FF3\u8FE8\u9005\u9004\u900B\u9026\u9011\u900D\u9016\u9021\u9035\u9036\u902D\u902F\u9044\u9051\u9052\u9050\u9068\u9058\u9062\u905B\u66B9\u9074\u907D\u9082\u9088\u9083\u908B\u5F50\u5F57\u5F56\u5F58\u5C3B\u54AB\u5C50\u5C59\u5B71\u5C63\u5C66\u7FBC\u5F2A\u5F29\u5F2D\u8274\u5F3C\u9B3B\u5C6E\u5981\u5983\u598D\u59A9\u59AA\u59A3"],
    ["e640", "\u936C", 34, "\u9390", 27],
    ["e680", "\u93AC", 29, "\u93CB\u93CC\u93CD\u5997\u59CA\u59AB\u599E\u59A4\u59D2\u59B2\u59AF\u59D7\u59BE\u5A05\u5A06\u59DD\u5A08\u59E3\u59D8\u59F9\u5A0C\u5A09\u5A32\u5A34\u5A11\u5A23\u5A13\u5A40\u5A67\u5A4A\u5A55\u5A3C\u5A62\u5A75\u80EC\u5AAA\u5A9B\u5A77\u5A7A\u5ABE\u5AEB\u5AB2\u5AD2\u5AD4\u5AB8\u5AE0\u5AE3\u5AF1\u5AD6\u5AE6\u5AD8\u5ADC\u5B09\u5B17\u5B16\u5B32\u5B37\u5B40\u5C15\u5C1C\u5B5A\u5B65\u5B73\u5B51\u5B53\u5B62\u9A75\u9A77\u9A78\u9A7A\u9A7F\u9A7D\u9A80\u9A81\u9A85\u9A88\u9A8A\u9A90\u9A92\u9A93\u9A96\u9A98\u9A9B\u9A9C\u9A9D\u9A9F\u9AA0\u9AA2\u9AA3\u9AA5\u9AA7\u7E9F\u7EA1\u7EA3\u7EA5\u7EA8\u7EA9"],
    ["e740", "\u93CE", 7, "\u93D7", 54],
    ["e780", "\u940E", 32, "\u7EAD\u7EB0\u7EBE\u7EC0\u7EC1\u7EC2\u7EC9\u7ECB\u7ECC\u7ED0\u7ED4\u7ED7\u7EDB\u7EE0\u7EE1\u7EE8\u7EEB\u7EEE\u7EEF\u7EF1\u7EF2\u7F0D\u7EF6\u7EFA\u7EFB\u7EFE\u7F01\u7F02\u7F03\u7F07\u7F08\u7F0B\u7F0C\u7F0F\u7F11\u7F12\u7F17\u7F19\u7F1C\u7F1B\u7F1F\u7F21", 6, "\u7F2A\u7F2B\u7F2C\u7F2D\u7F2F", 4, "\u7F35\u5E7A\u757F\u5DDB\u753E\u9095\u738E\u7391\u73AE\u73A2\u739F\u73CF\u73C2\u73D1\u73B7\u73B3\u73C0\u73C9\u73C8\u73E5\u73D9\u987C\u740A\u73E9\u73E7\u73DE\u73BA\u73F2\u740F\u742A\u745B\u7426\u7425\u7428\u7430\u742E\u742C"],
    ["e840", "\u942F", 14, "\u943F", 43, "\u946C\u946D\u946E\u946F"],
    ["e880", "\u9470", 20, "\u9491\u9496\u9498\u94C7\u94CF\u94D3\u94D4\u94DA\u94E6\u94FB\u951C\u9520\u741B\u741A\u7441\u745C\u7457\u7455\u7459\u7477\u746D\u747E\u749C\u748E\u7480\u7481\u7487\u748B\u749E\u74A8\u74A9\u7490\u74A7\u74D2\u74BA\u97EA\u97EB\u97EC\u674C\u6753\u675E\u6748\u6769\u67A5\u6787\u676A\u6773\u6798\u67A7\u6775\u67A8\u679E\u67AD\u678B\u6777\u677C\u67F0\u6809\u67D8\u680A\u67E9\u67B0\u680C\u67D9\u67B5\u67DA\u67B3\u67DD\u6800\u67C3\u67B8\u67E2\u680E\u67C1\u67FD\u6832\u6833\u6860\u6861\u684E\u6862\u6844\u6864\u6883\u681D\u6855\u6866\u6841\u6867\u6840\u683E\u684A\u6849\u6829\u68B5\u688F\u6874\u6877\u6893\u686B\u68C2\u696E\u68FC\u691F\u6920\u68F9"],
    ["e940", "\u9527\u9533\u953D\u9543\u9548\u954B\u9555\u955A\u9560\u956E\u9574\u9575\u9577", 7, "\u9580", 42],
    ["e980", "\u95AB", 32, "\u6924\u68F0\u690B\u6901\u6957\u68E3\u6910\u6971\u6939\u6960\u6942\u695D\u6984\u696B\u6980\u6998\u6978\u6934\u69CC\u6987\u6988\u69CE\u6989\u6966\u6963\u6979\u699B\u69A7\u69BB\u69AB\u69AD\u69D4\u69B1\u69C1\u69CA\u69DF\u6995\u69E0\u698D\u69FF\u6A2F\u69ED\u6A17\u6A18\u6A65\u69F2\u6A44\u6A3E\u6AA0\u6A50\u6A5B\u6A35\u6A8E\u6A79\u6A3D\u6A28\u6A58\u6A7C\u6A91\u6A90\u6AA9\u6A97\u6AAB\u7337\u7352\u6B81\u6B82\u6B87\u6B84\u6B92\u6B93\u6B8D\u6B9A\u6B9B\u6BA1\u6BAA\u8F6B\u8F6D\u8F71\u8F72\u8F73\u8F75\u8F76\u8F78\u8F77\u8F79\u8F7A\u8F7C\u8F7E\u8F81\u8F82\u8F84\u8F87\u8F8B"],
    ["ea40", "\u95CC", 27, "\u95EC\u95FF\u9607\u9613\u9618\u961B\u961E\u9620\u9623", 6, "\u962B\u962C\u962D\u962F\u9630\u9637\u9638\u9639\u963A\u963E\u9641\u9643\u964A\u964E\u964F\u9651\u9652\u9653\u9656\u9657"],
    ["ea80", "\u9658\u9659\u965A\u965C\u965D\u965E\u9660\u9663\u9665\u9666\u966B\u966D", 4, "\u9673\u9678", 12, "\u9687\u9689\u968A\u8F8D\u8F8E\u8F8F\u8F98\u8F9A\u8ECE\u620B\u6217\u621B\u621F\u6222\u6221\u6225\u6224\u622C\u81E7\u74EF\u74F4\u74FF\u750F\u7511\u7513\u6534\u65EE\u65EF\u65F0\u660A\u6619\u6772\u6603\u6615\u6600\u7085\u66F7\u661D\u6634\u6631\u6636\u6635\u8006\u665F\u6654\u6641\u664F\u6656\u6661\u6657\u6677\u6684\u668C\u66A7\u669D\u66BE\u66DB\u66DC\u66E6\u66E9\u8D32\u8D33\u8D36\u8D3B\u8D3D\u8D40\u8D45\u8D46\u8D48\u8D49\u8D47\u8D4D\u8D55\u8D59\u89C7\u89CA\u89CB\u89CC\u89CE\u89CF\u89D0\u89D1\u726E\u729F\u725D\u7266\u726F\u727E\u727F\u7284\u728B\u728D\u728F\u7292\u6308\u6332\u63B0"],
    ["eb40", "\u968C\u968E\u9691\u9692\u9693\u9695\u9696\u969A\u969B\u969D", 9, "\u96A8", 7, "\u96B1\u96B2\u96B4\u96B5\u96B7\u96B8\u96BA\u96BB\u96BF\u96C2\u96C3\u96C8\u96CA\u96CB\u96D0\u96D1\u96D3\u96D4\u96D6", 9, "\u96E1", 6, "\u96EB"],
    ["eb80", "\u96EC\u96ED\u96EE\u96F0\u96F1\u96F2\u96F4\u96F5\u96F8\u96FA\u96FB\u96FC\u96FD\u96FF\u9702\u9703\u9705\u970A\u970B\u970C\u9710\u9711\u9712\u9714\u9715\u9717", 4, "\u971D\u971F\u9720\u643F\u64D8\u8004\u6BEA\u6BF3\u6BFD\u6BF5\u6BF9\u6C05\u6C07\u6C06\u6C0D\u6C15\u6C18\u6C19\u6C1A\u6C21\u6C29\u6C24\u6C2A\u6C32\u6535\u6555\u656B\u724D\u7252\u7256\u7230\u8662\u5216\u809F\u809C\u8093\u80BC\u670A\u80BD\u80B1\u80AB\u80AD\u80B4\u80B7\u80E7\u80E8\u80E9\u80EA\u80DB\u80C2\u80C4\u80D9\u80CD\u80D7\u6710\u80DD\u80EB\u80F1\u80F4\u80ED\u810D\u810E\u80F2\u80FC\u6715\u8112\u8C5A\u8136\u811E\u812C\u8118\u8132\u8148\u814C\u8153\u8174\u8159\u815A\u8171\u8160\u8169\u817C\u817D\u816D\u8167\u584D\u5AB5\u8188\u8182\u8191\u6ED5\u81A3\u81AA\u81CC\u6726\u81CA\u81BB"],
    ["ec40", "\u9721", 8, "\u972B\u972C\u972E\u972F\u9731\u9733", 4, "\u973A\u973B\u973C\u973D\u973F", 18, "\u9754\u9755\u9757\u9758\u975A\u975C\u975D\u975F\u9763\u9764\u9766\u9767\u9768\u976A", 7],
    ["ec80", "\u9772\u9775\u9777", 4, "\u977D", 7, "\u9786", 4, "\u978C\u978E\u978F\u9790\u9793\u9795\u9796\u9797\u9799", 4, "\u81C1\u81A6\u6B24\u6B37\u6B39\u6B43\u6B46\u6B59\u98D1\u98D2\u98D3\u98D5\u98D9\u98DA\u6BB3\u5F40\u6BC2\u89F3\u6590\u9F51\u6593\u65BC\u65C6\u65C4\u65C3\u65CC\u65CE\u65D2\u65D6\u7080\u709C\u7096\u709D\u70BB\u70C0\u70B7\u70AB\u70B1\u70E8\u70CA\u7110\u7113\u7116\u712F\u7131\u7173\u715C\u7168\u7145\u7172\u714A\u7178\u717A\u7198\u71B3\u71B5\u71A8\u71A0\u71E0\u71D4\u71E7\u71F9\u721D\u7228\u706C\u7118\u7166\u71B9\u623E\u623D\u6243\u6248\u6249\u793B\u7940\u7946\u7949\u795B\u795C\u7953\u795A\u7962\u7957\u7960\u796F\u7967\u797A\u7985\u798A\u799A\u79A7\u79B3\u5FD1\u5FD0"],
    ["ed40", "\u979E\u979F\u97A1\u97A2\u97A4", 6, "\u97AC\u97AE\u97B0\u97B1\u97B3\u97B5", 46],
    ["ed80", "\u97E4\u97E5\u97E8\u97EE", 4, "\u97F4\u97F7", 23, "\u603C\u605D\u605A\u6067\u6041\u6059\u6063\u60AB\u6106\u610D\u615D\u61A9\u619D\u61CB\u61D1\u6206\u8080\u807F\u6C93\u6CF6\u6DFC\u77F6\u77F8\u7800\u7809\u7817\u7818\u7811\u65AB\u782D\u781C\u781D\u7839\u783A\u783B\u781F\u783C\u7825\u782C\u7823\u7829\u784E\u786D\u7856\u7857\u7826\u7850\u7847\u784C\u786A\u789B\u7893\u789A\u7887\u789C\u78A1\u78A3\u78B2\u78B9\u78A5\u78D4\u78D9\u78C9\u78EC\u78F2\u7905\u78F4\u7913\u7924\u791E\u7934\u9F9B\u9EF9\u9EFB\u9EFC\u76F1\u7704\u770D\u76F9\u7707\u7708\u771A\u7722\u7719\u772D\u7726\u7735\u7738\u7750\u7751\u7747\u7743\u775A\u7768"],
    ["ee40", "\u980F", 62],
    ["ee80", "\u984E", 32, "\u7762\u7765\u777F\u778D\u777D\u7780\u778C\u7791\u779F\u77A0\u77B0\u77B5\u77BD\u753A\u7540\u754E\u754B\u7548\u755B\u7572\u7579\u7583\u7F58\u7F61\u7F5F\u8A48\u7F68\u7F74\u7F71\u7F79\u7F81\u7F7E\u76CD\u76E5\u8832\u9485\u9486\u9487\u948B\u948A\u948C\u948D\u948F\u9490\u9494\u9497\u9495\u949A\u949B\u949C\u94A3\u94A4\u94AB\u94AA\u94AD\u94AC\u94AF\u94B0\u94B2\u94B4\u94B6", 4, "\u94BC\u94BD\u94BF\u94C4\u94C8", 6, "\u94D0\u94D1\u94D2\u94D5\u94D6\u94D7\u94D9\u94D8\u94DB\u94DE\u94DF\u94E0\u94E2\u94E4\u94E5\u94E7\u94E8\u94EA"],
    ["ef40", "\u986F", 5, "\u988B\u988E\u9892\u9895\u9899\u98A3\u98A8", 37, "\u98CF\u98D0\u98D4\u98D6\u98D7\u98DB\u98DC\u98DD\u98E0", 4],
    ["ef80", "\u98E5\u98E6\u98E9", 30, "\u94E9\u94EB\u94EE\u94EF\u94F3\u94F4\u94F5\u94F7\u94F9\u94FC\u94FD\u94FF\u9503\u9502\u9506\u9507\u9509\u950A\u950D\u950E\u950F\u9512", 4, "\u9518\u951B\u951D\u951E\u951F\u9522\u952A\u952B\u9529\u952C\u9531\u9532\u9534\u9536\u9537\u9538\u953C\u953E\u953F\u9542\u9535\u9544\u9545\u9546\u9549\u954C\u954E\u954F\u9552\u9553\u9554\u9556\u9557\u9558\u9559\u955B\u955E\u955F\u955D\u9561\u9562\u9564", 8, "\u956F\u9571\u9572\u9573\u953A\u77E7\u77EC\u96C9\u79D5\u79ED\u79E3\u79EB\u7A06\u5D47\u7A03\u7A02\u7A1E\u7A14"],
    ["f040", "\u9908", 4, "\u990E\u990F\u9911", 28, "\u992F", 26],
    ["f080", "\u994A", 9, "\u9956", 12, "\u9964\u9966\u9973\u9978\u9979\u997B\u997E\u9982\u9983\u9989\u7A39\u7A37\u7A51\u9ECF\u99A5\u7A70\u7688\u768E\u7693\u7699\u76A4\u74DE\u74E0\u752C\u9E20\u9E22\u9E28", 4, "\u9E32\u9E31\u9E36\u9E38\u9E37\u9E39\u9E3A\u9E3E\u9E41\u9E42\u9E44\u9E46\u9E47\u9E48\u9E49\u9E4B\u9E4C\u9E4E\u9E51\u9E55\u9E57\u9E5A\u9E5B\u9E5C\u9E5E\u9E63\u9E66", 6, "\u9E71\u9E6D\u9E73\u7592\u7594\u7596\u75A0\u759D\u75AC\u75A3\u75B3\u75B4\u75B8\u75C4\u75B1\u75B0\u75C3\u75C2\u75D6\u75CD\u75E3\u75E8\u75E6\u75E4\u75EB\u75E7\u7603\u75F1\u75FC\u75FF\u7610\u7600\u7605\u760C\u7617\u760A\u7625\u7618\u7615\u7619"],
    ["f140", "\u998C\u998E\u999A", 10, "\u99A6\u99A7\u99A9", 47],
    ["f180", "\u99D9", 32, "\u761B\u763C\u7622\u7620\u7640\u762D\u7630\u763F\u7635\u7643\u763E\u7633\u764D\u765E\u7654\u765C\u7656\u766B\u766F\u7FCA\u7AE6\u7A78\u7A79\u7A80\u7A86\u7A88\u7A95\u7AA6\u7AA0\u7AAC\u7AA8\u7AAD\u7AB3\u8864\u8869\u8872\u887D\u887F\u8882\u88A2\u88C6\u88B7\u88BC\u88C9\u88E2\u88CE\u88E3\u88E5\u88F1\u891A\u88FC\u88E8\u88FE\u88F0\u8921\u8919\u8913\u891B\u890A\u8934\u892B\u8936\u8941\u8966\u897B\u758B\u80E5\u76B2\u76B4\u77DC\u8012\u8014\u8016\u801C\u8020\u8022\u8025\u8026\u8027\u8029\u8028\u8031\u800B\u8035\u8043\u8046\u804D\u8052\u8069\u8071\u8983\u9878\u9880\u9883"],
    ["f240", "\u99FA", 62],
    ["f280", "\u9A39", 32, "\u9889\u988C\u988D\u988F\u9894\u989A\u989B\u989E\u989F\u98A1\u98A2\u98A5\u98A6\u864D\u8654\u866C\u866E\u867F\u867A\u867C\u867B\u86A8\u868D\u868B\u86AC\u869D\u86A7\u86A3\u86AA\u8693\u86A9\u86B6\u86C4\u86B5\u86CE\u86B0\u86BA\u86B1\u86AF\u86C9\u86CF\u86B4\u86E9\u86F1\u86F2\u86ED\u86F3\u86D0\u8713\u86DE\u86F4\u86DF\u86D8\u86D1\u8703\u8707\u86F8\u8708\u870A\u870D\u8709\u8723\u873B\u871E\u8725\u872E\u871A\u873E\u8748\u8734\u8731\u8729\u8737\u873F\u8782\u8722\u877D\u877E\u877B\u8760\u8770\u874C\u876E\u878B\u8753\u8763\u877C\u8764\u8759\u8765\u8793\u87AF\u87A8\u87D2"],
    ["f340", "\u9A5A", 17, "\u9A72\u9A83\u9A89\u9A8D\u9A8E\u9A94\u9A95\u9A99\u9AA6\u9AA9", 6, "\u9AB2\u9AB3\u9AB4\u9AB5\u9AB9\u9ABB\u9ABD\u9ABE\u9ABF\u9AC3\u9AC4\u9AC6", 4, "\u9ACD\u9ACE\u9ACF\u9AD0\u9AD2\u9AD4\u9AD5\u9AD6\u9AD7\u9AD9\u9ADA\u9ADB\u9ADC"],
    ["f380", "\u9ADD\u9ADE\u9AE0\u9AE2\u9AE3\u9AE4\u9AE5\u9AE7\u9AE8\u9AE9\u9AEA\u9AEC\u9AEE\u9AF0", 8, "\u9AFA\u9AFC", 6, "\u9B04\u9B05\u9B06\u87C6\u8788\u8785\u87AD\u8797\u8783\u87AB\u87E5\u87AC\u87B5\u87B3\u87CB\u87D3\u87BD\u87D1\u87C0\u87CA\u87DB\u87EA\u87E0\u87EE\u8816\u8813\u87FE\u880A\u881B\u8821\u8839\u883C\u7F36\u7F42\u7F44\u7F45\u8210\u7AFA\u7AFD\u7B08\u7B03\u7B04\u7B15\u7B0A\u7B2B\u7B0F\u7B47\u7B38\u7B2A\u7B19\u7B2E\u7B31\u7B20\u7B25\u7B24\u7B33\u7B3E\u7B1E\u7B58\u7B5A\u7B45\u7B75\u7B4C\u7B5D\u7B60\u7B6E\u7B7B\u7B62\u7B72\u7B71\u7B90\u7BA6\u7BA7\u7BB8\u7BAC\u7B9D\u7BA8\u7B85\u7BAA\u7B9C\u7BA2\u7BAB\u7BB4\u7BD1\u7BC1\u7BCC\u7BDD\u7BDA\u7BE5\u7BE6\u7BEA\u7C0C\u7BFE\u7BFC\u7C0F\u7C16\u7C0B"],
    ["f440", "\u9B07\u9B09", 5, "\u9B10\u9B11\u9B12\u9B14", 10, "\u9B20\u9B21\u9B22\u9B24", 10, "\u9B30\u9B31\u9B33", 7, "\u9B3D\u9B3E\u9B3F\u9B40\u9B46\u9B4A\u9B4B\u9B4C\u9B4E\u9B50\u9B52\u9B53\u9B55", 5],
    ["f480", "\u9B5B", 32, "\u7C1F\u7C2A\u7C26\u7C38\u7C41\u7C40\u81FE\u8201\u8202\u8204\u81EC\u8844\u8221\u8222\u8223\u822D\u822F\u8228\u822B\u8238\u823B\u8233\u8234\u823E\u8244\u8249\u824B\u824F\u825A\u825F\u8268\u887E\u8885\u8888\u88D8\u88DF\u895E\u7F9D\u7F9F\u7FA7\u7FAF\u7FB0\u7FB2\u7C7C\u6549\u7C91\u7C9D\u7C9C\u7C9E\u7CA2\u7CB2\u7CBC\u7CBD\u7CC1\u7CC7\u7CCC\u7CCD\u7CC8\u7CC5\u7CD7\u7CE8\u826E\u66A8\u7FBF\u7FCE\u7FD5\u7FE5\u7FE1\u7FE6\u7FE9\u7FEE\u7FF3\u7CF8\u7D77\u7DA6\u7DAE\u7E47\u7E9B\u9EB8\u9EB4\u8D73\u8D84\u8D94\u8D91\u8DB1\u8D67\u8D6D\u8C47\u8C49\u914A\u9150\u914E\u914F\u9164"],
    ["f540", "\u9B7C", 62],
    ["f580", "\u9BBB", 32, "\u9162\u9161\u9170\u9169\u916F\u917D\u917E\u9172\u9174\u9179\u918C\u9185\u9190\u918D\u9191\u91A2\u91A3\u91AA\u91AD\u91AE\u91AF\u91B5\u91B4\u91BA\u8C55\u9E7E\u8DB8\u8DEB\u8E05\u8E59\u8E69\u8DB5\u8DBF\u8DBC\u8DBA\u8DC4\u8DD6\u8DD7\u8DDA\u8DDE\u8DCE\u8DCF\u8DDB\u8DC6\u8DEC\u8DF7\u8DF8\u8DE3\u8DF9\u8DFB\u8DE4\u8E09\u8DFD\u8E14\u8E1D\u8E1F\u8E2C\u8E2E\u8E23\u8E2F\u8E3A\u8E40\u8E39\u8E35\u8E3D\u8E31\u8E49\u8E41\u8E42\u8E51\u8E52\u8E4A\u8E70\u8E76\u8E7C\u8E6F\u8E74\u8E85\u8E8F\u8E94\u8E90\u8E9C\u8E9E\u8C78\u8C82\u8C8A\u8C85\u8C98\u8C94\u659B\u89D6\u89DE\u89DA\u89DC"],
    ["f640", "\u9BDC", 62],
    ["f680", "\u9C1B", 32, "\u89E5\u89EB\u89EF\u8A3E\u8B26\u9753\u96E9\u96F3\u96EF\u9706\u9701\u9708\u970F\u970E\u972A\u972D\u9730\u973E\u9F80\u9F83\u9F85", 5, "\u9F8C\u9EFE\u9F0B\u9F0D\u96B9\u96BC\u96BD\u96CE\u96D2\u77BF\u96E0\u928E\u92AE\u92C8\u933E\u936A\u93CA\u938F\u943E\u946B\u9C7F\u9C82\u9C85\u9C86\u9C87\u9C88\u7A23\u9C8B\u9C8E\u9C90\u9C91\u9C92\u9C94\u9C95\u9C9A\u9C9B\u9C9E", 5, "\u9CA5", 4, "\u9CAB\u9CAD\u9CAE\u9CB0", 7, "\u9CBA\u9CBB\u9CBC\u9CBD\u9CC4\u9CC5\u9CC6\u9CC7\u9CCA\u9CCB"],
    ["f740", "\u9C3C", 62],
    ["f780", "\u9C7B\u9C7D\u9C7E\u9C80\u9C83\u9C84\u9C89\u9C8A\u9C8C\u9C8F\u9C93\u9C96\u9C97\u9C98\u9C99\u9C9D\u9CAA\u9CAC\u9CAF\u9CB9\u9CBE", 4, "\u9CC8\u9CC9\u9CD1\u9CD2\u9CDA\u9CDB\u9CE0\u9CE1\u9CCC", 4, "\u9CD3\u9CD4\u9CD5\u9CD7\u9CD8\u9CD9\u9CDC\u9CDD\u9CDF\u9CE2\u977C\u9785\u9791\u9792\u9794\u97AF\u97AB\u97A3\u97B2\u97B4\u9AB1\u9AB0\u9AB7\u9E58\u9AB6\u9ABA\u9ABC\u9AC1\u9AC0\u9AC5\u9AC2\u9ACB\u9ACC\u9AD1\u9B45\u9B43\u9B47\u9B49\u9B48\u9B4D\u9B51\u98E8\u990D\u992E\u9955\u9954\u9ADF\u9AE1\u9AE6\u9AEF\u9AEB\u9AFB\u9AED\u9AF9\u9B08\u9B0F\u9B13\u9B1F\u9B23\u9EBD\u9EBE\u7E3B\u9E82\u9E87\u9E88\u9E8B\u9E92\u93D6\u9E9D\u9E9F\u9EDB\u9EDC\u9EDD\u9EE0\u9EDF\u9EE2\u9EE9\u9EE7\u9EE5\u9EEA\u9EEF\u9F22\u9F2C\u9F2F\u9F39\u9F37\u9F3D\u9F3E\u9F44"],
    ["f840", "\u9CE3", 62],
    ["f880", "\u9D22", 32],
    ["f940", "\u9D43", 62],
    ["f980", "\u9D82", 32],
    ["fa40", "\u9DA3", 62],
    ["fa80", "\u9DE2", 32],
    ["fb40", "\u9E03", 27, "\u9E24\u9E27\u9E2E\u9E30\u9E34\u9E3B\u9E3C\u9E40\u9E4D\u9E50\u9E52\u9E53\u9E54\u9E56\u9E59\u9E5D\u9E5F\u9E60\u9E61\u9E62\u9E65\u9E6E\u9E6F\u9E72\u9E74", 9, "\u9E80"],
    ["fb80", "\u9E81\u9E83\u9E84\u9E85\u9E86\u9E89\u9E8A\u9E8C", 5, "\u9E94", 8, "\u9E9E\u9EA0", 5, "\u9EA7\u9EA8\u9EA9\u9EAA"],
    ["fc40", "\u9EAB", 8, "\u9EB5\u9EB6\u9EB7\u9EB9\u9EBA\u9EBC\u9EBF", 4, "\u9EC5\u9EC6\u9EC7\u9EC8\u9ECA\u9ECB\u9ECC\u9ED0\u9ED2\u9ED3\u9ED5\u9ED6\u9ED7\u9ED9\u9EDA\u9EDE\u9EE1\u9EE3\u9EE4\u9EE6\u9EE8\u9EEB\u9EEC\u9EED\u9EEE\u9EF0", 8, "\u9EFA\u9EFD\u9EFF", 6],
    ["fc80", "\u9F06", 4, "\u9F0C\u9F0F\u9F11\u9F12\u9F14\u9F15\u9F16\u9F18\u9F1A", 5, "\u9F21\u9F23", 8, "\u9F2D\u9F2E\u9F30\u9F31"],
    ["fd40", "\u9F32", 4, "\u9F38\u9F3A\u9F3C\u9F3F", 4, "\u9F45", 10, "\u9F52", 38],
    ["fd80", "\u9F79", 5, "\u9F81\u9F82\u9F8D", 11, "\u9F9C\u9F9D\u9F9E\u9FA1", 4, "\uF92C\uF979\uF995\uF9E7\uF9F1"],
    ["fe40", "\uFA0C\uFA0D\uFA0E\uFA0F\uFA11\uFA13\uFA14\uFA18\uFA1F\uFA20\uFA21\uFA23\uFA24\uFA27\uFA28\uFA29"]
  ];
});
var require_gbk_added = __commonJS2((exports, module) => {
  module.exports = [
    ["a140", "\uE4C6", 62],
    ["a180", "\uE505", 32],
    ["a240", "\uE526", 62],
    ["a280", "\uE565", 32],
    ["a2ab", "\uE766", 5],
    ["a2e3", "\u20AC\uE76D"],
    ["a2ef", "\uE76E\uE76F"],
    ["a2fd", "\uE770\uE771"],
    ["a340", "\uE586", 62],
    ["a380", "\uE5C5", 31, "\u3000"],
    ["a440", "\uE5E6", 62],
    ["a480", "\uE625", 32],
    ["a4f4", "\uE772", 10],
    ["a540", "\uE646", 62],
    ["a580", "\uE685", 32],
    ["a5f7", "\uE77D", 7],
    ["a640", "\uE6A6", 62],
    ["a680", "\uE6E5", 32],
    ["a6b9", "\uE785", 7],
    ["a6d9", "\uE78D", 6],
    ["a6ec", "\uE794\uE795"],
    ["a6f3", "\uE796"],
    ["a6f6", "\uE797", 8],
    ["a740", "\uE706", 62],
    ["a780", "\uE745", 32],
    ["a7c2", "\uE7A0", 14],
    ["a7f2", "\uE7AF", 12],
    ["a896", "\uE7BC", 10],
    ["a8bc", "\u1E3F"],
    ["a8bf", "\u01F9"],
    ["a8c1", "\uE7C9\uE7CA\uE7CB\uE7CC"],
    ["a8ea", "\uE7CD", 20],
    ["a958", "\uE7E2"],
    ["a95b", "\uE7E3"],
    ["a95d", "\uE7E4\uE7E5\uE7E6"],
    ["a989", "\u303E\u2FF0", 11],
    ["a997", "\uE7F4", 12],
    ["a9f0", "\uE801", 14],
    ["aaa1", "\uE000", 93],
    ["aba1", "\uE05E", 93],
    ["aca1", "\uE0BC", 93],
    ["ada1", "\uE11A", 93],
    ["aea1", "\uE178", 93],
    ["afa1", "\uE1D6", 93],
    ["d7fa", "\uE810", 4],
    ["f8a1", "\uE234", 93],
    ["f9a1", "\uE292", 93],
    ["faa1", "\uE2F0", 93],
    ["fba1", "\uE34E", 93],
    ["fca1", "\uE3AC", 93],
    ["fda1", "\uE40A", 93],
    ["fe50", "\u2E81\uE816\uE817\uE818\u2E84\u3473\u3447\u2E88\u2E8B\uE81E\u359E\u361A\u360E\u2E8C\u2E97\u396E\u3918\uE826\u39CF\u39DF\u3A73\u39D0\uE82B\uE82C\u3B4E\u3C6E\u3CE0\u2EA7\uE831\uE832\u2EAA\u4056\u415F\u2EAE\u4337\u2EB3\u2EB6\u2EB7\uE83B\u43B1\u43AC\u2EBB\u43DD\u44D6\u4661\u464C\uE843"],
    ["fe80", "\u4723\u4729\u477C\u478D\u2ECA\u4947\u497A\u497D\u4982\u4983\u4985\u4986\u499F\u499B\u49B7\u49B6\uE854\uE855\u4CA3\u4C9F\u4CA0\u4CA1\u4C77\u4CA2\u4D13", 6, "\u4DAE\uE864\uE468", 93],
    ["8135f437", "\uE7C7"]
  ];
});
var require_gb18030_ranges = __commonJS2((exports, module) => {
  module.exports = { uChars: [128, 165, 169, 178, 184, 216, 226, 235, 238, 244, 248, 251, 253, 258, 276, 284, 300, 325, 329, 334, 364, 463, 465, 467, 469, 471, 473, 475, 477, 506, 594, 610, 712, 716, 730, 930, 938, 962, 970, 1026, 1104, 1106, 8209, 8215, 8218, 8222, 8231, 8241, 8244, 8246, 8252, 8365, 8452, 8454, 8458, 8471, 8482, 8556, 8570, 8596, 8602, 8713, 8720, 8722, 8726, 8731, 8737, 8740, 8742, 8748, 8751, 8760, 8766, 8777, 8781, 8787, 8802, 8808, 8816, 8854, 8858, 8870, 8896, 8979, 9322, 9372, 9548, 9588, 9616, 9622, 9634, 9652, 9662, 9672, 9676, 9680, 9702, 9735, 9738, 9793, 9795, 11906, 11909, 11913, 11917, 11928, 11944, 11947, 11951, 11956, 11960, 11964, 11979, 12284, 12292, 12312, 12319, 12330, 12351, 12436, 12447, 12535, 12543, 12586, 12842, 12850, 12964, 13200, 13215, 13218, 13253, 13263, 13267, 13270, 13384, 13428, 13727, 13839, 13851, 14617, 14703, 14801, 14816, 14964, 15183, 15471, 15585, 16471, 16736, 17208, 17325, 17330, 17374, 17623, 17997, 18018, 18212, 18218, 18301, 18318, 18760, 18811, 18814, 18820, 18823, 18844, 18848, 18872, 19576, 19620, 19738, 19887, 40870, 59244, 59336, 59367, 59413, 59417, 59423, 59431, 59437, 59443, 59452, 59460, 59478, 59493, 63789, 63866, 63894, 63976, 63986, 64016, 64018, 64021, 64025, 64034, 64037, 64042, 65074, 65093, 65107, 65112, 65127, 65132, 65375, 65510, 65536], gbChars: [0, 36, 38, 45, 50, 81, 89, 95, 96, 100, 103, 104, 105, 109, 126, 133, 148, 172, 175, 179, 208, 306, 307, 308, 309, 310, 311, 312, 313, 341, 428, 443, 544, 545, 558, 741, 742, 749, 750, 805, 819, 820, 7922, 7924, 7925, 7927, 7934, 7943, 7944, 7945, 7950, 8062, 8148, 8149, 8152, 8164, 8174, 8236, 8240, 8262, 8264, 8374, 8380, 8381, 8384, 8388, 8390, 8392, 8393, 8394, 8396, 8401, 8406, 8416, 8419, 8424, 8437, 8439, 8445, 8482, 8485, 8496, 8521, 8603, 8936, 8946, 9046, 9050, 9063, 9066, 9076, 9092, 9100, 9108, 9111, 9113, 9131, 9162, 9164, 9218, 9219, 11329, 11331, 11334, 11336, 11346, 11361, 11363, 11366, 11370, 11372, 11375, 11389, 11682, 11686, 11687, 11692, 11694, 11714, 11716, 11723, 11725, 11730, 11736, 11982, 11989, 12102, 12336, 12348, 12350, 12384, 12393, 12395, 12397, 12510, 12553, 12851, 12962, 12973, 13738, 13823, 13919, 13933, 14080, 14298, 14585, 14698, 15583, 15847, 16318, 16434, 16438, 16481, 16729, 17102, 17122, 17315, 17320, 17402, 17418, 17859, 17909, 17911, 17915, 17916, 17936, 17939, 17961, 18664, 18703, 18814, 18962, 19043, 33469, 33470, 33471, 33484, 33485, 33490, 33497, 33501, 33505, 33513, 33520, 33536, 33550, 37845, 37921, 37948, 38029, 38038, 38064, 38065, 38066, 38069, 38075, 38076, 38078, 39108, 39109, 39113, 39114, 39115, 39116, 39265, 39394, 189000] };
});
var require_cp949 = __commonJS2((exports, module) => {
  module.exports = [
    ["0", "\0", 127],
    ["8141", "\uAC02\uAC03\uAC05\uAC06\uAC0B", 4, "\uAC18\uAC1E\uAC1F\uAC21\uAC22\uAC23\uAC25", 6, "\uAC2E\uAC32\uAC33\uAC34"],
    ["8161", "\uAC35\uAC36\uAC37\uAC3A\uAC3B\uAC3D\uAC3E\uAC3F\uAC41", 9, "\uAC4C\uAC4E", 5, "\uAC55"],
    ["8181", "\uAC56\uAC57\uAC59\uAC5A\uAC5B\uAC5D", 18, "\uAC72\uAC73\uAC75\uAC76\uAC79\uAC7B", 4, "\uAC82\uAC87\uAC88\uAC8D\uAC8E\uAC8F\uAC91\uAC92\uAC93\uAC95", 6, "\uAC9E\uACA2", 5, "\uACAB\uACAD\uACAE\uACB1", 6, "\uACBA\uACBE\uACBF\uACC0\uACC2\uACC3\uACC5\uACC6\uACC7\uACC9\uACCA\uACCB\uACCD", 7, "\uACD6\uACD8", 7, "\uACE2\uACE3\uACE5\uACE6\uACE9\uACEB\uACED\uACEE\uACF2\uACF4\uACF7", 4, "\uACFE\uACFF\uAD01\uAD02\uAD03\uAD05\uAD07", 4, "\uAD0E\uAD10\uAD12\uAD13"],
    ["8241", "\uAD14\uAD15\uAD16\uAD17\uAD19\uAD1A\uAD1B\uAD1D\uAD1E\uAD1F\uAD21", 7, "\uAD2A\uAD2B\uAD2E", 5],
    ["8261", "\uAD36\uAD37\uAD39\uAD3A\uAD3B\uAD3D", 6, "\uAD46\uAD48\uAD4A", 5, "\uAD51\uAD52\uAD53\uAD55\uAD56\uAD57"],
    ["8281", "\uAD59", 7, "\uAD62\uAD64", 7, "\uAD6E\uAD6F\uAD71\uAD72\uAD77\uAD78\uAD79\uAD7A\uAD7E\uAD80\uAD83", 4, "\uAD8A\uAD8B\uAD8D\uAD8E\uAD8F\uAD91", 10, "\uAD9E", 5, "\uADA5", 17, "\uADB8", 7, "\uADC2\uADC3\uADC5\uADC6\uADC7\uADC9", 6, "\uADD2\uADD4", 7, "\uADDD\uADDE\uADDF\uADE1\uADE2\uADE3\uADE5", 18],
    ["8341", "\uADFA\uADFB\uADFD\uADFE\uAE02", 5, "\uAE0A\uAE0C\uAE0E", 5, "\uAE15", 7],
    ["8361", "\uAE1D", 18, "\uAE32\uAE33\uAE35\uAE36\uAE39\uAE3B\uAE3C"],
    ["8381", "\uAE3D\uAE3E\uAE3F\uAE42\uAE44\uAE47\uAE48\uAE49\uAE4B\uAE4F\uAE51\uAE52\uAE53\uAE55\uAE57", 4, "\uAE5E\uAE62\uAE63\uAE64\uAE66\uAE67\uAE6A\uAE6B\uAE6D\uAE6E\uAE6F\uAE71", 6, "\uAE7A\uAE7E", 5, "\uAE86", 5, "\uAE8D", 46, "\uAEBF\uAEC1\uAEC2\uAEC3\uAEC5", 6, "\uAECE\uAED2", 5, "\uAEDA\uAEDB\uAEDD", 8],
    ["8441", "\uAEE6\uAEE7\uAEE9\uAEEA\uAEEC\uAEEE", 5, "\uAEF5\uAEF6\uAEF7\uAEF9\uAEFA\uAEFB\uAEFD", 8],
    ["8461", "\uAF06\uAF09\uAF0A\uAF0B\uAF0C\uAF0E\uAF0F\uAF11", 18],
    ["8481", "\uAF24", 7, "\uAF2E\uAF2F\uAF31\uAF33\uAF35", 6, "\uAF3E\uAF40\uAF44\uAF45\uAF46\uAF47\uAF4A", 5, "\uAF51", 10, "\uAF5E", 5, "\uAF66", 18, "\uAF7A", 5, "\uAF81\uAF82\uAF83\uAF85\uAF86\uAF87\uAF89", 6, "\uAF92\uAF93\uAF94\uAF96", 5, "\uAF9D", 26, "\uAFBA\uAFBB\uAFBD\uAFBE"],
    ["8541", "\uAFBF\uAFC1", 5, "\uAFCA\uAFCC\uAFCF", 4, "\uAFD5", 6, "\uAFDD", 4],
    ["8561", "\uAFE2", 5, "\uAFEA", 5, "\uAFF2\uAFF3\uAFF5\uAFF6\uAFF7\uAFF9", 6, "\uB002\uB003"],
    ["8581", "\uB005", 6, "\uB00D\uB00E\uB00F\uB011\uB012\uB013\uB015", 6, "\uB01E", 9, "\uB029", 26, "\uB046\uB047\uB049\uB04B\uB04D\uB04F\uB050\uB051\uB052\uB056\uB058\uB05A\uB05B\uB05C\uB05E", 29, "\uB07E\uB07F\uB081\uB082\uB083\uB085", 6, "\uB08E\uB090\uB092", 5, "\uB09B\uB09D\uB09E\uB0A3\uB0A4"],
    ["8641", "\uB0A5\uB0A6\uB0A7\uB0AA\uB0B0\uB0B2\uB0B6\uB0B7\uB0B9\uB0BA\uB0BB\uB0BD", 6, "\uB0C6\uB0CA", 5, "\uB0D2"],
    ["8661", "\uB0D3\uB0D5\uB0D6\uB0D7\uB0D9", 6, "\uB0E1\uB0E2\uB0E3\uB0E4\uB0E6", 10],
    ["8681", "\uB0F1", 22, "\uB10A\uB10D\uB10E\uB10F\uB111\uB114\uB115\uB116\uB117\uB11A\uB11E", 4, "\uB126\uB127\uB129\uB12A\uB12B\uB12D", 6, "\uB136\uB13A", 5, "\uB142\uB143\uB145\uB146\uB147\uB149", 6, "\uB152\uB153\uB156\uB157\uB159\uB15A\uB15B\uB15D\uB15E\uB15F\uB161", 22, "\uB17A\uB17B\uB17D\uB17E\uB17F\uB181\uB183", 4, "\uB18A\uB18C\uB18E\uB18F\uB190\uB191\uB195\uB196\uB197\uB199\uB19A\uB19B\uB19D"],
    ["8741", "\uB19E", 9, "\uB1A9", 15],
    ["8761", "\uB1B9", 18, "\uB1CD\uB1CE\uB1CF\uB1D1\uB1D2\uB1D3\uB1D5"],
    ["8781", "\uB1D6", 5, "\uB1DE\uB1E0", 7, "\uB1EA\uB1EB\uB1ED\uB1EE\uB1EF\uB1F1", 7, "\uB1FA\uB1FC\uB1FE", 5, "\uB206\uB207\uB209\uB20A\uB20D", 6, "\uB216\uB218\uB21A", 5, "\uB221", 18, "\uB235", 6, "\uB23D", 26, "\uB259\uB25A\uB25B\uB25D\uB25E\uB25F\uB261", 6, "\uB26A", 4],
    ["8841", "\uB26F", 4, "\uB276", 5, "\uB27D", 6, "\uB286\uB287\uB288\uB28A", 4],
    ["8861", "\uB28F\uB292\uB293\uB295\uB296\uB297\uB29B", 4, "\uB2A2\uB2A4\uB2A7\uB2A8\uB2A9\uB2AB\uB2AD\uB2AE\uB2AF\uB2B1\uB2B2\uB2B3\uB2B5\uB2B6\uB2B7"],
    ["8881", "\uB2B8", 15, "\uB2CA\uB2CB\uB2CD\uB2CE\uB2CF\uB2D1\uB2D3", 4, "\uB2DA\uB2DC\uB2DE\uB2DF\uB2E0\uB2E1\uB2E3\uB2E7\uB2E9\uB2EA\uB2F0\uB2F1\uB2F2\uB2F6\uB2FC\uB2FD\uB2FE\uB302\uB303\uB305\uB306\uB307\uB309", 6, "\uB312\uB316", 5, "\uB31D", 54, "\uB357\uB359\uB35A\uB35D\uB360\uB361\uB362\uB363"],
    ["8941", "\uB366\uB368\uB36A\uB36C\uB36D\uB36F\uB372\uB373\uB375\uB376\uB377\uB379", 6, "\uB382\uB386", 5, "\uB38D"],
    ["8961", "\uB38E\uB38F\uB391\uB392\uB393\uB395", 10, "\uB3A2", 5, "\uB3A9\uB3AA\uB3AB\uB3AD"],
    ["8981", "\uB3AE", 21, "\uB3C6\uB3C7\uB3C9\uB3CA\uB3CD\uB3CF\uB3D1\uB3D2\uB3D3\uB3D6\uB3D8\uB3DA\uB3DC\uB3DE\uB3DF\uB3E1\uB3E2\uB3E3\uB3E5\uB3E6\uB3E7\uB3E9", 18, "\uB3FD", 18, "\uB411", 6, "\uB419\uB41A\uB41B\uB41D\uB41E\uB41F\uB421", 6, "\uB42A\uB42C", 7, "\uB435", 15],
    ["8a41", "\uB445", 10, "\uB452\uB453\uB455\uB456\uB457\uB459", 6, "\uB462\uB464\uB466"],
    ["8a61", "\uB467", 4, "\uB46D", 18, "\uB481\uB482"],
    ["8a81", "\uB483", 4, "\uB489", 19, "\uB49E", 5, "\uB4A5\uB4A6\uB4A7\uB4A9\uB4AA\uB4AB\uB4AD", 7, "\uB4B6\uB4B8\uB4BA", 5, "\uB4C1\uB4C2\uB4C3\uB4C5\uB4C6\uB4C7\uB4C9", 6, "\uB4D1\uB4D2\uB4D3\uB4D4\uB4D6", 5, "\uB4DE\uB4DF\uB4E1\uB4E2\uB4E5\uB4E7", 4, "\uB4EE\uB4F0\uB4F2", 5, "\uB4F9", 26, "\uB516\uB517\uB519\uB51A\uB51D"],
    ["8b41", "\uB51E", 5, "\uB526\uB52B", 4, "\uB532\uB533\uB535\uB536\uB537\uB539", 6, "\uB542\uB546"],
    ["8b61", "\uB547\uB548\uB549\uB54A\uB54E\uB54F\uB551\uB552\uB553\uB555", 6, "\uB55E\uB562", 8],
    ["8b81", "\uB56B", 52, "\uB5A2\uB5A3\uB5A5\uB5A6\uB5A7\uB5A9\uB5AC\uB5AD\uB5AE\uB5AF\uB5B2\uB5B6", 4, "\uB5BE\uB5BF\uB5C1\uB5C2\uB5C3\uB5C5", 6, "\uB5CE\uB5D2", 5, "\uB5D9", 18, "\uB5ED", 18],
    ["8c41", "\uB600", 15, "\uB612\uB613\uB615\uB616\uB617\uB619", 4],
    ["8c61", "\uB61E", 6, "\uB626", 5, "\uB62D", 6, "\uB635", 5],
    ["8c81", "\uB63B", 12, "\uB649", 26, "\uB665\uB666\uB667\uB669", 50, "\uB69E\uB69F\uB6A1\uB6A2\uB6A3\uB6A5", 5, "\uB6AD\uB6AE\uB6AF\uB6B0\uB6B2", 16],
    ["8d41", "\uB6C3", 16, "\uB6D5", 8],
    ["8d61", "\uB6DE", 17, "\uB6F1\uB6F2\uB6F3\uB6F5\uB6F6\uB6F7\uB6F9\uB6FA"],
    ["8d81", "\uB6FB", 4, "\uB702\uB703\uB704\uB706", 33, "\uB72A\uB72B\uB72D\uB72E\uB731", 6, "\uB73A\uB73C", 7, "\uB745\uB746\uB747\uB749\uB74A\uB74B\uB74D", 6, "\uB756", 9, "\uB761\uB762\uB763\uB765\uB766\uB767\uB769", 6, "\uB772\uB774\uB776", 5, "\uB77E\uB77F\uB781\uB782\uB783\uB785", 6, "\uB78E\uB793\uB794\uB795\uB79A\uB79B\uB79D\uB79E"],
    ["8e41", "\uB79F\uB7A1", 6, "\uB7AA\uB7AE", 5, "\uB7B6\uB7B7\uB7B9", 8],
    ["8e61", "\uB7C2", 4, "\uB7C8\uB7CA", 19],
    ["8e81", "\uB7DE", 13, "\uB7EE\uB7EF\uB7F1\uB7F2\uB7F3\uB7F5", 6, "\uB7FE\uB802", 4, "\uB80A\uB80B\uB80D\uB80E\uB80F\uB811", 6, "\uB81A\uB81C\uB81E", 5, "\uB826\uB827\uB829\uB82A\uB82B\uB82D", 6, "\uB836\uB83A", 5, "\uB841\uB842\uB843\uB845", 11, "\uB852\uB854", 7, "\uB85E\uB85F\uB861\uB862\uB863\uB865", 6, "\uB86E\uB870\uB872", 5, "\uB879\uB87A\uB87B\uB87D", 7],
    ["8f41", "\uB885", 7, "\uB88E", 17],
    ["8f61", "\uB8A0", 7, "\uB8A9", 6, "\uB8B1\uB8B2\uB8B3\uB8B5\uB8B6\uB8B7\uB8B9", 4],
    ["8f81", "\uB8BE\uB8BF\uB8C2\uB8C4\uB8C6", 5, "\uB8CD\uB8CE\uB8CF\uB8D1\uB8D2\uB8D3\uB8D5", 7, "\uB8DE\uB8E0\uB8E2", 5, "\uB8EA\uB8EB\uB8ED\uB8EE\uB8EF\uB8F1", 6, "\uB8FA\uB8FC\uB8FE", 5, "\uB905", 18, "\uB919", 6, "\uB921", 26, "\uB93E\uB93F\uB941\uB942\uB943\uB945", 6, "\uB94D\uB94E\uB950\uB952", 5],
    ["9041", "\uB95A\uB95B\uB95D\uB95E\uB95F\uB961", 6, "\uB96A\uB96C\uB96E", 5, "\uB976\uB977\uB979\uB97A\uB97B\uB97D"],
    ["9061", "\uB97E", 5, "\uB986\uB988\uB98B\uB98C\uB98F", 15],
    ["9081", "\uB99F", 12, "\uB9AE\uB9AF\uB9B1\uB9B2\uB9B3\uB9B5", 6, "\uB9BE\uB9C0\uB9C2", 5, "\uB9CA\uB9CB\uB9CD\uB9D3", 4, "\uB9DA\uB9DC\uB9DF\uB9E0\uB9E2\uB9E6\uB9E7\uB9E9\uB9EA\uB9EB\uB9ED", 6, "\uB9F6\uB9FB", 4, "\uBA02", 5, "\uBA09", 11, "\uBA16", 33, "\uBA3A\uBA3B\uBA3D\uBA3E\uBA3F\uBA41\uBA43\uBA44\uBA45\uBA46"],
    ["9141", "\uBA47\uBA4A\uBA4C\uBA4F\uBA50\uBA51\uBA52\uBA56\uBA57\uBA59\uBA5A\uBA5B\uBA5D", 6, "\uBA66\uBA6A", 5],
    ["9161", "\uBA72\uBA73\uBA75\uBA76\uBA77\uBA79", 9, "\uBA86\uBA88\uBA89\uBA8A\uBA8B\uBA8D", 5],
    ["9181", "\uBA93", 20, "\uBAAA\uBAAD\uBAAE\uBAAF\uBAB1\uBAB3", 4, "\uBABA\uBABC\uBABE", 5, "\uBAC5\uBAC6\uBAC7\uBAC9", 14, "\uBADA", 33, "\uBAFD\uBAFE\uBAFF\uBB01\uBB02\uBB03\uBB05", 7, "\uBB0E\uBB10\uBB12", 5, "\uBB19\uBB1A\uBB1B\uBB1D\uBB1E\uBB1F\uBB21", 6],
    ["9241", "\uBB28\uBB2A\uBB2C", 7, "\uBB37\uBB39\uBB3A\uBB3F", 4, "\uBB46\uBB48\uBB4A\uBB4B\uBB4C\uBB4E\uBB51\uBB52"],
    ["9261", "\uBB53\uBB55\uBB56\uBB57\uBB59", 7, "\uBB62\uBB64", 7, "\uBB6D", 4],
    ["9281", "\uBB72", 21, "\uBB89\uBB8A\uBB8B\uBB8D\uBB8E\uBB8F\uBB91", 18, "\uBBA5\uBBA6\uBBA7\uBBA9\uBBAA\uBBAB\uBBAD", 6, "\uBBB5\uBBB6\uBBB8", 7, "\uBBC1\uBBC2\uBBC3\uBBC5\uBBC6\uBBC7\uBBC9", 6, "\uBBD1\uBBD2\uBBD4", 35, "\uBBFA\uBBFB\uBBFD\uBBFE\uBC01"],
    ["9341", "\uBC03", 4, "\uBC0A\uBC0E\uBC10\uBC12\uBC13\uBC19\uBC1A\uBC20\uBC21\uBC22\uBC23\uBC26\uBC28\uBC2A\uBC2B\uBC2C\uBC2E\uBC2F\uBC32\uBC33\uBC35"],
    ["9361", "\uBC36\uBC37\uBC39", 6, "\uBC42\uBC46\uBC47\uBC48\uBC4A\uBC4B\uBC4E\uBC4F\uBC51", 8],
    ["9381", "\uBC5A\uBC5B\uBC5C\uBC5E", 37, "\uBC86\uBC87\uBC89\uBC8A\uBC8D\uBC8F", 4, "\uBC96\uBC98\uBC9B", 4, "\uBCA2\uBCA3\uBCA5\uBCA6\uBCA9", 6, "\uBCB2\uBCB6", 5, "\uBCBE\uBCBF\uBCC1\uBCC2\uBCC3\uBCC5", 7, "\uBCCE\uBCD2\uBCD3\uBCD4\uBCD6\uBCD7\uBCD9\uBCDA\uBCDB\uBCDD", 22, "\uBCF7\uBCF9\uBCFA\uBCFB\uBCFD"],
    ["9441", "\uBCFE", 5, "\uBD06\uBD08\uBD0A", 5, "\uBD11\uBD12\uBD13\uBD15", 8],
    ["9461", "\uBD1E", 5, "\uBD25", 6, "\uBD2D", 12],
    ["9481", "\uBD3A", 5, "\uBD41", 6, "\uBD4A\uBD4B\uBD4D\uBD4E\uBD4F\uBD51", 6, "\uBD5A", 9, "\uBD65\uBD66\uBD67\uBD69", 22, "\uBD82\uBD83\uBD85\uBD86\uBD8B", 4, "\uBD92\uBD94\uBD96\uBD97\uBD98\uBD9B\uBD9D", 6, "\uBDA5", 10, "\uBDB1", 6, "\uBDB9", 24],
    ["9541", "\uBDD2\uBDD3\uBDD6\uBDD7\uBDD9\uBDDA\uBDDB\uBDDD", 11, "\uBDEA", 5, "\uBDF1"],
    ["9561", "\uBDF2\uBDF3\uBDF5\uBDF6\uBDF7\uBDF9", 6, "\uBE01\uBE02\uBE04\uBE06", 5, "\uBE0E\uBE0F\uBE11\uBE12\uBE13"],
    ["9581", "\uBE15", 6, "\uBE1E\uBE20", 35, "\uBE46\uBE47\uBE49\uBE4A\uBE4B\uBE4D\uBE4F", 4, "\uBE56\uBE58\uBE5C\uBE5D\uBE5E\uBE5F\uBE62\uBE63\uBE65\uBE66\uBE67\uBE69\uBE6B", 4, "\uBE72\uBE76", 4, "\uBE7E\uBE7F\uBE81\uBE82\uBE83\uBE85", 6, "\uBE8E\uBE92", 5, "\uBE9A", 13, "\uBEA9", 14],
    ["9641", "\uBEB8", 23, "\uBED2\uBED3"],
    ["9661", "\uBED5\uBED6\uBED9", 6, "\uBEE1\uBEE2\uBEE6", 5, "\uBEED", 8],
    ["9681", "\uBEF6", 10, "\uBF02", 5, "\uBF0A", 13, "\uBF1A\uBF1E", 33, "\uBF42\uBF43\uBF45\uBF46\uBF47\uBF49", 6, "\uBF52\uBF53\uBF54\uBF56", 44],
    ["9741", "\uBF83", 16, "\uBF95", 8],
    ["9761", "\uBF9E", 17, "\uBFB1", 7],
    ["9781", "\uBFB9", 11, "\uBFC6", 5, "\uBFCE\uBFCF\uBFD1\uBFD2\uBFD3\uBFD5", 6, "\uBFDD\uBFDE\uBFE0\uBFE2", 89, "\uC03D\uC03E\uC03F"],
    ["9841", "\uC040", 16, "\uC052", 5, "\uC059\uC05A\uC05B"],
    ["9861", "\uC05D\uC05E\uC05F\uC061", 6, "\uC06A", 15],
    ["9881", "\uC07A", 21, "\uC092\uC093\uC095\uC096\uC097\uC099", 6, "\uC0A2\uC0A4\uC0A6", 5, "\uC0AE\uC0B1\uC0B2\uC0B7", 4, "\uC0BE\uC0C2\uC0C3\uC0C4\uC0C6\uC0C7\uC0CA\uC0CB\uC0CD\uC0CE\uC0CF\uC0D1", 6, "\uC0DA\uC0DE", 5, "\uC0E6\uC0E7\uC0E9\uC0EA\uC0EB\uC0ED", 6, "\uC0F6\uC0F8\uC0FA", 5, "\uC101\uC102\uC103\uC105\uC106\uC107\uC109", 6, "\uC111\uC112\uC113\uC114\uC116", 5, "\uC121\uC122\uC125\uC128\uC129\uC12A\uC12B\uC12E"],
    ["9941", "\uC132\uC133\uC134\uC135\uC137\uC13A\uC13B\uC13D\uC13E\uC13F\uC141", 6, "\uC14A\uC14E", 5, "\uC156\uC157"],
    ["9961", "\uC159\uC15A\uC15B\uC15D", 6, "\uC166\uC16A", 5, "\uC171\uC172\uC173\uC175\uC176\uC177\uC179\uC17A\uC17B"],
    ["9981", "\uC17C", 8, "\uC186", 5, "\uC18F\uC191\uC192\uC193\uC195\uC197", 4, "\uC19E\uC1A0\uC1A2\uC1A3\uC1A4\uC1A6\uC1A7\uC1AA\uC1AB\uC1AD\uC1AE\uC1AF\uC1B1", 11, "\uC1BE", 5, "\uC1C5\uC1C6\uC1C7\uC1C9\uC1CA\uC1CB\uC1CD", 6, "\uC1D5\uC1D6\uC1D9", 6, "\uC1E1\uC1E2\uC1E3\uC1E5\uC1E6\uC1E7\uC1E9", 6, "\uC1F2\uC1F4", 7, "\uC1FE\uC1FF\uC201\uC202\uC203\uC205", 6, "\uC20E\uC210\uC212", 5, "\uC21A\uC21B\uC21D\uC21E\uC221\uC222\uC223"],
    ["9a41", "\uC224\uC225\uC226\uC227\uC22A\uC22C\uC22E\uC230\uC233\uC235", 16],
    ["9a61", "\uC246\uC247\uC249", 6, "\uC252\uC253\uC255\uC256\uC257\uC259", 6, "\uC261\uC262\uC263\uC264\uC266"],
    ["9a81", "\uC267", 4, "\uC26E\uC26F\uC271\uC272\uC273\uC275", 6, "\uC27E\uC280\uC282", 5, "\uC28A", 5, "\uC291", 6, "\uC299\uC29A\uC29C\uC29E", 5, "\uC2A6\uC2A7\uC2A9\uC2AA\uC2AB\uC2AE", 5, "\uC2B6\uC2B8\uC2BA", 33, "\uC2DE\uC2DF\uC2E1\uC2E2\uC2E5", 5, "\uC2EE\uC2F0\uC2F2\uC2F3\uC2F4\uC2F5\uC2F7\uC2FA\uC2FD\uC2FE\uC2FF\uC301", 6, "\uC30A\uC30B\uC30E\uC30F"],
    ["9b41", "\uC310\uC311\uC312\uC316\uC317\uC319\uC31A\uC31B\uC31D", 6, "\uC326\uC327\uC32A", 8],
    ["9b61", "\uC333", 17, "\uC346", 7],
    ["9b81", "\uC34E", 25, "\uC36A\uC36B\uC36D\uC36E\uC36F\uC371\uC373", 4, "\uC37A\uC37B\uC37E", 5, "\uC385\uC386\uC387\uC389\uC38A\uC38B\uC38D", 50, "\uC3C1", 22, "\uC3DA"],
    ["9c41", "\uC3DB\uC3DD\uC3DE\uC3E1\uC3E3", 4, "\uC3EA\uC3EB\uC3EC\uC3EE", 5, "\uC3F6\uC3F7\uC3F9", 5],
    ["9c61", "\uC3FF", 8, "\uC409", 6, "\uC411", 9],
    ["9c81", "\uC41B", 8, "\uC425", 6, "\uC42D\uC42E\uC42F\uC431\uC432\uC433\uC435", 6, "\uC43E", 9, "\uC449", 26, "\uC466\uC467\uC469\uC46A\uC46B\uC46D", 6, "\uC476\uC477\uC478\uC47A", 5, "\uC481", 18, "\uC495", 6, "\uC49D", 12],
    ["9d41", "\uC4AA", 13, "\uC4B9\uC4BA\uC4BB\uC4BD", 8],
    ["9d61", "\uC4C6", 25],
    ["9d81", "\uC4E0", 8, "\uC4EA", 5, "\uC4F2\uC4F3\uC4F5\uC4F6\uC4F7\uC4F9\uC4FB\uC4FC\uC4FD\uC4FE\uC502", 9, "\uC50D\uC50E\uC50F\uC511\uC512\uC513\uC515", 6, "\uC51D", 10, "\uC52A\uC52B\uC52D\uC52E\uC52F\uC531", 6, "\uC53A\uC53C\uC53E", 5, "\uC546\uC547\uC54B\uC54F\uC550\uC551\uC552\uC556\uC55A\uC55B\uC55C\uC55F\uC562\uC563\uC565\uC566\uC567\uC569", 6, "\uC572\uC576", 5, "\uC57E\uC57F\uC581\uC582\uC583\uC585\uC586\uC588\uC589\uC58A\uC58B\uC58E\uC590\uC592\uC593\uC594"],
    ["9e41", "\uC596\uC599\uC59A\uC59B\uC59D\uC59E\uC59F\uC5A1", 7, "\uC5AA", 9, "\uC5B6"],
    ["9e61", "\uC5B7\uC5BA\uC5BF", 4, "\uC5CB\uC5CD\uC5CF\uC5D2\uC5D3\uC5D5\uC5D6\uC5D7\uC5D9", 6, "\uC5E2\uC5E4\uC5E6\uC5E7"],
    ["9e81", "\uC5E8\uC5E9\uC5EA\uC5EB\uC5EF\uC5F1\uC5F2\uC5F3\uC5F5\uC5F8\uC5F9\uC5FA\uC5FB\uC602\uC603\uC604\uC609\uC60A\uC60B\uC60D\uC60E\uC60F\uC611", 6, "\uC61A\uC61D", 6, "\uC626\uC627\uC629\uC62A\uC62B\uC62F\uC631\uC632\uC636\uC638\uC63A\uC63C\uC63D\uC63E\uC63F\uC642\uC643\uC645\uC646\uC647\uC649", 6, "\uC652\uC656", 5, "\uC65E\uC65F\uC661", 10, "\uC66D\uC66E\uC670\uC672", 5, "\uC67A\uC67B\uC67D\uC67E\uC67F\uC681", 6, "\uC68A\uC68C\uC68E", 5, "\uC696\uC697\uC699\uC69A\uC69B\uC69D", 6, "\uC6A6"],
    ["9f41", "\uC6A8\uC6AA", 5, "\uC6B2\uC6B3\uC6B5\uC6B6\uC6B7\uC6BB", 4, "\uC6C2\uC6C4\uC6C6", 5, "\uC6CE"],
    ["9f61", "\uC6CF\uC6D1\uC6D2\uC6D3\uC6D5", 6, "\uC6DE\uC6DF\uC6E2", 5, "\uC6EA\uC6EB\uC6ED\uC6EE\uC6EF\uC6F1\uC6F2"],
    ["9f81", "\uC6F3", 4, "\uC6FA\uC6FB\uC6FC\uC6FE", 5, "\uC706\uC707\uC709\uC70A\uC70B\uC70D", 6, "\uC716\uC718\uC71A", 5, "\uC722\uC723\uC725\uC726\uC727\uC729", 6, "\uC732\uC734\uC736\uC738\uC739\uC73A\uC73B\uC73E\uC73F\uC741\uC742\uC743\uC745", 4, "\uC74B\uC74E\uC750\uC759\uC75A\uC75B\uC75D\uC75E\uC75F\uC761", 6, "\uC769\uC76A\uC76C", 7, "\uC776\uC777\uC779\uC77A\uC77B\uC77F\uC780\uC781\uC782\uC786\uC78B\uC78C\uC78D\uC78F\uC792\uC793\uC795\uC799\uC79B", 4, "\uC7A2\uC7A7", 4, "\uC7AE\uC7AF\uC7B1\uC7B2\uC7B3\uC7B5\uC7B6\uC7B7"],
    ["a041", "\uC7B8\uC7B9\uC7BA\uC7BB\uC7BE\uC7C2", 5, "\uC7CA\uC7CB\uC7CD\uC7CF\uC7D1", 6, "\uC7D9\uC7DA\uC7DB\uC7DC"],
    ["a061", "\uC7DE", 5, "\uC7E5\uC7E6\uC7E7\uC7E9\uC7EA\uC7EB\uC7ED", 13],
    ["a081", "\uC7FB", 4, "\uC802\uC803\uC805\uC806\uC807\uC809\uC80B", 4, "\uC812\uC814\uC817", 4, "\uC81E\uC81F\uC821\uC822\uC823\uC825", 6, "\uC82E\uC830\uC832", 5, "\uC839\uC83A\uC83B\uC83D\uC83E\uC83F\uC841", 6, "\uC84A\uC84B\uC84E", 5, "\uC855", 26, "\uC872\uC873\uC875\uC876\uC877\uC879\uC87B", 4, "\uC882\uC884\uC888\uC889\uC88A\uC88E", 5, "\uC895", 7, "\uC89E\uC8A0\uC8A2\uC8A3\uC8A4"],
    ["a141", "\uC8A5\uC8A6\uC8A7\uC8A9", 18, "\uC8BE\uC8BF\uC8C0\uC8C1"],
    ["a161", "\uC8C2\uC8C3\uC8C5\uC8C6\uC8C7\uC8C9\uC8CA\uC8CB\uC8CD", 6, "\uC8D6\uC8D8\uC8DA", 5, "\uC8E2\uC8E3\uC8E5"],
    ["a181", "\uC8E6", 14, "\uC8F6", 5, "\uC8FE\uC8FF\uC901\uC902\uC903\uC907", 4, "\uC90E\u3000\u3001\u3002\xB7\u2025\u2026\xA8\u3003\xAD\u2015\u2225\uFF3C\u223C\u2018\u2019\u201C\u201D\u3014\u3015\u3008", 9, "\xB1\xD7\xF7\u2260\u2264\u2265\u221E\u2234\xB0\u2032\u2033\u2103\u212B\uFFE0\uFFE1\uFFE5\u2642\u2640\u2220\u22A5\u2312\u2202\u2207\u2261\u2252\xA7\u203B\u2606\u2605\u25CB\u25CF\u25CE\u25C7\u25C6\u25A1\u25A0\u25B3\u25B2\u25BD\u25BC\u2192\u2190\u2191\u2193\u2194\u3013\u226A\u226B\u221A\u223D\u221D\u2235\u222B\u222C\u2208\u220B\u2286\u2287\u2282\u2283\u222A\u2229\u2227\u2228\uFFE2"],
    ["a241", "\uC910\uC912", 5, "\uC919", 18],
    ["a261", "\uC92D", 6, "\uC935", 18],
    ["a281", "\uC948", 7, "\uC952\uC953\uC955\uC956\uC957\uC959", 6, "\uC962\uC964", 7, "\uC96D\uC96E\uC96F\u21D2\u21D4\u2200\u2203\xB4\uFF5E\u02C7\u02D8\u02DD\u02DA\u02D9\xB8\u02DB\xA1\xBF\u02D0\u222E\u2211\u220F\xA4\u2109\u2030\u25C1\u25C0\u25B7\u25B6\u2664\u2660\u2661\u2665\u2667\u2663\u2299\u25C8\u25A3\u25D0\u25D1\u2592\u25A4\u25A5\u25A8\u25A7\u25A6\u25A9\u2668\u260F\u260E\u261C\u261E\xB6\u2020\u2021\u2195\u2197\u2199\u2196\u2198\u266D\u2669\u266A\u266C\u327F\u321C\u2116\u33C7\u2122\u33C2\u33D8\u2121\u20AC\xAE"],
    ["a341", "\uC971\uC972\uC973\uC975", 6, "\uC97D", 10, "\uC98A\uC98B\uC98D\uC98E\uC98F"],
    ["a361", "\uC991", 6, "\uC99A\uC99C\uC99E", 16],
    ["a381", "\uC9AF", 16, "\uC9C2\uC9C3\uC9C5\uC9C6\uC9C9\uC9CB", 4, "\uC9D2\uC9D4\uC9D7\uC9D8\uC9DB\uFF01", 58, "\uFFE6\uFF3D", 32, "\uFFE3"],
    ["a441", "\uC9DE\uC9DF\uC9E1\uC9E3\uC9E5\uC9E6\uC9E8\uC9E9\uC9EA\uC9EB\uC9EE\uC9F2", 5, "\uC9FA\uC9FB\uC9FD\uC9FE\uC9FF\uCA01\uCA02\uCA03\uCA04"],
    ["a461", "\uCA05\uCA06\uCA07\uCA0A\uCA0E", 5, "\uCA15\uCA16\uCA17\uCA19", 12],
    ["a481", "\uCA26\uCA27\uCA28\uCA2A", 28, "\u3131", 93],
    ["a541", "\uCA47", 4, "\uCA4E\uCA4F\uCA51\uCA52\uCA53\uCA55", 6, "\uCA5E\uCA62", 5, "\uCA69\uCA6A"],
    ["a561", "\uCA6B", 17, "\uCA7E", 5, "\uCA85\uCA86"],
    ["a581", "\uCA87", 16, "\uCA99", 14, "\u2170", 9],
    ["a5b0", "\u2160", 9],
    ["a5c1", "\u0391", 16, "\u03A3", 6],
    ["a5e1", "\u03B1", 16, "\u03C3", 6],
    ["a641", "\uCAA8", 19, "\uCABE\uCABF\uCAC1\uCAC2\uCAC3\uCAC5"],
    ["a661", "\uCAC6", 5, "\uCACE\uCAD0\uCAD2\uCAD4\uCAD5\uCAD6\uCAD7\uCADA", 5, "\uCAE1", 6],
    ["a681", "\uCAE8\uCAE9\uCAEA\uCAEB\uCAED", 6, "\uCAF5", 18, "\uCB09\uCB0A\u2500\u2502\u250C\u2510\u2518\u2514\u251C\u252C\u2524\u2534\u253C\u2501\u2503\u250F\u2513\u251B\u2517\u2523\u2533\u252B\u253B\u254B\u2520\u252F\u2528\u2537\u253F\u251D\u2530\u2525\u2538\u2542\u2512\u2511\u251A\u2519\u2516\u2515\u250E\u250D\u251E\u251F\u2521\u2522\u2526\u2527\u2529\u252A\u252D\u252E\u2531\u2532\u2535\u2536\u2539\u253A\u253D\u253E\u2540\u2541\u2543", 7],
    ["a741", "\uCB0B", 4, "\uCB11\uCB12\uCB13\uCB15\uCB16\uCB17\uCB19", 6, "\uCB22", 7],
    ["a761", "\uCB2A", 22, "\uCB42\uCB43\uCB44"],
    ["a781", "\uCB45\uCB46\uCB47\uCB4A\uCB4B\uCB4D\uCB4E\uCB4F\uCB51", 6, "\uCB5A\uCB5B\uCB5C\uCB5E", 5, "\uCB65", 7, "\u3395\u3396\u3397\u2113\u3398\u33C4\u33A3\u33A4\u33A5\u33A6\u3399", 9, "\u33CA\u338D\u338E\u338F\u33CF\u3388\u3389\u33C8\u33A7\u33A8\u33B0", 9, "\u3380", 4, "\u33BA", 5, "\u3390", 4, "\u2126\u33C0\u33C1\u338A\u338B\u338C\u33D6\u33C5\u33AD\u33AE\u33AF\u33DB\u33A9\u33AA\u33AB\u33AC\u33DD\u33D0\u33D3\u33C3\u33C9\u33DC\u33C6"],
    ["a841", "\uCB6D", 10, "\uCB7A", 14],
    ["a861", "\uCB89", 18, "\uCB9D", 6],
    ["a881", "\uCBA4", 19, "\uCBB9", 11, "\xC6\xD0\xAA\u0126"],
    ["a8a6", "\u0132"],
    ["a8a8", "\u013F\u0141\xD8\u0152\xBA\xDE\u0166\u014A"],
    ["a8b1", "\u3260", 27, "\u24D0", 25, "\u2460", 14, "\xBD\u2153\u2154\xBC\xBE\u215B\u215C\u215D\u215E"],
    ["a941", "\uCBC5", 14, "\uCBD5", 10],
    ["a961", "\uCBE0\uCBE1\uCBE2\uCBE3\uCBE5\uCBE6\uCBE8\uCBEA", 18],
    ["a981", "\uCBFD", 14, "\uCC0E\uCC0F\uCC11\uCC12\uCC13\uCC15", 6, "\uCC1E\uCC1F\uCC20\uCC23\uCC24\xE6\u0111\xF0\u0127\u0131\u0133\u0138\u0140\u0142\xF8\u0153\xDF\xFE\u0167\u014B\u0149\u3200", 27, "\u249C", 25, "\u2474", 14, "\xB9\xB2\xB3\u2074\u207F\u2081\u2082\u2083\u2084"],
    ["aa41", "\uCC25\uCC26\uCC2A\uCC2B\uCC2D\uCC2F\uCC31", 6, "\uCC3A\uCC3F", 4, "\uCC46\uCC47\uCC49\uCC4A\uCC4B\uCC4D\uCC4E"],
    ["aa61", "\uCC4F", 4, "\uCC56\uCC5A", 5, "\uCC61\uCC62\uCC63\uCC65\uCC67\uCC69", 6, "\uCC71\uCC72"],
    ["aa81", "\uCC73\uCC74\uCC76", 29, "\u3041", 82],
    ["ab41", "\uCC94\uCC95\uCC96\uCC97\uCC9A\uCC9B\uCC9D\uCC9E\uCC9F\uCCA1", 6, "\uCCAA\uCCAE", 5, "\uCCB6\uCCB7\uCCB9"],
    ["ab61", "\uCCBA\uCCBB\uCCBD", 6, "\uCCC6\uCCC8\uCCCA", 5, "\uCCD1\uCCD2\uCCD3\uCCD5", 5],
    ["ab81", "\uCCDB", 8, "\uCCE5", 6, "\uCCED\uCCEE\uCCEF\uCCF1", 12, "\u30A1", 85],
    ["ac41", "\uCCFE\uCCFF\uCD00\uCD02", 5, "\uCD0A\uCD0B\uCD0D\uCD0E\uCD0F\uCD11", 6, "\uCD1A\uCD1C\uCD1E\uCD1F\uCD20"],
    ["ac61", "\uCD21\uCD22\uCD23\uCD25\uCD26\uCD27\uCD29\uCD2A\uCD2B\uCD2D", 11, "\uCD3A", 4],
    ["ac81", "\uCD3F", 28, "\uCD5D\uCD5E\uCD5F\u0410", 5, "\u0401\u0416", 25],
    ["acd1", "\u0430", 5, "\u0451\u0436", 25],
    ["ad41", "\uCD61\uCD62\uCD63\uCD65", 6, "\uCD6E\uCD70\uCD72", 5, "\uCD79", 7],
    ["ad61", "\uCD81", 6, "\uCD89", 10, "\uCD96\uCD97\uCD99\uCD9A\uCD9B\uCD9D\uCD9E\uCD9F"],
    ["ad81", "\uCDA0\uCDA1\uCDA2\uCDA3\uCDA6\uCDA8\uCDAA", 5, "\uCDB1", 18, "\uCDC5"],
    ["ae41", "\uCDC6", 5, "\uCDCD\uCDCE\uCDCF\uCDD1", 16],
    ["ae61", "\uCDE2", 5, "\uCDE9\uCDEA\uCDEB\uCDED\uCDEE\uCDEF\uCDF1", 6, "\uCDFA\uCDFC\uCDFE", 4],
    ["ae81", "\uCE03\uCE05\uCE06\uCE07\uCE09\uCE0A\uCE0B\uCE0D", 6, "\uCE15\uCE16\uCE17\uCE18\uCE1A", 5, "\uCE22\uCE23\uCE25\uCE26\uCE27\uCE29\uCE2A\uCE2B"],
    ["af41", "\uCE2C\uCE2D\uCE2E\uCE2F\uCE32\uCE34\uCE36", 19],
    ["af61", "\uCE4A", 13, "\uCE5A\uCE5B\uCE5D\uCE5E\uCE62", 5, "\uCE6A\uCE6C"],
    ["af81", "\uCE6E", 5, "\uCE76\uCE77\uCE79\uCE7A\uCE7B\uCE7D", 6, "\uCE86\uCE88\uCE8A", 5, "\uCE92\uCE93\uCE95\uCE96\uCE97\uCE99"],
    ["b041", "\uCE9A", 5, "\uCEA2\uCEA6", 5, "\uCEAE", 12],
    ["b061", "\uCEBB", 5, "\uCEC2", 19],
    ["b081", "\uCED6", 13, "\uCEE6\uCEE7\uCEE9\uCEEA\uCEED", 6, "\uCEF6\uCEFA", 5, "\uAC00\uAC01\uAC04\uAC07\uAC08\uAC09\uAC0A\uAC10", 7, "\uAC19", 4, "\uAC20\uAC24\uAC2C\uAC2D\uAC2F\uAC30\uAC31\uAC38\uAC39\uAC3C\uAC40\uAC4B\uAC4D\uAC54\uAC58\uAC5C\uAC70\uAC71\uAC74\uAC77\uAC78\uAC7A\uAC80\uAC81\uAC83\uAC84\uAC85\uAC86\uAC89\uAC8A\uAC8B\uAC8C\uAC90\uAC94\uAC9C\uAC9D\uAC9F\uACA0\uACA1\uACA8\uACA9\uACAA\uACAC\uACAF\uACB0\uACB8\uACB9\uACBB\uACBC\uACBD\uACC1\uACC4\uACC8\uACCC\uACD5\uACD7\uACE0\uACE1\uACE4\uACE7\uACE8\uACEA\uACEC\uACEF\uACF0\uACF1\uACF3\uACF5\uACF6\uACFC\uACFD\uAD00\uAD04\uAD06"],
    ["b141", "\uCF02\uCF03\uCF05\uCF06\uCF07\uCF09", 6, "\uCF12\uCF14\uCF16", 5, "\uCF1D\uCF1E\uCF1F\uCF21\uCF22\uCF23"],
    ["b161", "\uCF25", 6, "\uCF2E\uCF32", 5, "\uCF39", 11],
    ["b181", "\uCF45", 14, "\uCF56\uCF57\uCF59\uCF5A\uCF5B\uCF5D", 6, "\uCF66\uCF68\uCF6A\uCF6B\uCF6C\uAD0C\uAD0D\uAD0F\uAD11\uAD18\uAD1C\uAD20\uAD29\uAD2C\uAD2D\uAD34\uAD35\uAD38\uAD3C\uAD44\uAD45\uAD47\uAD49\uAD50\uAD54\uAD58\uAD61\uAD63\uAD6C\uAD6D\uAD70\uAD73\uAD74\uAD75\uAD76\uAD7B\uAD7C\uAD7D\uAD7F\uAD81\uAD82\uAD88\uAD89\uAD8C\uAD90\uAD9C\uAD9D\uADA4\uADB7\uADC0\uADC1\uADC4\uADC8\uADD0\uADD1\uADD3\uADDC\uADE0\uADE4\uADF8\uADF9\uADFC\uADFF\uAE00\uAE01\uAE08\uAE09\uAE0B\uAE0D\uAE14\uAE30\uAE31\uAE34\uAE37\uAE38\uAE3A\uAE40\uAE41\uAE43\uAE45\uAE46\uAE4A\uAE4C\uAE4D\uAE4E\uAE50\uAE54\uAE56\uAE5C\uAE5D\uAE5F\uAE60\uAE61\uAE65\uAE68\uAE69\uAE6C\uAE70\uAE78"],
    ["b241", "\uCF6D\uCF6E\uCF6F\uCF72\uCF73\uCF75\uCF76\uCF77\uCF79", 6, "\uCF81\uCF82\uCF83\uCF84\uCF86", 5, "\uCF8D"],
    ["b261", "\uCF8E", 18, "\uCFA2", 5, "\uCFA9"],
    ["b281", "\uCFAA", 5, "\uCFB1", 18, "\uCFC5", 6, "\uAE79\uAE7B\uAE7C\uAE7D\uAE84\uAE85\uAE8C\uAEBC\uAEBD\uAEBE\uAEC0\uAEC4\uAECC\uAECD\uAECF\uAED0\uAED1\uAED8\uAED9\uAEDC\uAEE8\uAEEB\uAEED\uAEF4\uAEF8\uAEFC\uAF07\uAF08\uAF0D\uAF10\uAF2C\uAF2D\uAF30\uAF32\uAF34\uAF3C\uAF3D\uAF3F\uAF41\uAF42\uAF43\uAF48\uAF49\uAF50\uAF5C\uAF5D\uAF64\uAF65\uAF79\uAF80\uAF84\uAF88\uAF90\uAF91\uAF95\uAF9C\uAFB8\uAFB9\uAFBC\uAFC0\uAFC7\uAFC8\uAFC9\uAFCB\uAFCD\uAFCE\uAFD4\uAFDC\uAFE8\uAFE9\uAFF0\uAFF1\uAFF4\uAFF8\uB000\uB001\uB004\uB00C\uB010\uB014\uB01C\uB01D\uB028\uB044\uB045\uB048\uB04A\uB04C\uB04E\uB053\uB054\uB055\uB057\uB059"],
    ["b341", "\uCFCC", 19, "\uCFE2\uCFE3\uCFE5\uCFE6\uCFE7\uCFE9"],
    ["b361", "\uCFEA", 5, "\uCFF2\uCFF4\uCFF6", 5, "\uCFFD\uCFFE\uCFFF\uD001\uD002\uD003\uD005", 5],
    ["b381", "\uD00B", 5, "\uD012", 5, "\uD019", 19, "\uB05D\uB07C\uB07D\uB080\uB084\uB08C\uB08D\uB08F\uB091\uB098\uB099\uB09A\uB09C\uB09F\uB0A0\uB0A1\uB0A2\uB0A8\uB0A9\uB0AB", 4, "\uB0B1\uB0B3\uB0B4\uB0B5\uB0B8\uB0BC\uB0C4\uB0C5\uB0C7\uB0C8\uB0C9\uB0D0\uB0D1\uB0D4\uB0D8\uB0E0\uB0E5\uB108\uB109\uB10B\uB10C\uB110\uB112\uB113\uB118\uB119\uB11B\uB11C\uB11D\uB123\uB124\uB125\uB128\uB12C\uB134\uB135\uB137\uB138\uB139\uB140\uB141\uB144\uB148\uB150\uB151\uB154\uB155\uB158\uB15C\uB160\uB178\uB179\uB17C\uB180\uB182\uB188\uB189\uB18B\uB18D\uB192\uB193\uB194\uB198\uB19C\uB1A8\uB1CC\uB1D0\uB1D4\uB1DC\uB1DD"],
    ["b441", "\uD02E", 5, "\uD036\uD037\uD039\uD03A\uD03B\uD03D", 6, "\uD046\uD048\uD04A", 5],
    ["b461", "\uD051\uD052\uD053\uD055\uD056\uD057\uD059", 6, "\uD061", 10, "\uD06E\uD06F"],
    ["b481", "\uD071\uD072\uD073\uD075", 6, "\uD07E\uD07F\uD080\uD082", 18, "\uB1DF\uB1E8\uB1E9\uB1EC\uB1F0\uB1F9\uB1FB\uB1FD\uB204\uB205\uB208\uB20B\uB20C\uB214\uB215\uB217\uB219\uB220\uB234\uB23C\uB258\uB25C\uB260\uB268\uB269\uB274\uB275\uB27C\uB284\uB285\uB289\uB290\uB291\uB294\uB298\uB299\uB29A\uB2A0\uB2A1\uB2A3\uB2A5\uB2A6\uB2AA\uB2AC\uB2B0\uB2B4\uB2C8\uB2C9\uB2CC\uB2D0\uB2D2\uB2D8\uB2D9\uB2DB\uB2DD\uB2E2\uB2E4\uB2E5\uB2E6\uB2E8\uB2EB", 4, "\uB2F3\uB2F4\uB2F5\uB2F7", 4, "\uB2FF\uB300\uB301\uB304\uB308\uB310\uB311\uB313\uB314\uB315\uB31C\uB354\uB355\uB356\uB358\uB35B\uB35C\uB35E\uB35F\uB364\uB365"],
    ["b541", "\uD095", 14, "\uD0A6\uD0A7\uD0A9\uD0AA\uD0AB\uD0AD", 5],
    ["b561", "\uD0B3\uD0B6\uD0B8\uD0BA", 5, "\uD0C2\uD0C3\uD0C5\uD0C6\uD0C7\uD0CA", 5, "\uD0D2\uD0D6", 4],
    ["b581", "\uD0DB\uD0DE\uD0DF\uD0E1\uD0E2\uD0E3\uD0E5", 6, "\uD0EE\uD0F2", 5, "\uD0F9", 11, "\uB367\uB369\uB36B\uB36E\uB370\uB371\uB374\uB378\uB380\uB381\uB383\uB384\uB385\uB38C\uB390\uB394\uB3A0\uB3A1\uB3A8\uB3AC\uB3C4\uB3C5\uB3C8\uB3CB\uB3CC\uB3CE\uB3D0\uB3D4\uB3D5\uB3D7\uB3D9\uB3DB\uB3DD\uB3E0\uB3E4\uB3E8\uB3FC\uB410\uB418\uB41C\uB420\uB428\uB429\uB42B\uB434\uB450\uB451\uB454\uB458\uB460\uB461\uB463\uB465\uB46C\uB480\uB488\uB49D\uB4A4\uB4A8\uB4AC\uB4B5\uB4B7\uB4B9\uB4C0\uB4C4\uB4C8\uB4D0\uB4D5\uB4DC\uB4DD\uB4E0\uB4E3\uB4E4\uB4E6\uB4EC\uB4ED\uB4EF\uB4F1\uB4F8\uB514\uB515\uB518\uB51B\uB51C\uB524\uB525\uB527\uB528\uB529\uB52A\uB530\uB531\uB534\uB538"],
    ["b641", "\uD105", 7, "\uD10E", 17],
    ["b661", "\uD120", 15, "\uD132\uD133\uD135\uD136\uD137\uD139\uD13B\uD13C\uD13D\uD13E"],
    ["b681", "\uD13F\uD142\uD146", 5, "\uD14E\uD14F\uD151\uD152\uD153\uD155", 6, "\uD15E\uD160\uD162", 5, "\uD169\uD16A\uD16B\uD16D\uB540\uB541\uB543\uB544\uB545\uB54B\uB54C\uB54D\uB550\uB554\uB55C\uB55D\uB55F\uB560\uB561\uB5A0\uB5A1\uB5A4\uB5A8\uB5AA\uB5AB\uB5B0\uB5B1\uB5B3\uB5B4\uB5B5\uB5BB\uB5BC\uB5BD\uB5C0\uB5C4\uB5CC\uB5CD\uB5CF\uB5D0\uB5D1\uB5D8\uB5EC\uB610\uB611\uB614\uB618\uB625\uB62C\uB634\uB648\uB664\uB668\uB69C\uB69D\uB6A0\uB6A4\uB6AB\uB6AC\uB6B1\uB6D4\uB6F0\uB6F4\uB6F8\uB700\uB701\uB705\uB728\uB729\uB72C\uB72F\uB730\uB738\uB739\uB73B\uB744\uB748\uB74C\uB754\uB755\uB760\uB764\uB768\uB770\uB771\uB773\uB775\uB77C\uB77D\uB780\uB784\uB78C\uB78D\uB78F\uB790\uB791\uB792\uB796\uB797"],
    ["b741", "\uD16E", 13, "\uD17D", 6, "\uD185\uD186\uD187\uD189\uD18A"],
    ["b761", "\uD18B", 20, "\uD1A2\uD1A3\uD1A5\uD1A6\uD1A7"],
    ["b781", "\uD1A9", 6, "\uD1B2\uD1B4\uD1B6\uD1B7\uD1B8\uD1B9\uD1BB\uD1BD\uD1BE\uD1BF\uD1C1", 14, "\uB798\uB799\uB79C\uB7A0\uB7A8\uB7A9\uB7AB\uB7AC\uB7AD\uB7B4\uB7B5\uB7B8\uB7C7\uB7C9\uB7EC\uB7ED\uB7F0\uB7F4\uB7FC\uB7FD\uB7FF\uB800\uB801\uB807\uB808\uB809\uB80C\uB810\uB818\uB819\uB81B\uB81D\uB824\uB825\uB828\uB82C\uB834\uB835\uB837\uB838\uB839\uB840\uB844\uB851\uB853\uB85C\uB85D\uB860\uB864\uB86C\uB86D\uB86F\uB871\uB878\uB87C\uB88D\uB8A8\uB8B0\uB8B4\uB8B8\uB8C0\uB8C1\uB8C3\uB8C5\uB8CC\uB8D0\uB8D4\uB8DD\uB8DF\uB8E1\uB8E8\uB8E9\uB8EC\uB8F0\uB8F8\uB8F9\uB8FB\uB8FD\uB904\uB918\uB920\uB93C\uB93D\uB940\uB944\uB94C\uB94F\uB951\uB958\uB959\uB95C\uB960\uB968\uB969"],
    ["b841", "\uD1D0", 7, "\uD1D9", 17],
    ["b861", "\uD1EB", 8, "\uD1F5\uD1F6\uD1F7\uD1F9", 13],
    ["b881", "\uD208\uD20A", 5, "\uD211", 24, "\uB96B\uB96D\uB974\uB975\uB978\uB97C\uB984\uB985\uB987\uB989\uB98A\uB98D\uB98E\uB9AC\uB9AD\uB9B0\uB9B4\uB9BC\uB9BD\uB9BF\uB9C1\uB9C8\uB9C9\uB9CC\uB9CE", 4, "\uB9D8\uB9D9\uB9DB\uB9DD\uB9DE\uB9E1\uB9E3\uB9E4\uB9E5\uB9E8\uB9EC\uB9F4\uB9F5\uB9F7\uB9F8\uB9F9\uB9FA\uBA00\uBA01\uBA08\uBA15\uBA38\uBA39\uBA3C\uBA40\uBA42\uBA48\uBA49\uBA4B\uBA4D\uBA4E\uBA53\uBA54\uBA55\uBA58\uBA5C\uBA64\uBA65\uBA67\uBA68\uBA69\uBA70\uBA71\uBA74\uBA78\uBA83\uBA84\uBA85\uBA87\uBA8C\uBAA8\uBAA9\uBAAB\uBAAC\uBAB0\uBAB2\uBAB8\uBAB9\uBABB\uBABD\uBAC4\uBAC8\uBAD8\uBAD9\uBAFC"],
    ["b941", "\uD22A\uD22B\uD22E\uD22F\uD231\uD232\uD233\uD235", 6, "\uD23E\uD240\uD242", 5, "\uD249\uD24A\uD24B\uD24C"],
    ["b961", "\uD24D", 14, "\uD25D", 6, "\uD265\uD266\uD267\uD268"],
    ["b981", "\uD269", 22, "\uD282\uD283\uD285\uD286\uD287\uD289\uD28A\uD28B\uD28C\uBB00\uBB04\uBB0D\uBB0F\uBB11\uBB18\uBB1C\uBB20\uBB29\uBB2B\uBB34\uBB35\uBB36\uBB38\uBB3B\uBB3C\uBB3D\uBB3E\uBB44\uBB45\uBB47\uBB49\uBB4D\uBB4F\uBB50\uBB54\uBB58\uBB61\uBB63\uBB6C\uBB88\uBB8C\uBB90\uBBA4\uBBA8\uBBAC\uBBB4\uBBB7\uBBC0\uBBC4\uBBC8\uBBD0\uBBD3\uBBF8\uBBF9\uBBFC\uBBFF\uBC00\uBC02\uBC08\uBC09\uBC0B\uBC0C\uBC0D\uBC0F\uBC11\uBC14", 4, "\uBC1B", 4, "\uBC24\uBC25\uBC27\uBC29\uBC2D\uBC30\uBC31\uBC34\uBC38\uBC40\uBC41\uBC43\uBC44\uBC45\uBC49\uBC4C\uBC4D\uBC50\uBC5D\uBC84\uBC85\uBC88\uBC8B\uBC8C\uBC8E\uBC94\uBC95\uBC97"],
    ["ba41", "\uD28D\uD28E\uD28F\uD292\uD293\uD294\uD296", 5, "\uD29D\uD29E\uD29F\uD2A1\uD2A2\uD2A3\uD2A5", 6, "\uD2AD"],
    ["ba61", "\uD2AE\uD2AF\uD2B0\uD2B2", 5, "\uD2BA\uD2BB\uD2BD\uD2BE\uD2C1\uD2C3", 4, "\uD2CA\uD2CC", 5],
    ["ba81", "\uD2D2\uD2D3\uD2D5\uD2D6\uD2D7\uD2D9\uD2DA\uD2DB\uD2DD", 6, "\uD2E6", 9, "\uD2F2\uD2F3\uD2F5\uD2F6\uD2F7\uD2F9\uD2FA\uBC99\uBC9A\uBCA0\uBCA1\uBCA4\uBCA7\uBCA8\uBCB0\uBCB1\uBCB3\uBCB4\uBCB5\uBCBC\uBCBD\uBCC0\uBCC4\uBCCD\uBCCF\uBCD0\uBCD1\uBCD5\uBCD8\uBCDC\uBCF4\uBCF5\uBCF6\uBCF8\uBCFC\uBD04\uBD05\uBD07\uBD09\uBD10\uBD14\uBD24\uBD2C\uBD40\uBD48\uBD49\uBD4C\uBD50\uBD58\uBD59\uBD64\uBD68\uBD80\uBD81\uBD84\uBD87\uBD88\uBD89\uBD8A\uBD90\uBD91\uBD93\uBD95\uBD99\uBD9A\uBD9C\uBDA4\uBDB0\uBDB8\uBDD4\uBDD5\uBDD8\uBDDC\uBDE9\uBDF0\uBDF4\uBDF8\uBE00\uBE03\uBE05\uBE0C\uBE0D\uBE10\uBE14\uBE1C\uBE1D\uBE1F\uBE44\uBE45\uBE48\uBE4C\uBE4E\uBE54\uBE55\uBE57\uBE59\uBE5A\uBE5B\uBE60\uBE61\uBE64"],
    ["bb41", "\uD2FB", 4, "\uD302\uD304\uD306", 5, "\uD30F\uD311\uD312\uD313\uD315\uD317", 4, "\uD31E\uD322\uD323"],
    ["bb61", "\uD324\uD326\uD327\uD32A\uD32B\uD32D\uD32E\uD32F\uD331", 6, "\uD33A\uD33E", 5, "\uD346\uD347\uD348\uD349"],
    ["bb81", "\uD34A", 31, "\uBE68\uBE6A\uBE70\uBE71\uBE73\uBE74\uBE75\uBE7B\uBE7C\uBE7D\uBE80\uBE84\uBE8C\uBE8D\uBE8F\uBE90\uBE91\uBE98\uBE99\uBEA8\uBED0\uBED1\uBED4\uBED7\uBED8\uBEE0\uBEE3\uBEE4\uBEE5\uBEEC\uBF01\uBF08\uBF09\uBF18\uBF19\uBF1B\uBF1C\uBF1D\uBF40\uBF41\uBF44\uBF48\uBF50\uBF51\uBF55\uBF94\uBFB0\uBFC5\uBFCC\uBFCD\uBFD0\uBFD4\uBFDC\uBFDF\uBFE1\uC03C\uC051\uC058\uC05C\uC060\uC068\uC069\uC090\uC091\uC094\uC098\uC0A0\uC0A1\uC0A3\uC0A5\uC0AC\uC0AD\uC0AF\uC0B0\uC0B3\uC0B4\uC0B5\uC0B6\uC0BC\uC0BD\uC0BF\uC0C0\uC0C1\uC0C5\uC0C8\uC0C9\uC0CC\uC0D0\uC0D8\uC0D9\uC0DB\uC0DC\uC0DD\uC0E4"],
    ["bc41", "\uD36A", 17, "\uD37E\uD37F\uD381\uD382\uD383\uD385\uD386\uD387"],
    ["bc61", "\uD388\uD389\uD38A\uD38B\uD38E\uD392", 5, "\uD39A\uD39B\uD39D\uD39E\uD39F\uD3A1", 6, "\uD3AA\uD3AC\uD3AE"],
    ["bc81", "\uD3AF", 4, "\uD3B5\uD3B6\uD3B7\uD3B9\uD3BA\uD3BB\uD3BD", 6, "\uD3C6\uD3C7\uD3CA", 5, "\uD3D1", 5, "\uC0E5\uC0E8\uC0EC\uC0F4\uC0F5\uC0F7\uC0F9\uC100\uC104\uC108\uC110\uC115\uC11C", 4, "\uC123\uC124\uC126\uC127\uC12C\uC12D\uC12F\uC130\uC131\uC136\uC138\uC139\uC13C\uC140\uC148\uC149\uC14B\uC14C\uC14D\uC154\uC155\uC158\uC15C\uC164\uC165\uC167\uC168\uC169\uC170\uC174\uC178\uC185\uC18C\uC18D\uC18E\uC190\uC194\uC196\uC19C\uC19D\uC19F\uC1A1\uC1A5\uC1A8\uC1A9\uC1AC\uC1B0\uC1BD\uC1C4\uC1C8\uC1CC\uC1D4\uC1D7\uC1D8\uC1E0\uC1E4\uC1E8\uC1F0\uC1F1\uC1F3\uC1FC\uC1FD\uC200\uC204\uC20C\uC20D\uC20F\uC211\uC218\uC219\uC21C\uC21F\uC220\uC228\uC229\uC22B\uC22D"],
    ["bd41", "\uD3D7\uD3D9", 7, "\uD3E2\uD3E4", 7, "\uD3EE\uD3EF\uD3F1\uD3F2\uD3F3\uD3F5\uD3F6\uD3F7"],
    ["bd61", "\uD3F8\uD3F9\uD3FA\uD3FB\uD3FE\uD400\uD402", 5, "\uD409", 13],
    ["bd81", "\uD417", 5, "\uD41E", 25, "\uC22F\uC231\uC232\uC234\uC248\uC250\uC251\uC254\uC258\uC260\uC265\uC26C\uC26D\uC270\uC274\uC27C\uC27D\uC27F\uC281\uC288\uC289\uC290\uC298\uC29B\uC29D\uC2A4\uC2A5\uC2A8\uC2AC\uC2AD\uC2B4\uC2B5\uC2B7\uC2B9\uC2DC\uC2DD\uC2E0\uC2E3\uC2E4\uC2EB\uC2EC\uC2ED\uC2EF\uC2F1\uC2F6\uC2F8\uC2F9\uC2FB\uC2FC\uC300\uC308\uC309\uC30C\uC30D\uC313\uC314\uC315\uC318\uC31C\uC324\uC325\uC328\uC329\uC345\uC368\uC369\uC36C\uC370\uC372\uC378\uC379\uC37C\uC37D\uC384\uC388\uC38C\uC3C0\uC3D8\uC3D9\uC3DC\uC3DF\uC3E0\uC3E2\uC3E8\uC3E9\uC3ED\uC3F4\uC3F5\uC3F8\uC408\uC410\uC424\uC42C\uC430"],
    ["be41", "\uD438", 7, "\uD441\uD442\uD443\uD445", 14],
    ["be61", "\uD454", 7, "\uD45D\uD45E\uD45F\uD461\uD462\uD463\uD465", 7, "\uD46E\uD470\uD471\uD472"],
    ["be81", "\uD473", 4, "\uD47A\uD47B\uD47D\uD47E\uD481\uD483", 4, "\uD48A\uD48C\uD48E", 5, "\uD495", 8, "\uC434\uC43C\uC43D\uC448\uC464\uC465\uC468\uC46C\uC474\uC475\uC479\uC480\uC494\uC49C\uC4B8\uC4BC\uC4E9\uC4F0\uC4F1\uC4F4\uC4F8\uC4FA\uC4FF\uC500\uC501\uC50C\uC510\uC514\uC51C\uC528\uC529\uC52C\uC530\uC538\uC539\uC53B\uC53D\uC544\uC545\uC548\uC549\uC54A\uC54C\uC54D\uC54E\uC553\uC554\uC555\uC557\uC558\uC559\uC55D\uC55E\uC560\uC561\uC564\uC568\uC570\uC571\uC573\uC574\uC575\uC57C\uC57D\uC580\uC584\uC587\uC58C\uC58D\uC58F\uC591\uC595\uC597\uC598\uC59C\uC5A0\uC5A9\uC5B4\uC5B5\uC5B8\uC5B9\uC5BB\uC5BC\uC5BD\uC5BE\uC5C4", 6, "\uC5CC\uC5CE"],
    ["bf41", "\uD49E", 10, "\uD4AA", 14],
    ["bf61", "\uD4B9", 18, "\uD4CD\uD4CE\uD4CF\uD4D1\uD4D2\uD4D3\uD4D5"],
    ["bf81", "\uD4D6", 5, "\uD4DD\uD4DE\uD4E0", 7, "\uD4E9\uD4EA\uD4EB\uD4ED\uD4EE\uD4EF\uD4F1", 6, "\uD4F9\uD4FA\uD4FC\uC5D0\uC5D1\uC5D4\uC5D8\uC5E0\uC5E1\uC5E3\uC5E5\uC5EC\uC5ED\uC5EE\uC5F0\uC5F4\uC5F6\uC5F7\uC5FC", 5, "\uC605\uC606\uC607\uC608\uC60C\uC610\uC618\uC619\uC61B\uC61C\uC624\uC625\uC628\uC62C\uC62D\uC62E\uC630\uC633\uC634\uC635\uC637\uC639\uC63B\uC640\uC641\uC644\uC648\uC650\uC651\uC653\uC654\uC655\uC65C\uC65D\uC660\uC66C\uC66F\uC671\uC678\uC679\uC67C\uC680\uC688\uC689\uC68B\uC68D\uC694\uC695\uC698\uC69C\uC6A4\uC6A5\uC6A7\uC6A9\uC6B0\uC6B1\uC6B4\uC6B8\uC6B9\uC6BA\uC6C0\uC6C1\uC6C3\uC6C5\uC6CC\uC6CD\uC6D0\uC6D4\uC6DC\uC6DD\uC6E0\uC6E1\uC6E8"],
    ["c041", "\uD4FE", 5, "\uD505\uD506\uD507\uD509\uD50A\uD50B\uD50D", 6, "\uD516\uD518", 5],
    ["c061", "\uD51E", 25],
    ["c081", "\uD538\uD539\uD53A\uD53B\uD53E\uD53F\uD541\uD542\uD543\uD545", 6, "\uD54E\uD550\uD552", 5, "\uD55A\uD55B\uD55D\uD55E\uD55F\uD561\uD562\uD563\uC6E9\uC6EC\uC6F0\uC6F8\uC6F9\uC6FD\uC704\uC705\uC708\uC70C\uC714\uC715\uC717\uC719\uC720\uC721\uC724\uC728\uC730\uC731\uC733\uC735\uC737\uC73C\uC73D\uC740\uC744\uC74A\uC74C\uC74D\uC74F\uC751", 7, "\uC75C\uC760\uC768\uC76B\uC774\uC775\uC778\uC77C\uC77D\uC77E\uC783\uC784\uC785\uC787\uC788\uC789\uC78A\uC78E\uC790\uC791\uC794\uC796\uC797\uC798\uC79A\uC7A0\uC7A1\uC7A3\uC7A4\uC7A5\uC7A6\uC7AC\uC7AD\uC7B0\uC7B4\uC7BC\uC7BD\uC7BF\uC7C0\uC7C1\uC7C8\uC7C9\uC7CC\uC7CE\uC7D0\uC7D8\uC7DD\uC7E4\uC7E8\uC7EC\uC800\uC801\uC804\uC808\uC80A"],
    ["c141", "\uD564\uD566\uD567\uD56A\uD56C\uD56E", 5, "\uD576\uD577\uD579\uD57A\uD57B\uD57D", 6, "\uD586\uD58A\uD58B"],
    ["c161", "\uD58C\uD58D\uD58E\uD58F\uD591", 19, "\uD5A6\uD5A7"],
    ["c181", "\uD5A8", 31, "\uC810\uC811\uC813\uC815\uC816\uC81C\uC81D\uC820\uC824\uC82C\uC82D\uC82F\uC831\uC838\uC83C\uC840\uC848\uC849\uC84C\uC84D\uC854\uC870\uC871\uC874\uC878\uC87A\uC880\uC881\uC883\uC885\uC886\uC887\uC88B\uC88C\uC88D\uC894\uC89D\uC89F\uC8A1\uC8A8\uC8BC\uC8BD\uC8C4\uC8C8\uC8CC\uC8D4\uC8D5\uC8D7\uC8D9\uC8E0\uC8E1\uC8E4\uC8F5\uC8FC\uC8FD\uC900\uC904\uC905\uC906\uC90C\uC90D\uC90F\uC911\uC918\uC92C\uC934\uC950\uC951\uC954\uC958\uC960\uC961\uC963\uC96C\uC970\uC974\uC97C\uC988\uC989\uC98C\uC990\uC998\uC999\uC99B\uC99D\uC9C0\uC9C1\uC9C4\uC9C7\uC9C8\uC9CA\uC9D0\uC9D1\uC9D3"],
    ["c241", "\uD5CA\uD5CB\uD5CD\uD5CE\uD5CF\uD5D1\uD5D3", 4, "\uD5DA\uD5DC\uD5DE", 5, "\uD5E6\uD5E7\uD5E9\uD5EA\uD5EB\uD5ED\uD5EE"],
    ["c261", "\uD5EF", 4, "\uD5F6\uD5F8\uD5FA", 5, "\uD602\uD603\uD605\uD606\uD607\uD609", 6, "\uD612"],
    ["c281", "\uD616", 5, "\uD61D\uD61E\uD61F\uD621\uD622\uD623\uD625", 7, "\uD62E", 9, "\uD63A\uD63B\uC9D5\uC9D6\uC9D9\uC9DA\uC9DC\uC9DD\uC9E0\uC9E2\uC9E4\uC9E7\uC9EC\uC9ED\uC9EF\uC9F0\uC9F1\uC9F8\uC9F9\uC9FC\uCA00\uCA08\uCA09\uCA0B\uCA0C\uCA0D\uCA14\uCA18\uCA29\uCA4C\uCA4D\uCA50\uCA54\uCA5C\uCA5D\uCA5F\uCA60\uCA61\uCA68\uCA7D\uCA84\uCA98\uCABC\uCABD\uCAC0\uCAC4\uCACC\uCACD\uCACF\uCAD1\uCAD3\uCAD8\uCAD9\uCAE0\uCAEC\uCAF4\uCB08\uCB10\uCB14\uCB18\uCB20\uCB21\uCB41\uCB48\uCB49\uCB4C\uCB50\uCB58\uCB59\uCB5D\uCB64\uCB78\uCB79\uCB9C\uCBB8\uCBD4\uCBE4\uCBE7\uCBE9\uCC0C\uCC0D\uCC10\uCC14\uCC1C\uCC1D\uCC21\uCC22\uCC27\uCC28\uCC29\uCC2C\uCC2E\uCC30\uCC38\uCC39\uCC3B"],
    ["c341", "\uD63D\uD63E\uD63F\uD641\uD642\uD643\uD644\uD646\uD647\uD64A\uD64C\uD64E\uD64F\uD650\uD652\uD653\uD656\uD657\uD659\uD65A\uD65B\uD65D", 4],
    ["c361", "\uD662", 4, "\uD668\uD66A", 5, "\uD672\uD673\uD675", 11],
    ["c381", "\uD681\uD682\uD684\uD686", 5, "\uD68E\uD68F\uD691\uD692\uD693\uD695", 7, "\uD69E\uD6A0\uD6A2", 5, "\uD6A9\uD6AA\uCC3C\uCC3D\uCC3E\uCC44\uCC45\uCC48\uCC4C\uCC54\uCC55\uCC57\uCC58\uCC59\uCC60\uCC64\uCC66\uCC68\uCC70\uCC75\uCC98\uCC99\uCC9C\uCCA0\uCCA8\uCCA9\uCCAB\uCCAC\uCCAD\uCCB4\uCCB5\uCCB8\uCCBC\uCCC4\uCCC5\uCCC7\uCCC9\uCCD0\uCCD4\uCCE4\uCCEC\uCCF0\uCD01\uCD08\uCD09\uCD0C\uCD10\uCD18\uCD19\uCD1B\uCD1D\uCD24\uCD28\uCD2C\uCD39\uCD5C\uCD60\uCD64\uCD6C\uCD6D\uCD6F\uCD71\uCD78\uCD88\uCD94\uCD95\uCD98\uCD9C\uCDA4\uCDA5\uCDA7\uCDA9\uCDB0\uCDC4\uCDCC\uCDD0\uCDE8\uCDEC\uCDF0\uCDF8\uCDF9\uCDFB\uCDFD\uCE04\uCE08\uCE0C\uCE14\uCE19\uCE20\uCE21\uCE24\uCE28\uCE30\uCE31\uCE33\uCE35"],
    ["c441", "\uD6AB\uD6AD\uD6AE\uD6AF\uD6B1", 7, "\uD6BA\uD6BC", 7, "\uD6C6\uD6C7\uD6C9\uD6CA\uD6CB"],
    ["c461", "\uD6CD\uD6CE\uD6CF\uD6D0\uD6D2\uD6D3\uD6D5\uD6D6\uD6D8\uD6DA", 5, "\uD6E1\uD6E2\uD6E3\uD6E5\uD6E6\uD6E7\uD6E9", 4],
    ["c481", "\uD6EE\uD6EF\uD6F1\uD6F2\uD6F3\uD6F4\uD6F6", 5, "\uD6FE\uD6FF\uD701\uD702\uD703\uD705", 11, "\uD712\uD713\uD714\uCE58\uCE59\uCE5C\uCE5F\uCE60\uCE61\uCE68\uCE69\uCE6B\uCE6D\uCE74\uCE75\uCE78\uCE7C\uCE84\uCE85\uCE87\uCE89\uCE90\uCE91\uCE94\uCE98\uCEA0\uCEA1\uCEA3\uCEA4\uCEA5\uCEAC\uCEAD\uCEC1\uCEE4\uCEE5\uCEE8\uCEEB\uCEEC\uCEF4\uCEF5\uCEF7\uCEF8\uCEF9\uCF00\uCF01\uCF04\uCF08\uCF10\uCF11\uCF13\uCF15\uCF1C\uCF20\uCF24\uCF2C\uCF2D\uCF2F\uCF30\uCF31\uCF38\uCF54\uCF55\uCF58\uCF5C\uCF64\uCF65\uCF67\uCF69\uCF70\uCF71\uCF74\uCF78\uCF80\uCF85\uCF8C\uCFA1\uCFA8\uCFB0\uCFC4\uCFE0\uCFE1\uCFE4\uCFE8\uCFF0\uCFF1\uCFF3\uCFF5\uCFFC\uD000\uD004\uD011\uD018\uD02D\uD034\uD035\uD038\uD03C"],
    ["c541", "\uD715\uD716\uD717\uD71A\uD71B\uD71D\uD71E\uD71F\uD721", 6, "\uD72A\uD72C\uD72E", 5, "\uD736\uD737\uD739"],
    ["c561", "\uD73A\uD73B\uD73D", 6, "\uD745\uD746\uD748\uD74A", 5, "\uD752\uD753\uD755\uD75A", 4],
    ["c581", "\uD75F\uD762\uD764\uD766\uD767\uD768\uD76A\uD76B\uD76D\uD76E\uD76F\uD771\uD772\uD773\uD775", 6, "\uD77E\uD77F\uD780\uD782", 5, "\uD78A\uD78B\uD044\uD045\uD047\uD049\uD050\uD054\uD058\uD060\uD06C\uD06D\uD070\uD074\uD07C\uD07D\uD081\uD0A4\uD0A5\uD0A8\uD0AC\uD0B4\uD0B5\uD0B7\uD0B9\uD0C0\uD0C1\uD0C4\uD0C8\uD0C9\uD0D0\uD0D1\uD0D3\uD0D4\uD0D5\uD0DC\uD0DD\uD0E0\uD0E4\uD0EC\uD0ED\uD0EF\uD0F0\uD0F1\uD0F8\uD10D\uD130\uD131\uD134\uD138\uD13A\uD140\uD141\uD143\uD144\uD145\uD14C\uD14D\uD150\uD154\uD15C\uD15D\uD15F\uD161\uD168\uD16C\uD17C\uD184\uD188\uD1A0\uD1A1\uD1A4\uD1A8\uD1B0\uD1B1\uD1B3\uD1B5\uD1BA\uD1BC\uD1C0\uD1D8\uD1F4\uD1F8\uD207\uD209\uD210\uD22C\uD22D\uD230\uD234\uD23C\uD23D\uD23F\uD241\uD248\uD25C"],
    ["c641", "\uD78D\uD78E\uD78F\uD791", 6, "\uD79A\uD79C\uD79E", 5],
    ["c6a1", "\uD264\uD280\uD281\uD284\uD288\uD290\uD291\uD295\uD29C\uD2A0\uD2A4\uD2AC\uD2B1\uD2B8\uD2B9\uD2BC\uD2BF\uD2C0\uD2C2\uD2C8\uD2C9\uD2CB\uD2D4\uD2D8\uD2DC\uD2E4\uD2E5\uD2F0\uD2F1\uD2F4\uD2F8\uD300\uD301\uD303\uD305\uD30C\uD30D\uD30E\uD310\uD314\uD316\uD31C\uD31D\uD31F\uD320\uD321\uD325\uD328\uD329\uD32C\uD330\uD338\uD339\uD33B\uD33C\uD33D\uD344\uD345\uD37C\uD37D\uD380\uD384\uD38C\uD38D\uD38F\uD390\uD391\uD398\uD399\uD39C\uD3A0\uD3A8\uD3A9\uD3AB\uD3AD\uD3B4\uD3B8\uD3BC\uD3C4\uD3C5\uD3C8\uD3C9\uD3D0\uD3D8\uD3E1\uD3E3\uD3EC\uD3ED\uD3F0\uD3F4\uD3FC\uD3FD\uD3FF\uD401"],
    ["c7a1", "\uD408\uD41D\uD440\uD444\uD45C\uD460\uD464\uD46D\uD46F\uD478\uD479\uD47C\uD47F\uD480\uD482\uD488\uD489\uD48B\uD48D\uD494\uD4A9\uD4CC\uD4D0\uD4D4\uD4DC\uD4DF\uD4E8\uD4EC\uD4F0\uD4F8\uD4FB\uD4FD\uD504\uD508\uD50C\uD514\uD515\uD517\uD53C\uD53D\uD540\uD544\uD54C\uD54D\uD54F\uD551\uD558\uD559\uD55C\uD560\uD565\uD568\uD569\uD56B\uD56D\uD574\uD575\uD578\uD57C\uD584\uD585\uD587\uD588\uD589\uD590\uD5A5\uD5C8\uD5C9\uD5CC\uD5D0\uD5D2\uD5D8\uD5D9\uD5DB\uD5DD\uD5E4\uD5E5\uD5E8\uD5EC\uD5F4\uD5F5\uD5F7\uD5F9\uD600\uD601\uD604\uD608\uD610\uD611\uD613\uD614\uD615\uD61C\uD620"],
    ["c8a1", "\uD624\uD62D\uD638\uD639\uD63C\uD640\uD645\uD648\uD649\uD64B\uD64D\uD651\uD654\uD655\uD658\uD65C\uD667\uD669\uD670\uD671\uD674\uD683\uD685\uD68C\uD68D\uD690\uD694\uD69D\uD69F\uD6A1\uD6A8\uD6AC\uD6B0\uD6B9\uD6BB\uD6C4\uD6C5\uD6C8\uD6CC\uD6D1\uD6D4\uD6D7\uD6D9\uD6E0\uD6E4\uD6E8\uD6F0\uD6F5\uD6FC\uD6FD\uD700\uD704\uD711\uD718\uD719\uD71C\uD720\uD728\uD729\uD72B\uD72D\uD734\uD735\uD738\uD73C\uD744\uD747\uD749\uD750\uD751\uD754\uD756\uD757\uD758\uD759\uD760\uD761\uD763\uD765\uD769\uD76C\uD770\uD774\uD77C\uD77D\uD781\uD788\uD789\uD78C\uD790\uD798\uD799\uD79B\uD79D"],
    ["caa1", "\u4F3D\u4F73\u5047\u50F9\u52A0\u53EF\u5475\u54E5\u5609\u5AC1\u5BB6\u6687\u67B6\u67B7\u67EF\u6B4C\u73C2\u75C2\u7A3C\u82DB\u8304\u8857\u8888\u8A36\u8CC8\u8DCF\u8EFB\u8FE6\u99D5\u523B\u5374\u5404\u606A\u6164\u6BBC\u73CF\u811A\u89BA\u89D2\u95A3\u4F83\u520A\u58BE\u5978\u59E6\u5E72\u5E79\u61C7\u63C0\u6746\u67EC\u687F\u6F97\u764E\u770B\u78F5\u7A08\u7AFF\u7C21\u809D\u826E\u8271\u8AEB\u9593\u4E6B\u559D\u66F7\u6E34\u78A3\u7AED\u845B\u8910\u874E\u97A8\u52D8\u574E\u582A\u5D4C\u611F\u61BE\u6221\u6562\u67D1\u6A44\u6E1B\u7518\u75B3\u76E3\u77B0\u7D3A\u90AF\u9451\u9452\u9F95"],
    ["cba1", "\u5323\u5CAC\u7532\u80DB\u9240\u9598\u525B\u5808\u59DC\u5CA1\u5D17\u5EB7\u5F3A\u5F4A\u6177\u6C5F\u757A\u7586\u7CE0\u7D73\u7DB1\u7F8C\u8154\u8221\u8591\u8941\u8B1B\u92FC\u964D\u9C47\u4ECB\u4EF7\u500B\u51F1\u584F\u6137\u613E\u6168\u6539\u69EA\u6F11\u75A5\u7686\u76D6\u7B87\u82A5\u84CB\uF900\u93A7\u958B\u5580\u5BA2\u5751\uF901\u7CB3\u7FB9\u91B5\u5028\u53BB\u5C45\u5DE8\u62D2\u636E\u64DA\u64E7\u6E20\u70AC\u795B\u8DDD\u8E1E\uF902\u907D\u9245\u92F8\u4E7E\u4EF6\u5065\u5DFE\u5EFA\u6106\u6957\u8171\u8654\u8E47\u9375\u9A2B\u4E5E\u5091\u6770\u6840\u5109\u528D\u5292\u6AA2"],
    ["cca1", "\u77BC\u9210\u9ED4\u52AB\u602F\u8FF2\u5048\u61A9\u63ED\u64CA\u683C\u6A84\u6FC0\u8188\u89A1\u9694\u5805\u727D\u72AC\u7504\u7D79\u7E6D\u80A9\u898B\u8B74\u9063\u9D51\u6289\u6C7A\u6F54\u7D50\u7F3A\u8A23\u517C\u614A\u7B9D\u8B19\u9257\u938C\u4EAC\u4FD3\u501E\u50BE\u5106\u52C1\u52CD\u537F\u5770\u5883\u5E9A\u5F91\u6176\u61AC\u64CE\u656C\u666F\u66BB\u66F4\u6897\u6D87\u7085\u70F1\u749F\u74A5\u74CA\u75D9\u786C\u78EC\u7ADF\u7AF6\u7D45\u7D93\u8015\u803F\u811B\u8396\u8B66\u8F15\u9015\u93E1\u9803\u9838\u9A5A\u9BE8\u4FC2\u5553\u583A\u5951\u5B63\u5C46\u60B8\u6212\u6842\u68B0"],
    ["cda1", "\u68E8\u6EAA\u754C\u7678\u78CE\u7A3D\u7CFB\u7E6B\u7E7C\u8A08\u8AA1\u8C3F\u968E\u9DC4\u53E4\u53E9\u544A\u5471\u56FA\u59D1\u5B64\u5C3B\u5EAB\u62F7\u6537\u6545\u6572\u66A0\u67AF\u69C1\u6CBD\u75FC\u7690\u777E\u7A3F\u7F94\u8003\u80A1\u818F\u82E6\u82FD\u83F0\u85C1\u8831\u88B4\u8AA5\uF903\u8F9C\u932E\u96C7\u9867\u9AD8\u9F13\u54ED\u659B\u66F2\u688F\u7A40\u8C37\u9D60\u56F0\u5764\u5D11\u6606\u68B1\u68CD\u6EFE\u7428\u889E\u9BE4\u6C68\uF904\u9AA8\u4F9B\u516C\u5171\u529F\u5B54\u5DE5\u6050\u606D\u62F1\u63A7\u653B\u73D9\u7A7A\u86A3\u8CA2\u978F\u4E32\u5BE1\u6208\u679C\u74DC"],
    ["cea1", "\u79D1\u83D3\u8A87\u8AB2\u8DE8\u904E\u934B\u9846\u5ED3\u69E8\u85FF\u90ED\uF905\u51A0\u5B98\u5BEC\u6163\u68FA\u6B3E\u704C\u742F\u74D8\u7BA1\u7F50\u83C5\u89C0\u8CAB\u95DC\u9928\u522E\u605D\u62EC\u9002\u4F8A\u5149\u5321\u58D9\u5EE3\u66E0\u6D38\u709A\u72C2\u73D6\u7B50\u80F1\u945B\u5366\u639B\u7F6B\u4E56\u5080\u584A\u58DE\u602A\u6127\u62D0\u69D0\u9B41\u5B8F\u7D18\u80B1\u8F5F\u4EA4\u50D1\u54AC\u55AC\u5B0C\u5DA0\u5DE7\u652A\u654E\u6821\u6A4B\u72E1\u768E\u77EF\u7D5E\u7FF9\u81A0\u854E\u86DF\u8F03\u8F4E\u90CA\u9903\u9A55\u9BAB\u4E18\u4E45\u4E5D\u4EC7\u4FF1\u5177\u52FE"],
    ["cfa1", "\u5340\u53E3\u53E5\u548E\u5614\u5775\u57A2\u5BC7\u5D87\u5ED0\u61FC\u62D8\u6551\u67B8\u67E9\u69CB\u6B50\u6BC6\u6BEC\u6C42\u6E9D\u7078\u72D7\u7396\u7403\u77BF\u77E9\u7A76\u7D7F\u8009\u81FC\u8205\u820A\u82DF\u8862\u8B33\u8CFC\u8EC0\u9011\u90B1\u9264\u92B6\u99D2\u9A45\u9CE9\u9DD7\u9F9C\u570B\u5C40\u83CA\u97A0\u97AB\u9EB4\u541B\u7A98\u7FA4\u88D9\u8ECD\u90E1\u5800\u5C48\u6398\u7A9F\u5BAE\u5F13\u7A79\u7AAE\u828E\u8EAC\u5026\u5238\u52F8\u5377\u5708\u62F3\u6372\u6B0A\u6DC3\u7737\u53A5\u7357\u8568\u8E76\u95D5\u673A\u6AC3\u6F70\u8A6D\u8ECC\u994B\uF906\u6677\u6B78\u8CB4"],
    ["d0a1", "\u9B3C\uF907\u53EB\u572D\u594E\u63C6\u69FB\u73EA\u7845\u7ABA\u7AC5\u7CFE\u8475\u898F\u8D73\u9035\u95A8\u52FB\u5747\u7547\u7B60\u83CC\u921E\uF908\u6A58\u514B\u524B\u5287\u621F\u68D8\u6975\u9699\u50C5\u52A4\u52E4\u61C3\u65A4\u6839\u69FF\u747E\u7B4B\u82B9\u83EB\u89B2\u8B39\u8FD1\u9949\uF909\u4ECA\u5997\u64D2\u6611\u6A8E\u7434\u7981\u79BD\u82A9\u887E\u887F\u895F\uF90A\u9326\u4F0B\u53CA\u6025\u6271\u6C72\u7D1A\u7D66\u4E98\u5162\u77DC\u80AF\u4F01\u4F0E\u5176\u5180\u55DC\u5668\u573B\u57FA\u57FC\u5914\u5947\u5993\u5BC4\u5C90\u5D0E\u5DF1\u5E7E\u5FCC\u6280\u65D7\u65E3"],
    ["d1a1", "\u671E\u671F\u675E\u68CB\u68C4\u6A5F\u6B3A\u6C23\u6C7D\u6C82\u6DC7\u7398\u7426\u742A\u7482\u74A3\u7578\u757F\u7881\u78EF\u7941\u7947\u7948\u797A\u7B95\u7D00\u7DBA\u7F88\u8006\u802D\u808C\u8A18\u8B4F\u8C48\u8D77\u9321\u9324\u98E2\u9951\u9A0E\u9A0F\u9A65\u9E92\u7DCA\u4F76\u5409\u62EE\u6854\u91D1\u55AB\u513A\uF90B\uF90C\u5A1C\u61E6\uF90D\u62CF\u62FF\uF90E", 5, "\u90A3\uF914", 4, "\u8AFE\uF919\uF91A\uF91B\uF91C\u6696\uF91D\u7156\uF91E\uF91F\u96E3\uF920\u634F\u637A\u5357\uF921\u678F\u6960\u6E73\uF922\u7537\uF923\uF924\uF925"],
    ["d2a1", "\u7D0D\uF926\uF927\u8872\u56CA\u5A18\uF928", 4, "\u4E43\uF92D\u5167\u5948\u67F0\u8010\uF92E\u5973\u5E74\u649A\u79CA\u5FF5\u606C\u62C8\u637B\u5BE7\u5BD7\u52AA\uF92F\u5974\u5F29\u6012\uF930\uF931\uF932\u7459\uF933", 5, "\u99D1\uF939", 10, "\u6FC3\uF944\uF945\u81BF\u8FB2\u60F1\uF946\uF947\u8166\uF948\uF949\u5C3F\uF94A", 7, "\u5AE9\u8A25\u677B\u7D10\uF952", 5, "\u80FD\uF958\uF959\u5C3C\u6CE5\u533F\u6EBA\u591A\u8336"],
    ["d3a1", "\u4E39\u4EB6\u4F46\u55AE\u5718\u58C7\u5F56\u65B7\u65E6\u6A80\u6BB5\u6E4D\u77ED\u7AEF\u7C1E\u7DDE\u86CB\u8892\u9132\u935B\u64BB\u6FBE\u737A\u75B8\u9054\u5556\u574D\u61BA\u64D4\u66C7\u6DE1\u6E5B\u6F6D\u6FB9\u75F0\u8043\u81BD\u8541\u8983\u8AC7\u8B5A\u931F\u6C93\u7553\u7B54\u8E0F\u905D\u5510\u5802\u5858\u5E62\u6207\u649E\u68E0\u7576\u7CD6\u87B3\u9EE8\u4EE3\u5788\u576E\u5927\u5C0D\u5CB1\u5E36\u5F85\u6234\u64E1\u73B3\u81FA\u888B\u8CB8\u968A\u9EDB\u5B85\u5FB7\u60B3\u5012\u5200\u5230\u5716\u5835\u5857\u5C0E\u5C60\u5CF6\u5D8B\u5EA6\u5F92\u60BC\u6311\u6389\u6417\u6843"],
    ["d4a1", "\u68F9\u6AC2\u6DD8\u6E21\u6ED4\u6FE4\u71FE\u76DC\u7779\u79B1\u7A3B\u8404\u89A9\u8CED\u8DF3\u8E48\u9003\u9014\u9053\u90FD\u934D\u9676\u97DC\u6BD2\u7006\u7258\u72A2\u7368\u7763\u79BF\u7BE4\u7E9B\u8B80\u58A9\u60C7\u6566\u65FD\u66BE\u6C8C\u711E\u71C9\u8C5A\u9813\u4E6D\u7A81\u4EDD\u51AC\u51CD\u52D5\u540C\u61A7\u6771\u6850\u68DF\u6D1E\u6F7C\u75BC\u77B3\u7AE5\u80F4\u8463\u9285\u515C\u6597\u675C\u6793\u75D8\u7AC7\u8373\uF95A\u8C46\u9017\u982D\u5C6F\u81C0\u829A\u9041\u906F\u920D\u5F97\u5D9D\u6A59\u71C8\u767B\u7B49\u85E4\u8B04\u9127\u9A30\u5587\u61F6\uF95B\u7669\u7F85"],
    ["d5a1", "\u863F\u87BA\u88F8\u908F\uF95C\u6D1B\u70D9\u73DE\u7D61\u843D\uF95D\u916A\u99F1\uF95E\u4E82\u5375\u6B04\u6B12\u703E\u721B\u862D\u9E1E\u524C\u8FA3\u5D50\u64E5\u652C\u6B16\u6FEB\u7C43\u7E9C\u85CD\u8964\u89BD\u62C9\u81D8\u881F\u5ECA\u6717\u6D6A\u72FC\u7405\u746F\u8782\u90DE\u4F86\u5D0D\u5FA0\u840A\u51B7\u63A0\u7565\u4EAE\u5006\u5169\u51C9\u6881\u6A11\u7CAE\u7CB1\u7CE7\u826F\u8AD2\u8F1B\u91CF\u4FB6\u5137\u52F5\u5442\u5EEC\u616E\u623E\u65C5\u6ADA\u6FFE\u792A\u85DC\u8823\u95AD\u9A62\u9A6A\u9E97\u9ECE\u529B\u66C6\u6B77\u701D\u792B\u8F62\u9742\u6190\u6200\u6523\u6F23"],
    ["d6a1", "\u7149\u7489\u7DF4\u806F\u84EE\u8F26\u9023\u934A\u51BD\u5217\u52A3\u6D0C\u70C8\u88C2\u5EC9\u6582\u6BAE\u6FC2\u7C3E\u7375\u4EE4\u4F36\u56F9\uF95F\u5CBA\u5DBA\u601C\u73B2\u7B2D\u7F9A\u7FCE\u8046\u901E\u9234\u96F6\u9748\u9818\u9F61\u4F8B\u6FA7\u79AE\u91B4\u96B7\u52DE\uF960\u6488\u64C4\u6AD3\u6F5E\u7018\u7210\u76E7\u8001\u8606\u865C\u8DEF\u8F05\u9732\u9B6F\u9DFA\u9E75\u788C\u797F\u7DA0\u83C9\u9304\u9E7F\u9E93\u8AD6\u58DF\u5F04\u6727\u7027\u74CF\u7C60\u807E\u5121\u7028\u7262\u78CA\u8CC2\u8CDA\u8CF4\u96F7\u4E86\u50DA\u5BEE\u5ED6\u6599\u71CE\u7642\u77AD\u804A\u84FC"],
    ["d7a1", "\u907C\u9B27\u9F8D\u58D8\u5A41\u5C62\u6A13\u6DDA\u6F0F\u763B\u7D2F\u7E37\u851E\u8938\u93E4\u964B\u5289\u65D2\u67F3\u69B4\u6D41\u6E9C\u700F\u7409\u7460\u7559\u7624\u786B\u8B2C\u985E\u516D\u622E\u9678\u4F96\u502B\u5D19\u6DEA\u7DB8\u8F2A\u5F8B\u6144\u6817\uF961\u9686\u52D2\u808B\u51DC\u51CC\u695E\u7A1C\u7DBE\u83F1\u9675\u4FDA\u5229\u5398\u540F\u550E\u5C65\u60A7\u674E\u68A8\u6D6C\u7281\u72F8\u7406\u7483\uF962\u75E2\u7C6C\u7F79\u7FB8\u8389\u88CF\u88E1\u91CC\u91D0\u96E2\u9BC9\u541D\u6F7E\u71D0\u7498\u85FA\u8EAA\u96A3\u9C57\u9E9F\u6797\u6DCB\u7433\u81E8\u9716\u782C"],
    ["d8a1", "\u7ACB\u7B20\u7C92\u6469\u746A\u75F2\u78BC\u78E8\u99AC\u9B54\u9EBB\u5BDE\u5E55\u6F20\u819C\u83AB\u9088\u4E07\u534D\u5A29\u5DD2\u5F4E\u6162\u633D\u6669\u66FC\u6EFF\u6F2B\u7063\u779E\u842C\u8513\u883B\u8F13\u9945\u9C3B\u551C\u62B9\u672B\u6CAB\u8309\u896A\u977A\u4EA1\u5984\u5FD8\u5FD9\u671B\u7DB2\u7F54\u8292\u832B\u83BD\u8F1E\u9099\u57CB\u59B9\u5A92\u5BD0\u6627\u679A\u6885\u6BCF\u7164\u7F75\u8CB7\u8CE3\u9081\u9B45\u8108\u8C8A\u964C\u9A40\u9EA5\u5B5F\u6C13\u731B\u76F2\u76DF\u840C\u51AA\u8993\u514D\u5195\u52C9\u68C9\u6C94\u7704\u7720\u7DBF\u7DEC\u9762\u9EB5\u6EC5"],
    ["d9a1", "\u8511\u51A5\u540D\u547D\u660E\u669D\u6927\u6E9F\u76BF\u7791\u8317\u84C2\u879F\u9169\u9298\u9CF4\u8882\u4FAE\u5192\u52DF\u59C6\u5E3D\u6155\u6478\u6479\u66AE\u67D0\u6A21\u6BCD\u6BDB\u725F\u7261\u7441\u7738\u77DB\u8017\u82BC\u8305\u8B00\u8B28\u8C8C\u6728\u6C90\u7267\u76EE\u7766\u7A46\u9DA9\u6B7F\u6C92\u5922\u6726\u8499\u536F\u5893\u5999\u5EDF\u63CF\u6634\u6773\u6E3A\u732B\u7AD7\u82D7\u9328\u52D9\u5DEB\u61AE\u61CB\u620A\u62C7\u64AB\u65E0\u6959\u6B66\u6BCB\u7121\u73F7\u755D\u7E46\u821E\u8302\u856A\u8AA3\u8CBF\u9727\u9D61\u58A8\u9ED8\u5011\u520E\u543B\u554F\u6587"],
    ["daa1", "\u6C76\u7D0A\u7D0B\u805E\u868A\u9580\u96EF\u52FF\u6C95\u7269\u5473\u5A9A\u5C3E\u5D4B\u5F4C\u5FAE\u672A\u68B6\u6963\u6E3C\u6E44\u7709\u7C73\u7F8E\u8587\u8B0E\u8FF7\u9761\u9EF4\u5CB7\u60B6\u610D\u61AB\u654F\u65FB\u65FC\u6C11\u6CEF\u739F\u73C9\u7DE1\u9594\u5BC6\u871C\u8B10\u525D\u535A\u62CD\u640F\u64B2\u6734\u6A38\u6CCA\u73C0\u749E\u7B94\u7C95\u7E1B\u818A\u8236\u8584\u8FEB\u96F9\u99C1\u4F34\u534A\u53CD\u53DB\u62CC\u642C\u6500\u6591\u69C3\u6CEE\u6F58\u73ED\u7554\u7622\u76E4\u76FC\u78D0\u78FB\u792C\u7D46\u822C\u87E0\u8FD4\u9812\u98EF\u52C3\u62D4\u64A5\u6E24\u6F51"],
    ["dba1", "\u767C\u8DCB\u91B1\u9262\u9AEE\u9B43\u5023\u508D\u574A\u59A8\u5C28\u5E47\u5F77\u623F\u653E\u65B9\u65C1\u6609\u678B\u699C\u6EC2\u78C5\u7D21\u80AA\u8180\u822B\u82B3\u84A1\u868C\u8A2A\u8B17\u90A6\u9632\u9F90\u500D\u4FF3\uF963\u57F9\u5F98\u62DC\u6392\u676F\u6E43\u7119\u76C3\u80CC\u80DA\u88F4\u88F5\u8919\u8CE0\u8F29\u914D\u966A\u4F2F\u4F70\u5E1B\u67CF\u6822\u767D\u767E\u9B44\u5E61\u6A0A\u7169\u71D4\u756A\uF964\u7E41\u8543\u85E9\u98DC\u4F10\u7B4F\u7F70\u95A5\u51E1\u5E06\u68B5\u6C3E\u6C4E\u6CDB\u72AF\u7BC4\u8303\u6CD5\u743A\u50FB\u5288\u58C1\u64D8\u6A97\u74A7\u7656"],
    ["dca1", "\u78A7\u8617\u95E2\u9739\uF965\u535E\u5F01\u8B8A\u8FA8\u8FAF\u908A\u5225\u77A5\u9C49\u9F08\u4E19\u5002\u5175\u5C5B\u5E77\u661E\u663A\u67C4\u68C5\u70B3\u7501\u75C5\u79C9\u7ADD\u8F27\u9920\u9A08\u4FDD\u5821\u5831\u5BF6\u666E\u6B65\u6D11\u6E7A\u6F7D\u73E4\u752B\u83E9\u88DC\u8913\u8B5C\u8F14\u4F0F\u50D5\u5310\u535C\u5B93\u5FA9\u670D\u798F\u8179\u832F\u8514\u8907\u8986\u8F39\u8F3B\u99A5\u9C12\u672C\u4E76\u4FF8\u5949\u5C01\u5CEF\u5CF0\u6367\u68D2\u70FD\u71A2\u742B\u7E2B\u84EC\u8702\u9022\u92D2\u9CF3\u4E0D\u4ED8\u4FEF\u5085\u5256\u526F\u5426\u5490\u57E0\u592B\u5A66"],
    ["dda1", "\u5B5A\u5B75\u5BCC\u5E9C\uF966\u6276\u6577\u65A7\u6D6E\u6EA5\u7236\u7B26\u7C3F\u7F36\u8150\u8151\u819A\u8240\u8299\u83A9\u8A03\u8CA0\u8CE6\u8CFB\u8D74\u8DBA\u90E8\u91DC\u961C\u9644\u99D9\u9CE7\u5317\u5206\u5429\u5674\u58B3\u5954\u596E\u5FFF\u61A4\u626E\u6610\u6C7E\u711A\u76C6\u7C89\u7CDE\u7D1B\u82AC\u8CC1\u96F0\uF967\u4F5B\u5F17\u5F7F\u62C2\u5D29\u670B\u68DA\u787C\u7E43\u9D6C\u4E15\u5099\u5315\u532A\u5351\u5983\u5A62\u5E87\u60B2\u618A\u6249\u6279\u6590\u6787\u69A7\u6BD4\u6BD6\u6BD7\u6BD8\u6CB8\uF968\u7435\u75FA\u7812\u7891\u79D5\u79D8\u7C83\u7DCB\u7FE1\u80A5"],
    ["dea1", "\u813E\u81C2\u83F2\u871A\u88E8\u8AB9\u8B6C\u8CBB\u9119\u975E\u98DB\u9F3B\u56AC\u5B2A\u5F6C\u658C\u6AB3\u6BAF\u6D5C\u6FF1\u7015\u725D\u73AD\u8CA7\u8CD3\u983B\u6191\u6C37\u8058\u9A01\u4E4D\u4E8B\u4E9B\u4ED5\u4F3A\u4F3C\u4F7F\u4FDF\u50FF\u53F2\u53F8\u5506\u55E3\u56DB\u58EB\u5962\u5A11\u5BEB\u5BFA\u5C04\u5DF3\u5E2B\u5F99\u601D\u6368\u659C\u65AF\u67F6\u67FB\u68AD\u6B7B\u6C99\u6CD7\u6E23\u7009\u7345\u7802\u793E\u7940\u7960\u79C1\u7BE9\u7D17\u7D72\u8086\u820D\u838E\u84D1\u86C7\u88DF\u8A50\u8A5E\u8B1D\u8CDC\u8D66\u8FAD\u90AA\u98FC\u99DF\u9E9D\u524A\uF969\u6714\uF96A"],
    ["dfa1", "\u5098\u522A\u5C71\u6563\u6C55\u73CA\u7523\u759D\u7B97\u849C\u9178\u9730\u4E77\u6492\u6BBA\u715E\u85A9\u4E09\uF96B\u6749\u68EE\u6E17\u829F\u8518\u886B\u63F7\u6F81\u9212\u98AF\u4E0A\u50B7\u50CF\u511F\u5546\u55AA\u5617\u5B40\u5C19\u5CE0\u5E38\u5E8A\u5EA0\u5EC2\u60F3\u6851\u6A61\u6E58\u723D\u7240\u72C0\u76F8\u7965\u7BB1\u7FD4\u88F3\u89F4\u8A73\u8C61\u8CDE\u971C\u585E\u74BD\u8CFD\u55C7\uF96C\u7A61\u7D22\u8272\u7272\u751F\u7525\uF96D\u7B19\u5885\u58FB\u5DBC\u5E8F\u5EB6\u5F90\u6055\u6292\u637F\u654D\u6691\u66D9\u66F8\u6816\u68F2\u7280\u745E\u7B6E\u7D6E\u7DD6\u7F72"],
    ["e0a1", "\u80E5\u8212\u85AF\u897F\u8A93\u901D\u92E4\u9ECD\u9F20\u5915\u596D\u5E2D\u60DC\u6614\u6673\u6790\u6C50\u6DC5\u6F5F\u77F3\u78A9\u84C6\u91CB\u932B\u4ED9\u50CA\u5148\u5584\u5B0B\u5BA3\u6247\u657E\u65CB\u6E32\u717D\u7401\u7444\u7487\u74BF\u766C\u79AA\u7DDA\u7E55\u7FA8\u817A\u81B3\u8239\u861A\u87EC\u8A75\u8DE3\u9078\u9291\u9425\u994D\u9BAE\u5368\u5C51\u6954\u6CC4\u6D29\u6E2B\u820C\u859B\u893B\u8A2D\u8AAA\u96EA\u9F67\u5261\u66B9\u6BB2\u7E96\u87FE\u8D0D\u9583\u965D\u651D\u6D89\u71EE\uF96E\u57CE\u59D3\u5BAC\u6027\u60FA\u6210\u661F\u665F\u7329\u73F9\u76DB\u7701\u7B6C"],
    ["e1a1", "\u8056\u8072\u8165\u8AA0\u9192\u4E16\u52E2\u6B72\u6D17\u7A05\u7B39\u7D30\uF96F\u8CB0\u53EC\u562F\u5851\u5BB5\u5C0F\u5C11\u5DE2\u6240\u6383\u6414\u662D\u68B3\u6CBC\u6D88\u6EAF\u701F\u70A4\u71D2\u7526\u758F\u758E\u7619\u7B11\u7BE0\u7C2B\u7D20\u7D39\u852C\u856D\u8607\u8A34\u900D\u9061\u90B5\u92B7\u97F6\u9A37\u4FD7\u5C6C\u675F\u6D91\u7C9F\u7E8C\u8B16\u8D16\u901F\u5B6B\u5DFD\u640D\u84C0\u905C\u98E1\u7387\u5B8B\u609A\u677E\u6DDE\u8A1F\u8AA6\u9001\u980C\u5237\uF970\u7051\u788E\u9396\u8870\u91D7\u4FEE\u53D7\u55FD\u56DA\u5782\u58FD\u5AC2\u5B88\u5CAB\u5CC0\u5E25\u6101"],
    ["e2a1", "\u620D\u624B\u6388\u641C\u6536\u6578\u6A39\u6B8A\u6C34\u6D19\u6F31\u71E7\u72E9\u7378\u7407\u74B2\u7626\u7761\u79C0\u7A57\u7AEA\u7CB9\u7D8F\u7DAC\u7E61\u7F9E\u8129\u8331\u8490\u84DA\u85EA\u8896\u8AB0\u8B90\u8F38\u9042\u9083\u916C\u9296\u92B9\u968B\u96A7\u96A8\u96D6\u9700\u9808\u9996\u9AD3\u9B1A\u53D4\u587E\u5919\u5B70\u5BBF\u6DD1\u6F5A\u719F\u7421\u74B9\u8085\u83FD\u5DE1\u5F87\u5FAA\u6042\u65EC\u6812\u696F\u6A53\u6B89\u6D35\u6DF3\u73E3\u76FE\u77AC\u7B4D\u7D14\u8123\u821C\u8340\u84F4\u8563\u8A62\u8AC4\u9187\u931E\u9806\u99B4\u620C\u8853\u8FF0\u9265\u5D07\u5D27"],
    ["e3a1", "\u5D69\u745F\u819D\u8768\u6FD5\u62FE\u7FD2\u8936\u8972\u4E1E\u4E58\u50E7\u52DD\u5347\u627F\u6607\u7E69\u8805\u965E\u4F8D\u5319\u5636\u59CB\u5AA4\u5C38\u5C4E\u5C4D\u5E02\u5F11\u6043\u65BD\u662F\u6642\u67BE\u67F4\u731C\u77E2\u793A\u7FC5\u8494\u84CD\u8996\u8A66\u8A69\u8AE1\u8C55\u8C7A\u57F4\u5BD4\u5F0F\u606F\u62ED\u690D\u6B96\u6E5C\u7184\u7BD2\u8755\u8B58\u8EFE\u98DF\u98FE\u4F38\u4F81\u4FE1\u547B\u5A20\u5BB8\u613C\u65B0\u6668\u71FC\u7533\u795E\u7D33\u814E\u81E3\u8398\u85AA\u85CE\u8703\u8A0A\u8EAB\u8F9B\uF971\u8FC5\u5931\u5BA4\u5BE6\u6089\u5BE9\u5C0B\u5FC3\u6C81"],
    ["e4a1", "\uF972\u6DF1\u700B\u751A\u82AF\u8AF6\u4EC0\u5341\uF973\u96D9\u6C0F\u4E9E\u4FC4\u5152\u555E\u5A25\u5CE8\u6211\u7259\u82BD\u83AA\u86FE\u8859\u8A1D\u963F\u96C5\u9913\u9D09\u9D5D\u580A\u5CB3\u5DBD\u5E44\u60E1\u6115\u63E1\u6A02\u6E25\u9102\u9354\u984E\u9C10\u9F77\u5B89\u5CB8\u6309\u664F\u6848\u773C\u96C1\u978D\u9854\u9B9F\u65A1\u8B01\u8ECB\u95BC\u5535\u5CA9\u5DD6\u5EB5\u6697\u764C\u83F4\u95C7\u58D3\u62BC\u72CE\u9D28\u4EF0\u592E\u600F\u663B\u6B83\u79E7\u9D26\u5393\u54C0\u57C3\u5D16\u611B\u66D6\u6DAF\u788D\u827E\u9698\u9744\u5384\u627C\u6396\u6DB2\u7E0A\u814B\u984D"],
    ["e5a1", "\u6AFB\u7F4C\u9DAF\u9E1A\u4E5F\u503B\u51B6\u591C\u60F9\u63F6\u6930\u723A\u8036\uF974\u91CE\u5F31\uF975\uF976\u7D04\u82E5\u846F\u84BB\u85E5\u8E8D\uF977\u4F6F\uF978\uF979\u58E4\u5B43\u6059\u63DA\u6518\u656D\u6698\uF97A\u694A\u6A23\u6D0B\u7001\u716C\u75D2\u760D\u79B3\u7A70\uF97B\u7F8A\uF97C\u8944\uF97D\u8B93\u91C0\u967D\uF97E\u990A\u5704\u5FA1\u65BC\u6F01\u7600\u79A6\u8A9E\u99AD\u9B5A\u9F6C\u5104\u61B6\u6291\u6A8D\u81C6\u5043\u5830\u5F66\u7109\u8A00\u8AFA\u5B7C\u8616\u4FFA\u513C\u56B4\u5944\u63A9\u6DF9\u5DAA\u696D\u5186\u4E88\u4F59\uF97F\uF980\uF981\u5982\uF982"],
    ["e6a1", "\uF983\u6B5F\u6C5D\uF984\u74B5\u7916\uF985\u8207\u8245\u8339\u8F3F\u8F5D\uF986\u9918\uF987\uF988\uF989\u4EA6\uF98A\u57DF\u5F79\u6613\uF98B\uF98C\u75AB\u7E79\u8B6F\uF98D\u9006\u9A5B\u56A5\u5827\u59F8\u5A1F\u5BB4\uF98E\u5EF6\uF98F\uF990\u6350\u633B\uF991\u693D\u6C87\u6CBF\u6D8E\u6D93\u6DF5\u6F14\uF992\u70DF\u7136\u7159\uF993\u71C3\u71D5\uF994\u784F\u786F\uF995\u7B75\u7DE3\uF996\u7E2F\uF997\u884D\u8EDF\uF998\uF999\uF99A\u925B\uF99B\u9CF6\uF99C\uF99D\uF99E\u6085\u6D85\uF99F\u71B1\uF9A0\uF9A1\u95B1\u53AD\uF9A2\uF9A3\uF9A4\u67D3\uF9A5\u708E\u7130\u7430\u8276\u82D2"],
    ["e7a1", "\uF9A6\u95BB\u9AE5\u9E7D\u66C4\uF9A7\u71C1\u8449\uF9A8\uF9A9\u584B\uF9AA\uF9AB\u5DB8\u5F71\uF9AC\u6620\u668E\u6979\u69AE\u6C38\u6CF3\u6E36\u6F41\u6FDA\u701B\u702F\u7150\u71DF\u7370\uF9AD\u745B\uF9AE\u74D4\u76C8\u7A4E\u7E93\uF9AF\uF9B0\u82F1\u8A60\u8FCE\uF9B1\u9348\uF9B2\u9719\uF9B3\uF9B4\u4E42\u502A\uF9B5\u5208\u53E1\u66F3\u6C6D\u6FCA\u730A\u777F\u7A62\u82AE\u85DD\u8602\uF9B6\u88D4\u8A63\u8B7D\u8C6B\uF9B7\u92B3\uF9B8\u9713\u9810\u4E94\u4F0D\u4FC9\u50B2\u5348\u543E\u5433\u55DA\u5862\u58BA\u5967\u5A1B\u5BE4\u609F\uF9B9\u61CA\u6556\u65FF\u6664\u68A7\u6C5A\u6FB3"],
    ["e8a1", "\u70CF\u71AC\u7352\u7B7D\u8708\u8AA4\u9C32\u9F07\u5C4B\u6C83\u7344\u7389\u923A\u6EAB\u7465\u761F\u7A69\u7E15\u860A\u5140\u58C5\u64C1\u74EE\u7515\u7670\u7FC1\u9095\u96CD\u9954\u6E26\u74E6\u7AA9\u7AAA\u81E5\u86D9\u8778\u8A1B\u5A49\u5B8C\u5B9B\u68A1\u6900\u6D63\u73A9\u7413\u742C\u7897\u7DE9\u7FEB\u8118\u8155\u839E\u8C4C\u962E\u9811\u66F0\u5F80\u65FA\u6789\u6C6A\u738B\u502D\u5A03\u6B6A\u77EE\u5916\u5D6C\u5DCD\u7325\u754F\uF9BA\uF9BB\u50E5\u51F9\u582F\u592D\u5996\u59DA\u5BE5\uF9BC\uF9BD\u5DA2\u62D7\u6416\u6493\u64FE\uF9BE\u66DC\uF9BF\u6A48\uF9C0\u71FF\u7464\uF9C1"],
    ["e9a1", "\u7A88\u7AAF\u7E47\u7E5E\u8000\u8170\uF9C2\u87EF\u8981\u8B20\u9059\uF9C3\u9080\u9952\u617E\u6B32\u6D74\u7E1F\u8925\u8FB1\u4FD1\u50AD\u5197\u52C7\u57C7\u5889\u5BB9\u5EB8\u6142\u6995\u6D8C\u6E67\u6EB6\u7194\u7462\u7528\u752C\u8073\u8338\u84C9\u8E0A\u9394\u93DE\uF9C4\u4E8E\u4F51\u5076\u512A\u53C8\u53CB\u53F3\u5B87\u5BD3\u5C24\u611A\u6182\u65F4\u725B\u7397\u7440\u76C2\u7950\u7991\u79B9\u7D06\u7FBD\u828B\u85D5\u865E\u8FC2\u9047\u90F5\u91EA\u9685\u96E8\u96E9\u52D6\u5F67\u65ED\u6631\u682F\u715C\u7A36\u90C1\u980A\u4E91\uF9C5\u6A52\u6B9E\u6F90\u7189\u8018\u82B8\u8553"],
    ["eaa1", "\u904B\u9695\u96F2\u97FB\u851A\u9B31\u4E90\u718A\u96C4\u5143\u539F\u54E1\u5713\u5712\u57A3\u5A9B\u5AC4\u5BC3\u6028\u613F\u63F4\u6C85\u6D39\u6E72\u6E90\u7230\u733F\u7457\u82D1\u8881\u8F45\u9060\uF9C6\u9662\u9858\u9D1B\u6708\u8D8A\u925E\u4F4D\u5049\u50DE\u5371\u570D\u59D4\u5A01\u5C09\u6170\u6690\u6E2D\u7232\u744B\u7DEF\u80C3\u840E\u8466\u853F\u875F\u885B\u8918\u8B02\u9055\u97CB\u9B4F\u4E73\u4F91\u5112\u516A\uF9C7\u552F\u55A9\u5B7A\u5BA5\u5E7C\u5E7D\u5EBE\u60A0\u60DF\u6108\u6109\u63C4\u6538\u6709\uF9C8\u67D4\u67DA\uF9C9\u6961\u6962\u6CB9\u6D27\uF9CA\u6E38\uF9CB"],
    ["eba1", "\u6FE1\u7336\u7337\uF9CC\u745C\u7531\uF9CD\u7652\uF9CE\uF9CF\u7DAD\u81FE\u8438\u88D5\u8A98\u8ADB\u8AED\u8E30\u8E42\u904A\u903E\u907A\u9149\u91C9\u936E\uF9D0\uF9D1\u5809\uF9D2\u6BD3\u8089\u80B2\uF9D3\uF9D4\u5141\u596B\u5C39\uF9D5\uF9D6\u6F64\u73A7\u80E4\u8D07\uF9D7\u9217\u958F\uF9D8\uF9D9\uF9DA\uF9DB\u807F\u620E\u701C\u7D68\u878D\uF9DC\u57A0\u6069\u6147\u6BB7\u8ABE\u9280\u96B1\u4E59\u541F\u6DEB\u852D\u9670\u97F3\u98EE\u63D6\u6CE3\u9091\u51DD\u61C9\u81BA\u9DF9\u4F9D\u501A\u5100\u5B9C\u610F\u61FF\u64EC\u6905\u6BC5\u7591\u77E3\u7FA9\u8264\u858F\u87FB\u8863\u8ABC"],
    ["eca1", "\u8B70\u91AB\u4E8C\u4EE5\u4F0A\uF9DD\uF9DE\u5937\u59E8\uF9DF\u5DF2\u5F1B\u5F5B\u6021\uF9E0\uF9E1\uF9E2\uF9E3\u723E\u73E5\uF9E4\u7570\u75CD\uF9E5\u79FB\uF9E6\u800C\u8033\u8084\u82E1\u8351\uF9E7\uF9E8\u8CBD\u8CB3\u9087\uF9E9\uF9EA\u98F4\u990C\uF9EB\uF9EC\u7037\u76CA\u7FCA\u7FCC\u7FFC\u8B1A\u4EBA\u4EC1\u5203\u5370\uF9ED\u54BD\u56E0\u59FB\u5BC5\u5F15\u5FCD\u6E6E\uF9EE\uF9EF\u7D6A\u8335\uF9F0\u8693\u8A8D\uF9F1\u976D\u9777\uF9F2\uF9F3\u4E00\u4F5A\u4F7E\u58F9\u65E5\u6EA2\u9038\u93B0\u99B9\u4EFB\u58EC\u598A\u59D9\u6041\uF9F4\uF9F5\u7A14\uF9F6\u834F\u8CC3\u5165\u5344"],
    ["eda1", "\uF9F7\uF9F8\uF9F9\u4ECD\u5269\u5B55\u82BF\u4ED4\u523A\u54A8\u59C9\u59FF\u5B50\u5B57\u5B5C\u6063\u6148\u6ECB\u7099\u716E\u7386\u74F7\u75B5\u78C1\u7D2B\u8005\u81EA\u8328\u8517\u85C9\u8AEE\u8CC7\u96CC\u4F5C\u52FA\u56BC\u65AB\u6628\u707C\u70B8\u7235\u7DBD\u828D\u914C\u96C0\u9D72\u5B71\u68E7\u6B98\u6F7A\u76DE\u5C91\u66AB\u6F5B\u7BB4\u7C2A\u8836\u96DC\u4E08\u4ED7\u5320\u5834\u58BB\u58EF\u596C\u5C07\u5E33\u5E84\u5F35\u638C\u66B2\u6756\u6A1F\u6AA3\u6B0C\u6F3F\u7246\uF9FA\u7350\u748B\u7AE0\u7CA7\u8178\u81DF\u81E7\u838A\u846C\u8523\u8594\u85CF\u88DD\u8D13\u91AC\u9577"],
    ["eea1", "\u969C\u518D\u54C9\u5728\u5BB0\u624D\u6750\u683D\u6893\u6E3D\u6ED3\u707D\u7E21\u88C1\u8CA1\u8F09\u9F4B\u9F4E\u722D\u7B8F\u8ACD\u931A\u4F47\u4F4E\u5132\u5480\u59D0\u5E95\u62B5\u6775\u696E\u6A17\u6CAE\u6E1A\u72D9\u732A\u75BD\u7BB8\u7D35\u82E7\u83F9\u8457\u85F7\u8A5B\u8CAF\u8E87\u9019\u90B8\u96CE\u9F5F\u52E3\u540A\u5AE1\u5BC2\u6458\u6575\u6EF4\u72C4\uF9FB\u7684\u7A4D\u7B1B\u7C4D\u7E3E\u7FDF\u837B\u8B2B\u8CCA\u8D64\u8DE1\u8E5F\u8FEA\u8FF9\u9069\u93D1\u4F43\u4F7A\u50B3\u5168\u5178\u524D\u526A\u5861\u587C\u5960\u5C08\u5C55\u5EDB\u609B\u6230\u6813\u6BBF\u6C08\u6FB1"],
    ["efa1", "\u714E\u7420\u7530\u7538\u7551\u7672\u7B4C\u7B8B\u7BAD\u7BC6\u7E8F\u8A6E\u8F3E\u8F49\u923F\u9293\u9322\u942B\u96FB\u985A\u986B\u991E\u5207\u622A\u6298\u6D59\u7664\u7ACA\u7BC0\u7D76\u5360\u5CBE\u5E97\u6F38\u70B9\u7C98\u9711\u9B8E\u9EDE\u63A5\u647A\u8776\u4E01\u4E95\u4EAD\u505C\u5075\u5448\u59C3\u5B9A\u5E40\u5EAD\u5EF7\u5F81\u60C5\u633A\u653F\u6574\u65CC\u6676\u6678\u67FE\u6968\u6A89\u6B63\u6C40\u6DC0\u6DE8\u6E1F\u6E5E\u701E\u70A1\u738E\u73FD\u753A\u775B\u7887\u798E\u7A0B\u7A7D\u7CBE\u7D8E\u8247\u8A02\u8AEA\u8C9E\u912D\u914A\u91D8\u9266\u92CC\u9320\u9706\u9756"],
    ["f0a1", "\u975C\u9802\u9F0E\u5236\u5291\u557C\u5824\u5E1D\u5F1F\u608C\u63D0\u68AF\u6FDF\u796D\u7B2C\u81CD\u85BA\u88FD\u8AF8\u8E44\u918D\u9664\u969B\u973D\u984C\u9F4A\u4FCE\u5146\u51CB\u52A9\u5632\u5F14\u5F6B\u63AA\u64CD\u65E9\u6641\u66FA\u66F9\u671D\u689D\u68D7\u69FD\u6F15\u6F6E\u7167\u71E5\u722A\u74AA\u773A\u7956\u795A\u79DF\u7A20\u7A95\u7C97\u7CDF\u7D44\u7E70\u8087\u85FB\u86A4\u8A54\u8ABF\u8D99\u8E81\u9020\u906D\u91E3\u963B\u96D5\u9CE5\u65CF\u7C07\u8DB3\u93C3\u5B58\u5C0A\u5352\u62D9\u731D\u5027\u5B97\u5F9E\u60B0\u616B\u68D5\u6DD9\u742E\u7A2E\u7D42\u7D9C\u7E31\u816B"],
    ["f1a1", "\u8E2A\u8E35\u937E\u9418\u4F50\u5750\u5DE6\u5EA7\u632B\u7F6A\u4E3B\u4F4F\u4F8F\u505A\u59DD\u80C4\u546A\u5468\u55FE\u594F\u5B99\u5DDE\u5EDA\u665D\u6731\u67F1\u682A\u6CE8\u6D32\u6E4A\u6F8D\u70B7\u73E0\u7587\u7C4C\u7D02\u7D2C\u7DA2\u821F\u86DB\u8A3B\u8A85\u8D70\u8E8A\u8F33\u9031\u914E\u9152\u9444\u99D0\u7AF9\u7CA5\u4FCA\u5101\u51C6\u57C8\u5BEF\u5CFB\u6659\u6A3D\u6D5A\u6E96\u6FEC\u710C\u756F\u7AE3\u8822\u9021\u9075\u96CB\u99FF\u8301\u4E2D\u4EF2\u8846\u91CD\u537D\u6ADB\u696B\u6C41\u847A\u589E\u618E\u66FE\u62EF\u70DD\u7511\u75C7\u7E52\u84B8\u8B49\u8D08\u4E4B\u53EA"],
    ["f2a1", "\u54AB\u5730\u5740\u5FD7\u6301\u6307\u646F\u652F\u65E8\u667A\u679D\u67B3\u6B62\u6C60\u6C9A\u6F2C\u77E5\u7825\u7949\u7957\u7D19\u80A2\u8102\u81F3\u829D\u82B7\u8718\u8A8C\uF9FC\u8D04\u8DBE\u9072\u76F4\u7A19\u7A37\u7E54\u8077\u5507\u55D4\u5875\u632F\u6422\u6649\u664B\u686D\u699B\u6B84\u6D25\u6EB1\u73CD\u7468\u74A1\u755B\u75B9\u76E1\u771E\u778B\u79E6\u7E09\u7E1D\u81FB\u852F\u8897\u8A3A\u8CD1\u8EEB\u8FB0\u9032\u93AD\u9663\u9673\u9707\u4F84\u53F1\u59EA\u5AC9\u5E19\u684E\u74C6\u75BE\u79E9\u7A92\u81A3\u86ED\u8CEA\u8DCC\u8FED\u659F\u6715\uF9FD\u57F7\u6F57\u7DDD\u8F2F"],
    ["f3a1", "\u93F6\u96C6\u5FB5\u61F2\u6F84\u4E14\u4F98\u501F\u53C9\u55DF\u5D6F\u5DEE\u6B21\u6B64\u78CB\u7B9A\uF9FE\u8E49\u8ECA\u906E\u6349\u643E\u7740\u7A84\u932F\u947F\u9F6A\u64B0\u6FAF\u71E6\u74A8\u74DA\u7AC4\u7C12\u7E82\u7CB2\u7E98\u8B9A\u8D0A\u947D\u9910\u994C\u5239\u5BDF\u64E6\u672D\u7D2E\u50ED\u53C3\u5879\u6158\u6159\u61FA\u65AC\u7AD9\u8B92\u8B96\u5009\u5021\u5275\u5531\u5A3C\u5EE0\u5F70\u6134\u655E\u660C\u6636\u66A2\u69CD\u6EC4\u6F32\u7316\u7621\u7A93\u8139\u8259\u83D6\u84BC\u50B5\u57F0\u5BC0\u5BE8\u5F69\u63A1\u7826\u7DB5\u83DC\u8521\u91C7\u91F5\u518A\u67F5\u7B56"],
    ["f4a1", "\u8CAC\u51C4\u59BB\u60BD\u8655\u501C\uF9FF\u5254\u5C3A\u617D\u621A\u62D3\u64F2\u65A5\u6ECC\u7620\u810A\u8E60\u965F\u96BB\u4EDF\u5343\u5598\u5929\u5DDD\u64C5\u6CC9\u6DFA\u7394\u7A7F\u821B\u85A6\u8CE4\u8E10\u9077\u91E7\u95E1\u9621\u97C6\u51F8\u54F2\u5586\u5FB9\u64A4\u6F88\u7DB4\u8F1F\u8F4D\u9435\u50C9\u5C16\u6CBE\u6DFB\u751B\u77BB\u7C3D\u7C64\u8A79\u8AC2\u581E\u59BE\u5E16\u6377\u7252\u758A\u776B\u8ADC\u8CBC\u8F12\u5EF3\u6674\u6DF8\u807D\u83C1\u8ACB\u9751\u9BD6\uFA00\u5243\u66FF\u6D95\u6EEF\u7DE0\u8AE6\u902E\u905E\u9AD4\u521D\u527F\u54E8\u6194\u6284\u62DB\u68A2"],
    ["f5a1", "\u6912\u695A\u6A35\u7092\u7126\u785D\u7901\u790E\u79D2\u7A0D\u8096\u8278\u82D5\u8349\u8549\u8C82\u8D85\u9162\u918B\u91AE\u4FC3\u56D1\u71ED\u77D7\u8700\u89F8\u5BF8\u5FD6\u6751\u90A8\u53E2\u585A\u5BF5\u60A4\u6181\u6460\u7E3D\u8070\u8525\u9283\u64AE\u50AC\u5D14\u6700\u589C\u62BD\u63A8\u690E\u6978\u6A1E\u6E6B\u76BA\u79CB\u82BB\u8429\u8ACF\u8DA8\u8FFD\u9112\u914B\u919C\u9310\u9318\u939A\u96DB\u9A36\u9C0D\u4E11\u755C\u795D\u7AFA\u7B51\u7BC9\u7E2E\u84C4\u8E59\u8E74\u8EF8\u9010\u6625\u693F\u7443\u51FA\u672E\u9EDC\u5145\u5FE0\u6C96\u87F2\u885D\u8877\u60B4\u81B5\u8403"],
    ["f6a1", "\u8D05\u53D6\u5439\u5634\u5A36\u5C31\u708A\u7FE0\u805A\u8106\u81ED\u8DA3\u9189\u9A5F\u9DF2\u5074\u4EC4\u53A0\u60FB\u6E2C\u5C64\u4F88\u5024\u55E4\u5CD9\u5E5F\u6065\u6894\u6CBB\u6DC4\u71BE\u75D4\u75F4\u7661\u7A1A\u7A49\u7DC7\u7DFB\u7F6E\u81F4\u86A9\u8F1C\u96C9\u99B3\u9F52\u5247\u52C5\u98ED\u89AA\u4E03\u67D2\u6F06\u4FB5\u5BE2\u6795\u6C88\u6D78\u741B\u7827\u91DD\u937C\u87C4\u79E4\u7A31\u5FEB\u4ED6\u54A4\u553E\u58AE\u59A5\u60F0\u6253\u62D6\u6736\u6955\u8235\u9640\u99B1\u99DD\u502C\u5353\u5544\u577C\uFA01\u6258\uFA02\u64E2\u666B\u67DD\u6FC1\u6FEF\u7422\u7438\u8A17"],
    ["f7a1", "\u9438\u5451\u5606\u5766\u5F48\u619A\u6B4E\u7058\u70AD\u7DBB\u8A95\u596A\u812B\u63A2\u7708\u803D\u8CAA\u5854\u642D\u69BB\u5B95\u5E11\u6E6F\uFA03\u8569\u514C\u53F0\u592A\u6020\u614B\u6B86\u6C70\u6CF0\u7B1E\u80CE\u82D4\u8DC6\u90B0\u98B1\uFA04\u64C7\u6FA4\u6491\u6504\u514E\u5410\u571F\u8A0E\u615F\u6876\uFA05\u75DB\u7B52\u7D71\u901A\u5806\u69CC\u817F\u892A\u9000\u9839\u5078\u5957\u59AC\u6295\u900F\u9B2A\u615D\u7279\u95D6\u5761\u5A46\u5DF4\u628A\u64AD\u64FA\u6777\u6CE2\u6D3E\u722C\u7436\u7834\u7F77\u82AD\u8DDB\u9817\u5224\u5742\u677F\u7248\u74E3\u8CA9\u8FA6\u9211"],
    ["f8a1", "\u962A\u516B\u53ED\u634C\u4F69\u5504\u6096\u6557\u6C9B\u6D7F\u724C\u72FD\u7A17\u8987\u8C9D\u5F6D\u6F8E\u70F9\u81A8\u610E\u4FBF\u504F\u6241\u7247\u7BC7\u7DE8\u7FE9\u904D\u97AD\u9A19\u8CB6\u576A\u5E73\u67B0\u840D\u8A55\u5420\u5B16\u5E63\u5EE2\u5F0A\u6583\u80BA\u853D\u9589\u965B\u4F48\u5305\u530D\u530F\u5486\u54FA\u5703\u5E03\u6016\u629B\u62B1\u6355\uFA06\u6CE1\u6D66\u75B1\u7832\u80DE\u812F\u82DE\u8461\u84B2\u888D\u8912\u900B\u92EA\u98FD\u9B91\u5E45\u66B4\u66DD\u7011\u7206\uFA07\u4FF5\u527D\u5F6A\u6153\u6753\u6A19\u6F02\u74E2\u7968\u8868\u8C79\u98C7\u98C4\u9A43"],
    ["f9a1", "\u54C1\u7A1F\u6953\u8AF7\u8C4A\u98A8\u99AE\u5F7C\u62AB\u75B2\u76AE\u88AB\u907F\u9642\u5339\u5F3C\u5FC5\u6CCC\u73CC\u7562\u758B\u7B46\u82FE\u999D\u4E4F\u903C\u4E0B\u4F55\u53A6\u590F\u5EC8\u6630\u6CB3\u7455\u8377\u8766\u8CC0\u9050\u971E\u9C15\u58D1\u5B78\u8650\u8B14\u9DB4\u5BD2\u6068\u608D\u65F1\u6C57\u6F22\u6FA3\u701A\u7F55\u7FF0\u9591\u9592\u9650\u97D3\u5272\u8F44\u51FD\u542B\u54B8\u5563\u558A\u6ABB\u6DB5\u7DD8\u8266\u929C\u9677\u9E79\u5408\u54C8\u76D2\u86E4\u95A4\u95D4\u965C\u4EA2\u4F09\u59EE\u5AE6\u5DF7\u6052\u6297\u676D\u6841\u6C86\u6E2F\u7F38\u809B\u822A"],
    ["faa1", "\uFA08\uFA09\u9805\u4EA5\u5055\u54B3\u5793\u595A\u5B69\u5BB3\u61C8\u6977\u6D77\u7023\u87F9\u89E3\u8A72\u8AE7\u9082\u99ED\u9AB8\u52BE\u6838\u5016\u5E78\u674F\u8347\u884C\u4EAB\u5411\u56AE\u73E6\u9115\u97FF\u9909\u9957\u9999\u5653\u589F\u865B\u8A31\u61B2\u6AF6\u737B\u8ED2\u6B47\u96AA\u9A57\u5955\u7200\u8D6B\u9769\u4FD4\u5CF4\u5F26\u61F8\u665B\u6CEB\u70AB\u7384\u73B9\u73FE\u7729\u774D\u7D43\u7D62\u7E23\u8237\u8852\uFA0A\u8CE2\u9249\u986F\u5B51\u7A74\u8840\u9801\u5ACC\u4FE0\u5354\u593E\u5CFD\u633E\u6D79\u72F9\u8105\u8107\u83A2\u92CF\u9830\u4EA8\u5144\u5211\u578B"],
    ["fba1", "\u5F62\u6CC2\u6ECE\u7005\u7050\u70AF\u7192\u73E9\u7469\u834A\u87A2\u8861\u9008\u90A2\u93A3\u99A8\u516E\u5F57\u60E0\u6167\u66B3\u8559\u8E4A\u91AF\u978B\u4E4E\u4E92\u547C\u58D5\u58FA\u597D\u5CB5\u5F27\u6236\u6248\u660A\u6667\u6BEB\u6D69\u6DCF\u6E56\u6EF8\u6F94\u6FE0\u6FE9\u705D\u72D0\u7425\u745A\u74E0\u7693\u795C\u7CCA\u7E1E\u80E1\u82A6\u846B\u84BF\u864E\u865F\u8774\u8B77\u8C6A\u93AC\u9800\u9865\u60D1\u6216\u9177\u5A5A\u660F\u6DF7\u6E3E\u743F\u9B42\u5FFD\u60DA\u7B0F\u54C4\u5F18\u6C5E\u6CD3\u6D2A\u70D8\u7D05\u8679\u8A0C\u9D3B\u5316\u548C\u5B05\u6A3A\u706B\u7575"],
    ["fca1", "\u798D\u79BE\u82B1\u83EF\u8A71\u8B41\u8CA8\u9774\uFA0B\u64F4\u652B\u78BA\u78BB\u7A6B\u4E38\u559A\u5950\u5BA6\u5E7B\u60A3\u63DB\u6B61\u6665\u6853\u6E19\u7165\u74B0\u7D08\u9084\u9A69\u9C25\u6D3B\u6ED1\u733E\u8C41\u95CA\u51F0\u5E4C\u5FA8\u604D\u60F6\u6130\u614C\u6643\u6644\u69A5\u6CC1\u6E5F\u6EC9\u6F62\u714C\u749C\u7687\u7BC1\u7C27\u8352\u8757\u9051\u968D\u9EC3\u532F\u56DE\u5EFB\u5F8A\u6062\u6094\u61F7\u6666\u6703\u6A9C\u6DEE\u6FAE\u7070\u736A\u7E6A\u81BE\u8334\u86D4\u8AA8\u8CC4\u5283\u7372\u5B96\u6A6B\u9404\u54EE\u5686\u5B5D\u6548\u6585\u66C9\u689F\u6D8D\u6DC6"],
    ["fda1", "\u723B\u80B4\u9175\u9A4D\u4FAF\u5019\u539A\u540E\u543C\u5589\u55C5\u5E3F\u5F8C\u673D\u7166\u73DD\u9005\u52DB\u52F3\u5864\u58CE\u7104\u718F\u71FB\u85B0\u8A13\u6688\u85A8\u55A7\u6684\u714A\u8431\u5349\u5599\u6BC1\u5F59\u5FBD\u63EE\u6689\u7147\u8AF1\u8F1D\u9EBE\u4F11\u643A\u70CB\u7566\u8667\u6064\u8B4E\u9DF8\u5147\u51F6\u5308\u6D36\u80F8\u9ED1\u6615\u6B23\u7098\u75D5\u5403\u5C79\u7D07\u8A16\u6B20\u6B3D\u6B46\u5438\u6070\u6D3D\u7FD5\u8208\u50D6\u51DE\u559C\u566B\u56CD\u59EC\u5B09\u5E0C\u6199\u6198\u6231\u665E\u66E6\u7199\u71B9\u71BA\u72A7\u79A7\u7A00\u7FB2\u8A70"]
  ];
});
var require_cp950 = __commonJS2((exports, module) => {
  module.exports = [
    ["0", "\0", 127],
    ["a140", "\u3000\uFF0C\u3001\u3002\uFF0E\u2027\uFF1B\uFF1A\uFF1F\uFF01\uFE30\u2026\u2025\uFE50\uFE51\uFE52\xB7\uFE54\uFE55\uFE56\uFE57\uFF5C\u2013\uFE31\u2014\uFE33\u2574\uFE34\uFE4F\uFF08\uFF09\uFE35\uFE36\uFF5B\uFF5D\uFE37\uFE38\u3014\u3015\uFE39\uFE3A\u3010\u3011\uFE3B\uFE3C\u300A\u300B\uFE3D\uFE3E\u3008\u3009\uFE3F\uFE40\u300C\u300D\uFE41\uFE42\u300E\u300F\uFE43\uFE44\uFE59\uFE5A"],
    ["a1a1", "\uFE5B\uFE5C\uFE5D\uFE5E\u2018\u2019\u201C\u201D\u301D\u301E\u2035\u2032\uFF03\uFF06\uFF0A\u203B\xA7\u3003\u25CB\u25CF\u25B3\u25B2\u25CE\u2606\u2605\u25C7\u25C6\u25A1\u25A0\u25BD\u25BC\u32A3\u2105\xAF\uFFE3\uFF3F\u02CD\uFE49\uFE4A\uFE4D\uFE4E\uFE4B\uFE4C\uFE5F\uFE60\uFE61\uFF0B\uFF0D\xD7\xF7\xB1\u221A\uFF1C\uFF1E\uFF1D\u2266\u2267\u2260\u221E\u2252\u2261\uFE62", 4, "\uFF5E\u2229\u222A\u22A5\u2220\u221F\u22BF\u33D2\u33D1\u222B\u222E\u2235\u2234\u2640\u2642\u2295\u2299\u2191\u2193\u2190\u2192\u2196\u2197\u2199\u2198\u2225\u2223\uFF0F"],
    ["a240", "\uFF3C\u2215\uFE68\uFF04\uFFE5\u3012\uFFE0\uFFE1\uFF05\uFF20\u2103\u2109\uFE69\uFE6A\uFE6B\u33D5\u339C\u339D\u339E\u33CE\u33A1\u338E\u338F\u33C4\xB0\u5159\u515B\u515E\u515D\u5161\u5163\u55E7\u74E9\u7CCE\u2581", 7, "\u258F\u258E\u258D\u258C\u258B\u258A\u2589\u253C\u2534\u252C\u2524\u251C\u2594\u2500\u2502\u2595\u250C\u2510\u2514\u2518\u256D"],
    ["a2a1", "\u256E\u2570\u256F\u2550\u255E\u256A\u2561\u25E2\u25E3\u25E5\u25E4\u2571\u2572\u2573\uFF10", 9, "\u2160", 9, "\u3021", 8, "\u5341\u5344\u5345\uFF21", 25, "\uFF41", 21],
    ["a340", "\uFF57\uFF58\uFF59\uFF5A\u0391", 16, "\u03A3", 6, "\u03B1", 16, "\u03C3", 6, "\u3105", 10],
    ["a3a1", "\u3110", 25, "\u02D9\u02C9\u02CA\u02C7\u02CB"],
    ["a3e1", "\u20AC"],
    ["a440", "\u4E00\u4E59\u4E01\u4E03\u4E43\u4E5D\u4E86\u4E8C\u4EBA\u513F\u5165\u516B\u51E0\u5200\u5201\u529B\u5315\u5341\u535C\u53C8\u4E09\u4E0B\u4E08\u4E0A\u4E2B\u4E38\u51E1\u4E45\u4E48\u4E5F\u4E5E\u4E8E\u4EA1\u5140\u5203\u52FA\u5343\u53C9\u53E3\u571F\u58EB\u5915\u5927\u5973\u5B50\u5B51\u5B53\u5BF8\u5C0F\u5C22\u5C38\u5C71\u5DDD\u5DE5\u5DF1\u5DF2\u5DF3\u5DFE\u5E72\u5EFE\u5F0B\u5F13\u624D"],
    ["a4a1", "\u4E11\u4E10\u4E0D\u4E2D\u4E30\u4E39\u4E4B\u5C39\u4E88\u4E91\u4E95\u4E92\u4E94\u4EA2\u4EC1\u4EC0\u4EC3\u4EC6\u4EC7\u4ECD\u4ECA\u4ECB\u4EC4\u5143\u5141\u5167\u516D\u516E\u516C\u5197\u51F6\u5206\u5207\u5208\u52FB\u52FE\u52FF\u5316\u5339\u5348\u5347\u5345\u535E\u5384\u53CB\u53CA\u53CD\u58EC\u5929\u592B\u592A\u592D\u5B54\u5C11\u5C24\u5C3A\u5C6F\u5DF4\u5E7B\u5EFF\u5F14\u5F15\u5FC3\u6208\u6236\u624B\u624E\u652F\u6587\u6597\u65A4\u65B9\u65E5\u66F0\u6708\u6728\u6B20\u6B62\u6B79\u6BCB\u6BD4\u6BDB\u6C0F\u6C34\u706B\u722A\u7236\u723B\u7247\u7259\u725B\u72AC\u738B\u4E19"],
    ["a540", "\u4E16\u4E15\u4E14\u4E18\u4E3B\u4E4D\u4E4F\u4E4E\u4EE5\u4ED8\u4ED4\u4ED5\u4ED6\u4ED7\u4EE3\u4EE4\u4ED9\u4EDE\u5145\u5144\u5189\u518A\u51AC\u51F9\u51FA\u51F8\u520A\u52A0\u529F\u5305\u5306\u5317\u531D\u4EDF\u534A\u5349\u5361\u5360\u536F\u536E\u53BB\u53EF\u53E4\u53F3\u53EC\u53EE\u53E9\u53E8\u53FC\u53F8\u53F5\u53EB\u53E6\u53EA\u53F2\u53F1\u53F0\u53E5\u53ED\u53FB\u56DB\u56DA\u5916"],
    ["a5a1", "\u592E\u5931\u5974\u5976\u5B55\u5B83\u5C3C\u5DE8\u5DE7\u5DE6\u5E02\u5E03\u5E73\u5E7C\u5F01\u5F18\u5F17\u5FC5\u620A\u6253\u6254\u6252\u6251\u65A5\u65E6\u672E\u672C\u672A\u672B\u672D\u6B63\u6BCD\u6C11\u6C10\u6C38\u6C41\u6C40\u6C3E\u72AF\u7384\u7389\u74DC\u74E6\u7518\u751F\u7528\u7529\u7530\u7531\u7532\u7533\u758B\u767D\u76AE\u76BF\u76EE\u77DB\u77E2\u77F3\u793A\u79BE\u7A74\u7ACB\u4E1E\u4E1F\u4E52\u4E53\u4E69\u4E99\u4EA4\u4EA6\u4EA5\u4EFF\u4F09\u4F19\u4F0A\u4F15\u4F0D\u4F10\u4F11\u4F0F\u4EF2\u4EF6\u4EFB\u4EF0\u4EF3\u4EFD\u4F01\u4F0B\u5149\u5147\u5146\u5148\u5168"],
    ["a640", "\u5171\u518D\u51B0\u5217\u5211\u5212\u520E\u5216\u52A3\u5308\u5321\u5320\u5370\u5371\u5409\u540F\u540C\u540A\u5410\u5401\u540B\u5404\u5411\u540D\u5408\u5403\u540E\u5406\u5412\u56E0\u56DE\u56DD\u5733\u5730\u5728\u572D\u572C\u572F\u5729\u5919\u591A\u5937\u5938\u5984\u5978\u5983\u597D\u5979\u5982\u5981\u5B57\u5B58\u5B87\u5B88\u5B85\u5B89\u5BFA\u5C16\u5C79\u5DDE\u5E06\u5E76\u5E74"],
    ["a6a1", "\u5F0F\u5F1B\u5FD9\u5FD6\u620E\u620C\u620D\u6210\u6263\u625B\u6258\u6536\u65E9\u65E8\u65EC\u65ED\u66F2\u66F3\u6709\u673D\u6734\u6731\u6735\u6B21\u6B64\u6B7B\u6C16\u6C5D\u6C57\u6C59\u6C5F\u6C60\u6C50\u6C55\u6C61\u6C5B\u6C4D\u6C4E\u7070\u725F\u725D\u767E\u7AF9\u7C73\u7CF8\u7F36\u7F8A\u7FBD\u8001\u8003\u800C\u8012\u8033\u807F\u8089\u808B\u808C\u81E3\u81EA\u81F3\u81FC\u820C\u821B\u821F\u826E\u8272\u827E\u866B\u8840\u884C\u8863\u897F\u9621\u4E32\u4EA8\u4F4D\u4F4F\u4F47\u4F57\u4F5E\u4F34\u4F5B\u4F55\u4F30\u4F50\u4F51\u4F3D\u4F3A\u4F38\u4F43\u4F54\u4F3C\u4F46\u4F63"],
    ["a740", "\u4F5C\u4F60\u4F2F\u4F4E\u4F36\u4F59\u4F5D\u4F48\u4F5A\u514C\u514B\u514D\u5175\u51B6\u51B7\u5225\u5224\u5229\u522A\u5228\u52AB\u52A9\u52AA\u52AC\u5323\u5373\u5375\u541D\u542D\u541E\u543E\u5426\u544E\u5427\u5446\u5443\u5433\u5448\u5442\u541B\u5429\u544A\u5439\u543B\u5438\u542E\u5435\u5436\u5420\u543C\u5440\u5431\u542B\u541F\u542C\u56EA\u56F0\u56E4\u56EB\u574A\u5751\u5740\u574D"],
    ["a7a1", "\u5747\u574E\u573E\u5750\u574F\u573B\u58EF\u593E\u599D\u5992\u59A8\u599E\u59A3\u5999\u5996\u598D\u59A4\u5993\u598A\u59A5\u5B5D\u5B5C\u5B5A\u5B5B\u5B8C\u5B8B\u5B8F\u5C2C\u5C40\u5C41\u5C3F\u5C3E\u5C90\u5C91\u5C94\u5C8C\u5DEB\u5E0C\u5E8F\u5E87\u5E8A\u5EF7\u5F04\u5F1F\u5F64\u5F62\u5F77\u5F79\u5FD8\u5FCC\u5FD7\u5FCD\u5FF1\u5FEB\u5FF8\u5FEA\u6212\u6211\u6284\u6297\u6296\u6280\u6276\u6289\u626D\u628A\u627C\u627E\u6279\u6273\u6292\u626F\u6298\u626E\u6295\u6293\u6291\u6286\u6539\u653B\u6538\u65F1\u66F4\u675F\u674E\u674F\u6750\u6751\u675C\u6756\u675E\u6749\u6746\u6760"],
    ["a840", "\u6753\u6757\u6B65\u6BCF\u6C42\u6C5E\u6C99\u6C81\u6C88\u6C89\u6C85\u6C9B\u6C6A\u6C7A\u6C90\u6C70\u6C8C\u6C68\u6C96\u6C92\u6C7D\u6C83\u6C72\u6C7E\u6C74\u6C86\u6C76\u6C8D\u6C94\u6C98\u6C82\u7076\u707C\u707D\u7078\u7262\u7261\u7260\u72C4\u72C2\u7396\u752C\u752B\u7537\u7538\u7682\u76EF\u77E3\u79C1\u79C0\u79BF\u7A76\u7CFB\u7F55\u8096\u8093\u809D\u8098\u809B\u809A\u80B2\u826F\u8292"],
    ["a8a1", "\u828B\u828D\u898B\u89D2\u8A00\u8C37\u8C46\u8C55\u8C9D\u8D64\u8D70\u8DB3\u8EAB\u8ECA\u8F9B\u8FB0\u8FC2\u8FC6\u8FC5\u8FC4\u5DE1\u9091\u90A2\u90AA\u90A6\u90A3\u9149\u91C6\u91CC\u9632\u962E\u9631\u962A\u962C\u4E26\u4E56\u4E73\u4E8B\u4E9B\u4E9E\u4EAB\u4EAC\u4F6F\u4F9D\u4F8D\u4F73\u4F7F\u4F6C\u4F9B\u4F8B\u4F86\u4F83\u4F70\u4F75\u4F88\u4F69\u4F7B\u4F96\u4F7E\u4F8F\u4F91\u4F7A\u5154\u5152\u5155\u5169\u5177\u5176\u5178\u51BD\u51FD\u523B\u5238\u5237\u523A\u5230\u522E\u5236\u5241\u52BE\u52BB\u5352\u5354\u5353\u5351\u5366\u5377\u5378\u5379\u53D6\u53D4\u53D7\u5473\u5475"],
    ["a940", "\u5496\u5478\u5495\u5480\u547B\u5477\u5484\u5492\u5486\u547C\u5490\u5471\u5476\u548C\u549A\u5462\u5468\u548B\u547D\u548E\u56FA\u5783\u5777\u576A\u5769\u5761\u5766\u5764\u577C\u591C\u5949\u5947\u5948\u5944\u5954\u59BE\u59BB\u59D4\u59B9\u59AE\u59D1\u59C6\u59D0\u59CD\u59CB\u59D3\u59CA\u59AF\u59B3\u59D2\u59C5\u5B5F\u5B64\u5B63\u5B97\u5B9A\u5B98\u5B9C\u5B99\u5B9B\u5C1A\u5C48\u5C45"],
    ["a9a1", "\u5C46\u5CB7\u5CA1\u5CB8\u5CA9\u5CAB\u5CB1\u5CB3\u5E18\u5E1A\u5E16\u5E15\u5E1B\u5E11\u5E78\u5E9A\u5E97\u5E9C\u5E95\u5E96\u5EF6\u5F26\u5F27\u5F29\u5F80\u5F81\u5F7F\u5F7C\u5FDD\u5FE0\u5FFD\u5FF5\u5FFF\u600F\u6014\u602F\u6035\u6016\u602A\u6015\u6021\u6027\u6029\u602B\u601B\u6216\u6215\u623F\u623E\u6240\u627F\u62C9\u62CC\u62C4\u62BF\u62C2\u62B9\u62D2\u62DB\u62AB\u62D3\u62D4\u62CB\u62C8\u62A8\u62BD\u62BC\u62D0\u62D9\u62C7\u62CD\u62B5\u62DA\u62B1\u62D8\u62D6\u62D7\u62C6\u62AC\u62CE\u653E\u65A7\u65BC\u65FA\u6614\u6613\u660C\u6606\u6602\u660E\u6600\u660F\u6615\u660A"],
    ["aa40", "\u6607\u670D\u670B\u676D\u678B\u6795\u6771\u679C\u6773\u6777\u6787\u679D\u6797\u676F\u6770\u677F\u6789\u677E\u6790\u6775\u679A\u6793\u677C\u676A\u6772\u6B23\u6B66\u6B67\u6B7F\u6C13\u6C1B\u6CE3\u6CE8\u6CF3\u6CB1\u6CCC\u6CE5\u6CB3\u6CBD\u6CBE\u6CBC\u6CE2\u6CAB\u6CD5\u6CD3\u6CB8\u6CC4\u6CB9\u6CC1\u6CAE\u6CD7\u6CC5\u6CF1\u6CBF\u6CBB\u6CE1\u6CDB\u6CCA\u6CAC\u6CEF\u6CDC\u6CD6\u6CE0"],
    ["aaa1", "\u7095\u708E\u7092\u708A\u7099\u722C\u722D\u7238\u7248\u7267\u7269\u72C0\u72CE\u72D9\u72D7\u72D0\u73A9\u73A8\u739F\u73AB\u73A5\u753D\u759D\u7599\u759A\u7684\u76C2\u76F2\u76F4\u77E5\u77FD\u793E\u7940\u7941\u79C9\u79C8\u7A7A\u7A79\u7AFA\u7CFE\u7F54\u7F8C\u7F8B\u8005\u80BA\u80A5\u80A2\u80B1\u80A1\u80AB\u80A9\u80B4\u80AA\u80AF\u81E5\u81FE\u820D\u82B3\u829D\u8299\u82AD\u82BD\u829F\u82B9\u82B1\u82AC\u82A5\u82AF\u82B8\u82A3\u82B0\u82BE\u82B7\u864E\u8671\u521D\u8868\u8ECB\u8FCE\u8FD4\u8FD1\u90B5\u90B8\u90B1\u90B6\u91C7\u91D1\u9577\u9580\u961C\u9640\u963F\u963B\u9644"],
    ["ab40", "\u9642\u96B9\u96E8\u9752\u975E\u4E9F\u4EAD\u4EAE\u4FE1\u4FB5\u4FAF\u4FBF\u4FE0\u4FD1\u4FCF\u4FDD\u4FC3\u4FB6\u4FD8\u4FDF\u4FCA\u4FD7\u4FAE\u4FD0\u4FC4\u4FC2\u4FDA\u4FCE\u4FDE\u4FB7\u5157\u5192\u5191\u51A0\u524E\u5243\u524A\u524D\u524C\u524B\u5247\u52C7\u52C9\u52C3\u52C1\u530D\u5357\u537B\u539A\u53DB\u54AC\u54C0\u54A8\u54CE\u54C9\u54B8\u54A6\u54B3\u54C7\u54C2\u54BD\u54AA\u54C1"],
    ["aba1", "\u54C4\u54C8\u54AF\u54AB\u54B1\u54BB\u54A9\u54A7\u54BF\u56FF\u5782\u578B\u57A0\u57A3\u57A2\u57CE\u57AE\u5793\u5955\u5951\u594F\u594E\u5950\u59DC\u59D8\u59FF\u59E3\u59E8\u5A03\u59E5\u59EA\u59DA\u59E6\u5A01\u59FB\u5B69\u5BA3\u5BA6\u5BA4\u5BA2\u5BA5\u5C01\u5C4E\u5C4F\u5C4D\u5C4B\u5CD9\u5CD2\u5DF7\u5E1D\u5E25\u5E1F\u5E7D\u5EA0\u5EA6\u5EFA\u5F08\u5F2D\u5F65\u5F88\u5F85\u5F8A\u5F8B\u5F87\u5F8C\u5F89\u6012\u601D\u6020\u6025\u600E\u6028\u604D\u6070\u6068\u6062\u6046\u6043\u606C\u606B\u606A\u6064\u6241\u62DC\u6316\u6309\u62FC\u62ED\u6301\u62EE\u62FD\u6307\u62F1\u62F7"],
    ["ac40", "\u62EF\u62EC\u62FE\u62F4\u6311\u6302\u653F\u6545\u65AB\u65BD\u65E2\u6625\u662D\u6620\u6627\u662F\u661F\u6628\u6631\u6624\u66F7\u67FF\u67D3\u67F1\u67D4\u67D0\u67EC\u67B6\u67AF\u67F5\u67E9\u67EF\u67C4\u67D1\u67B4\u67DA\u67E5\u67B8\u67CF\u67DE\u67F3\u67B0\u67D9\u67E2\u67DD\u67D2\u6B6A\u6B83\u6B86\u6BB5\u6BD2\u6BD7\u6C1F\u6CC9\u6D0B\u6D32\u6D2A\u6D41\u6D25\u6D0C\u6D31\u6D1E\u6D17"],
    ["aca1", "\u6D3B\u6D3D\u6D3E\u6D36\u6D1B\u6CF5\u6D39\u6D27\u6D38\u6D29\u6D2E\u6D35\u6D0E\u6D2B\u70AB\u70BA\u70B3\u70AC\u70AF\u70AD\u70B8\u70AE\u70A4\u7230\u7272\u726F\u7274\u72E9\u72E0\u72E1\u73B7\u73CA\u73BB\u73B2\u73CD\u73C0\u73B3\u751A\u752D\u754F\u754C\u754E\u754B\u75AB\u75A4\u75A5\u75A2\u75A3\u7678\u7686\u7687\u7688\u76C8\u76C6\u76C3\u76C5\u7701\u76F9\u76F8\u7709\u770B\u76FE\u76FC\u7707\u77DC\u7802\u7814\u780C\u780D\u7946\u7949\u7948\u7947\u79B9\u79BA\u79D1\u79D2\u79CB\u7A7F\u7A81\u7AFF\u7AFD\u7C7D\u7D02\u7D05\u7D00\u7D09\u7D07\u7D04\u7D06\u7F38\u7F8E\u7FBF\u8004"],
    ["ad40", "\u8010\u800D\u8011\u8036\u80D6\u80E5\u80DA\u80C3\u80C4\u80CC\u80E1\u80DB\u80CE\u80DE\u80E4\u80DD\u81F4\u8222\u82E7\u8303\u8305\u82E3\u82DB\u82E6\u8304\u82E5\u8302\u8309\u82D2\u82D7\u82F1\u8301\u82DC\u82D4\u82D1\u82DE\u82D3\u82DF\u82EF\u8306\u8650\u8679\u867B\u867A\u884D\u886B\u8981\u89D4\u8A08\u8A02\u8A03\u8C9E\u8CA0\u8D74\u8D73\u8DB4\u8ECD\u8ECC\u8FF0\u8FE6\u8FE2\u8FEA\u8FE5"],
    ["ada1", "\u8FED\u8FEB\u8FE4\u8FE8\u90CA\u90CE\u90C1\u90C3\u914B\u914A\u91CD\u9582\u9650\u964B\u964C\u964D\u9762\u9769\u97CB\u97ED\u97F3\u9801\u98A8\u98DB\u98DF\u9996\u9999\u4E58\u4EB3\u500C\u500D\u5023\u4FEF\u5026\u5025\u4FF8\u5029\u5016\u5006\u503C\u501F\u501A\u5012\u5011\u4FFA\u5000\u5014\u5028\u4FF1\u5021\u500B\u5019\u5018\u4FF3\u4FEE\u502D\u502A\u4FFE\u502B\u5009\u517C\u51A4\u51A5\u51A2\u51CD\u51CC\u51C6\u51CB\u5256\u525C\u5254\u525B\u525D\u532A\u537F\u539F\u539D\u53DF\u54E8\u5510\u5501\u5537\u54FC\u54E5\u54F2\u5506\u54FA\u5514\u54E9\u54ED\u54E1\u5509\u54EE\u54EA"],
    ["ae40", "\u54E6\u5527\u5507\u54FD\u550F\u5703\u5704\u57C2\u57D4\u57CB\u57C3\u5809\u590F\u5957\u5958\u595A\u5A11\u5A18\u5A1C\u5A1F\u5A1B\u5A13\u59EC\u5A20\u5A23\u5A29\u5A25\u5A0C\u5A09\u5B6B\u5C58\u5BB0\u5BB3\u5BB6\u5BB4\u5BAE\u5BB5\u5BB9\u5BB8\u5C04\u5C51\u5C55\u5C50\u5CED\u5CFD\u5CFB\u5CEA\u5CE8\u5CF0\u5CF6\u5D01\u5CF4\u5DEE\u5E2D\u5E2B\u5EAB\u5EAD\u5EA7\u5F31\u5F92\u5F91\u5F90\u6059"],
    ["aea1", "\u6063\u6065\u6050\u6055\u606D\u6069\u606F\u6084\u609F\u609A\u608D\u6094\u608C\u6085\u6096\u6247\u62F3\u6308\u62FF\u634E\u633E\u632F\u6355\u6342\u6346\u634F\u6349\u633A\u6350\u633D\u632A\u632B\u6328\u634D\u634C\u6548\u6549\u6599\u65C1\u65C5\u6642\u6649\u664F\u6643\u6652\u664C\u6645\u6641\u66F8\u6714\u6715\u6717\u6821\u6838\u6848\u6846\u6853\u6839\u6842\u6854\u6829\u68B3\u6817\u684C\u6851\u683D\u67F4\u6850\u6840\u683C\u6843\u682A\u6845\u6813\u6818\u6841\u6B8A\u6B89\u6BB7\u6C23\u6C27\u6C28\u6C26\u6C24\u6CF0\u6D6A\u6D95\u6D88\u6D87\u6D66\u6D78\u6D77\u6D59\u6D93"],
    ["af40", "\u6D6C\u6D89\u6D6E\u6D5A\u6D74\u6D69\u6D8C\u6D8A\u6D79\u6D85\u6D65\u6D94\u70CA\u70D8\u70E4\u70D9\u70C8\u70CF\u7239\u7279\u72FC\u72F9\u72FD\u72F8\u72F7\u7386\u73ED\u7409\u73EE\u73E0\u73EA\u73DE\u7554\u755D\u755C\u755A\u7559\u75BE\u75C5\u75C7\u75B2\u75B3\u75BD\u75BC\u75B9\u75C2\u75B8\u768B\u76B0\u76CA\u76CD\u76CE\u7729\u771F\u7720\u7728\u77E9\u7830\u7827\u7838\u781D\u7834\u7837"],
    ["afa1", "\u7825\u782D\u7820\u781F\u7832\u7955\u7950\u7960\u795F\u7956\u795E\u795D\u7957\u795A\u79E4\u79E3\u79E7\u79DF\u79E6\u79E9\u79D8\u7A84\u7A88\u7AD9\u7B06\u7B11\u7C89\u7D21\u7D17\u7D0B\u7D0A\u7D20\u7D22\u7D14\u7D10\u7D15\u7D1A\u7D1C\u7D0D\u7D19\u7D1B\u7F3A\u7F5F\u7F94\u7FC5\u7FC1\u8006\u8018\u8015\u8019\u8017\u803D\u803F\u80F1\u8102\u80F0\u8105\u80ED\u80F4\u8106\u80F8\u80F3\u8108\u80FD\u810A\u80FC\u80EF\u81ED\u81EC\u8200\u8210\u822A\u822B\u8228\u822C\u82BB\u832B\u8352\u8354\u834A\u8338\u8350\u8349\u8335\u8334\u834F\u8332\u8339\u8336\u8317\u8340\u8331\u8328\u8343"],
    ["b040", "\u8654\u868A\u86AA\u8693\u86A4\u86A9\u868C\u86A3\u869C\u8870\u8877\u8881\u8882\u887D\u8879\u8A18\u8A10\u8A0E\u8A0C\u8A15\u8A0A\u8A17\u8A13\u8A16\u8A0F\u8A11\u8C48\u8C7A\u8C79\u8CA1\u8CA2\u8D77\u8EAC\u8ED2\u8ED4\u8ECF\u8FB1\u9001\u9006\u8FF7\u9000\u8FFA\u8FF4\u9003\u8FFD\u9005\u8FF8\u9095\u90E1\u90DD\u90E2\u9152\u914D\u914C\u91D8\u91DD\u91D7\u91DC\u91D9\u9583\u9662\u9663\u9661"],
    ["b0a1", "\u965B\u965D\u9664\u9658\u965E\u96BB\u98E2\u99AC\u9AA8\u9AD8\u9B25\u9B32\u9B3C\u4E7E\u507A\u507D\u505C\u5047\u5043\u504C\u505A\u5049\u5065\u5076\u504E\u5055\u5075\u5074\u5077\u504F\u500F\u506F\u506D\u515C\u5195\u51F0\u526A\u526F\u52D2\u52D9\u52D8\u52D5\u5310\u530F\u5319\u533F\u5340\u533E\u53C3\u66FC\u5546\u556A\u5566\u5544\u555E\u5561\u5543\u554A\u5531\u5556\u554F\u5555\u552F\u5564\u5538\u552E\u555C\u552C\u5563\u5533\u5541\u5557\u5708\u570B\u5709\u57DF\u5805\u580A\u5806\u57E0\u57E4\u57FA\u5802\u5835\u57F7\u57F9\u5920\u5962\u5A36\u5A41\u5A49\u5A66\u5A6A\u5A40"],
    ["b140", "\u5A3C\u5A62\u5A5A\u5A46\u5A4A\u5B70\u5BC7\u5BC5\u5BC4\u5BC2\u5BBF\u5BC6\u5C09\u5C08\u5C07\u5C60\u5C5C\u5C5D\u5D07\u5D06\u5D0E\u5D1B\u5D16\u5D22\u5D11\u5D29\u5D14\u5D19\u5D24\u5D27\u5D17\u5DE2\u5E38\u5E36\u5E33\u5E37\u5EB7\u5EB8\u5EB6\u5EB5\u5EBE\u5F35\u5F37\u5F57\u5F6C\u5F69\u5F6B\u5F97\u5F99\u5F9E\u5F98\u5FA1\u5FA0\u5F9C\u607F\u60A3\u6089\u60A0\u60A8\u60CB\u60B4\u60E6\u60BD"],
    ["b1a1", "\u60C5\u60BB\u60B5\u60DC\u60BC\u60D8\u60D5\u60C6\u60DF\u60B8\u60DA\u60C7\u621A\u621B\u6248\u63A0\u63A7\u6372\u6396\u63A2\u63A5\u6377\u6367\u6398\u63AA\u6371\u63A9\u6389\u6383\u639B\u636B\u63A8\u6384\u6388\u6399\u63A1\u63AC\u6392\u638F\u6380\u637B\u6369\u6368\u637A\u655D\u6556\u6551\u6559\u6557\u555F\u654F\u6558\u6555\u6554\u659C\u659B\u65AC\u65CF\u65CB\u65CC\u65CE\u665D\u665A\u6664\u6668\u6666\u665E\u66F9\u52D7\u671B\u6881\u68AF\u68A2\u6893\u68B5\u687F\u6876\u68B1\u68A7\u6897\u68B0\u6883\u68C4\u68AD\u6886\u6885\u6894\u689D\u68A8\u689F\u68A1\u6882\u6B32\u6BBA"],
    ["b240", "\u6BEB\u6BEC\u6C2B\u6D8E\u6DBC\u6DF3\u6DD9\u6DB2\u6DE1\u6DCC\u6DE4\u6DFB\u6DFA\u6E05\u6DC7\u6DCB\u6DAF\u6DD1\u6DAE\u6DDE\u6DF9\u6DB8\u6DF7\u6DF5\u6DC5\u6DD2\u6E1A\u6DB5\u6DDA\u6DEB\u6DD8\u6DEA\u6DF1\u6DEE\u6DE8\u6DC6\u6DC4\u6DAA\u6DEC\u6DBF\u6DE6\u70F9\u7109\u710A\u70FD\u70EF\u723D\u727D\u7281\u731C\u731B\u7316\u7313\u7319\u7387\u7405\u740A\u7403\u7406\u73FE\u740D\u74E0\u74F6"],
    ["b2a1", "\u74F7\u751C\u7522\u7565\u7566\u7562\u7570\u758F\u75D4\u75D5\u75B5\u75CA\u75CD\u768E\u76D4\u76D2\u76DB\u7737\u773E\u773C\u7736\u7738\u773A\u786B\u7843\u784E\u7965\u7968\u796D\u79FB\u7A92\u7A95\u7B20\u7B28\u7B1B\u7B2C\u7B26\u7B19\u7B1E\u7B2E\u7C92\u7C97\u7C95\u7D46\u7D43\u7D71\u7D2E\u7D39\u7D3C\u7D40\u7D30\u7D33\u7D44\u7D2F\u7D42\u7D32\u7D31\u7F3D\u7F9E\u7F9A\u7FCC\u7FCE\u7FD2\u801C\u804A\u8046\u812F\u8116\u8123\u812B\u8129\u8130\u8124\u8202\u8235\u8237\u8236\u8239\u838E\u839E\u8398\u8378\u83A2\u8396\u83BD\u83AB\u8392\u838A\u8393\u8389\u83A0\u8377\u837B\u837C"],
    ["b340", "\u8386\u83A7\u8655\u5F6A\u86C7\u86C0\u86B6\u86C4\u86B5\u86C6\u86CB\u86B1\u86AF\u86C9\u8853\u889E\u8888\u88AB\u8892\u8896\u888D\u888B\u8993\u898F\u8A2A\u8A1D\u8A23\u8A25\u8A31\u8A2D\u8A1F\u8A1B\u8A22\u8C49\u8C5A\u8CA9\u8CAC\u8CAB\u8CA8\u8CAA\u8CA7\u8D67\u8D66\u8DBE\u8DBA\u8EDB\u8EDF\u9019\u900D\u901A\u9017\u9023\u901F\u901D\u9010\u9015\u901E\u9020\u900F\u9022\u9016\u901B\u9014"],
    ["b3a1", "\u90E8\u90ED\u90FD\u9157\u91CE\u91F5\u91E6\u91E3\u91E7\u91ED\u91E9\u9589\u966A\u9675\u9673\u9678\u9670\u9674\u9676\u9677\u966C\u96C0\u96EA\u96E9\u7AE0\u7ADF\u9802\u9803\u9B5A\u9CE5\u9E75\u9E7F\u9EA5\u9EBB\u50A2\u508D\u5085\u5099\u5091\u5080\u5096\u5098\u509A\u6700\u51F1\u5272\u5274\u5275\u5269\u52DE\u52DD\u52DB\u535A\u53A5\u557B\u5580\u55A7\u557C\u558A\u559D\u5598\u5582\u559C\u55AA\u5594\u5587\u558B\u5583\u55B3\u55AE\u559F\u553E\u55B2\u559A\u55BB\u55AC\u55B1\u557E\u5589\u55AB\u5599\u570D\u582F\u582A\u5834\u5824\u5830\u5831\u5821\u581D\u5820\u58F9\u58FA\u5960"],
    ["b440", "\u5A77\u5A9A\u5A7F\u5A92\u5A9B\u5AA7\u5B73\u5B71\u5BD2\u5BCC\u5BD3\u5BD0\u5C0A\u5C0B\u5C31\u5D4C\u5D50\u5D34\u5D47\u5DFD\u5E45\u5E3D\u5E40\u5E43\u5E7E\u5ECA\u5EC1\u5EC2\u5EC4\u5F3C\u5F6D\u5FA9\u5FAA\u5FA8\u60D1\u60E1\u60B2\u60B6\u60E0\u611C\u6123\u60FA\u6115\u60F0\u60FB\u60F4\u6168\u60F1\u610E\u60F6\u6109\u6100\u6112\u621F\u6249\u63A3\u638C\u63CF\u63C0\u63E9\u63C9\u63C6\u63CD"],
    ["b4a1", "\u63D2\u63E3\u63D0\u63E1\u63D6\u63ED\u63EE\u6376\u63F4\u63EA\u63DB\u6452\u63DA\u63F9\u655E\u6566\u6562\u6563\u6591\u6590\u65AF\u666E\u6670\u6674\u6676\u666F\u6691\u667A\u667E\u6677\u66FE\u66FF\u671F\u671D\u68FA\u68D5\u68E0\u68D8\u68D7\u6905\u68DF\u68F5\u68EE\u68E7\u68F9\u68D2\u68F2\u68E3\u68CB\u68CD\u690D\u6912\u690E\u68C9\u68DA\u696E\u68FB\u6B3E\u6B3A\u6B3D\u6B98\u6B96\u6BBC\u6BEF\u6C2E\u6C2F\u6C2C\u6E2F\u6E38\u6E54\u6E21\u6E32\u6E67\u6E4A\u6E20\u6E25\u6E23\u6E1B\u6E5B\u6E58\u6E24\u6E56\u6E6E\u6E2D\u6E26\u6E6F\u6E34\u6E4D\u6E3A\u6E2C\u6E43\u6E1D\u6E3E\u6ECB"],
    ["b540", "\u6E89\u6E19\u6E4E\u6E63\u6E44\u6E72\u6E69\u6E5F\u7119\u711A\u7126\u7130\u7121\u7136\u716E\u711C\u724C\u7284\u7280\u7336\u7325\u7334\u7329\u743A\u742A\u7433\u7422\u7425\u7435\u7436\u7434\u742F\u741B\u7426\u7428\u7525\u7526\u756B\u756A\u75E2\u75DB\u75E3\u75D9\u75D8\u75DE\u75E0\u767B\u767C\u7696\u7693\u76B4\u76DC\u774F\u77ED\u785D\u786C\u786F\u7A0D\u7A08\u7A0B\u7A05\u7A00\u7A98"],
    ["b5a1", "\u7A97\u7A96\u7AE5\u7AE3\u7B49\u7B56\u7B46\u7B50\u7B52\u7B54\u7B4D\u7B4B\u7B4F\u7B51\u7C9F\u7CA5\u7D5E\u7D50\u7D68\u7D55\u7D2B\u7D6E\u7D72\u7D61\u7D66\u7D62\u7D70\u7D73\u5584\u7FD4\u7FD5\u800B\u8052\u8085\u8155\u8154\u814B\u8151\u814E\u8139\u8146\u813E\u814C\u8153\u8174\u8212\u821C\u83E9\u8403\u83F8\u840D\u83E0\u83C5\u840B\u83C1\u83EF\u83F1\u83F4\u8457\u840A\u83F0\u840C\u83CC\u83FD\u83F2\u83CA\u8438\u840E\u8404\u83DC\u8407\u83D4\u83DF\u865B\u86DF\u86D9\u86ED\u86D4\u86DB\u86E4\u86D0\u86DE\u8857\u88C1\u88C2\u88B1\u8983\u8996\u8A3B\u8A60\u8A55\u8A5E\u8A3C\u8A41"],
    ["b640", "\u8A54\u8A5B\u8A50\u8A46\u8A34\u8A3A\u8A36\u8A56\u8C61\u8C82\u8CAF\u8CBC\u8CB3\u8CBD\u8CC1\u8CBB\u8CC0\u8CB4\u8CB7\u8CB6\u8CBF\u8CB8\u8D8A\u8D85\u8D81\u8DCE\u8DDD\u8DCB\u8DDA\u8DD1\u8DCC\u8DDB\u8DC6\u8EFB\u8EF8\u8EFC\u8F9C\u902E\u9035\u9031\u9038\u9032\u9036\u9102\u90F5\u9109\u90FE\u9163\u9165\u91CF\u9214\u9215\u9223\u9209\u921E\u920D\u9210\u9207\u9211\u9594\u958F\u958B\u9591"],
    ["b6a1", "\u9593\u9592\u958E\u968A\u968E\u968B\u967D\u9685\u9686\u968D\u9672\u9684\u96C1\u96C5\u96C4\u96C6\u96C7\u96EF\u96F2\u97CC\u9805\u9806\u9808\u98E7\u98EA\u98EF\u98E9\u98F2\u98ED\u99AE\u99AD\u9EC3\u9ECD\u9ED1\u4E82\u50AD\u50B5\u50B2\u50B3\u50C5\u50BE\u50AC\u50B7\u50BB\u50AF\u50C7\u527F\u5277\u527D\u52DF\u52E6\u52E4\u52E2\u52E3\u532F\u55DF\u55E8\u55D3\u55E6\u55CE\u55DC\u55C7\u55D1\u55E3\u55E4\u55EF\u55DA\u55E1\u55C5\u55C6\u55E5\u55C9\u5712\u5713\u585E\u5851\u5858\u5857\u585A\u5854\u586B\u584C\u586D\u584A\u5862\u5852\u584B\u5967\u5AC1\u5AC9\u5ACC\u5ABE\u5ABD\u5ABC"],
    ["b740", "\u5AB3\u5AC2\u5AB2\u5D69\u5D6F\u5E4C\u5E79\u5EC9\u5EC8\u5F12\u5F59\u5FAC\u5FAE\u611A\u610F\u6148\u611F\u60F3\u611B\u60F9\u6101\u6108\u614E\u614C\u6144\u614D\u613E\u6134\u6127\u610D\u6106\u6137\u6221\u6222\u6413\u643E\u641E\u642A\u642D\u643D\u642C\u640F\u641C\u6414\u640D\u6436\u6416\u6417\u6406\u656C\u659F\u65B0\u6697\u6689\u6687\u6688\u6696\u6684\u6698\u668D\u6703\u6994\u696D"],
    ["b7a1", "\u695A\u6977\u6960\u6954\u6975\u6930\u6982\u694A\u6968\u696B\u695E\u6953\u6979\u6986\u695D\u6963\u695B\u6B47\u6B72\u6BC0\u6BBF\u6BD3\u6BFD\u6EA2\u6EAF\u6ED3\u6EB6\u6EC2\u6E90\u6E9D\u6EC7\u6EC5\u6EA5\u6E98\u6EBC\u6EBA\u6EAB\u6ED1\u6E96\u6E9C\u6EC4\u6ED4\u6EAA\u6EA7\u6EB4\u714E\u7159\u7169\u7164\u7149\u7167\u715C\u716C\u7166\u714C\u7165\u715E\u7146\u7168\u7156\u723A\u7252\u7337\u7345\u733F\u733E\u746F\u745A\u7455\u745F\u745E\u7441\u743F\u7459\u745B\u745C\u7576\u7578\u7600\u75F0\u7601\u75F2\u75F1\u75FA\u75FF\u75F4\u75F3\u76DE\u76DF\u775B\u776B\u7766\u775E\u7763"],
    ["b840", "\u7779\u776A\u776C\u775C\u7765\u7768\u7762\u77EE\u788E\u78B0\u7897\u7898\u788C\u7889\u787C\u7891\u7893\u787F\u797A\u797F\u7981\u842C\u79BD\u7A1C\u7A1A\u7A20\u7A14\u7A1F\u7A1E\u7A9F\u7AA0\u7B77\u7BC0\u7B60\u7B6E\u7B67\u7CB1\u7CB3\u7CB5\u7D93\u7D79\u7D91\u7D81\u7D8F\u7D5B\u7F6E\u7F69\u7F6A\u7F72\u7FA9\u7FA8\u7FA4\u8056\u8058\u8086\u8084\u8171\u8170\u8178\u8165\u816E\u8173\u816B"],
    ["b8a1", "\u8179\u817A\u8166\u8205\u8247\u8482\u8477\u843D\u8431\u8475\u8466\u846B\u8449\u846C\u845B\u843C\u8435\u8461\u8463\u8469\u846D\u8446\u865E\u865C\u865F\u86F9\u8713\u8708\u8707\u8700\u86FE\u86FB\u8702\u8703\u8706\u870A\u8859\u88DF\u88D4\u88D9\u88DC\u88D8\u88DD\u88E1\u88CA\u88D5\u88D2\u899C\u89E3\u8A6B\u8A72\u8A73\u8A66\u8A69\u8A70\u8A87\u8A7C\u8A63\u8AA0\u8A71\u8A85\u8A6D\u8A62\u8A6E\u8A6C\u8A79\u8A7B\u8A3E\u8A68\u8C62\u8C8A\u8C89\u8CCA\u8CC7\u8CC8\u8CC4\u8CB2\u8CC3\u8CC2\u8CC5\u8DE1\u8DDF\u8DE8\u8DEF\u8DF3\u8DFA\u8DEA\u8DE4\u8DE6\u8EB2\u8F03\u8F09\u8EFE\u8F0A"],
    ["b940", "\u8F9F\u8FB2\u904B\u904A\u9053\u9042\u9054\u903C\u9055\u9050\u9047\u904F\u904E\u904D\u9051\u903E\u9041\u9112\u9117\u916C\u916A\u9169\u91C9\u9237\u9257\u9238\u923D\u9240\u923E\u925B\u924B\u9264\u9251\u9234\u9249\u924D\u9245\u9239\u923F\u925A\u9598\u9698\u9694\u9695\u96CD\u96CB\u96C9\u96CA\u96F7\u96FB\u96F9\u96F6\u9756\u9774\u9776\u9810\u9811\u9813\u980A\u9812\u980C\u98FC\u98F4"],
    ["b9a1", "\u98FD\u98FE\u99B3\u99B1\u99B4\u9AE1\u9CE9\u9E82\u9F0E\u9F13\u9F20\u50E7\u50EE\u50E5\u50D6\u50ED\u50DA\u50D5\u50CF\u50D1\u50F1\u50CE\u50E9\u5162\u51F3\u5283\u5282\u5331\u53AD\u55FE\u5600\u561B\u5617\u55FD\u5614\u5606\u5609\u560D\u560E\u55F7\u5616\u561F\u5608\u5610\u55F6\u5718\u5716\u5875\u587E\u5883\u5893\u588A\u5879\u5885\u587D\u58FD\u5925\u5922\u5924\u596A\u5969\u5AE1\u5AE6\u5AE9\u5AD7\u5AD6\u5AD8\u5AE3\u5B75\u5BDE\u5BE7\u5BE1\u5BE5\u5BE6\u5BE8\u5BE2\u5BE4\u5BDF\u5C0D\u5C62\u5D84\u5D87\u5E5B\u5E63\u5E55\u5E57\u5E54\u5ED3\u5ED6\u5F0A\u5F46\u5F70\u5FB9\u6147"],
    ["ba40", "\u613F\u614B\u6177\u6162\u6163\u615F\u615A\u6158\u6175\u622A\u6487\u6458\u6454\u64A4\u6478\u645F\u647A\u6451\u6467\u6434\u646D\u647B\u6572\u65A1\u65D7\u65D6\u66A2\u66A8\u669D\u699C\u69A8\u6995\u69C1\u69AE\u69D3\u69CB\u699B\u69B7\u69BB\u69AB\u69B4\u69D0\u69CD\u69AD\u69CC\u69A6\u69C3\u69A3\u6B49\u6B4C\u6C33\u6F33\u6F14\u6EFE\u6F13\u6EF4\u6F29\u6F3E\u6F20\u6F2C\u6F0F\u6F02\u6F22"],
    ["baa1", "\u6EFF\u6EEF\u6F06\u6F31\u6F38\u6F32\u6F23\u6F15\u6F2B\u6F2F\u6F88\u6F2A\u6EEC\u6F01\u6EF2\u6ECC\u6EF7\u7194\u7199\u717D\u718A\u7184\u7192\u723E\u7292\u7296\u7344\u7350\u7464\u7463\u746A\u7470\u746D\u7504\u7591\u7627\u760D\u760B\u7609\u7613\u76E1\u76E3\u7784\u777D\u777F\u7761\u78C1\u789F\u78A7\u78B3\u78A9\u78A3\u798E\u798F\u798D\u7A2E\u7A31\u7AAA\u7AA9\u7AED\u7AEF\u7BA1\u7B95\u7B8B\u7B75\u7B97\u7B9D\u7B94\u7B8F\u7BB8\u7B87\u7B84\u7CB9\u7CBD\u7CBE\u7DBB\u7DB0\u7D9C\u7DBD\u7DBE\u7DA0\u7DCA\u7DB4\u7DB2\u7DB1\u7DBA\u7DA2\u7DBF\u7DB5\u7DB8\u7DAD\u7DD2\u7DC7\u7DAC"],
    ["bb40", "\u7F70\u7FE0\u7FE1\u7FDF\u805E\u805A\u8087\u8150\u8180\u818F\u8188\u818A\u817F\u8182\u81E7\u81FA\u8207\u8214\u821E\u824B\u84C9\u84BF\u84C6\u84C4\u8499\u849E\u84B2\u849C\u84CB\u84B8\u84C0\u84D3\u8490\u84BC\u84D1\u84CA\u873F\u871C\u873B\u8722\u8725\u8734\u8718\u8755\u8737\u8729\u88F3\u8902\u88F4\u88F9\u88F8\u88FD\u88E8\u891A\u88EF\u8AA6\u8A8C\u8A9E\u8AA3\u8A8D\u8AA1\u8A93\u8AA4"],
    ["bba1", "\u8AAA\u8AA5\u8AA8\u8A98\u8A91\u8A9A\u8AA7\u8C6A\u8C8D\u8C8C\u8CD3\u8CD1\u8CD2\u8D6B\u8D99\u8D95\u8DFC\u8F14\u8F12\u8F15\u8F13\u8FA3\u9060\u9058\u905C\u9063\u9059\u905E\u9062\u905D\u905B\u9119\u9118\u911E\u9175\u9178\u9177\u9174\u9278\u9280\u9285\u9298\u9296\u927B\u9293\u929C\u92A8\u927C\u9291\u95A1\u95A8\u95A9\u95A3\u95A5\u95A4\u9699\u969C\u969B\u96CC\u96D2\u9700\u977C\u9785\u97F6\u9817\u9818\u98AF\u98B1\u9903\u9905\u990C\u9909\u99C1\u9AAF\u9AB0\u9AE6\u9B41\u9B42\u9CF4\u9CF6\u9CF3\u9EBC\u9F3B\u9F4A\u5104\u5100\u50FB\u50F5\u50F9\u5102\u5108\u5109\u5105\u51DC"],
    ["bc40", "\u5287\u5288\u5289\u528D\u528A\u52F0\u53B2\u562E\u563B\u5639\u5632\u563F\u5634\u5629\u5653\u564E\u5657\u5674\u5636\u562F\u5630\u5880\u589F\u589E\u58B3\u589C\u58AE\u58A9\u58A6\u596D\u5B09\u5AFB\u5B0B\u5AF5\u5B0C\u5B08\u5BEE\u5BEC\u5BE9\u5BEB\u5C64\u5C65\u5D9D\u5D94\u5E62\u5E5F\u5E61\u5EE2\u5EDA\u5EDF\u5EDD\u5EE3\u5EE0\u5F48\u5F71\u5FB7\u5FB5\u6176\u6167\u616E\u615D\u6155\u6182"],
    ["bca1", "\u617C\u6170\u616B\u617E\u61A7\u6190\u61AB\u618E\u61AC\u619A\u61A4\u6194\u61AE\u622E\u6469\u646F\u6479\u649E\u64B2\u6488\u6490\u64B0\u64A5\u6493\u6495\u64A9\u6492\u64AE\u64AD\u64AB\u649A\u64AC\u6499\u64A2\u64B3\u6575\u6577\u6578\u66AE\u66AB\u66B4\u66B1\u6A23\u6A1F\u69E8\u6A01\u6A1E\u6A19\u69FD\u6A21\u6A13\u6A0A\u69F3\u6A02\u6A05\u69ED\u6A11\u6B50\u6B4E\u6BA4\u6BC5\u6BC6\u6F3F\u6F7C\u6F84\u6F51\u6F66\u6F54\u6F86\u6F6D\u6F5B\u6F78\u6F6E\u6F8E\u6F7A\u6F70\u6F64\u6F97\u6F58\u6ED5\u6F6F\u6F60\u6F5F\u719F\u71AC\u71B1\u71A8\u7256\u729B\u734E\u7357\u7469\u748B\u7483"],
    ["bd40", "\u747E\u7480\u757F\u7620\u7629\u761F\u7624\u7626\u7621\u7622\u769A\u76BA\u76E4\u778E\u7787\u778C\u7791\u778B\u78CB\u78C5\u78BA\u78CA\u78BE\u78D5\u78BC\u78D0\u7A3F\u7A3C\u7A40\u7A3D\u7A37\u7A3B\u7AAF\u7AAE\u7BAD\u7BB1\u7BC4\u7BB4\u7BC6\u7BC7\u7BC1\u7BA0\u7BCC\u7CCA\u7DE0\u7DF4\u7DEF\u7DFB\u7DD8\u7DEC\u7DDD\u7DE8\u7DE3\u7DDA\u7DDE\u7DE9\u7D9E\u7DD9\u7DF2\u7DF9\u7F75\u7F77\u7FAF"],
    ["bda1", "\u7FE9\u8026\u819B\u819C\u819D\u81A0\u819A\u8198\u8517\u853D\u851A\u84EE\u852C\u852D\u8513\u8511\u8523\u8521\u8514\u84EC\u8525\u84FF\u8506\u8782\u8774\u8776\u8760\u8766\u8778\u8768\u8759\u8757\u874C\u8753\u885B\u885D\u8910\u8907\u8912\u8913\u8915\u890A\u8ABC\u8AD2\u8AC7\u8AC4\u8A95\u8ACB\u8AF8\u8AB2\u8AC9\u8AC2\u8ABF\u8AB0\u8AD6\u8ACD\u8AB6\u8AB9\u8ADB\u8C4C\u8C4E\u8C6C\u8CE0\u8CDE\u8CE6\u8CE4\u8CEC\u8CED\u8CE2\u8CE3\u8CDC\u8CEA\u8CE1\u8D6D\u8D9F\u8DA3\u8E2B\u8E10\u8E1D\u8E22\u8E0F\u8E29\u8E1F\u8E21\u8E1E\u8EBA\u8F1D\u8F1B\u8F1F\u8F29\u8F26\u8F2A\u8F1C\u8F1E"],
    ["be40", "\u8F25\u9069\u906E\u9068\u906D\u9077\u9130\u912D\u9127\u9131\u9187\u9189\u918B\u9183\u92C5\u92BB\u92B7\u92EA\u92AC\u92E4\u92C1\u92B3\u92BC\u92D2\u92C7\u92F0\u92B2\u95AD\u95B1\u9704\u9706\u9707\u9709\u9760\u978D\u978B\u978F\u9821\u982B\u981C\u98B3\u990A\u9913\u9912\u9918\u99DD\u99D0\u99DF\u99DB\u99D1\u99D5\u99D2\u99D9\u9AB7\u9AEE\u9AEF\u9B27\u9B45\u9B44\u9B77\u9B6F\u9D06\u9D09"],
    ["bea1", "\u9D03\u9EA9\u9EBE\u9ECE\u58A8\u9F52\u5112\u5118\u5114\u5110\u5115\u5180\u51AA\u51DD\u5291\u5293\u52F3\u5659\u566B\u5679\u5669\u5664\u5678\u566A\u5668\u5665\u5671\u566F\u566C\u5662\u5676\u58C1\u58BE\u58C7\u58C5\u596E\u5B1D\u5B34\u5B78\u5BF0\u5C0E\u5F4A\u61B2\u6191\u61A9\u618A\u61CD\u61B6\u61BE\u61CA\u61C8\u6230\u64C5\u64C1\u64CB\u64BB\u64BC\u64DA\u64C4\u64C7\u64C2\u64CD\u64BF\u64D2\u64D4\u64BE\u6574\u66C6\u66C9\u66B9\u66C4\u66C7\u66B8\u6A3D\u6A38\u6A3A\u6A59\u6A6B\u6A58\u6A39\u6A44\u6A62\u6A61\u6A4B\u6A47\u6A35\u6A5F\u6A48\u6B59\u6B77\u6C05\u6FC2\u6FB1\u6FA1"],
    ["bf40", "\u6FC3\u6FA4\u6FC1\u6FA7\u6FB3\u6FC0\u6FB9\u6FB6\u6FA6\u6FA0\u6FB4\u71BE\u71C9\u71D0\u71D2\u71C8\u71D5\u71B9\u71CE\u71D9\u71DC\u71C3\u71C4\u7368\u749C\u74A3\u7498\u749F\u749E\u74E2\u750C\u750D\u7634\u7638\u763A\u76E7\u76E5\u77A0\u779E\u779F\u77A5\u78E8\u78DA\u78EC\u78E7\u79A6\u7A4D\u7A4E\u7A46\u7A4C\u7A4B\u7ABA\u7BD9\u7C11\u7BC9\u7BE4\u7BDB\u7BE1\u7BE9\u7BE6\u7CD5\u7CD6\u7E0A"],
    ["bfa1", "\u7E11\u7E08\u7E1B\u7E23\u7E1E\u7E1D\u7E09\u7E10\u7F79\u7FB2\u7FF0\u7FF1\u7FEE\u8028\u81B3\u81A9\u81A8\u81FB\u8208\u8258\u8259\u854A\u8559\u8548\u8568\u8569\u8543\u8549\u856D\u856A\u855E\u8783\u879F\u879E\u87A2\u878D\u8861\u892A\u8932\u8925\u892B\u8921\u89AA\u89A6\u8AE6\u8AFA\u8AEB\u8AF1\u8B00\u8ADC\u8AE7\u8AEE\u8AFE\u8B01\u8B02\u8AF7\u8AED\u8AF3\u8AF6\u8AFC\u8C6B\u8C6D\u8C93\u8CF4\u8E44\u8E31\u8E34\u8E42\u8E39\u8E35\u8F3B\u8F2F\u8F38\u8F33\u8FA8\u8FA6\u9075\u9074\u9078\u9072\u907C\u907A\u9134\u9192\u9320\u9336\u92F8\u9333\u932F\u9322\u92FC\u932B\u9304\u931A"],
    ["c040", "\u9310\u9326\u9321\u9315\u932E\u9319\u95BB\u96A7\u96A8\u96AA\u96D5\u970E\u9711\u9716\u970D\u9713\u970F\u975B\u975C\u9766\u9798\u9830\u9838\u983B\u9837\u982D\u9839\u9824\u9910\u9928\u991E\u991B\u9921\u991A\u99ED\u99E2\u99F1\u9AB8\u9ABC\u9AFB\u9AED\u9B28\u9B91\u9D15\u9D23\u9D26\u9D28\u9D12\u9D1B\u9ED8\u9ED4\u9F8D\u9F9C\u512A\u511F\u5121\u5132\u52F5\u568E\u5680\u5690\u5685\u5687"],
    ["c0a1", "\u568F\u58D5\u58D3\u58D1\u58CE\u5B30\u5B2A\u5B24\u5B7A\u5C37\u5C68\u5DBC\u5DBA\u5DBD\u5DB8\u5E6B\u5F4C\u5FBD\u61C9\u61C2\u61C7\u61E6\u61CB\u6232\u6234\u64CE\u64CA\u64D8\u64E0\u64F0\u64E6\u64EC\u64F1\u64E2\u64ED\u6582\u6583\u66D9\u66D6\u6A80\u6A94\u6A84\u6AA2\u6A9C\u6ADB\u6AA3\u6A7E\u6A97\u6A90\u6AA0\u6B5C\u6BAE\u6BDA\u6C08\u6FD8\u6FF1\u6FDF\u6FE0\u6FDB\u6FE4\u6FEB\u6FEF\u6F80\u6FEC\u6FE1\u6FE9\u6FD5\u6FEE\u6FF0\u71E7\u71DF\u71EE\u71E6\u71E5\u71ED\u71EC\u71F4\u71E0\u7235\u7246\u7370\u7372\u74A9\u74B0\u74A6\u74A8\u7646\u7642\u764C\u76EA\u77B3\u77AA\u77B0\u77AC"],
    ["c140", "\u77A7\u77AD\u77EF\u78F7\u78FA\u78F4\u78EF\u7901\u79A7\u79AA\u7A57\u7ABF\u7C07\u7C0D\u7BFE\u7BF7\u7C0C\u7BE0\u7CE0\u7CDC\u7CDE\u7CE2\u7CDF\u7CD9\u7CDD\u7E2E\u7E3E\u7E46\u7E37\u7E32\u7E43\u7E2B\u7E3D\u7E31\u7E45\u7E41\u7E34\u7E39\u7E48\u7E35\u7E3F\u7E2F\u7F44\u7FF3\u7FFC\u8071\u8072\u8070\u806F\u8073\u81C6\u81C3\u81BA\u81C2\u81C0\u81BF\u81BD\u81C9\u81BE\u81E8\u8209\u8271\u85AA"],
    ["c1a1", "\u8584\u857E\u859C\u8591\u8594\u85AF\u859B\u8587\u85A8\u858A\u8667\u87C0\u87D1\u87B3\u87D2\u87C6\u87AB\u87BB\u87BA\u87C8\u87CB\u893B\u8936\u8944\u8938\u893D\u89AC\u8B0E\u8B17\u8B19\u8B1B\u8B0A\u8B20\u8B1D\u8B04\u8B10\u8C41\u8C3F\u8C73\u8CFA\u8CFD\u8CFC\u8CF8\u8CFB\u8DA8\u8E49\u8E4B\u8E48\u8E4A\u8F44\u8F3E\u8F42\u8F45\u8F3F\u907F\u907D\u9084\u9081\u9082\u9080\u9139\u91A3\u919E\u919C\u934D\u9382\u9328\u9375\u934A\u9365\u934B\u9318\u937E\u936C\u935B\u9370\u935A\u9354\u95CA\u95CB\u95CC\u95C8\u95C6\u96B1\u96B8\u96D6\u971C\u971E\u97A0\u97D3\u9846\u98B6\u9935\u9A01"],
    ["c240", "\u99FF\u9BAE\u9BAB\u9BAA\u9BAD\u9D3B\u9D3F\u9E8B\u9ECF\u9EDE\u9EDC\u9EDD\u9EDB\u9F3E\u9F4B\u53E2\u5695\u56AE\u58D9\u58D8\u5B38\u5F5D\u61E3\u6233\u64F4\u64F2\u64FE\u6506\u64FA\u64FB\u64F7\u65B7\u66DC\u6726\u6AB3\u6AAC\u6AC3\u6ABB\u6AB8\u6AC2\u6AAE\u6AAF\u6B5F\u6B78\u6BAF\u7009\u700B\u6FFE\u7006\u6FFA\u7011\u700F\u71FB\u71FC\u71FE\u71F8\u7377\u7375\u74A7\u74BF\u7515\u7656\u7658"],
    ["c2a1", "\u7652\u77BD\u77BF\u77BB\u77BC\u790E\u79AE\u7A61\u7A62\u7A60\u7AC4\u7AC5\u7C2B\u7C27\u7C2A\u7C1E\u7C23\u7C21\u7CE7\u7E54\u7E55\u7E5E\u7E5A\u7E61\u7E52\u7E59\u7F48\u7FF9\u7FFB\u8077\u8076\u81CD\u81CF\u820A\u85CF\u85A9\u85CD\u85D0\u85C9\u85B0\u85BA\u85B9\u85A6\u87EF\u87EC\u87F2\u87E0\u8986\u89B2\u89F4\u8B28\u8B39\u8B2C\u8B2B\u8C50\u8D05\u8E59\u8E63\u8E66\u8E64\u8E5F\u8E55\u8EC0\u8F49\u8F4D\u9087\u9083\u9088\u91AB\u91AC\u91D0\u9394\u938A\u9396\u93A2\u93B3\u93AE\u93AC\u93B0\u9398\u939A\u9397\u95D4\u95D6\u95D0\u95D5\u96E2\u96DC\u96D9\u96DB\u96DE\u9724\u97A3\u97A6"],
    ["c340", "\u97AD\u97F9\u984D\u984F\u984C\u984E\u9853\u98BA\u993E\u993F\u993D\u992E\u99A5\u9A0E\u9AC1\u9B03\u9B06\u9B4F\u9B4E\u9B4D\u9BCA\u9BC9\u9BFD\u9BC8\u9BC0\u9D51\u9D5D\u9D60\u9EE0\u9F15\u9F2C\u5133\u56A5\u58DE\u58DF\u58E2\u5BF5\u9F90\u5EEC\u61F2\u61F7\u61F6\u61F5\u6500\u650F\u66E0\u66DD\u6AE5\u6ADD\u6ADA\u6AD3\u701B\u701F\u7028\u701A\u701D\u7015\u7018\u7206\u720D\u7258\u72A2\u7378"],
    ["c3a1", "\u737A\u74BD\u74CA\u74E3\u7587\u7586\u765F\u7661\u77C7\u7919\u79B1\u7A6B\u7A69\u7C3E\u7C3F\u7C38\u7C3D\u7C37\u7C40\u7E6B\u7E6D\u7E79\u7E69\u7E6A\u7F85\u7E73\u7FB6\u7FB9\u7FB8\u81D8\u85E9\u85DD\u85EA\u85D5\u85E4\u85E5\u85F7\u87FB\u8805\u880D\u87F9\u87FE\u8960\u895F\u8956\u895E\u8B41\u8B5C\u8B58\u8B49\u8B5A\u8B4E\u8B4F\u8B46\u8B59\u8D08\u8D0A\u8E7C\u8E72\u8E87\u8E76\u8E6C\u8E7A\u8E74\u8F54\u8F4E\u8FAD\u908A\u908B\u91B1\u91AE\u93E1\u93D1\u93DF\u93C3\u93C8\u93DC\u93DD\u93D6\u93E2\u93CD\u93D8\u93E4\u93D7\u93E8\u95DC\u96B4\u96E3\u972A\u9727\u9761\u97DC\u97FB\u985E"],
    ["c440", "\u9858\u985B\u98BC\u9945\u9949\u9A16\u9A19\u9B0D\u9BE8\u9BE7\u9BD6\u9BDB\u9D89\u9D61\u9D72\u9D6A\u9D6C\u9E92\u9E97\u9E93\u9EB4\u52F8\u56A8\u56B7\u56B6\u56B4\u56BC\u58E4\u5B40\u5B43\u5B7D\u5BF6\u5DC9\u61F8\u61FA\u6518\u6514\u6519\u66E6\u6727\u6AEC\u703E\u7030\u7032\u7210\u737B\u74CF\u7662\u7665\u7926\u792A\u792C\u792B\u7AC7\u7AF6\u7C4C\u7C43\u7C4D\u7CEF\u7CF0\u8FAE\u7E7D\u7E7C"],
    ["c4a1", "\u7E82\u7F4C\u8000\u81DA\u8266\u85FB\u85F9\u8611\u85FA\u8606\u860B\u8607\u860A\u8814\u8815\u8964\u89BA\u89F8\u8B70\u8B6C\u8B66\u8B6F\u8B5F\u8B6B\u8D0F\u8D0D\u8E89\u8E81\u8E85\u8E82\u91B4\u91CB\u9418\u9403\u93FD\u95E1\u9730\u98C4\u9952\u9951\u99A8\u9A2B\u9A30\u9A37\u9A35\u9C13\u9C0D\u9E79\u9EB5\u9EE8\u9F2F\u9F5F\u9F63\u9F61\u5137\u5138\u56C1\u56C0\u56C2\u5914\u5C6C\u5DCD\u61FC\u61FE\u651D\u651C\u6595\u66E9\u6AFB\u6B04\u6AFA\u6BB2\u704C\u721B\u72A7\u74D6\u74D4\u7669\u77D3\u7C50\u7E8F\u7E8C\u7FBC\u8617\u862D\u861A\u8823\u8822\u8821\u881F\u896A\u896C\u89BD\u8B74"],
    ["c540", "\u8B77\u8B7D\u8D13\u8E8A\u8E8D\u8E8B\u8F5F\u8FAF\u91BA\u942E\u9433\u9435\u943A\u9438\u9432\u942B\u95E2\u9738\u9739\u9732\u97FF\u9867\u9865\u9957\u9A45\u9A43\u9A40\u9A3E\u9ACF\u9B54\u9B51\u9C2D\u9C25\u9DAF\u9DB4\u9DC2\u9DB8\u9E9D\u9EEF\u9F19\u9F5C\u9F66\u9F67\u513C\u513B\u56C8\u56CA\u56C9\u5B7F\u5DD4\u5DD2\u5F4E\u61FF\u6524\u6B0A\u6B61\u7051\u7058\u7380\u74E4\u758A\u766E\u766C"],
    ["c5a1", "\u79B3\u7C60\u7C5F\u807E\u807D\u81DF\u8972\u896F\u89FC\u8B80\u8D16\u8D17\u8E91\u8E93\u8F61\u9148\u9444\u9451\u9452\u973D\u973E\u97C3\u97C1\u986B\u9955\u9A55\u9A4D\u9AD2\u9B1A\u9C49\u9C31\u9C3E\u9C3B\u9DD3\u9DD7\u9F34\u9F6C\u9F6A\u9F94\u56CC\u5DD6\u6200\u6523\u652B\u652A\u66EC\u6B10\u74DA\u7ACA\u7C64\u7C63\u7C65\u7E93\u7E96\u7E94\u81E2\u8638\u863F\u8831\u8B8A\u9090\u908F\u9463\u9460\u9464\u9768\u986F\u995C\u9A5A\u9A5B\u9A57\u9AD3\u9AD4\u9AD1\u9C54\u9C57\u9C56\u9DE5\u9E9F\u9EF4\u56D1\u58E9\u652C\u705E\u7671\u7672\u77D7\u7F50\u7F88\u8836\u8839\u8862\u8B93\u8B92"],
    ["c640", "\u8B96\u8277\u8D1B\u91C0\u946A\u9742\u9748\u9744\u97C6\u9870\u9A5F\u9B22\u9B58\u9C5F\u9DF9\u9DFA\u9E7C\u9E7D\u9F07\u9F77\u9F72\u5EF3\u6B16\u7063\u7C6C\u7C6E\u883B\u89C0\u8EA1\u91C1\u9472\u9470\u9871\u995E\u9AD6\u9B23\u9ECC\u7064\u77DA\u8B9A\u9477\u97C9\u9A62\u9A65\u7E9C\u8B9C\u8EAA\u91C5\u947D\u947E\u947C\u9C77\u9C78\u9EF7\u8C54\u947F\u9E1A\u7228\u9A6A\u9B31\u9E1B\u9E1E\u7C72"],
    ["c940", "\u4E42\u4E5C\u51F5\u531A\u5382\u4E07\u4E0C\u4E47\u4E8D\u56D7\uFA0C\u5C6E\u5F73\u4E0F\u5187\u4E0E\u4E2E\u4E93\u4EC2\u4EC9\u4EC8\u5198\u52FC\u536C\u53B9\u5720\u5903\u592C\u5C10\u5DFF\u65E1\u6BB3\u6BCC\u6C14\u723F\u4E31\u4E3C\u4EE8\u4EDC\u4EE9\u4EE1\u4EDD\u4EDA\u520C\u531C\u534C\u5722\u5723\u5917\u592F\u5B81\u5B84\u5C12\u5C3B\u5C74\u5C73\u5E04\u5E80\u5E82\u5FC9\u6209\u6250\u6C15"],
    ["c9a1", "\u6C36\u6C43\u6C3F\u6C3B\u72AE\u72B0\u738A\u79B8\u808A\u961E\u4F0E\u4F18\u4F2C\u4EF5\u4F14\u4EF1\u4F00\u4EF7\u4F08\u4F1D\u4F02\u4F05\u4F22\u4F13\u4F04\u4EF4\u4F12\u51B1\u5213\u5209\u5210\u52A6\u5322\u531F\u534D\u538A\u5407\u56E1\u56DF\u572E\u572A\u5734\u593C\u5980\u597C\u5985\u597B\u597E\u5977\u597F\u5B56\u5C15\u5C25\u5C7C\u5C7A\u5C7B\u5C7E\u5DDF\u5E75\u5E84\u5F02\u5F1A\u5F74\u5FD5\u5FD4\u5FCF\u625C\u625E\u6264\u6261\u6266\u6262\u6259\u6260\u625A\u6265\u65EF\u65EE\u673E\u6739\u6738\u673B\u673A\u673F\u673C\u6733\u6C18\u6C46\u6C52\u6C5C\u6C4F\u6C4A\u6C54\u6C4B"],
    ["ca40", "\u6C4C\u7071\u725E\u72B4\u72B5\u738E\u752A\u767F\u7A75\u7F51\u8278\u827C\u8280\u827D\u827F\u864D\u897E\u9099\u9097\u9098\u909B\u9094\u9622\u9624\u9620\u9623\u4F56\u4F3B\u4F62\u4F49\u4F53\u4F64\u4F3E\u4F67\u4F52\u4F5F\u4F41\u4F58\u4F2D\u4F33\u4F3F\u4F61\u518F\u51B9\u521C\u521E\u5221\u52AD\u52AE\u5309\u5363\u5372\u538E\u538F\u5430\u5437\u542A\u5454\u5445\u5419\u541C\u5425\u5418"],
    ["caa1", "\u543D\u544F\u5441\u5428\u5424\u5447\u56EE\u56E7\u56E5\u5741\u5745\u574C\u5749\u574B\u5752\u5906\u5940\u59A6\u5998\u59A0\u5997\u598E\u59A2\u5990\u598F\u59A7\u59A1\u5B8E\u5B92\u5C28\u5C2A\u5C8D\u5C8F\u5C88\u5C8B\u5C89\u5C92\u5C8A\u5C86\u5C93\u5C95\u5DE0\u5E0A\u5E0E\u5E8B\u5E89\u5E8C\u5E88\u5E8D\u5F05\u5F1D\u5F78\u5F76\u5FD2\u5FD1\u5FD0\u5FED\u5FE8\u5FEE\u5FF3\u5FE1\u5FE4\u5FE3\u5FFA\u5FEF\u5FF7\u5FFB\u6000\u5FF4\u623A\u6283\u628C\u628E\u628F\u6294\u6287\u6271\u627B\u627A\u6270\u6281\u6288\u6277\u627D\u6272\u6274\u6537\u65F0\u65F4\u65F3\u65F2\u65F5\u6745\u6747"],
    ["cb40", "\u6759\u6755\u674C\u6748\u675D\u674D\u675A\u674B\u6BD0\u6C19\u6C1A\u6C78\u6C67\u6C6B\u6C84\u6C8B\u6C8F\u6C71\u6C6F\u6C69\u6C9A\u6C6D\u6C87\u6C95\u6C9C\u6C66\u6C73\u6C65\u6C7B\u6C8E\u7074\u707A\u7263\u72BF\u72BD\u72C3\u72C6\u72C1\u72BA\u72C5\u7395\u7397\u7393\u7394\u7392\u753A\u7539\u7594\u7595\u7681\u793D\u8034\u8095\u8099\u8090\u8092\u809C\u8290\u828F\u8285\u828E\u8291\u8293"],
    ["cba1", "\u828A\u8283\u8284\u8C78\u8FC9\u8FBF\u909F\u90A1\u90A5\u909E\u90A7\u90A0\u9630\u9628\u962F\u962D\u4E33\u4F98\u4F7C\u4F85\u4F7D\u4F80\u4F87\u4F76\u4F74\u4F89\u4F84\u4F77\u4F4C\u4F97\u4F6A\u4F9A\u4F79\u4F81\u4F78\u4F90\u4F9C\u4F94\u4F9E\u4F92\u4F82\u4F95\u4F6B\u4F6E\u519E\u51BC\u51BE\u5235\u5232\u5233\u5246\u5231\u52BC\u530A\u530B\u533C\u5392\u5394\u5487\u547F\u5481\u5491\u5482\u5488\u546B\u547A\u547E\u5465\u546C\u5474\u5466\u548D\u546F\u5461\u5460\u5498\u5463\u5467\u5464\u56F7\u56F9\u576F\u5772\u576D\u576B\u5771\u5770\u5776\u5780\u5775\u577B\u5773\u5774\u5762"],
    ["cc40", "\u5768\u577D\u590C\u5945\u59B5\u59BA\u59CF\u59CE\u59B2\u59CC\u59C1\u59B6\u59BC\u59C3\u59D6\u59B1\u59BD\u59C0\u59C8\u59B4\u59C7\u5B62\u5B65\u5B93\u5B95\u5C44\u5C47\u5CAE\u5CA4\u5CA0\u5CB5\u5CAF\u5CA8\u5CAC\u5C9F\u5CA3\u5CAD\u5CA2\u5CAA\u5CA7\u5C9D\u5CA5\u5CB6\u5CB0\u5CA6\u5E17\u5E14\u5E19\u5F28\u5F22\u5F23\u5F24\u5F54\u5F82\u5F7E\u5F7D\u5FDE\u5FE5\u602D\u6026\u6019\u6032\u600B"],
    ["cca1", "\u6034\u600A\u6017\u6033\u601A\u601E\u602C\u6022\u600D\u6010\u602E\u6013\u6011\u600C\u6009\u601C\u6214\u623D\u62AD\u62B4\u62D1\u62BE\u62AA\u62B6\u62CA\u62AE\u62B3\u62AF\u62BB\u62A9\u62B0\u62B8\u653D\u65A8\u65BB\u6609\u65FC\u6604\u6612\u6608\u65FB\u6603\u660B\u660D\u6605\u65FD\u6611\u6610\u66F6\u670A\u6785\u676C\u678E\u6792\u6776\u677B\u6798\u6786\u6784\u6774\u678D\u678C\u677A\u679F\u6791\u6799\u6783\u677D\u6781\u6778\u6779\u6794\u6B25\u6B80\u6B7E\u6BDE\u6C1D\u6C93\u6CEC\u6CEB\u6CEE\u6CD9\u6CB6\u6CD4\u6CAD\u6CE7\u6CB7\u6CD0\u6CC2\u6CBA\u6CC3\u6CC6\u6CED\u6CF2"],
    ["cd40", "\u6CD2\u6CDD\u6CB4\u6C8A\u6C9D\u6C80\u6CDE\u6CC0\u6D30\u6CCD\u6CC7\u6CB0\u6CF9\u6CCF\u6CE9\u6CD1\u7094\u7098\u7085\u7093\u7086\u7084\u7091\u7096\u7082\u709A\u7083\u726A\u72D6\u72CB\u72D8\u72C9\u72DC\u72D2\u72D4\u72DA\u72CC\u72D1\u73A4\u73A1\u73AD\u73A6\u73A2\u73A0\u73AC\u739D\u74DD\u74E8\u753F\u7540\u753E\u758C\u7598\u76AF\u76F3\u76F1\u76F0\u76F5\u77F8\u77FC\u77F9\u77FB\u77FA"],
    ["cda1", "\u77F7\u7942\u793F\u79C5\u7A78\u7A7B\u7AFB\u7C75\u7CFD\u8035\u808F\u80AE\u80A3\u80B8\u80B5\u80AD\u8220\u82A0\u82C0\u82AB\u829A\u8298\u829B\u82B5\u82A7\u82AE\u82BC\u829E\u82BA\u82B4\u82A8\u82A1\u82A9\u82C2\u82A4\u82C3\u82B6\u82A2\u8670\u866F\u866D\u866E\u8C56\u8FD2\u8FCB\u8FD3\u8FCD\u8FD6\u8FD5\u8FD7\u90B2\u90B4\u90AF\u90B3\u90B0\u9639\u963D\u963C\u963A\u9643\u4FCD\u4FC5\u4FD3\u4FB2\u4FC9\u4FCB\u4FC1\u4FD4\u4FDC\u4FD9\u4FBB\u4FB3\u4FDB\u4FC7\u4FD6\u4FBA\u4FC0\u4FB9\u4FEC\u5244\u5249\u52C0\u52C2\u533D\u537C\u5397\u5396\u5399\u5398\u54BA\u54A1\u54AD\u54A5\u54CF"],
    ["ce40", "\u54C3\u830D\u54B7\u54AE\u54D6\u54B6\u54C5\u54C6\u54A0\u5470\u54BC\u54A2\u54BE\u5472\u54DE\u54B0\u57B5\u579E\u579F\u57A4\u578C\u5797\u579D\u579B\u5794\u5798\u578F\u5799\u57A5\u579A\u5795\u58F4\u590D\u5953\u59E1\u59DE\u59EE\u5A00\u59F1\u59DD\u59FA\u59FD\u59FC\u59F6\u59E4\u59F2\u59F7\u59DB\u59E9\u59F3\u59F5\u59E0\u59FE\u59F4\u59ED\u5BA8\u5C4C\u5CD0\u5CD8\u5CCC\u5CD7\u5CCB\u5CDB"],
    ["cea1", "\u5CDE\u5CDA\u5CC9\u5CC7\u5CCA\u5CD6\u5CD3\u5CD4\u5CCF\u5CC8\u5CC6\u5CCE\u5CDF\u5CF8\u5DF9\u5E21\u5E22\u5E23\u5E20\u5E24\u5EB0\u5EA4\u5EA2\u5E9B\u5EA3\u5EA5\u5F07\u5F2E\u5F56\u5F86\u6037\u6039\u6054\u6072\u605E\u6045\u6053\u6047\u6049\u605B\u604C\u6040\u6042\u605F\u6024\u6044\u6058\u6066\u606E\u6242\u6243\u62CF\u630D\u630B\u62F5\u630E\u6303\u62EB\u62F9\u630F\u630C\u62F8\u62F6\u6300\u6313\u6314\u62FA\u6315\u62FB\u62F0\u6541\u6543\u65AA\u65BF\u6636\u6621\u6632\u6635\u661C\u6626\u6622\u6633\u662B\u663A\u661D\u6634\u6639\u662E\u670F\u6710\u67C1\u67F2\u67C8\u67BA"],
    ["cf40", "\u67DC\u67BB\u67F8\u67D8\u67C0\u67B7\u67C5\u67EB\u67E4\u67DF\u67B5\u67CD\u67B3\u67F7\u67F6\u67EE\u67E3\u67C2\u67B9\u67CE\u67E7\u67F0\u67B2\u67FC\u67C6\u67ED\u67CC\u67AE\u67E6\u67DB\u67FA\u67C9\u67CA\u67C3\u67EA\u67CB\u6B28\u6B82\u6B84\u6BB6\u6BD6\u6BD8\u6BE0\u6C20\u6C21\u6D28\u6D34\u6D2D\u6D1F\u6D3C\u6D3F\u6D12\u6D0A\u6CDA\u6D33\u6D04\u6D19\u6D3A\u6D1A\u6D11\u6D00\u6D1D\u6D42"],
    ["cfa1", "\u6D01\u6D18\u6D37\u6D03\u6D0F\u6D40\u6D07\u6D20\u6D2C\u6D08\u6D22\u6D09\u6D10\u70B7\u709F\u70BE\u70B1\u70B0\u70A1\u70B4\u70B5\u70A9\u7241\u7249\u724A\u726C\u7270\u7273\u726E\u72CA\u72E4\u72E8\u72EB\u72DF\u72EA\u72E6\u72E3\u7385\u73CC\u73C2\u73C8\u73C5\u73B9\u73B6\u73B5\u73B4\u73EB\u73BF\u73C7\u73BE\u73C3\u73C6\u73B8\u73CB\u74EC\u74EE\u752E\u7547\u7548\u75A7\u75AA\u7679\u76C4\u7708\u7703\u7704\u7705\u770A\u76F7\u76FB\u76FA\u77E7\u77E8\u7806\u7811\u7812\u7805\u7810\u780F\u780E\u7809\u7803\u7813\u794A\u794C\u794B\u7945\u7944\u79D5\u79CD\u79CF\u79D6\u79CE\u7A80"],
    ["d040", "\u7A7E\u7AD1\u7B00\u7B01\u7C7A\u7C78\u7C79\u7C7F\u7C80\u7C81\u7D03\u7D08\u7D01\u7F58\u7F91\u7F8D\u7FBE\u8007\u800E\u800F\u8014\u8037\u80D8\u80C7\u80E0\u80D1\u80C8\u80C2\u80D0\u80C5\u80E3\u80D9\u80DC\u80CA\u80D5\u80C9\u80CF\u80D7\u80E6\u80CD\u81FF\u8221\u8294\u82D9\u82FE\u82F9\u8307\u82E8\u8300\u82D5\u833A\u82EB\u82D6\u82F4\u82EC\u82E1\u82F2\u82F5\u830C\u82FB\u82F6\u82F0\u82EA"],
    ["d0a1", "\u82E4\u82E0\u82FA\u82F3\u82ED\u8677\u8674\u867C\u8673\u8841\u884E\u8867\u886A\u8869\u89D3\u8A04\u8A07\u8D72\u8FE3\u8FE1\u8FEE\u8FE0\u90F1\u90BD\u90BF\u90D5\u90C5\u90BE\u90C7\u90CB\u90C8\u91D4\u91D3\u9654\u964F\u9651\u9653\u964A\u964E\u501E\u5005\u5007\u5013\u5022\u5030\u501B\u4FF5\u4FF4\u5033\u5037\u502C\u4FF6\u4FF7\u5017\u501C\u5020\u5027\u5035\u502F\u5031\u500E\u515A\u5194\u5193\u51CA\u51C4\u51C5\u51C8\u51CE\u5261\u525A\u5252\u525E\u525F\u5255\u5262\u52CD\u530E\u539E\u5526\u54E2\u5517\u5512\u54E7\u54F3\u54E4\u551A\u54FF\u5504\u5508\u54EB\u5511\u5505\u54F1"],
    ["d140", "\u550A\u54FB\u54F7\u54F8\u54E0\u550E\u5503\u550B\u5701\u5702\u57CC\u5832\u57D5\u57D2\u57BA\u57C6\u57BD\u57BC\u57B8\u57B6\u57BF\u57C7\u57D0\u57B9\u57C1\u590E\u594A\u5A19\u5A16\u5A2D\u5A2E\u5A15\u5A0F\u5A17\u5A0A\u5A1E\u5A33\u5B6C\u5BA7\u5BAD\u5BAC\u5C03\u5C56\u5C54\u5CEC\u5CFF\u5CEE\u5CF1\u5CF7\u5D00\u5CF9\u5E29\u5E28\u5EA8\u5EAE\u5EAA\u5EAC\u5F33\u5F30\u5F67\u605D\u605A\u6067"],
    ["d1a1", "\u6041\u60A2\u6088\u6080\u6092\u6081\u609D\u6083\u6095\u609B\u6097\u6087\u609C\u608E\u6219\u6246\u62F2\u6310\u6356\u632C\u6344\u6345\u6336\u6343\u63E4\u6339\u634B\u634A\u633C\u6329\u6341\u6334\u6358\u6354\u6359\u632D\u6347\u6333\u635A\u6351\u6338\u6357\u6340\u6348\u654A\u6546\u65C6\u65C3\u65C4\u65C2\u664A\u665F\u6647\u6651\u6712\u6713\u681F\u681A\u6849\u6832\u6833\u683B\u684B\u684F\u6816\u6831\u681C\u6835\u682B\u682D\u682F\u684E\u6844\u6834\u681D\u6812\u6814\u6826\u6828\u682E\u684D\u683A\u6825\u6820\u6B2C\u6B2F\u6B2D\u6B31\u6B34\u6B6D\u8082\u6B88\u6BE6\u6BE4"],
    ["d240", "\u6BE8\u6BE3\u6BE2\u6BE7\u6C25\u6D7A\u6D63\u6D64\u6D76\u6D0D\u6D61\u6D92\u6D58\u6D62\u6D6D\u6D6F\u6D91\u6D8D\u6DEF\u6D7F\u6D86\u6D5E\u6D67\u6D60\u6D97\u6D70\u6D7C\u6D5F\u6D82\u6D98\u6D2F\u6D68\u6D8B\u6D7E\u6D80\u6D84\u6D16\u6D83\u6D7B\u6D7D\u6D75\u6D90\u70DC\u70D3\u70D1\u70DD\u70CB\u7F39\u70E2\u70D7\u70D2\u70DE\u70E0\u70D4\u70CD\u70C5\u70C6\u70C7\u70DA\u70CE\u70E1\u7242\u7278"],
    ["d2a1", "\u7277\u7276\u7300\u72FA\u72F4\u72FE\u72F6\u72F3\u72FB\u7301\u73D3\u73D9\u73E5\u73D6\u73BC\u73E7\u73E3\u73E9\u73DC\u73D2\u73DB\u73D4\u73DD\u73DA\u73D7\u73D8\u73E8\u74DE\u74DF\u74F4\u74F5\u7521\u755B\u755F\u75B0\u75C1\u75BB\u75C4\u75C0\u75BF\u75B6\u75BA\u768A\u76C9\u771D\u771B\u7710\u7713\u7712\u7723\u7711\u7715\u7719\u771A\u7722\u7727\u7823\u782C\u7822\u7835\u782F\u7828\u782E\u782B\u7821\u7829\u7833\u782A\u7831\u7954\u795B\u794F\u795C\u7953\u7952\u7951\u79EB\u79EC\u79E0\u79EE\u79ED\u79EA\u79DC\u79DE\u79DD\u7A86\u7A89\u7A85\u7A8B\u7A8C\u7A8A\u7A87\u7AD8\u7B10"],
    ["d340", "\u7B04\u7B13\u7B05\u7B0F\u7B08\u7B0A\u7B0E\u7B09\u7B12\u7C84\u7C91\u7C8A\u7C8C\u7C88\u7C8D\u7C85\u7D1E\u7D1D\u7D11\u7D0E\u7D18\u7D16\u7D13\u7D1F\u7D12\u7D0F\u7D0C\u7F5C\u7F61\u7F5E\u7F60\u7F5D\u7F5B\u7F96\u7F92\u7FC3\u7FC2\u7FC0\u8016\u803E\u8039\u80FA\u80F2\u80F9\u80F5\u8101\u80FB\u8100\u8201\u822F\u8225\u8333\u832D\u8344\u8319\u8351\u8325\u8356\u833F\u8341\u8326\u831C\u8322"],
    ["d3a1", "\u8342\u834E\u831B\u832A\u8308\u833C\u834D\u8316\u8324\u8320\u8337\u832F\u8329\u8347\u8345\u834C\u8353\u831E\u832C\u834B\u8327\u8348\u8653\u8652\u86A2\u86A8\u8696\u868D\u8691\u869E\u8687\u8697\u8686\u868B\u869A\u8685\u86A5\u8699\u86A1\u86A7\u8695\u8698\u868E\u869D\u8690\u8694\u8843\u8844\u886D\u8875\u8876\u8872\u8880\u8871\u887F\u886F\u8883\u887E\u8874\u887C\u8A12\u8C47\u8C57\u8C7B\u8CA4\u8CA3\u8D76\u8D78\u8DB5\u8DB7\u8DB6\u8ED1\u8ED3\u8FFE\u8FF5\u9002\u8FFF\u8FFB\u9004\u8FFC\u8FF6\u90D6\u90E0\u90D9\u90DA\u90E3\u90DF\u90E5\u90D8\u90DB\u90D7\u90DC\u90E4\u9150"],
    ["d440", "\u914E\u914F\u91D5\u91E2\u91DA\u965C\u965F\u96BC\u98E3\u9ADF\u9B2F\u4E7F\u5070\u506A\u5061\u505E\u5060\u5053\u504B\u505D\u5072\u5048\u504D\u5041\u505B\u504A\u5062\u5015\u5045\u505F\u5069\u506B\u5063\u5064\u5046\u5040\u506E\u5073\u5057\u5051\u51D0\u526B\u526D\u526C\u526E\u52D6\u52D3\u532D\u539C\u5575\u5576\u553C\u554D\u5550\u5534\u552A\u5551\u5562\u5536\u5535\u5530\u5552\u5545"],
    ["d4a1", "\u550C\u5532\u5565\u554E\u5539\u5548\u552D\u553B\u5540\u554B\u570A\u5707\u57FB\u5814\u57E2\u57F6\u57DC\u57F4\u5800\u57ED\u57FD\u5808\u57F8\u580B\u57F3\u57CF\u5807\u57EE\u57E3\u57F2\u57E5\u57EC\u57E1\u580E\u57FC\u5810\u57E7\u5801\u580C\u57F1\u57E9\u57F0\u580D\u5804\u595C\u5A60\u5A58\u5A55\u5A67\u5A5E\u5A38\u5A35\u5A6D\u5A50\u5A5F\u5A65\u5A6C\u5A53\u5A64\u5A57\u5A43\u5A5D\u5A52\u5A44\u5A5B\u5A48\u5A8E\u5A3E\u5A4D\u5A39\u5A4C\u5A70\u5A69\u5A47\u5A51\u5A56\u5A42\u5A5C\u5B72\u5B6E\u5BC1\u5BC0\u5C59\u5D1E\u5D0B\u5D1D\u5D1A\u5D20\u5D0C\u5D28\u5D0D\u5D26\u5D25\u5D0F"],
    ["d540", "\u5D30\u5D12\u5D23\u5D1F\u5D2E\u5E3E\u5E34\u5EB1\u5EB4\u5EB9\u5EB2\u5EB3\u5F36\u5F38\u5F9B\u5F96\u5F9F\u608A\u6090\u6086\u60BE\u60B0\u60BA\u60D3\u60D4\u60CF\u60E4\u60D9\u60DD\u60C8\u60B1\u60DB\u60B7\u60CA\u60BF\u60C3\u60CD\u60C0\u6332\u6365\u638A\u6382\u637D\u63BD\u639E\u63AD\u639D\u6397\u63AB\u638E\u636F\u6387\u6390\u636E\u63AF\u6375\u639C\u636D\u63AE\u637C\u63A4\u633B\u639F"],
    ["d5a1", "\u6378\u6385\u6381\u6391\u638D\u6370\u6553\u65CD\u6665\u6661\u665B\u6659\u665C\u6662\u6718\u6879\u6887\u6890\u689C\u686D\u686E\u68AE\u68AB\u6956\u686F\u68A3\u68AC\u68A9\u6875\u6874\u68B2\u688F\u6877\u6892\u687C\u686B\u6872\u68AA\u6880\u6871\u687E\u689B\u6896\u688B\u68A0\u6889\u68A4\u6878\u687B\u6891\u688C\u688A\u687D\u6B36\u6B33\u6B37\u6B38\u6B91\u6B8F\u6B8D\u6B8E\u6B8C\u6C2A\u6DC0\u6DAB\u6DB4\u6DB3\u6E74\u6DAC\u6DE9\u6DE2\u6DB7\u6DF6\u6DD4\u6E00\u6DC8\u6DE0\u6DDF\u6DD6\u6DBE\u6DE5\u6DDC\u6DDD\u6DDB\u6DF4\u6DCA\u6DBD\u6DED\u6DF0\u6DBA\u6DD5\u6DC2\u6DCF\u6DC9"],
    ["d640", "\u6DD0\u6DF2\u6DD3\u6DFD\u6DD7\u6DCD\u6DE3\u6DBB\u70FA\u710D\u70F7\u7117\u70F4\u710C\u70F0\u7104\u70F3\u7110\u70FC\u70FF\u7106\u7113\u7100\u70F8\u70F6\u710B\u7102\u710E\u727E\u727B\u727C\u727F\u731D\u7317\u7307\u7311\u7318\u730A\u7308\u72FF\u730F\u731E\u7388\u73F6\u73F8\u73F5\u7404\u7401\u73FD\u7407\u7400\u73FA\u73FC\u73FF\u740C\u740B\u73F4\u7408\u7564\u7563\u75CE\u75D2\u75CF"],
    ["d6a1", "\u75CB\u75CC\u75D1\u75D0\u768F\u7689\u76D3\u7739\u772F\u772D\u7731\u7732\u7734\u7733\u773D\u7725\u773B\u7735\u7848\u7852\u7849\u784D\u784A\u784C\u7826\u7845\u7850\u7964\u7967\u7969\u796A\u7963\u796B\u7961\u79BB\u79FA\u79F8\u79F6\u79F7\u7A8F\u7A94\u7A90\u7B35\u7B47\u7B34\u7B25\u7B30\u7B22\u7B24\u7B33\u7B18\u7B2A\u7B1D\u7B31\u7B2B\u7B2D\u7B2F\u7B32\u7B38\u7B1A\u7B23\u7C94\u7C98\u7C96\u7CA3\u7D35\u7D3D\u7D38\u7D36\u7D3A\u7D45\u7D2C\u7D29\u7D41\u7D47\u7D3E\u7D3F\u7D4A\u7D3B\u7D28\u7F63\u7F95\u7F9C\u7F9D\u7F9B\u7FCA\u7FCB\u7FCD\u7FD0\u7FD1\u7FC7\u7FCF\u7FC9\u801F"],
    ["d740", "\u801E\u801B\u8047\u8043\u8048\u8118\u8125\u8119\u811B\u812D\u811F\u812C\u811E\u8121\u8115\u8127\u811D\u8122\u8211\u8238\u8233\u823A\u8234\u8232\u8274\u8390\u83A3\u83A8\u838D\u837A\u8373\u83A4\u8374\u838F\u8381\u8395\u8399\u8375\u8394\u83A9\u837D\u8383\u838C\u839D\u839B\u83AA\u838B\u837E\u83A5\u83AF\u8388\u8397\u83B0\u837F\u83A6\u8387\u83AE\u8376\u839A\u8659\u8656\u86BF\u86B7"],
    ["d7a1", "\u86C2\u86C1\u86C5\u86BA\u86B0\u86C8\u86B9\u86B3\u86B8\u86CC\u86B4\u86BB\u86BC\u86C3\u86BD\u86BE\u8852\u8889\u8895\u88A8\u88A2\u88AA\u889A\u8891\u88A1\u889F\u8898\u88A7\u8899\u889B\u8897\u88A4\u88AC\u888C\u8893\u888E\u8982\u89D6\u89D9\u89D5\u8A30\u8A27\u8A2C\u8A1E\u8C39\u8C3B\u8C5C\u8C5D\u8C7D\u8CA5\u8D7D\u8D7B\u8D79\u8DBC\u8DC2\u8DB9\u8DBF\u8DC1\u8ED8\u8EDE\u8EDD\u8EDC\u8ED7\u8EE0\u8EE1\u9024\u900B\u9011\u901C\u900C\u9021\u90EF\u90EA\u90F0\u90F4\u90F2\u90F3\u90D4\u90EB\u90EC\u90E9\u9156\u9158\u915A\u9153\u9155\u91EC\u91F4\u91F1\u91F3\u91F8\u91E4\u91F9\u91EA"],
    ["d840", "\u91EB\u91F7\u91E8\u91EE\u957A\u9586\u9588\u967C\u966D\u966B\u9671\u966F\u96BF\u976A\u9804\u98E5\u9997\u509B\u5095\u5094\u509E\u508B\u50A3\u5083\u508C\u508E\u509D\u5068\u509C\u5092\u5082\u5087\u515F\u51D4\u5312\u5311\u53A4\u53A7\u5591\u55A8\u55A5\u55AD\u5577\u5645\u55A2\u5593\u5588\u558F\u55B5\u5581\u55A3\u5592\u55A4\u557D\u558C\u55A6\u557F\u5595\u55A1\u558E\u570C\u5829\u5837"],
    ["d8a1", "\u5819\u581E\u5827\u5823\u5828\u57F5\u5848\u5825\u581C\u581B\u5833\u583F\u5836\u582E\u5839\u5838\u582D\u582C\u583B\u5961\u5AAF\u5A94\u5A9F\u5A7A\u5AA2\u5A9E\u5A78\u5AA6\u5A7C\u5AA5\u5AAC\u5A95\u5AAE\u5A37\u5A84\u5A8A\u5A97\u5A83\u5A8B\u5AA9\u5A7B\u5A7D\u5A8C\u5A9C\u5A8F\u5A93\u5A9D\u5BEA\u5BCD\u5BCB\u5BD4\u5BD1\u5BCA\u5BCE\u5C0C\u5C30\u5D37\u5D43\u5D6B\u5D41\u5D4B\u5D3F\u5D35\u5D51\u5D4E\u5D55\u5D33\u5D3A\u5D52\u5D3D\u5D31\u5D59\u5D42\u5D39\u5D49\u5D38\u5D3C\u5D32\u5D36\u5D40\u5D45\u5E44\u5E41\u5F58\u5FA6\u5FA5\u5FAB\u60C9\u60B9\u60CC\u60E2\u60CE\u60C4\u6114"],
    ["d940", "\u60F2\u610A\u6116\u6105\u60F5\u6113\u60F8\u60FC\u60FE\u60C1\u6103\u6118\u611D\u6110\u60FF\u6104\u610B\u624A\u6394\u63B1\u63B0\u63CE\u63E5\u63E8\u63EF\u63C3\u649D\u63F3\u63CA\u63E0\u63F6\u63D5\u63F2\u63F5\u6461\u63DF\u63BE\u63DD\u63DC\u63C4\u63D8\u63D3\u63C2\u63C7\u63CC\u63CB\u63C8\u63F0\u63D7\u63D9\u6532\u6567\u656A\u6564\u655C\u6568\u6565\u658C\u659D\u659E\u65AE\u65D0\u65D2"],
    ["d9a1", "\u667C\u666C\u667B\u6680\u6671\u6679\u666A\u6672\u6701\u690C\u68D3\u6904\u68DC\u692A\u68EC\u68EA\u68F1\u690F\u68D6\u68F7\u68EB\u68E4\u68F6\u6913\u6910\u68F3\u68E1\u6907\u68CC\u6908\u6970\u68B4\u6911\u68EF\u68C6\u6914\u68F8\u68D0\u68FD\u68FC\u68E8\u690B\u690A\u6917\u68CE\u68C8\u68DD\u68DE\u68E6\u68F4\u68D1\u6906\u68D4\u68E9\u6915\u6925\u68C7\u6B39\u6B3B\u6B3F\u6B3C\u6B94\u6B97\u6B99\u6B95\u6BBD\u6BF0\u6BF2\u6BF3\u6C30\u6DFC\u6E46\u6E47\u6E1F\u6E49\u6E88\u6E3C\u6E3D\u6E45\u6E62\u6E2B\u6E3F\u6E41\u6E5D\u6E73\u6E1C\u6E33\u6E4B\u6E40\u6E51\u6E3B\u6E03\u6E2E\u6E5E"],
    ["da40", "\u6E68\u6E5C\u6E61\u6E31\u6E28\u6E60\u6E71\u6E6B\u6E39\u6E22\u6E30\u6E53\u6E65\u6E27\u6E78\u6E64\u6E77\u6E55\u6E79\u6E52\u6E66\u6E35\u6E36\u6E5A\u7120\u711E\u712F\u70FB\u712E\u7131\u7123\u7125\u7122\u7132\u711F\u7128\u713A\u711B\u724B\u725A\u7288\u7289\u7286\u7285\u728B\u7312\u730B\u7330\u7322\u7331\u7333\u7327\u7332\u732D\u7326\u7323\u7335\u730C\u742E\u742C\u7430\u742B\u7416"],
    ["daa1", "\u741A\u7421\u742D\u7431\u7424\u7423\u741D\u7429\u7420\u7432\u74FB\u752F\u756F\u756C\u75E7\u75DA\u75E1\u75E6\u75DD\u75DF\u75E4\u75D7\u7695\u7692\u76DA\u7746\u7747\u7744\u774D\u7745\u774A\u774E\u774B\u774C\u77DE\u77EC\u7860\u7864\u7865\u785C\u786D\u7871\u786A\u786E\u7870\u7869\u7868\u785E\u7862\u7974\u7973\u7972\u7970\u7A02\u7A0A\u7A03\u7A0C\u7A04\u7A99\u7AE6\u7AE4\u7B4A\u7B3B\u7B44\u7B48\u7B4C\u7B4E\u7B40\u7B58\u7B45\u7CA2\u7C9E\u7CA8\u7CA1\u7D58\u7D6F\u7D63\u7D53\u7D56\u7D67\u7D6A\u7D4F\u7D6D\u7D5C\u7D6B\u7D52\u7D54\u7D69\u7D51\u7D5F\u7D4E\u7F3E\u7F3F\u7F65"],
    ["db40", "\u7F66\u7FA2\u7FA0\u7FA1\u7FD7\u8051\u804F\u8050\u80FE\u80D4\u8143\u814A\u8152\u814F\u8147\u813D\u814D\u813A\u81E6\u81EE\u81F7\u81F8\u81F9\u8204\u823C\u823D\u823F\u8275\u833B\u83CF\u83F9\u8423\u83C0\u83E8\u8412\u83E7\u83E4\u83FC\u83F6\u8410\u83C6\u83C8\u83EB\u83E3\u83BF\u8401\u83DD\u83E5\u83D8\u83FF\u83E1\u83CB\u83CE\u83D6\u83F5\u83C9\u8409\u840F\u83DE\u8411\u8406\u83C2\u83F3"],
    ["dba1", "\u83D5\u83FA\u83C7\u83D1\u83EA\u8413\u83C3\u83EC\u83EE\u83C4\u83FB\u83D7\u83E2\u841B\u83DB\u83FE\u86D8\u86E2\u86E6\u86D3\u86E3\u86DA\u86EA\u86DD\u86EB\u86DC\u86EC\u86E9\u86D7\u86E8\u86D1\u8848\u8856\u8855\u88BA\u88D7\u88B9\u88B8\u88C0\u88BE\u88B6\u88BC\u88B7\u88BD\u88B2\u8901\u88C9\u8995\u8998\u8997\u89DD\u89DA\u89DB\u8A4E\u8A4D\u8A39\u8A59\u8A40\u8A57\u8A58\u8A44\u8A45\u8A52\u8A48\u8A51\u8A4A\u8A4C\u8A4F\u8C5F\u8C81\u8C80\u8CBA\u8CBE\u8CB0\u8CB9\u8CB5\u8D84\u8D80\u8D89\u8DD8\u8DD3\u8DCD\u8DC7\u8DD6\u8DDC\u8DCF\u8DD5\u8DD9\u8DC8\u8DD7\u8DC5\u8EEF\u8EF7\u8EFA"],
    ["dc40", "\u8EF9\u8EE6\u8EEE\u8EE5\u8EF5\u8EE7\u8EE8\u8EF6\u8EEB\u8EF1\u8EEC\u8EF4\u8EE9\u902D\u9034\u902F\u9106\u912C\u9104\u90FF\u90FC\u9108\u90F9\u90FB\u9101\u9100\u9107\u9105\u9103\u9161\u9164\u915F\u9162\u9160\u9201\u920A\u9225\u9203\u921A\u9226\u920F\u920C\u9200\u9212\u91FF\u91FD\u9206\u9204\u9227\u9202\u921C\u9224\u9219\u9217\u9205\u9216\u957B\u958D\u958C\u9590\u9687\u967E\u9688"],
    ["dca1", "\u9689\u9683\u9680\u96C2\u96C8\u96C3\u96F1\u96F0\u976C\u9770\u976E\u9807\u98A9\u98EB\u9CE6\u9EF9\u4E83\u4E84\u4EB6\u50BD\u50BF\u50C6\u50AE\u50C4\u50CA\u50B4\u50C8\u50C2\u50B0\u50C1\u50BA\u50B1\u50CB\u50C9\u50B6\u50B8\u51D7\u527A\u5278\u527B\u527C\u55C3\u55DB\u55CC\u55D0\u55CB\u55CA\u55DD\u55C0\u55D4\u55C4\u55E9\u55BF\u55D2\u558D\u55CF\u55D5\u55E2\u55D6\u55C8\u55F2\u55CD\u55D9\u55C2\u5714\u5853\u5868\u5864\u584F\u584D\u5849\u586F\u5855\u584E\u585D\u5859\u5865\u585B\u583D\u5863\u5871\u58FC\u5AC7\u5AC4\u5ACB\u5ABA\u5AB8\u5AB1\u5AB5\u5AB0\u5ABF\u5AC8\u5ABB\u5AC6"],
    ["dd40", "\u5AB7\u5AC0\u5ACA\u5AB4\u5AB6\u5ACD\u5AB9\u5A90\u5BD6\u5BD8\u5BD9\u5C1F\u5C33\u5D71\u5D63\u5D4A\u5D65\u5D72\u5D6C\u5D5E\u5D68\u5D67\u5D62\u5DF0\u5E4F\u5E4E\u5E4A\u5E4D\u5E4B\u5EC5\u5ECC\u5EC6\u5ECB\u5EC7\u5F40\u5FAF\u5FAD\u60F7\u6149\u614A\u612B\u6145\u6136\u6132\u612E\u6146\u612F\u614F\u6129\u6140\u6220\u9168\u6223\u6225\u6224\u63C5\u63F1\u63EB\u6410\u6412\u6409\u6420\u6424"],
    ["dda1", "\u6433\u6443\u641F\u6415\u6418\u6439\u6437\u6422\u6423\u640C\u6426\u6430\u6428\u6441\u6435\u642F\u640A\u641A\u6440\u6425\u6427\u640B\u63E7\u641B\u642E\u6421\u640E\u656F\u6592\u65D3\u6686\u668C\u6695\u6690\u668B\u668A\u6699\u6694\u6678\u6720\u6966\u695F\u6938\u694E\u6962\u6971\u693F\u6945\u696A\u6939\u6942\u6957\u6959\u697A\u6948\u6949\u6935\u696C\u6933\u693D\u6965\u68F0\u6978\u6934\u6969\u6940\u696F\u6944\u6976\u6958\u6941\u6974\u694C\u693B\u694B\u6937\u695C\u694F\u6951\u6932\u6952\u692F\u697B\u693C\u6B46\u6B45\u6B43\u6B42\u6B48\u6B41\u6B9B\uFA0D\u6BFB\u6BFC"],
    ["de40", "\u6BF9\u6BF7\u6BF8\u6E9B\u6ED6\u6EC8\u6E8F\u6EC0\u6E9F\u6E93\u6E94\u6EA0\u6EB1\u6EB9\u6EC6\u6ED2\u6EBD\u6EC1\u6E9E\u6EC9\u6EB7\u6EB0\u6ECD\u6EA6\u6ECF\u6EB2\u6EBE\u6EC3\u6EDC\u6ED8\u6E99\u6E92\u6E8E\u6E8D\u6EA4\u6EA1\u6EBF\u6EB3\u6ED0\u6ECA\u6E97\u6EAE\u6EA3\u7147\u7154\u7152\u7163\u7160\u7141\u715D\u7162\u7172\u7178\u716A\u7161\u7142\u7158\u7143\u714B\u7170\u715F\u7150\u7153"],
    ["dea1", "\u7144\u714D\u715A\u724F\u728D\u728C\u7291\u7290\u728E\u733C\u7342\u733B\u733A\u7340\u734A\u7349\u7444\u744A\u744B\u7452\u7451\u7457\u7440\u744F\u7450\u744E\u7442\u7446\u744D\u7454\u74E1\u74FF\u74FE\u74FD\u751D\u7579\u7577\u6983\u75EF\u760F\u7603\u75F7\u75FE\u75FC\u75F9\u75F8\u7610\u75FB\u75F6\u75ED\u75F5\u75FD\u7699\u76B5\u76DD\u7755\u775F\u7760\u7752\u7756\u775A\u7769\u7767\u7754\u7759\u776D\u77E0\u7887\u789A\u7894\u788F\u7884\u7895\u7885\u7886\u78A1\u7883\u7879\u7899\u7880\u7896\u787B\u797C\u7982\u797D\u7979\u7A11\u7A18\u7A19\u7A12\u7A17\u7A15\u7A22\u7A13"],
    ["df40", "\u7A1B\u7A10\u7AA3\u7AA2\u7A9E\u7AEB\u7B66\u7B64\u7B6D\u7B74\u7B69\u7B72\u7B65\u7B73\u7B71\u7B70\u7B61\u7B78\u7B76\u7B63\u7CB2\u7CB4\u7CAF\u7D88\u7D86\u7D80\u7D8D\u7D7F\u7D85\u7D7A\u7D8E\u7D7B\u7D83\u7D7C\u7D8C\u7D94\u7D84\u7D7D\u7D92\u7F6D\u7F6B\u7F67\u7F68\u7F6C\u7FA6\u7FA5\u7FA7\u7FDB\u7FDC\u8021\u8164\u8160\u8177\u815C\u8169\u815B\u8162\u8172\u6721\u815E\u8176\u8167\u816F"],
    ["dfa1", "\u8144\u8161\u821D\u8249\u8244\u8240\u8242\u8245\u84F1\u843F\u8456\u8476\u8479\u848F\u848D\u8465\u8451\u8440\u8486\u8467\u8430\u844D\u847D\u845A\u8459\u8474\u8473\u845D\u8507\u845E\u8437\u843A\u8434\u847A\u8443\u8478\u8432\u8445\u8429\u83D9\u844B\u842F\u8442\u842D\u845F\u8470\u8439\u844E\u844C\u8452\u846F\u84C5\u848E\u843B\u8447\u8436\u8433\u8468\u847E\u8444\u842B\u8460\u8454\u846E\u8450\u870B\u8704\u86F7\u870C\u86FA\u86D6\u86F5\u874D\u86F8\u870E\u8709\u8701\u86F6\u870D\u8705\u88D6\u88CB\u88CD\u88CE\u88DE\u88DB\u88DA\u88CC\u88D0\u8985\u899B\u89DF\u89E5\u89E4"],
    ["e040", "\u89E1\u89E0\u89E2\u89DC\u89E6\u8A76\u8A86\u8A7F\u8A61\u8A3F\u8A77\u8A82\u8A84\u8A75\u8A83\u8A81\u8A74\u8A7A\u8C3C\u8C4B\u8C4A\u8C65\u8C64\u8C66\u8C86\u8C84\u8C85\u8CCC\u8D68\u8D69\u8D91\u8D8C\u8D8E\u8D8F\u8D8D\u8D93\u8D94\u8D90\u8D92\u8DF0\u8DE0\u8DEC\u8DF1\u8DEE\u8DD0\u8DE9\u8DE3\u8DE2\u8DE7\u8DF2\u8DEB\u8DF4\u8F06\u8EFF\u8F01\u8F00\u8F05\u8F07\u8F08\u8F02\u8F0B\u9052\u903F"],
    ["e0a1", "\u9044\u9049\u903D\u9110\u910D\u910F\u9111\u9116\u9114\u910B\u910E\u916E\u916F\u9248\u9252\u9230\u923A\u9266\u9233\u9265\u925E\u9283\u922E\u924A\u9246\u926D\u926C\u924F\u9260\u9267\u926F\u9236\u9261\u9270\u9231\u9254\u9263\u9250\u9272\u924E\u9253\u924C\u9256\u9232\u959F\u959C\u959E\u959B\u9692\u9693\u9691\u9697\u96CE\u96FA\u96FD\u96F8\u96F5\u9773\u9777\u9778\u9772\u980F\u980D\u980E\u98AC\u98F6\u98F9\u99AF\u99B2\u99B0\u99B5\u9AAD\u9AAB\u9B5B\u9CEA\u9CED\u9CE7\u9E80\u9EFD\u50E6\u50D4\u50D7\u50E8\u50F3\u50DB\u50EA\u50DD\u50E4\u50D3\u50EC\u50F0\u50EF\u50E3\u50E0"],
    ["e140", "\u51D8\u5280\u5281\u52E9\u52EB\u5330\u53AC\u5627\u5615\u560C\u5612\u55FC\u560F\u561C\u5601\u5613\u5602\u55FA\u561D\u5604\u55FF\u55F9\u5889\u587C\u5890\u5898\u5886\u5881\u587F\u5874\u588B\u587A\u5887\u5891\u588E\u5876\u5882\u5888\u587B\u5894\u588F\u58FE\u596B\u5ADC\u5AEE\u5AE5\u5AD5\u5AEA\u5ADA\u5AED\u5AEB\u5AF3\u5AE2\u5AE0\u5ADB\u5AEC\u5ADE\u5ADD\u5AD9\u5AE8\u5ADF\u5B77\u5BE0"],
    ["e1a1", "\u5BE3\u5C63\u5D82\u5D80\u5D7D\u5D86\u5D7A\u5D81\u5D77\u5D8A\u5D89\u5D88\u5D7E\u5D7C\u5D8D\u5D79\u5D7F\u5E58\u5E59\u5E53\u5ED8\u5ED1\u5ED7\u5ECE\u5EDC\u5ED5\u5ED9\u5ED2\u5ED4\u5F44\u5F43\u5F6F\u5FB6\u612C\u6128\u6141\u615E\u6171\u6173\u6152\u6153\u6172\u616C\u6180\u6174\u6154\u617A\u615B\u6165\u613B\u616A\u6161\u6156\u6229\u6227\u622B\u642B\u644D\u645B\u645D\u6474\u6476\u6472\u6473\u647D\u6475\u6466\u64A6\u644E\u6482\u645E\u645C\u644B\u6453\u6460\u6450\u647F\u643F\u646C\u646B\u6459\u6465\u6477\u6573\u65A0\u66A1\u66A0\u669F\u6705\u6704\u6722\u69B1\u69B6\u69C9"],
    ["e240", "\u69A0\u69CE\u6996\u69B0\u69AC\u69BC\u6991\u6999\u698E\u69A7\u698D\u69A9\u69BE\u69AF\u69BF\u69C4\u69BD\u69A4\u69D4\u69B9\u69CA\u699A\u69CF\u69B3\u6993\u69AA\u69A1\u699E\u69D9\u6997\u6990\u69C2\u69B5\u69A5\u69C6\u6B4A\u6B4D\u6B4B\u6B9E\u6B9F\u6BA0\u6BC3\u6BC4\u6BFE\u6ECE\u6EF5\u6EF1\u6F03\u6F25\u6EF8\u6F37\u6EFB\u6F2E\u6F09\u6F4E\u6F19\u6F1A\u6F27\u6F18\u6F3B\u6F12\u6EED\u6F0A"],
    ["e2a1", "\u6F36\u6F73\u6EF9\u6EEE\u6F2D\u6F40\u6F30\u6F3C\u6F35\u6EEB\u6F07\u6F0E\u6F43\u6F05\u6EFD\u6EF6\u6F39\u6F1C\u6EFC\u6F3A\u6F1F\u6F0D\u6F1E\u6F08\u6F21\u7187\u7190\u7189\u7180\u7185\u7182\u718F\u717B\u7186\u7181\u7197\u7244\u7253\u7297\u7295\u7293\u7343\u734D\u7351\u734C\u7462\u7473\u7471\u7475\u7472\u7467\u746E\u7500\u7502\u7503\u757D\u7590\u7616\u7608\u760C\u7615\u7611\u760A\u7614\u76B8\u7781\u777C\u7785\u7782\u776E\u7780\u776F\u777E\u7783\u78B2\u78AA\u78B4\u78AD\u78A8\u787E\u78AB\u789E\u78A5\u78A0\u78AC\u78A2\u78A4\u7998\u798A\u798B\u7996\u7995\u7994\u7993"],
    ["e340", "\u7997\u7988\u7992\u7990\u7A2B\u7A4A\u7A30\u7A2F\u7A28\u7A26\u7AA8\u7AAB\u7AAC\u7AEE\u7B88\u7B9C\u7B8A\u7B91\u7B90\u7B96\u7B8D\u7B8C\u7B9B\u7B8E\u7B85\u7B98\u5284\u7B99\u7BA4\u7B82\u7CBB\u7CBF\u7CBC\u7CBA\u7DA7\u7DB7\u7DC2\u7DA3\u7DAA\u7DC1\u7DC0\u7DC5\u7D9D\u7DCE\u7DC4\u7DC6\u7DCB\u7DCC\u7DAF\u7DB9\u7D96\u7DBC\u7D9F\u7DA6\u7DAE\u7DA9\u7DA1\u7DC9\u7F73\u7FE2\u7FE3\u7FE5\u7FDE"],
    ["e3a1", "\u8024\u805D\u805C\u8189\u8186\u8183\u8187\u818D\u818C\u818B\u8215\u8497\u84A4\u84A1\u849F\u84BA\u84CE\u84C2\u84AC\u84AE\u84AB\u84B9\u84B4\u84C1\u84CD\u84AA\u849A\u84B1\u84D0\u849D\u84A7\u84BB\u84A2\u8494\u84C7\u84CC\u849B\u84A9\u84AF\u84A8\u84D6\u8498\u84B6\u84CF\u84A0\u84D7\u84D4\u84D2\u84DB\u84B0\u8491\u8661\u8733\u8723\u8728\u876B\u8740\u872E\u871E\u8721\u8719\u871B\u8743\u872C\u8741\u873E\u8746\u8720\u8732\u872A\u872D\u873C\u8712\u873A\u8731\u8735\u8742\u8726\u8727\u8738\u8724\u871A\u8730\u8711\u88F7\u88E7\u88F1\u88F2\u88FA\u88FE\u88EE\u88FC\u88F6\u88FB"],
    ["e440", "\u88F0\u88EC\u88EB\u899D\u89A1\u899F\u899E\u89E9\u89EB\u89E8\u8AAB\u8A99\u8A8B\u8A92\u8A8F\u8A96\u8C3D\u8C68\u8C69\u8CD5\u8CCF\u8CD7\u8D96\u8E09\u8E02\u8DFF\u8E0D\u8DFD\u8E0A\u8E03\u8E07\u8E06\u8E05\u8DFE\u8E00\u8E04\u8F10\u8F11\u8F0E\u8F0D\u9123\u911C\u9120\u9122\u911F\u911D\u911A\u9124\u9121\u911B\u917A\u9172\u9179\u9173\u92A5\u92A4\u9276\u929B\u927A\u92A0\u9294\u92AA\u928D"],
    ["e4a1", "\u92A6\u929A\u92AB\u9279\u9297\u927F\u92A3\u92EE\u928E\u9282\u9295\u92A2\u927D\u9288\u92A1\u928A\u9286\u928C\u9299\u92A7\u927E\u9287\u92A9\u929D\u928B\u922D\u969E\u96A1\u96FF\u9758\u977D\u977A\u977E\u9783\u9780\u9782\u977B\u9784\u9781\u977F\u97CE\u97CD\u9816\u98AD\u98AE\u9902\u9900\u9907\u999D\u999C\u99C3\u99B9\u99BB\u99BA\u99C2\u99BD\u99C7\u9AB1\u9AE3\u9AE7\u9B3E\u9B3F\u9B60\u9B61\u9B5F\u9CF1\u9CF2\u9CF5\u9EA7\u50FF\u5103\u5130\u50F8\u5106\u5107\u50F6\u50FE\u510B\u510C\u50FD\u510A\u528B\u528C\u52F1\u52EF\u5648\u5642\u564C\u5635\u5641\u564A\u5649\u5646\u5658"],
    ["e540", "\u565A\u5640\u5633\u563D\u562C\u563E\u5638\u562A\u563A\u571A\u58AB\u589D\u58B1\u58A0\u58A3\u58AF\u58AC\u58A5\u58A1\u58FF\u5AFF\u5AF4\u5AFD\u5AF7\u5AF6\u5B03\u5AF8\u5B02\u5AF9\u5B01\u5B07\u5B05\u5B0F\u5C67\u5D99\u5D97\u5D9F\u5D92\u5DA2\u5D93\u5D95\u5DA0\u5D9C\u5DA1\u5D9A\u5D9E\u5E69\u5E5D\u5E60\u5E5C\u7DF3\u5EDB\u5EDE\u5EE1\u5F49\u5FB2\u618B\u6183\u6179\u61B1\u61B0\u61A2\u6189"],
    ["e5a1", "\u619B\u6193\u61AF\u61AD\u619F\u6192\u61AA\u61A1\u618D\u6166\u61B3\u622D\u646E\u6470\u6496\u64A0\u6485\u6497\u649C\u648F\u648B\u648A\u648C\u64A3\u649F\u6468\u64B1\u6498\u6576\u657A\u6579\u657B\u65B2\u65B3\u66B5\u66B0\u66A9\u66B2\u66B7\u66AA\u66AF\u6A00\u6A06\u6A17\u69E5\u69F8\u6A15\u69F1\u69E4\u6A20\u69FF\u69EC\u69E2\u6A1B\u6A1D\u69FE\u6A27\u69F2\u69EE\u6A14\u69F7\u69E7\u6A40\u6A08\u69E6\u69FB\u6A0D\u69FC\u69EB\u6A09\u6A04\u6A18\u6A25\u6A0F\u69F6\u6A26\u6A07\u69F4\u6A16\u6B51\u6BA5\u6BA3\u6BA2\u6BA6\u6C01\u6C00\u6BFF\u6C02\u6F41\u6F26\u6F7E\u6F87\u6FC6\u6F92"],
    ["e640", "\u6F8D\u6F89\u6F8C\u6F62\u6F4F\u6F85\u6F5A\u6F96\u6F76\u6F6C\u6F82\u6F55\u6F72\u6F52\u6F50\u6F57\u6F94\u6F93\u6F5D\u6F00\u6F61\u6F6B\u6F7D\u6F67\u6F90\u6F53\u6F8B\u6F69\u6F7F\u6F95\u6F63\u6F77\u6F6A\u6F7B\u71B2\u71AF\u719B\u71B0\u71A0\u719A\u71A9\u71B5\u719D\u71A5\u719E\u71A4\u71A1\u71AA\u719C\u71A7\u71B3\u7298\u729A\u7358\u7352\u735E\u735F\u7360\u735D\u735B\u7361\u735A\u7359"],
    ["e6a1", "\u7362\u7487\u7489\u748A\u7486\u7481\u747D\u7485\u7488\u747C\u7479\u7508\u7507\u757E\u7625\u761E\u7619\u761D\u761C\u7623\u761A\u7628\u761B\u769C\u769D\u769E\u769B\u778D\u778F\u7789\u7788\u78CD\u78BB\u78CF\u78CC\u78D1\u78CE\u78D4\u78C8\u78C3\u78C4\u78C9\u799A\u79A1\u79A0\u799C\u79A2\u799B\u6B76\u7A39\u7AB2\u7AB4\u7AB3\u7BB7\u7BCB\u7BBE\u7BAC\u7BCE\u7BAF\u7BB9\u7BCA\u7BB5\u7CC5\u7CC8\u7CCC\u7CCB\u7DF7\u7DDB\u7DEA\u7DE7\u7DD7\u7DE1\u7E03\u7DFA\u7DE6\u7DF6\u7DF1\u7DF0\u7DEE\u7DDF\u7F76\u7FAC\u7FB0\u7FAD\u7FED\u7FEB\u7FEA\u7FEC\u7FE6\u7FE8\u8064\u8067\u81A3\u819F"],
    ["e740", "\u819E\u8195\u81A2\u8199\u8197\u8216\u824F\u8253\u8252\u8250\u824E\u8251\u8524\u853B\u850F\u8500\u8529\u850E\u8509\u850D\u851F\u850A\u8527\u851C\u84FB\u852B\u84FA\u8508\u850C\u84F4\u852A\u84F2\u8515\u84F7\u84EB\u84F3\u84FC\u8512\u84EA\u84E9\u8516\u84FE\u8528\u851D\u852E\u8502\u84FD\u851E\u84F6\u8531\u8526\u84E7\u84E8\u84F0\u84EF\u84F9\u8518\u8520\u8530\u850B\u8519\u852F\u8662"],
    ["e7a1", "\u8756\u8763\u8764\u8777\u87E1\u8773\u8758\u8754\u875B\u8752\u8761\u875A\u8751\u875E\u876D\u876A\u8750\u874E\u875F\u875D\u876F\u876C\u877A\u876E\u875C\u8765\u874F\u877B\u8775\u8762\u8767\u8769\u885A\u8905\u890C\u8914\u890B\u8917\u8918\u8919\u8906\u8916\u8911\u890E\u8909\u89A2\u89A4\u89A3\u89ED\u89F0\u89EC\u8ACF\u8AC6\u8AB8\u8AD3\u8AD1\u8AD4\u8AD5\u8ABB\u8AD7\u8ABE\u8AC0\u8AC5\u8AD8\u8AC3\u8ABA\u8ABD\u8AD9\u8C3E\u8C4D\u8C8F\u8CE5\u8CDF\u8CD9\u8CE8\u8CDA\u8CDD\u8CE7\u8DA0\u8D9C\u8DA1\u8D9B\u8E20\u8E23\u8E25\u8E24\u8E2E\u8E15\u8E1B\u8E16\u8E11\u8E19\u8E26\u8E27"],
    ["e840", "\u8E14\u8E12\u8E18\u8E13\u8E1C\u8E17\u8E1A\u8F2C\u8F24\u8F18\u8F1A\u8F20\u8F23\u8F16\u8F17\u9073\u9070\u906F\u9067\u906B\u912F\u912B\u9129\u912A\u9132\u9126\u912E\u9185\u9186\u918A\u9181\u9182\u9184\u9180\u92D0\u92C3\u92C4\u92C0\u92D9\u92B6\u92CF\u92F1\u92DF\u92D8\u92E9\u92D7\u92DD\u92CC\u92EF\u92C2\u92E8\u92CA\u92C8\u92CE\u92E6\u92CD\u92D5\u92C9\u92E0\u92DE\u92E7\u92D1\u92D3"],
    ["e8a1", "\u92B5\u92E1\u92C6\u92B4\u957C\u95AC\u95AB\u95AE\u95B0\u96A4\u96A2\u96D3\u9705\u9708\u9702\u975A\u978A\u978E\u9788\u97D0\u97CF\u981E\u981D\u9826\u9829\u9828\u9820\u981B\u9827\u98B2\u9908\u98FA\u9911\u9914\u9916\u9917\u9915\u99DC\u99CD\u99CF\u99D3\u99D4\u99CE\u99C9\u99D6\u99D8\u99CB\u99D7\u99CC\u9AB3\u9AEC\u9AEB\u9AF3\u9AF2\u9AF1\u9B46\u9B43\u9B67\u9B74\u9B71\u9B66\u9B76\u9B75\u9B70\u9B68\u9B64\u9B6C\u9CFC\u9CFA\u9CFD\u9CFF\u9CF7\u9D07\u9D00\u9CF9\u9CFB\u9D08\u9D05\u9D04\u9E83\u9ED3\u9F0F\u9F10\u511C\u5113\u5117\u511A\u5111\u51DE\u5334\u53E1\u5670\u5660\u566E"],
    ["e940", "\u5673\u5666\u5663\u566D\u5672\u565E\u5677\u571C\u571B\u58C8\u58BD\u58C9\u58BF\u58BA\u58C2\u58BC\u58C6\u5B17\u5B19\u5B1B\u5B21\u5B14\u5B13\u5B10\u5B16\u5B28\u5B1A\u5B20\u5B1E\u5BEF\u5DAC\u5DB1\u5DA9\u5DA7\u5DB5\u5DB0\u5DAE\u5DAA\u5DA8\u5DB2\u5DAD\u5DAF\u5DB4\u5E67\u5E68\u5E66\u5E6F\u5EE9\u5EE7\u5EE6\u5EE8\u5EE5\u5F4B\u5FBC\u619D\u61A8\u6196\u61C5\u61B4\u61C6\u61C1\u61CC\u61BA"],
    ["e9a1", "\u61BF\u61B8\u618C\u64D7\u64D6\u64D0\u64CF\u64C9\u64BD\u6489\u64C3\u64DB\u64F3\u64D9\u6533\u657F\u657C\u65A2\u66C8\u66BE\u66C0\u66CA\u66CB\u66CF\u66BD\u66BB\u66BA\u66CC\u6723\u6A34\u6A66\u6A49\u6A67\u6A32\u6A68\u6A3E\u6A5D\u6A6D\u6A76\u6A5B\u6A51\u6A28\u6A5A\u6A3B\u6A3F\u6A41\u6A6A\u6A64\u6A50\u6A4F\u6A54\u6A6F\u6A69\u6A60\u6A3C\u6A5E\u6A56\u6A55\u6A4D\u6A4E\u6A46\u6B55\u6B54\u6B56\u6BA7\u6BAA\u6BAB\u6BC8\u6BC7\u6C04\u6C03\u6C06\u6FAD\u6FCB\u6FA3\u6FC7\u6FBC\u6FCE\u6FC8\u6F5E\u6FC4\u6FBD\u6F9E\u6FCA\u6FA8\u7004\u6FA5\u6FAE\u6FBA\u6FAC\u6FAA\u6FCF\u6FBF\u6FB8"],
    ["ea40", "\u6FA2\u6FC9\u6FAB\u6FCD\u6FAF\u6FB2\u6FB0\u71C5\u71C2\u71BF\u71B8\u71D6\u71C0\u71C1\u71CB\u71D4\u71CA\u71C7\u71CF\u71BD\u71D8\u71BC\u71C6\u71DA\u71DB\u729D\u729E\u7369\u7366\u7367\u736C\u7365\u736B\u736A\u747F\u749A\u74A0\u7494\u7492\u7495\u74A1\u750B\u7580\u762F\u762D\u7631\u763D\u7633\u763C\u7635\u7632\u7630\u76BB\u76E6\u779A\u779D\u77A1\u779C\u779B\u77A2\u77A3\u7795\u7799"],
    ["eaa1", "\u7797\u78DD\u78E9\u78E5\u78EA\u78DE\u78E3\u78DB\u78E1\u78E2\u78ED\u78DF\u78E0\u79A4\u7A44\u7A48\u7A47\u7AB6\u7AB8\u7AB5\u7AB1\u7AB7\u7BDE\u7BE3\u7BE7\u7BDD\u7BD5\u7BE5\u7BDA\u7BE8\u7BF9\u7BD4\u7BEA\u7BE2\u7BDC\u7BEB\u7BD8\u7BDF\u7CD2\u7CD4\u7CD7\u7CD0\u7CD1\u7E12\u7E21\u7E17\u7E0C\u7E1F\u7E20\u7E13\u7E0E\u7E1C\u7E15\u7E1A\u7E22\u7E0B\u7E0F\u7E16\u7E0D\u7E14\u7E25\u7E24\u7F43\u7F7B\u7F7C\u7F7A\u7FB1\u7FEF\u802A\u8029\u806C\u81B1\u81A6\u81AE\u81B9\u81B5\u81AB\u81B0\u81AC\u81B4\u81B2\u81B7\u81A7\u81F2\u8255\u8256\u8257\u8556\u8545\u856B\u854D\u8553\u8561\u8558"],
    ["eb40", "\u8540\u8546\u8564\u8541\u8562\u8544\u8551\u8547\u8563\u853E\u855B\u8571\u854E\u856E\u8575\u8555\u8567\u8560\u858C\u8566\u855D\u8554\u8565\u856C\u8663\u8665\u8664\u879B\u878F\u8797\u8793\u8792\u8788\u8781\u8796\u8798\u8779\u8787\u87A3\u8785\u8790\u8791\u879D\u8784\u8794\u879C\u879A\u8789\u891E\u8926\u8930\u892D\u892E\u8927\u8931\u8922\u8929\u8923\u892F\u892C\u891F\u89F1\u8AE0"],
    ["eba1", "\u8AE2\u8AF2\u8AF4\u8AF5\u8ADD\u8B14\u8AE4\u8ADF\u8AF0\u8AC8\u8ADE\u8AE1\u8AE8\u8AFF\u8AEF\u8AFB\u8C91\u8C92\u8C90\u8CF5\u8CEE\u8CF1\u8CF0\u8CF3\u8D6C\u8D6E\u8DA5\u8DA7\u8E33\u8E3E\u8E38\u8E40\u8E45\u8E36\u8E3C\u8E3D\u8E41\u8E30\u8E3F\u8EBD\u8F36\u8F2E\u8F35\u8F32\u8F39\u8F37\u8F34\u9076\u9079\u907B\u9086\u90FA\u9133\u9135\u9136\u9193\u9190\u9191\u918D\u918F\u9327\u931E\u9308\u931F\u9306\u930F\u937A\u9338\u933C\u931B\u9323\u9312\u9301\u9346\u932D\u930E\u930D\u92CB\u931D\u92FA\u9325\u9313\u92F9\u92F7\u9334\u9302\u9324\u92FF\u9329\u9339\u9335\u932A\u9314\u930C"],
    ["ec40", "\u930B\u92FE\u9309\u9300\u92FB\u9316\u95BC\u95CD\u95BE\u95B9\u95BA\u95B6\u95BF\u95B5\u95BD\u96A9\u96D4\u970B\u9712\u9710\u9799\u9797\u9794\u97F0\u97F8\u9835\u982F\u9832\u9924\u991F\u9927\u9929\u999E\u99EE\u99EC\u99E5\u99E4\u99F0\u99E3\u99EA\u99E9\u99E7\u9AB9\u9ABF\u9AB4\u9ABB\u9AF6\u9AFA\u9AF9\u9AF7\u9B33\u9B80\u9B85\u9B87\u9B7C\u9B7E\u9B7B\u9B82\u9B93\u9B92\u9B90\u9B7A\u9B95"],
    ["eca1", "\u9B7D\u9B88\u9D25\u9D17\u9D20\u9D1E\u9D14\u9D29\u9D1D\u9D18\u9D22\u9D10\u9D19\u9D1F\u9E88\u9E86\u9E87\u9EAE\u9EAD\u9ED5\u9ED6\u9EFA\u9F12\u9F3D\u5126\u5125\u5122\u5124\u5120\u5129\u52F4\u5693\u568C\u568D\u5686\u5684\u5683\u567E\u5682\u567F\u5681\u58D6\u58D4\u58CF\u58D2\u5B2D\u5B25\u5B32\u5B23\u5B2C\u5B27\u5B26\u5B2F\u5B2E\u5B7B\u5BF1\u5BF2\u5DB7\u5E6C\u5E6A\u5FBE\u5FBB\u61C3\u61B5\u61BC\u61E7\u61E0\u61E5\u61E4\u61E8\u61DE\u64EF\u64E9\u64E3\u64EB\u64E4\u64E8\u6581\u6580\u65B6\u65DA\u66D2\u6A8D\u6A96\u6A81\u6AA5\u6A89\u6A9F\u6A9B\u6AA1\u6A9E\u6A87\u6A93\u6A8E"],
    ["ed40", "\u6A95\u6A83\u6AA8\u6AA4\u6A91\u6A7F\u6AA6\u6A9A\u6A85\u6A8C\u6A92\u6B5B\u6BAD\u6C09\u6FCC\u6FA9\u6FF4\u6FD4\u6FE3\u6FDC\u6FED\u6FE7\u6FE6\u6FDE\u6FF2\u6FDD\u6FE2\u6FE8\u71E1\u71F1\u71E8\u71F2\u71E4\u71F0\u71E2\u7373\u736E\u736F\u7497\u74B2\u74AB\u7490\u74AA\u74AD\u74B1\u74A5\u74AF\u7510\u7511\u7512\u750F\u7584\u7643\u7648\u7649\u7647\u76A4\u76E9\u77B5\u77AB\u77B2\u77B7\u77B6"],
    ["eda1", "\u77B4\u77B1\u77A8\u77F0\u78F3\u78FD\u7902\u78FB\u78FC\u78F2\u7905\u78F9\u78FE\u7904\u79AB\u79A8\u7A5C\u7A5B\u7A56\u7A58\u7A54\u7A5A\u7ABE\u7AC0\u7AC1\u7C05\u7C0F\u7BF2\u7C00\u7BFF\u7BFB\u7C0E\u7BF4\u7C0B\u7BF3\u7C02\u7C09\u7C03\u7C01\u7BF8\u7BFD\u7C06\u7BF0\u7BF1\u7C10\u7C0A\u7CE8\u7E2D\u7E3C\u7E42\u7E33\u9848\u7E38\u7E2A\u7E49\u7E40\u7E47\u7E29\u7E4C\u7E30\u7E3B\u7E36\u7E44\u7E3A\u7F45\u7F7F\u7F7E\u7F7D\u7FF4\u7FF2\u802C\u81BB\u81C4\u81CC\u81CA\u81C5\u81C7\u81BC\u81E9\u825B\u825A\u825C\u8583\u8580\u858F\u85A7\u8595\u85A0\u858B\u85A3\u857B\u85A4\u859A\u859E"],
    ["ee40", "\u8577\u857C\u8589\u85A1\u857A\u8578\u8557\u858E\u8596\u8586\u858D\u8599\u859D\u8581\u85A2\u8582\u8588\u8585\u8579\u8576\u8598\u8590\u859F\u8668\u87BE\u87AA\u87AD\u87C5\u87B0\u87AC\u87B9\u87B5\u87BC\u87AE\u87C9\u87C3\u87C2\u87CC\u87B7\u87AF\u87C4\u87CA\u87B4\u87B6\u87BF\u87B8\u87BD\u87DE\u87B2\u8935\u8933\u893C\u893E\u8941\u8952\u8937\u8942\u89AD\u89AF\u89AE\u89F2\u89F3\u8B1E"],
    ["eea1", "\u8B18\u8B16\u8B11\u8B05\u8B0B\u8B22\u8B0F\u8B12\u8B15\u8B07\u8B0D\u8B08\u8B06\u8B1C\u8B13\u8B1A\u8C4F\u8C70\u8C72\u8C71\u8C6F\u8C95\u8C94\u8CF9\u8D6F\u8E4E\u8E4D\u8E53\u8E50\u8E4C\u8E47\u8F43\u8F40\u9085\u907E\u9138\u919A\u91A2\u919B\u9199\u919F\u91A1\u919D\u91A0\u93A1\u9383\u93AF\u9364\u9356\u9347\u937C\u9358\u935C\u9376\u9349\u9350\u9351\u9360\u936D\u938F\u934C\u936A\u9379\u9357\u9355\u9352\u934F\u9371\u9377\u937B\u9361\u935E\u9363\u9367\u9380\u934E\u9359\u95C7\u95C0\u95C9\u95C3\u95C5\u95B7\u96AE\u96B0\u96AC\u9720\u971F\u9718\u971D\u9719\u979A\u97A1\u979C"],
    ["ef40", "\u979E\u979D\u97D5\u97D4\u97F1\u9841\u9844\u984A\u9849\u9845\u9843\u9925\u992B\u992C\u992A\u9933\u9932\u992F\u992D\u9931\u9930\u9998\u99A3\u99A1\u9A02\u99FA\u99F4\u99F7\u99F9\u99F8\u99F6\u99FB\u99FD\u99FE\u99FC\u9A03\u9ABE\u9AFE\u9AFD\u9B01\u9AFC\u9B48\u9B9A\u9BA8\u9B9E\u9B9B\u9BA6\u9BA1\u9BA5\u9BA4\u9B86\u9BA2\u9BA0\u9BAF\u9D33\u9D41\u9D67\u9D36\u9D2E\u9D2F\u9D31\u9D38\u9D30"],
    ["efa1", "\u9D45\u9D42\u9D43\u9D3E\u9D37\u9D40\u9D3D\u7FF5\u9D2D\u9E8A\u9E89\u9E8D\u9EB0\u9EC8\u9EDA\u9EFB\u9EFF\u9F24\u9F23\u9F22\u9F54\u9FA0\u5131\u512D\u512E\u5698\u569C\u5697\u569A\u569D\u5699\u5970\u5B3C\u5C69\u5C6A\u5DC0\u5E6D\u5E6E\u61D8\u61DF\u61ED\u61EE\u61F1\u61EA\u61F0\u61EB\u61D6\u61E9\u64FF\u6504\u64FD\u64F8\u6501\u6503\u64FC\u6594\u65DB\u66DA\u66DB\u66D8\u6AC5\u6AB9\u6ABD\u6AE1\u6AC6\u6ABA\u6AB6\u6AB7\u6AC7\u6AB4\u6AAD\u6B5E\u6BC9\u6C0B\u7007\u700C\u700D\u7001\u7005\u7014\u700E\u6FFF\u7000\u6FFB\u7026\u6FFC\u6FF7\u700A\u7201\u71FF\u71F9\u7203\u71FD\u7376"],
    ["f040", "\u74B8\u74C0\u74B5\u74C1\u74BE\u74B6\u74BB\u74C2\u7514\u7513\u765C\u7664\u7659\u7650\u7653\u7657\u765A\u76A6\u76BD\u76EC\u77C2\u77BA\u78FF\u790C\u7913\u7914\u7909\u7910\u7912\u7911\u79AD\u79AC\u7A5F\u7C1C\u7C29\u7C19\u7C20\u7C1F\u7C2D\u7C1D\u7C26\u7C28\u7C22\u7C25\u7C30\u7E5C\u7E50\u7E56\u7E63\u7E58\u7E62\u7E5F\u7E51\u7E60\u7E57\u7E53\u7FB5\u7FB3\u7FF7\u7FF8\u8075\u81D1\u81D2"],
    ["f0a1", "\u81D0\u825F\u825E\u85B4\u85C6\u85C0\u85C3\u85C2\u85B3\u85B5\u85BD\u85C7\u85C4\u85BF\u85CB\u85CE\u85C8\u85C5\u85B1\u85B6\u85D2\u8624\u85B8\u85B7\u85BE\u8669\u87E7\u87E6\u87E2\u87DB\u87EB\u87EA\u87E5\u87DF\u87F3\u87E4\u87D4\u87DC\u87D3\u87ED\u87D8\u87E3\u87A4\u87D7\u87D9\u8801\u87F4\u87E8\u87DD\u8953\u894B\u894F\u894C\u8946\u8950\u8951\u8949\u8B2A\u8B27\u8B23\u8B33\u8B30\u8B35\u8B47\u8B2F\u8B3C\u8B3E\u8B31\u8B25\u8B37\u8B26\u8B36\u8B2E\u8B24\u8B3B\u8B3D\u8B3A\u8C42\u8C75\u8C99\u8C98\u8C97\u8CFE\u8D04\u8D02\u8D00\u8E5C\u8E62\u8E60\u8E57\u8E56\u8E5E\u8E65\u8E67"],
    ["f140", "\u8E5B\u8E5A\u8E61\u8E5D\u8E69\u8E54\u8F46\u8F47\u8F48\u8F4B\u9128\u913A\u913B\u913E\u91A8\u91A5\u91A7\u91AF\u91AA\u93B5\u938C\u9392\u93B7\u939B\u939D\u9389\u93A7\u938E\u93AA\u939E\u93A6\u9395\u9388\u9399\u939F\u938D\u93B1\u9391\u93B2\u93A4\u93A8\u93B4\u93A3\u93A5\u95D2\u95D3\u95D1\u96B3\u96D7\u96DA\u5DC2\u96DF\u96D8\u96DD\u9723\u9722\u9725\u97AC\u97AE\u97A8\u97AB\u97A4\u97AA"],
    ["f1a1", "\u97A2\u97A5\u97D7\u97D9\u97D6\u97D8\u97FA\u9850\u9851\u9852\u98B8\u9941\u993C\u993A\u9A0F\u9A0B\u9A09\u9A0D\u9A04\u9A11\u9A0A\u9A05\u9A07\u9A06\u9AC0\u9ADC\u9B08\u9B04\u9B05\u9B29\u9B35\u9B4A\u9B4C\u9B4B\u9BC7\u9BC6\u9BC3\u9BBF\u9BC1\u9BB5\u9BB8\u9BD3\u9BB6\u9BC4\u9BB9\u9BBD\u9D5C\u9D53\u9D4F\u9D4A\u9D5B\u9D4B\u9D59\u9D56\u9D4C\u9D57\u9D52\u9D54\u9D5F\u9D58\u9D5A\u9E8E\u9E8C\u9EDF\u9F01\u9F00\u9F16\u9F25\u9F2B\u9F2A\u9F29\u9F28\u9F4C\u9F55\u5134\u5135\u5296\u52F7\u53B4\u56AB\u56AD\u56A6\u56A7\u56AA\u56AC\u58DA\u58DD\u58DB\u5912\u5B3D\u5B3E\u5B3F\u5DC3\u5E70"],
    ["f240", "\u5FBF\u61FB\u6507\u6510\u650D\u6509\u650C\u650E\u6584\u65DE\u65DD\u66DE\u6AE7\u6AE0\u6ACC\u6AD1\u6AD9\u6ACB\u6ADF\u6ADC\u6AD0\u6AEB\u6ACF\u6ACD\u6ADE\u6B60\u6BB0\u6C0C\u7019\u7027\u7020\u7016\u702B\u7021\u7022\u7023\u7029\u7017\u7024\u701C\u702A\u720C\u720A\u7207\u7202\u7205\u72A5\u72A6\u72A4\u72A3\u72A1\u74CB\u74C5\u74B7\u74C3\u7516\u7660\u77C9\u77CA\u77C4\u77F1\u791D\u791B"],
    ["f2a1", "\u7921\u791C\u7917\u791E\u79B0\u7A67\u7A68\u7C33\u7C3C\u7C39\u7C2C\u7C3B\u7CEC\u7CEA\u7E76\u7E75\u7E78\u7E70\u7E77\u7E6F\u7E7A\u7E72\u7E74\u7E68\u7F4B\u7F4A\u7F83\u7F86\u7FB7\u7FFD\u7FFE\u8078\u81D7\u81D5\u8264\u8261\u8263\u85EB\u85F1\u85ED\u85D9\u85E1\u85E8\u85DA\u85D7\u85EC\u85F2\u85F8\u85D8\u85DF\u85E3\u85DC\u85D1\u85F0\u85E6\u85EF\u85DE\u85E2\u8800\u87FA\u8803\u87F6\u87F7\u8809\u880C\u880B\u8806\u87FC\u8808\u87FF\u880A\u8802\u8962\u895A\u895B\u8957\u8961\u895C\u8958\u895D\u8959\u8988\u89B7\u89B6\u89F6\u8B50\u8B48\u8B4A\u8B40\u8B53\u8B56\u8B54\u8B4B\u8B55"],
    ["f340", "\u8B51\u8B42\u8B52\u8B57\u8C43\u8C77\u8C76\u8C9A\u8D06\u8D07\u8D09\u8DAC\u8DAA\u8DAD\u8DAB\u8E6D\u8E78\u8E73\u8E6A\u8E6F\u8E7B\u8EC2\u8F52\u8F51\u8F4F\u8F50\u8F53\u8FB4\u9140\u913F\u91B0\u91AD\u93DE\u93C7\u93CF\u93C2\u93DA\u93D0\u93F9\u93EC\u93CC\u93D9\u93A9\u93E6\u93CA\u93D4\u93EE\u93E3\u93D5\u93C4\u93CE\u93C0\u93D2\u93E7\u957D\u95DA\u95DB\u96E1\u9729\u972B\u972C\u9728\u9726"],
    ["f3a1", "\u97B3\u97B7\u97B6\u97DD\u97DE\u97DF\u985C\u9859\u985D\u9857\u98BF\u98BD\u98BB\u98BE\u9948\u9947\u9943\u99A6\u99A7\u9A1A\u9A15\u9A25\u9A1D\u9A24\u9A1B\u9A22\u9A20\u9A27\u9A23\u9A1E\u9A1C\u9A14\u9AC2\u9B0B\u9B0A\u9B0E\u9B0C\u9B37\u9BEA\u9BEB\u9BE0\u9BDE\u9BE4\u9BE6\u9BE2\u9BF0\u9BD4\u9BD7\u9BEC\u9BDC\u9BD9\u9BE5\u9BD5\u9BE1\u9BDA\u9D77\u9D81\u9D8A\u9D84\u9D88\u9D71\u9D80\u9D78\u9D86\u9D8B\u9D8C\u9D7D\u9D6B\u9D74\u9D75\u9D70\u9D69\u9D85\u9D73\u9D7B\u9D82\u9D6F\u9D79\u9D7F\u9D87\u9D68\u9E94\u9E91\u9EC0\u9EFC\u9F2D\u9F40\u9F41\u9F4D\u9F56\u9F57\u9F58\u5337\u56B2"],
    ["f440", "\u56B5\u56B3\u58E3\u5B45\u5DC6\u5DC7\u5EEE\u5EEF\u5FC0\u5FC1\u61F9\u6517\u6516\u6515\u6513\u65DF\u66E8\u66E3\u66E4\u6AF3\u6AF0\u6AEA\u6AE8\u6AF9\u6AF1\u6AEE\u6AEF\u703C\u7035\u702F\u7037\u7034\u7031\u7042\u7038\u703F\u703A\u7039\u7040\u703B\u7033\u7041\u7213\u7214\u72A8\u737D\u737C\u74BA\u76AB\u76AA\u76BE\u76ED\u77CC\u77CE\u77CF\u77CD\u77F2\u7925\u7923\u7927\u7928\u7924\u7929"],
    ["f4a1", "\u79B2\u7A6E\u7A6C\u7A6D\u7AF7\u7C49\u7C48\u7C4A\u7C47\u7C45\u7CEE\u7E7B\u7E7E\u7E81\u7E80\u7FBA\u7FFF\u8079\u81DB\u81D9\u820B\u8268\u8269\u8622\u85FF\u8601\u85FE\u861B\u8600\u85F6\u8604\u8609\u8605\u860C\u85FD\u8819\u8810\u8811\u8817\u8813\u8816\u8963\u8966\u89B9\u89F7\u8B60\u8B6A\u8B5D\u8B68\u8B63\u8B65\u8B67\u8B6D\u8DAE\u8E86\u8E88\u8E84\u8F59\u8F56\u8F57\u8F55\u8F58\u8F5A\u908D\u9143\u9141\u91B7\u91B5\u91B2\u91B3\u940B\u9413\u93FB\u9420\u940F\u9414\u93FE\u9415\u9410\u9428\u9419\u940D\u93F5\u9400\u93F7\u9407\u940E\u9416\u9412\u93FA\u9409\u93F8\u940A\u93FF"],
    ["f540", "\u93FC\u940C\u93F6\u9411\u9406\u95DE\u95E0\u95DF\u972E\u972F\u97B9\u97BB\u97FD\u97FE\u9860\u9862\u9863\u985F\u98C1\u98C2\u9950\u994E\u9959\u994C\u994B\u9953\u9A32\u9A34\u9A31\u9A2C\u9A2A\u9A36\u9A29\u9A2E\u9A38\u9A2D\u9AC7\u9ACA\u9AC6\u9B10\u9B12\u9B11\u9C0B\u9C08\u9BF7\u9C05\u9C12\u9BF8\u9C40\u9C07\u9C0E\u9C06\u9C17\u9C14\u9C09\u9D9F\u9D99\u9DA4\u9D9D\u9D92\u9D98\u9D90\u9D9B"],
    ["f5a1", "\u9DA0\u9D94\u9D9C\u9DAA\u9D97\u9DA1\u9D9A\u9DA2\u9DA8\u9D9E\u9DA3\u9DBF\u9DA9\u9D96\u9DA6\u9DA7\u9E99\u9E9B\u9E9A\u9EE5\u9EE4\u9EE7\u9EE6\u9F30\u9F2E\u9F5B\u9F60\u9F5E\u9F5D\u9F59\u9F91\u513A\u5139\u5298\u5297\u56C3\u56BD\u56BE\u5B48\u5B47\u5DCB\u5DCF\u5EF1\u61FD\u651B\u6B02\u6AFC\u6B03\u6AF8\u6B00\u7043\u7044\u704A\u7048\u7049\u7045\u7046\u721D\u721A\u7219\u737E\u7517\u766A\u77D0\u792D\u7931\u792F\u7C54\u7C53\u7CF2\u7E8A\u7E87\u7E88\u7E8B\u7E86\u7E8D\u7F4D\u7FBB\u8030\u81DD\u8618\u862A\u8626\u861F\u8623\u861C\u8619\u8627\u862E\u8621\u8620\u8629\u861E\u8625"],
    ["f640", "\u8829\u881D\u881B\u8820\u8824\u881C\u882B\u884A\u896D\u8969\u896E\u896B\u89FA\u8B79\u8B78\u8B45\u8B7A\u8B7B\u8D10\u8D14\u8DAF\u8E8E\u8E8C\u8F5E\u8F5B\u8F5D\u9146\u9144\u9145\u91B9\u943F\u943B\u9436\u9429\u943D\u943C\u9430\u9439\u942A\u9437\u942C\u9440\u9431\u95E5\u95E4\u95E3\u9735\u973A\u97BF\u97E1\u9864\u98C9\u98C6\u98C0\u9958\u9956\u9A39\u9A3D\u9A46\u9A44\u9A42\u9A41\u9A3A"],
    ["f6a1", "\u9A3F\u9ACD\u9B15\u9B17\u9B18\u9B16\u9B3A\u9B52\u9C2B\u9C1D\u9C1C\u9C2C\u9C23\u9C28\u9C29\u9C24\u9C21\u9DB7\u9DB6\u9DBC\u9DC1\u9DC7\u9DCA\u9DCF\u9DBE\u9DC5\u9DC3\u9DBB\u9DB5\u9DCE\u9DB9\u9DBA\u9DAC\u9DC8\u9DB1\u9DAD\u9DCC\u9DB3\u9DCD\u9DB2\u9E7A\u9E9C\u9EEB\u9EEE\u9EED\u9F1B\u9F18\u9F1A\u9F31\u9F4E\u9F65\u9F64\u9F92\u4EB9\u56C6\u56C5\u56CB\u5971\u5B4B\u5B4C\u5DD5\u5DD1\u5EF2\u6521\u6520\u6526\u6522\u6B0B\u6B08\u6B09\u6C0D\u7055\u7056\u7057\u7052\u721E\u721F\u72A9\u737F\u74D8\u74D5\u74D9\u74D7\u766D\u76AD\u7935\u79B4\u7A70\u7A71\u7C57\u7C5C\u7C59\u7C5B\u7C5A"],
    ["f740", "\u7CF4\u7CF1\u7E91\u7F4F\u7F87\u81DE\u826B\u8634\u8635\u8633\u862C\u8632\u8636\u882C\u8828\u8826\u882A\u8825\u8971\u89BF\u89BE\u89FB\u8B7E\u8B84\u8B82\u8B86\u8B85\u8B7F\u8D15\u8E95\u8E94\u8E9A\u8E92\u8E90\u8E96\u8E97\u8F60\u8F62\u9147\u944C\u9450\u944A\u944B\u944F\u9447\u9445\u9448\u9449\u9446\u973F\u97E3\u986A\u9869\u98CB\u9954\u995B\u9A4E\u9A53\u9A54\u9A4C\u9A4F\u9A48\u9A4A"],
    ["f7a1", "\u9A49\u9A52\u9A50\u9AD0\u9B19\u9B2B\u9B3B\u9B56\u9B55\u9C46\u9C48\u9C3F\u9C44\u9C39\u9C33\u9C41\u9C3C\u9C37\u9C34\u9C32\u9C3D\u9C36\u9DDB\u9DD2\u9DDE\u9DDA\u9DCB\u9DD0\u9DDC\u9DD1\u9DDF\u9DE9\u9DD9\u9DD8\u9DD6\u9DF5\u9DD5\u9DDD\u9EB6\u9EF0\u9F35\u9F33\u9F32\u9F42\u9F6B\u9F95\u9FA2\u513D\u5299\u58E8\u58E7\u5972\u5B4D\u5DD8\u882F\u5F4F\u6201\u6203\u6204\u6529\u6525\u6596\u66EB\u6B11\u6B12\u6B0F\u6BCA\u705B\u705A\u7222\u7382\u7381\u7383\u7670\u77D4\u7C67\u7C66\u7E95\u826C\u863A\u8640\u8639\u863C\u8631\u863B\u863E\u8830\u8832\u882E\u8833\u8976\u8974\u8973\u89FE"],
    ["f840", "\u8B8C\u8B8E\u8B8B\u8B88\u8C45\u8D19\u8E98\u8F64\u8F63\u91BC\u9462\u9455\u945D\u9457\u945E\u97C4\u97C5\u9800\u9A56\u9A59\u9B1E\u9B1F\u9B20\u9C52\u9C58\u9C50\u9C4A\u9C4D\u9C4B\u9C55\u9C59\u9C4C\u9C4E\u9DFB\u9DF7\u9DEF\u9DE3\u9DEB\u9DF8\u9DE4\u9DF6\u9DE1\u9DEE\u9DE6\u9DF2\u9DF0\u9DE2\u9DEC\u9DF4\u9DF3\u9DE8\u9DED\u9EC2\u9ED0\u9EF2\u9EF3\u9F06\u9F1C\u9F38\u9F37\u9F36\u9F43\u9F4F"],
    ["f8a1", "\u9F71\u9F70\u9F6E\u9F6F\u56D3\u56CD\u5B4E\u5C6D\u652D\u66ED\u66EE\u6B13\u705F\u7061\u705D\u7060\u7223\u74DB\u74E5\u77D5\u7938\u79B7\u79B6\u7C6A\u7E97\u7F89\u826D\u8643\u8838\u8837\u8835\u884B\u8B94\u8B95\u8E9E\u8E9F\u8EA0\u8E9D\u91BE\u91BD\u91C2\u946B\u9468\u9469\u96E5\u9746\u9743\u9747\u97C7\u97E5\u9A5E\u9AD5\u9B59\u9C63\u9C67\u9C66\u9C62\u9C5E\u9C60\u9E02\u9DFE\u9E07\u9E03\u9E06\u9E05\u9E00\u9E01\u9E09\u9DFF\u9DFD\u9E04\u9EA0\u9F1E\u9F46\u9F74\u9F75\u9F76\u56D4\u652E\u65B8\u6B18\u6B19\u6B17\u6B1A\u7062\u7226\u72AA\u77D8\u77D9\u7939\u7C69\u7C6B\u7CF6\u7E9A"],
    ["f940", "\u7E98\u7E9B\u7E99\u81E0\u81E1\u8646\u8647\u8648\u8979\u897A\u897C\u897B\u89FF\u8B98\u8B99\u8EA5\u8EA4\u8EA3\u946E\u946D\u946F\u9471\u9473\u9749\u9872\u995F\u9C68\u9C6E\u9C6D\u9E0B\u9E0D\u9E10\u9E0F\u9E12\u9E11\u9EA1\u9EF5\u9F09\u9F47\u9F78\u9F7B\u9F7A\u9F79\u571E\u7066\u7C6F\u883C\u8DB2\u8EA6\u91C3\u9474\u9478\u9476\u9475\u9A60\u9C74\u9C73\u9C71\u9C75\u9E14\u9E13\u9EF6\u9F0A"],
    ["f9a1", "\u9FA4\u7068\u7065\u7CF7\u866A\u883E\u883D\u883F\u8B9E\u8C9C\u8EA9\u8EC9\u974B\u9873\u9874\u98CC\u9961\u99AB\u9A64\u9A66\u9A67\u9B24\u9E15\u9E17\u9F48\u6207\u6B1E\u7227\u864C\u8EA8\u9482\u9480\u9481\u9A69\u9A68\u9B2E\u9E19\u7229\u864B\u8B9F\u9483\u9C79\u9EB7\u7675\u9A6B\u9C7A\u9E1D\u7069\u706A\u9EA4\u9F7E\u9F49\u9F98\u7881\u92B9\u88CF\u58BB\u6052\u7CA7\u5AFA\u2554\u2566\u2557\u2560\u256C\u2563\u255A\u2569\u255D\u2552\u2564\u2555\u255E\u256A\u2561\u2558\u2567\u255B\u2553\u2565\u2556\u255F\u256B\u2562\u2559\u2568\u255C\u2551\u2550\u256D\u256E\u2570\u256F\u2593"]
  ];
});
var require_big5_added = __commonJS2((exports, module) => {
  module.exports = [
    ["8740", "\u43F0\u4C32\u4603\u45A6\u4578\uD85C\uDE67\u4D77\u45B3\uD85F\uDCB1\u4CE2\uD85F\uDCC5\u3B95\u4736\u4744\u4C47\u4C40\uD850\uDEBF\uD84D\uDE17\uD85C\uDF52\uD85B\uDE8B\uD85C\uDCD2\u4C57\uD868\uDF51\u474F\u45DA\u4C85\uD85F\uDC6C\u4D07\u4AA4\u46A1\uD85A\uDF23\u7225\uD856\uDE54\uD846\uDE63\uD84F\uDE06\uD84F\uDF61\u664D\u56FB"],
    ["8767", "\u7D95\u591D\uD862\uDFB9\u3DF4\u9734\uD85E\uDFEF\u5BDB\uD847\uDD5E\u5AA4\u3625\uD867\uDEB0\u5AD1\u5BB7\u5CFC\u676E\u8593\uD866\uDD45\u7461\u749D\u3875\uD847\uDD53\uD84D\uDE9E\uD858\uDC21\u3EEC"],
    ["87a1", "\uD856\uDCDE\u3AF5\u7AFC\u9F97\uD850\uDD61\uD862\uDD0D\uD84C\uDDEA\uD842\uDE8A\uD84C\uDE5E\u430A\u8484\u9F96\u942F\u4930\u8613\u5896\u974A\u9218\u79D0\u7A32\u6660\u6A29\u889D\u744C\u7BC5\u6782\u7A2C\u524F\u9046\u34E6\u73C4\uD857\uDDB9\u74C6\u9FC7\u57B3\u492F\u544C\u4131\uD84D\uDE8E\u5818\u7A72\uD85E\uDF65\u8B8F\u46AE\uD85B\uDE88\u4181\uD857\uDD99\u7BAE\uD849\uDCBC\u9FC8\uD849\uDCC1\uD849\uDCC9\uD849\uDCCC\u9FC9\u8504\uD84D\uDDBB\u40B4\u9FCA\u44E1\uD86B\uDDFF\u62C1\u706E\u9FCB"],
    ["8840", "\u31C0", 4, "\uD840\uDD0C\u31C5\uD840\uDCD1\uD840\uDCCD\u31C6\u31C7\uD840\uDCCB\uD847\uDFE8\u31C8\uD840\uDCCA\u31C9\u31CA\u31CB\u31CC\uD840\uDD0E\u31CD\u31CE\u0100\xC1\u01CD\xC0\u0112\xC9\u011A\xC8\u014C\xD3\u01D1\xD2\u0FFF\xCA\u0304\u1EBE\u0FFF\xCA\u030C\u1EC0\xCA\u0101\xE1\u01CE\xE0\u0251\u0113\xE9\u011B\xE8\u012B\xED\u01D0\xEC\u014D\xF3\u01D2\xF2\u016B\xFA\u01D4\xF9\u01D6\u01D8\u01DA"],
    ["88a1", "\u01DC\xFC\u0FFF\xEA\u0304\u1EBF\u0FFF\xEA\u030C\u1EC1\xEA\u0261\u23DA\u23DB"],
    ["8940", "\uD868\uDFA9\uD844\uDD45"],
    ["8943", "\u650A"],
    ["8946", "\u4E3D\u6EDD\u9D4E\u91DF"],
    ["894c", "\uD85D\uDF35\u6491\u4F1A\u4F28\u4FA8\u5156\u5174\u519C\u51E4\u52A1\u52A8\u533B\u534E\u53D1\u53D8\u56E2\u58F0\u5904\u5907\u5932\u5934\u5B66\u5B9E\u5B9F\u5C9A\u5E86\u603B\u6589\u67FE\u6804\u6865\u6D4E\u70BC\u7535\u7EA4\u7EAC\u7EBA\u7EC7\u7ECF\u7EDF\u7F06\u7F37\u827A\u82CF\u836F\u89C6\u8BBE\u8BE2\u8F66\u8F67\u8F6E"],
    ["89a1", "\u7411\u7CFC\u7DCD\u6946\u7AC9\u5227"],
    ["89ab", "\u918C\u78B8\u915E\u80BC"],
    ["89b0", "\u8D0B\u80F6\uD842\uDDE7"],
    ["89b5", "\u809F\u9EC7\u4CCD\u9DC9\u9E0C\u4C3E\uD867\uDDF6\uD85C\uDC0E\u9E0A\uD868\uDD33\u35C1"],
    ["89c1", "\u6E9A\u823E\u7519"],
    ["89c5", "\u4911\u9A6C\u9A8F\u9F99\u7987\uD861\uDC6C\uD847\uDDCA\uD841\uDDD0\uD84A\uDEE6\u4E24\u4E81\u4E80\u4E87\u4EBF\u4EEB\u4F37\u344C\u4FBD\u3E48\u5003\u5088\u347D\u3493\u34A5\u5186\u5905\u51DB\u51FC\u5205\u4E89\u5279\u5290\u5327\u35C7\u53A9\u3551\u53B0\u3553\u53C2\u5423\u356D\u3572\u3681\u5493\u54A3\u54B4\u54B9\u54D0\u54EF\u5518\u5523\u5528\u3598\u553F\u35A5\u35BF\u55D7\u35C5"],
    ["8a40", "\uD85F\uDD84\u5525"],
    ["8a43", "\uD843\uDC42\uD843\uDD15\uD854\uDD2B\u5590\uD84B\uDCC6\u39EC\uD840\uDF41\u8E46\uD853\uDDB8\uD865\uDCE5\u4053\uD860\uDCBE\u777A\uD84B\uDC38\u3A34\u47D5\uD860\uDD5D\uD85A\uDDF2\uD853\uDDEA\u64DD\uD843\uDD7C\uD843\uDFB4\uD843\uDCD5\uD844\uDCF4\u648D\u8E7E\uD843\uDE96\uD843\uDC0B\uD843\uDF64\uD84B\uDCA9\uD860\uDE56\uD851\uDCD3"],
    ["8a64", "\uD843\uDD46\uD866\uDE4D\uD860\uDCE9\u47F4\uD853\uDEA7\uD84B\uDCC2\u9AB2\u3A67\uD865\uDDF4\u3FED\u3506\uD854\uDEC7\uD865\uDFD4\uD85E\uDCC8\uD84B\uDD44\u9D6E\u9815"],
    ["8a76", "\u43D9\uD858\uDCA5\u64B4\u54E3\uD84B\uDD4C\uD84A\uDFCA\uD844\uDC77\u39FB\uD844\uDC6F"],
    ["8aa1", "\uD859\uDEDA\uD859\uDF16\uD85E\uDDA0\u64EA\uD854\uDC52\uD843\uDC43\u8E68\uD848\uDDA1\uD862\uDF4C\uD841\uDF31"],
    ["8aac", "\u480B\uD840\uDDA9\u3FFA\u5873\uD84B\uDD8D"],
    ["8ab2", "\uD851\uDDC8\uD841\uDCFC\uD858\uDC97\uD843\uDF4C\uD843\uDD96\u5579\u40BB\u43BA"],
    ["8abb", "\u4AB4\uD84A\uDE66\uD844\uDC9D\u81AA\u98F5\uD843\uDD9C\u6379\u39FE\uD849\uDF75\u8DC0\u56A1\u647C\u3E43"],
    ["8ac9", "\uD869\uDE01\uD843\uDE09\uD84A\uDECF\uD84B\uDCC9"],
    ["8ace", "\uD844\uDCC8\uD84E\uDDC2\u3992\u3A06\uD860\uDE9B\u3578\uD857\uDE49\uD848\uDCC7\u5652\uD843\uDF31\uD84B\uDCB2\uD865\uDF20\u34BC\u6C3D\uD853\uDE3B"],
    ["8adf", "\uD85D\uDD74\uD84B\uDE8B\uD848\uDE08\uD869\uDE5B\uD863\uDCCD\uD843\uDE7A\uD843\uDC34\uD85A\uDC1C\u7F93\uD844\uDCCF\uD84A\uDC03\uD84A\uDD39\u35FB\uD854\uDDE3\uD843\uDE8C\uD843\uDF8D\uD843\uDEAA\u3F93\uD843\uDF30\uD843\uDD47\uD844\uDD4F\uD843\uDE4C"],
    ["8af6", "\uD843\uDEAB\uD842\uDFA9\uD843\uDD48\uD844\uDCC0\uD844\uDD3D\u3FF9\uD849\uDE96\u6432\uD843\uDFAD"],
    ["8b40", "\uD84C\uDFF4\uD85D\uDE39\uD84A\uDFCE\uD843\uDD7E\uD843\uDD7F\uD84B\uDC51\uD84B\uDC55\u3A18\uD843\uDE98\uD844\uDCC7\uD843\uDF2E\uD869\uDE32\uD85A\uDF50\uD863\uDCD2\uD863\uDD99\uD863\uDCCA\u95AA\u54CC\u82C4\u55B9"],
    ["8b55", "\uD867\uDEC3\u9C26\u9AB6\uD85D\uDF5E\uD84B\uDDEE\u7140\u816D\u80EC\u5C1C\uD859\uDD72\u8134\u3797\u535F\uD860\uDCBD\u91B6\uD843\uDEFA\uD843\uDE0F\uD843\uDE77\uD843\uDEFB\u35DD\uD853\uDDEB\u3609\uD843\uDCD6\u56AF\uD849\uDFB5\uD844\uDCC9\uD843\uDE10\uD843\uDE78\uD844\uDC78\uD844\uDD48\uD860\uDE07\uD845\uDC55\uD843\uDE79\uD853\uDE50\uD84B\uDDA4\u5A54\uD844\uDC1D\uD844\uDC1E\uD844\uDCF5\uD844\uDCF6\u579C\uD843\uDE11"],
    ["8ba1", "\uD85D\uDE94\uD860\uDECD\uD843\uDFB5\uD843\uDE7B\uD854\uDD7E\u3703\uD843\uDFB6\uD844\uDD80\uD854\uDED8\uD868\uDEBD\uD852\uDDDA\uD846\uDC3A\uD850\uDD77\uD860\uDE7C\u5899\u5268\u361A\uD855\uDF3D\u7BB2\u5B68\u4800\u4B2C\u9F27\u49E7\u9C1F\u9B8D\uD856\uDF74\uD84C\uDD3D\u55FB\u35F2\u5689\u4E28\u5902\uD846\uDFC1\uD87E\uDC78\u9751\uD840\uDC86\u4E5B\u4EBB\u353E\u5C23\u5F51\u5FC4\u38FA\u624C\u6535\u6B7A\u6C35\u6C3A\u706C\u722B\u4E2C\u72AD\uD852\uDCE9\u7F52\u793B\u7CF9\u7F53\uD858\uDE6A\u34C1"],
    ["8bde", "\uD858\uDF4B\u8002\u8080\uD859\uDE12\uD85A\uDD51\u535D\u8864\u89C1\uD85E\uDCB2\u8BA0\u8D1D\u9485\u9578\u957F\u95E8\uD863\uDE0F\u97E6\u9875\u98CE\u98DE\u9963\uD866\uDC10\u9C7C\u9E1F\u9EC4\u6B6F\uF907\u4E37\uD840\uDC87\u961D\u6237\u94A2"],
    ["8c40", "\u503B\u6DFE\uD867\uDC73\u9FA6\u3DC9\u888F\uD850\uDD4E\u7077\u5CF5\u4B20\uD854\uDDCD\u3559\uD857\uDD30\u6122\uD862\uDE32\u8FA7\u91F6\u7191\u6719\u73BA\uD84C\uDE81\uD868\uDD07\u3C8B\uD846\uDD80\u4B10\u78E4\u7402\u51AE\uD861\uDF0F\u4009\u6A63\uD868\uDEBA\u4223\u860F\uD842\uDE6F\u7A2A\uD866\uDD47\uD862\uDEEA\u9755\u704D\u5324\uD848\uDC7E\u93F4\u76D9\uD862\uDDE3\u9FA7\u77DD\u4EA3\u4FF0\u50BC\u4E2F\u4F17\u9FA8\u5434\u7D8B\u5892\u58D0\uD847\uDDB6\u5E92\u5E99\u5FC2\uD849\uDF12\u658B"],
    ["8ca1", "\uD84C\uDFF9\u6919\u6A43\uD84F\uDC63\u6CFF"],
    ["8ca7", "\u7200\uD851\uDD05\u738C\u3EDB\uD852\uDE13\u5B15\u74B9\u8B83\uD857\uDCA4\uD855\uDE95\u7A93\u7BEC\u7CC3\u7E6C\u82F8\u8597\u9FA9\u8890\u9FAA\u8EB9\u9FAB\u8FCF\u855F\u99E0\u9221\u9FAC\uD863\uDDB9\uD845\uDC3F\u4071\u42A2\u5A1A"],
    ["8cc9", "\u9868\u676B\u4276\u573D"],
    ["8cce", "\u85D6\uD852\uDD7B\u82BF\uD85C\uDD0D\u4C81\uD85B\uDD74\u5D7B\uD85A\uDF15\uD85B\uDFBE\u9FAD\u9FAE\u5B96\u9FAF\u66E7\u7E5B\u6E57\u79CA\u3D88\u44C3\uD84C\uDE56\uD849\uDF96\u439A\u4536"],
    ["8ce6", "\u5CD5\uD84E\uDF1A\u8AF9\u5C78\u3D12\uD84D\uDD51\u5D78\u9FB2\u7157\u4558\uD850\uDCEC\uD847\uDE23\u4C77\u3978\u344A\uD840\uDDA4\uD85B\uDC41\u8ACC\u4FB4\uD840\uDE39\u59BF\u816C\u9856\uD866\uDCFA\u5F3B"],
    ["8d40", "\uD842\uDF9F"],
    ["8d42", "\uD848\uDDC1\uD862\uDD6D\u4102\u46BB\uD864\uDC79\u3F07\u9FB3\uD868\uDDB5\u40F8\u37D6\u46F7\uD85B\uDC46\u417C\uD861\uDEB2\uD85C\uDFFF\u456D\u38D4\uD855\uDC9A\u4561\u451B\u4D89\u4C7B\u4D76\u45EA\u3FC8\uD852\uDF0F\u3661\u44DE\u44BD\u41ED\u5D3E\u5D48\u5D56\u3DFC\u380F\u5DA4\u5DB9\u3820\u3838\u5E42\u5EBD\u5F25\u5F83\u3908\u3914\u393F\u394D\u60D7\u613D\u5CE5\u3989\u61B7\u61B9\u61CF\u39B8\u622C\u6290\u62E5\u6318\u39F8\u56B1"],
    ["8da1", "\u3A03\u63E2\u63FB\u6407\u645A\u3A4B\u64C0\u5D15\u5621\u9F9F\u3A97\u6586\u3ABD\u65FF\u6653\u3AF2\u6692\u3B22\u6716\u3B42\u67A4\u6800\u3B58\u684A\u6884\u3B72\u3B71\u3B7B\u6909\u6943\u725C\u6964\u699F\u6985\u3BBC\u69D6\u3BDD\u6A65\u6A74\u6A71\u6A82\u3BEC\u6A99\u3BF2\u6AAB\u6AB5\u6AD4\u6AF6\u6B81\u6BC1\u6BEA\u6C75\u6CAA\u3CCB\u6D02\u6D06\u6D26\u6D81\u3CEF\u6DA4\u6DB1\u6E15\u6E18\u6E29\u6E86\uD862\uDDC0\u6EBB\u6EE2\u6EDA\u9F7F\u6EE8\u6EE9\u6F24\u6F34\u3D46\uD84F\uDF41\u6F81\u6FBE\u3D6A\u3D75\u71B7\u5C99\u3D8A\u702C\u3D91\u7050\u7054\u706F\u707F\u7089\uD840\uDF25\u43C1\u35F1\uD843\uDED8"],
    ["8e40", "\uD84F\uDED7\u57BE\uD85B\uDED3\u713E\uD855\uDFE0\u364E\u69A2\uD862\uDFE9\u5B74\u7A49\uD856\uDCE1\uD865\uDCD9\u7A65\u7A7D\uD856\uDDAC\u7ABB\u7AB0\u7AC2\u7AC3\u71D1\uD859\uDC8D\u41CA\u7ADA\u7ADD\u7AEA\u41EF\u54B2\uD857\uDC01\u7B0B\u7B55\u7B29\uD854\uDF0E\uD857\uDCFE\u7BA2\u7B6F\u839C\uD856\uDFB4\uD85B\uDC7F\u7BD0\u8421\u7B92\u7BB8\uD857\uDD20\u3DAD\uD857\uDC65\u8492\u7BFA\u7C06\u7C35\uD857\uDCC1\u7C44\u7C83\uD852\uDC82\u7CA6\u667D\uD851\uDD78\u7CC9\u7CC7\u7CE6\u7C74\u7CF3\u7CF5\u7CCE"],
    ["8ea1", "\u7E67\u451D\uD85B\uDE44\u7D5D\uD85B\uDED6\u748D\u7D89\u7DAB\u7135\u7DB3\u7DD2\uD850\uDC57\uD858\uDC29\u7DE4\u3D13\u7DF5\uD845\uDFF9\u7DE5\uD860\uDF6D\u7E1D\uD858\uDD21\uD858\uDD5A\u7E6E\u7E92\u432B\u946C\u7E27\u7F40\u7F41\u7F47\u7936\uD858\uDED0\u99E1\u7F97\uD858\uDF51\u7FA3\uD845\uDE61\uD840\uDC68\u455C\uD84D\uDF66\u4503\uD860\uDF3A\u7FFA\uD859\uDC89\u8005\u8008\u801D\u8028\u802F\uD868\uDC87\uD85B\uDCC3\u803B\u803C\u8061\uD849\uDF14\u4989\uD859\uDE26\uD84F\uDDE3\uD859\uDEE8\u6725\u80A7\uD862\uDE48\u8107\u811A\u58B0\uD849\uDEF6\u6C7F\uD859\uDC98\uD853\uDFB8\u64E7\uD845\uDC8A\u8218\uD846\uDC5E\u6A53\uD852\uDE65\uD852\uDE95\u447A\u8229\uD842\uDF0D\uD85A\uDE52\uD84F\uDD7E\u4FF9\uD845\uDCFD\u84E2\u8362\uD85A\uDF0A\uD852\uDDA7\uD84D\uDD30\uD845\uDF73\uD84F\uDDF8\u82AA\u691B\uD87E\uDD94\u41DB"],
    ["8f40", "\u854B\u82D0\u831A\uD843\uDE16\uD845\uDFB4\u36C1\uD84C\uDD7D\uD84D\uDD5A\u827B\u82E2\u8318\uD84F\uDE8B\uD85B\uDDA3\uD85A\uDF05\uD85A\uDF97\uD84D\uDDCE\u3DBF\u831D\u55EC\u8385\u450B\uD85B\uDDA5\u83AC\u83C1\u83D3\u347E\uD85B\uDED4\u6A57\u855A\u3496\uD85B\uDE42\uD84B\uDEEF\u8458\uD856\uDFE4\u8471\u3DD3\u44E4\u6AA7\u844A\uD84F\uDCB5\u7958\u84A8\uD85A\uDF96\uD85B\uDE77\uD85B\uDE43\u84DE\u840F\u8391\u44A0\u8493\u84E4\uD857\uDC91\u4240\uD857\uDCC0\u4543\u8534\u5AF2\uD85B\uDE99\u4527\u8573\u4516\u67BF\u8616"],
    ["8fa1", "\uD861\uDE25\uD861\uDE3B\u85C1\uD85C\uDC88\u8602\uD845\uDD82\uD85C\uDCCD\uD87E\uDDB2\u456A\u8628\u3648\uD846\uDCA2\u53F7\uD85C\uDF9A\u867E\u8771\uD868\uDCF8\u87EE\uD84B\uDC27\u87B1\u87DA\u880F\u5661\u866C\u6856\u460F\u8845\u8846\uD85D\uDDE0\uD84F\uDDB9\uD85D\uDDE4\u885E\u889C\u465B\u88B4\u88B5\u63C1\u88C5\u7777\uD85D\uDF0F\u8987\u898A\u89A6\u89A9\u89A7\u89BC\uD862\uDE25\u89E7\uD85E\uDD24\uD85E\uDEBD\u8A9C\u7793\u91FE\u8A90\uD85E\uDE59\u7AE9\uD85E\uDF3A\uD84F\uDF8F\u4713\uD85E\uDF38\u717C\u8B0C\u8B1F\uD855\uDC30\uD855\uDD65\u8B3F\u8B4C\u8B4D\u8AA9\uD852\uDE7A\u8B90\u8B9B\u8AAF\uD845\uDEDF\u4615\u884F\u8C9B\uD85F\uDD54\uD85F\uDD8F\uD87E\uDDD4\u3725\uD85F\uDD53\u8CD6\uD85F\uDD98\uD85F\uDDBD\u8D12\u8D03\uD846\uDD10\u8CDB\u705C\u8D11\uD853\uDCC9\u3ED0\u8D77"],
    ["9040", "\u8DA9\uD860\uDC02\uD844\uDC14\uD852\uDD8A\u3B7C\uD860\uDDBC\uD85C\uDD0C\u7AE7\u8EAD\u8EB6\u8EC3\u92D4\u8F19\u8F2D\uD860\uDF65\uD861\uDC12\u8FA5\u9303\uD868\uDE9F\uD842\uDE50\u8FB3\u492A\uD862\uDDDE\uD861\uDD3D\uD84F\uDDBB\u5EF8\uD84C\uDE62\u8FF9\uD868\uDC14\uD861\uDEBC\uD861\uDD01\uD848\uDF25\u3980\uD85B\uDED7\u9037\uD861\uDD3C\uD85E\uDEBE\u9061\uD861\uDD6C\uD861\uDE0B\u90A8\uD861\uDF13\u90C4\uD861\uDEE6\u90AE\u90FD\u9167\u3AF0\u91A9\u91C4\u7CAC\uD862\uDD33\uD847\uDE89\u920E\u6C9F\u9241\u9262\uD855\uDDB9\u92B9\uD862\uDEC6\uD84F\uDC9B\uD862\uDF0C\uD855\uDDDB"],
    ["90a1", "\uD843\uDD31\u932C\u936B\uD862\uDEE1\uD862\uDFEB\u708F\u5AC3\uD862\uDEE2\uD862\uDEE5\u4965\u9244\uD862\uDFEC\uD863\uDC39\uD862\uDFFF\u9373\u945B\u8EBC\u9585\u95A6\u9426\u95A0\u6FF6\u42B9\uD849\uDE7A\uD861\uDED8\uD844\uDE7C\uD84F\uDE2E\u49DF\u6C1C\u967B\u9696\u416C\u96A3\uD85B\uDED5\u61DA\u96B6\u78F5\uD862\uDEE0\u96BD\u53CC\u49A1\uD85B\uDCB8\uD840\uDE74\uD859\uDC10\uD864\uDCAF\uD864\uDCE5\uD852\uDED1\uD846\uDD15\uD84C\uDF0A\u9731\u8642\u9736\u4A0F\u453D\u4585\uD852\uDEE9\u7075\u5B41\u971B\u975C\uD864\uDDD5\u9757\u5B4A\uD864\uDDEB\u975F\u9425\u50D0\uD84C\uDCB7\uD84C\uDCBC\u9789\u979F\u97B1\u97BE\u97C0\u97D2\u97E0\uD855\uDC6C\u97EE\u741C\uD865\uDC33\u97FF\u97F5\uD865\uDC1D\uD85E\uDD7A\u4AD1\u9834\u9833\u984B\u9866\u3B0E\uD85C\uDD75\u3D51\uD841\uDE30\uD850\uDD5C"],
    ["9140", "\uD855\uDF06\u98CA\u98B7\u98C8\u98C7\u4AFF\uD85B\uDD27\uD845\uDED3\u55B0\u98E1\u98E6\u98EC\u9378\u9939\uD852\uDE29\u4B72\uD866\uDC57\uD866\uDD05\u99F5\u9A0C\u9A3B\u9A10\u9A58\uD855\uDF25\u36C4\uD864\uDCB1\uD866\uDFD5\u9AE0\u9AE2\uD866\uDF05\u9AF4\u4C0E\u9B14\u9B2D\uD861\uDE00\u5034\u9B34\uD85A\uDDA8\u38C3\uD84C\uDC7D\u9B50\u9B40\uD867\uDD3E\u5A45\uD846\uDC63\u9B8E\uD850\uDE4B\u9C02\u9BFF\u9C0C\uD867\uDE68\u9DD4\uD867\uDFB7\uD868\uDD92\uD868\uDDAB\uD868\uDCE1\uD868\uDD23\uD868\uDDDF\u9D7E\u9D83\uD868\uDD34\u9E0E\u6888"],
    ["91a1", "\u9DC4\uD848\uDD5B\uD868\uDD93\uD868\uDE20\uD846\uDD3B\uD868\uDE33\u9D39\uD868\uDCB9\uD868\uDEB4\u9E90\u9E95\u9E9E\u9EA2\u4D34\u9EAA\u9EAF\uD850\uDF64\u9EC1\u3B60\u39E5\u3D1D\u4F32\u37BE\uD863\uDC2B\u9F02\u9F08\u4B96\u9424\uD85B\uDDA2\u9F17\u9F16\u9F39\u569F\u568A\u9F45\u99B8\uD864\uDC8B\u97F2\u847F\u9F62\u9F69\u7ADC\u9F8E\u7216\u4BBE\uD852\uDD75\uD852\uDDBB\u7177\uD852\uDDF8\uD850\uDF48\uD852\uDE51\u739E\uD862\uDFDA\uD846\uDCFA\u799F\uD862\uDD7E\uD863\uDE36\u9369\u93F3\uD862\uDE44\u92EC\u9381\u93CB\uD862\uDD6C\uD851\uDCB9\u7217\u3EEB\u7772\u7A43\u70D0\uD851\uDC73\uD850\uDFF8\u717E\uD845\uDFEF\u70A3\uD846\uDCBE\uD84D\uDD99\u3EC7\uD846\uDC85\uD855\uDC2F\uD845\uDFF8\u3722\uD845\uDEFB\uD846\uDC39\u36E1\uD845\uDF74\uD846\uDCD1\uD857\uDF4B\u3723\uD845\uDEC0\u575B\uD852\uDE25\uD844\uDFFE\uD844\uDEA8"],
    ["9240", "\uD844\uDFC6\uD845\uDCB6\u8503\uD84D\uDEA6\u8503\u8455\uD852\uDD94\uD85C\uDD65\uD84F\uDE31\uD855\uDD5C\uD84F\uDEFB\uD85C\uDC52\u44F4\uD84D\uDEEE\uD866\uDD9D\uD85B\uDF26\u67F9\u3733\u3C15\u3DE7\u586C\uD846\uDD22\u6810\u4057\uD84D\uDF3F\uD850\uDCE1\uD850\uDC8B\uD850\uDD0F\uD85B\uDC21\u54CB\u569E\uD859\uDEB1\u5692\uD843\uDFDF\uD842\uDFA8\uD843\uDE0D\u93C6\uD862\uDF13\u939C\u4EF8\u512B\u3819\uD851\uDC36\u4EBC\uD841\uDC65\uD840\uDF7F\u4F4B\u4F8A\uD855\uDE51\u5A68\uD840\uDDAB\uD840\uDFCB\u3999\uD840\uDF0A\uD841\uDC14\u3435\u4F29\uD840\uDEC0\uD863\uDEB3\uD840\uDE75\u8ADA\uD840\uDE0C\u4E98"],
    ["92a1", "\u50CD\u510D\u4FA2\u4F03\uD852\uDE0E\uD84F\uDE8A\u4F42\u502E\u506C\u5081\u4FCC\u4FE5\u5058\u50FC\u5159\u515B\u515D\u515E\u6E76\uD84D\uDD95\uD84F\uDE39\uD84F\uDEBF\u6D72\uD846\uDC84\uD84F\uDE89\u51A8\u51C3\uD841\uDDE0\u44DD\uD841\uDCA3\uD841\uDC92\uD841\uDC91\u8D7A\uD862\uDE9C\uD841\uDF0E\u5259\u52A4\uD842\uDC73\u52E1\u936E\u467A\u718C\uD850\uDF8C\uD843\uDC20\uD852\uDDAC\uD844\uDCE4\u69D1\uD843\uDE1D\u7479\u3EDE\u7499\u7414\u7456\u7398\u4B8E\uD852\uDEBC\uD850\uDC8D\u53D0\u3584\u720F\uD850\uDCC9\u55B4\uD840\uDF45\u54CD\uD842\uDFC6\u571D\u925D\u96F4\u9366\u57DD\u578D\u577F\u363E\u58CB\u5A99\uD862\uDE46\uD845\uDEFA\uD845\uDF6F\uD845\uDF10\u5A2C\u59B8\u928F\u5A7E\u5ACF\u5A12\uD856\uDD46\uD846\uDDF3\uD846\uDC61\uD850\uDE95\u36F5\u6D05\u7443\u5A21\uD857\uDE83"],
    ["9340", "\u5A81\uD862\uDFD7\uD841\uDC13\u93E0\u748C\uD844\uDF03\u7105\u4972\u9408\uD862\uDDFB\u93BD\u37A0\u5C1E\u5C9E\u5E5E\u5E48\uD846\uDD96\uD846\uDD7C\uD84E\uDEEE\u5ECD\u5B4F\uD846\uDD03\uD846\uDD04\u3701\uD846\uDCA0\u36DD\uD845\uDEFE\u36D3\u812A\uD862\uDE47\uD847\uDDBA\uD84D\uDC72\uD862\uDDA8\u5F0C\u5F0E\uD846\uDD27\uD845\uDFAB\u5A6B\uD845\uDF3B\u5B44\u8614\uD85D\uDDFD\u8860\u607E\uD84A\uDC60\uD849\uDE2B\u5FDB\u3EB8\uD849\uDDAF\uD849\uDDBE\uD864\uDC88\uD85B\uDF73\u61C0\uD840\uDC3E\uD840\uDC46\uD849\uDE1B\u6199\u6198\u6075\uD84B\uDC9B\uD84B\uDD07\uD851\uDED4\uD864\uDD4D"],
    ["93a1", "\u6471\uD851\uDE65\uD84A\uDF6A\u3A29\uD84A\uDF22\uD84D\uDC50\uD866\uDCEA\uD84B\uDE78\u6337\uD869\uDC5B\u64B6\u6331\u63D1\uD852\uDDE3\uD84B\uDD67\u62A4\uD84B\uDCA1\u643B\u656B\u6972\u3BF4\uD84C\uDC8E\uD84C\uDEAD\uD852\uDD89\uD84C\uDEAB\u550D\uD84C\uDEE0\uD846\uDCD9\uD865\uDC3F\u66CE\uD84C\uDE89\uD84C\uDDB3\u3AE0\u4190\uD855\uDD84\uD862\uDF22\uD855\uDD8F\uD845\uDEFC\uD855\uDD5B\uD855\uDC25\u78EE\uD84C\uDD03\uD846\uDC2A\uD84C\uDE34\u3464\uD84C\uDE0F\uD84C\uDD82\uD850\uDEC9\u668E\uD85B\uDD24\u666B\u4B93\u6630\uD85E\uDC70\uD847\uDDEB\u6663\uD84C\uDED2\uD84C\uDEE1\u661E\uD856\uDC72\u38D1\uD84E\uDC3A\uD84D\uDFBC\u3B99\uD84D\uDFA2\uD84C\uDFFE\u74D0\u3B96\u678F\uD851\uDE2A\u68B6\u681E\u3BC4\u6ABE\u3863\uD84D\uDFD5\uD851\uDC87\u6A33\u6A52\u6AC9\u6B05\uD846\uDD12\u6511\u6898\u6A4C\u3BD7\u6A7A\u6B57\uD84F\uDFC0\uD84F\uDC9A\u93A0\u92F2\uD862\uDFEA\uD862\uDECB"],
    ["9440", "\u9289\uD860\uDC1E\uD862\uDDDC\u9467\u6DA5\u6F0B\uD852\uDDEC\u6D67\uD84F\uDF7F\u3D8F\u6E04\uD850\uDC3C\u5A3D\u6E0A\u5847\u6D24\u7842\u713B\uD850\uDF1A\uD850\uDE76\u70F1\u7250\u7287\u7294\uD851\uDF8F\uD851\uDF25\u5179\uD852\uDEA4\uD841\uDDEB\u747A\uD84F\uDEF8\uD84D\uDE5F\uD852\uDE4A\uD852\uDD17\uD857\uDFE1\u3F06\u3EB1\uD852\uDEDF\uD863\uDC23\uD84F\uDF35\u60A7\u3EF3\u74CC\u743C\u9387\u7437\u449F\uD85B\uDDEA\u4551\u7583\u3F63\uD853\uDCD9\uD853\uDD06\u3F58\u7555\u7673\uD869\uDDC6\u3B19\u7468\uD862\uDECC\uD852\uDDAB\uD852\uDD8E\u3AFB"],
    ["94a1", "\u3DCD\uD852\uDE4E\u3EFF\uD852\uDDC5\uD852\uDCF3\u91FA\u5732\u9342\uD862\uDEE3\uD846\uDC64\u50DF\uD854\uDE21\uD854\uDDE7\u7778\uD84C\uDE32\u770E\u770F\u777B\uD851\uDE97\uD84D\uDF81\u3A5E\uD852\uDCF0\u7438\u749B\u3EBF\uD852\uDEBA\uD852\uDEC7\u40C8\uD852\uDE96\uD858\uDDAE\u9307\uD855\uDD81\u781E\u788D\u7888\u78D2\u73D0\u7959\uD85D\uDF41\uD855\uDEE3\u410E\u799B\u8496\u79A5\u6A2D\uD84F\uDEFA\u7A3A\u79F4\u416E\uD845\uDEE6\u4132\u9235\u79F1\uD843\uDD4C\uD852\uDD8C\uD840\uDE99\uD84F\uDDBA\uD845\uDF6E\u3597\u556B\u3570\u36AA\uD840\uDDD4\uD843\uDC0D\u7AE2\u5A59\uD849\uDEF5\uD856\uDEAF\uD856\uDE9C\u5A0D\uD840\uDE5B\u78F0\u5A2A\uD856\uDFC6\u7AFE\u41F9\u7C5D\u7C6D\u4211\uD856\uDFB3\uD857\uDEBC\uD857\uDEA6\u7CCD\uD852\uDDF9\uD845\uDFB0\u7C8E\u7C7C\u7CAE\u6AB2\u7DDC\u7E07\u7DD3\u7F4E\uD858\uDE61"],
    ["9540", "\uD858\uDD5C\uD85E\uDF48\u7D97\uD857\uDE82\u426A\uD85A\uDF75\uD842\uDD16\u67D6\uD840\uDC4E\uD84D\uDDCF\u57C4\uD859\uDC12\uD858\uDFF8\uD852\uDD62\u7FDD\u7B27\uD842\uDC2C\uD856\uDEE9\uD857\uDD43\u7B0C\uD857\uDE0E\u99E6\u8645\u9A63\u6A1C\uD84D\uDC3F\u39E2\uD852\uDDF7\uD859\uDDAD\u9A1F\uD859\uDDA0\u8480\uD85C\uDD27\uD85B\uDCD1\u44EA\u8137\u4402\u80C6\u8109\u8142\uD859\uDFB4\u98C3\uD85A\uDE42\u8262\u8265\uD85A\uDE51\u8453\uD85B\uDDA7\u8610\uD85C\uDE1B\u5A86\u417F\uD846\uDC40\u5B2B\uD846\uDCA1\u5AE4\uD846\uDCD8\u86A0\uD87E\uDDBC\uD84F\uDD8F\u882D\uD85D\uDC22\u5A02"],
    ["95a1", "\u886E\u4F45\u8887\u88BF\u88E6\u8965\u894D\uD855\uDE83\u8954\uD85D\uDF85\uD85D\uDF84\uD862\uDFF5\uD862\uDFD9\uD862\uDF9C\uD862\uDDF9\u3EAD\u84A3\u46F5\u46CF\u37F2\u8A3D\u8A1C\uD865\uDC48\u5F4D\u922B\uD850\uDE84\u65D4\u7129\u70C4\uD846\uDC45\u9D6D\u8C9F\u8CE9\uD85F\uDDDC\u599A\u77C3\u59F0\u436E\u36D4\u8E2A\u8EA7\uD853\uDC09\u8F30\u8F4A\u42F4\u6C58\u6FBB\uD848\uDF21\u489B\u6F79\u6E8B\uD845\uDFDA\u9BE9\u36B5\uD852\uDD2F\u90BB\u9097\u5571\u4906\u91BB\u9404\uD862\uDE4B\u4062\uD862\uDEFC\u9427\uD863\uDC1D\uD863\uDC3B\u84E5\u8A2B\u9599\u95A7\u9597\u9596\uD863\uDD34\u7445\u3EC2\uD852\uDCFF\uD852\uDE42\uD850\uDFEA\u3EE7\uD84C\uDE25\u968F\uD863\uDEE7\uD863\uDE66\uD863\uDE65\u3ECC\uD852\uDDED\uD852\uDE78\uD84F\uDFEE\u7412\u746B\u3EFC\u9741\uD864\uDCB0"],
    ["9640", "\u6847\u4A1D\uD864\uDC93\uD855\uDFDF\u975D\u9368\uD862\uDD89\uD863\uDC26\uD862\uDF2F\uD858\uDFBE\u92BA\u5B11\u8B69\u493C\u73F9\uD850\uDE1B\u979B\u9771\u9938\uD843\uDF26\u5DC1\uD862\uDFC5\uD852\uDEB2\u981F\uD865\uDCDA\u92F6\uD865\uDDD7\u91E5\u44C0\uD862\uDF50\uD852\uDE67\uD862\uDF64\u98DC\uD862\uDE45\u3F00\u922A\u4925\u8414\u993B\u994D\uD85E\uDF06\u3DFD\u999B\u4B6F\u99AA\u9A5C\uD862\uDF65\uD856\uDCC8\u6A8F\u9A21\u5AFE\u9A2F\uD866\uDCF1\u4B90\uD866\uDD48\u99BC\u4BBD\u4B97\u937D\u5872\uD844\uDF02\u5822\uD852\uDDB8"],
    ["96a1", "\uD845\uDCE8\u7844\uD849\uDF1F\uD84F\uDDB8\u68C5\u3D7D\u9458\u3927\u6150\uD849\uDF81\uD84A\uDD6B\u6107\u9C4F\u9C53\u9C7B\u9C35\u9C10\u9B7F\u9BCF\uD867\uDE2D\u9B9F\uD868\uDDF5\uD868\uDCFE\u9D21\u4CAE\uD850\uDD04\u9E18\u4CB0\u9D0C\uD868\uDDB4\uD868\uDCED\uD868\uDCF3\uD866\uDD2F\u9DA5\u84BD\uD85B\uDE12\uD85B\uDFDF\uD85A\uDF82\u85FC\u4533\uD85B\uDDA4\uD85B\uDE84\uD85B\uDDF0\u8420\u85EE\uD85B\uDE00\uD84D\uDFD7\uD858\uDC64\u79E2\uD84D\uDD9C\uD84D\uDE40\u492D\uD852\uDDDE\u3D62\u93DB\u92BE\u9348\uD840\uDEBF\u78B9\u9277\u944D\u4FE4\u3440\u9064\uD855\uDD5D\u783D\u7854\u78B6\u784B\uD845\uDF57\uD84C\uDDC9\uD852\uDD41\u369A\u4F72\u6FDA\u6FD9\u701E\u701E\u5414\uD850\uDDB5\u57BB\u58F3\u578A\u9D16\u57D7\u7134\u34AF\uD850\uDDAC\u71EB\uD85B\uDC40\uD853\uDF97\u5B28\uD845\uDFB5\uD862\uDE49"],
    ["9740", "\u610C\u5ACE\u5A0B\u42BC\uD851\uDC88\u372C\u4B7B\uD862\uDDFC\u93BB\u93B8\uD846\uDCD6\uD843\uDF1D\u8472\uD85B\uDCC0\uD845\uDC13\uD850\uDEFA\uD84B\uDC26\uD850\uDFC1\u5994\uD84F\uDDB7\uD859\uDF41\u7DA8\uD858\uDD5B\uD858\uDCA4\uD852\uDDB9\uD852\uDD8B\uD862\uDDFA\u92E5\u73E2\u3EE9\u74B4\uD862\uDF63\uD846\uDC9F\u3EE1\uD852\uDEB3\u6AD8\u73F3\u73FB\u3ED6\uD852\uDE3E\uD852\uDE94\uD845\uDFD9\uD852\uDE66\uD840\uDFA7\uD845\uDC24\uD852\uDDE5\u7448\uD852\uDD16\u70A5\uD852\uDD76\u9284\u73E6\u935F\uD841\uDCFE\u9331\uD862\uDECE\uD862\uDE16\u9386\uD862\uDFE7\uD855\uDDD5\u4935\uD862\uDE82\u716B"],
    ["97a1", "\uD852\uDD43\uD843\uDCFF\u56A4\uD841\uDE1A\uD842\uDFEB\uD843\uDCB8\u5502\u79C4\uD845\uDFFA\u7DFE\uD845\uDEC2\uD852\uDE50\uD846\uDC52\u452E\u9401\u370A\uD862\uDEC0\uD852\uDDAD\u59B0\uD846\uDCBF\uD846\uDC83\uD85D\uDC84\u5AA1\u36E2\uD84F\uDD5B\u36B0\u925F\u5A79\uD862\uDE81\uD846\uDC62\u9374\u3CCD\uD842\uDEB4\u4A96\u398A\u50F4\u3D69\u3D4C\uD844\uDF9C\u7175\u42FB\uD860\uDE18\u6E0F\uD864\uDCE4\u44EB\u6D57\uD85F\uDE4F\u7067\u6CAF\u3CD6\uD84F\uDFED\uD84F\uDE2D\u6E02\u6F0C\u3D6F\uD840\uDFF5\u7551\u36BC\u34C8\u4680\u3EDA\u4871\u59C4\u926E\u493E\u8F41\uD863\uDC1C\uD85A\uDFC0\u5812\u57C8\u36D6\uD845\uDC52\u70FE\uD850\uDF62\uD852\uDE71\uD84B\uDFE3\uD844\uDEB0\uD848\uDFBD\u68B9\u6967\uD844\uDF98\uD84D\uDCE5\uD85E\uDFF4\uD84D\uDEDF\uD862\uDE83\uD84D\uDFD6\uD84C\uDFFA\uD853\uDC9F\u6A1A\uD84D\uDEAD\uD85B\uDCB7\u843E\u44DF\u44CE"],
    ["9840", "\uD85B\uDD26\uD85B\uDD51\uD85B\uDC82\uD85B\uDFDE\u6F17\uD85C\uDD09\u833D\uD845\uDF3A\u83ED\uD85B\uDC80\uD85C\uDC53\uD845\uDFDB\u5989\u5A82\uD845\uDFB3\u5A61\u5A71\uD846\uDD05\uD850\uDDFC\u372D\u59EF\uD845\uDF3C\u36C7\u718E\u9390\u669A\uD850\uDEA5\u5A6E\u5A2B\uD850\uDE93\u6A2B\uD84F\uDEF9\uD85D\uDF36\uD851\uDC5B\uD850\uDECA\u711D\uD850\uDE59\uD862\uDDE1\u4FB0\uD85B\uDD28\u5CC2\uD851\uDCCE\uD85F\uDE4D\uD850\uDFBD\u6A0C\uD850\uDE56\uD844\uDF04\u70A6\u7133\uD850\uDFE9\u3DA5\u6CDF\uD87E\uDC25\uD852\uDE4F\u7E65\u59EB\u5D2F\u3DF3\u5F5C\uD852\uDE5D\uD845\uDFDF\u7DA4\u8426"],
    ["98a1", "\u5485\uD84E\uDEFA\uD84C\uDF00\uD840\uDE14\u577E\uD842\uDCD5\uD841\uDE19\u3FE5\uD847\uDF9E\uD868\uDEB6\u7003\uD864\uDD5B\u5D70\u738F\u7CD3\uD862\uDE59\uD865\uDC20\u4FC8\u7FE7\u72CD\u7310\uD85E\uDEF4\u7338\u7339\uD855\uDEF6\u7341\u7348\u3EA9\uD85E\uDF18\u906C\u71F5\uD852\uDCF2\u73E1\u81F6\u3ECA\u770C\u3ED1\u6CA2\u56FD\u7419\u741E\u741F\u3EE2\u3EF0\u3EF4\u3EFA\u74D3\u3F0E\u3F53\u7542\u756D\u7572\u758D\u3F7C\u75C8\u75DC\u3FC0\u764D\u3FD7\u7674\u3FDC\u767A\uD853\uDF5C\u7188\u5623\u8980\u5869\u401D\u7743\u4039\u6761\u4045\u35DB\u7798\u406A\u406F\u5C5E\u77BE\u77CB\u58F2\u7818\u70B9\u781C\u40A8\u7839\u7847\u7851\u7866\u8448\uD855\uDD35\u7933\u6803\u7932\u4103"],
    ["9940", "\u4109\u7991\u7999\u8FBB\u7A06\u8FBC\u4167\u7A91\u41B2\u7ABC\u8279\u41C4\u7ACF\u7ADB\u41CF\u4E21\u7B62\u7B6C\u7B7B\u7C12\u7C1B\u4260\u427A\u7C7B\u7C9C\u428C\u7CB8\u4294\u7CED\u8F93\u70C0\uD843\uDCCF\u7DCF\u7DD4\u7DD0\u7DFD\u7FAE\u7FB4\u729F\u4397\u8020\u8025\u7B39\u802E\u8031\u8054\u3DCC\u57B4\u70A0\u80B7\u80E9\u43ED\u810C\u732A\u810E\u8112\u7560\u8114\u4401\u3B39\u8156\u8159\u815A"],
    ["99a1", "\u4413\u583A\u817C\u8184\u4425\u8193\u442D\u81A5\u57EF\u81C1\u81E4\u8254\u448F\u82A6\u8276\u82CA\u82D8\u82FF\u44B0\u8357\u9669\u698A\u8405\u70F5\u8464\u60E3\u8488\u4504\u84BE\u84E1\u84F8\u8510\u8538\u8552\u453B\u856F\u8570\u85E0\u4577\u8672\u8692\u86B2\u86EF\u9645\u878B\u4606\u4617\u88AE\u88FF\u8924\u8947\u8991\uD85E\uDD67\u8A29\u8A38\u8A94\u8AB4\u8C51\u8CD4\u8CF2\u8D1C\u4798\u585F\u8DC3\u47ED\u4EEE\u8E3A\u55D8\u5754\u8E71\u55F5\u8EB0\u4837\u8ECE\u8EE2\u8EE4\u8EED\u8EF2\u8FB7\u8FC1\u8FCA\u8FCC\u9033\u99C4\u48AD\u98E0\u9213\u491E\u9228\u9258\u926B\u92B1\u92AE\u92BF"],
    ["9a40", "\u92E3\u92EB\u92F3\u92F4\u92FD\u9343\u9384\u93AD\u4945\u4951\u9EBF\u9417\u5301\u941D\u942D\u943E\u496A\u9454\u9479\u952D\u95A2\u49A7\u95F4\u9633\u49E5\u67A0\u4A24\u9740\u4A35\u97B2\u97C2\u5654\u4AE4\u60E8\u98B9\u4B19\u98F1\u5844\u990E\u9919\u51B4\u991C\u9937\u9942\u995D\u9962\u4B70\u99C5\u4B9D\u9A3C\u9B0F\u7A83\u9B69\u9B81\u9BDD\u9BF1\u9BF4\u4C6D\u9C20\u376F\uD846\uDFC2\u9D49\u9C3A"],
    ["9aa1", "\u9EFE\u5650\u9D93\u9DBD\u9DC0\u9DFC\u94F6\u8FB6\u9E7B\u9EAC\u9EB1\u9EBD\u9EC6\u94DC\u9EE2\u9EF1\u9EF8\u7AC8\u9F44\uD840\uDC94\uD840\uDEB7\uD840\uDFA0\u691A\u94C3\u59AC\uD841\uDCD7\u5840\u94C1\u37B9\uD841\uDDD5\uD841\uDE15\uD841\uDE76\uD845\uDEBA\u5757\u7173\uD842\uDEC2\uD842\uDECD\uD842\uDFBF\u546A\uD87E\uDC3B\uD842\uDFCB\u549E\uD842\uDFFB\uD843\uDC3B\uD843\uDC53\uD843\uDC65\uD843\uDC7C\u60E7\uD843\uDC8D\u567A\uD843\uDCB5\uD843\uDCDD\uD843\uDCED\uD843\uDD6F\uD843\uDDB2\uD843\uDDC8\u6955\u9C2F\u87A5\uD843\uDE04\uD843\uDE0E\uD843\uDED7\uD843\uDF90\uD843\uDF2D\uD843\uDE73\u5C20\uD843\uDFBC\u5E0B\uD844\uDC5C\uD844\uDC4F\uD844\uDC76\u671E\uD844\uDC7B\uD844\uDC88\uD844\uDC96\u3647\uD844\uDCBF\uD844\uDCD3\uD844\uDD2F\uD844\uDD3B\u5364\u84AD\uD844\uDEE3\uD844\uDF75\uD844\uDF36\u8B81\uD845\uDD77\uD845\uDE19\uD845\uDFC3\uD845\uDFC7\u4E78\u70BB\uD846\uDC2D\uD846\uDD6A"],
    ["9b40", "\uD846\uDE2D\uD846\uDE45\uD847\uDC2A\uD847\uDC70\uD847\uDCAC\uD847\uDEC8\u62C3\uD847\uDED5\uD847\uDF15\u7198\u6855\uD848\uDC45\u69E9\u36C8\uD848\uDE7C\uD848\uDFD7\uD848\uDFFA\uD849\uDF2A\uD84A\uDC71\uD84A\uDD4F\u82FD\uD84A\uDD67\uD84A\uDD93\uD84A\uDED5\u89A5\uD84A\uDEE8\u8FA0\uD84A\uDF0E\u97B8\uD84A\uDF3F\u9847\u9ABD\uD84B\uDC4C"],
    ["9b62", "\uD84B\uDC88\uD84B\uDCB7\uD856\uDFE8\uD84B\uDD08\uD84B\uDD12\uD84B\uDDB7\uD84B\uDD95\uD84B\uDE42\uD84B\uDF74\uD84B\uDFCC\uD84C\uDC33\uD84C\uDC66\uD84C\uDF1F\uD84C\uDFDE\u5FB1\u6648\u66BF\uD85E\uDE79\uD84D\uDD67\uD84D\uDDF3\u7201\uD852\uDDBA\u77D7\uD84D\uDE1A\uD84D\uDF16\u7E87\uD840\uDF46\u58B5\u670E"],
    ["9ba1", "\u6918\uD84E\uDEA7\uD85D\uDE57\uD857\uDFE2\uD84F\uDE11\uD84F\uDEB9\uD85D\uDDFE\uD848\uDC9A\u48D0\u4AB8\uD850\uDD19\uD862\uDE9A\uD850\uDEEE\uD850\uDF0D\uD850\uDC3B\uD850\uDF34\uD850\uDF96\uD852\uDE45\uD841\uDDCA\u51D2\uD841\uDE11\u599F\uD847\uDEA8\u3BBE\uD84F\uDCFF\uD851\uDC04\uD851\uDCD6\u5788\uD851\uDE74\u399B\uD851\uDF2F\uD861\uDDE8\uD866\uDDC9\u3762\uD848\uDDC3\u8B5E\uD862\uDF4E\u99D6\uD852\uDC12\uD852\uDCFB\uD852\uDE15\u7209\uD852\uDEC0\uD843\uDC78\u5965\uD853\uDEA5\uD853\uDF86\uD841\uDF79\u8EDA\uD854\uDC2C\u528F\u573F\u7171\uD854\uDE99\uD855\uDC19\uD84F\uDF4A\uD852\uDEA7\u55BC\uD855\uDC46\uD855\uDC6E\uD85A\uDF52\u91D4\u3473\uD855\uDD3F\uD85D\uDE32\uD855\uDD5E\u4718\uD855\uDD62\uD855\uDD66\uD855\uDFC7\uD852\uDD3F\uD856\uDC5D\u5066\u34FB\uD84C\uDFCC\u60DE\uD856\uDD03\u477C\uD862\uDD48\uD856\uDEAE\uD856\uDF89\uD857\uDC06\uD847\uDD90\u57A1\u7151\u6FB6\uD858\uDD02\uD85F\uDC12\u9056\uD858\uDDB2\uD853\uDF9A\u8B62\uD859\uDC02\uD859\uDC4A"],
    ["9c40", "\u5D5B\uD85A\uDFF7\u8F36\uD859\uDC84\uD846\uDD1C\u8AEA\uD852\uDDF6\uD859\uDC88\uD84F\uDFEF\uD859\uDD12\u4BC0\uD859\uDDBF\uD859\uDEB5\uD849\uDF1B\u9465\uD855\uDFE1\u6195\u5A27\uD87E\uDCCD\u4FBB\u56B9\uD851\uDD21\uD859\uDEFC\u4E6A\uD852\uDD34\u9656\u6D8F\uD85B\uDCBD\u3618\u8977\uD859\uDF99\uD85A\uDC6E\uD859\uDC11\uD85A\uDC5E\u71DF\uD85A\uDCC7\u7B42\uD864\uDCC0\uD842\uDE11\uD85A\uDD26\u9104\uD85A\uDD39\u7A45\u9DF0\uD85A\uDDFA\u9A26\uD85A\uDE2D\u365F\uD859\uDC69\uD840\uDC21\u7983\uD85A\uDE34\uD85A\uDF5B\u5D2C\uD84D\uDD19\u83CF\uD85A\uDF9D\u46D0\uD85B\uDCA4\u753B\u8865\uD85B\uDDAE\u58B6"],
    ["9ca1", "\u371C\uD849\uDD8D\uD85C\uDC4B\uD85C\uDDCD\u3C54\uD85C\uDE80\uD85C\uDE85\u9281\uD848\uDD7A\uD85C\uDE8B\u9330\uD85C\uDEE6\uD852\uDDD0\u6C39\u949F\uD85D\uDC50\uD843\uDEF8\u8827\u88F5\uD84A\uDD26\uD861\uDC73\uD845\uDFB1\u6EB8\uD852\uDE2A\uD846\uDC20\u39A4\u36B9\u5C10\u79E3\u453F\u66B6\uD867\uDCAD\uD866\uDCA4\u8943\uD85D\uDFCC\uD85E\uDC58\u56D6\u40DF\uD845\uDE0A\u39A1\uD84D\uDF2F\uD860\uDCE8\uD844\uDFC5\u71AD\u8366\uD85E\uDDDD\uD864\uDDA8\u5A67\u4CB7\uD85C\uDCAF\uD862\uDDAB\uD85E\uDDFD\uD85E\uDE0A\uD85E\uDF0B\uD85F\uDD66\uD850\uDD7A\u7B43\u797E\uD860\uDC09\u6FB5\uD868\uDEDF\u6A03\uD860\uDF18\u53A2\uD85B\uDE07\u93BF\u6836\u975D\uD860\uDD6F\uD860\uDC23\uD85A\uDDB5\uD844\uDFED\uD84C\uDE2F\uD860\uDC48\u5D85\uD863\uDC30\uD860\uDC83\u5715\u9823\uD862\uDD49\u5DAB\uD852\uDD88\u65BE\u69D5\u53D2\uD852\uDEA5\uD84F\uDF81\u3C11\u6736\uD860\uDC90\uD860\uDCF4\uD860\uDD2E\uD847\uDFA1\uD860\uDD4F"],
    ["9d40", "\uD860\uDD89\uD860\uDDAF\uD860\uDE1A\uD860\uDF06\uD860\uDF2F\uD860\uDF8A\u35CA\uD861\uDC68\uD861\uDEAA\u48FA\u63E6\uD862\uDD56\u7808\u9255\uD862\uDDB8\u43F2\uD862\uDDE7\u43DF\uD862\uDDE8\uD862\uDF46\uD862\uDFD4\u59F8\uD863\uDC09\u8F0B\uD863\uDFC5\uD864\uDCEC\u7B51\uD864\uDD10\uD864\uDD3C\u3DF7\uD864\uDD5E\uD852\uDECA\u8FD0\u728F\u568B\uD865\uDCE7\uD865\uDDE9\uD865\uDDB0\uD865\uDDB8\uD865\uDF32\uD866\uDCD1\uD866\uDD49\uD866\uDD6A\uD866\uDDC3\uD866\uDE28\uD866\uDF0E\uD867\uDD5A\uD867\uDD9B\u7E9F\uD867\uDEF8\uD867\uDF23\u4CA4\u9547\uD868\uDE93\u71A2\uD868\uDEFF\u4D91\u9012\uD869\uDDCB\u4D9C\uD843\uDC9C\u8FBE\u55C1"],
    ["9da1", "\u8FBA\uD849\uDCB0\u8FB9\uD852\uDE93\u4509\u7E7F\u6F56\u6AB1\u4EEA\u34E4\uD862\uDF2C\uD85E\uDC9D\u373A\u8E80\uD845\uDFF5\uD860\uDC24\uD862\uDF6C\uD862\uDF99\uD85E\uDE3E\uD859\uDEAF\u3DEB\uD85D\uDE55\uD84F\uDCB7\uD855\uDE35\uD856\uDD56\u4E9A\uD857\uDE81\uD858\uDE58\u56BF\uD843\uDE6D\u8E0E\u5B6D\uD84F\uDE88\uD853\uDC9E\u63DE\u62D0\uD845\uDFF6\uD846\uDC7B\u6530\u562D\uD857\uDC4A\u541A\uD854\uDF11\u3DC6\uD867\uDD98\u4C7D\u5622\u561E\u7F49\uD857\uDED8\u5975\uD84F\uDD40\u8770\u4E1C\uD843\uDFEA\uD843\uDD49\uD84D\uDEBA\u8117\u9D5E\u8D18\u763B\u9C45\u764E\u77B9\u9345\u5432\u8148\u82F7\u5625\u8132\u8418\u80BD\u55EA\u7962\u5643\u5416\uD843\uDE9D\u35CE\u5605\u55F1\u66F1\uD860\uDEE2\u362D\u7534\u55F0\u55BA\u5497\u5572\uD843\uDC41\uD843\uDC96\u5ED0\uD854\uDD48\uD843\uDE76\uD84B\uDC62"],
    ["9e40", "\uD843\uDEA2\u9EAB\u7D5A\u55DE\uD844\uDC75\u629D\u976D\u5494\u8CCD\u71F6\u9176\u63FC\u63B9\u63FE\u5569\uD84A\uDF43\u9C72\uD84B\uDEB3\u519A\u34DF\uD843\uDDA7\u51A7\u544D\u551E\u5513\u7666\u8E2D\uD85A\uDC8A\u75B1\u80B6\u8804\u8786\u88C7\u81B6\u841C\uD844\uDCC1\u44EC\u7304\uD851\uDF06\u5B90\u830B\uD85A\uDC93\u567B\uD849\uDEF4\uD85F\uDD2F\uD850\uDDA3\uD85F\uDD73\uD85B\uDED0\uD85C\uDEB6\u9170\uD844\uDDD9\u9208\uD84F\uDCFC\uD869\uDEA9\uD843\uDEAC\uD843\uDEF9\u7266\uD847\uDCA2\u474E\uD853\uDFC2\uD85F\uDFF9\uD843\uDFEB\u40FA"],
    ["9ea1", "\u9C5D\u651F\uD84B\uDDA0\u48F3\uD851\uDFE0\uD867\uDD7C\uD843\uDFEC\uD843\uDE0A\u6062\uD85D\uDDA3\uD843\uDFED"],
    ["9ead", "\uD858\uDC48\uD844\uDD87\u71A3\u7E8E\u9D50\u4E1A\u4E04\u3577\u5B0D\u6CB2\u5367\u36AC\u39DC\u537D\u36A5\uD851\uDE18\u589A\uD852\uDF6E\u822D\u544B\u57AA\uD856\uDE95\uD842\uDD79"],
    ["9ec5", "\u3A52\uD849\uDC65\u7374\uD867\uDEAC\u4D09\u9BED\uD84F\uDCFE\uD867\uDF30\u4C5B\uD853\uDFA9\uD865\uDD9E\uD867\uDFDE\u845C\uD84F\uDDB6\uD85C\uDEB2\uD859\uDFB3\uD84D\uDF20\u632E\u7D25\uD84F\uDEF7\uD84F\uDE2C\u3A2A\u9008\u52CC\u3E74\u367A\u45E9\uD841\uDC8E\u7640\u5AF0\uD843\uDEB6\u787A\uD85F\uDF2E\u58A7\u40BF\u567C\u9B8B\u5D74\u7654\uD869\uDC34\u9E85\u4CE1\u75F9\u37FB\u6119\uD84C\uDCDA\uD850\uDFF2"],
    ["9ef5", "\u565D\uD844\uDEA9\u57A7\uD852\uDD63\uD867\uDE06\u5234\uD85C\uDCAE\u35AD\u6C4A\u9D7C"],
    ["9f40", "\u7C56\u9B39\u57DE\uD845\uDF6C\u5C53\u64D3\uD865\uDCD0\uD858\uDF35\uD85C\uDD64\u86AD\uD843\uDD28\uD85B\uDD22\uD852\uDEE2\uD843\uDD71"],
    ["9f4f", "\u51FE\uD847\uDF0F\u5D8E\u9703\uD847\uDDD1\u9E81\u904C\u7B1F\u9B02\u5CD1\u7BA3\u6268\u6335\u9AFF\u7BCF\u9B2A\u7C7E\u9B2E\u7C42\u7C86\u9C15\u7BFC\u9B09\u9F17\u9C1B\uD852\uDD3E\u9F5A\u5573\u5BC3\u4FFD\u9E98\u4FF2\u5260\u3E06\u52D1\u5767\u5056\u59B7\u5E12\u97C8\u9DAB\u8F5C\u5469\u97B4\u9940\u97BA\u532C\u6130"],
    ["9fa1", "\u692C\u53DA\u9C0A\u9D02\u4C3B\u9641\u6980\u50A6\u7546\uD845\uDF6D\u99DA\u5273"],
    ["9fae", "\u9159\u9681\u915C"],
    ["9fb2", "\u9151\uD863\uDE97\u637F\uD85B\uDD23\u6ACA\u5611\u918E\u757A\u6285\uD840\uDFFC\u734F\u7C70\uD857\uDC21\uD84F\uDCFD"],
    ["9fc1", "\uD852\uDD19\u76D6\u9B9D\u4E2A\uD843\uDCD4\u83BE\u8842"],
    ["9fc9", "\u5C4A\u69C0\u50ED\u577A\u521F\u5DF5\u4ECE\u6C31\uD840\uDDF2\u4F39\u549C\u54DA\u529A\u8D82\u35FE\u5F0C\u35F3"],
    ["9fdb", "\u6B52\u917C\u9FA5\u9B97\u982E\u98B4\u9ABA\u9EA8\u9E84\u717A\u7B14"],
    ["9fe7", "\u6BFA\u8818\u7F78"],
    ["9feb", "\u5620\uD869\uDE4A\u8E77\u9F53"],
    ["9ff0", "\u8DD4\u8E4F\u9E1C\u8E01\u6282\uD860\uDF7D\u8E28\u8E75\u7AD3\uD852\uDE77\u7A3E\u78D8\u6CEA\u8A67\u7607"],
    ["a040", "\uD862\uDE5A\u9F26\u6CCE\u87D6\u75C3\uD868\uDEB2\u7853\uD87E\uDC40\u8D0C\u72E2\u7371\u8B2D\u7302\u74F1\u8CEB\uD852\uDEBB\u862F\u5FBA\u88A0\u44B7"],
    ["a055", "\uD846\uDC3B\uD85B\uDE05"],
    ["a058", "\u8A7E\uD849\uDD1B"],
    ["a05b", "\u60FD\u7667\u9AD7\u9D44\u936E\u9B8F\u87F5"],
    ["a063", "\u880F\u8CF7\u732C\u9721\u9BB0\u35D6\u72B2\u4C07\u7C51\u994A\uD858\uDD59\u6159\u4C04\u9E96\u617D"],
    ["a073", "\u575F\u616F\u62A6\u6239\u62CE\u3A5C\u61E2\u53AA\uD84C\uDFF5\u6364\u6802\u35D2"],
    ["a0a1", "\u5D57\uD862\uDFC2\u8FDA\uD863\uDE39"],
    ["a0a6", "\u50D9\uD847\uDD46\u7906\u5332\u9638\uD843\uDF3B\u4065"],
    ["a0ae", "\u77FE"],
    ["a0b0", "\u7CC2\uD857\uDF1A\u7CDA\u7A2D\u8066\u8063\u7D4D\u7505\u74F2\u8994\u821A\u670C\u8062\uD85D\uDC86\u805B\u74F0\u8103\u7724\u8989\uD859\uDFCC\u7553\uD85B\uDED1\u87A9\u87CE\u81C8\u878C\u8A49\u8CAD\u8B43\u772B\u74F8\u84DA\u3635\u69B2\u8DA6"],
    ["a0d4", "\u89A9\u7468\u6DB9\u87C1\uD850\uDC11\u74E7\u3DDB\u7176\u60A4\u619C\u3CD1\u7162\u6077"],
    ["a0e2", "\u7F71\uD862\uDF2D\u7250\u60E9\u4B7E\u5220\u3C18\uD84F\uDCC7\uD857\uDED7\uD85D\uDE56\uD855\uDD31\uD846\uDD44\uD844\uDEFE\uD866\uDD03\uD85B\uDDDC\uD85C\uDCAD\u5CC1\uD858\uDDAD\uD862\uDE0F\uD84D\uDE77\uD840\uDCEE\uD85A\uDC46\uD853\uDF0E\u4562\u5B1F\uD858\uDF4C\u9F50\u9EA6\uD858\uDE6B"],
    ["a3c0", "\u2400", 31, "\u2421"],
    ["c6a1", "\u2460", 9, "\u2474", 9, "\u2170", 9, "\u4E36\u4E3F\u4E85\u4EA0\u5182\u5196\u51AB\u52F9\u5338\u5369\u53B6\u590A\u5B80\u5DDB\u2F33\u5E7F\u5EF4\u5F50\u5F61\u6534\u65E0\u7592\u7676\u8FB5\u96B6\xA8\u02C6\u30FD\u30FE\u309D\u309E\u3003\u4EDD\u3005\u3006\u3007\u30FC\uFF3B\uFF3D\u273D\u3041", 23],
    ["c740", "\u3059", 58, "\u30A1\u30A2\u30A3\u30A4"],
    ["c7a1", "\u30A5", 81, "\u0410", 5, "\u0401\u0416", 4],
    ["c840", "\u041B", 26, "\u0451\u0436", 25, "\u21E7\u21B8\u21B9\u31CF\uD840\uDCCC\u4E5A\uD840\uDC8A\u5202\u4491"],
    ["c8a1", "\u9FB0\u5188\u9FB1\uD85D\uDE07"],
    ["c8cd", "\uFFE2\uFFE4\uFF07\uFF02\u3231\u2116\u2121\u309B\u309C\u2E80\u2E84\u2E86\u2E87\u2E88\u2E8A\u2E8C\u2E8D\u2E95\u2E9C\u2E9D\u2EA5\u2EA7\u2EAA\u2EAC\u2EAE\u2EB6\u2EBC\u2EBE\u2EC6\u2ECA\u2ECC\u2ECD\u2ECF\u2ED6\u2ED7\u2EDE\u2EE3"],
    ["c8f5", "\u0283\u0250\u025B\u0254\u0275\u0153\xF8\u014B\u028A\u026A"],
    ["f9fe", "\uFFED"],
    ["fa40", "\uD841\uDD47\u92DB\uD841\uDDDF\uD84F\uDFC5\u854C\u42B5\u73EF\u51B5\u3649\uD852\uDD42\uD862\uDDE4\u9344\uD846\uDDDB\u82EE\uD84F\uDCC8\u783C\u6744\u62DF\uD852\uDD33\uD862\uDDAA\uD840\uDEA0\uD85A\uDFB3\uD844\uDF05\u4FAB\uD849\uDCED\u5008\uD85B\uDD29\uD85E\uDE84\uD84D\uDE00\uD852\uDEB1\uD849\uDD13\u5029\uD840\uDF7E\u5FA4\uD840\uDF80\uD840\uDF47\u6EDB\uD841\uDC1F\u507D\u5101\u347A\u510E\u986C\u3743\u8416\uD852\uDDA4\uD841\uDC87\u5160\uD84C\uDFB4\u516A\uD842\uDFFF\uD848\uDCFC\uD840\uDEE5\uD849\uDD30\uD841\uDD8E\uD84C\uDE33\uD846\uDD83\u5B82\u877D\uD841\uDDB3\uD84F\uDC99\u51B2\u51B8"],
    ["faa1", "\u9D34\u51C9\u51CF\u51D1\u3CDC\u51D3\uD852\uDEA6\u51B3\u51E2\u5342\u51ED\u83CD\u693E\uD84D\uDF2D\u5F7B\u520B\u5226\u523C\u52B5\u5257\u5294\u52B9\u52C5\u7C15\u8542\u52E0\u860D\uD85A\uDF13\u5305\uD862\uDEDE\u5549\u6ED9\uD84F\uDF80\uD842\uDD54\uD84F\uDFEC\u5333\u5344\uD842\uDFE2\u6CCB\uD845\uDF26\u681B\u73D5\u604A\u3EAA\u38CC\uD845\uDEE8\u71DD\u44A2\u536D\u5374\uD861\uDEAB\u537E\u537F\uD845\uDD96\uD845\uDE13\u77E6\u5393\uD862\uDE9B\u53A0\u53AB\u53AE\u73A7\uD855\uDF72\u3F59\u739C\u53C1\u53C5\u6C49\u4E49\u57FE\u53D9\u3AAB\uD842\uDF8F\u53E0\uD84F\uDFEB\uD84B\uDDA3\u53F6\uD843\uDC77\u5413\u7079\u552B\u6657\u6D5B\u546D\uD85A\uDF53\uD843\uDD74\u555D\u548F\u54A4\u47A6\uD845\uDF0D\uD843\uDEDD\u3DB4\uD843\uDD4D"],
    ["fb40", "\uD862\uDDBC\uD849\uDE98\u5547\u4CED\u542F\u7417\u5586\u55A9\u5605\uD846\uDCD7\uD850\uDC3A\u4552\uD851\uDC35\u66B3\uD844\uDCB4\u5637\u66CD\uD84C\uDE8A\u66A4\u66AD\u564D\u564F\u78F1\u56F1\u9787\u53FE\u5700\u56EF\u56ED\uD862\uDF66\u3623\uD844\uDE4F\u5746\uD850\uDDA5\u6C6E\u708B\u5742\u36B1\uD85B\uDC7E\u57E6\uD845\uDC16\u5803\uD845\uDC54\uD850\uDF63\u5826\uD852\uDFF5\u585C\u58AA\u3561\u58E0\u58DC\uD844\uDE3C\u58FB\u5BFF\u5743\uD868\uDD50\uD850\uDE78\u93D3\u35A1\u591F\u68A6\u36C3\u6E59"],
    ["fba1", "\uD845\uDE3E\u5A24\u5553\uD845\uDE92\u8505\u59C9\uD843\uDD4E\uD85B\uDC81\uD85B\uDD2A\uD845\uDFDC\u59D9\uD845\uDFFB\uD845\uDFB2\uD85B\uDDA6\u6D71\uD846\uDC28\uD845\uDED5\u59F9\uD85B\uDE45\u5AAB\u5A63\u36E6\uD852\uDDA9\u5A77\u3708\u5A96\u7465\u5AD3\uD85B\uDFA1\uD849\uDD54\u3D85\uD846\uDD11\u3732\uD845\uDEB8\u5E83\u52D0\u5B76\u6588\u5B7C\uD85E\uDE0E\u4004\u485D\uD840\uDE04\u5BD5\u6160\uD846\uDE34\uD856\uDDCC\uD841\uDDA5\u5BF3\u5B9D\u4D10\u5C05\uD846\uDF44\u5C13\u73CE\u5C14\uD847\uDCA5\uD85A\uDF28\u5C49\u48DD\u5C85\u5CE9\u5CEF\u5D8B\uD847\uDDF9\uD847\uDE37\u5D10\u5D18\u5D46\uD847\uDEA4\u5CBA\u5DD7\u82FC\u382D\uD852\uDD01\uD848\uDC49\uD848\uDD73\u8287\u3836\u3BC2\u5E2E\u6A8A\u5E75\u5E7A\uD851\uDCBC\uD843\uDCD3\u53A6\u4EB7\u5ED0\u53A8\uD845\uDF71\u5E09\u5EF4\uD861\uDC82"],
    ["fc40", "\u5EF9\u5EFB\u38A0\u5EFC\u683E\u941B\u5F0D\uD840\uDDC1\uD87E\uDC94\u3ADE\u48AE\uD844\uDF3A\u5F3A\uD85A\uDC88\uD848\uDFD0\u5F58\uD849\uDC71\u5F63\u97BD\uD85B\uDE6E\u5F72\u9340\uD862\uDE36\u5FA7\u5DB6\u3D5F\uD854\uDE50\uD847\uDF6A\uD85C\uDCF8\uD849\uDE68\u91D6\uD840\uDE9E\uD862\uDE29\u6031\u6685\uD846\uDC77\u3963\u3DC7\u3639\u5790\uD849\uDFB4\u7971\u3E40\u609E\u60A4\u60B3\uD852\uDD82\uD852\uDD8F\uD85E\uDE53\u74A4\u50E1\u5AA0\u6164\u8424\u6142\uD87E\uDCA6\uD85B\uDED2\u6181\u51F4\uD841\uDE56\u6187\u5BAA\uD84F\uDFB7"],
    ["fca1", "\uD84A\uDC5F\u61D3\uD862\uDF9D\uD866\uDD5D\u61D0\u3932\uD84A\uDD80\uD84A\uDCC1\u6023\u615C\u651E\u638B\uD840\uDD18\u62C5\uD845\uDF70\u62D5\uD84B\uDE0D\u636C\uD852\uDDDF\u3A17\u6438\u63F8\uD844\uDF8E\uD845\uDFFC\u6490\u6F8A\uD84B\uDE36\u9814\uD850\uDC8C\uD855\uDF1D\u64E1\u64E5\u947B\u3A66\u643A\u3A57\u654D\u6F16\uD852\uDE28\uD852\uDE23\u6585\u656D\u655F\uD84C\uDC7E\u65B5\uD852\uDD40\u4B37\u65D1\u40D8\uD846\uDC29\u65E0\u65E3\u5FDF\uD84D\uDC00\u6618\uD84C\uDDF7\uD84C\uDDF8\u6644\uD84C\uDDA4\uD84C\uDDA5\u664B\uD843\uDE75\u6667\uD854\uDDE6\u6673\u6674\uD847\uDE3D\uD84C\uDE31\uD861\uDDF4\uD84C\uDDC8\uD854\uDF13\u77C5\uD84A\uDCF7\u99A4\u6702\uD850\uDF9C\uD852\uDE21\u3B2B\u69FA\uD84D\uDFC2\u675E\u6767\u6762\uD850\uDDCD\uD864\uDCED\u67D7\u44E9\u6822\u6E50\u923C\u6801\uD84C\uDFE6\uD85B\uDDA0\u685D"],
    ["fd40", "\uD84D\uDC6F\u69E1\u6A0B\uD862\uDEDF\u6973\u68C3\uD84D\uDDCD\u6901\u6900\u3D32\u3A01\uD84D\uDE3C\u3B80\u67AC\u6961\uD862\uDE4A\u42FC\u6936\u6998\u3BA1\uD840\uDFC9\u8363\u5090\u69F9\uD84D\uDE59\uD848\uDD2A\u6A45\uD84D\uDF03\u6A9D\u3BF3\u67B1\u6AC8\uD864\uDD9C\u3C0D\u6B1D\uD842\uDD23\u60DE\u6B35\u6B74\uD849\uDFCD\u6EB5\uD84E\uDEDB\uD840\uDFB5\uD846\uDD58\u3740\u5421\uD84E\uDF5A\u6BE1\uD84F\uDEFC\u6BDC\u6C37\uD849\uDC8B\uD852\uDCF1\uD85A\uDF51\u6C5A\u8226\u6C79\uD84F\uDDBC\u44C5\uD84F\uDDBD\uD850\uDDA4\uD852\uDD0C\uD852\uDD00"],
    ["fda1", "\uD84F\uDCC9\u36E5\u3CEB\uD843\uDD32\u9B83\uD84C\uDDF9\uD849\uDC91\u7F8F\u6837\uD85B\uDD25\uD85B\uDDA1\uD85B\uDDEB\u6D96\u6D5C\u6E7C\u6F04\uD852\uDD7F\uD850\uDC85\uD85B\uDE72\u8533\uD85B\uDF74\u51C7\u6C9C\u6E1D\u842E\uD862\uDF21\u6E2F\uD84F\uDE2F\u7453\uD84F\uDF82\u79CC\u6E4F\u5A91\uD84C\uDC4B\u6FF8\u370D\u6F9D\uD84F\uDE30\u6EFA\uD845\uDC97\uD850\uDC3D\u4555\u93F0\u6F44\u6F5C\u3D4E\u6F74\uD864\uDD70\u3D3B\u6F9F\uD850\uDD44\u6FD3\uD850\uDC91\uD850\uDD55\uD850\uDC39\uD84F\uDFF0\uD84F\uDFB4\uD850\uDD3F\u51DF\uD850\uDD56\uD850\uDD57\uD850\uDD40\uD858\uDDDD\u704B\u707E\u70A7\u7081\u70CC\u70D5\u70D6\u70DF\u4104\u3DE8\u71B4\u7196\uD850\uDE77\u712B\u7145\u5A88\u714A\u716E\u5C9C\uD850\uDF65\u714F\u9362\uD850\uDEC1\u712C\uD851\uDC5A\uD852\uDE27\uD852\uDE22\u71BA\uD862\uDFE8\u70BD\u720E"],
    ["fe40", "\u9442\u7215\u5911\u9443\u7224\u9341\uD855\uDE05\u722E\u7240\uD852\uDD74\u68BD\u7255\u7257\u3E55\uD84C\uDC44\u680D\u6F3D\u7282\u732A\u732B\uD852\uDC23\uD862\uDC2B\u48ED\uD862\uDC04\u7328\u732E\u73CF\u73AA\uD843\uDC3A\uD85A\uDE2E\u73C9\u7449\uD850\uDDE2\uD845\uDEE7\uD852\uDE24\u6623\u36C5\uD852\uDDB7\uD852\uDD8D\uD852\uDDFB\u73F7\u7415\u6903\uD852\uDE26\u7439\uD841\uDDC3\u3ED7\u745C\uD84A\uDCAD\u7460\uD863\uDEB2\u7447\u73E4\u7476\u83B9\u746C\u3730\u7474\u93F1\u6A2C\u7482\u4953\uD852\uDE8C"],
    ["fea1", "\uD850\uDD5F\uD852\uDE79\uD862\uDF8F\u5B46\uD863\uDC03\uD846\uDC9E\u74C8\uD846\uDD88\u750E\u74E9\u751E\uD863\uDED9\uD846\uDE4B\u5BD7\uD863\uDEAC\u9385\u754D\u754A\u7567\u756E\uD853\uDF82\u3F04\uD853\uDD13\u758E\u745D\u759E\u75B4\u7602\u762C\u7651\u764F\u766F\u7676\uD858\uDFF5\u7690\u81EF\u37F8\uD85A\uDD11\uD85A\uDD0E\u76A1\u76A5\u76B7\u76CC\uD85B\uDF9F\u8462\uD854\uDC9D\uD854\uDD7D\uD847\uDE1C\u771E\u7726\u7740\u64AF\uD854\uDE20\u7758\uD84C\uDEAC\u77AF\uD862\uDD64\uD862\uDD68\uD845\uDEC1\u77F4\u7809\uD844\uDF76\uD852\uDE12\u68CA\u78AF\u78C7\u78D3\u96A5\u792E\uD855\uDDE0\u78D7\u7934\u78B1\uD85D\uDE0C\u8FB8\u8884\uD862\uDF2B\uD858\uDC83\uD849\uDE1C\u7986\u8900\u6902\u7980\uD856\uDC57\u799D\uD85E\uDF39\u793C\u79A9\u6E2A\uD85C\uDD26\u3EA8\u79C6\uD864\uDD0D\u79D4"]
  ];
});
var require_dbcs_data = __commonJS2((exports, module) => {
  module.exports = {
    shiftjis: {
      type: "_dbcs",
      table: function() {
        return require_shiftjis();
      },
      encodeAdd: { "\xA5": 92, "\u203E": 126 },
      encodeSkipVals: [{ from: 60736, to: 63808 }]
    },
    csshiftjis: "shiftjis",
    mskanji: "shiftjis",
    sjis: "shiftjis",
    windows31j: "shiftjis",
    ms31j: "shiftjis",
    xsjis: "shiftjis",
    windows932: "shiftjis",
    ms932: "shiftjis",
    "932": "shiftjis",
    cp932: "shiftjis",
    eucjp: {
      type: "_dbcs",
      table: function() {
        return require_eucjp();
      },
      encodeAdd: { "\xA5": 92, "\u203E": 126 }
    },
    gb2312: "cp936",
    gb231280: "cp936",
    gb23121980: "cp936",
    csgb2312: "cp936",
    csiso58gb231280: "cp936",
    euccn: "cp936",
    windows936: "cp936",
    ms936: "cp936",
    "936": "cp936",
    cp936: {
      type: "_dbcs",
      table: function() {
        return require_cp936();
      }
    },
    gbk: {
      type: "_dbcs",
      table: function() {
        return require_cp936().concat(require_gbk_added());
      }
    },
    xgbk: "gbk",
    isoir58: "gbk",
    gb18030: {
      type: "_dbcs",
      table: function() {
        return require_cp936().concat(require_gbk_added());
      },
      gb18030: function() {
        return require_gb18030_ranges();
      },
      encodeSkipVals: [128],
      encodeAdd: { "\u20AC": 41699 }
    },
    chinese: "gb18030",
    windows949: "cp949",
    ms949: "cp949",
    "949": "cp949",
    cp949: {
      type: "_dbcs",
      table: function() {
        return require_cp949();
      }
    },
    cseuckr: "cp949",
    csksc56011987: "cp949",
    euckr: "cp949",
    isoir149: "cp949",
    korean: "cp949",
    ksc56011987: "cp949",
    ksc56011989: "cp949",
    ksc5601: "cp949",
    windows950: "cp950",
    ms950: "cp950",
    "950": "cp950",
    cp950: {
      type: "_dbcs",
      table: function() {
        return require_cp950();
      }
    },
    big5: "big5hkscs",
    big5hkscs: {
      type: "_dbcs",
      table: function() {
        return require_cp950().concat(require_big5_added());
      },
      encodeSkipVals: [
        36457,
        36463,
        36478,
        36523,
        36532,
        36557,
        36560,
        36695,
        36713,
        36718,
        36811,
        36862,
        36973,
        36986,
        37060,
        37084,
        37105,
        37311,
        37551,
        37552,
        37553,
        37554,
        37585,
        37959,
        38090,
        38361,
        38652,
        39285,
        39798,
        39800,
        39803,
        39878,
        39902,
        39916,
        39926,
        40002,
        40019,
        40034,
        40040,
        40043,
        40055,
        40124,
        40125,
        40144,
        40279,
        40282,
        40388,
        40431,
        40443,
        40617,
        40687,
        40701,
        40800,
        40907,
        41079,
        41180,
        41183,
        36812,
        37576,
        38468,
        38637,
        41636,
        41637,
        41639,
        41638,
        41676,
        41678
      ]
    },
    cnbig5: "big5hkscs",
    csbig5: "big5hkscs",
    xxbig5: "big5hkscs"
  };
});
var require_encodings = __commonJS2((exports, module) => {
  var modules = [
    require_internal(),
    require_utf32(),
    require_utf16(),
    require_utf7(),
    require_sbcs_codec(),
    require_sbcs_data(),
    require_sbcs_data_generated(),
    require_dbcs_codec(),
    require_dbcs_data()
  ];
  for (i2 = 0;i2 < modules.length; i2++) {
    module = modules[i2];
    for (enc in module)
      if (Object.prototype.hasOwnProperty.call(module, enc))
        exports[enc] = module[enc];
  }
  var module;
  var enc;
  var i2;
});
var require_streams = __commonJS2((exports, module) => {
  var Buffer22 = require_safer().Buffer;
  module.exports = function(stream_module) {
    var Transform2 = stream_module.Transform;
    function IconvLiteEncoderStream(conv, options3) {
      this.conv = conv;
      options3 = options3 || {};
      options3.decodeStrings = false;
      Transform2.call(this, options3);
    }
    IconvLiteEncoderStream.prototype = Object.create(Transform2.prototype, {
      constructor: { value: IconvLiteEncoderStream }
    });
    IconvLiteEncoderStream.prototype._transform = function(chunk, encoding, done) {
      if (typeof chunk != "string")
        return done(new Error("Iconv encoding stream needs strings as its input."));
      try {
        var res = this.conv.write(chunk);
        if (res && res.length)
          this.push(res);
        done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteEncoderStream.prototype._flush = function(done) {
      try {
        var res = this.conv.end();
        if (res && res.length)
          this.push(res);
        done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteEncoderStream.prototype.collect = function(cb) {
      var chunks = [];
      this.on("error", cb);
      this.on("data", function(chunk) {
        chunks.push(chunk);
      });
      this.on("end", function() {
        cb(null, Buffer22.concat(chunks));
      });
      return this;
    };
    function IconvLiteDecoderStream(conv, options3) {
      this.conv = conv;
      options3 = options3 || {};
      options3.encoding = this.encoding = "utf8";
      Transform2.call(this, options3);
    }
    IconvLiteDecoderStream.prototype = Object.create(Transform2.prototype, {
      constructor: { value: IconvLiteDecoderStream }
    });
    IconvLiteDecoderStream.prototype._transform = function(chunk, encoding, done) {
      if (!Buffer22.isBuffer(chunk) && !(chunk instanceof Uint8Array))
        return done(new Error("Iconv decoding stream needs buffers as its input."));
      try {
        var res = this.conv.write(chunk);
        if (res && res.length)
          this.push(res, this.encoding);
        done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteDecoderStream.prototype._flush = function(done) {
      try {
        var res = this.conv.end();
        if (res && res.length)
          this.push(res, this.encoding);
        done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteDecoderStream.prototype.collect = function(cb) {
      var res = "";
      this.on("error", cb);
      this.on("data", function(chunk) {
        res += chunk;
      });
      this.on("end", function() {
        cb(null, res);
      });
      return this;
    };
    return {
      IconvLiteEncoderStream,
      IconvLiteDecoderStream
    };
  };
});
var require_lib15 = __commonJS2((exports, module) => {
  var Buffer22 = require_safer().Buffer;
  var bomHandling = require_bom_handling();
  var iconv = exports;
  iconv.encodings = null;
  iconv.defaultCharUnicode = "\uFFFD";
  iconv.defaultCharSingleByte = "?";
  iconv.encode = function encode(str, encoding, options3) {
    str = "" + (str || "");
    var encoder = iconv.getEncoder(encoding, options3);
    var res = encoder.write(str);
    var trail = encoder.end();
    return trail && trail.length > 0 ? Buffer22.concat([res, trail]) : res;
  };
  iconv.decode = function decode(buf, encoding, options3) {
    if (typeof buf === "string") {
      if (!iconv.skipDecodeWarning) {
        console.error("Iconv-lite warning: decode()-ing strings is deprecated. Refer to https://github.com/ashtuchkin/iconv-lite/wiki/Use-Buffers-when-decoding");
        iconv.skipDecodeWarning = true;
      }
      buf = Buffer22.from("" + (buf || ""), "binary");
    }
    var decoder = iconv.getDecoder(encoding, options3);
    var res = decoder.write(buf);
    var trail = decoder.end();
    return trail ? res + trail : res;
  };
  iconv.encodingExists = function encodingExists(enc) {
    try {
      iconv.getCodec(enc);
      return true;
    } catch (e) {
      return false;
    }
  };
  iconv.toEncoding = iconv.encode;
  iconv.fromEncoding = iconv.decode;
  iconv._codecDataCache = {};
  iconv.getCodec = function getCodec(encoding) {
    if (!iconv.encodings)
      iconv.encodings = require_encodings();
    var enc = iconv._canonicalizeEncoding(encoding);
    var codecOptions = {};
    while (true) {
      var codec = iconv._codecDataCache[enc];
      if (codec)
        return codec;
      var codecDef = iconv.encodings[enc];
      switch (typeof codecDef) {
        case "string":
          enc = codecDef;
          break;
        case "object":
          for (var key in codecDef)
            codecOptions[key] = codecDef[key];
          if (!codecOptions.encodingName)
            codecOptions.encodingName = enc;
          enc = codecDef.type;
          break;
        case "function":
          if (!codecOptions.encodingName)
            codecOptions.encodingName = enc;
          codec = new codecDef(codecOptions, iconv);
          iconv._codecDataCache[codecOptions.encodingName] = codec;
          return codec;
        default:
          throw new Error("Encoding not recognized: '" + encoding + "' (searched as: '" + enc + "')");
      }
    }
  };
  iconv._canonicalizeEncoding = function(encoding) {
    return ("" + encoding).toLowerCase().replace(/:\d{4}$|[^0-9a-z]/g, "");
  };
  iconv.getEncoder = function getEncoder(encoding, options3) {
    var codec = iconv.getCodec(encoding), encoder = new codec.encoder(options3, codec);
    if (codec.bomAware && options3 && options3.addBOM)
      encoder = new bomHandling.PrependBOM(encoder, options3);
    return encoder;
  };
  iconv.getDecoder = function getDecoder(encoding, options3) {
    var codec = iconv.getCodec(encoding), decoder = new codec.decoder(options3, codec);
    if (codec.bomAware && !(options3 && options3.stripBOM === false))
      decoder = new bomHandling.StripBOM(decoder, options3);
    return decoder;
  };
  iconv.enableStreamingAPI = function enableStreamingAPI(stream_module2) {
    if (iconv.supportsStreams)
      return;
    var streams = require_streams()(stream_module2);
    iconv.IconvLiteEncoderStream = streams.IconvLiteEncoderStream;
    iconv.IconvLiteDecoderStream = streams.IconvLiteDecoderStream;
    iconv.encodeStream = function encodeStream(encoding, options3) {
      return new iconv.IconvLiteEncoderStream(iconv.getEncoder(encoding, options3), options3);
    };
    iconv.decodeStream = function decodeStream(encoding, options3) {
      return new iconv.IconvLiteDecoderStream(iconv.getDecoder(encoding, options3), options3);
    };
    iconv.supportsStreams = true;
  };
  var stream_module;
  try {
    stream_module = import.meta.require("stream");
  } catch (e) {
  }
  if (stream_module && stream_module.Transform) {
    iconv.enableStreamingAPI(stream_module);
  } else {
    iconv.encodeStream = iconv.decodeStream = function() {
      throw new Error("iconv-lite Streaming API is not enabled. Use iconv.enableStreamingAPI(require('stream')); to enable it.");
    };
  }
  if (false) {
  }
});
var require_string2 = __commonJS2((exports) => {
  var Iconv = require_lib15();
  var { createLRU } = require_lib14();
  var decoderCache = createLRU({
    max: 500
  });
  exports.decode = function(buffer, encoding, start, end, options3) {
    if (Buffer.isEncoding(encoding)) {
      return buffer.toString(encoding, start, end);
    }
    let decoder;
    if (!options3) {
      decoder = decoderCache.get(encoding);
      if (!decoder) {
        decoder = Iconv.getDecoder(encoding);
        decoderCache.set(encoding, decoder);
      }
    } else {
      const decoderArgs = { encoding, options: options3 };
      const decoderKey = JSON.stringify(decoderArgs);
      decoder = decoderCache.get(decoderKey);
      if (!decoder) {
        decoder = Iconv.getDecoder(decoderArgs.encoding, decoderArgs.options);
        decoderCache.set(decoderKey, decoder);
      }
    }
    const res = decoder.write(buffer.slice(start, end));
    const trail = decoder.end();
    return trail ? res + trail : res;
  };
  exports.encode = function(string2, encoding, options3) {
    if (Buffer.isEncoding(encoding)) {
      return Buffer.from(string2, encoding);
    }
    const encoder = Iconv.getEncoder(encoding, options3 || {});
    const res = encoder.write(string2);
    const trail = encoder.end();
    return trail && trail.length > 0 ? Buffer.concat([res, trail]) : res;
  };
});
var require_packet = __commonJS2((exports, module) => {
  var ErrorCodeToName = require_errors();
  var NativeBuffer = import.meta.require("buffer").Buffer;
  var Long = require_umd();
  var StringParser = require_string2();
  var INVALID_DATE = new Date(NaN);
  var pad = "000000000000";
  function leftPad(num, value) {
    const s32 = value.toString();
    if (s32.length >= num) {
      return s32;
    }
    return (pad + s32).slice(-num);
  }
  var minus = "-".charCodeAt(0);
  var plus = "+".charCodeAt(0);
  var dot = ".".charCodeAt(0);
  var exponent = "e".charCodeAt(0);
  var exponentCapital = "E".charCodeAt(0);

  class Packet {
    constructor(id, buffer, start, end) {
      this.sequenceId = id;
      this.numPackets = 1;
      this.buffer = buffer;
      this.start = start;
      this.offset = start + 4;
      this.end = end;
    }
    reset() {
      this.offset = this.start + 4;
    }
    length() {
      return this.end - this.start;
    }
    slice() {
      return this.buffer.slice(this.start, this.end);
    }
    dump() {
      console.log([this.buffer.asciiSlice(this.start, this.end)], this.buffer.slice(this.start, this.end), this.length(), this.sequenceId);
    }
    haveMoreData() {
      return this.end > this.offset;
    }
    skip(num) {
      this.offset += num;
    }
    readInt8() {
      return this.buffer[this.offset++];
    }
    readInt16() {
      this.offset += 2;
      return this.buffer.readUInt16LE(this.offset - 2);
    }
    readInt24() {
      return this.readInt16() + (this.readInt8() << 16);
    }
    readInt32() {
      this.offset += 4;
      return this.buffer.readUInt32LE(this.offset - 4);
    }
    readSInt8() {
      return this.buffer.readInt8(this.offset++);
    }
    readSInt16() {
      this.offset += 2;
      return this.buffer.readInt16LE(this.offset - 2);
    }
    readSInt32() {
      this.offset += 4;
      return this.buffer.readInt32LE(this.offset - 4);
    }
    readInt64JSNumber() {
      const word0 = this.readInt32();
      const word1 = this.readInt32();
      const l22 = new Long(word0, word1, true);
      return l22.toNumber();
    }
    readSInt64JSNumber() {
      const word0 = this.readInt32();
      const word1 = this.readInt32();
      if (!(word1 & 2147483648)) {
        return word0 + 4294967296 * word1;
      }
      const l22 = new Long(word0, word1, false);
      return l22.toNumber();
    }
    readInt64String() {
      const word0 = this.readInt32();
      const word1 = this.readInt32();
      const res = new Long(word0, word1, true);
      return res.toString();
    }
    readSInt64String() {
      const word0 = this.readInt32();
      const word1 = this.readInt32();
      const res = new Long(word0, word1, false);
      return res.toString();
    }
    readInt64() {
      const word0 = this.readInt32();
      const word1 = this.readInt32();
      let res = new Long(word0, word1, true);
      const resNumber = res.toNumber();
      const resString = res.toString();
      res = resNumber.toString() === resString ? resNumber : resString;
      return res;
    }
    readSInt64() {
      const word0 = this.readInt32();
      const word1 = this.readInt32();
      let res = new Long(word0, word1, false);
      const resNumber = res.toNumber();
      const resString = res.toString();
      res = resNumber.toString() === resString ? resNumber : resString;
      return res;
    }
    isEOF() {
      return this.buffer[this.offset] === 254 && this.length() < 13;
    }
    eofStatusFlags() {
      return this.buffer.readInt16LE(this.offset + 3);
    }
    eofWarningCount() {
      return this.buffer.readInt16LE(this.offset + 1);
    }
    readLengthCodedNumber(bigNumberStrings, signed) {
      const byte1 = this.buffer[this.offset++];
      if (byte1 < 251) {
        return byte1;
      }
      return this.readLengthCodedNumberExt(byte1, bigNumberStrings, signed);
    }
    readLengthCodedNumberSigned(bigNumberStrings) {
      return this.readLengthCodedNumber(bigNumberStrings, true);
    }
    readLengthCodedNumberExt(tag, bigNumberStrings, signed) {
      let word0, word1;
      let res;
      if (tag === 251) {
        return null;
      }
      if (tag === 252) {
        return this.readInt8() + (this.readInt8() << 8);
      }
      if (tag === 253) {
        return this.readInt8() + (this.readInt8() << 8) + (this.readInt8() << 16);
      }
      if (tag === 254) {
        word0 = this.readInt32();
        word1 = this.readInt32();
        if (word1 === 0) {
          return word0;
        }
        if (word1 < 2097152) {
          return word1 * 4294967296 + word0;
        }
        res = new Long(word0, word1, !signed);
        const resNumber = res.toNumber();
        const resString = res.toString();
        res = resNumber.toString() === resString ? resNumber : resString;
        return bigNumberStrings ? resString : res;
      }
      console.trace();
      throw new Error(`Should not reach here: ${tag}`);
    }
    readFloat() {
      const res = this.buffer.readFloatLE(this.offset);
      this.offset += 4;
      return res;
    }
    readDouble() {
      const res = this.buffer.readDoubleLE(this.offset);
      this.offset += 8;
      return res;
    }
    readBuffer(len) {
      if (typeof len === "undefined") {
        len = this.end - this.offset;
      }
      this.offset += len;
      return this.buffer.slice(this.offset - len, this.offset);
    }
    readDateTime(timezone) {
      if (!timezone || timezone === "Z" || timezone === "local") {
        const length = this.readInt8();
        if (length === 251) {
          return null;
        }
        let y = 0;
        let m22 = 0;
        let d = 0;
        let H22 = 0;
        let M22 = 0;
        let S = 0;
        let ms = 0;
        if (length > 3) {
          y = this.readInt16();
          m22 = this.readInt8();
          d = this.readInt8();
        }
        if (length > 6) {
          H22 = this.readInt8();
          M22 = this.readInt8();
          S = this.readInt8();
        }
        if (length > 10) {
          ms = this.readInt32() / 1000;
        }
        if (y + m22 + d + H22 + M22 + S + ms === 0) {
          return INVALID_DATE;
        }
        if (timezone === "Z") {
          return new Date(Date.UTC(y, m22 - 1, d, H22, M22, S, ms));
        }
        return new Date(y, m22 - 1, d, H22, M22, S, ms);
      }
      let str = this.readDateTimeString(6, "T");
      if (str.length === 10) {
        str += "T00:00:00";
      }
      return new Date(str + timezone);
    }
    readDateTimeString(decimals, timeSep) {
      const length = this.readInt8();
      let y = 0;
      let m22 = 0;
      let d = 0;
      let H22 = 0;
      let M22 = 0;
      let S = 0;
      let ms = 0;
      let str;
      if (length > 3) {
        y = this.readInt16();
        m22 = this.readInt8();
        d = this.readInt8();
        str = [leftPad(4, y), leftPad(2, m22), leftPad(2, d)].join("-");
      }
      if (length > 6) {
        H22 = this.readInt8();
        M22 = this.readInt8();
        S = this.readInt8();
        str += `${timeSep || " "}${[
          leftPad(2, H22),
          leftPad(2, M22),
          leftPad(2, S)
        ].join(":")}`;
      }
      if (length > 10) {
        ms = this.readInt32();
        str += ".";
        if (decimals) {
          ms = leftPad(6, ms);
          if (ms.length > decimals) {
            ms = ms.substring(0, decimals);
          }
        }
        str += ms;
      }
      return str;
    }
    readTimeString(convertTtoMs) {
      const length = this.readInt8();
      if (length === 0) {
        return "00:00:00";
      }
      const sign = this.readInt8() ? -1 : 1;
      let d = 0;
      let H22 = 0;
      let M22 = 0;
      let S = 0;
      let ms = 0;
      if (length > 6) {
        d = this.readInt32();
        H22 = this.readInt8();
        M22 = this.readInt8();
        S = this.readInt8();
      }
      if (length > 10) {
        ms = this.readInt32();
      }
      if (convertTtoMs) {
        H22 += d * 24;
        M22 += H22 * 60;
        S += M22 * 60;
        ms += S * 1000;
        ms *= sign;
        return ms;
      }
      return (sign === -1 ? "-" : "") + [leftPad(2, d * 24 + H22), leftPad(2, M22), leftPad(2, S)].join(":") + (ms ? `.${ms}`.replace(/0+$/, "") : "");
    }
    readLengthCodedString(encoding) {
      const len = this.readLengthCodedNumber();
      if (len === null) {
        return null;
      }
      this.offset += len;
      return StringParser.decode(this.buffer, encoding, this.offset - len, this.offset);
    }
    readLengthCodedBuffer() {
      const len = this.readLengthCodedNumber();
      if (len === null) {
        return null;
      }
      return this.readBuffer(len);
    }
    readNullTerminatedString(encoding) {
      const start = this.offset;
      let end = this.offset;
      while (this.buffer[end]) {
        end = end + 1;
      }
      this.offset = end + 1;
      return StringParser.decode(this.buffer, encoding, start, end);
    }
    readString(len, encoding) {
      if (typeof len === "string" && typeof encoding === "undefined") {
        encoding = len;
        len = undefined;
      }
      if (typeof len === "undefined") {
        len = this.end - this.offset;
      }
      this.offset += len;
      return StringParser.decode(this.buffer, encoding, this.offset - len, this.offset);
    }
    parseInt(len, supportBigNumbers) {
      if (len === null) {
        return null;
      }
      if (len >= 14 && !supportBigNumbers) {
        const s32 = this.buffer.toString("ascii", this.offset, this.offset + len);
        this.offset += len;
        return Number(s32);
      }
      let result2 = 0;
      const start = this.offset;
      const end = this.offset + len;
      let sign = 1;
      if (len === 0) {
        return 0;
      }
      if (this.buffer[this.offset] === minus) {
        this.offset++;
        sign = -1;
      }
      let str;
      const numDigits = end - this.offset;
      if (supportBigNumbers) {
        if (numDigits >= 15) {
          str = this.readString(end - this.offset, "binary");
          result2 = parseInt(str, 10);
          if (result2.toString() === str) {
            return sign * result2;
          }
          return sign === -1 ? `-${str}` : str;
        }
        if (numDigits > 16) {
          str = this.readString(end - this.offset);
          return sign === -1 ? `-${str}` : str;
        }
      }
      if (this.buffer[this.offset] === plus) {
        this.offset++;
      }
      while (this.offset < end) {
        result2 *= 10;
        result2 += this.buffer[this.offset] - 48;
        this.offset++;
      }
      const num = result2 * sign;
      if (!supportBigNumbers) {
        return num;
      }
      str = this.buffer.toString("ascii", start, end);
      if (num.toString() === str) {
        return num;
      }
      return str;
    }
    parseIntNoBigCheck(len) {
      if (len === null) {
        return null;
      }
      let result2 = 0;
      const end = this.offset + len;
      let sign = 1;
      if (len === 0) {
        return 0;
      }
      if (this.buffer[this.offset] === minus) {
        this.offset++;
        sign = -1;
      }
      if (this.buffer[this.offset] === plus) {
        this.offset++;
      }
      while (this.offset < end) {
        result2 *= 10;
        result2 += this.buffer[this.offset] - 48;
        this.offset++;
      }
      return result2 * sign;
    }
    parseGeometryValue() {
      const buffer = this.readLengthCodedBuffer();
      let offset2 = 4;
      if (buffer === null || !buffer.length) {
        return null;
      }
      function parseGeometry() {
        let x, y, i2, j22, numPoints, line;
        let result2 = null;
        const byteOrder = buffer.readUInt8(offset2);
        offset2 += 1;
        const wkbType = byteOrder ? buffer.readUInt32LE(offset2) : buffer.readUInt32BE(offset2);
        offset2 += 4;
        switch (wkbType) {
          case 1:
            x = byteOrder ? buffer.readDoubleLE(offset2) : buffer.readDoubleBE(offset2);
            offset2 += 8;
            y = byteOrder ? buffer.readDoubleLE(offset2) : buffer.readDoubleBE(offset2);
            offset2 += 8;
            result2 = { x, y };
            break;
          case 2:
            numPoints = byteOrder ? buffer.readUInt32LE(offset2) : buffer.readUInt32BE(offset2);
            offset2 += 4;
            result2 = [];
            for (i2 = numPoints;i2 > 0; i2--) {
              x = byteOrder ? buffer.readDoubleLE(offset2) : buffer.readDoubleBE(offset2);
              offset2 += 8;
              y = byteOrder ? buffer.readDoubleLE(offset2) : buffer.readDoubleBE(offset2);
              offset2 += 8;
              result2.push({ x, y });
            }
            break;
          case 3:
            const numRings = byteOrder ? buffer.readUInt32LE(offset2) : buffer.readUInt32BE(offset2);
            offset2 += 4;
            result2 = [];
            for (i2 = numRings;i2 > 0; i2--) {
              numPoints = byteOrder ? buffer.readUInt32LE(offset2) : buffer.readUInt32BE(offset2);
              offset2 += 4;
              line = [];
              for (j22 = numPoints;j22 > 0; j22--) {
                x = byteOrder ? buffer.readDoubleLE(offset2) : buffer.readDoubleBE(offset2);
                offset2 += 8;
                y = byteOrder ? buffer.readDoubleLE(offset2) : buffer.readDoubleBE(offset2);
                offset2 += 8;
                line.push({ x, y });
              }
              result2.push(line);
            }
            break;
          case 4:
          case 5:
          case 6:
          case 7:
            const num = byteOrder ? buffer.readUInt32LE(offset2) : buffer.readUInt32BE(offset2);
            offset2 += 4;
            result2 = [];
            for (i2 = num;i2 > 0; i2--) {
              result2.push(parseGeometry());
            }
            break;
        }
        return result2;
      }
      return parseGeometry();
    }
    parseVector() {
      const bufLen = this.readLengthCodedNumber();
      const vectorEnd = this.offset + bufLen;
      const result2 = [];
      while (this.offset < vectorEnd && this.offset < this.end) {
        result2.push(this.readFloat());
      }
      return result2;
    }
    parseDate(timezone) {
      const strLen = this.readLengthCodedNumber();
      if (strLen === null) {
        return null;
      }
      if (strLen !== 10) {
        return new Date(NaN);
      }
      const y = this.parseInt(4);
      this.offset++;
      const m22 = this.parseInt(2);
      this.offset++;
      const d = this.parseInt(2);
      if (!timezone || timezone === "local") {
        return new Date(y, m22 - 1, d);
      }
      if (timezone === "Z") {
        return new Date(Date.UTC(y, m22 - 1, d));
      }
      return new Date(`${leftPad(4, y)}-${leftPad(2, m22)}-${leftPad(2, d)}T00:00:00${timezone}`);
    }
    parseDateTime(timezone) {
      const str = this.readLengthCodedString("binary");
      if (str === null) {
        return null;
      }
      if (!timezone || timezone === "local") {
        return new Date(str);
      }
      return new Date(`${str}${timezone}`);
    }
    parseFloat(len) {
      if (len === null) {
        return null;
      }
      let result2 = 0;
      const end = this.offset + len;
      let factor = 1;
      let pastDot = false;
      let charCode = 0;
      if (len === 0) {
        return 0;
      }
      if (this.buffer[this.offset] === minus) {
        this.offset++;
        factor = -1;
      }
      if (this.buffer[this.offset] === plus) {
        this.offset++;
      }
      while (this.offset < end) {
        charCode = this.buffer[this.offset];
        if (charCode === dot) {
          pastDot = true;
          this.offset++;
        } else if (charCode === exponent || charCode === exponentCapital) {
          this.offset++;
          const exponentValue = this.parseInt(end - this.offset);
          return result2 / factor * Math.pow(10, exponentValue);
        } else {
          result2 *= 10;
          result2 += this.buffer[this.offset] - 48;
          this.offset++;
          if (pastDot) {
            factor = factor * 10;
          }
        }
      }
      return result2 / factor;
    }
    parseLengthCodedIntNoBigCheck() {
      return this.parseIntNoBigCheck(this.readLengthCodedNumber());
    }
    parseLengthCodedInt(supportBigNumbers) {
      return this.parseInt(this.readLengthCodedNumber(), supportBigNumbers);
    }
    parseLengthCodedIntString() {
      return this.readLengthCodedString("binary");
    }
    parseLengthCodedFloat() {
      return this.parseFloat(this.readLengthCodedNumber());
    }
    peekByte() {
      return this.buffer[this.offset];
    }
    isAlt() {
      return this.peekByte() === 254;
    }
    isError() {
      return this.peekByte() === 255;
    }
    asError(encoding) {
      this.reset();
      this.readInt8();
      const errorCode = this.readInt16();
      let sqlState = "";
      if (this.buffer[this.offset] === 35) {
        this.skip(1);
        sqlState = this.readBuffer(5).toString();
      }
      const message = this.readString(undefined, encoding);
      const err22 = new Error(message);
      err22.code = ErrorCodeToName[errorCode];
      err22.errno = errorCode;
      err22.sqlState = sqlState;
      err22.sqlMessage = message;
      return err22;
    }
    writeInt32(n) {
      this.buffer.writeUInt32LE(n, this.offset);
      this.offset += 4;
    }
    writeInt24(n) {
      this.writeInt8(n & 255);
      this.writeInt16(n >> 8);
    }
    writeInt16(n) {
      this.buffer.writeUInt16LE(n, this.offset);
      this.offset += 2;
    }
    writeInt8(n) {
      this.buffer.writeUInt8(n, this.offset);
      this.offset++;
    }
    writeDouble(n) {
      this.buffer.writeDoubleLE(n, this.offset);
      this.offset += 8;
    }
    writeBuffer(b22) {
      b22.copy(this.buffer, this.offset);
      this.offset += b22.length;
    }
    writeNull() {
      this.buffer[this.offset] = 251;
      this.offset++;
    }
    writeNullTerminatedString(s32, encoding) {
      const buf = StringParser.encode(s32, encoding);
      this.buffer.length && buf.copy(this.buffer, this.offset);
      this.offset += buf.length;
      this.writeInt8(0);
    }
    writeString(s32, encoding) {
      if (s32 === null) {
        this.writeInt8(251);
        return;
      }
      if (s32.length === 0) {
        return;
      }
      const buf = StringParser.encode(s32, encoding);
      this.buffer.length && buf.copy(this.buffer, this.offset);
      this.offset += buf.length;
    }
    writeLengthCodedString(s32, encoding) {
      const buf = StringParser.encode(s32, encoding);
      this.writeLengthCodedNumber(buf.length);
      this.buffer.length && buf.copy(this.buffer, this.offset);
      this.offset += buf.length;
    }
    writeLengthCodedBuffer(b22) {
      this.writeLengthCodedNumber(b22.length);
      b22.copy(this.buffer, this.offset);
      this.offset += b22.length;
    }
    writeLengthCodedNumber(n) {
      if (n < 251) {
        return this.writeInt8(n);
      }
      if (n < 65535) {
        this.writeInt8(252);
        return this.writeInt16(n);
      }
      if (n < 16777215) {
        this.writeInt8(253);
        return this.writeInt24(n);
      }
      if (n === null) {
        return this.writeInt8(251);
      }
      this.writeInt8(254);
      this.buffer.writeUInt32LE(n, this.offset);
      this.offset += 4;
      this.buffer.writeUInt32LE(n >> 32, this.offset);
      this.offset += 4;
      return this.offset;
    }
    writeDate(d, timezone) {
      this.buffer.writeUInt8(11, this.offset);
      if (!timezone || timezone === "local") {
        this.buffer.writeUInt16LE(d.getFullYear(), this.offset + 1);
        this.buffer.writeUInt8(d.getMonth() + 1, this.offset + 3);
        this.buffer.writeUInt8(d.getDate(), this.offset + 4);
        this.buffer.writeUInt8(d.getHours(), this.offset + 5);
        this.buffer.writeUInt8(d.getMinutes(), this.offset + 6);
        this.buffer.writeUInt8(d.getSeconds(), this.offset + 7);
        this.buffer.writeUInt32LE(d.getMilliseconds() * 1000, this.offset + 8);
      } else {
        if (timezone !== "Z") {
          const offset2 = (timezone[0] === "-" ? -1 : 1) * (parseInt(timezone.substring(1, 3), 10) * 60 + parseInt(timezone.substring(4), 10));
          if (offset2 !== 0) {
            d = new Date(d.getTime() + 60000 * offset2);
          }
        }
        this.buffer.writeUInt16LE(d.getUTCFullYear(), this.offset + 1);
        this.buffer.writeUInt8(d.getUTCMonth() + 1, this.offset + 3);
        this.buffer.writeUInt8(d.getUTCDate(), this.offset + 4);
        this.buffer.writeUInt8(d.getUTCHours(), this.offset + 5);
        this.buffer.writeUInt8(d.getUTCMinutes(), this.offset + 6);
        this.buffer.writeUInt8(d.getUTCSeconds(), this.offset + 7);
        this.buffer.writeUInt32LE(d.getUTCMilliseconds() * 1000, this.offset + 8);
      }
      this.offset += 12;
    }
    writeHeader(sequenceId) {
      const offset2 = this.offset;
      this.offset = 0;
      this.writeInt24(this.buffer.length - 4);
      this.writeInt8(sequenceId);
      this.offset = offset2;
    }
    clone() {
      return new Packet(this.sequenceId, this.buffer, this.start, this.end);
    }
    type() {
      if (this.isEOF()) {
        return "EOF";
      }
      if (this.isError()) {
        return "Error";
      }
      if (this.buffer[this.offset] === 0) {
        return "maybeOK";
      }
      return "";
    }
    static lengthCodedNumberLength(n) {
      if (n < 251) {
        return 1;
      }
      if (n < 65535) {
        return 3;
      }
      if (n < 16777215) {
        return 5;
      }
      return 9;
    }
    static lengthCodedStringLength(str, encoding) {
      const buf = StringParser.encode(str, encoding);
      const slen = buf.length;
      return Packet.lengthCodedNumberLength(slen) + slen;
    }
    static MockBuffer() {
      const noop3 = function() {
      };
      const res = Buffer.alloc(0);
      for (const op in NativeBuffer.prototype) {
        if (typeof res[op] === "function") {
          res[op] = noop3;
        }
      }
      return res;
    }
  }
  module.exports = Packet;
});
var require_packet_parser = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var MAX_PACKET_LENGTH = 16777215;
  function readPacketLength(b22, off) {
    const b0 = b22[off];
    const b1 = b22[off + 1];
    const b222 = b22[off + 2];
    if (b1 + b222 === 0) {
      return b0;
    }
    return b0 + (b1 << 8) + (b222 << 16);
  }

  class PacketParser {
    constructor(onPacket, packetHeaderLength) {
      if (typeof packetHeaderLength === "undefined") {
        packetHeaderLength = 4;
      }
      this.buffer = [];
      this.bufferLength = 0;
      this.packetHeaderLength = packetHeaderLength;
      this.headerLen = 0;
      this.length = 0;
      this.largePacketParts = [];
      this.firstPacketSequenceId = 0;
      this.onPacket = onPacket;
      this.execute = PacketParser.prototype.executeStart;
      this._flushLargePacket = packetHeaderLength === 7 ? this._flushLargePacket7 : this._flushLargePacket4;
    }
    _flushLargePacket4() {
      const numPackets = this.largePacketParts.length;
      this.largePacketParts.unshift(Buffer.from([0, 0, 0, 0]));
      const body = Buffer.concat(this.largePacketParts);
      const packet = new Packet(this.firstPacketSequenceId, body, 0, body.length);
      this.largePacketParts.length = 0;
      packet.numPackets = numPackets;
      this.onPacket(packet);
    }
    _flushLargePacket7() {
      const numPackets = this.largePacketParts.length;
      this.largePacketParts.unshift(Buffer.from([0, 0, 0, 0, 0, 0, 0]));
      const body = Buffer.concat(this.largePacketParts);
      this.largePacketParts.length = 0;
      const packet = new Packet(this.firstPacketSequenceId, body, 0, body.length);
      packet.numPackets = numPackets;
      this.onPacket(packet);
    }
    executeStart(chunk) {
      let start = 0;
      const end = chunk.length;
      while (end - start >= 3) {
        this.length = readPacketLength(chunk, start);
        if (end - start >= this.length + this.packetHeaderLength) {
          const sequenceId = chunk[start + 3];
          if (this.length < MAX_PACKET_LENGTH && this.largePacketParts.length === 0) {
            this.onPacket(new Packet(sequenceId, chunk, start, start + this.packetHeaderLength + this.length));
          } else {
            if (this.largePacketParts.length === 0) {
              this.firstPacketSequenceId = sequenceId;
            }
            this.largePacketParts.push(chunk.slice(start + this.packetHeaderLength, start + this.packetHeaderLength + this.length));
            if (this.length < MAX_PACKET_LENGTH) {
              this._flushLargePacket();
            }
          }
          start += this.packetHeaderLength + this.length;
        } else {
          this.buffer = [chunk.slice(start + 3, end)];
          this.bufferLength = end - start - 3;
          this.execute = PacketParser.prototype.executePayload;
          return;
        }
      }
      if (end - start > 0) {
        this.headerLen = end - start;
        this.length = chunk[start];
        if (this.headerLen === 2) {
          this.length = chunk[start] + (chunk[start + 1] << 8);
          this.execute = PacketParser.prototype.executeHeader3;
        } else {
          this.execute = PacketParser.prototype.executeHeader2;
        }
      }
    }
    executePayload(chunk) {
      let start = 0;
      const end = chunk.length;
      const remainingPayload = this.length - this.bufferLength + this.packetHeaderLength - 3;
      if (end - start >= remainingPayload) {
        const payload = Buffer.allocUnsafe(this.length + this.packetHeaderLength);
        let offset2 = 3;
        for (let i2 = 0;i2 < this.buffer.length; ++i2) {
          this.buffer[i2].copy(payload, offset2);
          offset2 += this.buffer[i2].length;
        }
        chunk.copy(payload, offset2, start, start + remainingPayload);
        const sequenceId = payload[3];
        if (this.length < MAX_PACKET_LENGTH && this.largePacketParts.length === 0) {
          this.onPacket(new Packet(sequenceId, payload, 0, this.length + this.packetHeaderLength));
        } else {
          if (this.largePacketParts.length === 0) {
            this.firstPacketSequenceId = sequenceId;
          }
          this.largePacketParts.push(payload.slice(this.packetHeaderLength, this.packetHeaderLength + this.length));
          if (this.length < MAX_PACKET_LENGTH) {
            this._flushLargePacket();
          }
        }
        this.buffer = [];
        this.bufferLength = 0;
        this.execute = PacketParser.prototype.executeStart;
        start += remainingPayload;
        if (end - start > 0) {
          return this.execute(chunk.slice(start, end));
        }
      } else {
        this.buffer.push(chunk);
        this.bufferLength += chunk.length;
      }
      return null;
    }
    executeHeader2(chunk) {
      this.length += chunk[0] << 8;
      if (chunk.length > 1) {
        this.length += chunk[1] << 16;
        this.execute = PacketParser.prototype.executePayload;
        return this.executePayload(chunk.slice(2));
      }
      this.execute = PacketParser.prototype.executeHeader3;
      return null;
    }
    executeHeader3(chunk) {
      this.length += chunk[0] << 16;
      this.execute = PacketParser.prototype.executePayload;
      return this.executePayload(chunk.slice(1));
    }
  }
  module.exports = PacketParser;
});
var require_auth_next_factor = __commonJS2((exports, module) => {
  var Packet = require_packet();

  class AuthNextFactor {
    constructor(opts) {
      this.pluginName = opts.pluginName;
      this.pluginData = opts.pluginData;
    }
    toPacket(encoding) {
      const length = 6 + this.pluginName.length + this.pluginData.length;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(2);
      packet.writeNullTerminatedString(this.pluginName, encoding);
      packet.writeBuffer(this.pluginData);
      return packet;
    }
    static fromPacket(packet, encoding) {
      packet.readInt8();
      const name = packet.readNullTerminatedString(encoding);
      const data2 = packet.readBuffer();
      return new AuthNextFactor({
        pluginName: name,
        pluginData: data2
      });
    }
  }
  module.exports = AuthNextFactor;
});
var require_auth_switch_request = __commonJS2((exports, module) => {
  var Packet = require_packet();

  class AuthSwitchRequest {
    constructor(opts) {
      this.pluginName = opts.pluginName;
      this.pluginData = opts.pluginData;
    }
    toPacket() {
      const length = 6 + this.pluginName.length + this.pluginData.length;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(254);
      packet.writeNullTerminatedString(this.pluginName, "cesu8");
      packet.writeBuffer(this.pluginData);
      return packet;
    }
    static fromPacket(packet) {
      packet.readInt8();
      const name = packet.readNullTerminatedString("cesu8");
      const data2 = packet.readBuffer();
      return new AuthSwitchRequest({
        pluginName: name,
        pluginData: data2
      });
    }
  }
  module.exports = AuthSwitchRequest;
});
var require_auth_switch_request_more_data = __commonJS2((exports, module) => {
  var Packet = require_packet();

  class AuthSwitchRequestMoreData {
    constructor(data2) {
      this.data = data2;
    }
    toPacket() {
      const length = 5 + this.data.length;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(1);
      packet.writeBuffer(this.data);
      return packet;
    }
    static fromPacket(packet) {
      packet.readInt8();
      const data2 = packet.readBuffer();
      return new AuthSwitchRequestMoreData(data2);
    }
    static verifyMarker(packet) {
      return packet.peekByte() === 1;
    }
  }
  module.exports = AuthSwitchRequestMoreData;
});
var require_auth_switch_response = __commonJS2((exports, module) => {
  var Packet = require_packet();

  class AuthSwitchResponse {
    constructor(data2) {
      if (!Buffer.isBuffer(data2)) {
        data2 = Buffer.from(data2);
      }
      this.data = data2;
    }
    toPacket() {
      const length = 4 + this.data.length;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeBuffer(this.data);
      return packet;
    }
    static fromPacket(packet) {
      const data2 = packet.readBuffer();
      return new AuthSwitchResponse(data2);
    }
  }
  module.exports = AuthSwitchResponse;
});
var require_types2 = __commonJS2((exports, module) => {
  module.exports = {
    0: "DECIMAL",
    1: "TINY",
    2: "SHORT",
    3: "LONG",
    4: "FLOAT",
    5: "DOUBLE",
    6: "NULL",
    7: "TIMESTAMP",
    8: "LONGLONG",
    9: "INT24",
    10: "DATE",
    11: "TIME",
    12: "DATETIME",
    13: "YEAR",
    14: "NEWDATE",
    15: "VARCHAR",
    16: "BIT",
    245: "JSON",
    246: "NEWDECIMAL",
    247: "ENUM",
    248: "SET",
    249: "TINY_BLOB",
    250: "MEDIUM_BLOB",
    251: "LONG_BLOB",
    252: "BLOB",
    253: "VAR_STRING",
    254: "STRING",
    255: "GEOMETRY"
  };
  module.exports.DECIMAL = 0;
  module.exports.TINY = 1;
  module.exports.SHORT = 2;
  module.exports.LONG = 3;
  module.exports.FLOAT = 4;
  module.exports.DOUBLE = 5;
  module.exports.NULL = 6;
  module.exports.TIMESTAMP = 7;
  module.exports.LONGLONG = 8;
  module.exports.INT24 = 9;
  module.exports.DATE = 10;
  module.exports.TIME = 11;
  module.exports.DATETIME = 12;
  module.exports.YEAR = 13;
  module.exports.NEWDATE = 14;
  module.exports.VARCHAR = 15;
  module.exports.BIT = 16;
  module.exports.VECTOR = 242;
  module.exports.JSON = 245;
  module.exports.NEWDECIMAL = 246;
  module.exports.ENUM = 247;
  module.exports.SET = 248;
  module.exports.TINY_BLOB = 249;
  module.exports.MEDIUM_BLOB = 250;
  module.exports.LONG_BLOB = 251;
  module.exports.BLOB = 252;
  module.exports.VAR_STRING = 253;
  module.exports.STRING = 254;
  module.exports.GEOMETRY = 255;
});
var require_binary_row = __commonJS2((exports, module) => {
  var Types = require_types2();
  var Packet = require_packet();
  var binaryReader = new Array(256);

  class BinaryRow {
    constructor(columns) {
      this.columns = columns || [];
    }
    static toPacket(columns, encoding) {
      const sequenceId = 0;
      let length = 0;
      columns.forEach((val2) => {
        if (val2 === null || typeof val2 === "undefined") {
          ++length;
          return;
        }
        length += Packet.lengthCodedStringLength(val2.toString(10), encoding);
      });
      length = length + 2;
      const buffer = Buffer.allocUnsafe(length + 4);
      const packet = new Packet(sequenceId, buffer, 0, length + 4);
      packet.offset = 4;
      packet.writeInt8(0);
      let bitmap = 0;
      let bitValue = 1;
      columns.forEach((parameter) => {
        if (parameter.type === Types.NULL) {
          bitmap += bitValue;
        }
        bitValue *= 2;
        if (bitValue === 256) {
          packet.writeInt8(bitmap);
          bitmap = 0;
          bitValue = 1;
        }
      });
      if (bitValue !== 1) {
        packet.writeInt8(bitmap);
      }
      columns.forEach((val2) => {
        if (val2 === null) {
          packet.writeNull();
          return;
        }
        if (typeof val2 === "undefined") {
          packet.writeInt8(0);
          return;
        }
        packet.writeLengthCodedString(val2.toString(10), encoding);
      });
      return packet;
    }
    static fromPacket(fields22, packet) {
      const columns = new Array(fields22.length);
      packet.readInt8();
      const nullBitmapLength = Math.floor((fields22.length + 7 + 2) / 8);
      packet.skip(nullBitmapLength);
      for (let i2 = 0;i2 < columns.length; ++i2) {
        columns[i2] = binaryReader[fields22[i2].columnType].apply(packet);
      }
      return new BinaryRow(columns);
    }
  }
  binaryReader[Types.DECIMAL] = Packet.prototype.readLengthCodedString;
  binaryReader[1] = Packet.prototype.readInt8;
  binaryReader[2] = Packet.prototype.readInt16;
  binaryReader[3] = Packet.prototype.readInt32;
  binaryReader[4] = Packet.prototype.readFloat;
  binaryReader[5] = Packet.prototype.readDouble;
  binaryReader[6] = Packet.prototype.assertInvalid;
  binaryReader[7] = Packet.prototype.readTimestamp;
  binaryReader[8] = Packet.prototype.readInt64;
  binaryReader[9] = Packet.prototype.readInt32;
  binaryReader[10] = Packet.prototype.readTimestamp;
  binaryReader[11] = Packet.prototype.readTime;
  binaryReader[12] = Packet.prototype.readDateTime;
  binaryReader[13] = Packet.prototype.readInt16;
  binaryReader[Types.VAR_STRING] = Packet.prototype.readLengthCodedString;
  module.exports = BinaryRow;
});
var require_commands = __commonJS2((exports, module) => {
  module.exports = {
    SLEEP: 0,
    QUIT: 1,
    INIT_DB: 2,
    QUERY: 3,
    FIELD_LIST: 4,
    CREATE_DB: 5,
    DROP_DB: 6,
    REFRESH: 7,
    SHUTDOWN: 8,
    STATISTICS: 9,
    PROCESS_INFO: 10,
    CONNECT: 11,
    PROCESS_KILL: 12,
    DEBUG: 13,
    PING: 14,
    TIME: 15,
    DELAYED_INSERT: 16,
    CHANGE_USER: 17,
    BINLOG_DUMP: 18,
    TABLE_DUMP: 19,
    CONNECT_OUT: 20,
    REGISTER_SLAVE: 21,
    STMT_PREPARE: 22,
    STMT_EXECUTE: 23,
    STMT_SEND_LONG_DATA: 24,
    STMT_CLOSE: 25,
    STMT_RESET: 26,
    SET_OPTION: 27,
    STMT_FETCH: 28,
    DAEMON: 29,
    BINLOG_DUMP_GTID: 30,
    UNKNOWN: 255
  };
});
var require_binlog_dump = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var CommandCodes = require_commands();

  class BinlogDump {
    constructor(opts) {
      this.binlogPos = opts.binlogPos || 0;
      this.serverId = opts.serverId || 0;
      this.flags = opts.flags || 0;
      this.filename = opts.filename || "";
    }
    toPacket() {
      const length = 15 + Buffer.byteLength(this.filename, "utf8");
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(CommandCodes.BINLOG_DUMP);
      packet.writeInt32(this.binlogPos);
      packet.writeInt16(this.flags);
      packet.writeInt32(this.serverId);
      packet.writeString(this.filename);
      return packet;
    }
  }
  module.exports = BinlogDump;
});
var require_client = __commonJS2((exports) => {
  exports.LONG_PASSWORD = 1;
  exports.FOUND_ROWS = 2;
  exports.LONG_FLAG = 4;
  exports.CONNECT_WITH_DB = 8;
  exports.NO_SCHEMA = 16;
  exports.COMPRESS = 32;
  exports.ODBC = 64;
  exports.LOCAL_FILES = 128;
  exports.IGNORE_SPACE = 256;
  exports.PROTOCOL_41 = 512;
  exports.INTERACTIVE = 1024;
  exports.SSL = 2048;
  exports.IGNORE_SIGPIPE = 4096;
  exports.TRANSACTIONS = 8192;
  exports.RESERVED = 16384;
  exports.SECURE_CONNECTION = 32768;
  exports.MULTI_STATEMENTS = 65536;
  exports.MULTI_RESULTS = 131072;
  exports.PS_MULTI_RESULTS = 262144;
  exports.PLUGIN_AUTH = 524288;
  exports.CONNECT_ATTRS = 1048576;
  exports.PLUGIN_AUTH_LENENC_CLIENT_DATA = 2097152;
  exports.CAN_HANDLE_EXPIRED_PASSWORDS = 4194304;
  exports.SESSION_TRACK = 8388608;
  exports.DEPRECATE_EOF = 16777216;
  exports.SSL_VERIFY_SERVER_CERT = 1073741824;
  exports.REMEMBER_OPTIONS = 2147483648;
  exports.MULTI_FACTOR_AUTHENTICATION = 268435456;
});
var require_auth_41 = __commonJS2((exports) => {
  var crypto = import.meta.require("crypto");
  function sha1(msg, msg1, msg2) {
    const hash = crypto.createHash("sha1");
    hash.update(msg);
    if (msg1) {
      hash.update(msg1);
    }
    if (msg2) {
      hash.update(msg2);
    }
    return hash.digest();
  }
  function xor(a, b22) {
    const result2 = Buffer.allocUnsafe(a.length);
    for (let i2 = 0;i2 < a.length; i2++) {
      result2[i2] = a[i2] ^ b22[i2];
    }
    return result2;
  }
  exports.xor = xor;
  function token(password, scramble1, scramble2) {
    if (!password) {
      return Buffer.alloc(0);
    }
    const stage1 = sha1(password);
    return exports.calculateTokenFromPasswordSha(stage1, scramble1, scramble2);
  }
  exports.calculateTokenFromPasswordSha = function(passwordSha, scramble1, scramble2) {
    const authPluginData1 = scramble1.slice(0, 8);
    const authPluginData2 = scramble2.slice(0, 12);
    const stage2 = sha1(passwordSha);
    const stage3 = sha1(authPluginData1, authPluginData2, stage2);
    return xor(stage3, passwordSha);
  };
  exports.calculateToken = token;
  exports.verifyToken = function(publicSeed1, publicSeed2, token2, doubleSha) {
    const hashStage1 = xor(token2, sha1(publicSeed1, publicSeed2, doubleSha));
    const candidateHash2 = sha1(hashStage1);
    return candidateHash2.compare(doubleSha) === 0;
  };
  exports.doubleSha1 = function(password) {
    return sha1(sha1(password));
  };
  function xorRotating(a, seed) {
    const result2 = Buffer.allocUnsafe(a.length);
    const seedLen = seed.length;
    for (let i2 = 0;i2 < a.length; i2++) {
      result2[i2] = a[i2] ^ seed[i2 % seedLen];
    }
    return result2;
  }
  exports.xorRotating = xorRotating;
});
var require_charset_encodings = __commonJS2((exports, module) => {
  module.exports = [
    "utf8",
    "big5",
    "latin2",
    "dec8",
    "cp850",
    "latin1",
    "hp8",
    "koi8r",
    "latin1",
    "latin2",
    "swe7",
    "ascii",
    "eucjp",
    "sjis",
    "cp1251",
    "latin1",
    "hebrew",
    "utf8",
    "tis620",
    "euckr",
    "latin7",
    "latin2",
    "koi8u",
    "cp1251",
    "gb2312",
    "greek",
    "cp1250",
    "latin2",
    "gbk",
    "cp1257",
    "latin5",
    "latin1",
    "armscii8",
    "cesu8",
    "cp1250",
    "ucs2",
    "cp866",
    "keybcs2",
    "macintosh",
    "macroman",
    "cp852",
    "latin7",
    "latin7",
    "macintosh",
    "cp1250",
    "utf8",
    "utf8",
    "latin1",
    "latin1",
    "latin1",
    "cp1251",
    "cp1251",
    "cp1251",
    "macroman",
    "utf16",
    "utf16",
    "utf16-le",
    "cp1256",
    "cp1257",
    "cp1257",
    "utf32",
    "utf32",
    "utf16-le",
    "binary",
    "armscii8",
    "ascii",
    "cp1250",
    "cp1256",
    "cp866",
    "dec8",
    "greek",
    "hebrew",
    "hp8",
    "keybcs2",
    "koi8r",
    "koi8u",
    "cesu8",
    "latin2",
    "latin5",
    "latin7",
    "cp850",
    "cp852",
    "swe7",
    "cesu8",
    "big5",
    "euckr",
    "gb2312",
    "gbk",
    "sjis",
    "tis620",
    "ucs2",
    "eucjp",
    "geostd8",
    "geostd8",
    "latin1",
    "cp932",
    "cp932",
    "eucjpms",
    "eucjpms",
    "cp1250",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf16",
    "utf8",
    "utf8",
    "utf8",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "ucs2",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "ucs2",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf32",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "cesu8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "cesu8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "gb18030",
    "gb18030",
    "gb18030",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8",
    "utf8"
  ];
});
var require_change_user = __commonJS2((exports, module) => {
  var CommandCode = require_commands();
  var ClientConstants = require_client();
  var Packet = require_packet();
  var auth41 = require_auth_41();
  var CharsetToEncoding = require_charset_encodings();

  class ChangeUser {
    constructor(opts) {
      this.flags = opts.flags;
      this.user = opts.user || "";
      this.database = opts.database || "";
      this.password = opts.password || "";
      this.passwordSha1 = opts.passwordSha1;
      this.authPluginData1 = opts.authPluginData1;
      this.authPluginData2 = opts.authPluginData2;
      this.connectAttributes = opts.connectAttrinutes || {};
      let authToken;
      if (this.passwordSha1) {
        authToken = auth41.calculateTokenFromPasswordSha(this.passwordSha1, this.authPluginData1, this.authPluginData2);
      } else {
        authToken = auth41.calculateToken(this.password, this.authPluginData1, this.authPluginData2);
      }
      this.authToken = authToken;
      this.charsetNumber = opts.charsetNumber;
    }
    serializeToBuffer(buffer) {
      const isSet = (flag) => this.flags & ClientConstants[flag];
      const packet = new Packet(0, buffer, 0, buffer.length);
      packet.offset = 4;
      const encoding = CharsetToEncoding[this.charsetNumber];
      packet.writeInt8(CommandCode.CHANGE_USER);
      packet.writeNullTerminatedString(this.user, encoding);
      if (isSet("SECURE_CONNECTION")) {
        packet.writeInt8(this.authToken.length);
        packet.writeBuffer(this.authToken);
      } else {
        packet.writeBuffer(this.authToken);
        packet.writeInt8(0);
      }
      packet.writeNullTerminatedString(this.database, encoding);
      packet.writeInt16(this.charsetNumber);
      if (isSet("PLUGIN_AUTH")) {
        packet.writeNullTerminatedString("mysql_native_password", "latin1");
      }
      if (isSet("CONNECT_ATTRS")) {
        const connectAttributes = this.connectAttributes;
        const attrNames = Object.keys(connectAttributes);
        let keysLength = 0;
        for (let k = 0;k < attrNames.length; ++k) {
          keysLength += Packet.lengthCodedStringLength(attrNames[k], encoding);
          keysLength += Packet.lengthCodedStringLength(connectAttributes[attrNames[k]], encoding);
        }
        packet.writeLengthCodedNumber(keysLength);
        for (let k = 0;k < attrNames.length; ++k) {
          packet.writeLengthCodedString(attrNames[k], encoding);
          packet.writeLengthCodedString(connectAttributes[attrNames[k]], encoding);
        }
      }
      return packet;
    }
    toPacket() {
      if (typeof this.user !== "string") {
        throw new Error('"user" connection config property must be a string');
      }
      if (typeof this.database !== "string") {
        throw new Error('"database" connection config property must be a string');
      }
      const p32 = this.serializeToBuffer(Packet.MockBuffer());
      return this.serializeToBuffer(Buffer.allocUnsafe(p32.offset));
    }
  }
  module.exports = ChangeUser;
});
var require_close_statement = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var CommandCodes = require_commands();

  class CloseStatement {
    constructor(id) {
      this.id = id;
    }
    toPacket() {
      const packet = new Packet(0, Buffer.allocUnsafe(9), 0, 9);
      packet.offset = 4;
      packet.writeInt8(CommandCodes.STMT_CLOSE);
      packet.writeInt32(this.id);
      return packet;
    }
  }
  module.exports = CloseStatement;
});
var require_field_flags = __commonJS2((exports) => {
  exports.NOT_NULL = 1;
  exports.PRI_KEY = 2;
  exports.UNIQUE_KEY = 4;
  exports.MULTIPLE_KEY = 8;
  exports.BLOB = 16;
  exports.UNSIGNED = 32;
  exports.ZEROFILL = 64;
  exports.BINARY = 128;
  exports.ENUM = 256;
  exports.AUTO_INCREMENT = 512;
  exports.TIMESTAMP = 1024;
  exports.SET = 2048;
  exports.NO_DEFAULT_VALUE = 4096;
  exports.ON_UPDATE_NOW = 8192;
  exports.NUM = 32768;
});
var require_column_definition = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var StringParser = require_string2();
  var CharsetToEncoding = require_charset_encodings();
  var fields22 = ["catalog", "schema", "table", "orgTable", "name", "orgName"];

  class ColumnDefinition {
    constructor(packet, clientEncoding) {
      this._buf = packet.buffer;
      this._clientEncoding = clientEncoding;
      this._catalogLength = packet.readLengthCodedNumber();
      this._catalogStart = packet.offset;
      packet.offset += this._catalogLength;
      this._schemaLength = packet.readLengthCodedNumber();
      this._schemaStart = packet.offset;
      packet.offset += this._schemaLength;
      this._tableLength = packet.readLengthCodedNumber();
      this._tableStart = packet.offset;
      packet.offset += this._tableLength;
      this._orgTableLength = packet.readLengthCodedNumber();
      this._orgTableStart = packet.offset;
      packet.offset += this._orgTableLength;
      const _nameLength = packet.readLengthCodedNumber();
      const _nameStart = packet.offset;
      packet.offset += _nameLength;
      this._orgNameLength = packet.readLengthCodedNumber();
      this._orgNameStart = packet.offset;
      packet.offset += this._orgNameLength;
      packet.skip(1);
      this.characterSet = packet.readInt16();
      this.encoding = CharsetToEncoding[this.characterSet];
      this.name = StringParser.decode(this._buf, this.encoding === "binary" ? this._clientEncoding : this.encoding, _nameStart, _nameStart + _nameLength);
      this.columnLength = packet.readInt32();
      this.columnType = packet.readInt8();
      this.type = this.columnType;
      this.flags = packet.readInt16();
      this.decimals = packet.readInt8();
    }
    inspect() {
      return {
        catalog: this.catalog,
        schema: this.schema,
        name: this.name,
        orgName: this.orgName,
        table: this.table,
        orgTable: this.orgTable,
        characterSet: this.characterSet,
        encoding: this.encoding,
        columnLength: this.columnLength,
        type: this.columnType,
        flags: this.flags,
        decimals: this.decimals
      };
    }
    [Symbol.for("nodejs.util.inspect.custom")](depth2, inspectOptions, inspect2) {
      const Types = require_types2();
      const typeNames = [];
      for (const t in Types) {
        typeNames[Types[t]] = t;
      }
      const fiedFlags = require_field_flags();
      const flagNames = [];
      const inspectFlags = this.flags;
      for (const f22 in fiedFlags) {
        if (inspectFlags & fiedFlags[f22]) {
          if (f22 === "PRI_KEY") {
            flagNames.push("PRIMARY KEY");
          } else if (f22 === "NOT_NULL") {
            flagNames.push("NOT NULL");
          } else if (f22 === "BINARY") {
          } else if (f22 === "MULTIPLE_KEY") {
          } else if (f22 === "NO_DEFAULT_VALUE") {
          } else if (f22 === "BLOB") {
          } else if (f22 === "UNSIGNED") {
          } else if (f22 === "TIMESTAMP") {
          } else if (f22 === "ON_UPDATE_NOW") {
            flagNames.push("ON UPDATE CURRENT_TIMESTAMP");
          } else {
            flagNames.push(f22);
          }
        }
      }
      if (depth2 > 1) {
        return inspect2({
          ...this.inspect(),
          typeName: typeNames[this.columnType],
          flags: flagNames
        });
      }
      const isUnsigned = this.flags & fiedFlags.UNSIGNED;
      let typeName = typeNames[this.columnType];
      if (typeName === "BLOB") {
        if (this.columnLength === 4294967295) {
          typeName = "LONGTEXT";
        } else if (this.columnLength === 67108860) {
          typeName = "MEDIUMTEXT";
        } else if (this.columnLength === 262140) {
          typeName = "TEXT";
        } else if (this.columnLength === 1020) {
          typeName = "TINYTEXT";
        } else {
          typeName = `BLOB(${this.columnLength})`;
        }
      } else if (typeName === "VAR_STRING") {
        typeName = `VARCHAR(${Math.ceil(this.columnLength / 4)})`;
      } else if (typeName === "TINY") {
        if (this.columnLength === 3 && isUnsigned || this.columnLength === 4 && !isUnsigned) {
          typeName = "TINYINT";
        } else {
          typeName = `TINYINT(${this.columnLength})`;
        }
      } else if (typeName === "LONGLONG") {
        if (this.columnLength === 20) {
          typeName = "BIGINT";
        } else {
          typeName = `BIGINT(${this.columnLength})`;
        }
      } else if (typeName === "SHORT") {
        if (isUnsigned && this.columnLength === 5) {
          typeName = "SMALLINT";
        } else if (!isUnsigned && this.columnLength === 6) {
          typeName = "SMALLINT";
        } else {
          typeName = `SMALLINT(${this.columnLength})`;
        }
      } else if (typeName === "LONG") {
        if (isUnsigned && this.columnLength === 10) {
          typeName = "INT";
        } else if (!isUnsigned && this.columnLength === 11) {
          typeName = "INT";
        } else {
          typeName = `INT(${this.columnLength})`;
        }
      } else if (typeName === "INT24") {
        if (isUnsigned && this.columnLength === 8) {
          typeName = "MEDIUMINT";
        } else if (!isUnsigned && this.columnLength === 9) {
          typeName = "MEDIUMINT";
        } else {
          typeName = `MEDIUMINT(${this.columnLength})`;
        }
      } else if (typeName === "DOUBLE") {
        if (this.columnLength === 22 && this.decimals === 31) {
          typeName = "DOUBLE";
        } else {
          typeName = `DOUBLE(${this.columnLength},${this.decimals})`;
        }
      } else if (typeName === "FLOAT") {
        if (this.columnLength === 12 && this.decimals === 31) {
          typeName = "FLOAT";
        } else {
          typeName = `FLOAT(${this.columnLength},${this.decimals})`;
        }
      } else if (typeName === "NEWDECIMAL") {
        if (this.columnLength === 11 && this.decimals === 0) {
          typeName = "DECIMAL";
        } else if (this.decimals === 0) {
          if (isUnsigned) {
            typeName = `DECIMAL(${this.columnLength})`;
          } else {
            typeName = `DECIMAL(${this.columnLength - 1})`;
          }
        } else {
          typeName = `DECIMAL(${this.columnLength - 2},${this.decimals})`;
        }
      } else {
        typeName = `${typeNames[this.columnType]}(${this.columnLength})`;
      }
      if (isUnsigned) {
        typeName += " UNSIGNED";
      }
      return `\`${this.name}\` ${[typeName, ...flagNames].join(" ")}`;
    }
    static toPacket(column, sequenceId) {
      let length = 17;
      fields22.forEach((field) => {
        length += Packet.lengthCodedStringLength(column[field], CharsetToEncoding[column.characterSet]);
      });
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(sequenceId, buffer, 0, length);
      function writeField(name) {
        packet.writeLengthCodedString(column[name], CharsetToEncoding[column.characterSet]);
      }
      packet.offset = 4;
      fields22.forEach(writeField);
      packet.writeInt8(12);
      packet.writeInt16(column.characterSet);
      packet.writeInt32(column.columnLength);
      packet.writeInt8(column.columnType);
      packet.writeInt16(column.flags);
      packet.writeInt8(column.decimals);
      packet.writeInt16(0);
      return packet;
    }
    get db() {
      return this.schema;
    }
  }
  var addString = function(name) {
    Object.defineProperty(ColumnDefinition.prototype, name, {
      get: function() {
        const start = this[`_${name}Start`];
        const end = start + this[`_${name}Length`];
        const val2 = StringParser.decode(this._buf, this.encoding === "binary" ? this._clientEncoding : this.encoding, start, end);
        Object.defineProperty(this, name, {
          value: val2,
          writable: false,
          configurable: false,
          enumerable: false
        });
        return val2;
      }
    });
  };
  addString("catalog");
  addString("schema");
  addString("table");
  addString("orgTable");
  addString("orgName");
  module.exports = ColumnDefinition;
});
var require_cursor = __commonJS2((exports, module) => {
  module.exports = {
    NO_CURSOR: 0,
    READ_ONLY: 1,
    FOR_UPDATE: 2,
    SCROLLABLE: 3
  };
});
var require_execute = __commonJS2((exports, module) => {
  var CursorType = require_cursor();
  var CommandCodes = require_commands();
  var Types = require_types2();
  var Packet = require_packet();
  var CharsetToEncoding = require_charset_encodings();
  function isJSON(value) {
    return Array.isArray(value) || value.constructor === Object || typeof value.toJSON === "function" && !Buffer.isBuffer(value);
  }
  function toParameter(value, encoding, timezone) {
    let type = Types.VAR_STRING;
    let length;
    let writer = function(value2) {
      return Packet.prototype.writeLengthCodedString.call(this, value2, encoding);
    };
    if (value !== null) {
      switch (typeof value) {
        case "undefined":
          throw new TypeError("Bind parameters must not contain undefined");
        case "number":
          type = Types.DOUBLE;
          length = 8;
          writer = Packet.prototype.writeDouble;
          break;
        case "boolean":
          value = value | 0;
          type = Types.TINY;
          length = 1;
          writer = Packet.prototype.writeInt8;
          break;
        case "object":
          if (Object.prototype.toString.call(value) === "[object Date]") {
            type = Types.DATETIME;
            length = 12;
            writer = function(value2) {
              return Packet.prototype.writeDate.call(this, value2, timezone);
            };
          } else if (isJSON(value)) {
            value = JSON.stringify(value);
            type = Types.JSON;
          } else if (Buffer.isBuffer(value)) {
            length = Packet.lengthCodedNumberLength(value.length) + value.length;
            writer = Packet.prototype.writeLengthCodedBuffer;
          }
          break;
        default:
          value = value.toString();
      }
    } else {
      value = "";
      type = Types.NULL;
    }
    if (!length) {
      length = Packet.lengthCodedStringLength(value, encoding);
    }
    return { value, type, length, writer };
  }

  class Execute {
    constructor(id, parameters, charsetNumber, timezone) {
      this.id = id;
      this.parameters = parameters;
      this.encoding = CharsetToEncoding[charsetNumber];
      this.timezone = timezone;
    }
    static fromPacket(packet, encoding) {
      const stmtId = packet.readInt32();
      const flags = packet.readInt8();
      const iterationCount = packet.readInt32();
      let i2 = packet.offset;
      while (i2 < packet.end - 1) {
        if ((packet.buffer[i2 + 1] === Types.VAR_STRING || packet.buffer[i2 + 1] === Types.NULL || packet.buffer[i2 + 1] === Types.DOUBLE || packet.buffer[i2 + 1] === Types.TINY || packet.buffer[i2 + 1] === Types.DATETIME || packet.buffer[i2 + 1] === Types.JSON) && packet.buffer[i2] === 1 && packet.buffer[i2 + 2] === 0) {
          break;
        } else {
          packet.readInt8();
        }
        i2++;
      }
      const types5 = [];
      for (let i22 = packet.offset + 1;i22 < packet.end - 1; i22++) {
        if ((packet.buffer[i22] === Types.VAR_STRING || packet.buffer[i22] === Types.NULL || packet.buffer[i22] === Types.DOUBLE || packet.buffer[i22] === Types.TINY || packet.buffer[i22] === Types.DATETIME || packet.buffer[i22] === Types.JSON) && packet.buffer[i22 + 1] === 0) {
          types5.push(packet.buffer[i22]);
          packet.skip(2);
        }
      }
      packet.skip(1);
      const values3 = [];
      for (let i22 = 0;i22 < types5.length; i22++) {
        if (types5[i22] === Types.VAR_STRING) {
          values3.push(packet.readLengthCodedString(encoding));
        } else if (types5[i22] === Types.DOUBLE) {
          values3.push(packet.readDouble());
        } else if (types5[i22] === Types.TINY) {
          values3.push(packet.readInt8());
        } else if (types5[i22] === Types.DATETIME) {
          values3.push(packet.readDateTime());
        } else if (types5[i22] === Types.JSON) {
          values3.push(JSON.parse(packet.readLengthCodedString(encoding)));
        }
        if (types5[i22] === Types.NULL) {
          values3.push(null);
        }
      }
      return { stmtId, flags, iterationCount, values: values3 };
    }
    toPacket() {
      let length = 14;
      let parameters;
      if (this.parameters && this.parameters.length > 0) {
        length += Math.floor((this.parameters.length + 7) / 8);
        length += 1;
        length += 2 * this.parameters.length;
        parameters = this.parameters.map((value) => toParameter(value, this.encoding, this.timezone));
        length += parameters.reduce((accumulator, parameter) => accumulator + parameter.length, 0);
      }
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(CommandCodes.STMT_EXECUTE);
      packet.writeInt32(this.id);
      packet.writeInt8(CursorType.NO_CURSOR);
      packet.writeInt32(1);
      if (parameters) {
        let bitmap = 0;
        let bitValue = 1;
        parameters.forEach((parameter) => {
          if (parameter.type === Types.NULL) {
            bitmap += bitValue;
          }
          bitValue *= 2;
          if (bitValue === 256) {
            packet.writeInt8(bitmap);
            bitmap = 0;
            bitValue = 1;
          }
        });
        if (bitValue !== 1) {
          packet.writeInt8(bitmap);
        }
        packet.writeInt8(1);
        parameters.forEach((parameter) => {
          packet.writeInt8(parameter.type);
          packet.writeInt8(0);
        });
        parameters.forEach((parameter) => {
          if (parameter.type !== Types.NULL) {
            parameter.writer.call(packet, parameter.value);
          }
        });
      }
      return packet;
    }
  }
  module.exports = Execute;
});
var require_handshake = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var ClientConstants = require_client();

  class Handshake {
    constructor(args) {
      this.protocolVersion = args.protocolVersion;
      this.serverVersion = args.serverVersion;
      this.capabilityFlags = args.capabilityFlags;
      this.connectionId = args.connectionId;
      this.authPluginData1 = args.authPluginData1;
      this.authPluginData2 = args.authPluginData2;
      this.characterSet = args.characterSet;
      this.statusFlags = args.statusFlags;
      this.autPluginName = args.autPluginName;
    }
    setScrambleData(cb) {
      import.meta.require("crypto").randomBytes(20, (err22, data2) => {
        if (err22) {
          cb(err22);
          return;
        }
        this.authPluginData1 = data2.slice(0, 8);
        this.authPluginData2 = data2.slice(8, 20);
        cb();
      });
    }
    toPacket(sequenceId) {
      const length = 68 + Buffer.byteLength(this.serverVersion, "utf8");
      const buffer = Buffer.alloc(length + 4, 0);
      const packet = new Packet(sequenceId, buffer, 0, length + 4);
      packet.offset = 4;
      packet.writeInt8(this.protocolVersion);
      packet.writeString(this.serverVersion, "cesu8");
      packet.writeInt8(0);
      packet.writeInt32(this.connectionId);
      packet.writeBuffer(this.authPluginData1);
      packet.writeInt8(0);
      const capabilityFlagsBuffer = Buffer.allocUnsafe(4);
      capabilityFlagsBuffer.writeUInt32LE(this.capabilityFlags, 0);
      packet.writeBuffer(capabilityFlagsBuffer.slice(0, 2));
      packet.writeInt8(this.characterSet);
      packet.writeInt16(this.statusFlags);
      packet.writeBuffer(capabilityFlagsBuffer.slice(2, 4));
      packet.writeInt8(21);
      packet.skip(10);
      packet.writeBuffer(this.authPluginData2);
      packet.writeInt8(0);
      packet.writeString("mysql_native_password", "latin1");
      packet.writeInt8(0);
      return packet;
    }
    static fromPacket(packet) {
      const args = {};
      args.protocolVersion = packet.readInt8();
      args.serverVersion = packet.readNullTerminatedString("cesu8");
      args.connectionId = packet.readInt32();
      args.authPluginData1 = packet.readBuffer(8);
      packet.skip(1);
      const capabilityFlagsBuffer = Buffer.allocUnsafe(4);
      capabilityFlagsBuffer[0] = packet.readInt8();
      capabilityFlagsBuffer[1] = packet.readInt8();
      if (packet.haveMoreData()) {
        args.characterSet = packet.readInt8();
        args.statusFlags = packet.readInt16();
        capabilityFlagsBuffer[2] = packet.readInt8();
        capabilityFlagsBuffer[3] = packet.readInt8();
        args.capabilityFlags = capabilityFlagsBuffer.readUInt32LE(0);
        if (args.capabilityFlags & ClientConstants.PLUGIN_AUTH) {
          args.authPluginDataLength = packet.readInt8();
        } else {
          args.authPluginDataLength = 0;
          packet.skip(1);
        }
        packet.skip(10);
      } else {
        args.capabilityFlags = capabilityFlagsBuffer.readUInt16LE(0);
      }
      const isSecureConnection = args.capabilityFlags & ClientConstants.SECURE_CONNECTION;
      if (isSecureConnection) {
        const authPluginDataLength = args.authPluginDataLength;
        if (authPluginDataLength === 0) {
          args.authPluginDataLength = 20;
          args.authPluginData2 = packet.readBuffer(12);
          packet.skip(1);
        } else {
          const len = Math.max(13, authPluginDataLength - 8);
          args.authPluginData2 = packet.readBuffer(len);
        }
      }
      if (args.capabilityFlags & ClientConstants.PLUGIN_AUTH) {
        args.autPluginName = packet.readNullTerminatedString("ascii");
      }
      return new Handshake(args);
    }
  }
  module.exports = Handshake;
});
var require_handshake_response = __commonJS2((exports, module) => {
  var ClientConstants = require_client();
  var CharsetToEncoding = require_charset_encodings();
  var Packet = require_packet();
  var auth41 = require_auth_41();

  class HandshakeResponse {
    constructor(handshake) {
      this.user = handshake.user || "";
      this.database = handshake.database || "";
      this.password = handshake.password || "";
      this.passwordSha1 = handshake.passwordSha1;
      this.authPluginData1 = handshake.authPluginData1;
      this.authPluginData2 = handshake.authPluginData2;
      this.compress = handshake.compress;
      this.clientFlags = handshake.flags;
      let authToken;
      if (this.passwordSha1) {
        authToken = auth41.calculateTokenFromPasswordSha(this.passwordSha1, this.authPluginData1, this.authPluginData2);
      } else {
        authToken = auth41.calculateToken(this.password, this.authPluginData1, this.authPluginData2);
      }
      this.authToken = authToken;
      this.charsetNumber = handshake.charsetNumber;
      this.encoding = CharsetToEncoding[handshake.charsetNumber];
      this.connectAttributes = handshake.connectAttributes;
    }
    serializeResponse(buffer) {
      const isSet = (flag) => this.clientFlags & ClientConstants[flag];
      const packet = new Packet(0, buffer, 0, buffer.length);
      packet.offset = 4;
      packet.writeInt32(this.clientFlags);
      packet.writeInt32(0);
      packet.writeInt8(this.charsetNumber);
      packet.skip(23);
      const encoding = this.encoding;
      packet.writeNullTerminatedString(this.user, encoding);
      let k;
      if (isSet("PLUGIN_AUTH_LENENC_CLIENT_DATA")) {
        packet.writeLengthCodedNumber(this.authToken.length);
        packet.writeBuffer(this.authToken);
      } else if (isSet("SECURE_CONNECTION")) {
        packet.writeInt8(this.authToken.length);
        packet.writeBuffer(this.authToken);
      } else {
        packet.writeBuffer(this.authToken);
        packet.writeInt8(0);
      }
      if (isSet("CONNECT_WITH_DB")) {
        packet.writeNullTerminatedString(this.database, encoding);
      }
      if (isSet("PLUGIN_AUTH")) {
        packet.writeNullTerminatedString("mysql_native_password", "latin1");
      }
      if (isSet("CONNECT_ATTRS")) {
        const connectAttributes = this.connectAttributes || {};
        const attrNames = Object.keys(connectAttributes);
        let keysLength = 0;
        for (k = 0;k < attrNames.length; ++k) {
          keysLength += Packet.lengthCodedStringLength(attrNames[k], encoding);
          keysLength += Packet.lengthCodedStringLength(connectAttributes[attrNames[k]], encoding);
        }
        packet.writeLengthCodedNumber(keysLength);
        for (k = 0;k < attrNames.length; ++k) {
          packet.writeLengthCodedString(attrNames[k], encoding);
          packet.writeLengthCodedString(connectAttributes[attrNames[k]], encoding);
        }
      }
      return packet;
    }
    toPacket() {
      if (typeof this.user !== "string") {
        throw new Error('"user" connection config property must be a string');
      }
      if (typeof this.database !== "string") {
        throw new Error('"database" connection config property must be a string');
      }
      const p32 = this.serializeResponse(Packet.MockBuffer());
      return this.serializeResponse(Buffer.alloc(p32.offset));
    }
    static fromPacket(packet) {
      const args = {};
      args.clientFlags = packet.readInt32();
      function isSet(flag) {
        return args.clientFlags & ClientConstants[flag];
      }
      args.maxPacketSize = packet.readInt32();
      args.charsetNumber = packet.readInt8();
      const encoding = CharsetToEncoding[args.charsetNumber];
      args.encoding = encoding;
      packet.skip(23);
      args.user = packet.readNullTerminatedString(encoding);
      let authTokenLength;
      if (isSet("PLUGIN_AUTH_LENENC_CLIENT_DATA")) {
        authTokenLength = packet.readLengthCodedNumber(encoding);
        args.authToken = packet.readBuffer(authTokenLength);
      } else if (isSet("SECURE_CONNECTION")) {
        authTokenLength = packet.readInt8();
        args.authToken = packet.readBuffer(authTokenLength);
      } else {
        args.authToken = packet.readNullTerminatedString(encoding);
      }
      if (isSet("CONNECT_WITH_DB")) {
        args.database = packet.readNullTerminatedString(encoding);
      }
      if (isSet("PLUGIN_AUTH")) {
        args.authPluginName = packet.readNullTerminatedString(encoding);
      }
      if (isSet("CONNECT_ATTRS")) {
        const keysLength = packet.readLengthCodedNumber(encoding);
        const keysEnd = packet.offset + keysLength;
        const attrs = {};
        while (packet.offset < keysEnd) {
          attrs[packet.readLengthCodedString(encoding)] = packet.readLengthCodedString(encoding);
        }
        args.connectAttributes = attrs;
      }
      return args;
    }
  }
  module.exports = HandshakeResponse;
});
var require_prepare_statement = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var CommandCodes = require_commands();
  var StringParser = require_string2();
  var CharsetToEncoding = require_charset_encodings();

  class PrepareStatement {
    constructor(sql3, charsetNumber) {
      this.query = sql3;
      this.charsetNumber = charsetNumber;
      this.encoding = CharsetToEncoding[charsetNumber];
    }
    toPacket() {
      const buf = StringParser.encode(this.query, this.encoding);
      const length = 5 + buf.length;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(CommandCodes.STMT_PREPARE);
      packet.writeBuffer(buf);
      return packet;
    }
  }
  module.exports = PrepareStatement;
});
var require_prepared_statement_header = __commonJS2((exports, module) => {

  class PreparedStatementHeader {
    constructor(packet) {
      packet.skip(1);
      this.id = packet.readInt32();
      this.fieldCount = packet.readInt16();
      this.parameterCount = packet.readInt16();
      packet.skip(1);
      this.warningCount = packet.readInt16();
    }
  }
  module.exports = PreparedStatementHeader;
});
var require_query = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var CommandCode = require_commands();
  var StringParser = require_string2();
  var CharsetToEncoding = require_charset_encodings();

  class Query {
    constructor(sql3, charsetNumber) {
      this.query = sql3;
      this.charsetNumber = charsetNumber;
      this.encoding = CharsetToEncoding[charsetNumber];
    }
    toPacket() {
      const buf = StringParser.encode(this.query, this.encoding);
      const length = 5 + buf.length;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(CommandCode.QUERY);
      packet.writeBuffer(buf);
      return packet;
    }
  }
  module.exports = Query;
});
var require_register_slave = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var CommandCodes = require_commands();

  class RegisterSlave {
    constructor(opts) {
      this.serverId = opts.serverId || 0;
      this.slaveHostname = opts.slaveHostname || "";
      this.slaveUser = opts.slaveUser || "";
      this.slavePassword = opts.slavePassword || "";
      this.slavePort = opts.slavePort || 0;
      this.replicationRank = opts.replicationRank || 0;
      this.masterId = opts.masterId || 0;
    }
    toPacket() {
      const length = 15 + Buffer.byteLength(this.slaveHostname, "utf8") + Buffer.byteLength(this.slaveUser, "utf8") + Buffer.byteLength(this.slavePassword, "utf8") + 3 + 4;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(CommandCodes.REGISTER_SLAVE);
      packet.writeInt32(this.serverId);
      packet.writeInt8(Buffer.byteLength(this.slaveHostname, "utf8"));
      packet.writeString(this.slaveHostname);
      packet.writeInt8(Buffer.byteLength(this.slaveUser, "utf8"));
      packet.writeString(this.slaveUser);
      packet.writeInt8(Buffer.byteLength(this.slavePassword, "utf8"));
      packet.writeString(this.slavePassword);
      packet.writeInt16(this.slavePort);
      packet.writeInt32(this.replicationRank);
      packet.writeInt32(this.masterId);
      return packet;
    }
  }
  module.exports = RegisterSlave;
});
var require_server_status = __commonJS2((exports) => {
  exports.SERVER_STATUS_IN_TRANS = 1;
  exports.SERVER_STATUS_AUTOCOMMIT = 2;
  exports.SERVER_MORE_RESULTS_EXISTS = 8;
  exports.SERVER_QUERY_NO_GOOD_INDEX_USED = 16;
  exports.SERVER_QUERY_NO_INDEX_USED = 32;
  exports.SERVER_STATUS_CURSOR_EXISTS = 64;
  exports.SERVER_STATUS_LAST_ROW_SENT = 128;
  exports.SERVER_STATUS_DB_DROPPED = 256;
  exports.SERVER_STATUS_NO_BACKSLASH_ESCAPES = 512;
  exports.SERVER_STATUS_METADATA_CHANGED = 1024;
  exports.SERVER_QUERY_WAS_SLOW = 2048;
  exports.SERVER_PS_OUT_PARAMS = 4096;
  exports.SERVER_STATUS_IN_TRANS_READONLY = 8192;
  exports.SERVER_SESSION_STATE_CHANGED = 16384;
});
var require_encoding_charset = __commonJS2((exports, module) => {
  module.exports = {
    big5: 1,
    latin2: 2,
    dec8: 3,
    cp850: 4,
    latin1: 5,
    hp8: 6,
    koi8r: 7,
    swe7: 10,
    ascii: 11,
    eucjp: 12,
    sjis: 13,
    cp1251: 14,
    hebrew: 16,
    tis620: 18,
    euckr: 19,
    latin7: 20,
    koi8u: 22,
    gb2312: 24,
    greek: 25,
    cp1250: 26,
    gbk: 28,
    cp1257: 29,
    latin5: 30,
    armscii8: 32,
    cesu8: 33,
    ucs2: 35,
    cp866: 36,
    keybcs2: 37,
    macintosh: 38,
    macroman: 39,
    cp852: 40,
    utf8: 45,
    utf8mb4: 45,
    utf16: 54,
    utf16le: 56,
    cp1256: 57,
    utf32: 60,
    binary: 63,
    geostd8: 92,
    cp932: 95,
    eucjpms: 97,
    gb18030: 248
  };
});
var require_session_track = __commonJS2((exports) => {
  exports.SYSTEM_VARIABLES = 0;
  exports.SCHEMA = 1;
  exports.STATE_CHANGE = 2;
  exports.STATE_GTIDS = 3;
  exports.TRANSACTION_CHARACTERISTICS = 4;
  exports.TRANSACTION_STATE = 5;
  exports.FIRST_KEY = exports.SYSTEM_VARIABLES;
  exports.LAST_KEY = exports.TRANSACTION_STATE;
});
var require_resultset_header = __commonJS2((exports, module) => {
  var Packet = require_packet();
  var ClientConstants = require_client();
  var ServerSatusFlags = require_server_status();
  var EncodingToCharset = require_encoding_charset();
  var sessionInfoTypes = require_session_track();

  class ResultSetHeader {
    constructor(packet, connection) {
      const bigNumberStrings = connection.config.bigNumberStrings;
      const encoding = connection.serverEncoding;
      const flags = connection._handshakePacket.capabilityFlags;
      const isSet = function(flag) {
        return flags & ClientConstants[flag];
      };
      if (packet.buffer[packet.offset] !== 0) {
        this.fieldCount = packet.readLengthCodedNumber();
        if (this.fieldCount === null) {
          this.infileName = packet.readString(undefined, encoding);
        }
        return;
      }
      this.fieldCount = packet.readInt8();
      this.affectedRows = packet.readLengthCodedNumber(bigNumberStrings);
      this.insertId = packet.readLengthCodedNumberSigned(bigNumberStrings);
      this.info = "";
      if (isSet("PROTOCOL_41")) {
        this.serverStatus = packet.readInt16();
        this.warningStatus = packet.readInt16();
      } else if (isSet("TRANSACTIONS")) {
        this.serverStatus = packet.readInt16();
      }
      let stateChanges = null;
      if (isSet("SESSION_TRACK") && packet.offset < packet.end) {
        this.info = packet.readLengthCodedString(encoding);
        if (this.serverStatus && ServerSatusFlags.SERVER_SESSION_STATE_CHANGED) {
          let len = packet.offset < packet.end ? packet.readLengthCodedNumber() : 0;
          const end = packet.offset + len;
          let type, key, stateEnd;
          if (len > 0) {
            stateChanges = {
              systemVariables: {},
              schema: null,
              gtids: [],
              trackStateChange: null
            };
          }
          while (packet.offset < end) {
            type = packet.readInt8();
            len = packet.readLengthCodedNumber();
            stateEnd = packet.offset + len;
            if (type === sessionInfoTypes.SYSTEM_VARIABLES) {
              key = packet.readLengthCodedString(encoding);
              const val2 = packet.readLengthCodedString(encoding);
              stateChanges.systemVariables[key] = val2;
              if (key === "character_set_client") {
                const charsetNumber = EncodingToCharset[val2];
                connection.config.charsetNumber = charsetNumber;
              }
            } else if (type === sessionInfoTypes.SCHEMA) {
              key = packet.readLengthCodedString(encoding);
              stateChanges.schema = key;
            } else if (type === sessionInfoTypes.STATE_CHANGE) {
              stateChanges.trackStateChange = packet.readLengthCodedString(encoding);
            } else if (type === sessionInfoTypes.STATE_GTIDS) {
              const _unknownString = packet.readLengthCodedString(encoding);
              const gtid = packet.readLengthCodedString(encoding);
              stateChanges.gtids = gtid.split(",");
            } else {
            }
            packet.offset = stateEnd;
          }
        }
      } else {
        this.info = packet.readString(undefined, encoding);
      }
      if (stateChanges) {
        this.stateChanges = stateChanges;
      }
      const m22 = this.info.match(/\schanged:\s*(\d+)/i);
      if (m22 !== null) {
        this.changedRows = parseInt(m22[1], 10);
      } else {
        this.changedRows = 0;
      }
    }
    static toPacket(fieldCount, insertId) {
      let length = 4 + Packet.lengthCodedNumberLength(fieldCount);
      if (typeof insertId !== "undefined") {
        length += Packet.lengthCodedNumberLength(insertId);
      }
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeLengthCodedNumber(fieldCount);
      if (typeof insertId !== "undefined") {
        packet.writeLengthCodedNumber(insertId);
      }
      return packet;
    }
  }
  module.exports = ResultSetHeader;
});
var require_ssl_request = __commonJS2((exports, module) => {
  var ClientConstants = require_client();
  var Packet = require_packet();

  class SSLRequest {
    constructor(flags, charset) {
      this.clientFlags = flags | ClientConstants.SSL;
      this.charset = charset;
    }
    toPacket() {
      const length = 36;
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      buffer.fill(0);
      packet.offset = 4;
      packet.writeInt32(this.clientFlags);
      packet.writeInt32(0);
      packet.writeInt8(this.charset);
      return packet;
    }
  }
  module.exports = SSLRequest;
});
var require_text_row = __commonJS2((exports, module) => {
  var Packet = require_packet();

  class TextRow {
    constructor(columns) {
      this.columns = columns || [];
    }
    static fromPacket(packet) {
      const columns = [];
      while (packet.haveMoreData()) {
        columns.push(packet.readLengthCodedString());
      }
      return new TextRow(columns);
    }
    static toPacket(columns, encoding) {
      const sequenceId = 0;
      let length = 0;
      columns.forEach((val2) => {
        if (val2 === null || typeof val2 === "undefined") {
          ++length;
          return;
        }
        length += Packet.lengthCodedStringLength(val2.toString(10), encoding);
      });
      const buffer = Buffer.allocUnsafe(length + 4);
      const packet = new Packet(sequenceId, buffer, 0, length + 4);
      packet.offset = 4;
      columns.forEach((val2) => {
        if (val2 === null) {
          packet.writeNull();
          return;
        }
        if (typeof val2 === "undefined") {
          packet.writeInt8(0);
          return;
        }
        packet.writeLengthCodedString(val2.toString(10), encoding);
      });
      return packet;
    }
  }
  module.exports = TextRow;
});
var require_packets = __commonJS2((exports, module) => {
  var process102 = import.meta.require("process");
  var AuthNextFactor = require_auth_next_factor();
  var AuthSwitchRequest = require_auth_switch_request();
  var AuthSwitchRequestMoreData = require_auth_switch_request_more_data();
  var AuthSwitchResponse = require_auth_switch_response();
  var BinaryRow = require_binary_row();
  var BinlogDump = require_binlog_dump();
  var ChangeUser = require_change_user();
  var CloseStatement = require_close_statement();
  var ColumnDefinition = require_column_definition();
  var Execute = require_execute();
  var Handshake = require_handshake();
  var HandshakeResponse = require_handshake_response();
  var PrepareStatement = require_prepare_statement();
  var PreparedStatementHeader = require_prepared_statement_header();
  var Query = require_query();
  var RegisterSlave = require_register_slave();
  var ResultSetHeader = require_resultset_header();
  var SSLRequest = require_ssl_request();
  var TextRow = require_text_row();
  var ctorMap = {
    AuthNextFactor,
    AuthSwitchRequest,
    AuthSwitchRequestMoreData,
    AuthSwitchResponse,
    BinaryRow,
    BinlogDump,
    ChangeUser,
    CloseStatement,
    ColumnDefinition,
    Execute,
    Handshake,
    HandshakeResponse,
    PrepareStatement,
    PreparedStatementHeader,
    Query,
    RegisterSlave,
    ResultSetHeader,
    SSLRequest,
    TextRow
  };
  Object.entries(ctorMap).forEach(([name, ctor]) => {
    exports[name] = ctor;
    if (process102.env.NODE_DEBUG) {
      if (ctor.prototype.toPacket) {
        const old = ctor.prototype.toPacket;
        ctor.prototype.toPacket = function() {
          const p32 = old.call(this);
          p32._name = name;
          return p32;
        };
      }
    }
  });
  var Packet = require_packet();
  exports.Packet = Packet;

  class OK {
    static toPacket(args, encoding) {
      args = args || {};
      const affectedRows = args.affectedRows || 0;
      const insertId = args.insertId || 0;
      const serverStatus = args.serverStatus || 0;
      const warningCount = args.warningCount || 0;
      const message = args.message || "";
      let length = 9 + Packet.lengthCodedNumberLength(affectedRows);
      length += Packet.lengthCodedNumberLength(insertId);
      const buffer = Buffer.allocUnsafe(length);
      const packet = new Packet(0, buffer, 0, length);
      packet.offset = 4;
      packet.writeInt8(0);
      packet.writeLengthCodedNumber(affectedRows);
      packet.writeLengthCodedNumber(insertId);
      packet.writeInt16(serverStatus);
      packet.writeInt16(warningCount);
      packet.writeString(message, encoding);
      packet._name = "OK";
      return packet;
    }
  }
  exports.OK = OK;

  class EOF {
    static toPacket(warnings, statusFlags) {
      if (typeof warnings === "undefined") {
        warnings = 0;
      }
      if (typeof statusFlags === "undefined") {
        statusFlags = 0;
      }
      const packet = new Packet(0, Buffer.allocUnsafe(9), 0, 9);
      packet.offset = 4;
      packet.writeInt8(254);
      packet.writeInt16(warnings);
      packet.writeInt16(statusFlags);
      packet._name = "EOF";
      return packet;
    }
  }
  exports.EOF = EOF;

  class Error2 {
    static toPacket(args, encoding) {
      const length = 13 + Buffer.byteLength(args.message, "utf8");
      const packet = new Packet(0, Buffer.allocUnsafe(length), 0, length);
      packet.offset = 4;
      packet.writeInt8(255);
      packet.writeInt16(args.code);
      packet.writeString("#_____", encoding);
      packet.writeString(args.message, encoding);
      packet._name = "Error";
      return packet;
    }
    static fromPacket(packet) {
      packet.readInt8();
      const code = packet.readInt16();
      packet.readString(1, "ascii");
      packet.readString(5, "ascii");
      const message = packet.readNullTerminatedString("utf8");
      const error = new Error2;
      error.message = message;
      error.code = code;
      return error;
    }
  }
  exports.Error = Error2;
});
var require_command = __commonJS2((exports, module) => {
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var Timers = import.meta.require("timers");

  class Command2 extends EventEmitter23 {
    constructor() {
      super();
      this.next = null;
    }
    stateName() {
      const state = this.next;
      for (const i2 in this) {
        if (this[i2] === state && i2 !== "next") {
          return i2;
        }
      }
      return "unknown name";
    }
    execute(packet, connection) {
      if (!this.next) {
        this.next = this.start;
        connection._resetSequenceId();
      }
      if (packet && packet.isError()) {
        const err22 = packet.asError(connection.clientEncoding);
        err22.sql = this.sql || this.query;
        if (this.queryTimeout) {
          Timers.clearTimeout(this.queryTimeout);
          this.queryTimeout = null;
        }
        if (this.onResult) {
          this.onResult(err22);
          this.emit("end");
        } else {
          this.emit("error", err22);
          this.emit("end");
        }
        return true;
      }
      this.next = this.next(packet, connection);
      if (this.next) {
        return false;
      }
      this.emit("end");
      return true;
    }
  }
  module.exports = Command2;
});
var require_sha256_password = __commonJS2((exports, module) => {
  var PLUGIN_NAME = "sha256_password";
  var crypto = import.meta.require("crypto");
  var { xorRotating } = require_auth_41();
  var REQUEST_SERVER_KEY_PACKET = Buffer.from([1]);
  var STATE_INITIAL = 0;
  var STATE_WAIT_SERVER_KEY = 1;
  var STATE_FINAL = -1;
  function encrypt(password, scramble, key) {
    const stage1 = xorRotating(Buffer.from(`${password}\0`, "utf8"), scramble);
    return crypto.publicEncrypt(key, stage1);
  }
  module.exports = (pluginOptions = {}) => ({ connection }) => {
    let state = 0;
    let scramble = null;
    const password = connection.config.password;
    const authWithKey = (serverKey) => {
      const _password = encrypt(password, scramble, serverKey);
      state = STATE_FINAL;
      return _password;
    };
    return (data2) => {
      switch (state) {
        case STATE_INITIAL:
          scramble = data2.slice(0, 20);
          if (pluginOptions.serverPublicKey) {
            return authWithKey(pluginOptions.serverPublicKey);
          }
          state = STATE_WAIT_SERVER_KEY;
          return REQUEST_SERVER_KEY_PACKET;
        case STATE_WAIT_SERVER_KEY:
          if (pluginOptions.onServerPublicKey) {
            pluginOptions.onServerPublicKey(data2);
          }
          return authWithKey(data2);
        case STATE_FINAL:
          throw new Error(`Unexpected data in AuthMoreData packet received by ${PLUGIN_NAME} plugin in STATE_FINAL state.`);
      }
      throw new Error(`Unexpected data in AuthMoreData packet received by ${PLUGIN_NAME} plugin in state ${state}`);
    };
  };
});
var require_caching_sha2_password = __commonJS2((exports, module) => {
  var PLUGIN_NAME = "caching_sha2_password";
  var crypto = import.meta.require("crypto");
  var { xor, xorRotating } = require_auth_41();
  var REQUEST_SERVER_KEY_PACKET = Buffer.from([2]);
  var FAST_AUTH_SUCCESS_PACKET = Buffer.from([3]);
  var PERFORM_FULL_AUTHENTICATION_PACKET = Buffer.from([4]);
  var STATE_INITIAL = 0;
  var STATE_TOKEN_SENT = 1;
  var STATE_WAIT_SERVER_KEY = 2;
  var STATE_FINAL = -1;
  function sha256(msg) {
    const hash = crypto.createHash("sha256");
    hash.update(msg);
    return hash.digest();
  }
  function calculateToken(password, scramble) {
    if (!password) {
      return Buffer.alloc(0);
    }
    const stage1 = sha256(Buffer.from(password));
    const stage2 = sha256(stage1);
    const stage3 = sha256(Buffer.concat([stage2, scramble]));
    return xor(stage1, stage3);
  }
  function encrypt(password, scramble, key) {
    const stage1 = xorRotating(Buffer.from(`${password}\0`, "utf8"), scramble);
    return crypto.publicEncrypt({
      key,
      padding: crypto.constants.RSA_PKCS1_OAEP_PADDING
    }, stage1);
  }
  module.exports = (pluginOptions = {}) => ({ connection }) => {
    let state = 0;
    let scramble = null;
    const password = connection.config.password;
    const authWithKey = (serverKey) => {
      const _password = encrypt(password, scramble, serverKey);
      state = STATE_FINAL;
      return _password;
    };
    return (data2) => {
      switch (state) {
        case STATE_INITIAL:
          scramble = data2.slice(0, 20);
          state = STATE_TOKEN_SENT;
          return calculateToken(password, scramble);
        case STATE_TOKEN_SENT:
          if (FAST_AUTH_SUCCESS_PACKET.equals(data2)) {
            state = STATE_FINAL;
            return null;
          }
          if (PERFORM_FULL_AUTHENTICATION_PACKET.equals(data2)) {
            const isSecureConnection = typeof pluginOptions.overrideIsSecure === "undefined" ? connection.config.ssl || connection.config.socketPath : pluginOptions.overrideIsSecure;
            if (isSecureConnection) {
              state = STATE_FINAL;
              return Buffer.from(`${password}\0`, "utf8");
            }
            if (pluginOptions.serverPublicKey) {
              return authWithKey(pluginOptions.serverPublicKey);
            }
            state = STATE_WAIT_SERVER_KEY;
            return REQUEST_SERVER_KEY_PACKET;
          }
          throw new Error(`Invalid AuthMoreData packet received by ${PLUGIN_NAME} plugin in STATE_TOKEN_SENT state.`);
        case STATE_WAIT_SERVER_KEY:
          if (pluginOptions.onServerPublicKey) {
            pluginOptions.onServerPublicKey(data2);
          }
          return authWithKey(data2);
        case STATE_FINAL:
          throw new Error(`Unexpected data in AuthMoreData packet received by ${PLUGIN_NAME} plugin in STATE_FINAL state.`);
      }
      throw new Error(`Unexpected data in AuthMoreData packet received by ${PLUGIN_NAME} plugin in state ${state}`);
    };
  };
});
var require_mysql_native_password = __commonJS2((exports, module) => {
  var auth41 = require_auth_41();
  module.exports = (pluginOptions) => ({ connection, command: command2 }) => {
    const password = command2.password || pluginOptions.password || connection.config.password;
    const passwordSha1 = command2.passwordSha1 || pluginOptions.passwordSha1 || connection.config.passwordSha1;
    return (data2) => {
      const authPluginData1 = data2.slice(0, 8);
      const authPluginData2 = data2.slice(8, 20);
      let authToken;
      if (passwordSha1) {
        authToken = auth41.calculateTokenFromPasswordSha(passwordSha1, authPluginData1, authPluginData2);
      } else {
        authToken = auth41.calculateToken(password, authPluginData1, authPluginData2);
      }
      return authToken;
    };
  };
});
var require_mysql_clear_password = __commonJS2((exports, module) => {
  function bufferFromStr(str) {
    return Buffer.from(`${str}\0`);
  }
  var create_mysql_clear_password_plugin = (pluginOptions) => function mysql_clear_password_plugin({ connection, command: command2 }) {
    const password = command2.password || pluginOptions.password || connection.config.password;
    return function() {
      return bufferFromStr(password);
    };
  };
  module.exports = create_mysql_clear_password_plugin;
});
var require_auth_switch = __commonJS2((exports, module) => {
  var Packets = require_packets();
  var sha256_password = require_sha256_password();
  var caching_sha2_password = require_caching_sha2_password();
  var mysql_native_password = require_mysql_native_password();
  var mysql_clear_password = require_mysql_clear_password();
  var standardAuthPlugins = {
    sha256_password: sha256_password({}),
    caching_sha2_password: caching_sha2_password({}),
    mysql_native_password: mysql_native_password({}),
    mysql_clear_password: mysql_clear_password({})
  };
  function warnLegacyAuthSwitch() {
    console.warn("WARNING! authSwitchHandler api is deprecated, please use new authPlugins api");
  }
  function authSwitchPluginError(error, command2) {
    error.code = "AUTH_SWITCH_PLUGIN_ERROR";
    error.fatal = true;
    command2.emit("error", error);
  }
  function authSwitchRequest(packet, connection, command2) {
    const { pluginName, pluginData } = Packets.AuthSwitchRequest.fromPacket(packet);
    let authPlugin = connection.config.authPlugins && connection.config.authPlugins[pluginName];
    if (connection.config.authSwitchHandler && pluginName !== "mysql_native_password") {
      const legacySwitchHandler = connection.config.authSwitchHandler;
      warnLegacyAuthSwitch();
      legacySwitchHandler({ pluginName, pluginData }, (err22, data2) => {
        if (err22) {
          return authSwitchPluginError(err22, command2);
        }
        connection.writePacket(new Packets.AuthSwitchResponse(data2).toPacket());
      });
      return;
    }
    if (!authPlugin) {
      authPlugin = standardAuthPlugins[pluginName];
    }
    if (!authPlugin) {
      throw new Error(`Server requests authentication using unknown plugin ${pluginName}. See TODO: add plugins doco here on how to configure or author authentication plugins.`);
    }
    connection._authPlugin = authPlugin({ connection, command: command2 });
    Promise.resolve(connection._authPlugin(pluginData)).then((data2) => {
      if (data2) {
        connection.writePacket(new Packets.AuthSwitchResponse(data2).toPacket());
      }
    }).catch((err22) => {
      authSwitchPluginError(err22, command2);
    });
  }
  function authSwitchRequestMoreData(packet, connection, command2) {
    const { data: data2 } = Packets.AuthSwitchRequestMoreData.fromPacket(packet);
    if (connection.config.authSwitchHandler) {
      const legacySwitchHandler = connection.config.authSwitchHandler;
      warnLegacyAuthSwitch();
      legacySwitchHandler({ pluginData: data2 }, (err22, data3) => {
        if (err22) {
          return authSwitchPluginError(err22, command2);
        }
        connection.writePacket(new Packets.AuthSwitchResponse(data3).toPacket());
      });
      return;
    }
    if (!connection._authPlugin) {
      throw new Error("AuthPluginMoreData received but no auth plugin instance found");
    }
    Promise.resolve(connection._authPlugin(data2)).then((data3) => {
      if (data3) {
        connection.writePacket(new Packets.AuthSwitchResponse(data3).toPacket());
      }
    }).catch((err22) => {
      authSwitchPluginError(err22, command2);
    });
  }
  module.exports = {
    authSwitchRequest,
    authSwitchRequestMoreData
  };
});
var require_seq_queue = __commonJS2((exports, module) => {
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var util = import.meta.require("util");
  var DEFAULT_TIMEOUT = 3000;
  var INIT_ID = 0;
  var EVENT_CLOSED = "closed";
  var EVENT_DRAINED = "drained";
  var SeqQueue = function(timeout) {
    EventEmitter23.call(this);
    if (timeout && timeout > 0) {
      this.timeout = timeout;
    } else {
      this.timeout = DEFAULT_TIMEOUT;
    }
    this.status = SeqQueueManager.STATUS_IDLE;
    this.curId = INIT_ID;
    this.queue = [];
  };
  util.inherits(SeqQueue, EventEmitter23);
  SeqQueue.prototype.push = function(fn, ontimeout, timeout) {
    if (this.status !== SeqQueueManager.STATUS_IDLE && this.status !== SeqQueueManager.STATUS_BUSY) {
      return false;
    }
    if (typeof fn !== "function") {
      throw new Error("fn should be a function.");
    }
    this.queue.push({ fn, ontimeout, timeout });
    if (this.status === SeqQueueManager.STATUS_IDLE) {
      this.status = SeqQueueManager.STATUS_BUSY;
      var self2 = this;
      process.nextTick(function() {
        self2._next(self2.curId);
      });
    }
    return true;
  };
  SeqQueue.prototype.close = function(force) {
    if (this.status !== SeqQueueManager.STATUS_IDLE && this.status !== SeqQueueManager.STATUS_BUSY) {
      return;
    }
    if (force) {
      this.status = SeqQueueManager.STATUS_DRAINED;
      if (this.timerId) {
        clearTimeout(this.timerId);
        this.timerId = undefined;
      }
      this.emit(EVENT_DRAINED);
    } else {
      this.status = SeqQueueManager.STATUS_CLOSED;
      this.emit(EVENT_CLOSED);
    }
  };
  SeqQueue.prototype._next = function(tid) {
    if (tid !== this.curId || this.status !== SeqQueueManager.STATUS_BUSY && this.status !== SeqQueueManager.STATUS_CLOSED) {
      return;
    }
    if (this.timerId) {
      clearTimeout(this.timerId);
      this.timerId = undefined;
    }
    var task = this.queue.shift();
    if (!task) {
      if (this.status === SeqQueueManager.STATUS_BUSY) {
        this.status = SeqQueueManager.STATUS_IDLE;
        this.curId++;
      } else {
        this.status = SeqQueueManager.STATUS_DRAINED;
        this.emit(EVENT_DRAINED);
      }
      return;
    }
    var self2 = this;
    task.id = ++this.curId;
    var timeout = task.timeout > 0 ? task.timeout : this.timeout;
    timeout = timeout > 0 ? timeout : DEFAULT_TIMEOUT;
    this.timerId = setTimeout(function() {
      process.nextTick(function() {
        self2._next(task.id);
      });
      self2.emit("timeout", task);
      if (task.ontimeout) {
        task.ontimeout();
      }
    }, timeout);
    try {
      task.fn({
        done: function() {
          var res = task.id === self2.curId;
          process.nextTick(function() {
            self2._next(task.id);
          });
          return res;
        }
      });
    } catch (err22) {
      self2.emit("error", err22, task);
      process.nextTick(function() {
        self2._next(task.id);
      });
    }
  };
  var SeqQueueManager = exports;
  SeqQueueManager.STATUS_IDLE = 0;
  SeqQueueManager.STATUS_BUSY = 1;
  SeqQueueManager.STATUS_CLOSED = 2;
  SeqQueueManager.STATUS_DRAINED = 3;
  SeqQueueManager.createQueue = function(timeout) {
    return new SeqQueue(timeout);
  };
});
var require_compressed_protocol = __commonJS2((exports, module) => {
  var zlib = import.meta.require("zlib");
  var PacketParser = require_packet_parser();
  function handleCompressedPacket(packet) {
    const connection = this;
    const deflatedLength = packet.readInt24();
    const body = packet.readBuffer();
    if (deflatedLength !== 0) {
      connection.inflateQueue.push((task) => {
        zlib.inflate(body, (err22, data2) => {
          if (err22) {
            connection._handleNetworkError(err22);
            return;
          }
          connection._bumpCompressedSequenceId(packet.numPackets);
          connection._inflatedPacketsParser.execute(data2);
          task.done();
        });
      });
    } else {
      connection.inflateQueue.push((task) => {
        connection._bumpCompressedSequenceId(packet.numPackets);
        connection._inflatedPacketsParser.execute(body);
        task.done();
      });
    }
  }
  function writeCompressed(buffer) {
    const MAX_COMPRESSED_LENGTH = 16777210;
    let start;
    if (buffer.length > MAX_COMPRESSED_LENGTH) {
      for (start = 0;start < buffer.length; start += MAX_COMPRESSED_LENGTH) {
        writeCompressed.call(this, buffer.slice(start, start + MAX_COMPRESSED_LENGTH));
      }
      return;
    }
    const connection = this;
    let packetLen = buffer.length;
    const compressHeader = Buffer.allocUnsafe(7);
    (function(seqId) {
      connection.deflateQueue.push((task) => {
        zlib.deflate(buffer, (err22, compressed) => {
          if (err22) {
            connection._handleFatalError(err22);
            return;
          }
          let compressedLength = compressed.length;
          if (compressedLength < packetLen) {
            compressHeader.writeUInt8(compressedLength & 255, 0);
            compressHeader.writeUInt16LE(compressedLength >> 8, 1);
            compressHeader.writeUInt8(seqId, 3);
            compressHeader.writeUInt8(packetLen & 255, 4);
            compressHeader.writeUInt16LE(packetLen >> 8, 5);
            connection.writeUncompressed(compressHeader);
            connection.writeUncompressed(compressed);
          } else {
            compressedLength = packetLen;
            packetLen = 0;
            compressHeader.writeUInt8(compressedLength & 255, 0);
            compressHeader.writeUInt16LE(compressedLength >> 8, 1);
            compressHeader.writeUInt8(seqId, 3);
            compressHeader.writeUInt8(packetLen & 255, 4);
            compressHeader.writeUInt16LE(packetLen >> 8, 5);
            connection.writeUncompressed(compressHeader);
            connection.writeUncompressed(buffer);
          }
          task.done();
        });
      });
    })(connection.compressedSequenceId);
    connection._bumpCompressedSequenceId(1);
  }
  function enableCompression(connection) {
    connection._lastWrittenPacketId = 0;
    connection._lastReceivedPacketId = 0;
    connection._handleCompressedPacket = handleCompressedPacket;
    connection._inflatedPacketsParser = new PacketParser((p32) => {
      connection.handlePacket(p32);
    }, 4);
    connection._inflatedPacketsParser._lastPacket = 0;
    connection.packetParser = new PacketParser((packet) => {
      connection._handleCompressedPacket(packet);
    }, 7);
    connection.writeUncompressed = connection.write;
    connection.write = writeCompressed;
    const seqqueue = require_seq_queue();
    connection.inflateQueue = seqqueue.createQueue();
    connection.deflateQueue = seqqueue.createQueue();
  }
  module.exports = {
    enableCompression
  };
});
var require_client_handshake = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var Packets = require_packets();
  var ClientConstants = require_client();
  var CharsetToEncoding = require_charset_encodings();
  var auth41 = require_auth_41();
  function flagNames(flags) {
    const res = [];
    for (const c22 in ClientConstants) {
      if (flags & ClientConstants[c22]) {
        res.push(c22.replace(/_/g, " ").toLowerCase());
      }
    }
    return res;
  }

  class ClientHandshake extends Command2 {
    constructor(clientFlags) {
      super();
      this.handshake = null;
      this.clientFlags = clientFlags;
      this.authenticationFactor = 0;
    }
    start() {
      return ClientHandshake.prototype.handshakeInit;
    }
    sendSSLRequest(connection) {
      const sslRequest = new Packets.SSLRequest(this.clientFlags, connection.config.charsetNumber);
      connection.writePacket(sslRequest.toPacket());
    }
    sendCredentials(connection) {
      if (connection.config.debug) {
        console.log("Sending handshake packet: flags:%d=(%s)", this.clientFlags, flagNames(this.clientFlags).join(", "));
      }
      this.user = connection.config.user;
      this.password = connection.config.password;
      this.password1 = connection.config.password;
      this.password2 = connection.config.password2;
      this.password3 = connection.config.password3;
      this.passwordSha1 = connection.config.passwordSha1;
      this.database = connection.config.database;
      this.autPluginName = this.handshake.autPluginName;
      const handshakeResponse = new Packets.HandshakeResponse({
        flags: this.clientFlags,
        user: this.user,
        database: this.database,
        password: this.password,
        passwordSha1: this.passwordSha1,
        charsetNumber: connection.config.charsetNumber,
        authPluginData1: this.handshake.authPluginData1,
        authPluginData2: this.handshake.authPluginData2,
        compress: connection.config.compress,
        connectAttributes: connection.config.connectAttributes
      });
      connection.writePacket(handshakeResponse.toPacket());
    }
    calculateNativePasswordAuthToken(authPluginData) {
      const authPluginData1 = authPluginData.slice(0, 8);
      const authPluginData2 = authPluginData.slice(8, 20);
      let authToken;
      if (this.passwordSha1) {
        authToken = auth41.calculateTokenFromPasswordSha(this.passwordSha1, authPluginData1, authPluginData2);
      } else {
        authToken = auth41.calculateToken(this.password, authPluginData1, authPluginData2);
      }
      return authToken;
    }
    handshakeInit(helloPacket, connection) {
      this.on("error", (e) => {
        connection._fatalError = e;
        connection._protocolError = e;
      });
      this.handshake = Packets.Handshake.fromPacket(helloPacket);
      if (connection.config.debug) {
        console.log("Server hello packet: capability flags:%d=(%s)", this.handshake.capabilityFlags, flagNames(this.handshake.capabilityFlags).join(", "));
      }
      connection.serverCapabilityFlags = this.handshake.capabilityFlags;
      connection.serverEncoding = CharsetToEncoding[this.handshake.characterSet];
      connection.connectionId = this.handshake.connectionId;
      const serverSSLSupport = this.handshake.capabilityFlags & ClientConstants.SSL;
      const multiFactorAuthentication = this.handshake.capabilityFlags & ClientConstants.MULTI_FACTOR_AUTHENTICATION;
      this.clientFlags = this.clientFlags | multiFactorAuthentication;
      connection.config.compress = connection.config.compress && this.handshake.capabilityFlags & ClientConstants.COMPRESS;
      this.clientFlags = this.clientFlags | connection.config.compress;
      if (connection.config.ssl) {
        if (!serverSSLSupport) {
          const err22 = new Error("Server does not support secure connection");
          err22.code = "HANDSHAKE_NO_SSL_SUPPORT";
          err22.fatal = true;
          this.emit("error", err22);
          return false;
        }
        this.clientFlags |= ClientConstants.SSL;
        this.sendSSLRequest(connection);
        connection.startTLS((err22) => {
          if (err22) {
            err22.code = "HANDSHAKE_SSL_ERROR";
            err22.fatal = true;
            this.emit("error", err22);
            return;
          }
          this.sendCredentials(connection);
        });
      } else {
        this.sendCredentials(connection);
      }
      if (multiFactorAuthentication) {
        this.authenticationFactor = 1;
      }
      return ClientHandshake.prototype.handshakeResult;
    }
    handshakeResult(packet, connection) {
      const marker = packet.peekByte();
      if (marker === 254 || marker === 1 || marker === 2) {
        const authSwitch = require_auth_switch();
        try {
          if (marker === 1) {
            authSwitch.authSwitchRequestMoreData(packet, connection, this);
          } else {
            if (this.authenticationFactor !== 0) {
              connection.config.password = this[`password${this.authenticationFactor}`];
              this.authenticationFactor += 1;
            }
            authSwitch.authSwitchRequest(packet, connection, this);
          }
          return ClientHandshake.prototype.handshakeResult;
        } catch (err22) {
          err22.code = "AUTH_SWITCH_PLUGIN_ERROR";
          err22.fatal = true;
          if (this.onResult) {
            this.onResult(err22);
          } else {
            this.emit("error", err22);
          }
          return null;
        }
      }
      if (marker !== 0) {
        const err22 = new Error("Unexpected packet during handshake phase");
        err22.code = "HANDSHAKE_UNKNOWN_ERROR";
        err22.fatal = true;
        if (this.onResult) {
          this.onResult(err22);
        } else {
          this.emit("error", err22);
        }
        return null;
      }
      if (!connection.authorized) {
        connection.authorized = true;
        if (connection.config.compress) {
          const enableCompression = require_compressed_protocol().enableCompression;
          enableCompression(connection);
        }
      }
      if (this.onResult) {
        this.onResult(null);
      }
      return null;
    }
  }
  module.exports = ClientHandshake;
});
var require_server_handshake = __commonJS2((exports, module) => {
  var CommandCode = require_commands();
  var Errors = require_errors();
  var Command2 = require_command();
  var Packets = require_packets();

  class ServerHandshake extends Command2 {
    constructor(args) {
      super();
      this.args = args;
    }
    start(packet, connection) {
      const serverHelloPacket = new Packets.Handshake(this.args);
      this.serverHello = serverHelloPacket;
      serverHelloPacket.setScrambleData((err22) => {
        if (err22) {
          connection.emit("error", new Error("Error generating random bytes"));
          return;
        }
        connection.writePacket(serverHelloPacket.toPacket(0));
      });
      return ServerHandshake.prototype.readClientReply;
    }
    readClientReply(packet, connection) {
      const clientHelloReply = Packets.HandshakeResponse.fromPacket(packet);
      connection.clientHelloReply = clientHelloReply;
      if (this.args.authCallback) {
        this.args.authCallback({
          user: clientHelloReply.user,
          database: clientHelloReply.database,
          address: connection.stream.remoteAddress,
          authPluginData1: this.serverHello.authPluginData1,
          authPluginData2: this.serverHello.authPluginData2,
          authToken: clientHelloReply.authToken
        }, (err22, mysqlError) => {
          if (!mysqlError) {
            connection.writeOk();
          } else {
            connection.writeError({
              message: mysqlError.message || "",
              code: mysqlError.code || 1045
            });
            connection.close();
          }
        });
      } else {
        connection.writeOk();
      }
      return ServerHandshake.prototype.dispatchCommands;
    }
    _isStatement(query, name) {
      const firstWord = query.split(" ")[0].toUpperCase();
      return firstWord === name;
    }
    dispatchCommands(packet, connection) {
      let knownCommand = true;
      const encoding = connection.clientHelloReply.encoding;
      const commandCode = packet.readInt8();
      switch (commandCode) {
        case CommandCode.STMT_PREPARE:
          if (connection.listeners("stmt_prepare").length) {
            const query = packet.readString(undefined, encoding);
            connection.emit("stmt_prepare", query);
          } else {
            connection.writeError({
              code: Errors.HA_ERR_INTERNAL_ERROR,
              message: "No query handler for prepared statements."
            });
          }
          break;
        case CommandCode.STMT_EXECUTE:
          if (connection.listeners("stmt_execute").length) {
            const { stmtId, flags, iterationCount, values: values3 } = Packets.Execute.fromPacket(packet, encoding);
            connection.emit("stmt_execute", stmtId, flags, iterationCount, values3);
          } else {
            connection.writeError({
              code: Errors.HA_ERR_INTERNAL_ERROR,
              message: "No query handler for execute statements."
            });
          }
          break;
        case CommandCode.QUIT:
          if (connection.listeners("quit").length) {
            connection.emit("quit");
          } else {
            connection.stream.end();
          }
          break;
        case CommandCode.INIT_DB:
          if (connection.listeners("init_db").length) {
            const schemaName = packet.readString(undefined, encoding);
            connection.emit("init_db", schemaName);
          } else {
            connection.writeOk();
          }
          break;
        case CommandCode.QUERY:
          if (connection.listeners("query").length) {
            const query = packet.readString(undefined, encoding);
            if (this._isStatement(query, "PREPARE") || this._isStatement(query, "SET")) {
              connection.emit("stmt_prepare", query);
            } else if (this._isStatement(query, "EXECUTE")) {
              connection.emit("stmt_execute", null, null, null, null, query);
            } else
              connection.emit("query", query);
          } else {
            connection.writeError({
              code: Errors.HA_ERR_INTERNAL_ERROR,
              message: "No query handler"
            });
          }
          break;
        case CommandCode.FIELD_LIST:
          if (connection.listeners("field_list").length) {
            const table = packet.readNullTerminatedString(encoding);
            const fields22 = packet.readString(undefined, encoding);
            connection.emit("field_list", table, fields22);
          } else {
            connection.writeError({
              code: Errors.ER_WARN_DEPRECATED_SYNTAX,
              message: "As of MySQL 5.7.11, COM_FIELD_LIST is deprecated and will be removed in a future version of MySQL."
            });
          }
          break;
        case CommandCode.PING:
          if (connection.listeners("ping").length) {
            connection.emit("ping");
          } else {
            connection.writeOk();
          }
          break;
        default:
          knownCommand = false;
      }
      if (connection.listeners("packet").length) {
        connection.emit("packet", packet.clone(), knownCommand, commandCode);
      } else if (!knownCommand) {
        console.log("Unknown command:", commandCode);
      }
      return ServerHandshake.prototype.dispatchCommands;
    }
  }
  module.exports = ServerHandshake;
});
var require_charsets = __commonJS2((exports) => {
  exports.BIG5_CHINESE_CI = 1;
  exports.LATIN2_CZECH_CS = 2;
  exports.DEC8_SWEDISH_CI = 3;
  exports.CP850_GENERAL_CI = 4;
  exports.LATIN1_GERMAN1_CI = 5;
  exports.HP8_ENGLISH_CI = 6;
  exports.KOI8R_GENERAL_CI = 7;
  exports.LATIN1_SWEDISH_CI = 8;
  exports.LATIN2_GENERAL_CI = 9;
  exports.SWE7_SWEDISH_CI = 10;
  exports.ASCII_GENERAL_CI = 11;
  exports.UJIS_JAPANESE_CI = 12;
  exports.SJIS_JAPANESE_CI = 13;
  exports.CP1251_BULGARIAN_CI = 14;
  exports.LATIN1_DANISH_CI = 15;
  exports.HEBREW_GENERAL_CI = 16;
  exports.TIS620_THAI_CI = 18;
  exports.EUCKR_KOREAN_CI = 19;
  exports.LATIN7_ESTONIAN_CS = 20;
  exports.LATIN2_HUNGARIAN_CI = 21;
  exports.KOI8U_GENERAL_CI = 22;
  exports.CP1251_UKRAINIAN_CI = 23;
  exports.GB2312_CHINESE_CI = 24;
  exports.GREEK_GENERAL_CI = 25;
  exports.CP1250_GENERAL_CI = 26;
  exports.LATIN2_CROATIAN_CI = 27;
  exports.GBK_CHINESE_CI = 28;
  exports.CP1257_LITHUANIAN_CI = 29;
  exports.LATIN5_TURKISH_CI = 30;
  exports.LATIN1_GERMAN2_CI = 31;
  exports.ARMSCII8_GENERAL_CI = 32;
  exports.UTF8_GENERAL_CI = 33;
  exports.CP1250_CZECH_CS = 34;
  exports.UCS2_GENERAL_CI = 35;
  exports.CP866_GENERAL_CI = 36;
  exports.KEYBCS2_GENERAL_CI = 37;
  exports.MACCE_GENERAL_CI = 38;
  exports.MACROMAN_GENERAL_CI = 39;
  exports.CP852_GENERAL_CI = 40;
  exports.LATIN7_GENERAL_CI = 41;
  exports.LATIN7_GENERAL_CS = 42;
  exports.MACCE_BIN = 43;
  exports.CP1250_CROATIAN_CI = 44;
  exports.UTF8MB4_GENERAL_CI = 45;
  exports.UTF8MB4_BIN = 46;
  exports.LATIN1_BIN = 47;
  exports.LATIN1_GENERAL_CI = 48;
  exports.LATIN1_GENERAL_CS = 49;
  exports.CP1251_BIN = 50;
  exports.CP1251_GENERAL_CI = 51;
  exports.CP1251_GENERAL_CS = 52;
  exports.MACROMAN_BIN = 53;
  exports.UTF16_GENERAL_CI = 54;
  exports.UTF16_BIN = 55;
  exports.UTF16LE_GENERAL_CI = 56;
  exports.CP1256_GENERAL_CI = 57;
  exports.CP1257_BIN = 58;
  exports.CP1257_GENERAL_CI = 59;
  exports.UTF32_GENERAL_CI = 60;
  exports.UTF32_BIN = 61;
  exports.UTF16LE_BIN = 62;
  exports.BINARY = 63;
  exports.ARMSCII8_BIN = 64;
  exports.ASCII_BIN = 65;
  exports.CP1250_BIN = 66;
  exports.CP1256_BIN = 67;
  exports.CP866_BIN = 68;
  exports.DEC8_BIN = 69;
  exports.GREEK_BIN = 70;
  exports.HEBREW_BIN = 71;
  exports.HP8_BIN = 72;
  exports.KEYBCS2_BIN = 73;
  exports.KOI8R_BIN = 74;
  exports.KOI8U_BIN = 75;
  exports.UTF8_TOLOWER_CI = 76;
  exports.LATIN2_BIN = 77;
  exports.LATIN5_BIN = 78;
  exports.LATIN7_BIN = 79;
  exports.CP850_BIN = 80;
  exports.CP852_BIN = 81;
  exports.SWE7_BIN = 82;
  exports.UTF8_BIN = 83;
  exports.BIG5_BIN = 84;
  exports.EUCKR_BIN = 85;
  exports.GB2312_BIN = 86;
  exports.GBK_BIN = 87;
  exports.SJIS_BIN = 88;
  exports.TIS620_BIN = 89;
  exports.UCS2_BIN = 90;
  exports.UJIS_BIN = 91;
  exports.GEOSTD8_GENERAL_CI = 92;
  exports.GEOSTD8_BIN = 93;
  exports.LATIN1_SPANISH_CI = 94;
  exports.CP932_JAPANESE_CI = 95;
  exports.CP932_BIN = 96;
  exports.EUCJPMS_JAPANESE_CI = 97;
  exports.EUCJPMS_BIN = 98;
  exports.CP1250_POLISH_CI = 99;
  exports.UTF16_UNICODE_CI = 101;
  exports.UTF16_ICELANDIC_CI = 102;
  exports.UTF16_LATVIAN_CI = 103;
  exports.UTF16_ROMANIAN_CI = 104;
  exports.UTF16_SLOVENIAN_CI = 105;
  exports.UTF16_POLISH_CI = 106;
  exports.UTF16_ESTONIAN_CI = 107;
  exports.UTF16_SPANISH_CI = 108;
  exports.UTF16_SWEDISH_CI = 109;
  exports.UTF16_TURKISH_CI = 110;
  exports.UTF16_CZECH_CI = 111;
  exports.UTF16_DANISH_CI = 112;
  exports.UTF16_LITHUANIAN_CI = 113;
  exports.UTF16_SLOVAK_CI = 114;
  exports.UTF16_SPANISH2_CI = 115;
  exports.UTF16_ROMAN_CI = 116;
  exports.UTF16_PERSIAN_CI = 117;
  exports.UTF16_ESPERANTO_CI = 118;
  exports.UTF16_HUNGARIAN_CI = 119;
  exports.UTF16_SINHALA_CI = 120;
  exports.UTF16_GERMAN2_CI = 121;
  exports.UTF16_CROATIAN_CI = 122;
  exports.UTF16_UNICODE_520_CI = 123;
  exports.UTF16_VIETNAMESE_CI = 124;
  exports.UCS2_UNICODE_CI = 128;
  exports.UCS2_ICELANDIC_CI = 129;
  exports.UCS2_LATVIAN_CI = 130;
  exports.UCS2_ROMANIAN_CI = 131;
  exports.UCS2_SLOVENIAN_CI = 132;
  exports.UCS2_POLISH_CI = 133;
  exports.UCS2_ESTONIAN_CI = 134;
  exports.UCS2_SPANISH_CI = 135;
  exports.UCS2_SWEDISH_CI = 136;
  exports.UCS2_TURKISH_CI = 137;
  exports.UCS2_CZECH_CI = 138;
  exports.UCS2_DANISH_CI = 139;
  exports.UCS2_LITHUANIAN_CI = 140;
  exports.UCS2_SLOVAK_CI = 141;
  exports.UCS2_SPANISH2_CI = 142;
  exports.UCS2_ROMAN_CI = 143;
  exports.UCS2_PERSIAN_CI = 144;
  exports.UCS2_ESPERANTO_CI = 145;
  exports.UCS2_HUNGARIAN_CI = 146;
  exports.UCS2_SINHALA_CI = 147;
  exports.UCS2_GERMAN2_CI = 148;
  exports.UCS2_CROATIAN_CI = 149;
  exports.UCS2_UNICODE_520_CI = 150;
  exports.UCS2_VIETNAMESE_CI = 151;
  exports.UCS2_GENERAL_MYSQL500_CI = 159;
  exports.UTF32_UNICODE_CI = 160;
  exports.UTF32_ICELANDIC_CI = 161;
  exports.UTF32_LATVIAN_CI = 162;
  exports.UTF32_ROMANIAN_CI = 163;
  exports.UTF32_SLOVENIAN_CI = 164;
  exports.UTF32_POLISH_CI = 165;
  exports.UTF32_ESTONIAN_CI = 166;
  exports.UTF32_SPANISH_CI = 167;
  exports.UTF32_SWEDISH_CI = 168;
  exports.UTF32_TURKISH_CI = 169;
  exports.UTF32_CZECH_CI = 170;
  exports.UTF32_DANISH_CI = 171;
  exports.UTF32_LITHUANIAN_CI = 172;
  exports.UTF32_SLOVAK_CI = 173;
  exports.UTF32_SPANISH2_CI = 174;
  exports.UTF32_ROMAN_CI = 175;
  exports.UTF32_PERSIAN_CI = 176;
  exports.UTF32_ESPERANTO_CI = 177;
  exports.UTF32_HUNGARIAN_CI = 178;
  exports.UTF32_SINHALA_CI = 179;
  exports.UTF32_GERMAN2_CI = 180;
  exports.UTF32_CROATIAN_CI = 181;
  exports.UTF32_UNICODE_520_CI = 182;
  exports.UTF32_VIETNAMESE_CI = 183;
  exports.UTF8_UNICODE_CI = 192;
  exports.UTF8_ICELANDIC_CI = 193;
  exports.UTF8_LATVIAN_CI = 194;
  exports.UTF8_ROMANIAN_CI = 195;
  exports.UTF8_SLOVENIAN_CI = 196;
  exports.UTF8_POLISH_CI = 197;
  exports.UTF8_ESTONIAN_CI = 198;
  exports.UTF8_SPANISH_CI = 199;
  exports.UTF8_SWEDISH_CI = 200;
  exports.UTF8_TURKISH_CI = 201;
  exports.UTF8_CZECH_CI = 202;
  exports.UTF8_DANISH_CI = 203;
  exports.UTF8_LITHUANIAN_CI = 204;
  exports.UTF8_SLOVAK_CI = 205;
  exports.UTF8_SPANISH2_CI = 206;
  exports.UTF8_ROMAN_CI = 207;
  exports.UTF8_PERSIAN_CI = 208;
  exports.UTF8_ESPERANTO_CI = 209;
  exports.UTF8_HUNGARIAN_CI = 210;
  exports.UTF8_SINHALA_CI = 211;
  exports.UTF8_GERMAN2_CI = 212;
  exports.UTF8_CROATIAN_CI = 213;
  exports.UTF8_UNICODE_520_CI = 214;
  exports.UTF8_VIETNAMESE_CI = 215;
  exports.UTF8_GENERAL_MYSQL500_CI = 223;
  exports.UTF8MB4_UNICODE_CI = 224;
  exports.UTF8MB4_ICELANDIC_CI = 225;
  exports.UTF8MB4_LATVIAN_CI = 226;
  exports.UTF8MB4_ROMANIAN_CI = 227;
  exports.UTF8MB4_SLOVENIAN_CI = 228;
  exports.UTF8MB4_POLISH_CI = 229;
  exports.UTF8MB4_ESTONIAN_CI = 230;
  exports.UTF8MB4_SPANISH_CI = 231;
  exports.UTF8MB4_SWEDISH_CI = 232;
  exports.UTF8MB4_TURKISH_CI = 233;
  exports.UTF8MB4_CZECH_CI = 234;
  exports.UTF8MB4_DANISH_CI = 235;
  exports.UTF8MB4_LITHUANIAN_CI = 236;
  exports.UTF8MB4_SLOVAK_CI = 237;
  exports.UTF8MB4_SPANISH2_CI = 238;
  exports.UTF8MB4_ROMAN_CI = 239;
  exports.UTF8MB4_PERSIAN_CI = 240;
  exports.UTF8MB4_ESPERANTO_CI = 241;
  exports.UTF8MB4_HUNGARIAN_CI = 242;
  exports.UTF8MB4_SINHALA_CI = 243;
  exports.UTF8MB4_GERMAN2_CI = 244;
  exports.UTF8MB4_CROATIAN_CI = 245;
  exports.UTF8MB4_UNICODE_520_CI = 246;
  exports.UTF8MB4_VIETNAMESE_CI = 247;
  exports.GB18030_CHINESE_CI = 248;
  exports.GB18030_BIN = 249;
  exports.GB18030_UNICODE_520_CI = 250;
  exports.UTF8_GENERAL50_CI = 253;
  exports.UTF8MB4_0900_AI_CI = 255;
  exports.UTF8MB4_DE_PB_0900_AI_CI = 256;
  exports.UTF8MB4_IS_0900_AI_CI = 257;
  exports.UTF8MB4_LV_0900_AI_CI = 258;
  exports.UTF8MB4_RO_0900_AI_CI = 259;
  exports.UTF8MB4_SL_0900_AI_CI = 260;
  exports.UTF8MB4_PL_0900_AI_CI = 261;
  exports.UTF8MB4_ET_0900_AI_CI = 262;
  exports.UTF8MB4_ES_0900_AI_CI = 263;
  exports.UTF8MB4_SV_0900_AI_CI = 264;
  exports.UTF8MB4_TR_0900_AI_CI = 265;
  exports.UTF8MB4_CS_0900_AI_CI = 266;
  exports.UTF8MB4_DA_0900_AI_CI = 267;
  exports.UTF8MB4_LT_0900_AI_CI = 268;
  exports.UTF8MB4_SK_0900_AI_CI = 269;
  exports.UTF8MB4_ES_TRAD_0900_AI_CI = 270;
  exports.UTF8MB4_LA_0900_AI_CI = 271;
  exports.UTF8MB4_EO_0900_AI_CI = 273;
  exports.UTF8MB4_HU_0900_AI_CI = 274;
  exports.UTF8MB4_HR_0900_AI_CI = 275;
  exports.UTF8MB4_VI_0900_AI_CI = 277;
  exports.UTF8MB4_0900_AS_CS = 278;
  exports.UTF8MB4_DE_PB_0900_AS_CS = 279;
  exports.UTF8MB4_IS_0900_AS_CS = 280;
  exports.UTF8MB4_LV_0900_AS_CS = 281;
  exports.UTF8MB4_RO_0900_AS_CS = 282;
  exports.UTF8MB4_SL_0900_AS_CS = 283;
  exports.UTF8MB4_PL_0900_AS_CS = 284;
  exports.UTF8MB4_ET_0900_AS_CS = 285;
  exports.UTF8MB4_ES_0900_AS_CS = 286;
  exports.UTF8MB4_SV_0900_AS_CS = 287;
  exports.UTF8MB4_TR_0900_AS_CS = 288;
  exports.UTF8MB4_CS_0900_AS_CS = 289;
  exports.UTF8MB4_DA_0900_AS_CS = 290;
  exports.UTF8MB4_LT_0900_AS_CS = 291;
  exports.UTF8MB4_SK_0900_AS_CS = 292;
  exports.UTF8MB4_ES_TRAD_0900_AS_CS = 293;
  exports.UTF8MB4_LA_0900_AS_CS = 294;
  exports.UTF8MB4_EO_0900_AS_CS = 296;
  exports.UTF8MB4_HU_0900_AS_CS = 297;
  exports.UTF8MB4_HR_0900_AS_CS = 298;
  exports.UTF8MB4_VI_0900_AS_CS = 300;
  exports.UTF8MB4_JA_0900_AS_CS = 303;
  exports.UTF8MB4_JA_0900_AS_CS_KS = 304;
  exports.UTF8MB4_0900_AS_CI = 305;
  exports.UTF8MB4_RU_0900_AI_CI = 306;
  exports.UTF8MB4_RU_0900_AS_CS = 307;
  exports.UTF8MB4_ZH_0900_AS_CS = 308;
  exports.UTF8MB4_0900_BIN = 309;
  exports.BIG5 = exports.BIG5_CHINESE_CI;
  exports.DEC8 = exports.DEC8_SWEDISH_CI;
  exports.CP850 = exports.CP850_GENERAL_CI;
  exports.HP8 = exports.HP8_ENGLISH_CI;
  exports.KOI8R = exports.KOI8R_GENERAL_CI;
  exports.LATIN1 = exports.LATIN1_SWEDISH_CI;
  exports.LATIN2 = exports.LATIN2_GENERAL_CI;
  exports.SWE7 = exports.SWE7_SWEDISH_CI;
  exports.ASCII = exports.ASCII_GENERAL_CI;
  exports.UJIS = exports.UJIS_JAPANESE_CI;
  exports.SJIS = exports.SJIS_JAPANESE_CI;
  exports.HEBREW = exports.HEBREW_GENERAL_CI;
  exports.TIS620 = exports.TIS620_THAI_CI;
  exports.EUCKR = exports.EUCKR_KOREAN_CI;
  exports.KOI8U = exports.KOI8U_GENERAL_CI;
  exports.GB2312 = exports.GB2312_CHINESE_CI;
  exports.GREEK = exports.GREEK_GENERAL_CI;
  exports.CP1250 = exports.CP1250_GENERAL_CI;
  exports.GBK = exports.GBK_CHINESE_CI;
  exports.LATIN5 = exports.LATIN5_TURKISH_CI;
  exports.ARMSCII8 = exports.ARMSCII8_GENERAL_CI;
  exports.UTF8 = exports.UTF8_GENERAL_CI;
  exports.UCS2 = exports.UCS2_GENERAL_CI;
  exports.CP866 = exports.CP866_GENERAL_CI;
  exports.KEYBCS2 = exports.KEYBCS2_GENERAL_CI;
  exports.MACCE = exports.MACCE_GENERAL_CI;
  exports.MACROMAN = exports.MACROMAN_GENERAL_CI;
  exports.CP852 = exports.CP852_GENERAL_CI;
  exports.LATIN7 = exports.LATIN7_GENERAL_CI;
  exports.UTF8MB4 = exports.UTF8MB4_GENERAL_CI;
  exports.CP1251 = exports.CP1251_GENERAL_CI;
  exports.UTF16 = exports.UTF16_GENERAL_CI;
  exports.UTF16LE = exports.UTF16LE_GENERAL_CI;
  exports.CP1256 = exports.CP1256_GENERAL_CI;
  exports.CP1257 = exports.CP1257_GENERAL_CI;
  exports.UTF32 = exports.UTF32_GENERAL_CI;
  exports.CP932 = exports.CP932_JAPANESE_CI;
  exports.EUCJPMS = exports.EUCJPMS_JAPANESE_CI;
  exports.GB18030 = exports.GB18030_CHINESE_CI;
  exports.GEOSTD8 = exports.GEOSTD8_GENERAL_CI;
});
var require_helpers = __commonJS2((exports) => {
  function srcEscape(str) {
    return JSON.stringify({
      [str]: 1
    }).slice(1, -3);
  }
  exports.srcEscape = srcEscape;
  var highlightFn;
  var cardinalRecommended = false;
  try {
    const REQUIRE_TERMINATOR = "";
    highlightFn = import.meta.require(`cardinal${REQUIRE_TERMINATOR}`).highlight;
  } catch (err22) {
    highlightFn = (text22) => {
      if (!cardinalRecommended) {
        console.log("For nicer debug output consider install cardinal@^2.0.0");
        cardinalRecommended = true;
      }
      return text22;
    };
  }
  function printDebugWithCode(msg, code) {
    console.log(`\n\n${msg}:\n`);
    console.log(`${highlightFn(code)}\n`);
  }
  exports.printDebugWithCode = printDebugWithCode;
  function typeMatch(type, list2, Types) {
    if (Array.isArray(list2)) {
      return list2.some((t) => type === Types[t]);
    }
    return !!list2;
  }
  exports.typeMatch = typeMatch;
  var privateObjectProps = new Set([
    "__defineGetter__",
    "__defineSetter__",
    "__lookupGetter__",
    "__lookupSetter__",
    "__proto__"
  ]);
  exports.privateObjectProps = privateObjectProps;
  var fieldEscape = (field) => {
    if (privateObjectProps.has(field)) {
      throw new Error(`The field name (${field}) can't be the same as an object's private property.`);
    }
    return srcEscape(field);
  };
  exports.fieldEscape = fieldEscape;
});
var require_is_property = __commonJS2((exports, module) => {
  function isProperty(str) {
    return /^[$A-Z\_a-z\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05d0-\u05ea\u05f0-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u08a0\u08a2-\u08ac\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097f\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c33\u0c35-\u0c39\u0c3d\u0c58\u0c59\u0c60\u0c61\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d05-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d60\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e87\u0e88\u0e8a\u0e8d\u0e94-\u0e97\u0e99-\u0e9f\u0ea1-\u0ea3\u0ea5\u0ea7\u0eaa\u0eab\u0ead-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f4\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f0\u1700-\u170c\u170e-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1877\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191c\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19c1-\u19c7\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4b\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1ce9-\u1cec\u1cee-\u1cf1\u1cf5\u1cf6\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2119-\u211d\u2124\u2126\u2128\u212a-\u212d\u212f-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2c2e\u2c30-\u2c5e\u2c60-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u2e2f\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309d-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312d\u3131-\u318e\u31a0-\u31ba\u31f0-\u31ff\u3400-\u4db5\u4e00-\u9fcc\ua000-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e\ua67f-\ua697\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua78e\ua790-\ua793\ua7a0-\ua7aa\ua7f8-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa80-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uabc0-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc][$A-Z\_a-z\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05d0-\u05ea\u05f0-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u08a0\u08a2-\u08ac\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097f\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c33\u0c35-\u0c39\u0c3d\u0c58\u0c59\u0c60\u0c61\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d05-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d60\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e87\u0e88\u0e8a\u0e8d\u0e94-\u0e97\u0e99-\u0e9f\u0ea1-\u0ea3\u0ea5\u0ea7\u0eaa\u0eab\u0ead-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f4\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f0\u1700-\u170c\u170e-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1877\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191c\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19c1-\u19c7\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4b\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1ce9-\u1cec\u1cee-\u1cf1\u1cf5\u1cf6\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2119-\u211d\u2124\u2126\u2128\u212a-\u212d\u212f-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2c2e\u2c30-\u2c5e\u2c60-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u2e2f\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309d-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312d\u3131-\u318e\u31a0-\u31ba\u31f0-\u31ff\u3400-\u4db5\u4e00-\u9fcc\ua000-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e\ua67f-\ua697\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua78e\ua790-\ua793\ua7a0-\ua7aa\ua7f8-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa80-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uabc0-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc0-9\u0300-\u036f\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u0669\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u06f0-\u06f9\u0711\u0730-\u074a\u07a6-\u07b0\u07c0-\u07c9\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u08e4-\u08fe\u0900-\u0903\u093a-\u093c\u093e-\u094f\u0951-\u0957\u0962\u0963\u0966-\u096f\u0981-\u0983\u09bc\u09be-\u09c4\u09c7\u09c8\u09cb-\u09cd\u09d7\u09e2\u09e3\u09e6-\u09ef\u0a01-\u0a03\u0a3c\u0a3e-\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a66-\u0a71\u0a75\u0a81-\u0a83\u0abc\u0abe-\u0ac5\u0ac7-\u0ac9\u0acb-\u0acd\u0ae2\u0ae3\u0ae6-\u0aef\u0b01-\u0b03\u0b3c\u0b3e-\u0b44\u0b47\u0b48\u0b4b-\u0b4d\u0b56\u0b57\u0b62\u0b63\u0b66-\u0b6f\u0b82\u0bbe-\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcd\u0bd7\u0be6-\u0bef\u0c01-\u0c03\u0c3e-\u0c44\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0c66-\u0c6f\u0c82\u0c83\u0cbc\u0cbe-\u0cc4\u0cc6-\u0cc8\u0cca-\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0ce6-\u0cef\u0d02\u0d03\u0d3e-\u0d44\u0d46-\u0d48\u0d4a-\u0d4d\u0d57\u0d62\u0d63\u0d66-\u0d6f\u0d82\u0d83\u0dca\u0dcf-\u0dd4\u0dd6\u0dd8-\u0ddf\u0df2\u0df3\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0e50-\u0e59\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0ed0-\u0ed9\u0f18\u0f19\u0f20-\u0f29\u0f35\u0f37\u0f39\u0f3e\u0f3f\u0f71-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102b-\u103e\u1040-\u1049\u1056-\u1059\u105e-\u1060\u1062-\u1064\u1067-\u106d\u1071-\u1074\u1082-\u108d\u108f-\u109d\u135d-\u135f\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17b4-\u17d3\u17dd\u17e0-\u17e9\u180b-\u180d\u1810-\u1819\u18a9\u1920-\u192b\u1930-\u193b\u1946-\u194f\u19b0-\u19c0\u19c8\u19c9\u19d0-\u19d9\u1a17-\u1a1b\u1a55-\u1a5e\u1a60-\u1a7c\u1a7f-\u1a89\u1a90-\u1a99\u1b00-\u1b04\u1b34-\u1b44\u1b50-\u1b59\u1b6b-\u1b73\u1b80-\u1b82\u1ba1-\u1bad\u1bb0-\u1bb9\u1be6-\u1bf3\u1c24-\u1c37\u1c40-\u1c49\u1c50-\u1c59\u1cd0-\u1cd2\u1cd4-\u1ce8\u1ced\u1cf2-\u1cf4\u1dc0-\u1de6\u1dfc-\u1dff\u200c\u200d\u203f\u2040\u2054\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua620-\ua629\ua66f\ua674-\ua67d\ua69f\ua6f0\ua6f1\ua802\ua806\ua80b\ua823-\ua827\ua880\ua881\ua8b4-\ua8c4\ua8d0-\ua8d9\ua8e0-\ua8f1\ua900-\ua909\ua926-\ua92d\ua947-\ua953\ua980-\ua983\ua9b3-\ua9c0\ua9d0-\ua9d9\uaa29-\uaa36\uaa43\uaa4c\uaa4d\uaa50-\uaa59\uaa7b\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uaaeb-\uaaef\uaaf5\uaaf6\uabe3-\uabea\uabec\uabed\uabf0-\uabf9\ufb1e\ufe00-\ufe0f\ufe20-\ufe26\ufe33\ufe34\ufe4d-\ufe4f\uff10-\uff19\uff3f]*$/.test(str);
  }
  module.exports = isProperty;
});
var require_generate_function = __commonJS2((exports, module) => {
  var util = import.meta.require("util");
  var isProperty = require_is_property();
  var INDENT_START = /[\{\[]/;
  var INDENT_END = /[\}\]]/;
  var RESERVED = [
    "do",
    "if",
    "in",
    "for",
    "let",
    "new",
    "try",
    "var",
    "case",
    "else",
    "enum",
    "eval",
    "null",
    "this",
    "true",
    "void",
    "with",
    "await",
    "break",
    "catch",
    "class",
    "const",
    "false",
    "super",
    "throw",
    "while",
    "yield",
    "delete",
    "export",
    "import",
    "public",
    "return",
    "static",
    "switch",
    "typeof",
    "default",
    "extends",
    "finally",
    "package",
    "private",
    "continue",
    "debugger",
    "function",
    "arguments",
    "interface",
    "protected",
    "implements",
    "instanceof",
    "NaN",
    "undefined"
  ];
  var RESERVED_MAP = {};
  for (i2 = 0;i2 < RESERVED.length; i2++) {
    RESERVED_MAP[RESERVED[i2]] = true;
  }
  var i2;
  var isVariable = function(name) {
    return isProperty(name) && !RESERVED_MAP.hasOwnProperty(name);
  };
  var formats = {
    s: function(s32) {
      return "" + s32;
    },
    d: function(d) {
      return "" + Number(d);
    },
    o: function(o) {
      return JSON.stringify(o);
    }
  };
  var genfun = function() {
    var lines = [];
    var indent = 0;
    var vars = {};
    var push3 = function(str) {
      var spaces = "";
      while (spaces.length < indent * 2)
        spaces += "  ";
      lines.push(spaces + str);
    };
    var pushLine = function(line2) {
      if (INDENT_END.test(line2.trim()[0]) && INDENT_START.test(line2[line2.length - 1])) {
        indent--;
        push3(line2);
        indent++;
        return;
      }
      if (INDENT_START.test(line2[line2.length - 1])) {
        push3(line2);
        indent++;
        return;
      }
      if (INDENT_END.test(line2.trim()[0])) {
        indent--;
        push3(line2);
        return;
      }
      push3(line2);
    };
    var line = function(fmt) {
      if (!fmt)
        return line;
      if (arguments.length === 1 && fmt.indexOf("\n") > -1) {
        var lines2 = fmt.trim().split("\n");
        for (var i22 = 0;i22 < lines2.length; i22++) {
          pushLine(lines2[i22].trim());
        }
      } else {
        pushLine(util.format.apply(util, arguments));
      }
      return line;
    };
    line.scope = {};
    line.formats = formats;
    line.sym = function(name) {
      if (!name || !isVariable(name))
        name = "tmp";
      if (!vars[name])
        vars[name] = 0;
      return name + (vars[name]++ || "");
    };
    line.property = function(obj, name) {
      if (arguments.length === 1) {
        name = obj;
        obj = "";
      }
      name = name + "";
      if (isProperty(name))
        return obj ? obj + "." + name : name;
      return obj ? obj + "[" + JSON.stringify(name) + "]" : JSON.stringify(name);
    };
    line.toString = function() {
      return lines.join("\n");
    };
    line.toFunction = function(scope) {
      if (!scope)
        scope = {};
      var src22 = "return (" + line.toString() + ")";
      Object.keys(line.scope).forEach(function(key) {
        if (!scope[key])
          scope[key] = line.scope[key];
      });
      var keys2 = Object.keys(scope).map(function(key) {
        return key;
      });
      var vals = keys2.map(function(key) {
        return scope[key];
      });
      return Function.apply(null, keys2.concat(src22)).apply(null, vals);
    };
    if (arguments.length)
      line.apply(null, arguments);
    return line;
  };
  genfun.formats = formats;
  module.exports = genfun;
});
var require_parser_cache = __commonJS2((exports, module) => {
  var { createLRU } = require_lib14();
  var parserCache = createLRU({
    max: 15000
  });
  function keyFromFields(type, fields22, options3, config5) {
    const res = [
      type,
      typeof options3.nestTables,
      options3.nestTables,
      Boolean(options3.rowsAsArray),
      Boolean(options3.supportBigNumbers || config5.supportBigNumbers),
      Boolean(options3.bigNumberStrings || config5.bigNumberStrings),
      typeof options3.typeCast,
      options3.timezone || config5.timezone,
      Boolean(options3.decimalNumbers),
      options3.dateStrings
    ];
    for (let i2 = 0;i2 < fields22.length; ++i2) {
      const field = fields22[i2];
      res.push([
        field.name,
        field.columnType,
        field.length,
        field.schema,
        field.table,
        field.flags,
        field.characterSet
      ]);
    }
    return JSON.stringify(res, null, 0);
  }
  function getParser(type, fields22, options3, config5, compiler) {
    const key = keyFromFields(type, fields22, options3, config5);
    let parser = parserCache.get(key);
    if (parser) {
      return parser;
    }
    parser = compiler(fields22, options3, config5);
    parserCache.set(key, parser);
    return parser;
  }
  function setMaxCache(max) {
    parserCache.resize(max);
  }
  function clearCache() {
    parserCache.clear();
  }
  module.exports = {
    getParser,
    setMaxCache,
    clearCache,
    _keyFromFields: keyFromFields
  };
});
var require_text_parser = __commonJS2((exports, module) => {
  var Types = require_types2();
  var Charsets = require_charsets();
  var helpers6 = require_helpers();
  var genFunc = require_generate_function();
  var parserCache = require_parser_cache();
  var typeNames = [];
  for (const t in Types) {
    typeNames[Types[t]] = t;
  }
  function readCodeFor(type, charset, encodingExpr, config5, options3) {
    const supportBigNumbers = Boolean(options3.supportBigNumbers || config5.supportBigNumbers);
    const bigNumberStrings = Boolean(options3.bigNumberStrings || config5.bigNumberStrings);
    const timezone = options3.timezone || config5.timezone;
    const dateStrings = options3.dateStrings || config5.dateStrings;
    switch (type) {
      case Types.TINY:
      case Types.SHORT:
      case Types.LONG:
      case Types.INT24:
      case Types.YEAR:
        return "packet.parseLengthCodedIntNoBigCheck()";
      case Types.LONGLONG:
        if (supportBigNumbers && bigNumberStrings) {
          return "packet.parseLengthCodedIntString()";
        }
        return `packet.parseLengthCodedInt(${supportBigNumbers})`;
      case Types.FLOAT:
      case Types.DOUBLE:
        return "packet.parseLengthCodedFloat()";
      case Types.NULL:
        return "packet.readLengthCodedNumber()";
      case Types.DECIMAL:
      case Types.NEWDECIMAL:
        if (config5.decimalNumbers) {
          return "packet.parseLengthCodedFloat()";
        }
        return 'packet.readLengthCodedString("ascii")';
      case Types.DATE:
        if (helpers6.typeMatch(type, dateStrings, Types)) {
          return 'packet.readLengthCodedString("ascii")';
        }
        return `packet.parseDate(${helpers6.srcEscape(timezone)})`;
      case Types.DATETIME:
      case Types.TIMESTAMP:
        if (helpers6.typeMatch(type, dateStrings, Types)) {
          return 'packet.readLengthCodedString("ascii")';
        }
        return `packet.parseDateTime(${helpers6.srcEscape(timezone)})`;
      case Types.TIME:
        return 'packet.readLengthCodedString("ascii")';
      case Types.GEOMETRY:
        return "packet.parseGeometryValue()";
      case Types.VECTOR:
        return "packet.parseVector()";
      case Types.JSON:
        return config5.jsonStrings ? 'packet.readLengthCodedString("utf8")' : 'JSON.parse(packet.readLengthCodedString("utf8"))';
      default:
        if (charset === Charsets.BINARY) {
          return "packet.readLengthCodedBuffer()";
        }
        return `packet.readLengthCodedString(${encodingExpr})`;
    }
  }
  function compile(fields22, options3, config5) {
    if (typeof config5.typeCast === "function" && typeof options3.typeCast !== "function") {
      options3.typeCast = config5.typeCast;
    }
    function wrap(field, _this) {
      return {
        type: typeNames[field.columnType],
        length: field.columnLength,
        db: field.schema,
        table: field.table,
        name: field.name,
        string: function(encoding = field.encoding) {
          if (field.columnType === Types.JSON && encoding === field.encoding) {
            console.warn(`typeCast: JSON column "${field.name}" is interpreted as BINARY by default, recommended to manually set utf8 encoding: \`field.string("utf8")\``);
          }
          return _this.packet.readLengthCodedString(encoding);
        },
        buffer: function() {
          return _this.packet.readLengthCodedBuffer();
        },
        geometry: function() {
          return _this.packet.parseGeometryValue();
        }
      };
    }
    const parserFn = genFunc();
    parserFn("(function () {")("return class TextRow {");
    parserFn("constructor(fields) {");
    if (typeof options3.typeCast === "function") {
      parserFn("const _this = this;");
      parserFn("for(let i=0; i<fields.length; ++i) {");
      parserFn("this[`wrap${i}`] = wrap(fields[i], _this);");
      parserFn("}");
    }
    parserFn("}");
    parserFn("next(packet, fields, options) {");
    parserFn("this.packet = packet;");
    if (options3.rowsAsArray) {
      parserFn(`const result = new Array(${fields22.length});`);
    } else {
      parserFn("const result = {};");
    }
    const resultTables = {};
    let resultTablesArray = [];
    if (options3.nestTables === true) {
      for (let i2 = 0;i2 < fields22.length; i2++) {
        resultTables[fields22[i2].table] = 1;
      }
      resultTablesArray = Object.keys(resultTables);
      for (let i2 = 0;i2 < resultTablesArray.length; i2++) {
        parserFn(`result[${helpers6.fieldEscape(resultTablesArray[i2])}] = {};`);
      }
    }
    let lvalue = "";
    let fieldName = "";
    let tableName = "";
    for (let i2 = 0;i2 < fields22.length; i2++) {
      fieldName = helpers6.fieldEscape(fields22[i2].name);
      if (typeof options3.nestTables === "string") {
        lvalue = `result[${helpers6.fieldEscape(fields22[i2].table + options3.nestTables + fields22[i2].name)}]`;
      } else if (options3.nestTables === true) {
        tableName = helpers6.fieldEscape(fields22[i2].table);
        parserFn(`if (!result[${tableName}]) result[${tableName}] = {};`);
        lvalue = `result[${tableName}][${fieldName}]`;
      } else if (options3.rowsAsArray) {
        lvalue = `result[${i2.toString(10)}]`;
      } else {
        lvalue = `result[${fieldName}]`;
      }
      if (options3.typeCast === false) {
        parserFn(`${lvalue} = packet.readLengthCodedBuffer();`);
      } else {
        const encodingExpr = `fields[${i2}].encoding`;
        const readCode = readCodeFor(fields22[i2].columnType, fields22[i2].characterSet, encodingExpr, config5, options3);
        if (typeof options3.typeCast === "function") {
          parserFn(`${lvalue} = options.typeCast(this.wrap${i2}, function() { return ${readCode} });`);
        } else {
          parserFn(`${lvalue} = ${readCode};`);
        }
      }
    }
    parserFn("return result;");
    parserFn("}");
    parserFn("};")("})()");
    if (config5.debug) {
      helpers6.printDebugWithCode("Compiled text protocol row parser", parserFn.toString());
    }
    if (typeof options3.typeCast === "function") {
      return parserFn.toFunction({ wrap });
    }
    return parserFn.toFunction();
  }
  function getTextParser(fields22, options3, config5) {
    return parserCache.getParser("text", fields22, options3, config5, compile);
  }
  module.exports = getTextParser;
});
var require_query2 = __commonJS2((exports, module) => {
  var process102 = import.meta.require("process");
  var Timers = import.meta.require("timers");
  var Readable10 = import.meta.require("stream").Readable;
  var Command2 = require_command();
  var Packets = require_packets();
  var getTextParser = require_text_parser();
  var ServerStatus = require_server_status();
  var EmptyPacket = new Packets.Packet(0, Buffer.allocUnsafe(4), 0, 4);

  class Query extends Command2 {
    constructor(options3, callback) {
      super();
      this.sql = options3.sql;
      this.values = options3.values;
      this._queryOptions = options3;
      this.namedPlaceholders = options3.namedPlaceholders || false;
      this.onResult = callback;
      this.timeout = options3.timeout;
      this.queryTimeout = null;
      this._fieldCount = 0;
      this._rowParser = null;
      this._fields = [];
      this._rows = [];
      this._receivedFieldsCount = 0;
      this._resultIndex = 0;
      this._localStream = null;
      this._unpipeStream = function() {
      };
      this._streamFactory = options3.infileStreamFactory;
      this._connection = null;
    }
    then() {
      const err22 = "You have tried to call .then(), .catch(), or invoked await on the result of query that is not a promise, which is a programming error. Try calling con.promise().query(), or require('mysql2/promise') instead of 'mysql2' for a promise-compatible version of the query interface. To learn how to use async/await or Promises check out documentation at https://sidorares.github.io/node-mysql2/docs#using-promise-wrapper, or the mysql2 documentation at https://sidorares.github.io/node-mysql2/docs/documentation/promise-wrapper";
      console.log(err22);
      throw new Error(err22);
    }
    start(_packet, connection) {
      if (connection.config.debug) {
        console.log("        Sending query command: %s", this.sql);
      }
      this._connection = connection;
      this.options = Object.assign({}, connection.config, this._queryOptions);
      this._setTimeout();
      const cmdPacket = new Packets.Query(this.sql, connection.config.charsetNumber);
      connection.writePacket(cmdPacket.toPacket(1));
      return Query.prototype.resultsetHeader;
    }
    done() {
      this._unpipeStream();
      if (this.timeout && !this.queryTimeout) {
        return null;
      }
      if (this.queryTimeout) {
        Timers.clearTimeout(this.queryTimeout);
        this.queryTimeout = null;
      }
      if (this.onResult) {
        let rows, fields22;
        if (this._resultIndex === 0) {
          rows = this._rows[0];
          fields22 = this._fields[0];
        } else {
          rows = this._rows;
          fields22 = this._fields;
        }
        if (fields22) {
          process102.nextTick(() => {
            this.onResult(null, rows, fields22);
          });
        } else {
          process102.nextTick(() => {
            this.onResult(null, rows);
          });
        }
      }
      return null;
    }
    doneInsert(rs) {
      if (this._localStreamError) {
        if (this.onResult) {
          this.onResult(this._localStreamError, rs);
        } else {
          this.emit("error", this._localStreamError);
        }
        return null;
      }
      this._rows.push(rs);
      this._fields.push(undefined);
      this.emit("fields", undefined);
      this.emit("result", rs);
      if (rs.serverStatus & ServerStatus.SERVER_MORE_RESULTS_EXISTS) {
        this._resultIndex++;
        return this.resultsetHeader;
      }
      return this.done();
    }
    resultsetHeader(packet, connection) {
      const rs = new Packets.ResultSetHeader(packet, connection);
      this._fieldCount = rs.fieldCount;
      if (connection.config.debug) {
        console.log(`        Resultset header received, expecting ${rs.fieldCount} column definition packets`);
      }
      if (this._fieldCount === 0) {
        return this.doneInsert(rs);
      }
      if (this._fieldCount === null) {
        return this._streamLocalInfile(connection, rs.infileName);
      }
      this._receivedFieldsCount = 0;
      this._rows.push([]);
      this._fields.push([]);
      return this.readField;
    }
    _streamLocalInfile(connection, path42) {
      if (this._streamFactory) {
        this._localStream = this._streamFactory(path42);
      } else {
        this._localStreamError = new Error(`As a result of LOCAL INFILE command server wants to read ${path42} file, but as of v2.0 you must provide streamFactory option returning ReadStream.`);
        connection.writePacket(EmptyPacket);
        return this.infileOk;
      }
      const onConnectionError = () => {
        this._unpipeStream();
      };
      const onDrain = () => {
        this._localStream.resume();
      };
      const onPause = () => {
        this._localStream.pause();
      };
      const onData = function(data2) {
        const dataWithHeader = Buffer.allocUnsafe(data2.length + 4);
        data2.copy(dataWithHeader, 4);
        connection.writePacket(new Packets.Packet(0, dataWithHeader, 0, dataWithHeader.length));
      };
      const onEnd = () => {
        connection.removeListener("error", onConnectionError);
        connection.writePacket(EmptyPacket);
      };
      const onError2 = (err22) => {
        this._localStreamError = err22;
        connection.removeListener("error", onConnectionError);
        connection.writePacket(EmptyPacket);
      };
      this._unpipeStream = () => {
        connection.stream.removeListener("pause", onPause);
        connection.stream.removeListener("drain", onDrain);
        this._localStream.removeListener("data", onData);
        this._localStream.removeListener("end", onEnd);
        this._localStream.removeListener("error", onError2);
      };
      connection.stream.on("pause", onPause);
      connection.stream.on("drain", onDrain);
      this._localStream.on("data", onData);
      this._localStream.on("end", onEnd);
      this._localStream.on("error", onError2);
      connection.once("error", onConnectionError);
      return this.infileOk;
    }
    readField(packet, connection) {
      this._receivedFieldsCount++;
      if (this._fields[this._resultIndex].length !== this._fieldCount) {
        const field = new Packets.ColumnDefinition(packet, connection.clientEncoding);
        this._fields[this._resultIndex].push(field);
        if (connection.config.debug) {
          console.log("        Column definition:");
          console.log(`          name: ${field.name}`);
          console.log(`          type: ${field.columnType}`);
          console.log(`         flags: ${field.flags}`);
        }
      }
      if (this._receivedFieldsCount === this._fieldCount) {
        const fields22 = this._fields[this._resultIndex];
        this.emit("fields", fields22);
        this._rowParser = new (getTextParser(fields22, this.options, connection.config))(fields22);
        return Query.prototype.fieldsEOF;
      }
      return Query.prototype.readField;
    }
    fieldsEOF(packet, connection) {
      if (!packet.isEOF()) {
        return connection.protocolError("Expected EOF packet");
      }
      return this.row;
    }
    row(packet, _connection) {
      if (packet.isEOF()) {
        const status = packet.eofStatusFlags();
        const moreResults = status & ServerStatus.SERVER_MORE_RESULTS_EXISTS;
        if (moreResults) {
          this._resultIndex++;
          return Query.prototype.resultsetHeader;
        }
        return this.done();
      }
      let row;
      try {
        row = this._rowParser.next(packet, this._fields[this._resultIndex], this.options);
      } catch (err22) {
        this._localStreamError = err22;
        return this.doneInsert(null);
      }
      if (this.onResult) {
        this._rows[this._resultIndex].push(row);
      } else {
        this.emit("result", row, this._resultIndex);
      }
      return Query.prototype.row;
    }
    infileOk(packet, connection) {
      const rs = new Packets.ResultSetHeader(packet, connection);
      return this.doneInsert(rs);
    }
    stream(options3) {
      options3 = options3 || {};
      options3.objectMode = true;
      const stream2 = new Readable10(options3);
      stream2._read = () => {
        this._connection && this._connection.resume();
      };
      this.on("result", (row, resultSetIndex) => {
        if (!stream2.push(row)) {
          this._connection.pause();
        }
        stream2.emit("result", row, resultSetIndex);
      });
      this.on("error", (err22) => {
        stream2.emit("error", err22);
      });
      this.on("end", () => {
        stream2.push(null);
      });
      this.on("fields", (fields22) => {
        stream2.emit("fields", fields22);
      });
      stream2.on("end", () => {
        stream2.emit("close");
      });
      return stream2;
    }
    _setTimeout() {
      if (this.timeout) {
        const timeoutHandler = this._handleTimeoutError.bind(this);
        this.queryTimeout = Timers.setTimeout(timeoutHandler, this.timeout);
      }
    }
    _handleTimeoutError() {
      if (this.queryTimeout) {
        Timers.clearTimeout(this.queryTimeout);
        this.queryTimeout = null;
      }
      const err22 = new Error("Query inactivity timeout");
      err22.errorno = "PROTOCOL_SEQUENCE_TIMEOUT";
      err22.code = "PROTOCOL_SEQUENCE_TIMEOUT";
      err22.syscall = "query";
      if (this.onResult) {
        this.onResult(err22);
      } else {
        this.emit("error", err22);
      }
    }
  }
  Query.prototype.catch = Query.prototype.then;
  module.exports = Query;
});
var require_close_statement2 = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var Packets = require_packets();

  class CloseStatement extends Command2 {
    constructor(id) {
      super();
      this.id = id;
    }
    start(packet, connection) {
      connection.writePacket(new Packets.CloseStatement(this.id).toPacket(1));
      return null;
    }
  }
  module.exports = CloseStatement;
});
var require_binary_parser = __commonJS2((exports, module) => {
  var FieldFlags = require_field_flags();
  var Charsets = require_charsets();
  var Types = require_types2();
  var helpers6 = require_helpers();
  var genFunc = require_generate_function();
  var parserCache = require_parser_cache();
  var typeNames = [];
  for (const t in Types) {
    typeNames[Types[t]] = t;
  }
  function readCodeFor(field, config5, options3, fieldNum) {
    const supportBigNumbers = Boolean(options3.supportBigNumbers || config5.supportBigNumbers);
    const bigNumberStrings = Boolean(options3.bigNumberStrings || config5.bigNumberStrings);
    const timezone = options3.timezone || config5.timezone;
    const dateStrings = options3.dateStrings || config5.dateStrings;
    const unsigned = field.flags & FieldFlags.UNSIGNED;
    switch (field.columnType) {
      case Types.TINY:
        return unsigned ? "packet.readInt8();" : "packet.readSInt8();";
      case Types.SHORT:
        return unsigned ? "packet.readInt16();" : "packet.readSInt16();";
      case Types.LONG:
      case Types.INT24:
        return unsigned ? "packet.readInt32();" : "packet.readSInt32();";
      case Types.YEAR:
        return "packet.readInt16()";
      case Types.FLOAT:
        return "packet.readFloat();";
      case Types.DOUBLE:
        return "packet.readDouble();";
      case Types.NULL:
        return "null;";
      case Types.DATE:
      case Types.DATETIME:
      case Types.TIMESTAMP:
      case Types.NEWDATE:
        if (helpers6.typeMatch(field.columnType, dateStrings, Types)) {
          return `packet.readDateTimeString(${parseInt(field.decimals, 10)});`;
        }
        return `packet.readDateTime(${helpers6.srcEscape(timezone)});`;
      case Types.TIME:
        return "packet.readTimeString()";
      case Types.DECIMAL:
      case Types.NEWDECIMAL:
        if (config5.decimalNumbers) {
          return "packet.parseLengthCodedFloat();";
        }
        return 'packet.readLengthCodedString("ascii");';
      case Types.GEOMETRY:
        return "packet.parseGeometryValue();";
      case Types.VECTOR:
        return "packet.parseVector()";
      case Types.JSON:
        return config5.jsonStrings ? 'packet.readLengthCodedString("utf8")' : 'JSON.parse(packet.readLengthCodedString("utf8"));';
      case Types.LONGLONG:
        if (!supportBigNumbers) {
          return unsigned ? "packet.readInt64JSNumber();" : "packet.readSInt64JSNumber();";
        }
        if (bigNumberStrings) {
          return unsigned ? "packet.readInt64String();" : "packet.readSInt64String();";
        }
        return unsigned ? "packet.readInt64();" : "packet.readSInt64();";
      default:
        if (field.characterSet === Charsets.BINARY) {
          return "packet.readLengthCodedBuffer();";
        }
        return `packet.readLengthCodedString(fields[${fieldNum}].encoding)`;
    }
  }
  function compile(fields22, options3, config5) {
    const parserFn = genFunc();
    const nullBitmapLength = Math.floor((fields22.length + 7 + 2) / 8);
    function wrap(field, packet) {
      return {
        type: typeNames[field.columnType],
        length: field.columnLength,
        db: field.schema,
        table: field.table,
        name: field.name,
        string: function(encoding = field.encoding) {
          if (field.columnType === Types.JSON && encoding === field.encoding) {
            console.warn(`typeCast: JSON column "${field.name}" is interpreted as BINARY by default, recommended to manually set utf8 encoding: \`field.string("utf8")\``);
          }
          if ([Types.DATETIME, Types.NEWDATE, Types.TIMESTAMP, Types.DATE].includes(field.columnType)) {
            return packet.readDateTimeString(parseInt(field.decimals, 10));
          }
          if (field.columnType === Types.TINY) {
            const unsigned = field.flags & FieldFlags.UNSIGNED;
            return String(unsigned ? packet.readInt8() : packet.readSInt8());
          }
          if (field.columnType === Types.TIME) {
            return packet.readTimeString();
          }
          return packet.readLengthCodedString(encoding);
        },
        buffer: function() {
          return packet.readLengthCodedBuffer();
        },
        geometry: function() {
          return packet.parseGeometryValue();
        }
      };
    }
    parserFn("(function(){");
    parserFn("return class BinaryRow {");
    parserFn("constructor() {");
    parserFn("}");
    parserFn("next(packet, fields, options) {");
    if (options3.rowsAsArray) {
      parserFn(`const result = new Array(${fields22.length});`);
    } else {
      parserFn("const result = {};");
    }
    if (typeof config5.typeCast === "function" && typeof options3.typeCast !== "function") {
      options3.typeCast = config5.typeCast;
    }
    parserFn("packet.readInt8();");
    for (let i2 = 0;i2 < nullBitmapLength; ++i2) {
      parserFn(`const nullBitmaskByte${i2} = packet.readInt8();`);
    }
    let lvalue = "";
    let currentFieldNullBit = 4;
    let nullByteIndex = 0;
    let fieldName = "";
    let tableName = "";
    for (let i2 = 0;i2 < fields22.length; i2++) {
      fieldName = helpers6.fieldEscape(fields22[i2].name);
      if (typeof options3.nestTables === "string") {
        lvalue = `result[${helpers6.fieldEscape(fields22[i2].table + options3.nestTables + fields22[i2].name)}]`;
      } else if (options3.nestTables === true) {
        tableName = helpers6.fieldEscape(fields22[i2].table);
        parserFn(`if (!result[${tableName}]) result[${tableName}] = {};`);
        lvalue = `result[${tableName}][${fieldName}]`;
      } else if (options3.rowsAsArray) {
        lvalue = `result[${i2.toString(10)}]`;
      } else {
        lvalue = `result[${fieldName}]`;
      }
      parserFn(`if (nullBitmaskByte${nullByteIndex} & ${currentFieldNullBit}) `);
      parserFn(`${lvalue} = null;`);
      parserFn("else {");
      if (options3.typeCast === false) {
        parserFn(`${lvalue} = packet.readLengthCodedBuffer();`);
      } else {
        const fieldWrapperVar = `fieldWrapper${i2}`;
        parserFn(`const ${fieldWrapperVar} = wrap(fields[${i2}], packet);`);
        const readCode = readCodeFor(fields22[i2], config5, options3, i2);
        if (typeof options3.typeCast === "function") {
          parserFn(`${lvalue} = options.typeCast(${fieldWrapperVar}, function() { return ${readCode} });`);
        } else {
          parserFn(`${lvalue} = ${readCode};`);
        }
      }
      parserFn("}");
      currentFieldNullBit *= 2;
      if (currentFieldNullBit === 256) {
        currentFieldNullBit = 1;
        nullByteIndex++;
      }
    }
    parserFn("return result;");
    parserFn("}");
    parserFn("};")("})()");
    if (config5.debug) {
      helpers6.printDebugWithCode("Compiled binary protocol row parser", parserFn.toString());
    }
    return parserFn.toFunction({ wrap });
  }
  function getBinaryParser(fields22, options3, config5) {
    return parserCache.getParser("binary", fields22, options3, config5, compile);
  }
  module.exports = getBinaryParser;
});
var require_execute2 = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var Query = require_query2();
  var Packets = require_packets();
  var getBinaryParser = require_binary_parser();

  class Execute extends Command2 {
    constructor(options3, callback) {
      super();
      this.statement = options3.statement;
      this.sql = options3.sql;
      this.values = options3.values;
      this.onResult = callback;
      this.parameters = options3.values;
      this.insertId = 0;
      this.timeout = options3.timeout;
      this.queryTimeout = null;
      this._rows = [];
      this._fields = [];
      this._result = [];
      this._fieldCount = 0;
      this._rowParser = null;
      this._executeOptions = options3;
      this._resultIndex = 0;
      this._localStream = null;
      this._unpipeStream = function() {
      };
      this._streamFactory = options3.infileStreamFactory;
      this._connection = null;
    }
    buildParserFromFields(fields22, connection) {
      return getBinaryParser(fields22, this.options, connection.config);
    }
    start(packet, connection) {
      this._connection = connection;
      this.options = Object.assign({}, connection.config, this._executeOptions);
      this._setTimeout();
      const executePacket = new Packets.Execute(this.statement.id, this.parameters, connection.config.charsetNumber, connection.config.timezone);
      try {
        connection.writePacket(executePacket.toPacket(1));
      } catch (error) {
        this.onResult(error);
      }
      return Execute.prototype.resultsetHeader;
    }
    readField(packet, connection) {
      let fields22;
      const field = new Packets.ColumnDefinition(packet, connection.clientEncoding);
      this._receivedFieldsCount++;
      this._fields[this._resultIndex].push(field);
      if (this._receivedFieldsCount === this._fieldCount) {
        fields22 = this._fields[this._resultIndex];
        this.emit("fields", fields22, this._resultIndex);
        return Execute.prototype.fieldsEOF;
      }
      return Execute.prototype.readField;
    }
    fieldsEOF(packet, connection) {
      if (!packet.isEOF()) {
        return connection.protocolError("Expected EOF packet");
      }
      this._rowParser = new (this.buildParserFromFields(this._fields[this._resultIndex], connection));
      return Execute.prototype.row;
    }
  }
  Execute.prototype.done = Query.prototype.done;
  Execute.prototype.doneInsert = Query.prototype.doneInsert;
  Execute.prototype.resultsetHeader = Query.prototype.resultsetHeader;
  Execute.prototype._findOrCreateReadStream = Query.prototype._findOrCreateReadStream;
  Execute.prototype._streamLocalInfile = Query.prototype._streamLocalInfile;
  Execute.prototype._setTimeout = Query.prototype._setTimeout;
  Execute.prototype._handleTimeoutError = Query.prototype._handleTimeoutError;
  Execute.prototype.row = Query.prototype.row;
  Execute.prototype.stream = Query.prototype.stream;
  module.exports = Execute;
});
var require_prepare = __commonJS2((exports, module) => {
  var Packets = require_packets();
  var Command2 = require_command();
  var CloseStatement = require_close_statement2();
  var Execute = require_execute2();

  class PreparedStatementInfo {
    constructor(query, id, columns, parameters, connection) {
      this.query = query;
      this.id = id;
      this.columns = columns;
      this.parameters = parameters;
      this.rowParser = null;
      this._connection = connection;
    }
    close() {
      return this._connection.addCommand(new CloseStatement(this.id));
    }
    execute(parameters, callback) {
      if (typeof parameters === "function") {
        callback = parameters;
        parameters = [];
      }
      return this._connection.addCommand(new Execute({ statement: this, values: parameters }, callback));
    }
  }

  class Prepare extends Command2 {
    constructor(options3, callback) {
      super();
      this.query = options3.sql;
      this.onResult = callback;
      this.id = 0;
      this.fieldCount = 0;
      this.parameterCount = 0;
      this.fields = [];
      this.parameterDefinitions = [];
      this.options = options3;
    }
    start(packet, connection) {
      const Connection = connection.constructor;
      this.key = Connection.statementKey(this.options);
      const statement = connection._statements.get(this.key);
      if (statement) {
        if (this.onResult) {
          this.onResult(null, statement);
        }
        return null;
      }
      const cmdPacket = new Packets.PrepareStatement(this.query, connection.config.charsetNumber, this.options.values);
      connection.writePacket(cmdPacket.toPacket(1));
      return Prepare.prototype.prepareHeader;
    }
    prepareHeader(packet, connection) {
      const header = new Packets.PreparedStatementHeader(packet);
      this.id = header.id;
      this.fieldCount = header.fieldCount;
      this.parameterCount = header.parameterCount;
      if (this.parameterCount > 0) {
        return Prepare.prototype.readParameter;
      }
      if (this.fieldCount > 0) {
        return Prepare.prototype.readField;
      }
      return this.prepareDone(connection);
    }
    readParameter(packet, connection) {
      if (packet.isEOF()) {
        if (this.fieldCount > 0) {
          return Prepare.prototype.readField;
        }
        return this.prepareDone(connection);
      }
      const def = new Packets.ColumnDefinition(packet, connection.clientEncoding);
      this.parameterDefinitions.push(def);
      if (this.parameterDefinitions.length === this.parameterCount) {
        return Prepare.prototype.parametersEOF;
      }
      return this.readParameter;
    }
    readField(packet, connection) {
      if (packet.isEOF()) {
        return this.prepareDone(connection);
      }
      const def = new Packets.ColumnDefinition(packet, connection.clientEncoding);
      this.fields.push(def);
      if (this.fields.length === this.fieldCount) {
        return Prepare.prototype.fieldsEOF;
      }
      return Prepare.prototype.readField;
    }
    parametersEOF(packet, connection) {
      if (!packet.isEOF()) {
        return connection.protocolError("Expected EOF packet after parameters");
      }
      if (this.fieldCount > 0) {
        return Prepare.prototype.readField;
      }
      return this.prepareDone(connection);
    }
    fieldsEOF(packet, connection) {
      if (!packet.isEOF()) {
        return connection.protocolError("Expected EOF packet after fields");
      }
      return this.prepareDone(connection);
    }
    prepareDone(connection) {
      const statement = new PreparedStatementInfo(this.query, this.id, this.fields, this.parameterDefinitions, connection);
      connection._statements.set(this.key, statement);
      if (this.onResult) {
        this.onResult(null, statement);
      }
      return null;
    }
  }
  module.exports = Prepare;
});
var require_ping = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var CommandCode = require_commands();
  var Packet = require_packet();

  class Ping extends Command2 {
    constructor(callback) {
      super();
      this.onResult = callback;
    }
    start(packet, connection) {
      const ping = new Packet(0, Buffer.from([1, 0, 0, 0, CommandCode.PING]), 0, 5);
      connection.writePacket(ping);
      return Ping.prototype.pingResponse;
    }
    pingResponse() {
      if (this.onResult) {
        process.nextTick(this.onResult.bind(this));
      }
      return null;
    }
  }
  module.exports = Ping;
});
var require_register_slave2 = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var Packets = require_packets();

  class RegisterSlave extends Command2 {
    constructor(opts, callback) {
      super();
      this.onResult = callback;
      this.opts = opts;
    }
    start(packet, connection) {
      const newPacket = new Packets.RegisterSlave(this.opts);
      connection.writePacket(newPacket.toPacket(1));
      return RegisterSlave.prototype.registerResponse;
    }
    registerResponse() {
      if (this.onResult) {
        process.nextTick(this.onResult.bind(this));
      }
      return null;
    }
  }
  module.exports = RegisterSlave;
});
var require_binlog_query_statusvars = __commonJS2((exports, module) => {
  var keys2 = {
    FLAGS2: 0,
    SQL_MODE: 1,
    CATALOG: 2,
    AUTO_INCREMENT: 3,
    CHARSET: 4,
    TIME_ZONE: 5,
    CATALOG_NZ: 6,
    LC_TIME_NAMES: 7,
    CHARSET_DATABASE: 8,
    TABLE_MAP_FOR_UPDATE: 9,
    MASTER_DATA_WRITTEN: 10,
    INVOKERS: 11,
    UPDATED_DB_NAMES: 12,
    MICROSECONDS: 3
  };
  module.exports = function parseStatusVars(buffer) {
    const result2 = {};
    let offset2 = 0;
    let key, length, prevOffset;
    while (offset2 < buffer.length) {
      key = buffer[offset2++];
      switch (key) {
        case keys2.FLAGS2:
          result2.flags = buffer.readUInt32LE(offset2);
          offset2 += 4;
          break;
        case keys2.SQL_MODE:
          result2.sqlMode = buffer.readUInt32LE(offset2);
          offset2 += 8;
          break;
        case keys2.CATALOG:
          length = buffer[offset2++];
          result2.catalog = buffer.toString("utf8", offset2, offset2 + length);
          offset2 += length + 1;
          break;
        case keys2.CHARSET:
          result2.clientCharset = buffer.readUInt16LE(offset2);
          result2.connectionCollation = buffer.readUInt16LE(offset2 + 2);
          result2.serverCharset = buffer.readUInt16LE(offset2 + 4);
          offset2 += 6;
          break;
        case keys2.TIME_ZONE:
          length = buffer[offset2++];
          result2.timeZone = buffer.toString("utf8", offset2, offset2 + length);
          offset2 += length;
          break;
        case keys2.CATALOG_NZ:
          length = buffer[offset2++];
          result2.catalogNz = buffer.toString("utf8", offset2, offset2 + length);
          offset2 += length;
          break;
        case keys2.LC_TIME_NAMES:
          result2.lcTimeNames = buffer.readUInt16LE(offset2);
          offset2 += 2;
          break;
        case keys2.CHARSET_DATABASE:
          result2.schemaCharset = buffer.readUInt16LE(offset2);
          offset2 += 2;
          break;
        case keys2.TABLE_MAP_FOR_UPDATE:
          result2.mapForUpdate1 = buffer.readUInt32LE(offset2);
          result2.mapForUpdate2 = buffer.readUInt32LE(offset2 + 4);
          offset2 += 8;
          break;
        case keys2.MASTER_DATA_WRITTEN:
          result2.masterDataWritten = buffer.readUInt32LE(offset2);
          offset2 += 4;
          break;
        case keys2.INVOKERS:
          length = buffer[offset2++];
          result2.invokerUsername = buffer.toString("utf8", offset2, offset2 + length);
          offset2 += length;
          length = buffer[offset2++];
          result2.invokerHostname = buffer.toString("utf8", offset2, offset2 + length);
          offset2 += length;
          break;
        case keys2.UPDATED_DB_NAMES:
          length = buffer[offset2++];
          result2.updatedDBs = [];
          for (;length; --length) {
            prevOffset = offset2;
            while (buffer[offset2++] && offset2 < buffer.length) {
            }
            result2.updatedDBs.push(buffer.toString("utf8", prevOffset, offset2 - 1));
          }
          break;
        case keys2.MICROSECONDS:
          result2.microseconds = buffer.readInt16LE(offset2) + (buffer[offset2 + 2] << 16);
          offset2 += 3;
      }
    }
    return result2;
  };
});
var require_binlog_dump2 = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var Packets = require_packets();
  var eventParsers = [];

  class BinlogEventHeader {
    constructor(packet) {
      this.timestamp = packet.readInt32();
      this.eventType = packet.readInt8();
      this.serverId = packet.readInt32();
      this.eventSize = packet.readInt32();
      this.logPos = packet.readInt32();
      this.flags = packet.readInt16();
    }
  }

  class BinlogDump extends Command2 {
    constructor(opts) {
      super();
      this.opts = opts;
    }
    start(packet, connection) {
      const newPacket = new Packets.BinlogDump(this.opts);
      connection.writePacket(newPacket.toPacket(1));
      return BinlogDump.prototype.binlogData;
    }
    binlogData(packet) {
      if (packet.isEOF()) {
        this.emit("eof");
        return null;
      }
      packet.readInt8();
      const header = new BinlogEventHeader(packet);
      const EventParser = eventParsers[header.eventType];
      let event;
      if (EventParser) {
        event = new EventParser(packet);
      } else {
        event = {
          name: "UNKNOWN"
        };
      }
      event.header = header;
      this.emit("event", event);
      return BinlogDump.prototype.binlogData;
    }
  }

  class RotateEvent {
    constructor(packet) {
      this.pposition = packet.readInt32();
      packet.readInt32();
      this.nextBinlog = packet.readString();
      this.name = "RotateEvent";
    }
  }

  class FormatDescriptionEvent {
    constructor(packet) {
      this.binlogVersion = packet.readInt16();
      this.serverVersion = packet.readString(50).replace(/\u0000.*/, "");
      this.createTimestamp = packet.readInt32();
      this.eventHeaderLength = packet.readInt8();
      this.eventsLength = packet.readBuffer();
      this.name = "FormatDescriptionEvent";
    }
  }

  class QueryEvent {
    constructor(packet) {
      const parseStatusVars = require_binlog_query_statusvars();
      this.slaveProxyId = packet.readInt32();
      this.executionTime = packet.readInt32();
      const schemaLength = packet.readInt8();
      this.errorCode = packet.readInt16();
      const statusVarsLength = packet.readInt16();
      const statusVars = packet.readBuffer(statusVarsLength);
      this.schema = packet.readString(schemaLength);
      packet.readInt8();
      this.statusVars = parseStatusVars(statusVars);
      this.query = packet.readString();
      this.name = "QueryEvent";
    }
  }

  class XidEvent {
    constructor(packet) {
      this.binlogVersion = packet.readInt16();
      this.xid = packet.readInt64();
      this.name = "XidEvent";
    }
  }
  eventParsers[2] = QueryEvent;
  eventParsers[4] = RotateEvent;
  eventParsers[15] = FormatDescriptionEvent;
  eventParsers[16] = XidEvent;
  module.exports = BinlogDump;
});
var require_change_user2 = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var Packets = require_packets();
  var ClientConstants = require_client();
  var ClientHandshake = require_client_handshake();
  var CharsetToEncoding = require_charset_encodings();

  class ChangeUser extends Command2 {
    constructor(options3, callback) {
      super();
      this.onResult = callback;
      this.user = options3.user;
      this.password = options3.password;
      this.password1 = options3.password;
      this.password2 = options3.password2;
      this.password3 = options3.password3;
      this.database = options3.database;
      this.passwordSha1 = options3.passwordSha1;
      this.charsetNumber = options3.charsetNumber;
      this.currentConfig = options3.currentConfig;
      this.authenticationFactor = 0;
    }
    start(packet, connection) {
      const newPacket = new Packets.ChangeUser({
        flags: connection.config.clientFlags,
        user: this.user,
        database: this.database,
        charsetNumber: this.charsetNumber,
        password: this.password,
        passwordSha1: this.passwordSha1,
        authPluginData1: connection._handshakePacket.authPluginData1,
        authPluginData2: connection._handshakePacket.authPluginData2
      });
      this.currentConfig.user = this.user;
      this.currentConfig.password = this.password;
      this.currentConfig.database = this.database;
      this.currentConfig.charsetNumber = this.charsetNumber;
      connection.clientEncoding = CharsetToEncoding[this.charsetNumber];
      connection._statements.clear();
      connection.writePacket(newPacket.toPacket());
      const multiFactorAuthentication = connection.serverCapabilityFlags & ClientConstants.MULTI_FACTOR_AUTHENTICATION;
      if (multiFactorAuthentication) {
        this.authenticationFactor = 1;
      }
      return ChangeUser.prototype.handshakeResult;
    }
  }
  ChangeUser.prototype.handshakeResult = ClientHandshake.prototype.handshakeResult;
  ChangeUser.prototype.calculateNativePasswordAuthToken = ClientHandshake.prototype.calculateNativePasswordAuthToken;
  module.exports = ChangeUser;
});
var require_quit = __commonJS2((exports, module) => {
  var Command2 = require_command();
  var CommandCode = require_commands();
  var Packet = require_packet();

  class Quit extends Command2 {
    constructor(callback) {
      super();
      this.onResult = callback;
    }
    start(packet, connection) {
      connection._closing = true;
      const quit = new Packet(0, Buffer.from([1, 0, 0, 0, CommandCode.QUIT]), 0, 5);
      if (this.onResult) {
        this.onResult();
      }
      connection.writePacket(quit);
      return null;
    }
  }
  module.exports = Quit;
});
var require_commands2 = __commonJS2((exports, module) => {
  var ClientHandshake = require_client_handshake();
  var ServerHandshake = require_server_handshake();
  var Query = require_query2();
  var Prepare = require_prepare();
  var CloseStatement = require_close_statement2();
  var Execute = require_execute2();
  var Ping = require_ping();
  var RegisterSlave = require_register_slave2();
  var BinlogDump = require_binlog_dump2();
  var ChangeUser = require_change_user2();
  var Quit = require_quit();
  module.exports = {
    ClientHandshake,
    ServerHandshake,
    Query,
    Prepare,
    CloseStatement,
    Execute,
    Ping,
    RegisterSlave,
    BinlogDump,
    ChangeUser,
    Quit
  };
});
var require_package = __commonJS2((exports, module) => {
  module.exports = {
    name: "mysql2",
    version: "3.11.3",
    description: "fast mysql driver. Implements core protocol, prepared statements, ssl and compression in native JS",
    main: "index.js",
    typings: "typings/mysql/index",
    scripts: {
      lint: "npm run lint:docs && npm run lint:code",
      "lint:code": "eslint index.js promise.js index.d.ts promise.d.ts \"typings/**/*.ts\" \"lib/**/*.js\" \"test/**/*.{js,cjs,mjs,ts}\" \"benchmarks/**/*.js\"",
      "lint:docs": "eslint Contributing.md README.md",
      "lint:typings": "npx prettier --check ./typings",
      "lint:tests": "npx prettier --check ./test",
      test: "poku --debug --include=\"test/esm,test/unit,test/integration\"",
      "test:bun": "poku --debug --platform=\"bun\" --include=\"test/esm,test/unit,test/integration\"",
      "test:deno": "deno run --allow-read --allow-env --allow-run npm:poku --debug --platform=\"deno\" --deno-allow=\"read,env,net,sys\" --deno-cjs=\".js,.cjs\" --include=\"test/esm,test/unit,test/integration\"",
      "test:tsc-build": "cd \"test/tsc-build\" && npx tsc -p \"tsconfig.json\"",
      "coverage-test": "c8 npm run test",
      benchmark: "node ./benchmarks/benchmark.js",
      prettier: "prettier --single-quote --trailing-comma none --write \"{lib,test}/**/*.js\"",
      "prettier:docs": "prettier --single-quote --trailing-comma none --write README.md",
      precommit: "lint-staged",
      "eslint-check": "eslint --print-config .eslintrc | eslint-config-prettier-check",
      "wait-port": "wait-on"
    },
    "lint-staged": {
      "*.js": [
        "prettier --single-quote --trailing-comma none --write",
        "git add"
      ]
    },
    repository: {
      type: "git",
      url: "https://github.com/sidorares/node-mysql2"
    },
    homepage: "https://sidorares.github.io/node-mysql2/docs",
    keywords: [
      "mysql",
      "client",
      "server"
    ],
    files: [
      "lib",
      "typings/mysql",
      "index.js",
      "index.d.ts",
      "promise.js",
      "promise.d.ts"
    ],
    exports: {
      ".": "./index.js",
      "./package.json": "./package.json",
      "./promise": "./promise.js",
      "./promise.js": "./promise.js"
    },
    engines: {
      node: ">= 8.0"
    },
    author: "Andrey Sidorov <andrey.sidorov@gmail.com>",
    license: "MIT",
    dependencies: {
      "aws-ssl-profiles": "^1.1.1",
      denque: "^2.1.0",
      "generate-function": "^2.3.1",
      "iconv-lite": "^0.6.3",
      long: "^5.2.1",
      "lru.min": "^1.0.0",
      "named-placeholders": "^1.1.3",
      "seq-queue": "^0.0.5",
      sqlstring: "^2.3.2"
    },
    devDependencies: {
      "@types/node": "^22.0.0",
      "@typescript-eslint/eslint-plugin": "^5.42.1",
      "@typescript-eslint/parser": "^5.42.1",
      "assert-diff": "^3.0.2",
      benchmark: "^2.1.4",
      c8: "^10.1.1",
      "error-stack-parser": "^2.0.3",
      eslint: "^8.27.0",
      "eslint-config-prettier": "^9.0.0",
      "eslint-plugin-async-await": "0.0.0",
      "eslint-plugin-markdown": "^5.0.0",
      "lint-staged": "^15.0.1",
      poku: "^2.0.0",
      portfinder: "^1.0.28",
      prettier: "^3.0.0",
      progress: "^2.0.3",
      typescript: "^5.0.2"
    }
  };
});
var require_defaults = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.defaults = undefined;
  exports.defaults = [
    "-----BEGIN CERTIFICATE-----\nMIIEEjCCAvqgAwIBAgIJAM2ZN/+nPi27MA0GCSqGSIb3DQEBCwUAMIGVMQswCQYD\nVQQGEwJVUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEi\nMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1h\nem9uIFJEUzEmMCQGA1UEAwwdQW1hem9uIFJEUyBhZi1zb3V0aC0xIFJvb3QgQ0Ew\nHhcNMTkxMDI4MTgwNTU4WhcNMjQxMDI2MTgwNTU4WjCBlTELMAkGA1UEBhMCVVMx\nEDAOBgNVBAcMB1NlYXR0bGUxEzARBgNVBAgMCldhc2hpbmd0b24xIjAgBgNVBAoM\nGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMx\nJjAkBgNVBAMMHUFtYXpvbiBSRFMgYWYtc291dGgtMSBSb290IENBMIIBIjANBgkq\nhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwR2351uPMZaJk2gMGT+1sk8HE9MQh2rc\n/sCnbxGn2p1c7Oi9aBbd/GiFijeJb2BXvHU+TOq3d3Jjqepq8tapXVt4ojbTJNyC\nJ5E7r7KjTktKdLxtBE1MK25aY+IRJjtdU6vG3KiPKUT1naO3xs3yt0F76WVuFivd\n9OHv2a+KHvPkRUWIxpmAHuMY9SIIMmEZtVE7YZGx5ah0iO4JzItHcbVR0y0PBH55\narpFBddpIVHCacp1FUPxSEWkOpI7q0AaU4xfX0fe1BV5HZYRKpBOIp1TtZWvJD+X\njGUtL1BEsT5vN5g9MkqdtYrC+3SNpAk4VtpvJrdjraI/hhvfeXNnAwIDAQABo2Mw\nYTAOBgNVHQ8BAf8EBAMCAQYwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUEEi/\nWWMcBJsoGXg+EZwkQ0MscZQwHwYDVR0jBBgwFoAUEEi/WWMcBJsoGXg+EZwkQ0Ms\ncZQwDQYJKoZIhvcNAQELBQADggEBAGDZ5js5Pc/gC58LJrwMPXFhJDBS8QuDm23C\nFFUdlqucskwOS3907ErK1ZkmVJCIqFLArHqskFXMAkRZ2PNR7RjWLqBs+0znG5yH\nhRKb4DXzhUFQ18UBRcvT6V6zN97HTRsEEaNhM/7k8YLe7P8vfNZ28VIoJIGGgv9D\nwQBBvkxQ71oOmAG0AwaGD0ORGUfbYry9Dz4a4IcUsZyRWRMADixgrFv6VuETp26s\n/+z+iqNaGWlELBKh3iQCT6Y/1UnkPLO42bxrCSyOvshdkYN58Q2gMTE1SVTqyo8G\nLw8lLAz9bnvUSgHzB3jRrSx6ggF/WRMRYlR++y6LXP4SAsSAaC0=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEEjCCAvqgAwIBAgIJAJYM4LxvTZA6MA0GCSqGSIb3DQEBCwUAMIGVMQswCQYD\nVQQGEwJVUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEi\nMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1h\nem9uIFJEUzEmMCQGA1UEAwwdQW1hem9uIFJEUyBldS1zb3V0aC0xIFJvb3QgQ0Ew\nHhcNMTkxMDMwMjAyMDM2WhcNMjQxMDI4MjAyMDM2WjCBlTELMAkGA1UEBhMCVVMx\nEDAOBgNVBAcMB1NlYXR0bGUxEzARBgNVBAgMCldhc2hpbmd0b24xIjAgBgNVBAoM\nGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMx\nJjAkBgNVBAMMHUFtYXpvbiBSRFMgZXUtc291dGgtMSBSb290IENBMIIBIjANBgkq\nhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAqM921jXCXeqpRNCS9CBPOe5N7gMaEt+D\ns5uR3riZbqzRlHGiF1jZihkXfHAIQewDwy+Yz+Oec1aEZCQMhUHxZJPusuX0cJfj\nb+UluFqHIijL2TfXJ3D0PVLLoNTQJZ8+GAPECyojAaNuoHbdVqxhOcznMsXIXVFq\nyVLKDGvyKkJjai/iSPDrQMXufg3kWt0ISjNLvsG5IFXgP4gttsM8i0yvRd4QcHoo\nDjvH7V3cS+CQqW5SnDrGnHToB0RLskE1ET+oNOfeN9PWOxQprMOX/zmJhnJQlTqD\nQP7jcf7SddxrKFjuziFiouskJJyNDsMjt1Lf60+oHZhed2ogTeifGwIDAQABo2Mw\nYTAOBgNVHQ8BAf8EBAMCAQYwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUFBAF\ncgJe/BBuZiGeZ8STfpkgRYQwHwYDVR0jBBgwFoAUFBAFcgJe/BBuZiGeZ8STfpkg\nRYQwDQYJKoZIhvcNAQELBQADggEBAKAYUtlvDuX2UpZW9i1QgsjFuy/ErbW0dLHU\ne/IcFtju2z6RLZ+uF+5A8Kme7IKG1hgt8s+w9TRVQS/7ukQzoK3TaN6XKXRosjtc\no9Rm4gYWM8bmglzY1TPNaiI4HC7546hSwJhubjN0bXCuj/0sHD6w2DkiGuwKNAef\nyTu5vZhPkeNyXLykxkzz7bNp2/PtMBnzIp+WpS7uUDmWyScGPohKMq5PqvL59z+L\nZI3CYeMZrJ5VpXUg3fNNIz/83N3G0sk7wr0ohs/kHTP7xPOYB0zD7Ku4HA0Q9Swf\nWX0qr6UQgTPMjfYDLffI7aEId0gxKw1eGYc6Cq5JAZ3ipi/cBFc=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEEjCCAvqgAwIBAgIJANew34ehz5l8MA0GCSqGSIb3DQEBCwUAMIGVMQswCQYD\nVQQGEwJVUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEi\nMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1h\nem9uIFJEUzEmMCQGA1UEAwwdQW1hem9uIFJEUyBtZS1zb3V0aC0xIFJvb3QgQ0Ew\nHhcNMTkwNTEwMjE0ODI3WhcNMjQwNTA4MjE0ODI3WjCBlTELMAkGA1UEBhMCVVMx\nEDAOBgNVBAcMB1NlYXR0bGUxEzARBgNVBAgMCldhc2hpbmd0b24xIjAgBgNVBAoM\nGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMx\nJjAkBgNVBAMMHUFtYXpvbiBSRFMgbWUtc291dGgtMSBSb290IENBMIIBIjANBgkq\nhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAp7BYV88MukcY+rq0r79+C8UzkT30fEfT\naPXbx1d6M7uheGN4FMaoYmL+JE1NZPaMRIPTHhFtLSdPccInvenRDIatcXX+jgOk\nUA6lnHQ98pwN0pfDUyz/Vph4jBR9LcVkBbe0zdoKKp+HGbMPRU0N2yNrog9gM5O8\ngkU/3O2csJ/OFQNnj4c2NQloGMUpEmedwJMOyQQfcUyt9CvZDfIPNnheUS29jGSw\nERpJe/AENu8Pxyc72jaXQuD+FEi2Ck6lBkSlWYQFhTottAeGvVFNCzKszCntrtqd\nrdYUwurYsLTXDHv9nW2hfDUQa0mhXf9gNDOBIVAZugR9NqNRNyYLHQIDAQABo2Mw\nYTAOBgNVHQ8BAf8EBAMCAQYwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQU54cf\nDjgwBx4ycBH8+/r8WXdaiqYwHwYDVR0jBBgwFoAU54cfDjgwBx4ycBH8+/r8WXda\niqYwDQYJKoZIhvcNAQELBQADggEBAIIMTSPx/dR7jlcxggr+O6OyY49Rlap2laKA\neC/XI4ySP3vQkIFlP822U9Kh8a9s46eR0uiwV4AGLabcu0iKYfXjPkIprVCqeXV7\nny9oDtrbflyj7NcGdZLvuzSwgl9SYTJp7PVCZtZutsPYlbJrBPHwFABvAkMvRtDB\nhitIg4AESDGPoCl94sYHpfDfjpUDMSrAMDUyO6DyBdZH5ryRMAs3lGtsmkkNUrso\naTW6R05681Z0mvkRdb+cdXtKOSuDZPoe2wJJIaz3IlNQNSrB5TImMYgmt6iAsFhv\n3vfTSTKrZDNTJn4ybG6pq1zWExoXsktZPylJly6R3RBwV6nwqBM=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBjCCAu6gAwIBAgIJAMc0ZzaSUK51MA0GCSqGSIb3DQEBCwUAMIGPMQswCQYD\nVQQGEwJVUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEi\nMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1h\nem9uIFJEUzEgMB4GA1UEAwwXQW1hem9uIFJEUyBSb290IDIwMTkgQ0EwHhcNMTkw\nODIyMTcwODUwWhcNMjQwODIyMTcwODUwWjCBjzELMAkGA1UEBhMCVVMxEDAOBgNV\nBAcMB1NlYXR0bGUxEzARBgNVBAgMCldhc2hpbmd0b24xIjAgBgNVBAoMGUFtYXpv\nbiBXZWIgU2VydmljZXMsIEluYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxIDAeBgNV\nBAMMF0FtYXpvbiBSRFMgUm9vdCAyMDE5IENBMIIBIjANBgkqhkiG9w0BAQEFAAOC\nAQ8AMIIBCgKCAQEArXnF/E6/Qh+ku3hQTSKPMhQQlCpoWvnIthzX6MK3p5a0eXKZ\noWIjYcNNG6UwJjp4fUXl6glp53Jobn+tWNX88dNH2n8DVbppSwScVE2LpuL+94vY\n0EYE/XxN7svKea8YvlrqkUBKyxLxTjh+U/KrGOaHxz9v0l6ZNlDbuaZw3qIWdD/I\n6aNbGeRUVtpM6P+bWIoxVl/caQylQS6CEYUk+CpVyJSkopwJlzXT07tMoDL5WgX9\nO08KVgDNz9qP/IGtAcRduRcNioH3E9v981QO1zt/Gpb2f8NqAjUUCUZzOnij6mx9\nMcZ+9cWX88CRzR0vQODWuZscgI08NvM69Fn2SQIDAQABo2MwYTAOBgNVHQ8BAf8E\nBAMCAQYwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUc19g2LzLA5j0Kxc0LjZa\npmD/vB8wHwYDVR0jBBgwFoAUc19g2LzLA5j0Kxc0LjZapmD/vB8wDQYJKoZIhvcN\nAQELBQADggEBAHAG7WTmyjzPRIM85rVj+fWHsLIvqpw6DObIjMWokpliCeMINZFV\nynfgBKsf1ExwbvJNzYFXW6dihnguDG9VMPpi2up/ctQTN8tm9nDKOy08uNZoofMc\nNUZxKCEkVKZv+IL4oHoeayt8egtv3ujJM6V14AstMQ6SwvwvA93EP/Ug2e4WAXHu\ncbI1NAbUgVDqp+DRdfvZkgYKryjTWd/0+1fS8X1bBZVWzl7eirNVnHbSH2ZDpNuY\n0SBd8dj5F6ld3t58ydZbrTHze7JJOd8ijySAp4/kiu9UfZWuTPABzDa/DSdz9Dk/\nzPW4CXXvhLmE02TA9/HeCw3KEHIwicNuEfw=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEEDCCAvigAwIBAgIJAKFMXyltvuRdMA0GCSqGSIb3DQEBCwUAMIGUMQswCQYD\nVQQGEwJVUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEi\nMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1h\nem9uIFJEUzElMCMGA1UEAwwcQW1hem9uIFJEUyBCZXRhIFJvb3QgMjAxOSBDQTAe\nFw0xOTA4MTkxNzM4MjZaFw0yNDA4MTkxNzM4MjZaMIGUMQswCQYDVQQGEwJVUzEQ\nMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEiMCAGA1UECgwZ\nQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEl\nMCMGA1UEAwwcQW1hem9uIFJEUyBCZXRhIFJvb3QgMjAxOSBDQTCCASIwDQYJKoZI\nhvcNAQEBBQADggEPADCCAQoCggEBAMkZdnIH9ndatGAcFo+DppGJ1HUt4x+zeO+0\nZZ29m0sfGetVulmTlv2d5b66e+QXZFWpcPQMouSxxYTW08TbrQiZngKr40JNXftA\natvzBqIImD4II0ZX5UEVj2h98qe/ypW5xaDN7fEa5e8FkYB1TEemPaWIbNXqchcL\ntV7IJPr3Cd7Z5gZJlmujIVDPpMuSiNaal9/6nT9oqN+JSM1fx5SzrU5ssg1Vp1vv\n5Xab64uOg7wCJRB9R2GC9XD04odX6VcxUAGrZo6LR64ZSifupo3l+R5sVOc5i8NH\nskdboTzU9H7+oSdqoAyhIU717PcqeDum23DYlPE2nGBWckE+eT8CAwEAAaNjMGEw\nDgYDVR0PAQH/BAQDAgEGMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFK2hDBWl\nsbHzt/EHd0QYOooqcFPhMB8GA1UdIwQYMBaAFK2hDBWlsbHzt/EHd0QYOooqcFPh\nMA0GCSqGSIb3DQEBCwUAA4IBAQAO/718k8EnOqJDx6wweUscGTGL/QdKXUzTVRAx\nJUsjNUv49mH2HQVEW7oxszfH6cPCaupNAddMhQc4C/af6GHX8HnqfPDk27/yBQI+\nyBBvIanGgxv9c9wBbmcIaCEWJcsLp3HzXSYHmjiqkViXwCpYfkoV3Ns2m8bp+KCO\ny9XmcCKRaXkt237qmoxoh2sGmBHk2UlQtOsMC0aUQ4d7teAJG0q6pbyZEiPyKZY1\nXR/UVxMJL0Q4iVpcRS1kaNCMfqS2smbLJeNdsan8pkw1dvPhcaVTb7CvjhJtjztF\nYfDzAI5794qMlWxwilKMmUvDlPPOTen8NNHkLwWvyFCH7Doh\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEFjCCAv6gAwIBAgIJAMzYZJ+R9NBVMA0GCSqGSIb3DQEBCwUAMIGXMQswCQYD\nVQQGEwJVUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEi\nMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1h\nem9uIFJEUzEoMCYGA1UEAwwfQW1hem9uIFJEUyBQcmV2aWV3IFJvb3QgMjAxOSBD\nQTAeFw0xOTA4MjEyMjI5NDlaFw0yNDA4MjEyMjI5NDlaMIGXMQswCQYDVQQGEwJV\nUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEiMCAGA1UE\nCgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJE\nUzEoMCYGA1UEAwwfQW1hem9uIFJEUyBQcmV2aWV3IFJvb3QgMjAxOSBDQTCCASIw\nDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAM7kkS6vjgKKQTPynC2NjdN5aPPV\nO71G0JJS/2ARVBVJd93JLiGovVJilfWYfwZCs4gTRSSjrUD4D4HyqCd6A+eEEtJq\nM0DEC7i0dC+9WNTsPszuB206Jy2IUmxZMIKJAA1NHSbIMjB+b6/JhbSUi7nKdbR/\nbrj83bF+RoSA+ogrgX7mQbxhmFcoZN9OGaJgYKsKWUt5Wqv627KkGodUK8mDepgD\nS3ZfoRQRx3iceETpcmHJvaIge6+vyDX3d9Z22jmvQ4AKv3py2CmU2UwuhOltFDwB\n0ddtb39vgwrJxaGfiMRHpEP1DfNLWHAnA69/pgZPwIggidS+iBPUhgucMp8CAwEA\nAaNjMGEwDgYDVR0PAQH/BAQDAgEGMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYE\nFGnTGpQuQ2H/DZlXMQijZEhjs7TdMB8GA1UdIwQYMBaAFGnTGpQuQ2H/DZlXMQij\nZEhjs7TdMA0GCSqGSIb3DQEBCwUAA4IBAQC3xz1vQvcXAfpcZlngiRWeqU8zQAMQ\nLZPCFNv7PVk4pmqX+ZiIRo4f9Zy7TrOVcboCnqmP/b/mNq0gVF4O+88jwXJZD+f8\n/RnABMZcnGU+vK0YmxsAtYU6TIb1uhRFmbF8K80HHbj9vSjBGIQdPCbvmR2zY6VJ\nBYM+w9U9hp6H4DVMLKXPc1bFlKA5OBTgUtgkDibWJKFOEPW3UOYwp9uq6pFoN0AO\nxMTldqWFsOF3bJIlvOY0c/1EFZXu3Ns6/oCP//Ap9vumldYMUZWmbK+gK33FPOXV\n8BQ6jNC29icv7lLDpRPwjibJBXX+peDR5UK4FdYcswWEB1Tix5X8dYu6\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgICEAAwDQYJKoZIhvcNAQELBQAwgZUxCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSYwJAYDVQQDDB1BbWF6b24gUkRTIGFmLXNvdXRoLTEgUm9vdCBDQTAeFw0xOTEw\nMjgxODA2NTNaFw0yNDEwMjgxODA2NTNaMIGQMQswCQYDVQQGEwJVUzETMBEGA1UE\nCAwKV2FzaGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9u\nIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEhMB8GA1UE\nAwwYQW1hem9uIFJEUyBhZi1zb3V0aC0xIENBMIIBIjANBgkqhkiG9w0BAQEFAAOC\nAQ8AMIIBCgKCAQEAvtV1OqmFa8zCVQSKOvPUJERLVFtd4rZmDpImc5rIoeBk7w/P\n9lcKUJjO8R/w1a2lJXx3oQ81tiY0Piw6TpT62YWVRMWrOw8+Vxq1dNaDSFp9I8d0\nUHillSSbOk6FOrPDp+R6AwbGFqUDebbN5LFFoDKbhNmH1BVS0a6YNKpGigLRqhka\ncClPslWtPqtjbaP3Jbxl26zWzLo7OtZl98dR225pq8aApNBwmtgA7Gh60HK/cX0t\n32W94n8D+GKSg6R4MKredVFqRTi9hCCNUu0sxYPoELuM+mHiqB5NPjtm92EzCWs+\n+vgWhMc6GxG+82QSWx1Vj8sgLqtE/vLrWddf5QIDAQABo2YwZDAOBgNVHQ8BAf8E\nBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQUuLB4gYVJrSKJj/Gz\npqc6yeA+RcAwHwYDVR0jBBgwFoAUEEi/WWMcBJsoGXg+EZwkQ0MscZQwDQYJKoZI\nhvcNAQELBQADggEBABauYOZxUhe9/RhzGJ8MsWCz8eKcyDVd4FCnY6Qh+9wcmYNT\nLtnD88LACtJKb/b81qYzcB0Em6+zVJ3Z9jznfr6buItE6es9wAoja22Xgv44BTHL\nrimbgMwpTt3uEMXDffaS0Ww6YWb3pSE0XYI2ISMWz+xRERRf+QqktSaL39zuiaW5\ntfZMre+YhohRa/F0ZQl3RCd6yFcLx4UoSPqQsUl97WhYzwAxZZfwvLJXOc4ATt3u\nVlCUylNDkaZztDJc/yN5XQoK9W5nOt2cLu513MGYKbuarQr8f+gYU8S+qOyuSRSP\nNRITzwCRVnsJE+2JmcRInn/NcanB7uOGqTvJ9+c=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgICEAAwDQYJKoZIhvcNAQELBQAwgZUxCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSYwJAYDVQQDDB1BbWF6b24gUkRTIGV1LXNvdXRoLTEgUm9vdCBDQTAeFw0xOTEw\nMzAyMDIxMzBaFw0yNDEwMzAyMDIxMzBaMIGQMQswCQYDVQQGEwJVUzETMBEGA1UE\nCAwKV2FzaGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9u\nIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEhMB8GA1UE\nAwwYQW1hem9uIFJEUyBldS1zb3V0aC0xIENBMIIBIjANBgkqhkiG9w0BAQEFAAOC\nAQ8AMIIBCgKCAQEAtEyjYcajx6xImJn8Vz1zjdmL4ANPgQXwF7+tF7xccmNAZETb\nbzb3I9i5fZlmrRaVznX+9biXVaGxYzIUIR3huQ3Q283KsDYnVuGa3mk690vhvJbB\nQIPgKa5mVwJppnuJm78KqaSpi0vxyCPe3h8h6LLFawVyWrYNZ4okli1/U582eef8\nRzJp/Ear3KgHOLIiCdPDF0rjOdCG1MOlDLixVnPn9IYOciqO+VivXBg+jtfc5J+L\nAaPm0/Yx4uELt1tkbWkm4BvTU/gBOODnYziITZM0l6Fgwvbwgq5duAtKW+h031lC\n37rEvrclqcp4wrsUYcLAWX79ZyKIlRxcAdvEhQIDAQABo2YwZDAOBgNVHQ8BAf8E\nBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQU7zPyc0azQxnBCe7D\nb9KAadH1QSEwHwYDVR0jBBgwFoAUFBAFcgJe/BBuZiGeZ8STfpkgRYQwDQYJKoZI\nhvcNAQELBQADggEBAFGaNiYxg7yC/xauXPlaqLCtwbm2dKyK9nIFbF/7be8mk7Q3\nMOA0of1vGHPLVQLr6bJJpD9MAbUcm4cPAwWaxwcNpxOjYOFDaq10PCK4eRAxZWwF\nNJRIRmGsl8NEsMNTMCy8X+Kyw5EzH4vWFl5Uf2bGKOeFg0zt43jWQVOX6C+aL3Cd\npRS5MhmYpxMG8irrNOxf4NVFE2zpJOCm3bn0STLhkDcV/ww4zMzObTJhiIb5wSWn\nEXKKWhUXuRt7A2y1KJtXpTbSRHQxE++69Go1tWhXtRiULCJtf7wF2Ksm0RR/AdXT\n1uR1vKyH5KBJPX3ppYkQDukoHTFR0CpB+G84NLo=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgICEAAwDQYJKoZIhvcNAQELBQAwgZUxCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSYwJAYDVQQDDB1BbWF6b24gUkRTIG1lLXNvdXRoLTEgUm9vdCBDQTAeFw0xOTA1\nMTAyMTU4NDNaFw0yNTA2MDExMjAwMDBaMIGQMQswCQYDVQQGEwJVUzETMBEGA1UE\nCAwKV2FzaGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9u\nIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEhMB8GA1UE\nAwwYQW1hem9uIFJEUyBtZS1zb3V0aC0xIENBMIIBIjANBgkqhkiG9w0BAQEFAAOC\nAQ8AMIIBCgKCAQEAudOYPZH+ihJAo6hNYMB5izPVBe3TYhnZm8+X3IoaaYiKtsp1\nJJhkTT0CEejYIQ58Fh4QrMUyWvU8qsdK3diNyQRoYLbctsBPgxBR1u07eUJDv38/\nC1JlqgHmMnMi4y68Iy7ymv50QgAMuaBqgEBRI1R6Lfbyrb2YvH5txjJyTVMwuCfd\nYPAtZVouRz0JxmnfsHyxjE+So56uOKTDuw++Ho4HhZ7Qveej7XB8b+PIPuroknd3\nFQB5RVbXRvt5ZcVD4F2fbEdBniF7FAF4dEiofVCQGQ2nynT7dZdEIPfPdH3n7ZmE\nlAOmwHQ6G83OsiHRBLnbp+QZRgOsjkHJxT20bQIDAQABo2YwZDAOBgNVHQ8BAf8E\nBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQUOEVDM7VomRH4HVdA\nQvIMNq2tXOcwHwYDVR0jBBgwFoAU54cfDjgwBx4ycBH8+/r8WXdaiqYwDQYJKoZI\nhvcNAQELBQADggEBAHhvMssj+Th8IpNePU6RH0BiL6o9c437R3Q4IEJeFdYL+nZz\nPW/rELDPvLRUNMfKM+KzduLZ+l29HahxefejYPXtvXBlq/E/9czFDD4fWXg+zVou\nuDXhyrV4kNmP4S0eqsAP/jQHPOZAMFA4yVwO9hlqmePhyDnszCh9c1PfJSBh49+b\n4w7i/L3VBOMt8j3EKYvqz0gVfpeqhJwL4Hey8UbVfJRFJMJzfNHpePqtDRAY7yjV\nPYquRaV2ab/E+/7VFkWMM4tazYz/qsYA2jSH+4xDHvYk8LnsbcrF9iuidQmEc5sb\nFgcWaSKG4DJjcI5k7AJLWcXyTDt21Ci43LE+I9Q=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECDCCAvCgAwIBAgICVIYwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MDQxNzEz\nMDRaFw0yNDA4MjIxNzA4NTBaMIGVMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEmMCQGA1UEAwwdQW1h\nem9uIFJEUyBhcC1zb3V0aC0xIDIwMTkgQ0EwggEiMA0GCSqGSIb3DQEBAQUAA4IB\nDwAwggEKAoIBAQDUYOz1hGL42yUCrcsMSOoU8AeD/3KgZ4q7gP+vAz1WnY9K/kim\neWN/2Qqzlo3+mxSFQFyD4MyV3+CnCPnBl9Sh1G/F6kThNiJ7dEWSWBQGAB6HMDbC\nBaAsmUc1UIz8sLTL3fO+S9wYhA63Wun0Fbm/Rn2yk/4WnJAaMZcEtYf6e0KNa0LM\np/kN/70/8cD3iz3dDR8zOZFpHoCtf0ek80QqTich0A9n3JLxR6g6tpwoYviVg89e\nqCjQ4axxOkWWeusLeTJCcY6CkVyFvDAKvcUl1ytM5AiaUkXblE7zDFXRM4qMMRdt\nlPm8d3pFxh0fRYk8bIKnpmtOpz3RIctDrZZxAgMBAAGjZjBkMA4GA1UdDwEB/wQE\nAwIBBjASBgNVHRMBAf8ECDAGAQH/AgEAMB0GA1UdDgQWBBT99wKJftD3jb4sHoHG\ni3uGlH6W6TAfBgNVHSMEGDAWgBRzX2DYvMsDmPQrFzQuNlqmYP+8HzANBgkqhkiG\n9w0BAQsFAAOCAQEAZ17hhr3dII3hUfuHQ1hPWGrpJOX/G9dLzkprEIcCidkmRYl+\nhu1Pe3caRMh/17+qsoEErmnVq5jNY9X1GZL04IZH8YbHc7iRHw3HcWAdhN8633+K\njYEB2LbJ3vluCGnCejq9djDb6alOugdLMJzxOkHDhMZ6/gYbECOot+ph1tQuZXzD\ntZ7prRsrcuPBChHlPjmGy8M9z8u+kF196iNSUGC4lM8vLkHM7ycc1/ZOwRq9aaTe\niOghbQQyAEe03MWCyDGtSmDfr0qEk+CHN+6hPiaL8qKt4s+V9P7DeK4iW08ny8Ox\nAVS7u0OK/5+jKMAMrKwpYrBydOjTUTHScocyNw==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBzCCAu+gAwIBAgICQ2QwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MDUxODQ2\nMjlaFw0yNDA4MjIxNzA4NTBaMIGUMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzElMCMGA1UEAwwcQW1h\nem9uIFJEUyBzYS1lYXN0LTEgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEP\nADCCAQoCggEBAMMvR+ReRnOzqJzoaPipNTt1Z2VA968jlN1+SYKUrYM3No+Vpz0H\nM6Tn0oYB66ByVsXiGc28ulsqX1HbHsxqDPwvQTKvO7SrmDokoAkjJgLocOLUAeld\n5AwvUjxGRP6yY90NV7X786MpnYb2Il9DIIaV9HjCmPt+rjy2CZjS0UjPjCKNfB8J\nbFjgW6GGscjeyGb/zFwcom5p4j0rLydbNaOr9wOyQrtt3ZQWLYGY9Zees/b8pmcc\nJt+7jstZ2UMV32OO/kIsJ4rMUn2r/uxccPwAc1IDeRSSxOrnFKhW3Cu69iB3bHp7\nJbawY12g7zshE4I14sHjv3QoXASoXjx4xgMCAwEAAaNmMGQwDgYDVR0PAQH/BAQD\nAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFI1Fc/Ql2jx+oJPgBVYq\nccgP0pQ8MB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqGSIb3\nDQEBCwUAA4IBAQB4VVVabVp70myuYuZ3vltQIWqSUMhkaTzehMgGcHjMf9iLoZ/I\n93KiFUSGnek5cRePyS9wcpp0fcBT3FvkjpUdCjVtdttJgZFhBxgTd8y26ImdDDMR\n4+BUuhI5msvjL08f+Vkkpu1GQcGmyFVPFOy/UY8iefu+QyUuiBUnUuEDd49Hw0Fn\n/kIPII6Vj82a2mWV/Q8e+rgN8dIRksRjKI03DEoP8lhPlsOkhdwU6Uz9Vu6NOB2Q\nLs1kbcxAc7cFSyRVJEhh12Sz9d0q/CQSTFsVJKOjSNQBQfVnLz1GwO/IieUEAr4C\njkTntH0r1LX5b/GwN4R887LvjAEdTbg1his7\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECDCCAvCgAwIBAgIDAIkHMA0GCSqGSIb3DQEBCwUAMIGPMQswCQYDVQQGEwJV\nUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEiMCAGA1UE\nCgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJE\nUzEgMB4GA1UEAwwXQW1hem9uIFJEUyBSb290IDIwMTkgQ0EwHhcNMTkwOTA2MTc0\nMDIxWhcNMjQwODIyMTcwODUwWjCBlDELMAkGA1UEBhMCVVMxEzARBgNVBAgMCldh\nc2hpbmd0b24xEDAOBgNVBAcMB1NlYXR0bGUxIjAgBgNVBAoMGUFtYXpvbiBXZWIg\nU2VydmljZXMsIEluYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxJTAjBgNVBAMMHEFt\nYXpvbiBSRFMgdXMtd2VzdC0xIDIwMTkgQ0EwggEiMA0GCSqGSIb3DQEBAQUAA4IB\nDwAwggEKAoIBAQDD2yzbbAl77OofTghDMEf624OvU0eS9O+lsdO0QlbfUfWa1Kd6\n0WkgjkLZGfSRxEHMCnrv4UPBSK/Qwn6FTjkDLgemhqBtAnplN4VsoDL+BkRX4Wwq\n/dSQJE2b+0hm9w9UMVGFDEq1TMotGGTD2B71eh9HEKzKhGzqiNeGsiX4VV+LJzdH\nuM23eGisNqmd4iJV0zcAZ+Gbh2zK6fqTOCvXtm7Idccv8vZZnyk1FiWl3NR4WAgK\nAkvWTIoFU3Mt7dIXKKClVmvssG8WHCkd3Xcb4FHy/G756UZcq67gMMTX/9fOFM/v\nl5C0+CHl33Yig1vIDZd+fXV1KZD84dEJfEvHAgMBAAGjZjBkMA4GA1UdDwEB/wQE\nAwIBBjASBgNVHRMBAf8ECDAGAQH/AgEAMB0GA1UdDgQWBBR+ap20kO/6A7pPxo3+\nT3CfqZpQWjAfBgNVHSMEGDAWgBRzX2DYvMsDmPQrFzQuNlqmYP+8HzANBgkqhkiG\n9w0BAQsFAAOCAQEAHCJky2tPjPttlDM/RIqExupBkNrnSYnOK4kr9xJ3sl8UF2DA\nPAnYsjXp3rfcjN/k/FVOhxwzi3cXJF/2Tjj39Bm/OEfYTOJDNYtBwB0VVH4ffa/6\ntZl87jaIkrxJcreeeHqYMnIxeN0b/kliyA+a5L2Yb0VPjt9INq34QDc1v74FNZ17\n4z8nr1nzg4xsOWu0Dbjo966lm4nOYIGBRGOKEkHZRZ4mEiMgr3YLkv8gSmeitx57\nZ6dVemNtUic/LVo5Iqw4n3TBS0iF2C1Q1xT/s3h+0SXZlfOWttzSluDvoMv5PvCd\npFjNn+aXLAALoihL1MJSsxydtsLjOBro5eK0Vw==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEDDCCAvSgAwIBAgICOFAwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTAxNzQ2\nMjFaFw0yNDA4MjIxNzA4NTBaMIGZMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEqMCgGA1UEAwwhQW1h\nem9uIFJEUyBhcC1ub3J0aGVhc3QtMiAyMDE5IENBMIIBIjANBgkqhkiG9w0BAQEF\nAAOCAQ8AMIIBCgKCAQEAzU72e6XbaJbi4HjJoRNjKxzUEuChKQIt7k3CWzNnmjc5\n8I1MjCpa2W1iw1BYVysXSNSsLOtUsfvBZxi/1uyMn5ZCaf9aeoA9UsSkFSZBjOCN\nDpKPCmfV1zcEOvJz26+1m8WDg+8Oa60QV0ou2AU1tYcw98fOQjcAES0JXXB80P2s\n3UfkNcnDz+l4k7j4SllhFPhH6BQ4lD2NiFAP4HwoG6FeJUn45EPjzrydxjq6v5Fc\ncQ8rGuHADVXotDbEhaYhNjIrsPL+puhjWfhJjheEw8c4whRZNp6gJ/b6WEes/ZhZ\nh32DwsDsZw0BfRDUMgUn8TdecNexHUw8vQWeC181hwIDAQABo2YwZDAOBgNVHQ8B\nAf8EBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQUwW9bWgkWkr0U\nlrOsq2kvIdrECDgwHwYDVR0jBBgwFoAUc19g2LzLA5j0Kxc0LjZapmD/vB8wDQYJ\nKoZIhvcNAQELBQADggEBAEugF0Gj7HVhX0ehPZoGRYRt3PBuI2YjfrrJRTZ9X5wc\n9T8oHmw07mHmNy1qqWvooNJg09bDGfB0k5goC2emDiIiGfc/kvMLI7u+eQOoMKj6\nmkfCncyRN3ty08Po45vTLBFZGUvtQmjM6yKewc4sXiASSBmQUpsMbiHRCL72M5qV\nobcJOjGcIdDTmV1BHdWT+XcjynsGjUqOvQWWhhLPrn4jWe6Xuxll75qlrpn3IrIx\nCRBv/5r7qbcQJPOgwQsyK4kv9Ly8g7YT1/vYBlR3cRsYQjccw5ceWUj2DrMVWhJ4\nprf+E3Aa4vYmLLOUUvKnDQ1k3RGNu56V0tonsQbfsaM=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECjCCAvKgAwIBAgICEzUwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTAyMDUy\nMjVaFw0yNDA4MjIxNzA4NTBaMIGXMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEoMCYGA1UEAwwfQW1h\nem9uIFJEUyBjYS1jZW50cmFsLTEgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQAD\nggEPADCCAQoCggEBAOxHqdcPSA2uBjsCP4DLSlqSoPuQ/X1kkJLusVRKiQE2zayB\nviuCBt4VB9Qsh2rW3iYGM+usDjltGnI1iUWA5KHcvHszSMkWAOYWLiMNKTlg6LCp\nXnE89tvj5dIH6U8WlDvXLdjB/h30gW9JEX7S8supsBSci2GxEzb5mRdKaDuuF/0O\nqvz4YE04pua3iZ9QwmMFuTAOYzD1M72aOpj+7Ac+YLMM61qOtU+AU6MndnQkKoQi\nqmUN2A9IFaqHFzRlSdXwKCKUA4otzmz+/N3vFwjb5F4DSsbsrMfjeHMo6o/nb6Nh\nYDb0VJxxPee6TxSuN7CQJ2FxMlFUezcoXqwqXD0CAwEAAaNmMGQwDgYDVR0PAQH/\nBAQDAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFDGGpon9WfIpsggE\nCxHq8hZ7E2ESMB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqG\nSIb3DQEBCwUAA4IBAQAvpeQYEGZvoTVLgV9rd2+StPYykMsmFjWQcyn3dBTZRXC2\nlKq7QhQczMAOhEaaN29ZprjQzsA2X/UauKzLR2Uyqc2qOeO9/YOl0H3qauo8C/W9\nr8xqPbOCDLEXlOQ19fidXyyEPHEq5WFp8j+fTh+s8WOx2M7IuC0ANEetIZURYhSp\nxl9XOPRCJxOhj7JdelhpweX0BJDNHeUFi0ClnFOws8oKQ7sQEv66d5ddxqqZ3NVv\nRbCvCtEutQMOUMIuaygDlMn1anSM8N7Wndx8G6+Uy67AnhjGx7jw/0YPPxopEj6x\nJXP8j0sJbcT9K/9/fPVLNT25RvQ/93T2+IQL4Ca2\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBzCCAu+gAwIBAgICYpgwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTExNzMx\nNDhaFw0yNDA4MjIxNzA4NTBaMIGUMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzElMCMGA1UEAwwcQW1h\nem9uIFJEUyBldS13ZXN0LTEgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEP\nADCCAQoCggEBAMk3YdSZ64iAYp6MyyKtYJtNzv7zFSnnNf6vv0FB4VnfITTMmOyZ\nLXqKAT2ahZ00hXi34ewqJElgU6eUZT/QlzdIu359TEZyLVPwURflL6SWgdG01Q5X\nO++7fSGcBRyIeuQWs9FJNIIqK8daF6qw0Rl5TXfu7P9dBc3zkgDXZm2DHmxGDD69\n7liQUiXzoE1q2Z9cA8+jirDioJxN9av8hQt12pskLQumhlArsMIhjhHRgF03HOh5\ntvi+RCfihVOxELyIRTRpTNiIwAqfZxxTWFTgfn+gijTmd0/1DseAe82aYic8JbuS\nEMbrDduAWsqrnJ4GPzxHKLXX0JasCUcWyMECAwEAAaNmMGQwDgYDVR0PAQH/BAQD\nAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFPLtsq1NrwJXO13C9eHt\nsLY11AGwMB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqGSIb3\nDQEBCwUAA4IBAQAnWBKj5xV1A1mYd0kIgDdkjCwQkiKF5bjIbGkT3YEFFbXoJlSP\n0lZZ/hDaOHI8wbLT44SzOvPEEmWF9EE7SJzkvSdQrUAWR9FwDLaU427ALI3ngNHy\nlGJ2hse1fvSRNbmg8Sc9GBv8oqNIBPVuw+AJzHTacZ1OkyLZrz1c1QvwvwN2a+Jd\nvH0V0YIhv66llKcYDMUQJAQi4+8nbRxXWv6Gq3pvrFoorzsnkr42V3JpbhnYiK+9\nnRKd4uWl62KRZjGkfMbmsqZpj2fdSWMY1UGyN1k+kDmCSWYdrTRDP0xjtIocwg+A\nJ116n4hV/5mbA0BaPiS2krtv17YAeHABZcvz\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECjCCAvKgAwIBAgICV2YwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTExOTM2\nMjBaFw0yNDA4MjIxNzA4NTBaMIGXMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEoMCYGA1UEAwwfQW1h\nem9uIFJEUyBldS1jZW50cmFsLTEgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQAD\nggEPADCCAQoCggEBAMEx54X2pHVv86APA0RWqxxRNmdkhAyp2R1cFWumKQRofoFv\nn+SPXdkpIINpMuEIGJANozdiEz7SPsrAf8WHyD93j/ZxrdQftRcIGH41xasetKGl\nI67uans8d+pgJgBKGb/Z+B5m+UsIuEVekpvgpwKtmmaLFC/NCGuSsJoFsRqoa6Gh\nm34W6yJoY87UatddCqLY4IIXaBFsgK9Q/wYzYLbnWM6ZZvhJ52VMtdhcdzeTHNW0\n5LGuXJOF7Ahb4JkEhoo6TS2c0NxB4l4MBfBPgti+O7WjR3FfZHpt18A6Zkq6A2u6\nD/oTSL6c9/3sAaFTFgMyL3wHb2YlW0BPiljZIqECAwEAAaNmMGQwDgYDVR0PAQH/\nBAQDAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFOcAToAc6skWffJa\nTnreaswAfrbcMB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqG\nSIb3DQEBCwUAA4IBAQA1d0Whc1QtspK496mFWfFEQNegLh0a9GWYlJm+Htcj5Nxt\nDAIGXb+8xrtOZFHmYP7VLCT5Zd2C+XytqseK/+s07iAr0/EPF+O2qcyQWMN5KhgE\ncXw2SwuP9FPV3i+YAm11PBVeenrmzuk9NrdHQ7TxU4v7VGhcsd2C++0EisrmquWH\nmgIfmVDGxphwoES52cY6t3fbnXmTkvENvR+h3rj+fUiSz0aSo+XZUGHPgvuEKM/W\nCBD9Smc9CBoBgvy7BgHRgRUmwtABZHFUIEjHI5rIr7ZvYn+6A0O6sogRfvVYtWFc\nqpyrW1YX8mD0VlJ8fGKM3G+aCOsiiPKDV/Uafrm+\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECDCCAvCgAwIBAgICGAcwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTIxODE5\nNDRaFw0yNDA4MjIxNzA4NTBaMIGVMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEmMCQGA1UEAwwdQW1h\nem9uIFJEUyBldS1ub3J0aC0xIDIwMTkgQ0EwggEiMA0GCSqGSIb3DQEBAQUAA4IB\nDwAwggEKAoIBAQCiIYnhe4UNBbdBb/nQxl5giM0XoVHWNrYV5nB0YukA98+TPn9v\nAoj1RGYmtryjhrf01Kuv8SWO+Eom95L3zquoTFcE2gmxCfk7bp6qJJ3eHOJB+QUO\nXsNRh76fwDzEF1yTeZWH49oeL2xO13EAx4PbZuZpZBttBM5zAxgZkqu4uWQczFEs\nJXfla7z2fvWmGcTagX10O5C18XaFroV0ubvSyIi75ue9ykg/nlFAeB7O0Wxae88e\nuhiBEFAuLYdqWnsg3459NfV8Yi1GnaitTym6VI3tHKIFiUvkSiy0DAlAGV2iiyJE\nq+DsVEO4/hSINJEtII4TMtysOsYPpINqeEzRAgMBAAGjZjBkMA4GA1UdDwEB/wQE\nAwIBBjASBgNVHRMBAf8ECDAGAQH/AgEAMB0GA1UdDgQWBBRR0UpnbQyjnHChgmOc\nhnlc0PogzTAfBgNVHSMEGDAWgBRzX2DYvMsDmPQrFzQuNlqmYP+8HzANBgkqhkiG\n9w0BAQsFAAOCAQEAKJD4xVzSf4zSGTBJrmamo86jl1NHQxXUApAZuBZEc8tqC6TI\nT5CeoSr9CMuVC8grYyBjXblC4OsM5NMvmsrXl/u5C9dEwtBFjo8mm53rOOIm1fxl\nI1oYB/9mtO9ANWjkykuLzWeBlqDT/i7ckaKwalhLODsRDO73vRhYNjsIUGloNsKe\npxw3dzHwAZx4upSdEVG4RGCZ1D0LJ4Gw40OfD69hfkDfRVVxKGrbEzqxXRvovmDc\ntKLdYZO/6REoca36v4BlgIs1CbUXJGLSXUwtg7YXGLSVBJ/U0+22iGJmBSNcoyUN\ncjPFD9JQEhDDIYYKSGzIYpvslvGc4T5ISXFiuQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBzCCAu+gAwIBAgICZIEwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTIyMTMy\nMzJaFw0yNDA4MjIxNzA4NTBaMIGUMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzElMCMGA1UEAwwcQW1h\nem9uIFJEUyBldS13ZXN0LTIgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEP\nADCCAQoCggEBALGiwqjiF7xIjT0Sx7zB3764K2T2a1DHnAxEOr+/EIftWKxWzT3u\nPFwS2eEZcnKqSdRQ+vRzonLBeNLO4z8aLjQnNbkizZMBuXGm4BqRm1Kgq3nlLDQn\n7YqdijOq54SpShvR/8zsO4sgMDMmHIYAJJOJqBdaus2smRt0NobIKc0liy7759KB\n6kmQ47Gg+kfIwxrQA5zlvPLeQImxSoPi9LdbRoKvu7Iot7SOa+jGhVBh3VdqndJX\n7tm/saj4NE375csmMETFLAOXjat7zViMRwVorX4V6AzEg1vkzxXpA9N7qywWIT5Y\nfYaq5M8i6vvLg0CzrH9fHORtnkdjdu1y+0MCAwEAAaNmMGQwDgYDVR0PAQH/BAQD\nAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFFOhOx1yt3Z7mvGB9jBv\n2ymdZwiOMB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqGSIb3\nDQEBCwUAA4IBAQBehqY36UGDvPVU9+vtaYGr38dBbp+LzkjZzHwKT1XJSSUc2wqM\nhnCIQKilonrTIvP1vmkQi8qHPvDRtBZKqvz/AErW/ZwQdZzqYNFd+BmOXaeZWV0Q\noHtDzXmcwtP8aUQpxN0e1xkWb1E80qoy+0uuRqb/50b/R4Q5qqSfJhkn6z8nwB10\n7RjLtJPrK8igxdpr3tGUzfAOyiPrIDncY7UJaL84GFp7WWAkH0WG3H8Y8DRcRXOU\nmqDxDLUP3rNuow3jnGxiUY+gGX5OqaZg4f4P6QzOSmeQYs6nLpH0PiN00+oS1BbD\nbpWdZEttILPI+vAYkU4QuBKKDjJL6HbSd+cn\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECDCCAvCgAwIBAgIDAIVCMA0GCSqGSIb3DQEBCwUAMIGPMQswCQYDVQQGEwJV\nUzEQMA4GA1UEBwwHU2VhdHRsZTETMBEGA1UECAwKV2FzaGluZ3RvbjEiMCAGA1UE\nCgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJE\nUzEgMB4GA1UEAwwXQW1hem9uIFJEUyBSb290IDIwMTkgQ0EwHhcNMTkwOTEzMTcw\nNjQxWhcNMjQwODIyMTcwODUwWjCBlDELMAkGA1UEBhMCVVMxEzARBgNVBAgMCldh\nc2hpbmd0b24xEDAOBgNVBAcMB1NlYXR0bGUxIjAgBgNVBAoMGUFtYXpvbiBXZWIg\nU2VydmljZXMsIEluYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxJTAjBgNVBAMMHEFt\nYXpvbiBSRFMgdXMtZWFzdC0yIDIwMTkgQ0EwggEiMA0GCSqGSIb3DQEBAQUAA4IB\nDwAwggEKAoIBAQDE+T2xYjUbxOp+pv+gRA3FO24+1zCWgXTDF1DHrh1lsPg5k7ht\n2KPYzNc+Vg4E+jgPiW0BQnA6jStX5EqVh8BU60zELlxMNvpg4KumniMCZ3krtMUC\nau1NF9rM7HBh+O+DYMBLK5eSIVt6lZosOb7bCi3V6wMLA8YqWSWqabkxwN4w0vXI\n8lu5uXXFRemHnlNf+yA/4YtN4uaAyd0ami9+klwdkZfkrDOaiy59haOeBGL8EB/c\ndbJJlguHH5CpCscs3RKtOOjEonXnKXldxarFdkMzi+aIIjQ8GyUOSAXHtQHb3gZ4\nnS6Ey0CMlwkB8vUObZU9fnjKJcL5QCQqOfwvAgMBAAGjZjBkMA4GA1UdDwEB/wQE\nAwIBBjASBgNVHRMBAf8ECDAGAQH/AgEAMB0GA1UdDgQWBBQUPuRHohPxx4VjykmH\n6usGrLL1ETAfBgNVHSMEGDAWgBRzX2DYvMsDmPQrFzQuNlqmYP+8HzANBgkqhkiG\n9w0BAQsFAAOCAQEAUdR9Vb3y33Yj6X6KGtuthZ08SwjImVQPtknzpajNE5jOJAh8\nquvQnU9nlnMO85fVDU1Dz3lLHGJ/YG1pt1Cqq2QQ200JcWCvBRgdvH6MjHoDQpqZ\nHvQ3vLgOGqCLNQKFuet9BdpsHzsctKvCVaeBqbGpeCtt3Hh/26tgx0rorPLw90A2\nV8QSkZJjlcKkLa58N5CMM8Xz8KLWg3MZeT4DmlUXVCukqK2RGuP2L+aME8dOxqNv\nOnOz1zrL5mR2iJoDpk8+VE/eBDmJX40IJk6jBjWoxAO/RXq+vBozuF5YHN1ujE92\ntO8HItgTp37XT8bJBAiAnt5mxw+NLSqtxk2QdQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEDDCCAvSgAwIBAgICY4kwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTMyMDEx\nNDJaFw0yNDA4MjIxNzA4NTBaMIGZMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEqMCgGA1UEAwwhQW1h\nem9uIFJEUyBhcC1zb3V0aGVhc3QtMSAyMDE5IENBMIIBIjANBgkqhkiG9w0BAQEF\nAAOCAQ8AMIIBCgKCAQEAr5u9OuLL/OF/fBNUX2kINJLzFl4DnmrhnLuSeSnBPgbb\nqddjf5EFFJBfv7IYiIWEFPDbDG5hoBwgMup5bZDbas+ZTJTotnnxVJTQ6wlhTmns\neHECcg2pqGIKGrxZfbQhlj08/4nNAPvyYCTS0bEcmQ1emuDPyvJBYDDLDU6AbCB5\n6Z7YKFQPTiCBblvvNzchjLWF9IpkqiTsPHiEt21sAdABxj9ityStV3ja/W9BfgxH\nwzABSTAQT6FbDwmQMo7dcFOPRX+hewQSic2Rn1XYjmNYzgEHisdUsH7eeXREAcTw\n61TRvaLH8AiOWBnTEJXPAe6wYfrcSd1pD0MXpoB62wIDAQABo2YwZDAOBgNVHQ8B\nAf8EBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQUytwMiomQOgX5\nIchd+2lDWRUhkikwHwYDVR0jBBgwFoAUc19g2LzLA5j0Kxc0LjZapmD/vB8wDQYJ\nKoZIhvcNAQELBQADggEBACf6lRDpfCD7BFRqiWM45hqIzffIaysmVfr+Jr+fBTjP\nuYe/ba1omSrNGG23bOcT9LJ8hkQJ9d+FxUwYyICQNWOy6ejicm4z0C3VhphbTPqj\nyjpt9nG56IAcV8BcRJh4o/2IfLNzC/dVuYJV8wj7XzwlvjysenwdrJCoLadkTr1h\neIdG6Le07sB9IxrGJL9e04afk37h7c8ESGSE4E+oS4JQEi3ATq8ne1B9DQ9SasXi\nIRmhNAaISDzOPdyLXi9N9V9Lwe/DHcja7hgLGYx3UqfjhLhOKwp8HtoZORixAmOI\nHfILgNmwyugAbuZoCazSKKBhQ0wgO0WZ66ZKTMG8Oho=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBzCCAu+gAwIBAgICUYkwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTYxODIx\nMTVaFw0yNDA4MjIxNzA4NTBaMIGUMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzElMCMGA1UEAwwcQW1h\nem9uIFJEUyB1cy13ZXN0LTIgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEP\nADCCAQoCggEBANCEZBZyu6yJQFZBJmSUZfSZd3Ui2gitczMKC4FLr0QzkbxY+cLa\nuVONIOrPt4Rwi+3h/UdnUg917xao3S53XDf1TDMFEYp4U8EFPXqCn/GXBIWlU86P\nPvBN+gzw3nS+aco7WXb+woTouvFVkk8FGU7J532llW8o/9ydQyDIMtdIkKTuMfho\nOiNHSaNc+QXQ32TgvM9A/6q7ksUoNXGCP8hDOkSZ/YOLiI5TcdLh/aWj00ziL5bj\npvytiMZkilnc9dLY9QhRNr0vGqL0xjmWdoEXz9/OwjmCihHqJq+20MJPsvFm7D6a\n2NKybR9U+ddrjb8/iyLOjURUZnj5O+2+OPcCAwEAAaNmMGQwDgYDVR0PAQH/BAQD\nAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFEBxMBdv81xuzqcK5TVu\npHj+Aor8MB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqGSIb3\nDQEBCwUAA4IBAQBZkfiVqGoJjBI37aTlLOSjLcjI75L5wBrwO39q+B4cwcmpj58P\n3sivv+jhYfAGEbQnGRzjuFoyPzWnZ1DesRExX+wrmHsLLQbF2kVjLZhEJMHF9eB7\nGZlTPdTzHErcnuXkwA/OqyXMpj9aghcQFuhCNguEfnROY9sAoK2PTfnTz9NJHL+Q\nUpDLEJEUfc0GZMVWYhahc0x38ZnSY2SKacIPECQrTI0KpqZv/P+ijCEcMD9xmYEb\njL4en+XKS1uJpw5fIU5Sj0MxhdGstH6S84iAE5J3GM3XHklGSFwwqPYvuTXvANH6\nuboynxRgSae59jIlAK6Jrr6GWMwQRbgcaAlW\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEDDCCAvSgAwIBAgICEkYwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTYxOTUz\nNDdaFw0yNDA4MjIxNzA4NTBaMIGZMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEqMCgGA1UEAwwhQW1h\nem9uIFJEUyBhcC1zb3V0aGVhc3QtMiAyMDE5IENBMIIBIjANBgkqhkiG9w0BAQEF\nAAOCAQ8AMIIBCgKCAQEAufodI2Flker8q7PXZG0P0vmFSlhQDw907A6eJuF/WeMo\nGHnll3b4S6nC3oRS3nGeRMHbyU2KKXDwXNb3Mheu+ox+n5eb/BJ17eoj9HbQR1cd\ngEkIciiAltf8gpMMQH4anP7TD+HNFlZnP7ii3geEJB2GGXSxgSWvUzH4etL67Zmn\nTpGDWQMB0T8lK2ziLCMF4XAC/8xDELN/buHCNuhDpxpPebhct0T+f6Arzsiswt2j\n7OeNeLLZwIZvVwAKF7zUFjC6m7/VmTQC8nidVY559D6l0UhhU0Co/txgq3HVsMOH\nPbxmQUwJEKAzQXoIi+4uZzHFZrvov/nDTNJUhC6DqwIDAQABo2YwZDAOBgNVHQ8B\nAf8EBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQUwaZpaCme+EiV\nM5gcjeHZSTgOn4owHwYDVR0jBBgwFoAUc19g2LzLA5j0Kxc0LjZapmD/vB8wDQYJ\nKoZIhvcNAQELBQADggEBAAR6a2meCZuXO2TF9bGqKGtZmaah4pH2ETcEVUjkvXVz\nsl+ZKbYjrun+VkcMGGKLUjS812e7eDF726ptoku9/PZZIxlJB0isC/0OyixI8N4M\nNsEyvp52XN9QundTjkl362bomPnHAApeU0mRbMDRR2JdT70u6yAzGLGsUwMkoNnw\n1VR4XKhXHYGWo7KMvFrZ1KcjWhubxLHxZWXRulPVtGmyWg/MvE6KF+2XMLhojhUL\n+9jB3Fpn53s6KMx5tVq1x8PukHmowcZuAF8k+W4gk8Y68wIwynrdZrKRyRv6CVtR\nFZ8DeJgoNZT3y/GT254VqMxxfuy2Ccb/RInd16tEvVk=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEDDCCAvSgAwIBAgICOYIwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTcyMDA1\nMjlaFw0yNDA4MjIxNzA4NTBaMIGZMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEqMCgGA1UEAwwhQW1h\nem9uIFJEUyBhcC1ub3J0aGVhc3QtMyAyMDE5IENBMIIBIjANBgkqhkiG9w0BAQEF\nAAOCAQ8AMIIBCgKCAQEA4dMak8W+XW8y/2F6nRiytFiA4XLwePadqWebGtlIgyCS\nkbug8Jv5w7nlMkuxOxoUeD4WhI6A9EkAn3r0REM/2f0aYnd2KPxeqS2MrtdxxHw1\nxoOxk2x0piNSlOz6yog1idsKR5Wurf94fvM9FdTrMYPPrDabbGqiBMsZZmoHLvA3\nZ+57HEV2tU0Ei3vWeGIqnNjIekS+E06KhASxrkNU5vi611UsnYZlSi0VtJsH4UGV\nLhnHl53aZL0YFO5mn/fzuNG/51qgk/6EFMMhaWInXX49Dia9FnnuWXwVwi6uX1Wn\n7kjoHi5VtmC8ZlGEHroxX2DxEr6bhJTEpcLMnoQMqwIDAQABo2YwZDAOBgNVHQ8B\nAf8EBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQUsUI5Cb3SWB8+\ngv1YLN/ABPMdxSAwHwYDVR0jBBgwFoAUc19g2LzLA5j0Kxc0LjZapmD/vB8wDQYJ\nKoZIhvcNAQELBQADggEBAJAF3E9PM1uzVL8YNdzb6fwJrxxqI2shvaMVmC1mXS+w\nG0zh4v2hBZOf91l1EO0rwFD7+fxoI6hzQfMxIczh875T6vUXePKVOCOKI5wCrDad\nzQbVqbFbdhsBjF4aUilOdtw2qjjs9JwPuB0VXN4/jY7m21oKEOcnpe36+7OiSPjN\nxngYewCXKrSRqoj3mw+0w/+exYj3Wsush7uFssX18av78G+ehKPIVDXptOCP/N7W\n8iKVNeQ2QGTnu2fzWsGUSvMGyM7yqT+h1ILaT//yQS8er511aHMLc142bD4D9VSy\nDgactwPDTShK/PXqhvNey9v/sKXm4XatZvwcc8KYlW4=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEDDCCAvSgAwIBAgICcEUwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTgxNjU2\nMjBaFw0yNDA4MjIxNzA4NTBaMIGZMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzEqMCgGA1UEAwwhQW1h\nem9uIFJEUyBhcC1ub3J0aGVhc3QtMSAyMDE5IENBMIIBIjANBgkqhkiG9w0BAQEF\nAAOCAQ8AMIIBCgKCAQEAndtkldmHtk4TVQAyqhAvtEHSMb6pLhyKrIFved1WO3S7\n+I+bWwv9b2W/ljJxLq9kdT43bhvzonNtI4a1LAohS6bqyirmk8sFfsWT3akb+4Sx\n1sjc8Ovc9eqIWJCrUiSvv7+cS7ZTA9AgM1PxvHcsqrcUXiK3Jd/Dax9jdZE1e15s\nBEhb2OEPE+tClFZ+soj8h8Pl2Clo5OAppEzYI4LmFKtp1X/BOf62k4jviXuCSst3\nUnRJzE/CXtjmN6oZySVWSe0rQYuyqRl6//9nK40cfGKyxVnimB8XrrcxUN743Vud\nQQVU0Esm8OVTX013mXWQXJHP2c0aKkog8LOga0vobQIDAQABo2YwZDAOBgNVHQ8B\nAf8EBAMCAQYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQULmoOS1mFSjj+\nsnUPx4DgS3SkLFYwHwYDVR0jBBgwFoAUc19g2LzLA5j0Kxc0LjZapmD/vB8wDQYJ\nKoZIhvcNAQELBQADggEBAAkVL2P1M2/G9GM3DANVAqYOwmX0Xk58YBHQu6iiQg4j\nb4Ky/qsZIsgT7YBsZA4AOcPKQFgGTWhe9pvhmXqoN3RYltN8Vn7TbUm/ZVDoMsrM\ngwv0+TKxW1/u7s8cXYfHPiTzVSJuOogHx99kBW6b2f99GbP7O1Sv3sLq4j6lVvBX\nFiacf5LAWC925nvlTzLlBgIc3O9xDtFeAGtZcEtxZJ4fnGXiqEnN4539+nqzIyYq\nnvlgCzyvcfRAxwltrJHuuRu6Maw5AGcd2Y0saMhqOVq9KYKFKuD/927BTrbd2JVf\n2sGWyuPZPCk3gq+5pCjbD0c6DkhcMGI6WwxvM5V/zSM=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBzCCAu+gAwIBAgICJDQwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTgxNzAz\nMTVaFw0yNDA4MjIxNzA4NTBaMIGUMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzElMCMGA1UEAwwcQW1h\nem9uIFJEUyBldS13ZXN0LTMgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEP\nADCCAQoCggEBAL9bL7KE0n02DLVtlZ2PL+g/BuHpMYFq2JnE2RgompGurDIZdjmh\n1pxfL3nT+QIVMubuAOy8InRfkRxfpxyjKYdfLJTPJG+jDVL+wDcPpACFVqoV7Prg\npVYEV0lc5aoYw4bSeYFhdzgim6F8iyjoPnObjll9mo4XsHzSoqJLCd0QC+VG9Fw2\nq+GDRZrLRmVM2oNGDRbGpGIFg77aRxRapFZa8SnUgs2AqzuzKiprVH5i0S0M6dWr\ni+kk5epmTtkiDHceX+dP/0R1NcnkCPoQ9TglyXyPdUdTPPRfKCq12dftqll+u4mV\nARdN6WFjovxax8EAP2OAUTi1afY+1JFMj+sCAwEAAaNmMGQwDgYDVR0PAQH/BAQD\nAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFLfhrbrO5exkCVgxW0x3\nY2mAi8lNMB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqGSIb3\nDQEBCwUAA4IBAQAigQ5VBNGyw+OZFXwxeJEAUYaXVoP/qrhTOJ6mCE2DXUVEoJeV\nSxScy/TlFA9tJXqmit8JH8VQ/xDL4ubBfeMFAIAo4WzNWDVoeVMqphVEcDWBHsI1\nAETWzfsapRS9yQekOMmxg63d/nV8xewIl8aNVTHdHYXMqhhik47VrmaVEok1UQb3\nO971RadLXIEbVd9tjY5bMEHm89JsZDnDEw1hQXBb67Elu64OOxoKaHBgUH8AZn/2\nzFsL1ynNUjOhCSAA15pgd1vjwc0YsBbAEBPcHBWYBEyME6NLNarjOzBl4FMtATSF\nwWCKRGkvqN8oxYhwR2jf2rR5Mu4DWkK5Q8Ep\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBzCCAu+gAwIBAgICJVUwDQYJKoZIhvcNAQELBQAwgY8xCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSAwHgYDVQQDDBdBbWF6b24gUkRTIFJvb3QgMjAxOSBDQTAeFw0xOTA5MTkxODE2\nNTNaFw0yNDA4MjIxNzA4NTBaMIGUMQswCQYDVQQGEwJVUzETMBEGA1UECAwKV2Fz\naGluZ3RvbjEQMA4GA1UEBwwHU2VhdHRsZTEiMCAGA1UECgwZQW1hem9uIFdlYiBT\nZXJ2aWNlcywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzElMCMGA1UEAwwcQW1h\nem9uIFJEUyB1cy1lYXN0LTEgMjAxOSBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEP\nADCCAQoCggEBAM3i/k2u6cqbMdcISGRvh+m+L0yaSIoOXjtpNEoIftAipTUYoMhL\nInXGlQBVA4shkekxp1N7HXe1Y/iMaPEyb3n+16pf3vdjKl7kaSkIhjdUz3oVUEYt\ni8Z/XeJJ9H2aEGuiZh3kHixQcZczn8cg3dA9aeeyLSEnTkl/npzLf//669Ammyhs\nXcAo58yvT0D4E0D/EEHf2N7HRX7j/TlyWvw/39SW0usiCrHPKDLxByLojxLdHzso\nQIp/S04m+eWn6rmD+uUiRteN1hI5ncQiA3wo4G37mHnUEKo6TtTUh+sd/ku6a8HK\nglMBcgqudDI90s1OpuIAWmuWpY//8xEG2YECAwEAAaNmMGQwDgYDVR0PAQH/BAQD\nAgEGMBIGA1UdEwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFPqhoWZcrVY9mU7tuemR\nRBnQIj1jMB8GA1UdIwQYMBaAFHNfYNi8ywOY9CsXNC42WqZg/7wfMA0GCSqGSIb3\nDQEBCwUAA4IBAQB6zOLZ+YINEs72heHIWlPZ8c6WY8MDU+Be5w1M+BK2kpcVhCUK\nPJO4nMXpgamEX8DIiaO7emsunwJzMSvavSPRnxXXTKIc0i/g1EbiDjnYX9d85DkC\nE1LaAUCmCZBVi9fIe0H2r9whIh4uLWZA41oMnJx/MOmo3XyMfQoWcqaSFlMqfZM4\n0rNoB/tdHLNuV4eIdaw2mlHxdWDtF4oH+HFm+2cVBUVC1jXKrFv/euRVtsTT+A6i\nh2XBHKxQ1Y4HgAn0jACP2QSPEmuoQEIa57bEKEcZsBR8SDY6ZdTd2HLRIApcCOSF\nMRM8CKLeF658I0XgF8D5EsYoKPsA+74Z+jDH\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEETCCAvmgAwIBAgICEAAwDQYJKoZIhvcNAQELBQAwgZQxCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSUwIwYDVQQDDBxBbWF6b24gUkRTIEJldGEgUm9vdCAyMDE5IENBMB4XDTE5MDgy\nMDE3MTAwN1oXDTI0MDgxOTE3MzgyNlowgZkxCzAJBgNVBAYTAlVTMRMwEQYDVQQI\nDApXYXNoaW5ndG9uMRAwDgYDVQQHDAdTZWF0dGxlMSIwIAYDVQQKDBlBbWF6b24g\nV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMSowKAYDVQQD\nDCFBbWF6b24gUkRTIEJldGEgdXMtZWFzdC0xIDIwMTkgQ0EwggEiMA0GCSqGSIb3\nDQEBAQUAA4IBDwAwggEKAoIBAQDTNCOlotQcLP8TP82U2+nk0bExVuuMVOgFeVMx\nvbUHZQeIj9ikjk+jm6eTDnnkhoZcmJiJgRy+5Jt69QcRbb3y3SAU7VoHgtraVbxF\nQDh7JEHI9tqEEVOA5OvRrDRcyeEYBoTDgh76ROco2lR+/9uCvGtHVrMCtG7BP7ZB\nsSVNAr1IIRZZqKLv2skKT/7mzZR2ivcw9UeBBTUf8xsfiYVBvMGoEsXEycjYdf6w\nWV+7XS7teNOc9UgsFNN+9AhIBc1jvee5E//72/4F8pAttAg/+mmPUyIKtekNJ4gj\nOAR2VAzGx1ybzWPwIgOudZFHXFduxvq4f1hIRPH0KbQ/gkRrAgMBAAGjZjBkMA4G\nA1UdDwEB/wQEAwIBBjASBgNVHRMBAf8ECDAGAQH/AgEAMB0GA1UdDgQWBBTkvpCD\n6C43rar9TtJoXr7q8dkrrjAfBgNVHSMEGDAWgBStoQwVpbGx87fxB3dEGDqKKnBT\n4TANBgkqhkiG9w0BAQsFAAOCAQEAJd9fOSkwB3uVdsS+puj6gCER8jqmhd3g/J5V\nZjk9cKS8H0e8pq/tMxeJ8kpurPAzUk5RkCspGt2l0BSwmf3ahr8aJRviMX6AuW3/\ng8aKplTvq/WMNGKLXONa3Sq8591J+ce8gtOX/1rDKmFI4wQ/gUzOSYiT991m7QKS\nFr6HMgFuz7RNJbb3Fy5cnurh8eYWA7mMv7laiLwTNsaro5qsqErD5uXuot6o9beT\na+GiKinEur35tNxAr47ax4IRubuIzyfCrezjfKc5raVV2NURJDyKP0m0CCaffAxE\nqn2dNfYc3v1D8ypg3XjHlOzRo32RB04o8ALHMD9LSwsYDLpMag==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEFzCCAv+gAwIBAgICFSUwDQYJKoZIhvcNAQELBQAwgZcxCzAJBgNVBAYTAlVT\nMRAwDgYDVQQHDAdTZWF0dGxlMRMwEQYDVQQIDApXYXNoaW5ndG9uMSIwIAYDVQQK\nDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRT\nMSgwJgYDVQQDDB9BbWF6b24gUkRTIFByZXZpZXcgUm9vdCAyMDE5IENBMB4XDTE5\nMDgyMTIyMzk0N1oXDTI0MDgyMTIyMjk0OVowgZwxCzAJBgNVBAYTAlVTMRMwEQYD\nVQQIDApXYXNoaW5ndG9uMRAwDgYDVQQHDAdTZWF0dGxlMSIwIAYDVQQKDBlBbWF6\nb24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMS0wKwYD\nVQQDDCRBbWF6b24gUkRTIFByZXZpZXcgdXMtZWFzdC0yIDIwMTkgQ0EwggEiMA0G\nCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQD0dB/U7qRnSf05wOi7m10Pa2uPMTJv\nr6U/3Y17a5prq5Zr4++CnSUYarG51YuIf355dKs+7Lpzs782PIwCmLpzAHKWzix6\npOaTQ+WZ0+vUMTxyqgqWbsBgSCyP7pVBiyqnmLC/L4az9XnscrbAX4pNaoJxsuQe\nmzBo6yofjQaAzCX69DuqxFkVTRQnVy7LCFkVaZtjNAftnAHJjVgQw7lIhdGZp9q9\nIafRt2gteihYfpn+EAQ/t/E4MnhrYs4CPLfS7BaYXBycEKC5Muj1l4GijNNQ0Efo\nxG8LSZz7SNgUvfVwiNTaqfLP3AtEAWiqxyMyh3VO+1HpCjT7uNBFtmF3AgMBAAGj\nZjBkMA4GA1UdDwEB/wQEAwIBBjASBgNVHRMBAf8ECDAGAQH/AgEAMB0GA1UdDgQW\nBBQtinkdrj+0B2+qdXngV2tgHnPIujAfBgNVHSMEGDAWgBRp0xqULkNh/w2ZVzEI\no2RIY7O03TANBgkqhkiG9w0BAQsFAAOCAQEAtJdqbCxDeMc8VN1/RzCabw9BIL/z\n73Auh8eFTww/sup26yn8NWUkfbckeDYr1BrXa+rPyLfHpg06kwR8rBKyrs5mHwJx\nbvOzXD/5WTdgreB+2Fb7mXNvWhenYuji1MF+q1R2DXV3I05zWHteKX6Dajmx+Uuq\nYq78oaCBSV48hMxWlp8fm40ANCL1+gzQ122xweMFN09FmNYFhwuW+Ao+Vv90ZfQG\nPYwTvN4n/gegw2TYcifGZC2PNX74q3DH03DXe5fvNgRW5plgz/7f+9mS+YHd5qa9\ntYTPUvoRbi169ou6jicsMKUKPORHWhiTpSCWR1FMMIbsAcsyrvtIsuaGCQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/jCCAuagAwIBAgIQdOCSuA9psBpQd8EI368/0DANBgkqhkiG9w0BAQsFADCB\nlzELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdB\nbWF6b24gUkRTIHNhLWVhc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjEwNTE5MTgwNjI2WhgPMjA2MTA1MTkxOTA2MjZaMIGXMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpv\nbiBSRFMgc2EtZWFzdC0xIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN6ftL6w8v3dB2yW\nLjCxSP1D7ZsOTeLZOSCz1Zv0Gkd0XLhil5MdHOHBvwH/DrXqFU2oGzCRuAy+aZis\nDardJU6ChyIQIciXCO37f0K23edhtpXuruTLLwUwzeEPdcnLPCX+sWEn9Y5FPnVm\npCd6J8edH2IfSGoa9LdErkpuESXdidLym/w0tWG/O2By4TabkNSmpdrCL00cqI+c\nprA8Bx1jX8/9sY0gpAovtuFaRN+Ivg3PAnWuhqiSYyQ5nC2qDparOWuDiOhpY56E\nEgmTvjwqMMjNtExfYx6Rv2Ndu50TriiNKEZBzEtkekwXInTupmYTvc7U83P/959V\nUiQ+WSMCAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQU4uYHdH0+\nbUeh81Eq2l5/RJbW+vswDgYDVR0PAQH/BAQDAgGGMA0GCSqGSIb3DQEBCwUAA4IB\nAQBhxcExJ+w74bvDknrPZDRgTeMLYgbVJjx2ExH7/Ac5FZZWcpUpFwWMIJJxtewI\nAnhryzM3tQYYd4CG9O+Iu0+h/VVfW7e4O3joWVkxNMb820kQSEwvZfA78aItGwOY\nWSaFNVRyloVicZRNJSyb1UL9EiJ9ldhxm4LTT0ax+4ontI7zTx6n6h8Sr6r/UOvX\nd9T5aUUENWeo6M9jGupHNn3BobtL7BZm2oS8wX8IVYj4tl0q5T89zDi2x0MxbsIV\n5ZjwqBQ5JWKv7ASGPb+z286RjPA9R2knF4lJVZrYuNV90rHvI/ECyt/JrDqeljGL\nBLl1W/UsvZo6ldLIpoMbbrb5\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBDCCAuygAwIBAgIQUfVbqapkLYpUqcLajpTJWzANBgkqhkiG9w0BAQsFADCB\nmjELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTMwMQYDVQQDDCpB\nbWF6b24gUkRTIG1lLWNlbnRyYWwtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNV\nBAcMB1NlYXR0bGUwIBcNMjIwNTA2MjMyMDA5WhgPMjA2MjA1MDcwMDIwMDlaMIGa\nMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5j\nLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMzAxBgNVBAMMKkFt\nYXpvbiBSRFMgbWUtY2VudHJhbC0xIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJIeovu3\newI9FVitXMQzvkh34aQ6WyI4NO3YepfJaePiv3cnyFGYHN2S1cR3UQcLWgypP5va\nj6bfroqwGbCbZZcb+6cyOB4ceKO9Ws1UkcaGHnNDcy5gXR7aCW2OGTUfinUuhd2d\n5bOGgV7JsPbpw0bwJ156+MwfOK40OLCWVbzy8B1kITs4RUPNa/ZJnvIbiMu9rdj4\n8y7GSFJLnKCjlOFUkNI5LcaYvI1+ybuNgphT3nuu5ZirvTswGakGUT/Q0J3dxP0J\npDfg5Sj/2G4gXiaM0LppVOoU5yEwVewhQ250l0eQAqSrwPqAkdTg9ng360zqCFPE\nJPPcgI1tdGUgneECAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQU\n/2AJVxWdZxc8eJgdpbwpW7b0f7IwDgYDVR0PAQH/BAQDAgGGMA0GCSqGSIb3DQEB\nCwUAA4IBAQBYm63jTu2qYKJ94gKnqc+oUgqmb1mTXmgmp/lXDbxonjszJDOXFbri\n3CCO7xB2sg9bd5YWY8sGKHaWmENj3FZpCmoefbUx++8D7Mny95Cz8R32rNcwsPTl\nebpd9A/Oaw5ug6M0x/cNr0qzF8Wk9Dx+nFEimp8RYQdKvLDfNFZHjPa1itnTiD8M\nTorAqj+VwnUGHOYBsT/0NY12tnwXdD+ATWfpEHdOXV+kTMqFFwDyhfgRVNpTc+os\nygr8SwhnSCpJPB/EYl2S7r+tgAbJOkuwUvGT4pTqrzDQEhwE7swgepnHC87zhf6l\nqN6mVpSnQKQLm6Ob5TeCEFgcyElsF5bH\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjSgAwIBAgIRAOxu0I1QuMAhIeszB3fJIlkwCgYIKoZIzj0EAwMwgZYx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1h\nem9uIFJEUyB1cy13ZXN0LTIgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTI0MjIwNjU5WhgPMjEyMTA1MjQyMzA2NTlaMIGWMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExLzAtBgNVBAMMJkFtYXpvbiBS\nRFMgdXMtd2VzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdTZWF0dGxl\nMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEz4bylRcGqqDWdP7gQIIoTHdBK6FNtKH1\n4SkEIXRXkYDmRvL9Bci1MuGrwuvrka5TDj4b7e+csY0llEzHpKfq6nJPFljoYYP9\nuqHFkv77nOpJJ633KOr8IxmeHW5RXgrZo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0G\nA1UdDgQWBBQQikVz8wmjd9eDFRXzBIU8OseiGzAOBgNVHQ8BAf8EBAMCAYYwCgYI\nKoZIzj0EAwMDaAAwZQIwf06Mcrpw1O0EBLBBrp84m37NYtOkE/0Z0O+C7D41wnXi\nEQdn6PXUVgdD23Gj82SrAjEAklhKs+liO1PtN15yeZR1Io98nFve+lLptaLakZcH\n+hfFuUtCqMbaI8CdvJlKnPqT\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nl9Se1Hsq0ZU5f+OZKQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\n5zT5+Bs=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nHing\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgIRANxgyBbnxgTEOpDul2ZnC0UwDQYJKoZIhvcNAQELBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1zb3V0aGVhc3QtMyBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNjEwMTgxOTA3WhgPMjA2MTA2MTAxOTE5MDda\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtc291dGhlYXN0LTMgUm9vdCBDQSBSU0EyMDQ4IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA\nxnwSDAChrMkfk5TA4Dk8hKzStDlSlONzmd3fTG0Wqr5+x3EmFT6Ksiu/WIwEl9J2\nK98UI7vYyuZfCxUKb1iMPeBdVGqk0zb92GpURd+Iz/+K1ps9ZLeGBkzR8mBmAi1S\nOfpwKiTBzIv6E8twhEn4IUpHsdcuX/2Y78uESpJyM8O5CpkG0JaV9FNEbDkJeBUQ\nAo2qqNcH4R0Qcr5pyeqA9Zto1RswgL06BQMI9dTpfwSP5VvkvcNUaLl7Zv5WzLQE\nJzORWePvdPzzvWEkY/3FPjxBypuYwssKaERW0fkPDmPtykktP9W/oJolKUFI6pXp\ny+Y6p6/AVdnQD2zZjW5FhQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1Ud\nDgQWBBT+jEKs96LC+/X4BZkUYUkzPfXdqTAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZI\nhvcNAQELBQADggEBAIGQqgqcQ6XSGkmNebzR6DhadTbfDmbYeN5N0Vuzv+Tdmufb\ntMGjdjnYMg4B+IVnTKQb+Ox3pL9gbX6KglGK8HupobmIRtwKVth+gYYz3m0SL/Nk\nhaWPYzOm0x3tJm8jSdufJcEob4/ATce9JwseLl76pSWdl5A4lLjnhPPKudUDfH+1\nBLNUi3lxpp6GkC8aWUPtupnhZuXddolTLOuA3GwTZySI44NfaFRm+o83N1jp+EwD\n6e94M4cTRzjUv6J3MZmSbdtQP/Tk1uz2K4bQZGP0PZC3bVpqiesdE/xr+wbu8uHr\ncM1JXH0AmXf1yIkTgyWzmvt0k1/vgcw5ixAqvvE=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEATCCAumgAwIBAgIRAMhw98EQU18mIji+unM2YH8wDQYJKoZIhvcNAQELBQAw\ngZgxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTExMC8GA1UEAwwo\nQW1hem9uIFJEUyBhcC1zb3V0aC0yIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTAgFw0yMjA2MDYyMTQyMjJaGA8yMDYyMDYwNjIyNDIyMlowgZgx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTExMC8GA1UEAwwoQW1h\nem9uIFJEUyBhcC1zb3V0aC0yIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UEBwwH\nU2VhdHRsZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAIeeRoLfTm+7\nvqm7ZlFSx+1/CGYHyYrOOryM4/Z3dqYVHFMgWTR7V3ziO8RZ6yUanrRcWVX3PZbF\nAfX0KFE8OgLsXEZIX8odSrq86+/Th5eZOchB2fDBsUB7GuN2rvFBbM8lTI9ivVOU\nlbuTnYyb55nOXN7TpmH2bK+z5c1y9RVC5iQsNAl6IJNvSN8VCqXh31eK5MlKB4DT\n+Y3OivCrSGsjM+UR59uZmwuFB1h+icE+U0p9Ct3Mjq3MzSX5tQb6ElTNGlfmyGpW\nKh7GQ5XU1KaKNZXoJ37H53woNSlq56bpVrKI4uv7ATpdpFubOnSLtpsKlpLdR3sy\nWs245200pC8CAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUp0ki\n6+eWvsnBjQhMxwMW5pwn7DgwDgYDVR0PAQH/BAQDAgGGMA0GCSqGSIb3DQEBCwUA\nA4IBAQB2V8lv0aqbYQpj/bmVv/83QfE4vOxKCJAHv7DQ35cJsTyBdF+8pBczzi3t\n3VNL5IUgW6WkyuUOWnE0eqAFOUVj0yTS1jSAtfl3vOOzGJZmWBbqm9BKEdu1D8O6\nsB8bnomwiab2tNDHPmUslpdDqdabbkWwNWzLJ97oGFZ7KNODMEPXWKWNxg33iHfS\n/nlmnrTVI3XgaNK9qLZiUrxu9Yz5gxi/1K+sG9/Dajd32ZxjRwDipOLiZbiXQrsd\nqzIMY4GcWf3g1gHL5mCTfk7dG22h/rhPyGV0svaDnsb+hOt6sv1McMN6Y3Ou0mtM\n/UaAXojREmJmTSCNvs2aBny3/2sy\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjSgAwIBAgIRAMnRxsKLYscJV8Qv5pWbL7swCgYIKoZIzj0EAwMwgZYx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1h\nem9uIFJEUyBzYS1lYXN0LTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTE5MTgxNjAxWhgPMjEyMTA1MTkxOTE2MDFaMIGWMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExLzAtBgNVBAMMJkFtYXpvbiBS\nRFMgc2EtZWFzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdTZWF0dGxl\nMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEjFOCZgTNVKxLKhUxffiDEvTLFhrmIqdO\ndKqVdgDoELEzIHWDdC+19aDPitbCYtBVHl65ITu/9pn6mMUl5hhUNtfZuc6A+Iw1\nsBe0v0qI3y9Q9HdQYrGgeHDh8M5P7E2ho0IwQDAPBgNVHRMBAf8EBTADAQH/MB0G\nA1UdDgQWBBS5L7/8M0TzoBZk39Ps7BkfTB4yJTAOBgNVHQ8BAf8EBAMCAYYwCgYI\nKoZIzj0EAwMDaAAwZQIwI43O0NtWKTgnVv9z0LO5UMZYgSve7GvGTwqktZYCMObE\nrUI4QerXM9D6JwLy09mqAjEAypfkdLyVWtaElVDUyHFkihAS1I1oUxaaDrynLNQK\nOu/Ay+ns+J+GyvyDUjBpVVW1\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nzDY=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgIRAK5EYG3iHserxMqgg+0EFjgwDQYJKoZIhvcNAQELBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1ub3J0aGVhc3QtMyBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTI0MjAyMzE2WhgPMjA2MTA1MjQyMTIzMTZa\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtbm9ydGhlYXN0LTMgUm9vdCBDQSBSU0EyMDQ4IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA\ns1L6TtB84LGraLHVC+rGPhLBW2P0oN/91Rq3AnYwqDOuTom7agANwEjvLq7dSRG/\nsIfZsSV/ABTgArZ5sCmLjHFZAo8Kd45yA9byx20RcYtAG8IZl+q1Cri+s0XefzyO\nU6mlfXZkVe6lzjlfXBkrlE/+5ifVbJK4dqOS1t9cWIpgKqv5fbE6Qbq4LVT+5/WM\nVd2BOljuBMGMzdZubqFKFq4mzTuIYfnBm7SmHlZfTdfBYPP1ScNuhpjuzw4n3NCR\nEdU6dQv04Q6th4r7eiOCwbWI9LkmVbvBe3ylhH63lApC7MiiPYLlB13xBubVHVhV\nq1NHoNTi+zA3MN9HWicRxQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1Ud\nDgQWBBSuxoqm0/wjNiZLvqv+JlQwsDvTPDAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZI\nhvcNAQELBQADggEBAFfTK/j5kv90uIbM8VaFdVbr/6weKTwehafT0pAk1bfLVX+7\nuf8oHgYiyKTTl0DFQicXejghXTeyzwoEkWSR8c6XkhD5vYG3oESqmt/RGvvoxz11\nrHHy7yHYu7RIUc3VQG60c4qxXv/1mWySGwVwJrnuyNT9KZXPevu3jVaWOVHEILaK\nHvzQ2YEcWBPmde/zEseO2QeeGF8FL45Q1d66wqIP4nNUd2pCjeTS5SpB0MMx7yi9\nki1OH1pv8tOuIdimtZ7wkdB8+JSZoaJ81b8sRrydRwJyvB88rftuI3YB4WwGuONT\nZezUPsmaoK69B0RChB0ofDpAaviF9V3xOWvVZfo=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\n1axqeKpI0F5SBUPsaVNYY2uNFg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECDCCAvCgAwIBAgIQCREfzzVyDTMcNME+gWnTCTANBgkqhkiG9w0BAQsFADCB\nnDELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTUwMwYDVQQDDCxB\nbWF6b24gUkRTIGFwLXNvdXRoZWFzdC0yIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4G\nA1UEBwwHU2VhdHRsZTAgFw0yMTA1MjQyMDQyMzNaGA8yMDYxMDUyNDIxNDIzM1ow\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1zb3V0aGVhc3QtMiBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQDL\n1MT6br3L/4Pq87DPXtcjlXN3cnbNk2YqRAZHJayStTz8VtsFcGPJOpk14geRVeVk\ne9uKFHRbcyr/RM4owrJTj5X4qcEuATYZbo6ou/rW2kYzuWFZpFp7lqm0vasV4Z9F\nfChlhwkNks0UbM3G+psCSMNSoF19ERunj7w2c4E62LwujkeYLvKGNepjnaH10TJL\n2krpERd+ZQ4jIpObtRcMH++bTrvklc+ei8W9lqrVOJL+89v2piN3Ecdd389uphst\nqQdb1BBVXbhUrtuGHgVf7zKqN1SkCoktoWxVuOprVWhSvr7akaWeq0UmlvbEsujU\nvADqxGMcJFyCzxx3CkJjAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0O\nBBYEFFk8UJmlhoxFT3PP12PvhvazHjT4MA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG\n9w0BAQsFAAOCAQEAfFtr2lGoWVXmWAsIo2NYre7kzL8Xb9Tx7desKxCCz5HOOvIr\n8JMB1YK6A7IOvQsLJQ/f1UnKRh3X3mJZjKIywfrMSh0FiDf+rjcEzXxw2dGtUem4\nA+WMvIA3jwxnJ90OQj5rQ8bg3iPtE6eojzo9vWQGw/Vu48Dtw1DJo9210Lq/6hze\nhPhNkFh8fMXNT7Q1Wz/TJqJElyAQGNOXhyGpHKeb0jHMMhsy5UNoW5hLeMS5ffao\nTBFWEJ1gVfxIU9QRxSh+62m46JIg+dwDlWv8Aww14KgepspRbMqDuaM2cinoejv6\nt3dyOyHHrsOyv3ffZUKtQhQbQr+sUcL89lARsg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/zCCAuegAwIBAgIRAIJLTMpzGNxqHZ4t+c1MlCIwDQYJKoZIhvcNAQELBQAw\ngZcxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEwMC4GA1UEAwwn\nQW1hem9uIFJEUyBhcC1lYXN0LTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyNTIxMzAzM1oYDzIwNjEwNTI1MjIzMDMzWjCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGFwLWVhc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQDtdHut0ZhJ9Nn2\nMpVafFcwHdoEzx06okmmhjJsNy4l9QYVeh0UUoek0SufRNMRF4d5ibzpgZol0Y92\n/qKWNe0jNxhEj6sXyHsHPeYtNBPuDMzThfbvsLK8z7pBP7vVyGPGuppqW/6m4ZBB\nlcc9fsf7xpZ689iSgoyjiT6J5wlVgmCx8hFYc/uvcRtfd8jAHvheug7QJ3zZmIye\nV4htOW+fRVWnBjf40Q+7uTv790UAqs0Zboj4Yil+hER0ibG62y1g71XcCyvcVpto\n2/XW7Y9NCgMNqQ7fGN3wR1gjtSYPd7DO32LTzYhutyvfbpAZjsAHnoObmoljcgXI\nQjfBcCFpAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFJI3aWLg\nCS5xqU5WYVaeT5s8lpO0MA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG9w0BAQsFAAOC\nAQEAUwATpJOcGVOs3hZAgJwznWOoTzOVJKfrqBum7lvkVH1vBwxBl9CahaKj3ZOt\nYYp2qJzhDUWludL164DL4ZjS6eRedLRviyy5cRy0581l1MxPWTThs27z+lCC14RL\nPJZNVYYdl7Jy9Q5NsQ0RBINUKYlRY6OqGDySWyuMPgno2GPbE8aynMdKP+f6G/uE\nYHOf08gFDqTsbyfa70ztgVEJaRooVf5JJq4UQtpDvVswW2reT96qi6tXPKHN5qp3\n3wI0I1Mp4ePmiBKku2dwYzPfrJK/pQlvu0Gu5lKOQ65QdotwLAAoaFqrf9za1yYs\nINUkHLWIxDds+4OHNYcerGp5Dw==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIGCTCCA/GgAwIBAgIRAIO6ldra1KZvNWJ0TA1ihXEwDQYJKoZIhvcNAQEMBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1zb3V0aGVhc3QtMSBSb290IENBIFJTQTQwOTYgRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTIxMjE0NTA1WhgPMjEyMTA1MjEyMjQ1MDVa\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtc291dGhlYXN0LTEgUm9vdCBDQSBSU0E0MDk2IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIICIjANBgkqhkiG9w0BAQEFAAOCAg8AMIICCgKCAgEA\nsDN52Si9pFSyZ1ruh3xAN0nVqEs960o2IK5CPu/ZfshFmzAwnx/MM8EHt/jMeZtj\nSM58LADAsNDL01ELpFZATjgZQ6xNAyXRXE7RiTRUvNkK7O3o2qAGbLnJq/UqF7Sw\nLRnB8V6hYOv+2EjVnohtGCn9SUFGZtYDjWXsLd4ML4Zpxv0a5LK7oEC7AHzbUR7R\njsjkrXqSv7GE7bvhSOhMkmgxgj1F3J0b0jdQdtyyj109aO0ATUmIvf+Bzadg5AI2\nA9UA+TUcGeebhpHu8AP1Hf56XIlzPpaQv3ZJ4vzoLaVNUC7XKzAl1dlvCl7Klg/C\n84qmbD/tjZ6GHtzpLKgg7kQEV7mRoXq8X4wDX2AFPPQl2fv+Kbe+JODqm5ZjGegm\nuskABBi8IFv1hYx9jEulZPxC6uD/09W2+niFm3pirnlWS83BwVDTUBzF+CooUIMT\njhWkIIZGDDgMJTzouBHfoSJtS1KpUZi99m2WyVs21MNKHeWAbs+zmI6TO5iiMC+T\nuB8spaOiHFO1573Fmeer4sy3YA6qVoqVl6jjTQqOdy3frAMbCkwH22/crV8YA+08\nhLeHXrMK+6XUvU+EtHAM3VzcrLbuYJUI2XJbzTj5g0Eb8I8JWsHvWHR5K7Z7gceR\n78AzxQmoGEfV6KABNWKsgoCQnfb1BidDJIe3BsI0A6UCAwEAAaNCMEAwDwYDVR0T\nAQH/BAUwAwEB/zAdBgNVHQ4EFgQUABp0MlB14MSHgAcuNSOhs3MOlUcwDgYDVR0P\nAQH/BAQDAgGGMA0GCSqGSIb3DQEBDAUAA4ICAQCv4CIOBSQi/QR9NxdRgVAG/pAh\ntFJhV7OWb/wqwsNKFDtg6tTxwaahdCfWpGWId15OUe7G9LoPiKiwM9C92n0ZeHRz\n4ewbrQVo7Eu1JI1wf0rnZJISL72hVYKmlvaWaacHhWxvsbKLrB7vt6Cknxa+S993\nKf8i2Psw8j5886gaxhiUtzMTBwoDWak8ZaK7m3Y6C6hXQk08+3pnIornVSFJ9dlS\nPAqt5UPwWmrEfF+0uIDORlT+cvrAwgSp7nUF1q8iasledycZ/BxFgQqzNwnkBDwQ\nZ/aM52ArGsTzfMhkZRz9HIEhz1/0mJw8gZtDVQroD8778h8zsx2SrIz7eWQ6uWsD\nQEeSWXpcheiUtEfzkDImjr2DLbwbA23c9LoexUD10nwohhoiQQg77LmvBVxeu7WU\nE63JqaYUlOLOzEmNJp85zekIgR8UTkO7Gc+5BD7P4noYscI7pPOL5rP7YLg15ZFi\nega+G53NTckRXz4metsd8XFWloDjZJJq4FfD60VuxgXzoMNT9wpFTNSH42PR2s9L\nI1vcl3w8yNccs9se2utM2nLsItZ3J0m/+QSRiw9hbrTYTcM9sXki0DtH2kyIOwYf\nlOrGJDiYOIrXSQK36H0gQ+8omlrUTvUj4msvkXuQjlfgx6sgp2duOAfnGxE7uHnc\nUhnJzzoe6M+LfGHkVQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICuDCCAj2gAwIBAgIQSAG6j2WHtWUUuLGJTPb1nTAKBggqhkjOPQQDAzCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLW5vcnRoZWFzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyMDE2MzgyNloYDzIxMjEwNTIwMTczODI2WjCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLW5vcnRoZWFzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAE2eqwU4FOzW8RV1W381Bd\nolhDOrqoMqzWli21oDUt7y8OnXM/lmAuOS6sr8Nt61BLVbONdbr+jgCYw75KabrK\nZGg3siqvMOgabIKkKuXO14wtrGyGDt7dnKXg5ERGYOZlo0IwQDAPBgNVHRMBAf8E\nBTADAQH/MB0GA1UdDgQWBBS1Acp2WYxOcblv5ikZ3ZIbRCCW+zAOBgNVHQ8BAf8E\nBAMCAYYwCgYIKoZIzj0EAwMDaQAwZgIxAJL84J08PBprxmsAKPTotBuVI3MyW1r8\nxQ0i8lgCQUf8GcmYjQ0jI4oZyv+TuYJAcwIxAP9Xpzq0Docxb+4N1qVhpiOfWt1O\nFnemFiy9m1l+wv6p3riQMPV7mBVpklmijkIv3Q==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgIRALZLcqCVIJ25maDPE3sbPCIwDQYJKoZIhvcNAQELBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1zb3V0aGVhc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTIxMjEzOTM5WhgPMjA2MTA1MjEyMjM5Mzla\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtc291dGhlYXN0LTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA\nypKc+6FfGx6Gl6fQ78WYS29QoKgQiur58oxR3zltWeg5fqh9Z85K5S3UbRSTqWWu\nXcfnkz0/FS07qHX+nWAGU27JiQb4YYqhjZNOAq8q0+ptFHJ6V7lyOqXBq5xOzO8f\n+0DlbJSsy7GEtJp7d7QCM3M5KVY9dENVZUKeJwa8PC5StvwPx4jcLeZRJC2rAVDG\nSW7NAInbATvr9ssSh03JqjXb+HDyywiqoQ7EVLtmtXWimX+0b3/2vhqcH5jgcKC9\nIGFydrjPbv4kwMrKnm6XlPZ9L0/3FMzanXPGd64LQVy51SI4d5Xymn0Mw2kMX8s6\nNf05OsWcDzJ1n6/Q1qHSxQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1Ud\nDgQWBBRmaIc8eNwGP7i6P7AJrNQuK6OpFzAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZI\nhvcNAQELBQADggEBAIBeHfGwz3S2zwIUIpqEEI5/sMySDeS+3nJR+woWAHeO0C8i\nBJdDh+kzzkP0JkWpr/4NWz84/IdYo1lqASd1Kopz9aT1+iROXaWr43CtbzjXb7/X\nZv7eZZFC8/lS5SROq42pPWl4ekbR0w8XGQElmHYcWS41LBfKeHCUwv83ATF0XQ6I\n4t+9YSqZHzj4vvedrvcRInzmwWJaal9s7Z6GuwTGmnMsN3LkhZ+/GD6oW3pU/Pyh\nEtWqffjsLhfcdCs3gG8x9BbkcJPH5aPAVkPn4wc8wuXg6xxb9YGsQuY930GWTYRf\nschbgjsuqznW4HHakq4WNhs1UdTSTKkRdZz7FUQ=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEDzCCAvegAwIBAgIRAM2zAbhyckaqRim63b+Tib8wDQYJKoZIhvcNAQELBQAw\ngZ8xCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE4MDYGA1UEAwwv\nQW1hem9uIFJEUyBQcmV2aWV3IHVzLWVhc3QtMiBSb290IENBIFJTQTIwNDggRzEx\nEDAOBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTE4MjA0OTQ1WhgPMjA2MTA1MTgyMTQ5\nNDVaMIGfMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNl\ncywgSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExODA2BgNV\nBAMML0FtYXpvbiBSRFMgUHJldmlldyB1cy1lYXN0LTIgUm9vdCBDQSBSU0EyMDQ4\nIEcxMRAwDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIB\nCgKCAQEA1ybjQMH1MkbvfKsWJaCTXeCSN1SG5UYid+Twe+TjuSqaXWonyp4WRR5z\ntlkqq+L2MWUeQQAX3S17ivo/t84mpZ3Rla0cx39SJtP3BiA2BwfUKRjhPwOjmk7j\n3zrcJjV5k1vSeLNOfFFSlwyDiVyLAE61lO6onBx+cRjelu0egMGq6WyFVidTdCmT\nQ9Zw3W6LTrnPvPmEyjHy2yCHzH3E50KSd/5k4MliV4QTujnxYexI2eR8F8YQC4m3\nDYjXt/MicbqA366SOoJA50JbgpuVv62+LSBu56FpzY12wubmDZsdn4lsfYKiWxUy\nuc83a2fRXsJZ1d3whxrl20VFtLFHFQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/\nMB0GA1UdDgQWBBRC0ytKmDYbfz0Bz0Psd4lRQV3aNTAOBgNVHQ8BAf8EBAMCAYYw\nDQYJKoZIhvcNAQELBQADggEBAGv8qZu4uaeoF6zsbumauz6ea6tdcWt+hGFuwGrb\ntRbI85ucAmVSX06x59DJClsb4MPhL1XmqO3RxVMIVVfRwRHWOsZQPnXm8OYQ2sny\nrYuFln1COOz1U/KflZjgJmxbn8x4lYiTPZRLarG0V/OsCmnLkQLPtEl/spMu8Un7\nr3K8SkbWN80gg17Q8EV5mnFwycUx9xsTAaFItuG0en9bGsMgMmy+ZsDmTRbL+lcX\nFq8r4LT4QjrFz0shrzCwuuM4GmcYtBSxlacl+HxYEtAs5k10tmzRf6OYlY33tGf6\n1tkYvKryxDPF/EDgGp/LiBwx6ixYMBfISoYASt4V/ylAlHA=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICtTCCAjqgAwIBAgIRAK9BSZU6nIe6jqfODmuVctYwCgYIKoZIzj0EAwMwgZkx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEyMDAGA1UEAwwpQW1h\nem9uIFJEUyBjYS1jZW50cmFsLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjEwNTIxMjIxMzA5WhgPMjEyMTA1MjEyMzEzMDlaMIGZMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMjAwBgNVBAMMKUFtYXpv\nbiBSRFMgY2EtY2VudHJhbC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEUkEERcgxneT5H+P+fERcbGmf\nbVx+M7rNWtgWUr6w+OBENebQA9ozTkeSg4c4M+qdYSObFqjxITdYxT1z/nHz1gyx\nOKAhLjWu+nkbRefqy3RwXaWT680uUaAP6ccnkZOMo0IwQDAPBgNVHRMBAf8EBTAD\nAQH/MB0GA1UdDgQWBBSN6fxlg0s5Wny08uRBYZcQ3TUoyzAOBgNVHQ8BAf8EBAMC\nAYYwCgYIKoZIzj0EAwMDaQAwZgIxAORaz+MBVoFBTmZ93j2G2vYTwA6T5hWzBWrx\nCrI54pKn5g6At56DBrkjrwZF5T1enAIxAJe/LZ9xpDkAdxDgGJFN8gZYLRWc0NRy\nRb4hihy5vj9L+w9uKc9VfEBIFuhT7Z3ljg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEADCCAuigAwIBAgIQB/57HSuaqUkLaasdjxUdPjANBgkqhkiG9w0BAQsFADCB\nmDELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChB\nbWF6b24gUkRTIGFwLXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUxOTE3NDAzNFoYDzIwNjEwNTE5MTg0MDM0WjCBmDEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChBbWF6\nb24gUkRTIGFwLXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAtbkaoVsUS76o\nTgLFmcnaB8cswBk1M3Bf4IVRcwWT3a1HeJSnaJUqWHCJ+u3ip/zGVOYl0gN1MgBb\nMuQRIJiB95zGVcIa6HZtx00VezDTr3jgGWRHmRjNVCCHGmxOZWvJjsIE1xavT/1j\nQYV/ph4EZEIZ/qPq7e3rHohJaHDe23Z7QM9kbyqp2hANG2JtU/iUhCxqgqUHNozV\nZd0l5K6KnltZQoBhhekKgyiHqdTrH8fWajYl5seD71bs0Axowb+Oh0rwmrws3Db2\nDh+oc2PwREnjHeca9/1C6J2vhY+V0LGaJmnnIuOANrslx2+bgMlyhf9j0Bv8AwSi\ndSWsobOhNQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBQb7vJT\nVciLN72yJGhaRKLn6Krn2TAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZIhvcNAQELBQAD\nggEBAAxEj8N9GslReAQnNOBpGl8SLgCMTejQ6AW/bapQvzxrZrfVOZOYwp/5oV0f\n9S1jcGysDM+DrmfUJNzWxq2Y586R94WtpH4UpJDGqZp+FuOVJL313te4609kopzO\nlDdmd+8z61+0Au93wB1rMiEfnIMkOEyt7D2eTFJfJRKNmnPrd8RjimRDlFgcLWJA\n3E8wca67Lz/G0eAeLhRHIXv429y8RRXDtKNNz0wA2RwURWIxyPjn1fHjA9SPDkeW\nE1Bq7gZj+tBnrqz+ra3yjZ2blss6Ds3/uRY6NYqseFTZWmQWT7FolZEnT9vMUitW\nI0VynUbShVpGf6946e0vgaaKw20=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/jCCAuagAwIBAgIQGyUVTaVjYJvWhroVEiHPpDANBgkqhkiG9w0BAQsFADCB\nlzELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdB\nbWF6b24gUkRTIHVzLXdlc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjEwNTE5MTkwNDA2WhgPMjA2MTA1MTkyMDA0MDZaMIGXMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpv\nbiBSRFMgdXMtd2VzdC0xIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBANhyXpJ0t4nigRDZ\nEwNtFOem1rM1k8k5XmziHKDvDk831p7QsX9ZOxl/BT59Pu/P+6W6SvasIyKls1sW\nFJIjFF+6xRQcpoE5L5evMgN/JXahpKGeQJPOX9UEXVW5B8yi+/dyUitFT7YK5LZA\nMqWBN/LtHVPa8UmE88RCDLiKkqiv229tmwZtWT7nlMTTCqiAHMFcryZHx0pf9VPh\nx/iPV8p2gBJnuPwcz7z1kRKNmJ8/cWaY+9w4q7AYlAMaq/rzEqDaN2XXevdpsYAK\nTMMj2kji4x1oZO50+VPNfBl5ZgJc92qz1ocF95SAwMfOUsP8AIRZkf0CILJYlgzk\n/6u6qZECAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUm5jfcS9o\n+LwL517HpB6hG+PmpBswDgYDVR0PAQH/BAQDAgGGMA0GCSqGSIb3DQEBCwUAA4IB\nAQAcQ6lsqxi63MtpGk9XK8mCxGRLCad51+MF6gcNz6i6PAqhPOoKCoFqdj4cEQTF\nF8dCfa3pvfJhxV6RIh+t5FCk/y6bWT8Ls/fYKVo6FhHj57bcemWsw/Z0XnROdVfK\nYqbc7zvjCPmwPHEqYBhjU34NcY4UF9yPmlLOL8uO1JKXa3CAR0htIoW4Pbmo6sA4\n6P0co/clW+3zzsQ92yUCjYmRNeSbdXbPfz3K/RtFfZ8jMtriRGuO7KNxp8MqrUho\nHK8O0mlSUxGXBZMNicfo7qY8FD21GIPH9w5fp5oiAl7lqFzt3E3sCLD3IiVJmxbf\nfUwpGd1XZBBSdIxysRLM6j48\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrTCCAjOgAwIBAgIQU+PAILXGkpoTcpF200VD/jAKBggqhkjOPQQDAzCBljEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMS8wLQYDVQQDDCZBbWF6\nb24gUkRTIGFwLWVhc3QtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTAgFw0yMTA1MjUyMTQ1MTFaGA8yMTIxMDUyNTIyNDUxMVowgZYxCzAJBgNV\nBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYD\nVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1hem9uIFJE\nUyBhcC1lYXN0LTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1NlYXR0bGUw\ndjAQBgcqhkjOPQIBBgUrgQQAIgNiAAT3tFKE8Kw1sGQAvNLlLhd8OcGhlc7MiW/s\nNXm3pOiCT4vZpawKvHBzD76Kcv+ZZzHRxQEmG1/muDzZGlKR32h8AAj+NNO2Wy3d\nCKTtYMiVF6Z2zjtuSkZQdjuQbe4eQ7qjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYD\nVR0OBBYEFAiSQOp16Vv0Ohpvqcbd2j5RmhYNMA4GA1UdDwEB/wQEAwIBhjAKBggq\nhkjOPQQDAwNoADBlAjBVsi+5Ape0kOhMt/WFkANkslD4qXA5uqhrfAtH29Xzz2NV\ntR7akiA771OaIGB/6xsCMQCZt2egCtbX7J0WkuZ2KivTh66jecJr5DHvAP4X2xtS\nF/5pS+AUhcKTEGjI9jDH3ew=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICuDCCAj2gAwIBAgIQT5mGlavQzFHsB7hV6Mmy6TAKBggqhkjOPQQDAzCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLXNvdXRoZWFzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyNDIwNTAxNVoYDzIxMjEwNTI0MjE1MDE1WjCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLXNvdXRoZWFzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEcm4BBBjYK7clwm0HJRWS\nflt3iYwoJbIXiXn9c1y3E+Vb7bmuyKhS4eO8mwO4GefUcXObRfoHY2TZLhMJLVBQ\n7MN2xDc0RtZNj07BbGD3VAIFRTDX0mH9UNYd0JQM3t/Oo0IwQDAPBgNVHRMBAf8E\nBTADAQH/MB0GA1UdDgQWBBRrd5ITedfAwrGo4FA9UaDaGFK3rjAOBgNVHQ8BAf8E\nBAMCAYYwCgYIKoZIzj0EAwMDaQAwZgIxAPBNqmVv1IIA3EZyQ6XuVf4gj79/DMO8\nbkicNS1EcBpUqbSuU4Zwt2BYc8c/t7KVOQIxAOHoWkoKZPiKyCxfMtJpCZySUG+n\nsXgB/LOyWE5BJcXUfm+T1ckeNoWeUUMOLmnJjg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgIRAJcDeinvdNrDQBeJ8+t38WQwDQYJKoZIhvcNAQELBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1zb3V0aGVhc3QtNCBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjIwNTI1MTY0OTE2WhgPMjA2MjA1MjUxNzQ5MTZa\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtc291dGhlYXN0LTQgUm9vdCBDQSBSU0EyMDQ4IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA\nk8DBNkr9tMoIM0NHoFiO7cQfSX0cOMhEuk/CHt0fFx95IBytx7GHCnNzpM27O5z6\nx6iRhfNnx+B6CrGyCzOjxvPizneY+h+9zfvNz9jj7L1I2uYMuiNyOKR6FkHR46CT\n1CiArfVLLPaTqgD/rQjS0GL2sLHS/0dmYipzynnZcs613XT0rAWdYDYgxDq7r/Yi\nXge5AkWQFkMUq3nOYDLCyGGfQqWKkwv6lZUHLCDKf+Y0Uvsrj8YGCI1O8mF0qPCQ\nlmlfaDvbuBu1AV+aabmkvyFj3b8KRIlNLEtQ4N8KGYR2Jdb82S4YUGIOAt4wuuFt\n1B7AUDLk3V/u+HTWiwfoLQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1Ud\nDgQWBBSNpcjz6ArWBtAA+Gz6kyyZxrrgdDAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZI\nhvcNAQELBQADggEBAGJEd7UgOzHYIcQRSF7nSYyjLROyalaIV9AX4WXW/Cqlul1c\nMblP5etDZm7A/thliZIWAuyqv2bNicmS3xKvNy6/QYi1YgxZyy/qwJ3NdFl067W0\nt8nGo29B+EVK94IPjzFHWShuoktIgp+dmpijB7wkTIk8SmIoe9yuY4+hzgqk+bo4\nms2SOXSN1DoQ75Xv+YmztbnZM8MuWhL1T7hA4AMorzTQLJ9Pof8SpSdMHeDsHp0R\n01jogNFkwy25nw7cL62nufSuH2fPYGWXyNDg+y42wKsKWYXLRgUQuDVEJ2OmTFMB\nT0Vf7VuNijfIA9hkN2d3K53m/9z5WjGPSdOjGhg=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/jCCAuagAwIBAgIQRiwspKyrO0xoxDgSkqLZczANBgkqhkiG9w0BAQsFADCB\nlzELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdB\nbWF6b24gUkRTIHVzLXdlc3QtMiBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjEwNTI0MjE1OTAwWhgPMjA2MTA1MjQyMjU5MDBaMIGXMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpv\nbiBSRFMgdXMtd2VzdC0yIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAL53Jk3GsKiu+4bx\njDfsevWbwPCNJ3H08Zp7GWhvI3Tgi39opfHYv2ku2BKFjK8N2L6RvNPSR8yplv5j\nY0tK0U+XVNl8o0ibhqRDhbTuh6KL8CFINWYzAajuxFS+CF0U6c1Q3tXLBdALxA7l\nFlXJ71QrP06W31kRe7kvgrvO7qWU3/OzUf9qYw4LSiR1/VkvvRCTqcVNw09clw/M\nJbw6FSgweN65M9j7zPbjGAXSHkXyxH1Erin2fa+B9PE4ZDgX9cp2C1DHewYJQL/g\nSepwwcudVNRN1ibKH7kpMrgPnaNIVNx5sXVsTjk6q2ZqYw3SVHegltJpLy/cZReP\nmlivF2kCAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUmTcQd6o1\nCuS65MjBrMwQ9JJjmBwwDgYDVR0PAQH/BAQDAgGGMA0GCSqGSIb3DQEBCwUAA4IB\nAQAKSDSIzl956wVddPThf2VAzI8syw9ngSwsEHZvxVGHBvu5gg618rDyguVCYX9L\n4Kw/xJrk6S3qxOS2ZDyBcOpsrBskgahDFIunzoRP3a18ARQVq55LVgfwSDQiunch\nBd05cnFGLoiLkR5rrkgYaP2ftn3gRBRaf0y0S3JXZ2XB3sMZxGxavYq9mfiEcwB0\nLMTMQ1NYzahIeG6Jm3LqRqR8HkzP/Ztq4dT2AtSLvFebbNMiWqeqT7OcYp94HTYT\nzqrtaVdUg9bwyAUCDgy0GV9RHDIdNAOInU/4LEETovrtuBU7Z1q4tcHXvN6Hd1H8\ngMb0mCG5I393qW5hFsA/diFb\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgIRAPQAvihfjBg/JDbj6U64K98wDQYJKoZIhvcNAQELBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1ub3J0aGVhc3QtMiBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTIwMTYyODQxWhgPMjA2MTA1MjAxNzI4NDFa\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtbm9ydGhlYXN0LTIgUm9vdCBDQSBSU0EyMDQ4IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA\nvJ9lgyksCxkBlY40qOzI1TCj/Q0FVGuPL/Z1Mw2YN0l+41BDv0FHApjTUkIKOeIP\nnwDwpXTa3NjYbk3cOZ/fpH2rYJ++Fte6PNDGPgKppVCUh6x3jiVZ1L7wOgnTdK1Q\nTrw8440IDS5eLykRHvz8OmwvYDl0iIrt832V0QyOlHTGt6ZJ/aTQKl12Fy3QBLv7\nstClPzvHTrgWqVU6uidSYoDtzHbU7Vda7YH0wD9IUoMBf7Tu0rqcE4uH47s2XYkc\nSdLEoOg/Ngs7Y9B1y1GCyj3Ux7hnyvCoRTw014QyNB7dTatFMDvYlrRDGG14KeiU\nUL7Vo/+EejWI31eXNLw84wIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1Ud\nDgQWBBQkgTWFsNg6wA3HbbihDQ4vpt1E2zAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZI\nhvcNAQELBQADggEBAGz1Asiw7hn5WYUj8RpOCzpE0h/oBZcnxP8wulzZ5Xd0YxWO\n0jYUcUk3tTQy1QvoY+Q5aCjg6vFv+oFBAxkib/SmZzp4xLisZIGlzpJQuAgRkwWA\n6BVMgRS+AaOMQ6wKPgz1x4v6T0cIELZEPq3piGxvvqkcLZKdCaeC3wCS6sxuafzZ\n4qA3zMwWuLOzRftgX2hQto7d/2YkRXga7jSvQl3id/EI+xrYoH6zIWgjdU1AUaNq\nNGT7DIo47vVMfnd9HFZNhREsd4GJE83I+JhTqIxiKPNxrKgESzyADmNPt0gXDnHo\ntbV1pMZz5HpJtjnP/qVZhEK5oB0tqlKPv9yx074=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICuTCCAj6gAwIBAgIRAKp1Rn3aL/g/6oiHVIXtCq8wCgYIKoZIzj0EAwMwgZsx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE0MDIGA1UEAwwrQW1h\nem9uIFJEUyBhcC1ub3J0aGVhc3QtMyBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTAgFw0yMTA1MjQyMDMyMTdaGA8yMTIxMDUyNDIxMzIxN1owgZsx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE0MDIGA1UEAwwrQW1h\nem9uIFJEUyBhcC1ub3J0aGVhc3QtMyBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABGTYWPILeBJXfcL3Dz4z\nEWMUq78xB1HpjBwHoTURYfcMd5r96BTVG6yaUBWnAVCMeeD6yTG9a1eVGNhG14Hk\nZAEjgLiNB7RRbEG5JZ/XV7W/vODh09WCst2y9SLKsdgeAaNCMEAwDwYDVR0TAQH/\nBAUwAwEB/zAdBgNVHQ4EFgQUoE0qZHmDCDB+Bnm8GUa/evpfPwgwDgYDVR0PAQH/\nBAQDAgGGMAoGCCqGSM49BAMDA2kAMGYCMQCnil5MMwhY3qoXv0xvcKZGxGPaBV15\n0CCssCKn0oVtdJQfJQ3Jrf3RSaEyijXIJsoCMQC35iJi4cWoNX3N/qfgnHohW52O\nB5dg0DYMqy5cNZ40+UcAanRMyqNQ6P7fy3umGco=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICtzCCAj2gAwIBAgIQPXnDTPegvJrI98qz8WxrMjAKBggqhkjOPQQDAzCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIEJldGEgdXMtZWFzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUxODIxNDAxMloYDzIxMjEwNTE4MjI0MDEyWjCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIEJldGEgdXMtZWFzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEI0sR7gwutK5AB46hM761\ngcLTGBIYlURSEoM1jcBwy56CL+3CJKZwLLyJ7qoOKfWbu5GsVLUTWS8MV6Nw33cx\n2KQD2svb694wi+Px2f4n9+XHkEFQw8BbiodDD7RZA70fo0IwQDAPBgNVHRMBAf8E\nBTADAQH/MB0GA1UdDgQWBBTQSioOvnVLEMXwNSDg+zgln/vAkjAOBgNVHQ8BAf8E\nBAMCAYYwCgYIKoZIzj0EAwMDaAAwZQIxAMwu1hqm5Bc98uE/E0B5iMYbBQ4kpMxO\ntP8FTfz5UR37HUn26nXE0puj6S/Ffj4oJgIwXI7s2c26tFQeqzq6u3lrNJHp5jC9\nUxlo/hEJOLoDj5jnpxo8dMAtCNoQPaHdfL0P\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjWgAwIBAgIQGKVv+5VuzEZEBzJ+bVfx2zAKBggqhkjOPQQDAzCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGFwLXNvdXRoLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTE5MTc1MDU5WhgPMjEyMTA1MTkxODUwNTlaMIGXMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpvbiBS\nRFMgYXAtc291dGgtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2VhdHRs\nZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABMqdLJ0tZF/DGFZTKZDrGRJZID8ivC2I\nJRCYTWweZKCKSCAzoiuGGHzJhr5RlLHQf/QgmFcgXsdmO2n3CggzhA4tOD9Ip7Lk\nP05eHd2UPInyPCHRgmGjGb0Z+RdQ6zkitKNCMEAwDwYDVR0TAQH/BAUwAwEB/zAd\nBgNVHQ4EFgQUC1yhRgVqU5bR8cGzOUCIxRpl4EYwDgYDVR0PAQH/BAQDAgGGMAoG\nCCqGSM49BAMDA2cAMGQCMG0c/zLGECRPzGKJvYCkpFTCUvdP4J74YP0v/dPvKojL\nt/BrR1Tg4xlfhaib7hPc7wIwFvgqHes20CubQnZmswbTKLUrgSUW4/lcKFpouFd2\nt2/ewfi/0VhkeUW+IiHhOMdU\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIGCTCCA/GgAwIBAgIRAOXxJuyXVkbfhZCkS/dOpfEwDQYJKoZIhvcNAQEMBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1ub3J0aGVhc3QtMSBSb290IENBIFJTQTQwOTYgRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTI1MjE1OTEwWhgPMjEyMTA1MjUyMjU5MTBa\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtbm9ydGhlYXN0LTEgUm9vdCBDQSBSU0E0MDk2IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIICIjANBgkqhkiG9w0BAQEFAAOCAg8AMIICCgKCAgEA\nxiP4RDYm4tIS12hGgn1csfO8onQDmK5SZDswUpl0HIKXOUVVWkHNlINkVxbdqpqH\nFhbyZmNN6F/EWopotMDKe1B+NLrjNQf4zefv2vyKvPHJXhxoKmfyuTd5Wk8k1F7I\nlNwLQzznB+ElhrLIDJl9Ro8t31YBBNFRGAGEnxyACFGcdkjlsa52UwfYrwreEg2l\ngW5AzqHgjFfj9QRLydeU/n4bHm0F1adMsV7P3rVwilcUlqsENDwXnWyPEyv3sw6F\nwNemLEs1129mB77fwvySb+lLNGsnzr8w4wdioZ74co+T9z2ca+eUiP+EQccVw1Is\nD4Fh57IjPa6Wuc4mwiUYKkKY63+38aCfEWb0Qoi+zW+mE9nek6MOQ914cN12u5LX\ndBoYopphRO5YmubSN4xcBy405nIdSdbrAVWwxXnVVyjqjknmNeqQsPZaxAhdoKhV\nAqxNr8AUAdOAO6Sz3MslmcLlDXFihrEEOeUbpg/m1mSUUHGbu966ajTG1FuEHHwS\n7WB52yxoJo/tHvt9nAWnh3uH5BHmS8zn6s6CGweWKbX5yICnZ1QFR1e4pogxX39v\nXD6YcNOO+Vn+HY4nXmjgSYVC7l+eeP8eduMg1xJujzjrbmrXU+d+cBObgdTOAlpa\nJFHaGwYw1osAwPCo9cZ2f04yitBfj9aPFia8ASKldakCAwEAAaNCMEAwDwYDVR0T\nAQH/BAUwAwEB/zAdBgNVHQ4EFgQUqKS+ltlior0SyZKYAkJ/efv55towDgYDVR0P\nAQH/BAQDAgGGMA0GCSqGSIb3DQEBDAUAA4ICAQAdElvp8bW4B+Cv+1WSN87dg6TN\nwGyIjJ14/QYURgyrZiYpUmZpj+/pJmprSWXu4KNyqHftmaidu7cdjL5nCAvAfnY5\n/6eDDbX4j8Gt9fb/6H9y0O0dn3mUPSEKG0crR+JRFAtPhn/2FNvst2P82yguWLv0\npHjHVUVcq+HqDMtUIJsTPYjSh9Iy77Q6TOZKln9dyDOWJpCSkiUWQtMAKbCSlvzd\nzTs/ahqpT+zLfGR1SR+T3snZHgQnbnemmz/XtlKl52NxccARwfcEEKaCRQyGq/pR\n0PVZasyJS9JY4JfQs4YOdeOt4UMZ8BmW1+BQWGSkkb0QIRl8CszoKofucAlqdPcO\nIT/ZaMVhI580LFGWiQIizWFskX6lqbCyHqJB3LDl8gJISB5vNTHOHpvpMOMs5PYt\ncRl5Mrksx5MKMqG7y5R734nMlZxQIHjL5FOoOxTBp9KeWIL/Ib89T2QDaLw1SQ+w\nihqWBJ4ZdrIMWYpP3WqM+MXWk7WAem+xsFJdR+MDgOOuobVQTy5dGBlPks/6gpjm\nrO9TjfQ36ppJ3b7LdKUPeRfnYmlR5RU4oyYJ//uLbClI443RZAgxaCXX/nyc12lr\neVLUMNF2abLX4/VF63m2/Z9ACgMRfqGshPssn1NN33OonrotQoj4S3N9ZrjvzKt8\niHcaqd60QKpfiH2A3A==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICuDCCAj2gAwIBAgIQPaVGRuu86nh/ylZVCLB0MzAKBggqhkjOPQQDAzCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLW5vcnRoZWFzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyNTIyMDMxNloYDzIxMjEwNTI1MjMwMzE2WjCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLW5vcnRoZWFzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEexNURoB9KE93MEtEAlJG\nobz4LS/pD2hc8Gczix1WhVvpJ8bN5zCDXaKdnDMCebetyRQsmQ2LYlfmCwpZwSDu\n0zowB11Pt3I5Avu2EEcuKTlKIDMBeZ1WWuOd3Tf7MEAMo0IwQDAPBgNVHRMBAf8E\nBTADAQH/MB0GA1UdDgQWBBSaYbZPBvFLikSAjpa8mRJvyArMxzAOBgNVHQ8BAf8E\nBAMCAYYwCgYIKoZIzj0EAwMDaQAwZgIxAOEJkuh3Zjb7Ih/zuNRd1RBqmIYcnyw0\nnwUZczKXry+9XebYj3VQxSRNadrarPWVqgIxAMg1dyGoDAYjY/L/9YElyMnvHltO\nPwpJShmqHvCLc/mXMgjjYb/akK7yGthvW6j/uQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\n6YYLNPRrj3mi9T/f\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjSgAwIBAgIRAMkvdFnVDb0mWWFiXqnKH68wCgYIKoZIzj0EAwMwgZYx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1h\nem9uIFJEUyB1cy13ZXN0LTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTE5MTkxMzI0WhgPMjEyMTA1MTkyMDEzMjRaMIGWMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExLzAtBgNVBAMMJkFtYXpvbiBS\nRFMgdXMtd2VzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdTZWF0dGxl\nMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEy86DB+9th/0A5VcWqMSWDxIUblWTt/R0\nao6Z2l3vf2YDF2wt1A2NIOGpfQ5+WAOJO/IQmnV9LhYo+kacB8sOnXdQa6biZZkR\nIyouUfikVQAKWEJnh1Cuo5YMM4E2sUt5o0IwQDAPBgNVHRMBAf8EBTADAQH/MB0G\nA1UdDgQWBBQ8u3OnecANmG8OoT7KLWDuFzZwBTAOBgNVHQ8BAf8EBAMCAYYwCgYI\nKoZIzj0EAwMDaAAwZQIwQ817qkb7mWJFnieRAN+m9W3E0FLVKaV3zC5aYJUk2fcZ\nTaUx3oLp3jPLGvY5+wgeAjEA6wAicAki4ZiDfxvAIuYiIe1OS/7H5RA++R8BH6qG\niRzUBM/FItFpnkus7u/eTkvo\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrzCCAjWgAwIBAgIQS/+Ryfgb/IOVEa1pWoe8oTAKBggqhkjOPQQDAzCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGFwLXNvdXRoLTIgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjIwNjA2MjE1NDQyWhgPMjEyMjA2MDYyMjU0NDJaMIGXMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpvbiBS\nRFMgYXAtc291dGgtMiBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2VhdHRs\nZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABDsX6fhdUWBQpYTdseBD/P3s96Dtw2Iw\nOrXKNToCnmX5nMkUGdRn9qKNiz1pw3EPzaPxShbYwQ7LYP09ENK/JN4QQjxMihxC\njLFxS85nhBQQQGRCWikDAe38mD8fSvREQKNCMEAwDwYDVR0TAQH/BAUwAwEB/zAd\nBgNVHQ4EFgQUIh1xZiseQYFjPYKJmGbruAgRH+AwDgYDVR0PAQH/BAQDAgGGMAoG\nCCqGSM49BAMDA2gAMGUCMFudS4zLy+UUGrtgNLtRMcu/DZ9BUzV4NdHxo0bkG44O\nthnjl4+wTKI6VbyAbj2rkgIxAOHps8NMITU5DpyiMnKTxV8ubb/WGHrLl0BjB8Lw\nETVJk5DNuZvsIIcm7ykk6iL4Tw==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\ncuLMVcQZceE=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEADCCAuigAwIBAgIQAhAteLRCvizAElaWORFU2zANBgkqhkiG9w0BAQsFADCB\nmDELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChB\nbWF6b24gUkRTIG1lLXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyMDE3MDkxNloYDzIwNjEwNTIwMTgwOTE2WjCBmDEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChBbWF6\nb24gUkRTIG1lLXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA+qg7JAcOVKjh\nN83SACnBFZPyB63EusfDr/0V9ZdL8lKcmZX9sv/CqoBo3N0EvBqHQqUUX6JvFb7F\nXrMUZ740kr28gSRALfXTFgNODjXeDsCtEkKRTkac/UM8xXHn+hR7UFRPHS3e0GzI\niLiwQWDkr0Op74W8aM0CfaVKvh2bp4BI1jJbdDnQ9OKXpOxNHGUf0ZGb7TkNPkgI\nb2CBAc8J5o3H9lfw4uiyvl6Fz5JoP+A+zPELAioYBXDrbE7wJeqQDJrETWqR9VEK\nBXURCkVnHeaJy123MpAX2ozf4pqk0V0LOEOZRS29I+USF5DcWr7QIXR/w2I8ws1Q\n7ys+qbE+kQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBQFJ16n\n1EcCMOIhoZs/F9sR+Jy++zAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZIhvcNAQELBQAD\nggEBAOc5nXbT3XTDEZsxX2iD15YrQvmL5m13B3ImZWpx/pqmObsgx3/dg75rF2nQ\nqS+Vl+f/HLh516pj2BPP/yWCq12TRYigGav8UH0qdT3CAClYy2o+zAzUJHm84oiB\nud+6pFVGkbqpsY+QMpJUbZWu52KViBpJMYsUEy+9cnPSFRVuRAHjYynSiLk2ZEjb\nWkdc4x0nOZR5tP0FgrX0Ve2KcjFwVQJVZLgOUqmFYQ/G0TIIGTNh9tcmR7yp+xJR\nA2tbPV2Z6m9Yxx4E8lLEPNuoeouJ/GR4CkMEmF8cLwM310t174o3lKKUXJ4Vs2HO\nWj2uN6R9oI+jGLMSswTzCNV1vgc=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICuDCCAj6gAwIBAgIRAOocLeZWjYkG/EbHmscuy8gwCgYIKoZIzj0EAwMwgZsx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE0MDIGA1UEAwwrQW1h\nem9uIFJEUyBhcC1zb3V0aGVhc3QtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTAgFw0yMTA1MjEyMTUwMDFaGA8yMTIxMDUyMTIyNTAwMVowgZsx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE0MDIGA1UEAwwrQW1h\nem9uIFJEUyBhcC1zb3V0aGVhc3QtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABCEr3jq1KtRncnZfK5cq\nbtY0nW6ZG3FMbh7XwBIR6Ca0f8llGZ4vJEC1pXgiM/4Dh045B9ZIzNrR54rYOIfa\n2NcYZ7mk06DjIQML64hbAxbQzOAuNzLPx268MrlL2uW2XaNCMEAwDwYDVR0TAQH/\nBAUwAwEB/zAdBgNVHQ4EFgQUln75pChychwN4RfHl+tOinMrfVowDgYDVR0PAQH/\nBAQDAgGGMAoGCCqGSM49BAMDA2gAMGUCMGiyPINRU1mwZ4Crw01vpuPvxZxb2IOr\nyX3RNlOIu4We1H+5dQk5tIvH8KGYFbWEpAIxAO9NZ6/j9osMhLgZ0yj0WVjb+uZx\nYlZR9fyFisY/jNfX7QhSk+nrc3SFLRUNtpXrng==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBTCCAu2gAwIBAgIRAKiaRZatN8eiz9p0s0lu0rQwDQYJKoZIhvcNAQELBQAw\ngZoxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEzMDEGA1UEAwwq\nQW1hem9uIFJEUyBjYS1jZW50cmFsLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYD\nVQQHDAdTZWF0dGxlMCAXDTIxMDUyMTIyMDIzNVoYDzIwNjEwNTIxMjMwMjM1WjCB\nmjELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTMwMQYDVQQDDCpB\nbWF6b24gUkRTIGNhLWNlbnRyYWwtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNV\nBAcMB1NlYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCygVMf\nqB865IR9qYRBRFHn4eAqGJOCFx+UbraQZmjr/mnRqSkY+nhbM7Pn/DWOrRnxoh+w\nq5F9ZxdZ5D5T1v6kljVwxyfFgHItyyyIL0YS7e2h7cRRscCM+75kMedAP7icb4YN\nLfWBqfKHbHIOqvvQK8T6+Emu/QlG2B5LvuErrop9K0KinhITekpVIO4HCN61cuOe\nCADBKF/5uUJHwS9pWw3uUbpGUwsLBuhJzCY/OpJlDqC8Y9aToi2Ivl5u3/Q/sKjr\n6AZb9lx4q3J2z7tJDrm5MHYwV74elGSXoeoG8nODUqjgklIWAPrt6lQ3WJpO2kug\n8RhCdSbWkcXHfX95AgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYE\nFOIxhqTPkKVqKBZvMWtKewKWDvDBMA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG9w0B\nAQsFAAOCAQEAqoItII89lOl4TKvg0I1EinxafZLXIheLcdGCxpjRxlZ9QMQUN3yb\ny/8uFKBL0otbQgJEoGhxm4h0tp54g28M6TN1U0332dwkjYxUNwvzrMaV5Na55I2Z\n1hq4GB3NMXW+PvdtsgVOZbEN+zOyOZ5MvJHEQVkT3YRnf6avsdntltcRzHJ16pJc\nY8rR7yWwPXh1lPaPkxddrCtwayyGxNbNmRybjR48uHRhwu7v2WuAMdChL8H8bp89\nTQLMrMHgSbZfee9hKhO4Zebelf1/cslRSrhkG0ESq6G5MUINj6lMg2g6F0F7Xz2v\nncD/vuRN5P+vT8th/oZ0Q2Gc68Pun0cn/g==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/zCCAuegAwIBAgIRAJYlnmkGRj4ju/2jBQsnXJYwDQYJKoZIhvcNAQELBQAw\ngZcxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEwMC4GA1UEAwwn\nQW1hem9uIFJEUyB1cy1lYXN0LTIgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyMTIzMDQ0NFoYDzIwNjEwNTIyMDAwNDQ0WjCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIHVzLWVhc3QtMiBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQC74V3eigv+pCj5\nnqDBqplY0Jp16pTeNB06IKbzb4MOTvNde6QjsZxrE1xUmprT8LxQqN9tI3aDYEYk\nb9v4F99WtQVgCv3Y34tYKX9NwWQgwS1vQwnIR8zOFBYqsAsHEkeJuSqAB12AYUSd\nZv2RVFjiFmYJho2X30IrSLQfS/IE3KV7fCyMMm154+/K1Z2IJlcissydEAwgsUHw\nedrE6CxJVkkJ3EvIgG4ugK/suxd8eEMztaQYJwSdN8TdfT59LFuSPl7zmF3fIBdJ\n//WexcQmGabaJ7Xnx+6o2HTfkP8Zzzzaq8fvjAcvA7gyFH5EP26G2ZqMG+0y4pTx\nSPVTrQEXAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFIWWuNEF\nsUMOC82XlfJeqazzrkPDMA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG9w0BAQsFAAOC\nAQEAgClmxcJaQTGpEZmjElL8G2Zc8lGc+ylGjiNlSIw8X25/bcLRptbDA90nuP+q\nzXAMhEf0ccbdpwxG/P5a8JipmHgqQLHfpkvaXx+0CuP++3k+chAJ3Gk5XtY587jX\n+MJfrPgjFt7vmMaKmynndf+NaIJAYczjhJj6xjPWmGrjM3MlTa9XesmelMwP3jep\nbApIWAvCYVjGndbK9byyMq1nyj0TUzB8oJZQooaR3MMjHTmADuVBylWzkRMxbKPl\n4Nlsk4Ef1JvIWBCzsMt+X17nuKfEatRfp3c9tbpGlAE/DSP0W2/Lnayxr4RpE9ds\nICF35uSis/7ZlsftODUe8wtpkQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nPqj2\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nKDPtFEk=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICtzCCAj2gAwIBAgIQVZ5Y/KqjR4XLou8MCD5pOjAKBggqhkjOPQQDAzCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLXNvdXRoZWFzdC00IFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIyMDUyNTE2NTgzM1oYDzIxMjIwNTI1MTc1ODMzWjCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLXNvdXRoZWFzdC00IFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEbo473OmpD5vkckdJajXg\nbrhmNFyoSa0WCY1njuZC2zMFp3zP6rX4I1r3imrYnJd9pFH/aSiV/r6L5ACE5RPx\n4qdg5SQ7JJUaZc3DWsTOiOed7BCZSzM+KTYK/2QzDMApo0IwQDAPBgNVHRMBAf8E\nBTADAQH/MB0GA1UdDgQWBBTmogc06+1knsej1ltKUOdWFvwgsjAOBgNVHQ8BAf8E\nBAMCAYYwCgYIKoZIzj0EAwMDaAAwZQIxAIs7TlLMbGTWNXpGiKf9DxaM07d/iDHe\nF/Vv/wyWSTGdobxBL6iArQNVXz0Gr4dvPAIwd0rsoa6R0x5mtvhdRPtM37FYrbHJ\npbV+OMusQqcSLseunLBoCHenvJW0QOCQ8EDY\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICvTCCAkOgAwIBAgIQCIY7E/bFvFN2lK9Kckb0dTAKBggqhkjOPQQDAzCBnjEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTcwNQYDVQQDDC5BbWF6\nb24gUkRTIFByZXZpZXcgdXMtZWFzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYD\nVQQHDAdTZWF0dGxlMCAXDTIxMDUxODIxMDUxMFoYDzIxMjEwNTE4MjIwNTEwWjCB\nnjELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTcwNQYDVQQDDC5B\nbWF6b24gUkRTIFByZXZpZXcgdXMtZWFzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEMI0hzf1JCEOI\nEue4+DmcNnSs2i2UaJxHMrNGGfU7b42a7vwP53F7045ffHPBGP4jb9q02/bStZzd\nVHqfcgqkSRI7beBKjD2mfz82hF/wJSITTgCLs+NRpS6zKMFOFHUNo0IwQDAPBgNV\nHRMBAf8EBTADAQH/MB0GA1UdDgQWBBS8uF/6hk5mPLH4qaWv9NVZaMmyTjAOBgNV\nHQ8BAf8EBAMCAYYwCgYIKoZIzj0EAwMDaAAwZQIxAO7Pu9wzLyM0X7Q08uLIL+vL\nqaxe3UFuzFTWjM16MLJHbzLf1i9IDFKz+Q4hXCSiJwIwClMBsqT49BPUxVsJnjGr\nEbyEk6aOOVfY1p2yQL649zh3M4h8okLnwf+bYIb1YpeU\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEADCCAuigAwIBAgIQY+JhwFEQTe36qyRlUlF8ozANBgkqhkiG9w0BAQsFADCB\nmDELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChB\nbWF6b24gUkRTIGFmLXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUxOTE5MjQxNloYDzIwNjEwNTE5MjAyNDE2WjCBmDEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChBbWF6\nb24gUkRTIGFmLXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAnIye77j6ev40\n8wRPyN2OdKFSUfI9jB20Or2RLO+RDoL43+USXdrze0Wv4HMRLqaen9BcmCfaKMp0\nE4SFo47bXK/O17r6G8eyq1sqnHE+v288mWtYH9lAlSamNFRF6YwA7zncmE/iKL8J\n0vePHMHP/B6svw8LULZCk+nZk3tgxQn2+r0B4FOz+RmpkoVddfqqUPMbKUxhM2wf\nfO7F6bJaUXDNMBPhCn/3ayKCjYr49ErmnpYV2ZVs1i34S+LFq39J7kyv6zAgbHv9\n+/MtRMoRB1CjpqW0jIOZkHBdYcd1o9p1zFn591Do1wPkmMsWdjIYj+6e7UXcHvOB\n2+ScIRAcnwIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBQGtq2W\nYSyMMxpdQ3IZvcGE+nyZqTAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZIhvcNAQELBQAD\nggEBAEgoP3ixJsKSD5FN8dQ01RNHERl/IFbA7TRXfwC+L1yFocKnQh4Mp/msPRSV\n+OeHIvemPW/wtZDJzLTOFJ6eTolGekHK1GRTQ6ZqsWiU2fmiOP8ks4oSpI+tQ9Lw\nVrfZqTiEcS5wEIqyfUAZZfKDo7W1xp+dQWzfczSBuZJZwI5iaha7+ILM0r8Ckden\nTVTapc5pLSoO15v0ziRuQ2bT3V3nwu/U0MRK44z+VWOJdSiKxdnOYDs8hFNnKhfe\nklbTZF7kW7WbiNYB43OaAQBJ6BALZsIskEaqfeZT8FD71uN928TcEQyBDXdZpRN+\niGQZDGhht0r0URGMDSs9waJtTfA=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\ndIA=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/zCCAuegAwIBAgIRAPVSMfFitmM5PhmbaOFoGfUwDQYJKoZIhvcNAQELBQAw\ngZcxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEwMC4GA1UEAwwn\nQW1hem9uIFJEUyB1cy1lYXN0LTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyNTIyMzQ1N1oYDzIwNjEwNTI1MjMzNDU3WjCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIHVzLWVhc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQDu9H7TBeGoDzMr\ndxN6H8COntJX4IR6dbyhnj5qMD4xl/IWvp50lt0VpmMd+z2PNZzx8RazeGC5IniV\n5nrLg0AKWRQ2A/lGGXbUrGXCSe09brMQCxWBSIYe1WZZ1iU1IJ/6Bp4D2YEHpXrW\nbPkOq5x3YPcsoitgm1Xh8ygz6vb7PsvJvPbvRMnkDg5IqEThapPjmKb8ZJWyEFEE\nQRrkCIRueB1EqQtJw0fvP4PKDlCJAKBEs/y049FoOqYpT3pRy0WKqPhWve+hScMd\n6obq8kxTFy1IHACjHc51nrGII5Bt76/MpTWhnJIJrCnq1/Uc3Qs8IVeb+sLaFC8K\nDI69Sw6bAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFE7PCopt\nlyOgtXX0Y1lObBUxuKaCMA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG9w0BAQsFAAOC\nAQEAFj+bX8gLmMNefr5jRJfHjrL3iuZCjf7YEZgn89pS4z8408mjj9z6Q5D1H7yS\njNETVV8QaJip1qyhh5gRzRaArgGAYvi2/r0zPsy+Tgf7v1KGL5Lh8NT8iCEGGXwF\ng3Ir+Nl3e+9XUp0eyyzBIjHtjLBm6yy8rGk9p6OtFDQnKF5OxwbAgip42CD75r/q\np421maEDDvvRFR4D+99JZxgAYDBGqRRceUoe16qDzbMvlz0A9paCZFclxeftAxv6\nQlR5rItMz/XdzpBJUpYhdzM0gCzAzdQuVO5tjJxmXhkSMcDP+8Q+Uv6FA9k2VpUV\nE/O5jgpqUJJ2Hc/5rs9VkAPXeA==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrzCCAjWgAwIBAgIQW0yuFCle3uj4vWiGU0SaGzAKBggqhkjOPQQDAzCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGFmLXNvdXRoLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTE5MTkzNTE2WhgPMjEyMTA1MTkyMDM1MTZaMIGXMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpvbiBS\nRFMgYWYtc291dGgtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2VhdHRs\nZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABDPiKNZSaXs3Un/J/v+LTsFDANHpi7en\noL2qh0u0DoqNzEBTbBjvO23bLN3k599zh6CY3HKW0r2k1yaIdbWqt4upMCRCcUFi\nI4iedAmubgzh56wJdoMZztjXZRwDthTkJKNCMEAwDwYDVR0TAQH/BAUwAwEB/zAd\nBgNVHQ4EFgQUWbYkcrvVSnAWPR5PJhIzppcAnZIwDgYDVR0PAQH/BAQDAgGGMAoG\nCCqGSM49BAMDA2gAMGUCMCESGqpat93CjrSEjE7z+Hbvz0psZTHwqaxuiH64GKUm\nmYynIiwpKHyBrzjKBmeDoQIxANGrjIo6/b8Jl6sdIZQI18V0pAyLfLiZjlHVOnhM\nMOTVgr82ZuPoEHTX78MxeMnYlw==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgIRAIbsx8XOl0sgTNiCN4O+18QwDQYJKoZIhvcNAQELBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBhcC1ub3J0aGVhc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTI1MjE1NDU4WhgPMjA2MTA1MjUyMjU0NTha\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgYXAtbm9ydGhlYXN0LTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA\ntROxwXWCgn5R9gI/2Ivjzaxc0g95ysBjoJsnhPdJEHQb7w3y2kWrVWU3Y9fOitgb\nCEsnEC3PrhRnzNVW0fPsK6kbvOeCmjvY30rdbxbc8h+bjXfGmIOgAkmoULEr6Hc7\nG1Q/+tvv4lEwIs7bEaf+abSZxRJbZ0MBxhbHn7UHHDiMZYvzK+SV1MGCxx7JVhrm\nxWu3GC1zZCsGDhB9YqY9eR6PmjbqA5wy8vqbC57dZZa1QVtWIQn3JaRXn+faIzHx\nnLMN5CEWihsdmHBXhnRboXprE/OS4MFv1UrQF/XM/h5RBeCywpHePpC+Oe1T3LNC\niP8KzRFrjC1MX/WXJnmOVQIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1Ud\nDgQWBBS33XbXAUMs1znyZo4B0+B3D68WFTAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZI\nhvcNAQELBQADggEBADuadd2EmlpueY2VlrIIPC30QkoA1EOSoCmZgN6124apkoY1\nHiV4r+QNPljN4WP8gmcARnNkS7ZeR4fvWi8xPh5AxQCpiaBMw4gcbTMCuKDV68Pw\nP2dZCTMspvR3CDfM35oXCufdtFnxyU6PAyINUqF/wyTHguO3owRFPz64+sk3r2pT\nWHmJjG9E7V+KOh0s6REgD17Gqn6C5ijLchSrPUHB0wOIkeLJZndHxN/76h7+zhMt\nfFeNxPWHY2MfpcaLjz4UREzZPSB2U9k+y3pW1omCIcl6MQU9itGx/LpQE+H3ZeX2\nM2bdYd5L+ow+bdbGtsVKOuN+R9Dm17YpswF+vyQ=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIGATCCA+mgAwIBAgIRAKlQ+3JX9yHXyjP/Ja6kZhkwDQYJKoZIhvcNAQEMBQAw\ngZgxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTExMC8GA1UEAwwo\nQW1hem9uIFJEUyBhcC1zb3V0aC0xIFJvb3QgQ0EgUlNBNDA5NiBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTAgFw0yMTA1MTkxNzQ1MjBaGA8yMTIxMDUxOTE4NDUyMFowgZgx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTExMC8GA1UEAwwoQW1h\nem9uIFJEUyBhcC1zb3V0aC0xIFJvb3QgQ0EgUlNBNDA5NiBHMTEQMA4GA1UEBwwH\nU2VhdHRsZTCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoCggIBAKtahBrpUjQ6\nH2mni05BAKU6Z5USPZeSKmBBJN3YgD17rJ93ikJxSgzJ+CupGy5rvYQ0xznJyiV0\n91QeQN4P+G2MjGQR0RGeUuZcfcZitJro7iAg3UBvw8WIGkcDUg+MGVpRv/B7ry88\n7E4OxKb8CPNoa+a9j6ABjOaaxaI22Bb7j3OJ+JyMICs6CU2bgkJaj3VUV9FCNUOc\nh9PxD4jzT9yyGYm/sK9BAT1WOTPG8XQUkpcFqy/IerZDfiQkf1koiSd4s5VhBkUn\naQHOdri/stldT7a+HJFVyz2AXDGPDj+UBMOuLq0K6GAT6ThpkXCb2RIf4mdTy7ox\nN5BaJ+ih+Ro3ZwPkok60egnt/RN98jgbm+WstgjJWuLqSNInnMUgkuqjyBWwePqX\nKib+wdpyx/LOzhKPEFpeMIvHQ3A0sjlulIjnh+j+itezD+dp0UNxMERlW4Bn/IlS\nsYQVNfYutWkRPRLErXOZXtlxxkI98JWQtLjvGzQr+jywxTiw644FSLWdhKa6DtfU\n2JWBHqQPJicMElfZpmfaHZjtXuCZNdZQXWg7onZYohe281ZrdFPOqC4rUq7gYamL\nT+ZB+2P+YCPOLJ60bj/XSvcB7mesAdg8P0DNddPhHUFWx2dFqOs1HxIVB4FZVA9U\nPpbv4a484yxjTgG7zFZNqXHKTqze6rBBAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMB\nAf8wHQYDVR0OBBYEFCEAqjighncv/UnWzBjqu1Ka2Yb4MA4GA1UdDwEB/wQEAwIB\nhjANBgkqhkiG9w0BAQwFAAOCAgEAYyvumblckIXlohzi3QiShkZhqFzZultbFIu9\nGhA5CDar1IFMhJ9vJpO9nUK/camKs1VQRs8ZsBbXa0GFUM2p8y2cgUfLwFULAiC/\nsWETyW5lcX/xc4Pyf6dONhqFJt/ovVBxNZtcmMEWv/1D6Tf0nLeEb0P2i/pnSRR4\nOq99LVFjossXtyvtaq06OSiUUZ1zLPvV6AQINg8dWeBOWRcQYhYcEcC2wQ06KShZ\n0ahuu7ar5Gym3vuLK6nH+eQrkUievVomN/LpASrYhK32joQ5ypIJej3sICIgJUEP\nUoeswJ+Z16f3ECoL1OSnq4A0riiLj1ZGmVHNhM6m/gotKaHNMxsK9zsbqmuU6IT/\nP6cR0S+vdigQG8ZNFf5vEyVNXhl8KcaJn6lMD/gMB2rY0qpaeTg4gPfU5wcg8S4Y\nC9V//tw3hv0f2n+8kGNmqZrylOQDQWSSo8j8M2SRSXiwOHDoTASd1fyBEIqBAwzn\nLvXVg8wQd1WlmM3b0Vrsbzltyh6y4SuKSkmgufYYvC07NknQO5vqvZcNoYbLNea3\n76NkFaMHUekSbwVejZgG5HGwbaYBgNdJEdpbWlA3X4yGRVxknQSUyt4dZRnw/HrX\nk8x6/wvtw7wht0/DOqz1li7baSsMazqxx+jDdSr1h9xML416Q4loFCLgqQhil8Jq\nEm4Hy3A=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\njGKc3k6UNxpg\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\n0Ws=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICtDCCAjqgAwIBAgIRAMyaTlVLN0ndGp4ffwKAfoMwCgYIKoZIzj0EAwMwgZkx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEyMDAGA1UEAwwpQW1h\nem9uIFJEUyBtZS1jZW50cmFsLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjIwNTA3MDA0NDM3WhgPMjEyMjA1MDcwMTQ0MzdaMIGZMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMjAwBgNVBAMMKUFtYXpv\nbiBSRFMgbWUtY2VudHJhbC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAE19nCV1nsI6CohSor13+B25cr\nzg+IHdi9Y3L7ziQnHWI6yjBazvnKD+oC71aRRlR8b5YXsYGUQxWzPLHN7EGPcSGv\nbzA9SLG1KQYCJaQ0m9Eg/iGrwKWOgylbhVw0bCxoo0IwQDAPBgNVHRMBAf8EBTAD\nAQH/MB0GA1UdDgQWBBS4KsknsJXM9+QPEkBdZxUPaLr11zAOBgNVHQ8BAf8EBAMC\nAYYwCgYIKoZIzj0EAwMDaAAwZQIxAJaRgrYIEfXQMZQQDxMTYS0azpyWSseQooXo\nL3nYq4OHGBgYyQ9gVjvRYWU85PXbfgIwdi82DtANQFkCu+j+BU0JBY/uRKPEeYzo\nJG92igKIcXPqCoxIJ7lJbbzmuf73gQu5\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nTspdjbg=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIECTCCAvGgAwIBAgIRAJZFh4s9aZGzKaTMLrSb4acwDQYJKoZIhvcNAQELBQAw\ngZwxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTE1MDMGA1UEAwws\nQW1hem9uIFJEUyBCZXRhIHVzLWVhc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAO\nBgNVBAcMB1NlYXR0bGUwIBcNMjEwNTE4MjEyODQxWhgPMjA2MTA1MTgyMjI4NDFa\nMIGcMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywg\nSW5jLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExNTAzBgNVBAMM\nLEFtYXpvbiBSRFMgQmV0YSB1cy1lYXN0LTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAw\nDgYDVQQHDAdTZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA\n17i2yoU6diep+WrqxIn2CrDEO2NdJVwWTSckx4WMZlLpkQDoymSmkNHjq9ADIApD\nA31Cx+843apL7wub8QkFZD0Tk7/ThdHWJOzcAM3ov98QBPQfOC1W5zYIIRP2F+vQ\nTRETHQnLcW3rLv0NMk5oQvIKpJoC9ett6aeVrzu+4cU4DZVWYlJUoC/ljWzCluau\n8blfW0Vwin6OB7s0HCG5/wijQWJBU5SrP/KAIPeQi1GqG5efbqAXDr/ple0Ipwyo\nXjjl73LenGUgqpANlC9EAT4i7FkJcllLPeK3NcOHjuUG0AccLv1lGsHAxZLgjk/x\nz9ZcnVV9UFWZiyJTKxeKPwIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1Ud\nDgQWBBRWyMuZUo4gxCR3Luf9/bd2AqZ7CjAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZI\nhvcNAQELBQADggEBAIqN2DlIKlvDFPO0QUZQVFbsi/tLdYM98/vvzBpttlTGVMyD\ngJuQeHVz+MnhGIwoCGOlGU3OOUoIlLAut0+WG74qYczn43oA2gbMd7HoD7oL/IGg\nnjorBwJVcuuLv2G//SqM3nxGcLRtkRnQ+lvqPxMz9+0fKFUn6QcIDuF0QSfthLs2\nWSiGEPKO9c9RSXdRQ4pXA7c3hXng8P4A2ZmdciPne5Nu4I4qLDGZYRrRLRkNTrOi\nTyS6r2HNGUfgF7eOSeKt3NWL+mNChcYj71/Vycf5edeczpUgfnWy9WbPrK1svKyl\naAs2xg+X6O8qB+Mnj2dNBzm+lZIS3sIlm+nO9sg=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjSgAwIBAgIRAPAlEk8VJPmEzVRRaWvTh2AwCgYIKoZIzj0EAwMwgZYx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1h\nem9uIFJEUyB1cy1lYXN0LTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTI1MjI0MTU1WhgPMjEyMTA1MjUyMzQxNTVaMIGWMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExLzAtBgNVBAMMJkFtYXpvbiBS\nRFMgdXMtZWFzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdTZWF0dGxl\nMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEx5xjrup8II4HOJw15NTnS3H5yMrQGlbj\nEDA5MMGnE9DmHp5dACIxmPXPMe/99nO7wNdl7G71OYPCgEvWm0FhdvVUeTb3LVnV\nBnaXt32Ek7/oxGk1T+Df03C+W0vmuJ+wo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0G\nA1UdDgQWBBTGXmqBWN/1tkSea4pNw0oHrjk2UDAOBgNVHQ8BAf8EBAMCAYYwCgYI\nKoZIzj0EAwMDaAAwZQIxAIqqZWCSrIkZ7zsv/FygtAusW6yvlL935YAWYPVXU30m\njkMFLM+/RJ9GMvnO8jHfCgIwB+whlkcItzE9CRQ6CsMo/d5cEHDUu/QW6jSIh9BR\nOGh9pTYPVkUbBiKPA7lVVhre\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nnWS0\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nUfff2jrbfbzECn1ELg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nfejbXelUSJSzDIdY\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nPtjwbKW0hYAhIttT0Q==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICtzCCAj2gAwIBAgIQQRBQTs6Y3H1DDbpHGta3lzAKBggqhkjOPQQDAzCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLXNvdXRoZWFzdC0zIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDYxMTAwMTI0M1oYDzIxMjEwNjExMDExMjQzWjCBmzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTQwMgYDVQQDDCtBbWF6\nb24gUkRTIGFwLXNvdXRoZWFzdC0zIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEs0942Xj4m/gKA+WA6F5h\nAHYuek9eGpzTRoLJddM4rEV1T3eSueytMVKOSlS3Ub9IhyQrH2D8EHsLYk9ktnGR\npATk0kCYTqFbB7onNo070lmMJmGT/Q7NgwC8cySChFxbo0IwQDAPBgNVHRMBAf8E\nBTADAQH/MB0GA1UdDgQWBBQ20iKBKiNkcbIZRu0y1uoF1yJTEzAOBgNVHQ8BAf8E\nBAMCAYYwCgYIKoZIzj0EAwMDaAAwZQIwYv0wTSrpQTaPaarfLN8Xcqrqu3hzl07n\nFrESIoRw6Cx77ZscFi2/MV6AFyjCV/TlAjEAhpwJ3tpzPXpThRML8DMJYZ3YgMh3\nCMuLqhPpla3cL0PhybrD27hJWl29C4el6aMO\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrDCCAjOgAwIBAgIQGcztRyV40pyMKbNeSN+vXTAKBggqhkjOPQQDAzCBljEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMS8wLQYDVQQDDCZBbWF6\nb24gUkRTIHVzLWVhc3QtMiBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTAgFw0yMTA1MjEyMzE1NTZaGA8yMTIxMDUyMjAwMTU1NlowgZYxCzAJBgNV\nBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYD\nVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1hem9uIFJE\nUyB1cy1lYXN0LTIgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1NlYXR0bGUw\ndjAQBgcqhkjOPQIBBgUrgQQAIgNiAAQfDcv+GGRESD9wT+I5YIPRsD3L+/jsiIis\nTr7t9RSbFl+gYpO7ZbDXvNbV5UGOC5lMJo/SnqFRTC6vL06NF7qOHfig3XO8QnQz\n6T5uhhrhnX2RSY3/10d2kTyHq3ZZg3+jQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYD\nVR0OBBYEFLDyD3PRyNXpvKHPYYxjHXWOgfPnMA4GA1UdDwEB/wQEAwIBhjAKBggq\nhkjOPQQDAwNnADBkAjB20HQp6YL7CqYD82KaLGzgw305aUKw2aMrdkBR29J183jY\n6Ocj9+Wcif9xnRMS+7oCMAvrt03rbh4SU9BohpRUcQ2Pjkh7RoY0jDR4Xq4qzjNr\n5UFr3BXpFvACxXF51BksGQ==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjWgAwIBAgIQeKbS5zvtqDvRtwr5H48cAjAKBggqhkjOPQQDAzCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIG1lLXNvdXRoLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTIwMTcxOTU1WhgPMjEyMTA1MjAxODE5NTVaMIGXMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpvbiBS\nRFMgbWUtc291dGgtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2VhdHRs\nZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABEKjgUaAPmUlRMEQdBC7BScAGosJ1zRV\nLDd38qTBjzgmwBfQJ5ZfGIvyEK5unB09MB4e/3qqK5I/L6Qn5Px/n5g4dq0c7MQZ\nu7G9GBYm90U3WRJBf7lQrPStXaRnS4A/O6NCMEAwDwYDVR0TAQH/BAUwAwEB/zAd\nBgNVHQ4EFgQUNKcAbGEIn03/vkwd8g6jNyiRdD4wDgYDVR0PAQH/BAQDAgGGMAoG\nCCqGSM49BAMDA2cAMGQCMHIeTrjenCSYuGC6txuBt/0ZwnM/ciO9kHGWVCoK8QLs\njGghb5/YSFGZbmQ6qpGlSAIwVOQgdFfTpEfe5i+Vs9frLJ4QKAfc27cTNYzRIM0I\nE+AJgK4C4+DiyyMzOpiCfmvq\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nWT1QcNdw7ntUJP/w\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrzCCAjWgAwIBAgIQARky6+5PNFRkFVOp3Ob1CTAKBggqhkjOPQQDAzCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGV1LXNvdXRoLTIgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjIwNTIzMTg0MTI4WhgPMjEyMjA1MjMxOTQxMjdaMIGXMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpvbiBS\nRFMgZXUtc291dGgtMiBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2VhdHRs\nZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABNVGL5oF7cfIBxKyWd2PVK/S5yQfaJY3\nQFHWvEdt6951n9JhiiPrHzfVHsxZp1CBjILRMzjgRbYWmc8qRoLkgGE7htGdwudJ\nFa/WuKzO574Prv4iZXUnVGTboC7JdvKbh6NCMEAwDwYDVR0TAQH/BAUwAwEB/zAd\nBgNVHQ4EFgQUgDeIIEKynwUbNXApdIPnmRWieZwwDgYDVR0PAQH/BAQDAgGGMAoG\nCCqGSM49BAMDA2gAMGUCMEOOJfucrST+FxuqJkMZyCM3gWGZaB+/w6+XUAJC6hFM\nuSTY0F44/bERkA4XhH+YGAIxAIpJQBakCA1/mXjsTnQ+0El9ty+LODp8ibkn031c\n8DKDS7pR9UK7ZYdR6zFg3ZCjQw==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjOgAwIBAgIQJvkWUcYLbnxtuwnyjMmntDAKBggqhkjOPQQDAzCBljEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMS8wLQYDVQQDDCZBbWF6\nb24gUkRTIGV1LXdlc3QtMyBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTAgFw0yMTA1MjUyMjI2MTJaGA8yMTIxMDUyNTIzMjYxMlowgZYxCzAJBgNV\nBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMwEQYD\nVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1hem9uIFJE\nUyBldS13ZXN0LTMgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1NlYXR0bGUw\ndjAQBgcqhkjOPQIBBgUrgQQAIgNiAARENn8uHCyjn1dFax4OeXxvbV861qsXFD9G\nDshumTmFzWWHN/69WN/AOsxy9XN5S7Cgad4gQgeYYYgZ5taw+tFo/jQvCLY//uR5\nuihcLuLJ78opvRPvD9kbWZ6oXfBtFkWjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYD\nVR0OBBYEFKiK3LpoF+gDnqPldGSwChBPCYciMA4GA1UdDwEB/wQEAwIBhjAKBggq\nhkjOPQQDAwNpADBmAjEA+7qfvRlnvF1Aosyp9HzxxCbN7VKu+QXXPhLEBWa5oeWW\nUOcifunf/IVLC4/FGCsLAjEAte1AYp+iJyOHDB8UYkhBE/1sxnFaTiEPbvQBU0wZ\nSuwWVLhu2wWDuSW+K7tTuL8p\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/zCCAuegAwIBAgIRAKeDpqX5WFCGNo94M4v69sUwDQYJKoZIhvcNAQELBQAw\ngZcxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEwMC4GA1UEAwwn\nQW1hem9uIFJEUyBldS13ZXN0LTMgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyNTIyMTgzM1oYDzIwNjEwNTI1MjMxODMzWjCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGV1LXdlc3QtMyBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCcKOTEMTfzvs4H\nWtJR8gI7GXN6xesulWtZPv21oT+fLGwJ+9Bv8ADCGDDrDxfeH/HxJmzG9hgVAzVn\n4g97Bn7q07tGZM5pVi96/aNp11velZT7spOJKfJDZTlGns6DPdHmx48whpdO+dOb\n6+eR0VwCIv+Vl1fWXgoACXYCoKjhxJs+R+fwY//0JJ1YG8yjZ+ghLCJmvlkOJmE1\nTCPUyIENaEONd6T+FHGLVYRRxC2cPO65Jc4yQjsXvvQypoGgx7FwD5voNJnFMdyY\n754JGPOOe/SZdepN7Tz7UEq8kn7NQSbhmCsgA/Hkjkchz96qN/YJ+H/okiQUTNB0\neG9ogiVFAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFFjayw9Y\nMjbxfF14XAhMM2VPl0PfMA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG9w0BAQsFAAOC\nAQEAAtmx6d9+9CWlMoU0JCirtp4dSS41bBfb9Oor6GQ8WIr2LdfZLL6uES/ubJPE\n1Sh5Vu/Zon5/MbqLMVrfniv3UpQIof37jKXsjZJFE1JVD/qQfRzG8AlBkYgHNEiS\nVtD4lFxERmaCkY1tjKB4Dbd5hfhdrDy29618ZjbSP7NwAfnwb96jobCmMKgxVGiH\nUqsLSiEBZ33b2hI7PJ6iTJnYBWGuiDnsWzKRmheA4nxwbmcQSfjbrNwa93w3caL2\nv/4u54Kcasvcu3yFsUwJygt8z43jsGAemNZsS7GWESxVVlW93MJRn6M+MMakkl9L\ntWaXdHZ+KUV7LhfYLb0ajvb40w==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBDCCAuygAwIBAgIQJ5oxPEjefCsaESSwrxk68DANBgkqhkiG9w0BAQsFADCB\nmjELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTMwMQYDVQQDDCpB\nbWF6b24gUkRTIGV1LWNlbnRyYWwtMiBSb290IENBIFJTQTIwNDggRzExEDAOBgNV\nBAcMB1NlYXR0bGUwIBcNMjIwNjA2MjExNzA1WhgPMjA2MjA2MDYyMjE3MDVaMIGa\nMQswCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5j\nLjETMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMzAxBgNVBAMMKkFt\nYXpvbiBSRFMgZXUtY2VudHJhbC0yIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UE\nBwwHU2VhdHRsZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALTQt5eX\ng+VP3BjO9VBkWJhE0GfLrU/QIk32I6WvrnejayTrlup9H1z4QWlXF7GNJrqScRMY\nKhJHlcP05aPsx1lYco6pdFOf42ybXyWHHJdShj4A5glU81GTT+VrXGzHSarLmtua\neozkQgPpDsSlPt0RefyTyel7r3Cq+5K/4vyjCTcIqbfgaGwTU36ffjM1LaPCuE4O\nnINMeD6YuImt2hU/mFl20FZ+IZQUIFZZU7pxGLqTRz/PWcH8tDDxnkYg7tNuXOeN\nJbTpXrw7St50/E9ZQ0llGS+MxJD8jGRAa/oL4G/cwnV8P2OEPVVkgN9xDDQeieo0\n3xkzolkDkmeKOnUCAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQU\nbwu8635iQGQMRanekesORM8Hkm4wDgYDVR0PAQH/BAQDAgGGMA0GCSqGSIb3DQEB\nCwUAA4IBAQAgN6LE9mUgjsj6xGCX1afYE69fnmCjjb0rC6eEe1mb/QZNcyw4XBIW\n6+zTXo4mjZ4ffoxb//R0/+vdTE7IvaLgfAZgFsLKJCtYDDstXZj8ujQnGR9Pig3R\nW+LpNacvOOSJSawNQq0Xrlcu55AU4buyD5VjcICnfF1dqBMnGTnh27m/scd/ZMx/\nkapHZ/fMoK2mAgSX/NvUKF3UkhT85vSSM2BTtET33DzCPDQTZQYxFBa4rFRmFi4c\nBLlmIReiCGyh3eJhuUUuYAbK6wLaRyPsyEcIOLMQmZe1+gAFm1+1/q5Ke9ugBmjf\nPbTWjsi/lfZ5CdVAhc5lmZj/l5aKqwaS\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjSgAwIBAgIRAKKPTYKln9L4NTx9dpZGUjowCgYIKoZIzj0EAwMwgZYx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1h\nem9uIFJEUyBldS13ZXN0LTIgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTIxMjI1NTIxWhgPMjEyMTA1MjEyMzU1MjFaMIGWMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExLzAtBgNVBAMMJkFtYXpvbiBS\nRFMgZXUtd2VzdC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdTZWF0dGxl\nMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAE/owTReDvaRqdmbtTzXbyRmEpKCETNj6O\nhZMKH0F8oU9Tmn8RU7kQQj6xUKEyjLPrFBN7c+26TvrVO1KmJAvbc8bVliiJZMbc\nC0yV5PtJTalvlMZA1NnciZuhxaxrzlK1o0IwQDAPBgNVHRMBAf8EBTADAQH/MB0G\nA1UdDgQWBBT4i5HaoHtrs7Mi8auLhMbKM1XevDAOBgNVHQ8BAf8EBAMCAYYwCgYI\nKoZIzj0EAwMDaAAwZQIxAK9A+8/lFdX4XJKgfP+ZLy5ySXC2E0Spoy12Gv2GdUEZ\np1G7c1KbWVlyb1d6subzkQIwKyH0Naf/3usWfftkmq8SzagicKz5cGcEUaULq4tO\nGzA/AMpr63IDBAqkZbMDTCmH\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrzCCAjWgAwIBAgIQTgIvwTDuNWQo0Oe1sOPQEzAKBggqhkjOPQQDAzCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGV1LW5vcnRoLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTI0MjEwNjM4WhgPMjEyMTA1MjQyMjA2MzhaMIGXMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpvbiBS\nRFMgZXUtbm9ydGgtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwHU2VhdHRs\nZTB2MBAGByqGSM49AgEGBSuBBAAiA2IABJuzXLU8q6WwSKXBvx8BbdIi3mPhb7Xo\nrNJBfuMW1XRj5BcKH1ZoGaDGw+BIIwyBJg8qNmCK8kqIb4cH8/Hbo3Y+xBJyoXq/\ncuk8aPrxiNoRsKWwiDHCsVxaK9L7GhHHAqNCMEAwDwYDVR0TAQH/BAUwAwEB/zAd\nBgNVHQ4EFgQUYgcsdU4fm5xtuqLNppkfTHM2QMYwDgYDVR0PAQH/BAQDAgGGMAoG\nCCqGSM49BAMDA2gAMGUCMQDz/Rm89+QJOWJecYAmYcBWCcETASyoK1kbr4vw7Hsg\n7Ew3LpLeq4IRmTyuiTMl0gMCMAa0QSjfAnxBKGhAnYxcNJSntUyyMpaXzur43ec0\n3D8npJghwC4DuICtKEkQiI5cSg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nu3UBpZI=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICtDCCAjmgAwIBAgIQenQbcP/Zbj9JxvZ+jXbRnTAKBggqhkjOPQQDAzCBmTEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTIwMAYDVQQDDClBbWF6\nb24gUkRTIGV1LWNlbnRyYWwtMSBSb290IENBIEVDQzM4NCBHMTEQMA4GA1UEBwwH\nU2VhdHRsZTAgFw0yMTA1MjEyMjMzMjRaGA8yMTIxMDUyMTIzMzMyNFowgZkxCzAJ\nBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMuMRMw\nEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEyMDAGA1UEAwwpQW1hem9u\nIFJEUyBldS1jZW50cmFsLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwdjAQBgcqhkjOPQIBBgUrgQQAIgNiAATlBHiEM9LoEb1Hdnd5j2VpCDOU\n5nGuFoBD8ROUCkFLFh5mHrHfPXwBc63heW9WrP3qnDEm+UZEUvW7ROvtWCTPZdLz\nZ4XaqgAlSqeE2VfUyZOZzBSgUUJk7OlznXfkCMOjQjBAMA8GA1UdEwEB/wQFMAMB\nAf8wHQYDVR0OBBYEFDT/ThjQZl42Nv/4Z/7JYaPNMly2MA4GA1UdDwEB/wQEAwIB\nhjAKBggqhkjOPQQDAwNpADBmAjEAnZWmSgpEbmq+oiCa13l5aGmxSlfp9h12Orvw\nDq/W5cENJz891QD0ufOsic5oGq1JAjEAp5kSJj0MxJBTHQze1Aa9gG4sjHBxXn98\n4MP1VGsQuhfndNHQb4V0Au7OWnOeiobq\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/zCCAuegAwIBAgIRAMgnyikWz46xY6yRgiYwZ3swDQYJKoZIhvcNAQELBQAw\ngZcxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEwMC4GA1UEAwwn\nQW1hem9uIFJEUyBldS13ZXN0LTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyMDE2NDkxMloYDzIwNjEwNTIwMTc0OTEyWjCBlzEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6\nb24gUkRTIGV1LXdlc3QtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCi8JYOc9cYSgZH\ngYPxLk6Xcc7HqzamvsnjYU98Dcb98y6iDqS46Ra2Ne02MITtU5MDL+qjxb8WGDZV\nRUA9ZS69tkTO3gldW8QdiSh3J6hVNJQW81F0M7ZWgV0gB3n76WCmfT4IWos0AXHM\n5v7M/M4tqVmCPViQnZb2kdVlM3/Xc9GInfSMCgNfwHPTXl+PXX+xCdNBePaP/A5C\n5S0oK3HiXaKGQAy3K7VnaQaYdiv32XUatlM4K2WS4AMKt+2cw3hTCjlmqKRHvYFQ\nveWCXAuc+U5PQDJ9SuxB1buFJZhT4VP3JagOuZbh5NWpIbOTxlAJOb5pGEDuJTKi\n1gQQQVEFAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFNXm+N87\nOFxK9Af/bjSxDCiulGUzMA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG9w0BAQsFAAOC\nAQEAkqIbkgZ45spvrgRQ6n9VKzDLvNg+WciLtmVrqyohwwJbj4pYvWwnKQCkVc7c\nhUOSBmlSBa5REAPbH5o8bdt00FPRrD6BdXLXhaECKgjsHe1WW08nsequRKD8xVmc\n8bEX6sw/utBeBV3mB+3Zv7ejYAbDFM4vnRsWtO+XqgReOgrl+cwdA6SNQT9oW3e5\nrSQ+VaXgJtl9NhkiIysq9BeYigxqS/A13pHQp0COMwS8nz+kBPHhJTsajHCDc8F4\nHfLi6cgs9G0gaRhT8FCH66OdGSqn196sE7Y3bPFFFs/3U+vxvmQgoZC6jegQXAg5\nPrxd+VNXtNI/azitTysQPumH7A==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEBTCCAu2gAwIBAgIRAO8bekN7rUReuNPG8pSTKtEwDQYJKoZIhvcNAQELBQAw\ngZoxCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJ\nbmMuMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEzMDEGA1UEAwwq\nQW1hem9uIFJEUyBldS1jZW50cmFsLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYD\nVQQHDAdTZWF0dGxlMCAXDTIxMDUyMTIyMjM0N1oYDzIwNjEwNTIxMjMyMzQ3WjCB\nmjELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTMwMQYDVQQDDCpB\nbWF6b24gUkRTIGV1LWNlbnRyYWwtMSBSb290IENBIFJTQTIwNDggRzExEDAOBgNV\nBAcMB1NlYXR0bGUwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCTTYds\nTray+Q9VA5j5jTh5TunHKFQzn68ZbOzdqaoi/Rq4ohfC0xdLrxCpfqn2TGDHN6Zi\n2qGK1tWJZEd1H0trhzd9d1CtGK+3cjabUmz/TjSW/qBar7e9MA67/iJ74Gc+Ww43\nA0xPNIWcL4aLrHaLm7sHgAO2UCKsrBUpxErOAACERScVYwPAfu79xeFcX7DmcX+e\nlIqY16pQAvK2RIzrekSYfLFxwFq2hnlgKHaVgZ3keKP+nmXcXmRSHQYUUr72oYNZ\nHcNYl2+gxCc9ccPEHM7xncVEKmb5cWEWvVoaysgQ+osi5f5aQdzgC2X2g2daKbyA\nXL/z5FM9GHpS5BJjAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYE\nFBDAiJ7Py9/A9etNa/ebOnx5l5MGMA4GA1UdDwEB/wQEAwIBhjANBgkqhkiG9w0B\nAQsFAAOCAQEALMh/+81fFPdJV/RrJUeoUvFCGMp8iaANu97NpeJyKitNOv7RoeVP\nWjivS0KcCqZaDBs+p6IZ0sLI5ZH098LDzzytcfZg0PsGqUAb8a0MiU/LfgDCI9Ee\njsOiwaFB8k0tfUJK32NPcIoQYApTMT2e26lPzYORSkfuntme2PTHUnuC7ikiQrZk\nP+SZjWgRuMcp09JfRXyAYWIuix4Gy0eZ4rpRuaTK6mjAb1/LYoNK/iZ/gTeIqrNt\nl70OWRsWW8jEmSyNTIubGK/gGGyfuZGSyqoRX6OKHESkP6SSulbIZHyJ5VZkgtXo\n2XvyRyJ7w5pFyoofrL3Wv0UF8yt/GDszmg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\n2jpC\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nFEv9Bg==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICsDCCAjagAwIBAgIRAMgApnfGYPpK/fD0dbN2U4YwCgYIKoZIzj0EAwMwgZcx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEwMC4GA1UEAwwnQW1h\nem9uIFJEUyBldS1zb3V0aC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMCAXDTIxMDUxOTE4MzgxMVoYDzIxMjEwNTE5MTkzODExWjCBlzELMAkG\nA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4xEzAR\nBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdBbWF6b24g\nUkRTIGV1LXNvdXRoLTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1NlYXR0\nbGUwdjAQBgcqhkjOPQIBBgUrgQQAIgNiAAQfEWl6d4qSuIoECdZPp+39LaKsfsX7\nTHs3/RrtT0+h/jl3bjZ7Qc68k16x+HGcHbaayHfqD0LPdzH/kKtNSfQKqemdxDQh\nZ4pwkixJu8T1VpXZ5zzCvBXCl75UqgEFS92jQjBAMA8GA1UdEwEB/wQFMAMBAf8w\nHQYDVR0OBBYEFFPrSNtWS5JU+Tvi6ABV231XbjbEMA4GA1UdDwEB/wQEAwIBhjAK\nBggqhkjOPQQDAwNoADBlAjEA+a7hF1IrNkBd2N/l7IQYAQw8chnRZDzh4wiGsZsC\n6A83maaKFWUKIb3qZYXFSi02AjAbp3wxH3myAmF8WekDHhKcC2zDvyOiKLkg9Y6v\nZVmyMR043dscQbcsVoacOYv198c=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICtDCCAjqgAwIBAgIRAPhVkIsQ51JFhD2kjFK5uAkwCgYIKoZIzj0EAwMwgZkx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEyMDAGA1UEAwwpQW1h\nem9uIFJEUyBldS1jZW50cmFsLTIgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjIwNjA2MjEyOTE3WhgPMjEyMjA2MDYyMjI5MTdaMIGZMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMjAwBgNVBAMMKUFtYXpv\nbiBSRFMgZXUtY2VudHJhbC0yIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEA5xnIEBtG5b2nmbj49UEwQza\nyX0844fXjccYzZ8xCDUe9dS2XOUi0aZlGblgSe/3lwjg8fMcKXLObGGQfgIx1+5h\nAIBjORis/dlyN5q/yH4U5sjS8tcR0GDGVHrsRUZCo0IwQDAPBgNVHRMBAf8EBTAD\nAQH/MB0GA1UdDgQWBBRK+lSGutXf4DkTjR3WNfv4+KeNFTAOBgNVHQ8BAf8EBAMC\nAYYwCgYIKoZIzj0EAwMDaAAwZQIxAJ4NxQ1Gerqr70ZrnUqc62Vl8NNqTzInamCG\nKce3FTsMWbS9qkgrjZkO9QqOcGIw/gIwSLrwUT+PKr9+H9eHyGvpq9/3AIYSnFkb\nCf3dyWPiLKoAtLFwjzB/CkJlsAS1c8dS\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIF/jCCA+agAwIBAgIQGZH12Q7x41qIh9vDu9ikTjANBgkqhkiG9w0BAQwFADCB\nlzELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdB\nbWF6b24gUkRTIGV1LXdlc3QtMyBSb290IENBIFJTQTQwOTYgRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjEwNTI1MjIyMjMzWhgPMjEyMTA1MjUyMzIyMzNaMIGXMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpv\nbiBSRFMgZXUtd2VzdC0zIFJvb3QgQ0EgUlNBNDA5NiBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoCggIBAMqE47sHXWzdpuqj\nJHb+6jM9tDbQLDFnYjDWpq4VpLPZhb7xPNh9gnYYTPKG4avG421EblAHqzy9D2pN\n1z90yKbIfUb/Sy2MhQbmZomsObhONEra06fJ0Dydyjswf1iYRp2kwpx5AgkVoNo7\n3dlws73zFjD7ImKvUx2C7B75bhnw2pJWkFnGcswl8fZt9B5Yt95sFOKEz2MSJE91\nkZlHtya19OUxZ/cSGci4MlOySzqzbGwUqGxEIDlY8I39VMwXaYQ8uXUN4G780VcL\nu46FeyRGxZGz2n3hMc805WAA1V5uir87vuirTvoSVREET97HVRGVVNJJ/FM6GXr1\nVKtptybbo81nefYJg9KBysxAa2Ao2x2ry/2ZxwhS6VZ6v1+90bpZA1BIYFEDXXn/\ndW07HSCFnYSlgPtSc+Muh15mdr94LspYeDqNIierK9i4tB6ep7llJAnq0BU91fM2\nJPeqyoTtc3m06QhLf68ccSxO4l8Hmq9kLSHO7UXgtdjfRVaffngopTNk8qK7bIb7\nLrgkqhiQw/PRCZjUdyXL153/fUcsj9nFNe25gM4vcFYwH6c5trd2tUl31NTi1MfG\nMgp3d2dqxQBIYANkEjtBDMy3SqQLIo9EymqmVP8xx2A/gCBgaxvMAsI6FSWRoC7+\nhqJ8XH4mFnXSHKtYMe6WPY+/XZgtAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMBAf8w\nHQYDVR0OBBYEFIkXqTnllT/VJnI2NqipA4XV8rh1MA4GA1UdDwEB/wQEAwIBhjAN\nBgkqhkiG9w0BAQwFAAOCAgEAKjSle8eenGeHgT8pltWCw/HzWyQruVKhfYIBfKJd\nMhV4EnH5BK7LxBIvpXGsFUrb0ThzSw0fn0zoA9jBs3i/Sj6KyeZ9qUF6b8ycDXd+\nwHonmJiQ7nk7UuMefaYAfs06vosgl1rI7eBHC0itexIQmKh0aX+821l4GEgEoSMf\nloMFTLXv2w36fPHHCsZ67ODldgcZbKNnpCTX0YrCwEYO3Pz/L398btiRcWGrewrK\njdxAAyietra8DRno1Zl87685tfqc6HsL9v8rVw58clAo9XAQvT+fmSOFw/PogRZ7\nOMHUat3gu/uQ1M5S64nkLLFsKu7jzudBuoNmcJysPlzIbqJ7vYc82OUGe9ucF3wi\n3tbKQ983hdJiTExVRBLX/fYjPsGbG3JtPTv89eg2tjWHlPhCDMMxyRKl6isu2RTq\n6VT489Z2zQrC33MYF8ZqO1NKjtyMAMIZwxVu4cGLkVsqFmEV2ScDHa5RadDyD3Ok\nm+mqybhvEVm5tPgY6p0ILPMN3yvJsMSPSvuBXhO/X5ppNnpw9gnxpwbjQKNhkFaG\nM5pkADZ14uRguOLM4VthSwUSEAr5VQYCFZhEwK+UOyJAGiB/nJz6IxL5XBNUXmRM\nHl8Xvz4riq48LMQbjcVQj0XvH941yPh+P8xOi00SGaQRaWp55Vyr4YKGbV0mEDz1\nr1o=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nwOx+\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\n89cEIGdbjsA=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEADCCAuigAwIBAgIQYjbPSg4+RNRD3zNxO1fuKDANBgkqhkiG9w0BAQsFADCB\nmDELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChB\nbWF6b24gUkRTIGV1LW5vcnRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUyNDIwNTkyMVoYDzIwNjEwNTI0MjE1OTIxWjCBmDEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChBbWF6\nb24gUkRTIGV1LW5vcnRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA179eQHxcV0YL\nXMkqEmhSBazHhnRVd8yICbMq82PitE3BZcnv1Z5Zs/oOgNmMkOKae4tCXO/41JCX\nwAgbs/eWWi+nnCfpQ/FqbLPg0h3dqzAgeszQyNl9IzTzX4Nd7JFRBVJXPIIKzlRf\n+GmFsAhi3rYgDgO27pz3ciahVSN+CuACIRYnA0K0s9lhYdddmrW/SYeWyoB7jPa2\nLmWpAs7bDOgS4LlP2H3eFepBPgNufRytSQUVA8f58lsE5w25vNiUSnrdlvDrIU5n\nQwzc7NIZCx4qJpRbSKWrUtbyJriWfAkGU7i0IoainHLn0eHp9bWkwb9D+C/tMk1X\nERZw2PDGkwIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBSFmR7s\ndAblusFN+xhf1ae0KUqhWTAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZIhvcNAQELBQAD\nggEBAHsXOpjPMyH9lDhPM61zYdja1ebcMVgfUvsDvt+w0xKMKPhBzYDMs/cFOi1N\nQ8LV79VNNfI2NuvFmGygcvTIR+4h0pqqZ+wjWl3Kk5jVxCrbHg3RBX02QLumKd/i\nkwGcEtTUvTssn3SM8bgM0/1BDXgImZPC567ciLvWDo0s/Fe9dJJC3E0G7d/4s09n\nOMdextcxFuWBZrBm/KK3QF0ByA8MG3//VXaGO9OIeeOJCpWn1G1PjT1UklYhkg61\nEbsTiZVA2DLd1BGzfU4o4M5mo68l0msse/ndR1nEY6IywwpgIFue7+rEleDh6b9d\nPYkG1rHVw2I0XDG4o17aOn5E94I=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEADCCAuigAwIBAgIQC6W4HFghUkkgyQw14a6JljANBgkqhkiG9w0BAQsFADCB\nmDELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChB\nbWF6b24gUkRTIGV1LXNvdXRoLTIgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIyMDUyMzE4MTYzMloYDzIwNjIwNTIzMTkxNjMyWjCBmDEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChBbWF6\nb24gUkRTIGV1LXNvdXRoLTIgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAiM/t4FV2R9Nx\nUQG203UY83jInTa/6TMq0SPyg617FqYZxvz2kkx09x3dmxepUg9ttGMlPgjsRZM5\nLCFEi1FWk+hxHzt7vAdhHES5tdjwds3aIkgNEillmRDVrUsbrDwufLaa+MMDO2E1\nwQ/JYFXw16WBCCi2g1EtyQ2Xp+tZDX5IWOTnvhZpW8vVDptZ2AcJ5rMhfOYO3OsK\n5EF0GGA5ldzuezP+BkrBYGJ4wVKGxeaq9+5AT8iVZrypjwRkD7Y5CurywK3+aBwm\ns9Q5Nd8t45JCOUzYp92rFKsCriD86n/JnEvgDfdP6Hvtm0/DkwXK40Wz2q0Zrd0k\nmjP054NRPwIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBRR7yqd\nSfKcX2Q8GzhcVucReIpewTAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZIhvcNAQELBQAD\nggEBAEszBRDwXcZyNm07VcFwI1Im94oKwKccuKYeJEsizTBsVon8VpEiMwDs+yGu\n3p8kBhvkLwWybkD/vv6McH7T5b9jDX2DoOudqYnnaYeypsPH/00Vh3LvKagqzQza\norWLx+0tLo8xW4BtU+Wrn3JId8LvAhxyYXTn9bm+EwPcStp8xGLwu53OPD1RXYuy\nuu+3ps/2piP7GVfou7H6PRaqbFHNfiGg6Y+WA0HGHiJzn8uLmrRJ5YRdIOOG9/xi\nqTmAZloUNM7VNuurcMM2hWF494tQpsQ6ysg2qPjbBqzlGoOt3GfBTOZmqmwmqtam\nK7juWM/mdMQAJ3SMlE5wI8nVdx4=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIICrjCCAjSgAwIBAgIRAL9SdzVPcpq7GOpvdGoM80IwCgYIKoZIzj0EAwMwgZYx\nCzAJBgNVBAYTAlVTMSIwIAYDVQQKDBlBbWF6b24gV2ViIFNlcnZpY2VzLCBJbmMu\nMRMwEQYDVQQLDApBbWF6b24gUkRTMQswCQYDVQQIDAJXQTEvMC0GA1UEAwwmQW1h\nem9uIFJEUyBldS13ZXN0LTEgUm9vdCBDQSBFQ0MzODQgRzExEDAOBgNVBAcMB1Nl\nYXR0bGUwIBcNMjEwNTIwMTY1ODA3WhgPMjEyMTA1MjAxNzU4MDdaMIGWMQswCQYD\nVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjETMBEG\nA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExLzAtBgNVBAMMJkFtYXpvbiBS\nRFMgZXUtd2VzdC0xIFJvb3QgQ0EgRUNDMzg0IEcxMRAwDgYDVQQHDAdTZWF0dGxl\nMHYwEAYHKoZIzj0CAQYFK4EEACIDYgAEJWDgXebvwjR+Ce+hxKOLbnsfN5W5dOlP\nZn8kwWnD+SLkU81Eac/BDJsXGrMk6jFD1vg16PEkoSevsuYWlC8xR6FmT6F6pmeh\nfsMGOyJpfK4fyoEPhKeQoT23lFIc5Orjo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0G\nA1UdDgQWBBSVNAN1CHAz0eZ77qz2adeqjm31TzAOBgNVHQ8BAf8EBAMCAYYwCgYI\nKoZIzj0EAwMDaAAwZQIxAMlQeHbcjor49jqmcJ9gRLWdEWpXG8thIf6zfYQ/OEAg\nd7GDh4fR/OUk0VfjsBUN/gIwZB0bGdXvK38s6AAE/9IT051cz/wMe9GIrX1MnL1T\n1F5OqnXJdiwfZRRTHsRQ/L00\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\n1YfpdH2jp30=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID/jCCAuagAwIBAgIQTDc+UgTRtYO7ZGTQ8UWKDDANBgkqhkiG9w0BAQsFADCB\nlzELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTAwLgYDVQQDDCdB\nbWF6b24gUkRTIGV1LXdlc3QtMiBSb290IENBIFJTQTIwNDggRzExEDAOBgNVBAcM\nB1NlYXR0bGUwIBcNMjEwNTIxMjI0NjI0WhgPMjA2MTA1MjEyMzQ2MjRaMIGXMQsw\nCQYDVQQGEwJVUzEiMCAGA1UECgwZQW1hem9uIFdlYiBTZXJ2aWNlcywgSW5jLjET\nMBEGA1UECwwKQW1hem9uIFJEUzELMAkGA1UECAwCV0ExMDAuBgNVBAMMJ0FtYXpv\nbiBSRFMgZXUtd2VzdC0yIFJvb3QgQ0EgUlNBMjA0OCBHMTEQMA4GA1UEBwwHU2Vh\ndHRsZTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAM1oGtthQ1YiVIC2\ni4u4swMAGxAjc/BZp0yq0eP5ZQFaxnxs7zFAPabEWsrjeDzrRhdVO0h7zskrertP\ngblGhfD20JfjvCHdP1RUhy/nzG+T+hn6Takan/GIgs8grlBMRHMgBYHW7tklhjaH\n3F7LujhceAHhhgp6IOrpb6YTaTTaJbF3GTmkqxSJ3l1LtEoWz8Al/nL/Ftzxrtez\nVs6ebpvd7sw37sxmXBWX2OlvUrPCTmladw9OrllGXtCFw4YyLe3zozBlZ3cHzQ0q\nlINhpRcajTMfZrsiGCkQtoJT+AqVJPS2sHjqsEH8yiySW9Jbq4zyMbM1yqQ2vnnx\nMJgoYMcCAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUaQG88UnV\nJPTI+Pcti1P+q3H7pGYwDgYDVR0PAQH/BAQDAgGGMA0GCSqGSIb3DQEBCwUAA4IB\nAQBAkgr75V0sEJimC6QRiTVWEuj2Khy7unjSfudbM6zumhXEU2/sUaVLiYy6cA/x\n3v0laDle6T07x9g64j5YastE/4jbzrGgIINFlY0JnaYmR3KZEjgi1s1fkRRf3llL\nPJm9u4Q1mbwAMQK/ZjLuuRcL3uRIHJek18nRqT5h43GB26qXyvJqeYYpYfIjL9+/\nYiZAbSRRZG+Li23cmPWrbA1CJY121SB+WybCbysbOXzhD3Sl2KSZRwSw4p2HrFtV\n1Prk0dOBtZxCG9luf87ultuDZpfS0w6oNBAMXocgswk24ylcADkkFxBWW+7BETn1\nEpK+t1Lm37mU4sxtuha00XAi\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIEADCCAuigAwIBAgIQcY44/8NUvBwr6LlHfRy7KjANBgkqhkiG9w0BAQsFADCB\nmDELMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIElu\nYy4xEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChB\nbWF6b24gUkRTIGV1LXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQH\nDAdTZWF0dGxlMCAXDTIxMDUxOTE4MjcxOFoYDzIwNjEwNTE5MTkyNzE4WjCBmDEL\nMAkGA1UEBhMCVVMxIjAgBgNVBAoMGUFtYXpvbiBXZWIgU2VydmljZXMsIEluYy4x\nEzARBgNVBAsMCkFtYXpvbiBSRFMxCzAJBgNVBAgMAldBMTEwLwYDVQQDDChBbWF6\nb24gUkRTIGV1LXNvdXRoLTEgUm9vdCBDQSBSU0EyMDQ4IEcxMRAwDgYDVQQHDAdT\nZWF0dGxlMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEA0UaBeC+Usalu\nEtXnV7+PnH+gi7/71tI/jkKVGKuhD2JDVvqLVoqbMHRh3+wGMvqKCjbHPcC2XMWv\n566fpAj4UZ9CLB5fVzss+QVNTl+FH2XhEzigopp+872ajsNzcZxrMkifxGb4i0U+\nt0Zi+UrbL5tsfP2JonKR1crOrbS6/DlzHBjIiJazGOQcMsJjNuTOItLbMohLpraA\n/nApa3kOvI7Ufool1/34MG0+wL3UUA4YkZ6oBJVxjZvvs6tI7Lzz/SnhK2widGdc\nsnbLqBpHNIZQSorVoiwcFaRBGYX/uzYkiw44Yfa4cK2V/B5zgu1Fbr0gbI2am4eh\nyVYyg4jPawIDAQABo0IwQDAPBgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBS9gM1m\nIIjyh9O5H/7Vj0R/akI7UzAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZIhvcNAQELBQAD\nggEBAF0Sm9HC2AUyedBVnwgkVXMibnYChOzz7T+0Y+fOLXYAEXex2s8oqGeZdGYX\nJHkjBn7JXu7LM+TpTbPbFFDoc1sgMguD/ls+8XsqAl1CssW+amryIL+jfcfbgQ+P\nICwEUD9hGdjBgJ5WcuS+qqxHsEIlFNci3HxcxfBa9VsWs5TjI7Vsl4meL5lf7ZyL\nwDV7dHRuU+cImqG1MIvPRIlvPnT7EghrCYi2VCPhP2pM/UvShuwVnkz4MJ29ebIk\nWR9kpblFxFdE92D5UUvMCjC2kmtgzNiErvTcwIvOO9YCbBHzRB1fFiWrXUHhJWq9\nIkaxR5icb/IpAV0A1lYZEWMVsfQ=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----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\nrM2p0kk=\n-----END CERTIFICATE-----\n"
  ];
});
var require_proxies = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.proxies = undefined;
  exports.proxies = [
    "-----BEGIN CERTIFICATE-----\nMIIDQTCCAimgAwIBAgITBmyfz5m/jAo54vB4ikPmljZbyjANBgkqhkiG9w0BAQsF\nADA5MQswCQYDVQQGEwJVUzEPMA0GA1UEChMGQW1hem9uMRkwFwYDVQQDExBBbWF6\nb24gUm9vdCBDQSAxMB4XDTE1MDUyNjAwMDAwMFoXDTM4MDExNzAwMDAwMFowOTEL\nMAkGA1UEBhMCVVMxDzANBgNVBAoTBkFtYXpvbjEZMBcGA1UEAxMQQW1hem9uIFJv\nb3QgQ0EgMTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALJ4gHHKeNXj\nca9HgFB0fW7Y14h29Jlo91ghYPl0hAEvrAIthtOgQ3pOsqTQNroBvo3bSMgHFzZM\n9O6II8c+6zf1tRn4SWiw3te5djgdYZ6k/oI2peVKVuRF4fn9tBb6dNqcmzU5L/qw\nIFAGbHrQgLKm+a/sRxmPUDgH3KKHOVj4utWp+UhnMJbulHheb4mjUcAwhmahRWa6\nVOujw5H5SNz/0egwLX0tdHA114gk957EWW67c4cX8jJGKLhD+rcdqsq08p8kDi1L\n93FcXmn/6pUCyziKrlA4b9v7LWIbxcceVOF34GfID5yHI9Y/QCB/IIDEgEw+OyQm\njgSubJrIqg0CAwEAAaNCMEAwDwYDVR0TAQH/BAUwAwEB/zAOBgNVHQ8BAf8EBAMC\nAYYwHQYDVR0OBBYEFIQYzIU07LwMlJQuCFmcx7IQTgoIMA0GCSqGSIb3DQEBCwUA\nA4IBAQCY8jdaQZChGsV2USggNiMOruYou6r4lK5IpDB/G/wkjUu0yKGX9rbxenDI\nU5PMCCjjmCXPI6T53iHTfIUJrU6adTrCC2qJeHZERxhlbI1Bjjt/msv0tadQ1wUs\nN+gDS63pYaACbvXy8MWy7Vu33PqUXHeeE6V/Uq2V8viTO96LXFvKWlJbYK8U90vv\no/ufQJVtMVT8QtPHRh8jrdkPSHCa2XV4cdFyQzR1bldZwgJcJmApzyMZFo6IQ6XU\n5MsI+yMRQ+hDKXJioaldXgjUkK642M4UwtBV8ob2xJNDd2ZhwLnoQdeXeGADbkpy\nrqXRfboQnoZsG4q5WTP468SQvvG5\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIFQTCCAymgAwIBAgITBmyf0pY1hp8KD+WGePhbJruKNzANBgkqhkiG9w0BAQwF\nADA5MQswCQYDVQQGEwJVUzEPMA0GA1UEChMGQW1hem9uMRkwFwYDVQQDExBBbWF6\nb24gUm9vdCBDQSAyMB4XDTE1MDUyNjAwMDAwMFoXDTQwMDUyNjAwMDAwMFowOTEL\nMAkGA1UEBhMCVVMxDzANBgNVBAoTBkFtYXpvbjEZMBcGA1UEAxMQQW1hem9uIFJv\nb3QgQ0EgMjCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoCggIBAK2Wny2cSkxK\ngXlRmeyKy2tgURO8TW0G/LAIjd0ZEGrHJgw12MBvIITplLGbhQPDW9tK6Mj4kHbZ\nW0/jTOgGNk3Mmqw9DJArktQGGWCsN0R5hYGCrVo34A3MnaZMUnbqQ523BNFQ9lXg\n1dKmSYXpN+nKfq5clU1Imj+uIFptiJXZNLhSGkOQsL9sBbm2eLfq0OQ6PBJTYv9K\n8nu+NQWpEjTj82R0Yiw9AElaKP4yRLuH3WUnAnE72kr3H9rN9yFVkE8P7K6C4Z9r\n2UXTu/Bfh+08LDmG2j/e7HJV63mjrdvdfLC6HM783k81ds8P+HgfajZRRidhW+me\nz/CiVX18JYpvL7TFz4QuK/0NURBs+18bvBt+xa47mAExkv8LV/SasrlX6avvDXbR\n8O70zoan4G7ptGmh32n2M8ZpLpcTnqWHsFcQgTfJU7O7f/aS0ZzQGPSSbtqDT6Zj\nmUyl+17vIWR6IF9sZIUVyzfpYgwLKhbcAS4y2j5L9Z469hdAlO+ekQiG+r5jqFoz\n7Mt0Q5X5bGlSNscpb/xVA1wf+5+9R+vnSUeVC06JIglJ4PVhHvG/LopyboBZ/1c6\n+XUyo05f7O0oYtlNc/LMgRdg7c3r3NunysV+Ar3yVAhU/bQtCSwXVEqY0VThUWcI\n0u1ufm8/0i2BWSlmy5A5lREedCf+3euvAgMBAAGjQjBAMA8GA1UdEwEB/wQFMAMB\nAf8wDgYDVR0PAQH/BAQDAgGGMB0GA1UdDgQWBBSwDPBMMPQFWAJI/TPlUq9LhONm\nUjANBgkqhkiG9w0BAQwFAAOCAgEAqqiAjw54o+Ci1M3m9Zh6O+oAA7CXDpO8Wqj2\nLIxyh6mx/H9z/WNxeKWHWc8w4Q0QshNabYL1auaAn6AFC2jkR2vHat+2/XcycuUY\n+gn0oJMsXdKMdYV2ZZAMA3m3MSNjrXiDCYZohMr/+c8mmpJ5581LxedhpxfL86kS\nk5Nrp+gvU5LEYFiwzAJRGFuFjWJZY7attN6a+yb3ACfAXVU3dJnJUH/jWS5E4ywl\n7uxMMne0nxrpS10gxdr9HIcWxkPo1LsmmkVwXqkLN1PiRnsn/eBG8om3zEK2yygm\nbtmlyTrIQRNg91CMFa6ybRoVGld45pIq2WWQgj9sAq+uEjonljYE1x2igGOpm/Hl\nurR8FLBOybEfdF849lHqm/osohHUqS0nGkWxr7JOcQ3AWEbWaQbLU8uz/mtBzUF+\nfUwPfHJ5elnNXkoOrJupmHN5fLT0zLm4BwyydFy4x2+IoZCn9Kr5v2c69BoVYh63\nn749sSmvZ6ES8lgQGVMDMBu4Gon2nL2XA46jCfMdiyHxtN/kHNGfZQIG6lzWE7OE\n76KlXIx3KadowGuuQNKotOrN8I1LOJwZmhsoVLiJkO/KdYE+HvJkJMcYr07/R54H\n9jVlpNMKVv/1F2Rs76giJUmTtt8AF9pYfl3uxRuw0dFfIRDH+fO6AgonB8Xx1sfT\n4PsJYGw=\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIBtjCCAVugAwIBAgITBmyf1XSXNmY/Owua2eiedgPySjAKBggqhkjOPQQDAjA5\nMQswCQYDVQQGEwJVUzEPMA0GA1UEChMGQW1hem9uMRkwFwYDVQQDExBBbWF6b24g\nUm9vdCBDQSAzMB4XDTE1MDUyNjAwMDAwMFoXDTQwMDUyNjAwMDAwMFowOTELMAkG\nA1UEBhMCVVMxDzANBgNVBAoTBkFtYXpvbjEZMBcGA1UEAxMQQW1hem9uIFJvb3Qg\nQ0EgMzBZMBMGByqGSM49AgEGCCqGSM49AwEHA0IABCmXp8ZBf8ANm+gBG1bG8lKl\nui2yEujSLtf6ycXYqm0fc4E7O5hrOXwzpcVOho6AF2hiRVd9RFgdszflZwjrZt6j\nQjBAMA8GA1UdEwEB/wQFMAMBAf8wDgYDVR0PAQH/BAQDAgGGMB0GA1UdDgQWBBSr\nttvXBp43rDCGB5Fwx5zEGbF4wDAKBggqhkjOPQQDAgNJADBGAiEA4IWSoxe3jfkr\nBqWTrBqYaGFy+uGh0PsceGCmQ5nFuMQCIQCcAu/xlJyzlvnrxir4tiz+OpAUFteM\nYyRIHN8wfdVoOw==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIIB8jCCAXigAwIBAgITBmyf18G7EEwpQ+Vxe3ssyBrBDjAKBggqhkjOPQQDAzA5\nMQswCQYDVQQGEwJVUzEPMA0GA1UEChMGQW1hem9uMRkwFwYDVQQDExBBbWF6b24g\nUm9vdCBDQSA0MB4XDTE1MDUyNjAwMDAwMFoXDTQwMDUyNjAwMDAwMFowOTELMAkG\nA1UEBhMCVVMxDzANBgNVBAoTBkFtYXpvbjEZMBcGA1UEAxMQQW1hem9uIFJvb3Qg\nQ0EgNDB2MBAGByqGSM49AgEGBSuBBAAiA2IABNKrijdPo1MN/sGKe0uoe0ZLY7Bi\n9i0b2whxIdIA6GO9mif78DluXeo9pcmBqqNbIJhFXRbb/egQbeOc4OO9X4Ri83Bk\nM6DLJC9wuoihKqB1+IGuYgbEgds5bimwHvouXKNCMEAwDwYDVR0TAQH/BAUwAwEB\n/zAOBgNVHQ8BAf8EBAMCAYYwHQYDVR0OBBYEFNPsxzplbszh2naaVvuc84ZtV+WB\nMAoGCCqGSM49BAMDA2gAMGUCMDqLIfG9fhGt0O9Yli/W651+kI0rz2ZVwyzjKKlw\nCkcO8DdZEv8tmZQoTipPNU0zWgIxAOp1AE47xDqUEpHJWEadIRNyp4iciuRMStuW\n1KyLa2tJElMzrdfkviT8tQp21KW8EA==\n-----END CERTIFICATE-----\n",
    "-----BEGIN CERTIFICATE-----\nMIID7zCCAtegAwIBAgIBADANBgkqhkiG9w0BAQsFADCBmDELMAkGA1UEBhMCVVMx\nEDAOBgNVBAgTB0FyaXpvbmExEzARBgNVBAcTClNjb3R0c2RhbGUxJTAjBgNVBAoT\nHFN0YXJmaWVsZCBUZWNobm9sb2dpZXMsIEluYy4xOzA5BgNVBAMTMlN0YXJmaWVs\nZCBTZXJ2aWNlcyBSb290IENlcnRpZmljYXRlIEF1dGhvcml0eSAtIEcyMB4XDTA5\nMDkwMTAwMDAwMFoXDTM3MTIzMTIzNTk1OVowgZgxCzAJBgNVBAYTAlVTMRAwDgYD\nVQQIEwdBcml6b25hMRMwEQYDVQQHEwpTY290dHNkYWxlMSUwIwYDVQQKExxTdGFy\nZmllbGQgVGVjaG5vbG9naWVzLCBJbmMuMTswOQYDVQQDEzJTdGFyZmllbGQgU2Vy\ndmljZXMgUm9vdCBDZXJ0aWZpY2F0ZSBBdXRob3JpdHkgLSBHMjCCASIwDQYJKoZI\nhvcNAQEBBQADggEPADCCAQoCggEBANUMOsQq+U7i9b4Zl1+OiFOxHz/Lz58gE20p\nOsgPfTz3a3Y4Y9k2YKibXlwAgLIvWX/2h/klQ4bnaRtSmpDhcePYLQ1Ob/bISdm2\n8xpWriu2dBTrz/sm4xq6HZYuajtYlIlHVv8loJNwU4PahHQUw2eeBGg6345AWh1K\nTs9DkTvnVtYAcMtS7nt9rjrnvDH5RfbCYM8TWQIrgMw0R9+53pBlbQLPLJGmpufe\nhRhJfGZOozptqbXuNC66DQO4M99H67FrjSXZm86B0UVGMpZwh94CDklDhbZsc7tk\n6mFBrMnUVN+HL8cisibMn1lUaJ/8viovxFUcdUBgF4UCVTmLfwUCAwEAAaNCMEAw\nDwYDVR0TAQH/BAUwAwEB/zAOBgNVHQ8BAf8EBAMCAQYwHQYDVR0OBBYEFJxfAN+q\nAdcwKziIorhtSpzyEZGDMA0GCSqGSIb3DQEBCwUAA4IBAQBLNqaEd2ndOxmfZyMI\nbw5hyf2E3F/YNoHN2BtBLZ9g3ccaaNnRbobhiCPPE95Dz+I0swSdHynVv/heyNXB\nve6SbzJ08pGCL72CQnqtKrcgfU28elUSwhXqvfdqlS5sdJ/PHLTyxQGjhdByPq1z\nqwubdQxtRbeOlKyWN7Wg0I8VRw7j6IPdj/3vQQF3zCepYoUz8jcI73HPdwbeyBkd\niEDPfUYd/x7H4c7/I9vG+o1VTqkC50cRRj70/b17KSa7qWFiNyi2LSr2EIZkyXCn\n0q23KXB56jzaYyWf/Wi3MOxw+3WKt21gZ7IeyLnp2KhvAotnDU0mV3HaIPzBSlCN\nsSi6\n-----END CERTIFICATE-----\n"
  ];
});
var require_lib16 = __commonJS2((exports, module) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  var defaults_js_1 = require_defaults();
  var proxies_js_1 = require_proxies();
  var proxyBundle = {
    ca: proxies_js_1.proxies
  };
  var profiles = {
    ca: [...defaults_js_1.defaults, ...proxies_js_1.proxies]
  };
  module.exports = profiles;
  module.exports.proxyBundle = proxyBundle;
  module.exports.default = profiles;
});
var require_ssl_profiles = __commonJS2((exports) => {
  var awsCaBundle = require_lib16();
  exports["Amazon RDS"] = {
    ca: awsCaBundle.ca
  };
});
var require_connection_config = __commonJS2((exports, module) => {
  var { URL: URL2 } = import.meta.require("url");
  var ClientConstants = require_client();
  var Charsets = require_charsets();
  var { version: version4 } = require_package();
  var SSLProfiles = null;
  var validOptions = {
    authPlugins: 1,
    authSwitchHandler: 1,
    bigNumberStrings: 1,
    charset: 1,
    charsetNumber: 1,
    compress: 1,
    connectAttributes: 1,
    connectTimeout: 1,
    database: 1,
    dateStrings: 1,
    debug: 1,
    decimalNumbers: 1,
    enableKeepAlive: 1,
    flags: 1,
    host: 1,
    insecureAuth: 1,
    infileStreamFactory: 1,
    isServer: 1,
    keepAliveInitialDelay: 1,
    localAddress: 1,
    maxPreparedStatements: 1,
    multipleStatements: 1,
    namedPlaceholders: 1,
    nestTables: 1,
    password: 1,
    password1: 1,
    password2: 1,
    password3: 1,
    passwordSha1: 1,
    pool: 1,
    port: 1,
    queryFormat: 1,
    rowsAsArray: 1,
    socketPath: 1,
    ssl: 1,
    stream: 1,
    stringifyObjects: 1,
    supportBigNumbers: 1,
    timezone: 1,
    trace: 1,
    typeCast: 1,
    uri: 1,
    user: 1,
    connectionLimit: 1,
    maxIdle: 1,
    idleTimeout: 1,
    Promise: 1,
    queueLimit: 1,
    waitForConnections: 1,
    jsonStrings: 1
  };

  class ConnectionConfig {
    constructor(options3) {
      if (typeof options3 === "string") {
        options3 = ConnectionConfig.parseUrl(options3);
      } else if (options3 && options3.uri) {
        const uriOptions = ConnectionConfig.parseUrl(options3.uri);
        for (const key in uriOptions) {
          if (!Object.prototype.hasOwnProperty.call(uriOptions, key))
            continue;
          if (options3[key])
            continue;
          options3[key] = uriOptions[key];
        }
      }
      for (const key in options3) {
        if (!Object.prototype.hasOwnProperty.call(options3, key))
          continue;
        if (validOptions[key] !== 1) {
          console.error(`Ignoring invalid configuration option passed to Connection: ${key}. This is currently a warning, but in future versions of MySQL2, an error will be thrown if you pass an invalid configuration option to a Connection`);
        }
      }
      this.isServer = options3.isServer;
      this.stream = options3.stream;
      this.host = options3.host || "localhost";
      this.port = (typeof options3.port === "string" ? parseInt(options3.port, 10) : options3.port) || 3306;
      this.localAddress = options3.localAddress;
      this.socketPath = options3.socketPath;
      this.user = options3.user || undefined;
      this.password = options3.password || options3.password1 || undefined;
      this.password2 = options3.password2 || undefined;
      this.password3 = options3.password3 || undefined;
      this.passwordSha1 = options3.passwordSha1 || undefined;
      this.database = options3.database;
      this.connectTimeout = isNaN(options3.connectTimeout) ? 1e4 : options3.connectTimeout;
      this.insecureAuth = options3.insecureAuth || false;
      this.infileStreamFactory = options3.infileStreamFactory || undefined;
      this.supportBigNumbers = options3.supportBigNumbers || false;
      this.bigNumberStrings = options3.bigNumberStrings || false;
      this.decimalNumbers = options3.decimalNumbers || false;
      this.dateStrings = options3.dateStrings || false;
      this.debug = options3.debug;
      this.trace = options3.trace !== false;
      this.stringifyObjects = options3.stringifyObjects || false;
      this.enableKeepAlive = options3.enableKeepAlive !== false;
      this.keepAliveInitialDelay = options3.keepAliveInitialDelay;
      if (options3.timezone && !/^(?:local|Z|[ +-]\d\d:\d\d)$/.test(options3.timezone)) {
        console.error(`Ignoring invalid timezone passed to Connection: ${options3.timezone}. This is currently a warning, but in future versions of MySQL2, an error will be thrown if you pass an invalid configuration option to a Connection`);
        this.timezone = "Z";
      } else {
        this.timezone = options3.timezone || "local";
      }
      this.queryFormat = options3.queryFormat;
      this.pool = options3.pool || undefined;
      this.ssl = typeof options3.ssl === "string" ? ConnectionConfig.getSSLProfile(options3.ssl) : options3.ssl || false;
      this.multipleStatements = options3.multipleStatements || false;
      this.rowsAsArray = options3.rowsAsArray || false;
      this.namedPlaceholders = options3.namedPlaceholders || false;
      this.nestTables = options3.nestTables === undefined ? undefined : options3.nestTables;
      this.typeCast = options3.typeCast === undefined ? true : options3.typeCast;
      if (this.timezone[0] === " ") {
        this.timezone = `+${this.timezone.slice(1)}`;
      }
      if (this.ssl) {
        if (typeof this.ssl !== "object") {
          throw new TypeError(`SSL profile must be an object, instead it's a ${typeof this.ssl}`);
        }
        this.ssl.rejectUnauthorized = this.ssl.rejectUnauthorized !== false;
      }
      this.maxPacketSize = 0;
      this.charsetNumber = options3.charset ? ConnectionConfig.getCharsetNumber(options3.charset) : options3.charsetNumber || Charsets.UTF8MB4_UNICODE_CI;
      this.compress = options3.compress || false;
      this.authPlugins = options3.authPlugins;
      this.authSwitchHandler = options3.authSwitchHandler;
      this.clientFlags = ConnectionConfig.mergeFlags(ConnectionConfig.getDefaultFlags(options3), options3.flags || "");
      const defaultConnectAttributes = {
        _client_name: "Node-MySQL-2",
        _client_version: version4
      };
      this.connectAttributes = { ...defaultConnectAttributes, ...options3.connectAttributes || {} };
      this.maxPreparedStatements = options3.maxPreparedStatements || 16000;
      this.jsonStrings = options3.jsonStrings || false;
    }
    static mergeFlags(default_flags, user_flags) {
      let flags = 0, i2;
      if (!Array.isArray(user_flags)) {
        user_flags = String(user_flags || "").toUpperCase().split(/\s*,+\s*/);
      }
      for (i2 in default_flags) {
        if (user_flags.indexOf(`-${default_flags[i2]}`) >= 0) {
          continue;
        }
        flags |= ClientConstants[default_flags[i2]] || 0;
      }
      for (i2 in user_flags) {
        if (user_flags[i2][0] === "-") {
          continue;
        }
        if (default_flags.indexOf(user_flags[i2]) >= 0) {
          continue;
        }
        flags |= ClientConstants[user_flags[i2]] || 0;
      }
      return flags;
    }
    static getDefaultFlags(options3) {
      const defaultFlags = [
        "LONG_PASSWORD",
        "FOUND_ROWS",
        "LONG_FLAG",
        "CONNECT_WITH_DB",
        "ODBC",
        "LOCAL_FILES",
        "IGNORE_SPACE",
        "PROTOCOL_41",
        "IGNORE_SIGPIPE",
        "TRANSACTIONS",
        "RESERVED",
        "SECURE_CONNECTION",
        "MULTI_RESULTS",
        "TRANSACTIONS",
        "SESSION_TRACK",
        "CONNECT_ATTRS"
      ];
      if (options3 && options3.multipleStatements) {
        defaultFlags.push("MULTI_STATEMENTS");
      }
      defaultFlags.push("PLUGIN_AUTH");
      defaultFlags.push("PLUGIN_AUTH_LENENC_CLIENT_DATA");
      return defaultFlags;
    }
    static getCharsetNumber(charset) {
      const num = Charsets[charset.toUpperCase()];
      if (num === undefined) {
        throw new TypeError(`Unknown charset '${charset}'`);
      }
      return num;
    }
    static getSSLProfile(name) {
      if (!SSLProfiles) {
        SSLProfiles = require_ssl_profiles();
      }
      const ssl = SSLProfiles[name];
      if (ssl === undefined) {
        throw new TypeError(`Unknown SSL profile '${name}'`);
      }
      return ssl;
    }
    static parseUrl(url) {
      const parsedUrl = new URL2(url);
      const options3 = {
        host: decodeURIComponent(parsedUrl.hostname),
        port: parseInt(parsedUrl.port, 10),
        database: decodeURIComponent(parsedUrl.pathname.slice(1)),
        user: decodeURIComponent(parsedUrl.username),
        password: decodeURIComponent(parsedUrl.password)
      };
      parsedUrl.searchParams.forEach((value, key) => {
        try {
          options3[key] = JSON.parse(value);
        } catch (err22) {
          options3[key] = value;
        }
      });
      return options3;
    }
  }
  module.exports = ConnectionConfig;
});
var require_promise = __commonJS2((exports) => {
  var core = require_mysql2();
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var parserCache = require_parser_cache();
  function makeDoneCb(resolve5, reject, localErr) {
    return function(err22, rows, fields22) {
      if (err22) {
        localErr.message = err22.message;
        localErr.code = err22.code;
        localErr.errno = err22.errno;
        localErr.sql = err22.sql;
        localErr.sqlState = err22.sqlState;
        localErr.sqlMessage = err22.sqlMessage;
        reject(localErr);
      } else {
        resolve5([rows, fields22]);
      }
    };
  }
  function inheritEvents(source, target, events2) {
    const listeners = {};
    target.on("newListener", (eventName) => {
      if (events2.indexOf(eventName) >= 0 && !target.listenerCount(eventName)) {
        source.on(eventName, listeners[eventName] = function() {
          const args = [].slice.call(arguments);
          args.unshift(eventName);
          target.emit.apply(target, args);
        });
      }
    }).on("removeListener", (eventName) => {
      if (events2.indexOf(eventName) >= 0 && !target.listenerCount(eventName)) {
        source.removeListener(eventName, listeners[eventName]);
        delete listeners[eventName];
      }
    });
  }

  class PromisePreparedStatementInfo {
    constructor(statement, promiseImpl) {
      this.statement = statement;
      this.Promise = promiseImpl;
    }
    execute(parameters) {
      const s32 = this.statement;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        if (parameters) {
          s32.execute(parameters, done);
        } else {
          s32.execute(done);
        }
      });
    }
    close() {
      return new this.Promise((resolve5) => {
        this.statement.close();
        resolve5();
      });
    }
  }

  class PromiseConnection extends EventEmitter23 {
    constructor(connection, promiseImpl) {
      super();
      this.connection = connection;
      this.Promise = promiseImpl || Promise;
      inheritEvents(connection, this, [
        "error",
        "drain",
        "connect",
        "end",
        "enqueue"
      ]);
    }
    release() {
      this.connection.release();
    }
    query(query, params) {
      const c22 = this.connection;
      const localErr = new Error;
      if (typeof params === "function") {
        throw new Error("Callback function is not available with promise clients.");
      }
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        if (params !== undefined) {
          c22.query(query, params, done);
        } else {
          c22.query(query, done);
        }
      });
    }
    execute(query, params) {
      const c22 = this.connection;
      const localErr = new Error;
      if (typeof params === "function") {
        throw new Error("Callback function is not available with promise clients.");
      }
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        if (params !== undefined) {
          c22.execute(query, params, done);
        } else {
          c22.execute(query, done);
        }
      });
    }
    end() {
      return new this.Promise((resolve5) => {
        this.connection.end(resolve5);
      });
    }
    beginTransaction() {
      const c22 = this.connection;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        c22.beginTransaction(done);
      });
    }
    commit() {
      const c22 = this.connection;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        c22.commit(done);
      });
    }
    rollback() {
      const c22 = this.connection;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        c22.rollback(done);
      });
    }
    ping() {
      const c22 = this.connection;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        c22.ping((err22) => {
          if (err22) {
            localErr.message = err22.message;
            localErr.code = err22.code;
            localErr.errno = err22.errno;
            localErr.sqlState = err22.sqlState;
            localErr.sqlMessage = err22.sqlMessage;
            reject(localErr);
          } else {
            resolve5(true);
          }
        });
      });
    }
    connect() {
      const c22 = this.connection;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        c22.connect((err22, param) => {
          if (err22) {
            localErr.message = err22.message;
            localErr.code = err22.code;
            localErr.errno = err22.errno;
            localErr.sqlState = err22.sqlState;
            localErr.sqlMessage = err22.sqlMessage;
            reject(localErr);
          } else {
            resolve5(param);
          }
        });
      });
    }
    prepare(options3) {
      const c22 = this.connection;
      const promiseImpl = this.Promise;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        c22.prepare(options3, (err22, statement) => {
          if (err22) {
            localErr.message = err22.message;
            localErr.code = err22.code;
            localErr.errno = err22.errno;
            localErr.sqlState = err22.sqlState;
            localErr.sqlMessage = err22.sqlMessage;
            reject(localErr);
          } else {
            const wrappedStatement = new PromisePreparedStatementInfo(statement, promiseImpl);
            resolve5(wrappedStatement);
          }
        });
      });
    }
    changeUser(options3) {
      const c22 = this.connection;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        c22.changeUser(options3, (err22) => {
          if (err22) {
            localErr.message = err22.message;
            localErr.code = err22.code;
            localErr.errno = err22.errno;
            localErr.sqlState = err22.sqlState;
            localErr.sqlMessage = err22.sqlMessage;
            reject(localErr);
          } else {
            resolve5();
          }
        });
      });
    }
    get config() {
      return this.connection.config;
    }
    get threadId() {
      return this.connection.threadId;
    }
  }
  function createConnection(opts) {
    const coreConnection = core.createConnection(opts);
    const createConnectionErr = new Error;
    const thePromise = opts.Promise || Promise;
    if (!thePromise) {
      throw new Error("no Promise implementation available.Use promise-enabled node version or pass userland Promise implementation as parameter, for example: { Promise: require('bluebird') }");
    }
    return new thePromise((resolve5, reject) => {
      coreConnection.once("connect", () => {
        resolve5(new PromiseConnection(coreConnection, thePromise));
      });
      coreConnection.once("error", (err22) => {
        createConnectionErr.message = err22.message;
        createConnectionErr.code = err22.code;
        createConnectionErr.errno = err22.errno;
        createConnectionErr.sqlState = err22.sqlState;
        reject(createConnectionErr);
      });
    });
  }
  (function(functionsToWrap) {
    for (let i2 = 0;functionsToWrap && i2 < functionsToWrap.length; i2++) {
      const func = functionsToWrap[i2];
      if (typeof core.Connection.prototype[func] === "function" && PromiseConnection.prototype[func] === undefined) {
        PromiseConnection.prototype[func] = function factory(funcName) {
          return function() {
            return core.Connection.prototype[funcName].apply(this.connection, arguments);
          };
        }(func);
      }
    }
  })([
    "close",
    "createBinlogStream",
    "destroy",
    "escape",
    "escapeId",
    "format",
    "pause",
    "pipe",
    "resume",
    "unprepare"
  ]);

  class PromisePoolConnection extends PromiseConnection {
    constructor(connection, promiseImpl) {
      super(connection, promiseImpl);
    }
    destroy() {
      return core.PoolConnection.prototype.destroy.apply(this.connection, arguments);
    }
  }

  class PromisePool extends EventEmitter23 {
    constructor(pool, thePromise) {
      super();
      this.pool = pool;
      this.Promise = thePromise || Promise;
      inheritEvents(pool, this, ["acquire", "connection", "enqueue", "release"]);
    }
    getConnection() {
      const corePool = this.pool;
      return new this.Promise((resolve5, reject) => {
        corePool.getConnection((err22, coreConnection) => {
          if (err22) {
            reject(err22);
          } else {
            resolve5(new PromisePoolConnection(coreConnection, this.Promise));
          }
        });
      });
    }
    releaseConnection(connection) {
      if (connection instanceof PromisePoolConnection)
        connection.release();
    }
    query(sql3, args) {
      const corePool = this.pool;
      const localErr = new Error;
      if (typeof args === "function") {
        throw new Error("Callback function is not available with promise clients.");
      }
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        if (args !== undefined) {
          corePool.query(sql3, args, done);
        } else {
          corePool.query(sql3, done);
        }
      });
    }
    execute(sql3, args) {
      const corePool = this.pool;
      const localErr = new Error;
      if (typeof args === "function") {
        throw new Error("Callback function is not available with promise clients.");
      }
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        if (args) {
          corePool.execute(sql3, args, done);
        } else {
          corePool.execute(sql3, done);
        }
      });
    }
    end() {
      const corePool = this.pool;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        corePool.end((err22) => {
          if (err22) {
            localErr.message = err22.message;
            localErr.code = err22.code;
            localErr.errno = err22.errno;
            localErr.sqlState = err22.sqlState;
            localErr.sqlMessage = err22.sqlMessage;
            reject(localErr);
          } else {
            resolve5();
          }
        });
      });
    }
  }
  function createPool(opts) {
    const corePool = core.createPool(opts);
    const thePromise = opts.Promise || Promise;
    if (!thePromise) {
      throw new Error("no Promise implementation available.Use promise-enabled node version or pass userland Promise implementation as parameter, for example: { Promise: require('bluebird') }");
    }
    return new PromisePool(corePool, thePromise);
  }
  (function(functionsToWrap) {
    for (let i2 = 0;functionsToWrap && i2 < functionsToWrap.length; i2++) {
      const func = functionsToWrap[i2];
      if (typeof core.Pool.prototype[func] === "function" && PromisePool.prototype[func] === undefined) {
        PromisePool.prototype[func] = function factory(funcName) {
          return function() {
            return core.Pool.prototype[funcName].apply(this.pool, arguments);
          };
        }(func);
      }
    }
  })([
    "escape",
    "escapeId",
    "format"
  ]);

  class PromisePoolCluster extends EventEmitter23 {
    constructor(poolCluster, thePromise) {
      super();
      this.poolCluster = poolCluster;
      this.Promise = thePromise || Promise;
      inheritEvents(poolCluster, this, ["warn", "remove"]);
    }
    getConnection(pattern, selector) {
      const corePoolCluster = this.poolCluster;
      return new this.Promise((resolve5, reject) => {
        corePoolCluster.getConnection(pattern, selector, (err22, coreConnection) => {
          if (err22) {
            reject(err22);
          } else {
            resolve5(new PromisePoolConnection(coreConnection, this.Promise));
          }
        });
      });
    }
    query(sql3, args) {
      const corePoolCluster = this.poolCluster;
      const localErr = new Error;
      if (typeof args === "function") {
        throw new Error("Callback function is not available with promise clients.");
      }
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        corePoolCluster.query(sql3, args, done);
      });
    }
    execute(sql3, args) {
      const corePoolCluster = this.poolCluster;
      const localErr = new Error;
      if (typeof args === "function") {
        throw new Error("Callback function is not available with promise clients.");
      }
      return new this.Promise((resolve5, reject) => {
        const done = makeDoneCb(resolve5, reject, localErr);
        corePoolCluster.execute(sql3, args, done);
      });
    }
    of(pattern, selector) {
      return new PromisePoolCluster(this.poolCluster.of(pattern, selector), this.Promise);
    }
    end() {
      const corePoolCluster = this.poolCluster;
      const localErr = new Error;
      return new this.Promise((resolve5, reject) => {
        corePoolCluster.end((err22) => {
          if (err22) {
            localErr.message = err22.message;
            localErr.code = err22.code;
            localErr.errno = err22.errno;
            localErr.sqlState = err22.sqlState;
            localErr.sqlMessage = err22.sqlMessage;
            reject(localErr);
          } else {
            resolve5();
          }
        });
      });
    }
  }
  (function(functionsToWrap) {
    for (let i2 = 0;functionsToWrap && i2 < functionsToWrap.length; i2++) {
      const func = functionsToWrap[i2];
      if (typeof core.PoolCluster.prototype[func] === "function" && PromisePoolCluster.prototype[func] === undefined) {
        PromisePoolCluster.prototype[func] = function factory(funcName) {
          return function() {
            return core.PoolCluster.prototype[funcName].apply(this.poolCluster, arguments);
          };
        }(func);
      }
    }
  })([
    "add"
  ]);
  function createPoolCluster(opts) {
    const corePoolCluster = core.createPoolCluster(opts);
    const thePromise = opts && opts.Promise || Promise;
    if (!thePromise) {
      throw new Error("no Promise implementation available.Use promise-enabled node version or pass userland Promise implementation as parameter, for example: { Promise: require('bluebird') }");
    }
    return new PromisePoolCluster(corePoolCluster, thePromise);
  }
  exports.createConnection = createConnection;
  exports.createPool = createPool;
  exports.createPoolCluster = createPoolCluster;
  exports.escape = core.escape;
  exports.escapeId = core.escapeId;
  exports.format = core.format;
  exports.raw = core.raw;
  exports.PromisePool = PromisePool;
  exports.PromiseConnection = PromiseConnection;
  exports.PromisePoolConnection = PromisePoolConnection;
  exports.__defineGetter__("Types", () => require_types2());
  exports.__defineGetter__("Charsets", () => require_charsets());
  exports.__defineGetter__("CharsetToEncoding", () => require_charset_encodings());
  exports.setMaxParserCache = function(max) {
    parserCache.setMaxCache(max);
  };
  exports.clearParserCache = function() {
    parserCache.clearCache();
  };
});
var require_lru_cache = __commonJS2((exports, module) => {
  var perf = typeof performance === "object" && performance && typeof performance.now === "function" ? performance : Date;
  var hasAbortController = typeof AbortController === "function";
  var AC = hasAbortController ? AbortController : class AbortController2 {
    constructor() {
      this.signal = new AS;
    }
    abort(reason = new Error("This operation was aborted")) {
      this.signal.reason = this.signal.reason || reason;
      this.signal.aborted = true;
      this.signal.dispatchEvent({
        type: "abort",
        target: this.signal
      });
    }
  };
  var hasAbortSignal = typeof AbortSignal === "function";
  var hasACAbortSignal = typeof AC.AbortSignal === "function";
  var AS = hasAbortSignal ? AbortSignal : hasACAbortSignal ? AC.AbortController : class AbortSignal2 {
    constructor() {
      this.reason = undefined;
      this.aborted = false;
      this._listeners = [];
    }
    dispatchEvent(e) {
      if (e.type === "abort") {
        this.aborted = true;
        this.onabort(e);
        this._listeners.forEach((f22) => f22(e), this);
      }
    }
    onabort() {
    }
    addEventListener(ev, fn) {
      if (ev === "abort") {
        this._listeners.push(fn);
      }
    }
    removeEventListener(ev, fn) {
      if (ev === "abort") {
        this._listeners = this._listeners.filter((f22) => f22 !== fn);
      }
    }
  };
  var warned = new Set;
  var deprecatedOption = (opt, instead) => {
    const code = `LRU_CACHE_OPTION_${opt}`;
    if (shouldWarn(code)) {
      warn(code, `${opt} option`, `options.${instead}`, LRUCache);
    }
  };
  var deprecatedMethod = (method, instead) => {
    const code = `LRU_CACHE_METHOD_${method}`;
    if (shouldWarn(code)) {
      const { prototype } = LRUCache;
      const { get } = Object.getOwnPropertyDescriptor(prototype, method);
      warn(code, `${method} method`, `cache.${instead}()`, get);
    }
  };
  var deprecatedProperty = (field, instead) => {
    const code = `LRU_CACHE_PROPERTY_${field}`;
    if (shouldWarn(code)) {
      const { prototype } = LRUCache;
      const { get } = Object.getOwnPropertyDescriptor(prototype, field);
      warn(code, `${field} property`, `cache.${instead}`, get);
    }
  };
  var emitWarning = (...a) => {
    typeof process === "object" && process && typeof process.emitWarning === "function" ? process.emitWarning(...a) : console.error(...a);
  };
  var shouldWarn = (code) => !warned.has(code);
  var warn = (code, what, instead, fn) => {
    warned.add(code);
    const msg = `The ${what} is deprecated. Please use ${instead} instead.`;
    emitWarning(msg, "DeprecationWarning", code, fn);
  };
  var isPosInt = (n) => n && n === Math.floor(n) && n > 0 && isFinite(n);
  var getUintArray = (max) => !isPosInt(max) ? null : max <= Math.pow(2, 8) ? Uint8Array : max <= Math.pow(2, 16) ? Uint16Array : max <= Math.pow(2, 32) ? Uint32Array : max <= Number.MAX_SAFE_INTEGER ? ZeroArray : null;

  class ZeroArray extends Array {
    constructor(size) {
      super(size);
      this.fill(0);
    }
  }

  class Stack {
    constructor(max) {
      if (max === 0) {
        return [];
      }
      const UintArray = getUintArray(max);
      this.heap = new UintArray(max);
      this.length = 0;
    }
    push(n) {
      this.heap[this.length++] = n;
    }
    pop() {
      return this.heap[--this.length];
    }
  }

  class LRUCache {
    constructor(options3 = {}) {
      const {
        max = 0,
        ttl,
        ttlResolution = 1,
        ttlAutopurge,
        updateAgeOnGet,
        updateAgeOnHas,
        allowStale,
        dispose,
        disposeAfter,
        noDisposeOnSet,
        noUpdateTTL,
        maxSize = 0,
        maxEntrySize = 0,
        sizeCalculation,
        fetchMethod,
        fetchContext,
        noDeleteOnFetchRejection,
        noDeleteOnStaleGet,
        allowStaleOnFetchRejection,
        allowStaleOnFetchAbort,
        ignoreFetchAbort
      } = options3;
      const { length, maxAge, stale } = options3 instanceof LRUCache ? {} : options3;
      if (max !== 0 && !isPosInt(max)) {
        throw new TypeError("max option must be a nonnegative integer");
      }
      const UintArray = max ? getUintArray(max) : Array;
      if (!UintArray) {
        throw new Error("invalid max value: " + max);
      }
      this.max = max;
      this.maxSize = maxSize;
      this.maxEntrySize = maxEntrySize || this.maxSize;
      this.sizeCalculation = sizeCalculation || length;
      if (this.sizeCalculation) {
        if (!this.maxSize && !this.maxEntrySize) {
          throw new TypeError("cannot set sizeCalculation without setting maxSize or maxEntrySize");
        }
        if (typeof this.sizeCalculation !== "function") {
          throw new TypeError("sizeCalculation set to non-function");
        }
      }
      this.fetchMethod = fetchMethod || null;
      if (this.fetchMethod && typeof this.fetchMethod !== "function") {
        throw new TypeError("fetchMethod must be a function if specified");
      }
      this.fetchContext = fetchContext;
      if (!this.fetchMethod && fetchContext !== undefined) {
        throw new TypeError("cannot set fetchContext without fetchMethod");
      }
      this.keyMap = new Map;
      this.keyList = new Array(max).fill(null);
      this.valList = new Array(max).fill(null);
      this.next = new UintArray(max);
      this.prev = new UintArray(max);
      this.head = 0;
      this.tail = 0;
      this.free = new Stack(max);
      this.initialFill = 1;
      this.size = 0;
      if (typeof dispose === "function") {
        this.dispose = dispose;
      }
      if (typeof disposeAfter === "function") {
        this.disposeAfter = disposeAfter;
        this.disposed = [];
      } else {
        this.disposeAfter = null;
        this.disposed = null;
      }
      this.noDisposeOnSet = !!noDisposeOnSet;
      this.noUpdateTTL = !!noUpdateTTL;
      this.noDeleteOnFetchRejection = !!noDeleteOnFetchRejection;
      this.allowStaleOnFetchRejection = !!allowStaleOnFetchRejection;
      this.allowStaleOnFetchAbort = !!allowStaleOnFetchAbort;
      this.ignoreFetchAbort = !!ignoreFetchAbort;
      if (this.maxEntrySize !== 0) {
        if (this.maxSize !== 0) {
          if (!isPosInt(this.maxSize)) {
            throw new TypeError("maxSize must be a positive integer if specified");
          }
        }
        if (!isPosInt(this.maxEntrySize)) {
          throw new TypeError("maxEntrySize must be a positive integer if specified");
        }
        this.initializeSizeTracking();
      }
      this.allowStale = !!allowStale || !!stale;
      this.noDeleteOnStaleGet = !!noDeleteOnStaleGet;
      this.updateAgeOnGet = !!updateAgeOnGet;
      this.updateAgeOnHas = !!updateAgeOnHas;
      this.ttlResolution = isPosInt(ttlResolution) || ttlResolution === 0 ? ttlResolution : 1;
      this.ttlAutopurge = !!ttlAutopurge;
      this.ttl = ttl || maxAge || 0;
      if (this.ttl) {
        if (!isPosInt(this.ttl)) {
          throw new TypeError("ttl must be a positive integer if specified");
        }
        this.initializeTTLTracking();
      }
      if (this.max === 0 && this.ttl === 0 && this.maxSize === 0) {
        throw new TypeError("At least one of max, maxSize, or ttl is required");
      }
      if (!this.ttlAutopurge && !this.max && !this.maxSize) {
        const code = "LRU_CACHE_UNBOUNDED";
        if (shouldWarn(code)) {
          warned.add(code);
          const msg = "TTL caching without ttlAutopurge, max, or maxSize can result in unbounded memory consumption.";
          emitWarning(msg, "UnboundedCacheWarning", code, LRUCache);
        }
      }
      if (stale) {
        deprecatedOption("stale", "allowStale");
      }
      if (maxAge) {
        deprecatedOption("maxAge", "ttl");
      }
      if (length) {
        deprecatedOption("length", "sizeCalculation");
      }
    }
    getRemainingTTL(key) {
      return this.has(key, { updateAgeOnHas: false }) ? Infinity : 0;
    }
    initializeTTLTracking() {
      this.ttls = new ZeroArray(this.max);
      this.starts = new ZeroArray(this.max);
      this.setItemTTL = (index, ttl, start = perf.now()) => {
        this.starts[index] = ttl !== 0 ? start : 0;
        this.ttls[index] = ttl;
        if (ttl !== 0 && this.ttlAutopurge) {
          const t = setTimeout(() => {
            if (this.isStale(index)) {
              this.delete(this.keyList[index]);
            }
          }, ttl + 1);
          if (t.unref) {
            t.unref();
          }
        }
      };
      this.updateItemAge = (index) => {
        this.starts[index] = this.ttls[index] !== 0 ? perf.now() : 0;
      };
      this.statusTTL = (status, index) => {
        if (status) {
          status.ttl = this.ttls[index];
          status.start = this.starts[index];
          status.now = cachedNow || getNow();
          status.remainingTTL = status.now + status.ttl - status.start;
        }
      };
      let cachedNow = 0;
      const getNow = () => {
        const n = perf.now();
        if (this.ttlResolution > 0) {
          cachedNow = n;
          const t = setTimeout(() => cachedNow = 0, this.ttlResolution);
          if (t.unref) {
            t.unref();
          }
        }
        return n;
      };
      this.getRemainingTTL = (key) => {
        const index = this.keyMap.get(key);
        if (index === undefined) {
          return 0;
        }
        return this.ttls[index] === 0 || this.starts[index] === 0 ? Infinity : this.starts[index] + this.ttls[index] - (cachedNow || getNow());
      };
      this.isStale = (index) => {
        return this.ttls[index] !== 0 && this.starts[index] !== 0 && (cachedNow || getNow()) - this.starts[index] > this.ttls[index];
      };
    }
    updateItemAge(_index) {
    }
    statusTTL(_status, _index) {
    }
    setItemTTL(_index, _ttl, _start) {
    }
    isStale(_index) {
      return false;
    }
    initializeSizeTracking() {
      this.calculatedSize = 0;
      this.sizes = new ZeroArray(this.max);
      this.removeItemSize = (index) => {
        this.calculatedSize -= this.sizes[index];
        this.sizes[index] = 0;
      };
      this.requireSize = (k, v22, size, sizeCalculation) => {
        if (this.isBackgroundFetch(v22)) {
          return 0;
        }
        if (!isPosInt(size)) {
          if (sizeCalculation) {
            if (typeof sizeCalculation !== "function") {
              throw new TypeError("sizeCalculation must be a function");
            }
            size = sizeCalculation(v22, k);
            if (!isPosInt(size)) {
              throw new TypeError("sizeCalculation return invalid (expect positive integer)");
            }
          } else {
            throw new TypeError("invalid size value (must be positive integer). When maxSize or maxEntrySize is used, sizeCalculation or size must be set.");
          }
        }
        return size;
      };
      this.addItemSize = (index, size, status) => {
        this.sizes[index] = size;
        if (this.maxSize) {
          const maxSize = this.maxSize - this.sizes[index];
          while (this.calculatedSize > maxSize) {
            this.evict(true);
          }
        }
        this.calculatedSize += this.sizes[index];
        if (status) {
          status.entrySize = size;
          status.totalCalculatedSize = this.calculatedSize;
        }
      };
    }
    removeItemSize(_index) {
    }
    addItemSize(_index, _size) {
    }
    requireSize(_k, _v, size, sizeCalculation) {
      if (size || sizeCalculation) {
        throw new TypeError("cannot set size without setting maxSize or maxEntrySize on cache");
      }
    }
    *indexes({ allowStale = this.allowStale } = {}) {
      if (this.size) {
        for (let i2 = this.tail;; ) {
          if (!this.isValidIndex(i2)) {
            break;
          }
          if (allowStale || !this.isStale(i2)) {
            yield i2;
          }
          if (i2 === this.head) {
            break;
          } else {
            i2 = this.prev[i2];
          }
        }
      }
    }
    *rindexes({ allowStale = this.allowStale } = {}) {
      if (this.size) {
        for (let i2 = this.head;; ) {
          if (!this.isValidIndex(i2)) {
            break;
          }
          if (allowStale || !this.isStale(i2)) {
            yield i2;
          }
          if (i2 === this.tail) {
            break;
          } else {
            i2 = this.next[i2];
          }
        }
      }
    }
    isValidIndex(index) {
      return index !== undefined && this.keyMap.get(this.keyList[index]) === index;
    }
    *entries() {
      for (const i2 of this.indexes()) {
        if (this.valList[i2] !== undefined && this.keyList[i2] !== undefined && !this.isBackgroundFetch(this.valList[i2])) {
          yield [this.keyList[i2], this.valList[i2]];
        }
      }
    }
    *rentries() {
      for (const i2 of this.rindexes()) {
        if (this.valList[i2] !== undefined && this.keyList[i2] !== undefined && !this.isBackgroundFetch(this.valList[i2])) {
          yield [this.keyList[i2], this.valList[i2]];
        }
      }
    }
    *keys() {
      for (const i2 of this.indexes()) {
        if (this.keyList[i2] !== undefined && !this.isBackgroundFetch(this.valList[i2])) {
          yield this.keyList[i2];
        }
      }
    }
    *rkeys() {
      for (const i2 of this.rindexes()) {
        if (this.keyList[i2] !== undefined && !this.isBackgroundFetch(this.valList[i2])) {
          yield this.keyList[i2];
        }
      }
    }
    *values() {
      for (const i2 of this.indexes()) {
        if (this.valList[i2] !== undefined && !this.isBackgroundFetch(this.valList[i2])) {
          yield this.valList[i2];
        }
      }
    }
    *rvalues() {
      for (const i2 of this.rindexes()) {
        if (this.valList[i2] !== undefined && !this.isBackgroundFetch(this.valList[i2])) {
          yield this.valList[i2];
        }
      }
    }
    [Symbol.iterator]() {
      return this.entries();
    }
    find(fn, getOptions2) {
      for (const i2 of this.indexes()) {
        const v22 = this.valList[i2];
        const value = this.isBackgroundFetch(v22) ? v22.__staleWhileFetching : v22;
        if (value === undefined)
          continue;
        if (fn(value, this.keyList[i2], this)) {
          return this.get(this.keyList[i2], getOptions2);
        }
      }
    }
    forEach(fn, thisp = this) {
      for (const i2 of this.indexes()) {
        const v22 = this.valList[i2];
        const value = this.isBackgroundFetch(v22) ? v22.__staleWhileFetching : v22;
        if (value === undefined)
          continue;
        fn.call(thisp, value, this.keyList[i2], this);
      }
    }
    rforEach(fn, thisp = this) {
      for (const i2 of this.rindexes()) {
        const v22 = this.valList[i2];
        const value = this.isBackgroundFetch(v22) ? v22.__staleWhileFetching : v22;
        if (value === undefined)
          continue;
        fn.call(thisp, value, this.keyList[i2], this);
      }
    }
    get prune() {
      deprecatedMethod("prune", "purgeStale");
      return this.purgeStale;
    }
    purgeStale() {
      let deleted = false;
      for (const i2 of this.rindexes({ allowStale: true })) {
        if (this.isStale(i2)) {
          this.delete(this.keyList[i2]);
          deleted = true;
        }
      }
      return deleted;
    }
    dump() {
      const arr = [];
      for (const i2 of this.indexes({ allowStale: true })) {
        const key = this.keyList[i2];
        const v22 = this.valList[i2];
        const value = this.isBackgroundFetch(v22) ? v22.__staleWhileFetching : v22;
        if (value === undefined)
          continue;
        const entry = { value };
        if (this.ttls) {
          entry.ttl = this.ttls[i2];
          const age = perf.now() - this.starts[i2];
          entry.start = Math.floor(Date.now() - age);
        }
        if (this.sizes) {
          entry.size = this.sizes[i2];
        }
        arr.unshift([key, entry]);
      }
      return arr;
    }
    load(arr) {
      this.clear();
      for (const [key, entry] of arr) {
        if (entry.start) {
          const age = Date.now() - entry.start;
          entry.start = perf.now() - age;
        }
        this.set(key, entry.value, entry);
      }
    }
    dispose(_v, _k, _reason) {
    }
    set(k, v22, {
      ttl = this.ttl,
      start,
      noDisposeOnSet = this.noDisposeOnSet,
      size = 0,
      sizeCalculation = this.sizeCalculation,
      noUpdateTTL = this.noUpdateTTL,
      status
    } = {}) {
      size = this.requireSize(k, v22, size, sizeCalculation);
      if (this.maxEntrySize && size > this.maxEntrySize) {
        if (status) {
          status.set = "miss";
          status.maxEntrySizeExceeded = true;
        }
        this.delete(k);
        return this;
      }
      let index = this.size === 0 ? undefined : this.keyMap.get(k);
      if (index === undefined) {
        index = this.newIndex();
        this.keyList[index] = k;
        this.valList[index] = v22;
        this.keyMap.set(k, index);
        this.next[this.tail] = index;
        this.prev[index] = this.tail;
        this.tail = index;
        this.size++;
        this.addItemSize(index, size, status);
        if (status) {
          status.set = "add";
        }
        noUpdateTTL = false;
      } else {
        this.moveToTail(index);
        const oldVal = this.valList[index];
        if (v22 !== oldVal) {
          if (this.isBackgroundFetch(oldVal)) {
            oldVal.__abortController.abort(new Error("replaced"));
          } else {
            if (!noDisposeOnSet) {
              this.dispose(oldVal, k, "set");
              if (this.disposeAfter) {
                this.disposed.push([oldVal, k, "set"]);
              }
            }
          }
          this.removeItemSize(index);
          this.valList[index] = v22;
          this.addItemSize(index, size, status);
          if (status) {
            status.set = "replace";
            const oldValue = oldVal && this.isBackgroundFetch(oldVal) ? oldVal.__staleWhileFetching : oldVal;
            if (oldValue !== undefined)
              status.oldValue = oldValue;
          }
        } else if (status) {
          status.set = "update";
        }
      }
      if (ttl !== 0 && this.ttl === 0 && !this.ttls) {
        this.initializeTTLTracking();
      }
      if (!noUpdateTTL) {
        this.setItemTTL(index, ttl, start);
      }
      this.statusTTL(status, index);
      if (this.disposeAfter) {
        while (this.disposed.length) {
          this.disposeAfter(...this.disposed.shift());
        }
      }
      return this;
    }
    newIndex() {
      if (this.size === 0) {
        return this.tail;
      }
      if (this.size === this.max && this.max !== 0) {
        return this.evict(false);
      }
      if (this.free.length !== 0) {
        return this.free.pop();
      }
      return this.initialFill++;
    }
    pop() {
      if (this.size) {
        const val2 = this.valList[this.head];
        this.evict(true);
        return val2;
      }
    }
    evict(free) {
      const head2 = this.head;
      const k = this.keyList[head2];
      const v22 = this.valList[head2];
      if (this.isBackgroundFetch(v22)) {
        v22.__abortController.abort(new Error("evicted"));
      } else {
        this.dispose(v22, k, "evict");
        if (this.disposeAfter) {
          this.disposed.push([v22, k, "evict"]);
        }
      }
      this.removeItemSize(head2);
      if (free) {
        this.keyList[head2] = null;
        this.valList[head2] = null;
        this.free.push(head2);
      }
      this.head = this.next[head2];
      this.keyMap.delete(k);
      this.size--;
      return head2;
    }
    has(k, { updateAgeOnHas = this.updateAgeOnHas, status } = {}) {
      const index = this.keyMap.get(k);
      if (index !== undefined) {
        if (!this.isStale(index)) {
          if (updateAgeOnHas) {
            this.updateItemAge(index);
          }
          if (status)
            status.has = "hit";
          this.statusTTL(status, index);
          return true;
        } else if (status) {
          status.has = "stale";
          this.statusTTL(status, index);
        }
      } else if (status) {
        status.has = "miss";
      }
      return false;
    }
    peek(k, { allowStale = this.allowStale } = {}) {
      const index = this.keyMap.get(k);
      if (index !== undefined && (allowStale || !this.isStale(index))) {
        const v22 = this.valList[index];
        return this.isBackgroundFetch(v22) ? v22.__staleWhileFetching : v22;
      }
    }
    backgroundFetch(k, index, options3, context) {
      const v22 = index === undefined ? undefined : this.valList[index];
      if (this.isBackgroundFetch(v22)) {
        return v22;
      }
      const ac = new AC;
      if (options3.signal) {
        options3.signal.addEventListener("abort", () => ac.abort(options3.signal.reason));
      }
      const fetchOpts = {
        signal: ac.signal,
        options: options3,
        context
      };
      const cb = (v3, updateCache = false) => {
        const { aborted } = ac.signal;
        const ignoreAbort = options3.ignoreFetchAbort && v3 !== undefined;
        if (options3.status) {
          if (aborted && !updateCache) {
            options3.status.fetchAborted = true;
            options3.status.fetchError = ac.signal.reason;
            if (ignoreAbort)
              options3.status.fetchAbortIgnored = true;
          } else {
            options3.status.fetchResolved = true;
          }
        }
        if (aborted && !ignoreAbort && !updateCache) {
          return fetchFail(ac.signal.reason);
        }
        if (this.valList[index] === p32) {
          if (v3 === undefined) {
            if (p32.__staleWhileFetching) {
              this.valList[index] = p32.__staleWhileFetching;
            } else {
              this.delete(k);
            }
          } else {
            if (options3.status)
              options3.status.fetchUpdated = true;
            this.set(k, v3, fetchOpts.options);
          }
        }
        return v3;
      };
      const eb = (er) => {
        if (options3.status) {
          options3.status.fetchRejected = true;
          options3.status.fetchError = er;
        }
        return fetchFail(er);
      };
      const fetchFail = (er) => {
        const { aborted } = ac.signal;
        const allowStaleAborted = aborted && options3.allowStaleOnFetchAbort;
        const allowStale = allowStaleAborted || options3.allowStaleOnFetchRejection;
        const noDelete = allowStale || options3.noDeleteOnFetchRejection;
        if (this.valList[index] === p32) {
          const del = !noDelete || p32.__staleWhileFetching === undefined;
          if (del) {
            this.delete(k);
          } else if (!allowStaleAborted) {
            this.valList[index] = p32.__staleWhileFetching;
          }
        }
        if (allowStale) {
          if (options3.status && p32.__staleWhileFetching !== undefined) {
            options3.status.returnedStale = true;
          }
          return p32.__staleWhileFetching;
        } else if (p32.__returned === p32) {
          throw er;
        }
      };
      const pcall = (res, rej) => {
        this.fetchMethod(k, v22, fetchOpts).then((v3) => res(v3), rej);
        ac.signal.addEventListener("abort", () => {
          if (!options3.ignoreFetchAbort || options3.allowStaleOnFetchAbort) {
            res();
            if (options3.allowStaleOnFetchAbort) {
              res = (v3) => cb(v3, true);
            }
          }
        });
      };
      if (options3.status)
        options3.status.fetchDispatched = true;
      const p32 = new Promise(pcall).then(cb, eb);
      p32.__abortController = ac;
      p32.__staleWhileFetching = v22;
      p32.__returned = null;
      if (index === undefined) {
        this.set(k, p32, { ...fetchOpts.options, status: undefined });
        index = this.keyMap.get(k);
      } else {
        this.valList[index] = p32;
      }
      return p32;
    }
    isBackgroundFetch(p32) {
      return p32 && typeof p32 === "object" && typeof p32.then === "function" && Object.prototype.hasOwnProperty.call(p32, "__staleWhileFetching") && Object.prototype.hasOwnProperty.call(p32, "__returned") && (p32.__returned === p32 || p32.__returned === null);
    }
    async fetch(k, {
      allowStale = this.allowStale,
      updateAgeOnGet = this.updateAgeOnGet,
      noDeleteOnStaleGet = this.noDeleteOnStaleGet,
      ttl = this.ttl,
      noDisposeOnSet = this.noDisposeOnSet,
      size = 0,
      sizeCalculation = this.sizeCalculation,
      noUpdateTTL = this.noUpdateTTL,
      noDeleteOnFetchRejection = this.noDeleteOnFetchRejection,
      allowStaleOnFetchRejection = this.allowStaleOnFetchRejection,
      ignoreFetchAbort = this.ignoreFetchAbort,
      allowStaleOnFetchAbort = this.allowStaleOnFetchAbort,
      fetchContext = this.fetchContext,
      forceRefresh = false,
      status,
      signal
    } = {}) {
      if (!this.fetchMethod) {
        if (status)
          status.fetch = "get";
        return this.get(k, {
          allowStale,
          updateAgeOnGet,
          noDeleteOnStaleGet,
          status
        });
      }
      const options3 = {
        allowStale,
        updateAgeOnGet,
        noDeleteOnStaleGet,
        ttl,
        noDisposeOnSet,
        size,
        sizeCalculation,
        noUpdateTTL,
        noDeleteOnFetchRejection,
        allowStaleOnFetchRejection,
        allowStaleOnFetchAbort,
        ignoreFetchAbort,
        status,
        signal
      };
      let index = this.keyMap.get(k);
      if (index === undefined) {
        if (status)
          status.fetch = "miss";
        const p32 = this.backgroundFetch(k, index, options3, fetchContext);
        return p32.__returned = p32;
      } else {
        const v22 = this.valList[index];
        if (this.isBackgroundFetch(v22)) {
          const stale = allowStale && v22.__staleWhileFetching !== undefined;
          if (status) {
            status.fetch = "inflight";
            if (stale)
              status.returnedStale = true;
          }
          return stale ? v22.__staleWhileFetching : v22.__returned = v22;
        }
        const isStale = this.isStale(index);
        if (!forceRefresh && !isStale) {
          if (status)
            status.fetch = "hit";
          this.moveToTail(index);
          if (updateAgeOnGet) {
            this.updateItemAge(index);
          }
          this.statusTTL(status, index);
          return v22;
        }
        const p32 = this.backgroundFetch(k, index, options3, fetchContext);
        const hasStale = p32.__staleWhileFetching !== undefined;
        const staleVal = hasStale && allowStale;
        if (status) {
          status.fetch = hasStale && isStale ? "stale" : "refresh";
          if (staleVal && isStale)
            status.returnedStale = true;
        }
        return staleVal ? p32.__staleWhileFetching : p32.__returned = p32;
      }
    }
    get(k, {
      allowStale = this.allowStale,
      updateAgeOnGet = this.updateAgeOnGet,
      noDeleteOnStaleGet = this.noDeleteOnStaleGet,
      status
    } = {}) {
      const index = this.keyMap.get(k);
      if (index !== undefined) {
        const value = this.valList[index];
        const fetching = this.isBackgroundFetch(value);
        this.statusTTL(status, index);
        if (this.isStale(index)) {
          if (status)
            status.get = "stale";
          if (!fetching) {
            if (!noDeleteOnStaleGet) {
              this.delete(k);
            }
            if (status)
              status.returnedStale = allowStale;
            return allowStale ? value : undefined;
          } else {
            if (status) {
              status.returnedStale = allowStale && value.__staleWhileFetching !== undefined;
            }
            return allowStale ? value.__staleWhileFetching : undefined;
          }
        } else {
          if (status)
            status.get = "hit";
          if (fetching) {
            return value.__staleWhileFetching;
          }
          this.moveToTail(index);
          if (updateAgeOnGet) {
            this.updateItemAge(index);
          }
          return value;
        }
      } else if (status) {
        status.get = "miss";
      }
    }
    connect(p32, n) {
      this.prev[n] = p32;
      this.next[p32] = n;
    }
    moveToTail(index) {
      if (index !== this.tail) {
        if (index === this.head) {
          this.head = this.next[index];
        } else {
          this.connect(this.prev[index], this.next[index]);
        }
        this.connect(this.tail, index);
        this.tail = index;
      }
    }
    get del() {
      deprecatedMethod("del", "delete");
      return this.delete;
    }
    delete(k) {
      let deleted = false;
      if (this.size !== 0) {
        const index = this.keyMap.get(k);
        if (index !== undefined) {
          deleted = true;
          if (this.size === 1) {
            this.clear();
          } else {
            this.removeItemSize(index);
            const v22 = this.valList[index];
            if (this.isBackgroundFetch(v22)) {
              v22.__abortController.abort(new Error("deleted"));
            } else {
              this.dispose(v22, k, "delete");
              if (this.disposeAfter) {
                this.disposed.push([v22, k, "delete"]);
              }
            }
            this.keyMap.delete(k);
            this.keyList[index] = null;
            this.valList[index] = null;
            if (index === this.tail) {
              this.tail = this.prev[index];
            } else if (index === this.head) {
              this.head = this.next[index];
            } else {
              this.next[this.prev[index]] = this.next[index];
              this.prev[this.next[index]] = this.prev[index];
            }
            this.size--;
            this.free.push(index);
          }
        }
      }
      if (this.disposed) {
        while (this.disposed.length) {
          this.disposeAfter(...this.disposed.shift());
        }
      }
      return deleted;
    }
    clear() {
      for (const index of this.rindexes({ allowStale: true })) {
        const v22 = this.valList[index];
        if (this.isBackgroundFetch(v22)) {
          v22.__abortController.abort(new Error("deleted"));
        } else {
          const k = this.keyList[index];
          this.dispose(v22, k, "delete");
          if (this.disposeAfter) {
            this.disposed.push([v22, k, "delete"]);
          }
        }
      }
      this.keyMap.clear();
      this.valList.fill(null);
      this.keyList.fill(null);
      if (this.ttls) {
        this.ttls.fill(0);
        this.starts.fill(0);
      }
      if (this.sizes) {
        this.sizes.fill(0);
      }
      this.head = 0;
      this.tail = 0;
      this.initialFill = 1;
      this.free.length = 0;
      this.calculatedSize = 0;
      this.size = 0;
      if (this.disposed) {
        while (this.disposed.length) {
          this.disposeAfter(...this.disposed.shift());
        }
      }
    }
    get reset() {
      deprecatedMethod("reset", "clear");
      return this.clear;
    }
    get length() {
      deprecatedProperty("length", "size");
      return this.size;
    }
    static get AbortController() {
      return AC;
    }
    static get AbortSignal() {
      return AS;
    }
  }
  module.exports = LRUCache;
});
var require_named_placeholders = __commonJS2((exports, module) => {
  var RE_PARAM = /(?:\?)|(?::(\d+|(?:[a-zA-Z][a-zA-Z0-9_]*)))/g;
  var DQUOTE = 34;
  var SQUOTE = 39;
  var BSLASH = 92;
  function parse8(query) {
    let ppos = RE_PARAM.exec(query);
    let curpos = 0;
    let start = 0;
    let end;
    const parts = [];
    let inQuote = false;
    let escape3 = false;
    let qchr;
    const tokens = [];
    let qcnt = 0;
    let lastTokenEndPos = 0;
    let i2;
    if (ppos) {
      do {
        for (i2 = curpos, end = ppos.index;i2 < end; ++i2) {
          let chr = query.charCodeAt(i2);
          if (chr === BSLASH)
            escape3 = !escape3;
          else {
            if (escape3) {
              escape3 = false;
              continue;
            }
            if (inQuote && chr === qchr) {
              if (query.charCodeAt(i2 + 1) === qchr) {
                ++i2;
                continue;
              }
              inQuote = false;
            } else if (chr === DQUOTE || chr === SQUOTE) {
              inQuote = true;
              qchr = chr;
            }
          }
        }
        if (!inQuote) {
          parts.push(query.substring(start, end));
          tokens.push(ppos[0].length === 1 ? qcnt++ : ppos[1]);
          start = end + ppos[0].length;
          lastTokenEndPos = start;
        }
        curpos = end + ppos[0].length;
      } while (ppos = RE_PARAM.exec(query));
      if (tokens.length) {
        if (curpos < query.length) {
          parts.push(query.substring(lastTokenEndPos));
        }
        return [parts, tokens];
      }
    }
    return [query];
  }
  function createCompiler(config5) {
    if (!config5)
      config5 = {};
    if (!config5.placeholder) {
      config5.placeholder = "?";
    }
    let ncache = 100;
    let cache3;
    if (typeof config5.cache === "number") {
      ncache = config5.cache;
    }
    if (typeof config5.cache === "object") {
      cache3 = config5.cache;
    }
    if (config5.cache !== false && !cache3) {
      cache3 = new (require_lru_cache())({ max: ncache });
    }
    function toArrayParams(tree, params) {
      const arr = [];
      if (tree.length == 1) {
        return [tree[0], []];
      }
      if (typeof params == "undefined")
        throw new Error("Named query contains placeholders, but parameters object is undefined");
      const tokens = tree[1];
      for (let i2 = 0;i2 < tokens.length; ++i2) {
        arr.push(params[tokens[i2]]);
      }
      return [tree[0], arr];
    }
    function noTailingSemicolon(s32) {
      if (s32.slice(-1) == ":") {
        return s32.slice(0, -1);
      }
      return s32;
    }
    function join23(tree) {
      if (tree.length == 1) {
        return tree;
      }
      let unnamed = noTailingSemicolon(tree[0][0]);
      for (let i2 = 1;i2 < tree[0].length; ++i2) {
        if (tree[0][i2 - 1].slice(-1) == ":") {
          unnamed += config5.placeholder;
        }
        unnamed += config5.placeholder;
        unnamed += noTailingSemicolon(tree[0][i2]);
      }
      const last = tree[0][tree[0].length - 1];
      if (tree[0].length == tree[1].length) {
        if (last.slice(-1) == ":") {
          unnamed += config5.placeholder;
        }
        unnamed += config5.placeholder;
      }
      return [unnamed, tree[1]];
    }
    function compile(query, paramsObj) {
      let tree;
      if (cache3 && (tree = cache3.get(query))) {
        return toArrayParams(tree, paramsObj);
      }
      tree = join23(parse8(query));
      if (cache3) {
        cache3.set(query, tree);
      }
      return toArrayParams(tree, paramsObj);
    }
    compile.parse = parse8;
    return compile;
  }
  function toNumbered(q22, params) {
    const tree = parse8(q22);
    const paramsArr = [];
    if (tree.length == 1) {
      return [tree[0], paramsArr];
    }
    const pIndexes = {};
    let pLastIndex = 0;
    let qs = "";
    let varIndex;
    const varNames = [];
    for (let i2 = 0;i2 < tree[0].length; ++i2) {
      varIndex = pIndexes[tree[1][i2]];
      if (!varIndex) {
        varIndex = ++pLastIndex;
        pIndexes[tree[1][i2]] = varIndex;
      }
      if (tree[1][i2]) {
        varNames[varIndex - 1] = tree[1][i2];
        qs += tree[0][i2] + "$" + varIndex;
      } else {
        qs += tree[0][i2];
      }
    }
    return [qs, varNames.map((n) => params[n])];
  }
  module.exports = createCompiler;
  module.exports.toNumbered = toNumbered;
});
var require_connection = __commonJS2((exports, module) => {
  var Net = import.meta.require("net");
  var Tls = import.meta.require("tls");
  var Timers = import.meta.require("timers");
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var Readable10 = import.meta.require("stream").Readable;
  var Queue = require_denque();
  var SqlString = require_SqlString();
  var { createLRU } = require_lib14();
  var PacketParser = require_packet_parser();
  var Packets = require_packets();
  var Commands = require_commands2();
  var ConnectionConfig = require_connection_config();
  var CharsetToEncoding = require_charset_encodings();
  var _connectionId = 0;
  var convertNamedPlaceholders = null;

  class Connection extends EventEmitter23 {
    constructor(opts) {
      super();
      this.config = opts.config;
      if (!opts.config.stream) {
        if (opts.config.socketPath) {
          this.stream = Net.connect(opts.config.socketPath);
        } else {
          this.stream = Net.connect(opts.config.port, opts.config.host);
          if (this.config.enableKeepAlive) {
            this.stream.on("connect", () => {
              this.stream.setKeepAlive(true, this.config.keepAliveInitialDelay);
            });
          }
          this.stream.setNoDelay(true);
        }
      } else if (typeof opts.config.stream === "function") {
        this.stream = opts.config.stream(opts);
      } else {
        this.stream = opts.config.stream;
      }
      this._internalId = _connectionId++;
      this._commands = new Queue;
      this._command = null;
      this._paused = false;
      this._paused_packets = new Queue;
      this._statements = createLRU({
        max: this.config.maxPreparedStatements,
        onEviction: function(_22, statement) {
          statement.close();
        }
      });
      this.serverCapabilityFlags = 0;
      this.authorized = false;
      this.sequenceId = 0;
      this.compressedSequenceId = 0;
      this.threadId = null;
      this._handshakePacket = null;
      this._fatalError = null;
      this._protocolError = null;
      this._outOfOrderPackets = [];
      this.clientEncoding = CharsetToEncoding[this.config.charsetNumber];
      this.stream.on("error", this._handleNetworkError.bind(this));
      this.packetParser = new PacketParser((p32) => {
        this.handlePacket(p32);
      });
      this.stream.on("data", (data2) => {
        if (this.connectTimeout) {
          Timers.clearTimeout(this.connectTimeout);
          this.connectTimeout = null;
        }
        this.packetParser.execute(data2);
      });
      this.stream.on("end", () => {
        this.emit("end");
      });
      this.stream.on("close", () => {
        if (this._closing) {
          return;
        }
        if (!this._protocolError) {
          this._protocolError = new Error("Connection lost: The server closed the connection.");
          this._protocolError.fatal = true;
          this._protocolError.code = "PROTOCOL_CONNECTION_LOST";
        }
        this._notifyError(this._protocolError);
      });
      let handshakeCommand;
      if (!this.config.isServer) {
        handshakeCommand = new Commands.ClientHandshake(this.config.clientFlags);
        handshakeCommand.on("end", () => {
          if (!handshakeCommand.handshake || this._fatalError || this._protocolError) {
            return;
          }
          this._handshakePacket = handshakeCommand.handshake;
          this.threadId = handshakeCommand.handshake.connectionId;
          this.emit("connect", handshakeCommand.handshake);
        });
        handshakeCommand.on("error", (err22) => {
          this._closing = true;
          this._notifyError(err22);
        });
        this.addCommand(handshakeCommand);
      }
      this.serverEncoding = "utf8";
      if (this.config.connectTimeout) {
        const timeoutHandler = this._handleTimeoutError.bind(this);
        this.connectTimeout = Timers.setTimeout(timeoutHandler, this.config.connectTimeout);
      }
    }
    promise(promiseImpl) {
      const PromiseConnection = require_promise().PromiseConnection;
      return new PromiseConnection(this, promiseImpl);
    }
    _addCommandClosedState(cmd) {
      const err22 = new Error("Can't add new command when connection is in closed state");
      err22.fatal = true;
      if (cmd.onResult) {
        cmd.onResult(err22);
      } else {
        this.emit("error", err22);
      }
    }
    _handleFatalError(err22) {
      err22.fatal = true;
      this.stream.removeAllListeners("data");
      this.addCommand = this._addCommandClosedState;
      this.write = () => {
        this.emit("error", new Error("Can't write in closed state"));
      };
      this._notifyError(err22);
      this._fatalError = err22;
    }
    _handleNetworkError(err22) {
      if (this.connectTimeout) {
        Timers.clearTimeout(this.connectTimeout);
        this.connectTimeout = null;
      }
      if (err22.code === "ECONNRESET" && this._closing) {
        return;
      }
      this._handleFatalError(err22);
    }
    _handleTimeoutError() {
      if (this.connectTimeout) {
        Timers.clearTimeout(this.connectTimeout);
        this.connectTimeout = null;
      }
      this.stream.destroy && this.stream.destroy();
      const err22 = new Error("connect ETIMEDOUT");
      err22.errorno = "ETIMEDOUT";
      err22.code = "ETIMEDOUT";
      err22.syscall = "connect";
      this._handleNetworkError(err22);
    }
    _notifyError(err22) {
      if (this.connectTimeout) {
        Timers.clearTimeout(this.connectTimeout);
        this.connectTimeout = null;
      }
      if (this._fatalError) {
        return;
      }
      let command2;
      let bubbleErrorToConnection = !this._command;
      if (this._command && this._command.onResult) {
        this._command.onResult(err22);
        this._command = null;
      } else if (!(this._command && this._command.constructor === Commands.ClientHandshake && this._commands.length > 0)) {
        bubbleErrorToConnection = true;
      }
      while (command2 = this._commands.shift()) {
        if (command2.onResult) {
          command2.onResult(err22);
        } else {
          bubbleErrorToConnection = true;
        }
      }
      if (bubbleErrorToConnection || this._pool) {
        this.emit("error", err22);
      }
      if (err22.fatal) {
        this.close();
      }
    }
    write(buffer) {
      const result2 = this.stream.write(buffer, (err22) => {
        if (err22) {
          this._handleNetworkError(err22);
        }
      });
      if (!result2) {
        this.stream.emit("pause");
      }
    }
    _resetSequenceId() {
      this.sequenceId = 0;
      this.compressedSequenceId = 0;
    }
    _bumpCompressedSequenceId(numPackets) {
      this.compressedSequenceId += numPackets;
      this.compressedSequenceId %= 256;
    }
    _bumpSequenceId(numPackets) {
      this.sequenceId += numPackets;
      this.sequenceId %= 256;
    }
    writePacket(packet) {
      const MAX_PACKET_LENGTH = 16777215;
      const length = packet.length();
      let chunk, offset2, header;
      if (length < MAX_PACKET_LENGTH) {
        packet.writeHeader(this.sequenceId);
        if (this.config.debug) {
          console.log(`${this._internalId} ${this.connectionId} <== ${this._command._commandName}#${this._command.stateName()}(${[this.sequenceId, packet._name, packet.length()].join(",")})`);
          console.log(`${this._internalId} ${this.connectionId} <== ${packet.buffer.toString("hex")}`);
        }
        this._bumpSequenceId(1);
        this.write(packet.buffer);
      } else {
        if (this.config.debug) {
          console.log(`${this._internalId} ${this.connectionId} <== Writing large packet, raw content not written:`);
          console.log(`${this._internalId} ${this.connectionId} <== ${this._command._commandName}#${this._command.stateName()}(${[this.sequenceId, packet._name, packet.length()].join(",")})`);
        }
        for (offset2 = 4;offset2 < 4 + length; offset2 += MAX_PACKET_LENGTH) {
          chunk = packet.buffer.slice(offset2, offset2 + MAX_PACKET_LENGTH);
          if (chunk.length === MAX_PACKET_LENGTH) {
            header = Buffer.from([255, 255, 255, this.sequenceId]);
          } else {
            header = Buffer.from([
              chunk.length & 255,
              chunk.length >> 8 & 255,
              chunk.length >> 16 & 255,
              this.sequenceId
            ]);
          }
          this._bumpSequenceId(1);
          this.write(header);
          this.write(chunk);
        }
      }
    }
    startTLS(onSecure) {
      if (this.config.debug) {
        console.log("Upgrading connection to TLS");
      }
      const secureContext = Tls.createSecureContext({
        ca: this.config.ssl.ca,
        cert: this.config.ssl.cert,
        ciphers: this.config.ssl.ciphers,
        key: this.config.ssl.key,
        passphrase: this.config.ssl.passphrase,
        minVersion: this.config.ssl.minVersion,
        maxVersion: this.config.ssl.maxVersion
      });
      const rejectUnauthorized = this.config.ssl.rejectUnauthorized;
      const verifyIdentity = this.config.ssl.verifyIdentity;
      const servername = this.config.host;
      let secureEstablished = false;
      this.stream.removeAllListeners("data");
      const secureSocket = Tls.connect({
        rejectUnauthorized,
        requestCert: rejectUnauthorized,
        checkServerIdentity: verifyIdentity ? Tls.checkServerIdentity : function() {
          return;
        },
        secureContext,
        isServer: false,
        socket: this.stream,
        servername
      }, () => {
        secureEstablished = true;
        if (rejectUnauthorized) {
          if (typeof servername === "string" && verifyIdentity) {
            const cert = secureSocket.getPeerCertificate(true);
            const serverIdentityCheckError = Tls.checkServerIdentity(servername, cert);
            if (serverIdentityCheckError) {
              onSecure(serverIdentityCheckError);
              return;
            }
          }
        }
        onSecure();
      });
      secureSocket.on("error", (err22) => {
        if (secureEstablished) {
          this._handleNetworkError(err22);
        } else {
          onSecure(err22);
        }
      });
      secureSocket.on("data", (data2) => {
        this.packetParser.execute(data2);
      });
      this.write = (buffer) => secureSocket.write(buffer);
    }
    protocolError(message, code) {
      if (this._closing) {
        return;
      }
      const err22 = new Error(message);
      err22.fatal = true;
      err22.code = code || "PROTOCOL_ERROR";
      this.emit("error", err22);
    }
    get fatalError() {
      return this._fatalError;
    }
    handlePacket(packet) {
      if (this._paused) {
        this._paused_packets.push(packet);
        return;
      }
      if (this.config.debug) {
        if (packet) {
          console.log(` raw: ${packet.buffer.slice(packet.offset, packet.offset + packet.length()).toString("hex")}`);
          console.trace();
          const commandName = this._command ? this._command._commandName : "(no command)";
          const stateName = this._command ? this._command.stateName() : "(no command)";
          console.log(`${this._internalId} ${this.connectionId} ==> ${commandName}#${stateName}(${[packet.sequenceId, packet.type(), packet.length()].join(",")})`);
        }
      }
      if (!this._command) {
        const marker = packet.peekByte();
        if (marker === 255) {
          const error = Packets.Error.fromPacket(packet);
          this.protocolError(error.message, error.code);
        } else {
          this.protocolError("Unexpected packet while no commands in the queue", "PROTOCOL_UNEXPECTED_PACKET");
        }
        this.close();
        return;
      }
      if (packet) {
        if (this.sequenceId !== packet.sequenceId) {
          const err22 = new Error(`Warning: got packets out of order. Expected ${this.sequenceId} but received ${packet.sequenceId}`);
          err22.expected = this.sequenceId;
          err22.received = packet.sequenceId;
          this.emit("warn", err22);
          console.error(err22.message);
        }
        this._bumpSequenceId(packet.numPackets);
      }
      try {
        if (this._fatalError) {
          return;
        }
        const done = this._command.execute(packet, this);
        if (done) {
          this._command = this._commands.shift();
          if (this._command) {
            this.sequenceId = 0;
            this.compressedSequenceId = 0;
            this.handlePacket();
          }
        }
      } catch (err22) {
        this._handleFatalError(err22);
        this.stream.destroy();
      }
    }
    addCommand(cmd) {
      if (this.config.debug) {
        const commandName = cmd.constructor.name;
        console.log(`Add command: ${commandName}`);
        cmd._commandName = commandName;
      }
      if (!this._command) {
        this._command = cmd;
        this.handlePacket();
      } else {
        this._commands.push(cmd);
      }
      return cmd;
    }
    format(sql3, values3) {
      if (typeof this.config.queryFormat === "function") {
        return this.config.queryFormat.call(this, sql3, values3, this.config.timezone);
      }
      const opts = {
        sql: sql3,
        values: values3
      };
      this._resolveNamedPlaceholders(opts);
      return SqlString.format(opts.sql, opts.values, this.config.stringifyObjects, this.config.timezone);
    }
    escape(value) {
      return SqlString.escape(value, false, this.config.timezone);
    }
    escapeId(value) {
      return SqlString.escapeId(value, false);
    }
    raw(sql3) {
      return SqlString.raw(sql3);
    }
    _resolveNamedPlaceholders(options3) {
      let unnamed;
      if (this.config.namedPlaceholders || options3.namedPlaceholders) {
        if (Array.isArray(options3.values)) {
          return;
        }
        if (convertNamedPlaceholders === null) {
          convertNamedPlaceholders = require_named_placeholders()();
        }
        unnamed = convertNamedPlaceholders(options3.sql, options3.values);
        options3.sql = unnamed[0];
        options3.values = unnamed[1];
      }
    }
    query(sql3, values3, cb) {
      let cmdQuery;
      if (sql3.constructor === Commands.Query) {
        cmdQuery = sql3;
      } else {
        cmdQuery = Connection.createQuery(sql3, values3, cb, this.config);
      }
      this._resolveNamedPlaceholders(cmdQuery);
      const rawSql = this.format(cmdQuery.sql, cmdQuery.values !== undefined ? cmdQuery.values : []);
      cmdQuery.sql = rawSql;
      return this.addCommand(cmdQuery);
    }
    pause() {
      this._paused = true;
      this.stream.pause();
    }
    resume() {
      let packet;
      this._paused = false;
      while (packet = this._paused_packets.shift()) {
        this.handlePacket(packet);
        if (this._paused) {
          return;
        }
      }
      this.stream.resume();
    }
    prepare(options3, cb) {
      if (typeof options3 === "string") {
        options3 = { sql: options3 };
      }
      return this.addCommand(new Commands.Prepare(options3, cb));
    }
    unprepare(sql3) {
      let options3 = {};
      if (typeof sql3 === "object") {
        options3 = sql3;
      } else {
        options3.sql = sql3;
      }
      const key = Connection.statementKey(options3);
      const stmt = this._statements.get(key);
      if (stmt) {
        this._statements.delete(key);
        stmt.close();
      }
      return stmt;
    }
    execute(sql3, values3, cb) {
      let options3 = {
        infileStreamFactory: this.config.infileStreamFactory
      };
      if (typeof sql3 === "object") {
        options3 = {
          ...options3,
          ...sql3,
          sql: sql3.sql,
          values: sql3.values
        };
        if (typeof values3 === "function") {
          cb = values3;
        } else {
          options3.values = options3.values || values3;
        }
      } else if (typeof values3 === "function") {
        cb = values3;
        options3.sql = sql3;
        options3.values = undefined;
      } else {
        options3.sql = sql3;
        options3.values = values3;
      }
      this._resolveNamedPlaceholders(options3);
      if (options3.values) {
        if (!Array.isArray(options3.values)) {
          throw new TypeError("Bind parameters must be array if namedPlaceholders parameter is not enabled");
        }
        options3.values.forEach((val2) => {
          if (!Array.isArray(options3.values)) {
            throw new TypeError("Bind parameters must be array if namedPlaceholders parameter is not enabled");
          }
          if (val2 === undefined) {
            throw new TypeError("Bind parameters must not contain undefined. To pass SQL NULL specify JS null");
          }
          if (typeof val2 === "function") {
            throw new TypeError("Bind parameters must not contain function(s). To pass the body of a function as a string call .toString() first");
          }
        });
      }
      const executeCommand = new Commands.Execute(options3, cb);
      const prepareCommand = new Commands.Prepare(options3, (err22, stmt) => {
        if (err22) {
          executeCommand.start = function() {
            return null;
          };
          if (cb) {
            cb(err22);
          } else {
            executeCommand.emit("error", err22);
          }
          executeCommand.emit("end");
          return;
        }
        executeCommand.statement = stmt;
      });
      this.addCommand(prepareCommand);
      this.addCommand(executeCommand);
      return executeCommand;
    }
    changeUser(options3, callback) {
      if (!callback && typeof options3 === "function") {
        callback = options3;
        options3 = {};
      }
      const charsetNumber = options3.charset ? ConnectionConfig.getCharsetNumber(options3.charset) : this.config.charsetNumber;
      return this.addCommand(new Commands.ChangeUser({
        user: options3.user || this.config.user,
        password: options3.password || options3.password1 || this.config.password || this.config.password1,
        password2: options3.password2 || this.config.password2,
        password3: options3.password3 || this.config.password3,
        passwordSha1: options3.passwordSha1 || this.config.passwordSha1,
        database: options3.database || this.config.database,
        timeout: options3.timeout,
        charsetNumber,
        currentConfig: this.config
      }, (err22) => {
        if (err22) {
          err22.fatal = true;
        }
        if (callback) {
          callback(err22);
        }
      }));
    }
    beginTransaction(cb) {
      return this.query("START TRANSACTION", cb);
    }
    commit(cb) {
      return this.query("COMMIT", cb);
    }
    rollback(cb) {
      return this.query("ROLLBACK", cb);
    }
    ping(cb) {
      return this.addCommand(new Commands.Ping(cb));
    }
    _registerSlave(opts, cb) {
      return this.addCommand(new Commands.RegisterSlave(opts, cb));
    }
    _binlogDump(opts, cb) {
      return this.addCommand(new Commands.BinlogDump(opts, cb));
    }
    destroy() {
      this.close();
    }
    close() {
      if (this.connectTimeout) {
        Timers.clearTimeout(this.connectTimeout);
        this.connectTimeout = null;
      }
      this._closing = true;
      this.stream.end();
      this.addCommand = this._addCommandClosedState;
    }
    createBinlogStream(opts) {
      let test = 1;
      const stream2 = new Readable10({ objectMode: true });
      stream2._read = function() {
        return {
          data: test++
        };
      };
      this._registerSlave(opts, () => {
        const dumpCmd = this._binlogDump(opts);
        dumpCmd.on("event", (ev) => {
          stream2.push(ev);
        });
        dumpCmd.on("eof", () => {
          stream2.push(null);
          if (opts.flags && opts.flags & 1) {
            this.close();
          }
        });
      });
      return stream2;
    }
    connect(cb) {
      if (!cb) {
        return;
      }
      if (this._fatalError || this._protocolError) {
        return cb(this._fatalError || this._protocolError);
      }
      if (this._handshakePacket) {
        return cb(null, this);
      }
      let connectCalled = 0;
      function callbackOnce(isErrorHandler) {
        return function(param) {
          if (!connectCalled) {
            if (isErrorHandler) {
              cb(param);
            } else {
              cb(null, param);
            }
          }
          connectCalled = 1;
        };
      }
      this.once("error", callbackOnce(true));
      this.once("connect", callbackOnce(false));
    }
    writeColumns(columns) {
      this.writePacket(Packets.ResultSetHeader.toPacket(columns.length));
      columns.forEach((column) => {
        this.writePacket(Packets.ColumnDefinition.toPacket(column, this.serverConfig.encoding));
      });
      this.writeEof();
    }
    writeTextRow(column) {
      this.writePacket(Packets.TextRow.toPacket(column, this.serverConfig.encoding));
    }
    writeBinaryRow(column) {
      this.writePacket(Packets.BinaryRow.toPacket(column, this.serverConfig.encoding));
    }
    writeTextResult(rows, columns, binary2 = false) {
      this.writeColumns(columns);
      rows.forEach((row) => {
        const arrayRow = new Array(columns.length);
        columns.forEach((column) => {
          arrayRow.push(row[column.name]);
        });
        if (binary2) {
          this.writeBinaryRow(arrayRow);
        } else
          this.writeTextRow(arrayRow);
      });
      this.writeEof();
    }
    writeEof(warnings, statusFlags) {
      this.writePacket(Packets.EOF.toPacket(warnings, statusFlags));
    }
    writeOk(args) {
      if (!args) {
        args = { affectedRows: 0 };
      }
      this.writePacket(Packets.OK.toPacket(args, this.serverConfig.encoding));
    }
    writeError(args) {
      const encoding = this.serverConfig ? this.serverConfig.encoding : "cesu8";
      this.writePacket(Packets.Error.toPacket(args, encoding));
    }
    serverHandshake(args) {
      this.serverConfig = args;
      this.serverConfig.encoding = CharsetToEncoding[this.serverConfig.characterSet];
      return this.addCommand(new Commands.ServerHandshake(args));
    }
    end(callback) {
      if (this.config.isServer) {
        this._closing = true;
        const quitCmd2 = new EventEmitter23;
        setImmediate(() => {
          this.stream.end();
          quitCmd2.emit("end");
        });
        return quitCmd2;
      }
      const quitCmd = this.addCommand(new Commands.Quit(callback));
      this.addCommand = this._addCommandClosedState;
      return quitCmd;
    }
    static createQuery(sql3, values3, cb, config5) {
      let options3 = {
        rowsAsArray: config5.rowsAsArray,
        infileStreamFactory: config5.infileStreamFactory
      };
      if (typeof sql3 === "object") {
        options3 = {
          ...options3,
          ...sql3,
          sql: sql3.sql,
          values: sql3.values
        };
        if (typeof values3 === "function") {
          cb = values3;
        } else if (values3 !== undefined) {
          options3.values = values3;
        }
      } else if (typeof values3 === "function") {
        cb = values3;
        options3.sql = sql3;
        options3.values = undefined;
      } else {
        options3.sql = sql3;
        options3.values = values3;
      }
      return new Commands.Query(options3, cb);
    }
    static statementKey(options3) {
      return `${typeof options3.nestTables}/${options3.nestTables}/${options3.rowsAsArray}${options3.sql}`;
    }
  }
  module.exports = Connection;
});
var require_pool_connection = __commonJS2((exports, module) => {
  var Connection = require_mysql2().Connection;

  class PoolConnection extends Connection {
    constructor(pool, options3) {
      super(options3);
      this._pool = pool;
      this.lastActiveTime = Date.now();
      this.once("end", () => {
        this._removeFromPool();
      });
      this.once("error", () => {
        this._removeFromPool();
      });
    }
    release() {
      if (!this._pool || this._pool._closed) {
        return;
      }
      this.lastActiveTime = Date.now();
      this._pool.releaseConnection(this);
    }
    promise(promiseImpl) {
      const PromisePoolConnection = require_promise().PromisePoolConnection;
      return new PromisePoolConnection(this, promiseImpl);
    }
    end() {
      const err22 = new Error("Calling conn.end() to release a pooled connection is deprecated. In next version calling conn.end() will be restored to default conn.end() behavior. Use conn.release() instead.");
      this.emit("warn", err22);
      console.warn(err22.message);
      this.release();
    }
    destroy() {
      this._removeFromPool();
      super.destroy();
    }
    _removeFromPool() {
      if (!this._pool || this._pool._closed) {
        return;
      }
      const pool = this._pool;
      this._pool = null;
      pool._removeConnection(this);
    }
  }
  PoolConnection.statementKey = Connection.statementKey;
  module.exports = PoolConnection;
  PoolConnection.prototype._realEnd = Connection.prototype.end;
});
var require_pool = __commonJS2((exports, module) => {
  var process102 = import.meta.require("process");
  var mysql2 = require_mysql2();
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var PoolConnection = require_pool_connection();
  var Queue = require_denque();
  var Connection = require_connection();
  function spliceConnection(queue4, connection) {
    const len = queue4.length;
    for (let i2 = 0;i2 < len; i2++) {
      if (queue4.get(i2) === connection) {
        queue4.removeOne(i2);
        break;
      }
    }
  }

  class Pool extends EventEmitter23 {
    constructor(options3) {
      super();
      this.config = options3.config;
      this.config.connectionConfig.pool = this;
      this._allConnections = new Queue;
      this._freeConnections = new Queue;
      this._connectionQueue = new Queue;
      this._closed = false;
      if (this.config.maxIdle < this.config.connectionLimit) {
        this._removeIdleTimeoutConnections();
      }
    }
    promise(promiseImpl) {
      const PromisePool = require_promise().PromisePool;
      return new PromisePool(this, promiseImpl);
    }
    getConnection(cb) {
      if (this._closed) {
        return process102.nextTick(() => cb(new Error("Pool is closed.")));
      }
      let connection;
      if (this._freeConnections.length > 0) {
        connection = this._freeConnections.pop();
        this.emit("acquire", connection);
        return process102.nextTick(() => cb(null, connection));
      }
      if (this.config.connectionLimit === 0 || this._allConnections.length < this.config.connectionLimit) {
        connection = new PoolConnection(this, {
          config: this.config.connectionConfig
        });
        this._allConnections.push(connection);
        return connection.connect((err22) => {
          if (this._closed) {
            return cb(new Error("Pool is closed."));
          }
          if (err22) {
            return cb(err22);
          }
          this.emit("connection", connection);
          this.emit("acquire", connection);
          return cb(null, connection);
        });
      }
      if (!this.config.waitForConnections) {
        return process102.nextTick(() => cb(new Error("No connections available.")));
      }
      if (this.config.queueLimit && this._connectionQueue.length >= this.config.queueLimit) {
        return cb(new Error("Queue limit reached."));
      }
      this.emit("enqueue");
      return this._connectionQueue.push(cb);
    }
    releaseConnection(connection) {
      let cb;
      if (!connection._pool) {
        if (this._connectionQueue.length) {
          cb = this._connectionQueue.shift();
          process102.nextTick(this.getConnection.bind(this, cb));
        }
      } else if (this._connectionQueue.length) {
        cb = this._connectionQueue.shift();
        process102.nextTick(cb.bind(null, null, connection));
      } else {
        this._freeConnections.push(connection);
        this.emit("release", connection);
      }
    }
    end(cb) {
      this._closed = true;
      clearTimeout(this._removeIdleTimeoutConnectionsTimer);
      if (typeof cb !== "function") {
        cb = function(err22) {
          if (err22) {
            throw err22;
          }
        };
      }
      let calledBack = false;
      let closedConnections = 0;
      let connection;
      const endCB = function(err22) {
        if (calledBack) {
          return;
        }
        if (err22 || ++closedConnections >= this._allConnections.length) {
          calledBack = true;
          cb(err22);
          return;
        }
      }.bind(this);
      if (this._allConnections.length === 0) {
        endCB();
        return;
      }
      for (let i2 = 0;i2 < this._allConnections.length; i2++) {
        connection = this._allConnections.get(i2);
        connection._realEnd(endCB);
      }
    }
    query(sql3, values3, cb) {
      const cmdQuery = Connection.createQuery(sql3, values3, cb, this.config.connectionConfig);
      if (typeof cmdQuery.namedPlaceholders === "undefined") {
        cmdQuery.namedPlaceholders = this.config.connectionConfig.namedPlaceholders;
      }
      this.getConnection((err22, conn) => {
        if (err22) {
          if (typeof cmdQuery.onResult === "function") {
            cmdQuery.onResult(err22);
          } else {
            cmdQuery.emit("error", err22);
          }
          return;
        }
        try {
          conn.query(cmdQuery).once("end", () => {
            conn.release();
          });
        } catch (e) {
          conn.release();
          throw e;
        }
      });
      return cmdQuery;
    }
    execute(sql3, values3, cb) {
      if (typeof values3 === "function") {
        cb = values3;
        values3 = [];
      }
      this.getConnection((err22, conn) => {
        if (err22) {
          return cb(err22);
        }
        try {
          conn.execute(sql3, values3, cb).once("end", () => {
            conn.release();
          });
        } catch (e) {
          conn.release();
          return cb(e);
        }
      });
    }
    _removeConnection(connection) {
      spliceConnection(this._allConnections, connection);
      spliceConnection(this._freeConnections, connection);
      this.releaseConnection(connection);
    }
    _removeIdleTimeoutConnections() {
      if (this._removeIdleTimeoutConnectionsTimer) {
        clearTimeout(this._removeIdleTimeoutConnectionsTimer);
      }
      this._removeIdleTimeoutConnectionsTimer = setTimeout(() => {
        try {
          while (this._freeConnections.length > this.config.maxIdle || this._freeConnections.length > 0 && Date.now() - this._freeConnections.get(0).lastActiveTime > this.config.idleTimeout) {
            this._freeConnections.get(0).destroy();
          }
        } finally {
          this._removeIdleTimeoutConnections();
        }
      }, 1000);
    }
    format(sql3, values3) {
      return mysql2.format(sql3, values3, this.config.connectionConfig.stringifyObjects, this.config.connectionConfig.timezone);
    }
    escape(value) {
      return mysql2.escape(value, this.config.connectionConfig.stringifyObjects, this.config.connectionConfig.timezone);
    }
    escapeId(value) {
      return mysql2.escapeId(value, false);
    }
  }
  module.exports = Pool;
});
var require_pool_config = __commonJS2((exports, module) => {
  var ConnectionConfig = require_connection_config();

  class PoolConfig {
    constructor(options3) {
      if (typeof options3 === "string") {
        options3 = ConnectionConfig.parseUrl(options3);
      }
      this.connectionConfig = new ConnectionConfig(options3);
      this.waitForConnections = options3.waitForConnections === undefined ? true : Boolean(options3.waitForConnections);
      this.connectionLimit = isNaN(options3.connectionLimit) ? 10 : Number(options3.connectionLimit);
      this.maxIdle = isNaN(options3.maxIdle) ? this.connectionLimit : Number(options3.maxIdle);
      this.idleTimeout = isNaN(options3.idleTimeout) ? 60000 : Number(options3.idleTimeout);
      this.queueLimit = isNaN(options3.queueLimit) ? 0 : Number(options3.queueLimit);
    }
  }
  module.exports = PoolConfig;
});
var require_pool_cluster = __commonJS2((exports, module) => {
  var process102 = import.meta.require("process");
  var Pool = require_pool();
  var PoolConfig = require_pool_config();
  var Connection = require_connection();
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var makeSelector = {
    RR() {
      let index = 0;
      return (clusterIds) => clusterIds[index++ % clusterIds.length];
    },
    RANDOM() {
      return (clusterIds) => clusterIds[Math.floor(Math.random() * clusterIds.length)];
    },
    ORDER() {
      return (clusterIds) => clusterIds[0];
    }
  };

  class PoolNamespace {
    constructor(cluster, pattern, selector) {
      this._cluster = cluster;
      this._pattern = pattern;
      this._selector = makeSelector[selector]();
    }
    getConnection(cb) {
      const clusterNode = this._getClusterNode();
      if (clusterNode === null) {
        return cb(new Error("Pool does Not exists."));
      }
      return this._cluster._getConnection(clusterNode, (err22, connection) => {
        if (err22) {
          return cb(err22);
        }
        if (connection === "retry") {
          return this.getConnection(cb);
        }
        return cb(null, connection);
      });
    }
    query(sql3, values3, cb) {
      const query = Connection.createQuery(sql3, values3, cb, {});
      this.getConnection((err22, conn) => {
        if (err22) {
          if (typeof query.onResult === "function") {
            query.onResult(err22);
          } else {
            query.emit("error", err22);
          }
          return;
        }
        try {
          conn.query(query).once("end", () => {
            conn.release();
          });
        } catch (e) {
          conn.release();
          throw e;
        }
      });
      return query;
    }
    execute(sql3, values3, cb) {
      if (typeof values3 === "function") {
        cb = values3;
        values3 = [];
      }
      this.getConnection((err22, conn) => {
        if (err22) {
          return cb(err22);
        }
        try {
          conn.execute(sql3, values3, cb).once("end", () => {
            conn.release();
          });
        } catch (e) {
          conn.release();
          throw e;
        }
      });
    }
    _getClusterNode() {
      const foundNodeIds = this._cluster._findNodeIds(this._pattern);
      if (foundNodeIds.length === 0) {
        return null;
      }
      const nodeId = foundNodeIds.length === 1 ? foundNodeIds[0] : this._selector(foundNodeIds);
      return this._cluster._getNode(nodeId);
    }
  }

  class PoolCluster extends EventEmitter23 {
    constructor(config5) {
      super();
      config5 = config5 || {};
      this._canRetry = typeof config5.canRetry === "undefined" ? true : config5.canRetry;
      this._removeNodeErrorCount = config5.removeNodeErrorCount || 5;
      this._defaultSelector = config5.defaultSelector || "RR";
      this._closed = false;
      this._lastId = 0;
      this._nodes = {};
      this._serviceableNodeIds = [];
      this._namespaces = {};
      this._findCaches = {};
    }
    of(pattern, selector) {
      pattern = pattern || "*";
      selector = selector || this._defaultSelector;
      selector = selector.toUpperCase();
      if (!makeSelector[selector] === "undefined") {
        selector = this._defaultSelector;
      }
      const key = pattern + selector;
      if (typeof this._namespaces[key] === "undefined") {
        this._namespaces[key] = new PoolNamespace(this, pattern, selector);
      }
      return this._namespaces[key];
    }
    add(id, config5) {
      if (typeof id === "object") {
        config5 = id;
        id = `CLUSTER::${++this._lastId}`;
      }
      if (typeof this._nodes[id] === "undefined") {
        this._nodes[id] = {
          id,
          errorCount: 0,
          pool: new Pool({ config: new PoolConfig(config5) })
        };
        this._serviceableNodeIds.push(id);
        this._clearFindCaches();
      }
    }
    getConnection(pattern, selector, cb) {
      let namespace;
      if (typeof pattern === "function") {
        cb = pattern;
        namespace = this.of();
      } else {
        if (typeof selector === "function") {
          cb = selector;
          selector = this._defaultSelector;
        }
        namespace = this.of(pattern, selector);
      }
      namespace.getConnection(cb);
    }
    end(callback) {
      const cb = callback !== undefined ? callback : (err22) => {
        if (err22) {
          throw err22;
        }
      };
      if (this._closed) {
        process102.nextTick(cb);
        return;
      }
      this._closed = true;
      let calledBack = false;
      let waitingClose = 0;
      const onEnd = (err22) => {
        if (!calledBack && (err22 || --waitingClose <= 0)) {
          calledBack = true;
          return cb(err22);
        }
      };
      for (const id in this._nodes) {
        waitingClose++;
        this._nodes[id].pool.end(onEnd);
      }
      if (waitingClose === 0) {
        process102.nextTick(onEnd);
      }
    }
    _findNodeIds(pattern) {
      if (typeof this._findCaches[pattern] !== "undefined") {
        return this._findCaches[pattern];
      }
      let foundNodeIds;
      if (pattern === "*") {
        foundNodeIds = this._serviceableNodeIds;
      } else if (this._serviceableNodeIds.indexOf(pattern) !== -1) {
        foundNodeIds = [pattern];
      } else {
        const keyword = pattern.substring(pattern.length - 1, 0);
        foundNodeIds = this._serviceableNodeIds.filter((id) => id.startsWith(keyword));
      }
      this._findCaches[pattern] = foundNodeIds;
      return foundNodeIds;
    }
    _getNode(id) {
      return this._nodes[id] || null;
    }
    _increaseErrorCount(node) {
      if (++node.errorCount >= this._removeNodeErrorCount) {
        const index = this._serviceableNodeIds.indexOf(node.id);
        if (index !== -1) {
          this._serviceableNodeIds.splice(index, 1);
          delete this._nodes[node.id];
          this._clearFindCaches();
          node.pool.end();
          this.emit("remove", node.id);
        }
      }
    }
    _decreaseErrorCount(node) {
      if (node.errorCount > 0) {
        --node.errorCount;
      }
    }
    _getConnection(node, cb) {
      node.pool.getConnection((err22, connection) => {
        if (err22) {
          this._increaseErrorCount(node);
          if (this._canRetry) {
            this.emit("warn", err22);
            console.warn(`[Error] PoolCluster : ${err22}`);
            return cb(null, "retry");
          }
          return cb(err22);
        }
        this._decreaseErrorCount(node);
        connection._clusterId = node.id;
        return cb(null, connection);
      });
    }
    _clearFindCaches() {
      this._findCaches = {};
    }
  }
  module.exports = PoolCluster;
});
var require_server = __commonJS2((exports, module) => {
  var net = import.meta.require("net");
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var Connection = require_connection();
  var ConnectionConfig = require_connection_config();

  class Server extends EventEmitter23 {
    constructor() {
      super();
      this.connections = [];
      this._server = net.createServer(this._handleConnection.bind(this));
    }
    _handleConnection(socket) {
      const connectionConfig = new ConnectionConfig({
        stream: socket,
        isServer: true
      });
      const connection = new Connection({ config: connectionConfig });
      this.emit("connection", connection);
    }
    listen(port) {
      this._port = port;
      this._server.listen.apply(this._server, arguments);
      return this;
    }
    close(cb) {
      this._server.close(cb);
    }
  }
  module.exports = Server;
});
var require_auth_plugins = __commonJS2((exports, module) => {
  module.exports = {
    caching_sha2_password: require_caching_sha2_password(),
    mysql_clear_password: require_mysql_clear_password(),
    mysql_native_password: require_mysql_native_password(),
    sha256_password: require_sha256_password()
  };
});
var require_mysql2 = __commonJS2((exports) => {
  var SqlString = require_SqlString();
  var Connection = require_connection();
  var ConnectionConfig = require_connection_config();
  var parserCache = require_parser_cache();
  exports.createConnection = function(opts) {
    return new Connection({ config: new ConnectionConfig(opts) });
  };
  exports.connect = exports.createConnection;
  exports.Connection = Connection;
  exports.ConnectionConfig = ConnectionConfig;
  var Pool = require_pool();
  var PoolCluster = require_pool_cluster();
  exports.createPool = function(config5) {
    const PoolConfig = require_pool_config();
    return new Pool({ config: new PoolConfig(config5) });
  };
  exports.createPoolCluster = function(config5) {
    const PoolCluster2 = require_pool_cluster();
    return new PoolCluster2(config5);
  };
  exports.createQuery = Connection.createQuery;
  exports.Pool = Pool;
  exports.PoolCluster = PoolCluster;
  exports.createServer = function(handler3) {
    const Server = require_server();
    const s32 = new Server;
    if (handler3) {
      s32.on("connection", handler3);
    }
    return s32;
  };
  exports.PoolConnection = require_pool_connection();
  exports.authPlugins = require_auth_plugins();
  exports.escape = SqlString.escape;
  exports.escapeId = SqlString.escapeId;
  exports.format = SqlString.format;
  exports.raw = SqlString.raw;
  exports.__defineGetter__("createConnectionPromise", () => require_promise().createConnection);
  exports.__defineGetter__("createPoolPromise", () => require_promise().createPool);
  exports.__defineGetter__("createPoolClusterPromise", () => require_promise().createPoolCluster);
  exports.__defineGetter__("Types", () => require_types2());
  exports.__defineGetter__("Charsets", () => require_charsets());
  exports.__defineGetter__("CharsetToEncoding", () => require_charset_encodings());
  exports.setMaxParserCache = function(max) {
    parserCache.setMaxCache(max);
  };
  exports.clearParserCache = function() {
    parserCache.clearCache();
  };
});
var require_postgres_array = __commonJS2((exports) => {
  exports.parse = function(source, transform2) {
    return new ArrayParser(source, transform2).parse();
  };

  class ArrayParser {
    constructor(source, transform2) {
      this.source = source;
      this.transform = transform2 || identity;
      this.position = 0;
      this.entries = [];
      this.recorded = [];
      this.dimension = 0;
    }
    isEof() {
      return this.position >= this.source.length;
    }
    nextCharacter() {
      var character = this.source[this.position++];
      if (character === "\\") {
        return {
          value: this.source[this.position++],
          escaped: true
        };
      }
      return {
        value: character,
        escaped: false
      };
    }
    record(character) {
      this.recorded.push(character);
    }
    newEntry(includeEmpty) {
      var entry;
      if (this.recorded.length > 0 || includeEmpty) {
        entry = this.recorded.join("");
        if (entry === "NULL" && !includeEmpty) {
          entry = null;
        }
        if (entry !== null)
          entry = this.transform(entry);
        this.entries.push(entry);
        this.recorded = [];
      }
    }
    consumeDimensions() {
      if (this.source[0] === "[") {
        while (!this.isEof()) {
          var char = this.nextCharacter();
          if (char.value === "=")
            break;
        }
      }
    }
    parse(nested) {
      var character, parser, quote;
      this.consumeDimensions();
      while (!this.isEof()) {
        character = this.nextCharacter();
        if (character.value === "{" && !quote) {
          this.dimension++;
          if (this.dimension > 1) {
            parser = new ArrayParser(this.source.substr(this.position - 1), this.transform);
            this.entries.push(parser.parse(true));
            this.position += parser.position - 2;
          }
        } else if (character.value === "}" && !quote) {
          this.dimension--;
          if (!this.dimension) {
            this.newEntry();
            if (nested)
              return this.entries;
          }
        } else if (character.value === '"' && !character.escaped) {
          if (quote)
            this.newEntry(true);
          quote = !quote;
        } else if (character.value === "," && !quote) {
          this.newEntry();
        } else {
          this.record(character.value);
        }
      }
      if (this.dimension !== 0) {
        throw new Error("array dimension not balanced");
      }
      return this.entries;
    }
  }
  function identity(value) {
    return value;
  }
});
var require_arrayParser = __commonJS2((exports, module) => {
  var array = require_postgres_array();
  module.exports = {
    create: function(source, transform2) {
      return {
        parse: function() {
          return array.parse(source, transform2);
        }
      };
    }
  };
});
var require_postgres_date = __commonJS2((exports, module) => {
  var DATE_TIME = /(\d{1,})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})(\.\d{1,})?.*?( BC)?$/;
  var DATE = /^(\d{1,})-(\d{2})-(\d{2})( BC)?$/;
  var TIME_ZONE = /([Z+-])(\d{2})?:?(\d{2})?:?(\d{2})?/;
  var INFINITY = /^-?infinity$/;
  module.exports = function parseDate(isoDate) {
    if (INFINITY.test(isoDate)) {
      return Number(isoDate.replace("i", "I"));
    }
    var matches = DATE_TIME.exec(isoDate);
    if (!matches) {
      return getDate(isoDate) || null;
    }
    var isBC = !!matches[8];
    var year = parseInt(matches[1], 10);
    if (isBC) {
      year = bcYearToNegativeYear(year);
    }
    var month = parseInt(matches[2], 10) - 1;
    var day = matches[3];
    var hour = parseInt(matches[4], 10);
    var minute = parseInt(matches[5], 10);
    var second = parseInt(matches[6], 10);
    var ms = matches[7];
    ms = ms ? 1000 * parseFloat(ms) : 0;
    var date;
    var offset2 = timeZoneOffset(isoDate);
    if (offset2 != null) {
      date = new Date(Date.UTC(year, month, day, hour, minute, second, ms));
      if (is0To99(year)) {
        date.setUTCFullYear(year);
      }
      if (offset2 !== 0) {
        date.setTime(date.getTime() - offset2);
      }
    } else {
      date = new Date(year, month, day, hour, minute, second, ms);
      if (is0To99(year)) {
        date.setFullYear(year);
      }
    }
    return date;
  };
  function getDate(isoDate) {
    var matches = DATE.exec(isoDate);
    if (!matches) {
      return;
    }
    var year = parseInt(matches[1], 10);
    var isBC = !!matches[4];
    if (isBC) {
      year = bcYearToNegativeYear(year);
    }
    var month = parseInt(matches[2], 10) - 1;
    var day = matches[3];
    var date = new Date(year, month, day);
    if (is0To99(year)) {
      date.setFullYear(year);
    }
    return date;
  }
  function timeZoneOffset(isoDate) {
    if (isoDate.endsWith("+00")) {
      return 0;
    }
    var zone = TIME_ZONE.exec(isoDate.split(" ")[1]);
    if (!zone)
      return;
    var type = zone[1];
    if (type === "Z") {
      return 0;
    }
    var sign = type === "-" ? -1 : 1;
    var offset2 = parseInt(zone[2], 10) * 3600 + parseInt(zone[3] || 0, 10) * 60 + parseInt(zone[4] || 0, 10);
    return offset2 * sign * 1000;
  }
  function bcYearToNegativeYear(year) {
    return -(year - 1);
  }
  function is0To99(num) {
    return num >= 0 && num < 100;
  }
});
var require_mutable = __commonJS2((exports, module) => {
  module.exports = extend2;
  var hasOwnProperty3 = Object.prototype.hasOwnProperty;
  function extend2(target) {
    for (var i2 = 1;i2 < arguments.length; i2++) {
      var source = arguments[i2];
      for (var key in source) {
        if (hasOwnProperty3.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  }
});
var require_postgres_interval = __commonJS2((exports, module) => {
  var extend2 = require_mutable();
  module.exports = PostgresInterval;
  function PostgresInterval(raw) {
    if (!(this instanceof PostgresInterval)) {
      return new PostgresInterval(raw);
    }
    extend2(this, parse8(raw));
  }
  var properties = ["seconds", "minutes", "hours", "days", "months", "years"];
  PostgresInterval.prototype.toPostgres = function() {
    var filtered = properties.filter(this.hasOwnProperty, this);
    if (this.milliseconds && filtered.indexOf("seconds") < 0) {
      filtered.push("seconds");
    }
    if (filtered.length === 0)
      return "0";
    return filtered.map(function(property) {
      var value = this[property] || 0;
      if (property === "seconds" && this.milliseconds) {
        value = (value + this.milliseconds / 1000).toFixed(6).replace(/\.?0+$/, "");
      }
      return value + " " + property;
    }, this).join(" ");
  };
  var propertiesISOEquivalent = {
    years: "Y",
    months: "M",
    days: "D",
    hours: "H",
    minutes: "M",
    seconds: "S"
  };
  var dateProperties = ["years", "months", "days"];
  var timeProperties = ["hours", "minutes", "seconds"];
  PostgresInterval.prototype.toISOString = PostgresInterval.prototype.toISO = function() {
    var datePart = dateProperties.map(buildProperty, this).join("");
    var timePart = timeProperties.map(buildProperty, this).join("");
    return "P" + datePart + "T" + timePart;
    function buildProperty(property) {
      var value = this[property] || 0;
      if (property === "seconds" && this.milliseconds) {
        value = (value + this.milliseconds / 1000).toFixed(6).replace(/0+$/, "");
      }
      return value + propertiesISOEquivalent[property];
    }
  };
  var NUMBER = "([+-]?\\d+)";
  var YEAR = NUMBER + "\\s+years?";
  var MONTH = NUMBER + "\\s+mons?";
  var DAY = NUMBER + "\\s+days?";
  var TIME = "([+-])?([\\d]*):(\\d\\d):(\\d\\d)\\.?(\\d{1,6})?";
  var INTERVAL = new RegExp([YEAR, MONTH, DAY, TIME].map(function(regexString) {
    return "(" + regexString + ")?";
  }).join("\\s*"));
  var positions = {
    years: 2,
    months: 4,
    days: 6,
    hours: 9,
    minutes: 10,
    seconds: 11,
    milliseconds: 12
  };
  var negatives = ["hours", "minutes", "seconds", "milliseconds"];
  function parseMilliseconds(fraction) {
    var microseconds = fraction + "000000".slice(fraction.length);
    return parseInt(microseconds, 10) / 1000;
  }
  function parse8(interval) {
    if (!interval)
      return {};
    var matches = INTERVAL.exec(interval);
    var isNegative = matches[8] === "-";
    return Object.keys(positions).reduce(function(parsed, property) {
      var position = positions[property];
      var value = matches[position];
      if (!value)
        return parsed;
      value = property === "milliseconds" ? parseMilliseconds(value) : parseInt(value, 10);
      if (!value)
        return parsed;
      if (isNegative && ~negatives.indexOf(property)) {
        value *= -1;
      }
      parsed[property] = value;
      return parsed;
    }, {});
  }
});
var require_postgres_bytea = __commonJS2((exports, module) => {
  module.exports = function parseBytea(input) {
    if (/^\\x/.test(input)) {
      return new Buffer(input.substr(2), "hex");
    }
    var output = "";
    var i2 = 0;
    while (i2 < input.length) {
      if (input[i2] !== "\\") {
        output += input[i2];
        ++i2;
      } else {
        if (/[0-7]{3}/.test(input.substr(i2 + 1, 3))) {
          output += String.fromCharCode(parseInt(input.substr(i2 + 1, 3), 8));
          i2 += 4;
        } else {
          var backslashes = 1;
          while (i2 + backslashes < input.length && input[i2 + backslashes] === "\\") {
            backslashes++;
          }
          for (var k = 0;k < Math.floor(backslashes / 2); ++k) {
            output += "\\";
          }
          i2 += Math.floor(backslashes / 2) * 2;
        }
      }
    }
    return new Buffer(output, "binary");
  };
});
var require_textParsers = __commonJS2((exports, module) => {
  var array = require_postgres_array();
  var arrayParser = require_arrayParser();
  var parseDate = require_postgres_date();
  var parseInterval = require_postgres_interval();
  var parseByteA = require_postgres_bytea();
  function allowNull(fn) {
    return function nullAllowed(value) {
      if (value === null)
        return value;
      return fn(value);
    };
  }
  function parseBool(value) {
    if (value === null)
      return value;
    return value === "TRUE" || value === "t" || value === "true" || value === "y" || value === "yes" || value === "on" || value === "1";
  }
  function parseBoolArray(value) {
    if (!value)
      return null;
    return array.parse(value, parseBool);
  }
  function parseBaseTenInt(string2) {
    return parseInt(string2, 10);
  }
  function parseIntegerArray(value) {
    if (!value)
      return null;
    return array.parse(value, allowNull(parseBaseTenInt));
  }
  function parseBigIntegerArray(value) {
    if (!value)
      return null;
    return array.parse(value, allowNull(function(entry) {
      return parseBigInteger(entry).trim();
    }));
  }
  var parsePointArray = function(value) {
    if (!value) {
      return null;
    }
    var p32 = arrayParser.create(value, function(entry) {
      if (entry !== null) {
        entry = parsePoint(entry);
      }
      return entry;
    });
    return p32.parse();
  };
  var parseFloatArray = function(value) {
    if (!value) {
      return null;
    }
    var p32 = arrayParser.create(value, function(entry) {
      if (entry !== null) {
        entry = parseFloat(entry);
      }
      return entry;
    });
    return p32.parse();
  };
  var parseStringArray = function(value) {
    if (!value) {
      return null;
    }
    var p32 = arrayParser.create(value);
    return p32.parse();
  };
  var parseDateArray = function(value) {
    if (!value) {
      return null;
    }
    var p32 = arrayParser.create(value, function(entry) {
      if (entry !== null) {
        entry = parseDate(entry);
      }
      return entry;
    });
    return p32.parse();
  };
  var parseIntervalArray = function(value) {
    if (!value) {
      return null;
    }
    var p32 = arrayParser.create(value, function(entry) {
      if (entry !== null) {
        entry = parseInterval(entry);
      }
      return entry;
    });
    return p32.parse();
  };
  var parseByteAArray = function(value) {
    if (!value) {
      return null;
    }
    return array.parse(value, allowNull(parseByteA));
  };
  var parseInteger = function(value) {
    return parseInt(value, 10);
  };
  var parseBigInteger = function(value) {
    var valStr = String(value);
    if (/^\d+$/.test(valStr)) {
      return valStr;
    }
    return value;
  };
  var parseJsonArray = function(value) {
    if (!value) {
      return null;
    }
    return array.parse(value, allowNull(JSON.parse));
  };
  var parsePoint = function(value) {
    if (value[0] !== "(") {
      return null;
    }
    value = value.substring(1, value.length - 1).split(",");
    return {
      x: parseFloat(value[0]),
      y: parseFloat(value[1])
    };
  };
  var parseCircle = function(value) {
    if (value[0] !== "<" && value[1] !== "(") {
      return null;
    }
    var point = "(";
    var radius = "";
    var pointParsed = false;
    for (var i2 = 2;i2 < value.length - 1; i2++) {
      if (!pointParsed) {
        point += value[i2];
      }
      if (value[i2] === ")") {
        pointParsed = true;
        continue;
      } else if (!pointParsed) {
        continue;
      }
      if (value[i2] === ",") {
        continue;
      }
      radius += value[i2];
    }
    var result2 = parsePoint(point);
    result2.radius = parseFloat(radius);
    return result2;
  };
  var init3 = function(register) {
    register(20, parseBigInteger);
    register(21, parseInteger);
    register(23, parseInteger);
    register(26, parseInteger);
    register(700, parseFloat);
    register(701, parseFloat);
    register(16, parseBool);
    register(1082, parseDate);
    register(1114, parseDate);
    register(1184, parseDate);
    register(600, parsePoint);
    register(651, parseStringArray);
    register(718, parseCircle);
    register(1000, parseBoolArray);
    register(1001, parseByteAArray);
    register(1005, parseIntegerArray);
    register(1007, parseIntegerArray);
    register(1028, parseIntegerArray);
    register(1016, parseBigIntegerArray);
    register(1017, parsePointArray);
    register(1021, parseFloatArray);
    register(1022, parseFloatArray);
    register(1231, parseFloatArray);
    register(1014, parseStringArray);
    register(1015, parseStringArray);
    register(1008, parseStringArray);
    register(1009, parseStringArray);
    register(1040, parseStringArray);
    register(1041, parseStringArray);
    register(1115, parseDateArray);
    register(1182, parseDateArray);
    register(1185, parseDateArray);
    register(1186, parseInterval);
    register(1187, parseIntervalArray);
    register(17, parseByteA);
    register(114, JSON.parse.bind(JSON));
    register(3802, JSON.parse.bind(JSON));
    register(199, parseJsonArray);
    register(3807, parseJsonArray);
    register(3907, parseStringArray);
    register(2951, parseStringArray);
    register(791, parseStringArray);
    register(1183, parseStringArray);
    register(1270, parseStringArray);
  };
  module.exports = {
    init: init3
  };
});
var require_pg_int8 = __commonJS2((exports, module) => {
  var BASE = 1e6;
  function readInt8(buffer) {
    var high = buffer.readInt32BE(0);
    var low = buffer.readUInt32BE(4);
    var sign = "";
    if (high < 0) {
      high = ~high + (low === 0);
      low = ~low + 1 >>> 0;
      sign = "-";
    }
    var result2 = "";
    var carry;
    var t;
    var digits;
    var pad;
    var l22;
    var i2;
    {
      carry = high % BASE;
      high = high / BASE >>> 0;
      t = 4294967296 * carry + low;
      low = t / BASE >>> 0;
      digits = "" + (t - BASE * low);
      if (low === 0 && high === 0) {
        return sign + digits + result2;
      }
      pad = "";
      l22 = 6 - digits.length;
      for (i2 = 0;i2 < l22; i2++) {
        pad += "0";
      }
      result2 = pad + digits + result2;
    }
    {
      carry = high % BASE;
      high = high / BASE >>> 0;
      t = 4294967296 * carry + low;
      low = t / BASE >>> 0;
      digits = "" + (t - BASE * low);
      if (low === 0 && high === 0) {
        return sign + digits + result2;
      }
      pad = "";
      l22 = 6 - digits.length;
      for (i2 = 0;i2 < l22; i2++) {
        pad += "0";
      }
      result2 = pad + digits + result2;
    }
    {
      carry = high % BASE;
      high = high / BASE >>> 0;
      t = 4294967296 * carry + low;
      low = t / BASE >>> 0;
      digits = "" + (t - BASE * low);
      if (low === 0 && high === 0) {
        return sign + digits + result2;
      }
      pad = "";
      l22 = 6 - digits.length;
      for (i2 = 0;i2 < l22; i2++) {
        pad += "0";
      }
      result2 = pad + digits + result2;
    }
    {
      carry = high % BASE;
      t = 4294967296 * carry + low;
      digits = "" + t % BASE;
      return sign + digits + result2;
    }
  }
  module.exports = readInt8;
});
var require_binaryParsers = __commonJS2((exports, module) => {
  var parseInt64 = require_pg_int8();
  var parseBits = function(data2, bits, offset2, invert, callback) {
    offset2 = offset2 || 0;
    invert = invert || false;
    callback = callback || function(lastValue, newValue, bits2) {
      return lastValue * Math.pow(2, bits2) + newValue;
    };
    var offsetBytes = offset2 >> 3;
    var inv = function(value) {
      if (invert) {
        return ~value & 255;
      }
      return value;
    };
    var mask = 255;
    var firstBits = 8 - offset2 % 8;
    if (bits < firstBits) {
      mask = 255 << 8 - bits & 255;
      firstBits = bits;
    }
    if (offset2) {
      mask = mask >> offset2 % 8;
    }
    var result2 = 0;
    if (offset2 % 8 + bits >= 8) {
      result2 = callback(0, inv(data2[offsetBytes]) & mask, firstBits);
    }
    var bytes = bits + offset2 >> 3;
    for (var i2 = offsetBytes + 1;i2 < bytes; i2++) {
      result2 = callback(result2, inv(data2[i2]), 8);
    }
    var lastBits = (bits + offset2) % 8;
    if (lastBits > 0) {
      result2 = callback(result2, inv(data2[bytes]) >> 8 - lastBits, lastBits);
    }
    return result2;
  };
  var parseFloatFromBits = function(data2, precisionBits, exponentBits) {
    var bias = Math.pow(2, exponentBits - 1) - 1;
    var sign = parseBits(data2, 1);
    var exponent = parseBits(data2, exponentBits, 1);
    if (exponent === 0) {
      return 0;
    }
    var precisionBitsCounter = 1;
    var parsePrecisionBits = function(lastValue, newValue, bits) {
      if (lastValue === 0) {
        lastValue = 1;
      }
      for (var i2 = 1;i2 <= bits; i2++) {
        precisionBitsCounter /= 2;
        if ((newValue & 1 << bits - i2) > 0) {
          lastValue += precisionBitsCounter;
        }
      }
      return lastValue;
    };
    var mantissa = parseBits(data2, precisionBits, exponentBits + 1, false, parsePrecisionBits);
    if (exponent == Math.pow(2, exponentBits + 1) - 1) {
      if (mantissa === 0) {
        return sign === 0 ? Infinity : -Infinity;
      }
      return NaN;
    }
    return (sign === 0 ? 1 : -1) * Math.pow(2, exponent - bias) * mantissa;
  };
  var parseInt16 = function(value) {
    if (parseBits(value, 1) == 1) {
      return -1 * (parseBits(value, 15, 1, true) + 1);
    }
    return parseBits(value, 15, 1);
  };
  var parseInt32 = function(value) {
    if (parseBits(value, 1) == 1) {
      return -1 * (parseBits(value, 31, 1, true) + 1);
    }
    return parseBits(value, 31, 1);
  };
  var parseFloat32 = function(value) {
    return parseFloatFromBits(value, 23, 8);
  };
  var parseFloat64 = function(value) {
    return parseFloatFromBits(value, 52, 11);
  };
  var parseNumeric = function(value) {
    var sign = parseBits(value, 16, 32);
    if (sign == 49152) {
      return NaN;
    }
    var weight = Math.pow(1e4, parseBits(value, 16, 16));
    var result2 = 0;
    var digits = [];
    var ndigits = parseBits(value, 16);
    for (var i2 = 0;i2 < ndigits; i2++) {
      result2 += parseBits(value, 16, 64 + 16 * i2) * weight;
      weight /= 1e4;
    }
    var scale = Math.pow(10, parseBits(value, 16, 48));
    return (sign === 0 ? 1 : -1) * Math.round(result2 * scale) / scale;
  };
  var parseDate = function(isUTC, value) {
    var sign = parseBits(value, 1);
    var rawValue = parseBits(value, 63, 1);
    var result2 = new Date((sign === 0 ? 1 : -1) * rawValue / 1000 + 946684800000);
    if (!isUTC) {
      result2.setTime(result2.getTime() + result2.getTimezoneOffset() * 60000);
    }
    result2.usec = rawValue % 1000;
    result2.getMicroSeconds = function() {
      return this.usec;
    };
    result2.setMicroSeconds = function(value2) {
      this.usec = value2;
    };
    result2.getUTCMicroSeconds = function() {
      return this.usec;
    };
    return result2;
  };
  var parseArray2 = function(value) {
    var dim3 = parseBits(value, 32);
    var flags = parseBits(value, 32, 32);
    var elementType = parseBits(value, 32, 64);
    var offset2 = 96;
    var dims = [];
    for (var i2 = 0;i2 < dim3; i2++) {
      dims[i2] = parseBits(value, 32, offset2);
      offset2 += 32;
      offset2 += 32;
    }
    var parseElement = function(elementType2) {
      var length = parseBits(value, 32, offset2);
      offset2 += 32;
      if (length == 4294967295) {
        return null;
      }
      var result2;
      if (elementType2 == 23 || elementType2 == 20) {
        result2 = parseBits(value, length * 8, offset2);
        offset2 += length * 8;
        return result2;
      } else if (elementType2 == 25) {
        result2 = value.toString(this.encoding, offset2 >> 3, (offset2 += length << 3) >> 3);
        return result2;
      } else {
        console.log("ERROR: ElementType not implemented: " + elementType2);
      }
    };
    var parse8 = function(dimension, elementType2) {
      var array = [];
      var i22;
      if (dimension.length > 1) {
        var count = dimension.shift();
        for (i22 = 0;i22 < count; i22++) {
          array[i22] = parse8(dimension, elementType2);
        }
        dimension.unshift(count);
      } else {
        for (i22 = 0;i22 < dimension[0]; i22++) {
          array[i22] = parseElement(elementType2);
        }
      }
      return array;
    };
    return parse8(dims, elementType);
  };
  var parseText = function(value) {
    return value.toString("utf8");
  };
  var parseBool = function(value) {
    if (value === null)
      return null;
    return parseBits(value, 8) > 0;
  };
  var init3 = function(register) {
    register(20, parseInt64);
    register(21, parseInt16);
    register(23, parseInt32);
    register(26, parseInt32);
    register(1700, parseNumeric);
    register(700, parseFloat32);
    register(701, parseFloat64);
    register(16, parseBool);
    register(1114, parseDate.bind(null, false));
    register(1184, parseDate.bind(null, true));
    register(1000, parseArray2);
    register(1007, parseArray2);
    register(1016, parseArray2);
    register(1008, parseArray2);
    register(1009, parseArray2);
    register(25, parseText);
  };
  module.exports = {
    init: init3
  };
});
var require_builtins = __commonJS2((exports, module) => {
  module.exports = {
    BOOL: 16,
    BYTEA: 17,
    CHAR: 18,
    INT8: 20,
    INT2: 21,
    INT4: 23,
    REGPROC: 24,
    TEXT: 25,
    OID: 26,
    TID: 27,
    XID: 28,
    CID: 29,
    JSON: 114,
    XML: 142,
    PG_NODE_TREE: 194,
    SMGR: 210,
    PATH: 602,
    POLYGON: 604,
    CIDR: 650,
    FLOAT4: 700,
    FLOAT8: 701,
    ABSTIME: 702,
    RELTIME: 703,
    TINTERVAL: 704,
    CIRCLE: 718,
    MACADDR8: 774,
    MONEY: 790,
    MACADDR: 829,
    INET: 869,
    ACLITEM: 1033,
    BPCHAR: 1042,
    VARCHAR: 1043,
    DATE: 1082,
    TIME: 1083,
    TIMESTAMP: 1114,
    TIMESTAMPTZ: 1184,
    INTERVAL: 1186,
    TIMETZ: 1266,
    BIT: 1560,
    VARBIT: 1562,
    NUMERIC: 1700,
    REFCURSOR: 1790,
    REGPROCEDURE: 2202,
    REGOPER: 2203,
    REGOPERATOR: 2204,
    REGCLASS: 2205,
    REGTYPE: 2206,
    UUID: 2950,
    TXID_SNAPSHOT: 2970,
    PG_LSN: 3220,
    PG_NDISTINCT: 3361,
    PG_DEPENDENCIES: 3402,
    TSVECTOR: 3614,
    TSQUERY: 3615,
    GTSVECTOR: 3642,
    REGCONFIG: 3734,
    REGDICTIONARY: 3769,
    JSONB: 3802,
    REGNAMESPACE: 4089,
    REGROLE: 4096
  };
});
var require_pg_types = __commonJS2((exports) => {
  var textParsers = require_textParsers();
  var binaryParsers = require_binaryParsers();
  var arrayParser = require_arrayParser();
  var builtinTypes = require_builtins();
  exports.getTypeParser = getTypeParser;
  exports.setTypeParser = setTypeParser;
  exports.arrayParser = arrayParser;
  exports.builtins = builtinTypes;
  var typeParsers = {
    text: {},
    binary: {}
  };
  function noParse(val2) {
    return String(val2);
  }
  function getTypeParser(oid, format) {
    format = format || "text";
    if (!typeParsers[format]) {
      return noParse;
    }
    return typeParsers[format][oid] || noParse;
  }
  function setTypeParser(oid, format, parseFn) {
    if (typeof format == "function") {
      parseFn = format;
      format = "text";
    }
    typeParsers[format][oid] = parseFn;
  }
  textParsers.init(function(oid, converter) {
    typeParsers.text[oid] = converter;
  });
  binaryParsers.init(function(oid, converter) {
    typeParsers.binary[oid] = converter;
  });
});
var require_defaults2 = __commonJS2((exports, module) => {
  module.exports = {
    host: "localhost",
    user: process.platform === "win32" ? process.env.USERNAME : "chrisbreuer",
    database: undefined,
    password: null,
    connectionString: undefined,
    port: 5432,
    rows: 0,
    binary: false,
    max: 10,
    idleTimeoutMillis: 30000,
    client_encoding: "",
    ssl: false,
    application_name: undefined,
    fallback_application_name: undefined,
    options: undefined,
    parseInputDatesAsUTC: false,
    statement_timeout: false,
    lock_timeout: false,
    idle_in_transaction_session_timeout: false,
    query_timeout: false,
    connect_timeout: 0,
    keepalives: 1,
    keepalives_idle: 0
  };
  var pgTypes = require_pg_types();
  var parseBigInteger = pgTypes.getTypeParser(20, "text");
  var parseBigIntegerArray = pgTypes.getTypeParser(1016, "text");
  module.exports.__defineSetter__("parseInt8", function(val2) {
    pgTypes.setTypeParser(20, "text", val2 ? pgTypes.getTypeParser(23, "text") : parseBigInteger);
    pgTypes.setTypeParser(1016, "text", val2 ? pgTypes.getTypeParser(1007, "text") : parseBigIntegerArray);
  });
});
var require_utils5 = __commonJS2((exports, module) => {
  var defaults3 = require_defaults2();
  function escapeElement(elementRepresentation) {
    var escaped = elementRepresentation.replace(/\\/g, "\\\\").replace(/"/g, '\\"');
    return '"' + escaped + '"';
  }
  function arrayString(val2) {
    var result2 = "{";
    for (var i2 = 0;i2 < val2.length; i2++) {
      if (i2 > 0) {
        result2 = result2 + ",";
      }
      if (val2[i2] === null || typeof val2[i2] === "undefined") {
        result2 = result2 + "NULL";
      } else if (Array.isArray(val2[i2])) {
        result2 = result2 + arrayString(val2[i2]);
      } else if (ArrayBuffer.isView(val2[i2])) {
        var item = val2[i2];
        if (!(item instanceof Buffer)) {
          var buf = Buffer.from(item.buffer, item.byteOffset, item.byteLength);
          if (buf.length === item.byteLength) {
            item = buf;
          } else {
            item = buf.slice(item.byteOffset, item.byteOffset + item.byteLength);
          }
        }
        result2 += "\\\\x" + item.toString("hex");
      } else {
        result2 += escapeElement(prepareValue(val2[i2]));
      }
    }
    result2 = result2 + "}";
    return result2;
  }
  var prepareValue = function(val2, seen) {
    if (val2 == null) {
      return null;
    }
    if (val2 instanceof Buffer) {
      return val2;
    }
    if (ArrayBuffer.isView(val2)) {
      var buf = Buffer.from(val2.buffer, val2.byteOffset, val2.byteLength);
      if (buf.length === val2.byteLength) {
        return buf;
      }
      return buf.slice(val2.byteOffset, val2.byteOffset + val2.byteLength);
    }
    if (val2 instanceof Date) {
      if (defaults3.parseInputDatesAsUTC) {
        return dateToStringUTC(val2);
      } else {
        return dateToString(val2);
      }
    }
    if (Array.isArray(val2)) {
      return arrayString(val2);
    }
    if (typeof val2 === "object") {
      return prepareObject(val2, seen);
    }
    return val2.toString();
  };
  function prepareObject(val2, seen) {
    if (val2 && typeof val2.toPostgres === "function") {
      seen = seen || [];
      if (seen.indexOf(val2) !== -1) {
        throw new Error('circular reference detected while preparing "' + val2 + '" for query');
      }
      seen.push(val2);
      return prepareValue(val2.toPostgres(prepareValue), seen);
    }
    return JSON.stringify(val2);
  }
  function pad(number, digits) {
    number = "" + number;
    while (number.length < digits) {
      number = "0" + number;
    }
    return number;
  }
  function dateToString(date) {
    var offset2 = -date.getTimezoneOffset();
    var year = date.getFullYear();
    var isBCYear = year < 1;
    if (isBCYear)
      year = Math.abs(year) + 1;
    var ret = pad(year, 4) + "-" + pad(date.getMonth() + 1, 2) + "-" + pad(date.getDate(), 2) + "T" + pad(date.getHours(), 2) + ":" + pad(date.getMinutes(), 2) + ":" + pad(date.getSeconds(), 2) + "." + pad(date.getMilliseconds(), 3);
    if (offset2 < 0) {
      ret += "-";
      offset2 *= -1;
    } else {
      ret += "+";
    }
    ret += pad(Math.floor(offset2 / 60), 2) + ":" + pad(offset2 % 60, 2);
    if (isBCYear)
      ret += " BC";
    return ret;
  }
  function dateToStringUTC(date) {
    var year = date.getUTCFullYear();
    var isBCYear = year < 1;
    if (isBCYear)
      year = Math.abs(year) + 1;
    var ret = pad(year, 4) + "-" + pad(date.getUTCMonth() + 1, 2) + "-" + pad(date.getUTCDate(), 2) + "T" + pad(date.getUTCHours(), 2) + ":" + pad(date.getUTCMinutes(), 2) + ":" + pad(date.getUTCSeconds(), 2) + "." + pad(date.getUTCMilliseconds(), 3);
    ret += "+00:00";
    if (isBCYear)
      ret += " BC";
    return ret;
  }
  function normalizeQueryConfig(config5, values3, callback) {
    config5 = typeof config5 === "string" ? { text: config5 } : config5;
    if (values3) {
      if (typeof values3 === "function") {
        config5.callback = values3;
      } else {
        config5.values = values3;
      }
    }
    if (callback) {
      config5.callback = callback;
    }
    return config5;
  }
  var escapeIdentifier = function(str) {
    return '"' + str.replace(/"/g, '""') + '"';
  };
  var escapeLiteral = function(str) {
    var hasBackslash = false;
    var escaped = "'";
    for (var i2 = 0;i2 < str.length; i2++) {
      var c22 = str[i2];
      if (c22 === "'") {
        escaped += c22 + c22;
      } else if (c22 === "\\") {
        escaped += c22 + c22;
        hasBackslash = true;
      } else {
        escaped += c22;
      }
    }
    escaped += "'";
    if (hasBackslash === true) {
      escaped = " E" + escaped;
    }
    return escaped;
  };
  module.exports = {
    prepareValue: function prepareValueWrapper(value) {
      return prepareValue(value);
    },
    normalizeQueryConfig,
    escapeIdentifier,
    escapeLiteral
  };
});
var require_utils_legacy = __commonJS2((exports, module) => {
  var nodeCrypto = import.meta.require("crypto");
  function md5(string2) {
    return nodeCrypto.createHash("md5").update(string2, "utf-8").digest("hex");
  }
  function postgresMd5PasswordHash(user, password, salt) {
    var inner = md5(password + user);
    var outer = md5(Buffer.concat([Buffer.from(inner), salt]));
    return "md5" + outer;
  }
  function sha256(text22) {
    return nodeCrypto.createHash("sha256").update(text22).digest();
  }
  function hmacSha256(key, msg) {
    return nodeCrypto.createHmac("sha256", key).update(msg).digest();
  }
  async function deriveKey(password, salt, iterations) {
    return nodeCrypto.pbkdf2Sync(password, salt, iterations, 32, "sha256");
  }
  module.exports = {
    postgresMd5PasswordHash,
    randomBytes: nodeCrypto.randomBytes,
    deriveKey,
    sha256,
    hmacSha256,
    md5
  };
});
var require_utils_webcrypto = __commonJS2((exports, module) => {
  var nodeCrypto = import.meta.require("crypto");
  module.exports = {
    postgresMd5PasswordHash,
    randomBytes,
    deriveKey,
    sha256,
    hmacSha256,
    md5
  };
  var webCrypto = nodeCrypto.webcrypto || globalThis.crypto;
  var subtleCrypto = webCrypto.subtle;
  var textEncoder = new TextEncoder;
  function randomBytes(length) {
    return webCrypto.getRandomValues(Buffer.alloc(length));
  }
  async function md5(string2) {
    try {
      return nodeCrypto.createHash("md5").update(string2, "utf-8").digest("hex");
    } catch (e) {
      const data2 = typeof string2 === "string" ? textEncoder.encode(string2) : string2;
      const hash = await subtleCrypto.digest("MD5", data2);
      return Array.from(new Uint8Array(hash)).map((b22) => b22.toString(16).padStart(2, "0")).join("");
    }
  }
  async function postgresMd5PasswordHash(user, password, salt) {
    var inner = await md5(password + user);
    var outer = await md5(Buffer.concat([Buffer.from(inner), salt]));
    return "md5" + outer;
  }
  async function sha256(text22) {
    return await subtleCrypto.digest("SHA-256", text22);
  }
  async function hmacSha256(keyBuffer, msg) {
    const key = await subtleCrypto.importKey("raw", keyBuffer, { name: "HMAC", hash: "SHA-256" }, false, ["sign"]);
    return await subtleCrypto.sign("HMAC", key, textEncoder.encode(msg));
  }
  async function deriveKey(password, salt, iterations) {
    const key = await subtleCrypto.importKey("raw", textEncoder.encode(password), "PBKDF2", false, ["deriveBits"]);
    const params = { name: "PBKDF2", hash: "SHA-256", salt, iterations };
    return await subtleCrypto.deriveBits(params, key, 256, ["deriveBits"]);
  }
});
var require_utils6 = __commonJS2((exports, module) => {
  var useLegacyCrypto = parseInt(process.versions && process.versions.node && process.versions.node.split(".")[0]) < 15;
  if (useLegacyCrypto) {
    module.exports = require_utils_legacy();
  } else {
    module.exports = require_utils_webcrypto();
  }
});
var require_sasl = __commonJS2((exports, module) => {
  var crypto = require_utils6();
  function startSession(mechanisms) {
    if (mechanisms.indexOf("SCRAM-SHA-256") === -1) {
      throw new Error("SASL: Only mechanism SCRAM-SHA-256 is currently supported");
    }
    const clientNonce = crypto.randomBytes(18).toString("base64");
    return {
      mechanism: "SCRAM-SHA-256",
      clientNonce,
      response: "n,,n=*,r=" + clientNonce,
      message: "SASLInitialResponse"
    };
  }
  async function continueSession(session, password, serverData) {
    if (session.message !== "SASLInitialResponse") {
      throw new Error("SASL: Last message was not SASLInitialResponse");
    }
    if (typeof password !== "string") {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: client password must be a string");
    }
    if (password === "") {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: client password must be a non-empty string");
    }
    if (typeof serverData !== "string") {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: serverData must be a string");
    }
    const sv = parseServerFirstMessage(serverData);
    if (!sv.nonce.startsWith(session.clientNonce)) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: server nonce does not start with client nonce");
    } else if (sv.nonce.length === session.clientNonce.length) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: server nonce is too short");
    }
    var clientFirstMessageBare = "n=*,r=" + session.clientNonce;
    var serverFirstMessage = "r=" + sv.nonce + ",s=" + sv.salt + ",i=" + sv.iteration;
    var clientFinalMessageWithoutProof = "c=biws,r=" + sv.nonce;
    var authMessage = clientFirstMessageBare + "," + serverFirstMessage + "," + clientFinalMessageWithoutProof;
    var saltBytes = Buffer.from(sv.salt, "base64");
    var saltedPassword = await crypto.deriveKey(password, saltBytes, sv.iteration);
    var clientKey = await crypto.hmacSha256(saltedPassword, "Client Key");
    var storedKey = await crypto.sha256(clientKey);
    var clientSignature = await crypto.hmacSha256(storedKey, authMessage);
    var clientProof = xorBuffers(Buffer.from(clientKey), Buffer.from(clientSignature)).toString("base64");
    var serverKey = await crypto.hmacSha256(saltedPassword, "Server Key");
    var serverSignatureBytes = await crypto.hmacSha256(serverKey, authMessage);
    session.message = "SASLResponse";
    session.serverSignature = Buffer.from(serverSignatureBytes).toString("base64");
    session.response = clientFinalMessageWithoutProof + ",p=" + clientProof;
  }
  function finalizeSession(session, serverData) {
    if (session.message !== "SASLResponse") {
      throw new Error("SASL: Last message was not SASLResponse");
    }
    if (typeof serverData !== "string") {
      throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: serverData must be a string");
    }
    const { serverSignature } = parseServerFinalMessage(serverData);
    if (serverSignature !== session.serverSignature) {
      throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature does not match");
    }
  }
  function isPrintableChars(text22) {
    if (typeof text22 !== "string") {
      throw new TypeError("SASL: text must be a string");
    }
    return text22.split("").map((_22, i2) => text22.charCodeAt(i2)).every((c22) => c22 >= 33 && c22 <= 43 || c22 >= 45 && c22 <= 126);
  }
  function isBase64(text22) {
    return /^(?:[a-zA-Z0-9+/]{4})*(?:[a-zA-Z0-9+/]{2}==|[a-zA-Z0-9+/]{3}=)?$/.test(text22);
  }
  function parseAttributePairs(text22) {
    if (typeof text22 !== "string") {
      throw new TypeError("SASL: attribute pairs text must be a string");
    }
    return new Map(text22.split(",").map((attrValue) => {
      if (!/^.=/.test(attrValue)) {
        throw new Error("SASL: Invalid attribute pair entry");
      }
      const name = attrValue[0];
      const value = attrValue.substring(2);
      return [name, value];
    }));
  }
  function parseServerFirstMessage(data2) {
    const attrPairs = parseAttributePairs(data2);
    const nonce = attrPairs.get("r");
    if (!nonce) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: nonce missing");
    } else if (!isPrintableChars(nonce)) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: nonce must only contain printable characters");
    }
    const salt = attrPairs.get("s");
    if (!salt) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: salt missing");
    } else if (!isBase64(salt)) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: salt must be base64");
    }
    const iterationText = attrPairs.get("i");
    if (!iterationText) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: iteration missing");
    } else if (!/^[1-9][0-9]*$/.test(iterationText)) {
      throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: invalid iteration count");
    }
    const iteration = parseInt(iterationText, 10);
    return {
      nonce,
      salt,
      iteration
    };
  }
  function parseServerFinalMessage(serverData) {
    const attrPairs = parseAttributePairs(serverData);
    const serverSignature = attrPairs.get("v");
    if (!serverSignature) {
      throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature is missing");
    } else if (!isBase64(serverSignature)) {
      throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature must be base64");
    }
    return {
      serverSignature
    };
  }
  function xorBuffers(a, b22) {
    if (!Buffer.isBuffer(a)) {
      throw new TypeError("first argument must be a Buffer");
    }
    if (!Buffer.isBuffer(b22)) {
      throw new TypeError("second argument must be a Buffer");
    }
    if (a.length !== b22.length) {
      throw new Error("Buffer lengths must match");
    }
    if (a.length === 0) {
      throw new Error("Buffers cannot be empty");
    }
    return Buffer.from(a.map((_22, i2) => a[i2] ^ b22[i2]));
  }
  module.exports = {
    startSession,
    continueSession,
    finalizeSession
  };
});
var require_type_overrides = __commonJS2((exports, module) => {
  var types5 = require_pg_types();
  function TypeOverrides(userTypes) {
    this._types = userTypes || types5;
    this.text = {};
    this.binary = {};
  }
  TypeOverrides.prototype.getOverrides = function(format) {
    switch (format) {
      case "text":
        return this.text;
      case "binary":
        return this.binary;
      default:
        return {};
    }
  };
  TypeOverrides.prototype.setTypeParser = function(oid, format, parseFn) {
    if (typeof format === "function") {
      parseFn = format;
      format = "text";
    }
    this.getOverrides(format)[oid] = parseFn;
  };
  TypeOverrides.prototype.getTypeParser = function(oid, format) {
    format = format || "text";
    return this.getOverrides(format)[oid] || this._types.getTypeParser(oid, format);
  };
  module.exports = TypeOverrides;
});
var require_pg_connection_string = __commonJS2((exports, module) => {
  function parse8(str) {
    if (str.charAt(0) === "/") {
      const config6 = str.split(" ");
      return { host: config6[0], database: config6[1] };
    }
    const config5 = {};
    let result2;
    let dummyHost = false;
    if (/ |%[^a-f0-9]|%[a-f0-9][^a-f0-9]/i.test(str)) {
      str = encodeURI(str).replace(/\%25(\d\d)/g, "%$1");
    }
    try {
      result2 = new URL(str, "postgres://base");
    } catch (e) {
      result2 = new URL(str.replace("@/", "@___DUMMY___/"), "postgres://base");
      dummyHost = true;
    }
    for (const entry of result2.searchParams.entries()) {
      config5[entry[0]] = entry[1];
    }
    config5.user = config5.user || decodeURIComponent(result2.username);
    config5.password = config5.password || decodeURIComponent(result2.password);
    if (result2.protocol == "socket:") {
      config5.host = decodeURI(result2.pathname);
      config5.database = result2.searchParams.get("db");
      config5.client_encoding = result2.searchParams.get("encoding");
      return config5;
    }
    const hostname = dummyHost ? "" : result2.hostname;
    if (!config5.host) {
      config5.host = decodeURIComponent(hostname);
    } else if (hostname && /^%2f/i.test(hostname)) {
      result2.pathname = hostname + result2.pathname;
    }
    if (!config5.port) {
      config5.port = result2.port;
    }
    const pathname = result2.pathname.slice(1) || null;
    config5.database = pathname ? decodeURI(pathname) : null;
    if (config5.ssl === "true" || config5.ssl === "1") {
      config5.ssl = true;
    }
    if (config5.ssl === "0") {
      config5.ssl = false;
    }
    if (config5.sslcert || config5.sslkey || config5.sslrootcert || config5.sslmode) {
      config5.ssl = {};
    }
    const fs32 = config5.sslcert || config5.sslkey || config5.sslrootcert ? import.meta.require("fs") : null;
    if (config5.sslcert) {
      config5.ssl.cert = fs32.readFileSync(config5.sslcert).toString();
    }
    if (config5.sslkey) {
      config5.ssl.key = fs32.readFileSync(config5.sslkey).toString();
    }
    if (config5.sslrootcert) {
      config5.ssl.ca = fs32.readFileSync(config5.sslrootcert).toString();
    }
    switch (config5.sslmode) {
      case "disable": {
        config5.ssl = false;
        break;
      }
      case "prefer":
      case "require":
      case "verify-ca":
      case "verify-full": {
        break;
      }
      case "no-verify": {
        config5.ssl.rejectUnauthorized = false;
        break;
      }
    }
    return config5;
  }
  module.exports = parse8;
  parse8.parse = parse8;
});
var require_connection_parameters = __commonJS2((exports, module) => {
  var dns3 = import.meta.require("dns");
  var defaults3 = require_defaults2();
  var parse8 = require_pg_connection_string().parse;
  var val2 = function(key, config5, envVar) {
    if (envVar === undefined) {
      envVar = process.env["PG" + key.toUpperCase()];
    } else if (envVar === false) {
    } else {
      envVar = process.env[envVar];
    }
    return config5[key] || envVar || defaults3[key];
  };
  var readSSLConfigFromEnvironment = function() {
    switch (process.env.PGSSLMODE) {
      case "disable":
        return false;
      case "prefer":
      case "require":
      case "verify-ca":
      case "verify-full":
        return true;
      case "no-verify":
        return { rejectUnauthorized: false };
    }
    return defaults3.ssl;
  };
  var quoteParamValue = function(value) {
    return "'" + ("" + value).replace(/\\/g, "\\\\").replace(/'/g, "\\'") + "'";
  };
  var add = function(params, config5, paramName) {
    var value = config5[paramName];
    if (value !== undefined && value !== null) {
      params.push(paramName + "=" + quoteParamValue(value));
    }
  };

  class ConnectionParameters {
    constructor(config5) {
      config5 = typeof config5 === "string" ? parse8(config5) : config5 || {};
      if (config5.connectionString) {
        config5 = Object.assign({}, config5, parse8(config5.connectionString));
      }
      this.user = val2("user", config5);
      this.database = val2("database", config5);
      if (this.database === undefined) {
        this.database = this.user;
      }
      this.port = parseInt(val2("port", config5), 10);
      this.host = val2("host", config5);
      Object.defineProperty(this, "password", {
        configurable: true,
        enumerable: false,
        writable: true,
        value: val2("password", config5)
      });
      this.binary = val2("binary", config5);
      this.options = val2("options", config5);
      this.ssl = typeof config5.ssl === "undefined" ? readSSLConfigFromEnvironment() : config5.ssl;
      if (typeof this.ssl === "string") {
        if (this.ssl === "true") {
          this.ssl = true;
        }
      }
      if (this.ssl === "no-verify") {
        this.ssl = { rejectUnauthorized: false };
      }
      if (this.ssl && this.ssl.key) {
        Object.defineProperty(this.ssl, "key", {
          enumerable: false
        });
      }
      this.client_encoding = val2("client_encoding", config5);
      this.replication = val2("replication", config5);
      this.isDomainSocket = !(this.host || "").indexOf("/");
      this.application_name = val2("application_name", config5, "PGAPPNAME");
      this.fallback_application_name = val2("fallback_application_name", config5, false);
      this.statement_timeout = val2("statement_timeout", config5, false);
      this.lock_timeout = val2("lock_timeout", config5, false);
      this.idle_in_transaction_session_timeout = val2("idle_in_transaction_session_timeout", config5, false);
      this.query_timeout = val2("query_timeout", config5, false);
      if (config5.connectionTimeoutMillis === undefined) {
        this.connect_timeout = process.env.PGCONNECT_TIMEOUT || 0;
      } else {
        this.connect_timeout = Math.floor(config5.connectionTimeoutMillis / 1000);
      }
      if (config5.keepAlive === false) {
        this.keepalives = 0;
      } else if (config5.keepAlive === true) {
        this.keepalives = 1;
      }
      if (typeof config5.keepAliveInitialDelayMillis === "number") {
        this.keepalives_idle = Math.floor(config5.keepAliveInitialDelayMillis / 1000);
      }
    }
    getLibpqConnectionString(cb) {
      var params = [];
      add(params, this, "user");
      add(params, this, "password");
      add(params, this, "port");
      add(params, this, "application_name");
      add(params, this, "fallback_application_name");
      add(params, this, "connect_timeout");
      add(params, this, "options");
      var ssl = typeof this.ssl === "object" ? this.ssl : this.ssl ? { sslmode: this.ssl } : {};
      add(params, ssl, "sslmode");
      add(params, ssl, "sslca");
      add(params, ssl, "sslkey");
      add(params, ssl, "sslcert");
      add(params, ssl, "sslrootcert");
      if (this.database) {
        params.push("dbname=" + quoteParamValue(this.database));
      }
      if (this.replication) {
        params.push("replication=" + quoteParamValue(this.replication));
      }
      if (this.host) {
        params.push("host=" + quoteParamValue(this.host));
      }
      if (this.isDomainSocket) {
        return cb(null, params.join(" "));
      }
      if (this.client_encoding) {
        params.push("client_encoding=" + quoteParamValue(this.client_encoding));
      }
      dns3.lookup(this.host, function(err22, address) {
        if (err22)
          return cb(err22, null);
        params.push("hostaddr=" + quoteParamValue(address));
        return cb(null, params.join(" "));
      });
    }
  }
  module.exports = ConnectionParameters;
});
var require_result = __commonJS2((exports, module) => {
  var types5 = require_pg_types();
  var matchRegexp = /^([A-Za-z]+)(?: (\d+))?(?: (\d+))?/;

  class Result22 {
    constructor(rowMode, types6) {
      this.command = null;
      this.rowCount = null;
      this.oid = null;
      this.rows = [];
      this.fields = [];
      this._parsers = undefined;
      this._types = types6;
      this.RowCtor = null;
      this.rowAsArray = rowMode === "array";
      if (this.rowAsArray) {
        this.parseRow = this._parseRowAsArray;
      }
      this._prebuiltEmptyResultObject = null;
    }
    addCommandComplete(msg) {
      var match;
      if (msg.text) {
        match = matchRegexp.exec(msg.text);
      } else {
        match = matchRegexp.exec(msg.command);
      }
      if (match) {
        this.command = match[1];
        if (match[3]) {
          this.oid = parseInt(match[2], 10);
          this.rowCount = parseInt(match[3], 10);
        } else if (match[2]) {
          this.rowCount = parseInt(match[2], 10);
        }
      }
    }
    _parseRowAsArray(rowData) {
      var row = new Array(rowData.length);
      for (var i2 = 0, len = rowData.length;i2 < len; i2++) {
        var rawValue = rowData[i2];
        if (rawValue !== null) {
          row[i2] = this._parsers[i2](rawValue);
        } else {
          row[i2] = null;
        }
      }
      return row;
    }
    parseRow(rowData) {
      var row = { ...this._prebuiltEmptyResultObject };
      for (var i2 = 0, len = rowData.length;i2 < len; i2++) {
        var rawValue = rowData[i2];
        var field = this.fields[i2].name;
        if (rawValue !== null) {
          row[field] = this._parsers[i2](rawValue);
        } else {
          row[field] = null;
        }
      }
      return row;
    }
    addRow(row) {
      this.rows.push(row);
    }
    addFields(fieldDescriptions) {
      this.fields = fieldDescriptions;
      if (this.fields.length) {
        this._parsers = new Array(fieldDescriptions.length);
      }
      var row = {};
      for (var i2 = 0;i2 < fieldDescriptions.length; i2++) {
        var desc = fieldDescriptions[i2];
        row[desc.name] = null;
        if (this._types) {
          this._parsers[i2] = this._types.getTypeParser(desc.dataTypeID, desc.format || "text");
        } else {
          this._parsers[i2] = types5.getTypeParser(desc.dataTypeID, desc.format || "text");
        }
      }
      this._prebuiltEmptyResultObject = { ...row };
    }
  }
  module.exports = Result22;
});
var require_query3 = __commonJS2((exports, module) => {
  var { EventEmitter: EventEmitter23 } = import.meta.require("events");
  var Result22 = require_result();
  var utils9 = require_utils5();

  class Query extends EventEmitter23 {
    constructor(config5, values3, callback) {
      super();
      config5 = utils9.normalizeQueryConfig(config5, values3, callback);
      this.text = config5.text;
      this.values = config5.values;
      this.rows = config5.rows;
      this.types = config5.types;
      this.name = config5.name;
      this.queryMode = config5.queryMode;
      this.binary = config5.binary;
      this.portal = config5.portal || "";
      this.callback = config5.callback;
      this._rowMode = config5.rowMode;
      if (process.domain && config5.callback) {
        this.callback = process.domain.bind(config5.callback);
      }
      this._result = new Result22(this._rowMode, this.types);
      this._results = this._result;
      this._canceledDueToError = false;
    }
    requiresPreparation() {
      if (this.queryMode === "extended") {
        return true;
      }
      if (this.name) {
        return true;
      }
      if (this.rows) {
        return true;
      }
      if (!this.text) {
        return false;
      }
      if (!this.values) {
        return false;
      }
      return this.values.length > 0;
    }
    _checkForMultirow() {
      if (this._result.command) {
        if (!Array.isArray(this._results)) {
          this._results = [this._result];
        }
        this._result = new Result22(this._rowMode, this._result._types);
        this._results.push(this._result);
      }
    }
    handleRowDescription(msg) {
      this._checkForMultirow();
      this._result.addFields(msg.fields);
      this._accumulateRows = this.callback || !this.listeners("row").length;
    }
    handleDataRow(msg) {
      let row;
      if (this._canceledDueToError) {
        return;
      }
      try {
        row = this._result.parseRow(msg.fields);
      } catch (err22) {
        this._canceledDueToError = err22;
        return;
      }
      this.emit("row", row, this._result);
      if (this._accumulateRows) {
        this._result.addRow(row);
      }
    }
    handleCommandComplete(msg, connection) {
      this._checkForMultirow();
      this._result.addCommandComplete(msg);
      if (this.rows) {
        connection.sync();
      }
    }
    handleEmptyQuery(connection) {
      if (this.rows) {
        connection.sync();
      }
    }
    handleError(err22, connection) {
      if (this._canceledDueToError) {
        err22 = this._canceledDueToError;
        this._canceledDueToError = false;
      }
      if (this.callback) {
        return this.callback(err22);
      }
      this.emit("error", err22);
    }
    handleReadyForQuery(con) {
      if (this._canceledDueToError) {
        return this.handleError(this._canceledDueToError, con);
      }
      if (this.callback) {
        try {
          this.callback(null, this._results);
        } catch (err22) {
          process.nextTick(() => {
            throw err22;
          });
        }
      }
      this.emit("end", this._results);
    }
    submit(connection) {
      if (typeof this.text !== "string" && typeof this.name !== "string") {
        return new Error("A query must have either text or a name. Supplying neither is unsupported.");
      }
      const previous = connection.parsedStatements[this.name];
      if (this.text && previous && this.text !== previous) {
        return new Error(`Prepared statements must be unique - '${this.name}' was used for a different statement`);
      }
      if (this.values && !Array.isArray(this.values)) {
        return new Error("Query values must be an array");
      }
      if (this.requiresPreparation()) {
        this.prepare(connection);
      } else {
        connection.query(this.text);
      }
      return null;
    }
    hasBeenParsed(connection) {
      return this.name && connection.parsedStatements[this.name];
    }
    handlePortalSuspended(connection) {
      this._getRows(connection, this.rows);
    }
    _getRows(connection, rows) {
      connection.execute({
        portal: this.portal,
        rows
      });
      if (!rows) {
        connection.sync();
      } else {
        connection.flush();
      }
    }
    prepare(connection) {
      if (!this.hasBeenParsed(connection)) {
        connection.parse({
          text: this.text,
          name: this.name,
          types: this.types
        });
      }
      try {
        connection.bind({
          portal: this.portal,
          statement: this.name,
          values: this.values,
          binary: this.binary,
          valueMapper: utils9.prepareValue
        });
      } catch (err22) {
        this.handleError(err22, connection);
        return;
      }
      connection.describe({
        type: "P",
        name: this.portal || ""
      });
      this._getRows(connection, this.rows);
    }
    handleCopyInResponse(connection) {
      connection.sendCopyFail("No source stream defined");
    }
    handleCopyData(msg, connection) {
    }
  }
  module.exports = Query;
});
var require_messages = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.NoticeMessage = exports.DataRowMessage = exports.CommandCompleteMessage = exports.ReadyForQueryMessage = exports.NotificationResponseMessage = exports.BackendKeyDataMessage = exports.AuthenticationMD5Password = exports.ParameterStatusMessage = exports.ParameterDescriptionMessage = exports.RowDescriptionMessage = exports.Field = exports.CopyResponse = exports.CopyDataMessage = exports.DatabaseError = exports.copyDone = exports.emptyQuery = exports.replicationStart = exports.portalSuspended = exports.noData = exports.closeComplete = exports.bindComplete = exports.parseComplete = undefined;
  exports.parseComplete = {
    name: "parseComplete",
    length: 5
  };
  exports.bindComplete = {
    name: "bindComplete",
    length: 5
  };
  exports.closeComplete = {
    name: "closeComplete",
    length: 5
  };
  exports.noData = {
    name: "noData",
    length: 5
  };
  exports.portalSuspended = {
    name: "portalSuspended",
    length: 5
  };
  exports.replicationStart = {
    name: "replicationStart",
    length: 4
  };
  exports.emptyQuery = {
    name: "emptyQuery",
    length: 4
  };
  exports.copyDone = {
    name: "copyDone",
    length: 4
  };

  class DatabaseError extends Error {
    constructor(message, length, name) {
      super(message);
      this.length = length;
      this.name = name;
    }
  }
  exports.DatabaseError = DatabaseError;

  class CopyDataMessage {
    constructor(length, chunk) {
      this.length = length;
      this.chunk = chunk;
      this.name = "copyData";
    }
  }
  exports.CopyDataMessage = CopyDataMessage;

  class CopyResponse {
    constructor(length, name, binary2, columnCount) {
      this.length = length;
      this.name = name;
      this.binary = binary2;
      this.columnTypes = new Array(columnCount);
    }
  }
  exports.CopyResponse = CopyResponse;

  class Field {
    constructor(name, tableID, columnID, dataTypeID, dataTypeSize, dataTypeModifier, format) {
      this.name = name;
      this.tableID = tableID;
      this.columnID = columnID;
      this.dataTypeID = dataTypeID;
      this.dataTypeSize = dataTypeSize;
      this.dataTypeModifier = dataTypeModifier;
      this.format = format;
    }
  }
  exports.Field = Field;

  class RowDescriptionMessage {
    constructor(length, fieldCount) {
      this.length = length;
      this.fieldCount = fieldCount;
      this.name = "rowDescription";
      this.fields = new Array(this.fieldCount);
    }
  }
  exports.RowDescriptionMessage = RowDescriptionMessage;

  class ParameterDescriptionMessage {
    constructor(length, parameterCount) {
      this.length = length;
      this.parameterCount = parameterCount;
      this.name = "parameterDescription";
      this.dataTypeIDs = new Array(this.parameterCount);
    }
  }
  exports.ParameterDescriptionMessage = ParameterDescriptionMessage;

  class ParameterStatusMessage {
    constructor(length, parameterName, parameterValue) {
      this.length = length;
      this.parameterName = parameterName;
      this.parameterValue = parameterValue;
      this.name = "parameterStatus";
    }
  }
  exports.ParameterStatusMessage = ParameterStatusMessage;

  class AuthenticationMD5Password {
    constructor(length, salt) {
      this.length = length;
      this.salt = salt;
      this.name = "authenticationMD5Password";
    }
  }
  exports.AuthenticationMD5Password = AuthenticationMD5Password;

  class BackendKeyDataMessage {
    constructor(length, processID, secretKey) {
      this.length = length;
      this.processID = processID;
      this.secretKey = secretKey;
      this.name = "backendKeyData";
    }
  }
  exports.BackendKeyDataMessage = BackendKeyDataMessage;

  class NotificationResponseMessage {
    constructor(length, processId, channel, payload) {
      this.length = length;
      this.processId = processId;
      this.channel = channel;
      this.payload = payload;
      this.name = "notification";
    }
  }
  exports.NotificationResponseMessage = NotificationResponseMessage;

  class ReadyForQueryMessage {
    constructor(length, status) {
      this.length = length;
      this.status = status;
      this.name = "readyForQuery";
    }
  }
  exports.ReadyForQueryMessage = ReadyForQueryMessage;

  class CommandCompleteMessage {
    constructor(length, text22) {
      this.length = length;
      this.text = text22;
      this.name = "commandComplete";
    }
  }
  exports.CommandCompleteMessage = CommandCompleteMessage;

  class DataRowMessage {
    constructor(length, fields22) {
      this.length = length;
      this.fields = fields22;
      this.name = "dataRow";
      this.fieldCount = fields22.length;
    }
  }
  exports.DataRowMessage = DataRowMessage;

  class NoticeMessage {
    constructor(length, message) {
      this.length = length;
      this.message = message;
      this.name = "notice";
    }
  }
  exports.NoticeMessage = NoticeMessage;
});
var require_buffer_writer = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.Writer = undefined;

  class Writer {
    constructor(size = 256) {
      this.size = size;
      this.offset = 5;
      this.headerPosition = 0;
      this.buffer = Buffer.allocUnsafe(size);
    }
    ensure(size) {
      var remaining = this.buffer.length - this.offset;
      if (remaining < size) {
        var oldBuffer = this.buffer;
        var newSize = oldBuffer.length + (oldBuffer.length >> 1) + size;
        this.buffer = Buffer.allocUnsafe(newSize);
        oldBuffer.copy(this.buffer);
      }
    }
    addInt32(num) {
      this.ensure(4);
      this.buffer[this.offset++] = num >>> 24 & 255;
      this.buffer[this.offset++] = num >>> 16 & 255;
      this.buffer[this.offset++] = num >>> 8 & 255;
      this.buffer[this.offset++] = num >>> 0 & 255;
      return this;
    }
    addInt16(num) {
      this.ensure(2);
      this.buffer[this.offset++] = num >>> 8 & 255;
      this.buffer[this.offset++] = num >>> 0 & 255;
      return this;
    }
    addCString(string2) {
      if (!string2) {
        this.ensure(1);
      } else {
        var len = Buffer.byteLength(string2);
        this.ensure(len + 1);
        this.buffer.write(string2, this.offset, "utf-8");
        this.offset += len;
      }
      this.buffer[this.offset++] = 0;
      return this;
    }
    addString(string2 = "") {
      var len = Buffer.byteLength(string2);
      this.ensure(len);
      this.buffer.write(string2, this.offset);
      this.offset += len;
      return this;
    }
    add(otherBuffer) {
      this.ensure(otherBuffer.length);
      otherBuffer.copy(this.buffer, this.offset);
      this.offset += otherBuffer.length;
      return this;
    }
    join(code) {
      if (code) {
        this.buffer[this.headerPosition] = code;
        const length = this.offset - (this.headerPosition + 1);
        this.buffer.writeInt32BE(length, this.headerPosition + 1);
      }
      return this.buffer.slice(code ? 0 : 5, this.offset);
    }
    flush(code) {
      var result2 = this.join(code);
      this.offset = 5;
      this.headerPosition = 0;
      this.buffer = Buffer.allocUnsafe(this.size);
      return result2;
    }
  }
  exports.Writer = Writer;
});
var require_serializer = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.serialize = undefined;
  var buffer_writer_1 = require_buffer_writer();
  var writer = new buffer_writer_1.Writer;
  var startup = (opts) => {
    writer.addInt16(3).addInt16(0);
    for (const key of Object.keys(opts)) {
      writer.addCString(key).addCString(opts[key]);
    }
    writer.addCString("client_encoding").addCString("UTF8");
    var bodyBuffer = writer.addCString("").flush();
    var length = bodyBuffer.length + 4;
    return new buffer_writer_1.Writer().addInt32(length).add(bodyBuffer).flush();
  };
  var requestSsl = () => {
    const response = Buffer.allocUnsafe(8);
    response.writeInt32BE(8, 0);
    response.writeInt32BE(80877103, 4);
    return response;
  };
  var password = (password2) => {
    return writer.addCString(password2).flush(112);
  };
  var sendSASLInitialResponseMessage = function(mechanism, initialResponse) {
    writer.addCString(mechanism).addInt32(Buffer.byteLength(initialResponse)).addString(initialResponse);
    return writer.flush(112);
  };
  var sendSCRAMClientFinalMessage = function(additionalData) {
    return writer.addString(additionalData).flush(112);
  };
  var query = (text22) => {
    return writer.addCString(text22).flush(81);
  };
  var emptyArray = [];
  var parse8 = (query2) => {
    const name = query2.name || "";
    if (name.length > 63) {
      console.error("Warning! Postgres only supports 63 characters for query names.");
      console.error("You supplied %s (%s)", name, name.length);
      console.error("This can cause conflicts and silent errors executing queries");
    }
    const types5 = query2.types || emptyArray;
    var len = types5.length;
    var buffer = writer.addCString(name).addCString(query2.text).addInt16(len);
    for (var i2 = 0;i2 < len; i2++) {
      buffer.addInt32(types5[i2]);
    }
    return writer.flush(80);
  };
  var paramWriter = new buffer_writer_1.Writer;
  var writeValues = function(values3, valueMapper) {
    for (let i2 = 0;i2 < values3.length; i2++) {
      const mappedVal = valueMapper ? valueMapper(values3[i2], i2) : values3[i2];
      if (mappedVal == null) {
        writer.addInt16(0);
        paramWriter.addInt32(-1);
      } else if (mappedVal instanceof Buffer) {
        writer.addInt16(1);
        paramWriter.addInt32(mappedVal.length);
        paramWriter.add(mappedVal);
      } else {
        writer.addInt16(0);
        paramWriter.addInt32(Buffer.byteLength(mappedVal));
        paramWriter.addString(mappedVal);
      }
    }
  };
  var bind = (config5 = {}) => {
    const portal = config5.portal || "";
    const statement = config5.statement || "";
    const binary2 = config5.binary || false;
    const values3 = config5.values || emptyArray;
    const len = values3.length;
    writer.addCString(portal).addCString(statement);
    writer.addInt16(len);
    writeValues(values3, config5.valueMapper);
    writer.addInt16(len);
    writer.add(paramWriter.flush());
    writer.addInt16(binary2 ? 1 : 0);
    return writer.flush(66);
  };
  var emptyExecute = Buffer.from([69, 0, 0, 0, 9, 0, 0, 0, 0, 0]);
  var execute = (config5) => {
    if (!config5 || !config5.portal && !config5.rows) {
      return emptyExecute;
    }
    const portal = config5.portal || "";
    const rows = config5.rows || 0;
    const portalLength = Buffer.byteLength(portal);
    const len = 4 + portalLength + 1 + 4;
    const buff = Buffer.allocUnsafe(1 + len);
    buff[0] = 69;
    buff.writeInt32BE(len, 1);
    buff.write(portal, 5, "utf-8");
    buff[portalLength + 5] = 0;
    buff.writeUInt32BE(rows, buff.length - 4);
    return buff;
  };
  var cancel = (processID, secretKey) => {
    const buffer = Buffer.allocUnsafe(16);
    buffer.writeInt32BE(16, 0);
    buffer.writeInt16BE(1234, 4);
    buffer.writeInt16BE(5678, 6);
    buffer.writeInt32BE(processID, 8);
    buffer.writeInt32BE(secretKey, 12);
    return buffer;
  };
  var cstringMessage = (code, string2) => {
    const stringLen = Buffer.byteLength(string2);
    const len = 4 + stringLen + 1;
    const buffer = Buffer.allocUnsafe(1 + len);
    buffer[0] = code;
    buffer.writeInt32BE(len, 1);
    buffer.write(string2, 5, "utf-8");
    buffer[len] = 0;
    return buffer;
  };
  var emptyDescribePortal = writer.addCString("P").flush(68);
  var emptyDescribeStatement = writer.addCString("S").flush(68);
  var describe = (msg) => {
    return msg.name ? cstringMessage(68, `${msg.type}${msg.name || ""}`) : msg.type === "P" ? emptyDescribePortal : emptyDescribeStatement;
  };
  var close = (msg) => {
    const text22 = `${msg.type}${msg.name || ""}`;
    return cstringMessage(67, text22);
  };
  var copyData = (chunk) => {
    return writer.add(chunk).flush(100);
  };
  var copyFail = (message) => {
    return cstringMessage(102, message);
  };
  var codeOnlyBuffer = (code) => Buffer.from([code, 0, 0, 0, 4]);
  var flushBuffer = codeOnlyBuffer(72);
  var syncBuffer = codeOnlyBuffer(83);
  var endBuffer = codeOnlyBuffer(88);
  var copyDoneBuffer = codeOnlyBuffer(99);
  var serialize = {
    startup,
    password,
    requestSsl,
    sendSASLInitialResponseMessage,
    sendSCRAMClientFinalMessage,
    query,
    parse: parse8,
    bind,
    execute,
    describe,
    close,
    flush: () => flushBuffer,
    sync: () => syncBuffer,
    end: () => endBuffer,
    copyData,
    copyDone: () => copyDoneBuffer,
    copyFail,
    cancel
  };
  exports.serialize = serialize;
});
var require_buffer_reader = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.BufferReader = undefined;
  var emptyBuffer = Buffer.allocUnsafe(0);

  class BufferReader {
    constructor(offset2 = 0) {
      this.offset = offset2;
      this.buffer = emptyBuffer;
      this.encoding = "utf-8";
    }
    setBuffer(offset2, buffer) {
      this.offset = offset2;
      this.buffer = buffer;
    }
    int16() {
      const result2 = this.buffer.readInt16BE(this.offset);
      this.offset += 2;
      return result2;
    }
    byte() {
      const result2 = this.buffer[this.offset];
      this.offset++;
      return result2;
    }
    int32() {
      const result2 = this.buffer.readInt32BE(this.offset);
      this.offset += 4;
      return result2;
    }
    string(length) {
      const result2 = this.buffer.toString(this.encoding, this.offset, this.offset + length);
      this.offset += length;
      return result2;
    }
    cstring() {
      const start = this.offset;
      let end = start;
      while (this.buffer[end++] !== 0) {
      }
      this.offset = end;
      return this.buffer.toString(this.encoding, start, end - 1);
    }
    bytes(length) {
      const result2 = this.buffer.slice(this.offset, this.offset + length);
      this.offset += length;
      return result2;
    }
  }
  exports.BufferReader = BufferReader;
});
var require_parser = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.Parser = undefined;
  var messages_1 = require_messages();
  var buffer_reader_1 = require_buffer_reader();
  var CODE_LENGTH = 1;
  var LEN_LENGTH = 4;
  var HEADER_LENGTH = CODE_LENGTH + LEN_LENGTH;
  var emptyBuffer = Buffer.allocUnsafe(0);

  class Parser3 {
    constructor(opts) {
      this.buffer = emptyBuffer;
      this.bufferLength = 0;
      this.bufferOffset = 0;
      this.reader = new buffer_reader_1.BufferReader;
      if ((opts === null || opts === undefined ? undefined : opts.mode) === "binary") {
        throw new Error("Binary mode not supported yet");
      }
      this.mode = (opts === null || opts === undefined ? undefined : opts.mode) || "text";
    }
    parse(buffer, callback) {
      this.mergeBuffer(buffer);
      const bufferFullLength = this.bufferOffset + this.bufferLength;
      let offset2 = this.bufferOffset;
      while (offset2 + HEADER_LENGTH <= bufferFullLength) {
        const code = this.buffer[offset2];
        const length = this.buffer.readUInt32BE(offset2 + CODE_LENGTH);
        const fullMessageLength = CODE_LENGTH + length;
        if (fullMessageLength + offset2 <= bufferFullLength) {
          const message = this.handlePacket(offset2 + HEADER_LENGTH, code, length, this.buffer);
          callback(message);
          offset2 += fullMessageLength;
        } else {
          break;
        }
      }
      if (offset2 === bufferFullLength) {
        this.buffer = emptyBuffer;
        this.bufferLength = 0;
        this.bufferOffset = 0;
      } else {
        this.bufferLength = bufferFullLength - offset2;
        this.bufferOffset = offset2;
      }
    }
    mergeBuffer(buffer) {
      if (this.bufferLength > 0) {
        const newLength = this.bufferLength + buffer.byteLength;
        const newFullLength = newLength + this.bufferOffset;
        if (newFullLength > this.buffer.byteLength) {
          let newBuffer;
          if (newLength <= this.buffer.byteLength && this.bufferOffset >= this.bufferLength) {
            newBuffer = this.buffer;
          } else {
            let newBufferLength = this.buffer.byteLength * 2;
            while (newLength >= newBufferLength) {
              newBufferLength *= 2;
            }
            newBuffer = Buffer.allocUnsafe(newBufferLength);
          }
          this.buffer.copy(newBuffer, 0, this.bufferOffset, this.bufferOffset + this.bufferLength);
          this.buffer = newBuffer;
          this.bufferOffset = 0;
        }
        buffer.copy(this.buffer, this.bufferOffset + this.bufferLength);
        this.bufferLength = newLength;
      } else {
        this.buffer = buffer;
        this.bufferOffset = 0;
        this.bufferLength = buffer.byteLength;
      }
    }
    handlePacket(offset2, code, length, bytes) {
      switch (code) {
        case 50:
          return messages_1.bindComplete;
        case 49:
          return messages_1.parseComplete;
        case 51:
          return messages_1.closeComplete;
        case 110:
          return messages_1.noData;
        case 115:
          return messages_1.portalSuspended;
        case 99:
          return messages_1.copyDone;
        case 87:
          return messages_1.replicationStart;
        case 73:
          return messages_1.emptyQuery;
        case 68:
          return this.parseDataRowMessage(offset2, length, bytes);
        case 67:
          return this.parseCommandCompleteMessage(offset2, length, bytes);
        case 90:
          return this.parseReadyForQueryMessage(offset2, length, bytes);
        case 65:
          return this.parseNotificationMessage(offset2, length, bytes);
        case 82:
          return this.parseAuthenticationResponse(offset2, length, bytes);
        case 83:
          return this.parseParameterStatusMessage(offset2, length, bytes);
        case 75:
          return this.parseBackendKeyData(offset2, length, bytes);
        case 69:
          return this.parseErrorMessage(offset2, length, bytes, "error");
        case 78:
          return this.parseErrorMessage(offset2, length, bytes, "notice");
        case 84:
          return this.parseRowDescriptionMessage(offset2, length, bytes);
        case 116:
          return this.parseParameterDescriptionMessage(offset2, length, bytes);
        case 71:
          return this.parseCopyInMessage(offset2, length, bytes);
        case 72:
          return this.parseCopyOutMessage(offset2, length, bytes);
        case 100:
          return this.parseCopyData(offset2, length, bytes);
        default:
          return new messages_1.DatabaseError("received invalid response: " + code.toString(16), length, "error");
      }
    }
    parseReadyForQueryMessage(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const status = this.reader.string(1);
      return new messages_1.ReadyForQueryMessage(length, status);
    }
    parseCommandCompleteMessage(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const text22 = this.reader.cstring();
      return new messages_1.CommandCompleteMessage(length, text22);
    }
    parseCopyData(offset2, length, bytes) {
      const chunk = bytes.slice(offset2, offset2 + (length - 4));
      return new messages_1.CopyDataMessage(length, chunk);
    }
    parseCopyInMessage(offset2, length, bytes) {
      return this.parseCopyMessage(offset2, length, bytes, "copyInResponse");
    }
    parseCopyOutMessage(offset2, length, bytes) {
      return this.parseCopyMessage(offset2, length, bytes, "copyOutResponse");
    }
    parseCopyMessage(offset2, length, bytes, messageName) {
      this.reader.setBuffer(offset2, bytes);
      const isBinary = this.reader.byte() !== 0;
      const columnCount = this.reader.int16();
      const message = new messages_1.CopyResponse(length, messageName, isBinary, columnCount);
      for (let i2 = 0;i2 < columnCount; i2++) {
        message.columnTypes[i2] = this.reader.int16();
      }
      return message;
    }
    parseNotificationMessage(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const processId = this.reader.int32();
      const channel = this.reader.cstring();
      const payload = this.reader.cstring();
      return new messages_1.NotificationResponseMessage(length, processId, channel, payload);
    }
    parseRowDescriptionMessage(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const fieldCount = this.reader.int16();
      const message = new messages_1.RowDescriptionMessage(length, fieldCount);
      for (let i2 = 0;i2 < fieldCount; i2++) {
        message.fields[i2] = this.parseField();
      }
      return message;
    }
    parseField() {
      const name = this.reader.cstring();
      const tableID = this.reader.int32();
      const columnID = this.reader.int16();
      const dataTypeID = this.reader.int32();
      const dataTypeSize = this.reader.int16();
      const dataTypeModifier = this.reader.int32();
      const mode = this.reader.int16() === 0 ? "text" : "binary";
      return new messages_1.Field(name, tableID, columnID, dataTypeID, dataTypeSize, dataTypeModifier, mode);
    }
    parseParameterDescriptionMessage(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const parameterCount = this.reader.int16();
      const message = new messages_1.ParameterDescriptionMessage(length, parameterCount);
      for (let i2 = 0;i2 < parameterCount; i2++) {
        message.dataTypeIDs[i2] = this.reader.int32();
      }
      return message;
    }
    parseDataRowMessage(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const fieldCount = this.reader.int16();
      const fields22 = new Array(fieldCount);
      for (let i2 = 0;i2 < fieldCount; i2++) {
        const len = this.reader.int32();
        fields22[i2] = len === -1 ? null : this.reader.string(len);
      }
      return new messages_1.DataRowMessage(length, fields22);
    }
    parseParameterStatusMessage(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const name = this.reader.cstring();
      const value = this.reader.cstring();
      return new messages_1.ParameterStatusMessage(length, name, value);
    }
    parseBackendKeyData(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const processID = this.reader.int32();
      const secretKey = this.reader.int32();
      return new messages_1.BackendKeyDataMessage(length, processID, secretKey);
    }
    parseAuthenticationResponse(offset2, length, bytes) {
      this.reader.setBuffer(offset2, bytes);
      const code = this.reader.int32();
      const message = {
        name: "authenticationOk",
        length
      };
      switch (code) {
        case 0:
          break;
        case 3:
          if (message.length === 8) {
            message.name = "authenticationCleartextPassword";
          }
          break;
        case 5:
          if (message.length === 12) {
            message.name = "authenticationMD5Password";
            const salt = this.reader.bytes(4);
            return new messages_1.AuthenticationMD5Password(length, salt);
          }
          break;
        case 10:
          message.name = "authenticationSASL";
          message.mechanisms = [];
          let mechanism;
          do {
            mechanism = this.reader.cstring();
            if (mechanism) {
              message.mechanisms.push(mechanism);
            }
          } while (mechanism);
          break;
        case 11:
          message.name = "authenticationSASLContinue";
          message.data = this.reader.string(length - 8);
          break;
        case 12:
          message.name = "authenticationSASLFinal";
          message.data = this.reader.string(length - 8);
          break;
        default:
          throw new Error("Unknown authenticationOk message type " + code);
      }
      return message;
    }
    parseErrorMessage(offset2, length, bytes, name) {
      this.reader.setBuffer(offset2, bytes);
      const fields22 = {};
      let fieldType = this.reader.string(1);
      while (fieldType !== "\0") {
        fields22[fieldType] = this.reader.cstring();
        fieldType = this.reader.string(1);
      }
      const messageValue = fields22.M;
      const message = name === "notice" ? new messages_1.NoticeMessage(length, messageValue) : new messages_1.DatabaseError(messageValue, length, name);
      message.severity = fields22.S;
      message.code = fields22.C;
      message.detail = fields22.D;
      message.hint = fields22.H;
      message.position = fields22.P;
      message.internalPosition = fields22.p;
      message.internalQuery = fields22.q;
      message.where = fields22.W;
      message.schema = fields22.s;
      message.table = fields22.t;
      message.column = fields22.c;
      message.dataType = fields22.d;
      message.constraint = fields22.n;
      message.file = fields22.F;
      message.line = fields22.L;
      message.routine = fields22.R;
      return message;
    }
  }
  exports.Parser = Parser3;
});
var require_dist22 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.DatabaseError = exports.serialize = exports.parse = undefined;
  var messages_1 = require_messages();
  Object.defineProperty(exports, "DatabaseError", { enumerable: true, get: function() {
    return messages_1.DatabaseError;
  } });
  var serializer_1 = require_serializer();
  Object.defineProperty(exports, "serialize", { enumerable: true, get: function() {
    return serializer_1.serialize;
  } });
  var parser_1 = require_parser();
  function parse8(stream2, callback) {
    const parser = new parser_1.Parser;
    stream2.on("data", (buffer) => parser.parse(buffer, callback));
    return new Promise((resolve5) => stream2.on("end", () => resolve5()));
  }
  exports.parse = parse8;
});
var exports_empty = {};
__export3(exports_empty, {
  default: () => empty_default
});
var empty_default;
var init_empty = __esm2(() => {
  empty_default = {};
});
var require_stream = __commonJS2((exports, module) => {
  var { getStream, getSecureStream } = getStreamFuncs();
  module.exports = {
    getStream,
    getSecureStream
  };
  function getNodejsStreamFuncs() {
    function getStream2(ssl) {
      const net = import.meta.require("net");
      return new net.Socket;
    }
    function getSecureStream2(options3) {
      var tls = import.meta.require("tls");
      return tls.connect(options3);
    }
    return {
      getStream: getStream2,
      getSecureStream: getSecureStream2
    };
  }
  function getCloudflareStreamFuncs() {
    function getStream2(ssl) {
      const { CloudflareSocket } = (init_empty(), __toCommonJS(exports_empty));
      return new CloudflareSocket(ssl);
    }
    function getSecureStream2(options3) {
      options3.socket.startTls(options3);
      return options3.socket;
    }
    return {
      getStream: getStream2,
      getSecureStream: getSecureStream2
    };
  }
  function isCloudflareRuntime() {
    if (typeof navigator === "object" && navigator !== null && typeof navigator.userAgent === "string") {
      return navigator.userAgent === "Cloudflare-Workers";
    }
    if (typeof Response === "function") {
      const resp = new Response(null, { cf: { thing: true } });
      if (typeof resp.cf === "object" && resp.cf !== null && resp.cf.thing) {
        return true;
      }
    }
    return false;
  }
  function getStreamFuncs() {
    if (isCloudflareRuntime()) {
      return getCloudflareStreamFuncs();
    }
    return getNodejsStreamFuncs();
  }
});
var require_connection2 = __commonJS2((exports, module) => {
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var { parse: parse8, serialize } = require_dist22();
  var { getStream, getSecureStream } = require_stream();
  var flushBuffer = serialize.flush();
  var syncBuffer = serialize.sync();
  var endBuffer = serialize.end();

  class Connection extends EventEmitter23 {
    constructor(config5) {
      super();
      config5 = config5 || {};
      this.stream = config5.stream || getStream(config5.ssl);
      if (typeof this.stream === "function") {
        this.stream = this.stream(config5);
      }
      this._keepAlive = config5.keepAlive;
      this._keepAliveInitialDelayMillis = config5.keepAliveInitialDelayMillis;
      this.lastBuffer = false;
      this.parsedStatements = {};
      this.ssl = config5.ssl || false;
      this._ending = false;
      this._emitMessage = false;
      var self2 = this;
      this.on("newListener", function(eventName) {
        if (eventName === "message") {
          self2._emitMessage = true;
        }
      });
    }
    connect(port, host) {
      var self2 = this;
      this._connecting = true;
      this.stream.setNoDelay(true);
      this.stream.connect(port, host);
      this.stream.once("connect", function() {
        if (self2._keepAlive) {
          self2.stream.setKeepAlive(true, self2._keepAliveInitialDelayMillis);
        }
        self2.emit("connect");
      });
      const reportStreamError = function(error) {
        if (self2._ending && (error.code === "ECONNRESET" || error.code === "EPIPE")) {
          return;
        }
        self2.emit("error", error);
      };
      this.stream.on("error", reportStreamError);
      this.stream.on("close", function() {
        self2.emit("end");
      });
      if (!this.ssl) {
        return this.attachListeners(this.stream);
      }
      this.stream.once("data", function(buffer) {
        var responseCode = buffer.toString("utf8");
        switch (responseCode) {
          case "S":
            break;
          case "N":
            self2.stream.end();
            return self2.emit("error", new Error("The server does not support SSL connections"));
          default:
            self2.stream.end();
            return self2.emit("error", new Error("There was an error establishing an SSL connection"));
        }
        const options3 = {
          socket: self2.stream
        };
        if (self2.ssl !== true) {
          Object.assign(options3, self2.ssl);
          if ("key" in self2.ssl) {
            options3.key = self2.ssl.key;
          }
        }
        var net = import.meta.require("net");
        if (net.isIP && net.isIP(host) === 0) {
          options3.servername = host;
        }
        try {
          self2.stream = getSecureStream(options3);
        } catch (err22) {
          return self2.emit("error", err22);
        }
        self2.attachListeners(self2.stream);
        self2.stream.on("error", reportStreamError);
        self2.emit("sslconnect");
      });
    }
    attachListeners(stream2) {
      parse8(stream2, (msg) => {
        var eventName = msg.name === "error" ? "errorMessage" : msg.name;
        if (this._emitMessage) {
          this.emit("message", msg);
        }
        this.emit(eventName, msg);
      });
    }
    requestSsl() {
      this.stream.write(serialize.requestSsl());
    }
    startup(config5) {
      this.stream.write(serialize.startup(config5));
    }
    cancel(processID, secretKey) {
      this._send(serialize.cancel(processID, secretKey));
    }
    password(password) {
      this._send(serialize.password(password));
    }
    sendSASLInitialResponseMessage(mechanism, initialResponse) {
      this._send(serialize.sendSASLInitialResponseMessage(mechanism, initialResponse));
    }
    sendSCRAMClientFinalMessage(additionalData) {
      this._send(serialize.sendSCRAMClientFinalMessage(additionalData));
    }
    _send(buffer) {
      if (!this.stream.writable) {
        return false;
      }
      return this.stream.write(buffer);
    }
    query(text22) {
      this._send(serialize.query(text22));
    }
    parse(query) {
      this._send(serialize.parse(query));
    }
    bind(config5) {
      this._send(serialize.bind(config5));
    }
    execute(config5) {
      this._send(serialize.execute(config5));
    }
    flush() {
      if (this.stream.writable) {
        this.stream.write(flushBuffer);
      }
    }
    sync() {
      this._ending = true;
      this._send(syncBuffer);
    }
    ref() {
      this.stream.ref();
    }
    unref() {
      this.stream.unref();
    }
    end() {
      this._ending = true;
      if (!this._connecting || !this.stream.writable) {
        this.stream.end();
        return;
      }
      return this.stream.write(endBuffer, () => {
        this.stream.end();
      });
    }
    close(msg) {
      this._send(serialize.close(msg));
    }
    describe(msg) {
      this._send(serialize.describe(msg));
    }
    sendCopyFromChunk(chunk) {
      this._send(serialize.copyData(chunk));
    }
    endCopyFrom() {
      this._send(serialize.copyDone());
    }
    sendCopyFail(msg) {
      this._send(serialize.copyFail(msg));
    }
  }
  module.exports = Connection;
});
var require_split2 = __commonJS2((exports, module) => {
  var { Transform: Transform2 } = import.meta.require("stream");
  var { StringDecoder } = import.meta.require("string_decoder");
  var kLast = Symbol("last");
  var kDecoder = Symbol("decoder");
  function transform2(chunk, enc, cb) {
    let list2;
    if (this.overflow) {
      const buf = this[kDecoder].write(chunk);
      list2 = buf.split(this.matcher);
      if (list2.length === 1)
        return cb();
      list2.shift();
      this.overflow = false;
    } else {
      this[kLast] += this[kDecoder].write(chunk);
      list2 = this[kLast].split(this.matcher);
    }
    this[kLast] = list2.pop();
    for (let i2 = 0;i2 < list2.length; i2++) {
      try {
        push3(this, this.mapper(list2[i2]));
      } catch (error) {
        return cb(error);
      }
    }
    this.overflow = this[kLast].length > this.maxLength;
    if (this.overflow && !this.skipOverflow) {
      cb(new Error("maximum buffer reached"));
      return;
    }
    cb();
  }
  function flush(cb) {
    this[kLast] += this[kDecoder].end();
    if (this[kLast]) {
      try {
        push3(this, this.mapper(this[kLast]));
      } catch (error) {
        return cb(error);
      }
    }
    cb();
  }
  function push3(self2, val2) {
    if (val2 !== undefined) {
      self2.push(val2);
    }
  }
  function noop3(incoming) {
    return incoming;
  }
  function split2(matcher, mapper, options3) {
    matcher = matcher || /\r?\n/;
    mapper = mapper || noop3;
    options3 = options3 || {};
    switch (arguments.length) {
      case 1:
        if (typeof matcher === "function") {
          mapper = matcher;
          matcher = /\r?\n/;
        } else if (typeof matcher === "object" && !(matcher instanceof RegExp) && !matcher[Symbol.split]) {
          options3 = matcher;
          matcher = /\r?\n/;
        }
        break;
      case 2:
        if (typeof matcher === "function") {
          options3 = mapper;
          mapper = matcher;
          matcher = /\r?\n/;
        } else if (typeof mapper === "object") {
          options3 = mapper;
          mapper = noop3;
        }
    }
    options3 = Object.assign({}, options3);
    options3.autoDestroy = true;
    options3.transform = transform2;
    options3.flush = flush;
    options3.readableObjectMode = true;
    const stream2 = new Transform2(options3);
    stream2[kLast] = "";
    stream2[kDecoder] = new StringDecoder("utf8");
    stream2.matcher = matcher;
    stream2.mapper = mapper;
    stream2.maxLength = options3.maxLength;
    stream2.skipOverflow = options3.skipOverflow || false;
    stream2.overflow = false;
    stream2._destroy = function(err22, cb) {
      this._writableState.errorEmitted = false;
      cb(err22);
    };
    return stream2;
  }
  module.exports = split2;
});
var require_helper = __commonJS2((exports, module) => {
  var path42 = import.meta.require("path");
  var Stream = import.meta.require("stream").Stream;
  var split2 = require_split2();
  var util = import.meta.require("util");
  var defaultPort = 5432;
  var isWin = process.platform === "win32";
  var warnStream = process.stderr;
  var S_IRWXG = 56;
  var S_IRWXO = 7;
  var S_IFMT = 61440;
  var S_IFREG = 32768;
  function isRegFile(mode) {
    return (mode & S_IFMT) == S_IFREG;
  }
  var fieldNames = ["host", "port", "database", "user", "password"];
  var nrOfFields = fieldNames.length;
  var passKey = fieldNames[nrOfFields - 1];
  function warn() {
    var isWritable = warnStream instanceof Stream && warnStream.writable === true;
    if (isWritable) {
      var args = Array.prototype.slice.call(arguments).concat("\n");
      warnStream.write(util.format.apply(util, args));
    }
  }
  Object.defineProperty(exports, "isWin", {
    get: function() {
      return isWin;
    },
    set: function(val2) {
      isWin = val2;
    }
  });
  exports.warnTo = function(stream2) {
    var old = warnStream;
    warnStream = stream2;
    return old;
  };
  exports.getFileName = function(rawEnv) {
    var env62 = rawEnv || process.env;
    var file = env62.PGPASSFILE || (isWin ? path42.join(env62.APPDATA || "./", "postgresql", "pgpass.conf") : path42.join(env62.HOME || "./", ".pgpass"));
    return file;
  };
  exports.usePgPass = function(stats, fname) {
    if (Object.prototype.hasOwnProperty.call(process.env, "PGPASSWORD")) {
      return false;
    }
    if (isWin) {
      return true;
    }
    fname = fname || "<unkn>";
    if (!isRegFile(stats.mode)) {
      warn('WARNING: password file "%s" is not a plain file', fname);
      return false;
    }
    if (stats.mode & (S_IRWXG | S_IRWXO)) {
      warn('WARNING: password file "%s" has group or world access; permissions should be u=rw (0600) or less', fname);
      return false;
    }
    return true;
  };
  var matcher = exports.match = function(connInfo, entry) {
    return fieldNames.slice(0, -1).reduce(function(prev, field, idx) {
      if (idx == 1) {
        if (Number(connInfo[field] || defaultPort) === Number(entry[field])) {
          return prev && true;
        }
      }
      return prev && (entry[field] === "*" || entry[field] === connInfo[field]);
    }, true);
  };
  exports.getPassword = function(connInfo, stream2, cb) {
    var pass;
    var lineStream = stream2.pipe(split2());
    function onLine(line) {
      var entry = parseLine(line);
      if (entry && isValidEntry(entry) && matcher(connInfo, entry)) {
        pass = entry[passKey];
        lineStream.end();
      }
    }
    var onEnd = function() {
      stream2.destroy();
      cb(pass);
    };
    var onErr = function(err22) {
      stream2.destroy();
      warn("WARNING: error on reading file: %s", err22);
      cb(undefined);
    };
    stream2.on("error", onErr);
    lineStream.on("data", onLine).on("end", onEnd).on("error", onErr);
  };
  var parseLine = exports.parseLine = function(line) {
    if (line.length < 11 || line.match(/^\s+#/)) {
      return null;
    }
    var curChar = "";
    var prevChar = "";
    var fieldIdx = 0;
    var startIdx = 0;
    var endIdx = 0;
    var obj = {};
    var isLastField = false;
    var addToObj = function(idx, i0, i1) {
      var field = line.substring(i0, i1);
      if (!Object.hasOwnProperty.call(process.env, "PGPASS_NO_DEESCAPE")) {
        field = field.replace(/\\([:\\])/g, "$1");
      }
      obj[fieldNames[idx]] = field;
    };
    for (var i2 = 0;i2 < line.length - 1; i2 += 1) {
      curChar = line.charAt(i2 + 1);
      prevChar = line.charAt(i2);
      isLastField = fieldIdx == nrOfFields - 1;
      if (isLastField) {
        addToObj(fieldIdx, startIdx);
        break;
      }
      if (i2 >= 0 && curChar == ":" && prevChar !== "\\") {
        addToObj(fieldIdx, startIdx, i2 + 1);
        startIdx = i2 + 2;
        fieldIdx += 1;
      }
    }
    obj = Object.keys(obj).length === nrOfFields ? obj : null;
    return obj;
  };
  var isValidEntry = exports.isValidEntry = function(entry) {
    var rules2 = {
      0: function(x) {
        return x.length > 0;
      },
      1: function(x) {
        if (x === "*") {
          return true;
        }
        x = Number(x);
        return isFinite(x) && x > 0 && x < 9007199254740992 && Math.floor(x) === x;
      },
      2: function(x) {
        return x.length > 0;
      },
      3: function(x) {
        return x.length > 0;
      },
      4: function(x) {
        return x.length > 0;
      }
    };
    for (var idx = 0;idx < fieldNames.length; idx += 1) {
      var rule = rules2[idx];
      var value = entry[fieldNames[idx]] || "";
      var res = rule(value);
      if (!res) {
        return false;
      }
    }
    return true;
  };
});
var require_lib17 = __commonJS2((exports, module) => {
  var path42 = import.meta.require("path");
  var fs32 = import.meta.require("fs");
  var helper = require_helper();
  module.exports = function(connInfo, cb) {
    var file = helper.getFileName();
    fs32.stat(file, function(err22, stat22) {
      if (err22 || !helper.usePgPass(stat22, file)) {
        return cb(undefined);
      }
      var st = fs32.createReadStream(file);
      helper.getPassword(connInfo, st, cb);
    });
  };
  module.exports.warnTo = helper.warnTo;
});
var require_client2 = __commonJS2((exports, module) => {
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var utils9 = require_utils5();
  var sasl = require_sasl();
  var TypeOverrides = require_type_overrides();
  var ConnectionParameters = require_connection_parameters();
  var Query = require_query3();
  var defaults3 = require_defaults2();
  var Connection = require_connection2();
  var crypto = require_utils6();

  class Client extends EventEmitter23 {
    constructor(config5) {
      super();
      this.connectionParameters = new ConnectionParameters(config5);
      this.user = this.connectionParameters.user;
      this.database = this.connectionParameters.database;
      this.port = this.connectionParameters.port;
      this.host = this.connectionParameters.host;
      Object.defineProperty(this, "password", {
        configurable: true,
        enumerable: false,
        writable: true,
        value: this.connectionParameters.password
      });
      this.replication = this.connectionParameters.replication;
      var c22 = config5 || {};
      this._Promise = c22.Promise || global.Promise;
      this._types = new TypeOverrides(c22.types);
      this._ending = false;
      this._ended = false;
      this._connecting = false;
      this._connected = false;
      this._connectionError = false;
      this._queryable = true;
      this.connection = c22.connection || new Connection({
        stream: c22.stream,
        ssl: this.connectionParameters.ssl,
        keepAlive: c22.keepAlive || false,
        keepAliveInitialDelayMillis: c22.keepAliveInitialDelayMillis || 0,
        encoding: this.connectionParameters.client_encoding || "utf8"
      });
      this.queryQueue = [];
      this.binary = c22.binary || defaults3.binary;
      this.processID = null;
      this.secretKey = null;
      this.ssl = this.connectionParameters.ssl || false;
      if (this.ssl && this.ssl.key) {
        Object.defineProperty(this.ssl, "key", {
          enumerable: false
        });
      }
      this._connectionTimeoutMillis = c22.connectionTimeoutMillis || 0;
    }
    _errorAllQueries(err22) {
      const enqueueError = (query) => {
        process.nextTick(() => {
          query.handleError(err22, this.connection);
        });
      };
      if (this.activeQuery) {
        enqueueError(this.activeQuery);
        this.activeQuery = null;
      }
      this.queryQueue.forEach(enqueueError);
      this.queryQueue.length = 0;
    }
    _connect(callback) {
      var self2 = this;
      var con = this.connection;
      this._connectionCallback = callback;
      if (this._connecting || this._connected) {
        const err22 = new Error("Client has already been connected. You cannot reuse a client.");
        process.nextTick(() => {
          callback(err22);
        });
        return;
      }
      this._connecting = true;
      if (this._connectionTimeoutMillis > 0) {
        this.connectionTimeoutHandle = setTimeout(() => {
          con._ending = true;
          con.stream.destroy(new Error("timeout expired"));
        }, this._connectionTimeoutMillis);
      }
      if (this.host && this.host.indexOf("/") === 0) {
        con.connect(this.host + "/.s.PGSQL." + this.port);
      } else {
        con.connect(this.port, this.host);
      }
      con.on("connect", function() {
        if (self2.ssl) {
          con.requestSsl();
        } else {
          con.startup(self2.getStartupConf());
        }
      });
      con.on("sslconnect", function() {
        con.startup(self2.getStartupConf());
      });
      this._attachListeners(con);
      con.once("end", () => {
        const error = this._ending ? new Error("Connection terminated") : new Error("Connection terminated unexpectedly");
        clearTimeout(this.connectionTimeoutHandle);
        this._errorAllQueries(error);
        this._ended = true;
        if (!this._ending) {
          if (this._connecting && !this._connectionError) {
            if (this._connectionCallback) {
              this._connectionCallback(error);
            } else {
              this._handleErrorEvent(error);
            }
          } else if (!this._connectionError) {
            this._handleErrorEvent(error);
          }
        }
        process.nextTick(() => {
          this.emit("end");
        });
      });
    }
    connect(callback) {
      if (callback) {
        this._connect(callback);
        return;
      }
      return new this._Promise((resolve5, reject) => {
        this._connect((error) => {
          if (error) {
            reject(error);
          } else {
            resolve5();
          }
        });
      });
    }
    _attachListeners(con) {
      con.on("authenticationCleartextPassword", this._handleAuthCleartextPassword.bind(this));
      con.on("authenticationMD5Password", this._handleAuthMD5Password.bind(this));
      con.on("authenticationSASL", this._handleAuthSASL.bind(this));
      con.on("authenticationSASLContinue", this._handleAuthSASLContinue.bind(this));
      con.on("authenticationSASLFinal", this._handleAuthSASLFinal.bind(this));
      con.on("backendKeyData", this._handleBackendKeyData.bind(this));
      con.on("error", this._handleErrorEvent.bind(this));
      con.on("errorMessage", this._handleErrorMessage.bind(this));
      con.on("readyForQuery", this._handleReadyForQuery.bind(this));
      con.on("notice", this._handleNotice.bind(this));
      con.on("rowDescription", this._handleRowDescription.bind(this));
      con.on("dataRow", this._handleDataRow.bind(this));
      con.on("portalSuspended", this._handlePortalSuspended.bind(this));
      con.on("emptyQuery", this._handleEmptyQuery.bind(this));
      con.on("commandComplete", this._handleCommandComplete.bind(this));
      con.on("parseComplete", this._handleParseComplete.bind(this));
      con.on("copyInResponse", this._handleCopyInResponse.bind(this));
      con.on("copyData", this._handleCopyData.bind(this));
      con.on("notification", this._handleNotification.bind(this));
    }
    _checkPgPass(cb) {
      const con = this.connection;
      if (typeof this.password === "function") {
        this._Promise.resolve().then(() => this.password()).then((pass) => {
          if (pass !== undefined) {
            if (typeof pass !== "string") {
              con.emit("error", new TypeError("Password must be a string"));
              return;
            }
            this.connectionParameters.password = this.password = pass;
          } else {
            this.connectionParameters.password = this.password = null;
          }
          cb();
        }).catch((err22) => {
          con.emit("error", err22);
        });
      } else if (this.password !== null) {
        cb();
      } else {
        try {
          const pgPass = require_lib17();
          pgPass(this.connectionParameters, (pass) => {
            if (pass !== undefined) {
              this.connectionParameters.password = this.password = pass;
            }
            cb();
          });
        } catch (e) {
          this.emit("error", e);
        }
      }
    }
    _handleAuthCleartextPassword(msg) {
      this._checkPgPass(() => {
        this.connection.password(this.password);
      });
    }
    _handleAuthMD5Password(msg) {
      this._checkPgPass(async () => {
        try {
          const hashedPassword = await crypto.postgresMd5PasswordHash(this.user, this.password, msg.salt);
          this.connection.password(hashedPassword);
        } catch (e) {
          this.emit("error", e);
        }
      });
    }
    _handleAuthSASL(msg) {
      this._checkPgPass(() => {
        try {
          this.saslSession = sasl.startSession(msg.mechanisms);
          this.connection.sendSASLInitialResponseMessage(this.saslSession.mechanism, this.saslSession.response);
        } catch (err22) {
          this.connection.emit("error", err22);
        }
      });
    }
    async _handleAuthSASLContinue(msg) {
      try {
        await sasl.continueSession(this.saslSession, this.password, msg.data);
        this.connection.sendSCRAMClientFinalMessage(this.saslSession.response);
      } catch (err22) {
        this.connection.emit("error", err22);
      }
    }
    _handleAuthSASLFinal(msg) {
      try {
        sasl.finalizeSession(this.saslSession, msg.data);
        this.saslSession = null;
      } catch (err22) {
        this.connection.emit("error", err22);
      }
    }
    _handleBackendKeyData(msg) {
      this.processID = msg.processID;
      this.secretKey = msg.secretKey;
    }
    _handleReadyForQuery(msg) {
      if (this._connecting) {
        this._connecting = false;
        this._connected = true;
        clearTimeout(this.connectionTimeoutHandle);
        if (this._connectionCallback) {
          this._connectionCallback(null, this);
          this._connectionCallback = null;
        }
        this.emit("connect");
      }
      const { activeQuery } = this;
      this.activeQuery = null;
      this.readyForQuery = true;
      if (activeQuery) {
        activeQuery.handleReadyForQuery(this.connection);
      }
      this._pulseQueryQueue();
    }
    _handleErrorWhileConnecting(err22) {
      if (this._connectionError) {
        return;
      }
      this._connectionError = true;
      clearTimeout(this.connectionTimeoutHandle);
      if (this._connectionCallback) {
        return this._connectionCallback(err22);
      }
      this.emit("error", err22);
    }
    _handleErrorEvent(err22) {
      if (this._connecting) {
        return this._handleErrorWhileConnecting(err22);
      }
      this._queryable = false;
      this._errorAllQueries(err22);
      this.emit("error", err22);
    }
    _handleErrorMessage(msg) {
      if (this._connecting) {
        return this._handleErrorWhileConnecting(msg);
      }
      const activeQuery = this.activeQuery;
      if (!activeQuery) {
        this._handleErrorEvent(msg);
        return;
      }
      this.activeQuery = null;
      activeQuery.handleError(msg, this.connection);
    }
    _handleRowDescription(msg) {
      this.activeQuery.handleRowDescription(msg);
    }
    _handleDataRow(msg) {
      this.activeQuery.handleDataRow(msg);
    }
    _handlePortalSuspended(msg) {
      this.activeQuery.handlePortalSuspended(this.connection);
    }
    _handleEmptyQuery(msg) {
      this.activeQuery.handleEmptyQuery(this.connection);
    }
    _handleCommandComplete(msg) {
      if (this.activeQuery == null) {
        const error = new Error("Received unexpected commandComplete message from backend.");
        this._handleErrorEvent(error);
        return;
      }
      this.activeQuery.handleCommandComplete(msg, this.connection);
    }
    _handleParseComplete() {
      if (this.activeQuery == null) {
        const error = new Error("Received unexpected parseComplete message from backend.");
        this._handleErrorEvent(error);
        return;
      }
      if (this.activeQuery.name) {
        this.connection.parsedStatements[this.activeQuery.name] = this.activeQuery.text;
      }
    }
    _handleCopyInResponse(msg) {
      this.activeQuery.handleCopyInResponse(this.connection);
    }
    _handleCopyData(msg) {
      this.activeQuery.handleCopyData(msg, this.connection);
    }
    _handleNotification(msg) {
      this.emit("notification", msg);
    }
    _handleNotice(msg) {
      this.emit("notice", msg);
    }
    getStartupConf() {
      var params = this.connectionParameters;
      var data2 = {
        user: params.user,
        database: params.database
      };
      var appName = params.application_name || params.fallback_application_name;
      if (appName) {
        data2.application_name = appName;
      }
      if (params.replication) {
        data2.replication = "" + params.replication;
      }
      if (params.statement_timeout) {
        data2.statement_timeout = String(parseInt(params.statement_timeout, 10));
      }
      if (params.lock_timeout) {
        data2.lock_timeout = String(parseInt(params.lock_timeout, 10));
      }
      if (params.idle_in_transaction_session_timeout) {
        data2.idle_in_transaction_session_timeout = String(parseInt(params.idle_in_transaction_session_timeout, 10));
      }
      if (params.options) {
        data2.options = params.options;
      }
      return data2;
    }
    cancel(client, query) {
      if (client.activeQuery === query) {
        var con = this.connection;
        if (this.host && this.host.indexOf("/") === 0) {
          con.connect(this.host + "/.s.PGSQL." + this.port);
        } else {
          con.connect(this.port, this.host);
        }
        con.on("connect", function() {
          con.cancel(client.processID, client.secretKey);
        });
      } else if (client.queryQueue.indexOf(query) !== -1) {
        client.queryQueue.splice(client.queryQueue.indexOf(query), 1);
      }
    }
    setTypeParser(oid, format, parseFn) {
      return this._types.setTypeParser(oid, format, parseFn);
    }
    getTypeParser(oid, format) {
      return this._types.getTypeParser(oid, format);
    }
    escapeIdentifier(str) {
      return utils9.escapeIdentifier(str);
    }
    escapeLiteral(str) {
      return utils9.escapeLiteral(str);
    }
    _pulseQueryQueue() {
      if (this.readyForQuery === true) {
        this.activeQuery = this.queryQueue.shift();
        if (this.activeQuery) {
          this.readyForQuery = false;
          this.hasExecuted = true;
          const queryError = this.activeQuery.submit(this.connection);
          if (queryError) {
            process.nextTick(() => {
              this.activeQuery.handleError(queryError, this.connection);
              this.readyForQuery = true;
              this._pulseQueryQueue();
            });
          }
        } else if (this.hasExecuted) {
          this.activeQuery = null;
          this.emit("drain");
        }
      }
    }
    query(config5, values3, callback) {
      var query;
      var result2;
      var readTimeout;
      var readTimeoutTimer;
      var queryCallback;
      if (config5 === null || config5 === undefined) {
        throw new TypeError("Client was passed a null or undefined query");
      } else if (typeof config5.submit === "function") {
        readTimeout = config5.query_timeout || this.connectionParameters.query_timeout;
        result2 = query = config5;
        if (typeof values3 === "function") {
          query.callback = query.callback || values3;
        }
      } else {
        readTimeout = config5.query_timeout || this.connectionParameters.query_timeout;
        query = new Query(config5, values3, callback);
        if (!query.callback) {
          result2 = new this._Promise((resolve5, reject) => {
            query.callback = (err22, res) => err22 ? reject(err22) : resolve5(res);
          }).catch((err22) => {
            Error.captureStackTrace(err22);
            throw err22;
          });
        }
      }
      if (readTimeout) {
        queryCallback = query.callback;
        readTimeoutTimer = setTimeout(() => {
          var error = new Error("Query read timeout");
          process.nextTick(() => {
            query.handleError(error, this.connection);
          });
          queryCallback(error);
          query.callback = () => {
          };
          var index = this.queryQueue.indexOf(query);
          if (index > -1) {
            this.queryQueue.splice(index, 1);
          }
          this._pulseQueryQueue();
        }, readTimeout);
        query.callback = (err22, res) => {
          clearTimeout(readTimeoutTimer);
          queryCallback(err22, res);
        };
      }
      if (this.binary && !query.binary) {
        query.binary = true;
      }
      if (query._result && !query._result._types) {
        query._result._types = this._types;
      }
      if (!this._queryable) {
        process.nextTick(() => {
          query.handleError(new Error("Client has encountered a connection error and is not queryable"), this.connection);
        });
        return result2;
      }
      if (this._ending) {
        process.nextTick(() => {
          query.handleError(new Error("Client was closed and is not queryable"), this.connection);
        });
        return result2;
      }
      this.queryQueue.push(query);
      this._pulseQueryQueue();
      return result2;
    }
    ref() {
      this.connection.ref();
    }
    unref() {
      this.connection.unref();
    }
    end(cb) {
      this._ending = true;
      if (!this.connection._connecting || this._ended) {
        if (cb) {
          cb();
        } else {
          return this._Promise.resolve();
        }
      }
      if (this.activeQuery || !this._queryable) {
        this.connection.stream.destroy();
      } else {
        this.connection.end();
      }
      if (cb) {
        this.connection.once("end", cb);
      } else {
        return new this._Promise((resolve5) => {
          this.connection.once("end", resolve5);
        });
      }
    }
  }
  Client.Query = Query;
  module.exports = Client;
});
var require_pg_pool = __commonJS2((exports, module) => {
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var NOOP = function() {
  };
  var removeWhere = (list2, predicate) => {
    const i2 = list2.findIndex(predicate);
    return i2 === -1 ? undefined : list2.splice(i2, 1)[0];
  };

  class IdleItem {
    constructor(client, idleListener, timeoutId) {
      this.client = client;
      this.idleListener = idleListener;
      this.timeoutId = timeoutId;
    }
  }

  class PendingItem {
    constructor(callback) {
      this.callback = callback;
    }
  }
  function throwOnDoubleRelease() {
    throw new Error("Release called on client which has already been released to the pool.");
  }
  function promisify22(Promise2, callback) {
    if (callback) {
      return { callback, result: undefined };
    }
    let rej;
    let res;
    const cb = function(err22, client) {
      err22 ? rej(err22) : res(client);
    };
    const result2 = new Promise2(function(resolve5, reject) {
      res = resolve5;
      rej = reject;
    }).catch((err22) => {
      Error.captureStackTrace(err22);
      throw err22;
    });
    return { callback: cb, result: result2 };
  }
  function makeIdleListener(pool, client) {
    return function idleListener(err22) {
      err22.client = client;
      client.removeListener("error", idleListener);
      client.on("error", () => {
        pool.log("additional client error after disconnection due to error", err22);
      });
      pool._remove(client);
      pool.emit("error", err22, client);
    };
  }

  class Pool extends EventEmitter23 {
    constructor(options3, Client) {
      super();
      this.options = Object.assign({}, options3);
      if (options3 != null && "password" in options3) {
        Object.defineProperty(this.options, "password", {
          configurable: true,
          enumerable: false,
          writable: true,
          value: options3.password
        });
      }
      if (options3 != null && options3.ssl && options3.ssl.key) {
        Object.defineProperty(this.options.ssl, "key", {
          enumerable: false
        });
      }
      this.options.max = this.options.max || this.options.poolSize || 10;
      this.options.maxUses = this.options.maxUses || Infinity;
      this.options.allowExitOnIdle = this.options.allowExitOnIdle || false;
      this.options.maxLifetimeSeconds = this.options.maxLifetimeSeconds || 0;
      this.log = this.options.log || function() {
      };
      this.Client = this.options.Client || Client || require_lib18().Client;
      this.Promise = this.options.Promise || global.Promise;
      if (typeof this.options.idleTimeoutMillis === "undefined") {
        this.options.idleTimeoutMillis = 1e4;
      }
      this._clients = [];
      this._idle = [];
      this._expired = new WeakSet;
      this._pendingQueue = [];
      this._endCallback = undefined;
      this.ending = false;
      this.ended = false;
    }
    _isFull() {
      return this._clients.length >= this.options.max;
    }
    _pulseQueue() {
      this.log("pulse queue");
      if (this.ended) {
        this.log("pulse queue ended");
        return;
      }
      if (this.ending) {
        this.log("pulse queue on ending");
        if (this._idle.length) {
          this._idle.slice().map((item) => {
            this._remove(item.client);
          });
        }
        if (!this._clients.length) {
          this.ended = true;
          this._endCallback();
        }
        return;
      }
      if (!this._pendingQueue.length) {
        this.log("no queued requests");
        return;
      }
      if (!this._idle.length && this._isFull()) {
        return;
      }
      const pendingItem = this._pendingQueue.shift();
      if (this._idle.length) {
        const idleItem = this._idle.pop();
        clearTimeout(idleItem.timeoutId);
        const client = idleItem.client;
        client.ref && client.ref();
        const idleListener = idleItem.idleListener;
        return this._acquireClient(client, pendingItem, idleListener, false);
      }
      if (!this._isFull()) {
        return this.newClient(pendingItem);
      }
      throw new Error("unexpected condition");
    }
    _remove(client) {
      const removed = removeWhere(this._idle, (item) => item.client === client);
      if (removed !== undefined) {
        clearTimeout(removed.timeoutId);
      }
      this._clients = this._clients.filter((c22) => c22 !== client);
      client.end();
      this.emit("remove", client);
    }
    connect(cb) {
      if (this.ending) {
        const err22 = new Error("Cannot use a pool after calling end on the pool");
        return cb ? cb(err22) : this.Promise.reject(err22);
      }
      const response = promisify22(this.Promise, cb);
      const result2 = response.result;
      if (this._isFull() || this._idle.length) {
        if (this._idle.length) {
          process.nextTick(() => this._pulseQueue());
        }
        if (!this.options.connectionTimeoutMillis) {
          this._pendingQueue.push(new PendingItem(response.callback));
          return result2;
        }
        const queueCallback = (err22, res, done) => {
          clearTimeout(tid);
          response.callback(err22, res, done);
        };
        const pendingItem = new PendingItem(queueCallback);
        const tid = setTimeout(() => {
          removeWhere(this._pendingQueue, (i2) => i2.callback === queueCallback);
          pendingItem.timedOut = true;
          response.callback(new Error("timeout exceeded when trying to connect"));
        }, this.options.connectionTimeoutMillis);
        this._pendingQueue.push(pendingItem);
        return result2;
      }
      this.newClient(new PendingItem(response.callback));
      return result2;
    }
    newClient(pendingItem) {
      const client = new this.Client(this.options);
      this._clients.push(client);
      const idleListener = makeIdleListener(this, client);
      this.log("checking client timeout");
      let tid;
      let timeoutHit = false;
      if (this.options.connectionTimeoutMillis) {
        tid = setTimeout(() => {
          this.log("ending client due to timeout");
          timeoutHit = true;
          client.connection ? client.connection.stream.destroy() : client.end();
        }, this.options.connectionTimeoutMillis);
      }
      this.log("connecting new client");
      client.connect((err22) => {
        if (tid) {
          clearTimeout(tid);
        }
        client.on("error", idleListener);
        if (err22) {
          this.log("client failed to connect", err22);
          this._clients = this._clients.filter((c22) => c22 !== client);
          if (timeoutHit) {
            err22.message = "Connection terminated due to connection timeout";
          }
          this._pulseQueue();
          if (!pendingItem.timedOut) {
            pendingItem.callback(err22, undefined, NOOP);
          }
        } else {
          this.log("new client connected");
          if (this.options.maxLifetimeSeconds !== 0) {
            const maxLifetimeTimeout = setTimeout(() => {
              this.log("ending client due to expired lifetime");
              this._expired.add(client);
              const idleIndex = this._idle.findIndex((idleItem) => idleItem.client === client);
              if (idleIndex !== -1) {
                this._acquireClient(client, new PendingItem((err3, client2, clientRelease) => clientRelease()), idleListener, false);
              }
            }, this.options.maxLifetimeSeconds * 1000);
            maxLifetimeTimeout.unref();
            client.once("end", () => clearTimeout(maxLifetimeTimeout));
          }
          return this._acquireClient(client, pendingItem, idleListener, true);
        }
      });
    }
    _acquireClient(client, pendingItem, idleListener, isNew) {
      if (isNew) {
        this.emit("connect", client);
      }
      this.emit("acquire", client);
      client.release = this._releaseOnce(client, idleListener);
      client.removeListener("error", idleListener);
      if (!pendingItem.timedOut) {
        if (isNew && this.options.verify) {
          this.options.verify(client, (err22) => {
            if (err22) {
              client.release(err22);
              return pendingItem.callback(err22, undefined, NOOP);
            }
            pendingItem.callback(undefined, client, client.release);
          });
        } else {
          pendingItem.callback(undefined, client, client.release);
        }
      } else {
        if (isNew && this.options.verify) {
          this.options.verify(client, client.release);
        } else {
          client.release();
        }
      }
    }
    _releaseOnce(client, idleListener) {
      let released = false;
      return (err22) => {
        if (released) {
          throwOnDoubleRelease();
        }
        released = true;
        this._release(client, idleListener, err22);
      };
    }
    _release(client, idleListener, err22) {
      client.on("error", idleListener);
      client._poolUseCount = (client._poolUseCount || 0) + 1;
      this.emit("release", err22, client);
      if (err22 || this.ending || !client._queryable || client._ending || client._poolUseCount >= this.options.maxUses) {
        if (client._poolUseCount >= this.options.maxUses) {
          this.log("remove expended client");
        }
        this._remove(client);
        this._pulseQueue();
        return;
      }
      const isExpired = this._expired.has(client);
      if (isExpired) {
        this.log("remove expired client");
        this._expired.delete(client);
        this._remove(client);
        this._pulseQueue();
        return;
      }
      let tid;
      if (this.options.idleTimeoutMillis) {
        tid = setTimeout(() => {
          this.log("remove idle client");
          this._remove(client);
        }, this.options.idleTimeoutMillis);
        if (this.options.allowExitOnIdle) {
          tid.unref();
        }
      }
      if (this.options.allowExitOnIdle) {
        client.unref();
      }
      this._idle.push(new IdleItem(client, idleListener, tid));
      this._pulseQueue();
    }
    query(text22, values3, cb) {
      if (typeof text22 === "function") {
        const response2 = promisify22(this.Promise, text22);
        setImmediate(function() {
          return response2.callback(new Error("Passing a function as the first parameter to pool.query is not supported"));
        });
        return response2.result;
      }
      if (typeof values3 === "function") {
        cb = values3;
        values3 = undefined;
      }
      const response = promisify22(this.Promise, cb);
      cb = response.callback;
      this.connect((err22, client) => {
        if (err22) {
          return cb(err22);
        }
        let clientReleased = false;
        const onError2 = (err3) => {
          if (clientReleased) {
            return;
          }
          clientReleased = true;
          client.release(err3);
          cb(err3);
        };
        client.once("error", onError2);
        this.log("dispatching query");
        try {
          client.query(text22, values3, (err3, res) => {
            this.log("query dispatched");
            client.removeListener("error", onError2);
            if (clientReleased) {
              return;
            }
            clientReleased = true;
            client.release(err3);
            if (err3) {
              return cb(err3);
            }
            return cb(undefined, res);
          });
        } catch (err3) {
          client.release(err3);
          return cb(err3);
        }
      });
      return response.result;
    }
    end(cb) {
      this.log("ending");
      if (this.ending) {
        const err22 = new Error("Called end on pool more than once");
        return cb ? cb(err22) : this.Promise.reject(err22);
      }
      this.ending = true;
      const promised = promisify22(this.Promise, cb);
      this._endCallback = promised.callback;
      this._pulseQueue();
      return promised.result;
    }
    get waitingCount() {
      return this._pendingQueue.length;
    }
    get idleCount() {
      return this._idle.length;
    }
    get expiredCount() {
      return this._clients.reduce((acc, client) => acc + (this._expired.has(client) ? 1 : 0), 0);
    }
    get totalCount() {
      return this._clients.length;
    }
  }
  module.exports = Pool;
});
var require_query4 = __commonJS2((exports, module) => {
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var util = import.meta.require("util");
  var utils9 = require_utils5();
  var NativeQuery = module.exports = function(config5, values3, callback) {
    EventEmitter23.call(this);
    config5 = utils9.normalizeQueryConfig(config5, values3, callback);
    this.text = config5.text;
    this.values = config5.values;
    this.name = config5.name;
    this.queryMode = config5.queryMode;
    this.callback = config5.callback;
    this.state = "new";
    this._arrayMode = config5.rowMode === "array";
    this._emitRowEvents = false;
    this.on("newListener", function(event) {
      if (event === "row")
        this._emitRowEvents = true;
    }.bind(this));
  };
  util.inherits(NativeQuery, EventEmitter23);
  var errorFieldMap = {
    sqlState: "code",
    statementPosition: "position",
    messagePrimary: "message",
    context: "where",
    schemaName: "schema",
    tableName: "table",
    columnName: "column",
    dataTypeName: "dataType",
    constraintName: "constraint",
    sourceFile: "file",
    sourceLine: "line",
    sourceFunction: "routine"
  };
  NativeQuery.prototype.handleError = function(err22) {
    var fields22 = this.native.pq.resultErrorFields();
    if (fields22) {
      for (var key in fields22) {
        var normalizedFieldName = errorFieldMap[key] || key;
        err22[normalizedFieldName] = fields22[key];
      }
    }
    if (this.callback) {
      this.callback(err22);
    } else {
      this.emit("error", err22);
    }
    this.state = "error";
  };
  NativeQuery.prototype.then = function(onSuccess, onFailure) {
    return this._getPromise().then(onSuccess, onFailure);
  };
  NativeQuery.prototype.catch = function(callback) {
    return this._getPromise().catch(callback);
  };
  NativeQuery.prototype._getPromise = function() {
    if (this._promise)
      return this._promise;
    this._promise = new Promise(function(resolve5, reject) {
      this._once("end", resolve5);
      this._once("error", reject);
    }.bind(this));
    return this._promise;
  };
  NativeQuery.prototype.submit = function(client) {
    this.state = "running";
    var self2 = this;
    this.native = client.native;
    client.native.arrayMode = this._arrayMode;
    var after = function(err22, rows, results) {
      client.native.arrayMode = false;
      setImmediate(function() {
        self2.emit("_done");
      });
      if (err22) {
        return self2.handleError(err22);
      }
      if (self2._emitRowEvents) {
        if (results.length > 1) {
          rows.forEach((rowOfRows, i2) => {
            rowOfRows.forEach((row) => {
              self2.emit("row", row, results[i2]);
            });
          });
        } else {
          rows.forEach(function(row) {
            self2.emit("row", row, results);
          });
        }
      }
      self2.state = "end";
      self2.emit("end", results);
      if (self2.callback) {
        self2.callback(null, results);
      }
    };
    if (process.domain) {
      after = process.domain.bind(after);
    }
    if (this.name) {
      if (this.name.length > 63) {
        console.error("Warning! Postgres only supports 63 characters for query names.");
        console.error("You supplied %s (%s)", this.name, this.name.length);
        console.error("This can cause conflicts and silent errors executing queries");
      }
      var values3 = (this.values || []).map(utils9.prepareValue);
      if (client.namedQueries[this.name]) {
        if (this.text && client.namedQueries[this.name] !== this.text) {
          const err22 = new Error(`Prepared statements must be unique - '${this.name}' was used for a different statement`);
          return after(err22);
        }
        return client.native.execute(this.name, values3, after);
      }
      return client.native.prepare(this.name, this.text, values3.length, function(err22) {
        if (err22)
          return after(err22);
        client.namedQueries[self2.name] = self2.text;
        return self2.native.execute(self2.name, values3, after);
      });
    } else if (this.values) {
      if (!Array.isArray(this.values)) {
        const err22 = new Error("Query values must be an array");
        return after(err22);
      }
      var vals = this.values.map(utils9.prepareValue);
      client.native.query(this.text, vals, after);
    } else if (this.queryMode === "extended") {
      client.native.query(this.text, [], after);
    } else {
      client.native.query(this.text, after);
    }
  };
});
var require_client3 = __commonJS2((exports, module) => {
  var Native;
  try {
    Native = (() => {
      throw new Error(`Cannot require module "pg-native"`);
    })();
  } catch (e) {
    throw e;
  }
  var TypeOverrides = require_type_overrides();
  var EventEmitter23 = import.meta.require("events").EventEmitter;
  var util = import.meta.require("util");
  var ConnectionParameters = require_connection_parameters();
  var NativeQuery = require_query4();
  var Client = module.exports = function(config5) {
    EventEmitter23.call(this);
    config5 = config5 || {};
    this._Promise = config5.Promise || global.Promise;
    this._types = new TypeOverrides(config5.types);
    this.native = new Native({
      types: this._types
    });
    this._queryQueue = [];
    this._ending = false;
    this._connecting = false;
    this._connected = false;
    this._queryable = true;
    var cp = this.connectionParameters = new ConnectionParameters(config5);
    if (config5.nativeConnectionString)
      cp.nativeConnectionString = config5.nativeConnectionString;
    this.user = cp.user;
    Object.defineProperty(this, "password", {
      configurable: true,
      enumerable: false,
      writable: true,
      value: cp.password
    });
    this.database = cp.database;
    this.host = cp.host;
    this.port = cp.port;
    this.namedQueries = {};
  };
  Client.Query = NativeQuery;
  util.inherits(Client, EventEmitter23);
  Client.prototype._errorAllQueries = function(err22) {
    const enqueueError = (query) => {
      process.nextTick(() => {
        query.native = this.native;
        query.handleError(err22);
      });
    };
    if (this._hasActiveQuery()) {
      enqueueError(this._activeQuery);
      this._activeQuery = null;
    }
    this._queryQueue.forEach(enqueueError);
    this._queryQueue.length = 0;
  };
  Client.prototype._connect = function(cb) {
    var self2 = this;
    if (this._connecting) {
      process.nextTick(() => cb(new Error("Client has already been connected. You cannot reuse a client.")));
      return;
    }
    this._connecting = true;
    this.connectionParameters.getLibpqConnectionString(function(err22, conString) {
      if (self2.connectionParameters.nativeConnectionString)
        conString = self2.connectionParameters.nativeConnectionString;
      if (err22)
        return cb(err22);
      self2.native.connect(conString, function(err3) {
        if (err3) {
          self2.native.end();
          return cb(err3);
        }
        self2._connected = true;
        self2.native.on("error", function(err4) {
          self2._queryable = false;
          self2._errorAllQueries(err4);
          self2.emit("error", err4);
        });
        self2.native.on("notification", function(msg) {
          self2.emit("notification", {
            channel: msg.relname,
            payload: msg.extra
          });
        });
        self2.emit("connect");
        self2._pulseQueryQueue(true);
        cb();
      });
    });
  };
  Client.prototype.connect = function(callback) {
    if (callback) {
      this._connect(callback);
      return;
    }
    return new this._Promise((resolve5, reject) => {
      this._connect((error) => {
        if (error) {
          reject(error);
        } else {
          resolve5();
        }
      });
    });
  };
  Client.prototype.query = function(config5, values3, callback) {
    var query;
    var result2;
    var readTimeout;
    var readTimeoutTimer;
    var queryCallback;
    if (config5 === null || config5 === undefined) {
      throw new TypeError("Client was passed a null or undefined query");
    } else if (typeof config5.submit === "function") {
      readTimeout = config5.query_timeout || this.connectionParameters.query_timeout;
      result2 = query = config5;
      if (typeof values3 === "function") {
        config5.callback = values3;
      }
    } else {
      readTimeout = config5.query_timeout || this.connectionParameters.query_timeout;
      query = new NativeQuery(config5, values3, callback);
      if (!query.callback) {
        let resolveOut, rejectOut;
        result2 = new this._Promise((resolve5, reject) => {
          resolveOut = resolve5;
          rejectOut = reject;
        }).catch((err22) => {
          Error.captureStackTrace(err22);
          throw err22;
        });
        query.callback = (err22, res) => err22 ? rejectOut(err22) : resolveOut(res);
      }
    }
    if (readTimeout) {
      queryCallback = query.callback;
      readTimeoutTimer = setTimeout(() => {
        var error = new Error("Query read timeout");
        process.nextTick(() => {
          query.handleError(error, this.connection);
        });
        queryCallback(error);
        query.callback = () => {
        };
        var index = this._queryQueue.indexOf(query);
        if (index > -1) {
          this._queryQueue.splice(index, 1);
        }
        this._pulseQueryQueue();
      }, readTimeout);
      query.callback = (err22, res) => {
        clearTimeout(readTimeoutTimer);
        queryCallback(err22, res);
      };
    }
    if (!this._queryable) {
      query.native = this.native;
      process.nextTick(() => {
        query.handleError(new Error("Client has encountered a connection error and is not queryable"));
      });
      return result2;
    }
    if (this._ending) {
      query.native = this.native;
      process.nextTick(() => {
        query.handleError(new Error("Client was closed and is not queryable"));
      });
      return result2;
    }
    this._queryQueue.push(query);
    this._pulseQueryQueue();
    return result2;
  };
  Client.prototype.end = function(cb) {
    var self2 = this;
    this._ending = true;
    if (!this._connected) {
      this.once("connect", this.end.bind(this, cb));
    }
    var result2;
    if (!cb) {
      result2 = new this._Promise(function(resolve5, reject) {
        cb = (err22) => err22 ? reject(err22) : resolve5();
      });
    }
    this.native.end(function() {
      self2._errorAllQueries(new Error("Connection terminated"));
      process.nextTick(() => {
        self2.emit("end");
        if (cb)
          cb();
      });
    });
    return result2;
  };
  Client.prototype._hasActiveQuery = function() {
    return this._activeQuery && this._activeQuery.state !== "error" && this._activeQuery.state !== "end";
  };
  Client.prototype._pulseQueryQueue = function(initialConnection) {
    if (!this._connected) {
      return;
    }
    if (this._hasActiveQuery()) {
      return;
    }
    var query = this._queryQueue.shift();
    if (!query) {
      if (!initialConnection) {
        this.emit("drain");
      }
      return;
    }
    this._activeQuery = query;
    query.submit(this);
    var self2 = this;
    query.once("_done", function() {
      self2._pulseQueryQueue();
    });
  };
  Client.prototype.cancel = function(query) {
    if (this._activeQuery === query) {
      this.native.cancel(function() {
      });
    } else if (this._queryQueue.indexOf(query) !== -1) {
      this._queryQueue.splice(this._queryQueue.indexOf(query), 1);
    }
  };
  Client.prototype.ref = function() {
  };
  Client.prototype.unref = function() {
  };
  Client.prototype.setTypeParser = function(oid, format, parseFn) {
    return this._types.setTypeParser(oid, format, parseFn);
  };
  Client.prototype.getTypeParser = function(oid, format) {
    return this._types.getTypeParser(oid, format);
  };
});
var require_lib18 = __commonJS2((exports, module) => {
  var Client = require_client2();
  var defaults3 = require_defaults2();
  var Connection = require_connection2();
  var Pool = require_pg_pool();
  var { DatabaseError } = require_dist22();
  var { escapeIdentifier, escapeLiteral } = require_utils5();
  var poolFactory = (Client2) => {
    return class BoundPool extends Pool {
      constructor(options3) {
        super(options3, Client2);
      }
    };
  };
  var PG = function(clientConstructor) {
    this.defaults = defaults3;
    this.Client = clientConstructor;
    this.Query = this.Client.Query;
    this.Pool = poolFactory(this.Client);
    this._pools = [];
    this.Connection = Connection;
    this.types = require_pg_types();
    this.DatabaseError = DatabaseError;
    this.escapeIdentifier = escapeIdentifier;
    this.escapeLiteral = escapeLiteral;
  };
  if (typeof process.env.NODE_PG_FORCE_NATIVE !== "undefined") {
    module.exports = new PG(require_client3());
  } else {
    module.exports = new PG(Client);
    Object.defineProperty(module.exports, "native", {
      configurable: true,
      enumerable: false,
      get() {
        var native = null;
        try {
          native = new PG(require_client3());
        } catch (err22) {
          if (err22.code !== "MODULE_NOT_FOUND") {
            throw err22;
          }
        }
        Object.defineProperty(module.exports, "native", {
          value: native
        });
        return native;
      }
    });
  }
});
function getDialect() {
  const driver2 = database22.default ?? "sqlite";
  log2.debug(`Using database driver: ${driver2}`);
  if (driver2 === "sqlite") {
    const defaultName = appEnv !== "testing" ? "database/stacks.sqlite" : "database/stacks_testing.sqlite";
    const sqliteDbName = database22.connections?.sqlite.database ?? defaultName;
    const dbPath = path2.projectPath(sqliteDbName);
    return new BunWorkerDialect({
      url: dbPath
    });
  }
  if (driver2 === "mysql") {
    return new MysqlDialect({
      pool: import_mysql2.createPool({
        database: database22.connections?.mysql?.name || "stacks",
        host: database22.connections?.mysql?.host ?? "127.0.0.1",
        user: database22.connections?.mysql?.username ?? "root",
        password: database22.connections?.mysql?.password ?? "",
        port: database22.connections?.mysql?.port ?? 3306
      })
    });
  }
  if (driver2 === "postgres") {
    const pgDbName = database22.connections?.postgres?.name ?? "stacks";
    const finalPgDbName = appEnv === "testing" ? `${pgDbName}_testing` : pgDbName;
    return new PostgresDialect({
      pool: new import_pg.Pool({
        database: finalPgDbName,
        host: database22.connections?.postgres?.host ?? "127.0.0.1",
        user: database22.connections?.postgres?.username ?? "",
        password: database22.connections?.postgres?.password ?? "",
        port: database22.connections?.postgres?.port ?? 5432
      })
    });
  }
  throw new Error(`Unsupported driver: ${driver2}`);
}
var import_mysql2;
var import_pg;
var appEnv;
var now;
var db;
var init_utils9 = __esm2(() => {
  init_src6();
  init_src8();
  init_src11();
  init_esm2();
  init_dist4();
  import_mysql2 = __toESM3(require_mysql2(), 1);
  import_pg = __toESM3(require_lib18(), 1);
  appEnv = app22.env || "local";
  now = sql`now()`;
  db = new Kysely({
    dialect: getDialect()
  });
});
var driver2;
var migrator2;
var init_migrations = __esm2(() => {
  init_src10();
  init_src6();
  init_src7();
  init_src11();
  init_src23();
  init_esm2();
  init_drivers();
  init_utils9();
  driver2 = database22.default || "";
  migrator2 = new Migrator({
    db,
    provider: new FileMigrationProvider({
      fs: fs2,
      path: path2,
      migrationFolder: path2.userMigrationsPath()
    }),
    migrationTableName: database22.migrations,
    migrationLockTableName: database22.migrationLocks
  });
});
var init_table = __esm2(() => {
  init_src8();
});
var init_schema3 = __esm2(() => {
  init_src8();
  init_table();
});
var require_core5 = __commonJS2((exports, module) => {
  (function(root, factory) {
    if (typeof exports === "object") {
      module.exports = exports = factory();
    } else if (typeof define === "function" && define.amd) {
      define([], factory);
    } else {
      root.CryptoJS = factory();
    }
  })(exports, function() {
    var CryptoJS = CryptoJS || function(Math2, undefined2) {
      var crypto;
      if (typeof window !== "undefined" && window.crypto) {
        crypto = window.crypto;
      }
      if (typeof self !== "undefined" && self.crypto) {
        crypto = self.crypto;
      }
      if (typeof globalThis !== "undefined" && globalThis.crypto) {
        crypto = globalThis.crypto;
      }
      if (!crypto && typeof window !== "undefined" && window.msCrypto) {
        crypto = window.msCrypto;
      }
      if (!crypto && typeof global !== "undefined" && global.crypto) {
        crypto = global.crypto;
      }
      if (!crypto && true) {
        try {
          crypto = import.meta.require("crypto");
        } catch (err22) {
        }
      }
      var cryptoSecureRandomInt = function() {
        if (crypto) {
          if (typeof crypto.getRandomValues === "function") {
            try {
              return crypto.getRandomValues(new Uint32Array(1))[0];
            } catch (err22) {
            }
          }
          if (typeof crypto.randomBytes === "function") {
            try {
              return crypto.randomBytes(4).readInt32LE();
            } catch (err22) {
            }
          }
        }
        throw new Error("Native crypto module could not be used to get secure random number.");
      };
      var create = Object.create || function() {
        function F() {
        }
        return function(obj) {
          var subtype;
          F.prototype = obj;
          subtype = new F;
          F.prototype = null;
          return subtype;
        };
      }();
      var C2 = {};
      var C_lib = C2.lib = {};
      var Base = C_lib.Base = function() {
        return {
          extend: function(overrides) {
            var subtype = create(this);
            if (overrides) {
              subtype.mixIn(overrides);
            }
            if (!subtype.hasOwnProperty("init") || this.init === subtype.init) {
              subtype.init = function() {
                subtype.$super.init.apply(this, arguments);
              };
            }
            subtype.init.prototype = subtype;
            subtype.$super = this;
            return subtype;
          },
          create: function() {
            var instance = this.extend();
            instance.init.apply(instance, arguments);
            return instance;
          },
          init: function() {
          },
          mixIn: function(properties) {
            for (var propertyName in properties) {
              if (properties.hasOwnProperty(propertyName)) {
                this[propertyName] = properties[propertyName];
              }
            }
            if (properties.hasOwnProperty("toString")) {
              this.toString = properties.toString;
            }
          },
          clone: function() {
            return this.init.prototype.extend(this);
          }
        };
      }();
      var WordArray = C_lib.WordArray = Base.extend({
        init: function(words, sigBytes) {
          words = this.words = words || [];
          if (sigBytes != undefined2) {
            this.sigBytes = sigBytes;
          } else {
            this.sigBytes = words.length * 4;
          }
        },
        toString: function(encoder) {
          return (encoder || Hex).stringify(this);
        },
        concat: function(wordArray) {
          var thisWords = this.words;
          var thatWords = wordArray.words;
          var thisSigBytes = this.sigBytes;
          var thatSigBytes = wordArray.sigBytes;
          this.clamp();
          if (thisSigBytes % 4) {
            for (var i2 = 0;i2 < thatSigBytes; i2++) {
              var thatByte = thatWords[i2 >>> 2] >>> 24 - i2 % 4 * 8 & 255;
              thisWords[thisSigBytes + i2 >>> 2] |= thatByte << 24 - (thisSigBytes + i2) % 4 * 8;
            }
          } else {
            for (var j22 = 0;j22 < thatSigBytes; j22 += 4) {
              thisWords[thisSigBytes + j22 >>> 2] = thatWords[j22 >>> 2];
            }
          }
          this.sigBytes += thatSigBytes;
          return this;
        },
        clamp: function() {
          var words = this.words;
          var sigBytes = this.sigBytes;
          words[sigBytes >>> 2] &= 4294967295 << 32 - sigBytes % 4 * 8;
          words.length = Math2.ceil(sigBytes / 4);
        },
        clone: function() {
          var clone3 = Base.clone.call(this);
          clone3.words = this.words.slice(0);
          return clone3;
        },
        random: function(nBytes) {
          var words = [];
          for (var i2 = 0;i2 < nBytes; i2 += 4) {
            words.push(cryptoSecureRandomInt());
          }
          return new WordArray.init(words, nBytes);
        }
      });
      var C_enc = C2.enc = {};
      var Hex = C_enc.Hex = {
        stringify: function(wordArray) {
          var words = wordArray.words;
          var sigBytes = wordArray.sigBytes;
          var hexChars = [];
          for (var i2 = 0;i2 < sigBytes; i2++) {
            var bite = words[i2 >>> 2] >>> 24 - i2 % 4 * 8 & 255;
            hexChars.push((bite >>> 4).toString(16));
            hexChars.push((bite & 15).toString(16));
          }
          return hexChars.join("");
        },
        parse: function(hexStr) {
          var hexStrLength = hexStr.length;
          var words = [];
          for (var i2 = 0;i2 < hexStrLength; i2 += 2) {
            words[i2 >>> 3] |= parseInt(hexStr.substr(i2, 2), 16) << 24 - i2 % 8 * 4;
          }
          return new WordArray.init(words, hexStrLength / 2);
        }
      };
      var Latin1 = C_enc.Latin1 = {
        stringify: function(wordArray) {
          var words = wordArray.words;
          var sigBytes = wordArray.sigBytes;
          var latin1Chars = [];
          for (var i2 = 0;i2 < sigBytes; i2++) {
            var bite = words[i2 >>> 2] >>> 24 - i2 % 4 * 8 & 255;
            latin1Chars.push(String.fromCharCode(bite));
          }
          return latin1Chars.join("");
        },
        parse: function(latin1Str) {
          var latin1StrLength = latin1Str.length;
          var words = [];
          for (var i2 = 0;i2 < latin1StrLength; i2++) {
            words[i2 >>> 2] |= (latin1Str.charCodeAt(i2) & 255) << 24 - i2 % 4 * 8;
          }
          return new WordArray.init(words, latin1StrLength);
        }
      };
      var Utf8 = C_enc.Utf8 = {
        stringify: function(wordArray) {
          try {
            return decodeURIComponent(escape(Latin1.stringify(wordArray)));
          } catch (e) {
            throw new Error("Malformed UTF-8 data");
          }
        },
        parse: function(utf8Str) {
          return Latin1.parse(unescape(encodeURIComponent(utf8Str)));
        }
      };
      var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm = Base.extend({
        reset: function() {
          this._data = new WordArray.init;
          this._nDataBytes = 0;
        },
        _append: function(data2) {
          if (typeof data2 == "string") {
            data2 = Utf8.parse(data2);
          }
          this._data.concat(data2);
          this._nDataBytes += data2.sigBytes;
        },
        _process: function(doFlush) {
          var processedWords;
          var data2 = this._data;
          var dataWords = data2.words;
          var dataSigBytes = data2.sigBytes;
          var blockSize = this.blockSize;
          var blockSizeBytes = blockSize * 4;
          var nBlocksReady = dataSigBytes / blockSizeBytes;
          if (doFlush) {
            nBlocksReady = Math2.ceil(nBlocksReady);
          } else {
            nBlocksReady = Math2.max((nBlocksReady | 0) - this._minBufferSize, 0);
          }
          var nWordsReady = nBlocksReady * blockSize;
          var nBytesReady = Math2.min(nWordsReady * 4, dataSigBytes);
          if (nWordsReady) {
            for (var offset2 = 0;offset2 < nWordsReady; offset2 += blockSize) {
              this._doProcessBlock(dataWords, offset2);
            }
            processedWords = dataWords.splice(0, nWordsReady);
            data2.sigBytes -= nBytesReady;
          }
          return new WordArray.init(processedWords, nBytesReady);
        },
        clone: function() {
          var clone3 = Base.clone.call(this);
          clone3._data = this._data.clone();
          return clone3;
        },
        _minBufferSize: 0
      });
      var Hasher = C_lib.Hasher = BufferedBlockAlgorithm.extend({
        cfg: Base.extend(),
        init: function(cfg) {
          this.cfg = this.cfg.extend(cfg);
          this.reset();
        },
        reset: function() {
          BufferedBlockAlgorithm.reset.call(this);
          this._doReset();
        },
        update: function(messageUpdate) {
          this._append(messageUpdate);
          this._process();
          return this;
        },
        finalize: function(messageUpdate) {
          if (messageUpdate) {
            this._append(messageUpdate);
          }
          var hash = this._doFinalize();
          return hash;
        },
        blockSize: 16,
        _createHelper: function(hasher) {
          return function(message, cfg) {
            return new hasher.init(cfg).finalize(message);
          };
        },
        _createHmacHelper: function(hasher) {
          return function(message, key) {
            return new C_algo.HMAC.init(hasher, key).finalize(message);
          };
        }
      });
      var C_algo = C2.algo = {};
      return C2;
    }(Math);
    return CryptoJS;
  });
});
var require_enc_base64 = __commonJS2((exports, module) => {
  (function(root, factory) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5());
    } else if (typeof define === "function" && define.amd) {
      define(["./core"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    (function() {
      var C2 = CryptoJS;
      var C_lib = C2.lib;
      var WordArray = C_lib.WordArray;
      var C_enc = C2.enc;
      var Base64 = C_enc.Base64 = {
        stringify: function(wordArray) {
          var words = wordArray.words;
          var sigBytes = wordArray.sigBytes;
          var map = this._map;
          wordArray.clamp();
          var base64Chars = [];
          for (var i2 = 0;i2 < sigBytes; i2 += 3) {
            var byte1 = words[i2 >>> 2] >>> 24 - i2 % 4 * 8 & 255;
            var byte2 = words[i2 + 1 >>> 2] >>> 24 - (i2 + 1) % 4 * 8 & 255;
            var byte3 = words[i2 + 2 >>> 2] >>> 24 - (i2 + 2) % 4 * 8 & 255;
            var triplet = byte1 << 16 | byte2 << 8 | byte3;
            for (var j22 = 0;j22 < 4 && i2 + j22 * 0.75 < sigBytes; j22++) {
              base64Chars.push(map.charAt(triplet >>> 6 * (3 - j22) & 63));
            }
          }
          var paddingChar = map.charAt(64);
          if (paddingChar) {
            while (base64Chars.length % 4) {
              base64Chars.push(paddingChar);
            }
          }
          return base64Chars.join("");
        },
        parse: function(base64Str) {
          var base64StrLength = base64Str.length;
          var map = this._map;
          var reverseMap = this._reverseMap;
          if (!reverseMap) {
            reverseMap = this._reverseMap = [];
            for (var j22 = 0;j22 < map.length; j22++) {
              reverseMap[map.charCodeAt(j22)] = j22;
            }
          }
          var paddingChar = map.charAt(64);
          if (paddingChar) {
            var paddingIndex = base64Str.indexOf(paddingChar);
            if (paddingIndex !== -1) {
              base64StrLength = paddingIndex;
            }
          }
          return parseLoop(base64Str, base64StrLength, reverseMap);
        },
        _map: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
      };
      function parseLoop(base64Str, base64StrLength, reverseMap) {
        var words = [];
        var nBytes = 0;
        for (var i2 = 0;i2 < base64StrLength; i2++) {
          if (i2 % 4) {
            var bits1 = reverseMap[base64Str.charCodeAt(i2 - 1)] << i2 % 4 * 2;
            var bits2 = reverseMap[base64Str.charCodeAt(i2)] >>> 6 - i2 % 4 * 2;
            var bitsCombined = bits1 | bits2;
            words[nBytes >>> 2] |= bitsCombined << 24 - nBytes % 4 * 8;
            nBytes++;
          }
        }
        return WordArray.create(words, nBytes);
      }
    })();
    return CryptoJS.enc.Base64;
  });
});
var require_md5 = __commonJS2((exports, module) => {
  (function(root, factory) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5());
    } else if (typeof define === "function" && define.amd) {
      define(["./core"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    (function(Math2) {
      var C2 = CryptoJS;
      var C_lib = C2.lib;
      var WordArray = C_lib.WordArray;
      var Hasher = C_lib.Hasher;
      var C_algo = C2.algo;
      var T22 = [];
      (function() {
        for (var i2 = 0;i2 < 64; i2++) {
          T22[i2] = Math2.abs(Math2.sin(i2 + 1)) * 4294967296 | 0;
        }
      })();
      var MD5 = C_algo.MD5 = Hasher.extend({
        _doReset: function() {
          this._hash = new WordArray.init([
            1732584193,
            4023233417,
            2562383102,
            271733878
          ]);
        },
        _doProcessBlock: function(M22, offset2) {
          for (var i2 = 0;i2 < 16; i2++) {
            var offset_i = offset2 + i2;
            var M_offset_i = M22[offset_i];
            M22[offset_i] = (M_offset_i << 8 | M_offset_i >>> 24) & 16711935 | (M_offset_i << 24 | M_offset_i >>> 8) & 4278255360;
          }
          var H22 = this._hash.words;
          var M_offset_0 = M22[offset2 + 0];
          var M_offset_1 = M22[offset2 + 1];
          var M_offset_2 = M22[offset2 + 2];
          var M_offset_3 = M22[offset2 + 3];
          var M_offset_4 = M22[offset2 + 4];
          var M_offset_5 = M22[offset2 + 5];
          var M_offset_6 = M22[offset2 + 6];
          var M_offset_7 = M22[offset2 + 7];
          var M_offset_8 = M22[offset2 + 8];
          var M_offset_9 = M22[offset2 + 9];
          var M_offset_10 = M22[offset2 + 10];
          var M_offset_11 = M22[offset2 + 11];
          var M_offset_12 = M22[offset2 + 12];
          var M_offset_13 = M22[offset2 + 13];
          var M_offset_14 = M22[offset2 + 14];
          var M_offset_15 = M22[offset2 + 15];
          var a = H22[0];
          var b22 = H22[1];
          var c22 = H22[2];
          var d = H22[3];
          a = FF(a, b22, c22, d, M_offset_0, 7, T22[0]);
          d = FF(d, a, b22, c22, M_offset_1, 12, T22[1]);
          c22 = FF(c22, d, a, b22, M_offset_2, 17, T22[2]);
          b22 = FF(b22, c22, d, a, M_offset_3, 22, T22[3]);
          a = FF(a, b22, c22, d, M_offset_4, 7, T22[4]);
          d = FF(d, a, b22, c22, M_offset_5, 12, T22[5]);
          c22 = FF(c22, d, a, b22, M_offset_6, 17, T22[6]);
          b22 = FF(b22, c22, d, a, M_offset_7, 22, T22[7]);
          a = FF(a, b22, c22, d, M_offset_8, 7, T22[8]);
          d = FF(d, a, b22, c22, M_offset_9, 12, T22[9]);
          c22 = FF(c22, d, a, b22, M_offset_10, 17, T22[10]);
          b22 = FF(b22, c22, d, a, M_offset_11, 22, T22[11]);
          a = FF(a, b22, c22, d, M_offset_12, 7, T22[12]);
          d = FF(d, a, b22, c22, M_offset_13, 12, T22[13]);
          c22 = FF(c22, d, a, b22, M_offset_14, 17, T22[14]);
          b22 = FF(b22, c22, d, a, M_offset_15, 22, T22[15]);
          a = GG(a, b22, c22, d, M_offset_1, 5, T22[16]);
          d = GG(d, a, b22, c22, M_offset_6, 9, T22[17]);
          c22 = GG(c22, d, a, b22, M_offset_11, 14, T22[18]);
          b22 = GG(b22, c22, d, a, M_offset_0, 20, T22[19]);
          a = GG(a, b22, c22, d, M_offset_5, 5, T22[20]);
          d = GG(d, a, b22, c22, M_offset_10, 9, T22[21]);
          c22 = GG(c22, d, a, b22, M_offset_15, 14, T22[22]);
          b22 = GG(b22, c22, d, a, M_offset_4, 20, T22[23]);
          a = GG(a, b22, c22, d, M_offset_9, 5, T22[24]);
          d = GG(d, a, b22, c22, M_offset_14, 9, T22[25]);
          c22 = GG(c22, d, a, b22, M_offset_3, 14, T22[26]);
          b22 = GG(b22, c22, d, a, M_offset_8, 20, T22[27]);
          a = GG(a, b22, c22, d, M_offset_13, 5, T22[28]);
          d = GG(d, a, b22, c22, M_offset_2, 9, T22[29]);
          c22 = GG(c22, d, a, b22, M_offset_7, 14, T22[30]);
          b22 = GG(b22, c22, d, a, M_offset_12, 20, T22[31]);
          a = HH(a, b22, c22, d, M_offset_5, 4, T22[32]);
          d = HH(d, a, b22, c22, M_offset_8, 11, T22[33]);
          c22 = HH(c22, d, a, b22, M_offset_11, 16, T22[34]);
          b22 = HH(b22, c22, d, a, M_offset_14, 23, T22[35]);
          a = HH(a, b22, c22, d, M_offset_1, 4, T22[36]);
          d = HH(d, a, b22, c22, M_offset_4, 11, T22[37]);
          c22 = HH(c22, d, a, b22, M_offset_7, 16, T22[38]);
          b22 = HH(b22, c22, d, a, M_offset_10, 23, T22[39]);
          a = HH(a, b22, c22, d, M_offset_13, 4, T22[40]);
          d = HH(d, a, b22, c22, M_offset_0, 11, T22[41]);
          c22 = HH(c22, d, a, b22, M_offset_3, 16, T22[42]);
          b22 = HH(b22, c22, d, a, M_offset_6, 23, T22[43]);
          a = HH(a, b22, c22, d, M_offset_9, 4, T22[44]);
          d = HH(d, a, b22, c22, M_offset_12, 11, T22[45]);
          c22 = HH(c22, d, a, b22, M_offset_15, 16, T22[46]);
          b22 = HH(b22, c22, d, a, M_offset_2, 23, T22[47]);
          a = II(a, b22, c22, d, M_offset_0, 6, T22[48]);
          d = II(d, a, b22, c22, M_offset_7, 10, T22[49]);
          c22 = II(c22, d, a, b22, M_offset_14, 15, T22[50]);
          b22 = II(b22, c22, d, a, M_offset_5, 21, T22[51]);
          a = II(a, b22, c22, d, M_offset_12, 6, T22[52]);
          d = II(d, a, b22, c22, M_offset_3, 10, T22[53]);
          c22 = II(c22, d, a, b22, M_offset_10, 15, T22[54]);
          b22 = II(b22, c22, d, a, M_offset_1, 21, T22[55]);
          a = II(a, b22, c22, d, M_offset_8, 6, T22[56]);
          d = II(d, a, b22, c22, M_offset_15, 10, T22[57]);
          c22 = II(c22, d, a, b22, M_offset_6, 15, T22[58]);
          b22 = II(b22, c22, d, a, M_offset_13, 21, T22[59]);
          a = II(a, b22, c22, d, M_offset_4, 6, T22[60]);
          d = II(d, a, b22, c22, M_offset_11, 10, T22[61]);
          c22 = II(c22, d, a, b22, M_offset_2, 15, T22[62]);
          b22 = II(b22, c22, d, a, M_offset_9, 21, T22[63]);
          H22[0] = H22[0] + a | 0;
          H22[1] = H22[1] + b22 | 0;
          H22[2] = H22[2] + c22 | 0;
          H22[3] = H22[3] + d | 0;
        },
        _doFinalize: function() {
          var data2 = this._data;
          var dataWords = data2.words;
          var nBitsTotal = this._nDataBytes * 8;
          var nBitsLeft = data2.sigBytes * 8;
          dataWords[nBitsLeft >>> 5] |= 128 << 24 - nBitsLeft % 32;
          var nBitsTotalH = Math2.floor(nBitsTotal / 4294967296);
          var nBitsTotalL = nBitsTotal;
          dataWords[(nBitsLeft + 64 >>> 9 << 4) + 15] = (nBitsTotalH << 8 | nBitsTotalH >>> 24) & 16711935 | (nBitsTotalH << 24 | nBitsTotalH >>> 8) & 4278255360;
          dataWords[(nBitsLeft + 64 >>> 9 << 4) + 14] = (nBitsTotalL << 8 | nBitsTotalL >>> 24) & 16711935 | (nBitsTotalL << 24 | nBitsTotalL >>> 8) & 4278255360;
          data2.sigBytes = (dataWords.length + 1) * 4;
          this._process();
          var hash = this._hash;
          var H22 = hash.words;
          for (var i2 = 0;i2 < 4; i2++) {
            var H_i = H22[i2];
            H22[i2] = (H_i << 8 | H_i >>> 24) & 16711935 | (H_i << 24 | H_i >>> 8) & 4278255360;
          }
          return hash;
        },
        clone: function() {
          var clone3 = Hasher.clone.call(this);
          clone3._hash = this._hash.clone();
          return clone3;
        }
      });
      function FF(a, b22, c22, d, x, s32, t) {
        var n = a + (b22 & c22 | ~b22 & d) + x + t;
        return (n << s32 | n >>> 32 - s32) + b22;
      }
      function GG(a, b22, c22, d, x, s32, t) {
        var n = a + (b22 & d | c22 & ~d) + x + t;
        return (n << s32 | n >>> 32 - s32) + b22;
      }
      function HH(a, b22, c22, d, x, s32, t) {
        var n = a + (b22 ^ c22 ^ d) + x + t;
        return (n << s32 | n >>> 32 - s32) + b22;
      }
      function II(a, b22, c22, d, x, s32, t) {
        var n = a + (c22 ^ (b22 | ~d)) + x + t;
        return (n << s32 | n >>> 32 - s32) + b22;
      }
      C2.MD5 = Hasher._createHelper(MD5);
      C2.HmacMD5 = Hasher._createHmacHelper(MD5);
    })(Math);
    return CryptoJS.MD5;
  });
});
var require_sha1 = __commonJS2((exports, module) => {
  (function(root, factory) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5());
    } else if (typeof define === "function" && define.amd) {
      define(["./core"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    (function() {
      var C2 = CryptoJS;
      var C_lib = C2.lib;
      var WordArray = C_lib.WordArray;
      var Hasher = C_lib.Hasher;
      var C_algo = C2.algo;
      var W22 = [];
      var SHA1 = C_algo.SHA1 = Hasher.extend({
        _doReset: function() {
          this._hash = new WordArray.init([
            1732584193,
            4023233417,
            2562383102,
            271733878,
            3285377520
          ]);
        },
        _doProcessBlock: function(M22, offset2) {
          var H22 = this._hash.words;
          var a = H22[0];
          var b22 = H22[1];
          var c22 = H22[2];
          var d = H22[3];
          var e = H22[4];
          for (var i2 = 0;i2 < 80; i2++) {
            if (i2 < 16) {
              W22[i2] = M22[offset2 + i2] | 0;
            } else {
              var n = W22[i2 - 3] ^ W22[i2 - 8] ^ W22[i2 - 14] ^ W22[i2 - 16];
              W22[i2] = n << 1 | n >>> 31;
            }
            var t = (a << 5 | a >>> 27) + e + W22[i2];
            if (i2 < 20) {
              t += (b22 & c22 | ~b22 & d) + 1518500249;
            } else if (i2 < 40) {
              t += (b22 ^ c22 ^ d) + 1859775393;
            } else if (i2 < 60) {
              t += (b22 & c22 | b22 & d | c22 & d) - 1894007588;
            } else {
              t += (b22 ^ c22 ^ d) - 899497514;
            }
            e = d;
            d = c22;
            c22 = b22 << 30 | b22 >>> 2;
            b22 = a;
            a = t;
          }
          H22[0] = H22[0] + a | 0;
          H22[1] = H22[1] + b22 | 0;
          H22[2] = H22[2] + c22 | 0;
          H22[3] = H22[3] + d | 0;
          H22[4] = H22[4] + e | 0;
        },
        _doFinalize: function() {
          var data2 = this._data;
          var dataWords = data2.words;
          var nBitsTotal = this._nDataBytes * 8;
          var nBitsLeft = data2.sigBytes * 8;
          dataWords[nBitsLeft >>> 5] |= 128 << 24 - nBitsLeft % 32;
          dataWords[(nBitsLeft + 64 >>> 9 << 4) + 14] = Math.floor(nBitsTotal / 4294967296);
          dataWords[(nBitsLeft + 64 >>> 9 << 4) + 15] = nBitsTotal;
          data2.sigBytes = dataWords.length * 4;
          this._process();
          return this._hash;
        },
        clone: function() {
          var clone3 = Hasher.clone.call(this);
          clone3._hash = this._hash.clone();
          return clone3;
        }
      });
      C2.SHA1 = Hasher._createHelper(SHA1);
      C2.HmacSHA1 = Hasher._createHmacHelper(SHA1);
    })();
    return CryptoJS.SHA1;
  });
});
var require_hmac = __commonJS2((exports, module) => {
  (function(root, factory) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5());
    } else if (typeof define === "function" && define.amd) {
      define(["./core"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    (function() {
      var C2 = CryptoJS;
      var C_lib = C2.lib;
      var Base = C_lib.Base;
      var C_enc = C2.enc;
      var Utf8 = C_enc.Utf8;
      var C_algo = C2.algo;
      var HMAC = C_algo.HMAC = Base.extend({
        init: function(hasher, key) {
          hasher = this._hasher = new hasher.init;
          if (typeof key == "string") {
            key = Utf8.parse(key);
          }
          var hasherBlockSize = hasher.blockSize;
          var hasherBlockSizeBytes = hasherBlockSize * 4;
          if (key.sigBytes > hasherBlockSizeBytes) {
            key = hasher.finalize(key);
          }
          key.clamp();
          var oKey = this._oKey = key.clone();
          var iKey = this._iKey = key.clone();
          var oKeyWords = oKey.words;
          var iKeyWords = iKey.words;
          for (var i2 = 0;i2 < hasherBlockSize; i2++) {
            oKeyWords[i2] ^= 1549556828;
            iKeyWords[i2] ^= 909522486;
          }
          oKey.sigBytes = iKey.sigBytes = hasherBlockSizeBytes;
          this.reset();
        },
        reset: function() {
          var hasher = this._hasher;
          hasher.reset();
          hasher.update(this._iKey);
        },
        update: function(messageUpdate) {
          this._hasher.update(messageUpdate);
          return this;
        },
        finalize: function(messageUpdate) {
          var hasher = this._hasher;
          var innerHash = hasher.finalize(messageUpdate);
          hasher.reset();
          var hmac = hasher.finalize(this._oKey.clone().concat(innerHash));
          return hmac;
        }
      });
    })();
  });
});
var require_evpkdf = __commonJS2((exports, module) => {
  (function(root, factory, undef) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5(), require_sha1(), require_hmac());
    } else if (typeof define === "function" && define.amd) {
      define(["./core", "./sha1", "./hmac"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    (function() {
      var C2 = CryptoJS;
      var C_lib = C2.lib;
      var Base = C_lib.Base;
      var WordArray = C_lib.WordArray;
      var C_algo = C2.algo;
      var MD5 = C_algo.MD5;
      var EvpKDF = C_algo.EvpKDF = Base.extend({
        cfg: Base.extend({
          keySize: 4,
          hasher: MD5,
          iterations: 1
        }),
        init: function(cfg) {
          this.cfg = this.cfg.extend(cfg);
        },
        compute: function(password, salt) {
          var block;
          var cfg = this.cfg;
          var hasher = cfg.hasher.create();
          var derivedKey = WordArray.create();
          var derivedKeyWords = derivedKey.words;
          var keySize = cfg.keySize;
          var iterations = cfg.iterations;
          while (derivedKeyWords.length < keySize) {
            if (block) {
              hasher.update(block);
            }
            block = hasher.update(password).finalize(salt);
            hasher.reset();
            for (var i2 = 1;i2 < iterations; i2++) {
              block = hasher.finalize(block);
              hasher.reset();
            }
            derivedKey.concat(block);
          }
          derivedKey.sigBytes = keySize * 4;
          return derivedKey;
        }
      });
      C2.EvpKDF = function(password, salt, cfg) {
        return EvpKDF.create(cfg).compute(password, salt);
      };
    })();
    return CryptoJS.EvpKDF;
  });
});
var require_cipher_core = __commonJS2((exports, module) => {
  (function(root, factory, undef) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5(), require_evpkdf());
    } else if (typeof define === "function" && define.amd) {
      define(["./core", "./evpkdf"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    CryptoJS.lib.Cipher || function(undefined2) {
      var C2 = CryptoJS;
      var C_lib = C2.lib;
      var Base = C_lib.Base;
      var WordArray = C_lib.WordArray;
      var BufferedBlockAlgorithm = C_lib.BufferedBlockAlgorithm;
      var C_enc = C2.enc;
      var Utf8 = C_enc.Utf8;
      var Base64 = C_enc.Base64;
      var C_algo = C2.algo;
      var EvpKDF = C_algo.EvpKDF;
      var Cipher = C_lib.Cipher = BufferedBlockAlgorithm.extend({
        cfg: Base.extend(),
        createEncryptor: function(key, cfg) {
          return this.create(this._ENC_XFORM_MODE, key, cfg);
        },
        createDecryptor: function(key, cfg) {
          return this.create(this._DEC_XFORM_MODE, key, cfg);
        },
        init: function(xformMode, key, cfg) {
          this.cfg = this.cfg.extend(cfg);
          this._xformMode = xformMode;
          this._key = key;
          this.reset();
        },
        reset: function() {
          BufferedBlockAlgorithm.reset.call(this);
          this._doReset();
        },
        process: function(dataUpdate) {
          this._append(dataUpdate);
          return this._process();
        },
        finalize: function(dataUpdate) {
          if (dataUpdate) {
            this._append(dataUpdate);
          }
          var finalProcessedData = this._doFinalize();
          return finalProcessedData;
        },
        keySize: 4,
        ivSize: 4,
        _ENC_XFORM_MODE: 1,
        _DEC_XFORM_MODE: 2,
        _createHelper: function() {
          function selectCipherStrategy(key) {
            if (typeof key == "string") {
              return PasswordBasedCipher;
            } else {
              return SerializableCipher;
            }
          }
          return function(cipher) {
            return {
              encrypt: function(message, key, cfg) {
                return selectCipherStrategy(key).encrypt(cipher, message, key, cfg);
              },
              decrypt: function(ciphertext, key, cfg) {
                return selectCipherStrategy(key).decrypt(cipher, ciphertext, key, cfg);
              }
            };
          };
        }()
      });
      var StreamCipher = C_lib.StreamCipher = Cipher.extend({
        _doFinalize: function() {
          var finalProcessedBlocks = this._process(true);
          return finalProcessedBlocks;
        },
        blockSize: 1
      });
      var C_mode = C2.mode = {};
      var BlockCipherMode = C_lib.BlockCipherMode = Base.extend({
        createEncryptor: function(cipher, iv) {
          return this.Encryptor.create(cipher, iv);
        },
        createDecryptor: function(cipher, iv) {
          return this.Decryptor.create(cipher, iv);
        },
        init: function(cipher, iv) {
          this._cipher = cipher;
          this._iv = iv;
        }
      });
      var CBC = C_mode.CBC = function() {
        var CBC2 = BlockCipherMode.extend();
        CBC2.Encryptor = CBC2.extend({
          processBlock: function(words, offset2) {
            var cipher = this._cipher;
            var blockSize = cipher.blockSize;
            xorBlock.call(this, words, offset2, blockSize);
            cipher.encryptBlock(words, offset2);
            this._prevBlock = words.slice(offset2, offset2 + blockSize);
          }
        });
        CBC2.Decryptor = CBC2.extend({
          processBlock: function(words, offset2) {
            var cipher = this._cipher;
            var blockSize = cipher.blockSize;
            var thisBlock = words.slice(offset2, offset2 + blockSize);
            cipher.decryptBlock(words, offset2);
            xorBlock.call(this, words, offset2, blockSize);
            this._prevBlock = thisBlock;
          }
        });
        function xorBlock(words, offset2, blockSize) {
          var block;
          var iv = this._iv;
          if (iv) {
            block = iv;
            this._iv = undefined2;
          } else {
            block = this._prevBlock;
          }
          for (var i2 = 0;i2 < blockSize; i2++) {
            words[offset2 + i2] ^= block[i2];
          }
        }
        return CBC2;
      }();
      var C_pad = C2.pad = {};
      var Pkcs7 = C_pad.Pkcs7 = {
        pad: function(data2, blockSize) {
          var blockSizeBytes = blockSize * 4;
          var nPaddingBytes = blockSizeBytes - data2.sigBytes % blockSizeBytes;
          var paddingWord = nPaddingBytes << 24 | nPaddingBytes << 16 | nPaddingBytes << 8 | nPaddingBytes;
          var paddingWords = [];
          for (var i2 = 0;i2 < nPaddingBytes; i2 += 4) {
            paddingWords.push(paddingWord);
          }
          var padding = WordArray.create(paddingWords, nPaddingBytes);
          data2.concat(padding);
        },
        unpad: function(data2) {
          var nPaddingBytes = data2.words[data2.sigBytes - 1 >>> 2] & 255;
          data2.sigBytes -= nPaddingBytes;
        }
      };
      var BlockCipher = C_lib.BlockCipher = Cipher.extend({
        cfg: Cipher.cfg.extend({
          mode: CBC,
          padding: Pkcs7
        }),
        reset: function() {
          var modeCreator;
          Cipher.reset.call(this);
          var cfg = this.cfg;
          var iv = cfg.iv;
          var mode = cfg.mode;
          if (this._xformMode == this._ENC_XFORM_MODE) {
            modeCreator = mode.createEncryptor;
          } else {
            modeCreator = mode.createDecryptor;
            this._minBufferSize = 1;
          }
          if (this._mode && this._mode.__creator == modeCreator) {
            this._mode.init(this, iv && iv.words);
          } else {
            this._mode = modeCreator.call(mode, this, iv && iv.words);
            this._mode.__creator = modeCreator;
          }
        },
        _doProcessBlock: function(words, offset2) {
          this._mode.processBlock(words, offset2);
        },
        _doFinalize: function() {
          var finalProcessedBlocks;
          var padding = this.cfg.padding;
          if (this._xformMode == this._ENC_XFORM_MODE) {
            padding.pad(this._data, this.blockSize);
            finalProcessedBlocks = this._process(true);
          } else {
            finalProcessedBlocks = this._process(true);
            padding.unpad(finalProcessedBlocks);
          }
          return finalProcessedBlocks;
        },
        blockSize: 4
      });
      var CipherParams = C_lib.CipherParams = Base.extend({
        init: function(cipherParams) {
          this.mixIn(cipherParams);
        },
        toString: function(formatter22) {
          return (formatter22 || this.formatter).stringify(this);
        }
      });
      var C_format = C2.format = {};
      var OpenSSLFormatter = C_format.OpenSSL = {
        stringify: function(cipherParams) {
          var wordArray;
          var ciphertext = cipherParams.ciphertext;
          var salt = cipherParams.salt;
          if (salt) {
            wordArray = WordArray.create([1398893684, 1701076831]).concat(salt).concat(ciphertext);
          } else {
            wordArray = ciphertext;
          }
          return wordArray.toString(Base64);
        },
        parse: function(openSSLStr) {
          var salt;
          var ciphertext = Base64.parse(openSSLStr);
          var ciphertextWords = ciphertext.words;
          if (ciphertextWords[0] == 1398893684 && ciphertextWords[1] == 1701076831) {
            salt = WordArray.create(ciphertextWords.slice(2, 4));
            ciphertextWords.splice(0, 4);
            ciphertext.sigBytes -= 16;
          }
          return CipherParams.create({ ciphertext, salt });
        }
      };
      var SerializableCipher = C_lib.SerializableCipher = Base.extend({
        cfg: Base.extend({
          format: OpenSSLFormatter
        }),
        encrypt: function(cipher, message, key, cfg) {
          cfg = this.cfg.extend(cfg);
          var encryptor = cipher.createEncryptor(key, cfg);
          var ciphertext = encryptor.finalize(message);
          var cipherCfg = encryptor.cfg;
          return CipherParams.create({
            ciphertext,
            key,
            iv: cipherCfg.iv,
            algorithm: cipher,
            mode: cipherCfg.mode,
            padding: cipherCfg.padding,
            blockSize: cipher.blockSize,
            formatter: cfg.format
          });
        },
        decrypt: function(cipher, ciphertext, key, cfg) {
          cfg = this.cfg.extend(cfg);
          ciphertext = this._parse(ciphertext, cfg.format);
          var plaintext = cipher.createDecryptor(key, cfg).finalize(ciphertext.ciphertext);
          return plaintext;
        },
        _parse: function(ciphertext, format) {
          if (typeof ciphertext == "string") {
            return format.parse(ciphertext, this);
          } else {
            return ciphertext;
          }
        }
      });
      var C_kdf = C2.kdf = {};
      var OpenSSLKdf = C_kdf.OpenSSL = {
        execute: function(password, keySize, ivSize, salt, hasher) {
          if (!salt) {
            salt = WordArray.random(8);
          }
          if (!hasher) {
            var key = EvpKDF.create({ keySize: keySize + ivSize }).compute(password, salt);
          } else {
            var key = EvpKDF.create({ keySize: keySize + ivSize, hasher }).compute(password, salt);
          }
          var iv = WordArray.create(key.words.slice(keySize), ivSize * 4);
          key.sigBytes = keySize * 4;
          return CipherParams.create({ key, iv, salt });
        }
      };
      var PasswordBasedCipher = C_lib.PasswordBasedCipher = SerializableCipher.extend({
        cfg: SerializableCipher.cfg.extend({
          kdf: OpenSSLKdf
        }),
        encrypt: function(cipher, message, password, cfg) {
          cfg = this.cfg.extend(cfg);
          var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize, cfg.salt, cfg.hasher);
          cfg.iv = derivedParams.iv;
          var ciphertext = SerializableCipher.encrypt.call(this, cipher, message, derivedParams.key, cfg);
          ciphertext.mixIn(derivedParams);
          return ciphertext;
        },
        decrypt: function(cipher, ciphertext, password, cfg) {
          cfg = this.cfg.extend(cfg);
          ciphertext = this._parse(ciphertext, cfg.format);
          var derivedParams = cfg.kdf.execute(password, cipher.keySize, cipher.ivSize, ciphertext.salt, cfg.hasher);
          cfg.iv = derivedParams.iv;
          var plaintext = SerializableCipher.decrypt.call(this, cipher, ciphertext, derivedParams.key, cfg);
          return plaintext;
        }
      });
    }();
  });
});
var require_aes = __commonJS2((exports, module) => {
  (function(root, factory, undef) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5(), require_enc_base64(), require_md5(), require_evpkdf(), require_cipher_core());
    } else if (typeof define === "function" && define.amd) {
      define(["./core", "./enc-base64", "./md5", "./evpkdf", "./cipher-core"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    (function() {
      var C2 = CryptoJS;
      var C_lib = C2.lib;
      var BlockCipher = C_lib.BlockCipher;
      var C_algo = C2.algo;
      var SBOX = [];
      var INV_SBOX = [];
      var SUB_MIX_0 = [];
      var SUB_MIX_1 = [];
      var SUB_MIX_2 = [];
      var SUB_MIX_3 = [];
      var INV_SUB_MIX_0 = [];
      var INV_SUB_MIX_1 = [];
      var INV_SUB_MIX_2 = [];
      var INV_SUB_MIX_3 = [];
      (function() {
        var d = [];
        for (var i2 = 0;i2 < 256; i2++) {
          if (i2 < 128) {
            d[i2] = i2 << 1;
          } else {
            d[i2] = i2 << 1 ^ 283;
          }
        }
        var x = 0;
        var xi = 0;
        for (var i2 = 0;i2 < 256; i2++) {
          var sx = xi ^ xi << 1 ^ xi << 2 ^ xi << 3 ^ xi << 4;
          sx = sx >>> 8 ^ sx & 255 ^ 99;
          SBOX[x] = sx;
          INV_SBOX[sx] = x;
          var x2 = d[x];
          var x4 = d[x2];
          var x8 = d[x4];
          var t = d[sx] * 257 ^ sx * 16843008;
          SUB_MIX_0[x] = t << 24 | t >>> 8;
          SUB_MIX_1[x] = t << 16 | t >>> 16;
          SUB_MIX_2[x] = t << 8 | t >>> 24;
          SUB_MIX_3[x] = t;
          var t = x8 * 16843009 ^ x4 * 65537 ^ x2 * 257 ^ x * 16843008;
          INV_SUB_MIX_0[sx] = t << 24 | t >>> 8;
          INV_SUB_MIX_1[sx] = t << 16 | t >>> 16;
          INV_SUB_MIX_2[sx] = t << 8 | t >>> 24;
          INV_SUB_MIX_3[sx] = t;
          if (!x) {
            x = xi = 1;
          } else {
            x = x2 ^ d[d[d[x8 ^ x2]]];
            xi ^= d[d[xi]];
          }
        }
      })();
      var RCON = [0, 1, 2, 4, 8, 16, 32, 64, 128, 27, 54];
      var AES = C_algo.AES = BlockCipher.extend({
        _doReset: function() {
          var t;
          if (this._nRounds && this._keyPriorReset === this._key) {
            return;
          }
          var key = this._keyPriorReset = this._key;
          var keyWords = key.words;
          var keySize = key.sigBytes / 4;
          var nRounds = this._nRounds = keySize + 6;
          var ksRows = (nRounds + 1) * 4;
          var keySchedule = this._keySchedule = [];
          for (var ksRow = 0;ksRow < ksRows; ksRow++) {
            if (ksRow < keySize) {
              keySchedule[ksRow] = keyWords[ksRow];
            } else {
              t = keySchedule[ksRow - 1];
              if (!(ksRow % keySize)) {
                t = t << 8 | t >>> 24;
                t = SBOX[t >>> 24] << 24 | SBOX[t >>> 16 & 255] << 16 | SBOX[t >>> 8 & 255] << 8 | SBOX[t & 255];
                t ^= RCON[ksRow / keySize | 0] << 24;
              } else if (keySize > 6 && ksRow % keySize == 4) {
                t = SBOX[t >>> 24] << 24 | SBOX[t >>> 16 & 255] << 16 | SBOX[t >>> 8 & 255] << 8 | SBOX[t & 255];
              }
              keySchedule[ksRow] = keySchedule[ksRow - keySize] ^ t;
            }
          }
          var invKeySchedule = this._invKeySchedule = [];
          for (var invKsRow = 0;invKsRow < ksRows; invKsRow++) {
            var ksRow = ksRows - invKsRow;
            if (invKsRow % 4) {
              var t = keySchedule[ksRow];
            } else {
              var t = keySchedule[ksRow - 4];
            }
            if (invKsRow < 4 || ksRow <= 4) {
              invKeySchedule[invKsRow] = t;
            } else {
              invKeySchedule[invKsRow] = INV_SUB_MIX_0[SBOX[t >>> 24]] ^ INV_SUB_MIX_1[SBOX[t >>> 16 & 255]] ^ INV_SUB_MIX_2[SBOX[t >>> 8 & 255]] ^ INV_SUB_MIX_3[SBOX[t & 255]];
            }
          }
        },
        encryptBlock: function(M22, offset2) {
          this._doCryptBlock(M22, offset2, this._keySchedule, SUB_MIX_0, SUB_MIX_1, SUB_MIX_2, SUB_MIX_3, SBOX);
        },
        decryptBlock: function(M22, offset2) {
          var t = M22[offset2 + 1];
          M22[offset2 + 1] = M22[offset2 + 3];
          M22[offset2 + 3] = t;
          this._doCryptBlock(M22, offset2, this._invKeySchedule, INV_SUB_MIX_0, INV_SUB_MIX_1, INV_SUB_MIX_2, INV_SUB_MIX_3, INV_SBOX);
          var t = M22[offset2 + 1];
          M22[offset2 + 1] = M22[offset2 + 3];
          M22[offset2 + 3] = t;
        },
        _doCryptBlock: function(M22, offset2, keySchedule, SUB_MIX_02, SUB_MIX_12, SUB_MIX_22, SUB_MIX_32, SBOX2) {
          var nRounds = this._nRounds;
          var s0 = M22[offset2] ^ keySchedule[0];
          var s1 = M22[offset2 + 1] ^ keySchedule[1];
          var s222 = M22[offset2 + 2] ^ keySchedule[2];
          var s32 = M22[offset2 + 3] ^ keySchedule[3];
          var ksRow = 4;
          for (var round = 1;round < nRounds; round++) {
            var t0 = SUB_MIX_02[s0 >>> 24] ^ SUB_MIX_12[s1 >>> 16 & 255] ^ SUB_MIX_22[s222 >>> 8 & 255] ^ SUB_MIX_32[s32 & 255] ^ keySchedule[ksRow++];
            var t1 = SUB_MIX_02[s1 >>> 24] ^ SUB_MIX_12[s222 >>> 16 & 255] ^ SUB_MIX_22[s32 >>> 8 & 255] ^ SUB_MIX_32[s0 & 255] ^ keySchedule[ksRow++];
            var t2 = SUB_MIX_02[s222 >>> 24] ^ SUB_MIX_12[s32 >>> 16 & 255] ^ SUB_MIX_22[s0 >>> 8 & 255] ^ SUB_MIX_32[s1 & 255] ^ keySchedule[ksRow++];
            var t3 = SUB_MIX_02[s32 >>> 24] ^ SUB_MIX_12[s0 >>> 16 & 255] ^ SUB_MIX_22[s1 >>> 8 & 255] ^ SUB_MIX_32[s222 & 255] ^ keySchedule[ksRow++];
            s0 = t0;
            s1 = t1;
            s222 = t2;
            s32 = t3;
          }
          var t0 = (SBOX2[s0 >>> 24] << 24 | SBOX2[s1 >>> 16 & 255] << 16 | SBOX2[s222 >>> 8 & 255] << 8 | SBOX2[s32 & 255]) ^ keySchedule[ksRow++];
          var t1 = (SBOX2[s1 >>> 24] << 24 | SBOX2[s222 >>> 16 & 255] << 16 | SBOX2[s32 >>> 8 & 255] << 8 | SBOX2[s0 & 255]) ^ keySchedule[ksRow++];
          var t2 = (SBOX2[s222 >>> 24] << 24 | SBOX2[s32 >>> 16 & 255] << 16 | SBOX2[s0 >>> 8 & 255] << 8 | SBOX2[s1 & 255]) ^ keySchedule[ksRow++];
          var t3 = (SBOX2[s32 >>> 24] << 24 | SBOX2[s0 >>> 16 & 255] << 16 | SBOX2[s1 >>> 8 & 255] << 8 | SBOX2[s222 & 255]) ^ keySchedule[ksRow++];
          M22[offset2] = t0;
          M22[offset2 + 1] = t1;
          M22[offset2 + 2] = t2;
          M22[offset2 + 3] = t3;
        },
        keySize: 8
      });
      C2.AES = BlockCipher._createHelper(AES);
    })();
    return CryptoJS.AES;
  });
});
var require_enc_utf8 = __commonJS2((exports, module) => {
  (function(root, factory) {
    if (typeof exports === "object") {
      module.exports = exports = factory(require_core5());
    } else if (typeof define === "function" && define.amd) {
      define(["./core"], factory);
    } else {
      factory(root.CryptoJS);
    }
  })(exports, function(CryptoJS) {
    return CryptoJS.enc.Utf8;
  });
});
var import_aes;
var import_enc_utf8;
var init_crypt = __esm2(() => {
  init_src4();
  import_aes = __toESM3(require_aes(), 1);
  import_enc_utf8 = __toESM3(require_enc_utf8(), 1);
});
var import_md5;
var init_hash2 = __esm2(() => {
  init_src6();
  import_md5 = __toESM3(require_md5(), 1);
});
var import_enc_base64;
var import_enc_utf82;
var init_key = __esm2(() => {
  import_enc_base64 = __toESM3(require_enc_base64(), 1);
  import_enc_utf82 = __toESM3(require_enc_utf8(), 1);
});
var init_src15 = __esm2(() => {
  init_crypt();
  init_hash2();
  init_key();
});
var init_seeder = __esm2(() => {
  init_src10();
  init_src16();
  init_src14();
  init_src11();
  init_src15();
  init_src23();
  init_src();
});
var init_types3 = () => {
};
var init_src16 = __esm2(() => {
  init_drivers();
  init_migrations();
  init_schema3();
  init_seeder();
  init_types3();
  init_utils9();
});
async function findRequestInstance(requestInstance) {
  const frameworkDirectory = path2.storagePath("framework/requests");
  const filePath = path2.join(frameworkDirectory, `${requestInstance}.ts`);
  const reqInstance = await import(filePath);
  return reqInstance.request;
}
async function extractDefaultRequest() {
  const requestPath = path2.frameworkPath(`core/router/src/request.ts`);
  const requestInstance = await import(requestPath);
  return requestInstance.request;
}
var init_utils10 = __esm2(() => {
  init_src7();
  init_src11();
  init_src();
  init_router();
});
var exports_api = {};
var init_api = __esm2(() => {
  init_src17();
  route.get("/foo/bar/{id}", () => "hello world, foo bar");
  route.get("/", () => "hello world");
  route.get("/hello/world", () => "hello world, buddy");
  route.post("/email/subscribe", "Actions/SubscriberEmailAction");
  route.post("/login", "Actions/LoginAction");
  route.get("/generate-registration-options", "Actions/Auth/GenerateRegistrationAction");
  route.post("/verify-registration", "Actions/Auth/VerifyRegistrationAction");
  route.get("/generate-authentication-options", "Actions/Auth/GenerateAuthenticationAction");
  route.post("/verify-authentication", "Actions/Auth/VerifyAuthenticationAction");
  route.health();
  route.get("/install", "Actions/InstallAction");
  route.post("/ai/ask", "Actions/AI/AskAction");
  route.post("/ai/summary", "Actions/AI/SummaryAction");
  route.post("/stripe/create-payment-intent", "Actions/Payment/CreatePaymentIntentAction");
  route.post("/stripe/create-subscription", "Actions/Payment/CreateSubscriptionAction");
  route.post("/stripe/create-invoice-subscription", "Actions/Payment/CreateInvoiceSubscription");
  route.post("/stripe/update-customer", "Actions/Payment/UpdateCustomerAction");
  route.post("/stripe/checkout", "Actions/Payment/CreateCheckoutAction");
});
var exports_routes = {};
var init_routes = __esm2(() => {
  init_src17();
  route.get("users", "UserIndexOrmAction").middleware(["Api"]);
  route.post("users", "UserStoreOrmAction").middleware(["Api"]);
  route.get("users/{id}", "UserShowOrmAction").middleware(["Api"]);
});

class Router {
  routes = [];
  groupPrefix = "";
  path = "";
  addRoute(method, uri, callback, statusCode) {
    const name = uri.replace(/\//g, ".").replace(/:/g, "");
    const pattern = new RegExp(`^${uri.replace(/:[a-z]+/gi, (_match) => {
      return "([a-zA-Z0-9-]+)";
    })}$`);
    log2.debug(`Adding route: ${method} ${uri} with name ${name}`);
    this.routes.push({
      name,
      method,
      url: uri,
      uri,
      callback,
      pattern,
      statusCode,
      paramNames: []
    });
    return this;
  }
  get(path42, callback) {
    this.path = this.normalizePath(path42);
    log2.debug(`Normalized Path: ${this.path}`);
    const uri = this.prepareUri(this.path);
    log2.debug(`Prepared URI: ${uri}`);
    return this.addRoute("GET", uri, callback, 200);
  }
  async email(path42) {
    path42 = pascalCase(path42);
    const emailModule = (await import(path2.userNotificationsPath(path42))).default;
    const callback = emailModule.handle;
    const uri = this.prepareUri(path42);
    this.addRoute("GET", uri, callback, 200);
    return this;
  }
  async health() {
    const healthModule = (await import(path2.userActionsPath("HealthAction"))).default;
    const callback = healthModule.handle;
    const path42 = healthModule.path ?? `/health`;
    this.addRoute("GET", path42, callback, 200);
    return this;
  }
  async job(path42) {
    path42 = pascalCase(path42);
    const job = (await import(path2.userJobsPath(`${path42}.ts`))).default;
    return this.addRoute("GET", this.prepareUri(path42), job.handle, 200);
  }
  async action(path42) {
    if (!path42)
      return this;
    if (path42?.endsWith(".ts")) {
      const action = (await import(path2.userActionsPath(path42))).default;
      path42 = action.path ?? kebabCase(path42);
      return this.addRoute(action.method ?? "GET", path42, action.handle, 200);
    }
    path42 = pascalCase(path42);
    try {
      const action = (await import(path2.userActionsPath(path42))).default;
      return this.addRoute(action.method ?? "GET", this.prepareUri(path42), action.handle, 200);
    } catch (error) {
      handleError2(`Could not find Action for path: ${path42}`, error);
      return this;
    }
  }
  post(path42, callback) {
    this.path = this.normalizePath(path42);
    const uri = this.prepareUri(this.path);
    return this.addRoute("POST", uri, callback, 201);
  }
  view(path42, callback) {
    this.path = this.normalizePath(path42);
    const uri = this.prepareUri(this.path);
    return this.addRoute("GET", uri, callback, 200);
  }
  redirect(path42, callback, _status) {
    return this.addRoute("GET", path42, callback, 302);
  }
  delete(path42, callback) {
    return this.addRoute("DELETE", this.prepareUri(path42), callback, 204);
  }
  patch(path42, callback) {
    this.path = this.normalizePath(path42);
    log2.debug(`Normalized Path: ${this.path}`);
    const uri = this.prepareUri(this.path);
    log2.debug(`Prepared URI: ${uri}`);
    return this.addRoute("PATCH", uri, callback, 202);
  }
  put(path42, callback) {
    this.path = this.normalizePath(path42);
    const uri = this.prepareUri(this.path);
    return this.addRoute("PUT", uri, callback, 202);
  }
  group(options3, callback) {
    if (typeof options3 === "string")
      options3 = options3.startsWith("/") ? options3.slice(1) : options3;
    let cb;
    this.prepareGroupPrefix(options3);
    if (typeof options3 === "function") {
      cb = options3;
      options3 = {};
    }
    if (!callback)
      throw new Error("Missing callback function for your route group.");
    cb = callback;
    const { prefix, middleware = [] } = options3;
    const originalRoutes = this.routes;
    this.routes = [];
    cb();
    this.routes.forEach((r22) => {
      r22.uri = `${prefix}${r22.uri}`;
      if (middleware.length)
        r22.middleware = middleware;
      originalRoutes.push(r22);
      return this;
    });
    this.routes = originalRoutes;
    return this;
  }
  name(name) {
    this.routes[this.routes.length - 1].name = name;
    return this;
  }
  middleware(middleware) {
    this.routes[this.routes.length - 1].middleware = middleware;
    return this;
  }
  prefix(prefix) {
    this.routes[this.routes.length - 1].prefix = prefix;
    return this;
  }
  async getRoutes() {
    await Promise.resolve().then(() => (init_api(), exports_api));
    await Promise.resolve().then(() => (init_routes(), exports_routes));
    return this.routes;
  }
  setGroupPrefix(prefix, options3 = {}) {
    if (prefix !== "") {
      prefix = `/${this.groupPrefix}/${prefix}`.replace(/\/\//g, "/");
      this.groupPrefix = prefix;
      return;
    }
    const effectiveOptions = typeof options3 === "object" ? options3 : {};
    this.groupPrefix = effectiveOptions.prefix ?? prefix ?? "";
  }
  prepareGroupPrefix(options3) {
    if (this.groupPrefix !== "" && typeof options3 !== "string") {
      this.setGroupPrefix(this.groupPrefix, options3);
      return;
    }
    if (typeof options3 === "string") {
      this.setGroupPrefix(options3);
      return;
    }
    this.setGroupPrefix("", options3);
  }
  async resolveCallback(callback) {
    if (callback instanceof Promise) {
      const actionModule = await callback;
      return actionModule.default;
    }
    if (typeof callback === "string")
      return await this.importCallbackFromPath(callback, this.path);
    return callback;
  }
  async importCallbackFromPath(callbackPath, originalPath) {
    let modulePath = callbackPath;
    let importPathFunction = path2.appPath;
    if (callbackPath.startsWith("../"))
      importPathFunction = path2.routesPath;
    if (modulePath.includes("OrmAction"))
      importPathFunction = path2.storagePath;
    modulePath = modulePath.endsWith(".ts") ? modulePath.slice(0, -3) : modulePath;
    let actionModule = null;
    if (modulePath.includes("storage/framework/orm"))
      actionModule = await import(modulePath);
    else if (modulePath.includes("app/Actions"))
      actionModule = await import(modulePath);
    else if (modulePath.includes("OrmAction"))
      actionModule = await import(path2.storagePath(`/framework/actions/src/${modulePath}.ts`));
    else
      actionModule = await import(importPathFunction(modulePath));
    const newPath = actionModule.default.path ?? originalPath;
    this.updatePathIfNeeded(newPath, originalPath);
    let requestInstance;
    if (actionModule.default.requestFile) {
      requestInstance = await findRequestInstance(actionModule.default.requestFile);
    } else {
      requestInstance = await extractDefaultRequest();
    }
    try {
      if (isObjectNotEmpty(actionModule.default.validations) && requestInstance)
        await customValidate(actionModule.default.validations, requestInstance.all());
      return await actionModule.default.handle(requestInstance);
    } catch (error) {
      const errorResponse = await this.handleErrors(error);
      return errorResponse;
    }
  }
  async handleErrors(error) {
    const stackTrace = error.stack || "No stack trace available";
    this.storeError(error);
    this.logError(error);
    if (error.status === 422) {
      return { status: 422, errors: JSON.parse(error.message), stack: stackTrace };
    }
    if (!error.status) {
      return { status: 500, errors: error.message, stack: stackTrace };
    }
    return { status: error.status, errors: error.message, stack: stackTrace };
  }
  async storeError(error) {
    const stackTrace = error.stack || "No stack trace available";
    await db.insertInto("errors").values({
      type: error.name || "Unknown Error",
      message: error.message || "No message available",
      stack: stackTrace || "Unkown Stack",
      status: typeof error.status === "number" ? error.status : 500
    }).execute();
  }
  async logError(error) {
    const stackTrace = error.stack || "No stack trace available";
    log2.debug(stackTrace);
  }
  normalizePath(path42) {
    return path42.endsWith("/") ? path42.slice(0, -1) : path42;
  }
  prepareUri(path42) {
    if (path42.startsWith("/"))
      path42 = path42.slice(1);
    path42 = `${this.groupPrefix}/${path42}`;
    return path42.endsWith("/") ? path42.slice(0, -1) : path42;
  }
  updatePathIfNeeded(newPath, originalPath) {
    if (newPath !== originalPath) {
      this.path = newPath;
    }
  }
}
var route;
var init_router = __esm2(() => {
  init_src16();
  init_src7();
  init_src8();
  init_src11();
  init_src();
  init_src3();
  init_utils10();
  route = new Router;
});
var init_server = __esm2(() => {
  init_src7();
  init_src8();
  init_src14();
  init_src11();
  init_src23();
  init_src17();
  init_middleware();
  init_request();
});
var init_src17 = __esm2(() => {
  init_middleware();
  init_request();
  init_router();
  init_server();
  init_utils10();
});
var init_generate_openapi = __esm2(() => {
  init_src11();
  init_src17();
});
var init_ofetch = () => {
};
var init_src18 = __esm2(() => {
  init_generate_openapi();
  init_ofetch();
});
var init_vscode_custom_data = __esm2(() => {
  init_src7();
  init_src8();
  init_src11();
  init_src23();
  init_library();
});
var init_generate = __esm2(() => {
  init_src18();
  init_src10();
  init_src12();
  init_src8();
  init_src14();
  init_src11();
  init_src21();
  init_helpers5();
  init_vscode_custom_data();
});
var init_make = __esm2(() => {
  init_src10();
  init_src7();
  init_src8();
  init_src11();
  init_src23();
});
var init_src19 = __esm2(() => {
  init_add();
  init_commit();
  init_dev();
  init_generate();
  init_helpers5();
  init_make();
});
var require_identity = __commonJS2((exports) => {
  var ALIAS = Symbol.for("yaml.alias");
  var DOC = Symbol.for("yaml.document");
  var MAP2 = Symbol.for("yaml.map");
  var PAIR = Symbol.for("yaml.pair");
  var SCALAR = Symbol.for("yaml.scalar");
  var SEQ = Symbol.for("yaml.seq");
  var NODE_TYPE = Symbol.for("yaml.node.type");
  var isAlias = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === ALIAS;
  var isDocument = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === DOC;
  var isMap = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === MAP2;
  var isPair = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === PAIR;
  var isScalar = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === SCALAR;
  var isSeq = (node) => !!node && typeof node === "object" && node[NODE_TYPE] === SEQ;
  function isCollection(node) {
    if (node && typeof node === "object")
      switch (node[NODE_TYPE]) {
        case MAP2:
        case SEQ:
          return true;
      }
    return false;
  }
  function isNode(node) {
    if (node && typeof node === "object")
      switch (node[NODE_TYPE]) {
        case ALIAS:
        case MAP2:
        case SCALAR:
        case SEQ:
          return true;
      }
    return false;
  }
  var hasAnchor = (node) => (isScalar(node) || isCollection(node)) && !!node.anchor;
  exports.ALIAS = ALIAS;
  exports.DOC = DOC;
  exports.MAP = MAP2;
  exports.NODE_TYPE = NODE_TYPE;
  exports.PAIR = PAIR;
  exports.SCALAR = SCALAR;
  exports.SEQ = SEQ;
  exports.hasAnchor = hasAnchor;
  exports.isAlias = isAlias;
  exports.isCollection = isCollection;
  exports.isDocument = isDocument;
  exports.isMap = isMap;
  exports.isNode = isNode;
  exports.isPair = isPair;
  exports.isScalar = isScalar;
  exports.isSeq = isSeq;
});
var require_visit = __commonJS2((exports) => {
  var identity = require_identity();
  var BREAK = Symbol("break visit");
  var SKIP = Symbol("skip children");
  var REMOVE = Symbol("remove node");
  function visit(node, visitor) {
    const visitor_ = initVisitor(visitor);
    if (identity.isDocument(node)) {
      const cd = visit_(null, node.contents, visitor_, Object.freeze([node]));
      if (cd === REMOVE)
        node.contents = null;
    } else
      visit_(null, node, visitor_, Object.freeze([]));
  }
  visit.BREAK = BREAK;
  visit.SKIP = SKIP;
  visit.REMOVE = REMOVE;
  function visit_(key2, node, visitor, path42) {
    const ctrl = callVisitor(key2, node, visitor, path42);
    if (identity.isNode(ctrl) || identity.isPair(ctrl)) {
      replaceNode(key2, path42, ctrl);
      return visit_(key2, ctrl, visitor, path42);
    }
    if (typeof ctrl !== "symbol") {
      if (identity.isCollection(node)) {
        path42 = Object.freeze(path42.concat(node));
        for (let i2 = 0;i2 < node.items.length; ++i2) {
          const ci = visit_(i2, node.items[i2], visitor, path42);
          if (typeof ci === "number")
            i2 = ci - 1;
          else if (ci === BREAK)
            return BREAK;
          else if (ci === REMOVE) {
            node.items.splice(i2, 1);
            i2 -= 1;
          }
        }
      } else if (identity.isPair(node)) {
        path42 = Object.freeze(path42.concat(node));
        const ck = visit_("key", node.key, visitor, path42);
        if (ck === BREAK)
          return BREAK;
        else if (ck === REMOVE)
          node.key = null;
        const cv = visit_("value", node.value, visitor, path42);
        if (cv === BREAK)
          return BREAK;
        else if (cv === REMOVE)
          node.value = null;
      }
    }
    return ctrl;
  }
  async function visitAsync(node, visitor) {
    const visitor_ = initVisitor(visitor);
    if (identity.isDocument(node)) {
      const cd = await visitAsync_(null, node.contents, visitor_, Object.freeze([node]));
      if (cd === REMOVE)
        node.contents = null;
    } else
      await visitAsync_(null, node, visitor_, Object.freeze([]));
  }
  visitAsync.BREAK = BREAK;
  visitAsync.SKIP = SKIP;
  visitAsync.REMOVE = REMOVE;
  async function visitAsync_(key2, node, visitor, path42) {
    const ctrl = await callVisitor(key2, node, visitor, path42);
    if (identity.isNode(ctrl) || identity.isPair(ctrl)) {
      replaceNode(key2, path42, ctrl);
      return visitAsync_(key2, ctrl, visitor, path42);
    }
    if (typeof ctrl !== "symbol") {
      if (identity.isCollection(node)) {
        path42 = Object.freeze(path42.concat(node));
        for (let i2 = 0;i2 < node.items.length; ++i2) {
          const ci = await visitAsync_(i2, node.items[i2], visitor, path42);
          if (typeof ci === "number")
            i2 = ci - 1;
          else if (ci === BREAK)
            return BREAK;
          else if (ci === REMOVE) {
            node.items.splice(i2, 1);
            i2 -= 1;
          }
        }
      } else if (identity.isPair(node)) {
        path42 = Object.freeze(path42.concat(node));
        const ck = await visitAsync_("key", node.key, visitor, path42);
        if (ck === BREAK)
          return BREAK;
        else if (ck === REMOVE)
          node.key = null;
        const cv = await visitAsync_("value", node.value, visitor, path42);
        if (cv === BREAK)
          return BREAK;
        else if (cv === REMOVE)
          node.value = null;
      }
    }
    return ctrl;
  }
  function initVisitor(visitor) {
    if (typeof visitor === "object" && (visitor.Collection || visitor.Node || visitor.Value)) {
      return Object.assign({
        Alias: visitor.Node,
        Map: visitor.Node,
        Scalar: visitor.Node,
        Seq: visitor.Node
      }, visitor.Value && {
        Map: visitor.Value,
        Scalar: visitor.Value,
        Seq: visitor.Value
      }, visitor.Collection && {
        Map: visitor.Collection,
        Seq: visitor.Collection
      }, visitor);
    }
    return visitor;
  }
  function callVisitor(key2, node, visitor, path42) {
    if (typeof visitor === "function")
      return visitor(key2, node, path42);
    if (identity.isMap(node))
      return visitor.Map?.(key2, node, path42);
    if (identity.isSeq(node))
      return visitor.Seq?.(key2, node, path42);
    if (identity.isPair(node))
      return visitor.Pair?.(key2, node, path42);
    if (identity.isScalar(node))
      return visitor.Scalar?.(key2, node, path42);
    if (identity.isAlias(node))
      return visitor.Alias?.(key2, node, path42);
    return;
  }
  function replaceNode(key2, path42, node) {
    const parent = path42[path42.length - 1];
    if (identity.isCollection(parent)) {
      parent.items[key2] = node;
    } else if (identity.isPair(parent)) {
      if (key2 === "key")
        parent.key = node;
      else
        parent.value = node;
    } else if (identity.isDocument(parent)) {
      parent.contents = node;
    } else {
      const pt = identity.isAlias(parent) ? "alias" : "scalar";
      throw new Error(`Cannot replace node with ${pt} parent`);
    }
  }
  exports.visit = visit;
  exports.visitAsync = visitAsync;
});
var require_directives = __commonJS2((exports) => {
  var identity = require_identity();
  var visit = require_visit();
  var escapeChars = {
    "!": "%21",
    ",": "%2C",
    "[": "%5B",
    "]": "%5D",
    "{": "%7B",
    "}": "%7D"
  };
  var escapeTagName = (tn) => tn.replace(/[!,[\]{}]/g, (ch) => escapeChars[ch]);

  class Directives {
    constructor(yaml, tags) {
      this.docStart = null;
      this.docEnd = false;
      this.yaml = Object.assign({}, Directives.defaultYaml, yaml);
      this.tags = Object.assign({}, Directives.defaultTags, tags);
    }
    clone() {
      const copy = new Directives(this.yaml, this.tags);
      copy.docStart = this.docStart;
      return copy;
    }
    atDocument() {
      const res = new Directives(this.yaml, this.tags);
      switch (this.yaml.version) {
        case "1.1":
          this.atNextDocument = true;
          break;
        case "1.2":
          this.atNextDocument = false;
          this.yaml = {
            explicit: Directives.defaultYaml.explicit,
            version: "1.2"
          };
          this.tags = Object.assign({}, Directives.defaultTags);
          break;
      }
      return res;
    }
    add(line, onError2) {
      if (this.atNextDocument) {
        this.yaml = { explicit: Directives.defaultYaml.explicit, version: "1.1" };
        this.tags = Object.assign({}, Directives.defaultTags);
        this.atNextDocument = false;
      }
      const parts = line.trim().split(/[ \t]+/);
      const name = parts.shift();
      switch (name) {
        case "%TAG": {
          if (parts.length !== 2) {
            onError2(0, "%TAG directive should contain exactly two parts");
            if (parts.length < 2)
              return false;
          }
          const [handle, prefix] = parts;
          this.tags[handle] = prefix;
          return true;
        }
        case "%YAML": {
          this.yaml.explicit = true;
          if (parts.length !== 1) {
            onError2(0, "%YAML directive should contain exactly one part");
            return false;
          }
          const [version4] = parts;
          if (version4 === "1.1" || version4 === "1.2") {
            this.yaml.version = version4;
            return true;
          } else {
            const isValid = /^\d+\.\d+$/.test(version4);
            onError2(6, `Unsupported YAML version ${version4}`, isValid);
            return false;
          }
        }
        default:
          onError2(0, `Unknown directive ${name}`, true);
          return false;
      }
    }
    tagName(source, onError2) {
      if (source === "!")
        return "!";
      if (source[0] !== "!") {
        onError2(`Not a valid tag: ${source}`);
        return null;
      }
      if (source[1] === "<") {
        const verbatim = source.slice(2, -1);
        if (verbatim === "!" || verbatim === "!!") {
          onError2(`Verbatim tags aren't resolved, so ${source} is invalid.`);
          return null;
        }
        if (source[source.length - 1] !== ">")
          onError2("Verbatim tags must end with a >");
        return verbatim;
      }
      const [, handle, suffix] = source.match(/^(.*!)([^!]*)$/s);
      if (!suffix)
        onError2(`The ${source} tag has no suffix`);
      const prefix = this.tags[handle];
      if (prefix) {
        try {
          return prefix + decodeURIComponent(suffix);
        } catch (error) {
          onError2(String(error));
          return null;
        }
      }
      if (handle === "!")
        return source;
      onError2(`Could not resolve tag: ${source}`);
      return null;
    }
    tagString(tag) {
      for (const [handle, prefix] of Object.entries(this.tags)) {
        if (tag.startsWith(prefix))
          return handle + escapeTagName(tag.substring(prefix.length));
      }
      return tag[0] === "!" ? tag : `!<${tag}>`;
    }
    toString(doc) {
      const lines = this.yaml.explicit ? [`%YAML ${this.yaml.version || "1.2"}`] : [];
      const tagEntries = Object.entries(this.tags);
      let tagNames;
      if (doc && tagEntries.length > 0 && identity.isNode(doc.contents)) {
        const tags = {};
        visit.visit(doc.contents, (_key, node) => {
          if (identity.isNode(node) && node.tag)
            tags[node.tag] = true;
        });
        tagNames = Object.keys(tags);
      } else
        tagNames = [];
      for (const [handle, prefix] of tagEntries) {
        if (handle === "!!" && prefix === "tag:yaml.org,2002:")
          continue;
        if (!doc || tagNames.some((tn) => tn.startsWith(prefix)))
          lines.push(`%TAG ${handle} ${prefix}`);
      }
      return lines.join("\n");
    }
  }
  Directives.defaultYaml = { explicit: false, version: "1.2" };
  Directives.defaultTags = { "!!": "tag:yaml.org,2002:" };
  exports.Directives = Directives;
});
var require_anchors = __commonJS2((exports) => {
  var identity = require_identity();
  var visit = require_visit();
  function anchorIsValid(anchor) {
    if (/[\x00-\x19\s,[\]{}]/.test(anchor)) {
      const sa = JSON.stringify(anchor);
      const msg = `Anchor must not contain whitespace or control characters: ${sa}`;
      throw new Error(msg);
    }
    return true;
  }
  function anchorNames(root) {
    const anchors = new Set;
    visit.visit(root, {
      Value(_key, node) {
        if (node.anchor)
          anchors.add(node.anchor);
      }
    });
    return anchors;
  }
  function findNewAnchor(prefix, exclude) {
    for (let i2 = 1;; ++i2) {
      const name = `${prefix}${i2}`;
      if (!exclude.has(name))
        return name;
    }
  }
  function createNodeAnchors(doc, prefix) {
    const aliasObjects = [];
    const sourceObjects = new Map;
    let prevAnchors = null;
    return {
      onAnchor: (source) => {
        aliasObjects.push(source);
        if (!prevAnchors)
          prevAnchors = anchorNames(doc);
        const anchor = findNewAnchor(prefix, prevAnchors);
        prevAnchors.add(anchor);
        return anchor;
      },
      setAnchors: () => {
        for (const source of aliasObjects) {
          const ref2 = sourceObjects.get(source);
          if (typeof ref2 === "object" && ref2.anchor && (identity.isScalar(ref2.node) || identity.isCollection(ref2.node))) {
            ref2.node.anchor = ref2.anchor;
          } else {
            const error = new Error("Failed to resolve repeated object (this should not happen)");
            error.source = source;
            throw error;
          }
        }
      },
      sourceObjects
    };
  }
  exports.anchorIsValid = anchorIsValid;
  exports.anchorNames = anchorNames;
  exports.createNodeAnchors = createNodeAnchors;
  exports.findNewAnchor = findNewAnchor;
});
var require_applyReviver = __commonJS2((exports) => {
  function applyReviver(reviver, obj, key2, val2) {
    if (val2 && typeof val2 === "object") {
      if (Array.isArray(val2)) {
        for (let i2 = 0, len = val2.length;i2 < len; ++i2) {
          const v0 = val2[i2];
          const v1 = applyReviver(reviver, val2, String(i2), v0);
          if (v1 === undefined)
            delete val2[i2];
          else if (v1 !== v0)
            val2[i2] = v1;
        }
      } else if (val2 instanceof Map) {
        for (const k of Array.from(val2.keys())) {
          const v0 = val2.get(k);
          const v1 = applyReviver(reviver, val2, k, v0);
          if (v1 === undefined)
            val2.delete(k);
          else if (v1 !== v0)
            val2.set(k, v1);
        }
      } else if (val2 instanceof Set) {
        for (const v0 of Array.from(val2)) {
          const v1 = applyReviver(reviver, val2, v0, v0);
          if (v1 === undefined)
            val2.delete(v0);
          else if (v1 !== v0) {
            val2.delete(v0);
            val2.add(v1);
          }
        }
      } else {
        for (const [k, v0] of Object.entries(val2)) {
          const v1 = applyReviver(reviver, val2, k, v0);
          if (v1 === undefined)
            delete val2[k];
          else if (v1 !== v0)
            val2[k] = v1;
        }
      }
    }
    return reviver.call(obj, key2, val2);
  }
  exports.applyReviver = applyReviver;
});
var require_toJS = __commonJS2((exports) => {
  var identity = require_identity();
  function toJS(value, arg, ctx) {
    if (Array.isArray(value))
      return value.map((v22, i2) => toJS(v22, String(i2), ctx));
    if (value && typeof value.toJSON === "function") {
      if (!ctx || !identity.hasAnchor(value))
        return value.toJSON(arg, ctx);
      const data2 = { aliasCount: 0, count: 1, res: undefined };
      ctx.anchors.set(value, data2);
      ctx.onCreate = (res2) => {
        data2.res = res2;
        delete ctx.onCreate;
      };
      const res = value.toJSON(arg, ctx);
      if (ctx.onCreate)
        ctx.onCreate(res);
      return res;
    }
    if (typeof value === "bigint" && !ctx?.keep)
      return Number(value);
    return value;
  }
  exports.toJS = toJS;
});
var require_Node = __commonJS2((exports) => {
  var applyReviver = require_applyReviver();
  var identity = require_identity();
  var toJS = require_toJS();

  class NodeBase2 {
    constructor(type) {
      Object.defineProperty(this, identity.NODE_TYPE, { value: type });
    }
    clone() {
      const copy = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this));
      if (this.range)
        copy.range = this.range.slice();
      return copy;
    }
    toJS(doc, { mapAsMap, maxAliasCount, onAnchor, reviver } = {}) {
      if (!identity.isDocument(doc))
        throw new TypeError("A document argument is required");
      const ctx = {
        anchors: new Map,
        doc,
        keep: true,
        mapAsMap: mapAsMap === true,
        mapKeyWarned: false,
        maxAliasCount: typeof maxAliasCount === "number" ? maxAliasCount : 100
      };
      const res = toJS.toJS(this, "", ctx);
      if (typeof onAnchor === "function")
        for (const { count, res: res2 } of ctx.anchors.values())
          onAnchor(res2, count);
      return typeof reviver === "function" ? applyReviver.applyReviver(reviver, { "": res }, "", res) : res;
    }
  }
  exports.NodeBase = NodeBase2;
});
var require_Alias = __commonJS2((exports) => {
  var anchors = require_anchors();
  var visit = require_visit();
  var identity = require_identity();
  var Node3 = require_Node();
  var toJS = require_toJS();

  class Alias extends Node3.NodeBase {
    constructor(source) {
      super(identity.ALIAS);
      this.source = source;
      Object.defineProperty(this, "tag", {
        set() {
          throw new Error("Alias nodes cannot have tags");
        }
      });
    }
    resolve(doc) {
      let found = undefined;
      visit.visit(doc, {
        Node: (_key, node) => {
          if (node === this)
            return visit.visit.BREAK;
          if (node.anchor === this.source)
            found = node;
        }
      });
      return found;
    }
    toJSON(_arg, ctx) {
      if (!ctx)
        return { source: this.source };
      const { anchors: anchors2, doc, maxAliasCount } = ctx;
      const source = this.resolve(doc);
      if (!source) {
        const msg = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
        throw new ReferenceError(msg);
      }
      let data2 = anchors2.get(source);
      if (!data2) {
        toJS.toJS(source, null, ctx);
        data2 = anchors2.get(source);
      }
      if (!data2 || data2.res === undefined) {
        const msg = "This should not happen: Alias anchor was not resolved?";
        throw new ReferenceError(msg);
      }
      if (maxAliasCount >= 0) {
        data2.count += 1;
        if (data2.aliasCount === 0)
          data2.aliasCount = getAliasCount(doc, source, anchors2);
        if (data2.count * data2.aliasCount > maxAliasCount) {
          const msg = "Excessive alias count indicates a resource exhaustion attack";
          throw new ReferenceError(msg);
        }
      }
      return data2.res;
    }
    toString(ctx, _onComment, _onChompKeep) {
      const src22 = `*${this.source}`;
      if (ctx) {
        anchors.anchorIsValid(this.source);
        if (ctx.options.verifyAliasOrder && !ctx.anchors.has(this.source)) {
          const msg = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
          throw new Error(msg);
        }
        if (ctx.implicitKey)
          return `${src22} `;
      }
      return src22;
    }
  }
  function getAliasCount(doc, node, anchors2) {
    if (identity.isAlias(node)) {
      const source = node.resolve(doc);
      const anchor = anchors2 && source && anchors2.get(source);
      return anchor ? anchor.count * anchor.aliasCount : 0;
    } else if (identity.isCollection(node)) {
      let count = 0;
      for (const item of node.items) {
        const c22 = getAliasCount(doc, item, anchors2);
        if (c22 > count)
          count = c22;
      }
      return count;
    } else if (identity.isPair(node)) {
      const kc = getAliasCount(doc, node.key, anchors2);
      const vc = getAliasCount(doc, node.value, anchors2);
      return Math.max(kc, vc);
    }
    return 1;
  }
  exports.Alias = Alias;
});
var require_Scalar = __commonJS2((exports) => {
  var identity = require_identity();
  var Node3 = require_Node();
  var toJS = require_toJS();
  var isScalarValue = (value) => !value || typeof value !== "function" && typeof value !== "object";

  class Scalar extends Node3.NodeBase {
    constructor(value) {
      super(identity.SCALAR);
      this.value = value;
    }
    toJSON(arg, ctx) {
      return ctx?.keep ? this.value : toJS.toJS(this.value, arg, ctx);
    }
    toString() {
      return String(this.value);
    }
  }
  Scalar.BLOCK_FOLDED = "BLOCK_FOLDED";
  Scalar.BLOCK_LITERAL = "BLOCK_LITERAL";
  Scalar.PLAIN = "PLAIN";
  Scalar.QUOTE_DOUBLE = "QUOTE_DOUBLE";
  Scalar.QUOTE_SINGLE = "QUOTE_SINGLE";
  exports.Scalar = Scalar;
  exports.isScalarValue = isScalarValue;
});
var require_createNode = __commonJS2((exports) => {
  var Alias = require_Alias();
  var identity = require_identity();
  var Scalar = require_Scalar();
  var defaultTagPrefix = "tag:yaml.org,2002:";
  function findTagObject(value, tagName, tags) {
    if (tagName) {
      const match = tags.filter((t) => t.tag === tagName);
      const tagObj = match.find((t) => !t.format) ?? match[0];
      if (!tagObj)
        throw new Error(`Tag ${tagName} not found`);
      return tagObj;
    }
    return tags.find((t) => t.identify?.(value) && !t.format);
  }
  function createNode(value, tagName, ctx) {
    if (identity.isDocument(value))
      value = value.contents;
    if (identity.isNode(value))
      return value;
    if (identity.isPair(value)) {
      const map = ctx.schema[identity.MAP].createNode?.(ctx.schema, null, ctx);
      map.items.push(value);
      return map;
    }
    if (value instanceof String || value instanceof Number || value instanceof Boolean || typeof BigInt !== "undefined" && value instanceof BigInt) {
      value = value.valueOf();
    }
    const { aliasDuplicateObjects, onAnchor, onTagObj, schema: schema4, sourceObjects } = ctx;
    let ref2 = undefined;
    if (aliasDuplicateObjects && value && typeof value === "object") {
      ref2 = sourceObjects.get(value);
      if (ref2) {
        if (!ref2.anchor)
          ref2.anchor = onAnchor(value);
        return new Alias.Alias(ref2.anchor);
      } else {
        ref2 = { anchor: null, node: null };
        sourceObjects.set(value, ref2);
      }
    }
    if (tagName?.startsWith("!!"))
      tagName = defaultTagPrefix + tagName.slice(2);
    let tagObj = findTagObject(value, tagName, schema4.tags);
    if (!tagObj) {
      if (value && typeof value.toJSON === "function") {
        value = value.toJSON();
      }
      if (!value || typeof value !== "object") {
        const node2 = new Scalar.Scalar(value);
        if (ref2)
          ref2.node = node2;
        return node2;
      }
      tagObj = value instanceof Map ? schema4[identity.MAP] : (Symbol.iterator in Object(value)) ? schema4[identity.SEQ] : schema4[identity.MAP];
    }
    if (onTagObj) {
      onTagObj(tagObj);
      delete ctx.onTagObj;
    }
    const node = tagObj?.createNode ? tagObj.createNode(ctx.schema, value, ctx) : typeof tagObj?.nodeClass?.from === "function" ? tagObj.nodeClass.from(ctx.schema, value, ctx) : new Scalar.Scalar(value);
    if (tagName)
      node.tag = tagName;
    else if (!tagObj.default)
      node.tag = tagObj.tag;
    if (ref2)
      ref2.node = node;
    return node;
  }
  exports.createNode = createNode;
});
var require_Collection = __commonJS2((exports) => {
  var createNode = require_createNode();
  var identity = require_identity();
  var Node3 = require_Node();
  function collectionFromPath(schema4, path42, value) {
    let v22 = value;
    for (let i2 = path42.length - 1;i2 >= 0; --i2) {
      const k = path42[i2];
      if (typeof k === "number" && Number.isInteger(k) && k >= 0) {
        const a = [];
        a[k] = v22;
        v22 = a;
      } else {
        v22 = new Map([[k, v22]]);
      }
    }
    return createNode.createNode(v22, undefined, {
      aliasDuplicateObjects: false,
      keepUndefined: false,
      onAnchor: () => {
        throw new Error("This should not happen, please report a bug.");
      },
      schema: schema4,
      sourceObjects: new Map
    });
  }
  var isEmptyPath = (path42) => path42 == null || typeof path42 === "object" && !!path42[Symbol.iterator]().next().done;

  class Collection22 extends Node3.NodeBase {
    constructor(type, schema4) {
      super(type);
      Object.defineProperty(this, "schema", {
        value: schema4,
        configurable: true,
        enumerable: false,
        writable: true
      });
    }
    clone(schema4) {
      const copy = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this));
      if (schema4)
        copy.schema = schema4;
      copy.items = copy.items.map((it) => identity.isNode(it) || identity.isPair(it) ? it.clone(schema4) : it);
      if (this.range)
        copy.range = this.range.slice();
      return copy;
    }
    addIn(path42, value) {
      if (isEmptyPath(path42))
        this.add(value);
      else {
        const [key2, ...rest] = path42;
        const node = this.get(key2, true);
        if (identity.isCollection(node))
          node.addIn(rest, value);
        else if (node === undefined && this.schema)
          this.set(key2, collectionFromPath(this.schema, rest, value));
        else
          throw new Error(`Expected YAML collection at ${key2}. Remaining path: ${rest}`);
      }
    }
    deleteIn(path42) {
      const [key2, ...rest] = path42;
      if (rest.length === 0)
        return this.delete(key2);
      const node = this.get(key2, true);
      if (identity.isCollection(node))
        return node.deleteIn(rest);
      else
        throw new Error(`Expected YAML collection at ${key2}. Remaining path: ${rest}`);
    }
    getIn(path42, keepScalar) {
      const [key2, ...rest] = path42;
      const node = this.get(key2, true);
      if (rest.length === 0)
        return !keepScalar && identity.isScalar(node) ? node.value : node;
      else
        return identity.isCollection(node) ? node.getIn(rest, keepScalar) : undefined;
    }
    hasAllNullValues(allowScalar) {
      return this.items.every((node) => {
        if (!identity.isPair(node))
          return false;
        const n = node.value;
        return n == null || allowScalar && identity.isScalar(n) && n.value == null && !n.commentBefore && !n.comment && !n.tag;
      });
    }
    hasIn(path42) {
      const [key2, ...rest] = path42;
      if (rest.length === 0)
        return this.has(key2);
      const node = this.get(key2, true);
      return identity.isCollection(node) ? node.hasIn(rest) : false;
    }
    setIn(path42, value) {
      const [key2, ...rest] = path42;
      if (rest.length === 0) {
        this.set(key2, value);
      } else {
        const node = this.get(key2, true);
        if (identity.isCollection(node))
          node.setIn(rest, value);
        else if (node === undefined && this.schema)
          this.set(key2, collectionFromPath(this.schema, rest, value));
        else
          throw new Error(`Expected YAML collection at ${key2}. Remaining path: ${rest}`);
      }
    }
  }
  exports.Collection = Collection22;
  exports.collectionFromPath = collectionFromPath;
  exports.isEmptyPath = isEmptyPath;
});
var require_stringifyComment = __commonJS2((exports) => {
  var stringifyComment = (str) => str.replace(/^(?!$)(?: $)?/gm, "#");
  function indentComment(comment, indent) {
    if (/^\n+$/.test(comment))
      return comment.substring(1);
    return indent ? comment.replace(/^(?! *$)/gm, indent) : comment;
  }
  var lineComment = (str, indent, comment) => str.endsWith("\n") ? indentComment(comment, indent) : comment.includes("\n") ? "\n" + indentComment(comment, indent) : (str.endsWith(" ") ? "" : " ") + comment;
  exports.indentComment = indentComment;
  exports.lineComment = lineComment;
  exports.stringifyComment = stringifyComment;
});
var require_foldFlowLines = __commonJS2((exports) => {
  var FOLD_FLOW = "flow";
  var FOLD_BLOCK = "block";
  var FOLD_QUOTED = "quoted";
  function foldFlowLines(text22, indent, mode = "flow", { indentAtStart, lineWidth = 80, minContentWidth = 20, onFold, onOverflow } = {}) {
    if (!lineWidth || lineWidth < 0)
      return text22;
    if (lineWidth < minContentWidth)
      minContentWidth = 0;
    const endStep = Math.max(1 + minContentWidth, 1 + lineWidth - indent.length);
    if (text22.length <= endStep)
      return text22;
    const folds = [];
    const escapedFolds = {};
    let end = lineWidth - indent.length;
    if (typeof indentAtStart === "number") {
      if (indentAtStart > lineWidth - Math.max(2, minContentWidth))
        folds.push(0);
      else
        end = lineWidth - indentAtStart;
    }
    let split2 = undefined;
    let prev = undefined;
    let overflow = false;
    let i2 = -1;
    let escStart = -1;
    let escEnd = -1;
    if (mode === FOLD_BLOCK) {
      i2 = consumeMoreIndentedLines(text22, i2, indent.length);
      if (i2 !== -1)
        end = i2 + endStep;
    }
    for (let ch;ch = text22[i2 += 1]; ) {
      if (mode === FOLD_QUOTED && ch === "\\") {
        escStart = i2;
        switch (text22[i2 + 1]) {
          case "x":
            i2 += 3;
            break;
          case "u":
            i2 += 5;
            break;
          case "U":
            i2 += 9;
            break;
          default:
            i2 += 1;
        }
        escEnd = i2;
      }
      if (ch === "\n") {
        if (mode === FOLD_BLOCK)
          i2 = consumeMoreIndentedLines(text22, i2, indent.length);
        end = i2 + indent.length + endStep;
        split2 = undefined;
      } else {
        if (ch === " " && prev && prev !== " " && prev !== "\n" && prev !== "\t") {
          const next = text22[i2 + 1];
          if (next && next !== " " && next !== "\n" && next !== "\t")
            split2 = i2;
        }
        if (i2 >= end) {
          if (split2) {
            folds.push(split2);
            end = split2 + endStep;
            split2 = undefined;
          } else if (mode === FOLD_QUOTED) {
            while (prev === " " || prev === "\t") {
              prev = ch;
              ch = text22[i2 += 1];
              overflow = true;
            }
            const j22 = i2 > escEnd + 1 ? i2 - 2 : escStart - 1;
            if (escapedFolds[j22])
              return text22;
            folds.push(j22);
            escapedFolds[j22] = true;
            end = j22 + endStep;
            split2 = undefined;
          } else {
            overflow = true;
          }
        }
      }
      prev = ch;
    }
    if (overflow && onOverflow)
      onOverflow();
    if (folds.length === 0)
      return text22;
    if (onFold)
      onFold();
    let res = text22.slice(0, folds[0]);
    for (let i22 = 0;i22 < folds.length; ++i22) {
      const fold = folds[i22];
      const end2 = folds[i22 + 1] || text22.length;
      if (fold === 0)
        res = `\n${indent}${text22.slice(0, end2)}`;
      else {
        if (mode === FOLD_QUOTED && escapedFolds[fold])
          res += `${text22[fold]}\\`;
        res += `\n${indent}${text22.slice(fold + 1, end2)}`;
      }
    }
    return res;
  }
  function consumeMoreIndentedLines(text22, i2, indent) {
    let end = i2;
    let start = i2 + 1;
    let ch = text22[start];
    while (ch === " " || ch === "\t") {
      if (i2 < start + indent) {
        ch = text22[++i2];
      } else {
        do {
          ch = text22[++i2];
        } while (ch && ch !== "\n");
        end = i2;
        start = i2 + 1;
        ch = text22[start];
      }
    }
    return end;
  }
  exports.FOLD_BLOCK = FOLD_BLOCK;
  exports.FOLD_FLOW = FOLD_FLOW;
  exports.FOLD_QUOTED = FOLD_QUOTED;
  exports.foldFlowLines = foldFlowLines;
});
var require_stringifyString = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var foldFlowLines = require_foldFlowLines();
  var getFoldOptions = (ctx, isBlock) => ({
    indentAtStart: isBlock ? ctx.indent.length : ctx.indentAtStart,
    lineWidth: ctx.options.lineWidth,
    minContentWidth: ctx.options.minContentWidth
  });
  var containsDocumentMarker = (str) => /^(%|---|\.\.\.)/m.test(str);
  function lineLengthOverLimit(str, lineWidth, indentLength) {
    if (!lineWidth || lineWidth < 0)
      return false;
    const limit = lineWidth - indentLength;
    const strLen = str.length;
    if (strLen <= limit)
      return false;
    for (let i2 = 0, start = 0;i2 < strLen; ++i2) {
      if (str[i2] === "\n") {
        if (i2 - start > limit)
          return true;
        start = i2 + 1;
        if (strLen - start <= limit)
          return false;
      }
    }
    return true;
  }
  function doubleQuotedString(value, ctx) {
    const json = JSON.stringify(value);
    if (ctx.options.doubleQuotedAsJSON)
      return json;
    const { implicitKey } = ctx;
    const minMultiLineLength = ctx.options.doubleQuotedMinMultiLineLength;
    const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
    let str = "";
    let start = 0;
    for (let i2 = 0, ch = json[i2];ch; ch = json[++i2]) {
      if (ch === " " && json[i2 + 1] === "\\" && json[i2 + 2] === "n") {
        str += json.slice(start, i2) + "\\ ";
        i2 += 1;
        start = i2;
        ch = "\\";
      }
      if (ch === "\\")
        switch (json[i2 + 1]) {
          case "u":
            {
              str += json.slice(start, i2);
              const code = json.substr(i2 + 2, 4);
              switch (code) {
                case "0000":
                  str += "\\0";
                  break;
                case "0007":
                  str += "\\a";
                  break;
                case "000b":
                  str += "\\v";
                  break;
                case "001b":
                  str += "\\e";
                  break;
                case "0085":
                  str += "\\N";
                  break;
                case "00a0":
                  str += "\\_";
                  break;
                case "2028":
                  str += "\\L";
                  break;
                case "2029":
                  str += "\\P";
                  break;
                default:
                  if (code.substr(0, 2) === "00")
                    str += "\\x" + code.substr(2);
                  else
                    str += json.substr(i2, 6);
              }
              i2 += 5;
              start = i2 + 1;
            }
            break;
          case "n":
            if (implicitKey || json[i2 + 2] === '"' || json.length < minMultiLineLength) {
              i2 += 1;
            } else {
              str += json.slice(start, i2) + "\n\n";
              while (json[i2 + 2] === "\\" && json[i2 + 3] === "n" && json[i2 + 4] !== '"') {
                str += "\n";
                i2 += 2;
              }
              str += indent;
              if (json[i2 + 2] === " ")
                str += "\\";
              i2 += 1;
              start = i2 + 1;
            }
            break;
          default:
            i2 += 1;
        }
    }
    str = start ? str + json.slice(start) : json;
    return implicitKey ? str : foldFlowLines.foldFlowLines(str, indent, foldFlowLines.FOLD_QUOTED, getFoldOptions(ctx, false));
  }
  function singleQuotedString(value, ctx) {
    if (ctx.options.singleQuote === false || ctx.implicitKey && value.includes("\n") || /[ \t]\n|\n[ \t]/.test(value))
      return doubleQuotedString(value, ctx);
    const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
    const res = "'" + value.replace(/'/g, "''").replace(/\n+/g, `$&
${indent}`) + "'";
    return ctx.implicitKey ? res : foldFlowLines.foldFlowLines(res, indent, foldFlowLines.FOLD_FLOW, getFoldOptions(ctx, false));
  }
  function quotedString(value, ctx) {
    const { singleQuote } = ctx.options;
    let qs;
    if (singleQuote === false)
      qs = doubleQuotedString;
    else {
      const hasDouble = value.includes('"');
      const hasSingle = value.includes("'");
      if (hasDouble && !hasSingle)
        qs = singleQuotedString;
      else if (hasSingle && !hasDouble)
        qs = doubleQuotedString;
      else
        qs = singleQuote ? singleQuotedString : doubleQuotedString;
    }
    return qs(value, ctx);
  }
  var blockEndNewlines;
  try {
    blockEndNewlines = new RegExp("(^|(?<!\n))\n+(?!\n|$)", "g");
  } catch {
    blockEndNewlines = /\n+(?!\n|$)/g;
  }
  function blockString({ comment, type, value }, ctx, onComment, onChompKeep) {
    const { blockQuote, commentString, lineWidth } = ctx.options;
    if (!blockQuote || /\n[\t ]+$/.test(value) || /^\s*$/.test(value)) {
      return quotedString(value, ctx);
    }
    const indent = ctx.indent || (ctx.forceBlockIndent || containsDocumentMarker(value) ? "  " : "");
    const literal2 = blockQuote === "literal" ? true : blockQuote === "folded" || type === Scalar.Scalar.BLOCK_FOLDED ? false : type === Scalar.Scalar.BLOCK_LITERAL ? true : !lineLengthOverLimit(value, lineWidth, indent.length);
    if (!value)
      return literal2 ? "|\n" : ">\n";
    let chomp;
    let endStart;
    for (endStart = value.length;endStart > 0; --endStart) {
      const ch = value[endStart - 1];
      if (ch !== "\n" && ch !== "\t" && ch !== " ")
        break;
    }
    let end = value.substring(endStart);
    const endNlPos = end.indexOf("\n");
    if (endNlPos === -1) {
      chomp = "-";
    } else if (value === end || endNlPos !== end.length - 1) {
      chomp = "+";
      if (onChompKeep)
        onChompKeep();
    } else {
      chomp = "";
    }
    if (end) {
      value = value.slice(0, -end.length);
      if (end[end.length - 1] === "\n")
        end = end.slice(0, -1);
      end = end.replace(blockEndNewlines, `$&${indent}`);
    }
    let startWithSpace = false;
    let startEnd;
    let startNlPos = -1;
    for (startEnd = 0;startEnd < value.length; ++startEnd) {
      const ch = value[startEnd];
      if (ch === " ")
        startWithSpace = true;
      else if (ch === "\n")
        startNlPos = startEnd;
      else
        break;
    }
    let start = value.substring(0, startNlPos < startEnd ? startNlPos + 1 : startEnd);
    if (start) {
      value = value.substring(start.length);
      start = start.replace(/\n+/g, `$&${indent}`);
    }
    const indentSize = indent ? "2" : "1";
    let header = (literal2 ? "|" : ">") + (startWithSpace ? indentSize : "") + chomp;
    if (comment) {
      header += " " + commentString(comment.replace(/ ?[\r\n]+/g, " "));
      if (onComment)
        onComment();
    }
    if (literal2) {
      value = value.replace(/\n+/g, `$&${indent}`);
      return `${header}\n${indent}${start}${value}${end}`;
    }
    value = value.replace(/\n+/g, "\n$&").replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, `$&${indent}`);
    const body = foldFlowLines.foldFlowLines(`${start}${value}${end}`, indent, foldFlowLines.FOLD_BLOCK, getFoldOptions(ctx, true));
    return `${header}\n${indent}${body}`;
  }
  function plainString(item, ctx, onComment, onChompKeep) {
    const { type, value } = item;
    const { actualString, implicitKey, indent, indentStep, inFlow } = ctx;
    if (implicitKey && value.includes("\n") || inFlow && /[[\]{},]/.test(value)) {
      return quotedString(value, ctx);
    }
    if (!value || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(value)) {
      return implicitKey || inFlow || !value.includes("\n") ? quotedString(value, ctx) : blockString(item, ctx, onComment, onChompKeep);
    }
    if (!implicitKey && !inFlow && type !== Scalar.Scalar.PLAIN && value.includes("\n")) {
      return blockString(item, ctx, onComment, onChompKeep);
    }
    if (containsDocumentMarker(value)) {
      if (indent === "") {
        ctx.forceBlockIndent = true;
        return blockString(item, ctx, onComment, onChompKeep);
      } else if (implicitKey && indent === indentStep) {
        return quotedString(value, ctx);
      }
    }
    const str = value.replace(/\n+/g, `$&
${indent}`);
    if (actualString) {
      const test = (tag) => tag.default && tag.tag !== "tag:yaml.org,2002:str" && tag.test?.test(str);
      const { compat, tags } = ctx.doc.schema;
      if (tags.some(test) || compat?.some(test))
        return quotedString(value, ctx);
    }
    return implicitKey ? str : foldFlowLines.foldFlowLines(str, indent, foldFlowLines.FOLD_FLOW, getFoldOptions(ctx, false));
  }
  function stringifyString(item, ctx, onComment, onChompKeep) {
    const { implicitKey, inFlow } = ctx;
    const ss = typeof item.value === "string" ? item : Object.assign({}, item, { value: String(item.value) });
    let { type } = item;
    if (type !== Scalar.Scalar.QUOTE_DOUBLE) {
      if (/[\x00-\x08\x0b-\x1f\x7f-\x9f\u{D800}-\u{DFFF}]/u.test(ss.value))
        type = Scalar.Scalar.QUOTE_DOUBLE;
    }
    const _stringify = (_type) => {
      switch (_type) {
        case Scalar.Scalar.BLOCK_FOLDED:
        case Scalar.Scalar.BLOCK_LITERAL:
          return implicitKey || inFlow ? quotedString(ss.value, ctx) : blockString(ss, ctx, onComment, onChompKeep);
        case Scalar.Scalar.QUOTE_DOUBLE:
          return doubleQuotedString(ss.value, ctx);
        case Scalar.Scalar.QUOTE_SINGLE:
          return singleQuotedString(ss.value, ctx);
        case Scalar.Scalar.PLAIN:
          return plainString(ss, ctx, onComment, onChompKeep);
        default:
          return null;
      }
    };
    let res = _stringify(type);
    if (res === null) {
      const { defaultKeyType, defaultStringType } = ctx.options;
      const t = implicitKey && defaultKeyType || defaultStringType;
      res = _stringify(t);
      if (res === null)
        throw new Error(`Unsupported default string type ${t}`);
    }
    return res;
  }
  exports.stringifyString = stringifyString;
});
var require_stringify = __commonJS2((exports) => {
  var anchors = require_anchors();
  var identity = require_identity();
  var stringifyComment = require_stringifyComment();
  var stringifyString = require_stringifyString();
  function createStringifyContext(doc, options3) {
    const opt = Object.assign({
      blockQuote: true,
      commentString: stringifyComment.stringifyComment,
      defaultKeyType: null,
      defaultStringType: "PLAIN",
      directives: null,
      doubleQuotedAsJSON: false,
      doubleQuotedMinMultiLineLength: 40,
      falseStr: "false",
      flowCollectionPadding: true,
      indentSeq: true,
      lineWidth: 80,
      minContentWidth: 20,
      nullStr: "null",
      simpleKeys: false,
      singleQuote: null,
      trueStr: "true",
      verifyAliasOrder: true
    }, doc.schema.toStringOptions, options3);
    let inFlow;
    switch (opt.collectionStyle) {
      case "block":
        inFlow = false;
        break;
      case "flow":
        inFlow = true;
        break;
      default:
        inFlow = null;
    }
    return {
      anchors: new Set,
      doc,
      flowCollectionPadding: opt.flowCollectionPadding ? " " : "",
      indent: "",
      indentStep: typeof opt.indent === "number" ? " ".repeat(opt.indent) : "  ",
      inFlow,
      options: opt
    };
  }
  function getTagObject(tags, item) {
    if (item.tag) {
      const match = tags.filter((t) => t.tag === item.tag);
      if (match.length > 0)
        return match.find((t) => t.format === item.format) ?? match[0];
    }
    let tagObj = undefined;
    let obj;
    if (identity.isScalar(item)) {
      obj = item.value;
      let match = tags.filter((t) => t.identify?.(obj));
      if (match.length > 1) {
        const testMatch = match.filter((t) => t.test);
        if (testMatch.length > 0)
          match = testMatch;
      }
      tagObj = match.find((t) => t.format === item.format) ?? match.find((t) => !t.format);
    } else {
      obj = item;
      tagObj = tags.find((t) => t.nodeClass && obj instanceof t.nodeClass);
    }
    if (!tagObj) {
      const name = obj?.constructor?.name ?? typeof obj;
      throw new Error(`Tag not resolved for ${name} value`);
    }
    return tagObj;
  }
  function stringifyProps(node, tagObj, { anchors: anchors$1, doc }) {
    if (!doc.directives)
      return "";
    const props = [];
    const anchor = (identity.isScalar(node) || identity.isCollection(node)) && node.anchor;
    if (anchor && anchors.anchorIsValid(anchor)) {
      anchors$1.add(anchor);
      props.push(`&${anchor}`);
    }
    const tag = node.tag ? node.tag : tagObj.default ? null : tagObj.tag;
    if (tag)
      props.push(doc.directives.tagString(tag));
    return props.join(" ");
  }
  function stringify(item, ctx, onComment, onChompKeep) {
    if (identity.isPair(item))
      return item.toString(ctx, onComment, onChompKeep);
    if (identity.isAlias(item)) {
      if (ctx.doc.directives)
        return item.toString(ctx);
      if (ctx.resolvedAliases?.has(item)) {
        throw new TypeError(`Cannot stringify circular structure without alias nodes`);
      } else {
        if (ctx.resolvedAliases)
          ctx.resolvedAliases.add(item);
        else
          ctx.resolvedAliases = new Set([item]);
        item = item.resolve(ctx.doc);
      }
    }
    let tagObj = undefined;
    const node = identity.isNode(item) ? item : ctx.doc.createNode(item, { onTagObj: (o) => tagObj = o });
    if (!tagObj)
      tagObj = getTagObject(ctx.doc.schema.tags, node);
    const props = stringifyProps(node, tagObj, ctx);
    if (props.length > 0)
      ctx.indentAtStart = (ctx.indentAtStart ?? 0) + props.length + 1;
    const str = typeof tagObj.stringify === "function" ? tagObj.stringify(node, ctx, onComment, onChompKeep) : identity.isScalar(node) ? stringifyString.stringifyString(node, ctx, onComment, onChompKeep) : node.toString(ctx, onComment, onChompKeep);
    if (!props)
      return str;
    return identity.isScalar(node) || str[0] === "{" || str[0] === "[" ? `${props} ${str}` : `${props}\n${ctx.indent}${str}`;
  }
  exports.createStringifyContext = createStringifyContext;
  exports.stringify = stringify;
});
var require_stringifyPair = __commonJS2((exports) => {
  var identity = require_identity();
  var Scalar = require_Scalar();
  var stringify = require_stringify();
  var stringifyComment = require_stringifyComment();
  function stringifyPair({ key: key2, value }, ctx, onComment, onChompKeep) {
    const { allNullValues, doc, indent, indentStep, options: { commentString, indentSeq, simpleKeys } } = ctx;
    let keyComment = identity.isNode(key2) && key2.comment || null;
    if (simpleKeys) {
      if (keyComment) {
        throw new Error("With simple keys, key nodes cannot have comments");
      }
      if (identity.isCollection(key2) || !identity.isNode(key2) && typeof key2 === "object") {
        const msg = "With simple keys, collection cannot be used as a key value";
        throw new Error(msg);
      }
    }
    let explicitKey = !simpleKeys && (!key2 || keyComment && value == null && !ctx.inFlow || identity.isCollection(key2) || (identity.isScalar(key2) ? key2.type === Scalar.Scalar.BLOCK_FOLDED || key2.type === Scalar.Scalar.BLOCK_LITERAL : typeof key2 === "object"));
    ctx = Object.assign({}, ctx, {
      allNullValues: false,
      implicitKey: !explicitKey && (simpleKeys || !allNullValues),
      indent: indent + indentStep
    });
    let keyCommentDone = false;
    let chompKeep = false;
    let str = stringify.stringify(key2, ctx, () => keyCommentDone = true, () => chompKeep = true);
    if (!explicitKey && !ctx.inFlow && str.length > 1024) {
      if (simpleKeys)
        throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
      explicitKey = true;
    }
    if (ctx.inFlow) {
      if (allNullValues || value == null) {
        if (keyCommentDone && onComment)
          onComment();
        return str === "" ? "?" : explicitKey ? `? ${str}` : str;
      }
    } else if (allNullValues && !simpleKeys || value == null && explicitKey) {
      str = `? ${str}`;
      if (keyComment && !keyCommentDone) {
        str += stringifyComment.lineComment(str, ctx.indent, commentString(keyComment));
      } else if (chompKeep && onChompKeep)
        onChompKeep();
      return str;
    }
    if (keyCommentDone)
      keyComment = null;
    if (explicitKey) {
      if (keyComment)
        str += stringifyComment.lineComment(str, ctx.indent, commentString(keyComment));
      str = `? ${str}\n${indent}:`;
    } else {
      str = `${str}:`;
      if (keyComment)
        str += stringifyComment.lineComment(str, ctx.indent, commentString(keyComment));
    }
    let vsb, vcb, valueComment;
    if (identity.isNode(value)) {
      vsb = !!value.spaceBefore;
      vcb = value.commentBefore;
      valueComment = value.comment;
    } else {
      vsb = false;
      vcb = null;
      valueComment = null;
      if (value && typeof value === "object")
        value = doc.createNode(value);
    }
    ctx.implicitKey = false;
    if (!explicitKey && !keyComment && identity.isScalar(value))
      ctx.indentAtStart = str.length + 1;
    chompKeep = false;
    if (!indentSeq && indentStep.length >= 2 && !ctx.inFlow && !explicitKey && identity.isSeq(value) && !value.flow && !value.tag && !value.anchor) {
      ctx.indent = ctx.indent.substring(2);
    }
    let valueCommentDone = false;
    const valueStr = stringify.stringify(value, ctx, () => valueCommentDone = true, () => chompKeep = true);
    let ws = " ";
    if (keyComment || vsb || vcb) {
      ws = vsb ? "\n" : "";
      if (vcb) {
        const cs = commentString(vcb);
        ws += `\n${stringifyComment.indentComment(cs, ctx.indent)}`;
      }
      if (valueStr === "" && !ctx.inFlow) {
        if (ws === "\n")
          ws = "\n\n";
      } else {
        ws += `\n${ctx.indent}`;
      }
    } else if (!explicitKey && identity.isCollection(value)) {
      const vs0 = valueStr[0];
      const nl0 = valueStr.indexOf("\n");
      const hasNewline = nl0 !== -1;
      const flow = ctx.inFlow ?? value.flow ?? value.items.length === 0;
      if (hasNewline || !flow) {
        let hasPropsLine = false;
        if (hasNewline && (vs0 === "&" || vs0 === "!")) {
          let sp0 = valueStr.indexOf(" ");
          if (vs0 === "&" && sp0 !== -1 && sp0 < nl0 && valueStr[sp0 + 1] === "!") {
            sp0 = valueStr.indexOf(" ", sp0 + 1);
          }
          if (sp0 === -1 || nl0 < sp0)
            hasPropsLine = true;
        }
        if (!hasPropsLine)
          ws = `\n${ctx.indent}`;
      }
    } else if (valueStr === "" || valueStr[0] === "\n") {
      ws = "";
    }
    str += ws + valueStr;
    if (ctx.inFlow) {
      if (valueCommentDone && onComment)
        onComment();
    } else if (valueComment && !valueCommentDone) {
      str += stringifyComment.lineComment(str, ctx.indent, commentString(valueComment));
    } else if (chompKeep && onChompKeep) {
      onChompKeep();
    }
    return str;
  }
  exports.stringifyPair = stringifyPair;
});
var require_log = __commonJS2((exports) => {
  function debug(logLevel22, ...messages3) {
    if (logLevel22 === "debug")
      console.log(...messages3);
  }
  function warn(logLevel22, warning) {
    if (logLevel22 === "debug" || logLevel22 === "warn") {
      if (typeof process !== "undefined" && process.emitWarning)
        process.emitWarning(warning);
      else
        console.warn(warning);
    }
  }
  exports.debug = debug;
  exports.warn = warn;
});
var require_merge22 = __commonJS2((exports) => {
  var identity = require_identity();
  var Scalar = require_Scalar();
  var MERGE_KEY = "<<";
  var merge = {
    identify: (value) => value === MERGE_KEY || typeof value === "symbol" && value.description === MERGE_KEY,
    default: "key",
    tag: "tag:yaml.org,2002:merge",
    test: /^<<$/,
    resolve: () => Object.assign(new Scalar.Scalar(Symbol(MERGE_KEY)), {
      addToJSMap: addMergeToJSMap
    }),
    stringify: () => MERGE_KEY
  };
  var isMergeKey = (ctx, key2) => (merge.identify(key2) || identity.isScalar(key2) && (!key2.type || key2.type === Scalar.Scalar.PLAIN) && merge.identify(key2.value)) && ctx?.doc.schema.tags.some((tag) => tag.tag === merge.tag && tag.default);
  function addMergeToJSMap(ctx, map, value) {
    value = ctx && identity.isAlias(value) ? value.resolve(ctx.doc) : value;
    if (identity.isSeq(value))
      for (const it of value.items)
        mergeValue(ctx, map, it);
    else if (Array.isArray(value))
      for (const it of value)
        mergeValue(ctx, map, it);
    else
      mergeValue(ctx, map, value);
  }
  function mergeValue(ctx, map, value) {
    const source = ctx && identity.isAlias(value) ? value.resolve(ctx.doc) : value;
    if (!identity.isMap(source))
      throw new Error("Merge sources must be maps or map aliases");
    const srcMap = source.toJSON(null, ctx, Map);
    for (const [key2, value2] of srcMap) {
      if (map instanceof Map) {
        if (!map.has(key2))
          map.set(key2, value2);
      } else if (map instanceof Set) {
        map.add(key2);
      } else if (!Object.prototype.hasOwnProperty.call(map, key2)) {
        Object.defineProperty(map, key2, {
          value: value2,
          writable: true,
          enumerable: true,
          configurable: true
        });
      }
    }
    return map;
  }
  exports.addMergeToJSMap = addMergeToJSMap;
  exports.isMergeKey = isMergeKey;
  exports.merge = merge;
});
var require_addPairToJSMap = __commonJS2((exports) => {
  var log3 = require_log();
  var merge = require_merge22();
  var stringify = require_stringify();
  var identity = require_identity();
  var toJS = require_toJS();
  function addPairToJSMap(ctx, map, { key: key2, value }) {
    if (identity.isNode(key2) && key2.addToJSMap)
      key2.addToJSMap(ctx, map, value);
    else if (merge.isMergeKey(ctx, key2))
      merge.addMergeToJSMap(ctx, map, value);
    else {
      const jsKey = toJS.toJS(key2, "", ctx);
      if (map instanceof Map) {
        map.set(jsKey, toJS.toJS(value, jsKey, ctx));
      } else if (map instanceof Set) {
        map.add(jsKey);
      } else {
        const stringKey = stringifyKey(key2, jsKey, ctx);
        const jsValue = toJS.toJS(value, stringKey, ctx);
        if (stringKey in map)
          Object.defineProperty(map, stringKey, {
            value: jsValue,
            writable: true,
            enumerable: true,
            configurable: true
          });
        else
          map[stringKey] = jsValue;
      }
    }
    return map;
  }
  function stringifyKey(key2, jsKey, ctx) {
    if (jsKey === null)
      return "";
    if (typeof jsKey !== "object")
      return String(jsKey);
    if (identity.isNode(key2) && ctx?.doc) {
      const strCtx = stringify.createStringifyContext(ctx.doc, {});
      strCtx.anchors = new Set;
      for (const node of ctx.anchors.keys())
        strCtx.anchors.add(node.anchor);
      strCtx.inFlow = true;
      strCtx.inStringifyKey = true;
      const strKey = key2.toString(strCtx);
      if (!ctx.mapKeyWarned) {
        let jsonStr = JSON.stringify(strKey);
        if (jsonStr.length > 40)
          jsonStr = jsonStr.substring(0, 36) + '..."';
        log3.warn(ctx.doc.options.logLevel, `Keys with collection values will be stringified due to JS Object restrictions: ${jsonStr}. Set mapAsMap: true to use object keys.`);
        ctx.mapKeyWarned = true;
      }
      return strKey;
    }
    return JSON.stringify(jsKey);
  }
  exports.addPairToJSMap = addPairToJSMap;
});
var require_Pair = __commonJS2((exports) => {
  var createNode = require_createNode();
  var stringifyPair = require_stringifyPair();
  var addPairToJSMap = require_addPairToJSMap();
  var identity = require_identity();
  function createPair(key2, value, ctx) {
    const k = createNode.createNode(key2, undefined, ctx);
    const v22 = createNode.createNode(value, undefined, ctx);
    return new Pair(k, v22);
  }

  class Pair {
    constructor(key2, value = null) {
      Object.defineProperty(this, identity.NODE_TYPE, { value: identity.PAIR });
      this.key = key2;
      this.value = value;
    }
    clone(schema4) {
      let { key: key2, value } = this;
      if (identity.isNode(key2))
        key2 = key2.clone(schema4);
      if (identity.isNode(value))
        value = value.clone(schema4);
      return new Pair(key2, value);
    }
    toJSON(_22, ctx) {
      const pair = ctx?.mapAsMap ? new Map : {};
      return addPairToJSMap.addPairToJSMap(ctx, pair, this);
    }
    toString(ctx, onComment, onChompKeep) {
      return ctx?.doc ? stringifyPair.stringifyPair(this, ctx, onComment, onChompKeep) : JSON.stringify(this);
    }
  }
  exports.Pair = Pair;
  exports.createPair = createPair;
});
var require_stringifyCollection = __commonJS2((exports) => {
  var identity = require_identity();
  var stringify = require_stringify();
  var stringifyComment = require_stringifyComment();
  function stringifyCollection(collection, ctx, options3) {
    const flow = ctx.inFlow ?? collection.flow;
    const stringify2 = flow ? stringifyFlowCollection : stringifyBlockCollection;
    return stringify2(collection, ctx, options3);
  }
  function stringifyBlockCollection({ comment, items }, ctx, { blockItemPrefix, flowChars, itemIndent, onChompKeep, onComment }) {
    const { indent, options: { commentString } } = ctx;
    const itemCtx = Object.assign({}, ctx, { indent: itemIndent, type: null });
    let chompKeep = false;
    const lines = [];
    for (let i2 = 0;i2 < items.length; ++i2) {
      const item = items[i2];
      let comment2 = null;
      if (identity.isNode(item)) {
        if (!chompKeep && item.spaceBefore)
          lines.push("");
        addCommentBefore(ctx, lines, item.commentBefore, chompKeep);
        if (item.comment)
          comment2 = item.comment;
      } else if (identity.isPair(item)) {
        const ik = identity.isNode(item.key) ? item.key : null;
        if (ik) {
          if (!chompKeep && ik.spaceBefore)
            lines.push("");
          addCommentBefore(ctx, lines, ik.commentBefore, chompKeep);
        }
      }
      chompKeep = false;
      let str2 = stringify.stringify(item, itemCtx, () => comment2 = null, () => chompKeep = true);
      if (comment2)
        str2 += stringifyComment.lineComment(str2, itemIndent, commentString(comment2));
      if (chompKeep && comment2)
        chompKeep = false;
      lines.push(blockItemPrefix + str2);
    }
    let str;
    if (lines.length === 0) {
      str = flowChars.start + flowChars.end;
    } else {
      str = lines[0];
      for (let i2 = 1;i2 < lines.length; ++i2) {
        const line = lines[i2];
        str += line ? `\n${indent}${line}` : "\n";
      }
    }
    if (comment) {
      str += "\n" + stringifyComment.indentComment(commentString(comment), indent);
      if (onComment)
        onComment();
    } else if (chompKeep && onChompKeep)
      onChompKeep();
    return str;
  }
  function stringifyFlowCollection({ items }, ctx, { flowChars, itemIndent }) {
    const { indent, indentStep, flowCollectionPadding: fcPadding, options: { commentString } } = ctx;
    itemIndent += indentStep;
    const itemCtx = Object.assign({}, ctx, {
      indent: itemIndent,
      inFlow: true,
      type: null
    });
    let reqNewline = false;
    let linesAtValue = 0;
    const lines = [];
    for (let i2 = 0;i2 < items.length; ++i2) {
      const item = items[i2];
      let comment = null;
      if (identity.isNode(item)) {
        if (item.spaceBefore)
          lines.push("");
        addCommentBefore(ctx, lines, item.commentBefore, false);
        if (item.comment)
          comment = item.comment;
      } else if (identity.isPair(item)) {
        const ik = identity.isNode(item.key) ? item.key : null;
        if (ik) {
          if (ik.spaceBefore)
            lines.push("");
          addCommentBefore(ctx, lines, ik.commentBefore, false);
          if (ik.comment)
            reqNewline = true;
        }
        const iv = identity.isNode(item.value) ? item.value : null;
        if (iv) {
          if (iv.comment)
            comment = iv.comment;
          if (iv.commentBefore)
            reqNewline = true;
        } else if (item.value == null && ik?.comment) {
          comment = ik.comment;
        }
      }
      if (comment)
        reqNewline = true;
      let str = stringify.stringify(item, itemCtx, () => comment = null);
      if (i2 < items.length - 1)
        str += ",";
      if (comment)
        str += stringifyComment.lineComment(str, itemIndent, commentString(comment));
      if (!reqNewline && (lines.length > linesAtValue || str.includes("\n")))
        reqNewline = true;
      lines.push(str);
      linesAtValue = lines.length;
    }
    const { start, end } = flowChars;
    if (lines.length === 0) {
      return start + end;
    } else {
      if (!reqNewline) {
        const len = lines.reduce((sum, line) => sum + line.length + 2, 2);
        reqNewline = ctx.options.lineWidth > 0 && len > ctx.options.lineWidth;
      }
      if (reqNewline) {
        let str = start;
        for (const line of lines)
          str += line ? `\n${indentStep}${indent}${line}` : "\n";
        return `${str}\n${indent}${end}`;
      } else {
        return `${start}${fcPadding}${lines.join(" ")}${fcPadding}${end}`;
      }
    }
  }
  function addCommentBefore({ indent, options: { commentString } }, lines, comment, chompKeep) {
    if (comment && chompKeep)
      comment = comment.replace(/^\n+/, "");
    if (comment) {
      const ic = stringifyComment.indentComment(commentString(comment), indent);
      lines.push(ic.trimStart());
    }
  }
  exports.stringifyCollection = stringifyCollection;
});
var require_YAMLMap = __commonJS2((exports) => {
  var stringifyCollection = require_stringifyCollection();
  var addPairToJSMap = require_addPairToJSMap();
  var Collection22 = require_Collection();
  var identity = require_identity();
  var Pair = require_Pair();
  var Scalar = require_Scalar();
  function findPair(items, key2) {
    const k = identity.isScalar(key2) ? key2.value : key2;
    for (const it of items) {
      if (identity.isPair(it)) {
        if (it.key === key2 || it.key === k)
          return it;
        if (identity.isScalar(it.key) && it.key.value === k)
          return it;
      }
    }
    return;
  }

  class YAMLMap extends Collection22.Collection {
    static get tagName() {
      return "tag:yaml.org,2002:map";
    }
    constructor(schema4) {
      super(identity.MAP, schema4);
      this.items = [];
    }
    static from(schema4, obj, ctx) {
      const { keepUndefined, replacer } = ctx;
      const map = new this(schema4);
      const add2 = (key2, value) => {
        if (typeof replacer === "function")
          value = replacer.call(obj, key2, value);
        else if (Array.isArray(replacer) && !replacer.includes(key2))
          return;
        if (value !== undefined || keepUndefined)
          map.items.push(Pair.createPair(key2, value, ctx));
      };
      if (obj instanceof Map) {
        for (const [key2, value] of obj)
          add2(key2, value);
      } else if (obj && typeof obj === "object") {
        for (const key2 of Object.keys(obj))
          add2(key2, obj[key2]);
      }
      if (typeof schema4.sortMapEntries === "function") {
        map.items.sort(schema4.sortMapEntries);
      }
      return map;
    }
    add(pair, overwrite) {
      let _pair;
      if (identity.isPair(pair))
        _pair = pair;
      else if (!pair || typeof pair !== "object" || !("key" in pair)) {
        _pair = new Pair.Pair(pair, pair?.value);
      } else
        _pair = new Pair.Pair(pair.key, pair.value);
      const prev = findPair(this.items, _pair.key);
      const sortEntries = this.schema?.sortMapEntries;
      if (prev) {
        if (!overwrite)
          throw new Error(`Key ${_pair.key} already set`);
        if (identity.isScalar(prev.value) && Scalar.isScalarValue(_pair.value))
          prev.value.value = _pair.value;
        else
          prev.value = _pair.value;
      } else if (sortEntries) {
        const i2 = this.items.findIndex((item) => sortEntries(_pair, item) < 0);
        if (i2 === -1)
          this.items.push(_pair);
        else
          this.items.splice(i2, 0, _pair);
      } else {
        this.items.push(_pair);
      }
    }
    delete(key2) {
      const it = findPair(this.items, key2);
      if (!it)
        return false;
      const del = this.items.splice(this.items.indexOf(it), 1);
      return del.length > 0;
    }
    get(key2, keepScalar) {
      const it = findPair(this.items, key2);
      const node = it?.value;
      return (!keepScalar && identity.isScalar(node) ? node.value : node) ?? undefined;
    }
    has(key2) {
      return !!findPair(this.items, key2);
    }
    set(key2, value) {
      this.add(new Pair.Pair(key2, value), true);
    }
    toJSON(_22, ctx, Type) {
      const map = Type ? new Type : ctx?.mapAsMap ? new Map : {};
      if (ctx?.onCreate)
        ctx.onCreate(map);
      for (const item of this.items)
        addPairToJSMap.addPairToJSMap(ctx, map, item);
      return map;
    }
    toString(ctx, onComment, onChompKeep) {
      if (!ctx)
        return JSON.stringify(this);
      for (const item of this.items) {
        if (!identity.isPair(item))
          throw new Error(`Map items must all be pairs; found ${JSON.stringify(item)} instead`);
      }
      if (!ctx.allNullValues && this.hasAllNullValues(false))
        ctx = Object.assign({}, ctx, { allNullValues: true });
      return stringifyCollection.stringifyCollection(this, ctx, {
        blockItemPrefix: "",
        flowChars: { start: "{", end: "}" },
        itemIndent: ctx.indent || "",
        onChompKeep,
        onComment
      });
    }
  }
  exports.YAMLMap = YAMLMap;
  exports.findPair = findPair;
});
var require_map = __commonJS2((exports) => {
  var identity = require_identity();
  var YAMLMap = require_YAMLMap();
  var map = {
    collection: "map",
    default: true,
    nodeClass: YAMLMap.YAMLMap,
    tag: "tag:yaml.org,2002:map",
    resolve(map2, onError2) {
      if (!identity.isMap(map2))
        onError2("Expected a mapping for this tag");
      return map2;
    },
    createNode: (schema4, obj, ctx) => YAMLMap.YAMLMap.from(schema4, obj, ctx)
  };
  exports.map = map;
});
var require_YAMLSeq = __commonJS2((exports) => {
  var createNode = require_createNode();
  var stringifyCollection = require_stringifyCollection();
  var Collection22 = require_Collection();
  var identity = require_identity();
  var Scalar = require_Scalar();
  var toJS = require_toJS();

  class YAMLSeq extends Collection22.Collection {
    static get tagName() {
      return "tag:yaml.org,2002:seq";
    }
    constructor(schema4) {
      super(identity.SEQ, schema4);
      this.items = [];
    }
    add(value) {
      this.items.push(value);
    }
    delete(key2) {
      const idx = asItemIndex(key2);
      if (typeof idx !== "number")
        return false;
      const del = this.items.splice(idx, 1);
      return del.length > 0;
    }
    get(key2, keepScalar) {
      const idx = asItemIndex(key2);
      if (typeof idx !== "number")
        return;
      const it = this.items[idx];
      return !keepScalar && identity.isScalar(it) ? it.value : it;
    }
    has(key2) {
      const idx = asItemIndex(key2);
      return typeof idx === "number" && idx < this.items.length;
    }
    set(key2, value) {
      const idx = asItemIndex(key2);
      if (typeof idx !== "number")
        throw new Error(`Expected a valid index, not ${key2}.`);
      const prev = this.items[idx];
      if (identity.isScalar(prev) && Scalar.isScalarValue(value))
        prev.value = value;
      else
        this.items[idx] = value;
    }
    toJSON(_22, ctx) {
      const seq = [];
      if (ctx?.onCreate)
        ctx.onCreate(seq);
      let i2 = 0;
      for (const item of this.items)
        seq.push(toJS.toJS(item, String(i2++), ctx));
      return seq;
    }
    toString(ctx, onComment, onChompKeep) {
      if (!ctx)
        return JSON.stringify(this);
      return stringifyCollection.stringifyCollection(this, ctx, {
        blockItemPrefix: "- ",
        flowChars: { start: "[", end: "]" },
        itemIndent: (ctx.indent || "") + "  ",
        onChompKeep,
        onComment
      });
    }
    static from(schema4, obj, ctx) {
      const { replacer } = ctx;
      const seq = new this(schema4);
      if (obj && Symbol.iterator in Object(obj)) {
        let i2 = 0;
        for (let it of obj) {
          if (typeof replacer === "function") {
            const key2 = obj instanceof Set ? it : String(i2++);
            it = replacer.call(obj, key2, it);
          }
          seq.items.push(createNode.createNode(it, undefined, ctx));
        }
      }
      return seq;
    }
  }
  function asItemIndex(key2) {
    let idx = identity.isScalar(key2) ? key2.value : key2;
    if (idx && typeof idx === "string")
      idx = Number(idx);
    return typeof idx === "number" && Number.isInteger(idx) && idx >= 0 ? idx : null;
  }
  exports.YAMLSeq = YAMLSeq;
});
var require_seq = __commonJS2((exports) => {
  var identity = require_identity();
  var YAMLSeq = require_YAMLSeq();
  var seq = {
    collection: "seq",
    default: true,
    nodeClass: YAMLSeq.YAMLSeq,
    tag: "tag:yaml.org,2002:seq",
    resolve(seq2, onError2) {
      if (!identity.isSeq(seq2))
        onError2("Expected a sequence for this tag");
      return seq2;
    },
    createNode: (schema4, obj, ctx) => YAMLSeq.YAMLSeq.from(schema4, obj, ctx)
  };
  exports.seq = seq;
});
var require_string3 = __commonJS2((exports) => {
  var stringifyString = require_stringifyString();
  var string2 = {
    identify: (value) => typeof value === "string",
    default: true,
    tag: "tag:yaml.org,2002:str",
    resolve: (str) => str,
    stringify(item, ctx, onComment, onChompKeep) {
      ctx = Object.assign({ actualString: true }, ctx);
      return stringifyString.stringifyString(item, ctx, onComment, onChompKeep);
    }
  };
  exports.string = string2;
});
var require_null = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var nullTag = {
    identify: (value) => value == null,
    createNode: () => new Scalar.Scalar(null),
    default: true,
    tag: "tag:yaml.org,2002:null",
    test: /^(?:~|[Nn]ull|NULL)?$/,
    resolve: () => new Scalar.Scalar(null),
    stringify: ({ source }, ctx) => typeof source === "string" && nullTag.test.test(source) ? source : ctx.options.nullStr
  };
  exports.nullTag = nullTag;
});
var require_bool = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var boolTag = {
    identify: (value) => typeof value === "boolean",
    default: true,
    tag: "tag:yaml.org,2002:bool",
    test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/,
    resolve: (str) => new Scalar.Scalar(str[0] === "t" || str[0] === "T"),
    stringify({ source, value }, ctx) {
      if (source && boolTag.test.test(source)) {
        const sv = source[0] === "t" || source[0] === "T";
        if (value === sv)
          return source;
      }
      return value ? ctx.options.trueStr : ctx.options.falseStr;
    }
  };
  exports.boolTag = boolTag;
});
var require_stringifyNumber = __commonJS2((exports) => {
  function stringifyNumber({ format, minFractionDigits, tag, value }) {
    if (typeof value === "bigint")
      return String(value);
    const num = typeof value === "number" ? value : Number(value);
    if (!isFinite(num))
      return isNaN(num) ? ".nan" : num < 0 ? "-.inf" : ".inf";
    let n = JSON.stringify(value);
    if (!format && minFractionDigits && (!tag || tag === "tag:yaml.org,2002:float") && /^\d/.test(n)) {
      let i2 = n.indexOf(".");
      if (i2 < 0) {
        i2 = n.length;
        n += ".";
      }
      let d = minFractionDigits - (n.length - i2 - 1);
      while (d-- > 0)
        n += "0";
    }
    return n;
  }
  exports.stringifyNumber = stringifyNumber;
});
var require_float = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var stringifyNumber = require_stringifyNumber();
  var floatNaN = {
    identify: (value) => typeof value === "number",
    default: true,
    tag: "tag:yaml.org,2002:float",
    test: /^(?:[-+]?\.(?:inf|Inf|INF)|\.nan|\.NaN|\.NAN)$/,
    resolve: (str) => str.slice(-3).toLowerCase() === "nan" ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
    stringify: stringifyNumber.stringifyNumber
  };
  var floatExp = {
    identify: (value) => typeof value === "number",
    default: true,
    tag: "tag:yaml.org,2002:float",
    format: "EXP",
    test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/,
    resolve: (str) => parseFloat(str),
    stringify(node) {
      const num = Number(node.value);
      return isFinite(num) ? num.toExponential() : stringifyNumber.stringifyNumber(node);
    }
  };
  var float = {
    identify: (value) => typeof value === "number",
    default: true,
    tag: "tag:yaml.org,2002:float",
    test: /^[-+]?(?:\.[0-9]+|[0-9]+\.[0-9]*)$/,
    resolve(str) {
      const node = new Scalar.Scalar(parseFloat(str));
      const dot = str.indexOf(".");
      if (dot !== -1 && str[str.length - 1] === "0")
        node.minFractionDigits = str.length - dot - 1;
      return node;
    },
    stringify: stringifyNumber.stringifyNumber
  };
  exports.float = float;
  exports.floatExp = floatExp;
  exports.floatNaN = floatNaN;
});
var require_int = __commonJS2((exports) => {
  var stringifyNumber = require_stringifyNumber();
  var intIdentify = (value) => typeof value === "bigint" || Number.isInteger(value);
  var intResolve = (str, offset2, radix, { intAsBigInt }) => intAsBigInt ? BigInt(str) : parseInt(str.substring(offset2), radix);
  function intStringify(node, radix, prefix) {
    const { value } = node;
    if (intIdentify(value) && value >= 0)
      return prefix + value.toString(radix);
    return stringifyNumber.stringifyNumber(node);
  }
  var intOct = {
    identify: (value) => intIdentify(value) && value >= 0,
    default: true,
    tag: "tag:yaml.org,2002:int",
    format: "OCT",
    test: /^0o[0-7]+$/,
    resolve: (str, _onError, opt) => intResolve(str, 2, 8, opt),
    stringify: (node) => intStringify(node, 8, "0o")
  };
  var int = {
    identify: intIdentify,
    default: true,
    tag: "tag:yaml.org,2002:int",
    test: /^[-+]?[0-9]+$/,
    resolve: (str, _onError, opt) => intResolve(str, 0, 10, opt),
    stringify: stringifyNumber.stringifyNumber
  };
  var intHex = {
    identify: (value) => intIdentify(value) && value >= 0,
    default: true,
    tag: "tag:yaml.org,2002:int",
    format: "HEX",
    test: /^0x[0-9a-fA-F]+$/,
    resolve: (str, _onError, opt) => intResolve(str, 2, 16, opt),
    stringify: (node) => intStringify(node, 16, "0x")
  };
  exports.int = int;
  exports.intHex = intHex;
  exports.intOct = intOct;
});
var require_schema = __commonJS2((exports) => {
  var map = require_map();
  var _null = require_null();
  var seq = require_seq();
  var string2 = require_string3();
  var bool = require_bool();
  var float = require_float();
  var int = require_int();
  var schema4 = [
    map.map,
    seq.seq,
    string2.string,
    _null.nullTag,
    bool.boolTag,
    int.intOct,
    int.int,
    int.intHex,
    float.floatNaN,
    float.floatExp,
    float.float
  ];
  exports.schema = schema4;
});
var require_schema2 = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var map = require_map();
  var seq = require_seq();
  function intIdentify(value) {
    return typeof value === "bigint" || Number.isInteger(value);
  }
  var stringifyJSON = ({ value }) => JSON.stringify(value);
  var jsonScalars = [
    {
      identify: (value) => typeof value === "string",
      default: true,
      tag: "tag:yaml.org,2002:str",
      resolve: (str) => str,
      stringify: stringifyJSON
    },
    {
      identify: (value) => value == null,
      createNode: () => new Scalar.Scalar(null),
      default: true,
      tag: "tag:yaml.org,2002:null",
      test: /^null$/,
      resolve: () => null,
      stringify: stringifyJSON
    },
    {
      identify: (value) => typeof value === "boolean",
      default: true,
      tag: "tag:yaml.org,2002:bool",
      test: /^true|false$/,
      resolve: (str) => str === "true",
      stringify: stringifyJSON
    },
    {
      identify: intIdentify,
      default: true,
      tag: "tag:yaml.org,2002:int",
      test: /^-?(?:0|[1-9][0-9]*)$/,
      resolve: (str, _onError, { intAsBigInt }) => intAsBigInt ? BigInt(str) : parseInt(str, 10),
      stringify: ({ value }) => intIdentify(value) ? value.toString() : JSON.stringify(value)
    },
    {
      identify: (value) => typeof value === "number",
      default: true,
      tag: "tag:yaml.org,2002:float",
      test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/,
      resolve: (str) => parseFloat(str),
      stringify: stringifyJSON
    }
  ];
  var jsonError = {
    default: true,
    tag: "",
    test: /^/,
    resolve(str, onError2) {
      onError2(`Unresolved plain scalar ${JSON.stringify(str)}`);
      return str;
    }
  };
  var schema4 = [map.map, seq.seq].concat(jsonScalars, jsonError);
  exports.schema = schema4;
});
var require_binary = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var stringifyString = require_stringifyString();
  var binary2 = {
    identify: (value) => value instanceof Uint8Array,
    default: false,
    tag: "tag:yaml.org,2002:binary",
    resolve(src22, onError2) {
      if (typeof Buffer === "function") {
        return Buffer.from(src22, "base64");
      } else if (typeof atob === "function") {
        const str = atob(src22.replace(/[\n\r]/g, ""));
        const buffer = new Uint8Array(str.length);
        for (let i2 = 0;i2 < str.length; ++i2)
          buffer[i2] = str.charCodeAt(i2);
        return buffer;
      } else {
        onError2("This environment does not support reading binary tags; either Buffer or atob is required");
        return src22;
      }
    },
    stringify({ comment, type, value }, ctx, onComment, onChompKeep) {
      const buf = value;
      let str;
      if (typeof Buffer === "function") {
        str = buf instanceof Buffer ? buf.toString("base64") : Buffer.from(buf.buffer).toString("base64");
      } else if (typeof btoa === "function") {
        let s32 = "";
        for (let i2 = 0;i2 < buf.length; ++i2)
          s32 += String.fromCharCode(buf[i2]);
        str = btoa(s32);
      } else {
        throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
      }
      if (!type)
        type = Scalar.Scalar.BLOCK_LITERAL;
      if (type !== Scalar.Scalar.QUOTE_DOUBLE) {
        const lineWidth = Math.max(ctx.options.lineWidth - ctx.indent.length, ctx.options.minContentWidth);
        const n = Math.ceil(str.length / lineWidth);
        const lines = new Array(n);
        for (let i2 = 0, o = 0;i2 < n; ++i2, o += lineWidth) {
          lines[i2] = str.substr(o, lineWidth);
        }
        str = lines.join(type === Scalar.Scalar.BLOCK_LITERAL ? "\n" : " ");
      }
      return stringifyString.stringifyString({ comment, type, value: str }, ctx, onComment, onChompKeep);
    }
  };
  exports.binary = binary2;
});
var require_pairs = __commonJS2((exports) => {
  var identity = require_identity();
  var Pair = require_Pair();
  var Scalar = require_Scalar();
  var YAMLSeq = require_YAMLSeq();
  function resolvePairs(seq, onError2) {
    if (identity.isSeq(seq)) {
      for (let i2 = 0;i2 < seq.items.length; ++i2) {
        let item = seq.items[i2];
        if (identity.isPair(item))
          continue;
        else if (identity.isMap(item)) {
          if (item.items.length > 1)
            onError2("Each pair must have its own sequence indicator");
          const pair = item.items[0] || new Pair.Pair(new Scalar.Scalar(null));
          if (item.commentBefore)
            pair.key.commentBefore = pair.key.commentBefore ? `${item.commentBefore}\n${pair.key.commentBefore}` : item.commentBefore;
          if (item.comment) {
            const cn = pair.value ?? pair.key;
            cn.comment = cn.comment ? `${item.comment}\n${cn.comment}` : item.comment;
          }
          item = pair;
        }
        seq.items[i2] = identity.isPair(item) ? item : new Pair.Pair(item);
      }
    } else
      onError2("Expected a sequence for this tag");
    return seq;
  }
  function createPairs(schema4, iterable, ctx) {
    const { replacer } = ctx;
    const pairs2 = new YAMLSeq.YAMLSeq(schema4);
    pairs2.tag = "tag:yaml.org,2002:pairs";
    let i2 = 0;
    if (iterable && Symbol.iterator in Object(iterable))
      for (let it of iterable) {
        if (typeof replacer === "function")
          it = replacer.call(iterable, String(i2++), it);
        let key2, value;
        if (Array.isArray(it)) {
          if (it.length === 2) {
            key2 = it[0];
            value = it[1];
          } else
            throw new TypeError(`Expected [key, value] tuple: ${it}`);
        } else if (it && it instanceof Object) {
          const keys2 = Object.keys(it);
          if (keys2.length === 1) {
            key2 = keys2[0];
            value = it[key2];
          } else {
            throw new TypeError(`Expected tuple with one key, not ${keys2.length} keys`);
          }
        } else {
          key2 = it;
        }
        pairs2.items.push(Pair.createPair(key2, value, ctx));
      }
    return pairs2;
  }
  var pairs = {
    collection: "seq",
    default: false,
    tag: "tag:yaml.org,2002:pairs",
    resolve: resolvePairs,
    createNode: createPairs
  };
  exports.createPairs = createPairs;
  exports.pairs = pairs;
  exports.resolvePairs = resolvePairs;
});
var require_omap = __commonJS2((exports) => {
  var identity = require_identity();
  var toJS = require_toJS();
  var YAMLMap = require_YAMLMap();
  var YAMLSeq = require_YAMLSeq();
  var pairs = require_pairs();

  class YAMLOMap extends YAMLSeq.YAMLSeq {
    constructor() {
      super();
      this.add = YAMLMap.YAMLMap.prototype.add.bind(this);
      this.delete = YAMLMap.YAMLMap.prototype.delete.bind(this);
      this.get = YAMLMap.YAMLMap.prototype.get.bind(this);
      this.has = YAMLMap.YAMLMap.prototype.has.bind(this);
      this.set = YAMLMap.YAMLMap.prototype.set.bind(this);
      this.tag = YAMLOMap.tag;
    }
    toJSON(_22, ctx) {
      if (!ctx)
        return super.toJSON(_22);
      const map = new Map;
      if (ctx?.onCreate)
        ctx.onCreate(map);
      for (const pair of this.items) {
        let key2, value;
        if (identity.isPair(pair)) {
          key2 = toJS.toJS(pair.key, "", ctx);
          value = toJS.toJS(pair.value, key2, ctx);
        } else {
          key2 = toJS.toJS(pair, "", ctx);
        }
        if (map.has(key2))
          throw new Error("Ordered maps must not include duplicate keys");
        map.set(key2, value);
      }
      return map;
    }
    static from(schema4, iterable, ctx) {
      const pairs$1 = pairs.createPairs(schema4, iterable, ctx);
      const omap2 = new this;
      omap2.items = pairs$1.items;
      return omap2;
    }
  }
  YAMLOMap.tag = "tag:yaml.org,2002:omap";
  var omap = {
    collection: "seq",
    identify: (value) => value instanceof Map,
    nodeClass: YAMLOMap,
    default: false,
    tag: "tag:yaml.org,2002:omap",
    resolve(seq, onError2) {
      const pairs$1 = pairs.resolvePairs(seq, onError2);
      const seenKeys = [];
      for (const { key: key2 } of pairs$1.items) {
        if (identity.isScalar(key2)) {
          if (seenKeys.includes(key2.value)) {
            onError2(`Ordered maps must not include duplicate keys: ${key2.value}`);
          } else {
            seenKeys.push(key2.value);
          }
        }
      }
      return Object.assign(new YAMLOMap, pairs$1);
    },
    createNode: (schema4, iterable, ctx) => YAMLOMap.from(schema4, iterable, ctx)
  };
  exports.YAMLOMap = YAMLOMap;
  exports.omap = omap;
});
var require_bool2 = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  function boolStringify({ value, source }, ctx) {
    const boolObj = value ? trueTag : falseTag;
    if (source && boolObj.test.test(source))
      return source;
    return value ? ctx.options.trueStr : ctx.options.falseStr;
  }
  var trueTag = {
    identify: (value) => value === true,
    default: true,
    tag: "tag:yaml.org,2002:bool",
    test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/,
    resolve: () => new Scalar.Scalar(true),
    stringify: boolStringify
  };
  var falseTag = {
    identify: (value) => value === false,
    default: true,
    tag: "tag:yaml.org,2002:bool",
    test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/,
    resolve: () => new Scalar.Scalar(false),
    stringify: boolStringify
  };
  exports.falseTag = falseTag;
  exports.trueTag = trueTag;
});
var require_float2 = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var stringifyNumber = require_stringifyNumber();
  var floatNaN = {
    identify: (value) => typeof value === "number",
    default: true,
    tag: "tag:yaml.org,2002:float",
    test: /^(?:[-+]?\.(?:inf|Inf|INF)|\.nan|\.NaN|\.NAN)$/,
    resolve: (str) => str.slice(-3).toLowerCase() === "nan" ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
    stringify: stringifyNumber.stringifyNumber
  };
  var floatExp = {
    identify: (value) => typeof value === "number",
    default: true,
    tag: "tag:yaml.org,2002:float",
    format: "EXP",
    test: /^[-+]?(?:[0-9][0-9_]*)?(?:\.[0-9_]*)?[eE][-+]?[0-9]+$/,
    resolve: (str) => parseFloat(str.replace(/_/g, "")),
    stringify(node) {
      const num = Number(node.value);
      return isFinite(num) ? num.toExponential() : stringifyNumber.stringifyNumber(node);
    }
  };
  var float = {
    identify: (value) => typeof value === "number",
    default: true,
    tag: "tag:yaml.org,2002:float",
    test: /^[-+]?(?:[0-9][0-9_]*)?\.[0-9_]*$/,
    resolve(str) {
      const node = new Scalar.Scalar(parseFloat(str.replace(/_/g, "")));
      const dot = str.indexOf(".");
      if (dot !== -1) {
        const f22 = str.substring(dot + 1).replace(/_/g, "");
        if (f22[f22.length - 1] === "0")
          node.minFractionDigits = f22.length;
      }
      return node;
    },
    stringify: stringifyNumber.stringifyNumber
  };
  exports.float = float;
  exports.floatExp = floatExp;
  exports.floatNaN = floatNaN;
});
var require_int2 = __commonJS2((exports) => {
  var stringifyNumber = require_stringifyNumber();
  var intIdentify = (value) => typeof value === "bigint" || Number.isInteger(value);
  function intResolve(str, offset2, radix, { intAsBigInt }) {
    const sign = str[0];
    if (sign === "-" || sign === "+")
      offset2 += 1;
    str = str.substring(offset2).replace(/_/g, "");
    if (intAsBigInt) {
      switch (radix) {
        case 2:
          str = `0b${str}`;
          break;
        case 8:
          str = `0o${str}`;
          break;
        case 16:
          str = `0x${str}`;
          break;
      }
      const n2 = BigInt(str);
      return sign === "-" ? BigInt(-1) * n2 : n2;
    }
    const n = parseInt(str, radix);
    return sign === "-" ? -1 * n : n;
  }
  function intStringify(node, radix, prefix) {
    const { value } = node;
    if (intIdentify(value)) {
      const str = value.toString(radix);
      return value < 0 ? "-" + prefix + str.substr(1) : prefix + str;
    }
    return stringifyNumber.stringifyNumber(node);
  }
  var intBin = {
    identify: intIdentify,
    default: true,
    tag: "tag:yaml.org,2002:int",
    format: "BIN",
    test: /^[-+]?0b[0-1_]+$/,
    resolve: (str, _onError, opt) => intResolve(str, 2, 2, opt),
    stringify: (node) => intStringify(node, 2, "0b")
  };
  var intOct = {
    identify: intIdentify,
    default: true,
    tag: "tag:yaml.org,2002:int",
    format: "OCT",
    test: /^[-+]?0[0-7_]+$/,
    resolve: (str, _onError, opt) => intResolve(str, 1, 8, opt),
    stringify: (node) => intStringify(node, 8, "0")
  };
  var int = {
    identify: intIdentify,
    default: true,
    tag: "tag:yaml.org,2002:int",
    test: /^[-+]?[0-9][0-9_]*$/,
    resolve: (str, _onError, opt) => intResolve(str, 0, 10, opt),
    stringify: stringifyNumber.stringifyNumber
  };
  var intHex = {
    identify: intIdentify,
    default: true,
    tag: "tag:yaml.org,2002:int",
    format: "HEX",
    test: /^[-+]?0x[0-9a-fA-F_]+$/,
    resolve: (str, _onError, opt) => intResolve(str, 2, 16, opt),
    stringify: (node) => intStringify(node, 16, "0x")
  };
  exports.int = int;
  exports.intBin = intBin;
  exports.intHex = intHex;
  exports.intOct = intOct;
});
var require_set = __commonJS2((exports) => {
  var identity = require_identity();
  var Pair = require_Pair();
  var YAMLMap = require_YAMLMap();

  class YAMLSet extends YAMLMap.YAMLMap {
    constructor(schema4) {
      super(schema4);
      this.tag = YAMLSet.tag;
    }
    add(key2) {
      let pair;
      if (identity.isPair(key2))
        pair = key2;
      else if (key2 && typeof key2 === "object" && "key" in key2 && "value" in key2 && key2.value === null)
        pair = new Pair.Pair(key2.key, null);
      else
        pair = new Pair.Pair(key2, null);
      const prev = YAMLMap.findPair(this.items, pair.key);
      if (!prev)
        this.items.push(pair);
    }
    get(key2, keepPair) {
      const pair = YAMLMap.findPair(this.items, key2);
      return !keepPair && identity.isPair(pair) ? identity.isScalar(pair.key) ? pair.key.value : pair.key : pair;
    }
    set(key2, value) {
      if (typeof value !== "boolean")
        throw new Error(`Expected boolean value for set(key, value) in a YAML set, not ${typeof value}`);
      const prev = YAMLMap.findPair(this.items, key2);
      if (prev && !value) {
        this.items.splice(this.items.indexOf(prev), 1);
      } else if (!prev && value) {
        this.items.push(new Pair.Pair(key2));
      }
    }
    toJSON(_22, ctx) {
      return super.toJSON(_22, ctx, Set);
    }
    toString(ctx, onComment, onChompKeep) {
      if (!ctx)
        return JSON.stringify(this);
      if (this.hasAllNullValues(true))
        return super.toString(Object.assign({}, ctx, { allNullValues: true }), onComment, onChompKeep);
      else
        throw new Error("Set items must all have null values");
    }
    static from(schema4, iterable, ctx) {
      const { replacer } = ctx;
      const set2 = new this(schema4);
      if (iterable && Symbol.iterator in Object(iterable))
        for (let value of iterable) {
          if (typeof replacer === "function")
            value = replacer.call(iterable, value, value);
          set2.items.push(Pair.createPair(value, null, ctx));
        }
      return set2;
    }
  }
  YAMLSet.tag = "tag:yaml.org,2002:set";
  var set = {
    collection: "map",
    identify: (value) => value instanceof Set,
    nodeClass: YAMLSet,
    default: false,
    tag: "tag:yaml.org,2002:set",
    createNode: (schema4, iterable, ctx) => YAMLSet.from(schema4, iterable, ctx),
    resolve(map, onError2) {
      if (identity.isMap(map)) {
        if (map.hasAllNullValues(true))
          return Object.assign(new YAMLSet, map);
        else
          onError2("Set items must all have null values");
      } else
        onError2("Expected a mapping for this tag");
      return map;
    }
  };
  exports.YAMLSet = YAMLSet;
  exports.set = set;
});
var require_timestamp = __commonJS2((exports) => {
  var stringifyNumber = require_stringifyNumber();
  function parseSexagesimal(str, asBigInt) {
    const sign = str[0];
    const parts = sign === "-" || sign === "+" ? str.substring(1) : str;
    const num = (n) => asBigInt ? BigInt(n) : Number(n);
    const res = parts.replace(/_/g, "").split(":").reduce((res2, p32) => res2 * num(60) + num(p32), num(0));
    return sign === "-" ? num(-1) * res : res;
  }
  function stringifySexagesimal(node) {
    let { value } = node;
    let num = (n) => n;
    if (typeof value === "bigint")
      num = (n) => BigInt(n);
    else if (isNaN(value) || !isFinite(value))
      return stringifyNumber.stringifyNumber(node);
    let sign = "";
    if (value < 0) {
      sign = "-";
      value *= num(-1);
    }
    const _60 = num(60);
    const parts = [value % _60];
    if (value < 60) {
      parts.unshift(0);
    } else {
      value = (value - parts[0]) / _60;
      parts.unshift(value % _60);
      if (value >= 60) {
        value = (value - parts[0]) / _60;
        parts.unshift(value);
      }
    }
    return sign + parts.map((n) => String(n).padStart(2, "0")).join(":").replace(/000000\d*$/, "");
  }
  var intTime = {
    identify: (value) => typeof value === "bigint" || Number.isInteger(value),
    default: true,
    tag: "tag:yaml.org,2002:int",
    format: "TIME",
    test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+$/,
    resolve: (str, _onError, { intAsBigInt }) => parseSexagesimal(str, intAsBigInt),
    stringify: stringifySexagesimal
  };
  var floatTime = {
    identify: (value) => typeof value === "number",
    default: true,
    tag: "tag:yaml.org,2002:float",
    format: "TIME",
    test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*$/,
    resolve: (str) => parseSexagesimal(str, false),
    stringify: stringifySexagesimal
  };
  var timestamp = {
    identify: (value) => value instanceof Date,
    default: true,
    tag: "tag:yaml.org,2002:timestamp",
    test: RegExp("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?$"),
    resolve(str) {
      const match = str.match(timestamp.test);
      if (!match)
        throw new Error("!!timestamp expects a date, starting with yyyy-mm-dd");
      const [, year, month, day, hour, minute, second] = match.map(Number);
      const millisec = match[7] ? Number((match[7] + "00").substr(1, 3)) : 0;
      let date = Date.UTC(year, month - 1, day, hour || 0, minute || 0, second || 0, millisec);
      const tz = match[8];
      if (tz && tz !== "Z") {
        let d = parseSexagesimal(tz, false);
        if (Math.abs(d) < 30)
          d *= 60;
        date -= 60000 * d;
      }
      return new Date(date);
    },
    stringify: ({ value }) => value.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "")
  };
  exports.floatTime = floatTime;
  exports.intTime = intTime;
  exports.timestamp = timestamp;
});
var require_schema3 = __commonJS2((exports) => {
  var map = require_map();
  var _null = require_null();
  var seq = require_seq();
  var string2 = require_string3();
  var binary2 = require_binary();
  var bool = require_bool2();
  var float = require_float2();
  var int = require_int2();
  var merge = require_merge22();
  var omap = require_omap();
  var pairs = require_pairs();
  var set = require_set();
  var timestamp = require_timestamp();
  var schema4 = [
    map.map,
    seq.seq,
    string2.string,
    _null.nullTag,
    bool.trueTag,
    bool.falseTag,
    int.intBin,
    int.intOct,
    int.int,
    int.intHex,
    float.floatNaN,
    float.floatExp,
    float.float,
    binary2.binary,
    merge.merge,
    omap.omap,
    pairs.pairs,
    set.set,
    timestamp.intTime,
    timestamp.floatTime,
    timestamp.timestamp
  ];
  exports.schema = schema4;
});
var require_tags = __commonJS2((exports) => {
  var map = require_map();
  var _null = require_null();
  var seq = require_seq();
  var string2 = require_string3();
  var bool = require_bool();
  var float = require_float();
  var int = require_int();
  var schema4 = require_schema();
  var schema$1 = require_schema2();
  var binary2 = require_binary();
  var merge = require_merge22();
  var omap = require_omap();
  var pairs = require_pairs();
  var schema$2 = require_schema3();
  var set = require_set();
  var timestamp = require_timestamp();
  var schemas = new Map([
    ["core", schema4.schema],
    ["failsafe", [map.map, seq.seq, string2.string]],
    ["json", schema$1.schema],
    ["yaml11", schema$2.schema],
    ["yaml-1.1", schema$2.schema]
  ]);
  var tagsByName = {
    binary: binary2.binary,
    bool: bool.boolTag,
    float: float.float,
    floatExp: float.floatExp,
    floatNaN: float.floatNaN,
    floatTime: timestamp.floatTime,
    int: int.int,
    intHex: int.intHex,
    intOct: int.intOct,
    intTime: timestamp.intTime,
    map: map.map,
    merge: merge.merge,
    null: _null.nullTag,
    omap: omap.omap,
    pairs: pairs.pairs,
    seq: seq.seq,
    set: set.set,
    timestamp: timestamp.timestamp
  };
  var coreKnownTags = {
    "tag:yaml.org,2002:binary": binary2.binary,
    "tag:yaml.org,2002:merge": merge.merge,
    "tag:yaml.org,2002:omap": omap.omap,
    "tag:yaml.org,2002:pairs": pairs.pairs,
    "tag:yaml.org,2002:set": set.set,
    "tag:yaml.org,2002:timestamp": timestamp.timestamp
  };
  function getTags(customTags, schemaName, addMergeTag) {
    const schemaTags = schemas.get(schemaName);
    if (schemaTags && !customTags) {
      return addMergeTag && !schemaTags.includes(merge.merge) ? schemaTags.concat(merge.merge) : schemaTags.slice();
    }
    let tags = schemaTags;
    if (!tags) {
      if (Array.isArray(customTags))
        tags = [];
      else {
        const keys2 = Array.from(schemas.keys()).filter((key2) => key2 !== "yaml11").map((key2) => JSON.stringify(key2)).join(", ");
        throw new Error(`Unknown schema "${schemaName}"; use one of ${keys2} or define customTags array`);
      }
    }
    if (Array.isArray(customTags)) {
      for (const tag of customTags)
        tags = tags.concat(tag);
    } else if (typeof customTags === "function") {
      tags = customTags(tags.slice());
    }
    if (addMergeTag)
      tags = tags.concat(merge.merge);
    return tags.reduce((tags2, tag) => {
      const tagObj = typeof tag === "string" ? tagsByName[tag] : tag;
      if (!tagObj) {
        const tagName = JSON.stringify(tag);
        const keys2 = Object.keys(tagsByName).map((key2) => JSON.stringify(key2)).join(", ");
        throw new Error(`Unknown custom tag ${tagName}; use one of ${keys2}`);
      }
      if (!tags2.includes(tagObj))
        tags2.push(tagObj);
      return tags2;
    }, []);
  }
  exports.coreKnownTags = coreKnownTags;
  exports.getTags = getTags;
});
var require_Schema = __commonJS2((exports) => {
  var identity = require_identity();
  var map = require_map();
  var seq = require_seq();
  var string2 = require_string3();
  var tags = require_tags();
  var sortMapEntriesByKey = (a, b22) => a.key < b22.key ? -1 : a.key > b22.key ? 1 : 0;

  class Schema {
    constructor({ compat, customTags, merge, resolveKnownTags, schema: schema4, sortMapEntries, toStringDefaults }) {
      this.compat = Array.isArray(compat) ? tags.getTags(compat, "compat") : compat ? tags.getTags(null, compat) : null;
      this.name = typeof schema4 === "string" && schema4 || "core";
      this.knownTags = resolveKnownTags ? tags.coreKnownTags : {};
      this.tags = tags.getTags(customTags, this.name, merge);
      this.toStringOptions = toStringDefaults ?? null;
      Object.defineProperty(this, identity.MAP, { value: map.map });
      Object.defineProperty(this, identity.SCALAR, { value: string2.string });
      Object.defineProperty(this, identity.SEQ, { value: seq.seq });
      this.sortMapEntries = typeof sortMapEntries === "function" ? sortMapEntries : sortMapEntries === true ? sortMapEntriesByKey : null;
    }
    clone() {
      const copy = Object.create(Schema.prototype, Object.getOwnPropertyDescriptors(this));
      copy.tags = this.tags.slice();
      return copy;
    }
  }
  exports.Schema = Schema;
});
var require_stringifyDocument = __commonJS2((exports) => {
  var identity = require_identity();
  var stringify = require_stringify();
  var stringifyComment = require_stringifyComment();
  function stringifyDocument(doc, options3) {
    const lines = [];
    let hasDirectives = options3.directives === true;
    if (options3.directives !== false && doc.directives) {
      const dir = doc.directives.toString(doc);
      if (dir) {
        lines.push(dir);
        hasDirectives = true;
      } else if (doc.directives.docStart)
        hasDirectives = true;
    }
    if (hasDirectives)
      lines.push("---");
    const ctx = stringify.createStringifyContext(doc, options3);
    const { commentString } = ctx.options;
    if (doc.commentBefore) {
      if (lines.length !== 1)
        lines.unshift("");
      const cs = commentString(doc.commentBefore);
      lines.unshift(stringifyComment.indentComment(cs, ""));
    }
    let chompKeep = false;
    let contentComment = null;
    if (doc.contents) {
      if (identity.isNode(doc.contents)) {
        if (doc.contents.spaceBefore && hasDirectives)
          lines.push("");
        if (doc.contents.commentBefore) {
          const cs = commentString(doc.contents.commentBefore);
          lines.push(stringifyComment.indentComment(cs, ""));
        }
        ctx.forceBlockIndent = !!doc.comment;
        contentComment = doc.contents.comment;
      }
      const onChompKeep = contentComment ? undefined : () => chompKeep = true;
      let body = stringify.stringify(doc.contents, ctx, () => contentComment = null, onChompKeep);
      if (contentComment)
        body += stringifyComment.lineComment(body, "", commentString(contentComment));
      if ((body[0] === "|" || body[0] === ">") && lines[lines.length - 1] === "---") {
        lines[lines.length - 1] = `--- ${body}`;
      } else
        lines.push(body);
    } else {
      lines.push(stringify.stringify(doc.contents, ctx));
    }
    if (doc.directives?.docEnd) {
      if (doc.comment) {
        const cs = commentString(doc.comment);
        if (cs.includes("\n")) {
          lines.push("...");
          lines.push(stringifyComment.indentComment(cs, ""));
        } else {
          lines.push(`... ${cs}`);
        }
      } else {
        lines.push("...");
      }
    } else {
      let dc = doc.comment;
      if (dc && chompKeep)
        dc = dc.replace(/^\n+/, "");
      if (dc) {
        if ((!chompKeep || contentComment) && lines[lines.length - 1] !== "")
          lines.push("");
        lines.push(stringifyComment.indentComment(commentString(dc), ""));
      }
    }
    return lines.join("\n") + "\n";
  }
  exports.stringifyDocument = stringifyDocument;
});
var require_Document = __commonJS2((exports) => {
  var Alias = require_Alias();
  var Collection22 = require_Collection();
  var identity = require_identity();
  var Pair = require_Pair();
  var toJS = require_toJS();
  var Schema = require_Schema();
  var stringifyDocument = require_stringifyDocument();
  var anchors = require_anchors();
  var applyReviver = require_applyReviver();
  var createNode = require_createNode();
  var directives2 = require_directives();

  class Document {
    constructor(value, replacer, options3) {
      this.commentBefore = null;
      this.comment = null;
      this.errors = [];
      this.warnings = [];
      Object.defineProperty(this, identity.NODE_TYPE, { value: identity.DOC });
      let _replacer = null;
      if (typeof replacer === "function" || Array.isArray(replacer)) {
        _replacer = replacer;
      } else if (options3 === undefined && replacer) {
        options3 = replacer;
        replacer = undefined;
      }
      const opt = Object.assign({
        intAsBigInt: false,
        keepSourceTokens: false,
        logLevel: "warn",
        prettyErrors: true,
        strict: true,
        stringKeys: false,
        uniqueKeys: true,
        version: "1.2"
      }, options3);
      this.options = opt;
      let { version: version4 } = opt;
      if (options3?._directives) {
        this.directives = options3._directives.atDocument();
        if (this.directives.yaml.explicit)
          version4 = this.directives.yaml.version;
      } else
        this.directives = new directives2.Directives({ version: version4 });
      this.setSchema(version4, options3);
      this.contents = value === undefined ? null : this.createNode(value, _replacer, options3);
    }
    clone() {
      const copy = Object.create(Document.prototype, {
        [identity.NODE_TYPE]: { value: identity.DOC }
      });
      copy.commentBefore = this.commentBefore;
      copy.comment = this.comment;
      copy.errors = this.errors.slice();
      copy.warnings = this.warnings.slice();
      copy.options = Object.assign({}, this.options);
      if (this.directives)
        copy.directives = this.directives.clone();
      copy.schema = this.schema.clone();
      copy.contents = identity.isNode(this.contents) ? this.contents.clone(copy.schema) : this.contents;
      if (this.range)
        copy.range = this.range.slice();
      return copy;
    }
    add(value) {
      if (assertCollection(this.contents))
        this.contents.add(value);
    }
    addIn(path42, value) {
      if (assertCollection(this.contents))
        this.contents.addIn(path42, value);
    }
    createAlias(node, name) {
      if (!node.anchor) {
        const prev = anchors.anchorNames(this);
        node.anchor = !name || prev.has(name) ? anchors.findNewAnchor(name || "a", prev) : name;
      }
      return new Alias.Alias(node.anchor);
    }
    createNode(value, replacer, options3) {
      let _replacer = undefined;
      if (typeof replacer === "function") {
        value = replacer.call({ "": value }, "", value);
        _replacer = replacer;
      } else if (Array.isArray(replacer)) {
        const keyToStr = (v22) => typeof v22 === "number" || v22 instanceof String || v22 instanceof Number;
        const asStr = replacer.filter(keyToStr).map(String);
        if (asStr.length > 0)
          replacer = replacer.concat(asStr);
        _replacer = replacer;
      } else if (options3 === undefined && replacer) {
        options3 = replacer;
        replacer = undefined;
      }
      const { aliasDuplicateObjects, anchorPrefix, flow, keepUndefined, onTagObj, tag } = options3 ?? {};
      const { onAnchor, setAnchors, sourceObjects } = anchors.createNodeAnchors(this, anchorPrefix || "a");
      const ctx = {
        aliasDuplicateObjects: aliasDuplicateObjects ?? true,
        keepUndefined: keepUndefined ?? false,
        onAnchor,
        onTagObj,
        replacer: _replacer,
        schema: this.schema,
        sourceObjects
      };
      const node = createNode.createNode(value, tag, ctx);
      if (flow && identity.isCollection(node))
        node.flow = true;
      setAnchors();
      return node;
    }
    createPair(key2, value, options3 = {}) {
      const k = this.createNode(key2, null, options3);
      const v22 = this.createNode(value, null, options3);
      return new Pair.Pair(k, v22);
    }
    delete(key2) {
      return assertCollection(this.contents) ? this.contents.delete(key2) : false;
    }
    deleteIn(path42) {
      if (Collection22.isEmptyPath(path42)) {
        if (this.contents == null)
          return false;
        this.contents = null;
        return true;
      }
      return assertCollection(this.contents) ? this.contents.deleteIn(path42) : false;
    }
    get(key2, keepScalar) {
      return identity.isCollection(this.contents) ? this.contents.get(key2, keepScalar) : undefined;
    }
    getIn(path42, keepScalar) {
      if (Collection22.isEmptyPath(path42))
        return !keepScalar && identity.isScalar(this.contents) ? this.contents.value : this.contents;
      return identity.isCollection(this.contents) ? this.contents.getIn(path42, keepScalar) : undefined;
    }
    has(key2) {
      return identity.isCollection(this.contents) ? this.contents.has(key2) : false;
    }
    hasIn(path42) {
      if (Collection22.isEmptyPath(path42))
        return this.contents !== undefined;
      return identity.isCollection(this.contents) ? this.contents.hasIn(path42) : false;
    }
    set(key2, value) {
      if (this.contents == null) {
        this.contents = Collection22.collectionFromPath(this.schema, [key2], value);
      } else if (assertCollection(this.contents)) {
        this.contents.set(key2, value);
      }
    }
    setIn(path42, value) {
      if (Collection22.isEmptyPath(path42)) {
        this.contents = value;
      } else if (this.contents == null) {
        this.contents = Collection22.collectionFromPath(this.schema, Array.from(path42), value);
      } else if (assertCollection(this.contents)) {
        this.contents.setIn(path42, value);
      }
    }
    setSchema(version4, options3 = {}) {
      if (typeof version4 === "number")
        version4 = String(version4);
      let opt;
      switch (version4) {
        case "1.1":
          if (this.directives)
            this.directives.yaml.version = "1.1";
          else
            this.directives = new directives2.Directives({ version: "1.1" });
          opt = { resolveKnownTags: false, schema: "yaml-1.1" };
          break;
        case "1.2":
        case "next":
          if (this.directives)
            this.directives.yaml.version = version4;
          else
            this.directives = new directives2.Directives({ version: version4 });
          opt = { resolveKnownTags: true, schema: "core" };
          break;
        case null:
          if (this.directives)
            delete this.directives;
          opt = null;
          break;
        default: {
          const sv = JSON.stringify(version4);
          throw new Error(`Expected '1.1', '1.2' or null as first argument, but found: ${sv}`);
        }
      }
      if (options3.schema instanceof Object)
        this.schema = options3.schema;
      else if (opt)
        this.schema = new Schema.Schema(Object.assign(opt, options3));
      else
        throw new Error(`With a null YAML version, the { schema: Schema } option is required`);
    }
    toJS({ json, jsonArg, mapAsMap, maxAliasCount, onAnchor, reviver } = {}) {
      const ctx = {
        anchors: new Map,
        doc: this,
        keep: !json,
        mapAsMap: mapAsMap === true,
        mapKeyWarned: false,
        maxAliasCount: typeof maxAliasCount === "number" ? maxAliasCount : 100
      };
      const res = toJS.toJS(this.contents, jsonArg ?? "", ctx);
      if (typeof onAnchor === "function")
        for (const { count, res: res2 } of ctx.anchors.values())
          onAnchor(res2, count);
      return typeof reviver === "function" ? applyReviver.applyReviver(reviver, { "": res }, "", res) : res;
    }
    toJSON(jsonArg, onAnchor) {
      return this.toJS({ json: true, jsonArg, mapAsMap: false, onAnchor });
    }
    toString(options3 = {}) {
      if (this.errors.length > 0)
        throw new Error("Document with errors cannot be stringified");
      if ("indent" in options3 && (!Number.isInteger(options3.indent) || Number(options3.indent) <= 0)) {
        const s32 = JSON.stringify(options3.indent);
        throw new Error(`"indent" option must be a positive integer, not ${s32}`);
      }
      return stringifyDocument.stringifyDocument(this, options3);
    }
  }
  function assertCollection(contents) {
    if (identity.isCollection(contents))
      return true;
    throw new Error("Expected a YAML collection as document contents");
  }
  exports.Document = Document;
});
var require_errors2 = __commonJS2((exports) => {

  class YAMLError extends Error {
    constructor(name, pos, code, message) {
      super();
      this.name = name;
      this.code = code;
      this.message = message;
      this.pos = pos;
    }
  }

  class YAMLParseError extends YAMLError {
    constructor(pos, code, message) {
      super("YAMLParseError", pos, code, message);
    }
  }

  class YAMLWarning extends YAMLError {
    constructor(pos, code, message) {
      super("YAMLWarning", pos, code, message);
    }
  }
  var prettifyError = (src22, lc) => (error) => {
    if (error.pos[0] === -1)
      return;
    error.linePos = error.pos.map((pos) => lc.linePos(pos));
    const { line, col } = error.linePos[0];
    error.message += ` at line ${line}, column ${col}`;
    let ci = col - 1;
    let lineStr = src22.substring(lc.lineStarts[line - 1], lc.lineStarts[line]).replace(/[\n\r]+$/, "");
    if (ci >= 60 && lineStr.length > 80) {
      const trimStart = Math.min(ci - 39, lineStr.length - 79);
      lineStr = "\u2026" + lineStr.substring(trimStart);
      ci -= trimStart - 1;
    }
    if (lineStr.length > 80)
      lineStr = lineStr.substring(0, 79) + "\u2026";
    if (line > 1 && /^ *$/.test(lineStr.substring(0, ci))) {
      let prev = src22.substring(lc.lineStarts[line - 2], lc.lineStarts[line - 1]);
      if (prev.length > 80)
        prev = prev.substring(0, 79) + `\u2026
`;
      lineStr = prev + lineStr;
    }
    if (/[^ ]/.test(lineStr)) {
      let count = 1;
      const end = error.linePos[1];
      if (end && end.line === line && end.col > col) {
        count = Math.max(1, Math.min(end.col - col, 80 - ci));
      }
      const pointer = " ".repeat(ci) + "^".repeat(count);
      error.message += `:\n\n${lineStr}\n${pointer}\n`;
    }
  };
  exports.YAMLError = YAMLError;
  exports.YAMLParseError = YAMLParseError;
  exports.YAMLWarning = YAMLWarning;
  exports.prettifyError = prettifyError;
});
var require_resolve_props = __commonJS2((exports) => {
  function resolveProps(tokens, { flow, indicator, next, offset: offset2, onError: onError2, parentIndent, startOnNewline }) {
    let spaceBefore = false;
    let atNewline = startOnNewline;
    let hasSpace = startOnNewline;
    let comment = "";
    let commentSep = "";
    let hasNewline = false;
    let reqSpace = false;
    let tab = null;
    let anchor = null;
    let tag = null;
    let newlineAfterProp = null;
    let comma3 = null;
    let found = null;
    let start = null;
    for (const token of tokens) {
      if (reqSpace) {
        if (token.type !== "space" && token.type !== "newline" && token.type !== "comma")
          onError2(token.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space");
        reqSpace = false;
      }
      if (tab) {
        if (atNewline && token.type !== "comment" && token.type !== "newline") {
          onError2(tab, "TAB_AS_INDENT", "Tabs are not allowed as indentation");
        }
        tab = null;
      }
      switch (token.type) {
        case "space":
          if (!flow && (indicator !== "doc-start" || next?.type !== "flow-collection") && token.source.includes("\t")) {
            tab = token;
          }
          hasSpace = true;
          break;
        case "comment": {
          if (!hasSpace)
            onError2(token, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
          const cb = token.source.substring(1) || " ";
          if (!comment)
            comment = cb;
          else
            comment += commentSep + cb;
          commentSep = "";
          atNewline = false;
          break;
        }
        case "newline":
          if (atNewline) {
            if (comment)
              comment += token.source;
            else
              spaceBefore = true;
          } else
            commentSep += token.source;
          atNewline = true;
          hasNewline = true;
          if (anchor || tag)
            newlineAfterProp = token;
          hasSpace = true;
          break;
        case "anchor":
          if (anchor)
            onError2(token, "MULTIPLE_ANCHORS", "A node can have at most one anchor");
          if (token.source.endsWith(":"))
            onError2(token.offset + token.source.length - 1, "BAD_ALIAS", "Anchor ending in : is ambiguous", true);
          anchor = token;
          if (start === null)
            start = token.offset;
          atNewline = false;
          hasSpace = false;
          reqSpace = true;
          break;
        case "tag": {
          if (tag)
            onError2(token, "MULTIPLE_TAGS", "A node can have at most one tag");
          tag = token;
          if (start === null)
            start = token.offset;
          atNewline = false;
          hasSpace = false;
          reqSpace = true;
          break;
        }
        case indicator:
          if (anchor || tag)
            onError2(token, "BAD_PROP_ORDER", `Anchors and tags must be after the ${token.source} indicator`);
          if (found)
            onError2(token, "UNEXPECTED_TOKEN", `Unexpected ${token.source} in ${flow ?? "collection"}`);
          found = token;
          atNewline = indicator === "seq-item-ind" || indicator === "explicit-key-ind";
          hasSpace = false;
          break;
        case "comma":
          if (flow) {
            if (comma3)
              onError2(token, "UNEXPECTED_TOKEN", `Unexpected , in ${flow}`);
            comma3 = token;
            atNewline = false;
            hasSpace = false;
            break;
          }
        default:
          onError2(token, "UNEXPECTED_TOKEN", `Unexpected ${token.type} token`);
          atNewline = false;
          hasSpace = false;
      }
    }
    const last = tokens[tokens.length - 1];
    const end = last ? last.offset + last.source.length : offset2;
    if (reqSpace && next && next.type !== "space" && next.type !== "newline" && next.type !== "comma" && (next.type !== "scalar" || next.source !== "")) {
      onError2(next.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space");
    }
    if (tab && (atNewline && tab.indent <= parentIndent || next?.type === "block-map" || next?.type === "block-seq"))
      onError2(tab, "TAB_AS_INDENT", "Tabs are not allowed as indentation");
    return {
      comma: comma3,
      found,
      spaceBefore,
      comment,
      hasNewline,
      anchor,
      tag,
      newlineAfterProp,
      end,
      start: start ?? end
    };
  }
  exports.resolveProps = resolveProps;
});
var require_util_contains_newline = __commonJS2((exports) => {
  function containsNewline(key2) {
    if (!key2)
      return null;
    switch (key2.type) {
      case "alias":
      case "scalar":
      case "double-quoted-scalar":
      case "single-quoted-scalar":
        if (key2.source.includes("\n"))
          return true;
        if (key2.end) {
          for (const st of key2.end)
            if (st.type === "newline")
              return true;
        }
        return false;
      case "flow-collection":
        for (const it of key2.items) {
          for (const st of it.start)
            if (st.type === "newline")
              return true;
          if (it.sep) {
            for (const st of it.sep)
              if (st.type === "newline")
                return true;
          }
          if (containsNewline(it.key) || containsNewline(it.value))
            return true;
        }
        return false;
      default:
        return true;
    }
  }
  exports.containsNewline = containsNewline;
});
var require_util_flow_indent_check = __commonJS2((exports) => {
  var utilContainsNewline = require_util_contains_newline();
  function flowIndentCheck(indent, fc, onError2) {
    if (fc?.type === "flow-collection") {
      const end = fc.end[0];
      if (end.indent === indent && (end.source === "]" || end.source === "}") && utilContainsNewline.containsNewline(fc)) {
        const msg = "Flow end indicator should be more indented than parent";
        onError2(end, "BAD_INDENT", msg, true);
      }
    }
  }
  exports.flowIndentCheck = flowIndentCheck;
});
var require_util_map_includes = __commonJS2((exports) => {
  var identity = require_identity();
  function mapIncludes(ctx, items, search) {
    const { uniqueKeys } = ctx.options;
    if (uniqueKeys === false)
      return false;
    const isEqual = typeof uniqueKeys === "function" ? uniqueKeys : (a, b22) => a === b22 || identity.isScalar(a) && identity.isScalar(b22) && a.value === b22.value;
    return items.some((pair) => isEqual(pair.key, search));
  }
  exports.mapIncludes = mapIncludes;
});
var require_resolve_block_map = __commonJS2((exports) => {
  var Pair = require_Pair();
  var YAMLMap = require_YAMLMap();
  var resolveProps = require_resolve_props();
  var utilContainsNewline = require_util_contains_newline();
  var utilFlowIndentCheck = require_util_flow_indent_check();
  var utilMapIncludes = require_util_map_includes();
  var startColMsg = "All mapping items must start at the same column";
  function resolveBlockMap({ composeNode, composeEmptyNode }, ctx, bm, onError2, tag) {
    const NodeClass = tag?.nodeClass ?? YAMLMap.YAMLMap;
    const map = new NodeClass(ctx.schema);
    if (ctx.atRoot)
      ctx.atRoot = false;
    let offset2 = bm.offset;
    let commentEnd = null;
    for (const collItem of bm.items) {
      const { start, key: key2, sep: sep33, value } = collItem;
      const keyProps = resolveProps.resolveProps(start, {
        indicator: "explicit-key-ind",
        next: key2 ?? sep33?.[0],
        offset: offset2,
        onError: onError2,
        parentIndent: bm.indent,
        startOnNewline: true
      });
      const implicitKey = !keyProps.found;
      if (implicitKey) {
        if (key2) {
          if (key2.type === "block-seq")
            onError2(offset2, "BLOCK_AS_IMPLICIT_KEY", "A block sequence may not be used as an implicit map key");
          else if ("indent" in key2 && key2.indent !== bm.indent)
            onError2(offset2, "BAD_INDENT", startColMsg);
        }
        if (!keyProps.anchor && !keyProps.tag && !sep33) {
          commentEnd = keyProps.end;
          if (keyProps.comment) {
            if (map.comment)
              map.comment += "\n" + keyProps.comment;
            else
              map.comment = keyProps.comment;
          }
          continue;
        }
        if (keyProps.newlineAfterProp || utilContainsNewline.containsNewline(key2)) {
          onError2(key2 ?? start[start.length - 1], "MULTILINE_IMPLICIT_KEY", "Implicit keys need to be on a single line");
        }
      } else if (keyProps.found?.indent !== bm.indent) {
        onError2(offset2, "BAD_INDENT", startColMsg);
      }
      ctx.atKey = true;
      const keyStart = keyProps.end;
      const keyNode = key2 ? composeNode(ctx, key2, keyProps, onError2) : composeEmptyNode(ctx, keyStart, start, null, keyProps, onError2);
      if (ctx.schema.compat)
        utilFlowIndentCheck.flowIndentCheck(bm.indent, key2, onError2);
      ctx.atKey = false;
      if (utilMapIncludes.mapIncludes(ctx, map.items, keyNode))
        onError2(keyStart, "DUPLICATE_KEY", "Map keys must be unique");
      const valueProps = resolveProps.resolveProps(sep33 ?? [], {
        indicator: "map-value-ind",
        next: value,
        offset: keyNode.range[2],
        onError: onError2,
        parentIndent: bm.indent,
        startOnNewline: !key2 || key2.type === "block-scalar"
      });
      offset2 = valueProps.end;
      if (valueProps.found) {
        if (implicitKey) {
          if (value?.type === "block-map" && !valueProps.hasNewline)
            onError2(offset2, "BLOCK_AS_IMPLICIT_KEY", "Nested mappings are not allowed in compact mappings");
          if (ctx.options.strict && keyProps.start < valueProps.found.offset - 1024)
            onError2(keyNode.range, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit block mapping key");
        }
        const valueNode = value ? composeNode(ctx, value, valueProps, onError2) : composeEmptyNode(ctx, offset2, sep33, null, valueProps, onError2);
        if (ctx.schema.compat)
          utilFlowIndentCheck.flowIndentCheck(bm.indent, value, onError2);
        offset2 = valueNode.range[2];
        const pair = new Pair.Pair(keyNode, valueNode);
        if (ctx.options.keepSourceTokens)
          pair.srcToken = collItem;
        map.items.push(pair);
      } else {
        if (implicitKey)
          onError2(keyNode.range, "MISSING_CHAR", "Implicit map keys need to be followed by map values");
        if (valueProps.comment) {
          if (keyNode.comment)
            keyNode.comment += "\n" + valueProps.comment;
          else
            keyNode.comment = valueProps.comment;
        }
        const pair = new Pair.Pair(keyNode);
        if (ctx.options.keepSourceTokens)
          pair.srcToken = collItem;
        map.items.push(pair);
      }
    }
    if (commentEnd && commentEnd < offset2)
      onError2(commentEnd, "IMPOSSIBLE", "Map comment with trailing content");
    map.range = [bm.offset, offset2, commentEnd ?? offset2];
    return map;
  }
  exports.resolveBlockMap = resolveBlockMap;
});
var require_resolve_block_seq = __commonJS2((exports) => {
  var YAMLSeq = require_YAMLSeq();
  var resolveProps = require_resolve_props();
  var utilFlowIndentCheck = require_util_flow_indent_check();
  function resolveBlockSeq({ composeNode, composeEmptyNode }, ctx, bs, onError2, tag) {
    const NodeClass = tag?.nodeClass ?? YAMLSeq.YAMLSeq;
    const seq = new NodeClass(ctx.schema);
    if (ctx.atRoot)
      ctx.atRoot = false;
    if (ctx.atKey)
      ctx.atKey = false;
    let offset2 = bs.offset;
    let commentEnd = null;
    for (const { start, value } of bs.items) {
      const props = resolveProps.resolveProps(start, {
        indicator: "seq-item-ind",
        next: value,
        offset: offset2,
        onError: onError2,
        parentIndent: bs.indent,
        startOnNewline: true
      });
      if (!props.found) {
        if (props.anchor || props.tag || value) {
          if (value && value.type === "block-seq")
            onError2(props.end, "BAD_INDENT", "All sequence items must start at the same column");
          else
            onError2(offset2, "MISSING_CHAR", "Sequence item without - indicator");
        } else {
          commentEnd = props.end;
          if (props.comment)
            seq.comment = props.comment;
          continue;
        }
      }
      const node = value ? composeNode(ctx, value, props, onError2) : composeEmptyNode(ctx, props.end, start, null, props, onError2);
      if (ctx.schema.compat)
        utilFlowIndentCheck.flowIndentCheck(bs.indent, value, onError2);
      offset2 = node.range[2];
      seq.items.push(node);
    }
    seq.range = [bs.offset, offset2, commentEnd ?? offset2];
    return seq;
  }
  exports.resolveBlockSeq = resolveBlockSeq;
});
var require_resolve_end = __commonJS2((exports) => {
  function resolveEnd(end, offset2, reqSpace, onError2) {
    let comment = "";
    if (end) {
      let hasSpace = false;
      let sep33 = "";
      for (const token of end) {
        const { source, type } = token;
        switch (type) {
          case "space":
            hasSpace = true;
            break;
          case "comment": {
            if (reqSpace && !hasSpace)
              onError2(token, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
            const cb = source.substring(1) || " ";
            if (!comment)
              comment = cb;
            else
              comment += sep33 + cb;
            sep33 = "";
            break;
          }
          case "newline":
            if (comment)
              sep33 += source;
            hasSpace = true;
            break;
          default:
            onError2(token, "UNEXPECTED_TOKEN", `Unexpected ${type} at node end`);
        }
        offset2 += source.length;
      }
    }
    return { comment, offset: offset2 };
  }
  exports.resolveEnd = resolveEnd;
});
var require_resolve_flow_collection = __commonJS2((exports) => {
  var identity = require_identity();
  var Pair = require_Pair();
  var YAMLMap = require_YAMLMap();
  var YAMLSeq = require_YAMLSeq();
  var resolveEnd = require_resolve_end();
  var resolveProps = require_resolve_props();
  var utilContainsNewline = require_util_contains_newline();
  var utilMapIncludes = require_util_map_includes();
  var blockMsg = "Block collections are not allowed within flow collections";
  var isBlock = (token) => token && (token.type === "block-map" || token.type === "block-seq");
  function resolveFlowCollection({ composeNode, composeEmptyNode }, ctx, fc, onError2, tag) {
    const isMap = fc.start.source === "{";
    const fcName = isMap ? "flow map" : "flow sequence";
    const NodeClass = tag?.nodeClass ?? (isMap ? YAMLMap.YAMLMap : YAMLSeq.YAMLSeq);
    const coll = new NodeClass(ctx.schema);
    coll.flow = true;
    const atRoot = ctx.atRoot;
    if (atRoot)
      ctx.atRoot = false;
    if (ctx.atKey)
      ctx.atKey = false;
    let offset2 = fc.offset + fc.start.source.length;
    for (let i2 = 0;i2 < fc.items.length; ++i2) {
      const collItem = fc.items[i2];
      const { start, key: key2, sep: sep33, value } = collItem;
      const props = resolveProps.resolveProps(start, {
        flow: fcName,
        indicator: "explicit-key-ind",
        next: key2 ?? sep33?.[0],
        offset: offset2,
        onError: onError2,
        parentIndent: fc.indent,
        startOnNewline: false
      });
      if (!props.found) {
        if (!props.anchor && !props.tag && !sep33 && !value) {
          if (i2 === 0 && props.comma)
            onError2(props.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${fcName}`);
          else if (i2 < fc.items.length - 1)
            onError2(props.start, "UNEXPECTED_TOKEN", `Unexpected empty item in ${fcName}`);
          if (props.comment) {
            if (coll.comment)
              coll.comment += "\n" + props.comment;
            else
              coll.comment = props.comment;
          }
          offset2 = props.end;
          continue;
        }
        if (!isMap && ctx.options.strict && utilContainsNewline.containsNewline(key2))
          onError2(key2, "MULTILINE_IMPLICIT_KEY", "Implicit keys of flow sequence pairs need to be on a single line");
      }
      if (i2 === 0) {
        if (props.comma)
          onError2(props.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${fcName}`);
      } else {
        if (!props.comma)
          onError2(props.start, "MISSING_CHAR", `Missing , between ${fcName} items`);
        if (props.comment) {
          let prevItemComment = "";
          loop:
            for (const st of start) {
              switch (st.type) {
                case "comma":
                case "space":
                  break;
                case "comment":
                  prevItemComment = st.source.substring(1);
                  break loop;
                default:
                  break loop;
              }
            }
          if (prevItemComment) {
            let prev = coll.items[coll.items.length - 1];
            if (identity.isPair(prev))
              prev = prev.value ?? prev.key;
            if (prev.comment)
              prev.comment += "\n" + prevItemComment;
            else
              prev.comment = prevItemComment;
            props.comment = props.comment.substring(prevItemComment.length + 1);
          }
        }
      }
      if (!isMap && !sep33 && !props.found) {
        const valueNode = value ? composeNode(ctx, value, props, onError2) : composeEmptyNode(ctx, props.end, sep33, null, props, onError2);
        coll.items.push(valueNode);
        offset2 = valueNode.range[2];
        if (isBlock(value))
          onError2(valueNode.range, "BLOCK_IN_FLOW", blockMsg);
      } else {
        ctx.atKey = true;
        const keyStart = props.end;
        const keyNode = key2 ? composeNode(ctx, key2, props, onError2) : composeEmptyNode(ctx, keyStart, start, null, props, onError2);
        if (isBlock(key2))
          onError2(keyNode.range, "BLOCK_IN_FLOW", blockMsg);
        ctx.atKey = false;
        const valueProps = resolveProps.resolveProps(sep33 ?? [], {
          flow: fcName,
          indicator: "map-value-ind",
          next: value,
          offset: keyNode.range[2],
          onError: onError2,
          parentIndent: fc.indent,
          startOnNewline: false
        });
        if (valueProps.found) {
          if (!isMap && !props.found && ctx.options.strict) {
            if (sep33)
              for (const st of sep33) {
                if (st === valueProps.found)
                  break;
                if (st.type === "newline") {
                  onError2(st, "MULTILINE_IMPLICIT_KEY", "Implicit keys of flow sequence pairs need to be on a single line");
                  break;
                }
              }
            if (props.start < valueProps.found.offset - 1024)
              onError2(valueProps.found, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit flow sequence key");
          }
        } else if (value) {
          if ("source" in value && value.source && value.source[0] === ":")
            onError2(value, "MISSING_CHAR", `Missing space after : in ${fcName}`);
          else
            onError2(valueProps.start, "MISSING_CHAR", `Missing , or : between ${fcName} items`);
        }
        const valueNode = value ? composeNode(ctx, value, valueProps, onError2) : valueProps.found ? composeEmptyNode(ctx, valueProps.end, sep33, null, valueProps, onError2) : null;
        if (valueNode) {
          if (isBlock(value))
            onError2(valueNode.range, "BLOCK_IN_FLOW", blockMsg);
        } else if (valueProps.comment) {
          if (keyNode.comment)
            keyNode.comment += "\n" + valueProps.comment;
          else
            keyNode.comment = valueProps.comment;
        }
        const pair = new Pair.Pair(keyNode, valueNode);
        if (ctx.options.keepSourceTokens)
          pair.srcToken = collItem;
        if (isMap) {
          const map = coll;
          if (utilMapIncludes.mapIncludes(ctx, map.items, keyNode))
            onError2(keyStart, "DUPLICATE_KEY", "Map keys must be unique");
          map.items.push(pair);
        } else {
          const map = new YAMLMap.YAMLMap(ctx.schema);
          map.flow = true;
          map.items.push(pair);
          const endRange = (valueNode ?? keyNode).range;
          map.range = [keyNode.range[0], endRange[1], endRange[2]];
          coll.items.push(map);
        }
        offset2 = valueNode ? valueNode.range[2] : valueProps.end;
      }
    }
    const expectedEnd = isMap ? "}" : "]";
    const [ce, ...ee] = fc.end;
    let cePos = offset2;
    if (ce && ce.source === expectedEnd)
      cePos = ce.offset + ce.source.length;
    else {
      const name = fcName[0].toUpperCase() + fcName.substring(1);
      const msg = atRoot ? `${name} must end with a ${expectedEnd}` : `${name} in block collection must be sufficiently indented and end with a ${expectedEnd}`;
      onError2(offset2, atRoot ? "MISSING_CHAR" : "BAD_INDENT", msg);
      if (ce && ce.source.length !== 1)
        ee.unshift(ce);
    }
    if (ee.length > 0) {
      const end = resolveEnd.resolveEnd(ee, cePos, ctx.options.strict, onError2);
      if (end.comment) {
        if (coll.comment)
          coll.comment += "\n" + end.comment;
        else
          coll.comment = end.comment;
      }
      coll.range = [fc.offset, cePos, end.offset];
    } else {
      coll.range = [fc.offset, cePos, cePos];
    }
    return coll;
  }
  exports.resolveFlowCollection = resolveFlowCollection;
});
var require_compose_collection = __commonJS2((exports) => {
  var identity = require_identity();
  var Scalar = require_Scalar();
  var YAMLMap = require_YAMLMap();
  var YAMLSeq = require_YAMLSeq();
  var resolveBlockMap = require_resolve_block_map();
  var resolveBlockSeq = require_resolve_block_seq();
  var resolveFlowCollection = require_resolve_flow_collection();
  function resolveCollection(CN, ctx, token, onError2, tagName, tag) {
    const coll = token.type === "block-map" ? resolveBlockMap.resolveBlockMap(CN, ctx, token, onError2, tag) : token.type === "block-seq" ? resolveBlockSeq.resolveBlockSeq(CN, ctx, token, onError2, tag) : resolveFlowCollection.resolveFlowCollection(CN, ctx, token, onError2, tag);
    const Coll = coll.constructor;
    if (tagName === "!" || tagName === Coll.tagName) {
      coll.tag = Coll.tagName;
      return coll;
    }
    if (tagName)
      coll.tag = tagName;
    return coll;
  }
  function composeCollection(CN, ctx, token, props, onError2) {
    const tagToken = props.tag;
    const tagName = !tagToken ? null : ctx.directives.tagName(tagToken.source, (msg) => onError2(tagToken, "TAG_RESOLVE_FAILED", msg));
    if (token.type === "block-seq") {
      const { anchor, newlineAfterProp: nl } = props;
      const lastProp = anchor && tagToken ? anchor.offset > tagToken.offset ? anchor : tagToken : anchor ?? tagToken;
      if (lastProp && (!nl || nl.offset < lastProp.offset)) {
        const message = "Missing newline after block sequence props";
        onError2(lastProp, "MISSING_CHAR", message);
      }
    }
    const expType = token.type === "block-map" ? "map" : token.type === "block-seq" ? "seq" : token.start.source === "{" ? "map" : "seq";
    if (!tagToken || !tagName || tagName === "!" || tagName === YAMLMap.YAMLMap.tagName && expType === "map" || tagName === YAMLSeq.YAMLSeq.tagName && expType === "seq") {
      return resolveCollection(CN, ctx, token, onError2, tagName);
    }
    let tag = ctx.schema.tags.find((t) => t.tag === tagName && t.collection === expType);
    if (!tag) {
      const kt2 = ctx.schema.knownTags[tagName];
      if (kt2 && kt2.collection === expType) {
        ctx.schema.tags.push(Object.assign({}, kt2, { default: false }));
        tag = kt2;
      } else {
        if (kt2?.collection) {
          onError2(tagToken, "BAD_COLLECTION_TYPE", `${kt2.tag} used for ${expType} collection, but expects ${kt2.collection}`, true);
        } else {
          onError2(tagToken, "TAG_RESOLVE_FAILED", `Unresolved tag: ${tagName}`, true);
        }
        return resolveCollection(CN, ctx, token, onError2, tagName);
      }
    }
    const coll = resolveCollection(CN, ctx, token, onError2, tagName, tag);
    const res = tag.resolve?.(coll, (msg) => onError2(tagToken, "TAG_RESOLVE_FAILED", msg), ctx.options) ?? coll;
    const node = identity.isNode(res) ? res : new Scalar.Scalar(res);
    node.range = coll.range;
    node.tag = tagName;
    if (tag?.format)
      node.format = tag.format;
    return node;
  }
  exports.composeCollection = composeCollection;
});
var require_resolve_block_scalar = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  function resolveBlockScalar(ctx, scalar, onError2) {
    const start = scalar.offset;
    const header = parseBlockScalarHeader(scalar, ctx.options.strict, onError2);
    if (!header)
      return { value: "", type: null, comment: "", range: [start, start, start] };
    const type = header.mode === ">" ? Scalar.Scalar.BLOCK_FOLDED : Scalar.Scalar.BLOCK_LITERAL;
    const lines = scalar.source ? splitLines(scalar.source) : [];
    let chompStart = lines.length;
    for (let i2 = lines.length - 1;i2 >= 0; --i2) {
      const content = lines[i2][1];
      if (content === "" || content === "\r")
        chompStart = i2;
      else
        break;
    }
    if (chompStart === 0) {
      const value2 = header.chomp === "+" && lines.length > 0 ? "\n".repeat(Math.max(1, lines.length - 1)) : "";
      let end2 = start + header.length;
      if (scalar.source)
        end2 += scalar.source.length;
      return { value: value2, type, comment: header.comment, range: [start, end2, end2] };
    }
    let trimIndent = scalar.indent + header.indent;
    let offset2 = scalar.offset + header.length;
    let contentStart = 0;
    for (let i2 = 0;i2 < chompStart; ++i2) {
      const [indent, content] = lines[i2];
      if (content === "" || content === "\r") {
        if (header.indent === 0 && indent.length > trimIndent)
          trimIndent = indent.length;
      } else {
        if (indent.length < trimIndent) {
          const message = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
          onError2(offset2 + indent.length, "MISSING_CHAR", message);
        }
        if (header.indent === 0)
          trimIndent = indent.length;
        contentStart = i2;
        if (trimIndent === 0 && !ctx.atRoot) {
          const message = "Block scalar values in collections must be indented";
          onError2(offset2, "BAD_INDENT", message);
        }
        break;
      }
      offset2 += indent.length + content.length + 1;
    }
    for (let i2 = lines.length - 1;i2 >= chompStart; --i2) {
      if (lines[i2][0].length > trimIndent)
        chompStart = i2 + 1;
    }
    let value = "";
    let sep33 = "";
    let prevMoreIndented = false;
    for (let i2 = 0;i2 < contentStart; ++i2)
      value += lines[i2][0].slice(trimIndent) + "\n";
    for (let i2 = contentStart;i2 < chompStart; ++i2) {
      let [indent, content] = lines[i2];
      offset2 += indent.length + content.length + 1;
      const crlf = content[content.length - 1] === "\r";
      if (crlf)
        content = content.slice(0, -1);
      if (content && indent.length < trimIndent) {
        const src22 = header.indent ? "explicit indentation indicator" : "first line";
        const message = `Block scalar lines must not be less indented than their ${src22}`;
        onError2(offset2 - content.length - (crlf ? 2 : 1), "BAD_INDENT", message);
        indent = "";
      }
      if (type === Scalar.Scalar.BLOCK_LITERAL) {
        value += sep33 + indent.slice(trimIndent) + content;
        sep33 = "\n";
      } else if (indent.length > trimIndent || content[0] === "\t") {
        if (sep33 === " ")
          sep33 = "\n";
        else if (!prevMoreIndented && sep33 === "\n")
          sep33 = "\n\n";
        value += sep33 + indent.slice(trimIndent) + content;
        sep33 = "\n";
        prevMoreIndented = true;
      } else if (content === "") {
        if (sep33 === "\n")
          value += "\n";
        else
          sep33 = "\n";
      } else {
        value += sep33 + content;
        sep33 = " ";
        prevMoreIndented = false;
      }
    }
    switch (header.chomp) {
      case "-":
        break;
      case "+":
        for (let i2 = chompStart;i2 < lines.length; ++i2)
          value += "\n" + lines[i2][0].slice(trimIndent);
        if (value[value.length - 1] !== "\n")
          value += "\n";
        break;
      default:
        value += "\n";
    }
    const end = start + header.length + scalar.source.length;
    return { value, type, comment: header.comment, range: [start, end, end] };
  }
  function parseBlockScalarHeader({ offset: offset2, props }, strict, onError2) {
    if (props[0].type !== "block-scalar-header") {
      onError2(props[0], "IMPOSSIBLE", "Block scalar header not found");
      return null;
    }
    const { source } = props[0];
    const mode = source[0];
    let indent = 0;
    let chomp = "";
    let error = -1;
    for (let i2 = 1;i2 < source.length; ++i2) {
      const ch = source[i2];
      if (!chomp && (ch === "-" || ch === "+"))
        chomp = ch;
      else {
        const n = Number(ch);
        if (!indent && n)
          indent = n;
        else if (error === -1)
          error = offset2 + i2;
      }
    }
    if (error !== -1)
      onError2(error, "UNEXPECTED_TOKEN", `Block scalar header includes extra characters: ${source}`);
    let hasSpace = false;
    let comment = "";
    let length = source.length;
    for (let i2 = 1;i2 < props.length; ++i2) {
      const token = props[i2];
      switch (token.type) {
        case "space":
          hasSpace = true;
        case "newline":
          length += token.source.length;
          break;
        case "comment":
          if (strict && !hasSpace) {
            const message = "Comments must be separated from other tokens by white space characters";
            onError2(token, "MISSING_CHAR", message);
          }
          length += token.source.length;
          comment = token.source.substring(1);
          break;
        case "error":
          onError2(token, "UNEXPECTED_TOKEN", token.message);
          length += token.source.length;
          break;
        default: {
          const message = `Unexpected token in block scalar header: ${token.type}`;
          onError2(token, "UNEXPECTED_TOKEN", message);
          const ts = token.source;
          if (ts && typeof ts === "string")
            length += ts.length;
        }
      }
    }
    return { mode, indent, chomp, comment, length };
  }
  function splitLines(source) {
    const split2 = source.split(/\n( *)/);
    const first = split2[0];
    const m22 = first.match(/^( *)/);
    const line0 = m22?.[1] ? [m22[1], first.slice(m22[1].length)] : ["", first];
    const lines = [line0];
    for (let i2 = 1;i2 < split2.length; i2 += 2)
      lines.push([split2[i2], split2[i2 + 1]]);
    return lines;
  }
  exports.resolveBlockScalar = resolveBlockScalar;
});
var require_resolve_flow_scalar = __commonJS2((exports) => {
  var Scalar = require_Scalar();
  var resolveEnd = require_resolve_end();
  function resolveFlowScalar(scalar, strict, onError2) {
    const { offset: offset2, type, source, end } = scalar;
    let _type;
    let value;
    const _onError = (rel, code, msg) => onError2(offset2 + rel, code, msg);
    switch (type) {
      case "scalar":
        _type = Scalar.Scalar.PLAIN;
        value = plainValue(source, _onError);
        break;
      case "single-quoted-scalar":
        _type = Scalar.Scalar.QUOTE_SINGLE;
        value = singleQuotedValue(source, _onError);
        break;
      case "double-quoted-scalar":
        _type = Scalar.Scalar.QUOTE_DOUBLE;
        value = doubleQuotedValue(source, _onError);
        break;
      default:
        onError2(scalar, "UNEXPECTED_TOKEN", `Expected a flow scalar value, but found: ${type}`);
        return {
          value: "",
          type: null,
          comment: "",
          range: [offset2, offset2 + source.length, offset2 + source.length]
        };
    }
    const valueEnd = offset2 + source.length;
    const re = resolveEnd.resolveEnd(end, valueEnd, strict, onError2);
    return {
      value,
      type: _type,
      comment: re.comment,
      range: [offset2, valueEnd, re.offset]
    };
  }
  function plainValue(source, onError2) {
    let badChar = "";
    switch (source[0]) {
      case "\t":
        badChar = "a tab character";
        break;
      case ",":
        badChar = "flow indicator character ,";
        break;
      case "%":
        badChar = "directive indicator character %";
        break;
      case "|":
      case ">": {
        badChar = `block scalar indicator ${source[0]}`;
        break;
      }
      case "@":
      case "`": {
        badChar = `reserved character ${source[0]}`;
        break;
      }
    }
    if (badChar)
      onError2(0, "BAD_SCALAR_START", `Plain value cannot start with ${badChar}`);
    return foldLines(source);
  }
  function singleQuotedValue(source, onError2) {
    if (source[source.length - 1] !== "'" || source.length === 1)
      onError2(source.length, "MISSING_CHAR", "Missing closing 'quote");
    return foldLines(source.slice(1, -1)).replace(/''/g, "'");
  }
  function foldLines(source) {
    let first, line;
    try {
      first = new RegExp("(.*?)(?<![ \t])[ \t]*\r?\n", "sy");
      line = new RegExp("[ \t]*(.*?)(?:(?<![ \t])[ \t]*)?\r?\n", "sy");
    } catch {
      first = /(.*?)[ \t]*\r?\n/sy;
      line = /[ \t]*(.*?)[ \t]*\r?\n/sy;
    }
    let match = first.exec(source);
    if (!match)
      return source;
    let res = match[1];
    let sep33 = " ";
    let pos = first.lastIndex;
    line.lastIndex = pos;
    while (match = line.exec(source)) {
      if (match[1] === "") {
        if (sep33 === "\n")
          res += sep33;
        else
          sep33 = "\n";
      } else {
        res += sep33 + match[1];
        sep33 = " ";
      }
      pos = line.lastIndex;
    }
    const last = /[ \t]*(.*)/sy;
    last.lastIndex = pos;
    match = last.exec(source);
    return res + sep33 + (match?.[1] ?? "");
  }
  function doubleQuotedValue(source, onError2) {
    let res = "";
    for (let i2 = 1;i2 < source.length - 1; ++i2) {
      const ch = source[i2];
      if (ch === "\r" && source[i2 + 1] === "\n")
        continue;
      if (ch === "\n") {
        const { fold, offset: offset2 } = foldNewline(source, i2);
        res += fold;
        i2 = offset2;
      } else if (ch === "\\") {
        let next = source[++i2];
        const cc = escapeCodes[next];
        if (cc)
          res += cc;
        else if (next === "\n") {
          next = source[i2 + 1];
          while (next === " " || next === "\t")
            next = source[++i2 + 1];
        } else if (next === "\r" && source[i2 + 1] === "\n") {
          next = source[++i2 + 1];
          while (next === " " || next === "\t")
            next = source[++i2 + 1];
        } else if (next === "x" || next === "u" || next === "U") {
          const length = { x: 2, u: 4, U: 8 }[next];
          res += parseCharCode(source, i2 + 1, length, onError2);
          i2 += length;
        } else {
          const raw = source.substr(i2 - 1, 2);
          onError2(i2 - 1, "BAD_DQ_ESCAPE", `Invalid escape sequence ${raw}`);
          res += raw;
        }
      } else if (ch === " " || ch === "\t") {
        const wsStart = i2;
        let next = source[i2 + 1];
        while (next === " " || next === "\t")
          next = source[++i2 + 1];
        if (next !== "\n" && !(next === "\r" && source[i2 + 2] === "\n"))
          res += i2 > wsStart ? source.slice(wsStart, i2 + 1) : ch;
      } else {
        res += ch;
      }
    }
    if (source[source.length - 1] !== '"' || source.length === 1)
      onError2(source.length, "MISSING_CHAR", 'Missing closing "quote');
    return res;
  }
  function foldNewline(source, offset2) {
    let fold = "";
    let ch = source[offset2 + 1];
    while (ch === " " || ch === "\t" || ch === "\n" || ch === "\r") {
      if (ch === "\r" && source[offset2 + 2] !== "\n")
        break;
      if (ch === "\n")
        fold += "\n";
      offset2 += 1;
      ch = source[offset2 + 1];
    }
    if (!fold)
      fold = " ";
    return { fold, offset: offset2 };
  }
  var escapeCodes = {
    "0": "\0",
    a: "\x07",
    b: "\b",
    e: "\x1B",
    f: "\f",
    n: "\n",
    r: "\r",
    t: "\t",
    v: "\v",
    N: "\x85",
    _: "\xA0",
    L: "\u2028",
    P: "\u2029",
    " ": " ",
    '"': '"',
    "/": "/",
    "\\": "\\",
    "\t": "\t"
  };
  function parseCharCode(source, offset2, length, onError2) {
    const cc = source.substr(offset2, length);
    const ok22 = cc.length === length && /^[0-9a-fA-F]+$/.test(cc);
    const code = ok22 ? parseInt(cc, 16) : NaN;
    if (isNaN(code)) {
      const raw = source.substr(offset2 - 2, length + 2);
      onError2(offset2 - 2, "BAD_DQ_ESCAPE", `Invalid escape sequence ${raw}`);
      return raw;
    }
    return String.fromCodePoint(code);
  }
  exports.resolveFlowScalar = resolveFlowScalar;
});
var require_compose_scalar = __commonJS2((exports) => {
  var identity = require_identity();
  var Scalar = require_Scalar();
  var resolveBlockScalar = require_resolve_block_scalar();
  var resolveFlowScalar = require_resolve_flow_scalar();
  function composeScalar(ctx, token, tagToken, onError2) {
    const { value, type, comment, range } = token.type === "block-scalar" ? resolveBlockScalar.resolveBlockScalar(ctx, token, onError2) : resolveFlowScalar.resolveFlowScalar(token, ctx.options.strict, onError2);
    const tagName = tagToken ? ctx.directives.tagName(tagToken.source, (msg) => onError2(tagToken, "TAG_RESOLVE_FAILED", msg)) : null;
    let tag;
    if (ctx.options.stringKeys && ctx.atKey) {
      tag = ctx.schema[identity.SCALAR];
    } else if (tagName)
      tag = findScalarTagByName(ctx.schema, value, tagName, tagToken, onError2);
    else if (token.type === "scalar")
      tag = findScalarTagByTest(ctx, value, token, onError2);
    else
      tag = ctx.schema[identity.SCALAR];
    let scalar;
    try {
      const res = tag.resolve(value, (msg) => onError2(tagToken ?? token, "TAG_RESOLVE_FAILED", msg), ctx.options);
      scalar = identity.isScalar(res) ? res : new Scalar.Scalar(res);
    } catch (error) {
      const msg = error instanceof Error ? error.message : String(error);
      onError2(tagToken ?? token, "TAG_RESOLVE_FAILED", msg);
      scalar = new Scalar.Scalar(value);
    }
    scalar.range = range;
    scalar.source = value;
    if (type)
      scalar.type = type;
    if (tagName)
      scalar.tag = tagName;
    if (tag.format)
      scalar.format = tag.format;
    if (comment)
      scalar.comment = comment;
    return scalar;
  }
  function findScalarTagByName(schema4, value, tagName, tagToken, onError2) {
    if (tagName === "!")
      return schema4[identity.SCALAR];
    const matchWithTest = [];
    for (const tag of schema4.tags) {
      if (!tag.collection && tag.tag === tagName) {
        if (tag.default && tag.test)
          matchWithTest.push(tag);
        else
          return tag;
      }
    }
    for (const tag of matchWithTest)
      if (tag.test?.test(value))
        return tag;
    const kt2 = schema4.knownTags[tagName];
    if (kt2 && !kt2.collection) {
      schema4.tags.push(Object.assign({}, kt2, { default: false, test: undefined }));
      return kt2;
    }
    onError2(tagToken, "TAG_RESOLVE_FAILED", `Unresolved tag: ${tagName}`, tagName !== "tag:yaml.org,2002:str");
    return schema4[identity.SCALAR];
  }
  function findScalarTagByTest({ atKey, directives: directives2, schema: schema4 }, value, token, onError2) {
    const tag = schema4.tags.find((tag2) => (tag2.default === true || atKey && tag2.default === "key") && tag2.test?.test(value)) || schema4[identity.SCALAR];
    if (schema4.compat) {
      const compat = schema4.compat.find((tag2) => tag2.default && tag2.test?.test(value)) ?? schema4[identity.SCALAR];
      if (tag.tag !== compat.tag) {
        const ts = directives2.tagString(tag.tag);
        const cs = directives2.tagString(compat.tag);
        const msg = `Value may be parsed as either ${ts} or ${cs}`;
        onError2(token, "TAG_RESOLVE_FAILED", msg, true);
      }
    }
    return tag;
  }
  exports.composeScalar = composeScalar;
});
var require_util_empty_scalar_position = __commonJS2((exports) => {
  function emptyScalarPosition(offset2, before, pos) {
    if (before) {
      if (pos === null)
        pos = before.length;
      for (let i2 = pos - 1;i2 >= 0; --i2) {
        let st = before[i2];
        switch (st.type) {
          case "space":
          case "comment":
          case "newline":
            offset2 -= st.source.length;
            continue;
        }
        st = before[++i2];
        while (st?.type === "space") {
          offset2 += st.source.length;
          st = before[++i2];
        }
        break;
      }
    }
    return offset2;
  }
  exports.emptyScalarPosition = emptyScalarPosition;
});
var require_compose_node = __commonJS2((exports) => {
  var Alias = require_Alias();
  var identity = require_identity();
  var composeCollection = require_compose_collection();
  var composeScalar = require_compose_scalar();
  var resolveEnd = require_resolve_end();
  var utilEmptyScalarPosition = require_util_empty_scalar_position();
  var CN = { composeNode, composeEmptyNode };
  function composeNode(ctx, token, props, onError2) {
    const atKey = ctx.atKey;
    const { spaceBefore, comment, anchor, tag } = props;
    let node;
    let isSrcToken = true;
    switch (token.type) {
      case "alias":
        node = composeAlias(ctx, token, onError2);
        if (anchor || tag)
          onError2(token, "ALIAS_PROPS", "An alias node must not specify any properties");
        break;
      case "scalar":
      case "single-quoted-scalar":
      case "double-quoted-scalar":
      case "block-scalar":
        node = composeScalar.composeScalar(ctx, token, tag, onError2);
        if (anchor)
          node.anchor = anchor.source.substring(1);
        break;
      case "block-map":
      case "block-seq":
      case "flow-collection":
        node = composeCollection.composeCollection(CN, ctx, token, props, onError2);
        if (anchor)
          node.anchor = anchor.source.substring(1);
        break;
      default: {
        const message = token.type === "error" ? token.message : `Unsupported token (type: ${token.type})`;
        onError2(token, "UNEXPECTED_TOKEN", message);
        node = composeEmptyNode(ctx, token.offset, undefined, null, props, onError2);
        isSrcToken = false;
      }
    }
    if (anchor && node.anchor === "")
      onError2(anchor, "BAD_ALIAS", "Anchor cannot be an empty string");
    if (atKey && ctx.options.stringKeys && (!identity.isScalar(node) || typeof node.value !== "string" || node.tag && node.tag !== "tag:yaml.org,2002:str")) {
      const msg = "With stringKeys, all keys must be strings";
      onError2(tag ?? token, "NON_STRING_KEY", msg);
    }
    if (spaceBefore)
      node.spaceBefore = true;
    if (comment) {
      if (token.type === "scalar" && token.source === "")
        node.comment = comment;
      else
        node.commentBefore = comment;
    }
    if (ctx.options.keepSourceTokens && isSrcToken)
      node.srcToken = token;
    return node;
  }
  function composeEmptyNode(ctx, offset2, before, pos, { spaceBefore, comment, anchor, tag, end }, onError2) {
    const token = {
      type: "scalar",
      offset: utilEmptyScalarPosition.emptyScalarPosition(offset2, before, pos),
      indent: -1,
      source: ""
    };
    const node = composeScalar.composeScalar(ctx, token, tag, onError2);
    if (anchor) {
      node.anchor = anchor.source.substring(1);
      if (node.anchor === "")
        onError2(anchor, "BAD_ALIAS", "Anchor cannot be an empty string");
    }
    if (spaceBefore)
      node.spaceBefore = true;
    if (comment) {
      node.comment = comment;
      node.range[2] = end;
    }
    return node;
  }
  function composeAlias({ options: options3 }, { offset: offset2, source, end }, onError2) {
    const alias = new Alias.Alias(source.substring(1));
    if (alias.source === "")
      onError2(offset2, "BAD_ALIAS", "Alias cannot be an empty string");
    if (alias.source.endsWith(":"))
      onError2(offset2 + source.length - 1, "BAD_ALIAS", "Alias ending in : is ambiguous", true);
    const valueEnd = offset2 + source.length;
    const re = resolveEnd.resolveEnd(end, valueEnd, options3.strict, onError2);
    alias.range = [offset2, valueEnd, re.offset];
    if (re.comment)
      alias.comment = re.comment;
    return alias;
  }
  exports.composeEmptyNode = composeEmptyNode;
  exports.composeNode = composeNode;
});
var require_compose_doc = __commonJS2((exports) => {
  var Document = require_Document();
  var composeNode = require_compose_node();
  var resolveEnd = require_resolve_end();
  var resolveProps = require_resolve_props();
  function composeDoc(options3, directives2, { offset: offset2, start, value, end }, onError2) {
    const opts = Object.assign({ _directives: directives2 }, options3);
    const doc = new Document.Document(undefined, opts);
    const ctx = {
      atKey: false,
      atRoot: true,
      directives: doc.directives,
      options: doc.options,
      schema: doc.schema
    };
    const props = resolveProps.resolveProps(start, {
      indicator: "doc-start",
      next: value ?? end?.[0],
      offset: offset2,
      onError: onError2,
      parentIndent: 0,
      startOnNewline: true
    });
    if (props.found) {
      doc.directives.docStart = true;
      if (value && (value.type === "block-map" || value.type === "block-seq") && !props.hasNewline)
        onError2(props.end, "MISSING_CHAR", "Block collection cannot start on same line with directives-end marker");
    }
    doc.contents = value ? composeNode.composeNode(ctx, value, props, onError2) : composeNode.composeEmptyNode(ctx, props.end, start, null, props, onError2);
    const contentEnd = doc.contents.range[2];
    const re = resolveEnd.resolveEnd(end, contentEnd, false, onError2);
    if (re.comment)
      doc.comment = re.comment;
    doc.range = [offset2, contentEnd, re.offset];
    return doc;
  }
  exports.composeDoc = composeDoc;
});
var require_composer = __commonJS2((exports) => {
  var directives2 = require_directives();
  var Document = require_Document();
  var errors3 = require_errors2();
  var identity = require_identity();
  var composeDoc = require_compose_doc();
  var resolveEnd = require_resolve_end();
  function getErrorPos(src22) {
    if (typeof src22 === "number")
      return [src22, src22 + 1];
    if (Array.isArray(src22))
      return src22.length === 2 ? src22 : [src22[0], src22[1]];
    const { offset: offset2, source } = src22;
    return [offset2, offset2 + (typeof source === "string" ? source.length : 1)];
  }
  function parsePrelude(prelude) {
    let comment = "";
    let atComment = false;
    let afterEmptyLine = false;
    for (let i2 = 0;i2 < prelude.length; ++i2) {
      const source = prelude[i2];
      switch (source[0]) {
        case "#":
          comment += (comment === "" ? "" : afterEmptyLine ? "\n\n" : "\n") + (source.substring(1) || " ");
          atComment = true;
          afterEmptyLine = false;
          break;
        case "%":
          if (prelude[i2 + 1]?.[0] !== "#")
            i2 += 1;
          atComment = false;
          break;
        default:
          if (!atComment)
            afterEmptyLine = true;
          atComment = false;
      }
    }
    return { comment, afterEmptyLine };
  }

  class Composer {
    constructor(options3 = {}) {
      this.doc = null;
      this.atDirectives = false;
      this.prelude = [];
      this.errors = [];
      this.warnings = [];
      this.onError = (source, code, message, warning) => {
        const pos = getErrorPos(source);
        if (warning)
          this.warnings.push(new errors3.YAMLWarning(pos, code, message));
        else
          this.errors.push(new errors3.YAMLParseError(pos, code, message));
      };
      this.directives = new directives2.Directives({ version: options3.version || "1.2" });
      this.options = options3;
    }
    decorate(doc, afterDoc) {
      const { comment, afterEmptyLine } = parsePrelude(this.prelude);
      if (comment) {
        const dc = doc.contents;
        if (afterDoc) {
          doc.comment = doc.comment ? `${doc.comment}\n${comment}` : comment;
        } else if (afterEmptyLine || doc.directives.docStart || !dc) {
          doc.commentBefore = comment;
        } else if (identity.isCollection(dc) && !dc.flow && dc.items.length > 0) {
          let it = dc.items[0];
          if (identity.isPair(it))
            it = it.key;
          const cb = it.commentBefore;
          it.commentBefore = cb ? `${comment}\n${cb}` : comment;
        } else {
          const cb = dc.commentBefore;
          dc.commentBefore = cb ? `${comment}\n${cb}` : comment;
        }
      }
      if (afterDoc) {
        Array.prototype.push.apply(doc.errors, this.errors);
        Array.prototype.push.apply(doc.warnings, this.warnings);
      } else {
        doc.errors = this.errors;
        doc.warnings = this.warnings;
      }
      this.prelude = [];
      this.errors = [];
      this.warnings = [];
    }
    streamInfo() {
      return {
        comment: parsePrelude(this.prelude).comment,
        directives: this.directives,
        errors: this.errors,
        warnings: this.warnings
      };
    }
    *compose(tokens, forceDoc = false, endOffset = -1) {
      for (const token of tokens)
        yield* this.next(token);
      yield* this.end(forceDoc, endOffset);
    }
    *next(token) {
      if (process.env.LOG_STREAM)
        console.dir(token, { depth: null });
      switch (token.type) {
        case "directive":
          this.directives.add(token.source, (offset2, message, warning) => {
            const pos = getErrorPos(token);
            pos[0] += offset2;
            this.onError(pos, "BAD_DIRECTIVE", message, warning);
          });
          this.prelude.push(token.source);
          this.atDirectives = true;
          break;
        case "document": {
          const doc = composeDoc.composeDoc(this.options, this.directives, token, this.onError);
          if (this.atDirectives && !doc.directives.docStart)
            this.onError(token, "MISSING_CHAR", "Missing directives-end/doc-start indicator line");
          this.decorate(doc, false);
          if (this.doc)
            yield this.doc;
          this.doc = doc;
          this.atDirectives = false;
          break;
        }
        case "byte-order-mark":
        case "space":
          break;
        case "comment":
        case "newline":
          this.prelude.push(token.source);
          break;
        case "error": {
          const msg = token.source ? `${token.message}: ${JSON.stringify(token.source)}` : token.message;
          const error = new errors3.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", msg);
          if (this.atDirectives || !this.doc)
            this.errors.push(error);
          else
            this.doc.errors.push(error);
          break;
        }
        case "doc-end": {
          if (!this.doc) {
            const msg = "Unexpected doc-end without preceding document";
            this.errors.push(new errors3.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", msg));
            break;
          }
          this.doc.directives.docEnd = true;
          const end = resolveEnd.resolveEnd(token.end, token.offset + token.source.length, this.doc.options.strict, this.onError);
          this.decorate(this.doc, true);
          if (end.comment) {
            const dc = this.doc.comment;
            this.doc.comment = dc ? `${dc}\n${end.comment}` : end.comment;
          }
          this.doc.range[2] = end.offset;
          break;
        }
        default:
          this.errors.push(new errors3.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", `Unsupported token ${token.type}`));
      }
    }
    *end(forceDoc = false, endOffset = -1) {
      if (this.doc) {
        this.decorate(this.doc, true);
        yield this.doc;
        this.doc = null;
      } else if (forceDoc) {
        const opts = Object.assign({ _directives: this.directives }, this.options);
        const doc = new Document.Document(undefined, opts);
        if (this.atDirectives)
          this.onError(endOffset, "MISSING_CHAR", "Missing directives-end indicator line");
        doc.range = [0, endOffset, endOffset];
        this.decorate(doc, false);
        yield doc;
      }
    }
  }
  exports.Composer = Composer;
});
var require_cst_scalar = __commonJS2((exports) => {
  var resolveBlockScalar = require_resolve_block_scalar();
  var resolveFlowScalar = require_resolve_flow_scalar();
  var errors3 = require_errors2();
  var stringifyString = require_stringifyString();
  function resolveAsScalar(token, strict = true, onError2) {
    if (token) {
      const _onError = (pos, code, message) => {
        const offset2 = typeof pos === "number" ? pos : Array.isArray(pos) ? pos[0] : pos.offset;
        if (onError2)
          onError2(offset2, code, message);
        else
          throw new errors3.YAMLParseError([offset2, offset2 + 1], code, message);
      };
      switch (token.type) {
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar":
          return resolveFlowScalar.resolveFlowScalar(token, strict, _onError);
        case "block-scalar":
          return resolveBlockScalar.resolveBlockScalar({ options: { strict } }, token, _onError);
      }
    }
    return null;
  }
  function createScalarToken(value, context) {
    const { implicitKey = false, indent, inFlow = false, offset: offset2 = -1, type = "PLAIN" } = context;
    const source = stringifyString.stringifyString({ type, value }, {
      implicitKey,
      indent: indent > 0 ? " ".repeat(indent) : "",
      inFlow,
      options: { blockQuote: true, lineWidth: -1 }
    });
    const end = context.end ?? [
      { type: "newline", offset: -1, indent, source: "\n" }
    ];
    switch (source[0]) {
      case "|":
      case ">": {
        const he = source.indexOf("\n");
        const head2 = source.substring(0, he);
        const body = source.substring(he + 1) + "\n";
        const props = [
          { type: "block-scalar-header", offset: offset2, indent, source: head2 }
        ];
        if (!addEndtoBlockProps(props, end))
          props.push({ type: "newline", offset: -1, indent, source: "\n" });
        return { type: "block-scalar", offset: offset2, indent, props, source: body };
      }
      case '"':
        return { type: "double-quoted-scalar", offset: offset2, indent, source, end };
      case "'":
        return { type: "single-quoted-scalar", offset: offset2, indent, source, end };
      default:
        return { type: "scalar", offset: offset2, indent, source, end };
    }
  }
  function setScalarValue(token, value, context = {}) {
    let { afterKey = false, implicitKey = false, inFlow = false, type } = context;
    let indent = "indent" in token ? token.indent : null;
    if (afterKey && typeof indent === "number")
      indent += 2;
    if (!type)
      switch (token.type) {
        case "single-quoted-scalar":
          type = "QUOTE_SINGLE";
          break;
        case "double-quoted-scalar":
          type = "QUOTE_DOUBLE";
          break;
        case "block-scalar": {
          const header = token.props[0];
          if (header.type !== "block-scalar-header")
            throw new Error("Invalid block scalar header");
          type = header.source[0] === ">" ? "BLOCK_FOLDED" : "BLOCK_LITERAL";
          break;
        }
        default:
          type = "PLAIN";
      }
    const source = stringifyString.stringifyString({ type, value }, {
      implicitKey: implicitKey || indent === null,
      indent: indent !== null && indent > 0 ? " ".repeat(indent) : "",
      inFlow,
      options: { blockQuote: true, lineWidth: -1 }
    });
    switch (source[0]) {
      case "|":
      case ">":
        setBlockScalarValue(token, source);
        break;
      case '"':
        setFlowScalarValue(token, source, "double-quoted-scalar");
        break;
      case "'":
        setFlowScalarValue(token, source, "single-quoted-scalar");
        break;
      default:
        setFlowScalarValue(token, source, "scalar");
    }
  }
  function setBlockScalarValue(token, source) {
    const he = source.indexOf("\n");
    const head2 = source.substring(0, he);
    const body = source.substring(he + 1) + "\n";
    if (token.type === "block-scalar") {
      const header = token.props[0];
      if (header.type !== "block-scalar-header")
        throw new Error("Invalid block scalar header");
      header.source = head2;
      token.source = body;
    } else {
      const { offset: offset2 } = token;
      const indent = "indent" in token ? token.indent : -1;
      const props = [
        { type: "block-scalar-header", offset: offset2, indent, source: head2 }
      ];
      if (!addEndtoBlockProps(props, "end" in token ? token.end : undefined))
        props.push({ type: "newline", offset: -1, indent, source: "\n" });
      for (const key2 of Object.keys(token))
        if (key2 !== "type" && key2 !== "offset")
          delete token[key2];
      Object.assign(token, { type: "block-scalar", indent, props, source: body });
    }
  }
  function addEndtoBlockProps(props, end) {
    if (end)
      for (const st of end)
        switch (st.type) {
          case "space":
          case "comment":
            props.push(st);
            break;
          case "newline":
            props.push(st);
            return true;
        }
    return false;
  }
  function setFlowScalarValue(token, source, type) {
    switch (token.type) {
      case "scalar":
      case "double-quoted-scalar":
      case "single-quoted-scalar":
        token.type = type;
        token.source = source;
        break;
      case "block-scalar": {
        const end = token.props.slice(1);
        let oa = source.length;
        if (token.props[0].type === "block-scalar-header")
          oa -= token.props[0].source.length;
        for (const tok of end)
          tok.offset += oa;
        delete token.props;
        Object.assign(token, { type, source, end });
        break;
      }
      case "block-map":
      case "block-seq": {
        const offset2 = token.offset + source.length;
        const nl = { type: "newline", offset: offset2, indent: token.indent, source: "\n" };
        delete token.items;
        Object.assign(token, { type, source, end: [nl] });
        break;
      }
      default: {
        const indent = "indent" in token ? token.indent : -1;
        const end = "end" in token && Array.isArray(token.end) ? token.end.filter((st) => st.type === "space" || st.type === "comment" || st.type === "newline") : [];
        for (const key2 of Object.keys(token))
          if (key2 !== "type" && key2 !== "offset")
            delete token[key2];
        Object.assign(token, { type, indent, source, end });
      }
    }
  }
  exports.createScalarToken = createScalarToken;
  exports.resolveAsScalar = resolveAsScalar;
  exports.setScalarValue = setScalarValue;
});
var require_cst_stringify = __commonJS2((exports) => {
  var stringify = (cst) => ("type" in cst) ? stringifyToken(cst) : stringifyItem(cst);
  function stringifyToken(token) {
    switch (token.type) {
      case "block-scalar": {
        let res = "";
        for (const tok of token.props)
          res += stringifyToken(tok);
        return res + token.source;
      }
      case "block-map":
      case "block-seq": {
        let res = "";
        for (const item of token.items)
          res += stringifyItem(item);
        return res;
      }
      case "flow-collection": {
        let res = token.start.source;
        for (const item of token.items)
          res += stringifyItem(item);
        for (const st of token.end)
          res += st.source;
        return res;
      }
      case "document": {
        let res = stringifyItem(token);
        if (token.end)
          for (const st of token.end)
            res += st.source;
        return res;
      }
      default: {
        let res = token.source;
        if ("end" in token && token.end)
          for (const st of token.end)
            res += st.source;
        return res;
      }
    }
  }
  function stringifyItem({ start, key: key2, sep: sep33, value }) {
    let res = "";
    for (const st of start)
      res += st.source;
    if (key2)
      res += stringifyToken(key2);
    if (sep33)
      for (const st of sep33)
        res += st.source;
    if (value)
      res += stringifyToken(value);
    return res;
  }
  exports.stringify = stringify;
});
var require_cst_visit = __commonJS2((exports) => {
  var BREAK = Symbol("break visit");
  var SKIP = Symbol("skip children");
  var REMOVE = Symbol("remove item");
  function visit(cst, visitor) {
    if ("type" in cst && cst.type === "document")
      cst = { start: cst.start, value: cst.value };
    _visit(Object.freeze([]), cst, visitor);
  }
  visit.BREAK = BREAK;
  visit.SKIP = SKIP;
  visit.REMOVE = REMOVE;
  visit.itemAtPath = (cst, path42) => {
    let item = cst;
    for (const [field, index] of path42) {
      const tok = item?.[field];
      if (tok && "items" in tok) {
        item = tok.items[index];
      } else
        return;
    }
    return item;
  };
  visit.parentCollection = (cst, path42) => {
    const parent = visit.itemAtPath(cst, path42.slice(0, -1));
    const field = path42[path42.length - 1][0];
    const coll = parent?.[field];
    if (coll && "items" in coll)
      return coll;
    throw new Error("Parent collection not found");
  };
  function _visit(path42, item, visitor) {
    let ctrl = visitor(item, path42);
    if (typeof ctrl === "symbol")
      return ctrl;
    for (const field of ["key", "value"]) {
      const token = item[field];
      if (token && "items" in token) {
        for (let i2 = 0;i2 < token.items.length; ++i2) {
          const ci = _visit(Object.freeze(path42.concat([[field, i2]])), token.items[i2], visitor);
          if (typeof ci === "number")
            i2 = ci - 1;
          else if (ci === BREAK)
            return BREAK;
          else if (ci === REMOVE) {
            token.items.splice(i2, 1);
            i2 -= 1;
          }
        }
        if (typeof ctrl === "function" && field === "key")
          ctrl = ctrl(item, path42);
      }
    }
    return typeof ctrl === "function" ? ctrl(item, path42) : ctrl;
  }
  exports.visit = visit;
});
var require_cst = __commonJS2((exports) => {
  var cstScalar = require_cst_scalar();
  var cstStringify = require_cst_stringify();
  var cstVisit = require_cst_visit();
  var BOM = "\uFEFF";
  var DOCUMENT = "\x02";
  var FLOW_END = "\x18";
  var SCALAR = "\x1F";
  var isCollection = (token) => !!token && ("items" in token);
  var isScalar = (token) => !!token && (token.type === "scalar" || token.type === "single-quoted-scalar" || token.type === "double-quoted-scalar" || token.type === "block-scalar");
  function prettyToken(token) {
    switch (token) {
      case BOM:
        return "<BOM>";
      case DOCUMENT:
        return "<DOC>";
      case FLOW_END:
        return "<FLOW_END>";
      case SCALAR:
        return "<SCALAR>";
      default:
        return JSON.stringify(token);
    }
  }
  function tokenType(source) {
    switch (source) {
      case BOM:
        return "byte-order-mark";
      case DOCUMENT:
        return "doc-mode";
      case FLOW_END:
        return "flow-error-end";
      case SCALAR:
        return "scalar";
      case "---":
        return "doc-start";
      case "...":
        return "doc-end";
      case "":
      case "\n":
      case "\r\n":
        return "newline";
      case "-":
        return "seq-item-ind";
      case "?":
        return "explicit-key-ind";
      case ":":
        return "map-value-ind";
      case "{":
        return "flow-map-start";
      case "}":
        return "flow-map-end";
      case "[":
        return "flow-seq-start";
      case "]":
        return "flow-seq-end";
      case ",":
        return "comma";
    }
    switch (source[0]) {
      case " ":
      case "\t":
        return "space";
      case "#":
        return "comment";
      case "%":
        return "directive-line";
      case "*":
        return "alias";
      case "&":
        return "anchor";
      case "!":
        return "tag";
      case "'":
        return "single-quoted-scalar";
      case '"':
        return "double-quoted-scalar";
      case "|":
      case ">":
        return "block-scalar-header";
    }
    return null;
  }
  exports.createScalarToken = cstScalar.createScalarToken;
  exports.resolveAsScalar = cstScalar.resolveAsScalar;
  exports.setScalarValue = cstScalar.setScalarValue;
  exports.stringify = cstStringify.stringify;
  exports.visit = cstVisit.visit;
  exports.BOM = BOM;
  exports.DOCUMENT = DOCUMENT;
  exports.FLOW_END = FLOW_END;
  exports.SCALAR = SCALAR;
  exports.isCollection = isCollection;
  exports.isScalar = isScalar;
  exports.prettyToken = prettyToken;
  exports.tokenType = tokenType;
});
var require_lexer = __commonJS2((exports) => {
  var cst = require_cst();
  function isEmpty(ch) {
    switch (ch) {
      case undefined:
      case " ":
      case "\n":
      case "\r":
      case "\t":
        return true;
      default:
        return false;
    }
  }
  var hexDigits = new Set("0123456789ABCDEFabcdef");
  var tagChars = new Set("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-#;/?:@&=+$_.!~*'()");
  var flowIndicatorChars = new Set(",[]{}");
  var invalidAnchorChars = new Set(" ,[]{}\n\r\t");
  var isNotAnchorChar = (ch) => !ch || invalidAnchorChars.has(ch);

  class Lexer {
    constructor() {
      this.atEnd = false;
      this.blockScalarIndent = -1;
      this.blockScalarKeep = false;
      this.buffer = "";
      this.flowKey = false;
      this.flowLevel = 0;
      this.indentNext = 0;
      this.indentValue = 0;
      this.lineEndPos = null;
      this.next = null;
      this.pos = 0;
    }
    *lex(source, incomplete = false) {
      if (source) {
        if (typeof source !== "string")
          throw TypeError("source is not a string");
        this.buffer = this.buffer ? this.buffer + source : source;
        this.lineEndPos = null;
      }
      this.atEnd = !incomplete;
      let next = this.next ?? "stream";
      while (next && (incomplete || this.hasChars(1)))
        next = yield* this.parseNext(next);
    }
    atLineEnd() {
      let i2 = this.pos;
      let ch = this.buffer[i2];
      while (ch === " " || ch === "\t")
        ch = this.buffer[++i2];
      if (!ch || ch === "#" || ch === "\n")
        return true;
      if (ch === "\r")
        return this.buffer[i2 + 1] === "\n";
      return false;
    }
    charAt(n) {
      return this.buffer[this.pos + n];
    }
    continueScalar(offset2) {
      let ch = this.buffer[offset2];
      if (this.indentNext > 0) {
        let indent = 0;
        while (ch === " ")
          ch = this.buffer[++indent + offset2];
        if (ch === "\r") {
          const next = this.buffer[indent + offset2 + 1];
          if (next === "\n" || !next && !this.atEnd)
            return offset2 + indent + 1;
        }
        return ch === "\n" || indent >= this.indentNext || !ch && !this.atEnd ? offset2 + indent : -1;
      }
      if (ch === "-" || ch === ".") {
        const dt2 = this.buffer.substr(offset2, 3);
        if ((dt2 === "---" || dt2 === "...") && isEmpty(this.buffer[offset2 + 3]))
          return -1;
      }
      return offset2;
    }
    getLine() {
      let end = this.lineEndPos;
      if (typeof end !== "number" || end !== -1 && end < this.pos) {
        end = this.buffer.indexOf("\n", this.pos);
        this.lineEndPos = end;
      }
      if (end === -1)
        return this.atEnd ? this.buffer.substring(this.pos) : null;
      if (this.buffer[end - 1] === "\r")
        end -= 1;
      return this.buffer.substring(this.pos, end);
    }
    hasChars(n) {
      return this.pos + n <= this.buffer.length;
    }
    setNext(state) {
      this.buffer = this.buffer.substring(this.pos);
      this.pos = 0;
      this.lineEndPos = null;
      this.next = state;
      return null;
    }
    peek(n) {
      return this.buffer.substr(this.pos, n);
    }
    *parseNext(next) {
      switch (next) {
        case "stream":
          return yield* this.parseStream();
        case "line-start":
          return yield* this.parseLineStart();
        case "block-start":
          return yield* this.parseBlockStart();
        case "doc":
          return yield* this.parseDocument();
        case "flow":
          return yield* this.parseFlowCollection();
        case "quoted-scalar":
          return yield* this.parseQuotedScalar();
        case "block-scalar":
          return yield* this.parseBlockScalar();
        case "plain-scalar":
          return yield* this.parsePlainScalar();
      }
    }
    *parseStream() {
      let line = this.getLine();
      if (line === null)
        return this.setNext("stream");
      if (line[0] === cst.BOM) {
        yield* this.pushCount(1);
        line = line.substring(1);
      }
      if (line[0] === "%") {
        let dirEnd = line.length;
        let cs = line.indexOf("#");
        while (cs !== -1) {
          const ch = line[cs - 1];
          if (ch === " " || ch === "\t") {
            dirEnd = cs - 1;
            break;
          } else {
            cs = line.indexOf("#", cs + 1);
          }
        }
        while (true) {
          const ch = line[dirEnd - 1];
          if (ch === " " || ch === "\t")
            dirEnd -= 1;
          else
            break;
        }
        const n = (yield* this.pushCount(dirEnd)) + (yield* this.pushSpaces(true));
        yield* this.pushCount(line.length - n);
        this.pushNewline();
        return "stream";
      }
      if (this.atLineEnd()) {
        const sp = yield* this.pushSpaces(true);
        yield* this.pushCount(line.length - sp);
        yield* this.pushNewline();
        return "stream";
      }
      yield cst.DOCUMENT;
      return yield* this.parseLineStart();
    }
    *parseLineStart() {
      const ch = this.charAt(0);
      if (!ch && !this.atEnd)
        return this.setNext("line-start");
      if (ch === "-" || ch === ".") {
        if (!this.atEnd && !this.hasChars(4))
          return this.setNext("line-start");
        const s32 = this.peek(3);
        if ((s32 === "---" || s32 === "...") && isEmpty(this.charAt(3))) {
          yield* this.pushCount(3);
          this.indentValue = 0;
          this.indentNext = 0;
          return s32 === "---" ? "doc" : "stream";
        }
      }
      this.indentValue = yield* this.pushSpaces(false);
      if (this.indentNext > this.indentValue && !isEmpty(this.charAt(1)))
        this.indentNext = this.indentValue;
      return yield* this.parseBlockStart();
    }
    *parseBlockStart() {
      const [ch0, ch1] = this.peek(2);
      if (!ch1 && !this.atEnd)
        return this.setNext("block-start");
      if ((ch0 === "-" || ch0 === "?" || ch0 === ":") && isEmpty(ch1)) {
        const n = (yield* this.pushCount(1)) + (yield* this.pushSpaces(true));
        this.indentNext = this.indentValue + 1;
        this.indentValue += n;
        return yield* this.parseBlockStart();
      }
      return "doc";
    }
    *parseDocument() {
      yield* this.pushSpaces(true);
      const line = this.getLine();
      if (line === null)
        return this.setNext("doc");
      let n = yield* this.pushIndicators();
      switch (line[n]) {
        case "#":
          yield* this.pushCount(line.length - n);
        case undefined:
          yield* this.pushNewline();
          return yield* this.parseLineStart();
        case "{":
        case "[":
          yield* this.pushCount(1);
          this.flowKey = false;
          this.flowLevel = 1;
          return "flow";
        case "}":
        case "]":
          yield* this.pushCount(1);
          return "doc";
        case "*":
          yield* this.pushUntil(isNotAnchorChar);
          return "doc";
        case '"':
        case "'":
          return yield* this.parseQuotedScalar();
        case "|":
        case ">":
          n += yield* this.parseBlockScalarHeader();
          n += yield* this.pushSpaces(true);
          yield* this.pushCount(line.length - n);
          yield* this.pushNewline();
          return yield* this.parseBlockScalar();
        default:
          return yield* this.parsePlainScalar();
      }
    }
    *parseFlowCollection() {
      let nl, sp;
      let indent = -1;
      do {
        nl = yield* this.pushNewline();
        if (nl > 0) {
          sp = yield* this.pushSpaces(false);
          this.indentValue = indent = sp;
        } else {
          sp = 0;
        }
        sp += yield* this.pushSpaces(true);
      } while (nl + sp > 0);
      const line = this.getLine();
      if (line === null)
        return this.setNext("flow");
      if (indent !== -1 && indent < this.indentNext && line[0] !== "#" || indent === 0 && (line.startsWith("---") || line.startsWith("...")) && isEmpty(line[3])) {
        const atFlowEndMarker = indent === this.indentNext - 1 && this.flowLevel === 1 && (line[0] === "]" || line[0] === "}");
        if (!atFlowEndMarker) {
          this.flowLevel = 0;
          yield cst.FLOW_END;
          return yield* this.parseLineStart();
        }
      }
      let n = 0;
      while (line[n] === ",") {
        n += yield* this.pushCount(1);
        n += yield* this.pushSpaces(true);
        this.flowKey = false;
      }
      n += yield* this.pushIndicators();
      switch (line[n]) {
        case undefined:
          return "flow";
        case "#":
          yield* this.pushCount(line.length - n);
          return "flow";
        case "{":
        case "[":
          yield* this.pushCount(1);
          this.flowKey = false;
          this.flowLevel += 1;
          return "flow";
        case "}":
        case "]":
          yield* this.pushCount(1);
          this.flowKey = true;
          this.flowLevel -= 1;
          return this.flowLevel ? "flow" : "doc";
        case "*":
          yield* this.pushUntil(isNotAnchorChar);
          return "flow";
        case '"':
        case "'":
          this.flowKey = true;
          return yield* this.parseQuotedScalar();
        case ":": {
          const next = this.charAt(1);
          if (this.flowKey || isEmpty(next) || next === ",") {
            this.flowKey = false;
            yield* this.pushCount(1);
            yield* this.pushSpaces(true);
            return "flow";
          }
        }
        default:
          this.flowKey = false;
          return yield* this.parsePlainScalar();
      }
    }
    *parseQuotedScalar() {
      const quote = this.charAt(0);
      let end = this.buffer.indexOf(quote, this.pos + 1);
      if (quote === "'") {
        while (end !== -1 && this.buffer[end + 1] === "'")
          end = this.buffer.indexOf("'", end + 2);
      } else {
        while (end !== -1) {
          let n = 0;
          while (this.buffer[end - 1 - n] === "\\")
            n += 1;
          if (n % 2 === 0)
            break;
          end = this.buffer.indexOf('"', end + 1);
        }
      }
      const qb = this.buffer.substring(0, end);
      let nl = qb.indexOf("\n", this.pos);
      if (nl !== -1) {
        while (nl !== -1) {
          const cs = this.continueScalar(nl + 1);
          if (cs === -1)
            break;
          nl = qb.indexOf("\n", cs);
        }
        if (nl !== -1) {
          end = nl - (qb[nl - 1] === "\r" ? 2 : 1);
        }
      }
      if (end === -1) {
        if (!this.atEnd)
          return this.setNext("quoted-scalar");
        end = this.buffer.length;
      }
      yield* this.pushToIndex(end + 1, false);
      return this.flowLevel ? "flow" : "doc";
    }
    *parseBlockScalarHeader() {
      this.blockScalarIndent = -1;
      this.blockScalarKeep = false;
      let i2 = this.pos;
      while (true) {
        const ch = this.buffer[++i2];
        if (ch === "+")
          this.blockScalarKeep = true;
        else if (ch > "0" && ch <= "9")
          this.blockScalarIndent = Number(ch) - 1;
        else if (ch !== "-")
          break;
      }
      return yield* this.pushUntil((ch) => isEmpty(ch) || ch === "#");
    }
    *parseBlockScalar() {
      let nl = this.pos - 1;
      let indent = 0;
      let ch;
      loop:
        for (let i22 = this.pos;ch = this.buffer[i22]; ++i22) {
          switch (ch) {
            case " ":
              indent += 1;
              break;
            case "\n":
              nl = i22;
              indent = 0;
              break;
            case "\r": {
              const next = this.buffer[i22 + 1];
              if (!next && !this.atEnd)
                return this.setNext("block-scalar");
              if (next === "\n")
                break;
            }
            default:
              break loop;
          }
        }
      if (!ch && !this.atEnd)
        return this.setNext("block-scalar");
      if (indent >= this.indentNext) {
        if (this.blockScalarIndent === -1)
          this.indentNext = indent;
        else {
          this.indentNext = this.blockScalarIndent + (this.indentNext === 0 ? 1 : this.indentNext);
        }
        do {
          const cs = this.continueScalar(nl + 1);
          if (cs === -1)
            break;
          nl = this.buffer.indexOf("\n", cs);
        } while (nl !== -1);
        if (nl === -1) {
          if (!this.atEnd)
            return this.setNext("block-scalar");
          nl = this.buffer.length;
        }
      }
      let i2 = nl + 1;
      ch = this.buffer[i2];
      while (ch === " ")
        ch = this.buffer[++i2];
      if (ch === "\t") {
        while (ch === "\t" || ch === " " || ch === "\r" || ch === "\n")
          ch = this.buffer[++i2];
        nl = i2 - 1;
      } else if (!this.blockScalarKeep) {
        do {
          let i22 = nl - 1;
          let ch2 = this.buffer[i22];
          if (ch2 === "\r")
            ch2 = this.buffer[--i22];
          const lastChar = i22;
          while (ch2 === " ")
            ch2 = this.buffer[--i22];
          if (ch2 === "\n" && i22 >= this.pos && i22 + 1 + indent > lastChar)
            nl = i22;
          else
            break;
        } while (true);
      }
      yield cst.SCALAR;
      yield* this.pushToIndex(nl + 1, true);
      return yield* this.parseLineStart();
    }
    *parsePlainScalar() {
      const inFlow = this.flowLevel > 0;
      let end = this.pos - 1;
      let i2 = this.pos - 1;
      let ch;
      while (ch = this.buffer[++i2]) {
        if (ch === ":") {
          const next = this.buffer[i2 + 1];
          if (isEmpty(next) || inFlow && flowIndicatorChars.has(next))
            break;
          end = i2;
        } else if (isEmpty(ch)) {
          let next = this.buffer[i2 + 1];
          if (ch === "\r") {
            if (next === "\n") {
              i2 += 1;
              ch = "\n";
              next = this.buffer[i2 + 1];
            } else
              end = i2;
          }
          if (next === "#" || inFlow && flowIndicatorChars.has(next))
            break;
          if (ch === "\n") {
            const cs = this.continueScalar(i2 + 1);
            if (cs === -1)
              break;
            i2 = Math.max(i2, cs - 2);
          }
        } else {
          if (inFlow && flowIndicatorChars.has(ch))
            break;
          end = i2;
        }
      }
      if (!ch && !this.atEnd)
        return this.setNext("plain-scalar");
      yield cst.SCALAR;
      yield* this.pushToIndex(end + 1, true);
      return inFlow ? "flow" : "doc";
    }
    *pushCount(n) {
      if (n > 0) {
        yield this.buffer.substr(this.pos, n);
        this.pos += n;
        return n;
      }
      return 0;
    }
    *pushToIndex(i2, allowEmpty) {
      const s32 = this.buffer.slice(this.pos, i2);
      if (s32) {
        yield s32;
        this.pos += s32.length;
        return s32.length;
      } else if (allowEmpty)
        yield "";
      return 0;
    }
    *pushIndicators() {
      switch (this.charAt(0)) {
        case "!":
          return (yield* this.pushTag()) + (yield* this.pushSpaces(true)) + (yield* this.pushIndicators());
        case "&":
          return (yield* this.pushUntil(isNotAnchorChar)) + (yield* this.pushSpaces(true)) + (yield* this.pushIndicators());
        case "-":
        case "?":
        case ":": {
          const inFlow = this.flowLevel > 0;
          const ch1 = this.charAt(1);
          if (isEmpty(ch1) || inFlow && flowIndicatorChars.has(ch1)) {
            if (!inFlow)
              this.indentNext = this.indentValue + 1;
            else if (this.flowKey)
              this.flowKey = false;
            return (yield* this.pushCount(1)) + (yield* this.pushSpaces(true)) + (yield* this.pushIndicators());
          }
        }
      }
      return 0;
    }
    *pushTag() {
      if (this.charAt(1) === "<") {
        let i2 = this.pos + 2;
        let ch = this.buffer[i2];
        while (!isEmpty(ch) && ch !== ">")
          ch = this.buffer[++i2];
        return yield* this.pushToIndex(ch === ">" ? i2 + 1 : i2, false);
      } else {
        let i2 = this.pos + 1;
        let ch = this.buffer[i2];
        while (ch) {
          if (tagChars.has(ch))
            ch = this.buffer[++i2];
          else if (ch === "%" && hexDigits.has(this.buffer[i2 + 1]) && hexDigits.has(this.buffer[i2 + 2])) {
            ch = this.buffer[i2 += 3];
          } else
            break;
        }
        return yield* this.pushToIndex(i2, false);
      }
    }
    *pushNewline() {
      const ch = this.buffer[this.pos];
      if (ch === "\n")
        return yield* this.pushCount(1);
      else if (ch === "\r" && this.charAt(1) === "\n")
        return yield* this.pushCount(2);
      else
        return 0;
    }
    *pushSpaces(allowTabs) {
      let i2 = this.pos - 1;
      let ch;
      do {
        ch = this.buffer[++i2];
      } while (ch === " " || allowTabs && ch === "\t");
      const n = i2 - this.pos;
      if (n > 0) {
        yield this.buffer.substr(this.pos, n);
        this.pos = i2;
      }
      return n;
    }
    *pushUntil(test) {
      let i2 = this.pos;
      let ch = this.buffer[i2];
      while (!test(ch))
        ch = this.buffer[++i2];
      return yield* this.pushToIndex(i2, false);
    }
  }
  exports.Lexer = Lexer;
});
var require_line_counter = __commonJS2((exports) => {

  class LineCounter {
    constructor() {
      this.lineStarts = [];
      this.addNewLine = (offset2) => this.lineStarts.push(offset2);
      this.linePos = (offset2) => {
        let low = 0;
        let high = this.lineStarts.length;
        while (low < high) {
          const mid = low + high >> 1;
          if (this.lineStarts[mid] < offset2)
            low = mid + 1;
          else
            high = mid;
        }
        if (this.lineStarts[low] === offset2)
          return { line: low + 1, col: 1 };
        if (low === 0)
          return { line: 0, col: offset2 };
        const start = this.lineStarts[low - 1];
        return { line: low, col: offset2 - start + 1 };
      };
    }
  }
  exports.LineCounter = LineCounter;
});
var require_parser2 = __commonJS2((exports) => {
  var cst = require_cst();
  var lexer = require_lexer();
  function includesToken(list2, type) {
    for (let i2 = 0;i2 < list2.length; ++i2)
      if (list2[i2].type === type)
        return true;
    return false;
  }
  function findNonEmptyIndex(list2) {
    for (let i2 = 0;i2 < list2.length; ++i2) {
      switch (list2[i2].type) {
        case "space":
        case "comment":
        case "newline":
          break;
        default:
          return i2;
      }
    }
    return -1;
  }
  function isFlowToken(token) {
    switch (token?.type) {
      case "alias":
      case "scalar":
      case "single-quoted-scalar":
      case "double-quoted-scalar":
      case "flow-collection":
        return true;
      default:
        return false;
    }
  }
  function getPrevProps(parent) {
    switch (parent.type) {
      case "document":
        return parent.start;
      case "block-map": {
        const it = parent.items[parent.items.length - 1];
        return it.sep ?? it.start;
      }
      case "block-seq":
        return parent.items[parent.items.length - 1].start;
      default:
        return [];
    }
  }
  function getFirstKeyStartProps(prev) {
    if (prev.length === 0)
      return [];
    let i2 = prev.length;
    loop:
      while (--i2 >= 0) {
        switch (prev[i2].type) {
          case "doc-start":
          case "explicit-key-ind":
          case "map-value-ind":
          case "seq-item-ind":
          case "newline":
            break loop;
        }
      }
    while (prev[++i2]?.type === "space") {
    }
    return prev.splice(i2, prev.length);
  }
  function fixFlowSeqItems(fc) {
    if (fc.start.type === "flow-seq-start") {
      for (const it of fc.items) {
        if (it.sep && !it.value && !includesToken(it.start, "explicit-key-ind") && !includesToken(it.sep, "map-value-ind")) {
          if (it.key)
            it.value = it.key;
          delete it.key;
          if (isFlowToken(it.value)) {
            if (it.value.end)
              Array.prototype.push.apply(it.value.end, it.sep);
            else
              it.value.end = it.sep;
          } else
            Array.prototype.push.apply(it.start, it.sep);
          delete it.sep;
        }
      }
    }
  }

  class Parser3 {
    constructor(onNewLine) {
      this.atNewLine = true;
      this.atScalar = false;
      this.indent = 0;
      this.offset = 0;
      this.onKeyLine = false;
      this.stack = [];
      this.source = "";
      this.type = "";
      this.lexer = new lexer.Lexer;
      this.onNewLine = onNewLine;
    }
    *parse(source, incomplete = false) {
      if (this.onNewLine && this.offset === 0)
        this.onNewLine(0);
      for (const lexeme of this.lexer.lex(source, incomplete))
        yield* this.next(lexeme);
      if (!incomplete)
        yield* this.end();
    }
    *next(source) {
      this.source = source;
      if (process.env.LOG_TOKENS)
        console.log("|", cst.prettyToken(source));
      if (this.atScalar) {
        this.atScalar = false;
        yield* this.step();
        this.offset += source.length;
        return;
      }
      const type = cst.tokenType(source);
      if (!type) {
        const message = `Not a YAML token: ${source}`;
        yield* this.pop({ type: "error", offset: this.offset, message, source });
        this.offset += source.length;
      } else if (type === "scalar") {
        this.atNewLine = false;
        this.atScalar = true;
        this.type = "scalar";
      } else {
        this.type = type;
        yield* this.step();
        switch (type) {
          case "newline":
            this.atNewLine = true;
            this.indent = 0;
            if (this.onNewLine)
              this.onNewLine(this.offset + source.length);
            break;
          case "space":
            if (this.atNewLine && source[0] === " ")
              this.indent += source.length;
            break;
          case "explicit-key-ind":
          case "map-value-ind":
          case "seq-item-ind":
            if (this.atNewLine)
              this.indent += source.length;
            break;
          case "doc-mode":
          case "flow-error-end":
            return;
          default:
            this.atNewLine = false;
        }
        this.offset += source.length;
      }
    }
    *end() {
      while (this.stack.length > 0)
        yield* this.pop();
    }
    get sourceToken() {
      const st = {
        type: this.type,
        offset: this.offset,
        indent: this.indent,
        source: this.source
      };
      return st;
    }
    *step() {
      const top = this.peek(1);
      if (this.type === "doc-end" && (!top || top.type !== "doc-end")) {
        while (this.stack.length > 0)
          yield* this.pop();
        this.stack.push({
          type: "doc-end",
          offset: this.offset,
          source: this.source
        });
        return;
      }
      if (!top)
        return yield* this.stream();
      switch (top.type) {
        case "document":
          return yield* this.document(top);
        case "alias":
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar":
          return yield* this.scalar(top);
        case "block-scalar":
          return yield* this.blockScalar(top);
        case "block-map":
          return yield* this.blockMap(top);
        case "block-seq":
          return yield* this.blockSequence(top);
        case "flow-collection":
          return yield* this.flowCollection(top);
        case "doc-end":
          return yield* this.documentEnd(top);
      }
      yield* this.pop();
    }
    peek(n) {
      return this.stack[this.stack.length - n];
    }
    *pop(error) {
      const token = error ?? this.stack.pop();
      if (!token) {
        const message = "Tried to pop an empty stack";
        yield { type: "error", offset: this.offset, source: "", message };
      } else if (this.stack.length === 0) {
        yield token;
      } else {
        const top = this.peek(1);
        if (token.type === "block-scalar") {
          token.indent = "indent" in top ? top.indent : 0;
        } else if (token.type === "flow-collection" && top.type === "document") {
          token.indent = 0;
        }
        if (token.type === "flow-collection")
          fixFlowSeqItems(token);
        switch (top.type) {
          case "document":
            top.value = token;
            break;
          case "block-scalar":
            top.props.push(token);
            break;
          case "block-map": {
            const it = top.items[top.items.length - 1];
            if (it.value) {
              top.items.push({ start: [], key: token, sep: [] });
              this.onKeyLine = true;
              return;
            } else if (it.sep) {
              it.value = token;
            } else {
              Object.assign(it, { key: token, sep: [] });
              this.onKeyLine = !it.explicitKey;
              return;
            }
            break;
          }
          case "block-seq": {
            const it = top.items[top.items.length - 1];
            if (it.value)
              top.items.push({ start: [], value: token });
            else
              it.value = token;
            break;
          }
          case "flow-collection": {
            const it = top.items[top.items.length - 1];
            if (!it || it.value)
              top.items.push({ start: [], key: token, sep: [] });
            else if (it.sep)
              it.value = token;
            else
              Object.assign(it, { key: token, sep: [] });
            return;
          }
          default:
            yield* this.pop();
            yield* this.pop(token);
        }
        if ((top.type === "document" || top.type === "block-map" || top.type === "block-seq") && (token.type === "block-map" || token.type === "block-seq")) {
          const last = token.items[token.items.length - 1];
          if (last && !last.sep && !last.value && last.start.length > 0 && findNonEmptyIndex(last.start) === -1 && (token.indent === 0 || last.start.every((st) => st.type !== "comment" || st.indent < token.indent))) {
            if (top.type === "document")
              top.end = last.start;
            else
              top.items.push({ start: last.start });
            token.items.splice(-1, 1);
          }
        }
      }
    }
    *stream() {
      switch (this.type) {
        case "directive-line":
          yield { type: "directive", offset: this.offset, source: this.source };
          return;
        case "byte-order-mark":
        case "space":
        case "comment":
        case "newline":
          yield this.sourceToken;
          return;
        case "doc-mode":
        case "doc-start": {
          const doc = {
            type: "document",
            offset: this.offset,
            start: []
          };
          if (this.type === "doc-start")
            doc.start.push(this.sourceToken);
          this.stack.push(doc);
          return;
        }
      }
      yield {
        type: "error",
        offset: this.offset,
        message: `Unexpected ${this.type} token in YAML stream`,
        source: this.source
      };
    }
    *document(doc) {
      if (doc.value)
        return yield* this.lineEnd(doc);
      switch (this.type) {
        case "doc-start": {
          if (findNonEmptyIndex(doc.start) !== -1) {
            yield* this.pop();
            yield* this.step();
          } else
            doc.start.push(this.sourceToken);
          return;
        }
        case "anchor":
        case "tag":
        case "space":
        case "comment":
        case "newline":
          doc.start.push(this.sourceToken);
          return;
      }
      const bv = this.startBlockValue(doc);
      if (bv)
        this.stack.push(bv);
      else {
        yield {
          type: "error",
          offset: this.offset,
          message: `Unexpected ${this.type} token in YAML document`,
          source: this.source
        };
      }
    }
    *scalar(scalar) {
      if (this.type === "map-value-ind") {
        const prev = getPrevProps(this.peek(2));
        const start = getFirstKeyStartProps(prev);
        let sep33;
        if (scalar.end) {
          sep33 = scalar.end;
          sep33.push(this.sourceToken);
          delete scalar.end;
        } else
          sep33 = [this.sourceToken];
        const map = {
          type: "block-map",
          offset: scalar.offset,
          indent: scalar.indent,
          items: [{ start, key: scalar, sep: sep33 }]
        };
        this.onKeyLine = true;
        this.stack[this.stack.length - 1] = map;
      } else
        yield* this.lineEnd(scalar);
    }
    *blockScalar(scalar) {
      switch (this.type) {
        case "space":
        case "comment":
        case "newline":
          scalar.props.push(this.sourceToken);
          return;
        case "scalar":
          scalar.source = this.source;
          this.atNewLine = true;
          this.indent = 0;
          if (this.onNewLine) {
            let nl = this.source.indexOf("\n") + 1;
            while (nl !== 0) {
              this.onNewLine(this.offset + nl);
              nl = this.source.indexOf("\n", nl) + 1;
            }
          }
          yield* this.pop();
          break;
        default:
          yield* this.pop();
          yield* this.step();
      }
    }
    *blockMap(map) {
      const it = map.items[map.items.length - 1];
      switch (this.type) {
        case "newline":
          this.onKeyLine = false;
          if (it.value) {
            const end = "end" in it.value ? it.value.end : undefined;
            const last = Array.isArray(end) ? end[end.length - 1] : undefined;
            if (last?.type === "comment")
              end?.push(this.sourceToken);
            else
              map.items.push({ start: [this.sourceToken] });
          } else if (it.sep) {
            it.sep.push(this.sourceToken);
          } else {
            it.start.push(this.sourceToken);
          }
          return;
        case "space":
        case "comment":
          if (it.value) {
            map.items.push({ start: [this.sourceToken] });
          } else if (it.sep) {
            it.sep.push(this.sourceToken);
          } else {
            if (this.atIndentedComment(it.start, map.indent)) {
              const prev = map.items[map.items.length - 2];
              const end = prev?.value?.end;
              if (Array.isArray(end)) {
                Array.prototype.push.apply(end, it.start);
                end.push(this.sourceToken);
                map.items.pop();
                return;
              }
            }
            it.start.push(this.sourceToken);
          }
          return;
      }
      if (this.indent >= map.indent) {
        const atMapIndent = !this.onKeyLine && this.indent === map.indent;
        const atNextItem = atMapIndent && (it.sep || it.explicitKey) && this.type !== "seq-item-ind";
        let start = [];
        if (atNextItem && it.sep && !it.value) {
          const nl = [];
          for (let i2 = 0;i2 < it.sep.length; ++i2) {
            const st = it.sep[i2];
            switch (st.type) {
              case "newline":
                nl.push(i2);
                break;
              case "space":
                break;
              case "comment":
                if (st.indent > map.indent)
                  nl.length = 0;
                break;
              default:
                nl.length = 0;
            }
          }
          if (nl.length >= 2)
            start = it.sep.splice(nl[1]);
        }
        switch (this.type) {
          case "anchor":
          case "tag":
            if (atNextItem || it.value) {
              start.push(this.sourceToken);
              map.items.push({ start });
              this.onKeyLine = true;
            } else if (it.sep) {
              it.sep.push(this.sourceToken);
            } else {
              it.start.push(this.sourceToken);
            }
            return;
          case "explicit-key-ind":
            if (!it.sep && !it.explicitKey) {
              it.start.push(this.sourceToken);
              it.explicitKey = true;
            } else if (atNextItem || it.value) {
              start.push(this.sourceToken);
              map.items.push({ start, explicitKey: true });
            } else {
              this.stack.push({
                type: "block-map",
                offset: this.offset,
                indent: this.indent,
                items: [{ start: [this.sourceToken], explicitKey: true }]
              });
            }
            this.onKeyLine = true;
            return;
          case "map-value-ind":
            if (it.explicitKey) {
              if (!it.sep) {
                if (includesToken(it.start, "newline")) {
                  Object.assign(it, { key: null, sep: [this.sourceToken] });
                } else {
                  const start2 = getFirstKeyStartProps(it.start);
                  this.stack.push({
                    type: "block-map",
                    offset: this.offset,
                    indent: this.indent,
                    items: [{ start: start2, key: null, sep: [this.sourceToken] }]
                  });
                }
              } else if (it.value) {
                map.items.push({ start: [], key: null, sep: [this.sourceToken] });
              } else if (includesToken(it.sep, "map-value-ind")) {
                this.stack.push({
                  type: "block-map",
                  offset: this.offset,
                  indent: this.indent,
                  items: [{ start, key: null, sep: [this.sourceToken] }]
                });
              } else if (isFlowToken(it.key) && !includesToken(it.sep, "newline")) {
                const start2 = getFirstKeyStartProps(it.start);
                const key2 = it.key;
                const sep33 = it.sep;
                sep33.push(this.sourceToken);
                delete it.key;
                delete it.sep;
                this.stack.push({
                  type: "block-map",
                  offset: this.offset,
                  indent: this.indent,
                  items: [{ start: start2, key: key2, sep: sep33 }]
                });
              } else if (start.length > 0) {
                it.sep = it.sep.concat(start, this.sourceToken);
              } else {
                it.sep.push(this.sourceToken);
              }
            } else {
              if (!it.sep) {
                Object.assign(it, { key: null, sep: [this.sourceToken] });
              } else if (it.value || atNextItem) {
                map.items.push({ start, key: null, sep: [this.sourceToken] });
              } else if (includesToken(it.sep, "map-value-ind")) {
                this.stack.push({
                  type: "block-map",
                  offset: this.offset,
                  indent: this.indent,
                  items: [{ start: [], key: null, sep: [this.sourceToken] }]
                });
              } else {
                it.sep.push(this.sourceToken);
              }
            }
            this.onKeyLine = true;
            return;
          case "alias":
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar": {
            const fs32 = this.flowScalar(this.type);
            if (atNextItem || it.value) {
              map.items.push({ start, key: fs32, sep: [] });
              this.onKeyLine = true;
            } else if (it.sep) {
              this.stack.push(fs32);
            } else {
              Object.assign(it, { key: fs32, sep: [] });
              this.onKeyLine = true;
            }
            return;
          }
          default: {
            const bv = this.startBlockValue(map);
            if (bv) {
              if (atMapIndent && bv.type !== "block-seq") {
                map.items.push({ start });
              }
              this.stack.push(bv);
              return;
            }
          }
        }
      }
      yield* this.pop();
      yield* this.step();
    }
    *blockSequence(seq) {
      const it = seq.items[seq.items.length - 1];
      switch (this.type) {
        case "newline":
          if (it.value) {
            const end = "end" in it.value ? it.value.end : undefined;
            const last = Array.isArray(end) ? end[end.length - 1] : undefined;
            if (last?.type === "comment")
              end?.push(this.sourceToken);
            else
              seq.items.push({ start: [this.sourceToken] });
          } else
            it.start.push(this.sourceToken);
          return;
        case "space":
        case "comment":
          if (it.value)
            seq.items.push({ start: [this.sourceToken] });
          else {
            if (this.atIndentedComment(it.start, seq.indent)) {
              const prev = seq.items[seq.items.length - 2];
              const end = prev?.value?.end;
              if (Array.isArray(end)) {
                Array.prototype.push.apply(end, it.start);
                end.push(this.sourceToken);
                seq.items.pop();
                return;
              }
            }
            it.start.push(this.sourceToken);
          }
          return;
        case "anchor":
        case "tag":
          if (it.value || this.indent <= seq.indent)
            break;
          it.start.push(this.sourceToken);
          return;
        case "seq-item-ind":
          if (this.indent !== seq.indent)
            break;
          if (it.value || includesToken(it.start, "seq-item-ind"))
            seq.items.push({ start: [this.sourceToken] });
          else
            it.start.push(this.sourceToken);
          return;
      }
      if (this.indent > seq.indent) {
        const bv = this.startBlockValue(seq);
        if (bv) {
          this.stack.push(bv);
          return;
        }
      }
      yield* this.pop();
      yield* this.step();
    }
    *flowCollection(fc) {
      const it = fc.items[fc.items.length - 1];
      if (this.type === "flow-error-end") {
        let top;
        do {
          yield* this.pop();
          top = this.peek(1);
        } while (top && top.type === "flow-collection");
      } else if (fc.end.length === 0) {
        switch (this.type) {
          case "comma":
          case "explicit-key-ind":
            if (!it || it.sep)
              fc.items.push({ start: [this.sourceToken] });
            else
              it.start.push(this.sourceToken);
            return;
          case "map-value-ind":
            if (!it || it.value)
              fc.items.push({ start: [], key: null, sep: [this.sourceToken] });
            else if (it.sep)
              it.sep.push(this.sourceToken);
            else
              Object.assign(it, { key: null, sep: [this.sourceToken] });
            return;
          case "space":
          case "comment":
          case "newline":
          case "anchor":
          case "tag":
            if (!it || it.value)
              fc.items.push({ start: [this.sourceToken] });
            else if (it.sep)
              it.sep.push(this.sourceToken);
            else
              it.start.push(this.sourceToken);
            return;
          case "alias":
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar": {
            const fs32 = this.flowScalar(this.type);
            if (!it || it.value)
              fc.items.push({ start: [], key: fs32, sep: [] });
            else if (it.sep)
              this.stack.push(fs32);
            else
              Object.assign(it, { key: fs32, sep: [] });
            return;
          }
          case "flow-map-end":
          case "flow-seq-end":
            fc.end.push(this.sourceToken);
            return;
        }
        const bv = this.startBlockValue(fc);
        if (bv)
          this.stack.push(bv);
        else {
          yield* this.pop();
          yield* this.step();
        }
      } else {
        const parent = this.peek(2);
        if (parent.type === "block-map" && (this.type === "map-value-ind" && parent.indent === fc.indent || this.type === "newline" && !parent.items[parent.items.length - 1].sep)) {
          yield* this.pop();
          yield* this.step();
        } else if (this.type === "map-value-ind" && parent.type !== "flow-collection") {
          const prev = getPrevProps(parent);
          const start = getFirstKeyStartProps(prev);
          fixFlowSeqItems(fc);
          const sep33 = fc.end.splice(1, fc.end.length);
          sep33.push(this.sourceToken);
          const map = {
            type: "block-map",
            offset: fc.offset,
            indent: fc.indent,
            items: [{ start, key: fc, sep: sep33 }]
          };
          this.onKeyLine = true;
          this.stack[this.stack.length - 1] = map;
        } else {
          yield* this.lineEnd(fc);
        }
      }
    }
    flowScalar(type) {
      if (this.onNewLine) {
        let nl = this.source.indexOf("\n") + 1;
        while (nl !== 0) {
          this.onNewLine(this.offset + nl);
          nl = this.source.indexOf("\n", nl) + 1;
        }
      }
      return {
        type,
        offset: this.offset,
        indent: this.indent,
        source: this.source
      };
    }
    startBlockValue(parent) {
      switch (this.type) {
        case "alias":
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar":
          return this.flowScalar(this.type);
        case "block-scalar-header":
          return {
            type: "block-scalar",
            offset: this.offset,
            indent: this.indent,
            props: [this.sourceToken],
            source: ""
          };
        case "flow-map-start":
        case "flow-seq-start":
          return {
            type: "flow-collection",
            offset: this.offset,
            indent: this.indent,
            start: this.sourceToken,
            items: [],
            end: []
          };
        case "seq-item-ind":
          return {
            type: "block-seq",
            offset: this.offset,
            indent: this.indent,
            items: [{ start: [this.sourceToken] }]
          };
        case "explicit-key-ind": {
          this.onKeyLine = true;
          const prev = getPrevProps(parent);
          const start = getFirstKeyStartProps(prev);
          start.push(this.sourceToken);
          return {
            type: "block-map",
            offset: this.offset,
            indent: this.indent,
            items: [{ start, explicitKey: true }]
          };
        }
        case "map-value-ind": {
          this.onKeyLine = true;
          const prev = getPrevProps(parent);
          const start = getFirstKeyStartProps(prev);
          return {
            type: "block-map",
            offset: this.offset,
            indent: this.indent,
            items: [{ start, key: null, sep: [this.sourceToken] }]
          };
        }
      }
      return null;
    }
    atIndentedComment(start, indent) {
      if (this.type !== "comment")
        return false;
      if (this.indent <= indent)
        return false;
      return start.every((st) => st.type === "newline" || st.type === "space");
    }
    *documentEnd(docEnd) {
      if (this.type !== "doc-mode") {
        if (docEnd.end)
          docEnd.end.push(this.sourceToken);
        else
          docEnd.end = [this.sourceToken];
        if (this.type === "newline")
          yield* this.pop();
      }
    }
    *lineEnd(token) {
      switch (this.type) {
        case "comma":
        case "doc-start":
        case "doc-end":
        case "flow-seq-end":
        case "flow-map-end":
        case "map-value-ind":
          yield* this.pop();
          yield* this.step();
          break;
        case "newline":
          this.onKeyLine = false;
        case "space":
        case "comment":
        default:
          if (token.end)
            token.end.push(this.sourceToken);
          else
            token.end = [this.sourceToken];
          if (this.type === "newline")
            yield* this.pop();
      }
    }
  }
  exports.Parser = Parser3;
});
var require_public_api = __commonJS2((exports) => {
  var composer = require_composer();
  var Document = require_Document();
  var errors3 = require_errors2();
  var log3 = require_log();
  var identity = require_identity();
  var lineCounter = require_line_counter();
  var parser = require_parser2();
  function parseOptions(options3) {
    const prettyErrors = options3.prettyErrors !== false;
    const lineCounter$1 = options3.lineCounter || prettyErrors && new lineCounter.LineCounter || null;
    return { lineCounter: lineCounter$1, prettyErrors };
  }
  function parseAllDocuments(source, options3 = {}) {
    const { lineCounter: lineCounter2, prettyErrors } = parseOptions(options3);
    const parser$1 = new parser.Parser(lineCounter2?.addNewLine);
    const composer$1 = new composer.Composer(options3);
    const docs3 = Array.from(composer$1.compose(parser$1.parse(source)));
    if (prettyErrors && lineCounter2)
      for (const doc of docs3) {
        doc.errors.forEach(errors3.prettifyError(source, lineCounter2));
        doc.warnings.forEach(errors3.prettifyError(source, lineCounter2));
      }
    if (docs3.length > 0)
      return docs3;
    return Object.assign([], { empty: true }, composer$1.streamInfo());
  }
  function parseDocument(source, options3 = {}) {
    const { lineCounter: lineCounter2, prettyErrors } = parseOptions(options3);
    const parser$1 = new parser.Parser(lineCounter2?.addNewLine);
    const composer$1 = new composer.Composer(options3);
    let doc = null;
    for (const _doc of composer$1.compose(parser$1.parse(source), true, source.length)) {
      if (!doc)
        doc = _doc;
      else if (doc.options.logLevel !== "silent") {
        doc.errors.push(new errors3.YAMLParseError(_doc.range.slice(0, 2), "MULTIPLE_DOCS", "Source contains multiple documents; please use YAML.parseAllDocuments()"));
        break;
      }
    }
    if (prettyErrors && lineCounter2) {
      doc.errors.forEach(errors3.prettifyError(source, lineCounter2));
      doc.warnings.forEach(errors3.prettifyError(source, lineCounter2));
    }
    return doc;
  }
  function parse8(src22, reviver, options3) {
    let _reviver = undefined;
    if (typeof reviver === "function") {
      _reviver = reviver;
    } else if (options3 === undefined && reviver && typeof reviver === "object") {
      options3 = reviver;
    }
    const doc = parseDocument(src22, options3);
    if (!doc)
      return null;
    doc.warnings.forEach((warning) => log3.warn(doc.options.logLevel, warning));
    if (doc.errors.length > 0) {
      if (doc.options.logLevel !== "silent")
        throw doc.errors[0];
      else
        doc.errors = [];
    }
    return doc.toJS(Object.assign({ reviver: _reviver }, options3));
  }
  function stringify(value, replacer, options3) {
    let _replacer = null;
    if (typeof replacer === "function" || Array.isArray(replacer)) {
      _replacer = replacer;
    } else if (options3 === undefined && replacer) {
      options3 = replacer;
    }
    if (typeof options3 === "string")
      options3 = options3.length;
    if (typeof options3 === "number") {
      const indent = Math.round(options3);
      options3 = indent < 1 ? undefined : indent > 8 ? { indent: 8 } : { indent };
    }
    if (value === undefined) {
      const { keepUndefined } = options3 ?? replacer ?? {};
      if (!keepUndefined)
        return;
    }
    if (identity.isDocument(value) && !_replacer)
      return value.toString(options3);
    return new Document.Document(value, _replacer, options3).toString(options3);
  }
  exports.parse = parse8;
  exports.parseAllDocuments = parseAllDocuments;
  exports.parseDocument = parseDocument;
  exports.stringify = stringify;
});
var composer;
var Document;
var Schema;
var errors3;
var Alias;
var identity;
var Pair;
var Scalar;
var YAMLMap;
var YAMLSeq;
var cst;
var lexer;
var lineCounter;
var parser;
var publicApi;
var visit;
var $Composer;
var $Document;
var $Schema;
var $YAMLError;
var $YAMLParseError;
var $YAMLWarning;
var $Alias;
var $isAlias;
var $isCollection;
var $isDocument;
var $isMap;
var $isNode;
var $isPair;
var $isScalar;
var $isSeq;
var $Pair;
var $Scalar;
var $YAMLMap;
var $YAMLSeq;
var $Lexer;
var $LineCounter;
var $Parser;
var $parse;
var $parseAllDocuments;
var $parseDocument;
var $stringify;
var $visit;
var $visitAsync;
var init_dist5 = __esm2(() => {
  composer = require_composer();
  Document = require_Document();
  Schema = require_Schema();
  errors3 = require_errors2();
  Alias = require_Alias();
  identity = require_identity();
  Pair = require_Pair();
  Scalar = require_Scalar();
  YAMLMap = require_YAMLMap();
  YAMLSeq = require_YAMLSeq();
  cst = require_cst();
  lexer = require_lexer();
  lineCounter = require_line_counter();
  parser = require_parser2();
  publicApi = require_public_api();
  visit = require_visit();
  $Composer = composer.Composer;
  $Document = Document.Document;
  $Schema = Schema.Schema;
  $YAMLError = errors3.YAMLError;
  $YAMLParseError = errors3.YAMLParseError;
  $YAMLWarning = errors3.YAMLWarning;
  $Alias = Alias.Alias;
  $isAlias = identity.isAlias;
  $isCollection = identity.isCollection;
  $isDocument = identity.isDocument;
  $isMap = identity.isMap;
  $isNode = identity.isNode;
  $isPair = identity.isPair;
  $isScalar = identity.isScalar;
  $isSeq = identity.isSeq;
  $Pair = Pair.Pair;
  $Scalar = Scalar.Scalar;
  $YAMLMap = YAMLMap.YAMLMap;
  $YAMLSeq = YAMLSeq.YAMLSeq;
  $Lexer = lexer.Lexer;
  $LineCounter = lineCounter.LineCounter;
  $Parser = parser.Parser;
  $parse = publicApi.parse;
  $parseAllDocuments = publicApi.parseAllDocuments;
  $parseDocument = publicApi.parseDocument;
  $stringify = publicApi.stringify;
  $visit = visit.visit;
  $visitAsync = visit.visitAsync;
});
function isNothing(subject) {
  return typeof subject === "undefined" || subject === null;
}
function isObject5(subject) {
  return typeof subject === "object" && subject !== null;
}
function toArray(sequence) {
  if (Array.isArray(sequence))
    return sequence;
  else if (isNothing(sequence))
    return [];
  return [sequence];
}
function extend2(target, source) {
  var index, length, key2, sourceKeys;
  if (source) {
    sourceKeys = Object.keys(source);
    for (index = 0, length = sourceKeys.length;index < length; index += 1) {
      key2 = sourceKeys[index];
      target[key2] = source[key2];
    }
  }
  return target;
}
function repeat(string2, count) {
  var result2 = "", cycle;
  for (cycle = 0;cycle < count; cycle += 1) {
    result2 += string2;
  }
  return result2;
}
function isNegativeZero(number) {
  return number === 0 && Number.NEGATIVE_INFINITY === 1 / number;
}
function formatError(exception, compact) {
  var where = "", message = exception.reason || "(unknown reason)";
  if (!exception.mark)
    return message;
  if (exception.mark.name) {
    where += 'in "' + exception.mark.name + '" ';
  }
  where += "(" + (exception.mark.line + 1) + ":" + (exception.mark.column + 1) + ")";
  if (!compact && exception.mark.snippet) {
    where += "\n\n" + exception.mark.snippet;
  }
  return message + " " + where;
}
function YAMLException$1(reason, mark2) {
  Error.call(this);
  this.name = "YAMLException";
  this.reason = reason;
  this.mark = mark2;
  this.message = formatError(this, false);
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = new Error().stack || "";
  }
}
function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
  var head2 = "";
  var tail = "";
  var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
  if (position - lineStart > maxHalfLength) {
    head2 = " ... ";
    lineStart = position - maxHalfLength + head2.length;
  }
  if (lineEnd - position > maxHalfLength) {
    tail = " ...";
    lineEnd = position + maxHalfLength - tail.length;
  }
  return {
    str: head2 + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
    pos: position - lineStart + head2.length
  };
}
function padStart(string2, max) {
  return common.repeat(" ", max - string2.length) + string2;
}
function makeSnippet(mark2, options3) {
  options3 = Object.create(options3 || null);
  if (!mark2.buffer)
    return null;
  if (!options3.maxLength)
    options3.maxLength = 79;
  if (typeof options3.indent !== "number")
    options3.indent = 1;
  if (typeof options3.linesBefore !== "number")
    options3.linesBefore = 3;
  if (typeof options3.linesAfter !== "number")
    options3.linesAfter = 2;
  var re = /\r?\n|\r|\0/g;
  var lineStarts = [0];
  var lineEnds = [];
  var match;
  var foundLineNo = -1;
  while (match = re.exec(mark2.buffer)) {
    lineEnds.push(match.index);
    lineStarts.push(match.index + match[0].length);
    if (mark2.position <= match.index && foundLineNo < 0) {
      foundLineNo = lineStarts.length - 2;
    }
  }
  if (foundLineNo < 0)
    foundLineNo = lineStarts.length - 1;
  var result2 = "", i2, line;
  var lineNoLength = Math.min(mark2.line + options3.linesAfter, lineEnds.length).toString().length;
  var maxLineLength = options3.maxLength - (options3.indent + lineNoLength + 3);
  for (i2 = 1;i2 <= options3.linesBefore; i2++) {
    if (foundLineNo - i2 < 0)
      break;
    line = getLine(mark2.buffer, lineStarts[foundLineNo - i2], lineEnds[foundLineNo - i2], mark2.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i2]), maxLineLength);
    result2 = common.repeat(" ", options3.indent) + padStart((mark2.line - i2 + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result2;
  }
  line = getLine(mark2.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark2.position, maxLineLength);
  result2 += common.repeat(" ", options3.indent) + padStart((mark2.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  result2 += common.repeat("-", options3.indent + lineNoLength + 3 + line.pos) + "^\n";
  for (i2 = 1;i2 <= options3.linesAfter; i2++) {
    if (foundLineNo + i2 >= lineEnds.length)
      break;
    line = getLine(mark2.buffer, lineStarts[foundLineNo + i2], lineEnds[foundLineNo + i2], mark2.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i2]), maxLineLength);
    result2 += common.repeat(" ", options3.indent) + padStart((mark2.line + i2 + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  }
  return result2.replace(/\n$/, "");
}
function compileStyleAliases(map) {
  var result2 = {};
  if (map !== null) {
    Object.keys(map).forEach(function(style) {
      map[style].forEach(function(alias) {
        result2[String(alias)] = style;
      });
    });
  }
  return result2;
}
function Type$1(tag, options3) {
  options3 = options3 || {};
  Object.keys(options3).forEach(function(name) {
    if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
      throw new exception('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
    }
  });
  this.options = options3;
  this.tag = tag;
  this.kind = options3["kind"] || null;
  this.resolve = options3["resolve"] || function() {
    return true;
  };
  this.construct = options3["construct"] || function(data2) {
    return data2;
  };
  this.instanceOf = options3["instanceOf"] || null;
  this.predicate = options3["predicate"] || null;
  this.represent = options3["represent"] || null;
  this.representName = options3["representName"] || null;
  this.defaultStyle = options3["defaultStyle"] || null;
  this.multi = options3["multi"] || false;
  this.styleAliases = compileStyleAliases(options3["styleAliases"] || null);
  if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
    throw new exception('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
  }
}
function compileList(schema4, name) {
  var result2 = [];
  schema4[name].forEach(function(currentType) {
    var newIndex = result2.length;
    result2.forEach(function(previousType, previousIndex) {
      if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
        newIndex = previousIndex;
      }
    });
    result2[newIndex] = currentType;
  });
  return result2;
}
function compileMap() {
  var result2 = {
    scalar: {},
    sequence: {},
    mapping: {},
    fallback: {},
    multi: {
      scalar: [],
      sequence: [],
      mapping: [],
      fallback: []
    }
  }, index, length;
  function collectType(type2) {
    if (type2.multi) {
      result2.multi[type2.kind].push(type2);
      result2.multi["fallback"].push(type2);
    } else {
      result2[type2.kind][type2.tag] = result2["fallback"][type2.tag] = type2;
    }
  }
  for (index = 0, length = arguments.length;index < length; index += 1) {
    arguments[index].forEach(collectType);
  }
  return result2;
}
function Schema$1(definition) {
  return this.extend(definition);
}
function resolveYamlNull(data2) {
  if (data2 === null)
    return true;
  var max = data2.length;
  return max === 1 && data2 === "~" || max === 4 && (data2 === "null" || data2 === "Null" || data2 === "NULL");
}
function constructYamlNull() {
  return null;
}
function isNull2(object) {
  return object === null;
}
function resolveYamlBoolean(data2) {
  if (data2 === null)
    return false;
  var max = data2.length;
  return max === 4 && (data2 === "true" || data2 === "True" || data2 === "TRUE") || max === 5 && (data2 === "false" || data2 === "False" || data2 === "FALSE");
}
function constructYamlBoolean(data2) {
  return data2 === "true" || data2 === "True" || data2 === "TRUE";
}
function isBoolean2(object) {
  return Object.prototype.toString.call(object) === "[object Boolean]";
}
function isHexCode(c22) {
  return 48 <= c22 && c22 <= 57 || 65 <= c22 && c22 <= 70 || 97 <= c22 && c22 <= 102;
}
function isOctCode(c22) {
  return 48 <= c22 && c22 <= 55;
}
function isDecCode(c22) {
  return 48 <= c22 && c22 <= 57;
}
function resolveYamlInteger(data2) {
  if (data2 === null)
    return false;
  var max = data2.length, index = 0, hasDigits = false, ch;
  if (!max)
    return false;
  ch = data2[index];
  if (ch === "-" || ch === "+") {
    ch = data2[++index];
  }
  if (ch === "0") {
    if (index + 1 === max)
      return true;
    ch = data2[++index];
    if (ch === "b") {
      index++;
      for (;index < max; index++) {
        ch = data2[index];
        if (ch === "_")
          continue;
        if (ch !== "0" && ch !== "1")
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "x") {
      index++;
      for (;index < max; index++) {
        ch = data2[index];
        if (ch === "_")
          continue;
        if (!isHexCode(data2.charCodeAt(index)))
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "o") {
      index++;
      for (;index < max; index++) {
        ch = data2[index];
        if (ch === "_")
          continue;
        if (!isOctCode(data2.charCodeAt(index)))
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
  }
  if (ch === "_")
    return false;
  for (;index < max; index++) {
    ch = data2[index];
    if (ch === "_")
      continue;
    if (!isDecCode(data2.charCodeAt(index))) {
      return false;
    }
    hasDigits = true;
  }
  if (!hasDigits || ch === "_")
    return false;
  return true;
}
function constructYamlInteger(data2) {
  var value = data2, sign = 1, ch;
  if (value.indexOf("_") !== -1) {
    value = value.replace(/_/g, "");
  }
  ch = value[0];
  if (ch === "-" || ch === "+") {
    if (ch === "-")
      sign = -1;
    value = value.slice(1);
    ch = value[0];
  }
  if (value === "0")
    return 0;
  if (ch === "0") {
    if (value[1] === "b")
      return sign * parseInt(value.slice(2), 2);
    if (value[1] === "x")
      return sign * parseInt(value.slice(2), 16);
    if (value[1] === "o")
      return sign * parseInt(value.slice(2), 8);
  }
  return sign * parseInt(value, 10);
}
function isInteger2(object) {
  return Object.prototype.toString.call(object) === "[object Number]" && (object % 1 === 0 && !common.isNegativeZero(object));
}
function resolveYamlFloat(data2) {
  if (data2 === null)
    return false;
  if (!YAML_FLOAT_PATTERN.test(data2) || data2[data2.length - 1] === "_") {
    return false;
  }
  return true;
}
function constructYamlFloat(data2) {
  var value, sign;
  value = data2.replace(/_/g, "").toLowerCase();
  sign = value[0] === "-" ? -1 : 1;
  if ("+-".indexOf(value[0]) >= 0) {
    value = value.slice(1);
  }
  if (value === ".inf") {
    return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
  } else if (value === ".nan") {
    return NaN;
  }
  return sign * parseFloat(value, 10);
}
function representYamlFloat(object, style) {
  var res;
  if (isNaN(object)) {
    switch (style) {
      case "lowercase":
        return ".nan";
      case "uppercase":
        return ".NAN";
      case "camelcase":
        return ".NaN";
    }
  } else if (Number.POSITIVE_INFINITY === object) {
    switch (style) {
      case "lowercase":
        return ".inf";
      case "uppercase":
        return ".INF";
      case "camelcase":
        return ".Inf";
    }
  } else if (Number.NEGATIVE_INFINITY === object) {
    switch (style) {
      case "lowercase":
        return "-.inf";
      case "uppercase":
        return "-.INF";
      case "camelcase":
        return "-.Inf";
    }
  } else if (common.isNegativeZero(object)) {
    return "-0.0";
  }
  res = object.toString(10);
  return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
}
function isFloat(object) {
  return Object.prototype.toString.call(object) === "[object Number]" && (object % 1 !== 0 || common.isNegativeZero(object));
}
function resolveYamlTimestamp(data2) {
  if (data2 === null)
    return false;
  if (YAML_DATE_REGEXP.exec(data2) !== null)
    return true;
  if (YAML_TIMESTAMP_REGEXP.exec(data2) !== null)
    return true;
  return false;
}
function constructYamlTimestamp(data2) {
  var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date;
  match = YAML_DATE_REGEXP.exec(data2);
  if (match === null)
    match = YAML_TIMESTAMP_REGEXP.exec(data2);
  if (match === null)
    throw new Error("Date resolve error");
  year = +match[1];
  month = +match[2] - 1;
  day = +match[3];
  if (!match[4]) {
    return new Date(Date.UTC(year, month, day));
  }
  hour = +match[4];
  minute = +match[5];
  second = +match[6];
  if (match[7]) {
    fraction = match[7].slice(0, 3);
    while (fraction.length < 3) {
      fraction += "0";
    }
    fraction = +fraction;
  }
  if (match[9]) {
    tz_hour = +match[10];
    tz_minute = +(match[11] || 0);
    delta = (tz_hour * 60 + tz_minute) * 60000;
    if (match[9] === "-")
      delta = -delta;
  }
  date = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
  if (delta)
    date.setTime(date.getTime() - delta);
  return date;
}
function representYamlTimestamp(object) {
  return object.toISOString();
}
function resolveYamlMerge(data2) {
  return data2 === "<<" || data2 === null;
}
function resolveYamlBinary(data2) {
  if (data2 === null)
    return false;
  var code, idx, bitlen = 0, max = data2.length, map2 = BASE64_MAP;
  for (idx = 0;idx < max; idx++) {
    code = map2.indexOf(data2.charAt(idx));
    if (code > 64)
      continue;
    if (code < 0)
      return false;
    bitlen += 6;
  }
  return bitlen % 8 === 0;
}
function constructYamlBinary(data2) {
  var idx, tailbits, input = data2.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP, bits = 0, result2 = [];
  for (idx = 0;idx < max; idx++) {
    if (idx % 4 === 0 && idx) {
      result2.push(bits >> 16 & 255);
      result2.push(bits >> 8 & 255);
      result2.push(bits & 255);
    }
    bits = bits << 6 | map2.indexOf(input.charAt(idx));
  }
  tailbits = max % 4 * 6;
  if (tailbits === 0) {
    result2.push(bits >> 16 & 255);
    result2.push(bits >> 8 & 255);
    result2.push(bits & 255);
  } else if (tailbits === 18) {
    result2.push(bits >> 10 & 255);
    result2.push(bits >> 2 & 255);
  } else if (tailbits === 12) {
    result2.push(bits >> 4 & 255);
  }
  return new Uint8Array(result2);
}
function representYamlBinary(object) {
  var result2 = "", bits = 0, idx, tail, max = object.length, map2 = BASE64_MAP;
  for (idx = 0;idx < max; idx++) {
    if (idx % 3 === 0 && idx) {
      result2 += map2[bits >> 18 & 63];
      result2 += map2[bits >> 12 & 63];
      result2 += map2[bits >> 6 & 63];
      result2 += map2[bits & 63];
    }
    bits = (bits << 8) + object[idx];
  }
  tail = max % 3;
  if (tail === 0) {
    result2 += map2[bits >> 18 & 63];
    result2 += map2[bits >> 12 & 63];
    result2 += map2[bits >> 6 & 63];
    result2 += map2[bits & 63];
  } else if (tail === 2) {
    result2 += map2[bits >> 10 & 63];
    result2 += map2[bits >> 4 & 63];
    result2 += map2[bits << 2 & 63];
    result2 += map2[64];
  } else if (tail === 1) {
    result2 += map2[bits >> 2 & 63];
    result2 += map2[bits << 4 & 63];
    result2 += map2[64];
    result2 += map2[64];
  }
  return result2;
}
function isBinary(obj) {
  return Object.prototype.toString.call(obj) === "[object Uint8Array]";
}
function resolveYamlOmap(data2) {
  if (data2 === null)
    return true;
  var objectKeys = [], index, length, pair, pairKey, pairHasKey, object = data2;
  for (index = 0, length = object.length;index < length; index += 1) {
    pair = object[index];
    pairHasKey = false;
    if (_toString$2.call(pair) !== "[object Object]")
      return false;
    for (pairKey in pair) {
      if (_hasOwnProperty$3.call(pair, pairKey)) {
        if (!pairHasKey)
          pairHasKey = true;
        else
          return false;
      }
    }
    if (!pairHasKey)
      return false;
    if (objectKeys.indexOf(pairKey) === -1)
      objectKeys.push(pairKey);
    else
      return false;
  }
  return true;
}
function constructYamlOmap(data2) {
  return data2 !== null ? data2 : [];
}
function resolveYamlPairs(data2) {
  if (data2 === null)
    return true;
  var index, length, pair, keys2, result2, object = data2;
  result2 = new Array(object.length);
  for (index = 0, length = object.length;index < length; index += 1) {
    pair = object[index];
    if (_toString$1.call(pair) !== "[object Object]")
      return false;
    keys2 = Object.keys(pair);
    if (keys2.length !== 1)
      return false;
    result2[index] = [keys2[0], pair[keys2[0]]];
  }
  return true;
}
function constructYamlPairs(data2) {
  if (data2 === null)
    return [];
  var index, length, pair, keys2, result2, object = data2;
  result2 = new Array(object.length);
  for (index = 0, length = object.length;index < length; index += 1) {
    pair = object[index];
    keys2 = Object.keys(pair);
    result2[index] = [keys2[0], pair[keys2[0]]];
  }
  return result2;
}
function resolveYamlSet(data2) {
  if (data2 === null)
    return true;
  var key2, object = data2;
  for (key2 in object) {
    if (_hasOwnProperty$2.call(object, key2)) {
      if (object[key2] !== null)
        return false;
    }
  }
  return true;
}
function constructYamlSet(data2) {
  return data2 !== null ? data2 : {};
}
function _class(obj) {
  return Object.prototype.toString.call(obj);
}
function is_EOL(c22) {
  return c22 === 10 || c22 === 13;
}
function is_WHITE_SPACE(c22) {
  return c22 === 9 || c22 === 32;
}
function is_WS_OR_EOL(c22) {
  return c22 === 9 || c22 === 32 || c22 === 10 || c22 === 13;
}
function is_FLOW_INDICATOR(c22) {
  return c22 === 44 || c22 === 91 || c22 === 93 || c22 === 123 || c22 === 125;
}
function fromHexCode(c22) {
  var lc;
  if (48 <= c22 && c22 <= 57) {
    return c22 - 48;
  }
  lc = c22 | 32;
  if (97 <= lc && lc <= 102) {
    return lc - 97 + 10;
  }
  return -1;
}
function escapedHexLen(c22) {
  if (c22 === 120) {
    return 2;
  }
  if (c22 === 117) {
    return 4;
  }
  if (c22 === 85) {
    return 8;
  }
  return 0;
}
function fromDecimalCode(c22) {
  if (48 <= c22 && c22 <= 57) {
    return c22 - 48;
  }
  return -1;
}
function simpleEscapeSequence(c22) {
  return c22 === 48 ? "\0" : c22 === 97 ? "\x07" : c22 === 98 ? "\b" : c22 === 116 ? "\t" : c22 === 9 ? "\t" : c22 === 110 ? `
` : c22 === 118 ? "\v" : c22 === 102 ? "\f" : c22 === 114 ? `\r` : c22 === 101 ? "\x1B" : c22 === 32 ? " " : c22 === 34 ? '"' : c22 === 47 ? "/" : c22 === 92 ? "\\" : c22 === 78 ? "\x85" : c22 === 95 ? "\xA0" : c22 === 76 ? "\u2028" : c22 === 80 ? "\u2029" : "";
}
function charFromCodepoint(c22) {
  if (c22 <= 65535) {
    return String.fromCharCode(c22);
  }
  return String.fromCharCode((c22 - 65536 >> 10) + 55296, (c22 - 65536 & 1023) + 56320);
}
function State$1(input, options3) {
  this.input = input;
  this.filename = options3["filename"] || null;
  this.schema = options3["schema"] || _default;
  this.onWarning = options3["onWarning"] || null;
  this.legacy = options3["legacy"] || false;
  this.json = options3["json"] || false;
  this.listener = options3["listener"] || null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.typeMap = this.schema.compiledTypeMap;
  this.length = input.length;
  this.position = 0;
  this.line = 0;
  this.lineStart = 0;
  this.lineIndent = 0;
  this.firstTabInLine = -1;
  this.documents = [];
}
function generateError(state, message) {
  var mark2 = {
    name: state.filename,
    buffer: state.input.slice(0, -1),
    position: state.position,
    line: state.line,
    column: state.position - state.lineStart
  };
  mark2.snippet = snippet(mark2);
  return new exception(message, mark2);
}
function throwError(state, message) {
  throw generateError(state, message);
}
function throwWarning(state, message) {
  if (state.onWarning) {
    state.onWarning.call(null, generateError(state, message));
  }
}
function captureSegment(state, start, end, checkJson) {
  var _position, _length, _character, _result;
  if (start < end) {
    _result = state.input.slice(start, end);
    if (checkJson) {
      for (_position = 0, _length = _result.length;_position < _length; _position += 1) {
        _character = _result.charCodeAt(_position);
        if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
          throwError(state, "expected valid JSON character");
        }
      }
    } else if (PATTERN_NON_PRINTABLE.test(_result)) {
      throwError(state, "the stream contains non-printable characters");
    }
    state.result += _result;
  }
}
function mergeMappings(state, destination, source, overridableKeys) {
  var sourceKeys, key2, index, quantity;
  if (!common.isObject(source)) {
    throwError(state, "cannot merge mappings; the provided source object is unacceptable");
  }
  sourceKeys = Object.keys(source);
  for (index = 0, quantity = sourceKeys.length;index < quantity; index += 1) {
    key2 = sourceKeys[index];
    if (!_hasOwnProperty$1.call(destination, key2)) {
      destination[key2] = source[key2];
      overridableKeys[key2] = true;
    }
  }
}
function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
  var index, quantity;
  if (Array.isArray(keyNode)) {
    keyNode = Array.prototype.slice.call(keyNode);
    for (index = 0, quantity = keyNode.length;index < quantity; index += 1) {
      if (Array.isArray(keyNode[index])) {
        throwError(state, "nested arrays are not supported inside keys");
      }
      if (typeof keyNode === "object" && _class(keyNode[index]) === "[object Object]") {
        keyNode[index] = "[object Object]";
      }
    }
  }
  if (typeof keyNode === "object" && _class(keyNode) === "[object Object]") {
    keyNode = "[object Object]";
  }
  keyNode = String(keyNode);
  if (_result === null) {
    _result = {};
  }
  if (keyTag === "tag:yaml.org,2002:merge") {
    if (Array.isArray(valueNode)) {
      for (index = 0, quantity = valueNode.length;index < quantity; index += 1) {
        mergeMappings(state, _result, valueNode[index], overridableKeys);
      }
    } else {
      mergeMappings(state, _result, valueNode, overridableKeys);
    }
  } else {
    if (!state.json && !_hasOwnProperty$1.call(overridableKeys, keyNode) && _hasOwnProperty$1.call(_result, keyNode)) {
      state.line = startLine || state.line;
      state.lineStart = startLineStart || state.lineStart;
      state.position = startPos || state.position;
      throwError(state, "duplicated mapping key");
    }
    if (keyNode === "__proto__") {
      Object.defineProperty(_result, keyNode, {
        configurable: true,
        enumerable: true,
        writable: true,
        value: valueNode
      });
    } else {
      _result[keyNode] = valueNode;
    }
    delete overridableKeys[keyNode];
  }
  return _result;
}
function readLineBreak(state) {
  var ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 10) {
    state.position++;
  } else if (ch === 13) {
    state.position++;
    if (state.input.charCodeAt(state.position) === 10) {
      state.position++;
    }
  } else {
    throwError(state, "a line break is expected");
  }
  state.line += 1;
  state.lineStart = state.position;
  state.firstTabInLine = -1;
}
function skipSeparationSpace(state, allowComments, checkIndent) {
  var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    while (is_WHITE_SPACE(ch)) {
      if (ch === 9 && state.firstTabInLine === -1) {
        state.firstTabInLine = state.position;
      }
      ch = state.input.charCodeAt(++state.position);
    }
    if (allowComments && ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (ch !== 10 && ch !== 13 && ch !== 0);
    }
    if (is_EOL(ch)) {
      readLineBreak(state);
      ch = state.input.charCodeAt(state.position);
      lineBreaks++;
      state.lineIndent = 0;
      while (ch === 32) {
        state.lineIndent++;
        ch = state.input.charCodeAt(++state.position);
      }
    } else {
      break;
    }
  }
  if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
    throwWarning(state, "deficient indentation");
  }
  return lineBreaks;
}
function testDocumentSeparator(state) {
  var _position = state.position, ch;
  ch = state.input.charCodeAt(_position);
  if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
    _position += 3;
    ch = state.input.charCodeAt(_position);
    if (ch === 0 || is_WS_OR_EOL(ch)) {
      return true;
    }
  }
  return false;
}
function writeFoldedLines(state, count) {
  if (count === 1) {
    state.result += " ";
  } else if (count > 1) {
    state.result += common.repeat("\n", count - 1);
  }
}
function readPlainScalar(state, nodeIndent, withinFlowCollection) {
  var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
  ch = state.input.charCodeAt(state.position);
  if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
    return false;
  }
  if (ch === 63 || ch === 45) {
    following = state.input.charCodeAt(state.position + 1);
    if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
      return false;
    }
  }
  state.kind = "scalar";
  state.result = "";
  captureStart = captureEnd = state.position;
  hasPendingContent = false;
  while (ch !== 0) {
    if (ch === 58) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
        break;
      }
    } else if (ch === 35) {
      preceding = state.input.charCodeAt(state.position - 1);
      if (is_WS_OR_EOL(preceding)) {
        break;
      }
    } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) {
      break;
    } else if (is_EOL(ch)) {
      _line = state.line;
      _lineStart = state.lineStart;
      _lineIndent = state.lineIndent;
      skipSeparationSpace(state, false, -1);
      if (state.lineIndent >= nodeIndent) {
        hasPendingContent = true;
        ch = state.input.charCodeAt(state.position);
        continue;
      } else {
        state.position = captureEnd;
        state.line = _line;
        state.lineStart = _lineStart;
        state.lineIndent = _lineIndent;
        break;
      }
    }
    if (hasPendingContent) {
      captureSegment(state, captureStart, captureEnd, false);
      writeFoldedLines(state, state.line - _line);
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
    }
    if (!is_WHITE_SPACE(ch)) {
      captureEnd = state.position + 1;
    }
    ch = state.input.charCodeAt(++state.position);
  }
  captureSegment(state, captureStart, captureEnd, false);
  if (state.result) {
    return true;
  }
  state.kind = _kind;
  state.result = _result;
  return false;
}
function readSingleQuotedScalar(state, nodeIndent) {
  var ch, captureStart, captureEnd;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 39) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 39) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (ch === 39) {
        captureStart = state.position;
        state.position++;
        captureEnd = state.position;
      } else {
        return true;
      }
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a single quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a single quoted scalar");
}
function readDoubleQuotedScalar(state, nodeIndent) {
  var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 34) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 34) {
      captureSegment(state, captureStart, state.position, true);
      state.position++;
      return true;
    } else if (ch === 92) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (is_EOL(ch)) {
        skipSeparationSpace(state, false, nodeIndent);
      } else if (ch < 256 && simpleEscapeCheck[ch]) {
        state.result += simpleEscapeMap[ch];
        state.position++;
      } else if ((tmp = escapedHexLen(ch)) > 0) {
        hexLength = tmp;
        hexResult = 0;
        for (;hexLength > 0; hexLength--) {
          ch = state.input.charCodeAt(++state.position);
          if ((tmp = fromHexCode(ch)) >= 0) {
            hexResult = (hexResult << 4) + tmp;
          } else {
            throwError(state, "expected hexadecimal character");
          }
        }
        state.result += charFromCodepoint(hexResult);
        state.position++;
      } else {
        throwError(state, "unknown escape sequence");
      }
      captureStart = captureEnd = state.position;
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a double quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a double quoted scalar");
}
function readFlowCollection(state, nodeIndent) {
  var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = Object.create(null), keyNode, keyTag, valueNode, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 91) {
    terminator = 93;
    isMapping = false;
    _result = [];
  } else if (ch === 123) {
    terminator = 125;
    isMapping = true;
    _result = {};
  } else {
    return false;
  }
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(++state.position);
  while (ch !== 0) {
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === terminator) {
      state.position++;
      state.tag = _tag;
      state.anchor = _anchor;
      state.kind = isMapping ? "mapping" : "sequence";
      state.result = _result;
      return true;
    } else if (!readNext) {
      throwError(state, "missed comma between flow collection entries");
    } else if (ch === 44) {
      throwError(state, "expected the node content, but found ','");
    }
    keyTag = keyNode = valueNode = null;
    isPair = isExplicitPair = false;
    if (ch === 63) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following)) {
        isPair = isExplicitPair = true;
        state.position++;
        skipSeparationSpace(state, true, nodeIndent);
      }
    }
    _line = state.line;
    _lineStart = state.lineStart;
    _pos = state.position;
    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
    keyTag = state.tag;
    keyNode = state.result;
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if ((isExplicitPair || state.line === _line) && ch === 58) {
      isPair = true;
      ch = state.input.charCodeAt(++state.position);
      skipSeparationSpace(state, true, nodeIndent);
      composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
      valueNode = state.result;
    }
    if (isMapping) {
      storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
    } else if (isPair) {
      _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
    } else {
      _result.push(keyNode);
    }
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === 44) {
      readNext = true;
      ch = state.input.charCodeAt(++state.position);
    } else {
      readNext = false;
    }
  }
  throwError(state, "unexpected end of the stream within a flow collection");
}
function readBlockScalar(state, nodeIndent) {
  var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 124) {
    folding = false;
  } else if (ch === 62) {
    folding = true;
  } else {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  while (ch !== 0) {
    ch = state.input.charCodeAt(++state.position);
    if (ch === 43 || ch === 45) {
      if (CHOMPING_CLIP === chomping) {
        chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP;
      } else {
        throwError(state, "repeat of a chomping mode identifier");
      }
    } else if ((tmp = fromDecimalCode(ch)) >= 0) {
      if (tmp === 0) {
        throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
      } else if (!detectedIndent) {
        textIndent = nodeIndent + tmp - 1;
        detectedIndent = true;
      } else {
        throwError(state, "repeat of an indentation width identifier");
      }
    } else {
      break;
    }
  }
  if (is_WHITE_SPACE(ch)) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (is_WHITE_SPACE(ch));
    if (ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (!is_EOL(ch) && ch !== 0);
    }
  }
  while (ch !== 0) {
    readLineBreak(state);
    state.lineIndent = 0;
    ch = state.input.charCodeAt(state.position);
    while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
      state.lineIndent++;
      ch = state.input.charCodeAt(++state.position);
    }
    if (!detectedIndent && state.lineIndent > textIndent) {
      textIndent = state.lineIndent;
    }
    if (is_EOL(ch)) {
      emptyLines++;
      continue;
    }
    if (state.lineIndent < textIndent) {
      if (chomping === CHOMPING_KEEP) {
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (chomping === CHOMPING_CLIP) {
        if (didReadContent) {
          state.result += "\n";
        }
      }
      break;
    }
    if (folding) {
      if (is_WHITE_SPACE(ch)) {
        atMoreIndented = true;
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (atMoreIndented) {
        atMoreIndented = false;
        state.result += common.repeat("\n", emptyLines + 1);
      } else if (emptyLines === 0) {
        if (didReadContent) {
          state.result += " ";
        }
      } else {
        state.result += common.repeat("\n", emptyLines);
      }
    } else {
      state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
    }
    didReadContent = true;
    detectedIndent = true;
    emptyLines = 0;
    captureStart = state.position;
    while (!is_EOL(ch) && ch !== 0) {
      ch = state.input.charCodeAt(++state.position);
    }
    captureSegment(state, captureStart, state.position, false);
  }
  return true;
}
function readBlockSequence(state, nodeIndent) {
  var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
  if (state.firstTabInLine !== -1)
    return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    if (ch !== 45) {
      break;
    }
    following = state.input.charCodeAt(state.position + 1);
    if (!is_WS_OR_EOL(following)) {
      break;
    }
    detected = true;
    state.position++;
    if (skipSeparationSpace(state, true, -1)) {
      if (state.lineIndent <= nodeIndent) {
        _result.push(null);
        ch = state.input.charCodeAt(state.position);
        continue;
      }
    }
    _line = state.line;
    composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
    _result.push(state.result);
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a sequence entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "sequence";
    state.result = _result;
    return true;
  }
  return false;
}
function readBlockMapping(state, nodeIndent, flowIndent) {
  var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
  if (state.firstTabInLine !== -1)
    return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (!atExplicitKey && state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    following = state.input.charCodeAt(state.position + 1);
    _line = state.line;
    if ((ch === 63 || ch === 58) && is_WS_OR_EOL(following)) {
      if (ch === 63) {
        if (atExplicitKey) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
          keyTag = keyNode = valueNode = null;
        }
        detected = true;
        atExplicitKey = true;
        allowCompact = true;
      } else if (atExplicitKey) {
        atExplicitKey = false;
        allowCompact = true;
      } else {
        throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
      }
      state.position += 1;
      ch = following;
    } else {
      _keyLine = state.line;
      _keyLineStart = state.lineStart;
      _keyPos = state.position;
      if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
        break;
      }
      if (state.line === _line) {
        ch = state.input.charCodeAt(state.position);
        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        if (ch === 58) {
          ch = state.input.charCodeAt(++state.position);
          if (!is_WS_OR_EOL(ch)) {
            throwError(state, "a whitespace character is expected after the key-value separator within a block mapping");
          }
          if (atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          detected = true;
          atExplicitKey = false;
          allowCompact = false;
          keyTag = state.tag;
          keyNode = state.result;
        } else if (detected) {
          throwError(state, "can not read an implicit mapping pair; a colon is missed");
        } else {
          state.tag = _tag;
          state.anchor = _anchor;
          return true;
        }
      } else if (detected) {
        throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
      } else {
        state.tag = _tag;
        state.anchor = _anchor;
        return true;
      }
    }
    if (state.line === _line || state.lineIndent > nodeIndent) {
      if (atExplicitKey) {
        _keyLine = state.line;
        _keyLineStart = state.lineStart;
        _keyPos = state.position;
      }
      if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
        if (atExplicitKey) {
          keyNode = state.result;
        } else {
          valueNode = state.result;
        }
      }
      if (!atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
        keyTag = keyNode = valueNode = null;
      }
      skipSeparationSpace(state, true, -1);
      ch = state.input.charCodeAt(state.position);
    }
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a mapping entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (atExplicitKey) {
    storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "mapping";
    state.result = _result;
  }
  return detected;
}
function readTagProperty(state) {
  var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 33)
    return false;
  if (state.tag !== null) {
    throwError(state, "duplication of a tag property");
  }
  ch = state.input.charCodeAt(++state.position);
  if (ch === 60) {
    isVerbatim = true;
    ch = state.input.charCodeAt(++state.position);
  } else if (ch === 33) {
    isNamed = true;
    tagHandle = "!!";
    ch = state.input.charCodeAt(++state.position);
  } else {
    tagHandle = "!";
  }
  _position = state.position;
  if (isVerbatim) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (ch !== 0 && ch !== 62);
    if (state.position < state.length) {
      tagName = state.input.slice(_position, state.position);
      ch = state.input.charCodeAt(++state.position);
    } else {
      throwError(state, "unexpected end of the stream within a verbatim tag");
    }
  } else {
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      if (ch === 33) {
        if (!isNamed) {
          tagHandle = state.input.slice(_position - 1, state.position + 1);
          if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
            throwError(state, "named tag handle cannot contain such characters");
          }
          isNamed = true;
          _position = state.position + 1;
        } else {
          throwError(state, "tag suffix cannot contain exclamation marks");
        }
      }
      ch = state.input.charCodeAt(++state.position);
    }
    tagName = state.input.slice(_position, state.position);
    if (PATTERN_FLOW_INDICATORS.test(tagName)) {
      throwError(state, "tag suffix cannot contain flow indicator characters");
    }
  }
  if (tagName && !PATTERN_TAG_URI.test(tagName)) {
    throwError(state, "tag name cannot contain such characters: " + tagName);
  }
  try {
    tagName = decodeURIComponent(tagName);
  } catch (err22) {
    throwError(state, "tag name is malformed: " + tagName);
  }
  if (isVerbatim) {
    state.tag = tagName;
  } else if (_hasOwnProperty$1.call(state.tagMap, tagHandle)) {
    state.tag = state.tagMap[tagHandle] + tagName;
  } else if (tagHandle === "!") {
    state.tag = "!" + tagName;
  } else if (tagHandle === "!!") {
    state.tag = "tag:yaml.org,2002:" + tagName;
  } else {
    throwError(state, 'undeclared tag handle "' + tagHandle + '"');
  }
  return true;
}
function readAnchorProperty(state) {
  var _position, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 38)
    return false;
  if (state.anchor !== null) {
    throwError(state, "duplication of an anchor property");
  }
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an anchor node must contain at least one character");
  }
  state.anchor = state.input.slice(_position, state.position);
  return true;
}
function readAlias(state) {
  var _position, alias, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 42)
    return false;
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an alias node must contain at least one character");
  }
  alias = state.input.slice(_position, state.position);
  if (!_hasOwnProperty$1.call(state.anchorMap, alias)) {
    throwError(state, 'unidentified alias "' + alias + '"');
  }
  state.result = state.anchorMap[alias];
  skipSeparationSpace(state, true, -1);
  return true;
}
function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
  var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
  if (state.listener !== null) {
    state.listener("open", state);
  }
  state.tag = null;
  state.anchor = null;
  state.kind = null;
  state.result = null;
  allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
  if (allowToSeek) {
    if (skipSeparationSpace(state, true, -1)) {
      atNewLine = true;
      if (state.lineIndent > parentIndent) {
        indentStatus = 1;
      } else if (state.lineIndent === parentIndent) {
        indentStatus = 0;
      } else if (state.lineIndent < parentIndent) {
        indentStatus = -1;
      }
    }
  }
  if (indentStatus === 1) {
    while (readTagProperty(state) || readAnchorProperty(state)) {
      if (skipSeparationSpace(state, true, -1)) {
        atNewLine = true;
        allowBlockCollections = allowBlockStyles;
        if (state.lineIndent > parentIndent) {
          indentStatus = 1;
        } else if (state.lineIndent === parentIndent) {
          indentStatus = 0;
        } else if (state.lineIndent < parentIndent) {
          indentStatus = -1;
        }
      } else {
        allowBlockCollections = false;
      }
    }
  }
  if (allowBlockCollections) {
    allowBlockCollections = atNewLine || allowCompact;
  }
  if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
    if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
      flowIndent = parentIndent;
    } else {
      flowIndent = parentIndent + 1;
    }
    blockIndent = state.position - state.lineStart;
    if (indentStatus === 1) {
      if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) {
        hasContent = true;
      } else {
        if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) {
          hasContent = true;
        } else if (readAlias(state)) {
          hasContent = true;
          if (state.tag !== null || state.anchor !== null) {
            throwError(state, "alias node should not have any properties");
          }
        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
          hasContent = true;
          if (state.tag === null) {
            state.tag = "?";
          }
        }
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      }
    } else if (indentStatus === 0) {
      hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
    }
  }
  if (state.tag === null) {
    if (state.anchor !== null) {
      state.anchorMap[state.anchor] = state.result;
    }
  } else if (state.tag === "?") {
    if (state.result !== null && state.kind !== "scalar") {
      throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
    }
    for (typeIndex = 0, typeQuantity = state.implicitTypes.length;typeIndex < typeQuantity; typeIndex += 1) {
      type2 = state.implicitTypes[typeIndex];
      if (type2.resolve(state.result)) {
        state.result = type2.construct(state.result);
        state.tag = type2.tag;
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
        break;
      }
    }
  } else if (state.tag !== "!") {
    if (_hasOwnProperty$1.call(state.typeMap[state.kind || "fallback"], state.tag)) {
      type2 = state.typeMap[state.kind || "fallback"][state.tag];
    } else {
      type2 = null;
      typeList = state.typeMap.multi[state.kind || "fallback"];
      for (typeIndex = 0, typeQuantity = typeList.length;typeIndex < typeQuantity; typeIndex += 1) {
        if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
          type2 = typeList[typeIndex];
          break;
        }
      }
    }
    if (!type2) {
      throwError(state, "unknown tag !<" + state.tag + ">");
    }
    if (state.result !== null && type2.kind !== state.kind) {
      throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
    }
    if (!type2.resolve(state.result, state.tag)) {
      throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
    } else {
      state.result = type2.construct(state.result, state.tag);
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = state.result;
      }
    }
  }
  if (state.listener !== null) {
    state.listener("close", state);
  }
  return state.tag !== null || state.anchor !== null || hasContent;
}
function readDocument(state) {
  var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
  state.version = null;
  state.checkLineBreaks = state.legacy;
  state.tagMap = Object.create(null);
  state.anchorMap = Object.create(null);
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if (state.lineIndent > 0 || ch !== 37) {
      break;
    }
    hasDirectives = true;
    ch = state.input.charCodeAt(++state.position);
    _position = state.position;
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      ch = state.input.charCodeAt(++state.position);
    }
    directiveName = state.input.slice(_position, state.position);
    directiveArgs = [];
    if (directiveName.length < 1) {
      throwError(state, "directive name must not be less than one character in length");
    }
    while (ch !== 0) {
      while (is_WHITE_SPACE(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (ch === 35) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && !is_EOL(ch));
        break;
      }
      if (is_EOL(ch))
        break;
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      directiveArgs.push(state.input.slice(_position, state.position));
    }
    if (ch !== 0)
      readLineBreak(state);
    if (_hasOwnProperty$1.call(directiveHandlers, directiveName)) {
      directiveHandlers[directiveName](state, directiveName, directiveArgs);
    } else {
      throwWarning(state, 'unknown document directive "' + directiveName + '"');
    }
  }
  skipSeparationSpace(state, true, -1);
  if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
    state.position += 3;
    skipSeparationSpace(state, true, -1);
  } else if (hasDirectives) {
    throwError(state, "directives end mark is expected");
  }
  composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
  skipSeparationSpace(state, true, -1);
  if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
    throwWarning(state, "non-ASCII line breaks are interpreted as content");
  }
  state.documents.push(state.result);
  if (state.position === state.lineStart && testDocumentSeparator(state)) {
    if (state.input.charCodeAt(state.position) === 46) {
      state.position += 3;
      skipSeparationSpace(state, true, -1);
    }
    return;
  }
  if (state.position < state.length - 1) {
    throwError(state, "end of the stream or a document separator is expected");
  } else {
    return;
  }
}
function loadDocuments(input, options3) {
  input = String(input);
  options3 = options3 || {};
  if (input.length !== 0) {
    if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
      input += "\n";
    }
    if (input.charCodeAt(0) === 65279) {
      input = input.slice(1);
    }
  }
  var state = new State$1(input, options3);
  var nullpos = input.indexOf("\0");
  if (nullpos !== -1) {
    state.position = nullpos;
    throwError(state, "null byte is not allowed in input");
  }
  state.input += "\0";
  while (state.input.charCodeAt(state.position) === 32) {
    state.lineIndent += 1;
    state.position += 1;
  }
  while (state.position < state.length - 1) {
    readDocument(state);
  }
  return state.documents;
}
function loadAll$1(input, iterator, options3) {
  if (iterator !== null && typeof iterator === "object" && typeof options3 === "undefined") {
    options3 = iterator;
    iterator = null;
  }
  var documents = loadDocuments(input, options3);
  if (typeof iterator !== "function") {
    return documents;
  }
  for (var index = 0, length = documents.length;index < length; index += 1) {
    iterator(documents[index]);
  }
}
function load$1(input, options3) {
  var documents = loadDocuments(input, options3);
  if (documents.length === 0) {
    return;
  } else if (documents.length === 1) {
    return documents[0];
  }
  throw new exception("expected a single document in the stream, but found more");
}
function compileStyleMap(schema5, map2) {
  var result2, keys2, index, length, tag, style, type2;
  if (map2 === null)
    return {};
  result2 = {};
  keys2 = Object.keys(map2);
  for (index = 0, length = keys2.length;index < length; index += 1) {
    tag = keys2[index];
    style = String(map2[tag]);
    if (tag.slice(0, 2) === "!!") {
      tag = "tag:yaml.org,2002:" + tag.slice(2);
    }
    type2 = schema5.compiledTypeMap["fallback"][tag];
    if (type2 && _hasOwnProperty.call(type2.styleAliases, style)) {
      style = type2.styleAliases[style];
    }
    result2[tag] = style;
  }
  return result2;
}
function encodeHex(character) {
  var string2, handle, length;
  string2 = character.toString(16).toUpperCase();
  if (character <= 255) {
    handle = "x";
    length = 2;
  } else if (character <= 65535) {
    handle = "u";
    length = 4;
  } else if (character <= 4294967295) {
    handle = "U";
    length = 8;
  } else {
    throw new exception("code point within a string may not be greater than 0xFFFFFFFF");
  }
  return "\\" + handle + common.repeat("0", length - string2.length) + string2;
}
function State(options3) {
  this.schema = options3["schema"] || _default;
  this.indent = Math.max(1, options3["indent"] || 2);
  this.noArrayIndent = options3["noArrayIndent"] || false;
  this.skipInvalid = options3["skipInvalid"] || false;
  this.flowLevel = common.isNothing(options3["flowLevel"]) ? -1 : options3["flowLevel"];
  this.styleMap = compileStyleMap(this.schema, options3["styles"] || null);
  this.sortKeys = options3["sortKeys"] || false;
  this.lineWidth = options3["lineWidth"] || 80;
  this.noRefs = options3["noRefs"] || false;
  this.noCompatMode = options3["noCompatMode"] || false;
  this.condenseFlow = options3["condenseFlow"] || false;
  this.quotingType = options3["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
  this.forceQuotes = options3["forceQuotes"] || false;
  this.replacer = typeof options3["replacer"] === "function" ? options3["replacer"] : null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.explicitTypes = this.schema.compiledExplicit;
  this.tag = null;
  this.result = "";
  this.duplicates = [];
  this.usedDuplicates = null;
}
function indentString(string2, spaces) {
  var ind = common.repeat(" ", spaces), position = 0, next = -1, result2 = "", line, length = string2.length;
  while (position < length) {
    next = string2.indexOf("\n", position);
    if (next === -1) {
      line = string2.slice(position);
      position = length;
    } else {
      line = string2.slice(position, next + 1);
      position = next + 1;
    }
    if (line.length && line !== "\n")
      result2 += ind;
    result2 += line;
  }
  return result2;
}
function generateNextLine(state, level) {
  return "\n" + common.repeat(" ", state.indent * level);
}
function testImplicitResolving(state, str2) {
  var index, length, type2;
  for (index = 0, length = state.implicitTypes.length;index < length; index += 1) {
    type2 = state.implicitTypes[index];
    if (type2.resolve(str2)) {
      return true;
    }
  }
  return false;
}
function isWhitespace(c22) {
  return c22 === CHAR_SPACE || c22 === CHAR_TAB;
}
function isPrintable(c22) {
  return 32 <= c22 && c22 <= 126 || 161 <= c22 && c22 <= 55295 && c22 !== 8232 && c22 !== 8233 || 57344 <= c22 && c22 <= 65533 && c22 !== CHAR_BOM || 65536 <= c22 && c22 <= 1114111;
}
function isNsCharOrWhitespace(c22) {
  return isPrintable(c22) && c22 !== CHAR_BOM && c22 !== CHAR_CARRIAGE_RETURN && c22 !== CHAR_LINE_FEED;
}
function isPlainSafe(c22, prev, inblock) {
  var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c22);
  var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c22);
  return (inblock ? cIsNsCharOrWhitespace : cIsNsCharOrWhitespace && c22 !== CHAR_COMMA2 && c22 !== CHAR_LEFT_SQUARE_BRACKET2 && c22 !== CHAR_RIGHT_SQUARE_BRACKET2 && c22 !== CHAR_LEFT_CURLY_BRACKET && c22 !== CHAR_RIGHT_CURLY_BRACKET) && c22 !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c22 === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar;
}
function isPlainSafeFirst(c22) {
  return isPrintable(c22) && c22 !== CHAR_BOM && !isWhitespace(c22) && c22 !== CHAR_MINUS && c22 !== CHAR_QUESTION && c22 !== CHAR_COLON && c22 !== CHAR_COMMA2 && c22 !== CHAR_LEFT_SQUARE_BRACKET2 && c22 !== CHAR_RIGHT_SQUARE_BRACKET2 && c22 !== CHAR_LEFT_CURLY_BRACKET && c22 !== CHAR_RIGHT_CURLY_BRACKET && c22 !== CHAR_SHARP && c22 !== CHAR_AMPERSAND && c22 !== CHAR_ASTERISK2 && c22 !== CHAR_EXCLAMATION && c22 !== CHAR_VERTICAL_LINE && c22 !== CHAR_EQUALS && c22 !== CHAR_GREATER_THAN && c22 !== CHAR_SINGLE_QUOTE && c22 !== CHAR_DOUBLE_QUOTE && c22 !== CHAR_PERCENT && c22 !== CHAR_COMMERCIAL_AT && c22 !== CHAR_GRAVE_ACCENT;
}
function isPlainSafeLast(c22) {
  return !isWhitespace(c22) && c22 !== CHAR_COLON;
}
function codePointAt(string2, pos) {
  var first = string2.charCodeAt(pos), second;
  if (first >= 55296 && first <= 56319 && pos + 1 < string2.length) {
    second = string2.charCodeAt(pos + 1);
    if (second >= 56320 && second <= 57343) {
      return (first - 55296) * 1024 + second - 56320 + 65536;
    }
  }
  return first;
}
function needIndentIndicator(string2) {
  var leadingSpaceRe = /^\n* /;
  return leadingSpaceRe.test(string2);
}
function chooseScalarStyle(string2, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
  var i2;
  var char = 0;
  var prevChar = null;
  var hasLineBreak = false;
  var hasFoldableLine = false;
  var shouldTrackWidth = lineWidth !== -1;
  var previousLineBreak = -1;
  var plain = isPlainSafeFirst(codePointAt(string2, 0)) && isPlainSafeLast(codePointAt(string2, string2.length - 1));
  if (singleLineOnly || forceQuotes) {
    for (i2 = 0;i2 < string2.length; char >= 65536 ? i2 += 2 : i2++) {
      char = codePointAt(string2, i2);
      if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
  } else {
    for (i2 = 0;i2 < string2.length; char >= 65536 ? i2 += 2 : i2++) {
      char = codePointAt(string2, i2);
      if (char === CHAR_LINE_FEED) {
        hasLineBreak = true;
        if (shouldTrackWidth) {
          hasFoldableLine = hasFoldableLine || i2 - previousLineBreak - 1 > lineWidth && string2[previousLineBreak + 1] !== " ";
          previousLineBreak = i2;
        }
      } else if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
    hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i2 - previousLineBreak - 1 > lineWidth && string2[previousLineBreak + 1] !== " ");
  }
  if (!hasLineBreak && !hasFoldableLine) {
    if (plain && !forceQuotes && !testAmbiguousType(string2)) {
      return STYLE_PLAIN;
    }
    return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
  }
  if (indentPerLevel > 9 && needIndentIndicator(string2)) {
    return STYLE_DOUBLE;
  }
  if (!forceQuotes) {
    return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
  }
  return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
}
function writeScalar(state, string2, level, iskey, inblock) {
  state.dump = function() {
    if (string2.length === 0) {
      return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
    }
    if (!state.noCompatMode) {
      if (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string2) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string2)) {
        return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string2 + '"' : "'" + string2 + "'";
      }
    }
    var indent = state.indent * Math.max(1, level);
    var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
    var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
    function testAmbiguity(string3) {
      return testImplicitResolving(state, string3);
    }
    switch (chooseScalarStyle(string2, singleLineOnly, state.indent, lineWidth, testAmbiguity, state.quotingType, state.forceQuotes && !iskey, inblock)) {
      case STYLE_PLAIN:
        return string2;
      case STYLE_SINGLE:
        return "'" + string2.replace(/'/g, "''") + "'";
      case STYLE_LITERAL:
        return "|" + blockHeader(string2, state.indent) + dropEndingNewline(indentString(string2, indent));
      case STYLE_FOLDED:
        return ">" + blockHeader(string2, state.indent) + dropEndingNewline(indentString(foldString(string2, lineWidth), indent));
      case STYLE_DOUBLE:
        return '"' + escapeString(string2) + '"';
      default:
        throw new exception("impossible error: invalid scalar style");
    }
  }();
}
function blockHeader(string2, indentPerLevel) {
  var indentIndicator = needIndentIndicator(string2) ? String(indentPerLevel) : "";
  var clip = string2[string2.length - 1] === "\n";
  var keep = clip && (string2[string2.length - 2] === "\n" || string2 === "\n");
  var chomp = keep ? "+" : clip ? "" : "-";
  return indentIndicator + chomp + "\n";
}
function dropEndingNewline(string2) {
  return string2[string2.length - 1] === "\n" ? string2.slice(0, -1) : string2;
}
function foldString(string2, width) {
  var lineRe = /(\n+)([^\n]*)/g;
  var result2 = function() {
    var nextLF = string2.indexOf("\n");
    nextLF = nextLF !== -1 ? nextLF : string2.length;
    lineRe.lastIndex = nextLF;
    return foldLine(string2.slice(0, nextLF), width);
  }();
  var prevMoreIndented = string2[0] === "\n" || string2[0] === " ";
  var moreIndented;
  var match;
  while (match = lineRe.exec(string2)) {
    var prefix = match[1], line = match[2];
    moreIndented = line[0] === " ";
    result2 += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine(line, width);
    prevMoreIndented = moreIndented;
  }
  return result2;
}
function foldLine(line, width) {
  if (line === "" || line[0] === " ")
    return line;
  var breakRe = / [^ ]/g;
  var match;
  var start = 0, end, curr = 0, next = 0;
  var result2 = "";
  while (match = breakRe.exec(line)) {
    next = match.index;
    if (next - start > width) {
      end = curr > start ? curr : next;
      result2 += "\n" + line.slice(start, end);
      start = end + 1;
    }
    curr = next;
  }
  result2 += "\n";
  if (line.length - start > width && curr > start) {
    result2 += line.slice(start, curr) + "\n" + line.slice(curr + 1);
  } else {
    result2 += line.slice(start);
  }
  return result2.slice(1);
}
function escapeString(string2) {
  var result2 = "";
  var char = 0;
  var escapeSeq;
  for (var i2 = 0;i2 < string2.length; char >= 65536 ? i2 += 2 : i2++) {
    char = codePointAt(string2, i2);
    escapeSeq = ESCAPE_SEQUENCES[char];
    if (!escapeSeq && isPrintable(char)) {
      result2 += string2[i2];
      if (char >= 65536)
        result2 += string2[i2 + 1];
    } else {
      result2 += escapeSeq || encodeHex(char);
    }
  }
  return result2;
}
function writeFlowSequence(state, level, object) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object.length;index < length; index += 1) {
    value = object[index];
    if (state.replacer) {
      value = state.replacer.call(object, String(index), value);
    }
    if (writeNode(state, level, value, false, false) || typeof value === "undefined" && writeNode(state, level, null, false, false)) {
      if (_result !== "")
        _result += "," + (!state.condenseFlow ? " " : "");
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = "[" + _result + "]";
}
function writeBlockSequence(state, level, object, compact) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object.length;index < length; index += 1) {
    value = object[index];
    if (state.replacer) {
      value = state.replacer.call(object, String(index), value);
    }
    if (writeNode(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode(state, level + 1, null, true, true, false, true)) {
      if (!compact || _result !== "") {
        _result += generateNextLine(state, level);
      }
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        _result += "-";
      } else {
        _result += "- ";
      }
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = _result || "[]";
}
function writeFlowMapping(state, level, object) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, pairBuffer;
  for (index = 0, length = objectKeyList.length;index < length; index += 1) {
    pairBuffer = "";
    if (_result !== "")
      pairBuffer += ", ";
    if (state.condenseFlow)
      pairBuffer += '"';
    objectKey = objectKeyList[index];
    objectValue = object[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object, objectKey, objectValue);
    }
    if (!writeNode(state, level, objectKey, false, false)) {
      continue;
    }
    if (state.dump.length > 1024)
      pairBuffer += "? ";
    pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
    if (!writeNode(state, level, objectValue, false, false)) {
      continue;
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = "{" + _result + "}";
}
function writeBlockMapping(state, level, object, compact) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, explicitPair, pairBuffer;
  if (state.sortKeys === true) {
    objectKeyList.sort();
  } else if (typeof state.sortKeys === "function") {
    objectKeyList.sort(state.sortKeys);
  } else if (state.sortKeys) {
    throw new exception("sortKeys must be a boolean or a function");
  }
  for (index = 0, length = objectKeyList.length;index < length; index += 1) {
    pairBuffer = "";
    if (!compact || _result !== "") {
      pairBuffer += generateNextLine(state, level);
    }
    objectKey = objectKeyList[index];
    objectValue = object[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object, objectKey, objectValue);
    }
    if (!writeNode(state, level + 1, objectKey, true, true, true)) {
      continue;
    }
    explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
    if (explicitPair) {
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        pairBuffer += "?";
      } else {
        pairBuffer += "? ";
      }
    }
    pairBuffer += state.dump;
    if (explicitPair) {
      pairBuffer += generateNextLine(state, level);
    }
    if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
      continue;
    }
    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
      pairBuffer += ":";
    } else {
      pairBuffer += ": ";
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = _result || "{}";
}
function detectType(state, object, explicit) {
  var _result, typeList, index, length, type2, style;
  typeList = explicit ? state.explicitTypes : state.implicitTypes;
  for (index = 0, length = typeList.length;index < length; index += 1) {
    type2 = typeList[index];
    if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || typeof object === "object" && object instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object))) {
      if (explicit) {
        if (type2.multi && type2.representName) {
          state.tag = type2.representName(object);
        } else {
          state.tag = type2.tag;
        }
      } else {
        state.tag = "?";
      }
      if (type2.represent) {
        style = state.styleMap[type2.tag] || type2.defaultStyle;
        if (_toString.call(type2.represent) === "[object Function]") {
          _result = type2.represent(object, style);
        } else if (_hasOwnProperty.call(type2.represent, style)) {
          _result = type2.represent[style](object, style);
        } else {
          throw new exception("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
        }
        state.dump = _result;
      }
      return true;
    }
  }
  return false;
}
function writeNode(state, level, object, block, compact, iskey, isblockseq) {
  state.tag = null;
  state.dump = object;
  if (!detectType(state, object, false)) {
    detectType(state, object, true);
  }
  var type2 = _toString.call(state.dump);
  var inblock = block;
  var tagStr;
  if (block) {
    block = state.flowLevel < 0 || state.flowLevel > level;
  }
  var objectOrArray = type2 === "[object Object]" || type2 === "[object Array]", duplicateIndex, duplicate;
  if (objectOrArray) {
    duplicateIndex = state.duplicates.indexOf(object);
    duplicate = duplicateIndex !== -1;
  }
  if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
    compact = false;
  }
  if (duplicate && state.usedDuplicates[duplicateIndex]) {
    state.dump = "*ref_" + duplicateIndex;
  } else {
    if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
      state.usedDuplicates[duplicateIndex] = true;
    }
    if (type2 === "[object Object]") {
      if (block && Object.keys(state.dump).length !== 0) {
        writeBlockMapping(state, level, state.dump, compact);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowMapping(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object Array]") {
      if (block && state.dump.length !== 0) {
        if (state.noArrayIndent && !isblockseq && level > 0) {
          writeBlockSequence(state, level - 1, state.dump, compact);
        } else {
          writeBlockSequence(state, level, state.dump, compact);
        }
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowSequence(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object String]") {
      if (state.tag !== "?") {
        writeScalar(state, state.dump, level, iskey, inblock);
      }
    } else if (type2 === "[object Undefined]") {
      return false;
    } else {
      if (state.skipInvalid)
        return false;
      throw new exception("unacceptable kind of an object to dump " + type2);
    }
    if (state.tag !== null && state.tag !== "?") {
      tagStr = encodeURI(state.tag[0] === "!" ? state.tag.slice(1) : state.tag).replace(/!/g, "%21");
      if (state.tag[0] === "!") {
        tagStr = "!" + tagStr;
      } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
        tagStr = "!!" + tagStr.slice(18);
      } else {
        tagStr = "!<" + tagStr + ">";
      }
      state.dump = tagStr + " " + state.dump;
    }
  }
  return true;
}
function getDuplicateReferences(object, state) {
  var objects = [], duplicatesIndexes = [], index, length;
  inspectNode(object, objects, duplicatesIndexes);
  for (index = 0, length = duplicatesIndexes.length;index < length; index += 1) {
    state.duplicates.push(objects[duplicatesIndexes[index]]);
  }
  state.usedDuplicates = new Array(length);
}
function inspectNode(object, objects, duplicatesIndexes) {
  var objectKeyList, index, length;
  if (object !== null && typeof object === "object") {
    index = objects.indexOf(object);
    if (index !== -1) {
      if (duplicatesIndexes.indexOf(index) === -1) {
        duplicatesIndexes.push(index);
      }
    } else {
      objects.push(object);
      if (Array.isArray(object)) {
        for (index = 0, length = object.length;index < length; index += 1) {
          inspectNode(object[index], objects, duplicatesIndexes);
        }
      } else {
        objectKeyList = Object.keys(object);
        for (index = 0, length = objectKeyList.length;index < length; index += 1) {
          inspectNode(object[objectKeyList[index]], objects, duplicatesIndexes);
        }
      }
    }
  }
}
function dump$1(input, options3) {
  options3 = options3 || {};
  var state = new State(options3);
  if (!state.noRefs)
    getDuplicateReferences(input, state);
  var value = input;
  if (state.replacer) {
    value = state.replacer.call({ "": value }, "", value);
  }
  if (writeNode(state, 0, value, true, true))
    return state.dump + "\n";
  return "";
}
function renamed(from, to) {
  return function() {
    throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
  };
}
var isNothing_1;
var isObject_1;
var toArray_1;
var repeat_1;
var isNegativeZero_1;
var extend_1;
var common;
var exception;
var snippet;
var TYPE_CONSTRUCTOR_OPTIONS;
var YAML_NODE_KINDS;
var type;
var schema4;
var str;
var seq;
var map;
var failsafe;
var _null;
var bool;
var int;
var YAML_FLOAT_PATTERN;
var SCIENTIFIC_WITHOUT_DOT;
var float;
var json;
var core;
var YAML_DATE_REGEXP;
var YAML_TIMESTAMP_REGEXP;
var timestamp;
var merge;
var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
var binary2;
var _hasOwnProperty$3;
var _toString$2;
var omap;
var _toString$1;
var pairs;
var _hasOwnProperty$2;
var set;
var _default;
var _hasOwnProperty$1;
var CONTEXT_FLOW_IN = 1;
var CONTEXT_FLOW_OUT = 2;
var CONTEXT_BLOCK_IN = 3;
var CONTEXT_BLOCK_OUT = 4;
var CHOMPING_CLIP = 1;
var CHOMPING_STRIP = 2;
var CHOMPING_KEEP = 3;
var PATTERN_NON_PRINTABLE;
var PATTERN_NON_ASCII_LINE_BREAKS;
var PATTERN_FLOW_INDICATORS;
var PATTERN_TAG_HANDLE;
var PATTERN_TAG_URI;
var simpleEscapeCheck;
var simpleEscapeMap;
var i;
var directiveHandlers;
var loadAll_1;
var load_1;
var loader;
var _toString;
var _hasOwnProperty;
var CHAR_BOM = 65279;
var CHAR_TAB = 9;
var CHAR_LINE_FEED = 10;
var CHAR_CARRIAGE_RETURN = 13;
var CHAR_SPACE = 32;
var CHAR_EXCLAMATION = 33;
var CHAR_DOUBLE_QUOTE = 34;
var CHAR_SHARP = 35;
var CHAR_PERCENT = 37;
var CHAR_AMPERSAND = 38;
var CHAR_SINGLE_QUOTE = 39;
var CHAR_ASTERISK2 = 42;
var CHAR_COMMA2 = 44;
var CHAR_MINUS = 45;
var CHAR_COLON = 58;
var CHAR_EQUALS = 61;
var CHAR_GREATER_THAN = 62;
var CHAR_QUESTION = 63;
var CHAR_COMMERCIAL_AT = 64;
var CHAR_LEFT_SQUARE_BRACKET2 = 91;
var CHAR_RIGHT_SQUARE_BRACKET2 = 93;
var CHAR_GRAVE_ACCENT = 96;
var CHAR_LEFT_CURLY_BRACKET = 123;
var CHAR_VERTICAL_LINE = 124;
var CHAR_RIGHT_CURLY_BRACKET = 125;
var ESCAPE_SEQUENCES;
var DEPRECATED_BOOLEANS_SYNTAX;
var DEPRECATED_BASE60_SYNTAX;
var QUOTING_TYPE_SINGLE = 1;
var QUOTING_TYPE_DOUBLE = 2;
var STYLE_PLAIN = 1;
var STYLE_SINGLE = 2;
var STYLE_LITERAL = 3;
var STYLE_FOLDED = 4;
var STYLE_DOUBLE = 5;
var dump_1;
var dumper;
var load2;
var loadAll;
var dump;
var safeLoad;
var safeLoadAll;
var safeDump;
var init_js_yaml = __esm2(() => {
  /*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT */
  isNothing_1 = isNothing;
  isObject_1 = isObject5;
  toArray_1 = toArray;
  repeat_1 = repeat;
  isNegativeZero_1 = isNegativeZero;
  extend_1 = extend2;
  common = {
    isNothing: isNothing_1,
    isObject: isObject_1,
    toArray: toArray_1,
    repeat: repeat_1,
    isNegativeZero: isNegativeZero_1,
    extend: extend_1
  };
  YAMLException$1.prototype = Object.create(Error.prototype);
  YAMLException$1.prototype.constructor = YAMLException$1;
  YAMLException$1.prototype.toString = function toString4(compact) {
    return this.name + ": " + formatError(this, compact);
  };
  exception = YAMLException$1;
  snippet = makeSnippet;
  TYPE_CONSTRUCTOR_OPTIONS = [
    "kind",
    "multi",
    "resolve",
    "construct",
    "instanceOf",
    "predicate",
    "represent",
    "representName",
    "defaultStyle",
    "styleAliases"
  ];
  YAML_NODE_KINDS = [
    "scalar",
    "sequence",
    "mapping"
  ];
  type = Type$1;
  Schema$1.prototype.extend = function extend3(definition) {
    var implicit = [];
    var explicit = [];
    if (definition instanceof type) {
      explicit.push(definition);
    } else if (Array.isArray(definition)) {
      explicit = explicit.concat(definition);
    } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
      if (definition.implicit)
        implicit = implicit.concat(definition.implicit);
      if (definition.explicit)
        explicit = explicit.concat(definition.explicit);
    } else {
      throw new exception("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
    }
    implicit.forEach(function(type$1) {
      if (!(type$1 instanceof type)) {
        throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
      }
      if (type$1.loadKind && type$1.loadKind !== "scalar") {
        throw new exception("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
      }
      if (type$1.multi) {
        throw new exception("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
      }
    });
    explicit.forEach(function(type$1) {
      if (!(type$1 instanceof type)) {
        throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
      }
    });
    var result2 = Object.create(Schema$1.prototype);
    result2.implicit = (this.implicit || []).concat(implicit);
    result2.explicit = (this.explicit || []).concat(explicit);
    result2.compiledImplicit = compileList(result2, "implicit");
    result2.compiledExplicit = compileList(result2, "explicit");
    result2.compiledTypeMap = compileMap(result2.compiledImplicit, result2.compiledExplicit);
    return result2;
  };
  schema4 = Schema$1;
  str = new type("tag:yaml.org,2002:str", {
    kind: "scalar",
    construct: function(data2) {
      return data2 !== null ? data2 : "";
    }
  });
  seq = new type("tag:yaml.org,2002:seq", {
    kind: "sequence",
    construct: function(data2) {
      return data2 !== null ? data2 : [];
    }
  });
  map = new type("tag:yaml.org,2002:map", {
    kind: "mapping",
    construct: function(data2) {
      return data2 !== null ? data2 : {};
    }
  });
  failsafe = new schema4({
    explicit: [
      str,
      seq,
      map
    ]
  });
  _null = new type("tag:yaml.org,2002:null", {
    kind: "scalar",
    resolve: resolveYamlNull,
    construct: constructYamlNull,
    predicate: isNull2,
    represent: {
      canonical: function() {
        return "~";
      },
      lowercase: function() {
        return "null";
      },
      uppercase: function() {
        return "NULL";
      },
      camelcase: function() {
        return "Null";
      },
      empty: function() {
        return "";
      }
    },
    defaultStyle: "lowercase"
  });
  bool = new type("tag:yaml.org,2002:bool", {
    kind: "scalar",
    resolve: resolveYamlBoolean,
    construct: constructYamlBoolean,
    predicate: isBoolean2,
    represent: {
      lowercase: function(object) {
        return object ? "true" : "false";
      },
      uppercase: function(object) {
        return object ? "TRUE" : "FALSE";
      },
      camelcase: function(object) {
        return object ? "True" : "False";
      }
    },
    defaultStyle: "lowercase"
  });
  int = new type("tag:yaml.org,2002:int", {
    kind: "scalar",
    resolve: resolveYamlInteger,
    construct: constructYamlInteger,
    predicate: isInteger2,
    represent: {
      binary: function(obj) {
        return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
      },
      octal: function(obj) {
        return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
      },
      decimal: function(obj) {
        return obj.toString(10);
      },
      hexadecimal: function(obj) {
        return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
      }
    },
    defaultStyle: "decimal",
    styleAliases: {
      binary: [2, "bin"],
      octal: [8, "oct"],
      decimal: [10, "dec"],
      hexadecimal: [16, "hex"]
    }
  });
  YAML_FLOAT_PATTERN = new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");
  SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
  float = new type("tag:yaml.org,2002:float", {
    kind: "scalar",
    resolve: resolveYamlFloat,
    construct: constructYamlFloat,
    predicate: isFloat,
    represent: representYamlFloat,
    defaultStyle: "lowercase"
  });
  json = failsafe.extend({
    implicit: [
      _null,
      bool,
      int,
      float
    ]
  });
  core = json;
  YAML_DATE_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$");
  YAML_TIMESTAMP_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$");
  timestamp = new type("tag:yaml.org,2002:timestamp", {
    kind: "scalar",
    resolve: resolveYamlTimestamp,
    construct: constructYamlTimestamp,
    instanceOf: Date,
    represent: representYamlTimestamp
  });
  merge = new type("tag:yaml.org,2002:merge", {
    kind: "scalar",
    resolve: resolveYamlMerge
  });
  binary2 = new type("tag:yaml.org,2002:binary", {
    kind: "scalar",
    resolve: resolveYamlBinary,
    construct: constructYamlBinary,
    predicate: isBinary,
    represent: representYamlBinary
  });
  _hasOwnProperty$3 = Object.prototype.hasOwnProperty;
  _toString$2 = Object.prototype.toString;
  omap = new type("tag:yaml.org,2002:omap", {
    kind: "sequence",
    resolve: resolveYamlOmap,
    construct: constructYamlOmap
  });
  _toString$1 = Object.prototype.toString;
  pairs = new type("tag:yaml.org,2002:pairs", {
    kind: "sequence",
    resolve: resolveYamlPairs,
    construct: constructYamlPairs
  });
  _hasOwnProperty$2 = Object.prototype.hasOwnProperty;
  set = new type("tag:yaml.org,2002:set", {
    kind: "mapping",
    resolve: resolveYamlSet,
    construct: constructYamlSet
  });
  _default = core.extend({
    implicit: [
      timestamp,
      merge
    ],
    explicit: [
      binary2,
      omap,
      pairs,
      set
    ]
  });
  _hasOwnProperty$1 = Object.prototype.hasOwnProperty;
  PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
  PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
  PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
  PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
  PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
  simpleEscapeCheck = new Array(256);
  simpleEscapeMap = new Array(256);
  for (i = 0;i < 256; i++) {
    simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0;
    simpleEscapeMap[i] = simpleEscapeSequence(i);
  }
  directiveHandlers = {
    YAML: function handleYamlDirective(state, name, args) {
      var match, major, minor;
      if (state.version !== null) {
        throwError(state, "duplication of %YAML directive");
      }
      if (args.length !== 1) {
        throwError(state, "YAML directive accepts exactly one argument");
      }
      match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
      if (match === null) {
        throwError(state, "ill-formed argument of the YAML directive");
      }
      major = parseInt(match[1], 10);
      minor = parseInt(match[2], 10);
      if (major !== 1) {
        throwError(state, "unacceptable YAML version of the document");
      }
      state.version = args[0];
      state.checkLineBreaks = minor < 2;
      if (minor !== 1 && minor !== 2) {
        throwWarning(state, "unsupported YAML version of the document");
      }
    },
    TAG: function handleTagDirective(state, name, args) {
      var handle, prefix;
      if (args.length !== 2) {
        throwError(state, "TAG directive accepts exactly two arguments");
      }
      handle = args[0];
      prefix = args[1];
      if (!PATTERN_TAG_HANDLE.test(handle)) {
        throwError(state, "ill-formed tag handle (first argument) of the TAG directive");
      }
      if (_hasOwnProperty$1.call(state.tagMap, handle)) {
        throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
      }
      if (!PATTERN_TAG_URI.test(prefix)) {
        throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
      }
      try {
        prefix = decodeURIComponent(prefix);
      } catch (err22) {
        throwError(state, "tag prefix is malformed: " + prefix);
      }
      state.tagMap[handle] = prefix;
    }
  };
  loadAll_1 = loadAll$1;
  load_1 = load$1;
  loader = {
    loadAll: loadAll_1,
    load: load_1
  };
  _toString = Object.prototype.toString;
  _hasOwnProperty = Object.prototype.hasOwnProperty;
  ESCAPE_SEQUENCES = {};
  ESCAPE_SEQUENCES[0] = "\\0";
  ESCAPE_SEQUENCES[7] = "\\a";
  ESCAPE_SEQUENCES[8] = "\\b";
  ESCAPE_SEQUENCES[9] = "\\t";
  ESCAPE_SEQUENCES[10] = "\\n";
  ESCAPE_SEQUENCES[11] = "\\v";
  ESCAPE_SEQUENCES[12] = "\\f";
  ESCAPE_SEQUENCES[13] = "\\r";
  ESCAPE_SEQUENCES[27] = "\\e";
  ESCAPE_SEQUENCES[34] = '\\"';
  ESCAPE_SEQUENCES[92] = "\\\\";
  ESCAPE_SEQUENCES[133] = "\\N";
  ESCAPE_SEQUENCES[160] = "\\_";
  ESCAPE_SEQUENCES[8232] = "\\L";
  ESCAPE_SEQUENCES[8233] = "\\P";
  DEPRECATED_BOOLEANS_SYNTAX = [
    "y",
    "Y",
    "yes",
    "Yes",
    "YES",
    "on",
    "On",
    "ON",
    "n",
    "N",
    "no",
    "No",
    "NO",
    "off",
    "Off",
    "OFF"
  ];
  DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
  dump_1 = dump$1;
  dumper = {
    dump: dump_1
  };
  load2 = loader.load;
  loadAll = loader.loadAll;
  dump = dumper.dump;
  safeLoad = renamed("safeLoad", "load");
  safeLoadAll = renamed("safeLoadAll", "loadAll");
  safeDump = renamed("safeDump", "dump");
});
var init_helpers6 = __esm2(() => {
  init_src19();
  init_src10();
  init_src6();
  init_src12();
  init_src7();
  init_src11();
  init_src23();
  init_dist5();
  init_js_yaml();
});
var require_build = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.Macroable = undefined;

  class Macroable22 {
    constructor() {
      if (!this.constructor["macros"] || !this.constructor["getters"]) {
        throw new Error('Set static properties "macros = {}" and "getters = {}" on the class for the macroable to work.');
      }
    }
    static macro(name, callback) {
      const self2 = this;
      self2.macros[name] = callback;
      this.prototype[name] = callback;
    }
    static getMacro(name) {
      return this.macros[name];
    }
    static hasMacro(name) {
      return !!this.getMacro(name);
    }
    static getter(name, callback, singleton = false) {
      const wrappedCallback = singleton ? function wrappedCallback() {
        const value = callback.bind(this)();
        Object.defineProperty(this, name, { value, configurable: true });
        return value;
      } : callback;
      const self2 = this;
      self2.getters[name] = wrappedCallback;
      Object.defineProperty(this.prototype, name, {
        get: wrappedCallback,
        configurable: true,
        enumerable: true
      });
    }
    static getGetter(name) {
      return this.getters[name];
    }
    static hasGetter(name) {
      return !!this.getGetter(name);
    }
    static hydrate() {
      Object.keys(this.macros).forEach((key2) => Reflect.deleteProperty(this.prototype, key2));
      Object.keys(this.getters).forEach((key2) => Reflect.deleteProperty(this.prototype, key2));
      this.macros = {};
      this.getters = {};
    }
  }
  exports.Macroable = Macroable22;
});
var import_macroable4;
var init_macroable = __esm2(() => {
  import_macroable4 = __toESM3(require_build(), 1);
});
var init_package2 = () => {
};
var init_versions = __esm2(() => {
  init_package2();
});
var init_base = __esm2(() => {
  init_src();
});
var init_debounce = () => {
};
var init_math = () => {
};
var init_regex = () => {
};
var init_pretty_bytes = () => {
};
var init_vendors = __esm2(() => {
  init_pretty_bytes();
});
var init_utils11 = __esm2(() => {
  init_base();
  init_debounce();
  init_math();
  init_regex();
  init_vendors();
});
var init_src20 = __esm2(() => {
  init_utils11();
});
var init_src21 = __esm2(() => {
  init_clean();
  init_config2();
  init_equal();
  init_export_size();
  init_find();
  init_git2();
  init_hash();
  init_helpers6();
  init_macroable();
  init_versions();
  init_src20();
});
var init_helpers7 = __esm2(() => {
  init_src21();
});
var init_arr = __esm2(() => {
  init_helpers7();
});
var init_macro2 = __esm2(() => {
  init_helpers7();
});
var init_src22 = __esm2(() => {
  init_arr();
  init_arr();
  init_macro2();
});
async function exists(path42) {
  return await import_fs_extra.pathExists(path42);
}
var fs2;
var import_fs_extra;
var init_fs = __esm2(() => {
  fs2 = __toESM3(require_lib2(), 1);
  import_fs_extra = __toESM3(require_lib2(), 1);
});
function copy(src22, dest, exclude = []) {
  if (Array.isArray(src22)) {
    src22.forEach((file) => {
      copy(file, dest, exclude);
    });
  } else {
    if (fs2.statSync(src22).isDirectory())
      copyFolder(src22, dest, exclude);
    else
      copyFile(src22, dest);
  }
}
function copyFile(src22, dest) {
  fs2.copyFileSync(src22, dest);
}
function copyFolder(src22, dest, exclude = []) {
  if (!fs2.existsSync(dest))
    fs2.mkdirSync(dest, { recursive: true });
  if (fs2.existsSync(src22)) {
    fs2.readdirSync(src22).forEach((file) => {
      if (!contains(join2(src22, file), exclude)) {
        const srcPath = join2(src22, file);
        const destPath = join2(dest, file);
        if (fs2.statSync(srcPath).isDirectory())
          copyFolder(srcPath, destPath, exclude);
        else
          fs2.copyFileSync(srcPath, destPath);
      }
    });
  }
}
var init_copy = __esm2(() => {
  init_src22();
  init_src11();
  init_fs();
});
function isFolder(path42) {
  try {
    return fs2.statSync(path42).isDirectory();
  } catch {
    return false;
  }
}
function isDir(path42) {
  return isFolder(path42);
}
function doesFolderExist(path42) {
  return fs2.existsSync(path42);
}
function createFolder(dir) {
  return new Promise((resolve5, reject) => {
    fs2.mkdirs(dir, (err22) => {
      if (err22)
        reject(err22);
      else
        resolve5();
    });
  });
}
function getFolders(dir) {
  return fs2.readdirSync(dir).filter((file) => {
    return fs2.statSync(join2(dir, file)).isDirectory();
  });
}
var folders;
var init_folders = __esm2(() => {
  init_src11();
  init_fs();
  folders = {
    isFolder,
    doesFolderExist,
    createFolder,
    getFolders
  };
});
var require_utils7 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.normalizePath = exports.convertSlashes = exports.cleanPath = undefined;
  var path_1 = import.meta.require("path");
  function cleanPath(path42) {
    let normalized = (0, path_1.normalize)(path42);
    if (normalized.length > 1 && normalized[normalized.length - 1] === path_1.sep)
      normalized = normalized.substring(0, normalized.length - 1);
    return normalized;
  }
  exports.cleanPath = cleanPath;
  var SLASHES_REGEX = /[\\/]/g;
  function convertSlashes(path42, separator) {
    return path42.replace(SLASHES_REGEX, separator);
  }
  exports.convertSlashes = convertSlashes;
  function normalizePath(path42, options3) {
    const { resolvePaths, normalizePath: normalizePath2, pathSeparator } = options3;
    const pathNeedsCleaning = process.platform === "win32" && path42.includes("/") || path42.startsWith(".");
    if (resolvePaths)
      path42 = (0, path_1.resolve)(path42);
    if (normalizePath2 || pathNeedsCleaning)
      path42 = cleanPath(path42);
    if (path42 === ".")
      return "";
    const needsSeperator = path42[path42.length - 1] !== pathSeparator;
    return convertSlashes(needsSeperator ? path42 + pathSeparator : path42, pathSeparator);
  }
  exports.normalizePath = normalizePath;
});
var require_join_path = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = exports.joinDirectoryPath = exports.joinPathWithBasePath = undefined;
  var path_1 = import.meta.require("path");
  var utils_1 = require_utils7();
  function joinPathWithBasePath(filename2, directoryPath) {
    return directoryPath + filename2;
  }
  exports.joinPathWithBasePath = joinPathWithBasePath;
  function joinPathWithRelativePath(root, options3) {
    return function(filename2, directoryPath) {
      const sameRoot = directoryPath.startsWith(root);
      if (sameRoot)
        return directoryPath.replace(root, "") + filename2;
      else
        return (0, utils_1.convertSlashes)((0, path_1.relative)(root, directoryPath), options3.pathSeparator) + options3.pathSeparator + filename2;
    };
  }
  function joinPath(filename2) {
    return filename2;
  }
  function joinDirectoryPath(filename2, directoryPath, separator) {
    return directoryPath + filename2 + separator;
  }
  exports.joinDirectoryPath = joinDirectoryPath;
  function build3(root, options3) {
    const { relativePaths, includeBasePath } = options3;
    return relativePaths && root ? joinPathWithRelativePath(root, options3) : includeBasePath ? joinPathWithBasePath : joinPath;
  }
  exports.build = build3;
});
var require_push_directory = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = undefined;
  function pushDirectoryWithRelativePath(root) {
    return function(directoryPath, paths) {
      paths.push(directoryPath.substring(root.length) || ".");
    };
  }
  function pushDirectoryFilterWithRelativePath(root) {
    return function(directoryPath, paths, filters) {
      const relativePath = directoryPath.substring(root.length) || ".";
      if (filters.every((filter) => filter(relativePath, true))) {
        paths.push(relativePath);
      }
    };
  }
  var pushDirectory = (directoryPath, paths) => {
    paths.push(directoryPath || ".");
  };
  var pushDirectoryFilter = (directoryPath, paths, filters) => {
    const path42 = directoryPath || ".";
    if (filters.every((filter) => filter(path42, true))) {
      paths.push(path42);
    }
  };
  var empty2 = () => {
  };
  function build3(root, options3) {
    const { includeDirs, filters, relativePaths } = options3;
    if (!includeDirs)
      return empty2;
    if (relativePaths)
      return filters && filters.length ? pushDirectoryFilterWithRelativePath(root) : pushDirectoryWithRelativePath(root);
    return filters && filters.length ? pushDirectoryFilter : pushDirectory;
  }
  exports.build = build3;
});
var require_push_file = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = undefined;
  var pushFileFilterAndCount = (filename2, _paths, counts, filters) => {
    if (filters.every((filter) => filter(filename2, false)))
      counts.files++;
  };
  var pushFileFilter = (filename2, paths, _counts, filters) => {
    if (filters.every((filter) => filter(filename2, false)))
      paths.push(filename2);
  };
  var pushFileCount = (_filename, _paths, counts, _filters) => {
    counts.files++;
  };
  var pushFile = (filename2, paths) => {
    paths.push(filename2);
  };
  var empty2 = () => {
  };
  function build3(options3) {
    const { excludeFiles, filters, onlyCounts } = options3;
    if (excludeFiles)
      return empty2;
    if (filters && filters.length) {
      return onlyCounts ? pushFileFilterAndCount : pushFileFilter;
    } else if (onlyCounts) {
      return pushFileCount;
    } else {
      return pushFile;
    }
  }
  exports.build = build3;
});
var require_get_array = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = undefined;
  var getArray = (paths) => {
    return paths;
  };
  var getArrayGroup = () => {
    return [""].slice(0, 0);
  };
  function build3(options3) {
    return options3.group ? getArrayGroup : getArray;
  }
  exports.build = build3;
});
var require_group_files = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = undefined;
  var groupFiles = (groups, directory, files) => {
    groups.push({ directory, files, dir: directory });
  };
  var empty2 = () => {
  };
  function build3(options3) {
    return options3.group ? groupFiles : empty2;
  }
  exports.build = build3;
});
var require_resolve_symlink = __commonJS2((exports) => {
  var __importDefault = exports && exports.__importDefault || function(mod) {
    return mod && mod.__esModule ? mod : { default: mod };
  };
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = undefined;
  var fs_1 = __importDefault(import.meta.require("fs"));
  var path_1 = import.meta.require("path");
  var resolveSymlinksAsync = function(path42, state, callback) {
    const { queue: queue4, options: { suppressErrors } } = state;
    queue4.enqueue();
    fs_1.default.realpath(path42, (error, resolvedPath2) => {
      if (error)
        return queue4.dequeue(suppressErrors ? null : error, state);
      fs_1.default.stat(resolvedPath2, (error2, stat22) => {
        if (error2)
          return queue4.dequeue(suppressErrors ? null : error2, state);
        if (stat22.isDirectory() && isRecursive(path42, resolvedPath2, state))
          return queue4.dequeue(null, state);
        callback(stat22, resolvedPath2);
        queue4.dequeue(null, state);
      });
    });
  };
  var resolveSymlinks = function(path42, state, callback) {
    const { queue: queue4, options: { suppressErrors } } = state;
    queue4.enqueue();
    try {
      const resolvedPath2 = fs_1.default.realpathSync(path42);
      const stat22 = fs_1.default.statSync(resolvedPath2);
      if (stat22.isDirectory() && isRecursive(path42, resolvedPath2, state))
        return;
      callback(stat22, resolvedPath2);
    } catch (e) {
      if (!suppressErrors)
        throw e;
    }
  };
  function build3(options3, isSynchronous) {
    if (!options3.resolveSymlinks || options3.excludeSymlinks)
      return null;
    return isSynchronous ? resolveSymlinks : resolveSymlinksAsync;
  }
  exports.build = build3;
  function isRecursive(path42, resolved, state) {
    if (state.options.useRealPaths)
      return isRecursiveUsingRealPaths(resolved, state);
    let parent = (0, path_1.dirname)(path42);
    let depth2 = 1;
    while (parent !== state.root && depth2 < 2) {
      const resolvedPath2 = state.symlinks.get(parent);
      const isSameRoot = !!resolvedPath2 && (resolvedPath2 === resolved || resolvedPath2.startsWith(resolved) || resolved.startsWith(resolvedPath2));
      if (isSameRoot)
        depth2++;
      else
        parent = (0, path_1.dirname)(parent);
    }
    state.symlinks.set(path42, resolved);
    return depth2 > 1;
  }
  function isRecursiveUsingRealPaths(resolved, state) {
    return state.visited.includes(resolved + state.options.pathSeparator);
  }
});
var require_invoke_callback = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = undefined;
  var onlyCountsSync = (state) => {
    return state.counts;
  };
  var groupsSync = (state) => {
    return state.groups;
  };
  var defaultSync = (state) => {
    return state.paths;
  };
  var limitFilesSync = (state) => {
    return state.paths.slice(0, state.options.maxFiles);
  };
  var onlyCountsAsync = (state, error, callback) => {
    report(error, callback, state.counts, state.options.suppressErrors);
    return null;
  };
  var defaultAsync = (state, error, callback) => {
    report(error, callback, state.paths, state.options.suppressErrors);
    return null;
  };
  var limitFilesAsync = (state, error, callback) => {
    report(error, callback, state.paths.slice(0, state.options.maxFiles), state.options.suppressErrors);
    return null;
  };
  var groupsAsync = (state, error, callback) => {
    report(error, callback, state.groups, state.options.suppressErrors);
    return null;
  };
  function report(error, callback, output, suppressErrors) {
    if (error && !suppressErrors)
      callback(error, output);
    else
      callback(null, output);
  }
  function build3(options3, isSynchronous) {
    const { onlyCounts, group: group22, maxFiles } = options3;
    if (onlyCounts)
      return isSynchronous ? onlyCountsSync : onlyCountsAsync;
    else if (group22)
      return isSynchronous ? groupsSync : groupsAsync;
    else if (maxFiles)
      return isSynchronous ? limitFilesSync : limitFilesAsync;
    else
      return isSynchronous ? defaultSync : defaultAsync;
  }
  exports.build = build3;
});
var require_walk_directory = __commonJS2((exports) => {
  var __importDefault = exports && exports.__importDefault || function(mod) {
    return mod && mod.__esModule ? mod : { default: mod };
  };
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.build = undefined;
  var fs_1 = __importDefault(import.meta.require("fs"));
  var readdirOpts = { withFileTypes: true };
  var walkAsync = (state, crawlPath, directoryPath, currentDepth, callback) => {
    if (currentDepth < 0)
      return state.queue.dequeue(null, state);
    state.visited.push(crawlPath);
    state.counts.directories++;
    state.queue.enqueue();
    fs_1.default.readdir(crawlPath || ".", readdirOpts, (error, entries = []) => {
      callback(entries, directoryPath, currentDepth);
      state.queue.dequeue(state.options.suppressErrors ? null : error, state);
    });
  };
  var walkSync = (state, crawlPath, directoryPath, currentDepth, callback) => {
    if (currentDepth < 0)
      return;
    state.visited.push(crawlPath);
    state.counts.directories++;
    let entries = [];
    try {
      entries = fs_1.default.readdirSync(crawlPath || ".", readdirOpts);
    } catch (e) {
      if (!state.options.suppressErrors)
        throw e;
    }
    callback(entries, directoryPath, currentDepth);
  };
  function build3(isSynchronous) {
    return isSynchronous ? walkSync : walkAsync;
  }
  exports.build = build3;
});
var require_queue = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.Queue = undefined;

  class Queue {
    onQueueEmpty;
    count = 0;
    constructor(onQueueEmpty) {
      this.onQueueEmpty = onQueueEmpty;
    }
    enqueue() {
      this.count++;
    }
    dequeue(error, output) {
      if (--this.count <= 0 || error)
        this.onQueueEmpty(error, output);
    }
  }
  exports.Queue = Queue;
});
var require_counter = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.Counter = undefined;

  class Counter {
    _files = 0;
    _directories = 0;
    set files(num) {
      this._files = num;
    }
    get files() {
      return this._files;
    }
    set directories(num) {
      this._directories = num;
    }
    get directories() {
      return this._directories;
    }
    get dirs() {
      return this._directories;
    }
  }
  exports.Counter = Counter;
});
var require_walker = __commonJS2((exports) => {
  var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m22, k, k2) {
    if (k2 === undefined)
      k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m22, k);
    if (!desc || ("get" in desc ? !m22.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() {
        return m22[k];
      } };
    }
    Object.defineProperty(o, k2, desc);
  } : function(o, m22, k, k2) {
    if (k2 === undefined)
      k2 = k;
    o[k2] = m22[k];
  });
  var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v22) {
    Object.defineProperty(o, "default", { enumerable: true, value: v22 });
  } : function(o, v22) {
    o["default"] = v22;
  });
  var __importStar = exports && exports.__importStar || function(mod) {
    if (mod && mod.__esModule)
      return mod;
    var result2 = {};
    if (mod != null) {
      for (var k in mod)
        if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
          __createBinding(result2, mod, k);
    }
    __setModuleDefault(result2, mod);
    return result2;
  };
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.Walker = undefined;
  var path_1 = import.meta.require("path");
  var utils_1 = require_utils7();
  var joinPath = __importStar(require_join_path());
  var pushDirectory = __importStar(require_push_directory());
  var pushFile = __importStar(require_push_file());
  var getArray = __importStar(require_get_array());
  var groupFiles = __importStar(require_group_files());
  var resolveSymlink = __importStar(require_resolve_symlink());
  var invokeCallback = __importStar(require_invoke_callback());
  var walkDirectory = __importStar(require_walk_directory());
  var queue_1 = require_queue();
  var counter_1 = require_counter();

  class Walker {
    root;
    isSynchronous;
    state;
    joinPath;
    pushDirectory;
    pushFile;
    getArray;
    groupFiles;
    resolveSymlink;
    walkDirectory;
    callbackInvoker;
    constructor(root, options3, callback) {
      this.isSynchronous = !callback;
      this.callbackInvoker = invokeCallback.build(options3, this.isSynchronous);
      this.root = (0, utils_1.normalizePath)(root, options3);
      this.state = {
        root: this.root.slice(0, -1),
        paths: [""].slice(0, 0),
        groups: [],
        counts: new counter_1.Counter,
        options: options3,
        queue: new queue_1.Queue((error, state) => this.callbackInvoker(state, error, callback)),
        symlinks: new Map,
        visited: [""].slice(0, 0)
      };
      this.joinPath = joinPath.build(this.root, options3);
      this.pushDirectory = pushDirectory.build(this.root, options3);
      this.pushFile = pushFile.build(options3);
      this.getArray = getArray.build(options3);
      this.groupFiles = groupFiles.build(options3);
      this.resolveSymlink = resolveSymlink.build(options3, this.isSynchronous);
      this.walkDirectory = walkDirectory.build(this.isSynchronous);
    }
    start() {
      this.walkDirectory(this.state, this.root, this.root, this.state.options.maxDepth, this.walk);
      return this.isSynchronous ? this.callbackInvoker(this.state, null) : null;
    }
    walk = (entries, directoryPath, depth2) => {
      const { paths, options: { filters, resolveSymlinks, excludeSymlinks, exclude, maxFiles, signal, useRealPaths, pathSeparator } } = this.state;
      if (signal && signal.aborted || maxFiles && paths.length > maxFiles)
        return;
      this.pushDirectory(directoryPath, paths, filters);
      const files = this.getArray(this.state.paths);
      for (let i2 = 0;i2 < entries.length; ++i2) {
        const entry = entries[i2];
        if (entry.isFile() || entry.isSymbolicLink() && !resolveSymlinks && !excludeSymlinks) {
          const filename2 = this.joinPath(entry.name, directoryPath);
          this.pushFile(filename2, files, this.state.counts, filters);
        } else if (entry.isDirectory()) {
          let path42 = joinPath.joinDirectoryPath(entry.name, directoryPath, this.state.options.pathSeparator);
          if (exclude && exclude(entry.name, path42))
            continue;
          this.walkDirectory(this.state, path42, path42, depth2 - 1, this.walk);
        } else if (entry.isSymbolicLink() && this.resolveSymlink) {
          let path42 = joinPath.joinPathWithBasePath(entry.name, directoryPath);
          this.resolveSymlink(path42, this.state, (stat22, resolvedPath2) => {
            if (stat22.isDirectory()) {
              resolvedPath2 = (0, utils_1.normalizePath)(resolvedPath2, this.state.options);
              if (exclude && exclude(entry.name, resolvedPath2))
                return;
              this.walkDirectory(this.state, resolvedPath2, useRealPaths ? resolvedPath2 : path42 + pathSeparator, depth2 - 1, this.walk);
            } else {
              resolvedPath2 = useRealPaths ? resolvedPath2 : path42;
              const filename2 = (0, path_1.basename)(resolvedPath2);
              const directoryPath2 = (0, utils_1.normalizePath)((0, path_1.dirname)(resolvedPath2), this.state.options);
              resolvedPath2 = this.joinPath(filename2, directoryPath2);
              this.pushFile(resolvedPath2, files, this.state.counts, filters);
            }
          });
        }
      }
      this.groupFiles(this.state.groups, directoryPath, files);
    };
  }
  exports.Walker = Walker;
});
var require_async2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.callback = exports.promise = undefined;
  var walker_1 = require_walker();
  function promise3(root, options3) {
    return new Promise((resolve5, reject) => {
      callback(root, options3, (err22, output) => {
        if (err22)
          return reject(err22);
        resolve5(output);
      });
    });
  }
  exports.promise = promise3;
  function callback(root, options3, callback2) {
    let walker = new walker_1.Walker(root, options3, callback2);
    walker.start();
  }
  exports.callback = callback;
});
var require_sync2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.sync = undefined;
  var walker_1 = require_walker();
  function sync(root, options3) {
    const walker = new walker_1.Walker(root, options3);
    return walker.start();
  }
  exports.sync = sync;
});
var require_api_builder = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.APIBuilder = undefined;
  var async_1 = require_async2();
  var sync_1 = require_sync2();

  class APIBuilder {
    root;
    options;
    constructor(root, options3) {
      this.root = root;
      this.options = options3;
    }
    withPromise() {
      return (0, async_1.promise)(this.root, this.options);
    }
    withCallback(cb) {
      (0, async_1.callback)(this.root, this.options, cb);
    }
    sync() {
      return (0, sync_1.sync)(this.root, this.options);
    }
  }
  exports.APIBuilder = APIBuilder;
});
var require_builder2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.Builder = undefined;
  var path_1 = import.meta.require("path");
  var api_builder_1 = require_api_builder();
  var pm = null;
  try {
    import.meta.require.resolve("picomatch");
    pm = require_picomatch2();
  } catch (_e) {
  }

  class Builder {
    globCache = {};
    options = {
      maxDepth: Infinity,
      suppressErrors: true,
      pathSeparator: path_1.sep,
      filters: []
    };
    globFunction;
    constructor(options3) {
      this.options = { ...this.options, ...options3 };
      this.globFunction = this.options.globFunction;
    }
    group() {
      this.options.group = true;
      return this;
    }
    withPathSeparator(separator) {
      this.options.pathSeparator = separator;
      return this;
    }
    withBasePath() {
      this.options.includeBasePath = true;
      return this;
    }
    withRelativePaths() {
      this.options.relativePaths = true;
      return this;
    }
    withDirs() {
      this.options.includeDirs = true;
      return this;
    }
    withMaxDepth(depth2) {
      this.options.maxDepth = depth2;
      return this;
    }
    withMaxFiles(limit) {
      this.options.maxFiles = limit;
      return this;
    }
    withFullPaths() {
      this.options.resolvePaths = true;
      this.options.includeBasePath = true;
      return this;
    }
    withErrors() {
      this.options.suppressErrors = false;
      return this;
    }
    withSymlinks({ resolvePaths = true } = {}) {
      this.options.resolveSymlinks = true;
      this.options.useRealPaths = resolvePaths;
      return this.withFullPaths();
    }
    withAbortSignal(signal) {
      this.options.signal = signal;
      return this;
    }
    normalize() {
      this.options.normalizePath = true;
      return this;
    }
    filter(predicate) {
      this.options.filters.push(predicate);
      return this;
    }
    onlyDirs() {
      this.options.excludeFiles = true;
      this.options.includeDirs = true;
      return this;
    }
    exclude(predicate) {
      this.options.exclude = predicate;
      return this;
    }
    onlyCounts() {
      this.options.onlyCounts = true;
      return this;
    }
    crawl(root) {
      return new api_builder_1.APIBuilder(root || ".", this.options);
    }
    withGlobFunction(fn) {
      this.globFunction = fn;
      return this;
    }
    crawlWithOptions(root, options3) {
      this.options = { ...this.options, ...options3 };
      return new api_builder_1.APIBuilder(root || ".", this.options);
    }
    glob(...patterns) {
      if (this.globFunction) {
        return this.globWithOptions(patterns);
      }
      return this.globWithOptions(patterns, ...[{ dot: true }]);
    }
    globWithOptions(patterns, ...options3) {
      const globFn = this.globFunction || pm;
      if (!globFn) {
        throw new Error("Please specify a glob function to use glob matching.");
      }
      var isMatch = this.globCache[patterns.join("\0")];
      if (!isMatch) {
        isMatch = globFn(patterns, ...options3);
        this.globCache[patterns.join("\0")] = isMatch;
      }
      this.options.filters.push((path42) => isMatch(path42));
      return this;
    }
  }
  exports.Builder = Builder;
});
var require_types3 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
});
var require_dist3 = __commonJS2((exports) => {
  var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m22, k, k2) {
    if (k2 === undefined)
      k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m22, k);
    if (!desc || ("get" in desc ? !m22.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() {
        return m22[k];
      } };
    }
    Object.defineProperty(o, k2, desc);
  } : function(o, m22, k, k2) {
    if (k2 === undefined)
      k2 = k;
    o[k2] = m22[k];
  });
  var __exportStar = exports && exports.__exportStar || function(m22, exports2) {
    for (var p32 in m22)
      if (p32 !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p32))
        __createBinding(exports2, m22, p32);
  };
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.fdir = undefined;
  var builder_1 = require_builder2();
  Object.defineProperty(exports, "fdir", { enumerable: true, get: function() {
    return builder_1.Builder;
  } });
  __exportStar(require_types3(), exports);
});
function convertPosixPathToPattern(path22) {
  return escapePosixPath(path22);
}
function convertWin32PathToPattern(path22) {
  return escapeWin32Path(path22).replace(ESCAPED_WIN32_BACKSLASHES, "/");
}
function isDynamicPattern(pattern, options3) {
  if ((options3 == null ? undefined : options3.caseSensitiveMatch) === false) {
    return true;
  }
  const scan2 = import_picomatch2.default.scan(pattern);
  return scan2.isGlob || scan2.negated;
}
function normalizePattern(pattern, expandDirectories, cwd, properties, isIgnore) {
  var _a;
  let result2 = pattern;
  if (pattern.endsWith("/")) {
    result2 = pattern.slice(0, -1);
  }
  if (!result2.endsWith("*") && expandDirectories) {
    result2 += "/**";
  }
  if (path4.isAbsolute(result2.replace(/\\(?=[()[\]{}!*+?@|])/g, ""))) {
    result2 = posix3.relative(cwd, result2);
  } else {
    result2 = posix3.normalize(result2);
  }
  const parentDirectoryMatch = /^(\/?\.\.)+/.exec(result2);
  if (parentDirectoryMatch == null ? undefined : parentDirectoryMatch[0]) {
    const potentialRoot = posix3.join(cwd, parentDirectoryMatch[0]);
    if (properties.root.length > potentialRoot.length) {
      properties.root = potentialRoot;
      properties.depthOffset = -(parentDirectoryMatch[0].length + 1) / 3;
    }
  } else if (!isIgnore && properties.depthOffset >= 0) {
    const current2 = result2.split("/");
    (_a = properties.commonPath) != null || (properties.commonPath = current2);
    const newCommonPath = [];
    for (let i2 = 0;i2 < Math.min(properties.commonPath.length, current2.length); i2++) {
      const part = current2[i2];
      if (part === "**" && !current2[i2 + 1]) {
        newCommonPath.pop();
        break;
      }
      if (part !== properties.commonPath[i2] || isDynamicPattern(part) || i2 === current2.length - 1) {
        break;
      }
      newCommonPath.push(part);
    }
    properties.depthOffset = newCommonPath.length;
    properties.commonPath = newCommonPath;
    properties.root = newCommonPath.length > 0 ? `${cwd}/${newCommonPath.join("/")}` : cwd;
  }
  return result2;
}
function processPatterns({ patterns, ignore: ignore2 = [], expandDirectories = true }, cwd, properties) {
  if (typeof patterns === "string") {
    patterns = [patterns];
  } else if (!patterns) {
    patterns = ["**/*"];
  }
  if (typeof ignore2 === "string") {
    ignore2 = [ignore2];
  }
  const matchPatterns = [];
  const ignorePatterns = [];
  for (const pattern of ignore2) {
    if (!pattern.startsWith("!") || pattern[1] === "(") {
      const newPattern = normalizePattern(pattern, expandDirectories, cwd, properties, true);
      ignorePatterns.push(newPattern);
    }
  }
  for (const pattern of patterns) {
    if (!pattern.startsWith("!") || pattern[1] === "(") {
      const newPattern = normalizePattern(pattern, expandDirectories, cwd, properties, false);
      matchPatterns.push(newPattern);
    } else if (pattern[1] !== "!" || pattern[2] === "(") {
      const newPattern = normalizePattern(pattern.slice(1), expandDirectories, cwd, properties, true);
      ignorePatterns.push(newPattern);
    }
  }
  return { match: matchPatterns, ignore: ignorePatterns };
}
function getRelativePath(path22, cwd, root) {
  return posix3.relative(cwd, `${root}/${path22}`);
}
function processPath(path22, cwd, root, isDirectory, absolute) {
  const relativePath = absolute ? path22.slice(root.length + 1) || "." : path22;
  if (root === cwd) {
    return isDirectory && relativePath !== "." ? relativePath.slice(0, -1) : relativePath;
  }
  return getRelativePath(relativePath, cwd, root);
}
function crawl(options3, cwd, sync) {
  const properties = {
    root: cwd,
    commonPath: null,
    depthOffset: 0
  };
  const processed = processPatterns(options3, cwd, properties);
  const matcher = import_picomatch.default(processed.match, {
    dot: options3.dot,
    nocase: options3.caseSensitiveMatch === false,
    ignore: processed.ignore
  });
  const exclude = import_picomatch.default(processed.ignore, {
    dot: options3.dot,
    nocase: options3.caseSensitiveMatch === false
  });
  const fdirOptions = {
    filters: [(p32, isDirectory) => matcher(processPath(p32, cwd, properties.root, isDirectory, options3.absolute))],
    exclude: (_22, p32) => exclude(processPath(p32, cwd, properties.root, true, true)),
    pathSeparator: "/",
    relativePaths: true,
    resolveSymlinks: true
  };
  if (options3.deep) {
    fdirOptions.maxDepth = Math.round(options3.deep - properties.depthOffset);
  }
  if (options3.absolute) {
    fdirOptions.relativePaths = false;
    fdirOptions.resolvePaths = true;
    fdirOptions.includeBasePath = true;
  }
  if (options3.followSymbolicLinks === false) {
    fdirOptions.resolveSymlinks = false;
    fdirOptions.excludeSymlinks = true;
  }
  if (options3.onlyDirectories) {
    fdirOptions.excludeFiles = true;
    fdirOptions.includeDirs = true;
  } else if (options3.onlyFiles === false) {
    fdirOptions.includeDirs = true;
  }
  properties.root = properties.root.replace(/\\/g, "");
  const api2 = new import_fdir.fdir(fdirOptions).crawl(properties.root);
  if (cwd === properties.root || options3.absolute) {
    return sync ? api2.sync() : api2.withPromise();
  }
  return sync ? api2.sync().map((p32) => getRelativePath(p32, cwd, properties.root) + (!p32 || p32.endsWith("/") ? "/" : "")) : api2.withPromise().then((paths) => paths.map((p32) => getRelativePath(p32, cwd, properties.root) + (!p32 || p32.endsWith("/") ? "/" : "")));
}
async function glob(patternsOrOptions, options3) {
  if (patternsOrOptions && (options3 == null ? undefined : options3.patterns)) {
    throw new Error("Cannot pass patterns as both an argument and an option");
  }
  const opts = Array.isArray(patternsOrOptions) || typeof patternsOrOptions === "string" ? { ...options3, patterns: patternsOrOptions } : patternsOrOptions;
  const cwd = opts.cwd ? path4.resolve(opts.cwd).replace(/\\/g, "/") : process.cwd().replace(/\\/g, "/");
  return crawl(opts, cwd, false);
}
function globSync2(patternsOrOptions, options3) {
  if (patternsOrOptions && (options3 == null ? undefined : options3.patterns)) {
    throw new Error("Cannot pass patterns as both an argument and an option");
  }
  const opts = Array.isArray(patternsOrOptions) || typeof patternsOrOptions === "string" ? { ...options3, patterns: patternsOrOptions } : patternsOrOptions;
  const cwd = opts.cwd ? path4.resolve(opts.cwd).replace(/\\/g, "/") : process.cwd().replace(/\\/g, "/");
  return crawl(opts, cwd, true);
}
var import_fdir;
var import_picomatch;
var import_picomatch2;
var ESCAPED_WIN32_BACKSLASHES;
var convertPathToPattern;
var POSIX_UNESCAPED_GLOB_SYMBOLS;
var WIN32_UNESCAPED_GLOB_SYMBOLS;
var escapePosixPath = (path22) => path22.replace(POSIX_UNESCAPED_GLOB_SYMBOLS, "\\$&");
var escapeWin32Path = (path22) => path22.replace(WIN32_UNESCAPED_GLOB_SYMBOLS, "\\$&");
var escapePath;
var init_dist6 = __esm2(() => {
  import_fdir = __toESM3(require_dist3(), 1);
  import_picomatch = __toESM3(require_picomatch2(), 1);
  import_picomatch2 = __toESM3(require_picomatch2(), 1);
  ESCAPED_WIN32_BACKSLASHES = /\\(?![()[\]{}!+@])/g;
  convertPathToPattern = process.platform === "win32" ? convertWin32PathToPattern : convertPosixPathToPattern;
  POSIX_UNESCAPED_GLOB_SYMBOLS = /(?<!\\)([()[\]{}*?|]|^!|[!+@](?=\()|\\(?![()[\]{}!*+?@|]))/g;
  WIN32_UNESCAPED_GLOB_SYMBOLS = /(?<!\\)([()[\]{}]|^!|[!+@](?=\())/g;
  escapePath = process.platform === "win32" ? escapeWin32Path : escapePosixPath;
});
function globSync(patterns, options3) {
  if (typeof patterns === "string") {
    return globSync2([patterns], options3);
  }
  return globSync2(patterns, options3);
}
var init_glob = __esm2(() => {
  init_dist6();
  init_dist6();
});
function deleteFolder(path5) {
  return new Promise((resolve5, reject) => {
    try {
      if (isFolder(path5)) {
        fs2.rmSync(path5, { recursive: true, force: true });
        return resolve5(ok2(`Deleted ${path5}`));
      }
      return resolve5(ok2(`Path ${path5} was not a directory`));
    } catch (error) {
      return reject(err2(error));
    }
  });
}
async function isDirectoryEmpty(path5) {
  return new Promise((resolve5, reject) => {
    try {
      if (fs2.statSync(path5).isDirectory()) {
        if (fs2.readdirSync(path5).length === 0)
          return resolve5(ok2(true));
        return resolve5(ok2(false));
      }
      return resolve5(ok2(false));
    } catch (error) {
      return reject(err2(error));
    }
  });
}
async function deleteEmptyFolder(path5) {
  return new Promise((resolve5, reject) => {
    try {
      if (fs2.statSync(path5).isDirectory()) {
        if (fs2.readdirSync(path5).length === 0) {
          fs2.rmSync(path5, { recursive: true, force: true });
          return resolve5(ok2(`Deleted ${path5}`));
        }
        return resolve5(ok2(`Path ${path5} was not empty`));
      }
      return resolve5(ok2(`Path ${path5} was not a directory`));
    } catch (error) {
      return reject(err2(error));
    }
  });
}
async function deleteEmptyFolders(dir) {
  try {
    if (!fs2.existsSync(dir))
      return ok2(`Path ${dir} does not exist`);
    const files = fs2.readdirSync(dir);
    for (const file of files) {
      const p32 = join2(dir, file);
      if (isFolder(p32)) {
        if (fs2.readdirSync(p32).length === 0)
          fs2.rmSync(p32, { recursive: true, force: true });
        else
          await deleteEmptyFolders(p32);
      }
    }
    return ok2(`Deleted empty folders located in ${dir}`);
  } catch (error) {
    return err2(error);
  }
}
function deleteFile(path5) {
  return new Promise((resolve5, reject) => {
    try {
      if (fs2.statSync(path5).isFile()) {
        fs2.rmSync(path5, { recursive: true, force: true });
        return resolve5(ok2(`Deleted ${path5}`));
      }
      return resolve5(ok2(`Path ${path5} was not a file`));
    } catch (error) {
      return reject(err2(error));
    }
  });
}
async function deleteGlob(path5) {
  if (!path5.includes("*"))
    return err2(handleError2(`Path ${path5} does not contain a glob`));
  const directories = await glob([path5], { onlyDirectories: true });
  for (const directory of directories) {
    const result2 = await deleteFolder(directory);
    if (result2.isErr()) {
      log2.error(result2.error);
      return result2;
    }
    log2.info(`Deleted ${italic2(directory)}`);
  }
  return ok2(`Deleted ${directories.length} directories`);
}
async function del(path5) {
  if (fs2.existsSync(path5) && fs2.statSync(path5).isFile())
    return await deleteFile(path5);
  if (isFolder(path5))
    return await deleteFolder(path5);
  if (path5.includes("*"))
    return await deleteGlob(path5);
  return err2(handleError2(`Path ${path5} cannot be deleted due to an unhandled condition. Please report this issue.`));
}
var init_delete = __esm2(() => {
  init_src10();
  init_src7();
  init_src11();
  init_folders();
  init_fs();
  init_glob();
});
async function readJsonFile(name, cwd) {
  const file = await readTextFile(name, cwd);
  const data2 = JSON.parse(file.data);
  const indent = detectIndent(file.data).indent;
  const newline = detectNewline(file.data);
  return { ...file, data: data2, indent, newline };
}
async function readPackageJson(name, cwd) {
  const file = await readJsonFile(name, cwd);
  return file.data;
}
async function writeFile(path5, data2) {
  if (typeof path5 === "string") {
    const dirPath = dirname22(path5);
    if (!await import_fs_extra.pathExists(dirPath))
      await createFolder(dirPath);
    return await Bun.write(Bun.file(path5), data2);
  }
  return await Bun.write(path5, data2);
}
async function writeJsonFile(file) {
  let json2 = JSON.stringify(file.data, undefined, file.indent);
  if (file.newline)
    json2 += file.newline;
  return writeTextFile({ ...file, data: json2 });
}
function readTextFile(name, cwd) {
  return new Promise((resolve5, reject) => {
    let filePath;
    if (cwd)
      filePath = join2(cwd, name);
    else
      filePath = name;
    fs2.readFile(filePath, "utf8", (err22, text22) => {
      if (err22) {
        reject(err22);
      } else {
        resolve5({
          path: filePath,
          data: text22
        });
      }
    });
  });
}
async function writeTextFile(file) {
  return await Bun.write(file.path, file.data);
}
function isFile(path5) {
  return fs2.existsSync(path5);
}
function doesExist(path5) {
  return !isFile(path5) || !isFolder(path5);
}
function doesNotExist(path5) {
  return !isFile(path5) && !isFolder(path5);
}
function hasFiles(folder) {
  try {
    return fs2.readdirSync(folder).length > 0;
  } catch (err22) {
    log2.debug(`Error reading folder: ${folder}`, err22);
    return false;
  }
}
function hasComponents() {
  return hasFiles(path2.componentsPath());
}
function hasFunctions() {
  return hasFiles(path2.functionsPath());
}
function deleteFiles(dir, exclude = []) {
  if (fs2.existsSync(dir)) {
    fs2.readdirSync(dir).forEach((file) => {
      const p32 = join2(dir, file);
      if (fs2.statSync(p32).isDirectory()) {
        if (fs2.readdirSync(p32).length === 0)
          fs2.rmSync(p32, { recursive: true, force: true });
        else
          deleteFiles(p32, exclude);
      } else if (!contains(p32, exclude)) {
        fs2.rmSync(p32);
      }
    });
  }
}
function getFiles(dir, exclude = []) {
  let results = [];
  const list2 = fs2.readdirSync(dir);
  list2.forEach((file) => {
    file = join2(dir, file);
    const stat22 = fs2.statSync(file);
    if (stat22.isDirectory())
      results = results.concat(getFiles(file, exclude));
    else if (!contains(file, exclude))
      results.push(file);
  });
  return results;
}
function put2(path5, contents) {
  const dirPath = dirname22(path5);
  if (!fs2.existsSync(dirPath))
    fs2.mkdirSync(dirPath, { recursive: true });
  fs2.writeFileSync(path5, contents, "utf-8");
}
async function get(path5) {
  return Bun.file(path5).text();
}
var files;
var init_files = __esm2(() => {
  init_src22();
  init_src8();
  init_src11();
  init_src();
  init_src23();
  init_fs();
  files = {
    readJsonFile,
    readPackageJson,
    readTextFile,
    writeJsonFile,
    writeTextFile,
    hasFiles,
    hasComponents,
    hasFunctions,
    deleteFiles,
    getFiles,
    put: put2,
    get
  };
});
var getHttpHandlerExtensionConfiguration = (runtimeConfig) => {
  let httpHandler = runtimeConfig.httpHandler;
  return {
    setHttpHandler(handler3) {
      httpHandler = handler3;
    },
    httpHandler() {
      return httpHandler;
    },
    updateHttpClientConfig(key2, value) {
      httpHandler.updateHttpClientConfig(key2, value);
    },
    httpHandlerConfigs() {
      return httpHandler.httpHandlerConfigs();
    }
  };
};
var resolveHttpHandlerRuntimeConfig = (httpHandlerExtensionConfiguration) => {
  return {
    httpHandler: httpHandlerExtensionConfiguration.httpHandler()
  };
};
var init_extensions = () => {
};
var require_dist_cjs = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    AlgorithmId: () => AlgorithmId,
    EndpointURLScheme: () => EndpointURLScheme,
    FieldPosition: () => FieldPosition,
    HttpApiKeyAuthLocation: () => HttpApiKeyAuthLocation,
    HttpAuthLocation: () => HttpAuthLocation,
    IniSectionType: () => IniSectionType,
    RequestHandlerProtocol: () => RequestHandlerProtocol,
    SMITHY_CONTEXT_KEY: () => SMITHY_CONTEXT_KEY,
    getDefaultClientConfiguration: () => getDefaultClientConfiguration,
    resolveDefaultRuntimeConfig: () => resolveDefaultRuntimeConfig
  });
  module.exports = __toCommonJS2(src_exports);
  var HttpAuthLocation = /* @__PURE__ */ ((HttpAuthLocation2) => {
    HttpAuthLocation2["HEADER"] = "header";
    HttpAuthLocation2["QUERY"] = "query";
    return HttpAuthLocation2;
  })(HttpAuthLocation || {});
  var HttpApiKeyAuthLocation = /* @__PURE__ */ ((HttpApiKeyAuthLocation2) => {
    HttpApiKeyAuthLocation2["HEADER"] = "header";
    HttpApiKeyAuthLocation2["QUERY"] = "query";
    return HttpApiKeyAuthLocation2;
  })(HttpApiKeyAuthLocation || {});
  var EndpointURLScheme = /* @__PURE__ */ ((EndpointURLScheme2) => {
    EndpointURLScheme2["HTTP"] = "http";
    EndpointURLScheme2["HTTPS"] = "https";
    return EndpointURLScheme2;
  })(EndpointURLScheme || {});
  var AlgorithmId = /* @__PURE__ */ ((AlgorithmId2) => {
    AlgorithmId2["MD5"] = "md5";
    AlgorithmId2["CRC32"] = "crc32";
    AlgorithmId2["CRC32C"] = "crc32c";
    AlgorithmId2["SHA1"] = "sha1";
    AlgorithmId2["SHA256"] = "sha256";
    return AlgorithmId2;
  })(AlgorithmId || {});
  var getChecksumConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
    const checksumAlgorithms = [];
    if (runtimeConfig.sha256 !== undefined) {
      checksumAlgorithms.push({
        algorithmId: () => "sha256",
        checksumConstructor: () => runtimeConfig.sha256
      });
    }
    if (runtimeConfig.md5 != null) {
      checksumAlgorithms.push({
        algorithmId: () => "md5",
        checksumConstructor: () => runtimeConfig.md5
      });
    }
    return {
      _checksumAlgorithms: checksumAlgorithms,
      addChecksumAlgorithm(algo) {
        this._checksumAlgorithms.push(algo);
      },
      checksumAlgorithms() {
        return this._checksumAlgorithms;
      }
    };
  }, "getChecksumConfiguration");
  var resolveChecksumRuntimeConfig = /* @__PURE__ */ __name((clientConfig) => {
    const runtimeConfig = {};
    clientConfig.checksumAlgorithms().forEach((checksumAlgorithm) => {
      runtimeConfig[checksumAlgorithm.algorithmId()] = checksumAlgorithm.checksumConstructor();
    });
    return runtimeConfig;
  }, "resolveChecksumRuntimeConfig");
  var getDefaultClientConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
    return {
      ...getChecksumConfiguration(runtimeConfig)
    };
  }, "getDefaultClientConfiguration");
  var resolveDefaultRuntimeConfig = /* @__PURE__ */ __name((config6) => {
    return {
      ...resolveChecksumRuntimeConfig(config6)
    };
  }, "resolveDefaultRuntimeConfig");
  var FieldPosition = /* @__PURE__ */ ((FieldPosition2) => {
    FieldPosition2[FieldPosition2["HEADER"] = 0] = "HEADER";
    FieldPosition2[FieldPosition2["TRAILER"] = 1] = "TRAILER";
    return FieldPosition2;
  })(FieldPosition || {});
  var SMITHY_CONTEXT_KEY = "__smithy_context";
  var IniSectionType = /* @__PURE__ */ ((IniSectionType2) => {
    IniSectionType2["PROFILE"] = "profile";
    IniSectionType2["SSO_SESSION"] = "sso-session";
    IniSectionType2["SERVICES"] = "services";
    return IniSectionType2;
  })(IniSectionType || {});
  var RequestHandlerProtocol = /* @__PURE__ */ ((RequestHandlerProtocol2) => {
    RequestHandlerProtocol2["HTTP_0_9"] = "http/0.9";
    RequestHandlerProtocol2["HTTP_1_0"] = "http/1.0";
    RequestHandlerProtocol2["TDS_8_0"] = "tds/8.0";
    return RequestHandlerProtocol2;
  })(RequestHandlerProtocol || {});
});
var import_types8;
var init_Field = __esm2(() => {
  import_types8 = __toESM3(require_dist_cjs(), 1);
});
var init_httpHandler = () => {
};

class HttpRequest {
  constructor(options3) {
    this.method = options3.method || "GET";
    this.hostname = options3.hostname || "localhost";
    this.port = options3.port;
    this.query = options3.query || {};
    this.headers = options3.headers || {};
    this.body = options3.body;
    this.protocol = options3.protocol ? options3.protocol.slice(-1) !== ":" ? `${options3.protocol}:` : options3.protocol : "https:";
    this.path = options3.path ? options3.path.charAt(0) !== "/" ? `/${options3.path}` : options3.path : "/";
    this.username = options3.username;
    this.password = options3.password;
    this.fragment = options3.fragment;
  }
  static clone(request42) {
    const cloned = new HttpRequest({
      ...request42,
      headers: { ...request42.headers }
    });
    if (cloned.query) {
      cloned.query = cloneQuery(cloned.query);
    }
    return cloned;
  }
  static isInstance(request42) {
    if (!request42) {
      return false;
    }
    const req = request42;
    return "method" in req && "protocol" in req && "hostname" in req && "path" in req && typeof req["query"] === "object" && typeof req["headers"] === "object";
  }
  clone() {
    return HttpRequest.clone(this);
  }
}
function cloneQuery(query) {
  return Object.keys(query).reduce((carry, paramName) => {
    const param = query[paramName];
    return {
      ...carry,
      [paramName]: Array.isArray(param) ? [...param] : param
    };
  }, {});
}

class HttpResponse {
  constructor(options3) {
    this.statusCode = options3.statusCode;
    this.reason = options3.reason;
    this.headers = options3.headers || {};
    this.body = options3.body;
  }
  static isInstance(response) {
    if (!response)
      return false;
    const resp = response;
    return typeof resp.statusCode === "number" && typeof resp.headers === "object";
  }
}
function isValidHostname(hostname) {
  const hostPattern = /^[a-z0-9][a-z0-9\.\-]*[a-z0-9]$/;
  return hostPattern.test(hostname);
}
var init_types4 = () => {
};
var init_dist_es = __esm2(() => {
  init_extensions();
  init_Field();
  init_httpHandler();
  init_types4();
});
function addExpectContinueMiddleware(options3) {
  return (next) => async (args) => {
    const { request: request42 } = args;
    if (HttpRequest.isInstance(request42) && request42.body && options3.runtime === "node") {
      if (options3.requestHandler?.constructor?.name !== "FetchHttpHandler") {
        request42.headers = {
          ...request42.headers,
          Expect: "100-continue"
        };
      }
    }
    return next({
      ...args,
      request: request42
    });
  };
}
var addExpectContinueMiddlewareOptions;
var getAddExpectContinuePlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(addExpectContinueMiddleware(options3), addExpectContinueMiddlewareOptions);
  }
});
var init_dist_es2 = __esm2(() => {
  init_dist_es();
  addExpectContinueMiddlewareOptions = {
    step: "build",
    tags: ["SET_EXPECT_HEADER", "EXPECT_HEADER"],
    name: "addExpectContinueMiddleware",
    override: true
  };
});
var RequestChecksumCalculation;
var DEFAULT_REQUEST_CHECKSUM_CALCULATION;
var ResponseChecksumValidation;
var DEFAULT_RESPONSE_CHECKSUM_VALIDATION;
var ChecksumAlgorithm;
var ChecksumLocation;
var DEFAULT_CHECKSUM_ALGORITHM;
var S3_EXPRESS_DEFAULT_CHECKSUM_ALGORITHM;
var init_constants = __esm2(() => {
  RequestChecksumCalculation = {
    WHEN_SUPPORTED: "WHEN_SUPPORTED",
    WHEN_REQUIRED: "WHEN_REQUIRED"
  };
  DEFAULT_REQUEST_CHECKSUM_CALCULATION = RequestChecksumCalculation.WHEN_SUPPORTED;
  ResponseChecksumValidation = {
    WHEN_SUPPORTED: "WHEN_SUPPORTED",
    WHEN_REQUIRED: "WHEN_REQUIRED"
  };
  DEFAULT_RESPONSE_CHECKSUM_VALIDATION = RequestChecksumCalculation.WHEN_SUPPORTED;
  (function(ChecksumAlgorithm2) {
    ChecksumAlgorithm2["MD5"] = "MD5";
    ChecksumAlgorithm2["CRC32"] = "CRC32";
    ChecksumAlgorithm2["CRC32C"] = "CRC32C";
    ChecksumAlgorithm2["SHA1"] = "SHA1";
    ChecksumAlgorithm2["SHA256"] = "SHA256";
  })(ChecksumAlgorithm || (ChecksumAlgorithm = {}));
  (function(ChecksumLocation2) {
    ChecksumLocation2["HEADER"] = "header";
    ChecksumLocation2["TRAILER"] = "trailer";
  })(ChecksumLocation || (ChecksumLocation = {}));
  DEFAULT_CHECKSUM_ALGORITHM = ChecksumAlgorithm.MD5;
  S3_EXPRESS_DEFAULT_CHECKSUM_ALGORITHM = ChecksumAlgorithm.CRC32;
});
var SelectorType;
var stringUnionSelector = (obj, key2, union22, type2) => {
  if (!(key2 in obj))
    return;
  const value = obj[key2].toUpperCase();
  if (!Object.values(union22).includes(value)) {
    throw new TypeError(`Cannot load ${type2} '${key2}'. Expected one of ${Object.values(union22)}, got '${obj[key2]}'.`);
  }
  return value;
};
var init_stringUnionSelector = __esm2(() => {
  (function(SelectorType2) {
    SelectorType2["ENV"] = "env";
    SelectorType2["CONFIG"] = "shared config entry";
  })(SelectorType || (SelectorType = {}));
});
var ENV_REQUEST_CHECKSUM_CALCULATION = "AWS_REQUEST_CHECKSUM_CALCULATION";
var CONFIG_REQUEST_CHECKSUM_CALCULATION = "request_checksum_calculation";
var NODE_REQUEST_CHECKSUM_CALCULATION_CONFIG_OPTIONS;
var init_NODE_REQUEST_CHECKSUM_CALCULATION_CONFIG_OPTIONS = __esm2(() => {
  init_constants();
  init_stringUnionSelector();
  NODE_REQUEST_CHECKSUM_CALCULATION_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => stringUnionSelector(env62, ENV_REQUEST_CHECKSUM_CALCULATION, RequestChecksumCalculation, SelectorType.ENV),
    configFileSelector: (profile) => stringUnionSelector(profile, CONFIG_REQUEST_CHECKSUM_CALCULATION, RequestChecksumCalculation, SelectorType.CONFIG),
    default: DEFAULT_REQUEST_CHECKSUM_CALCULATION
  };
});
var ENV_RESPONSE_CHECKSUM_VALIDATION = "AWS_RESPONSE_CHECKSUM_VALIDATION";
var CONFIG_RESPONSE_CHECKSUM_VALIDATION = "response_checksum_validation";
var NODE_RESPONSE_CHECKSUM_VALIDATION_CONFIG_OPTIONS;
var init_NODE_RESPONSE_CHECKSUM_VALIDATION_CONFIG_OPTIONS = __esm2(() => {
  init_constants();
  init_stringUnionSelector();
  NODE_RESPONSE_CHECKSUM_VALIDATION_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => stringUnionSelector(env62, ENV_RESPONSE_CHECKSUM_VALIDATION, ResponseChecksumValidation, SelectorType.ENV),
    configFileSelector: (profile) => stringUnionSelector(profile, CONFIG_RESPONSE_CHECKSUM_VALIDATION, ResponseChecksumValidation, SelectorType.CONFIG),
    default: DEFAULT_RESPONSE_CHECKSUM_VALIDATION
  };
});
var require_tslib = __commonJS2((exports, module) => {
  var __extends;
  var __assign2;
  var __rest;
  var __decorate;
  var __param;
  var __esDecorate;
  var __runInitializers;
  var __propKey;
  var __setFunctionName;
  var __metadata;
  var __awaiter22;
  var __generator;
  var __exportStar;
  var __values22;
  var __read;
  var __spread;
  var __spreadArrays;
  var __spreadArray;
  var __await22;
  var __asyncGenerator22;
  var __asyncDelegator22;
  var __asyncValues22;
  var __makeTemplateObject;
  var __importStar;
  var __importDefault;
  var __classPrivateFieldGet;
  var __classPrivateFieldSet;
  var __classPrivateFieldIn;
  var __createBinding;
  var __addDisposableResource;
  var __disposeResources;
  var __rewriteRelativeImportExtension;
  (function(factory) {
    var root = typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : {};
    if (typeof define === "function" && define.amd) {
      define("tslib", ["exports"], function(exports2) {
        factory(createExporter(root, createExporter(exports2)));
      });
    } else if (typeof module === "object" && typeof exports === "object") {
      factory(createExporter(root, createExporter(exports)));
    } else {
      factory(createExporter(root));
    }
    function createExporter(exports2, previous) {
      if (exports2 !== root) {
        if (typeof Object.create === "function") {
          Object.defineProperty(exports2, "__esModule", { value: true });
        } else {
          exports2.__esModule = true;
        }
      }
      return function(id, v22) {
        return exports2[id] = previous ? previous(id, v22) : v22;
      };
    }
  })(function(exporter) {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, b22) {
      d.__proto__ = b22;
    } || function(d, b22) {
      for (var p32 in b22)
        if (Object.prototype.hasOwnProperty.call(b22, p32))
          d[p32] = b22[p32];
    };
    __extends = function(d, b22) {
      if (typeof b22 !== "function" && b22 !== null)
        throw new TypeError("Class extends value " + String(b22) + " is not a constructor or null");
      extendStatics(d, b22);
      function __() {
        this.constructor = d;
      }
      d.prototype = b22 === null ? Object.create(b22) : (__.prototype = b22.prototype, new __);
    };
    __assign2 = Object.assign || function(t) {
      for (var s32, i2 = 1, n = arguments.length;i2 < n; i2++) {
        s32 = arguments[i2];
        for (var p32 in s32)
          if (Object.prototype.hasOwnProperty.call(s32, p32))
            t[p32] = s32[p32];
      }
      return t;
    };
    __rest = function(s32, e) {
      var t = {};
      for (var p32 in s32)
        if (Object.prototype.hasOwnProperty.call(s32, p32) && e.indexOf(p32) < 0)
          t[p32] = s32[p32];
      if (s32 != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i2 = 0, p32 = Object.getOwnPropertySymbols(s32);i2 < p32.length; i2++) {
          if (e.indexOf(p32[i2]) < 0 && Object.prototype.propertyIsEnumerable.call(s32, p32[i2]))
            t[p32[i2]] = s32[p32[i2]];
        }
      return t;
    };
    __decorate = function(decorators, target, key2, desc) {
      var c22 = arguments.length, r22 = c22 < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key2) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r22 = Reflect.decorate(decorators, target, key2, desc);
      else
        for (var i2 = decorators.length - 1;i2 >= 0; i2--)
          if (d = decorators[i2])
            r22 = (c22 < 3 ? d(r22) : c22 > 3 ? d(target, key2, r22) : d(target, key2)) || r22;
      return c22 > 3 && r22 && Object.defineProperty(target, key2, r22), r22;
    };
    __param = function(paramIndex, decorator) {
      return function(target, key2) {
        decorator(target, key2, paramIndex);
      };
    };
    __esDecorate = function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
      function accept(f22) {
        if (f22 !== undefined && typeof f22 !== "function")
          throw new TypeError("Function expected");
        return f22;
      }
      var kind = contextIn.kind, key2 = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
      var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
      var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
      var _22, done = false;
      for (var i2 = decorators.length - 1;i2 >= 0; i2--) {
        var context = {};
        for (var p32 in contextIn)
          context[p32] = p32 === "access" ? {} : contextIn[p32];
        for (var p32 in contextIn.access)
          context.access[p32] = contextIn.access[p32];
        context.addInitializer = function(f22) {
          if (done)
            throw new TypeError("Cannot add initializers after decoration has completed");
          extraInitializers.push(accept(f22 || null));
        };
        var result2 = (0, decorators[i2])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key2], context);
        if (kind === "accessor") {
          if (result2 === undefined)
            continue;
          if (result2 === null || typeof result2 !== "object")
            throw new TypeError("Object expected");
          if (_22 = accept(result2.get))
            descriptor.get = _22;
          if (_22 = accept(result2.set))
            descriptor.set = _22;
          if (_22 = accept(result2.init))
            initializers.unshift(_22);
        } else if (_22 = accept(result2)) {
          if (kind === "field")
            initializers.unshift(_22);
          else
            descriptor[key2] = _22;
        }
      }
      if (target)
        Object.defineProperty(target, contextIn.name, descriptor);
      done = true;
    };
    __runInitializers = function(thisArg, initializers, value) {
      var useValue = arguments.length > 2;
      for (var i2 = 0;i2 < initializers.length; i2++) {
        value = useValue ? initializers[i2].call(thisArg, value) : initializers[i2].call(thisArg);
      }
      return useValue ? value : undefined;
    };
    __propKey = function(x) {
      return typeof x === "symbol" ? x : "".concat(x);
    };
    __setFunctionName = function(f22, name, prefix) {
      if (typeof name === "symbol")
        name = name.description ? "[".concat(name.description, "]") : "";
      return Object.defineProperty(f22, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
    };
    __metadata = function(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(metadataKey, metadataValue);
    };
    __awaiter22 = function(thisArg, _arguments, P22, generator) {
      function adopt(value) {
        return value instanceof P22 ? value : new P22(function(resolve5) {
          resolve5(value);
        });
      }
      return new (P22 || (P22 = Promise))(function(resolve5, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result2) {
          result2.done ? resolve5(result2.value) : adopt(result2.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    __generator = function(thisArg, body) {
      var _22 = { label: 0, sent: function() {
        if (t[0] & 1)
          throw t[1];
        return t[1];
      }, trys: [], ops: [] }, f22, y, t, g22 = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
      return g22.next = verb(0), g22["throw"] = verb(1), g22["return"] = verb(2), typeof Symbol === "function" && (g22[Symbol.iterator] = function() {
        return this;
      }), g22;
      function verb(n) {
        return function(v22) {
          return step([n, v22]);
        };
      }
      function step(op) {
        if (f22)
          throw new TypeError("Generator is already executing.");
        while (g22 && (g22 = 0, op[0] && (_22 = 0)), _22)
          try {
            if (f22 = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
              return t;
            if (y = 0, t)
              op = [op[0] & 2, t.value];
            switch (op[0]) {
              case 0:
              case 1:
                t = op;
                break;
              case 4:
                _22.label++;
                return { value: op[1], done: false };
              case 5:
                _22.label++;
                y = op[1];
                op = [0];
                continue;
              case 7:
                op = _22.ops.pop();
                _22.trys.pop();
                continue;
              default:
                if (!(t = _22.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                  _22 = 0;
                  continue;
                }
                if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                  _22.label = op[1];
                  break;
                }
                if (op[0] === 6 && _22.label < t[1]) {
                  _22.label = t[1];
                  t = op;
                  break;
                }
                if (t && _22.label < t[2]) {
                  _22.label = t[2];
                  _22.ops.push(op);
                  break;
                }
                if (t[2])
                  _22.ops.pop();
                _22.trys.pop();
                continue;
            }
            op = body.call(thisArg, _22);
          } catch (e) {
            op = [6, e];
            y = 0;
          } finally {
            f22 = t = 0;
          }
        if (op[0] & 5)
          throw op[1];
        return { value: op[0] ? op[1] : undefined, done: true };
      }
    };
    __exportStar = function(m22, o) {
      for (var p32 in m22)
        if (p32 !== "default" && !Object.prototype.hasOwnProperty.call(o, p32))
          __createBinding(o, m22, p32);
    };
    __createBinding = Object.create ? function(o, m22, k, k2) {
      if (k2 === undefined)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m22, k);
      if (!desc || ("get" in desc ? !m22.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m22[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m22, k, k2) {
      if (k2 === undefined)
        k2 = k;
      o[k2] = m22[k];
    };
    __values22 = function(o) {
      var s32 = typeof Symbol === "function" && Symbol.iterator, m22 = s32 && o[s32], i2 = 0;
      if (m22)
        return m22.call(o);
      if (o && typeof o.length === "number")
        return {
          next: function() {
            if (o && i2 >= o.length)
              o = undefined;
            return { value: o && o[i2++], done: !o };
          }
        };
      throw new TypeError(s32 ? "Object is not iterable." : "Symbol.iterator is not defined.");
    };
    __read = function(o, n) {
      var m22 = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m22)
        return o;
      var i2 = m22.call(o), r22, ar = [], e;
      try {
        while ((n === undefined || n-- > 0) && !(r22 = i2.next()).done)
          ar.push(r22.value);
      } catch (error) {
        e = { error };
      } finally {
        try {
          if (r22 && !r22.done && (m22 = i2["return"]))
            m22.call(i2);
        } finally {
          if (e)
            throw e.error;
        }
      }
      return ar;
    };
    __spread = function() {
      for (var ar = [], i2 = 0;i2 < arguments.length; i2++)
        ar = ar.concat(__read(arguments[i2]));
      return ar;
    };
    __spreadArrays = function() {
      for (var s32 = 0, i2 = 0, il = arguments.length;i2 < il; i2++)
        s32 += arguments[i2].length;
      for (var r22 = Array(s32), k = 0, i2 = 0;i2 < il; i2++)
        for (var a = arguments[i2], j22 = 0, jl = a.length;j22 < jl; j22++, k++)
          r22[k] = a[j22];
      return r22;
    };
    __spreadArray = function(to, from, pack) {
      if (pack || arguments.length === 2)
        for (var i2 = 0, l22 = from.length, ar;i2 < l22; i2++) {
          if (ar || !(i2 in from)) {
            if (!ar)
              ar = Array.prototype.slice.call(from, 0, i2);
            ar[i2] = from[i2];
          }
        }
      return to.concat(ar || Array.prototype.slice.call(from));
    };
    __await22 = function(v22) {
      return this instanceof __await22 ? (this.v = v22, this) : new __await22(v22);
    };
    __asyncGenerator22 = function(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var g22 = generator.apply(thisArg, _arguments || []), i2, q22 = [];
      return i2 = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i2[Symbol.asyncIterator] = function() {
        return this;
      }, i2;
      function awaitReturn(f22) {
        return function(v22) {
          return Promise.resolve(v22).then(f22, reject);
        };
      }
      function verb(n, f22) {
        if (g22[n]) {
          i2[n] = function(v22) {
            return new Promise(function(a, b22) {
              q22.push([n, v22, a, b22]) > 1 || resume(n, v22);
            });
          };
          if (f22)
            i2[n] = f22(i2[n]);
        }
      }
      function resume(n, v22) {
        try {
          step(g22[n](v22));
        } catch (e) {
          settle(q22[0][3], e);
        }
      }
      function step(r22) {
        r22.value instanceof __await22 ? Promise.resolve(r22.value.v).then(fulfill, reject) : settle(q22[0][2], r22);
      }
      function fulfill(value) {
        resume("next", value);
      }
      function reject(value) {
        resume("throw", value);
      }
      function settle(f22, v22) {
        if (f22(v22), q22.shift(), q22.length)
          resume(q22[0][0], q22[0][1]);
      }
    };
    __asyncDelegator22 = function(o) {
      var i2, p32;
      return i2 = {}, verb("next"), verb("throw", function(e) {
        throw e;
      }), verb("return"), i2[Symbol.iterator] = function() {
        return this;
      }, i2;
      function verb(n, f22) {
        i2[n] = o[n] ? function(v22) {
          return (p32 = !p32) ? { value: __await22(o[n](v22)), done: false } : f22 ? f22(v22) : v22;
        } : f22;
      }
    };
    __asyncValues22 = function(o) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var m22 = o[Symbol.asyncIterator], i2;
      return m22 ? m22.call(o) : (o = typeof __values22 === "function" ? __values22(o) : o[Symbol.iterator](), i2 = {}, verb("next"), verb("throw"), verb("return"), i2[Symbol.asyncIterator] = function() {
        return this;
      }, i2);
      function verb(n) {
        i2[n] = o[n] && function(v22) {
          return new Promise(function(resolve5, reject) {
            v22 = o[n](v22), settle(resolve5, reject, v22.done, v22.value);
          });
        };
      }
      function settle(resolve5, reject, d, v22) {
        Promise.resolve(v22).then(function(v3) {
          resolve5({ value: v3, done: d });
        }, reject);
      }
    };
    __makeTemplateObject = function(cooked, raw) {
      if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", { value: raw });
      } else {
        cooked.raw = raw;
      }
      return cooked;
    };
    var __setModuleDefault = Object.create ? function(o, v22) {
      Object.defineProperty(o, "default", { enumerable: true, value: v22 });
    } : function(o, v22) {
      o["default"] = v22;
    };
    __importStar = function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    __importDefault = function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    __classPrivateFieldGet = function(receiver, state, kind, f22) {
      if (kind === "a" && !f22)
        throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f22 : !state.has(receiver))
        throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f22 : kind === "a" ? f22.call(receiver) : f22 ? f22.value : state.get(receiver);
    };
    __classPrivateFieldSet = function(receiver, state, value, kind, f22) {
      if (kind === "m")
        throw new TypeError("Private method is not writable");
      if (kind === "a" && !f22)
        throw new TypeError("Private accessor was defined without a setter");
      if (typeof state === "function" ? receiver !== state || !f22 : !state.has(receiver))
        throw new TypeError("Cannot write private member to an object whose class did not declare it");
      return kind === "a" ? f22.call(receiver, value) : f22 ? f22.value = value : state.set(receiver, value), value;
    };
    __classPrivateFieldIn = function(state, receiver) {
      if (receiver === null || typeof receiver !== "object" && typeof receiver !== "function")
        throw new TypeError("Cannot use 'in' operator on non-object");
      return typeof state === "function" ? receiver === state : state.has(receiver);
    };
    __addDisposableResource = function(env62, value, async) {
      if (value !== null && value !== undefined) {
        if (typeof value !== "object" && typeof value !== "function")
          throw new TypeError("Object expected.");
        var dispose, inner;
        if (async) {
          if (!Symbol.asyncDispose)
            throw new TypeError("Symbol.asyncDispose is not defined.");
          dispose = value[Symbol.asyncDispose];
        }
        if (dispose === undefined) {
          if (!Symbol.dispose)
            throw new TypeError("Symbol.dispose is not defined.");
          dispose = value[Symbol.dispose];
          if (async)
            inner = dispose;
        }
        if (typeof dispose !== "function")
          throw new TypeError("Object not disposable.");
        if (inner)
          dispose = function() {
            try {
              inner.call(this);
            } catch (e) {
              return Promise.reject(e);
            }
          };
        env62.stack.push({ value, dispose, async });
      } else if (async) {
        env62.stack.push({ async: true });
      }
      return value;
    };
    var _SuppressedError = typeof SuppressedError === "function" ? SuppressedError : function(error, suppressed, message) {
      var e = new Error(message);
      return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };
    __disposeResources = function(env62) {
      function fail(e) {
        env62.error = env62.hasError ? new _SuppressedError(e, env62.error, "An error was suppressed during disposal.") : e;
        env62.hasError = true;
      }
      var r22, s32 = 0;
      function next() {
        while (r22 = env62.stack.pop()) {
          try {
            if (!r22.async && s32 === 1)
              return s32 = 0, env62.stack.push(r22), Promise.resolve().then(next);
            if (r22.dispose) {
              var result2 = r22.dispose.call(r22.value);
              if (r22.async)
                return s32 |= 2, Promise.resolve(result2).then(next, function(e) {
                  fail(e);
                  return next();
                });
            } else
              s32 |= 1;
          } catch (e) {
            fail(e);
          }
        }
        if (s32 === 1)
          return env62.hasError ? Promise.reject(env62.error) : Promise.resolve();
        if (env62.hasError)
          throw env62.error;
      }
      return next();
    };
    __rewriteRelativeImportExtension = function(path5, preserveJsx) {
      if (typeof path5 === "string" && /^\.\.?\//.test(path5)) {
        return path5.replace(/\.(tsx)$|((?:\.d)?)((?:\.[^./]+?)?)\.([cm]?)ts$/i, function(m22, tsx, d, ext2, cm) {
          return tsx ? preserveJsx ? ".jsx" : ".js" : d && (!ext2 || !cm) ? m22 : d + ext2 + "." + cm.toLowerCase() + "js";
        });
      }
      return path5;
    };
    exporter("__extends", __extends);
    exporter("__assign", __assign2);
    exporter("__rest", __rest);
    exporter("__decorate", __decorate);
    exporter("__param", __param);
    exporter("__esDecorate", __esDecorate);
    exporter("__runInitializers", __runInitializers);
    exporter("__propKey", __propKey);
    exporter("__setFunctionName", __setFunctionName);
    exporter("__metadata", __metadata);
    exporter("__awaiter", __awaiter22);
    exporter("__generator", __generator);
    exporter("__exportStar", __exportStar);
    exporter("__createBinding", __createBinding);
    exporter("__values", __values22);
    exporter("__read", __read);
    exporter("__spread", __spread);
    exporter("__spreadArrays", __spreadArrays);
    exporter("__spreadArray", __spreadArray);
    exporter("__await", __await22);
    exporter("__asyncGenerator", __asyncGenerator22);
    exporter("__asyncDelegator", __asyncDelegator22);
    exporter("__asyncValues", __asyncValues22);
    exporter("__makeTemplateObject", __makeTemplateObject);
    exporter("__importStar", __importStar);
    exporter("__importDefault", __importDefault);
    exporter("__classPrivateFieldGet", __classPrivateFieldGet);
    exporter("__classPrivateFieldSet", __classPrivateFieldSet);
    exporter("__classPrivateFieldIn", __classPrivateFieldIn);
    exporter("__addDisposableResource", __addDisposableResource);
    exporter("__disposeResources", __disposeResources);
    exporter("__rewriteRelativeImportExtension", __rewriteRelativeImportExtension);
  });
});
var require_client4 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var client_exports = {};
  __export32(client_exports, {
    emitWarningIfUnsupportedVersion: () => emitWarningIfUnsupportedVersion,
    setCredentialFeature: () => setCredentialFeature,
    setFeature: () => setFeature,
    state: () => state
  });
  module.exports = __toCommonJS2(client_exports);
  var state = {
    warningEmitted: false
  };
  var emitWarningIfUnsupportedVersion = /* @__PURE__ */ __name((version5) => {
    if (version5 && !state.warningEmitted && parseInt(version5.substring(1, version5.indexOf("."))) < 18) {
      state.warningEmitted = true;
      process.emitWarning(`NodeDeprecationWarning: The AWS SDK for JavaScript (v3) will
no longer support Node.js 16.x on January 6, 2025.

To continue receiving updates to AWS services, bug fixes, and security
updates please upgrade to a supported Node.js LTS version.

More information can be found at: https://a.co/74kJMmI`);
    }
  }, "emitWarningIfUnsupportedVersion");
  function setCredentialFeature(credentials, feature, value) {
    if (!credentials.$source) {
      credentials.$source = {};
    }
    credentials.$source[feature] = value;
    return credentials;
  }
  __name(setCredentialFeature, "setCredentialFeature");
  function setFeature(context, feature, value) {
    if (!context.__aws_sdk_context) {
      context.__aws_sdk_context = {
        features: {}
      };
    } else if (!context.__aws_sdk_context.features) {
      context.__aws_sdk_context.features = {};
    }
    context.__aws_sdk_context.features[feature] = value;
  }
  __name(setFeature, "setFeature");
});
var require_dist_cjs2 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    Field: () => Field2,
    Fields: () => Fields2,
    HttpRequest: () => HttpRequest2,
    HttpResponse: () => HttpResponse2,
    IHttpRequest: () => import_types9.HttpRequest,
    getHttpHandlerExtensionConfiguration: () => getHttpHandlerExtensionConfiguration2,
    isValidHostname: () => isValidHostname3,
    resolveHttpHandlerRuntimeConfig: () => resolveHttpHandlerRuntimeConfig2
  });
  module.exports = __toCommonJS2(src_exports);
  var getHttpHandlerExtensionConfiguration2 = /* @__PURE__ */ __name((runtimeConfig) => {
    let httpHandler2 = runtimeConfig.httpHandler;
    return {
      setHttpHandler(handler3) {
        httpHandler2 = handler3;
      },
      httpHandler() {
        return httpHandler2;
      },
      updateHttpClientConfig(key2, value) {
        httpHandler2.updateHttpClientConfig(key2, value);
      },
      httpHandlerConfigs() {
        return httpHandler2.httpHandlerConfigs();
      }
    };
  }, "getHttpHandlerExtensionConfiguration");
  var resolveHttpHandlerRuntimeConfig2 = /* @__PURE__ */ __name((httpHandlerExtensionConfiguration) => {
    return {
      httpHandler: httpHandlerExtensionConfiguration.httpHandler()
    };
  }, "resolveHttpHandlerRuntimeConfig");
  var import_types9 = require_dist_cjs();
  var _Field = class _Field2 {
    constructor({ name, kind = import_types9.FieldPosition.HEADER, values: values3 = [] }) {
      this.name = name;
      this.kind = kind;
      this.values = values3;
    }
    add(value) {
      this.values.push(value);
    }
    set(values3) {
      this.values = values3;
    }
    remove(value) {
      this.values = this.values.filter((v22) => v22 !== value);
    }
    toString() {
      return this.values.map((v22) => v22.includes(",") || v22.includes(" ") ? `"${v22}"` : v22).join(", ");
    }
    get() {
      return this.values;
    }
  };
  __name(_Field, "Field");
  var Field2 = _Field;
  var _Fields = class _Fields2 {
    constructor({ fields: fields22 = [], encoding = "utf-8" }) {
      this.entries = {};
      fields22.forEach(this.setField.bind(this));
      this.encoding = encoding;
    }
    setField(field) {
      this.entries[field.name.toLowerCase()] = field;
    }
    getField(name) {
      return this.entries[name.toLowerCase()];
    }
    removeField(name) {
      delete this.entries[name.toLowerCase()];
    }
    getByType(kind) {
      return Object.values(this.entries).filter((field) => field.kind === kind);
    }
  };
  __name(_Fields, "Fields");
  var Fields2 = _Fields;
  var _HttpRequest = class _HttpRequest2 {
    constructor(options3) {
      this.method = options3.method || "GET";
      this.hostname = options3.hostname || "localhost";
      this.port = options3.port;
      this.query = options3.query || {};
      this.headers = options3.headers || {};
      this.body = options3.body;
      this.protocol = options3.protocol ? options3.protocol.slice(-1) !== ":" ? `${options3.protocol}:` : options3.protocol : "https:";
      this.path = options3.path ? options3.path.charAt(0) !== "/" ? `/${options3.path}` : options3.path : "/";
      this.username = options3.username;
      this.password = options3.password;
      this.fragment = options3.fragment;
    }
    static clone(request42) {
      const cloned = new _HttpRequest2({
        ...request42,
        headers: { ...request42.headers }
      });
      if (cloned.query) {
        cloned.query = cloneQuery2(cloned.query);
      }
      return cloned;
    }
    static isInstance(request42) {
      if (!request42) {
        return false;
      }
      const req = request42;
      return "method" in req && "protocol" in req && "hostname" in req && "path" in req && typeof req["query"] === "object" && typeof req["headers"] === "object";
    }
    clone() {
      return _HttpRequest2.clone(this);
    }
  };
  __name(_HttpRequest, "HttpRequest");
  var HttpRequest2 = _HttpRequest;
  function cloneQuery2(query) {
    return Object.keys(query).reduce((carry, paramName) => {
      const param = query[paramName];
      return {
        ...carry,
        [paramName]: Array.isArray(param) ? [...param] : param
      };
    }, {});
  }
  __name(cloneQuery2, "cloneQuery");
  var _HttpResponse = class _HttpResponse2 {
    constructor(options3) {
      this.statusCode = options3.statusCode;
      this.reason = options3.reason;
      this.headers = options3.headers || {};
      this.body = options3.body;
    }
    static isInstance(response) {
      if (!response)
        return false;
      const resp = response;
      return typeof resp.statusCode === "number" && typeof resp.headers === "object";
    }
  };
  __name(_HttpResponse, "HttpResponse");
  var HttpResponse2 = _HttpResponse;
  function isValidHostname3(hostname) {
    const hostPattern = /^[a-z0-9][a-z0-9\.\-]*[a-z0-9]$/;
    return hostPattern.test(hostname);
  }
  __name(isValidHostname3, "isValidHostname");
});
var require_dist_cjs3 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    getSmithyContext: () => getSmithyContext,
    normalizeProvider: () => normalizeProvider
  });
  module.exports = __toCommonJS2(src_exports);
  var import_types9 = require_dist_cjs();
  var getSmithyContext = /* @__PURE__ */ __name((context) => context[import_types9.SMITHY_CONTEXT_KEY] || (context[import_types9.SMITHY_CONTEXT_KEY] = {}), "getSmithyContext");
  var normalizeProvider = /* @__PURE__ */ __name((input) => {
    if (typeof input === "function")
      return input;
    const promisified = Promise.resolve(input);
    return () => promisified;
  }, "normalizeProvider");
});
var require_dist_cjs4 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    deserializerMiddleware: () => deserializerMiddleware,
    deserializerMiddlewareOption: () => deserializerMiddlewareOption,
    getSerdePlugin: () => getSerdePlugin,
    serializerMiddleware: () => serializerMiddleware,
    serializerMiddlewareOption: () => serializerMiddlewareOption
  });
  module.exports = __toCommonJS2(src_exports);
  var deserializerMiddleware = /* @__PURE__ */ __name((options3, deserializer) => (next) => async (args) => {
    const { response } = await next(args);
    try {
      const parsed = await deserializer(response, options3);
      return {
        response,
        output: parsed
      };
    } catch (error) {
      Object.defineProperty(error, "$response", {
        value: response
      });
      if (!("$metadata" in error)) {
        const hint = `Deserialization error: to see the raw response, inspect the hidden field {error}.$response on this object.`;
        error.message += "\n  " + hint;
        if (typeof error.$responseBodyText !== "undefined") {
          if (error.$response) {
            error.$response.body = error.$responseBodyText;
          }
        }
      }
      throw error;
    }
  }, "deserializerMiddleware");
  var serializerMiddleware = /* @__PURE__ */ __name((options3, serializer) => (next, context) => async (args) => {
    var _a;
    const endpoint = ((_a = context.endpointV2) == null ? undefined : _a.url) && options3.urlParser ? async () => options3.urlParser(context.endpointV2.url) : options3.endpoint;
    if (!endpoint) {
      throw new Error("No valid endpoint provider available.");
    }
    const request42 = await serializer(args.input, { ...options3, endpoint });
    return next({
      ...args,
      request: request42
    });
  }, "serializerMiddleware");
  var deserializerMiddlewareOption = {
    name: "deserializerMiddleware",
    step: "deserialize",
    tags: ["DESERIALIZER"],
    override: true
  };
  var serializerMiddlewareOption = {
    name: "serializerMiddleware",
    step: "serialize",
    tags: ["SERIALIZER"],
    override: true
  };
  function getSerdePlugin(config6, serializer, deserializer) {
    return {
      applyToStack: (commandStack) => {
        commandStack.add(deserializerMiddleware(config6, deserializer), deserializerMiddlewareOption);
        commandStack.add(serializerMiddleware(config6, serializer), serializerMiddlewareOption);
      }
    };
  }
  __name(getSerdePlugin, "getSerdePlugin");
});
var require_dist_cjs5 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    isArrayBuffer: () => isArrayBuffer
  });
  module.exports = __toCommonJS2(src_exports);
  var isArrayBuffer = /* @__PURE__ */ __name((arg) => typeof ArrayBuffer === "function" && arg instanceof ArrayBuffer || Object.prototype.toString.call(arg) === "[object ArrayBuffer]", "isArrayBuffer");
});
var require_dist_cjs6 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    fromArrayBuffer: () => fromArrayBuffer,
    fromString: () => fromString
  });
  module.exports = __toCommonJS2(src_exports);
  var import_is_array_buffer = require_dist_cjs5();
  var import_buffer10 = import.meta.require("buffer");
  var fromArrayBuffer = /* @__PURE__ */ __name((input, offset2 = 0, length = input.byteLength - offset2) => {
    if (!(0, import_is_array_buffer.isArrayBuffer)(input)) {
      throw new TypeError(`The "input" argument must be ArrayBuffer. Received type ${typeof input} (${input})`);
    }
    return import_buffer10.Buffer.from(input, offset2, length);
  }, "fromArrayBuffer");
  var fromString = /* @__PURE__ */ __name((input, encoding) => {
    if (typeof input !== "string") {
      throw new TypeError(`The "input" argument must be of type string. Received type ${typeof input} (${input})`);
    }
    return encoding ? import_buffer10.Buffer.from(input, encoding) : import_buffer10.Buffer.from(input);
  }, "fromString");
});
var require_fromBase64 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.fromBase64 = undefined;
  var util_buffer_from_1 = require_dist_cjs6();
  var BASE64_REGEX = /^[A-Za-z0-9+/]*={0,2}$/;
  var fromBase642 = (input) => {
    if (input.length * 3 % 4 !== 0) {
      throw new TypeError(`Incorrect padding on base64 string.`);
    }
    if (!BASE64_REGEX.exec(input)) {
      throw new TypeError(`Invalid base64 string.`);
    }
    const buffer = (0, util_buffer_from_1.fromString)(input, "base64");
    return new Uint8Array(buffer.buffer, buffer.byteOffset, buffer.byteLength);
  };
  exports.fromBase64 = fromBase642;
});
var require_dist_cjs7 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    fromUtf8: () => fromUtf8,
    toUint8Array: () => toUint8Array,
    toUtf8: () => toUtf8
  });
  module.exports = __toCommonJS2(src_exports);
  var import_util_buffer_from = require_dist_cjs6();
  var fromUtf8 = /* @__PURE__ */ __name((input) => {
    const buf = (0, import_util_buffer_from.fromString)(input, "utf8");
    return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength / Uint8Array.BYTES_PER_ELEMENT);
  }, "fromUtf8");
  var toUint8Array = /* @__PURE__ */ __name((data2) => {
    if (typeof data2 === "string") {
      return fromUtf8(data2);
    }
    if (ArrayBuffer.isView(data2)) {
      return new Uint8Array(data2.buffer, data2.byteOffset, data2.byteLength / Uint8Array.BYTES_PER_ELEMENT);
    }
    return new Uint8Array(data2);
  }, "toUint8Array");
  var toUtf8 = /* @__PURE__ */ __name((input) => {
    if (typeof input === "string") {
      return input;
    }
    if (typeof input !== "object" || typeof input.byteOffset !== "number" || typeof input.byteLength !== "number") {
      throw new Error("@smithy/util-utf8: toUtf8 encoder function only accepts string | Uint8Array.");
    }
    return (0, import_util_buffer_from.fromArrayBuffer)(input.buffer, input.byteOffset, input.byteLength).toString("utf8");
  }, "toUtf8");
});
var require_toBase64 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.toBase64 = undefined;
  var util_buffer_from_1 = require_dist_cjs6();
  var util_utf8_1 = require_dist_cjs7();
  var toBase643 = (_input) => {
    let input;
    if (typeof _input === "string") {
      input = (0, util_utf8_1.fromUtf8)(_input);
    } else {
      input = _input;
    }
    if (typeof input !== "object" || typeof input.byteOffset !== "number" || typeof input.byteLength !== "number") {
      throw new Error("@smithy/util-base64: toBase64 encoder function only accepts string | Uint8Array.");
    }
    return (0, util_buffer_from_1.fromArrayBuffer)(input.buffer, input.byteOffset, input.byteLength).toString("base64");
  };
  exports.toBase64 = toBase643;
});
var require_dist_cjs8 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  module.exports = __toCommonJS2(src_exports);
  __reExport(src_exports, require_fromBase64(), module.exports);
  __reExport(src_exports, require_toBase64(), module.exports);
});
var require_getAwsChunkedEncodingStream = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.getAwsChunkedEncodingStream = undefined;
  var stream_1 = import.meta.require("stream");
  var getAwsChunkedEncodingStream2 = (readableStream, options3) => {
    const { base64Encoder, bodyLengthChecker, checksumAlgorithmFn, checksumLocationName, streamHasher } = options3;
    const checksumRequired = base64Encoder !== undefined && checksumAlgorithmFn !== undefined && checksumLocationName !== undefined && streamHasher !== undefined;
    const digest = checksumRequired ? streamHasher(checksumAlgorithmFn, readableStream) : undefined;
    const awsChunkedEncodingStream = new stream_1.Readable({ read: () => {
    } });
    readableStream.on("data", (data2) => {
      const length = bodyLengthChecker(data2) || 0;
      awsChunkedEncodingStream.push(`${length.toString(16)}\r\n`);
      awsChunkedEncodingStream.push(data2);
      awsChunkedEncodingStream.push("\r\n");
    });
    readableStream.on("end", async () => {
      awsChunkedEncodingStream.push(`0\r\n`);
      if (checksumRequired) {
        const checksum = base64Encoder(await digest);
        awsChunkedEncodingStream.push(`${checksumLocationName}:${checksum}\r\n`);
        awsChunkedEncodingStream.push(`\r\n`);
      }
      awsChunkedEncodingStream.push(null);
    });
    return awsChunkedEncodingStream;
  };
  exports.getAwsChunkedEncodingStream = getAwsChunkedEncodingStream2;
});
var require_dist_cjs9 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    escapeUri: () => escapeUri,
    escapeUriPath: () => escapeUriPath
  });
  module.exports = __toCommonJS2(src_exports);
  var escapeUri = /* @__PURE__ */ __name((uri) => encodeURIComponent(uri).replace(/[!'()*]/g, hexEncode), "escapeUri");
  var hexEncode = /* @__PURE__ */ __name((c22) => `%${c22.charCodeAt(0).toString(16).toUpperCase()}`, "hexEncode");
  var escapeUriPath = /* @__PURE__ */ __name((uri) => uri.split("/").map(escapeUri).join("/"), "escapeUriPath");
});
var require_dist_cjs10 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    buildQueryString: () => buildQueryString
  });
  module.exports = __toCommonJS2(src_exports);
  var import_util_uri_escape = require_dist_cjs9();
  function buildQueryString(query) {
    const parts = [];
    for (let key2 of Object.keys(query).sort()) {
      const value = query[key2];
      key2 = (0, import_util_uri_escape.escapeUri)(key2);
      if (Array.isArray(value)) {
        for (let i2 = 0, iLen = value.length;i2 < iLen; i2++) {
          parts.push(`${key2}=${(0, import_util_uri_escape.escapeUri)(value[i2])}`);
        }
      } else {
        let qsEntry = key2;
        if (value || typeof value === "string") {
          qsEntry += `=${(0, import_util_uri_escape.escapeUri)(value)}`;
        }
        parts.push(qsEntry);
      }
    }
    return parts.join("&");
  }
  __name(buildQueryString, "buildQueryString");
});
var require_dist_cjs11 = __commonJS2((exports, module) => {
  var __create22 = Object.create;
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __getProtoOf22 = Object.getPrototypeOf;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toESM22 = (mod, isNodeMode, target) => (target = mod != null ? __create22(__getProtoOf22(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp32(target, "default", { value: mod, enumerable: true }) : target, mod));
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    DEFAULT_REQUEST_TIMEOUT: () => DEFAULT_REQUEST_TIMEOUT,
    NodeHttp2Handler: () => NodeHttp2Handler,
    NodeHttpHandler: () => NodeHttpHandler,
    streamCollector: () => streamCollector
  });
  module.exports = __toCommonJS2(src_exports);
  var import_protocol_http2 = require_dist_cjs2();
  var import_querystring_builder = require_dist_cjs10();
  var import_http3 = import.meta.require("http");
  var import_https2 = import.meta.require("https");
  var NODEJS_TIMEOUT_ERROR_CODES = ["ECONNRESET", "EPIPE", "ETIMEDOUT"];
  var getTransformedHeaders = /* @__PURE__ */ __name((headers) => {
    const transformedHeaders = {};
    for (const name of Object.keys(headers)) {
      const headerValues = headers[name];
      transformedHeaders[name] = Array.isArray(headerValues) ? headerValues.join(",") : headerValues;
    }
    return transformedHeaders;
  }, "getTransformedHeaders");
  var DEFER_EVENT_LISTENER_TIME = 1000;
  var setConnectionTimeout = /* @__PURE__ */ __name((request42, reject, timeoutInMs = 0) => {
    if (!timeoutInMs) {
      return -1;
    }
    const registerTimeout = /* @__PURE__ */ __name((offset2) => {
      const timeoutId = setTimeout(() => {
        request42.destroy();
        reject(Object.assign(new Error(`Socket timed out without establishing a connection within ${timeoutInMs} ms`), {
          name: "TimeoutError"
        }));
      }, timeoutInMs - offset2);
      const doWithSocket = /* @__PURE__ */ __name((socket) => {
        if (socket == null ? undefined : socket.connecting) {
          socket.on("connect", () => {
            clearTimeout(timeoutId);
          });
        } else {
          clearTimeout(timeoutId);
        }
      }, "doWithSocket");
      if (request42.socket) {
        doWithSocket(request42.socket);
      } else {
        request42.on("socket", doWithSocket);
      }
    }, "registerTimeout");
    if (timeoutInMs < 2000) {
      registerTimeout(0);
      return 0;
    }
    return setTimeout(registerTimeout.bind(null, DEFER_EVENT_LISTENER_TIME), DEFER_EVENT_LISTENER_TIME);
  }, "setConnectionTimeout");
  var DEFER_EVENT_LISTENER_TIME2 = 3000;
  var setSocketKeepAlive = /* @__PURE__ */ __name((request42, { keepAlive, keepAliveMsecs }, deferTimeMs = DEFER_EVENT_LISTENER_TIME2) => {
    if (keepAlive !== true) {
      return -1;
    }
    const registerListener = /* @__PURE__ */ __name(() => {
      if (request42.socket) {
        request42.socket.setKeepAlive(keepAlive, keepAliveMsecs || 0);
      } else {
        request42.on("socket", (socket) => {
          socket.setKeepAlive(keepAlive, keepAliveMsecs || 0);
        });
      }
    }, "registerListener");
    if (deferTimeMs === 0) {
      registerListener();
      return 0;
    }
    return setTimeout(registerListener, deferTimeMs);
  }, "setSocketKeepAlive");
  var DEFER_EVENT_LISTENER_TIME3 = 3000;
  var setSocketTimeout = /* @__PURE__ */ __name((request42, reject, timeoutInMs = 0) => {
    const registerTimeout = /* @__PURE__ */ __name((offset2) => {
      request42.setTimeout(timeoutInMs - offset2, () => {
        request42.destroy();
        reject(Object.assign(new Error(`Connection timed out after ${timeoutInMs} ms`), { name: "TimeoutError" }));
      });
    }, "registerTimeout");
    if (0 < timeoutInMs && timeoutInMs < 6000) {
      registerTimeout(0);
      return 0;
    }
    return setTimeout(registerTimeout.bind(null, timeoutInMs === 0 ? 0 : DEFER_EVENT_LISTENER_TIME3), DEFER_EVENT_LISTENER_TIME3);
  }, "setSocketTimeout");
  var import_stream16 = import.meta.require("stream");
  var MIN_WAIT_TIME = 1000;
  async function writeRequestBody(httpRequest2, request42, maxContinueTimeoutMs = MIN_WAIT_TIME) {
    const headers = request42.headers ?? {};
    const expect = headers["Expect"] || headers["expect"];
    let timeoutId = -1;
    let hasError = false;
    if (expect === "100-continue") {
      await Promise.race([
        new Promise((resolve5) => {
          timeoutId = Number(setTimeout(resolve5, Math.max(MIN_WAIT_TIME, maxContinueTimeoutMs)));
        }),
        new Promise((resolve5) => {
          httpRequest2.on("continue", () => {
            clearTimeout(timeoutId);
            resolve5();
          });
          httpRequest2.on("error", () => {
            hasError = true;
            clearTimeout(timeoutId);
            resolve5();
          });
        })
      ]);
    }
    if (!hasError) {
      writeBody(httpRequest2, request42.body);
    }
  }
  __name(writeRequestBody, "writeRequestBody");
  function writeBody(httpRequest2, body) {
    if (body instanceof import_stream16.Readable) {
      body.pipe(httpRequest2);
      return;
    }
    if (body) {
      if (Buffer.isBuffer(body) || typeof body === "string") {
        httpRequest2.end(body);
        return;
      }
      const uint8 = body;
      if (typeof uint8 === "object" && uint8.buffer && typeof uint8.byteOffset === "number" && typeof uint8.byteLength === "number") {
        httpRequest2.end(Buffer.from(uint8.buffer, uint8.byteOffset, uint8.byteLength));
        return;
      }
      httpRequest2.end(Buffer.from(body));
      return;
    }
    httpRequest2.end();
  }
  __name(writeBody, "writeBody");
  var DEFAULT_REQUEST_TIMEOUT = 0;
  var _NodeHttpHandler = class _NodeHttpHandler2 {
    constructor(options3) {
      this.socketWarningTimestamp = 0;
      this.metadata = { handlerProtocol: "http/1.1" };
      this.configProvider = new Promise((resolve5, reject) => {
        if (typeof options3 === "function") {
          options3().then((_options) => {
            resolve5(this.resolveDefaultConfig(_options));
          }).catch(reject);
        } else {
          resolve5(this.resolveDefaultConfig(options3));
        }
      });
    }
    static create(instanceOrOptions) {
      if (typeof (instanceOrOptions == null ? undefined : instanceOrOptions.handle) === "function") {
        return instanceOrOptions;
      }
      return new _NodeHttpHandler2(instanceOrOptions);
    }
    static checkSocketUsage(agent, socketWarningTimestamp, logger22 = console) {
      var _a, _b, _c;
      const { sockets, requests, maxSockets } = agent;
      if (typeof maxSockets !== "number" || maxSockets === Infinity) {
        return socketWarningTimestamp;
      }
      const interval = 15000;
      if (Date.now() - interval < socketWarningTimestamp) {
        return socketWarningTimestamp;
      }
      if (sockets && requests) {
        for (const origin in sockets) {
          const socketsInUse = ((_a = sockets[origin]) == null ? undefined : _a.length) ?? 0;
          const requestsEnqueued = ((_b = requests[origin]) == null ? undefined : _b.length) ?? 0;
          if (socketsInUse >= maxSockets && requestsEnqueued >= 2 * maxSockets) {
            (_c = logger22 == null ? undefined : logger22.warn) == null || _c.call(logger22, `@smithy/node-http-handler:WARN - socket usage at capacity=${socketsInUse} and ${requestsEnqueued} additional requests are enqueued.
See https://docs.aws.amazon.com/sdk-for-javascript/v3/developer-guide/node-configuring-maxsockets.html
or increase socketAcquisitionWarningTimeout=(millis) in the NodeHttpHandler config.`);
            return Date.now();
          }
        }
      }
      return socketWarningTimestamp;
    }
    resolveDefaultConfig(options3) {
      const { requestTimeout, connectionTimeout, socketTimeout, httpAgent, httpsAgent } = options3 || {};
      const keepAlive = true;
      const maxSockets = 50;
      return {
        connectionTimeout,
        requestTimeout: requestTimeout ?? socketTimeout,
        httpAgent: (() => {
          if (httpAgent instanceof import_http3.Agent || typeof (httpAgent == null ? undefined : httpAgent.destroy) === "function") {
            return httpAgent;
          }
          return new import_http3.Agent({ keepAlive, maxSockets, ...httpAgent });
        })(),
        httpsAgent: (() => {
          if (httpsAgent instanceof import_https2.Agent || typeof (httpsAgent == null ? undefined : httpsAgent.destroy) === "function") {
            return httpsAgent;
          }
          return new import_https2.Agent({ keepAlive, maxSockets, ...httpsAgent });
        })(),
        logger: console
      };
    }
    destroy() {
      var _a, _b, _c, _d;
      (_b = (_a = this.config) == null ? undefined : _a.httpAgent) == null || _b.destroy();
      (_d = (_c = this.config) == null ? undefined : _c.httpsAgent) == null || _d.destroy();
    }
    async handle(request42, { abortSignal } = {}) {
      if (!this.config) {
        this.config = await this.configProvider;
      }
      return new Promise((_resolve, _reject) => {
        let writeRequestBodyPromise = undefined;
        const timeouts = [];
        const resolve5 = /* @__PURE__ */ __name(async (arg) => {
          await writeRequestBodyPromise;
          timeouts.forEach(clearTimeout);
          _resolve(arg);
        }, "resolve");
        const reject = /* @__PURE__ */ __name(async (arg) => {
          await writeRequestBodyPromise;
          timeouts.forEach(clearTimeout);
          _reject(arg);
        }, "reject");
        if (!this.config) {
          throw new Error("Node HTTP request handler config is not resolved");
        }
        if (abortSignal == null ? undefined : abortSignal.aborted) {
          const abortError = new Error("Request aborted");
          abortError.name = "AbortError";
          reject(abortError);
          return;
        }
        const isSSL = request42.protocol === "https:";
        const agent = isSSL ? this.config.httpsAgent : this.config.httpAgent;
        timeouts.push(setTimeout(() => {
          this.socketWarningTimestamp = _NodeHttpHandler2.checkSocketUsage(agent, this.socketWarningTimestamp, this.config.logger);
        }, this.config.socketAcquisitionWarningTimeout ?? (this.config.requestTimeout ?? 2000) + (this.config.connectionTimeout ?? 1000)));
        const queryString = (0, import_querystring_builder.buildQueryString)(request42.query || {});
        let auth = undefined;
        if (request42.username != null || request42.password != null) {
          const username = request42.username ?? "";
          const password = request42.password ?? "";
          auth = `${username}:${password}`;
        }
        let path5 = request42.path;
        if (queryString) {
          path5 += `?${queryString}`;
        }
        if (request42.fragment) {
          path5 += `#${request42.fragment}`;
        }
        let hostname = request42.hostname ?? "";
        if (hostname[0] === "[" && hostname.endsWith("]")) {
          hostname = request42.hostname.slice(1, -1);
        } else {
          hostname = request42.hostname;
        }
        const nodeHttpsOptions = {
          headers: request42.headers,
          host: hostname,
          method: request42.method,
          path: path5,
          port: request42.port,
          agent,
          auth
        };
        const requestFunc = isSSL ? import_https2.request : import_http3.request;
        const req = requestFunc(nodeHttpsOptions, (res) => {
          const httpResponse2 = new import_protocol_http2.HttpResponse({
            statusCode: res.statusCode || -1,
            reason: res.statusMessage,
            headers: getTransformedHeaders(res.headers),
            body: res
          });
          resolve5({ response: httpResponse2 });
        });
        req.on("error", (err22) => {
          if (NODEJS_TIMEOUT_ERROR_CODES.includes(err22.code)) {
            reject(Object.assign(err22, { name: "TimeoutError" }));
          } else {
            reject(err22);
          }
        });
        if (abortSignal) {
          const onAbort = /* @__PURE__ */ __name(() => {
            req.destroy();
            const abortError = new Error("Request aborted");
            abortError.name = "AbortError";
            reject(abortError);
          }, "onAbort");
          if (typeof abortSignal.addEventListener === "function") {
            const signal = abortSignal;
            signal.addEventListener("abort", onAbort, { once: true });
            req.once("close", () => signal.removeEventListener("abort", onAbort));
          } else {
            abortSignal.onabort = onAbort;
          }
        }
        timeouts.push(setConnectionTimeout(req, reject, this.config.connectionTimeout));
        timeouts.push(setSocketTimeout(req, reject, this.config.requestTimeout));
        const httpAgent = nodeHttpsOptions.agent;
        if (typeof httpAgent === "object" && "keepAlive" in httpAgent) {
          timeouts.push(setSocketKeepAlive(req, {
            keepAlive: httpAgent.keepAlive,
            keepAliveMsecs: httpAgent.keepAliveMsecs
          }));
        }
        writeRequestBodyPromise = writeRequestBody(req, request42, this.config.requestTimeout).catch((e) => {
          timeouts.forEach(clearTimeout);
          return _reject(e);
        });
      });
    }
    updateHttpClientConfig(key2, value) {
      this.config = undefined;
      this.configProvider = this.configProvider.then((config6) => {
        return {
          ...config6,
          [key2]: value
        };
      });
    }
    httpHandlerConfigs() {
      return this.config ?? {};
    }
  };
  __name(_NodeHttpHandler, "NodeHttpHandler");
  var NodeHttpHandler = _NodeHttpHandler;
  var import_http22 = import.meta.require("http2");
  var import_http23 = __toESM22(import.meta.require("http2"));
  var _NodeHttp2ConnectionPool = class _NodeHttp2ConnectionPool2 {
    constructor(sessions) {
      this.sessions = [];
      this.sessions = sessions ?? [];
    }
    poll() {
      if (this.sessions.length > 0) {
        return this.sessions.shift();
      }
    }
    offerLast(session) {
      this.sessions.push(session);
    }
    contains(session) {
      return this.sessions.includes(session);
    }
    remove(session) {
      this.sessions = this.sessions.filter((s32) => s32 !== session);
    }
    [Symbol.iterator]() {
      return this.sessions[Symbol.iterator]();
    }
    destroy(connection) {
      for (const session of this.sessions) {
        if (session === connection) {
          if (!session.destroyed) {
            session.destroy();
          }
        }
      }
    }
  };
  __name(_NodeHttp2ConnectionPool, "NodeHttp2ConnectionPool");
  var NodeHttp2ConnectionPool = _NodeHttp2ConnectionPool;
  var _NodeHttp2ConnectionManager = class _NodeHttp2ConnectionManager2 {
    constructor(config6) {
      this.sessionCache = /* @__PURE__ */ new Map;
      this.config = config6;
      if (this.config.maxConcurrency && this.config.maxConcurrency <= 0) {
        throw new RangeError("maxConcurrency must be greater than zero.");
      }
    }
    lease(requestContext, connectionConfiguration) {
      const url = this.getUrlString(requestContext);
      const existingPool = this.sessionCache.get(url);
      if (existingPool) {
        const existingSession = existingPool.poll();
        if (existingSession && !this.config.disableConcurrency) {
          return existingSession;
        }
      }
      const session = import_http23.default.connect(url);
      if (this.config.maxConcurrency) {
        session.settings({ maxConcurrentStreams: this.config.maxConcurrency }, (err22) => {
          if (err22) {
            throw new Error("Fail to set maxConcurrentStreams to " + this.config.maxConcurrency + "when creating new session for " + requestContext.destination.toString());
          }
        });
      }
      session.unref();
      const destroySessionCb = /* @__PURE__ */ __name(() => {
        session.destroy();
        this.deleteSession(url, session);
      }, "destroySessionCb");
      session.on("goaway", destroySessionCb);
      session.on("error", destroySessionCb);
      session.on("frameError", destroySessionCb);
      session.on("close", () => this.deleteSession(url, session));
      if (connectionConfiguration.requestTimeout) {
        session.setTimeout(connectionConfiguration.requestTimeout, destroySessionCb);
      }
      const connectionPool = this.sessionCache.get(url) || new NodeHttp2ConnectionPool;
      connectionPool.offerLast(session);
      this.sessionCache.set(url, connectionPool);
      return session;
    }
    deleteSession(authority, session) {
      const existingConnectionPool = this.sessionCache.get(authority);
      if (!existingConnectionPool) {
        return;
      }
      if (!existingConnectionPool.contains(session)) {
        return;
      }
      existingConnectionPool.remove(session);
      this.sessionCache.set(authority, existingConnectionPool);
    }
    release(requestContext, session) {
      var _a;
      const cacheKey = this.getUrlString(requestContext);
      (_a = this.sessionCache.get(cacheKey)) == null || _a.offerLast(session);
    }
    destroy() {
      for (const [key2, connectionPool] of this.sessionCache) {
        for (const session of connectionPool) {
          if (!session.destroyed) {
            session.destroy();
          }
          connectionPool.remove(session);
        }
        this.sessionCache.delete(key2);
      }
    }
    setMaxConcurrentStreams(maxConcurrentStreams) {
      if (this.config.maxConcurrency && this.config.maxConcurrency <= 0) {
        throw new RangeError("maxConcurrentStreams must be greater than zero.");
      }
      this.config.maxConcurrency = maxConcurrentStreams;
    }
    setDisableConcurrentStreams(disableConcurrentStreams) {
      this.config.disableConcurrency = disableConcurrentStreams;
    }
    getUrlString(request42) {
      return request42.destination.toString();
    }
  };
  __name(_NodeHttp2ConnectionManager, "NodeHttp2ConnectionManager");
  var NodeHttp2ConnectionManager = _NodeHttp2ConnectionManager;
  var _NodeHttp2Handler = class _NodeHttp2Handler2 {
    constructor(options3) {
      this.metadata = { handlerProtocol: "h2" };
      this.connectionManager = new NodeHttp2ConnectionManager({});
      this.configProvider = new Promise((resolve5, reject) => {
        if (typeof options3 === "function") {
          options3().then((opts) => {
            resolve5(opts || {});
          }).catch(reject);
        } else {
          resolve5(options3 || {});
        }
      });
    }
    static create(instanceOrOptions) {
      if (typeof (instanceOrOptions == null ? undefined : instanceOrOptions.handle) === "function") {
        return instanceOrOptions;
      }
      return new _NodeHttp2Handler2(instanceOrOptions);
    }
    destroy() {
      this.connectionManager.destroy();
    }
    async handle(request42, { abortSignal } = {}) {
      if (!this.config) {
        this.config = await this.configProvider;
        this.connectionManager.setDisableConcurrentStreams(this.config.disableConcurrentStreams || false);
        if (this.config.maxConcurrentStreams) {
          this.connectionManager.setMaxConcurrentStreams(this.config.maxConcurrentStreams);
        }
      }
      const { requestTimeout, disableConcurrentStreams } = this.config;
      return new Promise((_resolve, _reject) => {
        var _a;
        let fulfilled = false;
        let writeRequestBodyPromise = undefined;
        const resolve5 = /* @__PURE__ */ __name(async (arg) => {
          await writeRequestBodyPromise;
          _resolve(arg);
        }, "resolve");
        const reject = /* @__PURE__ */ __name(async (arg) => {
          await writeRequestBodyPromise;
          _reject(arg);
        }, "reject");
        if (abortSignal == null ? undefined : abortSignal.aborted) {
          fulfilled = true;
          const abortError = new Error("Request aborted");
          abortError.name = "AbortError";
          reject(abortError);
          return;
        }
        const { hostname, method, port, protocol, query } = request42;
        let auth = "";
        if (request42.username != null || request42.password != null) {
          const username = request42.username ?? "";
          const password = request42.password ?? "";
          auth = `${username}:${password}@`;
        }
        const authority = `${protocol}//${auth}${hostname}${port ? `:${port}` : ""}`;
        const requestContext = { destination: new URL(authority) };
        const session = this.connectionManager.lease(requestContext, {
          requestTimeout: (_a = this.config) == null ? undefined : _a.sessionTimeout,
          disableConcurrentStreams: disableConcurrentStreams || false
        });
        const rejectWithDestroy = /* @__PURE__ */ __name((err22) => {
          if (disableConcurrentStreams) {
            this.destroySession(session);
          }
          fulfilled = true;
          reject(err22);
        }, "rejectWithDestroy");
        const queryString = (0, import_querystring_builder.buildQueryString)(query || {});
        let path5 = request42.path;
        if (queryString) {
          path5 += `?${queryString}`;
        }
        if (request42.fragment) {
          path5 += `#${request42.fragment}`;
        }
        const req = session.request({
          ...request42.headers,
          [import_http22.constants.HTTP2_HEADER_PATH]: path5,
          [import_http22.constants.HTTP2_HEADER_METHOD]: method
        });
        session.ref();
        req.on("response", (headers) => {
          const httpResponse2 = new import_protocol_http2.HttpResponse({
            statusCode: headers[":status"] || -1,
            headers: getTransformedHeaders(headers),
            body: req
          });
          fulfilled = true;
          resolve5({ response: httpResponse2 });
          if (disableConcurrentStreams) {
            session.close();
            this.connectionManager.deleteSession(authority, session);
          }
        });
        if (requestTimeout) {
          req.setTimeout(requestTimeout, () => {
            req.close();
            const timeoutError = new Error(`Stream timed out because of no activity for ${requestTimeout} ms`);
            timeoutError.name = "TimeoutError";
            rejectWithDestroy(timeoutError);
          });
        }
        if (abortSignal) {
          const onAbort = /* @__PURE__ */ __name(() => {
            req.close();
            const abortError = new Error("Request aborted");
            abortError.name = "AbortError";
            rejectWithDestroy(abortError);
          }, "onAbort");
          if (typeof abortSignal.addEventListener === "function") {
            const signal = abortSignal;
            signal.addEventListener("abort", onAbort, { once: true });
            req.once("close", () => signal.removeEventListener("abort", onAbort));
          } else {
            abortSignal.onabort = onAbort;
          }
        }
        req.on("frameError", (type2, code, id) => {
          rejectWithDestroy(new Error(`Frame type id ${type2} in stream id ${id} has failed with code ${code}.`));
        });
        req.on("error", rejectWithDestroy);
        req.on("aborted", () => {
          rejectWithDestroy(new Error(`HTTP/2 stream is abnormally aborted in mid-communication with result code ${req.rstCode}.`));
        });
        req.on("close", () => {
          session.unref();
          if (disableConcurrentStreams) {
            session.destroy();
          }
          if (!fulfilled) {
            rejectWithDestroy(new Error("Unexpected error: http2 request did not get a response"));
          }
        });
        writeRequestBodyPromise = writeRequestBody(req, request42, requestTimeout);
      });
    }
    updateHttpClientConfig(key2, value) {
      this.config = undefined;
      this.configProvider = this.configProvider.then((config6) => {
        return {
          ...config6,
          [key2]: value
        };
      });
    }
    httpHandlerConfigs() {
      return this.config ?? {};
    }
    destroySession(session) {
      if (!session.destroyed) {
        session.destroy();
      }
    }
  };
  __name(_NodeHttp2Handler, "NodeHttp2Handler");
  var NodeHttp2Handler = _NodeHttp2Handler;
  var _Collector = class _Collector2 extends import_stream16.Writable {
    constructor() {
      super(...arguments);
      this.bufferedBytes = [];
    }
    _write(chunk, encoding, callback) {
      this.bufferedBytes.push(chunk);
      callback();
    }
  };
  __name(_Collector, "Collector");
  var Collector = _Collector;
  var streamCollector = /* @__PURE__ */ __name((stream2) => {
    if (isReadableStreamInstance(stream2)) {
      return collectReadableStream(stream2);
    }
    return new Promise((resolve5, reject) => {
      const collector = new Collector;
      stream2.pipe(collector);
      stream2.on("error", (err22) => {
        collector.end();
        reject(err22);
      });
      collector.on("error", reject);
      collector.on("finish", function() {
        const bytes = new Uint8Array(Buffer.concat(this.bufferedBytes));
        resolve5(bytes);
      });
    });
  }, "streamCollector");
  var isReadableStreamInstance = /* @__PURE__ */ __name((stream2) => typeof ReadableStream === "function" && stream2 instanceof ReadableStream, "isReadableStreamInstance");
  async function collectReadableStream(stream2) {
    const chunks = [];
    const reader = stream2.getReader();
    let isDone = false;
    let length = 0;
    while (!isDone) {
      const { done, value } = await reader.read();
      if (value) {
        chunks.push(value);
        length += value.length;
      }
      isDone = done;
    }
    const collected = new Uint8Array(length);
    let offset2 = 0;
    for (const chunk of chunks) {
      collected.set(chunk, offset2);
      offset2 += chunk.length;
    }
    return collected;
  }
  __name(collectReadableStream, "collectReadableStream");
});
var require_dist_cjs12 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    FetchHttpHandler: () => FetchHttpHandler,
    keepAliveSupport: () => keepAliveSupport,
    streamCollector: () => streamCollector
  });
  module.exports = __toCommonJS2(src_exports);
  var import_protocol_http2 = require_dist_cjs2();
  var import_querystring_builder = require_dist_cjs10();
  function requestTimeout(timeoutInMs = 0) {
    return new Promise((resolve5, reject) => {
      if (timeoutInMs) {
        setTimeout(() => {
          const timeoutError = new Error(`Request did not complete within ${timeoutInMs} ms`);
          timeoutError.name = "TimeoutError";
          reject(timeoutError);
        }, timeoutInMs);
      }
    });
  }
  __name(requestTimeout, "requestTimeout");
  var keepAliveSupport = {
    supported: undefined
  };
  var _FetchHttpHandler = class _FetchHttpHandler2 {
    static create(instanceOrOptions) {
      if (typeof (instanceOrOptions == null ? undefined : instanceOrOptions.handle) === "function") {
        return instanceOrOptions;
      }
      return new _FetchHttpHandler2(instanceOrOptions);
    }
    constructor(options3) {
      if (typeof options3 === "function") {
        this.configProvider = options3().then((opts) => opts || {});
      } else {
        this.config = options3 ?? {};
        this.configProvider = Promise.resolve(this.config);
      }
      if (keepAliveSupport.supported === undefined) {
        keepAliveSupport.supported = Boolean(typeof Request !== "undefined" && "keepalive" in new Request("https://[::1]"));
      }
    }
    destroy() {
    }
    async handle(request42, { abortSignal } = {}) {
      var _a;
      if (!this.config) {
        this.config = await this.configProvider;
      }
      const requestTimeoutInMs = this.config.requestTimeout;
      const keepAlive = this.config.keepAlive === true;
      const credentials = this.config.credentials;
      if (abortSignal == null ? undefined : abortSignal.aborted) {
        const abortError = new Error("Request aborted");
        abortError.name = "AbortError";
        return Promise.reject(abortError);
      }
      let path5 = request42.path;
      const queryString = (0, import_querystring_builder.buildQueryString)(request42.query || {});
      if (queryString) {
        path5 += `?${queryString}`;
      }
      if (request42.fragment) {
        path5 += `#${request42.fragment}`;
      }
      let auth = "";
      if (request42.username != null || request42.password != null) {
        const username = request42.username ?? "";
        const password = request42.password ?? "";
        auth = `${username}:${password}@`;
      }
      const { port, method } = request42;
      const url = `${request42.protocol}//${auth}${request42.hostname}${port ? `:${port}` : ""}${path5}`;
      const body = method === "GET" || method === "HEAD" ? undefined : request42.body;
      const requestOptions = {
        body,
        headers: new Headers(request42.headers),
        method,
        credentials
      };
      if ((_a = this.config) == null ? undefined : _a.cache) {
        requestOptions.cache = this.config.cache;
      }
      if (body) {
        requestOptions.duplex = "half";
      }
      if (typeof AbortController !== "undefined") {
        requestOptions.signal = abortSignal;
      }
      if (keepAliveSupport.supported) {
        requestOptions.keepalive = keepAlive;
      }
      if (typeof this.config.requestInit === "function") {
        Object.assign(requestOptions, this.config.requestInit(request42));
      }
      let removeSignalEventListener = /* @__PURE__ */ __name(() => {
      }, "removeSignalEventListener");
      const fetchRequest = new Request(url, requestOptions);
      const raceOfPromises = [
        fetch(fetchRequest).then((response) => {
          const fetchHeaders = response.headers;
          const transformedHeaders = {};
          for (const pair of fetchHeaders.entries()) {
            transformedHeaders[pair[0]] = pair[1];
          }
          const hasReadableStream = response.body != null;
          if (!hasReadableStream) {
            return response.blob().then((body2) => ({
              response: new import_protocol_http2.HttpResponse({
                headers: transformedHeaders,
                reason: response.statusText,
                statusCode: response.status,
                body: body2
              })
            }));
          }
          return {
            response: new import_protocol_http2.HttpResponse({
              headers: transformedHeaders,
              reason: response.statusText,
              statusCode: response.status,
              body: response.body
            })
          };
        }),
        requestTimeout(requestTimeoutInMs)
      ];
      if (abortSignal) {
        raceOfPromises.push(new Promise((resolve5, reject) => {
          const onAbort = /* @__PURE__ */ __name(() => {
            const abortError = new Error("Request aborted");
            abortError.name = "AbortError";
            reject(abortError);
          }, "onAbort");
          if (typeof abortSignal.addEventListener === "function") {
            const signal = abortSignal;
            signal.addEventListener("abort", onAbort, { once: true });
            removeSignalEventListener = /* @__PURE__ */ __name(() => signal.removeEventListener("abort", onAbort), "removeSignalEventListener");
          } else {
            abortSignal.onabort = onAbort;
          }
        }));
      }
      return Promise.race(raceOfPromises).finally(removeSignalEventListener);
    }
    updateHttpClientConfig(key2, value) {
      this.config = undefined;
      this.configProvider = this.configProvider.then((config6) => {
        config6[key2] = value;
        return config6;
      });
    }
    httpHandlerConfigs() {
      return this.config ?? {};
    }
  };
  __name(_FetchHttpHandler, "FetchHttpHandler");
  var FetchHttpHandler = _FetchHttpHandler;
  var streamCollector = /* @__PURE__ */ __name(async (stream2) => {
    if (typeof Blob === "function" && stream2 instanceof Blob) {
      return new Uint8Array(await stream2.arrayBuffer());
    }
    return collectStream(stream2);
  }, "streamCollector");
  async function collectStream(stream2) {
    const chunks = [];
    const reader = stream2.getReader();
    let isDone = false;
    let length = 0;
    while (!isDone) {
      const { done, value } = await reader.read();
      if (value) {
        chunks.push(value);
        length += value.length;
      }
      isDone = done;
    }
    const collected = new Uint8Array(length);
    let offset2 = 0;
    for (const chunk of chunks) {
      collected.set(chunk, offset2);
      offset2 += chunk.length;
    }
    return collected;
  }
  __name(collectStream, "collectStream");
});
var require_dist_cjs13 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    fromHex: () => fromHex,
    toHex: () => toHex
  });
  module.exports = __toCommonJS2(src_exports);
  var SHORT_TO_HEX = {};
  var HEX_TO_SHORT = {};
  for (let i2 = 0;i2 < 256; i2++) {
    let encodedByte = i2.toString(16).toLowerCase();
    if (encodedByte.length === 1) {
      encodedByte = `0${encodedByte}`;
    }
    SHORT_TO_HEX[i2] = encodedByte;
    HEX_TO_SHORT[encodedByte] = i2;
  }
  function fromHex(encoded) {
    if (encoded.length % 2 !== 0) {
      throw new Error("Hex encoded strings must have an even number length");
    }
    const out = new Uint8Array(encoded.length / 2);
    for (let i2 = 0;i2 < encoded.length; i2 += 2) {
      const encodedByte = encoded.slice(i2, i2 + 2).toLowerCase();
      if (encodedByte in HEX_TO_SHORT) {
        out[i2 / 2] = HEX_TO_SHORT[encodedByte];
      } else {
        throw new Error(`Cannot decode unrecognized sequence ${encodedByte} as hexadecimal`);
      }
    }
    return out;
  }
  __name(fromHex, "fromHex");
  function toHex(bytes) {
    let out = "";
    for (let i2 = 0;i2 < bytes.byteLength; i2++) {
      out += SHORT_TO_HEX[bytes[i2]];
    }
    return out;
  }
  __name(toHex, "toHex");
});
var require_stream_type_check = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.isReadableStream = undefined;
  var isReadableStream2 = (stream2) => {
    var _a;
    return typeof ReadableStream === "function" && (((_a = stream2 === null || stream2 === undefined ? undefined : stream2.constructor) === null || _a === undefined ? undefined : _a.name) === ReadableStream.name || stream2 instanceof ReadableStream);
  };
  exports.isReadableStream = isReadableStream2;
});
var require_sdk_stream_mixin_browser = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.sdkStreamMixin = undefined;
  var fetch_http_handler_1 = require_dist_cjs12();
  var util_base64_1 = require_dist_cjs8();
  var util_hex_encoding_1 = require_dist_cjs13();
  var util_utf8_1 = require_dist_cjs7();
  var stream_type_check_1 = require_stream_type_check();
  var ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED = "The stream has already been transformed.";
  var sdkStreamMixin2 = (stream2) => {
    var _a, _b;
    if (!isBlobInstance(stream2) && !(0, stream_type_check_1.isReadableStream)(stream2)) {
      const name = ((_b = (_a = stream2 === null || stream2 === undefined ? undefined : stream2.__proto__) === null || _a === undefined ? undefined : _a.constructor) === null || _b === undefined ? undefined : _b.name) || stream2;
      throw new Error(`Unexpected stream implementation, expect Blob or ReadableStream, got ${name}`);
    }
    let transformed = false;
    const transformToByteArray = async () => {
      if (transformed) {
        throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED);
      }
      transformed = true;
      return await (0, fetch_http_handler_1.streamCollector)(stream2);
    };
    const blobToWebStream = (blob) => {
      if (typeof blob.stream !== "function") {
        throw new Error("Cannot transform payload Blob to web stream. Please make sure the Blob.stream() is polyfilled.\nIf you are using React Native, this API is not yet supported, see: https://react-native.canny.io/feature-requests/p/fetch-streaming-body");
      }
      return blob.stream();
    };
    return Object.assign(stream2, {
      transformToByteArray,
      transformToString: async (encoding) => {
        const buf = await transformToByteArray();
        if (encoding === "base64") {
          return (0, util_base64_1.toBase64)(buf);
        } else if (encoding === "hex") {
          return (0, util_hex_encoding_1.toHex)(buf);
        } else if (encoding === undefined || encoding === "utf8" || encoding === "utf-8") {
          return (0, util_utf8_1.toUtf8)(buf);
        } else if (typeof TextDecoder === "function") {
          return new TextDecoder(encoding).decode(buf);
        } else {
          throw new Error("TextDecoder is not available, please make sure polyfill is provided.");
        }
      },
      transformToWebStream: () => {
        if (transformed) {
          throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED);
        }
        transformed = true;
        if (isBlobInstance(stream2)) {
          return blobToWebStream(stream2);
        } else if ((0, stream_type_check_1.isReadableStream)(stream2)) {
          return stream2;
        } else {
          throw new Error(`Cannot transform payload to web stream, got ${stream2}`);
        }
      }
    });
  };
  exports.sdkStreamMixin = sdkStreamMixin2;
  var isBlobInstance = (stream2) => typeof Blob === "function" && stream2 instanceof Blob;
});
var require_sdk_stream_mixin = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.sdkStreamMixin = undefined;
  var node_http_handler_1 = require_dist_cjs11();
  var util_buffer_from_1 = require_dist_cjs6();
  var stream_1 = import.meta.require("stream");
  var util_1 = import.meta.require("util");
  var sdk_stream_mixin_browser_1 = require_sdk_stream_mixin_browser();
  var ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED = "The stream has already been transformed.";
  var sdkStreamMixin2 = (stream2) => {
    var _a, _b;
    if (!(stream2 instanceof stream_1.Readable)) {
      try {
        return (0, sdk_stream_mixin_browser_1.sdkStreamMixin)(stream2);
      } catch (e) {
        const name = ((_b = (_a = stream2 === null || stream2 === undefined ? undefined : stream2.__proto__) === null || _a === undefined ? undefined : _a.constructor) === null || _b === undefined ? undefined : _b.name) || stream2;
        throw new Error(`Unexpected stream implementation, expect Stream.Readable instance, got ${name}`);
      }
    }
    let transformed = false;
    const transformToByteArray = async () => {
      if (transformed) {
        throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED);
      }
      transformed = true;
      return await (0, node_http_handler_1.streamCollector)(stream2);
    };
    return Object.assign(stream2, {
      transformToByteArray,
      transformToString: async (encoding) => {
        const buf = await transformToByteArray();
        if (encoding === undefined || Buffer.isEncoding(encoding)) {
          return (0, util_buffer_from_1.fromArrayBuffer)(buf.buffer, buf.byteOffset, buf.byteLength).toString(encoding);
        } else {
          const decoder = new util_1.TextDecoder(encoding);
          return decoder.decode(buf);
        }
      },
      transformToWebStream: () => {
        if (transformed) {
          throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED);
        }
        if (stream2.readableFlowing !== null) {
          throw new Error("The stream has been consumed by other callbacks.");
        }
        if (typeof stream_1.Readable.toWeb !== "function") {
          throw new Error("Readable.toWeb() is not supported. Please make sure you are using Node.js >= 17.0.0, or polyfill is available.");
        }
        transformed = true;
        return stream_1.Readable.toWeb(stream2);
      }
    });
  };
  exports.sdkStreamMixin = sdkStreamMixin2;
});
var require_splitStream_browser = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.splitStream = undefined;
  async function splitStream2(stream2) {
    if (typeof stream2.stream === "function") {
      stream2 = stream2.stream();
    }
    const readableStream = stream2;
    return readableStream.tee();
  }
  exports.splitStream = splitStream2;
});
var require_splitStream = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.splitStream = undefined;
  var stream_1 = import.meta.require("stream");
  var splitStream_browser_1 = require_splitStream_browser();
  var stream_type_check_1 = require_stream_type_check();
  async function splitStream2(stream2) {
    if ((0, stream_type_check_1.isReadableStream)(stream2)) {
      return (0, splitStream_browser_1.splitStream)(stream2);
    }
    const stream1 = new stream_1.PassThrough;
    const stream22 = new stream_1.PassThrough;
    stream2.pipe(stream1);
    stream2.pipe(stream22);
    return [stream1, stream22];
  }
  exports.splitStream = splitStream2;
});
var require_headStream_browser = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.headStream = undefined;
  async function headStream2(stream2, bytes) {
    var _a;
    let byteLengthCounter = 0;
    const chunks = [];
    const reader = stream2.getReader();
    let isDone = false;
    while (!isDone) {
      const { done, value } = await reader.read();
      if (value) {
        chunks.push(value);
        byteLengthCounter += (_a = value === null || value === undefined ? undefined : value.byteLength) !== null && _a !== undefined ? _a : 0;
      }
      if (byteLengthCounter >= bytes) {
        break;
      }
      isDone = done;
    }
    reader.releaseLock();
    const collected = new Uint8Array(Math.min(bytes, byteLengthCounter));
    let offset2 = 0;
    for (const chunk of chunks) {
      if (chunk.byteLength > collected.byteLength - offset2) {
        collected.set(chunk.subarray(0, collected.byteLength - offset2), offset2);
        break;
      } else {
        collected.set(chunk, offset2);
      }
      offset2 += chunk.length;
    }
    return collected;
  }
  exports.headStream = headStream2;
});
var require_headStream = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.headStream = undefined;
  var stream_1 = import.meta.require("stream");
  var headStream_browser_1 = require_headStream_browser();
  var stream_type_check_1 = require_stream_type_check();
  var headStream2 = (stream2, bytes) => {
    if ((0, stream_type_check_1.isReadableStream)(stream2)) {
      return (0, headStream_browser_1.headStream)(stream2, bytes);
    }
    return new Promise((resolve5, reject) => {
      const collector = new Collector;
      collector.limit = bytes;
      stream2.pipe(collector);
      stream2.on("error", (err22) => {
        collector.end();
        reject(err22);
      });
      collector.on("error", reject);
      collector.on("finish", function() {
        const bytes2 = new Uint8Array(Buffer.concat(this.buffers));
        resolve5(bytes2);
      });
    });
  };
  exports.headStream = headStream2;

  class Collector extends stream_1.Writable {
    constructor() {
      super(...arguments);
      this.buffers = [];
      this.limit = Infinity;
      this.bytesBuffered = 0;
    }
    _write(chunk, encoding, callback) {
      var _a;
      this.buffers.push(chunk);
      this.bytesBuffered += (_a = chunk.byteLength) !== null && _a !== undefined ? _a : 0;
      if (this.bytesBuffered >= this.limit) {
        const excess = this.bytesBuffered - this.limit;
        const tailBuffer = this.buffers[this.buffers.length - 1];
        this.buffers[this.buffers.length - 1] = tailBuffer.subarray(0, tailBuffer.byteLength - excess);
        this.emit("finish");
      }
      callback();
    }
  }
});
var require_ChecksumStream = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.ChecksumStream = undefined;
  var util_base64_1 = require_dist_cjs8();
  var stream_1 = import.meta.require("stream");

  class ChecksumStream2 extends stream_1.Duplex {
    constructor({ expectedChecksum, checksum, source, checksumSourceLocation, base64Encoder }) {
      var _a, _b;
      super();
      if (typeof source.pipe === "function") {
        this.source = source;
      } else {
        throw new Error(`@smithy/util-stream: unsupported source type ${(_b = (_a = source === null || source === undefined ? undefined : source.constructor) === null || _a === undefined ? undefined : _a.name) !== null && _b !== undefined ? _b : source} in ChecksumStream.`);
      }
      this.base64Encoder = base64Encoder !== null && base64Encoder !== undefined ? base64Encoder : util_base64_1.toBase64;
      this.expectedChecksum = expectedChecksum;
      this.checksum = checksum;
      this.checksumSourceLocation = checksumSourceLocation;
      this.source.pipe(this);
    }
    _read(size) {
    }
    _write(chunk, encoding, callback) {
      try {
        this.checksum.update(chunk);
        this.push(chunk);
      } catch (e) {
        return callback(e);
      }
      return callback();
    }
    async _final(callback) {
      try {
        const digest = await this.checksum.digest();
        const received = this.base64Encoder(digest);
        if (this.expectedChecksum !== received) {
          return callback(new Error(`Checksum mismatch: expected "${this.expectedChecksum}" but received "${received}" in response header "${this.checksumSourceLocation}".`));
        }
      } catch (e) {
        return callback(e);
      }
      this.push(null);
      return callback();
    }
  }
  exports.ChecksumStream = ChecksumStream2;
});
var require_ChecksumStream_browser = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.ChecksumStream = undefined;
  var ReadableStreamRef = typeof ReadableStream === "function" ? ReadableStream : function() {
  };

  class ChecksumStream2 extends ReadableStreamRef {
  }
  exports.ChecksumStream = ChecksumStream2;
});
var require_createChecksumStream_browser = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.createChecksumStream = undefined;
  var util_base64_1 = require_dist_cjs8();
  var stream_type_check_1 = require_stream_type_check();
  var ChecksumStream_browser_1 = require_ChecksumStream_browser();
  var createChecksumStream2 = ({ expectedChecksum, checksum, source, checksumSourceLocation, base64Encoder }) => {
    var _a, _b;
    if (!(0, stream_type_check_1.isReadableStream)(source)) {
      throw new Error(`@smithy/util-stream: unsupported source type ${(_b = (_a = source === null || source === undefined ? undefined : source.constructor) === null || _a === undefined ? undefined : _a.name) !== null && _b !== undefined ? _b : source} in ChecksumStream.`);
    }
    const encoder = base64Encoder !== null && base64Encoder !== undefined ? base64Encoder : util_base64_1.toBase64;
    if (typeof TransformStream !== "function") {
      throw new Error("@smithy/util-stream: unable to instantiate ChecksumStream because API unavailable: ReadableStream/TransformStream.");
    }
    const transform2 = new TransformStream({
      start() {
      },
      async transform(chunk, controller) {
        checksum.update(chunk);
        controller.enqueue(chunk);
      },
      async flush(controller) {
        const digest = await checksum.digest();
        const received = encoder(digest);
        if (expectedChecksum !== received) {
          const error = new Error(`Checksum mismatch: expected "${expectedChecksum}" but received "${received}" in response header "${checksumSourceLocation}".`);
          controller.error(error);
        } else {
          controller.terminate();
        }
      }
    });
    source.pipeThrough(transform2);
    const readable2 = transform2.readable;
    Object.setPrototypeOf(readable2, ChecksumStream_browser_1.ChecksumStream.prototype);
    return readable2;
  };
  exports.createChecksumStream = createChecksumStream2;
});
var require_createChecksumStream = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  exports.createChecksumStream = undefined;
  var stream_type_check_1 = require_stream_type_check();
  var ChecksumStream_1 = require_ChecksumStream();
  var createChecksumStream_browser_1 = require_createChecksumStream_browser();
  function createChecksumStream2(init3) {
    if (typeof ReadableStream === "function" && (0, stream_type_check_1.isReadableStream)(init3.source)) {
      return (0, createChecksumStream_browser_1.createChecksumStream)(init3);
    }
    return new ChecksumStream_1.ChecksumStream(init3);
  }
  exports.createChecksumStream = createChecksumStream2;
});
var require_dist_cjs14 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    Uint8ArrayBlobAdapter: () => Uint8ArrayBlobAdapter
  });
  module.exports = __toCommonJS2(src_exports);
  var import_util_base64 = require_dist_cjs8();
  var import_util_utf8 = require_dist_cjs7();
  function transformToString(payload, encoding = "utf-8") {
    if (encoding === "base64") {
      return (0, import_util_base64.toBase64)(payload);
    }
    return (0, import_util_utf8.toUtf8)(payload);
  }
  __name(transformToString, "transformToString");
  function transformFromString(str2, encoding) {
    if (encoding === "base64") {
      return Uint8ArrayBlobAdapter.mutate((0, import_util_base64.fromBase64)(str2));
    }
    return Uint8ArrayBlobAdapter.mutate((0, import_util_utf8.fromUtf8)(str2));
  }
  __name(transformFromString, "transformFromString");
  var _Uint8ArrayBlobAdapter = class _Uint8ArrayBlobAdapter2 extends Uint8Array {
    static fromString(source, encoding = "utf-8") {
      switch (typeof source) {
        case "string":
          return transformFromString(source, encoding);
        default:
          throw new Error(`Unsupported conversion from ${typeof source} to Uint8ArrayBlobAdapter.`);
      }
    }
    static mutate(source) {
      Object.setPrototypeOf(source, _Uint8ArrayBlobAdapter2.prototype);
      return source;
    }
    transformToString(encoding = "utf-8") {
      return transformToString(this, encoding);
    }
  };
  __name(_Uint8ArrayBlobAdapter, "Uint8ArrayBlobAdapter");
  var Uint8ArrayBlobAdapter = _Uint8ArrayBlobAdapter;
  __reExport(src_exports, require_getAwsChunkedEncodingStream(), module.exports);
  __reExport(src_exports, require_sdk_stream_mixin(), module.exports);
  __reExport(src_exports, require_splitStream(), module.exports);
  __reExport(src_exports, require_headStream(), module.exports);
  __reExport(src_exports, require_stream_type_check(), module.exports);
  __reExport(src_exports, require_createChecksumStream(), module.exports);
  __reExport(src_exports, require_ChecksumStream(), module.exports);
});
var require_protocols = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var protocols_exports = {};
  __export32(protocols_exports, {
    RequestBuilder: () => RequestBuilder,
    collectBody: () => collectBody2,
    extendedEncodeURIComponent: () => extendedEncodeURIComponent2,
    requestBuilder: () => requestBuilder2,
    resolvedPath: () => resolvedPath2
  });
  module.exports = __toCommonJS2(protocols_exports);
  var import_util_stream = require_dist_cjs14();
  var collectBody2 = async (streamBody = new Uint8Array, context) => {
    if (streamBody instanceof Uint8Array) {
      return import_util_stream.Uint8ArrayBlobAdapter.mutate(streamBody);
    }
    if (!streamBody) {
      return import_util_stream.Uint8ArrayBlobAdapter.mutate(new Uint8Array);
    }
    const fromContext = context.streamCollector(streamBody);
    return import_util_stream.Uint8ArrayBlobAdapter.mutate(await fromContext);
  };
  function extendedEncodeURIComponent2(str2) {
    return encodeURIComponent(str2).replace(/[!'()*]/g, function(c22) {
      return "%" + c22.charCodeAt(0).toString(16).toUpperCase();
    });
  }
  var import_protocols = require_protocols();
  var import_protocol_http2 = require_dist_cjs2();
  function requestBuilder2(input, context) {
    return new RequestBuilder(input, context);
  }
  var RequestBuilder = class {
    constructor(input, context) {
      this.input = input;
      this.context = context;
      this.query = {};
      this.method = "";
      this.headers = {};
      this.path = "";
      this.body = null;
      this.hostname = "";
      this.resolvePathStack = [];
    }
    async build() {
      const { hostname, protocol = "https", port, path: basePath } = await this.context.endpoint();
      this.path = basePath;
      for (const resolvePath of this.resolvePathStack) {
        resolvePath(this.path);
      }
      return new import_protocol_http2.HttpRequest({
        protocol,
        hostname: this.hostname || hostname,
        port,
        method: this.method,
        path: this.path,
        query: this.query,
        body: this.body,
        headers: this.headers
      });
    }
    hn(hostname) {
      this.hostname = hostname;
      return this;
    }
    bp(uriLabel) {
      this.resolvePathStack.push((basePath) => {
        this.path = `${(basePath == null ? undefined : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + uriLabel;
      });
      return this;
    }
    p(memberName, labelValueProvider, uriLabel, isGreedyLabel) {
      this.resolvePathStack.push((path5) => {
        this.path = (0, import_protocols.resolvedPath)(path5, this.input, memberName, labelValueProvider, uriLabel, isGreedyLabel);
      });
      return this;
    }
    h(headers) {
      this.headers = headers;
      return this;
    }
    q(query) {
      this.query = query;
      return this;
    }
    b(body) {
      this.body = body;
      return this;
    }
    m(method) {
      this.method = method;
      return this;
    }
  };
  var resolvedPath2 = (resolvedPath3, input, memberName, labelValueProvider, uriLabel, isGreedyLabel) => {
    if (input != null && input[memberName] !== undefined) {
      const labelValue = labelValueProvider();
      if (labelValue.length <= 0) {
        throw new Error("Empty value provided for input HTTP label: " + memberName + ".");
      }
      resolvedPath3 = resolvedPath3.replace(uriLabel, isGreedyLabel ? labelValue.split("/").map((segment) => extendedEncodeURIComponent2(segment)).join("/") : extendedEncodeURIComponent2(labelValue));
    } else {
      throw new Error("No value provided for input HTTP label: " + memberName + ".");
    }
    return resolvedPath3;
  };
});
var require_dist_cjs15 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    DefaultIdentityProviderConfig: () => DefaultIdentityProviderConfig,
    EXPIRATION_MS: () => EXPIRATION_MS,
    HttpApiKeyAuthSigner: () => HttpApiKeyAuthSigner,
    HttpBearerAuthSigner: () => HttpBearerAuthSigner,
    NoAuthSigner: () => NoAuthSigner,
    createIsIdentityExpiredFunction: () => createIsIdentityExpiredFunction,
    createPaginator: () => createPaginator,
    doesIdentityRequireRefresh: () => doesIdentityRequireRefresh,
    getHttpAuthSchemeEndpointRuleSetPlugin: () => getHttpAuthSchemeEndpointRuleSetPlugin,
    getHttpAuthSchemePlugin: () => getHttpAuthSchemePlugin,
    getHttpSigningPlugin: () => getHttpSigningPlugin,
    getSmithyContext: () => getSmithyContext,
    httpAuthSchemeEndpointRuleSetMiddlewareOptions: () => httpAuthSchemeEndpointRuleSetMiddlewareOptions,
    httpAuthSchemeMiddleware: () => httpAuthSchemeMiddleware,
    httpAuthSchemeMiddlewareOptions: () => httpAuthSchemeMiddlewareOptions,
    httpSigningMiddleware: () => httpSigningMiddleware,
    httpSigningMiddlewareOptions: () => httpSigningMiddlewareOptions,
    isIdentityExpired: () => isIdentityExpired,
    memoizeIdentityProvider: () => memoizeIdentityProvider,
    normalizeProvider: () => normalizeProvider,
    requestBuilder: () => import_protocols.requestBuilder,
    setFeature: () => setFeature
  });
  module.exports = __toCommonJS2(src_exports);
  var import_types9 = require_dist_cjs();
  var getSmithyContext = /* @__PURE__ */ __name((context) => context[import_types9.SMITHY_CONTEXT_KEY] || (context[import_types9.SMITHY_CONTEXT_KEY] = {}), "getSmithyContext");
  var import_util_middleware = require_dist_cjs3();
  function convertHttpAuthSchemesToMap(httpAuthSchemes) {
    const map2 = /* @__PURE__ */ new Map;
    for (const scheme of httpAuthSchemes) {
      map2.set(scheme.schemeId, scheme);
    }
    return map2;
  }
  __name(convertHttpAuthSchemesToMap, "convertHttpAuthSchemesToMap");
  var httpAuthSchemeMiddleware = /* @__PURE__ */ __name((config6, mwOptions) => (next, context) => async (args) => {
    var _a;
    const options3 = config6.httpAuthSchemeProvider(await mwOptions.httpAuthSchemeParametersProvider(config6, context, args.input));
    const authSchemes = convertHttpAuthSchemesToMap(config6.httpAuthSchemes);
    const smithyContext = (0, import_util_middleware.getSmithyContext)(context);
    const failureReasons = [];
    for (const option of options3) {
      const scheme = authSchemes.get(option.schemeId);
      if (!scheme) {
        failureReasons.push(`HttpAuthScheme \`${option.schemeId}\` was not enabled for this service.`);
        continue;
      }
      const identityProvider = scheme.identityProvider(await mwOptions.identityProviderConfigProvider(config6));
      if (!identityProvider) {
        failureReasons.push(`HttpAuthScheme \`${option.schemeId}\` did not have an IdentityProvider configured.`);
        continue;
      }
      const { identityProperties = {}, signingProperties = {} } = ((_a = option.propertiesExtractor) == null ? undefined : _a.call(option, config6, context)) || {};
      option.identityProperties = Object.assign(option.identityProperties || {}, identityProperties);
      option.signingProperties = Object.assign(option.signingProperties || {}, signingProperties);
      smithyContext.selectedHttpAuthScheme = {
        httpAuthOption: option,
        identity: await identityProvider(option.identityProperties),
        signer: scheme.signer
      };
      break;
    }
    if (!smithyContext.selectedHttpAuthScheme) {
      throw new Error(failureReasons.join("\n"));
    }
    return next(args);
  }, "httpAuthSchemeMiddleware");
  var httpAuthSchemeEndpointRuleSetMiddlewareOptions = {
    step: "serialize",
    tags: ["HTTP_AUTH_SCHEME"],
    name: "httpAuthSchemeMiddleware",
    override: true,
    relation: "before",
    toMiddleware: "endpointV2Middleware"
  };
  var getHttpAuthSchemeEndpointRuleSetPlugin = /* @__PURE__ */ __name((config6, {
    httpAuthSchemeParametersProvider,
    identityProviderConfigProvider
  }) => ({
    applyToStack: (clientStack) => {
      clientStack.addRelativeTo(httpAuthSchemeMiddleware(config6, {
        httpAuthSchemeParametersProvider,
        identityProviderConfigProvider
      }), httpAuthSchemeEndpointRuleSetMiddlewareOptions);
    }
  }), "getHttpAuthSchemeEndpointRuleSetPlugin");
  var import_middleware_serde = require_dist_cjs4();
  var httpAuthSchemeMiddlewareOptions = {
    step: "serialize",
    tags: ["HTTP_AUTH_SCHEME"],
    name: "httpAuthSchemeMiddleware",
    override: true,
    relation: "before",
    toMiddleware: import_middleware_serde.serializerMiddlewareOption.name
  };
  var getHttpAuthSchemePlugin = /* @__PURE__ */ __name((config6, {
    httpAuthSchemeParametersProvider,
    identityProviderConfigProvider
  }) => ({
    applyToStack: (clientStack) => {
      clientStack.addRelativeTo(httpAuthSchemeMiddleware(config6, {
        httpAuthSchemeParametersProvider,
        identityProviderConfigProvider
      }), httpAuthSchemeMiddlewareOptions);
    }
  }), "getHttpAuthSchemePlugin");
  var import_protocol_http2 = require_dist_cjs2();
  var defaultErrorHandler = /* @__PURE__ */ __name((signingProperties) => (error) => {
    throw error;
  }, "defaultErrorHandler");
  var defaultSuccessHandler = /* @__PURE__ */ __name((httpResponse2, signingProperties) => {
  }, "defaultSuccessHandler");
  var httpSigningMiddleware = /* @__PURE__ */ __name((config6) => (next, context) => async (args) => {
    if (!import_protocol_http2.HttpRequest.isInstance(args.request)) {
      return next(args);
    }
    const smithyContext = (0, import_util_middleware.getSmithyContext)(context);
    const scheme = smithyContext.selectedHttpAuthScheme;
    if (!scheme) {
      throw new Error(`No HttpAuthScheme was selected: unable to sign request`);
    }
    const {
      httpAuthOption: { signingProperties = {} },
      identity: identity2,
      signer
    } = scheme;
    const output = await next({
      ...args,
      request: await signer.sign(args.request, identity2, signingProperties)
    }).catch((signer.errorHandler || defaultErrorHandler)(signingProperties));
    (signer.successHandler || defaultSuccessHandler)(output.response, signingProperties);
    return output;
  }, "httpSigningMiddleware");
  var httpSigningMiddlewareOptions = {
    step: "finalizeRequest",
    tags: ["HTTP_SIGNING"],
    name: "httpSigningMiddleware",
    aliases: ["apiKeyMiddleware", "tokenMiddleware", "awsAuthMiddleware"],
    override: true,
    relation: "after",
    toMiddleware: "retryMiddleware"
  };
  var getHttpSigningPlugin = /* @__PURE__ */ __name((config6) => ({
    applyToStack: (clientStack) => {
      clientStack.addRelativeTo(httpSigningMiddleware(config6), httpSigningMiddlewareOptions);
    }
  }), "getHttpSigningPlugin");
  var normalizeProvider = /* @__PURE__ */ __name((input) => {
    if (typeof input === "function")
      return input;
    const promisified = Promise.resolve(input);
    return () => promisified;
  }, "normalizeProvider");
  var makePagedClientRequest = /* @__PURE__ */ __name(async (CommandCtor, client, input, ...args) => {
    return await client.send(new CommandCtor(input), ...args);
  }, "makePagedClientRequest");
  function createPaginator(ClientCtor, CommandCtor, inputTokenName, outputTokenName, pageSizeTokenName) {
    return /* @__PURE__ */ __name(async function* paginateOperation(config6, input, ...additionalArguments) {
      let token = config6.startingToken || undefined;
      let hasNext = true;
      let page;
      while (hasNext) {
        input[inputTokenName] = token;
        if (pageSizeTokenName) {
          input[pageSizeTokenName] = input[pageSizeTokenName] ?? config6.pageSize;
        }
        if (config6.client instanceof ClientCtor) {
          page = await makePagedClientRequest(CommandCtor, config6.client, input, ...additionalArguments);
        } else {
          throw new Error(`Invalid client, expected instance of ${ClientCtor.name}`);
        }
        yield page;
        const prevToken = token;
        token = get2(page, outputTokenName);
        hasNext = !!(token && (!config6.stopOnSameToken || token !== prevToken));
      }
      return;
    }, "paginateOperation");
  }
  __name(createPaginator, "createPaginator");
  var get2 = /* @__PURE__ */ __name((fromObject, path5) => {
    let cursor22 = fromObject;
    const pathComponents = path5.split(".");
    for (const step of pathComponents) {
      if (!cursor22 || typeof cursor22 !== "object") {
        return;
      }
      cursor22 = cursor22[step];
    }
    return cursor22;
  }, "get");
  var import_protocols = require_protocols();
  function setFeature(context, feature, value) {
    if (!context.__smithy_context) {
      context.__smithy_context = {
        features: {}
      };
    } else if (!context.__smithy_context.features) {
      context.__smithy_context.features = {};
    }
    context.__smithy_context.features[feature] = value;
  }
  __name(setFeature, "setFeature");
  var _DefaultIdentityProviderConfig = class _DefaultIdentityProviderConfig2 {
    constructor(config6) {
      this.authSchemes = /* @__PURE__ */ new Map;
      for (const [key2, value] of Object.entries(config6)) {
        if (value !== undefined) {
          this.authSchemes.set(key2, value);
        }
      }
    }
    getIdentityProvider(schemeId) {
      return this.authSchemes.get(schemeId);
    }
  };
  __name(_DefaultIdentityProviderConfig, "DefaultIdentityProviderConfig");
  var DefaultIdentityProviderConfig = _DefaultIdentityProviderConfig;
  var _HttpApiKeyAuthSigner = class _HttpApiKeyAuthSigner2 {
    async sign(httpRequest2, identity2, signingProperties) {
      if (!signingProperties) {
        throw new Error("request could not be signed with `apiKey` since the `name` and `in` signer properties are missing");
      }
      if (!signingProperties.name) {
        throw new Error("request could not be signed with `apiKey` since the `name` signer property is missing");
      }
      if (!signingProperties.in) {
        throw new Error("request could not be signed with `apiKey` since the `in` signer property is missing");
      }
      if (!identity2.apiKey) {
        throw new Error("request could not be signed with `apiKey` since the `apiKey` is not defined");
      }
      const clonedRequest = import_protocol_http2.HttpRequest.clone(httpRequest2);
      if (signingProperties.in === import_types9.HttpApiKeyAuthLocation.QUERY) {
        clonedRequest.query[signingProperties.name] = identity2.apiKey;
      } else if (signingProperties.in === import_types9.HttpApiKeyAuthLocation.HEADER) {
        clonedRequest.headers[signingProperties.name] = signingProperties.scheme ? `${signingProperties.scheme} ${identity2.apiKey}` : identity2.apiKey;
      } else {
        throw new Error("request can only be signed with `apiKey` locations `query` or `header`, but found: `" + signingProperties.in + "`");
      }
      return clonedRequest;
    }
  };
  __name(_HttpApiKeyAuthSigner, "HttpApiKeyAuthSigner");
  var HttpApiKeyAuthSigner = _HttpApiKeyAuthSigner;
  var _HttpBearerAuthSigner = class _HttpBearerAuthSigner2 {
    async sign(httpRequest2, identity2, signingProperties) {
      const clonedRequest = import_protocol_http2.HttpRequest.clone(httpRequest2);
      if (!identity2.token) {
        throw new Error("request could not be signed with `token` since the `token` is not defined");
      }
      clonedRequest.headers["Authorization"] = `Bearer ${identity2.token}`;
      return clonedRequest;
    }
  };
  __name(_HttpBearerAuthSigner, "HttpBearerAuthSigner");
  var HttpBearerAuthSigner = _HttpBearerAuthSigner;
  var _NoAuthSigner = class _NoAuthSigner2 {
    async sign(httpRequest2, identity2, signingProperties) {
      return httpRequest2;
    }
  };
  __name(_NoAuthSigner, "NoAuthSigner");
  var NoAuthSigner = _NoAuthSigner;
  var createIsIdentityExpiredFunction = /* @__PURE__ */ __name((expirationMs) => (identity2) => doesIdentityRequireRefresh(identity2) && identity2.expiration.getTime() - Date.now() < expirationMs, "createIsIdentityExpiredFunction");
  var EXPIRATION_MS = 300000;
  var isIdentityExpired = createIsIdentityExpiredFunction(EXPIRATION_MS);
  var doesIdentityRequireRefresh = /* @__PURE__ */ __name((identity2) => identity2.expiration !== undefined, "doesIdentityRequireRefresh");
  var memoizeIdentityProvider = /* @__PURE__ */ __name((provider, isExpired, requiresRefresh) => {
    if (provider === undefined) {
      return;
    }
    const normalizedProvider = typeof provider !== "function" ? async () => Promise.resolve(provider) : provider;
    let resolved;
    let pending;
    let hasResult;
    let isConstant = false;
    const coalesceProvider = /* @__PURE__ */ __name(async (options3) => {
      if (!pending) {
        pending = normalizedProvider(options3);
      }
      try {
        resolved = await pending;
        hasResult = true;
        isConstant = false;
      } finally {
        pending = undefined;
      }
      return resolved;
    }, "coalesceProvider");
    if (isExpired === undefined) {
      return async (options3) => {
        if (!hasResult || (options3 == null ? undefined : options3.forceRefresh)) {
          resolved = await coalesceProvider(options3);
        }
        return resolved;
      };
    }
    return async (options3) => {
      if (!hasResult || (options3 == null ? undefined : options3.forceRefresh)) {
        resolved = await coalesceProvider(options3);
      }
      if (isConstant) {
        return resolved;
      }
      if (!requiresRefresh(resolved)) {
        isConstant = true;
        return resolved;
      }
      if (isExpired(resolved)) {
        await coalesceProvider(options3);
        return resolved;
      }
      return resolved;
    };
  }, "memoizeIdentityProvider");
});
var require_dist_cjs16 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    CredentialsProviderError: () => CredentialsProviderError,
    ProviderError: () => ProviderError,
    TokenProviderError: () => TokenProviderError,
    chain: () => chain,
    fromStatic: () => fromStatic,
    memoize: () => memoize2
  });
  module.exports = __toCommonJS2(src_exports);
  var _ProviderError = class _ProviderError2 extends Error {
    constructor(message, options3 = true) {
      var _a;
      let logger22;
      let tryNextLink = true;
      if (typeof options3 === "boolean") {
        logger22 = undefined;
        tryNextLink = options3;
      } else if (options3 != null && typeof options3 === "object") {
        logger22 = options3.logger;
        tryNextLink = options3.tryNextLink ?? true;
      }
      super(message);
      this.name = "ProviderError";
      this.tryNextLink = tryNextLink;
      Object.setPrototypeOf(this, _ProviderError2.prototype);
      (_a = logger22 == null ? undefined : logger22.debug) == null || _a.call(logger22, `@smithy/property-provider ${tryNextLink ? "->" : "(!)"} ${message}`);
    }
    static from(error, options3 = true) {
      return Object.assign(new this(error.message, options3), error);
    }
  };
  __name(_ProviderError, "ProviderError");
  var ProviderError = _ProviderError;
  var _CredentialsProviderError = class _CredentialsProviderError2 extends ProviderError {
    constructor(message, options3 = true) {
      super(message, options3);
      this.name = "CredentialsProviderError";
      Object.setPrototypeOf(this, _CredentialsProviderError2.prototype);
    }
  };
  __name(_CredentialsProviderError, "CredentialsProviderError");
  var CredentialsProviderError = _CredentialsProviderError;
  var _TokenProviderError = class _TokenProviderError2 extends ProviderError {
    constructor(message, options3 = true) {
      super(message, options3);
      this.name = "TokenProviderError";
      Object.setPrototypeOf(this, _TokenProviderError2.prototype);
    }
  };
  __name(_TokenProviderError, "TokenProviderError");
  var TokenProviderError = _TokenProviderError;
  var chain = /* @__PURE__ */ __name((...providers22) => async () => {
    if (providers22.length === 0) {
      throw new ProviderError("No providers in chain");
    }
    let lastProviderError;
    for (const provider of providers22) {
      try {
        const credentials = await provider();
        return credentials;
      } catch (err22) {
        lastProviderError = err22;
        if (err22 == null ? undefined : err22.tryNextLink) {
          continue;
        }
        throw err22;
      }
    }
    throw lastProviderError;
  }, "chain");
  var fromStatic = /* @__PURE__ */ __name((staticValue) => () => Promise.resolve(staticValue), "fromStatic");
  var memoize2 = /* @__PURE__ */ __name((provider, isExpired, requiresRefresh) => {
    let resolved;
    let pending;
    let hasResult;
    let isConstant = false;
    const coalesceProvider = /* @__PURE__ */ __name(async () => {
      if (!pending) {
        pending = provider();
      }
      try {
        resolved = await pending;
        hasResult = true;
        isConstant = false;
      } finally {
        pending = undefined;
      }
      return resolved;
    }, "coalesceProvider");
    if (isExpired === undefined) {
      return async (options3) => {
        if (!hasResult || (options3 == null ? undefined : options3.forceRefresh)) {
          resolved = await coalesceProvider();
        }
        return resolved;
      };
    }
    return async (options3) => {
      if (!hasResult || (options3 == null ? undefined : options3.forceRefresh)) {
        resolved = await coalesceProvider();
      }
      if (isConstant) {
        return resolved;
      }
      if (requiresRefresh && !requiresRefresh(resolved)) {
        isConstant = true;
        return resolved;
      }
      if (isExpired(resolved)) {
        await coalesceProvider();
        return resolved;
      }
      return resolved;
    };
  }, "memoize");
});
var require_dist_cjs17 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    SignatureV4: () => SignatureV4,
    clearCredentialCache: () => clearCredentialCache,
    createScope: () => createScope,
    getCanonicalHeaders: () => getCanonicalHeaders,
    getCanonicalQuery: () => getCanonicalQuery,
    getPayloadHash: () => getPayloadHash,
    getSigningKey: () => getSigningKey,
    moveHeadersToQuery: () => moveHeadersToQuery,
    prepareRequest: () => prepareRequest
  });
  module.exports = __toCommonJS2(src_exports);
  var import_util_middleware = require_dist_cjs3();
  var import_util_utf84 = require_dist_cjs7();
  var ALGORITHM_QUERY_PARAM = "X-Amz-Algorithm";
  var CREDENTIAL_QUERY_PARAM = "X-Amz-Credential";
  var AMZ_DATE_QUERY_PARAM = "X-Amz-Date";
  var SIGNED_HEADERS_QUERY_PARAM = "X-Amz-SignedHeaders";
  var EXPIRES_QUERY_PARAM = "X-Amz-Expires";
  var SIGNATURE_QUERY_PARAM = "X-Amz-Signature";
  var TOKEN_QUERY_PARAM = "X-Amz-Security-Token";
  var AUTH_HEADER = "authorization";
  var AMZ_DATE_HEADER = AMZ_DATE_QUERY_PARAM.toLowerCase();
  var DATE_HEADER = "date";
  var GENERATED_HEADERS = [AUTH_HEADER, AMZ_DATE_HEADER, DATE_HEADER];
  var SIGNATURE_HEADER = SIGNATURE_QUERY_PARAM.toLowerCase();
  var SHA256_HEADER = "x-amz-content-sha256";
  var TOKEN_HEADER = TOKEN_QUERY_PARAM.toLowerCase();
  var ALWAYS_UNSIGNABLE_HEADERS = {
    authorization: true,
    "cache-control": true,
    connection: true,
    expect: true,
    from: true,
    "keep-alive": true,
    "max-forwards": true,
    pragma: true,
    referer: true,
    te: true,
    trailer: true,
    "transfer-encoding": true,
    upgrade: true,
    "user-agent": true,
    "x-amzn-trace-id": true
  };
  var PROXY_HEADER_PATTERN = /^proxy-/;
  var SEC_HEADER_PATTERN = /^sec-/;
  var ALGORITHM_IDENTIFIER = "AWS4-HMAC-SHA256";
  var EVENT_ALGORITHM_IDENTIFIER = "AWS4-HMAC-SHA256-PAYLOAD";
  var UNSIGNED_PAYLOAD = "UNSIGNED-PAYLOAD";
  var MAX_CACHE_SIZE = 50;
  var KEY_TYPE_IDENTIFIER = "aws4_request";
  var MAX_PRESIGNED_TTL = 604800;
  var import_util_hex_encoding = require_dist_cjs13();
  var import_util_utf8 = require_dist_cjs7();
  var signingKeyCache = {};
  var cacheQueue = [];
  var createScope = /* @__PURE__ */ __name((shortDate, region, service) => `${shortDate}/${region}/${service}/${KEY_TYPE_IDENTIFIER}`, "createScope");
  var getSigningKey = /* @__PURE__ */ __name(async (sha256Constructor, credentials, shortDate, region, service) => {
    const credsHash = await hmac(sha256Constructor, credentials.secretAccessKey, credentials.accessKeyId);
    const cacheKey = `${shortDate}:${region}:${service}:${(0, import_util_hex_encoding.toHex)(credsHash)}:${credentials.sessionToken}`;
    if (cacheKey in signingKeyCache) {
      return signingKeyCache[cacheKey];
    }
    cacheQueue.push(cacheKey);
    while (cacheQueue.length > MAX_CACHE_SIZE) {
      delete signingKeyCache[cacheQueue.shift()];
    }
    let key2 = `AWS4${credentials.secretAccessKey}`;
    for (const signable of [shortDate, region, service, KEY_TYPE_IDENTIFIER]) {
      key2 = await hmac(sha256Constructor, key2, signable);
    }
    return signingKeyCache[cacheKey] = key2;
  }, "getSigningKey");
  var clearCredentialCache = /* @__PURE__ */ __name(() => {
    cacheQueue.length = 0;
    Object.keys(signingKeyCache).forEach((cacheKey) => {
      delete signingKeyCache[cacheKey];
    });
  }, "clearCredentialCache");
  var hmac = /* @__PURE__ */ __name((ctor, secret, data2) => {
    const hash3 = new ctor(secret);
    hash3.update((0, import_util_utf8.toUint8Array)(data2));
    return hash3.digest();
  }, "hmac");
  var getCanonicalHeaders = /* @__PURE__ */ __name(({ headers }, unsignableHeaders, signableHeaders) => {
    const canonical = {};
    for (const headerName of Object.keys(headers).sort()) {
      if (headers[headerName] == undefined) {
        continue;
      }
      const canonicalHeaderName = headerName.toLowerCase();
      if (canonicalHeaderName in ALWAYS_UNSIGNABLE_HEADERS || (unsignableHeaders == null ? undefined : unsignableHeaders.has(canonicalHeaderName)) || PROXY_HEADER_PATTERN.test(canonicalHeaderName) || SEC_HEADER_PATTERN.test(canonicalHeaderName)) {
        if (!signableHeaders || signableHeaders && !signableHeaders.has(canonicalHeaderName)) {
          continue;
        }
      }
      canonical[canonicalHeaderName] = headers[headerName].trim().replace(/\s+/g, " ");
    }
    return canonical;
  }, "getCanonicalHeaders");
  var import_util_uri_escape = require_dist_cjs9();
  var getCanonicalQuery = /* @__PURE__ */ __name(({ query = {} }) => {
    const keys2 = [];
    const serialized = {};
    for (const key2 of Object.keys(query)) {
      if (key2.toLowerCase() === SIGNATURE_HEADER) {
        continue;
      }
      const encodedKey = (0, import_util_uri_escape.escapeUri)(key2);
      keys2.push(encodedKey);
      const value = query[key2];
      if (typeof value === "string") {
        serialized[encodedKey] = `${encodedKey}=${(0, import_util_uri_escape.escapeUri)(value)}`;
      } else if (Array.isArray(value)) {
        serialized[encodedKey] = value.slice(0).reduce((encoded, value2) => encoded.concat([`${encodedKey}=${(0, import_util_uri_escape.escapeUri)(value2)}`]), []).sort().join("&");
      }
    }
    return keys2.sort().map((key2) => serialized[key2]).filter((serialized2) => serialized2).join("&");
  }, "getCanonicalQuery");
  var import_is_array_buffer = require_dist_cjs5();
  var import_util_utf82 = require_dist_cjs7();
  var getPayloadHash = /* @__PURE__ */ __name(async ({ headers, body }, hashConstructor) => {
    for (const headerName of Object.keys(headers)) {
      if (headerName.toLowerCase() === SHA256_HEADER) {
        return headers[headerName];
      }
    }
    if (body == undefined) {
      return "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855";
    } else if (typeof body === "string" || ArrayBuffer.isView(body) || (0, import_is_array_buffer.isArrayBuffer)(body)) {
      const hashCtor = new hashConstructor;
      hashCtor.update((0, import_util_utf82.toUint8Array)(body));
      return (0, import_util_hex_encoding.toHex)(await hashCtor.digest());
    }
    return UNSIGNED_PAYLOAD;
  }, "getPayloadHash");
  var import_util_utf83 = require_dist_cjs7();
  var _HeaderFormatter = class _HeaderFormatter2 {
    format(headers) {
      const chunks = [];
      for (const headerName of Object.keys(headers)) {
        const bytes = (0, import_util_utf83.fromUtf8)(headerName);
        chunks.push(Uint8Array.from([bytes.byteLength]), bytes, this.formatHeaderValue(headers[headerName]));
      }
      const out = new Uint8Array(chunks.reduce((carry, bytes) => carry + bytes.byteLength, 0));
      let position = 0;
      for (const chunk of chunks) {
        out.set(chunk, position);
        position += chunk.byteLength;
      }
      return out;
    }
    formatHeaderValue(header) {
      switch (header.type) {
        case "boolean":
          return Uint8Array.from([header.value ? 0 : 1]);
        case "byte":
          return Uint8Array.from([2, header.value]);
        case "short":
          const shortView = new DataView(new ArrayBuffer(3));
          shortView.setUint8(0, 3);
          shortView.setInt16(1, header.value, false);
          return new Uint8Array(shortView.buffer);
        case "integer":
          const intView = new DataView(new ArrayBuffer(5));
          intView.setUint8(0, 4);
          intView.setInt32(1, header.value, false);
          return new Uint8Array(intView.buffer);
        case "long":
          const longBytes = new Uint8Array(9);
          longBytes[0] = 5;
          longBytes.set(header.value.bytes, 1);
          return longBytes;
        case "binary":
          const binView = new DataView(new ArrayBuffer(3 + header.value.byteLength));
          binView.setUint8(0, 6);
          binView.setUint16(1, header.value.byteLength, false);
          const binBytes = new Uint8Array(binView.buffer);
          binBytes.set(header.value, 3);
          return binBytes;
        case "string":
          const utf8Bytes = (0, import_util_utf83.fromUtf8)(header.value);
          const strView = new DataView(new ArrayBuffer(3 + utf8Bytes.byteLength));
          strView.setUint8(0, 7);
          strView.setUint16(1, utf8Bytes.byteLength, false);
          const strBytes = new Uint8Array(strView.buffer);
          strBytes.set(utf8Bytes, 3);
          return strBytes;
        case "timestamp":
          const tsBytes = new Uint8Array(9);
          tsBytes[0] = 8;
          tsBytes.set(Int64.fromNumber(header.value.valueOf()).bytes, 1);
          return tsBytes;
        case "uuid":
          if (!UUID_PATTERN.test(header.value)) {
            throw new Error(`Invalid UUID received: ${header.value}`);
          }
          const uuidBytes = new Uint8Array(17);
          uuidBytes[0] = 9;
          uuidBytes.set((0, import_util_hex_encoding.fromHex)(header.value.replace(/\-/g, "")), 1);
          return uuidBytes;
      }
    }
  };
  __name(_HeaderFormatter, "HeaderFormatter");
  var HeaderFormatter = _HeaderFormatter;
  var UUID_PATTERN = /^[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}$/;
  var _Int64 = class _Int642 {
    constructor(bytes) {
      this.bytes = bytes;
      if (bytes.byteLength !== 8) {
        throw new Error("Int64 buffers must be exactly 8 bytes");
      }
    }
    static fromNumber(number) {
      if (number > 9223372036854776000 || number < -9223372036854776000) {
        throw new Error(`${number} is too large (or, if negative, too small) to represent as an Int64`);
      }
      const bytes = new Uint8Array(8);
      for (let i2 = 7, remaining = Math.abs(Math.round(number));i2 > -1 && remaining > 0; i2--, remaining /= 256) {
        bytes[i2] = remaining;
      }
      if (number < 0) {
        negate(bytes);
      }
      return new _Int642(bytes);
    }
    valueOf() {
      const bytes = this.bytes.slice(0);
      const negative = bytes[0] & 128;
      if (negative) {
        negate(bytes);
      }
      return parseInt((0, import_util_hex_encoding.toHex)(bytes), 16) * (negative ? -1 : 1);
    }
    toString() {
      return String(this.valueOf());
    }
  };
  __name(_Int64, "Int64");
  var Int64 = _Int64;
  function negate(bytes) {
    for (let i2 = 0;i2 < 8; i2++) {
      bytes[i2] ^= 255;
    }
    for (let i2 = 7;i2 > -1; i2--) {
      bytes[i2]++;
      if (bytes[i2] !== 0)
        break;
    }
  }
  __name(negate, "negate");
  var hasHeader = /* @__PURE__ */ __name((soughtHeader, headers) => {
    soughtHeader = soughtHeader.toLowerCase();
    for (const headerName of Object.keys(headers)) {
      if (soughtHeader === headerName.toLowerCase()) {
        return true;
      }
    }
    return false;
  }, "hasHeader");
  var import_protocol_http2 = require_dist_cjs2();
  var moveHeadersToQuery = /* @__PURE__ */ __name((request42, options3 = {}) => {
    var _a, _b;
    const { headers, query = {} } = import_protocol_http2.HttpRequest.clone(request42);
    for (const name of Object.keys(headers)) {
      const lname = name.toLowerCase();
      if (lname.slice(0, 6) === "x-amz-" && !((_a = options3.unhoistableHeaders) == null ? undefined : _a.has(lname)) || ((_b = options3.hoistableHeaders) == null ? undefined : _b.has(lname))) {
        query[name] = headers[name];
        delete headers[name];
      }
    }
    return {
      ...request42,
      headers,
      query
    };
  }, "moveHeadersToQuery");
  var prepareRequest = /* @__PURE__ */ __name((request42) => {
    request42 = import_protocol_http2.HttpRequest.clone(request42);
    for (const headerName of Object.keys(request42.headers)) {
      if (GENERATED_HEADERS.indexOf(headerName.toLowerCase()) > -1) {
        delete request42.headers[headerName];
      }
    }
    return request42;
  }, "prepareRequest");
  var iso8601 = /* @__PURE__ */ __name((time) => toDate(time).toISOString().replace(/\.\d{3}Z$/, "Z"), "iso8601");
  var toDate = /* @__PURE__ */ __name((time) => {
    if (typeof time === "number") {
      return new Date(time * 1000);
    }
    if (typeof time === "string") {
      if (Number(time)) {
        return new Date(Number(time) * 1000);
      }
      return new Date(time);
    }
    return time;
  }, "toDate");
  var _SignatureV4 = class _SignatureV42 {
    constructor({
      applyChecksum,
      credentials,
      region,
      service,
      sha256,
      uriEscapePath = true
    }) {
      this.headerFormatter = new HeaderFormatter;
      this.service = service;
      this.sha256 = sha256;
      this.uriEscapePath = uriEscapePath;
      this.applyChecksum = typeof applyChecksum === "boolean" ? applyChecksum : true;
      this.regionProvider = (0, import_util_middleware.normalizeProvider)(region);
      this.credentialProvider = (0, import_util_middleware.normalizeProvider)(credentials);
    }
    async presign(originalRequest, options3 = {}) {
      const {
        signingDate = /* @__PURE__ */ new Date,
        expiresIn = 3600,
        unsignableHeaders,
        unhoistableHeaders,
        signableHeaders,
        hoistableHeaders,
        signingRegion,
        signingService
      } = options3;
      const credentials = await this.credentialProvider();
      this.validateResolvedCredentials(credentials);
      const region = signingRegion ?? await this.regionProvider();
      const { longDate, shortDate } = formatDate(signingDate);
      if (expiresIn > MAX_PRESIGNED_TTL) {
        return Promise.reject("Signature version 4 presigned URLs must have an expiration date less than one week in the future");
      }
      const scope = createScope(shortDate, region, signingService ?? this.service);
      const request42 = moveHeadersToQuery(prepareRequest(originalRequest), { unhoistableHeaders, hoistableHeaders });
      if (credentials.sessionToken) {
        request42.query[TOKEN_QUERY_PARAM] = credentials.sessionToken;
      }
      request42.query[ALGORITHM_QUERY_PARAM] = ALGORITHM_IDENTIFIER;
      request42.query[CREDENTIAL_QUERY_PARAM] = `${credentials.accessKeyId}/${scope}`;
      request42.query[AMZ_DATE_QUERY_PARAM] = longDate;
      request42.query[EXPIRES_QUERY_PARAM] = expiresIn.toString(10);
      const canonicalHeaders = getCanonicalHeaders(request42, unsignableHeaders, signableHeaders);
      request42.query[SIGNED_HEADERS_QUERY_PARAM] = getCanonicalHeaderList(canonicalHeaders);
      request42.query[SIGNATURE_QUERY_PARAM] = await this.getSignature(longDate, scope, this.getSigningKey(credentials, region, shortDate, signingService), this.createCanonicalRequest(request42, canonicalHeaders, await getPayloadHash(originalRequest, this.sha256)));
      return request42;
    }
    async sign(toSign, options3) {
      if (typeof toSign === "string") {
        return this.signString(toSign, options3);
      } else if (toSign.headers && toSign.payload) {
        return this.signEvent(toSign, options3);
      } else if (toSign.message) {
        return this.signMessage(toSign, options3);
      } else {
        return this.signRequest(toSign, options3);
      }
    }
    async signEvent({ headers, payload }, { signingDate = /* @__PURE__ */ new Date, priorSignature, signingRegion, signingService }) {
      const region = signingRegion ?? await this.regionProvider();
      const { shortDate, longDate } = formatDate(signingDate);
      const scope = createScope(shortDate, region, signingService ?? this.service);
      const hashedPayload = await getPayloadHash({ headers: {}, body: payload }, this.sha256);
      const hash3 = new this.sha256;
      hash3.update(headers);
      const hashedHeaders = (0, import_util_hex_encoding.toHex)(await hash3.digest());
      const stringToSign = [
        EVENT_ALGORITHM_IDENTIFIER,
        longDate,
        scope,
        priorSignature,
        hashedHeaders,
        hashedPayload
      ].join("\n");
      return this.signString(stringToSign, { signingDate, signingRegion: region, signingService });
    }
    async signMessage(signableMessage, { signingDate = /* @__PURE__ */ new Date, signingRegion, signingService }) {
      const promise3 = this.signEvent({
        headers: this.headerFormatter.format(signableMessage.message.headers),
        payload: signableMessage.message.body
      }, {
        signingDate,
        signingRegion,
        signingService,
        priorSignature: signableMessage.priorSignature
      });
      return promise3.then((signature) => {
        return { message: signableMessage.message, signature };
      });
    }
    async signString(stringToSign, { signingDate = /* @__PURE__ */ new Date, signingRegion, signingService } = {}) {
      const credentials = await this.credentialProvider();
      this.validateResolvedCredentials(credentials);
      const region = signingRegion ?? await this.regionProvider();
      const { shortDate } = formatDate(signingDate);
      const hash3 = new this.sha256(await this.getSigningKey(credentials, region, shortDate, signingService));
      hash3.update((0, import_util_utf84.toUint8Array)(stringToSign));
      return (0, import_util_hex_encoding.toHex)(await hash3.digest());
    }
    async signRequest(requestToSign, {
      signingDate = /* @__PURE__ */ new Date,
      signableHeaders,
      unsignableHeaders,
      signingRegion,
      signingService
    } = {}) {
      const credentials = await this.credentialProvider();
      this.validateResolvedCredentials(credentials);
      const region = signingRegion ?? await this.regionProvider();
      const request42 = prepareRequest(requestToSign);
      const { longDate, shortDate } = formatDate(signingDate);
      const scope = createScope(shortDate, region, signingService ?? this.service);
      request42.headers[AMZ_DATE_HEADER] = longDate;
      if (credentials.sessionToken) {
        request42.headers[TOKEN_HEADER] = credentials.sessionToken;
      }
      const payloadHash = await getPayloadHash(request42, this.sha256);
      if (!hasHeader(SHA256_HEADER, request42.headers) && this.applyChecksum) {
        request42.headers[SHA256_HEADER] = payloadHash;
      }
      const canonicalHeaders = getCanonicalHeaders(request42, unsignableHeaders, signableHeaders);
      const signature = await this.getSignature(longDate, scope, this.getSigningKey(credentials, region, shortDate, signingService), this.createCanonicalRequest(request42, canonicalHeaders, payloadHash));
      request42.headers[AUTH_HEADER] = `${ALGORITHM_IDENTIFIER} Credential=${credentials.accessKeyId}/${scope}, SignedHeaders=${getCanonicalHeaderList(canonicalHeaders)}, Signature=${signature}`;
      return request42;
    }
    createCanonicalRequest(request42, canonicalHeaders, payloadHash) {
      const sortedHeaders = Object.keys(canonicalHeaders).sort();
      return `${request42.method}
${this.getCanonicalPath(request42)}
${getCanonicalQuery(request42)}
${sortedHeaders.map((name) => `${name}:${canonicalHeaders[name]}`).join("\n")}

${sortedHeaders.join(";")}
${payloadHash}`;
    }
    async createStringToSign(longDate, credentialScope, canonicalRequest) {
      const hash3 = new this.sha256;
      hash3.update((0, import_util_utf84.toUint8Array)(canonicalRequest));
      const hashedRequest = await hash3.digest();
      return `${ALGORITHM_IDENTIFIER}
${longDate}
${credentialScope}
${(0, import_util_hex_encoding.toHex)(hashedRequest)}`;
    }
    getCanonicalPath({ path: path5 }) {
      if (this.uriEscapePath) {
        const normalizedPathSegments = [];
        for (const pathSegment of path5.split("/")) {
          if ((pathSegment == null ? undefined : pathSegment.length) === 0)
            continue;
          if (pathSegment === ".")
            continue;
          if (pathSegment === "..") {
            normalizedPathSegments.pop();
          } else {
            normalizedPathSegments.push(pathSegment);
          }
        }
        const normalizedPath = `${(path5 == null ? undefined : path5.startsWith("/")) ? "/" : ""}${normalizedPathSegments.join("/")}${normalizedPathSegments.length > 0 && (path5 == null ? undefined : path5.endsWith("/")) ? "/" : ""}`;
        const doubleEncoded = (0, import_util_uri_escape.escapeUri)(normalizedPath);
        return doubleEncoded.replace(/%2F/g, "/");
      }
      return path5;
    }
    async getSignature(longDate, credentialScope, keyPromise, canonicalRequest) {
      const stringToSign = await this.createStringToSign(longDate, credentialScope, canonicalRequest);
      const hash3 = new this.sha256(await keyPromise);
      hash3.update((0, import_util_utf84.toUint8Array)(stringToSign));
      return (0, import_util_hex_encoding.toHex)(await hash3.digest());
    }
    getSigningKey(credentials, region, shortDate, service) {
      return getSigningKey(this.sha256, credentials, shortDate, region, service || this.service);
    }
    validateResolvedCredentials(credentials) {
      if (typeof credentials !== "object" || typeof credentials.accessKeyId !== "string" || typeof credentials.secretAccessKey !== "string") {
        throw new Error("Resolved credential object is not valid");
      }
    }
  };
  __name(_SignatureV4, "SignatureV4");
  var SignatureV4 = _SignatureV4;
  var formatDate = /* @__PURE__ */ __name((now2) => {
    const longDate = iso8601(now2).replace(/[\-:]/g, "");
    return {
      longDate,
      shortDate: longDate.slice(0, 8)
    };
  }, "formatDate");
  var getCanonicalHeaderList = /* @__PURE__ */ __name((headers) => Object.keys(headers).sort().join(";"), "getCanonicalHeaderList");
});
var require_httpAuthSchemes = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var httpAuthSchemes_exports = {};
  __export32(httpAuthSchemes_exports, {
    AWSSDKSigV4Signer: () => AWSSDKSigV4Signer,
    AwsSdkSigV4ASigner: () => AwsSdkSigV4ASigner,
    AwsSdkSigV4Signer: () => AwsSdkSigV4Signer,
    NODE_SIGV4A_CONFIG_OPTIONS: () => NODE_SIGV4A_CONFIG_OPTIONS,
    resolveAWSSDKSigV4Config: () => resolveAWSSDKSigV4Config,
    resolveAwsSdkSigV4AConfig: () => resolveAwsSdkSigV4AConfig,
    resolveAwsSdkSigV4Config: () => resolveAwsSdkSigV4Config,
    validateSigningProperties: () => validateSigningProperties
  });
  module.exports = __toCommonJS2(httpAuthSchemes_exports);
  var import_protocol_http2 = require_dist_cjs2();
  var import_protocol_http3 = require_dist_cjs2();
  var getDateHeader = /* @__PURE__ */ __name((response) => {
    var _a, _b;
    return import_protocol_http3.HttpResponse.isInstance(response) ? ((_a = response.headers) == null ? undefined : _a.date) ?? ((_b = response.headers) == null ? undefined : _b.Date) : undefined;
  }, "getDateHeader");
  var getSkewCorrectedDate = /* @__PURE__ */ __name((systemClockOffset) => new Date(Date.now() + systemClockOffset), "getSkewCorrectedDate");
  var isClockSkewed = /* @__PURE__ */ __name((clockTime, systemClockOffset) => Math.abs(getSkewCorrectedDate(systemClockOffset).getTime() - clockTime) >= 300000, "isClockSkewed");
  var getUpdatedSystemClockOffset = /* @__PURE__ */ __name((clockTime, currentSystemClockOffset) => {
    const clockTimeInMs = Date.parse(clockTime);
    if (isClockSkewed(clockTimeInMs, currentSystemClockOffset)) {
      return clockTimeInMs - Date.now();
    }
    return currentSystemClockOffset;
  }, "getUpdatedSystemClockOffset");
  var throwSigningPropertyError = /* @__PURE__ */ __name((name, property) => {
    if (!property) {
      throw new Error(`Property \`${name}\` is not resolved for AWS SDK SigV4Auth`);
    }
    return property;
  }, "throwSigningPropertyError");
  var validateSigningProperties = /* @__PURE__ */ __name(async (signingProperties) => {
    var _a, _b, _c;
    const context = throwSigningPropertyError("context", signingProperties.context);
    const config6 = throwSigningPropertyError("config", signingProperties.config);
    const authScheme = (_c = (_b = (_a = context.endpointV2) == null ? undefined : _a.properties) == null ? undefined : _b.authSchemes) == null ? undefined : _c[0];
    const signerFunction = throwSigningPropertyError("signer", config6.signer);
    const signer = await signerFunction(authScheme);
    const signingRegion = signingProperties == null ? undefined : signingProperties.signingRegion;
    const signingRegionSet = signingProperties == null ? undefined : signingProperties.signingRegionSet;
    const signingName = signingProperties == null ? undefined : signingProperties.signingName;
    return {
      config: config6,
      signer,
      signingRegion,
      signingRegionSet,
      signingName
    };
  }, "validateSigningProperties");
  var _AwsSdkSigV4Signer = class _AwsSdkSigV4Signer2 {
    async sign(httpRequest2, identity2, signingProperties) {
      var _a;
      if (!import_protocol_http2.HttpRequest.isInstance(httpRequest2)) {
        throw new Error("The request is not an instance of `HttpRequest` and cannot be signed");
      }
      const validatedProps = await validateSigningProperties(signingProperties);
      const { config: config6, signer } = validatedProps;
      let { signingRegion, signingName } = validatedProps;
      const handlerExecutionContext = signingProperties.context;
      if (((_a = handlerExecutionContext == null ? undefined : handlerExecutionContext.authSchemes) == null ? undefined : _a.length) ?? 0 > 1) {
        const [first, second] = handlerExecutionContext.authSchemes;
        if ((first == null ? undefined : first.name) === "sigv4a" && (second == null ? undefined : second.name) === "sigv4") {
          signingRegion = (second == null ? undefined : second.signingRegion) ?? signingRegion;
          signingName = (second == null ? undefined : second.signingName) ?? signingName;
        }
      }
      const signedRequest = await signer.sign(httpRequest2, {
        signingDate: getSkewCorrectedDate(config6.systemClockOffset),
        signingRegion,
        signingService: signingName
      });
      return signedRequest;
    }
    errorHandler(signingProperties) {
      return (error) => {
        const serverTime = error.ServerTime ?? getDateHeader(error.$response);
        if (serverTime) {
          const config6 = throwSigningPropertyError("config", signingProperties.config);
          const initialSystemClockOffset = config6.systemClockOffset;
          config6.systemClockOffset = getUpdatedSystemClockOffset(serverTime, config6.systemClockOffset);
          const clockSkewCorrected = config6.systemClockOffset !== initialSystemClockOffset;
          if (clockSkewCorrected && error.$metadata) {
            error.$metadata.clockSkewCorrected = true;
          }
        }
        throw error;
      };
    }
    successHandler(httpResponse2, signingProperties) {
      const dateHeader = getDateHeader(httpResponse2);
      if (dateHeader) {
        const config6 = throwSigningPropertyError("config", signingProperties.config);
        config6.systemClockOffset = getUpdatedSystemClockOffset(dateHeader, config6.systemClockOffset);
      }
    }
  };
  __name(_AwsSdkSigV4Signer, "AwsSdkSigV4Signer");
  var AwsSdkSigV4Signer = _AwsSdkSigV4Signer;
  var AWSSDKSigV4Signer = AwsSdkSigV4Signer;
  var import_protocol_http32 = require_dist_cjs2();
  var _AwsSdkSigV4ASigner = class _AwsSdkSigV4ASigner2 extends AwsSdkSigV4Signer {
    async sign(httpRequest2, identity2, signingProperties) {
      var _a;
      if (!import_protocol_http32.HttpRequest.isInstance(httpRequest2)) {
        throw new Error("The request is not an instance of `HttpRequest` and cannot be signed");
      }
      const { config: config6, signer, signingRegion, signingRegionSet, signingName } = await validateSigningProperties(signingProperties);
      const configResolvedSigningRegionSet = await ((_a = config6.sigv4aSigningRegionSet) == null ? undefined : _a.call(config6));
      const multiRegionOverride = (configResolvedSigningRegionSet ?? signingRegionSet ?? [signingRegion]).join(",");
      const signedRequest = await signer.sign(httpRequest2, {
        signingDate: getSkewCorrectedDate(config6.systemClockOffset),
        signingRegion: multiRegionOverride,
        signingService: signingName
      });
      return signedRequest;
    }
  };
  __name(_AwsSdkSigV4ASigner, "AwsSdkSigV4ASigner");
  var AwsSdkSigV4ASigner = _AwsSdkSigV4ASigner;
  var import_core4 = require_dist_cjs15();
  var import_property_provider = require_dist_cjs16();
  var resolveAwsSdkSigV4AConfig = /* @__PURE__ */ __name((config6) => {
    config6.sigv4aSigningRegionSet = (0, import_core4.normalizeProvider)(config6.sigv4aSigningRegionSet);
    return config6;
  }, "resolveAwsSdkSigV4AConfig");
  var NODE_SIGV4A_CONFIG_OPTIONS = {
    environmentVariableSelector(env62) {
      if (env62.AWS_SIGV4A_SIGNING_REGION_SET) {
        return env62.AWS_SIGV4A_SIGNING_REGION_SET.split(",").map((_22) => _22.trim());
      }
      throw new import_property_provider.ProviderError("AWS_SIGV4A_SIGNING_REGION_SET not set in env.", {
        tryNextLink: true
      });
    },
    configFileSelector(profile) {
      if (profile.sigv4a_signing_region_set) {
        return (profile.sigv4a_signing_region_set ?? "").split(",").map((_22) => _22.trim());
      }
      throw new import_property_provider.ProviderError("sigv4a_signing_region_set not set in profile.", {
        tryNextLink: true
      });
    },
    default: undefined
  };
  var import_client = require_client4();
  var import_core22 = require_dist_cjs15();
  var import_signature_v4 = require_dist_cjs17();
  var resolveAwsSdkSigV4Config = /* @__PURE__ */ __name((config6) => {
    let isUserSupplied = false;
    let normalizedCreds;
    if (config6.credentials) {
      isUserSupplied = true;
      normalizedCreds = (0, import_core22.memoizeIdentityProvider)(config6.credentials, import_core22.isIdentityExpired, import_core22.doesIdentityRequireRefresh);
    }
    if (!normalizedCreds) {
      if (config6.credentialDefaultProvider) {
        normalizedCreds = (0, import_core22.normalizeProvider)(config6.credentialDefaultProvider(Object.assign({}, config6, {
          parentClientConfig: config6
        })));
      } else {
        normalizedCreds = /* @__PURE__ */ __name(async () => {
          throw new Error("`credentials` is missing");
        }, "normalizedCreds");
      }
    }
    const {
      signingEscapePath = true,
      systemClockOffset = config6.systemClockOffset || 0,
      sha256
    } = config6;
    let signer;
    if (config6.signer) {
      signer = (0, import_core22.normalizeProvider)(config6.signer);
    } else if (config6.regionInfoProvider) {
      signer = /* @__PURE__ */ __name(() => (0, import_core22.normalizeProvider)(config6.region)().then(async (region) => [
        await config6.regionInfoProvider(region, {
          useFipsEndpoint: await config6.useFipsEndpoint(),
          useDualstackEndpoint: await config6.useDualstackEndpoint()
        }) || {},
        region
      ]).then(([regionInfo, region]) => {
        const { signingRegion, signingService } = regionInfo;
        config6.signingRegion = config6.signingRegion || signingRegion || region;
        config6.signingName = config6.signingName || signingService || config6.serviceId;
        const params = {
          ...config6,
          credentials: normalizedCreds,
          region: config6.signingRegion,
          service: config6.signingName,
          sha256,
          uriEscapePath: signingEscapePath
        };
        const SignerCtor = config6.signerConstructor || import_signature_v4.SignatureV4;
        return new SignerCtor(params);
      }), "signer");
    } else {
      signer = /* @__PURE__ */ __name(async (authScheme) => {
        authScheme = Object.assign({}, {
          name: "sigv4",
          signingName: config6.signingName || config6.defaultSigningName,
          signingRegion: await (0, import_core22.normalizeProvider)(config6.region)(),
          properties: {}
        }, authScheme);
        const signingRegion = authScheme.signingRegion;
        const signingService = authScheme.signingName;
        config6.signingRegion = config6.signingRegion || signingRegion;
        config6.signingName = config6.signingName || signingService || config6.serviceId;
        const params = {
          ...config6,
          credentials: normalizedCreds,
          region: config6.signingRegion,
          service: config6.signingName,
          sha256,
          uriEscapePath: signingEscapePath
        };
        const SignerCtor = config6.signerConstructor || import_signature_v4.SignatureV4;
        return new SignerCtor(params);
      }, "signer");
    }
    return {
      ...config6,
      systemClockOffset,
      signingEscapePath,
      credentials: isUserSupplied ? async () => normalizedCreds().then((creds) => (0, import_client.setCredentialFeature)(creds, "CREDENTIALS_CODE", "e")) : normalizedCreds,
      signer
    };
  }, "resolveAwsSdkSigV4Config");
  var resolveAWSSDKSigV4Config = resolveAwsSdkSigV4Config;
});
var require_dist_cjs18 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    constructStack: () => constructStack
  });
  module.exports = __toCommonJS2(src_exports);
  var getAllAliases = /* @__PURE__ */ __name((name, aliases) => {
    const _aliases = [];
    if (name) {
      _aliases.push(name);
    }
    if (aliases) {
      for (const alias of aliases) {
        _aliases.push(alias);
      }
    }
    return _aliases;
  }, "getAllAliases");
  var getMiddlewareNameWithAliases = /* @__PURE__ */ __name((name, aliases) => {
    return `${name || "anonymous"}${aliases && aliases.length > 0 ? ` (a.k.a. ${aliases.join(",")})` : ""}`;
  }, "getMiddlewareNameWithAliases");
  var constructStack = /* @__PURE__ */ __name(() => {
    let absoluteEntries = [];
    let relativeEntries = [];
    let identifyOnResolve = false;
    const entriesNameSet = /* @__PURE__ */ new Set;
    const sort = /* @__PURE__ */ __name((entries) => entries.sort((a, b22) => stepWeights[b22.step] - stepWeights[a.step] || priorityWeights[b22.priority || "normal"] - priorityWeights[a.priority || "normal"]), "sort");
    const removeByName = /* @__PURE__ */ __name((toRemove) => {
      let isRemoved = false;
      const filterCb = /* @__PURE__ */ __name((entry) => {
        const aliases = getAllAliases(entry.name, entry.aliases);
        if (aliases.includes(toRemove)) {
          isRemoved = true;
          for (const alias of aliases) {
            entriesNameSet.delete(alias);
          }
          return false;
        }
        return true;
      }, "filterCb");
      absoluteEntries = absoluteEntries.filter(filterCb);
      relativeEntries = relativeEntries.filter(filterCb);
      return isRemoved;
    }, "removeByName");
    const removeByReference = /* @__PURE__ */ __name((toRemove) => {
      let isRemoved = false;
      const filterCb = /* @__PURE__ */ __name((entry) => {
        if (entry.middleware === toRemove) {
          isRemoved = true;
          for (const alias of getAllAliases(entry.name, entry.aliases)) {
            entriesNameSet.delete(alias);
          }
          return false;
        }
        return true;
      }, "filterCb");
      absoluteEntries = absoluteEntries.filter(filterCb);
      relativeEntries = relativeEntries.filter(filterCb);
      return isRemoved;
    }, "removeByReference");
    const cloneTo = /* @__PURE__ */ __name((toStack) => {
      var _a;
      absoluteEntries.forEach((entry) => {
        toStack.add(entry.middleware, { ...entry });
      });
      relativeEntries.forEach((entry) => {
        toStack.addRelativeTo(entry.middleware, { ...entry });
      });
      (_a = toStack.identifyOnResolve) == null || _a.call(toStack, stack.identifyOnResolve());
      return toStack;
    }, "cloneTo");
    const expandRelativeMiddlewareList = /* @__PURE__ */ __name((from) => {
      const expandedMiddlewareList = [];
      from.before.forEach((entry) => {
        if (entry.before.length === 0 && entry.after.length === 0) {
          expandedMiddlewareList.push(entry);
        } else {
          expandedMiddlewareList.push(...expandRelativeMiddlewareList(entry));
        }
      });
      expandedMiddlewareList.push(from);
      from.after.reverse().forEach((entry) => {
        if (entry.before.length === 0 && entry.after.length === 0) {
          expandedMiddlewareList.push(entry);
        } else {
          expandedMiddlewareList.push(...expandRelativeMiddlewareList(entry));
        }
      });
      return expandedMiddlewareList;
    }, "expandRelativeMiddlewareList");
    const getMiddlewareList = /* @__PURE__ */ __name((debug = false) => {
      const normalizedAbsoluteEntries = [];
      const normalizedRelativeEntries = [];
      const normalizedEntriesNameMap = {};
      absoluteEntries.forEach((entry) => {
        const normalizedEntry = {
          ...entry,
          before: [],
          after: []
        };
        for (const alias of getAllAliases(normalizedEntry.name, normalizedEntry.aliases)) {
          normalizedEntriesNameMap[alias] = normalizedEntry;
        }
        normalizedAbsoluteEntries.push(normalizedEntry);
      });
      relativeEntries.forEach((entry) => {
        const normalizedEntry = {
          ...entry,
          before: [],
          after: []
        };
        for (const alias of getAllAliases(normalizedEntry.name, normalizedEntry.aliases)) {
          normalizedEntriesNameMap[alias] = normalizedEntry;
        }
        normalizedRelativeEntries.push(normalizedEntry);
      });
      normalizedRelativeEntries.forEach((entry) => {
        if (entry.toMiddleware) {
          const toMiddleware = normalizedEntriesNameMap[entry.toMiddleware];
          if (toMiddleware === undefined) {
            if (debug) {
              return;
            }
            throw new Error(`${entry.toMiddleware} is not found when adding ${getMiddlewareNameWithAliases(entry.name, entry.aliases)} middleware ${entry.relation} ${entry.toMiddleware}`);
          }
          if (entry.relation === "after") {
            toMiddleware.after.push(entry);
          }
          if (entry.relation === "before") {
            toMiddleware.before.push(entry);
          }
        }
      });
      const mainChain = sort(normalizedAbsoluteEntries).map(expandRelativeMiddlewareList).reduce((wholeList, expandedMiddlewareList) => {
        wholeList.push(...expandedMiddlewareList);
        return wholeList;
      }, []);
      return mainChain;
    }, "getMiddlewareList");
    const stack = {
      add: (middleware2, options3 = {}) => {
        const { name, override, aliases: _aliases } = options3;
        const entry = {
          step: "initialize",
          priority: "normal",
          middleware: middleware2,
          ...options3
        };
        const aliases = getAllAliases(name, _aliases);
        if (aliases.length > 0) {
          if (aliases.some((alias) => entriesNameSet.has(alias))) {
            if (!override)
              throw new Error(`Duplicate middleware name '${getMiddlewareNameWithAliases(name, _aliases)}'`);
            for (const alias of aliases) {
              const toOverrideIndex = absoluteEntries.findIndex((entry2) => {
                var _a;
                return entry2.name === alias || ((_a = entry2.aliases) == null ? undefined : _a.some((a) => a === alias));
              });
              if (toOverrideIndex === -1) {
                continue;
              }
              const toOverride = absoluteEntries[toOverrideIndex];
              if (toOverride.step !== entry.step || entry.priority !== toOverride.priority) {
                throw new Error(`"${getMiddlewareNameWithAliases(toOverride.name, toOverride.aliases)}" middleware with ${toOverride.priority} priority in ${toOverride.step} step cannot be overridden by "${getMiddlewareNameWithAliases(name, _aliases)}" middleware with ${entry.priority} priority in ${entry.step} step.`);
              }
              absoluteEntries.splice(toOverrideIndex, 1);
            }
          }
          for (const alias of aliases) {
            entriesNameSet.add(alias);
          }
        }
        absoluteEntries.push(entry);
      },
      addRelativeTo: (middleware2, options3) => {
        const { name, override, aliases: _aliases } = options3;
        const entry = {
          middleware: middleware2,
          ...options3
        };
        const aliases = getAllAliases(name, _aliases);
        if (aliases.length > 0) {
          if (aliases.some((alias) => entriesNameSet.has(alias))) {
            if (!override)
              throw new Error(`Duplicate middleware name '${getMiddlewareNameWithAliases(name, _aliases)}'`);
            for (const alias of aliases) {
              const toOverrideIndex = relativeEntries.findIndex((entry2) => {
                var _a;
                return entry2.name === alias || ((_a = entry2.aliases) == null ? undefined : _a.some((a) => a === alias));
              });
              if (toOverrideIndex === -1) {
                continue;
              }
              const toOverride = relativeEntries[toOverrideIndex];
              if (toOverride.toMiddleware !== entry.toMiddleware || toOverride.relation !== entry.relation) {
                throw new Error(`"${getMiddlewareNameWithAliases(toOverride.name, toOverride.aliases)}" middleware ${toOverride.relation} "${toOverride.toMiddleware}" middleware cannot be overridden by "${getMiddlewareNameWithAliases(name, _aliases)}" middleware ${entry.relation} "${entry.toMiddleware}" middleware.`);
              }
              relativeEntries.splice(toOverrideIndex, 1);
            }
          }
          for (const alias of aliases) {
            entriesNameSet.add(alias);
          }
        }
        relativeEntries.push(entry);
      },
      clone: () => cloneTo(constructStack()),
      use: (plugin) => {
        plugin.applyToStack(stack);
      },
      remove: (toRemove) => {
        if (typeof toRemove === "string")
          return removeByName(toRemove);
        else
          return removeByReference(toRemove);
      },
      removeByTag: (toRemove) => {
        let isRemoved = false;
        const filterCb = /* @__PURE__ */ __name((entry) => {
          const { tags, name, aliases: _aliases } = entry;
          if (tags && tags.includes(toRemove)) {
            const aliases = getAllAliases(name, _aliases);
            for (const alias of aliases) {
              entriesNameSet.delete(alias);
            }
            isRemoved = true;
            return false;
          }
          return true;
        }, "filterCb");
        absoluteEntries = absoluteEntries.filter(filterCb);
        relativeEntries = relativeEntries.filter(filterCb);
        return isRemoved;
      },
      concat: (from) => {
        var _a;
        const cloned = cloneTo(constructStack());
        cloned.use(from);
        cloned.identifyOnResolve(identifyOnResolve || cloned.identifyOnResolve() || (((_a = from.identifyOnResolve) == null ? undefined : _a.call(from)) ?? false));
        return cloned;
      },
      applyToStack: cloneTo,
      identify: () => {
        return getMiddlewareList(true).map((mw) => {
          const step = mw.step ?? mw.relation + " " + mw.toMiddleware;
          return getMiddlewareNameWithAliases(mw.name, mw.aliases) + " - " + step;
        });
      },
      identifyOnResolve(toggle) {
        if (typeof toggle === "boolean")
          identifyOnResolve = toggle;
        return identifyOnResolve;
      },
      resolve: (handler3, context) => {
        for (const middleware2 of getMiddlewareList().map((entry) => entry.middleware).reverse()) {
          handler3 = middleware2(handler3, context);
        }
        if (identifyOnResolve) {
          console.log(stack.identify());
        }
        return handler3;
      }
    };
    return stack;
  }, "constructStack");
  var stepWeights = {
    initialize: 5,
    serialize: 4,
    build: 3,
    finalizeRequest: 2,
    deserialize: 1
  };
  var priorityWeights = {
    high: 3,
    normal: 2,
    low: 1
  };
});
var require_dist_cjs19 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var src_exports = {};
  __export32(src_exports, {
    Client: () => Client,
    Command: () => Command2,
    LazyJsonString: () => LazyJsonString,
    NoOpLogger: () => NoOpLogger,
    SENSITIVE_STRING: () => SENSITIVE_STRING,
    ServiceException: () => ServiceException,
    StringWrapper: () => StringWrapper,
    _json: () => _json,
    collectBody: () => import_protocols.collectBody,
    convertMap: () => convertMap,
    createAggregatedClient: () => createAggregatedClient,
    dateToUtcString: () => dateToUtcString,
    decorateServiceException: () => decorateServiceException,
    emitWarningIfUnsupportedVersion: () => emitWarningIfUnsupportedVersion,
    expectBoolean: () => expectBoolean,
    expectByte: () => expectByte,
    expectFloat32: () => expectFloat32,
    expectInt: () => expectInt,
    expectInt32: () => expectInt32,
    expectLong: () => expectLong,
    expectNonNull: () => expectNonNull,
    expectNumber: () => expectNumber,
    expectObject: () => expectObject,
    expectShort: () => expectShort,
    expectString: () => expectString,
    expectUnion: () => expectUnion,
    extendedEncodeURIComponent: () => import_protocols.extendedEncodeURIComponent,
    getArrayIfSingleItem: () => getArrayIfSingleItem,
    getDefaultClientConfiguration: () => getDefaultClientConfiguration,
    getDefaultExtensionConfiguration: () => getDefaultExtensionConfiguration,
    getValueFromTextNode: () => getValueFromTextNode,
    handleFloat: () => handleFloat,
    isSerializableHeaderValue: () => isSerializableHeaderValue,
    limitedParseDouble: () => limitedParseDouble,
    limitedParseFloat: () => limitedParseFloat,
    limitedParseFloat32: () => limitedParseFloat32,
    loadConfigsForDefaultMode: () => loadConfigsForDefaultMode,
    logger: () => logger22,
    map: () => map2,
    parseBoolean: () => parseBoolean,
    parseEpochTimestamp: () => parseEpochTimestamp,
    parseRfc3339DateTime: () => parseRfc3339DateTime,
    parseRfc3339DateTimeWithOffset: () => parseRfc3339DateTimeWithOffset,
    parseRfc7231DateTime: () => parseRfc7231DateTime,
    quoteHeader: () => quoteHeader,
    resolveDefaultRuntimeConfig: () => resolveDefaultRuntimeConfig,
    resolvedPath: () => import_protocols.resolvedPath,
    serializeDateTime: () => serializeDateTime,
    serializeFloat: () => serializeFloat,
    splitEvery: () => splitEvery,
    splitHeader: () => splitHeader,
    strictParseByte: () => strictParseByte,
    strictParseDouble: () => strictParseDouble,
    strictParseFloat: () => strictParseFloat,
    strictParseFloat32: () => strictParseFloat32,
    strictParseInt: () => strictParseInt,
    strictParseInt32: () => strictParseInt32,
    strictParseLong: () => strictParseLong,
    strictParseShort: () => strictParseShort,
    take: () => take,
    throwDefaultError: () => throwDefaultError,
    withBaseException: () => withBaseException
  });
  module.exports = __toCommonJS2(src_exports);
  var import_middleware_stack = require_dist_cjs18();
  var _Client = class _Client2 {
    constructor(config6) {
      this.config = config6;
      this.middlewareStack = (0, import_middleware_stack.constructStack)();
    }
    send(command2, optionsOrCb, cb) {
      const options3 = typeof optionsOrCb !== "function" ? optionsOrCb : undefined;
      const callback = typeof optionsOrCb === "function" ? optionsOrCb : cb;
      const useHandlerCache = options3 === undefined && this.config.cacheMiddleware === true;
      let handler3;
      if (useHandlerCache) {
        if (!this.handlers) {
          this.handlers = /* @__PURE__ */ new WeakMap;
        }
        const handlers = this.handlers;
        if (handlers.has(command2.constructor)) {
          handler3 = handlers.get(command2.constructor);
        } else {
          handler3 = command2.resolveMiddleware(this.middlewareStack, this.config, options3);
          handlers.set(command2.constructor, handler3);
        }
      } else {
        delete this.handlers;
        handler3 = command2.resolveMiddleware(this.middlewareStack, this.config, options3);
      }
      if (callback) {
        handler3(command2).then((result2) => callback(null, result2.output), (err22) => callback(err22)).catch(() => {
        });
      } else {
        return handler3(command2).then((result2) => result2.output);
      }
    }
    destroy() {
      var _a, _b, _c;
      (_c = (_b = (_a = this.config) == null ? undefined : _a.requestHandler) == null ? undefined : _b.destroy) == null || _c.call(_b);
      delete this.handlers;
    }
  };
  __name(_Client, "Client");
  var Client = _Client;
  var import_protocols = require_protocols();
  var import_types9 = require_dist_cjs();
  var _Command = class _Command2 {
    constructor() {
      this.middlewareStack = (0, import_middleware_stack.constructStack)();
    }
    static classBuilder() {
      return new ClassBuilder;
    }
    resolveMiddlewareWithContext(clientStack, configuration, options3, {
      middlewareFn,
      clientName,
      commandName,
      inputFilterSensitiveLog,
      outputFilterSensitiveLog,
      smithyContext,
      additionalContext,
      CommandCtor
    }) {
      for (const mw of middlewareFn.bind(this)(CommandCtor, clientStack, configuration, options3)) {
        this.middlewareStack.use(mw);
      }
      const stack = clientStack.concat(this.middlewareStack);
      const { logger: logger222 } = configuration;
      const handlerExecutionContext = {
        logger: logger222,
        clientName,
        commandName,
        inputFilterSensitiveLog,
        outputFilterSensitiveLog,
        [import_types9.SMITHY_CONTEXT_KEY]: {
          commandInstance: this,
          ...smithyContext
        },
        ...additionalContext
      };
      const { requestHandler } = configuration;
      return stack.resolve((request42) => requestHandler.handle(request42.request, options3 || {}), handlerExecutionContext);
    }
  };
  __name(_Command, "Command");
  var Command2 = _Command;
  var _ClassBuilder = class _ClassBuilder2 {
    constructor() {
      this._init = () => {
      };
      this._ep = {};
      this._middlewareFn = () => [];
      this._commandName = "";
      this._clientName = "";
      this._additionalContext = {};
      this._smithyContext = {};
      this._inputFilterSensitiveLog = (_22) => _22;
      this._outputFilterSensitiveLog = (_22) => _22;
      this._serializer = null;
      this._deserializer = null;
    }
    init(cb) {
      this._init = cb;
    }
    ep(endpointParameterInstructions) {
      this._ep = endpointParameterInstructions;
      return this;
    }
    m(middlewareSupplier) {
      this._middlewareFn = middlewareSupplier;
      return this;
    }
    s(service, operation, smithyContext = {}) {
      this._smithyContext = {
        service,
        operation,
        ...smithyContext
      };
      return this;
    }
    c(additionalContext = {}) {
      this._additionalContext = additionalContext;
      return this;
    }
    n(clientName, commandName) {
      this._clientName = clientName;
      this._commandName = commandName;
      return this;
    }
    f(inputFilter = (_22) => _22, outputFilter = (_22) => _22) {
      this._inputFilterSensitiveLog = inputFilter;
      this._outputFilterSensitiveLog = outputFilter;
      return this;
    }
    ser(serializer) {
      this._serializer = serializer;
      return this;
    }
    de(deserializer) {
      this._deserializer = deserializer;
      return this;
    }
    build() {
      var _a;
      const closure = this;
      let CommandRef;
      return CommandRef = (_a = class extends Command2 {
        constructor(...[input]) {
          super();
          this.serialize = closure._serializer;
          this.deserialize = closure._deserializer;
          this.input = input ?? {};
          closure._init(this);
        }
        static getEndpointParameterInstructions() {
          return closure._ep;
        }
        resolveMiddleware(stack, configuration, options3) {
          return this.resolveMiddlewareWithContext(stack, configuration, options3, {
            CommandCtor: CommandRef,
            middlewareFn: closure._middlewareFn,
            clientName: closure._clientName,
            commandName: closure._commandName,
            inputFilterSensitiveLog: closure._inputFilterSensitiveLog,
            outputFilterSensitiveLog: closure._outputFilterSensitiveLog,
            smithyContext: closure._smithyContext,
            additionalContext: closure._additionalContext
          });
        }
      }, __name(_a, "CommandRef"), _a);
    }
  };
  __name(_ClassBuilder, "ClassBuilder");
  var ClassBuilder = _ClassBuilder;
  var SENSITIVE_STRING = "***SensitiveInformation***";
  var createAggregatedClient = /* @__PURE__ */ __name((commands, Client2) => {
    for (const command2 of Object.keys(commands)) {
      const CommandCtor = commands[command2];
      const methodImpl = /* @__PURE__ */ __name(async function(args, optionsOrCb, cb) {
        const command22 = new CommandCtor(args);
        if (typeof optionsOrCb === "function") {
          this.send(command22, optionsOrCb);
        } else if (typeof cb === "function") {
          if (typeof optionsOrCb !== "object")
            throw new Error(`Expected http options but got ${typeof optionsOrCb}`);
          this.send(command22, optionsOrCb || {}, cb);
        } else {
          return this.send(command22, optionsOrCb);
        }
      }, "methodImpl");
      const methodName = (command2[0].toLowerCase() + command2.slice(1)).replace(/Command$/, "");
      Client2.prototype[methodName] = methodImpl;
    }
  }, "createAggregatedClient");
  var parseBoolean = /* @__PURE__ */ __name((value) => {
    switch (value) {
      case "true":
        return true;
      case "false":
        return false;
      default:
        throw new Error(`Unable to parse boolean value "${value}"`);
    }
  }, "parseBoolean");
  var expectBoolean = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (typeof value === "number") {
      if (value === 0 || value === 1) {
        logger22.warn(stackTraceWarning(`Expected boolean, got ${typeof value}: ${value}`));
      }
      if (value === 0) {
        return false;
      }
      if (value === 1) {
        return true;
      }
    }
    if (typeof value === "string") {
      const lower = value.toLowerCase();
      if (lower === "false" || lower === "true") {
        logger22.warn(stackTraceWarning(`Expected boolean, got ${typeof value}: ${value}`));
      }
      if (lower === "false") {
        return false;
      }
      if (lower === "true") {
        return true;
      }
    }
    if (typeof value === "boolean") {
      return value;
    }
    throw new TypeError(`Expected boolean, got ${typeof value}: ${value}`);
  }, "expectBoolean");
  var expectNumber = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (typeof value === "string") {
      const parsed = parseFloat(value);
      if (!Number.isNaN(parsed)) {
        if (String(parsed) !== String(value)) {
          logger22.warn(stackTraceWarning(`Expected number but observed string: ${value}`));
        }
        return parsed;
      }
    }
    if (typeof value === "number") {
      return value;
    }
    throw new TypeError(`Expected number, got ${typeof value}: ${value}`);
  }, "expectNumber");
  var MAX_FLOAT = Math.ceil(340282346638528860000000000000000000000);
  var expectFloat32 = /* @__PURE__ */ __name((value) => {
    const expected = expectNumber(value);
    if (expected !== undefined && !Number.isNaN(expected) && expected !== Infinity && expected !== -Infinity) {
      if (Math.abs(expected) > MAX_FLOAT) {
        throw new TypeError(`Expected 32-bit float, got ${value}`);
      }
    }
    return expected;
  }, "expectFloat32");
  var expectLong = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (Number.isInteger(value) && !Number.isNaN(value)) {
      return value;
    }
    throw new TypeError(`Expected integer, got ${typeof value}: ${value}`);
  }, "expectLong");
  var expectInt = expectLong;
  var expectInt32 = /* @__PURE__ */ __name((value) => expectSizedInt(value, 32), "expectInt32");
  var expectShort = /* @__PURE__ */ __name((value) => expectSizedInt(value, 16), "expectShort");
  var expectByte = /* @__PURE__ */ __name((value) => expectSizedInt(value, 8), "expectByte");
  var expectSizedInt = /* @__PURE__ */ __name((value, size) => {
    const expected = expectLong(value);
    if (expected !== undefined && castInt(expected, size) !== expected) {
      throw new TypeError(`Expected ${size}-bit integer, got ${value}`);
    }
    return expected;
  }, "expectSizedInt");
  var castInt = /* @__PURE__ */ __name((value, size) => {
    switch (size) {
      case 32:
        return Int32Array.of(value)[0];
      case 16:
        return Int16Array.of(value)[0];
      case 8:
        return Int8Array.of(value)[0];
    }
  }, "castInt");
  var expectNonNull = /* @__PURE__ */ __name((value, location2) => {
    if (value === null || value === undefined) {
      if (location2) {
        throw new TypeError(`Expected a non-null value for ${location2}`);
      }
      throw new TypeError("Expected a non-null value");
    }
    return value;
  }, "expectNonNull");
  var expectObject = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (typeof value === "object" && !Array.isArray(value)) {
      return value;
    }
    const receivedType = Array.isArray(value) ? "array" : typeof value;
    throw new TypeError(`Expected object, got ${receivedType}: ${value}`);
  }, "expectObject");
  var expectString = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (typeof value === "string") {
      return value;
    }
    if (["boolean", "number", "bigint"].includes(typeof value)) {
      logger22.warn(stackTraceWarning(`Expected string, got ${typeof value}: ${value}`));
      return String(value);
    }
    throw new TypeError(`Expected string, got ${typeof value}: ${value}`);
  }, "expectString");
  var expectUnion = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    const asObject = expectObject(value);
    const setKeys = Object.entries(asObject).filter(([, v22]) => v22 != null).map(([k]) => k);
    if (setKeys.length === 0) {
      throw new TypeError(`Unions must have exactly one non-null member. None were found.`);
    }
    if (setKeys.length > 1) {
      throw new TypeError(`Unions must have exactly one non-null member. Keys ${setKeys} were not null.`);
    }
    return asObject;
  }, "expectUnion");
  var strictParseDouble = /* @__PURE__ */ __name((value) => {
    if (typeof value == "string") {
      return expectNumber(parseNumber(value));
    }
    return expectNumber(value);
  }, "strictParseDouble");
  var strictParseFloat = strictParseDouble;
  var strictParseFloat32 = /* @__PURE__ */ __name((value) => {
    if (typeof value == "string") {
      return expectFloat32(parseNumber(value));
    }
    return expectFloat32(value);
  }, "strictParseFloat32");
  var NUMBER_REGEX = /(-?(?:0|[1-9]\d*)(?:\.\d+)?(?:[eE][+-]?\d+)?)|(-?Infinity)|(NaN)/g;
  var parseNumber = /* @__PURE__ */ __name((value) => {
    const matches = value.match(NUMBER_REGEX);
    if (matches === null || matches[0].length !== value.length) {
      throw new TypeError(`Expected real number, got implicit NaN`);
    }
    return parseFloat(value);
  }, "parseNumber");
  var limitedParseDouble = /* @__PURE__ */ __name((value) => {
    if (typeof value == "string") {
      return parseFloatString(value);
    }
    return expectNumber(value);
  }, "limitedParseDouble");
  var handleFloat = limitedParseDouble;
  var limitedParseFloat = limitedParseDouble;
  var limitedParseFloat32 = /* @__PURE__ */ __name((value) => {
    if (typeof value == "string") {
      return parseFloatString(value);
    }
    return expectFloat32(value);
  }, "limitedParseFloat32");
  var parseFloatString = /* @__PURE__ */ __name((value) => {
    switch (value) {
      case "NaN":
        return NaN;
      case "Infinity":
        return Infinity;
      case "-Infinity":
        return -Infinity;
      default:
        throw new Error(`Unable to parse float value: ${value}`);
    }
  }, "parseFloatString");
  var strictParseLong = /* @__PURE__ */ __name((value) => {
    if (typeof value === "string") {
      return expectLong(parseNumber(value));
    }
    return expectLong(value);
  }, "strictParseLong");
  var strictParseInt = strictParseLong;
  var strictParseInt32 = /* @__PURE__ */ __name((value) => {
    if (typeof value === "string") {
      return expectInt32(parseNumber(value));
    }
    return expectInt32(value);
  }, "strictParseInt32");
  var strictParseShort = /* @__PURE__ */ __name((value) => {
    if (typeof value === "string") {
      return expectShort(parseNumber(value));
    }
    return expectShort(value);
  }, "strictParseShort");
  var strictParseByte = /* @__PURE__ */ __name((value) => {
    if (typeof value === "string") {
      return expectByte(parseNumber(value));
    }
    return expectByte(value);
  }, "strictParseByte");
  var stackTraceWarning = /* @__PURE__ */ __name((message) => {
    return String(new TypeError(message).stack || message).split("\n").slice(0, 5).filter((s32) => !s32.includes("stackTraceWarning")).join("\n");
  }, "stackTraceWarning");
  var logger22 = {
    warn: console.warn
  };
  var DAYS = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
  var MONTHS = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
  function dateToUtcString(date) {
    const year = date.getUTCFullYear();
    const month = date.getUTCMonth();
    const dayOfWeek = date.getUTCDay();
    const dayOfMonthInt = date.getUTCDate();
    const hoursInt = date.getUTCHours();
    const minutesInt = date.getUTCMinutes();
    const secondsInt = date.getUTCSeconds();
    const dayOfMonthString = dayOfMonthInt < 10 ? `0${dayOfMonthInt}` : `${dayOfMonthInt}`;
    const hoursString = hoursInt < 10 ? `0${hoursInt}` : `${hoursInt}`;
    const minutesString = minutesInt < 10 ? `0${minutesInt}` : `${minutesInt}`;
    const secondsString = secondsInt < 10 ? `0${secondsInt}` : `${secondsInt}`;
    return `${DAYS[dayOfWeek]}, ${dayOfMonthString} ${MONTHS[month]} ${year} ${hoursString}:${minutesString}:${secondsString} GMT`;
  }
  __name(dateToUtcString, "dateToUtcString");
  var RFC3339 = new RegExp(/^(\d{4})-(\d{2})-(\d{2})[tT](\d{2}):(\d{2}):(\d{2})(?:\.(\d+))?[zZ]$/);
  var parseRfc3339DateTime = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (typeof value !== "string") {
      throw new TypeError("RFC-3339 date-times must be expressed as strings");
    }
    const match = RFC3339.exec(value);
    if (!match) {
      throw new TypeError("Invalid RFC-3339 date-time value");
    }
    const [_22, yearStr, monthStr, dayStr, hours, minutes, seconds, fractionalMilliseconds] = match;
    const year = strictParseShort(stripLeadingZeroes(yearStr));
    const month = parseDateValue(monthStr, "month", 1, 12);
    const day = parseDateValue(dayStr, "day", 1, 31);
    return buildDate(year, month, day, { hours, minutes, seconds, fractionalMilliseconds });
  }, "parseRfc3339DateTime");
  var RFC3339_WITH_OFFSET = new RegExp(/^(\d{4})-(\d{2})-(\d{2})[tT](\d{2}):(\d{2}):(\d{2})(?:\.(\d+))?(([-+]\d{2}\:\d{2})|[zZ])$/);
  var parseRfc3339DateTimeWithOffset = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (typeof value !== "string") {
      throw new TypeError("RFC-3339 date-times must be expressed as strings");
    }
    const match = RFC3339_WITH_OFFSET.exec(value);
    if (!match) {
      throw new TypeError("Invalid RFC-3339 date-time value");
    }
    const [_22, yearStr, monthStr, dayStr, hours, minutes, seconds, fractionalMilliseconds, offsetStr] = match;
    const year = strictParseShort(stripLeadingZeroes(yearStr));
    const month = parseDateValue(monthStr, "month", 1, 12);
    const day = parseDateValue(dayStr, "day", 1, 31);
    const date = buildDate(year, month, day, { hours, minutes, seconds, fractionalMilliseconds });
    if (offsetStr.toUpperCase() != "Z") {
      date.setTime(date.getTime() - parseOffsetToMilliseconds(offsetStr));
    }
    return date;
  }, "parseRfc3339DateTimeWithOffset");
  var IMF_FIXDATE = new RegExp(/^(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun), (\d{2}) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) (\d{4}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? GMT$/);
  var RFC_850_DATE = new RegExp(/^(?:Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday), (\d{2})-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-(\d{2}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? GMT$/);
  var ASC_TIME = new RegExp(/^(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ( [1-9]|\d{2}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? (\d{4})$/);
  var parseRfc7231DateTime = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    if (typeof value !== "string") {
      throw new TypeError("RFC-7231 date-times must be expressed as strings");
    }
    let match = IMF_FIXDATE.exec(value);
    if (match) {
      const [_22, dayStr, monthStr, yearStr, hours, minutes, seconds, fractionalMilliseconds] = match;
      return buildDate(strictParseShort(stripLeadingZeroes(yearStr)), parseMonthByShortName(monthStr), parseDateValue(dayStr, "day", 1, 31), { hours, minutes, seconds, fractionalMilliseconds });
    }
    match = RFC_850_DATE.exec(value);
    if (match) {
      const [_22, dayStr, monthStr, yearStr, hours, minutes, seconds, fractionalMilliseconds] = match;
      return adjustRfc850Year(buildDate(parseTwoDigitYear(yearStr), parseMonthByShortName(monthStr), parseDateValue(dayStr, "day", 1, 31), {
        hours,
        minutes,
        seconds,
        fractionalMilliseconds
      }));
    }
    match = ASC_TIME.exec(value);
    if (match) {
      const [_22, monthStr, dayStr, hours, minutes, seconds, fractionalMilliseconds, yearStr] = match;
      return buildDate(strictParseShort(stripLeadingZeroes(yearStr)), parseMonthByShortName(monthStr), parseDateValue(dayStr.trimLeft(), "day", 1, 31), { hours, minutes, seconds, fractionalMilliseconds });
    }
    throw new TypeError("Invalid RFC-7231 date-time value");
  }, "parseRfc7231DateTime");
  var parseEpochTimestamp = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return;
    }
    let valueAsDouble;
    if (typeof value === "number") {
      valueAsDouble = value;
    } else if (typeof value === "string") {
      valueAsDouble = strictParseDouble(value);
    } else if (typeof value === "object" && value.tag === 1) {
      valueAsDouble = value.value;
    } else {
      throw new TypeError("Epoch timestamps must be expressed as floating point numbers or their string representation");
    }
    if (Number.isNaN(valueAsDouble) || valueAsDouble === Infinity || valueAsDouble === -Infinity) {
      throw new TypeError("Epoch timestamps must be valid, non-Infinite, non-NaN numerics");
    }
    return new Date(Math.round(valueAsDouble * 1000));
  }, "parseEpochTimestamp");
  var buildDate = /* @__PURE__ */ __name((year, month, day, time) => {
    const adjustedMonth = month - 1;
    validateDayOfMonth(year, adjustedMonth, day);
    return new Date(Date.UTC(year, adjustedMonth, day, parseDateValue(time.hours, "hour", 0, 23), parseDateValue(time.minutes, "minute", 0, 59), parseDateValue(time.seconds, "seconds", 0, 60), parseMilliseconds(time.fractionalMilliseconds)));
  }, "buildDate");
  var parseTwoDigitYear = /* @__PURE__ */ __name((value) => {
    const thisYear = (/* @__PURE__ */ new Date()).getUTCFullYear();
    const valueInThisCentury = Math.floor(thisYear / 100) * 100 + strictParseShort(stripLeadingZeroes(value));
    if (valueInThisCentury < thisYear) {
      return valueInThisCentury + 100;
    }
    return valueInThisCentury;
  }, "parseTwoDigitYear");
  var FIFTY_YEARS_IN_MILLIS = 1576800000000;
  var adjustRfc850Year = /* @__PURE__ */ __name((input) => {
    if (input.getTime() - (/* @__PURE__ */ new Date()).getTime() > FIFTY_YEARS_IN_MILLIS) {
      return new Date(Date.UTC(input.getUTCFullYear() - 100, input.getUTCMonth(), input.getUTCDate(), input.getUTCHours(), input.getUTCMinutes(), input.getUTCSeconds(), input.getUTCMilliseconds()));
    }
    return input;
  }, "adjustRfc850Year");
  var parseMonthByShortName = /* @__PURE__ */ __name((value) => {
    const monthIdx = MONTHS.indexOf(value);
    if (monthIdx < 0) {
      throw new TypeError(`Invalid month: ${value}`);
    }
    return monthIdx + 1;
  }, "parseMonthByShortName");
  var DAYS_IN_MONTH = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  var validateDayOfMonth = /* @__PURE__ */ __name((year, month, day) => {
    let maxDays = DAYS_IN_MONTH[month];
    if (month === 1 && isLeapYear(year)) {
      maxDays = 29;
    }
    if (day > maxDays) {
      throw new TypeError(`Invalid day for ${MONTHS[month]} in ${year}: ${day}`);
    }
  }, "validateDayOfMonth");
  var isLeapYear = /* @__PURE__ */ __name((year) => {
    return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
  }, "isLeapYear");
  var parseDateValue = /* @__PURE__ */ __name((value, type2, lower, upper) => {
    const dateVal = strictParseByte(stripLeadingZeroes(value));
    if (dateVal < lower || dateVal > upper) {
      throw new TypeError(`${type2} must be between ${lower} and ${upper}, inclusive`);
    }
    return dateVal;
  }, "parseDateValue");
  var parseMilliseconds = /* @__PURE__ */ __name((value) => {
    if (value === null || value === undefined) {
      return 0;
    }
    return strictParseFloat32("0." + value) * 1000;
  }, "parseMilliseconds");
  var parseOffsetToMilliseconds = /* @__PURE__ */ __name((value) => {
    const directionStr = value[0];
    let direction = 1;
    if (directionStr == "+") {
      direction = 1;
    } else if (directionStr == "-") {
      direction = -1;
    } else {
      throw new TypeError(`Offset direction, ${directionStr}, must be "+" or "-"`);
    }
    const hour = Number(value.substring(1, 3));
    const minute = Number(value.substring(4, 6));
    return direction * (hour * 60 + minute) * 60 * 1000;
  }, "parseOffsetToMilliseconds");
  var stripLeadingZeroes = /* @__PURE__ */ __name((value) => {
    let idx = 0;
    while (idx < value.length - 1 && value.charAt(idx) === "0") {
      idx++;
    }
    if (idx === 0) {
      return value;
    }
    return value.slice(idx);
  }, "stripLeadingZeroes");
  var _ServiceException = class _ServiceException2 extends Error {
    constructor(options3) {
      super(options3.message);
      Object.setPrototypeOf(this, _ServiceException2.prototype);
      this.name = options3.name;
      this.$fault = options3.$fault;
      this.$metadata = options3.$metadata;
    }
  };
  __name(_ServiceException, "ServiceException");
  var ServiceException = _ServiceException;
  var decorateServiceException = /* @__PURE__ */ __name((exception2, additions = {}) => {
    Object.entries(additions).filter(([, v22]) => v22 !== undefined).forEach(([k, v22]) => {
      if (exception2[k] == undefined || exception2[k] === "") {
        exception2[k] = v22;
      }
    });
    const message = exception2.message || exception2.Message || "UnknownError";
    exception2.message = message;
    delete exception2.Message;
    return exception2;
  }, "decorateServiceException");
  var throwDefaultError = /* @__PURE__ */ __name(({ output, parsedBody, exceptionCtor, errorCode }) => {
    const $metadata = deserializeMetadata(output);
    const statusCode = $metadata.httpStatusCode ? $metadata.httpStatusCode + "" : undefined;
    const response = new exceptionCtor({
      name: (parsedBody == null ? undefined : parsedBody.code) || (parsedBody == null ? undefined : parsedBody.Code) || errorCode || statusCode || "UnknownError",
      $fault: "client",
      $metadata
    });
    throw decorateServiceException(response, parsedBody);
  }, "throwDefaultError");
  var withBaseException = /* @__PURE__ */ __name((ExceptionCtor) => {
    return ({ output, parsedBody, errorCode }) => {
      throwDefaultError({ output, parsedBody, exceptionCtor: ExceptionCtor, errorCode });
    };
  }, "withBaseException");
  var deserializeMetadata = /* @__PURE__ */ __name((output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"]
  }), "deserializeMetadata");
  var loadConfigsForDefaultMode = /* @__PURE__ */ __name((mode2) => {
    switch (mode2) {
      case "standard":
        return {
          retryMode: "standard",
          connectionTimeout: 3100
        };
      case "in-region":
        return {
          retryMode: "standard",
          connectionTimeout: 1100
        };
      case "cross-region":
        return {
          retryMode: "standard",
          connectionTimeout: 3100
        };
      case "mobile":
        return {
          retryMode: "standard",
          connectionTimeout: 30000
        };
      default:
        return {};
    }
  }, "loadConfigsForDefaultMode");
  var warningEmitted = false;
  var emitWarningIfUnsupportedVersion = /* @__PURE__ */ __name((version5) => {
    if (version5 && !warningEmitted && parseInt(version5.substring(1, version5.indexOf("."))) < 16) {
      warningEmitted = true;
    }
  }, "emitWarningIfUnsupportedVersion");
  var getChecksumConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
    const checksumAlgorithms = [];
    for (const id in import_types9.AlgorithmId) {
      const algorithmId = import_types9.AlgorithmId[id];
      if (runtimeConfig[algorithmId] === undefined) {
        continue;
      }
      checksumAlgorithms.push({
        algorithmId: () => algorithmId,
        checksumConstructor: () => runtimeConfig[algorithmId]
      });
    }
    return {
      _checksumAlgorithms: checksumAlgorithms,
      addChecksumAlgorithm(algo) {
        this._checksumAlgorithms.push(algo);
      },
      checksumAlgorithms() {
        return this._checksumAlgorithms;
      }
    };
  }, "getChecksumConfiguration");
  var resolveChecksumRuntimeConfig = /* @__PURE__ */ __name((clientConfig) => {
    const runtimeConfig = {};
    clientConfig.checksumAlgorithms().forEach((checksumAlgorithm) => {
      runtimeConfig[checksumAlgorithm.algorithmId()] = checksumAlgorithm.checksumConstructor();
    });
    return runtimeConfig;
  }, "resolveChecksumRuntimeConfig");
  var getRetryConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
    let _retryStrategy = runtimeConfig.retryStrategy;
    return {
      setRetryStrategy(retryStrategy) {
        _retryStrategy = retryStrategy;
      },
      retryStrategy() {
        return _retryStrategy;
      }
    };
  }, "getRetryConfiguration");
  var resolveRetryRuntimeConfig = /* @__PURE__ */ __name((retryStrategyConfiguration) => {
    const runtimeConfig = {};
    runtimeConfig.retryStrategy = retryStrategyConfiguration.retryStrategy();
    return runtimeConfig;
  }, "resolveRetryRuntimeConfig");
  var getDefaultExtensionConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
    return {
      ...getChecksumConfiguration(runtimeConfig),
      ...getRetryConfiguration(runtimeConfig)
    };
  }, "getDefaultExtensionConfiguration");
  var getDefaultClientConfiguration = getDefaultExtensionConfiguration;
  var resolveDefaultRuntimeConfig = /* @__PURE__ */ __name((config6) => {
    return {
      ...resolveChecksumRuntimeConfig(config6),
      ...resolveRetryRuntimeConfig(config6)
    };
  }, "resolveDefaultRuntimeConfig");
  var getArrayIfSingleItem = /* @__PURE__ */ __name((mayBeArray) => Array.isArray(mayBeArray) ? mayBeArray : [mayBeArray], "getArrayIfSingleItem");
  var getValueFromTextNode = /* @__PURE__ */ __name((obj) => {
    const textNodeName = "#text";
    for (const key2 in obj) {
      if (obj.hasOwnProperty(key2) && obj[key2][textNodeName] !== undefined) {
        obj[key2] = obj[key2][textNodeName];
      } else if (typeof obj[key2] === "object" && obj[key2] !== null) {
        obj[key2] = getValueFromTextNode(obj[key2]);
      }
    }
    return obj;
  }, "getValueFromTextNode");
  var isSerializableHeaderValue = /* @__PURE__ */ __name((value) => {
    return value != null;
  }, "isSerializableHeaderValue");
  var StringWrapper = /* @__PURE__ */ __name(function() {
    const Class = Object.getPrototypeOf(this).constructor;
    const Constructor = Function.bind.apply(String, [null, ...arguments]);
    const instance = new Constructor;
    Object.setPrototypeOf(instance, Class.prototype);
    return instance;
  }, "StringWrapper");
  StringWrapper.prototype = Object.create(String.prototype, {
    constructor: {
      value: StringWrapper,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  Object.setPrototypeOf(StringWrapper, String);
  var _LazyJsonString = class _LazyJsonString2 extends StringWrapper {
    deserializeJSON() {
      return JSON.parse(super.toString());
    }
    toJSON() {
      return super.toString();
    }
    static fromObject(object) {
      if (object instanceof _LazyJsonString2) {
        return object;
      } else if (object instanceof String || typeof object === "string") {
        return new _LazyJsonString2(object);
      }
      return new _LazyJsonString2(JSON.stringify(object));
    }
  };
  __name(_LazyJsonString, "LazyJsonString");
  var LazyJsonString = _LazyJsonString;
  var _NoOpLogger = class _NoOpLogger2 {
    trace() {
    }
    debug() {
    }
    info() {
    }
    warn() {
    }
    error() {
    }
  };
  __name(_NoOpLogger, "NoOpLogger");
  var NoOpLogger = _NoOpLogger;
  function map2(arg0, arg1, arg2) {
    let target;
    let filter;
    let instructions;
    if (typeof arg1 === "undefined" && typeof arg2 === "undefined") {
      target = {};
      instructions = arg0;
    } else {
      target = arg0;
      if (typeof arg1 === "function") {
        filter = arg1;
        instructions = arg2;
        return mapWithFilter(target, filter, instructions);
      } else {
        instructions = arg1;
      }
    }
    for (const key2 of Object.keys(instructions)) {
      if (!Array.isArray(instructions[key2])) {
        target[key2] = instructions[key2];
        continue;
      }
      applyInstruction(target, null, instructions, key2);
    }
    return target;
  }
  __name(map2, "map");
  var convertMap = /* @__PURE__ */ __name((target) => {
    const output = {};
    for (const [k, v22] of Object.entries(target || {})) {
      output[k] = [, v22];
    }
    return output;
  }, "convertMap");
  var take = /* @__PURE__ */ __name((source, instructions) => {
    const out = {};
    for (const key2 in instructions) {
      applyInstruction(out, source, instructions, key2);
    }
    return out;
  }, "take");
  var mapWithFilter = /* @__PURE__ */ __name((target, filter, instructions) => {
    return map2(target, Object.entries(instructions).reduce((_instructions, [key2, value]) => {
      if (Array.isArray(value)) {
        _instructions[key2] = value;
      } else {
        if (typeof value === "function") {
          _instructions[key2] = [filter, value()];
        } else {
          _instructions[key2] = [filter, value];
        }
      }
      return _instructions;
    }, {}));
  }, "mapWithFilter");
  var applyInstruction = /* @__PURE__ */ __name((target, source, instructions, targetKey) => {
    if (source !== null) {
      let instruction = instructions[targetKey];
      if (typeof instruction === "function") {
        instruction = [, instruction];
      }
      const [filter2 = nonNullish, valueFn = pass, sourceKey = targetKey] = instruction;
      if (typeof filter2 === "function" && filter2(source[sourceKey]) || typeof filter2 !== "function" && !!filter2) {
        target[targetKey] = valueFn(source[sourceKey]);
      }
      return;
    }
    let [filter, value] = instructions[targetKey];
    if (typeof value === "function") {
      let _value;
      const defaultFilterPassed = filter === undefined && (_value = value()) != null;
      const customFilterPassed = typeof filter === "function" && !!filter(undefined) || typeof filter !== "function" && !!filter;
      if (defaultFilterPassed) {
        target[targetKey] = _value;
      } else if (customFilterPassed) {
        target[targetKey] = value();
      }
    } else {
      const defaultFilterPassed = filter === undefined && value != null;
      const customFilterPassed = typeof filter === "function" && !!filter(value) || typeof filter !== "function" && !!filter;
      if (defaultFilterPassed || customFilterPassed) {
        target[targetKey] = value;
      }
    }
  }, "applyInstruction");
  var nonNullish = /* @__PURE__ */ __name((_22) => _22 != null, "nonNullish");
  var pass = /* @__PURE__ */ __name((_22) => _22, "pass");
  function quoteHeader(part) {
    if (part.includes(",") || part.includes('"')) {
      part = `"${part.replace(/"/g, '\\"')}"`;
    }
    return part;
  }
  __name(quoteHeader, "quoteHeader");
  var serializeFloat = /* @__PURE__ */ __name((value) => {
    if (value !== value) {
      return "NaN";
    }
    switch (value) {
      case Infinity:
        return "Infinity";
      case -Infinity:
        return "-Infinity";
      default:
        return value;
    }
  }, "serializeFloat");
  var serializeDateTime = /* @__PURE__ */ __name((date) => date.toISOString().replace(".000Z", "Z"), "serializeDateTime");
  var _json = /* @__PURE__ */ __name((obj) => {
    if (obj == null) {
      return {};
    }
    if (Array.isArray(obj)) {
      return obj.filter((_22) => _22 != null).map(_json);
    }
    if (typeof obj === "object") {
      const target = {};
      for (const key2 of Object.keys(obj)) {
        if (obj[key2] == null) {
          continue;
        }
        target[key2] = _json(obj[key2]);
      }
      return target;
    }
    return obj;
  }, "_json");
  function splitEvery(value, delimiter22, numDelimiters) {
    if (numDelimiters <= 0 || !Number.isInteger(numDelimiters)) {
      throw new Error("Invalid number of delimiters (" + numDelimiters + ") for splitEvery.");
    }
    const segments = value.split(delimiter22);
    if (numDelimiters === 1) {
      return segments;
    }
    const compoundSegments = [];
    let currentSegment = "";
    for (let i2 = 0;i2 < segments.length; i2++) {
      if (currentSegment === "") {
        currentSegment = segments[i2];
      } else {
        currentSegment += delimiter22 + segments[i2];
      }
      if ((i2 + 1) % numDelimiters === 0) {
        compoundSegments.push(currentSegment);
        currentSegment = "";
      }
    }
    if (currentSegment !== "") {
      compoundSegments.push(currentSegment);
    }
    return compoundSegments;
  }
  __name(splitEvery, "splitEvery");
  var splitHeader = /* @__PURE__ */ __name((value) => {
    const z22 = value.length;
    const values3 = [];
    let withinQuotes = false;
    let prevChar = undefined;
    let anchor = 0;
    for (let i2 = 0;i2 < z22; ++i2) {
      const char = value[i2];
      switch (char) {
        case `"`:
          if (prevChar !== "\\") {
            withinQuotes = !withinQuotes;
          }
          break;
        case ",":
          if (!withinQuotes) {
            values3.push(value.slice(anchor, i2));
            anchor = i2 + 1;
          }
          break;
        default:
      }
      prevChar = char;
    }
    values3.push(value.slice(anchor));
    return values3.map((v22) => {
      v22 = v22.trim();
      const z222 = v22.length;
      if (z222 < 2) {
        return v22;
      }
      if (v22[0] === `"` && v22[z222 - 1] === `"`) {
        v22 = v22.slice(1, z222 - 1);
      }
      return v22.replace(/\\"/g, '"');
    });
  }, "splitHeader");
});
var require_util4 = __commonJS2((exports) => {
  var nameStartChar = ":A-Za-z_\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD";
  var nameChar = nameStartChar + "\\-.\\d\\u00B7\\u0300-\\u036F\\u203F-\\u2040";
  var nameRegexp = "[" + nameStartChar + "][" + nameChar + "]*";
  var regexName = new RegExp("^" + nameRegexp + "$");
  var getAllMatches = function(string2, regex32) {
    const matches = [];
    let match = regex32.exec(string2);
    while (match) {
      const allmatches = [];
      allmatches.startIndex = regex32.lastIndex - match[0].length;
      const len = match.length;
      for (let index = 0;index < len; index++) {
        allmatches.push(match[index]);
      }
      matches.push(allmatches);
      match = regex32.exec(string2);
    }
    return matches;
  };
  var isName = function(string2) {
    const match = regexName.exec(string2);
    return !(match === null || typeof match === "undefined");
  };
  exports.isExist = function(v22) {
    return typeof v22 !== "undefined";
  };
  exports.isEmptyObject = function(obj) {
    return Object.keys(obj).length === 0;
  };
  exports.merge = function(target, a, arrayMode) {
    if (a) {
      const keys2 = Object.keys(a);
      const len = keys2.length;
      for (let i2 = 0;i2 < len; i2++) {
        if (arrayMode === "strict") {
          target[keys2[i2]] = [a[keys2[i2]]];
        } else {
          target[keys2[i2]] = a[keys2[i2]];
        }
      }
    }
  };
  exports.getValue = function(v22) {
    if (exports.isExist(v22)) {
      return v22;
    } else {
      return "";
    }
  };
  exports.isName = isName;
  exports.getAllMatches = getAllMatches;
  exports.nameRegexp = nameRegexp;
});
var require_validator = __commonJS2((exports) => {
  var util = require_util4();
  var defaultOptions2 = {
    allowBooleanAttributes: false,
    unpairedTags: []
  };
  exports.validate = function(xmlData, options3) {
    options3 = Object.assign({}, defaultOptions2, options3);
    const tags = [];
    let tagFound = false;
    let reachedRoot = false;
    if (xmlData[0] === "\uFEFF") {
      xmlData = xmlData.substr(1);
    }
    for (let i2 = 0;i2 < xmlData.length; i2++) {
      if (xmlData[i2] === "<" && xmlData[i2 + 1] === "?") {
        i2 += 2;
        i2 = readPI(xmlData, i2);
        if (i2.err)
          return i2;
      } else if (xmlData[i2] === "<") {
        let tagStartPos = i2;
        i2++;
        if (xmlData[i2] === "!") {
          i2 = readCommentAndCDATA(xmlData, i2);
          continue;
        } else {
          let closingTag = false;
          if (xmlData[i2] === "/") {
            closingTag = true;
            i2++;
          }
          let tagName = "";
          for (;i2 < xmlData.length && xmlData[i2] !== ">" && xmlData[i2] !== " " && xmlData[i2] !== "\t" && xmlData[i2] !== "\n" && xmlData[i2] !== "\r"; i2++) {
            tagName += xmlData[i2];
          }
          tagName = tagName.trim();
          if (tagName[tagName.length - 1] === "/") {
            tagName = tagName.substring(0, tagName.length - 1);
            i2--;
          }
          if (!validateTagName(tagName)) {
            let msg;
            if (tagName.trim().length === 0) {
              msg = "Invalid space after '<'.";
            } else {
              msg = "Tag '" + tagName + "' is an invalid name.";
            }
            return getErrorObject("InvalidTag", msg, getLineNumberForPosition(xmlData, i2));
          }
          const result2 = readAttributeStr(xmlData, i2);
          if (result2 === false) {
            return getErrorObject("InvalidAttr", "Attributes for '" + tagName + "' have open quote.", getLineNumberForPosition(xmlData, i2));
          }
          let attrStr = result2.value;
          i2 = result2.index;
          if (attrStr[attrStr.length - 1] === "/") {
            const attrStrStart = i2 - attrStr.length;
            attrStr = attrStr.substring(0, attrStr.length - 1);
            const isValid = validateAttributeString(attrStr, options3);
            if (isValid === true) {
              tagFound = true;
            } else {
              return getErrorObject(isValid.err.code, isValid.err.msg, getLineNumberForPosition(xmlData, attrStrStart + isValid.err.line));
            }
          } else if (closingTag) {
            if (!result2.tagClosed) {
              return getErrorObject("InvalidTag", "Closing tag '" + tagName + "' doesn't have proper closing.", getLineNumberForPosition(xmlData, i2));
            } else if (attrStr.trim().length > 0) {
              return getErrorObject("InvalidTag", "Closing tag '" + tagName + "' can't have attributes or invalid starting.", getLineNumberForPosition(xmlData, tagStartPos));
            } else if (tags.length === 0) {
              return getErrorObject("InvalidTag", "Closing tag '" + tagName + "' has not been opened.", getLineNumberForPosition(xmlData, tagStartPos));
            } else {
              const otg = tags.pop();
              if (tagName !== otg.tagName) {
                let openPos = getLineNumberForPosition(xmlData, otg.tagStartPos);
                return getErrorObject("InvalidTag", "Expected closing tag '" + otg.tagName + "' (opened in line " + openPos.line + ", col " + openPos.col + ") instead of closing tag '" + tagName + "'.", getLineNumberForPosition(xmlData, tagStartPos));
              }
              if (tags.length == 0) {
                reachedRoot = true;
              }
            }
          } else {
            const isValid = validateAttributeString(attrStr, options3);
            if (isValid !== true) {
              return getErrorObject(isValid.err.code, isValid.err.msg, getLineNumberForPosition(xmlData, i2 - attrStr.length + isValid.err.line));
            }
            if (reachedRoot === true) {
              return getErrorObject("InvalidXml", "Multiple possible root nodes found.", getLineNumberForPosition(xmlData, i2));
            } else if (options3.unpairedTags.indexOf(tagName) !== -1) {
            } else {
              tags.push({ tagName, tagStartPos });
            }
            tagFound = true;
          }
          for (i2++;i2 < xmlData.length; i2++) {
            if (xmlData[i2] === "<") {
              if (xmlData[i2 + 1] === "!") {
                i2++;
                i2 = readCommentAndCDATA(xmlData, i2);
                continue;
              } else if (xmlData[i2 + 1] === "?") {
                i2 = readPI(xmlData, ++i2);
                if (i2.err)
                  return i2;
              } else {
                break;
              }
            } else if (xmlData[i2] === "&") {
              const afterAmp = validateAmpersand(xmlData, i2);
              if (afterAmp == -1)
                return getErrorObject("InvalidChar", "char '&' is not expected.", getLineNumberForPosition(xmlData, i2));
              i2 = afterAmp;
            } else {
              if (reachedRoot === true && !isWhiteSpace(xmlData[i2])) {
                return getErrorObject("InvalidXml", "Extra text at the end", getLineNumberForPosition(xmlData, i2));
              }
            }
          }
          if (xmlData[i2] === "<") {
            i2--;
          }
        }
      } else {
        if (isWhiteSpace(xmlData[i2])) {
          continue;
        }
        return getErrorObject("InvalidChar", "char '" + xmlData[i2] + "' is not expected.", getLineNumberForPosition(xmlData, i2));
      }
    }
    if (!tagFound) {
      return getErrorObject("InvalidXml", "Start tag expected.", 1);
    } else if (tags.length == 1) {
      return getErrorObject("InvalidTag", "Unclosed tag '" + tags[0].tagName + "'.", getLineNumberForPosition(xmlData, tags[0].tagStartPos));
    } else if (tags.length > 0) {
      return getErrorObject("InvalidXml", "Invalid '" + JSON.stringify(tags.map((t) => t.tagName), null, 4).replace(/\r?\n/g, "") + "' found.", { line: 1, col: 1 });
    }
    return true;
  };
  function isWhiteSpace(char) {
    return char === " " || char === "\t" || char === "\n" || char === "\r";
  }
  function readPI(xmlData, i2) {
    const start = i2;
    for (;i2 < xmlData.length; i2++) {
      if (xmlData[i2] == "?" || xmlData[i2] == " ") {
        const tagname = xmlData.substr(start, i2 - start);
        if (i2 > 5 && tagname === "xml") {
          return getErrorObject("InvalidXml", "XML declaration allowed only at the start of the document.", getLineNumberForPosition(xmlData, i2));
        } else if (xmlData[i2] == "?" && xmlData[i2 + 1] == ">") {
          i2++;
          break;
        } else {
          continue;
        }
      }
    }
    return i2;
  }
  function readCommentAndCDATA(xmlData, i2) {
    if (xmlData.length > i2 + 5 && xmlData[i2 + 1] === "-" && xmlData[i2 + 2] === "-") {
      for (i2 += 3;i2 < xmlData.length; i2++) {
        if (xmlData[i2] === "-" && xmlData[i2 + 1] === "-" && xmlData[i2 + 2] === ">") {
          i2 += 2;
          break;
        }
      }
    } else if (xmlData.length > i2 + 8 && xmlData[i2 + 1] === "D" && xmlData[i2 + 2] === "O" && xmlData[i2 + 3] === "C" && xmlData[i2 + 4] === "T" && xmlData[i2 + 5] === "Y" && xmlData[i2 + 6] === "P" && xmlData[i2 + 7] === "E") {
      let angleBracketsCount = 1;
      for (i2 += 8;i2 < xmlData.length; i2++) {
        if (xmlData[i2] === "<") {
          angleBracketsCount++;
        } else if (xmlData[i2] === ">") {
          angleBracketsCount--;
          if (angleBracketsCount === 0) {
            break;
          }
        }
      }
    } else if (xmlData.length > i2 + 9 && xmlData[i2 + 1] === "[" && xmlData[i2 + 2] === "C" && xmlData[i2 + 3] === "D" && xmlData[i2 + 4] === "A" && xmlData[i2 + 5] === "T" && xmlData[i2 + 6] === "A" && xmlData[i2 + 7] === "[") {
      for (i2 += 8;i2 < xmlData.length; i2++) {
        if (xmlData[i2] === "]" && xmlData[i2 + 1] === "]" && xmlData[i2 + 2] === ">") {
          i2 += 2;
          break;
        }
      }
    }
    return i2;
  }
  var doubleQuote = '"';
  var singleQuote = "'";
  function readAttributeStr(xmlData, i2) {
    let attrStr = "";
    let startChar = "";
    let tagClosed = false;
    for (;i2 < xmlData.length; i2++) {
      if (xmlData[i2] === doubleQuote || xmlData[i2] === singleQuote) {
        if (startChar === "") {
          startChar = xmlData[i2];
        } else if (startChar !== xmlData[i2]) {
        } else {
          startChar = "";
        }
      } else if (xmlData[i2] === ">") {
        if (startChar === "") {
          tagClosed = true;
          break;
        }
      }
      attrStr += xmlData[i2];
    }
    if (startChar !== "") {
      return false;
    }
    return {
      value: attrStr,
      index: i2,
      tagClosed
    };
  }
  var validAttrStrRegxp = new RegExp('(\\s*)([^\\s=]+)(\\s*=)?(\\s*([\'"])(([\\s\\S])*?)\\5)?', "g");
  function validateAttributeString(attrStr, options3) {
    const matches = util.getAllMatches(attrStr, validAttrStrRegxp);
    const attrNames = {};
    for (let i2 = 0;i2 < matches.length; i2++) {
      if (matches[i2][1].length === 0) {
        return getErrorObject("InvalidAttr", "Attribute '" + matches[i2][2] + "' has no space in starting.", getPositionFromMatch(matches[i2]));
      } else if (matches[i2][3] !== undefined && matches[i2][4] === undefined) {
        return getErrorObject("InvalidAttr", "Attribute '" + matches[i2][2] + "' is without value.", getPositionFromMatch(matches[i2]));
      } else if (matches[i2][3] === undefined && !options3.allowBooleanAttributes) {
        return getErrorObject("InvalidAttr", "boolean attribute '" + matches[i2][2] + "' is not allowed.", getPositionFromMatch(matches[i2]));
      }
      const attrName = matches[i2][2];
      if (!validateAttrName(attrName)) {
        return getErrorObject("InvalidAttr", "Attribute '" + attrName + "' is an invalid name.", getPositionFromMatch(matches[i2]));
      }
      if (!attrNames.hasOwnProperty(attrName)) {
        attrNames[attrName] = 1;
      } else {
        return getErrorObject("InvalidAttr", "Attribute '" + attrName + "' is repeated.", getPositionFromMatch(matches[i2]));
      }
    }
    return true;
  }
  function validateNumberAmpersand(xmlData, i2) {
    let re = /\d/;
    if (xmlData[i2] === "x") {
      i2++;
      re = /[\da-fA-F]/;
    }
    for (;i2 < xmlData.length; i2++) {
      if (xmlData[i2] === ";")
        return i2;
      if (!xmlData[i2].match(re))
        break;
    }
    return -1;
  }
  function validateAmpersand(xmlData, i2) {
    i2++;
    if (xmlData[i2] === ";")
      return -1;
    if (xmlData[i2] === "#") {
      i2++;
      return validateNumberAmpersand(xmlData, i2);
    }
    let count = 0;
    for (;i2 < xmlData.length; i2++, count++) {
      if (xmlData[i2].match(/\w/) && count < 20)
        continue;
      if (xmlData[i2] === ";")
        break;
      return -1;
    }
    return i2;
  }
  function getErrorObject(code, message, lineNumber) {
    return {
      err: {
        code,
        msg: message,
        line: lineNumber.line || lineNumber,
        col: lineNumber.col
      }
    };
  }
  function validateAttrName(attrName) {
    return util.isName(attrName);
  }
  function validateTagName(tagname) {
    return util.isName(tagname);
  }
  function getLineNumberForPosition(xmlData, index) {
    const lines = xmlData.substring(0, index).split(/\r?\n/);
    return {
      line: lines.length,
      col: lines[lines.length - 1].length + 1
    };
  }
  function getPositionFromMatch(match) {
    return match.startIndex + match[1].length;
  }
});
var require_OptionsBuilder = __commonJS2((exports) => {
  var defaultOptions2 = {
    preserveOrder: false,
    attributeNamePrefix: "@_",
    attributesGroupName: false,
    textNodeName: "#text",
    ignoreAttributes: true,
    removeNSPrefix: false,
    allowBooleanAttributes: false,
    parseTagValue: true,
    parseAttributeValue: false,
    trimValues: true,
    cdataPropName: false,
    numberParseOptions: {
      hex: true,
      leadingZeros: true,
      eNotation: true
    },
    tagValueProcessor: function(tagName, val2) {
      return val2;
    },
    attributeValueProcessor: function(attrName, val2) {
      return val2;
    },
    stopNodes: [],
    alwaysCreateTextNode: false,
    isArray: () => false,
    commentPropName: false,
    unpairedTags: [],
    processEntities: true,
    htmlEntities: false,
    ignoreDeclaration: false,
    ignorePiTags: false,
    transformTagName: false,
    transformAttributeName: false,
    updateTag: function(tagName, jPath, attrs) {
      return tagName;
    }
  };
  var buildOptions = function(options3) {
    return Object.assign({}, defaultOptions2, options3);
  };
  exports.buildOptions = buildOptions;
  exports.defaultOptions = defaultOptions2;
});
var require_xmlNode = __commonJS2((exports, module) => {

  class XmlNode {
    constructor(tagname) {
      this.tagname = tagname;
      this.child = [];
      this[":@"] = {};
    }
    add(key2, val2) {
      if (key2 === "__proto__")
        key2 = "#__proto__";
      this.child.push({ [key2]: val2 });
    }
    addChild(node) {
      if (node.tagname === "__proto__")
        node.tagname = "#__proto__";
      if (node[":@"] && Object.keys(node[":@"]).length > 0) {
        this.child.push({ [node.tagname]: node.child, [":@"]: node[":@"] });
      } else {
        this.child.push({ [node.tagname]: node.child });
      }
    }
  }
  module.exports = XmlNode;
});
var require_DocTypeReader = __commonJS2((exports, module) => {
  var util = require_util4();
  function readDocType(xmlData, i2) {
    const entities = {};
    if (xmlData[i2 + 3] === "O" && xmlData[i2 + 4] === "C" && xmlData[i2 + 5] === "T" && xmlData[i2 + 6] === "Y" && xmlData[i2 + 7] === "P" && xmlData[i2 + 8] === "E") {
      i2 = i2 + 9;
      let angleBracketsCount = 1;
      let hasBody = false, comment = false;
      let exp = "";
      for (;i2 < xmlData.length; i2++) {
        if (xmlData[i2] === "<" && !comment) {
          if (hasBody && isEntity(xmlData, i2)) {
            i2 += 7;
            [entityName, val, i2] = readEntityExp(xmlData, i2 + 1);
            if (val.indexOf("&") === -1)
              entities[validateEntityName(entityName)] = {
                regx: RegExp(`&${entityName};`, "g"),
                val
              };
          } else if (hasBody && isElement(xmlData, i2))
            i2 += 8;
          else if (hasBody && isAttlist(xmlData, i2))
            i2 += 8;
          else if (hasBody && isNotation(xmlData, i2))
            i2 += 9;
          else if (isComment)
            comment = true;
          else
            throw new Error("Invalid DOCTYPE");
          angleBracketsCount++;
          exp = "";
        } else if (xmlData[i2] === ">") {
          if (comment) {
            if (xmlData[i2 - 1] === "-" && xmlData[i2 - 2] === "-") {
              comment = false;
              angleBracketsCount--;
            }
          } else {
            angleBracketsCount--;
          }
          if (angleBracketsCount === 0) {
            break;
          }
        } else if (xmlData[i2] === "[") {
          hasBody = true;
        } else {
          exp += xmlData[i2];
        }
      }
      if (angleBracketsCount !== 0) {
        throw new Error(`Unclosed DOCTYPE`);
      }
    } else {
      throw new Error(`Invalid Tag instead of DOCTYPE`);
    }
    return { entities, i: i2 };
  }
  function readEntityExp(xmlData, i2) {
    let entityName2 = "";
    for (;i2 < xmlData.length && (xmlData[i2] !== "'" && xmlData[i2] !== '"'); i2++) {
      entityName2 += xmlData[i2];
    }
    entityName2 = entityName2.trim();
    if (entityName2.indexOf(" ") !== -1)
      throw new Error("External entites are not supported");
    const startChar = xmlData[i2++];
    let val2 = "";
    for (;i2 < xmlData.length && xmlData[i2] !== startChar; i2++) {
      val2 += xmlData[i2];
    }
    return [entityName2, val2, i2];
  }
  function isComment(xmlData, i2) {
    if (xmlData[i2 + 1] === "!" && xmlData[i2 + 2] === "-" && xmlData[i2 + 3] === "-")
      return true;
    return false;
  }
  function isEntity(xmlData, i2) {
    if (xmlData[i2 + 1] === "!" && xmlData[i2 + 2] === "E" && xmlData[i2 + 3] === "N" && xmlData[i2 + 4] === "T" && xmlData[i2 + 5] === "I" && xmlData[i2 + 6] === "T" && xmlData[i2 + 7] === "Y")
      return true;
    return false;
  }
  function isElement(xmlData, i2) {
    if (xmlData[i2 + 1] === "!" && xmlData[i2 + 2] === "E" && xmlData[i2 + 3] === "L" && xmlData[i2 + 4] === "E" && xmlData[i2 + 5] === "M" && xmlData[i2 + 6] === "E" && xmlData[i2 + 7] === "N" && xmlData[i2 + 8] === "T")
      return true;
    return false;
  }
  function isAttlist(xmlData, i2) {
    if (xmlData[i2 + 1] === "!" && xmlData[i2 + 2] === "A" && xmlData[i2 + 3] === "T" && xmlData[i2 + 4] === "T" && xmlData[i2 + 5] === "L" && xmlData[i2 + 6] === "I" && xmlData[i2 + 7] === "S" && xmlData[i2 + 8] === "T")
      return true;
    return false;
  }
  function isNotation(xmlData, i2) {
    if (xmlData[i2 + 1] === "!" && xmlData[i2 + 2] === "N" && xmlData[i2 + 3] === "O" && xmlData[i2 + 4] === "T" && xmlData[i2 + 5] === "A" && xmlData[i2 + 6] === "T" && xmlData[i2 + 7] === "I" && xmlData[i2 + 8] === "O" && xmlData[i2 + 9] === "N")
      return true;
    return false;
  }
  function validateEntityName(name) {
    if (util.isName(name))
      return name;
    else
      throw new Error(`Invalid entity name ${name}`);
  }
  module.exports = readDocType;
});
var require_strnum = __commonJS2((exports, module) => {
  var hexRegex = /^[-+]?0x[a-fA-F0-9]+$/;
  var numRegex = /^([\-\+])?(0*)(\.[0-9]+([eE]\-?[0-9]+)?|[0-9]+(\.[0-9]+([eE]\-?[0-9]+)?)?)$/;
  if (!Number.parseInt && window.parseInt) {
    Number.parseInt = window.parseInt;
  }
  if (!Number.parseFloat && window.parseFloat) {
    Number.parseFloat = window.parseFloat;
  }
  var consider = {
    hex: true,
    leadingZeros: true,
    decimalPoint: ".",
    eNotation: true
  };
  function toNumber(str2, options3 = {}) {
    options3 = Object.assign({}, consider, options3);
    if (!str2 || typeof str2 !== "string")
      return str2;
    let trimmedStr = str2.trim();
    if (options3.skipLike !== undefined && options3.skipLike.test(trimmedStr))
      return str2;
    else if (options3.hex && hexRegex.test(trimmedStr)) {
      return Number.parseInt(trimmedStr, 16);
    } else {
      const match = numRegex.exec(trimmedStr);
      if (match) {
        const sign = match[1];
        const leadingZeros = match[2];
        let numTrimmedByZeros = trimZeros(match[3]);
        const eNotation = match[4] || match[6];
        if (!options3.leadingZeros && leadingZeros.length > 0 && sign && trimmedStr[2] !== ".")
          return str2;
        else if (!options3.leadingZeros && leadingZeros.length > 0 && !sign && trimmedStr[1] !== ".")
          return str2;
        else {
          const num = Number(trimmedStr);
          const numStr = "" + num;
          if (numStr.search(/[eE]/) !== -1) {
            if (options3.eNotation)
              return num;
            else
              return str2;
          } else if (eNotation) {
            if (options3.eNotation)
              return num;
            else
              return str2;
          } else if (trimmedStr.indexOf(".") !== -1) {
            if (numStr === "0" && numTrimmedByZeros === "")
              return num;
            else if (numStr === numTrimmedByZeros)
              return num;
            else if (sign && numStr === "-" + numTrimmedByZeros)
              return num;
            else
              return str2;
          }
          if (leadingZeros) {
            if (numTrimmedByZeros === numStr)
              return num;
            else if (sign + numTrimmedByZeros === numStr)
              return num;
            else
              return str2;
          }
          if (trimmedStr === numStr)
            return num;
          else if (trimmedStr === sign + numStr)
            return num;
          return str2;
        }
      } else {
        return str2;
      }
    }
  }
  function trimZeros(numStr) {
    if (numStr && numStr.indexOf(".") !== -1) {
      numStr = numStr.replace(/0+$/, "");
      if (numStr === ".")
        numStr = "0";
      else if (numStr[0] === ".")
        numStr = "0" + numStr;
      else if (numStr[numStr.length - 1] === ".")
        numStr = numStr.substr(0, numStr.length - 1);
      return numStr;
    }
    return numStr;
  }
  module.exports = toNumber;
});
var require_OrderedObjParser = __commonJS2((exports, module) => {
  var util = require_util4();
  var xmlNode = require_xmlNode();
  var readDocType = require_DocTypeReader();
  var toNumber = require_strnum();

  class OrderedObjParser {
    constructor(options3) {
      this.options = options3;
      this.currentNode = null;
      this.tagsNodeStack = [];
      this.docTypeEntities = {};
      this.lastEntities = {
        apos: { regex: /&(apos|#39|#x27);/g, val: "'" },
        gt: { regex: /&(gt|#62|#x3E);/g, val: ">" },
        lt: { regex: /&(lt|#60|#x3C);/g, val: "<" },
        quot: { regex: /&(quot|#34|#x22);/g, val: "\"" }
      };
      this.ampEntity = { regex: /&(amp|#38|#x26);/g, val: "&" };
      this.htmlEntities = {
        space: { regex: /&(nbsp|#160);/g, val: " " },
        cent: { regex: /&(cent|#162);/g, val: "\xA2" },
        pound: { regex: /&(pound|#163);/g, val: "\xA3" },
        yen: { regex: /&(yen|#165);/g, val: "\xA5" },
        euro: { regex: /&(euro|#8364);/g, val: "\u20AC" },
        copyright: { regex: /&(copy|#169);/g, val: "\xA9" },
        reg: { regex: /&(reg|#174);/g, val: "\xAE" },
        inr: { regex: /&(inr|#8377);/g, val: "\u20B9" },
        num_dec: { regex: /&#([0-9]{1,7});/g, val: (_22, str2) => String.fromCharCode(Number.parseInt(str2, 10)) },
        num_hex: { regex: /&#x([0-9a-fA-F]{1,6});/g, val: (_22, str2) => String.fromCharCode(Number.parseInt(str2, 16)) }
      };
      this.addExternalEntities = addExternalEntities;
      this.parseXml = parseXml;
      this.parseTextData = parseTextData;
      this.resolveNameSpace = resolveNameSpace;
      this.buildAttributesMap = buildAttributesMap;
      this.isItStopNode = isItStopNode;
      this.replaceEntitiesValue = replaceEntitiesValue;
      this.readStopNodeData = readStopNodeData;
      this.saveTextToParentTag = saveTextToParentTag;
      this.addChild = addChild;
    }
  }
  function addExternalEntities(externalEntities) {
    const entKeys = Object.keys(externalEntities);
    for (let i2 = 0;i2 < entKeys.length; i2++) {
      const ent = entKeys[i2];
      this.lastEntities[ent] = {
        regex: new RegExp("&" + ent + ";", "g"),
        val: externalEntities[ent]
      };
    }
  }
  function parseTextData(val2, tagName, jPath, dontTrim, hasAttributes, isLeafNode, escapeEntities) {
    if (val2 !== undefined) {
      if (this.options.trimValues && !dontTrim) {
        val2 = val2.trim();
      }
      if (val2.length > 0) {
        if (!escapeEntities)
          val2 = this.replaceEntitiesValue(val2);
        const newval = this.options.tagValueProcessor(tagName, val2, jPath, hasAttributes, isLeafNode);
        if (newval === null || newval === undefined) {
          return val2;
        } else if (typeof newval !== typeof val2 || newval !== val2) {
          return newval;
        } else if (this.options.trimValues) {
          return parseValue(val2, this.options.parseTagValue, this.options.numberParseOptions);
        } else {
          const trimmedVal = val2.trim();
          if (trimmedVal === val2) {
            return parseValue(val2, this.options.parseTagValue, this.options.numberParseOptions);
          } else {
            return val2;
          }
        }
      }
    }
  }
  function resolveNameSpace(tagname) {
    if (this.options.removeNSPrefix) {
      const tags = tagname.split(":");
      const prefix = tagname.charAt(0) === "/" ? "/" : "";
      if (tags[0] === "xmlns") {
        return "";
      }
      if (tags.length === 2) {
        tagname = prefix + tags[1];
      }
    }
    return tagname;
  }
  var attrsRegx = new RegExp('([^\\s=]+)\\s*(=\\s*([\'"])([\\s\\S]*?)\\3)?', "gm");
  function buildAttributesMap(attrStr, jPath, tagName) {
    if (!this.options.ignoreAttributes && typeof attrStr === "string") {
      const matches = util.getAllMatches(attrStr, attrsRegx);
      const len = matches.length;
      const attrs = {};
      for (let i2 = 0;i2 < len; i2++) {
        const attrName = this.resolveNameSpace(matches[i2][1]);
        let oldVal = matches[i2][4];
        let aName = this.options.attributeNamePrefix + attrName;
        if (attrName.length) {
          if (this.options.transformAttributeName) {
            aName = this.options.transformAttributeName(aName);
          }
          if (aName === "__proto__")
            aName = "#__proto__";
          if (oldVal !== undefined) {
            if (this.options.trimValues) {
              oldVal = oldVal.trim();
            }
            oldVal = this.replaceEntitiesValue(oldVal);
            const newVal = this.options.attributeValueProcessor(attrName, oldVal, jPath);
            if (newVal === null || newVal === undefined) {
              attrs[aName] = oldVal;
            } else if (typeof newVal !== typeof oldVal || newVal !== oldVal) {
              attrs[aName] = newVal;
            } else {
              attrs[aName] = parseValue(oldVal, this.options.parseAttributeValue, this.options.numberParseOptions);
            }
          } else if (this.options.allowBooleanAttributes) {
            attrs[aName] = true;
          }
        }
      }
      if (!Object.keys(attrs).length) {
        return;
      }
      if (this.options.attributesGroupName) {
        const attrCollection = {};
        attrCollection[this.options.attributesGroupName] = attrs;
        return attrCollection;
      }
      return attrs;
    }
  }
  var parseXml = function(xmlData) {
    xmlData = xmlData.replace(/\r\n?/g, "\n");
    const xmlObj = new xmlNode("!xml");
    let currentNode = xmlObj;
    let textData = "";
    let jPath = "";
    for (let i2 = 0;i2 < xmlData.length; i2++) {
      const ch = xmlData[i2];
      if (ch === "<") {
        if (xmlData[i2 + 1] === "/") {
          const closeIndex = findClosingIndex(xmlData, ">", i2, "Closing Tag is not closed.");
          let tagName = xmlData.substring(i2 + 2, closeIndex).trim();
          if (this.options.removeNSPrefix) {
            const colonIndex = tagName.indexOf(":");
            if (colonIndex !== -1) {
              tagName = tagName.substr(colonIndex + 1);
            }
          }
          if (this.options.transformTagName) {
            tagName = this.options.transformTagName(tagName);
          }
          if (currentNode) {
            textData = this.saveTextToParentTag(textData, currentNode, jPath);
          }
          const lastTagName = jPath.substring(jPath.lastIndexOf(".") + 1);
          if (tagName && this.options.unpairedTags.indexOf(tagName) !== -1) {
            throw new Error(`Unpaired tag can not be used as closing tag: </${tagName}>`);
          }
          let propIndex = 0;
          if (lastTagName && this.options.unpairedTags.indexOf(lastTagName) !== -1) {
            propIndex = jPath.lastIndexOf(".", jPath.lastIndexOf(".") - 1);
            this.tagsNodeStack.pop();
          } else {
            propIndex = jPath.lastIndexOf(".");
          }
          jPath = jPath.substring(0, propIndex);
          currentNode = this.tagsNodeStack.pop();
          textData = "";
          i2 = closeIndex;
        } else if (xmlData[i2 + 1] === "?") {
          let tagData = readTagExp(xmlData, i2, false, "?>");
          if (!tagData)
            throw new Error("Pi Tag is not closed.");
          textData = this.saveTextToParentTag(textData, currentNode, jPath);
          if (this.options.ignoreDeclaration && tagData.tagName === "?xml" || this.options.ignorePiTags) {
          } else {
            const childNode = new xmlNode(tagData.tagName);
            childNode.add(this.options.textNodeName, "");
            if (tagData.tagName !== tagData.tagExp && tagData.attrExpPresent) {
              childNode[":@"] = this.buildAttributesMap(tagData.tagExp, jPath, tagData.tagName);
            }
            this.addChild(currentNode, childNode, jPath);
          }
          i2 = tagData.closeIndex + 1;
        } else if (xmlData.substr(i2 + 1, 3) === "!--") {
          const endIndex = findClosingIndex(xmlData, "-->", i2 + 4, "Comment is not closed.");
          if (this.options.commentPropName) {
            const comment = xmlData.substring(i2 + 4, endIndex - 2);
            textData = this.saveTextToParentTag(textData, currentNode, jPath);
            currentNode.add(this.options.commentPropName, [{ [this.options.textNodeName]: comment }]);
          }
          i2 = endIndex;
        } else if (xmlData.substr(i2 + 1, 2) === "!D") {
          const result2 = readDocType(xmlData, i2);
          this.docTypeEntities = result2.entities;
          i2 = result2.i;
        } else if (xmlData.substr(i2 + 1, 2) === "![") {
          const closeIndex = findClosingIndex(xmlData, "]]>", i2, "CDATA is not closed.") - 2;
          const tagExp = xmlData.substring(i2 + 9, closeIndex);
          textData = this.saveTextToParentTag(textData, currentNode, jPath);
          let val2 = this.parseTextData(tagExp, currentNode.tagname, jPath, true, false, true, true);
          if (val2 == undefined)
            val2 = "";
          if (this.options.cdataPropName) {
            currentNode.add(this.options.cdataPropName, [{ [this.options.textNodeName]: tagExp }]);
          } else {
            currentNode.add(this.options.textNodeName, val2);
          }
          i2 = closeIndex + 2;
        } else {
          let result2 = readTagExp(xmlData, i2, this.options.removeNSPrefix);
          let tagName = result2.tagName;
          const rawTagName = result2.rawTagName;
          let tagExp = result2.tagExp;
          let attrExpPresent = result2.attrExpPresent;
          let closeIndex = result2.closeIndex;
          if (this.options.transformTagName) {
            tagName = this.options.transformTagName(tagName);
          }
          if (currentNode && textData) {
            if (currentNode.tagname !== "!xml") {
              textData = this.saveTextToParentTag(textData, currentNode, jPath, false);
            }
          }
          const lastTag = currentNode;
          if (lastTag && this.options.unpairedTags.indexOf(lastTag.tagname) !== -1) {
            currentNode = this.tagsNodeStack.pop();
            jPath = jPath.substring(0, jPath.lastIndexOf("."));
          }
          if (tagName !== xmlObj.tagname) {
            jPath += jPath ? "." + tagName : tagName;
          }
          if (this.isItStopNode(this.options.stopNodes, jPath, tagName)) {
            let tagContent = "";
            if (tagExp.length > 0 && tagExp.lastIndexOf("/") === tagExp.length - 1) {
              if (tagName[tagName.length - 1] === "/") {
                tagName = tagName.substr(0, tagName.length - 1);
                jPath = jPath.substr(0, jPath.length - 1);
                tagExp = tagName;
              } else {
                tagExp = tagExp.substr(0, tagExp.length - 1);
              }
              i2 = result2.closeIndex;
            } else if (this.options.unpairedTags.indexOf(tagName) !== -1) {
              i2 = result2.closeIndex;
            } else {
              const result3 = this.readStopNodeData(xmlData, rawTagName, closeIndex + 1);
              if (!result3)
                throw new Error(`Unexpected end of ${rawTagName}`);
              i2 = result3.i;
              tagContent = result3.tagContent;
            }
            const childNode = new xmlNode(tagName);
            if (tagName !== tagExp && attrExpPresent) {
              childNode[":@"] = this.buildAttributesMap(tagExp, jPath, tagName);
            }
            if (tagContent) {
              tagContent = this.parseTextData(tagContent, tagName, jPath, true, attrExpPresent, true, true);
            }
            jPath = jPath.substr(0, jPath.lastIndexOf("."));
            childNode.add(this.options.textNodeName, tagContent);
            this.addChild(currentNode, childNode, jPath);
          } else {
            if (tagExp.length > 0 && tagExp.lastIndexOf("/") === tagExp.length - 1) {
              if (tagName[tagName.length - 1] === "/") {
                tagName = tagName.substr(0, tagName.length - 1);
                jPath = jPath.substr(0, jPath.length - 1);
                tagExp = tagName;
              } else {
                tagExp = tagExp.substr(0, tagExp.length - 1);
              }
              if (this.options.transformTagName) {
                tagName = this.options.transformTagName(tagName);
              }
              const childNode = new xmlNode(tagName);
              if (tagName !== tagExp && attrExpPresent) {
                childNode[":@"] = this.buildAttributesMap(tagExp, jPath, tagName);
              }
              this.addChild(currentNode, childNode, jPath);
              jPath = jPath.substr(0, jPath.lastIndexOf("."));
            } else {
              const childNode = new xmlNode(tagName);
              this.tagsNodeStack.push(currentNode);
              if (tagName !== tagExp && attrExpPresent) {
                childNode[":@"] = this.buildAttributesMap(tagExp, jPath, tagName);
              }
              this.addChild(currentNode, childNode, jPath);
              currentNode = childNode;
            }
            textData = "";
            i2 = closeIndex;
          }
        }
      } else {
        textData += xmlData[i2];
      }
    }
    return xmlObj.child;
  };
  function addChild(currentNode, childNode, jPath) {
    const result2 = this.options.updateTag(childNode.tagname, jPath, childNode[":@"]);
    if (result2 === false) {
    } else if (typeof result2 === "string") {
      childNode.tagname = result2;
      currentNode.addChild(childNode);
    } else {
      currentNode.addChild(childNode);
    }
  }
  var replaceEntitiesValue = function(val2) {
    if (this.options.processEntities) {
      for (let entityName2 in this.docTypeEntities) {
        const entity = this.docTypeEntities[entityName2];
        val2 = val2.replace(entity.regx, entity.val);
      }
      for (let entityName2 in this.lastEntities) {
        const entity = this.lastEntities[entityName2];
        val2 = val2.replace(entity.regex, entity.val);
      }
      if (this.options.htmlEntities) {
        for (let entityName2 in this.htmlEntities) {
          const entity = this.htmlEntities[entityName2];
          val2 = val2.replace(entity.regex, entity.val);
        }
      }
      val2 = val2.replace(this.ampEntity.regex, this.ampEntity.val);
    }
    return val2;
  };
  function saveTextToParentTag(textData, currentNode, jPath, isLeafNode) {
    if (textData) {
      if (isLeafNode === undefined)
        isLeafNode = Object.keys(currentNode.child).length === 0;
      textData = this.parseTextData(textData, currentNode.tagname, jPath, false, currentNode[":@"] ? Object.keys(currentNode[":@"]).length !== 0 : false, isLeafNode);
      if (textData !== undefined && textData !== "")
        currentNode.add(this.options.textNodeName, textData);
      textData = "";
    }
    return textData;
  }
  function isItStopNode(stopNodes, jPath, currentTagName) {
    const allNodesExp = "*." + currentTagName;
    for (const stopNodePath in stopNodes) {
      const stopNodeExp = stopNodes[stopNodePath];
      if (allNodesExp === stopNodeExp || jPath === stopNodeExp)
        return true;
    }
    return false;
  }
  function tagExpWithClosingIndex(xmlData, i2, closingChar = ">") {
    let attrBoundary;
    let tagExp = "";
    for (let index = i2;index < xmlData.length; index++) {
      let ch = xmlData[index];
      if (attrBoundary) {
        if (ch === attrBoundary)
          attrBoundary = "";
      } else if (ch === '"' || ch === "'") {
        attrBoundary = ch;
      } else if (ch === closingChar[0]) {
        if (closingChar[1]) {
          if (xmlData[index + 1] === closingChar[1]) {
            return {
              data: tagExp,
              index
            };
          }
        } else {
          return {
            data: tagExp,
            index
          };
        }
      } else if (ch === "\t") {
        ch = " ";
      }
      tagExp += ch;
    }
  }
  function findClosingIndex(xmlData, str2, i2, errMsg) {
    const closingIndex = xmlData.indexOf(str2, i2);
    if (closingIndex === -1) {
      throw new Error(errMsg);
    } else {
      return closingIndex + str2.length - 1;
    }
  }
  function readTagExp(xmlData, i2, removeNSPrefix, closingChar = ">") {
    const result2 = tagExpWithClosingIndex(xmlData, i2 + 1, closingChar);
    if (!result2)
      return;
    let tagExp = result2.data;
    const closeIndex = result2.index;
    const separatorIndex = tagExp.search(/\s/);
    let tagName = tagExp;
    let attrExpPresent = true;
    if (separatorIndex !== -1) {
      tagName = tagExp.substring(0, separatorIndex);
      tagExp = tagExp.substring(separatorIndex + 1).trimStart();
    }
    const rawTagName = tagName;
    if (removeNSPrefix) {
      const colonIndex = tagName.indexOf(":");
      if (colonIndex !== -1) {
        tagName = tagName.substr(colonIndex + 1);
        attrExpPresent = tagName !== result2.data.substr(colonIndex + 1);
      }
    }
    return {
      tagName,
      tagExp,
      closeIndex,
      attrExpPresent,
      rawTagName
    };
  }
  function readStopNodeData(xmlData, tagName, i2) {
    const startIndex = i2;
    let openTagCount = 1;
    for (;i2 < xmlData.length; i2++) {
      if (xmlData[i2] === "<") {
        if (xmlData[i2 + 1] === "/") {
          const closeIndex = findClosingIndex(xmlData, ">", i2, `${tagName} is not closed`);
          let closeTagName = xmlData.substring(i2 + 2, closeIndex).trim();
          if (closeTagName === tagName) {
            openTagCount--;
            if (openTagCount === 0) {
              return {
                tagContent: xmlData.substring(startIndex, i2),
                i: closeIndex
              };
            }
          }
          i2 = closeIndex;
        } else if (xmlData[i2 + 1] === "?") {
          const closeIndex = findClosingIndex(xmlData, "?>", i2 + 1, "StopNode is not closed.");
          i2 = closeIndex;
        } else if (xmlData.substr(i2 + 1, 3) === "!--") {
          const closeIndex = findClosingIndex(xmlData, "-->", i2 + 3, "StopNode is not closed.");
          i2 = closeIndex;
        } else if (xmlData.substr(i2 + 1, 2) === "![") {
          const closeIndex = findClosingIndex(xmlData, "]]>", i2, "StopNode is not closed.") - 2;
          i2 = closeIndex;
        } else {
          const tagData = readTagExp(xmlData, i2, ">");
          if (tagData) {
            const openTagName = tagData && tagData.tagName;
            if (openTagName === tagName && tagData.tagExp[tagData.tagExp.length - 1] !== "/") {
              openTagCount++;
            }
            i2 = tagData.closeIndex;
          }
        }
      }
    }
  }
  function parseValue(val2, shouldParse, options3) {
    if (shouldParse && typeof val2 === "string") {
      const newval = val2.trim();
      if (newval === "true")
        return true;
      else if (newval === "false")
        return false;
      else
        return toNumber(val2, options3);
    } else {
      if (util.isExist(val2)) {
        return val2;
      } else {
        return "";
      }
    }
  }
  module.exports = OrderedObjParser;
});
var require_node2json = __commonJS2((exports) => {
  function prettify(node, options3) {
    return compress(node, options3);
  }
  function compress(arr2, options3, jPath) {
    let text22;
    const compressedObj = {};
    for (let i2 = 0;i2 < arr2.length; i2++) {
      const tagObj = arr2[i2];
      const property = propName(tagObj);
      let newJpath = "";
      if (jPath === undefined)
        newJpath = property;
      else
        newJpath = jPath + "." + property;
      if (property === options3.textNodeName) {
        if (text22 === undefined)
          text22 = tagObj[property];
        else
          text22 += "" + tagObj[property];
      } else if (property === undefined) {
        continue;
      } else if (tagObj[property]) {
        let val2 = compress(tagObj[property], options3, newJpath);
        const isLeaf = isLeafTag(val2, options3);
        if (tagObj[":@"]) {
          assignAttributes(val2, tagObj[":@"], newJpath, options3);
        } else if (Object.keys(val2).length === 1 && val2[options3.textNodeName] !== undefined && !options3.alwaysCreateTextNode) {
          val2 = val2[options3.textNodeName];
        } else if (Object.keys(val2).length === 0) {
          if (options3.alwaysCreateTextNode)
            val2[options3.textNodeName] = "";
          else
            val2 = "";
        }
        if (compressedObj[property] !== undefined && compressedObj.hasOwnProperty(property)) {
          if (!Array.isArray(compressedObj[property])) {
            compressedObj[property] = [compressedObj[property]];
          }
          compressedObj[property].push(val2);
        } else {
          if (options3.isArray(property, newJpath, isLeaf)) {
            compressedObj[property] = [val2];
          } else {
            compressedObj[property] = val2;
          }
        }
      }
    }
    if (typeof text22 === "string") {
      if (text22.length > 0)
        compressedObj[options3.textNodeName] = text22;
    } else if (text22 !== undefined)
      compressedObj[options3.textNodeName] = text22;
    return compressedObj;
  }
  function propName(obj) {
    const keys2 = Object.keys(obj);
    for (let i2 = 0;i2 < keys2.length; i2++) {
      const key2 = keys2[i2];
      if (key2 !== ":@")
        return key2;
    }
  }
  function assignAttributes(obj, attrMap, jpath, options3) {
    if (attrMap) {
      const keys2 = Object.keys(attrMap);
      const len = keys2.length;
      for (let i2 = 0;i2 < len; i2++) {
        const atrrName = keys2[i2];
        if (options3.isArray(atrrName, jpath + "." + atrrName, true, true)) {
          obj[atrrName] = [attrMap[atrrName]];
        } else {
          obj[atrrName] = attrMap[atrrName];
        }
      }
    }
  }
  function isLeafTag(obj, options3) {
    const { textNodeName } = options3;
    const propCount = Object.keys(obj).length;
    if (propCount === 0) {
      return true;
    }
    if (propCount === 1 && (obj[textNodeName] || typeof obj[textNodeName] === "boolean" || obj[textNodeName] === 0)) {
      return true;
    }
    return false;
  }
  exports.prettify = prettify;
});
var require_XMLParser = __commonJS2((exports, module) => {
  var { buildOptions } = require_OptionsBuilder();
  var OrderedObjParser = require_OrderedObjParser();
  var { prettify } = require_node2json();
  var validator2 = require_validator();

  class XMLParser {
    constructor(options3) {
      this.externalEntities = {};
      this.options = buildOptions(options3);
    }
    parse(xmlData, validationOption) {
      if (typeof xmlData === "string") {
      } else if (xmlData.toString) {
        xmlData = xmlData.toString();
      } else {
        throw new Error("XML data is accepted in String or Bytes[] form.");
      }
      if (validationOption) {
        if (validationOption === true)
          validationOption = {};
        const result2 = validator2.validate(xmlData, validationOption);
        if (result2 !== true) {
          throw Error(`${result2.err.msg}:${result2.err.line}:${result2.err.col}`);
        }
      }
      const orderedObjParser = new OrderedObjParser(this.options);
      orderedObjParser.addExternalEntities(this.externalEntities);
      const orderedResult = orderedObjParser.parseXml(xmlData);
      if (this.options.preserveOrder || orderedResult === undefined)
        return orderedResult;
      else
        return prettify(orderedResult, this.options);
    }
    addEntity(key2, value) {
      if (value.indexOf("&") !== -1) {
        throw new Error("Entity value can't have '&'");
      } else if (key2.indexOf("&") !== -1 || key2.indexOf(";") !== -1) {
        throw new Error("An entity must be set without '&' and ';'. Eg. use '#xD' for '&#xD;'");
      } else if (value === "&") {
        throw new Error("An entity with value '&' is not permitted");
      } else {
        this.externalEntities[key2] = value;
      }
    }
  }
  module.exports = XMLParser;
});
var require_orderedJs2Xml = __commonJS2((exports, module) => {
  var EOL = "\n";
  function toXml(jArray, options3) {
    let indentation = "";
    if (options3.format && options3.indentBy.length > 0) {
      indentation = EOL;
    }
    return arrToStr(jArray, options3, "", indentation);
  }
  function arrToStr(arr2, options3, jPath, indentation) {
    let xmlStr = "";
    let isPreviousElementTag = false;
    for (let i2 = 0;i2 < arr2.length; i2++) {
      const tagObj = arr2[i2];
      const tagName = propName(tagObj);
      if (tagName === undefined)
        continue;
      let newJPath = "";
      if (jPath.length === 0)
        newJPath = tagName;
      else
        newJPath = `${jPath}.${tagName}`;
      if (tagName === options3.textNodeName) {
        let tagText = tagObj[tagName];
        if (!isStopNode(newJPath, options3)) {
          tagText = options3.tagValueProcessor(tagName, tagText);
          tagText = replaceEntitiesValue(tagText, options3);
        }
        if (isPreviousElementTag) {
          xmlStr += indentation;
        }
        xmlStr += tagText;
        isPreviousElementTag = false;
        continue;
      } else if (tagName === options3.cdataPropName) {
        if (isPreviousElementTag) {
          xmlStr += indentation;
        }
        xmlStr += `<![CDATA[${tagObj[tagName][0][options3.textNodeName]}]]>`;
        isPreviousElementTag = false;
        continue;
      } else if (tagName === options3.commentPropName) {
        xmlStr += indentation + `<!--${tagObj[tagName][0][options3.textNodeName]}-->`;
        isPreviousElementTag = true;
        continue;
      } else if (tagName[0] === "?") {
        const attStr2 = attr_to_str(tagObj[":@"], options3);
        const tempInd = tagName === "?xml" ? "" : indentation;
        let piTextNodeName = tagObj[tagName][0][options3.textNodeName];
        piTextNodeName = piTextNodeName.length !== 0 ? " " + piTextNodeName : "";
        xmlStr += tempInd + `<${tagName}${piTextNodeName}${attStr2}?>`;
        isPreviousElementTag = true;
        continue;
      }
      let newIdentation = indentation;
      if (newIdentation !== "") {
        newIdentation += options3.indentBy;
      }
      const attStr = attr_to_str(tagObj[":@"], options3);
      const tagStart = indentation + `<${tagName}${attStr}`;
      const tagValue = arrToStr(tagObj[tagName], options3, newJPath, newIdentation);
      if (options3.unpairedTags.indexOf(tagName) !== -1) {
        if (options3.suppressUnpairedNode)
          xmlStr += tagStart + ">";
        else
          xmlStr += tagStart + "/>";
      } else if ((!tagValue || tagValue.length === 0) && options3.suppressEmptyNode) {
        xmlStr += tagStart + "/>";
      } else if (tagValue && tagValue.endsWith(">")) {
        xmlStr += tagStart + `>${tagValue}${indentation}</${tagName}>`;
      } else {
        xmlStr += tagStart + ">";
        if (tagValue && indentation !== "" && (tagValue.includes("/>") || tagValue.includes("</"))) {
          xmlStr += indentation + options3.indentBy + tagValue + indentation;
        } else {
          xmlStr += tagValue;
        }
        xmlStr += `</${tagName}>`;
      }
      isPreviousElementTag = true;
    }
    return xmlStr;
  }
  function propName(obj) {
    const keys2 = Object.keys(obj);
    for (let i2 = 0;i2 < keys2.length; i2++) {
      const key2 = keys2[i2];
      if (!obj.hasOwnProperty(key2))
        continue;
      if (key2 !== ":@")
        return key2;
    }
  }
  function attr_to_str(attrMap, options3) {
    let attrStr = "";
    if (attrMap && !options3.ignoreAttributes) {
      for (let attr in attrMap) {
        if (!attrMap.hasOwnProperty(attr))
          continue;
        let attrVal = options3.attributeValueProcessor(attr, attrMap[attr]);
        attrVal = replaceEntitiesValue(attrVal, options3);
        if (attrVal === true && options3.suppressBooleanAttributes) {
          attrStr += ` ${attr.substr(options3.attributeNamePrefix.length)}`;
        } else {
          attrStr += ` ${attr.substr(options3.attributeNamePrefix.length)}="${attrVal}"`;
        }
      }
    }
    return attrStr;
  }
  function isStopNode(jPath, options3) {
    jPath = jPath.substr(0, jPath.length - options3.textNodeName.length - 1);
    let tagName = jPath.substr(jPath.lastIndexOf(".") + 1);
    for (let index in options3.stopNodes) {
      if (options3.stopNodes[index] === jPath || options3.stopNodes[index] === "*." + tagName)
        return true;
    }
    return false;
  }
  function replaceEntitiesValue(textValue, options3) {
    if (textValue && textValue.length > 0 && options3.processEntities) {
      for (let i2 = 0;i2 < options3.entities.length; i2++) {
        const entity = options3.entities[i2];
        textValue = textValue.replace(entity.regex, entity.val);
      }
    }
    return textValue;
  }
  module.exports = toXml;
});
var require_json2xml = __commonJS2((exports, module) => {
  var buildFromOrderedJs = require_orderedJs2Xml();
  var defaultOptions2 = {
    attributeNamePrefix: "@_",
    attributesGroupName: false,
    textNodeName: "#text",
    ignoreAttributes: true,
    cdataPropName: false,
    format: false,
    indentBy: "  ",
    suppressEmptyNode: false,
    suppressUnpairedNode: true,
    suppressBooleanAttributes: true,
    tagValueProcessor: function(key2, a) {
      return a;
    },
    attributeValueProcessor: function(attrName, a) {
      return a;
    },
    preserveOrder: false,
    commentPropName: false,
    unpairedTags: [],
    entities: [
      { regex: new RegExp("&", "g"), val: "&amp;" },
      { regex: new RegExp(">", "g"), val: "&gt;" },
      { regex: new RegExp("<", "g"), val: "&lt;" },
      { regex: new RegExp("\'", "g"), val: "&apos;" },
      { regex: new RegExp("\"", "g"), val: "&quot;" }
    ],
    processEntities: true,
    stopNodes: [],
    oneListGroup: false
  };
  function Builder(options3) {
    this.options = Object.assign({}, defaultOptions2, options3);
    if (this.options.ignoreAttributes || this.options.attributesGroupName) {
      this.isAttribute = function() {
        return false;
      };
    } else {
      this.attrPrefixLen = this.options.attributeNamePrefix.length;
      this.isAttribute = isAttribute;
    }
    this.processTextOrObjNode = processTextOrObjNode;
    if (this.options.format) {
      this.indentate = indentate;
      this.tagEndChar = ">\n";
      this.newLine = "\n";
    } else {
      this.indentate = function() {
        return "";
      };
      this.tagEndChar = ">";
      this.newLine = "";
    }
  }
  Builder.prototype.build = function(jObj) {
    if (this.options.preserveOrder) {
      return buildFromOrderedJs(jObj, this.options);
    } else {
      if (Array.isArray(jObj) && this.options.arrayNodeName && this.options.arrayNodeName.length > 1) {
        jObj = {
          [this.options.arrayNodeName]: jObj
        };
      }
      return this.j2x(jObj, 0).val;
    }
  };
  Builder.prototype.j2x = function(jObj, level) {
    let attrStr = "";
    let val2 = "";
    for (let key2 in jObj) {
      if (!Object.prototype.hasOwnProperty.call(jObj, key2))
        continue;
      if (typeof jObj[key2] === "undefined") {
        if (this.isAttribute(key2)) {
          val2 += "";
        }
      } else if (jObj[key2] === null) {
        if (this.isAttribute(key2)) {
          val2 += "";
        } else if (key2[0] === "?") {
          val2 += this.indentate(level) + "<" + key2 + "?" + this.tagEndChar;
        } else {
          val2 += this.indentate(level) + "<" + key2 + "/" + this.tagEndChar;
        }
      } else if (jObj[key2] instanceof Date) {
        val2 += this.buildTextValNode(jObj[key2], key2, "", level);
      } else if (typeof jObj[key2] !== "object") {
        const attr = this.isAttribute(key2);
        if (attr) {
          attrStr += this.buildAttrPairStr(attr, "" + jObj[key2]);
        } else {
          if (key2 === this.options.textNodeName) {
            let newval = this.options.tagValueProcessor(key2, "" + jObj[key2]);
            val2 += this.replaceEntitiesValue(newval);
          } else {
            val2 += this.buildTextValNode(jObj[key2], key2, "", level);
          }
        }
      } else if (Array.isArray(jObj[key2])) {
        const arrLen = jObj[key2].length;
        let listTagVal = "";
        let listTagAttr = "";
        for (let j22 = 0;j22 < arrLen; j22++) {
          const item = jObj[key2][j22];
          if (typeof item === "undefined") {
          } else if (item === null) {
            if (key2[0] === "?")
              val2 += this.indentate(level) + "<" + key2 + "?" + this.tagEndChar;
            else
              val2 += this.indentate(level) + "<" + key2 + "/" + this.tagEndChar;
          } else if (typeof item === "object") {
            if (this.options.oneListGroup) {
              const result2 = this.j2x(item, level + 1);
              listTagVal += result2.val;
              if (this.options.attributesGroupName && item.hasOwnProperty(this.options.attributesGroupName)) {
                listTagAttr += result2.attrStr;
              }
            } else {
              listTagVal += this.processTextOrObjNode(item, key2, level);
            }
          } else {
            if (this.options.oneListGroup) {
              let textValue = this.options.tagValueProcessor(key2, item);
              textValue = this.replaceEntitiesValue(textValue);
              listTagVal += textValue;
            } else {
              listTagVal += this.buildTextValNode(item, key2, "", level);
            }
          }
        }
        if (this.options.oneListGroup) {
          listTagVal = this.buildObjectNode(listTagVal, key2, listTagAttr, level);
        }
        val2 += listTagVal;
      } else {
        if (this.options.attributesGroupName && key2 === this.options.attributesGroupName) {
          const Ks = Object.keys(jObj[key2]);
          const L22 = Ks.length;
          for (let j22 = 0;j22 < L22; j22++) {
            attrStr += this.buildAttrPairStr(Ks[j22], "" + jObj[key2][Ks[j22]]);
          }
        } else {
          val2 += this.processTextOrObjNode(jObj[key2], key2, level);
        }
      }
    }
    return { attrStr, val: val2 };
  };
  Builder.prototype.buildAttrPairStr = function(attrName, val2) {
    val2 = this.options.attributeValueProcessor(attrName, "" + val2);
    val2 = this.replaceEntitiesValue(val2);
    if (this.options.suppressBooleanAttributes && val2 === "true") {
      return " " + attrName;
    } else
      return " " + attrName + '="' + val2 + '"';
  };
  function processTextOrObjNode(object, key2, level) {
    const result2 = this.j2x(object, level + 1);
    if (object[this.options.textNodeName] !== undefined && Object.keys(object).length === 1) {
      return this.buildTextValNode(object[this.options.textNodeName], key2, result2.attrStr, level);
    } else {
      return this.buildObjectNode(result2.val, key2, result2.attrStr, level);
    }
  }
  Builder.prototype.buildObjectNode = function(val2, key2, attrStr, level) {
    if (val2 === "") {
      if (key2[0] === "?")
        return this.indentate(level) + "<" + key2 + attrStr + "?" + this.tagEndChar;
      else {
        return this.indentate(level) + "<" + key2 + attrStr + this.closeTag(key2) + this.tagEndChar;
      }
    } else {
      let tagEndExp = "</" + key2 + this.tagEndChar;
      let piClosingChar = "";
      if (key2[0] === "?") {
        piClosingChar = "?";
        tagEndExp = "";
      }
      if ((attrStr || attrStr === "") && val2.indexOf("<") === -1) {
        return this.indentate(level) + "<" + key2 + attrStr + piClosingChar + ">" + val2 + tagEndExp;
      } else if (this.options.commentPropName !== false && key2 === this.options.commentPropName && piClosingChar.length === 0) {
        return this.indentate(level) + `<!--${val2}-->` + this.newLine;
      } else {
        return this.indentate(level) + "<" + key2 + attrStr + piClosingChar + this.tagEndChar + val2 + this.indentate(level) + tagEndExp;
      }
    }
  };
  Builder.prototype.closeTag = function(key2) {
    let closeTag = "";
    if (this.options.unpairedTags.indexOf(key2) !== -1) {
      if (!this.options.suppressUnpairedNode)
        closeTag = "/";
    } else if (this.options.suppressEmptyNode) {
      closeTag = "/";
    } else {
      closeTag = `></${key2}`;
    }
    return closeTag;
  };
  Builder.prototype.buildTextValNode = function(val2, key2, attrStr, level) {
    if (this.options.cdataPropName !== false && key2 === this.options.cdataPropName) {
      return this.indentate(level) + `<![CDATA[${val2}]]>` + this.newLine;
    } else if (this.options.commentPropName !== false && key2 === this.options.commentPropName) {
      return this.indentate(level) + `<!--${val2}-->` + this.newLine;
    } else if (key2[0] === "?") {
      return this.indentate(level) + "<" + key2 + attrStr + "?" + this.tagEndChar;
    } else {
      let textValue = this.options.tagValueProcessor(key2, val2);
      textValue = this.replaceEntitiesValue(textValue);
      if (textValue === "") {
        return this.indentate(level) + "<" + key2 + attrStr + this.closeTag(key2) + this.tagEndChar;
      } else {
        return this.indentate(level) + "<" + key2 + attrStr + ">" + textValue + "</" + key2 + this.tagEndChar;
      }
    }
  };
  Builder.prototype.replaceEntitiesValue = function(textValue) {
    if (textValue && textValue.length > 0 && this.options.processEntities) {
      for (let i2 = 0;i2 < this.options.entities.length; i2++) {
        const entity = this.options.entities[i2];
        textValue = textValue.replace(entity.regex, entity.val);
      }
    }
    return textValue;
  };
  function indentate(level) {
    return this.options.indentBy.repeat(level);
  }
  function isAttribute(name) {
    if (name.startsWith(this.options.attributeNamePrefix) && name !== this.options.textNodeName) {
      return name.substr(this.attrPrefixLen);
    } else {
      return false;
    }
  }
  module.exports = Builder;
});
var require_fxp = __commonJS2((exports, module) => {
  var validator2 = require_validator();
  var XMLParser = require_XMLParser();
  var XMLBuilder = require_json2xml();
  module.exports = {
    XMLParser,
    XMLValidator: validator2,
    XMLBuilder
  };
});
var require_protocols2 = __commonJS2((exports, module) => {
  var __defProp32 = Object.defineProperty;
  var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames22 = Object.getOwnPropertyNames;
  var __hasOwnProp22 = Object.prototype.hasOwnProperty;
  var __name = (target, value) => __defProp32(target, "name", { value, configurable: true });
  var __export32 = (target, all) => {
    for (var name in all)
      __defProp32(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key2 of __getOwnPropNames22(from))
        if (!__hasOwnProp22.call(to, key2) && key2 !== except)
          __defProp32(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc2(from, key2)) || desc.enumerable });
    }
    return to;
  };
  var __toCommonJS2 = (mod) => __copyProps(__defProp32({}, "__esModule", { value: true }), mod);
  var protocols_exports = {};
  __export32(protocols_exports, {
    _toBool: () => _toBool,
    _toNum: () => _toNum,
    _toStr: () => _toStr,
    awsExpectUnion: () => awsExpectUnion,
    loadRestJsonErrorCode: () => loadRestJsonErrorCode,
    loadRestXmlErrorCode: () => loadRestXmlErrorCode,
    parseJsonBody: () => parseJsonBody,
    parseJsonErrorBody: () => parseJsonErrorBody,
    parseXmlBody: () => parseXmlBody,
    parseXmlErrorBody: () => parseXmlErrorBody
  });
  module.exports = __toCommonJS2(protocols_exports);
  var _toStr = /* @__PURE__ */ __name((val2) => {
    if (val2 == null) {
      return val2;
    }
    if (typeof val2 === "number" || typeof val2 === "bigint") {
      const warning = new Error(`Received number ${val2} where a string was expected.`);
      warning.name = "Warning";
      console.warn(warning);
      return String(val2);
    }
    if (typeof val2 === "boolean") {
      const warning = new Error(`Received boolean ${val2} where a string was expected.`);
      warning.name = "Warning";
      console.warn(warning);
      return String(val2);
    }
    return val2;
  }, "_toStr");
  var _toBool = /* @__PURE__ */ __name((val2) => {
    if (val2 == null) {
      return val2;
    }
    if (typeof val2 === "number") {
    }
    if (typeof val2 === "string") {
      const lowercase = val2.toLowerCase();
      if (val2 !== "" && lowercase !== "false" && lowercase !== "true") {
        const warning = new Error(`Received string "${val2}" where a boolean was expected.`);
        warning.name = "Warning";
        console.warn(warning);
      }
      return val2 !== "" && lowercase !== "false";
    }
    return val2;
  }, "_toBool");
  var _toNum = /* @__PURE__ */ __name((val2) => {
    if (val2 == null) {
      return val2;
    }
    if (typeof val2 === "boolean") {
    }
    if (typeof val2 === "string") {
      const num = Number(val2);
      if (num.toString() !== val2) {
        const warning = new Error(`Received string "${val2}" where a number was expected.`);
        warning.name = "Warning";
        console.warn(warning);
        return val2;
      }
      return num;
    }
    return val2;
  }, "_toNum");
  var import_smithy_client = require_dist_cjs19();
  var awsExpectUnion = /* @__PURE__ */ __name((value) => {
    if (value == null) {
      return;
    }
    if (typeof value === "object" && "__type" in value) {
      delete value.__type;
    }
    return (0, import_smithy_client.expectUnion)(value);
  }, "awsExpectUnion");
  var import_smithy_client2 = require_dist_cjs19();
  var collectBodyString = /* @__PURE__ */ __name((streamBody, context) => (0, import_smithy_client2.collectBody)(streamBody, context).then((body) => context.utf8Encoder(body)), "collectBodyString");
  var parseJsonBody = /* @__PURE__ */ __name((streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
      try {
        return JSON.parse(encoded);
      } catch (e) {
        if ((e == null ? undefined : e.name) === "SyntaxError") {
          Object.defineProperty(e, "$responseBodyText", {
            value: encoded
          });
        }
        throw e;
      }
    }
    return {};
  }), "parseJsonBody");
  var parseJsonErrorBody = /* @__PURE__ */ __name(async (errorBody, context) => {
    const value = await parseJsonBody(errorBody, context);
    value.message = value.message ?? value.Message;
    return value;
  }, "parseJsonErrorBody");
  var loadRestJsonErrorCode = /* @__PURE__ */ __name((output, data2) => {
    const findKey = /* @__PURE__ */ __name((object, key2) => Object.keys(object).find((k) => k.toLowerCase() === key2.toLowerCase()), "findKey");
    const sanitizeErrorCode = /* @__PURE__ */ __name((rawValue) => {
      let cleanValue = rawValue;
      if (typeof cleanValue === "number") {
        cleanValue = cleanValue.toString();
      }
      if (cleanValue.indexOf(",") >= 0) {
        cleanValue = cleanValue.split(",")[0];
      }
      if (cleanValue.indexOf(":") >= 0) {
        cleanValue = cleanValue.split(":")[0];
      }
      if (cleanValue.indexOf("#") >= 0) {
        cleanValue = cleanValue.split("#")[1];
      }
      return cleanValue;
    }, "sanitizeErrorCode");
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
      return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data2.code !== undefined) {
      return sanitizeErrorCode(data2.code);
    }
    if (data2["__type"] !== undefined) {
      return sanitizeErrorCode(data2["__type"]);
    }
  }, "loadRestJsonErrorCode");
  var import_smithy_client3 = require_dist_cjs19();
  var import_fast_xml_parser = require_fxp();
  var parseXmlBody = /* @__PURE__ */ __name((streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
      const parser2 = new import_fast_xml_parser.XMLParser({
        attributeNamePrefix: "",
        htmlEntities: true,
        ignoreAttributes: false,
        ignoreDeclaration: true,
        parseTagValue: false,
        trimValues: false,
        tagValueProcessor: (_22, val2) => val2.trim() === "" && val2.includes("\n") ? "" : undefined
      });
      parser2.addEntity("#xD", "\r");
      parser2.addEntity("#10", "\n");
      let parsedObj;
      try {
        parsedObj = parser2.parse(encoded, true);
      } catch (e) {
        if (e && typeof e === "object") {
          Object.defineProperty(e, "$responseBodyText", {
            value: encoded
          });
        }
        throw e;
      }
      const textNodeName = "#text";
      const key2 = Object.keys(parsedObj)[0];
      const parsedObjToReturn = parsedObj[key2];
      if (parsedObjToReturn[textNodeName]) {
        parsedObjToReturn[key2] = parsedObjToReturn[textNodeName];
        delete parsedObjToReturn[textNodeName];
      }
      return (0, import_smithy_client3.getValueFromTextNode)(parsedObjToReturn);
    }
    return {};
  }), "parseXmlBody");
  var parseXmlErrorBody = /* @__PURE__ */ __name(async (errorBody, context) => {
    const value = await parseXmlBody(errorBody, context);
    if (value.Error) {
      value.Error.message = value.Error.message ?? value.Error.Message;
    }
    return value;
  }, "parseXmlErrorBody");
  var loadRestXmlErrorCode = /* @__PURE__ */ __name((output, data2) => {
    var _a;
    if (((_a = data2 == null ? undefined : data2.Error) == null ? undefined : _a.Code) !== undefined) {
      return data2.Error.Code;
    }
    if ((data2 == null ? undefined : data2.Code) !== undefined) {
      return data2.Code;
    }
    if (output.statusCode == 404) {
      return "NotFound";
    }
  }, "loadRestXmlErrorCode");
});
var require_dist_cjs20 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", { value: true });
  var tslib_1 = require_tslib();
  tslib_1.__exportStar(require_client4(), exports);
  tslib_1.__exportStar(require_httpAuthSchemes(), exports);
  tslib_1.__exportStar(require_protocols2(), exports);
});
var CLIENT_SUPPORTED_ALGORITHMS;
var PRIORITY_ORDER_ALGORITHMS;
var init_types5 = __esm2(() => {
  init_constants();
  CLIENT_SUPPORTED_ALGORITHMS = [
    ChecksumAlgorithm.CRC32,
    ChecksumAlgorithm.CRC32C,
    ChecksumAlgorithm.SHA1,
    ChecksumAlgorithm.SHA256
  ];
  PRIORITY_ORDER_ALGORITHMS = [
    ChecksumAlgorithm.SHA256,
    ChecksumAlgorithm.SHA1,
    ChecksumAlgorithm.CRC32,
    ChecksumAlgorithm.CRC32C
  ];
});
var getChecksumAlgorithmForRequest = (input, { requestChecksumRequired, requestAlgorithmMember }, isS3Express) => {
  const defaultAlgorithm = isS3Express ? S3_EXPRESS_DEFAULT_CHECKSUM_ALGORITHM : DEFAULT_CHECKSUM_ALGORITHM;
  if (!requestAlgorithmMember || !input[requestAlgorithmMember]) {
    return requestChecksumRequired ? defaultAlgorithm : undefined;
  }
  const checksumAlgorithm = input[requestAlgorithmMember];
  if (!CLIENT_SUPPORTED_ALGORITHMS.includes(checksumAlgorithm)) {
    throw new Error(`The checksum algorithm "${checksumAlgorithm}" is not supported by the client. Select one of ${CLIENT_SUPPORTED_ALGORITHMS}.`);
  }
  return checksumAlgorithm;
};
var init_getChecksumAlgorithmForRequest = __esm2(() => {
  init_constants();
  init_types5();
});
var getChecksumLocationName = (algorithm) => algorithm === ChecksumAlgorithm.MD5 ? "content-md5" : `x-amz-checksum-${algorithm.toLowerCase()}`;
var init_getChecksumLocationName = __esm2(() => {
  init_constants();
});
var hasHeader = (header, headers) => {
  const soughtHeader = header.toLowerCase();
  for (const headerName of Object.keys(headers)) {
    if (soughtHeader === headerName.toLowerCase()) {
      return true;
    }
  }
  return false;
};
var isArrayBuffer = (arg) => typeof ArrayBuffer === "function" && arg instanceof ArrayBuffer || Object.prototype.toString.call(arg) === "[object ArrayBuffer]";
var isStreaming = (body) => body !== undefined && typeof body !== "string" && !ArrayBuffer.isView(body) && !isArrayBuffer(body);
var init_isStreaming = () => {
};
var import_tslib;
var __extends;
var __assign2;
var __rest;
var __decorate;
var __param;
var __esDecorate;
var __runInitializers;
var __propKey;
var __setFunctionName;
var __metadata;
var __awaiter22;
var __generator;
var __exportStar;
var __createBinding;
var __values22;
var __read;
var __spread;
var __spreadArrays;
var __spreadArray;
var __await22;
var __asyncGenerator22;
var __asyncDelegator22;
var __asyncValues22;
var __makeTemplateObject;
var __importStar;
var __importDefault;
var __classPrivateFieldGet;
var __classPrivateFieldSet;
var __classPrivateFieldIn;
var __addDisposableResource;
var __disposeResources;
var __rewriteRelativeImportExtension;
var init_modules = __esm2(() => {
  import_tslib = __toESM3(require_tslib(), 1);
  ({
    __extends,
    __assign: __assign2,
    __rest,
    __decorate,
    __param,
    __esDecorate,
    __runInitializers,
    __propKey,
    __setFunctionName,
    __metadata,
    __awaiter: __awaiter22,
    __generator,
    __exportStar,
    __createBinding,
    __values: __values22,
    __read,
    __spread,
    __spreadArrays,
    __spreadArray,
    __await: __await22,
    __asyncGenerator: __asyncGenerator22,
    __asyncDelegator: __asyncDelegator22,
    __asyncValues: __asyncValues22,
    __makeTemplateObject,
    __importStar,
    __importDefault,
    __classPrivateFieldGet,
    __classPrivateFieldSet,
    __classPrivateFieldIn,
    __addDisposableResource,
    __disposeResources,
    __rewriteRelativeImportExtension
  } = import_tslib.default);
});
var fromString = (input, encoding) => {
  if (typeof input !== "string") {
    throw new TypeError(`The "input" argument must be of type string. Received type ${typeof input} (${input})`);
  }
  return encoding ? Buffer2.from(input, encoding) : Buffer2.from(input);
};
var init_dist_es3 = () => {
};
var fromUtf8 = (input) => {
  const buf = fromString(input, "utf8");
  return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength / Uint8Array.BYTES_PER_ELEMENT);
};
var init_fromUtf8 = __esm2(() => {
  init_dist_es3();
});
var init_toUint8Array = __esm2(() => {
  init_fromUtf8();
});
var init_toUtf8 = __esm2(() => {
  init_dist_es3();
});
var init_dist_es4 = __esm2(() => {
  init_fromUtf8();
  init_toUint8Array();
  init_toUtf8();
});
function convertToBuffer(data2) {
  if (data2 instanceof Uint8Array)
    return data2;
  if (typeof data2 === "string") {
    return fromUtf83(data2);
  }
  if (ArrayBuffer.isView(data2)) {
    return new Uint8Array(data2.buffer, data2.byteOffset, data2.byteLength / Uint8Array.BYTES_PER_ELEMENT);
  }
  return new Uint8Array(data2);
}
var fromUtf83;
var init_convertToBuffer = __esm2(() => {
  init_dist_es4();
  fromUtf83 = typeof Buffer !== "undefined" && Buffer.from ? function(input) {
    return Buffer.from(input, "utf8");
  } : fromUtf8;
});
function isEmptyData(data2) {
  if (typeof data2 === "string") {
    return data2.length === 0;
  }
  return data2.byteLength === 0;
}
function numToUint8(num) {
  return new Uint8Array([
    (num & 4278190080) >> 24,
    (num & 16711680) >> 16,
    (num & 65280) >> 8,
    num & 255
  ]);
}
function uint32ArrayFrom(a_lookUpTable) {
  if (!Uint32Array.from) {
    var return_array = new Uint32Array(a_lookUpTable.length);
    var a_index = 0;
    while (a_index < a_lookUpTable.length) {
      return_array[a_index] = a_lookUpTable[a_index];
      a_index += 1;
    }
    return return_array;
  }
  return Uint32Array.from(a_lookUpTable);
}
var init_module = __esm2(() => {
  init_convertToBuffer();
});
var AwsCrc32;
var init_aws_crc32 = __esm2(() => {
  init_modules();
  init_module();
  init_module2();
  AwsCrc32 = function() {
    function AwsCrc322() {
      this.crc32 = new Crc32;
    }
    AwsCrc322.prototype.update = function(toHash) {
      if (isEmptyData(toHash))
        return;
      this.crc32.update(convertToBuffer(toHash));
    };
    AwsCrc322.prototype.digest = function() {
      return __awaiter22(this, undefined, undefined, function() {
        return __generator(this, function(_a) {
          return [2, numToUint8(this.crc32.digest())];
        });
      });
    };
    AwsCrc322.prototype.reset = function() {
      this.crc32 = new Crc32;
    };
    return AwsCrc322;
  }();
});
var Crc32;
var a_lookUpTable;
var lookupTable;
var init_module2 = __esm2(() => {
  init_modules();
  init_module();
  init_aws_crc32();
  Crc32 = function() {
    function Crc322() {
      this.checksum = 4294967295;
    }
    Crc322.prototype.update = function(data2) {
      var e_1, _a;
      try {
        for (var data_1 = __values22(data2), data_1_1 = data_1.next();!data_1_1.done; data_1_1 = data_1.next()) {
          var byte = data_1_1.value;
          this.checksum = this.checksum >>> 8 ^ lookupTable[(this.checksum ^ byte) & 255];
        }
      } catch (e_1_1) {
        e_1 = { error: e_1_1 };
      } finally {
        try {
          if (data_1_1 && !data_1_1.done && (_a = data_1.return))
            _a.call(data_1);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return this;
    };
    Crc322.prototype.digest = function() {
      return (this.checksum ^ 4294967295) >>> 0;
    };
    return Crc322;
  }();
  a_lookUpTable = [
    0,
    1996959894,
    3993919788,
    2567524794,
    124634137,
    1886057615,
    3915621685,
    2657392035,
    249268274,
    2044508324,
    3772115230,
    2547177864,
    162941995,
    2125561021,
    3887607047,
    2428444049,
    498536548,
    1789927666,
    4089016648,
    2227061214,
    450548861,
    1843258603,
    4107580753,
    2211677639,
    325883990,
    1684777152,
    4251122042,
    2321926636,
    335633487,
    1661365465,
    4195302755,
    2366115317,
    997073096,
    1281953886,
    3579855332,
    2724688242,
    1006888145,
    1258607687,
    3524101629,
    2768942443,
    901097722,
    1119000684,
    3686517206,
    2898065728,
    853044451,
    1172266101,
    3705015759,
    2882616665,
    651767980,
    1373503546,
    3369554304,
    3218104598,
    565507253,
    1454621731,
    3485111705,
    3099436303,
    671266974,
    1594198024,
    3322730930,
    2970347812,
    795835527,
    1483230225,
    3244367275,
    3060149565,
    1994146192,
    31158534,
    2563907772,
    4023717930,
    1907459465,
    112637215,
    2680153253,
    3904427059,
    2013776290,
    251722036,
    2517215374,
    3775830040,
    2137656763,
    141376813,
    2439277719,
    3865271297,
    1802195444,
    476864866,
    2238001368,
    4066508878,
    1812370925,
    453092731,
    2181625025,
    4111451223,
    1706088902,
    314042704,
    2344532202,
    4240017532,
    1658658271,
    366619977,
    2362670323,
    4224994405,
    1303535960,
    984961486,
    2747007092,
    3569037538,
    1256170817,
    1037604311,
    2765210733,
    3554079995,
    1131014506,
    879679996,
    2909243462,
    3663771856,
    1141124467,
    855842277,
    2852801631,
    3708648649,
    1342533948,
    654459306,
    3188396048,
    3373015174,
    1466479909,
    544179635,
    3110523913,
    3462522015,
    1591671054,
    702138776,
    2966460450,
    3352799412,
    1504918807,
    783551873,
    3082640443,
    3233442989,
    3988292384,
    2596254646,
    62317068,
    1957810842,
    3939845945,
    2647816111,
    81470997,
    1943803523,
    3814918930,
    2489596804,
    225274430,
    2053790376,
    3826175755,
    2466906013,
    167816743,
    2097651377,
    4027552580,
    2265490386,
    503444072,
    1762050814,
    4150417245,
    2154129355,
    426522225,
    1852507879,
    4275313526,
    2312317920,
    282753626,
    1742555852,
    4189708143,
    2394877945,
    397917763,
    1622183637,
    3604390888,
    2714866558,
    953729732,
    1340076626,
    3518719985,
    2797360999,
    1068828381,
    1219638859,
    3624741850,
    2936675148,
    906185462,
    1090812512,
    3747672003,
    2825379669,
    829329135,
    1181335161,
    3412177804,
    3160834842,
    628085408,
    1382605366,
    3423369109,
    3138078467,
    570562233,
    1426400815,
    3317316542,
    2998733608,
    733239954,
    1555261956,
    3268935591,
    3050360625,
    752459403,
    1541320221,
    2607071920,
    3965973030,
    1969922972,
    40735498,
    2617837225,
    3943577151,
    1913087877,
    83908371,
    2512341634,
    3803740692,
    2075208622,
    213261112,
    2463272603,
    3855990285,
    2094854071,
    198958881,
    2262029012,
    4057260610,
    1759359992,
    534414190,
    2176718541,
    4139329115,
    1873836001,
    414664567,
    2282248934,
    4279200368,
    1711684554,
    285281116,
    2405801727,
    4167216745,
    1634467795,
    376229701,
    2685067896,
    3608007406,
    1308918612,
    956543938,
    2808555105,
    3495958263,
    1231636301,
    1047427035,
    2932959818,
    3654703836,
    1088359270,
    936918000,
    2847714899,
    3736837829,
    1202900863,
    817233897,
    3183342108,
    3401237130,
    1404277552,
    615818150,
    3134207493,
    3453421203,
    1423857449,
    601450431,
    3009837614,
    3294710456,
    1567103746,
    711928724,
    3020668471,
    3272380065,
    1510334235,
    755167117
  ];
  lookupTable = uint32ArrayFrom(a_lookUpTable);
});
var AwsCrc32c;
var init_aws_crc32c = __esm2(() => {
  init_modules();
  init_module();
  init_module3();
  AwsCrc32c = function() {
    function AwsCrc32c2() {
      this.crc32c = new Crc32c;
    }
    AwsCrc32c2.prototype.update = function(toHash) {
      if (isEmptyData(toHash))
        return;
      this.crc32c.update(convertToBuffer(toHash));
    };
    AwsCrc32c2.prototype.digest = function() {
      return __awaiter22(this, undefined, undefined, function() {
        return __generator(this, function(_a) {
          return [2, numToUint8(this.crc32c.digest())];
        });
      });
    };
    AwsCrc32c2.prototype.reset = function() {
      this.crc32c = new Crc32c;
    };
    return AwsCrc32c2;
  }();
});
var Crc32c;
var a_lookupTable;
var lookupTable2;
var init_module3 = __esm2(() => {
  init_modules();
  init_module();
  init_aws_crc32c();
  Crc32c = function() {
    function Crc32c2() {
      this.checksum = 4294967295;
    }
    Crc32c2.prototype.update = function(data2) {
      var e_1, _a;
      try {
        for (var data_1 = __values22(data2), data_1_1 = data_1.next();!data_1_1.done; data_1_1 = data_1.next()) {
          var byte = data_1_1.value;
          this.checksum = this.checksum >>> 8 ^ lookupTable2[(this.checksum ^ byte) & 255];
        }
      } catch (e_1_1) {
        e_1 = { error: e_1_1 };
      } finally {
        try {
          if (data_1_1 && !data_1_1.done && (_a = data_1.return))
            _a.call(data_1);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return this;
    };
    Crc32c2.prototype.digest = function() {
      return (this.checksum ^ 4294967295) >>> 0;
    };
    return Crc32c2;
  }();
  a_lookupTable = [
    0,
    4067132163,
    3778769143,
    324072436,
    3348797215,
    904991772,
    648144872,
    3570033899,
    2329499855,
    2024987596,
    1809983544,
    2575936315,
    1296289744,
    3207089363,
    2893594407,
    1578318884,
    274646895,
    3795141740,
    4049975192,
    51262619,
    3619967088,
    632279923,
    922689671,
    3298075524,
    2592579488,
    1760304291,
    2075979607,
    2312596564,
    1562183871,
    2943781820,
    3156637768,
    1313733451,
    549293790,
    3537243613,
    3246849577,
    871202090,
    3878099393,
    357341890,
    102525238,
    4101499445,
    2858735121,
    1477399826,
    1264559846,
    3107202533,
    1845379342,
    2677391885,
    2361733625,
    2125378298,
    820201905,
    3263744690,
    3520608582,
    598981189,
    4151959214,
    85089709,
    373468761,
    3827903834,
    3124367742,
    1213305469,
    1526817161,
    2842354314,
    2107672161,
    2412447074,
    2627466902,
    1861252501,
    1098587580,
    3004210879,
    2688576843,
    1378610760,
    2262928035,
    1955203488,
    1742404180,
    2511436119,
    3416409459,
    969524848,
    714683780,
    3639785095,
    205050476,
    4266873199,
    3976438427,
    526918040,
    1361435347,
    2739821008,
    2954799652,
    1114974503,
    2529119692,
    1691668175,
    2005155131,
    2247081528,
    3690758684,
    697762079,
    986182379,
    3366744552,
    476452099,
    3993867776,
    4250756596,
    255256311,
    1640403810,
    2477592673,
    2164122517,
    1922457750,
    2791048317,
    1412925310,
    1197962378,
    3037525897,
    3944729517,
    427051182,
    170179418,
    4165941337,
    746937522,
    3740196785,
    3451792453,
    1070968646,
    1905808397,
    2213795598,
    2426610938,
    1657317369,
    3053634322,
    1147748369,
    1463399397,
    2773627110,
    4215344322,
    153784257,
    444234805,
    3893493558,
    1021025245,
    3467647198,
    3722505002,
    797665321,
    2197175160,
    1889384571,
    1674398607,
    2443626636,
    1164749927,
    3070701412,
    2757221520,
    1446797203,
    137323447,
    4198817972,
    3910406976,
    461344835,
    3484808360,
    1037989803,
    781091935,
    3705997148,
    2460548119,
    1623424788,
    1939049696,
    2180517859,
    1429367560,
    2807687179,
    3020495871,
    1180866812,
    410100952,
    3927582683,
    4182430767,
    186734380,
    3756733383,
    763408580,
    1053836080,
    3434856499,
    2722870694,
    1344288421,
    1131464017,
    2971354706,
    1708204729,
    2545590714,
    2229949006,
    1988219213,
    680717673,
    3673779818,
    3383336350,
    1002577565,
    4010310262,
    493091189,
    238226049,
    4233660802,
    2987750089,
    1082061258,
    1395524158,
    2705686845,
    1972364758,
    2279892693,
    2494862625,
    1725896226,
    952904198,
    3399985413,
    3656866545,
    731699698,
    4283874585,
    222117402,
    510512622,
    3959836397,
    3280807620,
    837199303,
    582374963,
    3504198960,
    68661723,
    4135334616,
    3844915500,
    390545967,
    1230274059,
    3141532936,
    2825850620,
    1510247935,
    2395924756,
    2091215383,
    1878366691,
    2644384480,
    3553878443,
    565732008,
    854102364,
    3229815391,
    340358836,
    3861050807,
    4117890627,
    119113024,
    1493875044,
    2875275879,
    3090270611,
    1247431312,
    2660249211,
    1828433272,
    2141937292,
    2378227087,
    3811616794,
    291187481,
    34330861,
    4032846830,
    615137029,
    3603020806,
    3314634738,
    939183345,
    1776939221,
    2609017814,
    2295496738,
    2058945313,
    2926798794,
    1545135305,
    1330124605,
    3173225534,
    4084100981,
    17165430,
    307568514,
    3762199681,
    888469610,
    3332340585,
    3587147933,
    665062302,
    2042050490,
    2346497209,
    2559330125,
    1793573966,
    3190661285,
    1279665062,
    1595330642,
    2910671697
  ];
  lookupTable2 = uint32ArrayFrom(a_lookupTable);
});
var selectChecksumAlgorithmFunction = (checksumAlgorithm, config6) => ({
  [ChecksumAlgorithm.MD5]: config6.md5,
  [ChecksumAlgorithm.CRC32]: AwsCrc32,
  [ChecksumAlgorithm.CRC32C]: AwsCrc32c,
  [ChecksumAlgorithm.SHA1]: config6.sha1,
  [ChecksumAlgorithm.SHA256]: config6.sha256
})[checksumAlgorithm];
var init_selectChecksumAlgorithmFunction = __esm2(() => {
  init_module2();
  init_module3();
  init_constants();
});
var fromArrayBuffer2 = (input, offset2 = 0, length = input.byteLength - offset2) => {
  if (!isArrayBuffer(input)) {
    throw new TypeError(`The "input" argument must be ArrayBuffer. Received type ${typeof input} (${input})`);
  }
  return Buffer3.from(input, offset2, length);
};
var fromString2 = (input, encoding) => {
  if (typeof input !== "string") {
    throw new TypeError(`The "input" argument must be of type string. Received type ${typeof input} (${input})`);
  }
  return encoding ? Buffer3.from(input, encoding) : Buffer3.from(input);
};
var init_dist_es5 = () => {
};
var fromUtf84 = (input) => {
  const buf = fromString2(input, "utf8");
  return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength / Uint8Array.BYTES_PER_ELEMENT);
};
var init_fromUtf82 = __esm2(() => {
  init_dist_es5();
});
var toUint8Array2 = (data2) => {
  if (typeof data2 === "string") {
    return fromUtf84(data2);
  }
  if (ArrayBuffer.isView(data2)) {
    return new Uint8Array(data2.buffer, data2.byteOffset, data2.byteLength / Uint8Array.BYTES_PER_ELEMENT);
  }
  return new Uint8Array(data2);
};
var init_toUint8Array2 = __esm2(() => {
  init_fromUtf82();
});
var toUtf82 = (input) => {
  if (typeof input === "string") {
    return input;
  }
  if (typeof input !== "object" || typeof input.byteOffset !== "number" || typeof input.byteLength !== "number") {
    throw new Error("@smithy/util-utf8: toUtf8 encoder function only accepts string | Uint8Array.");
  }
  return fromArrayBuffer2(input.buffer, input.byteOffset, input.byteLength).toString("utf8");
};
var init_toUtf82 = __esm2(() => {
  init_dist_es5();
});
var init_dist_es6 = __esm2(() => {
  init_fromUtf82();
  init_toUint8Array2();
  init_toUtf82();
});
var stringHasher = (checksumAlgorithmFn, body) => {
  const hash3 = new checksumAlgorithmFn;
  hash3.update(toUint8Array2(body || ""));
  return hash3.digest();
};
var init_stringHasher = __esm2(() => {
  init_dist_es6();
});
var import_core4;
var flexibleChecksumsMiddlewareOptions;
var flexibleChecksumsMiddleware = (config6, middlewareConfig) => (next, context) => async (args) => {
  if (!HttpRequest.isInstance(args.request)) {
    return next(args);
  }
  const { request: request42 } = args;
  const { body: requestBody, headers } = request42;
  const { base64Encoder, streamHasher } = config6;
  const { input, requestChecksumRequired, requestAlgorithmMember } = middlewareConfig;
  const checksumAlgorithm = getChecksumAlgorithmForRequest(input, {
    requestChecksumRequired,
    requestAlgorithmMember
  }, !!context.isS3ExpressBucket);
  let updatedBody = requestBody;
  let updatedHeaders = headers;
  if (checksumAlgorithm) {
    switch (checksumAlgorithm) {
      case ChecksumAlgorithm.CRC32:
        import_core4.setFeature(context, "FLEXIBLE_CHECKSUMS_REQ_CRC32", "U");
        break;
      case ChecksumAlgorithm.CRC32C:
        import_core4.setFeature(context, "FLEXIBLE_CHECKSUMS_REQ_CRC32C", "V");
        break;
      case ChecksumAlgorithm.SHA1:
        import_core4.setFeature(context, "FLEXIBLE_CHECKSUMS_REQ_SHA1", "X");
        break;
      case ChecksumAlgorithm.SHA256:
        import_core4.setFeature(context, "FLEXIBLE_CHECKSUMS_REQ_SHA256", "Y");
        break;
    }
    const checksumLocationName = getChecksumLocationName(checksumAlgorithm);
    const checksumAlgorithmFn = selectChecksumAlgorithmFunction(checksumAlgorithm, config6);
    if (isStreaming(requestBody)) {
      const { getAwsChunkedEncodingStream: getAwsChunkedEncodingStream2, bodyLengthChecker } = config6;
      updatedBody = getAwsChunkedEncodingStream2(requestBody, {
        base64Encoder,
        bodyLengthChecker,
        checksumLocationName,
        checksumAlgorithmFn,
        streamHasher
      });
      updatedHeaders = {
        ...headers,
        "content-encoding": headers["content-encoding"] ? `${headers["content-encoding"]},aws-chunked` : "aws-chunked",
        "transfer-encoding": "chunked",
        "x-amz-decoded-content-length": headers["content-length"],
        "x-amz-content-sha256": "STREAMING-UNSIGNED-PAYLOAD-TRAILER",
        "x-amz-trailer": checksumLocationName
      };
      delete updatedHeaders["content-length"];
    } else if (!hasHeader(checksumLocationName, headers)) {
      const rawChecksum = await stringHasher(checksumAlgorithmFn, requestBody);
      updatedHeaders = {
        ...headers,
        [checksumLocationName]: base64Encoder(rawChecksum)
      };
    }
  }
  const result2 = await next({
    ...args,
    request: {
      ...request42,
      headers: updatedHeaders,
      body: updatedBody
    }
  });
  return result2;
};
var init_flexibleChecksumsMiddleware = __esm2(() => {
  import_core4 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es();
  init_constants();
  init_getChecksumAlgorithmForRequest();
  init_getChecksumLocationName();
  init_isStreaming();
  init_selectChecksumAlgorithmFunction();
  init_stringHasher();
  flexibleChecksumsMiddlewareOptions = {
    name: "flexibleChecksumsMiddleware",
    step: "build",
    tags: ["BODY_CHECKSUM"],
    override: true
  };
});
var getChecksumAlgorithmListForResponse = (responseAlgorithms = []) => {
  const validChecksumAlgorithms = [];
  for (const algorithm of PRIORITY_ORDER_ALGORITHMS) {
    if (!responseAlgorithms.includes(algorithm) || !CLIENT_SUPPORTED_ALGORITHMS.includes(algorithm)) {
      continue;
    }
    validChecksumAlgorithms.push(algorithm);
  }
  return validChecksumAlgorithms;
};
var init_getChecksumAlgorithmListForResponse = __esm2(() => {
  init_types5();
});
var isChecksumWithPartNumber = (checksum) => {
  const lastHyphenIndex = checksum.lastIndexOf("-");
  if (lastHyphenIndex !== -1) {
    const numberPart = checksum.slice(lastHyphenIndex + 1);
    if (!numberPart.startsWith("0")) {
      const number = parseInt(numberPart, 10);
      if (!isNaN(number) && number >= 1 && number <= 1e4) {
        return true;
      }
    }
  }
  return false;
};
function createReadStreamOnBuffer(buffer) {
  const stream2 = new Transform;
  stream2.push(buffer);
  stream2.push(null);
  return stream2;
}
var init_create_read_stream_on_buffer = () => {
};
var getChecksum = async (body, { streamHasher, checksumAlgorithmFn, base64Encoder }) => {
  const digest = isStreaming(body) ? streamHasher(checksumAlgorithmFn, body) : stringHasher(checksumAlgorithmFn, body);
  return base64Encoder(await digest);
};
var init_getChecksum = __esm2(() => {
  init_isStreaming();
  init_stringHasher();
});
var validateChecksumFromResponse = async (response, { config: config6, responseAlgorithms }) => {
  const checksumAlgorithms = getChecksumAlgorithmListForResponse(responseAlgorithms);
  const { body: responseBody, headers: responseHeaders } = response;
  for (const algorithm of checksumAlgorithms) {
    const responseHeader = getChecksumLocationName(algorithm);
    const checksumFromResponse = responseHeaders[responseHeader];
    if (checksumFromResponse) {
      const checksumAlgorithmFn = selectChecksumAlgorithmFunction(algorithm, config6);
      const { streamHasher, base64Encoder } = config6;
      const checksum = await getChecksum(responseBody, { streamHasher, checksumAlgorithmFn, base64Encoder });
      if (checksum === checksumFromResponse) {
        break;
      }
      throw new Error(`Checksum mismatch: expected "${checksum}" but received "${checksumFromResponse}" in response header "${responseHeader}".`);
    }
  }
};
var init_validateChecksumFromResponse = __esm2(() => {
  init_getChecksum();
  init_getChecksumAlgorithmListForResponse();
  init_getChecksumLocationName();
  init_selectChecksumAlgorithmFunction();
});
var flexibleChecksumsResponseMiddlewareOptions;
var flexibleChecksumsResponseMiddleware = (config6, middlewareConfig) => (next, context) => async (args) => {
  if (!HttpRequest.isInstance(args.request)) {
    return next(args);
  }
  const input = args.input;
  const result2 = await next(args);
  const response = result2.response;
  let collectedStream = undefined;
  const { requestValidationModeMember, responseAlgorithms } = middlewareConfig;
  if (requestValidationModeMember && input[requestValidationModeMember] === "ENABLED") {
    const { clientName, commandName } = context;
    const isS3WholeObjectMultipartGetResponseChecksum = clientName === "S3Client" && commandName === "GetObjectCommand" && getChecksumAlgorithmListForResponse(responseAlgorithms).every((algorithm) => {
      const responseHeader = getChecksumLocationName(algorithm);
      const checksumFromResponse = response.headers[responseHeader];
      return !checksumFromResponse || isChecksumWithPartNumber(checksumFromResponse);
    });
    if (isS3WholeObjectMultipartGetResponseChecksum) {
      return result2;
    }
    const isStreamingBody = isStreaming(response.body);
    if (isStreamingBody) {
      collectedStream = await config6.streamCollector(response.body);
      response.body = createReadStreamOnBuffer(collectedStream);
    }
    await validateChecksumFromResponse(result2.response, {
      config: config6,
      responseAlgorithms
    });
    if (isStreamingBody && collectedStream) {
      response.body = createReadStreamOnBuffer(collectedStream);
    }
  }
  return result2;
};
var init_flexibleChecksumsResponseMiddleware = __esm2(() => {
  init_dist_es();
  init_getChecksumAlgorithmListForResponse();
  init_getChecksumLocationName();
  init_isStreaming();
  init_create_read_stream_on_buffer();
  init_validateChecksumFromResponse();
  flexibleChecksumsResponseMiddlewareOptions = {
    name: "flexibleChecksumsResponseMiddleware",
    toMiddleware: "deserializerMiddleware",
    relation: "after",
    tags: ["BODY_CHECKSUM"],
    override: true
  };
});
var getFlexibleChecksumsPlugin = (config6, middlewareConfig) => ({
  applyToStack: (clientStack) => {
    clientStack.add(flexibleChecksumsMiddleware(config6, middlewareConfig), flexibleChecksumsMiddlewareOptions);
    clientStack.addRelativeTo(flexibleChecksumsResponseMiddleware(config6, middlewareConfig), flexibleChecksumsResponseMiddlewareOptions);
  }
});
var init_getFlexibleChecksumsPlugin = __esm2(() => {
  init_flexibleChecksumsMiddleware();
  init_flexibleChecksumsResponseMiddleware();
});
var import_util_middleware;
var resolveFlexibleChecksumsConfig = (input) => ({
  ...input,
  requestChecksumCalculation: import_util_middleware.normalizeProvider(input.requestChecksumCalculation ?? DEFAULT_REQUEST_CHECKSUM_CALCULATION),
  responseChecksumValidation: import_util_middleware.normalizeProvider(input.responseChecksumValidation ?? DEFAULT_RESPONSE_CHECKSUM_VALIDATION)
});
var init_resolveFlexibleChecksumsConfig = __esm2(() => {
  import_util_middleware = __toESM3(require_dist_cjs3(), 1);
  init_constants();
});
var init_dist_es7 = __esm2(() => {
  init_NODE_REQUEST_CHECKSUM_CALCULATION_CONFIG_OPTIONS();
  init_NODE_RESPONSE_CHECKSUM_VALIDATION_CONFIG_OPTIONS();
  init_constants();
  init_flexibleChecksumsMiddleware();
  init_getFlexibleChecksumsPlugin();
  init_resolveFlexibleChecksumsConfig();
});
function resolveHostHeaderConfig(input) {
  return input;
}
var hostHeaderMiddleware = (options3) => (next) => async (args) => {
  if (!HttpRequest.isInstance(args.request))
    return next(args);
  const { request: request42 } = args;
  const { handlerProtocol = "" } = options3.requestHandler.metadata || {};
  if (handlerProtocol.indexOf("h2") >= 0 && !request42.headers[":authority"]) {
    delete request42.headers["host"];
    request42.headers[":authority"] = request42.hostname + (request42.port ? ":" + request42.port : "");
  } else if (!request42.headers["host"]) {
    let host = request42.hostname;
    if (request42.port != null)
      host += `:${request42.port}`;
    request42.headers["host"] = host;
  }
  return next(args);
};
var hostHeaderMiddlewareOptions;
var getHostHeaderPlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(hostHeaderMiddleware(options3), hostHeaderMiddlewareOptions);
  }
});
var init_dist_es8 = __esm2(() => {
  init_dist_es();
  hostHeaderMiddlewareOptions = {
    name: "hostHeaderMiddleware",
    step: "build",
    priority: "low",
    tags: ["HOST"],
    override: true
  };
});
var loggerMiddleware = () => (next, context) => async (args) => {
  try {
    const response = await next(args);
    const { clientName, commandName, logger: logger22, dynamoDbDocumentClientOptions = {} } = context;
    const { overrideInputFilterSensitiveLog, overrideOutputFilterSensitiveLog } = dynamoDbDocumentClientOptions;
    const inputFilterSensitiveLog = overrideInputFilterSensitiveLog ?? context.inputFilterSensitiveLog;
    const outputFilterSensitiveLog = overrideOutputFilterSensitiveLog ?? context.outputFilterSensitiveLog;
    const { $metadata, ...outputWithoutMetadata } = response.output;
    logger22?.info?.({
      clientName,
      commandName,
      input: inputFilterSensitiveLog(args.input),
      output: outputFilterSensitiveLog(outputWithoutMetadata),
      metadata: $metadata
    });
    return response;
  } catch (error) {
    const { clientName, commandName, logger: logger22, dynamoDbDocumentClientOptions = {} } = context;
    const { overrideInputFilterSensitiveLog } = dynamoDbDocumentClientOptions;
    const inputFilterSensitiveLog = overrideInputFilterSensitiveLog ?? context.inputFilterSensitiveLog;
    logger22?.error?.({
      clientName,
      commandName,
      input: inputFilterSensitiveLog(args.input),
      error,
      metadata: error.$metadata
    });
    throw error;
  }
};
var loggerMiddlewareOptions;
var getLoggerPlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(loggerMiddleware(), loggerMiddlewareOptions);
  }
});
var init_loggerMiddleware = __esm2(() => {
  loggerMiddlewareOptions = {
    name: "loggerMiddleware",
    tags: ["LOGGER"],
    step: "initialize",
    override: true
  };
});
var init_dist_es9 = __esm2(() => {
  init_loggerMiddleware();
});
var TRACE_ID_HEADER_NAME = "X-Amzn-Trace-Id";
var ENV_LAMBDA_FUNCTION_NAME = "AWS_LAMBDA_FUNCTION_NAME";
var ENV_TRACE_ID = "_X_AMZN_TRACE_ID";
var recursionDetectionMiddleware = (options3) => (next) => async (args) => {
  const { request: request42 } = args;
  if (!HttpRequest.isInstance(request42) || options3.runtime !== "node" || request42.headers.hasOwnProperty(TRACE_ID_HEADER_NAME)) {
    return next(args);
  }
  const functionName = process.env[ENV_LAMBDA_FUNCTION_NAME];
  const traceId = process.env[ENV_TRACE_ID];
  const nonEmptyString = (str2) => typeof str2 === "string" && str2.length > 0;
  if (nonEmptyString(functionName) && nonEmptyString(traceId)) {
    request42.headers[TRACE_ID_HEADER_NAME] = traceId;
  }
  return next({
    ...args,
    request: request42
  });
};
var addRecursionDetectionMiddlewareOptions;
var getRecursionDetectionPlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(recursionDetectionMiddleware(options3), addRecursionDetectionMiddlewareOptions);
  }
});
var init_dist_es10 = __esm2(() => {
  init_dist_es();
  addRecursionDetectionMiddlewareOptions = {
    step: "build",
    tags: ["RECURSION_DETECTION"],
    name: "recursionDetectionMiddleware",
    override: true,
    priority: "low"
  };
});
var getAllAliases = (name, aliases) => {
  const _aliases = [];
  if (name) {
    _aliases.push(name);
  }
  if (aliases) {
    for (const alias of aliases) {
      _aliases.push(alias);
    }
  }
  return _aliases;
};
var getMiddlewareNameWithAliases = (name, aliases) => {
  return `${name || "anonymous"}${aliases && aliases.length > 0 ? ` (a.k.a. ${aliases.join(",")})` : ""}`;
};
var constructStack = () => {
  let absoluteEntries = [];
  let relativeEntries = [];
  let identifyOnResolve = false;
  const entriesNameSet = new Set;
  const sort = (entries) => entries.sort((a, b22) => stepWeights[b22.step] - stepWeights[a.step] || priorityWeights[b22.priority || "normal"] - priorityWeights[a.priority || "normal"]);
  const removeByName = (toRemove) => {
    let isRemoved = false;
    const filterCb = (entry) => {
      const aliases = getAllAliases(entry.name, entry.aliases);
      if (aliases.includes(toRemove)) {
        isRemoved = true;
        for (const alias of aliases) {
          entriesNameSet.delete(alias);
        }
        return false;
      }
      return true;
    };
    absoluteEntries = absoluteEntries.filter(filterCb);
    relativeEntries = relativeEntries.filter(filterCb);
    return isRemoved;
  };
  const removeByReference = (toRemove) => {
    let isRemoved = false;
    const filterCb = (entry) => {
      if (entry.middleware === toRemove) {
        isRemoved = true;
        for (const alias of getAllAliases(entry.name, entry.aliases)) {
          entriesNameSet.delete(alias);
        }
        return false;
      }
      return true;
    };
    absoluteEntries = absoluteEntries.filter(filterCb);
    relativeEntries = relativeEntries.filter(filterCb);
    return isRemoved;
  };
  const cloneTo = (toStack) => {
    absoluteEntries.forEach((entry) => {
      toStack.add(entry.middleware, { ...entry });
    });
    relativeEntries.forEach((entry) => {
      toStack.addRelativeTo(entry.middleware, { ...entry });
    });
    toStack.identifyOnResolve?.(stack.identifyOnResolve());
    return toStack;
  };
  const expandRelativeMiddlewareList = (from) => {
    const expandedMiddlewareList = [];
    from.before.forEach((entry) => {
      if (entry.before.length === 0 && entry.after.length === 0) {
        expandedMiddlewareList.push(entry);
      } else {
        expandedMiddlewareList.push(...expandRelativeMiddlewareList(entry));
      }
    });
    expandedMiddlewareList.push(from);
    from.after.reverse().forEach((entry) => {
      if (entry.before.length === 0 && entry.after.length === 0) {
        expandedMiddlewareList.push(entry);
      } else {
        expandedMiddlewareList.push(...expandRelativeMiddlewareList(entry));
      }
    });
    return expandedMiddlewareList;
  };
  const getMiddlewareList = (debug = false) => {
    const normalizedAbsoluteEntries = [];
    const normalizedRelativeEntries = [];
    const normalizedEntriesNameMap = {};
    absoluteEntries.forEach((entry) => {
      const normalizedEntry = {
        ...entry,
        before: [],
        after: []
      };
      for (const alias of getAllAliases(normalizedEntry.name, normalizedEntry.aliases)) {
        normalizedEntriesNameMap[alias] = normalizedEntry;
      }
      normalizedAbsoluteEntries.push(normalizedEntry);
    });
    relativeEntries.forEach((entry) => {
      const normalizedEntry = {
        ...entry,
        before: [],
        after: []
      };
      for (const alias of getAllAliases(normalizedEntry.name, normalizedEntry.aliases)) {
        normalizedEntriesNameMap[alias] = normalizedEntry;
      }
      normalizedRelativeEntries.push(normalizedEntry);
    });
    normalizedRelativeEntries.forEach((entry) => {
      if (entry.toMiddleware) {
        const toMiddleware = normalizedEntriesNameMap[entry.toMiddleware];
        if (toMiddleware === undefined) {
          if (debug) {
            return;
          }
          throw new Error(`${entry.toMiddleware} is not found when adding ${getMiddlewareNameWithAliases(entry.name, entry.aliases)} middleware ${entry.relation} ${entry.toMiddleware}`);
        }
        if (entry.relation === "after") {
          toMiddleware.after.push(entry);
        }
        if (entry.relation === "before") {
          toMiddleware.before.push(entry);
        }
      }
    });
    const mainChain = sort(normalizedAbsoluteEntries).map(expandRelativeMiddlewareList).reduce((wholeList, expandedMiddlewareList) => {
      wholeList.push(...expandedMiddlewareList);
      return wholeList;
    }, []);
    return mainChain;
  };
  const stack = {
    add: (middleware2, options3 = {}) => {
      const { name, override, aliases: _aliases } = options3;
      const entry = {
        step: "initialize",
        priority: "normal",
        middleware: middleware2,
        ...options3
      };
      const aliases = getAllAliases(name, _aliases);
      if (aliases.length > 0) {
        if (aliases.some((alias) => entriesNameSet.has(alias))) {
          if (!override)
            throw new Error(`Duplicate middleware name '${getMiddlewareNameWithAliases(name, _aliases)}'`);
          for (const alias of aliases) {
            const toOverrideIndex = absoluteEntries.findIndex((entry2) => entry2.name === alias || entry2.aliases?.some((a) => a === alias));
            if (toOverrideIndex === -1) {
              continue;
            }
            const toOverride = absoluteEntries[toOverrideIndex];
            if (toOverride.step !== entry.step || entry.priority !== toOverride.priority) {
              throw new Error(`"${getMiddlewareNameWithAliases(toOverride.name, toOverride.aliases)}" middleware with ${toOverride.priority} priority in ${toOverride.step} step cannot be overridden by "${getMiddlewareNameWithAliases(name, _aliases)}" middleware with ${entry.priority} priority in ${entry.step} step.`);
            }
            absoluteEntries.splice(toOverrideIndex, 1);
          }
        }
        for (const alias of aliases) {
          entriesNameSet.add(alias);
        }
      }
      absoluteEntries.push(entry);
    },
    addRelativeTo: (middleware2, options3) => {
      const { name, override, aliases: _aliases } = options3;
      const entry = {
        middleware: middleware2,
        ...options3
      };
      const aliases = getAllAliases(name, _aliases);
      if (aliases.length > 0) {
        if (aliases.some((alias) => entriesNameSet.has(alias))) {
          if (!override)
            throw new Error(`Duplicate middleware name '${getMiddlewareNameWithAliases(name, _aliases)}'`);
          for (const alias of aliases) {
            const toOverrideIndex = relativeEntries.findIndex((entry2) => entry2.name === alias || entry2.aliases?.some((a) => a === alias));
            if (toOverrideIndex === -1) {
              continue;
            }
            const toOverride = relativeEntries[toOverrideIndex];
            if (toOverride.toMiddleware !== entry.toMiddleware || toOverride.relation !== entry.relation) {
              throw new Error(`"${getMiddlewareNameWithAliases(toOverride.name, toOverride.aliases)}" middleware ${toOverride.relation} "${toOverride.toMiddleware}" middleware cannot be overridden by "${getMiddlewareNameWithAliases(name, _aliases)}" middleware ${entry.relation} "${entry.toMiddleware}" middleware.`);
            }
            relativeEntries.splice(toOverrideIndex, 1);
          }
        }
        for (const alias of aliases) {
          entriesNameSet.add(alias);
        }
      }
      relativeEntries.push(entry);
    },
    clone: () => cloneTo(constructStack()),
    use: (plugin) => {
      plugin.applyToStack(stack);
    },
    remove: (toRemove) => {
      if (typeof toRemove === "string")
        return removeByName(toRemove);
      else
        return removeByReference(toRemove);
    },
    removeByTag: (toRemove) => {
      let isRemoved = false;
      const filterCb = (entry) => {
        const { tags, name, aliases: _aliases } = entry;
        if (tags && tags.includes(toRemove)) {
          const aliases = getAllAliases(name, _aliases);
          for (const alias of aliases) {
            entriesNameSet.delete(alias);
          }
          isRemoved = true;
          return false;
        }
        return true;
      };
      absoluteEntries = absoluteEntries.filter(filterCb);
      relativeEntries = relativeEntries.filter(filterCb);
      return isRemoved;
    },
    concat: (from) => {
      const cloned = cloneTo(constructStack());
      cloned.use(from);
      cloned.identifyOnResolve(identifyOnResolve || cloned.identifyOnResolve() || (from.identifyOnResolve?.() ?? false));
      return cloned;
    },
    applyToStack: cloneTo,
    identify: () => {
      return getMiddlewareList(true).map((mw) => {
        const step = mw.step ?? mw.relation + " " + mw.toMiddleware;
        return getMiddlewareNameWithAliases(mw.name, mw.aliases) + " - " + step;
      });
    },
    identifyOnResolve(toggle) {
      if (typeof toggle === "boolean")
        identifyOnResolve = toggle;
      return identifyOnResolve;
    },
    resolve: (handler3, context) => {
      for (const middleware2 of getMiddlewareList().map((entry) => entry.middleware).reverse()) {
        handler3 = middleware2(handler3, context);
      }
      if (identifyOnResolve) {
        console.log(stack.identify());
      }
      return handler3;
    }
  };
  return stack;
};
var stepWeights;
var priorityWeights;
var init_MiddlewareStack = __esm2(() => {
  stepWeights = {
    initialize: 5,
    serialize: 4,
    build: 3,
    finalizeRequest: 2,
    deserialize: 1
  };
  priorityWeights = {
    high: 3,
    normal: 2,
    low: 1
  };
});
var init_dist_es11 = __esm2(() => {
  init_MiddlewareStack();
});

class Client {
  constructor(config6) {
    this.config = config6;
    this.middlewareStack = constructStack();
  }
  send(command2, optionsOrCb, cb) {
    const options3 = typeof optionsOrCb !== "function" ? optionsOrCb : undefined;
    const callback = typeof optionsOrCb === "function" ? optionsOrCb : cb;
    const useHandlerCache = options3 === undefined && this.config.cacheMiddleware === true;
    let handler3;
    if (useHandlerCache) {
      if (!this.handlers) {
        this.handlers = new WeakMap;
      }
      const handlers = this.handlers;
      if (handlers.has(command2.constructor)) {
        handler3 = handlers.get(command2.constructor);
      } else {
        handler3 = command2.resolveMiddleware(this.middlewareStack, this.config, options3);
        handlers.set(command2.constructor, handler3);
      }
    } else {
      delete this.handlers;
      handler3 = command2.resolveMiddleware(this.middlewareStack, this.config, options3);
    }
    if (callback) {
      handler3(command2).then((result2) => callback(null, result2.output), (err22) => callback(err22)).catch(() => {
      });
    } else {
      return handler3(command2).then((result2) => result2.output);
    }
  }
  destroy() {
    this.config?.requestHandler?.destroy?.();
    delete this.handlers;
  }
}
var init_client = __esm2(() => {
  init_dist_es11();
});
var import_protocols;
var init_collect_stream_body = __esm2(() => {
  import_protocols = __toESM3(require_protocols(), 1);
});

class Command2 {
  constructor() {
    this.middlewareStack = constructStack();
  }
  static classBuilder() {
    return new ClassBuilder;
  }
  resolveMiddlewareWithContext(clientStack, configuration, options3, { middlewareFn, clientName, commandName, inputFilterSensitiveLog, outputFilterSensitiveLog, smithyContext, additionalContext, CommandCtor }) {
    for (const mw of middlewareFn.bind(this)(CommandCtor, clientStack, configuration, options3)) {
      this.middlewareStack.use(mw);
    }
    const stack = clientStack.concat(this.middlewareStack);
    const { logger: logger22 } = configuration;
    const handlerExecutionContext = {
      logger: logger22,
      clientName,
      commandName,
      inputFilterSensitiveLog,
      outputFilterSensitiveLog,
      [import_types11.SMITHY_CONTEXT_KEY]: {
        commandInstance: this,
        ...smithyContext
      },
      ...additionalContext
    };
    const { requestHandler } = configuration;
    return stack.resolve((request42) => requestHandler.handle(request42.request, options3 || {}), handlerExecutionContext);
  }
}

class ClassBuilder {
  constructor() {
    this._init = () => {
    };
    this._ep = {};
    this._middlewareFn = () => [];
    this._commandName = "";
    this._clientName = "";
    this._additionalContext = {};
    this._smithyContext = {};
    this._inputFilterSensitiveLog = (_22) => _22;
    this._outputFilterSensitiveLog = (_22) => _22;
    this._serializer = null;
    this._deserializer = null;
  }
  init(cb) {
    this._init = cb;
  }
  ep(endpointParameterInstructions) {
    this._ep = endpointParameterInstructions;
    return this;
  }
  m(middlewareSupplier) {
    this._middlewareFn = middlewareSupplier;
    return this;
  }
  s(service, operation, smithyContext = {}) {
    this._smithyContext = {
      service,
      operation,
      ...smithyContext
    };
    return this;
  }
  c(additionalContext = {}) {
    this._additionalContext = additionalContext;
    return this;
  }
  n(clientName, commandName) {
    this._clientName = clientName;
    this._commandName = commandName;
    return this;
  }
  f(inputFilter = (_22) => _22, outputFilter = (_22) => _22) {
    this._inputFilterSensitiveLog = inputFilter;
    this._outputFilterSensitiveLog = outputFilter;
    return this;
  }
  ser(serializer) {
    this._serializer = serializer;
    return this;
  }
  de(deserializer) {
    this._deserializer = deserializer;
    return this;
  }
  build() {
    const closure = this;
    let CommandRef;
    return CommandRef = class extends Command2 {
      static getEndpointParameterInstructions() {
        return closure._ep;
      }
      constructor(...[input]) {
        super();
        this.serialize = closure._serializer;
        this.deserialize = closure._deserializer;
        this.input = input ?? {};
        closure._init(this);
      }
      resolveMiddleware(stack, configuration, options3) {
        return this.resolveMiddlewareWithContext(stack, configuration, options3, {
          CommandCtor: CommandRef,
          middlewareFn: closure._middlewareFn,
          clientName: closure._clientName,
          commandName: closure._commandName,
          inputFilterSensitiveLog: closure._inputFilterSensitiveLog,
          outputFilterSensitiveLog: closure._outputFilterSensitiveLog,
          smithyContext: closure._smithyContext,
          additionalContext: closure._additionalContext
        });
      }
    };
  }
}
var import_types11;
var init_command2 = __esm2(() => {
  init_dist_es11();
  import_types11 = __toESM3(require_dist_cjs(), 1);
});
var SENSITIVE_STRING = "***SensitiveInformation***";
var createAggregatedClient = (commands, Client2) => {
  for (const command2 of Object.keys(commands)) {
    const CommandCtor = commands[command2];
    const methodImpl = async function(args, optionsOrCb, cb) {
      const command3 = new CommandCtor(args);
      if (typeof optionsOrCb === "function") {
        this.send(command3, optionsOrCb);
      } else if (typeof cb === "function") {
        if (typeof optionsOrCb !== "object")
          throw new Error(`Expected http options but got ${typeof optionsOrCb}`);
        this.send(command3, optionsOrCb || {}, cb);
      } else {
        return this.send(command3, optionsOrCb);
      }
    };
    const methodName = (command2[0].toLowerCase() + command2.slice(1)).replace(/Command$/, "");
    Client2.prototype[methodName] = methodImpl;
  }
};
var parseBoolean = (value) => {
  switch (value) {
    case "true":
      return true;
    case "false":
      return false;
    default:
      throw new Error(`Unable to parse boolean value "${value}"`);
  }
};
var expectNumber = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  if (typeof value === "string") {
    const parsed = parseFloat(value);
    if (!Number.isNaN(parsed)) {
      if (String(parsed) !== String(value)) {
        logger22.warn(stackTraceWarning(`Expected number but observed string: ${value}`));
      }
      return parsed;
    }
  }
  if (typeof value === "number") {
    return value;
  }
  throw new TypeError(`Expected number, got ${typeof value}: ${value}`);
};
var MAX_FLOAT;
var expectFloat32 = (value) => {
  const expected = expectNumber(value);
  if (expected !== undefined && !Number.isNaN(expected) && expected !== Infinity && expected !== -Infinity) {
    if (Math.abs(expected) > MAX_FLOAT) {
      throw new TypeError(`Expected 32-bit float, got ${value}`);
    }
  }
  return expected;
};
var expectLong = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  if (Number.isInteger(value) && !Number.isNaN(value)) {
    return value;
  }
  throw new TypeError(`Expected integer, got ${typeof value}: ${value}`);
};
var expectInt32 = (value) => expectSizedInt(value, 32);
var expectShort = (value) => expectSizedInt(value, 16);
var expectByte = (value) => expectSizedInt(value, 8);
var expectSizedInt = (value, size) => {
  const expected = expectLong(value);
  if (expected !== undefined && castInt(expected, size) !== expected) {
    throw new TypeError(`Expected ${size}-bit integer, got ${value}`);
  }
  return expected;
};
var castInt = (value, size) => {
  switch (size) {
    case 32:
      return Int32Array.of(value)[0];
    case 16:
      return Int16Array.of(value)[0];
    case 8:
      return Int8Array.of(value)[0];
  }
};
var expectNonNull = (value, location2) => {
  if (value === null || value === undefined) {
    if (location2) {
      throw new TypeError(`Expected a non-null value for ${location2}`);
    }
    throw new TypeError("Expected a non-null value");
  }
  return value;
};
var expectObject = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  if (typeof value === "object" && !Array.isArray(value)) {
    return value;
  }
  const receivedType = Array.isArray(value) ? "array" : typeof value;
  throw new TypeError(`Expected object, got ${receivedType}: ${value}`);
};
var expectString = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  if (typeof value === "string") {
    return value;
  }
  if (["boolean", "number", "bigint"].includes(typeof value)) {
    logger22.warn(stackTraceWarning(`Expected string, got ${typeof value}: ${value}`));
    return String(value);
  }
  throw new TypeError(`Expected string, got ${typeof value}: ${value}`);
};
var expectUnion = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  const asObject = expectObject(value);
  const setKeys = Object.entries(asObject).filter(([, v22]) => v22 != null).map(([k]) => k);
  if (setKeys.length === 0) {
    throw new TypeError(`Unions must have exactly one non-null member. None were found.`);
  }
  if (setKeys.length > 1) {
    throw new TypeError(`Unions must have exactly one non-null member. Keys ${setKeys} were not null.`);
  }
  return asObject;
};
var strictParseFloat32 = (value) => {
  if (typeof value == "string") {
    return expectFloat32(parseNumber(value));
  }
  return expectFloat32(value);
};
var NUMBER_REGEX;
var parseNumber = (value) => {
  const matches = value.match(NUMBER_REGEX);
  if (matches === null || matches[0].length !== value.length) {
    throw new TypeError(`Expected real number, got implicit NaN`);
  }
  return parseFloat(value);
};
var strictParseLong = (value) => {
  if (typeof value === "string") {
    return expectLong(parseNumber(value));
  }
  return expectLong(value);
};
var strictParseInt32 = (value) => {
  if (typeof value === "string") {
    return expectInt32(parseNumber(value));
  }
  return expectInt32(value);
};
var strictParseShort = (value) => {
  if (typeof value === "string") {
    return expectShort(parseNumber(value));
  }
  return expectShort(value);
};
var strictParseByte = (value) => {
  if (typeof value === "string") {
    return expectByte(parseNumber(value));
  }
  return expectByte(value);
};
var stackTraceWarning = (message) => {
  return String(new TypeError(message).stack || message).split("\n").slice(0, 5).filter((s32) => !s32.includes("stackTraceWarning")).join("\n");
};
var logger22;
var init_parse_utils2 = __esm2(() => {
  MAX_FLOAT = Math.ceil(340282346638528860000000000000000000000);
  NUMBER_REGEX = /(-?(?:0|[1-9]\d*)(?:\.\d+)?(?:[eE][+-]?\d+)?)|(-?Infinity)|(NaN)/g;
  logger22 = {
    warn: console.warn
  };
});
function dateToUtcString(date) {
  const year = date.getUTCFullYear();
  const month = date.getUTCMonth();
  const dayOfWeek = date.getUTCDay();
  const dayOfMonthInt = date.getUTCDate();
  const hoursInt = date.getUTCHours();
  const minutesInt = date.getUTCMinutes();
  const secondsInt = date.getUTCSeconds();
  const dayOfMonthString = dayOfMonthInt < 10 ? `0${dayOfMonthInt}` : `${dayOfMonthInt}`;
  const hoursString = hoursInt < 10 ? `0${hoursInt}` : `${hoursInt}`;
  const minutesString = minutesInt < 10 ? `0${minutesInt}` : `${minutesInt}`;
  const secondsString = secondsInt < 10 ? `0${secondsInt}` : `${secondsInt}`;
  return `${DAYS[dayOfWeek]}, ${dayOfMonthString} ${MONTHS[month]} ${year} ${hoursString}:${minutesString}:${secondsString} GMT`;
}
var DAYS;
var MONTHS;
var RFC3339;
var parseRfc3339DateTime = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  if (typeof value !== "string") {
    throw new TypeError("RFC-3339 date-times must be expressed as strings");
  }
  const match = RFC3339.exec(value);
  if (!match) {
    throw new TypeError("Invalid RFC-3339 date-time value");
  }
  const [_22, yearStr, monthStr, dayStr, hours, minutes, seconds, fractionalMilliseconds] = match;
  const year = strictParseShort(stripLeadingZeroes(yearStr));
  const month = parseDateValue(monthStr, "month", 1, 12);
  const day = parseDateValue(dayStr, "day", 1, 31);
  return buildDate(year, month, day, { hours, minutes, seconds, fractionalMilliseconds });
};
var RFC3339_WITH_OFFSET;
var parseRfc3339DateTimeWithOffset = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  if (typeof value !== "string") {
    throw new TypeError("RFC-3339 date-times must be expressed as strings");
  }
  const match = RFC3339_WITH_OFFSET.exec(value);
  if (!match) {
    throw new TypeError("Invalid RFC-3339 date-time value");
  }
  const [_22, yearStr, monthStr, dayStr, hours, minutes, seconds, fractionalMilliseconds, offsetStr] = match;
  const year = strictParseShort(stripLeadingZeroes(yearStr));
  const month = parseDateValue(monthStr, "month", 1, 12);
  const day = parseDateValue(dayStr, "day", 1, 31);
  const date = buildDate(year, month, day, { hours, minutes, seconds, fractionalMilliseconds });
  if (offsetStr.toUpperCase() != "Z") {
    date.setTime(date.getTime() - parseOffsetToMilliseconds(offsetStr));
  }
  return date;
};
var IMF_FIXDATE;
var RFC_850_DATE;
var ASC_TIME;
var parseRfc7231DateTime = (value) => {
  if (value === null || value === undefined) {
    return;
  }
  if (typeof value !== "string") {
    throw new TypeError("RFC-7231 date-times must be expressed as strings");
  }
  let match = IMF_FIXDATE.exec(value);
  if (match) {
    const [_22, dayStr, monthStr, yearStr, hours, minutes, seconds, fractionalMilliseconds] = match;
    return buildDate(strictParseShort(stripLeadingZeroes(yearStr)), parseMonthByShortName(monthStr), parseDateValue(dayStr, "day", 1, 31), { hours, minutes, seconds, fractionalMilliseconds });
  }
  match = RFC_850_DATE.exec(value);
  if (match) {
    const [_22, dayStr, monthStr, yearStr, hours, minutes, seconds, fractionalMilliseconds] = match;
    return adjustRfc850Year(buildDate(parseTwoDigitYear(yearStr), parseMonthByShortName(monthStr), parseDateValue(dayStr, "day", 1, 31), {
      hours,
      minutes,
      seconds,
      fractionalMilliseconds
    }));
  }
  match = ASC_TIME.exec(value);
  if (match) {
    const [_22, monthStr, dayStr, hours, minutes, seconds, fractionalMilliseconds, yearStr] = match;
    return buildDate(strictParseShort(stripLeadingZeroes(yearStr)), parseMonthByShortName(monthStr), parseDateValue(dayStr.trimLeft(), "day", 1, 31), { hours, minutes, seconds, fractionalMilliseconds });
  }
  throw new TypeError("Invalid RFC-7231 date-time value");
};
var buildDate = (year, month, day, time) => {
  const adjustedMonth = month - 1;
  validateDayOfMonth(year, adjustedMonth, day);
  return new Date(Date.UTC(year, adjustedMonth, day, parseDateValue(time.hours, "hour", 0, 23), parseDateValue(time.minutes, "minute", 0, 59), parseDateValue(time.seconds, "seconds", 0, 60), parseMilliseconds(time.fractionalMilliseconds)));
};
var parseTwoDigitYear = (value) => {
  const thisYear = new Date().getUTCFullYear();
  const valueInThisCentury = Math.floor(thisYear / 100) * 100 + strictParseShort(stripLeadingZeroes(value));
  if (valueInThisCentury < thisYear) {
    return valueInThisCentury + 100;
  }
  return valueInThisCentury;
};
var FIFTY_YEARS_IN_MILLIS;
var adjustRfc850Year = (input) => {
  if (input.getTime() - new Date().getTime() > FIFTY_YEARS_IN_MILLIS) {
    return new Date(Date.UTC(input.getUTCFullYear() - 100, input.getUTCMonth(), input.getUTCDate(), input.getUTCHours(), input.getUTCMinutes(), input.getUTCSeconds(), input.getUTCMilliseconds()));
  }
  return input;
};
var parseMonthByShortName = (value) => {
  const monthIdx = MONTHS.indexOf(value);
  if (monthIdx < 0) {
    throw new TypeError(`Invalid month: ${value}`);
  }
  return monthIdx + 1;
};
var DAYS_IN_MONTH;
var validateDayOfMonth = (year, month, day) => {
  let maxDays = DAYS_IN_MONTH[month];
  if (month === 1 && isLeapYear(year)) {
    maxDays = 29;
  }
  if (day > maxDays) {
    throw new TypeError(`Invalid day for ${MONTHS[month]} in ${year}: ${day}`);
  }
};
var isLeapYear = (year) => {
  return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
};
var parseDateValue = (value, type2, lower, upper) => {
  const dateVal = strictParseByte(stripLeadingZeroes(value));
  if (dateVal < lower || dateVal > upper) {
    throw new TypeError(`${type2} must be between ${lower} and ${upper}, inclusive`);
  }
  return dateVal;
};
var parseMilliseconds = (value) => {
  if (value === null || value === undefined) {
    return 0;
  }
  return strictParseFloat32("0." + value) * 1000;
};
var parseOffsetToMilliseconds = (value) => {
  const directionStr = value[0];
  let direction = 1;
  if (directionStr == "+") {
    direction = 1;
  } else if (directionStr == "-") {
    direction = -1;
  } else {
    throw new TypeError(`Offset direction, ${directionStr}, must be "+" or "-"`);
  }
  const hour = Number(value.substring(1, 3));
  const minute = Number(value.substring(4, 6));
  return direction * (hour * 60 + minute) * 60 * 1000;
};
var stripLeadingZeroes = (value) => {
  let idx = 0;
  while (idx < value.length - 1 && value.charAt(idx) === "0") {
    idx++;
  }
  if (idx === 0) {
    return value;
  }
  return value.slice(idx);
};
var init_date_utils = __esm2(() => {
  init_parse_utils2();
  DAYS = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
  MONTHS = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
  RFC3339 = new RegExp(/^(\d{4})-(\d{2})-(\d{2})[tT](\d{2}):(\d{2}):(\d{2})(?:\.(\d+))?[zZ]$/);
  RFC3339_WITH_OFFSET = new RegExp(/^(\d{4})-(\d{2})-(\d{2})[tT](\d{2}):(\d{2}):(\d{2})(?:\.(\d+))?(([-+]\d{2}\:\d{2})|[zZ])$/);
  IMF_FIXDATE = new RegExp(/^(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun), (\d{2}) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) (\d{4}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? GMT$/);
  RFC_850_DATE = new RegExp(/^(?:Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday), (\d{2})-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-(\d{2}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? GMT$/);
  ASC_TIME = new RegExp(/^(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ( [1-9]|\d{2}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? (\d{4})$/);
  FIFTY_YEARS_IN_MILLIS = 1576800000000;
  DAYS_IN_MONTH = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
});
var ServiceException;
var decorateServiceException = (exception2, additions = {}) => {
  Object.entries(additions).filter(([, v22]) => v22 !== undefined).forEach(([k, v22]) => {
    if (exception2[k] == undefined || exception2[k] === "") {
      exception2[k] = v22;
    }
  });
  const message = exception2.message || exception2.Message || "UnknownError";
  exception2.message = message;
  delete exception2.Message;
  return exception2;
};
var init_exceptions = __esm2(() => {
  ServiceException = class ServiceException2 extends Error {
    constructor(options3) {
      super(options3.message);
      Object.setPrototypeOf(this, ServiceException2.prototype);
      this.name = options3.name;
      this.$fault = options3.$fault;
      this.$metadata = options3.$metadata;
    }
  };
});
var throwDefaultError = ({ output, parsedBody, exceptionCtor, errorCode }) => {
  const $metadata = deserializeMetadata(output);
  const statusCode = $metadata.httpStatusCode ? $metadata.httpStatusCode + "" : undefined;
  const response = new exceptionCtor({
    name: parsedBody?.code || parsedBody?.Code || errorCode || statusCode || "UnknownError",
    $fault: "client",
    $metadata
  });
  throw decorateServiceException(response, parsedBody);
};
var withBaseException = (ExceptionCtor) => {
  return ({ output, parsedBody, errorCode }) => {
    throwDefaultError({ output, parsedBody, exceptionCtor: ExceptionCtor, errorCode });
  };
};
var deserializeMetadata = (output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
});
var init_default_error_handler = __esm2(() => {
  init_exceptions();
});
var loadConfigsForDefaultMode = (mode2) => {
  switch (mode2) {
    case "standard":
      return {
        retryMode: "standard",
        connectionTimeout: 3100
      };
    case "in-region":
      return {
        retryMode: "standard",
        connectionTimeout: 1100
      };
    case "cross-region":
      return {
        retryMode: "standard",
        connectionTimeout: 3100
      };
    case "mobile":
      return {
        retryMode: "standard",
        connectionTimeout: 30000
      };
    default:
      return {};
  }
};
var warningEmitted = false;
var emitWarningIfUnsupportedVersion = (version5) => {
  if (version5 && !warningEmitted && parseInt(version5.substring(1, version5.indexOf("."))) < 16) {
    warningEmitted = true;
  }
};
var import_protocols2;
var init_extended_encode_uri_component = __esm2(() => {
  import_protocols2 = __toESM3(require_protocols(), 1);
});
var import_types12;
var getChecksumConfiguration = (runtimeConfig) => {
  const checksumAlgorithms = [];
  for (const id in import_types12.AlgorithmId) {
    const algorithmId = import_types12.AlgorithmId[id];
    if (runtimeConfig[algorithmId] === undefined) {
      continue;
    }
    checksumAlgorithms.push({
      algorithmId: () => algorithmId,
      checksumConstructor: () => runtimeConfig[algorithmId]
    });
  }
  return {
    _checksumAlgorithms: checksumAlgorithms,
    addChecksumAlgorithm(algo) {
      this._checksumAlgorithms.push(algo);
    },
    checksumAlgorithms() {
      return this._checksumAlgorithms;
    }
  };
};
var resolveChecksumRuntimeConfig = (clientConfig) => {
  const runtimeConfig = {};
  clientConfig.checksumAlgorithms().forEach((checksumAlgorithm) => {
    runtimeConfig[checksumAlgorithm.algorithmId()] = checksumAlgorithm.checksumConstructor();
  });
  return runtimeConfig;
};
var init_checksum = __esm2(() => {
  import_types12 = __toESM3(require_dist_cjs(), 1);
});
var getRetryConfiguration = (runtimeConfig) => {
  let _retryStrategy = runtimeConfig.retryStrategy;
  return {
    setRetryStrategy(retryStrategy) {
      _retryStrategy = retryStrategy;
    },
    retryStrategy() {
      return _retryStrategy;
    }
  };
};
var resolveRetryRuntimeConfig = (retryStrategyConfiguration) => {
  const runtimeConfig = {};
  runtimeConfig.retryStrategy = retryStrategyConfiguration.retryStrategy();
  return runtimeConfig;
};
var getDefaultExtensionConfiguration = (runtimeConfig) => {
  return {
    ...getChecksumConfiguration(runtimeConfig),
    ...getRetryConfiguration(runtimeConfig)
  };
};
var resolveDefaultRuntimeConfig = (config6) => {
  return {
    ...resolveChecksumRuntimeConfig(config6),
    ...resolveRetryRuntimeConfig(config6)
  };
};
var init_defaultExtensionConfiguration = __esm2(() => {
  init_checksum();
});
var init_extensions2 = __esm2(() => {
  init_defaultExtensionConfiguration();
});
var getArrayIfSingleItem = (mayBeArray) => Array.isArray(mayBeArray) ? mayBeArray : [mayBeArray];
var isSerializableHeaderValue = (value) => {
  return value != null;
};
var StringWrapper = function() {
  const Class = Object.getPrototypeOf(this).constructor;
  const Constructor = Function.bind.apply(String, [null, ...arguments]);
  const instance = new Constructor;
  Object.setPrototypeOf(instance, Class.prototype);
  return instance;
};
var init_lazy_json = __esm2(() => {
  StringWrapper.prototype = Object.create(String.prototype, {
    constructor: {
      value: StringWrapper,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  Object.setPrototypeOf(StringWrapper, String);
});

class NoOpLogger {
  trace() {
  }
  debug() {
  }
  info() {
  }
  warn() {
  }
  error() {
  }
}
function map2(arg0, arg1, arg2) {
  let target;
  let filter;
  let instructions;
  if (typeof arg1 === "undefined" && typeof arg2 === "undefined") {
    target = {};
    instructions = arg0;
  } else {
    target = arg0;
    if (typeof arg1 === "function") {
      filter = arg1;
      instructions = arg2;
      return mapWithFilter(target, filter, instructions);
    } else {
      instructions = arg1;
    }
  }
  for (const key2 of Object.keys(instructions)) {
    if (!Array.isArray(instructions[key2])) {
      target[key2] = instructions[key2];
      continue;
    }
    applyInstruction(target, null, instructions, key2);
  }
  return target;
}
var take = (source, instructions) => {
  const out = {};
  for (const key2 in instructions) {
    applyInstruction(out, source, instructions, key2);
  }
  return out;
};
var mapWithFilter = (target, filter, instructions) => {
  return map2(target, Object.entries(instructions).reduce((_instructions, [key2, value]) => {
    if (Array.isArray(value)) {
      _instructions[key2] = value;
    } else {
      if (typeof value === "function") {
        _instructions[key2] = [filter, value()];
      } else {
        _instructions[key2] = [filter, value];
      }
    }
    return _instructions;
  }, {}));
};
var applyInstruction = (target, source, instructions, targetKey) => {
  if (source !== null) {
    let instruction = instructions[targetKey];
    if (typeof instruction === "function") {
      instruction = [, instruction];
    }
    const [filter2 = nonNullish, valueFn = pass, sourceKey = targetKey] = instruction;
    if (typeof filter2 === "function" && filter2(source[sourceKey]) || typeof filter2 !== "function" && !!filter2) {
      target[targetKey] = valueFn(source[sourceKey]);
    }
    return;
  }
  let [filter, value] = instructions[targetKey];
  if (typeof value === "function") {
    let _value;
    const defaultFilterPassed = filter === undefined && (_value = value()) != null;
    const customFilterPassed = typeof filter === "function" && !!filter(undefined) || typeof filter !== "function" && !!filter;
    if (defaultFilterPassed) {
      target[targetKey] = _value;
    } else if (customFilterPassed) {
      target[targetKey] = value();
    }
  } else {
    const defaultFilterPassed = filter === undefined && value != null;
    const customFilterPassed = typeof filter === "function" && !!filter(value) || typeof filter !== "function" && !!filter;
    if (defaultFilterPassed || customFilterPassed) {
      target[targetKey] = value;
    }
  }
};
var nonNullish = (_22) => _22 != null;
var pass = (_22) => _22;
function quoteHeader(part) {
  if (part.includes(",") || part.includes('"')) {
    part = `"${part.replace(/"/g, '\\"')}"`;
  }
  return part;
}
var import_protocols3;
var init_resolve_path = __esm2(() => {
  import_protocols3 = __toESM3(require_protocols(), 1);
});
var serializeDateTime = (date) => date.toISOString().replace(".000Z", "Z");
var _json = (obj) => {
  if (obj == null) {
    return {};
  }
  if (Array.isArray(obj)) {
    return obj.filter((_22) => _22 != null).map(_json);
  }
  if (typeof obj === "object") {
    const target = {};
    for (const key2 of Object.keys(obj)) {
      if (obj[key2] == null) {
        continue;
      }
      target[key2] = _json(obj[key2]);
    }
    return target;
  }
  return obj;
};
var init_dist_es12 = __esm2(() => {
  init_client();
  init_collect_stream_body();
  init_command2();
  init_date_utils();
  init_default_error_handler();
  init_exceptions();
  init_extended_encode_uri_component();
  init_extensions2();
  init_lazy_json();
  init_parse_utils2();
  init_resolve_path();
});
function checkContentLengthHeader() {
  return (next, context) => async (args) => {
    const { request: request42 } = args;
    if (HttpRequest.isInstance(request42)) {
      if (!(CONTENT_LENGTH_HEADER in request42.headers)) {
        const message = `Are you using a Stream of unknown length as the Body of a PutObject request? Consider using Upload instead from @aws-sdk/lib-storage.`;
        if (typeof context?.logger?.warn === "function" && !(context.logger instanceof NoOpLogger)) {
          context.logger.warn(message);
        } else {
          console.warn(message);
        }
      }
    }
    return next({ ...args });
  };
}
var CONTENT_LENGTH_HEADER = "content-length";
var checkContentLengthHeaderMiddlewareOptions;
var getCheckContentLengthHeaderPlugin = (unused) => ({
  applyToStack: (clientStack) => {
    clientStack.add(checkContentLengthHeader(), checkContentLengthHeaderMiddlewareOptions);
  }
});
var init_check_content_length_header = __esm2(() => {
  init_dist_es();
  init_dist_es12();
  checkContentLengthHeaderMiddlewareOptions = {
    step: "finalizeRequest",
    tags: ["CHECK_CONTENT_LENGTH_HEADER"],
    name: "getCheckContentLengthHeaderPlugin",
    override: true
  };
});
var regionRedirectEndpointMiddleware = (config6) => {
  return (next, context) => async (args) => {
    const originalRegion = await config6.region();
    const regionProviderRef = config6.region;
    let unlock = () => {
    };
    if (context.__s3RegionRedirect) {
      Object.defineProperty(config6, "region", {
        writable: false,
        value: async () => {
          return context.__s3RegionRedirect;
        }
      });
      unlock = () => Object.defineProperty(config6, "region", {
        writable: true,
        value: regionProviderRef
      });
    }
    try {
      const result2 = await next(args);
      if (context.__s3RegionRedirect) {
        unlock();
        const region = await config6.region();
        if (originalRegion !== region) {
          throw new Error("Region was not restored following S3 region redirect.");
        }
      }
      return result2;
    } catch (e) {
      unlock();
      throw e;
    }
  };
};
var regionRedirectEndpointMiddlewareOptions;
var init_region_redirect_endpoint_middleware = __esm2(() => {
  regionRedirectEndpointMiddlewareOptions = {
    tags: ["REGION_REDIRECT", "S3"],
    name: "regionRedirectEndpointMiddleware",
    override: true,
    relation: "before",
    toMiddleware: "endpointV2Middleware"
  };
});
function regionRedirectMiddleware(clientConfig) {
  return (next, context) => async (args) => {
    try {
      return await next(args);
    } catch (err22) {
      if (clientConfig.followRegionRedirects) {
        if (err22?.$metadata?.httpStatusCode === 301 || err22?.$metadata?.httpStatusCode === 400 && err22?.name === "IllegalLocationConstraintException") {
          try {
            const actualRegion = err22.$response.headers["x-amz-bucket-region"];
            context.logger?.debug(`Redirecting from ${await clientConfig.region()} to ${actualRegion}`);
            context.__s3RegionRedirect = actualRegion;
          } catch (e) {
            throw new Error("Region redirect failed: " + e);
          }
          return next(args);
        }
      }
      throw err22;
    }
  };
}
var regionRedirectMiddlewareOptions;
var getRegionRedirectMiddlewarePlugin = (clientConfig) => ({
  applyToStack: (clientStack) => {
    clientStack.add(regionRedirectMiddleware(clientConfig), regionRedirectMiddlewareOptions);
    clientStack.addRelativeTo(regionRedirectEndpointMiddleware(clientConfig), regionRedirectEndpointMiddlewareOptions);
  }
});
var init_region_redirect_middleware = __esm2(() => {
  init_region_redirect_endpoint_middleware();
  regionRedirectMiddlewareOptions = {
    step: "initialize",
    tags: ["REGION_REDIRECT", "S3"],
    name: "regionRedirectMiddleware",
    override: true
  };
});
var s3ExpiresMiddleware = (config6) => {
  return (next, context) => async (args) => {
    const result2 = await next(args);
    const { response } = result2;
    if (HttpResponse.isInstance(response)) {
      if (response.headers.expires) {
        response.headers.expiresstring = response.headers.expires;
        try {
          parseRfc7231DateTime(response.headers.expires);
        } catch (e) {
          context.logger?.warn(`AWS SDK Warning for ${context.clientName}::${context.commandName} response parsing (${response.headers.expires}): ${e}`);
          delete response.headers.expires;
        }
      }
    }
    return result2;
  };
};
var s3ExpiresMiddlewareOptions;
var getS3ExpiresMiddlewarePlugin = (clientConfig) => ({
  applyToStack: (clientStack) => {
    clientStack.addRelativeTo(s3ExpiresMiddleware(clientConfig), s3ExpiresMiddlewareOptions);
  }
});
var init_s3_expires_middleware = __esm2(() => {
  init_dist_es();
  init_dist_es12();
  s3ExpiresMiddlewareOptions = {
    tags: ["S3"],
    name: "s3ExpiresMiddleware",
    override: true,
    relation: "after",
    toMiddleware: "deserializerMiddleware"
  };
});

class S3ExpressIdentityCache {
  constructor(data2 = {}) {
    this.data = data2;
    this.lastPurgeTime = Date.now();
  }
  get(key2) {
    const entry = this.data[key2];
    if (!entry) {
      return;
    }
    return entry;
  }
  set(key2, entry) {
    this.data[key2] = entry;
    return entry;
  }
  delete(key2) {
    delete this.data[key2];
  }
  async purgeExpired() {
    const now2 = Date.now();
    if (this.lastPurgeTime + S3ExpressIdentityCache.EXPIRED_CREDENTIAL_PURGE_INTERVAL_MS > now2) {
      return;
    }
    for (const key2 in this.data) {
      const entry = this.data[key2];
      if (!entry.isRefreshing) {
        const credential = await entry.identity;
        if (credential.expiration) {
          if (credential.expiration.getTime() < now2) {
            delete this.data[key2];
          }
        }
      }
    }
  }
}
var init_S3ExpressIdentityCache = __esm2(() => {
  S3ExpressIdentityCache.EXPIRED_CREDENTIAL_PURGE_INTERVAL_MS = 30000;
});

class S3ExpressIdentityCacheEntry {
  constructor(_identity, isRefreshing = false, accessed = Date.now()) {
    this._identity = _identity;
    this.isRefreshing = isRefreshing;
    this.accessed = accessed;
  }
  get identity() {
    this.accessed = Date.now();
    return this._identity;
  }
}

class S3ExpressIdentityProviderImpl {
  constructor(createSessionFn, cache3 = new S3ExpressIdentityCache) {
    this.createSessionFn = createSessionFn;
    this.cache = cache3;
  }
  async getS3ExpressIdentity(awsIdentity, identityProperties) {
    const key2 = identityProperties.Bucket;
    const { cache: cache3 } = this;
    const entry = cache3.get(key2);
    if (entry) {
      return entry.identity.then((identity2) => {
        const isExpired = (identity2.expiration?.getTime() ?? 0) < Date.now();
        if (isExpired) {
          return cache3.set(key2, new S3ExpressIdentityCacheEntry(this.getIdentity(key2))).identity;
        }
        const isExpiringSoon = (identity2.expiration?.getTime() ?? 0) < Date.now() + S3ExpressIdentityProviderImpl.REFRESH_WINDOW_MS;
        if (isExpiringSoon && !entry.isRefreshing) {
          entry.isRefreshing = true;
          this.getIdentity(key2).then((id) => {
            cache3.set(key2, new S3ExpressIdentityCacheEntry(Promise.resolve(id)));
          });
        }
        return identity2;
      });
    }
    return cache3.set(key2, new S3ExpressIdentityCacheEntry(this.getIdentity(key2))).identity;
  }
  async getIdentity(key2) {
    await this.cache.purgeExpired().catch((error) => {
      console.warn("Error while clearing expired entries in S3ExpressIdentityCache: \n" + error);
    });
    const session = await this.createSessionFn(key2);
    if (!session.Credentials?.AccessKeyId || !session.Credentials?.SecretAccessKey) {
      throw new Error("s3#createSession response credential missing AccessKeyId or SecretAccessKey.");
    }
    const identity2 = {
      accessKeyId: session.Credentials.AccessKeyId,
      secretAccessKey: session.Credentials.SecretAccessKey,
      sessionToken: session.Credentials.SessionToken,
      expiration: session.Credentials.Expiration ? new Date(session.Credentials.Expiration) : undefined
    };
    return identity2;
  }
}
var init_S3ExpressIdentityProviderImpl = __esm2(() => {
  init_S3ExpressIdentityCache();
  S3ExpressIdentityProviderImpl.REFRESH_WINDOW_MS = 60000;
});
var escapeUri = (uri) => encodeURIComponent(uri).replace(/[!'()*]/g, hexEncode);
var hexEncode = (c22) => `%${c22.charCodeAt(0).toString(16).toUpperCase()}`;
var init_escape_uri_path = () => {
};
var init_dist_es13 = __esm2(() => {
  init_escape_uri_path();
});
var ALGORITHM_QUERY_PARAM = "X-Amz-Algorithm";
var CREDENTIAL_QUERY_PARAM = "X-Amz-Credential";
var AMZ_DATE_QUERY_PARAM = "X-Amz-Date";
var SIGNED_HEADERS_QUERY_PARAM = "X-Amz-SignedHeaders";
var EXPIRES_QUERY_PARAM = "X-Amz-Expires";
var SIGNATURE_QUERY_PARAM = "X-Amz-Signature";
var TOKEN_QUERY_PARAM = "X-Amz-Security-Token";
var AUTH_HEADER = "authorization";
var AMZ_DATE_HEADER;
var DATE_HEADER = "date";
var GENERATED_HEADERS;
var SIGNATURE_HEADER;
var SHA256_HEADER = "x-amz-content-sha256";
var TOKEN_HEADER;
var ALWAYS_UNSIGNABLE_HEADERS;
var PROXY_HEADER_PATTERN;
var SEC_HEADER_PATTERN;
var ALGORITHM_IDENTIFIER = "AWS4-HMAC-SHA256";
var EVENT_ALGORITHM_IDENTIFIER = "AWS4-HMAC-SHA256-PAYLOAD";
var UNSIGNED_PAYLOAD = "UNSIGNED-PAYLOAD";
var MAX_CACHE_SIZE = 50;
var KEY_TYPE_IDENTIFIER = "aws4_request";
var MAX_PRESIGNED_TTL;
var init_constants2 = __esm2(() => {
  AMZ_DATE_HEADER = AMZ_DATE_QUERY_PARAM.toLowerCase();
  GENERATED_HEADERS = [AUTH_HEADER, AMZ_DATE_HEADER, DATE_HEADER];
  SIGNATURE_HEADER = SIGNATURE_QUERY_PARAM.toLowerCase();
  TOKEN_HEADER = TOKEN_QUERY_PARAM.toLowerCase();
  ALWAYS_UNSIGNABLE_HEADERS = {
    authorization: true,
    "cache-control": true,
    connection: true,
    expect: true,
    from: true,
    "keep-alive": true,
    "max-forwards": true,
    pragma: true,
    referer: true,
    te: true,
    trailer: true,
    "transfer-encoding": true,
    upgrade: true,
    "user-agent": true,
    "x-amzn-trace-id": true
  };
  PROXY_HEADER_PATTERN = /^proxy-/;
  SEC_HEADER_PATTERN = /^sec-/;
  MAX_PRESIGNED_TTL = 604800;
});
var import_util_hex_encoding;
var signingKeyCache;
var cacheQueue;
var createScope = (shortDate, region, service) => `${shortDate}/${region}/${service}/${KEY_TYPE_IDENTIFIER}`;
var getSigningKey = async (sha256Constructor, credentials, shortDate, region, service) => {
  const credsHash = await hmac(sha256Constructor, credentials.secretAccessKey, credentials.accessKeyId);
  const cacheKey = `${shortDate}:${region}:${service}:${import_util_hex_encoding.toHex(credsHash)}:${credentials.sessionToken}`;
  if (cacheKey in signingKeyCache) {
    return signingKeyCache[cacheKey];
  }
  cacheQueue.push(cacheKey);
  while (cacheQueue.length > MAX_CACHE_SIZE) {
    delete signingKeyCache[cacheQueue.shift()];
  }
  let key2 = `AWS4${credentials.secretAccessKey}`;
  for (const signable of [shortDate, region, service, KEY_TYPE_IDENTIFIER]) {
    key2 = await hmac(sha256Constructor, key2, signable);
  }
  return signingKeyCache[cacheKey] = key2;
};
var hmac = (ctor, secret, data2) => {
  const hash3 = new ctor(secret);
  hash3.update(toUint8Array2(data2));
  return hash3.digest();
};
var init_credentialDerivation = __esm2(() => {
  import_util_hex_encoding = __toESM3(require_dist_cjs13(), 1);
  init_dist_es6();
  init_constants2();
  signingKeyCache = {};
  cacheQueue = [];
});
var getCanonicalHeaders = ({ headers }, unsignableHeaders, signableHeaders) => {
  const canonical = {};
  for (const headerName of Object.keys(headers).sort()) {
    if (headers[headerName] == undefined) {
      continue;
    }
    const canonicalHeaderName = headerName.toLowerCase();
    if (canonicalHeaderName in ALWAYS_UNSIGNABLE_HEADERS || unsignableHeaders?.has(canonicalHeaderName) || PROXY_HEADER_PATTERN.test(canonicalHeaderName) || SEC_HEADER_PATTERN.test(canonicalHeaderName)) {
      if (!signableHeaders || signableHeaders && !signableHeaders.has(canonicalHeaderName)) {
        continue;
      }
    }
    canonical[canonicalHeaderName] = headers[headerName].trim().replace(/\s+/g, " ");
  }
  return canonical;
};
var init_getCanonicalHeaders = __esm2(() => {
  init_constants2();
});
var getCanonicalQuery = ({ query = {} }) => {
  const keys2 = [];
  const serialized = {};
  for (const key2 of Object.keys(query)) {
    if (key2.toLowerCase() === SIGNATURE_HEADER) {
      continue;
    }
    const encodedKey = escapeUri(key2);
    keys2.push(encodedKey);
    const value = query[key2];
    if (typeof value === "string") {
      serialized[encodedKey] = `${encodedKey}=${escapeUri(value)}`;
    } else if (Array.isArray(value)) {
      serialized[encodedKey] = value.slice(0).reduce((encoded, value2) => encoded.concat([`${encodedKey}=${escapeUri(value2)}`]), []).sort().join("&");
    }
  }
  return keys2.sort().map((key2) => serialized[key2]).filter((serialized2) => serialized2).join("&");
};
var init_getCanonicalQuery = __esm2(() => {
  init_dist_es13();
  init_constants2();
});
var import_util_hex_encoding2;
var getPayloadHash = async ({ headers, body }, hashConstructor) => {
  for (const headerName of Object.keys(headers)) {
    if (headerName.toLowerCase() === SHA256_HEADER) {
      return headers[headerName];
    }
  }
  if (body == undefined) {
    return "e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855";
  } else if (typeof body === "string" || ArrayBuffer.isView(body) || isArrayBuffer(body)) {
    const hashCtor = new hashConstructor;
    hashCtor.update(toUint8Array2(body));
    return import_util_hex_encoding2.toHex(await hashCtor.digest());
  }
  return UNSIGNED_PAYLOAD;
};
var init_getPayloadHash = __esm2(() => {
  import_util_hex_encoding2 = __toESM3(require_dist_cjs13(), 1);
  init_dist_es6();
  init_constants2();
});

class HeaderFormatter {
  format(headers) {
    const chunks = [];
    for (const headerName of Object.keys(headers)) {
      const bytes = fromUtf84(headerName);
      chunks.push(Uint8Array.from([bytes.byteLength]), bytes, this.formatHeaderValue(headers[headerName]));
    }
    const out = new Uint8Array(chunks.reduce((carry, bytes) => carry + bytes.byteLength, 0));
    let position = 0;
    for (const chunk of chunks) {
      out.set(chunk, position);
      position += chunk.byteLength;
    }
    return out;
  }
  formatHeaderValue(header) {
    switch (header.type) {
      case "boolean":
        return Uint8Array.from([header.value ? 0 : 1]);
      case "byte":
        return Uint8Array.from([2, header.value]);
      case "short":
        const shortView = new DataView(new ArrayBuffer(3));
        shortView.setUint8(0, 3);
        shortView.setInt16(1, header.value, false);
        return new Uint8Array(shortView.buffer);
      case "integer":
        const intView = new DataView(new ArrayBuffer(5));
        intView.setUint8(0, 4);
        intView.setInt32(1, header.value, false);
        return new Uint8Array(intView.buffer);
      case "long":
        const longBytes = new Uint8Array(9);
        longBytes[0] = 5;
        longBytes.set(header.value.bytes, 1);
        return longBytes;
      case "binary":
        const binView = new DataView(new ArrayBuffer(3 + header.value.byteLength));
        binView.setUint8(0, 6);
        binView.setUint16(1, header.value.byteLength, false);
        const binBytes = new Uint8Array(binView.buffer);
        binBytes.set(header.value, 3);
        return binBytes;
      case "string":
        const utf8Bytes = fromUtf84(header.value);
        const strView = new DataView(new ArrayBuffer(3 + utf8Bytes.byteLength));
        strView.setUint8(0, 7);
        strView.setUint16(1, utf8Bytes.byteLength, false);
        const strBytes = new Uint8Array(strView.buffer);
        strBytes.set(utf8Bytes, 3);
        return strBytes;
      case "timestamp":
        const tsBytes = new Uint8Array(9);
        tsBytes[0] = 8;
        tsBytes.set(Int64.fromNumber(header.value.valueOf()).bytes, 1);
        return tsBytes;
      case "uuid":
        if (!UUID_PATTERN.test(header.value)) {
          throw new Error(`Invalid UUID received: ${header.value}`);
        }
        const uuidBytes = new Uint8Array(17);
        uuidBytes[0] = 9;
        uuidBytes.set(import_util_hex_encoding3.fromHex(header.value.replace(/\-/g, "")), 1);
        return uuidBytes;
    }
  }
}

class Int64 {
  constructor(bytes) {
    this.bytes = bytes;
    if (bytes.byteLength !== 8) {
      throw new Error("Int64 buffers must be exactly 8 bytes");
    }
  }
  static fromNumber(number) {
    if (number > 9223372036854776000 || number < -9223372036854776000) {
      throw new Error(`${number} is too large (or, if negative, too small) to represent as an Int64`);
    }
    const bytes = new Uint8Array(8);
    for (let i2 = 7, remaining = Math.abs(Math.round(number));i2 > -1 && remaining > 0; i2--, remaining /= 256) {
      bytes[i2] = remaining;
    }
    if (number < 0) {
      negate(bytes);
    }
    return new Int64(bytes);
  }
  valueOf() {
    const bytes = this.bytes.slice(0);
    const negative = bytes[0] & 128;
    if (negative) {
      negate(bytes);
    }
    return parseInt(import_util_hex_encoding3.toHex(bytes), 16) * (negative ? -1 : 1);
  }
  toString() {
    return String(this.valueOf());
  }
}
function negate(bytes) {
  for (let i2 = 0;i2 < 8; i2++) {
    bytes[i2] ^= 255;
  }
  for (let i2 = 7;i2 > -1; i2--) {
    bytes[i2]++;
    if (bytes[i2] !== 0)
      break;
  }
}
var import_util_hex_encoding3;
var HEADER_VALUE_TYPE;
var UUID_PATTERN;
var init_HeaderFormatter = __esm2(() => {
  import_util_hex_encoding3 = __toESM3(require_dist_cjs13(), 1);
  init_dist_es6();
  (function(HEADER_VALUE_TYPE2) {
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["boolTrue"] = 0] = "boolTrue";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["boolFalse"] = 1] = "boolFalse";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["byte"] = 2] = "byte";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["short"] = 3] = "short";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["integer"] = 4] = "integer";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["long"] = 5] = "long";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["byteArray"] = 6] = "byteArray";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["string"] = 7] = "string";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["timestamp"] = 8] = "timestamp";
    HEADER_VALUE_TYPE2[HEADER_VALUE_TYPE2["uuid"] = 9] = "uuid";
  })(HEADER_VALUE_TYPE || (HEADER_VALUE_TYPE = {}));
  UUID_PATTERN = /^[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}$/;
});
var hasHeader2 = (soughtHeader, headers) => {
  soughtHeader = soughtHeader.toLowerCase();
  for (const headerName of Object.keys(headers)) {
    if (soughtHeader === headerName.toLowerCase()) {
      return true;
    }
  }
  return false;
};
var moveHeadersToQuery = (request42, options3 = {}) => {
  const { headers, query = {} } = HttpRequest.clone(request42);
  for (const name of Object.keys(headers)) {
    const lname = name.toLowerCase();
    if (lname.slice(0, 6) === "x-amz-" && !options3.unhoistableHeaders?.has(lname) || options3.hoistableHeaders?.has(lname)) {
      query[name] = headers[name];
      delete headers[name];
    }
  }
  return {
    ...request42,
    headers,
    query
  };
};
var init_moveHeadersToQuery = __esm2(() => {
  init_dist_es();
});
var prepareRequest = (request42) => {
  request42 = HttpRequest.clone(request42);
  for (const headerName of Object.keys(request42.headers)) {
    if (GENERATED_HEADERS.indexOf(headerName.toLowerCase()) > -1) {
      delete request42.headers[headerName];
    }
  }
  return request42;
};
var init_prepareRequest = __esm2(() => {
  init_dist_es();
  init_constants2();
});
var iso8601 = (time) => toDate(time).toISOString().replace(/\.\d{3}Z$/, "Z");
var toDate = (time) => {
  if (typeof time === "number") {
    return new Date(time * 1000);
  }
  if (typeof time === "string") {
    if (Number(time)) {
      return new Date(Number(time) * 1000);
    }
    return new Date(time);
  }
  return time;
};

class SignatureV4 {
  constructor({ applyChecksum, credentials, region, service, sha256, uriEscapePath = true }) {
    this.headerFormatter = new HeaderFormatter;
    this.service = service;
    this.sha256 = sha256;
    this.uriEscapePath = uriEscapePath;
    this.applyChecksum = typeof applyChecksum === "boolean" ? applyChecksum : true;
    this.regionProvider = import_util_middleware2.normalizeProvider(region);
    this.credentialProvider = import_util_middleware2.normalizeProvider(credentials);
  }
  async presign(originalRequest, options3 = {}) {
    const { signingDate = new Date, expiresIn = 3600, unsignableHeaders, unhoistableHeaders, signableHeaders, hoistableHeaders, signingRegion, signingService } = options3;
    const credentials = await this.credentialProvider();
    this.validateResolvedCredentials(credentials);
    const region = signingRegion ?? await this.regionProvider();
    const { longDate, shortDate } = formatDate(signingDate);
    if (expiresIn > MAX_PRESIGNED_TTL) {
      return Promise.reject("Signature version 4 presigned URLs must have an expiration date less than one week in the future");
    }
    const scope = createScope(shortDate, region, signingService ?? this.service);
    const request42 = moveHeadersToQuery(prepareRequest(originalRequest), { unhoistableHeaders, hoistableHeaders });
    if (credentials.sessionToken) {
      request42.query[TOKEN_QUERY_PARAM] = credentials.sessionToken;
    }
    request42.query[ALGORITHM_QUERY_PARAM] = ALGORITHM_IDENTIFIER;
    request42.query[CREDENTIAL_QUERY_PARAM] = `${credentials.accessKeyId}/${scope}`;
    request42.query[AMZ_DATE_QUERY_PARAM] = longDate;
    request42.query[EXPIRES_QUERY_PARAM] = expiresIn.toString(10);
    const canonicalHeaders = getCanonicalHeaders(request42, unsignableHeaders, signableHeaders);
    request42.query[SIGNED_HEADERS_QUERY_PARAM] = getCanonicalHeaderList(canonicalHeaders);
    request42.query[SIGNATURE_QUERY_PARAM] = await this.getSignature(longDate, scope, this.getSigningKey(credentials, region, shortDate, signingService), this.createCanonicalRequest(request42, canonicalHeaders, await getPayloadHash(originalRequest, this.sha256)));
    return request42;
  }
  async sign(toSign, options3) {
    if (typeof toSign === "string") {
      return this.signString(toSign, options3);
    } else if (toSign.headers && toSign.payload) {
      return this.signEvent(toSign, options3);
    } else if (toSign.message) {
      return this.signMessage(toSign, options3);
    } else {
      return this.signRequest(toSign, options3);
    }
  }
  async signEvent({ headers, payload }, { signingDate = new Date, priorSignature, signingRegion, signingService }) {
    const region = signingRegion ?? await this.regionProvider();
    const { shortDate, longDate } = formatDate(signingDate);
    const scope = createScope(shortDate, region, signingService ?? this.service);
    const hashedPayload = await getPayloadHash({ headers: {}, body: payload }, this.sha256);
    const hash3 = new this.sha256;
    hash3.update(headers);
    const hashedHeaders = import_util_hex_encoding4.toHex(await hash3.digest());
    const stringToSign = [
      EVENT_ALGORITHM_IDENTIFIER,
      longDate,
      scope,
      priorSignature,
      hashedHeaders,
      hashedPayload
    ].join("\n");
    return this.signString(stringToSign, { signingDate, signingRegion: region, signingService });
  }
  async signMessage(signableMessage, { signingDate = new Date, signingRegion, signingService }) {
    const promise3 = this.signEvent({
      headers: this.headerFormatter.format(signableMessage.message.headers),
      payload: signableMessage.message.body
    }, {
      signingDate,
      signingRegion,
      signingService,
      priorSignature: signableMessage.priorSignature
    });
    return promise3.then((signature) => {
      return { message: signableMessage.message, signature };
    });
  }
  async signString(stringToSign, { signingDate = new Date, signingRegion, signingService } = {}) {
    const credentials = await this.credentialProvider();
    this.validateResolvedCredentials(credentials);
    const region = signingRegion ?? await this.regionProvider();
    const { shortDate } = formatDate(signingDate);
    const hash3 = new this.sha256(await this.getSigningKey(credentials, region, shortDate, signingService));
    hash3.update(toUint8Array2(stringToSign));
    return import_util_hex_encoding4.toHex(await hash3.digest());
  }
  async signRequest(requestToSign, { signingDate = new Date, signableHeaders, unsignableHeaders, signingRegion, signingService } = {}) {
    const credentials = await this.credentialProvider();
    this.validateResolvedCredentials(credentials);
    const region = signingRegion ?? await this.regionProvider();
    const request42 = prepareRequest(requestToSign);
    const { longDate, shortDate } = formatDate(signingDate);
    const scope = createScope(shortDate, region, signingService ?? this.service);
    request42.headers[AMZ_DATE_HEADER] = longDate;
    if (credentials.sessionToken) {
      request42.headers[TOKEN_HEADER] = credentials.sessionToken;
    }
    const payloadHash = await getPayloadHash(request42, this.sha256);
    if (!hasHeader2(SHA256_HEADER, request42.headers) && this.applyChecksum) {
      request42.headers[SHA256_HEADER] = payloadHash;
    }
    const canonicalHeaders = getCanonicalHeaders(request42, unsignableHeaders, signableHeaders);
    const signature = await this.getSignature(longDate, scope, this.getSigningKey(credentials, region, shortDate, signingService), this.createCanonicalRequest(request42, canonicalHeaders, payloadHash));
    request42.headers[AUTH_HEADER] = `${ALGORITHM_IDENTIFIER} Credential=${credentials.accessKeyId}/${scope}, SignedHeaders=${getCanonicalHeaderList(canonicalHeaders)}, Signature=${signature}`;
    return request42;
  }
  createCanonicalRequest(request42, canonicalHeaders, payloadHash) {
    const sortedHeaders = Object.keys(canonicalHeaders).sort();
    return `${request42.method}
${this.getCanonicalPath(request42)}
${getCanonicalQuery(request42)}
${sortedHeaders.map((name) => `${name}:${canonicalHeaders[name]}`).join("\n")}

${sortedHeaders.join(";")}
${payloadHash}`;
  }
  async createStringToSign(longDate, credentialScope, canonicalRequest) {
    const hash3 = new this.sha256;
    hash3.update(toUint8Array2(canonicalRequest));
    const hashedRequest = await hash3.digest();
    return `${ALGORITHM_IDENTIFIER}
${longDate}
${credentialScope}
${import_util_hex_encoding4.toHex(hashedRequest)}`;
  }
  getCanonicalPath({ path: path5 }) {
    if (this.uriEscapePath) {
      const normalizedPathSegments = [];
      for (const pathSegment of path5.split("/")) {
        if (pathSegment?.length === 0)
          continue;
        if (pathSegment === ".")
          continue;
        if (pathSegment === "..") {
          normalizedPathSegments.pop();
        } else {
          normalizedPathSegments.push(pathSegment);
        }
      }
      const normalizedPath = `${path5?.startsWith("/") ? "/" : ""}${normalizedPathSegments.join("/")}${normalizedPathSegments.length > 0 && path5?.endsWith("/") ? "/" : ""}`;
      const doubleEncoded = escapeUri(normalizedPath);
      return doubleEncoded.replace(/%2F/g, "/");
    }
    return path5;
  }
  async getSignature(longDate, credentialScope, keyPromise, canonicalRequest) {
    const stringToSign = await this.createStringToSign(longDate, credentialScope, canonicalRequest);
    const hash3 = new this.sha256(await keyPromise);
    hash3.update(toUint8Array2(stringToSign));
    return import_util_hex_encoding4.toHex(await hash3.digest());
  }
  getSigningKey(credentials, region, shortDate, service) {
    return getSigningKey(this.sha256, credentials, shortDate, region, service || this.service);
  }
  validateResolvedCredentials(credentials) {
    if (typeof credentials !== "object" || typeof credentials.accessKeyId !== "string" || typeof credentials.secretAccessKey !== "string") {
      throw new Error("Resolved credential object is not valid");
    }
  }
}
var import_util_hex_encoding4;
var import_util_middleware2;
var formatDate = (now2) => {
  const longDate = iso8601(now2).replace(/[\-:]/g, "");
  return {
    longDate,
    shortDate: longDate.slice(0, 8)
  };
};
var getCanonicalHeaderList = (headers) => Object.keys(headers).sort().join(";");
var init_SignatureV4 = __esm2(() => {
  import_util_hex_encoding4 = __toESM3(require_dist_cjs13(), 1);
  import_util_middleware2 = __toESM3(require_dist_cjs3(), 1);
  init_dist_es13();
  init_dist_es6();
  init_constants2();
  init_credentialDerivation();
  init_getCanonicalHeaders();
  init_getCanonicalQuery();
  init_getPayloadHash();
  init_HeaderFormatter();
  init_moveHeadersToQuery();
  init_prepareRequest();
});
var init_dist_es14 = __esm2(() => {
  init_SignatureV4();
  init_getCanonicalHeaders();
  init_getCanonicalQuery();
  init_getPayloadHash();
  init_moveHeadersToQuery();
  init_prepareRequest();
  init_credentialDerivation();
});
var booleanSelector = (obj, key2, type2) => {
  if (!(key2 in obj))
    return;
  if (obj[key2] === "true")
    return true;
  if (obj[key2] === "false")
    return false;
  throw new Error(`Cannot load ${type2} "${key2}". Expected "true" or "false", got ${obj[key2]}.`);
};
var SelectorType2;
var init_types6 = __esm2(() => {
  (function(SelectorType3) {
    SelectorType3["ENV"] = "env";
    SelectorType3["CONFIG"] = "shared config entry";
  })(SelectorType2 || (SelectorType2 = {}));
});
var init_dist_es15 = __esm2(() => {
  init_types6();
});
var S3_EXPRESS_BUCKET_TYPE = "Directory";
var S3_EXPRESS_BACKEND = "S3Express";
var S3_EXPRESS_AUTH_SCHEME = "sigv4-s3express";
var SESSION_TOKEN_QUERY_PARAM = "X-Amz-S3session-Token";
var SESSION_TOKEN_HEADER;
var NODE_DISABLE_S3_EXPRESS_SESSION_AUTH_ENV_NAME = "AWS_S3_DISABLE_EXPRESS_SESSION_AUTH";
var NODE_DISABLE_S3_EXPRESS_SESSION_AUTH_INI_NAME = "s3_disable_express_session_auth";
var NODE_DISABLE_S3_EXPRESS_SESSION_AUTH_OPTIONS;
var init_constants3 = __esm2(() => {
  init_dist_es15();
  SESSION_TOKEN_HEADER = SESSION_TOKEN_QUERY_PARAM.toLowerCase();
  NODE_DISABLE_S3_EXPRESS_SESSION_AUTH_OPTIONS = {
    environmentVariableSelector: (env62) => booleanSelector(env62, NODE_DISABLE_S3_EXPRESS_SESSION_AUTH_ENV_NAME, SelectorType2.ENV),
    configFileSelector: (profile) => booleanSelector(profile, NODE_DISABLE_S3_EXPRESS_SESSION_AUTH_INI_NAME, SelectorType2.CONFIG),
    default: false
  };
});
function getCredentialsWithoutSessionToken(credentials) {
  const credentialsWithoutSessionToken = {
    accessKeyId: credentials.accessKeyId,
    secretAccessKey: credentials.secretAccessKey,
    expiration: credentials.expiration
  };
  return credentialsWithoutSessionToken;
}
function setSingleOverride(privateAccess, credentialsWithoutSessionToken) {
  const id = setTimeout(() => {
    throw new Error("SignatureV4S3Express credential override was created but not called.");
  }, 10);
  const currentCredentialProvider = privateAccess.credentialProvider;
  const overrideCredentialsProviderOnce = () => {
    clearTimeout(id);
    privateAccess.credentialProvider = currentCredentialProvider;
    return Promise.resolve(credentialsWithoutSessionToken);
  };
  privateAccess.credentialProvider = overrideCredentialsProviderOnce;
}
var SignatureV4S3Express;
var init_SignatureV4S3Express = __esm2(() => {
  init_dist_es14();
  init_constants3();
  SignatureV4S3Express = class SignatureV4S3Express2 extends SignatureV4 {
    async signWithCredentials(requestToSign, credentials, options3) {
      const credentialsWithoutSessionToken = getCredentialsWithoutSessionToken(credentials);
      requestToSign.headers[SESSION_TOKEN_HEADER] = credentials.sessionToken;
      const privateAccess = this;
      setSingleOverride(privateAccess, credentialsWithoutSessionToken);
      return privateAccess.signRequest(requestToSign, options3 ?? {});
    }
    async presignWithCredentials(requestToSign, credentials, options3) {
      const credentialsWithoutSessionToken = getCredentialsWithoutSessionToken(credentials);
      delete requestToSign.headers[SESSION_TOKEN_HEADER];
      requestToSign.headers[SESSION_TOKEN_QUERY_PARAM] = credentials.sessionToken;
      requestToSign.query = requestToSign.query ?? {};
      requestToSign.query[SESSION_TOKEN_QUERY_PARAM] = credentials.sessionToken;
      const privateAccess = this;
      setSingleOverride(privateAccess, credentialsWithoutSessionToken);
      return this.presign(requestToSign, options3);
    }
  };
});
var import_core5;
var s3ExpressMiddleware = (options3) => {
  return (next, context) => async (args) => {
    if (context.endpointV2) {
      const endpoint = context.endpointV2;
      const isS3ExpressAuth = endpoint.properties?.authSchemes?.[0]?.name === S3_EXPRESS_AUTH_SCHEME;
      const isS3ExpressBucket = endpoint.properties?.backend === S3_EXPRESS_BACKEND || endpoint.properties?.bucketType === S3_EXPRESS_BUCKET_TYPE;
      if (isS3ExpressBucket) {
        import_core5.setFeature(context, "S3_EXPRESS_BUCKET", "J");
        context.isS3ExpressBucket = true;
      }
      if (isS3ExpressAuth) {
        const requestBucket = args.input.Bucket;
        if (requestBucket) {
          const s3ExpressIdentity = await options3.s3ExpressIdentityProvider.getS3ExpressIdentity(await options3.credentials(), {
            Bucket: requestBucket
          });
          context.s3ExpressIdentity = s3ExpressIdentity;
          if (HttpRequest.isInstance(args.request) && s3ExpressIdentity.sessionToken) {
            args.request.headers[SESSION_TOKEN_HEADER] = s3ExpressIdentity.sessionToken;
          }
        }
      }
    }
    return next(args);
  };
};
var s3ExpressMiddlewareOptions;
var getS3ExpressPlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(s3ExpressMiddleware(options3), s3ExpressMiddlewareOptions);
  }
});
var init_s3ExpressMiddleware = __esm2(() => {
  import_core5 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es();
  init_constants3();
  s3ExpressMiddlewareOptions = {
    name: "s3ExpressMiddleware",
    step: "build",
    tags: ["S3", "S3_EXPRESS"],
    override: true
  };
});
var signS3Express = async (s3ExpressIdentity, signingOptions, request42, sigV4MultiRegionSigner) => {
  const signedRequest = await sigV4MultiRegionSigner.signWithCredentials(request42, s3ExpressIdentity, {});
  if (signedRequest.headers["X-Amz-Security-Token"] || signedRequest.headers["x-amz-security-token"]) {
    throw new Error("X-Amz-Security-Token must not be set for s3-express requests.");
  }
  return signedRequest;
};
var import_core6;
var import_types13;
var import_util_middleware3;
var defaultErrorHandler = (signingProperties) => (error) => {
  throw error;
};
var defaultSuccessHandler = (httpResponse2, signingProperties) => {
};
var s3ExpressHttpSigningMiddleware = (config6) => (next, context) => async (args) => {
  if (!HttpRequest.isInstance(args.request)) {
    return next(args);
  }
  const smithyContext = import_util_middleware3.getSmithyContext(context);
  const scheme = smithyContext.selectedHttpAuthScheme;
  if (!scheme) {
    throw new Error(`No HttpAuthScheme was selected: unable to sign request`);
  }
  const { httpAuthOption: { signingProperties = {} }, identity: identity2, signer } = scheme;
  let request42;
  if (context.s3ExpressIdentity) {
    request42 = await signS3Express(context.s3ExpressIdentity, signingProperties, args.request, await config6.signer());
  } else {
    request42 = await signer.sign(args.request, identity2, signingProperties);
  }
  const output = await next({
    ...args,
    request: request42
  }).catch((signer.errorHandler || defaultErrorHandler)(signingProperties));
  (signer.successHandler || defaultSuccessHandler)(output.response, signingProperties);
  return output;
};
var getS3ExpressHttpSigningPlugin = (config6) => ({
  applyToStack: (clientStack) => {
    clientStack.addRelativeTo(s3ExpressHttpSigningMiddleware(config6), import_core6.httpSigningMiddlewareOptions);
  }
});
var init_s3ExpressHttpSigningMiddleware = __esm2(() => {
  import_core6 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es();
  import_types13 = __toESM3(require_dist_cjs(), 1);
  import_util_middleware3 = __toESM3(require_dist_cjs3(), 1);
});
var init_s3_express = __esm2(() => {
  init_S3ExpressIdentityCache();
  init_S3ExpressIdentityProviderImpl();
  init_SignatureV4S3Express();
  init_constants3();
  init_s3ExpressMiddleware();
  init_s3ExpressHttpSigningMiddleware();
});
var resolveS3Config = (input, { session }) => {
  const [s3ClientProvider, CreateSessionCommandCtor] = session;
  return {
    ...input,
    forcePathStyle: input.forcePathStyle ?? false,
    useAccelerateEndpoint: input.useAccelerateEndpoint ?? false,
    disableMultiregionAccessPoints: input.disableMultiregionAccessPoints ?? false,
    followRegionRedirects: input.followRegionRedirects ?? false,
    s3ExpressIdentityProvider: input.s3ExpressIdentityProvider ?? new S3ExpressIdentityProviderImpl(async (key2) => s3ClientProvider().send(new CreateSessionCommandCtor({
      Bucket: key2,
      SessionMode: "ReadWrite"
    }))),
    bucketEndpoint: input.bucketEndpoint ?? false
  };
};
var init_s3Configuration = __esm2(() => {
  init_s3_express();
});
var BASE64_REGEX;
var fromBase642 = (input) => {
  if (input.length * 3 % 4 !== 0) {
    throw new TypeError(`Incorrect padding on base64 string.`);
  }
  if (!BASE64_REGEX.exec(input)) {
    throw new TypeError(`Invalid base64 string.`);
  }
  const buffer = fromString2(input, "base64");
  return new Uint8Array(buffer.buffer, buffer.byteOffset, buffer.byteLength);
};
var init_fromBase64 = __esm2(() => {
  init_dist_es5();
  BASE64_REGEX = /^[A-Za-z0-9+/]*={0,2}$/;
});
var toBase643 = (_input) => {
  let input;
  if (typeof _input === "string") {
    input = fromUtf84(_input);
  } else {
    input = _input;
  }
  if (typeof input !== "object" || typeof input.byteOffset !== "number" || typeof input.byteLength !== "number") {
    throw new Error("@smithy/util-base64: toBase64 encoder function only accepts string | Uint8Array.");
  }
  return fromArrayBuffer2(input.buffer, input.byteOffset, input.byteLength).toString("base64");
};
var init_toBase64 = __esm2(() => {
  init_dist_es5();
  init_dist_es6();
});
var init_dist_es16 = __esm2(() => {
  init_fromBase64();
  init_toBase64();
});
var init_transforms = __esm2(() => {
  init_dist_es16();
  init_dist_es6();
  init_Uint8ArrayBlobAdapter();
});
var init_Uint8ArrayBlobAdapter = __esm2(() => {
  init_transforms();
});
var getAwsChunkedEncodingStream2 = (readableStream, options3) => {
  const { base64Encoder, bodyLengthChecker, checksumAlgorithmFn, checksumLocationName, streamHasher } = options3;
  const checksumRequired = base64Encoder !== undefined && checksumAlgorithmFn !== undefined && checksumLocationName !== undefined && streamHasher !== undefined;
  const digest = checksumRequired ? streamHasher(checksumAlgorithmFn, readableStream) : undefined;
  const awsChunkedEncodingStream = new Readable({ read: () => {
  } });
  readableStream.on("data", (data2) => {
    const length = bodyLengthChecker(data2) || 0;
    awsChunkedEncodingStream.push(`${length.toString(16)}\r\n`);
    awsChunkedEncodingStream.push(data2);
    awsChunkedEncodingStream.push("\r\n");
  });
  readableStream.on("end", async () => {
    awsChunkedEncodingStream.push(`0\r\n`);
    if (checksumRequired) {
      const checksum = base64Encoder(await digest);
      awsChunkedEncodingStream.push(`${checksumLocationName}:${checksum}\r\n`);
      awsChunkedEncodingStream.push(`\r\n`);
    }
    awsChunkedEncodingStream.push(null);
  });
  return awsChunkedEncodingStream;
};
var init_getAwsChunkedEncodingStream = () => {
};
function buildQueryString(query) {
  const parts = [];
  for (let key2 of Object.keys(query).sort()) {
    const value = query[key2];
    key2 = escapeUri(key2);
    if (Array.isArray(value)) {
      for (let i2 = 0, iLen = value.length;i2 < iLen; i2++) {
        parts.push(`${key2}=${escapeUri(value[i2])}`);
      }
    } else {
      let qsEntry = key2;
      if (value || typeof value === "string") {
        qsEntry += `=${escapeUri(value)}`;
      }
      parts.push(qsEntry);
    }
  }
  return parts.join("&");
}
var init_dist_es17 = __esm2(() => {
  init_dist_es13();
});
var NODEJS_TIMEOUT_ERROR_CODES;
var init_constants4 = __esm2(() => {
  NODEJS_TIMEOUT_ERROR_CODES = ["ECONNRESET", "EPIPE", "ETIMEDOUT"];
});
var getTransformedHeaders = (headers) => {
  const transformedHeaders = {};
  for (const name of Object.keys(headers)) {
    const headerValues = headers[name];
    transformedHeaders[name] = Array.isArray(headerValues) ? headerValues.join(",") : headerValues;
  }
  return transformedHeaders;
};
var init_get_transformed_headers = () => {
};
var DEFER_EVENT_LISTENER_TIME = 1000;
var setConnectionTimeout = (request42, reject, timeoutInMs = 0) => {
  if (!timeoutInMs) {
    return -1;
  }
  const registerTimeout = (offset2) => {
    const timeoutId = setTimeout(() => {
      request42.destroy();
      reject(Object.assign(new Error(`Socket timed out without establishing a connection within ${timeoutInMs} ms`), {
        name: "TimeoutError"
      }));
    }, timeoutInMs - offset2);
    const doWithSocket = (socket) => {
      if (socket?.connecting) {
        socket.on("connect", () => {
          clearTimeout(timeoutId);
        });
      } else {
        clearTimeout(timeoutId);
      }
    };
    if (request42.socket) {
      doWithSocket(request42.socket);
    } else {
      request42.on("socket", doWithSocket);
    }
  };
  if (timeoutInMs < 2000) {
    registerTimeout(0);
    return 0;
  }
  return setTimeout(registerTimeout.bind(null, DEFER_EVENT_LISTENER_TIME), DEFER_EVENT_LISTENER_TIME);
};
var DEFER_EVENT_LISTENER_TIME2 = 3000;
var setSocketKeepAlive = (request42, { keepAlive, keepAliveMsecs }, deferTimeMs = DEFER_EVENT_LISTENER_TIME2) => {
  if (keepAlive !== true) {
    return -1;
  }
  const registerListener = () => {
    if (request42.socket) {
      request42.socket.setKeepAlive(keepAlive, keepAliveMsecs || 0);
    } else {
      request42.on("socket", (socket) => {
        socket.setKeepAlive(keepAlive, keepAliveMsecs || 0);
      });
    }
  };
  if (deferTimeMs === 0) {
    registerListener();
    return 0;
  }
  return setTimeout(registerListener, deferTimeMs);
};
var DEFER_EVENT_LISTENER_TIME3 = 3000;
var setSocketTimeout = (request42, reject, timeoutInMs = 0) => {
  const registerTimeout = (offset2) => {
    request42.setTimeout(timeoutInMs - offset2, () => {
      request42.destroy();
      reject(Object.assign(new Error(`Connection timed out after ${timeoutInMs} ms`), { name: "TimeoutError" }));
    });
  };
  if (0 < timeoutInMs && timeoutInMs < 6000) {
    registerTimeout(0);
    return 0;
  }
  return setTimeout(registerTimeout.bind(null, timeoutInMs === 0 ? 0 : DEFER_EVENT_LISTENER_TIME3), DEFER_EVENT_LISTENER_TIME3);
};
async function writeRequestBody(httpRequest2, request42, maxContinueTimeoutMs = MIN_WAIT_TIME) {
  const headers = request42.headers ?? {};
  const expect = headers["Expect"] || headers["expect"];
  let timeoutId = -1;
  let hasError = false;
  if (expect === "100-continue") {
    await Promise.race([
      new Promise((resolve5) => {
        timeoutId = Number(setTimeout(resolve5, Math.max(MIN_WAIT_TIME, maxContinueTimeoutMs)));
      }),
      new Promise((resolve5) => {
        httpRequest2.on("continue", () => {
          clearTimeout(timeoutId);
          resolve5();
        });
        httpRequest2.on("error", () => {
          hasError = true;
          clearTimeout(timeoutId);
          resolve5();
        });
      })
    ]);
  }
  if (!hasError) {
    writeBody(httpRequest2, request42.body);
  }
}
function writeBody(httpRequest2, body) {
  if (body instanceof Readable2) {
    body.pipe(httpRequest2);
    return;
  }
  if (body) {
    if (Buffer.isBuffer(body) || typeof body === "string") {
      httpRequest2.end(body);
      return;
    }
    const uint8 = body;
    if (typeof uint8 === "object" && uint8.buffer && typeof uint8.byteOffset === "number" && typeof uint8.byteLength === "number") {
      httpRequest2.end(Buffer.from(uint8.buffer, uint8.byteOffset, uint8.byteLength));
      return;
    }
    httpRequest2.end(Buffer.from(body));
    return;
  }
  httpRequest2.end();
}
var MIN_WAIT_TIME = 1000;
var init_write_request_body = () => {
};

class NodeHttpHandler {
  static create(instanceOrOptions) {
    if (typeof instanceOrOptions?.handle === "function") {
      return instanceOrOptions;
    }
    return new NodeHttpHandler(instanceOrOptions);
  }
  static checkSocketUsage(agent, socketWarningTimestamp, logger3 = console) {
    const { sockets, requests, maxSockets } = agent;
    if (typeof maxSockets !== "number" || maxSockets === Infinity) {
      return socketWarningTimestamp;
    }
    const interval = 15000;
    if (Date.now() - interval < socketWarningTimestamp) {
      return socketWarningTimestamp;
    }
    if (sockets && requests) {
      for (const origin in sockets) {
        const socketsInUse = sockets[origin]?.length ?? 0;
        const requestsEnqueued = requests[origin]?.length ?? 0;
        if (socketsInUse >= maxSockets && requestsEnqueued >= 2 * maxSockets) {
          logger3?.warn?.(`@smithy/node-http-handler:WARN - socket usage at capacity=${socketsInUse} and ${requestsEnqueued} additional requests are enqueued.
See https://docs.aws.amazon.com/sdk-for-javascript/v3/developer-guide/node-configuring-maxsockets.html
or increase socketAcquisitionWarningTimeout=(millis) in the NodeHttpHandler config.`);
          return Date.now();
        }
      }
    }
    return socketWarningTimestamp;
  }
  constructor(options3) {
    this.socketWarningTimestamp = 0;
    this.metadata = { handlerProtocol: "http/1.1" };
    this.configProvider = new Promise((resolve5, reject) => {
      if (typeof options3 === "function") {
        options3().then((_options) => {
          resolve5(this.resolveDefaultConfig(_options));
        }).catch(reject);
      } else {
        resolve5(this.resolveDefaultConfig(options3));
      }
    });
  }
  resolveDefaultConfig(options3) {
    const { requestTimeout, connectionTimeout, socketTimeout, httpAgent, httpsAgent } = options3 || {};
    const keepAlive = true;
    const maxSockets = 50;
    return {
      connectionTimeout,
      requestTimeout: requestTimeout ?? socketTimeout,
      httpAgent: (() => {
        if (httpAgent instanceof hAgent || typeof httpAgent?.destroy === "function") {
          return httpAgent;
        }
        return new hAgent({ keepAlive, maxSockets, ...httpAgent });
      })(),
      httpsAgent: (() => {
        if (httpsAgent instanceof hsAgent || typeof httpsAgent?.destroy === "function") {
          return httpsAgent;
        }
        return new hsAgent({ keepAlive, maxSockets, ...httpsAgent });
      })(),
      logger: console
    };
  }
  destroy() {
    this.config?.httpAgent?.destroy();
    this.config?.httpsAgent?.destroy();
  }
  async handle(request42, { abortSignal } = {}) {
    if (!this.config) {
      this.config = await this.configProvider;
    }
    return new Promise((_resolve, _reject) => {
      let writeRequestBodyPromise = undefined;
      const timeouts = [];
      const resolve5 = async (arg) => {
        await writeRequestBodyPromise;
        timeouts.forEach(clearTimeout);
        _resolve(arg);
      };
      const reject = async (arg) => {
        await writeRequestBodyPromise;
        timeouts.forEach(clearTimeout);
        _reject(arg);
      };
      if (!this.config) {
        throw new Error("Node HTTP request handler config is not resolved");
      }
      if (abortSignal?.aborted) {
        const abortError = new Error("Request aborted");
        abortError.name = "AbortError";
        reject(abortError);
        return;
      }
      const isSSL = request42.protocol === "https:";
      const agent = isSSL ? this.config.httpsAgent : this.config.httpAgent;
      timeouts.push(setTimeout(() => {
        this.socketWarningTimestamp = NodeHttpHandler.checkSocketUsage(agent, this.socketWarningTimestamp, this.config.logger);
      }, this.config.socketAcquisitionWarningTimeout ?? (this.config.requestTimeout ?? 2000) + (this.config.connectionTimeout ?? 1000)));
      const queryString = buildQueryString(request42.query || {});
      let auth = undefined;
      if (request42.username != null || request42.password != null) {
        const username = request42.username ?? "";
        const password = request42.password ?? "";
        auth = `${username}:${password}`;
      }
      let path5 = request42.path;
      if (queryString) {
        path5 += `?${queryString}`;
      }
      if (request42.fragment) {
        path5 += `#${request42.fragment}`;
      }
      let hostname = request42.hostname ?? "";
      if (hostname[0] === "[" && hostname.endsWith("]")) {
        hostname = request42.hostname.slice(1, -1);
      } else {
        hostname = request42.hostname;
      }
      const nodeHttpsOptions = {
        headers: request42.headers,
        host: hostname,
        method: request42.method,
        path: path5,
        port: request42.port,
        agent,
        auth
      };
      const requestFunc = isSSL ? hsRequest : hRequest;
      const req = requestFunc(nodeHttpsOptions, (res) => {
        const httpResponse2 = new HttpResponse({
          statusCode: res.statusCode || -1,
          reason: res.statusMessage,
          headers: getTransformedHeaders(res.headers),
          body: res
        });
        resolve5({ response: httpResponse2 });
      });
      req.on("error", (err22) => {
        if (NODEJS_TIMEOUT_ERROR_CODES.includes(err22.code)) {
          reject(Object.assign(err22, { name: "TimeoutError" }));
        } else {
          reject(err22);
        }
      });
      if (abortSignal) {
        const onAbort = () => {
          req.destroy();
          const abortError = new Error("Request aborted");
          abortError.name = "AbortError";
          reject(abortError);
        };
        if (typeof abortSignal.addEventListener === "function") {
          const signal = abortSignal;
          signal.addEventListener("abort", onAbort, { once: true });
          req.once("close", () => signal.removeEventListener("abort", onAbort));
        } else {
          abortSignal.onabort = onAbort;
        }
      }
      timeouts.push(setConnectionTimeout(req, reject, this.config.connectionTimeout));
      timeouts.push(setSocketTimeout(req, reject, this.config.requestTimeout));
      const httpAgent = nodeHttpsOptions.agent;
      if (typeof httpAgent === "object" && "keepAlive" in httpAgent) {
        timeouts.push(setSocketKeepAlive(req, {
          keepAlive: httpAgent.keepAlive,
          keepAliveMsecs: httpAgent.keepAliveMsecs
        }));
      }
      writeRequestBodyPromise = writeRequestBody(req, request42, this.config.requestTimeout).catch((e) => {
        timeouts.forEach(clearTimeout);
        return _reject(e);
      });
    });
  }
  updateHttpClientConfig(key2, value) {
    this.config = undefined;
    this.configProvider = this.configProvider.then((config6) => {
      return {
        ...config6,
        [key2]: value
      };
    });
  }
  httpHandlerConfigs() {
    return this.config ?? {};
  }
}
var init_node_http_handler = __esm2(() => {
  init_dist_es();
  init_dist_es17();
  init_constants4();
  init_get_transformed_headers();
  init_write_request_body();
});
var init_node_http2_connection_pool = () => {
};
var init_node_http2_connection_manager = __esm2(() => {
  init_node_http2_connection_pool();
});
var init_node_http2_handler = __esm2(() => {
  init_dist_es();
  init_dist_es17();
  init_get_transformed_headers();
  init_node_http2_connection_manager();
  init_write_request_body();
});
var Collector;
var init_collector = __esm2(() => {
  Collector = class Collector2 extends Writable {
    constructor() {
      super(...arguments);
      this.bufferedBytes = [];
    }
    _write(chunk, encoding, callback) {
      this.bufferedBytes.push(chunk);
      callback();
    }
  };
});
async function collectReadableStream(stream2) {
  const chunks = [];
  const reader = stream2.getReader();
  let isDone = false;
  let length = 0;
  while (!isDone) {
    const { done, value } = await reader.read();
    if (value) {
      chunks.push(value);
      length += value.length;
    }
    isDone = done;
  }
  const collected = new Uint8Array(length);
  let offset2 = 0;
  for (const chunk of chunks) {
    collected.set(chunk, offset2);
    offset2 += chunk.length;
  }
  return collected;
}
var streamCollector = (stream2) => {
  if (isReadableStreamInstance(stream2)) {
    return collectReadableStream(stream2);
  }
  return new Promise((resolve5, reject) => {
    const collector = new Collector;
    stream2.pipe(collector);
    stream2.on("error", (err22) => {
      collector.end();
      reject(err22);
    });
    collector.on("error", reject);
    collector.on("finish", function() {
      const bytes = new Uint8Array(Buffer.concat(this.bufferedBytes));
      resolve5(bytes);
    });
  });
};
var isReadableStreamInstance = (stream2) => typeof ReadableStream === "function" && stream2 instanceof ReadableStream;
var init_stream_collector = __esm2(() => {
  init_collector();
});
var init_dist_es18 = __esm2(() => {
  init_node_http_handler();
  init_node_http2_handler();
  init_stream_collector();
});
var isReadableStream2 = (stream2) => typeof ReadableStream === "function" && (stream2?.constructor?.name === ReadableStream.name || stream2 instanceof ReadableStream);
var import_fetch_http_handler;
var import_util_hex_encoding5;
var ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED = "The stream has already been transformed.";
var sdkStreamMixin2 = (stream2) => {
  if (!isBlobInstance(stream2) && !isReadableStream2(stream2)) {
    const name = stream2?.__proto__?.constructor?.name || stream2;
    throw new Error(`Unexpected stream implementation, expect Blob or ReadableStream, got ${name}`);
  }
  let transformed = false;
  const transformToByteArray = async () => {
    if (transformed) {
      throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED);
    }
    transformed = true;
    return await import_fetch_http_handler.streamCollector(stream2);
  };
  const blobToWebStream = (blob) => {
    if (typeof blob.stream !== "function") {
      throw new Error("Cannot transform payload Blob to web stream. Please make sure the Blob.stream() is polyfilled.\nIf you are using React Native, this API is not yet supported, see: https://react-native.canny.io/feature-requests/p/fetch-streaming-body");
    }
    return blob.stream();
  };
  return Object.assign(stream2, {
    transformToByteArray,
    transformToString: async (encoding) => {
      const buf = await transformToByteArray();
      if (encoding === "base64") {
        return toBase643(buf);
      } else if (encoding === "hex") {
        return import_util_hex_encoding5.toHex(buf);
      } else if (encoding === undefined || encoding === "utf8" || encoding === "utf-8") {
        return toUtf82(buf);
      } else if (typeof TextDecoder === "function") {
        return new TextDecoder(encoding).decode(buf);
      } else {
        throw new Error("TextDecoder is not available, please make sure polyfill is provided.");
      }
    },
    transformToWebStream: () => {
      if (transformed) {
        throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED);
      }
      transformed = true;
      if (isBlobInstance(stream2)) {
        return blobToWebStream(stream2);
      } else if (isReadableStream2(stream2)) {
        return stream2;
      } else {
        throw new Error(`Cannot transform payload to web stream, got ${stream2}`);
      }
    }
  });
};
var isBlobInstance = (stream2) => typeof Blob === "function" && stream2 instanceof Blob;
var init_sdk_stream_mixin_browser = __esm2(() => {
  import_fetch_http_handler = __toESM3(require_dist_cjs12(), 1);
  init_dist_es16();
  import_util_hex_encoding5 = __toESM3(require_dist_cjs13(), 1);
  init_dist_es6();
});
var ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED2 = "The stream has already been transformed.";
var sdkStreamMixin3 = (stream2) => {
  if (!(stream2 instanceof Readable3)) {
    try {
      return sdkStreamMixin2(stream2);
    } catch (e) {
      const name = stream2?.__proto__?.constructor?.name || stream2;
      throw new Error(`Unexpected stream implementation, expect Stream.Readable instance, got ${name}`);
    }
  }
  let transformed = false;
  const transformToByteArray = async () => {
    if (transformed) {
      throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED2);
    }
    transformed = true;
    return await streamCollector(stream2);
  };
  return Object.assign(stream2, {
    transformToByteArray,
    transformToString: async (encoding) => {
      const buf = await transformToByteArray();
      if (encoding === undefined || Buffer.isEncoding(encoding)) {
        return fromArrayBuffer2(buf.buffer, buf.byteOffset, buf.byteLength).toString(encoding);
      } else {
        const decoder = new TextDecoder2(encoding);
        return decoder.decode(buf);
      }
    },
    transformToWebStream: () => {
      if (transformed) {
        throw new Error(ERR_MSG_STREAM_HAS_BEEN_TRANSFORMED2);
      }
      if (stream2.readableFlowing !== null) {
        throw new Error("The stream has been consumed by other callbacks.");
      }
      if (typeof Readable3.toWeb !== "function") {
        throw new Error("Readable.toWeb() is not supported. Please make sure you are using Node.js >= 17.0.0, or polyfill is available.");
      }
      transformed = true;
      return Readable3.toWeb(stream2);
    }
  });
};
var init_sdk_stream_mixin = __esm2(() => {
  init_dist_es18();
  init_dist_es5();
  init_sdk_stream_mixin_browser();
});
async function splitStream2(stream2) {
  if (typeof stream2.stream === "function") {
    stream2 = stream2.stream();
  }
  const readableStream = stream2;
  return readableStream.tee();
}
async function splitStream3(stream2) {
  if (isReadableStream2(stream2)) {
    return splitStream2(stream2);
  }
  const stream1 = new PassThrough;
  const stream22 = new PassThrough;
  stream2.pipe(stream1);
  stream2.pipe(stream22);
  return [stream1, stream22];
}
var init_splitStream = () => {
};
async function headStream2(stream2, bytes) {
  let byteLengthCounter = 0;
  const chunks = [];
  const reader = stream2.getReader();
  let isDone = false;
  while (!isDone) {
    const { done, value } = await reader.read();
    if (value) {
      chunks.push(value);
      byteLengthCounter += value?.byteLength ?? 0;
    }
    if (byteLengthCounter >= bytes) {
      break;
    }
    isDone = done;
  }
  reader.releaseLock();
  const collected = new Uint8Array(Math.min(bytes, byteLengthCounter));
  let offset2 = 0;
  for (const chunk of chunks) {
    if (chunk.byteLength > collected.byteLength - offset2) {
      collected.set(chunk.subarray(0, collected.byteLength - offset2), offset2);
      break;
    } else {
      collected.set(chunk, offset2);
    }
    offset2 += chunk.length;
  }
  return collected;
}
var headStream3 = (stream2, bytes) => {
  if (isReadableStream2(stream2)) {
    return headStream2(stream2, bytes);
  }
  return new Promise((resolve5, reject) => {
    const collector = new Collector2;
    collector.limit = bytes;
    stream2.pipe(collector);
    stream2.on("error", (err22) => {
      collector.end();
      reject(err22);
    });
    collector.on("error", reject);
    collector.on("finish", function() {
      const bytes2 = new Uint8Array(Buffer.concat(this.buffers));
      resolve5(bytes2);
    });
  });
};
var Collector2;
var init_headStream = __esm2(() => {
  Collector2 = class Collector22 extends Writable2 {
    constructor() {
      super(...arguments);
      this.buffers = [];
      this.limit = Infinity;
      this.bytesBuffered = 0;
    }
    _write(chunk, encoding, callback) {
      this.buffers.push(chunk);
      this.bytesBuffered += chunk.byteLength ?? 0;
      if (this.bytesBuffered >= this.limit) {
        const excess = this.bytesBuffered - this.limit;
        const tailBuffer = this.buffers[this.buffers.length - 1];
        this.buffers[this.buffers.length - 1] = tailBuffer.subarray(0, tailBuffer.byteLength - excess);
        this.emit("finish");
      }
      callback();
    }
  };
});
var init_ChecksumStream = __esm2(() => {
  init_dist_es16();
});
var init_ChecksumStream_browser = () => {
};
var init_createChecksumStream_browser = __esm2(() => {
  init_dist_es16();
  init_ChecksumStream_browser();
});
var init_createChecksumStream = __esm2(() => {
  init_ChecksumStream();
  init_createChecksumStream_browser();
});
var init_dist_es19 = __esm2(() => {
  init_Uint8ArrayBlobAdapter();
  init_getAwsChunkedEncodingStream();
  init_sdk_stream_mixin();
  init_splitStream();
  init_headStream();
  init_createChecksumStream();
  init_ChecksumStream();
});
var THROW_IF_EMPTY_BODY;
var MAX_BYTES_TO_INSPECT = 3000;
var throw200ExceptionsMiddleware = (config6) => (next, context) => async (args) => {
  const result2 = await next(args);
  const { response } = result2;
  if (!HttpResponse.isInstance(response)) {
    return result2;
  }
  const { statusCode, body: sourceBody } = response;
  if (statusCode < 200 || statusCode >= 300) {
    return result2;
  }
  const isSplittableStream = typeof sourceBody?.stream === "function" || typeof sourceBody?.pipe === "function" || typeof sourceBody?.tee === "function";
  if (!isSplittableStream) {
    return result2;
  }
  let bodyCopy = sourceBody;
  let body = sourceBody;
  if (sourceBody && typeof sourceBody === "object" && !(sourceBody instanceof Uint8Array)) {
    [bodyCopy, body] = await splitStream3(sourceBody);
  }
  response.body = body;
  const bodyBytes = await collectBody3(bodyCopy, {
    streamCollector: async (stream2) => {
      return headStream3(stream2, MAX_BYTES_TO_INSPECT);
    }
  });
  if (typeof bodyCopy?.destroy === "function") {
    bodyCopy.destroy();
  }
  const bodyStringTail = config6.utf8Encoder(bodyBytes.subarray(bodyBytes.length - 16));
  if (bodyBytes.length === 0 && THROW_IF_EMPTY_BODY[context.commandName]) {
    const err22 = new Error("S3 aborted request");
    err22.name = "InternalError";
    throw err22;
  }
  if (bodyStringTail && bodyStringTail.endsWith("</Error>")) {
    response.statusCode = 400;
  }
  return result2;
};
var collectBody3 = (streamBody = new Uint8Array, context) => {
  if (streamBody instanceof Uint8Array) {
    return Promise.resolve(streamBody);
  }
  return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array);
};
var throw200ExceptionsMiddlewareOptions;
var getThrow200ExceptionsPlugin = (config6) => ({
  applyToStack: (clientStack) => {
    clientStack.addRelativeTo(throw200ExceptionsMiddleware(config6), throw200ExceptionsMiddlewareOptions);
  }
});
var init_throw_200_exceptions = __esm2(() => {
  init_dist_es();
  init_dist_es19();
  THROW_IF_EMPTY_BODY = {
    CopyObjectCommand: true,
    UploadPartCopyCommand: true,
    CompleteMultipartUploadCommand: true
  };
  throw200ExceptionsMiddlewareOptions = {
    relation: "after",
    toMiddleware: "deserializerMiddleware",
    tags: ["THROW_200_EXCEPTIONS", "S3"],
    name: "throw200ExceptionsMiddleware",
    override: true
  };
});
var validate2 = (str2) => typeof str2 === "string" && str2.indexOf("arn:") === 0 && str2.split(":").length >= 6;
function bucketEndpointMiddleware(options3) {
  return (next, context) => async (args) => {
    if (options3.bucketEndpoint) {
      const endpoint = context.endpointV2;
      if (endpoint) {
        const bucket = args.input.Bucket;
        if (typeof bucket === "string") {
          try {
            const bucketEndpointUrl = new URL(bucket);
            context.endpointV2 = {
              ...endpoint,
              url: bucketEndpointUrl
            };
          } catch (e) {
            const warning = `@aws-sdk/middleware-sdk-s3: bucketEndpoint=true was set but Bucket=${bucket} could not be parsed as URL.`;
            if (context.logger?.constructor?.name === "NoOpLogger") {
              console.warn(warning);
            } else {
              context.logger?.warn?.(warning);
            }
            throw e;
          }
        }
      }
    }
    return next(args);
  };
}
var bucketEndpointMiddlewareOptions;
var init_bucket_endpoint_middleware = __esm2(() => {
  bucketEndpointMiddlewareOptions = {
    name: "bucketEndpointMiddleware",
    override: true,
    relation: "after",
    toMiddleware: "endpointV2Middleware"
  };
});
function validateBucketNameMiddleware({ bucketEndpoint }) {
  return (next) => async (args) => {
    const { input: { Bucket } } = args;
    if (!bucketEndpoint && typeof Bucket === "string" && !validate2(Bucket) && Bucket.indexOf("/") >= 0) {
      const err22 = new Error(`Bucket name shouldn't contain '/', received '${Bucket}'`);
      err22.name = "InvalidBucketName";
      throw err22;
    }
    return next({ ...args });
  };
}
var validateBucketNameMiddlewareOptions;
var getValidateBucketNamePlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(validateBucketNameMiddleware(options3), validateBucketNameMiddlewareOptions);
    clientStack.addRelativeTo(bucketEndpointMiddleware(options3), bucketEndpointMiddlewareOptions);
  }
});
var init_validate_bucket_name = __esm2(() => {
  init_bucket_endpoint_middleware();
  validateBucketNameMiddlewareOptions = {
    step: "initialize",
    tags: ["VALIDATE_BUCKET_NAME"],
    name: "validateBucketNameMiddleware",
    override: true
  };
});
var init_dist_es20 = __esm2(() => {
  init_check_content_length_header();
  init_region_redirect_endpoint_middleware();
  init_region_redirect_middleware();
  init_s3_expires_middleware();
  init_s3_express();
  init_s3Configuration();
  init_throw_200_exceptions();
  init_validate_bucket_name();
});
function isValidUserAgentAppId(appId) {
  if (appId === undefined) {
    return true;
  }
  return typeof appId === "string" && appId.length <= 50;
}
function resolveUserAgentConfig(input) {
  const normalizedAppIdProvider = import_core7.normalizeProvider(input.userAgentAppId ?? DEFAULT_UA_APP_ID);
  return {
    ...input,
    customUserAgent: typeof input.customUserAgent === "string" ? [[input.customUserAgent]] : input.customUserAgent,
    userAgentAppId: async () => {
      const appId = await normalizedAppIdProvider();
      if (!isValidUserAgentAppId(appId)) {
        const logger3 = input.logger?.constructor?.name === "NoOpLogger" || !input.logger ? console : input.logger;
        if (typeof appId !== "string") {
          logger3?.warn("userAgentAppId must be a string or undefined.");
        } else if (appId.length > 50) {
          logger3?.warn("The provided userAgentAppId exceeds the maximum length of 50 characters.");
        }
      }
      return appId;
    }
  };
}
var import_core7;
var DEFAULT_UA_APP_ID = undefined;
var init_configurations = __esm2(() => {
  import_core7 = __toESM3(require_dist_cjs15(), 1);
});

class EndpointCache {
  constructor({ size, params }) {
    this.data = new Map;
    this.parameters = [];
    this.capacity = size ?? 50;
    if (params) {
      this.parameters = params;
    }
  }
  get(endpointParams, resolver2) {
    const key2 = this.hash(endpointParams);
    if (key2 === false) {
      return resolver2();
    }
    if (!this.data.has(key2)) {
      if (this.data.size > this.capacity + 10) {
        const keys2 = this.data.keys();
        let i2 = 0;
        while (true) {
          const { value, done } = keys2.next();
          this.data.delete(value);
          if (done || ++i2 > 10) {
            break;
          }
        }
      }
      this.data.set(key2, resolver2());
    }
    return this.data.get(key2);
  }
  size() {
    return this.data.size;
  }
  hash(endpointParams) {
    let buffer = "";
    const { parameters } = this;
    if (parameters.length === 0) {
      return false;
    }
    for (const param of parameters) {
      const val2 = String(endpointParams[param] ?? "");
      if (val2.includes("|;")) {
        return false;
      }
      buffer += val2 + "|;";
    }
    return buffer;
  }
}
var IP_V4_REGEX;
var isIpAddress = (value) => IP_V4_REGEX.test(value) || value.startsWith("[") && value.endsWith("]");
var init_isIpAddress = __esm2(() => {
  IP_V4_REGEX = new RegExp(`^(?:25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]\\d|\\d)(?:\\.(?:25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]\\d|\\d)){3}$`);
});
var VALID_HOST_LABEL_REGEX;
var isValidHostLabel = (value, allowSubDomains = false) => {
  if (!allowSubDomains) {
    return VALID_HOST_LABEL_REGEX.test(value);
  }
  const labels = value.split(".");
  for (const label of labels) {
    if (!isValidHostLabel(label)) {
      return false;
    }
  }
  return true;
};
var init_isValidHostLabel = __esm2(() => {
  VALID_HOST_LABEL_REGEX = new RegExp(`^(?!.*-$)(?!-)[a-zA-Z0-9-]{1,63}$`);
});
var customEndpointFunctions;
var init_customEndpointFunctions = __esm2(() => {
  customEndpointFunctions = {};
});
var debugId = "endpoints";
function toDebugString(input) {
  if (typeof input !== "object" || input == null) {
    return input;
  }
  if ("ref" in input) {
    return `$${toDebugString(input.ref)}`;
  }
  if ("fn" in input) {
    return `${input.fn}(${(input.argv || []).map(toDebugString).join(", ")})`;
  }
  return JSON.stringify(input, null, 2);
}
var init_debug = () => {
};
var EndpointError;
var init_EndpointError = __esm2(() => {
  EndpointError = class EndpointError2 extends Error {
    constructor(message) {
      super(message);
      this.name = "EndpointError";
    }
  };
});
var init_EndpointFunctions = () => {
};
var init_EndpointRuleObject = () => {
};
var init_ErrorRuleObject = () => {
};
var init_RuleSetObject = () => {
};
var init_TreeRuleObject = () => {
};
var init_shared = () => {
};
var init_types7 = __esm2(() => {
  init_EndpointError();
  init_EndpointFunctions();
  init_EndpointRuleObject();
  init_ErrorRuleObject();
  init_RuleSetObject();
  init_TreeRuleObject();
  init_shared();
});
var booleanEquals = (value1, value2) => value1 === value2;
var getAttrPathList = (path5) => {
  const parts = path5.split(".");
  const pathList = [];
  for (const part of parts) {
    const squareBracketIndex = part.indexOf("[");
    if (squareBracketIndex !== -1) {
      if (part.indexOf("]") !== part.length - 1) {
        throw new EndpointError(`Path: '${path5}' does not end with ']'`);
      }
      const arrayIndex = part.slice(squareBracketIndex + 1, -1);
      if (Number.isNaN(parseInt(arrayIndex))) {
        throw new EndpointError(`Invalid array index: '${arrayIndex}' in path: '${path5}'`);
      }
      if (squareBracketIndex !== 0) {
        pathList.push(part.slice(0, squareBracketIndex));
      }
      pathList.push(arrayIndex);
    } else {
      pathList.push(part);
    }
  }
  return pathList;
};
var init_getAttrPathList = __esm2(() => {
  init_types7();
});
var getAttr = (value, path5) => getAttrPathList(path5).reduce((acc, index) => {
  if (typeof acc !== "object") {
    throw new EndpointError(`Index '${index}' in '${path5}' not found in '${JSON.stringify(value)}'`);
  } else if (Array.isArray(acc)) {
    return acc[parseInt(index)];
  }
  return acc[index];
}, value);
var init_getAttr = __esm2(() => {
  init_types7();
  init_getAttrPathList();
});
var isSet = (value) => value != null;
var not = (value) => !value;
var import_types16;
var DEFAULT_PORTS;
var parseURL = (value) => {
  const whatwgURL = (() => {
    try {
      if (value instanceof URL) {
        return value;
      }
      if (typeof value === "object" && "hostname" in value) {
        const { hostname: hostname2, port, protocol: protocol2 = "", path: path5 = "", query = {} } = value;
        const url = new URL(`${protocol2}//${hostname2}${port ? `:${port}` : ""}${path5}`);
        url.search = Object.entries(query).map(([k, v22]) => `${k}=${v22}`).join("&");
        return url;
      }
      return new URL(value);
    } catch (error) {
      return null;
    }
  })();
  if (!whatwgURL) {
    console.error(`Unable to parse ${JSON.stringify(value)} as a whatwg URL.`);
    return null;
  }
  const urlString = whatwgURL.href;
  const { host, hostname, pathname, protocol, search } = whatwgURL;
  if (search) {
    return null;
  }
  const scheme = protocol.slice(0, -1);
  if (!Object.values(import_types16.EndpointURLScheme).includes(scheme)) {
    return null;
  }
  const isIp = isIpAddress(hostname);
  const inputContainsDefaultPort = urlString.includes(`${host}:${DEFAULT_PORTS[scheme]}`) || typeof value === "string" && value.includes(`${host}:${DEFAULT_PORTS[scheme]}`);
  const authority = `${host}${inputContainsDefaultPort ? `:${DEFAULT_PORTS[scheme]}` : ``}`;
  return {
    scheme,
    authority,
    path: pathname,
    normalizedPath: pathname.endsWith("/") ? pathname : `${pathname}/`,
    isIp
  };
};
var init_parseURL = __esm2(() => {
  import_types16 = __toESM3(require_dist_cjs(), 1);
  init_isIpAddress();
  DEFAULT_PORTS = {
    [import_types16.EndpointURLScheme.HTTP]: 80,
    [import_types16.EndpointURLScheme.HTTPS]: 443
  };
});
var stringEquals = (value1, value2) => value1 === value2;
var substring = (input, start, stop, reverse) => {
  if (start >= stop || input.length < stop) {
    return null;
  }
  if (!reverse) {
    return input.substring(start, stop);
  }
  return input.substring(input.length - stop, input.length - start);
};
var uriEncode = (value) => encodeURIComponent(value).replace(/[!*'()]/g, (c22) => `%${c22.charCodeAt(0).toString(16).toUpperCase()}`);
var init_lib = __esm2(() => {
  init_getAttr();
  init_isValidHostLabel();
  init_parseURL();
});
var endpointFunctions;
var init_endpointFunctions = __esm2(() => {
  init_lib();
  endpointFunctions = {
    booleanEquals,
    getAttr,
    isSet,
    isValidHostLabel,
    not,
    parseURL,
    stringEquals,
    substring,
    uriEncode
  };
});
var evaluateTemplate = (template2, options3) => {
  const evaluatedTemplateArr = [];
  const templateContext = {
    ...options3.endpointParams,
    ...options3.referenceRecord
  };
  let currentIndex = 0;
  while (currentIndex < template2.length) {
    const openingBraceIndex = template2.indexOf("{", currentIndex);
    if (openingBraceIndex === -1) {
      evaluatedTemplateArr.push(template2.slice(currentIndex));
      break;
    }
    evaluatedTemplateArr.push(template2.slice(currentIndex, openingBraceIndex));
    const closingBraceIndex = template2.indexOf("}", openingBraceIndex);
    if (closingBraceIndex === -1) {
      evaluatedTemplateArr.push(template2.slice(openingBraceIndex));
      break;
    }
    if (template2[openingBraceIndex + 1] === "{" && template2[closingBraceIndex + 1] === "}") {
      evaluatedTemplateArr.push(template2.slice(openingBraceIndex + 1, closingBraceIndex));
      currentIndex = closingBraceIndex + 2;
    }
    const parameterName = template2.substring(openingBraceIndex + 1, closingBraceIndex);
    if (parameterName.includes("#")) {
      const [refName, attrName] = parameterName.split("#");
      evaluatedTemplateArr.push(getAttr(templateContext[refName], attrName));
    } else {
      evaluatedTemplateArr.push(templateContext[parameterName]);
    }
    currentIndex = closingBraceIndex + 1;
  }
  return evaluatedTemplateArr.join("");
};
var init_evaluateTemplate = __esm2(() => {
  init_lib();
});
var getReferenceValue = ({ ref: ref2 }, options3) => {
  const referenceRecord = {
    ...options3.endpointParams,
    ...options3.referenceRecord
  };
  return referenceRecord[ref2];
};
var evaluateExpression = (obj, keyName, options3) => {
  if (typeof obj === "string") {
    return evaluateTemplate(obj, options3);
  } else if (obj["fn"]) {
    return callFunction(obj, options3);
  } else if (obj["ref"]) {
    return getReferenceValue(obj, options3);
  }
  throw new EndpointError(`'${keyName}': ${String(obj)} is not a string, function or reference.`);
};
var init_evaluateExpression = __esm2(() => {
  init_types7();
  init_callFunction();
  init_evaluateTemplate();
});
var callFunction = ({ fn, argv: argv3 }, options3) => {
  const evaluatedArgs = argv3.map((arg) => ["boolean", "number"].includes(typeof arg) ? arg : evaluateExpression(arg, "arg", options3));
  const fnSegments = fn.split(".");
  if (fnSegments[0] in customEndpointFunctions && fnSegments[1] != null) {
    return customEndpointFunctions[fnSegments[0]][fnSegments[1]](...evaluatedArgs);
  }
  return endpointFunctions[fn](...evaluatedArgs);
};
var init_callFunction = __esm2(() => {
  init_customEndpointFunctions();
  init_endpointFunctions();
  init_evaluateExpression();
});
var evaluateCondition = ({ assign, ...fnArgs }, options3) => {
  if (assign && assign in options3.referenceRecord) {
    throw new EndpointError(`'${assign}' is already defined in Reference Record.`);
  }
  const value = callFunction(fnArgs, options3);
  options3.logger?.debug?.(`${debugId} evaluateCondition: ${toDebugString(fnArgs)} = ${toDebugString(value)}`);
  return {
    result: value === "" ? true : !!value,
    ...assign != null && { toAssign: { name: assign, value } }
  };
};
var init_evaluateCondition = __esm2(() => {
  init_debug();
  init_types7();
  init_callFunction();
});
var evaluateConditions = (conditions = [], options3) => {
  const conditionsReferenceRecord = {};
  for (const condition of conditions) {
    const { result: result2, toAssign } = evaluateCondition(condition, {
      ...options3,
      referenceRecord: {
        ...options3.referenceRecord,
        ...conditionsReferenceRecord
      }
    });
    if (!result2) {
      return { result: result2 };
    }
    if (toAssign) {
      conditionsReferenceRecord[toAssign.name] = toAssign.value;
      options3.logger?.debug?.(`${debugId} assign: ${toAssign.name} := ${toDebugString(toAssign.value)}`);
    }
  }
  return { result: true, referenceRecord: conditionsReferenceRecord };
};
var init_evaluateConditions = __esm2(() => {
  init_debug();
  init_evaluateCondition();
});
var getEndpointHeaders = (headers, options3) => Object.entries(headers).reduce((acc, [headerKey, headerVal]) => ({
  ...acc,
  [headerKey]: headerVal.map((headerValEntry) => {
    const processedExpr = evaluateExpression(headerValEntry, "Header value entry", options3);
    if (typeof processedExpr !== "string") {
      throw new EndpointError(`Header '${headerKey}' value '${processedExpr}' is not a string`);
    }
    return processedExpr;
  })
}), {});
var init_getEndpointHeaders = __esm2(() => {
  init_types7();
  init_evaluateExpression();
});
var getEndpointProperty = (property, options3) => {
  if (Array.isArray(property)) {
    return property.map((propertyEntry) => getEndpointProperty(propertyEntry, options3));
  }
  switch (typeof property) {
    case "string":
      return evaluateTemplate(property, options3);
    case "object":
      if (property === null) {
        throw new EndpointError(`Unexpected endpoint property: ${property}`);
      }
      return getEndpointProperties(property, options3);
    case "boolean":
      return property;
    default:
      throw new EndpointError(`Unexpected endpoint property type: ${typeof property}`);
  }
};
var init_getEndpointProperty = __esm2(() => {
  init_types7();
  init_evaluateTemplate();
  init_getEndpointProperties();
});
var getEndpointProperties = (properties, options3) => Object.entries(properties).reduce((acc, [propertyKey, propertyVal]) => ({
  ...acc,
  [propertyKey]: getEndpointProperty(propertyVal, options3)
}), {});
var init_getEndpointProperties = __esm2(() => {
  init_getEndpointProperty();
});
var getEndpointUrl = (endpointUrl, options3) => {
  const expression2 = evaluateExpression(endpointUrl, "Endpoint URL", options3);
  if (typeof expression2 === "string") {
    try {
      return new URL(expression2);
    } catch (error) {
      console.error(`Failed to construct URL with ${expression2}`, error);
      throw error;
    }
  }
  throw new EndpointError(`Endpoint URL must be a string, got ${typeof expression2}`);
};
var init_getEndpointUrl = __esm2(() => {
  init_types7();
  init_evaluateExpression();
});
var evaluateEndpointRule = (endpointRule, options3) => {
  const { conditions, endpoint } = endpointRule;
  const { result: result2, referenceRecord } = evaluateConditions(conditions, options3);
  if (!result2) {
    return;
  }
  const endpointRuleOptions = {
    ...options3,
    referenceRecord: { ...options3.referenceRecord, ...referenceRecord }
  };
  const { url, properties, headers } = endpoint;
  options3.logger?.debug?.(`${debugId} Resolving endpoint from template: ${toDebugString(endpoint)}`);
  return {
    ...headers != null && {
      headers: getEndpointHeaders(headers, endpointRuleOptions)
    },
    ...properties != null && {
      properties: getEndpointProperties(properties, endpointRuleOptions)
    },
    url: getEndpointUrl(url, endpointRuleOptions)
  };
};
var init_evaluateEndpointRule = __esm2(() => {
  init_debug();
  init_evaluateConditions();
  init_getEndpointHeaders();
  init_getEndpointProperties();
  init_getEndpointUrl();
});
var evaluateErrorRule = (errorRule, options3) => {
  const { conditions, error } = errorRule;
  const { result: result2, referenceRecord } = evaluateConditions(conditions, options3);
  if (!result2) {
    return;
  }
  throw new EndpointError(evaluateExpression(error, "Error", {
    ...options3,
    referenceRecord: { ...options3.referenceRecord, ...referenceRecord }
  }));
};
var init_evaluateErrorRule = __esm2(() => {
  init_types7();
  init_evaluateConditions();
  init_evaluateExpression();
});
var evaluateTreeRule = (treeRule, options3) => {
  const { conditions, rules: rules2 } = treeRule;
  const { result: result2, referenceRecord } = evaluateConditions(conditions, options3);
  if (!result2) {
    return;
  }
  return evaluateRules(rules2, {
    ...options3,
    referenceRecord: { ...options3.referenceRecord, ...referenceRecord }
  });
};
var init_evaluateTreeRule = __esm2(() => {
  init_evaluateConditions();
  init_evaluateRules();
});
var evaluateRules = (rules2, options3) => {
  for (const rule of rules2) {
    if (rule.type === "endpoint") {
      const endpointOrUndefined = evaluateEndpointRule(rule, options3);
      if (endpointOrUndefined) {
        return endpointOrUndefined;
      }
    } else if (rule.type === "error") {
      evaluateErrorRule(rule, options3);
    } else if (rule.type === "tree") {
      const endpointOrUndefined = evaluateTreeRule(rule, options3);
      if (endpointOrUndefined) {
        return endpointOrUndefined;
      }
    } else {
      throw new EndpointError(`Unknown endpoint rule: ${rule}`);
    }
  }
  throw new EndpointError(`Rules evaluation failed`);
};
var init_evaluateRules = __esm2(() => {
  init_types7();
  init_evaluateEndpointRule();
  init_evaluateErrorRule();
  init_evaluateTreeRule();
});
var init_utils12 = __esm2(() => {
  init_customEndpointFunctions();
  init_evaluateRules();
});
var resolveEndpoint = (ruleSetObject, options3) => {
  const { endpointParams, logger: logger3 } = options3;
  const { parameters, rules: rules2 } = ruleSetObject;
  options3.logger?.debug?.(`${debugId} Initial EndpointParams: ${toDebugString(endpointParams)}`);
  const paramsWithDefault = Object.entries(parameters).filter(([, v22]) => v22.default != null).map(([k, v22]) => [k, v22.default]);
  if (paramsWithDefault.length > 0) {
    for (const [paramKey, paramDefaultValue] of paramsWithDefault) {
      endpointParams[paramKey] = endpointParams[paramKey] ?? paramDefaultValue;
    }
  }
  const requiredParams = Object.entries(parameters).filter(([, v22]) => v22.required).map(([k]) => k);
  for (const requiredParam of requiredParams) {
    if (endpointParams[requiredParam] == null) {
      throw new EndpointError(`Missing required parameter: '${requiredParam}'`);
    }
  }
  const endpoint = evaluateRules(rules2, { endpointParams, logger: logger3, referenceRecord: {} });
  options3.logger?.debug?.(`${debugId} Resolved endpoint: ${toDebugString(endpoint)}`);
  return endpoint;
};
var init_resolveEndpoint = __esm2(() => {
  init_debug();
  init_types7();
  init_utils12();
});
var init_dist_es21 = __esm2(() => {
  init_isIpAddress();
  init_isValidHostLabel();
  init_customEndpointFunctions();
  init_resolveEndpoint();
  init_types7();
});
var init_isIpAddress2 = __esm2(() => {
  init_dist_es21();
});
var isVirtualHostableS3Bucket = (value, allowSubDomains = false) => {
  if (allowSubDomains) {
    for (const label of value.split(".")) {
      if (!isVirtualHostableS3Bucket(label)) {
        return false;
      }
    }
    return true;
  }
  if (!isValidHostLabel(value)) {
    return false;
  }
  if (value.length < 3 || value.length > 63) {
    return false;
  }
  if (value !== value.toLowerCase()) {
    return false;
  }
  if (isIpAddress(value)) {
    return false;
  }
  return true;
};
var init_isVirtualHostableS3Bucket = __esm2(() => {
  init_dist_es21();
  init_isIpAddress2();
});
var ARN_DELIMITER = ":";
var RESOURCE_DELIMITER = "/";
var parseArn = (value) => {
  const segments = value.split(ARN_DELIMITER);
  if (segments.length < 6)
    return null;
  const [arn, partition2, service, region, accountId, ...resourcePath] = segments;
  if (arn !== "arn" || partition2 === "" || service === "" || resourcePath.join(ARN_DELIMITER) === "")
    return null;
  const resourceId = resourcePath.map((resource) => resource.split(RESOURCE_DELIMITER)).flat();
  return {
    partition: partition2,
    service,
    region,
    accountId,
    resourceId
  };
};
var partitions_default;
var init_partitions = __esm2(() => {
  partitions_default = {
    partitions: [{
      id: "aws",
      outputs: {
        dnsSuffix: "amazonaws.com",
        dualStackDnsSuffix: "api.aws",
        implicitGlobalRegion: "us-east-1",
        name: "aws",
        supportsDualStack: true,
        supportsFIPS: true
      },
      regionRegex: "^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$",
      regions: {
        "af-south-1": {
          description: "Africa (Cape Town)"
        },
        "ap-east-1": {
          description: "Asia Pacific (Hong Kong)"
        },
        "ap-northeast-1": {
          description: "Asia Pacific (Tokyo)"
        },
        "ap-northeast-2": {
          description: "Asia Pacific (Seoul)"
        },
        "ap-northeast-3": {
          description: "Asia Pacific (Osaka)"
        },
        "ap-south-1": {
          description: "Asia Pacific (Mumbai)"
        },
        "ap-south-2": {
          description: "Asia Pacific (Hyderabad)"
        },
        "ap-southeast-1": {
          description: "Asia Pacific (Singapore)"
        },
        "ap-southeast-2": {
          description: "Asia Pacific (Sydney)"
        },
        "ap-southeast-3": {
          description: "Asia Pacific (Jakarta)"
        },
        "ap-southeast-4": {
          description: "Asia Pacific (Melbourne)"
        },
        "ap-southeast-5": {
          description: "Asia Pacific (Malaysia)"
        },
        "aws-global": {
          description: "AWS Standard global region"
        },
        "ca-central-1": {
          description: "Canada (Central)"
        },
        "ca-west-1": {
          description: "Canada West (Calgary)"
        },
        "eu-central-1": {
          description: "Europe (Frankfurt)"
        },
        "eu-central-2": {
          description: "Europe (Zurich)"
        },
        "eu-north-1": {
          description: "Europe (Stockholm)"
        },
        "eu-south-1": {
          description: "Europe (Milan)"
        },
        "eu-south-2": {
          description: "Europe (Spain)"
        },
        "eu-west-1": {
          description: "Europe (Ireland)"
        },
        "eu-west-2": {
          description: "Europe (London)"
        },
        "eu-west-3": {
          description: "Europe (Paris)"
        },
        "il-central-1": {
          description: "Israel (Tel Aviv)"
        },
        "me-central-1": {
          description: "Middle East (UAE)"
        },
        "me-south-1": {
          description: "Middle East (Bahrain)"
        },
        "sa-east-1": {
          description: "South America (Sao Paulo)"
        },
        "us-east-1": {
          description: "US East (N. Virginia)"
        },
        "us-east-2": {
          description: "US East (Ohio)"
        },
        "us-west-1": {
          description: "US West (N. California)"
        },
        "us-west-2": {
          description: "US West (Oregon)"
        }
      }
    }, {
      id: "aws-cn",
      outputs: {
        dnsSuffix: "amazonaws.com.cn",
        dualStackDnsSuffix: "api.amazonwebservices.com.cn",
        implicitGlobalRegion: "cn-northwest-1",
        name: "aws-cn",
        supportsDualStack: true,
        supportsFIPS: true
      },
      regionRegex: "^cn\\-\\w+\\-\\d+$",
      regions: {
        "aws-cn-global": {
          description: "AWS China global region"
        },
        "cn-north-1": {
          description: "China (Beijing)"
        },
        "cn-northwest-1": {
          description: "China (Ningxia)"
        }
      }
    }, {
      id: "aws-us-gov",
      outputs: {
        dnsSuffix: "amazonaws.com",
        dualStackDnsSuffix: "api.aws",
        implicitGlobalRegion: "us-gov-west-1",
        name: "aws-us-gov",
        supportsDualStack: true,
        supportsFIPS: true
      },
      regionRegex: "^us\\-gov\\-\\w+\\-\\d+$",
      regions: {
        "aws-us-gov-global": {
          description: "AWS GovCloud (US) global region"
        },
        "us-gov-east-1": {
          description: "AWS GovCloud (US-East)"
        },
        "us-gov-west-1": {
          description: "AWS GovCloud (US-West)"
        }
      }
    }, {
      id: "aws-iso",
      outputs: {
        dnsSuffix: "c2s.ic.gov",
        dualStackDnsSuffix: "c2s.ic.gov",
        implicitGlobalRegion: "us-iso-east-1",
        name: "aws-iso",
        supportsDualStack: false,
        supportsFIPS: true
      },
      regionRegex: "^us\\-iso\\-\\w+\\-\\d+$",
      regions: {
        "aws-iso-global": {
          description: "AWS ISO (US) global region"
        },
        "us-iso-east-1": {
          description: "US ISO East"
        },
        "us-iso-west-1": {
          description: "US ISO WEST"
        }
      }
    }, {
      id: "aws-iso-b",
      outputs: {
        dnsSuffix: "sc2s.sgov.gov",
        dualStackDnsSuffix: "sc2s.sgov.gov",
        implicitGlobalRegion: "us-isob-east-1",
        name: "aws-iso-b",
        supportsDualStack: false,
        supportsFIPS: true
      },
      regionRegex: "^us\\-isob\\-\\w+\\-\\d+$",
      regions: {
        "aws-iso-b-global": {
          description: "AWS ISOB (US) global region"
        },
        "us-isob-east-1": {
          description: "US ISOB East (Ohio)"
        }
      }
    }, {
      id: "aws-iso-e",
      outputs: {
        dnsSuffix: "cloud.adc-e.uk",
        dualStackDnsSuffix: "cloud.adc-e.uk",
        implicitGlobalRegion: "eu-isoe-west-1",
        name: "aws-iso-e",
        supportsDualStack: false,
        supportsFIPS: true
      },
      regionRegex: "^eu\\-isoe\\-\\w+\\-\\d+$",
      regions: {
        "eu-isoe-west-1": {
          description: "EU ISOE West"
        }
      }
    }, {
      id: "aws-iso-f",
      outputs: {
        dnsSuffix: "csp.hci.ic.gov",
        dualStackDnsSuffix: "csp.hci.ic.gov",
        implicitGlobalRegion: "us-isof-south-1",
        name: "aws-iso-f",
        supportsDualStack: false,
        supportsFIPS: true
      },
      regionRegex: "^us\\-isof\\-\\w+\\-\\d+$",
      regions: {}
    }],
    version: "1.1"
  };
});
var selectedPartitionsInfo;
var selectedUserAgentPrefix = "";
var partition2 = (value) => {
  const { partitions } = selectedPartitionsInfo;
  for (const partition3 of partitions) {
    const { regions, outputs } = partition3;
    for (const [region, regionData] of Object.entries(regions)) {
      if (region === value) {
        return {
          ...outputs,
          ...regionData
        };
      }
    }
  }
  for (const partition3 of partitions) {
    const { regionRegex, outputs } = partition3;
    if (new RegExp(regionRegex).test(value)) {
      return {
        ...outputs
      };
    }
  }
  const DEFAULT_PARTITION = partitions.find((partition3) => partition3.id === "aws");
  if (!DEFAULT_PARTITION) {
    throw new Error("Provided region was not found in the partition array or regex, and default partition with id 'aws' doesn't exist.");
  }
  return {
    ...DEFAULT_PARTITION.outputs
  };
};
var getUserAgentPrefix = () => selectedUserAgentPrefix;
var init_partition = __esm2(() => {
  init_partitions();
  selectedPartitionsInfo = partitions_default;
});
var awsEndpointFunctions;
var init_aws = __esm2(() => {
  init_dist_es21();
  init_isVirtualHostableS3Bucket();
  init_partition();
  awsEndpointFunctions = {
    isVirtualHostableS3Bucket,
    parseArn,
    partition: partition2
  };
  customEndpointFunctions.aws = awsEndpointFunctions;
});
var init_resolveEndpoint2 = __esm2(() => {
  init_dist_es21();
});
var init_EndpointError2 = __esm2(() => {
  init_dist_es21();
});
var init_EndpointRuleObject2 = () => {
};
var init_ErrorRuleObject2 = () => {
};
var init_RuleSetObject2 = () => {
};
var init_TreeRuleObject2 = () => {
};
var init_shared2 = () => {
};
var init_types8 = __esm2(() => {
  init_EndpointError2();
  init_EndpointRuleObject2();
  init_ErrorRuleObject2();
  init_RuleSetObject2();
  init_TreeRuleObject2();
  init_shared2();
});
var init_dist_es22 = __esm2(() => {
  init_aws();
  init_partition();
  init_isIpAddress2();
  init_resolveEndpoint2();
  init_types8();
});
async function checkFeatures(context, config6, args) {
  const request42 = args.request;
  if (request42?.headers?.["smithy-protocol"] === "rpc-v2-cbor") {
    import_core8.setFeature(context, "PROTOCOL_RPC_V2_CBOR", "M");
  }
  if (typeof config6.retryStrategy === "function") {
    const retryStrategy = await config6.retryStrategy();
    if (typeof retryStrategy.acquireInitialRetryToken === "function") {
      if (retryStrategy.constructor?.name?.includes("Adaptive")) {
        import_core8.setFeature(context, "RETRY_MODE_ADAPTIVE", "F");
      } else {
        import_core8.setFeature(context, "RETRY_MODE_STANDARD", "E");
      }
    } else {
      import_core8.setFeature(context, "RETRY_MODE_LEGACY", "D");
    }
  }
  if (typeof config6.accountIdEndpointMode === "function") {
    const endpointV2 = context.endpointV2;
    if (String(endpointV2?.url?.hostname).match(ACCOUNT_ID_ENDPOINT_REGEX)) {
      import_core8.setFeature(context, "ACCOUNT_ID_ENDPOINT", "O");
    }
    switch (await config6.accountIdEndpointMode?.()) {
      case "disabled":
        import_core8.setFeature(context, "ACCOUNT_ID_MODE_DISABLED", "Q");
        break;
      case "preferred":
        import_core8.setFeature(context, "ACCOUNT_ID_MODE_PREFERRED", "P");
        break;
      case "required":
        import_core8.setFeature(context, "ACCOUNT_ID_MODE_REQUIRED", "R");
        break;
    }
  }
  const identity2 = context.__smithy_context?.selectedHttpAuthScheme?.identity;
  if (identity2?.$source) {
    const credentials = identity2;
    if (credentials.accountId) {
      import_core8.setFeature(context, "RESOLVED_ACCOUNT_ID", "T");
    }
    for (const [key2, value] of Object.entries(credentials.$source ?? {})) {
      import_core8.setFeature(context, key2, value);
    }
  }
}
var import_core8;
var ACCOUNT_ID_ENDPOINT_REGEX;
var init_check_features = __esm2(() => {
  import_core8 = __toESM3(require_dist_cjs20(), 1);
  ACCOUNT_ID_ENDPOINT_REGEX = /\d{12}\.ddb/;
});
var USER_AGENT = "user-agent";
var X_AMZ_USER_AGENT = "x-amz-user-agent";
var SPACE = " ";
var UA_NAME_SEPARATOR = "/";
var UA_NAME_ESCAPE_REGEX;
var UA_VALUE_ESCAPE_REGEX;
var UA_ESCAPE_CHAR = "-";
var init_constants5 = __esm2(() => {
  UA_NAME_ESCAPE_REGEX = /[^\!\$\%\&\'\*\+\-\.\^\_\`\|\~\d\w]/g;
  UA_VALUE_ESCAPE_REGEX = /[^\!\$\%\&\'\*\+\-\.\^\_\`\|\~\d\w\#]/g;
});
function encodeFeatures(features) {
  let buffer = "";
  for (const key2 in features) {
    const val2 = features[key2];
    if (buffer.length + val2.length + 1 <= BYTE_LIMIT) {
      if (buffer.length) {
        buffer += "," + val2;
      } else {
        buffer += val2;
      }
      continue;
    }
    break;
  }
  return buffer;
}
var BYTE_LIMIT = 1024;
var userAgentMiddleware = (options3) => (next, context) => async (args) => {
  const { request: request42 } = args;
  if (!HttpRequest.isInstance(request42)) {
    return next(args);
  }
  const { headers } = request42;
  const userAgent = context?.userAgent?.map(escapeUserAgent) || [];
  const defaultUserAgent = (await options3.defaultUserAgentProvider()).map(escapeUserAgent);
  await checkFeatures(context, options3, args);
  const awsContext = context;
  defaultUserAgent.push(`m/${encodeFeatures(Object.assign({}, context.__smithy_context?.features, awsContext.__aws_sdk_context?.features))}`);
  const customUserAgent = options3?.customUserAgent?.map(escapeUserAgent) || [];
  const appId = await options3.userAgentAppId();
  if (appId) {
    defaultUserAgent.push(escapeUserAgent([`app/${appId}`]));
  }
  const prefix = getUserAgentPrefix();
  const sdkUserAgentValue = (prefix ? [prefix] : []).concat([...defaultUserAgent, ...userAgent, ...customUserAgent]).join(SPACE);
  const normalUAValue = [
    ...defaultUserAgent.filter((section) => section.startsWith("aws-sdk-")),
    ...customUserAgent
  ].join(SPACE);
  if (options3.runtime !== "browser") {
    if (normalUAValue) {
      headers[X_AMZ_USER_AGENT] = headers[X_AMZ_USER_AGENT] ? `${headers[USER_AGENT]} ${normalUAValue}` : normalUAValue;
    }
    headers[USER_AGENT] = sdkUserAgentValue;
  } else {
    headers[X_AMZ_USER_AGENT] = sdkUserAgentValue;
  }
  return next({
    ...args,
    request: request42
  });
};
var escapeUserAgent = (userAgentPair) => {
  const name = userAgentPair[0].split(UA_NAME_SEPARATOR).map((part) => part.replace(UA_NAME_ESCAPE_REGEX, UA_ESCAPE_CHAR)).join(UA_NAME_SEPARATOR);
  const version5 = userAgentPair[1]?.replace(UA_VALUE_ESCAPE_REGEX, UA_ESCAPE_CHAR);
  const prefixSeparatorIndex = name.indexOf(UA_NAME_SEPARATOR);
  const prefix = name.substring(0, prefixSeparatorIndex);
  let uaName = name.substring(prefixSeparatorIndex + 1);
  if (prefix === "api") {
    uaName = uaName.toLowerCase();
  }
  return [prefix, uaName, version5].filter((item) => item && item.length > 0).reduce((acc, item, index) => {
    switch (index) {
      case 0:
        return item;
      case 1:
        return `${acc}/${item}`;
      default:
        return `${acc}#${item}`;
    }
  }, "");
};
var getUserAgentMiddlewareOptions;
var getUserAgentPlugin = (config6) => ({
  applyToStack: (clientStack) => {
    clientStack.add(userAgentMiddleware(config6), getUserAgentMiddlewareOptions);
  }
});
var init_user_agent_middleware = __esm2(() => {
  init_dist_es22();
  init_dist_es();
  init_check_features();
  init_constants5();
  getUserAgentMiddlewareOptions = {
    name: "getUserAgentMiddleware",
    step: "build",
    priority: "low",
    tags: ["SET_USER_AGENT", "USER_AGENT"],
    override: true
  };
});
var init_dist_es23 = __esm2(() => {
  init_configurations();
  init_user_agent_middleware();
});
var ENV_USE_DUALSTACK_ENDPOINT = "AWS_USE_DUALSTACK_ENDPOINT";
var CONFIG_USE_DUALSTACK_ENDPOINT = "use_dualstack_endpoint";
var NODE_USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS;
var init_NodeUseDualstackEndpointConfigOptions = __esm2(() => {
  init_dist_es15();
  NODE_USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => booleanSelector(env62, ENV_USE_DUALSTACK_ENDPOINT, SelectorType2.ENV),
    configFileSelector: (profile) => booleanSelector(profile, CONFIG_USE_DUALSTACK_ENDPOINT, SelectorType2.CONFIG),
    default: false
  };
});
var ENV_USE_FIPS_ENDPOINT = "AWS_USE_FIPS_ENDPOINT";
var CONFIG_USE_FIPS_ENDPOINT = "use_fips_endpoint";
var NODE_USE_FIPS_ENDPOINT_CONFIG_OPTIONS;
var init_NodeUseFipsEndpointConfigOptions = __esm2(() => {
  init_dist_es15();
  NODE_USE_FIPS_ENDPOINT_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => booleanSelector(env62, ENV_USE_FIPS_ENDPOINT, SelectorType2.ENV),
    configFileSelector: (profile) => booleanSelector(profile, CONFIG_USE_FIPS_ENDPOINT, SelectorType2.CONFIG),
    default: false
  };
});
var import_util_middleware4;
var init_resolveCustomEndpointsConfig = __esm2(() => {
  import_util_middleware4 = __toESM3(require_dist_cjs3(), 1);
});
var import_util_middleware5;
var init_resolveEndpointsConfig = __esm2(() => {
  import_util_middleware5 = __toESM3(require_dist_cjs3(), 1);
});
var init_endpointsConfig = __esm2(() => {
  init_NodeUseDualstackEndpointConfigOptions();
  init_NodeUseFipsEndpointConfigOptions();
  init_resolveCustomEndpointsConfig();
  init_resolveEndpointsConfig();
});
var REGION_ENV_NAME = "AWS_REGION";
var REGION_INI_NAME = "region";
var NODE_REGION_CONFIG_OPTIONS;
var NODE_REGION_CONFIG_FILE_OPTIONS;
var init_config3 = __esm2(() => {
  NODE_REGION_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => env62[REGION_ENV_NAME],
    configFileSelector: (profile) => profile[REGION_INI_NAME],
    default: () => {
      throw new Error("Region is missing");
    }
  };
  NODE_REGION_CONFIG_FILE_OPTIONS = {
    preferredFile: "credentials"
  };
});
var isFipsRegion = (region) => typeof region === "string" && (region.startsWith("fips-") || region.endsWith("-fips"));
var getRealRegion = (region) => isFipsRegion(region) ? ["fips-aws-global", "aws-fips"].includes(region) ? "us-east-1" : region.replace(/fips-(dkr-|prod-)?|-fips/, "") : region;
var init_getRealRegion = () => {
};
var resolveRegionConfig = (input) => {
  const { region, useFipsEndpoint } = input;
  if (!region) {
    throw new Error("Region is missing");
  }
  return {
    ...input,
    region: async () => {
      if (typeof region === "string") {
        return getRealRegion(region);
      }
      const providedRegion = await region();
      return getRealRegion(providedRegion);
    },
    useFipsEndpoint: async () => {
      const providedRegion = typeof region === "string" ? region : await region();
      if (isFipsRegion(providedRegion)) {
        return true;
      }
      return typeof useFipsEndpoint !== "function" ? Promise.resolve(!!useFipsEndpoint) : useFipsEndpoint();
    }
  };
};
var init_resolveRegionConfig = __esm2(() => {
  init_getRealRegion();
});
var init_regionConfig = __esm2(() => {
  init_config3();
  init_resolveRegionConfig();
});
var init_PartitionHash = () => {
};
var init_RegionHash = () => {
};
var init_getRegionInfo = () => {
};
var init_regionInfo = __esm2(() => {
  init_PartitionHash();
  init_RegionHash();
  init_getRegionInfo();
});
var init_dist_es24 = __esm2(() => {
  init_endpointsConfig();
  init_regionConfig();
  init_regionInfo();
});
var resolveEventStreamSerdeConfig = (input) => ({
  ...input,
  eventStreamMarshaller: input.eventStreamSerdeProvider(input)
});
var init_dist_es25 = () => {
};
function contentLengthMiddleware(bodyLengthChecker) {
  return (next) => async (args) => {
    const request42 = args.request;
    if (HttpRequest.isInstance(request42)) {
      const { body, headers } = request42;
      if (body && Object.keys(headers).map((str2) => str2.toLowerCase()).indexOf(CONTENT_LENGTH_HEADER2) === -1) {
        try {
          const length = bodyLengthChecker(body);
          request42.headers = {
            ...request42.headers,
            [CONTENT_LENGTH_HEADER2]: String(length)
          };
        } catch (error) {
        }
      }
    }
    return next({
      ...args,
      request: request42
    });
  };
}
var CONTENT_LENGTH_HEADER2 = "content-length";
var contentLengthMiddlewareOptions;
var getContentLengthPlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(contentLengthMiddleware(options3.bodyLengthChecker), contentLengthMiddlewareOptions);
  }
});
var init_dist_es26 = __esm2(() => {
  init_dist_es();
  contentLengthMiddlewareOptions = {
    step: "build",
    tags: ["SET_CONTENT_LENGTH", "CONTENT_LENGTH"],
    name: "contentLengthMiddleware",
    override: true
  };
});
var resolveParamsForS3 = async (endpointParams) => {
  const bucket = endpointParams?.Bucket || "";
  if (typeof endpointParams.Bucket === "string") {
    endpointParams.Bucket = bucket.replace(/#/g, encodeURIComponent("#")).replace(/\?/g, encodeURIComponent("?"));
  }
  if (isArnBucketName(bucket)) {
    if (endpointParams.ForcePathStyle === true) {
      throw new Error("Path-style addressing cannot be used with ARN buckets");
    }
  } else if (!isDnsCompatibleBucketName(bucket) || bucket.indexOf(".") !== -1 && !String(endpointParams.Endpoint).startsWith("http:") || bucket.toLowerCase() !== bucket || bucket.length < 3) {
    endpointParams.ForcePathStyle = true;
  }
  if (endpointParams.DisableMultiRegionAccessPoints) {
    endpointParams.disableMultiRegionAccessPoints = true;
    endpointParams.DisableMRAP = true;
  }
  return endpointParams;
};
var DOMAIN_PATTERN;
var IP_ADDRESS_PATTERN;
var DOTS_PATTERN;
var isDnsCompatibleBucketName = (bucketName) => DOMAIN_PATTERN.test(bucketName) && !IP_ADDRESS_PATTERN.test(bucketName) && !DOTS_PATTERN.test(bucketName);
var isArnBucketName = (bucketName) => {
  const [arn, partition4, service, , , bucket] = bucketName.split(":");
  const isArn = arn === "arn" && bucketName.split(":").length >= 6;
  const isValidArn = Boolean(isArn && partition4 && service && bucket);
  if (isArn && !isValidArn) {
    throw new Error(`Invalid ARN: ${bucketName} was an invalid ARN.`);
  }
  return isValidArn;
};
var init_s3 = __esm2(() => {
  DOMAIN_PATTERN = /^[a-z0-9][a-z0-9\.\-]{1,61}[a-z0-9]$/;
  IP_ADDRESS_PATTERN = /(\d+\.){3}\d+/;
  DOTS_PATTERN = /\.\./;
});
var init_service_customizations = __esm2(() => {
  init_s3();
});
var createConfigValueProvider = (configKey, canonicalEndpointParamKey, config7) => {
  const configProvider = async () => {
    const configValue = config7[configKey] ?? config7[canonicalEndpointParamKey];
    if (typeof configValue === "function") {
      return configValue();
    }
    return configValue;
  };
  if (configKey === "credentialScope" || canonicalEndpointParamKey === "CredentialScope") {
    return async () => {
      const credentials = typeof config7.credentials === "function" ? await config7.credentials() : config7.credentials;
      const configValue = credentials?.credentialScope ?? credentials?.CredentialScope;
      return configValue;
    };
  }
  if (configKey === "accountId" || canonicalEndpointParamKey === "AccountId") {
    return async () => {
      const credentials = typeof config7.credentials === "function" ? await config7.credentials() : config7.credentials;
      const configValue = credentials?.accountId ?? credentials?.AccountId;
      return configValue;
    };
  }
  if (configKey === "endpoint" || canonicalEndpointParamKey === "endpoint") {
    return async () => {
      const endpoint = await configProvider();
      if (endpoint && typeof endpoint === "object") {
        if ("url" in endpoint) {
          return endpoint.url.href;
        }
        if ("hostname" in endpoint) {
          const { protocol, hostname, port, path: path5 } = endpoint;
          return `${protocol}//${hostname}${port ? ":" + port : ""}${path5}`;
        }
      }
      return endpoint;
    };
  }
  return configProvider;
};
var ProviderError;
var init_ProviderError = __esm2(() => {
  ProviderError = class ProviderError2 extends Error {
    constructor(message, options3 = true) {
      let logger3;
      let tryNextLink = true;
      if (typeof options3 === "boolean") {
        logger3 = undefined;
        tryNextLink = options3;
      } else if (options3 != null && typeof options3 === "object") {
        logger3 = options3.logger;
        tryNextLink = options3.tryNextLink ?? true;
      }
      super(message);
      this.name = "ProviderError";
      this.tryNextLink = tryNextLink;
      Object.setPrototypeOf(this, ProviderError2.prototype);
      logger3?.debug?.(`@smithy/property-provider ${tryNextLink ? "->" : "(!)"} ${message}`);
    }
    static from(error, options3 = true) {
      return Object.assign(new this(error.message, options3), error);
    }
  };
});
var CredentialsProviderError;
var init_CredentialsProviderError = __esm2(() => {
  init_ProviderError();
  CredentialsProviderError = class CredentialsProviderError2 extends ProviderError {
    constructor(message, options3 = true) {
      super(message, options3);
      this.name = "CredentialsProviderError";
      Object.setPrototypeOf(this, CredentialsProviderError2.prototype);
    }
  };
});
var TokenProviderError;
var init_TokenProviderError = __esm2(() => {
  init_ProviderError();
  TokenProviderError = class TokenProviderError2 extends ProviderError {
    constructor(message, options3 = true) {
      super(message, options3);
      this.name = "TokenProviderError";
      Object.setPrototypeOf(this, TokenProviderError2.prototype);
    }
  };
});
var chain = (...providers22) => async () => {
  if (providers22.length === 0) {
    throw new ProviderError("No providers in chain");
  }
  let lastProviderError;
  for (const provider of providers22) {
    try {
      const credentials = await provider();
      return credentials;
    } catch (err22) {
      lastProviderError = err22;
      if (err22?.tryNextLink) {
        continue;
      }
      throw err22;
    }
  }
  throw lastProviderError;
};
var init_chain = __esm2(() => {
  init_ProviderError();
});
var fromStatic = (staticValue) => () => Promise.resolve(staticValue);
var memoize2 = (provider, isExpired, requiresRefresh) => {
  let resolved;
  let pending;
  let hasResult;
  let isConstant = false;
  const coalesceProvider = async () => {
    if (!pending) {
      pending = provider();
    }
    try {
      resolved = await pending;
      hasResult = true;
      isConstant = false;
    } finally {
      pending = undefined;
    }
    return resolved;
  };
  if (isExpired === undefined) {
    return async (options3) => {
      if (!hasResult || options3?.forceRefresh) {
        resolved = await coalesceProvider();
      }
      return resolved;
    };
  }
  return async (options3) => {
    if (!hasResult || options3?.forceRefresh) {
      resolved = await coalesceProvider();
    }
    if (isConstant) {
      return resolved;
    }
    if (requiresRefresh && !requiresRefresh(resolved)) {
      isConstant = true;
      return resolved;
    }
    if (isExpired(resolved)) {
      await coalesceProvider();
      return resolved;
    }
    return resolved;
  };
};
var init_dist_es27 = __esm2(() => {
  init_CredentialsProviderError();
  init_ProviderError();
  init_TokenProviderError();
  init_chain();
});
function getSelectorName(functionString) {
  try {
    const constants4 = new Set(Array.from(functionString.match(/([A-Z_]){3,}/g) ?? []));
    constants4.delete("CONFIG");
    constants4.delete("CONFIG_PREFIX_SEPARATOR");
    constants4.delete("ENV");
    return [...constants4].join(", ");
  } catch (e) {
    return functionString;
  }
}
var fromEnv = (envVarSelector, logger3) => async () => {
  try {
    const config7 = envVarSelector(process.env);
    if (config7 === undefined) {
      throw new Error;
    }
    return config7;
  } catch (e) {
    throw new CredentialsProviderError(e.message || `Not found in ENV: ${getSelectorName(envVarSelector.toString())}`, { logger: logger3 });
  }
};
var init_fromEnv = __esm2(() => {
  init_dist_es27();
});
var homeDirCache;
var getHomeDirCacheKey = () => {
  if (process && process.geteuid) {
    return `${process.geteuid()}`;
  }
  return "DEFAULT";
};
var getHomeDir = () => {
  const { HOME, USERPROFILE, HOMEPATH, HOMEDRIVE = `C:${sep32}` } = process.env;
  if (HOME)
    return HOME;
  if (USERPROFILE)
    return USERPROFILE;
  if (HOMEPATH)
    return `${HOMEDRIVE}${HOMEPATH}`;
  const homeDirCacheKey = getHomeDirCacheKey();
  if (!homeDirCache[homeDirCacheKey])
    homeDirCache[homeDirCacheKey] = homedir();
  return homeDirCache[homeDirCacheKey];
};
var init_getHomeDir = __esm2(() => {
  homeDirCache = {};
});
var ENV_PROFILE = "AWS_PROFILE";
var DEFAULT_PROFILE = "default";
var getProfileName = (init3) => init3.profile || process.env[ENV_PROFILE] || DEFAULT_PROFILE;
var getSSOTokenFilepath = (id) => {
  const hasher = createHash("sha1");
  const cacheName = hasher.update(id).digest("hex");
  return join22(getHomeDir(), ".aws", "sso", "cache", `${cacheName}.json`);
};
var init_getSSOTokenFilepath = __esm2(() => {
  init_getHomeDir();
});
var readFile2;
var getSSOTokenFromFile = async (id) => {
  const ssoTokenFilepath = getSSOTokenFilepath(id);
  const ssoTokenText = await readFile2(ssoTokenFilepath, "utf8");
  return JSON.parse(ssoTokenText);
};
var init_getSSOTokenFromFile = __esm2(() => {
  init_getSSOTokenFilepath();
  ({ readFile: readFile2 } = fsPromises);
});
var import_types25;
var getConfigData = (data2) => Object.entries(data2).filter(([key2]) => {
  const indexOfSeparator = key2.indexOf(CONFIG_PREFIX_SEPARATOR);
  if (indexOfSeparator === -1) {
    return false;
  }
  return Object.values(import_types25.IniSectionType).includes(key2.substring(0, indexOfSeparator));
}).reduce((acc, [key2, value]) => {
  const indexOfSeparator = key2.indexOf(CONFIG_PREFIX_SEPARATOR);
  const updatedKey = key2.substring(0, indexOfSeparator) === import_types25.IniSectionType.PROFILE ? key2.substring(indexOfSeparator + 1) : key2;
  acc[updatedKey] = value;
  return acc;
}, {
  ...data2.default && { default: data2.default }
});
var init_getConfigData = __esm2(() => {
  import_types25 = __toESM3(require_dist_cjs(), 1);
  init_loadSharedConfigFiles();
});
var ENV_CONFIG_PATH = "AWS_CONFIG_FILE";
var getConfigFilepath = () => process.env[ENV_CONFIG_PATH] || join3(getHomeDir(), ".aws", "config");
var init_getConfigFilepath = __esm2(() => {
  init_getHomeDir();
});
var ENV_CREDENTIALS_PATH = "AWS_SHARED_CREDENTIALS_FILE";
var getCredentialsFilepath = () => process.env[ENV_CREDENTIALS_PATH] || join4(getHomeDir(), ".aws", "credentials");
var init_getCredentialsFilepath = __esm2(() => {
  init_getHomeDir();
});
var import_types26;
var prefixKeyRegex;
var profileNameBlockList;
var parseIni = (iniData) => {
  const map3 = {};
  let currentSection;
  let currentSubSection;
  for (const iniLine of iniData.split(/\r?\n/)) {
    const trimmedLine = iniLine.split(/(^|\s)[;#]/)[0].trim();
    const isSection = trimmedLine[0] === "[" && trimmedLine[trimmedLine.length - 1] === "]";
    if (isSection) {
      currentSection = undefined;
      currentSubSection = undefined;
      const sectionName = trimmedLine.substring(1, trimmedLine.length - 1);
      const matches = prefixKeyRegex.exec(sectionName);
      if (matches) {
        const [, prefix, , name] = matches;
        if (Object.values(import_types26.IniSectionType).includes(prefix)) {
          currentSection = [prefix, name].join(CONFIG_PREFIX_SEPARATOR);
        }
      } else {
        currentSection = sectionName;
      }
      if (profileNameBlockList.includes(sectionName)) {
        throw new Error(`Found invalid profile name "${sectionName}"`);
      }
    } else if (currentSection) {
      const indexOfEqualsSign = trimmedLine.indexOf("=");
      if (![0, -1].includes(indexOfEqualsSign)) {
        const [name, value] = [
          trimmedLine.substring(0, indexOfEqualsSign).trim(),
          trimmedLine.substring(indexOfEqualsSign + 1).trim()
        ];
        if (value === "") {
          currentSubSection = name;
        } else {
          if (currentSubSection && iniLine.trimStart() === iniLine) {
            currentSubSection = undefined;
          }
          map3[currentSection] = map3[currentSection] || {};
          const key2 = currentSubSection ? [currentSubSection, name].join(CONFIG_PREFIX_SEPARATOR) : name;
          map3[currentSection][key2] = value;
        }
      }
    }
  }
  return map3;
};
var init_parseIni = __esm2(() => {
  import_types26 = __toESM3(require_dist_cjs(), 1);
  init_loadSharedConfigFiles();
  prefixKeyRegex = /^([\w-]+)\s(["'])?([\w-@\+\.%:/]+)\2$/;
  profileNameBlockList = ["__proto__", "profile __proto__"];
});
var readFile3;
var filePromisesHash;
var slurpFile = (path5, options3) => {
  if (!filePromisesHash[path5] || options3?.ignoreCache) {
    filePromisesHash[path5] = readFile3(path5, "utf8");
  }
  return filePromisesHash[path5];
};
var init_slurpFile = __esm2(() => {
  ({ readFile: readFile3 } = fsPromises2);
  filePromisesHash = {};
});
var swallowError = () => ({});
var CONFIG_PREFIX_SEPARATOR = ".";
var loadSharedConfigFiles = async (init3 = {}) => {
  const { filepath = getCredentialsFilepath(), configFilepath = getConfigFilepath() } = init3;
  const homeDir2 = getHomeDir();
  const relativeHomeDirPrefix = "~/";
  let resolvedFilepath = filepath;
  if (filepath.startsWith(relativeHomeDirPrefix)) {
    resolvedFilepath = join5(homeDir2, filepath.slice(2));
  }
  let resolvedConfigFilepath = configFilepath;
  if (configFilepath.startsWith(relativeHomeDirPrefix)) {
    resolvedConfigFilepath = join5(homeDir2, configFilepath.slice(2));
  }
  const parsedFiles = await Promise.all([
    slurpFile(resolvedConfigFilepath, {
      ignoreCache: init3.ignoreCache
    }).then(parseIni).then(getConfigData).catch(swallowError),
    slurpFile(resolvedFilepath, {
      ignoreCache: init3.ignoreCache
    }).then(parseIni).catch(swallowError)
  ]);
  return {
    configFile: parsedFiles[0],
    credentialsFile: parsedFiles[1]
  };
};
var init_loadSharedConfigFiles = __esm2(() => {
  init_getConfigData();
  init_getConfigFilepath();
  init_getCredentialsFilepath();
  init_getHomeDir();
  init_parseIni();
  init_slurpFile();
});
var import_types27;
var getSsoSessionData = (data2) => Object.entries(data2).filter(([key2]) => key2.startsWith(import_types27.IniSectionType.SSO_SESSION + CONFIG_PREFIX_SEPARATOR)).reduce((acc, [key2, value]) => ({ ...acc, [key2.substring(key2.indexOf(CONFIG_PREFIX_SEPARATOR) + 1)]: value }), {});
var init_getSsoSessionData = __esm2(() => {
  import_types27 = __toESM3(require_dist_cjs(), 1);
  init_loadSharedConfigFiles();
});
var swallowError2 = () => ({});
var loadSsoSessionData = async (init3 = {}) => slurpFile(init3.configFilepath ?? getConfigFilepath()).then(parseIni).then(getSsoSessionData).catch(swallowError2);
var init_loadSsoSessionData = __esm2(() => {
  init_getConfigFilepath();
  init_getSsoSessionData();
  init_parseIni();
  init_slurpFile();
});
var mergeConfigFiles = (...files2) => {
  const merged = {};
  for (const file of files2) {
    for (const [key2, values3] of Object.entries(file)) {
      if (merged[key2] !== undefined) {
        Object.assign(merged[key2], values3);
      } else {
        merged[key2] = values3;
      }
    }
  }
  return merged;
};
var parseKnownFiles = async (init3) => {
  const parsedFiles = await loadSharedConfigFiles(init3);
  return mergeConfigFiles(parsedFiles.configFile, parsedFiles.credentialsFile);
};
var init_parseKnownFiles = __esm2(() => {
  init_loadSharedConfigFiles();
});
var init_types9 = () => {
};
var init_dist_es28 = __esm2(() => {
  init_getHomeDir();
  init_getSSOTokenFilepath();
  init_getSSOTokenFromFile();
  init_loadSharedConfigFiles();
  init_loadSsoSessionData();
  init_parseKnownFiles();
  init_types9();
});
var fromSharedConfigFiles = (configSelector, { preferredFile = "config", ...init3 } = {}) => async () => {
  const profile = getProfileName(init3);
  const { configFile, credentialsFile } = await loadSharedConfigFiles(init3);
  const profileFromCredentials = credentialsFile[profile] || {};
  const profileFromConfig = configFile[profile] || {};
  const mergedProfile = preferredFile === "config" ? { ...profileFromCredentials, ...profileFromConfig } : { ...profileFromConfig, ...profileFromCredentials };
  try {
    const cfgFile = preferredFile === "config" ? configFile : credentialsFile;
    const configValue = configSelector(mergedProfile, cfgFile);
    if (configValue === undefined) {
      throw new Error;
    }
    return configValue;
  } catch (e) {
    throw new CredentialsProviderError(e.message || `Not found in config files w/ profile [${profile}]: ${getSelectorName(configSelector.toString())}`, { logger: init3.logger });
  }
};
var init_fromSharedConfigFiles = __esm2(() => {
  init_dist_es27();
  init_dist_es28();
});
var isFunction3 = (func) => typeof func === "function";
var fromStatic3 = (defaultValue) => isFunction3(defaultValue) ? async () => await defaultValue() : fromStatic(defaultValue);
var init_fromStatic = __esm2(() => {
  init_dist_es27();
});
var loadConfig = ({ environmentVariableSelector, configFileSelector, default: defaultValue }, configuration = {}) => memoize2(chain(fromEnv(environmentVariableSelector), fromSharedConfigFiles(configFileSelector, configuration), fromStatic3(defaultValue)));
var init_configLoader = __esm2(() => {
  init_dist_es27();
  init_fromEnv();
  init_fromSharedConfigFiles();
  init_fromStatic();
});
var init_dist_es29 = __esm2(() => {
  init_configLoader();
});
var ENV_ENDPOINT_URL = "AWS_ENDPOINT_URL";
var CONFIG_ENDPOINT_URL = "endpoint_url";
var getEndpointUrlConfig = (serviceId) => ({
  environmentVariableSelector: (env62) => {
    const serviceSuffixParts = serviceId.split(" ").map((w22) => w22.toUpperCase());
    const serviceEndpointUrl = env62[[ENV_ENDPOINT_URL, ...serviceSuffixParts].join("_")];
    if (serviceEndpointUrl)
      return serviceEndpointUrl;
    const endpointUrl = env62[ENV_ENDPOINT_URL];
    if (endpointUrl)
      return endpointUrl;
    return;
  },
  configFileSelector: (profile, config7) => {
    if (config7 && profile.services) {
      const servicesSection = config7[["services", profile.services].join(CONFIG_PREFIX_SEPARATOR)];
      if (servicesSection) {
        const servicePrefixParts = serviceId.split(" ").map((w22) => w22.toLowerCase());
        const endpointUrl2 = servicesSection[[servicePrefixParts.join("_"), CONFIG_ENDPOINT_URL].join(CONFIG_PREFIX_SEPARATOR)];
        if (endpointUrl2)
          return endpointUrl2;
      }
    }
    const endpointUrl = profile[CONFIG_ENDPOINT_URL];
    if (endpointUrl)
      return endpointUrl;
    return;
  },
  default: undefined
});
var init_getEndpointUrlConfig = __esm2(() => {
  init_dist_es28();
});
var getEndpointFromConfig = async (serviceId) => loadConfig(getEndpointUrlConfig(serviceId ?? ""))();
var init_getEndpointFromConfig = __esm2(() => {
  init_dist_es29();
  init_getEndpointUrlConfig();
});
function parseQueryString(querystring) {
  const query = {};
  querystring = querystring.replace(/^\?/, "");
  if (querystring) {
    for (const pair of querystring.split("&")) {
      let [key2, value = null] = pair.split("=");
      key2 = decodeURIComponent(key2);
      if (value) {
        value = decodeURIComponent(value);
      }
      if (!(key2 in query)) {
        query[key2] = value;
      } else if (Array.isArray(query[key2])) {
        query[key2].push(value);
      } else {
        query[key2] = [query[key2], value];
      }
    }
  }
  return query;
}
var parseUrl = (url) => {
  if (typeof url === "string") {
    return parseUrl(new URL(url));
  }
  const { hostname, pathname, port, protocol, search } = url;
  let query;
  if (search) {
    query = parseQueryString(search);
  }
  return {
    hostname,
    port: port ? parseInt(port) : undefined,
    protocol,
    path: pathname,
    query
  };
};
var init_dist_es30 = () => {
};
var toEndpointV1 = (endpoint) => {
  if (typeof endpoint === "object") {
    if ("url" in endpoint) {
      return parseUrl(endpoint.url);
    }
    return endpoint;
  }
  return parseUrl(endpoint);
};
var init_toEndpointV1 = __esm2(() => {
  init_dist_es30();
});
var getEndpointFromInstructions = async (commandInput, instructionsSupplier, clientConfig, context) => {
  if (!clientConfig.endpoint) {
    let endpointFromConfig;
    if (clientConfig.serviceConfiguredEndpoint) {
      endpointFromConfig = await clientConfig.serviceConfiguredEndpoint();
    } else {
      endpointFromConfig = await getEndpointFromConfig(clientConfig.serviceId);
    }
    if (endpointFromConfig) {
      clientConfig.endpoint = () => Promise.resolve(toEndpointV1(endpointFromConfig));
    }
  }
  const endpointParams = await resolveParams(commandInput, instructionsSupplier, clientConfig);
  if (typeof clientConfig.endpointProvider !== "function") {
    throw new Error("config.endpointProvider is not set.");
  }
  const endpoint = clientConfig.endpointProvider(endpointParams, context);
  return endpoint;
};
var resolveParams = async (commandInput, instructionsSupplier, clientConfig) => {
  const endpointParams = {};
  const instructions = instructionsSupplier?.getEndpointParameterInstructions?.() || {};
  for (const [name, instruction] of Object.entries(instructions)) {
    switch (instruction.type) {
      case "staticContextParams":
        endpointParams[name] = instruction.value;
        break;
      case "contextParams":
        endpointParams[name] = commandInput[instruction.name];
        break;
      case "clientContextParams":
      case "builtInParams":
        endpointParams[name] = await createConfigValueProvider(instruction.name, name, clientConfig)();
        break;
      default:
        throw new Error("Unrecognized endpoint parameter instruction: " + JSON.stringify(instruction));
    }
  }
  if (Object.keys(instructions).length === 0) {
    Object.assign(endpointParams, clientConfig);
  }
  if (String(clientConfig.serviceId).toLowerCase() === "s3") {
    await resolveParamsForS3(endpointParams);
  }
  return endpointParams;
};
var init_getEndpointFromInstructions = __esm2(() => {
  init_service_customizations();
  init_getEndpointFromConfig();
  init_toEndpointV1();
});
var init_adaptors = __esm2(() => {
  init_getEndpointFromInstructions();
  init_toEndpointV1();
});
var import_core9;
var import_util_middleware6;
var endpointMiddleware = ({ config: config7, instructions }) => {
  return (next, context) => async (args) => {
    if (config7.endpoint) {
      import_core9.setFeature(context, "ENDPOINT_OVERRIDE", "N");
    }
    const endpoint = await getEndpointFromInstructions(args.input, {
      getEndpointParameterInstructions() {
        return instructions;
      }
    }, { ...config7 }, context);
    context.endpointV2 = endpoint;
    context.authSchemes = endpoint.properties?.authSchemes;
    const authScheme = context.authSchemes?.[0];
    if (authScheme) {
      context["signing_region"] = authScheme.signingRegion;
      context["signing_service"] = authScheme.signingName;
      const smithyContext = import_util_middleware6.getSmithyContext(context);
      const httpAuthOption = smithyContext?.selectedHttpAuthScheme?.httpAuthOption;
      if (httpAuthOption) {
        httpAuthOption.signingProperties = Object.assign(httpAuthOption.signingProperties || {}, {
          signing_region: authScheme.signingRegion,
          signingRegion: authScheme.signingRegion,
          signing_service: authScheme.signingName,
          signingName: authScheme.signingName,
          signingRegionSet: authScheme.signingRegionSet
        }, authScheme.properties);
      }
    }
    return next({
      ...args
    });
  };
};
var init_endpointMiddleware = __esm2(() => {
  import_core9 = __toESM3(require_dist_cjs15(), 1);
  import_util_middleware6 = __toESM3(require_dist_cjs3(), 1);
  init_getEndpointFromInstructions();
});
var deserializerMiddleware = (options3, deserializer) => (next) => async (args) => {
  const { response } = await next(args);
  try {
    const parsed = await deserializer(response, options3);
    return {
      response,
      output: parsed
    };
  } catch (error) {
    Object.defineProperty(error, "$response", {
      value: response
    });
    if (!("$metadata" in error)) {
      const hint = `Deserialization error: to see the raw response, inspect the hidden field {error}.$response on this object.`;
      error.message += "\n  " + hint;
      if (typeof error.$responseBodyText !== "undefined") {
        if (error.$response) {
          error.$response.body = error.$responseBodyText;
        }
      }
    }
    throw error;
  }
};
var serializerMiddleware = (options3, serializer) => (next, context) => async (args) => {
  const endpoint = context.endpointV2?.url && options3.urlParser ? async () => options3.urlParser(context.endpointV2.url) : options3.endpoint;
  if (!endpoint) {
    throw new Error("No valid endpoint provider available.");
  }
  const request42 = await serializer(args.input, { ...options3, endpoint });
  return next({
    ...args,
    request: request42
  });
};
function getSerdePlugin(config7, serializer, deserializer) {
  return {
    applyToStack: (commandStack) => {
      commandStack.add(deserializerMiddleware(config7, deserializer), deserializerMiddlewareOption);
      commandStack.add(serializerMiddleware(config7, serializer), serializerMiddlewareOption);
    }
  };
}
var deserializerMiddlewareOption;
var serializerMiddlewareOption;
var init_serdePlugin = __esm2(() => {
  deserializerMiddlewareOption = {
    name: "deserializerMiddleware",
    step: "deserialize",
    tags: ["DESERIALIZER"],
    override: true
  };
  serializerMiddlewareOption = {
    name: "serializerMiddleware",
    step: "serialize",
    tags: ["SERIALIZER"],
    override: true
  };
});
var init_dist_es31 = __esm2(() => {
  init_serdePlugin();
});
var endpointMiddlewareOptions;
var getEndpointPlugin = (config7, instructions) => ({
  applyToStack: (clientStack) => {
    clientStack.addRelativeTo(endpointMiddleware({
      config: config7,
      instructions
    }), endpointMiddlewareOptions);
  }
});
var init_getEndpointPlugin = __esm2(() => {
  init_dist_es31();
  init_endpointMiddleware();
  endpointMiddlewareOptions = {
    step: "serialize",
    tags: ["ENDPOINT_PARAMETERS", "ENDPOINT_V2", "ENDPOINT"],
    name: "endpointV2Middleware",
    override: true,
    relation: "before",
    toMiddleware: serializerMiddlewareOption.name
  };
});
var import_util_middleware7;
var resolveEndpointConfig = (input) => {
  const tls = input.tls ?? true;
  const { endpoint } = input;
  const customEndpointProvider = endpoint != null ? async () => toEndpointV1(await import_util_middleware7.normalizeProvider(endpoint)()) : undefined;
  const isCustomEndpoint = !!endpoint;
  const resolvedConfig = {
    ...input,
    endpoint: customEndpointProvider,
    tls,
    isCustomEndpoint,
    useDualstackEndpoint: import_util_middleware7.normalizeProvider(input.useDualstackEndpoint ?? false),
    useFipsEndpoint: import_util_middleware7.normalizeProvider(input.useFipsEndpoint ?? false)
  };
  let configuredEndpointPromise = undefined;
  resolvedConfig.serviceConfiguredEndpoint = async () => {
    if (input.serviceId && !configuredEndpointPromise) {
      configuredEndpointPromise = getEndpointFromConfig(input.serviceId);
    }
    return configuredEndpointPromise;
  };
  return resolvedConfig;
};
var init_resolveEndpointConfig = __esm2(() => {
  import_util_middleware7 = __toESM3(require_dist_cjs3(), 1);
  init_getEndpointFromConfig();
  init_toEndpointV1();
});
var init_types10 = () => {
};
var init_dist_es32 = __esm2(() => {
  init_adaptors();
  init_endpointMiddleware();
  init_getEndpointPlugin();
  init_resolveEndpointConfig();
  init_types10();
});
var RETRY_MODES;
var DEFAULT_MAX_ATTEMPTS = 3;
var DEFAULT_RETRY_MODE;
var init_config4 = __esm2(() => {
  (function(RETRY_MODES2) {
    RETRY_MODES2["STANDARD"] = "standard";
    RETRY_MODES2["ADAPTIVE"] = "adaptive";
  })(RETRY_MODES || (RETRY_MODES = {}));
  DEFAULT_RETRY_MODE = RETRY_MODES.STANDARD;
});
var THROTTLING_ERROR_CODES;
var TRANSIENT_ERROR_CODES;
var TRANSIENT_ERROR_STATUS_CODES;
var NODEJS_TIMEOUT_ERROR_CODES2;
var init_constants6 = __esm2(() => {
  THROTTLING_ERROR_CODES = [
    "BandwidthLimitExceeded",
    "EC2ThrottledException",
    "LimitExceededException",
    "PriorRequestNotComplete",
    "ProvisionedThroughputExceededException",
    "RequestLimitExceeded",
    "RequestThrottled",
    "RequestThrottledException",
    "SlowDown",
    "ThrottledException",
    "Throttling",
    "ThrottlingException",
    "TooManyRequestsException",
    "TransactionInProgressException"
  ];
  TRANSIENT_ERROR_CODES = ["TimeoutError", "RequestTimeout", "RequestTimeoutException"];
  TRANSIENT_ERROR_STATUS_CODES = [500, 502, 503, 504];
  NODEJS_TIMEOUT_ERROR_CODES2 = ["ECONNRESET", "ECONNREFUSED", "EPIPE", "ETIMEDOUT"];
});
var isClockSkewCorrectedError = (error) => error.$metadata?.clockSkewCorrected;
var isThrottlingError = (error) => error.$metadata?.httpStatusCode === 429 || THROTTLING_ERROR_CODES.includes(error.name) || error.$retryable?.throttling == true;
var isTransientError = (error) => isClockSkewCorrectedError(error) || TRANSIENT_ERROR_CODES.includes(error.name) || NODEJS_TIMEOUT_ERROR_CODES2.includes(error?.code || "") || TRANSIENT_ERROR_STATUS_CODES.includes(error.$metadata?.httpStatusCode || 0);
var isServerError = (error) => {
  if (error.$metadata?.httpStatusCode !== undefined) {
    const statusCode = error.$metadata.httpStatusCode;
    if (500 <= statusCode && statusCode <= 599 && !isTransientError(error)) {
      return true;
    }
    return false;
  }
  return false;
};
var init_dist_es33 = __esm2(() => {
  init_constants6();
});

class DefaultRateLimiter {
  constructor(options3) {
    this.currentCapacity = 0;
    this.enabled = false;
    this.lastMaxRate = 0;
    this.measuredTxRate = 0;
    this.requestCount = 0;
    this.lastTimestamp = 0;
    this.timeWindow = 0;
    this.beta = options3?.beta ?? 0.7;
    this.minCapacity = options3?.minCapacity ?? 1;
    this.minFillRate = options3?.minFillRate ?? 0.5;
    this.scaleConstant = options3?.scaleConstant ?? 0.4;
    this.smooth = options3?.smooth ?? 0.8;
    const currentTimeInSeconds = this.getCurrentTimeInSeconds();
    this.lastThrottleTime = currentTimeInSeconds;
    this.lastTxRateBucket = Math.floor(this.getCurrentTimeInSeconds());
    this.fillRate = this.minFillRate;
    this.maxCapacity = this.minCapacity;
  }
  getCurrentTimeInSeconds() {
    return Date.now() / 1000;
  }
  async getSendToken() {
    return this.acquireTokenBucket(1);
  }
  async acquireTokenBucket(amount) {
    if (!this.enabled) {
      return;
    }
    this.refillTokenBucket();
    if (amount > this.currentCapacity) {
      const delay = (amount - this.currentCapacity) / this.fillRate * 1000;
      await new Promise((resolve5) => setTimeout(resolve5, delay));
    }
    this.currentCapacity = this.currentCapacity - amount;
  }
  refillTokenBucket() {
    const timestamp2 = this.getCurrentTimeInSeconds();
    if (!this.lastTimestamp) {
      this.lastTimestamp = timestamp2;
      return;
    }
    const fillAmount = (timestamp2 - this.lastTimestamp) * this.fillRate;
    this.currentCapacity = Math.min(this.maxCapacity, this.currentCapacity + fillAmount);
    this.lastTimestamp = timestamp2;
  }
  updateClientSendingRate(response) {
    let calculatedRate;
    this.updateMeasuredRate();
    if (isThrottlingError(response)) {
      const rateToUse = !this.enabled ? this.measuredTxRate : Math.min(this.measuredTxRate, this.fillRate);
      this.lastMaxRate = rateToUse;
      this.calculateTimeWindow();
      this.lastThrottleTime = this.getCurrentTimeInSeconds();
      calculatedRate = this.cubicThrottle(rateToUse);
      this.enableTokenBucket();
    } else {
      this.calculateTimeWindow();
      calculatedRate = this.cubicSuccess(this.getCurrentTimeInSeconds());
    }
    const newRate = Math.min(calculatedRate, 2 * this.measuredTxRate);
    this.updateTokenBucketRate(newRate);
  }
  calculateTimeWindow() {
    this.timeWindow = this.getPrecise(Math.pow(this.lastMaxRate * (1 - this.beta) / this.scaleConstant, 0.3333333333333333));
  }
  cubicThrottle(rateToUse) {
    return this.getPrecise(rateToUse * this.beta);
  }
  cubicSuccess(timestamp2) {
    return this.getPrecise(this.scaleConstant * Math.pow(timestamp2 - this.lastThrottleTime - this.timeWindow, 3) + this.lastMaxRate);
  }
  enableTokenBucket() {
    this.enabled = true;
  }
  updateTokenBucketRate(newRate) {
    this.refillTokenBucket();
    this.fillRate = Math.max(newRate, this.minFillRate);
    this.maxCapacity = Math.max(newRate, this.minCapacity);
    this.currentCapacity = Math.min(this.currentCapacity, this.maxCapacity);
  }
  updateMeasuredRate() {
    const t = this.getCurrentTimeInSeconds();
    const timeBucket = Math.floor(t * 2) / 2;
    this.requestCount++;
    if (timeBucket > this.lastTxRateBucket) {
      const currentRate = this.requestCount / (timeBucket - this.lastTxRateBucket);
      this.measuredTxRate = this.getPrecise(currentRate * this.smooth + this.measuredTxRate * (1 - this.smooth));
      this.requestCount = 0;
      this.lastTxRateBucket = timeBucket;
    }
  }
  getPrecise(num) {
    return parseFloat(num.toFixed(8));
  }
}
var init_DefaultRateLimiter = __esm2(() => {
  init_dist_es33();
});
var DEFAULT_RETRY_DELAY_BASE = 100;
var MAXIMUM_RETRY_DELAY;
var THROTTLING_RETRY_DELAY_BASE = 500;
var INITIAL_RETRY_TOKENS = 500;
var RETRY_COST = 5;
var TIMEOUT_RETRY_COST = 10;
var NO_RETRY_INCREMENT = 1;
var INVOCATION_ID_HEADER = "amz-sdk-invocation-id";
var REQUEST_HEADER = "amz-sdk-request";
var init_constants7 = __esm2(() => {
  MAXIMUM_RETRY_DELAY = 20000;
});
var getDefaultRetryBackoffStrategy = () => {
  let delayBase = DEFAULT_RETRY_DELAY_BASE;
  const computeNextBackoffDelay = (attempts) => {
    return Math.floor(Math.min(MAXIMUM_RETRY_DELAY, Math.random() * 2 ** attempts * delayBase));
  };
  const setDelayBase = (delay) => {
    delayBase = delay;
  };
  return {
    computeNextBackoffDelay,
    setDelayBase
  };
};
var init_defaultRetryBackoffStrategy = __esm2(() => {
  init_constants7();
});
var createDefaultRetryToken = ({ retryDelay, retryCount, retryCost }) => {
  const getRetryCount = () => retryCount;
  const getRetryDelay = () => Math.min(MAXIMUM_RETRY_DELAY, retryDelay);
  const getRetryCost = () => retryCost;
  return {
    getRetryCount,
    getRetryDelay,
    getRetryCost
  };
};
var init_defaultRetryToken = __esm2(() => {
  init_constants7();
});

class StandardRetryStrategy {
  constructor(maxAttempts) {
    this.maxAttempts = maxAttempts;
    this.mode = RETRY_MODES.STANDARD;
    this.capacity = INITIAL_RETRY_TOKENS;
    this.retryBackoffStrategy = getDefaultRetryBackoffStrategy();
    this.maxAttemptsProvider = typeof maxAttempts === "function" ? maxAttempts : async () => maxAttempts;
  }
  async acquireInitialRetryToken(retryTokenScope) {
    return createDefaultRetryToken({
      retryDelay: DEFAULT_RETRY_DELAY_BASE,
      retryCount: 0
    });
  }
  async refreshRetryTokenForRetry(token, errorInfo) {
    const maxAttempts = await this.getMaxAttempts();
    if (this.shouldRetry(token, errorInfo, maxAttempts)) {
      const errorType = errorInfo.errorType;
      this.retryBackoffStrategy.setDelayBase(errorType === "THROTTLING" ? THROTTLING_RETRY_DELAY_BASE : DEFAULT_RETRY_DELAY_BASE);
      const delayFromErrorType = this.retryBackoffStrategy.computeNextBackoffDelay(token.getRetryCount());
      const retryDelay = errorInfo.retryAfterHint ? Math.max(errorInfo.retryAfterHint.getTime() - Date.now() || 0, delayFromErrorType) : delayFromErrorType;
      const capacityCost = this.getCapacityCost(errorType);
      this.capacity -= capacityCost;
      return createDefaultRetryToken({
        retryDelay,
        retryCount: token.getRetryCount() + 1,
        retryCost: capacityCost
      });
    }
    throw new Error("No retry token available");
  }
  recordSuccess(token) {
    this.capacity = Math.max(INITIAL_RETRY_TOKENS, this.capacity + (token.getRetryCost() ?? NO_RETRY_INCREMENT));
  }
  getCapacity() {
    return this.capacity;
  }
  async getMaxAttempts() {
    try {
      return await this.maxAttemptsProvider();
    } catch (error) {
      console.warn(`Max attempts provider could not resolve. Using default of ${DEFAULT_MAX_ATTEMPTS}`);
      return DEFAULT_MAX_ATTEMPTS;
    }
  }
  shouldRetry(tokenToRenew, errorInfo, maxAttempts) {
    const attempts = tokenToRenew.getRetryCount() + 1;
    return attempts < maxAttempts && this.capacity >= this.getCapacityCost(errorInfo.errorType) && this.isRetryableError(errorInfo.errorType);
  }
  getCapacityCost(errorType) {
    return errorType === "TRANSIENT" ? TIMEOUT_RETRY_COST : RETRY_COST;
  }
  isRetryableError(errorType) {
    return errorType === "THROTTLING" || errorType === "TRANSIENT";
  }
}
var init_StandardRetryStrategy = __esm2(() => {
  init_config4();
  init_constants7();
  init_defaultRetryBackoffStrategy();
  init_defaultRetryToken();
});

class AdaptiveRetryStrategy {
  constructor(maxAttemptsProvider, options3) {
    this.maxAttemptsProvider = maxAttemptsProvider;
    this.mode = RETRY_MODES.ADAPTIVE;
    const { rateLimiter } = options3 ?? {};
    this.rateLimiter = rateLimiter ?? new DefaultRateLimiter;
    this.standardRetryStrategy = new StandardRetryStrategy(maxAttemptsProvider);
  }
  async acquireInitialRetryToken(retryTokenScope) {
    await this.rateLimiter.getSendToken();
    return this.standardRetryStrategy.acquireInitialRetryToken(retryTokenScope);
  }
  async refreshRetryTokenForRetry(tokenToRenew, errorInfo) {
    this.rateLimiter.updateClientSendingRate(errorInfo);
    return this.standardRetryStrategy.refreshRetryTokenForRetry(tokenToRenew, errorInfo);
  }
  recordSuccess(token) {
    this.rateLimiter.updateClientSendingRate({});
    this.standardRetryStrategy.recordSuccess(token);
  }
}
var init_AdaptiveRetryStrategy = __esm2(() => {
  init_config4();
  init_DefaultRateLimiter();
  init_StandardRetryStrategy();
});
var init_ConfiguredRetryStrategy = __esm2(() => {
  init_constants7();
  init_StandardRetryStrategy();
});
var init_types11 = () => {
};
var init_dist_es34 = __esm2(() => {
  init_AdaptiveRetryStrategy();
  init_ConfiguredRetryStrategy();
  init_DefaultRateLimiter();
  init_StandardRetryStrategy();
  init_config4();
  init_constants7();
  init_types11();
});
var require_rng = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = rng;
  var _crypto = _interopRequireDefault(import.meta.require("crypto"));
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var rnds8Pool = new Uint8Array(256);
  var poolPtr = rnds8Pool.length;
  function rng() {
    if (poolPtr > rnds8Pool.length - 16) {
      _crypto.default.randomFillSync(rnds8Pool);
      poolPtr = 0;
    }
    return rnds8Pool.slice(poolPtr, poolPtr += 16);
  }
});
var require_regex = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _default2 = /^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;
  exports.default = _default2;
});
var require_validate2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _regex = _interopRequireDefault(require_regex());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function validate22(uuid) {
    return typeof uuid === "string" && _regex.default.test(uuid);
  }
  var _default2 = validate22;
  exports.default = _default2;
});
var require_stringify2 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  exports.unsafeStringify = unsafeStringify;
  var _validate = _interopRequireDefault(require_validate2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var byteToHex = [];
  for (let i2 = 0;i2 < 256; ++i2) {
    byteToHex.push((i2 + 256).toString(16).slice(1));
  }
  function unsafeStringify(arr2, offset2 = 0) {
    return byteToHex[arr2[offset2 + 0]] + byteToHex[arr2[offset2 + 1]] + byteToHex[arr2[offset2 + 2]] + byteToHex[arr2[offset2 + 3]] + "-" + byteToHex[arr2[offset2 + 4]] + byteToHex[arr2[offset2 + 5]] + "-" + byteToHex[arr2[offset2 + 6]] + byteToHex[arr2[offset2 + 7]] + "-" + byteToHex[arr2[offset2 + 8]] + byteToHex[arr2[offset2 + 9]] + "-" + byteToHex[arr2[offset2 + 10]] + byteToHex[arr2[offset2 + 11]] + byteToHex[arr2[offset2 + 12]] + byteToHex[arr2[offset2 + 13]] + byteToHex[arr2[offset2 + 14]] + byteToHex[arr2[offset2 + 15]];
  }
  function stringify(arr2, offset2 = 0) {
    const uuid = unsafeStringify(arr2, offset2);
    if (!(0, _validate.default)(uuid)) {
      throw TypeError("Stringified UUID is invalid");
    }
    return uuid;
  }
  var _default2 = stringify;
  exports.default = _default2;
});
var require_v1 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _rng = _interopRequireDefault(require_rng());
  var _stringify = require_stringify2();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var _nodeId;
  var _clockseq;
  var _lastMSecs = 0;
  var _lastNSecs = 0;
  function v1(options3, buf, offset2) {
    let i2 = buf && offset2 || 0;
    const b22 = buf || new Array(16);
    options3 = options3 || {};
    let node = options3.node || _nodeId;
    let clockseq = options3.clockseq !== undefined ? options3.clockseq : _clockseq;
    if (node == null || clockseq == null) {
      const seedBytes = options3.random || (options3.rng || _rng.default)();
      if (node == null) {
        node = _nodeId = [seedBytes[0] | 1, seedBytes[1], seedBytes[2], seedBytes[3], seedBytes[4], seedBytes[5]];
      }
      if (clockseq == null) {
        clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 16383;
      }
    }
    let msecs = options3.msecs !== undefined ? options3.msecs : Date.now();
    let nsecs = options3.nsecs !== undefined ? options3.nsecs : _lastNSecs + 1;
    const dt2 = msecs - _lastMSecs + (nsecs - _lastNSecs) / 1e4;
    if (dt2 < 0 && options3.clockseq === undefined) {
      clockseq = clockseq + 1 & 16383;
    }
    if ((dt2 < 0 || msecs > _lastMSecs) && options3.nsecs === undefined) {
      nsecs = 0;
    }
    if (nsecs >= 1e4) {
      throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");
    }
    _lastMSecs = msecs;
    _lastNSecs = nsecs;
    _clockseq = clockseq;
    msecs += 12219292800000;
    const tl = ((msecs & 268435455) * 1e4 + nsecs) % 4294967296;
    b22[i2++] = tl >>> 24 & 255;
    b22[i2++] = tl >>> 16 & 255;
    b22[i2++] = tl >>> 8 & 255;
    b22[i2++] = tl & 255;
    const tmh = msecs / 4294967296 * 1e4 & 268435455;
    b22[i2++] = tmh >>> 8 & 255;
    b22[i2++] = tmh & 255;
    b22[i2++] = tmh >>> 24 & 15 | 16;
    b22[i2++] = tmh >>> 16 & 255;
    b22[i2++] = clockseq >>> 8 | 128;
    b22[i2++] = clockseq & 255;
    for (let n = 0;n < 6; ++n) {
      b22[i2 + n] = node[n];
    }
    return buf || (0, _stringify.unsafeStringify)(b22);
  }
  var _default2 = v1;
  exports.default = _default2;
});
var require_parse3 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _validate = _interopRequireDefault(require_validate2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function parse8(uuid) {
    if (!(0, _validate.default)(uuid)) {
      throw TypeError("Invalid UUID");
    }
    let v22;
    const arr2 = new Uint8Array(16);
    arr2[0] = (v22 = parseInt(uuid.slice(0, 8), 16)) >>> 24;
    arr2[1] = v22 >>> 16 & 255;
    arr2[2] = v22 >>> 8 & 255;
    arr2[3] = v22 & 255;
    arr2[4] = (v22 = parseInt(uuid.slice(9, 13), 16)) >>> 8;
    arr2[5] = v22 & 255;
    arr2[6] = (v22 = parseInt(uuid.slice(14, 18), 16)) >>> 8;
    arr2[7] = v22 & 255;
    arr2[8] = (v22 = parseInt(uuid.slice(19, 23), 16)) >>> 8;
    arr2[9] = v22 & 255;
    arr2[10] = (v22 = parseInt(uuid.slice(24, 36), 16)) / 1099511627776 & 255;
    arr2[11] = v22 / 4294967296 & 255;
    arr2[12] = v22 >>> 24 & 255;
    arr2[13] = v22 >>> 16 & 255;
    arr2[14] = v22 >>> 8 & 255;
    arr2[15] = v22 & 255;
    return arr2;
  }
  var _default2 = parse8;
  exports.default = _default2;
});
var require_v35 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.URL = exports.DNS = undefined;
  exports.default = v35;
  var _stringify = require_stringify2();
  var _parse = _interopRequireDefault(require_parse3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function stringToBytes(str2) {
    str2 = unescape(encodeURIComponent(str2));
    const bytes = [];
    for (let i2 = 0;i2 < str2.length; ++i2) {
      bytes.push(str2.charCodeAt(i2));
    }
    return bytes;
  }
  var DNS = "6ba7b810-9dad-11d1-80b4-00c04fd430c8";
  exports.DNS = DNS;
  var URL2 = "6ba7b811-9dad-11d1-80b4-00c04fd430c8";
  exports.URL = URL2;
  function v35(name, version5, hashfunc) {
    function generateUUID(value, namespace, buf, offset2) {
      var _namespace;
      if (typeof value === "string") {
        value = stringToBytes(value);
      }
      if (typeof namespace === "string") {
        namespace = (0, _parse.default)(namespace);
      }
      if (((_namespace = namespace) === null || _namespace === undefined ? undefined : _namespace.length) !== 16) {
        throw TypeError("Namespace must be array-like (16 iterable integer values, 0-255)");
      }
      let bytes = new Uint8Array(16 + value.length);
      bytes.set(namespace);
      bytes.set(value, namespace.length);
      bytes = hashfunc(bytes);
      bytes[6] = bytes[6] & 15 | version5;
      bytes[8] = bytes[8] & 63 | 128;
      if (buf) {
        offset2 = offset2 || 0;
        for (let i2 = 0;i2 < 16; ++i2) {
          buf[offset2 + i2] = bytes[i2];
        }
        return buf;
      }
      return (0, _stringify.unsafeStringify)(bytes);
    }
    try {
      generateUUID.name = name;
    } catch (err22) {
    }
    generateUUID.DNS = DNS;
    generateUUID.URL = URL2;
    return generateUUID;
  }
});
var require_md52 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _crypto = _interopRequireDefault(import.meta.require("crypto"));
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function md52(bytes) {
    if (Array.isArray(bytes)) {
      bytes = Buffer.from(bytes);
    } else if (typeof bytes === "string") {
      bytes = Buffer.from(bytes, "utf8");
    }
    return _crypto.default.createHash("md5").update(bytes).digest();
  }
  var _default2 = md52;
  exports.default = _default2;
});
var require_v3 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _v = _interopRequireDefault(require_v35());
  var _md = _interopRequireDefault(require_md52());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var v3 = (0, _v.default)("v3", 48, _md.default);
  var _default2 = v3;
  exports.default = _default2;
});
var require_native = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _crypto = _interopRequireDefault(import.meta.require("crypto"));
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var _default2 = {
    randomUUID: _crypto.default.randomUUID
  };
  exports.default = _default2;
});
var require_v4 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _native = _interopRequireDefault(require_native());
  var _rng = _interopRequireDefault(require_rng());
  var _stringify = require_stringify2();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function v4(options3, buf, offset2) {
    if (_native.default.randomUUID && !buf && !options3) {
      return _native.default.randomUUID();
    }
    options3 = options3 || {};
    const rnds = options3.random || (options3.rng || _rng.default)();
    rnds[6] = rnds[6] & 15 | 64;
    rnds[8] = rnds[8] & 63 | 128;
    if (buf) {
      offset2 = offset2 || 0;
      for (let i2 = 0;i2 < 16; ++i2) {
        buf[offset2 + i2] = rnds[i2];
      }
      return buf;
    }
    return (0, _stringify.unsafeStringify)(rnds);
  }
  var _default2 = v4;
  exports.default = _default2;
});
var require_sha12 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _crypto = _interopRequireDefault(import.meta.require("crypto"));
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function sha1(bytes) {
    if (Array.isArray(bytes)) {
      bytes = Buffer.from(bytes);
    } else if (typeof bytes === "string") {
      bytes = Buffer.from(bytes, "utf8");
    }
    return _crypto.default.createHash("sha1").update(bytes).digest();
  }
  var _default2 = sha1;
  exports.default = _default2;
});
var require_v5 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _v = _interopRequireDefault(require_v35());
  var _sha = _interopRequireDefault(require_sha12());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var v5 = (0, _v.default)("v5", 80, _sha.default);
  var _default2 = v5;
  exports.default = _default2;
});
var require_nil = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _default2 = "00000000-0000-0000-0000-000000000000";
  exports.default = _default2;
});
var require_version = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var _validate = _interopRequireDefault(require_validate2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function version5(uuid) {
    if (!(0, _validate.default)(uuid)) {
      throw TypeError("Invalid UUID");
    }
    return parseInt(uuid.slice(14, 15), 16);
  }
  var _default2 = version5;
  exports.default = _default2;
});
var require_dist4 = __commonJS2((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, "NIL", {
    enumerable: true,
    get: function() {
      return _nil.default;
    }
  });
  Object.defineProperty(exports, "parse", {
    enumerable: true,
    get: function() {
      return _parse.default;
    }
  });
  Object.defineProperty(exports, "stringify", {
    enumerable: true,
    get: function() {
      return _stringify.default;
    }
  });
  Object.defineProperty(exports, "v1", {
    enumerable: true,
    get: function() {
      return _v.default;
    }
  });
  Object.defineProperty(exports, "v3", {
    enumerable: true,
    get: function() {
      return _v2.default;
    }
  });
  Object.defineProperty(exports, "v4", {
    enumerable: true,
    get: function() {
      return _v3.default;
    }
  });
  Object.defineProperty(exports, "v5", {
    enumerable: true,
    get: function() {
      return _v4.default;
    }
  });
  Object.defineProperty(exports, "validate", {
    enumerable: true,
    get: function() {
      return _validate.default;
    }
  });
  Object.defineProperty(exports, "version", {
    enumerable: true,
    get: function() {
      return _version.default;
    }
  });
  var _v = _interopRequireDefault(require_v1());
  var _v2 = _interopRequireDefault(require_v3());
  var _v3 = _interopRequireDefault(require_v4());
  var _v4 = _interopRequireDefault(require_v5());
  var _nil = _interopRequireDefault(require_nil());
  var _version = _interopRequireDefault(require_version());
  var _validate = _interopRequireDefault(require_validate2());
  var _stringify = _interopRequireDefault(require_stringify2());
  var _parse = _interopRequireDefault(require_parse3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
});
var import_dist;
var v1;
var v3;
var v4;
var v5;
var NIL;
var version5;
var validate22;
var stringify;
var parse8;
var init_wrapper = __esm2(() => {
  import_dist = __toESM3(require_dist4(), 1);
  v1 = import_dist.default.v1;
  v3 = import_dist.default.v3;
  v4 = import_dist.default.v4;
  v5 = import_dist.default.v5;
  NIL = import_dist.default.NIL;
  version5 = import_dist.default.version;
  validate22 = import_dist.default.validate;
  stringify = import_dist.default.stringify;
  parse8 = import_dist.default.parse;
});
var init_defaultRetryQuota = __esm2(() => {
  init_dist_es34();
});
var init_delayDecider = __esm2(() => {
  init_dist_es34();
});
var init_retryDecider = __esm2(() => {
  init_dist_es33();
});
var asSdkError = (error) => {
  if (error instanceof Error)
    return error;
  if (error instanceof Object)
    return Object.assign(new Error, error);
  if (typeof error === "string")
    return new Error(error);
  return new Error(`AWS SDK error wrapper for ${error}`);
};
var init_StandardRetryStrategy2 = __esm2(() => {
  init_dist_es();
  init_dist_es33();
  init_dist_es34();
  init_defaultRetryQuota();
  init_delayDecider();
  init_retryDecider();
});
var init_AdaptiveRetryStrategy2 = __esm2(() => {
  init_dist_es34();
  init_StandardRetryStrategy2();
});
var import_util_middleware8;
var ENV_MAX_ATTEMPTS = "AWS_MAX_ATTEMPTS";
var CONFIG_MAX_ATTEMPTS = "max_attempts";
var NODE_MAX_ATTEMPT_CONFIG_OPTIONS;
var resolveRetryConfig = (input) => {
  const { retryStrategy } = input;
  const maxAttempts = import_util_middleware8.normalizeProvider(input.maxAttempts ?? DEFAULT_MAX_ATTEMPTS);
  return {
    ...input,
    maxAttempts,
    retryStrategy: async () => {
      if (retryStrategy) {
        return retryStrategy;
      }
      const retryMode = await import_util_middleware8.normalizeProvider(input.retryMode)();
      if (retryMode === RETRY_MODES.ADAPTIVE) {
        return new AdaptiveRetryStrategy(maxAttempts);
      }
      return new StandardRetryStrategy(maxAttempts);
    }
  };
};
var ENV_RETRY_MODE = "AWS_RETRY_MODE";
var CONFIG_RETRY_MODE = "retry_mode";
var NODE_RETRY_MODE_CONFIG_OPTIONS;
var init_configurations2 = __esm2(() => {
  import_util_middleware8 = __toESM3(require_dist_cjs3(), 1);
  init_dist_es34();
  NODE_MAX_ATTEMPT_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => {
      const value = env62[ENV_MAX_ATTEMPTS];
      if (!value)
        return;
      const maxAttempt = parseInt(value);
      if (Number.isNaN(maxAttempt)) {
        throw new Error(`Environment variable ${ENV_MAX_ATTEMPTS} mast be a number, got "${value}"`);
      }
      return maxAttempt;
    },
    configFileSelector: (profile) => {
      const value = profile[CONFIG_MAX_ATTEMPTS];
      if (!value)
        return;
      const maxAttempt = parseInt(value);
      if (Number.isNaN(maxAttempt)) {
        throw new Error(`Shared config file entry ${CONFIG_MAX_ATTEMPTS} mast be a number, got "${value}"`);
      }
      return maxAttempt;
    },
    default: DEFAULT_MAX_ATTEMPTS
  };
  NODE_RETRY_MODE_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => env62[ENV_RETRY_MODE],
    configFileSelector: (profile) => profile[CONFIG_RETRY_MODE],
    default: DEFAULT_RETRY_MODE
  };
});
var init_omitRetryHeadersMiddleware = __esm2(() => {
  init_dist_es();
  init_dist_es34();
});
var isStreamingPayload = (request42) => request42?.body instanceof Readable4 || typeof ReadableStream !== "undefined" && request42?.body instanceof ReadableStream;
var init_isStreamingPayload = () => {
};
var retryMiddleware = (options3) => (next, context) => async (args) => {
  let retryStrategy = await options3.retryStrategy();
  const maxAttempts = await options3.maxAttempts();
  if (isRetryStrategyV2(retryStrategy)) {
    retryStrategy = retryStrategy;
    let retryToken = await retryStrategy.acquireInitialRetryToken(context["partition_id"]);
    let lastError = new Error;
    let attempts = 0;
    let totalRetryDelay = 0;
    const { request: request42 } = args;
    const isRequest = HttpRequest.isInstance(request42);
    if (isRequest) {
      request42.headers[INVOCATION_ID_HEADER] = v4();
    }
    while (true) {
      try {
        if (isRequest) {
          request42.headers[REQUEST_HEADER] = `attempt=${attempts + 1}; max=${maxAttempts}`;
        }
        const { response, output } = await next(args);
        retryStrategy.recordSuccess(retryToken);
        output.$metadata.attempts = attempts + 1;
        output.$metadata.totalRetryDelay = totalRetryDelay;
        return { response, output };
      } catch (e) {
        const retryErrorInfo = getRetryErrorInfo(e);
        lastError = asSdkError(e);
        if (isRequest && isStreamingPayload(request42)) {
          (context.logger instanceof NoOpLogger ? console : context.logger)?.warn("An error was encountered in a non-retryable streaming request.");
          throw lastError;
        }
        try {
          retryToken = await retryStrategy.refreshRetryTokenForRetry(retryToken, retryErrorInfo);
        } catch (refreshError) {
          if (!lastError.$metadata) {
            lastError.$metadata = {};
          }
          lastError.$metadata.attempts = attempts + 1;
          lastError.$metadata.totalRetryDelay = totalRetryDelay;
          throw lastError;
        }
        attempts = retryToken.getRetryCount();
        const delay = retryToken.getRetryDelay();
        totalRetryDelay += delay;
        await new Promise((resolve5) => setTimeout(resolve5, delay));
      }
    }
  } else {
    retryStrategy = retryStrategy;
    if (retryStrategy?.mode)
      context.userAgent = [...context.userAgent || [], ["cfg/retry-mode", retryStrategy.mode]];
    return retryStrategy.retry(next, args);
  }
};
var isRetryStrategyV2 = (retryStrategy) => typeof retryStrategy.acquireInitialRetryToken !== "undefined" && typeof retryStrategy.refreshRetryTokenForRetry !== "undefined" && typeof retryStrategy.recordSuccess !== "undefined";
var getRetryErrorInfo = (error) => {
  const errorInfo = {
    error,
    errorType: getRetryErrorType(error)
  };
  const retryAfterHint = getRetryAfterHint(error.$response);
  if (retryAfterHint) {
    errorInfo.retryAfterHint = retryAfterHint;
  }
  return errorInfo;
};
var getRetryErrorType = (error) => {
  if (isThrottlingError(error))
    return "THROTTLING";
  if (isTransientError(error))
    return "TRANSIENT";
  if (isServerError(error))
    return "SERVER_ERROR";
  return "CLIENT_ERROR";
};
var retryMiddlewareOptions;
var getRetryPlugin = (options3) => ({
  applyToStack: (clientStack) => {
    clientStack.add(retryMiddleware(options3), retryMiddlewareOptions);
  }
});
var getRetryAfterHint = (response) => {
  if (!HttpResponse.isInstance(response))
    return;
  const retryAfterHeaderName = Object.keys(response.headers).find((key2) => key2.toLowerCase() === "retry-after");
  if (!retryAfterHeaderName)
    return;
  const retryAfter = response.headers[retryAfterHeaderName];
  const retryAfterSeconds = Number(retryAfter);
  if (!Number.isNaN(retryAfterSeconds))
    return new Date(retryAfterSeconds * 1000);
  const retryAfterDate = new Date(retryAfter);
  return retryAfterDate;
};
var init_retryMiddleware = __esm2(() => {
  init_dist_es();
  init_dist_es33();
  init_dist_es12();
  init_dist_es34();
  init_wrapper();
  init_isStreamingPayload();
  retryMiddlewareOptions = {
    name: "retryMiddleware",
    tags: ["RETRY"],
    step: "finalizeRequest",
    priority: "high",
    override: true
  };
});
var init_dist_es35 = __esm2(() => {
  init_AdaptiveRetryStrategy2();
  init_StandardRetryStrategy2();
  init_configurations2();
  init_delayDecider();
  init_omitRetryHeadersMiddleware();
  init_retryDecider();
  init_retryMiddleware();
});
var signatureV4CrtContainer;
var init_signature_v4_crt_container = __esm2(() => {
  signatureV4CrtContainer = {
    CrtSignerV4: null
  };
});

class SignatureV4MultiRegion {
  constructor(options3) {
    this.sigv4Signer = new SignatureV4S3Express(options3);
    this.signerOptions = options3;
  }
  async sign(requestToSign, options3 = {}) {
    if (options3.signingRegion === "*") {
      if (this.signerOptions.runtime !== "node")
        throw new Error("This request requires signing with SigV4Asymmetric algorithm. It's only available in Node.js");
      return this.getSigv4aSigner().sign(requestToSign, options3);
    }
    return this.sigv4Signer.sign(requestToSign, options3);
  }
  async signWithCredentials(requestToSign, credentials, options3 = {}) {
    if (options3.signingRegion === "*") {
      if (this.signerOptions.runtime !== "node")
        throw new Error("This request requires signing with SigV4Asymmetric algorithm. It's only available in Node.js");
      return this.getSigv4aSigner().signWithCredentials(requestToSign, credentials, options3);
    }
    return this.sigv4Signer.signWithCredentials(requestToSign, credentials, options3);
  }
  async presign(originalRequest, options3 = {}) {
    if (options3.signingRegion === "*") {
      if (this.signerOptions.runtime !== "node")
        throw new Error("This request requires signing with SigV4Asymmetric algorithm. It's only available in Node.js");
      return this.getSigv4aSigner().presign(originalRequest, options3);
    }
    return this.sigv4Signer.presign(originalRequest, options3);
  }
  async presignWithCredentials(originalRequest, credentials, options3 = {}) {
    if (options3.signingRegion === "*") {
      throw new Error("Method presignWithCredentials is not supported for [signingRegion=*].");
    }
    return this.sigv4Signer.presignWithCredentials(originalRequest, credentials, options3);
  }
  getSigv4aSigner() {
    if (!this.sigv4aSigner) {
      let CrtSignerV4 = null;
      try {
        CrtSignerV4 = signatureV4CrtContainer.CrtSignerV4;
        if (typeof CrtSignerV4 !== "function")
          throw new Error;
      } catch (e) {
        e.message = `${e.message}\nPlease check whether you have installed the "@aws-sdk/signature-v4-crt" package explicitly. \nYou must also register the package by calling [require("@aws-sdk/signature-v4-crt");] or an ESM equivalent such as [import "@aws-sdk/signature-v4-crt";]. \nFor more information please go to https://github.com/aws/aws-sdk-js-v3#functionality-requiring-aws-common-runtime-crt`;
        throw e;
      }
      this.sigv4aSigner = new CrtSignerV4({
        ...this.signerOptions,
        signingAlgorithm: 1
      });
    }
    return this.sigv4aSigner;
  }
}
var init_SignatureV4MultiRegion = __esm2(() => {
  init_dist_es20();
  init_signature_v4_crt_container();
});
var init_dist_es36 = __esm2(() => {
  init_SignatureV4MultiRegion();
  init_signature_v4_crt_container();
});
var ce = "required";
var cf = "type";
var cg = "conditions";
var ch = "fn";
var ci = "argv";
var cj = "ref";
var ck = "assign";
var cl = "url";
var cm = "properties";
var cn = "backend";
var co = "authSchemes";
var cp = "disableDoubleEncoding";
var cq = "signingName";
var cr = "signingRegion";
var cs = "headers";
var ct2 = "signingRegionSet";
var a = false;
var b22 = true;
var c22 = "isSet";
var d = "booleanEquals";
var e = "error";
var f22 = "aws.partition";
var g22 = "stringEquals";
var h22 = "getAttr";
var i = "name";
var j22 = "substring";
var k = "bucketSuffix";
var l22 = "parseURL";
var m22 = "{url#scheme}://{url#authority}/{uri_encoded_bucket}{url#path}";
var n = "endpoint";
var o = "tree";
var p32 = "aws.isVirtualHostableS3Bucket";
var q22 = "{url#scheme}://{Bucket}.{url#authority}{url#path}";
var r22 = "not";
var s4 = "{url#scheme}://{url#authority}{url#path}";
var t = "hardwareType";
var u = "regionPrefix";
var v22 = "bucketAliasSuffix";
var w22 = "outpostId";
var x = "isValidHostLabel";
var y = "sigv4a";
var z22 = "s3-outposts";
var A = "s3";
var B = "{url#scheme}://{url#authority}{url#normalizedPath}{Bucket}";
var C2 = "https://{Bucket}.s3-accelerate.{partitionResult#dnsSuffix}";
var D = "https://{Bucket}.s3.{partitionResult#dnsSuffix}";
var E = "aws.parseArn";
var F = "bucketArn";
var G22 = "arnType";
var H22 = "";
var I22 = "s3-object-lambda";
var J22 = "accesspoint";
var K22 = "accessPointName";
var L22 = "{url#scheme}://{accessPointName}-{bucketArn#accountId}.{url#authority}{url#path}";
var M22 = "mrapPartition";
var N22 = "outpostType";
var O2 = "arnPrefix";
var P22 = "{url#scheme}://{url#authority}{url#normalizedPath}{uri_encoded_bucket}";
var Q22 = "https://s3.{partitionResult#dnsSuffix}/{uri_encoded_bucket}";
var R22 = "https://s3.{partitionResult#dnsSuffix}";
var S;
var T22;
var U22;
var V22;
var W22;
var X22;
var Y22;
var Z22;
var aa;
var ab;
var ac;
var ad;
var ae;
var af;
var ag;
var ah;
var ai3;
var aj;
var ak;
var al;
var am;
var an;
var ao;
var ap;
var aq;
var ar;
var as;
var at3;
var au;
var av;
var aw;
var ax;
var ay;
var az;
var aA;
var aB;
var aC;
var aD;
var aE;
var aF;
var aG;
var aH;
var aI;
var aJ;
var aK;
var aL;
var aM;
var aN;
var aO;
var aP;
var aQ;
var aR;
var aS;
var aT;
var aU;
var aV;
var aW;
var aX;
var aY;
var aZ;
var ba;
var bb;
var bc;
var bd;
var be;
var bf;
var bg;
var bh;
var bi;
var bj;
var bk;
var bl;
var bm;
var bn;
var bo;
var bp;
var bq;
var br;
var bs;
var bt2;
var bu;
var bv;
var bw;
var bx;
var by;
var bz;
var bA;
var bB;
var bC;
var bD;
var bE;
var bF;
var bG;
var bH;
var bI;
var bJ;
var bK;
var bL;
var bM;
var bN;
var bO;
var bP;
var bQ;
var bR;
var bS;
var bT;
var bU;
var bV;
var bW;
var bX;
var bY;
var bZ;
var ca;
var cb;
var cc;
var cd;
var _data;
var ruleSet;
var init_ruleset = __esm2(() => {
  S = { [ce]: false, [cf]: "String" };
  T22 = { [ce]: true, default: false, [cf]: "Boolean" };
  U22 = { [ce]: false, [cf]: "Boolean" };
  V22 = { [ch]: d, [ci]: [{ [cj]: "Accelerate" }, true] };
  W22 = { [ch]: d, [ci]: [{ [cj]: "UseFIPS" }, true] };
  X22 = { [ch]: d, [ci]: [{ [cj]: "UseDualStack" }, true] };
  Y22 = { [ch]: c22, [ci]: [{ [cj]: "Endpoint" }] };
  Z22 = { [ch]: f22, [ci]: [{ [cj]: "Region" }], [ck]: "partitionResult" };
  aa = { [ch]: g22, [ci]: [{ [ch]: h22, [ci]: [{ [cj]: "partitionResult" }, i] }, "aws-cn"] };
  ab = { [ch]: c22, [ci]: [{ [cj]: "Bucket" }] };
  ac = { [cj]: "Bucket" };
  ad = { [ch]: l22, [ci]: [{ [cj]: "Endpoint" }], [ck]: "url" };
  ae = { [ch]: d, [ci]: [{ [ch]: h22, [ci]: [{ [cj]: "url" }, "isIp"] }, true] };
  af = { [cj]: "url" };
  ag = { [ch]: "uriEncode", [ci]: [ac], [ck]: "uri_encoded_bucket" };
  ah = { [cn]: "S3Express", [co]: [{ [cp]: true, [i]: "sigv4", [cq]: "s3express", [cr]: "{Region}" }] };
  ai3 = {};
  aj = { [ch]: p32, [ci]: [ac, false] };
  ak = { [e]: "S3Express bucket name is not a valid virtual hostable name.", [cf]: e };
  al = { [cn]: "S3Express", [co]: [{ [cp]: true, [i]: "sigv4-s3express", [cq]: "s3express", [cr]: "{Region}" }] };
  am = { [ch]: c22, [ci]: [{ [cj]: "UseS3ExpressControlEndpoint" }] };
  an = { [ch]: d, [ci]: [{ [cj]: "UseS3ExpressControlEndpoint" }, true] };
  ao = { [ch]: r22, [ci]: [Y22] };
  ap = { [e]: "Unrecognized S3Express bucket name format.", [cf]: e };
  aq = { [ch]: r22, [ci]: [ab] };
  ar = { [cj]: t };
  as = { [cg]: [ao], [e]: "Expected a endpoint to be specified but no endpoint was found", [cf]: e };
  at3 = { [co]: [{ [cp]: true, [i]: y, [cq]: z22, [ct2]: ["*"] }, { [cp]: true, [i]: "sigv4", [cq]: z22, [cr]: "{Region}" }] };
  au = { [ch]: d, [ci]: [{ [cj]: "ForcePathStyle" }, false] };
  av = { [cj]: "ForcePathStyle" };
  aw = { [ch]: d, [ci]: [{ [cj]: "Accelerate" }, false] };
  ax = { [ch]: g22, [ci]: [{ [cj]: "Region" }, "aws-global"] };
  ay = { [co]: [{ [cp]: true, [i]: "sigv4", [cq]: A, [cr]: "us-east-1" }] };
  az = { [ch]: r22, [ci]: [ax] };
  aA = { [ch]: d, [ci]: [{ [cj]: "UseGlobalEndpoint" }, true] };
  aB = { [cl]: "https://{Bucket}.s3-fips.dualstack.{Region}.{partitionResult#dnsSuffix}", [cm]: { [co]: [{ [cp]: true, [i]: "sigv4", [cq]: A, [cr]: "{Region}" }] }, [cs]: {} };
  aC = { [co]: [{ [cp]: true, [i]: "sigv4", [cq]: A, [cr]: "{Region}" }] };
  aD = { [ch]: d, [ci]: [{ [cj]: "UseGlobalEndpoint" }, false] };
  aE = { [ch]: d, [ci]: [{ [cj]: "UseDualStack" }, false] };
  aF = { [cl]: "https://{Bucket}.s3-fips.{Region}.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  aG = { [ch]: d, [ci]: [{ [cj]: "UseFIPS" }, false] };
  aH = { [cl]: "https://{Bucket}.s3-accelerate.dualstack.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  aI = { [cl]: "https://{Bucket}.s3.dualstack.{Region}.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  aJ = { [ch]: d, [ci]: [{ [ch]: h22, [ci]: [af, "isIp"] }, false] };
  aK = { [cl]: B, [cm]: aC, [cs]: {} };
  aL = { [cl]: q22, [cm]: aC, [cs]: {} };
  aM = { [n]: aL, [cf]: n };
  aN = { [cl]: C2, [cm]: aC, [cs]: {} };
  aO = { [cl]: "https://{Bucket}.s3.{Region}.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  aP = { [e]: "Invalid region: region was not a valid DNS name.", [cf]: e };
  aQ = { [cj]: F };
  aR = { [cj]: G22 };
  aS = { [ch]: h22, [ci]: [aQ, "service"] };
  aT = { [cj]: K22 };
  aU = { [cg]: [X22], [e]: "S3 Object Lambda does not support Dual-stack", [cf]: e };
  aV = { [cg]: [V22], [e]: "S3 Object Lambda does not support S3 Accelerate", [cf]: e };
  aW = { [cg]: [{ [ch]: c22, [ci]: [{ [cj]: "DisableAccessPoints" }] }, { [ch]: d, [ci]: [{ [cj]: "DisableAccessPoints" }, true] }], [e]: "Access points are not supported for this operation", [cf]: e };
  aX = { [cg]: [{ [ch]: c22, [ci]: [{ [cj]: "UseArnRegion" }] }, { [ch]: d, [ci]: [{ [cj]: "UseArnRegion" }, false] }, { [ch]: r22, [ci]: [{ [ch]: g22, [ci]: [{ [ch]: h22, [ci]: [aQ, "region"] }, "{Region}"] }] }], [e]: "Invalid configuration: region from ARN `{bucketArn#region}` does not match client region `{Region}` and UseArnRegion is `false`", [cf]: e };
  aY = { [ch]: h22, [ci]: [{ [cj]: "bucketPartition" }, i] };
  aZ = { [ch]: h22, [ci]: [aQ, "accountId"] };
  ba = { [co]: [{ [cp]: true, [i]: "sigv4", [cq]: I22, [cr]: "{bucketArn#region}" }] };
  bb = { [e]: "Invalid ARN: The access point name may only contain a-z, A-Z, 0-9 and `-`. Found: `{accessPointName}`", [cf]: e };
  bc = { [e]: "Invalid ARN: The account id may only contain a-z, A-Z, 0-9 and `-`. Found: `{bucketArn#accountId}`", [cf]: e };
  bd = { [e]: "Invalid region in ARN: `{bucketArn#region}` (invalid DNS name)", [cf]: e };
  be = { [e]: "Client was configured for partition `{partitionResult#name}` but ARN (`{Bucket}`) has `{bucketPartition#name}`", [cf]: e };
  bf = { [e]: "Invalid ARN: The ARN may only contain a single resource component after `accesspoint`.", [cf]: e };
  bg = { [e]: "Invalid ARN: Expected a resource of the format `accesspoint:<accesspoint name>` but no name was provided", [cf]: e };
  bh = { [co]: [{ [cp]: true, [i]: "sigv4", [cq]: A, [cr]: "{bucketArn#region}" }] };
  bi = { [co]: [{ [cp]: true, [i]: y, [cq]: z22, [ct2]: ["*"] }, { [cp]: true, [i]: "sigv4", [cq]: z22, [cr]: "{bucketArn#region}" }] };
  bj = { [ch]: E, [ci]: [ac] };
  bk = { [cl]: "https://s3-fips.dualstack.{Region}.{partitionResult#dnsSuffix}/{uri_encoded_bucket}", [cm]: aC, [cs]: {} };
  bl = { [cl]: "https://s3-fips.{Region}.{partitionResult#dnsSuffix}/{uri_encoded_bucket}", [cm]: aC, [cs]: {} };
  bm = { [cl]: "https://s3.dualstack.{Region}.{partitionResult#dnsSuffix}/{uri_encoded_bucket}", [cm]: aC, [cs]: {} };
  bn = { [cl]: P22, [cm]: aC, [cs]: {} };
  bo = { [cl]: "https://s3.{Region}.{partitionResult#dnsSuffix}/{uri_encoded_bucket}", [cm]: aC, [cs]: {} };
  bp = { [cj]: "UseObjectLambdaEndpoint" };
  bq = { [co]: [{ [cp]: true, [i]: "sigv4", [cq]: I22, [cr]: "{Region}" }] };
  br = { [cl]: "https://s3-fips.dualstack.{Region}.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  bs = { [cl]: "https://s3-fips.{Region}.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  bt2 = { [cl]: "https://s3.dualstack.{Region}.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  bu = { [cl]: s4, [cm]: aC, [cs]: {} };
  bv = { [cl]: "https://s3.{Region}.{partitionResult#dnsSuffix}", [cm]: aC, [cs]: {} };
  bw = [{ [cj]: "Region" }];
  bx = [{ [cj]: "Endpoint" }];
  by = [ac];
  bz = [X22];
  bA = [V22];
  bB = [Y22, ad];
  bC = [{ [ch]: c22, [ci]: [{ [cj]: "DisableS3ExpressSessionAuth" }] }, { [ch]: d, [ci]: [{ [cj]: "DisableS3ExpressSessionAuth" }, true] }];
  bD = [ae];
  bE = [ag];
  bF = [aj];
  bG = [W22];
  bH = [{ [ch]: j22, [ci]: [ac, 6, 14, true], [ck]: "s3expressAvailabilityZoneId" }, { [ch]: j22, [ci]: [ac, 14, 16, true], [ck]: "s3expressAvailabilityZoneDelim" }, { [ch]: g22, [ci]: [{ [cj]: "s3expressAvailabilityZoneDelim" }, "--"] }];
  bI = [{ [cg]: [W22], [n]: { [cl]: "https://{Bucket}.s3express-fips-{s3expressAvailabilityZoneId}.{Region}.amazonaws.com", [cm]: ah, [cs]: {} }, [cf]: n }, { [n]: { [cl]: "https://{Bucket}.s3express-{s3expressAvailabilityZoneId}.{Region}.amazonaws.com", [cm]: ah, [cs]: {} }, [cf]: n }];
  bJ = [{ [ch]: j22, [ci]: [ac, 6, 15, true], [ck]: "s3expressAvailabilityZoneId" }, { [ch]: j22, [ci]: [ac, 15, 17, true], [ck]: "s3expressAvailabilityZoneDelim" }, { [ch]: g22, [ci]: [{ [cj]: "s3expressAvailabilityZoneDelim" }, "--"] }];
  bK = [{ [cg]: [W22], [n]: { [cl]: "https://{Bucket}.s3express-fips-{s3expressAvailabilityZoneId}.{Region}.amazonaws.com", [cm]: al, [cs]: {} }, [cf]: n }, { [n]: { [cl]: "https://{Bucket}.s3express-{s3expressAvailabilityZoneId}.{Region}.amazonaws.com", [cm]: al, [cs]: {} }, [cf]: n }];
  bL = [ab];
  bM = [{ [ch]: x, [ci]: [{ [cj]: w22 }, false] }];
  bN = [{ [ch]: g22, [ci]: [{ [cj]: u }, "beta"] }];
  bO = ["*"];
  bP = [Z22];
  bQ = [{ [ch]: x, [ci]: [{ [cj]: "Region" }, false] }];
  bR = [{ [ch]: g22, [ci]: [{ [cj]: "Region" }, "us-east-1"] }];
  bS = [{ [ch]: g22, [ci]: [aR, J22] }];
  bT = [{ [ch]: h22, [ci]: [aQ, "resourceId[1]"], [ck]: K22 }, { [ch]: r22, [ci]: [{ [ch]: g22, [ci]: [aT, H22] }] }];
  bU = [aQ, "resourceId[1]"];
  bV = [{ [ch]: r22, [ci]: [{ [ch]: g22, [ci]: [{ [ch]: h22, [ci]: [aQ, "region"] }, H22] }] }];
  bW = [{ [ch]: r22, [ci]: [{ [ch]: c22, [ci]: [{ [ch]: h22, [ci]: [aQ, "resourceId[2]"] }] }] }];
  bX = [aQ, "resourceId[2]"];
  bY = [{ [ch]: f22, [ci]: [{ [ch]: h22, [ci]: [aQ, "region"] }], [ck]: "bucketPartition" }];
  bZ = [{ [ch]: g22, [ci]: [aY, { [ch]: h22, [ci]: [{ [cj]: "partitionResult" }, i] }] }];
  ca = [{ [ch]: x, [ci]: [{ [ch]: h22, [ci]: [aQ, "region"] }, true] }];
  cb = [{ [ch]: x, [ci]: [aZ, false] }];
  cc = [{ [ch]: x, [ci]: [aT, false] }];
  cd = [{ [ch]: x, [ci]: [{ [cj]: "Region" }, true] }];
  _data = { version: "1.0", parameters: { Bucket: S, Region: S, UseFIPS: T22, UseDualStack: T22, Endpoint: S, ForcePathStyle: T22, Accelerate: T22, UseGlobalEndpoint: T22, UseObjectLambdaEndpoint: U22, Key: S, Prefix: S, CopySource: S, DisableAccessPoints: U22, DisableMultiRegionAccessPoints: T22, UseArnRegion: U22, UseS3ExpressControlEndpoint: U22, DisableS3ExpressSessionAuth: U22 }, rules: [{ [cg]: [{ [ch]: c22, [ci]: bw }], rules: [{ [cg]: [V22, W22], error: "Accelerate cannot be used with FIPS", [cf]: e }, { [cg]: [X22, Y22], error: "Cannot set dual-stack in combination with a custom endpoint.", [cf]: e }, { [cg]: [Y22, W22], error: "A custom endpoint cannot be combined with FIPS", [cf]: e }, { [cg]: [Y22, V22], error: "A custom endpoint cannot be combined with S3 Accelerate", [cf]: e }, { [cg]: [W22, Z22, aa], error: "Partition does not support FIPS", [cf]: e }, { [cg]: [ab, { [ch]: j22, [ci]: [ac, 0, 6, b22], [ck]: k }, { [ch]: g22, [ci]: [{ [cj]: k }, "--x-s3"] }], rules: [{ [cg]: bz, error: "S3Express does not support Dual-stack.", [cf]: e }, { [cg]: bA, error: "S3Express does not support S3 Accelerate.", [cf]: e }, { [cg]: bB, rules: [{ [cg]: bC, rules: [{ [cg]: bD, rules: [{ [cg]: bE, rules: [{ endpoint: { [cl]: m22, [cm]: ah, [cs]: ai3 }, [cf]: n }], [cf]: o }], [cf]: o }, { [cg]: bF, rules: [{ endpoint: { [cl]: q22, [cm]: ah, [cs]: ai3 }, [cf]: n }], [cf]: o }, ak], [cf]: o }, { [cg]: bD, rules: [{ [cg]: bE, rules: [{ endpoint: { [cl]: m22, [cm]: al, [cs]: ai3 }, [cf]: n }], [cf]: o }], [cf]: o }, { [cg]: bF, rules: [{ endpoint: { [cl]: q22, [cm]: al, [cs]: ai3 }, [cf]: n }], [cf]: o }, ak], [cf]: o }, { [cg]: [am, an], rules: [{ [cg]: [ag, ao], rules: [{ [cg]: bG, endpoint: { [cl]: "https://s3express-control-fips.{Region}.amazonaws.com/{uri_encoded_bucket}", [cm]: ah, [cs]: ai3 }, [cf]: n }, { endpoint: { [cl]: "https://s3express-control.{Region}.amazonaws.com/{uri_encoded_bucket}", [cm]: ah, [cs]: ai3 }, [cf]: n }], [cf]: o }], [cf]: o }, { [cg]: bF, rules: [{ [cg]: bC, rules: [{ [cg]: bH, rules: bI, [cf]: o }, { [cg]: bJ, rules: bI, [cf]: o }, ap], [cf]: o }, { [cg]: bH, rules: bK, [cf]: o }, { [cg]: bJ, rules: bK, [cf]: o }, ap], [cf]: o }, ak], [cf]: o }, { [cg]: [aq, am, an], rules: [{ [cg]: bB, endpoint: { [cl]: s4, [cm]: ah, [cs]: ai3 }, [cf]: n }, { [cg]: bG, endpoint: { [cl]: "https://s3express-control-fips.{Region}.amazonaws.com", [cm]: ah, [cs]: ai3 }, [cf]: n }, { endpoint: { [cl]: "https://s3express-control.{Region}.amazonaws.com", [cm]: ah, [cs]: ai3 }, [cf]: n }], [cf]: o }, { [cg]: [ab, { [ch]: j22, [ci]: [ac, 49, 50, b22], [ck]: t }, { [ch]: j22, [ci]: [ac, 8, 12, b22], [ck]: u }, { [ch]: j22, [ci]: [ac, 0, 7, b22], [ck]: v22 }, { [ch]: j22, [ci]: [ac, 32, 49, b22], [ck]: w22 }, { [ch]: f22, [ci]: bw, [ck]: "regionPartition" }, { [ch]: g22, [ci]: [{ [cj]: v22 }, "--op-s3"] }], rules: [{ [cg]: bM, rules: [{ [cg]: [{ [ch]: g22, [ci]: [ar, "e"] }], rules: [{ [cg]: bN, rules: [as, { [cg]: bB, endpoint: { [cl]: "https://{Bucket}.ec2.{url#authority}", [cm]: at3, [cs]: ai3 }, [cf]: n }], [cf]: o }, { endpoint: { [cl]: "https://{Bucket}.ec2.s3-outposts.{Region}.{regionPartition#dnsSuffix}", [cm]: at3, [cs]: ai3 }, [cf]: n }], [cf]: o }, { [cg]: [{ [ch]: g22, [ci]: [ar, "o"] }], rules: [{ [cg]: bN, rules: [as, { [cg]: bB, endpoint: { [cl]: "https://{Bucket}.op-{outpostId}.{url#authority}", [cm]: at3, [cs]: ai3 }, [cf]: n }], [cf]: o }, { endpoint: { [cl]: "https://{Bucket}.op-{outpostId}.s3-outposts.{Region}.{regionPartition#dnsSuffix}", [cm]: at3, [cs]: ai3 }, [cf]: n }], [cf]: o }, { error: "Unrecognized hardware type: \"Expected hardware type o or e but got {hardwareType}\"", [cf]: e }], [cf]: o }, { error: "Invalid ARN: The outpost Id must only contain a-z, A-Z, 0-9 and `-`.", [cf]: e }], [cf]: o }, { [cg]: bL, rules: [{ [cg]: [Y22, { [ch]: r22, [ci]: [{ [ch]: c22, [ci]: [{ [ch]: l22, [ci]: bx }] }] }], error: "Custom endpoint `{Endpoint}` was not a valid URI", [cf]: e }, { [cg]: [au, aj], rules: [{ [cg]: bP, rules: [{ [cg]: bQ, rules: [{ [cg]: [V22, aa], error: "S3 Accelerate cannot be used in this region", [cf]: e }, { [cg]: [X22, W22, aw, ao, ax], endpoint: { [cl]: "https://{Bucket}.s3-fips.dualstack.us-east-1.{partitionResult#dnsSuffix}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [X22, W22, aw, ao, az, aA], rules: [{ endpoint: aB, [cf]: n }], [cf]: o }, { [cg]: [X22, W22, aw, ao, az, aD], endpoint: aB, [cf]: n }, { [cg]: [aE, W22, aw, ao, ax], endpoint: { [cl]: "https://{Bucket}.s3-fips.us-east-1.{partitionResult#dnsSuffix}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, W22, aw, ao, az, aA], rules: [{ endpoint: aF, [cf]: n }], [cf]: o }, { [cg]: [aE, W22, aw, ao, az, aD], endpoint: aF, [cf]: n }, { [cg]: [X22, aG, V22, ao, ax], endpoint: { [cl]: "https://{Bucket}.s3-accelerate.dualstack.us-east-1.{partitionResult#dnsSuffix}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [X22, aG, V22, ao, az, aA], rules: [{ endpoint: aH, [cf]: n }], [cf]: o }, { [cg]: [X22, aG, V22, ao, az, aD], endpoint: aH, [cf]: n }, { [cg]: [X22, aG, aw, ao, ax], endpoint: { [cl]: "https://{Bucket}.s3.dualstack.us-east-1.{partitionResult#dnsSuffix}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [X22, aG, aw, ao, az, aA], rules: [{ endpoint: aI, [cf]: n }], [cf]: o }, { [cg]: [X22, aG, aw, ao, az, aD], endpoint: aI, [cf]: n }, { [cg]: [aE, aG, aw, Y22, ad, ae, ax], endpoint: { [cl]: B, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, aG, aw, Y22, ad, aJ, ax], endpoint: { [cl]: q22, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, aG, aw, Y22, ad, ae, az, aA], rules: [{ [cg]: bR, endpoint: aK, [cf]: n }, { endpoint: aK, [cf]: n }], [cf]: o }, { [cg]: [aE, aG, aw, Y22, ad, aJ, az, aA], rules: [{ [cg]: bR, endpoint: aL, [cf]: n }, aM], [cf]: o }, { [cg]: [aE, aG, aw, Y22, ad, ae, az, aD], endpoint: aK, [cf]: n }, { [cg]: [aE, aG, aw, Y22, ad, aJ, az, aD], endpoint: aL, [cf]: n }, { [cg]: [aE, aG, V22, ao, ax], endpoint: { [cl]: C2, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, aG, V22, ao, az, aA], rules: [{ [cg]: bR, endpoint: aN, [cf]: n }, { endpoint: aN, [cf]: n }], [cf]: o }, { [cg]: [aE, aG, V22, ao, az, aD], endpoint: aN, [cf]: n }, { [cg]: [aE, aG, aw, ao, ax], endpoint: { [cl]: D, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, aG, aw, ao, az, aA], rules: [{ [cg]: bR, endpoint: { [cl]: D, [cm]: aC, [cs]: ai3 }, [cf]: n }, { endpoint: aO, [cf]: n }], [cf]: o }, { [cg]: [aE, aG, aw, ao, az, aD], endpoint: aO, [cf]: n }], [cf]: o }, aP], [cf]: o }], [cf]: o }, { [cg]: [Y22, ad, { [ch]: g22, [ci]: [{ [ch]: h22, [ci]: [af, "scheme"] }, "http"] }, { [ch]: p32, [ci]: [ac, b22] }, au, aG, aE, aw], rules: [{ [cg]: bP, rules: [{ [cg]: bQ, rules: [aM], [cf]: o }, aP], [cf]: o }], [cf]: o }, { [cg]: [au, { [ch]: E, [ci]: by, [ck]: F }], rules: [{ [cg]: [{ [ch]: h22, [ci]: [aQ, "resourceId[0]"], [ck]: G22 }, { [ch]: r22, [ci]: [{ [ch]: g22, [ci]: [aR, H22] }] }], rules: [{ [cg]: [{ [ch]: g22, [ci]: [aS, I22] }], rules: [{ [cg]: bS, rules: [{ [cg]: bT, rules: [aU, aV, { [cg]: bV, rules: [aW, { [cg]: bW, rules: [aX, { [cg]: bY, rules: [{ [cg]: bP, rules: [{ [cg]: bZ, rules: [{ [cg]: ca, rules: [{ [cg]: [{ [ch]: g22, [ci]: [aZ, H22] }], error: "Invalid ARN: Missing account id", [cf]: e }, { [cg]: cb, rules: [{ [cg]: cc, rules: [{ [cg]: bB, endpoint: { [cl]: L22, [cm]: ba, [cs]: ai3 }, [cf]: n }, { [cg]: bG, endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.s3-object-lambda-fips.{bucketArn#region}.{bucketPartition#dnsSuffix}", [cm]: ba, [cs]: ai3 }, [cf]: n }, { endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.s3-object-lambda.{bucketArn#region}.{bucketPartition#dnsSuffix}", [cm]: ba, [cs]: ai3 }, [cf]: n }], [cf]: o }, bb], [cf]: o }, bc], [cf]: o }, bd], [cf]: o }, be], [cf]: o }], [cf]: o }], [cf]: o }, bf], [cf]: o }, { error: "Invalid ARN: bucket ARN is missing a region", [cf]: e }], [cf]: o }, bg], [cf]: o }, { error: "Invalid ARN: Object Lambda ARNs only support `accesspoint` arn types, but found: `{arnType}`", [cf]: e }], [cf]: o }, { [cg]: bS, rules: [{ [cg]: bT, rules: [{ [cg]: bV, rules: [{ [cg]: bS, rules: [{ [cg]: bV, rules: [aW, { [cg]: bW, rules: [aX, { [cg]: bY, rules: [{ [cg]: bP, rules: [{ [cg]: [{ [ch]: g22, [ci]: [aY, "{partitionResult#name}"] }], rules: [{ [cg]: ca, rules: [{ [cg]: [{ [ch]: g22, [ci]: [aS, A] }], rules: [{ [cg]: cb, rules: [{ [cg]: cc, rules: [{ [cg]: bA, error: "Access Points do not support S3 Accelerate", [cf]: e }, { [cg]: [W22, X22], endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.s3-accesspoint-fips.dualstack.{bucketArn#region}.{bucketPartition#dnsSuffix}", [cm]: bh, [cs]: ai3 }, [cf]: n }, { [cg]: [W22, aE], endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.s3-accesspoint-fips.{bucketArn#region}.{bucketPartition#dnsSuffix}", [cm]: bh, [cs]: ai3 }, [cf]: n }, { [cg]: [aG, X22], endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.s3-accesspoint.dualstack.{bucketArn#region}.{bucketPartition#dnsSuffix}", [cm]: bh, [cs]: ai3 }, [cf]: n }, { [cg]: [aG, aE, Y22, ad], endpoint: { [cl]: L22, [cm]: bh, [cs]: ai3 }, [cf]: n }, { [cg]: [aG, aE], endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.s3-accesspoint.{bucketArn#region}.{bucketPartition#dnsSuffix}", [cm]: bh, [cs]: ai3 }, [cf]: n }], [cf]: o }, bb], [cf]: o }, bc], [cf]: o }, { error: "Invalid ARN: The ARN was not for the S3 service, found: {bucketArn#service}", [cf]: e }], [cf]: o }, bd], [cf]: o }, be], [cf]: o }], [cf]: o }], [cf]: o }, bf], [cf]: o }], [cf]: o }], [cf]: o }, { [cg]: [{ [ch]: x, [ci]: [aT, b22] }], rules: [{ [cg]: bz, error: "S3 MRAP does not support dual-stack", [cf]: e }, { [cg]: bG, error: "S3 MRAP does not support FIPS", [cf]: e }, { [cg]: bA, error: "S3 MRAP does not support S3 Accelerate", [cf]: e }, { [cg]: [{ [ch]: d, [ci]: [{ [cj]: "DisableMultiRegionAccessPoints" }, b22] }], error: "Invalid configuration: Multi-Region Access Point ARNs are disabled.", [cf]: e }, { [cg]: [{ [ch]: f22, [ci]: bw, [ck]: M22 }], rules: [{ [cg]: [{ [ch]: g22, [ci]: [{ [ch]: h22, [ci]: [{ [cj]: M22 }, i] }, { [ch]: h22, [ci]: [aQ, "partition"] }] }], rules: [{ endpoint: { [cl]: "https://{accessPointName}.accesspoint.s3-global.{mrapPartition#dnsSuffix}", [cm]: { [co]: [{ [cp]: b22, name: y, [cq]: A, [ct2]: bO }] }, [cs]: ai3 }, [cf]: n }], [cf]: o }, { error: "Client was configured for partition `{mrapPartition#name}` but bucket referred to partition `{bucketArn#partition}`", [cf]: e }], [cf]: o }], [cf]: o }, { error: "Invalid Access Point Name", [cf]: e }], [cf]: o }, bg], [cf]: o }, { [cg]: [{ [ch]: g22, [ci]: [aS, z22] }], rules: [{ [cg]: bz, error: "S3 Outposts does not support Dual-stack", [cf]: e }, { [cg]: bG, error: "S3 Outposts does not support FIPS", [cf]: e }, { [cg]: bA, error: "S3 Outposts does not support S3 Accelerate", [cf]: e }, { [cg]: [{ [ch]: c22, [ci]: [{ [ch]: h22, [ci]: [aQ, "resourceId[4]"] }] }], error: "Invalid Arn: Outpost Access Point ARN contains sub resources", [cf]: e }, { [cg]: [{ [ch]: h22, [ci]: bU, [ck]: w22 }], rules: [{ [cg]: bM, rules: [aX, { [cg]: bY, rules: [{ [cg]: bP, rules: [{ [cg]: bZ, rules: [{ [cg]: ca, rules: [{ [cg]: cb, rules: [{ [cg]: [{ [ch]: h22, [ci]: bX, [ck]: N22 }], rules: [{ [cg]: [{ [ch]: h22, [ci]: [aQ, "resourceId[3]"], [ck]: K22 }], rules: [{ [cg]: [{ [ch]: g22, [ci]: [{ [cj]: N22 }, J22] }], rules: [{ [cg]: bB, endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.{outpostId}.{url#authority}", [cm]: bi, [cs]: ai3 }, [cf]: n }, { endpoint: { [cl]: "https://{accessPointName}-{bucketArn#accountId}.{outpostId}.s3-outposts.{bucketArn#region}.{bucketPartition#dnsSuffix}", [cm]: bi, [cs]: ai3 }, [cf]: n }], [cf]: o }, { error: "Expected an outpost type `accesspoint`, found {outpostType}", [cf]: e }], [cf]: o }, { error: "Invalid ARN: expected an access point name", [cf]: e }], [cf]: o }, { error: "Invalid ARN: Expected a 4-component resource", [cf]: e }], [cf]: o }, bc], [cf]: o }, bd], [cf]: o }, be], [cf]: o }], [cf]: o }], [cf]: o }, { error: "Invalid ARN: The outpost Id may only contain a-z, A-Z, 0-9 and `-`. Found: `{outpostId}`", [cf]: e }], [cf]: o }, { error: "Invalid ARN: The Outpost Id was not set", [cf]: e }], [cf]: o }, { error: "Invalid ARN: Unrecognized format: {Bucket} (type: {arnType})", [cf]: e }], [cf]: o }, { error: "Invalid ARN: No ARN type specified", [cf]: e }], [cf]: o }, { [cg]: [{ [ch]: j22, [ci]: [ac, 0, 4, a], [ck]: O2 }, { [ch]: g22, [ci]: [{ [cj]: O2 }, "arn:"] }, { [ch]: r22, [ci]: [{ [ch]: c22, [ci]: [bj] }] }], error: "Invalid ARN: `{Bucket}` was not a valid ARN", [cf]: e }, { [cg]: [{ [ch]: d, [ci]: [av, b22] }, bj], error: "Path-style addressing cannot be used with ARN buckets", [cf]: e }, { [cg]: bE, rules: [{ [cg]: bP, rules: [{ [cg]: [aw], rules: [{ [cg]: [X22, ao, W22, ax], endpoint: { [cl]: "https://s3-fips.dualstack.us-east-1.{partitionResult#dnsSuffix}/{uri_encoded_bucket}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [X22, ao, W22, az, aA], rules: [{ endpoint: bk, [cf]: n }], [cf]: o }, { [cg]: [X22, ao, W22, az, aD], endpoint: bk, [cf]: n }, { [cg]: [aE, ao, W22, ax], endpoint: { [cl]: "https://s3-fips.us-east-1.{partitionResult#dnsSuffix}/{uri_encoded_bucket}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, ao, W22, az, aA], rules: [{ endpoint: bl, [cf]: n }], [cf]: o }, { [cg]: [aE, ao, W22, az, aD], endpoint: bl, [cf]: n }, { [cg]: [X22, ao, aG, ax], endpoint: { [cl]: "https://s3.dualstack.us-east-1.{partitionResult#dnsSuffix}/{uri_encoded_bucket}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [X22, ao, aG, az, aA], rules: [{ endpoint: bm, [cf]: n }], [cf]: o }, { [cg]: [X22, ao, aG, az, aD], endpoint: bm, [cf]: n }, { [cg]: [aE, Y22, ad, aG, ax], endpoint: { [cl]: P22, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, Y22, ad, aG, az, aA], rules: [{ [cg]: bR, endpoint: bn, [cf]: n }, { endpoint: bn, [cf]: n }], [cf]: o }, { [cg]: [aE, Y22, ad, aG, az, aD], endpoint: bn, [cf]: n }, { [cg]: [aE, ao, aG, ax], endpoint: { [cl]: Q22, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aE, ao, aG, az, aA], rules: [{ [cg]: bR, endpoint: { [cl]: Q22, [cm]: aC, [cs]: ai3 }, [cf]: n }, { endpoint: bo, [cf]: n }], [cf]: o }, { [cg]: [aE, ao, aG, az, aD], endpoint: bo, [cf]: n }], [cf]: o }, { error: "Path-style addressing cannot be used with S3 Accelerate", [cf]: e }], [cf]: o }], [cf]: o }], [cf]: o }, { [cg]: [{ [ch]: c22, [ci]: [bp] }, { [ch]: d, [ci]: [bp, b22] }], rules: [{ [cg]: bP, rules: [{ [cg]: cd, rules: [aU, aV, { [cg]: bB, endpoint: { [cl]: s4, [cm]: bq, [cs]: ai3 }, [cf]: n }, { [cg]: bG, endpoint: { [cl]: "https://s3-object-lambda-fips.{Region}.{partitionResult#dnsSuffix}", [cm]: bq, [cs]: ai3 }, [cf]: n }, { endpoint: { [cl]: "https://s3-object-lambda.{Region}.{partitionResult#dnsSuffix}", [cm]: bq, [cs]: ai3 }, [cf]: n }], [cf]: o }, aP], [cf]: o }], [cf]: o }, { [cg]: [aq], rules: [{ [cg]: bP, rules: [{ [cg]: cd, rules: [{ [cg]: [W22, X22, ao, ax], endpoint: { [cl]: "https://s3-fips.dualstack.us-east-1.{partitionResult#dnsSuffix}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [W22, X22, ao, az, aA], rules: [{ endpoint: br, [cf]: n }], [cf]: o }, { [cg]: [W22, X22, ao, az, aD], endpoint: br, [cf]: n }, { [cg]: [W22, aE, ao, ax], endpoint: { [cl]: "https://s3-fips.us-east-1.{partitionResult#dnsSuffix}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [W22, aE, ao, az, aA], rules: [{ endpoint: bs, [cf]: n }], [cf]: o }, { [cg]: [W22, aE, ao, az, aD], endpoint: bs, [cf]: n }, { [cg]: [aG, X22, ao, ax], endpoint: { [cl]: "https://s3.dualstack.us-east-1.{partitionResult#dnsSuffix}", [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aG, X22, ao, az, aA], rules: [{ endpoint: bt2, [cf]: n }], [cf]: o }, { [cg]: [aG, X22, ao, az, aD], endpoint: bt2, [cf]: n }, { [cg]: [aG, aE, Y22, ad, ax], endpoint: { [cl]: s4, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aG, aE, Y22, ad, az, aA], rules: [{ [cg]: bR, endpoint: bu, [cf]: n }, { endpoint: bu, [cf]: n }], [cf]: o }, { [cg]: [aG, aE, Y22, ad, az, aD], endpoint: bu, [cf]: n }, { [cg]: [aG, aE, ao, ax], endpoint: { [cl]: R22, [cm]: ay, [cs]: ai3 }, [cf]: n }, { [cg]: [aG, aE, ao, az, aA], rules: [{ [cg]: bR, endpoint: { [cl]: R22, [cm]: aC, [cs]: ai3 }, [cf]: n }, { endpoint: bv, [cf]: n }], [cf]: o }, { [cg]: [aG, aE, ao, az, aD], endpoint: bv, [cf]: n }], [cf]: o }, aP], [cf]: o }], [cf]: o }], [cf]: o }, { error: "A region must be set when sending requests to S3.", [cf]: e }] };
  ruleSet = _data;
});
var cache3;
var defaultEndpointResolver = (endpointParams, context = {}) => {
  return cache3.get(endpointParams, () => resolveEndpoint(ruleSet, {
    endpointParams,
    logger: context.logger
  }));
};
var init_endpointResolver = __esm2(() => {
  init_dist_es22();
  init_dist_es21();
  init_ruleset();
  cache3 = new EndpointCache({
    size: 50,
    params: [
      "Accelerate",
      "Bucket",
      "DisableAccessPoints",
      "DisableMultiRegionAccessPoints",
      "DisableS3ExpressSessionAuth",
      "Endpoint",
      "ForcePathStyle",
      "Region",
      "UseArnRegion",
      "UseDualStack",
      "UseFIPS",
      "UseGlobalEndpoint",
      "UseObjectLambdaEndpoint",
      "UseS3ExpressControlEndpoint"
    ]
  });
  customEndpointFunctions.aws = awsEndpointFunctions;
});
function createAwsAuthSigv4HttpAuthOption(authParameters) {
  return {
    schemeId: "aws.auth#sigv4",
    signingProperties: {
      name: "s3",
      region: authParameters.region
    },
    propertiesExtractor: (config8, context) => ({
      signingProperties: {
        config: config8,
        context
      }
    })
  };
}
function createAwsAuthSigv4aHttpAuthOption(authParameters) {
  return {
    schemeId: "aws.auth#sigv4a",
    signingProperties: {
      name: "s3",
      region: authParameters.region
    },
    propertiesExtractor: (config8, context) => ({
      signingProperties: {
        config: config8,
        context
      }
    })
  };
}
var import_core10;
var import_util_middleware9;
var createEndpointRuleSetHttpAuthSchemeParametersProvider = (defaultHttpAuthSchemeParametersProvider) => async (config8, context, input) => {
  if (!input) {
    throw new Error(`Could not find \`input\` for \`defaultEndpointRuleSetHttpAuthSchemeParametersProvider\``);
  }
  const defaultParameters = await defaultHttpAuthSchemeParametersProvider(config8, context, input);
  const instructionsFn = import_util_middleware9.getSmithyContext(context)?.commandInstance?.constructor?.getEndpointParameterInstructions;
  if (!instructionsFn) {
    throw new Error(`getEndpointParameterInstructions() is not defined on \`${context.commandName}\``);
  }
  const endpointParameters = await resolveParams(input, { getEndpointParameterInstructions: instructionsFn }, config8);
  return Object.assign(defaultParameters, endpointParameters);
};
var _defaultS3HttpAuthSchemeParametersProvider = async (config8, context, input) => {
  return {
    operation: import_util_middleware9.getSmithyContext(context).operation,
    region: await import_util_middleware9.normalizeProvider(config8.region)() || (() => {
      throw new Error("expected `region` to be configured for `aws.auth#sigv4`");
    })()
  };
};
var defaultS3HttpAuthSchemeParametersProvider;
var createEndpointRuleSetHttpAuthSchemeProvider = (defaultEndpointResolver2, defaultHttpAuthSchemeResolver, createHttpAuthOptionFunctions) => {
  const endpointRuleSetHttpAuthSchemeProvider = (authParameters) => {
    const endpoint = defaultEndpointResolver2(authParameters);
    const authSchemes = endpoint.properties?.authSchemes;
    if (!authSchemes) {
      return defaultHttpAuthSchemeResolver(authParameters);
    }
    const options3 = [];
    for (const scheme of authSchemes) {
      const { name: resolvedName, properties = {}, ...rest } = scheme;
      const name = resolvedName.toLowerCase();
      if (resolvedName !== name) {
        console.warn(`HttpAuthScheme has been normalized with lowercasing: \`${resolvedName}\` to \`${name}\``);
      }
      let schemeId;
      if (name === "sigv4a") {
        schemeId = "aws.auth#sigv4a";
        const sigv4Present = authSchemes.find((s5) => {
          const name2 = s5.name.toLowerCase();
          return name2 !== "sigv4a" && name2.startsWith("sigv4");
        });
        if (!signatureV4CrtContainer.CrtSignerV4 && sigv4Present) {
          continue;
        }
      } else if (name.startsWith("sigv4")) {
        schemeId = "aws.auth#sigv4";
      } else {
        throw new Error(`Unknown HttpAuthScheme found in \`@smithy.rules#endpointRuleSet\`: \`${name}\``);
      }
      const createOption = createHttpAuthOptionFunctions[schemeId];
      if (!createOption) {
        throw new Error(`Could not find HttpAuthOption create function for \`${schemeId}\``);
      }
      const option = createOption(authParameters);
      option.schemeId = schemeId;
      option.signingProperties = { ...option.signingProperties || {}, ...rest, ...properties };
      options3.push(option);
    }
    return options3;
  };
  return endpointRuleSetHttpAuthSchemeProvider;
};
var _defaultS3HttpAuthSchemeProvider = (authParameters) => {
  const options3 = [];
  switch (authParameters.operation) {
    default: {
      options3.push(createAwsAuthSigv4HttpAuthOption(authParameters));
      options3.push(createAwsAuthSigv4aHttpAuthOption(authParameters));
    }
  }
  return options3;
};
var defaultS3HttpAuthSchemeProvider;
var resolveHttpAuthSchemeConfig = (config8) => {
  const config_0 = import_core10.resolveAwsSdkSigV4Config(config8);
  const config_1 = import_core10.resolveAwsSdkSigV4AConfig(config_0);
  return {
    ...config_1
  };
};
var init_httpAuthSchemeProvider = __esm2(() => {
  import_core10 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es36();
  init_dist_es32();
  import_util_middleware9 = __toESM3(require_dist_cjs3(), 1);
  init_endpointResolver();
  defaultS3HttpAuthSchemeParametersProvider = createEndpointRuleSetHttpAuthSchemeParametersProvider(_defaultS3HttpAuthSchemeParametersProvider);
  defaultS3HttpAuthSchemeProvider = createEndpointRuleSetHttpAuthSchemeProvider(defaultEndpointResolver, _defaultS3HttpAuthSchemeProvider, {
    "aws.auth#sigv4": createAwsAuthSigv4HttpAuthOption,
    "aws.auth#sigv4a": createAwsAuthSigv4aHttpAuthOption
  });
});
var resolveClientEndpointParameters = (options3) => {
  return {
    ...options3,
    useFipsEndpoint: options3.useFipsEndpoint ?? false,
    useDualstackEndpoint: options3.useDualstackEndpoint ?? false,
    forcePathStyle: options3.forcePathStyle ?? false,
    useAccelerateEndpoint: options3.useAccelerateEndpoint ?? false,
    useGlobalEndpoint: options3.useGlobalEndpoint ?? false,
    disableMultiregionAccessPoints: options3.disableMultiregionAccessPoints ?? false,
    defaultSigningName: "s3"
  };
};
var commonParams;
var init_EndpointParameters = __esm2(() => {
  commonParams = {
    ForcePathStyle: { type: "clientContextParams", name: "forcePathStyle" },
    UseArnRegion: { type: "clientContextParams", name: "useArnRegion" },
    DisableMultiRegionAccessPoints: { type: "clientContextParams", name: "disableMultiregionAccessPoints" },
    Accelerate: { type: "clientContextParams", name: "useAccelerateEndpoint" },
    DisableS3ExpressSessionAuth: { type: "clientContextParams", name: "disableS3ExpressSessionAuth" },
    UseGlobalEndpoint: { type: "builtInParams", name: "useGlobalEndpoint" },
    UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
    Endpoint: { type: "builtInParams", name: "endpoint" },
    Region: { type: "builtInParams", name: "region" },
    UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" }
  };
});
var S3ServiceException;
var init_S3ServiceException = __esm2(() => {
  init_dist_es12();
  S3ServiceException = class S3ServiceException2 extends ServiceException {
    constructor(options3) {
      super(options3);
      Object.setPrototypeOf(this, S3ServiceException2.prototype);
    }
  };
});
var NoSuchUpload;
var ObjectNotInActiveTierError;
var BucketAlreadyExists;
var BucketAlreadyOwnedByYou;
var NoSuchBucket;
var AnalyticsFilter;
var MetricsFilter;
var InvalidObjectState;
var NoSuchKey;
var NotFound;
var CompleteMultipartUploadOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING }
});
var CompleteMultipartUploadRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING }
});
var CopyObjectOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING }
});
var CopyObjectRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING },
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING },
  ...obj.CopySourceSSECustomerKey && { CopySourceSSECustomerKey: SENSITIVE_STRING }
});
var CreateMultipartUploadOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING }
});
var CreateMultipartUploadRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING },
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING }
});
var SessionCredentialsFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SecretAccessKey && { SecretAccessKey: SENSITIVE_STRING },
  ...obj.SessionToken && { SessionToken: SENSITIVE_STRING }
});
var CreateSessionOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING },
  ...obj.Credentials && { Credentials: SessionCredentialsFilterSensitiveLog(obj.Credentials) }
});
var CreateSessionRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING }
});
var ServerSideEncryptionByDefaultFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.KMSMasterKeyID && { KMSMasterKeyID: SENSITIVE_STRING }
});
var ServerSideEncryptionRuleFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.ApplyServerSideEncryptionByDefault && {
    ApplyServerSideEncryptionByDefault: ServerSideEncryptionByDefaultFilterSensitiveLog(obj.ApplyServerSideEncryptionByDefault)
  }
});
var ServerSideEncryptionConfigurationFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Rules && { Rules: obj.Rules.map((item) => ServerSideEncryptionRuleFilterSensitiveLog(item)) }
});
var GetBucketEncryptionOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.ServerSideEncryptionConfiguration && {
    ServerSideEncryptionConfiguration: ServerSideEncryptionConfigurationFilterSensitiveLog(obj.ServerSideEncryptionConfiguration)
  }
});
var SSEKMSFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.KeyId && { KeyId: SENSITIVE_STRING }
});
var InventoryEncryptionFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMS && { SSEKMS: SSEKMSFilterSensitiveLog(obj.SSEKMS) }
});
var InventoryS3BucketDestinationFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Encryption && { Encryption: InventoryEncryptionFilterSensitiveLog(obj.Encryption) }
});
var InventoryDestinationFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.S3BucketDestination && {
    S3BucketDestination: InventoryS3BucketDestinationFilterSensitiveLog(obj.S3BucketDestination)
  }
});
var InventoryConfigurationFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Destination && { Destination: InventoryDestinationFilterSensitiveLog(obj.Destination) }
});
var GetBucketInventoryConfigurationOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.InventoryConfiguration && {
    InventoryConfiguration: InventoryConfigurationFilterSensitiveLog(obj.InventoryConfiguration)
  }
});
var GetObjectOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING }
});
var GetObjectRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING }
});
var GetObjectAttributesRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING }
});
var GetObjectTorrentOutputFilterSensitiveLog = (obj) => ({
  ...obj
});
var HeadObjectOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING }
});
var HeadObjectRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING }
});
var ListBucketInventoryConfigurationsOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.InventoryConfigurationList && {
    InventoryConfigurationList: obj.InventoryConfigurationList.map((item) => InventoryConfigurationFilterSensitiveLog(item))
  }
});
var ListPartsRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING }
});
var PutBucketEncryptionRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.ServerSideEncryptionConfiguration && {
    ServerSideEncryptionConfiguration: ServerSideEncryptionConfigurationFilterSensitiveLog(obj.ServerSideEncryptionConfiguration)
  }
});
var PutBucketInventoryConfigurationRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.InventoryConfiguration && {
    InventoryConfiguration: InventoryConfigurationFilterSensitiveLog(obj.InventoryConfiguration)
  }
});
var init_models_0 = __esm2(() => {
  init_dist_es12();
  init_S3ServiceException();
  NoSuchUpload = class NoSuchUpload2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "NoSuchUpload",
        $fault: "client",
        ...opts
      });
      this.name = "NoSuchUpload";
      this.$fault = "client";
      Object.setPrototypeOf(this, NoSuchUpload2.prototype);
    }
  };
  ObjectNotInActiveTierError = class ObjectNotInActiveTierError2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "ObjectNotInActiveTierError",
        $fault: "client",
        ...opts
      });
      this.name = "ObjectNotInActiveTierError";
      this.$fault = "client";
      Object.setPrototypeOf(this, ObjectNotInActiveTierError2.prototype);
    }
  };
  BucketAlreadyExists = class BucketAlreadyExists2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "BucketAlreadyExists",
        $fault: "client",
        ...opts
      });
      this.name = "BucketAlreadyExists";
      this.$fault = "client";
      Object.setPrototypeOf(this, BucketAlreadyExists2.prototype);
    }
  };
  BucketAlreadyOwnedByYou = class BucketAlreadyOwnedByYou2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "BucketAlreadyOwnedByYou",
        $fault: "client",
        ...opts
      });
      this.name = "BucketAlreadyOwnedByYou";
      this.$fault = "client";
      Object.setPrototypeOf(this, BucketAlreadyOwnedByYou2.prototype);
    }
  };
  NoSuchBucket = class NoSuchBucket2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "NoSuchBucket",
        $fault: "client",
        ...opts
      });
      this.name = "NoSuchBucket";
      this.$fault = "client";
      Object.setPrototypeOf(this, NoSuchBucket2.prototype);
    }
  };
  (function(AnalyticsFilter2) {
    AnalyticsFilter2.visit = (value, visitor) => {
      if (value.Prefix !== undefined)
        return visitor.Prefix(value.Prefix);
      if (value.Tag !== undefined)
        return visitor.Tag(value.Tag);
      if (value.And !== undefined)
        return visitor.And(value.And);
      return visitor._(value.$unknown[0], value.$unknown[1]);
    };
  })(AnalyticsFilter || (AnalyticsFilter = {}));
  (function(MetricsFilter2) {
    MetricsFilter2.visit = (value, visitor) => {
      if (value.Prefix !== undefined)
        return visitor.Prefix(value.Prefix);
      if (value.Tag !== undefined)
        return visitor.Tag(value.Tag);
      if (value.AccessPointArn !== undefined)
        return visitor.AccessPointArn(value.AccessPointArn);
      if (value.And !== undefined)
        return visitor.And(value.And);
      return visitor._(value.$unknown[0], value.$unknown[1]);
    };
  })(MetricsFilter || (MetricsFilter = {}));
  InvalidObjectState = class InvalidObjectState2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "InvalidObjectState",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidObjectState";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidObjectState2.prototype);
      this.StorageClass = opts.StorageClass;
      this.AccessTier = opts.AccessTier;
    }
  };
  NoSuchKey = class NoSuchKey2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "NoSuchKey",
        $fault: "client",
        ...opts
      });
      this.name = "NoSuchKey";
      this.$fault = "client";
      Object.setPrototypeOf(this, NoSuchKey2.prototype);
    }
  };
  NotFound = class NotFound2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "NotFound",
        $fault: "client",
        ...opts
      });
      this.name = "NotFound";
      this.$fault = "client";
      Object.setPrototypeOf(this, NotFound2.prototype);
    }
  };
});
function escapeAttribute(value) {
  return value.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;");
}
function escapeElement(value) {
  return value.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&apos;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\r/g, "&#x0D;").replace(/\n/g, "&#x0A;").replace(/\u0085/g, "&#x85;").replace(/\u2028/, "&#x2028;");
}

class XmlText {
  constructor(value) {
    this.value = value;
  }
  toString() {
    return escapeElement("" + this.value);
  }
}
var init_XmlText = () => {
};

class XmlNode {
  static of(name, childText, withName) {
    const node = new XmlNode(name);
    if (childText !== undefined) {
      node.addChildNode(new XmlText(childText));
    }
    if (withName !== undefined) {
      node.withName(withName);
    }
    return node;
  }
  constructor(name, children = []) {
    this.name = name;
    this.children = children;
    this.attributes = {};
  }
  withName(name) {
    this.name = name;
    return this;
  }
  addAttribute(name, value) {
    this.attributes[name] = value;
    return this;
  }
  addChildNode(child) {
    this.children.push(child);
    return this;
  }
  removeAttribute(name) {
    delete this.attributes[name];
    return this;
  }
  n(name) {
    this.name = name;
    return this;
  }
  c(child) {
    this.children.push(child);
    return this;
  }
  a(name, value) {
    if (value != null) {
      this.attributes[name] = value;
    }
    return this;
  }
  cc(input, field, withName = field) {
    if (input[field] != null) {
      const node = XmlNode.of(field, input[field]).withName(withName);
      this.c(node);
    }
  }
  l(input, listName, memberName, valueProvider) {
    if (input[listName] != null) {
      const nodes = valueProvider();
      nodes.map((node) => {
        node.withName(memberName);
        this.c(node);
      });
    }
  }
  lc(input, listName, memberName, valueProvider) {
    if (input[listName] != null) {
      const nodes = valueProvider();
      const containerNode = new XmlNode(memberName);
      nodes.map((node) => {
        containerNode.c(node);
      });
      this.c(containerNode);
    }
  }
  toString() {
    const hasChildren = Boolean(this.children.length);
    let xmlText = `<${this.name}`;
    const attributes = this.attributes;
    for (const attributeName of Object.keys(attributes)) {
      const attribute = attributes[attributeName];
      if (attribute != null) {
        xmlText += ` ${attributeName}="${escapeAttribute("" + attribute)}"`;
      }
    }
    return xmlText += !hasChildren ? "/>" : `>${this.children.map((c3) => c3.toString()).join("")}</${this.name}>`;
  }
}
var init_XmlNode = __esm2(() => {
  init_XmlText();
});
var init_dist_es37 = __esm2(() => {
  init_XmlNode();
  init_XmlText();
});
var ObjectAlreadyInActiveTierError;
var SelectObjectContentEventStream;
var PutObjectOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING }
});
var PutObjectRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING },
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING },
  ...obj.SSEKMSEncryptionContext && { SSEKMSEncryptionContext: SENSITIVE_STRING }
});
var EncryptionFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.KMSKeyId && { KMSKeyId: SENSITIVE_STRING }
});
var S3LocationFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Encryption && { Encryption: EncryptionFilterSensitiveLog(obj.Encryption) }
});
var OutputLocationFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.S3 && { S3: S3LocationFilterSensitiveLog(obj.S3) }
});
var RestoreRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.OutputLocation && { OutputLocation: OutputLocationFilterSensitiveLog(obj.OutputLocation) }
});
var RestoreObjectRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.RestoreRequest && { RestoreRequest: RestoreRequestFilterSensitiveLog(obj.RestoreRequest) }
});
var SelectObjectContentOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Payload && { Payload: "STREAMING_CONTENT" }
});
var SelectObjectContentRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING }
});
var UploadPartOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING }
});
var UploadPartRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING }
});
var UploadPartCopyOutputFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING }
});
var UploadPartCopyRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSECustomerKey && { SSECustomerKey: SENSITIVE_STRING },
  ...obj.CopySourceSSECustomerKey && { CopySourceSSECustomerKey: SENSITIVE_STRING }
});
var WriteGetObjectResponseRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SSEKMSKeyId && { SSEKMSKeyId: SENSITIVE_STRING }
});
var init_models_1 = __esm2(() => {
  init_dist_es12();
  init_S3ServiceException();
  ObjectAlreadyInActiveTierError = class ObjectAlreadyInActiveTierError2 extends S3ServiceException {
    constructor(opts) {
      super({
        name: "ObjectAlreadyInActiveTierError",
        $fault: "client",
        ...opts
      });
      this.name = "ObjectAlreadyInActiveTierError";
      this.$fault = "client";
      Object.setPrototypeOf(this, ObjectAlreadyInActiveTierError2.prototype);
    }
  };
  (function(SelectObjectContentEventStream2) {
    SelectObjectContentEventStream2.visit = (value, visitor) => {
      if (value.Records !== undefined)
        return visitor.Records(value.Records);
      if (value.Stats !== undefined)
        return visitor.Stats(value.Stats);
      if (value.Progress !== undefined)
        return visitor.Progress(value.Progress);
      if (value.Cont !== undefined)
        return visitor.Cont(value.Cont);
      if (value.End !== undefined)
        return visitor.End(value.End);
      return visitor._(value.$unknown[0], value.$unknown[1]);
    };
  })(SelectObjectContentEventStream || (SelectObjectContentEventStream = {}));
});
var import_core11;
var import_core12;
var se_AbortMultipartUploadCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "AbortMultipartUpload"],
    [_uI]: [, expectNonNull(input[_UI], `UploadId`)]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_CompleteMultipartUploadCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xacc]: input[_CCRC],
    [_xacc_]: input[_CCRCC],
    [_xacs]: input[_CSHA],
    [_xacs_]: input[_CSHAh],
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_inm]: input[_INM],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_uI]: [, expectNonNull(input[_UI], `UploadId`)]
  });
  let body;
  let contents;
  if (input.MultipartUpload !== undefined) {
    contents = se_CompletedMultipartUpload(input.MultipartUpload, context);
    contents = contents.n("CompleteMultipartUpload");
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("POST").h(headers).q(query).b(body);
  return b3.build();
};
var se_CopyObjectCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaa]: input[_ACL],
    [_cc]: input[_CC],
    [_xaca]: input[_CA],
    [_cd]: input[_CD],
    [_ce]: input[_CE],
    [_cl]: input[_CL],
    [_ct]: input[_CT],
    [_xacs__]: input[_CS],
    [_xacsim]: input[_CSIM],
    [_xacsims]: [() => isSerializableHeaderValue(input[_CSIMS]), () => dateToUtcString(input[_CSIMS]).toString()],
    [_xacsinm]: input[_CSINM],
    [_xacsius]: [() => isSerializableHeaderValue(input[_CSIUS]), () => dateToUtcString(input[_CSIUS]).toString()],
    [_e]: [() => isSerializableHeaderValue(input[_E]), () => dateToUtcString(input[_E]).toString()],
    [_xagfc]: input[_GFC],
    [_xagr]: input[_GR],
    [_xagra]: input[_GRACP],
    [_xagwa]: input[_GWACP],
    [_xamd]: input[_MD],
    [_xatd]: input[_TD],
    [_xasse]: input[_SSE],
    [_xasc]: input[_SC],
    [_xawrl]: input[_WRL],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xasseakki]: input[_SSEKMSKI],
    [_xassec]: input[_SSEKMSEC],
    [_xassebke]: [() => isSerializableHeaderValue(input[_BKE]), () => input[_BKE].toString()],
    [_xacssseca]: input[_CSSSECA],
    [_xacssseck]: input[_CSSSECK],
    [_xacssseckm]: input[_CSSSECKMD],
    [_xarp]: input[_RP],
    [_xat]: input[_T],
    [_xaolm]: input[_OLM],
    [_xaolrud]: [() => isSerializableHeaderValue(input[_OLRUD]), () => serializeDateTime(input[_OLRUD]).toString()],
    [_xaollh]: input[_OLLHS],
    [_xaebo]: input[_EBO],
    [_xasebo]: input[_ESBO],
    ...input.Metadata !== undefined && Object.keys(input.Metadata).reduce((acc, suffix) => {
      acc[`x-amz-meta-${suffix.toLowerCase()}`] = input.Metadata[suffix];
      return acc;
    }, {})
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "CopyObject"]
  });
  let body;
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_CreateBucketCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaa]: input[_ACL],
    [_xagfc]: input[_GFC],
    [_xagr]: input[_GR],
    [_xagra]: input[_GRACP],
    [_xagw]: input[_GW],
    [_xagwa]: input[_GWACP],
    [_xabole]: [() => isSerializableHeaderValue(input[_OLEFB]), () => input[_OLEFB].toString()],
    [_xaoo]: input[_OO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  let body;
  let contents;
  if (input.CreateBucketConfiguration !== undefined) {
    contents = se_CreateBucketConfiguration(input.CreateBucketConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).b(body);
  return b3.build();
};
var se_CreateMultipartUploadCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaa]: input[_ACL],
    [_cc]: input[_CC],
    [_cd]: input[_CD],
    [_ce]: input[_CE],
    [_cl]: input[_CL],
    [_ct]: input[_CT],
    [_e]: [() => isSerializableHeaderValue(input[_E]), () => dateToUtcString(input[_E]).toString()],
    [_xagfc]: input[_GFC],
    [_xagr]: input[_GR],
    [_xagra]: input[_GRACP],
    [_xagwa]: input[_GWACP],
    [_xasse]: input[_SSE],
    [_xasc]: input[_SC],
    [_xawrl]: input[_WRL],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xasseakki]: input[_SSEKMSKI],
    [_xassec]: input[_SSEKMSEC],
    [_xassebke]: [() => isSerializableHeaderValue(input[_BKE]), () => input[_BKE].toString()],
    [_xarp]: input[_RP],
    [_xat]: input[_T],
    [_xaolm]: input[_OLM],
    [_xaolrud]: [() => isSerializableHeaderValue(input[_OLRUD]), () => serializeDateTime(input[_OLRUD]).toString()],
    [_xaollh]: input[_OLLHS],
    [_xaebo]: input[_EBO],
    [_xaca]: input[_CA],
    ...input.Metadata !== undefined && Object.keys(input.Metadata).reduce((acc, suffix) => {
      acc[`x-amz-meta-${suffix.toLowerCase()}`] = input.Metadata[suffix];
      return acc;
    }, {})
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_u]: [, ""]
  });
  let body;
  b3.m("POST").h(headers).q(query).b(body);
  return b3.build();
};
var se_CreateSessionCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xacsm]: input[_SM],
    [_xasse]: input[_SSE],
    [_xasseakki]: input[_SSEKMSKI],
    [_xassec]: input[_SSEKMSEC],
    [_xassebke]: [() => isSerializableHeaderValue(input[_BKE]), () => input[_BKE].toString()]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_s]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  let body;
  b3.m("DELETE").h(headers).b(body);
  return b3.build();
};
var se_DeleteBucketAnalyticsConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_a]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketCorsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_c]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketEncryptionCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_en]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketIntelligentTieringConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = {};
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_it]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketInventoryConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_in]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketLifecycleCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_l]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketMetricsConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_m]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketOwnershipControlsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_oC]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketPolicyCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_p]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketReplicationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_r]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketTaggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_t]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteBucketWebsiteCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_w]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteObjectCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xam]: input[_MFA],
    [_xarp]: input[_RP],
    [_xabgr]: [() => isSerializableHeaderValue(input[_BGR]), () => input[_BGR].toString()],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "DeleteObject"],
    [_vI]: [, input[_VI]]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteObjectsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xam]: input[_MFA],
    [_xarp]: input[_RP],
    [_xabgr]: [() => isSerializableHeaderValue(input[_BGR]), () => input[_BGR].toString()],
    [_xaebo]: input[_EBO],
    [_xasca]: input[_CA]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_d]: [, ""]
  });
  let body;
  let contents;
  if (input.Delete !== undefined) {
    contents = se_Delete(input.Delete, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("POST").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeleteObjectTaggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_t]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_DeletePublicAccessBlockCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_pAB]: [, ""]
  });
  let body;
  b3.m("DELETE").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketAccelerateConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO],
    [_xarp]: input[_RP]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_ac]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketAclCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_acl]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketAnalyticsConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_a]: [, ""],
    [_xi]: [, "GetBucketAnalyticsConfiguration"],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketCorsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_c]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketEncryptionCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_en]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketIntelligentTieringConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = {};
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_it]: [, ""],
    [_xi]: [, "GetBucketIntelligentTieringConfiguration"],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketInventoryConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_in]: [, ""],
    [_xi]: [, "GetBucketInventoryConfiguration"],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketLifecycleConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_l]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketLocationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_lo]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketLoggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_log]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketMetricsConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_m]: [, ""],
    [_xi]: [, "GetBucketMetricsConfiguration"],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketNotificationConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_n]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketOwnershipControlsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_oC]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketPolicyCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_p]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketPolicyStatusCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_pS]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketReplicationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_r]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketRequestPaymentCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_rP]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketTaggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_t]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketVersioningCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_v]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetBucketWebsiteCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_w]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_im]: input[_IM],
    [_ims]: [() => isSerializableHeaderValue(input[_IMS]), () => dateToUtcString(input[_IMS]).toString()],
    [_inm]: input[_INM],
    [_ius]: [() => isSerializableHeaderValue(input[_IUS]), () => dateToUtcString(input[_IUS]).toString()],
    [_ra]: input[_R],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_xacm]: input[_CM]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "GetObject"],
    [_rcc]: [, input[_RCC]],
    [_rcd]: [, input[_RCD]],
    [_rce]: [, input[_RCE]],
    [_rcl]: [, input[_RCL]],
    [_rct]: [, input[_RCT]],
    [_re]: [() => input.ResponseExpires !== undefined, () => dateToUtcString(input[_RE]).toString()],
    [_vI]: [, input[_VI]],
    [_pN]: [() => input.PartNumber !== undefined, () => input[_PN].toString()]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectAclCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_acl]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectAttributesCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xamp]: [() => isSerializableHeaderValue(input[_MP]), () => input[_MP].toString()],
    [_xapnm]: input[_PNM],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_xaoa]: [() => isSerializableHeaderValue(input[_OA]), () => (input[_OA] || []).map(quoteHeader).join(", ")]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_at]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectLegalHoldCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_lh]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectLockConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_ol]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectRetentionCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_ret]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectTaggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO],
    [_xarp]: input[_RP]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_t]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetObjectTorrentCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_to]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_GetPublicAccessBlockCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_pAB]: [, ""]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_HeadBucketCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  let body;
  b3.m("HEAD").h(headers).b(body);
  return b3.build();
};
var se_HeadObjectCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_im]: input[_IM],
    [_ims]: [() => isSerializableHeaderValue(input[_IMS]), () => dateToUtcString(input[_IMS]).toString()],
    [_inm]: input[_INM],
    [_ius]: [() => isSerializableHeaderValue(input[_IUS]), () => dateToUtcString(input[_IUS]).toString()],
    [_ra]: input[_R],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_xacm]: input[_CM]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_rcc]: [, input[_RCC]],
    [_rcd]: [, input[_RCD]],
    [_rce]: [, input[_RCE]],
    [_rcl]: [, input[_RCL]],
    [_rct]: [, input[_RCT]],
    [_re]: [() => input.ResponseExpires !== undefined, () => dateToUtcString(input[_RE]).toString()],
    [_vI]: [, input[_VI]],
    [_pN]: [() => input.PartNumber !== undefined, () => input[_PN].toString()]
  });
  let body;
  b3.m("HEAD").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListBucketAnalyticsConfigurationsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_a]: [, ""],
    [_xi]: [, "ListBucketAnalyticsConfigurations"],
    [_ct_]: [, input[_CTo]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListBucketIntelligentTieringConfigurationsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = {};
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_it]: [, ""],
    [_xi]: [, "ListBucketIntelligentTieringConfigurations"],
    [_ct_]: [, input[_CTo]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListBucketInventoryConfigurationsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_in]: [, ""],
    [_xi]: [, "ListBucketInventoryConfigurations"],
    [_ct_]: [, input[_CTo]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListBucketMetricsConfigurationsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_m]: [, ""],
    [_xi]: [, "ListBucketMetricsConfigurations"],
    [_ct_]: [, input[_CTo]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListBucketsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = {};
  b3.bp("/");
  const query = map2({
    [_xi]: [, "ListBuckets"],
    [_mb]: [() => input.MaxBuckets !== undefined, () => input[_MB].toString()],
    [_ct_]: [, input[_CTo]],
    [_pr]: [, input[_P]],
    [_br]: [, input[_BR]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListDirectoryBucketsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = {};
  b3.bp("/");
  const query = map2({
    [_xi]: [, "ListDirectoryBuckets"],
    [_ct_]: [, input[_CTo]],
    [_mdb]: [() => input.MaxDirectoryBuckets !== undefined, () => input[_MDB].toString()]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListMultipartUploadsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO],
    [_xarp]: input[_RP]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_u]: [, ""],
    [_de]: [, input[_D]],
    [_et]: [, input[_ET]],
    [_km]: [, input[_KM]],
    [_mu]: [() => input.MaxUploads !== undefined, () => input[_MU].toString()],
    [_pr]: [, input[_P]],
    [_uim]: [, input[_UIM]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListObjectsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_xaooa]: [() => isSerializableHeaderValue(input[_OOA]), () => (input[_OOA] || []).map(quoteHeader).join(", ")]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_de]: [, input[_D]],
    [_et]: [, input[_ET]],
    [_ma]: [, input[_M]],
    [_mk]: [() => input.MaxKeys !== undefined, () => input[_MK].toString()],
    [_pr]: [, input[_P]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListObjectsV2Command = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_xaooa]: [() => isSerializableHeaderValue(input[_OOA]), () => (input[_OOA] || []).map(quoteHeader).join(", ")]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_lt]: [, "2"],
    [_de]: [, input[_D]],
    [_et]: [, input[_ET]],
    [_mk]: [() => input.MaxKeys !== undefined, () => input[_MK].toString()],
    [_pr]: [, input[_P]],
    [_ct_]: [, input[_CTo]],
    [_fo]: [() => input.FetchOwner !== undefined, () => input[_FO].toString()],
    [_sa]: [, input[_SA]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListObjectVersionsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xaebo]: input[_EBO],
    [_xarp]: input[_RP],
    [_xaooa]: [() => isSerializableHeaderValue(input[_OOA]), () => (input[_OOA] || []).map(quoteHeader).join(", ")]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_ver]: [, ""],
    [_de]: [, input[_D]],
    [_et]: [, input[_ET]],
    [_km]: [, input[_KM]],
    [_mk]: [() => input.MaxKeys !== undefined, () => input[_MK].toString()],
    [_pr]: [, input[_P]],
    [_vim]: [, input[_VIM]]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_ListPartsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "ListParts"],
    [_mp]: [() => input.MaxParts !== undefined, () => input[_MP].toString()],
    [_pnm]: [, input[_PNM]],
    [_uI]: [, expectNonNull(input[_UI], `UploadId`)]
  });
  let body;
  b3.m("GET").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketAccelerateConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaebo]: input[_EBO],
    [_xasca]: input[_CA]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_ac]: [, ""]
  });
  let body;
  let contents;
  if (input.AccelerateConfiguration !== undefined) {
    contents = se_AccelerateConfiguration(input.AccelerateConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketAclCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaa]: input[_ACL],
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xagfc]: input[_GFC],
    [_xagr]: input[_GR],
    [_xagra]: input[_GRACP],
    [_xagw]: input[_GW],
    [_xagwa]: input[_GWACP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_acl]: [, ""]
  });
  let body;
  let contents;
  if (input.AccessControlPolicy !== undefined) {
    contents = se_AccessControlPolicy(input.AccessControlPolicy, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketAnalyticsConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_a]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  let contents;
  if (input.AnalyticsConfiguration !== undefined) {
    contents = se_AnalyticsConfiguration(input.AnalyticsConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketCorsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_c]: [, ""]
  });
  let body;
  let contents;
  if (input.CORSConfiguration !== undefined) {
    contents = se_CORSConfiguration(input.CORSConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketEncryptionCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_en]: [, ""]
  });
  let body;
  let contents;
  if (input.ServerSideEncryptionConfiguration !== undefined) {
    contents = se_ServerSideEncryptionConfiguration(input.ServerSideEncryptionConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketIntelligentTieringConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = {
    "content-type": "application/xml"
  };
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_it]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  let contents;
  if (input.IntelligentTieringConfiguration !== undefined) {
    contents = se_IntelligentTieringConfiguration(input.IntelligentTieringConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketInventoryConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_in]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  let contents;
  if (input.InventoryConfiguration !== undefined) {
    contents = se_InventoryConfiguration(input.InventoryConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketLifecycleConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO],
    [_xatdmos]: input[_TDMOS]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_l]: [, ""]
  });
  let body;
  let contents;
  if (input.LifecycleConfiguration !== undefined) {
    contents = se_BucketLifecycleConfiguration(input.LifecycleConfiguration, context);
    contents = contents.n("LifecycleConfiguration");
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketLoggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_log]: [, ""]
  });
  let body;
  let contents;
  if (input.BucketLoggingStatus !== undefined) {
    contents = se_BucketLoggingStatus(input.BucketLoggingStatus, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketMetricsConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_m]: [, ""],
    [_i]: [, expectNonNull(input[_I], `Id`)]
  });
  let body;
  let contents;
  if (input.MetricsConfiguration !== undefined) {
    contents = se_MetricsConfiguration(input.MetricsConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketNotificationConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaebo]: input[_EBO],
    [_xasdv]: [() => isSerializableHeaderValue(input[_SDV]), () => input[_SDV].toString()]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_n]: [, ""]
  });
  let body;
  let contents;
  if (input.NotificationConfiguration !== undefined) {
    contents = se_NotificationConfiguration(input.NotificationConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketOwnershipControlsCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_oC]: [, ""]
  });
  let body;
  let contents;
  if (input.OwnershipControls !== undefined) {
    contents = se_OwnershipControls(input.OwnershipControls, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketPolicyCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "text/plain",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xacrsba]: [() => isSerializableHeaderValue(input[_CRSBA]), () => input[_CRSBA].toString()],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_p]: [, ""]
  });
  let body;
  let contents;
  if (input.Policy !== undefined) {
    contents = input.Policy;
    body = contents;
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketReplicationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xabolt]: input[_To],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_r]: [, ""]
  });
  let body;
  let contents;
  if (input.ReplicationConfiguration !== undefined) {
    contents = se_ReplicationConfiguration(input.ReplicationConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketRequestPaymentCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_rP]: [, ""]
  });
  let body;
  let contents;
  if (input.RequestPaymentConfiguration !== undefined) {
    contents = se_RequestPaymentConfiguration(input.RequestPaymentConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketTaggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_t]: [, ""]
  });
  let body;
  let contents;
  if (input.Tagging !== undefined) {
    contents = se_Tagging(input.Tagging, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketVersioningCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xam]: input[_MFA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_v]: [, ""]
  });
  let body;
  let contents;
  if (input.VersioningConfiguration !== undefined) {
    contents = se_VersioningConfiguration(input.VersioningConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutBucketWebsiteCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_w]: [, ""]
  });
  let body;
  let contents;
  if (input.WebsiteConfiguration !== undefined) {
    contents = se_WebsiteConfiguration(input.WebsiteConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutObjectCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_ct]: input[_CT] || "application/octet-stream",
    [_xaa]: input[_ACL],
    [_cc]: input[_CC],
    [_cd]: input[_CD],
    [_ce]: input[_CE],
    [_cl]: input[_CL],
    [_cl_]: [() => isSerializableHeaderValue(input[_CLo]), () => input[_CLo].toString()],
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xacc]: input[_CCRC],
    [_xacc_]: input[_CCRCC],
    [_xacs]: input[_CSHA],
    [_xacs_]: input[_CSHAh],
    [_e]: [() => isSerializableHeaderValue(input[_E]), () => dateToUtcString(input[_E]).toString()],
    [_inm]: input[_INM],
    [_xagfc]: input[_GFC],
    [_xagr]: input[_GR],
    [_xagra]: input[_GRACP],
    [_xagwa]: input[_GWACP],
    [_xasse]: input[_SSE],
    [_xasc]: input[_SC],
    [_xawrl]: input[_WRL],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xasseakki]: input[_SSEKMSKI],
    [_xassec]: input[_SSEKMSEC],
    [_xassebke]: [() => isSerializableHeaderValue(input[_BKE]), () => input[_BKE].toString()],
    [_xarp]: input[_RP],
    [_xat]: input[_T],
    [_xaolm]: input[_OLM],
    [_xaolrud]: [() => isSerializableHeaderValue(input[_OLRUD]), () => serializeDateTime(input[_OLRUD]).toString()],
    [_xaollh]: input[_OLLHS],
    [_xaebo]: input[_EBO],
    ...input.Metadata !== undefined && Object.keys(input.Metadata).reduce((acc, suffix) => {
      acc[`x-amz-meta-${suffix.toLowerCase()}`] = input.Metadata[suffix];
      return acc;
    }, {})
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "PutObject"]
  });
  let body;
  let contents;
  if (input.Body !== undefined) {
    contents = input.Body;
    body = contents;
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutObjectAclCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xaa]: input[_ACL],
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xagfc]: input[_GFC],
    [_xagr]: input[_GR],
    [_xagra]: input[_GRACP],
    [_xagw]: input[_GW],
    [_xagwa]: input[_GWACP],
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_acl]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  let contents;
  if (input.AccessControlPolicy !== undefined) {
    contents = se_AccessControlPolicy(input.AccessControlPolicy, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutObjectLegalHoldCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xarp]: input[_RP],
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_lh]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  let contents;
  if (input.LegalHold !== undefined) {
    contents = se_ObjectLockLegalHold(input.LegalHold, context);
    contents = contents.n("LegalHold");
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutObjectLockConfigurationCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xarp]: input[_RP],
    [_xabolt]: input[_To],
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_ol]: [, ""]
  });
  let body;
  let contents;
  if (input.ObjectLockConfiguration !== undefined) {
    contents = se_ObjectLockConfiguration(input.ObjectLockConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutObjectRetentionCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xarp]: input[_RP],
    [_xabgr]: [() => isSerializableHeaderValue(input[_BGR]), () => input[_BGR].toString()],
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_ret]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  let contents;
  if (input.Retention !== undefined) {
    contents = se_ObjectLockRetention(input.Retention, context);
    contents = contents.n("Retention");
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutObjectTaggingCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO],
    [_xarp]: input[_RP]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_t]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  let contents;
  if (input.Tagging !== undefined) {
    contents = se_Tagging(input.Tagging, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_PutPublicAccessBlockCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  const query = map2({
    [_pAB]: [, ""]
  });
  let body;
  let contents;
  if (input.PublicAccessBlockConfiguration !== undefined) {
    contents = se_PublicAccessBlockConfiguration(input.PublicAccessBlockConfiguration, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_RestoreObjectCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xarp]: input[_RP],
    [_xasca]: input[_CA],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_res]: [, ""],
    [_vI]: [, input[_VI]]
  });
  let body;
  let contents;
  if (input.RestoreRequest !== undefined) {
    contents = se_RestoreRequest(input.RestoreRequest, context);
    body = _ve;
    contents.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
    body += contents.toString();
  }
  b3.m("POST").h(headers).q(query).b(body);
  return b3.build();
};
var se_SelectObjectContentCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/xml",
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_se]: [, ""],
    [_st]: [, "2"]
  });
  let body;
  body = _ve;
  const bn2 = new XmlNode(_SOCR);
  bn2.a("xmlns", "http://s3.amazonaws.com/doc/2006-03-01/");
  bn2.cc(input, _Ex);
  bn2.cc(input, _ETx);
  if (input[_IS] != null) {
    bn2.c(se_InputSerialization(input[_IS], context).n(_IS));
  }
  if (input[_OS] != null) {
    bn2.c(se_OutputSerialization(input[_OS], context).n(_OS));
  }
  if (input[_RPe] != null) {
    bn2.c(se_RequestProgress(input[_RPe], context).n(_RPe));
  }
  if (input[_SR] != null) {
    bn2.c(se_ScanRange(input[_SR], context).n(_SR));
  }
  body += bn2.toString();
  b3.m("POST").h(headers).q(query).b(body);
  return b3.build();
};
var se_UploadPartCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "content-type": "application/octet-stream",
    [_cl_]: [() => isSerializableHeaderValue(input[_CLo]), () => input[_CLo].toString()],
    [_cm]: input[_CMD],
    [_xasca]: input[_CA],
    [_xacc]: input[_CCRC],
    [_xacc_]: input[_CCRCC],
    [_xacs]: input[_CSHA],
    [_xacs_]: input[_CSHAh],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "UploadPart"],
    [_pN]: [expectNonNull(input.PartNumber, `PartNumber`) != null, () => input[_PN].toString()],
    [_uI]: [, expectNonNull(input[_UI], `UploadId`)]
  });
  let body;
  let contents;
  if (input.Body !== undefined) {
    contents = input.Body;
    body = contents;
  }
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_UploadPartCopyCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xacs__]: input[_CS],
    [_xacsim]: input[_CSIM],
    [_xacsims]: [() => isSerializableHeaderValue(input[_CSIMS]), () => dateToUtcString(input[_CSIMS]).toString()],
    [_xacsinm]: input[_CSINM],
    [_xacsius]: [() => isSerializableHeaderValue(input[_CSIUS]), () => dateToUtcString(input[_CSIUS]).toString()],
    [_xacsr]: input[_CSR],
    [_xasseca]: input[_SSECA],
    [_xasseck]: input[_SSECK],
    [_xasseckm]: input[_SSECKMD],
    [_xacssseca]: input[_CSSSECA],
    [_xacssseck]: input[_CSSSECK],
    [_xacssseckm]: input[_CSSSECKMD],
    [_xarp]: input[_RP],
    [_xaebo]: input[_EBO],
    [_xasebo]: input[_ESBO]
  });
  b3.bp("/{Key+}");
  b3.p("Bucket", () => input.Bucket, "{Bucket}", false);
  b3.p("Key", () => input.Key, "{Key+}", true);
  const query = map2({
    [_xi]: [, "UploadPartCopy"],
    [_pN]: [expectNonNull(input.PartNumber, `PartNumber`) != null, () => input[_PN].toString()],
    [_uI]: [, expectNonNull(input[_UI], `UploadId`)]
  });
  let body;
  b3.m("PUT").h(headers).q(query).b(body);
  return b3.build();
};
var se_WriteGetObjectResponseCommand = async (input, context) => {
  const b3 = import_core12.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    "x-amz-content-sha256": "UNSIGNED-PAYLOAD",
    "content-type": "application/octet-stream",
    [_xarr]: input[_RR],
    [_xart]: input[_RT],
    [_xafs]: [() => isSerializableHeaderValue(input[_SCt]), () => input[_SCt].toString()],
    [_xafec]: input[_EC],
    [_xafem]: input[_EM],
    [_xafhar]: input[_AR],
    [_xafhcc]: input[_CC],
    [_xafhcd]: input[_CD],
    [_xafhce]: input[_CE],
    [_xafhcl]: input[_CL],
    [_cl_]: [() => isSerializableHeaderValue(input[_CLo]), () => input[_CLo].toString()],
    [_xafhcr]: input[_CR],
    [_xafhct]: input[_CT],
    [_xafhxacc]: input[_CCRC],
    [_xafhxacc_]: input[_CCRCC],
    [_xafhxacs]: input[_CSHA],
    [_xafhxacs_]: input[_CSHAh],
    [_xafhxadm]: [() => isSerializableHeaderValue(input[_DM]), () => input[_DM].toString()],
    [_xafhe]: input[_ETa],
    [_xafhe_]: [() => isSerializableHeaderValue(input[_E]), () => dateToUtcString(input[_E]).toString()],
    [_xafhxae]: input[_Exp],
    [_xafhlm]: [() => isSerializableHeaderValue(input[_LM]), () => dateToUtcString(input[_LM]).toString()],
    [_xafhxamm]: [() => isSerializableHeaderValue(input[_MM]), () => input[_MM].toString()],
    [_xafhxaolm]: input[_OLM],
    [_xafhxaollh]: input[_OLLHS],
    [_xafhxaolrud]: [
      () => isSerializableHeaderValue(input[_OLRUD]),
      () => serializeDateTime(input[_OLRUD]).toString()
    ],
    [_xafhxampc]: [() => isSerializableHeaderValue(input[_PC]), () => input[_PC].toString()],
    [_xafhxars]: input[_RS],
    [_xafhxarc]: input[_RC],
    [_xafhxar]: input[_Re],
    [_xafhxasse]: input[_SSE],
    [_xafhxasseca]: input[_SSECA],
    [_xafhxasseakki]: input[_SSEKMSKI],
    [_xafhxasseckm]: input[_SSECKMD],
    [_xafhxasc]: input[_SC],
    [_xafhxatc]: [() => isSerializableHeaderValue(input[_TC]), () => input[_TC].toString()],
    [_xafhxavi]: input[_VI],
    [_xafhxassebke]: [() => isSerializableHeaderValue(input[_BKE]), () => input[_BKE].toString()],
    ...input.Metadata !== undefined && Object.keys(input.Metadata).reduce((acc, suffix) => {
      acc[`x-amz-meta-${suffix.toLowerCase()}`] = input.Metadata[suffix];
      return acc;
    }, {})
  });
  b3.bp("/WriteGetObjectResponse");
  let body;
  let contents;
  if (input.Body !== undefined) {
    contents = input.Body;
    body = contents;
  }
  let { hostname: resolvedHostname } = await context.endpoint();
  if (context.disableHostPrefix !== true) {
    resolvedHostname = "{RequestRoute}." + resolvedHostname;
    if (input.RequestRoute === undefined) {
      throw new Error("Empty value provided for input host prefix: RequestRoute.");
    }
    resolvedHostname = resolvedHostname.replace("{RequestRoute}", input.RequestRoute);
    if (!isValidHostname(resolvedHostname)) {
      throw new Error("ValidationError: prefixed hostname must be hostname compatible.");
    }
  }
  b3.hn(resolvedHostname);
  b3.m("POST").h(headers).b(body);
  return b3.build();
};
var de_AbortMultipartUploadCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_CompleteMultipartUploadCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_Exp]: [, output.headers[_xae]],
    [_SSE]: [, output.headers[_xasse]],
    [_VI]: [, output.headers[_xavi]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_B] != null) {
    contents[_B] = expectString(data2[_B]);
  }
  if (data2[_CCRC] != null) {
    contents[_CCRC] = expectString(data2[_CCRC]);
  }
  if (data2[_CCRCC] != null) {
    contents[_CCRCC] = expectString(data2[_CCRCC]);
  }
  if (data2[_CSHA] != null) {
    contents[_CSHA] = expectString(data2[_CSHA]);
  }
  if (data2[_CSHAh] != null) {
    contents[_CSHAh] = expectString(data2[_CSHAh]);
  }
  if (data2[_ETa] != null) {
    contents[_ETa] = expectString(data2[_ETa]);
  }
  if (data2[_K] != null) {
    contents[_K] = expectString(data2[_K]);
  }
  if (data2[_L] != null) {
    contents[_L] = expectString(data2[_L]);
  }
  return contents;
};
var de_CopyObjectCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_Exp]: [, output.headers[_xae]],
    [_CSVI]: [, output.headers[_xacsvi]],
    [_VI]: [, output.headers[_xavi]],
    [_SSE]: [, output.headers[_xasse]],
    [_SSECA]: [, output.headers[_xasseca]],
    [_SSECKMD]: [, output.headers[_xasseckm]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_SSEKMSEC]: [, output.headers[_xassec]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.CopyObjectResult = de_CopyObjectResult(data2, context);
  return contents;
};
var de_CreateBucketCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_L]: [, output.headers[_lo]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_CreateMultipartUploadCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_AD]: [
      () => output.headers[_xaad] !== undefined,
      () => expectNonNull(parseRfc7231DateTime(output.headers[_xaad]))
    ],
    [_ARI]: [, output.headers[_xaari]],
    [_SSE]: [, output.headers[_xasse]],
    [_SSECA]: [, output.headers[_xasseca]],
    [_SSECKMD]: [, output.headers[_xasseckm]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_SSEKMSEC]: [, output.headers[_xassec]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_RC]: [, output.headers[_xarc]],
    [_CA]: [, output.headers[_xaca]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_B] != null) {
    contents[_B] = expectString(data2[_B]);
  }
  if (data2[_K] != null) {
    contents[_K] = expectString(data2[_K]);
  }
  if (data2[_UI] != null) {
    contents[_UI] = expectString(data2[_UI]);
  }
  return contents;
};
var de_CreateSessionCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_SSE]: [, output.headers[_xasse]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_SSEKMSEC]: [, output.headers[_xassec]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_C] != null) {
    contents[_C] = de_SessionCredentials(data2[_C], context);
  }
  return contents;
};
var de_DeleteBucketCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketAnalyticsConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketCorsCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketEncryptionCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketIntelligentTieringConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketInventoryConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketLifecycleCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketMetricsConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketOwnershipControlsCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketPolicyCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketReplicationCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketTaggingCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteBucketWebsiteCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteObjectCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_DM]: [() => output.headers[_xadm] !== undefined, () => parseBoolean(output.headers[_xadm])],
    [_VI]: [, output.headers[_xavi]],
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeleteObjectsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.Deleted === "") {
    contents[_De] = [];
  } else if (data2[_De] != null) {
    contents[_De] = de_DeletedObjects(getArrayIfSingleItem(data2[_De]), context);
  }
  if (data2.Error === "") {
    contents[_Err] = [];
  } else if (data2[_Er] != null) {
    contents[_Err] = de_Errors(getArrayIfSingleItem(data2[_Er]), context);
  }
  return contents;
};
var de_DeleteObjectTaggingCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_VI]: [, output.headers[_xavi]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_DeletePublicAccessBlockCommand = async (output, context) => {
  if (output.statusCode !== 204 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_GetBucketAccelerateConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_S] != null) {
    contents[_S] = expectString(data2[_S]);
  }
  return contents;
};
var de_GetBucketAclCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.AccessControlList === "") {
    contents[_Gr] = [];
  } else if (data2[_ACLc] != null && data2[_ACLc][_G] != null) {
    contents[_Gr] = de_Grants(getArrayIfSingleItem(data2[_ACLc][_G]), context);
  }
  if (data2[_O] != null) {
    contents[_O] = de_Owner(data2[_O], context);
  }
  return contents;
};
var de_GetBucketAnalyticsConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.AnalyticsConfiguration = de_AnalyticsConfiguration(data2, context);
  return contents;
};
var de_GetBucketCorsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.CORSRule === "") {
    contents[_CORSRu] = [];
  } else if (data2[_CORSR] != null) {
    contents[_CORSRu] = de_CORSRules(getArrayIfSingleItem(data2[_CORSR]), context);
  }
  return contents;
};
var de_GetBucketEncryptionCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.ServerSideEncryptionConfiguration = de_ServerSideEncryptionConfiguration(data2, context);
  return contents;
};
var de_GetBucketIntelligentTieringConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.IntelligentTieringConfiguration = de_IntelligentTieringConfiguration(data2, context);
  return contents;
};
var de_GetBucketInventoryConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.InventoryConfiguration = de_InventoryConfiguration(data2, context);
  return contents;
};
var de_GetBucketLifecycleConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_TDMOS]: [, output.headers[_xatdmos]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.Rule === "") {
    contents[_Rul] = [];
  } else if (data2[_Ru] != null) {
    contents[_Rul] = de_LifecycleRules(getArrayIfSingleItem(data2[_Ru]), context);
  }
  return contents;
};
var de_GetBucketLocationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_LC] != null) {
    contents[_LC] = expectString(data2[_LC]);
  }
  return contents;
};
var de_GetBucketLoggingCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_LE] != null) {
    contents[_LE] = de_LoggingEnabled(data2[_LE], context);
  }
  return contents;
};
var de_GetBucketMetricsConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.MetricsConfiguration = de_MetricsConfiguration(data2, context);
  return contents;
};
var de_GetBucketNotificationConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_EBC] != null) {
    contents[_EBC] = de_EventBridgeConfiguration(data2[_EBC], context);
  }
  if (data2.CloudFunctionConfiguration === "") {
    contents[_LFC] = [];
  } else if (data2[_CFC] != null) {
    contents[_LFC] = de_LambdaFunctionConfigurationList(getArrayIfSingleItem(data2[_CFC]), context);
  }
  if (data2.QueueConfiguration === "") {
    contents[_QCu] = [];
  } else if (data2[_QC] != null) {
    contents[_QCu] = de_QueueConfigurationList(getArrayIfSingleItem(data2[_QC]), context);
  }
  if (data2.TopicConfiguration === "") {
    contents[_TCop] = [];
  } else if (data2[_TCo] != null) {
    contents[_TCop] = de_TopicConfigurationList(getArrayIfSingleItem(data2[_TCo]), context);
  }
  return contents;
};
var de_GetBucketOwnershipControlsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.OwnershipControls = de_OwnershipControls(data2, context);
  return contents;
};
var de_GetBucketPolicyCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = await collectBodyString(output.body, context);
  contents.Policy = expectString(data2);
  return contents;
};
var de_GetBucketPolicyStatusCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.PolicyStatus = de_PolicyStatus(data2, context);
  return contents;
};
var de_GetBucketReplicationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.ReplicationConfiguration = de_ReplicationConfiguration(data2, context);
  return contents;
};
var de_GetBucketRequestPaymentCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_Pa] != null) {
    contents[_Pa] = expectString(data2[_Pa]);
  }
  return contents;
};
var de_GetBucketTaggingCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.TagSet === "") {
    contents[_TS] = [];
  } else if (data2[_TS] != null && data2[_TS][_Ta] != null) {
    contents[_TS] = de_TagSet(getArrayIfSingleItem(data2[_TS][_Ta]), context);
  }
  return contents;
};
var de_GetBucketVersioningCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_MDf] != null) {
    contents[_MFAD] = expectString(data2[_MDf]);
  }
  if (data2[_S] != null) {
    contents[_S] = expectString(data2[_S]);
  }
  return contents;
};
var de_GetBucketWebsiteCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_ED] != null) {
    contents[_ED] = de_ErrorDocument(data2[_ED], context);
  }
  if (data2[_ID] != null) {
    contents[_ID] = de_IndexDocument(data2[_ID], context);
  }
  if (data2[_RART] != null) {
    contents[_RART] = de_RedirectAllRequestsTo(data2[_RART], context);
  }
  if (data2.RoutingRules === "") {
    contents[_RRo] = [];
  } else if (data2[_RRo] != null && data2[_RRo][_RRou] != null) {
    contents[_RRo] = de_RoutingRules(getArrayIfSingleItem(data2[_RRo][_RRou]), context);
  }
  return contents;
};
var de_GetObjectCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_DM]: [() => output.headers[_xadm] !== undefined, () => parseBoolean(output.headers[_xadm])],
    [_AR]: [, output.headers[_ar]],
    [_Exp]: [, output.headers[_xae]],
    [_Re]: [, output.headers[_xar]],
    [_LM]: [() => output.headers[_lm] !== undefined, () => expectNonNull(parseRfc7231DateTime(output.headers[_lm]))],
    [_CLo]: [() => output.headers[_cl_] !== undefined, () => strictParseLong(output.headers[_cl_])],
    [_ETa]: [, output.headers[_eta]],
    [_CCRC]: [, output.headers[_xacc]],
    [_CCRCC]: [, output.headers[_xacc_]],
    [_CSHA]: [, output.headers[_xacs]],
    [_CSHAh]: [, output.headers[_xacs_]],
    [_MM]: [() => output.headers[_xamm] !== undefined, () => strictParseInt32(output.headers[_xamm])],
    [_VI]: [, output.headers[_xavi]],
    [_CC]: [, output.headers[_cc]],
    [_CD]: [, output.headers[_cd]],
    [_CE]: [, output.headers[_ce]],
    [_CL]: [, output.headers[_cl]],
    [_CR]: [, output.headers[_cr]],
    [_CT]: [, output.headers[_ct]],
    [_E]: [() => output.headers[_e] !== undefined, () => expectNonNull(parseRfc7231DateTime(output.headers[_e]))],
    [_ES]: [, output.headers[_ex]],
    [_WRL]: [, output.headers[_xawrl]],
    [_SSE]: [, output.headers[_xasse]],
    [_SSECA]: [, output.headers[_xasseca]],
    [_SSECKMD]: [, output.headers[_xasseckm]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_SC]: [, output.headers[_xasc]],
    [_RC]: [, output.headers[_xarc]],
    [_RS]: [, output.headers[_xars]],
    [_PC]: [() => output.headers[_xampc] !== undefined, () => strictParseInt32(output.headers[_xampc])],
    [_TC]: [() => output.headers[_xatc] !== undefined, () => strictParseInt32(output.headers[_xatc])],
    [_OLM]: [, output.headers[_xaolm]],
    [_OLRUD]: [
      () => output.headers[_xaolrud] !== undefined,
      () => expectNonNull(parseRfc3339DateTimeWithOffset(output.headers[_xaolrud]))
    ],
    [_OLLHS]: [, output.headers[_xaollh]],
    Metadata: [
      ,
      Object.keys(output.headers).filter((header) => header.startsWith("x-amz-meta-")).reduce((acc, header) => {
        acc[header.substring(11)] = output.headers[header];
        return acc;
      }, {})
    ]
  });
  const data2 = output.body;
  context.sdkStreamMixin(data2);
  contents.Body = data2;
  return contents;
};
var de_GetObjectAclCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.AccessControlList === "") {
    contents[_Gr] = [];
  } else if (data2[_ACLc] != null && data2[_ACLc][_G] != null) {
    contents[_Gr] = de_Grants(getArrayIfSingleItem(data2[_ACLc][_G]), context);
  }
  if (data2[_O] != null) {
    contents[_O] = de_Owner(data2[_O], context);
  }
  return contents;
};
var de_GetObjectAttributesCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_DM]: [() => output.headers[_xadm] !== undefined, () => parseBoolean(output.headers[_xadm])],
    [_LM]: [() => output.headers[_lm] !== undefined, () => expectNonNull(parseRfc7231DateTime(output.headers[_lm]))],
    [_VI]: [, output.headers[_xavi]],
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_Ch] != null) {
    contents[_Ch] = de_Checksum(data2[_Ch], context);
  }
  if (data2[_ETa] != null) {
    contents[_ETa] = expectString(data2[_ETa]);
  }
  if (data2[_OP] != null) {
    contents[_OP] = de_GetObjectAttributesParts(data2[_OP], context);
  }
  if (data2[_OSb] != null) {
    contents[_OSb] = strictParseLong(data2[_OSb]);
  }
  if (data2[_SC] != null) {
    contents[_SC] = expectString(data2[_SC]);
  }
  return contents;
};
var de_GetObjectLegalHoldCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.LegalHold = de_ObjectLockLegalHold(data2, context);
  return contents;
};
var de_GetObjectLockConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.ObjectLockConfiguration = de_ObjectLockConfiguration(data2, context);
  return contents;
};
var de_GetObjectRetentionCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.Retention = de_ObjectLockRetention(data2, context);
  return contents;
};
var de_GetObjectTaggingCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_VI]: [, output.headers[_xavi]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.TagSet === "") {
    contents[_TS] = [];
  } else if (data2[_TS] != null && data2[_TS][_Ta] != null) {
    contents[_TS] = de_TagSet(getArrayIfSingleItem(data2[_TS][_Ta]), context);
  }
  return contents;
};
var de_GetObjectTorrentCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = output.body;
  context.sdkStreamMixin(data2);
  contents.Body = data2;
  return contents;
};
var de_GetPublicAccessBlockCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.PublicAccessBlockConfiguration = de_PublicAccessBlockConfiguration(data2, context);
  return contents;
};
var de_HeadBucketCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_BLT]: [, output.headers[_xablt]],
    [_BLN]: [, output.headers[_xabln]],
    [_BR]: [, output.headers[_xabr]],
    [_APA]: [() => output.headers[_xaapa] !== undefined, () => parseBoolean(output.headers[_xaapa])]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_HeadObjectCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_DM]: [() => output.headers[_xadm] !== undefined, () => parseBoolean(output.headers[_xadm])],
    [_AR]: [, output.headers[_ar]],
    [_Exp]: [, output.headers[_xae]],
    [_Re]: [, output.headers[_xar]],
    [_AS]: [, output.headers[_xaas]],
    [_LM]: [() => output.headers[_lm] !== undefined, () => expectNonNull(parseRfc7231DateTime(output.headers[_lm]))],
    [_CLo]: [() => output.headers[_cl_] !== undefined, () => strictParseLong(output.headers[_cl_])],
    [_CCRC]: [, output.headers[_xacc]],
    [_CCRCC]: [, output.headers[_xacc_]],
    [_CSHA]: [, output.headers[_xacs]],
    [_CSHAh]: [, output.headers[_xacs_]],
    [_ETa]: [, output.headers[_eta]],
    [_MM]: [() => output.headers[_xamm] !== undefined, () => strictParseInt32(output.headers[_xamm])],
    [_VI]: [, output.headers[_xavi]],
    [_CC]: [, output.headers[_cc]],
    [_CD]: [, output.headers[_cd]],
    [_CE]: [, output.headers[_ce]],
    [_CL]: [, output.headers[_cl]],
    [_CT]: [, output.headers[_ct]],
    [_E]: [() => output.headers[_e] !== undefined, () => expectNonNull(parseRfc7231DateTime(output.headers[_e]))],
    [_ES]: [, output.headers[_ex]],
    [_WRL]: [, output.headers[_xawrl]],
    [_SSE]: [, output.headers[_xasse]],
    [_SSECA]: [, output.headers[_xasseca]],
    [_SSECKMD]: [, output.headers[_xasseckm]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_SC]: [, output.headers[_xasc]],
    [_RC]: [, output.headers[_xarc]],
    [_RS]: [, output.headers[_xars]],
    [_PC]: [() => output.headers[_xampc] !== undefined, () => strictParseInt32(output.headers[_xampc])],
    [_OLM]: [, output.headers[_xaolm]],
    [_OLRUD]: [
      () => output.headers[_xaolrud] !== undefined,
      () => expectNonNull(parseRfc3339DateTimeWithOffset(output.headers[_xaolrud]))
    ],
    [_OLLHS]: [, output.headers[_xaollh]],
    Metadata: [
      ,
      Object.keys(output.headers).filter((header) => header.startsWith("x-amz-meta-")).reduce((acc, header) => {
        acc[header.substring(11)] = output.headers[header];
        return acc;
      }, {})
    ]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_ListBucketAnalyticsConfigurationsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.AnalyticsConfiguration === "") {
    contents[_ACLn] = [];
  } else if (data2[_AC] != null) {
    contents[_ACLn] = de_AnalyticsConfigurationList(getArrayIfSingleItem(data2[_AC]), context);
  }
  if (data2[_CTo] != null) {
    contents[_CTo] = expectString(data2[_CTo]);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_NCT] != null) {
    contents[_NCT] = expectString(data2[_NCT]);
  }
  return contents;
};
var de_ListBucketIntelligentTieringConfigurationsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_CTo] != null) {
    contents[_CTo] = expectString(data2[_CTo]);
  }
  if (data2.IntelligentTieringConfiguration === "") {
    contents[_ITCL] = [];
  } else if (data2[_ITC] != null) {
    contents[_ITCL] = de_IntelligentTieringConfigurationList(getArrayIfSingleItem(data2[_ITC]), context);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_NCT] != null) {
    contents[_NCT] = expectString(data2[_NCT]);
  }
  return contents;
};
var de_ListBucketInventoryConfigurationsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_CTo] != null) {
    contents[_CTo] = expectString(data2[_CTo]);
  }
  if (data2.InventoryConfiguration === "") {
    contents[_ICL] = [];
  } else if (data2[_IC] != null) {
    contents[_ICL] = de_InventoryConfigurationList(getArrayIfSingleItem(data2[_IC]), context);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_NCT] != null) {
    contents[_NCT] = expectString(data2[_NCT]);
  }
  return contents;
};
var de_ListBucketMetricsConfigurationsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_CTo] != null) {
    contents[_CTo] = expectString(data2[_CTo]);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2.MetricsConfiguration === "") {
    contents[_MCL] = [];
  } else if (data2[_MC] != null) {
    contents[_MCL] = de_MetricsConfigurationList(getArrayIfSingleItem(data2[_MC]), context);
  }
  if (data2[_NCT] != null) {
    contents[_NCT] = expectString(data2[_NCT]);
  }
  return contents;
};
var de_ListBucketsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.Buckets === "") {
    contents[_Bu] = [];
  } else if (data2[_Bu] != null && data2[_Bu][_B] != null) {
    contents[_Bu] = de_Buckets(getArrayIfSingleItem(data2[_Bu][_B]), context);
  }
  if (data2[_CTo] != null) {
    contents[_CTo] = expectString(data2[_CTo]);
  }
  if (data2[_O] != null) {
    contents[_O] = de_Owner(data2[_O], context);
  }
  if (data2[_P] != null) {
    contents[_P] = expectString(data2[_P]);
  }
  return contents;
};
var de_ListDirectoryBucketsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.Buckets === "") {
    contents[_Bu] = [];
  } else if (data2[_Bu] != null && data2[_Bu][_B] != null) {
    contents[_Bu] = de_Buckets(getArrayIfSingleItem(data2[_Bu][_B]), context);
  }
  if (data2[_CTo] != null) {
    contents[_CTo] = expectString(data2[_CTo]);
  }
  return contents;
};
var de_ListMultipartUploadsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_B] != null) {
    contents[_B] = expectString(data2[_B]);
  }
  if (data2.CommonPrefixes === "") {
    contents[_CP] = [];
  } else if (data2[_CP] != null) {
    contents[_CP] = de_CommonPrefixList(getArrayIfSingleItem(data2[_CP]), context);
  }
  if (data2[_D] != null) {
    contents[_D] = expectString(data2[_D]);
  }
  if (data2[_ET] != null) {
    contents[_ET] = expectString(data2[_ET]);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_KM] != null) {
    contents[_KM] = expectString(data2[_KM]);
  }
  if (data2[_MU] != null) {
    contents[_MU] = strictParseInt32(data2[_MU]);
  }
  if (data2[_NKM] != null) {
    contents[_NKM] = expectString(data2[_NKM]);
  }
  if (data2[_NUIM] != null) {
    contents[_NUIM] = expectString(data2[_NUIM]);
  }
  if (data2[_P] != null) {
    contents[_P] = expectString(data2[_P]);
  }
  if (data2[_UIM] != null) {
    contents[_UIM] = expectString(data2[_UIM]);
  }
  if (data2.Upload === "") {
    contents[_Up] = [];
  } else if (data2[_U] != null) {
    contents[_Up] = de_MultipartUploadList(getArrayIfSingleItem(data2[_U]), context);
  }
  return contents;
};
var de_ListObjectsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.CommonPrefixes === "") {
    contents[_CP] = [];
  } else if (data2[_CP] != null) {
    contents[_CP] = de_CommonPrefixList(getArrayIfSingleItem(data2[_CP]), context);
  }
  if (data2.Contents === "") {
    contents[_Co] = [];
  } else if (data2[_Co] != null) {
    contents[_Co] = de_ObjectList(getArrayIfSingleItem(data2[_Co]), context);
  }
  if (data2[_D] != null) {
    contents[_D] = expectString(data2[_D]);
  }
  if (data2[_ET] != null) {
    contents[_ET] = expectString(data2[_ET]);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_M] != null) {
    contents[_M] = expectString(data2[_M]);
  }
  if (data2[_MK] != null) {
    contents[_MK] = strictParseInt32(data2[_MK]);
  }
  if (data2[_N] != null) {
    contents[_N] = expectString(data2[_N]);
  }
  if (data2[_NM] != null) {
    contents[_NM] = expectString(data2[_NM]);
  }
  if (data2[_P] != null) {
    contents[_P] = expectString(data2[_P]);
  }
  return contents;
};
var de_ListObjectsV2Command = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.CommonPrefixes === "") {
    contents[_CP] = [];
  } else if (data2[_CP] != null) {
    contents[_CP] = de_CommonPrefixList(getArrayIfSingleItem(data2[_CP]), context);
  }
  if (data2.Contents === "") {
    contents[_Co] = [];
  } else if (data2[_Co] != null) {
    contents[_Co] = de_ObjectList(getArrayIfSingleItem(data2[_Co]), context);
  }
  if (data2[_CTo] != null) {
    contents[_CTo] = expectString(data2[_CTo]);
  }
  if (data2[_D] != null) {
    contents[_D] = expectString(data2[_D]);
  }
  if (data2[_ET] != null) {
    contents[_ET] = expectString(data2[_ET]);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_KC] != null) {
    contents[_KC] = strictParseInt32(data2[_KC]);
  }
  if (data2[_MK] != null) {
    contents[_MK] = strictParseInt32(data2[_MK]);
  }
  if (data2[_N] != null) {
    contents[_N] = expectString(data2[_N]);
  }
  if (data2[_NCT] != null) {
    contents[_NCT] = expectString(data2[_NCT]);
  }
  if (data2[_P] != null) {
    contents[_P] = expectString(data2[_P]);
  }
  if (data2[_SA] != null) {
    contents[_SA] = expectString(data2[_SA]);
  }
  return contents;
};
var de_ListObjectVersionsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2.CommonPrefixes === "") {
    contents[_CP] = [];
  } else if (data2[_CP] != null) {
    contents[_CP] = de_CommonPrefixList(getArrayIfSingleItem(data2[_CP]), context);
  }
  if (data2.DeleteMarker === "") {
    contents[_DMe] = [];
  } else if (data2[_DM] != null) {
    contents[_DMe] = de_DeleteMarkers(getArrayIfSingleItem(data2[_DM]), context);
  }
  if (data2[_D] != null) {
    contents[_D] = expectString(data2[_D]);
  }
  if (data2[_ET] != null) {
    contents[_ET] = expectString(data2[_ET]);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_KM] != null) {
    contents[_KM] = expectString(data2[_KM]);
  }
  if (data2[_MK] != null) {
    contents[_MK] = strictParseInt32(data2[_MK]);
  }
  if (data2[_N] != null) {
    contents[_N] = expectString(data2[_N]);
  }
  if (data2[_NKM] != null) {
    contents[_NKM] = expectString(data2[_NKM]);
  }
  if (data2[_NVIM] != null) {
    contents[_NVIM] = expectString(data2[_NVIM]);
  }
  if (data2[_P] != null) {
    contents[_P] = expectString(data2[_P]);
  }
  if (data2[_VIM] != null) {
    contents[_VIM] = expectString(data2[_VIM]);
  }
  if (data2.Version === "") {
    contents[_Ve] = [];
  } else if (data2[_V] != null) {
    contents[_Ve] = de_ObjectVersionList(getArrayIfSingleItem(data2[_V]), context);
  }
  return contents;
};
var de_ListPartsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_AD]: [
      () => output.headers[_xaad] !== undefined,
      () => expectNonNull(parseRfc7231DateTime(output.headers[_xaad]))
    ],
    [_ARI]: [, output.headers[_xaari]],
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectNonNull(expectObject(await import_core11.parseXmlBody(output.body, context)), "body");
  if (data2[_B] != null) {
    contents[_B] = expectString(data2[_B]);
  }
  if (data2[_CA] != null) {
    contents[_CA] = expectString(data2[_CA]);
  }
  if (data2[_In] != null) {
    contents[_In] = de_Initiator(data2[_In], context);
  }
  if (data2[_IT] != null) {
    contents[_IT] = parseBoolean(data2[_IT]);
  }
  if (data2[_K] != null) {
    contents[_K] = expectString(data2[_K]);
  }
  if (data2[_MP] != null) {
    contents[_MP] = strictParseInt32(data2[_MP]);
  }
  if (data2[_NPNM] != null) {
    contents[_NPNM] = expectString(data2[_NPNM]);
  }
  if (data2[_O] != null) {
    contents[_O] = de_Owner(data2[_O], context);
  }
  if (data2[_PNM] != null) {
    contents[_PNM] = expectString(data2[_PNM]);
  }
  if (data2.Part === "") {
    contents[_Part] = [];
  } else if (data2[_Par] != null) {
    contents[_Part] = de_Parts(getArrayIfSingleItem(data2[_Par]), context);
  }
  if (data2[_SC] != null) {
    contents[_SC] = expectString(data2[_SC]);
  }
  if (data2[_UI] != null) {
    contents[_UI] = expectString(data2[_UI]);
  }
  return contents;
};
var de_PutBucketAccelerateConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketAclCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketAnalyticsConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketCorsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketEncryptionCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketIntelligentTieringConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketInventoryConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketLifecycleConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_TDMOS]: [, output.headers[_xatdmos]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketLoggingCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketMetricsConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketNotificationConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketOwnershipControlsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketPolicyCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketReplicationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketRequestPaymentCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketTaggingCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketVersioningCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutBucketWebsiteCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutObjectCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_Exp]: [, output.headers[_xae]],
    [_ETa]: [, output.headers[_eta]],
    [_CCRC]: [, output.headers[_xacc]],
    [_CCRCC]: [, output.headers[_xacc_]],
    [_CSHA]: [, output.headers[_xacs]],
    [_CSHAh]: [, output.headers[_xacs_]],
    [_SSE]: [, output.headers[_xasse]],
    [_VI]: [, output.headers[_xavi]],
    [_SSECA]: [, output.headers[_xasseca]],
    [_SSECKMD]: [, output.headers[_xasseckm]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_SSEKMSEC]: [, output.headers[_xassec]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutObjectAclCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutObjectLegalHoldCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutObjectLockConfigurationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutObjectRetentionCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutObjectTaggingCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_VI]: [, output.headers[_xavi]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_PutPublicAccessBlockCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_RestoreObjectCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_RC]: [, output.headers[_xarc]],
    [_ROP]: [, output.headers[_xarop]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_SelectObjectContentCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  const data2 = output.body;
  contents.Payload = de_SelectObjectContentEventStream(data2, context);
  return contents;
};
var de_UploadPartCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_SSE]: [, output.headers[_xasse]],
    [_ETa]: [, output.headers[_eta]],
    [_CCRC]: [, output.headers[_xacc]],
    [_CCRCC]: [, output.headers[_xacc_]],
    [_CSHA]: [, output.headers[_xacs]],
    [_CSHAh]: [, output.headers[_xacs_]],
    [_SSECA]: [, output.headers[_xasseca]],
    [_SSECKMD]: [, output.headers[_xasseckm]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_RC]: [, output.headers[_xarc]]
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_UploadPartCopyCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output),
    [_CSVI]: [, output.headers[_xacsvi]],
    [_SSE]: [, output.headers[_xasse]],
    [_SSECA]: [, output.headers[_xasseca]],
    [_SSECKMD]: [, output.headers[_xasseckm]],
    [_SSEKMSKI]: [, output.headers[_xasseakki]],
    [_BKE]: [() => output.headers[_xassebke] !== undefined, () => parseBoolean(output.headers[_xassebke])],
    [_RC]: [, output.headers[_xarc]]
  });
  const data2 = expectObject(await import_core11.parseXmlBody(output.body, context));
  contents.CopyPartResult = de_CopyPartResult(data2, context);
  return contents;
};
var de_WriteGetObjectResponseCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata2(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_CommandError = async (output, context) => {
  const parsedOutput = {
    ...output,
    body: await import_core11.parseXmlErrorBody(output.body, context)
  };
  const errorCode = import_core11.loadRestXmlErrorCode(output, parsedOutput.body);
  switch (errorCode) {
    case "NoSuchUpload":
    case "com.amazonaws.s3#NoSuchUpload":
      throw await de_NoSuchUploadRes(parsedOutput, context);
    case "ObjectNotInActiveTierError":
    case "com.amazonaws.s3#ObjectNotInActiveTierError":
      throw await de_ObjectNotInActiveTierErrorRes(parsedOutput, context);
    case "BucketAlreadyExists":
    case "com.amazonaws.s3#BucketAlreadyExists":
      throw await de_BucketAlreadyExistsRes(parsedOutput, context);
    case "BucketAlreadyOwnedByYou":
    case "com.amazonaws.s3#BucketAlreadyOwnedByYou":
      throw await de_BucketAlreadyOwnedByYouRes(parsedOutput, context);
    case "NoSuchBucket":
    case "com.amazonaws.s3#NoSuchBucket":
      throw await de_NoSuchBucketRes(parsedOutput, context);
    case "InvalidObjectState":
    case "com.amazonaws.s3#InvalidObjectState":
      throw await de_InvalidObjectStateRes(parsedOutput, context);
    case "NoSuchKey":
    case "com.amazonaws.s3#NoSuchKey":
      throw await de_NoSuchKeyRes(parsedOutput, context);
    case "NotFound":
    case "com.amazonaws.s3#NotFound":
      throw await de_NotFoundRes(parsedOutput, context);
    case "ObjectAlreadyInActiveTierError":
    case "com.amazonaws.s3#ObjectAlreadyInActiveTierError":
      throw await de_ObjectAlreadyInActiveTierErrorRes(parsedOutput, context);
    default:
      const parsedBody = parsedOutput.body;
      return throwDefaultError2({
        output,
        parsedBody,
        errorCode
      });
  }
};
var throwDefaultError2;
var de_BucketAlreadyExistsRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new BucketAlreadyExists({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_BucketAlreadyOwnedByYouRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new BucketAlreadyOwnedByYou({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidObjectStateRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  if (data2[_AT] != null) {
    contents[_AT] = expectString(data2[_AT]);
  }
  if (data2[_SC] != null) {
    contents[_SC] = expectString(data2[_SC]);
  }
  const exception2 = new InvalidObjectState({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_NoSuchBucketRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new NoSuchBucket({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_NoSuchKeyRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new NoSuchKey({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_NoSuchUploadRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new NoSuchUpload({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_NotFoundRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new NotFound({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_ObjectAlreadyInActiveTierErrorRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new ObjectAlreadyInActiveTierError({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_ObjectNotInActiveTierErrorRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const exception2 = new ObjectNotInActiveTierError({
    $metadata: deserializeMetadata2(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_SelectObjectContentEventStream = (output, context) => {
  return context.eventStreamMarshaller.deserialize(output, async (event) => {
    if (event["Records"] != null) {
      return {
        Records: await de_RecordsEvent_event(event["Records"], context)
      };
    }
    if (event["Stats"] != null) {
      return {
        Stats: await de_StatsEvent_event(event["Stats"], context)
      };
    }
    if (event["Progress"] != null) {
      return {
        Progress: await de_ProgressEvent_event(event["Progress"], context)
      };
    }
    if (event["Cont"] != null) {
      return {
        Cont: await de_ContinuationEvent_event(event["Cont"], context)
      };
    }
    if (event["End"] != null) {
      return {
        End: await de_EndEvent_event(event["End"], context)
      };
    }
    return { $unknown: output };
  });
};
var de_ContinuationEvent_event = async (output, context) => {
  const contents = {};
  const data2 = await import_core11.parseXmlBody(output.body, context);
  Object.assign(contents, de_ContinuationEvent(data2, context));
  return contents;
};
var de_EndEvent_event = async (output, context) => {
  const contents = {};
  const data2 = await import_core11.parseXmlBody(output.body, context);
  Object.assign(contents, de_EndEvent(data2, context));
  return contents;
};
var de_ProgressEvent_event = async (output, context) => {
  const contents = {};
  const data2 = await import_core11.parseXmlBody(output.body, context);
  contents.Details = de_Progress(data2, context);
  return contents;
};
var de_RecordsEvent_event = async (output, context) => {
  const contents = {};
  contents.Payload = output.body;
  return contents;
};
var de_StatsEvent_event = async (output, context) => {
  const contents = {};
  const data2 = await import_core11.parseXmlBody(output.body, context);
  contents.Details = de_Stats(data2, context);
  return contents;
};
var se_AbortIncompleteMultipartUpload = (input, context) => {
  const bn2 = new XmlNode(_AIMU);
  if (input[_DAI] != null) {
    bn2.c(XmlNode.of(_DAI, String(input[_DAI])).n(_DAI));
  }
  return bn2;
};
var se_AccelerateConfiguration = (input, context) => {
  const bn2 = new XmlNode(_ACc);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_BAS, input[_S]).n(_S));
  }
  return bn2;
};
var se_AccessControlPolicy = (input, context) => {
  const bn2 = new XmlNode(_ACP);
  bn2.lc(input, "Grants", "AccessControlList", () => se_Grants(input[_Gr], context));
  if (input[_O] != null) {
    bn2.c(se_Owner(input[_O], context).n(_O));
  }
  return bn2;
};
var se_AccessControlTranslation = (input, context) => {
  const bn2 = new XmlNode(_ACT);
  if (input[_O] != null) {
    bn2.c(XmlNode.of(_OOw, input[_O]).n(_O));
  }
  return bn2;
};
var se_AllowedHeaders = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = XmlNode.of(_AH, entry);
    return n2.n(_me);
  });
};
var se_AllowedMethods = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = XmlNode.of(_AM, entry);
    return n2.n(_me);
  });
};
var se_AllowedOrigins = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = XmlNode.of(_AO, entry);
    return n2.n(_me);
  });
};
var se_AnalyticsAndOperator = (input, context) => {
  const bn2 = new XmlNode(_AAO);
  bn2.cc(input, _P);
  bn2.l(input, "Tags", "Tag", () => se_TagSet(input[_Tag], context));
  return bn2;
};
var se_AnalyticsConfiguration = (input, context) => {
  const bn2 = new XmlNode(_AC);
  if (input[_I] != null) {
    bn2.c(XmlNode.of(_AI, input[_I]).n(_I));
  }
  if (input[_F] != null) {
    bn2.c(se_AnalyticsFilter(input[_F], context).n(_F));
  }
  if (input[_SCA] != null) {
    bn2.c(se_StorageClassAnalysis(input[_SCA], context).n(_SCA));
  }
  return bn2;
};
var se_AnalyticsExportDestination = (input, context) => {
  const bn2 = new XmlNode(_AED);
  if (input[_SBD] != null) {
    bn2.c(se_AnalyticsS3BucketDestination(input[_SBD], context).n(_SBD));
  }
  return bn2;
};
var se_AnalyticsFilter = (input, context) => {
  const bn2 = new XmlNode(_AF);
  AnalyticsFilter.visit(input, {
    Prefix: (value) => {
      if (input[_P] != null) {
        bn2.c(XmlNode.of(_P, value).n(_P));
      }
    },
    Tag: (value) => {
      if (input[_Ta] != null) {
        bn2.c(se_Tag(value, context).n(_Ta));
      }
    },
    And: (value) => {
      if (input[_A] != null) {
        bn2.c(se_AnalyticsAndOperator(value, context).n(_A));
      }
    },
    _: (name, value) => {
      if (!(value instanceof XmlNode || value instanceof XmlText)) {
        throw new Error("Unable to serialize unknown union members in XML.");
      }
      bn2.c(new XmlNode(name).c(value));
    }
  });
  return bn2;
};
var se_AnalyticsS3BucketDestination = (input, context) => {
  const bn2 = new XmlNode(_ASBD);
  if (input[_Fo] != null) {
    bn2.c(XmlNode.of(_ASEFF, input[_Fo]).n(_Fo));
  }
  if (input[_BAI] != null) {
    bn2.c(XmlNode.of(_AIc, input[_BAI]).n(_BAI));
  }
  if (input[_B] != null) {
    bn2.c(XmlNode.of(_BN, input[_B]).n(_B));
  }
  bn2.cc(input, _P);
  return bn2;
};
var se_BucketInfo = (input, context) => {
  const bn2 = new XmlNode(_BI);
  bn2.cc(input, _DR);
  if (input[_Ty] != null) {
    bn2.c(XmlNode.of(_BT, input[_Ty]).n(_Ty));
  }
  return bn2;
};
var se_BucketLifecycleConfiguration = (input, context) => {
  const bn2 = new XmlNode(_BLC);
  bn2.l(input, "Rules", "Rule", () => se_LifecycleRules(input[_Rul], context));
  return bn2;
};
var se_BucketLoggingStatus = (input, context) => {
  const bn2 = new XmlNode(_BLS);
  if (input[_LE] != null) {
    bn2.c(se_LoggingEnabled(input[_LE], context).n(_LE));
  }
  return bn2;
};
var se_CompletedMultipartUpload = (input, context) => {
  const bn2 = new XmlNode(_CMU);
  bn2.l(input, "Parts", "Part", () => se_CompletedPartList(input[_Part], context));
  return bn2;
};
var se_CompletedPart = (input, context) => {
  const bn2 = new XmlNode(_CPo);
  bn2.cc(input, _ETa);
  bn2.cc(input, _CCRC);
  bn2.cc(input, _CCRCC);
  bn2.cc(input, _CSHA);
  bn2.cc(input, _CSHAh);
  if (input[_PN] != null) {
    bn2.c(XmlNode.of(_PN, String(input[_PN])).n(_PN));
  }
  return bn2;
};
var se_CompletedPartList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_CompletedPart(entry, context);
    return n2.n(_me);
  });
};
var se_Condition = (input, context) => {
  const bn2 = new XmlNode(_Con);
  bn2.cc(input, _HECRE);
  bn2.cc(input, _KPE);
  return bn2;
};
var se_CORSConfiguration = (input, context) => {
  const bn2 = new XmlNode(_CORSC);
  bn2.l(input, "CORSRules", "CORSRule", () => se_CORSRules(input[_CORSRu], context));
  return bn2;
};
var se_CORSRule = (input, context) => {
  const bn2 = new XmlNode(_CORSR);
  bn2.cc(input, _ID_);
  bn2.l(input, "AllowedHeaders", "AllowedHeader", () => se_AllowedHeaders(input[_AHl], context));
  bn2.l(input, "AllowedMethods", "AllowedMethod", () => se_AllowedMethods(input[_AMl], context));
  bn2.l(input, "AllowedOrigins", "AllowedOrigin", () => se_AllowedOrigins(input[_AOl], context));
  bn2.l(input, "ExposeHeaders", "ExposeHeader", () => se_ExposeHeaders(input[_EH], context));
  if (input[_MAS] != null) {
    bn2.c(XmlNode.of(_MAS, String(input[_MAS])).n(_MAS));
  }
  return bn2;
};
var se_CORSRules = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_CORSRule(entry, context);
    return n2.n(_me);
  });
};
var se_CreateBucketConfiguration = (input, context) => {
  const bn2 = new XmlNode(_CBC);
  if (input[_LC] != null) {
    bn2.c(XmlNode.of(_BLCu, input[_LC]).n(_LC));
  }
  if (input[_L] != null) {
    bn2.c(se_LocationInfo(input[_L], context).n(_L));
  }
  if (input[_B] != null) {
    bn2.c(se_BucketInfo(input[_B], context).n(_B));
  }
  return bn2;
};
var se_CSVInput = (input, context) => {
  const bn2 = new XmlNode(_CSVIn);
  bn2.cc(input, _FHI);
  bn2.cc(input, _Com);
  bn2.cc(input, _QEC);
  bn2.cc(input, _RD);
  bn2.cc(input, _FD);
  bn2.cc(input, _QCuo);
  if (input[_AQRD] != null) {
    bn2.c(XmlNode.of(_AQRD, String(input[_AQRD])).n(_AQRD));
  }
  return bn2;
};
var se_CSVOutput = (input, context) => {
  const bn2 = new XmlNode(_CSVO);
  bn2.cc(input, _QF);
  bn2.cc(input, _QEC);
  bn2.cc(input, _RD);
  bn2.cc(input, _FD);
  bn2.cc(input, _QCuo);
  return bn2;
};
var se_DefaultRetention = (input, context) => {
  const bn2 = new XmlNode(_DRe);
  if (input[_Mo] != null) {
    bn2.c(XmlNode.of(_OLRM, input[_Mo]).n(_Mo));
  }
  if (input[_Da] != null) {
    bn2.c(XmlNode.of(_Da, String(input[_Da])).n(_Da));
  }
  if (input[_Y] != null) {
    bn2.c(XmlNode.of(_Y, String(input[_Y])).n(_Y));
  }
  return bn2;
};
var se_Delete = (input, context) => {
  const bn2 = new XmlNode(_Del);
  bn2.l(input, "Objects", "Object", () => se_ObjectIdentifierList(input[_Ob], context));
  if (input[_Q] != null) {
    bn2.c(XmlNode.of(_Q, String(input[_Q])).n(_Q));
  }
  return bn2;
};
var se_DeleteMarkerReplication = (input, context) => {
  const bn2 = new XmlNode(_DMR);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_DMRS, input[_S]).n(_S));
  }
  return bn2;
};
var se_Destination = (input, context) => {
  const bn2 = new XmlNode(_Des);
  if (input[_B] != null) {
    bn2.c(XmlNode.of(_BN, input[_B]).n(_B));
  }
  if (input[_Ac] != null) {
    bn2.c(XmlNode.of(_AIc, input[_Ac]).n(_Ac));
  }
  bn2.cc(input, _SC);
  if (input[_ACT] != null) {
    bn2.c(se_AccessControlTranslation(input[_ACT], context).n(_ACT));
  }
  if (input[_ECn] != null) {
    bn2.c(se_EncryptionConfiguration(input[_ECn], context).n(_ECn));
  }
  if (input[_RTe] != null) {
    bn2.c(se_ReplicationTime(input[_RTe], context).n(_RTe));
  }
  if (input[_Me] != null) {
    bn2.c(se_Metrics(input[_Me], context).n(_Me));
  }
  return bn2;
};
var se_Encryption = (input, context) => {
  const bn2 = new XmlNode(_En);
  if (input[_ETn] != null) {
    bn2.c(XmlNode.of(_SSE, input[_ETn]).n(_ETn));
  }
  if (input[_KMSKI] != null) {
    bn2.c(XmlNode.of(_SSEKMSKI, input[_KMSKI]).n(_KMSKI));
  }
  bn2.cc(input, _KMSC);
  return bn2;
};
var se_EncryptionConfiguration = (input, context) => {
  const bn2 = new XmlNode(_ECn);
  bn2.cc(input, _RKKID);
  return bn2;
};
var se_ErrorDocument = (input, context) => {
  const bn2 = new XmlNode(_ED);
  if (input[_K] != null) {
    bn2.c(XmlNode.of(_OK, input[_K]).n(_K));
  }
  return bn2;
};
var se_EventBridgeConfiguration = (input, context) => {
  const bn2 = new XmlNode(_EBC);
  return bn2;
};
var se_EventList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = XmlNode.of(_Ev, entry);
    return n2.n(_me);
  });
};
var se_ExistingObjectReplication = (input, context) => {
  const bn2 = new XmlNode(_EOR);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_EORS, input[_S]).n(_S));
  }
  return bn2;
};
var se_ExposeHeaders = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = XmlNode.of(_EHx, entry);
    return n2.n(_me);
  });
};
var se_FilterRule = (input, context) => {
  const bn2 = new XmlNode(_FR);
  if (input[_N] != null) {
    bn2.c(XmlNode.of(_FRN, input[_N]).n(_N));
  }
  if (input[_Va] != null) {
    bn2.c(XmlNode.of(_FRV, input[_Va]).n(_Va));
  }
  return bn2;
};
var se_FilterRuleList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_FilterRule(entry, context);
    return n2.n(_me);
  });
};
var se_GlacierJobParameters = (input, context) => {
  const bn2 = new XmlNode(_GJP);
  bn2.cc(input, _Ti);
  return bn2;
};
var se_Grant = (input, context) => {
  const bn2 = new XmlNode(_G);
  if (input[_Gra] != null) {
    const n2 = se_Grantee(input[_Gra], context).n(_Gra);
    n2.a("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
    bn2.c(n2);
  }
  bn2.cc(input, _Pe);
  return bn2;
};
var se_Grantee = (input, context) => {
  const bn2 = new XmlNode(_Gra);
  bn2.cc(input, _DN);
  bn2.cc(input, _EA);
  bn2.cc(input, _ID_);
  bn2.cc(input, _URI);
  bn2.a("xsi:type", input[_Ty]);
  return bn2;
};
var se_Grants = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_Grant(entry, context);
    return n2.n(_G);
  });
};
var se_IndexDocument = (input, context) => {
  const bn2 = new XmlNode(_ID);
  bn2.cc(input, _Su);
  return bn2;
};
var se_InputSerialization = (input, context) => {
  const bn2 = new XmlNode(_IS);
  if (input[_CSV] != null) {
    bn2.c(se_CSVInput(input[_CSV], context).n(_CSV));
  }
  bn2.cc(input, _CTom);
  if (input[_JSON] != null) {
    bn2.c(se_JSONInput(input[_JSON], context).n(_JSON));
  }
  if (input[_Parq] != null) {
    bn2.c(se_ParquetInput(input[_Parq], context).n(_Parq));
  }
  return bn2;
};
var se_IntelligentTieringAndOperator = (input, context) => {
  const bn2 = new XmlNode(_ITAO);
  bn2.cc(input, _P);
  bn2.l(input, "Tags", "Tag", () => se_TagSet(input[_Tag], context));
  return bn2;
};
var se_IntelligentTieringConfiguration = (input, context) => {
  const bn2 = new XmlNode(_ITC);
  if (input[_I] != null) {
    bn2.c(XmlNode.of(_ITI, input[_I]).n(_I));
  }
  if (input[_F] != null) {
    bn2.c(se_IntelligentTieringFilter(input[_F], context).n(_F));
  }
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_ITS, input[_S]).n(_S));
  }
  bn2.l(input, "Tierings", "Tiering", () => se_TieringList(input[_Tie], context));
  return bn2;
};
var se_IntelligentTieringFilter = (input, context) => {
  const bn2 = new XmlNode(_ITF);
  bn2.cc(input, _P);
  if (input[_Ta] != null) {
    bn2.c(se_Tag(input[_Ta], context).n(_Ta));
  }
  if (input[_A] != null) {
    bn2.c(se_IntelligentTieringAndOperator(input[_A], context).n(_A));
  }
  return bn2;
};
var se_InventoryConfiguration = (input, context) => {
  const bn2 = new XmlNode(_IC);
  if (input[_Des] != null) {
    bn2.c(se_InventoryDestination(input[_Des], context).n(_Des));
  }
  if (input[_IE] != null) {
    bn2.c(XmlNode.of(_IE, String(input[_IE])).n(_IE));
  }
  if (input[_F] != null) {
    bn2.c(se_InventoryFilter(input[_F], context).n(_F));
  }
  if (input[_I] != null) {
    bn2.c(XmlNode.of(_II, input[_I]).n(_I));
  }
  if (input[_IOV] != null) {
    bn2.c(XmlNode.of(_IIOV, input[_IOV]).n(_IOV));
  }
  bn2.lc(input, "OptionalFields", "OptionalFields", () => se_InventoryOptionalFields(input[_OF], context));
  if (input[_Sc] != null) {
    bn2.c(se_InventorySchedule(input[_Sc], context).n(_Sc));
  }
  return bn2;
};
var se_InventoryDestination = (input, context) => {
  const bn2 = new XmlNode(_IDn);
  if (input[_SBD] != null) {
    bn2.c(se_InventoryS3BucketDestination(input[_SBD], context).n(_SBD));
  }
  return bn2;
};
var se_InventoryEncryption = (input, context) => {
  const bn2 = new XmlNode(_IEn);
  if (input[_SSES] != null) {
    bn2.c(se_SSES3(input[_SSES], context).n(_SS));
  }
  if (input[_SSEKMS] != null) {
    bn2.c(se_SSEKMS(input[_SSEKMS], context).n(_SK));
  }
  return bn2;
};
var se_InventoryFilter = (input, context) => {
  const bn2 = new XmlNode(_IF);
  bn2.cc(input, _P);
  return bn2;
};
var se_InventoryOptionalFields = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = XmlNode.of(_IOF, entry);
    return n2.n(_Fi);
  });
};
var se_InventoryS3BucketDestination = (input, context) => {
  const bn2 = new XmlNode(_ISBD);
  bn2.cc(input, _AIc);
  if (input[_B] != null) {
    bn2.c(XmlNode.of(_BN, input[_B]).n(_B));
  }
  if (input[_Fo] != null) {
    bn2.c(XmlNode.of(_IFn, input[_Fo]).n(_Fo));
  }
  bn2.cc(input, _P);
  if (input[_En] != null) {
    bn2.c(se_InventoryEncryption(input[_En], context).n(_En));
  }
  return bn2;
};
var se_InventorySchedule = (input, context) => {
  const bn2 = new XmlNode(_ISn);
  if (input[_Fr] != null) {
    bn2.c(XmlNode.of(_IFnv, input[_Fr]).n(_Fr));
  }
  return bn2;
};
var se_JSONInput = (input, context) => {
  const bn2 = new XmlNode(_JSONI);
  if (input[_Ty] != null) {
    bn2.c(XmlNode.of(_JSONT, input[_Ty]).n(_Ty));
  }
  return bn2;
};
var se_JSONOutput = (input, context) => {
  const bn2 = new XmlNode(_JSONO);
  bn2.cc(input, _RD);
  return bn2;
};
var se_LambdaFunctionConfiguration = (input, context) => {
  const bn2 = new XmlNode(_LFCa);
  if (input[_I] != null) {
    bn2.c(XmlNode.of(_NI, input[_I]).n(_I));
  }
  if (input[_LFA] != null) {
    bn2.c(XmlNode.of(_LFA, input[_LFA]).n(_CF));
  }
  bn2.l(input, "Events", "Event", () => se_EventList(input[_Eve], context));
  if (input[_F] != null) {
    bn2.c(se_NotificationConfigurationFilter(input[_F], context).n(_F));
  }
  return bn2;
};
var se_LambdaFunctionConfigurationList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_LambdaFunctionConfiguration(entry, context);
    return n2.n(_me);
  });
};
var se_LifecycleExpiration = (input, context) => {
  const bn2 = new XmlNode(_LEi);
  if (input[_Dat] != null) {
    bn2.c(XmlNode.of(_Dat, serializeDateTime(input[_Dat]).toString()).n(_Dat));
  }
  if (input[_Da] != null) {
    bn2.c(XmlNode.of(_Da, String(input[_Da])).n(_Da));
  }
  if (input[_EODM] != null) {
    bn2.c(XmlNode.of(_EODM, String(input[_EODM])).n(_EODM));
  }
  return bn2;
};
var se_LifecycleRule = (input, context) => {
  const bn2 = new XmlNode(_LR);
  if (input[_Exp] != null) {
    bn2.c(se_LifecycleExpiration(input[_Exp], context).n(_Exp));
  }
  bn2.cc(input, _ID_);
  bn2.cc(input, _P);
  if (input[_F] != null) {
    bn2.c(se_LifecycleRuleFilter(input[_F], context).n(_F));
  }
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_ESx, input[_S]).n(_S));
  }
  bn2.l(input, "Transitions", "Transition", () => se_TransitionList(input[_Tr], context));
  bn2.l(input, "NoncurrentVersionTransitions", "NoncurrentVersionTransition", () => se_NoncurrentVersionTransitionList(input[_NVT], context));
  if (input[_NVE] != null) {
    bn2.c(se_NoncurrentVersionExpiration(input[_NVE], context).n(_NVE));
  }
  if (input[_AIMU] != null) {
    bn2.c(se_AbortIncompleteMultipartUpload(input[_AIMU], context).n(_AIMU));
  }
  return bn2;
};
var se_LifecycleRuleAndOperator = (input, context) => {
  const bn2 = new XmlNode(_LRAO);
  bn2.cc(input, _P);
  bn2.l(input, "Tags", "Tag", () => se_TagSet(input[_Tag], context));
  if (input[_OSGT] != null) {
    bn2.c(XmlNode.of(_OSGTB, String(input[_OSGT])).n(_OSGT));
  }
  if (input[_OSLT] != null) {
    bn2.c(XmlNode.of(_OSLTB, String(input[_OSLT])).n(_OSLT));
  }
  return bn2;
};
var se_LifecycleRuleFilter = (input, context) => {
  const bn2 = new XmlNode(_LRF);
  bn2.cc(input, _P);
  if (input[_Ta] != null) {
    bn2.c(se_Tag(input[_Ta], context).n(_Ta));
  }
  if (input[_OSGT] != null) {
    bn2.c(XmlNode.of(_OSGTB, String(input[_OSGT])).n(_OSGT));
  }
  if (input[_OSLT] != null) {
    bn2.c(XmlNode.of(_OSLTB, String(input[_OSLT])).n(_OSLT));
  }
  if (input[_A] != null) {
    bn2.c(se_LifecycleRuleAndOperator(input[_A], context).n(_A));
  }
  return bn2;
};
var se_LifecycleRules = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_LifecycleRule(entry, context);
    return n2.n(_me);
  });
};
var se_LocationInfo = (input, context) => {
  const bn2 = new XmlNode(_LI);
  if (input[_Ty] != null) {
    bn2.c(XmlNode.of(_LT, input[_Ty]).n(_Ty));
  }
  if (input[_N] != null) {
    bn2.c(XmlNode.of(_LNAS, input[_N]).n(_N));
  }
  return bn2;
};
var se_LoggingEnabled = (input, context) => {
  const bn2 = new XmlNode(_LE);
  bn2.cc(input, _TB);
  bn2.lc(input, "TargetGrants", "TargetGrants", () => se_TargetGrants(input[_TG], context));
  bn2.cc(input, _TP);
  if (input[_TOKF] != null) {
    bn2.c(se_TargetObjectKeyFormat(input[_TOKF], context).n(_TOKF));
  }
  return bn2;
};
var se_MetadataEntry = (input, context) => {
  const bn2 = new XmlNode(_ME);
  if (input[_N] != null) {
    bn2.c(XmlNode.of(_MKe, input[_N]).n(_N));
  }
  if (input[_Va] != null) {
    bn2.c(XmlNode.of(_MV, input[_Va]).n(_Va));
  }
  return bn2;
};
var se_Metrics = (input, context) => {
  const bn2 = new XmlNode(_Me);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_MS, input[_S]).n(_S));
  }
  if (input[_ETv] != null) {
    bn2.c(se_ReplicationTimeValue(input[_ETv], context).n(_ETv));
  }
  return bn2;
};
var se_MetricsAndOperator = (input, context) => {
  const bn2 = new XmlNode(_MAO);
  bn2.cc(input, _P);
  bn2.l(input, "Tags", "Tag", () => se_TagSet(input[_Tag], context));
  bn2.cc(input, _APAc);
  return bn2;
};
var se_MetricsConfiguration = (input, context) => {
  const bn2 = new XmlNode(_MC);
  if (input[_I] != null) {
    bn2.c(XmlNode.of(_MI, input[_I]).n(_I));
  }
  if (input[_F] != null) {
    bn2.c(se_MetricsFilter(input[_F], context).n(_F));
  }
  return bn2;
};
var se_MetricsFilter = (input, context) => {
  const bn2 = new XmlNode(_MF);
  MetricsFilter.visit(input, {
    Prefix: (value) => {
      if (input[_P] != null) {
        bn2.c(XmlNode.of(_P, value).n(_P));
      }
    },
    Tag: (value) => {
      if (input[_Ta] != null) {
        bn2.c(se_Tag(value, context).n(_Ta));
      }
    },
    AccessPointArn: (value) => {
      if (input[_APAc] != null) {
        bn2.c(XmlNode.of(_APAc, value).n(_APAc));
      }
    },
    And: (value) => {
      if (input[_A] != null) {
        bn2.c(se_MetricsAndOperator(value, context).n(_A));
      }
    },
    _: (name, value) => {
      if (!(value instanceof XmlNode || value instanceof XmlText)) {
        throw new Error("Unable to serialize unknown union members in XML.");
      }
      bn2.c(new XmlNode(name).c(value));
    }
  });
  return bn2;
};
var se_NoncurrentVersionExpiration = (input, context) => {
  const bn2 = new XmlNode(_NVE);
  if (input[_ND] != null) {
    bn2.c(XmlNode.of(_Da, String(input[_ND])).n(_ND));
  }
  if (input[_NNV] != null) {
    bn2.c(XmlNode.of(_VC, String(input[_NNV])).n(_NNV));
  }
  return bn2;
};
var se_NoncurrentVersionTransition = (input, context) => {
  const bn2 = new XmlNode(_NVTo);
  if (input[_ND] != null) {
    bn2.c(XmlNode.of(_Da, String(input[_ND])).n(_ND));
  }
  if (input[_SC] != null) {
    bn2.c(XmlNode.of(_TSC, input[_SC]).n(_SC));
  }
  if (input[_NNV] != null) {
    bn2.c(XmlNode.of(_VC, String(input[_NNV])).n(_NNV));
  }
  return bn2;
};
var se_NoncurrentVersionTransitionList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_NoncurrentVersionTransition(entry, context);
    return n2.n(_me);
  });
};
var se_NotificationConfiguration = (input, context) => {
  const bn2 = new XmlNode(_NC);
  bn2.l(input, "TopicConfigurations", "TopicConfiguration", () => se_TopicConfigurationList(input[_TCop], context));
  bn2.l(input, "QueueConfigurations", "QueueConfiguration", () => se_QueueConfigurationList(input[_QCu], context));
  bn2.l(input, "LambdaFunctionConfigurations", "CloudFunctionConfiguration", () => se_LambdaFunctionConfigurationList(input[_LFC], context));
  if (input[_EBC] != null) {
    bn2.c(se_EventBridgeConfiguration(input[_EBC], context).n(_EBC));
  }
  return bn2;
};
var se_NotificationConfigurationFilter = (input, context) => {
  const bn2 = new XmlNode(_NCF);
  if (input[_K] != null) {
    bn2.c(se_S3KeyFilter(input[_K], context).n(_SKe));
  }
  return bn2;
};
var se_ObjectIdentifier = (input, context) => {
  const bn2 = new XmlNode(_OI);
  if (input[_K] != null) {
    bn2.c(XmlNode.of(_OK, input[_K]).n(_K));
  }
  if (input[_VI] != null) {
    bn2.c(XmlNode.of(_OVI, input[_VI]).n(_VI));
  }
  return bn2;
};
var se_ObjectIdentifierList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_ObjectIdentifier(entry, context);
    return n2.n(_me);
  });
};
var se_ObjectLockConfiguration = (input, context) => {
  const bn2 = new XmlNode(_OLC);
  bn2.cc(input, _OLE);
  if (input[_Ru] != null) {
    bn2.c(se_ObjectLockRule(input[_Ru], context).n(_Ru));
  }
  return bn2;
};
var se_ObjectLockLegalHold = (input, context) => {
  const bn2 = new XmlNode(_OLLH);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_OLLHS, input[_S]).n(_S));
  }
  return bn2;
};
var se_ObjectLockRetention = (input, context) => {
  const bn2 = new XmlNode(_OLR);
  if (input[_Mo] != null) {
    bn2.c(XmlNode.of(_OLRM, input[_Mo]).n(_Mo));
  }
  if (input[_RUD] != null) {
    bn2.c(XmlNode.of(_Dat, serializeDateTime(input[_RUD]).toString()).n(_RUD));
  }
  return bn2;
};
var se_ObjectLockRule = (input, context) => {
  const bn2 = new XmlNode(_OLRb);
  if (input[_DRe] != null) {
    bn2.c(se_DefaultRetention(input[_DRe], context).n(_DRe));
  }
  return bn2;
};
var se_OutputLocation = (input, context) => {
  const bn2 = new XmlNode(_OL);
  if (input[_S_] != null) {
    bn2.c(se_S3Location(input[_S_], context).n(_S_));
  }
  return bn2;
};
var se_OutputSerialization = (input, context) => {
  const bn2 = new XmlNode(_OS);
  if (input[_CSV] != null) {
    bn2.c(se_CSVOutput(input[_CSV], context).n(_CSV));
  }
  if (input[_JSON] != null) {
    bn2.c(se_JSONOutput(input[_JSON], context).n(_JSON));
  }
  return bn2;
};
var se_Owner = (input, context) => {
  const bn2 = new XmlNode(_O);
  bn2.cc(input, _DN);
  bn2.cc(input, _ID_);
  return bn2;
};
var se_OwnershipControls = (input, context) => {
  const bn2 = new XmlNode(_OC);
  bn2.l(input, "Rules", "Rule", () => se_OwnershipControlsRules(input[_Rul], context));
  return bn2;
};
var se_OwnershipControlsRule = (input, context) => {
  const bn2 = new XmlNode(_OCR);
  bn2.cc(input, _OO);
  return bn2;
};
var se_OwnershipControlsRules = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_OwnershipControlsRule(entry, context);
    return n2.n(_me);
  });
};
var se_ParquetInput = (input, context) => {
  const bn2 = new XmlNode(_PI);
  return bn2;
};
var se_PartitionedPrefix = (input, context) => {
  const bn2 = new XmlNode(_PP);
  bn2.cc(input, _PDS);
  return bn2;
};
var se_PublicAccessBlockConfiguration = (input, context) => {
  const bn2 = new XmlNode(_PABC);
  if (input[_BPA] != null) {
    bn2.c(XmlNode.of(_Se, String(input[_BPA])).n(_BPA));
  }
  if (input[_IPA] != null) {
    bn2.c(XmlNode.of(_Se, String(input[_IPA])).n(_IPA));
  }
  if (input[_BPP] != null) {
    bn2.c(XmlNode.of(_Se, String(input[_BPP])).n(_BPP));
  }
  if (input[_RPB] != null) {
    bn2.c(XmlNode.of(_Se, String(input[_RPB])).n(_RPB));
  }
  return bn2;
};
var se_QueueConfiguration = (input, context) => {
  const bn2 = new XmlNode(_QC);
  if (input[_I] != null) {
    bn2.c(XmlNode.of(_NI, input[_I]).n(_I));
  }
  if (input[_QA] != null) {
    bn2.c(XmlNode.of(_QA, input[_QA]).n(_Qu));
  }
  bn2.l(input, "Events", "Event", () => se_EventList(input[_Eve], context));
  if (input[_F] != null) {
    bn2.c(se_NotificationConfigurationFilter(input[_F], context).n(_F));
  }
  return bn2;
};
var se_QueueConfigurationList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_QueueConfiguration(entry, context);
    return n2.n(_me);
  });
};
var se_Redirect = (input, context) => {
  const bn2 = new XmlNode(_Red);
  bn2.cc(input, _HN);
  bn2.cc(input, _HRC);
  bn2.cc(input, _Pr);
  bn2.cc(input, _RKPW);
  bn2.cc(input, _RKW);
  return bn2;
};
var se_RedirectAllRequestsTo = (input, context) => {
  const bn2 = new XmlNode(_RART);
  bn2.cc(input, _HN);
  bn2.cc(input, _Pr);
  return bn2;
};
var se_ReplicaModifications = (input, context) => {
  const bn2 = new XmlNode(_RM);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_RMS, input[_S]).n(_S));
  }
  return bn2;
};
var se_ReplicationConfiguration = (input, context) => {
  const bn2 = new XmlNode(_RCe);
  bn2.cc(input, _Ro);
  bn2.l(input, "Rules", "Rule", () => se_ReplicationRules(input[_Rul], context));
  return bn2;
};
var se_ReplicationRule = (input, context) => {
  const bn2 = new XmlNode(_RRe);
  bn2.cc(input, _ID_);
  if (input[_Pri] != null) {
    bn2.c(XmlNode.of(_Pri, String(input[_Pri])).n(_Pri));
  }
  bn2.cc(input, _P);
  if (input[_F] != null) {
    bn2.c(se_ReplicationRuleFilter(input[_F], context).n(_F));
  }
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_RRS, input[_S]).n(_S));
  }
  if (input[_SSC] != null) {
    bn2.c(se_SourceSelectionCriteria(input[_SSC], context).n(_SSC));
  }
  if (input[_EOR] != null) {
    bn2.c(se_ExistingObjectReplication(input[_EOR], context).n(_EOR));
  }
  if (input[_Des] != null) {
    bn2.c(se_Destination(input[_Des], context).n(_Des));
  }
  if (input[_DMR] != null) {
    bn2.c(se_DeleteMarkerReplication(input[_DMR], context).n(_DMR));
  }
  return bn2;
};
var se_ReplicationRuleAndOperator = (input, context) => {
  const bn2 = new XmlNode(_RRAO);
  bn2.cc(input, _P);
  bn2.l(input, "Tags", "Tag", () => se_TagSet(input[_Tag], context));
  return bn2;
};
var se_ReplicationRuleFilter = (input, context) => {
  const bn2 = new XmlNode(_RRF);
  bn2.cc(input, _P);
  if (input[_Ta] != null) {
    bn2.c(se_Tag(input[_Ta], context).n(_Ta));
  }
  if (input[_A] != null) {
    bn2.c(se_ReplicationRuleAndOperator(input[_A], context).n(_A));
  }
  return bn2;
};
var se_ReplicationRules = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_ReplicationRule(entry, context);
    return n2.n(_me);
  });
};
var se_ReplicationTime = (input, context) => {
  const bn2 = new XmlNode(_RTe);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_RTS, input[_S]).n(_S));
  }
  if (input[_Tim] != null) {
    bn2.c(se_ReplicationTimeValue(input[_Tim], context).n(_Tim));
  }
  return bn2;
};
var se_ReplicationTimeValue = (input, context) => {
  const bn2 = new XmlNode(_RTV);
  if (input[_Mi] != null) {
    bn2.c(XmlNode.of(_Mi, String(input[_Mi])).n(_Mi));
  }
  return bn2;
};
var se_RequestPaymentConfiguration = (input, context) => {
  const bn2 = new XmlNode(_RPC);
  bn2.cc(input, _Pa);
  return bn2;
};
var se_RequestProgress = (input, context) => {
  const bn2 = new XmlNode(_RPe);
  if (input[_Ena] != null) {
    bn2.c(XmlNode.of(_ERP, String(input[_Ena])).n(_Ena));
  }
  return bn2;
};
var se_RestoreRequest = (input, context) => {
  const bn2 = new XmlNode(_RRes);
  if (input[_Da] != null) {
    bn2.c(XmlNode.of(_Da, String(input[_Da])).n(_Da));
  }
  if (input[_GJP] != null) {
    bn2.c(se_GlacierJobParameters(input[_GJP], context).n(_GJP));
  }
  if (input[_Ty] != null) {
    bn2.c(XmlNode.of(_RRT, input[_Ty]).n(_Ty));
  }
  bn2.cc(input, _Ti);
  bn2.cc(input, _Desc);
  if (input[_SP] != null) {
    bn2.c(se_SelectParameters(input[_SP], context).n(_SP));
  }
  if (input[_OL] != null) {
    bn2.c(se_OutputLocation(input[_OL], context).n(_OL));
  }
  return bn2;
};
var se_RoutingRule = (input, context) => {
  const bn2 = new XmlNode(_RRou);
  if (input[_Con] != null) {
    bn2.c(se_Condition(input[_Con], context).n(_Con));
  }
  if (input[_Red] != null) {
    bn2.c(se_Redirect(input[_Red], context).n(_Red));
  }
  return bn2;
};
var se_RoutingRules = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_RoutingRule(entry, context);
    return n2.n(_RRou);
  });
};
var se_S3KeyFilter = (input, context) => {
  const bn2 = new XmlNode(_SKF);
  bn2.l(input, "FilterRules", "FilterRule", () => se_FilterRuleList(input[_FRi], context));
  return bn2;
};
var se_S3Location = (input, context) => {
  const bn2 = new XmlNode(_SL);
  bn2.cc(input, _BN);
  if (input[_P] != null) {
    bn2.c(XmlNode.of(_LP, input[_P]).n(_P));
  }
  if (input[_En] != null) {
    bn2.c(se_Encryption(input[_En], context).n(_En));
  }
  if (input[_CACL] != null) {
    bn2.c(XmlNode.of(_OCACL, input[_CACL]).n(_CACL));
  }
  bn2.lc(input, "AccessControlList", "AccessControlList", () => se_Grants(input[_ACLc], context));
  if (input[_T] != null) {
    bn2.c(se_Tagging(input[_T], context).n(_T));
  }
  bn2.lc(input, "UserMetadata", "UserMetadata", () => se_UserMetadata(input[_UM], context));
  bn2.cc(input, _SC);
  return bn2;
};
var se_ScanRange = (input, context) => {
  const bn2 = new XmlNode(_SR);
  if (input[_St] != null) {
    bn2.c(XmlNode.of(_St, String(input[_St])).n(_St));
  }
  if (input[_End] != null) {
    bn2.c(XmlNode.of(_End, String(input[_End])).n(_End));
  }
  return bn2;
};
var se_SelectParameters = (input, context) => {
  const bn2 = new XmlNode(_SP);
  if (input[_IS] != null) {
    bn2.c(se_InputSerialization(input[_IS], context).n(_IS));
  }
  bn2.cc(input, _ETx);
  bn2.cc(input, _Ex);
  if (input[_OS] != null) {
    bn2.c(se_OutputSerialization(input[_OS], context).n(_OS));
  }
  return bn2;
};
var se_ServerSideEncryptionByDefault = (input, context) => {
  const bn2 = new XmlNode(_SSEBD);
  if (input[_SSEA] != null) {
    bn2.c(XmlNode.of(_SSE, input[_SSEA]).n(_SSEA));
  }
  if (input[_KMSMKID] != null) {
    bn2.c(XmlNode.of(_SSEKMSKI, input[_KMSMKID]).n(_KMSMKID));
  }
  return bn2;
};
var se_ServerSideEncryptionConfiguration = (input, context) => {
  const bn2 = new XmlNode(_SSEC);
  bn2.l(input, "Rules", "Rule", () => se_ServerSideEncryptionRules(input[_Rul], context));
  return bn2;
};
var se_ServerSideEncryptionRule = (input, context) => {
  const bn2 = new XmlNode(_SSER);
  if (input[_ASSEBD] != null) {
    bn2.c(se_ServerSideEncryptionByDefault(input[_ASSEBD], context).n(_ASSEBD));
  }
  if (input[_BKE] != null) {
    bn2.c(XmlNode.of(_BKE, String(input[_BKE])).n(_BKE));
  }
  return bn2;
};
var se_ServerSideEncryptionRules = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_ServerSideEncryptionRule(entry, context);
    return n2.n(_me);
  });
};
var se_SimplePrefix = (input, context) => {
  const bn2 = new XmlNode(_SPi);
  return bn2;
};
var se_SourceSelectionCriteria = (input, context) => {
  const bn2 = new XmlNode(_SSC);
  if (input[_SKEO] != null) {
    bn2.c(se_SseKmsEncryptedObjects(input[_SKEO], context).n(_SKEO));
  }
  if (input[_RM] != null) {
    bn2.c(se_ReplicaModifications(input[_RM], context).n(_RM));
  }
  return bn2;
};
var se_SSEKMS = (input, context) => {
  const bn2 = new XmlNode(_SK);
  if (input[_KI] != null) {
    bn2.c(XmlNode.of(_SSEKMSKI, input[_KI]).n(_KI));
  }
  return bn2;
};
var se_SseKmsEncryptedObjects = (input, context) => {
  const bn2 = new XmlNode(_SKEO);
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_SKEOS, input[_S]).n(_S));
  }
  return bn2;
};
var se_SSES3 = (input, context) => {
  const bn2 = new XmlNode(_SS);
  return bn2;
};
var se_StorageClassAnalysis = (input, context) => {
  const bn2 = new XmlNode(_SCA);
  if (input[_DE] != null) {
    bn2.c(se_StorageClassAnalysisDataExport(input[_DE], context).n(_DE));
  }
  return bn2;
};
var se_StorageClassAnalysisDataExport = (input, context) => {
  const bn2 = new XmlNode(_SCADE);
  if (input[_OSV] != null) {
    bn2.c(XmlNode.of(_SCASV, input[_OSV]).n(_OSV));
  }
  if (input[_Des] != null) {
    bn2.c(se_AnalyticsExportDestination(input[_Des], context).n(_Des));
  }
  return bn2;
};
var se_Tag = (input, context) => {
  const bn2 = new XmlNode(_Ta);
  if (input[_K] != null) {
    bn2.c(XmlNode.of(_OK, input[_K]).n(_K));
  }
  bn2.cc(input, _Va);
  return bn2;
};
var se_Tagging = (input, context) => {
  const bn2 = new XmlNode(_T);
  bn2.lc(input, "TagSet", "TagSet", () => se_TagSet(input[_TS], context));
  return bn2;
};
var se_TagSet = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_Tag(entry, context);
    return n2.n(_Ta);
  });
};
var se_TargetGrant = (input, context) => {
  const bn2 = new XmlNode(_TGa);
  if (input[_Gra] != null) {
    const n2 = se_Grantee(input[_Gra], context).n(_Gra);
    n2.a("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
    bn2.c(n2);
  }
  if (input[_Pe] != null) {
    bn2.c(XmlNode.of(_BLP, input[_Pe]).n(_Pe));
  }
  return bn2;
};
var se_TargetGrants = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_TargetGrant(entry, context);
    return n2.n(_G);
  });
};
var se_TargetObjectKeyFormat = (input, context) => {
  const bn2 = new XmlNode(_TOKF);
  if (input[_SPi] != null) {
    bn2.c(se_SimplePrefix(input[_SPi], context).n(_SPi));
  }
  if (input[_PP] != null) {
    bn2.c(se_PartitionedPrefix(input[_PP], context).n(_PP));
  }
  return bn2;
};
var se_Tiering = (input, context) => {
  const bn2 = new XmlNode(_Tier);
  if (input[_Da] != null) {
    bn2.c(XmlNode.of(_ITD, String(input[_Da])).n(_Da));
  }
  if (input[_AT] != null) {
    bn2.c(XmlNode.of(_ITAT, input[_AT]).n(_AT));
  }
  return bn2;
};
var se_TieringList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_Tiering(entry, context);
    return n2.n(_me);
  });
};
var se_TopicConfiguration = (input, context) => {
  const bn2 = new XmlNode(_TCo);
  if (input[_I] != null) {
    bn2.c(XmlNode.of(_NI, input[_I]).n(_I));
  }
  if (input[_TA] != null) {
    bn2.c(XmlNode.of(_TA, input[_TA]).n(_Top));
  }
  bn2.l(input, "Events", "Event", () => se_EventList(input[_Eve], context));
  if (input[_F] != null) {
    bn2.c(se_NotificationConfigurationFilter(input[_F], context).n(_F));
  }
  return bn2;
};
var se_TopicConfigurationList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_TopicConfiguration(entry, context);
    return n2.n(_me);
  });
};
var se_Transition = (input, context) => {
  const bn2 = new XmlNode(_Tra);
  if (input[_Dat] != null) {
    bn2.c(XmlNode.of(_Dat, serializeDateTime(input[_Dat]).toString()).n(_Dat));
  }
  if (input[_Da] != null) {
    bn2.c(XmlNode.of(_Da, String(input[_Da])).n(_Da));
  }
  if (input[_SC] != null) {
    bn2.c(XmlNode.of(_TSC, input[_SC]).n(_SC));
  }
  return bn2;
};
var se_TransitionList = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_Transition(entry, context);
    return n2.n(_me);
  });
};
var se_UserMetadata = (input, context) => {
  return input.filter((e2) => e2 != null).map((entry) => {
    const n2 = se_MetadataEntry(entry, context);
    return n2.n(_ME);
  });
};
var se_VersioningConfiguration = (input, context) => {
  const bn2 = new XmlNode(_VCe);
  if (input[_MFAD] != null) {
    bn2.c(XmlNode.of(_MFAD, input[_MFAD]).n(_MDf));
  }
  if (input[_S] != null) {
    bn2.c(XmlNode.of(_BVS, input[_S]).n(_S));
  }
  return bn2;
};
var se_WebsiteConfiguration = (input, context) => {
  const bn2 = new XmlNode(_WC);
  if (input[_ED] != null) {
    bn2.c(se_ErrorDocument(input[_ED], context).n(_ED));
  }
  if (input[_ID] != null) {
    bn2.c(se_IndexDocument(input[_ID], context).n(_ID));
  }
  if (input[_RART] != null) {
    bn2.c(se_RedirectAllRequestsTo(input[_RART], context).n(_RART));
  }
  bn2.lc(input, "RoutingRules", "RoutingRules", () => se_RoutingRules(input[_RRo], context));
  return bn2;
};
var de_AbortIncompleteMultipartUpload = (output, context) => {
  const contents = {};
  if (output[_DAI] != null) {
    contents[_DAI] = strictParseInt32(output[_DAI]);
  }
  return contents;
};
var de_AccessControlTranslation = (output, context) => {
  const contents = {};
  if (output[_O] != null) {
    contents[_O] = expectString(output[_O]);
  }
  return contents;
};
var de_AllowedHeaders = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return expectString(entry);
  });
};
var de_AllowedMethods = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return expectString(entry);
  });
};
var de_AllowedOrigins = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return expectString(entry);
  });
};
var de_AnalyticsAndOperator = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output.Tag === "") {
    contents[_Tag] = [];
  } else if (output[_Ta] != null) {
    contents[_Tag] = de_TagSet(getArrayIfSingleItem(output[_Ta]), context);
  }
  return contents;
};
var de_AnalyticsConfiguration = (output, context) => {
  const contents = {};
  if (output[_I] != null) {
    contents[_I] = expectString(output[_I]);
  }
  if (output.Filter === "") {
  } else if (output[_F] != null) {
    contents[_F] = de_AnalyticsFilter(expectUnion(output[_F]), context);
  }
  if (output[_SCA] != null) {
    contents[_SCA] = de_StorageClassAnalysis(output[_SCA], context);
  }
  return contents;
};
var de_AnalyticsConfigurationList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_AnalyticsConfiguration(entry, context);
  });
};
var de_AnalyticsExportDestination = (output, context) => {
  const contents = {};
  if (output[_SBD] != null) {
    contents[_SBD] = de_AnalyticsS3BucketDestination(output[_SBD], context);
  }
  return contents;
};
var de_AnalyticsFilter = (output, context) => {
  if (output[_P] != null) {
    return {
      Prefix: expectString(output[_P])
    };
  }
  if (output[_Ta] != null) {
    return {
      Tag: de_Tag(output[_Ta], context)
    };
  }
  if (output[_A] != null) {
    return {
      And: de_AnalyticsAndOperator(output[_A], context)
    };
  }
  return { $unknown: Object.entries(output)[0] };
};
var de_AnalyticsS3BucketDestination = (output, context) => {
  const contents = {};
  if (output[_Fo] != null) {
    contents[_Fo] = expectString(output[_Fo]);
  }
  if (output[_BAI] != null) {
    contents[_BAI] = expectString(output[_BAI]);
  }
  if (output[_B] != null) {
    contents[_B] = expectString(output[_B]);
  }
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  return contents;
};
var de_Bucket = (output, context) => {
  const contents = {};
  if (output[_N] != null) {
    contents[_N] = expectString(output[_N]);
  }
  if (output[_CDr] != null) {
    contents[_CDr] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_CDr]));
  }
  if (output[_BR] != null) {
    contents[_BR] = expectString(output[_BR]);
  }
  return contents;
};
var de_Buckets = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_Bucket(entry, context);
  });
};
var de_Checksum = (output, context) => {
  const contents = {};
  if (output[_CCRC] != null) {
    contents[_CCRC] = expectString(output[_CCRC]);
  }
  if (output[_CCRCC] != null) {
    contents[_CCRCC] = expectString(output[_CCRCC]);
  }
  if (output[_CSHA] != null) {
    contents[_CSHA] = expectString(output[_CSHA]);
  }
  if (output[_CSHAh] != null) {
    contents[_CSHAh] = expectString(output[_CSHAh]);
  }
  return contents;
};
var de_ChecksumAlgorithmList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return expectString(entry);
  });
};
var de_CommonPrefix = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  return contents;
};
var de_CommonPrefixList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_CommonPrefix(entry, context);
  });
};
var de_Condition = (output, context) => {
  const contents = {};
  if (output[_HECRE] != null) {
    contents[_HECRE] = expectString(output[_HECRE]);
  }
  if (output[_KPE] != null) {
    contents[_KPE] = expectString(output[_KPE]);
  }
  return contents;
};
var de_ContinuationEvent = (output, context) => {
  const contents = {};
  return contents;
};
var de_CopyObjectResult = (output, context) => {
  const contents = {};
  if (output[_ETa] != null) {
    contents[_ETa] = expectString(output[_ETa]);
  }
  if (output[_LM] != null) {
    contents[_LM] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_LM]));
  }
  if (output[_CCRC] != null) {
    contents[_CCRC] = expectString(output[_CCRC]);
  }
  if (output[_CCRCC] != null) {
    contents[_CCRCC] = expectString(output[_CCRCC]);
  }
  if (output[_CSHA] != null) {
    contents[_CSHA] = expectString(output[_CSHA]);
  }
  if (output[_CSHAh] != null) {
    contents[_CSHAh] = expectString(output[_CSHAh]);
  }
  return contents;
};
var de_CopyPartResult = (output, context) => {
  const contents = {};
  if (output[_ETa] != null) {
    contents[_ETa] = expectString(output[_ETa]);
  }
  if (output[_LM] != null) {
    contents[_LM] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_LM]));
  }
  if (output[_CCRC] != null) {
    contents[_CCRC] = expectString(output[_CCRC]);
  }
  if (output[_CCRCC] != null) {
    contents[_CCRCC] = expectString(output[_CCRCC]);
  }
  if (output[_CSHA] != null) {
    contents[_CSHA] = expectString(output[_CSHA]);
  }
  if (output[_CSHAh] != null) {
    contents[_CSHAh] = expectString(output[_CSHAh]);
  }
  return contents;
};
var de_CORSRule = (output, context) => {
  const contents = {};
  if (output[_ID_] != null) {
    contents[_ID_] = expectString(output[_ID_]);
  }
  if (output.AllowedHeader === "") {
    contents[_AHl] = [];
  } else if (output[_AH] != null) {
    contents[_AHl] = de_AllowedHeaders(getArrayIfSingleItem(output[_AH]), context);
  }
  if (output.AllowedMethod === "") {
    contents[_AMl] = [];
  } else if (output[_AM] != null) {
    contents[_AMl] = de_AllowedMethods(getArrayIfSingleItem(output[_AM]), context);
  }
  if (output.AllowedOrigin === "") {
    contents[_AOl] = [];
  } else if (output[_AO] != null) {
    contents[_AOl] = de_AllowedOrigins(getArrayIfSingleItem(output[_AO]), context);
  }
  if (output.ExposeHeader === "") {
    contents[_EH] = [];
  } else if (output[_EHx] != null) {
    contents[_EH] = de_ExposeHeaders(getArrayIfSingleItem(output[_EHx]), context);
  }
  if (output[_MAS] != null) {
    contents[_MAS] = strictParseInt32(output[_MAS]);
  }
  return contents;
};
var de_CORSRules = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_CORSRule(entry, context);
  });
};
var de_DefaultRetention = (output, context) => {
  const contents = {};
  if (output[_Mo] != null) {
    contents[_Mo] = expectString(output[_Mo]);
  }
  if (output[_Da] != null) {
    contents[_Da] = strictParseInt32(output[_Da]);
  }
  if (output[_Y] != null) {
    contents[_Y] = strictParseInt32(output[_Y]);
  }
  return contents;
};
var de_DeletedObject = (output, context) => {
  const contents = {};
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  if (output[_VI] != null) {
    contents[_VI] = expectString(output[_VI]);
  }
  if (output[_DM] != null) {
    contents[_DM] = parseBoolean(output[_DM]);
  }
  if (output[_DMVI] != null) {
    contents[_DMVI] = expectString(output[_DMVI]);
  }
  return contents;
};
var de_DeletedObjects = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_DeletedObject(entry, context);
  });
};
var de_DeleteMarkerEntry = (output, context) => {
  const contents = {};
  if (output[_O] != null) {
    contents[_O] = de_Owner(output[_O], context);
  }
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  if (output[_VI] != null) {
    contents[_VI] = expectString(output[_VI]);
  }
  if (output[_IL] != null) {
    contents[_IL] = parseBoolean(output[_IL]);
  }
  if (output[_LM] != null) {
    contents[_LM] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_LM]));
  }
  return contents;
};
var de_DeleteMarkerReplication = (output, context) => {
  const contents = {};
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  return contents;
};
var de_DeleteMarkers = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_DeleteMarkerEntry(entry, context);
  });
};
var de_Destination = (output, context) => {
  const contents = {};
  if (output[_B] != null) {
    contents[_B] = expectString(output[_B]);
  }
  if (output[_Ac] != null) {
    contents[_Ac] = expectString(output[_Ac]);
  }
  if (output[_SC] != null) {
    contents[_SC] = expectString(output[_SC]);
  }
  if (output[_ACT] != null) {
    contents[_ACT] = de_AccessControlTranslation(output[_ACT], context);
  }
  if (output[_ECn] != null) {
    contents[_ECn] = de_EncryptionConfiguration(output[_ECn], context);
  }
  if (output[_RTe] != null) {
    contents[_RTe] = de_ReplicationTime(output[_RTe], context);
  }
  if (output[_Me] != null) {
    contents[_Me] = de_Metrics(output[_Me], context);
  }
  return contents;
};
var de_EncryptionConfiguration = (output, context) => {
  const contents = {};
  if (output[_RKKID] != null) {
    contents[_RKKID] = expectString(output[_RKKID]);
  }
  return contents;
};
var de_EndEvent = (output, context) => {
  const contents = {};
  return contents;
};
var de__Error = (output, context) => {
  const contents = {};
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  if (output[_VI] != null) {
    contents[_VI] = expectString(output[_VI]);
  }
  if (output[_Cod] != null) {
    contents[_Cod] = expectString(output[_Cod]);
  }
  if (output[_Mes] != null) {
    contents[_Mes] = expectString(output[_Mes]);
  }
  return contents;
};
var de_ErrorDocument = (output, context) => {
  const contents = {};
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  return contents;
};
var de_Errors = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de__Error(entry, context);
  });
};
var de_EventBridgeConfiguration = (output, context) => {
  const contents = {};
  return contents;
};
var de_EventList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return expectString(entry);
  });
};
var de_ExistingObjectReplication = (output, context) => {
  const contents = {};
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  return contents;
};
var de_ExposeHeaders = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return expectString(entry);
  });
};
var de_FilterRule = (output, context) => {
  const contents = {};
  if (output[_N] != null) {
    contents[_N] = expectString(output[_N]);
  }
  if (output[_Va] != null) {
    contents[_Va] = expectString(output[_Va]);
  }
  return contents;
};
var de_FilterRuleList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_FilterRule(entry, context);
  });
};
var de_GetObjectAttributesParts = (output, context) => {
  const contents = {};
  if (output[_PC] != null) {
    contents[_TPC] = strictParseInt32(output[_PC]);
  }
  if (output[_PNM] != null) {
    contents[_PNM] = expectString(output[_PNM]);
  }
  if (output[_NPNM] != null) {
    contents[_NPNM] = expectString(output[_NPNM]);
  }
  if (output[_MP] != null) {
    contents[_MP] = strictParseInt32(output[_MP]);
  }
  if (output[_IT] != null) {
    contents[_IT] = parseBoolean(output[_IT]);
  }
  if (output.Part === "") {
    contents[_Part] = [];
  } else if (output[_Par] != null) {
    contents[_Part] = de_PartsList(getArrayIfSingleItem(output[_Par]), context);
  }
  return contents;
};
var de_Grant = (output, context) => {
  const contents = {};
  if (output[_Gra] != null) {
    contents[_Gra] = de_Grantee(output[_Gra], context);
  }
  if (output[_Pe] != null) {
    contents[_Pe] = expectString(output[_Pe]);
  }
  return contents;
};
var de_Grantee = (output, context) => {
  const contents = {};
  if (output[_DN] != null) {
    contents[_DN] = expectString(output[_DN]);
  }
  if (output[_EA] != null) {
    contents[_EA] = expectString(output[_EA]);
  }
  if (output[_ID_] != null) {
    contents[_ID_] = expectString(output[_ID_]);
  }
  if (output[_URI] != null) {
    contents[_URI] = expectString(output[_URI]);
  }
  if (output[_x] != null) {
    contents[_Ty] = expectString(output[_x]);
  }
  return contents;
};
var de_Grants = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_Grant(entry, context);
  });
};
var de_IndexDocument = (output, context) => {
  const contents = {};
  if (output[_Su] != null) {
    contents[_Su] = expectString(output[_Su]);
  }
  return contents;
};
var de_Initiator = (output, context) => {
  const contents = {};
  if (output[_ID_] != null) {
    contents[_ID_] = expectString(output[_ID_]);
  }
  if (output[_DN] != null) {
    contents[_DN] = expectString(output[_DN]);
  }
  return contents;
};
var de_IntelligentTieringAndOperator = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output.Tag === "") {
    contents[_Tag] = [];
  } else if (output[_Ta] != null) {
    contents[_Tag] = de_TagSet(getArrayIfSingleItem(output[_Ta]), context);
  }
  return contents;
};
var de_IntelligentTieringConfiguration = (output, context) => {
  const contents = {};
  if (output[_I] != null) {
    contents[_I] = expectString(output[_I]);
  }
  if (output[_F] != null) {
    contents[_F] = de_IntelligentTieringFilter(output[_F], context);
  }
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  if (output.Tiering === "") {
    contents[_Tie] = [];
  } else if (output[_Tier] != null) {
    contents[_Tie] = de_TieringList(getArrayIfSingleItem(output[_Tier]), context);
  }
  return contents;
};
var de_IntelligentTieringConfigurationList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_IntelligentTieringConfiguration(entry, context);
  });
};
var de_IntelligentTieringFilter = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output[_Ta] != null) {
    contents[_Ta] = de_Tag(output[_Ta], context);
  }
  if (output[_A] != null) {
    contents[_A] = de_IntelligentTieringAndOperator(output[_A], context);
  }
  return contents;
};
var de_InventoryConfiguration = (output, context) => {
  const contents = {};
  if (output[_Des] != null) {
    contents[_Des] = de_InventoryDestination(output[_Des], context);
  }
  if (output[_IE] != null) {
    contents[_IE] = parseBoolean(output[_IE]);
  }
  if (output[_F] != null) {
    contents[_F] = de_InventoryFilter(output[_F], context);
  }
  if (output[_I] != null) {
    contents[_I] = expectString(output[_I]);
  }
  if (output[_IOV] != null) {
    contents[_IOV] = expectString(output[_IOV]);
  }
  if (output.OptionalFields === "") {
    contents[_OF] = [];
  } else if (output[_OF] != null && output[_OF][_Fi] != null) {
    contents[_OF] = de_InventoryOptionalFields(getArrayIfSingleItem(output[_OF][_Fi]), context);
  }
  if (output[_Sc] != null) {
    contents[_Sc] = de_InventorySchedule(output[_Sc], context);
  }
  return contents;
};
var de_InventoryConfigurationList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_InventoryConfiguration(entry, context);
  });
};
var de_InventoryDestination = (output, context) => {
  const contents = {};
  if (output[_SBD] != null) {
    contents[_SBD] = de_InventoryS3BucketDestination(output[_SBD], context);
  }
  return contents;
};
var de_InventoryEncryption = (output, context) => {
  const contents = {};
  if (output[_SS] != null) {
    contents[_SSES] = de_SSES3(output[_SS], context);
  }
  if (output[_SK] != null) {
    contents[_SSEKMS] = de_SSEKMS(output[_SK], context);
  }
  return contents;
};
var de_InventoryFilter = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  return contents;
};
var de_InventoryOptionalFields = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return expectString(entry);
  });
};
var de_InventoryS3BucketDestination = (output, context) => {
  const contents = {};
  if (output[_AIc] != null) {
    contents[_AIc] = expectString(output[_AIc]);
  }
  if (output[_B] != null) {
    contents[_B] = expectString(output[_B]);
  }
  if (output[_Fo] != null) {
    contents[_Fo] = expectString(output[_Fo]);
  }
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output[_En] != null) {
    contents[_En] = de_InventoryEncryption(output[_En], context);
  }
  return contents;
};
var de_InventorySchedule = (output, context) => {
  const contents = {};
  if (output[_Fr] != null) {
    contents[_Fr] = expectString(output[_Fr]);
  }
  return contents;
};
var de_LambdaFunctionConfiguration = (output, context) => {
  const contents = {};
  if (output[_I] != null) {
    contents[_I] = expectString(output[_I]);
  }
  if (output[_CF] != null) {
    contents[_LFA] = expectString(output[_CF]);
  }
  if (output.Event === "") {
    contents[_Eve] = [];
  } else if (output[_Ev] != null) {
    contents[_Eve] = de_EventList(getArrayIfSingleItem(output[_Ev]), context);
  }
  if (output[_F] != null) {
    contents[_F] = de_NotificationConfigurationFilter(output[_F], context);
  }
  return contents;
};
var de_LambdaFunctionConfigurationList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_LambdaFunctionConfiguration(entry, context);
  });
};
var de_LifecycleExpiration = (output, context) => {
  const contents = {};
  if (output[_Dat] != null) {
    contents[_Dat] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_Dat]));
  }
  if (output[_Da] != null) {
    contents[_Da] = strictParseInt32(output[_Da]);
  }
  if (output[_EODM] != null) {
    contents[_EODM] = parseBoolean(output[_EODM]);
  }
  return contents;
};
var de_LifecycleRule = (output, context) => {
  const contents = {};
  if (output[_Exp] != null) {
    contents[_Exp] = de_LifecycleExpiration(output[_Exp], context);
  }
  if (output[_ID_] != null) {
    contents[_ID_] = expectString(output[_ID_]);
  }
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output[_F] != null) {
    contents[_F] = de_LifecycleRuleFilter(output[_F], context);
  }
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  if (output.Transition === "") {
    contents[_Tr] = [];
  } else if (output[_Tra] != null) {
    contents[_Tr] = de_TransitionList(getArrayIfSingleItem(output[_Tra]), context);
  }
  if (output.NoncurrentVersionTransition === "") {
    contents[_NVT] = [];
  } else if (output[_NVTo] != null) {
    contents[_NVT] = de_NoncurrentVersionTransitionList(getArrayIfSingleItem(output[_NVTo]), context);
  }
  if (output[_NVE] != null) {
    contents[_NVE] = de_NoncurrentVersionExpiration(output[_NVE], context);
  }
  if (output[_AIMU] != null) {
    contents[_AIMU] = de_AbortIncompleteMultipartUpload(output[_AIMU], context);
  }
  return contents;
};
var de_LifecycleRuleAndOperator = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output.Tag === "") {
    contents[_Tag] = [];
  } else if (output[_Ta] != null) {
    contents[_Tag] = de_TagSet(getArrayIfSingleItem(output[_Ta]), context);
  }
  if (output[_OSGT] != null) {
    contents[_OSGT] = strictParseLong(output[_OSGT]);
  }
  if (output[_OSLT] != null) {
    contents[_OSLT] = strictParseLong(output[_OSLT]);
  }
  return contents;
};
var de_LifecycleRuleFilter = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output[_Ta] != null) {
    contents[_Ta] = de_Tag(output[_Ta], context);
  }
  if (output[_OSGT] != null) {
    contents[_OSGT] = strictParseLong(output[_OSGT]);
  }
  if (output[_OSLT] != null) {
    contents[_OSLT] = strictParseLong(output[_OSLT]);
  }
  if (output[_A] != null) {
    contents[_A] = de_LifecycleRuleAndOperator(output[_A], context);
  }
  return contents;
};
var de_LifecycleRules = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_LifecycleRule(entry, context);
  });
};
var de_LoggingEnabled = (output, context) => {
  const contents = {};
  if (output[_TB] != null) {
    contents[_TB] = expectString(output[_TB]);
  }
  if (output.TargetGrants === "") {
    contents[_TG] = [];
  } else if (output[_TG] != null && output[_TG][_G] != null) {
    contents[_TG] = de_TargetGrants(getArrayIfSingleItem(output[_TG][_G]), context);
  }
  if (output[_TP] != null) {
    contents[_TP] = expectString(output[_TP]);
  }
  if (output[_TOKF] != null) {
    contents[_TOKF] = de_TargetObjectKeyFormat(output[_TOKF], context);
  }
  return contents;
};
var de_Metrics = (output, context) => {
  const contents = {};
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  if (output[_ETv] != null) {
    contents[_ETv] = de_ReplicationTimeValue(output[_ETv], context);
  }
  return contents;
};
var de_MetricsAndOperator = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output.Tag === "") {
    contents[_Tag] = [];
  } else if (output[_Ta] != null) {
    contents[_Tag] = de_TagSet(getArrayIfSingleItem(output[_Ta]), context);
  }
  if (output[_APAc] != null) {
    contents[_APAc] = expectString(output[_APAc]);
  }
  return contents;
};
var de_MetricsConfiguration = (output, context) => {
  const contents = {};
  if (output[_I] != null) {
    contents[_I] = expectString(output[_I]);
  }
  if (output.Filter === "") {
  } else if (output[_F] != null) {
    contents[_F] = de_MetricsFilter(expectUnion(output[_F]), context);
  }
  return contents;
};
var de_MetricsConfigurationList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_MetricsConfiguration(entry, context);
  });
};
var de_MetricsFilter = (output, context) => {
  if (output[_P] != null) {
    return {
      Prefix: expectString(output[_P])
    };
  }
  if (output[_Ta] != null) {
    return {
      Tag: de_Tag(output[_Ta], context)
    };
  }
  if (output[_APAc] != null) {
    return {
      AccessPointArn: expectString(output[_APAc])
    };
  }
  if (output[_A] != null) {
    return {
      And: de_MetricsAndOperator(output[_A], context)
    };
  }
  return { $unknown: Object.entries(output)[0] };
};
var de_MultipartUpload = (output, context) => {
  const contents = {};
  if (output[_UI] != null) {
    contents[_UI] = expectString(output[_UI]);
  }
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  if (output[_Ini] != null) {
    contents[_Ini] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_Ini]));
  }
  if (output[_SC] != null) {
    contents[_SC] = expectString(output[_SC]);
  }
  if (output[_O] != null) {
    contents[_O] = de_Owner(output[_O], context);
  }
  if (output[_In] != null) {
    contents[_In] = de_Initiator(output[_In], context);
  }
  if (output[_CA] != null) {
    contents[_CA] = expectString(output[_CA]);
  }
  return contents;
};
var de_MultipartUploadList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_MultipartUpload(entry, context);
  });
};
var de_NoncurrentVersionExpiration = (output, context) => {
  const contents = {};
  if (output[_ND] != null) {
    contents[_ND] = strictParseInt32(output[_ND]);
  }
  if (output[_NNV] != null) {
    contents[_NNV] = strictParseInt32(output[_NNV]);
  }
  return contents;
};
var de_NoncurrentVersionTransition = (output, context) => {
  const contents = {};
  if (output[_ND] != null) {
    contents[_ND] = strictParseInt32(output[_ND]);
  }
  if (output[_SC] != null) {
    contents[_SC] = expectString(output[_SC]);
  }
  if (output[_NNV] != null) {
    contents[_NNV] = strictParseInt32(output[_NNV]);
  }
  return contents;
};
var de_NoncurrentVersionTransitionList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_NoncurrentVersionTransition(entry, context);
  });
};
var de_NotificationConfigurationFilter = (output, context) => {
  const contents = {};
  if (output[_SKe] != null) {
    contents[_K] = de_S3KeyFilter(output[_SKe], context);
  }
  return contents;
};
var de__Object = (output, context) => {
  const contents = {};
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  if (output[_LM] != null) {
    contents[_LM] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_LM]));
  }
  if (output[_ETa] != null) {
    contents[_ETa] = expectString(output[_ETa]);
  }
  if (output.ChecksumAlgorithm === "") {
    contents[_CA] = [];
  } else if (output[_CA] != null) {
    contents[_CA] = de_ChecksumAlgorithmList(getArrayIfSingleItem(output[_CA]), context);
  }
  if (output[_Si] != null) {
    contents[_Si] = strictParseLong(output[_Si]);
  }
  if (output[_SC] != null) {
    contents[_SC] = expectString(output[_SC]);
  }
  if (output[_O] != null) {
    contents[_O] = de_Owner(output[_O], context);
  }
  if (output[_RSe] != null) {
    contents[_RSe] = de_RestoreStatus(output[_RSe], context);
  }
  return contents;
};
var de_ObjectList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de__Object(entry, context);
  });
};
var de_ObjectLockConfiguration = (output, context) => {
  const contents = {};
  if (output[_OLE] != null) {
    contents[_OLE] = expectString(output[_OLE]);
  }
  if (output[_Ru] != null) {
    contents[_Ru] = de_ObjectLockRule(output[_Ru], context);
  }
  return contents;
};
var de_ObjectLockLegalHold = (output, context) => {
  const contents = {};
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  return contents;
};
var de_ObjectLockRetention = (output, context) => {
  const contents = {};
  if (output[_Mo] != null) {
    contents[_Mo] = expectString(output[_Mo]);
  }
  if (output[_RUD] != null) {
    contents[_RUD] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_RUD]));
  }
  return contents;
};
var de_ObjectLockRule = (output, context) => {
  const contents = {};
  if (output[_DRe] != null) {
    contents[_DRe] = de_DefaultRetention(output[_DRe], context);
  }
  return contents;
};
var de_ObjectPart = (output, context) => {
  const contents = {};
  if (output[_PN] != null) {
    contents[_PN] = strictParseInt32(output[_PN]);
  }
  if (output[_Si] != null) {
    contents[_Si] = strictParseLong(output[_Si]);
  }
  if (output[_CCRC] != null) {
    contents[_CCRC] = expectString(output[_CCRC]);
  }
  if (output[_CCRCC] != null) {
    contents[_CCRCC] = expectString(output[_CCRCC]);
  }
  if (output[_CSHA] != null) {
    contents[_CSHA] = expectString(output[_CSHA]);
  }
  if (output[_CSHAh] != null) {
    contents[_CSHAh] = expectString(output[_CSHAh]);
  }
  return contents;
};
var de_ObjectVersion = (output, context) => {
  const contents = {};
  if (output[_ETa] != null) {
    contents[_ETa] = expectString(output[_ETa]);
  }
  if (output.ChecksumAlgorithm === "") {
    contents[_CA] = [];
  } else if (output[_CA] != null) {
    contents[_CA] = de_ChecksumAlgorithmList(getArrayIfSingleItem(output[_CA]), context);
  }
  if (output[_Si] != null) {
    contents[_Si] = strictParseLong(output[_Si]);
  }
  if (output[_SC] != null) {
    contents[_SC] = expectString(output[_SC]);
  }
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  if (output[_VI] != null) {
    contents[_VI] = expectString(output[_VI]);
  }
  if (output[_IL] != null) {
    contents[_IL] = parseBoolean(output[_IL]);
  }
  if (output[_LM] != null) {
    contents[_LM] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_LM]));
  }
  if (output[_O] != null) {
    contents[_O] = de_Owner(output[_O], context);
  }
  if (output[_RSe] != null) {
    contents[_RSe] = de_RestoreStatus(output[_RSe], context);
  }
  return contents;
};
var de_ObjectVersionList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_ObjectVersion(entry, context);
  });
};
var de_Owner = (output, context) => {
  const contents = {};
  if (output[_DN] != null) {
    contents[_DN] = expectString(output[_DN]);
  }
  if (output[_ID_] != null) {
    contents[_ID_] = expectString(output[_ID_]);
  }
  return contents;
};
var de_OwnershipControls = (output, context) => {
  const contents = {};
  if (output.Rule === "") {
    contents[_Rul] = [];
  } else if (output[_Ru] != null) {
    contents[_Rul] = de_OwnershipControlsRules(getArrayIfSingleItem(output[_Ru]), context);
  }
  return contents;
};
var de_OwnershipControlsRule = (output, context) => {
  const contents = {};
  if (output[_OO] != null) {
    contents[_OO] = expectString(output[_OO]);
  }
  return contents;
};
var de_OwnershipControlsRules = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_OwnershipControlsRule(entry, context);
  });
};
var de_Part = (output, context) => {
  const contents = {};
  if (output[_PN] != null) {
    contents[_PN] = strictParseInt32(output[_PN]);
  }
  if (output[_LM] != null) {
    contents[_LM] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_LM]));
  }
  if (output[_ETa] != null) {
    contents[_ETa] = expectString(output[_ETa]);
  }
  if (output[_Si] != null) {
    contents[_Si] = strictParseLong(output[_Si]);
  }
  if (output[_CCRC] != null) {
    contents[_CCRC] = expectString(output[_CCRC]);
  }
  if (output[_CCRCC] != null) {
    contents[_CCRCC] = expectString(output[_CCRCC]);
  }
  if (output[_CSHA] != null) {
    contents[_CSHA] = expectString(output[_CSHA]);
  }
  if (output[_CSHAh] != null) {
    contents[_CSHAh] = expectString(output[_CSHAh]);
  }
  return contents;
};
var de_PartitionedPrefix = (output, context) => {
  const contents = {};
  if (output[_PDS] != null) {
    contents[_PDS] = expectString(output[_PDS]);
  }
  return contents;
};
var de_Parts = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_Part(entry, context);
  });
};
var de_PartsList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_ObjectPart(entry, context);
  });
};
var de_PolicyStatus = (output, context) => {
  const contents = {};
  if (output[_IP] != null) {
    contents[_IP] = parseBoolean(output[_IP]);
  }
  return contents;
};
var de_Progress = (output, context) => {
  const contents = {};
  if (output[_BS] != null) {
    contents[_BS] = strictParseLong(output[_BS]);
  }
  if (output[_BP] != null) {
    contents[_BP] = strictParseLong(output[_BP]);
  }
  if (output[_BRy] != null) {
    contents[_BRy] = strictParseLong(output[_BRy]);
  }
  return contents;
};
var de_PublicAccessBlockConfiguration = (output, context) => {
  const contents = {};
  if (output[_BPA] != null) {
    contents[_BPA] = parseBoolean(output[_BPA]);
  }
  if (output[_IPA] != null) {
    contents[_IPA] = parseBoolean(output[_IPA]);
  }
  if (output[_BPP] != null) {
    contents[_BPP] = parseBoolean(output[_BPP]);
  }
  if (output[_RPB] != null) {
    contents[_RPB] = parseBoolean(output[_RPB]);
  }
  return contents;
};
var de_QueueConfiguration = (output, context) => {
  const contents = {};
  if (output[_I] != null) {
    contents[_I] = expectString(output[_I]);
  }
  if (output[_Qu] != null) {
    contents[_QA] = expectString(output[_Qu]);
  }
  if (output.Event === "") {
    contents[_Eve] = [];
  } else if (output[_Ev] != null) {
    contents[_Eve] = de_EventList(getArrayIfSingleItem(output[_Ev]), context);
  }
  if (output[_F] != null) {
    contents[_F] = de_NotificationConfigurationFilter(output[_F], context);
  }
  return contents;
};
var de_QueueConfigurationList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_QueueConfiguration(entry, context);
  });
};
var de_Redirect = (output, context) => {
  const contents = {};
  if (output[_HN] != null) {
    contents[_HN] = expectString(output[_HN]);
  }
  if (output[_HRC] != null) {
    contents[_HRC] = expectString(output[_HRC]);
  }
  if (output[_Pr] != null) {
    contents[_Pr] = expectString(output[_Pr]);
  }
  if (output[_RKPW] != null) {
    contents[_RKPW] = expectString(output[_RKPW]);
  }
  if (output[_RKW] != null) {
    contents[_RKW] = expectString(output[_RKW]);
  }
  return contents;
};
var de_RedirectAllRequestsTo = (output, context) => {
  const contents = {};
  if (output[_HN] != null) {
    contents[_HN] = expectString(output[_HN]);
  }
  if (output[_Pr] != null) {
    contents[_Pr] = expectString(output[_Pr]);
  }
  return contents;
};
var de_ReplicaModifications = (output, context) => {
  const contents = {};
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  return contents;
};
var de_ReplicationConfiguration = (output, context) => {
  const contents = {};
  if (output[_Ro] != null) {
    contents[_Ro] = expectString(output[_Ro]);
  }
  if (output.Rule === "") {
    contents[_Rul] = [];
  } else if (output[_Ru] != null) {
    contents[_Rul] = de_ReplicationRules(getArrayIfSingleItem(output[_Ru]), context);
  }
  return contents;
};
var de_ReplicationRule = (output, context) => {
  const contents = {};
  if (output[_ID_] != null) {
    contents[_ID_] = expectString(output[_ID_]);
  }
  if (output[_Pri] != null) {
    contents[_Pri] = strictParseInt32(output[_Pri]);
  }
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output[_F] != null) {
    contents[_F] = de_ReplicationRuleFilter(output[_F], context);
  }
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  if (output[_SSC] != null) {
    contents[_SSC] = de_SourceSelectionCriteria(output[_SSC], context);
  }
  if (output[_EOR] != null) {
    contents[_EOR] = de_ExistingObjectReplication(output[_EOR], context);
  }
  if (output[_Des] != null) {
    contents[_Des] = de_Destination(output[_Des], context);
  }
  if (output[_DMR] != null) {
    contents[_DMR] = de_DeleteMarkerReplication(output[_DMR], context);
  }
  return contents;
};
var de_ReplicationRuleAndOperator = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output.Tag === "") {
    contents[_Tag] = [];
  } else if (output[_Ta] != null) {
    contents[_Tag] = de_TagSet(getArrayIfSingleItem(output[_Ta]), context);
  }
  return contents;
};
var de_ReplicationRuleFilter = (output, context) => {
  const contents = {};
  if (output[_P] != null) {
    contents[_P] = expectString(output[_P]);
  }
  if (output[_Ta] != null) {
    contents[_Ta] = de_Tag(output[_Ta], context);
  }
  if (output[_A] != null) {
    contents[_A] = de_ReplicationRuleAndOperator(output[_A], context);
  }
  return contents;
};
var de_ReplicationRules = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_ReplicationRule(entry, context);
  });
};
var de_ReplicationTime = (output, context) => {
  const contents = {};
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  if (output[_Tim] != null) {
    contents[_Tim] = de_ReplicationTimeValue(output[_Tim], context);
  }
  return contents;
};
var de_ReplicationTimeValue = (output, context) => {
  const contents = {};
  if (output[_Mi] != null) {
    contents[_Mi] = strictParseInt32(output[_Mi]);
  }
  return contents;
};
var de_RestoreStatus = (output, context) => {
  const contents = {};
  if (output[_IRIP] != null) {
    contents[_IRIP] = parseBoolean(output[_IRIP]);
  }
  if (output[_RED] != null) {
    contents[_RED] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_RED]));
  }
  return contents;
};
var de_RoutingRule = (output, context) => {
  const contents = {};
  if (output[_Con] != null) {
    contents[_Con] = de_Condition(output[_Con], context);
  }
  if (output[_Red] != null) {
    contents[_Red] = de_Redirect(output[_Red], context);
  }
  return contents;
};
var de_RoutingRules = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_RoutingRule(entry, context);
  });
};
var de_S3KeyFilter = (output, context) => {
  const contents = {};
  if (output.FilterRule === "") {
    contents[_FRi] = [];
  } else if (output[_FR] != null) {
    contents[_FRi] = de_FilterRuleList(getArrayIfSingleItem(output[_FR]), context);
  }
  return contents;
};
var de_ServerSideEncryptionByDefault = (output, context) => {
  const contents = {};
  if (output[_SSEA] != null) {
    contents[_SSEA] = expectString(output[_SSEA]);
  }
  if (output[_KMSMKID] != null) {
    contents[_KMSMKID] = expectString(output[_KMSMKID]);
  }
  return contents;
};
var de_ServerSideEncryptionConfiguration = (output, context) => {
  const contents = {};
  if (output.Rule === "") {
    contents[_Rul] = [];
  } else if (output[_Ru] != null) {
    contents[_Rul] = de_ServerSideEncryptionRules(getArrayIfSingleItem(output[_Ru]), context);
  }
  return contents;
};
var de_ServerSideEncryptionRule = (output, context) => {
  const contents = {};
  if (output[_ASSEBD] != null) {
    contents[_ASSEBD] = de_ServerSideEncryptionByDefault(output[_ASSEBD], context);
  }
  if (output[_BKE] != null) {
    contents[_BKE] = parseBoolean(output[_BKE]);
  }
  return contents;
};
var de_ServerSideEncryptionRules = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_ServerSideEncryptionRule(entry, context);
  });
};
var de_SessionCredentials = (output, context) => {
  const contents = {};
  if (output[_AKI] != null) {
    contents[_AKI] = expectString(output[_AKI]);
  }
  if (output[_SAK] != null) {
    contents[_SAK] = expectString(output[_SAK]);
  }
  if (output[_ST] != null) {
    contents[_ST] = expectString(output[_ST]);
  }
  if (output[_Exp] != null) {
    contents[_Exp] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_Exp]));
  }
  return contents;
};
var de_SimplePrefix = (output, context) => {
  const contents = {};
  return contents;
};
var de_SourceSelectionCriteria = (output, context) => {
  const contents = {};
  if (output[_SKEO] != null) {
    contents[_SKEO] = de_SseKmsEncryptedObjects(output[_SKEO], context);
  }
  if (output[_RM] != null) {
    contents[_RM] = de_ReplicaModifications(output[_RM], context);
  }
  return contents;
};
var de_SSEKMS = (output, context) => {
  const contents = {};
  if (output[_KI] != null) {
    contents[_KI] = expectString(output[_KI]);
  }
  return contents;
};
var de_SseKmsEncryptedObjects = (output, context) => {
  const contents = {};
  if (output[_S] != null) {
    contents[_S] = expectString(output[_S]);
  }
  return contents;
};
var de_SSES3 = (output, context) => {
  const contents = {};
  return contents;
};
var de_Stats = (output, context) => {
  const contents = {};
  if (output[_BS] != null) {
    contents[_BS] = strictParseLong(output[_BS]);
  }
  if (output[_BP] != null) {
    contents[_BP] = strictParseLong(output[_BP]);
  }
  if (output[_BRy] != null) {
    contents[_BRy] = strictParseLong(output[_BRy]);
  }
  return contents;
};
var de_StorageClassAnalysis = (output, context) => {
  const contents = {};
  if (output[_DE] != null) {
    contents[_DE] = de_StorageClassAnalysisDataExport(output[_DE], context);
  }
  return contents;
};
var de_StorageClassAnalysisDataExport = (output, context) => {
  const contents = {};
  if (output[_OSV] != null) {
    contents[_OSV] = expectString(output[_OSV]);
  }
  if (output[_Des] != null) {
    contents[_Des] = de_AnalyticsExportDestination(output[_Des], context);
  }
  return contents;
};
var de_Tag = (output, context) => {
  const contents = {};
  if (output[_K] != null) {
    contents[_K] = expectString(output[_K]);
  }
  if (output[_Va] != null) {
    contents[_Va] = expectString(output[_Va]);
  }
  return contents;
};
var de_TagSet = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_Tag(entry, context);
  });
};
var de_TargetGrant = (output, context) => {
  const contents = {};
  if (output[_Gra] != null) {
    contents[_Gra] = de_Grantee(output[_Gra], context);
  }
  if (output[_Pe] != null) {
    contents[_Pe] = expectString(output[_Pe]);
  }
  return contents;
};
var de_TargetGrants = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_TargetGrant(entry, context);
  });
};
var de_TargetObjectKeyFormat = (output, context) => {
  const contents = {};
  if (output[_SPi] != null) {
    contents[_SPi] = de_SimplePrefix(output[_SPi], context);
  }
  if (output[_PP] != null) {
    contents[_PP] = de_PartitionedPrefix(output[_PP], context);
  }
  return contents;
};
var de_Tiering = (output, context) => {
  const contents = {};
  if (output[_Da] != null) {
    contents[_Da] = strictParseInt32(output[_Da]);
  }
  if (output[_AT] != null) {
    contents[_AT] = expectString(output[_AT]);
  }
  return contents;
};
var de_TieringList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_Tiering(entry, context);
  });
};
var de_TopicConfiguration = (output, context) => {
  const contents = {};
  if (output[_I] != null) {
    contents[_I] = expectString(output[_I]);
  }
  if (output[_Top] != null) {
    contents[_TA] = expectString(output[_Top]);
  }
  if (output.Event === "") {
    contents[_Eve] = [];
  } else if (output[_Ev] != null) {
    contents[_Eve] = de_EventList(getArrayIfSingleItem(output[_Ev]), context);
  }
  if (output[_F] != null) {
    contents[_F] = de_NotificationConfigurationFilter(output[_F], context);
  }
  return contents;
};
var de_TopicConfigurationList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_TopicConfiguration(entry, context);
  });
};
var de_Transition = (output, context) => {
  const contents = {};
  if (output[_Dat] != null) {
    contents[_Dat] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_Dat]));
  }
  if (output[_Da] != null) {
    contents[_Da] = strictParseInt32(output[_Da]);
  }
  if (output[_SC] != null) {
    contents[_SC] = expectString(output[_SC]);
  }
  return contents;
};
var de_TransitionList = (output, context) => {
  return (output || []).filter((e2) => e2 != null).map((entry) => {
    return de_Transition(entry, context);
  });
};
var deserializeMetadata2 = (output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
});
var collectBodyString = (streamBody, context) => import_protocols.collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
var _A = "And";
var _AAO = "AnalyticsAndOperator";
var _AC = "AnalyticsConfiguration";
var _ACL = "ACL";
var _ACLc = "AccessControlList";
var _ACLn = "AnalyticsConfigurationList";
var _ACP = "AccessControlPolicy";
var _ACT = "AccessControlTranslation";
var _ACc = "AccelerateConfiguration";
var _AD = "AbortDate";
var _AED = "AnalyticsExportDestination";
var _AF = "AnalyticsFilter";
var _AH = "AllowedHeader";
var _AHl = "AllowedHeaders";
var _AI = "AnalyticsId";
var _AIMU = "AbortIncompleteMultipartUpload";
var _AIc = "AccountId";
var _AKI = "AccessKeyId";
var _AM = "AllowedMethod";
var _AMl = "AllowedMethods";
var _AO = "AllowedOrigin";
var _AOl = "AllowedOrigins";
var _APA = "AccessPointAlias";
var _APAc = "AccessPointArn";
var _AQRD = "AllowQuotedRecordDelimiter";
var _AR = "AcceptRanges";
var _ARI = "AbortRuleId";
var _AS = "ArchiveStatus";
var _ASBD = "AnalyticsS3BucketDestination";
var _ASEFF = "AnalyticsS3ExportFileFormat";
var _ASSEBD = "ApplyServerSideEncryptionByDefault";
var _AT = "AccessTier";
var _Ac = "Account";
var _B = "Bucket";
var _BAI = "BucketAccountId";
var _BAS = "BucketAccelerateStatus";
var _BGR = "BypassGovernanceRetention";
var _BI = "BucketInfo";
var _BKE = "BucketKeyEnabled";
var _BLC = "BucketLifecycleConfiguration";
var _BLCu = "BucketLocationConstraint";
var _BLN = "BucketLocationName";
var _BLP = "BucketLogsPermission";
var _BLS = "BucketLoggingStatus";
var _BLT = "BucketLocationType";
var _BN = "BucketName";
var _BP = "BytesProcessed";
var _BPA = "BlockPublicAcls";
var _BPP = "BlockPublicPolicy";
var _BR = "BucketRegion";
var _BRy = "BytesReturned";
var _BS = "BytesScanned";
var _BT = "BucketType";
var _BVS = "BucketVersioningStatus";
var _Bu = "Buckets";
var _C = "Credentials";
var _CA = "ChecksumAlgorithm";
var _CACL = "CannedACL";
var _CBC = "CreateBucketConfiguration";
var _CC = "CacheControl";
var _CCRC = "ChecksumCRC32";
var _CCRCC = "ChecksumCRC32C";
var _CD = "ContentDisposition";
var _CDr = "CreationDate";
var _CE = "ContentEncoding";
var _CF = "CloudFunction";
var _CFC = "CloudFunctionConfiguration";
var _CL = "ContentLanguage";
var _CLo = "ContentLength";
var _CM = "ChecksumMode";
var _CMD = "ContentMD5";
var _CMU = "CompletedMultipartUpload";
var _CORSC = "CORSConfiguration";
var _CORSR = "CORSRule";
var _CORSRu = "CORSRules";
var _CP = "CommonPrefixes";
var _CPo = "CompletedPart";
var _CR = "ContentRange";
var _CRSBA = "ConfirmRemoveSelfBucketAccess";
var _CS = "CopySource";
var _CSHA = "ChecksumSHA1";
var _CSHAh = "ChecksumSHA256";
var _CSIM = "CopySourceIfMatch";
var _CSIMS = "CopySourceIfModifiedSince";
var _CSINM = "CopySourceIfNoneMatch";
var _CSIUS = "CopySourceIfUnmodifiedSince";
var _CSR = "CopySourceRange";
var _CSSSECA = "CopySourceSSECustomerAlgorithm";
var _CSSSECK = "CopySourceSSECustomerKey";
var _CSSSECKMD = "CopySourceSSECustomerKeyMD5";
var _CSV = "CSV";
var _CSVI = "CopySourceVersionId";
var _CSVIn = "CSVInput";
var _CSVO = "CSVOutput";
var _CT = "ContentType";
var _CTo = "ContinuationToken";
var _CTom = "CompressionType";
var _Ch = "Checksum";
var _Co = "Contents";
var _Cod = "Code";
var _Com = "Comments";
var _Con = "Condition";
var _D = "Delimiter";
var _DAI = "DaysAfterInitiation";
var _DE = "DataExport";
var _DM = "DeleteMarker";
var _DMR = "DeleteMarkerReplication";
var _DMRS = "DeleteMarkerReplicationStatus";
var _DMVI = "DeleteMarkerVersionId";
var _DMe = "DeleteMarkers";
var _DN = "DisplayName";
var _DR = "DataRedundancy";
var _DRe = "DefaultRetention";
var _Da = "Days";
var _Dat = "Date";
var _De = "Deleted";
var _Del = "Delete";
var _Des = "Destination";
var _Desc = "Description";
var _E = "Expires";
var _EA = "EmailAddress";
var _EBC = "EventBridgeConfiguration";
var _EBO = "ExpectedBucketOwner";
var _EC = "ErrorCode";
var _ECn = "EncryptionConfiguration";
var _ED = "ErrorDocument";
var _EH = "ExposeHeaders";
var _EHx = "ExposeHeader";
var _EM = "ErrorMessage";
var _EODM = "ExpiredObjectDeleteMarker";
var _EOR = "ExistingObjectReplication";
var _EORS = "ExistingObjectReplicationStatus";
var _ERP = "EnableRequestProgress";
var _ES = "ExpiresString";
var _ESBO = "ExpectedSourceBucketOwner";
var _ESx = "ExpirationStatus";
var _ET = "EncodingType";
var _ETa = "ETag";
var _ETn = "EncryptionType";
var _ETv = "EventThreshold";
var _ETx = "ExpressionType";
var _En = "Encryption";
var _Ena = "Enabled";
var _End = "End";
var _Er = "Error";
var _Err = "Errors";
var _Ev = "Event";
var _Eve = "Events";
var _Ex = "Expression";
var _Exp = "Expiration";
var _F = "Filter";
var _FD = "FieldDelimiter";
var _FHI = "FileHeaderInfo";
var _FO = "FetchOwner";
var _FR = "FilterRule";
var _FRN = "FilterRuleName";
var _FRV = "FilterRuleValue";
var _FRi = "FilterRules";
var _Fi = "Field";
var _Fo = "Format";
var _Fr = "Frequency";
var _G = "Grant";
var _GFC = "GrantFullControl";
var _GJP = "GlacierJobParameters";
var _GR = "GrantRead";
var _GRACP = "GrantReadACP";
var _GW = "GrantWrite";
var _GWACP = "GrantWriteACP";
var _Gr = "Grants";
var _Gra = "Grantee";
var _HECRE = "HttpErrorCodeReturnedEquals";
var _HN = "HostName";
var _HRC = "HttpRedirectCode";
var _I = "Id";
var _IC = "InventoryConfiguration";
var _ICL = "InventoryConfigurationList";
var _ID = "IndexDocument";
var _ID_ = "ID";
var _IDn = "InventoryDestination";
var _IE = "IsEnabled";
var _IEn = "InventoryEncryption";
var _IF = "InventoryFilter";
var _IFn = "InventoryFormat";
var _IFnv = "InventoryFrequency";
var _II = "InventoryId";
var _IIOV = "InventoryIncludedObjectVersions";
var _IL = "IsLatest";
var _IM = "IfMatch";
var _IMS = "IfModifiedSince";
var _INM = "IfNoneMatch";
var _IOF = "InventoryOptionalField";
var _IOV = "IncludedObjectVersions";
var _IP = "IsPublic";
var _IPA = "IgnorePublicAcls";
var _IRIP = "IsRestoreInProgress";
var _IS = "InputSerialization";
var _ISBD = "InventoryS3BucketDestination";
var _ISn = "InventorySchedule";
var _IT = "IsTruncated";
var _ITAO = "IntelligentTieringAndOperator";
var _ITAT = "IntelligentTieringAccessTier";
var _ITC = "IntelligentTieringConfiguration";
var _ITCL = "IntelligentTieringConfigurationList";
var _ITD = "IntelligentTieringDays";
var _ITF = "IntelligentTieringFilter";
var _ITI = "IntelligentTieringId";
var _ITS = "IntelligentTieringStatus";
var _IUS = "IfUnmodifiedSince";
var _In = "Initiator";
var _Ini = "Initiated";
var _JSON = "JSON";
var _JSONI = "JSONInput";
var _JSONO = "JSONOutput";
var _JSONT = "JSONType";
var _K = "Key";
var _KC = "KeyCount";
var _KI = "KeyId";
var _KM = "KeyMarker";
var _KMSC = "KMSContext";
var _KMSKI = "KMSKeyId";
var _KMSMKID = "KMSMasterKeyID";
var _KPE = "KeyPrefixEquals";
var _L = "Location";
var _LC = "LocationConstraint";
var _LE = "LoggingEnabled";
var _LEi = "LifecycleExpiration";
var _LFA = "LambdaFunctionArn";
var _LFC = "LambdaFunctionConfigurations";
var _LFCa = "LambdaFunctionConfiguration";
var _LI = "LocationInfo";
var _LM = "LastModified";
var _LNAS = "LocationNameAsString";
var _LP = "LocationPrefix";
var _LR = "LifecycleRule";
var _LRAO = "LifecycleRuleAndOperator";
var _LRF = "LifecycleRuleFilter";
var _LT = "LocationType";
var _M = "Marker";
var _MAO = "MetricsAndOperator";
var _MAS = "MaxAgeSeconds";
var _MB = "MaxBuckets";
var _MC = "MetricsConfiguration";
var _MCL = "MetricsConfigurationList";
var _MD = "MetadataDirective";
var _MDB = "MaxDirectoryBuckets";
var _MDf = "MfaDelete";
var _ME = "MetadataEntry";
var _MF = "MetricsFilter";
var _MFA = "MFA";
var _MFAD = "MFADelete";
var _MI = "MetricsId";
var _MK = "MaxKeys";
var _MKe = "MetadataKey";
var _MM = "MissingMeta";
var _MP = "MaxParts";
var _MS = "MetricsStatus";
var _MU = "MaxUploads";
var _MV = "MetadataValue";
var _Me = "Metrics";
var _Mes = "Message";
var _Mi = "Minutes";
var _Mo = "Mode";
var _N = "Name";
var _NC = "NotificationConfiguration";
var _NCF = "NotificationConfigurationFilter";
var _NCT = "NextContinuationToken";
var _ND = "NoncurrentDays";
var _NI = "NotificationId";
var _NKM = "NextKeyMarker";
var _NM = "NextMarker";
var _NNV = "NewerNoncurrentVersions";
var _NPNM = "NextPartNumberMarker";
var _NUIM = "NextUploadIdMarker";
var _NVE = "NoncurrentVersionExpiration";
var _NVIM = "NextVersionIdMarker";
var _NVT = "NoncurrentVersionTransitions";
var _NVTo = "NoncurrentVersionTransition";
var _O = "Owner";
var _OA = "ObjectAttributes";
var _OC = "OwnershipControls";
var _OCACL = "ObjectCannedACL";
var _OCR = "OwnershipControlsRule";
var _OF = "OptionalFields";
var _OI = "ObjectIdentifier";
var _OK = "ObjectKey";
var _OL = "OutputLocation";
var _OLC = "ObjectLockConfiguration";
var _OLE = "ObjectLockEnabled";
var _OLEFB = "ObjectLockEnabledForBucket";
var _OLLH = "ObjectLockLegalHold";
var _OLLHS = "ObjectLockLegalHoldStatus";
var _OLM = "ObjectLockMode";
var _OLR = "ObjectLockRetention";
var _OLRM = "ObjectLockRetentionMode";
var _OLRUD = "ObjectLockRetainUntilDate";
var _OLRb = "ObjectLockRule";
var _OO = "ObjectOwnership";
var _OOA = "OptionalObjectAttributes";
var _OOw = "OwnerOverride";
var _OP = "ObjectParts";
var _OS = "OutputSerialization";
var _OSGT = "ObjectSizeGreaterThan";
var _OSGTB = "ObjectSizeGreaterThanBytes";
var _OSLT = "ObjectSizeLessThan";
var _OSLTB = "ObjectSizeLessThanBytes";
var _OSV = "OutputSchemaVersion";
var _OSb = "ObjectSize";
var _OVI = "ObjectVersionId";
var _Ob = "Objects";
var _P = "Prefix";
var _PABC = "PublicAccessBlockConfiguration";
var _PC = "PartsCount";
var _PDS = "PartitionDateSource";
var _PI = "ParquetInput";
var _PN = "PartNumber";
var _PNM = "PartNumberMarker";
var _PP = "PartitionedPrefix";
var _Pa = "Payer";
var _Par = "Part";
var _Parq = "Parquet";
var _Part = "Parts";
var _Pe = "Permission";
var _Pr = "Protocol";
var _Pri = "Priority";
var _Q = "Quiet";
var _QA = "QueueArn";
var _QC = "QueueConfiguration";
var _QCu = "QueueConfigurations";
var _QCuo = "QuoteCharacter";
var _QEC = "QuoteEscapeCharacter";
var _QF = "QuoteFields";
var _Qu = "Queue";
var _R = "Range";
var _RART = "RedirectAllRequestsTo";
var _RC = "RequestCharged";
var _RCC = "ResponseCacheControl";
var _RCD = "ResponseContentDisposition";
var _RCE = "ResponseContentEncoding";
var _RCL = "ResponseContentLanguage";
var _RCT = "ResponseContentType";
var _RCe = "ReplicationConfiguration";
var _RD = "RecordDelimiter";
var _RE = "ResponseExpires";
var _RED = "RestoreExpiryDate";
var _RKKID = "ReplicaKmsKeyID";
var _RKPW = "ReplaceKeyPrefixWith";
var _RKW = "ReplaceKeyWith";
var _RM = "ReplicaModifications";
var _RMS = "ReplicaModificationsStatus";
var _ROP = "RestoreOutputPath";
var _RP = "RequestPayer";
var _RPB = "RestrictPublicBuckets";
var _RPC = "RequestPaymentConfiguration";
var _RPe = "RequestProgress";
var _RR = "RequestRoute";
var _RRAO = "ReplicationRuleAndOperator";
var _RRF = "ReplicationRuleFilter";
var _RRS = "ReplicationRuleStatus";
var _RRT = "RestoreRequestType";
var _RRe = "ReplicationRule";
var _RRes = "RestoreRequest";
var _RRo = "RoutingRules";
var _RRou = "RoutingRule";
var _RS = "ReplicationStatus";
var _RSe = "RestoreStatus";
var _RT = "RequestToken";
var _RTS = "ReplicationTimeStatus";
var _RTV = "ReplicationTimeValue";
var _RTe = "ReplicationTime";
var _RUD = "RetainUntilDate";
var _Re = "Restore";
var _Red = "Redirect";
var _Ro = "Role";
var _Ru = "Rule";
var _Rul = "Rules";
var _S = "Status";
var _SA = "StartAfter";
var _SAK = "SecretAccessKey";
var _SBD = "S3BucketDestination";
var _SC = "StorageClass";
var _SCA = "StorageClassAnalysis";
var _SCADE = "StorageClassAnalysisDataExport";
var _SCASV = "StorageClassAnalysisSchemaVersion";
var _SCt = "StatusCode";
var _SDV = "SkipDestinationValidation";
var _SK = "SSE-KMS";
var _SKEO = "SseKmsEncryptedObjects";
var _SKEOS = "SseKmsEncryptedObjectsStatus";
var _SKF = "S3KeyFilter";
var _SKe = "S3Key";
var _SL = "S3Location";
var _SM = "SessionMode";
var _SOCR = "SelectObjectContentRequest";
var _SP = "SelectParameters";
var _SPi = "SimplePrefix";
var _SR = "ScanRange";
var _SS = "SSE-S3";
var _SSC = "SourceSelectionCriteria";
var _SSE = "ServerSideEncryption";
var _SSEA = "SSEAlgorithm";
var _SSEBD = "ServerSideEncryptionByDefault";
var _SSEC = "ServerSideEncryptionConfiguration";
var _SSECA = "SSECustomerAlgorithm";
var _SSECK = "SSECustomerKey";
var _SSECKMD = "SSECustomerKeyMD5";
var _SSEKMS = "SSEKMS";
var _SSEKMSEC = "SSEKMSEncryptionContext";
var _SSEKMSKI = "SSEKMSKeyId";
var _SSER = "ServerSideEncryptionRule";
var _SSES = "SSES3";
var _ST = "SessionToken";
var _S_ = "S3";
var _Sc = "Schedule";
var _Se = "Setting";
var _Si = "Size";
var _St = "Start";
var _Su = "Suffix";
var _T = "Tagging";
var _TA = "TopicArn";
var _TB = "TargetBucket";
var _TC = "TagCount";
var _TCo = "TopicConfiguration";
var _TCop = "TopicConfigurations";
var _TD = "TaggingDirective";
var _TDMOS = "TransitionDefaultMinimumObjectSize";
var _TG = "TargetGrants";
var _TGa = "TargetGrant";
var _TOKF = "TargetObjectKeyFormat";
var _TP = "TargetPrefix";
var _TPC = "TotalPartsCount";
var _TS = "TagSet";
var _TSC = "TransitionStorageClass";
var _Ta = "Tag";
var _Tag = "Tags";
var _Ti = "Tier";
var _Tie = "Tierings";
var _Tier = "Tiering";
var _Tim = "Time";
var _To = "Token";
var _Top = "Topic";
var _Tr = "Transitions";
var _Tra = "Transition";
var _Ty = "Type";
var _U = "Upload";
var _UI = "UploadId";
var _UIM = "UploadIdMarker";
var _UM = "UserMetadata";
var _URI = "URI";
var _Up = "Uploads";
var _V = "Version";
var _VC = "VersionCount";
var _VCe = "VersioningConfiguration";
var _VI = "VersionId";
var _VIM = "VersionIdMarker";
var _Va = "Value";
var _Ve = "Versions";
var _WC = "WebsiteConfiguration";
var _WRL = "WebsiteRedirectLocation";
var _Y = "Years";
var _a = "analytics";
var _ac = "accelerate";
var _acl = "acl";
var _ar = "accept-ranges";
var _at = "attributes";
var _br = "bucket-region";
var _c = "cors";
var _cc = "cache-control";
var _cd = "content-disposition";
var _ce = "content-encoding";
var _cl = "content-language";
var _cl_ = "content-length";
var _cm = "content-md5";
var _cr = "content-range";
var _ct = "content-type";
var _ct_ = "continuation-token";
var _d = "delete";
var _de = "delimiter";
var _e = "expires";
var _en = "encryption";
var _et = "encoding-type";
var _eta = "etag";
var _ex = "expiresstring";
var _fo = "fetch-owner";
var _i = "id";
var _im = "if-match";
var _ims = "if-modified-since";
var _in = "inventory";
var _inm = "if-none-match";
var _it = "intelligent-tiering";
var _ius = "if-unmodified-since";
var _km = "key-marker";
var _l = "lifecycle";
var _lh = "legal-hold";
var _lm = "last-modified";
var _lo = "location";
var _log = "logging";
var _lt = "list-type";
var _m = "metrics";
var _ma = "marker";
var _mb = "max-buckets";
var _mdb = "max-directory-buckets";
var _me = "member";
var _mk = "max-keys";
var _mp = "max-parts";
var _mu = "max-uploads";
var _n = "notification";
var _oC = "ownershipControls";
var _ol = "object-lock";
var _p = "policy";
var _pAB = "publicAccessBlock";
var _pN = "partNumber";
var _pS = "policyStatus";
var _pnm = "part-number-marker";
var _pr = "prefix";
var _r = "replication";
var _rP = "requestPayment";
var _ra = "range";
var _rcc = "response-cache-control";
var _rcd = "response-content-disposition";
var _rce = "response-content-encoding";
var _rcl = "response-content-language";
var _rct = "response-content-type";
var _re = "response-expires";
var _res = "restore";
var _ret = "retention";
var _s = "session";
var _sa = "start-after";
var _se = "select";
var _st = "select-type";
var _t = "tagging";
var _to = "torrent";
var _u = "uploads";
var _uI = "uploadId";
var _uim = "upload-id-marker";
var _v = "versioning";
var _vI = "versionId";
var _ve = '<?xml version="1.0" encoding="UTF-8"?>';
var _ver = "versions";
var _vim = "version-id-marker";
var _w = "website";
var _x = "xsi:type";
var _xaa = "x-amz-acl";
var _xaad = "x-amz-abort-date";
var _xaapa = "x-amz-access-point-alias";
var _xaari = "x-amz-abort-rule-id";
var _xaas = "x-amz-archive-status";
var _xabgr = "x-amz-bypass-governance-retention";
var _xabln = "x-amz-bucket-location-name";
var _xablt = "x-amz-bucket-location-type";
var _xabole = "x-amz-bucket-object-lock-enabled";
var _xabolt = "x-amz-bucket-object-lock-token";
var _xabr = "x-amz-bucket-region";
var _xaca = "x-amz-checksum-algorithm";
var _xacc = "x-amz-checksum-crc32";
var _xacc_ = "x-amz-checksum-crc32c";
var _xacm = "x-amz-checksum-mode";
var _xacrsba = "x-amz-confirm-remove-self-bucket-access";
var _xacs = "x-amz-checksum-sha1";
var _xacs_ = "x-amz-checksum-sha256";
var _xacs__ = "x-amz-copy-source";
var _xacsim = "x-amz-copy-source-if-match";
var _xacsims = "x-amz-copy-source-if-modified-since";
var _xacsinm = "x-amz-copy-source-if-none-match";
var _xacsius = "x-amz-copy-source-if-unmodified-since";
var _xacsm = "x-amz-create-session-mode";
var _xacsr = "x-amz-copy-source-range";
var _xacssseca = "x-amz-copy-source-server-side-encryption-customer-algorithm";
var _xacssseck = "x-amz-copy-source-server-side-encryption-customer-key";
var _xacssseckm = "x-amz-copy-source-server-side-encryption-customer-key-md5";
var _xacsvi = "x-amz-copy-source-version-id";
var _xadm = "x-amz-delete-marker";
var _xae = "x-amz-expiration";
var _xaebo = "x-amz-expected-bucket-owner";
var _xafec = "x-amz-fwd-error-code";
var _xafem = "x-amz-fwd-error-message";
var _xafhar = "x-amz-fwd-header-accept-ranges";
var _xafhcc = "x-amz-fwd-header-cache-control";
var _xafhcd = "x-amz-fwd-header-content-disposition";
var _xafhce = "x-amz-fwd-header-content-encoding";
var _xafhcl = "x-amz-fwd-header-content-language";
var _xafhcr = "x-amz-fwd-header-content-range";
var _xafhct = "x-amz-fwd-header-content-type";
var _xafhe = "x-amz-fwd-header-etag";
var _xafhe_ = "x-amz-fwd-header-expires";
var _xafhlm = "x-amz-fwd-header-last-modified";
var _xafhxacc = "x-amz-fwd-header-x-amz-checksum-crc32";
var _xafhxacc_ = "x-amz-fwd-header-x-amz-checksum-crc32c";
var _xafhxacs = "x-amz-fwd-header-x-amz-checksum-sha1";
var _xafhxacs_ = "x-amz-fwd-header-x-amz-checksum-sha256";
var _xafhxadm = "x-amz-fwd-header-x-amz-delete-marker";
var _xafhxae = "x-amz-fwd-header-x-amz-expiration";
var _xafhxamm = "x-amz-fwd-header-x-amz-missing-meta";
var _xafhxampc = "x-amz-fwd-header-x-amz-mp-parts-count";
var _xafhxaollh = "x-amz-fwd-header-x-amz-object-lock-legal-hold";
var _xafhxaolm = "x-amz-fwd-header-x-amz-object-lock-mode";
var _xafhxaolrud = "x-amz-fwd-header-x-amz-object-lock-retain-until-date";
var _xafhxar = "x-amz-fwd-header-x-amz-restore";
var _xafhxarc = "x-amz-fwd-header-x-amz-request-charged";
var _xafhxars = "x-amz-fwd-header-x-amz-replication-status";
var _xafhxasc = "x-amz-fwd-header-x-amz-storage-class";
var _xafhxasse = "x-amz-fwd-header-x-amz-server-side-encryption";
var _xafhxasseakki = "x-amz-fwd-header-x-amz-server-side-encryption-aws-kms-key-id";
var _xafhxassebke = "x-amz-fwd-header-x-amz-server-side-encryption-bucket-key-enabled";
var _xafhxasseca = "x-amz-fwd-header-x-amz-server-side-encryption-customer-algorithm";
var _xafhxasseckm = "x-amz-fwd-header-x-amz-server-side-encryption-customer-key-md5";
var _xafhxatc = "x-amz-fwd-header-x-amz-tagging-count";
var _xafhxavi = "x-amz-fwd-header-x-amz-version-id";
var _xafs = "x-amz-fwd-status";
var _xagfc = "x-amz-grant-full-control";
var _xagr = "x-amz-grant-read";
var _xagra = "x-amz-grant-read-acp";
var _xagw = "x-amz-grant-write";
var _xagwa = "x-amz-grant-write-acp";
var _xam = "x-amz-mfa";
var _xamd = "x-amz-metadata-directive";
var _xamm = "x-amz-missing-meta";
var _xamp = "x-amz-max-parts";
var _xampc = "x-amz-mp-parts-count";
var _xaoa = "x-amz-object-attributes";
var _xaollh = "x-amz-object-lock-legal-hold";
var _xaolm = "x-amz-object-lock-mode";
var _xaolrud = "x-amz-object-lock-retain-until-date";
var _xaoo = "x-amz-object-ownership";
var _xaooa = "x-amz-optional-object-attributes";
var _xapnm = "x-amz-part-number-marker";
var _xar = "x-amz-restore";
var _xarc = "x-amz-request-charged";
var _xarop = "x-amz-restore-output-path";
var _xarp = "x-amz-request-payer";
var _xarr = "x-amz-request-route";
var _xars = "x-amz-replication-status";
var _xart = "x-amz-request-token";
var _xasc = "x-amz-storage-class";
var _xasca = "x-amz-sdk-checksum-algorithm";
var _xasdv = "x-amz-skip-destination-validation";
var _xasebo = "x-amz-source-expected-bucket-owner";
var _xasse = "x-amz-server-side-encryption";
var _xasseakki = "x-amz-server-side-encryption-aws-kms-key-id";
var _xassebke = "x-amz-server-side-encryption-bucket-key-enabled";
var _xassec = "x-amz-server-side-encryption-context";
var _xasseca = "x-amz-server-side-encryption-customer-algorithm";
var _xasseck = "x-amz-server-side-encryption-customer-key";
var _xasseckm = "x-amz-server-side-encryption-customer-key-md5";
var _xat = "x-amz-tagging";
var _xatc = "x-amz-tagging-count";
var _xatd = "x-amz-tagging-directive";
var _xatdmos = "x-amz-transition-default-minimum-object-size";
var _xavi = "x-amz-version-id";
var _xawrl = "x-amz-website-redirect-location";
var _xi = "x-id";
var init_Aws_restXml = __esm2(() => {
  import_core11 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es37();
  import_core12 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es();
  init_dist_es12();
  init_models_0();
  init_models_1();
  init_S3ServiceException();
  throwDefaultError2 = withBaseException(S3ServiceException);
});
var CreateSessionCommand;
var init_CreateSessionCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  CreateSessionCommand = class CreateSessionCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    DisableS3ExpressSessionAuth: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config8, o2) {
    return [
      getSerdePlugin(config8, this.serialize, this.deserialize),
      getEndpointPlugin(config8, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config8)
    ];
  }).s("AmazonS3", "CreateSession", {}).n("S3Client", "CreateSessionCommand").f(CreateSessionRequestFilterSensitiveLog, CreateSessionOutputFilterSensitiveLog).ser(se_CreateSessionCommand).de(de_CreateSessionCommand).build() {
  };
});
var package_default;
var init_package3 = __esm2(() => {
  package_default = {
    name: "@aws-sdk/client-s3",
    description: "AWS SDK for JavaScript S3 Client for Node.js, Browser and React Native",
    version: "3.679.0",
    scripts: {
      build: "concurrently 'yarn:build:cjs' 'yarn:build:es' 'yarn:build:types'",
      "build:cjs": "node ../../scripts/compilation/inline client-s3",
      "build:es": "tsc -p tsconfig.es.json",
      "build:include:deps": "lerna run --scope $npm_package_name --include-dependencies build",
      "build:types": "tsc -p tsconfig.types.json",
      "build:types:downlevel": "downlevel-dts dist-types dist-types/ts3.4",
      clean: "rimraf ./dist-* && rimraf *.tsbuildinfo",
      "extract:docs": "api-extractor run --local",
      "generate:client": "node ../../scripts/generate-clients/single-service --solo s3",
      test: "vitest run",
      "test:watch": "vitest watch",
      "test:e2e": "vitest run -c vitest.config.e2e.ts && yarn test:browser",
      "test:e2e:watch": "vitest watch -c vitest.config.e2e.ts",
      "test:browser": "node ./test/browser-build/esbuild && vitest run -c vitest.config.browser.ts",
      "test:browser:watch": "node ./test/browser-build/esbuild && vitest watch -c vitest.config.browser.ts"
    },
    main: "./dist-cjs/index.js",
    types: "./dist-types/index.d.ts",
    module: "./dist-es/index.js",
    sideEffects: false,
    dependencies: {
      "@aws-crypto/sha1-browser": "5.2.0",
      "@aws-crypto/sha256-browser": "5.2.0",
      "@aws-crypto/sha256-js": "5.2.0",
      "@aws-sdk/client-sso-oidc": "3.679.0",
      "@aws-sdk/client-sts": "3.679.0",
      "@aws-sdk/core": "3.679.0",
      "@aws-sdk/credential-provider-node": "3.679.0",
      "@aws-sdk/middleware-bucket-endpoint": "3.679.0",
      "@aws-sdk/middleware-expect-continue": "3.679.0",
      "@aws-sdk/middleware-flexible-checksums": "3.679.0",
      "@aws-sdk/middleware-host-header": "3.679.0",
      "@aws-sdk/middleware-location-constraint": "3.679.0",
      "@aws-sdk/middleware-logger": "3.679.0",
      "@aws-sdk/middleware-recursion-detection": "3.679.0",
      "@aws-sdk/middleware-sdk-s3": "3.679.0",
      "@aws-sdk/middleware-ssec": "3.679.0",
      "@aws-sdk/middleware-user-agent": "3.679.0",
      "@aws-sdk/region-config-resolver": "3.679.0",
      "@aws-sdk/signature-v4-multi-region": "3.679.0",
      "@aws-sdk/types": "3.679.0",
      "@aws-sdk/util-endpoints": "3.679.0",
      "@aws-sdk/util-user-agent-browser": "3.679.0",
      "@aws-sdk/util-user-agent-node": "3.679.0",
      "@aws-sdk/xml-builder": "3.679.0",
      "@smithy/config-resolver": "^3.0.9",
      "@smithy/core": "^2.4.8",
      "@smithy/eventstream-serde-browser": "^3.0.10",
      "@smithy/eventstream-serde-config-resolver": "^3.0.7",
      "@smithy/eventstream-serde-node": "^3.0.9",
      "@smithy/fetch-http-handler": "^3.2.9",
      "@smithy/hash-blob-browser": "^3.1.6",
      "@smithy/hash-node": "^3.0.7",
      "@smithy/hash-stream-node": "^3.1.6",
      "@smithy/invalid-dependency": "^3.0.7",
      "@smithy/md5-js": "^3.0.7",
      "@smithy/middleware-content-length": "^3.0.9",
      "@smithy/middleware-endpoint": "^3.1.4",
      "@smithy/middleware-retry": "^3.0.23",
      "@smithy/middleware-serde": "^3.0.7",
      "@smithy/middleware-stack": "^3.0.7",
      "@smithy/node-config-provider": "^3.1.8",
      "@smithy/node-http-handler": "^3.2.4",
      "@smithy/protocol-http": "^4.1.4",
      "@smithy/smithy-client": "^3.4.0",
      "@smithy/types": "^3.5.0",
      "@smithy/url-parser": "^3.0.7",
      "@smithy/util-base64": "^3.0.0",
      "@smithy/util-body-length-browser": "^3.0.0",
      "@smithy/util-body-length-node": "^3.0.0",
      "@smithy/util-defaults-mode-browser": "^3.0.23",
      "@smithy/util-defaults-mode-node": "^3.0.23",
      "@smithy/util-endpoints": "^2.1.3",
      "@smithy/util-middleware": "^3.0.7",
      "@smithy/util-retry": "^3.0.7",
      "@smithy/util-stream": "^3.1.9",
      "@smithy/util-utf8": "^3.0.0",
      "@smithy/util-waiter": "^3.1.6",
      tslib: "^2.6.2"
    },
    devDependencies: {
      "@aws-sdk/signature-v4-crt": "3.679.0",
      "@tsconfig/node16": "16.1.3",
      "@types/chai": "^4.2.11",
      "@types/mocha": "^8.0.4",
      "@types/node": "^16.18.96",
      concurrently: "7.0.0",
      "downlevel-dts": "0.10.1",
      rimraf: "3.0.2",
      typescript: "~4.9.5"
    },
    engines: {
      node: ">=16.0.0"
    },
    typesVersions: {
      "<4.0": {
        "dist-types/*": [
          "dist-types/ts3.4/*"
        ]
      }
    },
    files: [
      "dist-*/**"
    ],
    author: {
      name: "AWS SDK for JavaScript Team",
      url: "https://aws.amazon.com/javascript/"
    },
    license: "Apache-2.0",
    browser: {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.browser"
    },
    "react-native": {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.native"
    },
    homepage: "https://github.com/aws/aws-sdk-js-v3/tree/main/clients/client-s3",
    repository: {
      type: "git",
      url: "https://github.com/aws/aws-sdk-js-v3.git",
      directory: "clients/client-s3"
    }
  };
});
var import_client;
var ENV_KEY = "AWS_ACCESS_KEY_ID";
var ENV_SECRET = "AWS_SECRET_ACCESS_KEY";
var ENV_SESSION = "AWS_SESSION_TOKEN";
var ENV_EXPIRATION = "AWS_CREDENTIAL_EXPIRATION";
var ENV_CREDENTIAL_SCOPE = "AWS_CREDENTIAL_SCOPE";
var ENV_ACCOUNT_ID = "AWS_ACCOUNT_ID";
var fromEnv2 = (init3) => async () => {
  init3?.logger?.debug("@aws-sdk/credential-provider-env - fromEnv");
  const accessKeyId = process.env[ENV_KEY];
  const secretAccessKey = process.env[ENV_SECRET];
  const sessionToken = process.env[ENV_SESSION];
  const expiry = process.env[ENV_EXPIRATION];
  const credentialScope = process.env[ENV_CREDENTIAL_SCOPE];
  const accountId = process.env[ENV_ACCOUNT_ID];
  if (accessKeyId && secretAccessKey) {
    const credentials = {
      accessKeyId,
      secretAccessKey,
      ...sessionToken && { sessionToken },
      ...expiry && { expiration: new Date(expiry) },
      ...credentialScope && { credentialScope },
      ...accountId && { accountId }
    };
    import_client.setCredentialFeature(credentials, "CREDENTIALS_ENV_VARS", "g");
    return credentials;
  }
  throw new CredentialsProviderError("Unable to find environment variable credentials.", { logger: init3?.logger });
};
var init_fromEnv2 = __esm2(() => {
  import_client = __toESM3(require_client4(), 1);
  init_dist_es27();
});
var exports_dist_es = {};
__export3(exports_dist_es, {
  fromEnv: () => fromEnv2,
  ENV_SESSION: () => ENV_SESSION,
  ENV_SECRET: () => ENV_SECRET,
  ENV_KEY: () => ENV_KEY,
  ENV_EXPIRATION: () => ENV_EXPIRATION,
  ENV_CREDENTIAL_SCOPE: () => ENV_CREDENTIAL_SCOPE,
  ENV_ACCOUNT_ID: () => ENV_ACCOUNT_ID
});
var init_dist_es38 = __esm2(() => {
  init_fromEnv2();
});
function httpRequest2(options3) {
  return new Promise((resolve5, reject) => {
    const req = request4({
      method: "GET",
      ...options3,
      hostname: options3.hostname?.replace(/^\[(.+)\]$/, "$1")
    });
    req.on("error", (err22) => {
      reject(Object.assign(new ProviderError("Unable to connect to instance metadata service"), err22));
      req.destroy();
    });
    req.on("timeout", () => {
      reject(new ProviderError("TimeoutError from instance metadata service"));
      req.destroy();
    });
    req.on("response", (res) => {
      const { statusCode = 400 } = res;
      if (statusCode < 200 || 300 <= statusCode) {
        reject(Object.assign(new ProviderError("Error response received from instance metadata service"), { statusCode }));
        req.destroy();
      }
      const chunks = [];
      res.on("data", (chunk) => {
        chunks.push(chunk);
      });
      res.on("end", () => {
        resolve5(Buffer4.concat(chunks));
        req.destroy();
      });
    });
    req.end();
  });
}
var init_httpRequest = __esm2(() => {
  init_dist_es27();
});
var isImdsCredentials = (arg) => Boolean(arg) && typeof arg === "object" && typeof arg.AccessKeyId === "string" && typeof arg.SecretAccessKey === "string" && typeof arg.Token === "string" && typeof arg.Expiration === "string";
var fromImdsCredentials = (creds) => ({
  accessKeyId: creds.AccessKeyId,
  secretAccessKey: creds.SecretAccessKey,
  sessionToken: creds.Token,
  expiration: new Date(creds.Expiration),
  ...creds.AccountId && { accountId: creds.AccountId }
});
var DEFAULT_TIMEOUT = 1000;
var DEFAULT_MAX_RETRIES = 0;
var providerConfigFromInit = ({ maxRetries = DEFAULT_MAX_RETRIES, timeout = DEFAULT_TIMEOUT }) => ({ maxRetries, timeout });
var retry2 = (toRetry, maxRetries) => {
  let promise3 = toRetry();
  for (let i2 = 0;i2 < maxRetries; i2++) {
    promise3 = promise3.catch(toRetry);
  }
  return promise3;
};
var ENV_CMDS_FULL_URI = "AWS_CONTAINER_CREDENTIALS_FULL_URI";
var ENV_CMDS_RELATIVE_URI = "AWS_CONTAINER_CREDENTIALS_RELATIVE_URI";
var ENV_CMDS_AUTH_TOKEN = "AWS_CONTAINER_AUTHORIZATION_TOKEN";
var fromContainerMetadata = (init3 = {}) => {
  const { timeout, maxRetries } = providerConfigFromInit(init3);
  return () => retry2(async () => {
    const requestOptions = await getCmdsUri({ logger: init3.logger });
    const credsResponse = JSON.parse(await requestFromEcsImds(timeout, requestOptions));
    if (!isImdsCredentials(credsResponse)) {
      throw new CredentialsProviderError("Invalid response received from instance metadata service.", {
        logger: init3.logger
      });
    }
    return fromImdsCredentials(credsResponse);
  }, maxRetries);
};
var requestFromEcsImds = async (timeout, options3) => {
  if (process.env[ENV_CMDS_AUTH_TOKEN]) {
    options3.headers = {
      ...options3.headers,
      Authorization: process.env[ENV_CMDS_AUTH_TOKEN]
    };
  }
  const buffer = await httpRequest2({
    ...options3,
    timeout
  });
  return buffer.toString();
};
var CMDS_IP = "169.254.170.2";
var GREENGRASS_HOSTS;
var GREENGRASS_PROTOCOLS;
var getCmdsUri = async ({ logger: logger3 }) => {
  if (process.env[ENV_CMDS_RELATIVE_URI]) {
    return {
      hostname: CMDS_IP,
      path: process.env[ENV_CMDS_RELATIVE_URI]
    };
  }
  if (process.env[ENV_CMDS_FULL_URI]) {
    const parsed = parse9(process.env[ENV_CMDS_FULL_URI]);
    if (!parsed.hostname || !(parsed.hostname in GREENGRASS_HOSTS)) {
      throw new CredentialsProviderError(`${parsed.hostname} is not a valid container metadata service hostname`, {
        tryNextLink: false,
        logger: logger3
      });
    }
    if (!parsed.protocol || !(parsed.protocol in GREENGRASS_PROTOCOLS)) {
      throw new CredentialsProviderError(`${parsed.protocol} is not a valid container metadata service protocol`, {
        tryNextLink: false,
        logger: logger3
      });
    }
    return {
      ...parsed,
      port: parsed.port ? parseInt(parsed.port, 10) : undefined
    };
  }
  throw new CredentialsProviderError(`The container metadata credential provider cannot be used unless the ${ENV_CMDS_RELATIVE_URI} or ${ENV_CMDS_FULL_URI} environment variable is set`, {
    tryNextLink: false,
    logger: logger3
  });
};
var init_fromContainerMetadata = __esm2(() => {
  init_dist_es27();
  init_httpRequest();
  GREENGRASS_HOSTS = {
    localhost: true,
    "127.0.0.1": true
  };
  GREENGRASS_PROTOCOLS = {
    "http:": true,
    "https:": true
  };
});
var InstanceMetadataV1FallbackError;
var init_InstanceMetadataV1FallbackError = __esm2(() => {
  init_dist_es27();
  InstanceMetadataV1FallbackError = class InstanceMetadataV1FallbackError2 extends CredentialsProviderError {
    constructor(message, tryNextLink = true) {
      super(message, tryNextLink);
      this.tryNextLink = tryNextLink;
      this.name = "InstanceMetadataV1FallbackError";
      Object.setPrototypeOf(this, InstanceMetadataV1FallbackError2.prototype);
    }
  };
});
var Endpoint;
var init_Endpoint = __esm2(() => {
  (function(Endpoint2) {
    Endpoint2["IPv4"] = "http://169.254.169.254";
    Endpoint2["IPv6"] = "http://[fd00:ec2::254]";
  })(Endpoint || (Endpoint = {}));
});
var ENV_ENDPOINT_NAME = "AWS_EC2_METADATA_SERVICE_ENDPOINT";
var CONFIG_ENDPOINT_NAME = "ec2_metadata_service_endpoint";
var ENDPOINT_CONFIG_OPTIONS;
var init_EndpointConfigOptions = __esm2(() => {
  ENDPOINT_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => env62[ENV_ENDPOINT_NAME],
    configFileSelector: (profile) => profile[CONFIG_ENDPOINT_NAME],
    default: undefined
  };
});
var EndpointMode;
var init_EndpointMode = __esm2(() => {
  (function(EndpointMode2) {
    EndpointMode2["IPv4"] = "IPv4";
    EndpointMode2["IPv6"] = "IPv6";
  })(EndpointMode || (EndpointMode = {}));
});
var ENV_ENDPOINT_MODE_NAME = "AWS_EC2_METADATA_SERVICE_ENDPOINT_MODE";
var CONFIG_ENDPOINT_MODE_NAME = "ec2_metadata_service_endpoint_mode";
var ENDPOINT_MODE_CONFIG_OPTIONS;
var init_EndpointModeConfigOptions = __esm2(() => {
  init_EndpointMode();
  ENDPOINT_MODE_CONFIG_OPTIONS = {
    environmentVariableSelector: (env62) => env62[ENV_ENDPOINT_MODE_NAME],
    configFileSelector: (profile) => profile[CONFIG_ENDPOINT_MODE_NAME],
    default: EndpointMode.IPv4
  };
});
var getInstanceMetadataEndpoint = async () => parseUrl(await getFromEndpointConfig() || await getFromEndpointModeConfig());
var getFromEndpointConfig = async () => loadConfig(ENDPOINT_CONFIG_OPTIONS)();
var getFromEndpointModeConfig = async () => {
  const endpointMode = await loadConfig(ENDPOINT_MODE_CONFIG_OPTIONS)();
  switch (endpointMode) {
    case EndpointMode.IPv4:
      return Endpoint.IPv4;
    case EndpointMode.IPv6:
      return Endpoint.IPv6;
    default:
      throw new Error(`Unsupported endpoint mode: ${endpointMode}. Select from ${Object.values(EndpointMode)}`);
  }
};
var init_getInstanceMetadataEndpoint = __esm2(() => {
  init_dist_es29();
  init_dist_es30();
  init_Endpoint();
  init_EndpointConfigOptions();
  init_EndpointMode();
  init_EndpointModeConfigOptions();
});
var STATIC_STABILITY_REFRESH_INTERVAL_SECONDS;
var STATIC_STABILITY_REFRESH_INTERVAL_JITTER_WINDOW_SECONDS;
var STATIC_STABILITY_DOC_URL = "https://docs.aws.amazon.com/sdkref/latest/guide/feature-static-credentials.html";
var getExtendedInstanceMetadataCredentials = (credentials, logger3) => {
  const refreshInterval = STATIC_STABILITY_REFRESH_INTERVAL_SECONDS + Math.floor(Math.random() * STATIC_STABILITY_REFRESH_INTERVAL_JITTER_WINDOW_SECONDS);
  const newExpiration = new Date(Date.now() + refreshInterval * 1000);
  logger3.warn(`Attempting credential expiration extension due to a credential service availability issue. A refresh of these credentials will be attempted after ${new Date(newExpiration)}.\nFor more information, please visit: ` + STATIC_STABILITY_DOC_URL);
  const originalExpiration = credentials.originalExpiration ?? credentials.expiration;
  return {
    ...credentials,
    ...originalExpiration ? { originalExpiration } : {},
    expiration: newExpiration
  };
};
var init_getExtendedInstanceMetadataCredentials = __esm2(() => {
  STATIC_STABILITY_REFRESH_INTERVAL_SECONDS = 300;
  STATIC_STABILITY_REFRESH_INTERVAL_JITTER_WINDOW_SECONDS = 300;
});
var staticStabilityProvider = (provider, options3 = {}) => {
  const logger3 = options3?.logger || console;
  let pastCredentials;
  return async () => {
    let credentials;
    try {
      credentials = await provider();
      if (credentials.expiration && credentials.expiration.getTime() < Date.now()) {
        credentials = getExtendedInstanceMetadataCredentials(credentials, logger3);
      }
    } catch (e2) {
      if (pastCredentials) {
        logger3.warn("Credential renew failed: ", e2);
        credentials = getExtendedInstanceMetadataCredentials(pastCredentials, logger3);
      } else {
        throw e2;
      }
    }
    pastCredentials = credentials;
    return credentials;
  };
};
var init_staticStabilityProvider = __esm2(() => {
  init_getExtendedInstanceMetadataCredentials();
});
var IMDS_PATH = "/latest/meta-data/iam/security-credentials/";
var IMDS_TOKEN_PATH = "/latest/api/token";
var AWS_EC2_METADATA_V1_DISABLED = "AWS_EC2_METADATA_V1_DISABLED";
var PROFILE_AWS_EC2_METADATA_V1_DISABLED = "ec2_metadata_v1_disabled";
var X_AWS_EC2_METADATA_TOKEN = "x-aws-ec2-metadata-token";
var fromInstanceMetadata = (init3 = {}) => staticStabilityProvider(getInstanceMetadataProvider(init3), { logger: init3.logger });
var getInstanceMetadataProvider = (init3 = {}) => {
  let disableFetchToken = false;
  const { logger: logger3, profile } = init3;
  const { timeout, maxRetries } = providerConfigFromInit(init3);
  const getCredentials = async (maxRetries2, options3) => {
    const isImdsV1Fallback = disableFetchToken || options3.headers?.[X_AWS_EC2_METADATA_TOKEN] == null;
    if (isImdsV1Fallback) {
      let fallbackBlockedFromProfile = false;
      let fallbackBlockedFromProcessEnv = false;
      const configValue = await loadConfig({
        environmentVariableSelector: (env62) => {
          const envValue = env62[AWS_EC2_METADATA_V1_DISABLED];
          fallbackBlockedFromProcessEnv = !!envValue && envValue !== "false";
          if (envValue === undefined) {
            throw new CredentialsProviderError(`${AWS_EC2_METADATA_V1_DISABLED} not set in env, checking config file next.`, { logger: init3.logger });
          }
          return fallbackBlockedFromProcessEnv;
        },
        configFileSelector: (profile2) => {
          const profileValue = profile2[PROFILE_AWS_EC2_METADATA_V1_DISABLED];
          fallbackBlockedFromProfile = !!profileValue && profileValue !== "false";
          return fallbackBlockedFromProfile;
        },
        default: false
      }, {
        profile
      })();
      if (init3.ec2MetadataV1Disabled || configValue) {
        const causes = [];
        if (init3.ec2MetadataV1Disabled)
          causes.push("credential provider initialization (runtime option ec2MetadataV1Disabled)");
        if (fallbackBlockedFromProfile)
          causes.push(`config file profile (${PROFILE_AWS_EC2_METADATA_V1_DISABLED})`);
        if (fallbackBlockedFromProcessEnv)
          causes.push(`process environment variable (${AWS_EC2_METADATA_V1_DISABLED})`);
        throw new InstanceMetadataV1FallbackError(`AWS EC2 Metadata v1 fallback has been blocked by AWS SDK configuration in the following: [${causes.join(", ")}].`);
      }
    }
    const imdsProfile = (await retry2(async () => {
      let profile2;
      try {
        profile2 = await getProfile(options3);
      } catch (err22) {
        if (err22.statusCode === 401) {
          disableFetchToken = false;
        }
        throw err22;
      }
      return profile2;
    }, maxRetries2)).trim();
    return retry2(async () => {
      let creds;
      try {
        creds = await getCredentialsFromProfile(imdsProfile, options3, init3);
      } catch (err22) {
        if (err22.statusCode === 401) {
          disableFetchToken = false;
        }
        throw err22;
      }
      return creds;
    }, maxRetries2);
  };
  return async () => {
    const endpoint = await getInstanceMetadataEndpoint();
    if (disableFetchToken) {
      logger3?.debug("AWS SDK Instance Metadata", "using v1 fallback (no token fetch)");
      return getCredentials(maxRetries, { ...endpoint, timeout });
    } else {
      let token;
      try {
        token = (await getMetadataToken({ ...endpoint, timeout })).toString();
      } catch (error) {
        if (error?.statusCode === 400) {
          throw Object.assign(error, {
            message: "EC2 Metadata token request returned error"
          });
        } else if (error.message === "TimeoutError" || [403, 404, 405].includes(error.statusCode)) {
          disableFetchToken = true;
        }
        logger3?.debug("AWS SDK Instance Metadata", "using v1 fallback (initial)");
        return getCredentials(maxRetries, { ...endpoint, timeout });
      }
      return getCredentials(maxRetries, {
        ...endpoint,
        headers: {
          [X_AWS_EC2_METADATA_TOKEN]: token
        },
        timeout
      });
    }
  };
};
var getMetadataToken = async (options3) => httpRequest2({
  ...options3,
  path: IMDS_TOKEN_PATH,
  method: "PUT",
  headers: {
    "x-aws-ec2-metadata-token-ttl-seconds": "21600"
  }
});
var getProfile = async (options3) => (await httpRequest2({ ...options3, path: IMDS_PATH })).toString();
var getCredentialsFromProfile = async (profile, options3, init3) => {
  const credentialsResponse = JSON.parse((await httpRequest2({
    ...options3,
    path: IMDS_PATH + profile
  })).toString());
  if (!isImdsCredentials(credentialsResponse)) {
    throw new CredentialsProviderError("Invalid response received from instance metadata service.", {
      logger: init3.logger
    });
  }
  return fromImdsCredentials(credentialsResponse);
};
var init_fromInstanceMetadata = __esm2(() => {
  init_dist_es29();
  init_dist_es27();
  init_InstanceMetadataV1FallbackError();
  init_httpRequest();
  init_getInstanceMetadataEndpoint();
  init_staticStabilityProvider();
});
var init_types12 = () => {
};
var exports_dist_es2 = {};
__export3(exports_dist_es2, {
  providerConfigFromInit: () => providerConfigFromInit,
  httpRequest: () => httpRequest2,
  getInstanceMetadataEndpoint: () => getInstanceMetadataEndpoint,
  fromInstanceMetadata: () => fromInstanceMetadata,
  fromContainerMetadata: () => fromContainerMetadata,
  Endpoint: () => Endpoint,
  ENV_CMDS_RELATIVE_URI: () => ENV_CMDS_RELATIVE_URI,
  ENV_CMDS_FULL_URI: () => ENV_CMDS_FULL_URI,
  ENV_CMDS_AUTH_TOKEN: () => ENV_CMDS_AUTH_TOKEN,
  DEFAULT_TIMEOUT: () => DEFAULT_TIMEOUT,
  DEFAULT_MAX_RETRIES: () => DEFAULT_MAX_RETRIES
});
var init_dist_es39 = __esm2(() => {
  init_fromContainerMetadata();
  init_fromInstanceMetadata();
  init_types12();
  init_httpRequest();
  init_getInstanceMetadataEndpoint();
  init_Endpoint();
});
var ECS_CONTAINER_HOST = "169.254.170.2";
var EKS_CONTAINER_HOST_IPv4 = "169.254.170.23";
var EKS_CONTAINER_HOST_IPv6 = "[fd00:ec2::23]";
var checkUrl = (url, logger3) => {
  if (url.protocol === "https:") {
    return;
  }
  if (url.hostname === ECS_CONTAINER_HOST || url.hostname === EKS_CONTAINER_HOST_IPv4 || url.hostname === EKS_CONTAINER_HOST_IPv6) {
    return;
  }
  if (url.hostname.includes("[")) {
    if (url.hostname === "[::1]" || url.hostname === "[0000:0000:0000:0000:0000:0000:0000:0001]") {
      return;
    }
  } else {
    if (url.hostname === "localhost") {
      return;
    }
    const ipComponents = url.hostname.split(".");
    const inRange = (component) => {
      const num = parseInt(component, 10);
      return 0 <= num && num <= 255;
    };
    if (ipComponents[0] === "127" && inRange(ipComponents[1]) && inRange(ipComponents[2]) && inRange(ipComponents[3]) && ipComponents.length === 4) {
      return;
    }
  }
  throw new CredentialsProviderError(`URL not accepted. It must either be HTTPS or match one of the following:
  - loopback CIDR 127.0.0.0/8 or [::1/128]
  - ECS container host 169.254.170.2
  - EKS container host 169.254.170.23 or [fd00:ec2::23]`, { logger: logger3 });
};
var init_checkUrl = __esm2(() => {
  init_dist_es27();
});
function createGetRequest(url) {
  return new HttpRequest({
    protocol: url.protocol,
    hostname: url.hostname,
    port: Number(url.port),
    path: url.pathname,
    query: Array.from(url.searchParams.entries()).reduce((acc, [k2, v6]) => {
      acc[k2] = v6;
      return acc;
    }, {}),
    fragment: url.hash
  });
}
async function getCredentials(response, logger3) {
  const stream2 = sdkStreamMixin3(response.body);
  const str2 = await stream2.transformToString();
  if (response.statusCode === 200) {
    const parsed = JSON.parse(str2);
    if (typeof parsed.AccessKeyId !== "string" || typeof parsed.SecretAccessKey !== "string" || typeof parsed.Token !== "string" || typeof parsed.Expiration !== "string") {
      throw new CredentialsProviderError("HTTP credential provider response not of the required format, an object matching: { AccessKeyId: string, SecretAccessKey: string, Token: string, Expiration: string(rfc3339) }", { logger: logger3 });
    }
    return {
      accessKeyId: parsed.AccessKeyId,
      secretAccessKey: parsed.SecretAccessKey,
      sessionToken: parsed.Token,
      expiration: parseRfc3339DateTime(parsed.Expiration)
    };
  }
  if (response.statusCode >= 400 && response.statusCode < 500) {
    let parsedBody = {};
    try {
      parsedBody = JSON.parse(str2);
    } catch (e2) {
    }
    throw Object.assign(new CredentialsProviderError(`Server responded with status: ${response.statusCode}`, { logger: logger3 }), {
      Code: parsedBody.Code,
      Message: parsedBody.Message
    });
  }
  throw new CredentialsProviderError(`Server responded with status: ${response.statusCode}`, { logger: logger3 });
}
var init_requestHelpers = __esm2(() => {
  init_dist_es27();
  init_dist_es();
  init_dist_es12();
  init_dist_es19();
});
var retryWrapper = (toRetry, maxRetries, delayMs) => {
  return async () => {
    for (let i2 = 0;i2 < maxRetries; ++i2) {
      try {
        return await toRetry();
      } catch (e2) {
        await new Promise((resolve5) => setTimeout(resolve5, delayMs));
      }
    }
    return await toRetry();
  };
};
var import_client2;
var AWS_CONTAINER_CREDENTIALS_RELATIVE_URI = "AWS_CONTAINER_CREDENTIALS_RELATIVE_URI";
var DEFAULT_LINK_LOCAL_HOST = "http://169.254.170.2";
var AWS_CONTAINER_CREDENTIALS_FULL_URI = "AWS_CONTAINER_CREDENTIALS_FULL_URI";
var AWS_CONTAINER_AUTHORIZATION_TOKEN_FILE = "AWS_CONTAINER_AUTHORIZATION_TOKEN_FILE";
var AWS_CONTAINER_AUTHORIZATION_TOKEN = "AWS_CONTAINER_AUTHORIZATION_TOKEN";
var fromHttp = (options3 = {}) => {
  options3.logger?.debug("@aws-sdk/credential-provider-http - fromHttp");
  let host;
  const relative3 = options3.awsContainerCredentialsRelativeUri ?? process.env[AWS_CONTAINER_CREDENTIALS_RELATIVE_URI];
  const full = options3.awsContainerCredentialsFullUri ?? process.env[AWS_CONTAINER_CREDENTIALS_FULL_URI];
  const token = options3.awsContainerAuthorizationToken ?? process.env[AWS_CONTAINER_AUTHORIZATION_TOKEN];
  const tokenFile = options3.awsContainerAuthorizationTokenFile ?? process.env[AWS_CONTAINER_AUTHORIZATION_TOKEN_FILE];
  const warn = options3.logger?.constructor?.name === "NoOpLogger" || !options3.logger ? console.warn : options3.logger.warn;
  if (relative3 && full) {
    warn("@aws-sdk/credential-provider-http: you have set both awsContainerCredentialsRelativeUri and awsContainerCredentialsFullUri.");
    warn("awsContainerCredentialsFullUri will take precedence.");
  }
  if (token && tokenFile) {
    warn("@aws-sdk/credential-provider-http: you have set both awsContainerAuthorizationToken and awsContainerAuthorizationTokenFile.");
    warn("awsContainerAuthorizationToken will take precedence.");
  }
  if (full) {
    host = full;
  } else if (relative3) {
    host = `${DEFAULT_LINK_LOCAL_HOST}${relative3}`;
  } else {
    throw new CredentialsProviderError(`No HTTP credential provider host provided.
Set AWS_CONTAINER_CREDENTIALS_FULL_URI or AWS_CONTAINER_CREDENTIALS_RELATIVE_URI.`, { logger: options3.logger });
  }
  const url = new URL(host);
  checkUrl(url, options3.logger);
  const requestHandler = new NodeHttpHandler({
    requestTimeout: options3.timeout ?? 1000,
    connectionTimeout: options3.timeout ?? 1000
  });
  return retryWrapper(async () => {
    const request5 = createGetRequest(url);
    if (token) {
      request5.headers.Authorization = token;
    } else if (tokenFile) {
      request5.headers.Authorization = (await fs3.readFile(tokenFile)).toString();
    }
    try {
      const result2 = await requestHandler.handle(request5);
      return getCredentials(result2.response).then((creds) => import_client2.setCredentialFeature(creds, "CREDENTIALS_HTTP", "z"));
    } catch (e2) {
      throw new CredentialsProviderError(String(e2), { logger: options3.logger });
    }
  }, options3.maxRetries ?? 3, options3.timeout ?? 1000);
};
var init_fromHttp = __esm2(() => {
  import_client2 = __toESM3(require_client4(), 1);
  init_dist_es18();
  init_dist_es27();
  init_checkUrl();
  init_requestHelpers();
});
var exports_dist_es3 = {};
__export3(exports_dist_es3, {
  fromHttp: () => fromHttp
});
var init_dist_es40 = __esm2(() => {
  init_fromHttp();
});
var ENV_IMDS_DISABLED = "AWS_EC2_METADATA_DISABLED";
var remoteProvider = async (init3) => {
  const { ENV_CMDS_FULL_URI: ENV_CMDS_FULL_URI2, ENV_CMDS_RELATIVE_URI: ENV_CMDS_RELATIVE_URI2, fromContainerMetadata: fromContainerMetadata3, fromInstanceMetadata: fromInstanceMetadata3 } = await Promise.resolve().then(() => (init_dist_es39(), exports_dist_es2));
  if (process.env[ENV_CMDS_RELATIVE_URI2] || process.env[ENV_CMDS_FULL_URI2]) {
    init3.logger?.debug("@aws-sdk/credential-provider-node - remoteProvider::fromHttp/fromContainerMetadata");
    const { fromHttp: fromHttp2 } = await Promise.resolve().then(() => (init_dist_es40(), exports_dist_es3));
    return chain(fromHttp2(init3), fromContainerMetadata3(init3));
  }
  if (process.env[ENV_IMDS_DISABLED]) {
    return async () => {
      throw new CredentialsProviderError("EC2 Instance Metadata Service access disabled", { logger: init3.logger });
    };
  }
  init3.logger?.debug("@aws-sdk/credential-provider-node - remoteProvider::fromInstanceMetadata");
  return fromInstanceMetadata3(init3);
};
var init_remoteProvider = __esm2(() => {
  init_dist_es27();
});
var isSsoProfile = (arg) => arg && (typeof arg.sso_start_url === "string" || typeof arg.sso_account_id === "string" || typeof arg.sso_session === "string" || typeof arg.sso_region === "string" || typeof arg.sso_role_name === "string");
var EXPIRE_WINDOW_MS;
var REFRESH_MESSAGE = `To refresh this SSO session run 'aws sso login' with the corresponding profile.`;
var init_constants8 = __esm2(() => {
  EXPIRE_WINDOW_MS = 300000;
});
function createAwsAuthSigv4HttpAuthOption2(authParameters) {
  return {
    schemeId: "aws.auth#sigv4",
    signingProperties: {
      name: "sso-oauth",
      region: authParameters.region
    },
    propertiesExtractor: (config8, context) => ({
      signingProperties: {
        config: config8,
        context
      }
    })
  };
}
function createSmithyApiNoAuthHttpAuthOption(authParameters) {
  return {
    schemeId: "smithy.api#noAuth"
  };
}
var import_core13;
var import_util_middleware10;
var defaultSSOOIDCHttpAuthSchemeParametersProvider = async (config8, context, input) => {
  return {
    operation: import_util_middleware10.getSmithyContext(context).operation,
    region: await import_util_middleware10.normalizeProvider(config8.region)() || (() => {
      throw new Error("expected `region` to be configured for `aws.auth#sigv4`");
    })()
  };
};
var defaultSSOOIDCHttpAuthSchemeProvider = (authParameters) => {
  const options3 = [];
  switch (authParameters.operation) {
    case "CreateToken": {
      options3.push(createSmithyApiNoAuthHttpAuthOption(authParameters));
      break;
    }
    case "RegisterClient": {
      options3.push(createSmithyApiNoAuthHttpAuthOption(authParameters));
      break;
    }
    case "StartDeviceAuthorization": {
      options3.push(createSmithyApiNoAuthHttpAuthOption(authParameters));
      break;
    }
    default: {
      options3.push(createAwsAuthSigv4HttpAuthOption2(authParameters));
    }
  }
  return options3;
};
var resolveHttpAuthSchemeConfig2 = (config8) => {
  const config_0 = import_core13.resolveAwsSdkSigV4Config(config8);
  return {
    ...config_0
  };
};
var init_httpAuthSchemeProvider2 = __esm2(() => {
  import_core13 = __toESM3(require_dist_cjs20(), 1);
  import_util_middleware10 = __toESM3(require_dist_cjs3(), 1);
});
var resolveClientEndpointParameters2 = (options3) => {
  return {
    ...options3,
    useDualstackEndpoint: options3.useDualstackEndpoint ?? false,
    useFipsEndpoint: options3.useFipsEndpoint ?? false,
    defaultSigningName: "sso-oauth"
  };
};
var commonParams2;
var init_EndpointParameters2 = __esm2(() => {
  commonParams2 = {
    UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
    Endpoint: { type: "builtInParams", name: "endpoint" },
    Region: { type: "builtInParams", name: "region" },
    UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" }
  };
});
var package_default2;
var init_package4 = __esm2(() => {
  package_default2 = {
    name: "@aws-sdk/client-sso-oidc",
    description: "AWS SDK for JavaScript Sso Oidc Client for Node.js, Browser and React Native",
    version: "3.679.0",
    scripts: {
      build: "concurrently 'yarn:build:cjs' 'yarn:build:es' 'yarn:build:types'",
      "build:cjs": "node ../../scripts/compilation/inline client-sso-oidc",
      "build:es": "tsc -p tsconfig.es.json",
      "build:include:deps": "lerna run --scope $npm_package_name --include-dependencies build",
      "build:types": "tsc -p tsconfig.types.json",
      "build:types:downlevel": "downlevel-dts dist-types dist-types/ts3.4",
      clean: "rimraf ./dist-* && rimraf *.tsbuildinfo",
      "extract:docs": "api-extractor run --local",
      "generate:client": "node ../../scripts/generate-clients/single-service --solo sso-oidc"
    },
    main: "./dist-cjs/index.js",
    types: "./dist-types/index.d.ts",
    module: "./dist-es/index.js",
    sideEffects: false,
    dependencies: {
      "@aws-crypto/sha256-browser": "5.2.0",
      "@aws-crypto/sha256-js": "5.2.0",
      "@aws-sdk/core": "3.679.0",
      "@aws-sdk/credential-provider-node": "3.679.0",
      "@aws-sdk/middleware-host-header": "3.679.0",
      "@aws-sdk/middleware-logger": "3.679.0",
      "@aws-sdk/middleware-recursion-detection": "3.679.0",
      "@aws-sdk/middleware-user-agent": "3.679.0",
      "@aws-sdk/region-config-resolver": "3.679.0",
      "@aws-sdk/types": "3.679.0",
      "@aws-sdk/util-endpoints": "3.679.0",
      "@aws-sdk/util-user-agent-browser": "3.679.0",
      "@aws-sdk/util-user-agent-node": "3.679.0",
      "@smithy/config-resolver": "^3.0.9",
      "@smithy/core": "^2.4.8",
      "@smithy/fetch-http-handler": "^3.2.9",
      "@smithy/hash-node": "^3.0.7",
      "@smithy/invalid-dependency": "^3.0.7",
      "@smithy/middleware-content-length": "^3.0.9",
      "@smithy/middleware-endpoint": "^3.1.4",
      "@smithy/middleware-retry": "^3.0.23",
      "@smithy/middleware-serde": "^3.0.7",
      "@smithy/middleware-stack": "^3.0.7",
      "@smithy/node-config-provider": "^3.1.8",
      "@smithy/node-http-handler": "^3.2.4",
      "@smithy/protocol-http": "^4.1.4",
      "@smithy/smithy-client": "^3.4.0",
      "@smithy/types": "^3.5.0",
      "@smithy/url-parser": "^3.0.7",
      "@smithy/util-base64": "^3.0.0",
      "@smithy/util-body-length-browser": "^3.0.0",
      "@smithy/util-body-length-node": "^3.0.0",
      "@smithy/util-defaults-mode-browser": "^3.0.23",
      "@smithy/util-defaults-mode-node": "^3.0.23",
      "@smithy/util-endpoints": "^2.1.3",
      "@smithy/util-middleware": "^3.0.7",
      "@smithy/util-retry": "^3.0.7",
      "@smithy/util-utf8": "^3.0.0",
      tslib: "^2.6.2"
    },
    devDependencies: {
      "@tsconfig/node16": "16.1.3",
      "@types/node": "^16.18.96",
      concurrently: "7.0.0",
      "downlevel-dts": "0.10.1",
      rimraf: "3.0.2",
      typescript: "~4.9.5"
    },
    engines: {
      node: ">=16.0.0"
    },
    typesVersions: {
      "<4.0": {
        "dist-types/*": [
          "dist-types/ts3.4/*"
        ]
      }
    },
    files: [
      "dist-*/**"
    ],
    author: {
      name: "AWS SDK for JavaScript Team",
      url: "https://aws.amazon.com/javascript/"
    },
    license: "Apache-2.0",
    peerDependencies: {
      "@aws-sdk/client-sts": "^3.679.0"
    },
    browser: {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.browser"
    },
    "react-native": {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.native"
    },
    homepage: "https://github.com/aws/aws-sdk-js-v3/tree/main/clients/client-sso-oidc",
    repository: {
      type: "git",
      url: "https://github.com/aws/aws-sdk-js-v3.git",
      directory: "clients/client-sso-oidc"
    }
  };
});
var crtAvailability;
var init_crt_availability = __esm2(() => {
  crtAvailability = {
    isCrtAvailable: false
  };
});
var isCrtAvailable = () => {
  if (crtAvailability.isCrtAvailable) {
    return ["md/crt-avail"];
  }
  return null;
};
var init_is_crt_available = __esm2(() => {
  init_crt_availability();
});
var createDefaultUserAgentProvider = ({ serviceId, clientVersion }) => {
  return async (config8) => {
    const sections = [
      ["aws-sdk-js", clientVersion],
      ["ua", "2.1"],
      [`os/${platform3()}`, release()],
      ["lang/js"],
      ["md/nodejs", `${versions2.node}`]
    ];
    const crtAvailable = isCrtAvailable();
    if (crtAvailable) {
      sections.push(crtAvailable);
    }
    if (serviceId) {
      sections.push([`api/${serviceId}`, clientVersion]);
    }
    if (env6.AWS_EXECUTION_ENV) {
      sections.push([`exec-env/${env6.AWS_EXECUTION_ENV}`]);
    }
    const appId = await config8?.userAgentAppId?.();
    const resolvedUserAgent = appId ? [...sections, [`app/${appId}`]] : [...sections];
    return resolvedUserAgent;
  };
};
var init_defaultUserAgent = __esm2(() => {
  init_is_crt_available();
  init_crt_availability();
});
var UA_APP_ID_ENV_NAME = "AWS_SDK_UA_APP_ID";
var UA_APP_ID_INI_NAME = "sdk-ua-app-id";
var NODE_APP_ID_CONFIG_OPTIONS;
var init_nodeAppIdConfigOptions = __esm2(() => {
  init_dist_es23();
  NODE_APP_ID_CONFIG_OPTIONS = {
    environmentVariableSelector: (env7) => env7[UA_APP_ID_ENV_NAME],
    configFileSelector: (profile) => profile[UA_APP_ID_INI_NAME],
    default: DEFAULT_UA_APP_ID
  };
});
var init_dist_es41 = __esm2(() => {
  init_defaultUserAgent();
  init_nodeAppIdConfigOptions();
});

class Hash {
  constructor(algorithmIdentifier, secret) {
    this.algorithmIdentifier = algorithmIdentifier;
    this.secret = secret;
    this.reset();
  }
  update(toHash, encoding) {
    this.hash.update(toUint8Array2(castSourceData(toHash, encoding)));
  }
  digest() {
    return Promise.resolve(this.hash.digest());
  }
  reset() {
    this.hash = this.secret ? createHmac(this.algorithmIdentifier, castSourceData(this.secret)) : createHash2(this.algorithmIdentifier);
  }
}
function castSourceData(toCast, encoding) {
  if (Buffer5.isBuffer(toCast)) {
    return toCast;
  }
  if (typeof toCast === "string") {
    return fromString2(toCast, encoding);
  }
  if (ArrayBuffer.isView(toCast)) {
    return fromArrayBuffer2(toCast.buffer, toCast.byteOffset, toCast.byteLength);
  }
  return fromArrayBuffer2(toCast);
}
var init_dist_es42 = __esm2(() => {
  init_dist_es5();
  init_dist_es6();
});
var calculateBodyLength = (body) => {
  if (!body) {
    return 0;
  }
  if (typeof body === "string") {
    return Buffer.byteLength(body);
  } else if (typeof body.byteLength === "number") {
    return body.byteLength;
  } else if (typeof body.size === "number") {
    return body.size;
  } else if (typeof body.start === "number" && typeof body.end === "number") {
    return body.end + 1 - body.start;
  } else if (typeof body.path === "string" || Buffer.isBuffer(body.path)) {
    return lstatSync(body.path).size;
  } else if (typeof body.fd === "number") {
    return fstatSync(body.fd).size;
  }
  throw new Error(`Body Length computation failed for ${body}`);
};
var init_calculateBodyLength = () => {
};
var init_dist_es43 = __esm2(() => {
  init_calculateBodyLength();
});
var u2 = "required";
var v6 = "fn";
var w3 = "argv";
var x2 = "ref";
var a2 = true;
var b3 = "isSet";
var c3 = "booleanEquals";
var d2 = "error";
var e2 = "endpoint";
var f3 = "tree";
var g3 = "PartitionResult";
var h32 = "getAttr";
var i2;
var j3;
var k2;
var l32;
var m3;
var n2;
var o2;
var p4;
var q3;
var r3;
var s6;
var t2;
var _data2;
var ruleSet2;
var init_ruleset2 = __esm2(() => {
  i2 = { [u2]: false, type: "String" };
  j3 = { [u2]: true, default: false, type: "Boolean" };
  k2 = { [x2]: "Endpoint" };
  l32 = { [v6]: c3, [w3]: [{ [x2]: "UseFIPS" }, true] };
  m3 = { [v6]: c3, [w3]: [{ [x2]: "UseDualStack" }, true] };
  n2 = {};
  o2 = { [v6]: h32, [w3]: [{ [x2]: g3 }, "supportsFIPS"] };
  p4 = { [x2]: g3 };
  q3 = { [v6]: c3, [w3]: [true, { [v6]: h32, [w3]: [p4, "supportsDualStack"] }] };
  r3 = [l32];
  s6 = [m3];
  t2 = [{ [x2]: "Region" }];
  _data2 = { version: "1.0", parameters: { Region: i2, UseDualStack: j3, UseFIPS: j3, Endpoint: i2 }, rules: [{ conditions: [{ [v6]: b3, [w3]: [k2] }], rules: [{ conditions: r3, error: "Invalid Configuration: FIPS and custom endpoint are not supported", type: d2 }, { conditions: s6, error: "Invalid Configuration: Dualstack and custom endpoint are not supported", type: d2 }, { endpoint: { url: k2, properties: n2, headers: n2 }, type: e2 }], type: f3 }, { conditions: [{ [v6]: b3, [w3]: t2 }], rules: [{ conditions: [{ [v6]: "aws.partition", [w3]: t2, assign: g3 }], rules: [{ conditions: [l32, m3], rules: [{ conditions: [{ [v6]: c3, [w3]: [a2, o2] }, q3], rules: [{ endpoint: { url: "https://oidc-fips.{Region}.{PartitionResult#dualStackDnsSuffix}", properties: n2, headers: n2 }, type: e2 }], type: f3 }, { error: "FIPS and DualStack are enabled, but this partition does not support one or both", type: d2 }], type: f3 }, { conditions: r3, rules: [{ conditions: [{ [v6]: c3, [w3]: [o2, a2] }], rules: [{ conditions: [{ [v6]: "stringEquals", [w3]: [{ [v6]: h32, [w3]: [p4, "name"] }, "aws-us-gov"] }], endpoint: { url: "https://oidc.{Region}.amazonaws.com", properties: n2, headers: n2 }, type: e2 }, { endpoint: { url: "https://oidc-fips.{Region}.{PartitionResult#dnsSuffix}", properties: n2, headers: n2 }, type: e2 }], type: f3 }, { error: "FIPS is enabled but this partition does not support FIPS", type: d2 }], type: f3 }, { conditions: s6, rules: [{ conditions: [q3], rules: [{ endpoint: { url: "https://oidc.{Region}.{PartitionResult#dualStackDnsSuffix}", properties: n2, headers: n2 }, type: e2 }], type: f3 }, { error: "DualStack is enabled but this partition does not support DualStack", type: d2 }], type: f3 }, { endpoint: { url: "https://oidc.{Region}.{PartitionResult#dnsSuffix}", properties: n2, headers: n2 }, type: e2 }], type: f3 }], type: f3 }, { error: "Invalid Configuration: Missing Region", type: d2 }] };
  ruleSet2 = _data2;
});
var cache4;
var defaultEndpointResolver2 = (endpointParams, context = {}) => {
  return cache4.get(endpointParams, () => resolveEndpoint(ruleSet2, {
    endpointParams,
    logger: context.logger
  }));
};
var init_endpointResolver2 = __esm2(() => {
  init_dist_es22();
  init_dist_es21();
  init_ruleset2();
  cache4 = new EndpointCache({
    size: 50,
    params: ["Endpoint", "Region", "UseDualStack", "UseFIPS"]
  });
  customEndpointFunctions.aws = awsEndpointFunctions;
});
var import_core14;
var import_core15;
var getRuntimeConfig = (config8) => {
  return {
    apiVersion: "2019-06-10",
    base64Decoder: config8?.base64Decoder ?? fromBase642,
    base64Encoder: config8?.base64Encoder ?? toBase643,
    disableHostPrefix: config8?.disableHostPrefix ?? false,
    endpointProvider: config8?.endpointProvider ?? defaultEndpointResolver2,
    extensions: config8?.extensions ?? [],
    httpAuthSchemeProvider: config8?.httpAuthSchemeProvider ?? defaultSSOOIDCHttpAuthSchemeProvider,
    httpAuthSchemes: config8?.httpAuthSchemes ?? [
      {
        schemeId: "aws.auth#sigv4",
        identityProvider: (ipc) => ipc.getIdentityProvider("aws.auth#sigv4"),
        signer: new import_core14.AwsSdkSigV4Signer
      },
      {
        schemeId: "smithy.api#noAuth",
        identityProvider: (ipc) => ipc.getIdentityProvider("smithy.api#noAuth") || (async () => ({})),
        signer: new import_core15.NoAuthSigner
      }
    ],
    logger: config8?.logger ?? new NoOpLogger,
    serviceId: config8?.serviceId ?? "SSO OIDC",
    urlParser: config8?.urlParser ?? parseUrl,
    utf8Decoder: config8?.utf8Decoder ?? fromUtf84,
    utf8Encoder: config8?.utf8Encoder ?? toUtf82
  };
};
var init_runtimeConfig_shared = __esm2(() => {
  import_core14 = __toESM3(require_dist_cjs20(), 1);
  import_core15 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es12();
  init_dist_es30();
  init_dist_es16();
  init_dist_es6();
  init_httpAuthSchemeProvider2();
  init_endpointResolver2();
});
var AWS_EXECUTION_ENV = "AWS_EXECUTION_ENV";
var AWS_REGION_ENV = "AWS_REGION";
var AWS_DEFAULT_REGION_ENV = "AWS_DEFAULT_REGION";
var ENV_IMDS_DISABLED2 = "AWS_EC2_METADATA_DISABLED";
var DEFAULTS_MODE_OPTIONS;
var IMDS_REGION_PATH = "/latest/meta-data/placement/region";
var init_constants9 = __esm2(() => {
  DEFAULTS_MODE_OPTIONS = ["in-region", "cross-region", "mobile", "standard", "legacy"];
});
var AWS_DEFAULTS_MODE_ENV = "AWS_DEFAULTS_MODE";
var AWS_DEFAULTS_MODE_CONFIG = "defaults_mode";
var NODE_DEFAULTS_MODE_CONFIG_OPTIONS;
var init_defaultsModeConfig = __esm2(() => {
  NODE_DEFAULTS_MODE_CONFIG_OPTIONS = {
    environmentVariableSelector: (env7) => {
      return env7[AWS_DEFAULTS_MODE_ENV];
    },
    configFileSelector: (profile) => {
      return profile[AWS_DEFAULTS_MODE_CONFIG];
    },
    default: "legacy"
  };
});
var resolveDefaultsModeConfig = ({ region = loadConfig(NODE_REGION_CONFIG_OPTIONS), defaultsMode = loadConfig(NODE_DEFAULTS_MODE_CONFIG_OPTIONS) } = {}) => memoize2(async () => {
  const mode2 = typeof defaultsMode === "function" ? await defaultsMode() : defaultsMode;
  switch (mode2?.toLowerCase()) {
    case "auto":
      return resolveNodeDefaultsModeAuto(region);
    case "in-region":
    case "cross-region":
    case "mobile":
    case "standard":
    case "legacy":
      return Promise.resolve(mode2?.toLocaleLowerCase());
    case undefined:
      return Promise.resolve("legacy");
    default:
      throw new Error(`Invalid parameter for "defaultsMode", expect ${DEFAULTS_MODE_OPTIONS.join(", ")}, got ${mode2}`);
  }
});
var resolveNodeDefaultsModeAuto = async (clientRegion) => {
  if (clientRegion) {
    const resolvedRegion = typeof clientRegion === "function" ? await clientRegion() : clientRegion;
    const inferredRegion = await inferPhysicalRegion();
    if (!inferredRegion) {
      return "standard";
    }
    if (resolvedRegion === inferredRegion) {
      return "in-region";
    } else {
      return "cross-region";
    }
  }
  return "standard";
};
var inferPhysicalRegion = async () => {
  if (process.env[AWS_EXECUTION_ENV] && (process.env[AWS_REGION_ENV] || process.env[AWS_DEFAULT_REGION_ENV])) {
    return process.env[AWS_REGION_ENV] ?? process.env[AWS_DEFAULT_REGION_ENV];
  }
  if (!process.env[ENV_IMDS_DISABLED2]) {
    try {
      const { getInstanceMetadataEndpoint: getInstanceMetadataEndpoint2, httpRequest: httpRequest3 } = await Promise.resolve().then(() => (init_dist_es39(), exports_dist_es2));
      const endpoint = await getInstanceMetadataEndpoint2();
      return (await httpRequest3({ ...endpoint, path: IMDS_REGION_PATH })).toString();
    } catch (e3) {
    }
  }
};
var init_resolveDefaultsModeConfig = __esm2(() => {
  init_dist_es24();
  init_dist_es29();
  init_dist_es27();
  init_constants9();
  init_defaultsModeConfig();
});
var init_dist_es44 = __esm2(() => {
  init_resolveDefaultsModeConfig();
});
var import_core16;
var getRuntimeConfig2 = (config8) => {
  emitWarningIfUnsupportedVersion(process.version);
  const defaultsMode = resolveDefaultsModeConfig(config8);
  const defaultConfigProvider = () => defaultsMode().then(loadConfigsForDefaultMode);
  const clientSharedValues = getRuntimeConfig(config8);
  import_core16.emitWarningIfUnsupportedVersion(process.version);
  return {
    ...clientSharedValues,
    ...config8,
    runtime: "node",
    defaultsMode,
    bodyLengthChecker: config8?.bodyLengthChecker ?? calculateBodyLength,
    credentialDefaultProvider: config8?.credentialDefaultProvider ?? defaultProvider,
    defaultUserAgentProvider: config8?.defaultUserAgentProvider ?? createDefaultUserAgentProvider({ serviceId: clientSharedValues.serviceId, clientVersion: package_default2.version }),
    maxAttempts: config8?.maxAttempts ?? loadConfig(NODE_MAX_ATTEMPT_CONFIG_OPTIONS),
    region: config8?.region ?? loadConfig(NODE_REGION_CONFIG_OPTIONS, NODE_REGION_CONFIG_FILE_OPTIONS),
    requestHandler: NodeHttpHandler.create(config8?.requestHandler ?? defaultConfigProvider),
    retryMode: config8?.retryMode ?? loadConfig({
      ...NODE_RETRY_MODE_CONFIG_OPTIONS,
      default: async () => (await defaultConfigProvider()).retryMode || DEFAULT_RETRY_MODE
    }),
    sha256: config8?.sha256 ?? Hash.bind(null, "sha256"),
    streamCollector: config8?.streamCollector ?? streamCollector,
    useDualstackEndpoint: config8?.useDualstackEndpoint ?? loadConfig(NODE_USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS),
    useFipsEndpoint: config8?.useFipsEndpoint ?? loadConfig(NODE_USE_FIPS_ENDPOINT_CONFIG_OPTIONS),
    userAgentAppId: config8?.userAgentAppId ?? loadConfig(NODE_APP_ID_CONFIG_OPTIONS)
  };
};
var init_runtimeConfig = __esm2(() => {
  init_package4();
  import_core16 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es54();
  init_dist_es41();
  init_dist_es24();
  init_dist_es42();
  init_dist_es35();
  init_dist_es29();
  init_dist_es18();
  init_dist_es43();
  init_dist_es34();
  init_runtimeConfig_shared();
  init_dist_es12();
  init_dist_es44();
  init_dist_es12();
});
var getAwsRegionExtensionConfiguration = (runtimeConfig) => {
  let runtimeConfigRegion = async () => {
    if (runtimeConfig.region === undefined) {
      throw new Error("Region is missing from runtimeConfig");
    }
    const region = runtimeConfig.region;
    if (typeof region === "string") {
      return region;
    }
    return region();
  };
  return {
    setRegion(region) {
      runtimeConfigRegion = region;
    },
    region() {
      return runtimeConfigRegion;
    }
  };
};
var resolveAwsRegionExtensionConfiguration = (awsRegionExtensionConfiguration) => {
  return {
    region: awsRegionExtensionConfiguration.region()
  };
};
var init_config5 = () => {
};
var init_getRealRegion2 = () => {
};
var init_resolveRegionConfig2 = __esm2(() => {
  init_getRealRegion2();
});
var init_regionConfig2 = __esm2(() => {
  init_config5();
  init_resolveRegionConfig2();
});
var init_dist_es45 = __esm2(() => {
  init_regionConfig2();
});
var getHttpAuthExtensionConfiguration = (runtimeConfig) => {
  const _httpAuthSchemes = runtimeConfig.httpAuthSchemes;
  let _httpAuthSchemeProvider = runtimeConfig.httpAuthSchemeProvider;
  let _credentials = runtimeConfig.credentials;
  return {
    setHttpAuthScheme(httpAuthScheme) {
      const index = _httpAuthSchemes.findIndex((scheme) => scheme.schemeId === httpAuthScheme.schemeId);
      if (index === -1) {
        _httpAuthSchemes.push(httpAuthScheme);
      } else {
        _httpAuthSchemes.splice(index, 1, httpAuthScheme);
      }
    },
    httpAuthSchemes() {
      return _httpAuthSchemes;
    },
    setHttpAuthSchemeProvider(httpAuthSchemeProvider) {
      _httpAuthSchemeProvider = httpAuthSchemeProvider;
    },
    httpAuthSchemeProvider() {
      return _httpAuthSchemeProvider;
    },
    setCredentials(credentials) {
      _credentials = credentials;
    },
    credentials() {
      return _credentials;
    }
  };
};
var resolveHttpAuthRuntimeConfig = (config9) => {
  return {
    httpAuthSchemes: config9.httpAuthSchemes(),
    httpAuthSchemeProvider: config9.httpAuthSchemeProvider(),
    credentials: config9.credentials()
  };
};
var asPartial = (t3) => t3;
var resolveRuntimeExtensions = (runtimeConfig, extensions4) => {
  const extensionConfiguration = {
    ...asPartial(getAwsRegionExtensionConfiguration(runtimeConfig)),
    ...asPartial(getDefaultExtensionConfiguration(runtimeConfig)),
    ...asPartial(getHttpHandlerExtensionConfiguration(runtimeConfig)),
    ...asPartial(getHttpAuthExtensionConfiguration(runtimeConfig))
  };
  extensions4.forEach((extension2) => extension2.configure(extensionConfiguration));
  return {
    ...runtimeConfig,
    ...resolveAwsRegionExtensionConfiguration(extensionConfiguration),
    ...resolveDefaultRuntimeConfig(extensionConfiguration),
    ...resolveHttpHandlerRuntimeConfig(extensionConfiguration),
    ...resolveHttpAuthRuntimeConfig(extensionConfiguration)
  };
};
var init_runtimeExtensions = __esm2(() => {
  init_dist_es45();
  init_dist_es();
  init_dist_es12();
});
var import_core17;
var SSOOIDCClient;
var init_SSOOIDCClient = __esm2(() => {
  init_dist_es8();
  init_dist_es9();
  init_dist_es10();
  init_dist_es23();
  init_dist_es24();
  import_core17 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es26();
  init_dist_es32();
  init_dist_es35();
  init_dist_es12();
  init_httpAuthSchemeProvider2();
  init_EndpointParameters2();
  init_runtimeConfig();
  init_runtimeExtensions();
  SSOOIDCClient = class SSOOIDCClient2 extends Client {
    constructor(...[configuration]) {
      const _config_0 = getRuntimeConfig2(configuration || {});
      const _config_1 = resolveClientEndpointParameters2(_config_0);
      const _config_2 = resolveUserAgentConfig(_config_1);
      const _config_3 = resolveRetryConfig(_config_2);
      const _config_4 = resolveRegionConfig(_config_3);
      const _config_5 = resolveHostHeaderConfig(_config_4);
      const _config_6 = resolveEndpointConfig(_config_5);
      const _config_7 = resolveHttpAuthSchemeConfig2(_config_6);
      const _config_8 = resolveRuntimeExtensions(_config_7, configuration?.extensions || []);
      super(_config_8);
      this.config = _config_8;
      this.middlewareStack.use(getUserAgentPlugin(this.config));
      this.middlewareStack.use(getRetryPlugin(this.config));
      this.middlewareStack.use(getContentLengthPlugin(this.config));
      this.middlewareStack.use(getHostHeaderPlugin(this.config));
      this.middlewareStack.use(getLoggerPlugin(this.config));
      this.middlewareStack.use(getRecursionDetectionPlugin(this.config));
      this.middlewareStack.use(import_core17.getHttpAuthSchemeEndpointRuleSetPlugin(this.config, {
        httpAuthSchemeParametersProvider: defaultSSOOIDCHttpAuthSchemeParametersProvider,
        identityProviderConfigProvider: async (config9) => new import_core17.DefaultIdentityProviderConfig({
          "aws.auth#sigv4": config9.credentials
        })
      }));
      this.middlewareStack.use(import_core17.getHttpSigningPlugin(this.config));
    }
    destroy() {
      super.destroy();
    }
  };
});
var SSOOIDCServiceException;
var init_SSOOIDCServiceException = __esm2(() => {
  init_dist_es12();
  SSOOIDCServiceException = class SSOOIDCServiceException2 extends ServiceException {
    constructor(options3) {
      super(options3);
      Object.setPrototypeOf(this, SSOOIDCServiceException2.prototype);
    }
  };
});
var AccessDeniedException;
var AuthorizationPendingException;
var ExpiredTokenException;
var InternalServerException;
var InvalidClientException;
var InvalidGrantException;
var InvalidRequestException;
var InvalidScopeException;
var SlowDownException;
var UnauthorizedClientException;
var UnsupportedGrantTypeException;
var InvalidRequestRegionException;
var InvalidClientMetadataException;
var InvalidRedirectUriException;
var CreateTokenRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.clientSecret && { clientSecret: SENSITIVE_STRING },
  ...obj.refreshToken && { refreshToken: SENSITIVE_STRING },
  ...obj.codeVerifier && { codeVerifier: SENSITIVE_STRING }
});
var CreateTokenResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.accessToken && { accessToken: SENSITIVE_STRING },
  ...obj.refreshToken && { refreshToken: SENSITIVE_STRING },
  ...obj.idToken && { idToken: SENSITIVE_STRING }
});
var CreateTokenWithIAMRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.refreshToken && { refreshToken: SENSITIVE_STRING },
  ...obj.assertion && { assertion: SENSITIVE_STRING },
  ...obj.subjectToken && { subjectToken: SENSITIVE_STRING },
  ...obj.codeVerifier && { codeVerifier: SENSITIVE_STRING }
});
var CreateTokenWithIAMResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.accessToken && { accessToken: SENSITIVE_STRING },
  ...obj.refreshToken && { refreshToken: SENSITIVE_STRING },
  ...obj.idToken && { idToken: SENSITIVE_STRING }
});
var RegisterClientResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.clientSecret && { clientSecret: SENSITIVE_STRING }
});
var StartDeviceAuthorizationRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.clientSecret && { clientSecret: SENSITIVE_STRING }
});
var init_models_02 = __esm2(() => {
  init_dist_es12();
  init_SSOOIDCServiceException();
  AccessDeniedException = class AccessDeniedException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "AccessDeniedException",
        $fault: "client",
        ...opts
      });
      this.name = "AccessDeniedException";
      this.$fault = "client";
      Object.setPrototypeOf(this, AccessDeniedException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  AuthorizationPendingException = class AuthorizationPendingException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "AuthorizationPendingException",
        $fault: "client",
        ...opts
      });
      this.name = "AuthorizationPendingException";
      this.$fault = "client";
      Object.setPrototypeOf(this, AuthorizationPendingException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  ExpiredTokenException = class ExpiredTokenException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "ExpiredTokenException",
        $fault: "client",
        ...opts
      });
      this.name = "ExpiredTokenException";
      this.$fault = "client";
      Object.setPrototypeOf(this, ExpiredTokenException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  InternalServerException = class InternalServerException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InternalServerException",
        $fault: "server",
        ...opts
      });
      this.name = "InternalServerException";
      this.$fault = "server";
      Object.setPrototypeOf(this, InternalServerException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  InvalidClientException = class InvalidClientException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InvalidClientException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidClientException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidClientException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  InvalidGrantException = class InvalidGrantException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InvalidGrantException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidGrantException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidGrantException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  InvalidRequestException = class InvalidRequestException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InvalidRequestException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidRequestException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidRequestException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  InvalidScopeException = class InvalidScopeException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InvalidScopeException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidScopeException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidScopeException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  SlowDownException = class SlowDownException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "SlowDownException",
        $fault: "client",
        ...opts
      });
      this.name = "SlowDownException";
      this.$fault = "client";
      Object.setPrototypeOf(this, SlowDownException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  UnauthorizedClientException = class UnauthorizedClientException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "UnauthorizedClientException",
        $fault: "client",
        ...opts
      });
      this.name = "UnauthorizedClientException";
      this.$fault = "client";
      Object.setPrototypeOf(this, UnauthorizedClientException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  UnsupportedGrantTypeException = class UnsupportedGrantTypeException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "UnsupportedGrantTypeException",
        $fault: "client",
        ...opts
      });
      this.name = "UnsupportedGrantTypeException";
      this.$fault = "client";
      Object.setPrototypeOf(this, UnsupportedGrantTypeException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  InvalidRequestRegionException = class InvalidRequestRegionException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InvalidRequestRegionException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidRequestRegionException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidRequestRegionException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
      this.endpoint = opts.endpoint;
      this.region = opts.region;
    }
  };
  InvalidClientMetadataException = class InvalidClientMetadataException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InvalidClientMetadataException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidClientMetadataException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidClientMetadataException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
  InvalidRedirectUriException = class InvalidRedirectUriException2 extends SSOOIDCServiceException {
    constructor(opts) {
      super({
        name: "InvalidRedirectUriException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidRedirectUriException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidRedirectUriException2.prototype);
      this.error = opts.error;
      this.error_description = opts.error_description;
    }
  };
});
var import_core18;
var import_core19;
var se_CreateTokenCommand = async (input, context) => {
  const b4 = import_core19.requestBuilder(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b4.bp("/token");
  let body;
  body = JSON.stringify(take(input, {
    clientId: [],
    clientSecret: [],
    code: [],
    codeVerifier: [],
    deviceCode: [],
    grantType: [],
    redirectUri: [],
    refreshToken: [],
    scope: (_22) => _json(_22)
  }));
  b4.m("POST").h(headers).b(body);
  return b4.build();
};
var se_CreateTokenWithIAMCommand = async (input, context) => {
  const b4 = import_core19.requestBuilder(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b4.bp("/token");
  const query = map2({
    [_ai]: [, "t"]
  });
  let body;
  body = JSON.stringify(take(input, {
    assertion: [],
    clientId: [],
    code: [],
    codeVerifier: [],
    grantType: [],
    redirectUri: [],
    refreshToken: [],
    requestedTokenType: [],
    scope: (_22) => _json(_22),
    subjectToken: [],
    subjectTokenType: []
  }));
  b4.m("POST").h(headers).q(query).b(body);
  return b4.build();
};
var se_RegisterClientCommand = async (input, context) => {
  const b4 = import_core19.requestBuilder(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b4.bp("/client/register");
  let body;
  body = JSON.stringify(take(input, {
    clientName: [],
    clientType: [],
    entitledApplicationArn: [],
    grantTypes: (_22) => _json(_22),
    issuerUrl: [],
    redirectUris: (_22) => _json(_22),
    scopes: (_22) => _json(_22)
  }));
  b4.m("POST").h(headers).b(body);
  return b4.build();
};
var se_StartDeviceAuthorizationCommand = async (input, context) => {
  const b4 = import_core19.requestBuilder(input, context);
  const headers = {
    "content-type": "application/json"
  };
  b4.bp("/device_authorization");
  let body;
  body = JSON.stringify(take(input, {
    clientId: [],
    clientSecret: [],
    startUrl: []
  }));
  b4.m("POST").h(headers).b(body);
  return b4.build();
};
var de_CreateTokenCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError2(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata3(output)
  });
  const data2 = expectNonNull(expectObject(await import_core18.parseJsonBody(output.body, context)), "body");
  const doc = take(data2, {
    accessToken: expectString,
    expiresIn: expectInt32,
    idToken: expectString,
    refreshToken: expectString,
    tokenType: expectString
  });
  Object.assign(contents, doc);
  return contents;
};
var de_CreateTokenWithIAMCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError2(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata3(output)
  });
  const data2 = expectNonNull(expectObject(await import_core18.parseJsonBody(output.body, context)), "body");
  const doc = take(data2, {
    accessToken: expectString,
    expiresIn: expectInt32,
    idToken: expectString,
    issuedTokenType: expectString,
    refreshToken: expectString,
    scope: _json,
    tokenType: expectString
  });
  Object.assign(contents, doc);
  return contents;
};
var de_RegisterClientCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError2(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata3(output)
  });
  const data2 = expectNonNull(expectObject(await import_core18.parseJsonBody(output.body, context)), "body");
  const doc = take(data2, {
    authorizationEndpoint: expectString,
    clientId: expectString,
    clientIdIssuedAt: expectLong,
    clientSecret: expectString,
    clientSecretExpiresAt: expectLong,
    tokenEndpoint: expectString
  });
  Object.assign(contents, doc);
  return contents;
};
var de_StartDeviceAuthorizationCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError2(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata3(output)
  });
  const data2 = expectNonNull(expectObject(await import_core18.parseJsonBody(output.body, context)), "body");
  const doc = take(data2, {
    deviceCode: expectString,
    expiresIn: expectInt32,
    interval: expectInt32,
    userCode: expectString,
    verificationUri: expectString,
    verificationUriComplete: expectString
  });
  Object.assign(contents, doc);
  return contents;
};
var de_CommandError2 = async (output, context) => {
  const parsedOutput = {
    ...output,
    body: await import_core18.parseJsonErrorBody(output.body, context)
  };
  const errorCode = import_core18.loadRestJsonErrorCode(output, parsedOutput.body);
  switch (errorCode) {
    case "AccessDeniedException":
    case "com.amazonaws.ssooidc#AccessDeniedException":
      throw await de_AccessDeniedExceptionRes(parsedOutput, context);
    case "AuthorizationPendingException":
    case "com.amazonaws.ssooidc#AuthorizationPendingException":
      throw await de_AuthorizationPendingExceptionRes(parsedOutput, context);
    case "ExpiredTokenException":
    case "com.amazonaws.ssooidc#ExpiredTokenException":
      throw await de_ExpiredTokenExceptionRes(parsedOutput, context);
    case "InternalServerException":
    case "com.amazonaws.ssooidc#InternalServerException":
      throw await de_InternalServerExceptionRes(parsedOutput, context);
    case "InvalidClientException":
    case "com.amazonaws.ssooidc#InvalidClientException":
      throw await de_InvalidClientExceptionRes(parsedOutput, context);
    case "InvalidGrantException":
    case "com.amazonaws.ssooidc#InvalidGrantException":
      throw await de_InvalidGrantExceptionRes(parsedOutput, context);
    case "InvalidRequestException":
    case "com.amazonaws.ssooidc#InvalidRequestException":
      throw await de_InvalidRequestExceptionRes(parsedOutput, context);
    case "InvalidScopeException":
    case "com.amazonaws.ssooidc#InvalidScopeException":
      throw await de_InvalidScopeExceptionRes(parsedOutput, context);
    case "SlowDownException":
    case "com.amazonaws.ssooidc#SlowDownException":
      throw await de_SlowDownExceptionRes(parsedOutput, context);
    case "UnauthorizedClientException":
    case "com.amazonaws.ssooidc#UnauthorizedClientException":
      throw await de_UnauthorizedClientExceptionRes(parsedOutput, context);
    case "UnsupportedGrantTypeException":
    case "com.amazonaws.ssooidc#UnsupportedGrantTypeException":
      throw await de_UnsupportedGrantTypeExceptionRes(parsedOutput, context);
    case "InvalidRequestRegionException":
    case "com.amazonaws.ssooidc#InvalidRequestRegionException":
      throw await de_InvalidRequestRegionExceptionRes(parsedOutput, context);
    case "InvalidClientMetadataException":
    case "com.amazonaws.ssooidc#InvalidClientMetadataException":
      throw await de_InvalidClientMetadataExceptionRes(parsedOutput, context);
    case "InvalidRedirectUriException":
    case "com.amazonaws.ssooidc#InvalidRedirectUriException":
      throw await de_InvalidRedirectUriExceptionRes(parsedOutput, context);
    default:
      const parsedBody = parsedOutput.body;
      return throwDefaultError3({
        output,
        parsedBody,
        errorCode
      });
  }
};
var throwDefaultError3;
var de_AccessDeniedExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new AccessDeniedException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_AuthorizationPendingExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new AuthorizationPendingException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_ExpiredTokenExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new ExpiredTokenException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InternalServerExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InternalServerException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidClientExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidClientException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidClientMetadataExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidClientMetadataException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidGrantExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidGrantException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidRedirectUriExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidRedirectUriException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidRequestExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidRequestException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidRequestRegionExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    endpoint: expectString,
    error: expectString,
    error_description: expectString,
    region: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidRequestRegionException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_InvalidScopeExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidScopeException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_SlowDownExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new SlowDownException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_UnauthorizedClientExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new UnauthorizedClientException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_UnsupportedGrantTypeExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    error: expectString,
    error_description: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new UnsupportedGrantTypeException({
    $metadata: deserializeMetadata3(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var deserializeMetadata3 = (output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
});
var _ai = "aws_iam";
var init_Aws_restJson1 = __esm2(() => {
  import_core18 = __toESM3(require_dist_cjs20(), 1);
  import_core19 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es12();
  init_models_02();
  init_SSOOIDCServiceException();
  throwDefaultError3 = withBaseException(SSOOIDCServiceException);
});
var CreateTokenCommand;
var init_CreateTokenCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters2();
  init_models_02();
  init_Aws_restJson1();
  CreateTokenCommand = class CreateTokenCommand2 extends Command2.classBuilder().ep(commonParams2).m(function(Command22, cs2, config9, o3) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSSOOIDCService", "CreateToken", {}).n("SSOOIDCClient", "CreateTokenCommand").f(CreateTokenRequestFilterSensitiveLog, CreateTokenResponseFilterSensitiveLog).ser(se_CreateTokenCommand).de(de_CreateTokenCommand).build() {
  };
});
var CreateTokenWithIAMCommand;
var init_CreateTokenWithIAMCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters2();
  init_models_02();
  init_Aws_restJson1();
  CreateTokenWithIAMCommand = class CreateTokenWithIAMCommand2 extends Command2.classBuilder().ep(commonParams2).m(function(Command22, cs2, config9, o3) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSSOOIDCService", "CreateTokenWithIAM", {}).n("SSOOIDCClient", "CreateTokenWithIAMCommand").f(CreateTokenWithIAMRequestFilterSensitiveLog, CreateTokenWithIAMResponseFilterSensitiveLog).ser(se_CreateTokenWithIAMCommand).de(de_CreateTokenWithIAMCommand).build() {
  };
});
var RegisterClientCommand;
var init_RegisterClientCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters2();
  init_models_02();
  init_Aws_restJson1();
  RegisterClientCommand = class RegisterClientCommand2 extends Command2.classBuilder().ep(commonParams2).m(function(Command22, cs2, config9, o3) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSSOOIDCService", "RegisterClient", {}).n("SSOOIDCClient", "RegisterClientCommand").f(undefined, RegisterClientResponseFilterSensitiveLog).ser(se_RegisterClientCommand).de(de_RegisterClientCommand).build() {
  };
});
var StartDeviceAuthorizationCommand;
var init_StartDeviceAuthorizationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters2();
  init_models_02();
  init_Aws_restJson1();
  StartDeviceAuthorizationCommand = class StartDeviceAuthorizationCommand2 extends Command2.classBuilder().ep(commonParams2).m(function(Command22, cs2, config9, o3) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSSOOIDCService", "StartDeviceAuthorization", {}).n("SSOOIDCClient", "StartDeviceAuthorizationCommand").f(StartDeviceAuthorizationRequestFilterSensitiveLog, undefined).ser(se_StartDeviceAuthorizationCommand).de(de_StartDeviceAuthorizationCommand).build() {
  };
});
var commands;
var SSOOIDC;
var init_SSOOIDC = __esm2(() => {
  init_dist_es12();
  init_CreateTokenCommand();
  init_CreateTokenWithIAMCommand();
  init_RegisterClientCommand();
  init_StartDeviceAuthorizationCommand();
  init_SSOOIDCClient();
  commands = {
    CreateTokenCommand,
    CreateTokenWithIAMCommand,
    RegisterClientCommand,
    StartDeviceAuthorizationCommand
  };
  SSOOIDC = class SSOOIDC2 extends SSOOIDCClient {
  };
  createAggregatedClient(commands, SSOOIDC);
});
var init_commands = __esm2(() => {
  init_CreateTokenCommand();
  init_CreateTokenWithIAMCommand();
  init_RegisterClientCommand();
  init_StartDeviceAuthorizationCommand();
});
var init_models = __esm2(() => {
  init_models_02();
});
var exports_dist_es4 = {};
__export3(exports_dist_es4, {
  __Client: () => Client,
  UnsupportedGrantTypeException: () => UnsupportedGrantTypeException,
  UnauthorizedClientException: () => UnauthorizedClientException,
  StartDeviceAuthorizationRequestFilterSensitiveLog: () => StartDeviceAuthorizationRequestFilterSensitiveLog,
  StartDeviceAuthorizationCommand: () => StartDeviceAuthorizationCommand,
  SlowDownException: () => SlowDownException,
  SSOOIDCServiceException: () => SSOOIDCServiceException,
  SSOOIDCClient: () => SSOOIDCClient,
  SSOOIDC: () => SSOOIDC,
  RegisterClientResponseFilterSensitiveLog: () => RegisterClientResponseFilterSensitiveLog,
  RegisterClientCommand: () => RegisterClientCommand,
  InvalidScopeException: () => InvalidScopeException,
  InvalidRequestRegionException: () => InvalidRequestRegionException,
  InvalidRequestException: () => InvalidRequestException,
  InvalidRedirectUriException: () => InvalidRedirectUriException,
  InvalidGrantException: () => InvalidGrantException,
  InvalidClientMetadataException: () => InvalidClientMetadataException,
  InvalidClientException: () => InvalidClientException,
  InternalServerException: () => InternalServerException,
  ExpiredTokenException: () => ExpiredTokenException,
  CreateTokenWithIAMResponseFilterSensitiveLog: () => CreateTokenWithIAMResponseFilterSensitiveLog,
  CreateTokenWithIAMRequestFilterSensitiveLog: () => CreateTokenWithIAMRequestFilterSensitiveLog,
  CreateTokenWithIAMCommand: () => CreateTokenWithIAMCommand,
  CreateTokenResponseFilterSensitiveLog: () => CreateTokenResponseFilterSensitiveLog,
  CreateTokenRequestFilterSensitiveLog: () => CreateTokenRequestFilterSensitiveLog,
  CreateTokenCommand: () => CreateTokenCommand,
  AuthorizationPendingException: () => AuthorizationPendingException,
  AccessDeniedException: () => AccessDeniedException,
  $Command: () => Command2
});
var init_dist_es46 = __esm2(() => {
  init_SSOOIDCClient();
  init_SSOOIDC();
  init_commands();
  init_models();
  init_SSOOIDCServiceException();
});
var ssoOidcClientsHash;
var getSsoOidcClient = async (ssoRegion) => {
  const { SSOOIDCClient: SSOOIDCClient3 } = await Promise.resolve().then(() => (init_dist_es46(), exports_dist_es4));
  if (ssoOidcClientsHash[ssoRegion]) {
    return ssoOidcClientsHash[ssoRegion];
  }
  const ssoOidcClient = new SSOOIDCClient3({ region: ssoRegion });
  ssoOidcClientsHash[ssoRegion] = ssoOidcClient;
  return ssoOidcClient;
};
var init_getSsoOidcClient = __esm2(() => {
  ssoOidcClientsHash = {};
});
var getNewSsoOidcToken = async (ssoToken, ssoRegion) => {
  const { CreateTokenCommand: CreateTokenCommand3 } = await Promise.resolve().then(() => (init_dist_es46(), exports_dist_es4));
  const ssoOidcClient = await getSsoOidcClient(ssoRegion);
  return ssoOidcClient.send(new CreateTokenCommand3({
    clientId: ssoToken.clientId,
    clientSecret: ssoToken.clientSecret,
    refreshToken: ssoToken.refreshToken,
    grantType: "refresh_token"
  }));
};
var init_getNewSsoOidcToken = __esm2(() => {
  init_getSsoOidcClient();
});
var validateTokenExpiry = (token) => {
  if (token.expiration && token.expiration.getTime() < Date.now()) {
    throw new TokenProviderError(`Token is expired. ${REFRESH_MESSAGE}`, false);
  }
};
var init_validateTokenExpiry = __esm2(() => {
  init_dist_es27();
  init_constants8();
});
var validateTokenKey = (key2, value, forRefresh = false) => {
  if (typeof value === "undefined") {
    throw new TokenProviderError(`Value not present for '${key2}' in SSO Token${forRefresh ? ". Cannot refresh" : ""}. ${REFRESH_MESSAGE}`, false);
  }
};
var init_validateTokenKey = __esm2(() => {
  init_dist_es27();
  init_constants8();
});
var writeFile2;
var writeSSOTokenToFile = (id, ssoToken) => {
  const tokenFilepath = getSSOTokenFilepath(id);
  const tokenString = JSON.stringify(ssoToken, null, 2);
  return writeFile2(tokenFilepath, tokenString);
};
var init_writeSSOTokenToFile = __esm2(() => {
  init_dist_es28();
  ({ writeFile: writeFile2 } = fsPromises3);
});
var lastRefreshAttemptTime;
var fromSso = (init3 = {}) => async () => {
  init3.logger?.debug("@aws-sdk/token-providers - fromSso");
  const profiles = await parseKnownFiles(init3);
  const profileName = getProfileName(init3);
  const profile = profiles[profileName];
  if (!profile) {
    throw new TokenProviderError(`Profile '${profileName}' could not be found in shared credentials file.`, false);
  } else if (!profile["sso_session"]) {
    throw new TokenProviderError(`Profile '${profileName}' is missing required property 'sso_session'.`);
  }
  const ssoSessionName = profile["sso_session"];
  const ssoSessions = await loadSsoSessionData(init3);
  const ssoSession = ssoSessions[ssoSessionName];
  if (!ssoSession) {
    throw new TokenProviderError(`Sso session '${ssoSessionName}' could not be found in shared credentials file.`, false);
  }
  for (const ssoSessionRequiredKey of ["sso_start_url", "sso_region"]) {
    if (!ssoSession[ssoSessionRequiredKey]) {
      throw new TokenProviderError(`Sso session '${ssoSessionName}' is missing required property '${ssoSessionRequiredKey}'.`, false);
    }
  }
  const ssoStartUrl = ssoSession["sso_start_url"];
  const ssoRegion = ssoSession["sso_region"];
  let ssoToken;
  try {
    ssoToken = await getSSOTokenFromFile(ssoSessionName);
  } catch (e3) {
    throw new TokenProviderError(`The SSO session token associated with profile=${profileName} was not found or is invalid. ${REFRESH_MESSAGE}`, false);
  }
  validateTokenKey("accessToken", ssoToken.accessToken);
  validateTokenKey("expiresAt", ssoToken.expiresAt);
  const { accessToken, expiresAt } = ssoToken;
  const existingToken = { token: accessToken, expiration: new Date(expiresAt) };
  if (existingToken.expiration.getTime() - Date.now() > EXPIRE_WINDOW_MS) {
    return existingToken;
  }
  if (Date.now() - lastRefreshAttemptTime.getTime() < 30000) {
    validateTokenExpiry(existingToken);
    return existingToken;
  }
  validateTokenKey("clientId", ssoToken.clientId, true);
  validateTokenKey("clientSecret", ssoToken.clientSecret, true);
  validateTokenKey("refreshToken", ssoToken.refreshToken, true);
  try {
    lastRefreshAttemptTime.setTime(Date.now());
    const newSsoOidcToken = await getNewSsoOidcToken(ssoToken, ssoRegion);
    validateTokenKey("accessToken", newSsoOidcToken.accessToken);
    validateTokenKey("expiresIn", newSsoOidcToken.expiresIn);
    const newTokenExpiration = new Date(Date.now() + newSsoOidcToken.expiresIn * 1000);
    try {
      await writeSSOTokenToFile(ssoSessionName, {
        ...ssoToken,
        accessToken: newSsoOidcToken.accessToken,
        expiresAt: newTokenExpiration.toISOString(),
        refreshToken: newSsoOidcToken.refreshToken
      });
    } catch (error) {
    }
    return {
      token: newSsoOidcToken.accessToken,
      expiration: newTokenExpiration
    };
  } catch (error) {
    validateTokenExpiry(existingToken);
    return existingToken;
  }
};
var init_fromSso = __esm2(() => {
  init_dist_es27();
  init_dist_es28();
  init_constants8();
  init_getNewSsoOidcToken();
  init_validateTokenExpiry();
  init_validateTokenKey();
  init_writeSSOTokenToFile();
  lastRefreshAttemptTime = new Date(0);
});
var init_fromStatic2 = __esm2(() => {
  init_dist_es27();
});
var init_nodeProvider = __esm2(() => {
  init_dist_es27();
});
var init_dist_es47 = __esm2(() => {
  init_fromSso();
  init_fromStatic2();
  init_nodeProvider();
});
function createAwsAuthSigv4HttpAuthOption3(authParameters) {
  return {
    schemeId: "aws.auth#sigv4",
    signingProperties: {
      name: "awsssoportal",
      region: authParameters.region
    },
    propertiesExtractor: (config9, context) => ({
      signingProperties: {
        config: config9,
        context
      }
    })
  };
}
function createSmithyApiNoAuthHttpAuthOption2(authParameters) {
  return {
    schemeId: "smithy.api#noAuth"
  };
}
var import_core20;
var import_util_middleware11;
var defaultSSOHttpAuthSchemeParametersProvider = async (config9, context, input) => {
  return {
    operation: import_util_middleware11.getSmithyContext(context).operation,
    region: await import_util_middleware11.normalizeProvider(config9.region)() || (() => {
      throw new Error("expected `region` to be configured for `aws.auth#sigv4`");
    })()
  };
};
var defaultSSOHttpAuthSchemeProvider = (authParameters) => {
  const options3 = [];
  switch (authParameters.operation) {
    case "GetRoleCredentials": {
      options3.push(createSmithyApiNoAuthHttpAuthOption2(authParameters));
      break;
    }
    case "ListAccountRoles": {
      options3.push(createSmithyApiNoAuthHttpAuthOption2(authParameters));
      break;
    }
    case "ListAccounts": {
      options3.push(createSmithyApiNoAuthHttpAuthOption2(authParameters));
      break;
    }
    case "Logout": {
      options3.push(createSmithyApiNoAuthHttpAuthOption2(authParameters));
      break;
    }
    default: {
      options3.push(createAwsAuthSigv4HttpAuthOption3(authParameters));
    }
  }
  return options3;
};
var resolveHttpAuthSchemeConfig3 = (config9) => {
  const config_0 = import_core20.resolveAwsSdkSigV4Config(config9);
  return {
    ...config_0
  };
};
var init_httpAuthSchemeProvider3 = __esm2(() => {
  import_core20 = __toESM3(require_dist_cjs20(), 1);
  import_util_middleware11 = __toESM3(require_dist_cjs3(), 1);
});
var resolveClientEndpointParameters3 = (options3) => {
  return {
    ...options3,
    useDualstackEndpoint: options3.useDualstackEndpoint ?? false,
    useFipsEndpoint: options3.useFipsEndpoint ?? false,
    defaultSigningName: "awsssoportal"
  };
};
var commonParams3;
var init_EndpointParameters3 = __esm2(() => {
  commonParams3 = {
    UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
    Endpoint: { type: "builtInParams", name: "endpoint" },
    Region: { type: "builtInParams", name: "region" },
    UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" }
  };
});
var package_default3;
var init_package5 = __esm2(() => {
  package_default3 = {
    name: "@aws-sdk/client-sso",
    description: "AWS SDK for JavaScript Sso Client for Node.js, Browser and React Native",
    version: "3.679.0",
    scripts: {
      build: "concurrently 'yarn:build:cjs' 'yarn:build:es' 'yarn:build:types'",
      "build:cjs": "node ../../scripts/compilation/inline client-sso",
      "build:es": "tsc -p tsconfig.es.json",
      "build:include:deps": "lerna run --scope $npm_package_name --include-dependencies build",
      "build:types": "tsc -p tsconfig.types.json",
      "build:types:downlevel": "downlevel-dts dist-types dist-types/ts3.4",
      clean: "rimraf ./dist-* && rimraf *.tsbuildinfo",
      "extract:docs": "api-extractor run --local",
      "generate:client": "node ../../scripts/generate-clients/single-service --solo sso"
    },
    main: "./dist-cjs/index.js",
    types: "./dist-types/index.d.ts",
    module: "./dist-es/index.js",
    sideEffects: false,
    dependencies: {
      "@aws-crypto/sha256-browser": "5.2.0",
      "@aws-crypto/sha256-js": "5.2.0",
      "@aws-sdk/core": "3.679.0",
      "@aws-sdk/middleware-host-header": "3.679.0",
      "@aws-sdk/middleware-logger": "3.679.0",
      "@aws-sdk/middleware-recursion-detection": "3.679.0",
      "@aws-sdk/middleware-user-agent": "3.679.0",
      "@aws-sdk/region-config-resolver": "3.679.0",
      "@aws-sdk/types": "3.679.0",
      "@aws-sdk/util-endpoints": "3.679.0",
      "@aws-sdk/util-user-agent-browser": "3.679.0",
      "@aws-sdk/util-user-agent-node": "3.679.0",
      "@smithy/config-resolver": "^3.0.9",
      "@smithy/core": "^2.4.8",
      "@smithy/fetch-http-handler": "^3.2.9",
      "@smithy/hash-node": "^3.0.7",
      "@smithy/invalid-dependency": "^3.0.7",
      "@smithy/middleware-content-length": "^3.0.9",
      "@smithy/middleware-endpoint": "^3.1.4",
      "@smithy/middleware-retry": "^3.0.23",
      "@smithy/middleware-serde": "^3.0.7",
      "@smithy/middleware-stack": "^3.0.7",
      "@smithy/node-config-provider": "^3.1.8",
      "@smithy/node-http-handler": "^3.2.4",
      "@smithy/protocol-http": "^4.1.4",
      "@smithy/smithy-client": "^3.4.0",
      "@smithy/types": "^3.5.0",
      "@smithy/url-parser": "^3.0.7",
      "@smithy/util-base64": "^3.0.0",
      "@smithy/util-body-length-browser": "^3.0.0",
      "@smithy/util-body-length-node": "^3.0.0",
      "@smithy/util-defaults-mode-browser": "^3.0.23",
      "@smithy/util-defaults-mode-node": "^3.0.23",
      "@smithy/util-endpoints": "^2.1.3",
      "@smithy/util-middleware": "^3.0.7",
      "@smithy/util-retry": "^3.0.7",
      "@smithy/util-utf8": "^3.0.0",
      tslib: "^2.6.2"
    },
    devDependencies: {
      "@tsconfig/node16": "16.1.3",
      "@types/node": "^16.18.96",
      concurrently: "7.0.0",
      "downlevel-dts": "0.10.1",
      rimraf: "3.0.2",
      typescript: "~4.9.5"
    },
    engines: {
      node: ">=16.0.0"
    },
    typesVersions: {
      "<4.0": {
        "dist-types/*": [
          "dist-types/ts3.4/*"
        ]
      }
    },
    files: [
      "dist-*/**"
    ],
    author: {
      name: "AWS SDK for JavaScript Team",
      url: "https://aws.amazon.com/javascript/"
    },
    license: "Apache-2.0",
    browser: {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.browser"
    },
    "react-native": {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.native"
    },
    homepage: "https://github.com/aws/aws-sdk-js-v3/tree/main/clients/client-sso",
    repository: {
      type: "git",
      url: "https://github.com/aws/aws-sdk-js-v3.git",
      directory: "clients/client-sso"
    }
  };
});
var u3 = "required";
var v8 = "fn";
var w4 = "argv";
var x3 = "ref";
var a3 = true;
var b4 = "isSet";
var c4 = "booleanEquals";
var d3 = "error";
var e3 = "endpoint";
var f4 = "tree";
var g4 = "PartitionResult";
var h4 = "getAttr";
var i3;
var j4;
var k3;
var l4;
var m4;
var n3;
var o3;
var p5;
var q4;
var r4;
var s7;
var t3;
var _data3;
var ruleSet3;
var init_ruleset3 = __esm2(() => {
  i3 = { [u3]: false, type: "String" };
  j4 = { [u3]: true, default: false, type: "Boolean" };
  k3 = { [x3]: "Endpoint" };
  l4 = { [v8]: c4, [w4]: [{ [x3]: "UseFIPS" }, true] };
  m4 = { [v8]: c4, [w4]: [{ [x3]: "UseDualStack" }, true] };
  n3 = {};
  o3 = { [v8]: h4, [w4]: [{ [x3]: g4 }, "supportsFIPS"] };
  p5 = { [x3]: g4 };
  q4 = { [v8]: c4, [w4]: [true, { [v8]: h4, [w4]: [p5, "supportsDualStack"] }] };
  r4 = [l4];
  s7 = [m4];
  t3 = [{ [x3]: "Region" }];
  _data3 = { version: "1.0", parameters: { Region: i3, UseDualStack: j4, UseFIPS: j4, Endpoint: i3 }, rules: [{ conditions: [{ [v8]: b4, [w4]: [k3] }], rules: [{ conditions: r4, error: "Invalid Configuration: FIPS and custom endpoint are not supported", type: d3 }, { conditions: s7, error: "Invalid Configuration: Dualstack and custom endpoint are not supported", type: d3 }, { endpoint: { url: k3, properties: n3, headers: n3 }, type: e3 }], type: f4 }, { conditions: [{ [v8]: b4, [w4]: t3 }], rules: [{ conditions: [{ [v8]: "aws.partition", [w4]: t3, assign: g4 }], rules: [{ conditions: [l4, m4], rules: [{ conditions: [{ [v8]: c4, [w4]: [a3, o3] }, q4], rules: [{ endpoint: { url: "https://portal.sso-fips.{Region}.{PartitionResult#dualStackDnsSuffix}", properties: n3, headers: n3 }, type: e3 }], type: f4 }, { error: "FIPS and DualStack are enabled, but this partition does not support one or both", type: d3 }], type: f4 }, { conditions: r4, rules: [{ conditions: [{ [v8]: c4, [w4]: [o3, a3] }], rules: [{ conditions: [{ [v8]: "stringEquals", [w4]: [{ [v8]: h4, [w4]: [p5, "name"] }, "aws-us-gov"] }], endpoint: { url: "https://portal.sso.{Region}.amazonaws.com", properties: n3, headers: n3 }, type: e3 }, { endpoint: { url: "https://portal.sso-fips.{Region}.{PartitionResult#dnsSuffix}", properties: n3, headers: n3 }, type: e3 }], type: f4 }, { error: "FIPS is enabled but this partition does not support FIPS", type: d3 }], type: f4 }, { conditions: s7, rules: [{ conditions: [q4], rules: [{ endpoint: { url: "https://portal.sso.{Region}.{PartitionResult#dualStackDnsSuffix}", properties: n3, headers: n3 }, type: e3 }], type: f4 }, { error: "DualStack is enabled but this partition does not support DualStack", type: d3 }], type: f4 }, { endpoint: { url: "https://portal.sso.{Region}.{PartitionResult#dnsSuffix}", properties: n3, headers: n3 }, type: e3 }], type: f4 }], type: f4 }, { error: "Invalid Configuration: Missing Region", type: d3 }] };
  ruleSet3 = _data3;
});
var cache5;
var defaultEndpointResolver3 = (endpointParams, context = {}) => {
  return cache5.get(endpointParams, () => resolveEndpoint(ruleSet3, {
    endpointParams,
    logger: context.logger
  }));
};
var init_endpointResolver3 = __esm2(() => {
  init_dist_es22();
  init_dist_es21();
  init_ruleset3();
  cache5 = new EndpointCache({
    size: 50,
    params: ["Endpoint", "Region", "UseDualStack", "UseFIPS"]
  });
  customEndpointFunctions.aws = awsEndpointFunctions;
});
var import_core21;
var import_core22;
var getRuntimeConfig3 = (config9) => {
  return {
    apiVersion: "2019-06-10",
    base64Decoder: config9?.base64Decoder ?? fromBase642,
    base64Encoder: config9?.base64Encoder ?? toBase643,
    disableHostPrefix: config9?.disableHostPrefix ?? false,
    endpointProvider: config9?.endpointProvider ?? defaultEndpointResolver3,
    extensions: config9?.extensions ?? [],
    httpAuthSchemeProvider: config9?.httpAuthSchemeProvider ?? defaultSSOHttpAuthSchemeProvider,
    httpAuthSchemes: config9?.httpAuthSchemes ?? [
      {
        schemeId: "aws.auth#sigv4",
        identityProvider: (ipc) => ipc.getIdentityProvider("aws.auth#sigv4"),
        signer: new import_core21.AwsSdkSigV4Signer
      },
      {
        schemeId: "smithy.api#noAuth",
        identityProvider: (ipc) => ipc.getIdentityProvider("smithy.api#noAuth") || (async () => ({})),
        signer: new import_core22.NoAuthSigner
      }
    ],
    logger: config9?.logger ?? new NoOpLogger,
    serviceId: config9?.serviceId ?? "SSO",
    urlParser: config9?.urlParser ?? parseUrl,
    utf8Decoder: config9?.utf8Decoder ?? fromUtf84,
    utf8Encoder: config9?.utf8Encoder ?? toUtf82
  };
};
var init_runtimeConfig_shared2 = __esm2(() => {
  import_core21 = __toESM3(require_dist_cjs20(), 1);
  import_core22 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es12();
  init_dist_es30();
  init_dist_es16();
  init_dist_es6();
  init_httpAuthSchemeProvider3();
  init_endpointResolver3();
});
var import_core23;
var getRuntimeConfig4 = (config9) => {
  emitWarningIfUnsupportedVersion(process.version);
  const defaultsMode = resolveDefaultsModeConfig(config9);
  const defaultConfigProvider = () => defaultsMode().then(loadConfigsForDefaultMode);
  const clientSharedValues = getRuntimeConfig3(config9);
  import_core23.emitWarningIfUnsupportedVersion(process.version);
  return {
    ...clientSharedValues,
    ...config9,
    runtime: "node",
    defaultsMode,
    bodyLengthChecker: config9?.bodyLengthChecker ?? calculateBodyLength,
    defaultUserAgentProvider: config9?.defaultUserAgentProvider ?? createDefaultUserAgentProvider({ serviceId: clientSharedValues.serviceId, clientVersion: package_default3.version }),
    maxAttempts: config9?.maxAttempts ?? loadConfig(NODE_MAX_ATTEMPT_CONFIG_OPTIONS),
    region: config9?.region ?? loadConfig(NODE_REGION_CONFIG_OPTIONS, NODE_REGION_CONFIG_FILE_OPTIONS),
    requestHandler: NodeHttpHandler.create(config9?.requestHandler ?? defaultConfigProvider),
    retryMode: config9?.retryMode ?? loadConfig({
      ...NODE_RETRY_MODE_CONFIG_OPTIONS,
      default: async () => (await defaultConfigProvider()).retryMode || DEFAULT_RETRY_MODE
    }),
    sha256: config9?.sha256 ?? Hash.bind(null, "sha256"),
    streamCollector: config9?.streamCollector ?? streamCollector,
    useDualstackEndpoint: config9?.useDualstackEndpoint ?? loadConfig(NODE_USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS),
    useFipsEndpoint: config9?.useFipsEndpoint ?? loadConfig(NODE_USE_FIPS_ENDPOINT_CONFIG_OPTIONS),
    userAgentAppId: config9?.userAgentAppId ?? loadConfig(NODE_APP_ID_CONFIG_OPTIONS)
  };
};
var init_runtimeConfig2 = __esm2(() => {
  init_package5();
  import_core23 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es41();
  init_dist_es24();
  init_dist_es42();
  init_dist_es35();
  init_dist_es29();
  init_dist_es18();
  init_dist_es43();
  init_dist_es34();
  init_runtimeConfig_shared2();
  init_dist_es12();
  init_dist_es44();
  init_dist_es12();
});
var getHttpAuthExtensionConfiguration2 = (runtimeConfig) => {
  const _httpAuthSchemes = runtimeConfig.httpAuthSchemes;
  let _httpAuthSchemeProvider = runtimeConfig.httpAuthSchemeProvider;
  let _credentials = runtimeConfig.credentials;
  return {
    setHttpAuthScheme(httpAuthScheme) {
      const index = _httpAuthSchemes.findIndex((scheme) => scheme.schemeId === httpAuthScheme.schemeId);
      if (index === -1) {
        _httpAuthSchemes.push(httpAuthScheme);
      } else {
        _httpAuthSchemes.splice(index, 1, httpAuthScheme);
      }
    },
    httpAuthSchemes() {
      return _httpAuthSchemes;
    },
    setHttpAuthSchemeProvider(httpAuthSchemeProvider) {
      _httpAuthSchemeProvider = httpAuthSchemeProvider;
    },
    httpAuthSchemeProvider() {
      return _httpAuthSchemeProvider;
    },
    setCredentials(credentials) {
      _credentials = credentials;
    },
    credentials() {
      return _credentials;
    }
  };
};
var resolveHttpAuthRuntimeConfig2 = (config9) => {
  return {
    httpAuthSchemes: config9.httpAuthSchemes(),
    httpAuthSchemeProvider: config9.httpAuthSchemeProvider(),
    credentials: config9.credentials()
  };
};
var asPartial2 = (t4) => t4;
var resolveRuntimeExtensions2 = (runtimeConfig, extensions4) => {
  const extensionConfiguration = {
    ...asPartial2(getAwsRegionExtensionConfiguration(runtimeConfig)),
    ...asPartial2(getDefaultExtensionConfiguration(runtimeConfig)),
    ...asPartial2(getHttpHandlerExtensionConfiguration(runtimeConfig)),
    ...asPartial2(getHttpAuthExtensionConfiguration2(runtimeConfig))
  };
  extensions4.forEach((extension2) => extension2.configure(extensionConfiguration));
  return {
    ...runtimeConfig,
    ...resolveAwsRegionExtensionConfiguration(extensionConfiguration),
    ...resolveDefaultRuntimeConfig(extensionConfiguration),
    ...resolveHttpHandlerRuntimeConfig(extensionConfiguration),
    ...resolveHttpAuthRuntimeConfig2(extensionConfiguration)
  };
};
var init_runtimeExtensions2 = __esm2(() => {
  init_dist_es45();
  init_dist_es();
  init_dist_es12();
});
var import_core24;
var SSOClient;
var init_SSOClient = __esm2(() => {
  init_dist_es8();
  init_dist_es9();
  init_dist_es10();
  init_dist_es23();
  init_dist_es24();
  import_core24 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es26();
  init_dist_es32();
  init_dist_es35();
  init_dist_es12();
  init_httpAuthSchemeProvider3();
  init_EndpointParameters3();
  init_runtimeConfig2();
  init_runtimeExtensions2();
  SSOClient = class SSOClient2 extends Client {
    constructor(...[configuration]) {
      const _config_0 = getRuntimeConfig4(configuration || {});
      const _config_1 = resolveClientEndpointParameters3(_config_0);
      const _config_2 = resolveUserAgentConfig(_config_1);
      const _config_3 = resolveRetryConfig(_config_2);
      const _config_4 = resolveRegionConfig(_config_3);
      const _config_5 = resolveHostHeaderConfig(_config_4);
      const _config_6 = resolveEndpointConfig(_config_5);
      const _config_7 = resolveHttpAuthSchemeConfig3(_config_6);
      const _config_8 = resolveRuntimeExtensions2(_config_7, configuration?.extensions || []);
      super(_config_8);
      this.config = _config_8;
      this.middlewareStack.use(getUserAgentPlugin(this.config));
      this.middlewareStack.use(getRetryPlugin(this.config));
      this.middlewareStack.use(getContentLengthPlugin(this.config));
      this.middlewareStack.use(getHostHeaderPlugin(this.config));
      this.middlewareStack.use(getLoggerPlugin(this.config));
      this.middlewareStack.use(getRecursionDetectionPlugin(this.config));
      this.middlewareStack.use(import_core24.getHttpAuthSchemeEndpointRuleSetPlugin(this.config, {
        httpAuthSchemeParametersProvider: defaultSSOHttpAuthSchemeParametersProvider,
        identityProviderConfigProvider: async (config9) => new import_core24.DefaultIdentityProviderConfig({
          "aws.auth#sigv4": config9.credentials
        })
      }));
      this.middlewareStack.use(import_core24.getHttpSigningPlugin(this.config));
    }
    destroy() {
      super.destroy();
    }
  };
});
var SSOServiceException;
var init_SSOServiceException = __esm2(() => {
  init_dist_es12();
  SSOServiceException = class SSOServiceException2 extends ServiceException {
    constructor(options3) {
      super(options3);
      Object.setPrototypeOf(this, SSOServiceException2.prototype);
    }
  };
});
var InvalidRequestException2;
var ResourceNotFoundException;
var TooManyRequestsException;
var UnauthorizedException;
var GetRoleCredentialsRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.accessToken && { accessToken: SENSITIVE_STRING }
});
var RoleCredentialsFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.secretAccessKey && { secretAccessKey: SENSITIVE_STRING },
  ...obj.sessionToken && { sessionToken: SENSITIVE_STRING }
});
var GetRoleCredentialsResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.roleCredentials && { roleCredentials: RoleCredentialsFilterSensitiveLog(obj.roleCredentials) }
});
var ListAccountRolesRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.accessToken && { accessToken: SENSITIVE_STRING }
});
var ListAccountsRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.accessToken && { accessToken: SENSITIVE_STRING }
});
var LogoutRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.accessToken && { accessToken: SENSITIVE_STRING }
});
var init_models_03 = __esm2(() => {
  init_dist_es12();
  init_SSOServiceException();
  InvalidRequestException2 = class InvalidRequestException22 extends SSOServiceException {
    constructor(opts) {
      super({
        name: "InvalidRequestException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidRequestException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidRequestException22.prototype);
    }
  };
  ResourceNotFoundException = class ResourceNotFoundException2 extends SSOServiceException {
    constructor(opts) {
      super({
        name: "ResourceNotFoundException",
        $fault: "client",
        ...opts
      });
      this.name = "ResourceNotFoundException";
      this.$fault = "client";
      Object.setPrototypeOf(this, ResourceNotFoundException2.prototype);
    }
  };
  TooManyRequestsException = class TooManyRequestsException2 extends SSOServiceException {
    constructor(opts) {
      super({
        name: "TooManyRequestsException",
        $fault: "client",
        ...opts
      });
      this.name = "TooManyRequestsException";
      this.$fault = "client";
      Object.setPrototypeOf(this, TooManyRequestsException2.prototype);
    }
  };
  UnauthorizedException = class UnauthorizedException2 extends SSOServiceException {
    constructor(opts) {
      super({
        name: "UnauthorizedException",
        $fault: "client",
        ...opts
      });
      this.name = "UnauthorizedException";
      this.$fault = "client";
      Object.setPrototypeOf(this, UnauthorizedException2.prototype);
    }
  };
});
var import_core25;
var import_core26;
var se_GetRoleCredentialsCommand = async (input, context) => {
  const b5 = import_core26.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xasbt]: input[_aT]
  });
  b5.bp("/federation/credentials");
  const query = map2({
    [_rn]: [, expectNonNull(input[_rN], `roleName`)],
    [_ai2]: [, expectNonNull(input[_aI], `accountId`)]
  });
  let body;
  b5.m("GET").h(headers).q(query).b(body);
  return b5.build();
};
var se_ListAccountRolesCommand = async (input, context) => {
  const b5 = import_core26.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xasbt]: input[_aT]
  });
  b5.bp("/assignment/roles");
  const query = map2({
    [_nt]: [, input[_nT]],
    [_mr]: [() => input.maxResults !== undefined, () => input[_mR].toString()],
    [_ai2]: [, expectNonNull(input[_aI], `accountId`)]
  });
  let body;
  b5.m("GET").h(headers).q(query).b(body);
  return b5.build();
};
var se_ListAccountsCommand = async (input, context) => {
  const b5 = import_core26.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xasbt]: input[_aT]
  });
  b5.bp("/assignment/accounts");
  const query = map2({
    [_nt]: [, input[_nT]],
    [_mr]: [() => input.maxResults !== undefined, () => input[_mR].toString()]
  });
  let body;
  b5.m("GET").h(headers).q(query).b(body);
  return b5.build();
};
var se_LogoutCommand = async (input, context) => {
  const b5 = import_core26.requestBuilder(input, context);
  const headers = map2({}, isSerializableHeaderValue, {
    [_xasbt]: input[_aT]
  });
  b5.bp("/logout");
  let body;
  b5.m("POST").h(headers).b(body);
  return b5.build();
};
var de_GetRoleCredentialsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError3(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata4(output)
  });
  const data2 = expectNonNull(expectObject(await import_core25.parseJsonBody(output.body, context)), "body");
  const doc = take(data2, {
    roleCredentials: _json
  });
  Object.assign(contents, doc);
  return contents;
};
var de_ListAccountRolesCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError3(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata4(output)
  });
  const data2 = expectNonNull(expectObject(await import_core25.parseJsonBody(output.body, context)), "body");
  const doc = take(data2, {
    nextToken: expectString,
    roleList: _json
  });
  Object.assign(contents, doc);
  return contents;
};
var de_ListAccountsCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError3(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata4(output)
  });
  const data2 = expectNonNull(expectObject(await import_core25.parseJsonBody(output.body, context)), "body");
  const doc = take(data2, {
    accountList: _json,
    nextToken: expectString
  });
  Object.assign(contents, doc);
  return contents;
};
var de_LogoutCommand = async (output, context) => {
  if (output.statusCode !== 200 && output.statusCode >= 300) {
    return de_CommandError3(output, context);
  }
  const contents = map2({
    $metadata: deserializeMetadata4(output)
  });
  await import_protocols.collectBody(output.body, context);
  return contents;
};
var de_CommandError3 = async (output, context) => {
  const parsedOutput = {
    ...output,
    body: await import_core25.parseJsonErrorBody(output.body, context)
  };
  const errorCode = import_core25.loadRestJsonErrorCode(output, parsedOutput.body);
  switch (errorCode) {
    case "InvalidRequestException":
    case "com.amazonaws.sso#InvalidRequestException":
      throw await de_InvalidRequestExceptionRes2(parsedOutput, context);
    case "ResourceNotFoundException":
    case "com.amazonaws.sso#ResourceNotFoundException":
      throw await de_ResourceNotFoundExceptionRes(parsedOutput, context);
    case "TooManyRequestsException":
    case "com.amazonaws.sso#TooManyRequestsException":
      throw await de_TooManyRequestsExceptionRes(parsedOutput, context);
    case "UnauthorizedException":
    case "com.amazonaws.sso#UnauthorizedException":
      throw await de_UnauthorizedExceptionRes(parsedOutput, context);
    default:
      const parsedBody = parsedOutput.body;
      return throwDefaultError4({
        output,
        parsedBody,
        errorCode
      });
  }
};
var throwDefaultError4;
var de_InvalidRequestExceptionRes2 = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    message: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new InvalidRequestException2({
    $metadata: deserializeMetadata4(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_ResourceNotFoundExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    message: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new ResourceNotFoundException({
    $metadata: deserializeMetadata4(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_TooManyRequestsExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    message: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new TooManyRequestsException({
    $metadata: deserializeMetadata4(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var de_UnauthorizedExceptionRes = async (parsedOutput, context) => {
  const contents = map2({});
  const data2 = parsedOutput.body;
  const doc = take(data2, {
    message: expectString
  });
  Object.assign(contents, doc);
  const exception2 = new UnauthorizedException({
    $metadata: deserializeMetadata4(parsedOutput),
    ...contents
  });
  return decorateServiceException(exception2, parsedOutput.body);
};
var deserializeMetadata4 = (output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
});
var _aI = "accountId";
var _aT = "accessToken";
var _ai2 = "account_id";
var _mR = "maxResults";
var _mr = "max_result";
var _nT = "nextToken";
var _nt = "next_token";
var _rN = "roleName";
var _rn = "role_name";
var _xasbt = "x-amz-sso_bearer_token";
var init_Aws_restJson12 = __esm2(() => {
  import_core25 = __toESM3(require_dist_cjs20(), 1);
  import_core26 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es12();
  init_models_03();
  init_SSOServiceException();
  throwDefaultError4 = withBaseException(SSOServiceException);
});
var GetRoleCredentialsCommand;
var init_GetRoleCredentialsCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters3();
  init_models_03();
  init_Aws_restJson12();
  GetRoleCredentialsCommand = class GetRoleCredentialsCommand2 extends Command2.classBuilder().ep(commonParams3).m(function(Command22, cs2, config9, o4) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("SWBPortalService", "GetRoleCredentials", {}).n("SSOClient", "GetRoleCredentialsCommand").f(GetRoleCredentialsRequestFilterSensitiveLog, GetRoleCredentialsResponseFilterSensitiveLog).ser(se_GetRoleCredentialsCommand).de(de_GetRoleCredentialsCommand).build() {
  };
});
var ListAccountRolesCommand;
var init_ListAccountRolesCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters3();
  init_models_03();
  init_Aws_restJson12();
  ListAccountRolesCommand = class ListAccountRolesCommand2 extends Command2.classBuilder().ep(commonParams3).m(function(Command22, cs2, config9, o4) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("SWBPortalService", "ListAccountRoles", {}).n("SSOClient", "ListAccountRolesCommand").f(ListAccountRolesRequestFilterSensitiveLog, undefined).ser(se_ListAccountRolesCommand).de(de_ListAccountRolesCommand).build() {
  };
});
var ListAccountsCommand;
var init_ListAccountsCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters3();
  init_models_03();
  init_Aws_restJson12();
  ListAccountsCommand = class ListAccountsCommand2 extends Command2.classBuilder().ep(commonParams3).m(function(Command22, cs2, config9, o4) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("SWBPortalService", "ListAccounts", {}).n("SSOClient", "ListAccountsCommand").f(ListAccountsRequestFilterSensitiveLog, undefined).ser(se_ListAccountsCommand).de(de_ListAccountsCommand).build() {
  };
});
var LogoutCommand;
var init_LogoutCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters3();
  init_models_03();
  init_Aws_restJson12();
  LogoutCommand = class LogoutCommand2 extends Command2.classBuilder().ep(commonParams3).m(function(Command22, cs2, config9, o4) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("SWBPortalService", "Logout", {}).n("SSOClient", "LogoutCommand").f(LogoutRequestFilterSensitiveLog, undefined).ser(se_LogoutCommand).de(de_LogoutCommand).build() {
  };
});
var commands3;
var SSO;
var init_SSO = __esm2(() => {
  init_dist_es12();
  init_GetRoleCredentialsCommand();
  init_ListAccountRolesCommand();
  init_ListAccountsCommand();
  init_LogoutCommand();
  init_SSOClient();
  commands3 = {
    GetRoleCredentialsCommand,
    ListAccountRolesCommand,
    ListAccountsCommand,
    LogoutCommand
  };
  SSO = class SSO2 extends SSOClient {
  };
  createAggregatedClient(commands3, SSO);
});
var init_commands2 = __esm2(() => {
  init_GetRoleCredentialsCommand();
  init_ListAccountRolesCommand();
  init_ListAccountsCommand();
  init_LogoutCommand();
});
var init_Interfaces = () => {
};
var import_core27;
var paginateListAccountRoles;
var init_ListAccountRolesPaginator = __esm2(() => {
  import_core27 = __toESM3(require_dist_cjs15(), 1);
  init_ListAccountRolesCommand();
  init_SSOClient();
  paginateListAccountRoles = import_core27.createPaginator(SSOClient, ListAccountRolesCommand, "nextToken", "nextToken", "maxResults");
});
var import_core28;
var paginateListAccounts;
var init_ListAccountsPaginator = __esm2(() => {
  import_core28 = __toESM3(require_dist_cjs15(), 1);
  init_ListAccountsCommand();
  init_SSOClient();
  paginateListAccounts = import_core28.createPaginator(SSOClient, ListAccountsCommand, "nextToken", "nextToken", "maxResults");
});
var init_pagination = __esm2(() => {
  init_Interfaces();
  init_ListAccountRolesPaginator();
  init_ListAccountsPaginator();
});
var init_models2 = __esm2(() => {
  init_models_03();
});
var init_dist_es48 = __esm2(() => {
  init_SSOClient();
  init_SSO();
  init_commands2();
  init_pagination();
  init_models2();
});
var exports_loadSso = {};
__export3(exports_loadSso, {
  SSOClient: () => SSOClient,
  GetRoleCredentialsCommand: () => GetRoleCredentialsCommand
});
var init_loadSso = __esm2(() => {
  init_dist_es48();
});
var import_client3;
var SHOULD_FAIL_CREDENTIAL_CHAIN = false;
var resolveSSOCredentials = async ({ ssoStartUrl, ssoSession, ssoAccountId, ssoRegion, ssoRoleName, ssoClient, clientConfig, profile, logger: logger3 }) => {
  let token;
  const refreshMessage = `To refresh this SSO session run aws sso login with the corresponding profile.`;
  if (ssoSession) {
    try {
      const _token = await fromSso({ profile })();
      token = {
        accessToken: _token.token,
        expiresAt: new Date(_token.expiration).toISOString()
      };
    } catch (e4) {
      throw new CredentialsProviderError(e4.message, {
        tryNextLink: SHOULD_FAIL_CREDENTIAL_CHAIN,
        logger: logger3
      });
    }
  } else {
    try {
      token = await getSSOTokenFromFile(ssoStartUrl);
    } catch (e4) {
      throw new CredentialsProviderError(`The SSO session associated with this profile is invalid. ${refreshMessage}`, {
        tryNextLink: SHOULD_FAIL_CREDENTIAL_CHAIN,
        logger: logger3
      });
    }
  }
  if (new Date(token.expiresAt).getTime() - Date.now() <= 0) {
    throw new CredentialsProviderError(`The SSO session associated with this profile has expired. ${refreshMessage}`, {
      tryNextLink: SHOULD_FAIL_CREDENTIAL_CHAIN,
      logger: logger3
    });
  }
  const { accessToken } = token;
  const { SSOClient: SSOClient3, GetRoleCredentialsCommand: GetRoleCredentialsCommand3 } = await Promise.resolve().then(() => (init_loadSso(), exports_loadSso));
  const sso = ssoClient || new SSOClient3(Object.assign({}, clientConfig ?? {}, {
    region: clientConfig?.region ?? ssoRegion
  }));
  let ssoResp;
  try {
    ssoResp = await sso.send(new GetRoleCredentialsCommand3({
      accountId: ssoAccountId,
      roleName: ssoRoleName,
      accessToken
    }));
  } catch (e4) {
    throw new CredentialsProviderError(e4, {
      tryNextLink: SHOULD_FAIL_CREDENTIAL_CHAIN,
      logger: logger3
    });
  }
  const { roleCredentials: { accessKeyId, secretAccessKey, sessionToken, expiration, credentialScope, accountId } = {} } = ssoResp;
  if (!accessKeyId || !secretAccessKey || !sessionToken || !expiration) {
    throw new CredentialsProviderError("SSO returns an invalid temporary credential.", {
      tryNextLink: SHOULD_FAIL_CREDENTIAL_CHAIN,
      logger: logger3
    });
  }
  const credentials = {
    accessKeyId,
    secretAccessKey,
    sessionToken,
    expiration: new Date(expiration),
    ...credentialScope && { credentialScope },
    ...accountId && { accountId }
  };
  if (ssoSession) {
    import_client3.setCredentialFeature(credentials, "CREDENTIALS_SSO", "s");
  } else {
    import_client3.setCredentialFeature(credentials, "CREDENTIALS_SSO_LEGACY", "u");
  }
  return credentials;
};
var init_resolveSSOCredentials = __esm2(() => {
  import_client3 = __toESM3(require_client4(), 1);
  init_dist_es47();
  init_dist_es27();
  init_dist_es28();
});
var validateSsoProfile = (profile, logger3) => {
  const { sso_start_url, sso_account_id, sso_region, sso_role_name } = profile;
  if (!sso_start_url || !sso_account_id || !sso_region || !sso_role_name) {
    throw new CredentialsProviderError(`Profile is configured with invalid SSO credentials. Required parameters "sso_account_id", "sso_region", "sso_role_name", "sso_start_url". Got ${Object.keys(profile).join(", ")}\nReference: https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html`, { tryNextLink: false, logger: logger3 });
  }
  return profile;
};
var init_validateSsoProfile = __esm2(() => {
  init_dist_es27();
});
var fromSSO = (init3 = {}) => async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-sso - fromSSO");
  const { ssoStartUrl, ssoAccountId, ssoRegion, ssoRoleName, ssoSession } = init3;
  const { ssoClient } = init3;
  const profileName = getProfileName(init3);
  if (!ssoStartUrl && !ssoAccountId && !ssoRegion && !ssoRoleName && !ssoSession) {
    const profiles = await parseKnownFiles(init3);
    const profile = profiles[profileName];
    if (!profile) {
      throw new CredentialsProviderError(`Profile ${profileName} was not found.`, { logger: init3.logger });
    }
    if (!isSsoProfile(profile)) {
      throw new CredentialsProviderError(`Profile ${profileName} is not configured with SSO credentials.`, {
        logger: init3.logger
      });
    }
    if (profile?.sso_session) {
      const ssoSessions = await loadSsoSessionData(init3);
      const session = ssoSessions[profile.sso_session];
      const conflictMsg = ` configurations in profile ${profileName} and sso-session ${profile.sso_session}`;
      if (ssoRegion && ssoRegion !== session.sso_region) {
        throw new CredentialsProviderError(`Conflicting SSO region` + conflictMsg, {
          tryNextLink: false,
          logger: init3.logger
        });
      }
      if (ssoStartUrl && ssoStartUrl !== session.sso_start_url) {
        throw new CredentialsProviderError(`Conflicting SSO start_url` + conflictMsg, {
          tryNextLink: false,
          logger: init3.logger
        });
      }
      profile.sso_region = session.sso_region;
      profile.sso_start_url = session.sso_start_url;
    }
    const { sso_start_url, sso_account_id, sso_region, sso_role_name, sso_session } = validateSsoProfile(profile, init3.logger);
    return resolveSSOCredentials({
      ssoStartUrl: sso_start_url,
      ssoSession: sso_session,
      ssoAccountId: sso_account_id,
      ssoRegion: sso_region,
      ssoRoleName: sso_role_name,
      ssoClient,
      clientConfig: init3.clientConfig,
      profile: profileName
    });
  } else if (!ssoStartUrl || !ssoAccountId || !ssoRegion || !ssoRoleName) {
    throw new CredentialsProviderError('Incomplete configuration. The fromSSO() argument hash must include "ssoStartUrl", "ssoAccountId", "ssoRegion", "ssoRoleName"', { tryNextLink: false, logger: init3.logger });
  } else {
    return resolveSSOCredentials({
      ssoStartUrl,
      ssoSession,
      ssoAccountId,
      ssoRegion,
      ssoRoleName,
      ssoClient,
      clientConfig: init3.clientConfig,
      profile: profileName
    });
  }
};
var init_fromSSO = __esm2(() => {
  init_dist_es27();
  init_dist_es28();
  init_resolveSSOCredentials();
  init_validateSsoProfile();
});
var init_types13 = () => {
};
var exports_dist_es5 = {};
__export3(exports_dist_es5, {
  validateSsoProfile: () => validateSsoProfile,
  isSsoProfile: () => isSsoProfile,
  fromSSO: () => fromSSO
});
var init_dist_es49 = __esm2(() => {
  init_fromSSO();
  init_types13();
  init_validateSsoProfile();
});
var import_client4;
var resolveCredentialSource = (credentialSource, profileName, logger3) => {
  const sourceProvidersMap = {
    EcsContainer: async (options3) => {
      const { fromHttp: fromHttp2 } = await Promise.resolve().then(() => (init_dist_es40(), exports_dist_es3));
      const { fromContainerMetadata: fromContainerMetadata3 } = await Promise.resolve().then(() => (init_dist_es39(), exports_dist_es2));
      logger3?.debug("@aws-sdk/credential-provider-ini - credential_source is EcsContainer");
      return async () => chain(fromHttp2(options3 ?? {}), fromContainerMetadata3(options3))().then(setNamedProvider);
    },
    Ec2InstanceMetadata: async (options3) => {
      logger3?.debug("@aws-sdk/credential-provider-ini - credential_source is Ec2InstanceMetadata");
      const { fromInstanceMetadata: fromInstanceMetadata3 } = await Promise.resolve().then(() => (init_dist_es39(), exports_dist_es2));
      return async () => fromInstanceMetadata3(options3)().then(setNamedProvider);
    },
    Environment: async (options3) => {
      logger3?.debug("@aws-sdk/credential-provider-ini - credential_source is Environment");
      const { fromEnv: fromEnv4 } = await Promise.resolve().then(() => (init_dist_es38(), exports_dist_es));
      return async () => fromEnv4(options3)().then(setNamedProvider);
    }
  };
  if (credentialSource in sourceProvidersMap) {
    return sourceProvidersMap[credentialSource];
  } else {
    throw new CredentialsProviderError(`Unsupported credential source in profile ${profileName}. Got ${credentialSource}, expected EcsContainer or Ec2InstanceMetadata or Environment.`, { logger: logger3 });
  }
};
var setNamedProvider = (creds) => import_client4.setCredentialFeature(creds, "CREDENTIALS_PROFILE_NAMED_PROVIDER", "p");
var init_resolveCredentialSource = __esm2(() => {
  import_client4 = __toESM3(require_client4(), 1);
  init_dist_es27();
});
function createAwsAuthSigv4HttpAuthOption4(authParameters) {
  return {
    schemeId: "aws.auth#sigv4",
    signingProperties: {
      name: "sts",
      region: authParameters.region
    },
    propertiesExtractor: (config9, context) => ({
      signingProperties: {
        config: config9,
        context
      }
    })
  };
}
function createSmithyApiNoAuthHttpAuthOption3(authParameters) {
  return {
    schemeId: "smithy.api#noAuth"
  };
}
var import_core29;
var import_util_middleware12;
var defaultSTSHttpAuthSchemeParametersProvider = async (config9, context, input) => {
  return {
    operation: import_util_middleware12.getSmithyContext(context).operation,
    region: await import_util_middleware12.normalizeProvider(config9.region)() || (() => {
      throw new Error("expected `region` to be configured for `aws.auth#sigv4`");
    })()
  };
};
var defaultSTSHttpAuthSchemeProvider = (authParameters) => {
  const options3 = [];
  switch (authParameters.operation) {
    case "AssumeRoleWithSAML": {
      options3.push(createSmithyApiNoAuthHttpAuthOption3(authParameters));
      break;
    }
    case "AssumeRoleWithWebIdentity": {
      options3.push(createSmithyApiNoAuthHttpAuthOption3(authParameters));
      break;
    }
    default: {
      options3.push(createAwsAuthSigv4HttpAuthOption4(authParameters));
    }
  }
  return options3;
};
var resolveStsAuthConfig = (input) => ({
  ...input,
  stsClientCtor: STSClient
});
var resolveHttpAuthSchemeConfig4 = (config9) => {
  const config_0 = resolveStsAuthConfig(config9);
  const config_1 = import_core29.resolveAwsSdkSigV4Config(config_0);
  return {
    ...config_1
  };
};
var init_httpAuthSchemeProvider4 = __esm2(() => {
  import_core29 = __toESM3(require_dist_cjs20(), 1);
  import_util_middleware12 = __toESM3(require_dist_cjs3(), 1);
  init_STSClient();
});
var resolveClientEndpointParameters4 = (options3) => {
  return {
    ...options3,
    useDualstackEndpoint: options3.useDualstackEndpoint ?? false,
    useFipsEndpoint: options3.useFipsEndpoint ?? false,
    useGlobalEndpoint: options3.useGlobalEndpoint ?? false,
    defaultSigningName: "sts"
  };
};
var commonParams4;
var init_EndpointParameters4 = __esm2(() => {
  commonParams4 = {
    UseGlobalEndpoint: { type: "builtInParams", name: "useGlobalEndpoint" },
    UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
    Endpoint: { type: "builtInParams", name: "endpoint" },
    Region: { type: "builtInParams", name: "region" },
    UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" }
  };
});
var package_default4;
var init_package6 = __esm2(() => {
  package_default4 = {
    name: "@aws-sdk/client-sts",
    description: "AWS SDK for JavaScript Sts Client for Node.js, Browser and React Native",
    version: "3.679.0",
    scripts: {
      build: "concurrently 'yarn:build:cjs' 'yarn:build:es' 'yarn:build:types'",
      "build:cjs": "node ../../scripts/compilation/inline client-sts",
      "build:es": "tsc -p tsconfig.es.json",
      "build:include:deps": "lerna run --scope $npm_package_name --include-dependencies build",
      "build:types": "rimraf ./dist-types tsconfig.types.tsbuildinfo && tsc -p tsconfig.types.json",
      "build:types:downlevel": "downlevel-dts dist-types dist-types/ts3.4",
      clean: "rimraf ./dist-* && rimraf *.tsbuildinfo",
      "extract:docs": "api-extractor run --local",
      "generate:client": "node ../../scripts/generate-clients/single-service --solo sts",
      test: "vitest run",
      "test:watch": "vitest watch"
    },
    main: "./dist-cjs/index.js",
    types: "./dist-types/index.d.ts",
    module: "./dist-es/index.js",
    sideEffects: false,
    dependencies: {
      "@aws-crypto/sha256-browser": "5.2.0",
      "@aws-crypto/sha256-js": "5.2.0",
      "@aws-sdk/client-sso-oidc": "3.679.0",
      "@aws-sdk/core": "3.679.0",
      "@aws-sdk/credential-provider-node": "3.679.0",
      "@aws-sdk/middleware-host-header": "3.679.0",
      "@aws-sdk/middleware-logger": "3.679.0",
      "@aws-sdk/middleware-recursion-detection": "3.679.0",
      "@aws-sdk/middleware-user-agent": "3.679.0",
      "@aws-sdk/region-config-resolver": "3.679.0",
      "@aws-sdk/types": "3.679.0",
      "@aws-sdk/util-endpoints": "3.679.0",
      "@aws-sdk/util-user-agent-browser": "3.679.0",
      "@aws-sdk/util-user-agent-node": "3.679.0",
      "@smithy/config-resolver": "^3.0.9",
      "@smithy/core": "^2.4.8",
      "@smithy/fetch-http-handler": "^3.2.9",
      "@smithy/hash-node": "^3.0.7",
      "@smithy/invalid-dependency": "^3.0.7",
      "@smithy/middleware-content-length": "^3.0.9",
      "@smithy/middleware-endpoint": "^3.1.4",
      "@smithy/middleware-retry": "^3.0.23",
      "@smithy/middleware-serde": "^3.0.7",
      "@smithy/middleware-stack": "^3.0.7",
      "@smithy/node-config-provider": "^3.1.8",
      "@smithy/node-http-handler": "^3.2.4",
      "@smithy/protocol-http": "^4.1.4",
      "@smithy/smithy-client": "^3.4.0",
      "@smithy/types": "^3.5.0",
      "@smithy/url-parser": "^3.0.7",
      "@smithy/util-base64": "^3.0.0",
      "@smithy/util-body-length-browser": "^3.0.0",
      "@smithy/util-body-length-node": "^3.0.0",
      "@smithy/util-defaults-mode-browser": "^3.0.23",
      "@smithy/util-defaults-mode-node": "^3.0.23",
      "@smithy/util-endpoints": "^2.1.3",
      "@smithy/util-middleware": "^3.0.7",
      "@smithy/util-retry": "^3.0.7",
      "@smithy/util-utf8": "^3.0.0",
      tslib: "^2.6.2"
    },
    devDependencies: {
      "@tsconfig/node16": "16.1.3",
      "@types/node": "^16.18.96",
      concurrently: "7.0.0",
      "downlevel-dts": "0.10.1",
      rimraf: "3.0.2",
      typescript: "~4.9.5"
    },
    engines: {
      node: ">=16.0.0"
    },
    typesVersions: {
      "<4.0": {
        "dist-types/*": [
          "dist-types/ts3.4/*"
        ]
      }
    },
    files: [
      "dist-*/**"
    ],
    author: {
      name: "AWS SDK for JavaScript Team",
      url: "https://aws.amazon.com/javascript/"
    },
    license: "Apache-2.0",
    browser: {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.browser"
    },
    "react-native": {
      "./dist-es/runtimeConfig": "./dist-es/runtimeConfig.native"
    },
    homepage: "https://github.com/aws/aws-sdk-js-v3/tree/main/clients/client-sts",
    repository: {
      type: "git",
      url: "https://github.com/aws/aws-sdk-js-v3.git",
      directory: "clients/client-sts"
    }
  };
});
var F2 = "required";
var G3 = "type";
var H3 = "fn";
var I3 = "argv";
var J3 = "ref";
var a4 = false;
var b5 = true;
var c5 = "booleanEquals";
var d4 = "stringEquals";
var e4 = "sigv4";
var f5 = "sts";
var g5 = "us-east-1";
var h5 = "endpoint";
var i4 = "https://sts.{Region}.{PartitionResult#dnsSuffix}";
var j5 = "tree";
var k4 = "error";
var l5 = "getAttr";
var m5;
var n4;
var o4;
var p6;
var q5;
var r5;
var s8;
var t4;
var u4;
var v9;
var w5;
var x4;
var y2;
var z3;
var A2;
var B2;
var C3;
var D2;
var E2;
var _data4;
var ruleSet4;
var init_ruleset4 = __esm2(() => {
  m5 = { [F2]: false, [G3]: "String" };
  n4 = { [F2]: true, default: false, [G3]: "Boolean" };
  o4 = { [J3]: "Endpoint" };
  p6 = { [H3]: "isSet", [I3]: [{ [J3]: "Region" }] };
  q5 = { [J3]: "Region" };
  r5 = { [H3]: "aws.partition", [I3]: [q5], assign: "PartitionResult" };
  s8 = { [J3]: "UseFIPS" };
  t4 = { [J3]: "UseDualStack" };
  u4 = { url: "https://sts.amazonaws.com", properties: { authSchemes: [{ name: e4, signingName: f5, signingRegion: g5 }] }, headers: {} };
  v9 = {};
  w5 = { conditions: [{ [H3]: d4, [I3]: [q5, "aws-global"] }], [h5]: u4, [G3]: h5 };
  x4 = { [H3]: c5, [I3]: [s8, true] };
  y2 = { [H3]: c5, [I3]: [t4, true] };
  z3 = { [H3]: l5, [I3]: [{ [J3]: "PartitionResult" }, "supportsFIPS"] };
  A2 = { [J3]: "PartitionResult" };
  B2 = { [H3]: c5, [I3]: [true, { [H3]: l5, [I3]: [A2, "supportsDualStack"] }] };
  C3 = [{ [H3]: "isSet", [I3]: [o4] }];
  D2 = [x4];
  E2 = [y2];
  _data4 = { version: "1.0", parameters: { Region: m5, UseDualStack: n4, UseFIPS: n4, Endpoint: m5, UseGlobalEndpoint: n4 }, rules: [{ conditions: [{ [H3]: c5, [I3]: [{ [J3]: "UseGlobalEndpoint" }, b5] }, { [H3]: "not", [I3]: C3 }, p6, r5, { [H3]: c5, [I3]: [s8, a4] }, { [H3]: c5, [I3]: [t4, a4] }], rules: [{ conditions: [{ [H3]: d4, [I3]: [q5, "ap-northeast-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "ap-south-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "ap-southeast-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "ap-southeast-2"] }], endpoint: u4, [G3]: h5 }, w5, { conditions: [{ [H3]: d4, [I3]: [q5, "ca-central-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "eu-central-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "eu-north-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "eu-west-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "eu-west-2"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "eu-west-3"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "sa-east-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, g5] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "us-east-2"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "us-west-1"] }], endpoint: u4, [G3]: h5 }, { conditions: [{ [H3]: d4, [I3]: [q5, "us-west-2"] }], endpoint: u4, [G3]: h5 }, { endpoint: { url: i4, properties: { authSchemes: [{ name: e4, signingName: f5, signingRegion: "{Region}" }] }, headers: v9 }, [G3]: h5 }], [G3]: j5 }, { conditions: C3, rules: [{ conditions: D2, error: "Invalid Configuration: FIPS and custom endpoint are not supported", [G3]: k4 }, { conditions: E2, error: "Invalid Configuration: Dualstack and custom endpoint are not supported", [G3]: k4 }, { endpoint: { url: o4, properties: v9, headers: v9 }, [G3]: h5 }], [G3]: j5 }, { conditions: [p6], rules: [{ conditions: [r5], rules: [{ conditions: [x4, y2], rules: [{ conditions: [{ [H3]: c5, [I3]: [b5, z3] }, B2], rules: [{ endpoint: { url: "https://sts-fips.{Region}.{PartitionResult#dualStackDnsSuffix}", properties: v9, headers: v9 }, [G3]: h5 }], [G3]: j5 }, { error: "FIPS and DualStack are enabled, but this partition does not support one or both", [G3]: k4 }], [G3]: j5 }, { conditions: D2, rules: [{ conditions: [{ [H3]: c5, [I3]: [z3, b5] }], rules: [{ conditions: [{ [H3]: d4, [I3]: [{ [H3]: l5, [I3]: [A2, "name"] }, "aws-us-gov"] }], endpoint: { url: "https://sts.{Region}.amazonaws.com", properties: v9, headers: v9 }, [G3]: h5 }, { endpoint: { url: "https://sts-fips.{Region}.{PartitionResult#dnsSuffix}", properties: v9, headers: v9 }, [G3]: h5 }], [G3]: j5 }, { error: "FIPS is enabled but this partition does not support FIPS", [G3]: k4 }], [G3]: j5 }, { conditions: E2, rules: [{ conditions: [B2], rules: [{ endpoint: { url: "https://sts.{Region}.{PartitionResult#dualStackDnsSuffix}", properties: v9, headers: v9 }, [G3]: h5 }], [G3]: j5 }, { error: "DualStack is enabled but this partition does not support DualStack", [G3]: k4 }], [G3]: j5 }, w5, { endpoint: { url: i4, properties: v9, headers: v9 }, [G3]: h5 }], [G3]: j5 }], [G3]: j5 }, { error: "Invalid Configuration: Missing Region", [G3]: k4 }] };
  ruleSet4 = _data4;
});
var cache6;
var defaultEndpointResolver4 = (endpointParams, context = {}) => {
  return cache6.get(endpointParams, () => resolveEndpoint(ruleSet4, {
    endpointParams,
    logger: context.logger
  }));
};
var init_endpointResolver4 = __esm2(() => {
  init_dist_es22();
  init_dist_es21();
  init_ruleset4();
  cache6 = new EndpointCache({
    size: 50,
    params: ["Endpoint", "Region", "UseDualStack", "UseFIPS", "UseGlobalEndpoint"]
  });
  customEndpointFunctions.aws = awsEndpointFunctions;
});
var import_core30;
var import_core31;
var getRuntimeConfig5 = (config9) => {
  return {
    apiVersion: "2011-06-15",
    base64Decoder: config9?.base64Decoder ?? fromBase642,
    base64Encoder: config9?.base64Encoder ?? toBase643,
    disableHostPrefix: config9?.disableHostPrefix ?? false,
    endpointProvider: config9?.endpointProvider ?? defaultEndpointResolver4,
    extensions: config9?.extensions ?? [],
    httpAuthSchemeProvider: config9?.httpAuthSchemeProvider ?? defaultSTSHttpAuthSchemeProvider,
    httpAuthSchemes: config9?.httpAuthSchemes ?? [
      {
        schemeId: "aws.auth#sigv4",
        identityProvider: (ipc) => ipc.getIdentityProvider("aws.auth#sigv4"),
        signer: new import_core30.AwsSdkSigV4Signer
      },
      {
        schemeId: "smithy.api#noAuth",
        identityProvider: (ipc) => ipc.getIdentityProvider("smithy.api#noAuth") || (async () => ({})),
        signer: new import_core31.NoAuthSigner
      }
    ],
    logger: config9?.logger ?? new NoOpLogger,
    serviceId: config9?.serviceId ?? "STS",
    urlParser: config9?.urlParser ?? parseUrl,
    utf8Decoder: config9?.utf8Decoder ?? fromUtf84,
    utf8Encoder: config9?.utf8Encoder ?? toUtf82
  };
};
var init_runtimeConfig_shared3 = __esm2(() => {
  import_core30 = __toESM3(require_dist_cjs20(), 1);
  import_core31 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es12();
  init_dist_es30();
  init_dist_es16();
  init_dist_es6();
  init_httpAuthSchemeProvider4();
  init_endpointResolver4();
});
var import_core32;
var import_core33;
var getRuntimeConfig6 = (config9) => {
  emitWarningIfUnsupportedVersion(process.version);
  const defaultsMode = resolveDefaultsModeConfig(config9);
  const defaultConfigProvider = () => defaultsMode().then(loadConfigsForDefaultMode);
  const clientSharedValues = getRuntimeConfig5(config9);
  import_core32.emitWarningIfUnsupportedVersion(process.version);
  return {
    ...clientSharedValues,
    ...config9,
    runtime: "node",
    defaultsMode,
    bodyLengthChecker: config9?.bodyLengthChecker ?? calculateBodyLength,
    credentialDefaultProvider: config9?.credentialDefaultProvider ?? defaultProvider,
    defaultUserAgentProvider: config9?.defaultUserAgentProvider ?? createDefaultUserAgentProvider({ serviceId: clientSharedValues.serviceId, clientVersion: package_default4.version }),
    httpAuthSchemes: config9?.httpAuthSchemes ?? [
      {
        schemeId: "aws.auth#sigv4",
        identityProvider: (ipc) => ipc.getIdentityProvider("aws.auth#sigv4") || (async (idProps) => await defaultProvider(idProps?.__config || {})()),
        signer: new import_core32.AwsSdkSigV4Signer
      },
      {
        schemeId: "smithy.api#noAuth",
        identityProvider: (ipc) => ipc.getIdentityProvider("smithy.api#noAuth") || (async () => ({})),
        signer: new import_core33.NoAuthSigner
      }
    ],
    maxAttempts: config9?.maxAttempts ?? loadConfig(NODE_MAX_ATTEMPT_CONFIG_OPTIONS),
    region: config9?.region ?? loadConfig(NODE_REGION_CONFIG_OPTIONS, NODE_REGION_CONFIG_FILE_OPTIONS),
    requestHandler: NodeHttpHandler.create(config9?.requestHandler ?? defaultConfigProvider),
    retryMode: config9?.retryMode ?? loadConfig({
      ...NODE_RETRY_MODE_CONFIG_OPTIONS,
      default: async () => (await defaultConfigProvider()).retryMode || DEFAULT_RETRY_MODE
    }),
    sha256: config9?.sha256 ?? Hash.bind(null, "sha256"),
    streamCollector: config9?.streamCollector ?? streamCollector,
    useDualstackEndpoint: config9?.useDualstackEndpoint ?? loadConfig(NODE_USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS),
    useFipsEndpoint: config9?.useFipsEndpoint ?? loadConfig(NODE_USE_FIPS_ENDPOINT_CONFIG_OPTIONS),
    userAgentAppId: config9?.userAgentAppId ?? loadConfig(NODE_APP_ID_CONFIG_OPTIONS)
  };
};
var init_runtimeConfig3 = __esm2(() => {
  init_package6();
  import_core32 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es54();
  init_dist_es41();
  init_dist_es24();
  import_core33 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es42();
  init_dist_es35();
  init_dist_es29();
  init_dist_es18();
  init_dist_es43();
  init_dist_es34();
  init_runtimeConfig_shared3();
  init_dist_es12();
  init_dist_es44();
  init_dist_es12();
});
var getHttpAuthExtensionConfiguration3 = (runtimeConfig) => {
  const _httpAuthSchemes = runtimeConfig.httpAuthSchemes;
  let _httpAuthSchemeProvider = runtimeConfig.httpAuthSchemeProvider;
  let _credentials = runtimeConfig.credentials;
  return {
    setHttpAuthScheme(httpAuthScheme) {
      const index = _httpAuthSchemes.findIndex((scheme) => scheme.schemeId === httpAuthScheme.schemeId);
      if (index === -1) {
        _httpAuthSchemes.push(httpAuthScheme);
      } else {
        _httpAuthSchemes.splice(index, 1, httpAuthScheme);
      }
    },
    httpAuthSchemes() {
      return _httpAuthSchemes;
    },
    setHttpAuthSchemeProvider(httpAuthSchemeProvider) {
      _httpAuthSchemeProvider = httpAuthSchemeProvider;
    },
    httpAuthSchemeProvider() {
      return _httpAuthSchemeProvider;
    },
    setCredentials(credentials) {
      _credentials = credentials;
    },
    credentials() {
      return _credentials;
    }
  };
};
var resolveHttpAuthRuntimeConfig3 = (config9) => {
  return {
    httpAuthSchemes: config9.httpAuthSchemes(),
    httpAuthSchemeProvider: config9.httpAuthSchemeProvider(),
    credentials: config9.credentials()
  };
};
var asPartial3 = (t5) => t5;
var resolveRuntimeExtensions3 = (runtimeConfig, extensions4) => {
  const extensionConfiguration = {
    ...asPartial3(getAwsRegionExtensionConfiguration(runtimeConfig)),
    ...asPartial3(getDefaultExtensionConfiguration(runtimeConfig)),
    ...asPartial3(getHttpHandlerExtensionConfiguration(runtimeConfig)),
    ...asPartial3(getHttpAuthExtensionConfiguration3(runtimeConfig))
  };
  extensions4.forEach((extension2) => extension2.configure(extensionConfiguration));
  return {
    ...runtimeConfig,
    ...resolveAwsRegionExtensionConfiguration(extensionConfiguration),
    ...resolveDefaultRuntimeConfig(extensionConfiguration),
    ...resolveHttpHandlerRuntimeConfig(extensionConfiguration),
    ...resolveHttpAuthRuntimeConfig3(extensionConfiguration)
  };
};
var init_runtimeExtensions3 = __esm2(() => {
  init_dist_es45();
  init_dist_es();
  init_dist_es12();
});
var import_core34;
var STSClient;
var init_STSClient = __esm2(() => {
  init_dist_es8();
  init_dist_es9();
  init_dist_es10();
  init_dist_es23();
  init_dist_es24();
  import_core34 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es26();
  init_dist_es32();
  init_dist_es35();
  init_dist_es12();
  init_httpAuthSchemeProvider4();
  init_EndpointParameters4();
  init_runtimeConfig3();
  init_runtimeExtensions3();
  STSClient = class STSClient2 extends Client {
    constructor(...[configuration]) {
      const _config_0 = getRuntimeConfig6(configuration || {});
      const _config_1 = resolveClientEndpointParameters4(_config_0);
      const _config_2 = resolveUserAgentConfig(_config_1);
      const _config_3 = resolveRetryConfig(_config_2);
      const _config_4 = resolveRegionConfig(_config_3);
      const _config_5 = resolveHostHeaderConfig(_config_4);
      const _config_6 = resolveEndpointConfig(_config_5);
      const _config_7 = resolveHttpAuthSchemeConfig4(_config_6);
      const _config_8 = resolveRuntimeExtensions3(_config_7, configuration?.extensions || []);
      super(_config_8);
      this.config = _config_8;
      this.middlewareStack.use(getUserAgentPlugin(this.config));
      this.middlewareStack.use(getRetryPlugin(this.config));
      this.middlewareStack.use(getContentLengthPlugin(this.config));
      this.middlewareStack.use(getHostHeaderPlugin(this.config));
      this.middlewareStack.use(getLoggerPlugin(this.config));
      this.middlewareStack.use(getRecursionDetectionPlugin(this.config));
      this.middlewareStack.use(import_core34.getHttpAuthSchemeEndpointRuleSetPlugin(this.config, {
        httpAuthSchemeParametersProvider: defaultSTSHttpAuthSchemeParametersProvider,
        identityProviderConfigProvider: async (config9) => new import_core34.DefaultIdentityProviderConfig({
          "aws.auth#sigv4": config9.credentials
        })
      }));
      this.middlewareStack.use(import_core34.getHttpSigningPlugin(this.config));
    }
    destroy() {
      super.destroy();
    }
  };
});
var STSServiceException;
var init_STSServiceException = __esm2(() => {
  init_dist_es12();
  STSServiceException = class STSServiceException2 extends ServiceException {
    constructor(options3) {
      super(options3);
      Object.setPrototypeOf(this, STSServiceException2.prototype);
    }
  };
});
var ExpiredTokenException2;
var MalformedPolicyDocumentException;
var PackedPolicyTooLargeException;
var RegionDisabledException;
var IDPRejectedClaimException;
var InvalidIdentityTokenException;
var IDPCommunicationErrorException;
var InvalidAuthorizationMessageException;
var CredentialsFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SecretAccessKey && { SecretAccessKey: SENSITIVE_STRING }
});
var AssumeRoleResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Credentials && { Credentials: CredentialsFilterSensitiveLog(obj.Credentials) }
});
var AssumeRoleWithSAMLRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.SAMLAssertion && { SAMLAssertion: SENSITIVE_STRING }
});
var AssumeRoleWithSAMLResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Credentials && { Credentials: CredentialsFilterSensitiveLog(obj.Credentials) }
});
var AssumeRoleWithWebIdentityRequestFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.WebIdentityToken && { WebIdentityToken: SENSITIVE_STRING }
});
var AssumeRoleWithWebIdentityResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Credentials && { Credentials: CredentialsFilterSensitiveLog(obj.Credentials) }
});
var GetFederationTokenResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Credentials && { Credentials: CredentialsFilterSensitiveLog(obj.Credentials) }
});
var GetSessionTokenResponseFilterSensitiveLog = (obj) => ({
  ...obj,
  ...obj.Credentials && { Credentials: CredentialsFilterSensitiveLog(obj.Credentials) }
});
var init_models_04 = __esm2(() => {
  init_dist_es12();
  init_STSServiceException();
  ExpiredTokenException2 = class ExpiredTokenException22 extends STSServiceException {
    constructor(opts) {
      super({
        name: "ExpiredTokenException",
        $fault: "client",
        ...opts
      });
      this.name = "ExpiredTokenException";
      this.$fault = "client";
      Object.setPrototypeOf(this, ExpiredTokenException22.prototype);
    }
  };
  MalformedPolicyDocumentException = class MalformedPolicyDocumentException2 extends STSServiceException {
    constructor(opts) {
      super({
        name: "MalformedPolicyDocumentException",
        $fault: "client",
        ...opts
      });
      this.name = "MalformedPolicyDocumentException";
      this.$fault = "client";
      Object.setPrototypeOf(this, MalformedPolicyDocumentException2.prototype);
    }
  };
  PackedPolicyTooLargeException = class PackedPolicyTooLargeException2 extends STSServiceException {
    constructor(opts) {
      super({
        name: "PackedPolicyTooLargeException",
        $fault: "client",
        ...opts
      });
      this.name = "PackedPolicyTooLargeException";
      this.$fault = "client";
      Object.setPrototypeOf(this, PackedPolicyTooLargeException2.prototype);
    }
  };
  RegionDisabledException = class RegionDisabledException2 extends STSServiceException {
    constructor(opts) {
      super({
        name: "RegionDisabledException",
        $fault: "client",
        ...opts
      });
      this.name = "RegionDisabledException";
      this.$fault = "client";
      Object.setPrototypeOf(this, RegionDisabledException2.prototype);
    }
  };
  IDPRejectedClaimException = class IDPRejectedClaimException2 extends STSServiceException {
    constructor(opts) {
      super({
        name: "IDPRejectedClaimException",
        $fault: "client",
        ...opts
      });
      this.name = "IDPRejectedClaimException";
      this.$fault = "client";
      Object.setPrototypeOf(this, IDPRejectedClaimException2.prototype);
    }
  };
  InvalidIdentityTokenException = class InvalidIdentityTokenException2 extends STSServiceException {
    constructor(opts) {
      super({
        name: "InvalidIdentityTokenException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidIdentityTokenException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidIdentityTokenException2.prototype);
    }
  };
  IDPCommunicationErrorException = class IDPCommunicationErrorException2 extends STSServiceException {
    constructor(opts) {
      super({
        name: "IDPCommunicationErrorException",
        $fault: "client",
        ...opts
      });
      this.name = "IDPCommunicationErrorException";
      this.$fault = "client";
      Object.setPrototypeOf(this, IDPCommunicationErrorException2.prototype);
    }
  };
  InvalidAuthorizationMessageException = class InvalidAuthorizationMessageException2 extends STSServiceException {
    constructor(opts) {
      super({
        name: "InvalidAuthorizationMessageException",
        $fault: "client",
        ...opts
      });
      this.name = "InvalidAuthorizationMessageException";
      this.$fault = "client";
      Object.setPrototypeOf(this, InvalidAuthorizationMessageException2.prototype);
    }
  };
});
var import_core35;
var se_AssumeRoleCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_AssumeRoleRequest(input, context),
    [_A2]: _AR2,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var se_AssumeRoleWithSAMLCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_AssumeRoleWithSAMLRequest(input, context),
    [_A2]: _ARWSAML,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var se_AssumeRoleWithWebIdentityCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_AssumeRoleWithWebIdentityRequest(input, context),
    [_A2]: _ARWWI,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var se_DecodeAuthorizationMessageCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_DecodeAuthorizationMessageRequest(input, context),
    [_A2]: _DAM,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var se_GetAccessKeyInfoCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_GetAccessKeyInfoRequest(input, context),
    [_A2]: _GAKI,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var se_GetCallerIdentityCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_GetCallerIdentityRequest(input, context),
    [_A2]: _GCI,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var se_GetFederationTokenCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_GetFederationTokenRequest(input, context),
    [_A2]: _GFT,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var se_GetSessionTokenCommand = async (input, context) => {
  const headers = SHARED_HEADERS;
  let body;
  body = buildFormUrlencodedString({
    ...se_GetSessionTokenRequest(input, context),
    [_A2]: _GST,
    [_V2]: _22
  });
  return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
var de_AssumeRoleCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_AssumeRoleResponse(data2.AssumeRoleResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_AssumeRoleWithSAMLCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_AssumeRoleWithSAMLResponse(data2.AssumeRoleWithSAMLResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_AssumeRoleWithWebIdentityCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_AssumeRoleWithWebIdentityResponse(data2.AssumeRoleWithWebIdentityResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_DecodeAuthorizationMessageCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_DecodeAuthorizationMessageResponse(data2.DecodeAuthorizationMessageResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_GetAccessKeyInfoCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_GetAccessKeyInfoResponse(data2.GetAccessKeyInfoResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_GetCallerIdentityCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_GetCallerIdentityResponse(data2.GetCallerIdentityResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_GetFederationTokenCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_GetFederationTokenResponse(data2.GetFederationTokenResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_GetSessionTokenCommand = async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError4(output, context);
  }
  const data2 = await import_core35.parseXmlBody(output.body, context);
  let contents = {};
  contents = de_GetSessionTokenResponse(data2.GetSessionTokenResult, context);
  const response = {
    $metadata: deserializeMetadata5(output),
    ...contents
  };
  return response;
};
var de_CommandError4 = async (output, context) => {
  const parsedOutput = {
    ...output,
    body: await import_core35.parseXmlErrorBody(output.body, context)
  };
  const errorCode = loadQueryErrorCode(output, parsedOutput.body);
  switch (errorCode) {
    case "ExpiredTokenException":
    case "com.amazonaws.sts#ExpiredTokenException":
      throw await de_ExpiredTokenExceptionRes2(parsedOutput, context);
    case "MalformedPolicyDocument":
    case "com.amazonaws.sts#MalformedPolicyDocumentException":
      throw await de_MalformedPolicyDocumentExceptionRes(parsedOutput, context);
    case "PackedPolicyTooLarge":
    case "com.amazonaws.sts#PackedPolicyTooLargeException":
      throw await de_PackedPolicyTooLargeExceptionRes(parsedOutput, context);
    case "RegionDisabledException":
    case "com.amazonaws.sts#RegionDisabledException":
      throw await de_RegionDisabledExceptionRes(parsedOutput, context);
    case "IDPRejectedClaim":
    case "com.amazonaws.sts#IDPRejectedClaimException":
      throw await de_IDPRejectedClaimExceptionRes(parsedOutput, context);
    case "InvalidIdentityToken":
    case "com.amazonaws.sts#InvalidIdentityTokenException":
      throw await de_InvalidIdentityTokenExceptionRes(parsedOutput, context);
    case "IDPCommunicationError":
    case "com.amazonaws.sts#IDPCommunicationErrorException":
      throw await de_IDPCommunicationErrorExceptionRes(parsedOutput, context);
    case "InvalidAuthorizationMessageException":
    case "com.amazonaws.sts#InvalidAuthorizationMessageException":
      throw await de_InvalidAuthorizationMessageExceptionRes(parsedOutput, context);
    default:
      const parsedBody = parsedOutput.body;
      return throwDefaultError5({
        output,
        parsedBody: parsedBody.Error,
        errorCode
      });
  }
};
var de_ExpiredTokenExceptionRes2 = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_ExpiredTokenException(body.Error, context);
  const exception2 = new ExpiredTokenException2({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var de_IDPCommunicationErrorExceptionRes = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_IDPCommunicationErrorException(body.Error, context);
  const exception2 = new IDPCommunicationErrorException({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var de_IDPRejectedClaimExceptionRes = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_IDPRejectedClaimException(body.Error, context);
  const exception2 = new IDPRejectedClaimException({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var de_InvalidAuthorizationMessageExceptionRes = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_InvalidAuthorizationMessageException(body.Error, context);
  const exception2 = new InvalidAuthorizationMessageException({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var de_InvalidIdentityTokenExceptionRes = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_InvalidIdentityTokenException(body.Error, context);
  const exception2 = new InvalidIdentityTokenException({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var de_MalformedPolicyDocumentExceptionRes = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_MalformedPolicyDocumentException(body.Error, context);
  const exception2 = new MalformedPolicyDocumentException({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var de_PackedPolicyTooLargeExceptionRes = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_PackedPolicyTooLargeException(body.Error, context);
  const exception2 = new PackedPolicyTooLargeException({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var de_RegionDisabledExceptionRes = async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = de_RegionDisabledException(body.Error, context);
  const exception2 = new RegionDisabledException({
    $metadata: deserializeMetadata5(parsedOutput),
    ...deserialized
  });
  return decorateServiceException(exception2, body);
};
var se_AssumeRoleRequest = (input, context) => {
  const entries = {};
  if (input[_RA] != null) {
    entries[_RA] = input[_RA];
  }
  if (input[_RSN] != null) {
    entries[_RSN] = input[_RSN];
  }
  if (input[_PA] != null) {
    const memberEntries = se_policyDescriptorListType(input[_PA], context);
    if (input[_PA]?.length === 0) {
      entries.PolicyArns = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `PolicyArns.${key2}`;
      entries[loc] = value;
    });
  }
  if (input[_P2] != null) {
    entries[_P2] = input[_P2];
  }
  if (input[_DS] != null) {
    entries[_DS] = input[_DS];
  }
  if (input[_T2] != null) {
    const memberEntries = se_tagListType(input[_T2], context);
    if (input[_T2]?.length === 0) {
      entries.Tags = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `Tags.${key2}`;
      entries[loc] = value;
    });
  }
  if (input[_TTK] != null) {
    const memberEntries = se_tagKeyListType(input[_TTK], context);
    if (input[_TTK]?.length === 0) {
      entries.TransitiveTagKeys = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `TransitiveTagKeys.${key2}`;
      entries[loc] = value;
    });
  }
  if (input[_EI] != null) {
    entries[_EI] = input[_EI];
  }
  if (input[_SN] != null) {
    entries[_SN] = input[_SN];
  }
  if (input[_TC2] != null) {
    entries[_TC2] = input[_TC2];
  }
  if (input[_SI] != null) {
    entries[_SI] = input[_SI];
  }
  if (input[_PC2] != null) {
    const memberEntries = se_ProvidedContextsListType(input[_PC2], context);
    if (input[_PC2]?.length === 0) {
      entries.ProvidedContexts = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `ProvidedContexts.${key2}`;
      entries[loc] = value;
    });
  }
  return entries;
};
var se_AssumeRoleWithSAMLRequest = (input, context) => {
  const entries = {};
  if (input[_RA] != null) {
    entries[_RA] = input[_RA];
  }
  if (input[_PAr] != null) {
    entries[_PAr] = input[_PAr];
  }
  if (input[_SAMLA] != null) {
    entries[_SAMLA] = input[_SAMLA];
  }
  if (input[_PA] != null) {
    const memberEntries = se_policyDescriptorListType(input[_PA], context);
    if (input[_PA]?.length === 0) {
      entries.PolicyArns = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `PolicyArns.${key2}`;
      entries[loc] = value;
    });
  }
  if (input[_P2] != null) {
    entries[_P2] = input[_P2];
  }
  if (input[_DS] != null) {
    entries[_DS] = input[_DS];
  }
  return entries;
};
var se_AssumeRoleWithWebIdentityRequest = (input, context) => {
  const entries = {};
  if (input[_RA] != null) {
    entries[_RA] = input[_RA];
  }
  if (input[_RSN] != null) {
    entries[_RSN] = input[_RSN];
  }
  if (input[_WIT] != null) {
    entries[_WIT] = input[_WIT];
  }
  if (input[_PI2] != null) {
    entries[_PI2] = input[_PI2];
  }
  if (input[_PA] != null) {
    const memberEntries = se_policyDescriptorListType(input[_PA], context);
    if (input[_PA]?.length === 0) {
      entries.PolicyArns = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `PolicyArns.${key2}`;
      entries[loc] = value;
    });
  }
  if (input[_P2] != null) {
    entries[_P2] = input[_P2];
  }
  if (input[_DS] != null) {
    entries[_DS] = input[_DS];
  }
  return entries;
};
var se_DecodeAuthorizationMessageRequest = (input, context) => {
  const entries = {};
  if (input[_EM2] != null) {
    entries[_EM2] = input[_EM2];
  }
  return entries;
};
var se_GetAccessKeyInfoRequest = (input, context) => {
  const entries = {};
  if (input[_AKI2] != null) {
    entries[_AKI2] = input[_AKI2];
  }
  return entries;
};
var se_GetCallerIdentityRequest = (input, context) => {
  const entries = {};
  return entries;
};
var se_GetFederationTokenRequest = (input, context) => {
  const entries = {};
  if (input[_N2] != null) {
    entries[_N2] = input[_N2];
  }
  if (input[_P2] != null) {
    entries[_P2] = input[_P2];
  }
  if (input[_PA] != null) {
    const memberEntries = se_policyDescriptorListType(input[_PA], context);
    if (input[_PA]?.length === 0) {
      entries.PolicyArns = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `PolicyArns.${key2}`;
      entries[loc] = value;
    });
  }
  if (input[_DS] != null) {
    entries[_DS] = input[_DS];
  }
  if (input[_T2] != null) {
    const memberEntries = se_tagListType(input[_T2], context);
    if (input[_T2]?.length === 0) {
      entries.Tags = [];
    }
    Object.entries(memberEntries).forEach(([key2, value]) => {
      const loc = `Tags.${key2}`;
      entries[loc] = value;
    });
  }
  return entries;
};
var se_GetSessionTokenRequest = (input, context) => {
  const entries = {};
  if (input[_DS] != null) {
    entries[_DS] = input[_DS];
  }
  if (input[_SN] != null) {
    entries[_SN] = input[_SN];
  }
  if (input[_TC2] != null) {
    entries[_TC2] = input[_TC2];
  }
  return entries;
};
var se_policyDescriptorListType = (input, context) => {
  const entries = {};
  let counter = 1;
  for (const entry of input) {
    if (entry === null) {
      continue;
    }
    const memberEntries = se_PolicyDescriptorType(entry, context);
    Object.entries(memberEntries).forEach(([key2, value]) => {
      entries[`member.${counter}.${key2}`] = value;
    });
    counter++;
  }
  return entries;
};
var se_PolicyDescriptorType = (input, context) => {
  const entries = {};
  if (input[_a2] != null) {
    entries[_a2] = input[_a2];
  }
  return entries;
};
var se_ProvidedContext = (input, context) => {
  const entries = {};
  if (input[_PAro] != null) {
    entries[_PAro] = input[_PAro];
  }
  if (input[_CA2] != null) {
    entries[_CA2] = input[_CA2];
  }
  return entries;
};
var se_ProvidedContextsListType = (input, context) => {
  const entries = {};
  let counter = 1;
  for (const entry of input) {
    if (entry === null) {
      continue;
    }
    const memberEntries = se_ProvidedContext(entry, context);
    Object.entries(memberEntries).forEach(([key2, value]) => {
      entries[`member.${counter}.${key2}`] = value;
    });
    counter++;
  }
  return entries;
};
var se_Tag2 = (input, context) => {
  const entries = {};
  if (input[_K2] != null) {
    entries[_K2] = input[_K2];
  }
  if (input[_Va2] != null) {
    entries[_Va2] = input[_Va2];
  }
  return entries;
};
var se_tagKeyListType = (input, context) => {
  const entries = {};
  let counter = 1;
  for (const entry of input) {
    if (entry === null) {
      continue;
    }
    entries[`member.${counter}`] = entry;
    counter++;
  }
  return entries;
};
var se_tagListType = (input, context) => {
  const entries = {};
  let counter = 1;
  for (const entry of input) {
    if (entry === null) {
      continue;
    }
    const memberEntries = se_Tag2(entry, context);
    Object.entries(memberEntries).forEach(([key2, value]) => {
      entries[`member.${counter}.${key2}`] = value;
    });
    counter++;
  }
  return entries;
};
var de_AssumedRoleUser = (output, context) => {
  const contents = {};
  if (output[_ARI2] != null) {
    contents[_ARI2] = expectString(output[_ARI2]);
  }
  if (output[_Ar] != null) {
    contents[_Ar] = expectString(output[_Ar]);
  }
  return contents;
};
var de_AssumeRoleResponse = (output, context) => {
  const contents = {};
  if (output[_C2] != null) {
    contents[_C2] = de_Credentials(output[_C2], context);
  }
  if (output[_ARU] != null) {
    contents[_ARU] = de_AssumedRoleUser(output[_ARU], context);
  }
  if (output[_PPS] != null) {
    contents[_PPS] = strictParseInt32(output[_PPS]);
  }
  if (output[_SI] != null) {
    contents[_SI] = expectString(output[_SI]);
  }
  return contents;
};
var de_AssumeRoleWithSAMLResponse = (output, context) => {
  const contents = {};
  if (output[_C2] != null) {
    contents[_C2] = de_Credentials(output[_C2], context);
  }
  if (output[_ARU] != null) {
    contents[_ARU] = de_AssumedRoleUser(output[_ARU], context);
  }
  if (output[_PPS] != null) {
    contents[_PPS] = strictParseInt32(output[_PPS]);
  }
  if (output[_S2] != null) {
    contents[_S2] = expectString(output[_S2]);
  }
  if (output[_ST2] != null) {
    contents[_ST2] = expectString(output[_ST2]);
  }
  if (output[_I2] != null) {
    contents[_I2] = expectString(output[_I2]);
  }
  if (output[_Au] != null) {
    contents[_Au] = expectString(output[_Au]);
  }
  if (output[_NQ] != null) {
    contents[_NQ] = expectString(output[_NQ]);
  }
  if (output[_SI] != null) {
    contents[_SI] = expectString(output[_SI]);
  }
  return contents;
};
var de_AssumeRoleWithWebIdentityResponse = (output, context) => {
  const contents = {};
  if (output[_C2] != null) {
    contents[_C2] = de_Credentials(output[_C2], context);
  }
  if (output[_SFWIT] != null) {
    contents[_SFWIT] = expectString(output[_SFWIT]);
  }
  if (output[_ARU] != null) {
    contents[_ARU] = de_AssumedRoleUser(output[_ARU], context);
  }
  if (output[_PPS] != null) {
    contents[_PPS] = strictParseInt32(output[_PPS]);
  }
  if (output[_Pr2] != null) {
    contents[_Pr2] = expectString(output[_Pr2]);
  }
  if (output[_Au] != null) {
    contents[_Au] = expectString(output[_Au]);
  }
  if (output[_SI] != null) {
    contents[_SI] = expectString(output[_SI]);
  }
  return contents;
};
var de_Credentials = (output, context) => {
  const contents = {};
  if (output[_AKI2] != null) {
    contents[_AKI2] = expectString(output[_AKI2]);
  }
  if (output[_SAK2] != null) {
    contents[_SAK2] = expectString(output[_SAK2]);
  }
  if (output[_STe] != null) {
    contents[_STe] = expectString(output[_STe]);
  }
  if (output[_E2] != null) {
    contents[_E2] = expectNonNull(parseRfc3339DateTimeWithOffset(output[_E2]));
  }
  return contents;
};
var de_DecodeAuthorizationMessageResponse = (output, context) => {
  const contents = {};
  if (output[_DM2] != null) {
    contents[_DM2] = expectString(output[_DM2]);
  }
  return contents;
};
var de_ExpiredTokenException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var de_FederatedUser = (output, context) => {
  const contents = {};
  if (output[_FUI] != null) {
    contents[_FUI] = expectString(output[_FUI]);
  }
  if (output[_Ar] != null) {
    contents[_Ar] = expectString(output[_Ar]);
  }
  return contents;
};
var de_GetAccessKeyInfoResponse = (output, context) => {
  const contents = {};
  if (output[_Ac2] != null) {
    contents[_Ac2] = expectString(output[_Ac2]);
  }
  return contents;
};
var de_GetCallerIdentityResponse = (output, context) => {
  const contents = {};
  if (output[_UI2] != null) {
    contents[_UI2] = expectString(output[_UI2]);
  }
  if (output[_Ac2] != null) {
    contents[_Ac2] = expectString(output[_Ac2]);
  }
  if (output[_Ar] != null) {
    contents[_Ar] = expectString(output[_Ar]);
  }
  return contents;
};
var de_GetFederationTokenResponse = (output, context) => {
  const contents = {};
  if (output[_C2] != null) {
    contents[_C2] = de_Credentials(output[_C2], context);
  }
  if (output[_FU] != null) {
    contents[_FU] = de_FederatedUser(output[_FU], context);
  }
  if (output[_PPS] != null) {
    contents[_PPS] = strictParseInt32(output[_PPS]);
  }
  return contents;
};
var de_GetSessionTokenResponse = (output, context) => {
  const contents = {};
  if (output[_C2] != null) {
    contents[_C2] = de_Credentials(output[_C2], context);
  }
  return contents;
};
var de_IDPCommunicationErrorException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var de_IDPRejectedClaimException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var de_InvalidAuthorizationMessageException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var de_InvalidIdentityTokenException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var de_MalformedPolicyDocumentException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var de_PackedPolicyTooLargeException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var de_RegionDisabledException = (output, context) => {
  const contents = {};
  if (output[_m2] != null) {
    contents[_m2] = expectString(output[_m2]);
  }
  return contents;
};
var deserializeMetadata5 = (output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
});
var throwDefaultError5;
var buildHttpRpcRequest = async (context, headers, path5, resolvedHostname, body) => {
  const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
  const contents = {
    protocol,
    hostname,
    port,
    method: "POST",
    path: basePath.endsWith("/") ? basePath.slice(0, -1) + path5 : basePath + path5,
    headers
  };
  if (resolvedHostname !== undefined) {
    contents.hostname = resolvedHostname;
  }
  if (body !== undefined) {
    contents.body = body;
  }
  return new HttpRequest(contents);
};
var SHARED_HEADERS;
var _22 = "2011-06-15";
var _A2 = "Action";
var _AKI2 = "AccessKeyId";
var _AR2 = "AssumeRole";
var _ARI2 = "AssumedRoleId";
var _ARU = "AssumedRoleUser";
var _ARWSAML = "AssumeRoleWithSAML";
var _ARWWI = "AssumeRoleWithWebIdentity";
var _Ac2 = "Account";
var _Ar = "Arn";
var _Au = "Audience";
var _C2 = "Credentials";
var _CA2 = "ContextAssertion";
var _DAM = "DecodeAuthorizationMessage";
var _DM2 = "DecodedMessage";
var _DS = "DurationSeconds";
var _E2 = "Expiration";
var _EI = "ExternalId";
var _EM2 = "EncodedMessage";
var _FU = "FederatedUser";
var _FUI = "FederatedUserId";
var _GAKI = "GetAccessKeyInfo";
var _GCI = "GetCallerIdentity";
var _GFT = "GetFederationToken";
var _GST = "GetSessionToken";
var _I2 = "Issuer";
var _K2 = "Key";
var _N2 = "Name";
var _NQ = "NameQualifier";
var _P2 = "Policy";
var _PA = "PolicyArns";
var _PAr = "PrincipalArn";
var _PAro = "ProviderArn";
var _PC2 = "ProvidedContexts";
var _PI2 = "ProviderId";
var _PPS = "PackedPolicySize";
var _Pr2 = "Provider";
var _RA = "RoleArn";
var _RSN = "RoleSessionName";
var _S2 = "Subject";
var _SAK2 = "SecretAccessKey";
var _SAMLA = "SAMLAssertion";
var _SFWIT = "SubjectFromWebIdentityToken";
var _SI = "SourceIdentity";
var _SN = "SerialNumber";
var _ST2 = "SubjectType";
var _STe = "SessionToken";
var _T2 = "Tags";
var _TC2 = "TokenCode";
var _TTK = "TransitiveTagKeys";
var _UI2 = "UserId";
var _V2 = "Version";
var _Va2 = "Value";
var _WIT = "WebIdentityToken";
var _a2 = "arn";
var _m2 = "message";
var buildFormUrlencodedString = (formEntries) => Object.entries(formEntries).map(([key2, value]) => import_protocols2.extendedEncodeURIComponent(key2) + "=" + import_protocols2.extendedEncodeURIComponent(value)).join("&");
var loadQueryErrorCode = (output, data2) => {
  if (data2.Error?.Code !== undefined) {
    return data2.Error.Code;
  }
  if (output.statusCode == 404) {
    return "NotFound";
  }
};
var init_Aws_query = __esm2(() => {
  import_core35 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es();
  init_dist_es12();
  init_models_04();
  init_STSServiceException();
  throwDefaultError5 = withBaseException(STSServiceException);
  SHARED_HEADERS = {
    "content-type": "application/x-www-form-urlencoded"
  };
});
var AssumeRoleCommand;
var init_AssumeRoleCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_models_04();
  init_Aws_query();
  AssumeRoleCommand = class AssumeRoleCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "AssumeRole", {}).n("STSClient", "AssumeRoleCommand").f(undefined, AssumeRoleResponseFilterSensitiveLog).ser(se_AssumeRoleCommand).de(de_AssumeRoleCommand).build() {
  };
});
var AssumeRoleWithSAMLCommand;
var init_AssumeRoleWithSAMLCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_models_04();
  init_Aws_query();
  AssumeRoleWithSAMLCommand = class AssumeRoleWithSAMLCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "AssumeRoleWithSAML", {}).n("STSClient", "AssumeRoleWithSAMLCommand").f(AssumeRoleWithSAMLRequestFilterSensitiveLog, AssumeRoleWithSAMLResponseFilterSensitiveLog).ser(se_AssumeRoleWithSAMLCommand).de(de_AssumeRoleWithSAMLCommand).build() {
  };
});
var AssumeRoleWithWebIdentityCommand;
var init_AssumeRoleWithWebIdentityCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_models_04();
  init_Aws_query();
  AssumeRoleWithWebIdentityCommand = class AssumeRoleWithWebIdentityCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "AssumeRoleWithWebIdentity", {}).n("STSClient", "AssumeRoleWithWebIdentityCommand").f(AssumeRoleWithWebIdentityRequestFilterSensitiveLog, AssumeRoleWithWebIdentityResponseFilterSensitiveLog).ser(se_AssumeRoleWithWebIdentityCommand).de(de_AssumeRoleWithWebIdentityCommand).build() {
  };
});
var DecodeAuthorizationMessageCommand;
var init_DecodeAuthorizationMessageCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_Aws_query();
  DecodeAuthorizationMessageCommand = class DecodeAuthorizationMessageCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "DecodeAuthorizationMessage", {}).n("STSClient", "DecodeAuthorizationMessageCommand").f(undefined, undefined).ser(se_DecodeAuthorizationMessageCommand).de(de_DecodeAuthorizationMessageCommand).build() {
  };
});
var GetAccessKeyInfoCommand;
var init_GetAccessKeyInfoCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_Aws_query();
  GetAccessKeyInfoCommand = class GetAccessKeyInfoCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "GetAccessKeyInfo", {}).n("STSClient", "GetAccessKeyInfoCommand").f(undefined, undefined).ser(se_GetAccessKeyInfoCommand).de(de_GetAccessKeyInfoCommand).build() {
  };
});
var GetCallerIdentityCommand;
var init_GetCallerIdentityCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_Aws_query();
  GetCallerIdentityCommand = class GetCallerIdentityCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "GetCallerIdentity", {}).n("STSClient", "GetCallerIdentityCommand").f(undefined, undefined).ser(se_GetCallerIdentityCommand).de(de_GetCallerIdentityCommand).build() {
  };
});
var GetFederationTokenCommand;
var init_GetFederationTokenCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_models_04();
  init_Aws_query();
  GetFederationTokenCommand = class GetFederationTokenCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "GetFederationToken", {}).n("STSClient", "GetFederationTokenCommand").f(undefined, GetFederationTokenResponseFilterSensitiveLog).ser(se_GetFederationTokenCommand).de(de_GetFederationTokenCommand).build() {
  };
});
var GetSessionTokenCommand;
var init_GetSessionTokenCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters4();
  init_models_04();
  init_Aws_query();
  GetSessionTokenCommand = class GetSessionTokenCommand2 extends Command2.classBuilder().ep(commonParams4).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AWSSecurityTokenServiceV20110615", "GetSessionToken", {}).n("STSClient", "GetSessionTokenCommand").f(undefined, GetSessionTokenResponseFilterSensitiveLog).ser(se_GetSessionTokenCommand).de(de_GetSessionTokenCommand).build() {
  };
});
var commands5;
var STS;
var init_STS = __esm2(() => {
  init_dist_es12();
  init_AssumeRoleCommand();
  init_AssumeRoleWithSAMLCommand();
  init_AssumeRoleWithWebIdentityCommand();
  init_DecodeAuthorizationMessageCommand();
  init_GetAccessKeyInfoCommand();
  init_GetCallerIdentityCommand();
  init_GetFederationTokenCommand();
  init_GetSessionTokenCommand();
  init_STSClient();
  commands5 = {
    AssumeRoleCommand,
    AssumeRoleWithSAMLCommand,
    AssumeRoleWithWebIdentityCommand,
    DecodeAuthorizationMessageCommand,
    GetAccessKeyInfoCommand,
    GetCallerIdentityCommand,
    GetFederationTokenCommand,
    GetSessionTokenCommand
  };
  STS = class STS2 extends STSClient {
  };
  createAggregatedClient(commands5, STS);
});
var init_commands3 = __esm2(() => {
  init_AssumeRoleCommand();
  init_AssumeRoleWithSAMLCommand();
  init_AssumeRoleWithWebIdentityCommand();
  init_DecodeAuthorizationMessageCommand();
  init_GetAccessKeyInfoCommand();
  init_GetCallerIdentityCommand();
  init_GetFederationTokenCommand();
  init_GetSessionTokenCommand();
});
var init_models3 = __esm2(() => {
  init_models_04();
});
var import_client5;
var ASSUME_ROLE_DEFAULT_REGION = "us-east-1";
var getAccountIdFromAssumedRoleUser = (assumedRoleUser) => {
  if (typeof assumedRoleUser?.Arn === "string") {
    const arnComponents = assumedRoleUser.Arn.split(":");
    if (arnComponents.length > 4 && arnComponents[4] !== "") {
      return arnComponents[4];
    }
  }
  return;
};
var resolveRegion = async (_region, _parentRegion, credentialProviderLogger) => {
  const region = typeof _region === "function" ? await _region() : _region;
  const parentRegion = typeof _parentRegion === "function" ? await _parentRegion() : _parentRegion;
  credentialProviderLogger?.debug?.("@aws-sdk/client-sts::resolveRegion", "accepting first of:", `${region} (provider)`, `${parentRegion} (parent client)`, `${ASSUME_ROLE_DEFAULT_REGION} (STS default)`);
  return region ?? parentRegion ?? ASSUME_ROLE_DEFAULT_REGION;
};
var getDefaultRoleAssumer = (stsOptions, stsClientCtor) => {
  let stsClient;
  let closureSourceCreds;
  return async (sourceCreds, params) => {
    closureSourceCreds = sourceCreds;
    if (!stsClient) {
      const { logger: logger3 = stsOptions?.parentClientConfig?.logger, region, requestHandler = stsOptions?.parentClientConfig?.requestHandler, credentialProviderLogger } = stsOptions;
      const resolvedRegion = await resolveRegion(region, stsOptions?.parentClientConfig?.region, credentialProviderLogger);
      const isCompatibleRequestHandler = !isH2(requestHandler);
      stsClient = new stsClientCtor({
        credentialDefaultProvider: () => async () => closureSourceCreds,
        region: resolvedRegion,
        requestHandler: isCompatibleRequestHandler ? requestHandler : undefined,
        logger: logger3
      });
    }
    const { Credentials, AssumedRoleUser } = await stsClient.send(new AssumeRoleCommand(params));
    if (!Credentials || !Credentials.AccessKeyId || !Credentials.SecretAccessKey) {
      throw new Error(`Invalid response from STS.assumeRole call with role ${params.RoleArn}`);
    }
    const accountId = getAccountIdFromAssumedRoleUser(AssumedRoleUser);
    const credentials = {
      accessKeyId: Credentials.AccessKeyId,
      secretAccessKey: Credentials.SecretAccessKey,
      sessionToken: Credentials.SessionToken,
      expiration: Credentials.Expiration,
      ...Credentials.CredentialScope && { credentialScope: Credentials.CredentialScope },
      ...accountId && { accountId }
    };
    import_client5.setCredentialFeature(credentials, "CREDENTIALS_STS_ASSUME_ROLE", "i");
    return credentials;
  };
};
var getDefaultRoleAssumerWithWebIdentity = (stsOptions, stsClientCtor) => {
  let stsClient;
  return async (params) => {
    if (!stsClient) {
      const { logger: logger3 = stsOptions?.parentClientConfig?.logger, region, requestHandler = stsOptions?.parentClientConfig?.requestHandler, credentialProviderLogger } = stsOptions;
      const resolvedRegion = await resolveRegion(region, stsOptions?.parentClientConfig?.region, credentialProviderLogger);
      const isCompatibleRequestHandler = !isH2(requestHandler);
      stsClient = new stsClientCtor({
        region: resolvedRegion,
        requestHandler: isCompatibleRequestHandler ? requestHandler : undefined,
        logger: logger3
      });
    }
    const { Credentials, AssumedRoleUser } = await stsClient.send(new AssumeRoleWithWebIdentityCommand(params));
    if (!Credentials || !Credentials.AccessKeyId || !Credentials.SecretAccessKey) {
      throw new Error(`Invalid response from STS.assumeRoleWithWebIdentity call with role ${params.RoleArn}`);
    }
    const accountId = getAccountIdFromAssumedRoleUser(AssumedRoleUser);
    const credentials = {
      accessKeyId: Credentials.AccessKeyId,
      secretAccessKey: Credentials.SecretAccessKey,
      sessionToken: Credentials.SessionToken,
      expiration: Credentials.Expiration,
      ...Credentials.CredentialScope && { credentialScope: Credentials.CredentialScope },
      ...accountId && { accountId }
    };
    if (accountId) {
      import_client5.setCredentialFeature(credentials, "RESOLVED_ACCOUNT_ID", "T");
    }
    import_client5.setCredentialFeature(credentials, "CREDENTIALS_STS_ASSUME_ROLE_WEB_ID", "k");
    return credentials;
  };
};
var isH2 = (requestHandler) => {
  return requestHandler?.metadata?.handlerProtocol === "h2";
};
var init_defaultStsRoleAssumers = __esm2(() => {
  import_client5 = __toESM3(require_client4(), 1);
  init_AssumeRoleCommand();
  init_AssumeRoleWithWebIdentityCommand();
});
var getCustomizableStsClientCtor = (baseCtor, customizations) => {
  if (!customizations)
    return baseCtor;
  else
    return class CustomizableSTSClient extends baseCtor {
      constructor(config9) {
        super(config9);
        for (const customization of customizations) {
          this.middlewareStack.use(customization);
        }
      }
    };
};
var getDefaultRoleAssumer2 = (stsOptions = {}, stsPlugins) => getDefaultRoleAssumer(stsOptions, getCustomizableStsClientCtor(STSClient, stsPlugins));
var getDefaultRoleAssumerWithWebIdentity2 = (stsOptions = {}, stsPlugins) => getDefaultRoleAssumerWithWebIdentity(stsOptions, getCustomizableStsClientCtor(STSClient, stsPlugins));
var decorateDefaultCredentialProvider = (provider) => (input) => provider({
  roleAssumer: getDefaultRoleAssumer2(input),
  roleAssumerWithWebIdentity: getDefaultRoleAssumerWithWebIdentity2(input),
  ...input
});
var init_defaultRoleAssumers = __esm2(() => {
  init_defaultStsRoleAssumers();
  init_STSClient();
});
var exports_dist_es6 = {};
__export3(exports_dist_es6, {
  getDefaultRoleAssumerWithWebIdentity: () => getDefaultRoleAssumerWithWebIdentity2,
  getDefaultRoleAssumer: () => getDefaultRoleAssumer2,
  decorateDefaultCredentialProvider: () => decorateDefaultCredentialProvider,
  __Client: () => Client,
  STSServiceException: () => STSServiceException,
  STSClient: () => STSClient,
  STS: () => STS,
  RegionDisabledException: () => RegionDisabledException,
  PackedPolicyTooLargeException: () => PackedPolicyTooLargeException,
  MalformedPolicyDocumentException: () => MalformedPolicyDocumentException,
  InvalidIdentityTokenException: () => InvalidIdentityTokenException,
  InvalidAuthorizationMessageException: () => InvalidAuthorizationMessageException,
  IDPRejectedClaimException: () => IDPRejectedClaimException,
  IDPCommunicationErrorException: () => IDPCommunicationErrorException,
  GetSessionTokenResponseFilterSensitiveLog: () => GetSessionTokenResponseFilterSensitiveLog,
  GetSessionTokenCommand: () => GetSessionTokenCommand,
  GetFederationTokenResponseFilterSensitiveLog: () => GetFederationTokenResponseFilterSensitiveLog,
  GetFederationTokenCommand: () => GetFederationTokenCommand,
  GetCallerIdentityCommand: () => GetCallerIdentityCommand,
  GetAccessKeyInfoCommand: () => GetAccessKeyInfoCommand,
  ExpiredTokenException: () => ExpiredTokenException2,
  DecodeAuthorizationMessageCommand: () => DecodeAuthorizationMessageCommand,
  CredentialsFilterSensitiveLog: () => CredentialsFilterSensitiveLog,
  AssumeRoleWithWebIdentityResponseFilterSensitiveLog: () => AssumeRoleWithWebIdentityResponseFilterSensitiveLog,
  AssumeRoleWithWebIdentityRequestFilterSensitiveLog: () => AssumeRoleWithWebIdentityRequestFilterSensitiveLog,
  AssumeRoleWithWebIdentityCommand: () => AssumeRoleWithWebIdentityCommand,
  AssumeRoleWithSAMLResponseFilterSensitiveLog: () => AssumeRoleWithSAMLResponseFilterSensitiveLog,
  AssumeRoleWithSAMLRequestFilterSensitiveLog: () => AssumeRoleWithSAMLRequestFilterSensitiveLog,
  AssumeRoleWithSAMLCommand: () => AssumeRoleWithSAMLCommand,
  AssumeRoleResponseFilterSensitiveLog: () => AssumeRoleResponseFilterSensitiveLog,
  AssumeRoleCommand: () => AssumeRoleCommand,
  $Command: () => Command2
});
var init_dist_es50 = __esm2(() => {
  init_STSClient();
  init_STS();
  init_commands3();
  init_models3();
  init_defaultRoleAssumers();
  init_STSServiceException();
});
var import_client6;
var isAssumeRoleProfile = (arg, { profile = "default", logger: logger3 } = {}) => {
  return Boolean(arg) && typeof arg === "object" && typeof arg.role_arn === "string" && ["undefined", "string"].indexOf(typeof arg.role_session_name) > -1 && ["undefined", "string"].indexOf(typeof arg.external_id) > -1 && ["undefined", "string"].indexOf(typeof arg.mfa_serial) > -1 && (isAssumeRoleWithSourceProfile(arg, { profile, logger: logger3 }) || isCredentialSourceProfile(arg, { profile, logger: logger3 }));
};
var isAssumeRoleWithSourceProfile = (arg, { profile, logger: logger3 }) => {
  const withSourceProfile = typeof arg.source_profile === "string" && typeof arg.credential_source === "undefined";
  if (withSourceProfile) {
    logger3?.debug?.(`    ${profile} isAssumeRoleWithSourceProfile source_profile=${arg.source_profile}`);
  }
  return withSourceProfile;
};
var isCredentialSourceProfile = (arg, { profile, logger: logger3 }) => {
  const withProviderProfile = typeof arg.credential_source === "string" && typeof arg.source_profile === "undefined";
  if (withProviderProfile) {
    logger3?.debug?.(`    ${profile} isCredentialSourceProfile credential_source=${arg.credential_source}`);
  }
  return withProviderProfile;
};
var resolveAssumeRoleCredentials = async (profileName, profiles, options3, visitedProfiles = {}) => {
  options3.logger?.debug("@aws-sdk/credential-provider-ini - resolveAssumeRoleCredentials (STS)");
  const data2 = profiles[profileName];
  if (!options3.roleAssumer) {
    const { getDefaultRoleAssumer: getDefaultRoleAssumer3 } = await Promise.resolve().then(() => (init_dist_es50(), exports_dist_es6));
    options3.roleAssumer = getDefaultRoleAssumer3({
      ...options3.clientConfig,
      credentialProviderLogger: options3.logger,
      parentClientConfig: options3?.parentClientConfig
    }, options3.clientPlugins);
  }
  const { source_profile } = data2;
  if (source_profile && source_profile in visitedProfiles) {
    throw new CredentialsProviderError(`Detected a cycle attempting to resolve credentials for profile ${getProfileName(options3)}. Profiles visited: ` + Object.keys(visitedProfiles).join(", "), { logger: options3.logger });
  }
  options3.logger?.debug(`@aws-sdk/credential-provider-ini - finding credential resolver using ${source_profile ? `source_profile=[${source_profile}]` : `profile=[${profileName}]`}`);
  const sourceCredsProvider = source_profile ? resolveProfileData(source_profile, profiles, options3, {
    ...visitedProfiles,
    [source_profile]: true
  }, isCredentialSourceWithoutRoleArn(profiles[source_profile] ?? {})) : (await resolveCredentialSource(data2.credential_source, profileName, options3.logger)(options3))();
  if (isCredentialSourceWithoutRoleArn(data2)) {
    return sourceCredsProvider.then((creds) => import_client6.setCredentialFeature(creds, "CREDENTIALS_PROFILE_SOURCE_PROFILE", "o"));
  } else {
    const params = {
      RoleArn: data2.role_arn,
      RoleSessionName: data2.role_session_name || `aws-sdk-js-${Date.now()}`,
      ExternalId: data2.external_id,
      DurationSeconds: parseInt(data2.duration_seconds || "3600", 10)
    };
    const { mfa_serial } = data2;
    if (mfa_serial) {
      if (!options3.mfaCodeProvider) {
        throw new CredentialsProviderError(`Profile ${profileName} requires multi-factor authentication, but no MFA code callback was provided.`, { logger: options3.logger, tryNextLink: false });
      }
      params.SerialNumber = mfa_serial;
      params.TokenCode = await options3.mfaCodeProvider(mfa_serial);
    }
    const sourceCreds = await sourceCredsProvider;
    return options3.roleAssumer(sourceCreds, params).then((creds) => import_client6.setCredentialFeature(creds, "CREDENTIALS_PROFILE_SOURCE_PROFILE", "o"));
  }
};
var isCredentialSourceWithoutRoleArn = (section) => {
  return !section.role_arn && !!section.credential_source;
};
var init_resolveAssumeRoleCredentials = __esm2(() => {
  import_client6 = __toESM3(require_client4(), 1);
  init_dist_es27();
  init_dist_es28();
  init_resolveCredentialSource();
  init_resolveProfileData();
});
var import_client7;
var getValidatedProcessCredentials = (profileName, data2, profiles) => {
  if (data2.Version !== 1) {
    throw Error(`Profile ${profileName} credential_process did not return Version 1.`);
  }
  if (data2.AccessKeyId === undefined || data2.SecretAccessKey === undefined) {
    throw Error(`Profile ${profileName} credential_process returned invalid credentials.`);
  }
  if (data2.Expiration) {
    const currentTime = new Date;
    const expireTime = new Date(data2.Expiration);
    if (expireTime < currentTime) {
      throw Error(`Profile ${profileName} credential_process returned expired credentials.`);
    }
  }
  let accountId = data2.AccountId;
  if (!accountId && profiles?.[profileName]?.aws_account_id) {
    accountId = profiles[profileName].aws_account_id;
  }
  const credentials = {
    accessKeyId: data2.AccessKeyId,
    secretAccessKey: data2.SecretAccessKey,
    ...data2.SessionToken && { sessionToken: data2.SessionToken },
    ...data2.Expiration && { expiration: new Date(data2.Expiration) },
    ...data2.CredentialScope && { credentialScope: data2.CredentialScope },
    ...accountId && { accountId }
  };
  import_client7.setCredentialFeature(credentials, "CREDENTIALS_PROCESS", "w");
  return credentials;
};
var init_getValidatedProcessCredentials = __esm2(() => {
  import_client7 = __toESM3(require_client4(), 1);
});
var resolveProcessCredentials = async (profileName, profiles, logger3) => {
  const profile = profiles[profileName];
  if (profiles[profileName]) {
    const credentialProcess = profile["credential_process"];
    if (credentialProcess !== undefined) {
      const execPromise = promisify2(exec3);
      try {
        const { stdout: stdout22 } = await execPromise(credentialProcess);
        let data2;
        try {
          data2 = JSON.parse(stdout22.trim());
        } catch {
          throw Error(`Profile ${profileName} credential_process returned invalid JSON.`);
        }
        return getValidatedProcessCredentials(profileName, data2, profiles);
      } catch (error) {
        throw new CredentialsProviderError(error.message, { logger: logger3 });
      }
    } else {
      throw new CredentialsProviderError(`Profile ${profileName} did not contain credential_process.`, { logger: logger3 });
    }
  } else {
    throw new CredentialsProviderError(`Profile ${profileName} could not be found in shared credentials file.`, {
      logger: logger3
    });
  }
};
var init_resolveProcessCredentials = __esm2(() => {
  init_dist_es27();
  init_getValidatedProcessCredentials();
});
var fromProcess = (init3 = {}) => async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-process - fromProcess");
  const profiles = await parseKnownFiles(init3);
  return resolveProcessCredentials(getProfileName(init3), profiles, init3.logger);
};
var init_fromProcess = __esm2(() => {
  init_dist_es28();
  init_resolveProcessCredentials();
});
var exports_dist_es7 = {};
__export3(exports_dist_es7, {
  fromProcess: () => fromProcess
});
var init_dist_es51 = __esm2(() => {
  init_fromProcess();
});
var import_client8;
var isProcessProfile = (arg) => Boolean(arg) && typeof arg === "object" && typeof arg.credential_process === "string";
var resolveProcessCredentials2 = async (options3, profile) => Promise.resolve().then(() => (init_dist_es51(), exports_dist_es7)).then(({ fromProcess: fromProcess3 }) => fromProcess3({
  ...options3,
  profile
})().then((creds) => import_client8.setCredentialFeature(creds, "CREDENTIALS_PROFILE_PROCESS", "v")));
var init_resolveProcessCredentials2 = __esm2(() => {
  import_client8 = __toESM3(require_client4(), 1);
});
var import_client9;
var resolveSsoCredentials = async (profile, profileData, options3 = {}) => {
  const { fromSSO: fromSSO3 } = await Promise.resolve().then(() => (init_dist_es49(), exports_dist_es5));
  return fromSSO3({
    profile,
    logger: options3.logger
  })().then((creds) => {
    if (profileData.sso_session) {
      return import_client9.setCredentialFeature(creds, "CREDENTIALS_PROFILE_SSO", "r");
    } else {
      return import_client9.setCredentialFeature(creds, "CREDENTIALS_PROFILE_SSO_LEGACY", "t");
    }
  });
};
var isSsoProfile3 = (arg) => arg && (typeof arg.sso_start_url === "string" || typeof arg.sso_account_id === "string" || typeof arg.sso_session === "string" || typeof arg.sso_region === "string" || typeof arg.sso_role_name === "string");
var init_resolveSsoCredentials = __esm2(() => {
  import_client9 = __toESM3(require_client4(), 1);
});
var import_client10;
var isStaticCredsProfile = (arg) => Boolean(arg) && typeof arg === "object" && typeof arg.aws_access_key_id === "string" && typeof arg.aws_secret_access_key === "string" && ["undefined", "string"].indexOf(typeof arg.aws_session_token) > -1 && ["undefined", "string"].indexOf(typeof arg.aws_account_id) > -1;
var resolveStaticCredentials = async (profile, options3) => {
  options3?.logger?.debug("@aws-sdk/credential-provider-ini - resolveStaticCredentials");
  const credentials = {
    accessKeyId: profile.aws_access_key_id,
    secretAccessKey: profile.aws_secret_access_key,
    sessionToken: profile.aws_session_token,
    ...profile.aws_credential_scope && { credentialScope: profile.aws_credential_scope },
    ...profile.aws_account_id && { accountId: profile.aws_account_id }
  };
  return import_client10.setCredentialFeature(credentials, "CREDENTIALS_PROFILE", "n");
};
var init_resolveStaticCredentials = __esm2(() => {
  import_client10 = __toESM3(require_client4(), 1);
});
var fromWebToken = (init3) => async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-web-identity - fromWebToken");
  const { roleArn, roleSessionName, webIdentityToken, providerId, policyArns, policy, durationSeconds } = init3;
  let { roleAssumerWithWebIdentity } = init3;
  if (!roleAssumerWithWebIdentity) {
    const { getDefaultRoleAssumerWithWebIdentity: getDefaultRoleAssumerWithWebIdentity3 } = await Promise.resolve().then(() => (init_dist_es50(), exports_dist_es6));
    roleAssumerWithWebIdentity = getDefaultRoleAssumerWithWebIdentity3({
      ...init3.clientConfig,
      credentialProviderLogger: init3.logger,
      parentClientConfig: init3.parentClientConfig
    }, init3.clientPlugins);
  }
  return roleAssumerWithWebIdentity({
    RoleArn: roleArn,
    RoleSessionName: roleSessionName ?? `aws-sdk-js-session-${Date.now()}`,
    WebIdentityToken: webIdentityToken,
    ProviderId: providerId,
    PolicyArns: policyArns,
    Policy: policy,
    DurationSeconds: durationSeconds
  });
};
var import_client11;
var ENV_TOKEN_FILE = "AWS_WEB_IDENTITY_TOKEN_FILE";
var ENV_ROLE_ARN = "AWS_ROLE_ARN";
var ENV_ROLE_SESSION_NAME = "AWS_ROLE_SESSION_NAME";
var fromTokenFile = (init3 = {}) => async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-web-identity - fromTokenFile");
  const webIdentityTokenFile = init3?.webIdentityTokenFile ?? process.env[ENV_TOKEN_FILE];
  const roleArn = init3?.roleArn ?? process.env[ENV_ROLE_ARN];
  const roleSessionName = init3?.roleSessionName ?? process.env[ENV_ROLE_SESSION_NAME];
  if (!webIdentityTokenFile || !roleArn) {
    throw new CredentialsProviderError("Web identity configuration not specified", {
      logger: init3.logger
    });
  }
  const credentials = await fromWebToken({
    ...init3,
    webIdentityToken: readFileSync2(webIdentityTokenFile, { encoding: "ascii" }),
    roleArn,
    roleSessionName
  })();
  if (webIdentityTokenFile === process.env[ENV_TOKEN_FILE]) {
    import_client11.setCredentialFeature(credentials, "CREDENTIALS_ENV_VARS_STS_WEB_ID_TOKEN", "h");
  }
  return credentials;
};
var init_fromTokenFile = __esm2(() => {
  import_client11 = __toESM3(require_client4(), 1);
  init_dist_es27();
});
var exports_dist_es8 = {};
__export3(exports_dist_es8, {
  fromWebToken: () => fromWebToken,
  fromTokenFile: () => fromTokenFile
});
var init_dist_es52 = __esm2(() => {
  init_fromTokenFile();
});
var import_client12;
var isWebIdentityProfile = (arg) => Boolean(arg) && typeof arg === "object" && typeof arg.web_identity_token_file === "string" && typeof arg.role_arn === "string" && ["undefined", "string"].indexOf(typeof arg.role_session_name) > -1;
var resolveWebIdentityCredentials = async (profile, options3) => Promise.resolve().then(() => (init_dist_es52(), exports_dist_es8)).then(({ fromTokenFile: fromTokenFile3 }) => fromTokenFile3({
  webIdentityTokenFile: profile.web_identity_token_file,
  roleArn: profile.role_arn,
  roleSessionName: profile.role_session_name,
  roleAssumerWithWebIdentity: options3.roleAssumerWithWebIdentity,
  logger: options3.logger,
  parentClientConfig: options3.parentClientConfig
})().then((creds) => import_client12.setCredentialFeature(creds, "CREDENTIALS_PROFILE_STS_WEB_ID_TOKEN", "q")));
var init_resolveWebIdentityCredentials = __esm2(() => {
  import_client12 = __toESM3(require_client4(), 1);
});
var resolveProfileData = async (profileName, profiles, options3, visitedProfiles = {}, isAssumeRoleRecursiveCall = false) => {
  const data2 = profiles[profileName];
  if (Object.keys(visitedProfiles).length > 0 && isStaticCredsProfile(data2)) {
    return resolveStaticCredentials(data2, options3);
  }
  if (isAssumeRoleRecursiveCall || isAssumeRoleProfile(data2, { profile: profileName, logger: options3.logger })) {
    return resolveAssumeRoleCredentials(profileName, profiles, options3, visitedProfiles);
  }
  if (isStaticCredsProfile(data2)) {
    return resolveStaticCredentials(data2, options3);
  }
  if (isWebIdentityProfile(data2)) {
    return resolveWebIdentityCredentials(data2, options3);
  }
  if (isProcessProfile(data2)) {
    return resolveProcessCredentials2(options3, profileName);
  }
  if (isSsoProfile3(data2)) {
    return await resolveSsoCredentials(profileName, data2, options3);
  }
  throw new CredentialsProviderError(`Could not resolve credentials using profile: [${profileName}] in configuration/credentials file(s).`, { logger: options3.logger });
};
var init_resolveProfileData = __esm2(() => {
  init_dist_es27();
  init_resolveAssumeRoleCredentials();
  init_resolveProcessCredentials2();
  init_resolveSsoCredentials();
  init_resolveStaticCredentials();
  init_resolveWebIdentityCredentials();
});
var fromIni = (init3 = {}) => async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-ini - fromIni");
  const profiles = await parseKnownFiles(init3);
  return resolveProfileData(getProfileName(init3), profiles, init3);
};
var init_fromIni = __esm2(() => {
  init_dist_es28();
  init_resolveProfileData();
});
var exports_dist_es9 = {};
__export3(exports_dist_es9, {
  fromIni: () => fromIni
});
var init_dist_es53 = __esm2(() => {
  init_fromIni();
});
var multipleCredentialSourceWarningEmitted = false;
var defaultProvider = (init3 = {}) => memoize2(chain(async () => {
  const profile = init3.profile ?? process.env[ENV_PROFILE];
  if (profile) {
    const envStaticCredentialsAreSet = process.env[ENV_KEY] && process.env[ENV_SECRET];
    if (envStaticCredentialsAreSet) {
      if (!multipleCredentialSourceWarningEmitted) {
        const warnFn = init3.logger?.warn && init3.logger?.constructor?.name !== "NoOpLogger" ? init3.logger.warn : console.warn;
        warnFn(`@aws-sdk/credential-provider-node - defaultProvider::fromEnv WARNING:
    Multiple credential sources detected: 
    Both AWS_PROFILE and the pair AWS_ACCESS_KEY_ID/AWS_SECRET_ACCESS_KEY static credentials are set.
    This SDK will proceed with the AWS_PROFILE value.
    
    However, a future version may change this behavior to prefer the ENV static credentials.
    Please ensure that your environment only sets either the AWS_PROFILE or the
    AWS_ACCESS_KEY_ID/AWS_SECRET_ACCESS_KEY pair.
`);
        multipleCredentialSourceWarningEmitted = true;
      }
    }
    throw new CredentialsProviderError("AWS_PROFILE is set, skipping fromEnv provider.", {
      logger: init3.logger,
      tryNextLink: true
    });
  }
  init3.logger?.debug("@aws-sdk/credential-provider-node - defaultProvider::fromEnv");
  return fromEnv2(init3)();
}, async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-node - defaultProvider::fromSSO");
  const { ssoStartUrl, ssoAccountId, ssoRegion, ssoRoleName, ssoSession } = init3;
  if (!ssoStartUrl && !ssoAccountId && !ssoRegion && !ssoRoleName && !ssoSession) {
    throw new CredentialsProviderError("Skipping SSO provider in default chain (inputs do not include SSO fields).", { logger: init3.logger });
  }
  const { fromSSO: fromSSO3 } = await Promise.resolve().then(() => (init_dist_es49(), exports_dist_es5));
  return fromSSO3(init3)();
}, async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-node - defaultProvider::fromIni");
  const { fromIni: fromIni3 } = await Promise.resolve().then(() => (init_dist_es53(), exports_dist_es9));
  return fromIni3(init3)();
}, async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-node - defaultProvider::fromProcess");
  const { fromProcess: fromProcess3 } = await Promise.resolve().then(() => (init_dist_es51(), exports_dist_es7));
  return fromProcess3(init3)();
}, async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-node - defaultProvider::fromTokenFile");
  const { fromTokenFile: fromTokenFile3 } = await Promise.resolve().then(() => (init_dist_es52(), exports_dist_es8));
  return fromTokenFile3(init3)();
}, async () => {
  init3.logger?.debug("@aws-sdk/credential-provider-node - defaultProvider::remoteProvider");
  return (await remoteProvider(init3))();
}, async () => {
  throw new CredentialsProviderError("Could not load credentials from any providers", {
    tryNextLink: false,
    logger: init3.logger
  });
}), credentialsTreatedAsExpired, credentialsWillNeedRefresh);
var credentialsWillNeedRefresh = (credentials) => credentials?.expiration !== undefined;
var credentialsTreatedAsExpired = (credentials) => credentials?.expiration !== undefined && credentials.expiration.getTime() - Date.now() < 300000;
var init_defaultProvider = __esm2(() => {
  init_dist_es38();
  init_dist_es27();
  init_dist_es28();
  init_remoteProvider();
});
var init_dist_es54 = __esm2(() => {
  init_defaultProvider();
});
var init_NodeDisableMultiregionAccessPointConfigOptions = __esm2(() => {
  init_dist_es15();
});
var NODE_USE_ARN_REGION_ENV_NAME = "AWS_S3_USE_ARN_REGION";
var NODE_USE_ARN_REGION_INI_NAME = "s3_use_arn_region";
var NODE_USE_ARN_REGION_CONFIG_OPTIONS;
var init_NodeUseArnRegionConfigOptions = __esm2(() => {
  init_dist_es15();
  NODE_USE_ARN_REGION_CONFIG_OPTIONS = {
    environmentVariableSelector: (env7) => booleanSelector(env7, NODE_USE_ARN_REGION_ENV_NAME, SelectorType2.ENV),
    configFileSelector: (profile) => booleanSelector(profile, NODE_USE_ARN_REGION_INI_NAME, SelectorType2.CONFIG),
    default: false
  };
});
var init_bucketHostnameUtils = () => {
};
var init_bucketHostname = __esm2(() => {
  init_bucketHostnameUtils();
});
var init_bucketEndpointMiddleware = __esm2(() => {
  init_dist_es();
  init_bucketHostname();
});
var init_dist_es55 = __esm2(() => {
  init_NodeDisableMultiregionAccessPointConfigOptions();
  init_NodeUseArnRegionConfigOptions();
  init_bucketEndpointMiddleware();
  init_bucketHostname();
  init_bucketHostnameUtils();
});

class Int642 {
  constructor(bytes) {
    this.bytes = bytes;
    if (bytes.byteLength !== 8) {
      throw new Error("Int64 buffers must be exactly 8 bytes");
    }
  }
  static fromNumber(number) {
    if (number > 9223372036854776000 || number < -9223372036854776000) {
      throw new Error(`${number} is too large (or, if negative, too small) to represent as an Int64`);
    }
    const bytes = new Uint8Array(8);
    for (let i5 = 7, remaining = Math.abs(Math.round(number));i5 > -1 && remaining > 0; i5--, remaining /= 256) {
      bytes[i5] = remaining;
    }
    if (number < 0) {
      negate2(bytes);
    }
    return new Int642(bytes);
  }
  valueOf() {
    const bytes = this.bytes.slice(0);
    const negative = bytes[0] & 128;
    if (negative) {
      negate2(bytes);
    }
    return parseInt(import_util_hex_encoding6.toHex(bytes), 16) * (negative ? -1 : 1);
  }
  toString() {
    return String(this.valueOf());
  }
}
function negate2(bytes) {
  for (let i5 = 0;i5 < 8; i5++) {
    bytes[i5] ^= 255;
  }
  for (let i5 = 7;i5 > -1; i5--) {
    bytes[i5]++;
    if (bytes[i5] !== 0)
      break;
  }
}
var import_util_hex_encoding6;
var init_Int64 = __esm2(() => {
  import_util_hex_encoding6 = __toESM3(require_dist_cjs13(), 1);
});

class HeaderMarshaller {
  constructor(toUtf84, fromUtf86) {
    this.toUtf8 = toUtf84;
    this.fromUtf8 = fromUtf86;
  }
  format(headers) {
    const chunks = [];
    for (const headerName of Object.keys(headers)) {
      const bytes = this.fromUtf8(headerName);
      chunks.push(Uint8Array.from([bytes.byteLength]), bytes, this.formatHeaderValue(headers[headerName]));
    }
    const out = new Uint8Array(chunks.reduce((carry, bytes) => carry + bytes.byteLength, 0));
    let position = 0;
    for (const chunk of chunks) {
      out.set(chunk, position);
      position += chunk.byteLength;
    }
    return out;
  }
  formatHeaderValue(header) {
    switch (header.type) {
      case "boolean":
        return Uint8Array.from([header.value ? 0 : 1]);
      case "byte":
        return Uint8Array.from([2, header.value]);
      case "short":
        const shortView = new DataView(new ArrayBuffer(3));
        shortView.setUint8(0, 3);
        shortView.setInt16(1, header.value, false);
        return new Uint8Array(shortView.buffer);
      case "integer":
        const intView = new DataView(new ArrayBuffer(5));
        intView.setUint8(0, 4);
        intView.setInt32(1, header.value, false);
        return new Uint8Array(intView.buffer);
      case "long":
        const longBytes = new Uint8Array(9);
        longBytes[0] = 5;
        longBytes.set(header.value.bytes, 1);
        return longBytes;
      case "binary":
        const binView = new DataView(new ArrayBuffer(3 + header.value.byteLength));
        binView.setUint8(0, 6);
        binView.setUint16(1, header.value.byteLength, false);
        const binBytes = new Uint8Array(binView.buffer);
        binBytes.set(header.value, 3);
        return binBytes;
      case "string":
        const utf8Bytes = this.fromUtf8(header.value);
        const strView = new DataView(new ArrayBuffer(3 + utf8Bytes.byteLength));
        strView.setUint8(0, 7);
        strView.setUint16(1, utf8Bytes.byteLength, false);
        const strBytes = new Uint8Array(strView.buffer);
        strBytes.set(utf8Bytes, 3);
        return strBytes;
      case "timestamp":
        const tsBytes = new Uint8Array(9);
        tsBytes[0] = 8;
        tsBytes.set(Int642.fromNumber(header.value.valueOf()).bytes, 1);
        return tsBytes;
      case "uuid":
        if (!UUID_PATTERN2.test(header.value)) {
          throw new Error(`Invalid UUID received: ${header.value}`);
        }
        const uuidBytes = new Uint8Array(17);
        uuidBytes[0] = 9;
        uuidBytes.set(import_util_hex_encoding7.fromHex(header.value.replace(/\-/g, "")), 1);
        return uuidBytes;
    }
  }
  parse(headers) {
    const out = {};
    let position = 0;
    while (position < headers.byteLength) {
      const nameLength = headers.getUint8(position++);
      const name = this.toUtf8(new Uint8Array(headers.buffer, headers.byteOffset + position, nameLength));
      position += nameLength;
      switch (headers.getUint8(position++)) {
        case 0:
          out[name] = {
            type: BOOLEAN_TAG,
            value: true
          };
          break;
        case 1:
          out[name] = {
            type: BOOLEAN_TAG,
            value: false
          };
          break;
        case 2:
          out[name] = {
            type: BYTE_TAG,
            value: headers.getInt8(position++)
          };
          break;
        case 3:
          out[name] = {
            type: SHORT_TAG,
            value: headers.getInt16(position, false)
          };
          position += 2;
          break;
        case 4:
          out[name] = {
            type: INT_TAG,
            value: headers.getInt32(position, false)
          };
          position += 4;
          break;
        case 5:
          out[name] = {
            type: LONG_TAG,
            value: new Int642(new Uint8Array(headers.buffer, headers.byteOffset + position, 8))
          };
          position += 8;
          break;
        case 6:
          const binaryLength = headers.getUint16(position, false);
          position += 2;
          out[name] = {
            type: BINARY_TAG,
            value: new Uint8Array(headers.buffer, headers.byteOffset + position, binaryLength)
          };
          position += binaryLength;
          break;
        case 7:
          const stringLength = headers.getUint16(position, false);
          position += 2;
          out[name] = {
            type: STRING_TAG,
            value: this.toUtf8(new Uint8Array(headers.buffer, headers.byteOffset + position, stringLength))
          };
          position += stringLength;
          break;
        case 8:
          out[name] = {
            type: TIMESTAMP_TAG,
            value: new Date(new Int642(new Uint8Array(headers.buffer, headers.byteOffset + position, 8)).valueOf())
          };
          position += 8;
          break;
        case 9:
          const uuidBytes = new Uint8Array(headers.buffer, headers.byteOffset + position, 16);
          position += 16;
          out[name] = {
            type: UUID_TAG,
            value: `${import_util_hex_encoding7.toHex(uuidBytes.subarray(0, 4))}-${import_util_hex_encoding7.toHex(uuidBytes.subarray(4, 6))}-${import_util_hex_encoding7.toHex(uuidBytes.subarray(6, 8))}-${import_util_hex_encoding7.toHex(uuidBytes.subarray(8, 10))}-${import_util_hex_encoding7.toHex(uuidBytes.subarray(10))}`
          };
          break;
        default:
          throw new Error(`Unrecognized header type tag`);
      }
    }
    return out;
  }
}
var import_util_hex_encoding7;
var HEADER_VALUE_TYPE2;
var BOOLEAN_TAG = "boolean";
var BYTE_TAG = "byte";
var SHORT_TAG = "short";
var INT_TAG = "integer";
var LONG_TAG = "long";
var BINARY_TAG = "binary";
var STRING_TAG = "string";
var TIMESTAMP_TAG = "timestamp";
var UUID_TAG = "uuid";
var UUID_PATTERN2;
var init_HeaderMarshaller = __esm2(() => {
  import_util_hex_encoding7 = __toESM3(require_dist_cjs13(), 1);
  init_Int64();
  (function(HEADER_VALUE_TYPE3) {
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["boolTrue"] = 0] = "boolTrue";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["boolFalse"] = 1] = "boolFalse";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["byte"] = 2] = "byte";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["short"] = 3] = "short";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["integer"] = 4] = "integer";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["long"] = 5] = "long";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["byteArray"] = 6] = "byteArray";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["string"] = 7] = "string";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["timestamp"] = 8] = "timestamp";
    HEADER_VALUE_TYPE3[HEADER_VALUE_TYPE3["uuid"] = 9] = "uuid";
  })(HEADER_VALUE_TYPE2 || (HEADER_VALUE_TYPE2 = {}));
  UUID_PATTERN2 = /^[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}$/;
});
function splitMessage({ byteLength, byteOffset, buffer }) {
  if (byteLength < MINIMUM_MESSAGE_LENGTH) {
    throw new Error("Provided message too short to accommodate event stream message overhead");
  }
  const view = new DataView(buffer, byteOffset, byteLength);
  const messageLength = view.getUint32(0, false);
  if (byteLength !== messageLength) {
    throw new Error("Reported message length does not match received message length");
  }
  const headerLength = view.getUint32(PRELUDE_MEMBER_LENGTH, false);
  const expectedPreludeChecksum = view.getUint32(PRELUDE_LENGTH, false);
  const expectedMessageChecksum = view.getUint32(byteLength - CHECKSUM_LENGTH, false);
  const checksummer = new Crc32().update(new Uint8Array(buffer, byteOffset, PRELUDE_LENGTH));
  if (expectedPreludeChecksum !== checksummer.digest()) {
    throw new Error(`The prelude checksum specified in the message (${expectedPreludeChecksum}) does not match the calculated CRC32 checksum (${checksummer.digest()})`);
  }
  checksummer.update(new Uint8Array(buffer, byteOffset + PRELUDE_LENGTH, byteLength - (PRELUDE_LENGTH + CHECKSUM_LENGTH)));
  if (expectedMessageChecksum !== checksummer.digest()) {
    throw new Error(`The message checksum (${checksummer.digest()}) did not match the expected value of ${expectedMessageChecksum}`);
  }
  return {
    headers: new DataView(buffer, byteOffset + PRELUDE_LENGTH + CHECKSUM_LENGTH, headerLength),
    body: new Uint8Array(buffer, byteOffset + PRELUDE_LENGTH + CHECKSUM_LENGTH + headerLength, messageLength - headerLength - (PRELUDE_LENGTH + CHECKSUM_LENGTH + CHECKSUM_LENGTH))
  };
}
var PRELUDE_MEMBER_LENGTH = 4;
var PRELUDE_LENGTH;
var CHECKSUM_LENGTH = 4;
var MINIMUM_MESSAGE_LENGTH;
var init_splitMessage = __esm2(() => {
  init_module2();
  PRELUDE_LENGTH = PRELUDE_MEMBER_LENGTH * 2;
  MINIMUM_MESSAGE_LENGTH = PRELUDE_LENGTH + CHECKSUM_LENGTH * 2;
});

class EventStreamCodec {
  constructor(toUtf84, fromUtf86) {
    this.headerMarshaller = new HeaderMarshaller(toUtf84, fromUtf86);
    this.messageBuffer = [];
    this.isEndOfStream = false;
  }
  feed(message) {
    this.messageBuffer.push(this.decode(message));
  }
  endOfStream() {
    this.isEndOfStream = true;
  }
  getMessage() {
    const message = this.messageBuffer.pop();
    const isEndOfStream = this.isEndOfStream;
    return {
      getMessage() {
        return message;
      },
      isEndOfStream() {
        return isEndOfStream;
      }
    };
  }
  getAvailableMessages() {
    const messages3 = this.messageBuffer;
    this.messageBuffer = [];
    const isEndOfStream = this.isEndOfStream;
    return {
      getMessages() {
        return messages3;
      },
      isEndOfStream() {
        return isEndOfStream;
      }
    };
  }
  encode({ headers: rawHeaders, body }) {
    const headers = this.headerMarshaller.format(rawHeaders);
    const length = headers.byteLength + body.byteLength + 16;
    const out = new Uint8Array(length);
    const view = new DataView(out.buffer, out.byteOffset, out.byteLength);
    const checksum = new Crc32;
    view.setUint32(0, length, false);
    view.setUint32(4, headers.byteLength, false);
    view.setUint32(8, checksum.update(out.subarray(0, 8)).digest(), false);
    out.set(headers, 12);
    out.set(body, headers.byteLength + 12);
    view.setUint32(length - 4, checksum.update(out.subarray(8, length - 4)).digest(), false);
    return out;
  }
  decode(message) {
    const { headers, body } = splitMessage(message);
    return { headers: this.headerMarshaller.parse(headers), body };
  }
  formatHeaders(rawHeaders) {
    return this.headerMarshaller.format(rawHeaders);
  }
}
var init_EventStreamCodec = __esm2(() => {
  init_module2();
  init_HeaderMarshaller();
  init_splitMessage();
});
var init_Message = () => {
};
var MessageDecoderStream;
var init_MessageDecoderStream = __esm2(() => {
  MessageDecoderStream = class MessageDecoderStream2 {
    constructor(options3) {
      this.options = options3;
    }
    [Symbol.asyncIterator]() {
      return this.asyncIterator();
    }
    async* asyncIterator() {
      for await (const bytes of this.options.inputStream) {
        const decoded = this.options.decoder.decode(bytes);
        yield decoded;
      }
    }
  };
});
var MessageEncoderStream;
var init_MessageEncoderStream = __esm2(() => {
  MessageEncoderStream = class MessageEncoderStream2 {
    constructor(options3) {
      this.options = options3;
    }
    [Symbol.asyncIterator]() {
      return this.asyncIterator();
    }
    async* asyncIterator() {
      for await (const msg of this.options.messageStream) {
        const encoded = this.options.encoder.encode(msg);
        yield encoded;
      }
      if (this.options.includeEndFrame) {
        yield new Uint8Array(0);
      }
    }
  };
});
var SmithyMessageDecoderStream;
var init_SmithyMessageDecoderStream = __esm2(() => {
  SmithyMessageDecoderStream = class SmithyMessageDecoderStream2 {
    constructor(options3) {
      this.options = options3;
    }
    [Symbol.asyncIterator]() {
      return this.asyncIterator();
    }
    async* asyncIterator() {
      for await (const message of this.options.messageStream) {
        const deserialized = await this.options.deserializer(message);
        if (deserialized === undefined)
          continue;
        yield deserialized;
      }
    }
  };
});
var SmithyMessageEncoderStream;
var init_SmithyMessageEncoderStream = __esm2(() => {
  SmithyMessageEncoderStream = class SmithyMessageEncoderStream2 {
    constructor(options3) {
      this.options = options3;
    }
    [Symbol.asyncIterator]() {
      return this.asyncIterator();
    }
    async* asyncIterator() {
      for await (const chunk of this.options.inputStream) {
        const payloadBuf = this.options.serializer(chunk);
        yield payloadBuf;
      }
    }
  };
});
var init_dist_es56 = __esm2(() => {
  init_EventStreamCodec();
  init_HeaderMarshaller();
  init_Int64();
  init_Message();
  init_MessageDecoderStream();
  init_MessageEncoderStream();
  init_SmithyMessageDecoderStream();
  init_SmithyMessageEncoderStream();
});
function getChunkedStream(source) {
  let currentMessageTotalLength = 0;
  let currentMessagePendingLength = 0;
  let currentMessage = null;
  let messageLengthBuffer = null;
  const allocateMessage = (size) => {
    if (typeof size !== "number") {
      throw new Error("Attempted to allocate an event message where size was not a number: " + size);
    }
    currentMessageTotalLength = size;
    currentMessagePendingLength = 4;
    currentMessage = new Uint8Array(size);
    const currentMessageView = new DataView(currentMessage.buffer);
    currentMessageView.setUint32(0, size, false);
  };
  const iterator = async function* () {
    const sourceIterator = source[Symbol.asyncIterator]();
    while (true) {
      const { value, done } = await sourceIterator.next();
      if (done) {
        if (!currentMessageTotalLength) {
          return;
        } else if (currentMessageTotalLength === currentMessagePendingLength) {
          yield currentMessage;
        } else {
          throw new Error("Truncated event message received.");
        }
        return;
      }
      const chunkLength = value.length;
      let currentOffset = 0;
      while (currentOffset < chunkLength) {
        if (!currentMessage) {
          const bytesRemaining = chunkLength - currentOffset;
          if (!messageLengthBuffer) {
            messageLengthBuffer = new Uint8Array(4);
          }
          const numBytesForTotal = Math.min(4 - currentMessagePendingLength, bytesRemaining);
          messageLengthBuffer.set(value.slice(currentOffset, currentOffset + numBytesForTotal), currentMessagePendingLength);
          currentMessagePendingLength += numBytesForTotal;
          currentOffset += numBytesForTotal;
          if (currentMessagePendingLength < 4) {
            break;
          }
          allocateMessage(new DataView(messageLengthBuffer.buffer).getUint32(0, false));
          messageLengthBuffer = null;
        }
        const numBytesToWrite = Math.min(currentMessageTotalLength - currentMessagePendingLength, chunkLength - currentOffset);
        currentMessage.set(value.slice(currentOffset, currentOffset + numBytesToWrite), currentMessagePendingLength);
        currentMessagePendingLength += numBytesToWrite;
        currentOffset += numBytesToWrite;
        if (currentMessageTotalLength && currentMessageTotalLength === currentMessagePendingLength) {
          yield currentMessage;
          currentMessage = null;
          currentMessageTotalLength = 0;
          currentMessagePendingLength = 0;
        }
      }
    }
  };
  return {
    [Symbol.asyncIterator]: iterator
  };
}
function getMessageUnmarshaller(deserializer, toUtf84) {
  return async function(message) {
    const { value: messageType } = message.headers[":message-type"];
    if (messageType === "error") {
      const unmodeledError = new Error(message.headers[":error-message"].value || "UnknownError");
      unmodeledError.name = message.headers[":error-code"].value;
      throw unmodeledError;
    } else if (messageType === "exception") {
      const code = message.headers[":exception-type"].value;
      const exception2 = { [code]: message };
      const deserializedException = await deserializer(exception2);
      if (deserializedException.$unknown) {
        const error = new Error(toUtf84(message.body));
        error.name = code;
        throw error;
      }
      throw deserializedException[code];
    } else if (messageType === "event") {
      const event = {
        [message.headers[":event-type"].value]: message
      };
      const deserialized = await deserializer(event);
      if (deserialized.$unknown)
        return;
      return deserialized;
    } else {
      throw Error(`Unrecognizable event type: ${message.headers[":event-type"].value}`);
    }
  };
}

class EventStreamMarshaller {
  constructor({ utf8Encoder, utf8Decoder }) {
    this.eventStreamCodec = new EventStreamCodec(utf8Encoder, utf8Decoder);
    this.utfEncoder = utf8Encoder;
  }
  deserialize(body, deserializer) {
    const inputStream = getChunkedStream(body);
    return new SmithyMessageDecoderStream({
      messageStream: new MessageDecoderStream({ inputStream, decoder: this.eventStreamCodec }),
      deserializer: getMessageUnmarshaller(deserializer, this.utfEncoder)
    });
  }
  serialize(inputStream, serializer) {
    return new MessageEncoderStream({
      messageStream: new SmithyMessageEncoderStream({ inputStream, serializer }),
      encoder: this.eventStreamCodec,
      includeEndFrame: true
    });
  }
}
var init_EventStreamMarshaller = __esm2(() => {
  init_dist_es56();
});
var init_provider = __esm2(() => {
  init_EventStreamMarshaller();
});
var init_dist_es57 = __esm2(() => {
  init_EventStreamMarshaller();
  init_provider();
});
async function* readabletoIterable(readStream) {
  let streamEnded = false;
  let generationEnded = false;
  const records = new Array;
  readStream.on("error", (err22) => {
    if (!streamEnded) {
      streamEnded = true;
    }
    if (err22) {
      throw err22;
    }
  });
  readStream.on("data", (data2) => {
    records.push(data2);
  });
  readStream.on("end", () => {
    streamEnded = true;
  });
  while (!generationEnded) {
    const value = await new Promise((resolve5) => setTimeout(() => resolve5(records.shift()), 0));
    if (value) {
      yield value;
    }
    generationEnded = streamEnded && records.length === 0;
  }
}

class EventStreamMarshaller3 {
  constructor({ utf8Encoder, utf8Decoder }) {
    this.universalMarshaller = new EventStreamMarshaller({
      utf8Decoder,
      utf8Encoder
    });
  }
  deserialize(body, deserializer) {
    const bodyIterable = typeof body[Symbol.asyncIterator] === "function" ? body : readabletoIterable(body);
    return this.universalMarshaller.deserialize(bodyIterable, deserializer);
  }
  serialize(input, serializer) {
    return Readable5.from(this.universalMarshaller.serialize(input, serializer));
  }
}
var init_EventStreamMarshaller2 = __esm2(() => {
  init_dist_es57();
});
var eventStreamSerdeProvider = (options3) => new EventStreamMarshaller3(options3);
var init_provider2 = __esm2(() => {
  init_EventStreamMarshaller2();
});
var init_dist_es58 = __esm2(() => {
  init_EventStreamMarshaller2();
  init_provider2();
});
var HashCalculator;
var init_HashCalculator = __esm2(() => {
  init_dist_es6();
  HashCalculator = class HashCalculator2 extends Writable3 {
    constructor(hash3, options3) {
      super(options3);
      this.hash = hash3;
    }
    _write(chunk, encoding, callback) {
      try {
        this.hash.update(toUint8Array2(chunk));
      } catch (err22) {
        return callback(err22);
      }
      callback();
    }
  };
});
var init_fileStreamHasher = __esm2(() => {
  init_HashCalculator();
});
var readableStreamHasher = (hashCtor, readableStream) => {
  if (readableStream.readableFlowing !== null) {
    throw new Error("Unable to calculate hash for flowing readable stream");
  }
  const hash3 = new hashCtor;
  const hashCalculator = new HashCalculator(hash3);
  readableStream.pipe(hashCalculator);
  return new Promise((resolve5, reject) => {
    readableStream.on("error", (err22) => {
      hashCalculator.end();
      reject(err22);
    });
    hashCalculator.on("error", reject);
    hashCalculator.on("finish", () => {
      hash3.digest().then(resolve5).catch(reject);
    });
  });
};
var init_readableStreamHasher = __esm2(() => {
  init_HashCalculator();
});
var init_dist_es59 = __esm2(() => {
  init_fileStreamHasher();
  init_readableStreamHasher();
});
var import_core36;
var getRuntimeConfig7 = (config9) => {
  return {
    apiVersion: "2006-03-01",
    base64Decoder: config9?.base64Decoder ?? fromBase642,
    base64Encoder: config9?.base64Encoder ?? toBase643,
    disableHostPrefix: config9?.disableHostPrefix ?? false,
    endpointProvider: config9?.endpointProvider ?? defaultEndpointResolver,
    extensions: config9?.extensions ?? [],
    getAwsChunkedEncodingStream: config9?.getAwsChunkedEncodingStream ?? getAwsChunkedEncodingStream2,
    httpAuthSchemeProvider: config9?.httpAuthSchemeProvider ?? defaultS3HttpAuthSchemeProvider,
    httpAuthSchemes: config9?.httpAuthSchemes ?? [
      {
        schemeId: "aws.auth#sigv4",
        identityProvider: (ipc) => ipc.getIdentityProvider("aws.auth#sigv4"),
        signer: new import_core36.AwsSdkSigV4Signer
      },
      {
        schemeId: "aws.auth#sigv4a",
        identityProvider: (ipc) => ipc.getIdentityProvider("aws.auth#sigv4a"),
        signer: new import_core36.AwsSdkSigV4ASigner
      }
    ],
    logger: config9?.logger ?? new NoOpLogger,
    sdkStreamMixin: config9?.sdkStreamMixin ?? sdkStreamMixin3,
    serviceId: config9?.serviceId ?? "S3",
    signerConstructor: config9?.signerConstructor ?? SignatureV4MultiRegion,
    signingEscapePath: config9?.signingEscapePath ?? false,
    urlParser: config9?.urlParser ?? parseUrl,
    useArnRegion: config9?.useArnRegion ?? false,
    utf8Decoder: config9?.utf8Decoder ?? fromUtf84,
    utf8Encoder: config9?.utf8Encoder ?? toUtf82
  };
};
var init_runtimeConfig_shared4 = __esm2(() => {
  import_core36 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es36();
  init_dist_es12();
  init_dist_es30();
  init_dist_es16();
  init_dist_es19();
  init_dist_es6();
  init_httpAuthSchemeProvider();
  init_endpointResolver();
});
var import_core37;
var getRuntimeConfig8 = (config9) => {
  emitWarningIfUnsupportedVersion(process.version);
  const defaultsMode = resolveDefaultsModeConfig(config9);
  const defaultConfigProvider = () => defaultsMode().then(loadConfigsForDefaultMode);
  const clientSharedValues = getRuntimeConfig7(config9);
  import_core37.emitWarningIfUnsupportedVersion(process.version);
  return {
    ...clientSharedValues,
    ...config9,
    runtime: "node",
    defaultsMode,
    bodyLengthChecker: config9?.bodyLengthChecker ?? calculateBodyLength,
    credentialDefaultProvider: config9?.credentialDefaultProvider ?? defaultProvider,
    defaultUserAgentProvider: config9?.defaultUserAgentProvider ?? createDefaultUserAgentProvider({ serviceId: clientSharedValues.serviceId, clientVersion: package_default.version }),
    disableS3ExpressSessionAuth: config9?.disableS3ExpressSessionAuth ?? loadConfig(NODE_DISABLE_S3_EXPRESS_SESSION_AUTH_OPTIONS),
    eventStreamSerdeProvider: config9?.eventStreamSerdeProvider ?? eventStreamSerdeProvider,
    maxAttempts: config9?.maxAttempts ?? loadConfig(NODE_MAX_ATTEMPT_CONFIG_OPTIONS),
    md5: config9?.md5 ?? Hash.bind(null, "md5"),
    region: config9?.region ?? loadConfig(NODE_REGION_CONFIG_OPTIONS, NODE_REGION_CONFIG_FILE_OPTIONS),
    requestChecksumCalculation: config9?.requestChecksumCalculation ?? loadConfig(NODE_REQUEST_CHECKSUM_CALCULATION_CONFIG_OPTIONS),
    requestHandler: NodeHttpHandler.create(config9?.requestHandler ?? defaultConfigProvider),
    responseChecksumValidation: config9?.responseChecksumValidation ?? loadConfig(NODE_RESPONSE_CHECKSUM_VALIDATION_CONFIG_OPTIONS),
    retryMode: config9?.retryMode ?? loadConfig({
      ...NODE_RETRY_MODE_CONFIG_OPTIONS,
      default: async () => (await defaultConfigProvider()).retryMode || DEFAULT_RETRY_MODE
    }),
    sha1: config9?.sha1 ?? Hash.bind(null, "sha1"),
    sha256: config9?.sha256 ?? Hash.bind(null, "sha256"),
    sigv4aSigningRegionSet: config9?.sigv4aSigningRegionSet ?? loadConfig(import_core37.NODE_SIGV4A_CONFIG_OPTIONS),
    streamCollector: config9?.streamCollector ?? streamCollector,
    streamHasher: config9?.streamHasher ?? readableStreamHasher,
    useArnRegion: config9?.useArnRegion ?? loadConfig(NODE_USE_ARN_REGION_CONFIG_OPTIONS),
    useDualstackEndpoint: config9?.useDualstackEndpoint ?? loadConfig(NODE_USE_DUALSTACK_ENDPOINT_CONFIG_OPTIONS),
    useFipsEndpoint: config9?.useFipsEndpoint ?? loadConfig(NODE_USE_FIPS_ENDPOINT_CONFIG_OPTIONS),
    userAgentAppId: config9?.userAgentAppId ?? loadConfig(NODE_APP_ID_CONFIG_OPTIONS)
  };
};
var init_runtimeConfig4 = __esm2(() => {
  init_package3();
  import_core37 = __toESM3(require_dist_cjs20(), 1);
  init_dist_es54();
  init_dist_es55();
  init_dist_es7();
  init_dist_es20();
  init_dist_es41();
  init_dist_es24();
  init_dist_es58();
  init_dist_es42();
  init_dist_es59();
  init_dist_es35();
  init_dist_es29();
  init_dist_es18();
  init_dist_es43();
  init_dist_es34();
  init_runtimeConfig_shared4();
  init_dist_es12();
  init_dist_es44();
  init_dist_es12();
});
var getHttpAuthExtensionConfiguration4 = (runtimeConfig) => {
  const _httpAuthSchemes = runtimeConfig.httpAuthSchemes;
  let _httpAuthSchemeProvider = runtimeConfig.httpAuthSchemeProvider;
  let _credentials = runtimeConfig.credentials;
  return {
    setHttpAuthScheme(httpAuthScheme) {
      const index = _httpAuthSchemes.findIndex((scheme) => scheme.schemeId === httpAuthScheme.schemeId);
      if (index === -1) {
        _httpAuthSchemes.push(httpAuthScheme);
      } else {
        _httpAuthSchemes.splice(index, 1, httpAuthScheme);
      }
    },
    httpAuthSchemes() {
      return _httpAuthSchemes;
    },
    setHttpAuthSchemeProvider(httpAuthSchemeProvider) {
      _httpAuthSchemeProvider = httpAuthSchemeProvider;
    },
    httpAuthSchemeProvider() {
      return _httpAuthSchemeProvider;
    },
    setCredentials(credentials) {
      _credentials = credentials;
    },
    credentials() {
      return _credentials;
    }
  };
};
var resolveHttpAuthRuntimeConfig4 = (config9) => {
  return {
    httpAuthSchemes: config9.httpAuthSchemes(),
    httpAuthSchemeProvider: config9.httpAuthSchemeProvider(),
    credentials: config9.credentials()
  };
};
var asPartial4 = (t5) => t5;
var resolveRuntimeExtensions4 = (runtimeConfig, extensions4) => {
  const extensionConfiguration = {
    ...asPartial4(getAwsRegionExtensionConfiguration(runtimeConfig)),
    ...asPartial4(getDefaultExtensionConfiguration(runtimeConfig)),
    ...asPartial4(getHttpHandlerExtensionConfiguration(runtimeConfig)),
    ...asPartial4(getHttpAuthExtensionConfiguration4(runtimeConfig))
  };
  extensions4.forEach((extension2) => extension2.configure(extensionConfiguration));
  return {
    ...runtimeConfig,
    ...resolveAwsRegionExtensionConfiguration(extensionConfiguration),
    ...resolveDefaultRuntimeConfig(extensionConfiguration),
    ...resolveHttpHandlerRuntimeConfig(extensionConfiguration),
    ...resolveHttpAuthRuntimeConfig4(extensionConfiguration)
  };
};
var init_runtimeExtensions4 = __esm2(() => {
  init_dist_es45();
  init_dist_es();
  init_dist_es12();
});
var import_core38;
var S3Client;
var init_S3Client = __esm2(() => {
  init_dist_es2();
  init_dist_es7();
  init_dist_es8();
  init_dist_es9();
  init_dist_es10();
  init_dist_es20();
  init_dist_es23();
  init_dist_es24();
  import_core38 = __toESM3(require_dist_cjs15(), 1);
  init_dist_es25();
  init_dist_es26();
  init_dist_es32();
  init_dist_es35();
  init_dist_es12();
  init_httpAuthSchemeProvider();
  init_CreateSessionCommand();
  init_EndpointParameters();
  init_runtimeConfig4();
  init_runtimeExtensions4();
  S3Client = class S3Client2 extends Client {
    constructor(...[configuration]) {
      const _config_0 = getRuntimeConfig8(configuration || {});
      const _config_1 = resolveClientEndpointParameters(_config_0);
      const _config_2 = resolveUserAgentConfig(_config_1);
      const _config_3 = resolveFlexibleChecksumsConfig(_config_2);
      const _config_4 = resolveRetryConfig(_config_3);
      const _config_5 = resolveRegionConfig(_config_4);
      const _config_6 = resolveHostHeaderConfig(_config_5);
      const _config_7 = resolveEndpointConfig(_config_6);
      const _config_8 = resolveEventStreamSerdeConfig(_config_7);
      const _config_9 = resolveHttpAuthSchemeConfig(_config_8);
      const _config_10 = resolveS3Config(_config_9, { session: [() => this, CreateSessionCommand] });
      const _config_11 = resolveRuntimeExtensions4(_config_10, configuration?.extensions || []);
      super(_config_11);
      this.config = _config_11;
      this.middlewareStack.use(getUserAgentPlugin(this.config));
      this.middlewareStack.use(getRetryPlugin(this.config));
      this.middlewareStack.use(getContentLengthPlugin(this.config));
      this.middlewareStack.use(getHostHeaderPlugin(this.config));
      this.middlewareStack.use(getLoggerPlugin(this.config));
      this.middlewareStack.use(getRecursionDetectionPlugin(this.config));
      this.middlewareStack.use(import_core38.getHttpAuthSchemeEndpointRuleSetPlugin(this.config, {
        httpAuthSchemeParametersProvider: defaultS3HttpAuthSchemeParametersProvider,
        identityProviderConfigProvider: async (config9) => new import_core38.DefaultIdentityProviderConfig({
          "aws.auth#sigv4": config9.credentials,
          "aws.auth#sigv4a": config9.credentials
        })
      }));
      this.middlewareStack.use(import_core38.getHttpSigningPlugin(this.config));
      this.middlewareStack.use(getValidateBucketNamePlugin(this.config));
      this.middlewareStack.use(getAddExpectContinuePlugin(this.config));
      this.middlewareStack.use(getRegionRedirectMiddlewarePlugin(this.config));
      this.middlewareStack.use(getS3ExpressPlugin(this.config));
      this.middlewareStack.use(getS3ExpressHttpSigningPlugin(this.config));
    }
    destroy() {
      super.destroy();
    }
  };
});
var AbortMultipartUploadCommand;
var init_AbortMultipartUploadCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  AbortMultipartUploadCommand = class AbortMultipartUploadCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "AbortMultipartUpload", {}).n("S3Client", "AbortMultipartUploadCommand").f(undefined, undefined).ser(se_AbortMultipartUploadCommand).de(de_AbortMultipartUploadCommand).build() {
  };
});
function ssecMiddleware(options3) {
  return (next) => async (args) => {
    const input = { ...args.input };
    const properties = [
      {
        target: "SSECustomerKey",
        hash: "SSECustomerKeyMD5"
      },
      {
        target: "CopySourceSSECustomerKey",
        hash: "CopySourceSSECustomerKeyMD5"
      }
    ];
    for (const prop of properties) {
      const value = input[prop.target];
      if (value) {
        let valueForHash;
        if (typeof value === "string") {
          if (isValidBase64EncodedSSECustomerKey(value, options3)) {
            valueForHash = options3.base64Decoder(value);
          } else {
            valueForHash = options3.utf8Decoder(value);
            input[prop.target] = options3.base64Encoder(valueForHash);
          }
        } else {
          valueForHash = ArrayBuffer.isView(value) ? new Uint8Array(value.buffer, value.byteOffset, value.byteLength) : new Uint8Array(value);
          input[prop.target] = options3.base64Encoder(valueForHash);
        }
        const hash3 = new options3.md5;
        hash3.update(valueForHash);
        input[prop.hash] = options3.base64Encoder(await hash3.digest());
      }
    }
    return next({
      ...args,
      input
    });
  };
}
function isValidBase64EncodedSSECustomerKey(str2, options3) {
  const base64Regex = /^(?:[A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/;
  if (!base64Regex.test(str2))
    return false;
  try {
    const decodedBytes = options3.base64Decoder(str2);
    return decodedBytes.length === 32;
  } catch {
    return false;
  }
}
var ssecMiddlewareOptions;
var getSsecPlugin = (config9) => ({
  applyToStack: (clientStack) => {
    clientStack.add(ssecMiddleware(config9), ssecMiddlewareOptions);
  }
});
var init_dist_es60 = __esm2(() => {
  ssecMiddlewareOptions = {
    name: "ssecMiddleware",
    step: "initialize",
    tags: ["SSE"],
    override: true
  };
});
var CompleteMultipartUploadCommand;
var init_CompleteMultipartUploadCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  CompleteMultipartUploadCommand = class CompleteMultipartUploadCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "CompleteMultipartUpload", {}).n("S3Client", "CompleteMultipartUploadCommand").f(CompleteMultipartUploadRequestFilterSensitiveLog, CompleteMultipartUploadOutputFilterSensitiveLog).ser(se_CompleteMultipartUploadCommand).de(de_CompleteMultipartUploadCommand).build() {
  };
});
var CopyObjectCommand;
var init_CopyObjectCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  CopyObjectCommand = class CopyObjectCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    DisableS3ExpressSessionAuth: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" },
    CopySource: { type: "contextParams", name: "CopySource" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "CopyObject", {}).n("S3Client", "CopyObjectCommand").f(CopyObjectRequestFilterSensitiveLog, CopyObjectOutputFilterSensitiveLog).ser(se_CopyObjectCommand).de(de_CopyObjectCommand).build() {
  };
});
function locationConstraintMiddleware(options3) {
  return (next) => async (args) => {
    const { CreateBucketConfiguration } = args.input;
    const region = await options3.region();
    if (!CreateBucketConfiguration?.LocationConstraint && !CreateBucketConfiguration?.Location) {
      args = {
        ...args,
        input: {
          ...args.input,
          CreateBucketConfiguration: region === "us-east-1" ? undefined : { LocationConstraint: region }
        }
      };
    }
    return next(args);
  };
}
var locationConstraintMiddlewareOptions;
var getLocationConstraintPlugin = (config9) => ({
  applyToStack: (clientStack) => {
    clientStack.add(locationConstraintMiddleware(config9), locationConstraintMiddlewareOptions);
  }
});
var init_dist_es61 = __esm2(() => {
  locationConstraintMiddlewareOptions = {
    step: "initialize",
    tags: ["LOCATION_CONSTRAINT", "CREATE_BUCKET_CONFIGURATION"],
    name: "locationConstraintMiddleware",
    override: true
  };
});
var CreateBucketCommand;
var init_CreateBucketCommand = __esm2(() => {
  init_dist_es61();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  CreateBucketCommand = class CreateBucketCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    DisableAccessPoints: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getLocationConstraintPlugin(config9)
    ];
  }).s("AmazonS3", "CreateBucket", {}).n("S3Client", "CreateBucketCommand").f(undefined, undefined).ser(se_CreateBucketCommand).de(de_CreateBucketCommand).build() {
  };
});
var CreateMultipartUploadCommand;
var init_CreateMultipartUploadCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  CreateMultipartUploadCommand = class CreateMultipartUploadCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "CreateMultipartUpload", {}).n("S3Client", "CreateMultipartUploadCommand").f(CreateMultipartUploadRequestFilterSensitiveLog, CreateMultipartUploadOutputFilterSensitiveLog).ser(se_CreateMultipartUploadCommand).de(de_CreateMultipartUploadCommand).build() {
  };
});
var DeleteBucketAnalyticsConfigurationCommand;
var init_DeleteBucketAnalyticsConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketAnalyticsConfigurationCommand = class DeleteBucketAnalyticsConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketAnalyticsConfiguration", {}).n("S3Client", "DeleteBucketAnalyticsConfigurationCommand").f(undefined, undefined).ser(se_DeleteBucketAnalyticsConfigurationCommand).de(de_DeleteBucketAnalyticsConfigurationCommand).build() {
  };
});
var DeleteBucketCommand;
var init_DeleteBucketCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketCommand = class DeleteBucketCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucket", {}).n("S3Client", "DeleteBucketCommand").f(undefined, undefined).ser(se_DeleteBucketCommand).de(de_DeleteBucketCommand).build() {
  };
});
var DeleteBucketCorsCommand;
var init_DeleteBucketCorsCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketCorsCommand = class DeleteBucketCorsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketCors", {}).n("S3Client", "DeleteBucketCorsCommand").f(undefined, undefined).ser(se_DeleteBucketCorsCommand).de(de_DeleteBucketCorsCommand).build() {
  };
});
var DeleteBucketEncryptionCommand;
var init_DeleteBucketEncryptionCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketEncryptionCommand = class DeleteBucketEncryptionCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketEncryption", {}).n("S3Client", "DeleteBucketEncryptionCommand").f(undefined, undefined).ser(se_DeleteBucketEncryptionCommand).de(de_DeleteBucketEncryptionCommand).build() {
  };
});
var DeleteBucketIntelligentTieringConfigurationCommand;
var init_DeleteBucketIntelligentTieringConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketIntelligentTieringConfigurationCommand = class DeleteBucketIntelligentTieringConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketIntelligentTieringConfiguration", {}).n("S3Client", "DeleteBucketIntelligentTieringConfigurationCommand").f(undefined, undefined).ser(se_DeleteBucketIntelligentTieringConfigurationCommand).de(de_DeleteBucketIntelligentTieringConfigurationCommand).build() {
  };
});
var DeleteBucketInventoryConfigurationCommand;
var init_DeleteBucketInventoryConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketInventoryConfigurationCommand = class DeleteBucketInventoryConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketInventoryConfiguration", {}).n("S3Client", "DeleteBucketInventoryConfigurationCommand").f(undefined, undefined).ser(se_DeleteBucketInventoryConfigurationCommand).de(de_DeleteBucketInventoryConfigurationCommand).build() {
  };
});
var DeleteBucketLifecycleCommand;
var init_DeleteBucketLifecycleCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketLifecycleCommand = class DeleteBucketLifecycleCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketLifecycle", {}).n("S3Client", "DeleteBucketLifecycleCommand").f(undefined, undefined).ser(se_DeleteBucketLifecycleCommand).de(de_DeleteBucketLifecycleCommand).build() {
  };
});
var DeleteBucketMetricsConfigurationCommand;
var init_DeleteBucketMetricsConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketMetricsConfigurationCommand = class DeleteBucketMetricsConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketMetricsConfiguration", {}).n("S3Client", "DeleteBucketMetricsConfigurationCommand").f(undefined, undefined).ser(se_DeleteBucketMetricsConfigurationCommand).de(de_DeleteBucketMetricsConfigurationCommand).build() {
  };
});
var DeleteBucketOwnershipControlsCommand;
var init_DeleteBucketOwnershipControlsCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketOwnershipControlsCommand = class DeleteBucketOwnershipControlsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketOwnershipControls", {}).n("S3Client", "DeleteBucketOwnershipControlsCommand").f(undefined, undefined).ser(se_DeleteBucketOwnershipControlsCommand).de(de_DeleteBucketOwnershipControlsCommand).build() {
  };
});
var DeleteBucketPolicyCommand;
var init_DeleteBucketPolicyCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketPolicyCommand = class DeleteBucketPolicyCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketPolicy", {}).n("S3Client", "DeleteBucketPolicyCommand").f(undefined, undefined).ser(se_DeleteBucketPolicyCommand).de(de_DeleteBucketPolicyCommand).build() {
  };
});
var DeleteBucketReplicationCommand;
var init_DeleteBucketReplicationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketReplicationCommand = class DeleteBucketReplicationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketReplication", {}).n("S3Client", "DeleteBucketReplicationCommand").f(undefined, undefined).ser(se_DeleteBucketReplicationCommand).de(de_DeleteBucketReplicationCommand).build() {
  };
});
var DeleteBucketTaggingCommand;
var init_DeleteBucketTaggingCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketTaggingCommand = class DeleteBucketTaggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketTagging", {}).n("S3Client", "DeleteBucketTaggingCommand").f(undefined, undefined).ser(se_DeleteBucketTaggingCommand).de(de_DeleteBucketTaggingCommand).build() {
  };
});
var DeleteBucketWebsiteCommand;
var init_DeleteBucketWebsiteCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteBucketWebsiteCommand = class DeleteBucketWebsiteCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeleteBucketWebsite", {}).n("S3Client", "DeleteBucketWebsiteCommand").f(undefined, undefined).ser(se_DeleteBucketWebsiteCommand).de(de_DeleteBucketWebsiteCommand).build() {
  };
});
var DeleteObjectCommand;
var init_DeleteObjectCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteObjectCommand = class DeleteObjectCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "DeleteObject", {}).n("S3Client", "DeleteObjectCommand").f(undefined, undefined).ser(se_DeleteObjectCommand).de(de_DeleteObjectCommand).build() {
  };
});
var DeleteObjectsCommand;
var init_DeleteObjectsCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteObjectsCommand = class DeleteObjectsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "DeleteObjects", {}).n("S3Client", "DeleteObjectsCommand").f(undefined, undefined).ser(se_DeleteObjectsCommand).de(de_DeleteObjectsCommand).build() {
  };
});
var DeleteObjectTaggingCommand;
var init_DeleteObjectTaggingCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeleteObjectTaggingCommand = class DeleteObjectTaggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "DeleteObjectTagging", {}).n("S3Client", "DeleteObjectTaggingCommand").f(undefined, undefined).ser(se_DeleteObjectTaggingCommand).de(de_DeleteObjectTaggingCommand).build() {
  };
});
var DeletePublicAccessBlockCommand;
var init_DeletePublicAccessBlockCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  DeletePublicAccessBlockCommand = class DeletePublicAccessBlockCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "DeletePublicAccessBlock", {}).n("S3Client", "DeletePublicAccessBlockCommand").f(undefined, undefined).ser(se_DeletePublicAccessBlockCommand).de(de_DeletePublicAccessBlockCommand).build() {
  };
});
var GetBucketAccelerateConfigurationCommand;
var init_GetBucketAccelerateConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketAccelerateConfigurationCommand = class GetBucketAccelerateConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketAccelerateConfiguration", {}).n("S3Client", "GetBucketAccelerateConfigurationCommand").f(undefined, undefined).ser(se_GetBucketAccelerateConfigurationCommand).de(de_GetBucketAccelerateConfigurationCommand).build() {
  };
});
var GetBucketAclCommand;
var init_GetBucketAclCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketAclCommand = class GetBucketAclCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketAcl", {}).n("S3Client", "GetBucketAclCommand").f(undefined, undefined).ser(se_GetBucketAclCommand).de(de_GetBucketAclCommand).build() {
  };
});
var GetBucketAnalyticsConfigurationCommand;
var init_GetBucketAnalyticsConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketAnalyticsConfigurationCommand = class GetBucketAnalyticsConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketAnalyticsConfiguration", {}).n("S3Client", "GetBucketAnalyticsConfigurationCommand").f(undefined, undefined).ser(se_GetBucketAnalyticsConfigurationCommand).de(de_GetBucketAnalyticsConfigurationCommand).build() {
  };
});
var GetBucketCorsCommand;
var init_GetBucketCorsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketCorsCommand = class GetBucketCorsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketCors", {}).n("S3Client", "GetBucketCorsCommand").f(undefined, undefined).ser(se_GetBucketCorsCommand).de(de_GetBucketCorsCommand).build() {
  };
});
var GetBucketEncryptionCommand;
var init_GetBucketEncryptionCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  GetBucketEncryptionCommand = class GetBucketEncryptionCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketEncryption", {}).n("S3Client", "GetBucketEncryptionCommand").f(undefined, GetBucketEncryptionOutputFilterSensitiveLog).ser(se_GetBucketEncryptionCommand).de(de_GetBucketEncryptionCommand).build() {
  };
});
var GetBucketIntelligentTieringConfigurationCommand;
var init_GetBucketIntelligentTieringConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketIntelligentTieringConfigurationCommand = class GetBucketIntelligentTieringConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketIntelligentTieringConfiguration", {}).n("S3Client", "GetBucketIntelligentTieringConfigurationCommand").f(undefined, undefined).ser(se_GetBucketIntelligentTieringConfigurationCommand).de(de_GetBucketIntelligentTieringConfigurationCommand).build() {
  };
});
var GetBucketInventoryConfigurationCommand;
var init_GetBucketInventoryConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  GetBucketInventoryConfigurationCommand = class GetBucketInventoryConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketInventoryConfiguration", {}).n("S3Client", "GetBucketInventoryConfigurationCommand").f(undefined, GetBucketInventoryConfigurationOutputFilterSensitiveLog).ser(se_GetBucketInventoryConfigurationCommand).de(de_GetBucketInventoryConfigurationCommand).build() {
  };
});
var GetBucketLifecycleConfigurationCommand;
var init_GetBucketLifecycleConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketLifecycleConfigurationCommand = class GetBucketLifecycleConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketLifecycleConfiguration", {}).n("S3Client", "GetBucketLifecycleConfigurationCommand").f(undefined, undefined).ser(se_GetBucketLifecycleConfigurationCommand).de(de_GetBucketLifecycleConfigurationCommand).build() {
  };
});
var GetBucketLocationCommand;
var init_GetBucketLocationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketLocationCommand = class GetBucketLocationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketLocation", {}).n("S3Client", "GetBucketLocationCommand").f(undefined, undefined).ser(se_GetBucketLocationCommand).de(de_GetBucketLocationCommand).build() {
  };
});
var GetBucketLoggingCommand;
var init_GetBucketLoggingCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketLoggingCommand = class GetBucketLoggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketLogging", {}).n("S3Client", "GetBucketLoggingCommand").f(undefined, undefined).ser(se_GetBucketLoggingCommand).de(de_GetBucketLoggingCommand).build() {
  };
});
var GetBucketMetricsConfigurationCommand;
var init_GetBucketMetricsConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketMetricsConfigurationCommand = class GetBucketMetricsConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketMetricsConfiguration", {}).n("S3Client", "GetBucketMetricsConfigurationCommand").f(undefined, undefined).ser(se_GetBucketMetricsConfigurationCommand).de(de_GetBucketMetricsConfigurationCommand).build() {
  };
});
var GetBucketNotificationConfigurationCommand;
var init_GetBucketNotificationConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketNotificationConfigurationCommand = class GetBucketNotificationConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketNotificationConfiguration", {}).n("S3Client", "GetBucketNotificationConfigurationCommand").f(undefined, undefined).ser(se_GetBucketNotificationConfigurationCommand).de(de_GetBucketNotificationConfigurationCommand).build() {
  };
});
var GetBucketOwnershipControlsCommand;
var init_GetBucketOwnershipControlsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketOwnershipControlsCommand = class GetBucketOwnershipControlsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketOwnershipControls", {}).n("S3Client", "GetBucketOwnershipControlsCommand").f(undefined, undefined).ser(se_GetBucketOwnershipControlsCommand).de(de_GetBucketOwnershipControlsCommand).build() {
  };
});
var GetBucketPolicyCommand;
var init_GetBucketPolicyCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketPolicyCommand = class GetBucketPolicyCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketPolicy", {}).n("S3Client", "GetBucketPolicyCommand").f(undefined, undefined).ser(se_GetBucketPolicyCommand).de(de_GetBucketPolicyCommand).build() {
  };
});
var GetBucketPolicyStatusCommand;
var init_GetBucketPolicyStatusCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketPolicyStatusCommand = class GetBucketPolicyStatusCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketPolicyStatus", {}).n("S3Client", "GetBucketPolicyStatusCommand").f(undefined, undefined).ser(se_GetBucketPolicyStatusCommand).de(de_GetBucketPolicyStatusCommand).build() {
  };
});
var GetBucketReplicationCommand;
var init_GetBucketReplicationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketReplicationCommand = class GetBucketReplicationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketReplication", {}).n("S3Client", "GetBucketReplicationCommand").f(undefined, undefined).ser(se_GetBucketReplicationCommand).de(de_GetBucketReplicationCommand).build() {
  };
});
var GetBucketRequestPaymentCommand;
var init_GetBucketRequestPaymentCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketRequestPaymentCommand = class GetBucketRequestPaymentCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketRequestPayment", {}).n("S3Client", "GetBucketRequestPaymentCommand").f(undefined, undefined).ser(se_GetBucketRequestPaymentCommand).de(de_GetBucketRequestPaymentCommand).build() {
  };
});
var GetBucketTaggingCommand;
var init_GetBucketTaggingCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketTaggingCommand = class GetBucketTaggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketTagging", {}).n("S3Client", "GetBucketTaggingCommand").f(undefined, undefined).ser(se_GetBucketTaggingCommand).de(de_GetBucketTaggingCommand).build() {
  };
});
var GetBucketVersioningCommand;
var init_GetBucketVersioningCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketVersioningCommand = class GetBucketVersioningCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketVersioning", {}).n("S3Client", "GetBucketVersioningCommand").f(undefined, undefined).ser(se_GetBucketVersioningCommand).de(de_GetBucketVersioningCommand).build() {
  };
});
var GetBucketWebsiteCommand;
var init_GetBucketWebsiteCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetBucketWebsiteCommand = class GetBucketWebsiteCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetBucketWebsite", {}).n("S3Client", "GetBucketWebsiteCommand").f(undefined, undefined).ser(se_GetBucketWebsiteCommand).de(de_GetBucketWebsiteCommand).build() {
  };
});
var GetObjectAclCommand;
var init_GetObjectAclCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetObjectAclCommand = class GetObjectAclCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetObjectAcl", {}).n("S3Client", "GetObjectAclCommand").f(undefined, undefined).ser(se_GetObjectAclCommand).de(de_GetObjectAclCommand).build() {
  };
});
var GetObjectAttributesCommand;
var init_GetObjectAttributesCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  GetObjectAttributesCommand = class GetObjectAttributesCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "GetObjectAttributes", {}).n("S3Client", "GetObjectAttributesCommand").f(GetObjectAttributesRequestFilterSensitiveLog, undefined).ser(se_GetObjectAttributesCommand).de(de_GetObjectAttributesCommand).build() {
  };
});
var GetObjectCommand;
var init_GetObjectCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  GetObjectCommand = class GetObjectCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestChecksumRequired: false,
        requestValidationModeMember: "ChecksumMode",
        responseAlgorithms: ["CRC32", "CRC32C", "SHA256", "SHA1"]
      }),
      getSsecPlugin(config9),
      getS3ExpiresMiddlewarePlugin(config9)
    ];
  }).s("AmazonS3", "GetObject", {}).n("S3Client", "GetObjectCommand").f(GetObjectRequestFilterSensitiveLog, GetObjectOutputFilterSensitiveLog).ser(se_GetObjectCommand).de(de_GetObjectCommand).build() {
  };
});
var GetObjectLegalHoldCommand;
var init_GetObjectLegalHoldCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetObjectLegalHoldCommand = class GetObjectLegalHoldCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetObjectLegalHold", {}).n("S3Client", "GetObjectLegalHoldCommand").f(undefined, undefined).ser(se_GetObjectLegalHoldCommand).de(de_GetObjectLegalHoldCommand).build() {
  };
});
var GetObjectLockConfigurationCommand;
var init_GetObjectLockConfigurationCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetObjectLockConfigurationCommand = class GetObjectLockConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetObjectLockConfiguration", {}).n("S3Client", "GetObjectLockConfigurationCommand").f(undefined, undefined).ser(se_GetObjectLockConfigurationCommand).de(de_GetObjectLockConfigurationCommand).build() {
  };
});
var GetObjectRetentionCommand;
var init_GetObjectRetentionCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetObjectRetentionCommand = class GetObjectRetentionCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetObjectRetention", {}).n("S3Client", "GetObjectRetentionCommand").f(undefined, undefined).ser(se_GetObjectRetentionCommand).de(de_GetObjectRetentionCommand).build() {
  };
});
var GetObjectTaggingCommand;
var init_GetObjectTaggingCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetObjectTaggingCommand = class GetObjectTaggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetObjectTagging", {}).n("S3Client", "GetObjectTaggingCommand").f(undefined, undefined).ser(se_GetObjectTaggingCommand).de(de_GetObjectTaggingCommand).build() {
  };
});
var GetObjectTorrentCommand;
var init_GetObjectTorrentCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  GetObjectTorrentCommand = class GetObjectTorrentCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "GetObjectTorrent", {}).n("S3Client", "GetObjectTorrentCommand").f(undefined, GetObjectTorrentOutputFilterSensitiveLog).ser(se_GetObjectTorrentCommand).de(de_GetObjectTorrentCommand).build() {
  };
});
var GetPublicAccessBlockCommand;
var init_GetPublicAccessBlockCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  GetPublicAccessBlockCommand = class GetPublicAccessBlockCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "GetPublicAccessBlock", {}).n("S3Client", "GetPublicAccessBlockCommand").f(undefined, undefined).ser(se_GetPublicAccessBlockCommand).de(de_GetPublicAccessBlockCommand).build() {
  };
});
var HeadBucketCommand;
var init_HeadBucketCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  HeadBucketCommand = class HeadBucketCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "HeadBucket", {}).n("S3Client", "HeadBucketCommand").f(undefined, undefined).ser(se_HeadBucketCommand).de(de_HeadBucketCommand).build() {
  };
});
var HeadObjectCommand;
var init_HeadObjectCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  HeadObjectCommand = class HeadObjectCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9),
      getS3ExpiresMiddlewarePlugin(config9)
    ];
  }).s("AmazonS3", "HeadObject", {}).n("S3Client", "HeadObjectCommand").f(HeadObjectRequestFilterSensitiveLog, HeadObjectOutputFilterSensitiveLog).ser(se_HeadObjectCommand).de(de_HeadObjectCommand).build() {
  };
});
var ListBucketAnalyticsConfigurationsCommand;
var init_ListBucketAnalyticsConfigurationsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListBucketAnalyticsConfigurationsCommand = class ListBucketAnalyticsConfigurationsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListBucketAnalyticsConfigurations", {}).n("S3Client", "ListBucketAnalyticsConfigurationsCommand").f(undefined, undefined).ser(se_ListBucketAnalyticsConfigurationsCommand).de(de_ListBucketAnalyticsConfigurationsCommand).build() {
  };
});
var ListBucketIntelligentTieringConfigurationsCommand;
var init_ListBucketIntelligentTieringConfigurationsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListBucketIntelligentTieringConfigurationsCommand = class ListBucketIntelligentTieringConfigurationsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListBucketIntelligentTieringConfigurations", {}).n("S3Client", "ListBucketIntelligentTieringConfigurationsCommand").f(undefined, undefined).ser(se_ListBucketIntelligentTieringConfigurationsCommand).de(de_ListBucketIntelligentTieringConfigurationsCommand).build() {
  };
});
var ListBucketInventoryConfigurationsCommand;
var init_ListBucketInventoryConfigurationsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  ListBucketInventoryConfigurationsCommand = class ListBucketInventoryConfigurationsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListBucketInventoryConfigurations", {}).n("S3Client", "ListBucketInventoryConfigurationsCommand").f(undefined, ListBucketInventoryConfigurationsOutputFilterSensitiveLog).ser(se_ListBucketInventoryConfigurationsCommand).de(de_ListBucketInventoryConfigurationsCommand).build() {
  };
});
var ListBucketMetricsConfigurationsCommand;
var init_ListBucketMetricsConfigurationsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListBucketMetricsConfigurationsCommand = class ListBucketMetricsConfigurationsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListBucketMetricsConfigurations", {}).n("S3Client", "ListBucketMetricsConfigurationsCommand").f(undefined, undefined).ser(se_ListBucketMetricsConfigurationsCommand).de(de_ListBucketMetricsConfigurationsCommand).build() {
  };
});
var ListBucketsCommand;
var init_ListBucketsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListBucketsCommand = class ListBucketsCommand2 extends Command2.classBuilder().ep(commonParams).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListBuckets", {}).n("S3Client", "ListBucketsCommand").f(undefined, undefined).ser(se_ListBucketsCommand).de(de_ListBucketsCommand).build() {
  };
});
var ListDirectoryBucketsCommand;
var init_ListDirectoryBucketsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListDirectoryBucketsCommand = class ListDirectoryBucketsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListDirectoryBuckets", {}).n("S3Client", "ListDirectoryBucketsCommand").f(undefined, undefined).ser(se_ListDirectoryBucketsCommand).de(de_ListDirectoryBucketsCommand).build() {
  };
});
var ListMultipartUploadsCommand;
var init_ListMultipartUploadsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListMultipartUploadsCommand = class ListMultipartUploadsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Prefix: { type: "contextParams", name: "Prefix" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListMultipartUploads", {}).n("S3Client", "ListMultipartUploadsCommand").f(undefined, undefined).ser(se_ListMultipartUploadsCommand).de(de_ListMultipartUploadsCommand).build() {
  };
});
var ListObjectsCommand;
var init_ListObjectsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListObjectsCommand = class ListObjectsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Prefix: { type: "contextParams", name: "Prefix" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListObjects", {}).n("S3Client", "ListObjectsCommand").f(undefined, undefined).ser(se_ListObjectsCommand).de(de_ListObjectsCommand).build() {
  };
});
var ListObjectsV2Command;
var init_ListObjectsV2Command = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListObjectsV2Command = class ListObjectsV2Command2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Prefix: { type: "contextParams", name: "Prefix" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListObjectsV2", {}).n("S3Client", "ListObjectsV2Command").f(undefined, undefined).ser(se_ListObjectsV2Command).de(de_ListObjectsV2Command).build() {
  };
});
var ListObjectVersionsCommand;
var init_ListObjectVersionsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  ListObjectVersionsCommand = class ListObjectVersionsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Prefix: { type: "contextParams", name: "Prefix" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "ListObjectVersions", {}).n("S3Client", "ListObjectVersionsCommand").f(undefined, undefined).ser(se_ListObjectVersionsCommand).de(de_ListObjectVersionsCommand).build() {
  };
});
var ListPartsCommand;
var init_ListPartsCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  ListPartsCommand = class ListPartsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "ListParts", {}).n("S3Client", "ListPartsCommand").f(ListPartsRequestFilterSensitiveLog, undefined).ser(se_ListPartsCommand).de(de_ListPartsCommand).build() {
  };
});
var PutBucketAccelerateConfigurationCommand;
var init_PutBucketAccelerateConfigurationCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketAccelerateConfigurationCommand = class PutBucketAccelerateConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: false
      })
    ];
  }).s("AmazonS3", "PutBucketAccelerateConfiguration", {}).n("S3Client", "PutBucketAccelerateConfigurationCommand").f(undefined, undefined).ser(se_PutBucketAccelerateConfigurationCommand).de(de_PutBucketAccelerateConfigurationCommand).build() {
  };
});
var PutBucketAclCommand;
var init_PutBucketAclCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketAclCommand = class PutBucketAclCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketAcl", {}).n("S3Client", "PutBucketAclCommand").f(undefined, undefined).ser(se_PutBucketAclCommand).de(de_PutBucketAclCommand).build() {
  };
});
var PutBucketAnalyticsConfigurationCommand;
var init_PutBucketAnalyticsConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketAnalyticsConfigurationCommand = class PutBucketAnalyticsConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "PutBucketAnalyticsConfiguration", {}).n("S3Client", "PutBucketAnalyticsConfigurationCommand").f(undefined, undefined).ser(se_PutBucketAnalyticsConfigurationCommand).de(de_PutBucketAnalyticsConfigurationCommand).build() {
  };
});
var PutBucketCorsCommand;
var init_PutBucketCorsCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketCorsCommand = class PutBucketCorsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketCors", {}).n("S3Client", "PutBucketCorsCommand").f(undefined, undefined).ser(se_PutBucketCorsCommand).de(de_PutBucketCorsCommand).build() {
  };
});
var PutBucketEncryptionCommand;
var init_PutBucketEncryptionCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  PutBucketEncryptionCommand = class PutBucketEncryptionCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketEncryption", {}).n("S3Client", "PutBucketEncryptionCommand").f(PutBucketEncryptionRequestFilterSensitiveLog, undefined).ser(se_PutBucketEncryptionCommand).de(de_PutBucketEncryptionCommand).build() {
  };
});
var PutBucketIntelligentTieringConfigurationCommand;
var init_PutBucketIntelligentTieringConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketIntelligentTieringConfigurationCommand = class PutBucketIntelligentTieringConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "PutBucketIntelligentTieringConfiguration", {}).n("S3Client", "PutBucketIntelligentTieringConfigurationCommand").f(undefined, undefined).ser(se_PutBucketIntelligentTieringConfigurationCommand).de(de_PutBucketIntelligentTieringConfigurationCommand).build() {
  };
});
var PutBucketInventoryConfigurationCommand;
var init_PutBucketInventoryConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_0();
  init_Aws_restXml();
  PutBucketInventoryConfigurationCommand = class PutBucketInventoryConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "PutBucketInventoryConfiguration", {}).n("S3Client", "PutBucketInventoryConfigurationCommand").f(PutBucketInventoryConfigurationRequestFilterSensitiveLog, undefined).ser(se_PutBucketInventoryConfigurationCommand).de(de_PutBucketInventoryConfigurationCommand).build() {
  };
});
var PutBucketLifecycleConfigurationCommand;
var init_PutBucketLifecycleConfigurationCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketLifecycleConfigurationCommand = class PutBucketLifecycleConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "PutBucketLifecycleConfiguration", {}).n("S3Client", "PutBucketLifecycleConfigurationCommand").f(undefined, undefined).ser(se_PutBucketLifecycleConfigurationCommand).de(de_PutBucketLifecycleConfigurationCommand).build() {
  };
});
var PutBucketLoggingCommand;
var init_PutBucketLoggingCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketLoggingCommand = class PutBucketLoggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketLogging", {}).n("S3Client", "PutBucketLoggingCommand").f(undefined, undefined).ser(se_PutBucketLoggingCommand).de(de_PutBucketLoggingCommand).build() {
  };
});
var PutBucketMetricsConfigurationCommand;
var init_PutBucketMetricsConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketMetricsConfigurationCommand = class PutBucketMetricsConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "PutBucketMetricsConfiguration", {}).n("S3Client", "PutBucketMetricsConfigurationCommand").f(undefined, undefined).ser(se_PutBucketMetricsConfigurationCommand).de(de_PutBucketMetricsConfigurationCommand).build() {
  };
});
var PutBucketNotificationConfigurationCommand;
var init_PutBucketNotificationConfigurationCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketNotificationConfigurationCommand = class PutBucketNotificationConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "PutBucketNotificationConfiguration", {}).n("S3Client", "PutBucketNotificationConfigurationCommand").f(undefined, undefined).ser(se_PutBucketNotificationConfigurationCommand).de(de_PutBucketNotificationConfigurationCommand).build() {
  };
});
var PutBucketOwnershipControlsCommand;
var init_PutBucketOwnershipControlsCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketOwnershipControlsCommand = class PutBucketOwnershipControlsCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketOwnershipControls", {}).n("S3Client", "PutBucketOwnershipControlsCommand").f(undefined, undefined).ser(se_PutBucketOwnershipControlsCommand).de(de_PutBucketOwnershipControlsCommand).build() {
  };
});
var PutBucketPolicyCommand;
var init_PutBucketPolicyCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketPolicyCommand = class PutBucketPolicyCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketPolicy", {}).n("S3Client", "PutBucketPolicyCommand").f(undefined, undefined).ser(se_PutBucketPolicyCommand).de(de_PutBucketPolicyCommand).build() {
  };
});
var PutBucketReplicationCommand;
var init_PutBucketReplicationCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketReplicationCommand = class PutBucketReplicationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketReplication", {}).n("S3Client", "PutBucketReplicationCommand").f(undefined, undefined).ser(se_PutBucketReplicationCommand).de(de_PutBucketReplicationCommand).build() {
  };
});
var PutBucketRequestPaymentCommand;
var init_PutBucketRequestPaymentCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketRequestPaymentCommand = class PutBucketRequestPaymentCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketRequestPayment", {}).n("S3Client", "PutBucketRequestPaymentCommand").f(undefined, undefined).ser(se_PutBucketRequestPaymentCommand).de(de_PutBucketRequestPaymentCommand).build() {
  };
});
var PutBucketTaggingCommand;
var init_PutBucketTaggingCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketTaggingCommand = class PutBucketTaggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketTagging", {}).n("S3Client", "PutBucketTaggingCommand").f(undefined, undefined).ser(se_PutBucketTaggingCommand).de(de_PutBucketTaggingCommand).build() {
  };
});
var PutBucketVersioningCommand;
var init_PutBucketVersioningCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketVersioningCommand = class PutBucketVersioningCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketVersioning", {}).n("S3Client", "PutBucketVersioningCommand").f(undefined, undefined).ser(se_PutBucketVersioningCommand).de(de_PutBucketVersioningCommand).build() {
  };
});
var PutBucketWebsiteCommand;
var init_PutBucketWebsiteCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutBucketWebsiteCommand = class PutBucketWebsiteCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutBucketWebsite", {}).n("S3Client", "PutBucketWebsiteCommand").f(undefined, undefined).ser(se_PutBucketWebsiteCommand).de(de_PutBucketWebsiteCommand).build() {
  };
});
var PutObjectAclCommand;
var init_PutObjectAclCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutObjectAclCommand = class PutObjectAclCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "PutObjectAcl", {}).n("S3Client", "PutObjectAclCommand").f(undefined, undefined).ser(se_PutObjectAclCommand).de(de_PutObjectAclCommand).build() {
  };
});
var PutObjectCommand;
var init_PutObjectCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_1();
  init_Aws_restXml();
  PutObjectCommand = class PutObjectCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: false
      }),
      getCheckContentLengthHeaderPlugin(config9),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "PutObject", {}).n("S3Client", "PutObjectCommand").f(PutObjectRequestFilterSensitiveLog, PutObjectOutputFilterSensitiveLog).ser(se_PutObjectCommand).de(de_PutObjectCommand).build() {
  };
});
var PutObjectLegalHoldCommand;
var init_PutObjectLegalHoldCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutObjectLegalHoldCommand = class PutObjectLegalHoldCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "PutObjectLegalHold", {}).n("S3Client", "PutObjectLegalHoldCommand").f(undefined, undefined).ser(se_PutObjectLegalHoldCommand).de(de_PutObjectLegalHoldCommand).build() {
  };
});
var PutObjectLockConfigurationCommand;
var init_PutObjectLockConfigurationCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutObjectLockConfigurationCommand = class PutObjectLockConfigurationCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "PutObjectLockConfiguration", {}).n("S3Client", "PutObjectLockConfigurationCommand").f(undefined, undefined).ser(se_PutObjectLockConfigurationCommand).de(de_PutObjectLockConfigurationCommand).build() {
  };
});
var PutObjectRetentionCommand;
var init_PutObjectRetentionCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutObjectRetentionCommand = class PutObjectRetentionCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "PutObjectRetention", {}).n("S3Client", "PutObjectRetentionCommand").f(undefined, undefined).ser(se_PutObjectRetentionCommand).de(de_PutObjectRetentionCommand).build() {
  };
});
var PutObjectTaggingCommand;
var init_PutObjectTaggingCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutObjectTaggingCommand = class PutObjectTaggingCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "PutObjectTagging", {}).n("S3Client", "PutObjectTaggingCommand").f(undefined, undefined).ser(se_PutObjectTaggingCommand).de(de_PutObjectTaggingCommand).build() {
  };
});
var PutPublicAccessBlockCommand;
var init_PutPublicAccessBlockCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_Aws_restXml();
  PutPublicAccessBlockCommand = class PutPublicAccessBlockCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: true
      })
    ];
  }).s("AmazonS3", "PutPublicAccessBlock", {}).n("S3Client", "PutPublicAccessBlockCommand").f(undefined, undefined).ser(se_PutPublicAccessBlockCommand).de(de_PutPublicAccessBlockCommand).build() {
  };
});
var RestoreObjectCommand;
var init_RestoreObjectCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_1();
  init_Aws_restXml();
  RestoreObjectCommand = class RestoreObjectCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: false
      }),
      getThrow200ExceptionsPlugin(config9)
    ];
  }).s("AmazonS3", "RestoreObject", {}).n("S3Client", "RestoreObjectCommand").f(RestoreObjectRequestFilterSensitiveLog, undefined).ser(se_RestoreObjectCommand).de(de_RestoreObjectCommand).build() {
  };
});
var SelectObjectContentCommand;
var init_SelectObjectContentCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_1();
  init_Aws_restXml();
  SelectObjectContentCommand = class SelectObjectContentCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "SelectObjectContent", {
    eventStream: {
      output: true
    }
  }).n("S3Client", "SelectObjectContentCommand").f(SelectObjectContentRequestFilterSensitiveLog, SelectObjectContentOutputFilterSensitiveLog).ser(se_SelectObjectContentCommand).de(de_SelectObjectContentCommand).build() {
  };
});
var UploadPartCommand;
var init_UploadPartCommand = __esm2(() => {
  init_dist_es7();
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_1();
  init_Aws_restXml();
  UploadPartCommand = class UploadPartCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    Bucket: { type: "contextParams", name: "Bucket" },
    Key: { type: "contextParams", name: "Key" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getFlexibleChecksumsPlugin(config9, {
        input: this.input,
        requestAlgorithmMember: "ChecksumAlgorithm",
        requestChecksumRequired: false
      }),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "UploadPart", {}).n("S3Client", "UploadPartCommand").f(UploadPartRequestFilterSensitiveLog, UploadPartOutputFilterSensitiveLog).ser(se_UploadPartCommand).de(de_UploadPartCommand).build() {
  };
});
var UploadPartCopyCommand;
var init_UploadPartCopyCommand = __esm2(() => {
  init_dist_es20();
  init_dist_es60();
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_1();
  init_Aws_restXml();
  UploadPartCopyCommand = class UploadPartCopyCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    DisableS3ExpressSessionAuth: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions()),
      getThrow200ExceptionsPlugin(config9),
      getSsecPlugin(config9)
    ];
  }).s("AmazonS3", "UploadPartCopy", {}).n("S3Client", "UploadPartCopyCommand").f(UploadPartCopyRequestFilterSensitiveLog, UploadPartCopyOutputFilterSensitiveLog).ser(se_UploadPartCopyCommand).de(de_UploadPartCopyCommand).build() {
  };
});
var WriteGetObjectResponseCommand;
var init_WriteGetObjectResponseCommand = __esm2(() => {
  init_dist_es32();
  init_dist_es31();
  init_dist_es12();
  init_EndpointParameters();
  init_models_1();
  init_Aws_restXml();
  WriteGetObjectResponseCommand = class WriteGetObjectResponseCommand2 extends Command2.classBuilder().ep({
    ...commonParams,
    UseObjectLambdaEndpoint: { type: "staticContextParams", value: true }
  }).m(function(Command22, cs2, config9, o5) {
    return [
      getSerdePlugin(config9, this.serialize, this.deserialize),
      getEndpointPlugin(config9, Command22.getEndpointParameterInstructions())
    ];
  }).s("AmazonS3", "WriteGetObjectResponse", {}).n("S3Client", "WriteGetObjectResponseCommand").f(WriteGetObjectResponseRequestFilterSensitiveLog, undefined).ser(se_WriteGetObjectResponseCommand).de(de_WriteGetObjectResponseCommand).build() {
  };
});
var commands7;
var S3;
var init_S3 = __esm2(() => {
  init_dist_es12();
  init_AbortMultipartUploadCommand();
  init_CompleteMultipartUploadCommand();
  init_CopyObjectCommand();
  init_CreateBucketCommand();
  init_CreateMultipartUploadCommand();
  init_CreateSessionCommand();
  init_DeleteBucketAnalyticsConfigurationCommand();
  init_DeleteBucketCommand();
  init_DeleteBucketCorsCommand();
  init_DeleteBucketEncryptionCommand();
  init_DeleteBucketIntelligentTieringConfigurationCommand();
  init_DeleteBucketInventoryConfigurationCommand();
  init_DeleteBucketLifecycleCommand();
  init_DeleteBucketMetricsConfigurationCommand();
  init_DeleteBucketOwnershipControlsCommand();
  init_DeleteBucketPolicyCommand();
  init_DeleteBucketReplicationCommand();
  init_DeleteBucketTaggingCommand();
  init_DeleteBucketWebsiteCommand();
  init_DeleteObjectCommand();
  init_DeleteObjectsCommand();
  init_DeleteObjectTaggingCommand();
  init_DeletePublicAccessBlockCommand();
  init_GetBucketAccelerateConfigurationCommand();
  init_GetBucketAclCommand();
  init_GetBucketAnalyticsConfigurationCommand();
  init_GetBucketCorsCommand();
  init_GetBucketEncryptionCommand();
  init_GetBucketIntelligentTieringConfigurationCommand();
  init_GetBucketInventoryConfigurationCommand();
  init_GetBucketLifecycleConfigurationCommand();
  init_GetBucketLocationCommand();
  init_GetBucketLoggingCommand();
  init_GetBucketMetricsConfigurationCommand();
  init_GetBucketNotificationConfigurationCommand();
  init_GetBucketOwnershipControlsCommand();
  init_GetBucketPolicyCommand();
  init_GetBucketPolicyStatusCommand();
  init_GetBucketReplicationCommand();
  init_GetBucketRequestPaymentCommand();
  init_GetBucketTaggingCommand();
  init_GetBucketVersioningCommand();
  init_GetBucketWebsiteCommand();
  init_GetObjectAclCommand();
  init_GetObjectAttributesCommand();
  init_GetObjectCommand();
  init_GetObjectLegalHoldCommand();
  init_GetObjectLockConfigurationCommand();
  init_GetObjectRetentionCommand();
  init_GetObjectTaggingCommand();
  init_GetObjectTorrentCommand();
  init_GetPublicAccessBlockCommand();
  init_HeadBucketCommand();
  init_HeadObjectCommand();
  init_ListBucketAnalyticsConfigurationsCommand();
  init_ListBucketIntelligentTieringConfigurationsCommand();
  init_ListBucketInventoryConfigurationsCommand();
  init_ListBucketMetricsConfigurationsCommand();
  init_ListBucketsCommand();
  init_ListDirectoryBucketsCommand();
  init_ListMultipartUploadsCommand();
  init_ListObjectsCommand();
  init_ListObjectsV2Command();
  init_ListObjectVersionsCommand();
  init_ListPartsCommand();
  init_PutBucketAccelerateConfigurationCommand();
  init_PutBucketAclCommand();
  init_PutBucketAnalyticsConfigurationCommand();
  init_PutBucketCorsCommand();
  init_PutBucketEncryptionCommand();
  init_PutBucketIntelligentTieringConfigurationCommand();
  init_PutBucketInventoryConfigurationCommand();
  init_PutBucketLifecycleConfigurationCommand();
  init_PutBucketLoggingCommand();
  init_PutBucketMetricsConfigurationCommand();
  init_PutBucketNotificationConfigurationCommand();
  init_PutBucketOwnershipControlsCommand();
  init_PutBucketPolicyCommand();
  init_PutBucketReplicationCommand();
  init_PutBucketRequestPaymentCommand();
  init_PutBucketTaggingCommand();
  init_PutBucketVersioningCommand();
  init_PutBucketWebsiteCommand();
  init_PutObjectAclCommand();
  init_PutObjectCommand();
  init_PutObjectLegalHoldCommand();
  init_PutObjectLockConfigurationCommand();
  init_PutObjectRetentionCommand();
  init_PutObjectTaggingCommand();
  init_PutPublicAccessBlockCommand();
  init_RestoreObjectCommand();
  init_SelectObjectContentCommand();
  init_UploadPartCommand();
  init_UploadPartCopyCommand();
  init_WriteGetObjectResponseCommand();
  init_S3Client();
  commands7 = {
    AbortMultipartUploadCommand,
    CompleteMultipartUploadCommand,
    CopyObjectCommand,
    CreateBucketCommand,
    CreateMultipartUploadCommand,
    CreateSessionCommand,
    DeleteBucketCommand,
    DeleteBucketAnalyticsConfigurationCommand,
    DeleteBucketCorsCommand,
    DeleteBucketEncryptionCommand,
    DeleteBucketIntelligentTieringConfigurationCommand,
    DeleteBucketInventoryConfigurationCommand,
    DeleteBucketLifecycleCommand,
    DeleteBucketMetricsConfigurationCommand,
    DeleteBucketOwnershipControlsCommand,
    DeleteBucketPolicyCommand,
    DeleteBucketReplicationCommand,
    DeleteBucketTaggingCommand,
    DeleteBucketWebsiteCommand,
    DeleteObjectCommand,
    DeleteObjectsCommand,
    DeleteObjectTaggingCommand,
    DeletePublicAccessBlockCommand,
    GetBucketAccelerateConfigurationCommand,
    GetBucketAclCommand,
    GetBucketAnalyticsConfigurationCommand,
    GetBucketCorsCommand,
    GetBucketEncryptionCommand,
    GetBucketIntelligentTieringConfigurationCommand,
    GetBucketInventoryConfigurationCommand,
    GetBucketLifecycleConfigurationCommand,
    GetBucketLocationCommand,
    GetBucketLoggingCommand,
    GetBucketMetricsConfigurationCommand,
    GetBucketNotificationConfigurationCommand,
    GetBucketOwnershipControlsCommand,
    GetBucketPolicyCommand,
    GetBucketPolicyStatusCommand,
    GetBucketReplicationCommand,
    GetBucketRequestPaymentCommand,
    GetBucketTaggingCommand,
    GetBucketVersioningCommand,
    GetBucketWebsiteCommand,
    GetObjectCommand,
    GetObjectAclCommand,
    GetObjectAttributesCommand,
    GetObjectLegalHoldCommand,
    GetObjectLockConfigurationCommand,
    GetObjectRetentionCommand,
    GetObjectTaggingCommand,
    GetObjectTorrentCommand,
    GetPublicAccessBlockCommand,
    HeadBucketCommand,
    HeadObjectCommand,
    ListBucketAnalyticsConfigurationsCommand,
    ListBucketIntelligentTieringConfigurationsCommand,
    ListBucketInventoryConfigurationsCommand,
    ListBucketMetricsConfigurationsCommand,
    ListBucketsCommand,
    ListDirectoryBucketsCommand,
    ListMultipartUploadsCommand,
    ListObjectsCommand,
    ListObjectsV2Command,
    ListObjectVersionsCommand,
    ListPartsCommand,
    PutBucketAccelerateConfigurationCommand,
    PutBucketAclCommand,
    PutBucketAnalyticsConfigurationCommand,
    PutBucketCorsCommand,
    PutBucketEncryptionCommand,
    PutBucketIntelligentTieringConfigurationCommand,
    PutBucketInventoryConfigurationCommand,
    PutBucketLifecycleConfigurationCommand,
    PutBucketLoggingCommand,
    PutBucketMetricsConfigurationCommand,
    PutBucketNotificationConfigurationCommand,
    PutBucketOwnershipControlsCommand,
    PutBucketPolicyCommand,
    PutBucketReplicationCommand,
    PutBucketRequestPaymentCommand,
    PutBucketTaggingCommand,
    PutBucketVersioningCommand,
    PutBucketWebsiteCommand,
    PutObjectCommand,
    PutObjectAclCommand,
    PutObjectLegalHoldCommand,
    PutObjectLockConfigurationCommand,
    PutObjectRetentionCommand,
    PutObjectTaggingCommand,
    PutPublicAccessBlockCommand,
    RestoreObjectCommand,
    SelectObjectContentCommand,
    UploadPartCommand,
    UploadPartCopyCommand,
    WriteGetObjectResponseCommand
  };
  S3 = class S32 extends S3Client {
  };
  createAggregatedClient(commands7, S3);
});
var init_commands4 = __esm2(() => {
  init_AbortMultipartUploadCommand();
  init_CompleteMultipartUploadCommand();
  init_CopyObjectCommand();
  init_CreateBucketCommand();
  init_CreateMultipartUploadCommand();
  init_CreateSessionCommand();
  init_DeleteBucketAnalyticsConfigurationCommand();
  init_DeleteBucketCommand();
  init_DeleteBucketCorsCommand();
  init_DeleteBucketEncryptionCommand();
  init_DeleteBucketIntelligentTieringConfigurationCommand();
  init_DeleteBucketInventoryConfigurationCommand();
  init_DeleteBucketLifecycleCommand();
  init_DeleteBucketMetricsConfigurationCommand();
  init_DeleteBucketOwnershipControlsCommand();
  init_DeleteBucketPolicyCommand();
  init_DeleteBucketReplicationCommand();
  init_DeleteBucketTaggingCommand();
  init_DeleteBucketWebsiteCommand();
  init_DeleteObjectCommand();
  init_DeleteObjectTaggingCommand();
  init_DeleteObjectsCommand();
  init_DeletePublicAccessBlockCommand();
  init_GetBucketAccelerateConfigurationCommand();
  init_GetBucketAclCommand();
  init_GetBucketAnalyticsConfigurationCommand();
  init_GetBucketCorsCommand();
  init_GetBucketEncryptionCommand();
  init_GetBucketIntelligentTieringConfigurationCommand();
  init_GetBucketInventoryConfigurationCommand();
  init_GetBucketLifecycleConfigurationCommand();
  init_GetBucketLocationCommand();
  init_GetBucketLoggingCommand();
  init_GetBucketMetricsConfigurationCommand();
  init_GetBucketNotificationConfigurationCommand();
  init_GetBucketOwnershipControlsCommand();
  init_GetBucketPolicyCommand();
  init_GetBucketPolicyStatusCommand();
  init_GetBucketReplicationCommand();
  init_GetBucketRequestPaymentCommand();
  init_GetBucketTaggingCommand();
  init_GetBucketVersioningCommand();
  init_GetBucketWebsiteCommand();
  init_GetObjectAclCommand();
  init_GetObjectAttributesCommand();
  init_GetObjectCommand();
  init_GetObjectLegalHoldCommand();
  init_GetObjectLockConfigurationCommand();
  init_GetObjectRetentionCommand();
  init_GetObjectTaggingCommand();
  init_GetObjectTorrentCommand();
  init_GetPublicAccessBlockCommand();
  init_HeadBucketCommand();
  init_HeadObjectCommand();
  init_ListBucketAnalyticsConfigurationsCommand();
  init_ListBucketIntelligentTieringConfigurationsCommand();
  init_ListBucketInventoryConfigurationsCommand();
  init_ListBucketMetricsConfigurationsCommand();
  init_ListBucketsCommand();
  init_ListDirectoryBucketsCommand();
  init_ListMultipartUploadsCommand();
  init_ListObjectVersionsCommand();
  init_ListObjectsCommand();
  init_ListObjectsV2Command();
  init_ListPartsCommand();
  init_PutBucketAccelerateConfigurationCommand();
  init_PutBucketAclCommand();
  init_PutBucketAnalyticsConfigurationCommand();
  init_PutBucketCorsCommand();
  init_PutBucketEncryptionCommand();
  init_PutBucketIntelligentTieringConfigurationCommand();
  init_PutBucketInventoryConfigurationCommand();
  init_PutBucketLifecycleConfigurationCommand();
  init_PutBucketLoggingCommand();
  init_PutBucketMetricsConfigurationCommand();
  init_PutBucketNotificationConfigurationCommand();
  init_PutBucketOwnershipControlsCommand();
  init_PutBucketPolicyCommand();
  init_PutBucketReplicationCommand();
  init_PutBucketRequestPaymentCommand();
  init_PutBucketTaggingCommand();
  init_PutBucketVersioningCommand();
  init_PutBucketWebsiteCommand();
  init_PutObjectAclCommand();
  init_PutObjectCommand();
  init_PutObjectLegalHoldCommand();
  init_PutObjectLockConfigurationCommand();
  init_PutObjectRetentionCommand();
  init_PutObjectTaggingCommand();
  init_PutPublicAccessBlockCommand();
  init_RestoreObjectCommand();
  init_SelectObjectContentCommand();
  init_UploadPartCommand();
  init_UploadPartCopyCommand();
  init_WriteGetObjectResponseCommand();
});
var init_Interfaces2 = () => {
};
var import_core39;
var paginateListBuckets;
var init_ListBucketsPaginator = __esm2(() => {
  import_core39 = __toESM3(require_dist_cjs15(), 1);
  init_ListBucketsCommand();
  init_S3Client();
  paginateListBuckets = import_core39.createPaginator(S3Client, ListBucketsCommand, "ContinuationToken", "ContinuationToken", "MaxBuckets");
});
var import_core40;
var paginateListDirectoryBuckets;
var init_ListDirectoryBucketsPaginator = __esm2(() => {
  import_core40 = __toESM3(require_dist_cjs15(), 1);
  init_ListDirectoryBucketsCommand();
  init_S3Client();
  paginateListDirectoryBuckets = import_core40.createPaginator(S3Client, ListDirectoryBucketsCommand, "ContinuationToken", "ContinuationToken", "MaxDirectoryBuckets");
});
var import_core41;
var paginateListObjectsV2;
var init_ListObjectsV2Paginator = __esm2(() => {
  import_core41 = __toESM3(require_dist_cjs15(), 1);
  init_ListObjectsV2Command();
  init_S3Client();
  paginateListObjectsV2 = import_core41.createPaginator(S3Client, ListObjectsV2Command, "ContinuationToken", "NextContinuationToken", "MaxKeys");
});
var import_core42;
var paginateListParts;
var init_ListPartsPaginator = __esm2(() => {
  import_core42 = __toESM3(require_dist_cjs15(), 1);
  init_ListPartsCommand();
  init_S3Client();
  paginateListParts = import_core42.createPaginator(S3Client, ListPartsCommand, "PartNumberMarker", "NextPartNumberMarker", "MaxParts");
});
var init_pagination2 = __esm2(() => {
  init_Interfaces2();
  init_ListBucketsPaginator();
  init_ListDirectoryBucketsPaginator();
  init_ListObjectsV2Paginator();
  init_ListPartsPaginator();
});
var WaiterState;
var init_waiter = __esm2(() => {
  (function(WaiterState2) {
    WaiterState2["ABORTED"] = "ABORTED";
    WaiterState2["FAILURE"] = "FAILURE";
    WaiterState2["SUCCESS"] = "SUCCESS";
    WaiterState2["RETRY"] = "RETRY";
    WaiterState2["TIMEOUT"] = "TIMEOUT";
  })(WaiterState || (WaiterState = {}));
});
var init_poller = __esm2(() => {
  init_waiter();
});
var init_utils13 = () => {
};
var init_createWaiter = __esm2(() => {
  init_poller();
  init_utils13();
  init_waiter();
});
var init_dist_es62 = __esm2(() => {
  init_createWaiter();
  init_waiter();
});
var init_waitForBucketExists = __esm2(() => {
  init_dist_es62();
});
var init_waitForBucketNotExists = __esm2(() => {
  init_dist_es62();
});
var init_waitForObjectExists = __esm2(() => {
  init_dist_es62();
});
var init_waitForObjectNotExists = __esm2(() => {
  init_dist_es62();
});
var init_waiters = __esm2(() => {
  init_waitForBucketExists();
  init_waitForBucketNotExists();
  init_waitForObjectExists();
  init_waitForObjectNotExists();
});
var init_models4 = __esm2(() => {
  init_models_0();
  init_models_1();
});
var init_dist_es63 = __esm2(() => {
  init_S3Client();
  init_S3();
  init_commands4();
  init_pagination2();
  init_waiters();
  init_models4();
  init_S3ServiceException();
});

class AbortSignal2 {
  constructor() {
    this.onabort = null;
    this._aborted = false;
    Object.defineProperty(this, "_aborted", {
      value: false,
      writable: true
    });
  }
  get aborted() {
    return this._aborted;
  }
  abort() {
    this._aborted = true;
    if (this.onabort) {
      this.onabort(this);
      this.onabort = null;
    }
  }
}

class AbortController2 {
  constructor() {
    this.signal = new AbortSignal2;
  }
  abort() {
    this.signal.abort();
  }
}
var init_AbortController = () => {
};
var init_dist_es64 = __esm2(() => {
  init_AbortController();
});
var ClientSharedValues;
var init_runtimeConfig_shared5 = __esm2(() => {
  ClientSharedValues = {
    lstatSync: () => {
    }
  };
});
var ClientDefaultValues;
var init_runtimeConfig5 = __esm2(() => {
  init_runtimeConfig_shared5();
  ClientDefaultValues = {
    ...ClientSharedValues,
    runtime: "node",
    lstatSync: lstatSync2
  };
});
var byteLength = (input) => {
  if (input === null || input === undefined)
    return 0;
  if (typeof input === "string") {
    return Buffer6.byteLength(input);
  }
  if (typeof input.byteLength === "number") {
    return input.byteLength;
  } else if (typeof input.length === "number") {
    return input.length;
  } else if (typeof input.size === "number") {
    return input.size;
  } else if (typeof input.path === "string") {
    try {
      return ClientDefaultValues.lstatSync(input.path).size;
    } catch (error) {
      return;
    }
  }
  return;
};
var init_bytelength = __esm2(() => {
  init_runtimeConfig5();
});
async function* getChunkStream(data2, partSize, getNextData) {
  let partNumber = 1;
  const currentBuffer = { chunks: [], length: 0 };
  for await (const datum of getNextData(data2)) {
    currentBuffer.chunks.push(datum);
    currentBuffer.length += datum.byteLength;
    while (currentBuffer.length > partSize) {
      const dataChunk = currentBuffer.chunks.length > 1 ? Buffer7.concat(currentBuffer.chunks) : currentBuffer.chunks[0];
      yield {
        partNumber,
        data: dataChunk.subarray(0, partSize)
      };
      currentBuffer.chunks = [dataChunk.subarray(partSize)];
      currentBuffer.length = currentBuffer.chunks[0].byteLength;
      partNumber += 1;
    }
  }
  yield {
    partNumber,
    data: currentBuffer.chunks.length !== 1 ? Buffer7.concat(currentBuffer.chunks) : currentBuffer.chunks[0],
    lastPart: true
  };
}
var init_getChunkStream = () => {
};
async function* getChunkUint8Array(data2, partSize) {
  let partNumber = 1;
  let startByte = 0;
  let endByte = partSize;
  while (endByte < data2.byteLength) {
    yield {
      partNumber,
      data: data2.subarray(startByte, endByte)
    };
    partNumber += 1;
    startByte = endByte;
    endByte = startByte + partSize;
  }
  yield {
    partNumber,
    data: data2.subarray(startByte),
    lastPart: true
  };
}
async function* getDataReadable(data2) {
  for await (const chunk of data2) {
    if (Buffer8.isBuffer(chunk) || chunk instanceof Uint8Array) {
      yield chunk;
    } else {
      yield Buffer8.from(chunk);
    }
  }
}
var init_getDataReadable = () => {
};
async function* getDataReadableStream(data2) {
  const reader = data2.getReader();
  try {
    while (true) {
      const { done, value } = await reader.read();
      if (done) {
        return;
      }
      if (Buffer9.isBuffer(value) || value instanceof Uint8Array) {
        yield value;
      } else {
        yield Buffer9.from(value);
      }
    }
  } catch (e5) {
    throw e5;
  } finally {
    reader.releaseLock();
  }
}
var init_getDataReadableStream = () => {
};
var getChunk = (data2, partSize) => {
  if (data2 instanceof Uint8Array) {
    return getChunkUint8Array(data2, partSize);
  }
  if (data2 instanceof Readable6) {
    return getChunkStream(data2, partSize, getDataReadable);
  }
  if (data2 instanceof String || typeof data2 === "string") {
    return getChunkUint8Array(Buffer10.from(data2), partSize);
  }
  if (typeof data2.stream === "function") {
    return getChunkStream(data2.stream(), partSize, getDataReadableStream);
  }
  if (data2 instanceof ReadableStream) {
    return getChunkStream(data2, partSize, getDataReadableStream);
  }
  throw new Error("Body Data is unsupported format, expected data to be one of: string | Uint8Array | Buffer | Readable | ReadableStream | Blob;.");
};
var init_chunker = __esm2(() => {
  init_getChunkStream();
  init_getDataReadable();
  init_getDataReadableStream();
});
var Upload;
var init_Upload = __esm2(() => {
  init_dist_es63();
  init_dist_es64();
  init_dist_es32();
  init_dist_es12();
  init_bytelength();
  init_chunker();
  Upload = class Upload2 extends EventEmitter22 {
    constructor(options3) {
      super();
      this.MAX_PARTS = 1e4;
      this.queueSize = 4;
      this.partSize = Upload2.MIN_PART_SIZE;
      this.leavePartsOnError = false;
      this.tags = [];
      this.concurrentUploaders = [];
      this.abortMultipartUploadCommand = null;
      this.uploadedParts = [];
      this.uploadEnqueuedPartsCount = 0;
      this.isMultiPart = true;
      this.sent = false;
      this.queueSize = options3.queueSize || this.queueSize;
      this.partSize = options3.partSize || this.partSize;
      this.leavePartsOnError = options3.leavePartsOnError || this.leavePartsOnError;
      this.tags = options3.tags || this.tags;
      this.client = options3.client;
      this.params = options3.params;
      this.__validateInput();
      this.totalBytes = byteLength(this.params.Body);
      this.bytesUploadedSoFar = 0;
      this.abortController = options3.abortController ?? new AbortController2;
    }
    async abort() {
      this.abortController.abort();
    }
    async done() {
      if (this.sent) {
        throw new Error("@aws-sdk/lib-storage: this instance of Upload has already executed .done(). Create a new instance.");
      }
      this.sent = true;
      return await Promise.race([this.__doMultipartUpload(), this.__abortTimeout(this.abortController.signal)]);
    }
    on(event, listener) {
      this.uploadEvent = event;
      return super.on(event, listener);
    }
    async __uploadUsingPut(dataPart) {
      this.isMultiPart = false;
      const params = { ...this.params, Body: dataPart.data };
      const clientConfig = this.client.config;
      const requestHandler = clientConfig.requestHandler;
      const eventEmitter = requestHandler instanceof EventEmitter22 ? requestHandler : null;
      const uploadEventListener = (event) => {
        this.bytesUploadedSoFar = event.loaded;
        this.totalBytes = event.total;
        this.__notifyProgress({
          loaded: this.bytesUploadedSoFar,
          total: this.totalBytes,
          part: dataPart.partNumber,
          Key: this.params.Key,
          Bucket: this.params.Bucket
        });
      };
      if (eventEmitter !== null) {
        eventEmitter.on("xhr.upload.progress", uploadEventListener);
      }
      const resolved = await Promise.all([this.client.send(new PutObjectCommand(params)), clientConfig?.endpoint?.()]);
      const putResult = resolved[0];
      let endpoint = resolved[1];
      if (!endpoint) {
        endpoint = toEndpointV1(await getEndpointFromInstructions(params, PutObjectCommand, {
          ...clientConfig
        }));
      }
      if (!endpoint) {
        throw new Error('Could not resolve endpoint from S3 "client.config.endpoint()" nor EndpointsV2.');
      }
      if (eventEmitter !== null) {
        eventEmitter.off("xhr.upload.progress", uploadEventListener);
      }
      const locationKey = this.params.Key.split("/").map((segment) => import_protocols2.extendedEncodeURIComponent(segment)).join("/");
      const locationBucket = import_protocols2.extendedEncodeURIComponent(this.params.Bucket);
      const Location = (() => {
        const endpointHostnameIncludesBucket = endpoint.hostname.startsWith(`${locationBucket}.`);
        const forcePathStyle = this.client.config.forcePathStyle;
        const optionalPort = endpoint.port ? `:${endpoint.port}` : ``;
        if (forcePathStyle) {
          return `${endpoint.protocol}//${endpoint.hostname}${optionalPort}/${locationBucket}/${locationKey}`;
        }
        if (endpointHostnameIncludesBucket) {
          return `${endpoint.protocol}//${endpoint.hostname}${optionalPort}/${locationKey}`;
        }
        return `${endpoint.protocol}//${locationBucket}.${endpoint.hostname}${optionalPort}/${locationKey}`;
      })();
      this.singleUploadResult = {
        ...putResult,
        Bucket: this.params.Bucket,
        Key: this.params.Key,
        Location
      };
      const totalSize = byteLength(dataPart.data);
      this.__notifyProgress({
        loaded: totalSize,
        total: totalSize,
        part: 1,
        Key: this.params.Key,
        Bucket: this.params.Bucket
      });
    }
    async __createMultipartUpload() {
      if (!this.createMultiPartPromise) {
        const createCommandParams = { ...this.params, Body: undefined };
        this.createMultiPartPromise = this.client.send(new CreateMultipartUploadCommand(createCommandParams)).then((createMpuResponse) => {
          this.abortMultipartUploadCommand = new AbortMultipartUploadCommand({
            Bucket: this.params.Bucket,
            Key: this.params.Key,
            UploadId: createMpuResponse.UploadId
          });
          return createMpuResponse;
        });
      }
      return this.createMultiPartPromise;
    }
    async __doConcurrentUpload(dataFeeder) {
      for await (const dataPart of dataFeeder) {
        if (this.uploadEnqueuedPartsCount > this.MAX_PARTS) {
          throw new Error(`Exceeded ${this.MAX_PARTS} parts in multipart upload to Bucket: ${this.params.Bucket} Key: ${this.params.Key}.`);
        }
        if (this.abortController.signal.aborted) {
          return;
        }
        if (dataPart.partNumber === 1 && dataPart.lastPart) {
          return await this.__uploadUsingPut(dataPart);
        }
        if (!this.uploadId) {
          const { UploadId } = await this.__createMultipartUpload();
          this.uploadId = UploadId;
          if (this.abortController.signal.aborted) {
            return;
          }
        }
        const partSize = byteLength(dataPart.data) || 0;
        const requestHandler = this.client.config.requestHandler;
        const eventEmitter = requestHandler instanceof EventEmitter22 ? requestHandler : null;
        let lastSeenBytes = 0;
        const uploadEventListener = (event, request5) => {
          const requestPartSize = Number(request5.query["partNumber"]) || -1;
          if (requestPartSize !== dataPart.partNumber) {
            return;
          }
          if (event.total && partSize) {
            this.bytesUploadedSoFar += event.loaded - lastSeenBytes;
            lastSeenBytes = event.loaded;
          }
          this.__notifyProgress({
            loaded: this.bytesUploadedSoFar,
            total: this.totalBytes,
            part: dataPart.partNumber,
            Key: this.params.Key,
            Bucket: this.params.Bucket
          });
        };
        if (eventEmitter !== null) {
          eventEmitter.on("xhr.upload.progress", uploadEventListener);
        }
        this.uploadEnqueuedPartsCount += 1;
        const partResult = await this.client.send(new UploadPartCommand({
          ...this.params,
          ContentLength: undefined,
          UploadId: this.uploadId,
          Body: dataPart.data,
          PartNumber: dataPart.partNumber
        }));
        if (eventEmitter !== null) {
          eventEmitter.off("xhr.upload.progress", uploadEventListener);
        }
        if (this.abortController.signal.aborted) {
          return;
        }
        if (!partResult.ETag) {
          throw new Error(`Part ${dataPart.partNumber} is missing ETag in UploadPart response. Missing Bucket CORS configuration for ETag header?`);
        }
        this.uploadedParts.push({
          PartNumber: dataPart.partNumber,
          ETag: partResult.ETag,
          ...partResult.ChecksumCRC32 && { ChecksumCRC32: partResult.ChecksumCRC32 },
          ...partResult.ChecksumCRC32C && { ChecksumCRC32C: partResult.ChecksumCRC32C },
          ...partResult.ChecksumSHA1 && { ChecksumSHA1: partResult.ChecksumSHA1 },
          ...partResult.ChecksumSHA256 && { ChecksumSHA256: partResult.ChecksumSHA256 }
        });
        if (eventEmitter === null) {
          this.bytesUploadedSoFar += partSize;
        }
        this.__notifyProgress({
          loaded: this.bytesUploadedSoFar,
          total: this.totalBytes,
          part: dataPart.partNumber,
          Key: this.params.Key,
          Bucket: this.params.Bucket
        });
      }
    }
    async __doMultipartUpload() {
      const dataFeeder = getChunk(this.params.Body, this.partSize);
      const concurrentUploaderFailures = [];
      for (let index = 0;index < this.queueSize; index++) {
        const currentUpload = this.__doConcurrentUpload(dataFeeder).catch((err22) => {
          concurrentUploaderFailures.push(err22);
        });
        this.concurrentUploaders.push(currentUpload);
      }
      await Promise.all(this.concurrentUploaders);
      if (concurrentUploaderFailures.length >= 1) {
        await this.markUploadAsAborted();
        throw concurrentUploaderFailures[0];
      }
      if (this.abortController.signal.aborted) {
        await this.markUploadAsAborted();
        throw Object.assign(new Error("Upload aborted."), { name: "AbortError" });
      }
      let result2;
      if (this.isMultiPart) {
        this.uploadedParts.sort((a5, b6) => a5.PartNumber - b6.PartNumber);
        const uploadCompleteParams = {
          ...this.params,
          Body: undefined,
          UploadId: this.uploadId,
          MultipartUpload: {
            Parts: this.uploadedParts
          }
        };
        result2 = await this.client.send(new CompleteMultipartUploadCommand(uploadCompleteParams));
        if (typeof result2?.Location === "string" && result2.Location.includes("%2F")) {
          result2.Location = result2.Location.replace(/%2F/g, "/");
        }
      } else {
        result2 = this.singleUploadResult;
      }
      this.abortMultipartUploadCommand = null;
      if (this.tags.length) {
        await this.client.send(new PutObjectTaggingCommand({
          ...this.params,
          Tagging: {
            TagSet: this.tags
          }
        }));
      }
      return result2;
    }
    async markUploadAsAborted() {
      if (this.uploadId && !this.leavePartsOnError && this.abortMultipartUploadCommand !== null) {
        await this.client.send(this.abortMultipartUploadCommand);
        this.abortMultipartUploadCommand = null;
      }
    }
    __notifyProgress(progress) {
      if (this.uploadEvent) {
        this.emit(this.uploadEvent, progress);
      }
    }
    async __abortTimeout(abortSignal) {
      return new Promise((resolve5, reject) => {
        abortSignal.onabort = () => {
          const abortError = new Error("Upload aborted.");
          abortError.name = "AbortError";
          reject(abortError);
        };
      });
    }
    __validateInput() {
      if (!this.params) {
        throw new Error(`InputError: Upload requires params to be passed to upload.`);
      }
      if (!this.client) {
        throw new Error(`InputError: Upload requires a AWS client to do uploads with.`);
      }
      if (this.partSize < Upload2.MIN_PART_SIZE) {
        throw new Error(`EntityTooSmall: Your proposed upload partsize [${this.partSize}] is smaller than the minimum allowed size [${Upload2.MIN_PART_SIZE}] (5MB)`);
      }
      if (this.queueSize < 1) {
        throw new Error(`Queue size: Must have at least one uploading queue.`);
      }
    }
  };
  Upload.MIN_PART_SIZE = 5242880;
});
var init_types14 = () => {
};
var init_dist_es65 = __esm2(() => {
  init_Upload();
  init_types14();
});
function formatUrl(request5) {
  const { port, query } = request5;
  let { protocol, path: path5, hostname } = request5;
  if (protocol && protocol.slice(-1) !== ":") {
    protocol += ":";
  }
  if (port) {
    hostname += `:${port}`;
  }
  if (path5 && path5.charAt(0) !== "/") {
    path5 = `/${path5}`;
  }
  let queryString = query ? buildQueryString(query) : "";
  if (queryString && queryString[0] !== "?") {
    queryString = `?${queryString}`;
  }
  let auth = "";
  if (request5.username != null || request5.password != null) {
    const username = request5.username ?? "";
    const password = request5.password ?? "";
    auth = `${username}:${password}@`;
  }
  let fragment = "";
  if (request5.fragment) {
    fragment = `#${request5.fragment}`;
  }
  return `${protocol}//${auth}${hostname}${path5}${queryString}${fragment}`;
}
var init_dist_es66 = __esm2(() => {
  init_dist_es17();
});
var UNSIGNED_PAYLOAD2 = "UNSIGNED-PAYLOAD";
var SHA256_HEADER2 = "X-Amz-Content-Sha256";

class S3RequestPresigner {
  constructor(options3) {
    const resolvedOptions = {
      service: options3.signingName || options3.service || "s3",
      uriEscapePath: options3.uriEscapePath || false,
      applyChecksum: options3.applyChecksum || false,
      ...options3
    };
    this.signer = new SignatureV4MultiRegion(resolvedOptions);
  }
  presign(requestToSign, { unsignableHeaders = new Set, hoistableHeaders = new Set, unhoistableHeaders = new Set, ...options3 } = {}) {
    this.prepareRequest(requestToSign, {
      unsignableHeaders,
      unhoistableHeaders,
      hoistableHeaders
    });
    return this.signer.presign(requestToSign, {
      expiresIn: 900,
      unsignableHeaders,
      unhoistableHeaders,
      ...options3
    });
  }
  presignWithCredentials(requestToSign, credentials, { unsignableHeaders = new Set, hoistableHeaders = new Set, unhoistableHeaders = new Set, ...options3 } = {}) {
    this.prepareRequest(requestToSign, {
      unsignableHeaders,
      unhoistableHeaders,
      hoistableHeaders
    });
    return this.signer.presignWithCredentials(requestToSign, credentials, {
      expiresIn: 900,
      unsignableHeaders,
      unhoistableHeaders,
      ...options3
    });
  }
  prepareRequest(requestToSign, { unsignableHeaders = new Set, unhoistableHeaders = new Set, hoistableHeaders = new Set } = {}) {
    unsignableHeaders.add("content-type");
    Object.keys(requestToSign.headers).map((header) => header.toLowerCase()).filter((header) => header.startsWith("x-amz-server-side-encryption")).forEach((header) => {
      if (!hoistableHeaders.has(header)) {
        unhoistableHeaders.add(header);
      }
    });
    requestToSign.headers[SHA256_HEADER2] = UNSIGNED_PAYLOAD2;
    const currentHostHeader = requestToSign.headers.host;
    const port = requestToSign.port;
    const expectedHostHeader = `${requestToSign.hostname}${requestToSign.port != null ? ":" + port : ""}`;
    if (!currentHostHeader || currentHostHeader === requestToSign.hostname && requestToSign.port != null) {
      requestToSign.headers.host = expectedHostHeader;
    }
  }
}
var init_presigner = __esm2(() => {
  init_dist_es36();
});
var getSignedUrl = async (client2, command3, options3 = {}) => {
  let s3Presigner;
  let region;
  if (typeof client2.config.endpointProvider === "function") {
    const endpointV2 = await getEndpointFromInstructions(command3.input, command3.constructor, client2.config);
    const authScheme = endpointV2.properties?.authSchemes?.[0];
    if (authScheme?.name === "sigv4a") {
      region = authScheme?.signingRegionSet?.join(",");
    } else {
      region = authScheme?.signingRegion;
    }
    s3Presigner = new S3RequestPresigner({
      ...client2.config,
      signingName: authScheme?.signingName,
      region: async () => region
    });
  } else {
    s3Presigner = new S3RequestPresigner(client2.config);
  }
  const presignInterceptMiddleware = (next, context) => async (args) => {
    const { request: request5 } = args;
    if (!HttpRequest.isInstance(request5)) {
      throw new Error("Request to be presigned is not an valid HTTP request.");
    }
    delete request5.headers["amz-sdk-invocation-id"];
    delete request5.headers["amz-sdk-request"];
    delete request5.headers["x-amz-user-agent"];
    let presigned2;
    const presignerOptions = {
      ...options3,
      signingRegion: options3.signingRegion ?? context["signing_region"] ?? region,
      signingService: options3.signingService ?? context["signing_service"]
    };
    if (context.s3ExpressIdentity) {
      presigned2 = await s3Presigner.presignWithCredentials(request5, context.s3ExpressIdentity, presignerOptions);
    } else {
      presigned2 = await s3Presigner.presign(request5, presignerOptions);
    }
    return {
      response: {},
      output: {
        $metadata: { httpStatusCode: 200 },
        presigned: presigned2
      }
    };
  };
  const middlewareName = "presignInterceptMiddleware";
  const clientStack = client2.middlewareStack.clone();
  clientStack.addRelativeTo(presignInterceptMiddleware, {
    name: middlewareName,
    relation: "before",
    toMiddleware: "awsAuthMiddleware",
    override: true
  });
  const handler3 = command3.resolveMiddleware(clientStack, client2.config, {});
  const { output } = await handler3({ input: command3.input });
  const { presigned } = output;
  return formatUrl(presigned);
};
var init_getSignedUrl = __esm2(() => {
  init_dist_es66();
  init_dist_es32();
  init_dist_es();
  init_presigner();
});
var init_dist_es67 = __esm2(() => {
  init_getSignedUrl();
  init_presigner();
});
async function checksumFromStream(stream2, options3) {
  return new Promise(async (resolve5, reject) => {
    const hash3 = createHash3(options3.algo ?? "md5");
    stream2.on("error", reject);
    stream2.pipe(hash3, { end: false });
    stream2.on("end", () => {
      hash3.end();
      resolve5(hash3.digest(options3.encoding ?? "hex"));
    });
  });
}
var init_checksum_from_stream = () => {
};
function errorToMessage(error) {
  return error instanceof Error ? error.message : String(error);
}
var FlystorageError;
var ChecksumIsNotAvailable;
var UnableToGetChecksum;
var UnableToGetMimeType;
var UnableToGetLastModified;
var UnableToGetFileSize;
var UnableToWriteFile;
var UnableToReadFile;
var UnableToSetVisibility;
var UnableToGetVisibility;
var UnableToGetPublicUrl;
var UnableToGetTemporaryUrl;
var UnableToCopyFile;
var UnableToMoveFile;
var UnableToGetStat;
var UnableToCreateDirectory;
var UnableToDeleteDirectory;
var UnableToDeleteFile;
var UnableToCheckFileExistence;
var UnableToCheckDirectoryExistence;
var UnableToListDirectory;
var init_errors2 = __esm2(() => {
  FlystorageError = class FlystorageError2 extends Error {
    context;
    code = "unknown_error";
    constructor(message, context = {}, cause = undefined) {
      const options3 = cause === undefined ? undefined : { cause };
      super(message, options3);
      this.context = context;
    }
  };
  ChecksumIsNotAvailable = class ChecksumIsNotAvailable2 extends FlystorageError {
    algo;
    code = "flystorage.checksum_not_supported";
    constructor(message, algo, context = {}, cause = undefined) {
      super(message, context, cause);
      this.algo = algo;
    }
    static checksumNotSupported = (algo, { context = {}, cause = undefined } = {}) => new ChecksumIsNotAvailable2(`Checksum algo "${algo}" is not supported`, algo, { ...context, algo }, cause);
  };
  UnableToGetChecksum = class UnableToGetChecksum2 extends FlystorageError {
    code = "flystorage.unable_to_get_checksum";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetChecksum2(`Unable to write the file. Reason: ${reason}`, context, cause);
  };
  UnableToGetMimeType = class UnableToGetMimeType2 extends FlystorageError {
    code = "flystorage.unable_to_get_mimetype";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetMimeType2(`Unable to get mime-type. Reason: ${reason}`, context, cause);
  };
  UnableToGetLastModified = class UnableToGetLastModified2 extends FlystorageError {
    code = "flystorage.unable_to_get_last_modified";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetLastModified2(`Unable to get last modified. Reason: ${reason}`, context, cause);
  };
  UnableToGetFileSize = class UnableToGetFileSize2 extends FlystorageError {
    code = "flystorage.unable_to_get_file_size";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetFileSize2(`Unable to get file size. Reason: ${reason}`, context, cause);
  };
  UnableToWriteFile = class UnableToWriteFile2 extends FlystorageError {
    code = "flystorage.unable_to_write_file";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToWriteFile2(`Unable to write the file. Reason: ${reason}`, context, cause);
  };
  UnableToReadFile = class UnableToReadFile2 extends FlystorageError {
    code = "flystorage.unable_to_read_file";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToReadFile2(`Unable to read the file. Reason: ${reason}`, context, cause);
  };
  UnableToSetVisibility = class UnableToSetVisibility2 extends FlystorageError {
    code = "flystorage.unable_to_set_visibility";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToSetVisibility2(`Unable to set visibility. Reason: ${reason}`, context, cause);
  };
  UnableToGetVisibility = class UnableToGetVisibility2 extends FlystorageError {
    code = "flystorage.unable_to_get_visibility";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetVisibility2(`Unable to get visibility. Reason: ${reason}`, context, cause);
  };
  UnableToGetPublicUrl = class UnableToGetPublicUrl2 extends FlystorageError {
    code = "flystorage.unable_to_get_public_url";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetPublicUrl2(`Unable to get public URL. Reason: ${reason}`, context, cause);
  };
  UnableToGetTemporaryUrl = class UnableToGetTemporaryUrl2 extends FlystorageError {
    code = "flystorage.unable_to_get_temporary_url";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetTemporaryUrl2(`Unable to get temporary URL. Reason: ${reason}`, context, cause);
  };
  UnableToCopyFile = class UnableToCopyFile2 extends FlystorageError {
    code = "flystorage.unable_to_copy_file";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToCopyFile2(`Unable to copy file. Reason: ${reason}`, context, cause);
  };
  UnableToMoveFile = class UnableToMoveFile2 extends FlystorageError {
    code = "flystorage.unable_to_move_file";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToMoveFile2(`Unable to move file. Reason: ${reason}`, context, cause);
  };
  UnableToGetStat = class UnableToGetStat2 extends FlystorageError {
    code = "flystorage.unable_to_get_stat";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToGetStat2(`Unable to get stat. Reason: ${reason}`, context, cause);
    static noFileStatResolved = ({ context = {}, cause = undefined }) => new UnableToGetStat2(`Stat was not a file.`, context, cause);
  };
  UnableToCreateDirectory = class UnableToCreateDirectory2 extends FlystorageError {
    code = "flystorage.unable_to_create_directory";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToCreateDirectory2(`Unable to create directory. Reason: ${reason}`, context, cause);
  };
  UnableToDeleteDirectory = class UnableToDeleteDirectory2 extends FlystorageError {
    code = "flystorage.unable_to_delete_directory";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToDeleteDirectory2(`Unable to delete directory. Reason: ${reason}`, context, cause);
  };
  UnableToDeleteFile = class UnableToDeleteFile2 extends FlystorageError {
    code = "flystorage.unable_to_delete_file";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToDeleteFile2(`Unable to delete file. Reason: ${reason}`, context, cause);
  };
  UnableToCheckFileExistence = class UnableToCheckFileExistence2 extends FlystorageError {
    code = "flystorage.unable_to_check_file_existence";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToCheckFileExistence2(`Unable to check file existence. Reason: ${reason}`, context, cause);
  };
  UnableToCheckDirectoryExistence = class UnableToCheckDirectoryExistence2 extends FlystorageError {
    code = "flystorage.unable_to_check_directory_existence";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToCheckDirectoryExistence2(`Unable to check directory existence. Reason: ${reason}`, context, cause);
  };
  UnableToListDirectory = class UnableToListDirectory2 extends FlystorageError {
    code = "flystorage.unable_to_list_directory_contents";
    static because = (reason, { context = {}, cause = undefined }) => new UnableToListDirectory2(`Unable to list directory contents. Reason: ${reason}`, context, cause);
  };
});

class PathNormalizerV1 {
  normalizePath(path5) {
    if (funkyWhiteSpaceRegex.test(path5)) {
      throw CorruptedPathDetected.unexpectedWhitespace(path5);
    }
    const normalized = join6(...path5.split("/"));
    if (normalized.indexOf("../") !== -1 || normalized == "..") {
      throw PathTraversalDetected.forPath(path5);
    }
    return normalized === "." ? "" : normalized;
  }
}
var funkyWhiteSpaceRegex;
var CorruptedPathDetected;
var PathTraversalDetected;
var init_path_normalizer = __esm2(() => {
  funkyWhiteSpaceRegex = new RegExp("\\p{C}+", "u");
  CorruptedPathDetected = class CorruptedPathDetected2 extends Error {
    static unexpectedWhitespace = (path5) => new CorruptedPathDetected2(`Corrupted path detected with unexpected whitespace: ${path5}`);
  };
  PathTraversalDetected = class PathTraversalDetected2 extends Error {
    static forPath = (path5) => new PathTraversalDetected2(`Path traversal detected for: ${path5}`);
  };
});
function isFile2(stat22) {
  return stat22.isFile;
}
function isDirectory(stat22) {
  return stat22.isDirectory;
}
function toReadable(contents) {
  if (contents instanceof Readable7) {
    return contents;
  }
  return Readable7.from(contents);
}

class FileStorage {
  adapter;
  pathNormalizer;
  options;
  constructor(adapter, pathNormalizer = new PathNormalizerV1, options3 = {}) {
    this.adapter = adapter;
    this.pathNormalizer = pathNormalizer;
    this.options = options3;
  }
  async write(path5, contents, options3 = {}) {
    try {
      const body = toReadable(contents);
      await this.adapter.write(this.pathNormalizer.normalizePath(path5), body, { ...this.options.visibility, ...this.options.writes, ...options3 });
      await closeReadable(body);
    } catch (error) {
      throw UnableToWriteFile.because(errorToMessage(error), { cause: error, context: { path: path5, options: options3 } });
    }
  }
  async read(path5) {
    try {
      return Readable7.from(await this.adapter.read(this.pathNormalizer.normalizePath(path5)));
    } catch (error) {
      throw UnableToReadFile.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async readToString(path5) {
    return await readableToString(await this.read(path5));
  }
  async readToUint8Array(path5) {
    return await readableToUint8Array(await this.read(path5));
  }
  async readToBuffer(path5) {
    return Buffer.from(await this.readToUint8Array(path5));
  }
  async deleteFile(path5) {
    try {
      await this.adapter.deleteFile(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToDeleteFile.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async createDirectory(path5, options3 = {}) {
    try {
      return await this.adapter.createDirectory(this.pathNormalizer.normalizePath(path5), { ...this.options.visibility, ...options3 });
    } catch (error) {
      throw UnableToCreateDirectory.because(errorToMessage(error), { cause: error, context: { path: path5, options: options3 } });
    }
  }
  async deleteDirectory(path5) {
    try {
      return await this.adapter.deleteDirectory(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToDeleteDirectory.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async stat(path5) {
    try {
      return await this.adapter.stat(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToGetStat.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async moveFile(from, to, options3 = {}) {
    try {
      await this.adapter.moveFile(this.pathNormalizer.normalizePath(from), this.pathNormalizer.normalizePath(to), { ...this.options.visibility, ...this.options.moves, ...options3 });
    } catch (error) {
      throw UnableToMoveFile.because(errorToMessage(error), { cause: error, context: { from, to } });
    }
  }
  async copyFile(from, to, options3 = {}) {
    try {
      await this.adapter.copyFile(this.pathNormalizer.normalizePath(from), this.pathNormalizer.normalizePath(to), { ...this.options.visibility, ...this.options.copies, ...options3 });
    } catch (error) {
      throw UnableToCopyFile.because(errorToMessage(error), { cause: error, context: { from, to } });
    }
  }
  async setVisibility(path5, visibility) {
    return this.changeVisibility(path5, visibility);
  }
  async changeVisibility(path5, visibility) {
    try {
      return await this.adapter.changeVisibility(this.pathNormalizer.normalizePath(path5), visibility);
    } catch (error) {
      throw UnableToSetVisibility.because(errorToMessage(error), { cause: error, context: { path: path5, visibility } });
    }
  }
  async visibility(path5) {
    try {
      return await this.adapter.visibility(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToGetVisibility.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async fileExists(path5) {
    try {
      return await this.adapter.fileExists(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToCheckFileExistence.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  list(path5, { deep = false } = {}) {
    return new DirectoryListing(this.adapter.list(this.pathNormalizer.normalizePath(path5), { deep }), path5, deep);
  }
  async statFile(path5) {
    const stat22 = await this.stat(path5);
    if (isFile2(stat22)) {
      return stat22;
    }
    throw UnableToGetStat.noFileStatResolved({ context: { path: path5 } });
  }
  async directoryExists(path5) {
    try {
      return await this.adapter.directoryExists(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToCheckDirectoryExistence.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async publicUrl(path5, options3 = {}) {
    try {
      return await this.adapter.publicUrl(this.pathNormalizer.normalizePath(path5), { ...this.options.publicUrls, ...options3 });
    } catch (error) {
      throw UnableToGetPublicUrl.because(errorToMessage(error), { cause: error, context: { path: path5, options: options3 } });
    }
  }
  async temporaryUrl(path5, options3) {
    try {
      return await this.adapter.temporaryUrl(this.pathNormalizer.normalizePath(path5), { ...this.options.temporaryUrls, ...options3 });
    } catch (error) {
      throw UnableToGetTemporaryUrl.because(errorToMessage(error), { cause: error, context: { path: path5, options: options3 } });
    }
  }
  async checksum(path5, options3 = {}) {
    try {
      return await this.adapter.checksum(this.pathNormalizer.normalizePath(path5), { ...this.options.checksums, ...options3 });
    } catch (error) {
      if (error instanceof ChecksumIsNotAvailable) {
        return this.calculateChecksum(path5, options3);
      }
      throw UnableToGetChecksum.because(errorToMessage(error), { cause: error, context: { path: path5, options: options3 } });
    }
  }
  async mimeType(path5, options3 = {}) {
    try {
      return await this.adapter.mimeType(this.pathNormalizer.normalizePath(path5), { ...this.options.mimeTypes, ...options3 });
    } catch (error) {
      throw UnableToGetMimeType.because(errorToMessage(error), { cause: error, context: { path: path5, options: options3 } });
    }
  }
  async lastModified(path5) {
    try {
      return await this.adapter.lastModified(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToGetLastModified.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async fileSize(path5) {
    try {
      return await this.adapter.fileSize(this.pathNormalizer.normalizePath(path5));
    } catch (error) {
      throw UnableToGetFileSize.because(errorToMessage(error), { cause: error, context: { path: path5 } });
    }
  }
  async calculateChecksum(path5, options3) {
    try {
      return await checksumFromStream(await this.read(path5), options3);
    } catch (error) {
      throw UnableToGetChecksum.because(errorToMessage(error), { cause: error, context: { path: path5, options: options3 } });
    }
  }
}
function normalizeExpiryToDate(expiresAt) {
  return expiresAt instanceof Date ? expiresAt : new Date(expiresAt);
}
function normalizeExpiryToMilliseconds(expiresAt) {
  return expiresAt instanceof Date ? expiresAt.getTime() : expiresAt;
}
async function closeReadable(body) {
  if (body.closed) {
    return;
  }
  await new Promise((resolve5, reject) => {
    body.on("close", (err22) => {
      err22 ? reject(err22) : resolve5();
    });
    body.destroy();
  });
}
async function readableToString(stream2) {
  const contents = decoder.decode(await readableToUint8Array(stream2));
  await closeReadable(stream2);
  return contents;
}
function readableToUint8Array(stream2) {
  return new Promise((resolve5, reject) => {
    const parts = [];
    stream2.on("data", (chunk) => {
      const type2 = typeof chunk;
      if (type2 === "string") {
        chunk = encoder.encode(chunk);
      } else if (type2 === "number") {
        chunk = new Uint8Array([chunk]);
      }
      parts.push(chunk);
    });
    stream2.on("error", reject);
    stream2.on("end", () => resolve5(concatUint8Arrays(parts)));
  });
}
function concatUint8Arrays(input) {
  const length = input.reduce((l6, a5) => l6 + a5.byteLength, 0);
  const output = new Uint8Array(length);
  let position = 0;
  input.forEach((i5) => {
    output.set(i5, position);
    position += i5.byteLength;
  });
  return output;
}
var DirectoryListing;
var naturalSorting;
var decoder;
var encoder;
var init_file_storage = __esm2(() => {
  init_checksum_from_stream();
  init_errors2();
  init_errors2();
  init_path_normalizer();
  DirectoryListing = class DirectoryListing2 {
    listing;
    path;
    deep;
    constructor(listing, path5, deep) {
      this.listing = listing;
      this.path = path5;
      this.deep = deep;
    }
    async toArray(sorted = true) {
      const items = [];
      for await (const item of this.listing) {
        items.push(item);
      }
      return sorted ? items.sort((a5, b6) => naturalSorting.compare(a5.path, b6.path)) : items;
    }
    filter(filter) {
      const listing = this.listing;
      const filtered = async function* () {
        for await (const entry of listing) {
          if (filter(entry)) {
            yield entry;
          }
        }
      }();
      return new DirectoryListing2(filtered, this.path, this.deep);
    }
    async* [Symbol.asyncIterator]() {
      try {
        for await (const item of this.listing) {
          yield item;
        }
      } catch (error) {
        throw UnableToListDirectory.because(errorToMessage(error), { cause: error, context: { path: this.path, deep: this.deep } });
      }
    }
  };
  naturalSorting = new Intl.Collator(undefined, {
    numeric: true,
    sensitivity: "base"
  });
  decoder = new TextDecoder;
  encoder = new TextEncoder2;
});

class PathPrefixer {
  separator;
  joinFunc;
  prefix = "";
  constructor(prefix = "", separator = "/", joinFunc = join7) {
    this.separator = separator;
    this.joinFunc = joinFunc;
    if (prefix.length > 0) {
      this.prefix = this.joinFunc(prefix, this.separator);
    }
  }
  prefixFilePath(path5) {
    return this.prefix.length > 0 ? this.joinFunc(this.prefix, path5) : path5;
  }
  prefixDirectoryPath(path5) {
    return this.prefix.length > 0 ? this.joinFunc(this.prefix, path5, "/") : this.joinFunc(path5, "/");
  }
  stripFilePath(path5) {
    return path5.substring(this.prefix.length);
  }
  stripDirectoryPath(path5) {
    return this.stripFilePath(path5).replace(/\/+$/g, "");
  }
}
var init_path_prefixer = () => {
};
var Visibility;
var init_portable_visibility = __esm2(() => {
  (function(Visibility2) {
    Visibility2["PUBLIC"] = "public";
    Visibility2["PRIVATE"] = "private";
  })(Visibility || (Visibility = {}));
});
var init_esm3 = __esm2(() => {
  init_checksum_from_stream();
  init_file_storage();
  init_errors2();
  init_path_normalizer();
  init_path_prefixer();
  init_portable_visibility();
});
var require_db = __commonJS2((exports, module) => {
  module.exports = {
    "application/1d-interleaved-parityfec": {
      source: "iana"
    },
    "application/3gpdash-qoe-report+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/3gpp-ims+xml": {
      source: "iana",
      compressible: true
    },
    "application/3gpphal+json": {
      source: "iana",
      compressible: true
    },
    "application/3gpphalforms+json": {
      source: "iana",
      compressible: true
    },
    "application/a2l": {
      source: "iana"
    },
    "application/ace+cbor": {
      source: "iana"
    },
    "application/activemessage": {
      source: "iana"
    },
    "application/activity+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-costmap+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-costmapfilter+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-directory+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-endpointcost+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-endpointcostparams+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-endpointprop+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-endpointpropparams+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-error+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-networkmap+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-networkmapfilter+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-updatestreamcontrol+json": {
      source: "iana",
      compressible: true
    },
    "application/alto-updatestreamparams+json": {
      source: "iana",
      compressible: true
    },
    "application/aml": {
      source: "iana"
    },
    "application/andrew-inset": {
      source: "iana",
      extensions: ["ez"]
    },
    "application/applefile": {
      source: "iana"
    },
    "application/applixware": {
      source: "apache",
      extensions: ["aw"]
    },
    "application/at+jwt": {
      source: "iana"
    },
    "application/atf": {
      source: "iana"
    },
    "application/atfx": {
      source: "iana"
    },
    "application/atom+xml": {
      source: "iana",
      compressible: true,
      extensions: ["atom"]
    },
    "application/atomcat+xml": {
      source: "iana",
      compressible: true,
      extensions: ["atomcat"]
    },
    "application/atomdeleted+xml": {
      source: "iana",
      compressible: true,
      extensions: ["atomdeleted"]
    },
    "application/atomicmail": {
      source: "iana"
    },
    "application/atomsvc+xml": {
      source: "iana",
      compressible: true,
      extensions: ["atomsvc"]
    },
    "application/atsc-dwd+xml": {
      source: "iana",
      compressible: true,
      extensions: ["dwd"]
    },
    "application/atsc-dynamic-event-message": {
      source: "iana"
    },
    "application/atsc-held+xml": {
      source: "iana",
      compressible: true,
      extensions: ["held"]
    },
    "application/atsc-rdt+json": {
      source: "iana",
      compressible: true
    },
    "application/atsc-rsat+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rsat"]
    },
    "application/atxml": {
      source: "iana"
    },
    "application/auth-policy+xml": {
      source: "iana",
      compressible: true
    },
    "application/bacnet-xdd+zip": {
      source: "iana",
      compressible: false
    },
    "application/batch-smtp": {
      source: "iana"
    },
    "application/bdoc": {
      compressible: false,
      extensions: ["bdoc"]
    },
    "application/beep+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/calendar+json": {
      source: "iana",
      compressible: true
    },
    "application/calendar+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xcs"]
    },
    "application/call-completion": {
      source: "iana"
    },
    "application/cals-1840": {
      source: "iana"
    },
    "application/captive+json": {
      source: "iana",
      compressible: true
    },
    "application/cbor": {
      source: "iana"
    },
    "application/cbor-seq": {
      source: "iana"
    },
    "application/cccex": {
      source: "iana"
    },
    "application/ccmp+xml": {
      source: "iana",
      compressible: true
    },
    "application/ccxml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["ccxml"]
    },
    "application/cdfx+xml": {
      source: "iana",
      compressible: true,
      extensions: ["cdfx"]
    },
    "application/cdmi-capability": {
      source: "iana",
      extensions: ["cdmia"]
    },
    "application/cdmi-container": {
      source: "iana",
      extensions: ["cdmic"]
    },
    "application/cdmi-domain": {
      source: "iana",
      extensions: ["cdmid"]
    },
    "application/cdmi-object": {
      source: "iana",
      extensions: ["cdmio"]
    },
    "application/cdmi-queue": {
      source: "iana",
      extensions: ["cdmiq"]
    },
    "application/cdni": {
      source: "iana"
    },
    "application/cea": {
      source: "iana"
    },
    "application/cea-2018+xml": {
      source: "iana",
      compressible: true
    },
    "application/cellml+xml": {
      source: "iana",
      compressible: true
    },
    "application/cfw": {
      source: "iana"
    },
    "application/city+json": {
      source: "iana",
      compressible: true
    },
    "application/clr": {
      source: "iana"
    },
    "application/clue+xml": {
      source: "iana",
      compressible: true
    },
    "application/clue_info+xml": {
      source: "iana",
      compressible: true
    },
    "application/cms": {
      source: "iana"
    },
    "application/cnrp+xml": {
      source: "iana",
      compressible: true
    },
    "application/coap-group+json": {
      source: "iana",
      compressible: true
    },
    "application/coap-payload": {
      source: "iana"
    },
    "application/commonground": {
      source: "iana"
    },
    "application/conference-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/cose": {
      source: "iana"
    },
    "application/cose-key": {
      source: "iana"
    },
    "application/cose-key-set": {
      source: "iana"
    },
    "application/cpl+xml": {
      source: "iana",
      compressible: true,
      extensions: ["cpl"]
    },
    "application/csrattrs": {
      source: "iana"
    },
    "application/csta+xml": {
      source: "iana",
      compressible: true
    },
    "application/cstadata+xml": {
      source: "iana",
      compressible: true
    },
    "application/csvm+json": {
      source: "iana",
      compressible: true
    },
    "application/cu-seeme": {
      source: "apache",
      extensions: ["cu"]
    },
    "application/cwt": {
      source: "iana"
    },
    "application/cybercash": {
      source: "iana"
    },
    "application/dart": {
      compressible: true
    },
    "application/dash+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mpd"]
    },
    "application/dash-patch+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mpp"]
    },
    "application/dashdelta": {
      source: "iana"
    },
    "application/davmount+xml": {
      source: "iana",
      compressible: true,
      extensions: ["davmount"]
    },
    "application/dca-rft": {
      source: "iana"
    },
    "application/dcd": {
      source: "iana"
    },
    "application/dec-dx": {
      source: "iana"
    },
    "application/dialog-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/dicom": {
      source: "iana"
    },
    "application/dicom+json": {
      source: "iana",
      compressible: true
    },
    "application/dicom+xml": {
      source: "iana",
      compressible: true
    },
    "application/dii": {
      source: "iana"
    },
    "application/dit": {
      source: "iana"
    },
    "application/dns": {
      source: "iana"
    },
    "application/dns+json": {
      source: "iana",
      compressible: true
    },
    "application/dns-message": {
      source: "iana"
    },
    "application/docbook+xml": {
      source: "apache",
      compressible: true,
      extensions: ["dbk"]
    },
    "application/dots+cbor": {
      source: "iana"
    },
    "application/dskpp+xml": {
      source: "iana",
      compressible: true
    },
    "application/dssc+der": {
      source: "iana",
      extensions: ["dssc"]
    },
    "application/dssc+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xdssc"]
    },
    "application/dvcs": {
      source: "iana"
    },
    "application/ecmascript": {
      source: "iana",
      compressible: true,
      extensions: ["es", "ecma"]
    },
    "application/edi-consent": {
      source: "iana"
    },
    "application/edi-x12": {
      source: "iana",
      compressible: false
    },
    "application/edifact": {
      source: "iana",
      compressible: false
    },
    "application/efi": {
      source: "iana"
    },
    "application/elm+json": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/elm+xml": {
      source: "iana",
      compressible: true
    },
    "application/emergencycalldata.cap+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/emergencycalldata.comment+xml": {
      source: "iana",
      compressible: true
    },
    "application/emergencycalldata.control+xml": {
      source: "iana",
      compressible: true
    },
    "application/emergencycalldata.deviceinfo+xml": {
      source: "iana",
      compressible: true
    },
    "application/emergencycalldata.ecall.msd": {
      source: "iana"
    },
    "application/emergencycalldata.providerinfo+xml": {
      source: "iana",
      compressible: true
    },
    "application/emergencycalldata.serviceinfo+xml": {
      source: "iana",
      compressible: true
    },
    "application/emergencycalldata.subscriberinfo+xml": {
      source: "iana",
      compressible: true
    },
    "application/emergencycalldata.veds+xml": {
      source: "iana",
      compressible: true
    },
    "application/emma+xml": {
      source: "iana",
      compressible: true,
      extensions: ["emma"]
    },
    "application/emotionml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["emotionml"]
    },
    "application/encaprtp": {
      source: "iana"
    },
    "application/epp+xml": {
      source: "iana",
      compressible: true
    },
    "application/epub+zip": {
      source: "iana",
      compressible: false,
      extensions: ["epub"]
    },
    "application/eshop": {
      source: "iana"
    },
    "application/exi": {
      source: "iana",
      extensions: ["exi"]
    },
    "application/expect-ct-report+json": {
      source: "iana",
      compressible: true
    },
    "application/express": {
      source: "iana",
      extensions: ["exp"]
    },
    "application/fastinfoset": {
      source: "iana"
    },
    "application/fastsoap": {
      source: "iana"
    },
    "application/fdt+xml": {
      source: "iana",
      compressible: true,
      extensions: ["fdt"]
    },
    "application/fhir+json": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/fhir+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/fido.trusted-apps+json": {
      compressible: true
    },
    "application/fits": {
      source: "iana"
    },
    "application/flexfec": {
      source: "iana"
    },
    "application/font-sfnt": {
      source: "iana"
    },
    "application/font-tdpfr": {
      source: "iana",
      extensions: ["pfr"]
    },
    "application/font-woff": {
      source: "iana",
      compressible: false
    },
    "application/framework-attributes+xml": {
      source: "iana",
      compressible: true
    },
    "application/geo+json": {
      source: "iana",
      compressible: true,
      extensions: ["geojson"]
    },
    "application/geo+json-seq": {
      source: "iana"
    },
    "application/geopackage+sqlite3": {
      source: "iana"
    },
    "application/geoxacml+xml": {
      source: "iana",
      compressible: true
    },
    "application/gltf-buffer": {
      source: "iana"
    },
    "application/gml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["gml"]
    },
    "application/gpx+xml": {
      source: "apache",
      compressible: true,
      extensions: ["gpx"]
    },
    "application/gxf": {
      source: "apache",
      extensions: ["gxf"]
    },
    "application/gzip": {
      source: "iana",
      compressible: false,
      extensions: ["gz"]
    },
    "application/h224": {
      source: "iana"
    },
    "application/held+xml": {
      source: "iana",
      compressible: true
    },
    "application/hjson": {
      extensions: ["hjson"]
    },
    "application/http": {
      source: "iana"
    },
    "application/hyperstudio": {
      source: "iana",
      extensions: ["stk"]
    },
    "application/ibe-key-request+xml": {
      source: "iana",
      compressible: true
    },
    "application/ibe-pkg-reply+xml": {
      source: "iana",
      compressible: true
    },
    "application/ibe-pp-data": {
      source: "iana"
    },
    "application/iges": {
      source: "iana"
    },
    "application/im-iscomposing+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/index": {
      source: "iana"
    },
    "application/index.cmd": {
      source: "iana"
    },
    "application/index.obj": {
      source: "iana"
    },
    "application/index.response": {
      source: "iana"
    },
    "application/index.vnd": {
      source: "iana"
    },
    "application/inkml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["ink", "inkml"]
    },
    "application/iotp": {
      source: "iana"
    },
    "application/ipfix": {
      source: "iana",
      extensions: ["ipfix"]
    },
    "application/ipp": {
      source: "iana"
    },
    "application/isup": {
      source: "iana"
    },
    "application/its+xml": {
      source: "iana",
      compressible: true,
      extensions: ["its"]
    },
    "application/java-archive": {
      source: "apache",
      compressible: false,
      extensions: ["jar", "war", "ear"]
    },
    "application/java-serialized-object": {
      source: "apache",
      compressible: false,
      extensions: ["ser"]
    },
    "application/java-vm": {
      source: "apache",
      compressible: false,
      extensions: ["class"]
    },
    "application/javascript": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["js", "mjs"]
    },
    "application/jf2feed+json": {
      source: "iana",
      compressible: true
    },
    "application/jose": {
      source: "iana"
    },
    "application/jose+json": {
      source: "iana",
      compressible: true
    },
    "application/jrd+json": {
      source: "iana",
      compressible: true
    },
    "application/jscalendar+json": {
      source: "iana",
      compressible: true
    },
    "application/json": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["json", "map"]
    },
    "application/json-patch+json": {
      source: "iana",
      compressible: true
    },
    "application/json-seq": {
      source: "iana"
    },
    "application/json5": {
      extensions: ["json5"]
    },
    "application/jsonml+json": {
      source: "apache",
      compressible: true,
      extensions: ["jsonml"]
    },
    "application/jwk+json": {
      source: "iana",
      compressible: true
    },
    "application/jwk-set+json": {
      source: "iana",
      compressible: true
    },
    "application/jwt": {
      source: "iana"
    },
    "application/kpml-request+xml": {
      source: "iana",
      compressible: true
    },
    "application/kpml-response+xml": {
      source: "iana",
      compressible: true
    },
    "application/ld+json": {
      source: "iana",
      compressible: true,
      extensions: ["jsonld"]
    },
    "application/lgr+xml": {
      source: "iana",
      compressible: true,
      extensions: ["lgr"]
    },
    "application/link-format": {
      source: "iana"
    },
    "application/load-control+xml": {
      source: "iana",
      compressible: true
    },
    "application/lost+xml": {
      source: "iana",
      compressible: true,
      extensions: ["lostxml"]
    },
    "application/lostsync+xml": {
      source: "iana",
      compressible: true
    },
    "application/lpf+zip": {
      source: "iana",
      compressible: false
    },
    "application/lxf": {
      source: "iana"
    },
    "application/mac-binhex40": {
      source: "iana",
      extensions: ["hqx"]
    },
    "application/mac-compactpro": {
      source: "apache",
      extensions: ["cpt"]
    },
    "application/macwriteii": {
      source: "iana"
    },
    "application/mads+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mads"]
    },
    "application/manifest+json": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["webmanifest"]
    },
    "application/marc": {
      source: "iana",
      extensions: ["mrc"]
    },
    "application/marcxml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mrcx"]
    },
    "application/mathematica": {
      source: "iana",
      extensions: ["ma", "nb", "mb"]
    },
    "application/mathml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mathml"]
    },
    "application/mathml-content+xml": {
      source: "iana",
      compressible: true
    },
    "application/mathml-presentation+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-associated-procedure-description+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-deregister+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-envelope+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-msk+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-msk-response+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-protection-description+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-reception-report+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-register+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-register-response+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-schedule+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbms-user-service-description+xml": {
      source: "iana",
      compressible: true
    },
    "application/mbox": {
      source: "iana",
      extensions: ["mbox"]
    },
    "application/media-policy-dataset+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mpf"]
    },
    "application/media_control+xml": {
      source: "iana",
      compressible: true
    },
    "application/mediaservercontrol+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mscml"]
    },
    "application/merge-patch+json": {
      source: "iana",
      compressible: true
    },
    "application/metalink+xml": {
      source: "apache",
      compressible: true,
      extensions: ["metalink"]
    },
    "application/metalink4+xml": {
      source: "iana",
      compressible: true,
      extensions: ["meta4"]
    },
    "application/mets+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mets"]
    },
    "application/mf4": {
      source: "iana"
    },
    "application/mikey": {
      source: "iana"
    },
    "application/mipc": {
      source: "iana"
    },
    "application/missing-blocks+cbor-seq": {
      source: "iana"
    },
    "application/mmt-aei+xml": {
      source: "iana",
      compressible: true,
      extensions: ["maei"]
    },
    "application/mmt-usd+xml": {
      source: "iana",
      compressible: true,
      extensions: ["musd"]
    },
    "application/mods+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mods"]
    },
    "application/moss-keys": {
      source: "iana"
    },
    "application/moss-signature": {
      source: "iana"
    },
    "application/mosskey-data": {
      source: "iana"
    },
    "application/mosskey-request": {
      source: "iana"
    },
    "application/mp21": {
      source: "iana",
      extensions: ["m21", "mp21"]
    },
    "application/mp4": {
      source: "iana",
      extensions: ["mp4s", "m4p"]
    },
    "application/mpeg4-generic": {
      source: "iana"
    },
    "application/mpeg4-iod": {
      source: "iana"
    },
    "application/mpeg4-iod-xmt": {
      source: "iana"
    },
    "application/mrb-consumer+xml": {
      source: "iana",
      compressible: true
    },
    "application/mrb-publish+xml": {
      source: "iana",
      compressible: true
    },
    "application/msc-ivr+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/msc-mixer+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/msword": {
      source: "iana",
      compressible: false,
      extensions: ["doc", "dot"]
    },
    "application/mud+json": {
      source: "iana",
      compressible: true
    },
    "application/multipart-core": {
      source: "iana"
    },
    "application/mxf": {
      source: "iana",
      extensions: ["mxf"]
    },
    "application/n-quads": {
      source: "iana",
      extensions: ["nq"]
    },
    "application/n-triples": {
      source: "iana",
      extensions: ["nt"]
    },
    "application/nasdata": {
      source: "iana"
    },
    "application/news-checkgroups": {
      source: "iana",
      charset: "US-ASCII"
    },
    "application/news-groupinfo": {
      source: "iana",
      charset: "US-ASCII"
    },
    "application/news-transmission": {
      source: "iana"
    },
    "application/nlsml+xml": {
      source: "iana",
      compressible: true
    },
    "application/node": {
      source: "iana",
      extensions: ["cjs"]
    },
    "application/nss": {
      source: "iana"
    },
    "application/oauth-authz-req+jwt": {
      source: "iana"
    },
    "application/oblivious-dns-message": {
      source: "iana"
    },
    "application/ocsp-request": {
      source: "iana"
    },
    "application/ocsp-response": {
      source: "iana"
    },
    "application/octet-stream": {
      source: "iana",
      compressible: false,
      extensions: ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "exe", "dll", "deb", "dmg", "iso", "img", "msi", "msp", "msm", "buffer"]
    },
    "application/oda": {
      source: "iana",
      extensions: ["oda"]
    },
    "application/odm+xml": {
      source: "iana",
      compressible: true
    },
    "application/odx": {
      source: "iana"
    },
    "application/oebps-package+xml": {
      source: "iana",
      compressible: true,
      extensions: ["opf"]
    },
    "application/ogg": {
      source: "iana",
      compressible: false,
      extensions: ["ogx"]
    },
    "application/omdoc+xml": {
      source: "apache",
      compressible: true,
      extensions: ["omdoc"]
    },
    "application/onenote": {
      source: "apache",
      extensions: ["onetoc", "onetoc2", "onetmp", "onepkg"]
    },
    "application/opc-nodeset+xml": {
      source: "iana",
      compressible: true
    },
    "application/oscore": {
      source: "iana"
    },
    "application/oxps": {
      source: "iana",
      extensions: ["oxps"]
    },
    "application/p21": {
      source: "iana"
    },
    "application/p21+zip": {
      source: "iana",
      compressible: false
    },
    "application/p2p-overlay+xml": {
      source: "iana",
      compressible: true,
      extensions: ["relo"]
    },
    "application/parityfec": {
      source: "iana"
    },
    "application/passport": {
      source: "iana"
    },
    "application/patch-ops-error+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xer"]
    },
    "application/pdf": {
      source: "iana",
      compressible: false,
      extensions: ["pdf"]
    },
    "application/pdx": {
      source: "iana"
    },
    "application/pem-certificate-chain": {
      source: "iana"
    },
    "application/pgp-encrypted": {
      source: "iana",
      compressible: false,
      extensions: ["pgp"]
    },
    "application/pgp-keys": {
      source: "iana",
      extensions: ["asc"]
    },
    "application/pgp-signature": {
      source: "iana",
      extensions: ["asc", "sig"]
    },
    "application/pics-rules": {
      source: "apache",
      extensions: ["prf"]
    },
    "application/pidf+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/pidf-diff+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/pkcs10": {
      source: "iana",
      extensions: ["p10"]
    },
    "application/pkcs12": {
      source: "iana"
    },
    "application/pkcs7-mime": {
      source: "iana",
      extensions: ["p7m", "p7c"]
    },
    "application/pkcs7-signature": {
      source: "iana",
      extensions: ["p7s"]
    },
    "application/pkcs8": {
      source: "iana",
      extensions: ["p8"]
    },
    "application/pkcs8-encrypted": {
      source: "iana"
    },
    "application/pkix-attr-cert": {
      source: "iana",
      extensions: ["ac"]
    },
    "application/pkix-cert": {
      source: "iana",
      extensions: ["cer"]
    },
    "application/pkix-crl": {
      source: "iana",
      extensions: ["crl"]
    },
    "application/pkix-pkipath": {
      source: "iana",
      extensions: ["pkipath"]
    },
    "application/pkixcmp": {
      source: "iana",
      extensions: ["pki"]
    },
    "application/pls+xml": {
      source: "iana",
      compressible: true,
      extensions: ["pls"]
    },
    "application/poc-settings+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/postscript": {
      source: "iana",
      compressible: true,
      extensions: ["ai", "eps", "ps"]
    },
    "application/ppsp-tracker+json": {
      source: "iana",
      compressible: true
    },
    "application/problem+json": {
      source: "iana",
      compressible: true
    },
    "application/problem+xml": {
      source: "iana",
      compressible: true
    },
    "application/provenance+xml": {
      source: "iana",
      compressible: true,
      extensions: ["provx"]
    },
    "application/prs.alvestrand.titrax-sheet": {
      source: "iana"
    },
    "application/prs.cww": {
      source: "iana",
      extensions: ["cww"]
    },
    "application/prs.cyn": {
      source: "iana",
      charset: "7-BIT"
    },
    "application/prs.hpub+zip": {
      source: "iana",
      compressible: false
    },
    "application/prs.nprend": {
      source: "iana"
    },
    "application/prs.plucker": {
      source: "iana"
    },
    "application/prs.rdf-xml-crypt": {
      source: "iana"
    },
    "application/prs.xsf+xml": {
      source: "iana",
      compressible: true
    },
    "application/pskc+xml": {
      source: "iana",
      compressible: true,
      extensions: ["pskcxml"]
    },
    "application/pvd+json": {
      source: "iana",
      compressible: true
    },
    "application/qsig": {
      source: "iana"
    },
    "application/raml+yaml": {
      compressible: true,
      extensions: ["raml"]
    },
    "application/raptorfec": {
      source: "iana"
    },
    "application/rdap+json": {
      source: "iana",
      compressible: true
    },
    "application/rdf+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rdf", "owl"]
    },
    "application/reginfo+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rif"]
    },
    "application/relax-ng-compact-syntax": {
      source: "iana",
      extensions: ["rnc"]
    },
    "application/remote-printing": {
      source: "iana"
    },
    "application/reputon+json": {
      source: "iana",
      compressible: true
    },
    "application/resource-lists+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rl"]
    },
    "application/resource-lists-diff+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rld"]
    },
    "application/rfc+xml": {
      source: "iana",
      compressible: true
    },
    "application/riscos": {
      source: "iana"
    },
    "application/rlmi+xml": {
      source: "iana",
      compressible: true
    },
    "application/rls-services+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rs"]
    },
    "application/route-apd+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rapd"]
    },
    "application/route-s-tsid+xml": {
      source: "iana",
      compressible: true,
      extensions: ["sls"]
    },
    "application/route-usd+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rusd"]
    },
    "application/rpki-ghostbusters": {
      source: "iana",
      extensions: ["gbr"]
    },
    "application/rpki-manifest": {
      source: "iana",
      extensions: ["mft"]
    },
    "application/rpki-publication": {
      source: "iana"
    },
    "application/rpki-roa": {
      source: "iana",
      extensions: ["roa"]
    },
    "application/rpki-updown": {
      source: "iana"
    },
    "application/rsd+xml": {
      source: "apache",
      compressible: true,
      extensions: ["rsd"]
    },
    "application/rss+xml": {
      source: "apache",
      compressible: true,
      extensions: ["rss"]
    },
    "application/rtf": {
      source: "iana",
      compressible: true,
      extensions: ["rtf"]
    },
    "application/rtploopback": {
      source: "iana"
    },
    "application/rtx": {
      source: "iana"
    },
    "application/samlassertion+xml": {
      source: "iana",
      compressible: true
    },
    "application/samlmetadata+xml": {
      source: "iana",
      compressible: true
    },
    "application/sarif+json": {
      source: "iana",
      compressible: true
    },
    "application/sarif-external-properties+json": {
      source: "iana",
      compressible: true
    },
    "application/sbe": {
      source: "iana"
    },
    "application/sbml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["sbml"]
    },
    "application/scaip+xml": {
      source: "iana",
      compressible: true
    },
    "application/scim+json": {
      source: "iana",
      compressible: true
    },
    "application/scvp-cv-request": {
      source: "iana",
      extensions: ["scq"]
    },
    "application/scvp-cv-response": {
      source: "iana",
      extensions: ["scs"]
    },
    "application/scvp-vp-request": {
      source: "iana",
      extensions: ["spq"]
    },
    "application/scvp-vp-response": {
      source: "iana",
      extensions: ["spp"]
    },
    "application/sdp": {
      source: "iana",
      extensions: ["sdp"]
    },
    "application/secevent+jwt": {
      source: "iana"
    },
    "application/senml+cbor": {
      source: "iana"
    },
    "application/senml+json": {
      source: "iana",
      compressible: true
    },
    "application/senml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["senmlx"]
    },
    "application/senml-etch+cbor": {
      source: "iana"
    },
    "application/senml-etch+json": {
      source: "iana",
      compressible: true
    },
    "application/senml-exi": {
      source: "iana"
    },
    "application/sensml+cbor": {
      source: "iana"
    },
    "application/sensml+json": {
      source: "iana",
      compressible: true
    },
    "application/sensml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["sensmlx"]
    },
    "application/sensml-exi": {
      source: "iana"
    },
    "application/sep+xml": {
      source: "iana",
      compressible: true
    },
    "application/sep-exi": {
      source: "iana"
    },
    "application/session-info": {
      source: "iana"
    },
    "application/set-payment": {
      source: "iana"
    },
    "application/set-payment-initiation": {
      source: "iana",
      extensions: ["setpay"]
    },
    "application/set-registration": {
      source: "iana"
    },
    "application/set-registration-initiation": {
      source: "iana",
      extensions: ["setreg"]
    },
    "application/sgml": {
      source: "iana"
    },
    "application/sgml-open-catalog": {
      source: "iana"
    },
    "application/shf+xml": {
      source: "iana",
      compressible: true,
      extensions: ["shf"]
    },
    "application/sieve": {
      source: "iana",
      extensions: ["siv", "sieve"]
    },
    "application/simple-filter+xml": {
      source: "iana",
      compressible: true
    },
    "application/simple-message-summary": {
      source: "iana"
    },
    "application/simplesymbolcontainer": {
      source: "iana"
    },
    "application/sipc": {
      source: "iana"
    },
    "application/slate": {
      source: "iana"
    },
    "application/smil": {
      source: "iana"
    },
    "application/smil+xml": {
      source: "iana",
      compressible: true,
      extensions: ["smi", "smil"]
    },
    "application/smpte336m": {
      source: "iana"
    },
    "application/soap+fastinfoset": {
      source: "iana"
    },
    "application/soap+xml": {
      source: "iana",
      compressible: true
    },
    "application/sparql-query": {
      source: "iana",
      extensions: ["rq"]
    },
    "application/sparql-results+xml": {
      source: "iana",
      compressible: true,
      extensions: ["srx"]
    },
    "application/spdx+json": {
      source: "iana",
      compressible: true
    },
    "application/spirits-event+xml": {
      source: "iana",
      compressible: true
    },
    "application/sql": {
      source: "iana"
    },
    "application/srgs": {
      source: "iana",
      extensions: ["gram"]
    },
    "application/srgs+xml": {
      source: "iana",
      compressible: true,
      extensions: ["grxml"]
    },
    "application/sru+xml": {
      source: "iana",
      compressible: true,
      extensions: ["sru"]
    },
    "application/ssdl+xml": {
      source: "apache",
      compressible: true,
      extensions: ["ssdl"]
    },
    "application/ssml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["ssml"]
    },
    "application/stix+json": {
      source: "iana",
      compressible: true
    },
    "application/swid+xml": {
      source: "iana",
      compressible: true,
      extensions: ["swidtag"]
    },
    "application/tamp-apex-update": {
      source: "iana"
    },
    "application/tamp-apex-update-confirm": {
      source: "iana"
    },
    "application/tamp-community-update": {
      source: "iana"
    },
    "application/tamp-community-update-confirm": {
      source: "iana"
    },
    "application/tamp-error": {
      source: "iana"
    },
    "application/tamp-sequence-adjust": {
      source: "iana"
    },
    "application/tamp-sequence-adjust-confirm": {
      source: "iana"
    },
    "application/tamp-status-query": {
      source: "iana"
    },
    "application/tamp-status-response": {
      source: "iana"
    },
    "application/tamp-update": {
      source: "iana"
    },
    "application/tamp-update-confirm": {
      source: "iana"
    },
    "application/tar": {
      compressible: true
    },
    "application/taxii+json": {
      source: "iana",
      compressible: true
    },
    "application/td+json": {
      source: "iana",
      compressible: true
    },
    "application/tei+xml": {
      source: "iana",
      compressible: true,
      extensions: ["tei", "teicorpus"]
    },
    "application/tetra_isi": {
      source: "iana"
    },
    "application/thraud+xml": {
      source: "iana",
      compressible: true,
      extensions: ["tfi"]
    },
    "application/timestamp-query": {
      source: "iana"
    },
    "application/timestamp-reply": {
      source: "iana"
    },
    "application/timestamped-data": {
      source: "iana",
      extensions: ["tsd"]
    },
    "application/tlsrpt+gzip": {
      source: "iana"
    },
    "application/tlsrpt+json": {
      source: "iana",
      compressible: true
    },
    "application/tnauthlist": {
      source: "iana"
    },
    "application/token-introspection+jwt": {
      source: "iana"
    },
    "application/toml": {
      compressible: true,
      extensions: ["toml"]
    },
    "application/trickle-ice-sdpfrag": {
      source: "iana"
    },
    "application/trig": {
      source: "iana",
      extensions: ["trig"]
    },
    "application/ttml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["ttml"]
    },
    "application/tve-trigger": {
      source: "iana"
    },
    "application/tzif": {
      source: "iana"
    },
    "application/tzif-leap": {
      source: "iana"
    },
    "application/ubjson": {
      compressible: false,
      extensions: ["ubj"]
    },
    "application/ulpfec": {
      source: "iana"
    },
    "application/urc-grpsheet+xml": {
      source: "iana",
      compressible: true
    },
    "application/urc-ressheet+xml": {
      source: "iana",
      compressible: true,
      extensions: ["rsheet"]
    },
    "application/urc-targetdesc+xml": {
      source: "iana",
      compressible: true,
      extensions: ["td"]
    },
    "application/urc-uisocketdesc+xml": {
      source: "iana",
      compressible: true
    },
    "application/vcard+json": {
      source: "iana",
      compressible: true
    },
    "application/vcard+xml": {
      source: "iana",
      compressible: true
    },
    "application/vemmi": {
      source: "iana"
    },
    "application/vividence.scriptfile": {
      source: "apache"
    },
    "application/vnd.1000minds.decision-model+xml": {
      source: "iana",
      compressible: true,
      extensions: ["1km"]
    },
    "application/vnd.3gpp-prose+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp-prose-pc3ch+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp-v2x-local-service-information": {
      source: "iana"
    },
    "application/vnd.3gpp.5gnas": {
      source: "iana"
    },
    "application/vnd.3gpp.access-transfer-events+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.bsf+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.gmop+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.gtpc": {
      source: "iana"
    },
    "application/vnd.3gpp.interworking-data": {
      source: "iana"
    },
    "application/vnd.3gpp.lpp": {
      source: "iana"
    },
    "application/vnd.3gpp.mc-signalling-ear": {
      source: "iana"
    },
    "application/vnd.3gpp.mcdata-affiliation-command+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcdata-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcdata-payload": {
      source: "iana"
    },
    "application/vnd.3gpp.mcdata-service-config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcdata-signalling": {
      source: "iana"
    },
    "application/vnd.3gpp.mcdata-ue-config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcdata-user-profile+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-affiliation-command+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-floor-request+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-location-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-mbms-usage-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-service-config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-signed+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-ue-config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-ue-init-config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcptt-user-profile+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-affiliation-command+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-affiliation-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-location-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-mbms-usage-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-service-config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-transmission-request+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-ue-config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mcvideo-user-profile+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.mid-call+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.ngap": {
      source: "iana"
    },
    "application/vnd.3gpp.pfcp": {
      source: "iana"
    },
    "application/vnd.3gpp.pic-bw-large": {
      source: "iana",
      extensions: ["plb"]
    },
    "application/vnd.3gpp.pic-bw-small": {
      source: "iana",
      extensions: ["psb"]
    },
    "application/vnd.3gpp.pic-bw-var": {
      source: "iana",
      extensions: ["pvb"]
    },
    "application/vnd.3gpp.s1ap": {
      source: "iana"
    },
    "application/vnd.3gpp.sms": {
      source: "iana"
    },
    "application/vnd.3gpp.sms+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.srvcc-ext+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.srvcc-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.state-and-event-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp.ussd+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp2.bcmcsinfo+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.3gpp2.sms": {
      source: "iana"
    },
    "application/vnd.3gpp2.tcap": {
      source: "iana",
      extensions: ["tcap"]
    },
    "application/vnd.3lightssoftware.imagescal": {
      source: "iana"
    },
    "application/vnd.3m.post-it-notes": {
      source: "iana",
      extensions: ["pwn"]
    },
    "application/vnd.accpac.simply.aso": {
      source: "iana",
      extensions: ["aso"]
    },
    "application/vnd.accpac.simply.imp": {
      source: "iana",
      extensions: ["imp"]
    },
    "application/vnd.acucobol": {
      source: "iana",
      extensions: ["acu"]
    },
    "application/vnd.acucorp": {
      source: "iana",
      extensions: ["atc", "acutc"]
    },
    "application/vnd.adobe.air-application-installer-package+zip": {
      source: "apache",
      compressible: false,
      extensions: ["air"]
    },
    "application/vnd.adobe.flash.movie": {
      source: "iana"
    },
    "application/vnd.adobe.formscentral.fcdt": {
      source: "iana",
      extensions: ["fcdt"]
    },
    "application/vnd.adobe.fxp": {
      source: "iana",
      extensions: ["fxp", "fxpl"]
    },
    "application/vnd.adobe.partial-upload": {
      source: "iana"
    },
    "application/vnd.adobe.xdp+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xdp"]
    },
    "application/vnd.adobe.xfdf": {
      source: "iana",
      extensions: ["xfdf"]
    },
    "application/vnd.aether.imp": {
      source: "iana"
    },
    "application/vnd.afpc.afplinedata": {
      source: "iana"
    },
    "application/vnd.afpc.afplinedata-pagedef": {
      source: "iana"
    },
    "application/vnd.afpc.cmoca-cmresource": {
      source: "iana"
    },
    "application/vnd.afpc.foca-charset": {
      source: "iana"
    },
    "application/vnd.afpc.foca-codedfont": {
      source: "iana"
    },
    "application/vnd.afpc.foca-codepage": {
      source: "iana"
    },
    "application/vnd.afpc.modca": {
      source: "iana"
    },
    "application/vnd.afpc.modca-cmtable": {
      source: "iana"
    },
    "application/vnd.afpc.modca-formdef": {
      source: "iana"
    },
    "application/vnd.afpc.modca-mediummap": {
      source: "iana"
    },
    "application/vnd.afpc.modca-objectcontainer": {
      source: "iana"
    },
    "application/vnd.afpc.modca-overlay": {
      source: "iana"
    },
    "application/vnd.afpc.modca-pagesegment": {
      source: "iana"
    },
    "application/vnd.age": {
      source: "iana",
      extensions: ["age"]
    },
    "application/vnd.ah-barcode": {
      source: "iana"
    },
    "application/vnd.ahead.space": {
      source: "iana",
      extensions: ["ahead"]
    },
    "application/vnd.airzip.filesecure.azf": {
      source: "iana",
      extensions: ["azf"]
    },
    "application/vnd.airzip.filesecure.azs": {
      source: "iana",
      extensions: ["azs"]
    },
    "application/vnd.amadeus+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.amazon.ebook": {
      source: "apache",
      extensions: ["azw"]
    },
    "application/vnd.amazon.mobi8-ebook": {
      source: "iana"
    },
    "application/vnd.americandynamics.acc": {
      source: "iana",
      extensions: ["acc"]
    },
    "application/vnd.amiga.ami": {
      source: "iana",
      extensions: ["ami"]
    },
    "application/vnd.amundsen.maze+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.android.ota": {
      source: "iana"
    },
    "application/vnd.android.package-archive": {
      source: "apache",
      compressible: false,
      extensions: ["apk"]
    },
    "application/vnd.anki": {
      source: "iana"
    },
    "application/vnd.anser-web-certificate-issue-initiation": {
      source: "iana",
      extensions: ["cii"]
    },
    "application/vnd.anser-web-funds-transfer-initiation": {
      source: "apache",
      extensions: ["fti"]
    },
    "application/vnd.antix.game-component": {
      source: "iana",
      extensions: ["atx"]
    },
    "application/vnd.apache.arrow.file": {
      source: "iana"
    },
    "application/vnd.apache.arrow.stream": {
      source: "iana"
    },
    "application/vnd.apache.thrift.binary": {
      source: "iana"
    },
    "application/vnd.apache.thrift.compact": {
      source: "iana"
    },
    "application/vnd.apache.thrift.json": {
      source: "iana"
    },
    "application/vnd.api+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.aplextor.warrp+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.apothekende.reservation+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.apple.installer+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mpkg"]
    },
    "application/vnd.apple.keynote": {
      source: "iana",
      extensions: ["key"]
    },
    "application/vnd.apple.mpegurl": {
      source: "iana",
      extensions: ["m3u8"]
    },
    "application/vnd.apple.numbers": {
      source: "iana",
      extensions: ["numbers"]
    },
    "application/vnd.apple.pages": {
      source: "iana",
      extensions: ["pages"]
    },
    "application/vnd.apple.pkpass": {
      compressible: false,
      extensions: ["pkpass"]
    },
    "application/vnd.arastra.swi": {
      source: "iana"
    },
    "application/vnd.aristanetworks.swi": {
      source: "iana",
      extensions: ["swi"]
    },
    "application/vnd.artisan+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.artsquare": {
      source: "iana"
    },
    "application/vnd.astraea-software.iota": {
      source: "iana",
      extensions: ["iota"]
    },
    "application/vnd.audiograph": {
      source: "iana",
      extensions: ["aep"]
    },
    "application/vnd.autopackage": {
      source: "iana"
    },
    "application/vnd.avalon+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.avistar+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.balsamiq.bmml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["bmml"]
    },
    "application/vnd.balsamiq.bmpr": {
      source: "iana"
    },
    "application/vnd.banana-accounting": {
      source: "iana"
    },
    "application/vnd.bbf.usp.error": {
      source: "iana"
    },
    "application/vnd.bbf.usp.msg": {
      source: "iana"
    },
    "application/vnd.bbf.usp.msg+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.bekitzur-stech+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.bint.med-content": {
      source: "iana"
    },
    "application/vnd.biopax.rdf+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.blink-idb-value-wrapper": {
      source: "iana"
    },
    "application/vnd.blueice.multipass": {
      source: "iana",
      extensions: ["mpm"]
    },
    "application/vnd.bluetooth.ep.oob": {
      source: "iana"
    },
    "application/vnd.bluetooth.le.oob": {
      source: "iana"
    },
    "application/vnd.bmi": {
      source: "iana",
      extensions: ["bmi"]
    },
    "application/vnd.bpf": {
      source: "iana"
    },
    "application/vnd.bpf3": {
      source: "iana"
    },
    "application/vnd.businessobjects": {
      source: "iana",
      extensions: ["rep"]
    },
    "application/vnd.byu.uapi+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.cab-jscript": {
      source: "iana"
    },
    "application/vnd.canon-cpdl": {
      source: "iana"
    },
    "application/vnd.canon-lips": {
      source: "iana"
    },
    "application/vnd.capasystems-pg+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.cendio.thinlinc.clientconf": {
      source: "iana"
    },
    "application/vnd.century-systems.tcp_stream": {
      source: "iana"
    },
    "application/vnd.chemdraw+xml": {
      source: "iana",
      compressible: true,
      extensions: ["cdxml"]
    },
    "application/vnd.chess-pgn": {
      source: "iana"
    },
    "application/vnd.chipnuts.karaoke-mmd": {
      source: "iana",
      extensions: ["mmd"]
    },
    "application/vnd.ciedi": {
      source: "iana"
    },
    "application/vnd.cinderella": {
      source: "iana",
      extensions: ["cdy"]
    },
    "application/vnd.cirpack.isdn-ext": {
      source: "iana"
    },
    "application/vnd.citationstyles.style+xml": {
      source: "iana",
      compressible: true,
      extensions: ["csl"]
    },
    "application/vnd.claymore": {
      source: "iana",
      extensions: ["cla"]
    },
    "application/vnd.cloanto.rp9": {
      source: "iana",
      extensions: ["rp9"]
    },
    "application/vnd.clonk.c4group": {
      source: "iana",
      extensions: ["c4g", "c4d", "c4f", "c4p", "c4u"]
    },
    "application/vnd.cluetrust.cartomobile-config": {
      source: "iana",
      extensions: ["c11amc"]
    },
    "application/vnd.cluetrust.cartomobile-config-pkg": {
      source: "iana",
      extensions: ["c11amz"]
    },
    "application/vnd.coffeescript": {
      source: "iana"
    },
    "application/vnd.collabio.xodocuments.document": {
      source: "iana"
    },
    "application/vnd.collabio.xodocuments.document-template": {
      source: "iana"
    },
    "application/vnd.collabio.xodocuments.presentation": {
      source: "iana"
    },
    "application/vnd.collabio.xodocuments.presentation-template": {
      source: "iana"
    },
    "application/vnd.collabio.xodocuments.spreadsheet": {
      source: "iana"
    },
    "application/vnd.collabio.xodocuments.spreadsheet-template": {
      source: "iana"
    },
    "application/vnd.collection+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.collection.doc+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.collection.next+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.comicbook+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.comicbook-rar": {
      source: "iana"
    },
    "application/vnd.commerce-battelle": {
      source: "iana"
    },
    "application/vnd.commonspace": {
      source: "iana",
      extensions: ["csp"]
    },
    "application/vnd.contact.cmsg": {
      source: "iana",
      extensions: ["cdbcmsg"]
    },
    "application/vnd.coreos.ignition+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.cosmocaller": {
      source: "iana",
      extensions: ["cmc"]
    },
    "application/vnd.crick.clicker": {
      source: "iana",
      extensions: ["clkx"]
    },
    "application/vnd.crick.clicker.keyboard": {
      source: "iana",
      extensions: ["clkk"]
    },
    "application/vnd.crick.clicker.palette": {
      source: "iana",
      extensions: ["clkp"]
    },
    "application/vnd.crick.clicker.template": {
      source: "iana",
      extensions: ["clkt"]
    },
    "application/vnd.crick.clicker.wordbank": {
      source: "iana",
      extensions: ["clkw"]
    },
    "application/vnd.criticaltools.wbs+xml": {
      source: "iana",
      compressible: true,
      extensions: ["wbs"]
    },
    "application/vnd.cryptii.pipe+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.crypto-shade-file": {
      source: "iana"
    },
    "application/vnd.cryptomator.encrypted": {
      source: "iana"
    },
    "application/vnd.cryptomator.vault": {
      source: "iana"
    },
    "application/vnd.ctc-posml": {
      source: "iana",
      extensions: ["pml"]
    },
    "application/vnd.ctct.ws+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.cups-pdf": {
      source: "iana"
    },
    "application/vnd.cups-postscript": {
      source: "iana"
    },
    "application/vnd.cups-ppd": {
      source: "iana",
      extensions: ["ppd"]
    },
    "application/vnd.cups-raster": {
      source: "iana"
    },
    "application/vnd.cups-raw": {
      source: "iana"
    },
    "application/vnd.curl": {
      source: "iana"
    },
    "application/vnd.curl.car": {
      source: "apache",
      extensions: ["car"]
    },
    "application/vnd.curl.pcurl": {
      source: "apache",
      extensions: ["pcurl"]
    },
    "application/vnd.cyan.dean.root+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.cybank": {
      source: "iana"
    },
    "application/vnd.cyclonedx+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.cyclonedx+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.d2l.coursepackage1p0+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.d3m-dataset": {
      source: "iana"
    },
    "application/vnd.d3m-problem": {
      source: "iana"
    },
    "application/vnd.dart": {
      source: "iana",
      compressible: true,
      extensions: ["dart"]
    },
    "application/vnd.data-vision.rdz": {
      source: "iana",
      extensions: ["rdz"]
    },
    "application/vnd.datapackage+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dataresource+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dbf": {
      source: "iana",
      extensions: ["dbf"]
    },
    "application/vnd.debian.binary-package": {
      source: "iana"
    },
    "application/vnd.dece.data": {
      source: "iana",
      extensions: ["uvf", "uvvf", "uvd", "uvvd"]
    },
    "application/vnd.dece.ttml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["uvt", "uvvt"]
    },
    "application/vnd.dece.unspecified": {
      source: "iana",
      extensions: ["uvx", "uvvx"]
    },
    "application/vnd.dece.zip": {
      source: "iana",
      extensions: ["uvz", "uvvz"]
    },
    "application/vnd.denovo.fcselayout-link": {
      source: "iana",
      extensions: ["fe_launch"]
    },
    "application/vnd.desmume.movie": {
      source: "iana"
    },
    "application/vnd.dir-bi.plate-dl-nosuffix": {
      source: "iana"
    },
    "application/vnd.dm.delegation+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dna": {
      source: "iana",
      extensions: ["dna"]
    },
    "application/vnd.document+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dolby.mlp": {
      source: "apache",
      extensions: ["mlp"]
    },
    "application/vnd.dolby.mobile.1": {
      source: "iana"
    },
    "application/vnd.dolby.mobile.2": {
      source: "iana"
    },
    "application/vnd.doremir.scorecloud-binary-document": {
      source: "iana"
    },
    "application/vnd.dpgraph": {
      source: "iana",
      extensions: ["dpg"]
    },
    "application/vnd.dreamfactory": {
      source: "iana",
      extensions: ["dfac"]
    },
    "application/vnd.drive+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ds-keypoint": {
      source: "apache",
      extensions: ["kpxx"]
    },
    "application/vnd.dtg.local": {
      source: "iana"
    },
    "application/vnd.dtg.local.flash": {
      source: "iana"
    },
    "application/vnd.dtg.local.html": {
      source: "iana"
    },
    "application/vnd.dvb.ait": {
      source: "iana",
      extensions: ["ait"]
    },
    "application/vnd.dvb.dvbisl+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.dvbj": {
      source: "iana"
    },
    "application/vnd.dvb.esgcontainer": {
      source: "iana"
    },
    "application/vnd.dvb.ipdcdftnotifaccess": {
      source: "iana"
    },
    "application/vnd.dvb.ipdcesgaccess": {
      source: "iana"
    },
    "application/vnd.dvb.ipdcesgaccess2": {
      source: "iana"
    },
    "application/vnd.dvb.ipdcesgpdd": {
      source: "iana"
    },
    "application/vnd.dvb.ipdcroaming": {
      source: "iana"
    },
    "application/vnd.dvb.iptv.alfec-base": {
      source: "iana"
    },
    "application/vnd.dvb.iptv.alfec-enhancement": {
      source: "iana"
    },
    "application/vnd.dvb.notif-aggregate-root+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.notif-container+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.notif-generic+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.notif-ia-msglist+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.notif-ia-registration-request+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.notif-ia-registration-response+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.notif-init+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.dvb.pfr": {
      source: "iana"
    },
    "application/vnd.dvb.service": {
      source: "iana",
      extensions: ["svc"]
    },
    "application/vnd.dxr": {
      source: "iana"
    },
    "application/vnd.dynageo": {
      source: "iana",
      extensions: ["geo"]
    },
    "application/vnd.dzr": {
      source: "iana"
    },
    "application/vnd.easykaraoke.cdgdownload": {
      source: "iana"
    },
    "application/vnd.ecdis-update": {
      source: "iana"
    },
    "application/vnd.ecip.rlp": {
      source: "iana"
    },
    "application/vnd.eclipse.ditto+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ecowin.chart": {
      source: "iana",
      extensions: ["mag"]
    },
    "application/vnd.ecowin.filerequest": {
      source: "iana"
    },
    "application/vnd.ecowin.fileupdate": {
      source: "iana"
    },
    "application/vnd.ecowin.series": {
      source: "iana"
    },
    "application/vnd.ecowin.seriesrequest": {
      source: "iana"
    },
    "application/vnd.ecowin.seriesupdate": {
      source: "iana"
    },
    "application/vnd.efi.img": {
      source: "iana"
    },
    "application/vnd.efi.iso": {
      source: "iana"
    },
    "application/vnd.emclient.accessrequest+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.enliven": {
      source: "iana",
      extensions: ["nml"]
    },
    "application/vnd.enphase.envoy": {
      source: "iana"
    },
    "application/vnd.eprints.data+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.epson.esf": {
      source: "iana",
      extensions: ["esf"]
    },
    "application/vnd.epson.msf": {
      source: "iana",
      extensions: ["msf"]
    },
    "application/vnd.epson.quickanime": {
      source: "iana",
      extensions: ["qam"]
    },
    "application/vnd.epson.salt": {
      source: "iana",
      extensions: ["slt"]
    },
    "application/vnd.epson.ssf": {
      source: "iana",
      extensions: ["ssf"]
    },
    "application/vnd.ericsson.quickcall": {
      source: "iana"
    },
    "application/vnd.espass-espass+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.eszigno3+xml": {
      source: "iana",
      compressible: true,
      extensions: ["es3", "et3"]
    },
    "application/vnd.etsi.aoc+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.asic-e+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.etsi.asic-s+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.etsi.cug+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvcommand+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvdiscovery+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvprofile+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvsad-bc+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvsad-cod+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvsad-npvr+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvservice+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvsync+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.iptvueprofile+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.mcid+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.mheg5": {
      source: "iana"
    },
    "application/vnd.etsi.overload-control-policy-dataset+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.pstn+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.sci+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.simservs+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.timestamp-token": {
      source: "iana"
    },
    "application/vnd.etsi.tsl+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.etsi.tsl.der": {
      source: "iana"
    },
    "application/vnd.eu.kasparian.car+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.eudora.data": {
      source: "iana"
    },
    "application/vnd.evolv.ecig.profile": {
      source: "iana"
    },
    "application/vnd.evolv.ecig.settings": {
      source: "iana"
    },
    "application/vnd.evolv.ecig.theme": {
      source: "iana"
    },
    "application/vnd.exstream-empower+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.exstream-package": {
      source: "iana"
    },
    "application/vnd.ezpix-album": {
      source: "iana",
      extensions: ["ez2"]
    },
    "application/vnd.ezpix-package": {
      source: "iana",
      extensions: ["ez3"]
    },
    "application/vnd.f-secure.mobile": {
      source: "iana"
    },
    "application/vnd.familysearch.gedcom+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.fastcopy-disk-image": {
      source: "iana"
    },
    "application/vnd.fdf": {
      source: "iana",
      extensions: ["fdf"]
    },
    "application/vnd.fdsn.mseed": {
      source: "iana",
      extensions: ["mseed"]
    },
    "application/vnd.fdsn.seed": {
      source: "iana",
      extensions: ["seed", "dataless"]
    },
    "application/vnd.ffsns": {
      source: "iana"
    },
    "application/vnd.ficlab.flb+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.filmit.zfc": {
      source: "iana"
    },
    "application/vnd.fints": {
      source: "iana"
    },
    "application/vnd.firemonkeys.cloudcell": {
      source: "iana"
    },
    "application/vnd.flographit": {
      source: "iana",
      extensions: ["gph"]
    },
    "application/vnd.fluxtime.clip": {
      source: "iana",
      extensions: ["ftc"]
    },
    "application/vnd.font-fontforge-sfd": {
      source: "iana"
    },
    "application/vnd.framemaker": {
      source: "iana",
      extensions: ["fm", "frame", "maker", "book"]
    },
    "application/vnd.frogans.fnc": {
      source: "iana",
      extensions: ["fnc"]
    },
    "application/vnd.frogans.ltf": {
      source: "iana",
      extensions: ["ltf"]
    },
    "application/vnd.fsc.weblaunch": {
      source: "iana",
      extensions: ["fsc"]
    },
    "application/vnd.fujifilm.fb.docuworks": {
      source: "iana"
    },
    "application/vnd.fujifilm.fb.docuworks.binder": {
      source: "iana"
    },
    "application/vnd.fujifilm.fb.docuworks.container": {
      source: "iana"
    },
    "application/vnd.fujifilm.fb.jfi+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.fujitsu.oasys": {
      source: "iana",
      extensions: ["oas"]
    },
    "application/vnd.fujitsu.oasys2": {
      source: "iana",
      extensions: ["oa2"]
    },
    "application/vnd.fujitsu.oasys3": {
      source: "iana",
      extensions: ["oa3"]
    },
    "application/vnd.fujitsu.oasysgp": {
      source: "iana",
      extensions: ["fg5"]
    },
    "application/vnd.fujitsu.oasysprs": {
      source: "iana",
      extensions: ["bh2"]
    },
    "application/vnd.fujixerox.art-ex": {
      source: "iana"
    },
    "application/vnd.fujixerox.art4": {
      source: "iana"
    },
    "application/vnd.fujixerox.ddd": {
      source: "iana",
      extensions: ["ddd"]
    },
    "application/vnd.fujixerox.docuworks": {
      source: "iana",
      extensions: ["xdw"]
    },
    "application/vnd.fujixerox.docuworks.binder": {
      source: "iana",
      extensions: ["xbd"]
    },
    "application/vnd.fujixerox.docuworks.container": {
      source: "iana"
    },
    "application/vnd.fujixerox.hbpl": {
      source: "iana"
    },
    "application/vnd.fut-misnet": {
      source: "iana"
    },
    "application/vnd.futoin+cbor": {
      source: "iana"
    },
    "application/vnd.futoin+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.fuzzysheet": {
      source: "iana",
      extensions: ["fzs"]
    },
    "application/vnd.genomatix.tuxedo": {
      source: "iana",
      extensions: ["txd"]
    },
    "application/vnd.gentics.grd+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.geo+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.geocube+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.geogebra.file": {
      source: "iana",
      extensions: ["ggb"]
    },
    "application/vnd.geogebra.slides": {
      source: "iana"
    },
    "application/vnd.geogebra.tool": {
      source: "iana",
      extensions: ["ggt"]
    },
    "application/vnd.geometry-explorer": {
      source: "iana",
      extensions: ["gex", "gre"]
    },
    "application/vnd.geonext": {
      source: "iana",
      extensions: ["gxt"]
    },
    "application/vnd.geoplan": {
      source: "iana",
      extensions: ["g2w"]
    },
    "application/vnd.geospace": {
      source: "iana",
      extensions: ["g3w"]
    },
    "application/vnd.gerber": {
      source: "iana"
    },
    "application/vnd.globalplatform.card-content-mgt": {
      source: "iana"
    },
    "application/vnd.globalplatform.card-content-mgt-response": {
      source: "iana"
    },
    "application/vnd.gmx": {
      source: "iana",
      extensions: ["gmx"]
    },
    "application/vnd.google-apps.document": {
      compressible: false,
      extensions: ["gdoc"]
    },
    "application/vnd.google-apps.presentation": {
      compressible: false,
      extensions: ["gslides"]
    },
    "application/vnd.google-apps.spreadsheet": {
      compressible: false,
      extensions: ["gsheet"]
    },
    "application/vnd.google-earth.kml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["kml"]
    },
    "application/vnd.google-earth.kmz": {
      source: "iana",
      compressible: false,
      extensions: ["kmz"]
    },
    "application/vnd.gov.sk.e-form+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.gov.sk.e-form+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.gov.sk.xmldatacontainer+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.grafeq": {
      source: "iana",
      extensions: ["gqf", "gqs"]
    },
    "application/vnd.gridmp": {
      source: "iana"
    },
    "application/vnd.groove-account": {
      source: "iana",
      extensions: ["gac"]
    },
    "application/vnd.groove-help": {
      source: "iana",
      extensions: ["ghf"]
    },
    "application/vnd.groove-identity-message": {
      source: "iana",
      extensions: ["gim"]
    },
    "application/vnd.groove-injector": {
      source: "iana",
      extensions: ["grv"]
    },
    "application/vnd.groove-tool-message": {
      source: "iana",
      extensions: ["gtm"]
    },
    "application/vnd.groove-tool-template": {
      source: "iana",
      extensions: ["tpl"]
    },
    "application/vnd.groove-vcard": {
      source: "iana",
      extensions: ["vcg"]
    },
    "application/vnd.hal+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.hal+xml": {
      source: "iana",
      compressible: true,
      extensions: ["hal"]
    },
    "application/vnd.handheld-entertainment+xml": {
      source: "iana",
      compressible: true,
      extensions: ["zmm"]
    },
    "application/vnd.hbci": {
      source: "iana",
      extensions: ["hbci"]
    },
    "application/vnd.hc+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.hcl-bireports": {
      source: "iana"
    },
    "application/vnd.hdt": {
      source: "iana"
    },
    "application/vnd.heroku+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.hhe.lesson-player": {
      source: "iana",
      extensions: ["les"]
    },
    "application/vnd.hl7cda+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/vnd.hl7v2+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/vnd.hp-hpgl": {
      source: "iana",
      extensions: ["hpgl"]
    },
    "application/vnd.hp-hpid": {
      source: "iana",
      extensions: ["hpid"]
    },
    "application/vnd.hp-hps": {
      source: "iana",
      extensions: ["hps"]
    },
    "application/vnd.hp-jlyt": {
      source: "iana",
      extensions: ["jlt"]
    },
    "application/vnd.hp-pcl": {
      source: "iana",
      extensions: ["pcl"]
    },
    "application/vnd.hp-pclxl": {
      source: "iana",
      extensions: ["pclxl"]
    },
    "application/vnd.httphone": {
      source: "iana"
    },
    "application/vnd.hydrostatix.sof-data": {
      source: "iana",
      extensions: ["sfd-hdstx"]
    },
    "application/vnd.hyper+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.hyper-item+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.hyperdrive+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.hzn-3d-crossword": {
      source: "iana"
    },
    "application/vnd.ibm.afplinedata": {
      source: "iana"
    },
    "application/vnd.ibm.electronic-media": {
      source: "iana"
    },
    "application/vnd.ibm.minipay": {
      source: "iana",
      extensions: ["mpy"]
    },
    "application/vnd.ibm.modcap": {
      source: "iana",
      extensions: ["afp", "listafp", "list3820"]
    },
    "application/vnd.ibm.rights-management": {
      source: "iana",
      extensions: ["irm"]
    },
    "application/vnd.ibm.secure-container": {
      source: "iana",
      extensions: ["sc"]
    },
    "application/vnd.iccprofile": {
      source: "iana",
      extensions: ["icc", "icm"]
    },
    "application/vnd.ieee.1905": {
      source: "iana"
    },
    "application/vnd.igloader": {
      source: "iana",
      extensions: ["igl"]
    },
    "application/vnd.imagemeter.folder+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.imagemeter.image+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.immervision-ivp": {
      source: "iana",
      extensions: ["ivp"]
    },
    "application/vnd.immervision-ivu": {
      source: "iana",
      extensions: ["ivu"]
    },
    "application/vnd.ims.imsccv1p1": {
      source: "iana"
    },
    "application/vnd.ims.imsccv1p2": {
      source: "iana"
    },
    "application/vnd.ims.imsccv1p3": {
      source: "iana"
    },
    "application/vnd.ims.lis.v2.result+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ims.lti.v2.toolconsumerprofile+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ims.lti.v2.toolproxy+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ims.lti.v2.toolproxy.id+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ims.lti.v2.toolsettings+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ims.lti.v2.toolsettings.simple+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.informedcontrol.rms+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.informix-visionary": {
      source: "iana"
    },
    "application/vnd.infotech.project": {
      source: "iana"
    },
    "application/vnd.infotech.project+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.innopath.wamp.notification": {
      source: "iana"
    },
    "application/vnd.insors.igm": {
      source: "iana",
      extensions: ["igm"]
    },
    "application/vnd.intercon.formnet": {
      source: "iana",
      extensions: ["xpw", "xpx"]
    },
    "application/vnd.intergeo": {
      source: "iana",
      extensions: ["i2g"]
    },
    "application/vnd.intertrust.digibox": {
      source: "iana"
    },
    "application/vnd.intertrust.nncp": {
      source: "iana"
    },
    "application/vnd.intu.qbo": {
      source: "iana",
      extensions: ["qbo"]
    },
    "application/vnd.intu.qfx": {
      source: "iana",
      extensions: ["qfx"]
    },
    "application/vnd.iptc.g2.catalogitem+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.iptc.g2.conceptitem+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.iptc.g2.knowledgeitem+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.iptc.g2.newsitem+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.iptc.g2.newsmessage+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.iptc.g2.packageitem+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.iptc.g2.planningitem+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ipunplugged.rcprofile": {
      source: "iana",
      extensions: ["rcprofile"]
    },
    "application/vnd.irepository.package+xml": {
      source: "iana",
      compressible: true,
      extensions: ["irp"]
    },
    "application/vnd.is-xpr": {
      source: "iana",
      extensions: ["xpr"]
    },
    "application/vnd.isac.fcs": {
      source: "iana",
      extensions: ["fcs"]
    },
    "application/vnd.iso11783-10+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.jam": {
      source: "iana",
      extensions: ["jam"]
    },
    "application/vnd.japannet-directory-service": {
      source: "iana"
    },
    "application/vnd.japannet-jpnstore-wakeup": {
      source: "iana"
    },
    "application/vnd.japannet-payment-wakeup": {
      source: "iana"
    },
    "application/vnd.japannet-registration": {
      source: "iana"
    },
    "application/vnd.japannet-registration-wakeup": {
      source: "iana"
    },
    "application/vnd.japannet-setstore-wakeup": {
      source: "iana"
    },
    "application/vnd.japannet-verification": {
      source: "iana"
    },
    "application/vnd.japannet-verification-wakeup": {
      source: "iana"
    },
    "application/vnd.jcp.javame.midlet-rms": {
      source: "iana",
      extensions: ["rms"]
    },
    "application/vnd.jisp": {
      source: "iana",
      extensions: ["jisp"]
    },
    "application/vnd.joost.joda-archive": {
      source: "iana",
      extensions: ["joda"]
    },
    "application/vnd.jsk.isdn-ngn": {
      source: "iana"
    },
    "application/vnd.kahootz": {
      source: "iana",
      extensions: ["ktz", "ktr"]
    },
    "application/vnd.kde.karbon": {
      source: "iana",
      extensions: ["karbon"]
    },
    "application/vnd.kde.kchart": {
      source: "iana",
      extensions: ["chrt"]
    },
    "application/vnd.kde.kformula": {
      source: "iana",
      extensions: ["kfo"]
    },
    "application/vnd.kde.kivio": {
      source: "iana",
      extensions: ["flw"]
    },
    "application/vnd.kde.kontour": {
      source: "iana",
      extensions: ["kon"]
    },
    "application/vnd.kde.kpresenter": {
      source: "iana",
      extensions: ["kpr", "kpt"]
    },
    "application/vnd.kde.kspread": {
      source: "iana",
      extensions: ["ksp"]
    },
    "application/vnd.kde.kword": {
      source: "iana",
      extensions: ["kwd", "kwt"]
    },
    "application/vnd.kenameaapp": {
      source: "iana",
      extensions: ["htke"]
    },
    "application/vnd.kidspiration": {
      source: "iana",
      extensions: ["kia"]
    },
    "application/vnd.kinar": {
      source: "iana",
      extensions: ["kne", "knp"]
    },
    "application/vnd.koan": {
      source: "iana",
      extensions: ["skp", "skd", "skt", "skm"]
    },
    "application/vnd.kodak-descriptor": {
      source: "iana",
      extensions: ["sse"]
    },
    "application/vnd.las": {
      source: "iana"
    },
    "application/vnd.las.las+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.las.las+xml": {
      source: "iana",
      compressible: true,
      extensions: ["lasxml"]
    },
    "application/vnd.laszip": {
      source: "iana"
    },
    "application/vnd.leap+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.liberty-request+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.llamagraphics.life-balance.desktop": {
      source: "iana",
      extensions: ["lbd"]
    },
    "application/vnd.llamagraphics.life-balance.exchange+xml": {
      source: "iana",
      compressible: true,
      extensions: ["lbe"]
    },
    "application/vnd.logipipe.circuit+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.loom": {
      source: "iana"
    },
    "application/vnd.lotus-1-2-3": {
      source: "iana",
      extensions: ["123"]
    },
    "application/vnd.lotus-approach": {
      source: "iana",
      extensions: ["apr"]
    },
    "application/vnd.lotus-freelance": {
      source: "iana",
      extensions: ["pre"]
    },
    "application/vnd.lotus-notes": {
      source: "iana",
      extensions: ["nsf"]
    },
    "application/vnd.lotus-organizer": {
      source: "iana",
      extensions: ["org"]
    },
    "application/vnd.lotus-screencam": {
      source: "iana",
      extensions: ["scm"]
    },
    "application/vnd.lotus-wordpro": {
      source: "iana",
      extensions: ["lwp"]
    },
    "application/vnd.macports.portpkg": {
      source: "iana",
      extensions: ["portpkg"]
    },
    "application/vnd.mapbox-vector-tile": {
      source: "iana",
      extensions: ["mvt"]
    },
    "application/vnd.marlin.drm.actiontoken+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.marlin.drm.conftoken+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.marlin.drm.license+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.marlin.drm.mdcf": {
      source: "iana"
    },
    "application/vnd.mason+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.maxar.archive.3tz+zip": {
      source: "iana",
      compressible: false
    },
    "application/vnd.maxmind.maxmind-db": {
      source: "iana"
    },
    "application/vnd.mcd": {
      source: "iana",
      extensions: ["mcd"]
    },
    "application/vnd.medcalcdata": {
      source: "iana",
      extensions: ["mc1"]
    },
    "application/vnd.mediastation.cdkey": {
      source: "iana",
      extensions: ["cdkey"]
    },
    "application/vnd.meridian-slingshot": {
      source: "iana"
    },
    "application/vnd.mfer": {
      source: "iana",
      extensions: ["mwf"]
    },
    "application/vnd.mfmp": {
      source: "iana",
      extensions: ["mfm"]
    },
    "application/vnd.micro+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.micrografx.flo": {
      source: "iana",
      extensions: ["flo"]
    },
    "application/vnd.micrografx.igx": {
      source: "iana",
      extensions: ["igx"]
    },
    "application/vnd.microsoft.portable-executable": {
      source: "iana"
    },
    "application/vnd.microsoft.windows.thumbnail-cache": {
      source: "iana"
    },
    "application/vnd.miele+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.mif": {
      source: "iana",
      extensions: ["mif"]
    },
    "application/vnd.minisoft-hp3000-save": {
      source: "iana"
    },
    "application/vnd.mitsubishi.misty-guard.trustweb": {
      source: "iana"
    },
    "application/vnd.mobius.daf": {
      source: "iana",
      extensions: ["daf"]
    },
    "application/vnd.mobius.dis": {
      source: "iana",
      extensions: ["dis"]
    },
    "application/vnd.mobius.mbk": {
      source: "iana",
      extensions: ["mbk"]
    },
    "application/vnd.mobius.mqy": {
      source: "iana",
      extensions: ["mqy"]
    },
    "application/vnd.mobius.msl": {
      source: "iana",
      extensions: ["msl"]
    },
    "application/vnd.mobius.plc": {
      source: "iana",
      extensions: ["plc"]
    },
    "application/vnd.mobius.txf": {
      source: "iana",
      extensions: ["txf"]
    },
    "application/vnd.mophun.application": {
      source: "iana",
      extensions: ["mpn"]
    },
    "application/vnd.mophun.certificate": {
      source: "iana",
      extensions: ["mpc"]
    },
    "application/vnd.motorola.flexsuite": {
      source: "iana"
    },
    "application/vnd.motorola.flexsuite.adsi": {
      source: "iana"
    },
    "application/vnd.motorola.flexsuite.fis": {
      source: "iana"
    },
    "application/vnd.motorola.flexsuite.gotap": {
      source: "iana"
    },
    "application/vnd.motorola.flexsuite.kmr": {
      source: "iana"
    },
    "application/vnd.motorola.flexsuite.ttc": {
      source: "iana"
    },
    "application/vnd.motorola.flexsuite.wem": {
      source: "iana"
    },
    "application/vnd.motorola.iprm": {
      source: "iana"
    },
    "application/vnd.mozilla.xul+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xul"]
    },
    "application/vnd.ms-3mfdocument": {
      source: "iana"
    },
    "application/vnd.ms-artgalry": {
      source: "iana",
      extensions: ["cil"]
    },
    "application/vnd.ms-asf": {
      source: "iana"
    },
    "application/vnd.ms-cab-compressed": {
      source: "iana",
      extensions: ["cab"]
    },
    "application/vnd.ms-color.iccprofile": {
      source: "apache"
    },
    "application/vnd.ms-excel": {
      source: "iana",
      compressible: false,
      extensions: ["xls", "xlm", "xla", "xlc", "xlt", "xlw"]
    },
    "application/vnd.ms-excel.addin.macroenabled.12": {
      source: "iana",
      extensions: ["xlam"]
    },
    "application/vnd.ms-excel.sheet.binary.macroenabled.12": {
      source: "iana",
      extensions: ["xlsb"]
    },
    "application/vnd.ms-excel.sheet.macroenabled.12": {
      source: "iana",
      extensions: ["xlsm"]
    },
    "application/vnd.ms-excel.template.macroenabled.12": {
      source: "iana",
      extensions: ["xltm"]
    },
    "application/vnd.ms-fontobject": {
      source: "iana",
      compressible: true,
      extensions: ["eot"]
    },
    "application/vnd.ms-htmlhelp": {
      source: "iana",
      extensions: ["chm"]
    },
    "application/vnd.ms-ims": {
      source: "iana",
      extensions: ["ims"]
    },
    "application/vnd.ms-lrm": {
      source: "iana",
      extensions: ["lrm"]
    },
    "application/vnd.ms-office.activex+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ms-officetheme": {
      source: "iana",
      extensions: ["thmx"]
    },
    "application/vnd.ms-opentype": {
      source: "apache",
      compressible: true
    },
    "application/vnd.ms-outlook": {
      compressible: false,
      extensions: ["msg"]
    },
    "application/vnd.ms-package.obfuscated-opentype": {
      source: "apache"
    },
    "application/vnd.ms-pki.seccat": {
      source: "apache",
      extensions: ["cat"]
    },
    "application/vnd.ms-pki.stl": {
      source: "apache",
      extensions: ["stl"]
    },
    "application/vnd.ms-playready.initiator+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ms-powerpoint": {
      source: "iana",
      compressible: false,
      extensions: ["ppt", "pps", "pot"]
    },
    "application/vnd.ms-powerpoint.addin.macroenabled.12": {
      source: "iana",
      extensions: ["ppam"]
    },
    "application/vnd.ms-powerpoint.presentation.macroenabled.12": {
      source: "iana",
      extensions: ["pptm"]
    },
    "application/vnd.ms-powerpoint.slide.macroenabled.12": {
      source: "iana",
      extensions: ["sldm"]
    },
    "application/vnd.ms-powerpoint.slideshow.macroenabled.12": {
      source: "iana",
      extensions: ["ppsm"]
    },
    "application/vnd.ms-powerpoint.template.macroenabled.12": {
      source: "iana",
      extensions: ["potm"]
    },
    "application/vnd.ms-printdevicecapabilities+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ms-printing.printticket+xml": {
      source: "apache",
      compressible: true
    },
    "application/vnd.ms-printschematicket+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ms-project": {
      source: "iana",
      extensions: ["mpp", "mpt"]
    },
    "application/vnd.ms-tnef": {
      source: "iana"
    },
    "application/vnd.ms-windows.devicepairing": {
      source: "iana"
    },
    "application/vnd.ms-windows.nwprinting.oob": {
      source: "iana"
    },
    "application/vnd.ms-windows.printerpairing": {
      source: "iana"
    },
    "application/vnd.ms-windows.wsd.oob": {
      source: "iana"
    },
    "application/vnd.ms-wmdrm.lic-chlg-req": {
      source: "iana"
    },
    "application/vnd.ms-wmdrm.lic-resp": {
      source: "iana"
    },
    "application/vnd.ms-wmdrm.meter-chlg-req": {
      source: "iana"
    },
    "application/vnd.ms-wmdrm.meter-resp": {
      source: "iana"
    },
    "application/vnd.ms-word.document.macroenabled.12": {
      source: "iana",
      extensions: ["docm"]
    },
    "application/vnd.ms-word.template.macroenabled.12": {
      source: "iana",
      extensions: ["dotm"]
    },
    "application/vnd.ms-works": {
      source: "iana",
      extensions: ["wps", "wks", "wcm", "wdb"]
    },
    "application/vnd.ms-wpl": {
      source: "iana",
      extensions: ["wpl"]
    },
    "application/vnd.ms-xpsdocument": {
      source: "iana",
      compressible: false,
      extensions: ["xps"]
    },
    "application/vnd.msa-disk-image": {
      source: "iana"
    },
    "application/vnd.mseq": {
      source: "iana",
      extensions: ["mseq"]
    },
    "application/vnd.msign": {
      source: "iana"
    },
    "application/vnd.multiad.creator": {
      source: "iana"
    },
    "application/vnd.multiad.creator.cif": {
      source: "iana"
    },
    "application/vnd.music-niff": {
      source: "iana"
    },
    "application/vnd.musician": {
      source: "iana",
      extensions: ["mus"]
    },
    "application/vnd.muvee.style": {
      source: "iana",
      extensions: ["msty"]
    },
    "application/vnd.mynfc": {
      source: "iana",
      extensions: ["taglet"]
    },
    "application/vnd.nacamar.ybrid+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.ncd.control": {
      source: "iana"
    },
    "application/vnd.ncd.reference": {
      source: "iana"
    },
    "application/vnd.nearst.inv+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.nebumind.line": {
      source: "iana"
    },
    "application/vnd.nervana": {
      source: "iana"
    },
    "application/vnd.netfpx": {
      source: "iana"
    },
    "application/vnd.neurolanguage.nlu": {
      source: "iana",
      extensions: ["nlu"]
    },
    "application/vnd.nimn": {
      source: "iana"
    },
    "application/vnd.nintendo.nitro.rom": {
      source: "iana"
    },
    "application/vnd.nintendo.snes.rom": {
      source: "iana"
    },
    "application/vnd.nitf": {
      source: "iana",
      extensions: ["ntf", "nitf"]
    },
    "application/vnd.noblenet-directory": {
      source: "iana",
      extensions: ["nnd"]
    },
    "application/vnd.noblenet-sealer": {
      source: "iana",
      extensions: ["nns"]
    },
    "application/vnd.noblenet-web": {
      source: "iana",
      extensions: ["nnw"]
    },
    "application/vnd.nokia.catalogs": {
      source: "iana"
    },
    "application/vnd.nokia.conml+wbxml": {
      source: "iana"
    },
    "application/vnd.nokia.conml+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.nokia.iptv.config+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.nokia.isds-radio-presets": {
      source: "iana"
    },
    "application/vnd.nokia.landmark+wbxml": {
      source: "iana"
    },
    "application/vnd.nokia.landmark+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.nokia.landmarkcollection+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.nokia.n-gage.ac+xml": {
      source: "iana",
      compressible: true,
      extensions: ["ac"]
    },
    "application/vnd.nokia.n-gage.data": {
      source: "iana",
      extensions: ["ngdat"]
    },
    "application/vnd.nokia.n-gage.symbian.install": {
      source: "iana",
      extensions: ["n-gage"]
    },
    "application/vnd.nokia.ncd": {
      source: "iana"
    },
    "application/vnd.nokia.pcd+wbxml": {
      source: "iana"
    },
    "application/vnd.nokia.pcd+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.nokia.radio-preset": {
      source: "iana",
      extensions: ["rpst"]
    },
    "application/vnd.nokia.radio-presets": {
      source: "iana",
      extensions: ["rpss"]
    },
    "application/vnd.novadigm.edm": {
      source: "iana",
      extensions: ["edm"]
    },
    "application/vnd.novadigm.edx": {
      source: "iana",
      extensions: ["edx"]
    },
    "application/vnd.novadigm.ext": {
      source: "iana",
      extensions: ["ext"]
    },
    "application/vnd.ntt-local.content-share": {
      source: "iana"
    },
    "application/vnd.ntt-local.file-transfer": {
      source: "iana"
    },
    "application/vnd.ntt-local.ogw_remote-access": {
      source: "iana"
    },
    "application/vnd.ntt-local.sip-ta_remote": {
      source: "iana"
    },
    "application/vnd.ntt-local.sip-ta_tcp_stream": {
      source: "iana"
    },
    "application/vnd.oasis.opendocument.chart": {
      source: "iana",
      extensions: ["odc"]
    },
    "application/vnd.oasis.opendocument.chart-template": {
      source: "iana",
      extensions: ["otc"]
    },
    "application/vnd.oasis.opendocument.database": {
      source: "iana",
      extensions: ["odb"]
    },
    "application/vnd.oasis.opendocument.formula": {
      source: "iana",
      extensions: ["odf"]
    },
    "application/vnd.oasis.opendocument.formula-template": {
      source: "iana",
      extensions: ["odft"]
    },
    "application/vnd.oasis.opendocument.graphics": {
      source: "iana",
      compressible: false,
      extensions: ["odg"]
    },
    "application/vnd.oasis.opendocument.graphics-template": {
      source: "iana",
      extensions: ["otg"]
    },
    "application/vnd.oasis.opendocument.image": {
      source: "iana",
      extensions: ["odi"]
    },
    "application/vnd.oasis.opendocument.image-template": {
      source: "iana",
      extensions: ["oti"]
    },
    "application/vnd.oasis.opendocument.presentation": {
      source: "iana",
      compressible: false,
      extensions: ["odp"]
    },
    "application/vnd.oasis.opendocument.presentation-template": {
      source: "iana",
      extensions: ["otp"]
    },
    "application/vnd.oasis.opendocument.spreadsheet": {
      source: "iana",
      compressible: false,
      extensions: ["ods"]
    },
    "application/vnd.oasis.opendocument.spreadsheet-template": {
      source: "iana",
      extensions: ["ots"]
    },
    "application/vnd.oasis.opendocument.text": {
      source: "iana",
      compressible: false,
      extensions: ["odt"]
    },
    "application/vnd.oasis.opendocument.text-master": {
      source: "iana",
      extensions: ["odm"]
    },
    "application/vnd.oasis.opendocument.text-template": {
      source: "iana",
      extensions: ["ott"]
    },
    "application/vnd.oasis.opendocument.text-web": {
      source: "iana",
      extensions: ["oth"]
    },
    "application/vnd.obn": {
      source: "iana"
    },
    "application/vnd.ocf+cbor": {
      source: "iana"
    },
    "application/vnd.oci.image.manifest.v1+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oftn.l10n+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.contentaccessdownload+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.contentaccessstreaming+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.cspg-hexbinary": {
      source: "iana"
    },
    "application/vnd.oipf.dae.svg+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.dae.xhtml+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.mippvcontrolmessage+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.pae.gem": {
      source: "iana"
    },
    "application/vnd.oipf.spdiscovery+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.spdlist+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.ueprofile+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oipf.userprofile+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.olpc-sugar": {
      source: "iana",
      extensions: ["xo"]
    },
    "application/vnd.oma-scws-config": {
      source: "iana"
    },
    "application/vnd.oma-scws-http-request": {
      source: "iana"
    },
    "application/vnd.oma-scws-http-response": {
      source: "iana"
    },
    "application/vnd.oma.bcast.associated-procedure-parameter+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.bcast.drm-trigger+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.bcast.imd+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.bcast.ltkm": {
      source: "iana"
    },
    "application/vnd.oma.bcast.notification+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.bcast.provisioningtrigger": {
      source: "iana"
    },
    "application/vnd.oma.bcast.sgboot": {
      source: "iana"
    },
    "application/vnd.oma.bcast.sgdd+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.bcast.sgdu": {
      source: "iana"
    },
    "application/vnd.oma.bcast.simple-symbol-container": {
      source: "iana"
    },
    "application/vnd.oma.bcast.smartcard-trigger+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.bcast.sprov+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.bcast.stkm": {
      source: "iana"
    },
    "application/vnd.oma.cab-address-book+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.cab-feature-handler+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.cab-pcc+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.cab-subs-invite+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.cab-user-prefs+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.dcd": {
      source: "iana"
    },
    "application/vnd.oma.dcdc": {
      source: "iana"
    },
    "application/vnd.oma.dd2+xml": {
      source: "iana",
      compressible: true,
      extensions: ["dd2"]
    },
    "application/vnd.oma.drm.risd+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.group-usage-list+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.lwm2m+cbor": {
      source: "iana"
    },
    "application/vnd.oma.lwm2m+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.lwm2m+tlv": {
      source: "iana"
    },
    "application/vnd.oma.pal+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.poc.detailed-progress-report+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.poc.final-report+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.poc.groups+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.poc.invocation-descriptor+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.poc.optimized-progress-report+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.push": {
      source: "iana"
    },
    "application/vnd.oma.scidm.messages+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oma.xcap-directory+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.omads-email+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/vnd.omads-file+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/vnd.omads-folder+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/vnd.omaloc-supl-init": {
      source: "iana"
    },
    "application/vnd.onepager": {
      source: "iana"
    },
    "application/vnd.onepagertamp": {
      source: "iana"
    },
    "application/vnd.onepagertamx": {
      source: "iana"
    },
    "application/vnd.onepagertat": {
      source: "iana"
    },
    "application/vnd.onepagertatp": {
      source: "iana"
    },
    "application/vnd.onepagertatx": {
      source: "iana"
    },
    "application/vnd.openblox.game+xml": {
      source: "iana",
      compressible: true,
      extensions: ["obgx"]
    },
    "application/vnd.openblox.game-binary": {
      source: "iana"
    },
    "application/vnd.openeye.oeb": {
      source: "iana"
    },
    "application/vnd.openofficeorg.extension": {
      source: "apache",
      extensions: ["oxt"]
    },
    "application/vnd.openstreetmap.data+xml": {
      source: "iana",
      compressible: true,
      extensions: ["osm"]
    },
    "application/vnd.opentimestamps.ots": {
      source: "iana"
    },
    "application/vnd.openxmlformats-officedocument.custom-properties+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.customxmlproperties+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.drawing+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.drawingml.chart+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.drawingml.diagramcolors+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.drawingml.diagramdata+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.drawingml.diagramlayout+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.drawingml.diagramstyle+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.extended-properties+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.commentauthors+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.comments+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.handoutmaster+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.notesmaster+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.notesslide+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.presentation": {
      source: "iana",
      compressible: false,
      extensions: ["pptx"]
    },
    "application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.presprops+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.slide": {
      source: "iana",
      extensions: ["sldx"]
    },
    "application/vnd.openxmlformats-officedocument.presentationml.slide+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.slidelayout+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.slidemaster+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.slideshow": {
      source: "iana",
      extensions: ["ppsx"]
    },
    "application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.slideupdateinfo+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.tablestyles+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.tags+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.template": {
      source: "iana",
      extensions: ["potx"]
    },
    "application/vnd.openxmlformats-officedocument.presentationml.template.main+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.presentationml.viewprops+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.calcchain+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.externallink+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotcachedefinition+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotcacherecords+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.pivottable+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.querytable+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionheaders+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionlog+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.sharedstrings+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": {
      source: "iana",
      compressible: false,
      extensions: ["xlsx"]
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.sheetmetadata+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.tablesinglecells+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.template": {
      source: "iana",
      extensions: ["xltx"]
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.usernames+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.volatiledependencies+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.theme+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.themeoverride+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.vmldrawing": {
      source: "iana"
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.document": {
      source: "iana",
      compressible: false,
      extensions: ["docx"]
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.fonttable+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.template": {
      source: "iana",
      extensions: ["dotx"]
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-officedocument.wordprocessingml.websettings+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-package.core-properties+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.openxmlformats-package.relationships+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oracle.resource+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.orange.indata": {
      source: "iana"
    },
    "application/vnd.osa.netdeploy": {
      source: "iana"
    },
    "application/vnd.osgeo.mapguide.package": {
      source: "iana",
      extensions: ["mgp"]
    },
    "application/vnd.osgi.bundle": {
      source: "iana"
    },
    "application/vnd.osgi.dp": {
      source: "iana",
      extensions: ["dp"]
    },
    "application/vnd.osgi.subsystem": {
      source: "iana",
      extensions: ["esa"]
    },
    "application/vnd.otps.ct-kip+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.oxli.countgraph": {
      source: "iana"
    },
    "application/vnd.pagerduty+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.palm": {
      source: "iana",
      extensions: ["pdb", "pqa", "oprc"]
    },
    "application/vnd.panoply": {
      source: "iana"
    },
    "application/vnd.paos.xml": {
      source: "iana"
    },
    "application/vnd.patentdive": {
      source: "iana"
    },
    "application/vnd.patientecommsdoc": {
      source: "iana"
    },
    "application/vnd.pawaafile": {
      source: "iana",
      extensions: ["paw"]
    },
    "application/vnd.pcos": {
      source: "iana"
    },
    "application/vnd.pg.format": {
      source: "iana",
      extensions: ["str"]
    },
    "application/vnd.pg.osasli": {
      source: "iana",
      extensions: ["ei6"]
    },
    "application/vnd.piaccess.application-licence": {
      source: "iana"
    },
    "application/vnd.picsel": {
      source: "iana",
      extensions: ["efif"]
    },
    "application/vnd.pmi.widget": {
      source: "iana",
      extensions: ["wg"]
    },
    "application/vnd.poc.group-advertisement+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.pocketlearn": {
      source: "iana",
      extensions: ["plf"]
    },
    "application/vnd.powerbuilder6": {
      source: "iana",
      extensions: ["pbd"]
    },
    "application/vnd.powerbuilder6-s": {
      source: "iana"
    },
    "application/vnd.powerbuilder7": {
      source: "iana"
    },
    "application/vnd.powerbuilder7-s": {
      source: "iana"
    },
    "application/vnd.powerbuilder75": {
      source: "iana"
    },
    "application/vnd.powerbuilder75-s": {
      source: "iana"
    },
    "application/vnd.preminet": {
      source: "iana"
    },
    "application/vnd.previewsystems.box": {
      source: "iana",
      extensions: ["box"]
    },
    "application/vnd.proteus.magazine": {
      source: "iana",
      extensions: ["mgz"]
    },
    "application/vnd.psfs": {
      source: "iana"
    },
    "application/vnd.publishare-delta-tree": {
      source: "iana",
      extensions: ["qps"]
    },
    "application/vnd.pvi.ptid1": {
      source: "iana",
      extensions: ["ptid"]
    },
    "application/vnd.pwg-multiplexed": {
      source: "iana"
    },
    "application/vnd.pwg-xhtml-print+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.qualcomm.brew-app-res": {
      source: "iana"
    },
    "application/vnd.quarantainenet": {
      source: "iana"
    },
    "application/vnd.quark.quarkxpress": {
      source: "iana",
      extensions: ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"]
    },
    "application/vnd.quobject-quoxdocument": {
      source: "iana"
    },
    "application/vnd.radisys.moml+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-audit+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-audit-conf+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-audit-conn+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-audit-dialog+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-audit-stream+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-conf+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-dialog+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-dialog-base+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-dialog-fax-detect+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-dialog-fax-sendrecv+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-dialog-group+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-dialog-speech+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.radisys.msml-dialog-transform+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.rainstor.data": {
      source: "iana"
    },
    "application/vnd.rapid": {
      source: "iana"
    },
    "application/vnd.rar": {
      source: "iana",
      extensions: ["rar"]
    },
    "application/vnd.realvnc.bed": {
      source: "iana",
      extensions: ["bed"]
    },
    "application/vnd.recordare.musicxml": {
      source: "iana",
      extensions: ["mxl"]
    },
    "application/vnd.recordare.musicxml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["musicxml"]
    },
    "application/vnd.renlearn.rlprint": {
      source: "iana"
    },
    "application/vnd.resilient.logic": {
      source: "iana"
    },
    "application/vnd.restful+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.rig.cryptonote": {
      source: "iana",
      extensions: ["cryptonote"]
    },
    "application/vnd.rim.cod": {
      source: "apache",
      extensions: ["cod"]
    },
    "application/vnd.rn-realmedia": {
      source: "apache",
      extensions: ["rm"]
    },
    "application/vnd.rn-realmedia-vbr": {
      source: "apache",
      extensions: ["rmvb"]
    },
    "application/vnd.route66.link66+xml": {
      source: "iana",
      compressible: true,
      extensions: ["link66"]
    },
    "application/vnd.rs-274x": {
      source: "iana"
    },
    "application/vnd.ruckus.download": {
      source: "iana"
    },
    "application/vnd.s3sms": {
      source: "iana"
    },
    "application/vnd.sailingtracker.track": {
      source: "iana",
      extensions: ["st"]
    },
    "application/vnd.sar": {
      source: "iana"
    },
    "application/vnd.sbm.cid": {
      source: "iana"
    },
    "application/vnd.sbm.mid2": {
      source: "iana"
    },
    "application/vnd.scribus": {
      source: "iana"
    },
    "application/vnd.sealed.3df": {
      source: "iana"
    },
    "application/vnd.sealed.csf": {
      source: "iana"
    },
    "application/vnd.sealed.doc": {
      source: "iana"
    },
    "application/vnd.sealed.eml": {
      source: "iana"
    },
    "application/vnd.sealed.mht": {
      source: "iana"
    },
    "application/vnd.sealed.net": {
      source: "iana"
    },
    "application/vnd.sealed.ppt": {
      source: "iana"
    },
    "application/vnd.sealed.tiff": {
      source: "iana"
    },
    "application/vnd.sealed.xls": {
      source: "iana"
    },
    "application/vnd.sealedmedia.softseal.html": {
      source: "iana"
    },
    "application/vnd.sealedmedia.softseal.pdf": {
      source: "iana"
    },
    "application/vnd.seemail": {
      source: "iana",
      extensions: ["see"]
    },
    "application/vnd.seis+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.sema": {
      source: "iana",
      extensions: ["sema"]
    },
    "application/vnd.semd": {
      source: "iana",
      extensions: ["semd"]
    },
    "application/vnd.semf": {
      source: "iana",
      extensions: ["semf"]
    },
    "application/vnd.shade-save-file": {
      source: "iana"
    },
    "application/vnd.shana.informed.formdata": {
      source: "iana",
      extensions: ["ifm"]
    },
    "application/vnd.shana.informed.formtemplate": {
      source: "iana",
      extensions: ["itp"]
    },
    "application/vnd.shana.informed.interchange": {
      source: "iana",
      extensions: ["iif"]
    },
    "application/vnd.shana.informed.package": {
      source: "iana",
      extensions: ["ipk"]
    },
    "application/vnd.shootproof+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.shopkick+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.shp": {
      source: "iana"
    },
    "application/vnd.shx": {
      source: "iana"
    },
    "application/vnd.sigrok.session": {
      source: "iana"
    },
    "application/vnd.simtech-mindmapper": {
      source: "iana",
      extensions: ["twd", "twds"]
    },
    "application/vnd.siren+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.smaf": {
      source: "iana",
      extensions: ["mmf"]
    },
    "application/vnd.smart.notebook": {
      source: "iana"
    },
    "application/vnd.smart.teacher": {
      source: "iana",
      extensions: ["teacher"]
    },
    "application/vnd.snesdev-page-table": {
      source: "iana"
    },
    "application/vnd.software602.filler.form+xml": {
      source: "iana",
      compressible: true,
      extensions: ["fo"]
    },
    "application/vnd.software602.filler.form-xml-zip": {
      source: "iana"
    },
    "application/vnd.solent.sdkm+xml": {
      source: "iana",
      compressible: true,
      extensions: ["sdkm", "sdkd"]
    },
    "application/vnd.spotfire.dxp": {
      source: "iana",
      extensions: ["dxp"]
    },
    "application/vnd.spotfire.sfs": {
      source: "iana",
      extensions: ["sfs"]
    },
    "application/vnd.sqlite3": {
      source: "iana"
    },
    "application/vnd.sss-cod": {
      source: "iana"
    },
    "application/vnd.sss-dtf": {
      source: "iana"
    },
    "application/vnd.sss-ntf": {
      source: "iana"
    },
    "application/vnd.stardivision.calc": {
      source: "apache",
      extensions: ["sdc"]
    },
    "application/vnd.stardivision.draw": {
      source: "apache",
      extensions: ["sda"]
    },
    "application/vnd.stardivision.impress": {
      source: "apache",
      extensions: ["sdd"]
    },
    "application/vnd.stardivision.math": {
      source: "apache",
      extensions: ["smf"]
    },
    "application/vnd.stardivision.writer": {
      source: "apache",
      extensions: ["sdw", "vor"]
    },
    "application/vnd.stardivision.writer-global": {
      source: "apache",
      extensions: ["sgl"]
    },
    "application/vnd.stepmania.package": {
      source: "iana",
      extensions: ["smzip"]
    },
    "application/vnd.stepmania.stepchart": {
      source: "iana",
      extensions: ["sm"]
    },
    "application/vnd.street-stream": {
      source: "iana"
    },
    "application/vnd.sun.wadl+xml": {
      source: "iana",
      compressible: true,
      extensions: ["wadl"]
    },
    "application/vnd.sun.xml.calc": {
      source: "apache",
      extensions: ["sxc"]
    },
    "application/vnd.sun.xml.calc.template": {
      source: "apache",
      extensions: ["stc"]
    },
    "application/vnd.sun.xml.draw": {
      source: "apache",
      extensions: ["sxd"]
    },
    "application/vnd.sun.xml.draw.template": {
      source: "apache",
      extensions: ["std"]
    },
    "application/vnd.sun.xml.impress": {
      source: "apache",
      extensions: ["sxi"]
    },
    "application/vnd.sun.xml.impress.template": {
      source: "apache",
      extensions: ["sti"]
    },
    "application/vnd.sun.xml.math": {
      source: "apache",
      extensions: ["sxm"]
    },
    "application/vnd.sun.xml.writer": {
      source: "apache",
      extensions: ["sxw"]
    },
    "application/vnd.sun.xml.writer.global": {
      source: "apache",
      extensions: ["sxg"]
    },
    "application/vnd.sun.xml.writer.template": {
      source: "apache",
      extensions: ["stw"]
    },
    "application/vnd.sus-calendar": {
      source: "iana",
      extensions: ["sus", "susp"]
    },
    "application/vnd.svd": {
      source: "iana",
      extensions: ["svd"]
    },
    "application/vnd.swiftview-ics": {
      source: "iana"
    },
    "application/vnd.sycle+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.syft+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.symbian.install": {
      source: "apache",
      extensions: ["sis", "sisx"]
    },
    "application/vnd.syncml+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["xsm"]
    },
    "application/vnd.syncml.dm+wbxml": {
      source: "iana",
      charset: "UTF-8",
      extensions: ["bdm"]
    },
    "application/vnd.syncml.dm+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["xdm"]
    },
    "application/vnd.syncml.dm.notification": {
      source: "iana"
    },
    "application/vnd.syncml.dmddf+wbxml": {
      source: "iana"
    },
    "application/vnd.syncml.dmddf+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["ddf"]
    },
    "application/vnd.syncml.dmtnds+wbxml": {
      source: "iana"
    },
    "application/vnd.syncml.dmtnds+xml": {
      source: "iana",
      charset: "UTF-8",
      compressible: true
    },
    "application/vnd.syncml.ds.notification": {
      source: "iana"
    },
    "application/vnd.tableschema+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.tao.intent-module-archive": {
      source: "iana",
      extensions: ["tao"]
    },
    "application/vnd.tcpdump.pcap": {
      source: "iana",
      extensions: ["pcap", "cap", "dmp"]
    },
    "application/vnd.think-cell.ppttc+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.tmd.mediaflex.api+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.tml": {
      source: "iana"
    },
    "application/vnd.tmobile-livetv": {
      source: "iana",
      extensions: ["tmo"]
    },
    "application/vnd.tri.onesource": {
      source: "iana"
    },
    "application/vnd.trid.tpt": {
      source: "iana",
      extensions: ["tpt"]
    },
    "application/vnd.triscape.mxs": {
      source: "iana",
      extensions: ["mxs"]
    },
    "application/vnd.trueapp": {
      source: "iana",
      extensions: ["tra"]
    },
    "application/vnd.truedoc": {
      source: "iana"
    },
    "application/vnd.ubisoft.webplayer": {
      source: "iana"
    },
    "application/vnd.ufdl": {
      source: "iana",
      extensions: ["ufd", "ufdl"]
    },
    "application/vnd.uiq.theme": {
      source: "iana",
      extensions: ["utz"]
    },
    "application/vnd.umajin": {
      source: "iana",
      extensions: ["umj"]
    },
    "application/vnd.unity": {
      source: "iana",
      extensions: ["unityweb"]
    },
    "application/vnd.uoml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["uoml"]
    },
    "application/vnd.uplanet.alert": {
      source: "iana"
    },
    "application/vnd.uplanet.alert-wbxml": {
      source: "iana"
    },
    "application/vnd.uplanet.bearer-choice": {
      source: "iana"
    },
    "application/vnd.uplanet.bearer-choice-wbxml": {
      source: "iana"
    },
    "application/vnd.uplanet.cacheop": {
      source: "iana"
    },
    "application/vnd.uplanet.cacheop-wbxml": {
      source: "iana"
    },
    "application/vnd.uplanet.channel": {
      source: "iana"
    },
    "application/vnd.uplanet.channel-wbxml": {
      source: "iana"
    },
    "application/vnd.uplanet.list": {
      source: "iana"
    },
    "application/vnd.uplanet.list-wbxml": {
      source: "iana"
    },
    "application/vnd.uplanet.listcmd": {
      source: "iana"
    },
    "application/vnd.uplanet.listcmd-wbxml": {
      source: "iana"
    },
    "application/vnd.uplanet.signal": {
      source: "iana"
    },
    "application/vnd.uri-map": {
      source: "iana"
    },
    "application/vnd.valve.source.material": {
      source: "iana"
    },
    "application/vnd.vcx": {
      source: "iana",
      extensions: ["vcx"]
    },
    "application/vnd.vd-study": {
      source: "iana"
    },
    "application/vnd.vectorworks": {
      source: "iana"
    },
    "application/vnd.vel+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.verimatrix.vcas": {
      source: "iana"
    },
    "application/vnd.veritone.aion+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.veryant.thin": {
      source: "iana"
    },
    "application/vnd.ves.encrypted": {
      source: "iana"
    },
    "application/vnd.vidsoft.vidconference": {
      source: "iana"
    },
    "application/vnd.visio": {
      source: "iana",
      extensions: ["vsd", "vst", "vss", "vsw"]
    },
    "application/vnd.visionary": {
      source: "iana",
      extensions: ["vis"]
    },
    "application/vnd.vividence.scriptfile": {
      source: "iana"
    },
    "application/vnd.vsf": {
      source: "iana",
      extensions: ["vsf"]
    },
    "application/vnd.wap.sic": {
      source: "iana"
    },
    "application/vnd.wap.slc": {
      source: "iana"
    },
    "application/vnd.wap.wbxml": {
      source: "iana",
      charset: "UTF-8",
      extensions: ["wbxml"]
    },
    "application/vnd.wap.wmlc": {
      source: "iana",
      extensions: ["wmlc"]
    },
    "application/vnd.wap.wmlscriptc": {
      source: "iana",
      extensions: ["wmlsc"]
    },
    "application/vnd.webturbo": {
      source: "iana",
      extensions: ["wtb"]
    },
    "application/vnd.wfa.dpp": {
      source: "iana"
    },
    "application/vnd.wfa.p2p": {
      source: "iana"
    },
    "application/vnd.wfa.wsc": {
      source: "iana"
    },
    "application/vnd.windows.devicepairing": {
      source: "iana"
    },
    "application/vnd.wmc": {
      source: "iana"
    },
    "application/vnd.wmf.bootstrap": {
      source: "iana"
    },
    "application/vnd.wolfram.mathematica": {
      source: "iana"
    },
    "application/vnd.wolfram.mathematica.package": {
      source: "iana"
    },
    "application/vnd.wolfram.player": {
      source: "iana",
      extensions: ["nbp"]
    },
    "application/vnd.wordperfect": {
      source: "iana",
      extensions: ["wpd"]
    },
    "application/vnd.wqd": {
      source: "iana",
      extensions: ["wqd"]
    },
    "application/vnd.wrq-hp3000-labelled": {
      source: "iana"
    },
    "application/vnd.wt.stf": {
      source: "iana",
      extensions: ["stf"]
    },
    "application/vnd.wv.csp+wbxml": {
      source: "iana"
    },
    "application/vnd.wv.csp+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.wv.ssp+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.xacml+json": {
      source: "iana",
      compressible: true
    },
    "application/vnd.xara": {
      source: "iana",
      extensions: ["xar"]
    },
    "application/vnd.xfdl": {
      source: "iana",
      extensions: ["xfdl"]
    },
    "application/vnd.xfdl.webform": {
      source: "iana"
    },
    "application/vnd.xmi+xml": {
      source: "iana",
      compressible: true
    },
    "application/vnd.xmpie.cpkg": {
      source: "iana"
    },
    "application/vnd.xmpie.dpkg": {
      source: "iana"
    },
    "application/vnd.xmpie.plan": {
      source: "iana"
    },
    "application/vnd.xmpie.ppkg": {
      source: "iana"
    },
    "application/vnd.xmpie.xlim": {
      source: "iana"
    },
    "application/vnd.yamaha.hv-dic": {
      source: "iana",
      extensions: ["hvd"]
    },
    "application/vnd.yamaha.hv-script": {
      source: "iana",
      extensions: ["hvs"]
    },
    "application/vnd.yamaha.hv-voice": {
      source: "iana",
      extensions: ["hvp"]
    },
    "application/vnd.yamaha.openscoreformat": {
      source: "iana",
      extensions: ["osf"]
    },
    "application/vnd.yamaha.openscoreformat.osfpvg+xml": {
      source: "iana",
      compressible: true,
      extensions: ["osfpvg"]
    },
    "application/vnd.yamaha.remote-setup": {
      source: "iana"
    },
    "application/vnd.yamaha.smaf-audio": {
      source: "iana",
      extensions: ["saf"]
    },
    "application/vnd.yamaha.smaf-phrase": {
      source: "iana",
      extensions: ["spf"]
    },
    "application/vnd.yamaha.through-ngn": {
      source: "iana"
    },
    "application/vnd.yamaha.tunnel-udpencap": {
      source: "iana"
    },
    "application/vnd.yaoweme": {
      source: "iana"
    },
    "application/vnd.yellowriver-custom-menu": {
      source: "iana",
      extensions: ["cmp"]
    },
    "application/vnd.youtube.yt": {
      source: "iana"
    },
    "application/vnd.zul": {
      source: "iana",
      extensions: ["zir", "zirz"]
    },
    "application/vnd.zzazz.deck+xml": {
      source: "iana",
      compressible: true,
      extensions: ["zaz"]
    },
    "application/voicexml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["vxml"]
    },
    "application/voucher-cms+json": {
      source: "iana",
      compressible: true
    },
    "application/vq-rtcpxr": {
      source: "iana"
    },
    "application/wasm": {
      source: "iana",
      compressible: true,
      extensions: ["wasm"]
    },
    "application/watcherinfo+xml": {
      source: "iana",
      compressible: true,
      extensions: ["wif"]
    },
    "application/webpush-options+json": {
      source: "iana",
      compressible: true
    },
    "application/whoispp-query": {
      source: "iana"
    },
    "application/whoispp-response": {
      source: "iana"
    },
    "application/widget": {
      source: "iana",
      extensions: ["wgt"]
    },
    "application/winhlp": {
      source: "apache",
      extensions: ["hlp"]
    },
    "application/wita": {
      source: "iana"
    },
    "application/wordperfect5.1": {
      source: "iana"
    },
    "application/wsdl+xml": {
      source: "iana",
      compressible: true,
      extensions: ["wsdl"]
    },
    "application/wspolicy+xml": {
      source: "iana",
      compressible: true,
      extensions: ["wspolicy"]
    },
    "application/x-7z-compressed": {
      source: "apache",
      compressible: false,
      extensions: ["7z"]
    },
    "application/x-abiword": {
      source: "apache",
      extensions: ["abw"]
    },
    "application/x-ace-compressed": {
      source: "apache",
      extensions: ["ace"]
    },
    "application/x-amf": {
      source: "apache"
    },
    "application/x-apple-diskimage": {
      source: "apache",
      extensions: ["dmg"]
    },
    "application/x-arj": {
      compressible: false,
      extensions: ["arj"]
    },
    "application/x-authorware-bin": {
      source: "apache",
      extensions: ["aab", "x32", "u32", "vox"]
    },
    "application/x-authorware-map": {
      source: "apache",
      extensions: ["aam"]
    },
    "application/x-authorware-seg": {
      source: "apache",
      extensions: ["aas"]
    },
    "application/x-bcpio": {
      source: "apache",
      extensions: ["bcpio"]
    },
    "application/x-bdoc": {
      compressible: false,
      extensions: ["bdoc"]
    },
    "application/x-bittorrent": {
      source: "apache",
      extensions: ["torrent"]
    },
    "application/x-blorb": {
      source: "apache",
      extensions: ["blb", "blorb"]
    },
    "application/x-bzip": {
      source: "apache",
      compressible: false,
      extensions: ["bz"]
    },
    "application/x-bzip2": {
      source: "apache",
      compressible: false,
      extensions: ["bz2", "boz"]
    },
    "application/x-cbr": {
      source: "apache",
      extensions: ["cbr", "cba", "cbt", "cbz", "cb7"]
    },
    "application/x-cdlink": {
      source: "apache",
      extensions: ["vcd"]
    },
    "application/x-cfs-compressed": {
      source: "apache",
      extensions: ["cfs"]
    },
    "application/x-chat": {
      source: "apache",
      extensions: ["chat"]
    },
    "application/x-chess-pgn": {
      source: "apache",
      extensions: ["pgn"]
    },
    "application/x-chrome-extension": {
      extensions: ["crx"]
    },
    "application/x-cocoa": {
      source: "nginx",
      extensions: ["cco"]
    },
    "application/x-compress": {
      source: "apache"
    },
    "application/x-conference": {
      source: "apache",
      extensions: ["nsc"]
    },
    "application/x-cpio": {
      source: "apache",
      extensions: ["cpio"]
    },
    "application/x-csh": {
      source: "apache",
      extensions: ["csh"]
    },
    "application/x-deb": {
      compressible: false
    },
    "application/x-debian-package": {
      source: "apache",
      extensions: ["deb", "udeb"]
    },
    "application/x-dgc-compressed": {
      source: "apache",
      extensions: ["dgc"]
    },
    "application/x-director": {
      source: "apache",
      extensions: ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"]
    },
    "application/x-doom": {
      source: "apache",
      extensions: ["wad"]
    },
    "application/x-dtbncx+xml": {
      source: "apache",
      compressible: true,
      extensions: ["ncx"]
    },
    "application/x-dtbook+xml": {
      source: "apache",
      compressible: true,
      extensions: ["dtb"]
    },
    "application/x-dtbresource+xml": {
      source: "apache",
      compressible: true,
      extensions: ["res"]
    },
    "application/x-dvi": {
      source: "apache",
      compressible: false,
      extensions: ["dvi"]
    },
    "application/x-envoy": {
      source: "apache",
      extensions: ["evy"]
    },
    "application/x-eva": {
      source: "apache",
      extensions: ["eva"]
    },
    "application/x-font-bdf": {
      source: "apache",
      extensions: ["bdf"]
    },
    "application/x-font-dos": {
      source: "apache"
    },
    "application/x-font-framemaker": {
      source: "apache"
    },
    "application/x-font-ghostscript": {
      source: "apache",
      extensions: ["gsf"]
    },
    "application/x-font-libgrx": {
      source: "apache"
    },
    "application/x-font-linux-psf": {
      source: "apache",
      extensions: ["psf"]
    },
    "application/x-font-pcf": {
      source: "apache",
      extensions: ["pcf"]
    },
    "application/x-font-snf": {
      source: "apache",
      extensions: ["snf"]
    },
    "application/x-font-speedo": {
      source: "apache"
    },
    "application/x-font-sunos-news": {
      source: "apache"
    },
    "application/x-font-type1": {
      source: "apache",
      extensions: ["pfa", "pfb", "pfm", "afm"]
    },
    "application/x-font-vfont": {
      source: "apache"
    },
    "application/x-freearc": {
      source: "apache",
      extensions: ["arc"]
    },
    "application/x-futuresplash": {
      source: "apache",
      extensions: ["spl"]
    },
    "application/x-gca-compressed": {
      source: "apache",
      extensions: ["gca"]
    },
    "application/x-glulx": {
      source: "apache",
      extensions: ["ulx"]
    },
    "application/x-gnumeric": {
      source: "apache",
      extensions: ["gnumeric"]
    },
    "application/x-gramps-xml": {
      source: "apache",
      extensions: ["gramps"]
    },
    "application/x-gtar": {
      source: "apache",
      extensions: ["gtar"]
    },
    "application/x-gzip": {
      source: "apache"
    },
    "application/x-hdf": {
      source: "apache",
      extensions: ["hdf"]
    },
    "application/x-httpd-php": {
      compressible: true,
      extensions: ["php"]
    },
    "application/x-install-instructions": {
      source: "apache",
      extensions: ["install"]
    },
    "application/x-iso9660-image": {
      source: "apache",
      extensions: ["iso"]
    },
    "application/x-iwork-keynote-sffkey": {
      extensions: ["key"]
    },
    "application/x-iwork-numbers-sffnumbers": {
      extensions: ["numbers"]
    },
    "application/x-iwork-pages-sffpages": {
      extensions: ["pages"]
    },
    "application/x-java-archive-diff": {
      source: "nginx",
      extensions: ["jardiff"]
    },
    "application/x-java-jnlp-file": {
      source: "apache",
      compressible: false,
      extensions: ["jnlp"]
    },
    "application/x-javascript": {
      compressible: true
    },
    "application/x-keepass2": {
      extensions: ["kdbx"]
    },
    "application/x-latex": {
      source: "apache",
      compressible: false,
      extensions: ["latex"]
    },
    "application/x-lua-bytecode": {
      extensions: ["luac"]
    },
    "application/x-lzh-compressed": {
      source: "apache",
      extensions: ["lzh", "lha"]
    },
    "application/x-makeself": {
      source: "nginx",
      extensions: ["run"]
    },
    "application/x-mie": {
      source: "apache",
      extensions: ["mie"]
    },
    "application/x-mobipocket-ebook": {
      source: "apache",
      extensions: ["prc", "mobi"]
    },
    "application/x-mpegurl": {
      compressible: false
    },
    "application/x-ms-application": {
      source: "apache",
      extensions: ["application"]
    },
    "application/x-ms-shortcut": {
      source: "apache",
      extensions: ["lnk"]
    },
    "application/x-ms-wmd": {
      source: "apache",
      extensions: ["wmd"]
    },
    "application/x-ms-wmz": {
      source: "apache",
      extensions: ["wmz"]
    },
    "application/x-ms-xbap": {
      source: "apache",
      extensions: ["xbap"]
    },
    "application/x-msaccess": {
      source: "apache",
      extensions: ["mdb"]
    },
    "application/x-msbinder": {
      source: "apache",
      extensions: ["obd"]
    },
    "application/x-mscardfile": {
      source: "apache",
      extensions: ["crd"]
    },
    "application/x-msclip": {
      source: "apache",
      extensions: ["clp"]
    },
    "application/x-msdos-program": {
      extensions: ["exe"]
    },
    "application/x-msdownload": {
      source: "apache",
      extensions: ["exe", "dll", "com", "bat", "msi"]
    },
    "application/x-msmediaview": {
      source: "apache",
      extensions: ["mvb", "m13", "m14"]
    },
    "application/x-msmetafile": {
      source: "apache",
      extensions: ["wmf", "wmz", "emf", "emz"]
    },
    "application/x-msmoney": {
      source: "apache",
      extensions: ["mny"]
    },
    "application/x-mspublisher": {
      source: "apache",
      extensions: ["pub"]
    },
    "application/x-msschedule": {
      source: "apache",
      extensions: ["scd"]
    },
    "application/x-msterminal": {
      source: "apache",
      extensions: ["trm"]
    },
    "application/x-mswrite": {
      source: "apache",
      extensions: ["wri"]
    },
    "application/x-netcdf": {
      source: "apache",
      extensions: ["nc", "cdf"]
    },
    "application/x-ns-proxy-autoconfig": {
      compressible: true,
      extensions: ["pac"]
    },
    "application/x-nzb": {
      source: "apache",
      extensions: ["nzb"]
    },
    "application/x-perl": {
      source: "nginx",
      extensions: ["pl", "pm"]
    },
    "application/x-pilot": {
      source: "nginx",
      extensions: ["prc", "pdb"]
    },
    "application/x-pkcs12": {
      source: "apache",
      compressible: false,
      extensions: ["p12", "pfx"]
    },
    "application/x-pkcs7-certificates": {
      source: "apache",
      extensions: ["p7b", "spc"]
    },
    "application/x-pkcs7-certreqresp": {
      source: "apache",
      extensions: ["p7r"]
    },
    "application/x-pki-message": {
      source: "iana"
    },
    "application/x-rar-compressed": {
      source: "apache",
      compressible: false,
      extensions: ["rar"]
    },
    "application/x-redhat-package-manager": {
      source: "nginx",
      extensions: ["rpm"]
    },
    "application/x-research-info-systems": {
      source: "apache",
      extensions: ["ris"]
    },
    "application/x-sea": {
      source: "nginx",
      extensions: ["sea"]
    },
    "application/x-sh": {
      source: "apache",
      compressible: true,
      extensions: ["sh"]
    },
    "application/x-shar": {
      source: "apache",
      extensions: ["shar"]
    },
    "application/x-shockwave-flash": {
      source: "apache",
      compressible: false,
      extensions: ["swf"]
    },
    "application/x-silverlight-app": {
      source: "apache",
      extensions: ["xap"]
    },
    "application/x-sql": {
      source: "apache",
      extensions: ["sql"]
    },
    "application/x-stuffit": {
      source: "apache",
      compressible: false,
      extensions: ["sit"]
    },
    "application/x-stuffitx": {
      source: "apache",
      extensions: ["sitx"]
    },
    "application/x-subrip": {
      source: "apache",
      extensions: ["srt"]
    },
    "application/x-sv4cpio": {
      source: "apache",
      extensions: ["sv4cpio"]
    },
    "application/x-sv4crc": {
      source: "apache",
      extensions: ["sv4crc"]
    },
    "application/x-t3vm-image": {
      source: "apache",
      extensions: ["t3"]
    },
    "application/x-tads": {
      source: "apache",
      extensions: ["gam"]
    },
    "application/x-tar": {
      source: "apache",
      compressible: true,
      extensions: ["tar"]
    },
    "application/x-tcl": {
      source: "apache",
      extensions: ["tcl", "tk"]
    },
    "application/x-tex": {
      source: "apache",
      extensions: ["tex"]
    },
    "application/x-tex-tfm": {
      source: "apache",
      extensions: ["tfm"]
    },
    "application/x-texinfo": {
      source: "apache",
      extensions: ["texinfo", "texi"]
    },
    "application/x-tgif": {
      source: "apache",
      extensions: ["obj"]
    },
    "application/x-ustar": {
      source: "apache",
      extensions: ["ustar"]
    },
    "application/x-virtualbox-hdd": {
      compressible: true,
      extensions: ["hdd"]
    },
    "application/x-virtualbox-ova": {
      compressible: true,
      extensions: ["ova"]
    },
    "application/x-virtualbox-ovf": {
      compressible: true,
      extensions: ["ovf"]
    },
    "application/x-virtualbox-vbox": {
      compressible: true,
      extensions: ["vbox"]
    },
    "application/x-virtualbox-vbox-extpack": {
      compressible: false,
      extensions: ["vbox-extpack"]
    },
    "application/x-virtualbox-vdi": {
      compressible: true,
      extensions: ["vdi"]
    },
    "application/x-virtualbox-vhd": {
      compressible: true,
      extensions: ["vhd"]
    },
    "application/x-virtualbox-vmdk": {
      compressible: true,
      extensions: ["vmdk"]
    },
    "application/x-wais-source": {
      source: "apache",
      extensions: ["src"]
    },
    "application/x-web-app-manifest+json": {
      compressible: true,
      extensions: ["webapp"]
    },
    "application/x-www-form-urlencoded": {
      source: "iana",
      compressible: true
    },
    "application/x-x509-ca-cert": {
      source: "iana",
      extensions: ["der", "crt", "pem"]
    },
    "application/x-x509-ca-ra-cert": {
      source: "iana"
    },
    "application/x-x509-next-ca-cert": {
      source: "iana"
    },
    "application/x-xfig": {
      source: "apache",
      extensions: ["fig"]
    },
    "application/x-xliff+xml": {
      source: "apache",
      compressible: true,
      extensions: ["xlf"]
    },
    "application/x-xpinstall": {
      source: "apache",
      compressible: false,
      extensions: ["xpi"]
    },
    "application/x-xz": {
      source: "apache",
      extensions: ["xz"]
    },
    "application/x-zmachine": {
      source: "apache",
      extensions: ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"]
    },
    "application/x400-bp": {
      source: "iana"
    },
    "application/xacml+xml": {
      source: "iana",
      compressible: true
    },
    "application/xaml+xml": {
      source: "apache",
      compressible: true,
      extensions: ["xaml"]
    },
    "application/xcap-att+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xav"]
    },
    "application/xcap-caps+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xca"]
    },
    "application/xcap-diff+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xdf"]
    },
    "application/xcap-el+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xel"]
    },
    "application/xcap-error+xml": {
      source: "iana",
      compressible: true
    },
    "application/xcap-ns+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xns"]
    },
    "application/xcon-conference-info+xml": {
      source: "iana",
      compressible: true
    },
    "application/xcon-conference-info-diff+xml": {
      source: "iana",
      compressible: true
    },
    "application/xenc+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xenc"]
    },
    "application/xhtml+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xhtml", "xht"]
    },
    "application/xhtml-voice+xml": {
      source: "apache",
      compressible: true
    },
    "application/xliff+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xlf"]
    },
    "application/xml": {
      source: "iana",
      compressible: true,
      extensions: ["xml", "xsl", "xsd", "rng"]
    },
    "application/xml-dtd": {
      source: "iana",
      compressible: true,
      extensions: ["dtd"]
    },
    "application/xml-external-parsed-entity": {
      source: "iana"
    },
    "application/xml-patch+xml": {
      source: "iana",
      compressible: true
    },
    "application/xmpp+xml": {
      source: "iana",
      compressible: true
    },
    "application/xop+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xop"]
    },
    "application/xproc+xml": {
      source: "apache",
      compressible: true,
      extensions: ["xpl"]
    },
    "application/xslt+xml": {
      source: "iana",
      compressible: true,
      extensions: ["xsl", "xslt"]
    },
    "application/xspf+xml": {
      source: "apache",
      compressible: true,
      extensions: ["xspf"]
    },
    "application/xv+xml": {
      source: "iana",
      compressible: true,
      extensions: ["mxml", "xhvml", "xvml", "xvm"]
    },
    "application/yang": {
      source: "iana",
      extensions: ["yang"]
    },
    "application/yang-data+json": {
      source: "iana",
      compressible: true
    },
    "application/yang-data+xml": {
      source: "iana",
      compressible: true
    },
    "application/yang-patch+json": {
      source: "iana",
      compressible: true
    },
    "application/yang-patch+xml": {
      source: "iana",
      compressible: true
    },
    "application/yin+xml": {
      source: "iana",
      compressible: true,
      extensions: ["yin"]
    },
    "application/zip": {
      source: "iana",
      compressible: false,
      extensions: ["zip"]
    },
    "application/zlib": {
      source: "iana"
    },
    "application/zstd": {
      source: "iana"
    },
    "audio/1d-interleaved-parityfec": {
      source: "iana"
    },
    "audio/32kadpcm": {
      source: "iana"
    },
    "audio/3gpp": {
      source: "iana",
      compressible: false,
      extensions: ["3gpp"]
    },
    "audio/3gpp2": {
      source: "iana"
    },
    "audio/aac": {
      source: "iana"
    },
    "audio/ac3": {
      source: "iana"
    },
    "audio/adpcm": {
      source: "apache",
      extensions: ["adp"]
    },
    "audio/amr": {
      source: "iana",
      extensions: ["amr"]
    },
    "audio/amr-wb": {
      source: "iana"
    },
    "audio/amr-wb+": {
      source: "iana"
    },
    "audio/aptx": {
      source: "iana"
    },
    "audio/asc": {
      source: "iana"
    },
    "audio/atrac-advanced-lossless": {
      source: "iana"
    },
    "audio/atrac-x": {
      source: "iana"
    },
    "audio/atrac3": {
      source: "iana"
    },
    "audio/basic": {
      source: "iana",
      compressible: false,
      extensions: ["au", "snd"]
    },
    "audio/bv16": {
      source: "iana"
    },
    "audio/bv32": {
      source: "iana"
    },
    "audio/clearmode": {
      source: "iana"
    },
    "audio/cn": {
      source: "iana"
    },
    "audio/dat12": {
      source: "iana"
    },
    "audio/dls": {
      source: "iana"
    },
    "audio/dsr-es201108": {
      source: "iana"
    },
    "audio/dsr-es202050": {
      source: "iana"
    },
    "audio/dsr-es202211": {
      source: "iana"
    },
    "audio/dsr-es202212": {
      source: "iana"
    },
    "audio/dv": {
      source: "iana"
    },
    "audio/dvi4": {
      source: "iana"
    },
    "audio/eac3": {
      source: "iana"
    },
    "audio/encaprtp": {
      source: "iana"
    },
    "audio/evrc": {
      source: "iana"
    },
    "audio/evrc-qcp": {
      source: "iana"
    },
    "audio/evrc0": {
      source: "iana"
    },
    "audio/evrc1": {
      source: "iana"
    },
    "audio/evrcb": {
      source: "iana"
    },
    "audio/evrcb0": {
      source: "iana"
    },
    "audio/evrcb1": {
      source: "iana"
    },
    "audio/evrcnw": {
      source: "iana"
    },
    "audio/evrcnw0": {
      source: "iana"
    },
    "audio/evrcnw1": {
      source: "iana"
    },
    "audio/evrcwb": {
      source: "iana"
    },
    "audio/evrcwb0": {
      source: "iana"
    },
    "audio/evrcwb1": {
      source: "iana"
    },
    "audio/evs": {
      source: "iana"
    },
    "audio/flexfec": {
      source: "iana"
    },
    "audio/fwdred": {
      source: "iana"
    },
    "audio/g711-0": {
      source: "iana"
    },
    "audio/g719": {
      source: "iana"
    },
    "audio/g722": {
      source: "iana"
    },
    "audio/g7221": {
      source: "iana"
    },
    "audio/g723": {
      source: "iana"
    },
    "audio/g726-16": {
      source: "iana"
    },
    "audio/g726-24": {
      source: "iana"
    },
    "audio/g726-32": {
      source: "iana"
    },
    "audio/g726-40": {
      source: "iana"
    },
    "audio/g728": {
      source: "iana"
    },
    "audio/g729": {
      source: "iana"
    },
    "audio/g7291": {
      source: "iana"
    },
    "audio/g729d": {
      source: "iana"
    },
    "audio/g729e": {
      source: "iana"
    },
    "audio/gsm": {
      source: "iana"
    },
    "audio/gsm-efr": {
      source: "iana"
    },
    "audio/gsm-hr-08": {
      source: "iana"
    },
    "audio/ilbc": {
      source: "iana"
    },
    "audio/ip-mr_v2.5": {
      source: "iana"
    },
    "audio/isac": {
      source: "apache"
    },
    "audio/l16": {
      source: "iana"
    },
    "audio/l20": {
      source: "iana"
    },
    "audio/l24": {
      source: "iana",
      compressible: false
    },
    "audio/l8": {
      source: "iana"
    },
    "audio/lpc": {
      source: "iana"
    },
    "audio/melp": {
      source: "iana"
    },
    "audio/melp1200": {
      source: "iana"
    },
    "audio/melp2400": {
      source: "iana"
    },
    "audio/melp600": {
      source: "iana"
    },
    "audio/mhas": {
      source: "iana"
    },
    "audio/midi": {
      source: "apache",
      extensions: ["mid", "midi", "kar", "rmi"]
    },
    "audio/mobile-xmf": {
      source: "iana",
      extensions: ["mxmf"]
    },
    "audio/mp3": {
      compressible: false,
      extensions: ["mp3"]
    },
    "audio/mp4": {
      source: "iana",
      compressible: false,
      extensions: ["m4a", "mp4a"]
    },
    "audio/mp4a-latm": {
      source: "iana"
    },
    "audio/mpa": {
      source: "iana"
    },
    "audio/mpa-robust": {
      source: "iana"
    },
    "audio/mpeg": {
      source: "iana",
      compressible: false,
      extensions: ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"]
    },
    "audio/mpeg4-generic": {
      source: "iana"
    },
    "audio/musepack": {
      source: "apache"
    },
    "audio/ogg": {
      source: "iana",
      compressible: false,
      extensions: ["oga", "ogg", "spx", "opus"]
    },
    "audio/opus": {
      source: "iana"
    },
    "audio/parityfec": {
      source: "iana"
    },
    "audio/pcma": {
      source: "iana"
    },
    "audio/pcma-wb": {
      source: "iana"
    },
    "audio/pcmu": {
      source: "iana"
    },
    "audio/pcmu-wb": {
      source: "iana"
    },
    "audio/prs.sid": {
      source: "iana"
    },
    "audio/qcelp": {
      source: "iana"
    },
    "audio/raptorfec": {
      source: "iana"
    },
    "audio/red": {
      source: "iana"
    },
    "audio/rtp-enc-aescm128": {
      source: "iana"
    },
    "audio/rtp-midi": {
      source: "iana"
    },
    "audio/rtploopback": {
      source: "iana"
    },
    "audio/rtx": {
      source: "iana"
    },
    "audio/s3m": {
      source: "apache",
      extensions: ["s3m"]
    },
    "audio/scip": {
      source: "iana"
    },
    "audio/silk": {
      source: "apache",
      extensions: ["sil"]
    },
    "audio/smv": {
      source: "iana"
    },
    "audio/smv-qcp": {
      source: "iana"
    },
    "audio/smv0": {
      source: "iana"
    },
    "audio/sofa": {
      source: "iana"
    },
    "audio/sp-midi": {
      source: "iana"
    },
    "audio/speex": {
      source: "iana"
    },
    "audio/t140c": {
      source: "iana"
    },
    "audio/t38": {
      source: "iana"
    },
    "audio/telephone-event": {
      source: "iana"
    },
    "audio/tetra_acelp": {
      source: "iana"
    },
    "audio/tetra_acelp_bb": {
      source: "iana"
    },
    "audio/tone": {
      source: "iana"
    },
    "audio/tsvcis": {
      source: "iana"
    },
    "audio/uemclip": {
      source: "iana"
    },
    "audio/ulpfec": {
      source: "iana"
    },
    "audio/usac": {
      source: "iana"
    },
    "audio/vdvi": {
      source: "iana"
    },
    "audio/vmr-wb": {
      source: "iana"
    },
    "audio/vnd.3gpp.iufp": {
      source: "iana"
    },
    "audio/vnd.4sb": {
      source: "iana"
    },
    "audio/vnd.audiokoz": {
      source: "iana"
    },
    "audio/vnd.celp": {
      source: "iana"
    },
    "audio/vnd.cisco.nse": {
      source: "iana"
    },
    "audio/vnd.cmles.radio-events": {
      source: "iana"
    },
    "audio/vnd.cns.anp1": {
      source: "iana"
    },
    "audio/vnd.cns.inf1": {
      source: "iana"
    },
    "audio/vnd.dece.audio": {
      source: "iana",
      extensions: ["uva", "uvva"]
    },
    "audio/vnd.digital-winds": {
      source: "iana",
      extensions: ["eol"]
    },
    "audio/vnd.dlna.adts": {
      source: "iana"
    },
    "audio/vnd.dolby.heaac.1": {
      source: "iana"
    },
    "audio/vnd.dolby.heaac.2": {
      source: "iana"
    },
    "audio/vnd.dolby.mlp": {
      source: "iana"
    },
    "audio/vnd.dolby.mps": {
      source: "iana"
    },
    "audio/vnd.dolby.pl2": {
      source: "iana"
    },
    "audio/vnd.dolby.pl2x": {
      source: "iana"
    },
    "audio/vnd.dolby.pl2z": {
      source: "iana"
    },
    "audio/vnd.dolby.pulse.1": {
      source: "iana"
    },
    "audio/vnd.dra": {
      source: "iana",
      extensions: ["dra"]
    },
    "audio/vnd.dts": {
      source: "iana",
      extensions: ["dts"]
    },
    "audio/vnd.dts.hd": {
      source: "iana",
      extensions: ["dtshd"]
    },
    "audio/vnd.dts.uhd": {
      source: "iana"
    },
    "audio/vnd.dvb.file": {
      source: "iana"
    },
    "audio/vnd.everad.plj": {
      source: "iana"
    },
    "audio/vnd.hns.audio": {
      source: "iana"
    },
    "audio/vnd.lucent.voice": {
      source: "iana",
      extensions: ["lvp"]
    },
    "audio/vnd.ms-playready.media.pya": {
      source: "iana",
      extensions: ["pya"]
    },
    "audio/vnd.nokia.mobile-xmf": {
      source: "iana"
    },
    "audio/vnd.nortel.vbk": {
      source: "iana"
    },
    "audio/vnd.nuera.ecelp4800": {
      source: "iana",
      extensions: ["ecelp4800"]
    },
    "audio/vnd.nuera.ecelp7470": {
      source: "iana",
      extensions: ["ecelp7470"]
    },
    "audio/vnd.nuera.ecelp9600": {
      source: "iana",
      extensions: ["ecelp9600"]
    },
    "audio/vnd.octel.sbc": {
      source: "iana"
    },
    "audio/vnd.presonus.multitrack": {
      source: "iana"
    },
    "audio/vnd.qcelp": {
      source: "iana"
    },
    "audio/vnd.rhetorex.32kadpcm": {
      source: "iana"
    },
    "audio/vnd.rip": {
      source: "iana",
      extensions: ["rip"]
    },
    "audio/vnd.rn-realaudio": {
      compressible: false
    },
    "audio/vnd.sealedmedia.softseal.mpeg": {
      source: "iana"
    },
    "audio/vnd.vmx.cvsd": {
      source: "iana"
    },
    "audio/vnd.wave": {
      compressible: false
    },
    "audio/vorbis": {
      source: "iana",
      compressible: false
    },
    "audio/vorbis-config": {
      source: "iana"
    },
    "audio/wav": {
      compressible: false,
      extensions: ["wav"]
    },
    "audio/wave": {
      compressible: false,
      extensions: ["wav"]
    },
    "audio/webm": {
      source: "apache",
      compressible: false,
      extensions: ["weba"]
    },
    "audio/x-aac": {
      source: "apache",
      compressible: false,
      extensions: ["aac"]
    },
    "audio/x-aiff": {
      source: "apache",
      extensions: ["aif", "aiff", "aifc"]
    },
    "audio/x-caf": {
      source: "apache",
      compressible: false,
      extensions: ["caf"]
    },
    "audio/x-flac": {
      source: "apache",
      extensions: ["flac"]
    },
    "audio/x-m4a": {
      source: "nginx",
      extensions: ["m4a"]
    },
    "audio/x-matroska": {
      source: "apache",
      extensions: ["mka"]
    },
    "audio/x-mpegurl": {
      source: "apache",
      extensions: ["m3u"]
    },
    "audio/x-ms-wax": {
      source: "apache",
      extensions: ["wax"]
    },
    "audio/x-ms-wma": {
      source: "apache",
      extensions: ["wma"]
    },
    "audio/x-pn-realaudio": {
      source: "apache",
      extensions: ["ram", "ra"]
    },
    "audio/x-pn-realaudio-plugin": {
      source: "apache",
      extensions: ["rmp"]
    },
    "audio/x-realaudio": {
      source: "nginx",
      extensions: ["ra"]
    },
    "audio/x-tta": {
      source: "apache"
    },
    "audio/x-wav": {
      source: "apache",
      extensions: ["wav"]
    },
    "audio/xm": {
      source: "apache",
      extensions: ["xm"]
    },
    "chemical/x-cdx": {
      source: "apache",
      extensions: ["cdx"]
    },
    "chemical/x-cif": {
      source: "apache",
      extensions: ["cif"]
    },
    "chemical/x-cmdf": {
      source: "apache",
      extensions: ["cmdf"]
    },
    "chemical/x-cml": {
      source: "apache",
      extensions: ["cml"]
    },
    "chemical/x-csml": {
      source: "apache",
      extensions: ["csml"]
    },
    "chemical/x-pdb": {
      source: "apache"
    },
    "chemical/x-xyz": {
      source: "apache",
      extensions: ["xyz"]
    },
    "font/collection": {
      source: "iana",
      extensions: ["ttc"]
    },
    "font/otf": {
      source: "iana",
      compressible: true,
      extensions: ["otf"]
    },
    "font/sfnt": {
      source: "iana"
    },
    "font/ttf": {
      source: "iana",
      compressible: true,
      extensions: ["ttf"]
    },
    "font/woff": {
      source: "iana",
      extensions: ["woff"]
    },
    "font/woff2": {
      source: "iana",
      extensions: ["woff2"]
    },
    "image/aces": {
      source: "iana",
      extensions: ["exr"]
    },
    "image/apng": {
      compressible: false,
      extensions: ["apng"]
    },
    "image/avci": {
      source: "iana",
      extensions: ["avci"]
    },
    "image/avcs": {
      source: "iana",
      extensions: ["avcs"]
    },
    "image/avif": {
      source: "iana",
      compressible: false,
      extensions: ["avif"]
    },
    "image/bmp": {
      source: "iana",
      compressible: true,
      extensions: ["bmp"]
    },
    "image/cgm": {
      source: "iana",
      extensions: ["cgm"]
    },
    "image/dicom-rle": {
      source: "iana",
      extensions: ["drle"]
    },
    "image/emf": {
      source: "iana",
      extensions: ["emf"]
    },
    "image/fits": {
      source: "iana",
      extensions: ["fits"]
    },
    "image/g3fax": {
      source: "iana",
      extensions: ["g3"]
    },
    "image/gif": {
      source: "iana",
      compressible: false,
      extensions: ["gif"]
    },
    "image/heic": {
      source: "iana",
      extensions: ["heic"]
    },
    "image/heic-sequence": {
      source: "iana",
      extensions: ["heics"]
    },
    "image/heif": {
      source: "iana",
      extensions: ["heif"]
    },
    "image/heif-sequence": {
      source: "iana",
      extensions: ["heifs"]
    },
    "image/hej2k": {
      source: "iana",
      extensions: ["hej2"]
    },
    "image/hsj2": {
      source: "iana",
      extensions: ["hsj2"]
    },
    "image/ief": {
      source: "iana",
      extensions: ["ief"]
    },
    "image/jls": {
      source: "iana",
      extensions: ["jls"]
    },
    "image/jp2": {
      source: "iana",
      compressible: false,
      extensions: ["jp2", "jpg2"]
    },
    "image/jpeg": {
      source: "iana",
      compressible: false,
      extensions: ["jpeg", "jpg", "jpe"]
    },
    "image/jph": {
      source: "iana",
      extensions: ["jph"]
    },
    "image/jphc": {
      source: "iana",
      extensions: ["jhc"]
    },
    "image/jpm": {
      source: "iana",
      compressible: false,
      extensions: ["jpm"]
    },
    "image/jpx": {
      source: "iana",
      compressible: false,
      extensions: ["jpx", "jpf"]
    },
    "image/jxr": {
      source: "iana",
      extensions: ["jxr"]
    },
    "image/jxra": {
      source: "iana",
      extensions: ["jxra"]
    },
    "image/jxrs": {
      source: "iana",
      extensions: ["jxrs"]
    },
    "image/jxs": {
      source: "iana",
      extensions: ["jxs"]
    },
    "image/jxsc": {
      source: "iana",
      extensions: ["jxsc"]
    },
    "image/jxsi": {
      source: "iana",
      extensions: ["jxsi"]
    },
    "image/jxss": {
      source: "iana",
      extensions: ["jxss"]
    },
    "image/ktx": {
      source: "iana",
      extensions: ["ktx"]
    },
    "image/ktx2": {
      source: "iana",
      extensions: ["ktx2"]
    },
    "image/naplps": {
      source: "iana"
    },
    "image/pjpeg": {
      compressible: false
    },
    "image/png": {
      source: "iana",
      compressible: false,
      extensions: ["png"]
    },
    "image/prs.btif": {
      source: "iana",
      extensions: ["btif"]
    },
    "image/prs.pti": {
      source: "iana",
      extensions: ["pti"]
    },
    "image/pwg-raster": {
      source: "iana"
    },
    "image/sgi": {
      source: "apache",
      extensions: ["sgi"]
    },
    "image/svg+xml": {
      source: "iana",
      compressible: true,
      extensions: ["svg", "svgz"]
    },
    "image/t38": {
      source: "iana",
      extensions: ["t38"]
    },
    "image/tiff": {
      source: "iana",
      compressible: false,
      extensions: ["tif", "tiff"]
    },
    "image/tiff-fx": {
      source: "iana",
      extensions: ["tfx"]
    },
    "image/vnd.adobe.photoshop": {
      source: "iana",
      compressible: true,
      extensions: ["psd"]
    },
    "image/vnd.airzip.accelerator.azv": {
      source: "iana",
      extensions: ["azv"]
    },
    "image/vnd.cns.inf2": {
      source: "iana"
    },
    "image/vnd.dece.graphic": {
      source: "iana",
      extensions: ["uvi", "uvvi", "uvg", "uvvg"]
    },
    "image/vnd.djvu": {
      source: "iana",
      extensions: ["djvu", "djv"]
    },
    "image/vnd.dvb.subtitle": {
      source: "iana",
      extensions: ["sub"]
    },
    "image/vnd.dwg": {
      source: "iana",
      extensions: ["dwg"]
    },
    "image/vnd.dxf": {
      source: "iana",
      extensions: ["dxf"]
    },
    "image/vnd.fastbidsheet": {
      source: "iana",
      extensions: ["fbs"]
    },
    "image/vnd.fpx": {
      source: "iana",
      extensions: ["fpx"]
    },
    "image/vnd.fst": {
      source: "iana",
      extensions: ["fst"]
    },
    "image/vnd.fujixerox.edmics-mmr": {
      source: "iana",
      extensions: ["mmr"]
    },
    "image/vnd.fujixerox.edmics-rlc": {
      source: "iana",
      extensions: ["rlc"]
    },
    "image/vnd.globalgraphics.pgb": {
      source: "iana"
    },
    "image/vnd.microsoft.icon": {
      source: "iana",
      compressible: true,
      extensions: ["ico"]
    },
    "image/vnd.mix": {
      source: "iana"
    },
    "image/vnd.mozilla.apng": {
      source: "iana"
    },
    "image/vnd.ms-dds": {
      compressible: true,
      extensions: ["dds"]
    },
    "image/vnd.ms-modi": {
      source: "iana",
      extensions: ["mdi"]
    },
    "image/vnd.ms-photo": {
      source: "apache",
      extensions: ["wdp"]
    },
    "image/vnd.net-fpx": {
      source: "iana",
      extensions: ["npx"]
    },
    "image/vnd.pco.b16": {
      source: "iana",
      extensions: ["b16"]
    },
    "image/vnd.radiance": {
      source: "iana"
    },
    "image/vnd.sealed.png": {
      source: "iana"
    },
    "image/vnd.sealedmedia.softseal.gif": {
      source: "iana"
    },
    "image/vnd.sealedmedia.softseal.jpg": {
      source: "iana"
    },
    "image/vnd.svf": {
      source: "iana"
    },
    "image/vnd.tencent.tap": {
      source: "iana",
      extensions: ["tap"]
    },
    "image/vnd.valve.source.texture": {
      source: "iana",
      extensions: ["vtf"]
    },
    "image/vnd.wap.wbmp": {
      source: "iana",
      extensions: ["wbmp"]
    },
    "image/vnd.xiff": {
      source: "iana",
      extensions: ["xif"]
    },
    "image/vnd.zbrush.pcx": {
      source: "iana",
      extensions: ["pcx"]
    },
    "image/webp": {
      source: "apache",
      extensions: ["webp"]
    },
    "image/wmf": {
      source: "iana",
      extensions: ["wmf"]
    },
    "image/x-3ds": {
      source: "apache",
      extensions: ["3ds"]
    },
    "image/x-cmu-raster": {
      source: "apache",
      extensions: ["ras"]
    },
    "image/x-cmx": {
      source: "apache",
      extensions: ["cmx"]
    },
    "image/x-freehand": {
      source: "apache",
      extensions: ["fh", "fhc", "fh4", "fh5", "fh7"]
    },
    "image/x-icon": {
      source: "apache",
      compressible: true,
      extensions: ["ico"]
    },
    "image/x-jng": {
      source: "nginx",
      extensions: ["jng"]
    },
    "image/x-mrsid-image": {
      source: "apache",
      extensions: ["sid"]
    },
    "image/x-ms-bmp": {
      source: "nginx",
      compressible: true,
      extensions: ["bmp"]
    },
    "image/x-pcx": {
      source: "apache",
      extensions: ["pcx"]
    },
    "image/x-pict": {
      source: "apache",
      extensions: ["pic", "pct"]
    },
    "image/x-portable-anymap": {
      source: "apache",
      extensions: ["pnm"]
    },
    "image/x-portable-bitmap": {
      source: "apache",
      extensions: ["pbm"]
    },
    "image/x-portable-graymap": {
      source: "apache",
      extensions: ["pgm"]
    },
    "image/x-portable-pixmap": {
      source: "apache",
      extensions: ["ppm"]
    },
    "image/x-rgb": {
      source: "apache",
      extensions: ["rgb"]
    },
    "image/x-tga": {
      source: "apache",
      extensions: ["tga"]
    },
    "image/x-xbitmap": {
      source: "apache",
      extensions: ["xbm"]
    },
    "image/x-xcf": {
      compressible: false
    },
    "image/x-xpixmap": {
      source: "apache",
      extensions: ["xpm"]
    },
    "image/x-xwindowdump": {
      source: "apache",
      extensions: ["xwd"]
    },
    "message/cpim": {
      source: "iana"
    },
    "message/delivery-status": {
      source: "iana"
    },
    "message/disposition-notification": {
      source: "iana",
      extensions: [
        "disposition-notification"
      ]
    },
    "message/external-body": {
      source: "iana"
    },
    "message/feedback-report": {
      source: "iana"
    },
    "message/global": {
      source: "iana",
      extensions: ["u8msg"]
    },
    "message/global-delivery-status": {
      source: "iana",
      extensions: ["u8dsn"]
    },
    "message/global-disposition-notification": {
      source: "iana",
      extensions: ["u8mdn"]
    },
    "message/global-headers": {
      source: "iana",
      extensions: ["u8hdr"]
    },
    "message/http": {
      source: "iana",
      compressible: false
    },
    "message/imdn+xml": {
      source: "iana",
      compressible: true
    },
    "message/news": {
      source: "iana"
    },
    "message/partial": {
      source: "iana",
      compressible: false
    },
    "message/rfc822": {
      source: "iana",
      compressible: true,
      extensions: ["eml", "mime"]
    },
    "message/s-http": {
      source: "iana"
    },
    "message/sip": {
      source: "iana"
    },
    "message/sipfrag": {
      source: "iana"
    },
    "message/tracking-status": {
      source: "iana"
    },
    "message/vnd.si.simp": {
      source: "iana"
    },
    "message/vnd.wfa.wsc": {
      source: "iana",
      extensions: ["wsc"]
    },
    "model/3mf": {
      source: "iana",
      extensions: ["3mf"]
    },
    "model/e57": {
      source: "iana"
    },
    "model/gltf+json": {
      source: "iana",
      compressible: true,
      extensions: ["gltf"]
    },
    "model/gltf-binary": {
      source: "iana",
      compressible: true,
      extensions: ["glb"]
    },
    "model/iges": {
      source: "iana",
      compressible: false,
      extensions: ["igs", "iges"]
    },
    "model/mesh": {
      source: "iana",
      compressible: false,
      extensions: ["msh", "mesh", "silo"]
    },
    "model/mtl": {
      source: "iana",
      extensions: ["mtl"]
    },
    "model/obj": {
      source: "iana",
      extensions: ["obj"]
    },
    "model/step": {
      source: "iana"
    },
    "model/step+xml": {
      source: "iana",
      compressible: true,
      extensions: ["stpx"]
    },
    "model/step+zip": {
      source: "iana",
      compressible: false,
      extensions: ["stpz"]
    },
    "model/step-xml+zip": {
      source: "iana",
      compressible: false,
      extensions: ["stpxz"]
    },
    "model/stl": {
      source: "iana",
      extensions: ["stl"]
    },
    "model/vnd.collada+xml": {
      source: "iana",
      compressible: true,
      extensions: ["dae"]
    },
    "model/vnd.dwf": {
      source: "iana",
      extensions: ["dwf"]
    },
    "model/vnd.flatland.3dml": {
      source: "iana"
    },
    "model/vnd.gdl": {
      source: "iana",
      extensions: ["gdl"]
    },
    "model/vnd.gs-gdl": {
      source: "apache"
    },
    "model/vnd.gs.gdl": {
      source: "iana"
    },
    "model/vnd.gtw": {
      source: "iana",
      extensions: ["gtw"]
    },
    "model/vnd.moml+xml": {
      source: "iana",
      compressible: true
    },
    "model/vnd.mts": {
      source: "iana",
      extensions: ["mts"]
    },
    "model/vnd.opengex": {
      source: "iana",
      extensions: ["ogex"]
    },
    "model/vnd.parasolid.transmit.binary": {
      source: "iana",
      extensions: ["x_b"]
    },
    "model/vnd.parasolid.transmit.text": {
      source: "iana",
      extensions: ["x_t"]
    },
    "model/vnd.pytha.pyox": {
      source: "iana"
    },
    "model/vnd.rosette.annotated-data-model": {
      source: "iana"
    },
    "model/vnd.sap.vds": {
      source: "iana",
      extensions: ["vds"]
    },
    "model/vnd.usdz+zip": {
      source: "iana",
      compressible: false,
      extensions: ["usdz"]
    },
    "model/vnd.valve.source.compiled-map": {
      source: "iana",
      extensions: ["bsp"]
    },
    "model/vnd.vtu": {
      source: "iana",
      extensions: ["vtu"]
    },
    "model/vrml": {
      source: "iana",
      compressible: false,
      extensions: ["wrl", "vrml"]
    },
    "model/x3d+binary": {
      source: "apache",
      compressible: false,
      extensions: ["x3db", "x3dbz"]
    },
    "model/x3d+fastinfoset": {
      source: "iana",
      extensions: ["x3db"]
    },
    "model/x3d+vrml": {
      source: "apache",
      compressible: false,
      extensions: ["x3dv", "x3dvz"]
    },
    "model/x3d+xml": {
      source: "iana",
      compressible: true,
      extensions: ["x3d", "x3dz"]
    },
    "model/x3d-vrml": {
      source: "iana",
      extensions: ["x3dv"]
    },
    "multipart/alternative": {
      source: "iana",
      compressible: false
    },
    "multipart/appledouble": {
      source: "iana"
    },
    "multipart/byteranges": {
      source: "iana"
    },
    "multipart/digest": {
      source: "iana"
    },
    "multipart/encrypted": {
      source: "iana",
      compressible: false
    },
    "multipart/form-data": {
      source: "iana",
      compressible: false
    },
    "multipart/header-set": {
      source: "iana"
    },
    "multipart/mixed": {
      source: "iana"
    },
    "multipart/multilingual": {
      source: "iana"
    },
    "multipart/parallel": {
      source: "iana"
    },
    "multipart/related": {
      source: "iana",
      compressible: false
    },
    "multipart/report": {
      source: "iana"
    },
    "multipart/signed": {
      source: "iana",
      compressible: false
    },
    "multipart/vnd.bint.med-plus": {
      source: "iana"
    },
    "multipart/voice-message": {
      source: "iana"
    },
    "multipart/x-mixed-replace": {
      source: "iana"
    },
    "text/1d-interleaved-parityfec": {
      source: "iana"
    },
    "text/cache-manifest": {
      source: "iana",
      compressible: true,
      extensions: ["appcache", "manifest"]
    },
    "text/calendar": {
      source: "iana",
      extensions: ["ics", "ifb"]
    },
    "text/calender": {
      compressible: true
    },
    "text/cmd": {
      compressible: true
    },
    "text/coffeescript": {
      extensions: ["coffee", "litcoffee"]
    },
    "text/cql": {
      source: "iana"
    },
    "text/cql-expression": {
      source: "iana"
    },
    "text/cql-identifier": {
      source: "iana"
    },
    "text/css": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["css"]
    },
    "text/csv": {
      source: "iana",
      compressible: true,
      extensions: ["csv"]
    },
    "text/csv-schema": {
      source: "iana"
    },
    "text/directory": {
      source: "iana"
    },
    "text/dns": {
      source: "iana"
    },
    "text/ecmascript": {
      source: "iana"
    },
    "text/encaprtp": {
      source: "iana"
    },
    "text/enriched": {
      source: "iana"
    },
    "text/fhirpath": {
      source: "iana"
    },
    "text/flexfec": {
      source: "iana"
    },
    "text/fwdred": {
      source: "iana"
    },
    "text/gff3": {
      source: "iana"
    },
    "text/grammar-ref-list": {
      source: "iana"
    },
    "text/html": {
      source: "iana",
      compressible: true,
      extensions: ["html", "htm", "shtml"]
    },
    "text/jade": {
      extensions: ["jade"]
    },
    "text/javascript": {
      source: "iana",
      compressible: true
    },
    "text/jcr-cnd": {
      source: "iana"
    },
    "text/jsx": {
      compressible: true,
      extensions: ["jsx"]
    },
    "text/less": {
      compressible: true,
      extensions: ["less"]
    },
    "text/markdown": {
      source: "iana",
      compressible: true,
      extensions: ["markdown", "md"]
    },
    "text/mathml": {
      source: "nginx",
      extensions: ["mml"]
    },
    "text/mdx": {
      compressible: true,
      extensions: ["mdx"]
    },
    "text/mizar": {
      source: "iana"
    },
    "text/n3": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["n3"]
    },
    "text/parameters": {
      source: "iana",
      charset: "UTF-8"
    },
    "text/parityfec": {
      source: "iana"
    },
    "text/plain": {
      source: "iana",
      compressible: true,
      extensions: ["txt", "text", "conf", "def", "list", "log", "in", "ini"]
    },
    "text/provenance-notation": {
      source: "iana",
      charset: "UTF-8"
    },
    "text/prs.fallenstein.rst": {
      source: "iana"
    },
    "text/prs.lines.tag": {
      source: "iana",
      extensions: ["dsc"]
    },
    "text/prs.prop.logic": {
      source: "iana"
    },
    "text/raptorfec": {
      source: "iana"
    },
    "text/red": {
      source: "iana"
    },
    "text/rfc822-headers": {
      source: "iana"
    },
    "text/richtext": {
      source: "iana",
      compressible: true,
      extensions: ["rtx"]
    },
    "text/rtf": {
      source: "iana",
      compressible: true,
      extensions: ["rtf"]
    },
    "text/rtp-enc-aescm128": {
      source: "iana"
    },
    "text/rtploopback": {
      source: "iana"
    },
    "text/rtx": {
      source: "iana"
    },
    "text/sgml": {
      source: "iana",
      extensions: ["sgml", "sgm"]
    },
    "text/shaclc": {
      source: "iana"
    },
    "text/shex": {
      source: "iana",
      extensions: ["shex"]
    },
    "text/slim": {
      extensions: ["slim", "slm"]
    },
    "text/spdx": {
      source: "iana",
      extensions: ["spdx"]
    },
    "text/strings": {
      source: "iana"
    },
    "text/stylus": {
      extensions: ["stylus", "styl"]
    },
    "text/t140": {
      source: "iana"
    },
    "text/tab-separated-values": {
      source: "iana",
      compressible: true,
      extensions: ["tsv"]
    },
    "text/troff": {
      source: "iana",
      extensions: ["t", "tr", "roff", "man", "me", "ms"]
    },
    "text/turtle": {
      source: "iana",
      charset: "UTF-8",
      extensions: ["ttl"]
    },
    "text/ulpfec": {
      source: "iana"
    },
    "text/uri-list": {
      source: "iana",
      compressible: true,
      extensions: ["uri", "uris", "urls"]
    },
    "text/vcard": {
      source: "iana",
      compressible: true,
      extensions: ["vcard"]
    },
    "text/vnd.a": {
      source: "iana"
    },
    "text/vnd.abc": {
      source: "iana"
    },
    "text/vnd.ascii-art": {
      source: "iana"
    },
    "text/vnd.curl": {
      source: "iana",
      extensions: ["curl"]
    },
    "text/vnd.curl.dcurl": {
      source: "apache",
      extensions: ["dcurl"]
    },
    "text/vnd.curl.mcurl": {
      source: "apache",
      extensions: ["mcurl"]
    },
    "text/vnd.curl.scurl": {
      source: "apache",
      extensions: ["scurl"]
    },
    "text/vnd.debian.copyright": {
      source: "iana",
      charset: "UTF-8"
    },
    "text/vnd.dmclientscript": {
      source: "iana"
    },
    "text/vnd.dvb.subtitle": {
      source: "iana",
      extensions: ["sub"]
    },
    "text/vnd.esmertec.theme-descriptor": {
      source: "iana",
      charset: "UTF-8"
    },
    "text/vnd.familysearch.gedcom": {
      source: "iana",
      extensions: ["ged"]
    },
    "text/vnd.ficlab.flt": {
      source: "iana"
    },
    "text/vnd.fly": {
      source: "iana",
      extensions: ["fly"]
    },
    "text/vnd.fmi.flexstor": {
      source: "iana",
      extensions: ["flx"]
    },
    "text/vnd.gml": {
      source: "iana"
    },
    "text/vnd.graphviz": {
      source: "iana",
      extensions: ["gv"]
    },
    "text/vnd.hans": {
      source: "iana"
    },
    "text/vnd.hgl": {
      source: "iana"
    },
    "text/vnd.in3d.3dml": {
      source: "iana",
      extensions: ["3dml"]
    },
    "text/vnd.in3d.spot": {
      source: "iana",
      extensions: ["spot"]
    },
    "text/vnd.iptc.newsml": {
      source: "iana"
    },
    "text/vnd.iptc.nitf": {
      source: "iana"
    },
    "text/vnd.latex-z": {
      source: "iana"
    },
    "text/vnd.motorola.reflex": {
      source: "iana"
    },
    "text/vnd.ms-mediapackage": {
      source: "iana"
    },
    "text/vnd.net2phone.commcenter.command": {
      source: "iana"
    },
    "text/vnd.radisys.msml-basic-layout": {
      source: "iana"
    },
    "text/vnd.senx.warpscript": {
      source: "iana"
    },
    "text/vnd.si.uricatalogue": {
      source: "iana"
    },
    "text/vnd.sosi": {
      source: "iana"
    },
    "text/vnd.sun.j2me.app-descriptor": {
      source: "iana",
      charset: "UTF-8",
      extensions: ["jad"]
    },
    "text/vnd.trolltech.linguist": {
      source: "iana",
      charset: "UTF-8"
    },
    "text/vnd.wap.si": {
      source: "iana"
    },
    "text/vnd.wap.sl": {
      source: "iana"
    },
    "text/vnd.wap.wml": {
      source: "iana",
      extensions: ["wml"]
    },
    "text/vnd.wap.wmlscript": {
      source: "iana",
      extensions: ["wmls"]
    },
    "text/vtt": {
      source: "iana",
      charset: "UTF-8",
      compressible: true,
      extensions: ["vtt"]
    },
    "text/x-asm": {
      source: "apache",
      extensions: ["s", "asm"]
    },
    "text/x-c": {
      source: "apache",
      extensions: ["c", "cc", "cxx", "cpp", "h", "hh", "dic"]
    },
    "text/x-component": {
      source: "nginx",
      extensions: ["htc"]
    },
    "text/x-fortran": {
      source: "apache",
      extensions: ["f", "for", "f77", "f90"]
    },
    "text/x-gwt-rpc": {
      compressible: true
    },
    "text/x-handlebars-template": {
      extensions: ["hbs"]
    },
    "text/x-java-source": {
      source: "apache",
      extensions: ["java"]
    },
    "text/x-jquery-tmpl": {
      compressible: true
    },
    "text/x-lua": {
      extensions: ["lua"]
    },
    "text/x-markdown": {
      compressible: true,
      extensions: ["mkd"]
    },
    "text/x-nfo": {
      source: "apache",
      extensions: ["nfo"]
    },
    "text/x-opml": {
      source: "apache",
      extensions: ["opml"]
    },
    "text/x-org": {
      compressible: true,
      extensions: ["org"]
    },
    "text/x-pascal": {
      source: "apache",
      extensions: ["p", "pas"]
    },
    "text/x-processing": {
      compressible: true,
      extensions: ["pde"]
    },
    "text/x-sass": {
      extensions: ["sass"]
    },
    "text/x-scss": {
      extensions: ["scss"]
    },
    "text/x-setext": {
      source: "apache",
      extensions: ["etx"]
    },
    "text/x-sfv": {
      source: "apache",
      extensions: ["sfv"]
    },
    "text/x-suse-ymp": {
      compressible: true,
      extensions: ["ymp"]
    },
    "text/x-uuencode": {
      source: "apache",
      extensions: ["uu"]
    },
    "text/x-vcalendar": {
      source: "apache",
      extensions: ["vcs"]
    },
    "text/x-vcard": {
      source: "apache",
      extensions: ["vcf"]
    },
    "text/xml": {
      source: "iana",
      compressible: true,
      extensions: ["xml"]
    },
    "text/xml-external-parsed-entity": {
      source: "iana"
    },
    "text/yaml": {
      compressible: true,
      extensions: ["yaml", "yml"]
    },
    "video/1d-interleaved-parityfec": {
      source: "iana"
    },
    "video/3gpp": {
      source: "iana",
      extensions: ["3gp", "3gpp"]
    },
    "video/3gpp-tt": {
      source: "iana"
    },
    "video/3gpp2": {
      source: "iana",
      extensions: ["3g2"]
    },
    "video/av1": {
      source: "iana"
    },
    "video/bmpeg": {
      source: "iana"
    },
    "video/bt656": {
      source: "iana"
    },
    "video/celb": {
      source: "iana"
    },
    "video/dv": {
      source: "iana"
    },
    "video/encaprtp": {
      source: "iana"
    },
    "video/ffv1": {
      source: "iana"
    },
    "video/flexfec": {
      source: "iana"
    },
    "video/h261": {
      source: "iana",
      extensions: ["h261"]
    },
    "video/h263": {
      source: "iana",
      extensions: ["h263"]
    },
    "video/h263-1998": {
      source: "iana"
    },
    "video/h263-2000": {
      source: "iana"
    },
    "video/h264": {
      source: "iana",
      extensions: ["h264"]
    },
    "video/h264-rcdo": {
      source: "iana"
    },
    "video/h264-svc": {
      source: "iana"
    },
    "video/h265": {
      source: "iana"
    },
    "video/iso.segment": {
      source: "iana",
      extensions: ["m4s"]
    },
    "video/jpeg": {
      source: "iana",
      extensions: ["jpgv"]
    },
    "video/jpeg2000": {
      source: "iana"
    },
    "video/jpm": {
      source: "apache",
      extensions: ["jpm", "jpgm"]
    },
    "video/jxsv": {
      source: "iana"
    },
    "video/mj2": {
      source: "iana",
      extensions: ["mj2", "mjp2"]
    },
    "video/mp1s": {
      source: "iana"
    },
    "video/mp2p": {
      source: "iana"
    },
    "video/mp2t": {
      source: "iana",
      extensions: ["ts"]
    },
    "video/mp4": {
      source: "iana",
      compressible: false,
      extensions: ["mp4", "mp4v", "mpg4"]
    },
    "video/mp4v-es": {
      source: "iana"
    },
    "video/mpeg": {
      source: "iana",
      compressible: false,
      extensions: ["mpeg", "mpg", "mpe", "m1v", "m2v"]
    },
    "video/mpeg4-generic": {
      source: "iana"
    },
    "video/mpv": {
      source: "iana"
    },
    "video/nv": {
      source: "iana"
    },
    "video/ogg": {
      source: "iana",
      compressible: false,
      extensions: ["ogv"]
    },
    "video/parityfec": {
      source: "iana"
    },
    "video/pointer": {
      source: "iana"
    },
    "video/quicktime": {
      source: "iana",
      compressible: false,
      extensions: ["qt", "mov"]
    },
    "video/raptorfec": {
      source: "iana"
    },
    "video/raw": {
      source: "iana"
    },
    "video/rtp-enc-aescm128": {
      source: "iana"
    },
    "video/rtploopback": {
      source: "iana"
    },
    "video/rtx": {
      source: "iana"
    },
    "video/scip": {
      source: "iana"
    },
    "video/smpte291": {
      source: "iana"
    },
    "video/smpte292m": {
      source: "iana"
    },
    "video/ulpfec": {
      source: "iana"
    },
    "video/vc1": {
      source: "iana"
    },
    "video/vc2": {
      source: "iana"
    },
    "video/vnd.cctv": {
      source: "iana"
    },
    "video/vnd.dece.hd": {
      source: "iana",
      extensions: ["uvh", "uvvh"]
    },
    "video/vnd.dece.mobile": {
      source: "iana",
      extensions: ["uvm", "uvvm"]
    },
    "video/vnd.dece.mp4": {
      source: "iana"
    },
    "video/vnd.dece.pd": {
      source: "iana",
      extensions: ["uvp", "uvvp"]
    },
    "video/vnd.dece.sd": {
      source: "iana",
      extensions: ["uvs", "uvvs"]
    },
    "video/vnd.dece.video": {
      source: "iana",
      extensions: ["uvv", "uvvv"]
    },
    "video/vnd.directv.mpeg": {
      source: "iana"
    },
    "video/vnd.directv.mpeg-tts": {
      source: "iana"
    },
    "video/vnd.dlna.mpeg-tts": {
      source: "iana"
    },
    "video/vnd.dvb.file": {
      source: "iana",
      extensions: ["dvb"]
    },
    "video/vnd.fvt": {
      source: "iana",
      extensions: ["fvt"]
    },
    "video/vnd.hns.video": {
      source: "iana"
    },
    "video/vnd.iptvforum.1dparityfec-1010": {
      source: "iana"
    },
    "video/vnd.iptvforum.1dparityfec-2005": {
      source: "iana"
    },
    "video/vnd.iptvforum.2dparityfec-1010": {
      source: "iana"
    },
    "video/vnd.iptvforum.2dparityfec-2005": {
      source: "iana"
    },
    "video/vnd.iptvforum.ttsavc": {
      source: "iana"
    },
    "video/vnd.iptvforum.ttsmpeg2": {
      source: "iana"
    },
    "video/vnd.motorola.video": {
      source: "iana"
    },
    "video/vnd.motorola.videop": {
      source: "iana"
    },
    "video/vnd.mpegurl": {
      source: "iana",
      extensions: ["mxu", "m4u"]
    },
    "video/vnd.ms-playready.media.pyv": {
      source: "iana",
      extensions: ["pyv"]
    },
    "video/vnd.nokia.interleaved-multimedia": {
      source: "iana"
    },
    "video/vnd.nokia.mp4vr": {
      source: "iana"
    },
    "video/vnd.nokia.videovoip": {
      source: "iana"
    },
    "video/vnd.objectvideo": {
      source: "iana"
    },
    "video/vnd.radgamettools.bink": {
      source: "iana"
    },
    "video/vnd.radgamettools.smacker": {
      source: "iana"
    },
    "video/vnd.sealed.mpeg1": {
      source: "iana"
    },
    "video/vnd.sealed.mpeg4": {
      source: "iana"
    },
    "video/vnd.sealed.swf": {
      source: "iana"
    },
    "video/vnd.sealedmedia.softseal.mov": {
      source: "iana"
    },
    "video/vnd.uvvu.mp4": {
      source: "iana",
      extensions: ["uvu", "uvvu"]
    },
    "video/vnd.vivo": {
      source: "iana",
      extensions: ["viv"]
    },
    "video/vnd.youtube.yt": {
      source: "iana"
    },
    "video/vp8": {
      source: "iana"
    },
    "video/vp9": {
      source: "iana"
    },
    "video/webm": {
      source: "apache",
      compressible: false,
      extensions: ["webm"]
    },
    "video/x-f4v": {
      source: "apache",
      extensions: ["f4v"]
    },
    "video/x-fli": {
      source: "apache",
      extensions: ["fli"]
    },
    "video/x-flv": {
      source: "apache",
      compressible: false,
      extensions: ["flv"]
    },
    "video/x-m4v": {
      source: "apache",
      extensions: ["m4v"]
    },
    "video/x-matroska": {
      source: "apache",
      compressible: false,
      extensions: ["mkv", "mk3d", "mks"]
    },
    "video/x-mng": {
      source: "apache",
      extensions: ["mng"]
    },
    "video/x-ms-asf": {
      source: "apache",
      extensions: ["asf", "asx"]
    },
    "video/x-ms-vob": {
      source: "apache",
      extensions: ["vob"]
    },
    "video/x-ms-wm": {
      source: "apache",
      extensions: ["wm"]
    },
    "video/x-ms-wmv": {
      source: "apache",
      compressible: false,
      extensions: ["wmv"]
    },
    "video/x-ms-wmx": {
      source: "apache",
      extensions: ["wmx"]
    },
    "video/x-ms-wvx": {
      source: "apache",
      extensions: ["wvx"]
    },
    "video/x-msvideo": {
      source: "apache",
      extensions: ["avi"]
    },
    "video/x-sgi-movie": {
      source: "apache",
      extensions: ["movie"]
    },
    "video/x-smv": {
      source: "apache",
      extensions: ["smv"]
    },
    "x-conference/x-cooltalk": {
      source: "apache",
      extensions: ["ice"]
    },
    "x-shader/x-fragment": {
      compressible: true
    },
    "x-shader/x-vertex": {
      compressible: true
    }
  };
});
var require_mime_db = __commonJS2((exports, module) => {
  /*!
     * mime-db
     * Copyright(c) 2014 Jonathan Ong
     * Copyright(c) 2015-2022 Douglas Christopher Wilson
     * MIT Licensed
     */
  module.exports = require_db();
});
function lookup2(path5) {
  if (!path5 || typeof path5 !== "string") {
    return false;
  }
  var extension2 = extname4("x." + path5).toLowerCase().substr(1);
  if (!extension2) {
    return false;
  }
  return $types[extension2] || false;
}
function populateMaps(extensions4, types16) {
  var preference = ["nginx", "apache", undefined, "iana"];
  Object.keys(db2).forEach(function forEachMimeType(type2) {
    var mime = db2[type2];
    var exts = mime.extensions;
    if (!exts || !exts.length) {
      return;
    }
    extensions4[type2] = exts;
    for (var i5 = 0;i5 < exts.length; i5++) {
      var extension2 = exts[i5];
      if (types16[extension2]) {
        var from = preference.indexOf(db2[types16[extension2]].source);
        var to = preference.indexOf(mime.source);
        if (types16[extension2] !== "application/octet-stream" && (from > to || from === to && types16[extension2].substr(0, 12) === "application/")) {
          continue;
        }
      }
      types16[extension2] = type2;
    }
  });
}
var db2;
var extname4;
var $extensions;
var $lookup;
var $types;
var init_mime_types = __esm2(() => {
  /*!
     * mime-types
     * Copyright(c) 2014 Jonathan Ong
     * Copyright(c) 2015 Douglas Christopher Wilson
     * MIT Licensed
     */
  db2 = require_mime_db();
  extname4 = import.meta.require("path").extname;
  $extensions = Object.create(null);
  $lookup = lookup2;
  $types = Object.create(null);
  populateMaps($extensions, $types);
});
function concatUint8Arrays2(input) {
  const length = input.reduce((l6, a5) => l6 + a5.byteLength, 0);
  const output = new Uint8Array(length);
  let position = 0;
  input.forEach((i5) => {
    output.set(i5, position);
    position += i5.byteLength;
  });
  return output;
}
async function streamHead(stream2, size) {
  return new Promise((resolve5, reject) => {
    const tunnel = new PassThrough2;
    const outputStream = new PassThrough2;
    let readBytes = 0;
    let buffers = [];
    let resolved = false;
    tunnel.once("error", reject);
    tunnel.on("data", (chunk) => {
      if (!resolved) {
        readBytes += chunk.byteLength;
        buffers.push(chunk);
        if (readBytes >= size) {
          resolved = true;
          const head2 = concatUint8Arrays2(buffers);
          buffers = [];
          resolve5([head2, outputStream]);
        }
      }
    });
    tunnel.once("end", () => {
      if (!resolved) {
        resolve5([concatUint8Arrays2(buffers), outputStream]);
      }
    });
    stream2.pipe(tunnel).pipe(outputStream);
  });
}
async function resolveMimeType(filename, stream, fallback = undefined) {
  const [head, readable] = await streamHead(stream, 4100);
  if (fileTypes === undefined) {
    fileTypes = await eval('import("file-type")');
  }
  const { fileTypeFromBuffer } = fileTypes;
  const lookup = await fileTypeFromBuffer(head);
  if (lookup) {
    return [lookup.mime, readable];
  }
  const { ext } = parse11(filename);
  return [$lookup(ext) || fallback, readable];
}
var fileTypes = undefined;
var init_stream_mime_type = __esm2(() => {
  init_mime_types();
});
var init_esm4 = __esm2(() => {
  init_stream_mime_type();
});
function isSupportedAlgo(algo) {
  return possibleChecksumAlgos.includes(algo);
}

class DefaultAwsPublicUrlGenerator {
  async publicUrl(path5, options3) {
    const baseUrl = options3.baseUrl ?? "https://{subdomain}.amazonaws.com/{uri}";
    const subdomain = options3.forcePathStyle !== true ? `${options3.bucket}.s3` : options3.region === undefined ? "s3" : `s3-${options3.region}`;
    const uri = options3.forcePathStyle !== true ? encodePath(path5) : `${options3.bucket}/${encodePath(path5)}`;
    return baseUrl.replace("{subdomain}", subdomain).replace("{uri}", uri);
  }
}
function encodePath(path5) {
  return path5.split("/").map(encodeURIComponent).join("/");
}

class AwsS3StorageAdapter {
  client;
  options;
  publicUrlGenerator;
  timestampResolver;
  prefixer;
  constructor(client2, options3, publicUrlGenerator = new DefaultAwsPublicUrlGenerator, timestampResolver = () => Date.now()) {
    this.client = client2;
    this.options = options3;
    this.publicUrlGenerator = publicUrlGenerator;
    this.timestampResolver = timestampResolver;
    this.prefixer = new PathPrefixer(options3.prefix ?? "", "/", (...paths) => {
      const path5 = join8(...paths);
      if (path5 === "." || path5 === "/") {
        return "";
      } else {
        return path5;
      }
    });
  }
  async copyFile(from, to, options3) {
    let visibility = options3.visibility;
    if (visibility === undefined && options3.retainVisibility) {
      visibility = await this.visibility(from);
    }
    let acl = visibility ? { ACL: this.visibilityToAcl(visibility) } : {};
    await this.client.send(new CopyObjectCommand({
      Bucket: this.options.bucket,
      CopySource: join8("/", this.options.bucket, encodePath(this.prefixer.prefixFilePath(from))),
      Key: this.prefixer.prefixFilePath(to),
      ...acl
    }));
  }
  async moveFile(from, to, options3) {
    await this.copyFile(from, to, options3);
    await this.deleteFile(from);
  }
  async temporaryUrl(path5, options3) {
    const expiry = normalizeExpiryToMilliseconds(options3.expiresAt);
    const now2 = this.timestampResolver();
    const getObjectParams = {
      Bucket: this.options.bucket,
      Key: this.prefixer.prefixFilePath(path5)
    };
    if (options3.responseHeaders) {
      if (options3.responseHeaders["Cache-Control"]) {
        getObjectParams.ResponseCacheControl = options3.responseHeaders["Cache-Control"];
      }
      if (options3.responseHeaders["Content-Disposition"]) {
        getObjectParams.ResponseContentDisposition = options3.responseHeaders["Content-Disposition"];
      }
      if (options3.responseHeaders["Content-Encoding"]) {
        getObjectParams.ResponseContentEncoding = options3.responseHeaders["Content-Encoding"];
      }
      if (options3.responseHeaders["Content-Language"]) {
        getObjectParams.ResponseContentLanguage = options3.responseHeaders["Content-Language"];
      }
      if (options3.responseHeaders["Content-Type"]) {
        getObjectParams.ResponseContentType = options3.responseHeaders["Content-Type"];
      }
      if (options3.responseHeaders["Expires"]) {
        getObjectParams.ResponseExpires = new Date(options3.responseHeaders["Expires"]);
      }
    }
    return await getSignedUrl(this.client, new GetObjectCommand(getObjectParams), {
      expiresIn: Math.floor((expiry - now2) / 1000)
    });
  }
  async lastModified(path5) {
    const stat22 = await this.stat(path5);
    if (stat22.lastModifiedMs === undefined) {
      throw new Error("Last modified is not available in stat");
    }
    return stat22.lastModifiedMs;
  }
  async fileSize(path5) {
    const stat22 = await this.stat(path5);
    if (stat22.isFile === false) {
      throw new Error("Path is not a file");
    }
    if (stat22.size === undefined) {
      throw new Error("File size is not available in stat.");
    }
    return stat22.size;
  }
  async mimeType(path5, options3) {
    const response = await this.stat(path5);
    if (!response.isFile) {
      throw new Error(`Path "${path5} is not a file.`);
    }
    if (response.mimeType) {
      return response.mimeType;
    }
    if (options3.disallowFallback) {
      throw new Error("Mime-type not available via HeadObject");
    }
    const method = options3.fallbackMethod ?? "path";
    const mimeType = method === "path" ? $lookup(path5) : await this.lookupMimeTypeFromStream(path5, options3);
    if (mimeType === undefined || mimeType === false) {
      throw new Error("Unable to resolve mime-type");
    }
    return mimeType;
  }
  async visibility(path5) {
    const response = await this.client.send(new GetObjectAclCommand({
      Bucket: this.options.bucket,
      Key: this.prefixer.prefixFilePath(path5)
    }));
    const publicRead = response.Grants?.some((grant) => grant.Grantee?.URI === "http://acs.amazonaws.com/groups/global/AllUsers" && grant.Permission === "READ") ?? false;
    return publicRead ? Visibility.PUBLIC : Visibility.PRIVATE;
  }
  async* list(path5, { deep }) {
    const listing = this.listObjects(path5, {
      deep,
      includePrefixes: true,
      includeSelf: false
    });
    for await (const { type: type2, item } of listing) {
      if (type2 === "prefix") {
        yield {
          type: "directory",
          isFile: false,
          isDirectory: true,
          path: this.prefixer.stripDirectoryPath(item.Prefix)
        };
      } else {
        const path6 = item.Key;
        if (path6.endsWith("/")) {
          yield {
            type: "directory",
            isFile: false,
            isDirectory: true,
            path: this.prefixer.stripDirectoryPath(path6)
          };
        } else {
          yield {
            type: "file",
            isFile: true,
            isDirectory: false,
            path: this.prefixer.stripFilePath(path6),
            size: item.Size ?? 0,
            lastModifiedMs: item.LastModified?.getTime()
          };
        }
      }
    }
  }
  async* listObjects(path5, options3) {
    const prefix = this.prefixer.prefixDirectoryPath(path5);
    let collectedKeys = 0;
    let shouldContinue = true;
    let continuationToken = undefined;
    while (shouldContinue && (options3.maxKeys === undefined || collectedKeys < options3.maxKeys)) {
      const response = await this.client.send(new ListObjectsV2Command({
        Bucket: this.options.bucket,
        Prefix: prefix,
        Delimiter: options3.deep ? undefined : "/",
        ContinuationToken: continuationToken,
        MaxKeys: options3.maxKeys
      }));
      continuationToken = response.NextContinuationToken;
      shouldContinue = response.IsTruncated ?? false;
      const prefixes = options3.includePrefixes ? response.CommonPrefixes ?? [] : [];
      for (const item of prefixes) {
        if (!options3.includeSelf && item.Prefix === prefix || item.Prefix === undefined) {
          continue;
        }
        collectedKeys++;
        yield { type: "prefix", item };
      }
      for (const item of response.Contents ?? []) {
        if (!options3.includeSelf && item.Key === prefix || item.Key === undefined) {
          continue;
        }
        collectedKeys++;
        yield { type: "object", item };
      }
    }
  }
  async read(path5) {
    const response = await this.client.send(new GetObjectCommand({
      Bucket: this.options.bucket,
      Key: this.prefixer.prefixFilePath(path5)
    }));
    if (response.Body instanceof Readable8) {
      return response.Body;
    }
    throw new Error("No response body was provided");
  }
  async stat(path5) {
    const response = await this.client.send(new HeadObjectCommand({
      Bucket: this.options.bucket,
      Key: this.prefixer.prefixFilePath(path5)
    }));
    return {
      path: path5,
      type: "file",
      isDirectory: false,
      isFile: true,
      size: response.ContentLength ?? 0,
      lastModifiedMs: response.LastModified?.getTime(),
      mimeType: response.ContentType
    };
  }
  async createDirectory(path5, options3) {
    await this.upload(this.prefixer.prefixDirectoryPath(path5), "", {
      ACL: options3.directoryVisibility ? this.visibilityToAcl(options3.directoryVisibility) : undefined
    });
  }
  async deleteDirectory(path5) {
    let itemsToDelete = this.listObjects(path5, {
      deep: true,
      includeSelf: true,
      includePrefixes: false
    });
    const flush = async (keys2) => this.client.send(new DeleteObjectsCommand({
      Bucket: this.options.bucket,
      Delete: {
        Objects: keys2
      }
    }));
    let bucket = [];
    let promises = [];
    for await (const { item } of itemsToDelete) {
      bucket.push({ Key: item.Key });
      if (bucket.length > 1000) {
        promises.push(flush(bucket));
        bucket = [];
      }
    }
    if (bucket.length > 0) {
      promises.push(flush(bucket));
    }
    await Promise.all(promises);
  }
  async write(path5, contents, options3) {
    let mimeType = options3.mimeType;
    if (mimeType === undefined) {
      [mimeType, contents] = await resolveMimeType(path5, contents);
    }
    await this.upload(this.prefixer.prefixFilePath(path5), contents, {
      ACL: options3.visibility ? this.visibilityToAcl(options3.visibility) : undefined,
      ContentType: mimeType,
      ContentLength: options3.size,
      CacheControl: options3.cacheControl
    });
  }
  async upload(key2, contents, options3) {
    const params = {
      Bucket: this.options.bucket,
      Key: key2,
      Body: contents,
      ...Object.assign({}, this.options.putObjectOptions, options3)
    };
    const upload = new Upload({
      client: this.client,
      params,
      ...this.options.uploadConfiguration
    });
    await upload.done();
  }
  async deleteFile(path5) {
    const key2 = this.prefixer.prefixFilePath(path5);
    await this.client.send(new DeleteObjectCommand({
      Bucket: this.options.bucket,
      Key: key2
    }));
  }
  visibilityToAcl(visibility) {
    if (visibility === Visibility.PUBLIC) {
      return "public-read";
    } else if (visibility === Visibility.PRIVATE) {
      return "private";
    }
    throw new Error(`Unrecognized visibility provided; ${visibility}`);
  }
  async changeVisibility(path5, visibility) {
    await this.client.send(new PutObjectAclCommand({
      Bucket: this.options.bucket,
      Key: this.prefixer.prefixFilePath(path5),
      ACL: this.visibilityToAcl(visibility)
    }));
  }
  async fileExists(path5) {
    try {
      await this.client.send(new HeadObjectCommand({
        Bucket: this.options.bucket,
        Key: this.prefixer.prefixFilePath(path5)
      }));
      return true;
    } catch (e5) {
      if (e5 instanceof S3ServiceException && e5.$metadata.httpStatusCode === 404) {
        return false;
      }
      throw e5;
    }
  }
  async directoryExists(path5) {
    const listing = this.listObjects(path5, {
      deep: true,
      includePrefixes: true,
      includeSelf: true,
      maxKeys: 1
    });
    for await (const _item of listing) {
      return true;
    }
    return false;
  }
  async publicUrl(path5, options3) {
    return this.publicUrlGenerator.publicUrl(this.prefixer.prefixFilePath(path5), {
      bucket: this.options.bucket,
      ...options3,
      ...this.options.publicUrlOptions
    });
  }
  async checksum(path5, options3) {
    const algo = (options3.algo || this.options.defaultChecksumAlgo || "SHA256").toUpperCase();
    if (!isSupportedAlgo(algo)) {
      throw ChecksumIsNotAvailable.checksumNotSupported(algo);
    }
    const responseKey = algo === "ETAG" ? "ETag" : `Checksum${algo}`;
    const response = await this.client.send(new HeadObjectCommand({
      Bucket: this.options.bucket,
      Key: this.prefixer.prefixFilePath(path5),
      ...algo === "ETAG" ? {} : { ChecksumMode: "ENABLED" }
    }));
    const checksum = response[responseKey];
    if (checksum === undefined) {
      throw new Error(`Unable to retrieve checksum with algo ${algo}`);
    }
    return checksum.replace(/^"(.+)"$/, "$1");
  }
  async lookupMimeTypeFromStream(path5, options3) {
    const [mimetype, stream2] = await resolveMimeType(path5, Readable8.from(await this.read(path5)));
    await closeReadable(stream2);
    return mimetype;
  }
}
var possibleChecksumAlgos;
var HostStyleAwsPublicUrlGenerator;
var init_aws_s3_storage_adapter = __esm2(() => {
  init_dist_es63();
  init_dist_es65();
  init_dist_es67();
  init_esm3();
  init_esm4();
  init_esm3();
  init_mime_types();
  possibleChecksumAlgos = ["SHA1", "SHA256", "CRC32", "CRC32C", "ETAG"];
  HostStyleAwsPublicUrlGenerator = class HostStyleAwsPublicUrlGenerator2 extends DefaultAwsPublicUrlGenerator {
  };
});
var init_esm5 = __esm2(() => {
  init_aws_s3_storage_adapter();
});
var defaultMessages = "End-Of-Stream";
var EndOfStreamError;
var init_EndOfStreamError = __esm2(() => {
  EndOfStreamError = class EndOfStreamError2 extends Error {
    constructor() {
      super(defaultMessages);
    }
  };
});

class Deferred2 {
  constructor() {
    this.resolve = () => null;
    this.reject = () => null;
    this.promise = new Promise((resolve5, reject) => {
      this.reject = reject;
      this.resolve = resolve5;
    });
  }
}

class AbstractStreamReader {
  constructor() {
    this.maxStreamReadSize = 1048576;
    this.endOfStream = false;
    this.peekQueue = [];
  }
  async peek(uint8Array, offset2, length) {
    const bytesRead = await this.read(uint8Array, offset2, length);
    this.peekQueue.push(uint8Array.subarray(offset2, offset2 + bytesRead));
    return bytesRead;
  }
  async read(buffer, offset2, length) {
    if (length === 0) {
      return 0;
    }
    let bytesRead = this.readFromPeekBuffer(buffer, offset2, length);
    bytesRead += await this.readRemainderFromStream(buffer, offset2 + bytesRead, length - bytesRead);
    if (bytesRead === 0) {
      throw new EndOfStreamError;
    }
    return bytesRead;
  }
  readFromPeekBuffer(buffer, offset2, length) {
    let remaining = length;
    let bytesRead = 0;
    while (this.peekQueue.length > 0 && remaining > 0) {
      const peekData = this.peekQueue.pop();
      if (!peekData)
        throw new Error("peekData should be defined");
      const lenCopy = Math.min(peekData.length, remaining);
      buffer.set(peekData.subarray(0, lenCopy), offset2 + bytesRead);
      bytesRead += lenCopy;
      remaining -= lenCopy;
      if (lenCopy < peekData.length) {
        this.peekQueue.push(peekData.subarray(lenCopy));
      }
    }
    return bytesRead;
  }
  async readRemainderFromStream(buffer, offset2, initialRemaining) {
    let remaining = initialRemaining;
    let bytesRead = 0;
    while (remaining > 0 && !this.endOfStream) {
      const reqLen = Math.min(remaining, this.maxStreamReadSize);
      const chunkLen = await this.readFromStream(buffer, offset2 + bytesRead, reqLen);
      if (chunkLen === 0)
        break;
      bytesRead += chunkLen;
      remaining -= chunkLen;
    }
    return bytesRead;
  }
}
var init_AbstractStreamReader = __esm2(() => {
  init_EndOfStreamError();
});
var StreamReader;
var init_StreamReader = __esm2(() => {
  init_EndOfStreamError();
  init_AbstractStreamReader();
  init_EndOfStreamError();
  StreamReader = class StreamReader2 extends AbstractStreamReader {
    constructor(s5) {
      super();
      this.s = s5;
      this.deferred = null;
      if (!s5.read || !s5.once) {
        throw new Error("Expected an instance of stream.Readable");
      }
      this.s.once("end", () => this.reject(new EndOfStreamError));
      this.s.once("error", (err22) => this.reject(err22));
      this.s.once("close", () => this.reject(new Error("Stream closed")));
    }
    async readFromStream(buffer, offset2, length) {
      if (this.endOfStream) {
        return 0;
      }
      const readBuffer = this.s.read(length);
      if (readBuffer) {
        buffer.set(readBuffer, offset2);
        return readBuffer.length;
      }
      const request5 = {
        buffer,
        offset: offset2,
        length,
        deferred: new Deferred2
      };
      this.deferred = request5.deferred;
      this.s.once("readable", () => {
        this.readDeferred(request5);
      });
      return request5.deferred.promise;
    }
    readDeferred(request5) {
      const readBuffer = this.s.read(request5.length);
      if (readBuffer) {
        request5.buffer.set(readBuffer, request5.offset);
        request5.deferred.resolve(readBuffer.length);
        this.deferred = null;
      } else {
        this.s.once("readable", () => {
          this.readDeferred(request5);
        });
      }
    }
    reject(err22) {
      this.endOfStream = true;
      if (this.deferred) {
        this.deferred.reject(err22);
        this.deferred = null;
      }
    }
    async abort() {
      this.s.destroy();
    }
  };
});
var WebStreamReader;
var init_WebStreamReader = __esm2(() => {
  init_EndOfStreamError();
  init_EndOfStreamError();
  init_AbstractStreamReader();
  WebStreamReader = class WebStreamReader2 extends AbstractStreamReader {
    constructor(stream2) {
      super();
      this.reader = stream2.getReader({ mode: "byob" });
    }
    async readFromStream(buffer, offset2, length) {
      if (this.endOfStream) {
        throw new EndOfStreamError;
      }
      const result2 = await this.reader.read(new Uint8Array(length));
      if (result2.done) {
        this.endOfStream = result2.done;
      }
      if (result2.value) {
        buffer.set(result2.value, offset2);
        return result2.value.byteLength;
      }
      return 0;
    }
    async abort() {
      await this.reader.cancel();
      this.reader.releaseLock();
    }
  };
});
var init_lib2 = __esm2(() => {
  init_EndOfStreamError();
  init_StreamReader();
  init_WebStreamReader();
});

class AbstractTokenizer {
  constructor(options3) {
    this.position = 0;
    this.numBuffer = new Uint8Array(8);
    this.fileInfo = options3?.fileInfo ?? {};
    this.onClose = options3?.onClose;
    if (options3?.abortSignal) {
      options3.abortSignal.addEventListener("abort", () => {
        this.abort();
      });
    }
  }
  async readToken(token, position = this.position) {
    const uint8Array = new Uint8Array(token.len);
    const len = await this.readBuffer(uint8Array, { position });
    if (len < token.len)
      throw new EndOfStreamError;
    return token.get(uint8Array, 0);
  }
  async peekToken(token, position = this.position) {
    const uint8Array = new Uint8Array(token.len);
    const len = await this.peekBuffer(uint8Array, { position });
    if (len < token.len)
      throw new EndOfStreamError;
    return token.get(uint8Array, 0);
  }
  async readNumber(token) {
    const len = await this.readBuffer(this.numBuffer, { length: token.len });
    if (len < token.len)
      throw new EndOfStreamError;
    return token.get(this.numBuffer, 0);
  }
  async peekNumber(token) {
    const len = await this.peekBuffer(this.numBuffer, { length: token.len });
    if (len < token.len)
      throw new EndOfStreamError;
    return token.get(this.numBuffer, 0);
  }
  async ignore(length) {
    if (this.fileInfo.size !== undefined) {
      const bytesLeft = this.fileInfo.size - this.position;
      if (length > bytesLeft) {
        this.position += bytesLeft;
        return bytesLeft;
      }
    }
    this.position += length;
    return length;
  }
  async close() {
    await this.abort();
    await this.onClose?.();
  }
  normalizeOptions(uint8Array, options3) {
    if (options3 && options3.position !== undefined && options3.position < this.position) {
      throw new Error("`options.position` must be equal or greater than `tokenizer.position`");
    }
    if (options3) {
      return {
        mayBeLess: options3.mayBeLess === true,
        offset: options3.offset ? options3.offset : 0,
        length: options3.length ? options3.length : uint8Array.length - (options3.offset ? options3.offset : 0),
        position: options3.position ? options3.position : this.position
      };
    }
    return {
      mayBeLess: false,
      offset: 0,
      length: uint8Array.length,
      position: this.position
    };
  }
  abort() {
    return Promise.resolve();
  }
}
var init_AbstractTokenizer = __esm2(() => {
  init_lib2();
});
var maxBufferSize = 256000;
var ReadStreamTokenizer;
var init_ReadStreamTokenizer = __esm2(() => {
  init_AbstractTokenizer();
  init_lib2();
  ReadStreamTokenizer = class ReadStreamTokenizer2 extends AbstractTokenizer {
    constructor(streamReader, options3) {
      super(options3);
      this.streamReader = streamReader;
    }
    async readBuffer(uint8Array, options3) {
      const normOptions = this.normalizeOptions(uint8Array, options3);
      const skipBytes = normOptions.position - this.position;
      if (skipBytes > 0) {
        await this.ignore(skipBytes);
        return this.readBuffer(uint8Array, options3);
      }
      if (skipBytes < 0) {
        throw new Error("`options.position` must be equal or greater than `tokenizer.position`");
      }
      if (normOptions.length === 0) {
        return 0;
      }
      const bytesRead = await this.streamReader.read(uint8Array, normOptions.offset, normOptions.length);
      this.position += bytesRead;
      if ((!options3 || !options3.mayBeLess) && bytesRead < normOptions.length) {
        throw new EndOfStreamError;
      }
      return bytesRead;
    }
    async peekBuffer(uint8Array, options3) {
      const normOptions = this.normalizeOptions(uint8Array, options3);
      let bytesRead = 0;
      if (normOptions.position) {
        const skipBytes = normOptions.position - this.position;
        if (skipBytes > 0) {
          const skipBuffer = new Uint8Array(normOptions.length + skipBytes);
          bytesRead = await this.peekBuffer(skipBuffer, { mayBeLess: normOptions.mayBeLess });
          uint8Array.set(skipBuffer.subarray(skipBytes), normOptions.offset);
          return bytesRead - skipBytes;
        }
        if (skipBytes < 0) {
          throw new Error("Cannot peek from a negative offset in a stream");
        }
      }
      if (normOptions.length > 0) {
        try {
          bytesRead = await this.streamReader.peek(uint8Array, normOptions.offset, normOptions.length);
        } catch (err22) {
          if (options3?.mayBeLess && err22 instanceof EndOfStreamError) {
            return 0;
          }
          throw err22;
        }
        if (!normOptions.mayBeLess && bytesRead < normOptions.length) {
          throw new EndOfStreamError;
        }
      }
      return bytesRead;
    }
    async ignore(length) {
      const bufSize = Math.min(maxBufferSize, length);
      const buf = new Uint8Array(bufSize);
      let totBytesRead = 0;
      while (totBytesRead < length) {
        const remaining = length - totBytesRead;
        const bytesRead = await this.readBuffer(buf, { length: Math.min(bufSize, remaining) });
        if (bytesRead < 0) {
          return bytesRead;
        }
        totBytesRead += bytesRead;
      }
      return totBytesRead;
    }
    abort() {
      return this.streamReader.abort();
    }
  };
});
var BufferTokenizer;
var init_BufferTokenizer = __esm2(() => {
  init_lib2();
  init_AbstractTokenizer();
  BufferTokenizer = class BufferTokenizer2 extends AbstractTokenizer {
    constructor(uint8Array, options3) {
      super(options3);
      this.uint8Array = uint8Array;
      this.fileInfo.size = this.fileInfo.size ? this.fileInfo.size : uint8Array.length;
    }
    async readBuffer(uint8Array, options3) {
      if (options3?.position) {
        if (options3.position < this.position) {
          throw new Error("`options.position` must be equal or greater than `tokenizer.position`");
        }
        this.position = options3.position;
      }
      const bytesRead = await this.peekBuffer(uint8Array, options3);
      this.position += bytesRead;
      return bytesRead;
    }
    async peekBuffer(uint8Array, options3) {
      const normOptions = this.normalizeOptions(uint8Array, options3);
      const bytes2read = Math.min(this.uint8Array.length - normOptions.position, normOptions.length);
      if (!normOptions.mayBeLess && bytes2read < normOptions.length) {
        throw new EndOfStreamError;
      }
      uint8Array.set(this.uint8Array.subarray(normOptions.position, normOptions.position + bytes2read), normOptions.offset);
      return bytes2read;
    }
    close() {
      return super.close();
    }
  };
});
function fromStream(stream2, options3) {
  return new ReadStreamTokenizer(new StreamReader(stream2), options3);
}
function fromWebStream(webStream, options3) {
  return new ReadStreamTokenizer(new WebStreamReader(webStream), options3);
}
function fromBuffer(uint8Array, options3) {
  return new BufferTokenizer(uint8Array, options3);
}
var init_core22 = __esm2(() => {
  init_lib2();
  init_ReadStreamTokenizer();
  init_BufferTokenizer();
  init_lib2();
  init_AbstractTokenizer();
});
async function fromFile(sourceFilePath) {
  const fileHandle = await fsOpen(sourceFilePath, "r");
  const stat22 = await fileHandle.stat();
  return new FileTokenizer(fileHandle, { fileInfo: { path: sourceFilePath, size: stat22.size } });
}
var FileTokenizer;
var init_FileTokenizer = __esm2(() => {
  init_AbstractTokenizer();
  init_lib2();
  FileTokenizer = class FileTokenizer2 extends AbstractTokenizer {
    constructor(fileHandle, options3) {
      super(options3);
      this.fileHandle = fileHandle;
    }
    async readBuffer(uint8Array, options3) {
      const normOptions = this.normalizeOptions(uint8Array, options3);
      this.position = normOptions.position;
      if (normOptions.length === 0)
        return 0;
      const res = await this.fileHandle.read(uint8Array, normOptions.offset, normOptions.length, normOptions.position);
      this.position += res.bytesRead;
      if (res.bytesRead < normOptions.length && (!options3 || !options3.mayBeLess)) {
        throw new EndOfStreamError;
      }
      return res.bytesRead;
    }
    async peekBuffer(uint8Array, options3) {
      const normOptions = this.normalizeOptions(uint8Array, options3);
      const res = await this.fileHandle.read(uint8Array, normOptions.offset, normOptions.length, normOptions.position);
      if (!normOptions.mayBeLess && res.bytesRead < normOptions.length) {
        throw new EndOfStreamError;
      }
      return res.bytesRead;
    }
    async close() {
      await this.fileHandle.close();
      return super.close();
    }
  };
});
async function fromStream2(stream2, options3) {
  const augmentedOptions = options3 ?? {};
  augmentedOptions.fileInfo = augmentedOptions.fileInfo ?? {};
  if (stream2.path) {
    const stat22 = await fsStat(stream2.path);
    augmentedOptions.fileInfo.path = stream2.path;
    augmentedOptions.fileInfo.size = stat22.size;
  }
  return fromStream(stream2, augmentedOptions);
}
var init_lib3 = __esm2(() => {
  init_core22();
  init_FileTokenizer();
  init_core22();
});
var init_ieee754 = __esm2(() => {
  /*! ieee754. BSD-3-Clause License. Feross Aboukhadijeh <https://feross.org/opensource> */
});
function dv(array) {
  return new DataView(array.buffer, array.byteOffset);
}

class StringType {
  constructor(len, encoding) {
    this.len = len;
    this.encoding = encoding;
    this.textDecoder = new TextDecoder(encoding);
  }
  get(uint8Array, offset2) {
    return this.textDecoder.decode(uint8Array.subarray(offset2, offset2 + this.len));
  }
}
var UINT8;
var UINT16_LE;
var UINT16_BE;
var UINT32_LE;
var UINT32_BE;
var INT32_BE;
var UINT64_LE;
var init_lib4 = __esm2(() => {
  init_ieee754();
  UINT8 = {
    len: 1,
    get(array, offset2) {
      return dv(array).getUint8(offset2);
    },
    put(array, offset2, value) {
      dv(array).setUint8(offset2, value);
      return offset2 + 1;
    }
  };
  UINT16_LE = {
    len: 2,
    get(array, offset2) {
      return dv(array).getUint16(offset2, true);
    },
    put(array, offset2, value) {
      dv(array).setUint16(offset2, value, true);
      return offset2 + 2;
    }
  };
  UINT16_BE = {
    len: 2,
    get(array, offset2) {
      return dv(array).getUint16(offset2);
    },
    put(array, offset2, value) {
      dv(array).setUint16(offset2, value);
      return offset2 + 2;
    }
  };
  UINT32_LE = {
    len: 4,
    get(array, offset2) {
      return dv(array).getUint32(offset2, true);
    },
    put(array, offset2, value) {
      dv(array).setUint32(offset2, value, true);
      return offset2 + 4;
    }
  };
  UINT32_BE = {
    len: 4,
    get(array, offset2) {
      return dv(array).getUint32(offset2);
    },
    put(array, offset2, value) {
      dv(array).setUint32(offset2, value);
      return offset2 + 4;
    }
  };
  INT32_BE = {
    len: 4,
    get(array, offset2) {
      return dv(array).getInt32(offset2);
    },
    put(array, offset2, value) {
      dv(array).setInt32(offset2, value);
      return offset2 + 4;
    }
  };
  UINT64_LE = {
    len: 8,
    get(array, offset2) {
      return dv(array).getBigUint64(offset2, true);
    },
    put(array, offset2, value) {
      dv(array).setBigUint64(offset2, value, true);
      return offset2 + 8;
    }
  };
});
function getUintBE(view) {
  const { byteLength: byteLength2 } = view;
  if (byteLength2 === 6) {
    return view.getUint16(0) * 4294967296 + view.getUint32(2);
  }
  if (byteLength2 === 5) {
    return view.getUint8(0) * 4294967296 + view.getUint32(1);
  }
  if (byteLength2 === 4) {
    return view.getUint32(0);
  }
  if (byteLength2 === 3) {
    return view.getUint8(0) * 65536 + view.getUint16(1);
  }
  if (byteLength2 === 2) {
    return view.getUint16(0);
  }
  if (byteLength2 === 1) {
    return view.getUint8(0);
  }
}
function indexOf(array, value) {
  const arrayLength = array.length;
  const valueLength = value.length;
  if (valueLength === 0) {
    return -1;
  }
  if (valueLength > arrayLength) {
    return -1;
  }
  const validOffsetLength = arrayLength - valueLength;
  for (let index = 0;index <= validOffsetLength; index++) {
    let isMatch = true;
    for (let index2 = 0;index2 < valueLength; index2++) {
      if (array[index + index2] !== value[index2]) {
        isMatch = false;
        break;
      }
    }
    if (isMatch) {
      return index;
    }
  }
  return -1;
}
function includes(array, value) {
  return indexOf(array, value) !== -1;
}
var cachedDecoders;
var cachedEncoder;
var byteToHexLookupTable;
var init_uint8array_extras = __esm2(() => {
  cachedDecoders = {
    utf8: new globalThis.TextDecoder("utf8")
  };
  cachedEncoder = new globalThis.TextEncoder;
  byteToHexLookupTable = Array.from({ length: 256 }, (_3, index) => index.toString(16).padStart(2, "0"));
});
function stringToBytes(string2) {
  return [...string2].map((character) => character.charCodeAt(0));
}
function tarHeaderChecksumMatches(arrayBuffer, offset2 = 0) {
  const readSum = Number.parseInt(new StringType(6).get(arrayBuffer, 148).replace(/\0.*$/, "").trim(), 8);
  if (Number.isNaN(readSum)) {
    return false;
  }
  let sum2 = 256;
  for (let index = offset2;index < offset2 + 148; index++) {
    sum2 += arrayBuffer[index];
  }
  for (let index = offset2 + 156;index < offset2 + 512; index++) {
    sum2 += arrayBuffer[index];
  }
  return readSum === sum2;
}
var uint32SyncSafeToken;
var init_util = __esm2(() => {
  init_lib4();
  uint32SyncSafeToken = {
    get: (buffer, offset2) => buffer[offset2 + 3] & 127 | buffer[offset2 + 2] << 7 | buffer[offset2 + 1] << 14 | buffer[offset2] << 21,
    len: 4
  };
});
var extensions4;
var mimeTypes;
var init_supported = __esm2(() => {
  extensions4 = [
    "jpg",
    "png",
    "apng",
    "gif",
    "webp",
    "flif",
    "xcf",
    "cr2",
    "cr3",
    "orf",
    "arw",
    "dng",
    "nef",
    "rw2",
    "raf",
    "tif",
    "bmp",
    "icns",
    "jxr",
    "psd",
    "indd",
    "zip",
    "tar",
    "rar",
    "gz",
    "bz2",
    "7z",
    "dmg",
    "mp4",
    "mid",
    "mkv",
    "webm",
    "mov",
    "avi",
    "mpg",
    "mp2",
    "mp3",
    "m4a",
    "oga",
    "ogg",
    "ogv",
    "opus",
    "flac",
    "wav",
    "spx",
    "amr",
    "pdf",
    "epub",
    "elf",
    "macho",
    "exe",
    "swf",
    "rtf",
    "wasm",
    "woff",
    "woff2",
    "eot",
    "ttf",
    "otf",
    "ico",
    "flv",
    "ps",
    "xz",
    "sqlite",
    "nes",
    "crx",
    "xpi",
    "cab",
    "deb",
    "ar",
    "rpm",
    "Z",
    "lz",
    "cfb",
    "mxf",
    "mts",
    "blend",
    "bpg",
    "docx",
    "pptx",
    "xlsx",
    "3gp",
    "3g2",
    "j2c",
    "jp2",
    "jpm",
    "jpx",
    "mj2",
    "aif",
    "qcp",
    "odt",
    "ods",
    "odp",
    "xml",
    "mobi",
    "heic",
    "cur",
    "ktx",
    "ape",
    "wv",
    "dcm",
    "ics",
    "glb",
    "pcap",
    "dsf",
    "lnk",
    "alias",
    "voc",
    "ac3",
    "m4v",
    "m4p",
    "m4b",
    "f4v",
    "f4p",
    "f4b",
    "f4a",
    "mie",
    "asf",
    "ogm",
    "ogx",
    "mpc",
    "arrow",
    "shp",
    "aac",
    "mp1",
    "it",
    "s3m",
    "xm",
    "ai",
    "skp",
    "avif",
    "eps",
    "lzh",
    "pgp",
    "asar",
    "stl",
    "chm",
    "3mf",
    "zst",
    "jxl",
    "vcf",
    "jls",
    "pst",
    "dwg",
    "parquet",
    "class",
    "arj",
    "cpio",
    "ace",
    "avro",
    "icc",
    "fbx",
    "vsdx",
    "vtt",
    "apk"
  ];
  mimeTypes = [
    "image/jpeg",
    "image/png",
    "image/gif",
    "image/webp",
    "image/flif",
    "image/x-xcf",
    "image/x-canon-cr2",
    "image/x-canon-cr3",
    "image/tiff",
    "image/bmp",
    "image/vnd.ms-photo",
    "image/vnd.adobe.photoshop",
    "application/x-indesign",
    "application/epub+zip",
    "application/x-xpinstall",
    "application/vnd.oasis.opendocument.text",
    "application/vnd.oasis.opendocument.spreadsheet",
    "application/vnd.oasis.opendocument.presentation",
    "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
    "application/vnd.openxmlformats-officedocument.presentationml.presentation",
    "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
    "application/zip",
    "application/x-tar",
    "application/x-rar-compressed",
    "application/gzip",
    "application/x-bzip2",
    "application/x-7z-compressed",
    "application/x-apple-diskimage",
    "application/x-apache-arrow",
    "video/mp4",
    "audio/midi",
    "video/x-matroska",
    "video/webm",
    "video/quicktime",
    "video/vnd.avi",
    "audio/wav",
    "audio/qcelp",
    "audio/x-ms-asf",
    "video/x-ms-asf",
    "application/vnd.ms-asf",
    "video/mpeg",
    "video/3gpp",
    "audio/mpeg",
    "audio/mp4",
    "video/ogg",
    "audio/ogg",
    "audio/ogg; codecs=opus",
    "application/ogg",
    "audio/x-flac",
    "audio/ape",
    "audio/wavpack",
    "audio/amr",
    "application/pdf",
    "application/x-elf",
    "application/x-mach-binary",
    "application/x-msdownload",
    "application/x-shockwave-flash",
    "application/rtf",
    "application/wasm",
    "font/woff",
    "font/woff2",
    "application/vnd.ms-fontobject",
    "font/ttf",
    "font/otf",
    "image/x-icon",
    "video/x-flv",
    "application/postscript",
    "application/eps",
    "application/x-xz",
    "application/x-sqlite3",
    "application/x-nintendo-nes-rom",
    "application/x-google-chrome-extension",
    "application/vnd.ms-cab-compressed",
    "application/x-deb",
    "application/x-unix-archive",
    "application/x-rpm",
    "application/x-compress",
    "application/x-lzip",
    "application/x-cfb",
    "application/x-mie",
    "application/mxf",
    "video/mp2t",
    "application/x-blender",
    "image/bpg",
    "image/j2c",
    "image/jp2",
    "image/jpx",
    "image/jpm",
    "image/mj2",
    "audio/aiff",
    "application/xml",
    "application/x-mobipocket-ebook",
    "image/heif",
    "image/heif-sequence",
    "image/heic",
    "image/heic-sequence",
    "image/icns",
    "image/ktx",
    "application/dicom",
    "audio/x-musepack",
    "text/calendar",
    "text/vcard",
    "text/vtt",
    "model/gltf-binary",
    "application/vnd.tcpdump.pcap",
    "audio/x-dsf",
    "application/x.ms.shortcut",
    "application/x.apple.alias",
    "audio/x-voc",
    "audio/vnd.dolby.dd-raw",
    "audio/x-m4a",
    "image/apng",
    "image/x-olympus-orf",
    "image/x-sony-arw",
    "image/x-adobe-dng",
    "image/x-nikon-nef",
    "image/x-panasonic-rw2",
    "image/x-fujifilm-raf",
    "video/x-m4v",
    "video/3gpp2",
    "application/x-esri-shape",
    "audio/aac",
    "audio/x-it",
    "audio/x-s3m",
    "audio/x-xm",
    "video/MP1S",
    "video/MP2P",
    "application/vnd.sketchup.skp",
    "image/avif",
    "application/x-lzh-compressed",
    "application/pgp-encrypted",
    "application/x-asar",
    "model/stl",
    "application/vnd.ms-htmlhelp",
    "model/3mf",
    "image/jxl",
    "application/zstd",
    "image/jls",
    "application/vnd.ms-outlook",
    "image/vnd.dwg",
    "application/x-parquet",
    "application/java-vm",
    "application/x-arj",
    "application/x-cpio",
    "application/x-ace-compressed",
    "application/avro",
    "application/vnd.iccprofile",
    "application/x.autodesk.fbx",
    "application/vnd.visio",
    "application/vnd.android.package-archive"
  ];
});
async function fileTypeFromBuffer2(input) {
  return new FileTypeParser().fromBuffer(input);
}
async function fileTypeFromBlob(blob) {
  return new FileTypeParser().fromBlob(blob);
}
function _check(buffer, headers, options3) {
  options3 = {
    offset: 0,
    ...options3
  };
  for (const [index, header] of headers.entries()) {
    if (options3.mask) {
      if (header !== (options3.mask[index] & buffer[index + options3.offset])) {
        return false;
      }
    } else if (header !== buffer[index + options3.offset]) {
      return false;
    }
  }
  return true;
}
async function fileTypeFromTokenizer(tokenizer3) {
  return new FileTypeParser().fromTokenizer(tokenizer3);
}

class FileTypeParser {
  constructor(options3) {
    this.detectors = options3?.customDetectors;
    this.tokenizerOptions = {
      abortSignal: options3?.signal
    };
    this.fromTokenizer = this.fromTokenizer.bind(this);
    this.fromBuffer = this.fromBuffer.bind(this);
    this.parse = this.parse.bind(this);
  }
  async fromTokenizer(tokenizer3) {
    const initialPosition = tokenizer3.position;
    for (const detector of this.detectors || []) {
      const fileType = await detector(tokenizer3);
      if (fileType) {
        return fileType;
      }
      if (initialPosition !== tokenizer3.position) {
        return;
      }
    }
    return this.parse(tokenizer3);
  }
  async fromBuffer(input) {
    if (!(input instanceof Uint8Array || input instanceof ArrayBuffer)) {
      throw new TypeError(`Expected the \`input\` argument to be of type \`Uint8Array\` or \`ArrayBuffer\`, got \`${typeof input}\``);
    }
    const buffer = input instanceof Uint8Array ? input : new Uint8Array(input);
    if (!(buffer?.length > 1)) {
      return;
    }
    return this.fromTokenizer(fromBuffer(buffer, this.tokenizerOptions));
  }
  async fromBlob(blob) {
    return this.fromStream(blob.stream());
  }
  async fromStream(stream2) {
    const tokenizer3 = await fromWebStream(stream2, this.tokenizerOptions);
    try {
      return await this.fromTokenizer(tokenizer3);
    } finally {
      await tokenizer3.close();
    }
  }
  async toDetectionStream(stream2, options3) {
    const { sampleSize = reasonableDetectionSizeInBytes } = options3;
    let detectedFileType;
    let firstChunk;
    const reader = stream2.getReader({ mode: "byob" });
    try {
      const { value: chunk, done } = await reader.read(new Uint8Array(sampleSize));
      firstChunk = chunk;
      if (!done && chunk) {
        try {
          detectedFileType = await this.fromBuffer(chunk.slice(0, sampleSize));
        } catch (error) {
          if (!(error instanceof EndOfStreamError)) {
            throw error;
          }
          detectedFileType = undefined;
        }
      }
      firstChunk = chunk;
    } finally {
      reader.releaseLock();
    }
    const transformStream = new TransformStream({
      async start(controller) {
        controller.enqueue(firstChunk);
      },
      transform(chunk, controller) {
        controller.enqueue(chunk);
      }
    });
    const newStream = stream2.pipeThrough(transformStream);
    newStream.fileType = detectedFileType;
    return newStream;
  }
  check(header, options3) {
    return _check(this.buffer, header, options3);
  }
  checkString(header, options3) {
    return this.check(stringToBytes(header), options3);
  }
  async parse(tokenizer3) {
    this.buffer = new Uint8Array(reasonableDetectionSizeInBytes);
    if (tokenizer3.fileInfo.size === undefined) {
      tokenizer3.fileInfo.size = Number.MAX_SAFE_INTEGER;
    }
    this.tokenizer = tokenizer3;
    await tokenizer3.peekBuffer(this.buffer, { length: 12, mayBeLess: true });
    if (this.check([66, 77])) {
      return {
        ext: "bmp",
        mime: "image/bmp"
      };
    }
    if (this.check([11, 119])) {
      return {
        ext: "ac3",
        mime: "audio/vnd.dolby.dd-raw"
      };
    }
    if (this.check([120, 1])) {
      return {
        ext: "dmg",
        mime: "application/x-apple-diskimage"
      };
    }
    if (this.check([77, 90])) {
      return {
        ext: "exe",
        mime: "application/x-msdownload"
      };
    }
    if (this.check([37, 33])) {
      await tokenizer3.peekBuffer(this.buffer, { length: 24, mayBeLess: true });
      if (this.checkString("PS-Adobe-", { offset: 2 }) && this.checkString(" EPSF-", { offset: 14 })) {
        return {
          ext: "eps",
          mime: "application/eps"
        };
      }
      return {
        ext: "ps",
        mime: "application/postscript"
      };
    }
    if (this.check([31, 160]) || this.check([31, 157])) {
      return {
        ext: "Z",
        mime: "application/x-compress"
      };
    }
    if (this.check([199, 113])) {
      return {
        ext: "cpio",
        mime: "application/x-cpio"
      };
    }
    if (this.check([96, 234])) {
      return {
        ext: "arj",
        mime: "application/x-arj"
      };
    }
    if (this.check([239, 187, 191])) {
      this.tokenizer.ignore(3);
      return this.parse(tokenizer3);
    }
    if (this.check([71, 73, 70])) {
      return {
        ext: "gif",
        mime: "image/gif"
      };
    }
    if (this.check([73, 73, 188])) {
      return {
        ext: "jxr",
        mime: "image/vnd.ms-photo"
      };
    }
    if (this.check([31, 139, 8])) {
      return {
        ext: "gz",
        mime: "application/gzip"
      };
    }
    if (this.check([66, 90, 104])) {
      return {
        ext: "bz2",
        mime: "application/x-bzip2"
      };
    }
    if (this.checkString("ID3")) {
      await tokenizer3.ignore(6);
      const id3HeaderLength = await tokenizer3.readToken(uint32SyncSafeToken);
      if (tokenizer3.position + id3HeaderLength > tokenizer3.fileInfo.size) {
        return {
          ext: "mp3",
          mime: "audio/mpeg"
        };
      }
      await tokenizer3.ignore(id3HeaderLength);
      return this.fromTokenizer(tokenizer3);
    }
    if (this.checkString("MP+")) {
      return {
        ext: "mpc",
        mime: "audio/x-musepack"
      };
    }
    if ((this.buffer[0] === 67 || this.buffer[0] === 70) && this.check([87, 83], { offset: 1 })) {
      return {
        ext: "swf",
        mime: "application/x-shockwave-flash"
      };
    }
    if (this.check([255, 216, 255])) {
      if (this.check([247], { offset: 3 })) {
        return {
          ext: "jls",
          mime: "image/jls"
        };
      }
      return {
        ext: "jpg",
        mime: "image/jpeg"
      };
    }
    if (this.check([79, 98, 106, 1])) {
      return {
        ext: "avro",
        mime: "application/avro"
      };
    }
    if (this.checkString("FLIF")) {
      return {
        ext: "flif",
        mime: "image/flif"
      };
    }
    if (this.checkString("8BPS")) {
      return {
        ext: "psd",
        mime: "image/vnd.adobe.photoshop"
      };
    }
    if (this.checkString("WEBP", { offset: 8 })) {
      return {
        ext: "webp",
        mime: "image/webp"
      };
    }
    if (this.checkString("MPCK")) {
      return {
        ext: "mpc",
        mime: "audio/x-musepack"
      };
    }
    if (this.checkString("FORM")) {
      return {
        ext: "aif",
        mime: "audio/aiff"
      };
    }
    if (this.checkString("icns", { offset: 0 })) {
      return {
        ext: "icns",
        mime: "image/icns"
      };
    }
    if (this.check([80, 75, 3, 4])) {
      try {
        while (tokenizer3.position + 30 < tokenizer3.fileInfo.size) {
          await tokenizer3.readBuffer(this.buffer, { length: 30 });
          const view = new DataView(this.buffer.buffer);
          const zipHeader = {
            compressedSize: view.getUint32(18, true),
            uncompressedSize: view.getUint32(22, true),
            filenameLength: view.getUint16(26, true),
            extraFieldLength: view.getUint16(28, true)
          };
          zipHeader.filename = await tokenizer3.readToken(new StringType(zipHeader.filenameLength, "utf-8"));
          await tokenizer3.ignore(zipHeader.extraFieldLength);
          if (/classes\d*\.dex/.test(zipHeader.filename)) {
            return {
              ext: "apk",
              mime: "application/vnd.android.package-archive"
            };
          }
          if (zipHeader.filename === "META-INF/mozilla.rsa") {
            return {
              ext: "xpi",
              mime: "application/x-xpinstall"
            };
          }
          if (zipHeader.filename.endsWith(".rels") || zipHeader.filename.endsWith(".xml")) {
            const type2 = zipHeader.filename.split("/")[0];
            switch (type2) {
              case "_rels":
                break;
              case "word":
                return {
                  ext: "docx",
                  mime: "application/vnd.openxmlformats-officedocument.wordprocessingml.document"
                };
              case "ppt":
                return {
                  ext: "pptx",
                  mime: "application/vnd.openxmlformats-officedocument.presentationml.presentation"
                };
              case "xl":
                return {
                  ext: "xlsx",
                  mime: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
                };
              case "visio":
                return {
                  ext: "vsdx",
                  mime: "application/vnd.visio"
                };
              default:
                break;
            }
          }
          if (zipHeader.filename.startsWith("xl/")) {
            return {
              ext: "xlsx",
              mime: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
            };
          }
          if (zipHeader.filename.startsWith("3D/") && zipHeader.filename.endsWith(".model")) {
            return {
              ext: "3mf",
              mime: "model/3mf"
            };
          }
          if (zipHeader.filename === "mimetype" && zipHeader.compressedSize === zipHeader.uncompressedSize) {
            let mimeType = await tokenizer3.readToken(new StringType(zipHeader.compressedSize, "utf-8"));
            mimeType = mimeType.trim();
            switch (mimeType) {
              case "application/epub+zip":
                return {
                  ext: "epub",
                  mime: "application/epub+zip"
                };
              case "application/vnd.oasis.opendocument.text":
                return {
                  ext: "odt",
                  mime: "application/vnd.oasis.opendocument.text"
                };
              case "application/vnd.oasis.opendocument.spreadsheet":
                return {
                  ext: "ods",
                  mime: "application/vnd.oasis.opendocument.spreadsheet"
                };
              case "application/vnd.oasis.opendocument.presentation":
                return {
                  ext: "odp",
                  mime: "application/vnd.oasis.opendocument.presentation"
                };
              default:
            }
          }
          if (zipHeader.compressedSize === 0) {
            let nextHeaderIndex = -1;
            while (nextHeaderIndex < 0 && tokenizer3.position < tokenizer3.fileInfo.size) {
              await tokenizer3.peekBuffer(this.buffer, { mayBeLess: true });
              nextHeaderIndex = indexOf(this.buffer, new Uint8Array([80, 75, 3, 4]));
              await tokenizer3.ignore(nextHeaderIndex >= 0 ? nextHeaderIndex : this.buffer.length);
            }
          } else {
            await tokenizer3.ignore(zipHeader.compressedSize);
          }
        }
      } catch (error) {
        if (!(error instanceof EndOfStreamError)) {
          throw error;
        }
      }
      return {
        ext: "zip",
        mime: "application/zip"
      };
    }
    if (this.checkString("OggS")) {
      await tokenizer3.ignore(28);
      const type2 = new Uint8Array(8);
      await tokenizer3.readBuffer(type2);
      if (_check(type2, [79, 112, 117, 115, 72, 101, 97, 100])) {
        return {
          ext: "opus",
          mime: "audio/ogg; codecs=opus"
        };
      }
      if (_check(type2, [128, 116, 104, 101, 111, 114, 97])) {
        return {
          ext: "ogv",
          mime: "video/ogg"
        };
      }
      if (_check(type2, [1, 118, 105, 100, 101, 111, 0])) {
        return {
          ext: "ogm",
          mime: "video/ogg"
        };
      }
      if (_check(type2, [127, 70, 76, 65, 67])) {
        return {
          ext: "oga",
          mime: "audio/ogg"
        };
      }
      if (_check(type2, [83, 112, 101, 101, 120, 32, 32])) {
        return {
          ext: "spx",
          mime: "audio/ogg"
        };
      }
      if (_check(type2, [1, 118, 111, 114, 98, 105, 115])) {
        return {
          ext: "ogg",
          mime: "audio/ogg"
        };
      }
      return {
        ext: "ogx",
        mime: "application/ogg"
      };
    }
    if (this.check([80, 75]) && (this.buffer[2] === 3 || this.buffer[2] === 5 || this.buffer[2] === 7) && (this.buffer[3] === 4 || this.buffer[3] === 6 || this.buffer[3] === 8)) {
      return {
        ext: "zip",
        mime: "application/zip"
      };
    }
    if (this.checkString("ftyp", { offset: 4 }) && (this.buffer[8] & 96) !== 0) {
      const brandMajor = new StringType(4, "latin1").get(this.buffer, 8).replace("\0", " ").trim();
      switch (brandMajor) {
        case "avif":
        case "avis":
          return { ext: "avif", mime: "image/avif" };
        case "mif1":
          return { ext: "heic", mime: "image/heif" };
        case "msf1":
          return { ext: "heic", mime: "image/heif-sequence" };
        case "heic":
        case "heix":
          return { ext: "heic", mime: "image/heic" };
        case "hevc":
        case "hevx":
          return { ext: "heic", mime: "image/heic-sequence" };
        case "qt":
          return { ext: "mov", mime: "video/quicktime" };
        case "M4V":
        case "M4VH":
        case "M4VP":
          return { ext: "m4v", mime: "video/x-m4v" };
        case "M4P":
          return { ext: "m4p", mime: "video/mp4" };
        case "M4B":
          return { ext: "m4b", mime: "audio/mp4" };
        case "M4A":
          return { ext: "m4a", mime: "audio/x-m4a" };
        case "F4V":
          return { ext: "f4v", mime: "video/mp4" };
        case "F4P":
          return { ext: "f4p", mime: "video/mp4" };
        case "F4A":
          return { ext: "f4a", mime: "audio/mp4" };
        case "F4B":
          return { ext: "f4b", mime: "audio/mp4" };
        case "crx":
          return { ext: "cr3", mime: "image/x-canon-cr3" };
        default:
          if (brandMajor.startsWith("3g")) {
            if (brandMajor.startsWith("3g2")) {
              return { ext: "3g2", mime: "video/3gpp2" };
            }
            return { ext: "3gp", mime: "video/3gpp" };
          }
          return { ext: "mp4", mime: "video/mp4" };
      }
    }
    if (this.checkString("MThd")) {
      return {
        ext: "mid",
        mime: "audio/midi"
      };
    }
    if (this.checkString("wOFF") && (this.check([0, 1, 0, 0], { offset: 4 }) || this.checkString("OTTO", { offset: 4 }))) {
      return {
        ext: "woff",
        mime: "font/woff"
      };
    }
    if (this.checkString("wOF2") && (this.check([0, 1, 0, 0], { offset: 4 }) || this.checkString("OTTO", { offset: 4 }))) {
      return {
        ext: "woff2",
        mime: "font/woff2"
      };
    }
    if (this.check([212, 195, 178, 161]) || this.check([161, 178, 195, 212])) {
      return {
        ext: "pcap",
        mime: "application/vnd.tcpdump.pcap"
      };
    }
    if (this.checkString("DSD ")) {
      return {
        ext: "dsf",
        mime: "audio/x-dsf"
      };
    }
    if (this.checkString("LZIP")) {
      return {
        ext: "lz",
        mime: "application/x-lzip"
      };
    }
    if (this.checkString("fLaC")) {
      return {
        ext: "flac",
        mime: "audio/x-flac"
      };
    }
    if (this.check([66, 80, 71, 251])) {
      return {
        ext: "bpg",
        mime: "image/bpg"
      };
    }
    if (this.checkString("wvpk")) {
      return {
        ext: "wv",
        mime: "audio/wavpack"
      };
    }
    if (this.checkString("%PDF")) {
      try {
        await tokenizer3.ignore(1350);
        const maxBufferSize2 = 10485760;
        const buffer = new Uint8Array(Math.min(maxBufferSize2, tokenizer3.fileInfo.size));
        await tokenizer3.readBuffer(buffer, { mayBeLess: true });
        if (includes(buffer, new TextEncoder().encode("AIPrivateData"))) {
          return {
            ext: "ai",
            mime: "application/postscript"
          };
        }
      } catch (error) {
        if (!(error instanceof EndOfStreamError)) {
          throw error;
        }
      }
      return {
        ext: "pdf",
        mime: "application/pdf"
      };
    }
    if (this.check([0, 97, 115, 109])) {
      return {
        ext: "wasm",
        mime: "application/wasm"
      };
    }
    if (this.check([73, 73])) {
      const fileType = await this.readTiffHeader(false);
      if (fileType) {
        return fileType;
      }
    }
    if (this.check([77, 77])) {
      const fileType = await this.readTiffHeader(true);
      if (fileType) {
        return fileType;
      }
    }
    if (this.checkString("MAC ")) {
      return {
        ext: "ape",
        mime: "audio/ape"
      };
    }
    if (this.check([26, 69, 223, 163])) {
      async function readField() {
        const msb = await tokenizer3.peekNumber(UINT8);
        let mask = 128;
        let ic = 0;
        while ((msb & mask) === 0 && mask !== 0) {
          ++ic;
          mask >>= 1;
        }
        const id = new Uint8Array(ic + 1);
        await tokenizer3.readBuffer(id);
        return id;
      }
      async function readElement() {
        const idField = await readField();
        const lengthField = await readField();
        lengthField[0] ^= 128 >> lengthField.length - 1;
        const nrLength = Math.min(6, lengthField.length);
        const idView = new DataView(idField.buffer);
        const lengthView = new DataView(lengthField.buffer, lengthField.length - nrLength, nrLength);
        return {
          id: getUintBE(idView),
          len: getUintBE(lengthView)
        };
      }
      async function readChildren(children) {
        while (children > 0) {
          const element = await readElement();
          if (element.id === 17026) {
            const rawValue = await tokenizer3.readToken(new StringType(element.len));
            return rawValue.replaceAll(/\00.*$/g, "");
          }
          await tokenizer3.ignore(element.len);
          --children;
        }
      }
      const re = await readElement();
      const docType = await readChildren(re.len);
      switch (docType) {
        case "webm":
          return {
            ext: "webm",
            mime: "video/webm"
          };
        case "matroska":
          return {
            ext: "mkv",
            mime: "video/x-matroska"
          };
        default:
          return;
      }
    }
    if (this.check([82, 73, 70, 70])) {
      if (this.check([65, 86, 73], { offset: 8 })) {
        return {
          ext: "avi",
          mime: "video/vnd.avi"
        };
      }
      if (this.check([87, 65, 86, 69], { offset: 8 })) {
        return {
          ext: "wav",
          mime: "audio/wav"
        };
      }
      if (this.check([81, 76, 67, 77], { offset: 8 })) {
        return {
          ext: "qcp",
          mime: "audio/qcelp"
        };
      }
    }
    if (this.checkString("SQLi")) {
      return {
        ext: "sqlite",
        mime: "application/x-sqlite3"
      };
    }
    if (this.check([78, 69, 83, 26])) {
      return {
        ext: "nes",
        mime: "application/x-nintendo-nes-rom"
      };
    }
    if (this.checkString("Cr24")) {
      return {
        ext: "crx",
        mime: "application/x-google-chrome-extension"
      };
    }
    if (this.checkString("MSCF") || this.checkString("ISc(")) {
      return {
        ext: "cab",
        mime: "application/vnd.ms-cab-compressed"
      };
    }
    if (this.check([237, 171, 238, 219])) {
      return {
        ext: "rpm",
        mime: "application/x-rpm"
      };
    }
    if (this.check([197, 208, 211, 198])) {
      return {
        ext: "eps",
        mime: "application/eps"
      };
    }
    if (this.check([40, 181, 47, 253])) {
      return {
        ext: "zst",
        mime: "application/zstd"
      };
    }
    if (this.check([127, 69, 76, 70])) {
      return {
        ext: "elf",
        mime: "application/x-elf"
      };
    }
    if (this.check([33, 66, 68, 78])) {
      return {
        ext: "pst",
        mime: "application/vnd.ms-outlook"
      };
    }
    if (this.checkString("PAR1")) {
      return {
        ext: "parquet",
        mime: "application/x-parquet"
      };
    }
    if (this.check([207, 250, 237, 254])) {
      return {
        ext: "macho",
        mime: "application/x-mach-binary"
      };
    }
    if (this.check([79, 84, 84, 79, 0])) {
      return {
        ext: "otf",
        mime: "font/otf"
      };
    }
    if (this.checkString("#!AMR")) {
      return {
        ext: "amr",
        mime: "audio/amr"
      };
    }
    if (this.checkString("{\\rtf")) {
      return {
        ext: "rtf",
        mime: "application/rtf"
      };
    }
    if (this.check([70, 76, 86, 1])) {
      return {
        ext: "flv",
        mime: "video/x-flv"
      };
    }
    if (this.checkString("IMPM")) {
      return {
        ext: "it",
        mime: "audio/x-it"
      };
    }
    if (this.checkString("-lh0-", { offset: 2 }) || this.checkString("-lh1-", { offset: 2 }) || this.checkString("-lh2-", { offset: 2 }) || this.checkString("-lh3-", { offset: 2 }) || this.checkString("-lh4-", { offset: 2 }) || this.checkString("-lh5-", { offset: 2 }) || this.checkString("-lh6-", { offset: 2 }) || this.checkString("-lh7-", { offset: 2 }) || this.checkString("-lzs-", { offset: 2 }) || this.checkString("-lz4-", { offset: 2 }) || this.checkString("-lz5-", { offset: 2 }) || this.checkString("-lhd-", { offset: 2 })) {
      return {
        ext: "lzh",
        mime: "application/x-lzh-compressed"
      };
    }
    if (this.check([0, 0, 1, 186])) {
      if (this.check([33], { offset: 4, mask: [241] })) {
        return {
          ext: "mpg",
          mime: "video/MP1S"
        };
      }
      if (this.check([68], { offset: 4, mask: [196] })) {
        return {
          ext: "mpg",
          mime: "video/MP2P"
        };
      }
    }
    if (this.checkString("ITSF")) {
      return {
        ext: "chm",
        mime: "application/vnd.ms-htmlhelp"
      };
    }
    if (this.check([202, 254, 186, 190])) {
      return {
        ext: "class",
        mime: "application/java-vm"
      };
    }
    if (this.check([253, 55, 122, 88, 90, 0])) {
      return {
        ext: "xz",
        mime: "application/x-xz"
      };
    }
    if (this.checkString("<?xml ")) {
      return {
        ext: "xml",
        mime: "application/xml"
      };
    }
    if (this.check([55, 122, 188, 175, 39, 28])) {
      return {
        ext: "7z",
        mime: "application/x-7z-compressed"
      };
    }
    if (this.check([82, 97, 114, 33, 26, 7]) && (this.buffer[6] === 0 || this.buffer[6] === 1)) {
      return {
        ext: "rar",
        mime: "application/x-rar-compressed"
      };
    }
    if (this.checkString("solid ")) {
      return {
        ext: "stl",
        mime: "model/stl"
      };
    }
    if (this.checkString("AC")) {
      const version6 = new StringType(4, "latin1").get(this.buffer, 2);
      if (version6.match("^d*") && version6 >= 1000 && version6 <= 1050) {
        return {
          ext: "dwg",
          mime: "image/vnd.dwg"
        };
      }
    }
    if (this.checkString("070707")) {
      return {
        ext: "cpio",
        mime: "application/x-cpio"
      };
    }
    if (this.checkString("BLENDER")) {
      return {
        ext: "blend",
        mime: "application/x-blender"
      };
    }
    if (this.checkString("!<arch>")) {
      await tokenizer3.ignore(8);
      const string2 = await tokenizer3.readToken(new StringType(13, "ascii"));
      if (string2 === "debian-binary") {
        return {
          ext: "deb",
          mime: "application/x-deb"
        };
      }
      return {
        ext: "ar",
        mime: "application/x-unix-archive"
      };
    }
    if (this.checkString("WEBVTT") && ["\n", "\r", "\t", " ", "\0"].some((char7) => this.checkString(char7, { offset: 6 }))) {
      return {
        ext: "vtt",
        mime: "text/vtt"
      };
    }
    if (this.check([137, 80, 78, 71, 13, 10, 26, 10])) {
      await tokenizer3.ignore(8);
      async function readChunkHeader() {
        return {
          length: await tokenizer3.readToken(INT32_BE),
          type: await tokenizer3.readToken(new StringType(4, "latin1"))
        };
      }
      do {
        const chunk = await readChunkHeader();
        if (chunk.length < 0) {
          return;
        }
        switch (chunk.type) {
          case "IDAT":
            return {
              ext: "png",
              mime: "image/png"
            };
          case "acTL":
            return {
              ext: "apng",
              mime: "image/apng"
            };
          default:
            await tokenizer3.ignore(chunk.length + 4);
        }
      } while (tokenizer3.position + 8 < tokenizer3.fileInfo.size);
      return {
        ext: "png",
        mime: "image/png"
      };
    }
    if (this.check([65, 82, 82, 79, 87, 49, 0, 0])) {
      return {
        ext: "arrow",
        mime: "application/x-apache-arrow"
      };
    }
    if (this.check([103, 108, 84, 70, 2, 0, 0, 0])) {
      return {
        ext: "glb",
        mime: "model/gltf-binary"
      };
    }
    if (this.check([102, 114, 101, 101], { offset: 4 }) || this.check([109, 100, 97, 116], { offset: 4 }) || this.check([109, 111, 111, 118], { offset: 4 }) || this.check([119, 105, 100, 101], { offset: 4 })) {
      return {
        ext: "mov",
        mime: "video/quicktime"
      };
    }
    if (this.check([73, 73, 82, 79, 8, 0, 0, 0, 24])) {
      return {
        ext: "orf",
        mime: "image/x-olympus-orf"
      };
    }
    if (this.checkString("gimp xcf ")) {
      return {
        ext: "xcf",
        mime: "image/x-xcf"
      };
    }
    if (this.check([73, 73, 85, 0, 24, 0, 0, 0, 136, 231, 116, 216])) {
      return {
        ext: "rw2",
        mime: "image/x-panasonic-rw2"
      };
    }
    if (this.check([48, 38, 178, 117, 142, 102, 207, 17, 166, 217])) {
      async function readHeader() {
        const guid = new Uint8Array(16);
        await tokenizer3.readBuffer(guid);
        return {
          id: guid,
          size: Number(await tokenizer3.readToken(UINT64_LE))
        };
      }
      await tokenizer3.ignore(30);
      while (tokenizer3.position + 24 < tokenizer3.fileInfo.size) {
        const header = await readHeader();
        let payload = header.size - 24;
        if (_check(header.id, [145, 7, 220, 183, 183, 169, 207, 17, 142, 230, 0, 192, 12, 32, 83, 101])) {
          const typeId = new Uint8Array(16);
          payload -= await tokenizer3.readBuffer(typeId);
          if (_check(typeId, [64, 158, 105, 248, 77, 91, 207, 17, 168, 253, 0, 128, 95, 92, 68, 43])) {
            return {
              ext: "asf",
              mime: "audio/x-ms-asf"
            };
          }
          if (_check(typeId, [192, 239, 25, 188, 77, 91, 207, 17, 168, 253, 0, 128, 95, 92, 68, 43])) {
            return {
              ext: "asf",
              mime: "video/x-ms-asf"
            };
          }
          break;
        }
        await tokenizer3.ignore(payload);
      }
      return {
        ext: "asf",
        mime: "application/vnd.ms-asf"
      };
    }
    if (this.check([171, 75, 84, 88, 32, 49, 49, 187, 13, 10, 26, 10])) {
      return {
        ext: "ktx",
        mime: "image/ktx"
      };
    }
    if ((this.check([126, 16, 4]) || this.check([126, 24, 4])) && this.check([48, 77, 73, 69], { offset: 4 })) {
      return {
        ext: "mie",
        mime: "application/x-mie"
      };
    }
    if (this.check([39, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], { offset: 2 })) {
      return {
        ext: "shp",
        mime: "application/x-esri-shape"
      };
    }
    if (this.check([255, 79, 255, 81])) {
      return {
        ext: "j2c",
        mime: "image/j2c"
      };
    }
    if (this.check([0, 0, 0, 12, 106, 80, 32, 32, 13, 10, 135, 10])) {
      await tokenizer3.ignore(20);
      const type2 = await tokenizer3.readToken(new StringType(4, "ascii"));
      switch (type2) {
        case "jp2 ":
          return {
            ext: "jp2",
            mime: "image/jp2"
          };
        case "jpx ":
          return {
            ext: "jpx",
            mime: "image/jpx"
          };
        case "jpm ":
          return {
            ext: "jpm",
            mime: "image/jpm"
          };
        case "mjp2":
          return {
            ext: "mj2",
            mime: "image/mj2"
          };
        default:
          return;
      }
    }
    if (this.check([255, 10]) || this.check([0, 0, 0, 12, 74, 88, 76, 32, 13, 10, 135, 10])) {
      return {
        ext: "jxl",
        mime: "image/jxl"
      };
    }
    if (this.check([254, 255])) {
      if (this.check([0, 60, 0, 63, 0, 120, 0, 109, 0, 108], { offset: 2 })) {
        return {
          ext: "xml",
          mime: "application/xml"
        };
      }
      return;
    }
    if (this.check([0, 0, 1, 186]) || this.check([0, 0, 1, 179])) {
      return {
        ext: "mpg",
        mime: "video/mpeg"
      };
    }
    if (this.check([0, 1, 0, 0, 0])) {
      return {
        ext: "ttf",
        mime: "font/ttf"
      };
    }
    if (this.check([0, 0, 1, 0])) {
      return {
        ext: "ico",
        mime: "image/x-icon"
      };
    }
    if (this.check([0, 0, 2, 0])) {
      return {
        ext: "cur",
        mime: "image/x-icon"
      };
    }
    if (this.check([208, 207, 17, 224, 161, 177, 26, 225])) {
      return {
        ext: "cfb",
        mime: "application/x-cfb"
      };
    }
    await tokenizer3.peekBuffer(this.buffer, { length: Math.min(256, tokenizer3.fileInfo.size), mayBeLess: true });
    if (this.check([97, 99, 115, 112], { offset: 36 })) {
      return {
        ext: "icc",
        mime: "application/vnd.iccprofile"
      };
    }
    if (this.checkString("**ACE", { offset: 7 }) && this.checkString("**", { offset: 12 })) {
      return {
        ext: "ace",
        mime: "application/x-ace-compressed"
      };
    }
    if (this.checkString("BEGIN:")) {
      if (this.checkString("VCARD", { offset: 6 })) {
        return {
          ext: "vcf",
          mime: "text/vcard"
        };
      }
      if (this.checkString("VCALENDAR", { offset: 6 })) {
        return {
          ext: "ics",
          mime: "text/calendar"
        };
      }
    }
    if (this.checkString("FUJIFILMCCD-RAW")) {
      return {
        ext: "raf",
        mime: "image/x-fujifilm-raf"
      };
    }
    if (this.checkString("Extended Module:")) {
      return {
        ext: "xm",
        mime: "audio/x-xm"
      };
    }
    if (this.checkString("Creative Voice File")) {
      return {
        ext: "voc",
        mime: "audio/x-voc"
      };
    }
    if (this.check([4, 0, 0, 0]) && this.buffer.length >= 16) {
      const jsonSize = new DataView(this.buffer.buffer).getUint32(12, true);
      if (jsonSize > 12 && this.buffer.length >= jsonSize + 16) {
        try {
          const header = new TextDecoder().decode(this.buffer.slice(16, jsonSize + 16));
          const json2 = JSON.parse(header);
          if (json2.files) {
            return {
              ext: "asar",
              mime: "application/x-asar"
            };
          }
        } catch {
        }
      }
    }
    if (this.check([6, 14, 43, 52, 2, 5, 1, 1, 13, 1, 2, 1, 1, 2])) {
      return {
        ext: "mxf",
        mime: "application/mxf"
      };
    }
    if (this.checkString("SCRM", { offset: 44 })) {
      return {
        ext: "s3m",
        mime: "audio/x-s3m"
      };
    }
    if (this.check([71]) && this.check([71], { offset: 188 })) {
      return {
        ext: "mts",
        mime: "video/mp2t"
      };
    }
    if (this.check([71], { offset: 4 }) && this.check([71], { offset: 196 })) {
      return {
        ext: "mts",
        mime: "video/mp2t"
      };
    }
    if (this.check([66, 79, 79, 75, 77, 79, 66, 73], { offset: 60 })) {
      return {
        ext: "mobi",
        mime: "application/x-mobipocket-ebook"
      };
    }
    if (this.check([68, 73, 67, 77], { offset: 128 })) {
      return {
        ext: "dcm",
        mime: "application/dicom"
      };
    }
    if (this.check([76, 0, 0, 0, 1, 20, 2, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 70])) {
      return {
        ext: "lnk",
        mime: "application/x.ms.shortcut"
      };
    }
    if (this.check([98, 111, 111, 107, 0, 0, 0, 0, 109, 97, 114, 107, 0, 0, 0, 0])) {
      return {
        ext: "alias",
        mime: "application/x.apple.alias"
      };
    }
    if (this.checkString("Kaydara FBX Binary  \0")) {
      return {
        ext: "fbx",
        mime: "application/x.autodesk.fbx"
      };
    }
    if (this.check([76, 80], { offset: 34 }) && (this.check([0, 0, 1], { offset: 8 }) || this.check([1, 0, 2], { offset: 8 }) || this.check([2, 0, 2], { offset: 8 }))) {
      return {
        ext: "eot",
        mime: "application/vnd.ms-fontobject"
      };
    }
    if (this.check([6, 6, 237, 245, 216, 29, 70, 229, 189, 49, 239, 231, 254, 116, 183, 29])) {
      return {
        ext: "indd",
        mime: "application/x-indesign"
      };
    }
    await tokenizer3.peekBuffer(this.buffer, { length: Math.min(512, tokenizer3.fileInfo.size), mayBeLess: true });
    if (tarHeaderChecksumMatches(this.buffer)) {
      return {
        ext: "tar",
        mime: "application/x-tar"
      };
    }
    if (this.check([255, 254])) {
      if (this.check([60, 0, 63, 0, 120, 0, 109, 0, 108, 0], { offset: 2 })) {
        return {
          ext: "xml",
          mime: "application/xml"
        };
      }
      if (this.check([255, 14, 83, 0, 107, 0, 101, 0, 116, 0, 99, 0, 104, 0, 85, 0, 112, 0, 32, 0, 77, 0, 111, 0, 100, 0, 101, 0, 108, 0], { offset: 2 })) {
        return {
          ext: "skp",
          mime: "application/vnd.sketchup.skp"
        };
      }
      return;
    }
    if (this.checkString("-----BEGIN PGP MESSAGE-----")) {
      return {
        ext: "pgp",
        mime: "application/pgp-encrypted"
      };
    }
    if (this.buffer.length >= 2 && this.check([255, 224], { offset: 0, mask: [255, 224] })) {
      if (this.check([16], { offset: 1, mask: [22] })) {
        if (this.check([8], { offset: 1, mask: [8] })) {
          return {
            ext: "aac",
            mime: "audio/aac"
          };
        }
        return {
          ext: "aac",
          mime: "audio/aac"
        };
      }
      if (this.check([2], { offset: 1, mask: [6] })) {
        return {
          ext: "mp3",
          mime: "audio/mpeg"
        };
      }
      if (this.check([4], { offset: 1, mask: [6] })) {
        return {
          ext: "mp2",
          mime: "audio/mpeg"
        };
      }
      if (this.check([6], { offset: 1, mask: [6] })) {
        return {
          ext: "mp1",
          mime: "audio/mpeg"
        };
      }
    }
  }
  async readTiffTag(bigEndian) {
    const tagId = await this.tokenizer.readToken(bigEndian ? UINT16_BE : UINT16_LE);
    this.tokenizer.ignore(10);
    switch (tagId) {
      case 50341:
        return {
          ext: "arw",
          mime: "image/x-sony-arw"
        };
      case 50706:
        return {
          ext: "dng",
          mime: "image/x-adobe-dng"
        };
      default:
    }
  }
  async readTiffIFD(bigEndian) {
    const numberOfTags = await this.tokenizer.readToken(bigEndian ? UINT16_BE : UINT16_LE);
    for (let n5 = 0;n5 < numberOfTags; ++n5) {
      const fileType = await this.readTiffTag(bigEndian);
      if (fileType) {
        return fileType;
      }
    }
  }
  async readTiffHeader(bigEndian) {
    const version6 = (bigEndian ? UINT16_BE : UINT16_LE).get(this.buffer, 2);
    const ifdOffset = (bigEndian ? UINT32_BE : UINT32_LE).get(this.buffer, 4);
    if (version6 === 42) {
      if (ifdOffset >= 6) {
        if (this.checkString("CR", { offset: 8 })) {
          return {
            ext: "cr2",
            mime: "image/x-canon-cr2"
          };
        }
        if (ifdOffset >= 8 && (this.check([28, 0, 254, 0], { offset: 8 }) || this.check([31, 0, 11, 0], { offset: 8 }))) {
          return {
            ext: "nef",
            mime: "image/x-nikon-nef"
          };
        }
      }
      await this.tokenizer.ignore(ifdOffset);
      const fileType = await this.readTiffIFD(bigEndian);
      return fileType ?? {
        ext: "tif",
        mime: "image/tiff"
      };
    }
    if (version6 === 43) {
      return {
        ext: "tif",
        mime: "image/tiff"
      };
    }
  }
}
var reasonableDetectionSizeInBytes = 4100;
var supportedExtensions2;
var supportedMimeTypes;
var init_core3 = __esm2(() => {
  init_lib4();
  init_core22();
  init_uint8array_extras();
  init_util();
  init_supported();
  supportedExtensions2 = new Set(extensions4);
  supportedMimeTypes = new Set(mimeTypes);
});
var exports_file_type = {};
__export3(exports_file_type, {
  supportedMimeTypes: () => supportedMimeTypes,
  supportedExtensions: () => supportedExtensions2,
  fileTypeStream: () => fileTypeStream,
  fileTypeFromTokenizer: () => fileTypeFromTokenizer,
  fileTypeFromStream: () => fileTypeFromStream,
  fileTypeFromFile: () => fileTypeFromFile2,
  fileTypeFromBuffer: () => fileTypeFromBuffer2,
  fileTypeFromBlob: () => fileTypeFromBlob,
  NodeFileTypeParser: () => NodeFileTypeParser,
  FileTypeParser: () => FileTypeParser
});
async function fileTypeFromFile2(path5, fileTypeOptions) {
  return new NodeFileTypeParser(fileTypeOptions).fromFile(path5, fileTypeOptions);
}
async function fileTypeFromStream(stream2, fileTypeOptions) {
  return new NodeFileTypeParser(fileTypeOptions).fromStream(stream2);
}
async function fileTypeStream(readableStream, options3 = {}) {
  return new NodeFileTypeParser(options3).toDetectionStream(readableStream, options3);
}
var NodeFileTypeParser;
var init_file_type = __esm2(() => {
  init_lib3();
  init_core3();
  init_core3();
  NodeFileTypeParser = class NodeFileTypeParser2 extends FileTypeParser {
    async fromStream(stream2) {
      const tokenizer3 = await (stream2 instanceof WebReadableStream ? fromWebStream(stream2, this.tokenizerOptions) : fromStream2(stream2, this.tokenizerOptions));
      try {
        return await super.fromTokenizer(tokenizer3);
      } finally {
        await tokenizer3.close();
      }
    }
    async fromFile(path5) {
      const tokenizer3 = await fromFile(path5);
      try {
        return await super.fromTokenizer(tokenizer3);
      } finally {
        await tokenizer3.close();
      }
    }
    async toDetectionStream(readableStream, options3 = {}) {
      if (!(readableStream instanceof Readable9)) {
        return super.toDetectionStream(readableStream, options3);
      }
      const { sampleSize = reasonableDetectionSizeInBytes } = options3;
      return new Promise((resolve5, reject) => {
        readableStream.on("error", reject);
        readableStream.once("readable", () => {
          (async () => {
            try {
              const pass2 = new PassThrough3;
              const outputStream = pipeline ? pipeline(readableStream, pass2, () => {
              }) : readableStream.pipe(pass2);
              const chunk = readableStream.read(sampleSize) ?? readableStream.read() ?? new Uint8Array(0);
              try {
                pass2.fileType = await this.fromBuffer(chunk);
              } catch (error) {
                if (error instanceof EndOfStreamError) {
                  pass2.fileType = undefined;
                } else {
                  reject(error);
                }
              }
              resolve5(outputStream);
            } catch (error) {
              reject(error);
            }
          })();
        });
      });
    }
  };
});

class InMemoryStorageAdapter {
  timestampResolver;
  entries = new Map;
  constructor(timestampResolver = () => Date.now()) {
    this.timestampResolver = timestampResolver;
  }
  deleteEverything() {
    this.entries = new Map;
  }
  async write(path5, contents, options3) {
    this.ensureParentDirsExist(path5, options3);
    this.entries.set(path5, {
      type: "file",
      path: path5,
      contents: new Uint8Array(await readableToUint8Array(contents)),
      lastModifiedMs: this.timestampResolver(),
      visibility: options3.visibility
    });
  }
  ensureParentDirsExist(path5, options3) {
    let parentDir = dirname4(path5);
    while (![".", ""].includes(parentDir) && !this.entries.has(parentDir)) {
      this.entries.set(parentDir, {
        path: parentDir,
        type: "directory",
        visibility: options3.directoryVisibility
      });
      parentDir = dirname4(parentDir);
    }
  }
  async read(path5) {
    const file = this.entries.get(path5);
    if (file?.type !== "file") {
      throw new Error(`Path "${path5}" is not a file`);
    }
    return file.contents;
  }
  async deleteFile(path5) {
    this.entries.delete(path5);
  }
  async createDirectory(path5, options3) {
    path5 = path5.replace(/\/+$/g, "");
    this.entries.set(path5, {
      path: path5,
      type: "directory",
      visibility: options3.directoryVisibility
    });
  }
  async copyFile(from, to, options3) {
    const source = this.entries.get(from);
    if (source?.type !== "file") {
      throw new Error(`Source file ${from} does not exist`);
    }
    this.ensureParentDirsExist(to, options3);
    this.entries.set(to, {
      ...source,
      path: to
    });
  }
  async moveFile(from, to, options3) {
    await this.copyFile(from, to, options3);
    await this.deleteFile(from);
  }
  async stat(path5) {
    const entry = this.entries.get(path5);
    if (entry === undefined) {
      throw new Error(`No entry found for path "${path5}"`);
    }
    return this.mapToStatEntry(entry);
  }
  mapToStatEntry(entry) {
    if (entry.type === "directory") {
      return {
        ...entry,
        isDirectory: true,
        isFile: false
      };
    }
    return {
      type: "file",
      path: entry.path,
      visibility: entry.visibility,
      isFile: true,
      isDirectory: false,
      lastModifiedMs: entry.lastModifiedMs
    };
  }
  async* list(path5, options3) {
    const entries = this.entries.values();
    const prefix = path5 === "" || path5 === "/" ? "" : `${path5.replace(/\/+$/g, "")}/`;
    for (const entry of entries) {
      if (!entry.path.startsWith(prefix)) {
        continue;
      }
      if (options3.deep !== true && entry.path.indexOf("/", prefix.length) !== -1) {
        continue;
      }
      yield this.mapToStatEntry(entry);
    }
  }
  async changeVisibility(path5, visibility) {
    const entry = this.entries.get(path5);
    if (entry?.type !== "file") {
      throw new Error(`Path ${path5} is not a file`);
    }
    this.entries.set(path5, {
      ...entry,
      visibility
    });
  }
  async visibility(path5) {
    const entry = this.entries.get(path5);
    if (entry === undefined) {
      throw new Error(`Path ${path5} does not exist`);
    }
    return entry.visibility ?? "public";
  }
  async deleteDirectory(path5) {
    const entries = this.entries.values();
    const prefix = `${path5.replace(/\/+$/g, "")}/`;
    for (const entry of entries) {
      if (entry.path.startsWith(prefix) || entry.path === path5) {
        this.entries.delete(entry.path);
      }
    }
  }
  async fileExists(path5) {
    return this.entries.get(path5)?.type === "file";
  }
  async directoryExists(path5) {
    return this.entries.get(path5)?.type === "directory";
  }
  async publicUrl(path5, options3) {
    throw new Error("Method not implemented.");
  }
  async temporaryUrl(path5, options3) {
    throw new Error("Method not implemented.");
  }
  async checksum(path5, options3) {
    if (!(this.entries.get(path5)?.type === "file")) {
      throw new Error(`File ${path5} does not exists`);
    }
    throw ChecksumIsNotAvailable.checksumNotSupported(options3.algo ?? "unknown", {
      context: { path: path5 }
    });
  }
  async mimeType(path5, options3) {
    const entry = this.entries.get(path5);
    if (entry?.type !== "file") {
      throw new Error(`File ${path5} does not exist`);
    }
    return await resolveMimeType2(path5, entry.contents);
  }
  async lastModified(path5) {
    const entry = this.entries.get(path5);
    if (entry?.type !== "file") {
      throw new Error(`File ${path5} does not exist`);
    }
    return entry.lastModifiedMs;
  }
  async fileSize(path5) {
    const entry = this.entries.get(path5);
    if (entry?.type !== "file") {
      throw new Error(`File ${path5} does not exist`);
    }
    return entry.contents.byteLength;
  }
}
async function resolveMimeType2(filename2, contents) {
  const { fileTypeFromBuffer: fileTypeFromBuffer3 } = await Promise.resolve().then(() => (init_file_type(), exports_file_type));
  const lookup3 = await fileTypeFromBuffer3(contents);
  if (lookup3) {
    return lookup3.mime;
  }
  const { ext: ext2 } = parse12(filename2);
  return $lookup(ext2) || "application/octet-stream";
}
var init_in_memory_file_storage = __esm2(() => {
  init_esm3();
  init_mime_types();
});
var init_esm6 = __esm2(() => {
  init_in_memory_file_storage();
});

class PortableUnixVisibilityConversion {
  filePublic;
  filePrivate;
  directoryPublic;
  directoryPrivate;
  defaultDirectoryVisibility;
  constructor(filePublic = 420, filePrivate = 384, directoryPublic = 493, directoryPrivate = 448, defaultDirectoryVisibility = Visibility.PUBLIC) {
    this.filePublic = filePublic;
    this.filePrivate = filePrivate;
    this.directoryPublic = directoryPublic;
    this.directoryPrivate = directoryPrivate;
    this.defaultDirectoryVisibility = defaultDirectoryVisibility;
  }
  get defaultDirectoryPermissions() {
    return this.visibilityToDirectoryPermissions(this.defaultDirectoryVisibility);
  }
  directoryPermissionsToVisibility(permissions) {
    if (permissions === this.directoryPrivate) {
      return Visibility.PRIVATE;
    }
    return Visibility.PUBLIC;
  }
  filePermissionsToVisibility(permissions) {
    if (permissions === this.filePrivate) {
      return Visibility.PRIVATE;
    }
    return Visibility.PUBLIC;
  }
  visibilityToDirectoryPermissions(visibility) {
    if (visibility === Visibility.PUBLIC) {
      return this.directoryPublic;
    } else if (visibility === Visibility.PRIVATE) {
      return this.directoryPrivate;
    }
    throw new Error(`Unsupported visibility was provided: ${visibility}`);
  }
  visibilityToFilePermissions(visibility) {
    if (visibility === Visibility.PUBLIC) {
      return this.filePublic;
    } else if (visibility === Visibility.PRIVATE) {
      return this.filePrivate;
    }
    throw new Error(`Unsupported visibility was provided: ${visibility}`);
  }
}
var init_unix_visibility = __esm2(() => {
  init_esm3();
});

class BaseUrlLocalPublicUrlGenerator {
  async publicUrl(path5, options3) {
    if (options3.baseUrl === undefined) {
      throw new Error("No base URL defined for public URL generation");
    }
    const base3 = options3.baseUrl.endsWith("/") ? options3.baseUrl : `${options3.baseUrl}/`;
    if (posix4.sep === "\\" && path5.includes(posix4.sep)) {
      path5 = path5.replace(posix4.sep, "/");
    }
    return `${base3}${path5}`;
  }
}

class FailingLocalTemporaryUrlGenerator {
  async temporaryUrl() {
    throw new Error("No temporary URL generator provided");
  }
}

class LocalStorageAdapter {
  rootDir;
  options;
  visibilityConversion;
  publicUrlGenerator;
  temporaryUrlGenerator;
  prefixer;
  constructor(rootDir, options3 = {}, visibilityConversion = new PortableUnixVisibilityConversion, publicUrlGenerator = new BaseUrlLocalPublicUrlGenerator, temporaryUrlGenerator = new FailingLocalTemporaryUrlGenerator) {
    this.rootDir = rootDir;
    this.options = options3;
    this.visibilityConversion = visibilityConversion;
    this.publicUrlGenerator = publicUrlGenerator;
    this.temporaryUrlGenerator = temporaryUrlGenerator;
    this.rootDir = posix4.join(this.rootDir, posix4.sep);
    this.prefixer = new PathPrefixer(this.rootDir, posix4.sep, posix4.join);
  }
  async copyFile(from, to, options3) {
    await this.ensureRootDirectoryExists();
    await this.ensureParentDirectoryExists(to, options3);
    await copyFile2(this.prefixer.prefixFilePath(from), this.prefixer.prefixFilePath(to));
  }
  async moveFile(from, to, options3) {
    await this.ensureRootDirectoryExists();
    await this.ensureParentDirectoryExists(to, options3);
    await rename(this.prefixer.prefixFilePath(from), this.prefixer.prefixFilePath(to));
  }
  temporaryUrl(path5, options3) {
    return this.temporaryUrlGenerator.temporaryUrl(path5, { ...this.options.temporaryUrlOptions, ...options3 });
  }
  publicUrl(path5, options3) {
    return this.publicUrlGenerator.publicUrl(path5, { ...this.options.publicUrlOptions, ...options3 });
  }
  async mimeType(path, options) {
    if (fileTypes2 === undefined) {
      fileTypes2 = await eval('import("file-type")');
    }
    const { fileTypeFromFile, supportedExtensions } = fileTypes2;
    const extension = extname5(path);
    if (!supportedExtensions.has(extension)) {
      const mimetype = $lookup(extension);
      if (mimetype === false) {
        throw new Error("Unable to resolve mime-type");
      }
      return mimetype;
    }
    const location = this.prefixer.prefixFilePath(path);
    const result = await fileTypeFromFile(location);
    if (result === undefined) {
      throw new Error("Unable to resolve mime-type");
    }
    return result.mime;
  }
  async fileSize(path5) {
    const stat3 = await this.stat(path5);
    if (!stat3.isFile) {
      throw new Error(`Path ${path5} is not a file.`);
    }
    if (stat3.size === undefined) {
      throw new Error("Stat unexpectedly did not return file size.");
    }
    return stat3.size;
  }
  async lastModified(path5) {
    const stat3 = await this.stat(path5);
    if (!stat3.isFile) {
      throw new Error(`Path ${path5} is not a file.`);
    }
    if (stat3.lastModifiedMs === undefined) {
      throw new Error("Stat unexpectedly did not return last modified.");
    }
    return stat3.lastModifiedMs;
  }
  async* list(path5, { deep }) {
    let entries = await opendir(this.prefixer.prefixDirectoryPath(path5), {
      recursive: deep
    });
    for await (const item of entries) {
      const itemPath = posix4.join(item.parentPath, item.name);
      yield this.mapStatToEntry(item, item.isFile() ? this.prefixer.stripFilePath(itemPath) : this.prefixer.stripDirectoryPath(itemPath));
    }
  }
  async read(path5) {
    return createReadStream(this.prefixer.prefixFilePath(path5));
  }
  async write(path5, contents, options3) {
    await this.ensureRootDirectoryExists();
    await this.ensureParentDirectoryExists(path5, options3);
    const writeStream22 = createWriteStream(this.prefixer.prefixFilePath(path5), {
      flags: "w+",
      mode: options3.visibility ? this.visibilityConversion.visibilityToFilePermissions(options3.visibility) : undefined
    });
    await pipeline2(contents, writeStream22);
  }
  async deleteFile(path5) {
    await rm(this.prefixer.prefixFilePath(path5), {
      force: true
    });
  }
  async createDirectory(path5, options3) {
    await mkdir22(this.prefixer.prefixDirectoryPath(path5), {
      recursive: true,
      mode: options3.directoryVisibility ? this.visibilityConversion.visibilityToDirectoryPermissions(options3.directoryVisibility) : undefined
    });
  }
  async stat(path5, type2 = "file") {
    return this.mapStatToEntry(await stat2(type2 === "file" ? this.prefixer.prefixFilePath(path5) : this.prefixer.prefixDirectoryPath(path5)), path5);
  }
  async fileExists(path5) {
    try {
      const stat3 = await this.stat(path5);
      return stat3.isFile;
    } catch (e5) {
      if (typeof e5 === "object" && e5.code === "ENOENT") {
        return false;
      }
      throw e5;
    }
  }
  async deleteDirectory(path5) {
    await rm(this.prefixer.prefixDirectoryPath(path5), {
      recursive: true,
      force: true
    });
  }
  mapStatToEntry(info, path5) {
    if (!info.isFile() && !info.isDirectory()) {
      throw new Error("Unsupported file entry encountered...");
    }
    const isDirent = info instanceof Dirent;
    return info.isFile() ? {
      path: path5,
      type: "file",
      isFile: true,
      isDirectory: false,
      visibility: isDirent ? undefined : this.visibilityConversion.filePermissionsToVisibility(info.mode & 511),
      lastModifiedMs: isDirent ? undefined : info.mtimeMs,
      size: isDirent ? undefined : info.size
    } : {
      path: path5,
      type: "directory",
      isFile: false,
      isDirectory: true,
      visibility: isDirent ? undefined : this.visibilityConversion.directoryPermissionsToVisibility(info.mode & 511),
      lastModifiedMs: isDirent ? undefined : info.mtimeMs
    };
  }
  async changeVisibility(path5, visibility) {
    await chmod(this.prefixer.prefixFilePath(path5), this.visibilityConversion.visibilityToFilePermissions(visibility));
  }
  async visibility(path5) {
    const stat3 = await this.stat(path5);
    if (!stat3.visibility) {
      throw new Error("Unable to determine visibility");
    }
    return stat3.visibility;
  }
  async directoryExists(path5) {
    try {
      const stat3 = await this.stat(path5, "directory");
      return stat3.isDirectory;
    } catch (e5) {
      if (typeof e5 === "object" && ["ENOTDIR", "ENOENT"].includes(e5.code)) {
        return false;
      }
      throw e5;
    }
  }
  rootDirectoryCreation = undefined;
  async ensureRootDirectoryExists() {
    if (this.rootDirectoryCreation === undefined) {
      this.rootDirectoryCreation = this.createDirectory("", {
        directoryVisibility: this.options.rootDirectoryVisibility ?? this.visibilityConversion.defaultDirectoryVisibility
      });
    }
    return await this.rootDirectoryCreation;
  }
  async ensureParentDirectoryExists(path5, options3) {
    const directoryName = posix4.dirname(path5);
    if (directoryName !== "." && directoryName !== "/") {
      await this.createDirectory(directoryName, {
        directoryVisibility: options3.directoryVisibility
      });
    }
  }
  async checksum(path5, options3) {
    return checksumFromStream(await this.read(path5), options3);
  }
}
var fileTypes2 = undefined;
var LocalFileStorage;
var init_local_file_storage = __esm2(() => {
  init_esm3();
  init_mime_types();
  init_unix_visibility();
  LocalFileStorage = class LocalFileStorage2 extends LocalStorageAdapter {
  };
});
var init_esm7 = __esm2(() => {
  init_local_file_storage();
  init_unix_visibility();
});
var init_flystorage = __esm2(() => {
  init_esm5();
  init_esm3();
  init_esm6();
  init_esm7();
});
function hashFileOrDirectory(path5, hash3) {
  if (!fs2.existsSync(path5)) {
    console.error(`Path does not exist: ${path5}`);
    return;
  }
  if (fs2.statSync(path5).isDirectory()) {
    const files2 = fs2.readdirSync(path5);
    for (const file of files2) {
      const filePath = path2.join(path5, file);
      hashFileOrDirectory(filePath, hash3);
    }
  } else {
    hash3.update(fs2.readFileSync(path5));
  }
}
function hashDirectory(directory) {
  const hash3 = createHash4("sha256");
  hashFileOrDirectory(directory, hash3);
  return hash3.digest("hex");
}
function hashPath(path5) {
  const hash3 = createHash4("sha256");
  hashFileOrDirectory(path5, hash3);
  return hash3.digest("hex");
}
function hashPaths(paths) {
  const hash3 = createHash4("sha256");
  const pathsArray = Array.isArray(paths) ? paths : [paths];
  for (const path5 of pathsArray)
    hashFileOrDirectory(path5, hash3);
  return hash3.digest("hex");
}
var init_hash3 = __esm2(() => {
  init_src11();
  init_fs();
});
function updateConfigFile(filePath, newConfig) {
  return new Promise((resolve5, reject) => {
    const config9 = JSON.parse(fs2.readFileSync(filePath, "utf8"));
    for (const key2 in newConfig)
      config9[key2] = newConfig[key2];
    try {
      fs2.writeFileSync(filePath, JSON.stringify(config9, null, 2));
      resolve5();
    } catch (error) {
      reject(error);
    }
  });
}
var __dirname2 = "/Users/chrisbreuer/Code/stacks/storage/framework/core/storage/src";
var _dirname;
var helpers9;
var init_helpers8 = __esm2(() => {
  init_src11();
  init_fs();
  _dirname = typeof __dirname2 !== "undefined" ? __dirname2 : dirname22(fileURLToPath(import.meta.url));
  helpers9 = {
    _dirname,
    updateConfigFile
  };
});
async function move2(src22, dest, options3) {
  try {
    if (Array.isArray(src22)) {
      const operations = src22.map(async (file) => {
        const from2 = file;
        const to2 = path2.resolve(dest, path2.basename(file));
        const result3 = await rename2(from2, to2, options3);
        if (result3.isErr())
          return log2.error(result3.error);
      });
      await Promise.all(operations);
      return ok2({ message: "Files moved successfully" });
    }
    const from = src22;
    const to = dest;
    const result2 = await rename2(from, to, options3);
    if (result2.isErr()) {
      log2.error(result2.error);
      return err2(handleError2(result2.error));
    }
    return ok2({ message: "File moved successfully" });
  } catch (error) {
    return err2(handleError2(error));
  }
}
async function rename2(from, to, options3) {
  return new Promise((resolve5, reject) => {
    try {
      const dir = path2.dirname(to);
      if (!fs2.existsSync(dir))
        fs2.mkdirSync(dir, { recursive: true });
      if (!fs2.existsSync(from))
        return reject(err2(new Error(`File or directory does not exist: ${from}`)));
      if (fs2.existsSync(to)) {
        if (!options3?.overwrite)
          return reject(err2(new Error(`File or directory already exists: ${to}`)));
        fs2.unlinkSync(to);
      }
      fs2.renameSync(from, to);
      return resolve5(ok2({ message: "File moved successfully" }));
    } catch (error) {
      if (error.code === "ENOENT")
        log2.error("File or directory does not exist\n\n", error);
      else
        log2.error(error);
      return reject(err2(new Error(error)));
    }
  });
}
var init_move = __esm2(() => {
  init_src7();
  init_src8();
  init_src11();
  init_fs();
});
function setVisibility() {
  return "wip";
}
async function zip(from, to, options3) {
  const toPath = to || "archive.zip";
  const fromPath = Array.isArray(from) ? from.join(" ") : from;
  if (Array.isArray(from))
    return runCommand(`zip -r ${toPath} ${fromPath}`, options3);
  return runCommand(`zip -r ${to} ${from}`, options3);
}
async function unzip(paths) {
  if (Array.isArray(paths))
    return runCommand(`unzip ${paths.join(" ")}`);
  return runCommand(`unzip ${paths}`);
}
function archive(paths) {
  return zip(paths);
}
function unarchive(paths) {
  return unzip(paths);
}
function compress(paths) {
  return zip(paths);
}
function decompress(paths) {
  return unzip(paths);
}
function gzipSync(data2, options3) {
  return Bun.gzipSync(data2, options3);
}
function gunzipSync(data2) {
  return Bun.gunzipSync(data2);
}
function deflateSync(data2, options3) {
  return Bun.deflateSync(data2, options3);
}
function inflateSync(data2) {
  return Bun.inflateSync(data2);
}
var init_zip = __esm2(() => {
  init_src10();
});
var exports_storage = {};
__export3(exports_storage, {
  zip: () => zip,
  writeTextFile: () => writeTextFile,
  writeJsonFile: () => writeJsonFile,
  writeFileSync: () => import_fs_extra.writeFileSync,
  writeFile: () => writeFile,
  watchFile: () => import_fs_extra.watchFile,
  updateConfigFile: () => updateConfigFile,
  unzip: () => unzip,
  unarchive: () => unarchive,
  setVisibility: () => setVisibility,
  rename: () => rename2,
  readTextFile: () => readTextFile,
  readPackageJson: () => readPackageJson,
  readJsonFile: () => readJsonFile,
  readFileSync: () => import_fs_extra.readFileSync,
  put: () => put2,
  move: () => move2,
  mkdirSync: () => import_fs_extra.mkdirSync,
  isFolder: () => isFolder,
  isDirectoryEmpty: () => isDirectoryEmpty,
  isDir: () => isDir,
  inflateSync: () => inflateSync,
  helpers: () => helpers9,
  hasFunctions: () => hasFunctions,
  hasFiles: () => hasFiles,
  hasComponents: () => hasComponents,
  gzipSync: () => gzipSync,
  gunzipSync: () => gunzipSync,
  getFolders: () => getFolders,
  getFiles: () => getFiles,
  get: () => get,
  fsWatch: () => import_fs_extra.watch,
  fs: () => fs2,
  folders: () => folders,
  files: () => files,
  existsSync: () => import_fs_extra.pathExists,
  exists: () => exists,
  doesNotExist: () => doesNotExist,
  doesFolderExist: () => doesFolderExist,
  doesExist: () => doesExist,
  deleteGlob: () => deleteGlob,
  deleteFolder: () => deleteFolder,
  deleteFiles: () => deleteFiles,
  deleteFile: () => deleteFile,
  deleteEmptyFolders: () => deleteEmptyFolders,
  deleteEmptyFolder: () => deleteEmptyFolder,
  del: () => del,
  deflateSync: () => deflateSync,
  decompress: () => decompress,
  createFolder: () => createFolder,
  copyFolder: () => copyFolder,
  copyFile: () => copyFile,
  copy: () => copy,
  compress: () => compress,
  archive: () => archive,
  _dirname: () => _dirname
});
var init_storage2 = __esm2(() => {
  init_copy();
  init_delete();
  init_files();
  init_folders();
  init_fs();
  init_helpers8();
  init_move();
  init_zip();
});
var init_src23 = __esm2(() => {
  init_copy();
  init_delete();
  init_files();
  init_flystorage();
  init_folders();
  init_fs();
  init_glob();
  init_hash3();
  init_helpers8();
  init_storage2();
  init_zip();
});
init_src23();
var export_writeFileSync = import_fs_extra.writeFileSync;
var export_watchFile = import_fs_extra.watchFile;
var export_readFileSync = import_fs_extra.readFileSync;
var export_mkdirSync = import_fs_extra.mkdirSync;
var export_fsWatch = import_fs_extra.watch;
var export_existsSync = import_fs_extra.pathExists;
// package.json
var version = "0.3.0";

// src/config.ts
import os4 from "os";
import path5 from "path";

// node_modules/bun-config/dist/index.js
import { resolve as resolve4 } from "path";
import process20 from "process";
function deepMerge(target, ...sources) {
  if (!sources.length)
    return target;
  const source = sources.shift();
  if (isObject6(target) && isObject6(source)) {
    for (const key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        const sourceValue = source[key];
        if (isObject6(sourceValue) && isObject6(target[key])) {
          target[key] = deepMerge(target[key], sourceValue);
        } else {
          target[key] = sourceValue;
        }
      }
    }
  }
  return deepMerge(target, ...sources);
}
function isObject6(item) {
  return item && typeof item === "object" && !Array.isArray(item);
}
async function loadConfig2({ name, cwd, defaultConfig }) {
  const configPath2 = resolve4(cwd || process20.cwd(), `${name}.config`);
  try {
    const importedConfig = await import(configPath2);
    const loadedConfig = importedConfig.default || importedConfig;
    return deepMerge(defaultConfig, loadedConfig);
  } catch (error) {
    return defaultConfig;
  }
}

// src/config.ts
var config6 = await loadConfig2({
  name: "reverse-proxy",
  defaultConfig: {
    from: "localhost:5173",
    to: "stacks.localhost",
    https: {
      domain: "stacks.localhost",
      hostCertCN: "stacks.localhost",
      caCertPath: path5.join(os4.homedir(), ".stacks", "ssl", `stacks.localhost.ca.crt`),
      certPath: path5.join(os4.homedir(), ".stacks", "ssl", `stacks.localhost.crt`),
      keyPath: path5.join(os4.homedir(), ".stacks", "ssl", `stacks.localhost.crt.key`),
      altNameIPs: ["127.0.0.1"],
      altNameURIs: ["localhost"],
      organizationName: "stacksjs.org",
      countryName: "US",
      stateName: "California",
      localityName: "Playa Vista",
      commonName: "stacks.localhost",
      validityDays: 180,
      verbose: false
    },
    etcHostsCleanup: false,
    verbose: true
  }
});

// src/start.ts
import * as fs7 from "fs";
import * as http from "http";
import * as https from "https";
import * as net from "net";
import os9 from "os";
import path10 from "path";
import process24 from "process";

// src/hosts.ts
import { spawn } from "child_process";
import fs4 from "fs";
import os6 from "os";
import path7 from "path";
import process22 from "process";

// src/utils.ts
function debugLog(category, message, verbose) {
  if (verbose || config6.verbose) {
    console.debug(`[rpx:${category}] ${message}`);
  }
}

// src/hosts.ts
var hostsFilePath = process22.platform === "win32" ? path7.join(process22.env.windir || "C:\\Windows", "System32", "drivers", "etc", "hosts") : "/etc/hosts";
async function sudoWrite(operation, content) {
  return new Promise((resolve5, reject) => {
    if (process22.platform === "win32") {
      reject(new Error("Administrator privileges required on Windows"));
      return;
    }
    const tmpFile = path7.join(os6.tmpdir(), "hosts.tmp");
    try {
      if (operation === "append") {
        const currentContent = fs4.readFileSync(hostsFilePath, "utf8");
        fs4.writeFileSync(tmpFile, currentContent + content, "utf8");
      } else {
        fs4.writeFileSync(tmpFile, content, "utf8");
      }
      const sudo = spawn("sudo", ["cp", tmpFile, hostsFilePath]);
      sudo.on("close", (code) => {
        try {
          fs4.unlinkSync(tmpFile);
          if (code === 0)
            resolve5();
          else
            reject(new Error(`sudo process exited with code ${code}`));
        } catch (err3) {
          reject(err3);
        }
      });
      sudo.on("error", (err3) => {
        try {
          fs4.unlinkSync(tmpFile);
        } catch {
        }
        reject(err3);
      });
    } catch (err3) {
      reject(err3);
    }
  });
}
async function addHosts(hosts) {
  debugLog("hosts", `Adding hosts: ${hosts.join(", ")}`, config6.verbose);
  debugLog("hosts", `Using hosts file at: ${hostsFilePath}`, config6.verbose);
  try {
    const existingContent = await fs4.promises.readFile(hostsFilePath, "utf-8");
    const newEntries = hosts.filter((host) => {
      const ipv4Entry = `127.0.0.1 ${host}`;
      const ipv6Entry = `::1 ${host}`;
      return !existingContent.includes(ipv4Entry) && !existingContent.includes(ipv6Entry);
    });
    if (newEntries.length === 0) {
      debugLog("hosts", "All hosts already exist in hosts file", config6.verbose);
      log.info("All hosts are already in the hosts file");
      return;
    }
    const hostEntries = newEntries.map((host) => `\n# Added by rpx\n127.0.0.1 ${host}\n::1 ${host}`).join("\n");
    try {
      await fs4.promises.appendFile(hostsFilePath, hostEntries, { flag: "a" });
      log.success(`Added new hosts: ${newEntries.join(", ")}`);
    } catch (writeErr) {
      if (writeErr.code === "EACCES") {
        debugLog("hosts", "Permission denied, attempting with sudo", config6.verbose);
        try {
          await sudoWrite("append", hostEntries);
          log.success(`Added new hosts with sudo: ${newEntries.join(", ")}`);
        } catch (sudoErr) {
          log.error("Failed to modify hosts file automatically");
          log.warn("Please add these entries to your hosts file manually:");
          hostEntries.split("\n").forEach((entry) => log.warn(entry));
          if (process22.platform === "win32") {
            log.warn("\nOn Windows:");
            log.warn("1. Run notepad as administrator");
            log.warn("2. Open C:\\Windows\\System32\\drivers\\etc\\hosts");
          } else {
            log.warn("\nOn Unix systems:");
            log.warn(`sudo nano ${hostsFilePath}`);
          }
          throw new Error("Failed to modify hosts file: manual intervention required");
        }
      } else {
        throw writeErr;
      }
    }
  } catch (err3) {
    const error = err3;
    log.error(`Failed to manage hosts file: ${error.message}`);
    throw error;
  }
}
async function removeHosts(hosts) {
  debugLog("hosts", `Removing hosts: ${hosts.join(", ")}`, config6.verbose);
  try {
    const content = await fs4.promises.readFile(hostsFilePath, "utf-8");
    const lines = content.split("\n");
    const filteredLines = lines.filter((line, index) => {
      if (line.trim() === "# Added by rpx") {
        lines.splice(index + 1, 2);
        return false;
      }
      return true;
    });
    while (filteredLines[filteredLines.length - 1]?.trim() === "")
      filteredLines.pop();
    const newContent = `${filteredLines.join("\n")}\n`;
    try {
      await fs4.promises.writeFile(hostsFilePath, newContent);
      log.success("Hosts removed successfully");
    } catch (writeErr) {
      if (writeErr.code === "EACCES") {
        debugLog("hosts", "Permission denied, attempting with sudo", config6.verbose);
        try {
          await sudoWrite("write", newContent);
          log.success("Hosts removed successfully with sudo");
        } catch (sudoErr) {
          log.error("Failed to modify hosts file automatically");
          log.warn("Please remove these entries from your hosts file manually:");
          hosts.forEach((host) => {
            log.warn("# Added by rpx");
            log.warn(`127.0.0.1 ${host}`);
            log.warn(`::1 ${host}`);
          });
          if (process22.platform === "win32") {
            log.warn("\nOn Windows:");
            log.warn("1. Run notepad as administrator");
            log.warn("2. Open C:\\Windows\\System32\\drivers\\etc\\hosts");
          } else {
            log.warn("\nOn Unix systems:");
            log.warn(`sudo nano ${hostsFilePath}`);
          }
          throw new Error("Failed to modify hosts file: manual intervention required");
        }
      } else {
        throw writeErr;
      }
    }
  } catch (err3) {
    const error = err3;
    log.error(`Failed to remove hosts: ${error.message}`);
    throw error;
  }
}
async function checkHosts(hosts) {
  debugLog("hosts", `Checking hosts: ${hosts}`, config6.verbose);
  const content = await fs4.promises.readFile(hostsFilePath, "utf-8");
  return hosts.map((host) => {
    const ipv4Entry = `127.0.0.1 ${host}`;
    const ipv6Entry = `::1 ${host}`;
    return content.includes(ipv4Entry) || content.includes(ipv6Entry);
  });
}

// src/https.ts
import os8 from "os";
import path9 from "path";

// node_modules/@stacksjs/tlsx/dist/index.js
import fs22 from "fs";
import os42 from "os";
import path32 from "path";
import { formatWithOptions as formatWithOptions3 } from "util";
import { sep as sep5 } from "path";
import * as tty6 from "tty";
import { stdin as stdin3, stdout as stdout3 } from "process";
import f6 from "readline";
import { WriteStream as WriteStream3 } from "tty";
import require$$03 from "tty";
import process$13 from "process";
import { createRequire as __tinyexec_cr2 } from "module";
import { access as access3, appendFile as appendFile3, mkdir as mkdir3 } from "fs/promises";
import { dirname as dirname23 } from "path";
import process73 from "process";
import {
  basename as basename3,
  delimiter as delimiter3,
  dirname as dirname5,
  extname as extname6,
  isAbsolute as isAbsolute4,
  join as join9,
  normalize as normalize3,
  parse as parse3,
  relative as relative3,
  resolve as resolve23,
  sep as sep23,
  toNamespacedPath as toNamespacedPath3
} from "path";
import process53 from "process";
import process43 from "process";
import p23 from "process";
import process82 from "process";
import process102 from "process";
import process182 from "process";
import process112 from "process";
import os7 from "os";
import tty33 from "tty";
import process142 from "process";
import process132 from "process";
import process152 from "process";
import process162 from "process";
import process172 from "process";
import process192 from "process";
import os23 from "os";
import path8 from "path";
import { resolve as resolve6 } from "path";
import process23 from "process";
import fs6 from "fs";
import path22 from "path";
var __create4 = Object.create;
var __getProtoOf4 = Object.getPrototypeOf;
var __defProp4 = Object.defineProperty;
var __getOwnPropNames4 = Object.getOwnPropertyNames;
var __hasOwnProp4 = Object.prototype.hasOwnProperty;
var __toESM4 = (mod, isNodeMode, target) => {
  target = mod != null ? __create4(__getProtoOf4(mod)) : {};
  const to = isNodeMode || !mod || !mod.__esModule ? __defProp4(target, "default", { value: mod, enumerable: true }) : target;
  for (let key of __getOwnPropNames4(mod))
    if (!__hasOwnProp4.call(to, key))
      __defProp4(to, key, {
        get: () => mod[key],
        enumerable: true
      });
  return to;
};
var __commonJS3 = (cb2, mod) => () => (mod || cb2((mod = { exports: {} }).exports, mod), mod.exports);
var require_forge = __commonJS3((exports, module) => {
  module.exports = {
    options: {
      usePureJavaScript: false
    }
  };
});
var require_baseN = __commonJS3((exports, module) => {
  var api = {};
  module.exports = api;
  var _reverseAlphabets = {};
  api.encode = function(input, alphabet, maxline) {
    if (typeof alphabet !== "string") {
      throw new TypeError('"alphabet" must be a string.');
    }
    if (maxline !== undefined && typeof maxline !== "number") {
      throw new TypeError('"maxline" must be a number.');
    }
    var output = "";
    if (!(input instanceof Uint8Array)) {
      output = _encodeWithByteBuffer(input, alphabet);
    } else {
      var i5 = 0;
      var base2 = alphabet.length;
      var first = alphabet.charAt(0);
      var digits = [0];
      for (i5 = 0;i5 < input.length; ++i5) {
        for (var j23 = 0, carry = input[i5];j23 < digits.length; ++j23) {
          carry += digits[j23] << 8;
          digits[j23] = carry % base2;
          carry = carry / base2 | 0;
        }
        while (carry > 0) {
          digits.push(carry % base2);
          carry = carry / base2 | 0;
        }
      }
      for (i5 = 0;input[i5] === 0 && i5 < input.length - 1; ++i5) {
        output += first;
      }
      for (i5 = digits.length - 1;i5 >= 0; --i5) {
        output += alphabet[digits[i5]];
      }
    }
    if (maxline) {
      var regex32 = new RegExp(".{1," + maxline + "}", "g");
      output = output.match(regex32).join("\r\n");
    }
    return output;
  };
  api.decode = function(input, alphabet) {
    if (typeof input !== "string") {
      throw new TypeError('"input" must be a string.');
    }
    if (typeof alphabet !== "string") {
      throw new TypeError('"alphabet" must be a string.');
    }
    var table = _reverseAlphabets[alphabet];
    if (!table) {
      table = _reverseAlphabets[alphabet] = [];
      for (var i5 = 0;i5 < alphabet.length; ++i5) {
        table[alphabet.charCodeAt(i5)] = i5;
      }
    }
    input = input.replace(/\s/g, "");
    var base2 = alphabet.length;
    var first = alphabet.charAt(0);
    var bytes = [0];
    for (var i5 = 0;i5 < input.length; i5++) {
      var value = table[input.charCodeAt(i5)];
      if (value === undefined) {
        return;
      }
      for (var j23 = 0, carry = value;j23 < bytes.length; ++j23) {
        carry += bytes[j23] * base2;
        bytes[j23] = carry & 255;
        carry >>= 8;
      }
      while (carry > 0) {
        bytes.push(carry & 255);
        carry >>= 8;
      }
    }
    for (var k5 = 0;input[k5] === first && k5 < input.length - 1; ++k5) {
      bytes.push(0);
    }
    if (typeof Buffer !== "undefined") {
      return Buffer.from(bytes.reverse());
    }
    return new Uint8Array(bytes.reverse());
  };
  function _encodeWithByteBuffer(input, alphabet) {
    var i5 = 0;
    var base2 = alphabet.length;
    var first = alphabet.charAt(0);
    var digits = [0];
    for (i5 = 0;i5 < input.length(); ++i5) {
      for (var j23 = 0, carry = input.at(i5);j23 < digits.length; ++j23) {
        carry += digits[j23] << 8;
        digits[j23] = carry % base2;
        carry = carry / base2 | 0;
      }
      while (carry > 0) {
        digits.push(carry % base2);
        carry = carry / base2 | 0;
      }
    }
    var output = "";
    for (i5 = 0;input.at(i5) === 0 && i5 < input.length() - 1; ++i5) {
      output += first;
    }
    for (i5 = digits.length - 1;i5 >= 0; --i5) {
      output += alphabet[digits[i5]];
    }
    return output;
  }
});
var require_util33 = __commonJS3((exports, module) => {
  var forge = require_forge();
  var baseN = require_baseN();
  var util = module.exports = forge.util = forge.util || {};
  (function() {
    if (typeof process !== "undefined" && process.nextTick && true) {
      util.nextTick = process.nextTick;
      if (typeof setImmediate === "function") {
        util.setImmediate = setImmediate;
      } else {
        util.setImmediate = util.nextTick;
      }
      return;
    }
    if (typeof setImmediate === "function") {
      util.setImmediate = function() {
        return setImmediate.apply(undefined, arguments);
      };
      util.nextTick = function(callback) {
        return setImmediate(callback);
      };
      return;
    }
    util.setImmediate = function(callback) {
      setTimeout(callback, 0);
    };
    if (typeof window !== "undefined" && typeof window.postMessage === "function") {
      let handler3 = function(event) {
        if (event.source === window && event.data === msg) {
          event.stopPropagation();
          var copy2 = callbacks.slice();
          callbacks.length = 0;
          copy2.forEach(function(callback) {
            callback();
          });
        }
      };
      var handler22 = handler3;
      var msg = "forge.setImmediate";
      var callbacks = [];
      util.setImmediate = function(callback) {
        callbacks.push(callback);
        if (callbacks.length === 1) {
          window.postMessage(msg, "*");
        }
      };
      window.addEventListener("message", handler3, true);
    }
    if (typeof MutationObserver !== "undefined") {
      var now2 = Date.now();
      var attr = true;
      var div = document.createElement("div");
      var callbacks = [];
      new MutationObserver(function() {
        var copy2 = callbacks.slice();
        callbacks.length = 0;
        copy2.forEach(function(callback) {
          callback();
        });
      }).observe(div, { attributes: true });
      var oldSetImmediate = util.setImmediate;
      util.setImmediate = function(callback) {
        if (Date.now() - now2 > 15) {
          now2 = Date.now();
          oldSetImmediate(callback);
        } else {
          callbacks.push(callback);
          if (callbacks.length === 1) {
            div.setAttribute("a", attr = !attr);
          }
        }
      };
    }
    util.nextTick = util.setImmediate;
  })();
  util.isNodejs = typeof process !== "undefined" && process.versions && process.versions.node;
  util.globalScope = function() {
    if (util.isNodejs) {
      return global;
    }
    return typeof self === "undefined" ? window : self;
  }();
  util.isArray = Array.isArray || function(x5) {
    return Object.prototype.toString.call(x5) === "[object Array]";
  };
  util.isArrayBuffer = function(x5) {
    return typeof ArrayBuffer !== "undefined" && x5 instanceof ArrayBuffer;
  };
  util.isArrayBufferView = function(x5) {
    return x5 && util.isArrayBuffer(x5.buffer) && x5.byteLength !== undefined;
  };
  function _checkBitsParam(n5) {
    if (!(n5 === 8 || n5 === 16 || n5 === 24 || n5 === 32)) {
      throw new Error("Only 8, 16, 24, or 32 bits supported: " + n5);
    }
  }
  util.ByteBuffer = ByteStringBuffer;
  function ByteStringBuffer(b23) {
    this.data = "";
    this.read = 0;
    if (typeof b23 === "string") {
      this.data = b23;
    } else if (util.isArrayBuffer(b23) || util.isArrayBufferView(b23)) {
      if (typeof Buffer !== "undefined" && b23 instanceof Buffer) {
        this.data = b23.toString("binary");
      } else {
        var arr = new Uint8Array(b23);
        try {
          this.data = String.fromCharCode.apply(null, arr);
        } catch (e5) {
          for (var i5 = 0;i5 < arr.length; ++i5) {
            this.putByte(arr[i5]);
          }
        }
      }
    } else if (b23 instanceof ByteStringBuffer || typeof b23 === "object" && typeof b23.data === "string" && typeof b23.read === "number") {
      this.data = b23.data;
      this.read = b23.read;
    }
    this._constructedStringLength = 0;
  }
  util.ByteStringBuffer = ByteStringBuffer;
  var _MAX_CONSTRUCTED_STRING_LENGTH = 4096;
  util.ByteStringBuffer.prototype._optimizeConstructedString = function(x5) {
    this._constructedStringLength += x5;
    if (this._constructedStringLength > _MAX_CONSTRUCTED_STRING_LENGTH) {
      this.data.substr(0, 1);
      this._constructedStringLength = 0;
    }
  };
  util.ByteStringBuffer.prototype.length = function() {
    return this.data.length - this.read;
  };
  util.ByteStringBuffer.prototype.isEmpty = function() {
    return this.length() <= 0;
  };
  util.ByteStringBuffer.prototype.putByte = function(b23) {
    return this.putBytes(String.fromCharCode(b23));
  };
  util.ByteStringBuffer.prototype.fillWithByte = function(b23, n5) {
    b23 = String.fromCharCode(b23);
    var d5 = this.data;
    while (n5 > 0) {
      if (n5 & 1) {
        d5 += b23;
      }
      n5 >>>= 1;
      if (n5 > 0) {
        b23 += b23;
      }
    }
    this.data = d5;
    this._optimizeConstructedString(n5);
    return this;
  };
  util.ByteStringBuffer.prototype.putBytes = function(bytes) {
    this.data += bytes;
    this._optimizeConstructedString(bytes.length);
    return this;
  };
  util.ByteStringBuffer.prototype.putString = function(str2) {
    return this.putBytes(util.encodeUtf8(str2));
  };
  util.ByteStringBuffer.prototype.putInt16 = function(i5) {
    return this.putBytes(String.fromCharCode(i5 >> 8 & 255) + String.fromCharCode(i5 & 255));
  };
  util.ByteStringBuffer.prototype.putInt24 = function(i5) {
    return this.putBytes(String.fromCharCode(i5 >> 16 & 255) + String.fromCharCode(i5 >> 8 & 255) + String.fromCharCode(i5 & 255));
  };
  util.ByteStringBuffer.prototype.putInt32 = function(i5) {
    return this.putBytes(String.fromCharCode(i5 >> 24 & 255) + String.fromCharCode(i5 >> 16 & 255) + String.fromCharCode(i5 >> 8 & 255) + String.fromCharCode(i5 & 255));
  };
  util.ByteStringBuffer.prototype.putInt16Le = function(i5) {
    return this.putBytes(String.fromCharCode(i5 & 255) + String.fromCharCode(i5 >> 8 & 255));
  };
  util.ByteStringBuffer.prototype.putInt24Le = function(i5) {
    return this.putBytes(String.fromCharCode(i5 & 255) + String.fromCharCode(i5 >> 8 & 255) + String.fromCharCode(i5 >> 16 & 255));
  };
  util.ByteStringBuffer.prototype.putInt32Le = function(i5) {
    return this.putBytes(String.fromCharCode(i5 & 255) + String.fromCharCode(i5 >> 8 & 255) + String.fromCharCode(i5 >> 16 & 255) + String.fromCharCode(i5 >> 24 & 255));
  };
  util.ByteStringBuffer.prototype.putInt = function(i5, n5) {
    _checkBitsParam(n5);
    var bytes = "";
    do {
      n5 -= 8;
      bytes += String.fromCharCode(i5 >> n5 & 255);
    } while (n5 > 0);
    return this.putBytes(bytes);
  };
  util.ByteStringBuffer.prototype.putSignedInt = function(i5, n5) {
    if (i5 < 0) {
      i5 += 2 << n5 - 1;
    }
    return this.putInt(i5, n5);
  };
  util.ByteStringBuffer.prototype.putBuffer = function(buffer) {
    return this.putBytes(buffer.getBytes());
  };
  util.ByteStringBuffer.prototype.getByte = function() {
    return this.data.charCodeAt(this.read++);
  };
  util.ByteStringBuffer.prototype.getInt16 = function() {
    var rval = this.data.charCodeAt(this.read) << 8 ^ this.data.charCodeAt(this.read + 1);
    this.read += 2;
    return rval;
  };
  util.ByteStringBuffer.prototype.getInt24 = function() {
    var rval = this.data.charCodeAt(this.read) << 16 ^ this.data.charCodeAt(this.read + 1) << 8 ^ this.data.charCodeAt(this.read + 2);
    this.read += 3;
    return rval;
  };
  util.ByteStringBuffer.prototype.getInt32 = function() {
    var rval = this.data.charCodeAt(this.read) << 24 ^ this.data.charCodeAt(this.read + 1) << 16 ^ this.data.charCodeAt(this.read + 2) << 8 ^ this.data.charCodeAt(this.read + 3);
    this.read += 4;
    return rval;
  };
  util.ByteStringBuffer.prototype.getInt16Le = function() {
    var rval = this.data.charCodeAt(this.read) ^ this.data.charCodeAt(this.read + 1) << 8;
    this.read += 2;
    return rval;
  };
  util.ByteStringBuffer.prototype.getInt24Le = function() {
    var rval = this.data.charCodeAt(this.read) ^ this.data.charCodeAt(this.read + 1) << 8 ^ this.data.charCodeAt(this.read + 2) << 16;
    this.read += 3;
    return rval;
  };
  util.ByteStringBuffer.prototype.getInt32Le = function() {
    var rval = this.data.charCodeAt(this.read) ^ this.data.charCodeAt(this.read + 1) << 8 ^ this.data.charCodeAt(this.read + 2) << 16 ^ this.data.charCodeAt(this.read + 3) << 24;
    this.read += 4;
    return rval;
  };
  util.ByteStringBuffer.prototype.getInt = function(n5) {
    _checkBitsParam(n5);
    var rval = 0;
    do {
      rval = (rval << 8) + this.data.charCodeAt(this.read++);
      n5 -= 8;
    } while (n5 > 0);
    return rval;
  };
  util.ByteStringBuffer.prototype.getSignedInt = function(n5) {
    var x5 = this.getInt(n5);
    var max = 2 << n5 - 2;
    if (x5 >= max) {
      x5 -= max << 1;
    }
    return x5;
  };
  util.ByteStringBuffer.prototype.getBytes = function(count) {
    var rval;
    if (count) {
      count = Math.min(this.length(), count);
      rval = this.data.slice(this.read, this.read + count);
      this.read += count;
    } else if (count === 0) {
      rval = "";
    } else {
      rval = this.read === 0 ? this.data : this.data.slice(this.read);
      this.clear();
    }
    return rval;
  };
  util.ByteStringBuffer.prototype.bytes = function(count) {
    return typeof count === "undefined" ? this.data.slice(this.read) : this.data.slice(this.read, this.read + count);
  };
  util.ByteStringBuffer.prototype.at = function(i5) {
    return this.data.charCodeAt(this.read + i5);
  };
  util.ByteStringBuffer.prototype.setAt = function(i5, b23) {
    this.data = this.data.substr(0, this.read + i5) + String.fromCharCode(b23) + this.data.substr(this.read + i5 + 1);
    return this;
  };
  util.ByteStringBuffer.prototype.last = function() {
    return this.data.charCodeAt(this.data.length - 1);
  };
  util.ByteStringBuffer.prototype.copy = function() {
    var c23 = util.createBuffer(this.data);
    c23.read = this.read;
    return c23;
  };
  util.ByteStringBuffer.prototype.compact = function() {
    if (this.read > 0) {
      this.data = this.data.slice(this.read);
      this.read = 0;
    }
    return this;
  };
  util.ByteStringBuffer.prototype.clear = function() {
    this.data = "";
    this.read = 0;
    return this;
  };
  util.ByteStringBuffer.prototype.truncate = function(count) {
    var len = Math.max(0, this.length() - count);
    this.data = this.data.substr(this.read, len);
    this.read = 0;
    return this;
  };
  util.ByteStringBuffer.prototype.toHex = function() {
    var rval = "";
    for (var i5 = this.read;i5 < this.data.length; ++i5) {
      var b23 = this.data.charCodeAt(i5);
      if (b23 < 16) {
        rval += "0";
      }
      rval += b23.toString(16);
    }
    return rval;
  };
  util.ByteStringBuffer.prototype.toString = function() {
    return util.decodeUtf8(this.bytes());
  };
  function DataBuffer(b23, options23) {
    options23 = options23 || {};
    this.read = options23.readOffset || 0;
    this.growSize = options23.growSize || 1024;
    var isArrayBuffer2 = util.isArrayBuffer(b23);
    var isArrayBufferView = util.isArrayBufferView(b23);
    if (isArrayBuffer2 || isArrayBufferView) {
      if (isArrayBuffer2) {
        this.data = new DataView(b23);
      } else {
        this.data = new DataView(b23.buffer, b23.byteOffset, b23.byteLength);
      }
      this.write = "writeOffset" in options23 ? options23.writeOffset : this.data.byteLength;
      return;
    }
    this.data = new DataView(new ArrayBuffer(0));
    this.write = 0;
    if (b23 !== null && b23 !== undefined) {
      this.putBytes(b23);
    }
    if ("writeOffset" in options23) {
      this.write = options23.writeOffset;
    }
  }
  util.DataBuffer = DataBuffer;
  util.DataBuffer.prototype.length = function() {
    return this.write - this.read;
  };
  util.DataBuffer.prototype.isEmpty = function() {
    return this.length() <= 0;
  };
  util.DataBuffer.prototype.accommodate = function(amount, growSize) {
    if (this.length() >= amount) {
      return this;
    }
    growSize = Math.max(growSize || this.growSize, amount);
    var src22 = new Uint8Array(this.data.buffer, this.data.byteOffset, this.data.byteLength);
    var dst = new Uint8Array(this.length() + growSize);
    dst.set(src22);
    this.data = new DataView(dst.buffer);
    return this;
  };
  util.DataBuffer.prototype.putByte = function(b23) {
    this.accommodate(1);
    this.data.setUint8(this.write++, b23);
    return this;
  };
  util.DataBuffer.prototype.fillWithByte = function(b23, n5) {
    this.accommodate(n5);
    for (var i5 = 0;i5 < n5; ++i5) {
      this.data.setUint8(b23);
    }
    return this;
  };
  util.DataBuffer.prototype.putBytes = function(bytes, encoding) {
    if (util.isArrayBufferView(bytes)) {
      var src22 = new Uint8Array(bytes.buffer, bytes.byteOffset, bytes.byteLength);
      var len = src22.byteLength - src22.byteOffset;
      this.accommodate(len);
      var dst = new Uint8Array(this.data.buffer, this.write);
      dst.set(src22);
      this.write += len;
      return this;
    }
    if (util.isArrayBuffer(bytes)) {
      var src22 = new Uint8Array(bytes);
      this.accommodate(src22.byteLength);
      var dst = new Uint8Array(this.data.buffer);
      dst.set(src22, this.write);
      this.write += src22.byteLength;
      return this;
    }
    if (bytes instanceof util.DataBuffer || typeof bytes === "object" && typeof bytes.read === "number" && typeof bytes.write === "number" && util.isArrayBufferView(bytes.data)) {
      var src22 = new Uint8Array(bytes.data.byteLength, bytes.read, bytes.length());
      this.accommodate(src22.byteLength);
      var dst = new Uint8Array(bytes.data.byteLength, this.write);
      dst.set(src22);
      this.write += src22.byteLength;
      return this;
    }
    if (bytes instanceof util.ByteStringBuffer) {
      bytes = bytes.data;
      encoding = "binary";
    }
    encoding = encoding || "binary";
    if (typeof bytes === "string") {
      var view;
      if (encoding === "hex") {
        this.accommodate(Math.ceil(bytes.length / 2));
        view = new Uint8Array(this.data.buffer, this.write);
        this.write += util.binary.hex.decode(bytes, view, this.write);
        return this;
      }
      if (encoding === "base64") {
        this.accommodate(Math.ceil(bytes.length / 4) * 3);
        view = new Uint8Array(this.data.buffer, this.write);
        this.write += util.binary.base64.decode(bytes, view, this.write);
        return this;
      }
      if (encoding === "utf8") {
        bytes = util.encodeUtf8(bytes);
        encoding = "binary";
      }
      if (encoding === "binary" || encoding === "raw") {
        this.accommodate(bytes.length);
        view = new Uint8Array(this.data.buffer, this.write);
        this.write += util.binary.raw.decode(view);
        return this;
      }
      if (encoding === "utf16") {
        this.accommodate(bytes.length * 2);
        view = new Uint16Array(this.data.buffer, this.write);
        this.write += util.text.utf16.encode(view);
        return this;
      }
      throw new Error("Invalid encoding: " + encoding);
    }
    throw Error("Invalid parameter: " + bytes);
  };
  util.DataBuffer.prototype.putBuffer = function(buffer) {
    this.putBytes(buffer);
    buffer.clear();
    return this;
  };
  util.DataBuffer.prototype.putString = function(str2) {
    return this.putBytes(str2, "utf16");
  };
  util.DataBuffer.prototype.putInt16 = function(i5) {
    this.accommodate(2);
    this.data.setInt16(this.write, i5);
    this.write += 2;
    return this;
  };
  util.DataBuffer.prototype.putInt24 = function(i5) {
    this.accommodate(3);
    this.data.setInt16(this.write, i5 >> 8 & 65535);
    this.data.setInt8(this.write, i5 >> 16 & 255);
    this.write += 3;
    return this;
  };
  util.DataBuffer.prototype.putInt32 = function(i5) {
    this.accommodate(4);
    this.data.setInt32(this.write, i5);
    this.write += 4;
    return this;
  };
  util.DataBuffer.prototype.putInt16Le = function(i5) {
    this.accommodate(2);
    this.data.setInt16(this.write, i5, true);
    this.write += 2;
    return this;
  };
  util.DataBuffer.prototype.putInt24Le = function(i5) {
    this.accommodate(3);
    this.data.setInt8(this.write, i5 >> 16 & 255);
    this.data.setInt16(this.write, i5 >> 8 & 65535, true);
    this.write += 3;
    return this;
  };
  util.DataBuffer.prototype.putInt32Le = function(i5) {
    this.accommodate(4);
    this.data.setInt32(this.write, i5, true);
    this.write += 4;
    return this;
  };
  util.DataBuffer.prototype.putInt = function(i5, n5) {
    _checkBitsParam(n5);
    this.accommodate(n5 / 8);
    do {
      n5 -= 8;
      this.data.setInt8(this.write++, i5 >> n5 & 255);
    } while (n5 > 0);
    return this;
  };
  util.DataBuffer.prototype.putSignedInt = function(i5, n5) {
    _checkBitsParam(n5);
    this.accommodate(n5 / 8);
    if (i5 < 0) {
      i5 += 2 << n5 - 1;
    }
    return this.putInt(i5, n5);
  };
  util.DataBuffer.prototype.getByte = function() {
    return this.data.getInt8(this.read++);
  };
  util.DataBuffer.prototype.getInt16 = function() {
    var rval = this.data.getInt16(this.read);
    this.read += 2;
    return rval;
  };
  util.DataBuffer.prototype.getInt24 = function() {
    var rval = this.data.getInt16(this.read) << 8 ^ this.data.getInt8(this.read + 2);
    this.read += 3;
    return rval;
  };
  util.DataBuffer.prototype.getInt32 = function() {
    var rval = this.data.getInt32(this.read);
    this.read += 4;
    return rval;
  };
  util.DataBuffer.prototype.getInt16Le = function() {
    var rval = this.data.getInt16(this.read, true);
    this.read += 2;
    return rval;
  };
  util.DataBuffer.prototype.getInt24Le = function() {
    var rval = this.data.getInt8(this.read) ^ this.data.getInt16(this.read + 1, true) << 8;
    this.read += 3;
    return rval;
  };
  util.DataBuffer.prototype.getInt32Le = function() {
    var rval = this.data.getInt32(this.read, true);
    this.read += 4;
    return rval;
  };
  util.DataBuffer.prototype.getInt = function(n5) {
    _checkBitsParam(n5);
    var rval = 0;
    do {
      rval = (rval << 8) + this.data.getInt8(this.read++);
      n5 -= 8;
    } while (n5 > 0);
    return rval;
  };
  util.DataBuffer.prototype.getSignedInt = function(n5) {
    var x5 = this.getInt(n5);
    var max = 2 << n5 - 2;
    if (x5 >= max) {
      x5 -= max << 1;
    }
    return x5;
  };
  util.DataBuffer.prototype.getBytes = function(count) {
    var rval;
    if (count) {
      count = Math.min(this.length(), count);
      rval = this.data.slice(this.read, this.read + count);
      this.read += count;
    } else if (count === 0) {
      rval = "";
    } else {
      rval = this.read === 0 ? this.data : this.data.slice(this.read);
      this.clear();
    }
    return rval;
  };
  util.DataBuffer.prototype.bytes = function(count) {
    return typeof count === "undefined" ? this.data.slice(this.read) : this.data.slice(this.read, this.read + count);
  };
  util.DataBuffer.prototype.at = function(i5) {
    return this.data.getUint8(this.read + i5);
  };
  util.DataBuffer.prototype.setAt = function(i5, b23) {
    this.data.setUint8(i5, b23);
    return this;
  };
  util.DataBuffer.prototype.last = function() {
    return this.data.getUint8(this.write - 1);
  };
  util.DataBuffer.prototype.copy = function() {
    return new util.DataBuffer(this);
  };
  util.DataBuffer.prototype.compact = function() {
    if (this.read > 0) {
      var src22 = new Uint8Array(this.data.buffer, this.read);
      var dst = new Uint8Array(src22.byteLength);
      dst.set(src22);
      this.data = new DataView(dst);
      this.write -= this.read;
      this.read = 0;
    }
    return this;
  };
  util.DataBuffer.prototype.clear = function() {
    this.data = new DataView(new ArrayBuffer(0));
    this.read = this.write = 0;
    return this;
  };
  util.DataBuffer.prototype.truncate = function(count) {
    this.write = Math.max(0, this.length() - count);
    this.read = Math.min(this.read, this.write);
    return this;
  };
  util.DataBuffer.prototype.toHex = function() {
    var rval = "";
    for (var i5 = this.read;i5 < this.data.byteLength; ++i5) {
      var b23 = this.data.getUint8(i5);
      if (b23 < 16) {
        rval += "0";
      }
      rval += b23.toString(16);
    }
    return rval;
  };
  util.DataBuffer.prototype.toString = function(encoding) {
    var view = new Uint8Array(this.data, this.read, this.length());
    encoding = encoding || "utf8";
    if (encoding === "binary" || encoding === "raw") {
      return util.binary.raw.encode(view);
    }
    if (encoding === "hex") {
      return util.binary.hex.encode(view);
    }
    if (encoding === "base64") {
      return util.binary.base64.encode(view);
    }
    if (encoding === "utf8") {
      return util.text.utf8.decode(view);
    }
    if (encoding === "utf16") {
      return util.text.utf16.decode(view);
    }
    throw new Error("Invalid encoding: " + encoding);
  };
  util.createBuffer = function(input, encoding) {
    encoding = encoding || "raw";
    if (input !== undefined && encoding === "utf8") {
      input = util.encodeUtf8(input);
    }
    return new util.ByteBuffer(input);
  };
  util.fillString = function(c23, n5) {
    var s32 = "";
    while (n5 > 0) {
      if (n5 & 1) {
        s32 += c23;
      }
      n5 >>>= 1;
      if (n5 > 0) {
        c23 += c23;
      }
    }
    return s32;
  };
  util.xorBytes = function(s1, s222, n5) {
    var s32 = "";
    var b23 = "";
    var t5 = "";
    var i5 = 0;
    var c23 = 0;
    for (;n5 > 0; --n5, ++i5) {
      b23 = s1.charCodeAt(i5) ^ s222.charCodeAt(i5);
      if (c23 >= 10) {
        s32 += t5;
        t5 = "";
        c23 = 0;
      }
      t5 += String.fromCharCode(b23);
      ++c23;
    }
    s32 += t5;
    return s32;
  };
  util.hexToBytes = function(hex) {
    var rval = "";
    var i5 = 0;
    if (hex.length & true) {
      i5 = 1;
      rval += String.fromCharCode(parseInt(hex[0], 16));
    }
    for (;i5 < hex.length; i5 += 2) {
      rval += String.fromCharCode(parseInt(hex.substr(i5, 2), 16));
    }
    return rval;
  };
  util.bytesToHex = function(bytes) {
    return util.createBuffer(bytes).toHex();
  };
  util.int32ToBytes = function(i5) {
    return String.fromCharCode(i5 >> 24 & 255) + String.fromCharCode(i5 >> 16 & 255) + String.fromCharCode(i5 >> 8 & 255) + String.fromCharCode(i5 & 255);
  };
  var _base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
  var _base64Idx = [
    62,
    -1,
    -1,
    -1,
    63,
    52,
    53,
    54,
    55,
    56,
    57,
    58,
    59,
    60,
    61,
    -1,
    -1,
    -1,
    64,
    -1,
    -1,
    -1,
    0,
    1,
    2,
    3,
    4,
    5,
    6,
    7,
    8,
    9,
    10,
    11,
    12,
    13,
    14,
    15,
    16,
    17,
    18,
    19,
    20,
    21,
    22,
    23,
    24,
    25,
    -1,
    -1,
    -1,
    -1,
    -1,
    -1,
    26,
    27,
    28,
    29,
    30,
    31,
    32,
    33,
    34,
    35,
    36,
    37,
    38,
    39,
    40,
    41,
    42,
    43,
    44,
    45,
    46,
    47,
    48,
    49,
    50,
    51
  ];
  var _base58 = "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";
  util.encode64 = function(input, maxline) {
    var line = "";
    var output = "";
    var chr1, chr2, chr3;
    var i5 = 0;
    while (i5 < input.length) {
      chr1 = input.charCodeAt(i5++);
      chr2 = input.charCodeAt(i5++);
      chr3 = input.charCodeAt(i5++);
      line += _base64.charAt(chr1 >> 2);
      line += _base64.charAt((chr1 & 3) << 4 | chr2 >> 4);
      if (isNaN(chr2)) {
        line += "==";
      } else {
        line += _base64.charAt((chr2 & 15) << 2 | chr3 >> 6);
        line += isNaN(chr3) ? "=" : _base64.charAt(chr3 & 63);
      }
      if (maxline && line.length > maxline) {
        output += line.substr(0, maxline) + "\r\n";
        line = line.substr(maxline);
      }
    }
    output += line;
    return output;
  };
  util.decode64 = function(input) {
    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
    var output = "";
    var enc1, enc2, enc3, enc4;
    var i5 = 0;
    while (i5 < input.length) {
      enc1 = _base64Idx[input.charCodeAt(i5++) - 43];
      enc2 = _base64Idx[input.charCodeAt(i5++) - 43];
      enc3 = _base64Idx[input.charCodeAt(i5++) - 43];
      enc4 = _base64Idx[input.charCodeAt(i5++) - 43];
      output += String.fromCharCode(enc1 << 2 | enc2 >> 4);
      if (enc3 !== 64) {
        output += String.fromCharCode((enc2 & 15) << 4 | enc3 >> 2);
        if (enc4 !== 64) {
          output += String.fromCharCode((enc3 & 3) << 6 | enc4);
        }
      }
    }
    return output;
  };
  util.encodeUtf8 = function(str2) {
    return unescape(encodeURIComponent(str2));
  };
  util.decodeUtf8 = function(str2) {
    return decodeURIComponent(escape(str2));
  };
  util.binary = {
    raw: {},
    hex: {},
    base64: {},
    base58: {},
    baseN: {
      encode: baseN.encode,
      decode: baseN.decode
    }
  };
  util.binary.raw.encode = function(bytes) {
    return String.fromCharCode.apply(null, bytes);
  };
  util.binary.raw.decode = function(str2, output, offset) {
    var out = output;
    if (!out) {
      out = new Uint8Array(str2.length);
    }
    offset = offset || 0;
    var j23 = offset;
    for (var i5 = 0;i5 < str2.length; ++i5) {
      out[j23++] = str2.charCodeAt(i5);
    }
    return output ? j23 - offset : out;
  };
  util.binary.hex.encode = util.bytesToHex;
  util.binary.hex.decode = function(hex, output, offset) {
    var out = output;
    if (!out) {
      out = new Uint8Array(Math.ceil(hex.length / 2));
    }
    offset = offset || 0;
    var i5 = 0, j23 = offset;
    if (hex.length & 1) {
      i5 = 1;
      out[j23++] = parseInt(hex[0], 16);
    }
    for (;i5 < hex.length; i5 += 2) {
      out[j23++] = parseInt(hex.substr(i5, 2), 16);
    }
    return output ? j23 - offset : out;
  };
  util.binary.base64.encode = function(input, maxline) {
    var line = "";
    var output = "";
    var chr1, chr2, chr3;
    var i5 = 0;
    while (i5 < input.byteLength) {
      chr1 = input[i5++];
      chr2 = input[i5++];
      chr3 = input[i5++];
      line += _base64.charAt(chr1 >> 2);
      line += _base64.charAt((chr1 & 3) << 4 | chr2 >> 4);
      if (isNaN(chr2)) {
        line += "==";
      } else {
        line += _base64.charAt((chr2 & 15) << 2 | chr3 >> 6);
        line += isNaN(chr3) ? "=" : _base64.charAt(chr3 & 63);
      }
      if (maxline && line.length > maxline) {
        output += line.substr(0, maxline) + "\r\n";
        line = line.substr(maxline);
      }
    }
    output += line;
    return output;
  };
  util.binary.base64.decode = function(input, output, offset) {
    var out = output;
    if (!out) {
      out = new Uint8Array(Math.ceil(input.length / 4) * 3);
    }
    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
    offset = offset || 0;
    var enc1, enc2, enc3, enc4;
    var i5 = 0, j23 = offset;
    while (i5 < input.length) {
      enc1 = _base64Idx[input.charCodeAt(i5++) - 43];
      enc2 = _base64Idx[input.charCodeAt(i5++) - 43];
      enc3 = _base64Idx[input.charCodeAt(i5++) - 43];
      enc4 = _base64Idx[input.charCodeAt(i5++) - 43];
      out[j23++] = enc1 << 2 | enc2 >> 4;
      if (enc3 !== 64) {
        out[j23++] = (enc2 & 15) << 4 | enc3 >> 2;
        if (enc4 !== 64) {
          out[j23++] = (enc3 & 3) << 6 | enc4;
        }
      }
    }
    return output ? j23 - offset : out.subarray(0, j23);
  };
  util.binary.base58.encode = function(input, maxline) {
    return util.binary.baseN.encode(input, _base58, maxline);
  };
  util.binary.base58.decode = function(input, maxline) {
    return util.binary.baseN.decode(input, _base58, maxline);
  };
  util.text = {
    utf8: {},
    utf16: {}
  };
  util.text.utf8.encode = function(str2, output, offset) {
    str2 = util.encodeUtf8(str2);
    var out = output;
    if (!out) {
      out = new Uint8Array(str2.length);
    }
    offset = offset || 0;
    var j23 = offset;
    for (var i5 = 0;i5 < str2.length; ++i5) {
      out[j23++] = str2.charCodeAt(i5);
    }
    return output ? j23 - offset : out;
  };
  util.text.utf8.decode = function(bytes) {
    return util.decodeUtf8(String.fromCharCode.apply(null, bytes));
  };
  util.text.utf16.encode = function(str2, output, offset) {
    var out = output;
    if (!out) {
      out = new Uint8Array(str2.length * 2);
    }
    var view = new Uint16Array(out.buffer);
    offset = offset || 0;
    var j23 = offset;
    var k5 = offset;
    for (var i5 = 0;i5 < str2.length; ++i5) {
      view[k5++] = str2.charCodeAt(i5);
      j23 += 2;
    }
    return output ? j23 - offset : out;
  };
  util.text.utf16.decode = function(bytes) {
    return String.fromCharCode.apply(null, new Uint16Array(bytes.buffer));
  };
  util.deflate = function(api, bytes, raw) {
    bytes = util.decode64(api.deflate(util.encode64(bytes)).rval);
    if (raw) {
      var start = 2;
      var flg = bytes.charCodeAt(1);
      if (flg & 32) {
        start = 6;
      }
      bytes = bytes.substring(start, bytes.length - 4);
    }
    return bytes;
  };
  util.inflate = function(api, bytes, raw) {
    var rval = api.inflate(util.encode64(bytes)).rval;
    return rval === null ? null : util.decode64(rval);
  };
  var _setStorageObject = function(api, id, obj) {
    if (!api) {
      throw new Error("WebStorage not available.");
    }
    var rval;
    if (obj === null) {
      rval = api.removeItem(id);
    } else {
      obj = util.encode64(JSON.stringify(obj));
      rval = api.setItem(id, obj);
    }
    if (typeof rval !== "undefined" && rval.rval !== true) {
      var error = new Error(rval.error.message);
      error.id = rval.error.id;
      error.name = rval.error.name;
      throw error;
    }
  };
  var _getStorageObject = function(api, id) {
    if (!api) {
      throw new Error("WebStorage not available.");
    }
    var rval = api.getItem(id);
    if (api.init) {
      if (rval.rval === null) {
        if (rval.error) {
          var error = new Error(rval.error.message);
          error.id = rval.error.id;
          error.name = rval.error.name;
          throw error;
        }
        rval = null;
      } else {
        rval = rval.rval;
      }
    }
    if (rval !== null) {
      rval = JSON.parse(util.decode64(rval));
    }
    return rval;
  };
  var _setItem = function(api, id, key, data2) {
    var obj = _getStorageObject(api, id);
    if (obj === null) {
      obj = {};
    }
    obj[key] = data2;
    _setStorageObject(api, id, obj);
  };
  var _getItem = function(api, id, key) {
    var rval = _getStorageObject(api, id);
    if (rval !== null) {
      rval = key in rval ? rval[key] : null;
    }
    return rval;
  };
  var _removeItem = function(api, id, key) {
    var obj = _getStorageObject(api, id);
    if (obj !== null && key in obj) {
      delete obj[key];
      var empty2 = true;
      for (var prop in obj) {
        empty2 = false;
        break;
      }
      if (empty2) {
        obj = null;
      }
      _setStorageObject(api, id, obj);
    }
  };
  var _clearItems = function(api, id) {
    _setStorageObject(api, id, null);
  };
  var _callStorageFunction = function(func, args, location2) {
    var rval = null;
    if (typeof location2 === "undefined") {
      location2 = ["web", "flash"];
    }
    var type2;
    var done = false;
    var exception2 = null;
    for (var idx in location2) {
      type2 = location2[idx];
      try {
        if (type2 === "flash" || type2 === "both") {
          if (args[0] === null) {
            throw new Error("Flash local storage not available.");
          }
          rval = func.apply(this, args);
          done = type2 === "flash";
        }
        if (type2 === "web" || type2 === "both") {
          args[0] = localStorage;
          rval = func.apply(this, args);
          done = true;
        }
      } catch (ex) {
        exception2 = ex;
      }
      if (done) {
        break;
      }
    }
    if (!done) {
      throw exception2;
    }
    return rval;
  };
  util.setItem = function(api, id, key, data2, location2) {
    _callStorageFunction(_setItem, arguments, location2);
  };
  util.getItem = function(api, id, key, location2) {
    return _callStorageFunction(_getItem, arguments, location2);
  };
  util.removeItem = function(api, id, key, location2) {
    _callStorageFunction(_removeItem, arguments, location2);
  };
  util.clearItems = function(api, id, location2) {
    _callStorageFunction(_clearItems, arguments, location2);
  };
  util.isEmpty = function(obj) {
    for (var prop in obj) {
      if (obj.hasOwnProperty(prop)) {
        return false;
      }
    }
    return true;
  };
  util.format = function(format) {
    var re = /%./g;
    var match;
    var part;
    var argi = 0;
    var parts = [];
    var last = 0;
    while (match = re.exec(format)) {
      part = format.substring(last, re.lastIndex - 2);
      if (part.length > 0) {
        parts.push(part);
      }
      last = re.lastIndex;
      var code = match[0][1];
      switch (code) {
        case "s":
        case "o":
          if (argi < arguments.length) {
            parts.push(arguments[argi++ + 1]);
          } else {
            parts.push("<?>");
          }
          break;
        case "%":
          parts.push("%");
          break;
        default:
          parts.push("<%" + code + "?>");
      }
    }
    parts.push(format.substring(last));
    return parts.join("");
  };
  util.formatNumber = function(number, decimals, dec_point, thousands_sep) {
    var n5 = number, c23 = isNaN(decimals = Math.abs(decimals)) ? 2 : decimals;
    var d5 = dec_point === undefined ? "," : dec_point;
    var t5 = thousands_sep === undefined ? "." : thousands_sep, s32 = n5 < 0 ? "-" : "";
    var i5 = parseInt(n5 = Math.abs(+n5 || 0).toFixed(c23), 10) + "";
    var j23 = i5.length > 3 ? i5.length % 3 : 0;
    return s32 + (j23 ? i5.substr(0, j23) + t5 : "") + i5.substr(j23).replace(/(\d{3})(?=\d)/g, "$1" + t5) + (c23 ? d5 + Math.abs(n5 - i5).toFixed(c23).slice(2) : "");
  };
  util.formatSize = function(size) {
    if (size >= 1073741824) {
      size = util.formatNumber(size / 1073741824, 2, ".", "") + " GiB";
    } else if (size >= 1048576) {
      size = util.formatNumber(size / 1048576, 2, ".", "") + " MiB";
    } else if (size >= 1024) {
      size = util.formatNumber(size / 1024, 0) + " KiB";
    } else {
      size = util.formatNumber(size, 0) + " bytes";
    }
    return size;
  };
  util.bytesFromIP = function(ip) {
    if (ip.indexOf(".") !== -1) {
      return util.bytesFromIPv4(ip);
    }
    if (ip.indexOf(":") !== -1) {
      return util.bytesFromIPv6(ip);
    }
    return null;
  };
  util.bytesFromIPv4 = function(ip) {
    ip = ip.split(".");
    if (ip.length !== 4) {
      return null;
    }
    var b23 = util.createBuffer();
    for (var i5 = 0;i5 < ip.length; ++i5) {
      var num = parseInt(ip[i5], 10);
      if (isNaN(num)) {
        return null;
      }
      b23.putByte(num);
    }
    return b23.getBytes();
  };
  util.bytesFromIPv6 = function(ip) {
    var blanks = 0;
    ip = ip.split(":").filter(function(e5) {
      if (e5.length === 0)
        ++blanks;
      return true;
    });
    var zeros = (8 - ip.length + blanks) * 2;
    var b23 = util.createBuffer();
    for (var i5 = 0;i5 < 8; ++i5) {
      if (!ip[i5] || ip[i5].length === 0) {
        b23.fillWithByte(0, zeros);
        zeros = 0;
        continue;
      }
      var bytes = util.hexToBytes(ip[i5]);
      if (bytes.length < 2) {
        b23.putByte(0);
      }
      b23.putBytes(bytes);
    }
    return b23.getBytes();
  };
  util.bytesToIP = function(bytes) {
    if (bytes.length === 4) {
      return util.bytesToIPv4(bytes);
    }
    if (bytes.length === 16) {
      return util.bytesToIPv6(bytes);
    }
    return null;
  };
  util.bytesToIPv4 = function(bytes) {
    if (bytes.length !== 4) {
      return null;
    }
    var ip = [];
    for (var i5 = 0;i5 < bytes.length; ++i5) {
      ip.push(bytes.charCodeAt(i5));
    }
    return ip.join(".");
  };
  util.bytesToIPv6 = function(bytes) {
    if (bytes.length !== 16) {
      return null;
    }
    var ip = [];
    var zeroGroups = [];
    var zeroMaxGroup = 0;
    for (var i5 = 0;i5 < bytes.length; i5 += 2) {
      var hex = util.bytesToHex(bytes[i5] + bytes[i5 + 1]);
      while (hex[0] === "0" && hex !== "0") {
        hex = hex.substr(1);
      }
      if (hex === "0") {
        var last = zeroGroups[zeroGroups.length - 1];
        var idx = ip.length;
        if (!last || idx !== last.end + 1) {
          zeroGroups.push({ start: idx, end: idx });
        } else {
          last.end = idx;
          if (last.end - last.start > zeroGroups[zeroMaxGroup].end - zeroGroups[zeroMaxGroup].start) {
            zeroMaxGroup = zeroGroups.length - 1;
          }
        }
      }
      ip.push(hex);
    }
    if (zeroGroups.length > 0) {
      var group22 = zeroGroups[zeroMaxGroup];
      if (group22.end - group22.start > 0) {
        ip.splice(group22.start, group22.end - group22.start + 1, "");
        if (group22.start === 0) {
          ip.unshift("");
        }
        if (group22.end === 7) {
          ip.push("");
        }
      }
    }
    return ip.join(":");
  };
  util.estimateCores = function(options23, callback) {
    if (typeof options23 === "function") {
      callback = options23;
      options23 = {};
    }
    options23 = options23 || {};
    if ("cores" in util && !options23.update) {
      return callback(null, util.cores);
    }
    if (typeof navigator !== "undefined" && "hardwareConcurrency" in navigator && navigator.hardwareConcurrency > 0) {
      util.cores = navigator.hardwareConcurrency;
      return callback(null, util.cores);
    }
    if (typeof Worker === "undefined") {
      util.cores = 1;
      return callback(null, util.cores);
    }
    if (typeof Blob === "undefined") {
      util.cores = 2;
      return callback(null, util.cores);
    }
    var blobUrl = URL.createObjectURL(new Blob([
      "(",
      function() {
        self.addEventListener("message", function(e5) {
          var st = Date.now();
          var et2 = st + 4;
          while (Date.now() < et2)
            ;
          self.postMessage({ st, et: et2 });
        });
      }.toString(),
      ")()"
    ], { type: "application/javascript" }));
    sample([], 5, 16);
    function sample(max, samples, numWorkers) {
      if (samples === 0) {
        var avg = Math.floor(max.reduce(function(avg2, x5) {
          return avg2 + x5;
        }, 0) / max.length);
        util.cores = Math.max(1, avg);
        URL.revokeObjectURL(blobUrl);
        return callback(null, util.cores);
      }
      map3(numWorkers, function(err22, results) {
        max.push(reduce(numWorkers, results));
        sample(max, samples - 1, numWorkers);
      });
    }
    function map3(numWorkers, callback2) {
      var workers = [];
      var results = [];
      for (var i5 = 0;i5 < numWorkers; ++i5) {
        var worker = new Worker(blobUrl);
        worker.addEventListener("message", function(e5) {
          results.push(e5.data);
          if (results.length === numWorkers) {
            for (var i22 = 0;i22 < numWorkers; ++i22) {
              workers[i22].terminate();
            }
            callback2(null, results);
          }
        });
        workers.push(worker);
      }
      for (var i5 = 0;i5 < numWorkers; ++i5) {
        workers[i5].postMessage(i5);
      }
    }
    function reduce(numWorkers, results) {
      var overlaps = [];
      for (var n5 = 0;n5 < numWorkers; ++n5) {
        var r1 = results[n5];
        var overlap = overlaps[n5] = [];
        for (var i5 = 0;i5 < numWorkers; ++i5) {
          if (n5 === i5) {
            continue;
          }
          var r23 = results[i5];
          if (r1.st > r23.st && r1.st < r23.et || r23.st > r1.st && r23.st < r1.et) {
            overlap.push(i5);
          }
        }
      }
      return overlaps.reduce(function(max, overlap2) {
        return Math.max(max, overlap2.length);
      }, 0);
    }
  };
});
var require_cipher = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  module.exports = forge.cipher = forge.cipher || {};
  forge.cipher.algorithms = forge.cipher.algorithms || {};
  forge.cipher.createCipher = function(algorithm, key) {
    var api = algorithm;
    if (typeof api === "string") {
      api = forge.cipher.getAlgorithm(api);
      if (api) {
        api = api();
      }
    }
    if (!api) {
      throw new Error("Unsupported algorithm: " + algorithm);
    }
    return new forge.cipher.BlockCipher({
      algorithm: api,
      key,
      decrypt: false
    });
  };
  forge.cipher.createDecipher = function(algorithm, key) {
    var api = algorithm;
    if (typeof api === "string") {
      api = forge.cipher.getAlgorithm(api);
      if (api) {
        api = api();
      }
    }
    if (!api) {
      throw new Error("Unsupported algorithm: " + algorithm);
    }
    return new forge.cipher.BlockCipher({
      algorithm: api,
      key,
      decrypt: true
    });
  };
  forge.cipher.registerAlgorithm = function(name, algorithm) {
    name = name.toUpperCase();
    forge.cipher.algorithms[name] = algorithm;
  };
  forge.cipher.getAlgorithm = function(name) {
    name = name.toUpperCase();
    if (name in forge.cipher.algorithms) {
      return forge.cipher.algorithms[name];
    }
    return null;
  };
  var BlockCipher = forge.cipher.BlockCipher = function(options23) {
    this.algorithm = options23.algorithm;
    this.mode = this.algorithm.mode;
    this.blockSize = this.mode.blockSize;
    this._finish = false;
    this._input = null;
    this.output = null;
    this._op = options23.decrypt ? this.mode.decrypt : this.mode.encrypt;
    this._decrypt = options23.decrypt;
    this.algorithm.initialize(options23);
  };
  BlockCipher.prototype.start = function(options23) {
    options23 = options23 || {};
    var opts = {};
    for (var key in options23) {
      opts[key] = options23[key];
    }
    opts.decrypt = this._decrypt;
    this._finish = false;
    this._input = forge.util.createBuffer();
    this.output = options23.output || forge.util.createBuffer();
    this.mode.start(opts);
  };
  BlockCipher.prototype.update = function(input) {
    if (input) {
      this._input.putBuffer(input);
    }
    while (!this._op.call(this.mode, this._input, this.output, this._finish) && !this._finish) {
    }
    this._input.compact();
  };
  BlockCipher.prototype.finish = function(pad) {
    if (pad && (this.mode.name === "ECB" || this.mode.name === "CBC")) {
      this.mode.pad = function(input) {
        return pad(this.blockSize, input, false);
      };
      this.mode.unpad = function(output) {
        return pad(this.blockSize, output, true);
      };
    }
    var options23 = {};
    options23.decrypt = this._decrypt;
    options23.overflow = this._input.length() % this.blockSize;
    if (!this._decrypt && this.mode.pad) {
      if (!this.mode.pad(this._input, options23)) {
        return false;
      }
    }
    this._finish = true;
    this.update();
    if (this._decrypt && this.mode.unpad) {
      if (!this.mode.unpad(this.output, options23)) {
        return false;
      }
    }
    if (this.mode.afterFinish) {
      if (!this.mode.afterFinish(this.output, options23)) {
        return false;
      }
    }
    return true;
  };
});
var require_cipherModes = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  forge.cipher = forge.cipher || {};
  var modes = module.exports = forge.cipher.modes = forge.cipher.modes || {};
  modes.ecb = function(options23) {
    options23 = options23 || {};
    this.name = "ECB";
    this.cipher = options23.cipher;
    this.blockSize = options23.blockSize || 16;
    this._ints = this.blockSize / 4;
    this._inBlock = new Array(this._ints);
    this._outBlock = new Array(this._ints);
  };
  modes.ecb.prototype.start = function(options23) {
  };
  modes.ecb.prototype.encrypt = function(input, output, finish) {
    if (input.length() < this.blockSize && !(finish && input.length() > 0)) {
      return true;
    }
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this._inBlock[i5] = input.getInt32();
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    for (var i5 = 0;i5 < this._ints; ++i5) {
      output.putInt32(this._outBlock[i5]);
    }
  };
  modes.ecb.prototype.decrypt = function(input, output, finish) {
    if (input.length() < this.blockSize && !(finish && input.length() > 0)) {
      return true;
    }
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this._inBlock[i5] = input.getInt32();
    }
    this.cipher.decrypt(this._inBlock, this._outBlock);
    for (var i5 = 0;i5 < this._ints; ++i5) {
      output.putInt32(this._outBlock[i5]);
    }
  };
  modes.ecb.prototype.pad = function(input, options23) {
    var padding = input.length() === this.blockSize ? this.blockSize : this.blockSize - input.length();
    input.fillWithByte(padding, padding);
    return true;
  };
  modes.ecb.prototype.unpad = function(output, options23) {
    if (options23.overflow > 0) {
      return false;
    }
    var len = output.length();
    var count = output.at(len - 1);
    if (count > this.blockSize << 2) {
      return false;
    }
    output.truncate(count);
    return true;
  };
  modes.cbc = function(options23) {
    options23 = options23 || {};
    this.name = "CBC";
    this.cipher = options23.cipher;
    this.blockSize = options23.blockSize || 16;
    this._ints = this.blockSize / 4;
    this._inBlock = new Array(this._ints);
    this._outBlock = new Array(this._ints);
  };
  modes.cbc.prototype.start = function(options23) {
    if (options23.iv === null) {
      if (!this._prev) {
        throw new Error("Invalid IV parameter.");
      }
      this._iv = this._prev.slice(0);
    } else if (!("iv" in options23)) {
      throw new Error("Invalid IV parameter.");
    } else {
      this._iv = transformIV(options23.iv, this.blockSize);
      this._prev = this._iv.slice(0);
    }
  };
  modes.cbc.prototype.encrypt = function(input, output, finish) {
    if (input.length() < this.blockSize && !(finish && input.length() > 0)) {
      return true;
    }
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this._inBlock[i5] = this._prev[i5] ^ input.getInt32();
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    for (var i5 = 0;i5 < this._ints; ++i5) {
      output.putInt32(this._outBlock[i5]);
    }
    this._prev = this._outBlock;
  };
  modes.cbc.prototype.decrypt = function(input, output, finish) {
    if (input.length() < this.blockSize && !(finish && input.length() > 0)) {
      return true;
    }
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this._inBlock[i5] = input.getInt32();
    }
    this.cipher.decrypt(this._inBlock, this._outBlock);
    for (var i5 = 0;i5 < this._ints; ++i5) {
      output.putInt32(this._prev[i5] ^ this._outBlock[i5]);
    }
    this._prev = this._inBlock.slice(0);
  };
  modes.cbc.prototype.pad = function(input, options23) {
    var padding = input.length() === this.blockSize ? this.blockSize : this.blockSize - input.length();
    input.fillWithByte(padding, padding);
    return true;
  };
  modes.cbc.prototype.unpad = function(output, options23) {
    if (options23.overflow > 0) {
      return false;
    }
    var len = output.length();
    var count = output.at(len - 1);
    if (count > this.blockSize << 2) {
      return false;
    }
    output.truncate(count);
    return true;
  };
  modes.cfb = function(options23) {
    options23 = options23 || {};
    this.name = "CFB";
    this.cipher = options23.cipher;
    this.blockSize = options23.blockSize || 16;
    this._ints = this.blockSize / 4;
    this._inBlock = null;
    this._outBlock = new Array(this._ints);
    this._partialBlock = new Array(this._ints);
    this._partialOutput = forge.util.createBuffer();
    this._partialBytes = 0;
  };
  modes.cfb.prototype.start = function(options23) {
    if (!("iv" in options23)) {
      throw new Error("Invalid IV parameter.");
    }
    this._iv = transformIV(options23.iv, this.blockSize);
    this._inBlock = this._iv.slice(0);
    this._partialBytes = 0;
  };
  modes.cfb.prototype.encrypt = function(input, output, finish) {
    var inputLength = input.length();
    if (inputLength === 0) {
      return true;
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    if (this._partialBytes === 0 && inputLength >= this.blockSize) {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        this._inBlock[i5] = input.getInt32() ^ this._outBlock[i5];
        output.putInt32(this._inBlock[i5]);
      }
      return;
    }
    var partialBytes = (this.blockSize - inputLength) % this.blockSize;
    if (partialBytes > 0) {
      partialBytes = this.blockSize - partialBytes;
    }
    this._partialOutput.clear();
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this._partialBlock[i5] = input.getInt32() ^ this._outBlock[i5];
      this._partialOutput.putInt32(this._partialBlock[i5]);
    }
    if (partialBytes > 0) {
      input.read -= this.blockSize;
    } else {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        this._inBlock[i5] = this._partialBlock[i5];
      }
    }
    if (this._partialBytes > 0) {
      this._partialOutput.getBytes(this._partialBytes);
    }
    if (partialBytes > 0 && !finish) {
      output.putBytes(this._partialOutput.getBytes(partialBytes - this._partialBytes));
      this._partialBytes = partialBytes;
      return true;
    }
    output.putBytes(this._partialOutput.getBytes(inputLength - this._partialBytes));
    this._partialBytes = 0;
  };
  modes.cfb.prototype.decrypt = function(input, output, finish) {
    var inputLength = input.length();
    if (inputLength === 0) {
      return true;
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    if (this._partialBytes === 0 && inputLength >= this.blockSize) {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        this._inBlock[i5] = input.getInt32();
        output.putInt32(this._inBlock[i5] ^ this._outBlock[i5]);
      }
      return;
    }
    var partialBytes = (this.blockSize - inputLength) % this.blockSize;
    if (partialBytes > 0) {
      partialBytes = this.blockSize - partialBytes;
    }
    this._partialOutput.clear();
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this._partialBlock[i5] = input.getInt32();
      this._partialOutput.putInt32(this._partialBlock[i5] ^ this._outBlock[i5]);
    }
    if (partialBytes > 0) {
      input.read -= this.blockSize;
    } else {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        this._inBlock[i5] = this._partialBlock[i5];
      }
    }
    if (this._partialBytes > 0) {
      this._partialOutput.getBytes(this._partialBytes);
    }
    if (partialBytes > 0 && !finish) {
      output.putBytes(this._partialOutput.getBytes(partialBytes - this._partialBytes));
      this._partialBytes = partialBytes;
      return true;
    }
    output.putBytes(this._partialOutput.getBytes(inputLength - this._partialBytes));
    this._partialBytes = 0;
  };
  modes.ofb = function(options23) {
    options23 = options23 || {};
    this.name = "OFB";
    this.cipher = options23.cipher;
    this.blockSize = options23.blockSize || 16;
    this._ints = this.blockSize / 4;
    this._inBlock = null;
    this._outBlock = new Array(this._ints);
    this._partialOutput = forge.util.createBuffer();
    this._partialBytes = 0;
  };
  modes.ofb.prototype.start = function(options23) {
    if (!("iv" in options23)) {
      throw new Error("Invalid IV parameter.");
    }
    this._iv = transformIV(options23.iv, this.blockSize);
    this._inBlock = this._iv.slice(0);
    this._partialBytes = 0;
  };
  modes.ofb.prototype.encrypt = function(input, output, finish) {
    var inputLength = input.length();
    if (input.length() === 0) {
      return true;
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    if (this._partialBytes === 0 && inputLength >= this.blockSize) {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        output.putInt32(input.getInt32() ^ this._outBlock[i5]);
        this._inBlock[i5] = this._outBlock[i5];
      }
      return;
    }
    var partialBytes = (this.blockSize - inputLength) % this.blockSize;
    if (partialBytes > 0) {
      partialBytes = this.blockSize - partialBytes;
    }
    this._partialOutput.clear();
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this._partialOutput.putInt32(input.getInt32() ^ this._outBlock[i5]);
    }
    if (partialBytes > 0) {
      input.read -= this.blockSize;
    } else {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        this._inBlock[i5] = this._outBlock[i5];
      }
    }
    if (this._partialBytes > 0) {
      this._partialOutput.getBytes(this._partialBytes);
    }
    if (partialBytes > 0 && !finish) {
      output.putBytes(this._partialOutput.getBytes(partialBytes - this._partialBytes));
      this._partialBytes = partialBytes;
      return true;
    }
    output.putBytes(this._partialOutput.getBytes(inputLength - this._partialBytes));
    this._partialBytes = 0;
  };
  modes.ofb.prototype.decrypt = modes.ofb.prototype.encrypt;
  modes.ctr = function(options23) {
    options23 = options23 || {};
    this.name = "CTR";
    this.cipher = options23.cipher;
    this.blockSize = options23.blockSize || 16;
    this._ints = this.blockSize / 4;
    this._inBlock = null;
    this._outBlock = new Array(this._ints);
    this._partialOutput = forge.util.createBuffer();
    this._partialBytes = 0;
  };
  modes.ctr.prototype.start = function(options23) {
    if (!("iv" in options23)) {
      throw new Error("Invalid IV parameter.");
    }
    this._iv = transformIV(options23.iv, this.blockSize);
    this._inBlock = this._iv.slice(0);
    this._partialBytes = 0;
  };
  modes.ctr.prototype.encrypt = function(input, output, finish) {
    var inputLength = input.length();
    if (inputLength === 0) {
      return true;
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    if (this._partialBytes === 0 && inputLength >= this.blockSize) {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        output.putInt32(input.getInt32() ^ this._outBlock[i5]);
      }
    } else {
      var partialBytes = (this.blockSize - inputLength) % this.blockSize;
      if (partialBytes > 0) {
        partialBytes = this.blockSize - partialBytes;
      }
      this._partialOutput.clear();
      for (var i5 = 0;i5 < this._ints; ++i5) {
        this._partialOutput.putInt32(input.getInt32() ^ this._outBlock[i5]);
      }
      if (partialBytes > 0) {
        input.read -= this.blockSize;
      }
      if (this._partialBytes > 0) {
        this._partialOutput.getBytes(this._partialBytes);
      }
      if (partialBytes > 0 && !finish) {
        output.putBytes(this._partialOutput.getBytes(partialBytes - this._partialBytes));
        this._partialBytes = partialBytes;
        return true;
      }
      output.putBytes(this._partialOutput.getBytes(inputLength - this._partialBytes));
      this._partialBytes = 0;
    }
    inc32(this._inBlock);
  };
  modes.ctr.prototype.decrypt = modes.ctr.prototype.encrypt;
  modes.gcm = function(options23) {
    options23 = options23 || {};
    this.name = "GCM";
    this.cipher = options23.cipher;
    this.blockSize = options23.blockSize || 16;
    this._ints = this.blockSize / 4;
    this._inBlock = new Array(this._ints);
    this._outBlock = new Array(this._ints);
    this._partialOutput = forge.util.createBuffer();
    this._partialBytes = 0;
    this._R = 3774873600;
  };
  modes.gcm.prototype.start = function(options23) {
    if (!("iv" in options23)) {
      throw new Error("Invalid IV parameter.");
    }
    var iv = forge.util.createBuffer(options23.iv);
    this._cipherLength = 0;
    var additionalData;
    if ("additionalData" in options23) {
      additionalData = forge.util.createBuffer(options23.additionalData);
    } else {
      additionalData = forge.util.createBuffer();
    }
    if ("tagLength" in options23) {
      this._tagLength = options23.tagLength;
    } else {
      this._tagLength = 128;
    }
    this._tag = null;
    if (options23.decrypt) {
      this._tag = forge.util.createBuffer(options23.tag).getBytes();
      if (this._tag.length !== this._tagLength / 8) {
        throw new Error("Authentication tag does not match tag length.");
      }
    }
    this._hashBlock = new Array(this._ints);
    this.tag = null;
    this._hashSubkey = new Array(this._ints);
    this.cipher.encrypt([0, 0, 0, 0], this._hashSubkey);
    this.componentBits = 4;
    this._m = this.generateHashTable(this._hashSubkey, this.componentBits);
    var ivLength = iv.length();
    if (ivLength === 12) {
      this._j0 = [iv.getInt32(), iv.getInt32(), iv.getInt32(), 1];
    } else {
      this._j0 = [0, 0, 0, 0];
      while (iv.length() > 0) {
        this._j0 = this.ghash(this._hashSubkey, this._j0, [iv.getInt32(), iv.getInt32(), iv.getInt32(), iv.getInt32()]);
      }
      this._j0 = this.ghash(this._hashSubkey, this._j0, [0, 0].concat(from64To32(ivLength * 8)));
    }
    this._inBlock = this._j0.slice(0);
    inc32(this._inBlock);
    this._partialBytes = 0;
    additionalData = forge.util.createBuffer(additionalData);
    this._aDataLength = from64To32(additionalData.length() * 8);
    var overflow = additionalData.length() % this.blockSize;
    if (overflow) {
      additionalData.fillWithByte(0, this.blockSize - overflow);
    }
    this._s = [0, 0, 0, 0];
    while (additionalData.length() > 0) {
      this._s = this.ghash(this._hashSubkey, this._s, [
        additionalData.getInt32(),
        additionalData.getInt32(),
        additionalData.getInt32(),
        additionalData.getInt32()
      ]);
    }
  };
  modes.gcm.prototype.encrypt = function(input, output, finish) {
    var inputLength = input.length();
    if (inputLength === 0) {
      return true;
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    if (this._partialBytes === 0 && inputLength >= this.blockSize) {
      for (var i5 = 0;i5 < this._ints; ++i5) {
        output.putInt32(this._outBlock[i5] ^= input.getInt32());
      }
      this._cipherLength += this.blockSize;
    } else {
      var partialBytes = (this.blockSize - inputLength) % this.blockSize;
      if (partialBytes > 0) {
        partialBytes = this.blockSize - partialBytes;
      }
      this._partialOutput.clear();
      for (var i5 = 0;i5 < this._ints; ++i5) {
        this._partialOutput.putInt32(input.getInt32() ^ this._outBlock[i5]);
      }
      if (partialBytes <= 0 || finish) {
        if (finish) {
          var overflow = inputLength % this.blockSize;
          this._cipherLength += overflow;
          this._partialOutput.truncate(this.blockSize - overflow);
        } else {
          this._cipherLength += this.blockSize;
        }
        for (var i5 = 0;i5 < this._ints; ++i5) {
          this._outBlock[i5] = this._partialOutput.getInt32();
        }
        this._partialOutput.read -= this.blockSize;
      }
      if (this._partialBytes > 0) {
        this._partialOutput.getBytes(this._partialBytes);
      }
      if (partialBytes > 0 && !finish) {
        input.read -= this.blockSize;
        output.putBytes(this._partialOutput.getBytes(partialBytes - this._partialBytes));
        this._partialBytes = partialBytes;
        return true;
      }
      output.putBytes(this._partialOutput.getBytes(inputLength - this._partialBytes));
      this._partialBytes = 0;
    }
    this._s = this.ghash(this._hashSubkey, this._s, this._outBlock);
    inc32(this._inBlock);
  };
  modes.gcm.prototype.decrypt = function(input, output, finish) {
    var inputLength = input.length();
    if (inputLength < this.blockSize && !(finish && inputLength > 0)) {
      return true;
    }
    this.cipher.encrypt(this._inBlock, this._outBlock);
    inc32(this._inBlock);
    this._hashBlock[0] = input.getInt32();
    this._hashBlock[1] = input.getInt32();
    this._hashBlock[2] = input.getInt32();
    this._hashBlock[3] = input.getInt32();
    this._s = this.ghash(this._hashSubkey, this._s, this._hashBlock);
    for (var i5 = 0;i5 < this._ints; ++i5) {
      output.putInt32(this._outBlock[i5] ^ this._hashBlock[i5]);
    }
    if (inputLength < this.blockSize) {
      this._cipherLength += inputLength % this.blockSize;
    } else {
      this._cipherLength += this.blockSize;
    }
  };
  modes.gcm.prototype.afterFinish = function(output, options23) {
    var rval = true;
    if (options23.decrypt && options23.overflow) {
      output.truncate(this.blockSize - options23.overflow);
    }
    this.tag = forge.util.createBuffer();
    var lengths = this._aDataLength.concat(from64To32(this._cipherLength * 8));
    this._s = this.ghash(this._hashSubkey, this._s, lengths);
    var tag = [];
    this.cipher.encrypt(this._j0, tag);
    for (var i5 = 0;i5 < this._ints; ++i5) {
      this.tag.putInt32(this._s[i5] ^ tag[i5]);
    }
    this.tag.truncate(this.tag.length() % (this._tagLength / 8));
    if (options23.decrypt && this.tag.bytes() !== this._tag) {
      rval = false;
    }
    return rval;
  };
  modes.gcm.prototype.multiply = function(x5, y3) {
    var z_i = [0, 0, 0, 0];
    var v_i = y3.slice(0);
    for (var i5 = 0;i5 < 128; ++i5) {
      var x_i = x5[i5 / 32 | 0] & 1 << 31 - i5 % 32;
      if (x_i) {
        z_i[0] ^= v_i[0];
        z_i[1] ^= v_i[1];
        z_i[2] ^= v_i[2];
        z_i[3] ^= v_i[3];
      }
      this.pow(v_i, v_i);
    }
    return z_i;
  };
  modes.gcm.prototype.pow = function(x5, out) {
    var lsb = x5[3] & 1;
    for (var i5 = 3;i5 > 0; --i5) {
      out[i5] = x5[i5] >>> 1 | (x5[i5 - 1] & 1) << 31;
    }
    out[0] = x5[0] >>> 1;
    if (lsb) {
      out[0] ^= this._R;
    }
  };
  modes.gcm.prototype.tableMultiply = function(x5) {
    var z23 = [0, 0, 0, 0];
    for (var i5 = 0;i5 < 32; ++i5) {
      var idx = i5 / 8 | 0;
      var x_i = x5[idx] >>> (7 - i5 % 8) * 4 & 15;
      var ah2 = this._m[i5][x_i];
      z23[0] ^= ah2[0];
      z23[1] ^= ah2[1];
      z23[2] ^= ah2[2];
      z23[3] ^= ah2[3];
    }
    return z23;
  };
  modes.gcm.prototype.ghash = function(h33, y3, x5) {
    y3[0] ^= x5[0];
    y3[1] ^= x5[1];
    y3[2] ^= x5[2];
    y3[3] ^= x5[3];
    return this.tableMultiply(y3);
  };
  modes.gcm.prototype.generateHashTable = function(h33, bits) {
    var multiplier = 8 / bits;
    var perInt = 4 * multiplier;
    var size = 16 * multiplier;
    var m23 = new Array(size);
    for (var i5 = 0;i5 < size; ++i5) {
      var tmp = [0, 0, 0, 0];
      var idx = i5 / perInt | 0;
      var shft = (perInt - 1 - i5 % perInt) * bits;
      tmp[idx] = 1 << bits - 1 << shft;
      m23[i5] = this.generateSubHashTable(this.multiply(tmp, h33), bits);
    }
    return m23;
  };
  modes.gcm.prototype.generateSubHashTable = function(mid, bits) {
    var size = 1 << bits;
    var half = size >>> 1;
    var m23 = new Array(size);
    m23[half] = mid.slice(0);
    var i5 = half >>> 1;
    while (i5 > 0) {
      this.pow(m23[2 * i5], m23[i5] = []);
      i5 >>= 1;
    }
    i5 = 2;
    while (i5 < half) {
      for (var j23 = 1;j23 < i5; ++j23) {
        var m_i = m23[i5];
        var m_j = m23[j23];
        m23[i5 + j23] = [
          m_i[0] ^ m_j[0],
          m_i[1] ^ m_j[1],
          m_i[2] ^ m_j[2],
          m_i[3] ^ m_j[3]
        ];
      }
      i5 *= 2;
    }
    m23[0] = [0, 0, 0, 0];
    for (i5 = half + 1;i5 < size; ++i5) {
      var c23 = m23[i5 ^ half];
      m23[i5] = [mid[0] ^ c23[0], mid[1] ^ c23[1], mid[2] ^ c23[2], mid[3] ^ c23[3]];
    }
    return m23;
  };
  function transformIV(iv, blockSize) {
    if (typeof iv === "string") {
      iv = forge.util.createBuffer(iv);
    }
    if (forge.util.isArray(iv) && iv.length > 4) {
      var tmp = iv;
      iv = forge.util.createBuffer();
      for (var i5 = 0;i5 < tmp.length; ++i5) {
        iv.putByte(tmp[i5]);
      }
    }
    if (iv.length() < blockSize) {
      throw new Error("Invalid IV length; got " + iv.length() + " bytes and expected " + blockSize + " bytes.");
    }
    if (!forge.util.isArray(iv)) {
      var ints = [];
      var blocks = blockSize / 4;
      for (var i5 = 0;i5 < blocks; ++i5) {
        ints.push(iv.getInt32());
      }
      iv = ints;
    }
    return iv;
  }
  function inc32(block) {
    block[block.length - 1] = block[block.length - 1] + 1 & 4294967295;
  }
  function from64To32(num) {
    return [num / 4294967296 | 0, num & 4294967295];
  }
});
var require_aes2 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_cipher();
  require_cipherModes();
  require_util33();
  module.exports = forge.aes = forge.aes || {};
  forge.aes.startEncrypting = function(key, iv, output, mode) {
    var cipher = _createCipher({
      key,
      output,
      decrypt: false,
      mode
    });
    cipher.start(iv);
    return cipher;
  };
  forge.aes.createEncryptionCipher = function(key, mode) {
    return _createCipher({
      key,
      output: null,
      decrypt: false,
      mode
    });
  };
  forge.aes.startDecrypting = function(key, iv, output, mode) {
    var cipher = _createCipher({
      key,
      output,
      decrypt: true,
      mode
    });
    cipher.start(iv);
    return cipher;
  };
  forge.aes.createDecryptionCipher = function(key, mode) {
    return _createCipher({
      key,
      output: null,
      decrypt: true,
      mode
    });
  };
  forge.aes.Algorithm = function(name, mode) {
    if (!init23) {
      initialize();
    }
    var self2 = this;
    self2.name = name;
    self2.mode = new mode({
      blockSize: 16,
      cipher: {
        encrypt: function(inBlock, outBlock) {
          return _updateBlock(self2._w, inBlock, outBlock, false);
        },
        decrypt: function(inBlock, outBlock) {
          return _updateBlock(self2._w, inBlock, outBlock, true);
        }
      }
    });
    self2._init = false;
  };
  forge.aes.Algorithm.prototype.initialize = function(options23) {
    if (this._init) {
      return;
    }
    var key = options23.key;
    var tmp;
    if (typeof key === "string" && (key.length === 16 || key.length === 24 || key.length === 32)) {
      key = forge.util.createBuffer(key);
    } else if (forge.util.isArray(key) && (key.length === 16 || key.length === 24 || key.length === 32)) {
      tmp = key;
      key = forge.util.createBuffer();
      for (var i5 = 0;i5 < tmp.length; ++i5) {
        key.putByte(tmp[i5]);
      }
    }
    if (!forge.util.isArray(key)) {
      tmp = key;
      key = [];
      var len = tmp.length();
      if (len === 16 || len === 24 || len === 32) {
        len = len >>> 2;
        for (var i5 = 0;i5 < len; ++i5) {
          key.push(tmp.getInt32());
        }
      }
    }
    if (!forge.util.isArray(key) || !(key.length === 4 || key.length === 6 || key.length === 8)) {
      throw new Error("Invalid key parameter.");
    }
    var mode = this.mode.name;
    var encryptOp = ["CFB", "OFB", "CTR", "GCM"].indexOf(mode) !== -1;
    this._w = _expandKey(key, options23.decrypt && !encryptOp);
    this._init = true;
  };
  forge.aes._expandKey = function(key, decrypt) {
    if (!init23) {
      initialize();
    }
    return _expandKey(key, decrypt);
  };
  forge.aes._updateBlock = _updateBlock;
  registerAlgorithm("AES-ECB", forge.cipher.modes.ecb);
  registerAlgorithm("AES-CBC", forge.cipher.modes.cbc);
  registerAlgorithm("AES-CFB", forge.cipher.modes.cfb);
  registerAlgorithm("AES-OFB", forge.cipher.modes.ofb);
  registerAlgorithm("AES-CTR", forge.cipher.modes.ctr);
  registerAlgorithm("AES-GCM", forge.cipher.modes.gcm);
  function registerAlgorithm(name, mode) {
    var factory = function() {
      return new forge.aes.Algorithm(name, mode);
    };
    forge.cipher.registerAlgorithm(name, factory);
  }
  var init23 = false;
  var Nb = 4;
  var sbox;
  var isbox;
  var rcon;
  var mix;
  var imix;
  function initialize() {
    init23 = true;
    rcon = [0, 1, 2, 4, 8, 16, 32, 64, 128, 27, 54];
    var xtime = new Array(256);
    for (var i5 = 0;i5 < 128; ++i5) {
      xtime[i5] = i5 << 1;
      xtime[i5 + 128] = i5 + 128 << 1 ^ 283;
    }
    sbox = new Array(256);
    isbox = new Array(256);
    mix = new Array(4);
    imix = new Array(4);
    for (var i5 = 0;i5 < 4; ++i5) {
      mix[i5] = new Array(256);
      imix[i5] = new Array(256);
    }
    var e5 = 0, ei = 0, e22, e42, e8, sx, sx2, me, ime;
    for (var i5 = 0;i5 < 256; ++i5) {
      sx = ei ^ ei << 1 ^ ei << 2 ^ ei << 3 ^ ei << 4;
      sx = sx >> 8 ^ sx & 255 ^ 99;
      sbox[e5] = sx;
      isbox[sx] = e5;
      sx2 = xtime[sx];
      e22 = xtime[e5];
      e42 = xtime[e22];
      e8 = xtime[e42];
      me = sx2 << 24 ^ sx << 16 ^ sx << 8 ^ (sx ^ sx2);
      ime = (e22 ^ e42 ^ e8) << 24 ^ (e5 ^ e8) << 16 ^ (e5 ^ e42 ^ e8) << 8 ^ (e5 ^ e22 ^ e8);
      for (var n5 = 0;n5 < 4; ++n5) {
        mix[n5][e5] = me;
        imix[n5][sx] = ime;
        me = me << 24 | me >>> 8;
        ime = ime << 24 | ime >>> 8;
      }
      if (e5 === 0) {
        e5 = ei = 1;
      } else {
        e5 = e22 ^ xtime[xtime[xtime[e22 ^ e8]]];
        ei ^= xtime[xtime[ei]];
      }
    }
  }
  function _expandKey(key, decrypt) {
    var w23 = key.slice(0);
    var temp, iNk = 1;
    var Nk = w23.length;
    var Nr1 = Nk + 6 + 1;
    var end = Nb * Nr1;
    for (var i5 = Nk;i5 < end; ++i5) {
      temp = w23[i5 - 1];
      if (i5 % Nk === 0) {
        temp = sbox[temp >>> 16 & 255] << 24 ^ sbox[temp >>> 8 & 255] << 16 ^ sbox[temp & 255] << 8 ^ sbox[temp >>> 24] ^ rcon[iNk] << 24;
        iNk++;
      } else if (Nk > 6 && i5 % Nk === 4) {
        temp = sbox[temp >>> 24] << 24 ^ sbox[temp >>> 16 & 255] << 16 ^ sbox[temp >>> 8 & 255] << 8 ^ sbox[temp & 255];
      }
      w23[i5] = w23[i5 - Nk] ^ temp;
    }
    if (decrypt) {
      var tmp;
      var m0 = imix[0];
      var m1 = imix[1];
      var m23 = imix[2];
      var m32 = imix[3];
      var wnew = w23.slice(0);
      end = w23.length;
      for (var i5 = 0, wi = end - Nb;i5 < end; i5 += Nb, wi -= Nb) {
        if (i5 === 0 || i5 === end - Nb) {
          wnew[i5] = w23[wi];
          wnew[i5 + 1] = w23[wi + 3];
          wnew[i5 + 2] = w23[wi + 2];
          wnew[i5 + 3] = w23[wi + 1];
        } else {
          for (var n5 = 0;n5 < Nb; ++n5) {
            tmp = w23[wi + n5];
            wnew[i5 + (3 & -n5)] = m0[sbox[tmp >>> 24]] ^ m1[sbox[tmp >>> 16 & 255]] ^ m23[sbox[tmp >>> 8 & 255]] ^ m32[sbox[tmp & 255]];
          }
        }
      }
      w23 = wnew;
    }
    return w23;
  }
  function _updateBlock(w23, input, output, decrypt) {
    var Nr = w23.length / 4 - 1;
    var m0, m1, m23, m32, sub;
    if (decrypt) {
      m0 = imix[0];
      m1 = imix[1];
      m23 = imix[2];
      m32 = imix[3];
      sub = isbox;
    } else {
      m0 = mix[0];
      m1 = mix[1];
      m23 = mix[2];
      m32 = mix[3];
      sub = sbox;
    }
    var a5, b23, c23, d5, a22, b222, c222;
    a5 = input[0] ^ w23[0];
    b23 = input[decrypt ? 3 : 1] ^ w23[1];
    c23 = input[2] ^ w23[2];
    d5 = input[decrypt ? 1 : 3] ^ w23[3];
    var i5 = 3;
    for (var round = 1;round < Nr; ++round) {
      a22 = m0[a5 >>> 24] ^ m1[b23 >>> 16 & 255] ^ m23[c23 >>> 8 & 255] ^ m32[d5 & 255] ^ w23[++i5];
      b222 = m0[b23 >>> 24] ^ m1[c23 >>> 16 & 255] ^ m23[d5 >>> 8 & 255] ^ m32[a5 & 255] ^ w23[++i5];
      c222 = m0[c23 >>> 24] ^ m1[d5 >>> 16 & 255] ^ m23[a5 >>> 8 & 255] ^ m32[b23 & 255] ^ w23[++i5];
      d5 = m0[d5 >>> 24] ^ m1[a5 >>> 16 & 255] ^ m23[b23 >>> 8 & 255] ^ m32[c23 & 255] ^ w23[++i5];
      a5 = a22;
      b23 = b222;
      c23 = c222;
    }
    output[0] = sub[a5 >>> 24] << 24 ^ sub[b23 >>> 16 & 255] << 16 ^ sub[c23 >>> 8 & 255] << 8 ^ sub[d5 & 255] ^ w23[++i5];
    output[decrypt ? 3 : 1] = sub[b23 >>> 24] << 24 ^ sub[c23 >>> 16 & 255] << 16 ^ sub[d5 >>> 8 & 255] << 8 ^ sub[a5 & 255] ^ w23[++i5];
    output[2] = sub[c23 >>> 24] << 24 ^ sub[d5 >>> 16 & 255] << 16 ^ sub[a5 >>> 8 & 255] << 8 ^ sub[b23 & 255] ^ w23[++i5];
    output[decrypt ? 1 : 3] = sub[d5 >>> 24] << 24 ^ sub[a5 >>> 16 & 255] << 16 ^ sub[b23 >>> 8 & 255] << 8 ^ sub[c23 & 255] ^ w23[++i5];
  }
  function _createCipher(options23) {
    options23 = options23 || {};
    var mode = (options23.mode || "CBC").toUpperCase();
    var algorithm = "AES-" + mode;
    var cipher;
    if (options23.decrypt) {
      cipher = forge.cipher.createDecipher(algorithm, options23.key);
    } else {
      cipher = forge.cipher.createCipher(algorithm, options23.key);
    }
    var start = cipher.start;
    cipher.start = function(iv, options3) {
      var output = null;
      if (options3 instanceof forge.util.ByteBuffer) {
        output = options3;
        options3 = {};
      }
      options3 = options3 || {};
      options3.output = output;
      options3.iv = iv;
      start.call(cipher, options3);
    };
    return cipher;
  }
});
var require_oids = __commonJS3((exports, module) => {
  var forge = require_forge();
  forge.pki = forge.pki || {};
  var oids = module.exports = forge.pki.oids = forge.oids = forge.oids || {};
  function _IN(id, name) {
    oids[id] = name;
    oids[name] = id;
  }
  function _I_(id, name) {
    oids[id] = name;
  }
  _IN("1.2.840.113549.1.1.1", "rsaEncryption");
  _IN("1.2.840.113549.1.1.4", "md5WithRSAEncryption");
  _IN("1.2.840.113549.1.1.5", "sha1WithRSAEncryption");
  _IN("1.2.840.113549.1.1.7", "RSAES-OAEP");
  _IN("1.2.840.113549.1.1.8", "mgf1");
  _IN("1.2.840.113549.1.1.9", "pSpecified");
  _IN("1.2.840.113549.1.1.10", "RSASSA-PSS");
  _IN("1.2.840.113549.1.1.11", "sha256WithRSAEncryption");
  _IN("1.2.840.113549.1.1.12", "sha384WithRSAEncryption");
  _IN("1.2.840.113549.1.1.13", "sha512WithRSAEncryption");
  _IN("1.3.101.112", "EdDSA25519");
  _IN("1.2.840.10040.4.3", "dsa-with-sha1");
  _IN("1.3.14.3.2.7", "desCBC");
  _IN("1.3.14.3.2.26", "sha1");
  _IN("1.3.14.3.2.29", "sha1WithRSASignature");
  _IN("2.16.840.1.101.3.4.2.1", "sha256");
  _IN("2.16.840.1.101.3.4.2.2", "sha384");
  _IN("2.16.840.1.101.3.4.2.3", "sha512");
  _IN("2.16.840.1.101.3.4.2.4", "sha224");
  _IN("2.16.840.1.101.3.4.2.5", "sha512-224");
  _IN("2.16.840.1.101.3.4.2.6", "sha512-256");
  _IN("1.2.840.113549.2.2", "md2");
  _IN("1.2.840.113549.2.5", "md5");
  _IN("1.2.840.113549.1.7.1", "data");
  _IN("1.2.840.113549.1.7.2", "signedData");
  _IN("1.2.840.113549.1.7.3", "envelopedData");
  _IN("1.2.840.113549.1.7.4", "signedAndEnvelopedData");
  _IN("1.2.840.113549.1.7.5", "digestedData");
  _IN("1.2.840.113549.1.7.6", "encryptedData");
  _IN("1.2.840.113549.1.9.1", "emailAddress");
  _IN("1.2.840.113549.1.9.2", "unstructuredName");
  _IN("1.2.840.113549.1.9.3", "contentType");
  _IN("1.2.840.113549.1.9.4", "messageDigest");
  _IN("1.2.840.113549.1.9.5", "signingTime");
  _IN("1.2.840.113549.1.9.6", "counterSignature");
  _IN("1.2.840.113549.1.9.7", "challengePassword");
  _IN("1.2.840.113549.1.9.8", "unstructuredAddress");
  _IN("1.2.840.113549.1.9.14", "extensionRequest");
  _IN("1.2.840.113549.1.9.20", "friendlyName");
  _IN("1.2.840.113549.1.9.21", "localKeyId");
  _IN("1.2.840.113549.1.9.22.1", "x509Certificate");
  _IN("1.2.840.113549.1.12.10.1.1", "keyBag");
  _IN("1.2.840.113549.1.12.10.1.2", "pkcs8ShroudedKeyBag");
  _IN("1.2.840.113549.1.12.10.1.3", "certBag");
  _IN("1.2.840.113549.1.12.10.1.4", "crlBag");
  _IN("1.2.840.113549.1.12.10.1.5", "secretBag");
  _IN("1.2.840.113549.1.12.10.1.6", "safeContentsBag");
  _IN("1.2.840.113549.1.5.13", "pkcs5PBES2");
  _IN("1.2.840.113549.1.5.12", "pkcs5PBKDF2");
  _IN("1.2.840.113549.1.12.1.1", "pbeWithSHAAnd128BitRC4");
  _IN("1.2.840.113549.1.12.1.2", "pbeWithSHAAnd40BitRC4");
  _IN("1.2.840.113549.1.12.1.3", "pbeWithSHAAnd3-KeyTripleDES-CBC");
  _IN("1.2.840.113549.1.12.1.4", "pbeWithSHAAnd2-KeyTripleDES-CBC");
  _IN("1.2.840.113549.1.12.1.5", "pbeWithSHAAnd128BitRC2-CBC");
  _IN("1.2.840.113549.1.12.1.6", "pbewithSHAAnd40BitRC2-CBC");
  _IN("1.2.840.113549.2.7", "hmacWithSHA1");
  _IN("1.2.840.113549.2.8", "hmacWithSHA224");
  _IN("1.2.840.113549.2.9", "hmacWithSHA256");
  _IN("1.2.840.113549.2.10", "hmacWithSHA384");
  _IN("1.2.840.113549.2.11", "hmacWithSHA512");
  _IN("1.2.840.113549.3.7", "des-EDE3-CBC");
  _IN("2.16.840.1.101.3.4.1.2", "aes128-CBC");
  _IN("2.16.840.1.101.3.4.1.22", "aes192-CBC");
  _IN("2.16.840.1.101.3.4.1.42", "aes256-CBC");
  _IN("2.5.4.3", "commonName");
  _IN("2.5.4.4", "surname");
  _IN("2.5.4.5", "serialNumber");
  _IN("2.5.4.6", "countryName");
  _IN("2.5.4.7", "localityName");
  _IN("2.5.4.8", "stateOrProvinceName");
  _IN("2.5.4.9", "streetAddress");
  _IN("2.5.4.10", "organizationName");
  _IN("2.5.4.11", "organizationalUnitName");
  _IN("2.5.4.12", "title");
  _IN("2.5.4.13", "description");
  _IN("2.5.4.15", "businessCategory");
  _IN("2.5.4.17", "postalCode");
  _IN("2.5.4.42", "givenName");
  _IN("1.3.6.1.4.1.311.60.2.1.2", "jurisdictionOfIncorporationStateOrProvinceName");
  _IN("1.3.6.1.4.1.311.60.2.1.3", "jurisdictionOfIncorporationCountryName");
  _IN("2.16.840.1.113730.1.1", "nsCertType");
  _IN("2.16.840.1.113730.1.13", "nsComment");
  _I_("2.5.29.1", "authorityKeyIdentifier");
  _I_("2.5.29.2", "keyAttributes");
  _I_("2.5.29.3", "certificatePolicies");
  _I_("2.5.29.4", "keyUsageRestriction");
  _I_("2.5.29.5", "policyMapping");
  _I_("2.5.29.6", "subtreesConstraint");
  _I_("2.5.29.7", "subjectAltName");
  _I_("2.5.29.8", "issuerAltName");
  _I_("2.5.29.9", "subjectDirectoryAttributes");
  _I_("2.5.29.10", "basicConstraints");
  _I_("2.5.29.11", "nameConstraints");
  _I_("2.5.29.12", "policyConstraints");
  _I_("2.5.29.13", "basicConstraints");
  _IN("2.5.29.14", "subjectKeyIdentifier");
  _IN("2.5.29.15", "keyUsage");
  _I_("2.5.29.16", "privateKeyUsagePeriod");
  _IN("2.5.29.17", "subjectAltName");
  _IN("2.5.29.18", "issuerAltName");
  _IN("2.5.29.19", "basicConstraints");
  _I_("2.5.29.20", "cRLNumber");
  _I_("2.5.29.21", "cRLReason");
  _I_("2.5.29.22", "expirationDate");
  _I_("2.5.29.23", "instructionCode");
  _I_("2.5.29.24", "invalidityDate");
  _I_("2.5.29.25", "cRLDistributionPoints");
  _I_("2.5.29.26", "issuingDistributionPoint");
  _I_("2.5.29.27", "deltaCRLIndicator");
  _I_("2.5.29.28", "issuingDistributionPoint");
  _I_("2.5.29.29", "certificateIssuer");
  _I_("2.5.29.30", "nameConstraints");
  _IN("2.5.29.31", "cRLDistributionPoints");
  _IN("2.5.29.32", "certificatePolicies");
  _I_("2.5.29.33", "policyMappings");
  _I_("2.5.29.34", "policyConstraints");
  _IN("2.5.29.35", "authorityKeyIdentifier");
  _I_("2.5.29.36", "policyConstraints");
  _IN("2.5.29.37", "extKeyUsage");
  _I_("2.5.29.46", "freshestCRL");
  _I_("2.5.29.54", "inhibitAnyPolicy");
  _IN("1.3.6.1.4.1.11129.2.4.2", "timestampList");
  _IN("1.3.6.1.5.5.7.1.1", "authorityInfoAccess");
  _IN("1.3.6.1.5.5.7.3.1", "serverAuth");
  _IN("1.3.6.1.5.5.7.3.2", "clientAuth");
  _IN("1.3.6.1.5.5.7.3.3", "codeSigning");
  _IN("1.3.6.1.5.5.7.3.4", "emailProtection");
  _IN("1.3.6.1.5.5.7.3.8", "timeStamping");
});
var require_asn1 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  require_oids();
  var asn1 = module.exports = forge.asn1 = forge.asn1 || {};
  asn1.Class = {
    UNIVERSAL: 0,
    APPLICATION: 64,
    CONTEXT_SPECIFIC: 128,
    PRIVATE: 192
  };
  asn1.Type = {
    NONE: 0,
    BOOLEAN: 1,
    INTEGER: 2,
    BITSTRING: 3,
    OCTETSTRING: 4,
    NULL: 5,
    OID: 6,
    ODESC: 7,
    EXTERNAL: 8,
    REAL: 9,
    ENUMERATED: 10,
    EMBEDDED: 11,
    UTF8: 12,
    ROID: 13,
    SEQUENCE: 16,
    SET: 17,
    PRINTABLESTRING: 19,
    IA5STRING: 22,
    UTCTIME: 23,
    GENERALIZEDTIME: 24,
    BMPSTRING: 30
  };
  asn1.create = function(tagClass, type2, constructed, value, options23) {
    if (forge.util.isArray(value)) {
      var tmp = [];
      for (var i5 = 0;i5 < value.length; ++i5) {
        if (value[i5] !== undefined) {
          tmp.push(value[i5]);
        }
      }
      value = tmp;
    }
    var obj = {
      tagClass,
      type: type2,
      constructed,
      composed: constructed || forge.util.isArray(value),
      value
    };
    if (options23 && "bitStringContents" in options23) {
      obj.bitStringContents = options23.bitStringContents;
      obj.original = asn1.copy(obj);
    }
    return obj;
  };
  asn1.copy = function(obj, options23) {
    var copy2;
    if (forge.util.isArray(obj)) {
      copy2 = [];
      for (var i5 = 0;i5 < obj.length; ++i5) {
        copy2.push(asn1.copy(obj[i5], options23));
      }
      return copy2;
    }
    if (typeof obj === "string") {
      return obj;
    }
    copy2 = {
      tagClass: obj.tagClass,
      type: obj.type,
      constructed: obj.constructed,
      composed: obj.composed,
      value: asn1.copy(obj.value, options23)
    };
    if (options23 && !options23.excludeBitStringContents) {
      copy2.bitStringContents = obj.bitStringContents;
    }
    return copy2;
  };
  asn1.equals = function(obj1, obj2, options23) {
    if (forge.util.isArray(obj1)) {
      if (!forge.util.isArray(obj2)) {
        return false;
      }
      if (obj1.length !== obj2.length) {
        return false;
      }
      for (var i5 = 0;i5 < obj1.length; ++i5) {
        if (!asn1.equals(obj1[i5], obj2[i5])) {
          return false;
        }
      }
      return true;
    }
    if (typeof obj1 !== typeof obj2) {
      return false;
    }
    if (typeof obj1 === "string") {
      return obj1 === obj2;
    }
    var equal = obj1.tagClass === obj2.tagClass && obj1.type === obj2.type && obj1.constructed === obj2.constructed && obj1.composed === obj2.composed && asn1.equals(obj1.value, obj2.value);
    if (options23 && options23.includeBitStringContents) {
      equal = equal && obj1.bitStringContents === obj2.bitStringContents;
    }
    return equal;
  };
  asn1.getBerValueLength = function(b23) {
    var b222 = b23.getByte();
    if (b222 === 128) {
      return;
    }
    var length;
    var longForm = b222 & 128;
    if (!longForm) {
      length = b222;
    } else {
      length = b23.getInt((b222 & 127) << 3);
    }
    return length;
  };
  function _checkBufferLength(bytes, remaining, n5) {
    if (n5 > remaining) {
      var error = new Error("Too few bytes to parse DER.");
      error.available = bytes.length();
      error.remaining = remaining;
      error.requested = n5;
      throw error;
    }
  }
  var _getValueLength = function(bytes, remaining) {
    var b23 = bytes.getByte();
    remaining--;
    if (b23 === 128) {
      return;
    }
    var length;
    var longForm = b23 & 128;
    if (!longForm) {
      length = b23;
    } else {
      var longFormBytes = b23 & 127;
      _checkBufferLength(bytes, remaining, longFormBytes);
      length = bytes.getInt(longFormBytes << 3);
    }
    if (length < 0) {
      throw new Error("Negative length: " + length);
    }
    return length;
  };
  asn1.fromDer = function(bytes, options23) {
    if (options23 === undefined) {
      options23 = {
        strict: true,
        parseAllBytes: true,
        decodeBitStrings: true
      };
    }
    if (typeof options23 === "boolean") {
      options23 = {
        strict: options23,
        parseAllBytes: true,
        decodeBitStrings: true
      };
    }
    if (!("strict" in options23)) {
      options23.strict = true;
    }
    if (!("parseAllBytes" in options23)) {
      options23.parseAllBytes = true;
    }
    if (!("decodeBitStrings" in options23)) {
      options23.decodeBitStrings = true;
    }
    if (typeof bytes === "string") {
      bytes = forge.util.createBuffer(bytes);
    }
    var byteCount = bytes.length();
    var value = _fromDer(bytes, bytes.length(), 0, options23);
    if (options23.parseAllBytes && bytes.length() !== 0) {
      var error = new Error("Unparsed DER bytes remain after ASN.1 parsing.");
      error.byteCount = byteCount;
      error.remaining = bytes.length();
      throw error;
    }
    return value;
  };
  function _fromDer(bytes, remaining, depth2, options23) {
    var start;
    _checkBufferLength(bytes, remaining, 2);
    var b1 = bytes.getByte();
    remaining--;
    var tagClass = b1 & 192;
    var type2 = b1 & 31;
    start = bytes.length();
    var length = _getValueLength(bytes, remaining);
    remaining -= start - bytes.length();
    if (length !== undefined && length > remaining) {
      if (options23.strict) {
        var error = new Error("Too few bytes to read ASN.1 value.");
        error.available = bytes.length();
        error.remaining = remaining;
        error.requested = length;
        throw error;
      }
      length = remaining;
    }
    var value;
    var bitStringContents;
    var constructed = (b1 & 32) === 32;
    if (constructed) {
      value = [];
      if (length === undefined) {
        for (;; ) {
          _checkBufferLength(bytes, remaining, 2);
          if (bytes.bytes(2) === String.fromCharCode(0, 0)) {
            bytes.getBytes(2);
            remaining -= 2;
            break;
          }
          start = bytes.length();
          value.push(_fromDer(bytes, remaining, depth2 + 1, options23));
          remaining -= start - bytes.length();
        }
      } else {
        while (length > 0) {
          start = bytes.length();
          value.push(_fromDer(bytes, length, depth2 + 1, options23));
          remaining -= start - bytes.length();
          length -= start - bytes.length();
        }
      }
    }
    if (value === undefined && tagClass === asn1.Class.UNIVERSAL && type2 === asn1.Type.BITSTRING) {
      bitStringContents = bytes.bytes(length);
    }
    if (value === undefined && options23.decodeBitStrings && tagClass === asn1.Class.UNIVERSAL && type2 === asn1.Type.BITSTRING && length > 1) {
      var savedRead = bytes.read;
      var savedRemaining = remaining;
      var unused = 0;
      if (type2 === asn1.Type.BITSTRING) {
        _checkBufferLength(bytes, remaining, 1);
        unused = bytes.getByte();
        remaining--;
      }
      if (unused === 0) {
        try {
          start = bytes.length();
          var subOptions = {
            strict: true,
            decodeBitStrings: true
          };
          var composed = _fromDer(bytes, remaining, depth2 + 1, subOptions);
          var used = start - bytes.length();
          remaining -= used;
          if (type2 == asn1.Type.BITSTRING) {
            used++;
          }
          var tc = composed.tagClass;
          if (used === length && (tc === asn1.Class.UNIVERSAL || tc === asn1.Class.CONTEXT_SPECIFIC)) {
            value = [composed];
          }
        } catch (ex) {
        }
      }
      if (value === undefined) {
        bytes.read = savedRead;
        remaining = savedRemaining;
      }
    }
    if (value === undefined) {
      if (length === undefined) {
        if (options23.strict) {
          throw new Error("Non-constructed ASN.1 object of indefinite length.");
        }
        length = remaining;
      }
      if (type2 === asn1.Type.BMPSTRING) {
        value = "";
        for (;length > 0; length -= 2) {
          _checkBufferLength(bytes, remaining, 2);
          value += String.fromCharCode(bytes.getInt16());
          remaining -= 2;
        }
      } else {
        value = bytes.getBytes(length);
        remaining -= length;
      }
    }
    var asn1Options = bitStringContents === undefined ? null : {
      bitStringContents
    };
    return asn1.create(tagClass, type2, constructed, value, asn1Options);
  }
  asn1.toDer = function(obj) {
    var bytes = forge.util.createBuffer();
    var b1 = obj.tagClass | obj.type;
    var value = forge.util.createBuffer();
    var useBitStringContents = false;
    if ("bitStringContents" in obj) {
      useBitStringContents = true;
      if (obj.original) {
        useBitStringContents = asn1.equals(obj, obj.original);
      }
    }
    if (useBitStringContents) {
      value.putBytes(obj.bitStringContents);
    } else if (obj.composed) {
      if (obj.constructed) {
        b1 |= 32;
      } else {
        value.putByte(0);
      }
      for (var i5 = 0;i5 < obj.value.length; ++i5) {
        if (obj.value[i5] !== undefined) {
          value.putBuffer(asn1.toDer(obj.value[i5]));
        }
      }
    } else {
      if (obj.type === asn1.Type.BMPSTRING) {
        for (var i5 = 0;i5 < obj.value.length; ++i5) {
          value.putInt16(obj.value.charCodeAt(i5));
        }
      } else {
        if (obj.type === asn1.Type.INTEGER && obj.value.length > 1 && (obj.value.charCodeAt(0) === 0 && (obj.value.charCodeAt(1) & 128) === 0 || obj.value.charCodeAt(0) === 255 && (obj.value.charCodeAt(1) & 128) === 128)) {
          value.putBytes(obj.value.substr(1));
        } else {
          value.putBytes(obj.value);
        }
      }
    }
    bytes.putByte(b1);
    if (value.length() <= 127) {
      bytes.putByte(value.length() & 127);
    } else {
      var len = value.length();
      var lenBytes = "";
      do {
        lenBytes += String.fromCharCode(len & 255);
        len = len >>> 8;
      } while (len > 0);
      bytes.putByte(lenBytes.length | 128);
      for (var i5 = lenBytes.length - 1;i5 >= 0; --i5) {
        bytes.putByte(lenBytes.charCodeAt(i5));
      }
    }
    bytes.putBuffer(value);
    return bytes;
  };
  asn1.oidToDer = function(oid) {
    var values22 = oid.split(".");
    var bytes = forge.util.createBuffer();
    bytes.putByte(40 * parseInt(values22[0], 10) + parseInt(values22[1], 10));
    var last, valueBytes, value, b23;
    for (var i5 = 2;i5 < values22.length; ++i5) {
      last = true;
      valueBytes = [];
      value = parseInt(values22[i5], 10);
      do {
        b23 = value & 127;
        value = value >>> 7;
        if (!last) {
          b23 |= 128;
        }
        valueBytes.push(b23);
        last = false;
      } while (value > 0);
      for (var n5 = valueBytes.length - 1;n5 >= 0; --n5) {
        bytes.putByte(valueBytes[n5]);
      }
    }
    return bytes;
  };
  asn1.derToOid = function(bytes) {
    var oid;
    if (typeof bytes === "string") {
      bytes = forge.util.createBuffer(bytes);
    }
    var b23 = bytes.getByte();
    oid = Math.floor(b23 / 40) + "." + b23 % 40;
    var value = 0;
    while (bytes.length() > 0) {
      b23 = bytes.getByte();
      value = value << 7;
      if (b23 & 128) {
        value += b23 & 127;
      } else {
        oid += "." + (value + b23);
        value = 0;
      }
    }
    return oid;
  };
  asn1.utcTimeToDate = function(utc) {
    var date = new Date;
    var year = parseInt(utc.substr(0, 2), 10);
    year = year >= 50 ? 1900 + year : 2000 + year;
    var MM = parseInt(utc.substr(2, 2), 10) - 1;
    var DD22 = parseInt(utc.substr(4, 2), 10);
    var hh = parseInt(utc.substr(6, 2), 10);
    var mm = parseInt(utc.substr(8, 2), 10);
    var ss = 0;
    if (utc.length > 11) {
      var c23 = utc.charAt(10);
      var end = 10;
      if (c23 !== "+" && c23 !== "-") {
        ss = parseInt(utc.substr(10, 2), 10);
        end += 2;
      }
    }
    date.setUTCFullYear(year, MM, DD22);
    date.setUTCHours(hh, mm, ss, 0);
    if (end) {
      c23 = utc.charAt(end);
      if (c23 === "+" || c23 === "-") {
        var hhoffset = parseInt(utc.substr(end + 1, 2), 10);
        var mmoffset = parseInt(utc.substr(end + 4, 2), 10);
        var offset = hhoffset * 60 + mmoffset;
        offset *= 60000;
        if (c23 === "+") {
          date.setTime(+date - offset);
        } else {
          date.setTime(+date + offset);
        }
      }
    }
    return date;
  };
  asn1.generalizedTimeToDate = function(gentime) {
    var date = new Date;
    var YYYY = parseInt(gentime.substr(0, 4), 10);
    var MM = parseInt(gentime.substr(4, 2), 10) - 1;
    var DD22 = parseInt(gentime.substr(6, 2), 10);
    var hh = parseInt(gentime.substr(8, 2), 10);
    var mm = parseInt(gentime.substr(10, 2), 10);
    var ss = parseInt(gentime.substr(12, 2), 10);
    var fff = 0;
    var offset = 0;
    var isUTC = false;
    if (gentime.charAt(gentime.length - 1) === "Z") {
      isUTC = true;
    }
    var end = gentime.length - 5, c23 = gentime.charAt(end);
    if (c23 === "+" || c23 === "-") {
      var hhoffset = parseInt(gentime.substr(end + 1, 2), 10);
      var mmoffset = parseInt(gentime.substr(end + 4, 2), 10);
      offset = hhoffset * 60 + mmoffset;
      offset *= 60000;
      if (c23 === "+") {
        offset *= -1;
      }
      isUTC = true;
    }
    if (gentime.charAt(14) === ".") {
      fff = parseFloat(gentime.substr(14), 10) * 1000;
    }
    if (isUTC) {
      date.setUTCFullYear(YYYY, MM, DD22);
      date.setUTCHours(hh, mm, ss, fff);
      date.setTime(+date + offset);
    } else {
      date.setFullYear(YYYY, MM, DD22);
      date.setHours(hh, mm, ss, fff);
    }
    return date;
  };
  asn1.dateToUtcTime = function(date) {
    if (typeof date === "string") {
      return date;
    }
    var rval = "";
    var format = [];
    format.push(("" + date.getUTCFullYear()).substr(2));
    format.push("" + (date.getUTCMonth() + 1));
    format.push("" + date.getUTCDate());
    format.push("" + date.getUTCHours());
    format.push("" + date.getUTCMinutes());
    format.push("" + date.getUTCSeconds());
    for (var i5 = 0;i5 < format.length; ++i5) {
      if (format[i5].length < 2) {
        rval += "0";
      }
      rval += format[i5];
    }
    rval += "Z";
    return rval;
  };
  asn1.dateToGeneralizedTime = function(date) {
    if (typeof date === "string") {
      return date;
    }
    var rval = "";
    var format = [];
    format.push("" + date.getUTCFullYear());
    format.push("" + (date.getUTCMonth() + 1));
    format.push("" + date.getUTCDate());
    format.push("" + date.getUTCHours());
    format.push("" + date.getUTCMinutes());
    format.push("" + date.getUTCSeconds());
    for (var i5 = 0;i5 < format.length; ++i5) {
      if (format[i5].length < 2) {
        rval += "0";
      }
      rval += format[i5];
    }
    rval += "Z";
    return rval;
  };
  asn1.integerToDer = function(x5) {
    var rval = forge.util.createBuffer();
    if (x5 >= -128 && x5 < 128) {
      return rval.putSignedInt(x5, 8);
    }
    if (x5 >= -32768 && x5 < 32768) {
      return rval.putSignedInt(x5, 16);
    }
    if (x5 >= -8388608 && x5 < 8388608) {
      return rval.putSignedInt(x5, 24);
    }
    if (x5 >= -2147483648 && x5 < 2147483648) {
      return rval.putSignedInt(x5, 32);
    }
    var error = new Error("Integer too large; max is 32-bits.");
    error.integer = x5;
    throw error;
  };
  asn1.derToInteger = function(bytes) {
    if (typeof bytes === "string") {
      bytes = forge.util.createBuffer(bytes);
    }
    var n5 = bytes.length() * 8;
    if (n5 > 32) {
      throw new Error("Integer too large; max is 32-bits.");
    }
    return bytes.getSignedInt(n5);
  };
  asn1.validate = function(obj, v23, capture, errors) {
    var rval = false;
    if ((obj.tagClass === v23.tagClass || typeof v23.tagClass === "undefined") && (obj.type === v23.type || typeof v23.type === "undefined")) {
      if (obj.constructed === v23.constructed || typeof v23.constructed === "undefined") {
        rval = true;
        if (v23.value && forge.util.isArray(v23.value)) {
          var j23 = 0;
          for (var i5 = 0;rval && i5 < v23.value.length; ++i5) {
            rval = v23.value[i5].optional || false;
            if (obj.value[j23]) {
              rval = asn1.validate(obj.value[j23], v23.value[i5], capture, errors);
              if (rval) {
                ++j23;
              } else if (v23.value[i5].optional) {
                rval = true;
              }
            }
            if (!rval && errors) {
              errors.push("[" + v23.name + "] " + 'Tag class "' + v23.tagClass + '", type "' + v23.type + '" expected value length "' + v23.value.length + '", got "' + obj.value.length + '"');
            }
          }
        }
        if (rval && capture) {
          if (v23.capture) {
            capture[v23.capture] = obj.value;
          }
          if (v23.captureAsn1) {
            capture[v23.captureAsn1] = obj;
          }
          if (v23.captureBitStringContents && "bitStringContents" in obj) {
            capture[v23.captureBitStringContents] = obj.bitStringContents;
          }
          if (v23.captureBitStringValue && "bitStringContents" in obj) {
            var value;
            if (obj.bitStringContents.length < 2) {
              capture[v23.captureBitStringValue] = "";
            } else {
              var unused = obj.bitStringContents.charCodeAt(0);
              if (unused !== 0) {
                throw new Error("captureBitStringValue only supported for zero unused bits");
              }
              capture[v23.captureBitStringValue] = obj.bitStringContents.slice(1);
            }
          }
        }
      } else if (errors) {
        errors.push("[" + v23.name + "] " + 'Expected constructed "' + v23.constructed + '", got "' + obj.constructed + '"');
      }
    } else if (errors) {
      if (obj.tagClass !== v23.tagClass) {
        errors.push("[" + v23.name + "] " + 'Expected tag class "' + v23.tagClass + '", got "' + obj.tagClass + '"');
      }
      if (obj.type !== v23.type) {
        errors.push("[" + v23.name + "] " + 'Expected type "' + v23.type + '", got "' + obj.type + '"');
      }
    }
    return rval;
  };
  var _nonLatinRegex = /[^\\u0000-\\u00ff]/;
  asn1.prettyPrint = function(obj, level, indentation) {
    var rval = "";
    level = level || 0;
    indentation = indentation || 2;
    if (level > 0) {
      rval += "\n";
    }
    var indent = "";
    for (var i5 = 0;i5 < level * indentation; ++i5) {
      indent += " ";
    }
    rval += indent + "Tag: ";
    switch (obj.tagClass) {
      case asn1.Class.UNIVERSAL:
        rval += "Universal:";
        break;
      case asn1.Class.APPLICATION:
        rval += "Application:";
        break;
      case asn1.Class.CONTEXT_SPECIFIC:
        rval += "Context-Specific:";
        break;
      case asn1.Class.PRIVATE:
        rval += "Private:";
        break;
    }
    if (obj.tagClass === asn1.Class.UNIVERSAL) {
      rval += obj.type;
      switch (obj.type) {
        case asn1.Type.NONE:
          rval += " (None)";
          break;
        case asn1.Type.BOOLEAN:
          rval += " (Boolean)";
          break;
        case asn1.Type.INTEGER:
          rval += " (Integer)";
          break;
        case asn1.Type.BITSTRING:
          rval += " (Bit string)";
          break;
        case asn1.Type.OCTETSTRING:
          rval += " (Octet string)";
          break;
        case asn1.Type.NULL:
          rval += " (Null)";
          break;
        case asn1.Type.OID:
          rval += " (Object Identifier)";
          break;
        case asn1.Type.ODESC:
          rval += " (Object Descriptor)";
          break;
        case asn1.Type.EXTERNAL:
          rval += " (External or Instance of)";
          break;
        case asn1.Type.REAL:
          rval += " (Real)";
          break;
        case asn1.Type.ENUMERATED:
          rval += " (Enumerated)";
          break;
        case asn1.Type.EMBEDDED:
          rval += " (Embedded PDV)";
          break;
        case asn1.Type.UTF8:
          rval += " (UTF8)";
          break;
        case asn1.Type.ROID:
          rval += " (Relative Object Identifier)";
          break;
        case asn1.Type.SEQUENCE:
          rval += " (Sequence)";
          break;
        case asn1.Type.SET:
          rval += " (Set)";
          break;
        case asn1.Type.PRINTABLESTRING:
          rval += " (Printable String)";
          break;
        case asn1.Type.IA5String:
          rval += " (IA5String (ASCII))";
          break;
        case asn1.Type.UTCTIME:
          rval += " (UTC time)";
          break;
        case asn1.Type.GENERALIZEDTIME:
          rval += " (Generalized time)";
          break;
        case asn1.Type.BMPSTRING:
          rval += " (BMP String)";
          break;
      }
    } else {
      rval += obj.type;
    }
    rval += "\n";
    rval += indent + "Constructed: " + obj.constructed + "\n";
    if (obj.composed) {
      var subvalues = 0;
      var sub = "";
      for (var i5 = 0;i5 < obj.value.length; ++i5) {
        if (obj.value[i5] !== undefined) {
          subvalues += 1;
          sub += asn1.prettyPrint(obj.value[i5], level + 1, indentation);
          if (i5 + 1 < obj.value.length) {
            sub += ",";
          }
        }
      }
      rval += indent + "Sub values: " + subvalues + sub;
    } else {
      rval += indent + "Value: ";
      if (obj.type === asn1.Type.OID) {
        var oid = asn1.derToOid(obj.value);
        rval += oid;
        if (forge.pki && forge.pki.oids) {
          if (oid in forge.pki.oids) {
            rval += " (" + forge.pki.oids[oid] + ") ";
          }
        }
      }
      if (obj.type === asn1.Type.INTEGER) {
        try {
          rval += asn1.derToInteger(obj.value);
        } catch (ex) {
          rval += "0x" + forge.util.bytesToHex(obj.value);
        }
      } else if (obj.type === asn1.Type.BITSTRING) {
        if (obj.value.length > 1) {
          rval += "0x" + forge.util.bytesToHex(obj.value.slice(1));
        } else {
          rval += "(none)";
        }
        if (obj.value.length > 0) {
          var unused = obj.value.charCodeAt(0);
          if (unused == 1) {
            rval += " (1 unused bit shown)";
          } else if (unused > 1) {
            rval += " (" + unused + " unused bits shown)";
          }
        }
      } else if (obj.type === asn1.Type.OCTETSTRING) {
        if (!_nonLatinRegex.test(obj.value)) {
          rval += "(" + obj.value + ") ";
        }
        rval += "0x" + forge.util.bytesToHex(obj.value);
      } else if (obj.type === asn1.Type.UTF8) {
        try {
          rval += forge.util.decodeUtf8(obj.value);
        } catch (e5) {
          if (e5.message === "URI malformed") {
            rval += "0x" + forge.util.bytesToHex(obj.value) + " (malformed UTF8)";
          } else {
            throw e5;
          }
        }
      } else if (obj.type === asn1.Type.PRINTABLESTRING || obj.type === asn1.Type.IA5String) {
        rval += obj.value;
      } else if (_nonLatinRegex.test(obj.value)) {
        rval += "0x" + forge.util.bytesToHex(obj.value);
      } else if (obj.value.length === 0) {
        rval += "[null]";
      } else {
        rval += obj.value;
      }
    }
    return rval;
  };
});
var require_md = __commonJS3((exports, module) => {
  var forge = require_forge();
  module.exports = forge.md = forge.md || {};
  forge.md.algorithms = forge.md.algorithms || {};
});
var require_hmac2 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_md();
  require_util33();
  var hmac2 = module.exports = forge.hmac = forge.hmac || {};
  hmac2.create = function() {
    var _key = null;
    var _md = null;
    var _ipadding = null;
    var _opadding = null;
    var ctx = {};
    ctx.start = function(md, key) {
      if (md !== null) {
        if (typeof md === "string") {
          md = md.toLowerCase();
          if (md in forge.md.algorithms) {
            _md = forge.md.algorithms[md].create();
          } else {
            throw new Error('Unknown hash algorithm "' + md + '"');
          }
        } else {
          _md = md;
        }
      }
      if (key === null) {
        key = _key;
      } else {
        if (typeof key === "string") {
          key = forge.util.createBuffer(key);
        } else if (forge.util.isArray(key)) {
          var tmp = key;
          key = forge.util.createBuffer();
          for (var i5 = 0;i5 < tmp.length; ++i5) {
            key.putByte(tmp[i5]);
          }
        }
        var keylen = key.length();
        if (keylen > _md.blockLength) {
          _md.start();
          _md.update(key.bytes());
          key = _md.digest();
        }
        _ipadding = forge.util.createBuffer();
        _opadding = forge.util.createBuffer();
        keylen = key.length();
        for (var i5 = 0;i5 < keylen; ++i5) {
          var tmp = key.at(i5);
          _ipadding.putByte(54 ^ tmp);
          _opadding.putByte(92 ^ tmp);
        }
        if (keylen < _md.blockLength) {
          var tmp = _md.blockLength - keylen;
          for (var i5 = 0;i5 < tmp; ++i5) {
            _ipadding.putByte(54);
            _opadding.putByte(92);
          }
        }
        _key = key;
        _ipadding = _ipadding.bytes();
        _opadding = _opadding.bytes();
      }
      _md.start();
      _md.update(_ipadding);
    };
    ctx.update = function(bytes) {
      _md.update(bytes);
    };
    ctx.getMac = function() {
      var inner = _md.digest().bytes();
      _md.start();
      _md.update(_opadding);
      _md.update(inner);
      return _md.digest();
    };
    ctx.digest = ctx.getMac;
    return ctx;
  };
});
var require_md53 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_md();
  require_util33();
  var md5 = module.exports = forge.md5 = forge.md5 || {};
  forge.md.md5 = forge.md.algorithms.md5 = md5;
  md5.create = function() {
    if (!_initialized) {
      _init();
    }
    var _state = null;
    var _input = forge.util.createBuffer();
    var _w2 = new Array(16);
    var md = {
      algorithm: "md5",
      blockLength: 64,
      digestLength: 16,
      messageLength: 0,
      fullMessageLength: null,
      messageLengthSize: 8
    };
    md.start = function() {
      md.messageLength = 0;
      md.fullMessageLength = md.messageLength64 = [];
      var int32s = md.messageLengthSize / 4;
      for (var i5 = 0;i5 < int32s; ++i5) {
        md.fullMessageLength.push(0);
      }
      _input = forge.util.createBuffer();
      _state = {
        h0: 1732584193,
        h1: 4023233417,
        h2: 2562383102,
        h3: 271733878
      };
      return md;
    };
    md.start();
    md.update = function(msg, encoding) {
      if (encoding === "utf8") {
        msg = forge.util.encodeUtf8(msg);
      }
      var len = msg.length;
      md.messageLength += len;
      len = [len / 4294967296 >>> 0, len >>> 0];
      for (var i5 = md.fullMessageLength.length - 1;i5 >= 0; --i5) {
        md.fullMessageLength[i5] += len[1];
        len[1] = len[0] + (md.fullMessageLength[i5] / 4294967296 >>> 0);
        md.fullMessageLength[i5] = md.fullMessageLength[i5] >>> 0;
        len[0] = len[1] / 4294967296 >>> 0;
      }
      _input.putBytes(msg);
      _update(_state, _w2, _input);
      if (_input.read > 2048 || _input.length() === 0) {
        _input.compact();
      }
      return md;
    };
    md.digest = function() {
      var finalBlock = forge.util.createBuffer();
      finalBlock.putBytes(_input.bytes());
      var remaining = md.fullMessageLength[md.fullMessageLength.length - 1] + md.messageLengthSize;
      var overflow = remaining & md.blockLength - 1;
      finalBlock.putBytes(_padding.substr(0, md.blockLength - overflow));
      var bits, carry = 0;
      for (var i5 = md.fullMessageLength.length - 1;i5 >= 0; --i5) {
        bits = md.fullMessageLength[i5] * 8 + carry;
        carry = bits / 4294967296 >>> 0;
        finalBlock.putInt32Le(bits >>> 0);
      }
      var s222 = {
        h0: _state.h0,
        h1: _state.h1,
        h2: _state.h2,
        h3: _state.h3
      };
      _update(s222, _w2, finalBlock);
      var rval = forge.util.createBuffer();
      rval.putInt32Le(s222.h0);
      rval.putInt32Le(s222.h1);
      rval.putInt32Le(s222.h2);
      rval.putInt32Le(s222.h3);
      return rval;
    };
    return md;
  };
  var _padding = null;
  var _g = null;
  var _r2 = null;
  var _k = null;
  var _initialized = false;
  function _init() {
    _padding = String.fromCharCode(128);
    _padding += forge.util.fillString(String.fromCharCode(0), 64);
    _g = [
      0,
      1,
      2,
      3,
      4,
      5,
      6,
      7,
      8,
      9,
      10,
      11,
      12,
      13,
      14,
      15,
      1,
      6,
      11,
      0,
      5,
      10,
      15,
      4,
      9,
      14,
      3,
      8,
      13,
      2,
      7,
      12,
      5,
      8,
      11,
      14,
      1,
      4,
      7,
      10,
      13,
      0,
      3,
      6,
      9,
      12,
      15,
      2,
      0,
      7,
      14,
      5,
      12,
      3,
      10,
      1,
      8,
      15,
      6,
      13,
      4,
      11,
      2,
      9
    ];
    _r2 = [
      7,
      12,
      17,
      22,
      7,
      12,
      17,
      22,
      7,
      12,
      17,
      22,
      7,
      12,
      17,
      22,
      5,
      9,
      14,
      20,
      5,
      9,
      14,
      20,
      5,
      9,
      14,
      20,
      5,
      9,
      14,
      20,
      4,
      11,
      16,
      23,
      4,
      11,
      16,
      23,
      4,
      11,
      16,
      23,
      4,
      11,
      16,
      23,
      6,
      10,
      15,
      21,
      6,
      10,
      15,
      21,
      6,
      10,
      15,
      21,
      6,
      10,
      15,
      21
    ];
    _k = new Array(64);
    for (var i5 = 0;i5 < 64; ++i5) {
      _k[i5] = Math.floor(Math.abs(Math.sin(i5 + 1)) * 4294967296);
    }
    _initialized = true;
  }
  function _update(s32, w23, bytes) {
    var t5, a5, b23, c23, d5, f23, r23, i5;
    var len = bytes.length();
    while (len >= 64) {
      a5 = s32.h0;
      b23 = s32.h1;
      c23 = s32.h2;
      d5 = s32.h3;
      for (i5 = 0;i5 < 16; ++i5) {
        w23[i5] = bytes.getInt32Le();
        f23 = d5 ^ b23 & (c23 ^ d5);
        t5 = a5 + f23 + _k[i5] + w23[i5];
        r23 = _r2[i5];
        a5 = d5;
        d5 = c23;
        c23 = b23;
        b23 += t5 << r23 | t5 >>> 32 - r23;
      }
      for (;i5 < 32; ++i5) {
        f23 = c23 ^ d5 & (b23 ^ c23);
        t5 = a5 + f23 + _k[i5] + w23[_g[i5]];
        r23 = _r2[i5];
        a5 = d5;
        d5 = c23;
        c23 = b23;
        b23 += t5 << r23 | t5 >>> 32 - r23;
      }
      for (;i5 < 48; ++i5) {
        f23 = b23 ^ c23 ^ d5;
        t5 = a5 + f23 + _k[i5] + w23[_g[i5]];
        r23 = _r2[i5];
        a5 = d5;
        d5 = c23;
        c23 = b23;
        b23 += t5 << r23 | t5 >>> 32 - r23;
      }
      for (;i5 < 64; ++i5) {
        f23 = c23 ^ (b23 | ~d5);
        t5 = a5 + f23 + _k[i5] + w23[_g[i5]];
        r23 = _r2[i5];
        a5 = d5;
        d5 = c23;
        c23 = b23;
        b23 += t5 << r23 | t5 >>> 32 - r23;
      }
      s32.h0 = s32.h0 + a5 | 0;
      s32.h1 = s32.h1 + b23 | 0;
      s32.h2 = s32.h2 + c23 | 0;
      s32.h3 = s32.h3 + d5 | 0;
      len -= 64;
    }
  }
});
var require_pem = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  var pem = module.exports = forge.pem = forge.pem || {};
  pem.encode = function(msg, options23) {
    options23 = options23 || {};
    var rval = "-----BEGIN " + msg.type + "-----\r\n";
    var header;
    if (msg.procType) {
      header = {
        name: "Proc-Type",
        values: [String(msg.procType.version), msg.procType.type]
      };
      rval += foldHeader(header);
    }
    if (msg.contentDomain) {
      header = { name: "Content-Domain", values: [msg.contentDomain] };
      rval += foldHeader(header);
    }
    if (msg.dekInfo) {
      header = { name: "DEK-Info", values: [msg.dekInfo.algorithm] };
      if (msg.dekInfo.parameters) {
        header.values.push(msg.dekInfo.parameters);
      }
      rval += foldHeader(header);
    }
    if (msg.headers) {
      for (var i5 = 0;i5 < msg.headers.length; ++i5) {
        rval += foldHeader(msg.headers[i5]);
      }
    }
    if (msg.procType) {
      rval += "\r\n";
    }
    rval += forge.util.encode64(msg.body, options23.maxline || 64) + "\r\n";
    rval += "-----END " + msg.type + "-----\r\n";
    return rval;
  };
  pem.decode = function(str2) {
    var rval = [];
    var rMessage = /\s*-----BEGIN ([A-Z0-9- ]+)-----\r?\n?([\x21-\x7e\s]+?(?:\r?\n\r?\n))?([:A-Za-z0-9+\/=\s]+?)-----END \1-----/g;
    var rHeader = /([\x21-\x7e]+):\s*([\x21-\x7e\s^:]+)/;
    var rCRLF = /\r?\n/;
    var match;
    while (true) {
      match = rMessage.exec(str2);
      if (!match) {
        break;
      }
      var type2 = match[1];
      if (type2 === "NEW CERTIFICATE REQUEST") {
        type2 = "CERTIFICATE REQUEST";
      }
      var msg = {
        type: type2,
        procType: null,
        contentDomain: null,
        dekInfo: null,
        headers: [],
        body: forge.util.decode64(match[3])
      };
      rval.push(msg);
      if (!match[2]) {
        continue;
      }
      var lines = match[2].split(rCRLF);
      var li = 0;
      while (match && li < lines.length) {
        var line = lines[li].replace(/\s+$/, "");
        for (var nl = li + 1;nl < lines.length; ++nl) {
          var next = lines[nl];
          if (!/\s/.test(next[0])) {
            break;
          }
          line += next;
          li = nl;
        }
        match = line.match(rHeader);
        if (match) {
          var header = { name: match[1], values: [] };
          var values22 = match[2].split(",");
          for (var vi = 0;vi < values22.length; ++vi) {
            header.values.push(ltrim(values22[vi]));
          }
          if (!msg.procType) {
            if (header.name !== "Proc-Type") {
              throw new Error("Invalid PEM formatted message. The first " + 'encapsulated header must be "Proc-Type".');
            } else if (header.values.length !== 2) {
              throw new Error('Invalid PEM formatted message. The "Proc-Type" ' + "header must have two subfields.");
            }
            msg.procType = { version: values22[0], type: values22[1] };
          } else if (!msg.contentDomain && header.name === "Content-Domain") {
            msg.contentDomain = values22[0] || "";
          } else if (!msg.dekInfo && header.name === "DEK-Info") {
            if (header.values.length === 0) {
              throw new Error('Invalid PEM formatted message. The "DEK-Info" ' + "header must have at least one subfield.");
            }
            msg.dekInfo = { algorithm: values22[0], parameters: values22[1] || null };
          } else {
            msg.headers.push(header);
          }
        }
        ++li;
      }
      if (msg.procType === "ENCRYPTED" && !msg.dekInfo) {
        throw new Error('Invalid PEM formatted message. The "DEK-Info" ' + 'header must be present if "Proc-Type" is "ENCRYPTED".');
      }
    }
    if (rval.length === 0) {
      throw new Error("Invalid PEM formatted message.");
    }
    return rval;
  };
  function foldHeader(header) {
    var rval = header.name + ": ";
    var values22 = [];
    var insertSpace = function(match, $1) {
      return " " + $1;
    };
    for (var i5 = 0;i5 < header.values.length; ++i5) {
      values22.push(header.values[i5].replace(/^(\S+\r\n)/, insertSpace));
    }
    rval += values22.join(",") + "\r\n";
    var length = 0;
    var candidate = -1;
    for (var i5 = 0;i5 < rval.length; ++i5, ++length) {
      if (length > 65 && candidate !== -1) {
        var insert = rval[candidate];
        if (insert === ",") {
          ++candidate;
          rval = rval.substr(0, candidate) + "\r\n " + rval.substr(candidate);
        } else {
          rval = rval.substr(0, candidate) + "\r\n" + insert + rval.substr(candidate + 1);
        }
        length = i5 - candidate - 1;
        candidate = -1;
        ++i5;
      } else if (rval[i5] === " " || rval[i5] === "\t" || rval[i5] === ",") {
        candidate = i5;
      }
    }
    return rval;
  }
  function ltrim(str2) {
    return str2.replace(/^\s+/, "");
  }
});
var require_des = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_cipher();
  require_cipherModes();
  require_util33();
  module.exports = forge.des = forge.des || {};
  forge.des.startEncrypting = function(key, iv, output, mode) {
    var cipher = _createCipher({
      key,
      output,
      decrypt: false,
      mode: mode || (iv === null ? "ECB" : "CBC")
    });
    cipher.start(iv);
    return cipher;
  };
  forge.des.createEncryptionCipher = function(key, mode) {
    return _createCipher({
      key,
      output: null,
      decrypt: false,
      mode
    });
  };
  forge.des.startDecrypting = function(key, iv, output, mode) {
    var cipher = _createCipher({
      key,
      output,
      decrypt: true,
      mode: mode || (iv === null ? "ECB" : "CBC")
    });
    cipher.start(iv);
    return cipher;
  };
  forge.des.createDecryptionCipher = function(key, mode) {
    return _createCipher({
      key,
      output: null,
      decrypt: true,
      mode
    });
  };
  forge.des.Algorithm = function(name, mode) {
    var self2 = this;
    self2.name = name;
    self2.mode = new mode({
      blockSize: 8,
      cipher: {
        encrypt: function(inBlock, outBlock) {
          return _updateBlock(self2._keys, inBlock, outBlock, false);
        },
        decrypt: function(inBlock, outBlock) {
          return _updateBlock(self2._keys, inBlock, outBlock, true);
        }
      }
    });
    self2._init = false;
  };
  forge.des.Algorithm.prototype.initialize = function(options23) {
    if (this._init) {
      return;
    }
    var key = forge.util.createBuffer(options23.key);
    if (this.name.indexOf("3DES") === 0) {
      if (key.length() !== 24) {
        throw new Error("Invalid Triple-DES key size: " + key.length() * 8);
      }
    }
    this._keys = _createKeys(key);
    this._init = true;
  };
  registerAlgorithm("DES-ECB", forge.cipher.modes.ecb);
  registerAlgorithm("DES-CBC", forge.cipher.modes.cbc);
  registerAlgorithm("DES-CFB", forge.cipher.modes.cfb);
  registerAlgorithm("DES-OFB", forge.cipher.modes.ofb);
  registerAlgorithm("DES-CTR", forge.cipher.modes.ctr);
  registerAlgorithm("3DES-ECB", forge.cipher.modes.ecb);
  registerAlgorithm("3DES-CBC", forge.cipher.modes.cbc);
  registerAlgorithm("3DES-CFB", forge.cipher.modes.cfb);
  registerAlgorithm("3DES-OFB", forge.cipher.modes.ofb);
  registerAlgorithm("3DES-CTR", forge.cipher.modes.ctr);
  function registerAlgorithm(name, mode) {
    var factory = function() {
      return new forge.des.Algorithm(name, mode);
    };
    forge.cipher.registerAlgorithm(name, factory);
  }
  var spfunction1 = [16843776, 0, 65536, 16843780, 16842756, 66564, 4, 65536, 1024, 16843776, 16843780, 1024, 16778244, 16842756, 16777216, 4, 1028, 16778240, 16778240, 66560, 66560, 16842752, 16842752, 16778244, 65540, 16777220, 16777220, 65540, 0, 1028, 66564, 16777216, 65536, 16843780, 4, 16842752, 16843776, 16777216, 16777216, 1024, 16842756, 65536, 66560, 16777220, 1024, 4, 16778244, 66564, 16843780, 65540, 16842752, 16778244, 16777220, 1028, 66564, 16843776, 1028, 16778240, 16778240, 0, 65540, 66560, 0, 16842756];
  var spfunction2 = [-2146402272, -2147450880, 32768, 1081376, 1048576, 32, -2146435040, -2147450848, -2147483616, -2146402272, -2146402304, -2147483648, -2147450880, 1048576, 32, -2146435040, 1081344, 1048608, -2147450848, 0, -2147483648, 32768, 1081376, -2146435072, 1048608, -2147483616, 0, 1081344, 32800, -2146402304, -2146435072, 32800, 0, 1081376, -2146435040, 1048576, -2147450848, -2146435072, -2146402304, 32768, -2146435072, -2147450880, 32, -2146402272, 1081376, 32, 32768, -2147483648, 32800, -2146402304, 1048576, -2147483616, 1048608, -2147450848, -2147483616, 1048608, 1081344, 0, -2147450880, 32800, -2147483648, -2146435040, -2146402272, 1081344];
  var spfunction3 = [520, 134349312, 0, 134348808, 134218240, 0, 131592, 134218240, 131080, 134217736, 134217736, 131072, 134349320, 131080, 134348800, 520, 134217728, 8, 134349312, 512, 131584, 134348800, 134348808, 131592, 134218248, 131584, 131072, 134218248, 8, 134349320, 512, 134217728, 134349312, 134217728, 131080, 520, 131072, 134349312, 134218240, 0, 512, 131080, 134349320, 134218240, 134217736, 512, 0, 134348808, 134218248, 131072, 134217728, 134349320, 8, 131592, 131584, 134217736, 134348800, 134218248, 520, 134348800, 131592, 8, 134348808, 131584];
  var spfunction4 = [8396801, 8321, 8321, 128, 8396928, 8388737, 8388609, 8193, 0, 8396800, 8396800, 8396929, 129, 0, 8388736, 8388609, 1, 8192, 8388608, 8396801, 128, 8388608, 8193, 8320, 8388737, 1, 8320, 8388736, 8192, 8396928, 8396929, 129, 8388736, 8388609, 8396800, 8396929, 129, 0, 0, 8396800, 8320, 8388736, 8388737, 1, 8396801, 8321, 8321, 128, 8396929, 129, 1, 8192, 8388609, 8193, 8396928, 8388737, 8193, 8320, 8388608, 8396801, 128, 8388608, 8192, 8396928];
  var spfunction5 = [256, 34078976, 34078720, 1107296512, 524288, 256, 1073741824, 34078720, 1074266368, 524288, 33554688, 1074266368, 1107296512, 1107820544, 524544, 1073741824, 33554432, 1074266112, 1074266112, 0, 1073742080, 1107820800, 1107820800, 33554688, 1107820544, 1073742080, 0, 1107296256, 34078976, 33554432, 1107296256, 524544, 524288, 1107296512, 256, 33554432, 1073741824, 34078720, 1107296512, 1074266368, 33554688, 1073741824, 1107820544, 34078976, 1074266368, 256, 33554432, 1107820544, 1107820800, 524544, 1107296256, 1107820800, 34078720, 0, 1074266112, 1107296256, 524544, 33554688, 1073742080, 524288, 0, 1074266112, 34078976, 1073742080];
  var spfunction6 = [536870928, 541065216, 16384, 541081616, 541065216, 16, 541081616, 4194304, 536887296, 4210704, 4194304, 536870928, 4194320, 536887296, 536870912, 16400, 0, 4194320, 536887312, 16384, 4210688, 536887312, 16, 541065232, 541065232, 0, 4210704, 541081600, 16400, 4210688, 541081600, 536870912, 536887296, 16, 541065232, 4210688, 541081616, 4194304, 16400, 536870928, 4194304, 536887296, 536870912, 16400, 536870928, 541081616, 4210688, 541065216, 4210704, 541081600, 0, 541065232, 16, 16384, 541065216, 4210704, 16384, 4194320, 536887312, 0, 541081600, 536870912, 4194320, 536887312];
  var spfunction7 = [2097152, 69206018, 67110914, 0, 2048, 67110914, 2099202, 69208064, 69208066, 2097152, 0, 67108866, 2, 67108864, 69206018, 2050, 67110912, 2099202, 2097154, 67110912, 67108866, 69206016, 69208064, 2097154, 69206016, 2048, 2050, 69208066, 2099200, 2, 67108864, 2099200, 67108864, 2099200, 2097152, 67110914, 67110914, 69206018, 69206018, 2, 2097154, 67108864, 67110912, 2097152, 69208064, 2050, 2099202, 69208064, 2050, 67108866, 69208066, 69206016, 2099200, 0, 2, 69208066, 0, 2099202, 69206016, 2048, 67108866, 67110912, 2048, 2097154];
  var spfunction8 = [268439616, 4096, 262144, 268701760, 268435456, 268439616, 64, 268435456, 262208, 268697600, 268701760, 266240, 268701696, 266304, 4096, 64, 268697600, 268435520, 268439552, 4160, 266240, 262208, 268697664, 268701696, 4160, 0, 0, 268697664, 268435520, 268439552, 266304, 262144, 266304, 262144, 268701696, 4096, 64, 268697664, 4096, 266304, 268439552, 64, 268435520, 268697600, 268697664, 268435456, 262144, 268439616, 0, 268701760, 262208, 268435520, 268697600, 268439552, 268439616, 0, 268701760, 266240, 266240, 4160, 4160, 262208, 268435456, 268701696];
  function _createKeys(key) {
    var pc2bytes0 = [0, 4, 536870912, 536870916, 65536, 65540, 536936448, 536936452, 512, 516, 536871424, 536871428, 66048, 66052, 536936960, 536936964], pc2bytes1 = [0, 1, 1048576, 1048577, 67108864, 67108865, 68157440, 68157441, 256, 257, 1048832, 1048833, 67109120, 67109121, 68157696, 68157697], pc2bytes2 = [0, 8, 2048, 2056, 16777216, 16777224, 16779264, 16779272, 0, 8, 2048, 2056, 16777216, 16777224, 16779264, 16779272], pc2bytes3 = [0, 2097152, 134217728, 136314880, 8192, 2105344, 134225920, 136323072, 131072, 2228224, 134348800, 136445952, 139264, 2236416, 134356992, 136454144], pc2bytes4 = [0, 262144, 16, 262160, 0, 262144, 16, 262160, 4096, 266240, 4112, 266256, 4096, 266240, 4112, 266256], pc2bytes5 = [0, 1024, 32, 1056, 0, 1024, 32, 1056, 33554432, 33555456, 33554464, 33555488, 33554432, 33555456, 33554464, 33555488], pc2bytes6 = [0, 268435456, 524288, 268959744, 2, 268435458, 524290, 268959746, 0, 268435456, 524288, 268959744, 2, 268435458, 524290, 268959746], pc2bytes7 = [0, 65536, 2048, 67584, 536870912, 536936448, 536872960, 536938496, 131072, 196608, 133120, 198656, 537001984, 537067520, 537004032, 537069568], pc2bytes8 = [0, 262144, 0, 262144, 2, 262146, 2, 262146, 33554432, 33816576, 33554432, 33816576, 33554434, 33816578, 33554434, 33816578], pc2bytes9 = [0, 268435456, 8, 268435464, 0, 268435456, 8, 268435464, 1024, 268436480, 1032, 268436488, 1024, 268436480, 1032, 268436488], pc2bytes10 = [0, 32, 0, 32, 1048576, 1048608, 1048576, 1048608, 8192, 8224, 8192, 8224, 1056768, 1056800, 1056768, 1056800], pc2bytes11 = [0, 16777216, 512, 16777728, 2097152, 18874368, 2097664, 18874880, 67108864, 83886080, 67109376, 83886592, 69206016, 85983232, 69206528, 85983744], pc2bytes12 = [0, 4096, 134217728, 134221824, 524288, 528384, 134742016, 134746112, 16, 4112, 134217744, 134221840, 524304, 528400, 134742032, 134746128], pc2bytes13 = [0, 4, 256, 260, 0, 4, 256, 260, 1, 5, 257, 261, 1, 5, 257, 261];
    var iterations = key.length() > 8 ? 3 : 1;
    var keys2 = [];
    var shifts = [0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0];
    var n5 = 0, tmp;
    for (var j23 = 0;j23 < iterations; j23++) {
      var left = key.getInt32();
      var right = key.getInt32();
      tmp = (left >>> 4 ^ right) & 252645135;
      right ^= tmp;
      left ^= tmp << 4;
      tmp = (right >>> -16 ^ left) & 65535;
      left ^= tmp;
      right ^= tmp << -16;
      tmp = (left >>> 2 ^ right) & 858993459;
      right ^= tmp;
      left ^= tmp << 2;
      tmp = (right >>> -16 ^ left) & 65535;
      left ^= tmp;
      right ^= tmp << -16;
      tmp = (left >>> 1 ^ right) & 1431655765;
      right ^= tmp;
      left ^= tmp << 1;
      tmp = (right >>> 8 ^ left) & 16711935;
      left ^= tmp;
      right ^= tmp << 8;
      tmp = (left >>> 1 ^ right) & 1431655765;
      right ^= tmp;
      left ^= tmp << 1;
      tmp = left << 8 | right >>> 20 & 240;
      left = right << 24 | right << 8 & 16711680 | right >>> 8 & 65280 | right >>> 24 & 240;
      right = tmp;
      for (var i5 = 0;i5 < shifts.length; ++i5) {
        if (shifts[i5]) {
          left = left << 2 | left >>> 26;
          right = right << 2 | right >>> 26;
        } else {
          left = left << 1 | left >>> 27;
          right = right << 1 | right >>> 27;
        }
        left &= -15;
        right &= -15;
        var lefttmp = pc2bytes0[left >>> 28] | pc2bytes1[left >>> 24 & 15] | pc2bytes2[left >>> 20 & 15] | pc2bytes3[left >>> 16 & 15] | pc2bytes4[left >>> 12 & 15] | pc2bytes5[left >>> 8 & 15] | pc2bytes6[left >>> 4 & 15];
        var righttmp = pc2bytes7[right >>> 28] | pc2bytes8[right >>> 24 & 15] | pc2bytes9[right >>> 20 & 15] | pc2bytes10[right >>> 16 & 15] | pc2bytes11[right >>> 12 & 15] | pc2bytes12[right >>> 8 & 15] | pc2bytes13[right >>> 4 & 15];
        tmp = (righttmp >>> 16 ^ lefttmp) & 65535;
        keys2[n5++] = lefttmp ^ tmp;
        keys2[n5++] = righttmp ^ tmp << 16;
      }
    }
    return keys2;
  }
  function _updateBlock(keys2, input, output, decrypt) {
    var iterations = keys2.length === 32 ? 3 : 9;
    var looping;
    if (iterations === 3) {
      looping = decrypt ? [30, -2, -2] : [0, 32, 2];
    } else {
      looping = decrypt ? [94, 62, -2, 32, 64, 2, 30, -2, -2] : [0, 32, 2, 62, 30, -2, 64, 96, 2];
    }
    var tmp;
    var left = input[0];
    var right = input[1];
    tmp = (left >>> 4 ^ right) & 252645135;
    right ^= tmp;
    left ^= tmp << 4;
    tmp = (left >>> 16 ^ right) & 65535;
    right ^= tmp;
    left ^= tmp << 16;
    tmp = (right >>> 2 ^ left) & 858993459;
    left ^= tmp;
    right ^= tmp << 2;
    tmp = (right >>> 8 ^ left) & 16711935;
    left ^= tmp;
    right ^= tmp << 8;
    tmp = (left >>> 1 ^ right) & 1431655765;
    right ^= tmp;
    left ^= tmp << 1;
    left = left << 1 | left >>> 31;
    right = right << 1 | right >>> 31;
    for (var j23 = 0;j23 < iterations; j23 += 3) {
      var endloop = looping[j23 + 1];
      var loopinc = looping[j23 + 2];
      for (var i5 = looping[j23];i5 != endloop; i5 += loopinc) {
        var right1 = right ^ keys2[i5];
        var right2 = (right >>> 4 | right << 28) ^ keys2[i5 + 1];
        tmp = left;
        left = right;
        right = tmp ^ (spfunction2[right1 >>> 24 & 63] | spfunction4[right1 >>> 16 & 63] | spfunction6[right1 >>> 8 & 63] | spfunction8[right1 & 63] | spfunction1[right2 >>> 24 & 63] | spfunction3[right2 >>> 16 & 63] | spfunction5[right2 >>> 8 & 63] | spfunction7[right2 & 63]);
      }
      tmp = left;
      left = right;
      right = tmp;
    }
    left = left >>> 1 | left << 31;
    right = right >>> 1 | right << 31;
    tmp = (left >>> 1 ^ right) & 1431655765;
    right ^= tmp;
    left ^= tmp << 1;
    tmp = (right >>> 8 ^ left) & 16711935;
    left ^= tmp;
    right ^= tmp << 8;
    tmp = (right >>> 2 ^ left) & 858993459;
    left ^= tmp;
    right ^= tmp << 2;
    tmp = (left >>> 16 ^ right) & 65535;
    right ^= tmp;
    left ^= tmp << 16;
    tmp = (left >>> 4 ^ right) & 252645135;
    right ^= tmp;
    left ^= tmp << 4;
    output[0] = left;
    output[1] = right;
  }
  function _createCipher(options23) {
    options23 = options23 || {};
    var mode = (options23.mode || "CBC").toUpperCase();
    var algorithm = "DES-" + mode;
    var cipher;
    if (options23.decrypt) {
      cipher = forge.cipher.createDecipher(algorithm, options23.key);
    } else {
      cipher = forge.cipher.createCipher(algorithm, options23.key);
    }
    var start = cipher.start;
    cipher.start = function(iv, options3) {
      var output = null;
      if (options3 instanceof forge.util.ByteBuffer) {
        output = options3;
        options3 = {};
      }
      options3 = options3 || {};
      options3.output = output;
      options3.iv = iv;
      start.call(cipher, options3);
    };
    return cipher;
  }
});
var require_pbkdf2 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_hmac2();
  require_md();
  require_util33();
  var pkcs5 = forge.pkcs5 = forge.pkcs5 || {};
  var crypto;
  if (forge.util.isNodejs && !forge.options.usePureJavaScript) {
    crypto = import.meta.require("crypto");
  }
  module.exports = forge.pbkdf2 = pkcs5.pbkdf2 = function(p33, s32, c23, dkLen, md, callback) {
    if (typeof md === "function") {
      callback = md;
      md = null;
    }
    if (forge.util.isNodejs && !forge.options.usePureJavaScript && crypto.pbkdf2 && (md === null || typeof md !== "object") && (crypto.pbkdf2Sync.length > 4 || (!md || md === "sha1"))) {
      if (typeof md !== "string") {
        md = "sha1";
      }
      p33 = Buffer.from(p33, "binary");
      s32 = Buffer.from(s32, "binary");
      if (!callback) {
        if (crypto.pbkdf2Sync.length === 4) {
          return crypto.pbkdf2Sync(p33, s32, c23, dkLen).toString("binary");
        }
        return crypto.pbkdf2Sync(p33, s32, c23, dkLen, md).toString("binary");
      }
      if (crypto.pbkdf2Sync.length === 4) {
        return crypto.pbkdf2(p33, s32, c23, dkLen, function(err3, key) {
          if (err3) {
            return callback(err3);
          }
          callback(null, key.toString("binary"));
        });
      }
      return crypto.pbkdf2(p33, s32, c23, dkLen, md, function(err3, key) {
        if (err3) {
          return callback(err3);
        }
        callback(null, key.toString("binary"));
      });
    }
    if (typeof md === "undefined" || md === null) {
      md = "sha1";
    }
    if (typeof md === "string") {
      if (!(md in forge.md.algorithms)) {
        throw new Error("Unknown hash algorithm: " + md);
      }
      md = forge.md[md].create();
    }
    var hLen = md.digestLength;
    if (dkLen > 4294967295 * hLen) {
      var err22 = new Error("Derived key is too long.");
      if (callback) {
        return callback(err22);
      }
      throw err22;
    }
    var len = Math.ceil(dkLen / hLen);
    var r23 = dkLen - (len - 1) * hLen;
    var prf = forge.hmac.create();
    prf.start(md, p33);
    var dk = "";
    var xor, u_c, u_c1;
    if (!callback) {
      for (var i5 = 1;i5 <= len; ++i5) {
        prf.start(null, null);
        prf.update(s32);
        prf.update(forge.util.int32ToBytes(i5));
        xor = u_c1 = prf.digest().getBytes();
        for (var j23 = 2;j23 <= c23; ++j23) {
          prf.start(null, null);
          prf.update(u_c1);
          u_c = prf.digest().getBytes();
          xor = forge.util.xorBytes(xor, u_c, hLen);
          u_c1 = u_c;
        }
        dk += i5 < len ? xor : xor.substr(0, r23);
      }
      return dk;
    }
    var i5 = 1, j23;
    function outer() {
      if (i5 > len) {
        return callback(null, dk);
      }
      prf.start(null, null);
      prf.update(s32);
      prf.update(forge.util.int32ToBytes(i5));
      xor = u_c1 = prf.digest().getBytes();
      j23 = 2;
      inner();
    }
    function inner() {
      if (j23 <= c23) {
        prf.start(null, null);
        prf.update(u_c1);
        u_c = prf.digest().getBytes();
        xor = forge.util.xorBytes(xor, u_c, hLen);
        u_c1 = u_c;
        ++j23;
        return forge.util.setImmediate(inner);
      }
      dk += i5 < len ? xor : xor.substr(0, r23);
      ++i5;
      outer();
    }
    outer();
  };
});
var require_sha256 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_md();
  require_util33();
  var sha256 = module.exports = forge.sha256 = forge.sha256 || {};
  forge.md.sha256 = forge.md.algorithms.sha256 = sha256;
  sha256.create = function() {
    if (!_initialized) {
      _init();
    }
    var _state = null;
    var _input = forge.util.createBuffer();
    var _w2 = new Array(64);
    var md = {
      algorithm: "sha256",
      blockLength: 64,
      digestLength: 32,
      messageLength: 0,
      fullMessageLength: null,
      messageLengthSize: 8
    };
    md.start = function() {
      md.messageLength = 0;
      md.fullMessageLength = md.messageLength64 = [];
      var int32s = md.messageLengthSize / 4;
      for (var i5 = 0;i5 < int32s; ++i5) {
        md.fullMessageLength.push(0);
      }
      _input = forge.util.createBuffer();
      _state = {
        h0: 1779033703,
        h1: 3144134277,
        h2: 1013904242,
        h3: 2773480762,
        h4: 1359893119,
        h5: 2600822924,
        h6: 528734635,
        h7: 1541459225
      };
      return md;
    };
    md.start();
    md.update = function(msg, encoding) {
      if (encoding === "utf8") {
        msg = forge.util.encodeUtf8(msg);
      }
      var len = msg.length;
      md.messageLength += len;
      len = [len / 4294967296 >>> 0, len >>> 0];
      for (var i5 = md.fullMessageLength.length - 1;i5 >= 0; --i5) {
        md.fullMessageLength[i5] += len[1];
        len[1] = len[0] + (md.fullMessageLength[i5] / 4294967296 >>> 0);
        md.fullMessageLength[i5] = md.fullMessageLength[i5] >>> 0;
        len[0] = len[1] / 4294967296 >>> 0;
      }
      _input.putBytes(msg);
      _update(_state, _w2, _input);
      if (_input.read > 2048 || _input.length() === 0) {
        _input.compact();
      }
      return md;
    };
    md.digest = function() {
      var finalBlock = forge.util.createBuffer();
      finalBlock.putBytes(_input.bytes());
      var remaining = md.fullMessageLength[md.fullMessageLength.length - 1] + md.messageLengthSize;
      var overflow = remaining & md.blockLength - 1;
      finalBlock.putBytes(_padding.substr(0, md.blockLength - overflow));
      var next, carry;
      var bits = md.fullMessageLength[0] * 8;
      for (var i5 = 0;i5 < md.fullMessageLength.length - 1; ++i5) {
        next = md.fullMessageLength[i5 + 1] * 8;
        carry = next / 4294967296 >>> 0;
        bits += carry;
        finalBlock.putInt32(bits >>> 0);
        bits = next >>> 0;
      }
      finalBlock.putInt32(bits);
      var s222 = {
        h0: _state.h0,
        h1: _state.h1,
        h2: _state.h2,
        h3: _state.h3,
        h4: _state.h4,
        h5: _state.h5,
        h6: _state.h6,
        h7: _state.h7
      };
      _update(s222, _w2, finalBlock);
      var rval = forge.util.createBuffer();
      rval.putInt32(s222.h0);
      rval.putInt32(s222.h1);
      rval.putInt32(s222.h2);
      rval.putInt32(s222.h3);
      rval.putInt32(s222.h4);
      rval.putInt32(s222.h5);
      rval.putInt32(s222.h6);
      rval.putInt32(s222.h7);
      return rval;
    };
    return md;
  };
  var _padding = null;
  var _initialized = false;
  var _k = null;
  function _init() {
    _padding = String.fromCharCode(128);
    _padding += forge.util.fillString(String.fromCharCode(0), 64);
    _k = [
      1116352408,
      1899447441,
      3049323471,
      3921009573,
      961987163,
      1508970993,
      2453635748,
      2870763221,
      3624381080,
      310598401,
      607225278,
      1426881987,
      1925078388,
      2162078206,
      2614888103,
      3248222580,
      3835390401,
      4022224774,
      264347078,
      604807628,
      770255983,
      1249150122,
      1555081692,
      1996064986,
      2554220882,
      2821834349,
      2952996808,
      3210313671,
      3336571891,
      3584528711,
      113926993,
      338241895,
      666307205,
      773529912,
      1294757372,
      1396182291,
      1695183700,
      1986661051,
      2177026350,
      2456956037,
      2730485921,
      2820302411,
      3259730800,
      3345764771,
      3516065817,
      3600352804,
      4094571909,
      275423344,
      430227734,
      506948616,
      659060556,
      883997877,
      958139571,
      1322822218,
      1537002063,
      1747873779,
      1955562222,
      2024104815,
      2227730452,
      2361852424,
      2428436474,
      2756734187,
      3204031479,
      3329325298
    ];
    _initialized = true;
  }
  function _update(s32, w23, bytes) {
    var t1, t22, s0, s1, ch2, maj, i5, a5, b23, c23, d5, e5, f23, g23, h33;
    var len = bytes.length();
    while (len >= 64) {
      for (i5 = 0;i5 < 16; ++i5) {
        w23[i5] = bytes.getInt32();
      }
      for (;i5 < 64; ++i5) {
        t1 = w23[i5 - 2];
        t1 = (t1 >>> 17 | t1 << 15) ^ (t1 >>> 19 | t1 << 13) ^ t1 >>> 10;
        t22 = w23[i5 - 15];
        t22 = (t22 >>> 7 | t22 << 25) ^ (t22 >>> 18 | t22 << 14) ^ t22 >>> 3;
        w23[i5] = t1 + w23[i5 - 7] + t22 + w23[i5 - 16] | 0;
      }
      a5 = s32.h0;
      b23 = s32.h1;
      c23 = s32.h2;
      d5 = s32.h3;
      e5 = s32.h4;
      f23 = s32.h5;
      g23 = s32.h6;
      h33 = s32.h7;
      for (i5 = 0;i5 < 64; ++i5) {
        s1 = (e5 >>> 6 | e5 << 26) ^ (e5 >>> 11 | e5 << 21) ^ (e5 >>> 25 | e5 << 7);
        ch2 = g23 ^ e5 & (f23 ^ g23);
        s0 = (a5 >>> 2 | a5 << 30) ^ (a5 >>> 13 | a5 << 19) ^ (a5 >>> 22 | a5 << 10);
        maj = a5 & b23 | c23 & (a5 ^ b23);
        t1 = h33 + s1 + ch2 + _k[i5] + w23[i5];
        t22 = s0 + maj;
        h33 = g23;
        g23 = f23;
        f23 = e5;
        e5 = d5 + t1 >>> 0;
        d5 = c23;
        c23 = b23;
        b23 = a5;
        a5 = t1 + t22 >>> 0;
      }
      s32.h0 = s32.h0 + a5 | 0;
      s32.h1 = s32.h1 + b23 | 0;
      s32.h2 = s32.h2 + c23 | 0;
      s32.h3 = s32.h3 + d5 | 0;
      s32.h4 = s32.h4 + e5 | 0;
      s32.h5 = s32.h5 + f23 | 0;
      s32.h6 = s32.h6 + g23 | 0;
      s32.h7 = s32.h7 + h33 | 0;
      len -= 64;
    }
  }
});
var require_prng = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  var _crypto = null;
  if (forge.util.isNodejs && !forge.options.usePureJavaScript && !process.versions["node-webkit"]) {
    _crypto = import.meta.require("crypto");
  }
  var prng = module.exports = forge.prng = forge.prng || {};
  prng.create = function(plugin) {
    var ctx = {
      plugin,
      key: null,
      seed: null,
      time: null,
      reseeds: 0,
      generated: 0,
      keyBytes: ""
    };
    var md = plugin.md;
    var pools = new Array(32);
    for (var i5 = 0;i5 < 32; ++i5) {
      pools[i5] = md.create();
    }
    ctx.pools = pools;
    ctx.pool = 0;
    ctx.generate = function(count, callback) {
      if (!callback) {
        return ctx.generateSync(count);
      }
      var cipher = ctx.plugin.cipher;
      var increment = ctx.plugin.increment;
      var formatKey = ctx.plugin.formatKey;
      var formatSeed = ctx.plugin.formatSeed;
      var b23 = forge.util.createBuffer();
      ctx.key = null;
      generate();
      function generate(err22) {
        if (err22) {
          return callback(err22);
        }
        if (b23.length() >= count) {
          return callback(null, b23.getBytes(count));
        }
        if (ctx.generated > 1048575) {
          ctx.key = null;
        }
        if (ctx.key === null) {
          return forge.util.nextTick(function() {
            _reseed(generate);
          });
        }
        var bytes = cipher(ctx.key, ctx.seed);
        ctx.generated += bytes.length;
        b23.putBytes(bytes);
        ctx.key = formatKey(cipher(ctx.key, increment(ctx.seed)));
        ctx.seed = formatSeed(cipher(ctx.key, ctx.seed));
        forge.util.setImmediate(generate);
      }
    };
    ctx.generateSync = function(count) {
      var cipher = ctx.plugin.cipher;
      var increment = ctx.plugin.increment;
      var formatKey = ctx.plugin.formatKey;
      var formatSeed = ctx.plugin.formatSeed;
      ctx.key = null;
      var b23 = forge.util.createBuffer();
      while (b23.length() < count) {
        if (ctx.generated > 1048575) {
          ctx.key = null;
        }
        if (ctx.key === null) {
          _reseedSync();
        }
        var bytes = cipher(ctx.key, ctx.seed);
        ctx.generated += bytes.length;
        b23.putBytes(bytes);
        ctx.key = formatKey(cipher(ctx.key, increment(ctx.seed)));
        ctx.seed = formatSeed(cipher(ctx.key, ctx.seed));
      }
      return b23.getBytes(count);
    };
    function _reseed(callback) {
      if (ctx.pools[0].messageLength >= 32) {
        _seed();
        return callback();
      }
      var needed = 32 - ctx.pools[0].messageLength << 5;
      ctx.seedFile(needed, function(err22, bytes) {
        if (err22) {
          return callback(err22);
        }
        ctx.collect(bytes);
        _seed();
        callback();
      });
    }
    function _reseedSync() {
      if (ctx.pools[0].messageLength >= 32) {
        return _seed();
      }
      var needed = 32 - ctx.pools[0].messageLength << 5;
      ctx.collect(ctx.seedFileSync(needed));
      _seed();
    }
    function _seed() {
      ctx.reseeds = ctx.reseeds === 4294967295 ? 0 : ctx.reseeds + 1;
      var md2 = ctx.plugin.md.create();
      md2.update(ctx.keyBytes);
      var _2powK = 1;
      for (var k5 = 0;k5 < 32; ++k5) {
        if (ctx.reseeds % _2powK === 0) {
          md2.update(ctx.pools[k5].digest().getBytes());
          ctx.pools[k5].start();
        }
        _2powK = _2powK << 1;
      }
      ctx.keyBytes = md2.digest().getBytes();
      md2.start();
      md2.update(ctx.keyBytes);
      var seedBytes = md2.digest().getBytes();
      ctx.key = ctx.plugin.formatKey(ctx.keyBytes);
      ctx.seed = ctx.plugin.formatSeed(seedBytes);
      ctx.generated = 0;
    }
    function defaultSeedFile(needed) {
      var getRandomValues = null;
      var globalScope = forge.util.globalScope;
      var _crypto2 = globalScope.crypto || globalScope.msCrypto;
      if (_crypto2 && _crypto2.getRandomValues) {
        getRandomValues = function(arr) {
          return _crypto2.getRandomValues(arr);
        };
      }
      var b23 = forge.util.createBuffer();
      if (getRandomValues) {
        while (b23.length() < needed) {
          var count = Math.max(1, Math.min(needed - b23.length(), 65536) / 4);
          var entropy = new Uint32Array(Math.floor(count));
          try {
            getRandomValues(entropy);
            for (var i22 = 0;i22 < entropy.length; ++i22) {
              b23.putInt32(entropy[i22]);
            }
          } catch (e5) {
            if (!(typeof QuotaExceededError !== "undefined" && e5 instanceof QuotaExceededError)) {
              throw e5;
            }
          }
        }
      }
      if (b23.length() < needed) {
        var hi, lo, next;
        var seed = Math.floor(Math.random() * 65536);
        while (b23.length() < needed) {
          lo = 16807 * (seed & 65535);
          hi = 16807 * (seed >> 16);
          lo += (hi & 32767) << 16;
          lo += hi >> 15;
          lo = (lo & 2147483647) + (lo >> 31);
          seed = lo & 4294967295;
          for (var i22 = 0;i22 < 3; ++i22) {
            next = seed >>> (i22 << 3);
            next ^= Math.floor(Math.random() * 256);
            b23.putByte(next & 255);
          }
        }
      }
      return b23.getBytes(needed);
    }
    if (_crypto) {
      ctx.seedFile = function(needed, callback) {
        _crypto.randomBytes(needed, function(err22, bytes) {
          if (err22) {
            return callback(err22);
          }
          callback(null, bytes.toString());
        });
      };
      ctx.seedFileSync = function(needed) {
        return _crypto.randomBytes(needed).toString();
      };
    } else {
      ctx.seedFile = function(needed, callback) {
        try {
          callback(null, defaultSeedFile(needed));
        } catch (e5) {
          callback(e5);
        }
      };
      ctx.seedFileSync = defaultSeedFile;
    }
    ctx.collect = function(bytes) {
      var count = bytes.length;
      for (var i22 = 0;i22 < count; ++i22) {
        ctx.pools[ctx.pool].update(bytes.substr(i22, 1));
        ctx.pool = ctx.pool === 31 ? 0 : ctx.pool + 1;
      }
    };
    ctx.collectInt = function(i22, n5) {
      var bytes = "";
      for (var x5 = 0;x5 < n5; x5 += 8) {
        bytes += String.fromCharCode(i22 >> x5 & 255);
      }
      ctx.collect(bytes);
    };
    ctx.registerWorker = function(worker) {
      if (worker === self) {
        ctx.seedFile = function(needed, callback) {
          function listener2(e5) {
            var data2 = e5.data;
            if (data2.forge && data2.forge.prng) {
              self.removeEventListener("message", listener2);
              callback(data2.forge.prng.err, data2.forge.prng.bytes);
            }
          }
          self.addEventListener("message", listener2);
          self.postMessage({ forge: { prng: { needed } } });
        };
      } else {
        var listener = function(e5) {
          var data2 = e5.data;
          if (data2.forge && data2.forge.prng) {
            ctx.seedFile(data2.forge.prng.needed, function(err22, bytes) {
              worker.postMessage({ forge: { prng: { err: err22, bytes } } });
            });
          }
        };
        worker.addEventListener("message", listener);
      }
    };
    return ctx;
  };
});
var require_random = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_aes2();
  require_sha256();
  require_prng();
  require_util33();
  (function() {
    if (forge.random && forge.random.getBytes) {
      module.exports = forge.random;
      return;
    }
    (function(jQuery2) {
      var prng_aes = {};
      var _prng_aes_output = new Array(4);
      var _prng_aes_buffer = forge.util.createBuffer();
      prng_aes.formatKey = function(key2) {
        var tmp = forge.util.createBuffer(key2);
        key2 = new Array(4);
        key2[0] = tmp.getInt32();
        key2[1] = tmp.getInt32();
        key2[2] = tmp.getInt32();
        key2[3] = tmp.getInt32();
        return forge.aes._expandKey(key2, false);
      };
      prng_aes.formatSeed = function(seed) {
        var tmp = forge.util.createBuffer(seed);
        seed = new Array(4);
        seed[0] = tmp.getInt32();
        seed[1] = tmp.getInt32();
        seed[2] = tmp.getInt32();
        seed[3] = tmp.getInt32();
        return seed;
      };
      prng_aes.cipher = function(key2, seed) {
        forge.aes._updateBlock(key2, seed, _prng_aes_output, false);
        _prng_aes_buffer.putInt32(_prng_aes_output[0]);
        _prng_aes_buffer.putInt32(_prng_aes_output[1]);
        _prng_aes_buffer.putInt32(_prng_aes_output[2]);
        _prng_aes_buffer.putInt32(_prng_aes_output[3]);
        return _prng_aes_buffer.getBytes();
      };
      prng_aes.increment = function(seed) {
        ++seed[3];
        return seed;
      };
      prng_aes.md = forge.md.sha256;
      function spawnPrng() {
        var ctx = forge.prng.create(prng_aes);
        ctx.getBytes = function(count, callback) {
          return ctx.generate(count, callback);
        };
        ctx.getBytesSync = function(count) {
          return ctx.generate(count);
        };
        return ctx;
      }
      var _ctx = spawnPrng();
      var getRandomValues = null;
      var globalScope = forge.util.globalScope;
      var _crypto = globalScope.crypto || globalScope.msCrypto;
      if (_crypto && _crypto.getRandomValues) {
        getRandomValues = function(arr) {
          return _crypto.getRandomValues(arr);
        };
      }
      if (forge.options.usePureJavaScript || !forge.util.isNodejs && !getRandomValues) {
        if (typeof window === "undefined" || window.document === undefined) {
        }
        _ctx.collectInt(+new Date, 32);
        if (typeof navigator !== "undefined") {
          var _navBytes = "";
          for (var key in navigator) {
            try {
              if (typeof navigator[key] == "string") {
                _navBytes += navigator[key];
              }
            } catch (e5) {
            }
          }
          _ctx.collect(_navBytes);
          _navBytes = null;
        }
        if (jQuery2) {
          jQuery2().mousemove(function(e5) {
            _ctx.collectInt(e5.clientX, 16);
            _ctx.collectInt(e5.clientY, 16);
          });
          jQuery2().keypress(function(e5) {
            _ctx.collectInt(e5.charCode, 8);
          });
        }
      }
      if (!forge.random) {
        forge.random = _ctx;
      } else {
        for (var key in _ctx) {
          forge.random[key] = _ctx[key];
        }
      }
      forge.random.createInstance = spawnPrng;
      module.exports = forge.random;
    })(typeof jQuery !== "undefined" ? jQuery : null);
  })();
});
var require_rc2 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  var piTable = [
    217,
    120,
    249,
    196,
    25,
    221,
    181,
    237,
    40,
    233,
    253,
    121,
    74,
    160,
    216,
    157,
    198,
    126,
    55,
    131,
    43,
    118,
    83,
    142,
    98,
    76,
    100,
    136,
    68,
    139,
    251,
    162,
    23,
    154,
    89,
    245,
    135,
    179,
    79,
    19,
    97,
    69,
    109,
    141,
    9,
    129,
    125,
    50,
    189,
    143,
    64,
    235,
    134,
    183,
    123,
    11,
    240,
    149,
    33,
    34,
    92,
    107,
    78,
    130,
    84,
    214,
    101,
    147,
    206,
    96,
    178,
    28,
    115,
    86,
    192,
    20,
    167,
    140,
    241,
    220,
    18,
    117,
    202,
    31,
    59,
    190,
    228,
    209,
    66,
    61,
    212,
    48,
    163,
    60,
    182,
    38,
    111,
    191,
    14,
    218,
    70,
    105,
    7,
    87,
    39,
    242,
    29,
    155,
    188,
    148,
    67,
    3,
    248,
    17,
    199,
    246,
    144,
    239,
    62,
    231,
    6,
    195,
    213,
    47,
    200,
    102,
    30,
    215,
    8,
    232,
    234,
    222,
    128,
    82,
    238,
    247,
    132,
    170,
    114,
    172,
    53,
    77,
    106,
    42,
    150,
    26,
    210,
    113,
    90,
    21,
    73,
    116,
    75,
    159,
    208,
    94,
    4,
    24,
    164,
    236,
    194,
    224,
    65,
    110,
    15,
    81,
    203,
    204,
    36,
    145,
    175,
    80,
    161,
    244,
    112,
    57,
    153,
    124,
    58,
    133,
    35,
    184,
    180,
    122,
    252,
    2,
    54,
    91,
    37,
    85,
    151,
    49,
    45,
    93,
    250,
    152,
    227,
    138,
    146,
    174,
    5,
    223,
    41,
    16,
    103,
    108,
    186,
    201,
    211,
    0,
    230,
    207,
    225,
    158,
    168,
    44,
    99,
    22,
    1,
    63,
    88,
    226,
    137,
    169,
    13,
    56,
    52,
    27,
    171,
    51,
    255,
    176,
    187,
    72,
    12,
    95,
    185,
    177,
    205,
    46,
    197,
    243,
    219,
    71,
    229,
    165,
    156,
    119,
    10,
    166,
    32,
    104,
    254,
    127,
    193,
    173
  ];
  var s32 = [1, 2, 3, 5];
  var rol = function(word, bits) {
    return word << bits & 65535 | (word & 65535) >> 16 - bits;
  };
  var ror = function(word, bits) {
    return (word & 65535) >> bits | word << 16 - bits & 65535;
  };
  module.exports = forge.rc2 = forge.rc2 || {};
  forge.rc2.expandKey = function(key, effKeyBits) {
    if (typeof key === "string") {
      key = forge.util.createBuffer(key);
    }
    effKeyBits = effKeyBits || 128;
    var L3 = key;
    var T23 = key.length();
    var T1 = effKeyBits;
    var T8 = Math.ceil(T1 / 8);
    var TM = 255 >> (T1 & 7);
    var i5;
    for (i5 = T23;i5 < 128; i5++) {
      L3.putByte(piTable[L3.at(i5 - 1) + L3.at(i5 - T23) & 255]);
    }
    L3.setAt(128 - T8, piTable[L3.at(128 - T8) & TM]);
    for (i5 = 127 - T8;i5 >= 0; i5--) {
      L3.setAt(i5, piTable[L3.at(i5 + 1) ^ L3.at(i5 + T8)]);
    }
    return L3;
  };
  var createCipher = function(key, bits, encrypt) {
    var _finish = false, _input = null, _output = null, _iv = null;
    var mixRound, mashRound;
    var i5, j23, K23 = [];
    key = forge.rc2.expandKey(key, bits);
    for (i5 = 0;i5 < 64; i5++) {
      K23.push(key.getInt16Le());
    }
    if (encrypt) {
      mixRound = function(R3) {
        for (i5 = 0;i5 < 4; i5++) {
          R3[i5] += K23[j23] + (R3[(i5 + 3) % 4] & R3[(i5 + 2) % 4]) + (~R3[(i5 + 3) % 4] & R3[(i5 + 1) % 4]);
          R3[i5] = rol(R3[i5], s32[i5]);
          j23++;
        }
      };
      mashRound = function(R3) {
        for (i5 = 0;i5 < 4; i5++) {
          R3[i5] += K23[R3[(i5 + 3) % 4] & 63];
        }
      };
    } else {
      mixRound = function(R3) {
        for (i5 = 3;i5 >= 0; i5--) {
          R3[i5] = ror(R3[i5], s32[i5]);
          R3[i5] -= K23[j23] + (R3[(i5 + 3) % 4] & R3[(i5 + 2) % 4]) + (~R3[(i5 + 3) % 4] & R3[(i5 + 1) % 4]);
          j23--;
        }
      };
      mashRound = function(R3) {
        for (i5 = 3;i5 >= 0; i5--) {
          R3[i5] -= K23[R3[(i5 + 3) % 4] & 63];
        }
      };
    }
    var runPlan = function(plan) {
      var R3 = [];
      for (i5 = 0;i5 < 4; i5++) {
        var val2 = _input.getInt16Le();
        if (_iv !== null) {
          if (encrypt) {
            val2 ^= _iv.getInt16Le();
          } else {
            _iv.putInt16Le(val2);
          }
        }
        R3.push(val2 & 65535);
      }
      j23 = encrypt ? 0 : 63;
      for (var ptr = 0;ptr < plan.length; ptr++) {
        for (var ctr = 0;ctr < plan[ptr][0]; ctr++) {
          plan[ptr][1](R3);
        }
      }
      for (i5 = 0;i5 < 4; i5++) {
        if (_iv !== null) {
          if (encrypt) {
            _iv.putInt16Le(R3[i5]);
          } else {
            R3[i5] ^= _iv.getInt16Le();
          }
        }
        _output.putInt16Le(R3[i5]);
      }
    };
    var cipher = null;
    cipher = {
      start: function(iv, output) {
        if (iv) {
          if (typeof iv === "string") {
            iv = forge.util.createBuffer(iv);
          }
        }
        _finish = false;
        _input = forge.util.createBuffer();
        _output = output || new forge.util.createBuffer;
        _iv = iv;
        cipher.output = _output;
      },
      update: function(input) {
        if (!_finish) {
          _input.putBuffer(input);
        }
        while (_input.length() >= 8) {
          runPlan([
            [5, mixRound],
            [1, mashRound],
            [6, mixRound],
            [1, mashRound],
            [5, mixRound]
          ]);
        }
      },
      finish: function(pad) {
        var rval = true;
        if (encrypt) {
          if (pad) {
            rval = pad(8, _input, !encrypt);
          } else {
            var padding = _input.length() === 8 ? 8 : 8 - _input.length();
            _input.fillWithByte(padding, padding);
          }
        }
        if (rval) {
          _finish = true;
          cipher.update();
        }
        if (!encrypt) {
          rval = _input.length() === 0;
          if (rval) {
            if (pad) {
              rval = pad(8, _output, !encrypt);
            } else {
              var len = _output.length();
              var count = _output.at(len - 1);
              if (count > len) {
                rval = false;
              } else {
                _output.truncate(count);
              }
            }
          }
        }
        return rval;
      }
    };
    return cipher;
  };
  forge.rc2.startEncrypting = function(key, iv, output) {
    var cipher = forge.rc2.createEncryptionCipher(key, 128);
    cipher.start(iv, output);
    return cipher;
  };
  forge.rc2.createEncryptionCipher = function(key, bits) {
    return createCipher(key, bits, true);
  };
  forge.rc2.startDecrypting = function(key, iv, output) {
    var cipher = forge.rc2.createDecryptionCipher(key, 128);
    cipher.start(iv, output);
    return cipher;
  };
  forge.rc2.createDecryptionCipher = function(key, bits) {
    return createCipher(key, bits, false);
  };
});
var require_jsbn = __commonJS3((exports, module) => {
  var forge = require_forge();
  module.exports = forge.jsbn = forge.jsbn || {};
  var dbits;
  var canary = 244837814094590;
  var j_lm = (canary & 16777215) == 15715070;
  function BigInteger(a5, b23, c23) {
    this.data = [];
    if (a5 != null)
      if (typeof a5 == "number")
        this.fromNumber(a5, b23, c23);
      else if (b23 == null && typeof a5 != "string")
        this.fromString(a5, 256);
      else
        this.fromString(a5, b23);
  }
  forge.jsbn.BigInteger = BigInteger;
  function nbi() {
    return new BigInteger(null);
  }
  function am1(i5, x5, w23, j23, c23, n5) {
    while (--n5 >= 0) {
      var v23 = x5 * this.data[i5++] + w23.data[j23] + c23;
      c23 = Math.floor(v23 / 67108864);
      w23.data[j23++] = v23 & 67108863;
    }
    return c23;
  }
  function am2(i5, x5, w23, j23, c23, n5) {
    var xl = x5 & 32767, xh = x5 >> 15;
    while (--n5 >= 0) {
      var l33 = this.data[i5] & 32767;
      var h33 = this.data[i5++] >> 15;
      var m23 = xh * l33 + h33 * xl;
      l33 = xl * l33 + ((m23 & 32767) << 15) + w23.data[j23] + (c23 & 1073741823);
      c23 = (l33 >>> 30) + (m23 >>> 15) + xh * h33 + (c23 >>> 30);
      w23.data[j23++] = l33 & 1073741823;
    }
    return c23;
  }
  function am3(i5, x5, w23, j23, c23, n5) {
    var xl = x5 & 16383, xh = x5 >> 14;
    while (--n5 >= 0) {
      var l33 = this.data[i5] & 16383;
      var h33 = this.data[i5++] >> 14;
      var m23 = xh * l33 + h33 * xl;
      l33 = xl * l33 + ((m23 & 16383) << 14) + w23.data[j23] + c23;
      c23 = (l33 >> 28) + (m23 >> 14) + xh * h33;
      w23.data[j23++] = l33 & 268435455;
    }
    return c23;
  }
  if (typeof navigator === "undefined") {
    BigInteger.prototype.am = am3;
    dbits = 28;
  } else if (j_lm && navigator.appName == "Microsoft Internet Explorer") {
    BigInteger.prototype.am = am2;
    dbits = 30;
  } else if (j_lm && navigator.appName != "Netscape") {
    BigInteger.prototype.am = am1;
    dbits = 26;
  } else {
    BigInteger.prototype.am = am3;
    dbits = 28;
  }
  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = (1 << dbits) - 1;
  BigInteger.prototype.DV = 1 << dbits;
  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2, BI_FP);
  BigInteger.prototype.F1 = BI_FP - dbits;
  BigInteger.prototype.F2 = 2 * dbits - BI_FP;
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array;
  var rr;
  var vv;
  rr = "0".charCodeAt(0);
  for (vv = 0;vv <= 9; ++vv)
    BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for (vv = 10;vv < 36; ++vv)
    BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for (vv = 10;vv < 36; ++vv)
    BI_RC[rr++] = vv;
  function int2char(n5) {
    return BI_RM.charAt(n5);
  }
  function intAt(s32, i5) {
    var c23 = BI_RC[s32.charCodeAt(i5)];
    return c23 == null ? -1 : c23;
  }
  function bnpCopyTo(r23) {
    for (var i5 = this.t - 1;i5 >= 0; --i5)
      r23.data[i5] = this.data[i5];
    r23.t = this.t;
    r23.s = this.s;
  }
  function bnpFromInt(x5) {
    this.t = 1;
    this.s = x5 < 0 ? -1 : 0;
    if (x5 > 0)
      this.data[0] = x5;
    else if (x5 < -1)
      this.data[0] = x5 + this.DV;
    else
      this.t = 0;
  }
  function nbv(i5) {
    var r23 = nbi();
    r23.fromInt(i5);
    return r23;
  }
  function bnpFromString(s32, b23) {
    var k5;
    if (b23 == 16)
      k5 = 4;
    else if (b23 == 8)
      k5 = 3;
    else if (b23 == 256)
      k5 = 8;
    else if (b23 == 2)
      k5 = 1;
    else if (b23 == 32)
      k5 = 5;
    else if (b23 == 4)
      k5 = 2;
    else {
      this.fromRadix(s32, b23);
      return;
    }
    this.t = 0;
    this.s = 0;
    var i5 = s32.length, mi = false, sh = 0;
    while (--i5 >= 0) {
      var x5 = k5 == 8 ? s32[i5] & 255 : intAt(s32, i5);
      if (x5 < 0) {
        if (s32.charAt(i5) == "-")
          mi = true;
        continue;
      }
      mi = false;
      if (sh == 0)
        this.data[this.t++] = x5;
      else if (sh + k5 > this.DB) {
        this.data[this.t - 1] |= (x5 & (1 << this.DB - sh) - 1) << sh;
        this.data[this.t++] = x5 >> this.DB - sh;
      } else
        this.data[this.t - 1] |= x5 << sh;
      sh += k5;
      if (sh >= this.DB)
        sh -= this.DB;
    }
    if (k5 == 8 && (s32[0] & 128) != 0) {
      this.s = -1;
      if (sh > 0)
        this.data[this.t - 1] |= (1 << this.DB - sh) - 1 << sh;
    }
    this.clamp();
    if (mi)
      BigInteger.ZERO.subTo(this, this);
  }
  function bnpClamp() {
    var c23 = this.s & this.DM;
    while (this.t > 0 && this.data[this.t - 1] == c23)
      --this.t;
  }
  function bnToString(b23) {
    if (this.s < 0)
      return "-" + this.negate().toString(b23);
    var k5;
    if (b23 == 16)
      k5 = 4;
    else if (b23 == 8)
      k5 = 3;
    else if (b23 == 2)
      k5 = 1;
    else if (b23 == 32)
      k5 = 5;
    else if (b23 == 4)
      k5 = 2;
    else
      return this.toRadix(b23);
    var km = (1 << k5) - 1, d5, m23 = false, r23 = "", i5 = this.t;
    var p33 = this.DB - i5 * this.DB % k5;
    if (i5-- > 0) {
      if (p33 < this.DB && (d5 = this.data[i5] >> p33) > 0) {
        m23 = true;
        r23 = int2char(d5);
      }
      while (i5 >= 0) {
        if (p33 < k5) {
          d5 = (this.data[i5] & (1 << p33) - 1) << k5 - p33;
          d5 |= this.data[--i5] >> (p33 += this.DB - k5);
        } else {
          d5 = this.data[i5] >> (p33 -= k5) & km;
          if (p33 <= 0) {
            p33 += this.DB;
            --i5;
          }
        }
        if (d5 > 0)
          m23 = true;
        if (m23)
          r23 += int2char(d5);
      }
    }
    return m23 ? r23 : "0";
  }
  function bnNegate() {
    var r23 = nbi();
    BigInteger.ZERO.subTo(this, r23);
    return r23;
  }
  function bnAbs() {
    return this.s < 0 ? this.negate() : this;
  }
  function bnCompareTo(a5) {
    var r23 = this.s - a5.s;
    if (r23 != 0)
      return r23;
    var i5 = this.t;
    r23 = i5 - a5.t;
    if (r23 != 0)
      return this.s < 0 ? -r23 : r23;
    while (--i5 >= 0)
      if ((r23 = this.data[i5] - a5.data[i5]) != 0)
        return r23;
    return 0;
  }
  function nbits(x5) {
    var r23 = 1, t5;
    if ((t5 = x5 >>> 16) != 0) {
      x5 = t5;
      r23 += 16;
    }
    if ((t5 = x5 >> 8) != 0) {
      x5 = t5;
      r23 += 8;
    }
    if ((t5 = x5 >> 4) != 0) {
      x5 = t5;
      r23 += 4;
    }
    if ((t5 = x5 >> 2) != 0) {
      x5 = t5;
      r23 += 2;
    }
    if ((t5 = x5 >> 1) != 0) {
      x5 = t5;
      r23 += 1;
    }
    return r23;
  }
  function bnBitLength() {
    if (this.t <= 0)
      return 0;
    return this.DB * (this.t - 1) + nbits(this.data[this.t - 1] ^ this.s & this.DM);
  }
  function bnpDLShiftTo(n5, r23) {
    var i5;
    for (i5 = this.t - 1;i5 >= 0; --i5)
      r23.data[i5 + n5] = this.data[i5];
    for (i5 = n5 - 1;i5 >= 0; --i5)
      r23.data[i5] = 0;
    r23.t = this.t + n5;
    r23.s = this.s;
  }
  function bnpDRShiftTo(n5, r23) {
    for (var i5 = n5;i5 < this.t; ++i5)
      r23.data[i5 - n5] = this.data[i5];
    r23.t = Math.max(this.t - n5, 0);
    r23.s = this.s;
  }
  function bnpLShiftTo(n5, r23) {
    var bs2 = n5 % this.DB;
    var cbs = this.DB - bs2;
    var bm2 = (1 << cbs) - 1;
    var ds = Math.floor(n5 / this.DB), c23 = this.s << bs2 & this.DM, i5;
    for (i5 = this.t - 1;i5 >= 0; --i5) {
      r23.data[i5 + ds + 1] = this.data[i5] >> cbs | c23;
      c23 = (this.data[i5] & bm2) << bs2;
    }
    for (i5 = ds - 1;i5 >= 0; --i5)
      r23.data[i5] = 0;
    r23.data[ds] = c23;
    r23.t = this.t + ds + 1;
    r23.s = this.s;
    r23.clamp();
  }
  function bnpRShiftTo(n5, r23) {
    r23.s = this.s;
    var ds = Math.floor(n5 / this.DB);
    if (ds >= this.t) {
      r23.t = 0;
      return;
    }
    var bs2 = n5 % this.DB;
    var cbs = this.DB - bs2;
    var bm2 = (1 << bs2) - 1;
    r23.data[0] = this.data[ds] >> bs2;
    for (var i5 = ds + 1;i5 < this.t; ++i5) {
      r23.data[i5 - ds - 1] |= (this.data[i5] & bm2) << cbs;
      r23.data[i5 - ds] = this.data[i5] >> bs2;
    }
    if (bs2 > 0)
      r23.data[this.t - ds - 1] |= (this.s & bm2) << cbs;
    r23.t = this.t - ds;
    r23.clamp();
  }
  function bnpSubTo(a5, r23) {
    var i5 = 0, c23 = 0, m23 = Math.min(a5.t, this.t);
    while (i5 < m23) {
      c23 += this.data[i5] - a5.data[i5];
      r23.data[i5++] = c23 & this.DM;
      c23 >>= this.DB;
    }
    if (a5.t < this.t) {
      c23 -= a5.s;
      while (i5 < this.t) {
        c23 += this.data[i5];
        r23.data[i5++] = c23 & this.DM;
        c23 >>= this.DB;
      }
      c23 += this.s;
    } else {
      c23 += this.s;
      while (i5 < a5.t) {
        c23 -= a5.data[i5];
        r23.data[i5++] = c23 & this.DM;
        c23 >>= this.DB;
      }
      c23 -= a5.s;
    }
    r23.s = c23 < 0 ? -1 : 0;
    if (c23 < -1)
      r23.data[i5++] = this.DV + c23;
    else if (c23 > 0)
      r23.data[i5++] = c23;
    r23.t = i5;
    r23.clamp();
  }
  function bnpMultiplyTo(a5, r23) {
    var x5 = this.abs(), y3 = a5.abs();
    var i5 = x5.t;
    r23.t = i5 + y3.t;
    while (--i5 >= 0)
      r23.data[i5] = 0;
    for (i5 = 0;i5 < y3.t; ++i5)
      r23.data[i5 + x5.t] = x5.am(0, y3.data[i5], r23, i5, 0, x5.t);
    r23.s = 0;
    r23.clamp();
    if (this.s != a5.s)
      BigInteger.ZERO.subTo(r23, r23);
  }
  function bnpSquareTo(r23) {
    var x5 = this.abs();
    var i5 = r23.t = 2 * x5.t;
    while (--i5 >= 0)
      r23.data[i5] = 0;
    for (i5 = 0;i5 < x5.t - 1; ++i5) {
      var c23 = x5.am(i5, x5.data[i5], r23, 2 * i5, 0, 1);
      if ((r23.data[i5 + x5.t] += x5.am(i5 + 1, 2 * x5.data[i5], r23, 2 * i5 + 1, c23, x5.t - i5 - 1)) >= x5.DV) {
        r23.data[i5 + x5.t] -= x5.DV;
        r23.data[i5 + x5.t + 1] = 1;
      }
    }
    if (r23.t > 0)
      r23.data[r23.t - 1] += x5.am(i5, x5.data[i5], r23, 2 * i5, 0, 1);
    r23.s = 0;
    r23.clamp();
  }
  function bnpDivRemTo(m23, q6, r23) {
    var pm = m23.abs();
    if (pm.t <= 0)
      return;
    var pt = this.abs();
    if (pt.t < pm.t) {
      if (q6 != null)
        q6.fromInt(0);
      if (r23 != null)
        this.copyTo(r23);
      return;
    }
    if (r23 == null)
      r23 = nbi();
    var y3 = nbi(), ts = this.s, ms = m23.s;
    var nsh = this.DB - nbits(pm.data[pm.t - 1]);
    if (nsh > 0) {
      pm.lShiftTo(nsh, y3);
      pt.lShiftTo(nsh, r23);
    } else {
      pm.copyTo(y3);
      pt.copyTo(r23);
    }
    var ys = y3.t;
    var y0 = y3.data[ys - 1];
    if (y0 == 0)
      return;
    var yt = y0 * (1 << this.F1) + (ys > 1 ? y3.data[ys - 2] >> this.F2 : 0);
    var d1 = this.FV / yt, d22 = (1 << this.F1) / yt, e5 = 1 << this.F2;
    var i5 = r23.t, j23 = i5 - ys, t5 = q6 == null ? nbi() : q6;
    y3.dlShiftTo(j23, t5);
    if (r23.compareTo(t5) >= 0) {
      r23.data[r23.t++] = 1;
      r23.subTo(t5, r23);
    }
    BigInteger.ONE.dlShiftTo(ys, t5);
    t5.subTo(y3, y3);
    while (y3.t < ys)
      y3.data[y3.t++] = 0;
    while (--j23 >= 0) {
      var qd = r23.data[--i5] == y0 ? this.DM : Math.floor(r23.data[i5] * d1 + (r23.data[i5 - 1] + e5) * d22);
      if ((r23.data[i5] += y3.am(0, qd, r23, j23, 0, ys)) < qd) {
        y3.dlShiftTo(j23, t5);
        r23.subTo(t5, r23);
        while (r23.data[i5] < --qd)
          r23.subTo(t5, r23);
      }
    }
    if (q6 != null) {
      r23.drShiftTo(ys, q6);
      if (ts != ms)
        BigInteger.ZERO.subTo(q6, q6);
    }
    r23.t = ys;
    r23.clamp();
    if (nsh > 0)
      r23.rShiftTo(nsh, r23);
    if (ts < 0)
      BigInteger.ZERO.subTo(r23, r23);
  }
  function bnMod(a5) {
    var r23 = nbi();
    this.abs().divRemTo(a5, null, r23);
    if (this.s < 0 && r23.compareTo(BigInteger.ZERO) > 0)
      a5.subTo(r23, r23);
    return r23;
  }
  function Classic(m23) {
    this.m = m23;
  }
  function cConvert(x5) {
    if (x5.s < 0 || x5.compareTo(this.m) >= 0)
      return x5.mod(this.m);
    else
      return x5;
  }
  function cRevert(x5) {
    return x5;
  }
  function cReduce(x5) {
    x5.divRemTo(this.m, null, x5);
  }
  function cMulTo(x5, y3, r23) {
    x5.multiplyTo(y3, r23);
    this.reduce(r23);
  }
  function cSqrTo(x5, r23) {
    x5.squareTo(r23);
    this.reduce(r23);
  }
  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;
  function bnpInvDigit() {
    if (this.t < 1)
      return 0;
    var x5 = this.data[0];
    if ((x5 & 1) == 0)
      return 0;
    var y3 = x5 & 3;
    y3 = y3 * (2 - (x5 & 15) * y3) & 15;
    y3 = y3 * (2 - (x5 & 255) * y3) & 255;
    y3 = y3 * (2 - ((x5 & 65535) * y3 & 65535)) & 65535;
    y3 = y3 * (2 - x5 * y3 % this.DV) % this.DV;
    return y3 > 0 ? this.DV - y3 : -y3;
  }
  function Montgomery(m23) {
    this.m = m23;
    this.mp = m23.invDigit();
    this.mpl = this.mp & 32767;
    this.mph = this.mp >> 15;
    this.um = (1 << m23.DB - 15) - 1;
    this.mt2 = 2 * m23.t;
  }
  function montConvert(x5) {
    var r23 = nbi();
    x5.abs().dlShiftTo(this.m.t, r23);
    r23.divRemTo(this.m, null, r23);
    if (x5.s < 0 && r23.compareTo(BigInteger.ZERO) > 0)
      this.m.subTo(r23, r23);
    return r23;
  }
  function montRevert(x5) {
    var r23 = nbi();
    x5.copyTo(r23);
    this.reduce(r23);
    return r23;
  }
  function montReduce(x5) {
    while (x5.t <= this.mt2)
      x5.data[x5.t++] = 0;
    for (var i5 = 0;i5 < this.m.t; ++i5) {
      var j23 = x5.data[i5] & 32767;
      var u0 = j23 * this.mpl + ((j23 * this.mph + (x5.data[i5] >> 15) * this.mpl & this.um) << 15) & x5.DM;
      j23 = i5 + this.m.t;
      x5.data[j23] += this.m.am(0, u0, x5, i5, 0, this.m.t);
      while (x5.data[j23] >= x5.DV) {
        x5.data[j23] -= x5.DV;
        x5.data[++j23]++;
      }
    }
    x5.clamp();
    x5.drShiftTo(this.m.t, x5);
    if (x5.compareTo(this.m) >= 0)
      x5.subTo(this.m, x5);
  }
  function montSqrTo(x5, r23) {
    x5.squareTo(r23);
    this.reduce(r23);
  }
  function montMulTo(x5, y3, r23) {
    x5.multiplyTo(y3, r23);
    this.reduce(r23);
  }
  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;
  function bnpIsEven() {
    return (this.t > 0 ? this.data[0] & 1 : this.s) == 0;
  }
  function bnpExp(e5, z23) {
    if (e5 > 4294967295 || e5 < 1)
      return BigInteger.ONE;
    var r23 = nbi(), r222 = nbi(), g23 = z23.convert(this), i5 = nbits(e5) - 1;
    g23.copyTo(r23);
    while (--i5 >= 0) {
      z23.sqrTo(r23, r222);
      if ((e5 & 1 << i5) > 0)
        z23.mulTo(r222, g23, r23);
      else {
        var t5 = r23;
        r23 = r222;
        r222 = t5;
      }
    }
    return z23.revert(r23);
  }
  function bnModPowInt(e5, m23) {
    var z23;
    if (e5 < 256 || m23.isEven())
      z23 = new Classic(m23);
    else
      z23 = new Montgomery(m23);
    return this.exp(e5, z23);
  }
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);
  function bnClone() {
    var r23 = nbi();
    this.copyTo(r23);
    return r23;
  }
  function bnIntValue() {
    if (this.s < 0) {
      if (this.t == 1)
        return this.data[0] - this.DV;
      else if (this.t == 0)
        return -1;
    } else if (this.t == 1)
      return this.data[0];
    else if (this.t == 0)
      return 0;
    return (this.data[1] & (1 << 32 - this.DB) - 1) << this.DB | this.data[0];
  }
  function bnByteValue() {
    return this.t == 0 ? this.s : this.data[0] << 24 >> 24;
  }
  function bnShortValue() {
    return this.t == 0 ? this.s : this.data[0] << 16 >> 16;
  }
  function bnpChunkSize(r23) {
    return Math.floor(Math.LN2 * this.DB / Math.log(r23));
  }
  function bnSigNum() {
    if (this.s < 0)
      return -1;
    else if (this.t <= 0 || this.t == 1 && this.data[0] <= 0)
      return 0;
    else
      return 1;
  }
  function bnpToRadix(b23) {
    if (b23 == null)
      b23 = 10;
    if (this.signum() == 0 || b23 < 2 || b23 > 36)
      return "0";
    var cs2 = this.chunkSize(b23);
    var a5 = Math.pow(b23, cs2);
    var d5 = nbv(a5), y3 = nbi(), z23 = nbi(), r23 = "";
    this.divRemTo(d5, y3, z23);
    while (y3.signum() > 0) {
      r23 = (a5 + z23.intValue()).toString(b23).substr(1) + r23;
      y3.divRemTo(d5, y3, z23);
    }
    return z23.intValue().toString(b23) + r23;
  }
  function bnpFromRadix(s32, b23) {
    this.fromInt(0);
    if (b23 == null)
      b23 = 10;
    var cs2 = this.chunkSize(b23);
    var d5 = Math.pow(b23, cs2), mi = false, j23 = 0, w23 = 0;
    for (var i5 = 0;i5 < s32.length; ++i5) {
      var x5 = intAt(s32, i5);
      if (x5 < 0) {
        if (s32.charAt(i5) == "-" && this.signum() == 0)
          mi = true;
        continue;
      }
      w23 = b23 * w23 + x5;
      if (++j23 >= cs2) {
        this.dMultiply(d5);
        this.dAddOffset(w23, 0);
        j23 = 0;
        w23 = 0;
      }
    }
    if (j23 > 0) {
      this.dMultiply(Math.pow(b23, j23));
      this.dAddOffset(w23, 0);
    }
    if (mi)
      BigInteger.ZERO.subTo(this, this);
  }
  function bnpFromNumber(a5, b23, c23) {
    if (typeof b23 == "number") {
      if (a5 < 2)
        this.fromInt(1);
      else {
        this.fromNumber(a5, c23);
        if (!this.testBit(a5 - 1))
          this.bitwiseTo(BigInteger.ONE.shiftLeft(a5 - 1), op_or, this);
        if (this.isEven())
          this.dAddOffset(1, 0);
        while (!this.isProbablePrime(b23)) {
          this.dAddOffset(2, 0);
          if (this.bitLength() > a5)
            this.subTo(BigInteger.ONE.shiftLeft(a5 - 1), this);
        }
      }
    } else {
      var x5 = new Array, t5 = a5 & 7;
      x5.length = (a5 >> 3) + 1;
      b23.nextBytes(x5);
      if (t5 > 0)
        x5[0] &= (1 << t5) - 1;
      else
        x5[0] = 0;
      this.fromString(x5, 256);
    }
  }
  function bnToByteArray() {
    var i5 = this.t, r23 = new Array;
    r23[0] = this.s;
    var p33 = this.DB - i5 * this.DB % 8, d5, k5 = 0;
    if (i5-- > 0) {
      if (p33 < this.DB && (d5 = this.data[i5] >> p33) != (this.s & this.DM) >> p33)
        r23[k5++] = d5 | this.s << this.DB - p33;
      while (i5 >= 0) {
        if (p33 < 8) {
          d5 = (this.data[i5] & (1 << p33) - 1) << 8 - p33;
          d5 |= this.data[--i5] >> (p33 += this.DB - 8);
        } else {
          d5 = this.data[i5] >> (p33 -= 8) & 255;
          if (p33 <= 0) {
            p33 += this.DB;
            --i5;
          }
        }
        if ((d5 & 128) != 0)
          d5 |= -256;
        if (k5 == 0 && (this.s & 128) != (d5 & 128))
          ++k5;
        if (k5 > 0 || d5 != this.s)
          r23[k5++] = d5;
      }
    }
    return r23;
  }
  function bnEquals(a5) {
    return this.compareTo(a5) == 0;
  }
  function bnMin(a5) {
    return this.compareTo(a5) < 0 ? this : a5;
  }
  function bnMax(a5) {
    return this.compareTo(a5) > 0 ? this : a5;
  }
  function bnpBitwiseTo(a5, op, r23) {
    var i5, f23, m23 = Math.min(a5.t, this.t);
    for (i5 = 0;i5 < m23; ++i5)
      r23.data[i5] = op(this.data[i5], a5.data[i5]);
    if (a5.t < this.t) {
      f23 = a5.s & this.DM;
      for (i5 = m23;i5 < this.t; ++i5)
        r23.data[i5] = op(this.data[i5], f23);
      r23.t = this.t;
    } else {
      f23 = this.s & this.DM;
      for (i5 = m23;i5 < a5.t; ++i5)
        r23.data[i5] = op(f23, a5.data[i5]);
      r23.t = a5.t;
    }
    r23.s = op(this.s, a5.s);
    r23.clamp();
  }
  function op_and(x5, y3) {
    return x5 & y3;
  }
  function bnAnd(a5) {
    var r23 = nbi();
    this.bitwiseTo(a5, op_and, r23);
    return r23;
  }
  function op_or(x5, y3) {
    return x5 | y3;
  }
  function bnOr(a5) {
    var r23 = nbi();
    this.bitwiseTo(a5, op_or, r23);
    return r23;
  }
  function op_xor(x5, y3) {
    return x5 ^ y3;
  }
  function bnXor(a5) {
    var r23 = nbi();
    this.bitwiseTo(a5, op_xor, r23);
    return r23;
  }
  function op_andnot(x5, y3) {
    return x5 & ~y3;
  }
  function bnAndNot(a5) {
    var r23 = nbi();
    this.bitwiseTo(a5, op_andnot, r23);
    return r23;
  }
  function bnNot() {
    var r23 = nbi();
    for (var i5 = 0;i5 < this.t; ++i5)
      r23.data[i5] = this.DM & ~this.data[i5];
    r23.t = this.t;
    r23.s = ~this.s;
    return r23;
  }
  function bnShiftLeft(n5) {
    var r23 = nbi();
    if (n5 < 0)
      this.rShiftTo(-n5, r23);
    else
      this.lShiftTo(n5, r23);
    return r23;
  }
  function bnShiftRight(n5) {
    var r23 = nbi();
    if (n5 < 0)
      this.lShiftTo(-n5, r23);
    else
      this.rShiftTo(n5, r23);
    return r23;
  }
  function lbit(x5) {
    if (x5 == 0)
      return -1;
    var r23 = 0;
    if ((x5 & 65535) == 0) {
      x5 >>= 16;
      r23 += 16;
    }
    if ((x5 & 255) == 0) {
      x5 >>= 8;
      r23 += 8;
    }
    if ((x5 & 15) == 0) {
      x5 >>= 4;
      r23 += 4;
    }
    if ((x5 & 3) == 0) {
      x5 >>= 2;
      r23 += 2;
    }
    if ((x5 & 1) == 0)
      ++r23;
    return r23;
  }
  function bnGetLowestSetBit() {
    for (var i5 = 0;i5 < this.t; ++i5)
      if (this.data[i5] != 0)
        return i5 * this.DB + lbit(this.data[i5]);
    if (this.s < 0)
      return this.t * this.DB;
    return -1;
  }
  function cbit(x5) {
    var r23 = 0;
    while (x5 != 0) {
      x5 &= x5 - 1;
      ++r23;
    }
    return r23;
  }
  function bnBitCount() {
    var r23 = 0, x5 = this.s & this.DM;
    for (var i5 = 0;i5 < this.t; ++i5)
      r23 += cbit(this.data[i5] ^ x5);
    return r23;
  }
  function bnTestBit(n5) {
    var j23 = Math.floor(n5 / this.DB);
    if (j23 >= this.t)
      return this.s != 0;
    return (this.data[j23] & 1 << n5 % this.DB) != 0;
  }
  function bnpChangeBit(n5, op) {
    var r23 = BigInteger.ONE.shiftLeft(n5);
    this.bitwiseTo(r23, op, r23);
    return r23;
  }
  function bnSetBit(n5) {
    return this.changeBit(n5, op_or);
  }
  function bnClearBit(n5) {
    return this.changeBit(n5, op_andnot);
  }
  function bnFlipBit(n5) {
    return this.changeBit(n5, op_xor);
  }
  function bnpAddTo(a5, r23) {
    var i5 = 0, c23 = 0, m23 = Math.min(a5.t, this.t);
    while (i5 < m23) {
      c23 += this.data[i5] + a5.data[i5];
      r23.data[i5++] = c23 & this.DM;
      c23 >>= this.DB;
    }
    if (a5.t < this.t) {
      c23 += a5.s;
      while (i5 < this.t) {
        c23 += this.data[i5];
        r23.data[i5++] = c23 & this.DM;
        c23 >>= this.DB;
      }
      c23 += this.s;
    } else {
      c23 += this.s;
      while (i5 < a5.t) {
        c23 += a5.data[i5];
        r23.data[i5++] = c23 & this.DM;
        c23 >>= this.DB;
      }
      c23 += a5.s;
    }
    r23.s = c23 < 0 ? -1 : 0;
    if (c23 > 0)
      r23.data[i5++] = c23;
    else if (c23 < -1)
      r23.data[i5++] = this.DV + c23;
    r23.t = i5;
    r23.clamp();
  }
  function bnAdd(a5) {
    var r23 = nbi();
    this.addTo(a5, r23);
    return r23;
  }
  function bnSubtract(a5) {
    var r23 = nbi();
    this.subTo(a5, r23);
    return r23;
  }
  function bnMultiply(a5) {
    var r23 = nbi();
    this.multiplyTo(a5, r23);
    return r23;
  }
  function bnDivide(a5) {
    var r23 = nbi();
    this.divRemTo(a5, r23, null);
    return r23;
  }
  function bnRemainder(a5) {
    var r23 = nbi();
    this.divRemTo(a5, null, r23);
    return r23;
  }
  function bnDivideAndRemainder(a5) {
    var q6 = nbi(), r23 = nbi();
    this.divRemTo(a5, q6, r23);
    return new Array(q6, r23);
  }
  function bnpDMultiply(n5) {
    this.data[this.t] = this.am(0, n5 - 1, this, 0, 0, this.t);
    ++this.t;
    this.clamp();
  }
  function bnpDAddOffset(n5, w23) {
    if (n5 == 0)
      return;
    while (this.t <= w23)
      this.data[this.t++] = 0;
    this.data[w23] += n5;
    while (this.data[w23] >= this.DV) {
      this.data[w23] -= this.DV;
      if (++w23 >= this.t)
        this.data[this.t++] = 0;
      ++this.data[w23];
    }
  }
  function NullExp() {
  }
  function nNop(x5) {
    return x5;
  }
  function nMulTo(x5, y3, r23) {
    x5.multiplyTo(y3, r23);
  }
  function nSqrTo(x5, r23) {
    x5.squareTo(r23);
  }
  NullExp.prototype.convert = nNop;
  NullExp.prototype.revert = nNop;
  NullExp.prototype.mulTo = nMulTo;
  NullExp.prototype.sqrTo = nSqrTo;
  function bnPow(e5) {
    return this.exp(e5, new NullExp);
  }
  function bnpMultiplyLowerTo(a5, n5, r23) {
    var i5 = Math.min(this.t + a5.t, n5);
    r23.s = 0;
    r23.t = i5;
    while (i5 > 0)
      r23.data[--i5] = 0;
    var j23;
    for (j23 = r23.t - this.t;i5 < j23; ++i5)
      r23.data[i5 + this.t] = this.am(0, a5.data[i5], r23, i5, 0, this.t);
    for (j23 = Math.min(a5.t, n5);i5 < j23; ++i5)
      this.am(0, a5.data[i5], r23, i5, 0, n5 - i5);
    r23.clamp();
  }
  function bnpMultiplyUpperTo(a5, n5, r23) {
    --n5;
    var i5 = r23.t = this.t + a5.t - n5;
    r23.s = 0;
    while (--i5 >= 0)
      r23.data[i5] = 0;
    for (i5 = Math.max(n5 - this.t, 0);i5 < a5.t; ++i5)
      r23.data[this.t + i5 - n5] = this.am(n5 - i5, a5.data[i5], r23, 0, 0, this.t + i5 - n5);
    r23.clamp();
    r23.drShiftTo(1, r23);
  }
  function Barrett(m23) {
    this.r2 = nbi();
    this.q3 = nbi();
    BigInteger.ONE.dlShiftTo(2 * m23.t, this.r2);
    this.mu = this.r2.divide(m23);
    this.m = m23;
  }
  function barrettConvert(x5) {
    if (x5.s < 0 || x5.t > 2 * this.m.t)
      return x5.mod(this.m);
    else if (x5.compareTo(this.m) < 0)
      return x5;
    else {
      var r23 = nbi();
      x5.copyTo(r23);
      this.reduce(r23);
      return r23;
    }
  }
  function barrettRevert(x5) {
    return x5;
  }
  function barrettReduce(x5) {
    x5.drShiftTo(this.m.t - 1, this.r2);
    if (x5.t > this.m.t + 1) {
      x5.t = this.m.t + 1;
      x5.clamp();
    }
    this.mu.multiplyUpperTo(this.r2, this.m.t + 1, this.q3);
    this.m.multiplyLowerTo(this.q3, this.m.t + 1, this.r2);
    while (x5.compareTo(this.r2) < 0)
      x5.dAddOffset(1, this.m.t + 1);
    x5.subTo(this.r2, x5);
    while (x5.compareTo(this.m) >= 0)
      x5.subTo(this.m, x5);
  }
  function barrettSqrTo(x5, r23) {
    x5.squareTo(r23);
    this.reduce(r23);
  }
  function barrettMulTo(x5, y3, r23) {
    x5.multiplyTo(y3, r23);
    this.reduce(r23);
  }
  Barrett.prototype.convert = barrettConvert;
  Barrett.prototype.revert = barrettRevert;
  Barrett.prototype.reduce = barrettReduce;
  Barrett.prototype.mulTo = barrettMulTo;
  Barrett.prototype.sqrTo = barrettSqrTo;
  function bnModPow(e5, m23) {
    var i5 = e5.bitLength(), k5, r23 = nbv(1), z23;
    if (i5 <= 0)
      return r23;
    else if (i5 < 18)
      k5 = 1;
    else if (i5 < 48)
      k5 = 3;
    else if (i5 < 144)
      k5 = 4;
    else if (i5 < 768)
      k5 = 5;
    else
      k5 = 6;
    if (i5 < 8)
      z23 = new Classic(m23);
    else if (m23.isEven())
      z23 = new Barrett(m23);
    else
      z23 = new Montgomery(m23);
    var g23 = new Array, n5 = 3, k1 = k5 - 1, km = (1 << k5) - 1;
    g23[1] = z23.convert(this);
    if (k5 > 1) {
      var g222 = nbi();
      z23.sqrTo(g23[1], g222);
      while (n5 <= km) {
        g23[n5] = nbi();
        z23.mulTo(g222, g23[n5 - 2], g23[n5]);
        n5 += 2;
      }
    }
    var j23 = e5.t - 1, w23, is1 = true, r222 = nbi(), t5;
    i5 = nbits(e5.data[j23]) - 1;
    while (j23 >= 0) {
      if (i5 >= k1)
        w23 = e5.data[j23] >> i5 - k1 & km;
      else {
        w23 = (e5.data[j23] & (1 << i5 + 1) - 1) << k1 - i5;
        if (j23 > 0)
          w23 |= e5.data[j23 - 1] >> this.DB + i5 - k1;
      }
      n5 = k5;
      while ((w23 & 1) == 0) {
        w23 >>= 1;
        --n5;
      }
      if ((i5 -= n5) < 0) {
        i5 += this.DB;
        --j23;
      }
      if (is1) {
        g23[w23].copyTo(r23);
        is1 = false;
      } else {
        while (n5 > 1) {
          z23.sqrTo(r23, r222);
          z23.sqrTo(r222, r23);
          n5 -= 2;
        }
        if (n5 > 0)
          z23.sqrTo(r23, r222);
        else {
          t5 = r23;
          r23 = r222;
          r222 = t5;
        }
        z23.mulTo(r222, g23[w23], r23);
      }
      while (j23 >= 0 && (e5.data[j23] & 1 << i5) == 0) {
        z23.sqrTo(r23, r222);
        t5 = r23;
        r23 = r222;
        r222 = t5;
        if (--i5 < 0) {
          i5 = this.DB - 1;
          --j23;
        }
      }
    }
    return z23.revert(r23);
  }
  function bnGCD(a5) {
    var x5 = this.s < 0 ? this.negate() : this.clone();
    var y3 = a5.s < 0 ? a5.negate() : a5.clone();
    if (x5.compareTo(y3) < 0) {
      var t5 = x5;
      x5 = y3;
      y3 = t5;
    }
    var i5 = x5.getLowestSetBit(), g23 = y3.getLowestSetBit();
    if (g23 < 0)
      return x5;
    if (i5 < g23)
      g23 = i5;
    if (g23 > 0) {
      x5.rShiftTo(g23, x5);
      y3.rShiftTo(g23, y3);
    }
    while (x5.signum() > 0) {
      if ((i5 = x5.getLowestSetBit()) > 0)
        x5.rShiftTo(i5, x5);
      if ((i5 = y3.getLowestSetBit()) > 0)
        y3.rShiftTo(i5, y3);
      if (x5.compareTo(y3) >= 0) {
        x5.subTo(y3, x5);
        x5.rShiftTo(1, x5);
      } else {
        y3.subTo(x5, y3);
        y3.rShiftTo(1, y3);
      }
    }
    if (g23 > 0)
      y3.lShiftTo(g23, y3);
    return y3;
  }
  function bnpModInt(n5) {
    if (n5 <= 0)
      return 0;
    var d5 = this.DV % n5, r23 = this.s < 0 ? n5 - 1 : 0;
    if (this.t > 0)
      if (d5 == 0)
        r23 = this.data[0] % n5;
      else
        for (var i5 = this.t - 1;i5 >= 0; --i5)
          r23 = (d5 * r23 + this.data[i5]) % n5;
    return r23;
  }
  function bnModInverse(m23) {
    var ac2 = m23.isEven();
    if (this.isEven() && ac2 || m23.signum() == 0)
      return BigInteger.ZERO;
    var u5 = m23.clone(), v23 = this.clone();
    var a5 = nbv(1), b23 = nbv(0), c23 = nbv(0), d5 = nbv(1);
    while (u5.signum() != 0) {
      while (u5.isEven()) {
        u5.rShiftTo(1, u5);
        if (ac2) {
          if (!a5.isEven() || !b23.isEven()) {
            a5.addTo(this, a5);
            b23.subTo(m23, b23);
          }
          a5.rShiftTo(1, a5);
        } else if (!b23.isEven())
          b23.subTo(m23, b23);
        b23.rShiftTo(1, b23);
      }
      while (v23.isEven()) {
        v23.rShiftTo(1, v23);
        if (ac2) {
          if (!c23.isEven() || !d5.isEven()) {
            c23.addTo(this, c23);
            d5.subTo(m23, d5);
          }
          c23.rShiftTo(1, c23);
        } else if (!d5.isEven())
          d5.subTo(m23, d5);
        d5.rShiftTo(1, d5);
      }
      if (u5.compareTo(v23) >= 0) {
        u5.subTo(v23, u5);
        if (ac2)
          a5.subTo(c23, a5);
        b23.subTo(d5, b23);
      } else {
        v23.subTo(u5, v23);
        if (ac2)
          c23.subTo(a5, c23);
        d5.subTo(b23, d5);
      }
    }
    if (v23.compareTo(BigInteger.ONE) != 0)
      return BigInteger.ZERO;
    if (d5.compareTo(m23) >= 0)
      return d5.subtract(m23);
    if (d5.signum() < 0)
      d5.addTo(m23, d5);
    else
      return d5;
    if (d5.signum() < 0)
      return d5.add(m23);
    else
      return d5;
  }
  var lowprimes = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509];
  var lplim = (1 << 26) / lowprimes[lowprimes.length - 1];
  function bnIsProbablePrime(t5) {
    var i5, x5 = this.abs();
    if (x5.t == 1 && x5.data[0] <= lowprimes[lowprimes.length - 1]) {
      for (i5 = 0;i5 < lowprimes.length; ++i5)
        if (x5.data[0] == lowprimes[i5])
          return true;
      return false;
    }
    if (x5.isEven())
      return false;
    i5 = 1;
    while (i5 < lowprimes.length) {
      var m23 = lowprimes[i5], j23 = i5 + 1;
      while (j23 < lowprimes.length && m23 < lplim)
        m23 *= lowprimes[j23++];
      m23 = x5.modInt(m23);
      while (i5 < j23)
        if (m23 % lowprimes[i5++] == 0)
          return false;
    }
    return x5.millerRabin(t5);
  }
  function bnpMillerRabin(t5) {
    var n1 = this.subtract(BigInteger.ONE);
    var k5 = n1.getLowestSetBit();
    if (k5 <= 0)
      return false;
    var r23 = n1.shiftRight(k5);
    var prng = bnGetPrng();
    var a5;
    for (var i5 = 0;i5 < t5; ++i5) {
      do {
        a5 = new BigInteger(this.bitLength(), prng);
      } while (a5.compareTo(BigInteger.ONE) <= 0 || a5.compareTo(n1) >= 0);
      var y3 = a5.modPow(r23, this);
      if (y3.compareTo(BigInteger.ONE) != 0 && y3.compareTo(n1) != 0) {
        var j23 = 1;
        while (j23++ < k5 && y3.compareTo(n1) != 0) {
          y3 = y3.modPowInt(2, this);
          if (y3.compareTo(BigInteger.ONE) == 0)
            return false;
        }
        if (y3.compareTo(n1) != 0)
          return false;
      }
    }
    return true;
  }
  function bnGetPrng() {
    return {
      nextBytes: function(x5) {
        for (var i5 = 0;i5 < x5.length; ++i5) {
          x5[i5] = Math.floor(Math.random() * 256);
        }
      }
    };
  }
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.fromNumber = bnpFromNumber;
  BigInteger.prototype.bitwiseTo = bnpBitwiseTo;
  BigInteger.prototype.changeBit = bnpChangeBit;
  BigInteger.prototype.addTo = bnpAddTo;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.multiplyLowerTo = bnpMultiplyLowerTo;
  BigInteger.prototype.multiplyUpperTo = bnpMultiplyUpperTo;
  BigInteger.prototype.modInt = bnpModInt;
  BigInteger.prototype.millerRabin = bnpMillerRabin;
  BigInteger.prototype.clone = bnClone;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.byteValue = bnByteValue;
  BigInteger.prototype.shortValue = bnShortValue;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.toByteArray = bnToByteArray;
  BigInteger.prototype.equals = bnEquals;
  BigInteger.prototype.min = bnMin;
  BigInteger.prototype.max = bnMax;
  BigInteger.prototype.and = bnAnd;
  BigInteger.prototype.or = bnOr;
  BigInteger.prototype.xor = bnXor;
  BigInteger.prototype.andNot = bnAndNot;
  BigInteger.prototype.not = bnNot;
  BigInteger.prototype.shiftLeft = bnShiftLeft;
  BigInteger.prototype.shiftRight = bnShiftRight;
  BigInteger.prototype.getLowestSetBit = bnGetLowestSetBit;
  BigInteger.prototype.bitCount = bnBitCount;
  BigInteger.prototype.testBit = bnTestBit;
  BigInteger.prototype.setBit = bnSetBit;
  BigInteger.prototype.clearBit = bnClearBit;
  BigInteger.prototype.flipBit = bnFlipBit;
  BigInteger.prototype.add = bnAdd;
  BigInteger.prototype.subtract = bnSubtract;
  BigInteger.prototype.multiply = bnMultiply;
  BigInteger.prototype.divide = bnDivide;
  BigInteger.prototype.remainder = bnRemainder;
  BigInteger.prototype.divideAndRemainder = bnDivideAndRemainder;
  BigInteger.prototype.modPow = bnModPow;
  BigInteger.prototype.modInverse = bnModInverse;
  BigInteger.prototype.pow = bnPow;
  BigInteger.prototype.gcd = bnGCD;
  BigInteger.prototype.isProbablePrime = bnIsProbablePrime;
});
var require_sha13 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_md();
  require_util33();
  var sha1 = module.exports = forge.sha1 = forge.sha1 || {};
  forge.md.sha1 = forge.md.algorithms.sha1 = sha1;
  sha1.create = function() {
    if (!_initialized) {
      _init();
    }
    var _state = null;
    var _input = forge.util.createBuffer();
    var _w2 = new Array(80);
    var md = {
      algorithm: "sha1",
      blockLength: 64,
      digestLength: 20,
      messageLength: 0,
      fullMessageLength: null,
      messageLengthSize: 8
    };
    md.start = function() {
      md.messageLength = 0;
      md.fullMessageLength = md.messageLength64 = [];
      var int32s = md.messageLengthSize / 4;
      for (var i5 = 0;i5 < int32s; ++i5) {
        md.fullMessageLength.push(0);
      }
      _input = forge.util.createBuffer();
      _state = {
        h0: 1732584193,
        h1: 4023233417,
        h2: 2562383102,
        h3: 271733878,
        h4: 3285377520
      };
      return md;
    };
    md.start();
    md.update = function(msg, encoding) {
      if (encoding === "utf8") {
        msg = forge.util.encodeUtf8(msg);
      }
      var len = msg.length;
      md.messageLength += len;
      len = [len / 4294967296 >>> 0, len >>> 0];
      for (var i5 = md.fullMessageLength.length - 1;i5 >= 0; --i5) {
        md.fullMessageLength[i5] += len[1];
        len[1] = len[0] + (md.fullMessageLength[i5] / 4294967296 >>> 0);
        md.fullMessageLength[i5] = md.fullMessageLength[i5] >>> 0;
        len[0] = len[1] / 4294967296 >>> 0;
      }
      _input.putBytes(msg);
      _update(_state, _w2, _input);
      if (_input.read > 2048 || _input.length() === 0) {
        _input.compact();
      }
      return md;
    };
    md.digest = function() {
      var finalBlock = forge.util.createBuffer();
      finalBlock.putBytes(_input.bytes());
      var remaining = md.fullMessageLength[md.fullMessageLength.length - 1] + md.messageLengthSize;
      var overflow = remaining & md.blockLength - 1;
      finalBlock.putBytes(_padding.substr(0, md.blockLength - overflow));
      var next, carry;
      var bits = md.fullMessageLength[0] * 8;
      for (var i5 = 0;i5 < md.fullMessageLength.length - 1; ++i5) {
        next = md.fullMessageLength[i5 + 1] * 8;
        carry = next / 4294967296 >>> 0;
        bits += carry;
        finalBlock.putInt32(bits >>> 0);
        bits = next >>> 0;
      }
      finalBlock.putInt32(bits);
      var s222 = {
        h0: _state.h0,
        h1: _state.h1,
        h2: _state.h2,
        h3: _state.h3,
        h4: _state.h4
      };
      _update(s222, _w2, finalBlock);
      var rval = forge.util.createBuffer();
      rval.putInt32(s222.h0);
      rval.putInt32(s222.h1);
      rval.putInt32(s222.h2);
      rval.putInt32(s222.h3);
      rval.putInt32(s222.h4);
      return rval;
    };
    return md;
  };
  var _padding = null;
  var _initialized = false;
  function _init() {
    _padding = String.fromCharCode(128);
    _padding += forge.util.fillString(String.fromCharCode(0), 64);
    _initialized = true;
  }
  function _update(s32, w23, bytes) {
    var t5, a5, b23, c23, d5, e5, f23, i5;
    var len = bytes.length();
    while (len >= 64) {
      a5 = s32.h0;
      b23 = s32.h1;
      c23 = s32.h2;
      d5 = s32.h3;
      e5 = s32.h4;
      for (i5 = 0;i5 < 16; ++i5) {
        t5 = bytes.getInt32();
        w23[i5] = t5;
        f23 = d5 ^ b23 & (c23 ^ d5);
        t5 = (a5 << 5 | a5 >>> 27) + f23 + e5 + 1518500249 + t5;
        e5 = d5;
        d5 = c23;
        c23 = (b23 << 30 | b23 >>> 2) >>> 0;
        b23 = a5;
        a5 = t5;
      }
      for (;i5 < 20; ++i5) {
        t5 = w23[i5 - 3] ^ w23[i5 - 8] ^ w23[i5 - 14] ^ w23[i5 - 16];
        t5 = t5 << 1 | t5 >>> 31;
        w23[i5] = t5;
        f23 = d5 ^ b23 & (c23 ^ d5);
        t5 = (a5 << 5 | a5 >>> 27) + f23 + e5 + 1518500249 + t5;
        e5 = d5;
        d5 = c23;
        c23 = (b23 << 30 | b23 >>> 2) >>> 0;
        b23 = a5;
        a5 = t5;
      }
      for (;i5 < 32; ++i5) {
        t5 = w23[i5 - 3] ^ w23[i5 - 8] ^ w23[i5 - 14] ^ w23[i5 - 16];
        t5 = t5 << 1 | t5 >>> 31;
        w23[i5] = t5;
        f23 = b23 ^ c23 ^ d5;
        t5 = (a5 << 5 | a5 >>> 27) + f23 + e5 + 1859775393 + t5;
        e5 = d5;
        d5 = c23;
        c23 = (b23 << 30 | b23 >>> 2) >>> 0;
        b23 = a5;
        a5 = t5;
      }
      for (;i5 < 40; ++i5) {
        t5 = w23[i5 - 6] ^ w23[i5 - 16] ^ w23[i5 - 28] ^ w23[i5 - 32];
        t5 = t5 << 2 | t5 >>> 30;
        w23[i5] = t5;
        f23 = b23 ^ c23 ^ d5;
        t5 = (a5 << 5 | a5 >>> 27) + f23 + e5 + 1859775393 + t5;
        e5 = d5;
        d5 = c23;
        c23 = (b23 << 30 | b23 >>> 2) >>> 0;
        b23 = a5;
        a5 = t5;
      }
      for (;i5 < 60; ++i5) {
        t5 = w23[i5 - 6] ^ w23[i5 - 16] ^ w23[i5 - 28] ^ w23[i5 - 32];
        t5 = t5 << 2 | t5 >>> 30;
        w23[i5] = t5;
        f23 = b23 & c23 | d5 & (b23 ^ c23);
        t5 = (a5 << 5 | a5 >>> 27) + f23 + e5 + 2400959708 + t5;
        e5 = d5;
        d5 = c23;
        c23 = (b23 << 30 | b23 >>> 2) >>> 0;
        b23 = a5;
        a5 = t5;
      }
      for (;i5 < 80; ++i5) {
        t5 = w23[i5 - 6] ^ w23[i5 - 16] ^ w23[i5 - 28] ^ w23[i5 - 32];
        t5 = t5 << 2 | t5 >>> 30;
        w23[i5] = t5;
        f23 = b23 ^ c23 ^ d5;
        t5 = (a5 << 5 | a5 >>> 27) + f23 + e5 + 3395469782 + t5;
        e5 = d5;
        d5 = c23;
        c23 = (b23 << 30 | b23 >>> 2) >>> 0;
        b23 = a5;
        a5 = t5;
      }
      s32.h0 = s32.h0 + a5 | 0;
      s32.h1 = s32.h1 + b23 | 0;
      s32.h2 = s32.h2 + c23 | 0;
      s32.h3 = s32.h3 + d5 | 0;
      s32.h4 = s32.h4 + e5 | 0;
      len -= 64;
    }
  }
});
var require_pkcs1 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  require_random();
  require_sha13();
  var pkcs1 = module.exports = forge.pkcs1 = forge.pkcs1 || {};
  pkcs1.encode_rsa_oaep = function(key, message, options23) {
    var label;
    var seed;
    var md;
    var mgf1Md;
    if (typeof options23 === "string") {
      label = options23;
      seed = arguments[3] || undefined;
      md = arguments[4] || undefined;
    } else if (options23) {
      label = options23.label || undefined;
      seed = options23.seed || undefined;
      md = options23.md || undefined;
      if (options23.mgf1 && options23.mgf1.md) {
        mgf1Md = options23.mgf1.md;
      }
    }
    if (!md) {
      md = forge.md.sha1.create();
    } else {
      md.start();
    }
    if (!mgf1Md) {
      mgf1Md = md;
    }
    var keyLength = Math.ceil(key.n.bitLength() / 8);
    var maxLength = keyLength - 2 * md.digestLength - 2;
    if (message.length > maxLength) {
      var error = new Error("RSAES-OAEP input message length is too long.");
      error.length = message.length;
      error.maxLength = maxLength;
      throw error;
    }
    if (!label) {
      label = "";
    }
    md.update(label, "raw");
    var lHash = md.digest();
    var PS = "";
    var PS_length = maxLength - message.length;
    for (var i5 = 0;i5 < PS_length; i5++) {
      PS += "\0";
    }
    var DB = lHash.getBytes() + PS + "\x01" + message;
    if (!seed) {
      seed = forge.random.getBytes(md.digestLength);
    } else if (seed.length !== md.digestLength) {
      var error = new Error("Invalid RSAES-OAEP seed. The seed length must " + "match the digest length.");
      error.seedLength = seed.length;
      error.digestLength = md.digestLength;
      throw error;
    }
    var dbMask = rsa_mgf1(seed, keyLength - md.digestLength - 1, mgf1Md);
    var maskedDB = forge.util.xorBytes(DB, dbMask, DB.length);
    var seedMask = rsa_mgf1(maskedDB, md.digestLength, mgf1Md);
    var maskedSeed = forge.util.xorBytes(seed, seedMask, seed.length);
    return "\0" + maskedSeed + maskedDB;
  };
  pkcs1.decode_rsa_oaep = function(key, em, options23) {
    var label;
    var md;
    var mgf1Md;
    if (typeof options23 === "string") {
      label = options23;
      md = arguments[3] || undefined;
    } else if (options23) {
      label = options23.label || undefined;
      md = options23.md || undefined;
      if (options23.mgf1 && options23.mgf1.md) {
        mgf1Md = options23.mgf1.md;
      }
    }
    var keyLength = Math.ceil(key.n.bitLength() / 8);
    if (em.length !== keyLength) {
      var error = new Error("RSAES-OAEP encoded message length is invalid.");
      error.length = em.length;
      error.expectedLength = keyLength;
      throw error;
    }
    if (md === undefined) {
      md = forge.md.sha1.create();
    } else {
      md.start();
    }
    if (!mgf1Md) {
      mgf1Md = md;
    }
    if (keyLength < 2 * md.digestLength + 2) {
      throw new Error("RSAES-OAEP key is too short for the hash function.");
    }
    if (!label) {
      label = "";
    }
    md.update(label, "raw");
    var lHash = md.digest().getBytes();
    var y3 = em.charAt(0);
    var maskedSeed = em.substring(1, md.digestLength + 1);
    var maskedDB = em.substring(1 + md.digestLength);
    var seedMask = rsa_mgf1(maskedDB, md.digestLength, mgf1Md);
    var seed = forge.util.xorBytes(maskedSeed, seedMask, maskedSeed.length);
    var dbMask = rsa_mgf1(seed, keyLength - md.digestLength - 1, mgf1Md);
    var db3 = forge.util.xorBytes(maskedDB, dbMask, maskedDB.length);
    var lHashPrime = db3.substring(0, md.digestLength);
    var error = y3 !== "\0";
    for (var i5 = 0;i5 < md.digestLength; ++i5) {
      error |= lHash.charAt(i5) !== lHashPrime.charAt(i5);
    }
    var in_ps = 1;
    var index = md.digestLength;
    for (var j23 = md.digestLength;j23 < db3.length; j23++) {
      var code = db3.charCodeAt(j23);
      var is_0 = code & 1 ^ 1;
      var error_mask = in_ps ? 65534 : 0;
      error |= code & error_mask;
      in_ps = in_ps & is_0;
      index += in_ps;
    }
    if (error || db3.charCodeAt(index) !== 1) {
      throw new Error("Invalid RSAES-OAEP padding.");
    }
    return db3.substring(index + 1);
  };
  function rsa_mgf1(seed, maskLength, hash) {
    if (!hash) {
      hash = forge.md.sha1.create();
    }
    var t5 = "";
    var count = Math.ceil(maskLength / hash.digestLength);
    for (var i5 = 0;i5 < count; ++i5) {
      var c23 = String.fromCharCode(i5 >> 24 & 255, i5 >> 16 & 255, i5 >> 8 & 255, i5 & 255);
      hash.start();
      hash.update(seed + c23);
      t5 += hash.digest().getBytes();
    }
    return t5.substring(0, maskLength);
  }
});
var require_prime = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  require_jsbn();
  require_random();
  (function() {
    if (forge.prime) {
      module.exports = forge.prime;
      return;
    }
    var prime = module.exports = forge.prime = forge.prime || {};
    var BigInteger = forge.jsbn.BigInteger;
    var GCD_30_DELTA = [6, 4, 2, 4, 2, 4, 6, 2];
    var THIRTY = new BigInteger(null);
    THIRTY.fromInt(30);
    var op_or = function(x5, y3) {
      return x5 | y3;
    };
    prime.generateProbablePrime = function(bits, options23, callback) {
      if (typeof options23 === "function") {
        callback = options23;
        options23 = {};
      }
      options23 = options23 || {};
      var algorithm = options23.algorithm || "PRIMEINC";
      if (typeof algorithm === "string") {
        algorithm = { name: algorithm };
      }
      algorithm.options = algorithm.options || {};
      var prng = options23.prng || forge.random;
      var rng = {
        nextBytes: function(x5) {
          var b23 = prng.getBytesSync(x5.length);
          for (var i5 = 0;i5 < x5.length; ++i5) {
            x5[i5] = b23.charCodeAt(i5);
          }
        }
      };
      if (algorithm.name === "PRIMEINC") {
        return primeincFindPrime(bits, rng, algorithm.options, callback);
      }
      throw new Error("Invalid prime generation algorithm: " + algorithm.name);
    };
    function primeincFindPrime(bits, rng, options23, callback) {
      if ("workers" in options23) {
        return primeincFindPrimeWithWorkers(bits, rng, options23, callback);
      }
      return primeincFindPrimeWithoutWorkers(bits, rng, options23, callback);
    }
    function primeincFindPrimeWithoutWorkers(bits, rng, options23, callback) {
      var num = generateRandom(bits, rng);
      var deltaIdx = 0;
      var mrTests = getMillerRabinTests(num.bitLength());
      if ("millerRabinTests" in options23) {
        mrTests = options23.millerRabinTests;
      }
      var maxBlockTime = 10;
      if ("maxBlockTime" in options23) {
        maxBlockTime = options23.maxBlockTime;
      }
      _primeinc(num, bits, rng, deltaIdx, mrTests, maxBlockTime, callback);
    }
    function _primeinc(num, bits, rng, deltaIdx, mrTests, maxBlockTime, callback) {
      var start = +new Date;
      do {
        if (num.bitLength() > bits) {
          num = generateRandom(bits, rng);
        }
        if (num.isProbablePrime(mrTests)) {
          return callback(null, num);
        }
        num.dAddOffset(GCD_30_DELTA[deltaIdx++ % 8], 0);
      } while (maxBlockTime < 0 || +new Date - start < maxBlockTime);
      forge.util.setImmediate(function() {
        _primeinc(num, bits, rng, deltaIdx, mrTests, maxBlockTime, callback);
      });
    }
    function primeincFindPrimeWithWorkers(bits, rng, options23, callback) {
      if (typeof Worker === "undefined") {
        return primeincFindPrimeWithoutWorkers(bits, rng, options23, callback);
      }
      var num = generateRandom(bits, rng);
      var numWorkers = options23.workers;
      var workLoad = options23.workLoad || 100;
      var range = workLoad * 30 / 8;
      var workerScript = options23.workerScript || "forge/prime.worker.js";
      if (numWorkers === -1) {
        return forge.util.estimateCores(function(err22, cores) {
          if (err22) {
            cores = 2;
          }
          numWorkers = cores - 1;
          generate();
        });
      }
      generate();
      function generate() {
        numWorkers = Math.max(1, numWorkers);
        var workers = [];
        for (var i5 = 0;i5 < numWorkers; ++i5) {
          workers[i5] = new Worker(workerScript);
        }
        var running = numWorkers;
        for (var i5 = 0;i5 < numWorkers; ++i5) {
          workers[i5].addEventListener("message", workerMessage);
        }
        var found = false;
        function workerMessage(e5) {
          if (found) {
            return;
          }
          --running;
          var data2 = e5.data;
          if (data2.found) {
            for (var i22 = 0;i22 < workers.length; ++i22) {
              workers[i22].terminate();
            }
            found = true;
            return callback(null, new BigInteger(data2.prime, 16));
          }
          if (num.bitLength() > bits) {
            num = generateRandom(bits, rng);
          }
          var hex = num.toString(16);
          e5.target.postMessage({
            hex,
            workLoad
          });
          num.dAddOffset(range, 0);
        }
      }
    }
    function generateRandom(bits, rng) {
      var num = new BigInteger(bits, rng);
      var bits1 = bits - 1;
      if (!num.testBit(bits1)) {
        num.bitwiseTo(BigInteger.ONE.shiftLeft(bits1), op_or, num);
      }
      num.dAddOffset(31 - num.mod(THIRTY).byteValue(), 0);
      return num;
    }
    function getMillerRabinTests(bits) {
      if (bits <= 100)
        return 27;
      if (bits <= 150)
        return 18;
      if (bits <= 200)
        return 15;
      if (bits <= 250)
        return 12;
      if (bits <= 300)
        return 9;
      if (bits <= 350)
        return 8;
      if (bits <= 400)
        return 7;
      if (bits <= 500)
        return 6;
      if (bits <= 600)
        return 5;
      if (bits <= 800)
        return 4;
      if (bits <= 1250)
        return 3;
      return 2;
    }
  })();
});
var require_rsa = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_asn1();
  require_jsbn();
  require_oids();
  require_pkcs1();
  require_prime();
  require_random();
  require_util33();
  if (typeof BigInteger === "undefined") {
    BigInteger = forge.jsbn.BigInteger;
  }
  var BigInteger;
  var _crypto = forge.util.isNodejs ? import.meta.require("crypto") : null;
  var asn1 = forge.asn1;
  var util = forge.util;
  forge.pki = forge.pki || {};
  module.exports = forge.pki.rsa = forge.rsa = forge.rsa || {};
  var pki = forge.pki;
  var GCD_30_DELTA = [6, 4, 2, 4, 2, 4, 6, 2];
  var privateKeyValidator = {
    name: "PrivateKeyInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "PrivateKeyInfo.version",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyVersion"
    }, {
      name: "PrivateKeyInfo.privateKeyAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "AlgorithmIdentifier.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "privateKeyOid"
      }]
    }, {
      name: "PrivateKeyInfo",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OCTETSTRING,
      constructed: false,
      capture: "privateKey"
    }]
  };
  var rsaPrivateKeyValidator = {
    name: "RSAPrivateKey",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "RSAPrivateKey.version",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyVersion"
    }, {
      name: "RSAPrivateKey.modulus",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyModulus"
    }, {
      name: "RSAPrivateKey.publicExponent",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyPublicExponent"
    }, {
      name: "RSAPrivateKey.privateExponent",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyPrivateExponent"
    }, {
      name: "RSAPrivateKey.prime1",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyPrime1"
    }, {
      name: "RSAPrivateKey.prime2",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyPrime2"
    }, {
      name: "RSAPrivateKey.exponent1",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyExponent1"
    }, {
      name: "RSAPrivateKey.exponent2",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyExponent2"
    }, {
      name: "RSAPrivateKey.coefficient",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyCoefficient"
    }]
  };
  var rsaPublicKeyValidator = {
    name: "RSAPublicKey",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "RSAPublicKey.modulus",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "publicKeyModulus"
    }, {
      name: "RSAPublicKey.exponent",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "publicKeyExponent"
    }]
  };
  var publicKeyValidator = forge.pki.rsa.publicKeyValidator = {
    name: "SubjectPublicKeyInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    captureAsn1: "subjectPublicKeyInfo",
    value: [{
      name: "SubjectPublicKeyInfo.AlgorithmIdentifier",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "AlgorithmIdentifier.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "publicKeyOid"
      }]
    }, {
      name: "SubjectPublicKeyInfo.subjectPublicKey",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.BITSTRING,
      constructed: false,
      value: [{
        name: "SubjectPublicKeyInfo.subjectPublicKey.RSAPublicKey",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        optional: true,
        captureAsn1: "rsaPublicKey"
      }]
    }]
  };
  var digestInfoValidator = {
    name: "DigestInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "DigestInfo.DigestAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "DigestInfo.DigestAlgorithm.algorithmIdentifier",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "algorithmIdentifier"
      }, {
        name: "DigestInfo.DigestAlgorithm.parameters",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.NULL,
        capture: "parameters",
        optional: true,
        constructed: false
      }]
    }, {
      name: "DigestInfo.digest",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OCTETSTRING,
      constructed: false,
      capture: "digest"
    }]
  };
  var emsaPkcs1v15encode = function(md) {
    var oid;
    if (md.algorithm in pki.oids) {
      oid = pki.oids[md.algorithm];
    } else {
      var error = new Error("Unknown message digest algorithm.");
      error.algorithm = md.algorithm;
      throw error;
    }
    var oidBytes = asn1.oidToDer(oid).getBytes();
    var digestInfo = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
    var digestAlgorithm = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
    digestAlgorithm.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, oidBytes));
    digestAlgorithm.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, ""));
    var digest = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, md.digest().getBytes());
    digestInfo.value.push(digestAlgorithm);
    digestInfo.value.push(digest);
    return asn1.toDer(digestInfo).getBytes();
  };
  var _modPow = function(x5, key, pub) {
    if (pub) {
      return x5.modPow(key.e, key.n);
    }
    if (!key.p || !key.q) {
      return x5.modPow(key.d, key.n);
    }
    if (!key.dP) {
      key.dP = key.d.mod(key.p.subtract(BigInteger.ONE));
    }
    if (!key.dQ) {
      key.dQ = key.d.mod(key.q.subtract(BigInteger.ONE));
    }
    if (!key.qInv) {
      key.qInv = key.q.modInverse(key.p);
    }
    var r23;
    do {
      r23 = new BigInteger(forge.util.bytesToHex(forge.random.getBytes(key.n.bitLength() / 8)), 16);
    } while (r23.compareTo(key.n) >= 0 || !r23.gcd(key.n).equals(BigInteger.ONE));
    x5 = x5.multiply(r23.modPow(key.e, key.n)).mod(key.n);
    var xp = x5.mod(key.p).modPow(key.dP, key.p);
    var xq = x5.mod(key.q).modPow(key.dQ, key.q);
    while (xp.compareTo(xq) < 0) {
      xp = xp.add(key.p);
    }
    var y3 = xp.subtract(xq).multiply(key.qInv).mod(key.p).multiply(key.q).add(xq);
    y3 = y3.multiply(r23.modInverse(key.n)).mod(key.n);
    return y3;
  };
  pki.rsa.encrypt = function(m23, key, bt22) {
    var pub = bt22;
    var eb;
    var k5 = Math.ceil(key.n.bitLength() / 8);
    if (bt22 !== false && bt22 !== true) {
      pub = bt22 === 2;
      eb = _encodePkcs1_v1_5(m23, key, bt22);
    } else {
      eb = forge.util.createBuffer();
      eb.putBytes(m23);
    }
    var x5 = new BigInteger(eb.toHex(), 16);
    var y3 = _modPow(x5, key, pub);
    var yhex = y3.toString(16);
    var ed = forge.util.createBuffer();
    var zeros = k5 - Math.ceil(yhex.length / 2);
    while (zeros > 0) {
      ed.putByte(0);
      --zeros;
    }
    ed.putBytes(forge.util.hexToBytes(yhex));
    return ed.getBytes();
  };
  pki.rsa.decrypt = function(ed, key, pub, ml) {
    var k5 = Math.ceil(key.n.bitLength() / 8);
    if (ed.length !== k5) {
      var error = new Error("Encrypted message length is invalid.");
      error.length = ed.length;
      error.expected = k5;
      throw error;
    }
    var y3 = new BigInteger(forge.util.createBuffer(ed).toHex(), 16);
    if (y3.compareTo(key.n) >= 0) {
      throw new Error("Encrypted message is invalid.");
    }
    var x5 = _modPow(y3, key, pub);
    var xhex = x5.toString(16);
    var eb = forge.util.createBuffer();
    var zeros = k5 - Math.ceil(xhex.length / 2);
    while (zeros > 0) {
      eb.putByte(0);
      --zeros;
    }
    eb.putBytes(forge.util.hexToBytes(xhex));
    if (ml !== false) {
      return _decodePkcs1_v1_5(eb.getBytes(), key, pub);
    }
    return eb.getBytes();
  };
  pki.rsa.createKeyPairGenerationState = function(bits, e5, options23) {
    if (typeof bits === "string") {
      bits = parseInt(bits, 10);
    }
    bits = bits || 2048;
    options23 = options23 || {};
    var prng = options23.prng || forge.random;
    var rng = {
      nextBytes: function(x5) {
        var b23 = prng.getBytesSync(x5.length);
        for (var i5 = 0;i5 < x5.length; ++i5) {
          x5[i5] = b23.charCodeAt(i5);
        }
      }
    };
    var algorithm = options23.algorithm || "PRIMEINC";
    var rval;
    if (algorithm === "PRIMEINC") {
      rval = {
        algorithm,
        state: 0,
        bits,
        rng,
        eInt: e5 || 65537,
        e: new BigInteger(null),
        p: null,
        q: null,
        qBits: bits >> 1,
        pBits: bits - (bits >> 1),
        pqState: 0,
        num: null,
        keys: null
      };
      rval.e.fromInt(rval.eInt);
    } else {
      throw new Error("Invalid key generation algorithm: " + algorithm);
    }
    return rval;
  };
  pki.rsa.stepKeyPairGenerationState = function(state, n5) {
    if (!("algorithm" in state)) {
      state.algorithm = "PRIMEINC";
    }
    var THIRTY = new BigInteger(null);
    THIRTY.fromInt(30);
    var deltaIdx = 0;
    var op_or = function(x5, y3) {
      return x5 | y3;
    };
    var t1 = +new Date;
    var t22;
    var total = 0;
    while (state.keys === null && (n5 <= 0 || total < n5)) {
      if (state.state === 0) {
        var bits = state.p === null ? state.pBits : state.qBits;
        var bits1 = bits - 1;
        if (state.pqState === 0) {
          state.num = new BigInteger(bits, state.rng);
          if (!state.num.testBit(bits1)) {
            state.num.bitwiseTo(BigInteger.ONE.shiftLeft(bits1), op_or, state.num);
          }
          state.num.dAddOffset(31 - state.num.mod(THIRTY).byteValue(), 0);
          deltaIdx = 0;
          ++state.pqState;
        } else if (state.pqState === 1) {
          if (state.num.bitLength() > bits) {
            state.pqState = 0;
          } else if (state.num.isProbablePrime(_getMillerRabinTests(state.num.bitLength()))) {
            ++state.pqState;
          } else {
            state.num.dAddOffset(GCD_30_DELTA[deltaIdx++ % 8], 0);
          }
        } else if (state.pqState === 2) {
          state.pqState = state.num.subtract(BigInteger.ONE).gcd(state.e).compareTo(BigInteger.ONE) === 0 ? 3 : 0;
        } else if (state.pqState === 3) {
          state.pqState = 0;
          if (state.p === null) {
            state.p = state.num;
          } else {
            state.q = state.num;
          }
          if (state.p !== null && state.q !== null) {
            ++state.state;
          }
          state.num = null;
        }
      } else if (state.state === 1) {
        if (state.p.compareTo(state.q) < 0) {
          state.num = state.p;
          state.p = state.q;
          state.q = state.num;
        }
        ++state.state;
      } else if (state.state === 2) {
        state.p1 = state.p.subtract(BigInteger.ONE);
        state.q1 = state.q.subtract(BigInteger.ONE);
        state.phi = state.p1.multiply(state.q1);
        ++state.state;
      } else if (state.state === 3) {
        if (state.phi.gcd(state.e).compareTo(BigInteger.ONE) === 0) {
          ++state.state;
        } else {
          state.p = null;
          state.q = null;
          state.state = 0;
        }
      } else if (state.state === 4) {
        state.n = state.p.multiply(state.q);
        if (state.n.bitLength() === state.bits) {
          ++state.state;
        } else {
          state.q = null;
          state.state = 0;
        }
      } else if (state.state === 5) {
        var d5 = state.e.modInverse(state.phi);
        state.keys = {
          privateKey: pki.rsa.setPrivateKey(state.n, state.e, d5, state.p, state.q, d5.mod(state.p1), d5.mod(state.q1), state.q.modInverse(state.p)),
          publicKey: pki.rsa.setPublicKey(state.n, state.e)
        };
      }
      t22 = +new Date;
      total += t22 - t1;
      t1 = t22;
    }
    return state.keys !== null;
  };
  pki.rsa.generateKeyPair = function(bits, e5, options23, callback) {
    if (arguments.length === 1) {
      if (typeof bits === "object") {
        options23 = bits;
        bits = undefined;
      } else if (typeof bits === "function") {
        callback = bits;
        bits = undefined;
      }
    } else if (arguments.length === 2) {
      if (typeof bits === "number") {
        if (typeof e5 === "function") {
          callback = e5;
          e5 = undefined;
        } else if (typeof e5 !== "number") {
          options23 = e5;
          e5 = undefined;
        }
      } else {
        options23 = bits;
        callback = e5;
        bits = undefined;
        e5 = undefined;
      }
    } else if (arguments.length === 3) {
      if (typeof e5 === "number") {
        if (typeof options23 === "function") {
          callback = options23;
          options23 = undefined;
        }
      } else {
        callback = options23;
        options23 = e5;
        e5 = undefined;
      }
    }
    options23 = options23 || {};
    if (bits === undefined) {
      bits = options23.bits || 2048;
    }
    if (e5 === undefined) {
      e5 = options23.e || 65537;
    }
    if (!forge.options.usePureJavaScript && !options23.prng && bits >= 256 && bits <= 16384 && (e5 === 65537 || e5 === 3)) {
      if (callback) {
        if (_detectNodeCrypto("generateKeyPair")) {
          return _crypto.generateKeyPair("rsa", {
            modulusLength: bits,
            publicExponent: e5,
            publicKeyEncoding: {
              type: "spki",
              format: "pem"
            },
            privateKeyEncoding: {
              type: "pkcs8",
              format: "pem"
            }
          }, function(err22, pub, priv) {
            if (err22) {
              return callback(err22);
            }
            callback(null, {
              privateKey: pki.privateKeyFromPem(priv),
              publicKey: pki.publicKeyFromPem(pub)
            });
          });
        }
        if (_detectSubtleCrypto("generateKey") && _detectSubtleCrypto("exportKey")) {
          return util.globalScope.crypto.subtle.generateKey({
            name: "RSASSA-PKCS1-v1_5",
            modulusLength: bits,
            publicExponent: _intToUint8Array(e5),
            hash: { name: "SHA-256" }
          }, true, ["sign", "verify"]).then(function(pair) {
            return util.globalScope.crypto.subtle.exportKey("pkcs8", pair.privateKey);
          }).then(undefined, function(err22) {
            callback(err22);
          }).then(function(pkcs8) {
            if (pkcs8) {
              var privateKey = pki.privateKeyFromAsn1(asn1.fromDer(forge.util.createBuffer(pkcs8)));
              callback(null, {
                privateKey,
                publicKey: pki.setRsaPublicKey(privateKey.n, privateKey.e)
              });
            }
          });
        }
        if (_detectSubtleMsCrypto("generateKey") && _detectSubtleMsCrypto("exportKey")) {
          var genOp = util.globalScope.msCrypto.subtle.generateKey({
            name: "RSASSA-PKCS1-v1_5",
            modulusLength: bits,
            publicExponent: _intToUint8Array(e5),
            hash: { name: "SHA-256" }
          }, true, ["sign", "verify"]);
          genOp.oncomplete = function(e22) {
            var pair = e22.target.result;
            var exportOp = util.globalScope.msCrypto.subtle.exportKey("pkcs8", pair.privateKey);
            exportOp.oncomplete = function(e32) {
              var pkcs8 = e32.target.result;
              var privateKey = pki.privateKeyFromAsn1(asn1.fromDer(forge.util.createBuffer(pkcs8)));
              callback(null, {
                privateKey,
                publicKey: pki.setRsaPublicKey(privateKey.n, privateKey.e)
              });
            };
            exportOp.onerror = function(err22) {
              callback(err22);
            };
          };
          genOp.onerror = function(err22) {
            callback(err22);
          };
          return;
        }
      } else {
        if (_detectNodeCrypto("generateKeyPairSync")) {
          var keypair = _crypto.generateKeyPairSync("rsa", {
            modulusLength: bits,
            publicExponent: e5,
            publicKeyEncoding: {
              type: "spki",
              format: "pem"
            },
            privateKeyEncoding: {
              type: "pkcs8",
              format: "pem"
            }
          });
          return {
            privateKey: pki.privateKeyFromPem(keypair.privateKey),
            publicKey: pki.publicKeyFromPem(keypair.publicKey)
          };
        }
      }
    }
    var state = pki.rsa.createKeyPairGenerationState(bits, e5, options23);
    if (!callback) {
      pki.rsa.stepKeyPairGenerationState(state, 0);
      return state.keys;
    }
    _generateKeyPair(state, options23, callback);
  };
  pki.setRsaPublicKey = pki.rsa.setPublicKey = function(n5, e5) {
    var key = {
      n: n5,
      e: e5
    };
    key.encrypt = function(data2, scheme, schemeOptions) {
      if (typeof scheme === "string") {
        scheme = scheme.toUpperCase();
      } else if (scheme === undefined) {
        scheme = "RSAES-PKCS1-V1_5";
      }
      if (scheme === "RSAES-PKCS1-V1_5") {
        scheme = {
          encode: function(m23, key2, pub) {
            return _encodePkcs1_v1_5(m23, key2, 2).getBytes();
          }
        };
      } else if (scheme === "RSA-OAEP" || scheme === "RSAES-OAEP") {
        scheme = {
          encode: function(m23, key2) {
            return forge.pkcs1.encode_rsa_oaep(key2, m23, schemeOptions);
          }
        };
      } else if (["RAW", "NONE", "NULL", null].indexOf(scheme) !== -1) {
        scheme = { encode: function(e32) {
          return e32;
        } };
      } else if (typeof scheme === "string") {
        throw new Error('Unsupported encryption scheme: "' + scheme + '".');
      }
      var e22 = scheme.encode(data2, key, true);
      return pki.rsa.encrypt(e22, key, true);
    };
    key.verify = function(digest, signature, scheme, options23) {
      if (typeof scheme === "string") {
        scheme = scheme.toUpperCase();
      } else if (scheme === undefined) {
        scheme = "RSASSA-PKCS1-V1_5";
      }
      if (options23 === undefined) {
        options23 = {
          _parseAllDigestBytes: true
        };
      }
      if (!("_parseAllDigestBytes" in options23)) {
        options23._parseAllDigestBytes = true;
      }
      if (scheme === "RSASSA-PKCS1-V1_5") {
        scheme = {
          verify: function(digest2, d22) {
            d22 = _decodePkcs1_v1_5(d22, key, true);
            var obj = asn1.fromDer(d22, {
              parseAllBytes: options23._parseAllDigestBytes
            });
            var capture = {};
            var errors = [];
            if (!asn1.validate(obj, digestInfoValidator, capture, errors)) {
              var error = new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 " + "DigestInfo value.");
              error.errors = errors;
              throw error;
            }
            var oid = asn1.derToOid(capture.algorithmIdentifier);
            if (!(oid === forge.oids.md2 || oid === forge.oids.md5 || oid === forge.oids.sha1 || oid === forge.oids.sha224 || oid === forge.oids.sha256 || oid === forge.oids.sha384 || oid === forge.oids.sha512 || oid === forge.oids["sha512-224"] || oid === forge.oids["sha512-256"])) {
              var error = new Error("Unknown RSASSA-PKCS1-v1_5 DigestAlgorithm identifier.");
              error.oid = oid;
              throw error;
            }
            if (oid === forge.oids.md2 || oid === forge.oids.md5) {
              if (!("parameters" in capture)) {
                throw new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 " + "DigestInfo value. " + "Missing algorithm identifer NULL parameters.");
              }
            }
            return digest2 === capture.digest;
          }
        };
      } else if (scheme === "NONE" || scheme === "NULL" || scheme === null) {
        scheme = {
          verify: function(digest2, d22) {
            d22 = _decodePkcs1_v1_5(d22, key, true);
            return digest2 === d22;
          }
        };
      }
      var d5 = pki.rsa.decrypt(signature, key, true, false);
      return scheme.verify(digest, d5, key.n.bitLength());
    };
    return key;
  };
  pki.setRsaPrivateKey = pki.rsa.setPrivateKey = function(n5, e5, d5, p33, q6, dP, dQ, qInv) {
    var key = {
      n: n5,
      e: e5,
      d: d5,
      p: p33,
      q: q6,
      dP,
      dQ,
      qInv
    };
    key.decrypt = function(data2, scheme, schemeOptions) {
      if (typeof scheme === "string") {
        scheme = scheme.toUpperCase();
      } else if (scheme === undefined) {
        scheme = "RSAES-PKCS1-V1_5";
      }
      var d22 = pki.rsa.decrypt(data2, key, false, false);
      if (scheme === "RSAES-PKCS1-V1_5") {
        scheme = { decode: _decodePkcs1_v1_5 };
      } else if (scheme === "RSA-OAEP" || scheme === "RSAES-OAEP") {
        scheme = {
          decode: function(d32, key2) {
            return forge.pkcs1.decode_rsa_oaep(key2, d32, schemeOptions);
          }
        };
      } else if (["RAW", "NONE", "NULL", null].indexOf(scheme) !== -1) {
        scheme = { decode: function(d32) {
          return d32;
        } };
      } else {
        throw new Error('Unsupported encryption scheme: "' + scheme + '".');
      }
      return scheme.decode(d22, key, false);
    };
    key.sign = function(md, scheme) {
      var bt22 = false;
      if (typeof scheme === "string") {
        scheme = scheme.toUpperCase();
      }
      if (scheme === undefined || scheme === "RSASSA-PKCS1-V1_5") {
        scheme = { encode: emsaPkcs1v15encode };
        bt22 = 1;
      } else if (scheme === "NONE" || scheme === "NULL" || scheme === null) {
        scheme = { encode: function() {
          return md;
        } };
        bt22 = 1;
      }
      var d22 = scheme.encode(md, key.n.bitLength());
      return pki.rsa.encrypt(d22, key, bt22);
    };
    return key;
  };
  pki.wrapRsaPrivateKey = function(rsaKey) {
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(0).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.rsaEncryption).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, asn1.toDer(rsaKey).getBytes())
    ]);
  };
  pki.privateKeyFromAsn1 = function(obj) {
    var capture = {};
    var errors = [];
    if (asn1.validate(obj, privateKeyValidator, capture, errors)) {
      obj = asn1.fromDer(forge.util.createBuffer(capture.privateKey));
    }
    capture = {};
    errors = [];
    if (!asn1.validate(obj, rsaPrivateKeyValidator, capture, errors)) {
      var error = new Error("Cannot read private key. " + "ASN.1 object does not contain an RSAPrivateKey.");
      error.errors = errors;
      throw error;
    }
    var n5, e5, d5, p33, q6, dP, dQ, qInv;
    n5 = forge.util.createBuffer(capture.privateKeyModulus).toHex();
    e5 = forge.util.createBuffer(capture.privateKeyPublicExponent).toHex();
    d5 = forge.util.createBuffer(capture.privateKeyPrivateExponent).toHex();
    p33 = forge.util.createBuffer(capture.privateKeyPrime1).toHex();
    q6 = forge.util.createBuffer(capture.privateKeyPrime2).toHex();
    dP = forge.util.createBuffer(capture.privateKeyExponent1).toHex();
    dQ = forge.util.createBuffer(capture.privateKeyExponent2).toHex();
    qInv = forge.util.createBuffer(capture.privateKeyCoefficient).toHex();
    return pki.setRsaPrivateKey(new BigInteger(n5, 16), new BigInteger(e5, 16), new BigInteger(d5, 16), new BigInteger(p33, 16), new BigInteger(q6, 16), new BigInteger(dP, 16), new BigInteger(dQ, 16), new BigInteger(qInv, 16));
  };
  pki.privateKeyToAsn1 = pki.privateKeyToRSAPrivateKey = function(key) {
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(0).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.n)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.e)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.d)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.p)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.q)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.dP)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.dQ)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.qInv))
    ]);
  };
  pki.publicKeyFromAsn1 = function(obj) {
    var capture = {};
    var errors = [];
    if (asn1.validate(obj, publicKeyValidator, capture, errors)) {
      var oid = asn1.derToOid(capture.publicKeyOid);
      if (oid !== pki.oids.rsaEncryption) {
        var error = new Error("Cannot read public key. Unknown OID.");
        error.oid = oid;
        throw error;
      }
      obj = capture.rsaPublicKey;
    }
    errors = [];
    if (!asn1.validate(obj, rsaPublicKeyValidator, capture, errors)) {
      var error = new Error("Cannot read public key. " + "ASN.1 object does not contain an RSAPublicKey.");
      error.errors = errors;
      throw error;
    }
    var n5 = forge.util.createBuffer(capture.publicKeyModulus).toHex();
    var e5 = forge.util.createBuffer(capture.publicKeyExponent).toHex();
    return pki.setRsaPublicKey(new BigInteger(n5, 16), new BigInteger(e5, 16));
  };
  pki.publicKeyToAsn1 = pki.publicKeyToSubjectPublicKeyInfo = function(key) {
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.rsaEncryption).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BITSTRING, false, [
        pki.publicKeyToRSAPublicKey(key)
      ])
    ]);
  };
  pki.publicKeyToRSAPublicKey = function(key) {
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.n)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, _bnToBytes(key.e))
    ]);
  };
  function _encodePkcs1_v1_5(m23, key, bt22) {
    var eb = forge.util.createBuffer();
    var k5 = Math.ceil(key.n.bitLength() / 8);
    if (m23.length > k5 - 11) {
      var error = new Error("Message is too long for PKCS#1 v1.5 padding.");
      error.length = m23.length;
      error.max = k5 - 11;
      throw error;
    }
    eb.putByte(0);
    eb.putByte(bt22);
    var padNum = k5 - 3 - m23.length;
    var padByte;
    if (bt22 === 0 || bt22 === 1) {
      padByte = bt22 === 0 ? 0 : 255;
      for (var i5 = 0;i5 < padNum; ++i5) {
        eb.putByte(padByte);
      }
    } else {
      while (padNum > 0) {
        var numZeros = 0;
        var padBytes = forge.random.getBytes(padNum);
        for (var i5 = 0;i5 < padNum; ++i5) {
          padByte = padBytes.charCodeAt(i5);
          if (padByte === 0) {
            ++numZeros;
          } else {
            eb.putByte(padByte);
          }
        }
        padNum = numZeros;
      }
    }
    eb.putByte(0);
    eb.putBytes(m23);
    return eb;
  }
  function _decodePkcs1_v1_5(em, key, pub, ml) {
    var k5 = Math.ceil(key.n.bitLength() / 8);
    var eb = forge.util.createBuffer(em);
    var first = eb.getByte();
    var bt22 = eb.getByte();
    if (first !== 0 || pub && bt22 !== 0 && bt22 !== 1 || !pub && bt22 != 2 || pub && bt22 === 0 && typeof ml === "undefined") {
      throw new Error("Encryption block is invalid.");
    }
    var padNum = 0;
    if (bt22 === 0) {
      padNum = k5 - 3 - ml;
      for (var i5 = 0;i5 < padNum; ++i5) {
        if (eb.getByte() !== 0) {
          throw new Error("Encryption block is invalid.");
        }
      }
    } else if (bt22 === 1) {
      padNum = 0;
      while (eb.length() > 1) {
        if (eb.getByte() !== 255) {
          --eb.read;
          break;
        }
        ++padNum;
      }
    } else if (bt22 === 2) {
      padNum = 0;
      while (eb.length() > 1) {
        if (eb.getByte() === 0) {
          --eb.read;
          break;
        }
        ++padNum;
      }
    }
    var zero = eb.getByte();
    if (zero !== 0 || padNum !== k5 - 3 - eb.length()) {
      throw new Error("Encryption block is invalid.");
    }
    return eb.getBytes();
  }
  function _generateKeyPair(state, options23, callback) {
    if (typeof options23 === "function") {
      callback = options23;
      options23 = {};
    }
    options23 = options23 || {};
    var opts = {
      algorithm: {
        name: options23.algorithm || "PRIMEINC",
        options: {
          workers: options23.workers || 2,
          workLoad: options23.workLoad || 100,
          workerScript: options23.workerScript
        }
      }
    };
    if ("prng" in options23) {
      opts.prng = options23.prng;
    }
    generate();
    function generate() {
      getPrime(state.pBits, function(err22, num) {
        if (err22) {
          return callback(err22);
        }
        state.p = num;
        if (state.q !== null) {
          return finish(err22, state.q);
        }
        getPrime(state.qBits, finish);
      });
    }
    function getPrime(bits, callback2) {
      forge.prime.generateProbablePrime(bits, opts, callback2);
    }
    function finish(err22, num) {
      if (err22) {
        return callback(err22);
      }
      state.q = num;
      if (state.p.compareTo(state.q) < 0) {
        var tmp = state.p;
        state.p = state.q;
        state.q = tmp;
      }
      if (state.p.subtract(BigInteger.ONE).gcd(state.e).compareTo(BigInteger.ONE) !== 0) {
        state.p = null;
        generate();
        return;
      }
      if (state.q.subtract(BigInteger.ONE).gcd(state.e).compareTo(BigInteger.ONE) !== 0) {
        state.q = null;
        getPrime(state.qBits, finish);
        return;
      }
      state.p1 = state.p.subtract(BigInteger.ONE);
      state.q1 = state.q.subtract(BigInteger.ONE);
      state.phi = state.p1.multiply(state.q1);
      if (state.phi.gcd(state.e).compareTo(BigInteger.ONE) !== 0) {
        state.p = state.q = null;
        generate();
        return;
      }
      state.n = state.p.multiply(state.q);
      if (state.n.bitLength() !== state.bits) {
        state.q = null;
        getPrime(state.qBits, finish);
        return;
      }
      var d5 = state.e.modInverse(state.phi);
      state.keys = {
        privateKey: pki.rsa.setPrivateKey(state.n, state.e, d5, state.p, state.q, d5.mod(state.p1), d5.mod(state.q1), state.q.modInverse(state.p)),
        publicKey: pki.rsa.setPublicKey(state.n, state.e)
      };
      callback(null, state.keys);
    }
  }
  function _bnToBytes(b23) {
    var hex = b23.toString(16);
    if (hex[0] >= "8") {
      hex = "00" + hex;
    }
    var bytes = forge.util.hexToBytes(hex);
    if (bytes.length > 1 && (bytes.charCodeAt(0) === 0 && (bytes.charCodeAt(1) & 128) === 0 || bytes.charCodeAt(0) === 255 && (bytes.charCodeAt(1) & 128) === 128)) {
      return bytes.substr(1);
    }
    return bytes;
  }
  function _getMillerRabinTests(bits) {
    if (bits <= 100)
      return 27;
    if (bits <= 150)
      return 18;
    if (bits <= 200)
      return 15;
    if (bits <= 250)
      return 12;
    if (bits <= 300)
      return 9;
    if (bits <= 350)
      return 8;
    if (bits <= 400)
      return 7;
    if (bits <= 500)
      return 6;
    if (bits <= 600)
      return 5;
    if (bits <= 800)
      return 4;
    if (bits <= 1250)
      return 3;
    return 2;
  }
  function _detectNodeCrypto(fn) {
    return forge.util.isNodejs && typeof _crypto[fn] === "function";
  }
  function _detectSubtleCrypto(fn) {
    return typeof util.globalScope !== "undefined" && typeof util.globalScope.crypto === "object" && typeof util.globalScope.crypto.subtle === "object" && typeof util.globalScope.crypto.subtle[fn] === "function";
  }
  function _detectSubtleMsCrypto(fn) {
    return typeof util.globalScope !== "undefined" && typeof util.globalScope.msCrypto === "object" && typeof util.globalScope.msCrypto.subtle === "object" && typeof util.globalScope.msCrypto.subtle[fn] === "function";
  }
  function _intToUint8Array(x5) {
    var bytes = forge.util.hexToBytes(x5.toString(16));
    var buffer = new Uint8Array(bytes.length);
    for (var i5 = 0;i5 < bytes.length; ++i5) {
      buffer[i5] = bytes.charCodeAt(i5);
    }
    return buffer;
  }
});
var require_pbe = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_aes2();
  require_asn1();
  require_des();
  require_md();
  require_oids();
  require_pbkdf2();
  require_pem();
  require_random();
  require_rc2();
  require_rsa();
  require_util33();
  if (typeof BigInteger === "undefined") {
    BigInteger = forge.jsbn.BigInteger;
  }
  var BigInteger;
  var asn1 = forge.asn1;
  var pki = forge.pki = forge.pki || {};
  module.exports = pki.pbe = forge.pbe = forge.pbe || {};
  var oids = pki.oids;
  var encryptedPrivateKeyValidator = {
    name: "EncryptedPrivateKeyInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "EncryptedPrivateKeyInfo.encryptionAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "AlgorithmIdentifier.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "encryptionOid"
      }, {
        name: "AlgorithmIdentifier.parameters",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        captureAsn1: "encryptionParams"
      }]
    }, {
      name: "EncryptedPrivateKeyInfo.encryptedData",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OCTETSTRING,
      constructed: false,
      capture: "encryptedData"
    }]
  };
  var PBES2AlgorithmsValidator = {
    name: "PBES2Algorithms",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "PBES2Algorithms.keyDerivationFunc",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "PBES2Algorithms.keyDerivationFunc.oid",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "kdfOid"
      }, {
        name: "PBES2Algorithms.params",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        value: [{
          name: "PBES2Algorithms.params.salt",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.OCTETSTRING,
          constructed: false,
          capture: "kdfSalt"
        }, {
          name: "PBES2Algorithms.params.iterationCount",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.INTEGER,
          constructed: false,
          capture: "kdfIterationCount"
        }, {
          name: "PBES2Algorithms.params.keyLength",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.INTEGER,
          constructed: false,
          optional: true,
          capture: "keyLength"
        }, {
          name: "PBES2Algorithms.params.prf",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          optional: true,
          value: [{
            name: "PBES2Algorithms.params.prf.algorithm",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.OID,
            constructed: false,
            capture: "prfOid"
          }]
        }]
      }]
    }, {
      name: "PBES2Algorithms.encryptionScheme",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "PBES2Algorithms.encryptionScheme.oid",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "encOid"
      }, {
        name: "PBES2Algorithms.encryptionScheme.iv",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OCTETSTRING,
        constructed: false,
        capture: "encIv"
      }]
    }]
  };
  var pkcs12PbeParamsValidator = {
    name: "pkcs-12PbeParams",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "pkcs-12PbeParams.salt",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OCTETSTRING,
      constructed: false,
      capture: "salt"
    }, {
      name: "pkcs-12PbeParams.iterations",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "iterations"
    }]
  };
  pki.encryptPrivateKeyInfo = function(obj, password, options23) {
    options23 = options23 || {};
    options23.saltSize = options23.saltSize || 8;
    options23.count = options23.count || 2048;
    options23.algorithm = options23.algorithm || "aes128";
    options23.prfAlgorithm = options23.prfAlgorithm || "sha1";
    var salt = forge.random.getBytesSync(options23.saltSize);
    var count = options23.count;
    var countBytes = asn1.integerToDer(count);
    var dkLen;
    var encryptionAlgorithm;
    var encryptedData;
    if (options23.algorithm.indexOf("aes") === 0 || options23.algorithm === "des") {
      var ivLen, encOid, cipherFn;
      switch (options23.algorithm) {
        case "aes128":
          dkLen = 16;
          ivLen = 16;
          encOid = oids["aes128-CBC"];
          cipherFn = forge.aes.createEncryptionCipher;
          break;
        case "aes192":
          dkLen = 24;
          ivLen = 16;
          encOid = oids["aes192-CBC"];
          cipherFn = forge.aes.createEncryptionCipher;
          break;
        case "aes256":
          dkLen = 32;
          ivLen = 16;
          encOid = oids["aes256-CBC"];
          cipherFn = forge.aes.createEncryptionCipher;
          break;
        case "des":
          dkLen = 8;
          ivLen = 8;
          encOid = oids["desCBC"];
          cipherFn = forge.des.createEncryptionCipher;
          break;
        default:
          var error = new Error("Cannot encrypt private key. Unknown encryption algorithm.");
          error.algorithm = options23.algorithm;
          throw error;
      }
      var prfAlgorithm = "hmacWith" + options23.prfAlgorithm.toUpperCase();
      var md = prfAlgorithmToMessageDigest(prfAlgorithm);
      var dk = forge.pkcs5.pbkdf2(password, salt, count, dkLen, md);
      var iv = forge.random.getBytesSync(ivLen);
      var cipher = cipherFn(dk);
      cipher.start(iv);
      cipher.update(asn1.toDer(obj));
      cipher.finish();
      encryptedData = cipher.output.getBytes();
      var params = createPbkdf2Params(salt, countBytes, dkLen, prfAlgorithm);
      encryptionAlgorithm = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(oids["pkcs5PBES2"]).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(oids["pkcs5PBKDF2"]).getBytes()),
            params
          ]),
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(encOid).getBytes()),
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, iv)
          ])
        ])
      ]);
    } else if (options23.algorithm === "3des") {
      dkLen = 24;
      var saltBytes = new forge.util.ByteBuffer(salt);
      var dk = pki.pbe.generatePkcs12Key(password, saltBytes, 1, count, dkLen);
      var iv = pki.pbe.generatePkcs12Key(password, saltBytes, 2, count, dkLen);
      var cipher = forge.des.createEncryptionCipher(dk);
      cipher.start(iv);
      cipher.update(asn1.toDer(obj));
      cipher.finish();
      encryptedData = cipher.output.getBytes();
      encryptionAlgorithm = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, salt),
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, countBytes.getBytes())
        ])
      ]);
    } else {
      var error = new Error("Cannot encrypt private key. Unknown encryption algorithm.");
      error.algorithm = options23.algorithm;
      throw error;
    }
    var rval = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      encryptionAlgorithm,
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, encryptedData)
    ]);
    return rval;
  };
  pki.decryptPrivateKeyInfo = function(obj, password) {
    var rval = null;
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, encryptedPrivateKeyValidator, capture, errors)) {
      var error = new Error("Cannot read encrypted private key. " + "ASN.1 object is not a supported EncryptedPrivateKeyInfo.");
      error.errors = errors;
      throw error;
    }
    var oid = asn1.derToOid(capture.encryptionOid);
    var cipher = pki.pbe.getCipher(oid, capture.encryptionParams, password);
    var encrypted = forge.util.createBuffer(capture.encryptedData);
    cipher.update(encrypted);
    if (cipher.finish()) {
      rval = asn1.fromDer(cipher.output);
    }
    return rval;
  };
  pki.encryptedPrivateKeyToPem = function(epki, maxline) {
    var msg = {
      type: "ENCRYPTED PRIVATE KEY",
      body: asn1.toDer(epki).getBytes()
    };
    return forge.pem.encode(msg, { maxline });
  };
  pki.encryptedPrivateKeyFromPem = function(pem) {
    var msg = forge.pem.decode(pem)[0];
    if (msg.type !== "ENCRYPTED PRIVATE KEY") {
      var error = new Error("Could not convert encrypted private key from PEM; " + 'PEM header type is "ENCRYPTED PRIVATE KEY".');
      error.headerType = msg.type;
      throw error;
    }
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      throw new Error("Could not convert encrypted private key from PEM; " + "PEM is encrypted.");
    }
    return asn1.fromDer(msg.body);
  };
  pki.encryptRsaPrivateKey = function(rsaKey, password, options23) {
    options23 = options23 || {};
    if (!options23.legacy) {
      var rval = pki.wrapRsaPrivateKey(pki.privateKeyToAsn1(rsaKey));
      rval = pki.encryptPrivateKeyInfo(rval, password, options23);
      return pki.encryptedPrivateKeyToPem(rval);
    }
    var algorithm;
    var iv;
    var dkLen;
    var cipherFn;
    switch (options23.algorithm) {
      case "aes128":
        algorithm = "AES-128-CBC";
        dkLen = 16;
        iv = forge.random.getBytesSync(16);
        cipherFn = forge.aes.createEncryptionCipher;
        break;
      case "aes192":
        algorithm = "AES-192-CBC";
        dkLen = 24;
        iv = forge.random.getBytesSync(16);
        cipherFn = forge.aes.createEncryptionCipher;
        break;
      case "aes256":
        algorithm = "AES-256-CBC";
        dkLen = 32;
        iv = forge.random.getBytesSync(16);
        cipherFn = forge.aes.createEncryptionCipher;
        break;
      case "3des":
        algorithm = "DES-EDE3-CBC";
        dkLen = 24;
        iv = forge.random.getBytesSync(8);
        cipherFn = forge.des.createEncryptionCipher;
        break;
      case "des":
        algorithm = "DES-CBC";
        dkLen = 8;
        iv = forge.random.getBytesSync(8);
        cipherFn = forge.des.createEncryptionCipher;
        break;
      default:
        var error = new Error("Could not encrypt RSA private key; unsupported " + 'encryption algorithm "' + options23.algorithm + '".');
        error.algorithm = options23.algorithm;
        throw error;
    }
    var dk = forge.pbe.opensslDeriveBytes(password, iv.substr(0, 8), dkLen);
    var cipher = cipherFn(dk);
    cipher.start(iv);
    cipher.update(asn1.toDer(pki.privateKeyToAsn1(rsaKey)));
    cipher.finish();
    var msg = {
      type: "RSA PRIVATE KEY",
      procType: {
        version: "4",
        type: "ENCRYPTED"
      },
      dekInfo: {
        algorithm,
        parameters: forge.util.bytesToHex(iv).toUpperCase()
      },
      body: cipher.output.getBytes()
    };
    return forge.pem.encode(msg);
  };
  pki.decryptRsaPrivateKey = function(pem, password) {
    var rval = null;
    var msg = forge.pem.decode(pem)[0];
    if (msg.type !== "ENCRYPTED PRIVATE KEY" && msg.type !== "PRIVATE KEY" && msg.type !== "RSA PRIVATE KEY") {
      var error = new Error("Could not convert private key from PEM; PEM header type " + 'is not "ENCRYPTED PRIVATE KEY", "PRIVATE KEY", or "RSA PRIVATE KEY".');
      error.headerType = error;
      throw error;
    }
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      var dkLen;
      var cipherFn;
      switch (msg.dekInfo.algorithm) {
        case "DES-CBC":
          dkLen = 8;
          cipherFn = forge.des.createDecryptionCipher;
          break;
        case "DES-EDE3-CBC":
          dkLen = 24;
          cipherFn = forge.des.createDecryptionCipher;
          break;
        case "AES-128-CBC":
          dkLen = 16;
          cipherFn = forge.aes.createDecryptionCipher;
          break;
        case "AES-192-CBC":
          dkLen = 24;
          cipherFn = forge.aes.createDecryptionCipher;
          break;
        case "AES-256-CBC":
          dkLen = 32;
          cipherFn = forge.aes.createDecryptionCipher;
          break;
        case "RC2-40-CBC":
          dkLen = 5;
          cipherFn = function(key) {
            return forge.rc2.createDecryptionCipher(key, 40);
          };
          break;
        case "RC2-64-CBC":
          dkLen = 8;
          cipherFn = function(key) {
            return forge.rc2.createDecryptionCipher(key, 64);
          };
          break;
        case "RC2-128-CBC":
          dkLen = 16;
          cipherFn = function(key) {
            return forge.rc2.createDecryptionCipher(key, 128);
          };
          break;
        default:
          var error = new Error("Could not decrypt private key; unsupported " + 'encryption algorithm "' + msg.dekInfo.algorithm + '".');
          error.algorithm = msg.dekInfo.algorithm;
          throw error;
      }
      var iv = forge.util.hexToBytes(msg.dekInfo.parameters);
      var dk = forge.pbe.opensslDeriveBytes(password, iv.substr(0, 8), dkLen);
      var cipher = cipherFn(dk);
      cipher.start(iv);
      cipher.update(forge.util.createBuffer(msg.body));
      if (cipher.finish()) {
        rval = cipher.output.getBytes();
      } else {
        return rval;
      }
    } else {
      rval = msg.body;
    }
    if (msg.type === "ENCRYPTED PRIVATE KEY") {
      rval = pki.decryptPrivateKeyInfo(asn1.fromDer(rval), password);
    } else {
      rval = asn1.fromDer(rval);
    }
    if (rval !== null) {
      rval = pki.privateKeyFromAsn1(rval);
    }
    return rval;
  };
  pki.pbe.generatePkcs12Key = function(password, salt, id, iter, n5, md) {
    var j23, l33;
    if (typeof md === "undefined" || md === null) {
      if (!("sha1" in forge.md)) {
        throw new Error('"sha1" hash algorithm unavailable.');
      }
      md = forge.md.sha1.create();
    }
    var u5 = md.digestLength;
    var v23 = md.blockLength;
    var result2 = new forge.util.ByteBuffer;
    var passBuf = new forge.util.ByteBuffer;
    if (password !== null && password !== undefined) {
      for (l33 = 0;l33 < password.length; l33++) {
        passBuf.putInt16(password.charCodeAt(l33));
      }
      passBuf.putInt16(0);
    }
    var p33 = passBuf.length();
    var s32 = salt.length();
    var D3 = new forge.util.ByteBuffer;
    D3.fillWithByte(id, v23);
    var Slen = v23 * Math.ceil(s32 / v23);
    var S2 = new forge.util.ByteBuffer;
    for (l33 = 0;l33 < Slen; l33++) {
      S2.putByte(salt.at(l33 % s32));
    }
    var Plen = v23 * Math.ceil(p33 / v23);
    var P23 = new forge.util.ByteBuffer;
    for (l33 = 0;l33 < Plen; l33++) {
      P23.putByte(passBuf.at(l33 % p33));
    }
    var I4 = S2;
    I4.putBuffer(P23);
    var c23 = Math.ceil(n5 / u5);
    for (var i5 = 1;i5 <= c23; i5++) {
      var buf = new forge.util.ByteBuffer;
      buf.putBytes(D3.bytes());
      buf.putBytes(I4.bytes());
      for (var round = 0;round < iter; round++) {
        md.start();
        md.update(buf.getBytes());
        buf = md.digest();
      }
      var B3 = new forge.util.ByteBuffer;
      for (l33 = 0;l33 < v23; l33++) {
        B3.putByte(buf.at(l33 % u5));
      }
      var k5 = Math.ceil(s32 / v23) + Math.ceil(p33 / v23);
      var Inew = new forge.util.ByteBuffer;
      for (j23 = 0;j23 < k5; j23++) {
        var chunk = new forge.util.ByteBuffer(I4.getBytes(v23));
        var x5 = 511;
        for (l33 = B3.length() - 1;l33 >= 0; l33--) {
          x5 = x5 >> 8;
          x5 += B3.at(l33) + chunk.at(l33);
          chunk.setAt(l33, x5 & 255);
        }
        Inew.putBuffer(chunk);
      }
      I4 = Inew;
      result2.putBuffer(buf);
    }
    result2.truncate(result2.length() - n5);
    return result2;
  };
  pki.pbe.getCipher = function(oid, params, password) {
    switch (oid) {
      case pki.oids["pkcs5PBES2"]:
        return pki.pbe.getCipherForPBES2(oid, params, password);
      case pki.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:
      case pki.oids["pbewithSHAAnd40BitRC2-CBC"]:
        return pki.pbe.getCipherForPKCS12PBE(oid, params, password);
      default:
        var error = new Error("Cannot read encrypted PBE data block. Unsupported OID.");
        error.oid = oid;
        error.supportedOids = [
          "pkcs5PBES2",
          "pbeWithSHAAnd3-KeyTripleDES-CBC",
          "pbewithSHAAnd40BitRC2-CBC"
        ];
        throw error;
    }
  };
  pki.pbe.getCipherForPBES2 = function(oid, params, password) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(params, PBES2AlgorithmsValidator, capture, errors)) {
      var error = new Error("Cannot read password-based-encryption algorithm " + "parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");
      error.errors = errors;
      throw error;
    }
    oid = asn1.derToOid(capture.kdfOid);
    if (oid !== pki.oids["pkcs5PBKDF2"]) {
      var error = new Error("Cannot read encrypted private key. " + "Unsupported key derivation function OID.");
      error.oid = oid;
      error.supportedOids = ["pkcs5PBKDF2"];
      throw error;
    }
    oid = asn1.derToOid(capture.encOid);
    if (oid !== pki.oids["aes128-CBC"] && oid !== pki.oids["aes192-CBC"] && oid !== pki.oids["aes256-CBC"] && oid !== pki.oids["des-EDE3-CBC"] && oid !== pki.oids["desCBC"]) {
      var error = new Error("Cannot read encrypted private key. " + "Unsupported encryption scheme OID.");
      error.oid = oid;
      error.supportedOids = [
        "aes128-CBC",
        "aes192-CBC",
        "aes256-CBC",
        "des-EDE3-CBC",
        "desCBC"
      ];
      throw error;
    }
    var salt = capture.kdfSalt;
    var count = forge.util.createBuffer(capture.kdfIterationCount);
    count = count.getInt(count.length() << 3);
    var dkLen;
    var cipherFn;
    switch (pki.oids[oid]) {
      case "aes128-CBC":
        dkLen = 16;
        cipherFn = forge.aes.createDecryptionCipher;
        break;
      case "aes192-CBC":
        dkLen = 24;
        cipherFn = forge.aes.createDecryptionCipher;
        break;
      case "aes256-CBC":
        dkLen = 32;
        cipherFn = forge.aes.createDecryptionCipher;
        break;
      case "des-EDE3-CBC":
        dkLen = 24;
        cipherFn = forge.des.createDecryptionCipher;
        break;
      case "desCBC":
        dkLen = 8;
        cipherFn = forge.des.createDecryptionCipher;
        break;
    }
    var md = prfOidToMessageDigest(capture.prfOid);
    var dk = forge.pkcs5.pbkdf2(password, salt, count, dkLen, md);
    var iv = capture.encIv;
    var cipher = cipherFn(dk);
    cipher.start(iv);
    return cipher;
  };
  pki.pbe.getCipherForPKCS12PBE = function(oid, params, password) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(params, pkcs12PbeParamsValidator, capture, errors)) {
      var error = new Error("Cannot read password-based-encryption algorithm " + "parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");
      error.errors = errors;
      throw error;
    }
    var salt = forge.util.createBuffer(capture.salt);
    var count = forge.util.createBuffer(capture.iterations);
    count = count.getInt(count.length() << 3);
    var dkLen, dIvLen, cipherFn;
    switch (oid) {
      case pki.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:
        dkLen = 24;
        dIvLen = 8;
        cipherFn = forge.des.startDecrypting;
        break;
      case pki.oids["pbewithSHAAnd40BitRC2-CBC"]:
        dkLen = 5;
        dIvLen = 8;
        cipherFn = function(key2, iv2) {
          var cipher = forge.rc2.createDecryptionCipher(key2, 40);
          cipher.start(iv2, null);
          return cipher;
        };
        break;
      default:
        var error = new Error("Cannot read PKCS #12 PBE data block. Unsupported OID.");
        error.oid = oid;
        throw error;
    }
    var md = prfOidToMessageDigest(capture.prfOid);
    var key = pki.pbe.generatePkcs12Key(password, salt, 1, count, dkLen, md);
    md.start();
    var iv = pki.pbe.generatePkcs12Key(password, salt, 2, count, dIvLen, md);
    return cipherFn(key, iv);
  };
  pki.pbe.opensslDeriveBytes = function(password, salt, dkLen, md) {
    if (typeof md === "undefined" || md === null) {
      if (!("md5" in forge.md)) {
        throw new Error('"md5" hash algorithm unavailable.');
      }
      md = forge.md.md5.create();
    }
    if (salt === null) {
      salt = "";
    }
    var digests = [hash(md, password + salt)];
    for (var length = 16, i5 = 1;length < dkLen; ++i5, length += 16) {
      digests.push(hash(md, digests[i5 - 1] + password + salt));
    }
    return digests.join("").substr(0, dkLen);
  };
  function hash(md, bytes) {
    return md.start().update(bytes).digest().getBytes();
  }
  function prfOidToMessageDigest(prfOid) {
    var prfAlgorithm;
    if (!prfOid) {
      prfAlgorithm = "hmacWithSHA1";
    } else {
      prfAlgorithm = pki.oids[asn1.derToOid(prfOid)];
      if (!prfAlgorithm) {
        var error = new Error("Unsupported PRF OID.");
        error.oid = prfOid;
        error.supported = [
          "hmacWithSHA1",
          "hmacWithSHA224",
          "hmacWithSHA256",
          "hmacWithSHA384",
          "hmacWithSHA512"
        ];
        throw error;
      }
    }
    return prfAlgorithmToMessageDigest(prfAlgorithm);
  }
  function prfAlgorithmToMessageDigest(prfAlgorithm) {
    var factory = forge.md;
    switch (prfAlgorithm) {
      case "hmacWithSHA224":
        factory = forge.md.sha512;
      case "hmacWithSHA1":
      case "hmacWithSHA256":
      case "hmacWithSHA384":
      case "hmacWithSHA512":
        prfAlgorithm = prfAlgorithm.substr(8).toLowerCase();
        break;
      default:
        var error = new Error("Unsupported PRF algorithm.");
        error.algorithm = prfAlgorithm;
        error.supported = [
          "hmacWithSHA1",
          "hmacWithSHA224",
          "hmacWithSHA256",
          "hmacWithSHA384",
          "hmacWithSHA512"
        ];
        throw error;
    }
    if (!factory || !(prfAlgorithm in factory)) {
      throw new Error("Unknown hash algorithm: " + prfAlgorithm);
    }
    return factory[prfAlgorithm].create();
  }
  function createPbkdf2Params(salt, countBytes, dkLen, prfAlgorithm) {
    var params = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, salt),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, countBytes.getBytes())
    ]);
    if (prfAlgorithm !== "hmacWithSHA1") {
      params.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, forge.util.hexToBytes(dkLen.toString(16))), asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids[prfAlgorithm]).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
      ]));
    }
    return params;
  }
});
var require_pkcs7asn1 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_asn1();
  require_util33();
  var asn1 = forge.asn1;
  var p7v = module.exports = forge.pkcs7asn1 = forge.pkcs7asn1 || {};
  forge.pkcs7 = forge.pkcs7 || {};
  forge.pkcs7.asn1 = p7v;
  var contentInfoValidator = {
    name: "ContentInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "ContentInfo.ContentType",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OID,
      constructed: false,
      capture: "contentType"
    }, {
      name: "ContentInfo.content",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 0,
      constructed: true,
      optional: true,
      captureAsn1: "content"
    }]
  };
  p7v.contentInfoValidator = contentInfoValidator;
  var encryptedContentInfoValidator = {
    name: "EncryptedContentInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "EncryptedContentInfo.contentType",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OID,
      constructed: false,
      capture: "contentType"
    }, {
      name: "EncryptedContentInfo.contentEncryptionAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "EncryptedContentInfo.contentEncryptionAlgorithm.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "encAlgorithm"
      }, {
        name: "EncryptedContentInfo.contentEncryptionAlgorithm.parameter",
        tagClass: asn1.Class.UNIVERSAL,
        captureAsn1: "encParameter"
      }]
    }, {
      name: "EncryptedContentInfo.encryptedContent",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 0,
      capture: "encryptedContent",
      captureAsn1: "encryptedContentAsn1"
    }]
  };
  p7v.envelopedDataValidator = {
    name: "EnvelopedData",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "EnvelopedData.Version",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "version"
    }, {
      name: "EnvelopedData.RecipientInfos",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SET,
      constructed: true,
      captureAsn1: "recipientInfos"
    }].concat(encryptedContentInfoValidator)
  };
  p7v.encryptedDataValidator = {
    name: "EncryptedData",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "EncryptedData.Version",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "version"
    }].concat(encryptedContentInfoValidator)
  };
  var signerValidator = {
    name: "SignerInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "SignerInfo.version",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false
    }, {
      name: "SignerInfo.issuerAndSerialNumber",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "SignerInfo.issuerAndSerialNumber.issuer",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        captureAsn1: "issuer"
      }, {
        name: "SignerInfo.issuerAndSerialNumber.serialNumber",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.INTEGER,
        constructed: false,
        capture: "serial"
      }]
    }, {
      name: "SignerInfo.digestAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "SignerInfo.digestAlgorithm.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "digestAlgorithm"
      }, {
        name: "SignerInfo.digestAlgorithm.parameter",
        tagClass: asn1.Class.UNIVERSAL,
        constructed: false,
        captureAsn1: "digestParameter",
        optional: true
      }]
    }, {
      name: "SignerInfo.authenticatedAttributes",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 0,
      constructed: true,
      optional: true,
      capture: "authenticatedAttributes"
    }, {
      name: "SignerInfo.digestEncryptionAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      capture: "signatureAlgorithm"
    }, {
      name: "SignerInfo.encryptedDigest",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OCTETSTRING,
      constructed: false,
      capture: "signature"
    }, {
      name: "SignerInfo.unauthenticatedAttributes",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 1,
      constructed: true,
      optional: true,
      capture: "unauthenticatedAttributes"
    }]
  };
  p7v.signedDataValidator = {
    name: "SignedData",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [
      {
        name: "SignedData.Version",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.INTEGER,
        constructed: false,
        capture: "version"
      },
      {
        name: "SignedData.DigestAlgorithms",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SET,
        constructed: true,
        captureAsn1: "digestAlgorithms"
      },
      contentInfoValidator,
      {
        name: "SignedData.Certificates",
        tagClass: asn1.Class.CONTEXT_SPECIFIC,
        type: 0,
        optional: true,
        captureAsn1: "certificates"
      },
      {
        name: "SignedData.CertificateRevocationLists",
        tagClass: asn1.Class.CONTEXT_SPECIFIC,
        type: 1,
        optional: true,
        captureAsn1: "crls"
      },
      {
        name: "SignedData.SignerInfos",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SET,
        capture: "signerInfos",
        optional: true,
        value: [signerValidator]
      }
    ]
  };
  p7v.recipientInfoValidator = {
    name: "RecipientInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "RecipientInfo.version",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "version"
    }, {
      name: "RecipientInfo.issuerAndSerial",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "RecipientInfo.issuerAndSerial.issuer",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        captureAsn1: "issuer"
      }, {
        name: "RecipientInfo.issuerAndSerial.serialNumber",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.INTEGER,
        constructed: false,
        capture: "serial"
      }]
    }, {
      name: "RecipientInfo.keyEncryptionAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "RecipientInfo.keyEncryptionAlgorithm.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "encAlgorithm"
      }, {
        name: "RecipientInfo.keyEncryptionAlgorithm.parameter",
        tagClass: asn1.Class.UNIVERSAL,
        constructed: false,
        captureAsn1: "encParameter",
        optional: true
      }]
    }, {
      name: "RecipientInfo.encryptedKey",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OCTETSTRING,
      constructed: false,
      capture: "encKey"
    }]
  };
});
var require_mgf1 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  forge.mgf = forge.mgf || {};
  var mgf1 = module.exports = forge.mgf.mgf1 = forge.mgf1 = forge.mgf1 || {};
  mgf1.create = function(md) {
    var mgf = {
      generate: function(seed, maskLen) {
        var t5 = new forge.util.ByteBuffer;
        var len = Math.ceil(maskLen / md.digestLength);
        for (var i5 = 0;i5 < len; i5++) {
          var c23 = new forge.util.ByteBuffer;
          c23.putInt32(i5);
          md.start();
          md.update(seed + c23.getBytes());
          t5.putBuffer(md.digest());
        }
        t5.truncate(t5.length() - maskLen);
        return t5.getBytes();
      }
    };
    return mgf;
  };
});
var require_mgf = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_mgf1();
  module.exports = forge.mgf = forge.mgf || {};
  forge.mgf.mgf1 = forge.mgf1;
});
var require_pss = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_random();
  require_util33();
  var pss = module.exports = forge.pss = forge.pss || {};
  pss.create = function(options23) {
    if (arguments.length === 3) {
      options23 = {
        md: arguments[0],
        mgf: arguments[1],
        saltLength: arguments[2]
      };
    }
    var hash = options23.md;
    var mgf = options23.mgf;
    var hLen = hash.digestLength;
    var salt_ = options23.salt || null;
    if (typeof salt_ === "string") {
      salt_ = forge.util.createBuffer(salt_);
    }
    var sLen;
    if ("saltLength" in options23) {
      sLen = options23.saltLength;
    } else if (salt_ !== null) {
      sLen = salt_.length();
    } else {
      throw new Error("Salt length not specified or specific salt not given.");
    }
    if (salt_ !== null && salt_.length() !== sLen) {
      throw new Error("Given salt length does not match length of given salt.");
    }
    var prng = options23.prng || forge.random;
    var pssobj = {};
    pssobj.encode = function(md, modBits) {
      var i5;
      var emBits = modBits - 1;
      var emLen = Math.ceil(emBits / 8);
      var mHash = md.digest().getBytes();
      if (emLen < hLen + sLen + 2) {
        throw new Error("Message is too long to encrypt.");
      }
      var salt;
      if (salt_ === null) {
        salt = prng.getBytesSync(sLen);
      } else {
        salt = salt_.bytes();
      }
      var m_ = new forge.util.ByteBuffer;
      m_.fillWithByte(0, 8);
      m_.putBytes(mHash);
      m_.putBytes(salt);
      hash.start();
      hash.update(m_.getBytes());
      var h33 = hash.digest().getBytes();
      var ps = new forge.util.ByteBuffer;
      ps.fillWithByte(0, emLen - sLen - hLen - 2);
      ps.putByte(1);
      ps.putBytes(salt);
      var db3 = ps.getBytes();
      var maskLen = emLen - hLen - 1;
      var dbMask = mgf.generate(h33, maskLen);
      var maskedDB = "";
      for (i5 = 0;i5 < maskLen; i5++) {
        maskedDB += String.fromCharCode(db3.charCodeAt(i5) ^ dbMask.charCodeAt(i5));
      }
      var mask = 65280 >> 8 * emLen - emBits & 255;
      maskedDB = String.fromCharCode(maskedDB.charCodeAt(0) & ~mask) + maskedDB.substr(1);
      return maskedDB + h33 + String.fromCharCode(188);
    };
    pssobj.verify = function(mHash, em, modBits) {
      var i5;
      var emBits = modBits - 1;
      var emLen = Math.ceil(emBits / 8);
      em = em.substr(-emLen);
      if (emLen < hLen + sLen + 2) {
        throw new Error("Inconsistent parameters to PSS signature verification.");
      }
      if (em.charCodeAt(emLen - 1) !== 188) {
        throw new Error("Encoded message does not end in 0xBC.");
      }
      var maskLen = emLen - hLen - 1;
      var maskedDB = em.substr(0, maskLen);
      var h33 = em.substr(maskLen, hLen);
      var mask = 65280 >> 8 * emLen - emBits & 255;
      if ((maskedDB.charCodeAt(0) & mask) !== 0) {
        throw new Error("Bits beyond keysize not zero as expected.");
      }
      var dbMask = mgf.generate(h33, maskLen);
      var db3 = "";
      for (i5 = 0;i5 < maskLen; i5++) {
        db3 += String.fromCharCode(maskedDB.charCodeAt(i5) ^ dbMask.charCodeAt(i5));
      }
      db3 = String.fromCharCode(db3.charCodeAt(0) & ~mask) + db3.substr(1);
      var checkLen = emLen - hLen - sLen - 2;
      for (i5 = 0;i5 < checkLen; i5++) {
        if (db3.charCodeAt(i5) !== 0) {
          throw new Error("Leftmost octets not zero as expected");
        }
      }
      if (db3.charCodeAt(checkLen) !== 1) {
        throw new Error("Inconsistent PSS signature, 0x01 marker not found");
      }
      var salt = db3.substr(-sLen);
      var m_ = new forge.util.ByteBuffer;
      m_.fillWithByte(0, 8);
      m_.putBytes(mHash);
      m_.putBytes(salt);
      hash.start();
      hash.update(m_.getBytes());
      var h_ = hash.digest().getBytes();
      return h33 === h_;
    };
    return pssobj;
  };
});
var require_x509 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_aes2();
  require_asn1();
  require_des();
  require_md();
  require_mgf();
  require_oids();
  require_pem();
  require_pss();
  require_rsa();
  require_util33();
  var asn1 = forge.asn1;
  var pki = module.exports = forge.pki = forge.pki || {};
  var oids = pki.oids;
  var _shortNames = {};
  _shortNames["CN"] = oids["commonName"];
  _shortNames["commonName"] = "CN";
  _shortNames["C"] = oids["countryName"];
  _shortNames["countryName"] = "C";
  _shortNames["L"] = oids["localityName"];
  _shortNames["localityName"] = "L";
  _shortNames["ST"] = oids["stateOrProvinceName"];
  _shortNames["stateOrProvinceName"] = "ST";
  _shortNames["O"] = oids["organizationName"];
  _shortNames["organizationName"] = "O";
  _shortNames["OU"] = oids["organizationalUnitName"];
  _shortNames["organizationalUnitName"] = "OU";
  _shortNames["E"] = oids["emailAddress"];
  _shortNames["emailAddress"] = "E";
  var publicKeyValidator = forge.pki.rsa.publicKeyValidator;
  var x509CertificateValidator = {
    name: "Certificate",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "Certificate.TBSCertificate",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      captureAsn1: "tbsCertificate",
      value: [
        {
          name: "Certificate.TBSCertificate.version",
          tagClass: asn1.Class.CONTEXT_SPECIFIC,
          type: 0,
          constructed: true,
          optional: true,
          value: [{
            name: "Certificate.TBSCertificate.version.integer",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.INTEGER,
            constructed: false,
            capture: "certVersion"
          }]
        },
        {
          name: "Certificate.TBSCertificate.serialNumber",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.INTEGER,
          constructed: false,
          capture: "certSerialNumber"
        },
        {
          name: "Certificate.TBSCertificate.signature",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          value: [{
            name: "Certificate.TBSCertificate.signature.algorithm",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.OID,
            constructed: false,
            capture: "certinfoSignatureOid"
          }, {
            name: "Certificate.TBSCertificate.signature.parameters",
            tagClass: asn1.Class.UNIVERSAL,
            optional: true,
            captureAsn1: "certinfoSignatureParams"
          }]
        },
        {
          name: "Certificate.TBSCertificate.issuer",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          captureAsn1: "certIssuer"
        },
        {
          name: "Certificate.TBSCertificate.validity",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          value: [{
            name: "Certificate.TBSCertificate.validity.notBefore (utc)",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.UTCTIME,
            constructed: false,
            optional: true,
            capture: "certValidity1UTCTime"
          }, {
            name: "Certificate.TBSCertificate.validity.notBefore (generalized)",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.GENERALIZEDTIME,
            constructed: false,
            optional: true,
            capture: "certValidity2GeneralizedTime"
          }, {
            name: "Certificate.TBSCertificate.validity.notAfter (utc)",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.UTCTIME,
            constructed: false,
            optional: true,
            capture: "certValidity3UTCTime"
          }, {
            name: "Certificate.TBSCertificate.validity.notAfter (generalized)",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.GENERALIZEDTIME,
            constructed: false,
            optional: true,
            capture: "certValidity4GeneralizedTime"
          }]
        },
        {
          name: "Certificate.TBSCertificate.subject",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          captureAsn1: "certSubject"
        },
        publicKeyValidator,
        {
          name: "Certificate.TBSCertificate.issuerUniqueID",
          tagClass: asn1.Class.CONTEXT_SPECIFIC,
          type: 1,
          constructed: true,
          optional: true,
          value: [{
            name: "Certificate.TBSCertificate.issuerUniqueID.id",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.BITSTRING,
            constructed: false,
            captureBitStringValue: "certIssuerUniqueId"
          }]
        },
        {
          name: "Certificate.TBSCertificate.subjectUniqueID",
          tagClass: asn1.Class.CONTEXT_SPECIFIC,
          type: 2,
          constructed: true,
          optional: true,
          value: [{
            name: "Certificate.TBSCertificate.subjectUniqueID.id",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.BITSTRING,
            constructed: false,
            captureBitStringValue: "certSubjectUniqueId"
          }]
        },
        {
          name: "Certificate.TBSCertificate.extensions",
          tagClass: asn1.Class.CONTEXT_SPECIFIC,
          type: 3,
          constructed: true,
          captureAsn1: "certExtensions",
          optional: true
        }
      ]
    }, {
      name: "Certificate.signatureAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "Certificate.signatureAlgorithm.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "certSignatureOid"
      }, {
        name: "Certificate.TBSCertificate.signature.parameters",
        tagClass: asn1.Class.UNIVERSAL,
        optional: true,
        captureAsn1: "certSignatureParams"
      }]
    }, {
      name: "Certificate.signatureValue",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.BITSTRING,
      constructed: false,
      captureBitStringValue: "certSignature"
    }]
  };
  var rsassaPssParameterValidator = {
    name: "rsapss",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "rsapss.hashAlgorithm",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 0,
      constructed: true,
      value: [{
        name: "rsapss.hashAlgorithm.AlgorithmIdentifier",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Class.SEQUENCE,
        constructed: true,
        optional: true,
        value: [{
          name: "rsapss.hashAlgorithm.AlgorithmIdentifier.algorithm",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.OID,
          constructed: false,
          capture: "hashOid"
        }]
      }]
    }, {
      name: "rsapss.maskGenAlgorithm",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 1,
      constructed: true,
      value: [{
        name: "rsapss.maskGenAlgorithm.AlgorithmIdentifier",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Class.SEQUENCE,
        constructed: true,
        optional: true,
        value: [{
          name: "rsapss.maskGenAlgorithm.AlgorithmIdentifier.algorithm",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.OID,
          constructed: false,
          capture: "maskGenOid"
        }, {
          name: "rsapss.maskGenAlgorithm.AlgorithmIdentifier.params",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          value: [{
            name: "rsapss.maskGenAlgorithm.AlgorithmIdentifier.params.algorithm",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.OID,
            constructed: false,
            capture: "maskGenHashOid"
          }]
        }]
      }]
    }, {
      name: "rsapss.saltLength",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 2,
      optional: true,
      value: [{
        name: "rsapss.saltLength.saltLength",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Class.INTEGER,
        constructed: false,
        capture: "saltLength"
      }]
    }, {
      name: "rsapss.trailerField",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      type: 3,
      optional: true,
      value: [{
        name: "rsapss.trailer.trailer",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Class.INTEGER,
        constructed: false,
        capture: "trailer"
      }]
    }]
  };
  var certificationRequestInfoValidator = {
    name: "CertificationRequestInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    captureAsn1: "certificationRequestInfo",
    value: [
      {
        name: "CertificationRequestInfo.integer",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.INTEGER,
        constructed: false,
        capture: "certificationRequestInfoVersion"
      },
      {
        name: "CertificationRequestInfo.subject",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        captureAsn1: "certificationRequestInfoSubject"
      },
      publicKeyValidator,
      {
        name: "CertificationRequestInfo.attributes",
        tagClass: asn1.Class.CONTEXT_SPECIFIC,
        type: 0,
        constructed: true,
        optional: true,
        capture: "certificationRequestInfoAttributes",
        value: [{
          name: "CertificationRequestInfo.attributes",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          value: [{
            name: "CertificationRequestInfo.attributes.type",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.OID,
            constructed: false
          }, {
            name: "CertificationRequestInfo.attributes.value",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.SET,
            constructed: true
          }]
        }]
      }
    ]
  };
  var certificationRequestValidator = {
    name: "CertificationRequest",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    captureAsn1: "csr",
    value: [
      certificationRequestInfoValidator,
      {
        name: "CertificationRequest.signatureAlgorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        value: [{
          name: "CertificationRequest.signatureAlgorithm.algorithm",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.OID,
          constructed: false,
          capture: "csrSignatureOid"
        }, {
          name: "CertificationRequest.signatureAlgorithm.parameters",
          tagClass: asn1.Class.UNIVERSAL,
          optional: true,
          captureAsn1: "csrSignatureParams"
        }]
      },
      {
        name: "CertificationRequest.signature",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.BITSTRING,
        constructed: false,
        captureBitStringValue: "csrSignature"
      }
    ]
  };
  pki.RDNAttributesAsArray = function(rdn, md) {
    var rval = [];
    var set2, attr, obj;
    for (var si = 0;si < rdn.value.length; ++si) {
      set2 = rdn.value[si];
      for (var i5 = 0;i5 < set2.value.length; ++i5) {
        obj = {};
        attr = set2.value[i5];
        obj.type = asn1.derToOid(attr.value[0].value);
        obj.value = attr.value[1].value;
        obj.valueTagClass = attr.value[1].type;
        if (obj.type in oids) {
          obj.name = oids[obj.type];
          if (obj.name in _shortNames) {
            obj.shortName = _shortNames[obj.name];
          }
        }
        if (md) {
          md.update(obj.type);
          md.update(obj.value);
        }
        rval.push(obj);
      }
    }
    return rval;
  };
  pki.CRIAttributesAsArray = function(attributes) {
    var rval = [];
    for (var si = 0;si < attributes.length; ++si) {
      var seq2 = attributes[si];
      var type2 = asn1.derToOid(seq2.value[0].value);
      var values22 = seq2.value[1].value;
      for (var vi = 0;vi < values22.length; ++vi) {
        var obj = {};
        obj.type = type2;
        obj.value = values22[vi].value;
        obj.valueTagClass = values22[vi].type;
        if (obj.type in oids) {
          obj.name = oids[obj.type];
          if (obj.name in _shortNames) {
            obj.shortName = _shortNames[obj.name];
          }
        }
        if (obj.type === oids.extensionRequest) {
          obj.extensions = [];
          for (var ei = 0;ei < obj.value.length; ++ei) {
            obj.extensions.push(pki.certificateExtensionFromAsn1(obj.value[ei]));
          }
        }
        rval.push(obj);
      }
    }
    return rval;
  };
  function _getAttribute(obj, options23) {
    if (typeof options23 === "string") {
      options23 = { shortName: options23 };
    }
    var rval = null;
    var attr;
    for (var i5 = 0;rval === null && i5 < obj.attributes.length; ++i5) {
      attr = obj.attributes[i5];
      if (options23.type && options23.type === attr.type) {
        rval = attr;
      } else if (options23.name && options23.name === attr.name) {
        rval = attr;
      } else if (options23.shortName && options23.shortName === attr.shortName) {
        rval = attr;
      }
    }
    return rval;
  }
  var _readSignatureParameters = function(oid, obj, fillDefaults) {
    var params = {};
    if (oid !== oids["RSASSA-PSS"]) {
      return params;
    }
    if (fillDefaults) {
      params = {
        hash: {
          algorithmOid: oids["sha1"]
        },
        mgf: {
          algorithmOid: oids["mgf1"],
          hash: {
            algorithmOid: oids["sha1"]
          }
        },
        saltLength: 20
      };
    }
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, rsassaPssParameterValidator, capture, errors)) {
      var error = new Error("Cannot read RSASSA-PSS parameter block.");
      error.errors = errors;
      throw error;
    }
    if (capture.hashOid !== undefined) {
      params.hash = params.hash || {};
      params.hash.algorithmOid = asn1.derToOid(capture.hashOid);
    }
    if (capture.maskGenOid !== undefined) {
      params.mgf = params.mgf || {};
      params.mgf.algorithmOid = asn1.derToOid(capture.maskGenOid);
      params.mgf.hash = params.mgf.hash || {};
      params.mgf.hash.algorithmOid = asn1.derToOid(capture.maskGenHashOid);
    }
    if (capture.saltLength !== undefined) {
      params.saltLength = capture.saltLength.charCodeAt(0);
    }
    return params;
  };
  var _createSignatureDigest = function(options23) {
    switch (oids[options23.signatureOid]) {
      case "sha1WithRSAEncryption":
      case "sha1WithRSASignature":
        return forge.md.sha1.create();
      case "md5WithRSAEncryption":
        return forge.md.md5.create();
      case "sha256WithRSAEncryption":
        return forge.md.sha256.create();
      case "sha384WithRSAEncryption":
        return forge.md.sha384.create();
      case "sha512WithRSAEncryption":
        return forge.md.sha512.create();
      case "RSASSA-PSS":
        return forge.md.sha256.create();
      default:
        var error = new Error("Could not compute " + options23.type + " digest. " + "Unknown signature OID.");
        error.signatureOid = options23.signatureOid;
        throw error;
    }
  };
  var _verifySignature = function(options23) {
    var cert = options23.certificate;
    var scheme;
    switch (cert.signatureOid) {
      case oids.sha1WithRSAEncryption:
      case oids.sha1WithRSASignature:
        break;
      case oids["RSASSA-PSS"]:
        var hash, mgf;
        hash = oids[cert.signatureParameters.mgf.hash.algorithmOid];
        if (hash === undefined || forge.md[hash] === undefined) {
          var error = new Error("Unsupported MGF hash function.");
          error.oid = cert.signatureParameters.mgf.hash.algorithmOid;
          error.name = hash;
          throw error;
        }
        mgf = oids[cert.signatureParameters.mgf.algorithmOid];
        if (mgf === undefined || forge.mgf[mgf] === undefined) {
          var error = new Error("Unsupported MGF function.");
          error.oid = cert.signatureParameters.mgf.algorithmOid;
          error.name = mgf;
          throw error;
        }
        mgf = forge.mgf[mgf].create(forge.md[hash].create());
        hash = oids[cert.signatureParameters.hash.algorithmOid];
        if (hash === undefined || forge.md[hash] === undefined) {
          var error = new Error("Unsupported RSASSA-PSS hash function.");
          error.oid = cert.signatureParameters.hash.algorithmOid;
          error.name = hash;
          throw error;
        }
        scheme = forge.pss.create(forge.md[hash].create(), mgf, cert.signatureParameters.saltLength);
        break;
    }
    return cert.publicKey.verify(options23.md.digest().getBytes(), options23.signature, scheme);
  };
  pki.certificateFromPem = function(pem, computeHash, strict) {
    var msg = forge.pem.decode(pem)[0];
    if (msg.type !== "CERTIFICATE" && msg.type !== "X509 CERTIFICATE" && msg.type !== "TRUSTED CERTIFICATE") {
      var error = new Error("Could not convert certificate from PEM; PEM header type " + 'is not "CERTIFICATE", "X509 CERTIFICATE", or "TRUSTED CERTIFICATE".');
      error.headerType = msg.type;
      throw error;
    }
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      throw new Error("Could not convert certificate from PEM; PEM is encrypted.");
    }
    var obj = asn1.fromDer(msg.body, strict);
    return pki.certificateFromAsn1(obj, computeHash);
  };
  pki.certificateToPem = function(cert, maxline) {
    var msg = {
      type: "CERTIFICATE",
      body: asn1.toDer(pki.certificateToAsn1(cert)).getBytes()
    };
    return forge.pem.encode(msg, { maxline });
  };
  pki.publicKeyFromPem = function(pem) {
    var msg = forge.pem.decode(pem)[0];
    if (msg.type !== "PUBLIC KEY" && msg.type !== "RSA PUBLIC KEY") {
      var error = new Error("Could not convert public key from PEM; PEM header " + 'type is not "PUBLIC KEY" or "RSA PUBLIC KEY".');
      error.headerType = msg.type;
      throw error;
    }
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      throw new Error("Could not convert public key from PEM; PEM is encrypted.");
    }
    var obj = asn1.fromDer(msg.body);
    return pki.publicKeyFromAsn1(obj);
  };
  pki.publicKeyToPem = function(key, maxline) {
    var msg = {
      type: "PUBLIC KEY",
      body: asn1.toDer(pki.publicKeyToAsn1(key)).getBytes()
    };
    return forge.pem.encode(msg, { maxline });
  };
  pki.publicKeyToRSAPublicKeyPem = function(key, maxline) {
    var msg = {
      type: "RSA PUBLIC KEY",
      body: asn1.toDer(pki.publicKeyToRSAPublicKey(key)).getBytes()
    };
    return forge.pem.encode(msg, { maxline });
  };
  pki.getPublicKeyFingerprint = function(key, options23) {
    options23 = options23 || {};
    var md = options23.md || forge.md.sha1.create();
    var type2 = options23.type || "RSAPublicKey";
    var bytes;
    switch (type2) {
      case "RSAPublicKey":
        bytes = asn1.toDer(pki.publicKeyToRSAPublicKey(key)).getBytes();
        break;
      case "SubjectPublicKeyInfo":
        bytes = asn1.toDer(pki.publicKeyToAsn1(key)).getBytes();
        break;
      default:
        throw new Error('Unknown fingerprint type "' + options23.type + '".');
    }
    md.start();
    md.update(bytes);
    var digest = md.digest();
    if (options23.encoding === "hex") {
      var hex = digest.toHex();
      if (options23.delimiter) {
        return hex.match(/.{2}/g).join(options23.delimiter);
      }
      return hex;
    } else if (options23.encoding === "binary") {
      return digest.getBytes();
    } else if (options23.encoding) {
      throw new Error('Unknown encoding "' + options23.encoding + '".');
    }
    return digest;
  };
  pki.certificationRequestFromPem = function(pem, computeHash, strict) {
    var msg = forge.pem.decode(pem)[0];
    if (msg.type !== "CERTIFICATE REQUEST") {
      var error = new Error("Could not convert certification request from PEM; " + 'PEM header type is not "CERTIFICATE REQUEST".');
      error.headerType = msg.type;
      throw error;
    }
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      throw new Error("Could not convert certification request from PEM; " + "PEM is encrypted.");
    }
    var obj = asn1.fromDer(msg.body, strict);
    return pki.certificationRequestFromAsn1(obj, computeHash);
  };
  pki.certificationRequestToPem = function(csr, maxline) {
    var msg = {
      type: "CERTIFICATE REQUEST",
      body: asn1.toDer(pki.certificationRequestToAsn1(csr)).getBytes()
    };
    return forge.pem.encode(msg, { maxline });
  };
  pki.createCertificate = function() {
    var cert = {};
    cert.version = 2;
    cert.serialNumber = "00";
    cert.signatureOid = null;
    cert.signature = null;
    cert.siginfo = {};
    cert.siginfo.algorithmOid = null;
    cert.validity = {};
    cert.validity.notBefore = new Date;
    cert.validity.notAfter = new Date;
    cert.issuer = {};
    cert.issuer.getField = function(sn) {
      return _getAttribute(cert.issuer, sn);
    };
    cert.issuer.addField = function(attr) {
      _fillMissingFields([attr]);
      cert.issuer.attributes.push(attr);
    };
    cert.issuer.attributes = [];
    cert.issuer.hash = null;
    cert.subject = {};
    cert.subject.getField = function(sn) {
      return _getAttribute(cert.subject, sn);
    };
    cert.subject.addField = function(attr) {
      _fillMissingFields([attr]);
      cert.subject.attributes.push(attr);
    };
    cert.subject.attributes = [];
    cert.subject.hash = null;
    cert.extensions = [];
    cert.publicKey = null;
    cert.md = null;
    cert.setSubject = function(attrs, uniqueId) {
      _fillMissingFields(attrs);
      cert.subject.attributes = attrs;
      delete cert.subject.uniqueId;
      if (uniqueId) {
        cert.subject.uniqueId = uniqueId;
      }
      cert.subject.hash = null;
    };
    cert.setIssuer = function(attrs, uniqueId) {
      _fillMissingFields(attrs);
      cert.issuer.attributes = attrs;
      delete cert.issuer.uniqueId;
      if (uniqueId) {
        cert.issuer.uniqueId = uniqueId;
      }
      cert.issuer.hash = null;
    };
    cert.setExtensions = function(exts) {
      for (var i5 = 0;i5 < exts.length; ++i5) {
        _fillMissingExtensionFields(exts[i5], { cert });
      }
      cert.extensions = exts;
    };
    cert.getExtension = function(options23) {
      if (typeof options23 === "string") {
        options23 = { name: options23 };
      }
      var rval = null;
      var ext2;
      for (var i5 = 0;rval === null && i5 < cert.extensions.length; ++i5) {
        ext2 = cert.extensions[i5];
        if (options23.id && ext2.id === options23.id) {
          rval = ext2;
        } else if (options23.name && ext2.name === options23.name) {
          rval = ext2;
        }
      }
      return rval;
    };
    cert.sign = function(key, md) {
      cert.md = md || forge.md.sha1.create();
      var algorithmOid = oids[cert.md.algorithm + "WithRSAEncryption"];
      if (!algorithmOid) {
        var error = new Error("Could not compute certificate digest. " + "Unknown message digest algorithm OID.");
        error.algorithm = cert.md.algorithm;
        throw error;
      }
      cert.signatureOid = cert.siginfo.algorithmOid = algorithmOid;
      cert.tbsCertificate = pki.getTBSCertificate(cert);
      var bytes = asn1.toDer(cert.tbsCertificate);
      cert.md.update(bytes.getBytes());
      cert.signature = key.sign(cert.md);
    };
    cert.verify = function(child) {
      var rval = false;
      if (!cert.issued(child)) {
        var issuer = child.issuer;
        var subject = cert.subject;
        var error = new Error("The parent certificate did not issue the given child " + "certificate; the child certificate\'s issuer does not match the " + "parent\'s subject.");
        error.expectedIssuer = subject.attributes;
        error.actualIssuer = issuer.attributes;
        throw error;
      }
      var md = child.md;
      if (md === null) {
        md = _createSignatureDigest({
          signatureOid: child.signatureOid,
          type: "certificate"
        });
        var tbsCertificate = child.tbsCertificate || pki.getTBSCertificate(child);
        var bytes = asn1.toDer(tbsCertificate);
        md.update(bytes.getBytes());
      }
      if (md !== null) {
        rval = _verifySignature({
          certificate: cert,
          md,
          signature: child.signature
        });
      }
      return rval;
    };
    cert.isIssuer = function(parent) {
      var rval = false;
      var i5 = cert.issuer;
      var s32 = parent.subject;
      if (i5.hash && s32.hash) {
        rval = i5.hash === s32.hash;
      } else if (i5.attributes.length === s32.attributes.length) {
        rval = true;
        var iattr, sattr;
        for (var n5 = 0;rval && n5 < i5.attributes.length; ++n5) {
          iattr = i5.attributes[n5];
          sattr = s32.attributes[n5];
          if (iattr.type !== sattr.type || iattr.value !== sattr.value) {
            rval = false;
          }
        }
      }
      return rval;
    };
    cert.issued = function(child) {
      return child.isIssuer(cert);
    };
    cert.generateSubjectKeyIdentifier = function() {
      return pki.getPublicKeyFingerprint(cert.publicKey, { type: "RSAPublicKey" });
    };
    cert.verifySubjectKeyIdentifier = function() {
      var oid = oids["subjectKeyIdentifier"];
      for (var i5 = 0;i5 < cert.extensions.length; ++i5) {
        var ext2 = cert.extensions[i5];
        if (ext2.id === oid) {
          var ski = cert.generateSubjectKeyIdentifier().getBytes();
          return forge.util.hexToBytes(ext2.subjectKeyIdentifier) === ski;
        }
      }
      return false;
    };
    return cert;
  };
  pki.certificateFromAsn1 = function(obj, computeHash) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, x509CertificateValidator, capture, errors)) {
      var error = new Error("Cannot read X.509 certificate. " + "ASN.1 object is not an X509v3 Certificate.");
      error.errors = errors;
      throw error;
    }
    var oid = asn1.derToOid(capture.publicKeyOid);
    if (oid !== pki.oids.rsaEncryption) {
      throw new Error("Cannot read public key. OID is not RSA.");
    }
    var cert = pki.createCertificate();
    cert.version = capture.certVersion ? capture.certVersion.charCodeAt(0) : 0;
    var serial = forge.util.createBuffer(capture.certSerialNumber);
    cert.serialNumber = serial.toHex();
    cert.signatureOid = forge.asn1.derToOid(capture.certSignatureOid);
    cert.signatureParameters = _readSignatureParameters(cert.signatureOid, capture.certSignatureParams, true);
    cert.siginfo.algorithmOid = forge.asn1.derToOid(capture.certinfoSignatureOid);
    cert.siginfo.parameters = _readSignatureParameters(cert.siginfo.algorithmOid, capture.certinfoSignatureParams, false);
    cert.signature = capture.certSignature;
    var validity = [];
    if (capture.certValidity1UTCTime !== undefined) {
      validity.push(asn1.utcTimeToDate(capture.certValidity1UTCTime));
    }
    if (capture.certValidity2GeneralizedTime !== undefined) {
      validity.push(asn1.generalizedTimeToDate(capture.certValidity2GeneralizedTime));
    }
    if (capture.certValidity3UTCTime !== undefined) {
      validity.push(asn1.utcTimeToDate(capture.certValidity3UTCTime));
    }
    if (capture.certValidity4GeneralizedTime !== undefined) {
      validity.push(asn1.generalizedTimeToDate(capture.certValidity4GeneralizedTime));
    }
    if (validity.length > 2) {
      throw new Error("Cannot read notBefore/notAfter validity times; more " + "than two times were provided in the certificate.");
    }
    if (validity.length < 2) {
      throw new Error("Cannot read notBefore/notAfter validity times; they " + "were not provided as either UTCTime or GeneralizedTime.");
    }
    cert.validity.notBefore = validity[0];
    cert.validity.notAfter = validity[1];
    cert.tbsCertificate = capture.tbsCertificate;
    if (computeHash) {
      cert.md = _createSignatureDigest({
        signatureOid: cert.signatureOid,
        type: "certificate"
      });
      var bytes = asn1.toDer(cert.tbsCertificate);
      cert.md.update(bytes.getBytes());
    }
    var imd = forge.md.sha1.create();
    var ibytes = asn1.toDer(capture.certIssuer);
    imd.update(ibytes.getBytes());
    cert.issuer.getField = function(sn) {
      return _getAttribute(cert.issuer, sn);
    };
    cert.issuer.addField = function(attr) {
      _fillMissingFields([attr]);
      cert.issuer.attributes.push(attr);
    };
    cert.issuer.attributes = pki.RDNAttributesAsArray(capture.certIssuer);
    if (capture.certIssuerUniqueId) {
      cert.issuer.uniqueId = capture.certIssuerUniqueId;
    }
    cert.issuer.hash = imd.digest().toHex();
    var smd = forge.md.sha1.create();
    var sbytes = asn1.toDer(capture.certSubject);
    smd.update(sbytes.getBytes());
    cert.subject.getField = function(sn) {
      return _getAttribute(cert.subject, sn);
    };
    cert.subject.addField = function(attr) {
      _fillMissingFields([attr]);
      cert.subject.attributes.push(attr);
    };
    cert.subject.attributes = pki.RDNAttributesAsArray(capture.certSubject);
    if (capture.certSubjectUniqueId) {
      cert.subject.uniqueId = capture.certSubjectUniqueId;
    }
    cert.subject.hash = smd.digest().toHex();
    if (capture.certExtensions) {
      cert.extensions = pki.certificateExtensionsFromAsn1(capture.certExtensions);
    } else {
      cert.extensions = [];
    }
    cert.publicKey = pki.publicKeyFromAsn1(capture.subjectPublicKeyInfo);
    return cert;
  };
  pki.certificateExtensionsFromAsn1 = function(exts) {
    var rval = [];
    for (var i5 = 0;i5 < exts.value.length; ++i5) {
      var extseq = exts.value[i5];
      for (var ei = 0;ei < extseq.value.length; ++ei) {
        rval.push(pki.certificateExtensionFromAsn1(extseq.value[ei]));
      }
    }
    return rval;
  };
  pki.certificateExtensionFromAsn1 = function(ext2) {
    var e5 = {};
    e5.id = asn1.derToOid(ext2.value[0].value);
    e5.critical = false;
    if (ext2.value[1].type === asn1.Type.BOOLEAN) {
      e5.critical = ext2.value[1].value.charCodeAt(0) !== 0;
      e5.value = ext2.value[2].value;
    } else {
      e5.value = ext2.value[1].value;
    }
    if (e5.id in oids) {
      e5.name = oids[e5.id];
      if (e5.name === "keyUsage") {
        var ev = asn1.fromDer(e5.value);
        var b23 = 0;
        var b32 = 0;
        if (ev.value.length > 1) {
          b23 = ev.value.charCodeAt(1);
          b32 = ev.value.length > 2 ? ev.value.charCodeAt(2) : 0;
        }
        e5.digitalSignature = (b23 & 128) === 128;
        e5.nonRepudiation = (b23 & 64) === 64;
        e5.keyEncipherment = (b23 & 32) === 32;
        e5.dataEncipherment = (b23 & 16) === 16;
        e5.keyAgreement = (b23 & 8) === 8;
        e5.keyCertSign = (b23 & 4) === 4;
        e5.cRLSign = (b23 & 2) === 2;
        e5.encipherOnly = (b23 & 1) === 1;
        e5.decipherOnly = (b32 & 128) === 128;
      } else if (e5.name === "basicConstraints") {
        var ev = asn1.fromDer(e5.value);
        if (ev.value.length > 0 && ev.value[0].type === asn1.Type.BOOLEAN) {
          e5.cA = ev.value[0].value.charCodeAt(0) !== 0;
        } else {
          e5.cA = false;
        }
        var value = null;
        if (ev.value.length > 0 && ev.value[0].type === asn1.Type.INTEGER) {
          value = ev.value[0].value;
        } else if (ev.value.length > 1) {
          value = ev.value[1].value;
        }
        if (value !== null) {
          e5.pathLenConstraint = asn1.derToInteger(value);
        }
      } else if (e5.name === "extKeyUsage") {
        var ev = asn1.fromDer(e5.value);
        for (var vi = 0;vi < ev.value.length; ++vi) {
          var oid = asn1.derToOid(ev.value[vi].value);
          if (oid in oids) {
            e5[oids[oid]] = true;
          } else {
            e5[oid] = true;
          }
        }
      } else if (e5.name === "nsCertType") {
        var ev = asn1.fromDer(e5.value);
        var b23 = 0;
        if (ev.value.length > 1) {
          b23 = ev.value.charCodeAt(1);
        }
        e5.client = (b23 & 128) === 128;
        e5.server = (b23 & 64) === 64;
        e5.email = (b23 & 32) === 32;
        e5.objsign = (b23 & 16) === 16;
        e5.reserved = (b23 & 8) === 8;
        e5.sslCA = (b23 & 4) === 4;
        e5.emailCA = (b23 & 2) === 2;
        e5.objCA = (b23 & 1) === 1;
      } else if (e5.name === "subjectAltName" || e5.name === "issuerAltName") {
        e5.altNames = [];
        var gn;
        var ev = asn1.fromDer(e5.value);
        for (var n5 = 0;n5 < ev.value.length; ++n5) {
          gn = ev.value[n5];
          var altName = {
            type: gn.type,
            value: gn.value
          };
          e5.altNames.push(altName);
          switch (gn.type) {
            case 1:
            case 2:
            case 6:
              break;
            case 7:
              altName.ip = forge.util.bytesToIP(gn.value);
              break;
            case 8:
              altName.oid = asn1.derToOid(gn.value);
              break;
            default:
          }
        }
      } else if (e5.name === "subjectKeyIdentifier") {
        var ev = asn1.fromDer(e5.value);
        e5.subjectKeyIdentifier = forge.util.bytesToHex(ev.value);
      }
    }
    return e5;
  };
  pki.certificationRequestFromAsn1 = function(obj, computeHash) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, certificationRequestValidator, capture, errors)) {
      var error = new Error("Cannot read PKCS#10 certificate request. " + "ASN.1 object is not a PKCS#10 CertificationRequest.");
      error.errors = errors;
      throw error;
    }
    var oid = asn1.derToOid(capture.publicKeyOid);
    if (oid !== pki.oids.rsaEncryption) {
      throw new Error("Cannot read public key. OID is not RSA.");
    }
    var csr = pki.createCertificationRequest();
    csr.version = capture.csrVersion ? capture.csrVersion.charCodeAt(0) : 0;
    csr.signatureOid = forge.asn1.derToOid(capture.csrSignatureOid);
    csr.signatureParameters = _readSignatureParameters(csr.signatureOid, capture.csrSignatureParams, true);
    csr.siginfo.algorithmOid = forge.asn1.derToOid(capture.csrSignatureOid);
    csr.siginfo.parameters = _readSignatureParameters(csr.siginfo.algorithmOid, capture.csrSignatureParams, false);
    csr.signature = capture.csrSignature;
    csr.certificationRequestInfo = capture.certificationRequestInfo;
    if (computeHash) {
      csr.md = _createSignatureDigest({
        signatureOid: csr.signatureOid,
        type: "certification request"
      });
      var bytes = asn1.toDer(csr.certificationRequestInfo);
      csr.md.update(bytes.getBytes());
    }
    var smd = forge.md.sha1.create();
    csr.subject.getField = function(sn) {
      return _getAttribute(csr.subject, sn);
    };
    csr.subject.addField = function(attr) {
      _fillMissingFields([attr]);
      csr.subject.attributes.push(attr);
    };
    csr.subject.attributes = pki.RDNAttributesAsArray(capture.certificationRequestInfoSubject, smd);
    csr.subject.hash = smd.digest().toHex();
    csr.publicKey = pki.publicKeyFromAsn1(capture.subjectPublicKeyInfo);
    csr.getAttribute = function(sn) {
      return _getAttribute(csr, sn);
    };
    csr.addAttribute = function(attr) {
      _fillMissingFields([attr]);
      csr.attributes.push(attr);
    };
    csr.attributes = pki.CRIAttributesAsArray(capture.certificationRequestInfoAttributes || []);
    return csr;
  };
  pki.createCertificationRequest = function() {
    var csr = {};
    csr.version = 0;
    csr.signatureOid = null;
    csr.signature = null;
    csr.siginfo = {};
    csr.siginfo.algorithmOid = null;
    csr.subject = {};
    csr.subject.getField = function(sn) {
      return _getAttribute(csr.subject, sn);
    };
    csr.subject.addField = function(attr) {
      _fillMissingFields([attr]);
      csr.subject.attributes.push(attr);
    };
    csr.subject.attributes = [];
    csr.subject.hash = null;
    csr.publicKey = null;
    csr.attributes = [];
    csr.getAttribute = function(sn) {
      return _getAttribute(csr, sn);
    };
    csr.addAttribute = function(attr) {
      _fillMissingFields([attr]);
      csr.attributes.push(attr);
    };
    csr.md = null;
    csr.setSubject = function(attrs) {
      _fillMissingFields(attrs);
      csr.subject.attributes = attrs;
      csr.subject.hash = null;
    };
    csr.setAttributes = function(attrs) {
      _fillMissingFields(attrs);
      csr.attributes = attrs;
    };
    csr.sign = function(key, md) {
      csr.md = md || forge.md.sha1.create();
      var algorithmOid = oids[csr.md.algorithm + "WithRSAEncryption"];
      if (!algorithmOid) {
        var error = new Error("Could not compute certification request digest. " + "Unknown message digest algorithm OID.");
        error.algorithm = csr.md.algorithm;
        throw error;
      }
      csr.signatureOid = csr.siginfo.algorithmOid = algorithmOid;
      csr.certificationRequestInfo = pki.getCertificationRequestInfo(csr);
      var bytes = asn1.toDer(csr.certificationRequestInfo);
      csr.md.update(bytes.getBytes());
      csr.signature = key.sign(csr.md);
    };
    csr.verify = function() {
      var rval = false;
      var md = csr.md;
      if (md === null) {
        md = _createSignatureDigest({
          signatureOid: csr.signatureOid,
          type: "certification request"
        });
        var cri = csr.certificationRequestInfo || pki.getCertificationRequestInfo(csr);
        var bytes = asn1.toDer(cri);
        md.update(bytes.getBytes());
      }
      if (md !== null) {
        rval = _verifySignature({
          certificate: csr,
          md,
          signature: csr.signature
        });
      }
      return rval;
    };
    return csr;
  };
  function _dnToAsn1(obj) {
    var rval = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
    var attr, set2;
    var attrs = obj.attributes;
    for (var i5 = 0;i5 < attrs.length; ++i5) {
      attr = attrs[i5];
      var value = attr.value;
      var valueTagClass = asn1.Type.PRINTABLESTRING;
      if ("valueTagClass" in attr) {
        valueTagClass = attr.valueTagClass;
        if (valueTagClass === asn1.Type.UTF8) {
          value = forge.util.encodeUtf8(value);
        }
      }
      set2 = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(attr.type).getBytes()),
          asn1.create(asn1.Class.UNIVERSAL, valueTagClass, false, value)
        ])
      ]);
      rval.value.push(set2);
    }
    return rval;
  }
  function _fillMissingFields(attrs) {
    var attr;
    for (var i5 = 0;i5 < attrs.length; ++i5) {
      attr = attrs[i5];
      if (typeof attr.name === "undefined") {
        if (attr.type && attr.type in pki.oids) {
          attr.name = pki.oids[attr.type];
        } else if (attr.shortName && attr.shortName in _shortNames) {
          attr.name = pki.oids[_shortNames[attr.shortName]];
        }
      }
      if (typeof attr.type === "undefined") {
        if (attr.name && attr.name in pki.oids) {
          attr.type = pki.oids[attr.name];
        } else {
          var error = new Error("Attribute type not specified.");
          error.attribute = attr;
          throw error;
        }
      }
      if (typeof attr.shortName === "undefined") {
        if (attr.name && attr.name in _shortNames) {
          attr.shortName = _shortNames[attr.name];
        }
      }
      if (attr.type === oids.extensionRequest) {
        attr.valueConstructed = true;
        attr.valueTagClass = asn1.Type.SEQUENCE;
        if (!attr.value && attr.extensions) {
          attr.value = [];
          for (var ei = 0;ei < attr.extensions.length; ++ei) {
            attr.value.push(pki.certificateExtensionToAsn1(_fillMissingExtensionFields(attr.extensions[ei])));
          }
        }
      }
      if (typeof attr.value === "undefined") {
        var error = new Error("Attribute value not specified.");
        error.attribute = attr;
        throw error;
      }
    }
  }
  function _fillMissingExtensionFields(e5, options23) {
    options23 = options23 || {};
    if (typeof e5.name === "undefined") {
      if (e5.id && e5.id in pki.oids) {
        e5.name = pki.oids[e5.id];
      }
    }
    if (typeof e5.id === "undefined") {
      if (e5.name && e5.name in pki.oids) {
        e5.id = pki.oids[e5.name];
      } else {
        var error = new Error("Extension ID not specified.");
        error.extension = e5;
        throw error;
      }
    }
    if (typeof e5.value !== "undefined") {
      return e5;
    }
    if (e5.name === "keyUsage") {
      var unused = 0;
      var b23 = 0;
      var b32 = 0;
      if (e5.digitalSignature) {
        b23 |= 128;
        unused = 7;
      }
      if (e5.nonRepudiation) {
        b23 |= 64;
        unused = 6;
      }
      if (e5.keyEncipherment) {
        b23 |= 32;
        unused = 5;
      }
      if (e5.dataEncipherment) {
        b23 |= 16;
        unused = 4;
      }
      if (e5.keyAgreement) {
        b23 |= 8;
        unused = 3;
      }
      if (e5.keyCertSign) {
        b23 |= 4;
        unused = 2;
      }
      if (e5.cRLSign) {
        b23 |= 2;
        unused = 1;
      }
      if (e5.encipherOnly) {
        b23 |= 1;
        unused = 0;
      }
      if (e5.decipherOnly) {
        b32 |= 128;
        unused = 7;
      }
      var value = String.fromCharCode(unused);
      if (b32 !== 0) {
        value += String.fromCharCode(b23) + String.fromCharCode(b32);
      } else if (b23 !== 0) {
        value += String.fromCharCode(b23);
      }
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BITSTRING, false, value);
    } else if (e5.name === "basicConstraints") {
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
      if (e5.cA) {
        e5.value.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BOOLEAN, false, String.fromCharCode(255)));
      }
      if ("pathLenConstraint" in e5) {
        e5.value.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(e5.pathLenConstraint).getBytes()));
      }
    } else if (e5.name === "extKeyUsage") {
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
      var seq2 = e5.value.value;
      for (var key in e5) {
        if (e5[key] !== true) {
          continue;
        }
        if (key in oids) {
          seq2.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(oids[key]).getBytes()));
        } else if (key.indexOf(".") !== -1) {
          seq2.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(key).getBytes()));
        }
      }
    } else if (e5.name === "nsCertType") {
      var unused = 0;
      var b23 = 0;
      if (e5.client) {
        b23 |= 128;
        unused = 7;
      }
      if (e5.server) {
        b23 |= 64;
        unused = 6;
      }
      if (e5.email) {
        b23 |= 32;
        unused = 5;
      }
      if (e5.objsign) {
        b23 |= 16;
        unused = 4;
      }
      if (e5.reserved) {
        b23 |= 8;
        unused = 3;
      }
      if (e5.sslCA) {
        b23 |= 4;
        unused = 2;
      }
      if (e5.emailCA) {
        b23 |= 2;
        unused = 1;
      }
      if (e5.objCA) {
        b23 |= 1;
        unused = 0;
      }
      var value = String.fromCharCode(unused);
      if (b23 !== 0) {
        value += String.fromCharCode(b23);
      }
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BITSTRING, false, value);
    } else if (e5.name === "subjectAltName" || e5.name === "issuerAltName") {
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
      var altName;
      for (var n5 = 0;n5 < e5.altNames.length; ++n5) {
        altName = e5.altNames[n5];
        var value = altName.value;
        if (altName.type === 7 && altName.ip) {
          value = forge.util.bytesFromIP(altName.ip);
          if (value === null) {
            var error = new Error('Extension "ip" value is not a valid IPv4 or IPv6 address.');
            error.extension = e5;
            throw error;
          }
        } else if (altName.type === 8) {
          if (altName.oid) {
            value = asn1.oidToDer(asn1.oidToDer(altName.oid));
          } else {
            value = asn1.oidToDer(value);
          }
        }
        e5.value.value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, altName.type, false, value));
      }
    } else if (e5.name === "nsComment" && options23.cert) {
      if (!/^[\x00-\x7F]*$/.test(e5.comment) || e5.comment.length < 1 || e5.comment.length > 128) {
        throw new Error('Invalid "nsComment" content.');
      }
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.IA5STRING, false, e5.comment);
    } else if (e5.name === "subjectKeyIdentifier" && options23.cert) {
      var ski = options23.cert.generateSubjectKeyIdentifier();
      e5.subjectKeyIdentifier = ski.toHex();
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, ski.getBytes());
    } else if (e5.name === "authorityKeyIdentifier" && options23.cert) {
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
      var seq2 = e5.value.value;
      if (e5.keyIdentifier) {
        var keyIdentifier = e5.keyIdentifier === true ? options23.cert.generateSubjectKeyIdentifier().getBytes() : e5.keyIdentifier;
        seq2.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, false, keyIdentifier));
      }
      if (e5.authorityCertIssuer) {
        var authorityCertIssuer = [
          asn1.create(asn1.Class.CONTEXT_SPECIFIC, 4, true, [
            _dnToAsn1(e5.authorityCertIssuer === true ? options23.cert.issuer : e5.authorityCertIssuer)
          ])
        ];
        seq2.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 1, true, authorityCertIssuer));
      }
      if (e5.serialNumber) {
        var serialNumber = forge.util.hexToBytes(e5.serialNumber === true ? options23.cert.serialNumber : e5.serialNumber);
        seq2.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 2, false, serialNumber));
      }
    } else if (e5.name === "cRLDistributionPoints") {
      e5.value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
      var seq2 = e5.value.value;
      var subSeq = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
      var fullNameGeneralNames = asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, []);
      var altName;
      for (var n5 = 0;n5 < e5.altNames.length; ++n5) {
        altName = e5.altNames[n5];
        var value = altName.value;
        if (altName.type === 7 && altName.ip) {
          value = forge.util.bytesFromIP(altName.ip);
          if (value === null) {
            var error = new Error('Extension "ip" value is not a valid IPv4 or IPv6 address.');
            error.extension = e5;
            throw error;
          }
        } else if (altName.type === 8) {
          if (altName.oid) {
            value = asn1.oidToDer(asn1.oidToDer(altName.oid));
          } else {
            value = asn1.oidToDer(value);
          }
        }
        fullNameGeneralNames.value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, altName.type, false, value));
      }
      subSeq.value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [fullNameGeneralNames]));
      seq2.push(subSeq);
    }
    if (typeof e5.value === "undefined") {
      var error = new Error("Extension value not specified.");
      error.extension = e5;
      throw error;
    }
    return e5;
  }
  function _signatureParametersToAsn1(oid, params) {
    switch (oid) {
      case oids["RSASSA-PSS"]:
        var parts = [];
        if (params.hash.algorithmOid !== undefined) {
          parts.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(params.hash.algorithmOid).getBytes()),
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
            ])
          ]));
        }
        if (params.mgf.algorithmOid !== undefined) {
          parts.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 1, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(params.mgf.algorithmOid).getBytes()),
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
                asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(params.mgf.hash.algorithmOid).getBytes()),
                asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
              ])
            ])
          ]));
        }
        if (params.saltLength !== undefined) {
          parts.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 2, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(params.saltLength).getBytes())
          ]));
        }
        return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, parts);
      default:
        return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "");
    }
  }
  function _CRIAttributesToAsn1(csr) {
    var rval = asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, []);
    if (csr.attributes.length === 0) {
      return rval;
    }
    var attrs = csr.attributes;
    for (var i5 = 0;i5 < attrs.length; ++i5) {
      var attr = attrs[i5];
      var value = attr.value;
      var valueTagClass = asn1.Type.UTF8;
      if ("valueTagClass" in attr) {
        valueTagClass = attr.valueTagClass;
      }
      if (valueTagClass === asn1.Type.UTF8) {
        value = forge.util.encodeUtf8(value);
      }
      var valueConstructed = false;
      if ("valueConstructed" in attr) {
        valueConstructed = attr.valueConstructed;
      }
      var seq2 = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(attr.type).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, [
          asn1.create(asn1.Class.UNIVERSAL, valueTagClass, valueConstructed, value)
        ])
      ]);
      rval.value.push(seq2);
    }
    return rval;
  }
  var jan_1_1950 = new Date("1950-01-01T00:00:00Z");
  var jan_1_2050 = new Date("2050-01-01T00:00:00Z");
  function _dateToAsn1(date) {
    if (date >= jan_1_1950 && date < jan_1_2050) {
      return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.UTCTIME, false, asn1.dateToUtcTime(date));
    } else {
      return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.GENERALIZEDTIME, false, asn1.dateToGeneralizedTime(date));
    }
  }
  pki.getTBSCertificate = function(cert) {
    var notBefore = _dateToAsn1(cert.validity.notBefore);
    var notAfter = _dateToAsn1(cert.validity.notAfter);
    var tbs = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(cert.version).getBytes())
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, forge.util.hexToBytes(cert.serialNumber)),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(cert.siginfo.algorithmOid).getBytes()),
        _signatureParametersToAsn1(cert.siginfo.algorithmOid, cert.siginfo.parameters)
      ]),
      _dnToAsn1(cert.issuer),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        notBefore,
        notAfter
      ]),
      _dnToAsn1(cert.subject),
      pki.publicKeyToAsn1(cert.publicKey)
    ]);
    if (cert.issuer.uniqueId) {
      tbs.value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 1, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BITSTRING, false, String.fromCharCode(0) + cert.issuer.uniqueId)
      ]));
    }
    if (cert.subject.uniqueId) {
      tbs.value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 2, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BITSTRING, false, String.fromCharCode(0) + cert.subject.uniqueId)
      ]));
    }
    if (cert.extensions.length > 0) {
      tbs.value.push(pki.certificateExtensionsToAsn1(cert.extensions));
    }
    return tbs;
  };
  pki.getCertificationRequestInfo = function(csr) {
    var cri = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(csr.version).getBytes()),
      _dnToAsn1(csr.subject),
      pki.publicKeyToAsn1(csr.publicKey),
      _CRIAttributesToAsn1(csr)
    ]);
    return cri;
  };
  pki.distinguishedNameToAsn1 = function(dn) {
    return _dnToAsn1(dn);
  };
  pki.certificateToAsn1 = function(cert) {
    var tbsCertificate = cert.tbsCertificate || pki.getTBSCertificate(cert);
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      tbsCertificate,
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(cert.signatureOid).getBytes()),
        _signatureParametersToAsn1(cert.signatureOid, cert.signatureParameters)
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BITSTRING, false, String.fromCharCode(0) + cert.signature)
    ]);
  };
  pki.certificateExtensionsToAsn1 = function(exts) {
    var rval = asn1.create(asn1.Class.CONTEXT_SPECIFIC, 3, true, []);
    var seq2 = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
    rval.value.push(seq2);
    for (var i5 = 0;i5 < exts.length; ++i5) {
      seq2.value.push(pki.certificateExtensionToAsn1(exts[i5]));
    }
    return rval;
  };
  pki.certificateExtensionToAsn1 = function(ext2) {
    var extseq = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, []);
    extseq.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(ext2.id).getBytes()));
    if (ext2.critical) {
      extseq.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BOOLEAN, false, String.fromCharCode(255)));
    }
    var value = ext2.value;
    if (typeof ext2.value !== "string") {
      value = asn1.toDer(value).getBytes();
    }
    extseq.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, value));
    return extseq;
  };
  pki.certificationRequestToAsn1 = function(csr) {
    var cri = csr.certificationRequestInfo || pki.getCertificationRequestInfo(csr);
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      cri,
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(csr.signatureOid).getBytes()),
        _signatureParametersToAsn1(csr.signatureOid, csr.signatureParameters)
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BITSTRING, false, String.fromCharCode(0) + csr.signature)
    ]);
  };
  pki.createCaStore = function(certs) {
    var caStore = {
      certs: {}
    };
    caStore.getIssuer = function(cert2) {
      var rval = getBySubject(cert2.issuer);
      return rval;
    };
    caStore.addCertificate = function(cert2) {
      if (typeof cert2 === "string") {
        cert2 = forge.pki.certificateFromPem(cert2);
      }
      ensureSubjectHasHash(cert2.subject);
      if (!caStore.hasCertificate(cert2)) {
        if (cert2.subject.hash in caStore.certs) {
          var tmp = caStore.certs[cert2.subject.hash];
          if (!forge.util.isArray(tmp)) {
            tmp = [tmp];
          }
          tmp.push(cert2);
          caStore.certs[cert2.subject.hash] = tmp;
        } else {
          caStore.certs[cert2.subject.hash] = cert2;
        }
      }
    };
    caStore.hasCertificate = function(cert2) {
      if (typeof cert2 === "string") {
        cert2 = forge.pki.certificateFromPem(cert2);
      }
      var match = getBySubject(cert2.subject);
      if (!match) {
        return false;
      }
      if (!forge.util.isArray(match)) {
        match = [match];
      }
      var der1 = asn1.toDer(pki.certificateToAsn1(cert2)).getBytes();
      for (var i22 = 0;i22 < match.length; ++i22) {
        var der2 = asn1.toDer(pki.certificateToAsn1(match[i22])).getBytes();
        if (der1 === der2) {
          return true;
        }
      }
      return false;
    };
    caStore.listAllCertificates = function() {
      var certList = [];
      for (var hash in caStore.certs) {
        if (caStore.certs.hasOwnProperty(hash)) {
          var value = caStore.certs[hash];
          if (!forge.util.isArray(value)) {
            certList.push(value);
          } else {
            for (var i22 = 0;i22 < value.length; ++i22) {
              certList.push(value[i22]);
            }
          }
        }
      }
      return certList;
    };
    caStore.removeCertificate = function(cert2) {
      var result2;
      if (typeof cert2 === "string") {
        cert2 = forge.pki.certificateFromPem(cert2);
      }
      ensureSubjectHasHash(cert2.subject);
      if (!caStore.hasCertificate(cert2)) {
        return null;
      }
      var match = getBySubject(cert2.subject);
      if (!forge.util.isArray(match)) {
        result2 = caStore.certs[cert2.subject.hash];
        delete caStore.certs[cert2.subject.hash];
        return result2;
      }
      var der1 = asn1.toDer(pki.certificateToAsn1(cert2)).getBytes();
      for (var i22 = 0;i22 < match.length; ++i22) {
        var der2 = asn1.toDer(pki.certificateToAsn1(match[i22])).getBytes();
        if (der1 === der2) {
          result2 = match[i22];
          match.splice(i22, 1);
        }
      }
      if (match.length === 0) {
        delete caStore.certs[cert2.subject.hash];
      }
      return result2;
    };
    function getBySubject(subject) {
      ensureSubjectHasHash(subject);
      return caStore.certs[subject.hash] || null;
    }
    function ensureSubjectHasHash(subject) {
      if (!subject.hash) {
        var md = forge.md.sha1.create();
        subject.attributes = pki.RDNAttributesAsArray(_dnToAsn1(subject), md);
        subject.hash = md.digest().toHex();
      }
    }
    if (certs) {
      for (var i5 = 0;i5 < certs.length; ++i5) {
        var cert = certs[i5];
        caStore.addCertificate(cert);
      }
    }
    return caStore;
  };
  pki.certificateError = {
    bad_certificate: "forge.pki.BadCertificate",
    unsupported_certificate: "forge.pki.UnsupportedCertificate",
    certificate_revoked: "forge.pki.CertificateRevoked",
    certificate_expired: "forge.pki.CertificateExpired",
    certificate_unknown: "forge.pki.CertificateUnknown",
    unknown_ca: "forge.pki.UnknownCertificateAuthority"
  };
  pki.verifyCertificateChain = function(caStore, chain2, options23) {
    if (typeof options23 === "function") {
      options23 = { verify: options23 };
    }
    options23 = options23 || {};
    chain2 = chain2.slice(0);
    var certs = chain2.slice(0);
    var validityCheckDate = options23.validityCheckDate;
    if (typeof validityCheckDate === "undefined") {
      validityCheckDate = new Date;
    }
    var first = true;
    var error = null;
    var depth2 = 0;
    do {
      var cert = chain2.shift();
      var parent = null;
      var selfSigned = false;
      if (validityCheckDate) {
        if (validityCheckDate < cert.validity.notBefore || validityCheckDate > cert.validity.notAfter) {
          error = {
            message: "Certificate is not valid yet or has expired.",
            error: pki.certificateError.certificate_expired,
            notBefore: cert.validity.notBefore,
            notAfter: cert.validity.notAfter,
            now: validityCheckDate
          };
        }
      }
      if (error === null) {
        parent = chain2[0] || caStore.getIssuer(cert);
        if (parent === null) {
          if (cert.isIssuer(cert)) {
            selfSigned = true;
            parent = cert;
          }
        }
        if (parent) {
          var parents = parent;
          if (!forge.util.isArray(parents)) {
            parents = [parents];
          }
          var verified = false;
          while (!verified && parents.length > 0) {
            parent = parents.shift();
            try {
              verified = parent.verify(cert);
            } catch (ex) {
            }
          }
          if (!verified) {
            error = {
              message: "Certificate signature is invalid.",
              error: pki.certificateError.bad_certificate
            };
          }
        }
        if (error === null && (!parent || selfSigned) && !caStore.hasCertificate(cert)) {
          error = {
            message: "Certificate is not trusted.",
            error: pki.certificateError.unknown_ca
          };
        }
      }
      if (error === null && parent && !cert.isIssuer(parent)) {
        error = {
          message: "Certificate issuer is invalid.",
          error: pki.certificateError.bad_certificate
        };
      }
      if (error === null) {
        var se = {
          keyUsage: true,
          basicConstraints: true
        };
        for (var i5 = 0;error === null && i5 < cert.extensions.length; ++i5) {
          var ext2 = cert.extensions[i5];
          if (ext2.critical && !(ext2.name in se)) {
            error = {
              message: "Certificate has an unsupported critical extension.",
              error: pki.certificateError.unsupported_certificate
            };
          }
        }
      }
      if (error === null && (!first || chain2.length === 0 && (!parent || selfSigned))) {
        var bcExt = cert.getExtension("basicConstraints");
        var keyUsageExt = cert.getExtension("keyUsage");
        if (keyUsageExt !== null) {
          if (!keyUsageExt.keyCertSign || bcExt === null) {
            error = {
              message: "Certificate keyUsage or basicConstraints conflict " + "or indicate that the certificate is not a CA. " + "If the certificate is the only one in the chain or " + "isn\'t the first then the certificate must be a " + "valid CA.",
              error: pki.certificateError.bad_certificate
            };
          }
        }
        if (error === null && bcExt !== null && !bcExt.cA) {
          error = {
            message: "Certificate basicConstraints indicates the certificate " + "is not a CA.",
            error: pki.certificateError.bad_certificate
          };
        }
        if (error === null && keyUsageExt !== null && "pathLenConstraint" in bcExt) {
          var pathLen = depth2 - 1;
          if (pathLen > bcExt.pathLenConstraint) {
            error = {
              message: "Certificate basicConstraints pathLenConstraint violated.",
              error: pki.certificateError.bad_certificate
            };
          }
        }
      }
      var vfd = error === null ? true : error.error;
      var ret = options23.verify ? options23.verify(vfd, depth2, certs) : vfd;
      if (ret === true) {
        error = null;
      } else {
        if (vfd === true) {
          error = {
            message: "The application rejected the certificate.",
            error: pki.certificateError.bad_certificate
          };
        }
        if (ret || ret === 0) {
          if (typeof ret === "object" && !forge.util.isArray(ret)) {
            if (ret.message) {
              error.message = ret.message;
            }
            if (ret.error) {
              error.error = ret.error;
            }
          } else if (typeof ret === "string") {
            error.error = ret;
          }
        }
        throw error;
      }
      first = false;
      ++depth2;
    } while (chain2.length > 0);
    return true;
  };
});
var require_pkcs12 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_asn1();
  require_hmac2();
  require_oids();
  require_pkcs7asn1();
  require_pbe();
  require_random();
  require_rsa();
  require_sha13();
  require_util33();
  require_x509();
  var asn1 = forge.asn1;
  var pki = forge.pki;
  var p12 = module.exports = forge.pkcs12 = forge.pkcs12 || {};
  var contentInfoValidator = {
    name: "ContentInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "ContentInfo.contentType",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OID,
      constructed: false,
      capture: "contentType"
    }, {
      name: "ContentInfo.content",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      constructed: true,
      captureAsn1: "content"
    }]
  };
  var pfxValidator = {
    name: "PFX",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [
      {
        name: "PFX.version",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.INTEGER,
        constructed: false,
        capture: "version"
      },
      contentInfoValidator,
      {
        name: "PFX.macData",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        optional: true,
        captureAsn1: "mac",
        value: [{
          name: "PFX.macData.mac",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.SEQUENCE,
          constructed: true,
          value: [{
            name: "PFX.macData.mac.digestAlgorithm",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.SEQUENCE,
            constructed: true,
            value: [{
              name: "PFX.macData.mac.digestAlgorithm.algorithm",
              tagClass: asn1.Class.UNIVERSAL,
              type: asn1.Type.OID,
              constructed: false,
              capture: "macAlgorithm"
            }, {
              name: "PFX.macData.mac.digestAlgorithm.parameters",
              tagClass: asn1.Class.UNIVERSAL,
              captureAsn1: "macAlgorithmParameters"
            }]
          }, {
            name: "PFX.macData.mac.digest",
            tagClass: asn1.Class.UNIVERSAL,
            type: asn1.Type.OCTETSTRING,
            constructed: false,
            capture: "macDigest"
          }]
        }, {
          name: "PFX.macData.macSalt",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.OCTETSTRING,
          constructed: false,
          capture: "macSalt"
        }, {
          name: "PFX.macData.iterations",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.INTEGER,
          constructed: false,
          optional: true,
          capture: "macIterations"
        }]
      }
    ]
  };
  var safeBagValidator = {
    name: "SafeBag",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "SafeBag.bagId",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OID,
      constructed: false,
      capture: "bagId"
    }, {
      name: "SafeBag.bagValue",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      constructed: true,
      captureAsn1: "bagValue"
    }, {
      name: "SafeBag.bagAttributes",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SET,
      constructed: true,
      optional: true,
      capture: "bagAttributes"
    }]
  };
  var attributeValidator = {
    name: "Attribute",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "Attribute.attrId",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OID,
      constructed: false,
      capture: "oid"
    }, {
      name: "Attribute.attrValues",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SET,
      constructed: true,
      capture: "values"
    }]
  };
  var certBagValidator = {
    name: "CertBag",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "CertBag.certId",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OID,
      constructed: false,
      capture: "certId"
    }, {
      name: "CertBag.certValue",
      tagClass: asn1.Class.CONTEXT_SPECIFIC,
      constructed: true,
      value: [{
        name: "CertBag.certValue[0]",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Class.OCTETSTRING,
        constructed: false,
        capture: "cert"
      }]
    }]
  };
  function _getBagsByAttribute(safeContents, attrName, attrValue, bagType) {
    var result2 = [];
    for (var i5 = 0;i5 < safeContents.length; i5++) {
      for (var j23 = 0;j23 < safeContents[i5].safeBags.length; j23++) {
        var bag = safeContents[i5].safeBags[j23];
        if (bagType !== undefined && bag.type !== bagType) {
          continue;
        }
        if (attrName === null) {
          result2.push(bag);
          continue;
        }
        if (bag.attributes[attrName] !== undefined && bag.attributes[attrName].indexOf(attrValue) >= 0) {
          result2.push(bag);
        }
      }
    }
    return result2;
  }
  p12.pkcs12FromAsn1 = function(obj, strict, password) {
    if (typeof strict === "string") {
      password = strict;
      strict = true;
    } else if (strict === undefined) {
      strict = true;
    }
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, pfxValidator, capture, errors)) {
      var error = new Error("Cannot read PKCS#12 PFX. " + "ASN.1 object is not an PKCS#12 PFX.");
      error.errors = error;
      throw error;
    }
    var pfx = {
      version: capture.version.charCodeAt(0),
      safeContents: [],
      getBags: function(filter) {
        var rval = {};
        var localKeyId;
        if ("localKeyId" in filter) {
          localKeyId = filter.localKeyId;
        } else if ("localKeyIdHex" in filter) {
          localKeyId = forge.util.hexToBytes(filter.localKeyIdHex);
        }
        if (localKeyId === undefined && !("friendlyName" in filter) && "bagType" in filter) {
          rval[filter.bagType] = _getBagsByAttribute(pfx.safeContents, null, null, filter.bagType);
        }
        if (localKeyId !== undefined) {
          rval.localKeyId = _getBagsByAttribute(pfx.safeContents, "localKeyId", localKeyId, filter.bagType);
        }
        if ("friendlyName" in filter) {
          rval.friendlyName = _getBagsByAttribute(pfx.safeContents, "friendlyName", filter.friendlyName, filter.bagType);
        }
        return rval;
      },
      getBagsByFriendlyName: function(friendlyName, bagType) {
        return _getBagsByAttribute(pfx.safeContents, "friendlyName", friendlyName, bagType);
      },
      getBagsByLocalKeyId: function(localKeyId, bagType) {
        return _getBagsByAttribute(pfx.safeContents, "localKeyId", localKeyId, bagType);
      }
    };
    if (capture.version.charCodeAt(0) !== 3) {
      var error = new Error("PKCS#12 PFX of version other than 3 not supported.");
      error.version = capture.version.charCodeAt(0);
      throw error;
    }
    if (asn1.derToOid(capture.contentType) !== pki.oids.data) {
      var error = new Error("Only PKCS#12 PFX in password integrity mode supported.");
      error.oid = asn1.derToOid(capture.contentType);
      throw error;
    }
    var data2 = capture.content.value[0];
    if (data2.tagClass !== asn1.Class.UNIVERSAL || data2.type !== asn1.Type.OCTETSTRING) {
      throw new Error("PKCS#12 authSafe content data is not an OCTET STRING.");
    }
    data2 = _decodePkcs7Data(data2);
    if (capture.mac) {
      var md = null;
      var macKeyBytes = 0;
      var macAlgorithm = asn1.derToOid(capture.macAlgorithm);
      switch (macAlgorithm) {
        case pki.oids.sha1:
          md = forge.md.sha1.create();
          macKeyBytes = 20;
          break;
        case pki.oids.sha256:
          md = forge.md.sha256.create();
          macKeyBytes = 32;
          break;
        case pki.oids.sha384:
          md = forge.md.sha384.create();
          macKeyBytes = 48;
          break;
        case pki.oids.sha512:
          md = forge.md.sha512.create();
          macKeyBytes = 64;
          break;
        case pki.oids.md5:
          md = forge.md.md5.create();
          macKeyBytes = 16;
          break;
      }
      if (md === null) {
        throw new Error("PKCS#12 uses unsupported MAC algorithm: " + macAlgorithm);
      }
      var macSalt = new forge.util.ByteBuffer(capture.macSalt);
      var macIterations = "macIterations" in capture ? parseInt(forge.util.bytesToHex(capture.macIterations), 16) : 1;
      var macKey = p12.generateKey(password, macSalt, 3, macIterations, macKeyBytes, md);
      var mac = forge.hmac.create();
      mac.start(md, macKey);
      mac.update(data2.value);
      var macValue = mac.getMac();
      if (macValue.getBytes() !== capture.macDigest) {
        throw new Error("PKCS#12 MAC could not be verified. Invalid password?");
      }
    }
    _decodeAuthenticatedSafe(pfx, data2.value, strict, password);
    return pfx;
  };
  function _decodePkcs7Data(data2) {
    if (data2.composed || data2.constructed) {
      var value = forge.util.createBuffer();
      for (var i5 = 0;i5 < data2.value.length; ++i5) {
        value.putBytes(data2.value[i5].value);
      }
      data2.composed = data2.constructed = false;
      data2.value = value.getBytes();
    }
    return data2;
  }
  function _decodeAuthenticatedSafe(pfx, authSafe, strict, password) {
    authSafe = asn1.fromDer(authSafe, strict);
    if (authSafe.tagClass !== asn1.Class.UNIVERSAL || authSafe.type !== asn1.Type.SEQUENCE || authSafe.constructed !== true) {
      throw new Error("PKCS#12 AuthenticatedSafe expected to be a " + "SEQUENCE OF ContentInfo");
    }
    for (var i5 = 0;i5 < authSafe.value.length; i5++) {
      var contentInfo = authSafe.value[i5];
      var capture = {};
      var errors = [];
      if (!asn1.validate(contentInfo, contentInfoValidator, capture, errors)) {
        var error = new Error("Cannot read ContentInfo.");
        error.errors = errors;
        throw error;
      }
      var obj = {
        encrypted: false
      };
      var safeContents = null;
      var data2 = capture.content.value[0];
      switch (asn1.derToOid(capture.contentType)) {
        case pki.oids.data:
          if (data2.tagClass !== asn1.Class.UNIVERSAL || data2.type !== asn1.Type.OCTETSTRING) {
            throw new Error("PKCS#12 SafeContents Data is not an OCTET STRING.");
          }
          safeContents = _decodePkcs7Data(data2).value;
          break;
        case pki.oids.encryptedData:
          safeContents = _decryptSafeContents(data2, password);
          obj.encrypted = true;
          break;
        default:
          var error = new Error("Unsupported PKCS#12 contentType.");
          error.contentType = asn1.derToOid(capture.contentType);
          throw error;
      }
      obj.safeBags = _decodeSafeContents(safeContents, strict, password);
      pfx.safeContents.push(obj);
    }
  }
  function _decryptSafeContents(data2, password) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(data2, forge.pkcs7.asn1.encryptedDataValidator, capture, errors)) {
      var error = new Error("Cannot read EncryptedContentInfo.");
      error.errors = errors;
      throw error;
    }
    var oid = asn1.derToOid(capture.contentType);
    if (oid !== pki.oids.data) {
      var error = new Error("PKCS#12 EncryptedContentInfo ContentType is not Data.");
      error.oid = oid;
      throw error;
    }
    oid = asn1.derToOid(capture.encAlgorithm);
    var cipher = pki.pbe.getCipher(oid, capture.encParameter, password);
    var encryptedContentAsn1 = _decodePkcs7Data(capture.encryptedContentAsn1);
    var encrypted = forge.util.createBuffer(encryptedContentAsn1.value);
    cipher.update(encrypted);
    if (!cipher.finish()) {
      throw new Error("Failed to decrypt PKCS#12 SafeContents.");
    }
    return cipher.output.getBytes();
  }
  function _decodeSafeContents(safeContents, strict, password) {
    if (!strict && safeContents.length === 0) {
      return [];
    }
    safeContents = asn1.fromDer(safeContents, strict);
    if (safeContents.tagClass !== asn1.Class.UNIVERSAL || safeContents.type !== asn1.Type.SEQUENCE || safeContents.constructed !== true) {
      throw new Error("PKCS#12 SafeContents expected to be a SEQUENCE OF SafeBag.");
    }
    var res = [];
    for (var i5 = 0;i5 < safeContents.value.length; i5++) {
      var safeBag = safeContents.value[i5];
      var capture = {};
      var errors = [];
      if (!asn1.validate(safeBag, safeBagValidator, capture, errors)) {
        var error = new Error("Cannot read SafeBag.");
        error.errors = errors;
        throw error;
      }
      var bag = {
        type: asn1.derToOid(capture.bagId),
        attributes: _decodeBagAttributes(capture.bagAttributes)
      };
      res.push(bag);
      var validator, decoder2;
      var bagAsn1 = capture.bagValue.value[0];
      switch (bag.type) {
        case pki.oids.pkcs8ShroudedKeyBag:
          bagAsn1 = pki.decryptPrivateKeyInfo(bagAsn1, password);
          if (bagAsn1 === null) {
            throw new Error("Unable to decrypt PKCS#8 ShroudedKeyBag, wrong password?");
          }
        case pki.oids.keyBag:
          try {
            bag.key = pki.privateKeyFromAsn1(bagAsn1);
          } catch (e5) {
            bag.key = null;
            bag.asn1 = bagAsn1;
          }
          continue;
        case pki.oids.certBag:
          validator = certBagValidator;
          decoder2 = function() {
            if (asn1.derToOid(capture.certId) !== pki.oids.x509Certificate) {
              var error2 = new Error("Unsupported certificate type, only X.509 supported.");
              error2.oid = asn1.derToOid(capture.certId);
              throw error2;
            }
            var certAsn1 = asn1.fromDer(capture.cert, strict);
            try {
              bag.cert = pki.certificateFromAsn1(certAsn1, true);
            } catch (e5) {
              bag.cert = null;
              bag.asn1 = certAsn1;
            }
          };
          break;
        default:
          var error = new Error("Unsupported PKCS#12 SafeBag type.");
          error.oid = bag.type;
          throw error;
      }
      if (validator !== undefined && !asn1.validate(bagAsn1, validator, capture, errors)) {
        var error = new Error("Cannot read PKCS#12 " + validator.name);
        error.errors = errors;
        throw error;
      }
      decoder2();
    }
    return res;
  }
  function _decodeBagAttributes(attributes) {
    var decodedAttrs = {};
    if (attributes !== undefined) {
      for (var i5 = 0;i5 < attributes.length; ++i5) {
        var capture = {};
        var errors = [];
        if (!asn1.validate(attributes[i5], attributeValidator, capture, errors)) {
          var error = new Error("Cannot read PKCS#12 BagAttribute.");
          error.errors = errors;
          throw error;
        }
        var oid = asn1.derToOid(capture.oid);
        if (pki.oids[oid] === undefined) {
          continue;
        }
        decodedAttrs[pki.oids[oid]] = [];
        for (var j23 = 0;j23 < capture.values.length; ++j23) {
          decodedAttrs[pki.oids[oid]].push(capture.values[j23].value);
        }
      }
    }
    return decodedAttrs;
  }
  p12.toPkcs12Asn1 = function(key, cert, password, options23) {
    options23 = options23 || {};
    options23.saltSize = options23.saltSize || 8;
    options23.count = options23.count || 2048;
    options23.algorithm = options23.algorithm || options23.encAlgorithm || "aes128";
    if (!("useMac" in options23)) {
      options23.useMac = true;
    }
    if (!("localKeyId" in options23)) {
      options23.localKeyId = null;
    }
    if (!("generateLocalKeyId" in options23)) {
      options23.generateLocalKeyId = true;
    }
    var localKeyId = options23.localKeyId;
    var bagAttrs;
    if (localKeyId !== null) {
      localKeyId = forge.util.hexToBytes(localKeyId);
    } else if (options23.generateLocalKeyId) {
      if (cert) {
        var pairedCert = forge.util.isArray(cert) ? cert[0] : cert;
        if (typeof pairedCert === "string") {
          pairedCert = pki.certificateFromPem(pairedCert);
        }
        var sha1 = forge.md.sha1.create();
        sha1.update(asn1.toDer(pki.certificateToAsn1(pairedCert)).getBytes());
        localKeyId = sha1.digest().getBytes();
      } else {
        localKeyId = forge.random.getBytes(20);
      }
    }
    var attrs = [];
    if (localKeyId !== null) {
      attrs.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.localKeyId).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, localKeyId)
        ])
      ]));
    }
    if ("friendlyName" in options23) {
      attrs.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.friendlyName).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.BMPSTRING, false, options23.friendlyName)
        ])
      ]));
    }
    if (attrs.length > 0) {
      bagAttrs = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, attrs);
    }
    var contents = [];
    var chain2 = [];
    if (cert !== null) {
      if (forge.util.isArray(cert)) {
        chain2 = cert;
      } else {
        chain2 = [cert];
      }
    }
    var certSafeBags = [];
    for (var i5 = 0;i5 < chain2.length; ++i5) {
      cert = chain2[i5];
      if (typeof cert === "string") {
        cert = pki.certificateFromPem(cert);
      }
      var certBagAttrs = i5 === 0 ? bagAttrs : undefined;
      var certAsn1 = pki.certificateToAsn1(cert);
      var certSafeBag = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.certBag).getBytes()),
        asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.x509Certificate).getBytes()),
            asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, asn1.toDer(certAsn1).getBytes())
            ])
          ])
        ]),
        certBagAttrs
      ]);
      certSafeBags.push(certSafeBag);
    }
    if (certSafeBags.length > 0) {
      var certSafeContents = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, certSafeBags);
      var certCI = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.data).getBytes()),
        asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, asn1.toDer(certSafeContents).getBytes())
        ])
      ]);
      contents.push(certCI);
    }
    var keyBag = null;
    if (key !== null) {
      var pkAsn1 = pki.wrapRsaPrivateKey(pki.privateKeyToAsn1(key));
      if (password === null) {
        keyBag = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.keyBag).getBytes()),
          asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
            pkAsn1
          ]),
          bagAttrs
        ]);
      } else {
        keyBag = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.pkcs8ShroudedKeyBag).getBytes()),
          asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
            pki.encryptPrivateKeyInfo(pkAsn1, password, options23)
          ]),
          bagAttrs
        ]);
      }
      var keySafeContents = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [keyBag]);
      var keyCI = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.data).getBytes()),
        asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, asn1.toDer(keySafeContents).getBytes())
        ])
      ]);
      contents.push(keyCI);
    }
    var safe = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, contents);
    var macData;
    if (options23.useMac) {
      var sha1 = forge.md.sha1.create();
      var macSalt = new forge.util.ByteBuffer(forge.random.getBytes(options23.saltSize));
      var count = options23.count;
      var key = p12.generateKey(password, macSalt, 3, count, 20);
      var mac = forge.hmac.create();
      mac.start(sha1, key);
      mac.update(asn1.toDer(safe).getBytes());
      var macValue = mac.getMac();
      macData = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.sha1).getBytes()),
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
          ]),
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, macValue.getBytes())
        ]),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, macSalt.getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(count).getBytes())
      ]);
    }
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(3).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(pki.oids.data).getBytes()),
        asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, asn1.toDer(safe).getBytes())
        ])
      ]),
      macData
    ]);
  };
  p12.generateKey = forge.pbe.generatePkcs12Key;
});
var require_pki = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_asn1();
  require_oids();
  require_pbe();
  require_pem();
  require_pbkdf2();
  require_pkcs12();
  require_pss();
  require_rsa();
  require_util33();
  require_x509();
  var asn1 = forge.asn1;
  var pki = module.exports = forge.pki = forge.pki || {};
  pki.pemToDer = function(pem) {
    var msg = forge.pem.decode(pem)[0];
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      throw new Error("Could not convert PEM to DER; PEM is encrypted.");
    }
    return forge.util.createBuffer(msg.body);
  };
  pki.privateKeyFromPem = function(pem) {
    var msg = forge.pem.decode(pem)[0];
    if (msg.type !== "PRIVATE KEY" && msg.type !== "RSA PRIVATE KEY") {
      var error = new Error("Could not convert private key from PEM; PEM " + 'header type is not "PRIVATE KEY" or "RSA PRIVATE KEY".');
      error.headerType = msg.type;
      throw error;
    }
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      throw new Error("Could not convert private key from PEM; PEM is encrypted.");
    }
    var obj = asn1.fromDer(msg.body);
    return pki.privateKeyFromAsn1(obj);
  };
  pki.privateKeyToPem = function(key, maxline) {
    var msg = {
      type: "RSA PRIVATE KEY",
      body: asn1.toDer(pki.privateKeyToAsn1(key)).getBytes()
    };
    return forge.pem.encode(msg, { maxline });
  };
  pki.privateKeyInfoToPem = function(pki2, maxline) {
    var msg = {
      type: "PRIVATE KEY",
      body: asn1.toDer(pki2).getBytes()
    };
    return forge.pem.encode(msg, { maxline });
  };
});
var require_tls = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_asn1();
  require_hmac2();
  require_md53();
  require_pem();
  require_pki();
  require_random();
  require_sha13();
  require_util33();
  var prf_TLS1 = function(secret, label, seed, length) {
    var rval = forge.util.createBuffer();
    var idx = secret.length >> 1;
    var slen = idx + (secret.length & 1);
    var s1 = secret.substr(0, slen);
    var s222 = secret.substr(idx, slen);
    var ai = forge.util.createBuffer();
    var hmac2 = forge.hmac.create();
    seed = label + seed;
    var md5itr = Math.ceil(length / 16);
    var sha1itr = Math.ceil(length / 20);
    hmac2.start("MD5", s1);
    var md5bytes = forge.util.createBuffer();
    ai.putBytes(seed);
    for (var i5 = 0;i5 < md5itr; ++i5) {
      hmac2.start(null, null);
      hmac2.update(ai.getBytes());
      ai.putBuffer(hmac2.digest());
      hmac2.start(null, null);
      hmac2.update(ai.bytes() + seed);
      md5bytes.putBuffer(hmac2.digest());
    }
    hmac2.start("SHA1", s222);
    var sha1bytes = forge.util.createBuffer();
    ai.clear();
    ai.putBytes(seed);
    for (var i5 = 0;i5 < sha1itr; ++i5) {
      hmac2.start(null, null);
      hmac2.update(ai.getBytes());
      ai.putBuffer(hmac2.digest());
      hmac2.start(null, null);
      hmac2.update(ai.bytes() + seed);
      sha1bytes.putBuffer(hmac2.digest());
    }
    rval.putBytes(forge.util.xorBytes(md5bytes.getBytes(), sha1bytes.getBytes(), length));
    return rval;
  };
  var hmac_sha1 = function(key2, seqNum, record) {
    var hmac2 = forge.hmac.create();
    hmac2.start("SHA1", key2);
    var b23 = forge.util.createBuffer();
    b23.putInt32(seqNum[0]);
    b23.putInt32(seqNum[1]);
    b23.putByte(record.type);
    b23.putByte(record.version.major);
    b23.putByte(record.version.minor);
    b23.putInt16(record.length);
    b23.putBytes(record.fragment.bytes());
    hmac2.update(b23.getBytes());
    return hmac2.digest().getBytes();
  };
  var deflate = function(c23, record, s32) {
    var rval = false;
    try {
      var bytes = c23.deflate(record.fragment.getBytes());
      record.fragment = forge.util.createBuffer(bytes);
      record.length = bytes.length;
      rval = true;
    } catch (ex) {
    }
    return rval;
  };
  var inflate = function(c23, record, s32) {
    var rval = false;
    try {
      var bytes = c23.inflate(record.fragment.getBytes());
      record.fragment = forge.util.createBuffer(bytes);
      record.length = bytes.length;
      rval = true;
    } catch (ex) {
    }
    return rval;
  };
  var readVector = function(b23, lenBytes) {
    var len = 0;
    switch (lenBytes) {
      case 1:
        len = b23.getByte();
        break;
      case 2:
        len = b23.getInt16();
        break;
      case 3:
        len = b23.getInt24();
        break;
      case 4:
        len = b23.getInt32();
        break;
    }
    return forge.util.createBuffer(b23.getBytes(len));
  };
  var writeVector = function(b23, lenBytes, v23) {
    b23.putInt(v23.length(), lenBytes << 3);
    b23.putBuffer(v23);
  };
  var tls = {};
  tls.Versions = {
    TLS_1_0: { major: 3, minor: 1 },
    TLS_1_1: { major: 3, minor: 2 },
    TLS_1_2: { major: 3, minor: 3 }
  };
  tls.SupportedVersions = [
    tls.Versions.TLS_1_1,
    tls.Versions.TLS_1_0
  ];
  tls.Version = tls.SupportedVersions[0];
  tls.MaxFragment = 16384 - 1024;
  tls.ConnectionEnd = {
    server: 0,
    client: 1
  };
  tls.PRFAlgorithm = {
    tls_prf_sha256: 0
  };
  tls.BulkCipherAlgorithm = {
    none: null,
    rc4: 0,
    des3: 1,
    aes: 2
  };
  tls.CipherType = {
    stream: 0,
    block: 1,
    aead: 2
  };
  tls.MACAlgorithm = {
    none: null,
    hmac_md5: 0,
    hmac_sha1: 1,
    hmac_sha256: 2,
    hmac_sha384: 3,
    hmac_sha512: 4
  };
  tls.CompressionMethod = {
    none: 0,
    deflate: 1
  };
  tls.ContentType = {
    change_cipher_spec: 20,
    alert: 21,
    handshake: 22,
    application_data: 23,
    heartbeat: 24
  };
  tls.HandshakeType = {
    hello_request: 0,
    client_hello: 1,
    server_hello: 2,
    certificate: 11,
    server_key_exchange: 12,
    certificate_request: 13,
    server_hello_done: 14,
    certificate_verify: 15,
    client_key_exchange: 16,
    finished: 20
  };
  tls.Alert = {};
  tls.Alert.Level = {
    warning: 1,
    fatal: 2
  };
  tls.Alert.Description = {
    close_notify: 0,
    unexpected_message: 10,
    bad_record_mac: 20,
    decryption_failed: 21,
    record_overflow: 22,
    decompression_failure: 30,
    handshake_failure: 40,
    bad_certificate: 42,
    unsupported_certificate: 43,
    certificate_revoked: 44,
    certificate_expired: 45,
    certificate_unknown: 46,
    illegal_parameter: 47,
    unknown_ca: 48,
    access_denied: 49,
    decode_error: 50,
    decrypt_error: 51,
    export_restriction: 60,
    protocol_version: 70,
    insufficient_security: 71,
    internal_error: 80,
    user_canceled: 90,
    no_renegotiation: 100
  };
  tls.HeartbeatMessageType = {
    heartbeat_request: 1,
    heartbeat_response: 2
  };
  tls.CipherSuites = {};
  tls.getCipherSuite = function(twoBytes) {
    var rval = null;
    for (var key2 in tls.CipherSuites) {
      var cs2 = tls.CipherSuites[key2];
      if (cs2.id[0] === twoBytes.charCodeAt(0) && cs2.id[1] === twoBytes.charCodeAt(1)) {
        rval = cs2;
        break;
      }
    }
    return rval;
  };
  tls.handleUnexpected = function(c23, record) {
    var ignore2 = !c23.open && c23.entity === tls.ConnectionEnd.client;
    if (!ignore2) {
      c23.error(c23, {
        message: "Unexpected message. Received TLS record out of order.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.unexpected_message
        }
      });
    }
  };
  tls.handleHelloRequest = function(c23, record, length) {
    if (!c23.handshaking && c23.handshakes > 0) {
      tls.queue(c23, tls.createAlert(c23, {
        level: tls.Alert.Level.warning,
        description: tls.Alert.Description.no_renegotiation
      }));
      tls.flush(c23);
    }
    c23.process();
  };
  tls.parseHelloMessage = function(c23, record, length) {
    var msg = null;
    var client = c23.entity === tls.ConnectionEnd.client;
    if (length < 38) {
      c23.error(c23, {
        message: client ? "Invalid ServerHello message. Message too short." : "Invalid ClientHello message. Message too short.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.illegal_parameter
        }
      });
    } else {
      var b23 = record.fragment;
      var remaining = b23.length();
      msg = {
        version: {
          major: b23.getByte(),
          minor: b23.getByte()
        },
        random: forge.util.createBuffer(b23.getBytes(32)),
        session_id: readVector(b23, 1),
        extensions: []
      };
      if (client) {
        msg.cipher_suite = b23.getBytes(2);
        msg.compression_method = b23.getByte();
      } else {
        msg.cipher_suites = readVector(b23, 2);
        msg.compression_methods = readVector(b23, 1);
      }
      remaining = length - (remaining - b23.length());
      if (remaining > 0) {
        var exts = readVector(b23, 2);
        while (exts.length() > 0) {
          msg.extensions.push({
            type: [exts.getByte(), exts.getByte()],
            data: readVector(exts, 2)
          });
        }
        if (!client) {
          for (var i5 = 0;i5 < msg.extensions.length; ++i5) {
            var ext2 = msg.extensions[i5];
            if (ext2.type[0] === 0 && ext2.type[1] === 0) {
              var snl = readVector(ext2.data, 2);
              while (snl.length() > 0) {
                var snType = snl.getByte();
                if (snType !== 0) {
                  break;
                }
                c23.session.extensions.server_name.serverNameList.push(readVector(snl, 2).getBytes());
              }
            }
          }
        }
      }
      if (c23.session.version) {
        if (msg.version.major !== c23.session.version.major || msg.version.minor !== c23.session.version.minor) {
          return c23.error(c23, {
            message: "TLS version change is disallowed during renegotiation.",
            send: true,
            alert: {
              level: tls.Alert.Level.fatal,
              description: tls.Alert.Description.protocol_version
            }
          });
        }
      }
      if (client) {
        c23.session.cipherSuite = tls.getCipherSuite(msg.cipher_suite);
      } else {
        var tmp = forge.util.createBuffer(msg.cipher_suites.bytes());
        while (tmp.length() > 0) {
          c23.session.cipherSuite = tls.getCipherSuite(tmp.getBytes(2));
          if (c23.session.cipherSuite !== null) {
            break;
          }
        }
      }
      if (c23.session.cipherSuite === null) {
        return c23.error(c23, {
          message: "No cipher suites in common.",
          send: true,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.handshake_failure
          },
          cipherSuite: forge.util.bytesToHex(msg.cipher_suite)
        });
      }
      if (client) {
        c23.session.compressionMethod = msg.compression_method;
      } else {
        c23.session.compressionMethod = tls.CompressionMethod.none;
      }
    }
    return msg;
  };
  tls.createSecurityParameters = function(c23, msg) {
    var client = c23.entity === tls.ConnectionEnd.client;
    var msgRandom = msg.random.bytes();
    var cRandom = client ? c23.session.sp.client_random : msgRandom;
    var sRandom = client ? msgRandom : tls.createRandom().getBytes();
    c23.session.sp = {
      entity: c23.entity,
      prf_algorithm: tls.PRFAlgorithm.tls_prf_sha256,
      bulk_cipher_algorithm: null,
      cipher_type: null,
      enc_key_length: null,
      block_length: null,
      fixed_iv_length: null,
      record_iv_length: null,
      mac_algorithm: null,
      mac_length: null,
      mac_key_length: null,
      compression_algorithm: c23.session.compressionMethod,
      pre_master_secret: null,
      master_secret: null,
      client_random: cRandom,
      server_random: sRandom
    };
  };
  tls.handleServerHello = function(c23, record, length) {
    var msg = tls.parseHelloMessage(c23, record, length);
    if (c23.fail) {
      return;
    }
    if (msg.version.minor <= c23.version.minor) {
      c23.version.minor = msg.version.minor;
    } else {
      return c23.error(c23, {
        message: "Incompatible TLS version.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.protocol_version
        }
      });
    }
    c23.session.version = c23.version;
    var sessionId = msg.session_id.bytes();
    if (sessionId.length > 0 && sessionId === c23.session.id) {
      c23.expect = SCC;
      c23.session.resuming = true;
      c23.session.sp.server_random = msg.random.bytes();
    } else {
      c23.expect = SCE;
      c23.session.resuming = false;
      tls.createSecurityParameters(c23, msg);
    }
    c23.session.id = sessionId;
    c23.process();
  };
  tls.handleClientHello = function(c23, record, length) {
    var msg = tls.parseHelloMessage(c23, record, length);
    if (c23.fail) {
      return;
    }
    var sessionId = msg.session_id.bytes();
    var session = null;
    if (c23.sessionCache) {
      session = c23.sessionCache.getSession(sessionId);
      if (session === null) {
        sessionId = "";
      } else if (session.version.major !== msg.version.major || session.version.minor > msg.version.minor) {
        session = null;
        sessionId = "";
      }
    }
    if (sessionId.length === 0) {
      sessionId = forge.random.getBytes(32);
    }
    c23.session.id = sessionId;
    c23.session.clientHelloVersion = msg.version;
    c23.session.sp = {};
    if (session) {
      c23.version = c23.session.version = session.version;
      c23.session.sp = session.sp;
    } else {
      var version3;
      for (var i5 = 1;i5 < tls.SupportedVersions.length; ++i5) {
        version3 = tls.SupportedVersions[i5];
        if (version3.minor <= msg.version.minor) {
          break;
        }
      }
      c23.version = { major: version3.major, minor: version3.minor };
      c23.session.version = c23.version;
    }
    if (session !== null) {
      c23.expect = CCC;
      c23.session.resuming = true;
      c23.session.sp.client_random = msg.random.bytes();
    } else {
      c23.expect = c23.verifyClient !== false ? CCE : CKE;
      c23.session.resuming = false;
      tls.createSecurityParameters(c23, msg);
    }
    c23.open = true;
    tls.queue(c23, tls.createRecord(c23, {
      type: tls.ContentType.handshake,
      data: tls.createServerHello(c23)
    }));
    if (c23.session.resuming) {
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.change_cipher_spec,
        data: tls.createChangeCipherSpec()
      }));
      c23.state.pending = tls.createConnectionState(c23);
      c23.state.current.write = c23.state.pending.write;
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.handshake,
        data: tls.createFinished(c23)
      }));
    } else {
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.handshake,
        data: tls.createCertificate(c23)
      }));
      if (!c23.fail) {
        tls.queue(c23, tls.createRecord(c23, {
          type: tls.ContentType.handshake,
          data: tls.createServerKeyExchange(c23)
        }));
        if (c23.verifyClient !== false) {
          tls.queue(c23, tls.createRecord(c23, {
            type: tls.ContentType.handshake,
            data: tls.createCertificateRequest(c23)
          }));
        }
        tls.queue(c23, tls.createRecord(c23, {
          type: tls.ContentType.handshake,
          data: tls.createServerHelloDone(c23)
        }));
      }
    }
    tls.flush(c23);
    c23.process();
  };
  tls.handleCertificate = function(c23, record, length) {
    if (length < 3) {
      return c23.error(c23, {
        message: "Invalid Certificate message. Message too short.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.illegal_parameter
        }
      });
    }
    var b23 = record.fragment;
    var msg = {
      certificate_list: readVector(b23, 3)
    };
    var cert, asn1;
    var certs = [];
    try {
      while (msg.certificate_list.length() > 0) {
        cert = readVector(msg.certificate_list, 3);
        asn1 = forge.asn1.fromDer(cert);
        cert = forge.pki.certificateFromAsn1(asn1, true);
        certs.push(cert);
      }
    } catch (ex) {
      return c23.error(c23, {
        message: "Could not parse certificate list.",
        cause: ex,
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.bad_certificate
        }
      });
    }
    var client = c23.entity === tls.ConnectionEnd.client;
    if ((client || c23.verifyClient === true) && certs.length === 0) {
      c23.error(c23, {
        message: client ? "No server certificate provided." : "No client certificate provided.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.illegal_parameter
        }
      });
    } else if (certs.length === 0) {
      c23.expect = client ? SKE : CKE;
    } else {
      if (client) {
        c23.session.serverCertificate = certs[0];
      } else {
        c23.session.clientCertificate = certs[0];
      }
      if (tls.verifyCertificateChain(c23, certs)) {
        c23.expect = client ? SKE : CKE;
      }
    }
    c23.process();
  };
  tls.handleServerKeyExchange = function(c23, record, length) {
    if (length > 0) {
      return c23.error(c23, {
        message: "Invalid key parameters. Only RSA is supported.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.unsupported_certificate
        }
      });
    }
    c23.expect = SCR;
    c23.process();
  };
  tls.handleClientKeyExchange = function(c23, record, length) {
    if (length < 48) {
      return c23.error(c23, {
        message: "Invalid key parameters. Only RSA is supported.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.unsupported_certificate
        }
      });
    }
    var b23 = record.fragment;
    var msg = {
      enc_pre_master_secret: readVector(b23, 2).getBytes()
    };
    var privateKey = null;
    if (c23.getPrivateKey) {
      try {
        privateKey = c23.getPrivateKey(c23, c23.session.serverCertificate);
        privateKey = forge.pki.privateKeyFromPem(privateKey);
      } catch (ex) {
        c23.error(c23, {
          message: "Could not get private key.",
          cause: ex,
          send: true,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.internal_error
          }
        });
      }
    }
    if (privateKey === null) {
      return c23.error(c23, {
        message: "No private key set.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.internal_error
        }
      });
    }
    try {
      var sp = c23.session.sp;
      sp.pre_master_secret = privateKey.decrypt(msg.enc_pre_master_secret);
      var version3 = c23.session.clientHelloVersion;
      if (version3.major !== sp.pre_master_secret.charCodeAt(0) || version3.minor !== sp.pre_master_secret.charCodeAt(1)) {
        throw new Error("TLS version rollback attack detected.");
      }
    } catch (ex) {
      sp.pre_master_secret = forge.random.getBytes(48);
    }
    c23.expect = CCC;
    if (c23.session.clientCertificate !== null) {
      c23.expect = CCV;
    }
    c23.process();
  };
  tls.handleCertificateRequest = function(c23, record, length) {
    if (length < 3) {
      return c23.error(c23, {
        message: "Invalid CertificateRequest. Message too short.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.illegal_parameter
        }
      });
    }
    var b23 = record.fragment;
    var msg = {
      certificate_types: readVector(b23, 1),
      certificate_authorities: readVector(b23, 2)
    };
    c23.session.certificateRequest = msg;
    c23.expect = SHD;
    c23.process();
  };
  tls.handleCertificateVerify = function(c23, record, length) {
    if (length < 2) {
      return c23.error(c23, {
        message: "Invalid CertificateVerify. Message too short.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.illegal_parameter
        }
      });
    }
    var b23 = record.fragment;
    b23.read -= 4;
    var msgBytes = b23.bytes();
    b23.read += 4;
    var msg = {
      signature: readVector(b23, 2).getBytes()
    };
    var verify = forge.util.createBuffer();
    verify.putBuffer(c23.session.md5.digest());
    verify.putBuffer(c23.session.sha1.digest());
    verify = verify.getBytes();
    try {
      var cert = c23.session.clientCertificate;
      if (!cert.publicKey.verify(verify, msg.signature, "NONE")) {
        throw new Error("CertificateVerify signature does not match.");
      }
      c23.session.md5.update(msgBytes);
      c23.session.sha1.update(msgBytes);
    } catch (ex) {
      return c23.error(c23, {
        message: "Bad signature in CertificateVerify.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.handshake_failure
        }
      });
    }
    c23.expect = CCC;
    c23.process();
  };
  tls.handleServerHelloDone = function(c23, record, length) {
    if (length > 0) {
      return c23.error(c23, {
        message: "Invalid ServerHelloDone message. Invalid length.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.record_overflow
        }
      });
    }
    if (c23.serverCertificate === null) {
      var error = {
        message: "No server certificate provided. Not enough security.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.insufficient_security
        }
      };
      var depth2 = 0;
      var ret = c23.verify(c23, error.alert.description, depth2, []);
      if (ret !== true) {
        if (ret || ret === 0) {
          if (typeof ret === "object" && !forge.util.isArray(ret)) {
            if (ret.message) {
              error.message = ret.message;
            }
            if (ret.alert) {
              error.alert.description = ret.alert;
            }
          } else if (typeof ret === "number") {
            error.alert.description = ret;
          }
        }
        return c23.error(c23, error);
      }
    }
    if (c23.session.certificateRequest !== null) {
      record = tls.createRecord(c23, {
        type: tls.ContentType.handshake,
        data: tls.createCertificate(c23)
      });
      tls.queue(c23, record);
    }
    record = tls.createRecord(c23, {
      type: tls.ContentType.handshake,
      data: tls.createClientKeyExchange(c23)
    });
    tls.queue(c23, record);
    c23.expect = SER;
    var callback = function(c32, signature) {
      if (c32.session.certificateRequest !== null && c32.session.clientCertificate !== null) {
        tls.queue(c32, tls.createRecord(c32, {
          type: tls.ContentType.handshake,
          data: tls.createCertificateVerify(c32, signature)
        }));
      }
      tls.queue(c32, tls.createRecord(c32, {
        type: tls.ContentType.change_cipher_spec,
        data: tls.createChangeCipherSpec()
      }));
      c32.state.pending = tls.createConnectionState(c32);
      c32.state.current.write = c32.state.pending.write;
      tls.queue(c32, tls.createRecord(c32, {
        type: tls.ContentType.handshake,
        data: tls.createFinished(c32)
      }));
      c32.expect = SCC;
      tls.flush(c32);
      c32.process();
    };
    if (c23.session.certificateRequest === null || c23.session.clientCertificate === null) {
      return callback(c23, null);
    }
    tls.getClientSignature(c23, callback);
  };
  tls.handleChangeCipherSpec = function(c23, record) {
    if (record.fragment.getByte() !== 1) {
      return c23.error(c23, {
        message: "Invalid ChangeCipherSpec message received.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.illegal_parameter
        }
      });
    }
    var client = c23.entity === tls.ConnectionEnd.client;
    if (c23.session.resuming && client || !c23.session.resuming && !client) {
      c23.state.pending = tls.createConnectionState(c23);
    }
    c23.state.current.read = c23.state.pending.read;
    if (!c23.session.resuming && client || c23.session.resuming && !client) {
      c23.state.pending = null;
    }
    c23.expect = client ? SFI : CFI;
    c23.process();
  };
  tls.handleFinished = function(c23, record, length) {
    var b23 = record.fragment;
    b23.read -= 4;
    var msgBytes = b23.bytes();
    b23.read += 4;
    var vd = record.fragment.getBytes();
    b23 = forge.util.createBuffer();
    b23.putBuffer(c23.session.md5.digest());
    b23.putBuffer(c23.session.sha1.digest());
    var client = c23.entity === tls.ConnectionEnd.client;
    var label = client ? "server finished" : "client finished";
    var sp = c23.session.sp;
    var vdl = 12;
    var prf = prf_TLS1;
    b23 = prf(sp.master_secret, label, b23.getBytes(), vdl);
    if (b23.getBytes() !== vd) {
      return c23.error(c23, {
        message: "Invalid verify_data in Finished message.",
        send: true,
        alert: {
          level: tls.Alert.Level.fatal,
          description: tls.Alert.Description.decrypt_error
        }
      });
    }
    c23.session.md5.update(msgBytes);
    c23.session.sha1.update(msgBytes);
    if (c23.session.resuming && client || !c23.session.resuming && !client) {
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.change_cipher_spec,
        data: tls.createChangeCipherSpec()
      }));
      c23.state.current.write = c23.state.pending.write;
      c23.state.pending = null;
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.handshake,
        data: tls.createFinished(c23)
      }));
    }
    c23.expect = client ? SAD : CAD;
    c23.handshaking = false;
    ++c23.handshakes;
    c23.peerCertificate = client ? c23.session.serverCertificate : c23.session.clientCertificate;
    tls.flush(c23);
    c23.isConnected = true;
    c23.connected(c23);
    c23.process();
  };
  tls.handleAlert = function(c23, record) {
    var b23 = record.fragment;
    var alert = {
      level: b23.getByte(),
      description: b23.getByte()
    };
    var msg;
    switch (alert.description) {
      case tls.Alert.Description.close_notify:
        msg = "Connection closed.";
        break;
      case tls.Alert.Description.unexpected_message:
        msg = "Unexpected message.";
        break;
      case tls.Alert.Description.bad_record_mac:
        msg = "Bad record MAC.";
        break;
      case tls.Alert.Description.decryption_failed:
        msg = "Decryption failed.";
        break;
      case tls.Alert.Description.record_overflow:
        msg = "Record overflow.";
        break;
      case tls.Alert.Description.decompression_failure:
        msg = "Decompression failed.";
        break;
      case tls.Alert.Description.handshake_failure:
        msg = "Handshake failure.";
        break;
      case tls.Alert.Description.bad_certificate:
        msg = "Bad certificate.";
        break;
      case tls.Alert.Description.unsupported_certificate:
        msg = "Unsupported certificate.";
        break;
      case tls.Alert.Description.certificate_revoked:
        msg = "Certificate revoked.";
        break;
      case tls.Alert.Description.certificate_expired:
        msg = "Certificate expired.";
        break;
      case tls.Alert.Description.certificate_unknown:
        msg = "Certificate unknown.";
        break;
      case tls.Alert.Description.illegal_parameter:
        msg = "Illegal parameter.";
        break;
      case tls.Alert.Description.unknown_ca:
        msg = "Unknown certificate authority.";
        break;
      case tls.Alert.Description.access_denied:
        msg = "Access denied.";
        break;
      case tls.Alert.Description.decode_error:
        msg = "Decode error.";
        break;
      case tls.Alert.Description.decrypt_error:
        msg = "Decrypt error.";
        break;
      case tls.Alert.Description.export_restriction:
        msg = "Export restriction.";
        break;
      case tls.Alert.Description.protocol_version:
        msg = "Unsupported protocol version.";
        break;
      case tls.Alert.Description.insufficient_security:
        msg = "Insufficient security.";
        break;
      case tls.Alert.Description.internal_error:
        msg = "Internal error.";
        break;
      case tls.Alert.Description.user_canceled:
        msg = "User canceled.";
        break;
      case tls.Alert.Description.no_renegotiation:
        msg = "Renegotiation not supported.";
        break;
      default:
        msg = "Unknown error.";
        break;
    }
    if (alert.description === tls.Alert.Description.close_notify) {
      return c23.close();
    }
    c23.error(c23, {
      message: msg,
      send: false,
      origin: c23.entity === tls.ConnectionEnd.client ? "server" : "client",
      alert
    });
    c23.process();
  };
  tls.handleHandshake = function(c23, record) {
    var b23 = record.fragment;
    var type2 = b23.getByte();
    var length = b23.getInt24();
    if (length > b23.length()) {
      c23.fragmented = record;
      record.fragment = forge.util.createBuffer();
      b23.read -= 4;
      return c23.process();
    }
    c23.fragmented = null;
    b23.read -= 4;
    var bytes = b23.bytes(length + 4);
    b23.read += 4;
    if (type2 in hsTable[c23.entity][c23.expect]) {
      if (c23.entity === tls.ConnectionEnd.server && !c23.open && !c23.fail) {
        c23.handshaking = true;
        c23.session = {
          version: null,
          extensions: {
            server_name: {
              serverNameList: []
            }
          },
          cipherSuite: null,
          compressionMethod: null,
          serverCertificate: null,
          clientCertificate: null,
          md5: forge.md.md5.create(),
          sha1: forge.md.sha1.create()
        };
      }
      if (type2 !== tls.HandshakeType.hello_request && type2 !== tls.HandshakeType.certificate_verify && type2 !== tls.HandshakeType.finished) {
        c23.session.md5.update(bytes);
        c23.session.sha1.update(bytes);
      }
      hsTable[c23.entity][c23.expect][type2](c23, record, length);
    } else {
      tls.handleUnexpected(c23, record);
    }
  };
  tls.handleApplicationData = function(c23, record) {
    c23.data.putBuffer(record.fragment);
    c23.dataReady(c23);
    c23.process();
  };
  tls.handleHeartbeat = function(c23, record) {
    var b23 = record.fragment;
    var type2 = b23.getByte();
    var length = b23.getInt16();
    var payload = b23.getBytes(length);
    if (type2 === tls.HeartbeatMessageType.heartbeat_request) {
      if (c23.handshaking || length > payload.length) {
        return c23.process();
      }
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.heartbeat,
        data: tls.createHeartbeat(tls.HeartbeatMessageType.heartbeat_response, payload)
      }));
      tls.flush(c23);
    } else if (type2 === tls.HeartbeatMessageType.heartbeat_response) {
      if (payload !== c23.expectedHeartbeatPayload) {
        return c23.process();
      }
      if (c23.heartbeatReceived) {
        c23.heartbeatReceived(c23, forge.util.createBuffer(payload));
      }
    }
    c23.process();
  };
  var SHE = 0;
  var SCE = 1;
  var SKE = 2;
  var SCR = 3;
  var SHD = 4;
  var SCC = 5;
  var SFI = 6;
  var SAD = 7;
  var SER = 8;
  var CHE = 0;
  var CCE = 1;
  var CKE = 2;
  var CCV = 3;
  var CCC = 4;
  var CFI = 5;
  var CAD = 6;
  var __ = tls.handleUnexpected;
  var R0 = tls.handleChangeCipherSpec;
  var R1 = tls.handleAlert;
  var R222 = tls.handleHandshake;
  var R3 = tls.handleApplicationData;
  var R4 = tls.handleHeartbeat;
  var ctTable = [];
  ctTable[tls.ConnectionEnd.client] = [
    [__, R1, R222, __, R4],
    [__, R1, R222, __, R4],
    [__, R1, R222, __, R4],
    [__, R1, R222, __, R4],
    [__, R1, R222, __, R4],
    [R0, R1, __, __, R4],
    [__, R1, R222, __, R4],
    [__, R1, R222, R3, R4],
    [__, R1, R222, __, R4]
  ];
  ctTable[tls.ConnectionEnd.server] = [
    [__, R1, R222, __, R4],
    [__, R1, R222, __, R4],
    [__, R1, R222, __, R4],
    [__, R1, R222, __, R4],
    [R0, R1, __, __, R4],
    [__, R1, R222, __, R4],
    [__, R1, R222, R3, R4],
    [__, R1, R222, __, R4]
  ];
  var H0 = tls.handleHelloRequest;
  var H1 = tls.handleServerHello;
  var H23 = tls.handleCertificate;
  var H32 = tls.handleServerKeyExchange;
  var H4 = tls.handleCertificateRequest;
  var H5 = tls.handleServerHelloDone;
  var H6 = tls.handleFinished;
  var hsTable = [];
  hsTable[tls.ConnectionEnd.client] = [
    [__, __, H1, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __],
    [H0, __, __, __, __, __, __, __, __, __, __, H23, H32, H4, H5, __, __, __, __, __, __],
    [H0, __, __, __, __, __, __, __, __, __, __, __, H32, H4, H5, __, __, __, __, __, __],
    [H0, __, __, __, __, __, __, __, __, __, __, __, __, H4, H5, __, __, __, __, __, __],
    [H0, __, __, __, __, __, __, __, __, __, __, __, __, __, H5, __, __, __, __, __, __],
    [H0, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __],
    [H0, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, H6],
    [H0, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __],
    [H0, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __]
  ];
  var H7 = tls.handleClientHello;
  var H8 = tls.handleClientKeyExchange;
  var H9 = tls.handleCertificateVerify;
  hsTable[tls.ConnectionEnd.server] = [
    [__, H7, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __],
    [__, __, __, __, __, __, __, __, __, __, __, H23, __, __, __, __, __, __, __, __, __],
    [__, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, H8, __, __, __, __],
    [__, __, __, __, __, __, __, __, __, __, __, __, __, __, __, H9, __, __, __, __, __],
    [__, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __],
    [__, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, H6],
    [__, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __],
    [__, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __, __]
  ];
  tls.generateKeys = function(c23, sp) {
    var prf = prf_TLS1;
    var random = sp.client_random + sp.server_random;
    if (!c23.session.resuming) {
      sp.master_secret = prf(sp.pre_master_secret, "master secret", random, 48).bytes();
      sp.pre_master_secret = null;
    }
    random = sp.server_random + sp.client_random;
    var length = 2 * sp.mac_key_length + 2 * sp.enc_key_length;
    var tls10 = c23.version.major === tls.Versions.TLS_1_0.major && c23.version.minor === tls.Versions.TLS_1_0.minor;
    if (tls10) {
      length += 2 * sp.fixed_iv_length;
    }
    var km = prf(sp.master_secret, "key expansion", random, length);
    var rval = {
      client_write_MAC_key: km.getBytes(sp.mac_key_length),
      server_write_MAC_key: km.getBytes(sp.mac_key_length),
      client_write_key: km.getBytes(sp.enc_key_length),
      server_write_key: km.getBytes(sp.enc_key_length)
    };
    if (tls10) {
      rval.client_write_IV = km.getBytes(sp.fixed_iv_length);
      rval.server_write_IV = km.getBytes(sp.fixed_iv_length);
    }
    return rval;
  };
  tls.createConnectionState = function(c23) {
    var client = c23.entity === tls.ConnectionEnd.client;
    var createMode = function() {
      var mode = {
        sequenceNumber: [0, 0],
        macKey: null,
        macLength: 0,
        macFunction: null,
        cipherState: null,
        cipherFunction: function(record) {
          return true;
        },
        compressionState: null,
        compressFunction: function(record) {
          return true;
        },
        updateSequenceNumber: function() {
          if (mode.sequenceNumber[1] === 4294967295) {
            mode.sequenceNumber[1] = 0;
            ++mode.sequenceNumber[0];
          } else {
            ++mode.sequenceNumber[1];
          }
        }
      };
      return mode;
    };
    var state = {
      read: createMode(),
      write: createMode()
    };
    state.read.update = function(c32, record) {
      if (!state.read.cipherFunction(record, state.read)) {
        c32.error(c32, {
          message: "Could not decrypt record or bad MAC.",
          send: true,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.bad_record_mac
          }
        });
      } else if (!state.read.compressFunction(c32, record, state.read)) {
        c32.error(c32, {
          message: "Could not decompress record.",
          send: true,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.decompression_failure
          }
        });
      }
      return !c32.fail;
    };
    state.write.update = function(c32, record) {
      if (!state.write.compressFunction(c32, record, state.write)) {
        c32.error(c32, {
          message: "Could not compress record.",
          send: false,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.internal_error
          }
        });
      } else if (!state.write.cipherFunction(record, state.write)) {
        c32.error(c32, {
          message: "Could not encrypt record.",
          send: false,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.internal_error
          }
        });
      }
      return !c32.fail;
    };
    if (c23.session) {
      var sp = c23.session.sp;
      c23.session.cipherSuite.initSecurityParameters(sp);
      sp.keys = tls.generateKeys(c23, sp);
      state.read.macKey = client ? sp.keys.server_write_MAC_key : sp.keys.client_write_MAC_key;
      state.write.macKey = client ? sp.keys.client_write_MAC_key : sp.keys.server_write_MAC_key;
      c23.session.cipherSuite.initConnectionState(state, c23, sp);
      switch (sp.compression_algorithm) {
        case tls.CompressionMethod.none:
          break;
        case tls.CompressionMethod.deflate:
          state.read.compressFunction = inflate;
          state.write.compressFunction = deflate;
          break;
        default:
          throw new Error("Unsupported compression algorithm.");
      }
    }
    return state;
  };
  tls.createRandom = function() {
    var d5 = new Date;
    var utc = +d5 + d5.getTimezoneOffset() * 60000;
    var rval = forge.util.createBuffer();
    rval.putInt32(utc);
    rval.putBytes(forge.random.getBytes(28));
    return rval;
  };
  tls.createRecord = function(c23, options23) {
    if (!options23.data) {
      return null;
    }
    var record = {
      type: options23.type,
      version: {
        major: c23.version.major,
        minor: c23.version.minor
      },
      length: options23.data.length(),
      fragment: options23.data
    };
    return record;
  };
  tls.createAlert = function(c23, alert) {
    var b23 = forge.util.createBuffer();
    b23.putByte(alert.level);
    b23.putByte(alert.description);
    return tls.createRecord(c23, {
      type: tls.ContentType.alert,
      data: b23
    });
  };
  tls.createClientHello = function(c23) {
    c23.session.clientHelloVersion = {
      major: c23.version.major,
      minor: c23.version.minor
    };
    var cipherSuites = forge.util.createBuffer();
    for (var i5 = 0;i5 < c23.cipherSuites.length; ++i5) {
      var cs2 = c23.cipherSuites[i5];
      cipherSuites.putByte(cs2.id[0]);
      cipherSuites.putByte(cs2.id[1]);
    }
    var cSuites = cipherSuites.length();
    var compressionMethods = forge.util.createBuffer();
    compressionMethods.putByte(tls.CompressionMethod.none);
    var cMethods = compressionMethods.length();
    var extensions = forge.util.createBuffer();
    if (c23.virtualHost) {
      var ext2 = forge.util.createBuffer();
      ext2.putByte(0);
      ext2.putByte(0);
      var serverName = forge.util.createBuffer();
      serverName.putByte(0);
      writeVector(serverName, 2, forge.util.createBuffer(c23.virtualHost));
      var snList = forge.util.createBuffer();
      writeVector(snList, 2, serverName);
      writeVector(ext2, 2, snList);
      extensions.putBuffer(ext2);
    }
    var extLength = extensions.length();
    if (extLength > 0) {
      extLength += 2;
    }
    var sessionId = c23.session.id;
    var length = sessionId.length + 1 + 2 + 4 + 28 + 2 + cSuites + 1 + cMethods + extLength;
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.client_hello);
    rval.putInt24(length);
    rval.putByte(c23.version.major);
    rval.putByte(c23.version.minor);
    rval.putBytes(c23.session.sp.client_random);
    writeVector(rval, 1, forge.util.createBuffer(sessionId));
    writeVector(rval, 2, cipherSuites);
    writeVector(rval, 1, compressionMethods);
    if (extLength > 0) {
      writeVector(rval, 2, extensions);
    }
    return rval;
  };
  tls.createServerHello = function(c23) {
    var sessionId = c23.session.id;
    var length = sessionId.length + 1 + 2 + 4 + 28 + 2 + 1;
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.server_hello);
    rval.putInt24(length);
    rval.putByte(c23.version.major);
    rval.putByte(c23.version.minor);
    rval.putBytes(c23.session.sp.server_random);
    writeVector(rval, 1, forge.util.createBuffer(sessionId));
    rval.putByte(c23.session.cipherSuite.id[0]);
    rval.putByte(c23.session.cipherSuite.id[1]);
    rval.putByte(c23.session.compressionMethod);
    return rval;
  };
  tls.createCertificate = function(c23) {
    var client = c23.entity === tls.ConnectionEnd.client;
    var cert = null;
    if (c23.getCertificate) {
      var hint;
      if (client) {
        hint = c23.session.certificateRequest;
      } else {
        hint = c23.session.extensions.server_name.serverNameList;
      }
      cert = c23.getCertificate(c23, hint);
    }
    var certList = forge.util.createBuffer();
    if (cert !== null) {
      try {
        if (!forge.util.isArray(cert)) {
          cert = [cert];
        }
        var asn1 = null;
        for (var i5 = 0;i5 < cert.length; ++i5) {
          var msg = forge.pem.decode(cert[i5])[0];
          if (msg.type !== "CERTIFICATE" && msg.type !== "X509 CERTIFICATE" && msg.type !== "TRUSTED CERTIFICATE") {
            var error = new Error("Could not convert certificate from PEM; PEM " + 'header type is not "CERTIFICATE", "X509 CERTIFICATE", or ' + '"TRUSTED CERTIFICATE".');
            error.headerType = msg.type;
            throw error;
          }
          if (msg.procType && msg.procType.type === "ENCRYPTED") {
            throw new Error("Could not convert certificate from PEM; PEM is encrypted.");
          }
          var der = forge.util.createBuffer(msg.body);
          if (asn1 === null) {
            asn1 = forge.asn1.fromDer(der.bytes(), false);
          }
          var certBuffer = forge.util.createBuffer();
          writeVector(certBuffer, 3, der);
          certList.putBuffer(certBuffer);
        }
        cert = forge.pki.certificateFromAsn1(asn1);
        if (client) {
          c23.session.clientCertificate = cert;
        } else {
          c23.session.serverCertificate = cert;
        }
      } catch (ex) {
        return c23.error(c23, {
          message: "Could not send certificate list.",
          cause: ex,
          send: true,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.bad_certificate
          }
        });
      }
    }
    var length = 3 + certList.length();
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.certificate);
    rval.putInt24(length);
    writeVector(rval, 3, certList);
    return rval;
  };
  tls.createClientKeyExchange = function(c23) {
    var b23 = forge.util.createBuffer();
    b23.putByte(c23.session.clientHelloVersion.major);
    b23.putByte(c23.session.clientHelloVersion.minor);
    b23.putBytes(forge.random.getBytes(46));
    var sp = c23.session.sp;
    sp.pre_master_secret = b23.getBytes();
    var key2 = c23.session.serverCertificate.publicKey;
    b23 = key2.encrypt(sp.pre_master_secret);
    var length = b23.length + 2;
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.client_key_exchange);
    rval.putInt24(length);
    rval.putInt16(b23.length);
    rval.putBytes(b23);
    return rval;
  };
  tls.createServerKeyExchange = function(c23) {
    var length = 0;
    var rval = forge.util.createBuffer();
    if (length > 0) {
      rval.putByte(tls.HandshakeType.server_key_exchange);
      rval.putInt24(length);
    }
    return rval;
  };
  tls.getClientSignature = function(c23, callback) {
    var b23 = forge.util.createBuffer();
    b23.putBuffer(c23.session.md5.digest());
    b23.putBuffer(c23.session.sha1.digest());
    b23 = b23.getBytes();
    c23.getSignature = c23.getSignature || function(c32, b32, callback2) {
      var privateKey = null;
      if (c32.getPrivateKey) {
        try {
          privateKey = c32.getPrivateKey(c32, c32.session.clientCertificate);
          privateKey = forge.pki.privateKeyFromPem(privateKey);
        } catch (ex) {
          c32.error(c32, {
            message: "Could not get private key.",
            cause: ex,
            send: true,
            alert: {
              level: tls.Alert.Level.fatal,
              description: tls.Alert.Description.internal_error
            }
          });
        }
      }
      if (privateKey === null) {
        c32.error(c32, {
          message: "No private key set.",
          send: true,
          alert: {
            level: tls.Alert.Level.fatal,
            description: tls.Alert.Description.internal_error
          }
        });
      } else {
        b32 = privateKey.sign(b32, null);
      }
      callback2(c32, b32);
    };
    c23.getSignature(c23, b23, callback);
  };
  tls.createCertificateVerify = function(c23, signature) {
    var length = signature.length + 2;
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.certificate_verify);
    rval.putInt24(length);
    rval.putInt16(signature.length);
    rval.putBytes(signature);
    return rval;
  };
  tls.createCertificateRequest = function(c23) {
    var certTypes = forge.util.createBuffer();
    certTypes.putByte(1);
    var cAs = forge.util.createBuffer();
    for (var key2 in c23.caStore.certs) {
      var cert = c23.caStore.certs[key2];
      var dn = forge.pki.distinguishedNameToAsn1(cert.subject);
      var byteBuffer = forge.asn1.toDer(dn);
      cAs.putInt16(byteBuffer.length());
      cAs.putBuffer(byteBuffer);
    }
    var length = 1 + certTypes.length() + 2 + cAs.length();
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.certificate_request);
    rval.putInt24(length);
    writeVector(rval, 1, certTypes);
    writeVector(rval, 2, cAs);
    return rval;
  };
  tls.createServerHelloDone = function(c23) {
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.server_hello_done);
    rval.putInt24(0);
    return rval;
  };
  tls.createChangeCipherSpec = function() {
    var rval = forge.util.createBuffer();
    rval.putByte(1);
    return rval;
  };
  tls.createFinished = function(c23) {
    var b23 = forge.util.createBuffer();
    b23.putBuffer(c23.session.md5.digest());
    b23.putBuffer(c23.session.sha1.digest());
    var client = c23.entity === tls.ConnectionEnd.client;
    var sp = c23.session.sp;
    var vdl = 12;
    var prf = prf_TLS1;
    var label = client ? "client finished" : "server finished";
    b23 = prf(sp.master_secret, label, b23.getBytes(), vdl);
    var rval = forge.util.createBuffer();
    rval.putByte(tls.HandshakeType.finished);
    rval.putInt24(b23.length());
    rval.putBuffer(b23);
    return rval;
  };
  tls.createHeartbeat = function(type2, payload, payloadLength) {
    if (typeof payloadLength === "undefined") {
      payloadLength = payload.length;
    }
    var rval = forge.util.createBuffer();
    rval.putByte(type2);
    rval.putInt16(payloadLength);
    rval.putBytes(payload);
    var plaintextLength = rval.length();
    var paddingLength = Math.max(16, plaintextLength - payloadLength - 3);
    rval.putBytes(forge.random.getBytes(paddingLength));
    return rval;
  };
  tls.queue = function(c23, record) {
    if (!record) {
      return;
    }
    if (record.fragment.length() === 0) {
      if (record.type === tls.ContentType.handshake || record.type === tls.ContentType.alert || record.type === tls.ContentType.change_cipher_spec) {
        return;
      }
    }
    if (record.type === tls.ContentType.handshake) {
      var bytes = record.fragment.bytes();
      c23.session.md5.update(bytes);
      c23.session.sha1.update(bytes);
      bytes = null;
    }
    var records;
    if (record.fragment.length() <= tls.MaxFragment) {
      records = [record];
    } else {
      records = [];
      var data2 = record.fragment.bytes();
      while (data2.length > tls.MaxFragment) {
        records.push(tls.createRecord(c23, {
          type: record.type,
          data: forge.util.createBuffer(data2.slice(0, tls.MaxFragment))
        }));
        data2 = data2.slice(tls.MaxFragment);
      }
      if (data2.length > 0) {
        records.push(tls.createRecord(c23, {
          type: record.type,
          data: forge.util.createBuffer(data2)
        }));
      }
    }
    for (var i5 = 0;i5 < records.length && !c23.fail; ++i5) {
      var rec = records[i5];
      var s32 = c23.state.current.write;
      if (s32.update(c23, rec)) {
        c23.records.push(rec);
      }
    }
  };
  tls.flush = function(c23) {
    for (var i5 = 0;i5 < c23.records.length; ++i5) {
      var record = c23.records[i5];
      c23.tlsData.putByte(record.type);
      c23.tlsData.putByte(record.version.major);
      c23.tlsData.putByte(record.version.minor);
      c23.tlsData.putInt16(record.fragment.length());
      c23.tlsData.putBuffer(c23.records[i5].fragment);
    }
    c23.records = [];
    return c23.tlsDataReady(c23);
  };
  var _certErrorToAlertDesc = function(error) {
    switch (error) {
      case true:
        return true;
      case forge.pki.certificateError.bad_certificate:
        return tls.Alert.Description.bad_certificate;
      case forge.pki.certificateError.unsupported_certificate:
        return tls.Alert.Description.unsupported_certificate;
      case forge.pki.certificateError.certificate_revoked:
        return tls.Alert.Description.certificate_revoked;
      case forge.pki.certificateError.certificate_expired:
        return tls.Alert.Description.certificate_expired;
      case forge.pki.certificateError.certificate_unknown:
        return tls.Alert.Description.certificate_unknown;
      case forge.pki.certificateError.unknown_ca:
        return tls.Alert.Description.unknown_ca;
      default:
        return tls.Alert.Description.bad_certificate;
    }
  };
  var _alertDescToCertError = function(desc) {
    switch (desc) {
      case true:
        return true;
      case tls.Alert.Description.bad_certificate:
        return forge.pki.certificateError.bad_certificate;
      case tls.Alert.Description.unsupported_certificate:
        return forge.pki.certificateError.unsupported_certificate;
      case tls.Alert.Description.certificate_revoked:
        return forge.pki.certificateError.certificate_revoked;
      case tls.Alert.Description.certificate_expired:
        return forge.pki.certificateError.certificate_expired;
      case tls.Alert.Description.certificate_unknown:
        return forge.pki.certificateError.certificate_unknown;
      case tls.Alert.Description.unknown_ca:
        return forge.pki.certificateError.unknown_ca;
      default:
        return forge.pki.certificateError.bad_certificate;
    }
  };
  tls.verifyCertificateChain = function(c23, chain2) {
    try {
      var options23 = {};
      for (var key2 in c23.verifyOptions) {
        options23[key2] = c23.verifyOptions[key2];
      }
      options23.verify = function(vfd, depth2, chain22) {
        var desc = _certErrorToAlertDesc(vfd);
        var ret = c23.verify(c23, vfd, depth2, chain22);
        if (ret !== true) {
          if (typeof ret === "object" && !forge.util.isArray(ret)) {
            var error = new Error("The application rejected the certificate.");
            error.send = true;
            error.alert = {
              level: tls.Alert.Level.fatal,
              description: tls.Alert.Description.bad_certificate
            };
            if (ret.message) {
              error.message = ret.message;
            }
            if (ret.alert) {
              error.alert.description = ret.alert;
            }
            throw error;
          }
          if (ret !== vfd) {
            ret = _alertDescToCertError(ret);
          }
        }
        return ret;
      };
      forge.pki.verifyCertificateChain(c23.caStore, chain2, options23);
    } catch (ex) {
      var err22 = ex;
      if (typeof err22 !== "object" || forge.util.isArray(err22)) {
        err22 = {
          send: true,
          alert: {
            level: tls.Alert.Level.fatal,
            description: _certErrorToAlertDesc(ex)
          }
        };
      }
      if (!("send" in err22)) {
        err22.send = true;
      }
      if (!("alert" in err22)) {
        err22.alert = {
          level: tls.Alert.Level.fatal,
          description: _certErrorToAlertDesc(err22.error)
        };
      }
      c23.error(c23, err22);
    }
    return !c23.fail;
  };
  tls.createSessionCache = function(cache, capacity) {
    var rval = null;
    if (cache && cache.getSession && cache.setSession && cache.order) {
      rval = cache;
    } else {
      rval = {};
      rval.cache = cache || {};
      rval.capacity = Math.max(capacity || 100, 1);
      rval.order = [];
      for (var key2 in cache) {
        if (rval.order.length <= capacity) {
          rval.order.push(key2);
        } else {
          delete cache[key2];
        }
      }
      rval.getSession = function(sessionId) {
        var session = null;
        var key3 = null;
        if (sessionId) {
          key3 = forge.util.bytesToHex(sessionId);
        } else if (rval.order.length > 0) {
          key3 = rval.order[0];
        }
        if (key3 !== null && key3 in rval.cache) {
          session = rval.cache[key3];
          delete rval.cache[key3];
          for (var i5 in rval.order) {
            if (rval.order[i5] === key3) {
              rval.order.splice(i5, 1);
              break;
            }
          }
        }
        return session;
      };
      rval.setSession = function(sessionId, session) {
        if (rval.order.length === rval.capacity) {
          var key3 = rval.order.shift();
          delete rval.cache[key3];
        }
        var key3 = forge.util.bytesToHex(sessionId);
        rval.order.push(key3);
        rval.cache[key3] = session;
      };
    }
    return rval;
  };
  tls.createConnection = function(options23) {
    var caStore = null;
    if (options23.caStore) {
      if (forge.util.isArray(options23.caStore)) {
        caStore = forge.pki.createCaStore(options23.caStore);
      } else {
        caStore = options23.caStore;
      }
    } else {
      caStore = forge.pki.createCaStore();
    }
    var cipherSuites = options23.cipherSuites || null;
    if (cipherSuites === null) {
      cipherSuites = [];
      for (var key2 in tls.CipherSuites) {
        cipherSuites.push(tls.CipherSuites[key2]);
      }
    }
    var entity = options23.server ? tls.ConnectionEnd.server : tls.ConnectionEnd.client;
    var sessionCache = options23.sessionCache ? tls.createSessionCache(options23.sessionCache) : null;
    var c23 = {
      version: { major: tls.Version.major, minor: tls.Version.minor },
      entity,
      sessionId: options23.sessionId,
      caStore,
      sessionCache,
      cipherSuites,
      connected: options23.connected,
      virtualHost: options23.virtualHost || null,
      verifyClient: options23.verifyClient || false,
      verify: options23.verify || function(cn2, vfd, dpth, cts) {
        return vfd;
      },
      verifyOptions: options23.verifyOptions || {},
      getCertificate: options23.getCertificate || null,
      getPrivateKey: options23.getPrivateKey || null,
      getSignature: options23.getSignature || null,
      input: forge.util.createBuffer(),
      tlsData: forge.util.createBuffer(),
      data: forge.util.createBuffer(),
      tlsDataReady: options23.tlsDataReady,
      dataReady: options23.dataReady,
      heartbeatReceived: options23.heartbeatReceived,
      closed: options23.closed,
      error: function(c32, ex) {
        ex.origin = ex.origin || (c32.entity === tls.ConnectionEnd.client ? "client" : "server");
        if (ex.send) {
          tls.queue(c32, tls.createAlert(c32, ex.alert));
          tls.flush(c32);
        }
        var fatal = ex.fatal !== false;
        if (fatal) {
          c32.fail = true;
        }
        options23.error(c32, ex);
        if (fatal) {
          c32.close(false);
        }
      },
      deflate: options23.deflate || null,
      inflate: options23.inflate || null
    };
    c23.reset = function(clearFail) {
      c23.version = { major: tls.Version.major, minor: tls.Version.minor };
      c23.record = null;
      c23.session = null;
      c23.peerCertificate = null;
      c23.state = {
        pending: null,
        current: null
      };
      c23.expect = c23.entity === tls.ConnectionEnd.client ? SHE : CHE;
      c23.fragmented = null;
      c23.records = [];
      c23.open = false;
      c23.handshakes = 0;
      c23.handshaking = false;
      c23.isConnected = false;
      c23.fail = !(clearFail || typeof clearFail === "undefined");
      c23.input.clear();
      c23.tlsData.clear();
      c23.data.clear();
      c23.state.current = tls.createConnectionState(c23);
    };
    c23.reset();
    var _update = function(c32, record) {
      var aligned = record.type - tls.ContentType.change_cipher_spec;
      var handlers = ctTable[c32.entity][c32.expect];
      if (aligned in handlers) {
        handlers[aligned](c32, record);
      } else {
        tls.handleUnexpected(c32, record);
      }
    };
    var _readRecordHeader = function(c32) {
      var rval = 0;
      var b23 = c32.input;
      var len = b23.length();
      if (len < 5) {
        rval = 5 - len;
      } else {
        c32.record = {
          type: b23.getByte(),
          version: {
            major: b23.getByte(),
            minor: b23.getByte()
          },
          length: b23.getInt16(),
          fragment: forge.util.createBuffer(),
          ready: false
        };
        var compatibleVersion = c32.record.version.major === c32.version.major;
        if (compatibleVersion && c32.session && c32.session.version) {
          compatibleVersion = c32.record.version.minor === c32.version.minor;
        }
        if (!compatibleVersion) {
          c32.error(c32, {
            message: "Incompatible TLS version.",
            send: true,
            alert: {
              level: tls.Alert.Level.fatal,
              description: tls.Alert.Description.protocol_version
            }
          });
        }
      }
      return rval;
    };
    var _readRecord = function(c32) {
      var rval = 0;
      var b23 = c32.input;
      var len = b23.length();
      if (len < c32.record.length) {
        rval = c32.record.length - len;
      } else {
        c32.record.fragment.putBytes(b23.getBytes(c32.record.length));
        b23.compact();
        var s32 = c32.state.current.read;
        if (s32.update(c32, c32.record)) {
          if (c32.fragmented !== null) {
            if (c32.fragmented.type === c32.record.type) {
              c32.fragmented.fragment.putBuffer(c32.record.fragment);
              c32.record = c32.fragmented;
            } else {
              c32.error(c32, {
                message: "Invalid fragmented record.",
                send: true,
                alert: {
                  level: tls.Alert.Level.fatal,
                  description: tls.Alert.Description.unexpected_message
                }
              });
            }
          }
          c32.record.ready = true;
        }
      }
      return rval;
    };
    c23.handshake = function(sessionId) {
      if (c23.entity !== tls.ConnectionEnd.client) {
        c23.error(c23, {
          message: "Cannot initiate handshake as a server.",
          fatal: false
        });
      } else if (c23.handshaking) {
        c23.error(c23, {
          message: "Handshake already in progress.",
          fatal: false
        });
      } else {
        if (c23.fail && !c23.open && c23.handshakes === 0) {
          c23.fail = false;
        }
        c23.handshaking = true;
        sessionId = sessionId || "";
        var session = null;
        if (sessionId.length > 0) {
          if (c23.sessionCache) {
            session = c23.sessionCache.getSession(sessionId);
          }
          if (session === null) {
            sessionId = "";
          }
        }
        if (sessionId.length === 0 && c23.sessionCache) {
          session = c23.sessionCache.getSession();
          if (session !== null) {
            sessionId = session.id;
          }
        }
        c23.session = {
          id: sessionId,
          version: null,
          cipherSuite: null,
          compressionMethod: null,
          serverCertificate: null,
          certificateRequest: null,
          clientCertificate: null,
          sp: {},
          md5: forge.md.md5.create(),
          sha1: forge.md.sha1.create()
        };
        if (session) {
          c23.version = session.version;
          c23.session.sp = session.sp;
        }
        c23.session.sp.client_random = tls.createRandom().getBytes();
        c23.open = true;
        tls.queue(c23, tls.createRecord(c23, {
          type: tls.ContentType.handshake,
          data: tls.createClientHello(c23)
        }));
        tls.flush(c23);
      }
    };
    c23.process = function(data2) {
      var rval = 0;
      if (data2) {
        c23.input.putBytes(data2);
      }
      if (!c23.fail) {
        if (c23.record !== null && c23.record.ready && c23.record.fragment.isEmpty()) {
          c23.record = null;
        }
        if (c23.record === null) {
          rval = _readRecordHeader(c23);
        }
        if (!c23.fail && c23.record !== null && !c23.record.ready) {
          rval = _readRecord(c23);
        }
        if (!c23.fail && c23.record !== null && c23.record.ready) {
          _update(c23, c23.record);
        }
      }
      return rval;
    };
    c23.prepare = function(data2) {
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.application_data,
        data: forge.util.createBuffer(data2)
      }));
      return tls.flush(c23);
    };
    c23.prepareHeartbeatRequest = function(payload, payloadLength) {
      if (payload instanceof forge.util.ByteBuffer) {
        payload = payload.bytes();
      }
      if (typeof payloadLength === "undefined") {
        payloadLength = payload.length;
      }
      c23.expectedHeartbeatPayload = payload;
      tls.queue(c23, tls.createRecord(c23, {
        type: tls.ContentType.heartbeat,
        data: tls.createHeartbeat(tls.HeartbeatMessageType.heartbeat_request, payload, payloadLength)
      }));
      return tls.flush(c23);
    };
    c23.close = function(clearFail) {
      if (!c23.fail && c23.sessionCache && c23.session) {
        var session = {
          id: c23.session.id,
          version: c23.session.version,
          sp: c23.session.sp
        };
        session.sp.keys = null;
        c23.sessionCache.setSession(session.id, session);
      }
      if (c23.open) {
        c23.open = false;
        c23.input.clear();
        if (c23.isConnected || c23.handshaking) {
          c23.isConnected = c23.handshaking = false;
          tls.queue(c23, tls.createAlert(c23, {
            level: tls.Alert.Level.warning,
            description: tls.Alert.Description.close_notify
          }));
          tls.flush(c23);
        }
        c23.closed(c23);
      }
      c23.reset(clearFail);
    };
    return c23;
  };
  module.exports = forge.tls = forge.tls || {};
  for (key in tls) {
    if (typeof tls[key] !== "function") {
      forge.tls[key] = tls[key];
    }
  }
  var key;
  forge.tls.prf_tls1 = prf_TLS1;
  forge.tls.hmac_sha1 = hmac_sha1;
  forge.tls.createSessionCache = tls.createSessionCache;
  forge.tls.createConnection = tls.createConnection;
});
var require_aesCipherSuites = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_aes2();
  require_tls();
  var tls = module.exports = forge.tls;
  tls.CipherSuites["TLS_RSA_WITH_AES_128_CBC_SHA"] = {
    id: [0, 47],
    name: "TLS_RSA_WITH_AES_128_CBC_SHA",
    initSecurityParameters: function(sp) {
      sp.bulk_cipher_algorithm = tls.BulkCipherAlgorithm.aes;
      sp.cipher_type = tls.CipherType.block;
      sp.enc_key_length = 16;
      sp.block_length = 16;
      sp.fixed_iv_length = 16;
      sp.record_iv_length = 16;
      sp.mac_algorithm = tls.MACAlgorithm.hmac_sha1;
      sp.mac_length = 20;
      sp.mac_key_length = 20;
    },
    initConnectionState
  };
  tls.CipherSuites["TLS_RSA_WITH_AES_256_CBC_SHA"] = {
    id: [0, 53],
    name: "TLS_RSA_WITH_AES_256_CBC_SHA",
    initSecurityParameters: function(sp) {
      sp.bulk_cipher_algorithm = tls.BulkCipherAlgorithm.aes;
      sp.cipher_type = tls.CipherType.block;
      sp.enc_key_length = 32;
      sp.block_length = 16;
      sp.fixed_iv_length = 16;
      sp.record_iv_length = 16;
      sp.mac_algorithm = tls.MACAlgorithm.hmac_sha1;
      sp.mac_length = 20;
      sp.mac_key_length = 20;
    },
    initConnectionState
  };
  function initConnectionState(state, c23, sp) {
    var client = c23.entity === forge.tls.ConnectionEnd.client;
    state.read.cipherState = {
      init: false,
      cipher: forge.cipher.createDecipher("AES-CBC", client ? sp.keys.server_write_key : sp.keys.client_write_key),
      iv: client ? sp.keys.server_write_IV : sp.keys.client_write_IV
    };
    state.write.cipherState = {
      init: false,
      cipher: forge.cipher.createCipher("AES-CBC", client ? sp.keys.client_write_key : sp.keys.server_write_key),
      iv: client ? sp.keys.client_write_IV : sp.keys.server_write_IV
    };
    state.read.cipherFunction = decrypt_aes_cbc_sha1;
    state.write.cipherFunction = encrypt_aes_cbc_sha1;
    state.read.macLength = state.write.macLength = sp.mac_length;
    state.read.macFunction = state.write.macFunction = tls.hmac_sha1;
  }
  function encrypt_aes_cbc_sha1(record, s32) {
    var rval = false;
    var mac = s32.macFunction(s32.macKey, s32.sequenceNumber, record);
    record.fragment.putBytes(mac);
    s32.updateSequenceNumber();
    var iv;
    if (record.version.minor === tls.Versions.TLS_1_0.minor) {
      iv = s32.cipherState.init ? null : s32.cipherState.iv;
    } else {
      iv = forge.random.getBytesSync(16);
    }
    s32.cipherState.init = true;
    var cipher = s32.cipherState.cipher;
    cipher.start({ iv });
    if (record.version.minor >= tls.Versions.TLS_1_1.minor) {
      cipher.output.putBytes(iv);
    }
    cipher.update(record.fragment);
    if (cipher.finish(encrypt_aes_cbc_sha1_padding)) {
      record.fragment = cipher.output;
      record.length = record.fragment.length();
      rval = true;
    }
    return rval;
  }
  function encrypt_aes_cbc_sha1_padding(blockSize, input, decrypt) {
    if (!decrypt) {
      var padding = blockSize - input.length() % blockSize;
      input.fillWithByte(padding - 1, padding);
    }
    return true;
  }
  function decrypt_aes_cbc_sha1_padding(blockSize, output, decrypt) {
    var rval = true;
    if (decrypt) {
      var len = output.length();
      var paddingLength = output.last();
      for (var i5 = len - 1 - paddingLength;i5 < len - 1; ++i5) {
        rval = rval && output.at(i5) == paddingLength;
      }
      if (rval) {
        output.truncate(paddingLength + 1);
      }
    }
    return rval;
  }
  function decrypt_aes_cbc_sha1(record, s32) {
    var rval = false;
    var iv;
    if (record.version.minor === tls.Versions.TLS_1_0.minor) {
      iv = s32.cipherState.init ? null : s32.cipherState.iv;
    } else {
      iv = record.fragment.getBytes(16);
    }
    s32.cipherState.init = true;
    var cipher = s32.cipherState.cipher;
    cipher.start({ iv });
    cipher.update(record.fragment);
    rval = cipher.finish(decrypt_aes_cbc_sha1_padding);
    var macLen = s32.macLength;
    var mac = forge.random.getBytesSync(macLen);
    var len = cipher.output.length();
    if (len >= macLen) {
      record.fragment = cipher.output.getBytes(len - macLen);
      mac = cipher.output.getBytes(macLen);
    } else {
      record.fragment = cipher.output.getBytes();
    }
    record.fragment = forge.util.createBuffer(record.fragment);
    record.length = record.fragment.length();
    var mac2 = s32.macFunction(s32.macKey, s32.sequenceNumber, record);
    s32.updateSequenceNumber();
    rval = compareMacs(s32.macKey, mac, mac2) && rval;
    return rval;
  }
  function compareMacs(key, mac1, mac2) {
    var hmac2 = forge.hmac.create();
    hmac2.start("SHA1", key);
    hmac2.update(mac1);
    mac1 = hmac2.digest().getBytes();
    hmac2.start(null, null);
    hmac2.update(mac2);
    mac2 = hmac2.digest().getBytes();
    return mac1 === mac2;
  }
});
var require_sha512 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_md();
  require_util33();
  var sha512 = module.exports = forge.sha512 = forge.sha512 || {};
  forge.md.sha512 = forge.md.algorithms.sha512 = sha512;
  var sha384 = forge.sha384 = forge.sha512.sha384 = forge.sha512.sha384 || {};
  sha384.create = function() {
    return sha512.create("SHA-384");
  };
  forge.md.sha384 = forge.md.algorithms.sha384 = sha384;
  forge.sha512.sha256 = forge.sha512.sha256 || {
    create: function() {
      return sha512.create("SHA-512/256");
    }
  };
  forge.md["sha512/256"] = forge.md.algorithms["sha512/256"] = forge.sha512.sha256;
  forge.sha512.sha224 = forge.sha512.sha224 || {
    create: function() {
      return sha512.create("SHA-512/224");
    }
  };
  forge.md["sha512/224"] = forge.md.algorithms["sha512/224"] = forge.sha512.sha224;
  sha512.create = function(algorithm) {
    if (!_initialized) {
      _init();
    }
    if (typeof algorithm === "undefined") {
      algorithm = "SHA-512";
    }
    if (!(algorithm in _states)) {
      throw new Error("Invalid SHA-512 algorithm: " + algorithm);
    }
    var _state = _states[algorithm];
    var _h = null;
    var _input = forge.util.createBuffer();
    var _w2 = new Array(80);
    for (var wi = 0;wi < 80; ++wi) {
      _w2[wi] = new Array(2);
    }
    var digestLength = 64;
    switch (algorithm) {
      case "SHA-384":
        digestLength = 48;
        break;
      case "SHA-512/256":
        digestLength = 32;
        break;
      case "SHA-512/224":
        digestLength = 28;
        break;
    }
    var md = {
      algorithm: algorithm.replace("-", "").toLowerCase(),
      blockLength: 128,
      digestLength,
      messageLength: 0,
      fullMessageLength: null,
      messageLengthSize: 16
    };
    md.start = function() {
      md.messageLength = 0;
      md.fullMessageLength = md.messageLength128 = [];
      var int32s = md.messageLengthSize / 4;
      for (var i5 = 0;i5 < int32s; ++i5) {
        md.fullMessageLength.push(0);
      }
      _input = forge.util.createBuffer();
      _h = new Array(_state.length);
      for (var i5 = 0;i5 < _state.length; ++i5) {
        _h[i5] = _state[i5].slice(0);
      }
      return md;
    };
    md.start();
    md.update = function(msg, encoding) {
      if (encoding === "utf8") {
        msg = forge.util.encodeUtf8(msg);
      }
      var len = msg.length;
      md.messageLength += len;
      len = [len / 4294967296 >>> 0, len >>> 0];
      for (var i5 = md.fullMessageLength.length - 1;i5 >= 0; --i5) {
        md.fullMessageLength[i5] += len[1];
        len[1] = len[0] + (md.fullMessageLength[i5] / 4294967296 >>> 0);
        md.fullMessageLength[i5] = md.fullMessageLength[i5] >>> 0;
        len[0] = len[1] / 4294967296 >>> 0;
      }
      _input.putBytes(msg);
      _update(_h, _w2, _input);
      if (_input.read > 2048 || _input.length() === 0) {
        _input.compact();
      }
      return md;
    };
    md.digest = function() {
      var finalBlock = forge.util.createBuffer();
      finalBlock.putBytes(_input.bytes());
      var remaining = md.fullMessageLength[md.fullMessageLength.length - 1] + md.messageLengthSize;
      var overflow = remaining & md.blockLength - 1;
      finalBlock.putBytes(_padding.substr(0, md.blockLength - overflow));
      var next, carry;
      var bits = md.fullMessageLength[0] * 8;
      for (var i5 = 0;i5 < md.fullMessageLength.length - 1; ++i5) {
        next = md.fullMessageLength[i5 + 1] * 8;
        carry = next / 4294967296 >>> 0;
        bits += carry;
        finalBlock.putInt32(bits >>> 0);
        bits = next >>> 0;
      }
      finalBlock.putInt32(bits);
      var h33 = new Array(_h.length);
      for (var i5 = 0;i5 < _h.length; ++i5) {
        h33[i5] = _h[i5].slice(0);
      }
      _update(h33, _w2, finalBlock);
      var rval = forge.util.createBuffer();
      var hlen;
      if (algorithm === "SHA-512") {
        hlen = h33.length;
      } else if (algorithm === "SHA-384") {
        hlen = h33.length - 2;
      } else {
        hlen = h33.length - 4;
      }
      for (var i5 = 0;i5 < hlen; ++i5) {
        rval.putInt32(h33[i5][0]);
        if (i5 !== hlen - 1 || algorithm !== "SHA-512/224") {
          rval.putInt32(h33[i5][1]);
        }
      }
      return rval;
    };
    return md;
  };
  var _padding = null;
  var _initialized = false;
  var _k = null;
  var _states = null;
  function _init() {
    _padding = String.fromCharCode(128);
    _padding += forge.util.fillString(String.fromCharCode(0), 128);
    _k = [
      [1116352408, 3609767458],
      [1899447441, 602891725],
      [3049323471, 3964484399],
      [3921009573, 2173295548],
      [961987163, 4081628472],
      [1508970993, 3053834265],
      [2453635748, 2937671579],
      [2870763221, 3664609560],
      [3624381080, 2734883394],
      [310598401, 1164996542],
      [607225278, 1323610764],
      [1426881987, 3590304994],
      [1925078388, 4068182383],
      [2162078206, 991336113],
      [2614888103, 633803317],
      [3248222580, 3479774868],
      [3835390401, 2666613458],
      [4022224774, 944711139],
      [264347078, 2341262773],
      [604807628, 2007800933],
      [770255983, 1495990901],
      [1249150122, 1856431235],
      [1555081692, 3175218132],
      [1996064986, 2198950837],
      [2554220882, 3999719339],
      [2821834349, 766784016],
      [2952996808, 2566594879],
      [3210313671, 3203337956],
      [3336571891, 1034457026],
      [3584528711, 2466948901],
      [113926993, 3758326383],
      [338241895, 168717936],
      [666307205, 1188179964],
      [773529912, 1546045734],
      [1294757372, 1522805485],
      [1396182291, 2643833823],
      [1695183700, 2343527390],
      [1986661051, 1014477480],
      [2177026350, 1206759142],
      [2456956037, 344077627],
      [2730485921, 1290863460],
      [2820302411, 3158454273],
      [3259730800, 3505952657],
      [3345764771, 106217008],
      [3516065817, 3606008344],
      [3600352804, 1432725776],
      [4094571909, 1467031594],
      [275423344, 851169720],
      [430227734, 3100823752],
      [506948616, 1363258195],
      [659060556, 3750685593],
      [883997877, 3785050280],
      [958139571, 3318307427],
      [1322822218, 3812723403],
      [1537002063, 2003034995],
      [1747873779, 3602036899],
      [1955562222, 1575990012],
      [2024104815, 1125592928],
      [2227730452, 2716904306],
      [2361852424, 442776044],
      [2428436474, 593698344],
      [2756734187, 3733110249],
      [3204031479, 2999351573],
      [3329325298, 3815920427],
      [3391569614, 3928383900],
      [3515267271, 566280711],
      [3940187606, 3454069534],
      [4118630271, 4000239992],
      [116418474, 1914138554],
      [174292421, 2731055270],
      [289380356, 3203993006],
      [460393269, 320620315],
      [685471733, 587496836],
      [852142971, 1086792851],
      [1017036298, 365543100],
      [1126000580, 2618297676],
      [1288033470, 3409855158],
      [1501505948, 4234509866],
      [1607167915, 987167468],
      [1816402316, 1246189591]
    ];
    _states = {};
    _states["SHA-512"] = [
      [1779033703, 4089235720],
      [3144134277, 2227873595],
      [1013904242, 4271175723],
      [2773480762, 1595750129],
      [1359893119, 2917565137],
      [2600822924, 725511199],
      [528734635, 4215389547],
      [1541459225, 327033209]
    ];
    _states["SHA-384"] = [
      [3418070365, 3238371032],
      [1654270250, 914150663],
      [2438529370, 812702999],
      [355462360, 4144912697],
      [1731405415, 4290775857],
      [2394180231, 1750603025],
      [3675008525, 1694076839],
      [1203062813, 3204075428]
    ];
    _states["SHA-512/256"] = [
      [573645204, 4230739756],
      [2673172387, 3360449730],
      [596883563, 1867755857],
      [2520282905, 1497426621],
      [2519219938, 2827943907],
      [3193839141, 1401305490],
      [721525244, 746961066],
      [246885852, 2177182882]
    ];
    _states["SHA-512/224"] = [
      [2352822216, 424955298],
      [1944164710, 2312950998],
      [502970286, 855612546],
      [1738396948, 1479516111],
      [258812777, 2077511080],
      [2011393907, 79989058],
      [1067287976, 1780299464],
      [286451373, 2446758561]
    ];
    _initialized = true;
  }
  function _update(s32, w23, bytes) {
    var t1_hi, t1_lo;
    var t2_hi, t2_lo;
    var s0_hi, s0_lo;
    var s1_hi, s1_lo;
    var ch_hi, ch_lo;
    var maj_hi, maj_lo;
    var a_hi, a_lo;
    var b_hi, b_lo;
    var c_hi, c_lo;
    var d_hi, d_lo;
    var e_hi, e_lo;
    var f_hi, f_lo;
    var g_hi, g_lo;
    var h_hi, h_lo;
    var i5, hi, lo, w222, w7, w15, w16;
    var len = bytes.length();
    while (len >= 128) {
      for (i5 = 0;i5 < 16; ++i5) {
        w23[i5][0] = bytes.getInt32() >>> 0;
        w23[i5][1] = bytes.getInt32() >>> 0;
      }
      for (;i5 < 80; ++i5) {
        w222 = w23[i5 - 2];
        hi = w222[0];
        lo = w222[1];
        t1_hi = ((hi >>> 19 | lo << 13) ^ (lo >>> 29 | hi << 3) ^ hi >>> 6) >>> 0;
        t1_lo = ((hi << 13 | lo >>> 19) ^ (lo << 3 | hi >>> 29) ^ (hi << 26 | lo >>> 6)) >>> 0;
        w15 = w23[i5 - 15];
        hi = w15[0];
        lo = w15[1];
        t2_hi = ((hi >>> 1 | lo << 31) ^ (hi >>> 8 | lo << 24) ^ hi >>> 7) >>> 0;
        t2_lo = ((hi << 31 | lo >>> 1) ^ (hi << 24 | lo >>> 8) ^ (hi << 25 | lo >>> 7)) >>> 0;
        w7 = w23[i5 - 7];
        w16 = w23[i5 - 16];
        lo = t1_lo + w7[1] + t2_lo + w16[1];
        w23[i5][0] = t1_hi + w7[0] + t2_hi + w16[0] + (lo / 4294967296 >>> 0) >>> 0;
        w23[i5][1] = lo >>> 0;
      }
      a_hi = s32[0][0];
      a_lo = s32[0][1];
      b_hi = s32[1][0];
      b_lo = s32[1][1];
      c_hi = s32[2][0];
      c_lo = s32[2][1];
      d_hi = s32[3][0];
      d_lo = s32[3][1];
      e_hi = s32[4][0];
      e_lo = s32[4][1];
      f_hi = s32[5][0];
      f_lo = s32[5][1];
      g_hi = s32[6][0];
      g_lo = s32[6][1];
      h_hi = s32[7][0];
      h_lo = s32[7][1];
      for (i5 = 0;i5 < 80; ++i5) {
        s1_hi = ((e_hi >>> 14 | e_lo << 18) ^ (e_hi >>> 18 | e_lo << 14) ^ (e_lo >>> 9 | e_hi << 23)) >>> 0;
        s1_lo = ((e_hi << 18 | e_lo >>> 14) ^ (e_hi << 14 | e_lo >>> 18) ^ (e_lo << 23 | e_hi >>> 9)) >>> 0;
        ch_hi = (g_hi ^ e_hi & (f_hi ^ g_hi)) >>> 0;
        ch_lo = (g_lo ^ e_lo & (f_lo ^ g_lo)) >>> 0;
        s0_hi = ((a_hi >>> 28 | a_lo << 4) ^ (a_lo >>> 2 | a_hi << 30) ^ (a_lo >>> 7 | a_hi << 25)) >>> 0;
        s0_lo = ((a_hi << 4 | a_lo >>> 28) ^ (a_lo << 30 | a_hi >>> 2) ^ (a_lo << 25 | a_hi >>> 7)) >>> 0;
        maj_hi = (a_hi & b_hi | c_hi & (a_hi ^ b_hi)) >>> 0;
        maj_lo = (a_lo & b_lo | c_lo & (a_lo ^ b_lo)) >>> 0;
        lo = h_lo + s1_lo + ch_lo + _k[i5][1] + w23[i5][1];
        t1_hi = h_hi + s1_hi + ch_hi + _k[i5][0] + w23[i5][0] + (lo / 4294967296 >>> 0) >>> 0;
        t1_lo = lo >>> 0;
        lo = s0_lo + maj_lo;
        t2_hi = s0_hi + maj_hi + (lo / 4294967296 >>> 0) >>> 0;
        t2_lo = lo >>> 0;
        h_hi = g_hi;
        h_lo = g_lo;
        g_hi = f_hi;
        g_lo = f_lo;
        f_hi = e_hi;
        f_lo = e_lo;
        lo = d_lo + t1_lo;
        e_hi = d_hi + t1_hi + (lo / 4294967296 >>> 0) >>> 0;
        e_lo = lo >>> 0;
        d_hi = c_hi;
        d_lo = c_lo;
        c_hi = b_hi;
        c_lo = b_lo;
        b_hi = a_hi;
        b_lo = a_lo;
        lo = t1_lo + t2_lo;
        a_hi = t1_hi + t2_hi + (lo / 4294967296 >>> 0) >>> 0;
        a_lo = lo >>> 0;
      }
      lo = s32[0][1] + a_lo;
      s32[0][0] = s32[0][0] + a_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[0][1] = lo >>> 0;
      lo = s32[1][1] + b_lo;
      s32[1][0] = s32[1][0] + b_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[1][1] = lo >>> 0;
      lo = s32[2][1] + c_lo;
      s32[2][0] = s32[2][0] + c_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[2][1] = lo >>> 0;
      lo = s32[3][1] + d_lo;
      s32[3][0] = s32[3][0] + d_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[3][1] = lo >>> 0;
      lo = s32[4][1] + e_lo;
      s32[4][0] = s32[4][0] + e_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[4][1] = lo >>> 0;
      lo = s32[5][1] + f_lo;
      s32[5][0] = s32[5][0] + f_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[5][1] = lo >>> 0;
      lo = s32[6][1] + g_lo;
      s32[6][0] = s32[6][0] + g_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[6][1] = lo >>> 0;
      lo = s32[7][1] + h_lo;
      s32[7][0] = s32[7][0] + h_hi + (lo / 4294967296 >>> 0) >>> 0;
      s32[7][1] = lo >>> 0;
      len -= 128;
    }
  }
});
var require_asn1_validator = __commonJS3((exports) => {
  var forge = require_forge();
  require_asn1();
  var asn1 = forge.asn1;
  exports.privateKeyValidator = {
    name: "PrivateKeyInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    value: [{
      name: "PrivateKeyInfo.version",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.INTEGER,
      constructed: false,
      capture: "privateKeyVersion"
    }, {
      name: "PrivateKeyInfo.privateKeyAlgorithm",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.SEQUENCE,
      constructed: true,
      value: [{
        name: "AlgorithmIdentifier.algorithm",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.OID,
        constructed: false,
        capture: "privateKeyOid"
      }]
    }, {
      name: "PrivateKeyInfo",
      tagClass: asn1.Class.UNIVERSAL,
      type: asn1.Type.OCTETSTRING,
      constructed: false,
      capture: "privateKey"
    }]
  };
  exports.publicKeyValidator = {
    name: "SubjectPublicKeyInfo",
    tagClass: asn1.Class.UNIVERSAL,
    type: asn1.Type.SEQUENCE,
    constructed: true,
    captureAsn1: "subjectPublicKeyInfo",
    value: [
      {
        name: "SubjectPublicKeyInfo.AlgorithmIdentifier",
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.SEQUENCE,
        constructed: true,
        value: [{
          name: "AlgorithmIdentifier.algorithm",
          tagClass: asn1.Class.UNIVERSAL,
          type: asn1.Type.OID,
          constructed: false,
          capture: "publicKeyOid"
        }]
      },
      {
        tagClass: asn1.Class.UNIVERSAL,
        type: asn1.Type.BITSTRING,
        constructed: false,
        composed: true,
        captureBitStringValue: "ed25519PublicKey"
      }
    ]
  };
});
var require_ed25519 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_jsbn();
  require_random();
  require_sha512();
  require_util33();
  var asn1Validator = require_asn1_validator();
  var publicKeyValidator = asn1Validator.publicKeyValidator;
  var privateKeyValidator = asn1Validator.privateKeyValidator;
  if (typeof BigInteger === "undefined") {
    BigInteger = forge.jsbn.BigInteger;
  }
  var BigInteger;
  var ByteBuffer = forge.util.ByteBuffer;
  var NativeBuffer = typeof Buffer === "undefined" ? Uint8Array : Buffer;
  forge.pki = forge.pki || {};
  module.exports = forge.pki.ed25519 = forge.ed25519 = forge.ed25519 || {};
  var ed25519 = forge.ed25519;
  ed25519.constants = {};
  ed25519.constants.PUBLIC_KEY_BYTE_LENGTH = 32;
  ed25519.constants.PRIVATE_KEY_BYTE_LENGTH = 64;
  ed25519.constants.SEED_BYTE_LENGTH = 32;
  ed25519.constants.SIGN_BYTE_LENGTH = 64;
  ed25519.constants.HASH_BYTE_LENGTH = 64;
  ed25519.generateKeyPair = function(options23) {
    options23 = options23 || {};
    var seed = options23.seed;
    if (seed === undefined) {
      seed = forge.random.getBytesSync(ed25519.constants.SEED_BYTE_LENGTH);
    } else if (typeof seed === "string") {
      if (seed.length !== ed25519.constants.SEED_BYTE_LENGTH) {
        throw new TypeError('"seed" must be ' + ed25519.constants.SEED_BYTE_LENGTH + " bytes in length.");
      }
    } else if (!(seed instanceof Uint8Array)) {
      throw new TypeError('"seed" must be a node.js Buffer, Uint8Array, or a binary string.');
    }
    seed = messageToNativeBuffer({ message: seed, encoding: "binary" });
    var pk = new NativeBuffer(ed25519.constants.PUBLIC_KEY_BYTE_LENGTH);
    var sk = new NativeBuffer(ed25519.constants.PRIVATE_KEY_BYTE_LENGTH);
    for (var i5 = 0;i5 < 32; ++i5) {
      sk[i5] = seed[i5];
    }
    crypto_sign_keypair(pk, sk);
    return { publicKey: pk, privateKey: sk };
  };
  ed25519.privateKeyFromAsn1 = function(obj) {
    var capture = {};
    var errors = [];
    var valid = forge.asn1.validate(obj, privateKeyValidator, capture, errors);
    if (!valid) {
      var error = new Error("Invalid Key.");
      error.errors = errors;
      throw error;
    }
    var oid = forge.asn1.derToOid(capture.privateKeyOid);
    var ed25519Oid = forge.oids.EdDSA25519;
    if (oid !== ed25519Oid) {
      throw new Error('Invalid OID "' + oid + '"; OID must be "' + ed25519Oid + '".');
    }
    var privateKey = capture.privateKey;
    var privateKeyBytes = messageToNativeBuffer({
      message: forge.asn1.fromDer(privateKey).value,
      encoding: "binary"
    });
    return { privateKeyBytes };
  };
  ed25519.publicKeyFromAsn1 = function(obj) {
    var capture = {};
    var errors = [];
    var valid = forge.asn1.validate(obj, publicKeyValidator, capture, errors);
    if (!valid) {
      var error = new Error("Invalid Key.");
      error.errors = errors;
      throw error;
    }
    var oid = forge.asn1.derToOid(capture.publicKeyOid);
    var ed25519Oid = forge.oids.EdDSA25519;
    if (oid !== ed25519Oid) {
      throw new Error('Invalid OID "' + oid + '"; OID must be "' + ed25519Oid + '".');
    }
    var publicKeyBytes = capture.ed25519PublicKey;
    if (publicKeyBytes.length !== ed25519.constants.PUBLIC_KEY_BYTE_LENGTH) {
      throw new Error("Key length is invalid.");
    }
    return messageToNativeBuffer({
      message: publicKeyBytes,
      encoding: "binary"
    });
  };
  ed25519.publicKeyFromPrivateKey = function(options23) {
    options23 = options23 || {};
    var privateKey = messageToNativeBuffer({
      message: options23.privateKey,
      encoding: "binary"
    });
    if (privateKey.length !== ed25519.constants.PRIVATE_KEY_BYTE_LENGTH) {
      throw new TypeError('"options.privateKey" must have a byte length of ' + ed25519.constants.PRIVATE_KEY_BYTE_LENGTH);
    }
    var pk = new NativeBuffer(ed25519.constants.PUBLIC_KEY_BYTE_LENGTH);
    for (var i5 = 0;i5 < pk.length; ++i5) {
      pk[i5] = privateKey[32 + i5];
    }
    return pk;
  };
  ed25519.sign = function(options23) {
    options23 = options23 || {};
    var msg = messageToNativeBuffer(options23);
    var privateKey = messageToNativeBuffer({
      message: options23.privateKey,
      encoding: "binary"
    });
    if (privateKey.length === ed25519.constants.SEED_BYTE_LENGTH) {
      var keyPair = ed25519.generateKeyPair({ seed: privateKey });
      privateKey = keyPair.privateKey;
    } else if (privateKey.length !== ed25519.constants.PRIVATE_KEY_BYTE_LENGTH) {
      throw new TypeError('"options.privateKey" must have a byte length of ' + ed25519.constants.SEED_BYTE_LENGTH + " or " + ed25519.constants.PRIVATE_KEY_BYTE_LENGTH);
    }
    var signedMsg = new NativeBuffer(ed25519.constants.SIGN_BYTE_LENGTH + msg.length);
    crypto_sign(signedMsg, msg, msg.length, privateKey);
    var sig = new NativeBuffer(ed25519.constants.SIGN_BYTE_LENGTH);
    for (var i5 = 0;i5 < sig.length; ++i5) {
      sig[i5] = signedMsg[i5];
    }
    return sig;
  };
  ed25519.verify = function(options23) {
    options23 = options23 || {};
    var msg = messageToNativeBuffer(options23);
    if (options23.signature === undefined) {
      throw new TypeError('"options.signature" must be a node.js Buffer, a Uint8Array, a forge ' + "ByteBuffer, or a binary string.");
    }
    var sig = messageToNativeBuffer({
      message: options23.signature,
      encoding: "binary"
    });
    if (sig.length !== ed25519.constants.SIGN_BYTE_LENGTH) {
      throw new TypeError('"options.signature" must have a byte length of ' + ed25519.constants.SIGN_BYTE_LENGTH);
    }
    var publicKey = messageToNativeBuffer({
      message: options23.publicKey,
      encoding: "binary"
    });
    if (publicKey.length !== ed25519.constants.PUBLIC_KEY_BYTE_LENGTH) {
      throw new TypeError('"options.publicKey" must have a byte length of ' + ed25519.constants.PUBLIC_KEY_BYTE_LENGTH);
    }
    var sm = new NativeBuffer(ed25519.constants.SIGN_BYTE_LENGTH + msg.length);
    var m23 = new NativeBuffer(ed25519.constants.SIGN_BYTE_LENGTH + msg.length);
    var i5;
    for (i5 = 0;i5 < ed25519.constants.SIGN_BYTE_LENGTH; ++i5) {
      sm[i5] = sig[i5];
    }
    for (i5 = 0;i5 < msg.length; ++i5) {
      sm[i5 + ed25519.constants.SIGN_BYTE_LENGTH] = msg[i5];
    }
    return crypto_sign_open(m23, sm, sm.length, publicKey) >= 0;
  };
  function messageToNativeBuffer(options23) {
    var message = options23.message;
    if (message instanceof Uint8Array || message instanceof NativeBuffer) {
      return message;
    }
    var encoding = options23.encoding;
    if (message === undefined) {
      if (options23.md) {
        message = options23.md.digest().getBytes();
        encoding = "binary";
      } else {
        throw new TypeError('"options.message" or "options.md" not specified.');
      }
    }
    if (typeof message === "string" && !encoding) {
      throw new TypeError('"options.encoding" must be "binary" or "utf8".');
    }
    if (typeof message === "string") {
      if (typeof Buffer !== "undefined") {
        return Buffer.from(message, encoding);
      }
      message = new ByteBuffer(message, encoding);
    } else if (!(message instanceof ByteBuffer)) {
      throw new TypeError('"options.message" must be a node.js Buffer, a Uint8Array, a forge ' + 'ByteBuffer, or a string with "options.encoding" specifying its ' + "encoding.");
    }
    var buffer = new NativeBuffer(message.length());
    for (var i5 = 0;i5 < buffer.length; ++i5) {
      buffer[i5] = message.at(i5);
    }
    return buffer;
  }
  var gf0 = gf();
  var gf1 = gf([1]);
  var D3 = gf([
    30883,
    4953,
    19914,
    30187,
    55467,
    16705,
    2637,
    112,
    59544,
    30585,
    16505,
    36039,
    65139,
    11119,
    27886,
    20995
  ]);
  var D22 = gf([
    61785,
    9906,
    39828,
    60374,
    45398,
    33411,
    5274,
    224,
    53552,
    61171,
    33010,
    6542,
    64743,
    22239,
    55772,
    9222
  ]);
  var X32 = gf([
    54554,
    36645,
    11616,
    51542,
    42930,
    38181,
    51040,
    26924,
    56412,
    64982,
    57905,
    49316,
    21502,
    52590,
    14035,
    8553
  ]);
  var Y23 = gf([
    26200,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214
  ]);
  var L3 = new Float64Array([
    237,
    211,
    245,
    92,
    26,
    99,
    18,
    88,
    214,
    156,
    247,
    162,
    222,
    249,
    222,
    20,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    16
  ]);
  var I4 = gf([
    41136,
    18958,
    6951,
    50414,
    58488,
    44335,
    6150,
    12099,
    55207,
    15867,
    153,
    11085,
    57099,
    20417,
    9344,
    11139
  ]);
  function sha512(msg, msgLen) {
    var md = forge.md.sha512.create();
    var buffer = new ByteBuffer(msg);
    md.update(buffer.getBytes(msgLen), "binary");
    var hash = md.digest().getBytes();
    if (typeof Buffer !== "undefined") {
      return Buffer.from(hash, "binary");
    }
    var out = new NativeBuffer(ed25519.constants.HASH_BYTE_LENGTH);
    for (var i5 = 0;i5 < 64; ++i5) {
      out[i5] = hash.charCodeAt(i5);
    }
    return out;
  }
  function crypto_sign_keypair(pk, sk) {
    var p33 = [gf(), gf(), gf(), gf()];
    var i5;
    var d5 = sha512(sk, 32);
    d5[0] &= 248;
    d5[31] &= 127;
    d5[31] |= 64;
    scalarbase(p33, d5);
    pack(pk, p33);
    for (i5 = 0;i5 < 32; ++i5) {
      sk[i5 + 32] = pk[i5];
    }
    return 0;
  }
  function crypto_sign(sm, m23, n5, sk) {
    var i5, j23, x5 = new Float64Array(64);
    var p33 = [gf(), gf(), gf(), gf()];
    var d5 = sha512(sk, 32);
    d5[0] &= 248;
    d5[31] &= 127;
    d5[31] |= 64;
    var smlen = n5 + 64;
    for (i5 = 0;i5 < n5; ++i5) {
      sm[64 + i5] = m23[i5];
    }
    for (i5 = 0;i5 < 32; ++i5) {
      sm[32 + i5] = d5[32 + i5];
    }
    var r23 = sha512(sm.subarray(32), n5 + 32);
    reduce(r23);
    scalarbase(p33, r23);
    pack(sm, p33);
    for (i5 = 32;i5 < 64; ++i5) {
      sm[i5] = sk[i5];
    }
    var h33 = sha512(sm, n5 + 64);
    reduce(h33);
    for (i5 = 32;i5 < 64; ++i5) {
      x5[i5] = 0;
    }
    for (i5 = 0;i5 < 32; ++i5) {
      x5[i5] = r23[i5];
    }
    for (i5 = 0;i5 < 32; ++i5) {
      for (j23 = 0;j23 < 32; j23++) {
        x5[i5 + j23] += h33[i5] * d5[j23];
      }
    }
    modL(sm.subarray(32), x5);
    return smlen;
  }
  function crypto_sign_open(m23, sm, n5, pk) {
    var i5, mlen;
    var t5 = new NativeBuffer(32);
    var p33 = [gf(), gf(), gf(), gf()], q6 = [gf(), gf(), gf(), gf()];
    mlen = -1;
    if (n5 < 64) {
      return -1;
    }
    if (unpackneg(q6, pk)) {
      return -1;
    }
    for (i5 = 0;i5 < n5; ++i5) {
      m23[i5] = sm[i5];
    }
    for (i5 = 0;i5 < 32; ++i5) {
      m23[i5 + 32] = pk[i5];
    }
    var h33 = sha512(m23, n5);
    reduce(h33);
    scalarmult(p33, q6, h33);
    scalarbase(q6, sm.subarray(32));
    add(p33, q6);
    pack(t5, p33);
    n5 -= 64;
    if (crypto_verify_32(sm, 0, t5, 0)) {
      for (i5 = 0;i5 < n5; ++i5) {
        m23[i5] = 0;
      }
      return -1;
    }
    for (i5 = 0;i5 < n5; ++i5) {
      m23[i5] = sm[i5 + 64];
    }
    mlen = n5;
    return mlen;
  }
  function modL(r23, x5) {
    var carry, i5, j23, k5;
    for (i5 = 63;i5 >= 32; --i5) {
      carry = 0;
      for (j23 = i5 - 32, k5 = i5 - 12;j23 < k5; ++j23) {
        x5[j23] += carry - 16 * x5[i5] * L3[j23 - (i5 - 32)];
        carry = x5[j23] + 128 >> 8;
        x5[j23] -= carry * 256;
      }
      x5[j23] += carry;
      x5[i5] = 0;
    }
    carry = 0;
    for (j23 = 0;j23 < 32; ++j23) {
      x5[j23] += carry - (x5[31] >> 4) * L3[j23];
      carry = x5[j23] >> 8;
      x5[j23] &= 255;
    }
    for (j23 = 0;j23 < 32; ++j23) {
      x5[j23] -= carry * L3[j23];
    }
    for (i5 = 0;i5 < 32; ++i5) {
      x5[i5 + 1] += x5[i5] >> 8;
      r23[i5] = x5[i5] & 255;
    }
  }
  function reduce(r23) {
    var x5 = new Float64Array(64);
    for (var i5 = 0;i5 < 64; ++i5) {
      x5[i5] = r23[i5];
      r23[i5] = 0;
    }
    modL(r23, x5);
  }
  function add(p33, q6) {
    var a5 = gf(), b23 = gf(), c23 = gf(), d5 = gf(), e5 = gf(), f23 = gf(), g23 = gf(), h33 = gf(), t5 = gf();
    Z23(a5, p33[1], p33[0]);
    Z23(t5, q6[1], q6[0]);
    M23(a5, a5, t5);
    A3(b23, p33[0], p33[1]);
    A3(t5, q6[0], q6[1]);
    M23(b23, b23, t5);
    M23(c23, p33[3], q6[3]);
    M23(c23, c23, D22);
    M23(d5, p33[2], q6[2]);
    A3(d5, d5, d5);
    Z23(e5, b23, a5);
    Z23(f23, d5, c23);
    A3(g23, d5, c23);
    A3(h33, b23, a5);
    M23(p33[0], e5, f23);
    M23(p33[1], h33, g23);
    M23(p33[2], g23, f23);
    M23(p33[3], e5, h33);
  }
  function cswap(p33, q6, b23) {
    for (var i5 = 0;i5 < 4; ++i5) {
      sel25519(p33[i5], q6[i5], b23);
    }
  }
  function pack(r23, p33) {
    var tx = gf(), ty = gf(), zi = gf();
    inv25519(zi, p33[2]);
    M23(tx, p33[0], zi);
    M23(ty, p33[1], zi);
    pack25519(r23, ty);
    r23[31] ^= par25519(tx) << 7;
  }
  function pack25519(o5, n5) {
    var i5, j23, b23;
    var m23 = gf(), t5 = gf();
    for (i5 = 0;i5 < 16; ++i5) {
      t5[i5] = n5[i5];
    }
    car25519(t5);
    car25519(t5);
    car25519(t5);
    for (j23 = 0;j23 < 2; ++j23) {
      m23[0] = t5[0] - 65517;
      for (i5 = 1;i5 < 15; ++i5) {
        m23[i5] = t5[i5] - 65535 - (m23[i5 - 1] >> 16 & 1);
        m23[i5 - 1] &= 65535;
      }
      m23[15] = t5[15] - 32767 - (m23[14] >> 16 & 1);
      b23 = m23[15] >> 16 & 1;
      m23[14] &= 65535;
      sel25519(t5, m23, 1 - b23);
    }
    for (i5 = 0;i5 < 16; i5++) {
      o5[2 * i5] = t5[i5] & 255;
      o5[2 * i5 + 1] = t5[i5] >> 8;
    }
  }
  function unpackneg(r23, p33) {
    var t5 = gf(), chk = gf(), num = gf(), den = gf(), den2 = gf(), den4 = gf(), den6 = gf();
    set25519(r23[2], gf1);
    unpack25519(r23[1], p33);
    S2(num, r23[1]);
    M23(den, num, D3);
    Z23(num, num, r23[2]);
    A3(den, r23[2], den);
    S2(den2, den);
    S2(den4, den2);
    M23(den6, den4, den2);
    M23(t5, den6, num);
    M23(t5, t5, den);
    pow2523(t5, t5);
    M23(t5, t5, num);
    M23(t5, t5, den);
    M23(t5, t5, den);
    M23(r23[0], t5, den);
    S2(chk, r23[0]);
    M23(chk, chk, den);
    if (neq25519(chk, num)) {
      M23(r23[0], r23[0], I4);
    }
    S2(chk, r23[0]);
    M23(chk, chk, den);
    if (neq25519(chk, num)) {
      return -1;
    }
    if (par25519(r23[0]) === p33[31] >> 7) {
      Z23(r23[0], gf0, r23[0]);
    }
    M23(r23[3], r23[0], r23[1]);
    return 0;
  }
  function unpack25519(o5, n5) {
    var i5;
    for (i5 = 0;i5 < 16; ++i5) {
      o5[i5] = n5[2 * i5] + (n5[2 * i5 + 1] << 8);
    }
    o5[15] &= 32767;
  }
  function pow2523(o5, i5) {
    var c23 = gf();
    var a5;
    for (a5 = 0;a5 < 16; ++a5) {
      c23[a5] = i5[a5];
    }
    for (a5 = 250;a5 >= 0; --a5) {
      S2(c23, c23);
      if (a5 !== 1) {
        M23(c23, c23, i5);
      }
    }
    for (a5 = 0;a5 < 16; ++a5) {
      o5[a5] = c23[a5];
    }
  }
  function neq25519(a5, b23) {
    var c23 = new NativeBuffer(32);
    var d5 = new NativeBuffer(32);
    pack25519(c23, a5);
    pack25519(d5, b23);
    return crypto_verify_32(c23, 0, d5, 0);
  }
  function crypto_verify_32(x5, xi, y3, yi) {
    return vn(x5, xi, y3, yi, 32);
  }
  function vn(x5, xi, y3, yi, n5) {
    var i5, d5 = 0;
    for (i5 = 0;i5 < n5; ++i5) {
      d5 |= x5[xi + i5] ^ y3[yi + i5];
    }
    return (1 & d5 - 1 >>> 8) - 1;
  }
  function par25519(a5) {
    var d5 = new NativeBuffer(32);
    pack25519(d5, a5);
    return d5[0] & 1;
  }
  function scalarmult(p33, q6, s32) {
    var b23, i5;
    set25519(p33[0], gf0);
    set25519(p33[1], gf1);
    set25519(p33[2], gf1);
    set25519(p33[3], gf0);
    for (i5 = 255;i5 >= 0; --i5) {
      b23 = s32[i5 / 8 | 0] >> (i5 & 7) & 1;
      cswap(p33, q6, b23);
      add(q6, p33);
      add(p33, p33);
      cswap(p33, q6, b23);
    }
  }
  function scalarbase(p33, s32) {
    var q6 = [gf(), gf(), gf(), gf()];
    set25519(q6[0], X32);
    set25519(q6[1], Y23);
    set25519(q6[2], gf1);
    M23(q6[3], X32, Y23);
    scalarmult(p33, q6, s32);
  }
  function set25519(r23, a5) {
    var i5;
    for (i5 = 0;i5 < 16; i5++) {
      r23[i5] = a5[i5] | 0;
    }
  }
  function inv25519(o5, i5) {
    var c23 = gf();
    var a5;
    for (a5 = 0;a5 < 16; ++a5) {
      c23[a5] = i5[a5];
    }
    for (a5 = 253;a5 >= 0; --a5) {
      S2(c23, c23);
      if (a5 !== 2 && a5 !== 4) {
        M23(c23, c23, i5);
      }
    }
    for (a5 = 0;a5 < 16; ++a5) {
      o5[a5] = c23[a5];
    }
  }
  function car25519(o5) {
    var i5, v23, c23 = 1;
    for (i5 = 0;i5 < 16; ++i5) {
      v23 = o5[i5] + c23 + 65535;
      c23 = Math.floor(v23 / 65536);
      o5[i5] = v23 - c23 * 65536;
    }
    o5[0] += c23 - 1 + 37 * (c23 - 1);
  }
  function sel25519(p33, q6, b23) {
    var t5, c23 = ~(b23 - 1);
    for (var i5 = 0;i5 < 16; ++i5) {
      t5 = c23 & (p33[i5] ^ q6[i5]);
      p33[i5] ^= t5;
      q6[i5] ^= t5;
    }
  }
  function gf(init23) {
    var i5, r23 = new Float64Array(16);
    if (init23) {
      for (i5 = 0;i5 < init23.length; ++i5) {
        r23[i5] = init23[i5];
      }
    }
    return r23;
  }
  function A3(o5, a5, b23) {
    for (var i5 = 0;i5 < 16; ++i5) {
      o5[i5] = a5[i5] + b23[i5];
    }
  }
  function Z23(o5, a5, b23) {
    for (var i5 = 0;i5 < 16; ++i5) {
      o5[i5] = a5[i5] - b23[i5];
    }
  }
  function S2(o5, a5) {
    M23(o5, a5, a5);
  }
  function M23(o5, a5, b23) {
    var v23, c23, t0 = 0, t1 = 0, t22 = 0, t32 = 0, t42 = 0, t5 = 0, t6 = 0, t7 = 0, t8 = 0, t9 = 0, t10 = 0, t11 = 0, t12 = 0, t13 = 0, t14 = 0, t15 = 0, t16 = 0, t17 = 0, t18 = 0, t19 = 0, t20 = 0, t21 = 0, t222 = 0, t23 = 0, t24 = 0, t25 = 0, t26 = 0, t27 = 0, t28 = 0, t29 = 0, t30 = 0, b0 = b23[0], b1 = b23[1], b222 = b23[2], b32 = b23[3], b42 = b23[4], b52 = b23[5], b6 = b23[6], b7 = b23[7], b8 = b23[8], b9 = b23[9], b10 = b23[10], b11 = b23[11], b12 = b23[12], b13 = b23[13], b14 = b23[14], b15 = b23[15];
    v23 = a5[0];
    t0 += v23 * b0;
    t1 += v23 * b1;
    t22 += v23 * b222;
    t32 += v23 * b32;
    t42 += v23 * b42;
    t5 += v23 * b52;
    t6 += v23 * b6;
    t7 += v23 * b7;
    t8 += v23 * b8;
    t9 += v23 * b9;
    t10 += v23 * b10;
    t11 += v23 * b11;
    t12 += v23 * b12;
    t13 += v23 * b13;
    t14 += v23 * b14;
    t15 += v23 * b15;
    v23 = a5[1];
    t1 += v23 * b0;
    t22 += v23 * b1;
    t32 += v23 * b222;
    t42 += v23 * b32;
    t5 += v23 * b42;
    t6 += v23 * b52;
    t7 += v23 * b6;
    t8 += v23 * b7;
    t9 += v23 * b8;
    t10 += v23 * b9;
    t11 += v23 * b10;
    t12 += v23 * b11;
    t13 += v23 * b12;
    t14 += v23 * b13;
    t15 += v23 * b14;
    t16 += v23 * b15;
    v23 = a5[2];
    t22 += v23 * b0;
    t32 += v23 * b1;
    t42 += v23 * b222;
    t5 += v23 * b32;
    t6 += v23 * b42;
    t7 += v23 * b52;
    t8 += v23 * b6;
    t9 += v23 * b7;
    t10 += v23 * b8;
    t11 += v23 * b9;
    t12 += v23 * b10;
    t13 += v23 * b11;
    t14 += v23 * b12;
    t15 += v23 * b13;
    t16 += v23 * b14;
    t17 += v23 * b15;
    v23 = a5[3];
    t32 += v23 * b0;
    t42 += v23 * b1;
    t5 += v23 * b222;
    t6 += v23 * b32;
    t7 += v23 * b42;
    t8 += v23 * b52;
    t9 += v23 * b6;
    t10 += v23 * b7;
    t11 += v23 * b8;
    t12 += v23 * b9;
    t13 += v23 * b10;
    t14 += v23 * b11;
    t15 += v23 * b12;
    t16 += v23 * b13;
    t17 += v23 * b14;
    t18 += v23 * b15;
    v23 = a5[4];
    t42 += v23 * b0;
    t5 += v23 * b1;
    t6 += v23 * b222;
    t7 += v23 * b32;
    t8 += v23 * b42;
    t9 += v23 * b52;
    t10 += v23 * b6;
    t11 += v23 * b7;
    t12 += v23 * b8;
    t13 += v23 * b9;
    t14 += v23 * b10;
    t15 += v23 * b11;
    t16 += v23 * b12;
    t17 += v23 * b13;
    t18 += v23 * b14;
    t19 += v23 * b15;
    v23 = a5[5];
    t5 += v23 * b0;
    t6 += v23 * b1;
    t7 += v23 * b222;
    t8 += v23 * b32;
    t9 += v23 * b42;
    t10 += v23 * b52;
    t11 += v23 * b6;
    t12 += v23 * b7;
    t13 += v23 * b8;
    t14 += v23 * b9;
    t15 += v23 * b10;
    t16 += v23 * b11;
    t17 += v23 * b12;
    t18 += v23 * b13;
    t19 += v23 * b14;
    t20 += v23 * b15;
    v23 = a5[6];
    t6 += v23 * b0;
    t7 += v23 * b1;
    t8 += v23 * b222;
    t9 += v23 * b32;
    t10 += v23 * b42;
    t11 += v23 * b52;
    t12 += v23 * b6;
    t13 += v23 * b7;
    t14 += v23 * b8;
    t15 += v23 * b9;
    t16 += v23 * b10;
    t17 += v23 * b11;
    t18 += v23 * b12;
    t19 += v23 * b13;
    t20 += v23 * b14;
    t21 += v23 * b15;
    v23 = a5[7];
    t7 += v23 * b0;
    t8 += v23 * b1;
    t9 += v23 * b222;
    t10 += v23 * b32;
    t11 += v23 * b42;
    t12 += v23 * b52;
    t13 += v23 * b6;
    t14 += v23 * b7;
    t15 += v23 * b8;
    t16 += v23 * b9;
    t17 += v23 * b10;
    t18 += v23 * b11;
    t19 += v23 * b12;
    t20 += v23 * b13;
    t21 += v23 * b14;
    t222 += v23 * b15;
    v23 = a5[8];
    t8 += v23 * b0;
    t9 += v23 * b1;
    t10 += v23 * b222;
    t11 += v23 * b32;
    t12 += v23 * b42;
    t13 += v23 * b52;
    t14 += v23 * b6;
    t15 += v23 * b7;
    t16 += v23 * b8;
    t17 += v23 * b9;
    t18 += v23 * b10;
    t19 += v23 * b11;
    t20 += v23 * b12;
    t21 += v23 * b13;
    t222 += v23 * b14;
    t23 += v23 * b15;
    v23 = a5[9];
    t9 += v23 * b0;
    t10 += v23 * b1;
    t11 += v23 * b222;
    t12 += v23 * b32;
    t13 += v23 * b42;
    t14 += v23 * b52;
    t15 += v23 * b6;
    t16 += v23 * b7;
    t17 += v23 * b8;
    t18 += v23 * b9;
    t19 += v23 * b10;
    t20 += v23 * b11;
    t21 += v23 * b12;
    t222 += v23 * b13;
    t23 += v23 * b14;
    t24 += v23 * b15;
    v23 = a5[10];
    t10 += v23 * b0;
    t11 += v23 * b1;
    t12 += v23 * b222;
    t13 += v23 * b32;
    t14 += v23 * b42;
    t15 += v23 * b52;
    t16 += v23 * b6;
    t17 += v23 * b7;
    t18 += v23 * b8;
    t19 += v23 * b9;
    t20 += v23 * b10;
    t21 += v23 * b11;
    t222 += v23 * b12;
    t23 += v23 * b13;
    t24 += v23 * b14;
    t25 += v23 * b15;
    v23 = a5[11];
    t11 += v23 * b0;
    t12 += v23 * b1;
    t13 += v23 * b222;
    t14 += v23 * b32;
    t15 += v23 * b42;
    t16 += v23 * b52;
    t17 += v23 * b6;
    t18 += v23 * b7;
    t19 += v23 * b8;
    t20 += v23 * b9;
    t21 += v23 * b10;
    t222 += v23 * b11;
    t23 += v23 * b12;
    t24 += v23 * b13;
    t25 += v23 * b14;
    t26 += v23 * b15;
    v23 = a5[12];
    t12 += v23 * b0;
    t13 += v23 * b1;
    t14 += v23 * b222;
    t15 += v23 * b32;
    t16 += v23 * b42;
    t17 += v23 * b52;
    t18 += v23 * b6;
    t19 += v23 * b7;
    t20 += v23 * b8;
    t21 += v23 * b9;
    t222 += v23 * b10;
    t23 += v23 * b11;
    t24 += v23 * b12;
    t25 += v23 * b13;
    t26 += v23 * b14;
    t27 += v23 * b15;
    v23 = a5[13];
    t13 += v23 * b0;
    t14 += v23 * b1;
    t15 += v23 * b222;
    t16 += v23 * b32;
    t17 += v23 * b42;
    t18 += v23 * b52;
    t19 += v23 * b6;
    t20 += v23 * b7;
    t21 += v23 * b8;
    t222 += v23 * b9;
    t23 += v23 * b10;
    t24 += v23 * b11;
    t25 += v23 * b12;
    t26 += v23 * b13;
    t27 += v23 * b14;
    t28 += v23 * b15;
    v23 = a5[14];
    t14 += v23 * b0;
    t15 += v23 * b1;
    t16 += v23 * b222;
    t17 += v23 * b32;
    t18 += v23 * b42;
    t19 += v23 * b52;
    t20 += v23 * b6;
    t21 += v23 * b7;
    t222 += v23 * b8;
    t23 += v23 * b9;
    t24 += v23 * b10;
    t25 += v23 * b11;
    t26 += v23 * b12;
    t27 += v23 * b13;
    t28 += v23 * b14;
    t29 += v23 * b15;
    v23 = a5[15];
    t15 += v23 * b0;
    t16 += v23 * b1;
    t17 += v23 * b222;
    t18 += v23 * b32;
    t19 += v23 * b42;
    t20 += v23 * b52;
    t21 += v23 * b6;
    t222 += v23 * b7;
    t23 += v23 * b8;
    t24 += v23 * b9;
    t25 += v23 * b10;
    t26 += v23 * b11;
    t27 += v23 * b12;
    t28 += v23 * b13;
    t29 += v23 * b14;
    t30 += v23 * b15;
    t0 += 38 * t16;
    t1 += 38 * t17;
    t22 += 38 * t18;
    t32 += 38 * t19;
    t42 += 38 * t20;
    t5 += 38 * t21;
    t6 += 38 * t222;
    t7 += 38 * t23;
    t8 += 38 * t24;
    t9 += 38 * t25;
    t10 += 38 * t26;
    t11 += 38 * t27;
    t12 += 38 * t28;
    t13 += 38 * t29;
    t14 += 38 * t30;
    c23 = 1;
    v23 = t0 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t0 = v23 - c23 * 65536;
    v23 = t1 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t1 = v23 - c23 * 65536;
    v23 = t22 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t22 = v23 - c23 * 65536;
    v23 = t32 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t32 = v23 - c23 * 65536;
    v23 = t42 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t42 = v23 - c23 * 65536;
    v23 = t5 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t5 = v23 - c23 * 65536;
    v23 = t6 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t6 = v23 - c23 * 65536;
    v23 = t7 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t7 = v23 - c23 * 65536;
    v23 = t8 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t8 = v23 - c23 * 65536;
    v23 = t9 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t9 = v23 - c23 * 65536;
    v23 = t10 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t10 = v23 - c23 * 65536;
    v23 = t11 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t11 = v23 - c23 * 65536;
    v23 = t12 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t12 = v23 - c23 * 65536;
    v23 = t13 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t13 = v23 - c23 * 65536;
    v23 = t14 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t14 = v23 - c23 * 65536;
    v23 = t15 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t15 = v23 - c23 * 65536;
    t0 += c23 - 1 + 37 * (c23 - 1);
    c23 = 1;
    v23 = t0 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t0 = v23 - c23 * 65536;
    v23 = t1 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t1 = v23 - c23 * 65536;
    v23 = t22 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t22 = v23 - c23 * 65536;
    v23 = t32 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t32 = v23 - c23 * 65536;
    v23 = t42 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t42 = v23 - c23 * 65536;
    v23 = t5 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t5 = v23 - c23 * 65536;
    v23 = t6 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t6 = v23 - c23 * 65536;
    v23 = t7 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t7 = v23 - c23 * 65536;
    v23 = t8 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t8 = v23 - c23 * 65536;
    v23 = t9 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t9 = v23 - c23 * 65536;
    v23 = t10 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t10 = v23 - c23 * 65536;
    v23 = t11 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t11 = v23 - c23 * 65536;
    v23 = t12 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t12 = v23 - c23 * 65536;
    v23 = t13 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t13 = v23 - c23 * 65536;
    v23 = t14 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t14 = v23 - c23 * 65536;
    v23 = t15 + c23 + 65535;
    c23 = Math.floor(v23 / 65536);
    t15 = v23 - c23 * 65536;
    t0 += c23 - 1 + 37 * (c23 - 1);
    o5[0] = t0;
    o5[1] = t1;
    o5[2] = t22;
    o5[3] = t32;
    o5[4] = t42;
    o5[5] = t5;
    o5[6] = t6;
    o5[7] = t7;
    o5[8] = t8;
    o5[9] = t9;
    o5[10] = t10;
    o5[11] = t11;
    o5[12] = t12;
    o5[13] = t13;
    o5[14] = t14;
    o5[15] = t15;
  }
});
var require_kem = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  require_random();
  require_jsbn();
  module.exports = forge.kem = forge.kem || {};
  var BigInteger = forge.jsbn.BigInteger;
  forge.kem.rsa = {};
  forge.kem.rsa.create = function(kdf, options23) {
    options23 = options23 || {};
    var prng = options23.prng || forge.random;
    var kem = {};
    kem.encrypt = function(publicKey, keyLength) {
      var byteLength2 = Math.ceil(publicKey.n.bitLength() / 8);
      var r23;
      do {
        r23 = new BigInteger(forge.util.bytesToHex(prng.getBytesSync(byteLength2)), 16).mod(publicKey.n);
      } while (r23.compareTo(BigInteger.ONE) <= 0);
      r23 = forge.util.hexToBytes(r23.toString(16));
      var zeros = byteLength2 - r23.length;
      if (zeros > 0) {
        r23 = forge.util.fillString(String.fromCharCode(0), zeros) + r23;
      }
      var encapsulation = publicKey.encrypt(r23, "NONE");
      var key = kdf.generate(r23, keyLength);
      return { encapsulation, key };
    };
    kem.decrypt = function(privateKey, encapsulation, keyLength) {
      var r23 = privateKey.decrypt(encapsulation, "NONE");
      return kdf.generate(r23, keyLength);
    };
    return kem;
  };
  forge.kem.kdf1 = function(md, digestLength) {
    _createKDF(this, md, 0, digestLength || md.digestLength);
  };
  forge.kem.kdf2 = function(md, digestLength) {
    _createKDF(this, md, 1, digestLength || md.digestLength);
  };
  function _createKDF(kdf, md, counterStart, digestLength) {
    kdf.generate = function(x5, length) {
      var key = new forge.util.ByteBuffer;
      var k5 = Math.ceil(length / digestLength) + counterStart;
      var c23 = new forge.util.ByteBuffer;
      for (var i5 = counterStart;i5 < k5; ++i5) {
        c23.putInt32(i5);
        md.start();
        md.update(x5 + c23.getBytes());
        var hash = md.digest();
        key.putBytes(hash.getBytes(digestLength));
      }
      key.truncate(key.length() - length);
      return key.getBytes();
    };
  }
});
var require_log2 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_util33();
  module.exports = forge.log = forge.log || {};
  forge.log.levels = [
    "none",
    "error",
    "warning",
    "info",
    "debug",
    "verbose",
    "max"
  ];
  var sLevelInfo = {};
  var sLoggers = [];
  var sConsoleLogger = null;
  forge.log.LEVEL_LOCKED = 1 << 1;
  forge.log.NO_LEVEL_CHECK = 1 << 2;
  forge.log.INTERPOLATE = 1 << 3;
  for (i5 = 0;i5 < forge.log.levels.length; ++i5) {
    level = forge.log.levels[i5];
    sLevelInfo[level] = {
      index: i5,
      name: level.toUpperCase()
    };
  }
  var level;
  var i5;
  forge.log.logMessage = function(message) {
    var messageLevelIndex = sLevelInfo[message.level].index;
    for (var i22 = 0;i22 < sLoggers.length; ++i22) {
      var logger3 = sLoggers[i22];
      if (logger3.flags & forge.log.NO_LEVEL_CHECK) {
        logger3.f(message);
      } else {
        var loggerLevelIndex = sLevelInfo[logger3.level].index;
        if (messageLevelIndex <= loggerLevelIndex) {
          logger3.f(logger3, message);
        }
      }
    }
  };
  forge.log.prepareStandard = function(message) {
    if (!("standard" in message)) {
      message.standard = sLevelInfo[message.level].name + " [" + message.category + "] " + message.message;
    }
  };
  forge.log.prepareFull = function(message) {
    if (!("full" in message)) {
      var args = [message.message];
      args = args.concat([]);
      message.full = forge.util.format.apply(this, args);
    }
  };
  forge.log.prepareStandardFull = function(message) {
    if (!("standardFull" in message)) {
      forge.log.prepareStandard(message);
      message.standardFull = message.standard;
    }
  };
  if (true) {
    levels = ["error", "warning", "info", "debug", "verbose"];
    for (i5 = 0;i5 < levels.length; ++i5) {
      (function(level2) {
        forge.log[level2] = function(category, message) {
          var args = Array.prototype.slice.call(arguments).slice(2);
          var msg = {
            timestamp: new Date,
            level: level2,
            category,
            message,
            arguments: args
          };
          forge.log.logMessage(msg);
        };
      })(levels[i5]);
    }
  }
  var levels;
  var i5;
  forge.log.makeLogger = function(logFunction) {
    var logger3 = {
      flags: 0,
      f: logFunction
    };
    forge.log.setLevel(logger3, "none");
    return logger3;
  };
  forge.log.setLevel = function(logger3, level2) {
    var rval = false;
    if (logger3 && !(logger3.flags & forge.log.LEVEL_LOCKED)) {
      for (var i22 = 0;i22 < forge.log.levels.length; ++i22) {
        var aValidLevel = forge.log.levels[i22];
        if (level2 == aValidLevel) {
          logger3.level = level2;
          rval = true;
          break;
        }
      }
    }
    return rval;
  };
  forge.log.lock = function(logger3, lock2) {
    if (typeof lock2 === "undefined" || lock2) {
      logger3.flags |= forge.log.LEVEL_LOCKED;
    } else {
      logger3.flags &= ~forge.log.LEVEL_LOCKED;
    }
  };
  forge.log.addLogger = function(logger3) {
    sLoggers.push(logger3);
  };
  if (typeof console !== "undefined" && "log" in console) {
    if (console.error && console.warn && console.info && console.debug) {
      levelHandlers = {
        error: console.error,
        warning: console.warn,
        info: console.info,
        debug: console.debug,
        verbose: console.debug
      };
      f23 = function(logger3, message) {
        forge.log.prepareStandard(message);
        var handler22 = levelHandlers[message.level];
        var args = [message.standard];
        args = args.concat(message["arguments"].slice());
        handler22.apply(console, args);
      };
      logger23 = forge.log.makeLogger(f23);
    } else {
      f23 = function(logger3, message) {
        forge.log.prepareStandardFull(message);
        console.log(message.standardFull);
      };
      logger23 = forge.log.makeLogger(f23);
    }
    forge.log.setLevel(logger23, "debug");
    forge.log.addLogger(logger23);
    sConsoleLogger = logger23;
  } else {
    console = {
      log: function() {
      }
    };
  }
  var logger23;
  var levelHandlers;
  var f23;
  if (sConsoleLogger !== null && typeof window !== "undefined" && window.location) {
    query = new URL(window.location.href).searchParams;
    if (query.has("console.level")) {
      forge.log.setLevel(sConsoleLogger, query.get("console.level").slice(-1)[0]);
    }
    if (query.has("console.lock")) {
      lock = query.get("console.lock").slice(-1)[0];
      if (lock == "true") {
        forge.log.lock(sConsoleLogger);
      }
    }
  }
  var query;
  var lock;
  forge.log.consoleLogger = sConsoleLogger;
});
var require_md_all = __commonJS3((exports, module) => {
  module.exports = require_md();
  require_md53();
  require_sha13();
  require_sha256();
  require_sha512();
});
var require_pkcs7 = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_aes2();
  require_asn1();
  require_des();
  require_oids();
  require_pem();
  require_pkcs7asn1();
  require_random();
  require_util33();
  require_x509();
  var asn1 = forge.asn1;
  var p7 = module.exports = forge.pkcs7 = forge.pkcs7 || {};
  p7.messageFromPem = function(pem) {
    var msg = forge.pem.decode(pem)[0];
    if (msg.type !== "PKCS7") {
      var error = new Error("Could not convert PKCS#7 message from PEM; PEM " + 'header type is not "PKCS#7".');
      error.headerType = msg.type;
      throw error;
    }
    if (msg.procType && msg.procType.type === "ENCRYPTED") {
      throw new Error("Could not convert PKCS#7 message from PEM; PEM is encrypted.");
    }
    var obj = asn1.fromDer(msg.body);
    return p7.messageFromAsn1(obj);
  };
  p7.messageToPem = function(msg, maxline) {
    var pemObj = {
      type: "PKCS7",
      body: asn1.toDer(msg.toAsn1()).getBytes()
    };
    return forge.pem.encode(pemObj, { maxline });
  };
  p7.messageFromAsn1 = function(obj) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, p7.asn1.contentInfoValidator, capture, errors)) {
      var error = new Error("Cannot read PKCS#7 message. " + "ASN.1 object is not an PKCS#7 ContentInfo.");
      error.errors = errors;
      throw error;
    }
    var contentType = asn1.derToOid(capture.contentType);
    var msg;
    switch (contentType) {
      case forge.pki.oids.envelopedData:
        msg = p7.createEnvelopedData();
        break;
      case forge.pki.oids.encryptedData:
        msg = p7.createEncryptedData();
        break;
      case forge.pki.oids.signedData:
        msg = p7.createSignedData();
        break;
      default:
        throw new Error("Cannot read PKCS#7 message. ContentType with OID " + contentType + " is not (yet) supported.");
    }
    msg.fromAsn1(capture.content.value[0]);
    return msg;
  };
  p7.createSignedData = function() {
    var msg = null;
    msg = {
      type: forge.pki.oids.signedData,
      version: 1,
      certificates: [],
      crls: [],
      signers: [],
      digestAlgorithmIdentifiers: [],
      contentInfo: null,
      signerInfos: [],
      fromAsn1: function(obj) {
        _fromAsn1(msg, obj, p7.asn1.signedDataValidator);
        msg.certificates = [];
        msg.crls = [];
        msg.digestAlgorithmIdentifiers = [];
        msg.contentInfo = null;
        msg.signerInfos = [];
        if (msg.rawCapture.certificates) {
          var certs = msg.rawCapture.certificates.value;
          for (var i5 = 0;i5 < certs.length; ++i5) {
            msg.certificates.push(forge.pki.certificateFromAsn1(certs[i5]));
          }
        }
      },
      toAsn1: function() {
        if (!msg.contentInfo) {
          msg.sign();
        }
        var certs = [];
        for (var i5 = 0;i5 < msg.certificates.length; ++i5) {
          certs.push(forge.pki.certificateToAsn1(msg.certificates[i5]));
        }
        var crls = [];
        var signedData = asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(msg.version).getBytes()),
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, msg.digestAlgorithmIdentifiers),
            msg.contentInfo
          ])
        ]);
        if (certs.length > 0) {
          signedData.value[0].value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, certs));
        }
        if (crls.length > 0) {
          signedData.value[0].value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 1, true, crls));
        }
        signedData.value[0].value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, msg.signerInfos));
        return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(msg.type).getBytes()),
          signedData
        ]);
      },
      addSigner: function(signer) {
        var issuer = signer.issuer;
        var serialNumber = signer.serialNumber;
        if (signer.certificate) {
          var cert = signer.certificate;
          if (typeof cert === "string") {
            cert = forge.pki.certificateFromPem(cert);
          }
          issuer = cert.issuer.attributes;
          serialNumber = cert.serialNumber;
        }
        var key = signer.key;
        if (!key) {
          throw new Error("Could not add PKCS#7 signer; no private key specified.");
        }
        if (typeof key === "string") {
          key = forge.pki.privateKeyFromPem(key);
        }
        var digestAlgorithm = signer.digestAlgorithm || forge.pki.oids.sha1;
        switch (digestAlgorithm) {
          case forge.pki.oids.sha1:
          case forge.pki.oids.sha256:
          case forge.pki.oids.sha384:
          case forge.pki.oids.sha512:
          case forge.pki.oids.md5:
            break;
          default:
            throw new Error("Could not add PKCS#7 signer; unknown message digest algorithm: " + digestAlgorithm);
        }
        var authenticatedAttributes = signer.authenticatedAttributes || [];
        if (authenticatedAttributes.length > 0) {
          var contentType = false;
          var messageDigest = false;
          for (var i5 = 0;i5 < authenticatedAttributes.length; ++i5) {
            var attr = authenticatedAttributes[i5];
            if (!contentType && attr.type === forge.pki.oids.contentType) {
              contentType = true;
              if (messageDigest) {
                break;
              }
              continue;
            }
            if (!messageDigest && attr.type === forge.pki.oids.messageDigest) {
              messageDigest = true;
              if (contentType) {
                break;
              }
              continue;
            }
          }
          if (!contentType || !messageDigest) {
            throw new Error("Invalid signer.authenticatedAttributes. If " + "signer.authenticatedAttributes is specified, then it must " + "contain at least two attributes, PKCS #9 content-type and " + "PKCS #9 message-digest.");
          }
        }
        msg.signers.push({
          key,
          version: 1,
          issuer,
          serialNumber,
          digestAlgorithm,
          signatureAlgorithm: forge.pki.oids.rsaEncryption,
          signature: null,
          authenticatedAttributes,
          unauthenticatedAttributes: []
        });
      },
      sign: function(options23) {
        options23 = options23 || {};
        if (typeof msg.content !== "object" || msg.contentInfo === null) {
          msg.contentInfo = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(forge.pki.oids.data).getBytes())
          ]);
          if ("content" in msg) {
            var content;
            if (msg.content instanceof forge.util.ByteBuffer) {
              content = msg.content.bytes();
            } else if (typeof msg.content === "string") {
              content = forge.util.encodeUtf8(msg.content);
            }
            if (options23.detached) {
              msg.detachedContent = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, content);
            } else {
              msg.contentInfo.value.push(asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
                asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, content)
              ]));
            }
          }
        }
        if (msg.signers.length === 0) {
          return;
        }
        var mds = addDigestAlgorithmIds();
        addSignerInfos(mds);
      },
      verify: function() {
        throw new Error("PKCS#7 signature verification not yet implemented.");
      },
      addCertificate: function(cert) {
        if (typeof cert === "string") {
          cert = forge.pki.certificateFromPem(cert);
        }
        msg.certificates.push(cert);
      },
      addCertificateRevokationList: function(crl) {
        throw new Error("PKCS#7 CRL support not yet implemented.");
      }
    };
    return msg;
    function addDigestAlgorithmIds() {
      var mds = {};
      for (var i5 = 0;i5 < msg.signers.length; ++i5) {
        var signer = msg.signers[i5];
        var oid = signer.digestAlgorithm;
        if (!(oid in mds)) {
          mds[oid] = forge.md[forge.pki.oids[oid]].create();
        }
        if (signer.authenticatedAttributes.length === 0) {
          signer.md = mds[oid];
        } else {
          signer.md = forge.md[forge.pki.oids[oid]].create();
        }
      }
      msg.digestAlgorithmIdentifiers = [];
      for (var oid in mds) {
        msg.digestAlgorithmIdentifiers.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(oid).getBytes()),
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
        ]));
      }
      return mds;
    }
    function addSignerInfos(mds) {
      var content;
      if (msg.detachedContent) {
        content = msg.detachedContent;
      } else {
        content = msg.contentInfo.value[1];
        content = content.value[0];
      }
      if (!content) {
        throw new Error("Could not sign PKCS#7 message; there is no content to sign.");
      }
      var contentType = asn1.derToOid(msg.contentInfo.value[0].value);
      var bytes = asn1.toDer(content);
      bytes.getByte();
      asn1.getBerValueLength(bytes);
      bytes = bytes.getBytes();
      for (var oid in mds) {
        mds[oid].start().update(bytes);
      }
      var signingTime = new Date;
      for (var i5 = 0;i5 < msg.signers.length; ++i5) {
        var signer = msg.signers[i5];
        if (signer.authenticatedAttributes.length === 0) {
          if (contentType !== forge.pki.oids.data) {
            throw new Error("Invalid signer; authenticatedAttributes must be present " + "when the ContentInfo content type is not PKCS#7 Data.");
          }
        } else {
          signer.authenticatedAttributesAsn1 = asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, []);
          var attrsAsn1 = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, []);
          for (var ai = 0;ai < signer.authenticatedAttributes.length; ++ai) {
            var attr = signer.authenticatedAttributes[ai];
            if (attr.type === forge.pki.oids.messageDigest) {
              attr.value = mds[signer.digestAlgorithm].digest();
            } else if (attr.type === forge.pki.oids.signingTime) {
              if (!attr.value) {
                attr.value = signingTime;
              }
            }
            attrsAsn1.value.push(_attributeToAsn1(attr));
            signer.authenticatedAttributesAsn1.value.push(_attributeToAsn1(attr));
          }
          bytes = asn1.toDer(attrsAsn1).getBytes();
          signer.md.start().update(bytes);
        }
        signer.signature = signer.key.sign(signer.md, "RSASSA-PKCS1-V1_5");
      }
      msg.signerInfos = _signersToAsn1(msg.signers);
    }
  };
  p7.createEncryptedData = function() {
    var msg = null;
    msg = {
      type: forge.pki.oids.encryptedData,
      version: 0,
      encryptedContent: {
        algorithm: forge.pki.oids["aes256-CBC"]
      },
      fromAsn1: function(obj) {
        _fromAsn1(msg, obj, p7.asn1.encryptedDataValidator);
      },
      decrypt: function(key) {
        if (key !== undefined) {
          msg.encryptedContent.key = key;
        }
        _decryptContent(msg);
      }
    };
    return msg;
  };
  p7.createEnvelopedData = function() {
    var msg = null;
    msg = {
      type: forge.pki.oids.envelopedData,
      version: 0,
      recipients: [],
      encryptedContent: {
        algorithm: forge.pki.oids["aes256-CBC"]
      },
      fromAsn1: function(obj) {
        var capture = _fromAsn1(msg, obj, p7.asn1.envelopedDataValidator);
        msg.recipients = _recipientsFromAsn1(capture.recipientInfos.value);
      },
      toAsn1: function() {
        return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
          asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(msg.type).getBytes()),
          asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
            asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(msg.version).getBytes()),
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, _recipientsToAsn1(msg.recipients)),
              asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, _encryptedContentToAsn1(msg.encryptedContent))
            ])
          ])
        ]);
      },
      findRecipient: function(cert) {
        var sAttr = cert.issuer.attributes;
        for (var i5 = 0;i5 < msg.recipients.length; ++i5) {
          var r23 = msg.recipients[i5];
          var rAttr = r23.issuer;
          if (r23.serialNumber !== cert.serialNumber) {
            continue;
          }
          if (rAttr.length !== sAttr.length) {
            continue;
          }
          var match = true;
          for (var j23 = 0;j23 < sAttr.length; ++j23) {
            if (rAttr[j23].type !== sAttr[j23].type || rAttr[j23].value !== sAttr[j23].value) {
              match = false;
              break;
            }
          }
          if (match) {
            return r23;
          }
        }
        return null;
      },
      decrypt: function(recipient, privKey) {
        if (msg.encryptedContent.key === undefined && recipient !== undefined && privKey !== undefined) {
          switch (recipient.encryptedContent.algorithm) {
            case forge.pki.oids.rsaEncryption:
            case forge.pki.oids.desCBC:
              var key = privKey.decrypt(recipient.encryptedContent.content);
              msg.encryptedContent.key = forge.util.createBuffer(key);
              break;
            default:
              throw new Error("Unsupported asymmetric cipher, " + "OID " + recipient.encryptedContent.algorithm);
          }
        }
        _decryptContent(msg);
      },
      addRecipient: function(cert) {
        msg.recipients.push({
          version: 0,
          issuer: cert.issuer.attributes,
          serialNumber: cert.serialNumber,
          encryptedContent: {
            algorithm: forge.pki.oids.rsaEncryption,
            key: cert.publicKey
          }
        });
      },
      encrypt: function(key, cipher) {
        if (msg.encryptedContent.content === undefined) {
          cipher = cipher || msg.encryptedContent.algorithm;
          key = key || msg.encryptedContent.key;
          var keyLen, ivLen, ciphFn;
          switch (cipher) {
            case forge.pki.oids["aes128-CBC"]:
              keyLen = 16;
              ivLen = 16;
              ciphFn = forge.aes.createEncryptionCipher;
              break;
            case forge.pki.oids["aes192-CBC"]:
              keyLen = 24;
              ivLen = 16;
              ciphFn = forge.aes.createEncryptionCipher;
              break;
            case forge.pki.oids["aes256-CBC"]:
              keyLen = 32;
              ivLen = 16;
              ciphFn = forge.aes.createEncryptionCipher;
              break;
            case forge.pki.oids["des-EDE3-CBC"]:
              keyLen = 24;
              ivLen = 8;
              ciphFn = forge.des.createEncryptionCipher;
              break;
            default:
              throw new Error("Unsupported symmetric cipher, OID " + cipher);
          }
          if (key === undefined) {
            key = forge.util.createBuffer(forge.random.getBytes(keyLen));
          } else if (key.length() != keyLen) {
            throw new Error("Symmetric key has wrong length; " + "got " + key.length() + " bytes, expected " + keyLen + ".");
          }
          msg.encryptedContent.algorithm = cipher;
          msg.encryptedContent.key = key;
          msg.encryptedContent.parameter = forge.util.createBuffer(forge.random.getBytes(ivLen));
          var ciph = ciphFn(key);
          ciph.start(msg.encryptedContent.parameter.copy());
          ciph.update(msg.content);
          if (!ciph.finish()) {
            throw new Error("Symmetric encryption failed.");
          }
          msg.encryptedContent.content = ciph.output;
        }
        for (var i5 = 0;i5 < msg.recipients.length; ++i5) {
          var recipient = msg.recipients[i5];
          if (recipient.encryptedContent.content !== undefined) {
            continue;
          }
          switch (recipient.encryptedContent.algorithm) {
            case forge.pki.oids.rsaEncryption:
              recipient.encryptedContent.content = recipient.encryptedContent.key.encrypt(msg.encryptedContent.key.data);
              break;
            default:
              throw new Error("Unsupported asymmetric cipher, OID " + recipient.encryptedContent.algorithm);
          }
        }
      }
    };
    return msg;
  };
  function _recipientFromAsn1(obj) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, p7.asn1.recipientInfoValidator, capture, errors)) {
      var error = new Error("Cannot read PKCS#7 RecipientInfo. " + "ASN.1 object is not an PKCS#7 RecipientInfo.");
      error.errors = errors;
      throw error;
    }
    return {
      version: capture.version.charCodeAt(0),
      issuer: forge.pki.RDNAttributesAsArray(capture.issuer),
      serialNumber: forge.util.createBuffer(capture.serial).toHex(),
      encryptedContent: {
        algorithm: asn1.derToOid(capture.encAlgorithm),
        parameter: capture.encParameter ? capture.encParameter.value : undefined,
        content: capture.encKey
      }
    };
  }
  function _recipientToAsn1(obj) {
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(obj.version).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        forge.pki.distinguishedNameToAsn1({ attributes: obj.issuer }),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, forge.util.hexToBytes(obj.serialNumber))
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(obj.encryptedContent.algorithm).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, obj.encryptedContent.content)
    ]);
  }
  function _recipientsFromAsn1(infos) {
    var ret = [];
    for (var i5 = 0;i5 < infos.length; ++i5) {
      ret.push(_recipientFromAsn1(infos[i5]));
    }
    return ret;
  }
  function _recipientsToAsn1(recipients) {
    var ret = [];
    for (var i5 = 0;i5 < recipients.length; ++i5) {
      ret.push(_recipientToAsn1(recipients[i5]));
    }
    return ret;
  }
  function _signerToAsn1(obj) {
    var rval = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, asn1.integerToDer(obj.version).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        forge.pki.distinguishedNameToAsn1({ attributes: obj.issuer }),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.INTEGER, false, forge.util.hexToBytes(obj.serialNumber))
      ]),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(obj.digestAlgorithm).getBytes()),
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
      ])
    ]);
    if (obj.authenticatedAttributesAsn1) {
      rval.value.push(obj.authenticatedAttributesAsn1);
    }
    rval.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(obj.signatureAlgorithm).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.NULL, false, "")
    ]));
    rval.value.push(asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, obj.signature));
    if (obj.unauthenticatedAttributes.length > 0) {
      var attrsAsn1 = asn1.create(asn1.Class.CONTEXT_SPECIFIC, 1, true, []);
      for (var i5 = 0;i5 < obj.unauthenticatedAttributes.length; ++i5) {
        var attr = obj.unauthenticatedAttributes[i5];
        attrsAsn1.values.push(_attributeToAsn1(attr));
      }
      rval.value.push(attrsAsn1);
    }
    return rval;
  }
  function _signersToAsn1(signers) {
    var ret = [];
    for (var i5 = 0;i5 < signers.length; ++i5) {
      ret.push(_signerToAsn1(signers[i5]));
    }
    return ret;
  }
  function _attributeToAsn1(attr) {
    var value;
    if (attr.type === forge.pki.oids.contentType) {
      value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(attr.value).getBytes());
    } else if (attr.type === forge.pki.oids.messageDigest) {
      value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, attr.value.bytes());
    } else if (attr.type === forge.pki.oids.signingTime) {
      var jan_1_1950 = new Date("1950-01-01T00:00:00Z");
      var jan_1_2050 = new Date("2050-01-01T00:00:00Z");
      var date = attr.value;
      if (typeof date === "string") {
        var timestamp2 = Date.parse(date);
        if (!isNaN(timestamp2)) {
          date = new Date(timestamp2);
        } else if (date.length === 13) {
          date = asn1.utcTimeToDate(date);
        } else {
          date = asn1.generalizedTimeToDate(date);
        }
      }
      if (date >= jan_1_1950 && date < jan_1_2050) {
        value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.UTCTIME, false, asn1.dateToUtcTime(date));
      } else {
        value = asn1.create(asn1.Class.UNIVERSAL, asn1.Type.GENERALIZEDTIME, false, asn1.dateToGeneralizedTime(date));
      }
    }
    return asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(attr.type).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SET, true, [
        value
      ])
    ]);
  }
  function _encryptedContentToAsn1(ec) {
    return [
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(forge.pki.oids.data).getBytes()),
      asn1.create(asn1.Class.UNIVERSAL, asn1.Type.SEQUENCE, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OID, false, asn1.oidToDer(ec.algorithm).getBytes()),
        !ec.parameter ? undefined : asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, ec.parameter.getBytes())
      ]),
      asn1.create(asn1.Class.CONTEXT_SPECIFIC, 0, true, [
        asn1.create(asn1.Class.UNIVERSAL, asn1.Type.OCTETSTRING, false, ec.content.getBytes())
      ])
    ];
  }
  function _fromAsn1(msg, obj, validator) {
    var capture = {};
    var errors = [];
    if (!asn1.validate(obj, validator, capture, errors)) {
      var error = new Error("Cannot read PKCS#7 message. " + "ASN.1 object is not a supported PKCS#7 message.");
      error.errors = error;
      throw error;
    }
    var contentType = asn1.derToOid(capture.contentType);
    if (contentType !== forge.pki.oids.data) {
      throw new Error("Unsupported PKCS#7 message. " + "Only wrapped ContentType Data supported.");
    }
    if (capture.encryptedContent) {
      var content = "";
      if (forge.util.isArray(capture.encryptedContent)) {
        for (var i5 = 0;i5 < capture.encryptedContent.length; ++i5) {
          if (capture.encryptedContent[i5].type !== asn1.Type.OCTETSTRING) {
            throw new Error("Malformed PKCS#7 message, expecting encrypted " + "content constructed of only OCTET STRING objects.");
          }
          content += capture.encryptedContent[i5].value;
        }
      } else {
        content = capture.encryptedContent;
      }
      msg.encryptedContent = {
        algorithm: asn1.derToOid(capture.encAlgorithm),
        parameter: forge.util.createBuffer(capture.encParameter.value),
        content: forge.util.createBuffer(content)
      };
    }
    if (capture.content) {
      var content = "";
      if (forge.util.isArray(capture.content)) {
        for (var i5 = 0;i5 < capture.content.length; ++i5) {
          if (capture.content[i5].type !== asn1.Type.OCTETSTRING) {
            throw new Error("Malformed PKCS#7 message, expecting " + "content constructed of only OCTET STRING objects.");
          }
          content += capture.content[i5].value;
        }
      } else {
        content = capture.content;
      }
      msg.content = forge.util.createBuffer(content);
    }
    msg.version = capture.version.charCodeAt(0);
    msg.rawCapture = capture;
    return capture;
  }
  function _decryptContent(msg) {
    if (msg.encryptedContent.key === undefined) {
      throw new Error("Symmetric key not available.");
    }
    if (msg.content === undefined) {
      var ciph;
      switch (msg.encryptedContent.algorithm) {
        case forge.pki.oids["aes128-CBC"]:
        case forge.pki.oids["aes192-CBC"]:
        case forge.pki.oids["aes256-CBC"]:
          ciph = forge.aes.createDecryptionCipher(msg.encryptedContent.key);
          break;
        case forge.pki.oids["desCBC"]:
        case forge.pki.oids["des-EDE3-CBC"]:
          ciph = forge.des.createDecryptionCipher(msg.encryptedContent.key);
          break;
        default:
          throw new Error("Unsupported symmetric cipher, OID " + msg.encryptedContent.algorithm);
      }
      ciph.start(msg.encryptedContent.parameter);
      ciph.update(msg.encryptedContent.content);
      if (!ciph.finish()) {
        throw new Error("Symmetric decryption failed.");
      }
      msg.content = ciph.output;
    }
  }
});
var require_ssh = __commonJS3((exports, module) => {
  var forge = require_forge();
  require_aes2();
  require_hmac2();
  require_md53();
  require_sha13();
  require_util33();
  var ssh = module.exports = forge.ssh = forge.ssh || {};
  ssh.privateKeyToPutty = function(privateKey, passphrase, comment) {
    comment = comment || "";
    passphrase = passphrase || "";
    var algorithm = "ssh-rsa";
    var encryptionAlgorithm = passphrase === "" ? "none" : "aes256-cbc";
    var ppk = "PuTTY-User-Key-File-2: " + algorithm + "\r\n";
    ppk += "Encryption: " + encryptionAlgorithm + "\r\n";
    ppk += "Comment: " + comment + "\r\n";
    var pubbuffer = forge.util.createBuffer();
    _addStringToBuffer(pubbuffer, algorithm);
    _addBigIntegerToBuffer(pubbuffer, privateKey.e);
    _addBigIntegerToBuffer(pubbuffer, privateKey.n);
    var pub = forge.util.encode64(pubbuffer.bytes(), 64);
    var length = Math.floor(pub.length / 66) + 1;
    ppk += "Public-Lines: " + length + "\r\n";
    ppk += pub;
    var privbuffer = forge.util.createBuffer();
    _addBigIntegerToBuffer(privbuffer, privateKey.d);
    _addBigIntegerToBuffer(privbuffer, privateKey.p);
    _addBigIntegerToBuffer(privbuffer, privateKey.q);
    _addBigIntegerToBuffer(privbuffer, privateKey.qInv);
    var priv;
    if (!passphrase) {
      priv = forge.util.encode64(privbuffer.bytes(), 64);
    } else {
      var encLen = privbuffer.length() + 16 - 1;
      encLen -= encLen % 16;
      var padding = _sha1(privbuffer.bytes());
      padding.truncate(padding.length() - encLen + privbuffer.length());
      privbuffer.putBuffer(padding);
      var aeskey = forge.util.createBuffer();
      aeskey.putBuffer(_sha1("\0\0\0\0", passphrase));
      aeskey.putBuffer(_sha1("\0\0\0\x01", passphrase));
      var cipher = forge.aes.createEncryptionCipher(aeskey.truncate(8), "CBC");
      cipher.start(forge.util.createBuffer().fillWithByte(0, 16));
      cipher.update(privbuffer.copy());
      cipher.finish();
      var encrypted = cipher.output;
      encrypted.truncate(16);
      priv = forge.util.encode64(encrypted.bytes(), 64);
    }
    length = Math.floor(priv.length / 66) + 1;
    ppk += "\r\nPrivate-Lines: " + length + "\r\n";
    ppk += priv;
    var mackey = _sha1("putty-private-key-file-mac-key", passphrase);
    var macbuffer = forge.util.createBuffer();
    _addStringToBuffer(macbuffer, algorithm);
    _addStringToBuffer(macbuffer, encryptionAlgorithm);
    _addStringToBuffer(macbuffer, comment);
    macbuffer.putInt32(pubbuffer.length());
    macbuffer.putBuffer(pubbuffer);
    macbuffer.putInt32(privbuffer.length());
    macbuffer.putBuffer(privbuffer);
    var hmac2 = forge.hmac.create();
    hmac2.start("sha1", mackey);
    hmac2.update(macbuffer.bytes());
    ppk += "\r\nPrivate-MAC: " + hmac2.digest().toHex() + "\r\n";
    return ppk;
  };
  ssh.publicKeyToOpenSSH = function(key, comment) {
    var type2 = "ssh-rsa";
    comment = comment || "";
    var buffer = forge.util.createBuffer();
    _addStringToBuffer(buffer, type2);
    _addBigIntegerToBuffer(buffer, key.e);
    _addBigIntegerToBuffer(buffer, key.n);
    return type2 + " " + forge.util.encode64(buffer.bytes()) + " " + comment;
  };
  ssh.privateKeyToOpenSSH = function(privateKey, passphrase) {
    if (!passphrase) {
      return forge.pki.privateKeyToPem(privateKey);
    }
    return forge.pki.encryptRsaPrivateKey(privateKey, passphrase, { legacy: true, algorithm: "aes128" });
  };
  ssh.getPublicKeyFingerprint = function(key, options23) {
    options23 = options23 || {};
    var md = options23.md || forge.md.md5.create();
    var type2 = "ssh-rsa";
    var buffer = forge.util.createBuffer();
    _addStringToBuffer(buffer, type2);
    _addBigIntegerToBuffer(buffer, key.e);
    _addBigIntegerToBuffer(buffer, key.n);
    md.start();
    md.update(buffer.getBytes());
    var digest = md.digest();
    if (options23.encoding === "hex") {
      var hex = digest.toHex();
      if (options23.delimiter) {
        return hex.match(/.{2}/g).join(options23.delimiter);
      }
      return hex;
    } else if (options23.encoding === "binary") {
      return digest.getBytes();
    } else if (options23.encoding) {
      throw new Error('Unknown encoding "' + options23.encoding + '".');
    }
    return digest;
  };
  function _addBigIntegerToBuffer(buffer, val2) {
    var hexVal = val2.toString(16);
    if (hexVal[0] >= "8") {
      hexVal = "00" + hexVal;
    }
    var bytes = forge.util.hexToBytes(hexVal);
    buffer.putInt32(bytes.length);
    buffer.putBytes(bytes);
  }
  function _addStringToBuffer(buffer, val2) {
    buffer.putInt32(val2.length);
    buffer.putString(val2);
  }
  function _sha1() {
    var sha = forge.md.sha1.create();
    var num = arguments.length;
    for (var i5 = 0;i5 < num; ++i5) {
      sha.update(arguments[i5]);
    }
    return sha.digest();
  }
});
var require_lib23 = __commonJS3((exports, module) => {
  module.exports = require_forge();
  require_aes2();
  require_aesCipherSuites();
  require_asn1();
  require_cipher();
  require_des();
  require_ed25519();
  require_hmac2();
  require_kem();
  require_log2();
  require_md_all();
  require_mgf1();
  require_pbkdf2();
  require_pem();
  require_pkcs1();
  require_pkcs12();
  require_pkcs7();
  require_pki();
  require_prime();
  require_prng();
  require_pss();
  require_random();
  require_rc2();
  require_ssh();
  require_tls();
  require_util33();
});
var __create22 = Object.create;
var __getProtoOf22 = Object.getPrototypeOf;
var __defProp24 = Object.defineProperty;
var __getOwnPropNames22 = Object.getOwnPropertyNames;
var __hasOwnProp22 = Object.prototype.hasOwnProperty;
var __toESM22 = (mod, isNodeMode, target) => {
  target = mod != null ? __create22(__getProtoOf22(mod)) : {};
  const to = isNodeMode || !mod || !mod.__esModule ? __defProp24(target, "default", { value: mod, enumerable: true }) : target;
  for (let key of __getOwnPropNames22(mod))
    if (!__hasOwnProp22.call(to, key))
      __defProp24(to, key, {
        get: () => mod[key],
        enumerable: true
      });
  return to;
};
var __commonJS22 = (cb2, mod) => () => (mod || cb2((mod = { exports: {} }).exports, mod), mod.exports);
var __export5 = (target, all) => {
  for (var name in all)
    __defProp24(target, name, {
      get: all[name],
      enumerable: true,
      configurable: true,
      set: (newValue) => all[name] = () => newValue
    });
};
var __esm3 = (fn, res) => () => (fn && (res = fn(fn = 0)), res);
function isObject8(value) {
  return value !== null && typeof value === "object";
}
function _defu3(baseObject, defaults3, namespace = ".", merger) {
  if (!isObject8(defaults3)) {
    return _defu3(baseObject, {}, namespace, merger);
  }
  const object = Object.assign({}, defaults3);
  for (const key in baseObject) {
    if (key === "__proto__" || key === "constructor") {
      continue;
    }
    const value = baseObject[key];
    if (value === null || value === undefined) {
      continue;
    }
    if (merger && merger(object, key, value, namespace)) {
      continue;
    }
    if (Array.isArray(value) && Array.isArray(object[key])) {
      object[key] = [...value, ...object[key]];
    } else if (isObject8(value) && isObject8(object[key])) {
      object[key] = _defu3(value, object[key], (namespace ? `${namespace}.` : "") + key.toString(), merger);
    } else {
      object[key] = value;
    }
  }
  return object;
}
function createDefu3(merger) {
  return (...arguments_) => arguments_.reduce((p7, c6) => _defu3(p7, c6, "", merger), {});
}
function isPlainObject3(obj) {
  return Object.prototype.toString.call(obj) === "[object Object]";
}
function isLogObj3(arg) {
  if (!isPlainObject3(arg)) {
    return false;
  }
  if (!arg.message && !arg.args) {
    return false;
  }
  if (arg.stack) {
    return false;
  }
  return true;
}

class Consola3 {
  constructor(options3 = {}) {
    const types = options3.types || LogTypes3;
    this.options = defu3({
      ...options3,
      defaults: { ...options3.defaults },
      level: _normalizeLogLevel3(options3.level, types),
      reporters: [...options3.reporters || []]
    }, {
      types: LogTypes3,
      throttle: 1000,
      throttleMin: 5,
      formatOptions: {
        date: true,
        colors: false,
        compact: true
      }
    });
    for (const type2 in types) {
      const defaults3 = {
        type: type2,
        ...this.options.defaults,
        ...types[type2]
      };
      this[type2] = this._wrapLogFn(defaults3);
      this[type2].raw = this._wrapLogFn(defaults3, true);
    }
    if (this.options.mockFn) {
      this.mockTypes();
    }
    this._lastLog = {};
  }
  get level() {
    return this.options.level;
  }
  set level(level) {
    this.options.level = _normalizeLogLevel3(level, this.options.types, this.options.level);
  }
  prompt(message, opts) {
    if (!this.options.prompt) {
      throw new Error("prompt is not supported!");
    }
    return this.options.prompt(message, opts);
  }
  create(options3) {
    const instance = new Consola3({
      ...this.options,
      ...options3
    });
    if (this._mockFn) {
      instance.mockTypes(this._mockFn);
    }
    return instance;
  }
  withDefaults(defaults3) {
    return this.create({
      ...this.options,
      defaults: {
        ...this.options.defaults,
        ...defaults3
      }
    });
  }
  withTag(tag) {
    return this.withDefaults({
      tag: this.options.defaults.tag ? this.options.defaults.tag + ":" + tag : tag
    });
  }
  addReporter(reporter) {
    this.options.reporters.push(reporter);
    return this;
  }
  removeReporter(reporter) {
    if (reporter) {
      const i5 = this.options.reporters.indexOf(reporter);
      if (i5 >= 0) {
        return this.options.reporters.splice(i5, 1);
      }
    } else {
      this.options.reporters.splice(0);
    }
    return this;
  }
  setReporters(reporters) {
    this.options.reporters = Array.isArray(reporters) ? reporters : [reporters];
    return this;
  }
  wrapAll() {
    this.wrapConsole();
    this.wrapStd();
  }
  restoreAll() {
    this.restoreConsole();
    this.restoreStd();
  }
  wrapConsole() {
    for (const type2 in this.options.types) {
      if (!console["__" + type2]) {
        console["__" + type2] = console[type2];
      }
      console[type2] = this[type2].raw;
    }
  }
  restoreConsole() {
    for (const type2 in this.options.types) {
      if (console["__" + type2]) {
        console[type2] = console["__" + type2];
        delete console["__" + type2];
      }
    }
  }
  wrapStd() {
    this._wrapStream(this.options.stdout, "log");
    this._wrapStream(this.options.stderr, "log");
  }
  _wrapStream(stream2, type2) {
    if (!stream2) {
      return;
    }
    if (!stream2.__write) {
      stream2.__write = stream2.write;
    }
    stream2.write = (data2) => {
      this[type2].raw(String(data2).trim());
    };
  }
  restoreStd() {
    this._restoreStream(this.options.stdout);
    this._restoreStream(this.options.stderr);
  }
  _restoreStream(stream2) {
    if (!stream2) {
      return;
    }
    if (stream2.__write) {
      stream2.write = stream2.__write;
      delete stream2.__write;
    }
  }
  pauseLogs() {
    paused3 = true;
  }
  resumeLogs() {
    paused3 = false;
    const _queue = queue23.splice(0);
    for (const item of _queue) {
      item[0]._logFn(item[1], item[2]);
    }
  }
  mockTypes(mockFn) {
    const _mockFn = mockFn || this.options.mockFn;
    this._mockFn = _mockFn;
    if (typeof _mockFn !== "function") {
      return;
    }
    for (const type2 in this.options.types) {
      this[type2] = _mockFn(type2, this.options.types[type2]) || this[type2];
      this[type2].raw = this[type2];
    }
  }
  _wrapLogFn(defaults3, isRaw) {
    return (...args) => {
      if (paused3) {
        queue23.push([this, defaults3, args, isRaw]);
        return;
      }
      return this._logFn(defaults3, args, isRaw);
    };
  }
  _logFn(defaults3, args, isRaw) {
    if ((defaults3.level || 0) > this.level) {
      return false;
    }
    const logObj = {
      date: /* @__PURE__ */ new Date,
      args: [],
      ...defaults3,
      level: _normalizeLogLevel3(defaults3.level, this.options.types)
    };
    if (!isRaw && args.length === 1 && isLogObj3(args[0])) {
      Object.assign(logObj, args[0]);
    } else {
      logObj.args = [...args];
    }
    if (logObj.message) {
      logObj.args.unshift(logObj.message);
      delete logObj.message;
    }
    if (logObj.additional) {
      if (!Array.isArray(logObj.additional)) {
        logObj.additional = logObj.additional.split("\n");
      }
      logObj.args.push("\n" + logObj.additional.join("\n"));
      delete logObj.additional;
    }
    logObj.type = typeof logObj.type === "string" ? logObj.type.toLowerCase() : "log";
    logObj.tag = typeof logObj.tag === "string" ? logObj.tag : "";
    const resolveLog = (newLog = false) => {
      const repeated = (this._lastLog.count || 0) - this.options.throttleMin;
      if (this._lastLog.object && repeated > 0) {
        const args2 = [...this._lastLog.object.args];
        if (repeated > 1) {
          args2.push(`(repeated ${repeated} times)`);
        }
        this._log({ ...this._lastLog.object, args: args2 });
        this._lastLog.count = 1;
      }
      if (newLog) {
        this._lastLog.object = logObj;
        this._log(logObj);
      }
    };
    clearTimeout(this._lastLog.timeout);
    const diffTime = this._lastLog.time && logObj.date ? logObj.date.getTime() - this._lastLog.time.getTime() : 0;
    this._lastLog.time = logObj.date;
    if (diffTime < this.options.throttle) {
      try {
        const serializedLog = JSON.stringify([
          logObj.type,
          logObj.tag,
          logObj.args
        ]);
        const isSameLog = this._lastLog.serialized === serializedLog;
        this._lastLog.serialized = serializedLog;
        if (isSameLog) {
          this._lastLog.count = (this._lastLog.count || 0) + 1;
          if (this._lastLog.count > this.options.throttleMin) {
            this._lastLog.timeout = setTimeout(resolveLog, this.options.throttle);
            return;
          }
        }
      } catch {
      }
    }
    resolveLog(true);
  }
  _log(logObj) {
    for (const reporter of this.options.reporters) {
      reporter.log(logObj, {
        options: this.options
      });
    }
  }
}
function _normalizeLogLevel3(input, types = {}, defaultLevel = 3) {
  if (input === undefined) {
    return defaultLevel;
  }
  if (typeof input === "number") {
    return input;
  }
  if (types[input] && types[input].level !== undefined) {
    return types[input].level;
  }
  return defaultLevel;
}
function createConsola5(options3 = {}) {
  return new Consola3(options3);
}
var LogLevels3;
var LogTypes3;
var defu3;
var paused3 = false;
var queue23;
var init_core4 = __esm3(() => {
  LogLevels3 = {
    silent: Number.NEGATIVE_INFINITY,
    fatal: 0,
    error: 0,
    warn: 1,
    log: 2,
    info: 3,
    success: 3,
    fail: 3,
    ready: 3,
    start: 3,
    box: 3,
    debug: 4,
    trace: 5,
    verbose: Number.POSITIVE_INFINITY
  };
  LogTypes3 = {
    silent: {
      level: -1
    },
    fatal: {
      level: LogLevels3.fatal
    },
    error: {
      level: LogLevels3.error
    },
    warn: {
      level: LogLevels3.warn
    },
    log: {
      level: LogLevels3.log
    },
    info: {
      level: LogLevels3.info
    },
    success: {
      level: LogLevels3.success
    },
    fail: {
      level: LogLevels3.fail
    },
    ready: {
      level: LogLevels3.info
    },
    start: {
      level: LogLevels3.info
    },
    box: {
      level: LogLevels3.info
    },
    debug: {
      level: LogLevels3.debug
    },
    trace: {
      level: LogLevels3.trace
    },
    verbose: {
      level: LogLevels3.verbose
    }
  };
  defu3 = createDefu3();
  queue23 = [];
  Consola3.prototype.add = Consola3.prototype.addReporter;
  Consola3.prototype.remove = Consola3.prototype.removeReporter;
  Consola3.prototype.clear = Consola3.prototype.removeReporter;
  Consola3.prototype.withScope = Consola3.prototype.withTag;
  Consola3.prototype.mock = Consola3.prototype.mockTypes;
  Consola3.prototype.pause = Consola3.prototype.pauseLogs;
  Consola3.prototype.resume = Consola3.prototype.resumeLogs;
});
function parseStack3(stack) {
  const cwd = process.cwd() + sep5;
  const lines = stack.split("\n").splice(1).map((l23) => l23.trim().replace("file://", "").replace(cwd, ""));
  return lines;
}
function writeStream3(data2, stream2) {
  const write = stream2.__write || stream2.write;
  return write.call(stream2, data2);
}

class BasicReporter3 {
  formatStack(stack, opts) {
    return "  " + parseStack3(stack).join("\n  ");
  }
  formatArgs(args, opts) {
    const _args = args.map((arg) => {
      if (arg && typeof arg.stack === "string") {
        return arg.message + "\n" + this.formatStack(arg.stack, opts);
      }
      return arg;
    });
    return formatWithOptions3(opts, ..._args);
  }
  formatDate(date, opts) {
    return opts.date ? date.toLocaleTimeString() : "";
  }
  filterAndJoin(arr) {
    return arr.filter(Boolean).join(" ");
  }
  formatLogObj(logObj, opts) {
    const message = this.formatArgs(logObj.args, opts);
    if (logObj.type === "box") {
      return "\n" + [
        bracket3(logObj.tag),
        logObj.title && logObj.title,
        ...message.split("\n")
      ].filter(Boolean).map((l23) => " > " + l23).join("\n") + "\n";
    }
    return this.filterAndJoin([
      bracket3(logObj.type),
      bracket3(logObj.tag),
      message
    ]);
  }
  log(logObj, ctx) {
    const line = this.formatLogObj(logObj, {
      columns: ctx.options.stdout.columns || 0,
      ...ctx.options.formatOptions
    });
    return writeStream3(line + "\n", logObj.level < 2 ? ctx.options.stderr || process.stderr : ctx.options.stdout || process.stdout);
  }
}
var bracket3 = (x22) => x22 ? `[${x22}]` : "";
var init_consola_06ad8a643 = () => {
};
function replaceClose5(index, string2, close, replace22, head2 = string2.slice(0, Math.max(0, index)) + replace22, tail = string2.slice(Math.max(0, index + close.length)), next = tail.indexOf(close)) {
  return head2 + (next < 0 ? tail : replaceClose5(next, tail, close, replace22));
}
function clearBleed3(index, string2, open, close, replace22) {
  return index < 0 ? open + string2 + close : open + replaceClose5(index, string2, close, replace22) + close;
}
function filterEmpty3(open, close, replace22 = open, at = open.length + 1) {
  return (string2) => string2 || !(string2 === "" || string2 === undefined) ? clearBleed3(("" + string2).indexOf(close, at), string2, open, close, replace22) : "";
}
function init3(open, close, replace22) {
  return filterEmpty3(`\x1B[${open}m`, `\x1B[${close}m`, replace22);
}
function createColors5(useColor = isColorSupported5) {
  return useColor ? colorDefs3 : Object.fromEntries(Object.keys(colorDefs3).map((key) => [key, String]));
}
function getColor5(color, fallback3 = "reset") {
  return colors3[color] || colors3[fallback3];
}
function stripAnsi6(text3) {
  return text3.replace(new RegExp(ansiRegex6, "g"), "");
}
function box3(text3, _opts = {}) {
  const opts = {
    ..._opts,
    style: {
      ...defaultStyle3,
      ..._opts.style
    }
  };
  const textLines = text3.split("\n");
  const boxLines = [];
  const _color = getColor5(opts.style.borderColor);
  const borderStyle = {
    ...typeof opts.style.borderStyle === "string" ? boxStylePresets3[opts.style.borderStyle] || boxStylePresets3.solid : opts.style.borderStyle
  };
  if (_color) {
    for (const key in borderStyle) {
      borderStyle[key] = _color(borderStyle[key]);
    }
  }
  const paddingOffset = opts.style.padding % 2 === 0 ? opts.style.padding : opts.style.padding + 1;
  const height = textLines.length + paddingOffset;
  const width = Math.max(...textLines.map((line) => line.length)) + paddingOffset;
  const widthOffset = width + paddingOffset;
  const leftSpace = opts.style.marginLeft > 0 ? " ".repeat(opts.style.marginLeft) : "";
  if (opts.style.marginTop > 0) {
    boxLines.push("".repeat(opts.style.marginTop));
  }
  if (opts.title) {
    const left = borderStyle.h.repeat(Math.floor((width - stripAnsi6(opts.title).length) / 2));
    const right = borderStyle.h.repeat(width - stripAnsi6(opts.title).length - stripAnsi6(left).length + paddingOffset);
    boxLines.push(`${leftSpace}${borderStyle.tl}${left}${opts.title}${right}${borderStyle.tr}`);
  } else {
    boxLines.push(`${leftSpace}${borderStyle.tl}${borderStyle.h.repeat(widthOffset)}${borderStyle.tr}`);
  }
  const valignOffset = opts.style.valign === "center" ? Math.floor((height - textLines.length) / 2) : opts.style.valign === "top" ? height - textLines.length - paddingOffset : height - textLines.length;
  for (let i5 = 0;i5 < height; i5++) {
    if (i5 < valignOffset || i5 >= valignOffset + textLines.length) {
      boxLines.push(`${leftSpace}${borderStyle.v}${" ".repeat(widthOffset)}${borderStyle.v}`);
    } else {
      const line = textLines[i5 - valignOffset];
      const left = " ".repeat(paddingOffset);
      const right = " ".repeat(width - stripAnsi6(line).length);
      boxLines.push(`${leftSpace}${borderStyle.v}${left}${line}${right}${borderStyle.v}`);
    }
  }
  boxLines.push(`${leftSpace}${borderStyle.bl}${borderStyle.h.repeat(widthOffset)}${borderStyle.br}`);
  if (opts.style.marginBottom > 0) {
    boxLines.push("".repeat(opts.style.marginBottom));
  }
  return boxLines.join("\n");
}
var env23;
var argv3;
var platform4;
var isDisabled3;
var isForced3;
var isWindows3;
var isDumbTerminal3;
var isCompatibleTerminal3;
var isCI5;
var isColorSupported5;
var colorDefs3;
var colors3;
var ansiRegex6;
var boxStylePresets3;
var defaultStyle3;
var init_utils14 = __esm3(() => {
  ({
    env: env23 = {},
    argv: argv3 = [],
    platform: platform4 = ""
  } = typeof process === "undefined" ? {} : process);
  isDisabled3 = "NO_COLOR" in env23 || argv3.includes("--no-color");
  isForced3 = "FORCE_COLOR" in env23 || argv3.includes("--color");
  isWindows3 = platform4 === "win32";
  isDumbTerminal3 = env23.TERM === "dumb";
  isCompatibleTerminal3 = tty6 && tty6.isatty && tty6.isatty(1) && env23.TERM && !isDumbTerminal3;
  isCI5 = "CI" in env23 && (("GITHUB_ACTIONS" in env23) || ("GITLAB_CI" in env23) || ("CIRCLECI" in env23));
  isColorSupported5 = !isDisabled3 && (isForced3 || isWindows3 && !isDumbTerminal3 || isCompatibleTerminal3 || isCI5);
  colorDefs3 = {
    reset: init3(0, 0),
    bold: init3(1, 22, "\x1B[22m\x1B[1m"),
    dim: init3(2, 22, "\x1B[22m\x1B[2m"),
    italic: init3(3, 23),
    underline: init3(4, 24),
    inverse: init3(7, 27),
    hidden: init3(8, 28),
    strikethrough: init3(9, 29),
    black: init3(30, 39),
    red: init3(31, 39),
    green: init3(32, 39),
    yellow: init3(33, 39),
    blue: init3(34, 39),
    magenta: init3(35, 39),
    cyan: init3(36, 39),
    white: init3(37, 39),
    gray: init3(90, 39),
    bgBlack: init3(40, 49),
    bgRed: init3(41, 49),
    bgGreen: init3(42, 49),
    bgYellow: init3(43, 49),
    bgBlue: init3(44, 49),
    bgMagenta: init3(45, 49),
    bgCyan: init3(46, 49),
    bgWhite: init3(47, 49),
    blackBright: init3(90, 39),
    redBright: init3(91, 39),
    greenBright: init3(92, 39),
    yellowBright: init3(93, 39),
    blueBright: init3(94, 39),
    magentaBright: init3(95, 39),
    cyanBright: init3(96, 39),
    whiteBright: init3(97, 39),
    bgBlackBright: init3(100, 49),
    bgRedBright: init3(101, 49),
    bgGreenBright: init3(102, 49),
    bgYellowBright: init3(103, 49),
    bgBlueBright: init3(104, 49),
    bgMagentaBright: init3(105, 49),
    bgCyanBright: init3(106, 49),
    bgWhiteBright: init3(107, 49)
  };
  colors3 = createColors5();
  ansiRegex6 = [
    "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))"
  ].join("|");
  boxStylePresets3 = {
    solid: {
      tl: "\u250C",
      tr: "\u2510",
      bl: "\u2514",
      br: "\u2518",
      h: "\u2500",
      v: "\u2502"
    },
    double: {
      tl: "\u2554",
      tr: "\u2557",
      bl: "\u255A",
      br: "\u255D",
      h: "\u2550",
      v: "\u2551"
    },
    doubleSingle: {
      tl: "\u2553",
      tr: "\u2556",
      bl: "\u2559",
      br: "\u255C",
      h: "\u2500",
      v: "\u2551"
    },
    doubleSingleRounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2500",
      v: "\u2551"
    },
    singleThick: {
      tl: "\u250F",
      tr: "\u2513",
      bl: "\u2517",
      br: "\u251B",
      h: "\u2501",
      v: "\u2503"
    },
    singleDouble: {
      tl: "\u2552",
      tr: "\u2555",
      bl: "\u2558",
      br: "\u255B",
      h: "\u2550",
      v: "\u2502"
    },
    singleDoubleRounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2550",
      v: "\u2502"
    },
    rounded: {
      tl: "\u256D",
      tr: "\u256E",
      bl: "\u2570",
      br: "\u256F",
      h: "\u2500",
      v: "\u2502"
    }
  };
  defaultStyle3 = {
    borderColor: "white",
    borderStyle: "rounded",
    valign: "center",
    padding: 2,
    marginLeft: 1,
    marginTop: 1,
    marginBottom: 1
  };
});
var exports_prompt3 = {};
__export5(exports_prompt3, {
  prompt: () => prompt3
});
function z4({ onlyFirst: t5 = false } = {}) {
  const u5 = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
  return new RegExp(u5, t5 ? undefined : "g");
}
function $22(t5) {
  if (typeof t5 != "string")
    throw new TypeError(`Expected a \`string\`, got \`${typeof t5}\``);
  return t5.replace(z4(), "");
}
function c6(t5, u5 = {}) {
  if (typeof t5 != "string" || t5.length === 0 || (u5 = { ambiguousIsNarrow: true, ...u5 }, t5 = $22(t5), t5.length === 0))
    return 0;
  t5 = t5.replace(Y3(), "  ");
  const F3 = u5.ambiguousIsNarrow ? 1 : 2;
  let e5 = 0;
  for (const s5 of t5) {
    const C4 = s5.codePointAt(0);
    if (C4 <= 31 || C4 >= 127 && C4 <= 159 || C4 >= 768 && C4 <= 879)
      continue;
    switch (K3.eastAsianWidth(s5)) {
      case "F":
      case "W":
        e5 += 2;
        break;
      case "A":
        e5 += F3;
        break;
      default:
        e5 += 1;
    }
  }
  return e5;
}
function U23() {
  const t5 = new Map;
  for (const [u5, F3] of Object.entries(r6)) {
    for (const [e5, s5] of Object.entries(F3))
      r6[e5] = { open: `\x1B[${s5[0]}m`, close: `\x1B[${s5[1]}m` }, F3[e5] = r6[e5], t5.set(s5[0], s5[1]);
    Object.defineProperty(r6, u5, { value: F3, enumerable: false });
  }
  return Object.defineProperty(r6, "codes", { value: t5, enumerable: false }), r6.color.close = "\x1B[39m", r6.bgColor.close = "\x1B[49m", r6.color.ansi = L23(), r6.color.ansi256 = M3(), r6.color.ansi16m = T3(), r6.bgColor.ansi = L23(v7), r6.bgColor.ansi256 = M3(v7), r6.bgColor.ansi16m = T3(v7), Object.defineProperties(r6, { rgbToAnsi256: { value: (u5, F3, e5) => u5 === F3 && F3 === e5 ? u5 < 8 ? 16 : u5 > 248 ? 231 : Math.round((u5 - 8) / 247 * 24) + 232 : 16 + 36 * Math.round(u5 / 255 * 5) + 6 * Math.round(F3 / 255 * 5) + Math.round(e5 / 255 * 5), enumerable: false }, hexToRgb: { value: (u5) => {
    const F3 = /[a-f\d]{6}|[a-f\d]{3}/i.exec(u5.toString(16));
    if (!F3)
      return [0, 0, 0];
    let [e5] = F3;
    e5.length === 3 && (e5 = [...e5].map((C4) => C4 + C4).join(""));
    const s5 = Number.parseInt(e5, 16);
    return [s5 >> 16 & 255, s5 >> 8 & 255, s5 & 255];
  }, enumerable: false }, hexToAnsi256: { value: (u5) => r6.rgbToAnsi256(...r6.hexToRgb(u5)), enumerable: false }, ansi256ToAnsi: { value: (u5) => {
    if (u5 < 8)
      return 30 + u5;
    if (u5 < 16)
      return 90 + (u5 - 8);
    let F3, e5, s5;
    if (u5 >= 232)
      F3 = ((u5 - 232) * 10 + 8) / 255, e5 = F3, s5 = F3;
    else {
      u5 -= 16;
      const i5 = u5 % 36;
      F3 = Math.floor(u5 / 36) / 5, e5 = Math.floor(i5 / 6) / 5, s5 = i5 % 6 / 5;
    }
    const C4 = Math.max(F3, e5, s5) * 2;
    if (C4 === 0)
      return 30;
    let D3 = 30 + (Math.round(s5) << 2 | Math.round(e5) << 1 | Math.round(F3));
    return C4 === 2 && (D3 += 60), D3;
  }, enumerable: false }, rgbToAnsi: { value: (u5, F3, e5) => r6.ansi256ToAnsi(r6.rgbToAnsi256(u5, F3, e5)), enumerable: false }, hexToAnsi: { value: (u5) => r6.ansi256ToAnsi(r6.hexToAnsi256(u5)), enumerable: false } }), r6;
}
function P3(t5, u5, F3) {
  return String(t5).normalize().replace(/\r\n/g, `
`).split(`
`).map((e5) => uD3(e5, u5, F3)).join(`
`);
}
function FD3(t5, u5) {
  if (t5 === u5)
    return;
  const F3 = t5.split(`
`), e5 = u5.split(`
`), s5 = [];
  for (let C4 = 0;C4 < Math.max(F3.length, e5.length); C4++)
    F3[C4] !== e5[C4] && s5.push(C4);
  return s5;
}
function g6(t5, u5) {
  t5.isTTY && t5.setRawMode(u5);
}

class h23 {
  constructor({ render: u5, input: F3 = stdin3, output: e5 = stdout3, ...s5 }, C4 = true) {
    this._track = false, this._cursor = 0, this.state = "initial", this.error = "", this.subscribers = new Map, this._prevFrame = "", this.opts = s5, this.onKeypress = this.onKeypress.bind(this), this.close = this.close.bind(this), this.render = this.render.bind(this), this._render = u5.bind(this), this._track = C4, this.input = F3, this.output = e5;
  }
  prompt() {
    const u5 = new WriteStream3(0);
    return u5._write = (F3, e5, s5) => {
      this._track && (this.value = this.rl.line.replace(/\t/g, ""), this._cursor = this.rl.cursor, this.emit("value", this.value)), s5();
    }, this.input.pipe(u5), this.rl = f6.createInterface({ input: this.input, output: u5, tabSize: 2, prompt: "", escapeCodeTimeout: 50 }), f6.emitKeypressEvents(this.input, this.rl), this.rl.prompt(), this.opts.initialValue !== undefined && this._track && this.rl.write(this.opts.initialValue), this.input.on("keypress", this.onKeypress), g6(this.input, true), this.output.on("resize", this.render), this.render(), new Promise((F3, e5) => {
      this.once("submit", () => {
        this.output.write(src3.cursor.show), this.output.off("resize", this.render), g6(this.input, false), F3(this.value);
      }), this.once("cancel", () => {
        this.output.write(src3.cursor.show), this.output.off("resize", this.render), g6(this.input, false), F3(R23);
      });
    });
  }
  on(u5, F3) {
    const e5 = this.subscribers.get(u5) ?? [];
    e5.push({ cb: F3 }), this.subscribers.set(u5, e5);
  }
  once(u5, F3) {
    const e5 = this.subscribers.get(u5) ?? [];
    e5.push({ cb: F3, once: true }), this.subscribers.set(u5, e5);
  }
  emit(u5, ...F3) {
    const e5 = this.subscribers.get(u5) ?? [], s5 = [];
    for (const C4 of e5)
      C4.cb(...F3), C4.once && s5.push(() => e5.splice(e5.indexOf(C4), 1));
    for (const C4 of s5)
      C4();
  }
  unsubscribe() {
    this.subscribers.clear();
  }
  onKeypress(u5, F3) {
    if (this.state === "error" && (this.state = "active"), F3?.name && !this._track && V3.has(F3.name) && this.emit("cursor", V3.get(F3.name)), F3?.name && tD3.has(F3.name) && this.emit("cursor", F3.name), u5 && (u5.toLowerCase() === "y" || u5.toLowerCase() === "n") && this.emit("confirm", u5.toLowerCase() === "y"), u5 && this.emit("key", u5.toLowerCase()), F3?.name === "return") {
      if (this.opts.validate) {
        const e5 = this.opts.validate(this.value);
        e5 && (this.error = e5, this.state = "error", this.rl.write(this.value));
      }
      this.state !== "error" && (this.state = "submit");
    }
    u5 === "" && (this.state = "cancel"), (this.state === "submit" || this.state === "cancel") && this.emit("finalize"), this.render(), (this.state === "submit" || this.state === "cancel") && this.close();
  }
  close() {
    this.input.unpipe(), this.input.removeListener("keypress", this.onKeypress), this.output.write(`
`), g6(this.input, false), this.rl.close(), this.emit(`${this.state}`, this.value), this.unsubscribe();
  }
  restoreCursor() {
    const u5 = P3(this._prevFrame, process.stdout.columns, { hard: true }).split(`
`).length - 1;
    this.output.write(src3.cursor.move(-999, u5 * -1));
  }
  render() {
    const u5 = P3(this._render(this) ?? "", process.stdout.columns, { hard: true });
    if (u5 !== this._prevFrame) {
      if (this.state === "initial")
        this.output.write(src3.cursor.hide);
      else {
        const F3 = FD3(this._prevFrame, u5);
        if (this.restoreCursor(), F3 && F3?.length === 1) {
          const e5 = F3[0];
          this.output.write(src3.cursor.move(0, e5)), this.output.write(src3.erase.lines(1));
          const s5 = u5.split(`
`);
          this.output.write(s5[e5]), this._prevFrame = u5, this.output.write(src3.cursor.move(0, s5.length - e5 - 1));
          return;
        } else if (F3 && F3?.length > 1) {
          const e5 = F3[0];
          this.output.write(src3.cursor.move(0, e5)), this.output.write(src3.erase.down());
          const C4 = u5.split(`
`).slice(e5);
          this.output.write(C4.join(`
`)), this._prevFrame = u5;
          return;
        }
        this.output.write(src3.erase.down());
      }
      this.output.write(u5), this.state === "initial" && (this.state = "active"), this._prevFrame = u5;
    }
  }
}
async function prompt3(message, opts = {}) {
  if (!opts.type || opts.type === "text") {
    return await text3({
      message,
      defaultValue: opts.default,
      placeholder: opts.placeholder,
      initialValue: opts.initial
    });
  }
  if (opts.type === "confirm") {
    return await confirm3({
      message,
      initialValue: opts.initial
    });
  }
  if (opts.type === "select") {
    return await select3({
      message,
      options: opts.options.map((o5) => typeof o5 === "string" ? { value: o5, label: o5 } : o5)
    });
  }
  if (opts.type === "multiselect") {
    return await multiselect3({
      message,
      options: opts.options.map((o5) => typeof o5 === "string" ? { value: o5, label: o5 } : o5),
      required: opts.required
    });
  }
  throw new Error(`Unknown prompt type: ${opts.type}`);
}
var ESC3 = "\x1B";
var CSI3;
var beep3 = "\x07";
var cursor3;
var scroll3;
var erase3;
var src3;
var picocolors3;
var tty23;
var isColorSupported23;
var formatter3 = (open, close, replace22 = open) => (input) => {
  let string2 = "" + input;
  let index = string2.indexOf(close, open.length);
  return ~index ? open + replaceClose23(string2, close, replace22, index) + close : open + string2 + close;
};
var replaceClose23 = (string2, close, replace22, index) => {
  let start = string2.substring(0, index) + replace22;
  let end = string2.substring(index + close.length);
  let nextIndex = end.indexOf(close);
  return ~nextIndex ? start + replaceClose23(end, close, replace22, nextIndex) : start + end;
};
var createColors23 = (enabled3 = isColorSupported23) => ({
  isColorSupported: enabled3,
  reset: enabled3 ? (s5) => `\x1B[0m${s5}\x1B[0m` : String,
  bold: enabled3 ? formatter3("\x1B[1m", "\x1B[22m", "\x1B[22m\x1B[1m") : String,
  dim: enabled3 ? formatter3("\x1B[2m", "\x1B[22m", "\x1B[22m\x1B[2m") : String,
  italic: enabled3 ? formatter3("\x1B[3m", "\x1B[23m") : String,
  underline: enabled3 ? formatter3("\x1B[4m", "\x1B[24m") : String,
  inverse: enabled3 ? formatter3("\x1B[7m", "\x1B[27m") : String,
  hidden: enabled3 ? formatter3("\x1B[8m", "\x1B[28m") : String,
  strikethrough: enabled3 ? formatter3("\x1B[9m", "\x1B[29m") : String,
  black: enabled3 ? formatter3("\x1B[30m", "\x1B[39m") : String,
  red: enabled3 ? formatter3("\x1B[31m", "\x1B[39m") : String,
  green: enabled3 ? formatter3("\x1B[32m", "\x1B[39m") : String,
  yellow: enabled3 ? formatter3("\x1B[33m", "\x1B[39m") : String,
  blue: enabled3 ? formatter3("\x1B[34m", "\x1B[39m") : String,
  magenta: enabled3 ? formatter3("\x1B[35m", "\x1B[39m") : String,
  cyan: enabled3 ? formatter3("\x1B[36m", "\x1B[39m") : String,
  white: enabled3 ? formatter3("\x1B[37m", "\x1B[39m") : String,
  gray: enabled3 ? formatter3("\x1B[90m", "\x1B[39m") : String,
  bgBlack: enabled3 ? formatter3("\x1B[40m", "\x1B[49m") : String,
  bgRed: enabled3 ? formatter3("\x1B[41m", "\x1B[49m") : String,
  bgGreen: enabled3 ? formatter3("\x1B[42m", "\x1B[49m") : String,
  bgYellow: enabled3 ? formatter3("\x1B[43m", "\x1B[49m") : String,
  bgBlue: enabled3 ? formatter3("\x1B[44m", "\x1B[49m") : String,
  bgMagenta: enabled3 ? formatter3("\x1B[45m", "\x1B[49m") : String,
  bgCyan: enabled3 ? formatter3("\x1B[46m", "\x1B[49m") : String,
  bgWhite: enabled3 ? formatter3("\x1B[47m", "\x1B[49m") : String
});
var picocolorsExports3;
var l23;
var m6;
var G4;
var K3;
var Y3 = function() {
  return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
};
var v7 = 10;
var L23 = (t5 = 0) => (u5) => `\x1B[${u5 + t5}m`;
var M3 = (t5 = 0) => (u5) => `\x1B[${38 + t5};5;${u5}m`;
var T3 = (t5 = 0) => (u5, F3, e5) => `\x1B[${38 + t5};2;${u5};${F3};${e5}m`;
var r6;
var Z3;
var H4;
var q23;
var p7;
var J4 = 39;
var b6 = "\x07";
var W23 = "[";
var Q3 = "]";
var I23 = "m";
var w6;
var N23 = (t5) => `${p7.values().next().value}${W23}${t5}${I23}`;
var j6 = (t5) => `${p7.values().next().value}${w6}${t5}${b6}`;
var X23 = (t5) => t5.split(" ").map((u5) => c6(u5));
var _3 = (t5, u5, F3) => {
  const e5 = [...u5];
  let s5 = false, C4 = false, D3 = c6($22(t5[t5.length - 1]));
  for (const [i5, o5] of e5.entries()) {
    const E3 = c6(o5);
    if (D3 + E3 <= F3 ? t5[t5.length - 1] += o5 : (t5.push(o5), D3 = 0), p7.has(o5) && (s5 = true, C4 = e5.slice(i5 + 1).join("").startsWith(w6)), s5) {
      C4 ? o5 === b6 && (s5 = false, C4 = false) : o5 === I23 && (s5 = false);
      continue;
    }
    D3 += E3, D3 === F3 && i5 < e5.length - 1 && (t5.push(""), D3 = 0);
  }
  !D3 && t5[t5.length - 1].length > 0 && t5.length > 1 && (t5[t5.length - 2] += t5.pop());
};
var DD3 = (t5) => {
  const u5 = t5.split(" ");
  let F3 = u5.length;
  for (;F3 > 0 && !(c6(u5[F3 - 1]) > 0); )
    F3--;
  return F3 === u5.length ? t5 : u5.slice(0, F3).join(" ") + u5.slice(F3).join("");
};
var uD3 = (t5, u5, F3 = {}) => {
  if (F3.trim !== false && t5.trim() === "")
    return "";
  let e5 = "", s5, C4;
  const D3 = X23(t5);
  let i5 = [""];
  for (const [E3, a5] of t5.split(" ").entries()) {
    F3.trim !== false && (i5[i5.length - 1] = i5[i5.length - 1].trimStart());
    let n5 = c6(i5[i5.length - 1]);
    if (E3 !== 0 && (n5 >= u5 && (F3.wordWrap === false || F3.trim === false) && (i5.push(""), n5 = 0), (n5 > 0 || F3.trim === false) && (i5[i5.length - 1] += " ", n5++)), F3.hard && D3[E3] > u5) {
      const B3 = u5 - n5, A3 = 1 + Math.floor((D3[E3] - B3 - 1) / u5);
      Math.floor((D3[E3] - 1) / u5) < A3 && i5.push(""), _3(i5, a5, u5);
      continue;
    }
    if (n5 + D3[E3] > u5 && n5 > 0 && D3[E3] > 0) {
      if (F3.wordWrap === false && n5 < u5) {
        _3(i5, a5, u5);
        continue;
      }
      i5.push("");
    }
    if (n5 + D3[E3] > u5 && F3.wordWrap === false) {
      _3(i5, a5, u5);
      continue;
    }
    i5[i5.length - 1] += a5;
  }
  F3.trim !== false && (i5 = i5.map((E3) => DD3(E3)));
  const o5 = [...i5.join(`
`)];
  for (const [E3, a5] of o5.entries()) {
    if (e5 += a5, p7.has(a5)) {
      const { groups: B3 } = new RegExp(`(?:\\${W23}(?<code>\\d+)m|\\${w6}(?<uri>.*)${b6})`).exec(o5.slice(E3).join("")) || { groups: {} };
      if (B3.code !== undefined) {
        const A3 = Number.parseFloat(B3.code);
        s5 = A3 === J4 ? undefined : A3;
      } else
        B3.uri !== undefined && (C4 = B3.uri.length === 0 ? undefined : B3.uri);
    }
    const n5 = q23.codes.get(Number(s5));
    o5[E3 + 1] === `
` ? (C4 && (e5 += j6("")), s5 && n5 && (e5 += N23(n5))) : a5 === `
` && (s5 && n5 && (e5 += N23(s5)), C4 && (e5 += j6(C4)));
  }
  return e5;
};
var R23;
var V3;
var tD3;
var sD3;
var iD3;
var ED3;
var oD3;
var unicode5;
var s5 = (c23, fallback3) => unicode5 ? c23 : fallback3;
var S_STEP_ACTIVE3;
var S_STEP_CANCEL3;
var S_STEP_ERROR3;
var S_STEP_SUBMIT3;
var S_BAR3 = "";
var S_BAR_END3 = "";
var S_RADIO_ACTIVE3;
var S_RADIO_INACTIVE3;
var S_CHECKBOX_ACTIVE3;
var S_CHECKBOX_SELECTED3;
var S_CHECKBOX_INACTIVE3;
var symbol3 = (state) => {
  switch (state) {
    case "initial":
    case "active": {
      return colors3.cyan(S_STEP_ACTIVE3);
    }
    case "cancel": {
      return colors3.red(S_STEP_CANCEL3);
    }
    case "error": {
      return colors3.yellow(S_STEP_ERROR3);
    }
    case "submit": {
      return colors3.green(S_STEP_SUBMIT3);
    }
  }
};
var text3 = (opts) => {
  return new oD3({
    validate: opts.validate,
    placeholder: opts.placeholder,
    defaultValue: opts.defaultValue,
    initialValue: opts.initialValue,
    render() {
      const title = `${colors3.gray(S_BAR3)}
${symbol3(this.state)} ${opts.message}
`;
      const placeholder = opts.placeholder ? colors3.inverse(opts.placeholder[0]) + colors3.dim(opts.placeholder.slice(1)) : colors3.inverse(colors3.hidden("_"));
      const value = this.value ? this.valueWithCursor : placeholder;
      switch (this.state) {
        case "error": {
          return `${title.trim()}
${colors3.yellow(S_BAR3)} ${value}
${colors3.yellow(S_BAR_END3)} ${colors3.yellow(this.error)}
`;
        }
        case "submit": {
          return `${title}${colors3.gray(S_BAR3)} ${colors3.dim(this.value || opts.placeholder)}`;
        }
        case "cancel": {
          return `${title}${colors3.gray(S_BAR3)} ${colors3.strikethrough(colors3.dim(this.value ?? ""))}${this.value?.trim() ? "\n" + colors3.gray(S_BAR3) : ""}`;
        }
        default: {
          return `${title}${colors3.cyan(S_BAR3)} ${value}
${colors3.cyan(S_BAR_END3)}
`;
        }
      }
    }
  }).prompt();
};
var confirm3 = (opts) => {
  const active = opts.active ?? "Yes";
  const inactive = opts.inactive ?? "No";
  return new sD3({
    active,
    inactive,
    initialValue: opts.initialValue ?? true,
    render() {
      const title = `${colors3.gray(S_BAR3)}
${symbol3(this.state)} ${opts.message}
`;
      const value = this.value ? active : inactive;
      switch (this.state) {
        case "submit": {
          return `${title}${colors3.gray(S_BAR3)} ${colors3.dim(value)}`;
        }
        case "cancel": {
          return `${title}${colors3.gray(S_BAR3)} ${colors3.strikethrough(colors3.dim(value))}
${colors3.gray(S_BAR3)}`;
        }
        default: {
          return `${title}${colors3.cyan(S_BAR3)} ${this.value ? `${colors3.green(S_RADIO_ACTIVE3)} ${active}` : `${colors3.dim(S_RADIO_INACTIVE3)} ${colors3.dim(active)}`} ${colors3.dim("/")} ${this.value ? `${colors3.dim(S_RADIO_INACTIVE3)} ${colors3.dim(inactive)}` : `${colors3.green(S_RADIO_ACTIVE3)} ${inactive}`}
${colors3.cyan(S_BAR_END3)}
`;
        }
      }
    }
  }).prompt();
};
var select3 = (opts) => {
  const opt = (option, state) => {
    const label = option.label ?? String(option.value);
    switch (state) {
      case "active": {
        return `${colors3.green(S_RADIO_ACTIVE3)} ${label} ${option.hint ? colors3.dim(`(${option.hint})`) : ""}`;
      }
      case "selected": {
        return `${colors3.dim(label)}`;
      }
      case "cancelled": {
        return `${colors3.strikethrough(colors3.dim(label))}`;
      }
    }
    return `${colors3.dim(S_RADIO_INACTIVE3)} ${colors3.dim(label)}`;
  };
  return new ED3({
    options: opts.options,
    initialValue: opts.initialValue,
    render() {
      const title = `${colors3.gray(S_BAR3)}
${symbol3(this.state)} ${opts.message}
`;
      switch (this.state) {
        case "submit": {
          return `${title}${colors3.gray(S_BAR3)} ${opt(this.options[this.cursor], "selected")}`;
        }
        case "cancel": {
          return `${title}${colors3.gray(S_BAR3)} ${opt(this.options[this.cursor], "cancelled")}
${colors3.gray(S_BAR3)}`;
        }
        default: {
          return `${title}${colors3.cyan(S_BAR3)} ${this.options.map((option, i5) => opt(option, i5 === this.cursor ? "active" : "inactive")).join(`
${colors3.cyan(S_BAR3)}  `)}
${colors3.cyan(S_BAR_END3)}
`;
        }
      }
    }
  }).prompt();
};
var multiselect3 = (opts) => {
  const opt = (option, state) => {
    const label = option.label ?? String(option.value);
    switch (state) {
      case "active": {
        return `${colors3.cyan(S_CHECKBOX_ACTIVE3)} ${label} ${option.hint ? colors3.dim(`(${option.hint})`) : ""}`;
      }
      case "selected": {
        return `${colors3.green(S_CHECKBOX_SELECTED3)} ${colors3.dim(label)}`;
      }
      case "cancelled": {
        return `${colors3.strikethrough(colors3.dim(label))}`;
      }
      case "active-selected": {
        return `${colors3.green(S_CHECKBOX_SELECTED3)} ${label} ${option.hint ? colors3.dim(`(${option.hint})`) : ""}`;
      }
      case "submitted": {
        return `${colors3.dim(label)}`;
      }
    }
    return `${colors3.dim(S_CHECKBOX_INACTIVE3)} ${colors3.dim(label)}`;
  };
  return new iD3({
    options: opts.options,
    initialValues: opts.initialValues,
    required: opts.required ?? true,
    cursorAt: opts.cursorAt,
    validate(selected) {
      if (this.required && selected.length === 0) {
        return `Please select at least one option.
${colors3.reset(colors3.dim(`Press ${colors3.gray(colors3.bgWhite(colors3.inverse(" space ")))} to select, ${colors3.gray(colors3.bgWhite(colors3.inverse(" enter ")))} to submit`))}`;
      }
    },
    render() {
      const title = `${colors3.gray(S_BAR3)}
${symbol3(this.state)} ${opts.message}
`;
      switch (this.state) {
        case "submit": {
          return `${title}${colors3.gray(S_BAR3)} ${this.options.filter(({ value }) => this.value.includes(value)).map((option) => opt(option, "submitted")).join(colors3.dim(", ")) || colors3.dim("none")}`;
        }
        case "cancel": {
          const label = this.options.filter(({ value }) => this.value.includes(value)).map((option) => opt(option, "cancelled")).join(colors3.dim(", "));
          return `${title}${colors3.gray(S_BAR3)} ${label.trim() ? `${label}
${colors3.gray(S_BAR3)}` : ""}`;
        }
        case "error": {
          const footer = this.error.split("\n").map((ln, i5) => i5 === 0 ? `${colors3.yellow(S_BAR_END3)} ${colors3.yellow(ln)}` : `   ${ln}`).join("\n");
          return title + colors3.yellow(S_BAR3) + "  " + this.options.map((option, i5) => {
            const selected = this.value.includes(option.value);
            const active = i5 === this.cursor;
            if (active && selected) {
              return opt(option, "active-selected");
            }
            if (selected) {
              return opt(option, "selected");
            }
            return opt(option, active ? "active" : "inactive");
          }).join(`
${colors3.yellow(S_BAR3)}  `) + "\n" + footer + "\n";
        }
        default: {
          return `${title}${colors3.cyan(S_BAR3)} ${this.options.map((option, i5) => {
            const selected = this.value.includes(option.value);
            const active = i5 === this.cursor;
            if (active && selected) {
              return opt(option, "active-selected");
            }
            if (selected) {
              return opt(option, "selected");
            }
            return opt(option, active ? "active" : "inactive");
          }).join(`
${colors3.cyan(S_BAR3)}  `)}
${colors3.cyan(S_BAR_END3)}
`;
        }
      }
    }
  }).prompt();
};
var init_prompt3 = __esm3(() => {
  init_consola_36c0034f3();
  init_utils14();
  init_core4();
  init_consola_06ad8a643();
  CSI3 = `${ESC3}[`;
  cursor3 = {
    to(x22, y3) {
      if (!y3)
        return `${CSI3}${x22 + 1}G`;
      return `${CSI3}${y3 + 1};${x22 + 1}H`;
    },
    move(x22, y3) {
      let ret = "";
      if (x22 < 0)
        ret += `${CSI3}${-x22}D`;
      else if (x22 > 0)
        ret += `${CSI3}${x22}C`;
      if (y3 < 0)
        ret += `${CSI3}${-y3}A`;
      else if (y3 > 0)
        ret += `${CSI3}${y3}B`;
      return ret;
    },
    up: (count = 1) => `${CSI3}${count}A`,
    down: (count = 1) => `${CSI3}${count}B`,
    forward: (count = 1) => `${CSI3}${count}C`,
    backward: (count = 1) => `${CSI3}${count}D`,
    nextLine: (count = 1) => `${CSI3}E`.repeat(count),
    prevLine: (count = 1) => `${CSI3}F`.repeat(count),
    left: `${CSI3}G`,
    hide: `${CSI3}?25l`,
    show: `${CSI3}?25h`,
    save: `${ESC3}7`,
    restore: `${ESC3}8`
  };
  scroll3 = {
    up: (count = 1) => `${CSI3}S`.repeat(count),
    down: (count = 1) => `${CSI3}T`.repeat(count)
  };
  erase3 = {
    screen: `${CSI3}2J`,
    up: (count = 1) => `${CSI3}1J`.repeat(count),
    down: (count = 1) => `${CSI3}J`.repeat(count),
    line: `${CSI3}2K`,
    lineEnd: `${CSI3}K`,
    lineStart: `${CSI3}1K`,
    lines(count) {
      let clear = "";
      for (let i5 = 0;i5 < count; i5++)
        clear += this.line + (i5 < count - 1 ? cursor3.up() : "");
      if (count)
        clear += cursor3.left;
      return clear;
    }
  };
  src3 = { cursor: cursor3, scroll: scroll3, erase: erase3, beep: beep3 };
  picocolors3 = { exports: {} };
  tty23 = require$$03;
  isColorSupported23 = !(("NO_COLOR" in process.env) || process.argv.includes("--no-color")) && (("FORCE_COLOR" in process.env) || process.argv.includes("--color") || process.platform === "win32" || tty23.isatty(1) && true || ("CI" in process.env));
  picocolors3.exports = createColors23();
  picocolors3.exports.createColors = createColors23;
  picocolorsExports3 = picocolors3.exports;
  l23 = /* @__PURE__ */ getDefaultExportFromCjs3(picocolorsExports3);
  m6 = {};
  G4 = { get exports() {
    return m6;
  }, set exports(t5) {
    m6 = t5;
  } };
  (function(t5) {
    var u5 = {};
    t5.exports = u5, u5.eastAsianWidth = function(e5) {
      var s23 = e5.charCodeAt(0), C4 = e5.length == 2 ? e5.charCodeAt(1) : 0, D3 = s23;
      return 55296 <= s23 && s23 <= 56319 && 56320 <= C4 && C4 <= 57343 && (s23 &= 1023, C4 &= 1023, D3 = s23 << 10 | C4, D3 += 65536), D3 == 12288 || 65281 <= D3 && D3 <= 65376 || 65504 <= D3 && D3 <= 65510 ? "F" : D3 == 8361 || 65377 <= D3 && D3 <= 65470 || 65474 <= D3 && D3 <= 65479 || 65482 <= D3 && D3 <= 65487 || 65490 <= D3 && D3 <= 65495 || 65498 <= D3 && D3 <= 65500 || 65512 <= D3 && D3 <= 65518 ? "H" : 4352 <= D3 && D3 <= 4447 || 4515 <= D3 && D3 <= 4519 || 4602 <= D3 && D3 <= 4607 || 9001 <= D3 && D3 <= 9002 || 11904 <= D3 && D3 <= 11929 || 11931 <= D3 && D3 <= 12019 || 12032 <= D3 && D3 <= 12245 || 12272 <= D3 && D3 <= 12283 || 12289 <= D3 && D3 <= 12350 || 12353 <= D3 && D3 <= 12438 || 12441 <= D3 && D3 <= 12543 || 12549 <= D3 && D3 <= 12589 || 12593 <= D3 && D3 <= 12686 || 12688 <= D3 && D3 <= 12730 || 12736 <= D3 && D3 <= 12771 || 12784 <= D3 && D3 <= 12830 || 12832 <= D3 && D3 <= 12871 || 12880 <= D3 && D3 <= 13054 || 13056 <= D3 && D3 <= 19903 || 19968 <= D3 && D3 <= 42124 || 42128 <= D3 && D3 <= 42182 || 43360 <= D3 && D3 <= 43388 || 44032 <= D3 && D3 <= 55203 || 55216 <= D3 && D3 <= 55238 || 55243 <= D3 && D3 <= 55291 || 63744 <= D3 && D3 <= 64255 || 65040 <= D3 && D3 <= 65049 || 65072 <= D3 && D3 <= 65106 || 65108 <= D3 && D3 <= 65126 || 65128 <= D3 && D3 <= 65131 || 110592 <= D3 && D3 <= 110593 || 127488 <= D3 && D3 <= 127490 || 127504 <= D3 && D3 <= 127546 || 127552 <= D3 && D3 <= 127560 || 127568 <= D3 && D3 <= 127569 || 131072 <= D3 && D3 <= 194367 || 177984 <= D3 && D3 <= 196605 || 196608 <= D3 && D3 <= 262141 ? "W" : 32 <= D3 && D3 <= 126 || 162 <= D3 && D3 <= 163 || 165 <= D3 && D3 <= 166 || D3 == 172 || D3 == 175 || 10214 <= D3 && D3 <= 10221 || 10629 <= D3 && D3 <= 10630 ? "Na" : D3 == 161 || D3 == 164 || 167 <= D3 && D3 <= 168 || D3 == 170 || 173 <= D3 && D3 <= 174 || 176 <= D3 && D3 <= 180 || 182 <= D3 && D3 <= 186 || 188 <= D3 && D3 <= 191 || D3 == 198 || D3 == 208 || 215 <= D3 && D3 <= 216 || 222 <= D3 && D3 <= 225 || D3 == 230 || 232 <= D3 && D3 <= 234 || 236 <= D3 && D3 <= 237 || D3 == 240 || 242 <= D3 && D3 <= 243 || 247 <= D3 && D3 <= 250 || D3 == 252 || D3 == 254 || D3 == 257 || D3 == 273 || D3 == 275 || D3 == 283 || 294 <= D3 && D3 <= 295 || D3 == 299 || 305 <= D3 && D3 <= 307 || D3 == 312 || 319 <= D3 && D3 <= 322 || D3 == 324 || 328 <= D3 && D3 <= 331 || D3 == 333 || 338 <= D3 && D3 <= 339 || 358 <= D3 && D3 <= 359 || D3 == 363 || D3 == 462 || D3 == 464 || D3 == 466 || D3 == 468 || D3 == 470 || D3 == 472 || D3 == 474 || D3 == 476 || D3 == 593 || D3 == 609 || D3 == 708 || D3 == 711 || 713 <= D3 && D3 <= 715 || D3 == 717 || D3 == 720 || 728 <= D3 && D3 <= 731 || D3 == 733 || D3 == 735 || 768 <= D3 && D3 <= 879 || 913 <= D3 && D3 <= 929 || 931 <= D3 && D3 <= 937 || 945 <= D3 && D3 <= 961 || 963 <= D3 && D3 <= 969 || D3 == 1025 || 1040 <= D3 && D3 <= 1103 || D3 == 1105 || D3 == 8208 || 8211 <= D3 && D3 <= 8214 || 8216 <= D3 && D3 <= 8217 || 8220 <= D3 && D3 <= 8221 || 8224 <= D3 && D3 <= 8226 || 8228 <= D3 && D3 <= 8231 || D3 == 8240 || 8242 <= D3 && D3 <= 8243 || D3 == 8245 || D3 == 8251 || D3 == 8254 || D3 == 8308 || D3 == 8319 || 8321 <= D3 && D3 <= 8324 || D3 == 8364 || D3 == 8451 || D3 == 8453 || D3 == 8457 || D3 == 8467 || D3 == 8470 || 8481 <= D3 && D3 <= 8482 || D3 == 8486 || D3 == 8491 || 8531 <= D3 && D3 <= 8532 || 8539 <= D3 && D3 <= 8542 || 8544 <= D3 && D3 <= 8555 || 8560 <= D3 && D3 <= 8569 || D3 == 8585 || 8592 <= D3 && D3 <= 8601 || 8632 <= D3 && D3 <= 8633 || D3 == 8658 || D3 == 8660 || D3 == 8679 || D3 == 8704 || 8706 <= D3 && D3 <= 8707 || 8711 <= D3 && D3 <= 8712 || D3 == 8715 || D3 == 8719 || D3 == 8721 || D3 == 8725 || D3 == 8730 || 8733 <= D3 && D3 <= 8736 || D3 == 8739 || D3 == 8741 || 8743 <= D3 && D3 <= 8748 || D3 == 8750 || 8756 <= D3 && D3 <= 8759 || 8764 <= D3 && D3 <= 8765 || D3 == 8776 || D3 == 8780 || D3 == 8786 || 8800 <= D3 && D3 <= 8801 || 8804 <= D3 && D3 <= 8807 || 8810 <= D3 && D3 <= 8811 || 8814 <= D3 && D3 <= 8815 || 8834 <= D3 && D3 <= 8835 || 8838 <= D3 && D3 <= 8839 || D3 == 8853 || D3 == 8857 || D3 == 8869 || D3 == 8895 || D3 == 8978 || 9312 <= D3 && D3 <= 9449 || 9451 <= D3 && D3 <= 9547 || 9552 <= D3 && D3 <= 9587 || 9600 <= D3 && D3 <= 9615 || 9618 <= D3 && D3 <= 9621 || 9632 <= D3 && D3 <= 9633 || 9635 <= D3 && D3 <= 9641 || 9650 <= D3 && D3 <= 9651 || 9654 <= D3 && D3 <= 9655 || 9660 <= D3 && D3 <= 9661 || 9664 <= D3 && D3 <= 9665 || 9670 <= D3 && D3 <= 9672 || D3 == 9675 || 9678 <= D3 && D3 <= 9681 || 9698 <= D3 && D3 <= 9701 || D3 == 9711 || 9733 <= D3 && D3 <= 9734 || D3 == 9737 || 9742 <= D3 && D3 <= 9743 || 9748 <= D3 && D3 <= 9749 || D3 == 9756 || D3 == 9758 || D3 == 9792 || D3 == 9794 || 9824 <= D3 && D3 <= 9825 || 9827 <= D3 && D3 <= 9829 || 9831 <= D3 && D3 <= 9834 || 9836 <= D3 && D3 <= 9837 || D3 == 9839 || 9886 <= D3 && D3 <= 9887 || 9918 <= D3 && D3 <= 9919 || 9924 <= D3 && D3 <= 9933 || 9935 <= D3 && D3 <= 9953 || D3 == 9955 || 9960 <= D3 && D3 <= 9983 || D3 == 10045 || D3 == 10071 || 10102 <= D3 && D3 <= 10111 || 11093 <= D3 && D3 <= 11097 || 12872 <= D3 && D3 <= 12879 || 57344 <= D3 && D3 <= 63743 || 65024 <= D3 && D3 <= 65039 || D3 == 65533 || 127232 <= D3 && D3 <= 127242 || 127248 <= D3 && D3 <= 127277 || 127280 <= D3 && D3 <= 127337 || 127344 <= D3 && D3 <= 127386 || 917760 <= D3 && D3 <= 917999 || 983040 <= D3 && D3 <= 1048573 || 1048576 <= D3 && D3 <= 1114109 ? "A" : "N";
    }, u5.characterLength = function(e5) {
      var s23 = this.eastAsianWidth(e5);
      return s23 == "F" || s23 == "W" || s23 == "A" ? 2 : 1;
    };
    function F3(e5) {
      return e5.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]|[^\uD800-\uDFFF]/g) || [];
    }
    u5.length = function(e5) {
      for (var s23 = F3(e5), C4 = 0, D3 = 0;D3 < s23.length; D3++)
        C4 = C4 + this.characterLength(s23[D3]);
      return C4;
    }, u5.slice = function(e5, s23, C4) {
      textLen = u5.length(e5), s23 = s23 || 0, C4 = C4 || 1, s23 < 0 && (s23 = textLen + s23), C4 < 0 && (C4 = textLen + C4);
      for (var D3 = "", i5 = 0, o5 = F3(e5), E3 = 0;E3 < o5.length; E3++) {
        var a5 = o5[E3], n5 = u5.length(a5);
        if (i5 >= s23 - (n5 == 2 ? 1 : 0))
          if (i5 + n5 <= C4)
            D3 += a5;
          else
            break;
        i5 += n5;
      }
      return D3;
    };
  })(G4);
  K3 = m6;
  r6 = { modifier: { reset: [0, 0], bold: [1, 22], dim: [2, 22], italic: [3, 23], underline: [4, 24], overline: [53, 55], inverse: [7, 27], hidden: [8, 28], strikethrough: [9, 29] }, color: { black: [30, 39], red: [31, 39], green: [32, 39], yellow: [33, 39], blue: [34, 39], magenta: [35, 39], cyan: [36, 39], white: [37, 39], blackBright: [90, 39], gray: [90, 39], grey: [90, 39], redBright: [91, 39], greenBright: [92, 39], yellowBright: [93, 39], blueBright: [94, 39], magentaBright: [95, 39], cyanBright: [96, 39], whiteBright: [97, 39] }, bgColor: { bgBlack: [40, 49], bgRed: [41, 49], bgGreen: [42, 49], bgYellow: [43, 49], bgBlue: [44, 49], bgMagenta: [45, 49], bgCyan: [46, 49], bgWhite: [47, 49], bgBlackBright: [100, 49], bgGray: [100, 49], bgGrey: [100, 49], bgRedBright: [101, 49], bgGreenBright: [102, 49], bgYellowBright: [103, 49], bgBlueBright: [104, 49], bgMagentaBright: [105, 49], bgCyanBright: [106, 49], bgWhiteBright: [107, 49] } };
  Object.keys(r6.modifier);
  Z3 = Object.keys(r6.color);
  H4 = Object.keys(r6.bgColor);
  [...Z3];
  q23 = U23();
  p7 = new Set(["\x1B", "\x9B"]);
  w6 = `${Q3}8;;`;
  R23 = Symbol("clack:cancel");
  V3 = new Map([["k", "up"], ["j", "down"], ["h", "left"], ["l", "right"]]);
  tD3 = new Set(["up", "down", "left", "right", "space", "enter"]);
  sD3 = class sD22 extends h23 {
    get cursor() {
      return this.value ? 0 : 1;
    }
    get _value() {
      return this.cursor === 0;
    }
    constructor(u5) {
      super(u5, false), this.value = !!u5.initialValue, this.on("value", () => {
        this.value = this._value;
      }), this.on("confirm", (F3) => {
        this.output.write(src3.cursor.move(0, -1)), this.value = F3, this.state = "submit", this.close();
      }), this.on("cursor", () => {
        this.value = !this.value;
      });
    }
  };
  iD3 = class iD22 extends h23 {
    constructor(u5) {
      super(u5, false), this.cursor = 0, this.options = u5.options, this.value = [...u5.initialValues ?? []], this.cursor = Math.max(this.options.findIndex(({ value: F3 }) => F3 === u5.cursorAt), 0), this.on("key", (F3) => {
        F3 === "a" && this.toggleAll();
      }), this.on("cursor", (F3) => {
        switch (F3) {
          case "left":
          case "up":
            this.cursor = this.cursor === 0 ? this.options.length - 1 : this.cursor - 1;
            break;
          case "down":
          case "right":
            this.cursor = this.cursor === this.options.length - 1 ? 0 : this.cursor + 1;
            break;
          case "space":
            this.toggleValue();
            break;
        }
      });
    }
    get _value() {
      return this.options[this.cursor].value;
    }
    toggleAll() {
      const u5 = this.value.length === this.options.length;
      this.value = u5 ? [] : this.options.map((F3) => F3.value);
    }
    toggleValue() {
      const u5 = this.value.includes(this._value);
      this.value = u5 ? this.value.filter((F3) => F3 !== this._value) : [...this.value, this._value];
    }
  };
  ED3 = class ED22 extends h23 {
    constructor(u5) {
      super(u5, false), this.cursor = 0, this.options = u5.options, this.cursor = this.options.findIndex(({ value: F3 }) => F3 === u5.initialValue), this.cursor === -1 && (this.cursor = 0), this.changeValue(), this.on("cursor", (F3) => {
        switch (F3) {
          case "left":
          case "up":
            this.cursor = this.cursor === 0 ? this.options.length - 1 : this.cursor - 1;
            break;
          case "down":
          case "right":
            this.cursor = this.cursor === this.options.length - 1 ? 0 : this.cursor + 1;
            break;
        }
        this.changeValue();
      });
    }
    get _value() {
      return this.options[this.cursor];
    }
    changeValue() {
      this.value = this._value.value;
    }
  };
  oD3 = class oD22 extends h23 {
    constructor(u5) {
      super(u5), this.valueWithCursor = "", this.on("finalize", () => {
        this.value || (this.value = u5.defaultValue), this.valueWithCursor = this.value;
      }), this.on("value", () => {
        if (this.cursor >= this.value.length)
          this.valueWithCursor = `${this.value}${l23.inverse(l23.hidden("_"))}`;
        else {
          const F3 = this.value.slice(0, this.cursor), e5 = this.value.slice(this.cursor);
          this.valueWithCursor = `${F3}${l23.inverse(e5[0])}${e5.slice(1)}`;
        }
      });
    }
    get cursor() {
      return this._cursor;
    }
  };
  unicode5 = isUnicodeSupported6();
  S_STEP_ACTIVE3 = s5("\u276F", ">");
  S_STEP_CANCEL3 = s5("\u25A0", "x");
  S_STEP_ERROR3 = s5("\u25B2", "x");
  S_STEP_SUBMIT3 = s5("\u2714", "\u221A");
  S_RADIO_ACTIVE3 = s5("\u25CF", ">");
  S_RADIO_INACTIVE3 = s5("\u25CB", " ");
  S_CHECKBOX_ACTIVE3 = s5("\u25FB", "[\u2022]");
  S_CHECKBOX_SELECTED3 = s5("\u25FC", "[+]");
  S_CHECKBOX_INACTIVE3 = s5("\u25FB", "[ ]");
});
function detectProvider3(env33) {
  for (const provider of providers3) {
    const envName = provider[1] || provider[0];
    if (env33[envName]) {
      return {
        name: provider[0].toLowerCase(),
        ...provider[2]
      };
    }
  }
  if (env33.SHELL && env33.SHELL === "/bin/jsh") {
    return {
      name: "stackblitz",
      ci: false
    };
  }
  return {
    name: "",
    ci: false
  };
}
function toBoolean3(val2) {
  return val2 ? val2 !== "false" : false;
}
function ansiRegex23({ onlyFirst = false } = {}) {
  const pattern = [
    "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"
  ].join("|");
  return new RegExp(pattern, onlyFirst ? undefined : "g");
}
function stripAnsi23(string2) {
  if (typeof string2 !== "string") {
    throw new TypeError(`Expected a \`string\`, got \`${typeof string2}\``);
  }
  return string2.replace(regex5, "");
}
function getDefaultExportFromCjs3(x22) {
  return x22 && x22.__esModule && Object.prototype.hasOwnProperty.call(x22, "default") ? x22["default"] : x22;
}
function stringWidth$13(string2, options3) {
  if (typeof string2 !== "string" || string2.length === 0) {
    return 0;
  }
  options3 = {
    ambiguousIsNarrow: true,
    countAnsiEscapeCodes: false,
    ...options3
  };
  if (!options3.countAnsiEscapeCodes) {
    string2 = stripAnsi23(string2);
  }
  if (string2.length === 0) {
    return 0;
  }
  const ambiguousCharacterWidth = options3.ambiguousIsNarrow ? 1 : 2;
  let width = 0;
  for (const { segment: character } of new Intl.Segmenter().segment(string2)) {
    const codePoint = character.codePointAt(0);
    if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
      continue;
    }
    if (codePoint >= 768 && codePoint <= 879) {
      continue;
    }
    if (emojiRegex3().test(character)) {
      width += 2;
      continue;
    }
    const code = eastAsianWidth5.eastAsianWidth(character);
    switch (code) {
      case "F":
      case "W": {
        width += 2;
        break;
      }
      case "A": {
        width += ambiguousCharacterWidth;
        break;
      }
      default: {
        width += 1;
      }
    }
  }
  return width;
}
function isUnicodeSupported6() {
  if (process$13.platform !== "win32") {
    return process$13.env.TERM !== "linux";
  }
  return Boolean(process$13.env.CI) || Boolean(process$13.env.WT_SESSION) || Boolean(process$13.env.TERMINUS_SUBLIME) || process$13.env.ConEmuTask === "{cmd::Cmder}" || process$13.env.TERM_PROGRAM === "Terminus-Sublime" || process$13.env.TERM_PROGRAM === "vscode" || process$13.env.TERM === "xterm-256color" || process$13.env.TERM === "alacritty" || process$13.env.TERMINAL_EMULATOR === "JetBrains-JediTerm";
}
function stringWidth5(str2) {
  if (!Intl.Segmenter) {
    return stripAnsi6(str2).length;
  }
  return stringWidth$13(str2);
}
function characterFormat3(str2) {
  return str2.replace(/`([^`]+)`/gm, (_23, m23) => colors3.cyan(m23)).replace(/\s+_([^_]+)_\s+/gm, (_23, m23) => ` ${colors3.underline(m23)} `);
}
function getColor23(color = "white") {
  return colors3[color] || colors3.white;
}
function getBgColor3(color = "bgWhite") {
  return colors3[`bg${color[0].toUpperCase()}${color.slice(1)}`] || colors3.bgWhite;
}
function createConsola23(options3 = {}) {
  let level = _getDefaultLogLevel3();
  if (process.env.CONSOLA_LEVEL) {
    level = Number.parseInt(process.env.CONSOLA_LEVEL) ?? level;
  }
  const consola22 = createConsola5({
    level,
    defaults: { level },
    stdout: process.stdout,
    stderr: process.stderr,
    prompt: (...args) => Promise.resolve().then(() => (init_prompt3(), exports_prompt3)).then((m23) => m23.prompt(...args)),
    reporters: options3.reporters || [
      options3.fancy ?? !(isCI23 || isTest3) ? new FancyReporter3 : new BasicReporter3
    ],
    ...options3
  });
  return consola22;
}
function _getDefaultLogLevel3() {
  if (isDebug3) {
    return LogLevels3.debug;
  }
  if (isTest3) {
    return LogLevels3.warn;
  }
  return LogLevels3.info;
}
var providers3;
var processShim3;
var envShim3;
var providerInfo3;
var nodeENV3;
var isCI23;
var hasTTY3;
var isDebug3;
var isTest3;
var regex5;
var eastasianwidth3;
var eastasianwidthExports3;
var eastAsianWidth5;
var emojiRegex3 = () => {
  return /[#*0-9]\uFE0F?\u20E3|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26AA\u26B0\u26B1\u26BD\u26BE\u26C4\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0-\u26F5\u26F7\u26F8\u26FA\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2757\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B55\u3030\u303D\u3297\u3299]\uFE0F?|[\u261D\u270C\u270D](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\u270A\u270B](?:\uD83C[\uDFFB-\uDFFF])?|[\u23E9-\u23EC\u23F0\u23F3\u25FD\u2693\u26A1\u26AB\u26C5\u26CE\u26D4\u26EA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2795-\u2797\u27B0\u27BF\u2B50]|\u26F9(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\u2764\uFE0F?(?:\u200D(?:\uD83D\uDD25|\uD83E\uDE79))?|\uD83C(?:[\uDC04\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]\uFE0F?|[\uDF85\uDFC2\uDFC7](?:\uD83C[\uDFFB-\uDFFF])?|[\uDFC3\uDFC4\uDFCA](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDFCB\uDFCC](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uDDE6\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF]|\uDDE7\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF]|\uDDE8\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF]|\uDDE9\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF]|\uDDEA\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA]|\uDDEB\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7]|\uDDEC\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE]|\uDDED\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA]|\uDDEE\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9]|\uDDEF\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5]|\uDDF0\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF]|\uDDF1\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE]|\uDDF2\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF]|\uDDF3\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF]|\uDDF4\uD83C\uDDF2|\uDDF5\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE]|\uDDF6\uD83C\uDDE6|\uDDF7\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC]|\uDDF8\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF]|\uDDF9\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF]|\uDDFA\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF]|\uDDFB\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA]|\uDDFC\uD83C[\uDDEB\uDDF8]|\uDDFD\uD83C\uDDF0|\uDDFE\uD83C[\uDDEA\uDDF9]|\uDDFF\uD83C[\uDDE6\uDDF2\uDDFC]|\uDFF3\uFE0F?(?:\u200D(?:\u26A7\uFE0F?|\uD83C\uDF08))?|\uDFF4(?:\u200D\u2620\uFE0F?|\uDB40\uDC67\uDB40\uDC62\uDB40(?:\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDC73\uDB40\uDC63\uDB40\uDC74|\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F)?)|\uD83D(?:[\uDC08\uDC26](?:\u200D\u2B1B)?|[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3]\uFE0F?|[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC](?:\uD83C[\uDFFB-\uDFFF])?|[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD74\uDD90](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC25\uDC27-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEDC-\uDEDF\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB\uDFF0]|\uDC15(?:\u200D\uD83E\uDDBA)?|\uDC3B(?:\u200D\u2744\uFE0F?)?|\uDC41\uFE0F?(?:\u200D\uD83D\uDDE8\uFE0F?)?|\uDC68(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDC68\uDC69]\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFE])))?))?|\uDC69(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?[\uDC68\uDC69]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?|\uDC69\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?))|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFE])))?))?|\uDC6F(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDD75(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDE2E(?:\u200D\uD83D\uDCA8)?|\uDE35(?:\u200D\uD83D\uDCAB)?|\uDE36(?:\u200D\uD83C\uDF2B\uFE0F?)?)|\uD83E(?:[\uDD0C\uDD0F\uDD18-\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5\uDEC3-\uDEC5\uDEF0\uDEF2-\uDEF8](?:\uD83C[\uDFFB-\uDFFF])?|[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDDDE\uDDDF](?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD0D\uDD0E\uDD10-\uDD17\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCC\uDDD0\uDDE0-\uDDFF\uDE70-\uDE7C\uDE80-\uDE88\uDE90-\uDEBD\uDEBF-\uDEC2\uDECE-\uDEDB\uDEE0-\uDEE8]|\uDD3C(?:\u200D[\u2640\u2642]\uFE0F?|\uD83C[\uDFFB-\uDFFF])?|\uDDD1(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFC-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFD-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFD\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFE]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF-\uDDB3\uDDBC\uDDBD]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?))?|\uDEF1(?:\uD83C(?:\uDFFB(?:\u200D\uD83E\uDEF2\uD83C[\uDFFC-\uDFFF])?|\uDFFC(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFD-\uDFFF])?|\uDFFD(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])?|\uDFFE(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFD\uDFFF])?|\uDFFF(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFE])?))?)/g;
};
var TYPE_COLOR_MAP3;
var LEVEL_COLOR_MAP3;
var unicode23;
var s23 = (c23, fallback3) => unicode23 ? c23 : fallback3;
var TYPE_ICONS3;
var FancyReporter3;
var consola3;
var init_consola_36c0034f3 = __esm3(() => {
  init_core4();
  init_consola_06ad8a643();
  init_utils14();
  providers3 = [
    ["APPVEYOR"],
    ["AZURE_PIPELINES", "SYSTEM_TEAMFOUNDATIONCOLLECTIONURI"],
    ["AZURE_STATIC", "INPUT_AZURE_STATIC_WEB_APPS_API_TOKEN"],
    ["APPCIRCLE", "AC_APPCIRCLE"],
    ["BAMBOO", "bamboo_planKey"],
    ["BITBUCKET", "BITBUCKET_COMMIT"],
    ["BITRISE", "BITRISE_IO"],
    ["BUDDY", "BUDDY_WORKSPACE_ID"],
    ["BUILDKITE"],
    ["CIRCLE", "CIRCLECI"],
    ["CIRRUS", "CIRRUS_CI"],
    ["CLOUDFLARE_PAGES", "CF_PAGES", { ci: true }],
    ["CODEBUILD", "CODEBUILD_BUILD_ARN"],
    ["CODEFRESH", "CF_BUILD_ID"],
    ["DRONE"],
    ["DRONE", "DRONE_BUILD_EVENT"],
    ["DSARI"],
    ["GITHUB_ACTIONS"],
    ["GITLAB", "GITLAB_CI"],
    ["GITLAB", "CI_MERGE_REQUEST_ID"],
    ["GOCD", "GO_PIPELINE_LABEL"],
    ["LAYERCI"],
    ["HUDSON", "HUDSON_URL"],
    ["JENKINS", "JENKINS_URL"],
    ["MAGNUM"],
    ["NETLIFY"],
    ["NETLIFY", "NETLIFY_LOCAL", { ci: false }],
    ["NEVERCODE"],
    ["RENDER"],
    ["SAIL", "SAILCI"],
    ["SEMAPHORE"],
    ["SCREWDRIVER"],
    ["SHIPPABLE"],
    ["SOLANO", "TDDIUM"],
    ["STRIDER"],
    ["TEAMCITY", "TEAMCITY_VERSION"],
    ["TRAVIS"],
    ["VERCEL", "NOW_BUILDER"],
    ["APPCENTER", "APPCENTER_BUILD_ID"],
    ["CODESANDBOX", "CODESANDBOX_SSE", { ci: false }],
    ["STACKBLITZ"],
    ["STORMKIT"],
    ["CLEAVR"]
  ];
  processShim3 = typeof process !== "undefined" ? process : {};
  envShim3 = processShim3.env || {};
  providerInfo3 = detectProvider3(envShim3);
  nodeENV3 = typeof process !== "undefined" && process.env && "development" || "";
  processShim3.platform;
  providerInfo3.name;
  isCI23 = toBoolean3(envShim3.CI) || providerInfo3.ci !== false;
  hasTTY3 = toBoolean3(processShim3.stdout && processShim3.stdout.isTTY);
  isDebug3 = toBoolean3(envShim3.DEBUG);
  isTest3 = nodeENV3 === "test" || toBoolean3(envShim3.TEST);
  toBoolean3(envShim3.MINIMAL);
  regex5 = ansiRegex23();
  eastasianwidth3 = { exports: {} };
  (function(module) {
    var eaw = {};
    {
      module.exports = eaw;
    }
    eaw.eastAsianWidth = function(character) {
      var x22 = character.charCodeAt(0);
      var y3 = character.length == 2 ? character.charCodeAt(1) : 0;
      var codePoint = x22;
      if (55296 <= x22 && x22 <= 56319 && (56320 <= y3 && y3 <= 57343)) {
        x22 &= 1023;
        y3 &= 1023;
        codePoint = x22 << 10 | y3;
        codePoint += 65536;
      }
      if (codePoint == 12288 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510) {
        return "F";
      }
      if (codePoint == 8361 || 65377 <= codePoint && codePoint <= 65470 || 65474 <= codePoint && codePoint <= 65479 || 65482 <= codePoint && codePoint <= 65487 || 65490 <= codePoint && codePoint <= 65495 || 65498 <= codePoint && codePoint <= 65500 || 65512 <= codePoint && codePoint <= 65518) {
        return "H";
      }
      if (4352 <= codePoint && codePoint <= 4447 || 4515 <= codePoint && codePoint <= 4519 || 4602 <= codePoint && codePoint <= 4607 || 9001 <= codePoint && codePoint <= 9002 || 11904 <= codePoint && codePoint <= 11929 || 11931 <= codePoint && codePoint <= 12019 || 12032 <= codePoint && codePoint <= 12245 || 12272 <= codePoint && codePoint <= 12283 || 12289 <= codePoint && codePoint <= 12350 || 12353 <= codePoint && codePoint <= 12438 || 12441 <= codePoint && codePoint <= 12543 || 12549 <= codePoint && codePoint <= 12589 || 12593 <= codePoint && codePoint <= 12686 || 12688 <= codePoint && codePoint <= 12730 || 12736 <= codePoint && codePoint <= 12771 || 12784 <= codePoint && codePoint <= 12830 || 12832 <= codePoint && codePoint <= 12871 || 12880 <= codePoint && codePoint <= 13054 || 13056 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42124 || 42128 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 55216 <= codePoint && codePoint <= 55238 || 55243 <= codePoint && codePoint <= 55291 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65106 || 65108 <= codePoint && codePoint <= 65126 || 65128 <= codePoint && codePoint <= 65131 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127490 || 127504 <= codePoint && codePoint <= 127546 || 127552 <= codePoint && codePoint <= 127560 || 127568 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 194367 || 177984 <= codePoint && codePoint <= 196605 || 196608 <= codePoint && codePoint <= 262141) {
        return "W";
      }
      if (32 <= codePoint && codePoint <= 126 || 162 <= codePoint && codePoint <= 163 || 165 <= codePoint && codePoint <= 166 || codePoint == 172 || codePoint == 175 || 10214 <= codePoint && codePoint <= 10221 || 10629 <= codePoint && codePoint <= 10630) {
        return "Na";
      }
      if (codePoint == 161 || codePoint == 164 || 167 <= codePoint && codePoint <= 168 || codePoint == 170 || 173 <= codePoint && codePoint <= 174 || 176 <= codePoint && codePoint <= 180 || 182 <= codePoint && codePoint <= 186 || 188 <= codePoint && codePoint <= 191 || codePoint == 198 || codePoint == 208 || 215 <= codePoint && codePoint <= 216 || 222 <= codePoint && codePoint <= 225 || codePoint == 230 || 232 <= codePoint && codePoint <= 234 || 236 <= codePoint && codePoint <= 237 || codePoint == 240 || 242 <= codePoint && codePoint <= 243 || 247 <= codePoint && codePoint <= 250 || codePoint == 252 || codePoint == 254 || codePoint == 257 || codePoint == 273 || codePoint == 275 || codePoint == 283 || 294 <= codePoint && codePoint <= 295 || codePoint == 299 || 305 <= codePoint && codePoint <= 307 || codePoint == 312 || 319 <= codePoint && codePoint <= 322 || codePoint == 324 || 328 <= codePoint && codePoint <= 331 || codePoint == 333 || 338 <= codePoint && codePoint <= 339 || 358 <= codePoint && codePoint <= 359 || codePoint == 363 || codePoint == 462 || codePoint == 464 || codePoint == 466 || codePoint == 468 || codePoint == 470 || codePoint == 472 || codePoint == 474 || codePoint == 476 || codePoint == 593 || codePoint == 609 || codePoint == 708 || codePoint == 711 || 713 <= codePoint && codePoint <= 715 || codePoint == 717 || codePoint == 720 || 728 <= codePoint && codePoint <= 731 || codePoint == 733 || codePoint == 735 || 768 <= codePoint && codePoint <= 879 || 913 <= codePoint && codePoint <= 929 || 931 <= codePoint && codePoint <= 937 || 945 <= codePoint && codePoint <= 961 || 963 <= codePoint && codePoint <= 969 || codePoint == 1025 || 1040 <= codePoint && codePoint <= 1103 || codePoint == 1105 || codePoint == 8208 || 8211 <= codePoint && codePoint <= 8214 || 8216 <= codePoint && codePoint <= 8217 || 8220 <= codePoint && codePoint <= 8221 || 8224 <= codePoint && codePoint <= 8226 || 8228 <= codePoint && codePoint <= 8231 || codePoint == 8240 || 8242 <= codePoint && codePoint <= 8243 || codePoint == 8245 || codePoint == 8251 || codePoint == 8254 || codePoint == 8308 || codePoint == 8319 || 8321 <= codePoint && codePoint <= 8324 || codePoint == 8364 || codePoint == 8451 || codePoint == 8453 || codePoint == 8457 || codePoint == 8467 || codePoint == 8470 || 8481 <= codePoint && codePoint <= 8482 || codePoint == 8486 || codePoint == 8491 || 8531 <= codePoint && codePoint <= 8532 || 8539 <= codePoint && codePoint <= 8542 || 8544 <= codePoint && codePoint <= 8555 || 8560 <= codePoint && codePoint <= 8569 || codePoint == 8585 || 8592 <= codePoint && codePoint <= 8601 || 8632 <= codePoint && codePoint <= 8633 || codePoint == 8658 || codePoint == 8660 || codePoint == 8679 || codePoint == 8704 || 8706 <= codePoint && codePoint <= 8707 || 8711 <= codePoint && codePoint <= 8712 || codePoint == 8715 || codePoint == 8719 || codePoint == 8721 || codePoint == 8725 || codePoint == 8730 || 8733 <= codePoint && codePoint <= 8736 || codePoint == 8739 || codePoint == 8741 || 8743 <= codePoint && codePoint <= 8748 || codePoint == 8750 || 8756 <= codePoint && codePoint <= 8759 || 8764 <= codePoint && codePoint <= 8765 || codePoint == 8776 || codePoint == 8780 || codePoint == 8786 || 8800 <= codePoint && codePoint <= 8801 || 8804 <= codePoint && codePoint <= 8807 || 8810 <= codePoint && codePoint <= 8811 || 8814 <= codePoint && codePoint <= 8815 || 8834 <= codePoint && codePoint <= 8835 || 8838 <= codePoint && codePoint <= 8839 || codePoint == 8853 || codePoint == 8857 || codePoint == 8869 || codePoint == 8895 || codePoint == 8978 || 9312 <= codePoint && codePoint <= 9449 || 9451 <= codePoint && codePoint <= 9547 || 9552 <= codePoint && codePoint <= 9587 || 9600 <= codePoint && codePoint <= 9615 || 9618 <= codePoint && codePoint <= 9621 || 9632 <= codePoint && codePoint <= 9633 || 9635 <= codePoint && codePoint <= 9641 || 9650 <= codePoint && codePoint <= 9651 || 9654 <= codePoint && codePoint <= 9655 || 9660 <= codePoint && codePoint <= 9661 || 9664 <= codePoint && codePoint <= 9665 || 9670 <= codePoint && codePoint <= 9672 || codePoint == 9675 || 9678 <= codePoint && codePoint <= 9681 || 9698 <= codePoint && codePoint <= 9701 || codePoint == 9711 || 9733 <= codePoint && codePoint <= 9734 || codePoint == 9737 || 9742 <= codePoint && codePoint <= 9743 || 9748 <= codePoint && codePoint <= 9749 || codePoint == 9756 || codePoint == 9758 || codePoint == 9792 || codePoint == 9794 || 9824 <= codePoint && codePoint <= 9825 || 9827 <= codePoint && codePoint <= 9829 || 9831 <= codePoint && codePoint <= 9834 || 9836 <= codePoint && codePoint <= 9837 || codePoint == 9839 || 9886 <= codePoint && codePoint <= 9887 || 9918 <= codePoint && codePoint <= 9919 || 9924 <= codePoint && codePoint <= 9933 || 9935 <= codePoint && codePoint <= 9953 || codePoint == 9955 || 9960 <= codePoint && codePoint <= 9983 || codePoint == 10045 || codePoint == 10071 || 10102 <= codePoint && codePoint <= 10111 || 11093 <= codePoint && codePoint <= 11097 || 12872 <= codePoint && codePoint <= 12879 || 57344 <= codePoint && codePoint <= 63743 || 65024 <= codePoint && codePoint <= 65039 || codePoint == 65533 || 127232 <= codePoint && codePoint <= 127242 || 127248 <= codePoint && codePoint <= 127277 || 127280 <= codePoint && codePoint <= 127337 || 127344 <= codePoint && codePoint <= 127386 || 917760 <= codePoint && codePoint <= 917999 || 983040 <= codePoint && codePoint <= 1048573 || 1048576 <= codePoint && codePoint <= 1114109) {
        return "A";
      }
      return "N";
    };
    eaw.characterLength = function(character) {
      var code = this.eastAsianWidth(character);
      if (code == "F" || code == "W" || code == "A") {
        return 2;
      } else {
        return 1;
      }
    };
    function stringToArray(string2) {
      return string2.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]|[^\uD800-\uDFFF]/g) || [];
    }
    eaw.length = function(string2) {
      var characters2 = stringToArray(string2);
      var len = 0;
      for (var i5 = 0;i5 < characters2.length; i5++) {
        len = len + this.characterLength(characters2[i5]);
      }
      return len;
    };
    eaw.slice = function(text22, start, end) {
      textLen = eaw.length(text22);
      start = start ? start : 0;
      end = end ? end : 1;
      if (start < 0) {
        start = textLen + start;
      }
      if (end < 0) {
        end = textLen + end;
      }
      var result2 = "";
      var eawLen = 0;
      var chars3 = stringToArray(text22);
      for (var i5 = 0;i5 < chars3.length; i5++) {
        var char = chars3[i5];
        var charLen = eaw.length(char);
        if (eawLen >= start - (charLen == 2 ? 1 : 0)) {
          if (eawLen + charLen <= end) {
            result2 += char;
          } else {
            break;
          }
        }
        eawLen += charLen;
      }
      return result2;
    };
  })(eastasianwidth3);
  eastasianwidthExports3 = eastasianwidth3.exports;
  eastAsianWidth5 = /* @__PURE__ */ getDefaultExportFromCjs3(eastasianwidthExports3);
  TYPE_COLOR_MAP3 = {
    info: "cyan",
    fail: "red",
    success: "green",
    ready: "green",
    start: "magenta"
  };
  LEVEL_COLOR_MAP3 = {
    0: "red",
    1: "yellow"
  };
  unicode23 = isUnicodeSupported6();
  TYPE_ICONS3 = {
    error: s23("\u2716", "\xD7"),
    fatal: s23("\u2716", "\xD7"),
    ready: s23("\u2714", "\u221A"),
    warn: s23("\u26A0", "\u203C"),
    info: s23("\u2139", "i"),
    success: s23("\u2714", "\u221A"),
    debug: s23("\u2699", "D"),
    trace: s23("\u2192", "\u2192"),
    fail: s23("\u2716", "\xD7"),
    start: s23("\u25D0", "o"),
    log: ""
  };
  FancyReporter3 = class FancyReporter22 extends BasicReporter3 {
    formatStack(stack) {
      return "\n" + parseStack3(stack).map((line) => "  " + line.replace(/^at +/, (m23) => colors3.gray(m23)).replace(/\((.+)\)/, (_23, m23) => `(${colors3.cyan(m23)})`)).join("\n");
    }
    formatType(logObj, isBadge, opts) {
      const typeColor = TYPE_COLOR_MAP3[logObj.type] || LEVEL_COLOR_MAP3[logObj.level] || "gray";
      if (isBadge) {
        return getBgColor3(typeColor)(colors3.black(` ${logObj.type.toUpperCase()} `));
      }
      const _type = typeof TYPE_ICONS3[logObj.type] === "string" ? TYPE_ICONS3[logObj.type] : logObj.icon || logObj.type;
      return _type ? getColor23(typeColor)(_type) : "";
    }
    formatLogObj(logObj, opts) {
      const [message, ...additional] = this.formatArgs(logObj.args, opts).split("\n");
      if (logObj.type === "box") {
        return box3(characterFormat3(message + (additional.length > 0 ? "\n" + additional.join("\n") : "")), {
          title: logObj.title ? characterFormat3(logObj.title) : undefined,
          style: logObj.style
        });
      }
      const date = this.formatDate(logObj.date, opts);
      const coloredDate = date && colors3.gray(date);
      const isBadge = logObj.badge ?? logObj.level < 2;
      const type2 = this.formatType(logObj, isBadge, opts);
      const tag = logObj.tag ? colors3.gray(logObj.tag) : "";
      let line;
      const left = this.filterAndJoin([type2, characterFormat3(message)]);
      const right = this.filterAndJoin(opts.columns ? [tag, coloredDate] : [tag]);
      const space2 = (opts.columns || 0) - stringWidth5(left) - stringWidth5(right) - 2;
      line = space2 > 0 && (opts.columns || 0) >= 80 ? left + " ".repeat(space2) + right : (right ? `${colors3.gray(`[${right}]`)} ` : "") + left;
      line += characterFormat3(additional.length > 0 ? "\n" + additional.join("\n") : "");
      if (logObj.type === "trace") {
        const _err = new Error("Trace: " + logObj.message);
        line += this.formatStack(_err.stack || "");
      }
      return isBadge ? "\n" + line + "\n" : line;
    }
  };
  consola3 = createConsola23();
});
var require_assertString3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = assertString;
  function _typeof(o5) {
    "@babel/helpers - typeof";
    return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o22) {
      return typeof o22;
    } : function(o22) {
      return o22 && typeof Symbol == "function" && o22.constructor === Symbol && o22 !== Symbol.prototype ? "symbol" : typeof o22;
    }, _typeof(o5);
  }
  function assertString(input) {
    var isString23 = typeof input === "string" || input instanceof String;
    if (!isString23) {
      var invalidType = _typeof(input);
      if (input === null)
        invalidType = "null";
      else if (invalidType === "object")
        invalidType = input.constructor.name;
      throw new TypeError("Expected a string but received a ".concat(invalidType));
    }
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isIP3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isIP;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var IPv4SegmentFormat = "(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])";
  var IPv4AddressFormat = "(".concat(IPv4SegmentFormat, "[.]){3}").concat(IPv4SegmentFormat);
  var IPv4AddressRegExp = new RegExp("^".concat(IPv4AddressFormat, "$"));
  var IPv6SegmentFormat = "(?:[0-9a-fA-F]{1,4})";
  var IPv6AddressRegExp = new RegExp("^(" + "(?:".concat(IPv6SegmentFormat, ":){7}(?:").concat(IPv6SegmentFormat, "|:)|") + "(?:".concat(IPv6SegmentFormat, ":){6}(?:").concat(IPv4AddressFormat, "|:").concat(IPv6SegmentFormat, "|:)|") + "(?:".concat(IPv6SegmentFormat, ":){5}(?::").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,2}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){4}(?:(:").concat(IPv6SegmentFormat, "){0,1}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,3}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){3}(?:(:").concat(IPv6SegmentFormat, "){0,2}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,4}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){2}(?:(:").concat(IPv6SegmentFormat, "){0,3}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,5}|:)|") + "(?:".concat(IPv6SegmentFormat, ":){1}(?:(:").concat(IPv6SegmentFormat, "){0,4}:").concat(IPv4AddressFormat, "|(:").concat(IPv6SegmentFormat, "){1,6}|:)|") + "(?::((?::".concat(IPv6SegmentFormat, "){0,5}:").concat(IPv4AddressFormat, "|(?::").concat(IPv6SegmentFormat, "){1,7}|:))") + ")(%[0-9a-zA-Z-.:]{1,})?$");
  function isIP(str2) {
    var version3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
    (0, _assertString.default)(str2);
    version3 = String(version3);
    if (!version3) {
      return isIP(str2, 4) || isIP(str2, 6);
    }
    if (version3 === "4") {
      return IPv4AddressRegExp.test(str2);
    }
    if (version3 === "6") {
      return IPv6AddressRegExp.test(str2);
    }
    return false;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_merge3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = merge2;
  function merge2() {
    var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var defaults3 = arguments.length > 1 ? arguments[1] : undefined;
    for (var key in defaults3) {
      if (typeof obj[key] === "undefined") {
        obj[key] = defaults3[key];
      }
    }
    return obj;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isBase643 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isBase64;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _merge = _interopRequireDefault(require_merge3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var notBase64 = /[^A-Z0-9+\/=]/i;
  var urlSafeBase64 = /^[A-Z0-9_\-]*$/i;
  var defaultBase64Options = {
    urlSafe: false
  };
  function isBase64(str2, options3) {
    (0, _assertString.default)(str2);
    options3 = (0, _merge.default)(options3, defaultBase64Options);
    var len = str2.length;
    if (options3.urlSafe) {
      return urlSafeBase64.test(str2);
    }
    if (len % 4 !== 0 || notBase64.test(str2)) {
      return false;
    }
    var firstPaddingChar = str2.indexOf("=");
    return firstPaddingChar === -1 || firstPaddingChar === len - 1 || firstPaddingChar === len - 2 && str2[len - 1] === "=";
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isJWT3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isJWT;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _isBase = _interopRequireDefault(require_isBase643());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isJWT(str2) {
    (0, _assertString.default)(str2);
    var dotSplit = str2.split(".");
    var len = dotSplit.length;
    if (len !== 3) {
      return false;
    }
    return dotSplit.reduce(function(acc, currElem) {
      return acc && (0, _isBase.default)(currElem, {
        urlSafe: true
      });
    }, true);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isFQDN3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isFQDN;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _merge = _interopRequireDefault(require_merge3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_fqdn_options = {
    require_tld: true,
    allow_underscores: false,
    allow_trailing_dot: false,
    allow_numeric_tld: false,
    allow_wildcard: false,
    ignore_max_length: false
  };
  function isFQDN(str2, options3) {
    (0, _assertString.default)(str2);
    options3 = (0, _merge.default)(options3, default_fqdn_options);
    if (options3.allow_trailing_dot && str2[str2.length - 1] === ".") {
      str2 = str2.substring(0, str2.length - 1);
    }
    if (options3.allow_wildcard === true && str2.indexOf("*.") === 0) {
      str2 = str2.substring(2);
    }
    var parts = str2.split(".");
    var tld = parts[parts.length - 1];
    if (options3.require_tld) {
      if (parts.length < 2) {
        return false;
      }
      if (!options3.allow_numeric_tld && !/^([a-z\u00A1-\u00A8\u00AA-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}|xn[a-z0-9-]{2,})$/i.test(tld)) {
        return false;
      }
      if (/\s/.test(tld)) {
        return false;
      }
    }
    if (!options3.allow_numeric_tld && /^\d+$/.test(tld)) {
      return false;
    }
    return parts.every(function(part) {
      if (part.length > 63 && !options3.ignore_max_length) {
        return false;
      }
      if (!/^[a-z_\u00a1-\uffff0-9-]+$/i.test(part)) {
        return false;
      }
      if (/[\uff01-\uff5e]/.test(part)) {
        return false;
      }
      if (/^-|-$/.test(part)) {
        return false;
      }
      if (!options3.allow_underscores && /_/.test(part)) {
        return false;
      }
      return true;
    });
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isURL3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isURL;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _isFQDN = _interopRequireDefault(require_isFQDN3());
  var _isIP = _interopRequireDefault(require_isIP3());
  var _merge = _interopRequireDefault(require_merge3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function _slicedToArray(arr, i5) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i5) || _unsupportedIterableToArray(arr, i5) || _nonIterableRest();
  }
  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _unsupportedIterableToArray(o5, minLen) {
    if (!o5)
      return;
    if (typeof o5 === "string")
      return _arrayLikeToArray(o5, minLen);
    var n5 = Object.prototype.toString.call(o5).slice(8, -1);
    if (n5 === "Object" && o5.constructor)
      n5 = o5.constructor.name;
    if (n5 === "Map" || n5 === "Set")
      return Array.from(o5);
    if (n5 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n5))
      return _arrayLikeToArray(o5, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i5 = 0, arr2 = new Array(len);i5 < len; i5++)
      arr2[i5] = arr[i5];
    return arr2;
  }
  function _iterableToArrayLimit(r23, l33) {
    var t5 = r23 == null ? null : typeof Symbol != "undefined" && r23[Symbol.iterator] || r23["@@iterator"];
    if (t5 != null) {
      var e5, n5, i5, u5, a5 = [], f23 = true, o5 = false;
      try {
        if (i5 = (t5 = t5.call(r23)).next, l33 === 0) {
          if (Object(t5) !== t5)
            return;
          f23 = false;
        } else
          for (;!(f23 = (e5 = i5.call(t5)).done) && (a5.push(e5.value), a5.length !== l33); f23 = true)
            ;
      } catch (r32) {
        o5 = true, n5 = r32;
      } finally {
        try {
          if (!f23 && t5.return != null && (u5 = t5.return(), Object(u5) !== u5))
            return;
        } finally {
          if (o5)
            throw n5;
        }
      }
      return a5;
    }
  }
  function _arrayWithHoles(arr) {
    if (Array.isArray(arr))
      return arr;
  }
  var default_url_options = {
    protocols: ["http", "https", "ftp"],
    require_tld: true,
    require_protocol: false,
    require_host: true,
    require_port: false,
    require_valid_protocol: true,
    allow_underscores: false,
    allow_trailing_dot: false,
    allow_protocol_relative_urls: false,
    allow_fragments: true,
    allow_query_components: true,
    validate_length: true
  };
  var wrapped_ipv6 = /^\[([^\]]+)\](?::([0-9]+))?$/;
  function isRegExp(obj) {
    return Object.prototype.toString.call(obj) === "[object RegExp]";
  }
  function checkHost(host, matches) {
    for (var i5 = 0;i5 < matches.length; i5++) {
      var match = matches[i5];
      if (host === match || isRegExp(match) && match.test(host)) {
        return true;
      }
    }
    return false;
  }
  function isURL(url, options3) {
    (0, _assertString.default)(url);
    if (!url || /[\s<>]/.test(url)) {
      return false;
    }
    if (url.indexOf("mailto:") === 0) {
      return false;
    }
    options3 = (0, _merge.default)(options3, default_url_options);
    if (options3.validate_length && url.length >= 2083) {
      return false;
    }
    if (!options3.allow_fragments && url.includes("#")) {
      return false;
    }
    if (!options3.allow_query_components && (url.includes("?") || url.includes("&"))) {
      return false;
    }
    var protocol, auth, host, hostname, port, port_str, split2, ipv6;
    split2 = url.split("#");
    url = split2.shift();
    split2 = url.split("?");
    url = split2.shift();
    split2 = url.split("://");
    if (split2.length > 1) {
      protocol = split2.shift().toLowerCase();
      if (options3.require_valid_protocol && options3.protocols.indexOf(protocol) === -1) {
        return false;
      }
    } else if (options3.require_protocol) {
      return false;
    } else if (url.slice(0, 2) === "//") {
      if (!options3.allow_protocol_relative_urls) {
        return false;
      }
      split2[0] = url.slice(2);
    }
    url = split2.join("://");
    if (url === "") {
      return false;
    }
    split2 = url.split("/");
    url = split2.shift();
    if (url === "" && !options3.require_host) {
      return true;
    }
    split2 = url.split("@");
    if (split2.length > 1) {
      if (options3.disallow_auth) {
        return false;
      }
      if (split2[0] === "") {
        return false;
      }
      auth = split2.shift();
      if (auth.indexOf(":") >= 0 && auth.split(":").length > 2) {
        return false;
      }
      var _auth$split = auth.split(":"), _auth$split2 = _slicedToArray(_auth$split, 2), user = _auth$split2[0], password = _auth$split2[1];
      if (user === "" && password === "") {
        return false;
      }
    }
    hostname = split2.join("@");
    port_str = null;
    ipv6 = null;
    var ipv6_match = hostname.match(wrapped_ipv6);
    if (ipv6_match) {
      host = "";
      ipv6 = ipv6_match[1];
      port_str = ipv6_match[2] || null;
    } else {
      split2 = hostname.split(":");
      host = split2.shift();
      if (split2.length) {
        port_str = split2.join(":");
      }
    }
    if (port_str !== null && port_str.length > 0) {
      port = parseInt(port_str, 10);
      if (!/^[0-9]+$/.test(port_str) || port <= 0 || port > 65535) {
        return false;
      }
    } else if (options3.require_port) {
      return false;
    }
    if (options3.host_whitelist) {
      return checkHost(host, options3.host_whitelist);
    }
    if (host === "" && !options3.require_host) {
      return true;
    }
    if (!(0, _isIP.default)(host) && !(0, _isFQDN.default)(host, options3) && (!ipv6 || !(0, _isIP.default)(ipv6, 6))) {
      return false;
    }
    host = host || ipv6;
    if (options3.host_blacklist && checkHost(host, options3.host_blacklist)) {
      return false;
    }
    return true;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isSlug3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isSlug;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var charsetRegex = /^[^\s-_](?!.*?[-_]{2,})[a-z0-9-\\][^\s]*[^-_\s]$/;
  function isSlug(str2) {
    (0, _assertString.default)(str2);
    return charsetRegex.test(str2);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isIBAN3 = __commonJS22((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isIBAN;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var ibanRegexThroughCountryCode = {
    AD: /^(AD[0-9]{2})\d{8}[A-Z0-9]{12}$/,
    AE: /^(AE[0-9]{2})\d{3}\d{16}$/,
    AL: /^(AL[0-9]{2})\d{8}[A-Z0-9]{16}$/,
    AT: /^(AT[0-9]{2})\d{16}$/,
    AZ: /^(AZ[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    BA: /^(BA[0-9]{2})\d{16}$/,
    BE: /^(BE[0-9]{2})\d{12}$/,
    BG: /^(BG[0-9]{2})[A-Z]{4}\d{6}[A-Z0-9]{8}$/,
    BH: /^(BH[0-9]{2})[A-Z]{4}[A-Z0-9]{14}$/,
    BR: /^(BR[0-9]{2})\d{23}[A-Z]{1}[A-Z0-9]{1}$/,
    BY: /^(BY[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    CH: /^(CH[0-9]{2})\d{5}[A-Z0-9]{12}$/,
    CR: /^(CR[0-9]{2})\d{18}$/,
    CY: /^(CY[0-9]{2})\d{8}[A-Z0-9]{16}$/,
    CZ: /^(CZ[0-9]{2})\d{20}$/,
    DE: /^(DE[0-9]{2})\d{18}$/,
    DK: /^(DK[0-9]{2})\d{14}$/,
    DO: /^(DO[0-9]{2})[A-Z]{4}\d{20}$/,
    DZ: /^(DZ\d{24})$/,
    EE: /^(EE[0-9]{2})\d{16}$/,
    EG: /^(EG[0-9]{2})\d{25}$/,
    ES: /^(ES[0-9]{2})\d{20}$/,
    FI: /^(FI[0-9]{2})\d{14}$/,
    FO: /^(FO[0-9]{2})\d{14}$/,
    FR: /^(FR[0-9]{2})\d{10}[A-Z0-9]{11}\d{2}$/,
    GB: /^(GB[0-9]{2})[A-Z]{4}\d{14}$/,
    GE: /^(GE[0-9]{2})[A-Z0-9]{2}\d{16}$/,
    GI: /^(GI[0-9]{2})[A-Z]{4}[A-Z0-9]{15}$/,
    GL: /^(GL[0-9]{2})\d{14}$/,
    GR: /^(GR[0-9]{2})\d{7}[A-Z0-9]{16}$/,
    GT: /^(GT[0-9]{2})[A-Z0-9]{4}[A-Z0-9]{20}$/,
    HR: /^(HR[0-9]{2})\d{17}$/,
    HU: /^(HU[0-9]{2})\d{24}$/,
    IE: /^(IE[0-9]{2})[A-Z0-9]{4}\d{14}$/,
    IL: /^(IL[0-9]{2})\d{19}$/,
    IQ: /^(IQ[0-9]{2})[A-Z]{4}\d{15}$/,
    IR: /^(IR[0-9]{2})0\d{2}0\d{18}$/,
    IS: /^(IS[0-9]{2})\d{22}$/,
    IT: /^(IT[0-9]{2})[A-Z]{1}\d{10}[A-Z0-9]{12}$/,
    JO: /^(JO[0-9]{2})[A-Z]{4}\d{22}$/,
    KW: /^(KW[0-9]{2})[A-Z]{4}[A-Z0-9]{22}$/,
    KZ: /^(KZ[0-9]{2})\d{3}[A-Z0-9]{13}$/,
    LB: /^(LB[0-9]{2})\d{4}[A-Z0-9]{20}$/,
    LC: /^(LC[0-9]{2})[A-Z]{4}[A-Z0-9]{24}$/,
    LI: /^(LI[0-9]{2})\d{5}[A-Z0-9]{12}$/,
    LT: /^(LT[0-9]{2})\d{16}$/,
    LU: /^(LU[0-9]{2})\d{3}[A-Z0-9]{13}$/,
    LV: /^(LV[0-9]{2})[A-Z]{4}[A-Z0-9]{13}$/,
    MA: /^(MA[0-9]{26})$/,
    MC: /^(MC[0-9]{2})\d{10}[A-Z0-9]{11}\d{2}$/,
    MD: /^(MD[0-9]{2})[A-Z0-9]{20}$/,
    ME: /^(ME[0-9]{2})\d{18}$/,
    MK: /^(MK[0-9]{2})\d{3}[A-Z0-9]{10}\d{2}$/,
    MR: /^(MR[0-9]{2})\d{23}$/,
    MT: /^(MT[0-9]{2})[A-Z]{4}\d{5}[A-Z0-9]{18}$/,
    MU: /^(MU[0-9]{2})[A-Z]{4}\d{19}[A-Z]{3}$/,
    MZ: /^(MZ[0-9]{2})\d{21}$/,
    NL: /^(NL[0-9]{2})[A-Z]{4}\d{10}$/,
    NO: /^(NO[0-9]{2})\d{11}$/,
    PK: /^(PK[0-9]{2})[A-Z0-9]{4}\d{16}$/,
    PL: /^(PL[0-9]{2})\d{24}$/,
    PS: /^(PS[0-9]{2})[A-Z0-9]{4}\d{21}$/,
    PT: /^(PT[0-9]{2})\d{21}$/,
    QA: /^(QA[0-9]{2})[A-Z]{4}[A-Z0-9]{21}$/,
    RO: /^(RO[0-9]{2})[A-Z]{4}[A-Z0-9]{16}$/,
    RS: /^(RS[0-9]{2})\d{18}$/,
    SA: /^(SA[0-9]{2})\d{2}[A-Z0-9]{18}$/,
    SC: /^(SC[0-9]{2})[A-Z]{4}\d{20}[A-Z]{3}$/,
    SE: /^(SE[0-9]{2})\d{20}$/,
    SI: /^(SI[0-9]{2})\d{15}$/,
    SK: /^(SK[0-9]{2})\d{20}$/,
    SM: /^(SM[0-9]{2})[A-Z]{1}\d{10}[A-Z0-9]{12}$/,
    SV: /^(SV[0-9]{2})[A-Z0-9]{4}\d{20}$/,
    TL: /^(TL[0-9]{2})\d{19}$/,
    TN: /^(TN[0-9]{2})\d{20}$/,
    TR: /^(TR[0-9]{2})\d{5}[A-Z0-9]{17}$/,
    UA: /^(UA[0-9]{2})\d{6}[A-Z0-9]{19}$/,
    VA: /^(VA[0-9]{2})\d{18}$/,
    VG: /^(VG[0-9]{2})[A-Z0-9]{4}\d{16}$/,
    XK: /^(XK[0-9]{2})\d{16}$/
  };
  function hasOnlyValidCountryCodes(countryCodeArray) {
    var countryCodeArrayFilteredWithObjectIbanCode = countryCodeArray.filter(function(countryCode) {
      return !(countryCode in ibanRegexThroughCountryCode);
    });
    if (countryCodeArrayFilteredWithObjectIbanCode.length > 0) {
      return false;
    }
    return true;
  }
  function hasValidIbanFormat(str2, options3) {
    var strippedStr = str2.replace(/[\s\-]+/gi, "").toUpperCase();
    var isoCountryCode = strippedStr.slice(0, 2).toUpperCase();
    var isoCountryCodeInIbanRegexCodeObject = isoCountryCode in ibanRegexThroughCountryCode;
    if (options3.whitelist) {
      if (!hasOnlyValidCountryCodes(options3.whitelist)) {
        return false;
      }
      var isoCountryCodeInWhiteList = options3.whitelist.includes(isoCountryCode);
      if (!isoCountryCodeInWhiteList) {
        return false;
      }
    }
    if (options3.blacklist) {
      var isoCountryCodeInBlackList = options3.blacklist.includes(isoCountryCode);
      if (isoCountryCodeInBlackList) {
        return false;
      }
    }
    return isoCountryCodeInIbanRegexCodeObject && ibanRegexThroughCountryCode[isoCountryCode].test(strippedStr);
  }
  function hasValidIbanChecksum(str2) {
    var strippedStr = str2.replace(/[^A-Z0-9]+/gi, "").toUpperCase();
    var rearranged = strippedStr.slice(4) + strippedStr.slice(0, 4);
    var alphaCapsReplacedWithDigits = rearranged.replace(/[A-Z]/g, function(char) {
      return char.charCodeAt(0) - 55;
    });
    var remainder = alphaCapsReplacedWithDigits.match(/\d{1,7}/g).reduce(function(acc, value) {
      return Number(acc + value) % 97;
    }, "");
    return remainder === 1;
  }
  function isIBAN(str2) {
    var options3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _assertString.default)(str2);
    return hasValidIbanFormat(str2, options3) && hasValidIbanChecksum(str2);
  }
  var locales22 = exports.locales = Object.keys(ibanRegexThroughCountryCode);
});
var require_isUUID3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isUUID;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var uuid = {
    1: /^[0-9A-F]{8}-[0-9A-F]{4}-1[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    2: /^[0-9A-F]{8}-[0-9A-F]{4}-2[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    3: /^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    4: /^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    5: /^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    7: /^[0-9A-F]{8}-[0-9A-F]{4}-7[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    all: /^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i
  };
  function isUUID(str2, version3) {
    (0, _assertString.default)(str2);
    var pattern = uuid[![undefined, null].includes(version3) ? version3 : "all"];
    return !!pattern && pattern.test(str2);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isAscii3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAscii;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var ascii = /^[\x00-\x7F]+$/;
  function isAscii(str2) {
    (0, _assertString.default)(str2);
    return ascii.test(str2);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isByteLength3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isByteLength;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function _typeof(o5) {
    "@babel/helpers - typeof";
    return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o22) {
      return typeof o22;
    } : function(o22) {
      return o22 && typeof Symbol == "function" && o22.constructor === Symbol && o22 !== Symbol.prototype ? "symbol" : typeof o22;
    }, _typeof(o5);
  }
  function isByteLength(str2, options3) {
    (0, _assertString.default)(str2);
    var min;
    var max;
    if (_typeof(options3) === "object") {
      min = options3.min || 0;
      max = options3.max;
    } else {
      min = arguments[1];
      max = arguments[2];
    }
    var len = encodeURI(str2).split(/%..|./).length - 1;
    return len >= min && (typeof max === "undefined" || len <= max);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isEmail3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isEmail;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _isByteLength = _interopRequireDefault(require_isByteLength3());
  var _isFQDN = _interopRequireDefault(require_isFQDN3());
  var _isIP = _interopRequireDefault(require_isIP3());
  var _merge = _interopRequireDefault(require_merge3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_email_options = {
    allow_display_name: false,
    allow_underscores: false,
    require_display_name: false,
    allow_utf8_local_part: true,
    require_tld: true,
    blacklisted_chars: "",
    ignore_max_length: false,
    host_blacklist: [],
    host_whitelist: []
  };
  var splitNameAddress = /^([^\x00-\x1F\x7F-\x9F\cX]+)</i;
  var emailUserPart = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i;
  var gmailUserPart = /^[a-z\d]+$/;
  var quotedEmailUser = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i;
  var emailUserUtf8Part = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A1-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i;
  var quotedEmailUserUtf8 = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i;
  var defaultMaxEmailLength = 254;
  function validateDisplayName(display_name) {
    var display_name_without_quotes = display_name.replace(/^"(.+)"$/, "$1");
    if (!display_name_without_quotes.trim()) {
      return false;
    }
    var contains_illegal = /[\.";<>]/.test(display_name_without_quotes);
    if (contains_illegal) {
      if (display_name_without_quotes === display_name) {
        return false;
      }
      var all_start_with_back_slash = display_name_without_quotes.split('"').length === display_name_without_quotes.split('\\"').length;
      if (!all_start_with_back_slash) {
        return false;
      }
    }
    return true;
  }
  function isEmail(str2, options3) {
    (0, _assertString.default)(str2);
    options3 = (0, _merge.default)(options3, default_email_options);
    if (options3.require_display_name || options3.allow_display_name) {
      var display_email = str2.match(splitNameAddress);
      if (display_email) {
        var display_name = display_email[1];
        str2 = str2.replace(display_name, "").replace(/(^<|>$)/g, "");
        if (display_name.endsWith(" ")) {
          display_name = display_name.slice(0, -1);
        }
        if (!validateDisplayName(display_name)) {
          return false;
        }
      } else if (options3.require_display_name) {
        return false;
      }
    }
    if (!options3.ignore_max_length && str2.length > defaultMaxEmailLength) {
      return false;
    }
    var parts = str2.split("@");
    var domain = parts.pop();
    var lower_domain = domain.toLowerCase();
    if (options3.host_blacklist.includes(lower_domain)) {
      return false;
    }
    if (options3.host_whitelist.length > 0 && !options3.host_whitelist.includes(lower_domain)) {
      return false;
    }
    var user = parts.join("@");
    if (options3.domain_specific_validation && (lower_domain === "gmail.com" || lower_domain === "googlemail.com")) {
      user = user.toLowerCase();
      var username = user.split("+")[0];
      if (!(0, _isByteLength.default)(username.replace(/\./g, ""), {
        min: 6,
        max: 30
      })) {
        return false;
      }
      var _user_parts = username.split(".");
      for (var i5 = 0;i5 < _user_parts.length; i5++) {
        if (!gmailUserPart.test(_user_parts[i5])) {
          return false;
        }
      }
    }
    if (options3.ignore_max_length === false && (!(0, _isByteLength.default)(user, {
      max: 64
    }) || !(0, _isByteLength.default)(domain, {
      max: 254
    }))) {
      return false;
    }
    if (!(0, _isFQDN.default)(domain, {
      require_tld: options3.require_tld,
      ignore_max_length: options3.ignore_max_length,
      allow_underscores: options3.allow_underscores
    })) {
      if (!options3.allow_ip_domain) {
        return false;
      }
      if (!(0, _isIP.default)(domain)) {
        if (!domain.startsWith("[") || !domain.endsWith("]")) {
          return false;
        }
        var noBracketdomain = domain.slice(1, -1);
        if (noBracketdomain.length === 0 || !(0, _isIP.default)(noBracketdomain)) {
          return false;
        }
      }
    }
    if (user[0] === '"') {
      user = user.slice(1, user.length - 1);
      return options3.allow_utf8_local_part ? quotedEmailUserUtf8.test(user) : quotedEmailUser.test(user);
    }
    var pattern = options3.allow_utf8_local_part ? emailUserUtf8Part : emailUserPart;
    var user_parts = user.split(".");
    for (var _i2 = 0;_i2 < user_parts.length; _i2++) {
      if (!pattern.test(user_parts[_i2])) {
        return false;
      }
    }
    if (options3.blacklisted_chars) {
      if (user.search(new RegExp("[".concat(options3.blacklisted_chars, "]+"), "g")) !== -1)
        return false;
    }
    return true;
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_alpha3 = __commonJS22((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.farsiLocales = exports.englishLocales = exports.dotDecimal = exports.decimal = exports.commaDecimal = exports.bengaliLocales = exports.arabicLocales = exports.alphanumeric = exports.alpha = undefined;
  var alpha = exports.alpha = {
    "en-US": /^[A-Z]+$/i,
    "az-AZ": /^[A-VXYZ\u00C7\u018F\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "bg-BG": /^[\u0410-\u042F]+$/i,
    "cs-CZ": /^[A-Z\u00C1\u010C\u010E\u00C9\u011A\u00CD\u0147\u00D3\u0158\u0160\u0164\u00DA\u016E\u00DD\u017D]+$/i,
    "da-DK": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "de-DE": /^[A-Z\u00C4\u00D6\u00DC\u00DF]+$/i,
    "el-GR": /^[\u0391-\u03CE]+$/i,
    "es-ES": /^[A-Z\u00C1\u00C9\u00CD\u00D1\u00D3\u00DA\u00DC]+$/i,
    "fa-IR": /^[\u0627\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u06CC]+$/i,
    "fi-FI": /^[A-Z\u00C5\u00C4\u00D6]+$/i,
    "fr-FR": /^[A-Z\u00C0\u00C2\u00C6\u00C7\u00C9\u00C8\u00CA\u00CB\u00CF\u00CE\u00D4\u0152\u00D9\u00DB\u00DC\u0178]+$/i,
    "it-IT": /^[A-Z\u00C0\u00C9\u00C8\u00CC\u00CE\u00D3\u00D2\u00D9]+$/i,
    "ja-JP": /^[\u3041-\u3093\u30A1-\u30F6\uFF66-\uFF9F\u4E00-\u9FA0\u30FC\u30FB\u3002\u3001]+$/i,
    "nb-NO": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "nl-NL": /^[A-Z\u00C1\u00C9\u00CB\u00CF\u00D3\u00D6\u00DC\u00DA]+$/i,
    "nn-NO": /^[A-Z\u00C6\u00D8\u00C5]+$/i,
    "hu-HU": /^[A-Z\u00C1\u00C9\u00CD\u00D3\u00D6\u0150\u00DA\u00DC\u0170]+$/i,
    "pl-PL": /^[A-Z\u0104\u0106\u0118\u015A\u0141\u0143\u00D3\u017B\u0179]+$/i,
    "pt-PT": /^[A-Z\u00C3\u00C1\u00C0\u00C2\u00C4\u00C7\u00C9\u00CA\u00CB\u00CD\u00CF\u00D5\u00D3\u00D4\u00D6\u00DA\u00DC]+$/i,
    "ru-RU": /^[\u0410-\u042F\u0401]+$/i,
    "kk-KZ": /^[\u0410-\u042F\u0401\u04D8\u04B0\u0406\u04A2\u0492\u04AE\u049A\u04E8\u04BA]+$/i,
    "sl-SI": /^[A-Z\u010C\u0106\u0110\u0160\u017D]+$/i,
    "sk-SK": /^[A-Z\u00C1\u010C\u010E\u00C9\u00CD\u0147\u00D3\u0160\u0164\u00DA\u00DD\u017D\u0139\u0154\u013D\u00C4\u00D4]+$/i,
    "sr-RS@latin": /^[A-Z\u010C\u0106\u017D\u0160\u0110]+$/i,
    "sr-RS": /^[\u0410-\u042F\u0402\u0408\u0409\u040A\u040B\u040F]+$/i,
    "sv-SE": /^[A-Z\u00C5\u00C4\u00D6]+$/i,
    "th-TH": /^[\u0E01-\u0E50\s]+$/i,
    "tr-TR": /^[A-Z\u00C7\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "uk-UA": /^[\u0410-\u0429\u042C\u042E\u042F\u0404I\u0407\u0490\u0456]+$/i,
    "vi-VN": /^[A-Z\u00C0\u00C1\u1EA0\u1EA2\u00C3\u00C2\u1EA6\u1EA4\u1EAC\u1EA8\u1EAA\u0102\u1EB0\u1EAE\u1EB6\u1EB2\u1EB4\u0110\u00C8\u00C9\u1EB8\u1EBA\u1EBC\u00CA\u1EC0\u1EBE\u1EC6\u1EC2\u1EC4\u00CC\u00CD\u1ECA\u1EC8\u0128\u00D2\u00D3\u1ECC\u1ECE\u00D5\u00D4\u1ED2\u1ED0\u1ED8\u1ED4\u1ED6\u01A0\u1EDC\u1EDA\u1EE2\u1EDE\u1EE0\u00D9\u00DA\u1EE4\u1EE6\u0168\u01AF\u1EEA\u1EE8\u1EF0\u1EEC\u1EEE\u1EF2\u00DD\u1EF4\u1EF6\u1EF8]+$/i,
    "ko-KR": /^[\u3131-\u314E\u314F-\u3163\uAC00-\uD7A3]*$/,
    "ku-IQ": /^[\u0626\u0627\u0628\u067E\u062A\u062C\u0686\u062D\u062E\u062F\u0631\u0695\u0632\u0698\u0633\u0634\u0639\u063A\u0641\u06A4\u0642\u06A9\u06AF\u0644\u06B5\u0645\u0646\u0648\u06C6\u06BE\u06D5\u06CC\u06CE\u064A\u0637\u0624\u062B\u0622\u0625\u0623\u0643\u0636\u0635\u0629\u0638\u0630]+$/i,
    ar: /^[\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\u0670]+$/,
    he: /^[\u05D0-\u05EA]+$/,
    fa: /^['\u0622\u0627\u0621\u0623\u0624\u0626\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u0629\u06CC']+$/i,
    bn: /^['\u0980\u0981\u0982\u0983\u0985\u0986\u0987\u0988\u0989\u098A\u098B\u098C\u098F\u0990\u0993\u0994\u0995\u0996\u0997\u0998\u0999\u099A\u099B\u099C\u099D\u099E\u099F\u09A0\u09A1\u09A2\u09A3\u09A4\u09A5\u09A6\u09A7\u09A8\u09AA\u09AB\u09AC\u09AD\u09AE\u09AF\u09B0\u09B2\u09B6\u09B7\u09B8\u09B9\u09BC\u09BD\u09BE\u09BF\u09C0\u09C1\u09C2\u09C3\u09C4\u09C7\u09C8\u09CB\u09CC\u09CD\u09CE\u09D7\u09DC\u09DD\u09DF\u09E0\u09E1\u09E2\u09E3\u09F0\u09F1\u09F2\u09F3\u09F4\u09F5\u09F6\u09F7\u09F8\u09F9\u09FA\u09FB']+$/,
    eo: /^[ABC\u0108D-G\u011CH\u0124IJ\u0134K-PRS\u015CTU\u016CVZ]+$/i,
    "hi-IN": /^[\u0900-\u0961]+[\u0972-\u097F]*$/i,
    "si-LK": /^[\u0D80-\u0DFF]+$/
  };
  var alphanumeric = exports.alphanumeric = {
    "en-US": /^[0-9A-Z]+$/i,
    "az-AZ": /^[0-9A-VXYZ\u00C7\u018F\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "bg-BG": /^[0-9\u0410-\u042F]+$/i,
    "cs-CZ": /^[0-9A-Z\u00C1\u010C\u010E\u00C9\u011A\u00CD\u0147\u00D3\u0158\u0160\u0164\u00DA\u016E\u00DD\u017D]+$/i,
    "da-DK": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "de-DE": /^[0-9A-Z\u00C4\u00D6\u00DC\u00DF]+$/i,
    "el-GR": /^[0-9\u0391-\u03C9]+$/i,
    "es-ES": /^[0-9A-Z\u00C1\u00C9\u00CD\u00D1\u00D3\u00DA\u00DC]+$/i,
    "fi-FI": /^[0-9A-Z\u00C5\u00C4\u00D6]+$/i,
    "fr-FR": /^[0-9A-Z\u00C0\u00C2\u00C6\u00C7\u00C9\u00C8\u00CA\u00CB\u00CF\u00CE\u00D4\u0152\u00D9\u00DB\u00DC\u0178]+$/i,
    "it-IT": /^[0-9A-Z\u00C0\u00C9\u00C8\u00CC\u00CE\u00D3\u00D2\u00D9]+$/i,
    "ja-JP": /^[0-9\uFF10-\uFF19\u3041-\u3093\u30A1-\u30F6\uFF66-\uFF9F\u4E00-\u9FA0\u30FC\u30FB\u3002\u3001]+$/i,
    "hu-HU": /^[0-9A-Z\u00C1\u00C9\u00CD\u00D3\u00D6\u0150\u00DA\u00DC\u0170]+$/i,
    "nb-NO": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "nl-NL": /^[0-9A-Z\u00C1\u00C9\u00CB\u00CF\u00D3\u00D6\u00DC\u00DA]+$/i,
    "nn-NO": /^[0-9A-Z\u00C6\u00D8\u00C5]+$/i,
    "pl-PL": /^[0-9A-Z\u0104\u0106\u0118\u015A\u0141\u0143\u00D3\u017B\u0179]+$/i,
    "pt-PT": /^[0-9A-Z\u00C3\u00C1\u00C0\u00C2\u00C4\u00C7\u00C9\u00CA\u00CB\u00CD\u00CF\u00D5\u00D3\u00D4\u00D6\u00DA\u00DC]+$/i,
    "ru-RU": /^[0-9\u0410-\u042F\u0401]+$/i,
    "kk-KZ": /^[0-9\u0410-\u042F\u0401\u04D8\u04B0\u0406\u04A2\u0492\u04AE\u049A\u04E8\u04BA]+$/i,
    "sl-SI": /^[0-9A-Z\u010C\u0106\u0110\u0160\u017D]+$/i,
    "sk-SK": /^[0-9A-Z\u00C1\u010C\u010E\u00C9\u00CD\u0147\u00D3\u0160\u0164\u00DA\u00DD\u017D\u0139\u0154\u013D\u00C4\u00D4]+$/i,
    "sr-RS@latin": /^[0-9A-Z\u010C\u0106\u017D\u0160\u0110]+$/i,
    "sr-RS": /^[0-9\u0410-\u042F\u0402\u0408\u0409\u040A\u040B\u040F]+$/i,
    "sv-SE": /^[0-9A-Z\u00C5\u00C4\u00D6]+$/i,
    "th-TH": /^[\u0E01-\u0E59\s]+$/i,
    "tr-TR": /^[0-9A-Z\u00C7\u011E\u0130\u0131\u00D6\u015E\u00DC]+$/i,
    "uk-UA": /^[0-9\u0410-\u0429\u042C\u042E\u042F\u0404I\u0407\u0490\u0456]+$/i,
    "ko-KR": /^[0-9\u3131-\u314E\u314F-\u3163\uAC00-\uD7A3]*$/,
    "ku-IQ": /^[\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u06690-9\u0626\u0627\u0628\u067E\u062A\u062C\u0686\u062D\u062E\u062F\u0631\u0695\u0632\u0698\u0633\u0634\u0639\u063A\u0641\u06A4\u0642\u06A9\u06AF\u0644\u06B5\u0645\u0646\u0648\u06C6\u06BE\u06D5\u06CC\u06CE\u064A\u0637\u0624\u062B\u0622\u0625\u0623\u0643\u0636\u0635\u0629\u0638\u0630]+$/i,
    "vi-VN": /^[0-9A-Z\u00C0\u00C1\u1EA0\u1EA2\u00C3\u00C2\u1EA6\u1EA4\u1EAC\u1EA8\u1EAA\u0102\u1EB0\u1EAE\u1EB6\u1EB2\u1EB4\u0110\u00C8\u00C9\u1EB8\u1EBA\u1EBC\u00CA\u1EC0\u1EBE\u1EC6\u1EC2\u1EC4\u00CC\u00CD\u1ECA\u1EC8\u0128\u00D2\u00D3\u1ECC\u1ECE\u00D5\u00D4\u1ED2\u1ED0\u1ED8\u1ED4\u1ED6\u01A0\u1EDC\u1EDA\u1EE2\u1EDE\u1EE0\u00D9\u00DA\u1EE4\u1EE6\u0168\u01AF\u1EEA\u1EE8\u1EF0\u1EEC\u1EEE\u1EF2\u00DD\u1EF4\u1EF6\u1EF8]+$/i,
    ar: /^[\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u06690-9\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\u0670]+$/,
    he: /^[0-9\u05D0-\u05EA]+$/,
    fa: /^['0-9\u0622\u0627\u0621\u0623\u0624\u0626\u0628\u067E\u062A\u062B\u062C\u0686\u062D\u062E\u062F\u0630\u0631\u0632\u0698\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\u0641\u0642\u06A9\u06AF\u0644\u0645\u0646\u0648\u0647\u0629\u06CC\u06F1\u06F2\u06F3\u06F4\u06F5\u06F6\u06F7\u06F8\u06F9\u06F0']+$/i,
    bn: /^['\u0980\u0981\u0982\u0983\u0985\u0986\u0987\u0988\u0989\u098A\u098B\u098C\u098F\u0990\u0993\u0994\u0995\u0996\u0997\u0998\u0999\u099A\u099B\u099C\u099D\u099E\u099F\u09A0\u09A1\u09A2\u09A3\u09A4\u09A5\u09A6\u09A7\u09A8\u09AA\u09AB\u09AC\u09AD\u09AE\u09AF\u09B0\u09B2\u09B6\u09B7\u09B8\u09B9\u09BC\u09BD\u09BE\u09BF\u09C0\u09C1\u09C2\u09C3\u09C4\u09C7\u09C8\u09CB\u09CC\u09CD\u09CE\u09D7\u09DC\u09DD\u09DF\u09E0\u09E1\u09E2\u09E3\u09E6\u09E7\u09E8\u09E9\u09EA\u09EB\u09EC\u09ED\u09EE\u09EF\u09F0\u09F1\u09F2\u09F3\u09F4\u09F5\u09F6\u09F7\u09F8\u09F9\u09FA\u09FB']+$/,
    eo: /^[0-9ABC\u0108D-G\u011CH\u0124IJ\u0134K-PRS\u015CTU\u016CVZ]+$/i,
    "hi-IN": /^[\u0900-\u0963]+[\u0966-\u097F]*$/i,
    "si-LK": /^[0-9\u0D80-\u0DFF]+$/
  };
  var decimal = exports.decimal = {
    "en-US": ".",
    ar: "\u066B"
  };
  var englishLocales = exports.englishLocales = ["AU", "GB", "HK", "IN", "NZ", "ZA", "ZM"];
  for (i5 = 0;i5 < englishLocales.length; i5++) {
    locale = "en-".concat(englishLocales[i5]);
    alpha[locale] = alpha["en-US"];
    alphanumeric[locale] = alphanumeric["en-US"];
    decimal[locale] = decimal["en-US"];
  }
  var locale;
  var i5;
  var arabicLocales = exports.arabicLocales = ["AE", "BH", "DZ", "EG", "IQ", "JO", "KW", "LB", "LY", "MA", "QM", "QA", "SA", "SD", "SY", "TN", "YE"];
  for (_i2 = 0;_i2 < arabicLocales.length; _i2++) {
    _locale = "ar-".concat(arabicLocales[_i2]);
    alpha[_locale] = alpha.ar;
    alphanumeric[_locale] = alphanumeric.ar;
    decimal[_locale] = decimal.ar;
  }
  var _locale;
  var _i2;
  var farsiLocales = exports.farsiLocales = ["IR", "AF"];
  for (_i22 = 0;_i22 < farsiLocales.length; _i22++) {
    _locale2 = "fa-".concat(farsiLocales[_i22]);
    alphanumeric[_locale2] = alphanumeric.fa;
    decimal[_locale2] = decimal.ar;
  }
  var _locale2;
  var _i22;
  var bengaliLocales = exports.bengaliLocales = ["BD", "IN"];
  for (_i3 = 0;_i3 < bengaliLocales.length; _i3++) {
    _locale3 = "bn-".concat(bengaliLocales[_i3]);
    alpha[_locale3] = alpha.bn;
    alphanumeric[_locale3] = alphanumeric.bn;
    decimal[_locale3] = decimal["en-US"];
  }
  var _locale3;
  var _i3;
  var dotDecimal = exports.dotDecimal = ["ar-EG", "ar-LB", "ar-LY"];
  var commaDecimal = exports.commaDecimal = ["bg-BG", "cs-CZ", "da-DK", "de-DE", "el-GR", "en-ZM", "eo", "es-ES", "fr-CA", "fr-FR", "id-ID", "it-IT", "ku-IQ", "hi-IN", "hu-HU", "nb-NO", "nn-NO", "nl-NL", "pl-PL", "pt-PT", "ru-RU", "kk-KZ", "si-LK", "sl-SI", "sr-RS@latin", "sr-RS", "sv-SE", "tr-TR", "uk-UA", "vi-VN"];
  for (_i4 = 0;_i4 < dotDecimal.length; _i4++) {
    decimal[dotDecimal[_i4]] = decimal["en-US"];
  }
  var _i4;
  for (_i5 = 0;_i5 < commaDecimal.length; _i5++) {
    decimal[commaDecimal[_i5]] = ",";
  }
  var _i5;
  alpha["fr-CA"] = alpha["fr-FR"];
  alphanumeric["fr-CA"] = alphanumeric["fr-FR"];
  alpha["pt-BR"] = alpha["pt-PT"];
  alphanumeric["pt-BR"] = alphanumeric["pt-PT"];
  decimal["pt-BR"] = decimal["pt-PT"];
  alpha["pl-Pl"] = alpha["pl-PL"];
  alphanumeric["pl-Pl"] = alphanumeric["pl-PL"];
  decimal["pl-Pl"] = decimal["pl-PL"];
  alpha["fa-AF"] = alpha.fa;
});
var require_isAlpha3 = __commonJS22((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAlpha;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _alpha = require_alpha3();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isAlpha(_str) {
    var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "en-US";
    var options3 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    (0, _assertString.default)(_str);
    var str2 = _str;
    var ignore2 = options3.ignore;
    if (ignore2) {
      if (ignore2 instanceof RegExp) {
        str2 = str2.replace(ignore2, "");
      } else if (typeof ignore2 === "string") {
        str2 = str2.replace(new RegExp("[".concat(ignore2.replace(/[-[\]{}()*+?.,\\^$|#\\s]/g, "\\$&"), "]"), "g"), "");
      } else {
        throw new Error("ignore should be instance of a String or RegExp");
      }
    }
    if (locale in _alpha.alpha) {
      return _alpha.alpha[locale].test(str2);
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales22 = exports.locales = Object.keys(_alpha.alpha);
});
var require_isLatLong3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isLatLong;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _merge = _interopRequireDefault(require_merge3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var lat = /^\(?[+-]?(90(\.0+)?|[1-8]?\d(\.\d+)?)$/;
  var long = /^\s?[+-]?(180(\.0+)?|1[0-7]\d(\.\d+)?|\d{1,2}(\.\d+)?)\)?$/;
  var latDMS = /^(([1-8]?\d)\D+([1-5]?\d|60)\D+([1-5]?\d|60)(\.\d+)?|90\D+0\D+0)\D+[NSns]?$/i;
  var longDMS = /^\s*([1-7]?\d{1,2}\D+([1-5]?\d|60)\D+([1-5]?\d|60)(\.\d+)?|180\D+0\D+0)\D+[EWew]?$/i;
  var defaultLatLongOptions = {
    checkDMS: false
  };
  function isLatLong(str2, options3) {
    (0, _assertString.default)(str2);
    options3 = (0, _merge.default)(options3, defaultLatLongOptions);
    if (!str2.includes(","))
      return false;
    var pair = str2.split(",");
    if (pair[0].startsWith("(") && !pair[1].endsWith(")") || pair[1].endsWith(")") && !pair[0].startsWith("("))
      return false;
    if (options3.checkDMS) {
      return latDMS.test(pair[0]) && longDMS.test(pair[1]);
    }
    return lat.test(pair[0]) && long.test(pair[1]);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_includes3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;
  var includes2 = function includes(arr, val2) {
    return arr.some(function(arrVal) {
      return val2 === arrVal;
    });
  };
  var _default2 = exports.default = includes2;
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isDecimal3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isDecimal;
  var _merge = _interopRequireDefault(require_merge3());
  var _assertString = _interopRequireDefault(require_assertString3());
  var _includes = _interopRequireDefault(require_includes3());
  var _alpha = require_alpha3();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function decimalRegExp(options3) {
    var regExp = new RegExp("^[-+]?([0-9]+)?(\\".concat(_alpha.decimal[options3.locale], "[0-9]{").concat(options3.decimal_digits, "})").concat(options3.force_decimal ? "" : "?", "$"));
    return regExp;
  }
  var default_decimal_options = {
    force_decimal: false,
    decimal_digits: "1,",
    locale: "en-US"
  };
  var blacklist = ["", "-", "+"];
  function isDecimal(str2, options3) {
    (0, _assertString.default)(str2);
    options3 = (0, _merge.default)(options3, default_decimal_options);
    if (options3.locale in _alpha.decimal) {
      return !(0, _includes.default)(blacklist, str2.replace(/ /g, "")) && decimalRegExp(options3).test(str2);
    }
    throw new Error("Invalid locale '".concat(options3.locale, "'"));
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isHexColor3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isHexColor;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var hexcolor = /^#?([0-9A-F]{3}|[0-9A-F]{4}|[0-9A-F]{6}|[0-9A-F]{8})$/i;
  function isHexColor(str2) {
    (0, _assertString.default)(str2);
    return hexcolor.test(str2);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isLuhnNumber3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isLuhnNumber;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isLuhnNumber(str2) {
    (0, _assertString.default)(str2);
    var sanitized = str2.replace(/[- ]+/g, "");
    var sum = 0;
    var digit;
    var tmpNum;
    var shouldDouble;
    for (var i5 = sanitized.length - 1;i5 >= 0; i5--) {
      digit = sanitized.substring(i5, i5 + 1);
      tmpNum = parseInt(digit, 10);
      if (shouldDouble) {
        tmpNum *= 2;
        if (tmpNum >= 10) {
          sum += tmpNum % 10 + 1;
        } else {
          sum += tmpNum;
        }
      } else {
        sum += tmpNum;
      }
      shouldDouble = !shouldDouble;
    }
    return !!(sum % 10 === 0 ? sanitized : false);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isCreditCard3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isCreditCard;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _isLuhnNumber = _interopRequireDefault(require_isLuhnNumber3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var cards = {
    amex: /^3[47][0-9]{13}$/,
    dinersclub: /^3(?:0[0-5]|[68][0-9])[0-9]{11}$/,
    discover: /^6(?:011|5[0-9][0-9])[0-9]{12,15}$/,
    jcb: /^(?:2131|1800|35\d{3})\d{11}$/,
    mastercard: /^5[1-5][0-9]{2}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}$/,
    unionpay: /^(6[27][0-9]{14}|^(81[0-9]{14,17}))$/,
    visa: /^(?:4[0-9]{12})(?:[0-9]{3,6})?$/
  };
  var allCards = function() {
    var tmpCardsArray = [];
    for (var cardProvider in cards) {
      if (cards.hasOwnProperty(cardProvider)) {
        tmpCardsArray.push(cards[cardProvider]);
      }
    }
    return tmpCardsArray;
  }();
  function isCreditCard(card) {
    var options3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _assertString.default)(card);
    var provider = options3.provider;
    var sanitized = card.replace(/[- ]+/g, "");
    if (provider && provider.toLowerCase() in cards) {
      if (!cards[provider.toLowerCase()].test(sanitized)) {
        return false;
      }
    } else if (provider && !(provider.toLowerCase() in cards)) {
      throw new Error("".concat(provider, " is not a valid credit card provider."));
    } else if (!allCards.some(function(cardProvider) {
      return cardProvider.test(sanitized);
    })) {
      return false;
    }
    return (0, _isLuhnNumber.default)(card);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isAlphanumeric3 = __commonJS22((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isAlphanumeric;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString3());
  var _alpha = require_alpha3();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function isAlphanumeric(_str) {
    var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "en-US";
    var options3 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    (0, _assertString.default)(_str);
    var str2 = _str;
    var ignore2 = options3.ignore;
    if (ignore2) {
      if (ignore2 instanceof RegExp) {
        str2 = str2.replace(ignore2, "");
      } else if (typeof ignore2 === "string") {
        str2 = str2.replace(new RegExp("[".concat(ignore2.replace(/[-[\]{}()*+?.,\\^$|#\\s]/g, "\\$&"), "]"), "g"), "");
      } else {
        throw new Error("ignore should be instance of a String or RegExp");
      }
    }
    if (locale in _alpha.alphanumeric) {
      return _alpha.alphanumeric[locale].test(str2);
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales22 = exports.locales = Object.keys(_alpha.alphanumeric);
});
var require_isPassportNumber3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isPassportNumber;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var passportRegexByCountryCode = {
    AM: /^[A-Z]{2}\d{7}$/,
    AR: /^[A-Z]{3}\d{6}$/,
    AT: /^[A-Z]\d{7}$/,
    AU: /^[A-Z]\d{7}$/,
    AZ: /^[A-Z]{1}\d{8}$/,
    BE: /^[A-Z]{2}\d{6}$/,
    BG: /^\d{9}$/,
    BR: /^[A-Z]{2}\d{6}$/,
    BY: /^[A-Z]{2}\d{7}$/,
    CA: /^[A-Z]{2}\d{6}$/,
    CH: /^[A-Z]\d{7}$/,
    CN: /^G\d{8}$|^E(?![IO])[A-Z0-9]\d{7}$/,
    CY: /^[A-Z](\d{6}|\d{8})$/,
    CZ: /^\d{8}$/,
    DE: /^[CFGHJKLMNPRTVWXYZ0-9]{9}$/,
    DK: /^\d{9}$/,
    DZ: /^\d{9}$/,
    EE: /^([A-Z]\d{7}|[A-Z]{2}\d{7})$/,
    ES: /^[A-Z0-9]{2}([A-Z0-9]?)\d{6}$/,
    FI: /^[A-Z]{2}\d{7}$/,
    FR: /^\d{2}[A-Z]{2}\d{5}$/,
    GB: /^\d{9}$/,
    GR: /^[A-Z]{2}\d{7}$/,
    HR: /^\d{9}$/,
    HU: /^[A-Z]{2}(\d{6}|\d{7})$/,
    IE: /^[A-Z0-9]{2}\d{7}$/,
    IN: /^[A-Z]{1}-?\d{7}$/,
    ID: /^[A-C]\d{7}$/,
    IR: /^[A-Z]\d{8}$/,
    IS: /^(A)\d{7}$/,
    IT: /^[A-Z0-9]{2}\d{7}$/,
    JM: /^[Aa]\d{7}$/,
    JP: /^[A-Z]{2}\d{7}$/,
    KR: /^[MS]\d{8}$/,
    KZ: /^[a-zA-Z]\d{7}$/,
    LI: /^[a-zA-Z]\d{5}$/,
    LT: /^[A-Z0-9]{8}$/,
    LU: /^[A-Z0-9]{8}$/,
    LV: /^[A-Z0-9]{2}\d{7}$/,
    LY: /^[A-Z0-9]{8}$/,
    MT: /^\d{7}$/,
    MZ: /^([A-Z]{2}\d{7})|(\d{2}[A-Z]{2}\d{5})$/,
    MY: /^[AHK]\d{8}$/,
    MX: /^\d{10,11}$/,
    NL: /^[A-Z]{2}[A-Z0-9]{6}\d$/,
    NZ: /^([Ll]([Aa]|[Dd]|[Ff]|[Hh])|[Ee]([Aa]|[Pp])|[Nn])\d{6}$/,
    PH: /^([A-Z](\d{6}|\d{7}[A-Z]))|([A-Z]{2}(\d{6}|\d{7}))$/,
    PK: /^[A-Z]{2}\d{7}$/,
    PL: /^[A-Z]{2}\d{7}$/,
    PT: /^[A-Z]\d{6}$/,
    RO: /^\d{8,9}$/,
    RU: /^\d{9}$/,
    SE: /^\d{8}$/,
    SL: /^(P)[A-Z]\d{7}$/,
    SK: /^[0-9A-Z]\d{7}$/,
    TH: /^[A-Z]{1,2}\d{6,7}$/,
    TR: /^[A-Z]\d{8}$/,
    UA: /^[A-Z]{2}\d{6}$/,
    US: /^\d{9}$/,
    ZA: /^[TAMD]\d{8}$/
  };
  function isPassportNumber(str2, countryCode) {
    (0, _assertString.default)(str2);
    var normalizedStr = str2.replace(/\s/g, "").toUpperCase();
    return countryCode.toUpperCase() in passportRegexByCountryCode && passportRegexByCountryCode[countryCode].test(normalizedStr);
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_isPostalCode3 = __commonJS22((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isPostalCode;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var threeDigit = /^\d{3}$/;
  var fourDigit = /^\d{4}$/;
  var fiveDigit = /^\d{5}$/;
  var sixDigit = /^\d{6}$/;
  var patterns = {
    AD: /^AD\d{3}$/,
    AT: fourDigit,
    AU: fourDigit,
    AZ: /^AZ\d{4}$/,
    BA: /^([7-8]\d{4}$)/,
    BE: fourDigit,
    BG: fourDigit,
    BR: /^\d{5}-\d{3}$/,
    BY: /^2[1-4]\d{4}$/,
    CA: /^[ABCEGHJKLMNPRSTVXY]\d[ABCEGHJ-NPRSTV-Z][\s\-]?\d[ABCEGHJ-NPRSTV-Z]\d$/i,
    CH: fourDigit,
    CN: /^(0[1-7]|1[012356]|2[0-7]|3[0-6]|4[0-7]|5[1-7]|6[1-7]|7[1-5]|8[1345]|9[09])\d{4}$/,
    CZ: /^\d{3}\s?\d{2}$/,
    DE: fiveDigit,
    DK: fourDigit,
    DO: fiveDigit,
    DZ: fiveDigit,
    EE: fiveDigit,
    ES: /^(5[0-2]{1}|[0-4]{1}\d{1})\d{3}$/,
    FI: fiveDigit,
    FR: /^\d{2}\s?\d{3}$/,
    GB: /^(gir\s?0aa|[a-z]{1,2}\d[\da-z]?\s?(\d[a-z]{2})?)$/i,
    GR: /^\d{3}\s?\d{2}$/,
    HR: /^([1-5]\d{4}$)/,
    HT: /^HT\d{4}$/,
    HU: fourDigit,
    ID: fiveDigit,
    IE: /^(?!.*(?:o))[A-Za-z]\d[\dw]\s\w{4}$/i,
    IL: /^(\d{5}|\d{7})$/,
    IN: /^((?!10|29|35|54|55|65|66|86|87|88|89)[1-9][0-9]{5})$/,
    IR: /^(?!(\d)\1{3})[13-9]{4}[1346-9][013-9]{5}$/,
    IS: threeDigit,
    IT: fiveDigit,
    JP: /^\d{3}\-\d{4}$/,
    KE: fiveDigit,
    KR: /^(\d{5}|\d{6})$/,
    LI: /^(948[5-9]|949[0-7])$/,
    LT: /^LT\-\d{5}$/,
    LU: fourDigit,
    LV: /^LV\-\d{4}$/,
    LK: fiveDigit,
    MG: threeDigit,
    MX: fiveDigit,
    MT: /^[A-Za-z]{3}\s{0,1}\d{4}$/,
    MY: fiveDigit,
    NL: /^[1-9]\d{3}\s?(?!sa|sd|ss)[a-z]{2}$/i,
    NO: fourDigit,
    NP: /^(10|21|22|32|33|34|44|45|56|57)\d{3}$|^(977)$/i,
    NZ: fourDigit,
    PL: /^\d{2}\-\d{3}$/,
    PR: /^00[679]\d{2}([ -]\d{4})?$/,
    PT: /^\d{4}\-\d{3}?$/,
    RO: sixDigit,
    RU: sixDigit,
    SA: fiveDigit,
    SE: /^[1-9]\d{2}\s?\d{2}$/,
    SG: sixDigit,
    SI: fourDigit,
    SK: /^\d{3}\s?\d{2}$/,
    TH: fiveDigit,
    TN: fourDigit,
    TW: /^\d{3}(\d{2})?$/,
    UA: fiveDigit,
    US: /^\d{5}(-\d{4})?$/,
    ZA: fourDigit,
    ZM: fiveDigit
  };
  var locales22 = exports.locales = Object.keys(patterns);
  function isPostalCode(str2, locale) {
    (0, _assertString.default)(str2);
    if (locale in patterns) {
      return patterns[locale].test(str2);
    } else if (locale === "any") {
      for (var key in patterns) {
        if (patterns.hasOwnProperty(key)) {
          var pattern = patterns[key];
          if (pattern.test(str2)) {
            return true;
          }
        }
      }
      return false;
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
});
var require_isMobilePhone3 = __commonJS22((exports) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = isMobilePhone;
  exports.locales = undefined;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var phones = {
    "am-AM": /^(\+?374|0)(33|4[134]|55|77|88|9[13-689])\d{6}$/,
    "ar-AE": /^((\+?971)|0)?5[024568]\d{7}$/,
    "ar-BH": /^(\+?973)?(3|6)\d{7}$/,
    "ar-DZ": /^(\+?213|0)(5|6|7)\d{8}$/,
    "ar-LB": /^(\+?961)?((3|81)\d{6}|7\d{7})$/,
    "ar-EG": /^((\+?20)|0)?1[0125]\d{8}$/,
    "ar-IQ": /^(\+?964|0)?7[0-9]\d{8}$/,
    "ar-JO": /^(\+?962|0)?7[789]\d{7}$/,
    "ar-KW": /^(\+?965)([569]\d{7}|41\d{6})$/,
    "ar-LY": /^((\+?218)|0)?(9[1-6]\d{7}|[1-8]\d{7,9})$/,
    "ar-MA": /^(?:(?:\+|00)212|0)[5-7]\d{8}$/,
    "ar-OM": /^((\+|00)968)?(9[1-9])\d{6}$/,
    "ar-PS": /^(\+?970|0)5[6|9](\d{7})$/,
    "ar-SA": /^(!?(\+?966)|0)?5\d{8}$/,
    "ar-SD": /^((\+?249)|0)?(9[012369]|1[012])\d{7}$/,
    "ar-SY": /^(!?(\+?963)|0)?9\d{8}$/,
    "ar-TN": /^(\+?216)?[2459]\d{7}$/,
    "az-AZ": /^(\+994|0)(10|5[015]|7[07]|99)\d{7}$/,
    "bs-BA": /^((((\+|00)3876)|06))((([0-3]|[5-6])\d{6})|(4\d{7}))$/,
    "be-BY": /^(\+?375)?(24|25|29|33|44)\d{7}$/,
    "bg-BG": /^(\+?359|0)?8[789]\d{7}$/,
    "bn-BD": /^(\+?880|0)1[13456789][0-9]{8}$/,
    "ca-AD": /^(\+376)?[346]\d{5}$/,
    "cs-CZ": /^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,
    "da-DK": /^(\+?45)?\s?\d{2}\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "de-DE": /^((\+49|0)1)(5[0-25-9]\d|6([23]|0\d?)|7([0-57-9]|6\d))\d{7,9}$/,
    "de-AT": /^(\+43|0)\d{1,4}\d{3,12}$/,
    "de-CH": /^(\+41|0)([1-9])\d{1,9}$/,
    "de-LU": /^(\+352)?((6\d1)\d{6})$/,
    "dv-MV": /^(\+?960)?(7[2-9]|9[1-9])\d{5}$/,
    "el-GR": /^(\+?30|0)?6(8[5-9]|9(?![26])[0-9])\d{7}$/,
    "el-CY": /^(\+?357?)?(9(9|6)\d{6})$/,
    "en-AI": /^(\+?1|0)264(?:2(35|92)|4(?:6[1-2]|76|97)|5(?:3[6-9]|8[1-4])|7(?:2(4|9)|72))\d{4}$/,
    "en-AU": /^(\+?61|0)4\d{8}$/,
    "en-AG": /^(?:\+1|1)268(?:464|7(?:1[3-9]|[28]\d|3[0246]|64|7[0-689]))\d{4}$/,
    "en-BM": /^(\+?1)?441(((3|7)\d{6}$)|(5[0-3][0-9]\d{4}$)|(59\d{5}$))/,
    "en-BS": /^(\+?1[-\s]?|0)?\(?242\)?[-\s]?\d{3}[-\s]?\d{4}$/,
    "en-GB": /^(\+?44|0)7\d{9}$/,
    "en-GG": /^(\+?44|0)1481\d{6}$/,
    "en-GH": /^(\+233|0)(20|50|24|54|27|57|26|56|23|28|55|59)\d{7}$/,
    "en-GY": /^(\+592|0)6\d{6}$/,
    "en-HK": /^(\+?852[-\s]?)?[456789]\d{3}[-\s]?\d{4}$/,
    "en-MO": /^(\+?853[-\s]?)?[6]\d{3}[-\s]?\d{4}$/,
    "en-IE": /^(\+?353|0)8[356789]\d{7}$/,
    "en-IN": /^(\+?91|0)?[6789]\d{9}$/,
    "en-JM": /^(\+?876)?\d{7}$/,
    "en-KE": /^(\+?254|0)(7|1)\d{8}$/,
    "fr-CF": /^(\+?236| ?)(70|75|77|72|21|22)\d{6}$/,
    "en-SS": /^(\+?211|0)(9[1257])\d{7}$/,
    "en-KI": /^((\+686|686)?)?( )?((6|7)(2|3|8)[0-9]{6})$/,
    "en-KN": /^(?:\+1|1)869(?:46\d|48[89]|55[6-8]|66\d|76[02-7])\d{4}$/,
    "en-LS": /^(\+?266)(22|28|57|58|59|27|52)\d{6}$/,
    "en-MT": /^(\+?356|0)?(99|79|77|21|27|22|25)[0-9]{6}$/,
    "en-MU": /^(\+?230|0)?\d{8}$/,
    "en-MW": /^(\+?265|0)(((77|88|31|99|98|21)\d{7})|(((111)|1)\d{6})|(32000\d{4}))$/,
    "en-NA": /^(\+?264|0)(6|8)\d{7}$/,
    "en-NG": /^(\+?234|0)?[789]\d{9}$/,
    "en-NZ": /^(\+?64|0)[28]\d{7,9}$/,
    "en-PG": /^(\+?675|0)?(7\d|8[18])\d{6}$/,
    "en-PK": /^((00|\+)?92|0)3[0-6]\d{8}$/,
    "en-PH": /^(09|\+639)\d{9}$/,
    "en-RW": /^(\+?250|0)?[7]\d{8}$/,
    "en-SG": /^(\+65)?[3689]\d{7}$/,
    "en-SL": /^(\+?232|0)\d{8}$/,
    "en-TZ": /^(\+?255|0)?[67]\d{8}$/,
    "en-UG": /^(\+?256|0)?[7]\d{8}$/,
    "en-US": /^((\+1|1)?( |-)?)?(\([2-9][0-9]{2}\)|[2-9][0-9]{2})( |-)?([2-9][0-9]{2}( |-)?[0-9]{4})$/,
    "en-ZA": /^(\+?27|0)\d{9}$/,
    "en-ZM": /^(\+?26)?09[567]\d{7}$/,
    "en-ZW": /^(\+263)[0-9]{9}$/,
    "en-BW": /^(\+?267)?(7[1-8]{1})\d{6}$/,
    "es-AR": /^\+?549(11|[2368]\d)\d{8}$/,
    "es-BO": /^(\+?591)?(6|7)\d{7}$/,
    "es-CO": /^(\+?57)?3(0(0|1|2|4|5)|1\d|2[0-4]|5(0|1))\d{7}$/,
    "es-CL": /^(\+?56|0)[2-9]\d{1}\d{7}$/,
    "es-CR": /^(\+506)?[2-8]\d{7}$/,
    "es-CU": /^(\+53|0053)?5\d{7}$/,
    "es-DO": /^(\+?1)?8[024]9\d{7}$/,
    "es-HN": /^(\+?504)?[9|8|3|2]\d{7}$/,
    "es-EC": /^(\+?593|0)([2-7]|9[2-9])\d{7}$/,
    "es-ES": /^(\+?34)?[6|7]\d{8}$/,
    "es-PE": /^(\+?51)?9\d{8}$/,
    "es-MX": /^(\+?52)?(1|01)?\d{10,11}$/,
    "es-NI": /^(\+?505)\d{7,8}$/,
    "es-PA": /^(\+?507)\d{7,8}$/,
    "es-PY": /^(\+?595|0)9[9876]\d{7}$/,
    "es-SV": /^(\+?503)?[67]\d{7}$/,
    "es-UY": /^(\+598|0)9[1-9][\d]{6}$/,
    "es-VE": /^(\+?58)?(2|4)\d{9}$/,
    "et-EE": /^(\+?372)?\s?(5|8[1-4])\s?([0-9]\s?){6,7}$/,
    "fa-IR": /^(\+?98[\-\s]?|0)9[0-39]\d[\-\s]?\d{3}[\-\s]?\d{4}$/,
    "fi-FI": /^(\+?358|0)\s?(4[0-6]|50)\s?(\d\s?){4,8}$/,
    "fj-FJ": /^(\+?679)?\s?\d{3}\s?\d{4}$/,
    "fo-FO": /^(\+?298)?\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "fr-BF": /^(\+226|0)[67]\d{7}$/,
    "fr-BJ": /^(\+229)\d{8}$/,
    "fr-CD": /^(\+?243|0)?(8|9)\d{8}$/,
    "fr-CM": /^(\+?237)6[0-9]{8}$/,
    "fr-FR": /^(\+?33|0)[67]\d{8}$/,
    "fr-GF": /^(\+?594|0|00594)[67]\d{8}$/,
    "fr-GP": /^(\+?590|0|00590)[67]\d{8}$/,
    "fr-MQ": /^(\+?596|0|00596)[67]\d{8}$/,
    "fr-PF": /^(\+?689)?8[789]\d{6}$/,
    "fr-RE": /^(\+?262|0|00262)[67]\d{8}$/,
    "fr-WF": /^(\+681)?\d{6}$/,
    "he-IL": /^(\+972|0)([23489]|5[012345689]|77)[1-9]\d{6}$/,
    "hu-HU": /^(\+?36|06)(20|30|31|50|70)\d{7}$/,
    "id-ID": /^(\+?62|0)8(1[123456789]|2[1238]|3[1238]|5[12356789]|7[78]|9[56789]|8[123456789])([\s?|\d]{5,11})$/,
    "ir-IR": /^(\+98|0)?9\d{9}$/,
    "it-IT": /^(\+?39)?\s?3\d{2} ?\d{6,7}$/,
    "it-SM": /^((\+378)|(0549)|(\+390549)|(\+3780549))?6\d{5,9}$/,
    "ja-JP": /^(\+81[ \-]?(\(0\))?|0)[6789]0[ \-]?\d{4}[ \-]?\d{4}$/,
    "ka-GE": /^(\+?995)?(79\d{7}|5\d{8})$/,
    "kk-KZ": /^(\+?7|8)?7\d{9}$/,
    "kl-GL": /^(\+?299)?\s?\d{2}\s?\d{2}\s?\d{2}$/,
    "ko-KR": /^((\+?82)[ \-]?)?0?1([0|1|6|7|8|9]{1})[ \-]?\d{3,4}[ \-]?\d{4}$/,
    "ky-KG": /^(\+?7\s?\+?7|0)\s?\d{2}\s?\d{3}\s?\d{4}$/,
    "lt-LT": /^(\+370|8)\d{8}$/,
    "lv-LV": /^(\+?371)2\d{7}$/,
    "mg-MG": /^((\+?261|0)(2|3)\d)?\d{7}$/,
    "mn-MN": /^(\+|00|011)?976(77|81|88|91|94|95|96|99)\d{6}$/,
    "my-MM": /^(\+?959|09|9)(2[5-7]|3[1-2]|4[0-5]|6[6-9]|7[5-9]|9[6-9])[0-9]{7}$/,
    "ms-MY": /^(\+?60|0)1(([0145](-|\s)?\d{7,8})|([236-9](-|\s)?\d{7}))$/,
    "mz-MZ": /^(\+?258)?8[234567]\d{7}$/,
    "nb-NO": /^(\+?47)?[49]\d{7}$/,
    "ne-NP": /^(\+?977)?9[78]\d{8}$/,
    "nl-BE": /^(\+?32|0)4\d{8}$/,
    "nl-NL": /^(((\+|00)?31\(0\))|((\+|00)?31)|0)6{1}\d{8}$/,
    "nl-AW": /^(\+)?297(56|59|64|73|74|99)\d{5}$/,
    "nn-NO": /^(\+?47)?[49]\d{7}$/,
    "pl-PL": /^(\+?48)? ?([5-8]\d|45) ?\d{3} ?\d{2} ?\d{2}$/,
    "pt-BR": /^((\+?55\ ?[1-9]{2}\ ?)|(\+?55\ ?\([1-9]{2}\)\ ?)|(0[1-9]{2}\ ?)|(\([1-9]{2}\)\ ?)|([1-9]{2}\ ?))((\d{4}\-?\d{4})|(9[1-9]{1}\d{3}\-?\d{4}))$/,
    "pt-PT": /^(\+?351)?9[1236]\d{7}$/,
    "pt-AO": /^(\+244)\d{9}$/,
    "ro-MD": /^(\+?373|0)((6(0|1|2|6|7|8|9))|(7(6|7|8|9)))\d{6}$/,
    "ro-RO": /^(\+?40|0)\s?7\d{2}(\/|\s|\.|-)?\d{3}(\s|\.|-)?\d{3}$/,
    "ru-RU": /^(\+?7|8)?9\d{9}$/,
    "si-LK": /^(?:0|94|\+94)?(7(0|1|2|4|5|6|7|8)( |-)?)\d{7}$/,
    "sl-SI": /^(\+386\s?|0)(\d{1}\s?\d{3}\s?\d{2}\s?\d{2}|\d{2}\s?\d{3}\s?\d{3})$/,
    "sk-SK": /^(\+?421)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,
    "so-SO": /^(\+?252|0)((6[0-9])\d{7}|(7[1-9])\d{7})$/,
    "sq-AL": /^(\+355|0)6[789]\d{6}$/,
    "sr-RS": /^(\+3816|06)[- \d]{5,9}$/,
    "sv-SE": /^(\+?46|0)[\s\-]?7[\s\-]?[02369]([\s\-]?\d){7}$/,
    "tg-TJ": /^(\+?992)?[5][5]\d{7}$/,
    "th-TH": /^(\+66|66|0)\d{9}$/,
    "tr-TR": /^(\+?90|0)?5\d{9}$/,
    "tk-TM": /^(\+993|993|8)\d{8}$/,
    "uk-UA": /^(\+?38|8)?0\d{9}$/,
    "uz-UZ": /^(\+?998)?(6[125-79]|7[1-69]|88|9\d)\d{7}$/,
    "vi-VN": /^((\+?84)|0)((3([2-9]))|(5([25689]))|(7([0|6-9]))|(8([1-9]))|(9([0-9])))([0-9]{7})$/,
    "zh-CN": /^((\+|00)86)?(1[3-9]|9[28])\d{9}$/,
    "zh-TW": /^(\+?886\-?|0)?9\d{8}$/,
    "dz-BT": /^(\+?975|0)?(17|16|77|02)\d{6}$/,
    "ar-YE": /^(((\+|00)9677|0?7)[0137]\d{7}|((\+|00)967|0)[1-7]\d{6})$/,
    "ar-EH": /^(\+?212|0)[\s\-]?(5288|5289)[\s\-]?\d{5}$/,
    "fa-AF": /^(\+93|0)?(2{1}[0-8]{1}|[3-5]{1}[0-4]{1})(\d{7})$/
  };
  phones["en-CA"] = phones["en-US"];
  phones["fr-CA"] = phones["en-CA"];
  phones["fr-BE"] = phones["nl-BE"];
  phones["zh-HK"] = phones["en-HK"];
  phones["zh-MO"] = phones["en-MO"];
  phones["ga-IE"] = phones["en-IE"];
  phones["fr-CH"] = phones["de-CH"];
  phones["it-CH"] = phones["fr-CH"];
  function isMobilePhone(str2, locale, options3) {
    (0, _assertString.default)(str2);
    if (options3 && options3.strictMode && !str2.startsWith("+")) {
      return false;
    }
    if (Array.isArray(locale)) {
      return locale.some(function(key2) {
        if (phones.hasOwnProperty(key2)) {
          var phone2 = phones[key2];
          if (phone2.test(str2)) {
            return true;
          }
        }
        return false;
      });
    } else if (locale in phones) {
      return phones[locale].test(str2);
    } else if (!locale || locale === "any") {
      for (var key in phones) {
        if (phones.hasOwnProperty(key)) {
          var phone = phones[key];
          if (phone.test(str2)) {
            return true;
          }
        }
      }
      return false;
    }
    throw new Error("Invalid locale '".concat(locale, "'"));
  }
  var locales22 = exports.locales = Object.keys(phones);
});
var require_dayjs_min3 = __commonJS22((exports, module) => {
  (function(t5, e5) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = e5() : typeof define == "function" && define.amd ? define(e5) : (t5 = typeof globalThis != "undefined" ? globalThis : t5 || self).dayjs = e5();
  })(exports, function() {
    var t5 = 1000, e5 = 60000, n5 = 3600000, r23 = "millisecond", i5 = "second", s32 = "minute", u5 = "hour", a5 = "day", o5 = "week", c23 = "month", f23 = "quarter", h33 = "year", d5 = "date", l33 = "Invalid Date", $32 = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, y3 = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, M23 = { name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"), ordinal: function(t22) {
      var e22 = ["th", "st", "nd", "rd"], n22 = t22 % 100;
      return "[" + t22 + (e22[(n22 - 20) % 10] || e22[n22] || e22[0]) + "]";
    } }, m23 = function(t22, e22, n22) {
      var r32 = String(t22);
      return !r32 || r32.length >= e22 ? t22 : "" + Array(e22 + 1 - r32.length).join(n22) + t22;
    }, v23 = { s: m23, z: function(t22) {
      var e22 = -t22.utcOffset(), n22 = Math.abs(e22), r32 = Math.floor(n22 / 60), i22 = n22 % 60;
      return (e22 <= 0 ? "+" : "-") + m23(r32, 2, "0") + ":" + m23(i22, 2, "0");
    }, m: function t(e22, n22) {
      if (e22.date() < n22.date())
        return -t(n22, e22);
      var r32 = 12 * (n22.year() - e22.year()) + (n22.month() - e22.month()), i22 = e22.clone().add(r32, c23), s42 = n22 - i22 < 0, u22 = e22.clone().add(r32 + (s42 ? -1 : 1), c23);
      return +(-(r32 + (n22 - i22) / (s42 ? i22 - u22 : u22 - i22)) || 0);
    }, a: function(t22) {
      return t22 < 0 ? Math.ceil(t22) || 0 : Math.floor(t22);
    }, p: function(t22) {
      return { M: c23, y: h33, w: o5, d: a5, D: d5, h: u5, m: s32, s: i5, ms: r23, Q: f23 }[t22] || String(t22 || "").toLowerCase().replace(/s$/, "");
    }, u: function(t22) {
      return t22 === undefined;
    } }, g23 = "en", D3 = {};
    D3[g23] = M23;
    var p222 = "$isDayjsObject", S2 = function(t22) {
      return t22 instanceof _23 || !(!t22 || !t22[p222]);
    }, w23 = function t(e22, n22, r32) {
      var i22;
      if (!e22)
        return g23;
      if (typeof e22 == "string") {
        var s42 = e22.toLowerCase();
        D3[s42] && (i22 = s42), n22 && (D3[s42] = n22, i22 = s42);
        var u22 = e22.split("-");
        if (!i22 && u22.length > 1)
          return t(u22[0]);
      } else {
        var a22 = e22.name;
        D3[a22] = e22, i22 = a22;
      }
      return !r32 && i22 && (g23 = i22), i22 || !r32 && g23;
    }, O3 = function(t22, e22) {
      if (S2(t22))
        return t22.clone();
      var n22 = typeof e22 == "object" ? e22 : {};
      return n22.date = t22, n22.args = arguments, new _23(n22);
    }, b23 = v23;
    b23.l = w23, b23.i = S2, b23.w = function(t22, e22) {
      return O3(t22, { locale: e22.$L, utc: e22.$u, x: e22.$x, $offset: e22.$offset });
    };
    var _23 = function() {
      function M32(t22) {
        this.$L = w23(t22.locale, null, true), this.parse(t22), this.$x = this.$x || t22.x || {}, this[p222] = true;
      }
      var m32 = M32.prototype;
      return m32.parse = function(t22) {
        this.$d = function(t32) {
          var { date: e22, utc: n22 } = t32;
          if (e22 === null)
            return new Date(NaN);
          if (b23.u(e22))
            return new Date;
          if (e22 instanceof Date)
            return new Date(e22);
          if (typeof e22 == "string" && !/Z$/i.test(e22)) {
            var r32 = e22.match($32);
            if (r32) {
              var i22 = r32[2] - 1 || 0, s42 = (r32[7] || "0").substring(0, 3);
              return n22 ? new Date(Date.UTC(r32[1], i22, r32[3] || 1, r32[4] || 0, r32[5] || 0, r32[6] || 0, s42)) : new Date(r32[1], i22, r32[3] || 1, r32[4] || 0, r32[5] || 0, r32[6] || 0, s42);
            }
          }
          return new Date(e22);
        }(t22), this.init();
      }, m32.init = function() {
        var t22 = this.$d;
        this.$y = t22.getFullYear(), this.$M = t22.getMonth(), this.$D = t22.getDate(), this.$W = t22.getDay(), this.$H = t22.getHours(), this.$m = t22.getMinutes(), this.$s = t22.getSeconds(), this.$ms = t22.getMilliseconds();
      }, m32.$utils = function() {
        return b23;
      }, m32.isValid = function() {
        return !(this.$d.toString() === l33);
      }, m32.isSame = function(t22, e22) {
        var n22 = O3(t22);
        return this.startOf(e22) <= n22 && n22 <= this.endOf(e22);
      }, m32.isAfter = function(t22, e22) {
        return O3(t22) < this.startOf(e22);
      }, m32.isBefore = function(t22, e22) {
        return this.endOf(e22) < O3(t22);
      }, m32.$g = function(t22, e22, n22) {
        return b23.u(t22) ? this[e22] : this.set(n22, t22);
      }, m32.unix = function() {
        return Math.floor(this.valueOf() / 1000);
      }, m32.valueOf = function() {
        return this.$d.getTime();
      }, m32.startOf = function(t22, e22) {
        var n22 = this, r32 = !!b23.u(e22) || e22, f32 = b23.p(t22), l42 = function(t32, e32) {
          var i22 = b23.w(n22.$u ? Date.UTC(n22.$y, e32, t32) : new Date(n22.$y, e32, t32), n22);
          return r32 ? i22 : i22.endOf(a5);
        }, $4 = function(t32, e32) {
          return b23.w(n22.toDate()[t32].apply(n22.toDate("s"), (r32 ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e32)), n22);
        }, y22 = this.$W, M4 = this.$M, m42 = this.$D, v32 = "set" + (this.$u ? "UTC" : "");
        switch (f32) {
          case h33:
            return r32 ? l42(1, 0) : l42(31, 11);
          case c23:
            return r32 ? l42(1, M4) : l42(0, M4 + 1);
          case o5:
            var g32 = this.$locale().weekStart || 0, D22 = (y22 < g32 ? y22 + 7 : y22) - g32;
            return l42(r32 ? m42 - D22 : m42 + (6 - D22), M4);
          case a5:
          case d5:
            return $4(v32 + "Hours", 0);
          case u5:
            return $4(v32 + "Minutes", 1);
          case s32:
            return $4(v32 + "Seconds", 2);
          case i5:
            return $4(v32 + "Milliseconds", 3);
          default:
            return this.clone();
        }
      }, m32.endOf = function(t22) {
        return this.startOf(t22, false);
      }, m32.$set = function(t22, e22) {
        var n22, o22 = b23.p(t22), f32 = "set" + (this.$u ? "UTC" : ""), l42 = (n22 = {}, n22[a5] = f32 + "Date", n22[d5] = f32 + "Date", n22[c23] = f32 + "Month", n22[h33] = f32 + "FullYear", n22[u5] = f32 + "Hours", n22[s32] = f32 + "Minutes", n22[i5] = f32 + "Seconds", n22[r23] = f32 + "Milliseconds", n22)[o22], $4 = o22 === a5 ? this.$D + (e22 - this.$W) : e22;
        if (o22 === c23 || o22 === h33) {
          var y22 = this.clone().set(d5, 1);
          y22.$d[l42]($4), y22.init(), this.$d = y22.set(d5, Math.min(this.$D, y22.daysInMonth())).$d;
        } else
          l42 && this.$d[l42]($4);
        return this.init(), this;
      }, m32.set = function(t22, e22) {
        return this.clone().$set(t22, e22);
      }, m32.get = function(t22) {
        return this[b23.p(t22)]();
      }, m32.add = function(r32, f32) {
        var d22, l42 = this;
        r32 = Number(r32);
        var $4 = b23.p(f32), y22 = function(t22) {
          var e22 = O3(l42);
          return b23.w(e22.date(e22.date() + Math.round(t22 * r32)), l42);
        };
        if ($4 === c23)
          return this.set(c23, this.$M + r32);
        if ($4 === h33)
          return this.set(h33, this.$y + r32);
        if ($4 === a5)
          return y22(1);
        if ($4 === o5)
          return y22(7);
        var M4 = (d22 = {}, d22[s32] = e5, d22[u5] = n5, d22[i5] = t5, d22)[$4] || 1, m42 = this.$d.getTime() + r32 * M4;
        return b23.w(m42, this);
      }, m32.subtract = function(t22, e22) {
        return this.add(-1 * t22, e22);
      }, m32.format = function(t22) {
        var e22 = this, n22 = this.$locale();
        if (!this.isValid())
          return n22.invalidDate || l33;
        var r32 = t22 || "YYYY-MM-DDTHH:mm:ssZ", i22 = b23.z(this), s42 = this.$H, u22 = this.$m, a22 = this.$M, o22 = n22.weekdays, c32 = n22.months, f32 = n22.meridiem, h42 = function(t32, n32, i32, s52) {
          return t32 && (t32[n32] || t32(e22, r32)) || i32[n32].slice(0, s52);
        }, d22 = function(t32) {
          return b23.s(s42 % 12 || 12, t32, "0");
        }, $4 = f32 || function(t32, e32, n32) {
          var r42 = t32 < 12 ? "AM" : "PM";
          return n32 ? r42.toLowerCase() : r42;
        };
        return r32.replace(y3, function(t32, r42) {
          return r42 || function(t42) {
            switch (t42) {
              case "YY":
                return String(e22.$y).slice(-2);
              case "YYYY":
                return b23.s(e22.$y, 4, "0");
              case "M":
                return a22 + 1;
              case "MM":
                return b23.s(a22 + 1, 2, "0");
              case "MMM":
                return h42(n22.monthsShort, a22, c32, 3);
              case "MMMM":
                return h42(c32, a22);
              case "D":
                return e22.$D;
              case "DD":
                return b23.s(e22.$D, 2, "0");
              case "d":
                return String(e22.$W);
              case "dd":
                return h42(n22.weekdaysMin, e22.$W, o22, 2);
              case "ddd":
                return h42(n22.weekdaysShort, e22.$W, o22, 3);
              case "dddd":
                return o22[e22.$W];
              case "H":
                return String(s42);
              case "HH":
                return b23.s(s42, 2, "0");
              case "h":
                return d22(1);
              case "hh":
                return d22(2);
              case "a":
                return $4(s42, u22, true);
              case "A":
                return $4(s42, u22, false);
              case "m":
                return String(u22);
              case "mm":
                return b23.s(u22, 2, "0");
              case "s":
                return String(e22.$s);
              case "ss":
                return b23.s(e22.$s, 2, "0");
              case "SSS":
                return b23.s(e22.$ms, 3, "0");
              case "Z":
                return i22;
            }
            return null;
          }(t32) || i22.replace(":", "");
        });
      }, m32.utcOffset = function() {
        return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
      }, m32.diff = function(r32, d22, l42) {
        var $4, y22 = this, M4 = b23.p(d22), m42 = O3(r32), v32 = (m42.utcOffset() - this.utcOffset()) * e5, g32 = this - m42, D22 = function() {
          return b23.m(y22, m42);
        };
        switch (M4) {
          case h33:
            $4 = D22() / 12;
            break;
          case c23:
            $4 = D22();
            break;
          case f23:
            $4 = D22() / 3;
            break;
          case o5:
            $4 = (g32 - v32) / 604800000;
            break;
          case a5:
            $4 = (g32 - v32) / 86400000;
            break;
          case u5:
            $4 = g32 / n5;
            break;
          case s32:
            $4 = g32 / e5;
            break;
          case i5:
            $4 = g32 / t5;
            break;
          default:
            $4 = g32;
        }
        return l42 ? $4 : b23.a($4);
      }, m32.daysInMonth = function() {
        return this.endOf(c23).$D;
      }, m32.$locale = function() {
        return D3[this.$L];
      }, m32.locale = function(t22, e22) {
        if (!t22)
          return this.$L;
        var n22 = this.clone(), r32 = w23(t22, e22, true);
        return r32 && (n22.$L = r32), n22;
      }, m32.clone = function() {
        return b23.w(this.$d, this);
      }, m32.toDate = function() {
        return new Date(this.valueOf());
      }, m32.toJSON = function() {
        return this.isValid() ? this.toISOString() : null;
      }, m32.toISOString = function() {
        return this.$d.toISOString();
      }, m32.toString = function() {
        return this.$d.toUTCString();
      }, M32;
    }(), k5 = _23.prototype;
    return O3.prototype = k5, [["$ms", r23], ["$s", i5], ["$m", s32], ["$H", u5], ["$W", a5], ["$M", c23], ["$y", h33], ["$D", d5]].forEach(function(t22) {
      k5[t22[1]] = function(e22) {
        return this.$g(e22, t22[0], t22[1]);
      };
    }), O3.extend = function(t22, e22) {
      return t22.$i || (t22(e22, _23, O3), t22.$i = true), O3;
    }, O3.locale = w23, O3.isDayjs = S2, O3.unix = function(t22) {
      return O3(1000 * t22);
    }, O3.en = D3[g23], O3.Ls = D3, O3.p = {}, O3;
  });
});
var require_isSameOrAfter3 = __commonJS22((exports, module) => {
  (function(e5, t5) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = t5() : typeof define == "function" && define.amd ? define(t5) : (e5 = typeof globalThis != "undefined" ? globalThis : e5 || self).dayjs_plugin_isSameOrAfter = t5();
  })(exports, function() {
    return function(e5, t5) {
      t5.prototype.isSameOrAfter = function(e22, t22) {
        return this.isSame(e22, t22) || this.isAfter(e22, t22);
      };
    };
  });
});
var require_isSameOrBefore3 = __commonJS22((exports, module) => {
  (function(e5, i5) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = i5() : typeof define == "function" && define.amd ? define(i5) : (e5 = typeof globalThis != "undefined" ? globalThis : e5 || self).dayjs_plugin_isSameOrBefore = i5();
  })(exports, function() {
    return function(e5, i5) {
      i5.prototype.isSameOrBefore = function(e22, i22) {
        return this.isSame(e22, i22) || this.isBefore(e22, i22);
      };
    };
  });
});
var require_customParseFormat3 = __commonJS22((exports, module) => {
  (function(e5, t5) {
    typeof exports == "object" && typeof module != "undefined" ? module.exports = t5() : typeof define == "function" && define.amd ? define(t5) : (e5 = typeof globalThis != "undefined" ? globalThis : e5 || self).dayjs_plugin_customParseFormat = t5();
  })(exports, function() {
    var e5 = { LTS: "h:mm:ss A", LT: "h:mm A", L: "MM/DD/YYYY", LL: "MMMM D, YYYY", LLL: "MMMM D, YYYY h:mm A", LLLL: "dddd, MMMM D, YYYY h:mm A" }, t5 = /(\[[^[]*\])|([-_:/.,()\s]+)|(A|a|Q|YYYY|YY?|ww?|MM?M?M?|Do|DD?|hh?|HH?|mm?|ss?|S{1,3}|z|ZZ?)/g, n5 = /\d/, r23 = /\d\d/, i5 = /\d\d?/, o5 = /\d*[^-_:/,()\s\d]+/, s32 = {}, a5 = function(e22) {
      return (e22 = +e22) + (e22 > 68 ? 1900 : 2000);
    };
    var f23 = function(e22) {
      return function(t22) {
        this[e22] = +t22;
      };
    }, h33 = [/[+-]\d\d:?(\d\d)?|Z/, function(e22) {
      (this.zone || (this.zone = {})).offset = function(e32) {
        if (!e32)
          return 0;
        if (e32 === "Z")
          return 0;
        var t22 = e32.match(/([+-]|\d\d)/g), n22 = 60 * t22[1] + (+t22[2] || 0);
        return n22 === 0 ? 0 : t22[0] === "+" ? -n22 : n22;
      }(e22);
    }], u5 = function(e22) {
      var t22 = s32[e22];
      return t22 && (t22.indexOf ? t22 : t22.s.concat(t22.f));
    }, d5 = function(e22, t22) {
      var n22, r32 = s32.meridiem;
      if (r32) {
        for (var i22 = 1;i22 <= 24; i22 += 1)
          if (e22.indexOf(r32(i22, 0, t22)) > -1) {
            n22 = i22 > 12;
            break;
          }
      } else
        n22 = e22 === (t22 ? "pm" : "PM");
      return n22;
    }, c23 = { A: [o5, function(e22) {
      this.afternoon = d5(e22, false);
    }], a: [o5, function(e22) {
      this.afternoon = d5(e22, true);
    }], Q: [n5, function(e22) {
      this.month = 3 * (e22 - 1) + 1;
    }], S: [n5, function(e22) {
      this.milliseconds = 100 * +e22;
    }], SS: [r23, function(e22) {
      this.milliseconds = 10 * +e22;
    }], SSS: [/\d{3}/, function(e22) {
      this.milliseconds = +e22;
    }], s: [i5, f23("seconds")], ss: [i5, f23("seconds")], m: [i5, f23("minutes")], mm: [i5, f23("minutes")], H: [i5, f23("hours")], h: [i5, f23("hours")], HH: [i5, f23("hours")], hh: [i5, f23("hours")], D: [i5, f23("day")], DD: [r23, f23("day")], Do: [o5, function(e22) {
      var t22 = s32.ordinal, n22 = e22.match(/\d+/);
      if (this.day = n22[0], t22)
        for (var r32 = 1;r32 <= 31; r32 += 1)
          t22(r32).replace(/\[|\]/g, "") === e22 && (this.day = r32);
    }], w: [i5, f23("week")], ww: [r23, f23("week")], M: [i5, f23("month")], MM: [r23, f23("month")], MMM: [o5, function(e22) {
      var t22 = u5("months"), n22 = (u5("monthsShort") || t22.map(function(e32) {
        return e32.slice(0, 3);
      })).indexOf(e22) + 1;
      if (n22 < 1)
        throw new Error;
      this.month = n22 % 12 || n22;
    }], MMMM: [o5, function(e22) {
      var t22 = u5("months").indexOf(e22) + 1;
      if (t22 < 1)
        throw new Error;
      this.month = t22 % 12 || t22;
    }], Y: [/[+-]?\d+/, f23("year")], YY: [r23, function(e22) {
      this.year = a5(e22);
    }], YYYY: [/\d{4}/, f23("year")], Z: h33, ZZ: h33 };
    function l33(n22) {
      var r32, i22;
      r32 = n22, i22 = s32 && s32.formats;
      for (var o22 = (n22 = r32.replace(/(\[[^\]]+])|(LTS?|l{1,4}|L{1,4})/g, function(t22, n32, r42) {
        var o32 = r42 && r42.toUpperCase();
        return n32 || i22[r42] || e5[r42] || i22[o32].replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g, function(e22, t32, n42) {
          return t32 || n42.slice(1);
        });
      })).match(t5), a22 = o22.length, f32 = 0;f32 < a22; f32 += 1) {
        var h42 = o22[f32], u22 = c23[h42], d22 = u22 && u22[0], l42 = u22 && u22[1];
        o22[f32] = l42 ? { regex: d22, parser: l42 } : h42.replace(/^\[|\]$/g, "");
      }
      return function(e22) {
        for (var t22 = {}, n32 = 0, r42 = 0;n32 < a22; n32 += 1) {
          var i32 = o22[n32];
          if (typeof i32 == "string")
            r42 += i32.length;
          else {
            var { regex: s42, parser: f42 } = i32, h52 = e22.slice(r42), u32 = s42.exec(h52)[0];
            f42.call(t22, u32), e22 = e22.replace(u32, "");
          }
        }
        return function(e32) {
          var t32 = e32.afternoon;
          if (t32 !== undefined) {
            var n42 = e32.hours;
            t32 ? n42 < 12 && (e32.hours += 12) : n42 === 12 && (e32.hours = 0), delete e32.afternoon;
          }
        }(t22), t22;
      };
    }
    return function(e22, t22, n22) {
      n22.p.customParseFormat = true, e22 && e22.parseTwoDigitYear && (a5 = e22.parseTwoDigitYear);
      var r32 = t22.prototype, i22 = r32.parse;
      r32.parse = function(e32) {
        var { date: t32, utc: r42, args: o22 } = e32;
        this.$u = r42;
        var a22 = o22[1];
        if (typeof a22 == "string") {
          var f32 = o22[2] === true, h42 = o22[3] === true, u22 = f32 || h42, d22 = o22[2];
          h42 && (d22 = o22[2]), s32 = this.$locale(), !f32 && d22 && (s32 = n22.Ls[d22]), this.$d = function(e42, t42, n32, r52) {
            try {
              if (["x", "X"].indexOf(t42) > -1)
                return new Date((t42 === "X" ? 1000 : 1) * e42);
              var i32 = l33(t42)(e42), o32 = i32.year, s42 = i32.month, a32 = i32.day, f42 = i32.hours, h52 = i32.minutes, u32 = i32.seconds, d32 = i32.milliseconds, c42 = i32.zone, m32 = i32.week, M32 = new Date, Y23 = a32 || (o32 || s42 ? 1 : M32.getDate()), p222 = o32 || M32.getFullYear(), v23 = 0;
              o32 && !s42 || (v23 = s42 > 0 ? s42 - 1 : M32.getMonth());
              var D3, w23 = f42 || 0, g23 = h52 || 0, y3 = u32 || 0, L3 = d32 || 0;
              return c42 ? new Date(Date.UTC(p222, v23, Y23, w23, g23, y3, L3 + 60 * c42.offset * 1000)) : n32 ? new Date(Date.UTC(p222, v23, Y23, w23, g23, y3, L3)) : (D3 = new Date(p222, v23, Y23, w23, g23, y3, L3), m32 && (D3 = r52(D3).week(m32).toDate()), D3);
            } catch (e52) {
              return new Date("");
            }
          }(t32, a22, r42, n22), this.init(), d22 && d22 !== true && (this.$L = this.locale(d22).$L), u22 && t32 != this.format(a22) && (this.$d = new Date("")), s32 = {};
        } else if (a22 instanceof Array)
          for (var c32 = a22.length, m23 = 1;m23 <= c32; m23 += 1) {
            o22[1] = a22[m23 - 1];
            var M23 = n22.apply(this, o22);
            if (M23.isValid()) {
              this.$d = M23.$d, this.$L = M23.$L, this.init();
              break;
            }
            m23 === c32 && (this.$d = new Date(""));
          }
        else
          i22.call(this, e32);
      };
    };
  });
});
var require_escape3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = escape2;
  var _assertString = _interopRequireDefault(require_assertString3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  function escape2(str2) {
    (0, _assertString.default)(str2);
    return str2.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\//g, "&#x2F;").replace(/\\/g, "&#x5C;").replace(/`/g, "&#96;");
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_normalizeEmail3 = __commonJS22((exports, module) => {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = normalizeEmail;
  var _merge = _interopRequireDefault(require_merge3());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
  var default_normalize_email_options = {
    all_lowercase: true,
    gmail_lowercase: true,
    gmail_remove_dots: true,
    gmail_remove_subaddress: true,
    gmail_convert_googlemaildotcom: true,
    outlookdotcom_lowercase: true,
    outlookdotcom_remove_subaddress: true,
    yahoo_lowercase: true,
    yahoo_remove_subaddress: true,
    yandex_lowercase: true,
    icloud_lowercase: true,
    icloud_remove_subaddress: true
  };
  var icloud_domains = ["icloud.com", "me.com"];
  var outlookdotcom_domains = ["hotmail.at", "hotmail.be", "hotmail.ca", "hotmail.cl", "hotmail.co.il", "hotmail.co.nz", "hotmail.co.th", "hotmail.co.uk", "hotmail.com", "hotmail.com.ar", "hotmail.com.au", "hotmail.com.br", "hotmail.com.gr", "hotmail.com.mx", "hotmail.com.pe", "hotmail.com.tr", "hotmail.com.vn", "hotmail.cz", "hotmail.de", "hotmail.dk", "hotmail.es", "hotmail.fr", "hotmail.hu", "hotmail.id", "hotmail.ie", "hotmail.in", "hotmail.it", "hotmail.jp", "hotmail.kr", "hotmail.lv", "hotmail.my", "hotmail.ph", "hotmail.pt", "hotmail.sa", "hotmail.sg", "hotmail.sk", "live.be", "live.co.uk", "live.com", "live.com.ar", "live.com.mx", "live.de", "live.es", "live.eu", "live.fr", "live.it", "live.nl", "msn.com", "outlook.at", "outlook.be", "outlook.cl", "outlook.co.il", "outlook.co.nz", "outlook.co.th", "outlook.com", "outlook.com.ar", "outlook.com.au", "outlook.com.br", "outlook.com.gr", "outlook.com.pe", "outlook.com.tr", "outlook.com.vn", "outlook.cz", "outlook.de", "outlook.dk", "outlook.es", "outlook.fr", "outlook.hu", "outlook.id", "outlook.ie", "outlook.in", "outlook.it", "outlook.jp", "outlook.kr", "outlook.lv", "outlook.my", "outlook.ph", "outlook.pt", "outlook.sa", "outlook.sg", "outlook.sk", "passport.com"];
  var yahoo_domains = ["rocketmail.com", "yahoo.ca", "yahoo.co.uk", "yahoo.com", "yahoo.de", "yahoo.fr", "yahoo.in", "yahoo.it", "ymail.com"];
  var yandex_domains = ["yandex.ru", "yandex.ua", "yandex.kz", "yandex.com", "yandex.by", "ya.ru"];
  function dotsReplacer(match) {
    if (match.length > 1) {
      return match;
    }
    return "";
  }
  function normalizeEmail(email23, options3) {
    options3 = (0, _merge.default)(options3, default_normalize_email_options);
    var raw_parts = email23.split("@");
    var domain = raw_parts.pop();
    var user = raw_parts.join("@");
    var parts = [user, domain];
    parts[1] = parts[1].toLowerCase();
    if (parts[1] === "gmail.com" || parts[1] === "googlemail.com") {
      if (options3.gmail_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (options3.gmail_remove_dots) {
        parts[0] = parts[0].replace(/\.+/g, dotsReplacer);
      }
      if (!parts[0].length) {
        return false;
      }
      if (options3.all_lowercase || options3.gmail_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
      parts[1] = options3.gmail_convert_googlemaildotcom ? "gmail.com" : parts[1];
    } else if (icloud_domains.indexOf(parts[1]) >= 0) {
      if (options3.icloud_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options3.all_lowercase || options3.icloud_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (outlookdotcom_domains.indexOf(parts[1]) >= 0) {
      if (options3.outlookdotcom_remove_subaddress) {
        parts[0] = parts[0].split("+")[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options3.all_lowercase || options3.outlookdotcom_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (yahoo_domains.indexOf(parts[1]) >= 0) {
      if (options3.yahoo_remove_subaddress) {
        var components2 = parts[0].split("-");
        parts[0] = components2.length > 1 ? components2.slice(0, -1).join("-") : components2[0];
      }
      if (!parts[0].length) {
        return false;
      }
      if (options3.all_lowercase || options3.yahoo_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
    } else if (yandex_domains.indexOf(parts[1]) >= 0) {
      if (options3.all_lowercase || options3.yandex_lowercase) {
        parts[0] = parts[0].toLowerCase();
      }
      parts[1] = "yandex.ru";
    } else if (options3.all_lowercase) {
      parts[0] = parts[0].toLowerCase();
    }
    return parts.join("@");
  }
  module.exports = exports.default;
  module.exports.default = exports.default;
});
var require_kleur3 = __commonJS22((exports, module) => {
  var { FORCE_COLOR, NODE_DISABLE_COLORS, TERM } = process.env;
  var $32 = {
    enabled: !NODE_DISABLE_COLORS && TERM !== "dumb" && FORCE_COLOR !== "0",
    reset: init23(0, 0),
    bold: init23(1, 22),
    dim: init23(2, 22),
    italic: init23(3, 23),
    underline: init23(4, 24),
    inverse: init23(7, 27),
    hidden: init23(8, 28),
    strikethrough: init23(9, 29),
    black: init23(30, 39),
    red: init23(31, 39),
    green: init23(32, 39),
    yellow: init23(33, 39),
    blue: init23(34, 39),
    magenta: init23(35, 39),
    cyan: init23(36, 39),
    white: init23(37, 39),
    gray: init23(90, 39),
    grey: init23(90, 39),
    bgBlack: init23(40, 49),
    bgRed: init23(41, 49),
    bgGreen: init23(42, 49),
    bgYellow: init23(43, 49),
    bgBlue: init23(44, 49),
    bgMagenta: init23(45, 49),
    bgCyan: init23(46, 49),
    bgWhite: init23(47, 49)
  };
  function run(arr, str2) {
    let i5 = 0, tmp, beg = "", end = "";
    for (;i5 < arr.length; i5++) {
      tmp = arr[i5];
      beg += tmp.open;
      end += tmp.close;
      if (str2.includes(tmp.close)) {
        str2 = str2.replace(tmp.rgx, tmp.close + tmp.open);
      }
    }
    return beg + str2 + end;
  }
  function chain2(has, keys2) {
    let ctx = { has, keys: keys2 };
    ctx.reset = $32.reset.bind(ctx);
    ctx.bold = $32.bold.bind(ctx);
    ctx.dim = $32.dim.bind(ctx);
    ctx.italic = $32.italic.bind(ctx);
    ctx.underline = $32.underline.bind(ctx);
    ctx.inverse = $32.inverse.bind(ctx);
    ctx.hidden = $32.hidden.bind(ctx);
    ctx.strikethrough = $32.strikethrough.bind(ctx);
    ctx.black = $32.black.bind(ctx);
    ctx.red = $32.red.bind(ctx);
    ctx.green = $32.green.bind(ctx);
    ctx.yellow = $32.yellow.bind(ctx);
    ctx.blue = $32.blue.bind(ctx);
    ctx.magenta = $32.magenta.bind(ctx);
    ctx.cyan = $32.cyan.bind(ctx);
    ctx.white = $32.white.bind(ctx);
    ctx.gray = $32.gray.bind(ctx);
    ctx.grey = $32.grey.bind(ctx);
    ctx.bgBlack = $32.bgBlack.bind(ctx);
    ctx.bgRed = $32.bgRed.bind(ctx);
    ctx.bgGreen = $32.bgGreen.bind(ctx);
    ctx.bgYellow = $32.bgYellow.bind(ctx);
    ctx.bgBlue = $32.bgBlue.bind(ctx);
    ctx.bgMagenta = $32.bgMagenta.bind(ctx);
    ctx.bgCyan = $32.bgCyan.bind(ctx);
    ctx.bgWhite = $32.bgWhite.bind(ctx);
    return ctx;
  }
  function init23(open, close) {
    let blk = {
      open: `\x1B[${open}m`,
      close: `\x1B[${close}m`,
      rgx: new RegExp(`\\x1b\\[${close}m`, "g")
    };
    return function(txt) {
      if (this !== undefined && this.has !== undefined) {
        this.has.includes(open) || (this.has.push(open), this.keys.push(blk));
        return txt === undefined ? this : $32.enabled ? run(this.keys, txt + "") : txt + "";
      }
      return txt === undefined ? chain2([open], [blk]) : $32.enabled ? run([blk], txt + "") : txt + "";
    };
  }
  module.exports = $32;
});
var require_action5 = __commonJS22((exports, module) => {
  module.exports = (key, isSelect) => {
    if (key.meta && key.name !== "escape")
      return;
    if (key.ctrl) {
      if (key.name === "a")
        return "first";
      if (key.name === "c")
        return "abort";
      if (key.name === "d")
        return "abort";
      if (key.name === "e")
        return "last";
      if (key.name === "g")
        return "reset";
    }
    if (isSelect) {
      if (key.name === "j")
        return "down";
      if (key.name === "k")
        return "up";
    }
    if (key.name === "return")
      return "submit";
    if (key.name === "enter")
      return "submit";
    if (key.name === "backspace")
      return "delete";
    if (key.name === "delete")
      return "deleteForward";
    if (key.name === "abort")
      return "abort";
    if (key.name === "escape")
      return "exit";
    if (key.name === "tab")
      return "next";
    if (key.name === "pagedown")
      return "nextPage";
    if (key.name === "pageup")
      return "prevPage";
    if (key.name === "home")
      return "home";
    if (key.name === "end")
      return "end";
    if (key.name === "up")
      return "up";
    if (key.name === "down")
      return "down";
    if (key.name === "right")
      return "right";
    if (key.name === "left")
      return "left";
    return false;
  };
});
var require_strip5 = __commonJS22((exports, module) => {
  module.exports = (str2) => {
    const pattern = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PRZcf-ntqry=><~]))"].join("|");
    const RGX = new RegExp(pattern, "g");
    return typeof str2 === "string" ? str2.replace(RGX, "") : str2;
  };
});
var require_src3 = __commonJS22((exports, module) => {
  var ESC22 = "\x1B";
  var CSI22 = `${ESC22}[`;
  var beep22 = "\x07";
  var cursor22 = {
    to(x22, y3) {
      if (!y3)
        return `${CSI22}${x22 + 1}G`;
      return `${CSI22}${y3 + 1};${x22 + 1}H`;
    },
    move(x22, y3) {
      let ret = "";
      if (x22 < 0)
        ret += `${CSI22}${-x22}D`;
      else if (x22 > 0)
        ret += `${CSI22}${x22}C`;
      if (y3 < 0)
        ret += `${CSI22}${-y3}A`;
      else if (y3 > 0)
        ret += `${CSI22}${y3}B`;
      return ret;
    },
    up: (count = 1) => `${CSI22}${count}A`,
    down: (count = 1) => `${CSI22}${count}B`,
    forward: (count = 1) => `${CSI22}${count}C`,
    backward: (count = 1) => `${CSI22}${count}D`,
    nextLine: (count = 1) => `${CSI22}E`.repeat(count),
    prevLine: (count = 1) => `${CSI22}F`.repeat(count),
    left: `${CSI22}G`,
    hide: `${CSI22}?25l`,
    show: `${CSI22}?25h`,
    save: `${ESC22}7`,
    restore: `${ESC22}8`
  };
  var scroll22 = {
    up: (count = 1) => `${CSI22}S`.repeat(count),
    down: (count = 1) => `${CSI22}T`.repeat(count)
  };
  var erase22 = {
    screen: `${CSI22}2J`,
    up: (count = 1) => `${CSI22}1J`.repeat(count),
    down: (count = 1) => `${CSI22}J`.repeat(count),
    line: `${CSI22}2K`,
    lineEnd: `${CSI22}K`,
    lineStart: `${CSI22}1K`,
    lines(count) {
      let clear = "";
      for (let i5 = 0;i5 < count; i5++)
        clear += this.line + (i5 < count - 1 ? cursor22.up() : "");
      if (count)
        clear += cursor22.left;
      return clear;
    }
  };
  module.exports = { cursor: cursor22, scroll: scroll22, erase: erase22, beep: beep22 };
});
var require_clear5 = __commonJS22((exports, module) => {
  function _createForOfIteratorHelper(o5, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o5[Symbol.iterator] || o5["@@iterator"];
    if (!it) {
      if (Array.isArray(o5) || (it = _unsupportedIterableToArray(o5)) || allowArrayLike && o5 && typeof o5.length === "number") {
        if (it)
          o5 = it;
        var i5 = 0;
        var F3 = function F() {
        };
        return { s: F3, n: function n() {
          if (i5 >= o5.length)
            return { done: true };
          return { done: false, value: o5[i5++] };
        }, e: function e(_e2) {
          throw _e2;
        }, f: F3 };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true, didErr = false, err22;
    return { s: function s() {
      it = it.call(o5);
    }, n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    }, e: function e(_e2) {
      didErr = true;
      err22 = _e2;
    }, f: function f() {
      try {
        if (!normalCompletion && it.return != null)
          it.return();
      } finally {
        if (didErr)
          throw err22;
      }
    } };
  }
  function _unsupportedIterableToArray(o5, minLen) {
    if (!o5)
      return;
    if (typeof o5 === "string")
      return _arrayLikeToArray(o5, minLen);
    var n5 = Object.prototype.toString.call(o5).slice(8, -1);
    if (n5 === "Object" && o5.constructor)
      n5 = o5.constructor.name;
    if (n5 === "Map" || n5 === "Set")
      return Array.from(o5);
    if (n5 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n5))
      return _arrayLikeToArray(o5, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i5 = 0, arr2 = new Array(len);i5 < len; i5++)
      arr2[i5] = arr[i5];
    return arr2;
  }
  var strip = require_strip5();
  var _require = require_src3();
  var erase22 = _require.erase;
  var cursor22 = _require.cursor;
  var width = (str2) => [...strip(str2)].length;
  module.exports = function(prompt22, perLine) {
    if (!perLine)
      return erase22.line + cursor22.to(0);
    let rows = 0;
    const lines = prompt22.split(/\r?\n/);
    var _iterator = _createForOfIteratorHelper(lines), _step;
    try {
      for (_iterator.s();!(_step = _iterator.n()).done; ) {
        let line = _step.value;
        rows += 1 + Math.floor(Math.max(width(line) - 1, 0) / perLine);
      }
    } catch (err22) {
      _iterator.e(err22);
    } finally {
      _iterator.f();
    }
    return erase22.lines(rows);
  };
});
var require_figures5 = __commonJS22((exports, module) => {
  var main2 = {
    arrowUp: "\u2191",
    arrowDown: "\u2193",
    arrowLeft: "\u2190",
    arrowRight: "\u2192",
    radioOn: "\u25C9",
    radioOff: "\u25EF",
    tick: "\u2714",
    cross: "\u2716",
    ellipsis: "\u2026",
    pointerSmall: "\u203A",
    line: "\u2500",
    pointer: "\u276F"
  };
  var win = {
    arrowUp: main2.arrowUp,
    arrowDown: main2.arrowDown,
    arrowLeft: main2.arrowLeft,
    arrowRight: main2.arrowRight,
    radioOn: "(*)",
    radioOff: "( )",
    tick: "\u221A",
    cross: "\xD7",
    ellipsis: "...",
    pointerSmall: "\xBB",
    line: "\u2500",
    pointer: ">"
  };
  var figures = process.platform === "win32" ? win : main2;
  module.exports = figures;
});
var require_style5 = __commonJS22((exports, module) => {
  var c23 = require_kleur3();
  var figures = require_figures5();
  var styles3 = Object.freeze({
    password: {
      scale: 1,
      render: (input) => "*".repeat(input.length)
    },
    emoji: {
      scale: 2,
      render: (input) => "\uD83D\uDE03".repeat(input.length)
    },
    invisible: {
      scale: 0,
      render: (input) => ""
    },
    default: {
      scale: 1,
      render: (input) => `${input}`
    }
  });
  var render = (type2) => styles3[type2] || styles3.default;
  var symbols = Object.freeze({
    aborted: c23.red(figures.cross),
    done: c23.green(figures.tick),
    exited: c23.yellow(figures.cross),
    default: c23.cyan("?")
  });
  var symbol22 = (done, aborted, exited) => aborted ? symbols.aborted : exited ? symbols.exited : done ? symbols.done : symbols.default;
  var delimiter22 = (completing) => c23.gray(completing ? figures.ellipsis : figures.pointerSmall);
  var item = (expandable, expanded) => c23.gray(expandable ? expanded ? figures.pointerSmall : "+" : figures.line);
  module.exports = {
    styles: styles3,
    render,
    symbols,
    symbol: symbol22,
    delimiter: delimiter22,
    item
  };
});
var require_lines5 = __commonJS22((exports, module) => {
  var strip = require_strip5();
  module.exports = function(msg, perLine) {
    let lines = String(strip(msg) || "").split(/\r?\n/);
    if (!perLine)
      return lines.length;
    return lines.map((l33) => Math.ceil(l33.length / perLine)).reduce((a5, b23) => a5 + b23);
  };
});
var require_wrap5 = __commonJS22((exports, module) => {
  module.exports = (msg, opts = {}) => {
    const tab = Number.isSafeInteger(parseInt(opts.margin)) ? new Array(parseInt(opts.margin)).fill(" ").join("") : opts.margin || "";
    const width = opts.width;
    return (msg || "").split(/\r?\n/g).map((line) => line.split(/\s+/g).reduce((arr, w23) => {
      if (w23.length + tab.length >= width || arr[arr.length - 1].length + w23.length + 1 < width)
        arr[arr.length - 1] += ` ${w23}`;
      else
        arr.push(`${tab}${w23}`);
      return arr;
    }, [tab]).join("\n")).join("\n");
  };
});
var require_entriesToDisplay5 = __commonJS22((exports, module) => {
  module.exports = (cursor22, total, maxVisible) => {
    maxVisible = maxVisible || total;
    let startIndex = Math.min(total - maxVisible, cursor22 - Math.floor(maxVisible / 2));
    if (startIndex < 0)
      startIndex = 0;
    let endIndex = Math.min(startIndex + maxVisible, total);
    return {
      startIndex,
      endIndex
    };
  };
});
var require_util5 = __commonJS22((exports, module) => {
  module.exports = {
    action: require_action5(),
    clear: require_clear5(),
    style: require_style5(),
    strip: require_strip5(),
    figures: require_figures5(),
    lines: require_lines5(),
    wrap: require_wrap5(),
    entriesToDisplay: require_entriesToDisplay5()
  };
});
var require_prompt5 = __commonJS22((exports, module) => {
  var readline = import.meta.require("readline");
  var _require = require_util5();
  var action = _require.action;
  var EventEmitter23 = import.meta.require("events");
  var _require2 = require_src3();
  var beep22 = _require2.beep;
  var cursor22 = _require2.cursor;
  var color = require_kleur3();

  class Prompt extends EventEmitter23 {
    constructor(opts = {}) {
      super();
      this.firstRender = true;
      this.in = opts.stdin || process.stdin;
      this.out = opts.stdout || process.stdout;
      this.onRender = (opts.onRender || (() => {
        return;
      })).bind(this);
      const rl = readline.createInterface({
        input: this.in,
        escapeCodeTimeout: 50
      });
      readline.emitKeypressEvents(this.in, rl);
      if (this.in.isTTY)
        this.in.setRawMode(true);
      const isSelect = ["SelectPrompt", "MultiselectPrompt"].indexOf(this.constructor.name) > -1;
      const keypress = (str2, key) => {
        let a5 = action(key, isSelect);
        if (a5 === false) {
          this._ && this._(str2, key);
        } else if (typeof this[a5] === "function") {
          this[a5](key);
        } else {
          this.bell();
        }
      };
      this.close = () => {
        this.out.write(cursor22.show);
        this.in.removeListener("keypress", keypress);
        if (this.in.isTTY)
          this.in.setRawMode(false);
        rl.close();
        this.emit(this.aborted ? "abort" : this.exited ? "exit" : "submit", this.value);
        this.closed = true;
      };
      this.in.on("keypress", keypress);
    }
    fire() {
      this.emit("state", {
        value: this.value,
        aborted: !!this.aborted,
        exited: !!this.exited
      });
    }
    bell() {
      this.out.write(beep22);
    }
    render() {
      this.onRender(color);
      if (this.firstRender)
        this.firstRender = false;
    }
  }
  module.exports = Prompt;
});
var require_text5 = __commonJS22((exports, module) => {
  function asyncGeneratorStep(gen, resolve32, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve32(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve32, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur3();
  var Prompt = require_prompt5();
  var _require = require_src3();
  var erase22 = _require.erase;
  var cursor22 = _require.cursor;
  var _require2 = require_util5();
  var style = _require2.style;
  var clear = _require2.clear;
  var lines = _require2.lines;
  var figures = _require2.figures;

  class TextPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.msg = opts.message;
      this.initial = opts.initial || ``;
      this.validator = opts.validate || (() => true);
      this.value = ``;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.clear = clear(``, this.out.columns);
      this.render();
    }
    set value(v23) {
      if (!v23 && this.initial) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(this.initial));
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(v23);
      }
      this._value = v23;
      this.fire();
    }
    get value() {
      return this._value;
    }
    reset() {
      this.value = ``;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.value = this.value || this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.red = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === `string`) {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        _this2.value = _this2.value || _this2.initial;
        _this2.cursorOffset = 0;
        _this2.cursor = _this2.rendered.length;
        yield _this2.validate();
        if (_this2.error) {
          _this2.red = true;
          _this2.fire();
          _this2.render();
          return;
        }
        _this2.done = true;
        _this2.aborted = false;
        _this2.fire();
        _this2.render();
        _this2.out.write("\n");
        _this2.close();
      })();
    }
    next() {
      if (!this.placeholder)
        return this.bell();
      this.value = this.initial;
      this.cursor = this.rendered.length;
      this.fire();
      this.render();
    }
    moveCursor(n5) {
      if (this.placeholder)
        return;
      this.cursor = this.cursor + n5;
      this.cursorOffset += n5;
    }
    _(c23, key) {
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${c23}${s222}`;
      this.red = false;
      this.cursor = this.placeholder ? 0 : s1.length + 1;
      this.render();
    }
    delete() {
      if (this.isCursorAtStart())
        return this.bell();
      let s1 = this.value.slice(0, this.cursor - 1);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtStart()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
        this.moveCursor(-1);
      }
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor + 1);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtEnd()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
      }
      this.render();
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length;
      this.render();
    }
    left() {
      if (this.cursor <= 0 || this.placeholder)
        return this.bell();
      this.moveCursor(-1);
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      this.moveCursor(1);
      this.render();
    }
    isCursorAtStart() {
      return this.cursor === 0 || this.placeholder && this.cursor === 1;
    }
    isCursorAtEnd() {
      return this.cursor === this.rendered.length || this.placeholder && this.cursor === this.rendered.length + 1;
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.red ? color.red(this.rendered) : this.rendered].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a5, l33, i5) => a5 + `\n${i5 ? " " : figures.pointerSmall} ${color.red().italic(l33)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore + cursor22.move(this.cursorOffset, 0));
    }
  }
  module.exports = TextPrompt;
});
var require_select5 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt5();
  var _require = require_util5();
  var style = _require.style;
  var clear = _require.clear;
  var figures = _require.figures;
  var wrap = _require.wrap;
  var entriesToDisplay = _require.entriesToDisplay;
  var _require2 = require_src3();
  var cursor22 = _require2.cursor;

  class SelectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.hint = opts.hint || "- Use arrow-keys. Return to submit.";
      this.warn = opts.warn || "- This option is disabled";
      this.cursor = opts.initial || 0;
      this.choices = opts.choices.map((ch2, idx) => {
        if (typeof ch2 === "string")
          ch2 = {
            title: ch2,
            value: idx
          };
        return {
          title: ch2 && (ch2.title || ch2.value || ch2),
          value: ch2 && (ch2.value === undefined ? idx : ch2.value),
          description: ch2 && ch2.description,
          selected: ch2 && ch2.selected,
          disabled: ch2 && ch2.disabled
        };
      });
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = (this.choices[this.cursor] || {}).value;
      this.clear = clear("", this.out.columns);
      this.render();
    }
    moveCursor(n5) {
      this.cursor = n5;
      this.value = this.choices[n5].value;
      this.fire();
    }
    reset() {
      this.moveCursor(0);
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      if (!this.selection.disabled) {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      } else
        this.bell();
    }
    first() {
      this.moveCursor(0);
      this.render();
    }
    last() {
      this.moveCursor(this.choices.length - 1);
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.moveCursor(this.choices.length - 1);
      } else {
        this.moveCursor(this.cursor - 1);
      }
      this.render();
    }
    down() {
      if (this.cursor === this.choices.length - 1) {
        this.moveCursor(0);
      } else {
        this.moveCursor(this.cursor + 1);
      }
      this.render();
    }
    next() {
      this.moveCursor((this.cursor + 1) % this.choices.length);
      this.render();
    }
    _(c23, key) {
      if (c23 === " ")
        return this.submit();
    }
    get selection() {
      return this.choices[this.cursor];
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let _entriesToDisplay = entriesToDisplay(this.cursor, this.choices.length, this.optionsPerPage), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.done ? this.selection.title : this.selection.disabled ? color.yellow(this.warn) : color.gray(this.hint)].join(" ");
      if (!this.done) {
        this.outputText += "\n";
        for (let i5 = startIndex;i5 < endIndex; i5++) {
          let title, prefix, desc = "", v23 = this.choices[i5];
          if (i5 === startIndex && startIndex > 0) {
            prefix = figures.arrowUp;
          } else if (i5 === endIndex - 1 && endIndex < this.choices.length) {
            prefix = figures.arrowDown;
          } else {
            prefix = " ";
          }
          if (v23.disabled) {
            title = this.cursor === i5 ? color.gray().underline(v23.title) : color.strikethrough().gray(v23.title);
            prefix = (this.cursor === i5 ? color.bold().gray(figures.pointer) + " " : "  ") + prefix;
          } else {
            title = this.cursor === i5 ? color.cyan().underline(v23.title) : v23.title;
            prefix = (this.cursor === i5 ? color.cyan(figures.pointer) + " " : "  ") + prefix;
            if (v23.description && this.cursor === i5) {
              desc = ` - ${v23.description}`;
              if (prefix.length + title.length + desc.length >= this.out.columns || v23.description.split(/\r?\n/).length > 1) {
                desc = "\n" + wrap(v23.description, {
                  margin: 3,
                  width: this.out.columns
                });
              }
            }
          }
          this.outputText += `${prefix} ${title}${color.gray(desc)}\n`;
        }
      }
      this.out.write(this.outputText);
    }
  }
  module.exports = SelectPrompt;
});
var require_toggle5 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt5();
  var _require = require_util5();
  var style = _require.style;
  var clear = _require.clear;
  var _require2 = require_src3();
  var cursor22 = _require2.cursor;
  var erase22 = _require2.erase;

  class TogglePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = !!opts.initial;
      this.active = opts.active || "on";
      this.inactive = opts.inactive || "off";
      this.initialValue = this.value;
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    deactivate() {
      if (this.value === false)
        return this.bell();
      this.value = false;
      this.render();
    }
    activate() {
      if (this.value === true)
        return this.bell();
      this.value = true;
      this.render();
    }
    delete() {
      this.deactivate();
    }
    left() {
      this.deactivate();
    }
    right() {
      this.activate();
    }
    down() {
      this.deactivate();
    }
    up() {
      this.activate();
    }
    next() {
      this.value = !this.value;
      this.fire();
      this.render();
    }
    _(c23, key) {
      if (c23 === " ") {
        this.value = !this.value;
      } else if (c23 === "1") {
        this.value = true;
      } else if (c23 === "0") {
        this.value = false;
      } else
        return this.bell();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.value ? this.inactive : color.cyan().underline(this.inactive), color.gray("/"), this.value ? color.cyan().underline(this.active) : this.active].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = TogglePrompt;
});
var require_datepart5 = __commonJS22((exports, module) => {

  class DatePart {
    constructor({
      token,
      date,
      parts,
      locales: locales22
    }) {
      this.token = token;
      this.date = date || new Date;
      this.parts = parts || [this];
      this.locales = locales22 || {};
    }
    up() {
    }
    down() {
    }
    next() {
      const currentIdx = this.parts.indexOf(this);
      return this.parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    setTo(val2) {
    }
    prev() {
      let parts = [].concat(this.parts).reverse();
      const currentIdx = parts.indexOf(this);
      return parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    toString() {
      return String(this.date);
    }
  }
  module.exports = DatePart;
});
var require_meridiem5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();

  class Meridiem extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours((this.date.getHours() + 12) % 24);
    }
    down() {
      this.up();
    }
    toString() {
      let meridiem = this.date.getHours() > 12 ? "pm" : "am";
      return /\A/.test(this.token) ? meridiem.toUpperCase() : meridiem;
    }
  }
  module.exports = Meridiem;
});
var require_day5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();
  var pos = (n5) => {
    n5 = n5 % 10;
    return n5 === 1 ? "st" : n5 === 2 ? "nd" : n5 === 3 ? "rd" : "th";
  };

  class Day extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setDate(this.date.getDate() + 1);
    }
    down() {
      this.date.setDate(this.date.getDate() - 1);
    }
    setTo(val2) {
      this.date.setDate(parseInt(val2.substr(-2)));
    }
    toString() {
      let date = this.date.getDate();
      let day = this.date.getDay();
      return this.token === "DD" ? String(date).padStart(2, "0") : this.token === "Do" ? date + pos(date) : this.token === "d" ? day + 1 : this.token === "ddd" ? this.locales.weekdaysShort[day] : this.token === "dddd" ? this.locales.weekdays[day] : date;
    }
  }
  module.exports = Day;
});
var require_hours5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();

  class Hours extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours(this.date.getHours() + 1);
    }
    down() {
      this.date.setHours(this.date.getHours() - 1);
    }
    setTo(val2) {
      this.date.setHours(parseInt(val2.substr(-2)));
    }
    toString() {
      let hours = this.date.getHours();
      if (/h/.test(this.token))
        hours = hours % 12 || 12;
      return this.token.length > 1 ? String(hours).padStart(2, "0") : hours;
    }
  }
  module.exports = Hours;
});
var require_milliseconds5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();

  class Milliseconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMilliseconds(this.date.getMilliseconds() + 1);
    }
    down() {
      this.date.setMilliseconds(this.date.getMilliseconds() - 1);
    }
    setTo(val2) {
      this.date.setMilliseconds(parseInt(val2.substr(-this.token.length)));
    }
    toString() {
      return String(this.date.getMilliseconds()).padStart(4, "0").substr(0, this.token.length);
    }
  }
  module.exports = Milliseconds;
});
var require_minutes5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();

  class Minutes extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMinutes(this.date.getMinutes() + 1);
    }
    down() {
      this.date.setMinutes(this.date.getMinutes() - 1);
    }
    setTo(val2) {
      this.date.setMinutes(parseInt(val2.substr(-2)));
    }
    toString() {
      let m23 = this.date.getMinutes();
      return this.token.length > 1 ? String(m23).padStart(2, "0") : m23;
    }
  }
  module.exports = Minutes;
});
var require_month5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();

  class Month extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMonth(this.date.getMonth() + 1);
    }
    down() {
      this.date.setMonth(this.date.getMonth() - 1);
    }
    setTo(val2) {
      val2 = parseInt(val2.substr(-2)) - 1;
      this.date.setMonth(val2 < 0 ? 0 : val2);
    }
    toString() {
      let month = this.date.getMonth();
      let tl = this.token.length;
      return tl === 2 ? String(month + 1).padStart(2, "0") : tl === 3 ? this.locales.monthsShort[month] : tl === 4 ? this.locales.months[month] : String(month + 1);
    }
  }
  module.exports = Month;
});
var require_seconds5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();

  class Seconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setSeconds(this.date.getSeconds() + 1);
    }
    down() {
      this.date.setSeconds(this.date.getSeconds() - 1);
    }
    setTo(val2) {
      this.date.setSeconds(parseInt(val2.substr(-2)));
    }
    toString() {
      let s32 = this.date.getSeconds();
      return this.token.length > 1 ? String(s32).padStart(2, "0") : s32;
    }
  }
  module.exports = Seconds;
});
var require_year5 = __commonJS22((exports, module) => {
  var DatePart = require_datepart5();

  class Year extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setFullYear(this.date.getFullYear() + 1);
    }
    down() {
      this.date.setFullYear(this.date.getFullYear() - 1);
    }
    setTo(val2) {
      this.date.setFullYear(val2.substr(-4));
    }
    toString() {
      let year = String(this.date.getFullYear()).padStart(4, "0");
      return this.token.length === 2 ? year.substr(-2) : year;
    }
  }
  module.exports = Year;
});
var require_dateparts5 = __commonJS22((exports, module) => {
  module.exports = {
    DatePart: require_datepart5(),
    Meridiem: require_meridiem5(),
    Day: require_day5(),
    Hours: require_hours5(),
    Milliseconds: require_milliseconds5(),
    Minutes: require_minutes5(),
    Month: require_month5(),
    Seconds: require_seconds5(),
    Year: require_year5()
  };
});
var require_date5 = __commonJS22((exports, module) => {
  function asyncGeneratorStep(gen, resolve32, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve32(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve32, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur3();
  var Prompt = require_prompt5();
  var _require = require_util5();
  var style = _require.style;
  var clear = _require.clear;
  var figures = _require.figures;
  var _require2 = require_src3();
  var erase22 = _require2.erase;
  var cursor22 = _require2.cursor;
  var _require3 = require_dateparts5();
  var DatePart = _require3.DatePart;
  var Meridiem = _require3.Meridiem;
  var Day = _require3.Day;
  var Hours = _require3.Hours;
  var Milliseconds = _require3.Milliseconds;
  var Minutes = _require3.Minutes;
  var Month = _require3.Month;
  var Seconds = _require3.Seconds;
  var Year = _require3.Year;
  var regex22 = /\\(.)|"((?:\\["\\]|[^"])+)"|(D[Do]?|d{3,4}|d)|(M{1,4})|(YY(?:YY)?)|([aA])|([Hh]{1,2})|(m{1,2})|(s{1,2})|(S{1,4})|./g;
  var regexGroups = {
    1: ({
      token
    }) => token.replace(/\\(.)/g, "$1"),
    2: (opts) => new Day(opts),
    3: (opts) => new Month(opts),
    4: (opts) => new Year(opts),
    5: (opts) => new Meridiem(opts),
    6: (opts) => new Hours(opts),
    7: (opts) => new Minutes(opts),
    8: (opts) => new Seconds(opts),
    9: (opts) => new Milliseconds(opts)
  };
  var dfltLocales = {
    months: "January,February,March,April,May,June,July,August,September,October,November,December".split(","),
    monthsShort: "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),
    weekdays: "Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),
    weekdaysShort: "Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(",")
  };

  class DatePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = 0;
      this.typed = "";
      this.locales = Object.assign(dfltLocales, opts.locales);
      this._date = opts.initial || new Date;
      this.errorMsg = opts.error || "Please Enter A Valid Value";
      this.validator = opts.validate || (() => true);
      this.mask = opts.mask || "YYYY-MM-DD HH:mm:ss";
      this.clear = clear("", this.out.columns);
      this.render();
    }
    get value() {
      return this.date;
    }
    get date() {
      return this._date;
    }
    set date(date) {
      if (date)
        this._date.setTime(date.getTime());
    }
    set mask(mask) {
      let result2;
      this.parts = [];
      while (result2 = regex22.exec(mask)) {
        let match = result2.shift();
        let idx = result2.findIndex((gr) => gr != null);
        this.parts.push(idx in regexGroups ? regexGroups[idx]({
          token: result2[idx] || match,
          date: this.date,
          parts: this.parts,
          locales: this.locales
        }) : result2[idx] || match);
      }
      let parts = this.parts.reduce((arr, i5) => {
        if (typeof i5 === "string" && typeof arr[arr.length - 1] === "string")
          arr[arr.length - 1] += i5;
        else
          arr.push(i5);
        return arr;
      }, []);
      this.parts.splice(0);
      this.parts.push(...parts);
      this.reset();
    }
    moveCursor(n5) {
      this.typed = "";
      this.cursor = n5;
      this.fire();
    }
    reset() {
      this.moveCursor(this.parts.findIndex((p33) => p33 instanceof DatePart));
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === "string") {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        yield _this2.validate();
        if (_this2.error) {
          _this2.color = "red";
          _this2.fire();
          _this2.render();
          return;
        }
        _this2.done = true;
        _this2.aborted = false;
        _this2.fire();
        _this2.render();
        _this2.out.write("\n");
        _this2.close();
      })();
    }
    up() {
      this.typed = "";
      this.parts[this.cursor].up();
      this.render();
    }
    down() {
      this.typed = "";
      this.parts[this.cursor].down();
      this.render();
    }
    left() {
      let prev = this.parts[this.cursor].prev();
      if (prev == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(prev));
      this.render();
    }
    right() {
      let next = this.parts[this.cursor].next();
      if (next == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(next));
      this.render();
    }
    next() {
      let next = this.parts[this.cursor].next();
      this.moveCursor(next ? this.parts.indexOf(next) : this.parts.findIndex((part) => part instanceof DatePart));
      this.render();
    }
    _(c23) {
      if (/\d/.test(c23)) {
        this.typed += c23;
        this.parts[this.cursor].setTo(this.typed);
        this.render();
      }
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.parts.reduce((arr, p33, idx) => arr.concat(idx === this.cursor && !this.done ? color.cyan().underline(p33.toString()) : p33), []).join("")].join(" ");
      if (this.error) {
        this.outputText += this.errorMsg.split("\n").reduce((a5, l33, i5) => a5 + `\n${i5 ? ` ` : figures.pointerSmall} ${color.red().italic(l33)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = DatePrompt;
});
var require_number5 = __commonJS22((exports, module) => {
  function asyncGeneratorStep(gen, resolve32, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve32(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve32, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur3();
  var Prompt = require_prompt5();
  var _require = require_src3();
  var cursor22 = _require.cursor;
  var erase22 = _require.erase;
  var _require2 = require_util5();
  var style = _require2.style;
  var figures = _require2.figures;
  var clear = _require2.clear;
  var lines = _require2.lines;
  var isNumber2 = /[0-9]/;
  var isDef = (any) => any !== undefined;
  var round = (number, precision) => {
    let factor = Math.pow(10, precision);
    return Math.round(number * factor) / factor;
  };

  class NumberPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.msg = opts.message;
      this.initial = isDef(opts.initial) ? opts.initial : "";
      this.float = !!opts.float;
      this.round = opts.round || 2;
      this.inc = opts.increment || 1;
      this.min = isDef(opts.min) ? opts.min : -Infinity;
      this.max = isDef(opts.max) ? opts.max : Infinity;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.validator = opts.validate || (() => true);
      this.color = `cyan`;
      this.value = ``;
      this.typed = ``;
      this.lastHit = 0;
      this.render();
    }
    set value(v23) {
      if (!v23 && v23 !== 0) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(`${this.initial}`));
        this._value = ``;
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(`${round(v23, this.round)}`);
        this._value = round(v23, this.round);
      }
      this.fire();
    }
    get value() {
      return this._value;
    }
    parse(x22) {
      return this.float ? parseFloat(x22) : parseInt(x22);
    }
    valid(c23) {
      return c23 === `-` || c23 === `.` && this.float || isNumber2.test(c23);
    }
    reset() {
      this.typed = ``;
      this.value = ``;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      let x22 = this.value;
      this.value = x22 !== `` ? x22 : this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    validate() {
      var _this = this;
      return _asyncToGenerator(function* () {
        let valid = yield _this.validator(_this.value);
        if (typeof valid === `string`) {
          _this.errorMsg = valid;
          valid = false;
        }
        _this.error = !valid;
      })();
    }
    submit() {
      var _this2 = this;
      return _asyncToGenerator(function* () {
        yield _this2.validate();
        if (_this2.error) {
          _this2.color = `red`;
          _this2.fire();
          _this2.render();
          return;
        }
        let x22 = _this2.value;
        _this2.value = x22 !== `` ? x22 : _this2.initial;
        _this2.done = true;
        _this2.aborted = false;
        _this2.error = false;
        _this2.fire();
        _this2.render();
        _this2.out.write(`\n`);
        _this2.close();
      })();
    }
    up() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min - this.inc;
      }
      if (this.value >= this.max)
        return this.bell();
      this.value += this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    down() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min + this.inc;
      }
      if (this.value <= this.min)
        return this.bell();
      this.value -= this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    delete() {
      let val2 = this.value.toString();
      if (val2.length === 0)
        return this.bell();
      this.value = this.parse(val2 = val2.slice(0, -1)) || ``;
      if (this.value !== "" && this.value < this.min) {
        this.value = this.min;
      }
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    next() {
      this.value = this.initial;
      this.fire();
      this.render();
    }
    _(c23, key) {
      if (!this.valid(c23))
        return this.bell();
      const now2 = Date.now();
      if (now2 - this.lastHit > 1000)
        this.typed = ``;
      this.typed += c23;
      this.lastHit = now2;
      this.color = `cyan`;
      if (c23 === `.`)
        return this.fire();
      this.value = Math.min(this.parse(this.typed), this.max);
      if (this.value > this.max)
        this.value = this.max;
      if (this.value < this.min)
        this.value = this.min;
      this.fire();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), !this.done || !this.done && !this.placeholder ? color[this.color]().underline(this.rendered) : this.rendered].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a5, l33, i5) => a5 + `\n${i5 ? ` ` : figures.pointerSmall} ${color.red().italic(l33)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore);
    }
  }
  module.exports = NumberPrompt;
});
var require_multiselect5 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var _require = require_src3();
  var cursor22 = _require.cursor;
  var Prompt = require_prompt5();
  var _require2 = require_util5();
  var clear = _require2.clear;
  var figures = _require2.figures;
  var style = _require2.style;
  var wrap = _require2.wrap;
  var entriesToDisplay = _require2.entriesToDisplay;

  class MultiselectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = opts.cursor || 0;
      this.scrollIndex = opts.cursor || 0;
      this.hint = opts.hint || "";
      this.warn = opts.warn || "- This option is disabled -";
      this.minSelected = opts.min;
      this.showMinError = false;
      this.maxChoices = opts.max;
      this.instructions = opts.instructions;
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = opts.choices.map((ch2, idx) => {
        if (typeof ch2 === "string")
          ch2 = {
            title: ch2,
            value: idx
          };
        return {
          title: ch2 && (ch2.title || ch2.value || ch2),
          description: ch2 && ch2.description,
          value: ch2 && (ch2.value === undefined ? idx : ch2.value),
          selected: ch2 && ch2.selected,
          disabled: ch2 && ch2.disabled
        };
      });
      this.clear = clear("", this.out.columns);
      if (!opts.overrideRender) {
        this.render();
      }
    }
    reset() {
      this.value.map((v23) => !v23.selected);
      this.cursor = 0;
      this.fire();
      this.render();
    }
    selected() {
      return this.value.filter((v23) => v23.selected);
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      const selected = this.value.filter((e5) => e5.selected);
      if (this.minSelected && selected.length < this.minSelected) {
        this.showMinError = true;
        this.render();
      } else {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.value.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.value.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.value.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.value[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e5) => e5.selected).length >= this.maxChoices)
        return this.bell();
      this.value[this.cursor].selected = true;
      this.render();
    }
    handleSpaceToggle() {
      const v23 = this.value[this.cursor];
      if (v23.selected) {
        v23.selected = false;
        this.render();
      } else if (v23.disabled || this.value.filter((e5) => e5.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v23.selected = true;
        this.render();
      }
    }
    toggleAll() {
      if (this.maxChoices !== undefined || this.value[this.cursor].disabled) {
        return this.bell();
      }
      const newSelected = !this.value[this.cursor].selected;
      this.value.filter((v23) => !v23.disabled).forEach((v23) => v23.selected = newSelected);
      this.render();
    }
    _(c23, key) {
      if (c23 === " ") {
        this.handleSpaceToggle();
      } else if (c23 === "a") {
        this.toggleAll();
      } else {
        return this.bell();
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return "\nInstructions:\n" + `    ${figures.arrowUp}/${figures.arrowDown}: Highlight option\n` + `    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection\n` + (this.maxChoices === undefined ? `    a: Toggle all\n` : "") + `    enter/return: Complete answer`;
      }
      return "";
    }
    renderOption(cursor32, v23, i5, arrowIndicator) {
      const prefix = (v23.selected ? color.green(figures.radioOn) : figures.radioOff) + " " + arrowIndicator + " ";
      let title, desc;
      if (v23.disabled) {
        title = cursor32 === i5 ? color.gray().underline(v23.title) : color.strikethrough().gray(v23.title);
      } else {
        title = cursor32 === i5 ? color.cyan().underline(v23.title) : v23.title;
        if (cursor32 === i5 && v23.description) {
          desc = ` - ${v23.description}`;
          if (prefix.length + title.length + desc.length >= this.out.columns || v23.description.split(/\r?\n/).length > 1) {
            desc = "\n" + wrap(v23.description, {
              margin: prefix.length,
              width: this.out.columns
            });
          }
        }
      }
      return prefix + title + color.gray(desc || "");
    }
    paginateOptions(options3) {
      if (options3.length === 0) {
        return color.red("No matches for this query.");
      }
      let _entriesToDisplay = entriesToDisplay(this.cursor, options3.length, this.optionsPerPage), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      let prefix, styledOptions = [];
      for (let i5 = startIndex;i5 < endIndex; i5++) {
        if (i5 === startIndex && startIndex > 0) {
          prefix = figures.arrowUp;
        } else if (i5 === endIndex - 1 && endIndex < options3.length) {
          prefix = figures.arrowDown;
        } else {
          prefix = " ";
        }
        styledOptions.push(this.renderOption(this.cursor, options3[i5], i5, prefix));
      }
      return "\n" + styledOptions.join("\n");
    }
    renderOptions(options3) {
      if (!this.done) {
        return this.paginateOptions(options3);
      }
      return "";
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e5) => e5.selected).map((v23) => v23.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions()];
      if (this.value[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.renderDoneOrInstructions()].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.value);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = MultiselectPrompt;
});
var require_autocomplete5 = __commonJS22((exports, module) => {
  function asyncGeneratorStep(gen, resolve32, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve32(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve32, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var color = require_kleur3();
  var Prompt = require_prompt5();
  var _require = require_src3();
  var erase22 = _require.erase;
  var cursor22 = _require.cursor;
  var _require2 = require_util5();
  var style = _require2.style;
  var clear = _require2.clear;
  var figures = _require2.figures;
  var wrap = _require2.wrap;
  var entriesToDisplay = _require2.entriesToDisplay;
  var getVal = (arr, i5) => arr[i5] && (arr[i5].value || arr[i5].title || arr[i5]);
  var getTitle = (arr, i5) => arr[i5] && (arr[i5].title || arr[i5].value || arr[i5]);
  var getIndex = (arr, valOrTitle) => {
    const index = arr.findIndex((el) => el.value === valOrTitle || el.title === valOrTitle);
    return index > -1 ? index : undefined;
  };

  class AutocompletePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.suggest = opts.suggest;
      this.choices = opts.choices;
      this.initial = typeof opts.initial === "number" ? opts.initial : getIndex(opts.choices, opts.initial);
      this.select = this.initial || opts.cursor || 0;
      this.i18n = {
        noMatches: opts.noMatches || "no matches found"
      };
      this.fallback = opts.fallback || this.initial;
      this.clearFirst = opts.clearFirst || false;
      this.suggestions = [];
      this.input = "";
      this.limit = opts.limit || 10;
      this.cursor = 0;
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.render = this.render.bind(this);
      this.complete = this.complete.bind(this);
      this.clear = clear("", this.out.columns);
      this.complete(this.render);
      this.render();
    }
    set fallback(fb) {
      this._fb = Number.isSafeInteger(parseInt(fb)) ? parseInt(fb) : fb;
    }
    get fallback() {
      let choice;
      if (typeof this._fb === "number")
        choice = this.choices[this._fb];
      else if (typeof this._fb === "string")
        choice = {
          title: this._fb
        };
      return choice || this._fb || {
        title: this.i18n.noMatches
      };
    }
    moveSelect(i5) {
      this.select = i5;
      if (this.suggestions.length > 0)
        this.value = getVal(this.suggestions, i5);
      else
        this.value = this.fallback.value;
      this.fire();
    }
    complete(cb2) {
      var _this = this;
      return _asyncToGenerator(function* () {
        const p33 = _this.completing = _this.suggest(_this.input, _this.choices);
        const suggestions = yield p33;
        if (_this.completing !== p33)
          return;
        _this.suggestions = suggestions.map((s32, i5, arr) => ({
          title: getTitle(arr, i5),
          value: getVal(arr, i5),
          description: s32.description
        }));
        _this.completing = false;
        const l33 = Math.max(suggestions.length - 1, 0);
        _this.moveSelect(Math.min(l33, _this.select));
        cb2 && cb2();
      })();
    }
    reset() {
      this.input = "";
      this.complete(() => {
        this.moveSelect(this.initial !== undefined ? this.initial : 0);
        this.render();
      });
      this.render();
    }
    exit() {
      if (this.clearFirst && this.input.length > 0) {
        this.reset();
      } else {
        this.done = this.exited = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    abort() {
      this.done = this.aborted = true;
      this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c23, key) {
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${c23}${s222}`;
      this.cursor = s1.length + 1;
      this.complete(this.render);
      this.render();
    }
    delete() {
      if (this.cursor === 0)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor - 1);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.cursor = this.cursor - 1;
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor + 1);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.render();
    }
    first() {
      this.moveSelect(0);
      this.render();
    }
    last() {
      this.moveSelect(this.suggestions.length - 1);
      this.render();
    }
    up() {
      if (this.select === 0) {
        this.moveSelect(this.suggestions.length - 1);
      } else {
        this.moveSelect(this.select - 1);
      }
      this.render();
    }
    down() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else {
        this.moveSelect(this.select + 1);
      }
      this.render();
    }
    next() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else
        this.moveSelect(this.select + 1);
      this.render();
    }
    nextPage() {
      this.moveSelect(Math.min(this.select + this.limit, this.suggestions.length - 1));
      this.render();
    }
    prevPage() {
      this.moveSelect(Math.max(this.select - this.limit, 0));
      this.render();
    }
    left() {
      if (this.cursor <= 0)
        return this.bell();
      this.cursor = this.cursor - 1;
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      this.cursor = this.cursor + 1;
      this.render();
    }
    renderOption(v23, hovered, isStart, isEnd) {
      let desc;
      let prefix = isStart ? figures.arrowUp : isEnd ? figures.arrowDown : " ";
      let title = hovered ? color.cyan().underline(v23.title) : v23.title;
      prefix = (hovered ? color.cyan(figures.pointer) + " " : "  ") + prefix;
      if (v23.description) {
        desc = ` - ${v23.description}`;
        if (prefix.length + title.length + desc.length >= this.out.columns || v23.description.split(/\r?\n/).length > 1) {
          desc = "\n" + wrap(v23.description, {
            margin: 3,
            width: this.out.columns
          });
        }
      }
      return prefix + " " + title + color.gray(desc || "");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let _entriesToDisplay = entriesToDisplay(this.select, this.choices.length, this.limit), startIndex = _entriesToDisplay.startIndex, endIndex = _entriesToDisplay.endIndex;
      this.outputText = [style.symbol(this.done, this.aborted, this.exited), color.bold(this.msg), style.delimiter(this.completing), this.done && this.suggestions[this.select] ? this.suggestions[this.select].title : this.rendered = this.transform.render(this.input)].join(" ");
      if (!this.done) {
        const suggestions = this.suggestions.slice(startIndex, endIndex).map((item, i5) => this.renderOption(item, this.select === i5 + startIndex, i5 === 0 && startIndex > 0, i5 + startIndex === endIndex - 1 && endIndex < this.choices.length)).join("\n");
        this.outputText += `\n` + (suggestions || color.gray(this.fallback.title));
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = AutocompletePrompt;
});
var require_autocompleteMultiselect5 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var _require = require_src3();
  var cursor22 = _require.cursor;
  var MultiselectPrompt = require_multiselect5();
  var _require2 = require_util5();
  var clear = _require2.clear;
  var style = _require2.style;
  var figures = _require2.figures;

  class AutocompleteMultiselectPrompt extends MultiselectPrompt {
    constructor(opts = {}) {
      opts.overrideRender = true;
      super(opts);
      this.inputValue = "";
      this.clear = clear("", this.out.columns);
      this.filteredOptions = this.value;
      this.render();
    }
    last() {
      this.cursor = this.filteredOptions.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.filteredOptions.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.filteredOptions.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.filteredOptions.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.filteredOptions[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e5) => e5.selected).length >= this.maxChoices)
        return this.bell();
      this.filteredOptions[this.cursor].selected = true;
      this.render();
    }
    delete() {
      if (this.inputValue.length) {
        this.inputValue = this.inputValue.substr(0, this.inputValue.length - 1);
        this.updateFilteredOptions();
      }
    }
    updateFilteredOptions() {
      const currentHighlight = this.filteredOptions[this.cursor];
      this.filteredOptions = this.value.filter((v23) => {
        if (this.inputValue) {
          if (typeof v23.title === "string") {
            if (v23.title.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          if (typeof v23.value === "string") {
            if (v23.value.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          return false;
        }
        return true;
      });
      const newHighlightIndex = this.filteredOptions.findIndex((v23) => v23 === currentHighlight);
      this.cursor = newHighlightIndex < 0 ? 0 : newHighlightIndex;
      this.render();
    }
    handleSpaceToggle() {
      const v23 = this.filteredOptions[this.cursor];
      if (v23.selected) {
        v23.selected = false;
        this.render();
      } else if (v23.disabled || this.value.filter((e5) => e5.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v23.selected = true;
        this.render();
      }
    }
    handleInputChange(c23) {
      this.inputValue = this.inputValue + c23;
      this.updateFilteredOptions();
    }
    _(c23, key) {
      if (c23 === " ") {
        this.handleSpaceToggle();
      } else {
        this.handleInputChange(c23);
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `
Instructions:
    ${figures.arrowUp}/${figures.arrowDown}: Highlight option
    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection
    [a,b,c]/delete: Filter choices
    enter/return: Complete answer
`;
      }
      return "";
    }
    renderCurrentInput() {
      return `
Filtered results for: ${this.inputValue ? this.inputValue : color.gray("Enter something to filter")}\n`;
    }
    renderOption(cursor32, v23, i5) {
      let title;
      if (v23.disabled)
        title = cursor32 === i5 ? color.gray().underline(v23.title) : color.strikethrough().gray(v23.title);
      else
        title = cursor32 === i5 ? color.cyan().underline(v23.title) : v23.title;
      return (v23.selected ? color.green(figures.radioOn) : figures.radioOff) + "  " + title;
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e5) => e5.selected).map((v23) => v23.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions(), this.renderCurrentInput()];
      if (this.filteredOptions.length && this.filteredOptions[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(false), this.renderDoneOrInstructions()].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.filteredOptions);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = AutocompleteMultiselectPrompt;
});
var require_confirm5 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt5();
  var _require = require_util5();
  var style = _require.style;
  var clear = _require.clear;
  var _require2 = require_src3();
  var erase22 = _require2.erase;
  var cursor22 = _require2.cursor;

  class ConfirmPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = opts.initial;
      this.initialValue = !!opts.initial;
      this.yesMsg = opts.yes || "yes";
      this.yesOption = opts.yesOption || "(Y/n)";
      this.noMsg = opts.no || "no";
      this.noOption = opts.noOption || "(y/N)";
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.value = this.value || false;
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c23, key) {
      if (c23.toLowerCase() === "y") {
        this.value = true;
        return this.submit();
      }
      if (c23.toLowerCase() === "n") {
        this.value = false;
        return this.submit();
      }
      return this.bell();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [style.symbol(this.done, this.aborted), color.bold(this.msg), style.delimiter(this.done), this.done ? this.value ? this.yesMsg : this.noMsg : color.gray(this.initialValue ? this.yesOption : this.noOption)].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = ConfirmPrompt;
});
var require_elements5 = __commonJS22((exports, module) => {
  module.exports = {
    TextPrompt: require_text5(),
    SelectPrompt: require_select5(),
    TogglePrompt: require_toggle5(),
    DatePrompt: require_date5(),
    NumberPrompt: require_number5(),
    MultiselectPrompt: require_multiselect5(),
    AutocompletePrompt: require_autocomplete5(),
    AutocompleteMultiselectPrompt: require_autocompleteMultiselect5(),
    ConfirmPrompt: require_confirm5()
  };
});
var require_prompts6 = __commonJS22((exports) => {
  var $32 = exports;
  var el = require_elements5();
  var noop3 = (v23) => v23;
  function toPrompt(type2, args, opts = {}) {
    return new Promise((res, rej) => {
      const p33 = new el[type2](args);
      const onAbort = opts.onAbort || noop3;
      const onSubmit = opts.onSubmit || noop3;
      const onExit2 = opts.onExit || noop3;
      p33.on("state", args.onState || noop3);
      p33.on("submit", (x22) => res(onSubmit(x22)));
      p33.on("exit", (x22) => res(onExit2(x22)));
      p33.on("abort", (x22) => rej(onAbort(x22)));
    });
  }
  $32.text = (args) => toPrompt("TextPrompt", args);
  $32.password = (args) => {
    args.style = "password";
    return $32.text(args);
  };
  $32.invisible = (args) => {
    args.style = "invisible";
    return $32.text(args);
  };
  $32.number = (args) => toPrompt("NumberPrompt", args);
  $32.date = (args) => toPrompt("DatePrompt", args);
  $32.confirm = (args) => toPrompt("ConfirmPrompt", args);
  $32.list = (args) => {
    const sep33 = args.separator || ",";
    return toPrompt("TextPrompt", args, {
      onSubmit: (str2) => str2.split(sep33).map((s32) => s32.trim())
    });
  };
  $32.toggle = (args) => toPrompt("TogglePrompt", args);
  $32.select = (args) => toPrompt("SelectPrompt", args);
  $32.multiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("MultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  $32.autocompleteMultiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("AutocompleteMultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  var byTitle = (input, choices) => Promise.resolve(choices.filter((item) => item.title.slice(0, input.length).toLowerCase() === input.toLowerCase()));
  $32.autocomplete = (args) => {
    args.suggest = args.suggest || byTitle;
    args.choices = [].concat(args.choices || []);
    return toPrompt("AutocompletePrompt", args);
  };
});
var require_dist5 = __commonJS22((exports, module) => {
  function ownKeys(object, enumerableOnly) {
    var keys2 = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) {
        symbols = symbols.filter(function(sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }
      keys2.push.apply(keys2, symbols);
    }
    return keys2;
  }
  function _objectSpread(target) {
    for (var i5 = 1;i5 < arguments.length; i5++) {
      var source = arguments[i5] != null ? arguments[i5] : {};
      if (i5 % 2) {
        ownKeys(Object(source), true).forEach(function(key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function(key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }
    return target;
  }
  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }
    return obj;
  }
  function _createForOfIteratorHelper(o5, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o5[Symbol.iterator] || o5["@@iterator"];
    if (!it) {
      if (Array.isArray(o5) || (it = _unsupportedIterableToArray(o5)) || allowArrayLike && o5 && typeof o5.length === "number") {
        if (it)
          o5 = it;
        var i5 = 0;
        var F3 = function F() {
        };
        return { s: F3, n: function n() {
          if (i5 >= o5.length)
            return { done: true };
          return { done: false, value: o5[i5++] };
        }, e: function e(_e2) {
          throw _e2;
        }, f: F3 };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true, didErr = false, err22;
    return { s: function s() {
      it = it.call(o5);
    }, n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    }, e: function e(_e2) {
      didErr = true;
      err22 = _e2;
    }, f: function f() {
      try {
        if (!normalCompletion && it.return != null)
          it.return();
      } finally {
        if (didErr)
          throw err22;
      }
    } };
  }
  function _unsupportedIterableToArray(o5, minLen) {
    if (!o5)
      return;
    if (typeof o5 === "string")
      return _arrayLikeToArray(o5, minLen);
    var n5 = Object.prototype.toString.call(o5).slice(8, -1);
    if (n5 === "Object" && o5.constructor)
      n5 = o5.constructor.name;
    if (n5 === "Map" || n5 === "Set")
      return Array.from(o5);
    if (n5 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n5))
      return _arrayLikeToArray(o5, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i5 = 0, arr2 = new Array(len);i5 < len; i5++)
      arr2[i5] = arr[i5];
    return arr2;
  }
  function asyncGeneratorStep(gen, resolve32, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve32(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function() {
      var self2 = this, args = arguments;
      return new Promise(function(resolve32, reject) {
        var gen = fn.apply(self2, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "next", value);
        }
        function _throw(err22) {
          asyncGeneratorStep(gen, resolve32, reject, _next, _throw, "throw", err22);
        }
        _next(undefined);
      });
    };
  }
  var prompts = require_prompts6();
  var passOn = ["suggest", "format", "onState", "validate", "onRender", "type"];
  var noop3 = () => {
  };
  function prompt22() {
    return _prompt.apply(this, arguments);
  }
  function _prompt() {
    _prompt = _asyncToGenerator(function* (questions = [], {
      onSubmit = noop3,
      onCancel = noop3
    } = {}) {
      const answers = {};
      const override2 = prompt22._override || {};
      questions = [].concat(questions);
      let answer, question, quit, name, type2, lastPrompt;
      const getFormattedAnswer = /* @__PURE__ */ function() {
        var _ref = _asyncToGenerator(function* (question2, answer2, skipValidation = false) {
          if (!skipValidation && question2.validate && question2.validate(answer2) !== true) {
            return;
          }
          return question2.format ? yield question2.format(answer2, answers) : answer2;
        });
        return function getFormattedAnswer(_x2, _x22) {
          return _ref.apply(this, arguments);
        };
      }();
      var _iterator = _createForOfIteratorHelper(questions), _step;
      try {
        for (_iterator.s();!(_step = _iterator.n()).done; ) {
          question = _step.value;
          var _question = question;
          name = _question.name;
          type2 = _question.type;
          if (typeof type2 === "function") {
            type2 = yield type2(answer, _objectSpread({}, answers), question);
            question["type"] = type2;
          }
          if (!type2)
            continue;
          for (let key in question) {
            if (passOn.includes(key))
              continue;
            let value = question[key];
            question[key] = typeof value === "function" ? yield value(answer, _objectSpread({}, answers), lastPrompt) : value;
          }
          lastPrompt = question;
          if (typeof question.message !== "string") {
            throw new Error("prompt message is required");
          }
          var _question2 = question;
          name = _question2.name;
          type2 = _question2.type;
          if (prompts[type2] === undefined) {
            throw new Error(`prompt type (${type2}) is not defined`);
          }
          if (override2[question.name] !== undefined) {
            answer = yield getFormattedAnswer(question, override2[question.name]);
            if (answer !== undefined) {
              answers[name] = answer;
              continue;
            }
          }
          try {
            answer = prompt22._injected ? getInjectedAnswer(prompt22._injected, question.initial) : yield prompts[type2](question);
            answers[name] = answer = yield getFormattedAnswer(question, answer, true);
            quit = yield onSubmit(question, answer, answers);
          } catch (err22) {
            quit = !(yield onCancel(question, answers));
          }
          if (quit)
            return answers;
        }
      } catch (err22) {
        _iterator.e(err22);
      } finally {
        _iterator.f();
      }
      return answers;
    });
    return _prompt.apply(this, arguments);
  }
  function getInjectedAnswer(injected, deafultValue) {
    const answer = injected.shift();
    if (answer instanceof Error) {
      throw answer;
    }
    return answer === undefined ? deafultValue : answer;
  }
  function inject(answers) {
    prompt22._injected = (prompt22._injected || []).concat(answers);
  }
  function override(answers) {
    prompt22._override = Object.assign({}, answers);
  }
  module.exports = Object.assign(prompt22, {
    prompt: prompt22,
    prompts,
    inject,
    override
  });
});
var require_action23 = __commonJS22((exports, module) => {
  module.exports = (key, isSelect) => {
    if (key.meta && key.name !== "escape")
      return;
    if (key.ctrl) {
      if (key.name === "a")
        return "first";
      if (key.name === "c")
        return "abort";
      if (key.name === "d")
        return "abort";
      if (key.name === "e")
        return "last";
      if (key.name === "g")
        return "reset";
    }
    if (isSelect) {
      if (key.name === "j")
        return "down";
      if (key.name === "k")
        return "up";
    }
    if (key.name === "return")
      return "submit";
    if (key.name === "enter")
      return "submit";
    if (key.name === "backspace")
      return "delete";
    if (key.name === "delete")
      return "deleteForward";
    if (key.name === "abort")
      return "abort";
    if (key.name === "escape")
      return "exit";
    if (key.name === "tab")
      return "next";
    if (key.name === "pagedown")
      return "nextPage";
    if (key.name === "pageup")
      return "prevPage";
    if (key.name === "home")
      return "home";
    if (key.name === "end")
      return "end";
    if (key.name === "up")
      return "up";
    if (key.name === "down")
      return "down";
    if (key.name === "right")
      return "right";
    if (key.name === "left")
      return "left";
    return false;
  };
});
var require_strip23 = __commonJS22((exports, module) => {
  module.exports = (str2) => {
    const pattern = [
      "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
      "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PRZcf-ntqry=><~]))"
    ].join("|");
    const RGX = new RegExp(pattern, "g");
    return typeof str2 === "string" ? str2.replace(RGX, "") : str2;
  };
});
var require_clear23 = __commonJS22((exports, module) => {
  var strip = require_strip23();
  var { erase: erase22, cursor: cursor22 } = require_src3();
  var width = (str2) => [...strip(str2)].length;
  module.exports = function(prompt22, perLine) {
    if (!perLine)
      return erase22.line + cursor22.to(0);
    let rows = 0;
    const lines = prompt22.split(/\r?\n/);
    for (let line of lines) {
      rows += 1 + Math.floor(Math.max(width(line) - 1, 0) / perLine);
    }
    return erase22.lines(rows);
  };
});
var require_figures23 = __commonJS22((exports, module) => {
  var main2 = {
    arrowUp: "\u2191",
    arrowDown: "\u2193",
    arrowLeft: "\u2190",
    arrowRight: "\u2192",
    radioOn: "\u25C9",
    radioOff: "\u25EF",
    tick: "\u2714",
    cross: "\u2716",
    ellipsis: "\u2026",
    pointerSmall: "\u203A",
    line: "\u2500",
    pointer: "\u276F"
  };
  var win = {
    arrowUp: main2.arrowUp,
    arrowDown: main2.arrowDown,
    arrowLeft: main2.arrowLeft,
    arrowRight: main2.arrowRight,
    radioOn: "(*)",
    radioOff: "( )",
    tick: "\u221A",
    cross: "\xD7",
    ellipsis: "...",
    pointerSmall: "\xBB",
    line: "\u2500",
    pointer: ">"
  };
  var figures = process.platform === "win32" ? win : main2;
  module.exports = figures;
});
var require_style23 = __commonJS22((exports, module) => {
  var c23 = require_kleur3();
  var figures = require_figures23();
  var styles3 = Object.freeze({
    password: { scale: 1, render: (input) => "*".repeat(input.length) },
    emoji: { scale: 2, render: (input) => "\uD83D\uDE03".repeat(input.length) },
    invisible: { scale: 0, render: (input) => "" },
    default: { scale: 1, render: (input) => `${input}` }
  });
  var render = (type2) => styles3[type2] || styles3.default;
  var symbols = Object.freeze({
    aborted: c23.red(figures.cross),
    done: c23.green(figures.tick),
    exited: c23.yellow(figures.cross),
    default: c23.cyan("?")
  });
  var symbol22 = (done, aborted, exited) => aborted ? symbols.aborted : exited ? symbols.exited : done ? symbols.done : symbols.default;
  var delimiter22 = (completing) => c23.gray(completing ? figures.ellipsis : figures.pointerSmall);
  var item = (expandable, expanded) => c23.gray(expandable ? expanded ? figures.pointerSmall : "+" : figures.line);
  module.exports = {
    styles: styles3,
    render,
    symbols,
    symbol: symbol22,
    delimiter: delimiter22,
    item
  };
});
var require_lines23 = __commonJS22((exports, module) => {
  var strip = require_strip23();
  module.exports = function(msg, perLine) {
    let lines = String(strip(msg) || "").split(/\r?\n/);
    if (!perLine)
      return lines.length;
    return lines.map((l33) => Math.ceil(l33.length / perLine)).reduce((a5, b23) => a5 + b23);
  };
});
var require_wrap23 = __commonJS22((exports, module) => {
  module.exports = (msg, opts = {}) => {
    const tab = Number.isSafeInteger(parseInt(opts.margin)) ? new Array(parseInt(opts.margin)).fill(" ").join("") : opts.margin || "";
    const width = opts.width;
    return (msg || "").split(/\r?\n/g).map((line) => line.split(/\s+/g).reduce((arr, w23) => {
      if (w23.length + tab.length >= width || arr[arr.length - 1].length + w23.length + 1 < width)
        arr[arr.length - 1] += ` ${w23}`;
      else
        arr.push(`${tab}${w23}`);
      return arr;
    }, [tab]).join("\n")).join("\n");
  };
});
var require_entriesToDisplay23 = __commonJS22((exports, module) => {
  module.exports = (cursor22, total, maxVisible) => {
    maxVisible = maxVisible || total;
    let startIndex = Math.min(total - maxVisible, cursor22 - Math.floor(maxVisible / 2));
    if (startIndex < 0)
      startIndex = 0;
    let endIndex = Math.min(startIndex + maxVisible, total);
    return { startIndex, endIndex };
  };
});
var require_util23 = __commonJS22((exports, module) => {
  module.exports = {
    action: require_action23(),
    clear: require_clear23(),
    style: require_style23(),
    strip: require_strip23(),
    figures: require_figures23(),
    lines: require_lines23(),
    wrap: require_wrap23(),
    entriesToDisplay: require_entriesToDisplay23()
  };
});
var require_prompt23 = __commonJS22((exports, module) => {
  var readline = import.meta.require("readline");
  var { action } = require_util23();
  var EventEmitter23 = import.meta.require("events");
  var { beep: beep22, cursor: cursor22 } = require_src3();
  var color = require_kleur3();

  class Prompt extends EventEmitter23 {
    constructor(opts = {}) {
      super();
      this.firstRender = true;
      this.in = opts.stdin || process.stdin;
      this.out = opts.stdout || process.stdout;
      this.onRender = (opts.onRender || (() => {
        return;
      })).bind(this);
      const rl = readline.createInterface({ input: this.in, escapeCodeTimeout: 50 });
      readline.emitKeypressEvents(this.in, rl);
      if (this.in.isTTY)
        this.in.setRawMode(true);
      const isSelect = ["SelectPrompt", "MultiselectPrompt"].indexOf(this.constructor.name) > -1;
      const keypress = (str2, key) => {
        let a5 = action(key, isSelect);
        if (a5 === false) {
          this._ && this._(str2, key);
        } else if (typeof this[a5] === "function") {
          this[a5](key);
        } else {
          this.bell();
        }
      };
      this.close = () => {
        this.out.write(cursor22.show);
        this.in.removeListener("keypress", keypress);
        if (this.in.isTTY)
          this.in.setRawMode(false);
        rl.close();
        this.emit(this.aborted ? "abort" : this.exited ? "exit" : "submit", this.value);
        this.closed = true;
      };
      this.in.on("keypress", keypress);
    }
    fire() {
      this.emit("state", {
        value: this.value,
        aborted: !!this.aborted,
        exited: !!this.exited
      });
    }
    bell() {
      this.out.write(beep22);
    }
    render() {
      this.onRender(color);
      if (this.firstRender)
        this.firstRender = false;
    }
  }
  module.exports = Prompt;
});
var require_text23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt23();
  var { erase: erase22, cursor: cursor22 } = require_src3();
  var { style, clear, lines, figures } = require_util23();

  class TextPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.msg = opts.message;
      this.initial = opts.initial || ``;
      this.validator = opts.validate || (() => true);
      this.value = ``;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.clear = clear(``, this.out.columns);
      this.render();
    }
    set value(v23) {
      if (!v23 && this.initial) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(this.initial));
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(v23);
      }
      this._value = v23;
      this.fire();
    }
    get value() {
      return this._value;
    }
    reset() {
      this.value = ``;
      this.cursor = Number(!!this.initial);
      this.cursorOffset = 0;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.value = this.value || this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.red = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === `string`) {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      this.value = this.value || this.initial;
      this.cursorOffset = 0;
      this.cursor = this.rendered.length;
      await this.validate();
      if (this.error) {
        this.red = true;
        this.fire();
        this.render();
        return;
      }
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    next() {
      if (!this.placeholder)
        return this.bell();
      this.value = this.initial;
      this.cursor = this.rendered.length;
      this.fire();
      this.render();
    }
    moveCursor(n5) {
      if (this.placeholder)
        return;
      this.cursor = this.cursor + n5;
      this.cursorOffset += n5;
    }
    _(c23, key) {
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${c23}${s222}`;
      this.red = false;
      this.cursor = this.placeholder ? 0 : s1.length + 1;
      this.render();
    }
    delete() {
      if (this.isCursorAtStart())
        return this.bell();
      let s1 = this.value.slice(0, this.cursor - 1);
      let s222 = this.value.slice(this.cursor);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtStart()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
        this.moveCursor(-1);
      }
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      let s1 = this.value.slice(0, this.cursor);
      let s222 = this.value.slice(this.cursor + 1);
      this.value = `${s1}${s222}`;
      this.red = false;
      if (this.isCursorAtEnd()) {
        this.cursorOffset = 0;
      } else {
        this.cursorOffset++;
      }
      this.render();
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length;
      this.render();
    }
    left() {
      if (this.cursor <= 0 || this.placeholder)
        return this.bell();
      this.moveCursor(-1);
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length || this.placeholder)
        return this.bell();
      this.moveCursor(1);
      this.render();
    }
    isCursorAtStart() {
      return this.cursor === 0 || this.placeholder && this.cursor === 1;
    }
    isCursorAtEnd() {
      return this.cursor === this.rendered.length || this.placeholder && this.cursor === this.rendered.length + 1;
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.red ? color.red(this.rendered) : this.rendered
      ].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a5, l33, i5) => a5 + `\n${i5 ? " " : figures.pointerSmall} ${color.red().italic(l33)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore + cursor22.move(this.cursorOffset, 0));
    }
  }
  module.exports = TextPrompt;
});
var require_select23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt23();
  var { style, clear, figures, wrap, entriesToDisplay } = require_util23();
  var { cursor: cursor22 } = require_src3();

  class SelectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.hint = opts.hint || "- Use arrow-keys. Return to submit.";
      this.warn = opts.warn || "- This option is disabled";
      this.cursor = opts.initial || 0;
      this.choices = opts.choices.map((ch2, idx) => {
        if (typeof ch2 === "string")
          ch2 = { title: ch2, value: idx };
        return {
          title: ch2 && (ch2.title || ch2.value || ch2),
          value: ch2 && (ch2.value === undefined ? idx : ch2.value),
          description: ch2 && ch2.description,
          selected: ch2 && ch2.selected,
          disabled: ch2 && ch2.disabled
        };
      });
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = (this.choices[this.cursor] || {}).value;
      this.clear = clear("", this.out.columns);
      this.render();
    }
    moveCursor(n5) {
      this.cursor = n5;
      this.value = this.choices[n5].value;
      this.fire();
    }
    reset() {
      this.moveCursor(0);
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      if (!this.selection.disabled) {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      } else
        this.bell();
    }
    first() {
      this.moveCursor(0);
      this.render();
    }
    last() {
      this.moveCursor(this.choices.length - 1);
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.moveCursor(this.choices.length - 1);
      } else {
        this.moveCursor(this.cursor - 1);
      }
      this.render();
    }
    down() {
      if (this.cursor === this.choices.length - 1) {
        this.moveCursor(0);
      } else {
        this.moveCursor(this.cursor + 1);
      }
      this.render();
    }
    next() {
      this.moveCursor((this.cursor + 1) % this.choices.length);
      this.render();
    }
    _(c23, key) {
      if (c23 === " ")
        return this.submit();
    }
    get selection() {
      return this.choices[this.cursor];
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let { startIndex, endIndex } = entriesToDisplay(this.cursor, this.choices.length, this.optionsPerPage);
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.done ? this.selection.title : this.selection.disabled ? color.yellow(this.warn) : color.gray(this.hint)
      ].join(" ");
      if (!this.done) {
        this.outputText += "\n";
        for (let i5 = startIndex;i5 < endIndex; i5++) {
          let title, prefix, desc = "", v23 = this.choices[i5];
          if (i5 === startIndex && startIndex > 0) {
            prefix = figures.arrowUp;
          } else if (i5 === endIndex - 1 && endIndex < this.choices.length) {
            prefix = figures.arrowDown;
          } else {
            prefix = " ";
          }
          if (v23.disabled) {
            title = this.cursor === i5 ? color.gray().underline(v23.title) : color.strikethrough().gray(v23.title);
            prefix = (this.cursor === i5 ? color.bold().gray(figures.pointer) + " " : "  ") + prefix;
          } else {
            title = this.cursor === i5 ? color.cyan().underline(v23.title) : v23.title;
            prefix = (this.cursor === i5 ? color.cyan(figures.pointer) + " " : "  ") + prefix;
            if (v23.description && this.cursor === i5) {
              desc = ` - ${v23.description}`;
              if (prefix.length + title.length + desc.length >= this.out.columns || v23.description.split(/\r?\n/).length > 1) {
                desc = "\n" + wrap(v23.description, { margin: 3, width: this.out.columns });
              }
            }
          }
          this.outputText += `${prefix} ${title}${color.gray(desc)}\n`;
        }
      }
      this.out.write(this.outputText);
    }
  }
  module.exports = SelectPrompt;
});
var require_toggle23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt23();
  var { style, clear } = require_util23();
  var { cursor: cursor22, erase: erase22 } = require_src3();

  class TogglePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = !!opts.initial;
      this.active = opts.active || "on";
      this.inactive = opts.inactive || "off";
      this.initialValue = this.value;
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    deactivate() {
      if (this.value === false)
        return this.bell();
      this.value = false;
      this.render();
    }
    activate() {
      if (this.value === true)
        return this.bell();
      this.value = true;
      this.render();
    }
    delete() {
      this.deactivate();
    }
    left() {
      this.deactivate();
    }
    right() {
      this.activate();
    }
    down() {
      this.deactivate();
    }
    up() {
      this.activate();
    }
    next() {
      this.value = !this.value;
      this.fire();
      this.render();
    }
    _(c23, key) {
      if (c23 === " ") {
        this.value = !this.value;
      } else if (c23 === "1") {
        this.value = true;
      } else if (c23 === "0") {
        this.value = false;
      } else
        return this.bell();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.value ? this.inactive : color.cyan().underline(this.inactive),
        color.gray("/"),
        this.value ? color.cyan().underline(this.active) : this.active
      ].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = TogglePrompt;
});
var require_datepart23 = __commonJS22((exports, module) => {

  class DatePart {
    constructor({ token, date, parts, locales: locales22 }) {
      this.token = token;
      this.date = date || new Date;
      this.parts = parts || [this];
      this.locales = locales22 || {};
    }
    up() {
    }
    down() {
    }
    next() {
      const currentIdx = this.parts.indexOf(this);
      return this.parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    setTo(val2) {
    }
    prev() {
      let parts = [].concat(this.parts).reverse();
      const currentIdx = parts.indexOf(this);
      return parts.find((part, idx) => idx > currentIdx && part instanceof DatePart);
    }
    toString() {
      return String(this.date);
    }
  }
  module.exports = DatePart;
});
var require_meridiem23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();

  class Meridiem extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours((this.date.getHours() + 12) % 24);
    }
    down() {
      this.up();
    }
    toString() {
      let meridiem = this.date.getHours() > 12 ? "pm" : "am";
      return /\A/.test(this.token) ? meridiem.toUpperCase() : meridiem;
    }
  }
  module.exports = Meridiem;
});
var require_day23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();
  var pos = (n5) => {
    n5 = n5 % 10;
    return n5 === 1 ? "st" : n5 === 2 ? "nd" : n5 === 3 ? "rd" : "th";
  };

  class Day extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setDate(this.date.getDate() + 1);
    }
    down() {
      this.date.setDate(this.date.getDate() - 1);
    }
    setTo(val2) {
      this.date.setDate(parseInt(val2.substr(-2)));
    }
    toString() {
      let date = this.date.getDate();
      let day = this.date.getDay();
      return this.token === "DD" ? String(date).padStart(2, "0") : this.token === "Do" ? date + pos(date) : this.token === "d" ? day + 1 : this.token === "ddd" ? this.locales.weekdaysShort[day] : this.token === "dddd" ? this.locales.weekdays[day] : date;
    }
  }
  module.exports = Day;
});
var require_hours23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();

  class Hours extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setHours(this.date.getHours() + 1);
    }
    down() {
      this.date.setHours(this.date.getHours() - 1);
    }
    setTo(val2) {
      this.date.setHours(parseInt(val2.substr(-2)));
    }
    toString() {
      let hours = this.date.getHours();
      if (/h/.test(this.token))
        hours = hours % 12 || 12;
      return this.token.length > 1 ? String(hours).padStart(2, "0") : hours;
    }
  }
  module.exports = Hours;
});
var require_milliseconds23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();

  class Milliseconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMilliseconds(this.date.getMilliseconds() + 1);
    }
    down() {
      this.date.setMilliseconds(this.date.getMilliseconds() - 1);
    }
    setTo(val2) {
      this.date.setMilliseconds(parseInt(val2.substr(-this.token.length)));
    }
    toString() {
      return String(this.date.getMilliseconds()).padStart(4, "0").substr(0, this.token.length);
    }
  }
  module.exports = Milliseconds;
});
var require_minutes23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();

  class Minutes extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMinutes(this.date.getMinutes() + 1);
    }
    down() {
      this.date.setMinutes(this.date.getMinutes() - 1);
    }
    setTo(val2) {
      this.date.setMinutes(parseInt(val2.substr(-2)));
    }
    toString() {
      let m23 = this.date.getMinutes();
      return this.token.length > 1 ? String(m23).padStart(2, "0") : m23;
    }
  }
  module.exports = Minutes;
});
var require_month23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();

  class Month extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setMonth(this.date.getMonth() + 1);
    }
    down() {
      this.date.setMonth(this.date.getMonth() - 1);
    }
    setTo(val2) {
      val2 = parseInt(val2.substr(-2)) - 1;
      this.date.setMonth(val2 < 0 ? 0 : val2);
    }
    toString() {
      let month = this.date.getMonth();
      let tl = this.token.length;
      return tl === 2 ? String(month + 1).padStart(2, "0") : tl === 3 ? this.locales.monthsShort[month] : tl === 4 ? this.locales.months[month] : String(month + 1);
    }
  }
  module.exports = Month;
});
var require_seconds23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();

  class Seconds extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setSeconds(this.date.getSeconds() + 1);
    }
    down() {
      this.date.setSeconds(this.date.getSeconds() - 1);
    }
    setTo(val2) {
      this.date.setSeconds(parseInt(val2.substr(-2)));
    }
    toString() {
      let s32 = this.date.getSeconds();
      return this.token.length > 1 ? String(s32).padStart(2, "0") : s32;
    }
  }
  module.exports = Seconds;
});
var require_year23 = __commonJS22((exports, module) => {
  var DatePart = require_datepart23();

  class Year extends DatePart {
    constructor(opts = {}) {
      super(opts);
    }
    up() {
      this.date.setFullYear(this.date.getFullYear() + 1);
    }
    down() {
      this.date.setFullYear(this.date.getFullYear() - 1);
    }
    setTo(val2) {
      this.date.setFullYear(val2.substr(-4));
    }
    toString() {
      let year = String(this.date.getFullYear()).padStart(4, "0");
      return this.token.length === 2 ? year.substr(-2) : year;
    }
  }
  module.exports = Year;
});
var require_dateparts23 = __commonJS22((exports, module) => {
  module.exports = {
    DatePart: require_datepart23(),
    Meridiem: require_meridiem23(),
    Day: require_day23(),
    Hours: require_hours23(),
    Milliseconds: require_milliseconds23(),
    Minutes: require_minutes23(),
    Month: require_month23(),
    Seconds: require_seconds23(),
    Year: require_year23()
  };
});
var require_date23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt23();
  var { style, clear, figures } = require_util23();
  var { erase: erase22, cursor: cursor22 } = require_src3();
  var { DatePart, Meridiem, Day, Hours, Milliseconds, Minutes, Month, Seconds, Year } = require_dateparts23();
  var regex22 = /\\(.)|"((?:\\["\\]|[^"])+)"|(D[Do]?|d{3,4}|d)|(M{1,4})|(YY(?:YY)?)|([aA])|([Hh]{1,2})|(m{1,2})|(s{1,2})|(S{1,4})|./g;
  var regexGroups = {
    1: ({ token }) => token.replace(/\\(.)/g, "$1"),
    2: (opts) => new Day(opts),
    3: (opts) => new Month(opts),
    4: (opts) => new Year(opts),
    5: (opts) => new Meridiem(opts),
    6: (opts) => new Hours(opts),
    7: (opts) => new Minutes(opts),
    8: (opts) => new Seconds(opts),
    9: (opts) => new Milliseconds(opts)
  };
  var dfltLocales = {
    months: "January,February,March,April,May,June,July,August,September,October,November,December".split(","),
    monthsShort: "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),
    weekdays: "Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),
    weekdaysShort: "Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(",")
  };

  class DatePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = 0;
      this.typed = "";
      this.locales = Object.assign(dfltLocales, opts.locales);
      this._date = opts.initial || new Date;
      this.errorMsg = opts.error || "Please Enter A Valid Value";
      this.validator = opts.validate || (() => true);
      this.mask = opts.mask || "YYYY-MM-DD HH:mm:ss";
      this.clear = clear("", this.out.columns);
      this.render();
    }
    get value() {
      return this.date;
    }
    get date() {
      return this._date;
    }
    set date(date) {
      if (date)
        this._date.setTime(date.getTime());
    }
    set mask(mask) {
      let result2;
      this.parts = [];
      while (result2 = regex22.exec(mask)) {
        let match = result2.shift();
        let idx = result2.findIndex((gr) => gr != null);
        this.parts.push(idx in regexGroups ? regexGroups[idx]({ token: result2[idx] || match, date: this.date, parts: this.parts, locales: this.locales }) : result2[idx] || match);
      }
      let parts = this.parts.reduce((arr, i5) => {
        if (typeof i5 === "string" && typeof arr[arr.length - 1] === "string")
          arr[arr.length - 1] += i5;
        else
          arr.push(i5);
        return arr;
      }, []);
      this.parts.splice(0);
      this.parts.push(...parts);
      this.reset();
    }
    moveCursor(n5) {
      this.typed = "";
      this.cursor = n5;
      this.fire();
    }
    reset() {
      this.moveCursor(this.parts.findIndex((p33) => p33 instanceof DatePart));
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === "string") {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      await this.validate();
      if (this.error) {
        this.color = "red";
        this.fire();
        this.render();
        return;
      }
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    up() {
      this.typed = "";
      this.parts[this.cursor].up();
      this.render();
    }
    down() {
      this.typed = "";
      this.parts[this.cursor].down();
      this.render();
    }
    left() {
      let prev = this.parts[this.cursor].prev();
      if (prev == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(prev));
      this.render();
    }
    right() {
      let next = this.parts[this.cursor].next();
      if (next == null)
        return this.bell();
      this.moveCursor(this.parts.indexOf(next));
      this.render();
    }
    next() {
      let next = this.parts[this.cursor].next();
      this.moveCursor(next ? this.parts.indexOf(next) : this.parts.findIndex((part) => part instanceof DatePart));
      this.render();
    }
    _(c23) {
      if (/\d/.test(c23)) {
        this.typed += c23;
        this.parts[this.cursor].setTo(this.typed);
        this.render();
      }
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.parts.reduce((arr, p33, idx) => arr.concat(idx === this.cursor && !this.done ? color.cyan().underline(p33.toString()) : p33), []).join("")
      ].join(" ");
      if (this.error) {
        this.outputText += this.errorMsg.split("\n").reduce((a5, l33, i5) => a5 + `\n${i5 ? ` ` : figures.pointerSmall} ${color.red().italic(l33)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = DatePrompt;
});
var require_number23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt23();
  var { cursor: cursor22, erase: erase22 } = require_src3();
  var { style, figures, clear, lines } = require_util23();
  var isNumber2 = /[0-9]/;
  var isDef = (any) => any !== undefined;
  var round = (number, precision) => {
    let factor = Math.pow(10, precision);
    return Math.round(number * factor) / factor;
  };

  class NumberPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.transform = style.render(opts.style);
      this.msg = opts.message;
      this.initial = isDef(opts.initial) ? opts.initial : "";
      this.float = !!opts.float;
      this.round = opts.round || 2;
      this.inc = opts.increment || 1;
      this.min = isDef(opts.min) ? opts.min : -Infinity;
      this.max = isDef(opts.max) ? opts.max : Infinity;
      this.errorMsg = opts.error || `Please Enter A Valid Value`;
      this.validator = opts.validate || (() => true);
      this.color = `cyan`;
      this.value = ``;
      this.typed = ``;
      this.lastHit = 0;
      this.render();
    }
    set value(v23) {
      if (!v23 && v23 !== 0) {
        this.placeholder = true;
        this.rendered = color.gray(this.transform.render(`${this.initial}`));
        this._value = ``;
      } else {
        this.placeholder = false;
        this.rendered = this.transform.render(`${round(v23, this.round)}`);
        this._value = round(v23, this.round);
      }
      this.fire();
    }
    get value() {
      return this._value;
    }
    parse(x22) {
      return this.float ? parseFloat(x22) : parseInt(x22);
    }
    valid(c23) {
      return c23 === `-` || c23 === `.` && this.float || isNumber2.test(c23);
    }
    reset() {
      this.typed = ``;
      this.value = ``;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      let x22 = this.value;
      this.value = x22 !== `` ? x22 : this.initial;
      this.done = this.aborted = true;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    async validate() {
      let valid = await this.validator(this.value);
      if (typeof valid === `string`) {
        this.errorMsg = valid;
        valid = false;
      }
      this.error = !valid;
    }
    async submit() {
      await this.validate();
      if (this.error) {
        this.color = `red`;
        this.fire();
        this.render();
        return;
      }
      let x22 = this.value;
      this.value = x22 !== `` ? x22 : this.initial;
      this.done = true;
      this.aborted = false;
      this.error = false;
      this.fire();
      this.render();
      this.out.write(`\n`);
      this.close();
    }
    up() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min - this.inc;
      }
      if (this.value >= this.max)
        return this.bell();
      this.value += this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    down() {
      this.typed = ``;
      if (this.value === "") {
        this.value = this.min + this.inc;
      }
      if (this.value <= this.min)
        return this.bell();
      this.value -= this.inc;
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    delete() {
      let val2 = this.value.toString();
      if (val2.length === 0)
        return this.bell();
      this.value = this.parse(val2 = val2.slice(0, -1)) || ``;
      if (this.value !== "" && this.value < this.min) {
        this.value = this.min;
      }
      this.color = `cyan`;
      this.fire();
      this.render();
    }
    next() {
      this.value = this.initial;
      this.fire();
      this.render();
    }
    _(c23, key) {
      if (!this.valid(c23))
        return this.bell();
      const now2 = Date.now();
      if (now2 - this.lastHit > 1000)
        this.typed = ``;
      this.typed += c23;
      this.lastHit = now2;
      this.color = `cyan`;
      if (c23 === `.`)
        return this.fire();
      this.value = Math.min(this.parse(this.typed), this.max);
      if (this.value > this.max)
        this.value = this.max;
      if (this.value < this.min)
        this.value = this.min;
      this.fire();
      this.render();
    }
    render() {
      if (this.closed)
        return;
      if (!this.firstRender) {
        if (this.outputError)
          this.out.write(cursor22.down(lines(this.outputError, this.out.columns) - 1) + clear(this.outputError, this.out.columns));
        this.out.write(clear(this.outputText, this.out.columns));
      }
      super.render();
      this.outputError = "";
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        !this.done || !this.done && !this.placeholder ? color[this.color]().underline(this.rendered) : this.rendered
      ].join(` `);
      if (this.error) {
        this.outputError += this.errorMsg.split(`\n`).reduce((a5, l33, i5) => a5 + `\n${i5 ? ` ` : figures.pointerSmall} ${color.red().italic(l33)}`, ``);
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText + cursor22.save + this.outputError + cursor22.restore);
    }
  }
  module.exports = NumberPrompt;
});
var require_multiselect23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var { cursor: cursor22 } = require_src3();
  var Prompt = require_prompt23();
  var { clear, figures, style, wrap, entriesToDisplay } = require_util23();

  class MultiselectPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.cursor = opts.cursor || 0;
      this.scrollIndex = opts.cursor || 0;
      this.hint = opts.hint || "";
      this.warn = opts.warn || "- This option is disabled -";
      this.minSelected = opts.min;
      this.showMinError = false;
      this.maxChoices = opts.max;
      this.instructions = opts.instructions;
      this.optionsPerPage = opts.optionsPerPage || 10;
      this.value = opts.choices.map((ch2, idx) => {
        if (typeof ch2 === "string")
          ch2 = { title: ch2, value: idx };
        return {
          title: ch2 && (ch2.title || ch2.value || ch2),
          description: ch2 && ch2.description,
          value: ch2 && (ch2.value === undefined ? idx : ch2.value),
          selected: ch2 && ch2.selected,
          disabled: ch2 && ch2.disabled
        };
      });
      this.clear = clear("", this.out.columns);
      if (!opts.overrideRender) {
        this.render();
      }
    }
    reset() {
      this.value.map((v23) => !v23.selected);
      this.cursor = 0;
      this.fire();
      this.render();
    }
    selected() {
      return this.value.filter((v23) => v23.selected);
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      const selected = this.value.filter((e5) => e5.selected);
      if (this.minSelected && selected.length < this.minSelected) {
        this.showMinError = true;
        this.render();
      } else {
        this.done = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    first() {
      this.cursor = 0;
      this.render();
    }
    last() {
      this.cursor = this.value.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.value.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.value.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.value.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.value[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e5) => e5.selected).length >= this.maxChoices)
        return this.bell();
      this.value[this.cursor].selected = true;
      this.render();
    }
    handleSpaceToggle() {
      const v23 = this.value[this.cursor];
      if (v23.selected) {
        v23.selected = false;
        this.render();
      } else if (v23.disabled || this.value.filter((e5) => e5.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v23.selected = true;
        this.render();
      }
    }
    toggleAll() {
      if (this.maxChoices !== undefined || this.value[this.cursor].disabled) {
        return this.bell();
      }
      const newSelected = !this.value[this.cursor].selected;
      this.value.filter((v23) => !v23.disabled).forEach((v23) => v23.selected = newSelected);
      this.render();
    }
    _(c23, key) {
      if (c23 === " ") {
        this.handleSpaceToggle();
      } else if (c23 === "a") {
        this.toggleAll();
      } else {
        return this.bell();
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return "\nInstructions:\n" + `    ${figures.arrowUp}/${figures.arrowDown}: Highlight option\n` + `    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection\n` + (this.maxChoices === undefined ? `    a: Toggle all\n` : "") + `    enter/return: Complete answer`;
      }
      return "";
    }
    renderOption(cursor32, v23, i5, arrowIndicator) {
      const prefix = (v23.selected ? color.green(figures.radioOn) : figures.radioOff) + " " + arrowIndicator + " ";
      let title, desc;
      if (v23.disabled) {
        title = cursor32 === i5 ? color.gray().underline(v23.title) : color.strikethrough().gray(v23.title);
      } else {
        title = cursor32 === i5 ? color.cyan().underline(v23.title) : v23.title;
        if (cursor32 === i5 && v23.description) {
          desc = ` - ${v23.description}`;
          if (prefix.length + title.length + desc.length >= this.out.columns || v23.description.split(/\r?\n/).length > 1) {
            desc = "\n" + wrap(v23.description, { margin: prefix.length, width: this.out.columns });
          }
        }
      }
      return prefix + title + color.gray(desc || "");
    }
    paginateOptions(options3) {
      if (options3.length === 0) {
        return color.red("No matches for this query.");
      }
      let { startIndex, endIndex } = entriesToDisplay(this.cursor, options3.length, this.optionsPerPage);
      let prefix, styledOptions = [];
      for (let i5 = startIndex;i5 < endIndex; i5++) {
        if (i5 === startIndex && startIndex > 0) {
          prefix = figures.arrowUp;
        } else if (i5 === endIndex - 1 && endIndex < options3.length) {
          prefix = figures.arrowDown;
        } else {
          prefix = " ";
        }
        styledOptions.push(this.renderOption(this.cursor, options3[i5], i5, prefix));
      }
      return "\n" + styledOptions.join("\n");
    }
    renderOptions(options3) {
      if (!this.done) {
        return this.paginateOptions(options3);
      }
      return "";
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e5) => e5.selected).map((v23) => v23.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions()];
      if (this.value[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.renderDoneOrInstructions()
      ].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.value);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = MultiselectPrompt;
});
var require_autocomplete23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt23();
  var { erase: erase22, cursor: cursor22 } = require_src3();
  var { style, clear, figures, wrap, entriesToDisplay } = require_util23();
  var getVal = (arr, i5) => arr[i5] && (arr[i5].value || arr[i5].title || arr[i5]);
  var getTitle = (arr, i5) => arr[i5] && (arr[i5].title || arr[i5].value || arr[i5]);
  var getIndex = (arr, valOrTitle) => {
    const index = arr.findIndex((el) => el.value === valOrTitle || el.title === valOrTitle);
    return index > -1 ? index : undefined;
  };

  class AutocompletePrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.suggest = opts.suggest;
      this.choices = opts.choices;
      this.initial = typeof opts.initial === "number" ? opts.initial : getIndex(opts.choices, opts.initial);
      this.select = this.initial || opts.cursor || 0;
      this.i18n = { noMatches: opts.noMatches || "no matches found" };
      this.fallback = opts.fallback || this.initial;
      this.clearFirst = opts.clearFirst || false;
      this.suggestions = [];
      this.input = "";
      this.limit = opts.limit || 10;
      this.cursor = 0;
      this.transform = style.render(opts.style);
      this.scale = this.transform.scale;
      this.render = this.render.bind(this);
      this.complete = this.complete.bind(this);
      this.clear = clear("", this.out.columns);
      this.complete(this.render);
      this.render();
    }
    set fallback(fb) {
      this._fb = Number.isSafeInteger(parseInt(fb)) ? parseInt(fb) : fb;
    }
    get fallback() {
      let choice;
      if (typeof this._fb === "number")
        choice = this.choices[this._fb];
      else if (typeof this._fb === "string")
        choice = { title: this._fb };
      return choice || this._fb || { title: this.i18n.noMatches };
    }
    moveSelect(i5) {
      this.select = i5;
      if (this.suggestions.length > 0)
        this.value = getVal(this.suggestions, i5);
      else
        this.value = this.fallback.value;
      this.fire();
    }
    async complete(cb2) {
      const p33 = this.completing = this.suggest(this.input, this.choices);
      const suggestions = await p33;
      if (this.completing !== p33)
        return;
      this.suggestions = suggestions.map((s32, i5, arr) => ({ title: getTitle(arr, i5), value: getVal(arr, i5), description: s32.description }));
      this.completing = false;
      const l33 = Math.max(suggestions.length - 1, 0);
      this.moveSelect(Math.min(l33, this.select));
      cb2 && cb2();
    }
    reset() {
      this.input = "";
      this.complete(() => {
        this.moveSelect(this.initial !== undefined ? this.initial : 0);
        this.render();
      });
      this.render();
    }
    exit() {
      if (this.clearFirst && this.input.length > 0) {
        this.reset();
      } else {
        this.done = this.exited = true;
        this.aborted = false;
        this.fire();
        this.render();
        this.out.write("\n");
        this.close();
      }
    }
    abort() {
      this.done = this.aborted = true;
      this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.done = true;
      this.aborted = this.exited = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c23, key) {
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${c23}${s222}`;
      this.cursor = s1.length + 1;
      this.complete(this.render);
      this.render();
    }
    delete() {
      if (this.cursor === 0)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor - 1);
      let s222 = this.input.slice(this.cursor);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.cursor = this.cursor - 1;
      this.render();
    }
    deleteForward() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      let s1 = this.input.slice(0, this.cursor);
      let s222 = this.input.slice(this.cursor + 1);
      this.input = `${s1}${s222}`;
      this.complete(this.render);
      this.render();
    }
    first() {
      this.moveSelect(0);
      this.render();
    }
    last() {
      this.moveSelect(this.suggestions.length - 1);
      this.render();
    }
    up() {
      if (this.select === 0) {
        this.moveSelect(this.suggestions.length - 1);
      } else {
        this.moveSelect(this.select - 1);
      }
      this.render();
    }
    down() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else {
        this.moveSelect(this.select + 1);
      }
      this.render();
    }
    next() {
      if (this.select === this.suggestions.length - 1) {
        this.moveSelect(0);
      } else
        this.moveSelect(this.select + 1);
      this.render();
    }
    nextPage() {
      this.moveSelect(Math.min(this.select + this.limit, this.suggestions.length - 1));
      this.render();
    }
    prevPage() {
      this.moveSelect(Math.max(this.select - this.limit, 0));
      this.render();
    }
    left() {
      if (this.cursor <= 0)
        return this.bell();
      this.cursor = this.cursor - 1;
      this.render();
    }
    right() {
      if (this.cursor * this.scale >= this.rendered.length)
        return this.bell();
      this.cursor = this.cursor + 1;
      this.render();
    }
    renderOption(v23, hovered, isStart, isEnd) {
      let desc;
      let prefix = isStart ? figures.arrowUp : isEnd ? figures.arrowDown : " ";
      let title = hovered ? color.cyan().underline(v23.title) : v23.title;
      prefix = (hovered ? color.cyan(figures.pointer) + " " : "  ") + prefix;
      if (v23.description) {
        desc = ` - ${v23.description}`;
        if (prefix.length + title.length + desc.length >= this.out.columns || v23.description.split(/\r?\n/).length > 1) {
          desc = "\n" + wrap(v23.description, { margin: 3, width: this.out.columns });
        }
      }
      return prefix + " " + title + color.gray(desc || "");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      let { startIndex, endIndex } = entriesToDisplay(this.select, this.choices.length, this.limit);
      this.outputText = [
        style.symbol(this.done, this.aborted, this.exited),
        color.bold(this.msg),
        style.delimiter(this.completing),
        this.done && this.suggestions[this.select] ? this.suggestions[this.select].title : this.rendered = this.transform.render(this.input)
      ].join(" ");
      if (!this.done) {
        const suggestions = this.suggestions.slice(startIndex, endIndex).map((item, i5) => this.renderOption(item, this.select === i5 + startIndex, i5 === 0 && startIndex > 0, i5 + startIndex === endIndex - 1 && endIndex < this.choices.length)).join("\n");
        this.outputText += `\n` + (suggestions || color.gray(this.fallback.title));
      }
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = AutocompletePrompt;
});
var require_autocompleteMultiselect23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var { cursor: cursor22 } = require_src3();
  var MultiselectPrompt = require_multiselect23();
  var { clear, style, figures } = require_util23();

  class AutocompleteMultiselectPrompt extends MultiselectPrompt {
    constructor(opts = {}) {
      opts.overrideRender = true;
      super(opts);
      this.inputValue = "";
      this.clear = clear("", this.out.columns);
      this.filteredOptions = this.value;
      this.render();
    }
    last() {
      this.cursor = this.filteredOptions.length - 1;
      this.render();
    }
    next() {
      this.cursor = (this.cursor + 1) % this.filteredOptions.length;
      this.render();
    }
    up() {
      if (this.cursor === 0) {
        this.cursor = this.filteredOptions.length - 1;
      } else {
        this.cursor--;
      }
      this.render();
    }
    down() {
      if (this.cursor === this.filteredOptions.length - 1) {
        this.cursor = 0;
      } else {
        this.cursor++;
      }
      this.render();
    }
    left() {
      this.filteredOptions[this.cursor].selected = false;
      this.render();
    }
    right() {
      if (this.value.filter((e5) => e5.selected).length >= this.maxChoices)
        return this.bell();
      this.filteredOptions[this.cursor].selected = true;
      this.render();
    }
    delete() {
      if (this.inputValue.length) {
        this.inputValue = this.inputValue.substr(0, this.inputValue.length - 1);
        this.updateFilteredOptions();
      }
    }
    updateFilteredOptions() {
      const currentHighlight = this.filteredOptions[this.cursor];
      this.filteredOptions = this.value.filter((v23) => {
        if (this.inputValue) {
          if (typeof v23.title === "string") {
            if (v23.title.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          if (typeof v23.value === "string") {
            if (v23.value.toLowerCase().includes(this.inputValue.toLowerCase())) {
              return true;
            }
          }
          return false;
        }
        return true;
      });
      const newHighlightIndex = this.filteredOptions.findIndex((v23) => v23 === currentHighlight);
      this.cursor = newHighlightIndex < 0 ? 0 : newHighlightIndex;
      this.render();
    }
    handleSpaceToggle() {
      const v23 = this.filteredOptions[this.cursor];
      if (v23.selected) {
        v23.selected = false;
        this.render();
      } else if (v23.disabled || this.value.filter((e5) => e5.selected).length >= this.maxChoices) {
        return this.bell();
      } else {
        v23.selected = true;
        this.render();
      }
    }
    handleInputChange(c23) {
      this.inputValue = this.inputValue + c23;
      this.updateFilteredOptions();
    }
    _(c23, key) {
      if (c23 === " ") {
        this.handleSpaceToggle();
      } else {
        this.handleInputChange(c23);
      }
    }
    renderInstructions() {
      if (this.instructions === undefined || this.instructions) {
        if (typeof this.instructions === "string") {
          return this.instructions;
        }
        return `
Instructions:
    ${figures.arrowUp}/${figures.arrowDown}: Highlight option
    ${figures.arrowLeft}/${figures.arrowRight}/[space]: Toggle selection
    [a,b,c]/delete: Filter choices
    enter/return: Complete answer
`;
      }
      return "";
    }
    renderCurrentInput() {
      return `
Filtered results for: ${this.inputValue ? this.inputValue : color.gray("Enter something to filter")}\n`;
    }
    renderOption(cursor32, v23, i5) {
      let title;
      if (v23.disabled)
        title = cursor32 === i5 ? color.gray().underline(v23.title) : color.strikethrough().gray(v23.title);
      else
        title = cursor32 === i5 ? color.cyan().underline(v23.title) : v23.title;
      return (v23.selected ? color.green(figures.radioOn) : figures.radioOff) + "  " + title;
    }
    renderDoneOrInstructions() {
      if (this.done) {
        return this.value.filter((e5) => e5.selected).map((v23) => v23.title).join(", ");
      }
      const output = [color.gray(this.hint), this.renderInstructions(), this.renderCurrentInput()];
      if (this.filteredOptions.length && this.filteredOptions[this.cursor].disabled) {
        output.push(color.yellow(this.warn));
      }
      return output.join(" ");
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      super.render();
      let prompt22 = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(false),
        this.renderDoneOrInstructions()
      ].join(" ");
      if (this.showMinError) {
        prompt22 += color.red(`You must select a minimum of ${this.minSelected} choices.`);
        this.showMinError = false;
      }
      prompt22 += this.renderOptions(this.filteredOptions);
      this.out.write(this.clear + prompt22);
      this.clear = clear(prompt22, this.out.columns);
    }
  }
  module.exports = AutocompleteMultiselectPrompt;
});
var require_confirm23 = __commonJS22((exports, module) => {
  var color = require_kleur3();
  var Prompt = require_prompt23();
  var { style, clear } = require_util23();
  var { erase: erase22, cursor: cursor22 } = require_src3();

  class ConfirmPrompt extends Prompt {
    constructor(opts = {}) {
      super(opts);
      this.msg = opts.message;
      this.value = opts.initial;
      this.initialValue = !!opts.initial;
      this.yesMsg = opts.yes || "yes";
      this.yesOption = opts.yesOption || "(Y/n)";
      this.noMsg = opts.no || "no";
      this.noOption = opts.noOption || "(y/N)";
      this.render();
    }
    reset() {
      this.value = this.initialValue;
      this.fire();
      this.render();
    }
    exit() {
      this.abort();
    }
    abort() {
      this.done = this.aborted = true;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    submit() {
      this.value = this.value || false;
      this.done = true;
      this.aborted = false;
      this.fire();
      this.render();
      this.out.write("\n");
      this.close();
    }
    _(c23, key) {
      if (c23.toLowerCase() === "y") {
        this.value = true;
        return this.submit();
      }
      if (c23.toLowerCase() === "n") {
        this.value = false;
        return this.submit();
      }
      return this.bell();
    }
    render() {
      if (this.closed)
        return;
      if (this.firstRender)
        this.out.write(cursor22.hide);
      else
        this.out.write(clear(this.outputText, this.out.columns));
      super.render();
      this.outputText = [
        style.symbol(this.done, this.aborted),
        color.bold(this.msg),
        style.delimiter(this.done),
        this.done ? this.value ? this.yesMsg : this.noMsg : color.gray(this.initialValue ? this.yesOption : this.noOption)
      ].join(" ");
      this.out.write(erase22.line + cursor22.to(0) + this.outputText);
    }
  }
  module.exports = ConfirmPrompt;
});
var require_elements23 = __commonJS22((exports, module) => {
  module.exports = {
    TextPrompt: require_text23(),
    SelectPrompt: require_select23(),
    TogglePrompt: require_toggle23(),
    DatePrompt: require_date23(),
    NumberPrompt: require_number23(),
    MultiselectPrompt: require_multiselect23(),
    AutocompletePrompt: require_autocomplete23(),
    AutocompleteMultiselectPrompt: require_autocompleteMultiselect23(),
    ConfirmPrompt: require_confirm23()
  };
});
var require_prompts23 = __commonJS22((exports) => {
  var $32 = exports;
  var el = require_elements23();
  var noop3 = (v23) => v23;
  function toPrompt(type2, args, opts = {}) {
    return new Promise((res, rej) => {
      const p33 = new el[type2](args);
      const onAbort = opts.onAbort || noop3;
      const onSubmit = opts.onSubmit || noop3;
      const onExit2 = opts.onExit || noop3;
      p33.on("state", args.onState || noop3);
      p33.on("submit", (x22) => res(onSubmit(x22)));
      p33.on("exit", (x22) => res(onExit2(x22)));
      p33.on("abort", (x22) => rej(onAbort(x22)));
    });
  }
  $32.text = (args) => toPrompt("TextPrompt", args);
  $32.password = (args) => {
    args.style = "password";
    return $32.text(args);
  };
  $32.invisible = (args) => {
    args.style = "invisible";
    return $32.text(args);
  };
  $32.number = (args) => toPrompt("NumberPrompt", args);
  $32.date = (args) => toPrompt("DatePrompt", args);
  $32.confirm = (args) => toPrompt("ConfirmPrompt", args);
  $32.list = (args) => {
    const sep33 = args.separator || ",";
    return toPrompt("TextPrompt", args, {
      onSubmit: (str2) => str2.split(sep33).map((s32) => s32.trim())
    });
  };
  $32.toggle = (args) => toPrompt("TogglePrompt", args);
  $32.select = (args) => toPrompt("SelectPrompt", args);
  $32.multiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("MultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  $32.autocompleteMultiselect = (args) => {
    args.choices = [].concat(args.choices || []);
    const toSelected = (items) => items.filter((item) => item.selected).map((item) => item.value);
    return toPrompt("AutocompleteMultiselectPrompt", args, {
      onAbort: toSelected,
      onSubmit: toSelected
    });
  };
  var byTitle = (input, choices) => Promise.resolve(choices.filter((item) => item.title.slice(0, input.length).toLowerCase() === input.toLowerCase()));
  $32.autocomplete = (args) => {
    args.suggest = args.suggest || byTitle;
    args.choices = [].concat(args.choices || []);
    return toPrompt("AutocompletePrompt", args);
  };
});
var require_lib19 = __commonJS22((exports, module) => {
  var prompts = require_prompts23();
  var passOn = ["suggest", "format", "onState", "validate", "onRender", "type"];
  var noop3 = () => {
  };
  async function prompt22(questions = [], { onSubmit = noop3, onCancel = noop3 } = {}) {
    const answers = {};
    const override2 = prompt22._override || {};
    questions = [].concat(questions);
    let answer, question, quit, name, type2, lastPrompt;
    const getFormattedAnswer = async (question2, answer2, skipValidation = false) => {
      if (!skipValidation && question2.validate && question2.validate(answer2) !== true) {
        return;
      }
      return question2.format ? await question2.format(answer2, answers) : answer2;
    };
    for (question of questions) {
      ({ name, type: type2 } = question);
      if (typeof type2 === "function") {
        type2 = await type2(answer, { ...answers }, question);
        question["type"] = type2;
      }
      if (!type2)
        continue;
      for (let key in question) {
        if (passOn.includes(key))
          continue;
        let value = question[key];
        question[key] = typeof value === "function" ? await value(answer, { ...answers }, lastPrompt) : value;
      }
      lastPrompt = question;
      if (typeof question.message !== "string") {
        throw new Error("prompt message is required");
      }
      ({ name, type: type2 } = question);
      if (prompts[type2] === undefined) {
        throw new Error(`prompt type (${type2}) is not defined`);
      }
      if (override2[question.name] !== undefined) {
        answer = await getFormattedAnswer(question, override2[question.name]);
        if (answer !== undefined) {
          answers[name] = answer;
          continue;
        }
      }
      try {
        answer = prompt22._injected ? getInjectedAnswer(prompt22._injected, question.initial) : await prompts[type2](question);
        answers[name] = answer = await getFormattedAnswer(question, answer, true);
        quit = await onSubmit(question, answer, answers);
      } catch (err22) {
        quit = !await onCancel(question, answers);
      }
      if (quit)
        return answers;
    }
    return answers;
  }
  function getInjectedAnswer(injected, deafultValue) {
    const answer = injected.shift();
    if (answer instanceof Error) {
      throw answer;
    }
    return answer === undefined ? deafultValue : answer;
  }
  function inject(answers) {
    prompt22._injected = (prompt22._injected || []).concat(answers);
  }
  function override(answers) {
    prompt22._override = Object.assign({}, answers);
  }
  module.exports = Object.assign(prompt22, { prompt: prompt22, prompts, inject, override });
});
var require_prompts33 = __commonJS22((exports, module) => {
  function isNodeLT(tar) {
    tar = (Array.isArray(tar) ? tar : tar.split(".")).map(Number);
    let i5 = 0, src22 = process.versions.node.split(".").map(Number);
    for (;i5 < tar.length; i5++) {
      if (src22[i5] > tar[i5])
        return false;
      if (tar[i5] > src22[i5])
        return true;
    }
    return false;
  }
  module.exports = isNodeLT("8.6.0") ? require_dist5() : require_lib19();
});
var require_spinners2 = __commonJS22((exports, module) => {
  module.exports = {
    dots: {
      interval: 80,
      frames: [
        "\u280B",
        "\u2819",
        "\u2839",
        "\u2838",
        "\u283C",
        "\u2834",
        "\u2826",
        "\u2827",
        "\u2807",
        "\u280F"
      ]
    },
    dots2: {
      interval: 80,
      frames: [
        "\u28FE",
        "\u28FD",
        "\u28FB",
        "\u28BF",
        "\u287F",
        "\u28DF",
        "\u28EF",
        "\u28F7"
      ]
    },
    dots3: {
      interval: 80,
      frames: [
        "\u280B",
        "\u2819",
        "\u281A",
        "\u281E",
        "\u2816",
        "\u2826",
        "\u2834",
        "\u2832",
        "\u2833",
        "\u2813"
      ]
    },
    dots4: {
      interval: 80,
      frames: [
        "\u2804",
        "\u2806",
        "\u2807",
        "\u280B",
        "\u2819",
        "\u2838",
        "\u2830",
        "\u2820",
        "\u2830",
        "\u2838",
        "\u2819",
        "\u280B",
        "\u2807",
        "\u2806"
      ]
    },
    dots5: {
      interval: 80,
      frames: [
        "\u280B",
        "\u2819",
        "\u281A",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u2832",
        "\u2834",
        "\u2826",
        "\u2816",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2813",
        "\u280B"
      ]
    },
    dots6: {
      interval: 80,
      frames: [
        "\u2801",
        "\u2809",
        "\u2819",
        "\u281A",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u2832",
        "\u2834",
        "\u2824",
        "\u2804",
        "\u2804",
        "\u2824",
        "\u2834",
        "\u2832",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u281A",
        "\u2819",
        "\u2809",
        "\u2801"
      ]
    },
    dots7: {
      interval: 80,
      frames: [
        "\u2808",
        "\u2809",
        "\u280B",
        "\u2813",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2816",
        "\u2826",
        "\u2824",
        "\u2820",
        "\u2820",
        "\u2824",
        "\u2826",
        "\u2816",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2813",
        "\u280B",
        "\u2809",
        "\u2808"
      ]
    },
    dots8: {
      interval: 80,
      frames: [
        "\u2801",
        "\u2801",
        "\u2809",
        "\u2819",
        "\u281A",
        "\u2812",
        "\u2802",
        "\u2802",
        "\u2812",
        "\u2832",
        "\u2834",
        "\u2824",
        "\u2804",
        "\u2804",
        "\u2824",
        "\u2820",
        "\u2820",
        "\u2824",
        "\u2826",
        "\u2816",
        "\u2812",
        "\u2810",
        "\u2810",
        "\u2812",
        "\u2813",
        "\u280B",
        "\u2809",
        "\u2808",
        "\u2808"
      ]
    },
    dots9: {
      interval: 80,
      frames: [
        "\u28B9",
        "\u28BA",
        "\u28BC",
        "\u28F8",
        "\u28C7",
        "\u2867",
        "\u2857",
        "\u284F"
      ]
    },
    dots10: {
      interval: 80,
      frames: [
        "\u2884",
        "\u2882",
        "\u2881",
        "\u2841",
        "\u2848",
        "\u2850",
        "\u2860"
      ]
    },
    dots11: {
      interval: 100,
      frames: [
        "\u2801",
        "\u2802",
        "\u2804",
        "\u2840",
        "\u2880",
        "\u2820",
        "\u2810",
        "\u2808"
      ]
    },
    dots12: {
      interval: 80,
      frames: [
        "\u2880\u2800",
        "\u2840\u2800",
        "\u2804\u2800",
        "\u2882\u2800",
        "\u2842\u2800",
        "\u2805\u2800",
        "\u2883\u2800",
        "\u2843\u2800",
        "\u280D\u2800",
        "\u288B\u2800",
        "\u284B\u2800",
        "\u280D\u2801",
        "\u288B\u2801",
        "\u284B\u2801",
        "\u280D\u2809",
        "\u280B\u2809",
        "\u280B\u2809",
        "\u2809\u2819",
        "\u2809\u2819",
        "\u2809\u2829",
        "\u2808\u2899",
        "\u2808\u2859",
        "\u2888\u2829",
        "\u2840\u2899",
        "\u2804\u2859",
        "\u2882\u2829",
        "\u2842\u2898",
        "\u2805\u2858",
        "\u2883\u2828",
        "\u2843\u2890",
        "\u280D\u2850",
        "\u288B\u2820",
        "\u284B\u2880",
        "\u280D\u2841",
        "\u288B\u2801",
        "\u284B\u2801",
        "\u280D\u2809",
        "\u280B\u2809",
        "\u280B\u2809",
        "\u2809\u2819",
        "\u2809\u2819",
        "\u2809\u2829",
        "\u2808\u2899",
        "\u2808\u2859",
        "\u2808\u2829",
        "\u2800\u2899",
        "\u2800\u2859",
        "\u2800\u2829",
        "\u2800\u2898",
        "\u2800\u2858",
        "\u2800\u2828",
        "\u2800\u2890",
        "\u2800\u2850",
        "\u2800\u2820",
        "\u2800\u2880",
        "\u2800\u2840"
      ]
    },
    dots13: {
      interval: 80,
      frames: [
        "\u28FC",
        "\u28F9",
        "\u28BB",
        "\u283F",
        "\u285F",
        "\u28CF",
        "\u28E7",
        "\u28F6"
      ]
    },
    dots8Bit: {
      interval: 80,
      frames: [
        "\u2800",
        "\u2801",
        "\u2802",
        "\u2803",
        "\u2804",
        "\u2805",
        "\u2806",
        "\u2807",
        "\u2840",
        "\u2841",
        "\u2842",
        "\u2843",
        "\u2844",
        "\u2845",
        "\u2846",
        "\u2847",
        "\u2808",
        "\u2809",
        "\u280A",
        "\u280B",
        "\u280C",
        "\u280D",
        "\u280E",
        "\u280F",
        "\u2848",
        "\u2849",
        "\u284A",
        "\u284B",
        "\u284C",
        "\u284D",
        "\u284E",
        "\u284F",
        "\u2810",
        "\u2811",
        "\u2812",
        "\u2813",
        "\u2814",
        "\u2815",
        "\u2816",
        "\u2817",
        "\u2850",
        "\u2851",
        "\u2852",
        "\u2853",
        "\u2854",
        "\u2855",
        "\u2856",
        "\u2857",
        "\u2818",
        "\u2819",
        "\u281A",
        "\u281B",
        "\u281C",
        "\u281D",
        "\u281E",
        "\u281F",
        "\u2858",
        "\u2859",
        "\u285A",
        "\u285B",
        "\u285C",
        "\u285D",
        "\u285E",
        "\u285F",
        "\u2820",
        "\u2821",
        "\u2822",
        "\u2823",
        "\u2824",
        "\u2825",
        "\u2826",
        "\u2827",
        "\u2860",
        "\u2861",
        "\u2862",
        "\u2863",
        "\u2864",
        "\u2865",
        "\u2866",
        "\u2867",
        "\u2828",
        "\u2829",
        "\u282A",
        "\u282B",
        "\u282C",
        "\u282D",
        "\u282E",
        "\u282F",
        "\u2868",
        "\u2869",
        "\u286A",
        "\u286B",
        "\u286C",
        "\u286D",
        "\u286E",
        "\u286F",
        "\u2830",
        "\u2831",
        "\u2832",
        "\u2833",
        "\u2834",
        "\u2835",
        "\u2836",
        "\u2837",
        "\u2870",
        "\u2871",
        "\u2872",
        "\u2873",
        "\u2874",
        "\u2875",
        "\u2876",
        "\u2877",
        "\u2838",
        "\u2839",
        "\u283A",
        "\u283B",
        "\u283C",
        "\u283D",
        "\u283E",
        "\u283F",
        "\u2878",
        "\u2879",
        "\u287A",
        "\u287B",
        "\u287C",
        "\u287D",
        "\u287E",
        "\u287F",
        "\u2880",
        "\u2881",
        "\u2882",
        "\u2883",
        "\u2884",
        "\u2885",
        "\u2886",
        "\u2887",
        "\u28C0",
        "\u28C1",
        "\u28C2",
        "\u28C3",
        "\u28C4",
        "\u28C5",
        "\u28C6",
        "\u28C7",
        "\u2888",
        "\u2889",
        "\u288A",
        "\u288B",
        "\u288C",
        "\u288D",
        "\u288E",
        "\u288F",
        "\u28C8",
        "\u28C9",
        "\u28CA",
        "\u28CB",
        "\u28CC",
        "\u28CD",
        "\u28CE",
        "\u28CF",
        "\u2890",
        "\u2891",
        "\u2892",
        "\u2893",
        "\u2894",
        "\u2895",
        "\u2896",
        "\u2897",
        "\u28D0",
        "\u28D1",
        "\u28D2",
        "\u28D3",
        "\u28D4",
        "\u28D5",
        "\u28D6",
        "\u28D7",
        "\u2898",
        "\u2899",
        "\u289A",
        "\u289B",
        "\u289C",
        "\u289D",
        "\u289E",
        "\u289F",
        "\u28D8",
        "\u28D9",
        "\u28DA",
        "\u28DB",
        "\u28DC",
        "\u28DD",
        "\u28DE",
        "\u28DF",
        "\u28A0",
        "\u28A1",
        "\u28A2",
        "\u28A3",
        "\u28A4",
        "\u28A5",
        "\u28A6",
        "\u28A7",
        "\u28E0",
        "\u28E1",
        "\u28E2",
        "\u28E3",
        "\u28E4",
        "\u28E5",
        "\u28E6",
        "\u28E7",
        "\u28A8",
        "\u28A9",
        "\u28AA",
        "\u28AB",
        "\u28AC",
        "\u28AD",
        "\u28AE",
        "\u28AF",
        "\u28E8",
        "\u28E9",
        "\u28EA",
        "\u28EB",
        "\u28EC",
        "\u28ED",
        "\u28EE",
        "\u28EF",
        "\u28B0",
        "\u28B1",
        "\u28B2",
        "\u28B3",
        "\u28B4",
        "\u28B5",
        "\u28B6",
        "\u28B7",
        "\u28F0",
        "\u28F1",
        "\u28F2",
        "\u28F3",
        "\u28F4",
        "\u28F5",
        "\u28F6",
        "\u28F7",
        "\u28B8",
        "\u28B9",
        "\u28BA",
        "\u28BB",
        "\u28BC",
        "\u28BD",
        "\u28BE",
        "\u28BF",
        "\u28F8",
        "\u28F9",
        "\u28FA",
        "\u28FB",
        "\u28FC",
        "\u28FD",
        "\u28FE",
        "\u28FF"
      ]
    },
    sand: {
      interval: 80,
      frames: [
        "\u2801",
        "\u2802",
        "\u2804",
        "\u2840",
        "\u2848",
        "\u2850",
        "\u2860",
        "\u28C0",
        "\u28C1",
        "\u28C2",
        "\u28C4",
        "\u28CC",
        "\u28D4",
        "\u28E4",
        "\u28E5",
        "\u28E6",
        "\u28EE",
        "\u28F6",
        "\u28F7",
        "\u28FF",
        "\u287F",
        "\u283F",
        "\u289F",
        "\u281F",
        "\u285B",
        "\u281B",
        "\u282B",
        "\u288B",
        "\u280B",
        "\u280D",
        "\u2849",
        "\u2809",
        "\u2811",
        "\u2821",
        "\u2881"
      ]
    },
    line: {
      interval: 130,
      frames: [
        "-",
        "\\",
        "|",
        "/"
      ]
    },
    line2: {
      interval: 100,
      frames: [
        "\u2802",
        "-",
        "\u2013",
        "\u2014",
        "\u2013",
        "-"
      ]
    },
    pipe: {
      interval: 100,
      frames: [
        "\u2524",
        "\u2518",
        "\u2534",
        "\u2514",
        "\u251C",
        "\u250C",
        "\u252C",
        "\u2510"
      ]
    },
    simpleDots: {
      interval: 400,
      frames: [
        ".  ",
        ".. ",
        "...",
        "   "
      ]
    },
    simpleDotsScrolling: {
      interval: 200,
      frames: [
        ".  ",
        ".. ",
        "...",
        " ..",
        "  .",
        "   "
      ]
    },
    star: {
      interval: 70,
      frames: [
        "\u2736",
        "\u2738",
        "\u2739",
        "\u273A",
        "\u2739",
        "\u2737"
      ]
    },
    star2: {
      interval: 80,
      frames: [
        "+",
        "x",
        "*"
      ]
    },
    flip: {
      interval: 70,
      frames: [
        "_",
        "_",
        "_",
        "-",
        "`",
        "`",
        "'",
        "\xB4",
        "-",
        "_",
        "_",
        "_"
      ]
    },
    hamburger: {
      interval: 100,
      frames: [
        "\u2631",
        "\u2632",
        "\u2634"
      ]
    },
    growVertical: {
      interval: 120,
      frames: [
        "\u2581",
        "\u2583",
        "\u2584",
        "\u2585",
        "\u2586",
        "\u2587",
        "\u2586",
        "\u2585",
        "\u2584",
        "\u2583"
      ]
    },
    growHorizontal: {
      interval: 120,
      frames: [
        "\u258F",
        "\u258E",
        "\u258D",
        "\u258C",
        "\u258B",
        "\u258A",
        "\u2589",
        "\u258A",
        "\u258B",
        "\u258C",
        "\u258D",
        "\u258E"
      ]
    },
    balloon: {
      interval: 140,
      frames: [
        " ",
        ".",
        "o",
        "O",
        "@",
        "*",
        " "
      ]
    },
    balloon2: {
      interval: 120,
      frames: [
        ".",
        "o",
        "O",
        "\xB0",
        "O",
        "o",
        "."
      ]
    },
    noise: {
      interval: 100,
      frames: [
        "\u2593",
        "\u2592",
        "\u2591"
      ]
    },
    bounce: {
      interval: 120,
      frames: [
        "\u2801",
        "\u2802",
        "\u2804",
        "\u2802"
      ]
    },
    boxBounce: {
      interval: 120,
      frames: [
        "\u2596",
        "\u2598",
        "\u259D",
        "\u2597"
      ]
    },
    boxBounce2: {
      interval: 100,
      frames: [
        "\u258C",
        "\u2580",
        "\u2590",
        "\u2584"
      ]
    },
    triangle: {
      interval: 50,
      frames: [
        "\u25E2",
        "\u25E3",
        "\u25E4",
        "\u25E5"
      ]
    },
    binary: {
      interval: 80,
      frames: [
        "010010",
        "001100",
        "100101",
        "111010",
        "111101",
        "010111",
        "101011",
        "111000",
        "110011",
        "110101"
      ]
    },
    arc: {
      interval: 100,
      frames: [
        "\u25DC",
        "\u25E0",
        "\u25DD",
        "\u25DE",
        "\u25E1",
        "\u25DF"
      ]
    },
    circle: {
      interval: 120,
      frames: [
        "\u25E1",
        "\u2299",
        "\u25E0"
      ]
    },
    squareCorners: {
      interval: 180,
      frames: [
        "\u25F0",
        "\u25F3",
        "\u25F2",
        "\u25F1"
      ]
    },
    circleQuarters: {
      interval: 120,
      frames: [
        "\u25F4",
        "\u25F7",
        "\u25F6",
        "\u25F5"
      ]
    },
    circleHalves: {
      interval: 50,
      frames: [
        "\u25D0",
        "\u25D3",
        "\u25D1",
        "\u25D2"
      ]
    },
    squish: {
      interval: 100,
      frames: [
        "\u256B",
        "\u256A"
      ]
    },
    toggle: {
      interval: 250,
      frames: [
        "\u22B6",
        "\u22B7"
      ]
    },
    toggle2: {
      interval: 80,
      frames: [
        "\u25AB",
        "\u25AA"
      ]
    },
    toggle3: {
      interval: 120,
      frames: [
        "\u25A1",
        "\u25A0"
      ]
    },
    toggle4: {
      interval: 100,
      frames: [
        "\u25A0",
        "\u25A1",
        "\u25AA",
        "\u25AB"
      ]
    },
    toggle5: {
      interval: 100,
      frames: [
        "\u25AE",
        "\u25AF"
      ]
    },
    toggle6: {
      interval: 300,
      frames: [
        "\u101D",
        "\u1040"
      ]
    },
    toggle7: {
      interval: 80,
      frames: [
        "\u29BE",
        "\u29BF"
      ]
    },
    toggle8: {
      interval: 100,
      frames: [
        "\u25CD",
        "\u25CC"
      ]
    },
    toggle9: {
      interval: 100,
      frames: [
        "\u25C9",
        "\u25CE"
      ]
    },
    toggle10: {
      interval: 100,
      frames: [
        "\u3282",
        "\u3280",
        "\u3281"
      ]
    },
    toggle11: {
      interval: 50,
      frames: [
        "\u29C7",
        "\u29C6"
      ]
    },
    toggle12: {
      interval: 120,
      frames: [
        "\u2617",
        "\u2616"
      ]
    },
    toggle13: {
      interval: 80,
      frames: [
        "=",
        "*",
        "-"
      ]
    },
    arrow: {
      interval: 100,
      frames: [
        "\u2190",
        "\u2196",
        "\u2191",
        "\u2197",
        "\u2192",
        "\u2198",
        "\u2193",
        "\u2199"
      ]
    },
    arrow2: {
      interval: 80,
      frames: [
        "\u2B06\uFE0F ",
        "\u2197\uFE0F ",
        "\u27A1\uFE0F ",
        "\u2198\uFE0F ",
        "\u2B07\uFE0F ",
        "\u2199\uFE0F ",
        "\u2B05\uFE0F ",
        "\u2196\uFE0F "
      ]
    },
    arrow3: {
      interval: 120,
      frames: [
        "\u25B9\u25B9\u25B9\u25B9\u25B9",
        "\u25B8\u25B9\u25B9\u25B9\u25B9",
        "\u25B9\u25B8\u25B9\u25B9\u25B9",
        "\u25B9\u25B9\u25B8\u25B9\u25B9",
        "\u25B9\u25B9\u25B9\u25B8\u25B9",
        "\u25B9\u25B9\u25B9\u25B9\u25B8"
      ]
    },
    bouncingBar: {
      interval: 80,
      frames: [
        "[    ]",
        "[=   ]",
        "[==  ]",
        "[=== ]",
        "[====]",
        "[ ===]",
        "[  ==]",
        "[   =]",
        "[    ]",
        "[   =]",
        "[  ==]",
        "[ ===]",
        "[====]",
        "[=== ]",
        "[==  ]",
        "[=   ]"
      ]
    },
    bouncingBall: {
      interval: 80,
      frames: [
        "( \u25CF    )",
        "(  \u25CF   )",
        "(   \u25CF  )",
        "(    \u25CF )",
        "(     \u25CF)",
        "(    \u25CF )",
        "(   \u25CF  )",
        "(  \u25CF   )",
        "( \u25CF    )",
        "(\u25CF     )"
      ]
    },
    smiley: {
      interval: 200,
      frames: [
        "\uD83D\uDE04 ",
        "\uD83D\uDE1D "
      ]
    },
    monkey: {
      interval: 300,
      frames: [
        "\uD83D\uDE48 ",
        "\uD83D\uDE48 ",
        "\uD83D\uDE49 ",
        "\uD83D\uDE4A "
      ]
    },
    hearts: {
      interval: 100,
      frames: [
        "\uD83D\uDC9B ",
        "\uD83D\uDC99 ",
        "\uD83D\uDC9C ",
        "\uD83D\uDC9A ",
        "\u2764\uFE0F "
      ]
    },
    clock: {
      interval: 100,
      frames: [
        "\uD83D\uDD5B ",
        "\uD83D\uDD50 ",
        "\uD83D\uDD51 ",
        "\uD83D\uDD52 ",
        "\uD83D\uDD53 ",
        "\uD83D\uDD54 ",
        "\uD83D\uDD55 ",
        "\uD83D\uDD56 ",
        "\uD83D\uDD57 ",
        "\uD83D\uDD58 ",
        "\uD83D\uDD59 ",
        "\uD83D\uDD5A "
      ]
    },
    earth: {
      interval: 180,
      frames: [
        "\uD83C\uDF0D ",
        "\uD83C\uDF0E ",
        "\uD83C\uDF0F "
      ]
    },
    material: {
      interval: 17,
      frames: [
        "\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
        "\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
        "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581"
      ]
    },
    moon: {
      interval: 80,
      frames: [
        "\uD83C\uDF11 ",
        "\uD83C\uDF12 ",
        "\uD83C\uDF13 ",
        "\uD83C\uDF14 ",
        "\uD83C\uDF15 ",
        "\uD83C\uDF16 ",
        "\uD83C\uDF17 ",
        "\uD83C\uDF18 "
      ]
    },
    runner: {
      interval: 140,
      frames: [
        "\uD83D\uDEB6 ",
        "\uD83C\uDFC3 "
      ]
    },
    pong: {
      interval: 80,
      frames: [
        "\u2590\u2802       \u258C",
        "\u2590\u2808       \u258C",
        "\u2590 \u2802      \u258C",
        "\u2590 \u2820      \u258C",
        "\u2590  \u2840     \u258C",
        "\u2590  \u2820     \u258C",
        "\u2590   \u2802    \u258C",
        "\u2590   \u2808    \u258C",
        "\u2590    \u2802   \u258C",
        "\u2590    \u2820   \u258C",
        "\u2590     \u2840  \u258C",
        "\u2590     \u2820  \u258C",
        "\u2590      \u2802 \u258C",
        "\u2590      \u2808 \u258C",
        "\u2590       \u2802\u258C",
        "\u2590       \u2820\u258C",
        "\u2590       \u2840\u258C",
        "\u2590      \u2820 \u258C",
        "\u2590      \u2802 \u258C",
        "\u2590     \u2808  \u258C",
        "\u2590     \u2802  \u258C",
        "\u2590    \u2820   \u258C",
        "\u2590    \u2840   \u258C",
        "\u2590   \u2820    \u258C",
        "\u2590   \u2802    \u258C",
        "\u2590  \u2808     \u258C",
        "\u2590  \u2802     \u258C",
        "\u2590 \u2820      \u258C",
        "\u2590 \u2840      \u258C",
        "\u2590\u2820       \u258C"
      ]
    },
    shark: {
      interval: 120,
      frames: [
        "\u2590|\\____________\u258C",
        "\u2590_|\\___________\u258C",
        "\u2590__|\\__________\u258C",
        "\u2590___|\\_________\u258C",
        "\u2590____|\\________\u258C",
        "\u2590_____|\\_______\u258C",
        "\u2590______|\\______\u258C",
        "\u2590_______|\\_____\u258C",
        "\u2590________|\\____\u258C",
        "\u2590_________|\\___\u258C",
        "\u2590__________|\\__\u258C",
        "\u2590___________|\\_\u258C",
        "\u2590____________|\\\u258C",
        "\u2590____________/|\u258C",
        "\u2590___________/|_\u258C",
        "\u2590__________/|__\u258C",
        "\u2590_________/|___\u258C",
        "\u2590________/|____\u258C",
        "\u2590_______/|_____\u258C",
        "\u2590______/|______\u258C",
        "\u2590_____/|_______\u258C",
        "\u2590____/|________\u258C",
        "\u2590___/|_________\u258C",
        "\u2590__/|__________\u258C",
        "\u2590_/|___________\u258C",
        "\u2590/|____________\u258C"
      ]
    },
    dqpb: {
      interval: 100,
      frames: [
        "d",
        "q",
        "p",
        "b"
      ]
    },
    weather: {
      interval: 100,
      frames: [
        "\u2600\uFE0F ",
        "\u2600\uFE0F ",
        "\u2600\uFE0F ",
        "\uD83C\uDF24 ",
        "\u26C5\uFE0F ",
        "\uD83C\uDF25 ",
        "\u2601\uFE0F ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\u26C8 ",
        "\uD83C\uDF28 ",
        "\uD83C\uDF27 ",
        "\uD83C\uDF28 ",
        "\u2601\uFE0F ",
        "\uD83C\uDF25 ",
        "\u26C5\uFE0F ",
        "\uD83C\uDF24 ",
        "\u2600\uFE0F ",
        "\u2600\uFE0F "
      ]
    },
    christmas: {
      interval: 400,
      frames: [
        "\uD83C\uDF32",
        "\uD83C\uDF84"
      ]
    },
    grenade: {
      interval: 80,
      frames: [
        "\u060C  ",
        "\u2032  ",
        " \xB4 ",
        " \u203E ",
        "  \u2E0C",
        "  \u2E0A",
        "  |",
        "  \u204E",
        "  \u2055",
        " \u0DF4 ",
        "  \u2053",
        "   ",
        "   ",
        "   "
      ]
    },
    point: {
      interval: 125,
      frames: [
        "\u2219\u2219\u2219",
        "\u25CF\u2219\u2219",
        "\u2219\u25CF\u2219",
        "\u2219\u2219\u25CF",
        "\u2219\u2219\u2219"
      ]
    },
    layer: {
      interval: 150,
      frames: [
        "-",
        "=",
        "\u2261"
      ]
    },
    betaWave: {
      interval: 80,
      frames: [
        "\u03C1\u03B2\u03B2\u03B2\u03B2\u03B2\u03B2",
        "\u03B2\u03C1\u03B2\u03B2\u03B2\u03B2\u03B2",
        "\u03B2\u03B2\u03C1\u03B2\u03B2\u03B2\u03B2",
        "\u03B2\u03B2\u03B2\u03C1\u03B2\u03B2\u03B2",
        "\u03B2\u03B2\u03B2\u03B2\u03C1\u03B2\u03B2",
        "\u03B2\u03B2\u03B2\u03B2\u03B2\u03C1\u03B2",
        "\u03B2\u03B2\u03B2\u03B2\u03B2\u03B2\u03C1"
      ]
    },
    fingerDance: {
      interval: 160,
      frames: [
        "\uD83E\uDD18 ",
        "\uD83E\uDD1F ",
        "\uD83D\uDD96 ",
        "\u270B ",
        "\uD83E\uDD1A ",
        "\uD83D\uDC46 "
      ]
    },
    fistBump: {
      interval: 80,
      frames: [
        "\uD83E\uDD1C\u3000\u3000\u3000\u3000\uD83E\uDD1B ",
        "\uD83E\uDD1C\u3000\u3000\u3000\u3000\uD83E\uDD1B ",
        "\uD83E\uDD1C\u3000\u3000\u3000\u3000\uD83E\uDD1B ",
        "\u3000\uD83E\uDD1C\u3000\u3000\uD83E\uDD1B\u3000 ",
        "\u3000\u3000\uD83E\uDD1C\uD83E\uDD1B\u3000\u3000 ",
        "\u3000\uD83E\uDD1C\u2728\uD83E\uDD1B\u3000\u3000 ",
        "\uD83E\uDD1C\u3000\u2728\u3000\uD83E\uDD1B\u3000 "
      ]
    },
    soccerHeader: {
      interval: 80,
      frames: [
        " \uD83E\uDDD1\u26BD\uFE0F       \uD83E\uDDD1 ",
        "\uD83E\uDDD1  \u26BD\uFE0F      \uD83E\uDDD1 ",
        "\uD83E\uDDD1   \u26BD\uFE0F     \uD83E\uDDD1 ",
        "\uD83E\uDDD1    \u26BD\uFE0F    \uD83E\uDDD1 ",
        "\uD83E\uDDD1     \u26BD\uFE0F   \uD83E\uDDD1 ",
        "\uD83E\uDDD1      \u26BD\uFE0F  \uD83E\uDDD1 ",
        "\uD83E\uDDD1       \u26BD\uFE0F\uD83E\uDDD1  ",
        "\uD83E\uDDD1      \u26BD\uFE0F  \uD83E\uDDD1 ",
        "\uD83E\uDDD1     \u26BD\uFE0F   \uD83E\uDDD1 ",
        "\uD83E\uDDD1    \u26BD\uFE0F    \uD83E\uDDD1 ",
        "\uD83E\uDDD1   \u26BD\uFE0F     \uD83E\uDDD1 ",
        "\uD83E\uDDD1  \u26BD\uFE0F      \uD83E\uDDD1 "
      ]
    },
    mindblown: {
      interval: 160,
      frames: [
        "\uD83D\uDE10 ",
        "\uD83D\uDE10 ",
        "\uD83D\uDE2E ",
        "\uD83D\uDE2E ",
        "\uD83D\uDE26 ",
        "\uD83D\uDE26 ",
        "\uD83D\uDE27 ",
        "\uD83D\uDE27 ",
        "\uD83E\uDD2F ",
        "\uD83D\uDCA5 ",
        "\u2728 ",
        "\u3000 ",
        "\u3000 ",
        "\u3000 "
      ]
    },
    speaker: {
      interval: 160,
      frames: [
        "\uD83D\uDD08 ",
        "\uD83D\uDD09 ",
        "\uD83D\uDD0A ",
        "\uD83D\uDD09 "
      ]
    },
    orangePulse: {
      interval: 100,
      frames: [
        "\uD83D\uDD38 ",
        "\uD83D\uDD36 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDD36 "
      ]
    },
    bluePulse: {
      interval: 100,
      frames: [
        "\uD83D\uDD39 ",
        "\uD83D\uDD37 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD37 "
      ]
    },
    orangeBluePulse: {
      interval: 100,
      frames: [
        "\uD83D\uDD38 ",
        "\uD83D\uDD36 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDFE0 ",
        "\uD83D\uDD36 ",
        "\uD83D\uDD39 ",
        "\uD83D\uDD37 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD35 ",
        "\uD83D\uDD37 "
      ]
    },
    timeTravel: {
      interval: 100,
      frames: [
        "\uD83D\uDD5B ",
        "\uD83D\uDD5A ",
        "\uD83D\uDD59 ",
        "\uD83D\uDD58 ",
        "\uD83D\uDD57 ",
        "\uD83D\uDD56 ",
        "\uD83D\uDD55 ",
        "\uD83D\uDD54 ",
        "\uD83D\uDD53 ",
        "\uD83D\uDD52 ",
        "\uD83D\uDD51 ",
        "\uD83D\uDD50 "
      ]
    },
    aesthetic: {
      interval: 80,
      frames: [
        "\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B1\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B1\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B1\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0\u25B1",
        "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0",
        "\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1\u25B1"
      ]
    },
    dwarfFortress: {
      interval: 80,
      frames: [
        " \u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2593\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2593\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2592\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2592\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2591\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A\u2591\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "\u263A \u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2593\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2593\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2592\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2592\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2591\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A\u2591\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u263A \u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2593\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2593\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2592\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2592\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2591\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A\u2591\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u263A \u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2593\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2593\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2592\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2592\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2591\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A\u2591\u2588\u2588\xA3\xA3\xA3  ",
        "   \u263A \u2588\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2588\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2588\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2593\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2593\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2592\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2592\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2591\u2588\xA3\xA3\xA3  ",
        "    \u263A\u2591\u2588\xA3\xA3\xA3  ",
        "    \u263A \u2588\xA3\xA3\xA3  ",
        "     \u263A\u2588\xA3\xA3\xA3  ",
        "     \u263A\u2588\xA3\xA3\xA3  ",
        "     \u263A\u2593\xA3\xA3\xA3  ",
        "     \u263A\u2593\xA3\xA3\xA3  ",
        "     \u263A\u2592\xA3\xA3\xA3  ",
        "     \u263A\u2592\xA3\xA3\xA3  ",
        "     \u263A\u2591\xA3\xA3\xA3  ",
        "     \u263A\u2591\xA3\xA3\xA3  ",
        "     \u263A \xA3\xA3\xA3  ",
        "      \u263A\xA3\xA3\xA3  ",
        "      \u263A\xA3\xA3\xA3  ",
        "      \u263A\u2593\xA3\xA3  ",
        "      \u263A\u2593\xA3\xA3  ",
        "      \u263A\u2592\xA3\xA3  ",
        "      \u263A\u2592\xA3\xA3  ",
        "      \u263A\u2591\xA3\xA3  ",
        "      \u263A\u2591\xA3\xA3  ",
        "      \u263A \xA3\xA3  ",
        "       \u263A\xA3\xA3  ",
        "       \u263A\xA3\xA3  ",
        "       \u263A\u2593\xA3  ",
        "       \u263A\u2593\xA3  ",
        "       \u263A\u2592\xA3  ",
        "       \u263A\u2592\xA3  ",
        "       \u263A\u2591\xA3  ",
        "       \u263A\u2591\xA3  ",
        "       \u263A \xA3  ",
        "        \u263A\xA3  ",
        "        \u263A\xA3  ",
        "        \u263A\u2593  ",
        "        \u263A\u2593  ",
        "        \u263A\u2592  ",
        "        \u263A\u2592  ",
        "        \u263A\u2591  ",
        "        \u263A\u2591  ",
        "        \u263A   ",
        "        \u263A  &",
        "        \u263A \u263C&",
        "       \u263A \u263C &",
        "       \u263A\u263C  &",
        "      \u263A\u263C  & ",
        "      \u203C   & ",
        "     \u263A   &  ",
        "    \u203C    &  ",
        "   \u263A    &   ",
        "  \u203C     &   ",
        " \u263A     &    ",
        "\u203C      &    ",
        "      &     ",
        "      &     ",
        "     &   \u2591  ",
        "     &   \u2592  ",
        "    &    \u2593  ",
        "    &    \xA3  ",
        "   &    \u2591\xA3  ",
        "   &    \u2592\xA3  ",
        "  &     \u2593\xA3  ",
        "  &     \xA3\xA3  ",
        " &     \u2591\xA3\xA3  ",
        " &     \u2592\xA3\xA3  ",
        "&      \u2593\xA3\xA3  ",
        "&      \xA3\xA3\xA3  ",
        "      \u2591\xA3\xA3\xA3  ",
        "      \u2592\xA3\xA3\xA3  ",
        "      \u2593\xA3\xA3\xA3  ",
        "      \u2588\xA3\xA3\xA3  ",
        "     \u2591\u2588\xA3\xA3\xA3  ",
        "     \u2592\u2588\xA3\xA3\xA3  ",
        "     \u2593\u2588\xA3\xA3\xA3  ",
        "     \u2588\u2588\xA3\xA3\xA3  ",
        "    \u2591\u2588\u2588\xA3\xA3\xA3  ",
        "    \u2592\u2588\u2588\xA3\xA3\xA3  ",
        "    \u2593\u2588\u2588\xA3\xA3\xA3  ",
        "    \u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2591\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2592\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2593\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "   \u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2591\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2592\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2593\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        "  \u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2591\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2592\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2593\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  ",
        " \u2588\u2588\u2588\u2588\u2588\u2588\xA3\xA3\xA3  "
      ]
    }
  };
});
var require_cli_spinners2 = __commonJS22((exports, module) => {
  var spinners = Object.assign({}, require_spinners2());
  var spinnersList = Object.keys(spinners);
  Object.defineProperty(spinners, "random", {
    get() {
      const randomIndex = Math.floor(Math.random() * spinnersList.length);
      const spinnerName = spinnersList[randomIndex];
      return spinners[spinnerName];
    }
  });
  module.exports = spinners;
});
var require22 = __tinyexec_cr2(import.meta.url);
var St2 = Object.create;
var $5 = Object.defineProperty;
var kt2 = Object.getOwnPropertyDescriptor;
var Tt2 = Object.getOwnPropertyNames;
var At2 = Object.getPrototypeOf;
var Rt2 = Object.prototype.hasOwnProperty;
var h6 = /* @__PURE__ */ ((t5) => typeof require22 < "u" ? require22 : typeof Proxy < "u" ? new Proxy(t5, {
  get: (e5, n5) => (typeof require22 < "u" ? require22 : e5)[n5]
}) : t5)(function(t5) {
  if (typeof require22 < "u")
    return require22.apply(this, arguments);
  throw Error('Dynamic require of "' + t5 + '" is not supported');
});
var l6 = (t5, e5) => () => (e5 || t5((e5 = { exports: {} }).exports, e5), e5.exports);
var $t2 = (t5, e5, n5, r23) => {
  if (e5 && typeof e5 == "object" || typeof e5 == "function")
    for (let s32 of Tt2(e5))
      !Rt2.call(t5, s32) && s32 !== n5 && $5(t5, s32, { get: () => e5[s32], enumerable: !(r23 = kt2(e5, s32)) || r23.enumerable });
  return t5;
};
var Nt2 = (t5, e5, n5) => (n5 = t5 != null ? St2(At2(t5)) : {}, $t2(e5 || !t5 || !t5.__esModule ? $5(n5, "default", { value: t5, enumerable: true }) : n5, t5));
var W5 = l6((Se, H23) => {
  H23.exports = z23;
  z23.sync = Wt;
  var j23 = h6("fs");
  function Ht(t5, e5) {
    var n5 = e5.pathExt !== undefined ? e5.pathExt : process.env.PATHEXT;
    if (!n5 || (n5 = n5.split(";"), n5.indexOf("") !== -1))
      return true;
    for (var r23 = 0;r23 < n5.length; r23++) {
      var s32 = n5[r23].toLowerCase();
      if (s32 && t5.substr(-s32.length).toLowerCase() === s32)
        return true;
    }
    return false;
  }
  function F3(t5, e5, n5) {
    return !t5.isSymbolicLink() && !t5.isFile() ? false : Ht(e5, n5);
  }
  function z23(t5, e5, n5) {
    j23.stat(t5, function(r23, s32) {
      n5(r23, r23 ? false : F3(s32, t5, e5));
    });
  }
  function Wt(t5, e5) {
    return F3(j23.statSync(t5), t5, e5);
  }
});
var X5 = l6((ke, B3) => {
  B3.exports = K23;
  K23.sync = Dt;
  var D3 = h6("fs");
  function K23(t5, e5, n5) {
    D3.stat(t5, function(r23, s32) {
      n5(r23, r23 ? false : M23(s32, e5));
    });
  }
  function Dt(t5, e5) {
    return M23(D3.statSync(t5), e5);
  }
  function M23(t5, e5) {
    return t5.isFile() && Kt(t5, e5);
  }
  function Kt(t5, e5) {
    var { mode: n5, uid: r23, gid: s32 } = t5, o5 = e5.uid !== undefined ? e5.uid : process.getuid && process.getuid(), i5 = e5.gid !== undefined ? e5.gid : process.getgid && process.getgid(), a5 = parseInt("100", 8), c23 = parseInt("010", 8), u5 = parseInt("001", 8), f23 = a5 | c23, p33 = n5 & u5 || n5 & c23 && s32 === i5 || n5 & a5 && r23 === o5 || n5 & f23 && o5 === 0;
    return p33;
  }
});
var U5 = l6((Ae, G23) => {
  var Te = h6("fs"), v23;
  process.platform === "win32" || global.TESTING_WINDOWS ? v23 = W5() : v23 = X5();
  G23.exports = y3;
  y3.sync = Mt;
  function y3(t5, e5, n5) {
    if (typeof e5 == "function" && (n5 = e5, e5 = {}), !n5) {
      if (typeof Promise != "function")
        throw new TypeError("callback not provided");
      return new Promise(function(r23, s32) {
        y3(t5, e5 || {}, function(o5, i5) {
          o5 ? s32(o5) : r23(i5);
        });
      });
    }
    v23(t5, e5 || {}, function(r23, s32) {
      r23 && (r23.code === "EACCES" || e5 && e5.ignoreErrors) && (r23 = null, s32 = false), n5(r23, s32);
    });
  }
  function Mt(t5, e5) {
    try {
      return v23.sync(t5, e5 || {});
    } catch (n5) {
      if (e5 && e5.ignoreErrors || n5.code === "EACCES")
        return false;
      throw n5;
    }
  }
});
var et2 = l6((Re, tt) => {
  var g23 = process.platform === "win32" || process.env.OSTYPE === "cygwin" || process.env.OSTYPE === "msys", Y23 = h6("path"), Bt = g23 ? ";" : ":", V23 = U5(), J23 = (t5) => Object.assign(new Error(`not found: ${t5}`), { code: "ENOENT" }), Q23 = (t5, e5) => {
    let n5 = e5.colon || Bt, r23 = t5.match(/\//) || g23 && t5.match(/\\/) ? [""] : [
      ...g23 ? [process.cwd()] : [],
      ...(e5.path || "/Users/chrisbreuer/Code/stacks/storage/framework/core/cli/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/framework/core/cli/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/framework/core/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/framework/node_modules/.bin:/Users/chrisbreuer/Code/stacks/storage/node_modules/.bin:/Users/chrisbreuer/Code/stacks/node_modules/.bin:/Users/chrisbreuer/Code/node_modules/.bin:/Users/chrisbreuer/node_modules/.bin:/Users/node_modules/.bin:/node_modules/.bin:/Users/chrisbreuer/.bun/bin:/Users/chrisbreuer/.pkgx/libpng.org/v1.6.43/bin:/Users/chrisbreuer/.pkgx/freedesktop.org/pkg-config/v0.29.2/bin:/Users/chrisbreuer/.pkgx/sourceware.org/bzip2/v1.0.8/bin:/Users/chrisbreuer/.pkgx/libexpat.github.io/v2.6.2/bin:/Users/chrisbreuer/.pkgx/tukaani.org/xz/v5.6.1/bin:/Users/chrisbreuer/.pkgx/sqlite.org/v3.45.2/bin:/Users/chrisbreuer/.pkgx/gnu.org/readline/v8.2.0/bin:/Users/chrisbreuer/.pkgx/invisible-island.net/ncurses/v6.4.0/bin:/Users/chrisbreuer/.pkgx/tcl-lang.org/v8.6.14/bin:/Users/chrisbreuer/.pkgx/gnome.org/libxml2/v2.12.6/bin:/Users/chrisbreuer/.pkgx/pkgx.sh/v1.1.6/bin:/Users/chrisbreuer/.pkgx/openssl.org/v1.1.1w/bin:/Users/chrisbreuer/.pkgx/python.org/v3.11.9/bin:/Users/chrisbreuer/.pkgx/gnu.org/gettext/v0.21.1/bin:/Users/chrisbreuer/.pkgx/curl.se/v8.6.0/bin:/Users/chrisbreuer/.pkgx/perl.org/v5.38.2/bin:/Users/chrisbreuer/.pkgx/aws.amazon.com/cli/v2.17.13/bin:/Users/chrisbreuer/.pkgx/bun.sh/v1.1.33/bin:/Users/chrisbreuer/.pkgx/dns.lookup.dog/v0.1.0/bin:/Users/chrisbreuer/.pkgx/httpie.io/v3.2.2/bin:/Users/chrisbreuer/.pkgx/info-zip.org/zip/v3.0.0/bin:/Users/chrisbreuer/.pkgx/info-zip.org/unzip/v6.0.0/bin:/Users/chrisbreuer/.pkgx/mailpit.axllent.org/v1.15.0/bin:/Users/chrisbreuer/.pkgx/redis.io/v7.4.0/bin:/Users/chrisbreuer/.pkgx/git-scm.org/v2.44.0/bin:.:node_modules/.bin:vendor/bin:/opt/homebrew/bin:/Users/chrisbreuer/.composer/vendor/bin:/Users/chrisbreuer/.dotfiles/bin:/opt/homebrew/bin:/opt/homebrew/sbin:/usr/local/bin:/System/Cryptexes/App/usr/bin:/usr/bin:/bin:/usr/sbin:/sbin:/var/run/com.apple.security.cryptexd/codex.system/bootstrap/usr/local/bin:/var/run/com.apple.security.cryptexd/codex.system/bootstrap/usr/bin:/var/run/com.apple.security.cryptexd/codex.system/bootstrap/usr/appleinternal/bin:/usr/local/share/cputil-osx-x64_v112/cputil-osx-x64:/Users/chrisbreuer/.bun/bin:.:node_modules/.bin:vendor/bin:/Users/chrisbreuer/.composer/vendor/bin:/Users/chrisbreuer/.dotfiles/bin:/Users/chrisbreuer/.local/bin:/Users/chrisbreuer/Library/Application Support/JetBrains/Toolbox/scripts:/Users/chrisbreuer/Library/Application Support/JetBrains/Toolbox/scripts").split(n5)
    ], s32 = g23 ? e5.pathExt || process.env.PATHEXT || ".EXE;.CMD;.BAT;.COM" : "", o5 = g23 ? s32.split(n5) : [""];
    return g23 && t5.indexOf(".") !== -1 && o5[0] !== "" && o5.unshift(""), {
      pathEnv: r23,
      pathExt: o5,
      pathExtExe: s32
    };
  }, Z23 = (t5, e5, n5) => {
    typeof e5 == "function" && (n5 = e5, e5 = {}), e5 || (e5 = {});
    let { pathEnv: r23, pathExt: s32, pathExtExe: o5 } = Q23(t5, e5), i5 = [], a5 = (u5) => new Promise((f23, p33) => {
      if (u5 === r23.length)
        return e5.all && i5.length ? f23(i5) : p33(J23(t5));
      let d5 = r23[u5], w23 = /^".*"$/.test(d5) ? d5.slice(1, -1) : d5, m23 = Y23.join(w23, t5), b23 = !w23 && /^\.[\\\/]/.test(t5) ? t5.slice(0, 2) + m23 : m23;
      f23(c23(b23, u5, 0));
    }), c23 = (u5, f23, p33) => new Promise((d5, w23) => {
      if (p33 === s32.length)
        return d5(a5(f23 + 1));
      let m23 = s32[p33];
      V23(u5 + m23, { pathExt: o5 }, (b23, Ot) => {
        if (!b23 && Ot)
          if (e5.all)
            i5.push(u5 + m23);
          else
            return d5(u5 + m23);
        return d5(c23(u5, f23, p33 + 1));
      });
    });
    return n5 ? a5(0).then((u5) => n5(null, u5), n5) : a5(0);
  }, Xt = (t5, e5) => {
    e5 = e5 || {};
    let { pathEnv: n5, pathExt: r23, pathExtExe: s32 } = Q23(t5, e5), o5 = [];
    for (let i5 = 0;i5 < n5.length; i5++) {
      let a5 = n5[i5], c23 = /^".*"$/.test(a5) ? a5.slice(1, -1) : a5, u5 = Y23.join(c23, t5), f23 = !c23 && /^\.[\\\/]/.test(t5) ? t5.slice(0, 2) + u5 : u5;
      for (let p33 = 0;p33 < r23.length; p33++) {
        let d5 = f23 + r23[p33];
        try {
          if (V23.sync(d5, { pathExt: s32 }))
            if (e5.all)
              o5.push(d5);
            else
              return d5;
        } catch {
        }
      }
    }
    if (e5.all && o5.length)
      return o5;
    if (e5.nothrow)
      return null;
    throw J23(t5);
  };
  tt.exports = Z23;
  Z23.sync = Xt;
});
var rt2 = l6(($e, _23) => {
  var nt = (t5 = {}) => {
    let e5 = t5.env || process.env;
    return (t5.platform || process.platform) !== "win32" ? "PATH" : Object.keys(e5).reverse().find((r23) => r23.toUpperCase() === "PATH") || "Path";
  };
  _23.exports = nt;
  _23.exports.default = nt;
});
var ct3 = l6((Ne, it) => {
  var st = h6("path"), Gt = et2(), Ut = rt2();
  function ot(t5, e5) {
    let n5 = t5.options.env || process.env, r23 = process.cwd(), s32 = t5.options.cwd != null, o5 = s32 && process.chdir !== undefined && !process.chdir.disabled;
    if (o5)
      try {
        process.chdir(t5.options.cwd);
      } catch {
      }
    let i5;
    try {
      i5 = Gt.sync(t5.command, {
        path: n5[Ut({ env: n5 })],
        pathExt: e5 ? st.delimiter : undefined
      });
    } catch {
    } finally {
      o5 && process.chdir(r23);
    }
    return i5 && (i5 = st.resolve(s32 ? t5.options.cwd : "", i5)), i5;
  }
  function Yt(t5) {
    return ot(t5) || ot(t5, true);
  }
  it.exports = Yt;
});
var ut2 = l6((qe, P23) => {
  var C4 = /([()\][%!^"`<>&|;, *?])/g;
  function Vt(t5) {
    return t5 = t5.replace(C4, "^$1"), t5;
  }
  function Jt(t5, e5) {
    return t5 = `${t5}`, t5 = t5.replace(/(\\*)"/g, '$1$1\\"'), t5 = t5.replace(/(\\*)$/, "$1$1"), t5 = `"${t5}"`, t5 = t5.replace(C4, "^$1"), e5 && (t5 = t5.replace(C4, "^$1")), t5;
  }
  P23.exports.command = Vt;
  P23.exports.argument = Jt;
});
var lt2 = l6((Ie, at) => {
  at.exports = /^#!(.*)/;
});
var dt2 = l6((Le, pt) => {
  var Qt = lt2();
  pt.exports = (t5 = "") => {
    let e5 = t5.match(Qt);
    if (!e5)
      return null;
    let [n5, r23] = e5[0].replace(/#! ?/, "").split(" "), s32 = n5.split("/").pop();
    return s32 === "env" ? r23 : r23 ? `${s32} ${r23}` : s32;
  };
});
var ht2 = l6((je, ft) => {
  var O3 = h6("fs"), Zt = dt2();
  function te(t5) {
    let n5 = Buffer.alloc(150), r23;
    try {
      r23 = O3.openSync(t5, "r"), O3.readSync(r23, n5, 0, 150, 0), O3.closeSync(r23);
    } catch {
    }
    return Zt(n5.toString());
  }
  ft.exports = te;
});
var wt2 = l6((Fe, Et) => {
  var ee = h6("path"), mt = ct3(), gt = ut2(), ne = ht2(), re = process.platform === "win32", se = /\.(?:com|exe)$/i, oe = /node_modules[\\/].bin[\\/][^\\/]+\.cmd$/i;
  function ie(t5) {
    t5.file = mt(t5);
    let e5 = t5.file && ne(t5.file);
    return e5 ? (t5.args.unshift(t5.file), t5.command = e5, mt(t5)) : t5.file;
  }
  function ce2(t5) {
    if (!re)
      return t5;
    let e5 = ie(t5), n5 = !se.test(e5);
    if (t5.options.forceShell || n5) {
      let r23 = oe.test(e5);
      t5.command = ee.normalize(t5.command), t5.command = gt.command(t5.command), t5.args = t5.args.map((o5) => gt.argument(o5, r23));
      let s32 = [t5.command].concat(t5.args).join(" ");
      t5.args = ["/d", "/s", "/c", `"${s32}"`], t5.command = process.env.comspec || "cmd.exe", t5.options.windowsVerbatimArguments = true;
    }
    return t5;
  }
  function ue(t5, e5, n5) {
    e5 && !Array.isArray(e5) && (n5 = e5, e5 = null), e5 = e5 ? e5.slice(0) : [], n5 = Object.assign({}, n5);
    let r23 = {
      command: t5,
      args: e5,
      options: n5,
      file: undefined,
      original: {
        command: t5,
        args: e5
      }
    };
    return n5.shell ? r23 : ce2(r23);
  }
  Et.exports = ue;
});
var bt3 = l6((ze, vt) => {
  var S2 = process.platform === "win32";
  function k5(t5, e5) {
    return Object.assign(new Error(`${e5} ${t5.command} ENOENT`), {
      code: "ENOENT",
      errno: "ENOENT",
      syscall: `${e5} ${t5.command}`,
      path: t5.command,
      spawnargs: t5.args
    });
  }
  function ae2(t5, e5) {
    if (!S2)
      return;
    let n5 = t5.emit;
    t5.emit = function(r23, s32) {
      if (r23 === "exit") {
        let o5 = xt(s32, e5, "spawn");
        if (o5)
          return n5.call(t5, "error", o5);
      }
      return n5.apply(t5, arguments);
    };
  }
  function xt(t5, e5) {
    return S2 && t5 === 1 && !e5.file ? k5(e5.original, "spawn") : null;
  }
  function le(t5, e5) {
    return S2 && t5 === 1 && !e5.file ? k5(e5.original, "spawnSync") : null;
  }
  vt.exports = {
    hookChildProcess: ae2,
    verifyENOENT: xt,
    verifyENOENTSync: le,
    notFoundError: k5
  };
});
var Ct2 = l6((He, E3) => {
  var yt = h6("child_process"), T23 = wt2(), A3 = bt3();
  function _t2(t5, e5, n5) {
    let r23 = T23(t5, e5, n5), s32 = yt.spawn(r23.command, r23.args, r23.options);
    return A3.hookChildProcess(s32, r23), s32;
  }
  function pe(t5, e5, n5) {
    let r23 = T23(t5, e5, n5), s32 = yt.spawnSync(r23.command, r23.args, r23.options);
    return s32.error = s32.error || A3.verifyENOENTSync(s32.status, r23), s32;
  }
  E3.exports = _t2;
  E3.exports.spawn = _t2;
  E3.exports.sync = pe;
  E3.exports._parse = T23;
  E3.exports._enoent = A3;
});
var Pt2 = Nt2(Ct2(), 1);
var processArgs3 = process.argv;
var platformInfo3 = `${process.platform}-${process.arch} node-${process.version}`;
var exports_config3 = {};
__export5(exports_config3, {
  ui: () => ui23,
  team: () => team23,
  storage: () => storage23,
  services: () => services23,
  security: () => security23,
  searchEngine: () => searchEngine3,
  saas: () => saas23,
  queue: () => queue33,
  ports: () => ports23,
  payment: () => payment3,
  overrides: () => overrides_default3,
  notification: () => notification3,
  logging: () => logging23,
  localUrl: () => localUrl3,
  library: () => library23,
  hashing: () => hashing23,
  git: () => git23,
  errors: () => errors23,
  email: () => email23,
  docs: () => docs23,
  dns: () => dns23,
  determineAppEnv: () => determineAppEnv3,
  defineUi: () => defineUi3,
  defineStorage: () => defineStorage3,
  defineStacksConfig: () => defineStacksConfig3,
  defineSms: () => defineSms3,
  defineServices: () => defineServices3,
  defineSecurity: () => defineSecurity3,
  defineSearchEngine: () => defineSearchEngine3,
  defineQueue: () => defineQueue3,
  definePayment: () => definePayment3,
  defineNotification: () => defineNotification3,
  defineModel: () => defineModel3,
  defineLibrary: () => defineLibrary3,
  defineJob: () => defineJob3,
  defineHashing: () => defineHashing3,
  defineGit: () => defineGit3,
  defineEvents: () => defineEvents3,
  defineEmailConfig: () => defineEmailConfig3,
  defineEmail: () => defineEmail3,
  defineDns: () => defineDns3,
  defineDependencies: () => defineDependencies3,
  defineDatabase: () => defineDatabase3,
  defineCronJob: () => defineCronJob3,
  defineCli: () => defineCli3,
  defineChat: () => defineChat3,
  defineCdn: () => defineCdn3,
  defineCache: () => defineCache3,
  defineApp: () => defineApp3,
  defaults: () => defaults_default3,
  database: () => database23,
  config: () => config33,
  cloud: () => cloud23,
  cli: () => cli32,
  cache: () => cache23,
  app: () => app23,
  analytics: () => analytics23,
  ai: () => ai23
});
var WORD_SEPARATORS3 = new Set(["\u2014", "\u2013", "-", "\u2015", "/"]);
var SENTENCE_TERMINATORS3 = new Set([".", "!", "?"]);
var TITLE_TERMINATORS3 = new Set([
  ...SENTENCE_TERMINATORS3,
  ":",
  '"',
  "\'",
  "\u201D"
]);
var SMALL_WORDS3 = new Set([
  "a",
  "an",
  "and",
  "as",
  "at",
  "because",
  "but",
  "by",
  "en",
  "for",
  "if",
  "in",
  "neither",
  "nor",
  "of",
  "on",
  "only",
  "or",
  "over",
  "per",
  "so",
  "some",
  "than",
  "that",
  "the",
  "to",
  "up",
  "upon",
  "v",
  "versus",
  "via",
  "vs",
  "when",
  "with",
  "without",
  "yet"
]);
var pluralRules3 = [];
var singularRules3 = [];
var uncountables3 = {};
var irregularPlurals3 = {};
var irregularSingles3 = {};
function sanitizeRule3(rule) {
  return typeof rule === "string" ? new RegExp(`^${rule}\$`, "i") : rule;
}
function restoreCase3(word, token) {
  if (word === token)
    return token;
  if (word === word.toLowerCase())
    return token.toLowerCase();
  if (word === word.toUpperCase())
    return token.toUpperCase();
  if (word[0] === word[0].toUpperCase()) {
    return token.charAt(0).toUpperCase() + token.slice(1).toLowerCase();
  }
  return token.toLowerCase();
}
function interpolate3(str2, ...args) {
  return str2.replace(/\$(\d{1,2})/g, (match, index) => args[Number(index)] || "");
}
function replace3(word, rule) {
  return word.replace(rule[0], (...matchArgs) => {
    const result2 = interpolate3(rule[1], ...matchArgs);
    if (matchArgs[0] === "") {
      return restoreCase3(word[matchArgs[matchArgs.length - 2] - 1], result2);
    }
    return restoreCase3(matchArgs[0], result2);
  });
}
function sanitizeWord3(token, word, rules) {
  if (!token.length || uncountables3[token]) {
    return word;
  }
  for (let i5 = rules.length - 1;i5 >= 0; i5--) {
    const rule = rules[i5];
    if (rule[0].test(word))
      return replace3(word, rule);
  }
  return word;
}
function replaceWord3(replaceMap, keepMap, rules) {
  return (word) => {
    const token = word.toLowerCase();
    if (keepMap[token])
      return restoreCase3(word, token);
    if (replaceMap[token])
      return restoreCase3(word, replaceMap[token]);
    return sanitizeWord3(token, word, rules);
  };
}
function checkWord3(replaceMap, keepMap, rules) {
  return (word) => {
    const token = word.toLowerCase();
    if (keepMap[token])
      return true;
    if (replaceMap[token])
      return false;
    return sanitizeWord3(token, token, rules) === token;
  };
}
var pluralize3 = (word, options3 = {}) => {
  const { count = 2, inclusive = false } = options3;
  if (typeof word !== "string") {
    throw new TypeError("Word must be a string");
  }
  const pluralized = count === 1 ? pluralize3.singular(word) : pluralize3.plural(word);
  return inclusive ? `${count} ${pluralized}` : pluralized;
};
pluralize3.plural = replaceWord3(irregularSingles3, irregularPlurals3, pluralRules3);
pluralize3.isPlural = checkWord3(irregularSingles3, irregularPlurals3, pluralRules3);
pluralize3.singular = replaceWord3(irregularPlurals3, irregularSingles3, singularRules3);
pluralize3.isSingular = checkWord3(irregularPlurals3, irregularSingles3, singularRules3);
pluralize3.addPluralRule = (rule, replacement) => {
  pluralRules3.push([sanitizeRule3(rule), replacement]);
};
pluralize3.addSingularRule = (rule, replacement) => {
  singularRules3.push([sanitizeRule3(rule), replacement]);
};
pluralize3.addUncountableRule = (word) => {
  if (typeof word === "string") {
    uncountables3[word.toLowerCase()] = true;
    return;
  }
  pluralize3.addPluralRule(word, "$0");
  pluralize3.addSingularRule(word, "$0");
};
pluralize3.addIrregularRule = (single, plural) => {
  const lowerPlural = plural.toLowerCase();
  const lowerSingle = single.toLowerCase();
  irregularSingles3[lowerSingle] = lowerPlural;
  irregularPlurals3[lowerPlural] = lowerSingle;
};
[
  ["I", "we"],
  ["me", "us"],
  ["he", "they"],
  ["she", "they"],
  ["them", "them"],
  ["myself", "ourselves"],
  ["yourself", "yourselves"],
  ["itself", "themselves"],
  ["herself", "themselves"],
  ["himself", "themselves"],
  ["themself", "themselves"],
  ["is", "are"],
  ["was", "were"],
  ["has", "have"],
  ["this", "these"],
  ["that", "those"],
  ["my", "our"],
  ["its", "their"],
  ["his", "their"],
  ["her", "their"],
  ["echo", "echoes"],
  ["dingo", "dingoes"],
  ["volcano", "volcanoes"],
  ["tornado", "tornadoes"],
  ["torpedo", "torpedoes"],
  ["genus", "genera"],
  ["viscus", "viscera"],
  ["stigma", "stigmata"],
  ["stoma", "stomata"],
  ["dogma", "dogmata"],
  ["lemma", "lemmata"],
  ["schema", "schemata"],
  ["anathema", "anathemata"],
  ["ox", "oxen"],
  ["axe", "axes"],
  ["die", "dice"],
  ["yes", "yeses"],
  ["foot", "feet"],
  ["eave", "eaves"],
  ["goose", "geese"],
  ["tooth", "teeth"],
  ["quiz", "quizzes"],
  ["human", "humans"],
  ["proof", "proofs"],
  ["carve", "carves"],
  ["valve", "valves"],
  ["looey", "looies"],
  ["thief", "thieves"],
  ["groove", "grooves"],
  ["pickaxe", "pickaxes"],
  ["passerby", "passersby"],
  ["canvas", "canvases"]
].forEach(([single, plural]) => pluralize3.addIrregularRule(single, plural));
[
  [/s?$/i, "s"],
  [/[^\x20-\x7F]$/, "$0"],
  [/([^aeiou]ese)$/i, "$1"],
  [/(ax|test)is$/i, "$1es"],
  [/(alias|[^aou]us|t[lm]as|gas|ris)$/i, "$1es"],
  [/(e[mn]u)s?$/i, "$1s"],
  [/([^l]ias|[aeiou]las|[ejzr]as|[iu]am)$/i, "$1"],
  [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1i"],
  [/(alumn|alg|vertebr)(?:a|ae)$/i, "$1ae"],
  [/(seraph|cherub)(?:im)?$/i, "$1im"],
  [/(her|at|gr)o$/i, "$1oes"],
  [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i, "$1a"],
  [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i, "$1a"],
  [/sis$/i, "ses"],
  [/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i, "$1$2ves"],
  [/([^aeiouy]|qu)y$/i, "$1ies"],
  [/([^ch][ieo][ln])ey$/i, "$1ies"],
  [/(x|ch|ss|sh|zz)$/i, "$1es"],
  [/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i, "$1ices"],
  [/\b((?:tit)?m|l)(?:ice|ouse)$/i, "$1ice"],
  [/(pe)(?:rson|ople)$/i, "$1ople"],
  [/(child)(?:ren)?$/i, "$1ren"],
  [/eaux$/i, "$0"],
  [/m[ae]n$/i, "men"],
  ["thou", "you"]
].forEach(([rule, replacement]) => pluralize3.addPluralRule(rule, replacement));
[
  [/s$/i, ""],
  [/(ss)$/i, "$1"],
  [/(wi|kni|(?:after|half|high|low|mid|non|night|\W|^)li)ves$/i, "$1fe"],
  [/(ar|(?:wo|[ae])l|[eo][ao])ves$/i, "$1f"],
  [/ies$/i, "y"],
  [/(dg|ss|ois|lk|ok|wn|mb|th|ch|ec|oal|is|ck|ix|sser|ts|wb)ies$/i, "$1ie"],
  [/\b(l|(?:neck|cross|hog|aun)?t|coll|faer|food|gen|goon|group|hipp|junk|vegg|(?:pork)?p|charl|calor|cut)ies$/i, "$1ie"],
  [/\b(mon|smil)ies$/i, "$1ey"],
  [/\b((?:tit)?m|l)ice$/i, "$1ouse"],
  [/(seraph|cherub)im$/i, "$1"],
  [/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|t[lm]as|gas|(?:her|at|gr)o|[aeiou]ris)(?:es)?$/i, "$1"],
  [/(analy|diagno|parenthe|progno|synop|the|empha|cri|ne)(?:sis|ses)$/i, "$1sis"],
  [/(movie|twelve|abuse|e[mn]u)s$/i, "$1"],
  [/(test)(?:is|es)$/i, "$1is"],
  [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1us"],
  [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i, "$1um"],
  [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i, "$1on"],
  [/(alumn|alg|vertebr)ae$/i, "$1a"],
  [/(cod|mur|sil|vert|ind)ices$/i, "$1ex"],
  [/(matr|append)ices$/i, "$1ix"],
  [/(pe)(rson|ople)$/i, "$1rson"],
  [/(child)ren$/i, "$1"],
  [/(eau)x?$/i, "$1"],
  [/men$/i, "man"]
].forEach(([rule, replacement]) => pluralize3.addSingularRule(rule, replacement));
[
  "adulthood",
  "advice",
  "agenda",
  "aid",
  "aircraft",
  "alcohol",
  "ammo",
  "analytics",
  "anime",
  "athletics",
  "audio",
  "bison",
  "blood",
  "bream",
  "buffalo",
  "butter",
  "carp",
  "cash",
  "chassis",
  "chess",
  "clothing",
  "cod",
  "commerce",
  "cooperation",
  "corps",
  "debris",
  "diabetes",
  "digestion",
  "elk",
  "energy",
  "equipment",
  "excretion",
  "expertise",
  "firmware",
  "flounder",
  "fun",
  "gallows",
  "garbage",
  "graffiti",
  "hardware",
  "headquarters",
  "health",
  "herpes",
  "highjinks",
  "homework",
  "housework",
  "information",
  "jeans",
  "justice",
  "kudos",
  "labour",
  "literature",
  "machinery",
  "mackerel",
  "mail",
  "media",
  "mews",
  "moose",
  "music",
  "mud",
  "manga",
  "news",
  "only",
  "personnel",
  "pike",
  "plankton",
  "pliers",
  "police",
  "pollution",
  "premises",
  "rain",
  "research",
  "rice",
  "salmon",
  "scissors",
  "series",
  "sewage",
  "shambles",
  "shrimp",
  "software",
  "staff",
  "swine",
  "tennis",
  "traffic",
  "transportation",
  "trout",
  "tuna",
  "wealth",
  "welfare",
  "whiting",
  "wildebeest",
  "wildlife",
  "you",
  /pok[e\u00E9]mon$/i,
  /[^aeiou]ese$/i,
  /deer$/i,
  /fish$/i,
  /measles$/i,
  /o[iu]s$/i,
  /pox$/i,
  /sheep$/i
].forEach(pluralize3.addUncountableRule);
var charMap3 = JSON.parse(`{"$":"dollar","%":"percent","&":"and","<":"less",">":"greater","|":"or","\xA2":"cent","\xA3":"pound","\xA4":"currency","\xA5":"yen","\xA9":"(c)","\xAA":"a","\xAE":"(r)","\xBA":"o","\xC0":"A","\xC1":"A","\xC2":"A","\xC3":"A","\xC4":"A","\xC5":"A","\xC6":"AE","\xC7":"C","\xC8":"E","\xC9":"E","\xCA":"E","\xCB":"E","\xCC":"I","\xCD":"I","\xCE":"I","\xCF":"I","\xD0":"D","\xD1":"N","\xD2":"O","\xD3":"O","\xD4":"O","\xD5":"O","\xD6":"O","\xD8":"O","\xD9":"U","\xDA":"U","\xDB":"U","\xDC":"U","\xDD":"Y","\xDE":"TH","\xDF":"ss","\xE0":"a","\xE1":"a","\xE2":"a","\xE3":"a","\xE4":"a","\xE5":"a","\xE6":"ae","\xE7":"c","\xE8":"e","\xE9":"e","\xEA":"e","\xEB":"e","\xEC":"i","\xED":"i","\xEE":"i","\xEF":"i","\xF0":"d","\xF1":"n","\xF2":"o","\xF3":"o","\xF4":"o","\xF5":"o","\xF6":"o","\xF8":"o","\xF9":"u","\xFA":"u","\xFB":"u","\xFC":"u","\xFD":"y","\xFE":"th","\xFF":"y","\u0100":"A","\u0101":"a","\u0102":"A","\u0103":"a","\u0104":"A","\u0105":"a","\u0106":"C","\u0107":"c","\u010C":"C","\u010D":"c","\u010E":"D","\u010F":"d","\u0110":"DJ","\u0111":"dj","\u0112":"E","\u0113":"e","\u0116":"E","\u0117":"e","\u0118":"e","\u0119":"e","\u011A":"E","\u011B":"e","\u011E":"G","\u011F":"g","\u0122":"G","\u0123":"g","\u0128":"I","\u0129":"i","\u012A":"i","\u012B":"i","\u012E":"I","\u012F":"i","\u0130":"I","\u0131":"i","\u0136":"k","\u0137":"k","\u013B":"L","\u013C":"l","\u013D":"L","\u013E":"l","\u0141":"L","\u0142":"l","\u0143":"N","\u0144":"n","\u0145":"N","\u0146":"n","\u0147":"N","\u0148":"n","\u014C":"O","\u014D":"o","\u0150":"O","\u0151":"o","\u0152":"OE","\u0153":"oe","\u0154":"R","\u0155":"r","\u0158":"R","\u0159":"r","\u015A":"S","\u015B":"s","\u015E":"S","\u015F":"s","\u0160":"S","\u0161":"s","\u0162":"T","\u0163":"t","\u0164":"T","\u0165":"t","\u0168":"U","\u0169":"u","\u016A":"u","\u016B":"u","\u016E":"U","\u016F":"u","\u0170":"U","\u0171":"u","\u0172":"U","\u0173":"u","\u0174":"W","\u0175":"w","\u0176":"Y","\u0177":"y","\u0178":"Y","\u0179":"Z","\u017A":"z","\u017B":"Z","\u017C":"z","\u017D":"Z","\u017E":"z","\u018F":"E","\u0192":"f","\u01A0":"O","\u01A1":"o","\u01AF":"U","\u01B0":"u","\u01C8":"LJ","\u01C9":"lj","\u01CB":"NJ","\u01CC":"nj","\u0218":"S","\u0219":"s","\u021A":"T","\u021B":"t","\u0259":"e","\u02DA":"o","\u0386":"A","\u0388":"E","\u0389":"H","\u038A":"I","\u038C":"O","\u038E":"Y","\u038F":"W","\u0390":"i","\u0391":"A","\u0392":"B","\u0393":"G","\u0394":"D","\u0395":"E","\u0396":"Z","\u0397":"H","\u0398":"8","\u0399":"I","\u039A":"K","\u039B":"L","\u039C":"M","\u039D":"N","\u039E":"3","\u039F":"O","\u03A0":"P","\u03A1":"R","\u03A3":"S","\u03A4":"T","\u03A5":"Y","\u03A6":"F","\u03A7":"X","\u03A8":"PS","\u03A9":"W","\u03AA":"I","\u03AB":"Y","\u03AC":"a","\u03AD":"e","\u03AE":"h","\u03AF":"i","\u03B0":"y","\u03B1":"a","\u03B2":"b","\u03B3":"g","\u03B4":"d","\u03B5":"e","\u03B6":"z","\u03B7":"h","\u03B8":"8","\u03B9":"i","\u03BA":"k","\u03BB":"l","\u03BC":"m","\u03BD":"n","\u03BE":"3","\u03BF":"o","\u03C0":"p","\u03C1":"r","\u03C2":"s","\u03C3":"s","\u03C4":"t","\u03C5":"y","\u03C6":"f","\u03C7":"x","\u03C8":"ps","\u03C9":"w","\u03CA":"i","\u03CB":"y","\u03CC":"o","\u03CD":"y","\u03CE":"w","\u0401":"Yo","\u0402":"DJ","\u0404":"Ye","\u0406":"I","\u0407":"Yi","\u0408":"J","\u0409":"LJ","\u040A":"NJ","\u040B":"C","\u040F":"DZ","\u0410":"A","\u0411":"B","\u0412":"V","\u0413":"G","\u0414":"D","\u0415":"E","\u0416":"Zh","\u0417":"Z","\u0418":"I","\u0419":"J","\u041A":"K","\u041B":"L","\u041C":"M","\u041D":"N","\u041E":"O","\u041F":"P","\u0420":"R","\u0421":"S","\u0422":"T","\u0423":"U","\u0424":"F","\u0425":"H","\u0426":"C","\u0427":"Ch","\u0428":"Sh","\u0429":"Sh","\u042A":"U","\u042B":"Y","\u042C":"","\u042D":"E","\u042E":"Yu","\u042F":"Ya","\u0430":"a","\u0431":"b","\u0432":"v","\u0433":"g","\u0434":"d","\u0435":"e","\u0436":"zh","\u0437":"z","\u0438":"i","\u0439":"j","\u043A":"k","\u043B":"l","\u043C":"m","\u043D":"n","\u043E":"o","\u043F":"p","\u0440":"r","\u0441":"s","\u0442":"t","\u0443":"u","\u0444":"f","\u0445":"h","\u0446":"c","\u0447":"ch","\u0448":"sh","\u0449":"sh","\u044A":"u","\u044B":"y","\u044C":"","\u044D":"e","\u044E":"yu","\u044F":"ya","\u0451":"yo","\u0452":"dj","\u0454":"ye","\u0456":"i","\u0457":"yi","\u0458":"j","\u0459":"lj","\u045A":"nj","\u045B":"c","\u045D":"u","\u045F":"dz","\u0490":"G","\u0491":"g","\u0492":"GH","\u0493":"gh","\u049A":"KH","\u049B":"kh","\u04A2":"NG","\u04A3":"ng","\u04AE":"UE","\u04AF":"ue","\u04B0":"U","\u04B1":"u","\u04BA":"H","\u04BB":"h","\u04D8":"AE","\u04D9":"ae","\u04E8":"OE","\u04E9":"oe","\u0531":"A","\u0532":"B","\u0533":"G","\u0534":"D","\u0535":"E","\u0536":"Z","\u0537":"E'","\u0538":"Y'","\u0539":"T'","\u053A":"JH","\u053B":"I","\u053C":"L","\u053D":"X","\u053E":"C'","\u053F":"K","\u0540":"H","\u0541":"D'","\u0542":"GH","\u0543":"TW","\u0544":"M","\u0545":"Y","\u0546":"N","\u0547":"SH","\u0549":"CH","\u054A":"P","\u054B":"J","\u054C":"R'","\u054D":"S","\u054E":"V","\u054F":"T","\u0550":"R","\u0551":"C","\u0553":"P'","\u0554":"Q'","\u0555":"O''","\u0556":"F","\u0587":"EV","\u0621":"a","\u0622":"aa","\u0623":"a","\u0624":"u","\u0625":"i","\u0626":"e","\u0627":"a","\u0628":"b","\u0629":"h","\u062A":"t","\u062B":"th","\u062C":"j","\u062D":"h","\u062E":"kh","\u062F":"d","\u0630":"th","\u0631":"r","\u0632":"z","\u0633":"s","\u0634":"sh","\u0635":"s","\u0636":"dh","\u0637":"t","\u0638":"z","\u0639":"a","\u063A":"gh","\u0641":"f","\u0642":"q","\u0643":"k","\u0644":"l","\u0645":"m","\u0646":"n","\u0647":"h","\u0648":"w","\u0649":"a","\u064A":"y","\u064B":"an","\u064C":"on","\u064D":"en","\u064E":"a","\u064F":"u","\u0650":"e","\u0652":"","\u0660":"0","\u0661":"1","\u0662":"2","\u0663":"3","\u0664":"4","\u0665":"5","\u0666":"6","\u0667":"7","\u0668":"8","\u0669":"9","\u067E":"p","\u0686":"ch","\u0698":"zh","\u06A9":"k","\u06AF":"g","\u06CC":"y","\u06F0":"0","\u06F1":"1","\u06F2":"2","\u06F3":"3","\u06F4":"4","\u06F5":"5","\u06F6":"6","\u06F7":"7","\u06F8":"8","\u06F9":"9","\u0E3F":"baht","\u10D0":"a","\u10D1":"b","\u10D2":"g","\u10D3":"d","\u10D4":"e","\u10D5":"v","\u10D6":"z","\u10D7":"t","\u10D8":"i","\u10D9":"k","\u10DA":"l","\u10DB":"m","\u10DC":"n","\u10DD":"o","\u10DE":"p","\u10DF":"zh","\u10E0":"r","\u10E1":"s","\u10E2":"t","\u10E3":"u","\u10E4":"f","\u10E5":"k","\u10E6":"gh","\u10E7":"q","\u10E8":"sh","\u10E9":"ch","\u10EA":"ts","\u10EB":"dz","\u10EC":"ts","\u10ED":"ch","\u10EE":"kh","\u10EF":"j","\u10F0":"h","\u1E62":"S","\u1E63":"s","\u1E80":"W","\u1E81":"w","\u1E82":"W","\u1E83":"w","\u1E84":"W","\u1E85":"w","\u1E9E":"SS","\u1EA0":"A","\u1EA1":"a","\u1EA2":"A","\u1EA3":"a","\u1EA4":"A","\u1EA5":"a","\u1EA6":"A","\u1EA7":"a","\u1EA8":"A","\u1EA9":"a","\u1EAA":"A","\u1EAB":"a","\u1EAC":"A","\u1EAD":"a","\u1EAE":"A","\u1EAF":"a","\u1EB0":"A","\u1EB1":"a","\u1EB2":"A","\u1EB3":"a","\u1EB4":"A","\u1EB5":"a","\u1EB6":"A","\u1EB7":"a","\u1EB8":"E","\u1EB9":"e","\u1EBA":"E","\u1EBB":"e","\u1EBC":"E","\u1EBD":"e","\u1EBE":"E","\u1EBF":"e","\u1EC0":"E","\u1EC1":"e","\u1EC2":"E","\u1EC3":"e","\u1EC4":"E","\u1EC5":"e","\u1EC6":"E","\u1EC7":"e","\u1EC8":"I","\u1EC9":"i","\u1ECA":"I","\u1ECB":"i","\u1ECC":"O","\u1ECD":"o","\u1ECE":"O","\u1ECF":"o","\u1ED0":"O","\u1ED1":"o","\u1ED2":"O","\u1ED3":"o","\u1ED4":"O","\u1ED5":"o","\u1ED6":"O","\u1ED7":"o","\u1ED8":"O","\u1ED9":"o","\u1EDA":"O","\u1EDB":"o","\u1EDC":"O","\u1EDD":"o","\u1EDE":"O","\u1EDF":"o","\u1EE0":"O","\u1EE1":"o","\u1EE2":"O","\u1EE3":"o","\u1EE4":"U","\u1EE5":"u","\u1EE6":"U","\u1EE7":"u","\u1EE8":"U","\u1EE9":"u","\u1EEA":"U","\u1EEB":"u","\u1EEC":"U","\u1EED":"u","\u1EEE":"U","\u1EEF":"u","\u1EF0":"U","\u1EF1":"u","\u1EF2":"Y","\u1EF3":"y","\u1EF4":"Y","\u1EF5":"y","\u1EF6":"Y","\u1EF7":"y","\u1EF8":"Y","\u1EF9":"y","\u2013":"-","\u2018":"'","\u2019":"'","\u201C":"\\"","\u201D":"\\"","\u201E":"\\"","\u2020":"+","\u2022":"*","\u2026":"...","\u20A0":"ecu","\u20A2":"cruzeiro","\u20A3":"french franc","\u20A4":"lira","\u20A5":"mill","\u20A6":"naira","\u20A7":"peseta","\u20A8":"rupee","\u20A9":"won","\u20AA":"new shequel","\u20AB":"dong","\u20AC":"euro","\u20AD":"kip","\u20AE":"tugrik","\u20AF":"drachma","\u20B0":"penny","\u20B1":"peso","\u20B2":"guarani","\u20B3":"austral","\u20B4":"hryvnia","\u20B5":"cedi","\u20B8":"kazakhstani tenge","\u20B9":"indian rupee","\u20BA":"turkish lira","\u20BD":"russian ruble","\u20BF":"bitcoin","\u2120":"sm","\u2122":"tm","\u2202":"d","\u2206":"delta","\u2211":"sum","\u221E":"infinity","\u2665":"love","\u5143":"yuan","\u5186":"yen","\uFDFC":"rial","\uFEF5":"laa","\uFEF7":"laa","\uFEF9":"lai","\uFEFB":"la"}`);
var locales3 = JSON.parse('{"bg":{"\u0419":"Y","\u0426":"Ts","\u0429":"Sht","\u042A":"A","\u042C":"Y","\u0439":"y","\u0446":"ts","\u0449":"sht","\u044A":"a","\u044C":"y"},"de":{"\xC4":"AE","\xE4":"ae","\xD6":"OE","\xF6":"oe","\xDC":"UE","\xFC":"ue","\xDF":"ss","%":"prozent","&":"und","|":"oder","\u2211":"summe","\u221E":"unendlich","\u2665":"liebe"},"es":{"%":"por ciento","&":"y","<":"menor que",">":"mayor que","|":"o","\xA2":"centavos","\xA3":"libras","\xA4":"moneda","\u20A3":"francos","\u2211":"suma","\u221E":"infinito","\u2665":"amor"},"fr":{"%":"pourcent","&":"et","<":"plus petit",">":"plus grand","|":"ou","\xA2":"centime","\xA3":"livre","\xA4":"devise","\u20A3":"franc","\u2211":"somme","\u221E":"infini","\u2665":"amour"},"pt":{"%":"porcento","&":"e","<":"menor",">":"maior","|":"ou","\xA2":"centavo","\u2211":"soma","\xA3":"libra","\u221E":"infinito","\u2665":"amor"},"uk":{"\u0418":"Y","\u0438":"y","\u0419":"Y","\u0439":"y","\u0426":"Ts","\u0446":"ts","\u0425":"Kh","\u0445":"kh","\u0429":"Shch","\u0449":"shch","\u0413":"H","\u0433":"h"},"vi":{"\u0110":"D","\u0111":"d"},"da":{"\xD8":"OE","\xF8":"oe","\xC5":"AA","\xE5":"aa","%":"procent","&":"og","|":"eller","$":"dollar","<":"mindre end",">":"st\xF8rre end"},"nb":{"&":"og","\xC5":"AA","\xC6":"AE","\xD8":"OE","\xE5":"aa","\xE6":"ae","\xF8":"oe"},"it":{"&":"e"},"nl":{"&":"en"},"sv":{"&":"och","\xC5":"AA","\xC4":"AE","\xD6":"OE","\xE5":"aa","\xE4":"ae","\xF6":"oe"}}');
init_consola_36c0034f3();
init_core4();
init_consola_06ad8a643();
init_utils14();
function logLevel3() {
  const verboseRegex = /--verbose(?!\s*=\s*false|\s+false)(?:\s+|=true)?(?:$|\s)/;
  const opts = buddyOptions3();
  if (verboseRegex.test(opts))
    return 4;
  return 3;
}
var logger3 = {
  ...createConsola23({
    level: logLevel3()
  }),
  warning: (message) => console.warn(message),
  dump: (...args) => console.log(...args),
  dd: (...args) => {
    console.log(...args);
    process43.exit(1);
  },
  echo: (message) => console.log(message)
};
var log3 = {
  info: async (message, options3) => {
    if (options3?.styled === false)
      console.log(message);
    else
      logger3.info(message);
    await writeToLogFile3(`INFO: ${stripAnsi6(message)}`);
  },
  success: async (message, options3) => {
    if (options3?.styled === false)
      console.log(message);
    else
      logger3.success(message);
    await writeToLogFile3(`SUCCESS: ${stripAnsi6(message)}`);
  },
  warn: async (message, options3) => {
    if (options3?.styled === false)
      console.log(message);
    else
      logger3.warn(message);
    await writeToLogFile3(`WARN: ${stripAnsi6(message)}`);
  },
  warning: async (message, options3) => {
    if (options3?.styled === false)
      console.log(message);
    else
      logger3.warn(message);
    await writeToLogFile3(`WARN: ${stripAnsi6(message)}`);
  },
  error: async (err3, options3) => {
    handleError3(err3, options3);
  },
  debug: async (...args) => {
    const formattedArgs = args.map((arg) => typeof arg === "object" ? JSON.stringify(arg, null, 2) : arg);
    const message = `DEBUG: ${formattedArgs.join(" ")}`;
    if (process43.env.APP_ENV === "production" || process43.env.APP_ENV === "prod")
      return writeToLogFile3(message);
    logger3.debug(message);
    await writeToLogFile3(stripAnsi6(message));
  },
  dump: (...args) => args.forEach((arg) => console.log(arg)),
  dd: (...args) => {
    args.forEach((arg) => console.log(arg));
    process43.exit(1);
  },
  echo: (...args) => console.log(...args)
};
function userDatabasePath3(path23) {
  return projectPath3(`database/${path23 || ""}`);
}
function appPath3(path23) {
  return projectPath3(`app/${path23 || ""}`);
}
function commandsPath3(path23) {
  return appPath3(`Commands/${path23 || ""}`);
}
function logsPath3(path23) {
  return storagePath3(`logs/${path23 || ""}`);
}
function projectPath3(filePath = "", options3) {
  let path23 = process53.cwd();
  while (path23.includes("storage"))
    path23 = resolve23(path23, "..");
  const finalPath = resolve23(path23, filePath);
  if (options3?.relative)
    return relative3(process53.cwd(), finalPath);
  return finalPath;
}
function storagePath3(path23) {
  return projectPath3(`storage/${path23 || ""}`);
}
var config7 = {
  ai: {
    deploy: false,
    models: [
      "amazon.titan-embed-text-v1",
      "amazon.titan-text-express-v1",
      "amazon.titan-embed-image-v1",
      "amazon.titan-image-generator-v1",
      "anthropic.claude-v1",
      "anthropic.claude-v2",
      "anthropic.claude-v2:1",
      "anthropic.claude-instant-v1",
      "meta.llama2-13b-chat-v1",
      "meta.llama2-70b-chat-v1"
    ]
  },
  analytics: {
    driver: undefined
  },
  app: {
    name: "Stacks",
    description: "A Stacks application.",
    env: "local",
    url: "stacks.localhost",
    debug: true,
    key: "",
    timezone: "UTC",
    locale: "en",
    fallbackLocale: "en",
    cipher: "AES-256-CBC",
    docMode: false,
    redirectUrls: [],
    maintenanceMode: false
  },
  cli: {
    name: "My Custom CLI",
    command: "my-custom-cli",
    description: "Stacks is a full-stack framework for TypeScript.",
    source: commandsPath3(),
    deploy: false
  },
  cache: {
    driver: "redis",
    prefix: "stx",
    ttl: 3600,
    drivers: {
      redis: {
        connection: "default",
        host: "localhost",
        port: 6379,
        username: "",
        password: ""
      }
    }
  },
  cloud: {
    type: "serverless",
    driver: "aws",
    storage: {},
    environments: ["production", "staging", "development"],
    firewall: {
      enabled: true,
      countryCodes: [],
      ipAddresses: [],
      queryString: [],
      httpHeaders: [],
      rateLimitPerMinute: 1000,
      useIpReputationLists: true,
      useKnownBadInputsRuleSet: true
    },
    cdn: {
      allowedMethods: "GET_HEAD",
      cachedMethods: "GET_HEAD",
      minTtl: 0,
      defaultTtl: 86400,
      maxTtl: 31536000,
      compress: true,
      priceClass: "PriceClass_All",
      originShieldRegion: "us-east-1",
      cookieBehavior: "none",
      allowList: {
        cookies: [],
        headers: [],
        queryStrings: []
      },
      realtimeLogs: {
        enabled: true,
        samplingRate: 2
      }
    },
    fileSystem: false
  },
  database: {
    default: "sqlite",
    connections: {
      sqlite: {
        database: userDatabasePath3("stacks.sqlite"),
        prefix: ""
      }
    },
    migrations: "migrations",
    migrationLocks: "migration_locks"
  },
  dns: {
    driver: "aws",
    a: [],
    aaaa: [],
    cname: [],
    mx: [],
    txt: []
  },
  docs: {
    lang: "en-US",
    title: "Stacks",
    description: "Rapid application, cloud & library framework.",
    lastUpdated: true,
    deploy: false,
    themeConfig: {
      editLink: {
        pattern: "https://github.com/stacksjs/stacks/edit/main/docs/docs/:path",
        text: "Edit this page on GitHub"
      },
      footer: {
        message: "Released under the MIT License.",
        copyright: "Copyright \xA9 2024-present Stacks.js, Inc."
      }
    }
  },
  email: {
    from: {
      name: "Stacks",
      address: "no-reply@stacksjs.org"
    },
    mailboxes: [],
    server: {
      scan: true
    }
  },
  errors: {
    messages: {
      string: "The {{ field }} field must be a string",
      email: "The {{ field }} field must be a valid email address",
      regex: "The {{ field }} field format is invalid",
      url: "The {{ field }} field must be a valid URL",
      activeUrl: "The {{ field }} field must be a valid URL",
      alpha: "The {{ field }} field must contain only letters",
      alphaNumeric: "The {{ field }} field must contain only letters and numbers",
      minLength: "The {{ field }} field must have at least {{ min }} characters",
      maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
      fixedLength: "The {{ field }} field must be {{ size }} characters long",
      confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
      endsWith: "The {{ field }} field must end with {{ substring }}",
      startsWith: "The {{ field }} field must start with {{ substring }}",
      sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
      notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
      in: "The selected {{ field }} is invalid",
      notIn: "The selected {{ field }} is invalid",
      ipAddress: "The {{ field }} field must be a valid IP address",
      uuid: "The {{ field }} field must be a valid UUID",
      ascii: "The {{ field }} field must only contain ASCII characters",
      creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
      hexCode: "The {{ field }} field must be a valid hex color code",
      iban: "The {{ field }} field must be a valid IBAN number",
      jwt: "The {{ field }} field must be a valid JWT token",
      coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
      mobile: "The {{ field }} field must be a valid mobile phone number",
      passport: "The {{ field }} field must be a valid passport number",
      postalCode: "The {{ field }} field must be a valid postal code",
      boolean: "The value must be a boolean",
      number: "The {{ field }} field must be a number",
      min: "The {{ field }} field must be at least {{ min }}",
      max: "The {{ field }} field must not be greater than {{ max }}",
      range: "The {{ field }} field must be between {{ min }} and {{ max }}",
      positive: "The {{ field }} field must be positive",
      negative: "The {{ field }} field must be negative",
      decimal: "The {{ field }} field must have {{ digits }} decimal places",
      withoutDecimals: "The {{ field }} field must not have decimal places",
      date: "The {{ field }} field must be a datetime value",
      "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
      "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
      "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
      "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
      "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
      "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
      "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
      "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
      accepted: "The {{ field }} field must be accepted",
      enum: "The selected {{ field }} is invalid",
      literal: "The {{ field }} field must be {{ expectedValue }}",
      object: "The {{ field }} field must be an object",
      record: "The {{ field }} field must be an object",
      "record.minLength": "The {{ field }} field must have at least {{ min }} items",
      "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
      "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
      array: "The {{ field }} field must be an array",
      "array.minLength": "The {{ field }} field must have at least {{ min }} items",
      "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
      "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
      notEmpty: "The {{ field }} field must not be empty",
      distinct: "The {{ field }} field has duplicate values",
      tuple: "The {{ field }} field must be an array",
      union: "Invalid value provided for {{ field }} field",
      unionGroup: "Invalid value provided for {{ field }} field",
      unionOfTypes: "Invalid value provided for {{ field }} field"
    }
  },
  git: {
    hooks: {
      "pre-commit": "lint-staged"
    },
    scopes: [
      "",
      "ci",
      "deps",
      "dx",
      "release",
      "docs",
      "test",
      "core",
      "actions",
      "arrays",
      "auth",
      "build",
      "cache",
      "cli",
      "cloud",
      "collections",
      "config",
      "database",
      "datetime",
      "docs",
      "errors",
      "git",
      "lint",
      "x-ray",
      "modules",
      "notifications",
      "objects",
      "path",
      "realtime",
      "router",
      "buddy",
      "security",
      "server",
      "storage",
      "strings",
      "tests",
      "types",
      "ui",
      "utils"
    ],
    messages: {
      type: "Select the type of change that you\u2019re committing:",
      scope: "Select the SCOPE of this change (optional):",
      customScope: "Select the SCOPE of this change:",
      subject: "Write a SHORT, IMPERATIVE tense description of the change:\n",
      body: 'Provide a LONGER description of the change (optional). Use "|" to break new line:\n',
      breaking: 'List any BREAKING CHANGES (optional). Use "|" to break new line:\n',
      footerPrefixesSelect: "Select the ISSUES type of the change list by this change (optional):",
      customFooterPrefixes: "Input ISSUES prefix:",
      footer: "List any ISSUES by this change. E.g.: #31, #34:\n",
      confirmCommit: "Are you sure you want to proceed with the commit above?"
    },
    types: [
      {
        value: "feat",
        name: "feat:     \u2728  A new feature",
        emoji: ":sparkles:"
      },
      { value: "fix", name: "fix:      \uD83D\uDC1B  A bug fix", emoji: ":bug:" },
      {
        value: "docs",
        name: "docs:     \uD83D\uDCDD  Documentation only changes",
        emoji: ":memo:"
      },
      {
        value: "style",
        name: "style:    \uD83D\uDC84  Changes that do not affect the meaning of the code",
        emoji: ":lipstick:"
      },
      {
        value: "refactor",
        name: "refactor: \u267B\uFE0F   A code change that neither fixes a bug nor adds a feature",
        emoji: ":recycle:"
      },
      {
        value: "perf",
        name: "perf:     \u26A1\uFE0F  A code change that improves performance",
        emoji: ":zap:"
      },
      {
        value: "test",
        name: "test:     \u2705  Adding missing tests or adjusting existing tests",
        emoji: ":white_check_mark:"
      },
      {
        value: "build",
        name: "build:    \uD83D\uDCE6\uFE0F  Changes that affect the build system or external dependencies",
        emoji: ":package:"
      },
      {
        value: "ci",
        name: "ci:       \uD83C\uDFA1  Changes to our CI configuration files and scripts",
        emoji: ":ferris_wheel:"
      },
      {
        value: "chore",
        name: "chore:    \uD83D\uDD28  Other changes that don\u2019t modify src or test files",
        emoji: ":hammer:"
      },
      {
        value: "revert",
        name: "revert:   \u23EA\uFE0F  Reverts a previous commit",
        emoji: ":rewind:"
      }
    ]
  },
  hashing: {
    driver: "argon2",
    bcrypt: {
      rounds: 10,
      cost: 4
    },
    argon2: {
      memory: 65536,
      time: 1
    }
  },
  library: {
    name: "hello-world",
    owner: "@stacksjs",
    repository: "stacksjs/stacks",
    license: "MIT",
    author: "Chris Breuer",
    contributors: ["Chris Breuer <chris@stacksjs.org>"],
    defaultLanguage: "en",
    vueComponents: {
      name: "hello-world-vue",
      description: "Your Vue component library description",
      keywords: ["component", "library", "vue", "vite", "typescript", "javascript"],
      tags: [
        {
          name: ["HelloWorld", "AppHelloWorld"],
          description: "The Hello World custom element, built via this framework.",
          attributes: [
            {
              name: "greeting",
              description: "The greeting."
            }
          ]
        }
      ]
    },
    webComponents: {
      name: "hello-world-elements",
      description: "Your framework agnostic web component library description.",
      keywords: ["custom-elements", "web-components", "library", "framework-agnostic", "typescript", "javascript"],
      tags: [
        {
          name: ["HelloWorld", "AppHelloWorld"],
          description: "The Hello World custom element, built via this framework.",
          attributes: [
            {
              name: "greeting",
              description: "The greeting."
            }
          ]
        }
      ]
    },
    functions: {
      name: "hello-world-fx",
      description: "Your function library description.",
      keywords: ["functions", "composables", "library", "typescript", "javascript"],
      shouldGenerateSourcemap: false,
      files: ["counter", "dark"]
    }
  },
  logging: {
    logsPath: "storage/logs/stacks.log",
    deploymentsPath: "storage/logs/deployments.log"
  },
  notification: {
    default: "email"
  },
  payment: {
    driver: "stripe"
  },
  ports: {
    frontend: 3000,
    backend: 3001,
    admin: 3002,
    library: 3003,
    desktop: 3004,
    email: 3005,
    docs: 3006,
    inspect: 3007,
    api: 3008,
    systemTray: 3009,
    database: 3010
  },
  queue: {
    default: "sync",
    connections: {
      sync: {
        driver: "sync"
      },
      database: {
        driver: "database",
        table: "jobs",
        queue: "default",
        retry_after: 90
      },
      redis: {
        driver: "redis",
        connection: "default",
        queue: "default",
        retry_after: 90
      },
      sqs: {
        driver: "sqs",
        key: "",
        secret: "",
        prefix: "",
        suffix: "",
        queue: "default",
        region: "us-east-1"
      }
    }
  },
  saas: {
    plans: [
      {
        productName: "Stacks Hobby",
        description: "All the Stacks features.",
        pricing: [
          {
            key: "stacks_hobby_monthly",
            price: 3900,
            interval: "month",
            currency: "usd"
          },
          {
            key: "stacks_hobby_yearly",
            price: 37900,
            interval: "year",
            currency: "usd"
          }
        ],
        metadata: {
          createdBy: "admin",
          version: "1.0.0"
        }
      },
      {
        productName: "Stacks Pro",
        description: "All the Stacks features, including being able to invite team members.",
        pricing: [
          {
            key: "stacks_pro_monthly",
            price: 5900,
            interval: "month",
            currency: "usd"
          },
          {
            key: "stacks_pro_yearly",
            price: 57900,
            interval: "year",
            currency: "usd"
          }
        ],
        metadata: {
          createdBy: "admin",
          version: "1.0.0"
        }
      }
    ],
    webhook: {
      endpoint: "/webhooks/stripe",
      secret: ""
    },
    currencies: ["usd"],
    coupons: [
      {
        code: "SUMMER2024",
        amountOff: 500,
        duration: "once"
      }
    ],
    products: [
      {
        name: "Stacks Pro",
        description: "All the Stacks features.",
        images: ["url_to_image"]
      }
    ]
  },
  searchEngine: {
    driver: "opensearch"
  },
  security: {
    firewall: {
      enabled: true,
      countryCodes: [],
      ipAddresses: [],
      queryString: [],
      httpHeaders: [],
      rateLimitPerMinute: 1000,
      useIpReputationLists: true,
      useKnownBadInputsRuleSet: true
    }
  },
  services: {
    aws: {
      accountId: "",
      appId: "",
      apiKey: "",
      region: "us-east-1"
    },
    algolia: {
      appId: "",
      apiKey: ""
    },
    meilisearch: {
      appId: "",
      apiKey: ""
    },
    stripe: {
      appId: "",
      apiKey: ""
    }
  },
  storage: {
    driver: "s3"
  },
  team: {
    name: "Stacks",
    members: {
      "Chris Breuer": "chris@stacksjs.org"
    }
  },
  ui: {
    shortcuts: [
      [
        "btn",
        "inline-flex items-center px-4 py-2 ml-2 border border-transparent shadow-sm text-base font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 cursor-pointer"
      ]
    ],
    safelist: "prose prose-sm m-auto text-left",
    trigger: ":stx:",
    classPrefix: "stx-",
    reset: "tailwind",
    icons: ["heroicons"],
    fonts: {
      email: {
        title: "Mona",
        text: "Hubot"
      },
      desktop: {
        title: "Mona",
        text: "Hubot"
      },
      mobile: {
        title: "Mona",
        text: "Hubot"
      },
      web: {
        title: "Mona",
        text: "Hubot"
      }
    }
  }
};
var defaults_default3 = config7;
var ai_default3 = {
  default: "meta.llama2-70b-chat-v1",
  models: [
    "amazon.titan-text-express-v1",
    "amazon.titan-text-lite-v1",
    "meta.llama2-70b-chat-v1"
  ],
  deploy: true
};
var analytics_default3 = {
  driver: "fathom",
  drivers: {
    googleAnalytics: {
      trackingId: "UA-XXXXXXXXX-X"
    },
    fathom: {
      siteId: "WOLZMJDL"
    }
  }
};
function isString3(val2) {
  return typeof val2 === "string";
}
var messages3 = {
  required: "The {{ field }} field must be defined",
  string: "The {{ field }} field must be a string",
  email: "The {{ field }} field must be a valid email address",
  mobile: "The {{ field }} field must be a valid mobile phone number",
  creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
  passport: "The {{ field }} field must be a valid passport number",
  postalCode: "The {{ field }} field must be a valid postal code",
  regex: "The {{ field }} field format is invalid",
  ascii: "The {{ field }} field must only contain ASCII characters",
  iban: "The {{ field }} field must be a valid IBAN number",
  jwt: "The {{ field }} field must be a valid JWT token",
  coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
  url: "The {{ field }} field must be a valid URL",
  activeUrl: "The {{ field }} field must be a valid URL",
  alpha: "The {{ field }} field must contain only letters",
  alphaNumeric: "The {{ field }} field must contain only letters and numbers",
  minLength: "The {{ field }} field must have at least {{ min }} characters",
  maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
  fixedLength: "The {{ field }} field must be {{ size }} characters long",
  confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
  endsWith: "The {{ field }} field must end with {{ substring }}",
  startsWith: "The {{ field }} field must start with {{ substring }}",
  sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
  notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
  in: "The selected {{ field }} is invalid",
  notIn: "The selected {{ field }} is invalid",
  ipAddress: "The {{ field }} field must be a valid IP address",
  uuid: "The {{ field }} field must be a valid UUID",
  hexCode: "The {{ field }} field must be a valid hex color code",
  boolean: "The value must be a boolean",
  number: "The {{ field }} field must be a number",
  "number.in": "The selected {{ field }} is not in {{ values }}",
  min: "The {{ field }} field must be at least {{ min }}",
  max: "The {{ field }} field must not be greater than {{ max }}",
  range: "The {{ field }} field must be between {{ min }} and {{ max }}",
  positive: "The {{ field }} field must be positive",
  negative: "The {{ field }} field must be negative",
  decimal: "The {{ field }} field must have {{ digits }} decimal places",
  withoutDecimals: "The {{ field }} field must be an integer",
  accepted: "The {{ field }} field must be accepted",
  enum: "The selected {{ field }} is invalid",
  literal: "The {{ field }} field must be {{ expectedValue }}",
  object: "The {{ field }} field must be an object",
  array: "The {{ field }} field must be an array",
  "array.minLength": "The {{ field }} field must have at least {{ min }} items",
  "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
  "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
  notEmpty: "The {{ field }} field must not be empty",
  distinct: "The {{ field }} field has duplicate values",
  record: "The {{ field }} field must be an object",
  "record.minLength": "The {{ field }} field must have at least {{ min }} items",
  "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
  "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
  tuple: "The {{ field }} field must be an array",
  union: "Invalid value provided for {{ field }} field",
  unionGroup: "Invalid value provided for {{ field }} field",
  unionOfTypes: "Invalid value provided for {{ field }} field",
  date: "The {{ field }} field must be a datetime value",
  "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
  "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
  "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
  "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
  "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
  "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
  "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
  "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
  "date.afterOrSameAs": "The {{ field }} field must be a date after or same as {{ otherField }}",
  "date.beforeField": "The {{ field }} field must be a date before {{ otherField }}",
  "date.beforeOrSameAs": "The {{ field }} field must be a date before or same as {{ otherField }}",
  "date.weekend": "The {{ field }} field is not a weekend",
  "date.weekday": "The {{ field }} field is not a weekday"
};
var fields3 = {
  "": "data"
};
var __defProp222 = Object.defineProperty;
var __export23 = (target, all) => {
  for (var name in all)
    __defProp222(target, name, { get: all[name], enumerable: true });
};
function dlv_es_default3(t5, e5, l33, n5, r23) {
  for (e5 = e5.split ? e5.split(".") : e5, n5 = 0;n5 < e5.length; n5++)
    t5 = t5 ? t5[e5[n5]] : r23;
  return t5 === r23 ? l33 : t5;
}
var import_isIP3 = __toESM22(require_isIP3(), 1);
var import_isJWT3 = __toESM22(require_isJWT3(), 1);
var import_isURL3 = __toESM22(require_isURL3(), 1);
var import_isSlug3 = __toESM22(require_isSlug3(), 1);
var import_isIBAN3 = __toESM22(require_isIBAN3(), 1);
var import_isUUID3 = __toESM22(require_isUUID3(), 1);
var import_isAscii3 = __toESM22(require_isAscii3(), 1);
var import_isEmail3 = __toESM22(require_isEmail3(), 1);
var import_isAlpha3 = __toESM22(require_isAlpha3(), 1);
var import_isLatLong3 = __toESM22(require_isLatLong3(), 1);
var import_isDecimal3 = __toESM22(require_isDecimal3(), 1);
var import_isHexColor3 = __toESM22(require_isHexColor3(), 1);
var import_isCreditCard3 = __toESM22(require_isCreditCard3(), 1);
var import_isAlphanumeric3 = __toESM22(require_isAlphanumeric3(), 1);
var import_isPassportNumber3 = __toESM22(require_isPassportNumber3(), 1);
var import_isPostalCode5 = __toESM22(require_isPostalCode3(), 1);
var import_isMobilePhone5 = __toESM22(require_isMobilePhone3(), 1);
var import_isMobilePhone23 = __toESM22(require_isMobilePhone3(), 1);
var import_isPostalCode23 = __toESM22(require_isPostalCode3(), 1);
var SimpleMessagesProvider3 = class {
  #messages;
  #fields;
  constructor(messages23, fields22) {
    this.#messages = messages23;
    this.#fields = fields22 || {};
  }
  #interpolate(message, data2) {
    if (!message.includes("{{")) {
      return message;
    }
    return message.replace(/(\\)?{{(.*?)}}/g, (_23, __, key) => {
      const tokens = key.trim().split(".");
      let output = data2;
      while (tokens.length) {
        if (output === null || typeof output !== "object") {
          return;
        }
        const token = tokens.shift();
        output = Object.hasOwn(output, token) ? output[token] : undefined;
      }
      return output;
    });
  }
  getMessage(rawMessage, rule, field, args) {
    const fieldName = this.#fields[field.name] || field.name;
    const fieldMessage = this.#messages[`${field.getFieldPath()}.${rule}`];
    if (fieldMessage) {
      return this.#interpolate(fieldMessage, {
        field: fieldName,
        ...args
      });
    }
    const wildcardMessage = this.#messages[`${field.wildCardPath}.${rule}`];
    if (wildcardMessage) {
      return this.#interpolate(wildcardMessage, {
        field: fieldName,
        ...args
      });
    }
    const ruleMessage = this.#messages[rule];
    if (ruleMessage) {
      return this.#interpolate(ruleMessage, {
        field: fieldName,
        ...args
      });
    }
    return this.#interpolate(rawMessage, {
      field: fieldName,
      ...args
    });
  }
  toJSON() {
    return {
      messages: this.#messages,
      fields: this.#fields
    };
  }
};
var main_exports3 = {};
__export23(main_exports3, {
  E_VALIDATION_ERROR: () => E_VALIDATION_ERROR3
});
var ValidationError3 = class extends Error {
  constructor(messages23, options3) {
    super("Validation failure", options3);
    this.messages = messages23;
    const ErrorConstructor = this.constructor;
    Error.captureStackTrace(this, ErrorConstructor);
  }
  status = 422;
  code = "E_VALIDATION_ERROR";
  get [Symbol.toStringTag]() {
    return this.constructor.name;
  }
  toString() {
    return `${this.name} [${this.code}]: ${this.message}`;
  }
};
var E_VALIDATION_ERROR3 = ValidationError3;
var SimpleErrorReporter3 = class {
  hasErrors = false;
  errors = [];
  report(message, rule, field, meta) {
    const error = {
      message,
      rule,
      field: field.getFieldPath()
    };
    if (meta) {
      error.meta = meta;
    }
    if (field.isArrayMember) {
      error.index = field.name;
    }
    this.hasErrors = true;
    this.errors.push(error);
  }
  createError() {
    return new E_VALIDATION_ERROR3(this.errors);
  }
};
var BOOLEAN_POSITIVES3 = ["1", 1, "true", true, "on"];
var BOOLEAN_NEGATIVES3 = ["0", 0, "false", false];
var helpers33 = {
  exists(value) {
    return value !== null && value !== undefined;
  },
  isMissing(value) {
    return !this.exists(value);
  },
  isTrue(value) {
    return BOOLEAN_POSITIVES3.includes(value);
  },
  isFalse(value) {
    return BOOLEAN_NEGATIVES3.includes(value);
  },
  isString(value) {
    return typeof value === "string";
  },
  isObject(value) {
    return !!(value && typeof value === "object" && !Array.isArray(value));
  },
  hasKeys(value, keys2) {
    for (let key of keys2) {
      if (key in value === false) {
        return false;
      }
    }
    return true;
  },
  isArray(value) {
    return Array.isArray(value);
  },
  isNumeric(value) {
    return !Number.isNaN(Number(value));
  },
  asNumber(value) {
    return value === null ? Number.NaN : Number(value);
  },
  asBoolean(value) {
    if (this.isTrue(value)) {
      return true;
    }
    if (this.isFalse(value)) {
      return false;
    }
    return null;
  },
  isEmail: import_isEmail3.default.default,
  isURL: import_isURL3.default.default,
  isAlpha: import_isAlpha3.default.default,
  isAlphaNumeric: import_isAlphanumeric3.default.default,
  isIP: import_isIP3.default.default,
  isUUID: import_isUUID3.default.default,
  isAscii: import_isAscii3.default.default,
  isCreditCard: import_isCreditCard3.default.default,
  isIBAN: import_isIBAN3.default.default,
  isJWT: import_isJWT3.default.default,
  isLatLong: import_isLatLong3.default.default,
  isMobilePhone: import_isMobilePhone5.default.default,
  isPassportNumber: import_isPassportNumber3.default.default,
  isPostalCode: import_isPostalCode5.default.default,
  isSlug: import_isSlug3.default.default,
  isDecimal: import_isDecimal3.default.default,
  mobileLocales: import_isMobilePhone23.locales,
  postalCountryCodes: import_isPostalCode23.locales,
  passportCountryCodes: [
    "AM",
    "AR",
    "AT",
    "AU",
    "AZ",
    "BE",
    "BG",
    "BR",
    "BY",
    "CA",
    "CH",
    "CY",
    "CZ",
    "DE",
    "DK",
    "DZ",
    "ES",
    "FI",
    "FR",
    "GB",
    "GR",
    "HR",
    "HU",
    "IE",
    "IN",
    "ID",
    "IR",
    "IS",
    "IT",
    "JM",
    "JP",
    "KR",
    "KZ",
    "LI",
    "LT",
    "LU",
    "LV",
    "LY",
    "MT",
    "MZ",
    "MY",
    "MX",
    "NL",
    "NZ",
    "PH",
    "PK",
    "PL",
    "PT",
    "RO",
    "RU",
    "SE",
    "SL",
    "SK",
    "TH",
    "TR",
    "UA",
    "US"
  ],
  isHexColor: (value) => {
    if (!value.startsWith("#")) {
      return false;
    }
    return import_isHexColor3.default.default(value);
  },
  isActiveURL: async (url) => {
    const { resolve4: resolve42, resolve6: resolve62 } = await import("dns/promises");
    try {
      const { hostname } = new URL(url);
      const v6Addresses = await resolve62(hostname);
      if (v6Addresses.length) {
        return true;
      } else {
        const v4Addresses = await resolve42(hostname);
        return v4Addresses.length > 0;
      }
    } catch {
      return false;
    }
  },
  isDistinct: (dataSet, fields22) => {
    const uniqueItems = /* @__PURE__ */ new Set;
    if (!fields22) {
      for (let item of dataSet) {
        if (helpers33.exists(item)) {
          if (uniqueItems.has(item)) {
            return false;
          } else {
            uniqueItems.add(item);
          }
        }
      }
      return true;
    }
    const fieldsList = Array.isArray(fields22) ? fields22 : [fields22];
    for (let item of dataSet) {
      if (helpers33.isObject(item) && helpers33.hasKeys(item, fieldsList)) {
        const element = fieldsList.map((field) => item[field]).join("_");
        if (uniqueItems.has(element)) {
          return false;
        } else {
          uniqueItems.add(element);
        }
      }
    }
    return true;
  },
  getNestedValue(key, field) {
    if (key.indexOf(".") > -1) {
      return dlv_es_default3(field.data, key);
    }
    return field.parent[key];
  }
};
var Macroable3 = class {
  static macro(name, value) {
    this.prototype[name] = value;
  }
  static getter(name, accumulator, singleton = false) {
    Object.defineProperty(this.prototype, name, {
      get() {
        const value = accumulator.call(this);
        if (singleton) {
          Object.defineProperty(this, name, {
            configurable: false,
            enumerable: false,
            value,
            writable: false
          });
        }
        return value;
      },
      configurable: true,
      enumerable: false
    });
  }
};
var UPPERCASE3 = /[\p{Lu}]/u;
var LOWERCASE3 = /[\p{Ll}]/u;
var LEADING_CAPITAL3 = /^[\p{Lu}](?![\p{Lu}])/gu;
var IDENTIFIER3 = /([\p{Alpha}\p{N}_]|$)/u;
var SEPARATORS3 = /[_.\- ]+/;
var LEADING_SEPARATORS3 = new RegExp("^" + SEPARATORS3.source);
var SEPARATORS_AND_IDENTIFIER3 = new RegExp(SEPARATORS3.source + IDENTIFIER3.source, "gu");
var NUMBERS_AND_IDENTIFIER3 = new RegExp("\\d+" + IDENTIFIER3.source, "gu");
var preserveCamelCase3 = (string2, toLowerCase, toUpperCase, preserveConsecutiveUppercase3) => {
  let isLastCharLower = false;
  let isLastCharUpper = false;
  let isLastLastCharUpper = false;
  let isLastLastCharPreserved = false;
  for (let index = 0;index < string2.length; index++) {
    const character = string2[index];
    isLastLastCharPreserved = index > 2 ? string2[index - 3] === "-" : true;
    if (isLastCharLower && UPPERCASE3.test(character)) {
      string2 = string2.slice(0, index) + "-" + string2.slice(index);
      isLastCharLower = false;
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = true;
      index++;
    } else if (isLastCharUpper && isLastLastCharUpper && LOWERCASE3.test(character) && (!isLastLastCharPreserved || preserveConsecutiveUppercase3)) {
      string2 = string2.slice(0, index - 1) + "-" + string2.slice(index - 1);
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = false;
      isLastCharLower = true;
    } else {
      isLastCharLower = toLowerCase(character) === character && toUpperCase(character) !== character;
      isLastLastCharUpper = isLastCharUpper;
      isLastCharUpper = toUpperCase(character) === character && toLowerCase(character) !== character;
    }
  }
  return string2;
};
var preserveConsecutiveUppercase3 = (input, toLowerCase) => {
  LEADING_CAPITAL3.lastIndex = 0;
  return input.replaceAll(LEADING_CAPITAL3, (match) => toLowerCase(match));
};
var postProcess3 = (input, toUpperCase) => {
  SEPARATORS_AND_IDENTIFIER3.lastIndex = 0;
  NUMBERS_AND_IDENTIFIER3.lastIndex = 0;
  return input.replaceAll(NUMBERS_AND_IDENTIFIER3, (match, pattern, offset) => ["_", "-"].includes(input.charAt(offset + match.length)) ? match : toUpperCase(match)).replaceAll(SEPARATORS_AND_IDENTIFIER3, (_23, identifier) => toUpperCase(identifier));
};
function camelCase23(input, options3) {
  if (!(typeof input === "string" || Array.isArray(input))) {
    throw new TypeError("Expected the input to be `string | string[]`");
  }
  options3 = {
    pascalCase: false,
    preserveConsecutiveUppercase: false,
    ...options3
  };
  if (Array.isArray(input)) {
    input = input.map((x22) => x22.trim()).filter((x22) => x22.length).join("-");
  } else {
    input = input.trim();
  }
  if (input.length === 0) {
    return "";
  }
  const toLowerCase = options3.locale === false ? (string2) => string2.toLowerCase() : (string2) => string2.toLocaleLowerCase(options3.locale);
  const toUpperCase = options3.locale === false ? (string2) => string2.toUpperCase() : (string2) => string2.toLocaleUpperCase(options3.locale);
  if (input.length === 1) {
    if (SEPARATORS3.test(input)) {
      return "";
    }
    return options3.pascalCase ? toUpperCase(input) : toLowerCase(input);
  }
  const hasUpperCase = input !== toLowerCase(input);
  if (hasUpperCase) {
    input = preserveCamelCase3(input, toLowerCase, toUpperCase, options3.preserveConsecutiveUppercase);
  }
  input = input.replace(LEADING_SEPARATORS3, "");
  input = options3.preserveConsecutiveUppercase ? preserveConsecutiveUppercase3(input, toLowerCase) : toLowerCase(input);
  if (options3.pascalCase) {
    input = toUpperCase(input.charAt(0)) + input.slice(1);
  }
  return postProcess3(input, toUpperCase);
}
var import_dayjs5 = __toESM22(require_dayjs_min3(), 1);
var import_dayjs23 = __toESM22(require_dayjs_min3(), 1);
var import_isSameOrAfter3 = __toESM22(require_isSameOrAfter3(), 1);
var import_isSameOrBefore3 = __toESM22(require_isSameOrBefore3(), 1);
var import_customParseFormat3 = __toESM22(require_customParseFormat3(), 1);
var DATA_URL_DEFAULT_MIME_TYPE3 = "text/plain";
var DATA_URL_DEFAULT_CHARSET3 = "us-ascii";
var testParameter3 = (name, filters) => filters.some((filter) => filter instanceof RegExp ? filter.test(name) : filter === name);
var supportedProtocols3 = new Set([
  "https:",
  "http:",
  "file:"
]);
var hasCustomProtocol3 = (urlString) => {
  try {
    const { protocol } = new URL(urlString);
    return protocol.endsWith(":") && !protocol.includes(".") && !supportedProtocols3.has(protocol);
  } catch {
    return false;
  }
};
var normalizeDataURL3 = (urlString, { stripHash }) => {
  const match = /^data:(?<type>[^,]*?),(?<data>[^#]*?)(?:#(?<hash>.*))?$/.exec(urlString);
  if (!match) {
    throw new Error(`Invalid URL: ${urlString}`);
  }
  let { type: type2, data: data2, hash } = match.groups;
  const mediaType = type2.split(";");
  hash = stripHash ? "" : hash;
  let isBase64 = false;
  if (mediaType[mediaType.length - 1] === "base64") {
    mediaType.pop();
    isBase64 = true;
  }
  const mimeType = mediaType.shift()?.toLowerCase() ?? "";
  const attributes = mediaType.map((attribute) => {
    let [key, value = ""] = attribute.split("=").map((string2) => string2.trim());
    if (key === "charset") {
      value = value.toLowerCase();
      if (value === DATA_URL_DEFAULT_CHARSET3) {
        return "";
      }
    }
    return `${key}${value ? `=${value}` : ""}`;
  }).filter(Boolean);
  const normalizedMediaType = [
    ...attributes
  ];
  if (isBase64) {
    normalizedMediaType.push("base64");
  }
  if (normalizedMediaType.length > 0 || mimeType && mimeType !== DATA_URL_DEFAULT_MIME_TYPE3) {
    normalizedMediaType.unshift(mimeType);
  }
  return `data:${normalizedMediaType.join(";")},${isBase64 ? data2.trim() : data2}${hash ? `#${hash}` : ""}`;
};
function normalizeUrl3(urlString, options3) {
  options3 = {
    defaultProtocol: "http",
    normalizeProtocol: true,
    forceHttp: false,
    forceHttps: false,
    stripAuthentication: true,
    stripHash: false,
    stripTextFragment: true,
    stripWWW: true,
    removeQueryParameters: [/^utm_\w+/i],
    removeTrailingSlash: true,
    removeSingleSlash: true,
    removeDirectoryIndex: false,
    removeExplicitPort: false,
    sortQueryParameters: true,
    ...options3
  };
  if (typeof options3.defaultProtocol === "string" && !options3.defaultProtocol.endsWith(":")) {
    options3.defaultProtocol = `${options3.defaultProtocol}:`;
  }
  urlString = urlString.trim();
  if (/^data:/i.test(urlString)) {
    return normalizeDataURL3(urlString, options3);
  }
  if (hasCustomProtocol3(urlString)) {
    return urlString;
  }
  const hasRelativeProtocol = urlString.startsWith("//");
  const isRelativeUrl = !hasRelativeProtocol && /^\.*\//.test(urlString);
  if (!isRelativeUrl) {
    urlString = urlString.replace(/^(?!(?:\w+:)?\/\/)|^\/\//, options3.defaultProtocol);
  }
  const urlObject = new URL(urlString);
  if (options3.forceHttp && options3.forceHttps) {
    throw new Error("The `forceHttp` and `forceHttps` options cannot be used together");
  }
  if (options3.forceHttp && urlObject.protocol === "https:") {
    urlObject.protocol = "http:";
  }
  if (options3.forceHttps && urlObject.protocol === "http:") {
    urlObject.protocol = "https:";
  }
  if (options3.stripAuthentication) {
    urlObject.username = "";
    urlObject.password = "";
  }
  if (options3.stripHash) {
    urlObject.hash = "";
  } else if (options3.stripTextFragment) {
    urlObject.hash = urlObject.hash.replace(/#?:~:text.*?$/i, "");
  }
  if (urlObject.pathname) {
    const protocolRegex = /\b[a-z][a-z\d+\-.]{1,50}:\/\//g;
    let lastIndex = 0;
    let result2 = "";
    for (;; ) {
      const match = protocolRegex.exec(urlObject.pathname);
      if (!match) {
        break;
      }
      const protocol = match[0];
      const protocolAtIndex = match.index;
      const intermediate = urlObject.pathname.slice(lastIndex, protocolAtIndex);
      result2 += intermediate.replace(/\/{2,}/g, "/");
      result2 += protocol;
      lastIndex = protocolAtIndex + protocol.length;
    }
    const remnant = urlObject.pathname.slice(lastIndex, urlObject.pathname.length);
    result2 += remnant.replace(/\/{2,}/g, "/");
    urlObject.pathname = result2;
  }
  if (urlObject.pathname) {
    try {
      urlObject.pathname = decodeURI(urlObject.pathname);
    } catch {
    }
  }
  if (options3.removeDirectoryIndex === true) {
    options3.removeDirectoryIndex = [/^index\.[a-z]+$/];
  }
  if (Array.isArray(options3.removeDirectoryIndex) && options3.removeDirectoryIndex.length > 0) {
    let pathComponents = urlObject.pathname.split("/");
    const lastComponent = pathComponents[pathComponents.length - 1];
    if (testParameter3(lastComponent, options3.removeDirectoryIndex)) {
      pathComponents = pathComponents.slice(0, -1);
      urlObject.pathname = pathComponents.slice(1).join("/") + "/";
    }
  }
  if (urlObject.hostname) {
    urlObject.hostname = urlObject.hostname.replace(/\.$/, "");
    if (options3.stripWWW && /^www\.(?!www\.)[a-z\-\d]{1,63}\.[a-z.\-\d]{2,63}$/.test(urlObject.hostname)) {
      urlObject.hostname = urlObject.hostname.replace(/^www\./, "");
    }
  }
  if (Array.isArray(options3.removeQueryParameters)) {
    for (const key of [...urlObject.searchParams.keys()]) {
      if (testParameter3(key, options3.removeQueryParameters)) {
        urlObject.searchParams.delete(key);
      }
    }
  }
  if (!Array.isArray(options3.keepQueryParameters) && options3.removeQueryParameters === true) {
    urlObject.search = "";
  }
  if (Array.isArray(options3.keepQueryParameters) && options3.keepQueryParameters.length > 0) {
    for (const key of [...urlObject.searchParams.keys()]) {
      if (!testParameter3(key, options3.keepQueryParameters)) {
        urlObject.searchParams.delete(key);
      }
    }
  }
  if (options3.sortQueryParameters) {
    urlObject.searchParams.sort();
    try {
      urlObject.search = decodeURIComponent(urlObject.search);
    } catch {
    }
  }
  if (options3.removeTrailingSlash) {
    urlObject.pathname = urlObject.pathname.replace(/\/$/, "");
  }
  if (options3.removeExplicitPort && urlObject.port) {
    urlObject.port = "";
  }
  const oldUrlString = urlString;
  urlString = urlObject.toString();
  if (!options3.removeSingleSlash && urlObject.pathname === "/" && !oldUrlString.endsWith("/") && urlObject.hash === "") {
    urlString = urlString.replace(/\/$/, "");
  }
  if ((options3.removeTrailingSlash || urlObject.pathname === "/") && urlObject.hash === "" && options3.removeSingleSlash) {
    urlString = urlString.replace(/\/$/, "");
  }
  if (hasRelativeProtocol && !options3.normalizeProtocol) {
    urlString = urlString.replace(/^http:\/\//, "//");
  }
  if (options3.stripProtocol) {
    urlString = urlString.replace(/^(?:https?:)?\/\//, "");
  }
  return urlString;
}
var import_escape3 = __toESM22(require_escape3(), 1);
var import_normalizeEmail3 = __toESM22(require_normalizeEmail3(), 1);
var CompilerBuffer3 = class _CompilerBuffer3 {
  #content = "";
  newLine = "\n";
  writeStatement(statement) {
    this.#content = `${this.#content}${this.newLine}${statement}`;
  }
  child() {
    return new _CompilerBuffer3;
  }
  toString() {
    return this.#content;
  }
  flush() {
    this.#content = "";
  }
};
function defineFieldVariables3({
  parseFnRefId,
  variableName,
  wildCardPath,
  isArrayMember,
  valueExpression,
  parentExpression,
  fieldNameExpression,
  parentValueExpression
}) {
  const inValueExpression = parseFnRefId ? `refs['${parseFnRefId}'](${valueExpression}, {
      data: root,
      meta: meta,
      parent: ${parentValueExpression}
    })` : valueExpression;
  let fieldPathOutputExpression = "";
  if (parentExpression === "root" || parentExpression === "root_item") {
    fieldPathOutputExpression = fieldNameExpression;
  } else if (fieldNameExpression !== "''") {
    fieldPathOutputExpression = `${parentExpression}.getFieldPath() + '.' + ${fieldNameExpression}`;
  }
  return `const ${variableName} = defineValue(${inValueExpression}, {
  data: root,
  meta: meta,
  name: ${fieldNameExpression},
  wildCardPath: '${wildCardPath}',
  getFieldPath() {
    return ${fieldPathOutputExpression};
  },
  mutate: defineValue,
  report: report,
  isValid: true,
  parent: ${parentValueExpression},
  isArrayMember: ${isArrayMember},
});`;
}
var BaseNode3 = class {
  #node;
  #parentField;
  field;
  constructor(node, compiler, parent, parentField) {
    this.#parentField = parentField;
    this.#node = node;
    if (this.#parentField) {
      this.field = this.#parentField;
    } else {
      compiler.variablesCounter++;
      this.field = compiler.createFieldFor(node, parent);
    }
  }
  defineField(buffer) {
    if (!this.#parentField) {
      buffer.writeStatement(defineFieldVariables3({
        fieldNameExpression: this.field.fieldNameExpression,
        isArrayMember: this.field.isArrayMember,
        parentExpression: this.field.parentExpression,
        parentValueExpression: this.field.parentValueExpression,
        valueExpression: this.field.valueExpression,
        variableName: this.field.variableName,
        wildCardPath: this.field.wildCardPath,
        parseFnRefId: "parseFnId" in this.#node ? this.#node.parseFnId : undefined
      }));
    }
  }
};
function defineArrayGuard3({ variableName, guardedCodeSnippet }) {
  return `if (ensureIsArray(${variableName})) {
${guardedCodeSnippet}
}`;
}
function defineIsValidGuard3({ variableName, bail, guardedCodeSnippet }) {
  if (!bail) {
    return guardedCodeSnippet;
  }
  return `if (${variableName}.isValid) {
${guardedCodeSnippet}
}`;
}
function defineFieldNullOutput3({
  allowNull,
  conditional,
  variableName,
  outputExpression,
  transformFnRefId
}) {
  if (!allowNull) {
    return "";
  }
  return `${conditional || "if"}(${variableName}.value === null) {
  ${outputExpression} = ${transformFnRefId ? `refs['${transformFnRefId}'](null, ${variableName});` : "null;"}
}`;
}
function wrapInConditional3(conditions, wrappingCode) {
  const [first, second] = conditions;
  if (first && second) {
    return `if (${first} && ${second}) {
  ${wrappingCode}
}`;
  }
  if (first) {
    return `if (${first}) {
  ${wrappingCode}
}`;
  }
  if (second) {
    return `if (${second}) {
  ${wrappingCode}
}`;
  }
  return wrappingCode;
}
function emitValidationSnippet3({ isAsync, implicit, ruleFnId }, variableName, bail, dropMissingCheck) {
  const rule = `refs['${ruleFnId}']`;
  const callable = `${rule}.validator(${variableName}.value, ${rule}.options, ${variableName});`;
  const bailCondition = bail ? `${variableName}.isValid` : "";
  const implicitCondition = implicit || dropMissingCheck ? "" : `${variableName}.isDefined`;
  return wrapInConditional3([bailCondition, implicitCondition], isAsync ? `await ${callable}` : `${callable}`);
}
function defineFieldValidations3({
  bail,
  validations,
  variableName,
  dropMissingCheck
}) {
  return `${validations.map((one) => emitValidationSnippet3(one, variableName, bail, dropMissingCheck)).join("\n")}`;
}
function defineArrayInitialOutput3({
  variableName,
  outputExpression,
  outputValueExpression
}) {
  return `const ${variableName}_out = ${outputValueExpression};
${outputExpression} = ${variableName}_out;`;
}
function defineFieldExistenceValidations3({
  allowNull,
  isOptional,
  variableName
}) {
  if (isOptional === false) {
    if (allowNull === false) {
      return `ensureExists(${variableName});`;
    } else {
      return `ensureIsDefined(${variableName});`;
    }
  }
  return "";
}
var TupleNodeCompiler3 = class extends BaseNode3 {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #compileTupleChildren() {
    const buffer = this.#buffer.child();
    const parent = {
      type: "tuple",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    };
    this.#node.properties.forEach((child) => {
      this.#compiler.compileNode(child, buffer, parent);
    });
    return buffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations3({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isArrayValidBlock = defineIsValidGuard3({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineArrayInitialOutput3({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: this.#node.allowUnknownProperties ? `copyProperties(${this.field.variableName}.value)` : `[]`
      })}${this.#compileTupleChildren()}`
    });
    const isValueAnArrayBlock = defineArrayGuard3({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations3({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${this.#buffer.newLine}${isArrayValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnArrayBlock}${this.#buffer.newLine}${defineFieldNullOutput3({
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      conditional: "else if"
    })}`);
  }
};
function defineArrayLoop3({
  variableName,
  loopCodeSnippet,
  startingIndex
}) {
  startingIndex = startingIndex || 0;
  return `const ${variableName}_items_size = ${variableName}.value.length;
for (let ${variableName}_i = ${startingIndex}; ${variableName}_i < ${variableName}_items_size; ${variableName}_i++) {
${loopCodeSnippet}
}`;
}
var ArrayNodeCompiler3 = class extends BaseNode3 {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #compileArrayElements() {
    const arrayElementsBuffer = this.#buffer.child();
    this.#compiler.compileNode(this.#node.each, arrayElementsBuffer, {
      type: "array",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    });
    const buffer = this.#buffer.child();
    buffer.writeStatement(defineArrayLoop3({
      variableName: this.field.variableName,
      startingIndex: 0,
      loopCodeSnippet: arrayElementsBuffer.toString()
    }));
    arrayElementsBuffer.flush();
    return buffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations3({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isArrayValidBlock = defineIsValidGuard3({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineArrayInitialOutput3({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: `[]`
      })}${this.#buffer.newLine}${this.#compileArrayElements()}`
    });
    const isValueAnArrayBlock = defineArrayGuard3({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations3({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${this.#buffer.newLine}${isArrayValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnArrayBlock}${this.#buffer.newLine}${defineFieldNullOutput3({
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      conditional: "else if"
    })}`);
  }
};
function callParseFunction3({ parseFnRefId, variableName }) {
  if (parseFnRefId) {
    return `${variableName}.value = refs['${parseFnRefId}'](${variableName}.value);`;
  }
  return "";
}
function defineElseCondition3({ variableName, conditionalFnRefId }) {
  return `else {
refs['${conditionalFnRefId}'](${variableName}.value, ${variableName});
}`;
}
function defineConditionalGuard3({
  conditional,
  variableName,
  conditionalFnRefId,
  guardedCodeSnippet
}) {
  return `${conditional}(refs['${conditionalFnRefId}'](${variableName}.value, ${variableName})) {
${guardedCodeSnippet}
}`;
}
var UnionNodeCompiler3 = class extends BaseNode3 {
  #compiler;
  #node;
  #buffer;
  #parent;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#parent = parent;
    this.#compiler = compiler;
  }
  #compileUnionChildren() {
    const childrenBuffer = this.#buffer.child();
    this.#node.conditions.forEach((child, index) => {
      const conditionalBuffer = this.#buffer.child();
      if ("parseFnId" in child.schema) {
        conditionalBuffer.writeStatement(callParseFunction3({
          parseFnRefId: child.schema.parseFnId,
          variableName: this.field.variableName
        }));
      }
      this.#compiler.compileNode(child.schema, conditionalBuffer, this.#parent, this.field);
      childrenBuffer.writeStatement(defineConditionalGuard3({
        conditional: index === 0 ? "if" : "else if",
        variableName: this.field.variableName,
        conditionalFnRefId: child.conditionalFnRefId,
        guardedCodeSnippet: conditionalBuffer.toString()
      }));
      conditionalBuffer.flush();
    });
    if (this.#node.elseConditionalFnRefId && this.#node.conditions.length) {
      childrenBuffer.writeStatement(defineElseCondition3({
        variableName: this.field.variableName,
        conditionalFnRefId: this.#node.elseConditionalFnRefId
      }));
    }
    return childrenBuffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(this.#compileUnionChildren());
  }
};
function defineRecordLoop3({ variableName, loopCodeSnippet }) {
  return `const ${variableName}_keys = Object.keys(${variableName}.value);
const ${variableName}_keys_size = ${variableName}_keys.length;
for (let ${variableName}_key_i = 0; ${variableName}_key_i < ${variableName}_keys_size; ${variableName}_key_i++) {
const ${variableName}_i = ${variableName}_keys[${variableName}_key_i];
${loopCodeSnippet}
}`;
}
function defineObjectGuard3({ variableName, guardedCodeSnippet }) {
  return `if (ensureIsObject(${variableName})) {
${guardedCodeSnippet}
}`;
}
function defineObjectInitialOutput3({
  variableName,
  outputExpression,
  outputValueExpression
}) {
  return `const ${variableName}_out = ${outputValueExpression};
${outputExpression} = ${variableName}_out;`;
}
var RecordNodeCompiler3 = class extends BaseNode3 {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #compileRecordElements() {
    const buffer = this.#buffer.child();
    const recordElementsBuffer = this.#buffer.child();
    this.#compiler.compileNode(this.#node.each, recordElementsBuffer, {
      type: "record",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    });
    buffer.writeStatement(defineRecordLoop3({
      variableName: this.field.variableName,
      loopCodeSnippet: recordElementsBuffer.toString()
    }));
    recordElementsBuffer.flush();
    return buffer.toString();
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations3({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isObjectValidBlock = defineIsValidGuard3({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineObjectInitialOutput3({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: `{}`
      })}${this.#compileRecordElements()}`
    });
    const isValueAnObjectBlock = defineObjectGuard3({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations3({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${this.#buffer.newLine}${isObjectValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnObjectBlock}${this.#buffer.newLine}${defineFieldNullOutput3({
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      conditional: "else if"
    })}`);
  }
};
function arrayToString3(arr) {
  return `[${arr.map((str2) => `"${str2}"`).join(", ")}]`;
}
function defineMoveProperties3({
  variableName,
  fieldsToIgnore,
  allowUnknownProperties
}) {
  if (!allowUnknownProperties) {
    return "";
  }
  const serializedFieldsToIgnore = arrayToString3(fieldsToIgnore);
  return `moveProperties(${variableName}.value, ${variableName}_out, ${serializedFieldsToIgnore});`;
}
var ObjectNodeCompiler3 = class extends BaseNode3 {
  #node;
  #buffer;
  #compiler;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
    this.#compiler = compiler;
  }
  #getFieldNames(node) {
    let fieldNames = node.properties.map((child) => child.fieldName);
    const groupsFieldNames = node.groups.flatMap((group3) => this.#getGroupFieldNames(group3));
    return fieldNames.concat(groupsFieldNames);
  }
  #getGroupFieldNames(group3) {
    return group3.conditions.flatMap((condition) => {
      return this.#getFieldNames(condition.schema);
    });
  }
  #compileObjectChildren() {
    const buffer = this.#buffer.child();
    const parent = {
      type: "object",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    };
    this.#node.properties.forEach((child) => this.#compiler.compileNode(child, buffer, parent));
    return buffer.toString();
  }
  #compileObjectGroups() {
    const buffer = this.#buffer.child();
    const parent = {
      type: "object",
      fieldPathExpression: this.field.fieldPathExpression,
      outputExpression: this.field.outputExpression,
      variableName: this.field.variableName,
      wildCardPath: this.field.wildCardPath
    };
    this.#node.groups.forEach((group3) => this.#compileObjectGroup(group3, buffer, parent));
    return buffer.toString();
  }
  #compileObjectGroup(group3, buffer, parent) {
    group3.conditions.forEach((condition, index) => {
      const guardBuffer = buffer.child();
      condition.schema.properties.forEach((child) => {
        this.#compiler.compileNode(child, guardBuffer, parent);
      });
      condition.schema.groups.forEach((child) => {
        this.#compileObjectGroup(child, guardBuffer, parent);
      });
      buffer.writeStatement(defineConditionalGuard3({
        variableName: this.field.variableName,
        conditional: index === 0 ? "if" : "else if",
        conditionalFnRefId: condition.conditionalFnRefId,
        guardedCodeSnippet: guardBuffer.toString()
      }));
    });
    if (group3.elseConditionalFnRefId && group3.conditions.length) {
      buffer.writeStatement(defineElseCondition3({
        variableName: this.field.variableName,
        conditionalFnRefId: group3.elseConditionalFnRefId
      }));
    }
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations3({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    const isObjectValidBlock = defineIsValidGuard3({
      variableName: this.field.variableName,
      bail: this.#node.bail,
      guardedCodeSnippet: `${defineObjectInitialOutput3({
        variableName: this.field.variableName,
        outputExpression: this.field.outputExpression,
        outputValueExpression: "{}"
      })}${this.#buffer.newLine}${this.#compileObjectChildren()}${this.#buffer.newLine}${this.#compileObjectGroups()}${this.#buffer.newLine}${defineMoveProperties3({
        variableName: this.field.variableName,
        allowUnknownProperties: this.#node.allowUnknownProperties,
        fieldsToIgnore: this.#node.allowUnknownProperties ? this.#getFieldNames(this.#node) : []
      })}`
    });
    const isValueAnObject = defineObjectGuard3({
      variableName: this.field.variableName,
      guardedCodeSnippet: `${defineFieldValidations3({
        variableName: this.field.variableName,
        validations: this.#node.validations,
        bail: this.#node.bail,
        dropMissingCheck: true
      })}${isObjectValidBlock}`
    });
    this.#buffer.writeStatement(`${isValueAnObject}${this.#buffer.newLine}${defineFieldNullOutput3({
      variableName: this.field.variableName,
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      conditional: "else if"
    })}`);
  }
};
function createRootField3(parent) {
  return {
    parentExpression: parent.variableName,
    parentValueExpression: parent.variableName,
    fieldNameExpression: `''`,
    fieldPathExpression: `''`,
    wildCardPath: "",
    variableName: `${parent.variableName}_item`,
    valueExpression: "root",
    outputExpression: parent.outputExpression,
    isArrayMember: false
  };
}
function defineFieldValueOutput3({
  variableName,
  outputExpression,
  transformFnRefId
}) {
  const outputValueExpression = transformFnRefId ? `refs['${transformFnRefId}'](${variableName}.value, ${variableName})` : `${variableName}.value`;
  return `if (${variableName}.isDefined && ${variableName}.isValid) {
  ${outputExpression} = ${outputValueExpression};
}`;
}
var LiteralNodeCompiler3 = class extends BaseNode3 {
  #node;
  #buffer;
  constructor(node, buffer, compiler, parent, parentField) {
    super(node, compiler, parent, parentField);
    this.#node = node;
    this.#buffer = buffer;
  }
  compile() {
    this.defineField(this.#buffer);
    this.#buffer.writeStatement(defineFieldExistenceValidations3({
      allowNull: this.#node.allowNull,
      isOptional: this.#node.isOptional,
      variableName: this.field.variableName
    }));
    this.#buffer.writeStatement(defineFieldValidations3({
      variableName: this.field.variableName,
      validations: this.#node.validations,
      bail: this.#node.bail,
      dropMissingCheck: false
    }));
    this.#buffer.writeStatement(`${defineFieldValueOutput3({
      variableName: this.field.variableName,
      outputExpression: this.field.outputExpression,
      transformFnRefId: this.#node.transformFnId
    })}${this.#buffer.newLine}${defineFieldNullOutput3({
      variableName: this.field.variableName,
      allowNull: this.#node.allowNull,
      outputExpression: this.field.outputExpression,
      transformFnRefId: this.#node.transformFnId,
      conditional: "else if"
    })}`);
  }
};
function createArrayField3(parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.*` : `*`;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${parent.variableName}_i`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item`,
    valueExpression: `${parent.variableName}.value[${parent.variableName}_i]`,
    outputExpression: `${parent.variableName}_out[${parent.variableName}_i]`,
    isArrayMember: true
  };
}
function createTupleField3(node, parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.${node.fieldName}` : node.fieldName;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${node.fieldName}`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item_${node.fieldName}`,
    valueExpression: `${parent.variableName}.value[${node.fieldName}]`,
    outputExpression: `${parent.variableName}_out[${node.propertyName}]`,
    isArrayMember: true
  };
}
function reportErrors3() {
  return `if(errorReporter.hasErrors) {
  throw errorReporter.createError();
}`;
}
function createObjectField3(node, variablesCounter, parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.${node.fieldName}` : node.fieldName;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `'${node.fieldName}'`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${node.propertyName}_${variablesCounter}`,
    valueExpression: `${parent.variableName}.value['${node.fieldName}']`,
    outputExpression: `${parent.variableName}_out['${node.propertyName}']`,
    isArrayMember: false
  };
}
function createRecordField3(parent) {
  const wildCardPath = parent.wildCardPath !== "" ? `${parent.wildCardPath}.*` : `*`;
  return {
    parentExpression: parent.variableName,
    parentValueExpression: `${parent.variableName}.value`,
    fieldNameExpression: `${parent.variableName}_i`,
    fieldPathExpression: wildCardPath,
    wildCardPath,
    variableName: `${parent.variableName}_item`,
    valueExpression: `${parent.variableName}.value[${parent.variableName}_i]`,
    outputExpression: `${parent.variableName}_out[${parent.variableName}_i]`,
    isArrayMember: false
  };
}
function defineInlineFunctions3(options3) {
  return `function report(message, rule, field, args) {
  field.isValid = false;
  errorReporter.report(messagesProvider.getMessage(message, rule, field, args), rule, field, args);
};
function defineValue(value, field) {
  ${options3.convertEmptyStringsToNull ? `if (value === '') { value = null; }` : ""}
  field.value = value;
  field.isDefined = value !== undefined && value !== null;
  return field;
};
function ensureExists(field) {
  if (field.value === undefined || field.value === null) {
    field.report(REQUIRED, 'required', field);
    return false;
  }
  return true;
};
function ensureIsDefined(field) {
  if (field.value === undefined) {
    field.report(REQUIRED, 'required', field);
    return false;
  }
  return true;
};
function ensureIsObject(field) {
  if (!field.isDefined) {
    return false;
  }
  if (typeof field.value == 'object' && !Array.isArray(field.value)) {
    return true;
  }
  field.report(NOT_AN_OBJECT, 'object', field);
  return false;
};
function ensureIsArray(field) {
  if (!field.isDefined) {
    return false;
  }
  if (Array.isArray(field.value)) {
    return true;
  }
  field.report(NOT_AN_ARRAY, 'array', field);
  return false;
};
function copyProperties(val) {
  let k, out, tmp;

  if (Array.isArray(val)) {
    out = Array((k = val.length))
    while (k--) out[k] = (tmp = val[k]) && typeof tmp == 'object' ? copyProperties(tmp) : tmp
    return out
  }

  if (Object.prototype.toString.call(val) === '[object Object]') {
    out = {} // null
    for (k in val) {
      out[k] = (tmp = val[k]) && typeof tmp == 'object' ? copyProperties(tmp) : tmp
    }
    return out
  }
  return val
};
function moveProperties(source, destination, ignoreKeys) {
  for (let key in source) {
    if (!ignoreKeys.includes(key)) {
      const value = source[key]
      destination[key] = copyProperties(value)
    }
  }
};`;
}
function defineInlineErrorMessages3(messages23) {
  return `const REQUIRED = '${messages23.required}';
const NOT_AN_OBJECT = '${messages23.object}';
const NOT_AN_ARRAY = '${messages23.array}';`;
}
var AsyncFunction3 = Object.getPrototypeOf(async function() {
}).constructor;
var Compiler3 = class {
  variablesCounter = 0;
  #rootNode;
  #options;
  #buffer = new CompilerBuffer3;
  constructor(rootNode, options3) {
    this.#rootNode = rootNode;
    this.#options = options3 || { convertEmptyStringsToNull: false };
  }
  #initiateJSOutput() {
    this.#buffer.writeStatement(defineInlineErrorMessages3({
      required: "value is required",
      object: "value is not a valid object",
      array: "value is not a valid array",
      ...this.#options.messages
    }));
    this.#buffer.writeStatement(defineInlineFunctions3(this.#options));
    this.#buffer.writeStatement("let out;");
  }
  #finishJSOutput() {
    this.#buffer.writeStatement(reportErrors3());
    this.#buffer.writeStatement("return out;");
  }
  #compileNodes() {
    this.compileNode(this.#rootNode.schema, this.#buffer, {
      type: "root",
      variableName: "root",
      outputExpression: "out",
      fieldPathExpression: "out",
      wildCardPath: ""
    });
  }
  #toAsyncFunction() {
    return new AsyncFunction3("root", "meta", "refs", "messagesProvider", "errorReporter", this.#buffer.toString());
  }
  createFieldFor(node, parent) {
    switch (parent.type) {
      case "array":
        return createArrayField3(parent);
      case "root":
        return createRootField3(parent);
      case "object":
        return createObjectField3(node, this.variablesCounter, parent);
      case "tuple":
        return createTupleField3(node, parent);
      case "record":
        return createRecordField3(parent);
    }
  }
  compileNode(node, buffer, parent, parentField) {
    switch (node.type) {
      case "literal":
        return new LiteralNodeCompiler3(node, buffer, this, parent, parentField).compile();
      case "array":
        return new ArrayNodeCompiler3(node, buffer, this, parent, parentField).compile();
      case "record":
        return new RecordNodeCompiler3(node, buffer, this, parent, parentField).compile();
      case "object":
        return new ObjectNodeCompiler3(node, buffer, this, parent, parentField).compile();
      case "tuple":
        return new TupleNodeCompiler3(node, buffer, this, parent, parentField).compile();
      case "union":
        return new UnionNodeCompiler3(node, buffer, this, parent, parentField).compile();
    }
  }
  compile() {
    this.#initiateJSOutput();
    this.#compileNodes();
    this.#finishJSOutput();
    const outputFunction = this.#toAsyncFunction();
    this.variablesCounter = 0;
    this.#buffer.flush();
    return outputFunction;
  }
};
function refsBuilder3() {
  let counter = 0;
  const refs = {};
  return {
    toJSON() {
      return refs;
    },
    track(value) {
      counter++;
      const ref2 = `ref://${counter}`;
      refs[ref2] = value;
      return ref2;
    },
    trackValidation(validation) {
      return this.track(validation);
    },
    trackParser(fn) {
      return this.track(fn);
    },
    trackTransformer(fn) {
      return this.track(fn);
    },
    trackConditional(fn) {
      return this.track(fn);
    }
  };
}
function createRule3(validator, metaData) {
  const rule = {
    validator,
    isAsync: metaData?.isAsync || validator.constructor.name === "AsyncFunction",
    implicit: metaData?.implicit ?? false
  };
  return function(...options3) {
    return {
      rule,
      options: options3[0]
    };
  };
}
var symbols_exports3 = {};
__export23(symbols_exports3, {
  COTYPE: () => COTYPE3,
  IS_OF_TYPE: () => IS_OF_TYPE3,
  ITYPE: () => ITYPE3,
  OTYPE: () => OTYPE3,
  PARSE: () => PARSE3,
  UNIQUE_NAME: () => UNIQUE_NAME3,
  VALIDATION: () => VALIDATION3
});
var UNIQUE_NAME3 = Symbol.for("schema_name");
var IS_OF_TYPE3 = Symbol.for("is_of_type");
var PARSE3 = Symbol.for("parse");
var ITYPE3 = Symbol.for("opaque_input_type");
var OTYPE3 = Symbol.for("opaque_type");
var COTYPE3 = Symbol.for("camelcase_opaque_type");
var VALIDATION3 = Symbol.for("to_validation");
var requiredWhen3 = createRule3((_23, checker, field) => {
  const shouldBeRequired = checker(field);
  if (!field.isDefined && shouldBeRequired) {
    field.report(messages3.required, "required", field);
  }
}, {
  implicit: true
});
var BaseModifiersType5 = class extends Macroable3 {
  optional(validations) {
    return new OptionalModifier5(this, validations);
  }
  nullable() {
    return new NullableModifier5(this);
  }
  transform(transformer) {
    return new TransformModifier3(transformer, this);
  }
};
var NullableModifier5 = class _NullableModifier3 extends BaseModifiersType5 {
  #parent;
  constructor(parent) {
    super();
    this.#parent = parent;
  }
  clone() {
    return new _NullableModifier3(this.#parent.clone());
  }
  [PARSE3](propertyName, refs, options3) {
    const output = this.#parent[PARSE3](propertyName, refs, options3);
    output.allowNull = true;
    return output;
  }
};
var OptionalModifier5 = class _OptionalModifier3 extends BaseModifiersType5 {
  #parent;
  validations;
  constructor(parent, validations) {
    super();
    this.#parent = parent;
    this.validations = validations || [];
  }
  cloneValidations() {
    return this.validations.map((validation) => {
      return {
        options: validation.options,
        rule: validation.rule
      };
    });
  }
  compileValidations(refs) {
    return this.validations.map((validation) => {
      return {
        ruleFnId: refs.track({
          validator: validation.rule.validator,
          options: validation.options
        }),
        implicit: validation.rule.implicit,
        isAsync: validation.rule.isAsync
      };
    });
  }
  use(validation) {
    this.validations.push(VALIDATION3 in validation ? validation[VALIDATION3]() : validation);
    return this;
  }
  requiredWhen(otherField, operator, expectedValue) {
    if (typeof otherField === "function") {
      return this.use(requiredWhen3(otherField));
    }
    let checker;
    switch (operator) {
      case "=":
        checker = (value) => value === expectedValue;
        break;
      case "!=":
        checker = (value) => value !== expectedValue;
        break;
      case "in":
        checker = (value) => expectedValue.includes(value);
        break;
      case "notIn":
        checker = (value) => !expectedValue.includes(value);
        break;
      case ">":
        checker = (value) => value > expectedValue;
        break;
      case "<":
        checker = (value) => value < expectedValue;
        break;
      case ">=":
        checker = (value) => value >= expectedValue;
        break;
      case "<=":
        checker = (value) => value <= expectedValue;
    }
    return this.use(requiredWhen3((field) => {
      const otherFieldValue = helpers33.getNestedValue(otherField, field);
      return checker(otherFieldValue);
    }));
  }
  requiredIfExists(fields22) {
    const fieldsToExist = Array.isArray(fields22) ? fields22 : [fields22];
    return this.use(requiredWhen3((field) => {
      return fieldsToExist.every((otherField) => helpers33.exists(helpers33.getNestedValue(otherField, field)));
    }));
  }
  requiredIfAnyExists(fields22) {
    return this.use(requiredWhen3((field) => {
      return fields22.some((otherField) => helpers33.exists(helpers33.getNestedValue(otherField, field)));
    }));
  }
  requiredIfMissing(fields22) {
    const fieldsToExist = Array.isArray(fields22) ? fields22 : [fields22];
    return this.use(requiredWhen3((field) => {
      return fieldsToExist.every((otherField) => helpers33.isMissing(helpers33.getNestedValue(otherField, field)));
    }));
  }
  requiredIfAnyMissing(fields22) {
    return this.use(requiredWhen3((field) => {
      return fields22.some((otherField) => helpers33.isMissing(helpers33.getNestedValue(otherField, field)));
    }));
  }
  clone() {
    return new _OptionalModifier3(this.#parent.clone(), this.cloneValidations());
  }
  [PARSE3](propertyName, refs, options3) {
    const output = this.#parent[PARSE3](propertyName, refs, options3);
    output.isOptional = true;
    output.validations = output.validations.concat(this.compileValidations(refs));
    return output;
  }
};
var TransformModifier3 = class _TransformModifier2 extends BaseModifiersType5 {
  #parent;
  #transform;
  constructor(transform, parent) {
    super();
    this.#transform = transform;
    this.#parent = parent;
  }
  clone() {
    return new _TransformModifier2(this.#transform, this.#parent.clone());
  }
  [PARSE3](propertyName, refs, options3) {
    const output = this.#parent[PARSE3](propertyName, refs, options3);
    output.transformFnId = refs.trackTransformer(this.#transform);
    return output;
  }
};
var BaseLiteralType3 = class extends BaseModifiersType5 {
  options;
  validations;
  constructor(options3, validations) {
    super();
    this.options = {
      bail: true,
      allowNull: false,
      isOptional: false,
      ...options3
    };
    this.validations = validations || [];
  }
  cloneValidations() {
    return this.validations.map((validation) => {
      return {
        options: validation.options,
        rule: validation.rule
      };
    });
  }
  cloneOptions() {
    return { ...this.options };
  }
  compileValidations(refs) {
    return this.validations.map((validation) => {
      return {
        ruleFnId: refs.track({
          validator: validation.rule.validator,
          options: validation.options
        }),
        implicit: validation.rule.implicit,
        isAsync: validation.rule.isAsync
      };
    });
  }
  parse(callback) {
    this.options.parse = callback;
    return this;
  }
  use(validation) {
    this.validations.push(VALIDATION3 in validation ? validation[VALIDATION3]() : validation);
    return this;
  }
  bail(state) {
    this.options.bail = state;
    return this;
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      type: "literal",
      fieldName: propertyName,
      propertyName: options3.toCamelCase ? camelCase23(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs)
    };
  }
};
var VineAny3 = class _VineAny2 extends BaseLiteralType3 {
  constructor(options3, validations) {
    super(options3, validations);
  }
  clone() {
    return new _VineAny2(this.cloneOptions(), this.cloneValidations());
  }
};
var enumRule3 = createRule3((value, options3, field) => {
  const choices = typeof options3.choices === "function" ? options3.choices(field) : options3.choices;
  if (!choices.includes(value)) {
    field.report(messages3.enum, "enum", field, { choices });
  }
});
var VineEnum3 = class _VineEnum2 extends BaseLiteralType3 {
  static rules = {
    enum: enumRule3
  };
  #values;
  getChoices() {
    return this.#values;
  }
  constructor(values3, options3, validations) {
    super(options3, validations || [enumRule3({ choices: values3 })]);
    this.#values = values3;
  }
  clone() {
    return new _VineEnum2(this.#values, this.cloneOptions(), this.cloneValidations());
  }
};
var DEFAULT_DATE_FORMATS3 = ["YYYY-MM-DD", "YYYY-MM-DD HH:mm:ss"];
import_dayjs23.default.extend(import_customParseFormat3.default);
import_dayjs23.default.extend(import_isSameOrAfter3.default);
import_dayjs23.default.extend(import_isSameOrBefore3.default);
var dateRule3 = createRule3((value, options3, field) => {
  if (typeof value !== "string" && typeof value !== "number") {
    field.report(messages3.date, "date", field);
    return;
  }
  let isTimestampAllowed = false;
  let formats = options3.formats || DEFAULT_DATE_FORMATS3;
  if (Array.isArray(formats)) {
    formats = [...formats];
    isTimestampAllowed = formats.includes("x");
  } else if (typeof formats !== "string") {
    formats = { ...formats };
    isTimestampAllowed = formats.format === "x";
  }
  const valueAsNumber = isTimestampAllowed ? helpers33.asNumber(value) : value;
  const dateTime = isTimestampAllowed && !Number.isNaN(valueAsNumber) ? import_dayjs23.default(valueAsNumber) : import_dayjs23.default(value, formats, true);
  if (!dateTime.isValid()) {
    field.report(messages3.date, "date", field);
    return;
  }
  field.meta.$value = dateTime;
  field.meta.$formats = formats;
  field.mutate(dateTime.toDate(), field);
});
var equalsRule5 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const format = options3.format || DEFAULT_DATE_FORMATS3;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options3.expectedValue === "function" ? options3.expectedValue(field) : options3.expectedValue;
  const expectedDateTime = import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the equals rule`);
  }
  if (!dateTime.isSame(expectedDateTime, compare2)) {
    field.report(messages3["date.equals"], "date.equals", field, {
      expectedValue,
      compare: compare2
    });
  }
});
var afterRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const format = options3.format || DEFAULT_DATE_FORMATS3;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options3.expectedValue === "function" ? options3.expectedValue(field) : options3.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs23.default() : expectedValue === "tomorrow" ? import_dayjs23.default().add(1, "day") : import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the after rule`);
  }
  if (!dateTime.isAfter(expectedDateTime, compare2)) {
    field.report(messages3["date.after"], "date.after", field, {
      expectedValue,
      compare: compare2
    });
  }
});
var afterOrEqualRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const format = options3.format || DEFAULT_DATE_FORMATS3;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options3.expectedValue === "function" ? options3.expectedValue(field) : options3.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs23.default() : expectedValue === "tomorrow" ? import_dayjs23.default().add(1, "day") : import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the afterOrEqual rule`);
  }
  if (!dateTime.isSameOrAfter(expectedDateTime, compare2)) {
    field.report(messages3["date.afterOrEqual"], "date.afterOrEqual", field, {
      expectedValue,
      compare: compare2
    });
  }
});
var beforeRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const format = options3.format || DEFAULT_DATE_FORMATS3;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options3.expectedValue === "function" ? options3.expectedValue(field) : options3.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs23.default() : expectedValue === "yesterday" ? import_dayjs23.default().subtract(1, "day") : import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the before rule`);
  }
  if (!dateTime.isBefore(expectedDateTime, compare2)) {
    field.report(messages3["date.before"], "date.before", field, {
      expectedValue,
      compare: compare2
    });
  }
});
var beforeOrEqualRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const format = options3.format || DEFAULT_DATE_FORMATS3;
  const dateTime = field.meta.$value;
  const expectedValue = typeof options3.expectedValue === "function" ? options3.expectedValue(field) : options3.expectedValue;
  const expectedDateTime = expectedValue === "today" ? import_dayjs23.default() : expectedValue === "yesterday" ? import_dayjs23.default().subtract(1, "day") : import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    throw new Error(`Invalid datetime value "${expectedValue}" value provided to the beforeOrEqual rule`);
  }
  if (!dateTime.isSameOrBefore(expectedDateTime, compare2)) {
    field.report(messages3["date.beforeOrEqual"], "date.beforeOrEqual", field, {
      expectedValue,
      compare: compare2
    });
  }
});
var sameAsRule5 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const dateTime = field.meta.$value;
  const format = options3.format || field.meta.$formats;
  const expectedValue = helpers33.getNestedValue(options3.otherField, field);
  const expectedDateTime = import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isSame(expectedDateTime, compare2)) {
    field.report(messages3["date.sameAs"], "date.sameAs", field, {
      otherField: options3.otherField,
      expectedValue,
      compare: compare2
    });
  }
});
var notSameAsRule5 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const dateTime = field.meta.$value;
  const format = options3.format || field.meta.$formats;
  const expectedValue = helpers33.getNestedValue(options3.otherField, field);
  const expectedDateTime = import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (dateTime.isSame(expectedDateTime, compare2)) {
    field.report(messages3["date.notSameAs"], "date.notSameAs", field, {
      otherField: options3.otherField,
      expectedValue,
      compare: compare2
    });
  }
});
var afterFieldRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const dateTime = field.meta.$value;
  const format = options3.format || field.meta.$formats;
  const expectedValue = helpers33.getNestedValue(options3.otherField, field);
  const expectedDateTime = import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isAfter(expectedDateTime, compare2)) {
    field.report(messages3["date.afterField"], "date.afterField", field, {
      otherField: options3.otherField,
      expectedValue,
      compare: compare2
    });
  }
});
var afterOrSameAsRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const dateTime = field.meta.$value;
  const format = options3.format || field.meta.$formats;
  const expectedValue = helpers33.getNestedValue(options3.otherField, field);
  const expectedDateTime = import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isSameOrAfter(expectedDateTime, compare2)) {
    field.report(messages3["date.afterOrSameAs"], "date.afterOrSameAs", field, {
      otherField: options3.otherField,
      expectedValue,
      compare: compare2
    });
  }
});
var beforeFieldRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const dateTime = field.meta.$value;
  const format = options3.format || field.meta.$formats;
  const expectedValue = helpers33.getNestedValue(options3.otherField, field);
  const expectedDateTime = import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isBefore(expectedDateTime, compare2)) {
    field.report(messages3["date.beforeField"], "date.beforeField", field, {
      otherField: options3.otherField,
      expectedValue,
      compare: compare2
    });
  }
});
var beforeOrSameAsRule3 = createRule3((_23, options3, field) => {
  if (!field.meta.$value) {
    return;
  }
  const compare2 = options3.compare || "day";
  const dateTime = field.meta.$value;
  const format = options3.format || field.meta.$formats;
  const expectedValue = helpers33.getNestedValue(options3.otherField, field);
  const expectedDateTime = import_dayjs23.default(expectedValue, format, true);
  if (!expectedDateTime.isValid()) {
    return;
  }
  if (!dateTime.isSameOrBefore(expectedDateTime, compare2)) {
    field.report(messages3["date.beforeOrSameAs"], "date.beforeOrSameAs", field, {
      otherField: options3.otherField,
      expectedValue,
      compare: compare2
    });
  }
});
var weekendRule3 = createRule3((_23, __, field) => {
  if (!field.meta.$value) {
    return;
  }
  const dateTime = field.meta.$value;
  const day = dateTime.day();
  if (day !== 0 && day !== 6) {
    field.report(messages3["date.weekend"], "date.weekend", field);
  }
});
var weekdayRule3 = createRule3((_23, __, field) => {
  if (!field.meta.$value) {
    return;
  }
  const dateTime = field.meta.$value;
  const day = dateTime.day();
  if (day === 0 || day === 6) {
    field.report(messages3["date.weekday"], "date.weekday", field);
  }
});
var VineDate3 = class _VineDate2 extends BaseLiteralType3 {
  static rules = {
    equals: equalsRule5,
    after: afterRule3,
    afterOrEqual: afterOrEqualRule3,
    before: beforeRule3,
    beforeOrEqual: beforeOrEqualRule3,
    sameAs: sameAsRule5,
    notSameAs: notSameAsRule5,
    afterField: afterFieldRule3,
    afterOrSameAs: afterOrSameAsRule3,
    beforeField: beforeFieldRule3,
    beforeOrSameAs: beforeOrSameAsRule3,
    weekend: weekendRule3,
    weekday: weekdayRule3
  };
  [UNIQUE_NAME3] = "vine.date";
  [IS_OF_TYPE3] = (value) => {
    if (typeof value !== "string") {
      return false;
    }
    return import_dayjs5.default(value, this.options.formats || DEFAULT_DATE_FORMATS3, true).isValid();
  };
  constructor(options3, validations) {
    super(options3, validations || [dateRule3(options3 || {})]);
  }
  equals(expectedValue, options3) {
    return this.use(equalsRule5({ expectedValue, ...options3 }));
  }
  after(expectedValue, options3) {
    return this.use(afterRule3({ expectedValue, ...options3 }));
  }
  afterOrEqual(expectedValue, options3) {
    return this.use(afterOrEqualRule3({ expectedValue, ...options3 }));
  }
  before(expectedValue, options3) {
    return this.use(beforeRule3({ expectedValue, ...options3 }));
  }
  beforeOrEqual(expectedValue, options3) {
    return this.use(beforeOrEqualRule3({ expectedValue, ...options3 }));
  }
  sameAs(otherField, options3) {
    return this.use(sameAsRule5({ otherField, ...options3 }));
  }
  notSameAs(otherField, options3) {
    return this.use(notSameAsRule5({ otherField, ...options3 }));
  }
  afterField(otherField, options3) {
    return this.use(afterFieldRule3({ otherField, ...options3 }));
  }
  afterOrSameAs(otherField, options3) {
    return this.use(afterOrSameAsRule3({ otherField, ...options3 }));
  }
  beforeField(otherField, options3) {
    return this.use(beforeFieldRule3({ otherField, ...options3 }));
  }
  beforeOrSameAs(otherField, options3) {
    return this.use(beforeOrSameAsRule3({ otherField, ...options3 }));
  }
  weekend() {
    return this.use(weekendRule3());
  }
  weekday() {
    return this.use(weekdayRule3());
  }
  clone() {
    return new _VineDate2(this.cloneOptions(), this.cloneValidations());
  }
};
var VineUnion3 = class _VineUnion2 {
  #conditionals;
  #otherwiseCallback = (_23, field) => {
    field.report(messages3.union, "union", field);
  };
  constructor(conditionals) {
    this.#conditionals = conditionals;
  }
  otherwise(callback) {
    this.#otherwiseCallback = callback;
    return this;
  }
  clone() {
    const cloned = new _VineUnion2(this.#conditionals);
    cloned.otherwise(this.#otherwiseCallback);
    return cloned;
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      type: "union",
      fieldName: propertyName,
      propertyName: options3.toCamelCase ? camelCase23(propertyName) : propertyName,
      elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
      conditions: this.#conditionals.map((conditional) => conditional[PARSE3](propertyName, refs, options3))
    };
  }
};
var UnionConditional3 = class {
  #schema;
  #conditional;
  constructor(conditional, schema) {
    this.#schema = schema;
    this.#conditional = conditional;
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      conditionalFnRefId: refs.trackConditional(this.#conditional),
      schema: this.#schema[PARSE3](propertyName, refs, options3)
    };
  }
};
function union3(conditionals) {
  return new VineUnion3(conditionals);
}
union3.if = function unionIf2(conditon, schema) {
  return new UnionConditional3(conditon, schema);
};
union3.else = function unionElse2(schema) {
  return new UnionConditional3(() => true, schema);
};
var BaseModifiersType23 = class extends Macroable3 {
  optional() {
    return new OptionalModifier23(this);
  }
  nullable() {
    return new NullableModifier23(this);
  }
};
var NullableModifier23 = class _NullableModifier22 extends BaseModifiersType23 {
  #parent;
  constructor(parent) {
    super();
    this.#parent = parent;
  }
  clone() {
    return new _NullableModifier22(this.#parent.clone());
  }
  [PARSE3](propertyName, refs, options3) {
    const output = this.#parent[PARSE3](propertyName, refs, options3);
    if (output.type !== "union") {
      output.allowNull = true;
    }
    return output;
  }
};
var OptionalModifier23 = class _OptionalModifier22 extends BaseModifiersType23 {
  #parent;
  constructor(parent) {
    super();
    this.#parent = parent;
  }
  clone() {
    return new _OptionalModifier22(this.#parent.clone());
  }
  [PARSE3](propertyName, refs, options3) {
    const output = this.#parent[PARSE3](propertyName, refs, options3);
    if (output.type !== "union") {
      output.isOptional = true;
    }
    return output;
  }
};
var BaseType3 = class extends BaseModifiersType23 {
  options;
  validations;
  constructor(options3, validations) {
    super();
    this.options = options3 || {
      bail: true,
      allowNull: false,
      isOptional: false
    };
    this.validations = validations || [];
  }
  cloneValidations() {
    return this.validations.map((validation) => {
      return {
        options: validation.options,
        rule: validation.rule
      };
    });
  }
  cloneOptions() {
    return { ...this.options };
  }
  compileValidations(refs) {
    return this.validations.map((validation) => {
      return {
        ruleFnId: refs.track({
          validator: validation.rule.validator,
          options: validation.options
        }),
        implicit: validation.rule.implicit,
        isAsync: validation.rule.isAsync
      };
    });
  }
  parse(callback) {
    this.options.parse = callback;
    return this;
  }
  use(validation) {
    this.validations.push(VALIDATION3 in validation ? validation[VALIDATION3]() : validation);
    return this;
  }
  bail(state) {
    this.options.bail = state;
    return this;
  }
};
var VineTuple3 = class _VineTuple2 extends BaseType3 {
  #schemas;
  #allowUnknownProperties = false;
  [UNIQUE_NAME3] = "vine.array";
  [IS_OF_TYPE3] = (value) => {
    return Array.isArray(value);
  };
  constructor(schemas, options3, validations) {
    super(options3, validations);
    this.#schemas = schemas;
  }
  allowUnknownProperties() {
    this.#allowUnknownProperties = true;
    return this;
  }
  clone() {
    const cloned = new _VineTuple2(this.#schemas.map((schema) => schema.clone()), this.cloneOptions(), this.cloneValidations());
    if (this.#allowUnknownProperties) {
      cloned.allowUnknownProperties();
    }
    return cloned;
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      type: "tuple",
      fieldName: propertyName,
      propertyName: options3.toCamelCase ? camelCase23(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      allowUnknownProperties: this.#allowUnknownProperties,
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs),
      properties: this.#schemas.map((schema, index) => schema[PARSE3](String(index), refs, options3))
    };
  }
};
var minLengthRule6 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length < options3.min) {
    field.report(messages3["array.minLength"], "array.minLength", field, options3);
  }
});
var maxLengthRule6 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length > options3.max) {
    field.report(messages3["array.maxLength"], "array.maxLength", field, options3);
  }
});
var fixedLengthRule6 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length !== options3.size) {
    field.report(messages3["array.fixedLength"], "array.fixedLength", field, options3);
  }
});
var notEmptyRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length <= 0) {
    field.report(messages3.notEmpty, "notEmpty", field);
  }
});
var distinctRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isDistinct(value, options3.fields)) {
    field.report(messages3.distinct, "distinct", field, options3);
  }
});
var compactRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.filter((item) => helpers33.exists(item) && item !== ""), field);
});
var VineArray3 = class _VineArray2 extends BaseType3 {
  static rules = {
    compact: compactRule3,
    notEmpty: notEmptyRule3,
    distinct: distinctRule3,
    minLength: minLengthRule6,
    maxLength: maxLengthRule6,
    fixedLength: fixedLengthRule6
  };
  #schema;
  [UNIQUE_NAME3] = "vine.array";
  [IS_OF_TYPE3] = (value) => {
    return Array.isArray(value);
  };
  constructor(schema, options3, validations) {
    super(options3, validations);
    this.#schema = schema;
  }
  minLength(expectedLength) {
    return this.use(minLengthRule6({ min: expectedLength }));
  }
  maxLength(expectedLength) {
    return this.use(maxLengthRule6({ max: expectedLength }));
  }
  fixedLength(expectedLength) {
    return this.use(fixedLengthRule6({ size: expectedLength }));
  }
  notEmpty() {
    return this.use(notEmptyRule3());
  }
  distinct(fields22) {
    return this.use(distinctRule3({ fields: fields22 }));
  }
  compact() {
    return this.use(compactRule3());
  }
  clone() {
    return new _VineArray2(this.#schema.clone(), this.cloneOptions(), this.cloneValidations());
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      type: "array",
      fieldName: propertyName,
      propertyName: options3.toCamelCase ? camelCase23(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      each: this.#schema[PARSE3]("*", refs, options3),
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs)
    };
  }
};
var VineCamelCaseObject3 = class _VineCamelCaseObject2 extends BaseModifiersType23 {
  #schema;
  [UNIQUE_NAME3] = "types.object";
  [IS_OF_TYPE3] = (value) => {
    return value !== null && typeof value === "object" && !Array.isArray(value);
  };
  constructor(schema) {
    super();
    this.#schema = schema;
  }
  clone() {
    return new _VineCamelCaseObject2(this.#schema.clone());
  }
  [PARSE3](propertyName, refs, options3) {
    options3.toCamelCase = true;
    return this.#schema[PARSE3](propertyName, refs, options3);
  }
};
var VineObject3 = class _VineObject2 extends BaseType3 {
  #properties;
  #groups = [];
  #allowUnknownProperties = false;
  [UNIQUE_NAME3] = "vine.object";
  [IS_OF_TYPE3] = (value) => {
    return value !== null && typeof value === "object" && !Array.isArray(value);
  };
  constructor(properties, options3, validations) {
    super(options3, validations);
    this.#properties = properties;
  }
  getProperties() {
    return Object.keys(this.#properties).reduce((result2, key) => {
      result2[key] = this.#properties[key].clone();
      return result2;
    }, {});
  }
  allowUnknownProperties() {
    this.#allowUnknownProperties = true;
    return this;
  }
  merge(group22) {
    this.#groups.push(group22);
    return this;
  }
  clone() {
    const cloned = new _VineObject2(this.getProperties(), this.cloneOptions(), this.cloneValidations());
    this.#groups.forEach((group22) => cloned.merge(group22));
    if (this.#allowUnknownProperties) {
      cloned.allowUnknownProperties();
    }
    return cloned;
  }
  toCamelCase() {
    return new VineCamelCaseObject3(this);
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      type: "object",
      fieldName: propertyName,
      propertyName: options3.toCamelCase ? camelCase23(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      allowUnknownProperties: this.#allowUnknownProperties,
      validations: this.compileValidations(refs),
      properties: Object.keys(this.#properties).map((property) => {
        return this.#properties[property][PARSE3](property, refs, options3);
      }),
      groups: this.#groups.map((group22) => {
        return group22[PARSE3](refs, options3);
      })
    };
  }
};
var minLengthRule23 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (Object.keys(value).length < options3.min) {
    field.report(messages3["record.minLength"], "record.minLength", field, options3);
  }
});
var maxLengthRule23 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (Object.keys(value).length > options3.max) {
    field.report(messages3["record.maxLength"], "record.maxLength", field, options3);
  }
});
var fixedLengthRule23 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (Object.keys(value).length !== options3.size) {
    field.report(messages3["record.fixedLength"], "record.fixedLength", field, options3);
  }
});
var validateKeysRule3 = createRule3((value, callback, field) => {
  if (!field.isValid) {
    return;
  }
  callback(Object.keys(value), field);
});
var VineRecord3 = class _VineRecord2 extends BaseType3 {
  static rules = {
    maxLength: maxLengthRule23,
    minLength: minLengthRule23,
    fixedLength: fixedLengthRule23,
    validateKeys: validateKeysRule3
  };
  #schema;
  [UNIQUE_NAME3] = "vine.object";
  [IS_OF_TYPE3] = (value) => {
    return value !== null && typeof value === "object" && !Array.isArray(value);
  };
  constructor(schema, options3, validations) {
    super(options3, validations);
    this.#schema = schema;
  }
  minLength(expectedLength) {
    return this.use(minLengthRule23({ min: expectedLength }));
  }
  maxLength(expectedLength) {
    return this.use(maxLengthRule23({ max: expectedLength }));
  }
  fixedLength(expectedLength) {
    return this.use(fixedLengthRule23({ size: expectedLength }));
  }
  validateKeys(...args) {
    return this.use(validateKeysRule3(...args));
  }
  clone() {
    return new _VineRecord2(this.#schema.clone(), this.cloneOptions(), this.cloneValidations());
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      type: "record",
      fieldName: propertyName,
      propertyName: options3.toCamelCase ? camelCase23(propertyName) : propertyName,
      bail: this.options.bail,
      allowNull: this.options.allowNull,
      isOptional: this.options.isOptional,
      each: this.#schema[PARSE3]("*", refs, options3),
      parseFnId: this.options.parse ? refs.trackParser(this.options.parse) : undefined,
      validations: this.compileValidations(refs)
    };
  }
};
var stringRule3 = createRule3((value, _23, field) => {
  if (typeof value !== "string") {
    field.report(messages3.string, "string", field);
  }
});
var emailRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isEmail(value, options3)) {
    field.report(messages3.email, "email", field);
  }
});
var mobileRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const normalizedOptions = options3 && typeof options3 === "function" ? options3(field) : options3;
  const locales22 = normalizedOptions?.locale || "any";
  if (!helpers33.isMobilePhone(value, locales22, normalizedOptions)) {
    field.report(messages3.mobile, "mobile", field);
  }
});
var ipAddressRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isIP(value, options3?.version)) {
    field.report(messages3.ipAddress, "ipAddress", field);
  }
});
var regexRule3 = createRule3((value, expression, field) => {
  if (!field.isValid) {
    return;
  }
  if (!expression.test(value)) {
    field.report(messages3.regex, "regex", field);
  }
});
var hexCodeRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isHexColor(value)) {
    field.report(messages3.hexCode, "hexCode", field);
  }
});
var urlRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isURL(value, options3)) {
    field.report(messages3.url, "url", field);
  }
});
var activeUrlRule3 = createRule3(async (value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (!await helpers33.isActiveURL(value)) {
    field.report(messages3.activeUrl, "activeUrl", field);
  }
});
var alphaRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  let characterSet = "a-zA-Z";
  if (options3) {
    if (options3.allowSpaces) {
      characterSet += "\\s";
    }
    if (options3.allowDashes) {
      characterSet += "-";
    }
    if (options3.allowUnderscores) {
      characterSet += "_";
    }
  }
  const expression = new RegExp(`^[${characterSet}]+\$`);
  if (!expression.test(value)) {
    field.report(messages3.alpha, "alpha", field);
  }
});
var alphaNumericRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  let characterSet = "a-zA-Z0-9";
  if (options3) {
    if (options3.allowSpaces) {
      characterSet += "\\s";
    }
    if (options3.allowDashes) {
      characterSet += "-";
    }
    if (options3.allowUnderscores) {
      characterSet += "_";
    }
  }
  const expression = new RegExp(`^[${characterSet}]+\$`);
  if (!expression.test(value)) {
    field.report(messages3.alphaNumeric, "alphaNumeric", field);
  }
});
var minLengthRule33 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length < options3.min) {
    field.report(messages3.minLength, "minLength", field, options3);
  }
});
var maxLengthRule33 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length > options3.max) {
    field.report(messages3.maxLength, "maxLength", field, options3);
  }
});
var fixedLengthRule33 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value.length !== options3.size) {
    field.report(messages3.fixedLength, "fixedLength", field, options3);
  }
});
var endsWithRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!value.endsWith(options3.substring)) {
    field.report(messages3.endsWith, "endsWith", field, options3);
  }
});
var startsWithRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!value.startsWith(options3.substring)) {
    field.report(messages3.startsWith, "startsWith", field, options3);
  }
});
var sameAsRule23 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const input = helpers33.getNestedValue(options3.otherField, field);
  if (input !== value) {
    field.report(messages3.sameAs, "sameAs", field, options3);
    return;
  }
});
var notSameAsRule23 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const input = helpers33.getNestedValue(options3.otherField, field);
  if (input === value) {
    field.report(messages3.notSameAs, "notSameAs", field, options3);
    return;
  }
});
var confirmedRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const otherField = options3?.confirmationField || `${field.name}_confirmation`;
  const input = field.parent[otherField];
  if (input !== value) {
    field.report(messages3.confirmed, "confirmed", field, { otherField });
    return;
  }
});
var trimRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.trim(), field);
});
var normalizeEmailRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(import_normalizeEmail3.default.default(value, options3), field);
});
var toUpperCaseRule3 = createRule3((value, locales22, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.toLocaleUpperCase(locales22), field);
});
var toLowerCaseRule3 = createRule3((value, locales22, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(value.toLocaleLowerCase(locales22), field);
});
var toCamelCaseRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(camelCase23(value), field);
});
var escapeRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(import_escape3.default.default(value), field);
});
var normalizeUrlRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  field.mutate(normalizeUrl3(value, options3), field);
});
var inRule5 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const choices = typeof options3.choices === "function" ? options3.choices(field) : options3.choices;
  if (!choices.includes(value)) {
    field.report(messages3.in, "in", field, options3);
    return;
  }
});
var notInRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const list2 = typeof options3.list === "function" ? options3.list(field) : options3.list;
  if (list2.includes(value)) {
    field.report(messages3.notIn, "notIn", field, options3);
    return;
  }
});
var creditCardRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const providers22 = options3 ? typeof options3 === "function" ? options3(field)?.provider || [] : options3.provider : [];
  if (!providers22.length) {
    if (!helpers33.isCreditCard(value)) {
      field.report(messages3.creditCard, "creditCard", field, {
        providersList: "credit"
      });
    }
  } else {
    const matchesAnyProvider = providers22.find((provider) => helpers33.isCreditCard(value, { provider }));
    if (!matchesAnyProvider) {
      field.report(messages3.creditCard, "creditCard", field, {
        providers: providers22,
        providersList: providers22.join("/")
      });
    }
  }
});
var passportRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const countryCodes = typeof options3 === "function" ? options3(field).countryCode : options3.countryCode;
  const matchesAnyCountryCode = countryCodes.find((countryCode) => helpers33.isPassportNumber(value, countryCode));
  if (!matchesAnyCountryCode) {
    field.report(messages3.passport, "passport", field, { countryCodes });
  }
});
var postalCodeRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  const countryCodes = options3 ? typeof options3 === "function" ? options3(field)?.countryCode || [] : options3.countryCode : [];
  if (!countryCodes.length) {
    if (!helpers33.isPostalCode(value, "any")) {
      field.report(messages3.postalCode, "postalCode", field);
    }
  } else {
    const matchesAnyCountryCode = countryCodes.find((countryCode) => helpers33.isPostalCode(value, countryCode));
    if (!matchesAnyCountryCode) {
      field.report(messages3.postalCode, "postalCode", field, { countryCodes });
    }
  }
});
var uuidRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!options3 || !options3.version) {
    if (!helpers33.isUUID(value)) {
      field.report(messages3.uuid, "uuid", field);
    }
  } else {
    const matchesAnyVersion = options3.version.find((version3) => helpers33.isUUID(value, version3));
    if (!matchesAnyVersion) {
      field.report(messages3.uuid, "uuid", field, options3);
    }
  }
});
var asciiRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isAscii(value)) {
    field.report(messages3.ascii, "ascii", field);
  }
});
var ibanRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isIBAN(value)) {
    field.report(messages3.iban, "iban", field);
  }
});
var jwtRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isJWT(value)) {
    field.report(messages3.jwt, "jwt", field);
  }
});
var coordinatesRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isLatLong(value)) {
    field.report(messages3.coordinates, "coordinates", field);
  }
});
var VineString3 = class _VineString2 extends BaseLiteralType3 {
  static rules = {
    in: inRule5,
    jwt: jwtRule3,
    url: urlRule3,
    iban: ibanRule3,
    uuid: uuidRule3,
    trim: trimRule3,
    email: emailRule3,
    alpha: alphaRule3,
    ascii: asciiRule3,
    notIn: notInRule3,
    regex: regexRule3,
    escape: escapeRule3,
    sameAs: sameAsRule23,
    mobile: mobileRule3,
    string: stringRule3,
    hexCode: hexCodeRule3,
    passport: passportRule3,
    endsWith: endsWithRule3,
    confirmed: confirmedRule3,
    activeUrl: activeUrlRule3,
    minLength: minLengthRule33,
    notSameAs: notSameAsRule23,
    maxLength: maxLengthRule33,
    ipAddress: ipAddressRule3,
    creditCard: creditCardRule3,
    postalCode: postalCodeRule3,
    startsWith: startsWithRule3,
    toUpperCase: toUpperCaseRule3,
    toLowerCase: toLowerCaseRule3,
    toCamelCase: toCamelCaseRule3,
    fixedLength: fixedLengthRule33,
    coordinates: coordinatesRule3,
    normalizeUrl: normalizeUrlRule3,
    alphaNumeric: alphaNumericRule3,
    normalizeEmail: normalizeEmailRule3
  };
  [UNIQUE_NAME3] = "vine.string";
  [IS_OF_TYPE3] = (value) => {
    return typeof value === "string";
  };
  constructor(options3, validations) {
    super(options3, validations || [stringRule3()]);
  }
  url(...args) {
    return this.use(urlRule3(...args));
  }
  activeUrl() {
    return this.use(activeUrlRule3());
  }
  email(...args) {
    return this.use(emailRule3(...args));
  }
  mobile(...args) {
    return this.use(mobileRule3(...args));
  }
  ipAddress(version3) {
    return this.use(ipAddressRule3(version3 ? { version: version3 } : undefined));
  }
  hexCode() {
    return this.use(hexCodeRule3());
  }
  regex(expression) {
    return this.use(regexRule3(expression));
  }
  alpha(options3) {
    return this.use(alphaRule3(options3));
  }
  alphaNumeric(options3) {
    return this.use(alphaNumericRule3(options3));
  }
  minLength(expectedLength) {
    return this.use(minLengthRule33({ min: expectedLength }));
  }
  maxLength(expectedLength) {
    return this.use(maxLengthRule33({ max: expectedLength }));
  }
  fixedLength(expectedLength) {
    return this.use(fixedLengthRule33({ size: expectedLength }));
  }
  confirmed(options3) {
    return this.use(confirmedRule3(options3));
  }
  trim() {
    return this.use(trimRule3());
  }
  normalizeEmail(options3) {
    return this.use(normalizeEmailRule3(options3));
  }
  toUpperCase() {
    return this.use(toUpperCaseRule3());
  }
  toLowerCase() {
    return this.use(toLowerCaseRule3());
  }
  toCamelCase() {
    return this.use(toCamelCaseRule3());
  }
  escape() {
    return this.use(escapeRule3());
  }
  normalizeUrl(...args) {
    return this.use(normalizeUrlRule3(...args));
  }
  startsWith(substring2) {
    return this.use(startsWithRule3({ substring: substring2 }));
  }
  endsWith(substring2) {
    return this.use(endsWithRule3({ substring: substring2 }));
  }
  sameAs(otherField) {
    return this.use(sameAsRule23({ otherField }));
  }
  notSameAs(otherField) {
    return this.use(notSameAsRule23({ otherField }));
  }
  in(choices) {
    return this.use(inRule5({ choices }));
  }
  notIn(list2) {
    return this.use(notInRule3({ list: list2 }));
  }
  creditCard(...args) {
    return this.use(creditCardRule3(...args));
  }
  passport(...args) {
    return this.use(passportRule3(...args));
  }
  postalCode(...args) {
    return this.use(postalCodeRule3(...args));
  }
  uuid(...args) {
    return this.use(uuidRule3(...args));
  }
  ascii() {
    return this.use(asciiRule3());
  }
  iban() {
    return this.use(ibanRule3());
  }
  jwt() {
    return this.use(jwtRule3());
  }
  coordinates() {
    return this.use(coordinatesRule3());
  }
  clone() {
    return new _VineString2(this.cloneOptions(), this.cloneValidations());
  }
};
var numberRule3 = createRule3((value, options3, field) => {
  const valueAsNumber = options3.strict ? value : helpers33.asNumber(value);
  if (typeof valueAsNumber !== "number" || Number.isNaN(valueAsNumber) || valueAsNumber === Number.POSITIVE_INFINITY || valueAsNumber === Number.NEGATIVE_INFINITY) {
    field.report(messages3.number, "number", field);
    return;
  }
  field.mutate(valueAsNumber, field);
});
var minRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value < options3.min) {
    field.report(messages3.min, "min", field, options3);
  }
});
var maxRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value > options3.max) {
    field.report(messages3.max, "max", field, options3);
  }
});
var rangeRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (value < options3.min || value > options3.max) {
    field.report(messages3.range, "range", field, options3);
  }
});
var positiveRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (value < 0) {
    field.report(messages3.positive, "positive", field);
  }
});
var negativeRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (value >= 0) {
    field.report(messages3.negative, "negative", field);
  }
});
var decimalRule3 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!helpers33.isDecimal(String(value), {
    force_decimal: options3.range[0] !== 0,
    decimal_digits: options3.range.join(",")
  })) {
    field.report(messages3.decimal, "decimal", field, { digits: options3.range.join("-") });
  }
});
var withoutDecimalsRule3 = createRule3((value, _23, field) => {
  if (!field.isValid) {
    return;
  }
  if (!Number.isInteger(value)) {
    field.report(messages3.withoutDecimals, "withoutDecimals", field);
  }
});
var inRule23 = createRule3((value, options3, field) => {
  if (!field.isValid) {
    return;
  }
  if (!options3.values.includes(value)) {
    field.report(messages3["number.in"], "in", field, options3);
  }
});
var VineNumber3 = class _VineNumber2 extends BaseLiteralType3 {
  static rules = {
    in: inRule23,
    max: maxRule3,
    min: minRule3,
    range: rangeRule3,
    number: numberRule3,
    decimal: decimalRule3,
    negative: negativeRule3,
    positive: positiveRule3,
    withoutDecimals: withoutDecimalsRule3
  };
  [UNIQUE_NAME3] = "vine.number";
  [IS_OF_TYPE3] = (value) => {
    const valueAsNumber = helpers33.asNumber(value);
    return !Number.isNaN(valueAsNumber);
  };
  constructor(options3, validations) {
    super(options3, validations || [numberRule3(options3 || {})]);
  }
  min(value) {
    return this.use(minRule3({ min: value }));
  }
  max(value) {
    return this.use(maxRule3({ max: value }));
  }
  range(value) {
    return this.use(rangeRule3({ min: value[0], max: value[1] }));
  }
  positive() {
    return this.use(positiveRule3());
  }
  negative() {
    return this.use(negativeRule3());
  }
  decimal(range) {
    return this.use(decimalRule3({ range: Array.isArray(range) ? range : [range] }));
  }
  withoutDecimals() {
    return this.use(withoutDecimalsRule3());
  }
  clone() {
    return new _VineNumber2(this.cloneOptions(), this.cloneValidations());
  }
  in(values3) {
    return this.use(inRule23({ values: values3 }));
  }
};
var booleanRule3 = createRule3((value, options3, field) => {
  const valueAsBoolean = options3.strict === true ? value : helpers33.asBoolean(value);
  if (typeof valueAsBoolean !== "boolean") {
    field.report(messages3.boolean, "boolean", field);
    return;
  }
  field.mutate(valueAsBoolean, field);
});
var VineBoolean3 = class _VineBoolean2 extends BaseLiteralType3 {
  static rules = {
    boolean: booleanRule3
  };
  [UNIQUE_NAME3] = "vine.boolean";
  [IS_OF_TYPE3] = (value) => {
    const valueAsBoolean = this.options.strict === true ? value : helpers33.asBoolean(value);
    return typeof valueAsBoolean === "boolean";
  };
  constructor(options3, validations) {
    super(options3, validations || [booleanRule3(options3 || {})]);
  }
  clone() {
    return new _VineBoolean2(this.cloneOptions(), this.cloneValidations());
  }
};
var equalsRule23 = createRule3((value, options3, field) => {
  let input = value;
  if (typeof options3.expectedValue === "boolean") {
    input = helpers33.asBoolean(value);
  } else if (typeof options3.expectedValue === "number") {
    input = helpers33.asNumber(value);
  }
  if (input !== options3.expectedValue) {
    field.report(messages3.literal, "literal", field, options3);
    return;
  }
  field.mutate(input, field);
});
var VineLiteral3 = class _VineLiteral2 extends BaseLiteralType3 {
  static rules = {
    equals: equalsRule23
  };
  #value;
  constructor(value, options3, validations) {
    super(options3, validations || [equalsRule23({ expectedValue: value })]);
    this.#value = value;
  }
  clone() {
    return new _VineLiteral2(this.#value, this.cloneOptions(), this.cloneValidations());
  }
};
var ACCEPTED_VALUES3 = ["on", "1", "yes", "true", true, 1];
var acceptedRule3 = createRule3((value, _23, field) => {
  if (!ACCEPTED_VALUES3.includes(value)) {
    field.report(messages3.accepted, "accepted", field);
  }
});
var VineAccepted3 = class _VineAccepted2 extends BaseLiteralType3 {
  static rules = {
    accepted: acceptedRule3
  };
  constructor(options3, validations) {
    super(options3, validations || [acceptedRule3()]);
  }
  clone() {
    return new _VineAccepted2(this.cloneOptions(), this.cloneValidations());
  }
};
var ObjectGroup3 = class _ObjectGroup2 {
  #conditionals;
  #otherwiseCallback = (_23, field) => {
    field.report(messages3.unionGroup, "unionGroup", field);
  };
  constructor(conditionals) {
    this.#conditionals = conditionals;
  }
  clone() {
    const cloned = new _ObjectGroup2(this.#conditionals);
    cloned.otherwise(this.#otherwiseCallback);
    return cloned;
  }
  otherwise(callback) {
    this.#otherwiseCallback = callback;
    return this;
  }
  [PARSE3](refs, options3) {
    return {
      type: "group",
      elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
      conditions: this.#conditionals.map((conditional) => conditional[PARSE3](refs, options3))
    };
  }
};
var GroupConditional3 = class {
  #properties;
  #conditional;
  constructor(conditional, properties) {
    this.#properties = properties;
    this.#conditional = conditional;
  }
  [PARSE3](refs, options3) {
    return {
      schema: {
        type: "sub_object",
        properties: Object.keys(this.#properties).map((property) => {
          return this.#properties[property][PARSE3](property, refs, options3);
        }),
        groups: []
      },
      conditionalFnRefId: refs.trackConditional(this.#conditional)
    };
  }
};
function group3(conditionals) {
  return new ObjectGroup3(conditionals);
}
group3.if = function groupIf2(conditon, properties) {
  return new GroupConditional3(conditon, properties);
};
group3.else = function groupElse2(properties) {
  return new GroupConditional3(() => true, properties);
};
var VineNativeEnum3 = class _VineNativeEnum2 extends BaseLiteralType3 {
  static rules = {
    enum: enumRule3
  };
  #values;
  constructor(values3, options3, validations) {
    super(options3, validations || [enumRule3({ choices: Object.values(values3) })]);
    this.#values = values3;
  }
  clone() {
    return new _VineNativeEnum2(this.#values, this.cloneOptions(), this.cloneValidations());
  }
};
var VineUnionOfTypes3 = class _VineUnionOfTypes2 {
  #schemas;
  #otherwiseCallback = (_23, field) => {
    field.report(messages3.unionOfTypes, "unionOfTypes", field);
  };
  constructor(schemas) {
    this.#schemas = schemas;
  }
  otherwise(callback) {
    this.#otherwiseCallback = callback;
    return this;
  }
  clone() {
    const cloned = new _VineUnionOfTypes2(this.#schemas);
    cloned.otherwise(this.#otherwiseCallback);
    return cloned;
  }
  [PARSE3](propertyName, refs, options3) {
    return {
      type: "union",
      fieldName: propertyName,
      propertyName: options3.toCamelCase ? camelCase23(propertyName) : propertyName,
      elseConditionalFnRefId: refs.trackConditional(this.#otherwiseCallback),
      conditions: this.#schemas.map((schema) => {
        return {
          conditionalFnRefId: refs.trackConditional((value, field) => {
            return schema[IS_OF_TYPE3](value, field);
          }),
          schema: schema[PARSE3](propertyName, refs, options3)
        };
      })
    };
  }
};
var SchemaBuilder3 = class extends Macroable3 {
  group = group3;
  union = union3;
  string() {
    return new VineString3;
  }
  boolean(options3) {
    return new VineBoolean3(options3);
  }
  accepted() {
    return new VineAccepted3;
  }
  number(options3) {
    return new VineNumber3(options3);
  }
  date(options3) {
    return new VineDate3(options3);
  }
  literal(value) {
    return new VineLiteral3(value);
  }
  object(properties) {
    return new VineObject3(properties);
  }
  array(schema) {
    return new VineArray3(schema);
  }
  tuple(schemas) {
    return new VineTuple3(schemas);
  }
  record(schema) {
    return new VineRecord3(schema);
  }
  enum(values3) {
    if (Array.isArray(values3) || typeof values3 === "function") {
      return new VineEnum3(values3);
    }
    return new VineNativeEnum3(values3);
  }
  any() {
    return new VineAny3;
  }
  unionOfTypes(schemas) {
    const schemasInUse = /* @__PURE__ */ new Set;
    schemas.forEach((schema) => {
      if (!schema[IS_OF_TYPE3] || !schema[UNIQUE_NAME3]) {
        throw new Error(`Cannot use "${schema.constructor.name}". The schema type is not compatible for use with "vine.unionOfTypes"`);
      }
      if (schemasInUse.has(schema[UNIQUE_NAME3])) {
        throw new Error(`Cannot use duplicate schema "${schema[UNIQUE_NAME3]}". "vine.unionOfTypes" needs distinct schema types only`);
      }
      schemasInUse.add(schema[UNIQUE_NAME3]);
    });
    schemasInUse.clear();
    return new VineUnionOfTypes3(schemas);
  }
};
var COMPILER_ERROR_MESSAGES3 = {
  required: messages3.required,
  array: messages3.array,
  object: messages3.object
};
var VineValidator3 = class {
  #compiled;
  messagesProvider;
  errorReporter;
  #parse(schema) {
    const refs = refsBuilder3();
    return {
      compilerNode: {
        type: "root",
        schema: schema[PARSE3]("", refs, { toCamelCase: false })
      },
      refs: refs.toJSON()
    };
  }
  constructor(schema, options3) {
    const { compilerNode, refs } = this.#parse(schema);
    this.#compiled = { schema: compilerNode, refs };
    const metaDataValidator = options3.metaDataValidator;
    const validateFn = new Compiler3(compilerNode, {
      convertEmptyStringsToNull: options3.convertEmptyStringsToNull,
      messages: COMPILER_ERROR_MESSAGES3
    }).compile();
    this.errorReporter = options3.errorReporter;
    this.messagesProvider = options3.messagesProvider;
    if (metaDataValidator) {
      this.validate = (data2, validateOptions) => {
        let normalizedOptions = validateOptions ?? {};
        const meta = normalizedOptions.meta ?? {};
        const errorReporter = normalizedOptions.errorReporter ?? this.errorReporter;
        const messagesProvider = normalizedOptions.messagesProvider ?? this.messagesProvider;
        metaDataValidator(meta);
        return validateFn(data2, meta, refs, messagesProvider, errorReporter());
      };
    } else {
      this.validate = (data2, validateOptions) => {
        let normalizedOptions = validateOptions ?? {};
        const meta = normalizedOptions.meta ?? {};
        const errorReporter = normalizedOptions.errorReporter ?? this.errorReporter;
        const messagesProvider = normalizedOptions.messagesProvider ?? this.messagesProvider;
        return validateFn(data2, meta, refs, messagesProvider, errorReporter());
      };
    }
  }
  async tryValidate(data2, ...[options3]) {
    try {
      const result2 = await this.validate(data2, options3);
      return [null, result2];
    } catch (error) {
      if (error instanceof ValidationError3) {
        return [error, null];
      }
      throw error;
    }
  }
  toJSON() {
    const { schema, refs } = this.#compiled;
    return {
      schema: structuredClone(schema),
      refs
    };
  }
};
var Vine3 = class extends SchemaBuilder3 {
  messagesProvider = new SimpleMessagesProvider3(messages3, fields3);
  errorReporter = () => new SimpleErrorReporter3;
  convertEmptyStringsToNull = false;
  helpers = helpers33;
  createRule = createRule3;
  compile(schema) {
    return new VineValidator3(schema, {
      convertEmptyStringsToNull: this.convertEmptyStringsToNull,
      messagesProvider: this.messagesProvider,
      errorReporter: this.errorReporter
    });
  }
  withMetaData(callback) {
    return {
      compile: (schema) => {
        return new VineValidator3(schema, {
          convertEmptyStringsToNull: this.convertEmptyStringsToNull,
          messagesProvider: this.messagesProvider,
          errorReporter: this.errorReporter,
          metaDataValidator: callback
        });
      }
    };
  }
  validate(options3) {
    const validator = this.compile(options3.schema);
    return validator.validate(options3.data, options3);
  }
  tryValidate(options3) {
    const validator = this.compile(options3.schema);
    return validator.tryValidate(options3.data, options3);
  }
};
var vine3 = new Vine3;
var vine_default3 = vine3;
var env_default3 = {
  APP_NAME: vine_default3.string(),
  APP_ENV: vine_default3.enum(["local", "dev", "stage", "prod"]),
  APP_KEY: vine_default3.string(),
  APP_URL: vine_default3.string(),
  PORT: vine_default3.number(),
  PORT_BACKEND: vine_default3.number(),
  PORT_ADMIN: vine_default3.number(),
  PORT_LIBRARY: vine_default3.number(),
  PORT_DESKTOP: vine_default3.number(),
  PORT_EMAIL: vine_default3.number(),
  PORT_DOCS: vine_default3.number(),
  PORT_INSPECT: vine_default3.number(),
  PORT_API: vine_default3.number(),
  PORT_SYSTEM_TRAY: vine_default3.number(),
  APP_MAINTENANCE: vine_default3.boolean(),
  DEBUG: vine_default3.boolean(),
  API_PREFIX: vine_default3.string(),
  DOCS_PREFIX: vine_default3.string(),
  DB_CONNECTION: vine_default3.enum(["mysql", "sqlite", "postgres"]),
  DB_HOST: vine_default3.string(),
  DB_PORT: vine_default3.number(),
  DB_DATABASE: vine_default3.string(),
  DB_USERNAME: vine_default3.string(),
  DB_PASSWORD: vine_default3.string(),
  AWS_ACCOUNT_ID: vine_default3.string(),
  AWS_ACCESS_KEY_ID: vine_default3.string(),
  AWS_SECRET_ACCESS_KEY: vine_default3.string(),
  AWS_DEFAULT_REGION: vine_default3.string(),
  AWS_DEFAULT_PASSWORD: vine_default3.string(),
  MAIL_MAILER: vine_default3.enum(["ses", "sendmail", "log", "smtp"]),
  MAIL_HOST: vine_default3.string(),
  MAIL_PORT: vine_default3.number(),
  MAIL_USERNAME: vine_default3.string(),
  MAIL_PASSWORD: vine_default3.string(),
  MAIL_ENCRYPTION: vine_default3.string(),
  MAIL_FROM_NAME: vine_default3.string(),
  MAIL_FROM_ADDRESS: vine_default3.string(),
  SEARCH_ENGINE_DRIVER: vine_default3.enum(["meilisearch", "algolia", "typesense"]),
  MEILISEARCH_HOST: vine_default3.string(),
  MEILISEARCH_KEY: vine_default3.string(),
  FRONTEND_APP_ENV: vine_default3.enum(["development", "staging", "production"]),
  FRONTEND_APP_URL: vine_default3.string()
};
var envEnum3 = {
  APP_ENV: ["local", "dev", "development", "staging", "prod", "production"],
  DB_CONNECTION: ["mysql", "sqlite", "postgres", "dynamodb"],
  MAIL_MAILER: ["smtp", "mailgun", "ses", "postmark", "sendmail", "log"],
  SEARCH_ENGINE_DRIVER: ["opensearch"],
  FRONTEND_APP_ENV: ["development", "staging", "production"]
};
var envStructure3 = Object.entries(env_default3).reduce((acc, [key, value]) => {
  let validatorType;
  switch (typeof value) {
    case "string":
      validatorType = vine_default3.string();
      break;
    case "number":
      validatorType = vine_default3.number();
      break;
    case "boolean":
      validatorType = vine_default3.boolean();
      break;
    default:
      if (Array.isArray(value)) {
        validatorType = vine_default3.enum(value);
        break;
      }
      if (typeof value === "object") {
        const schemaNameSymbol = Symbol.for("schema_name");
        const schemaName = value[schemaNameSymbol];
        if (schemaName === "vine.string") {
          validatorType = vine_default3.string();
          break;
        }
        if (schemaName === "vine.number") {
          validatorType = vine_default3.number();
          break;
        }
        if (schemaName === "vine.boolean") {
          validatorType = vine_default3.boolean();
          break;
        }
        if (!schemaName) {
          validatorType = vine_default3.enum(envEnum3.APP_ENV);
          break;
        }
        console.error("Unknown env value type", typeof value);
      }
      throw new Error(`Invalid env value for ${key}`);
  }
  const envKey = key;
  acc[envKey] = validatorType;
  return acc;
}, {});
var envSchema3 = vine_default3.object(envStructure3);
var handler3 = {
  get: (target, key) => {
    const value = target[key];
    if (typeof value === "string" && /^\d+$/.test(value) && key !== "AWS_ACCOUNT_ID")
      return Number(value);
    if (typeof value === "string" && /^true|false$/.test(value))
      return value === "true";
    if (value instanceof VineEnum3)
      return target[key];
    if (value instanceof VineBoolean3)
      return !!target[key];
    if (value instanceof VineNumber3)
      return Number(target[key]);
    return value;
  }
};
function process63() {
  return typeof Bun !== "undefined" ? Bun.env : p23.env;
}
var env33 = new Proxy(process63(), handler3);
var app_default3 = {
  name: env33.APP_NAME ?? "Stacks",
  description: "Stacks is a full-stack framework for building modern web applications.",
  env: env33.APP_ENV ?? "local",
  url: env33.APP_URL ?? "stacks.localhost",
  redirectUrls: ["stacksjs.com"],
  debug: env33.DEBUG ?? false,
  key: env33.APP_KEY,
  maintenanceMode: env33.APP_MAINTENANCE ?? false,
  docMode: false,
  timezone: "America/Los_Angeles",
  locale: "en",
  fallbackLocale: "en",
  cipher: "aes-256-cbc"
};
var cache_default3 = {
  driver: "dynamodb",
  prefix: "stacks",
  ttl: 3600,
  drivers: {
    dynamodb: {
      key: env33.AWS_ACCESS_KEY_ID || "",
      secret: env33.AWS_SECRET_ACCESS_KEY || "",
      region: env33.AWS_DEFAULT_REGION || "us-east-1",
      table: "cache",
      endpoint: ""
    },
    memcached: {
      persistent_id: "",
      sasl: ["", ""],
      options: {},
      servers: [
        {
          host: "127.0.0.1",
          port: 11211,
          weight: 100
        }
      ]
    },
    redis: {
      connection: "cache",
      host: "127.0.0.1",
      port: 6379,
      password: "",
      username: "stacks"
    }
  }
};
var cli_default3 = {
  name: "My Custom CLI",
  command: "custom-cli",
  description: "This is an example command to illustrate how to create your own commands. Check out `../app/commands` for more.",
  deploy: true
};
var security_default3 = {
  firewall: {
    enabled: true,
    countryCodes: ["RU", "IR"],
    ipAddresses: [],
    rateLimitPerMinute: 1000,
    useIpReputationLists: true,
    useKnownBadInputsRuleSet: true,
    queryString: [],
    httpHeaders: []
  }
};
var cloud_default3 = {
  sites: {
    root: "stacksjs.org",
    path: "dist",
    modals: {
      domain: "modals.stacksjs.org",
      path: "dist"
    },
    stepper: {
      domain: "stepper.stacksjs.org",
      path: "dist"
    },
    notification: {
      domain: "notification.stacksjs.org",
      path: "dist"
    },
    docs: {
      domain: "docs.stacksjs.org",
      path: "dist"
    },
    tlsx: {
      domain: "tlsx.stacksjs.org",
      path: "dist"
    },
    dtsx: {
      domain: "dtsx.stacksjs.org",
      path: "dist"
    },
    spreadsheet: {
      domain: "spreadsheet.stacksjs.org",
      path: "dist"
    }
  },
  infrastructure: {
    type: "serverless",
    driver: "aws",
    firewall: security_default3.firewall,
    environments: ["production", "staging", "development"],
    storage: {},
    api: {
      prefix: env33.API_PREFIX || "api",
      description: "My awesome Stacks API",
      deploy: true,
      memorySize: 512,
      prewarm: 10,
      timeout: 30
    },
    cdn: {
      compress: true,
      allowedMethods: "ALL",
      cachedMethods: "GET_HEAD",
      originShieldRegion: "us-east-1",
      minTtl: 0,
      defaultTtl: 86400,
      maxTtl: 31536000,
      cookieBehavior: "none",
      allowList: {
        cookies: [],
        headers: [],
        queryStrings: []
      },
      realtimeLogs: {
        enabled: true,
        samplingRate: 1
      }
    },
    fileSystem: true
  }
};
var database_default3 = {
  default: env33.DB_CONNECTION || "sqlite",
  connections: {
    sqlite: {
      database: env33.DB_DATABASE || "database/stacks.sqlite",
      prefix: ""
    },
    dynamodb: {
      key: env33.AWS_ACCESS_KEY_ID || "",
      secret: env33.AWS_SECRET_ACCESS_KEY || "",
      region: env33.AWS_DEFAULT_REGION || "us-east-1",
      prefix: env33.DB_DATABASE || "stacks",
      endpoint: "http://localhost",
      port: env33.DB_PORT || 8000
    },
    mysql: {
      name: env33.DB_DATABASE || "stacks",
      host: env33.DB_HOST || "127.0.0.1",
      port: env33.DB_PORT || 3306,
      username: env33.DB_USERNAME || "root",
      password: env33.DB_PASSWORD || "",
      prefix: ""
    },
    postgres: {
      name: env33.DB_DATABASE || "stacks",
      host: env33.DB_HOST || "127.0.0.1",
      port: env33.DB_PORT || 3306,
      username: env33.DB_USERNAME || "",
      password: env33.DB_PASSWORD || "",
      prefix: ""
    }
  },
  migrations: "migrations",
  migrationLocks: "migration_locks"
};
var dns_default3 = {
  a: [
    {
      name: env33.APP_URL || "",
      address: "10.0.0.1",
      ttl: 300
    },
    {
      name: "www",
      address: "@",
      ttl: 300
    }
  ],
  aaaa: [],
  cname: [],
  mx: [],
  txt: [],
  nameservers: []
};
var email_default3 = {
  from: {
    name: env33.MAIL_FROM_NAME || "Stacks",
    address: env33.MAIL_FROM_ADDRESS || "no-reply@stacksjs.org"
  },
  mailboxes: ["chris@stacksjs.org", "blake@stacksjs.org", "glenn@stacksjs.org"],
  url: env33.APP_URL || "http://localhost:3000",
  charset: "UTF-8",
  server: {
    scan: true
  }
};
var errors_default3 = {
  messages: {
    string: "The {{ field }} field must be a string",
    email: "The {{ field }} field must be a valid email address",
    regex: "The {{ field }} field format is invalid",
    url: "The {{ field }} field must be a valid URL",
    activeUrl: "The {{ field }} field must be a valid URL",
    alpha: "The {{ field }} field must contain only letters",
    alphaNumeric: "The {{ field }} field must contain only letters and numbers",
    minLength: "The {{ field }} field must have at least {{ min }} characters",
    maxLength: "The {{ field }} field must not be greater than {{ max }} characters",
    fixedLength: "The {{ field }} field must be {{ size }} characters long",
    confirmed: "The {{ field }} field and {{ otherField }} field must be the same",
    endsWith: "The {{ field }} field must end with {{ substring }}",
    startsWith: "The {{ field }} field must start with {{ substring }}",
    sameAs: "The {{ field }} field and {{ otherField }} field must be the same",
    notSameAs: "The {{ field }} field and {{ otherField }} field must be different",
    in: "The selected {{ field }} is invalid",
    notIn: "The selected {{ field }} is invalid",
    ipAddress: "The {{ field }} field must be a valid IP address",
    uuid: "The {{ field }} field must be a valid UUID",
    ascii: "The {{ field }} field must only contain ASCII characters",
    creditCard: "The {{ field }} field must be a valid {{ providersList }} card number",
    hexCode: "The {{ field }} field must be a valid hex color code",
    iban: "The {{ field }} field must be a valid IBAN number",
    jwt: "The {{ field }} field must be a valid JWT token",
    coordinates: "The {{ field }} field must contain latitude and longitude coordinates",
    mobile: "The {{ field }} field must be a valid mobile phone number",
    passport: "The {{ field }} field must be a valid passport number",
    postalCode: "The {{ field }} field must be a valid postal code",
    boolean: "The value must be a boolean",
    number: "The {{ field }} field must be a number",
    min: "The {{ field }} field must be at least {{ min }}",
    max: "The {{ field }} field must not be greater than {{ max }}",
    range: "The {{ field }} field must be between {{ min }} and {{ max }}",
    positive: "The {{ field }} field must be positive",
    negative: "The {{ field }} field must be negative",
    decimal: "The {{ field }} field must have {{ digits }} decimal places",
    withoutDecimals: "The {{ field }} field must not have decimal places",
    date: "The {{ field }} field must be a datetime value",
    "date.equals": "The {{ field }} field must be a date equal to {{ expectedValue }}",
    "date.after": "The {{ field }} field must be a date after {{ expectedValue }}",
    "date.before": "The {{ field }} field must be a date before {{ expectedValue }}",
    "date.afterOrEqual": "The {{ field }} field must be a date after or equal to {{ expectedValue }}",
    "date.beforeOrEqual": "The {{ field }} field must be a date before or equal to {{ expectedValue }}",
    "date.sameAs": "The {{ field }} field and {{ otherField }} field must be the same",
    "date.notSameAs": "The {{ field }} field and {{ otherField }} field must be different",
    "date.afterField": "The {{ field }} field must be a date after {{ otherField }}",
    accepted: "The {{ field }} field must be accepted",
    enum: "The selected {{ field }} is invalid",
    literal: "The {{ field }} field must be {{ expectedValue }}",
    object: "The {{ field }} field must be an object",
    record: "The {{ field }} field must be an object",
    "record.minLength": "The {{ field }} field must have at least {{ min }} items",
    "record.maxLength": "The {{ field }} field must not have more than {{ max }} items",
    "record.fixedLength": "The {{ field }} field must contain {{ size }} items",
    array: "The {{ field }} field must be an array",
    "array.minLength": "The {{ field }} field must have at least {{ min }} items",
    "array.maxLength": "The {{ field }} field must not have more than {{ max }} items",
    "array.fixedLength": "The {{ field }} field must contain {{ size }} items",
    notEmpty: "The {{ field }} field must not be empty",
    distinct: "The {{ field }} field has duplicate values",
    tuple: "The {{ field }} field must be an array",
    union: "Invalid value provided for {{ field }} field",
    unionGroup: "Invalid value provided for {{ field }} field",
    unionOfTypes: "Invalid value provided for {{ field }} field"
  }
};
var git_default3 = {
  hooks: {
    "pre-commit": "lint-staged"
  },
  scopes: [
    "",
    "ci",
    "deps",
    "dx",
    "release",
    "docs",
    "test",
    "core",
    "actions",
    "arrays",
    "auth",
    "build",
    "cache",
    "cli",
    "cloud",
    "collections",
    "config",
    "database",
    "datetime",
    "docs",
    "errors",
    "git",
    "lint",
    "x-ray",
    "modules",
    "notifications",
    "objects",
    "path",
    "realtime",
    "router",
    "buddy",
    "security",
    "server",
    "storage",
    "strings",
    "tests",
    "types",
    "ui",
    "utils"
  ],
  messages: {
    type: "Select the type of change that you\u2019re committing:",
    scope: "Select the SCOPE of this change (optional):",
    customScope: "Select the SCOPE of this change:",
    subject: "Write a SHORT, IMPERATIVE tense description of the change:\n",
    body: 'Provide a LONGER description of the change (optional). Use "|" to break new line:\n',
    breaking: 'List any BREAKING CHANGES (optional). Use "|" to break new line:\n',
    footerPrefixesSelect: "Select the ISSUES type of the change list by this change (optional):",
    customFooterPrefixes: "Input ISSUES prefix:",
    footer: "List any ISSUES by this change. E.g.: #31, #34:\n",
    confirmCommit: "Are you sure you want to proceed with the commit above?"
  },
  types: [
    { value: "feat", name: "feat:     \u2728  A new feature", emoji: ":sparkles:" },
    { value: "fix", name: "fix:      \uD83D\uDC1B  A bug fix", emoji: ":bug:" },
    {
      value: "docs",
      name: "docs:     \uD83D\uDCDD  Documentation only changes",
      emoji: ":memo:"
    },
    {
      value: "style",
      name: "style:    \uD83D\uDC84  Changes that do not affect the meaning of the code",
      emoji: ":lipstick:"
    },
    {
      value: "refactor",
      name: "refactor: \u267B\uFE0F   A code change that neither fixes a bug nor adds a feature",
      emoji: ":recycle:"
    },
    {
      value: "perf",
      name: "perf:     \u26A1\uFE0F  A code change that improves performance",
      emoji: ":zap:"
    },
    {
      value: "test",
      name: "test:     \u2705  Adding missing tests or adjusting existing tests",
      emoji: ":white_check_mark:"
    },
    {
      value: "build",
      name: "build:    \uD83D\uDCE6\uFE0F  Changes that affect the build system or external dependencies",
      emoji: ":package:"
    },
    {
      value: "ci",
      name: "ci:       \uD83C\uDFA1  Changes to our CI configuration files and scripts",
      emoji: ":ferris_wheel:"
    },
    {
      value: "chore",
      name: "chore:    \uD83D\uDD28  Other changes that don\u2019t modify src or test files",
      emoji: ":hammer:"
    },
    {
      value: "revert",
      name: "revert:   \u23EA\uFE0F  Reverts a previous commit",
      emoji: ":rewind:"
    }
  ]
};
var hashing_default3 = {
  driver: "argon2",
  bcrypt: {
    rounds: 10,
    cost: 4
  },
  argon2: {
    memory: 65536,
    threads: 1,
    time: 1
  }
};
var library_default3 = {
  name: "hello-world",
  owner: "@stacksjs",
  repository: "stacksjs/stacks",
  license: "MIT",
  author: "Chris Breuer",
  contributors: ["Chris Breuer <chris@stacksjs.org>"],
  defaultLanguage: "en",
  releaseable: true,
  vueComponents: {
    name: "hello-world-vue",
    description: "Your Vue component library description",
    keywords: ["component", "library", "vue", "vite", "typescript", "javascript"],
    tags: [
      {
        name: ["HelloWorld", "AppHelloWorld"],
        description: "The Hello World custom element, built via this framework.",
        attributes: [
          {
            name: "greeting",
            description: "The greeting."
          }
        ]
      }
    ]
  },
  webComponents: {
    name: "hello-world-elements",
    description: "Your framework agnostic web component library description.",
    keywords: ["custom-elements", "web-components", "library", "framework-agnostic", "typescript", "javascript"],
    tags: [
      {
        name: ["HelloWorld", "AppHelloWorld"],
        description: "The Hello World custom element, built via this framework.",
        attributes: [
          {
            name: "greeting",
            description: "The greeting."
          }
        ]
      }
    ]
  },
  functions: {
    name: "hello-world-fx",
    description: "Your function library description.",
    keywords: ["functions", "composables", "library", "typescript", "javascript"],
    shouldGenerateSourcemap: false,
    files: ["counter", "dark"]
  }
};
var logging_default3 = {
  logsPath: storagePath3("logs/stacks.log"),
  deploymentsPath: storagePath3("logs/deployments.log")
};
var notification_default3 = {
  default: "email"
};
var payment_default3 = {
  driver: "stripe",
  stripe: {
    publishableKey: env33.STRIPE_PUBLISHABLE_KEY || "",
    secretKey: env33.STRIPE_SECRET_KEY || ""
  }
};
var ports_default3 = {
  frontend: env33.PORT ?? 3000,
  backend: env33.PORT_BACKEND ?? 3001,
  admin: env33.PORT_ADMIN ?? 3002,
  library: env33.PORT_LIBRARY ?? 3003,
  desktop: env33.PORT_DESKTOP ?? 3004,
  email: env33.PORT_EMAIL ?? 3005,
  docs: env33.PORT_DOCS ?? 3006,
  inspect: env33.PORT_INSPECT ?? 3007,
  api: env33.PORT_API ?? 3008,
  systemTray: env33.PORT_SYSTEM_TRAY ?? 3009,
  database: 3010
};
var queue_default3 = {
  default: "sync",
  connections: {
    sync: {
      driver: "sync"
    },
    sqs: {
      driver: "sqs",
      key: "",
      secret: "",
      prefix: "",
      suffix: "",
      queue: "default",
      region: "us-east-1"
    }
  }
};
var saas_default3 = {
  plans: [
    {
      productName: "Stacks Hobby",
      description: "All the Stacks features.",
      pricing: [
        {
          key: "stacks_hobby_monthly",
          price: 3900,
          interval: "month",
          currency: "usd"
        },
        {
          key: "stacks_hobby_yearly",
          price: 37900,
          interval: "year",
          currency: "usd"
        }
      ],
      metadata: {
        createdBy: "admin",
        version: "1.0.0"
      }
    },
    {
      productName: "Stacks Pro",
      description: "All the Stacks features, including being able to invite team members.",
      pricing: [
        {
          key: "stacks_pro_monthly",
          price: 5900,
          interval: "month",
          currency: "usd"
        },
        {
          key: "stacks_pro_yearly",
          price: 57900,
          interval: "year",
          currency: "usd"
        }
      ],
      metadata: {
        createdBy: "admin",
        version: "1.0.0"
      }
    }
  ],
  webhook: {
    endpoint: "/webhooks/stripe",
    secret: ""
  },
  currencies: ["usd"],
  coupons: [
    {
      code: "SUMMER2024",
      amountOff: 500,
      duration: "once"
    }
  ],
  products: [
    {
      name: "Stacks Pro",
      description: "All the Stacks features.",
      images: ["url_to_image"]
    }
  ]
};
var search_engine_default3 = {
  driver: "opensearch"
};
var services_default3 = {
  aws: {
    accountId: env33.AWS_ACCOUNT_ID || "",
    appId: env33.AWS_ACCESS_KEY_ID || "",
    apiKey: env33.AWS_SECRET_ACCESS_KEY || "",
    region: env33.AWS_DEFAULT_REGION || "us-east-1"
  },
  algolia: {
    appId: "",
    apiKey: ""
  },
  meilisearch: {
    appId: "",
    apiKey: ""
  },
  lemonSqueezy: {
    appId: "",
    apiKey: ""
  },
  stripe: {
    appId: "",
    apiKey: ""
  }
};
var storage_default3 = {
  driver: "s3"
};
var team_default3 = {
  name: "Stacks",
  members: {
    chris: "chris@stacksjs.org",
    blake: "blake@stacksjs.org",
    zoltan: "zoltan@stacksjs.org",
    freddy: "freddy@stacksjs.org",
    glenn: "glenn@stacksjs.org",
    dorell: "dorell@stacksjs.org",
    avery: "avery@stacksjs.org",
    adelino: "adelino@stacksjs.org"
  }
};
var ui_default3 = {
  shortcuts: [
    [
      "btn",
      "inline-flex items-center px-4 py-2 ml-2 border border-transparent shadow-sm text-base font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500 cursor-pointer"
    ]
  ],
  safelist: "prose prose-sm m-auto text-left",
  trigger: ":stx:",
  classPrefix: "stx-",
  reset: "tailwind",
  icons: ["heroicons"],
  fonts: {
    email: {
      title: "Mona",
      text: "Hubot"
    },
    desktop: {
      title: "Mona",
      text: "Hubot"
    },
    mobile: {
      title: "Mona",
      text: "Hubot"
    },
    web: {
      title: "Mona",
      text: "Hubot"
    }
  },
  theme: {
    colors: {
      veryCool: "#0000ff",
      brand: {
        primary: "hsl(var(--hue, 217) 78% 51%)"
      }
    }
  }
};
var config23 = {
  ai: ai_default3,
  analytics: analytics_default3,
  app: app_default3,
  cache: cache_default3,
  cli: cli_default3,
  cloud: cloud_default3,
  database: database_default3,
  dns: dns_default3,
  email: email_default3,
  errors: errors_default3,
  git: git_default3,
  hashing: hashing_default3,
  library: library_default3,
  logging: logging_default3,
  notification: notification_default3,
  queue: queue_default3,
  payment: payment_default3,
  ports: ports_default3,
  saas: saas_default3,
  searchEngine: search_engine_default3,
  security: security_default3,
  services: services_default3,
  storage: storage_default3,
  team: team_default3,
  ui: ui_default3
};
var overrides_default3 = config23;
async function localTunnel3(options3) {
  const port = 3000;
  if (!options3?.port)
    options3 = { port };
  console.log("Creating local tunnel", options3.port);
  return "localTunnel";
}
async function createLocalTunnel3(port) {
  return await localTunnel3({ port });
}
async function localUrl3({
  domain = exports_config3.app.url || "stacks",
  type: type2 = "frontend",
  localhost = false,
  https = undefined,
  network = undefined
} = {}) {
  let url = domain.replace(/\.[^.]+$/, ".localhost");
  switch (type2) {
    case "frontend":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.frontend || 3000);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.frontend}`;
      break;
    case "backend":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.backend || 3001);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.backend}`;
      url = `api.${url}`;
      break;
    case "admin":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.admin || 3002);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.admin}`;
      url = `admin.${url}`;
      break;
    case "library":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.library || 3003);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.library}`;
      url = `libs.${url}`;
      break;
    case "email":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.email || 3005);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.email}`;
      url = `email.${url}`;
      break;
    case "desktop":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.desktop || 3004);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.desktop}`;
      url = `desktop.${url}`;
      break;
    case "docs":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.docs || 3006);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.docs}`;
      url = `docs.${url}`;
      break;
    case "inspect":
      if (network)
        return await createLocalTunnel3(exports_config3.ports?.inspect || 3007);
      if (localhost)
        return `http://localhost:${exports_config3.ports?.inspect}`;
      url = `inspect.${url}`;
      break;
    default:
      if (localhost)
        return `http://localhost:${exports_config3.ports?.frontend}`;
  }
  if (https)
    return `https://${url}`;
  return `http://${url}`;
}
function defineStacksConfig3(config33) {
  return config33;
}
function defineApp3(config33) {
  return config33;
}
function defineCache3(config33) {
  return config33;
}
function defineCdn3(config33) {
  return config33;
}
function defineChat3(config33) {
  return config33;
}
function defineCli3(config33) {
  return config33;
}
function defineJob3(config33) {
  return config33;
}
function defineCronJob3(config33) {
  return config33;
}
function defineDatabase3(config33) {
  return config33;
}
function defineDependencies3(config33) {
  return config33;
}
function defineDns3(config33) {
  return config33;
}
function defineEmailConfig3(config33) {
  return config33;
}
function defineEmail3(config33) {
  return config33;
}
function defineGit3(config33) {
  return config33;
}
function defineHashing3(config33) {
  return config33;
}
function defineLibrary3(config33) {
  return config33;
}
function defineNotification3(config33) {
  return config33;
}
function definePayment3(config33) {
  return config33;
}
function defineQueue3(config33) {
  return config33;
}
function defineSearchEngine3(config33) {
  return config33;
}
function defineSecurity3(config33) {
  return config33;
}
function defineServices3(config33) {
  return config33;
}
function defineSms3(config33) {
  return config33;
}
function defineStorage3(config33) {
  return config33;
}
function defineUi3(config33) {
  return config33;
}
function defineModel3(config33) {
  return config33;
}
function defineEvents3(config33) {
  return config33;
}
var config33 = {
  ...defaults_default3,
  ...overrides_default3
};
var ai23 = config33.ai;
var analytics23 = config33.analytics;
var app23 = config33.app;
var cache23 = config33.cache;
var cloud23 = config33.cloud;
var cli32 = config33.cli;
var database23 = config33.database;
var dns23 = config33.dns;
var docs23 = config33.docs;
var email23 = config33.email;
var errors23 = config33.errors;
var git23 = config33.git;
var hashing23 = config33.hashing;
var library23 = config33.library;
var logging23 = config33.logging;
var notification3 = config33.notification;
var payment3 = config33.payment;
var ports23 = config33.ports;
var queue33 = config33.queue;
var security23 = config33.security;
var saas23 = config33.saas;
var searchEngine3 = config33.searchEngine;
var services23 = config33.services;
var storage23 = config33.storage;
var team23 = config33.team;
var ui23 = config33.ui;
function determineAppEnv3() {
  if (app23.env === "local")
    return "dev";
  if (app23.env === "development")
    return "dev";
  if (app23.env === "staging")
    return "stage";
  if (app23.env === "production")
    return "prod";
  if (!app23.env)
    throw new Error("Couldn\'t determine app environment");
  return app23.env;
}

class ErrorHandler3 {
  static isTestEnvironment = false;
  static shouldExitProcess = true;
  static handle(err3, options3) {
    this.shouldExitProcess = options3?.shouldExit !== false;
    if (options3?.silent !== true)
      this.writeErrorToConsole(err3);
    let errorMessage;
    if (options3?.message) {
      errorMessage = options3.message;
    } else if (err3 instanceof Error) {
      errorMessage = err3.message;
    } else if (typeof err3 === "string") {
      errorMessage = err3;
    } else {
      errorMessage = JSON.stringify(err3);
    }
    const error = new Error(errorMessage);
    if (err3 instanceof Error) {
      Object.assign(error, err3);
    }
    this.writeErrorToFile(error).catch((e5) => console.error(e5));
    return error;
  }
  static handleError(err3, options3) {
    this.handle(err3, options3);
    return err3;
  }
  static async writeErrorToFile(err3) {
    if (!(err3 instanceof Error)) {
      console.error("Error is not an instance of Error:", err3);
      return;
    }
    const formattedError = `[${new Date().toISOString()}] ${err3.name}: ${err3.message}\n`;
    const logFilePath = logsPath3("stacks.log") ?? logsPath3("errors.log");
    try {
      await mkdir3(dirname5(logFilePath), { recursive: true });
      await appendFile3(logFilePath, formattedError);
    } catch (error) {
      console.error("Failed to write to error file:", error);
    }
  }
  static writeErrorToConsole(err3) {
    console.error(err3);
    const errorString = typeof err3 === "string" ? err3 : err3 instanceof Error ? err3.message : JSON.stringify(err3);
    if (errorString.includes("bunx --bun cdk destroy") || errorString === `Failed to execute command: ${italic3("bunx --bun eslint . --fix")}` || errorString === `Failed to execute command: ${italic3("bun storage/framework/core/actions/src/lint/fix.ts")}`) {
      if (!this.isTestEnvironment) {
        console.log("No need to worry. The edge function is currently being destroyed. Please run `buddy undeploy` shortly again, and continue doing so until it succeeds running.");
        console.log("Hoping to see you back soon!");
      }
    }
    if (this.shouldExitProcess) {
      process73.exit(1);
    }
  }
}
function handleError3(err3, options3) {
  let errorMessage;
  if (isString3(err3)) {
    errorMessage = err3;
  } else if (err3 instanceof Error) {
    errorMessage = err3.message;
  } else if (options3 instanceof Error) {
    errorMessage = options3.message;
  } else {
    errorMessage = String(err3);
  }
  writeToLogFile3(`ERROR: ${stripAnsi6(errorMessage)}`);
  return ErrorHandler3.handle(err3, options3);
}
async function writeToLogFile3(message, options3) {
  const formattedMessage = `[${new Date().toISOString()}] ${message}\n`;
  try {
    const logFile = options3?.logFile ?? exports_config3.logging.logsPath ?? "storage/logs/stacks.log";
    try {
      await access3(logFile);
    } catch {
      await mkdir3(dirname23(logFile), { recursive: true });
    }
    await appendFile3(logFile, formattedMessage);
  } catch (error) {
    console.error("Failed to write to log file:", error);
  }
}
var defaultErrorConfig3 = {
  withStackTrace: false
};
var createNeverThrowError3 = (message, result2, config5 = defaultErrorConfig3) => {
  const data2 = result2.isOk() ? { type: "Ok", value: result2.value } : { type: "Err", value: result2.error };
  const maybeStack = config5.withStackTrace ? new Error().stack : undefined;
  return {
    data: data2,
    message,
    stack: maybeStack
  };
};
function __awaiter3(thisArg, _arguments, P23, generator) {
  function adopt(value) {
    return value instanceof P23 ? value : new P23(function(resolve32) {
      resolve32(value);
    });
  }
  return new (P23 || (P23 = Promise))(function(resolve32, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e5) {
        reject(e5);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e5) {
        reject(e5);
      }
    }
    function step(result2) {
      result2.done ? resolve32(result2.value) : adopt(result2.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __values3(o5) {
  var s32 = typeof Symbol === "function" && Symbol.iterator, m23 = s32 && o5[s32], i5 = 0;
  if (m23)
    return m23.call(o5);
  if (o5 && typeof o5.length === "number")
    return {
      next: function() {
        if (o5 && i5 >= o5.length)
          o5 = undefined;
        return { value: o5 && o5[i5++], done: !o5 };
      }
    };
  throw new TypeError(s32 ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __await3(v23) {
  return this instanceof __await3 ? (this.v = v23, this) : new __await3(v23);
}
function __asyncGenerator3(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g23 = generator.apply(thisArg, _arguments || []), i5, q32 = [];
  return i5 = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i5[Symbol.asyncIterator] = function() {
    return this;
  }, i5;
  function awaitReturn(f23) {
    return function(v23) {
      return Promise.resolve(v23).then(f23, reject);
    };
  }
  function verb(n5, f23) {
    if (g23[n5]) {
      i5[n5] = function(v23) {
        return new Promise(function(a5, b23) {
          q32.push([n5, v23, a5, b23]) > 1 || resume(n5, v23);
        });
      };
      if (f23)
        i5[n5] = f23(i5[n5]);
    }
  }
  function resume(n5, v23) {
    try {
      step(g23[n5](v23));
    } catch (e5) {
      settle(q32[0][3], e5);
    }
  }
  function step(r23) {
    r23.value instanceof __await3 ? Promise.resolve(r23.value.v).then(fulfill, reject) : settle(q32[0][2], r23);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f23, v23) {
    if (f23(v23), q32.shift(), q32.length)
      resume(q32[0][0], q32[0][1]);
  }
}
function __asyncDelegator3(o5) {
  var i5, p33;
  return i5 = {}, verb("next"), verb("throw", function(e5) {
    throw e5;
  }), verb("return"), i5[Symbol.iterator] = function() {
    return this;
  }, i5;
  function verb(n5, f23) {
    i5[n5] = o5[n5] ? function(v23) {
      return (p33 = !p33) ? { value: __await3(o5[n5](v23)), done: false } : f23 ? f23(v23) : v23;
    } : f23;
  }
}
function __asyncValues3(o5) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m23 = o5[Symbol.asyncIterator], i5;
  return m23 ? m23.call(o5) : (o5 = typeof __values3 === "function" ? __values3(o5) : o5[Symbol.iterator](), i5 = {}, verb("next"), verb("throw"), verb("return"), i5[Symbol.asyncIterator] = function() {
    return this;
  }, i5);
  function verb(n5) {
    i5[n5] = o5[n5] && function(v23) {
      return new Promise(function(resolve32, reject) {
        v23 = o5[n5](v23), settle(resolve32, reject, v23.done, v23.value);
      });
    };
  }
  function settle(resolve32, reject, d5, v23) {
    Promise.resolve(v23).then(function(v32) {
      resolve32({ value: v32, done: d5 });
    }, reject);
  }
}

class ResultAsync3 {
  constructor(res) {
    this._promise = res;
  }
  static fromSafePromise(promise2) {
    const newPromise = promise2.then((value) => new Ok3(value));
    return new ResultAsync3(newPromise);
  }
  static fromPromise(promise2, errorFn) {
    const newPromise = promise2.then((value) => new Ok3(value)).catch((e5) => new Err3(errorFn(e5)));
    return new ResultAsync3(newPromise);
  }
  static fromThrowable(fn, errorFn) {
    return (...args) => {
      return new ResultAsync3((() => __awaiter3(this, undefined, undefined, function* () {
        try {
          return new Ok3(yield fn(...args));
        } catch (error) {
          return new Err3(errorFn ? errorFn(error) : error);
        }
      }))());
    };
  }
  static combine(asyncResultList) {
    return combineResultAsyncList3(asyncResultList);
  }
  static combineWithAllErrors(asyncResultList) {
    return combineResultAsyncListWithAllErrors3(asyncResultList);
  }
  map(f23) {
    return new ResultAsync3(this._promise.then((res) => __awaiter3(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return new Err3(res.error);
      }
      return new Ok3(yield f23(res.value));
    })));
  }
  andThrough(f23) {
    return new ResultAsync3(this._promise.then((res) => __awaiter3(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return new Err3(res.error);
      }
      const newRes = yield f23(res.value);
      if (newRes.isErr()) {
        return new Err3(newRes.error);
      }
      return new Ok3(res.value);
    })));
  }
  andTee(f23) {
    return new ResultAsync3(this._promise.then((res) => __awaiter3(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return new Err3(res.error);
      }
      try {
        yield f23(res.value);
      } catch (e5) {
      }
      return new Ok3(res.value);
    })));
  }
  mapErr(f23) {
    return new ResultAsync3(this._promise.then((res) => __awaiter3(this, undefined, undefined, function* () {
      if (res.isOk()) {
        return new Ok3(res.value);
      }
      return new Err3(yield f23(res.error));
    })));
  }
  andThen(f23) {
    return new ResultAsync3(this._promise.then((res) => {
      if (res.isErr()) {
        return new Err3(res.error);
      }
      const newValue = f23(res.value);
      return newValue instanceof ResultAsync3 ? newValue._promise : newValue;
    }));
  }
  orElse(f23) {
    return new ResultAsync3(this._promise.then((res) => __awaiter3(this, undefined, undefined, function* () {
      if (res.isErr()) {
        return f23(res.error);
      }
      return new Ok3(res.value);
    })));
  }
  match(ok3, _err) {
    return this._promise.then((res) => res.match(ok3, _err));
  }
  unwrapOr(t5) {
    return this._promise.then((res) => res.unwrapOr(t5));
  }
  safeUnwrap() {
    return __asyncGenerator3(this, arguments, function* safeUnwrap_1() {
      return yield __await3(yield __await3(yield* __asyncDelegator3(__asyncValues3(yield __await3(this._promise.then((res) => res.safeUnwrap()))))));
    });
  }
  then(successCallback, failureCallback) {
    return this._promise.then(successCallback, failureCallback);
  }
  [Symbol.asyncIterator]() {
    return __asyncGenerator3(this, arguments, function* _a() {
      const result2 = yield __await3(this._promise);
      if (result2.isErr()) {
        yield yield __await3(errAsync3(result2.error));
      }
      return yield __await3(result2.value);
    });
  }
}
var errAsync3 = (err3) => new ResultAsync3(Promise.resolve(new Err3(err3)));
var fromPromise3 = ResultAsync3.fromPromise;
var fromSafePromise3 = ResultAsync3.fromSafePromise;
var fromAsyncThrowable3 = ResultAsync3.fromThrowable;
var combineResultList3 = (resultList) => {
  let acc = ok3([]);
  for (const result2 of resultList) {
    if (result2.isErr()) {
      acc = err3(result2.error);
      break;
    } else {
      acc.map((list2) => list2.push(result2.value));
    }
  }
  return acc;
};
var combineResultAsyncList3 = (asyncResultList) => ResultAsync3.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultList3);
var combineResultListWithAllErrors3 = (resultList) => {
  let acc = ok3([]);
  for (const result2 of resultList) {
    if (result2.isErr() && acc.isErr()) {
      acc.error.push(result2.error);
    } else if (result2.isErr() && acc.isOk()) {
      acc = err3([result2.error]);
    } else if (result2.isOk() && acc.isOk()) {
      acc.value.push(result2.value);
    }
  }
  return acc;
};
var combineResultAsyncListWithAllErrors3 = (asyncResultList) => ResultAsync3.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultListWithAllErrors3);
var Result3;
(function(Result22) {
  function fromThrowable3(fn, errorFn) {
    return (...args) => {
      try {
        const result2 = fn(...args);
        return ok3(result2);
      } catch (e5) {
        return err3(errorFn ? errorFn(e5) : e5);
      }
    };
  }
  Result22.fromThrowable = fromThrowable3;
  function combine(resultList) {
    return combineResultList3(resultList);
  }
  Result22.combine = combine;
  function combineWithAllErrors(resultList) {
    return combineResultListWithAllErrors3(resultList);
  }
  Result22.combineWithAllErrors = combineWithAllErrors;
})(Result3 || (Result3 = {}));
var ok3 = (value) => new Ok3(value);
function err3(err22) {
  return new Err3(err22);
}

class Ok3 {
  constructor(value) {
    this.value = value;
  }
  isOk() {
    return true;
  }
  isErr() {
    return !this.isOk();
  }
  map(f23) {
    return ok3(f23(this.value));
  }
  mapErr(_f) {
    return ok3(this.value);
  }
  andThen(f23) {
    return f23(this.value);
  }
  andThrough(f23) {
    return f23(this.value).map((_value) => this.value);
  }
  andTee(f23) {
    try {
      f23(this.value);
    } catch (e5) {
    }
    return ok3(this.value);
  }
  orElse(_f) {
    return ok3(this.value);
  }
  asyncAndThen(f23) {
    return f23(this.value);
  }
  asyncAndThrough(f23) {
    return f23(this.value).map(() => this.value);
  }
  asyncMap(f23) {
    return ResultAsync3.fromSafePromise(f23(this.value));
  }
  unwrapOr(_v2) {
    return this.value;
  }
  match(ok22, _err) {
    return ok22(this.value);
  }
  safeUnwrap() {
    const value = this.value;
    return function* () {
      return value;
    }();
  }
  _unsafeUnwrap(_23) {
    return this.value;
  }
  _unsafeUnwrapErr(config5) {
    throw createNeverThrowError3("Called `_unsafeUnwrapErr` on an Ok", this, config5);
  }
  *[Symbol.iterator]() {
    return this.value;
  }
}

class Err3 {
  constructor(error) {
    this.error = error;
  }
  isOk() {
    return false;
  }
  isErr() {
    return !this.isOk();
  }
  map(_f) {
    return err3(this.error);
  }
  mapErr(f23) {
    return err3(f23(this.error));
  }
  andThrough(_f) {
    return err3(this.error);
  }
  andTee(_f) {
    return err3(this.error);
  }
  andThen(_f) {
    return err3(this.error);
  }
  orElse(f23) {
    return f23(this.error);
  }
  asyncAndThen(_f) {
    return errAsync3(this.error);
  }
  asyncAndThrough(_f) {
    return errAsync3(this.error);
  }
  asyncMap(_f) {
    return errAsync3(this.error);
  }
  unwrapOr(v23) {
    return v23;
  }
  match(_ok, err22) {
    return err22(this.error);
  }
  safeUnwrap() {
    const error = this.error;
    return function* () {
      yield err3(error);
      throw new Error("Do not use this generator out of `safeTry`");
    }();
  }
  _unsafeUnwrap(config5) {
    throw createNeverThrowError3("Called `_unsafeUnwrap` on an Err", this, config5);
  }
  _unsafeUnwrapErr(_23) {
    return this.error;
  }
  *[Symbol.iterator]() {
    const self2 = this;
    yield self2;
    return self2;
  }
}
var fromThrowable3 = Result3.fromThrowable;
var import_prompts3 = __toESM22(require_prompts33(), 1);
async function exec2(command, options3) {
  const cmd = Array.isArray(command) ? command : command.match(/(?:[^\s"]|"[^"]*")+/g);
  log3.debug("exec:", Array.isArray(command) ? command.join(" ") : command, options3);
  log3.debug("cmd:", cmd);
  if (!cmd)
    return err3(handleError3(`Failed to parse command: ${cmd}`, options3));
  const cwd = options3?.cwd ?? process82.cwd();
  const proc = Bun.spawn(cmd, {
    stdin: options3?.stdin ?? "inherit",
    stdout: options3?.silent || options3?.quiet ? "ignore" : options3?.stdin ? options3.stdin : options3?.stdout || "inherit",
    stderr: options3?.silent || options3?.quiet ? "ignore" : options3?.stderr || "inherit",
    cwd,
    onExit(subprocess, exitCode, signalCode, error) {
      exitHandler2("spawn", subprocess, exitCode, signalCode, error);
    }
  });
  if (options3?.stdin === "pipe" && options3.input) {
    if (proc.stdin) {
      proc.stdin.write(options3.input);
      proc.stdin.end();
    }
  }
  const exited = await proc.exited;
  if (exited === 0)
    return ok3(proc);
  return err3(handleError3(`Failed to execute command: ${italic3(cmd.join(" "))} in ${italic3(cwd)}`, options3));
}
function exitHandler2(type2, subprocess, exitCode, signalCode, error) {
  log3.debug(`exitHandler: ${type2}`);
  log3.debug("subprocess", subprocess);
  log3.debug("exitCode", exitCode);
  log3.debug("signalCode", signalCode);
  if (error) {
    log3.error(error);
    process82.exit(1);
  }
  if (exitCode !== 0 && exitCode)
    process82.exit(exitCode);
}
async function runCommand2(command, options3) {
  log3.debug("runCommand:", command, options3);
  const opts = {
    ...options3,
    stdio: options3?.stdio ?? [options3?.stdin ?? "inherit", "pipe", "pipe"],
    verbose: options3?.verbose ?? false
  };
  return await exec2(command, opts);
}
var exports_esm2 = {};
__export5(exports_esm2, {
  yellow: () => yellow3,
  white: () => white3,
  underline: () => underline3,
  trueColorBg: () => trueColorBg2,
  trueColor: () => trueColor2,
  stripColors: () => stripColors2,
  strikethrough: () => strikethrough3,
  reset: () => reset3,
  red: () => red3,
  options: () => options3,
  magenta: () => magenta3,
  link: () => link2,
  lightYellow: () => lightYellow3,
  lightRed: () => lightRed3,
  lightMagenta: () => lightMagenta3,
  lightGreen: () => lightGreen3,
  lightGray: () => lightGray3,
  lightCyan: () => lightCyan3,
  lightBlue: () => lightBlue3,
  italic: () => italic3,
  inverse: () => inverse3,
  hidden: () => hidden3,
  green: () => green3,
  gray: () => gray3,
  dim: () => dim3,
  cyan: () => cyan3,
  bold: () => bold3,
  blue: () => blue3,
  black: () => black3,
  bgYellow: () => bgYellow3,
  bgWhite: () => bgWhite3,
  bgRed: () => bgRed3,
  bgMagenta: () => bgMagenta3,
  bgLightYellow: () => bgLightYellow3,
  bgLightRed: () => bgLightRed3,
  bgLightMagenta: () => bgLightMagenta3,
  bgLightGreen: () => bgLightGreen3,
  bgLightGray: () => bgLightGray3,
  bgLightCyan: () => bgLightCyan3,
  bgLightBlue: () => bgLightBlue3,
  bgGreen: () => bgGreen3,
  bgGray: () => bgGray3,
  bgCyan: () => bgCyan3,
  bgBlue: () => bgBlue3,
  bgBlack: () => bgBlack3,
  ansi256Bg: () => ansi256Bg2,
  ansi256: () => ansi2562
});
var enabled3 = true;
var globalVar3 = typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {};
var supportLevel3 = 0;
if (globalVar3.process && globalVar3.process.env && globalVar3.process.stdout) {
  const { FORCE_COLOR, NODE_DISABLE_COLORS, NO_COLOR, TERM, COLORTERM } = globalVar3.process.env;
  if (NODE_DISABLE_COLORS || NO_COLOR || FORCE_COLOR === "0") {
    enabled3 = false;
  } else if (FORCE_COLOR === "1" || FORCE_COLOR === "2" || FORCE_COLOR === "3") {
    enabled3 = true;
  } else if (TERM === "dumb") {
    enabled3 = false;
  } else if ("CI" in globalVar3.process.env && [
    "TRAVIS",
    "CIRCLECI",
    "APPVEYOR",
    "GITLAB_CI",
    "GITHUB_ACTIONS",
    "BUILDKITE",
    "DRONE"
  ].some((vendor) => (vendor in globalVar3.process.env))) {
    enabled3 = true;
  } else {
    enabled3 = process.stdout.isTTY;
  }
  if (enabled3) {
    if (process.platform === "win32") {
      supportLevel3 = 3;
    } else {
      if (COLORTERM && (COLORTERM === "truecolor" || COLORTERM === "24bit")) {
        supportLevel3 = 3;
      } else if (TERM && (TERM.endsWith("-256color") || TERM.endsWith("256"))) {
        supportLevel3 = 2;
      } else {
        supportLevel3 = 1;
      }
    }
  }
}
var options3 = {
  enabled: enabled3,
  supportLevel: supportLevel3
};
function kolorist3(start, end, level = 1) {
  const open = `\x1B[${start}m`;
  const close = `\x1B[${end}m`;
  const regex22 = new RegExp(`\\x1b\\[${end}m`, "g");
  return (str2) => {
    return options3.enabled && options3.supportLevel >= level ? open + ("" + str2).replace(regex22, open) + close : "" + str2;
  };
}
function rgbToAnsi2562(r23, g23, b23) {
  if (r23 >> 4 === g23 >> 4 && g23 >> 4 === b23 >> 4) {
    if (r23 < 8) {
      return 16;
    }
    if (r23 > 248) {
      return 231;
    }
    return Math.round((r23 - 8) / 247 * 24) + 232;
  }
  const ansi = 16 + 36 * Math.round(r23 / 255 * 5) + 6 * Math.round(g23 / 255 * 5) + Math.round(b23 / 255 * 5);
  return ansi;
}
function stripColors2(str2) {
  return ("" + str2).replace(/\x1b\[[0-9;]+m/g, "").replace(/\x1b\]8;;.*?\x07(.*?)\x1b\]8;;\x07/g, (_23, group22) => group22);
}
var reset3 = kolorist3(0, 0);
var bold3 = kolorist3(1, 22);
var dim3 = kolorist3(2, 22);
var italic3 = kolorist3(3, 23);
var underline3 = kolorist3(4, 24);
var inverse3 = kolorist3(7, 27);
var hidden3 = kolorist3(8, 28);
var strikethrough3 = kolorist3(9, 29);
var black3 = kolorist3(30, 39);
var red3 = kolorist3(31, 39);
var green3 = kolorist3(32, 39);
var yellow3 = kolorist3(33, 39);
var blue3 = kolorist3(34, 39);
var magenta3 = kolorist3(35, 39);
var cyan3 = kolorist3(36, 39);
var white3 = kolorist3(97, 39);
var gray3 = kolorist3(90, 39);
var lightGray3 = kolorist3(37, 39);
var lightRed3 = kolorist3(91, 39);
var lightGreen3 = kolorist3(92, 39);
var lightYellow3 = kolorist3(93, 39);
var lightBlue3 = kolorist3(94, 39);
var lightMagenta3 = kolorist3(95, 39);
var lightCyan3 = kolorist3(96, 39);
var bgBlack3 = kolorist3(40, 49);
var bgRed3 = kolorist3(41, 49);
var bgGreen3 = kolorist3(42, 49);
var bgYellow3 = kolorist3(43, 49);
var bgBlue3 = kolorist3(44, 49);
var bgMagenta3 = kolorist3(45, 49);
var bgCyan3 = kolorist3(46, 49);
var bgWhite3 = kolorist3(107, 49);
var bgGray3 = kolorist3(100, 49);
var bgLightRed3 = kolorist3(101, 49);
var bgLightGreen3 = kolorist3(102, 49);
var bgLightYellow3 = kolorist3(103, 49);
var bgLightBlue3 = kolorist3(104, 49);
var bgLightMagenta3 = kolorist3(105, 49);
var bgLightCyan3 = kolorist3(106, 49);
var bgLightGray3 = kolorist3(47, 49);
var ansi2562 = (n5) => kolorist3("38;5;" + n5, 0, 2);
var ansi256Bg2 = (n5) => kolorist3("48;5;" + n5, 0, 2);
var trueColor2 = (r23, g23, b23) => {
  return options3.supportLevel === 2 ? ansi2562(rgbToAnsi2562(r23, g23, b23)) : kolorist3(`38;2;${r23};${g23};${b23}`, 0, 3);
};
var trueColorBg2 = (r23, g23, b23) => {
  return options3.supportLevel === 2 ? ansi256Bg2(rgbToAnsi2562(r23, g23, b23)) : kolorist3(`48;2;${r23};${g23};${b23}`, 0, 3);
};
var OSC2 = "\x1B]";
var BEL2 = "\x07";
var SEP2 = ";";
function link2(text22, url) {
  return options3.enabled ? OSC2 + "8" + SEP2 + SEP2 + url + BEL2 + text22 + OSC2 + "8" + SEP2 + SEP2 + BEL2 : `${text22} (\u200B${url}\u200B)`;
}
function buddyOptions3(options23) {
  if (Array.isArray(options23)) {
    options23 = Array.from(new Set(options23));
    if (Array.isArray(options23) && options23[0] && !options23[0].startsWith("-"))
      options23.shift();
    return options23.join(" ");
  }
  if (typeof options23 === "object" && options23 !== null) {
    return Object.entries(options23).map(([key, value]) => {
      if (value === true)
        return `--${key}`;
      return `--${key} ${value}`;
    }).join(" ");
  }
  return buddyOptions3(process102.argv.slice(2));
}
var ANSI_BACKGROUND_OFFSET2 = 10;
var wrapAnsi162 = (offset = 0) => (code) => `\x1B[${code + offset}m`;
var wrapAnsi2562 = (offset = 0) => (code) => `\x1B[${38 + offset};5;${code}m`;
var wrapAnsi16m2 = (offset = 0) => (red23, green23, blue22) => `\x1B[${38 + offset};2;${red23};${green23};${blue22}m`;
var styles3 = {
  modifier: {
    reset: [0, 0],
    bold: [1, 22],
    dim: [2, 22],
    italic: [3, 23],
    underline: [4, 24],
    overline: [53, 55],
    inverse: [7, 27],
    hidden: [8, 28],
    strikethrough: [9, 29]
  },
  color: {
    black: [30, 39],
    red: [31, 39],
    green: [32, 39],
    yellow: [33, 39],
    blue: [34, 39],
    magenta: [35, 39],
    cyan: [36, 39],
    white: [37, 39],
    blackBright: [90, 39],
    gray: [90, 39],
    grey: [90, 39],
    redBright: [91, 39],
    greenBright: [92, 39],
    yellowBright: [93, 39],
    blueBright: [94, 39],
    magentaBright: [95, 39],
    cyanBright: [96, 39],
    whiteBright: [97, 39]
  },
  bgColor: {
    bgBlack: [40, 49],
    bgRed: [41, 49],
    bgGreen: [42, 49],
    bgYellow: [43, 49],
    bgBlue: [44, 49],
    bgMagenta: [45, 49],
    bgCyan: [46, 49],
    bgWhite: [47, 49],
    bgBlackBright: [100, 49],
    bgGray: [100, 49],
    bgGrey: [100, 49],
    bgRedBright: [101, 49],
    bgGreenBright: [102, 49],
    bgYellowBright: [103, 49],
    bgBlueBright: [104, 49],
    bgMagentaBright: [105, 49],
    bgCyanBright: [106, 49],
    bgWhiteBright: [107, 49]
  }
};
var modifierNames2 = Object.keys(styles3.modifier);
var foregroundColorNames2 = Object.keys(styles3.color);
var backgroundColorNames2 = Object.keys(styles3.bgColor);
var colorNames2 = [...foregroundColorNames2, ...backgroundColorNames2];
function assembleStyles2() {
  const codes = new Map;
  for (const [groupName, group22] of Object.entries(styles3)) {
    for (const [styleName, style] of Object.entries(group22)) {
      styles3[styleName] = {
        open: `\x1B[${style[0]}m`,
        close: `\x1B[${style[1]}m`
      };
      group22[styleName] = styles3[styleName];
      codes.set(style[0], style[1]);
    }
    Object.defineProperty(styles3, groupName, {
      value: group22,
      enumerable: false
    });
  }
  Object.defineProperty(styles3, "codes", {
    value: codes,
    enumerable: false
  });
  styles3.color.close = "\x1B[39m";
  styles3.bgColor.close = "\x1B[49m";
  styles3.color.ansi = wrapAnsi162();
  styles3.color.ansi256 = wrapAnsi2562();
  styles3.color.ansi16m = wrapAnsi16m2();
  styles3.bgColor.ansi = wrapAnsi162(ANSI_BACKGROUND_OFFSET2);
  styles3.bgColor.ansi256 = wrapAnsi2562(ANSI_BACKGROUND_OFFSET2);
  styles3.bgColor.ansi16m = wrapAnsi16m2(ANSI_BACKGROUND_OFFSET2);
  Object.defineProperties(styles3, {
    rgbToAnsi256: {
      value(red23, green23, blue22) {
        if (red23 === green23 && green23 === blue22) {
          if (red23 < 8) {
            return 16;
          }
          if (red23 > 248) {
            return 231;
          }
          return Math.round((red23 - 8) / 247 * 24) + 232;
        }
        return 16 + 36 * Math.round(red23 / 255 * 5) + 6 * Math.round(green23 / 255 * 5) + Math.round(blue22 / 255 * 5);
      },
      enumerable: false
    },
    hexToRgb: {
      value(hex) {
        const matches = /[a-f\d]{6}|[a-f\d]{3}/i.exec(hex.toString(16));
        if (!matches) {
          return [0, 0, 0];
        }
        let [colorString] = matches;
        if (colorString.length === 3) {
          colorString = [...colorString].map((character) => character + character).join("");
        }
        const integer = Number.parseInt(colorString, 16);
        return [
          integer >> 16 & 255,
          integer >> 8 & 255,
          integer & 255
        ];
      },
      enumerable: false
    },
    hexToAnsi256: {
      value: (hex) => styles3.rgbToAnsi256(...styles3.hexToRgb(hex)),
      enumerable: false
    },
    ansi256ToAnsi: {
      value(code) {
        if (code < 8) {
          return 30 + code;
        }
        if (code < 16) {
          return 90 + (code - 8);
        }
        let red23;
        let green23;
        let blue22;
        if (code >= 232) {
          red23 = ((code - 232) * 10 + 8) / 255;
          green23 = red23;
          blue22 = red23;
        } else {
          code -= 16;
          const remainder = code % 36;
          red23 = Math.floor(code / 36) / 5;
          green23 = Math.floor(remainder / 6) / 5;
          blue22 = remainder % 6 / 5;
        }
        const value = Math.max(red23, green23, blue22) * 2;
        if (value === 0) {
          return 30;
        }
        let result2 = 30 + (Math.round(blue22) << 2 | Math.round(green23) << 1 | Math.round(red23));
        if (value === 2) {
          result2 += 60;
        }
        return result2;
      },
      enumerable: false
    },
    rgbToAnsi: {
      value: (red23, green23, blue22) => styles3.ansi256ToAnsi(styles3.rgbToAnsi256(red23, green23, blue22)),
      enumerable: false
    },
    hexToAnsi: {
      value: (hex) => styles3.ansi256ToAnsi(styles3.hexToAnsi256(hex)),
      enumerable: false
    }
  });
  return styles3;
}
var ansiStyles2 = assembleStyles2();
var ansi_styles_default2 = ansiStyles2;
function hasFlag3(flag, argv23 = globalThis.Deno ? globalThis.Deno.args : process112.argv) {
  const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
  const position = argv23.indexOf(prefix + flag);
  const terminatorPosition = argv23.indexOf("--");
  return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
}
var { env: env43 } = process112;
var flagForceColor3;
if (hasFlag3("no-color") || hasFlag3("no-colors") || hasFlag3("color=false") || hasFlag3("color=never")) {
  flagForceColor3 = 0;
} else if (hasFlag3("color") || hasFlag3("colors") || hasFlag3("color=true") || hasFlag3("color=always")) {
  flagForceColor3 = 1;
}
function envForceColor3() {
  if ("FORCE_COLOR" in env43) {
    if (env43.FORCE_COLOR === "true") {
      return 1;
    }
    if (env43.FORCE_COLOR === "false") {
      return 0;
    }
    return env43.FORCE_COLOR.length === 0 ? 1 : Math.min(Number.parseInt(env43.FORCE_COLOR, 10), 3);
  }
}
function translateLevel3(level) {
  if (level === 0) {
    return false;
  }
  return {
    level,
    hasBasic: true,
    has256: level >= 2,
    has16m: level >= 3
  };
}
function _supportsColor3(haveStream, { streamIsTTY, sniffFlags = true } = {}) {
  const noFlagForceColor = envForceColor3();
  if (noFlagForceColor !== undefined) {
    flagForceColor3 = noFlagForceColor;
  }
  const forceColor = sniffFlags ? flagForceColor3 : noFlagForceColor;
  if (forceColor === 0) {
    return 0;
  }
  if (sniffFlags) {
    if (hasFlag3("color=16m") || hasFlag3("color=full") || hasFlag3("color=truecolor")) {
      return 3;
    }
    if (hasFlag3("color=256")) {
      return 2;
    }
  }
  if ("TF_BUILD" in env43 && "AGENT_NAME" in env43) {
    return 1;
  }
  if (haveStream && !streamIsTTY && forceColor === undefined) {
    return 0;
  }
  const min = forceColor || 0;
  if (env43.TERM === "dumb") {
    return min;
  }
  if (process112.platform === "win32") {
    const osRelease = os7.release().split(".");
    if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
      return Number(osRelease[2]) >= 14931 ? 3 : 2;
    }
    return 1;
  }
  if ("CI" in env43) {
    if ("GITHUB_ACTIONS" in env43 || "GITEA_ACTIONS" in env43) {
      return 3;
    }
    if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI", "BUILDKITE", "DRONE"].some((sign) => (sign in env43)) || env43.CI_NAME === "codeship") {
      return 1;
    }
    return min;
  }
  if ("TEAMCITY_VERSION" in env43) {
    return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env43.TEAMCITY_VERSION) ? 1 : 0;
  }
  if (env43.COLORTERM === "truecolor") {
    return 3;
  }
  if (env43.TERM === "xterm-kitty") {
    return 3;
  }
  if ("TERM_PROGRAM" in env43) {
    const version22 = Number.parseInt((env43.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
    switch (env43.TERM_PROGRAM) {
      case "iTerm.app": {
        return version22 >= 3 ? 3 : 2;
      }
      case "Apple_Terminal": {
        return 2;
      }
    }
  }
  if (/-256(color)?$/i.test(env43.TERM)) {
    return 2;
  }
  if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env43.TERM)) {
    return 1;
  }
  if ("COLORTERM" in env43) {
    return 1;
  }
  return min;
}
function createSupportsColor3(stream2, options23 = {}) {
  const level = _supportsColor3(stream2, {
    streamIsTTY: stream2 && stream2.isTTY,
    ...options23
  });
  return translateLevel3(level);
}
var supportsColor3 = {
  stdout: createSupportsColor3({ isTTY: tty33.isatty(1) }),
  stderr: createSupportsColor3({ isTTY: tty33.isatty(2) })
};
var supports_color_default3 = supportsColor3;
function stringReplaceAll2(string2, substring2, replacer) {
  let index = string2.indexOf(substring2);
  if (index === -1) {
    return string2;
  }
  const substringLength = substring2.length;
  let endIndex = 0;
  let returnValue = "";
  do {
    returnValue += string2.slice(endIndex, index) + substring2 + replacer;
    endIndex = index + substringLength;
    index = string2.indexOf(substring2, endIndex);
  } while (index !== -1);
  returnValue += string2.slice(endIndex);
  return returnValue;
}
function stringEncaseCRLFWithFirstIndex2(string2, prefix, postfix, index) {
  let endIndex = 0;
  let returnValue = "";
  do {
    const gotCR = string2[index - 1] === "\r";
    returnValue += string2.slice(endIndex, gotCR ? index - 1 : index) + prefix + (gotCR ? "\r\n" : "\n") + postfix;
    endIndex = index + 1;
    index = string2.indexOf("\n", endIndex);
  } while (index !== -1);
  returnValue += string2.slice(endIndex);
  return returnValue;
}
var { stdout: stdoutColor2, stderr: stderrColor2 } = supports_color_default3;
var GENERATOR2 = Symbol("GENERATOR");
var STYLER2 = Symbol("STYLER");
var IS_EMPTY2 = Symbol("IS_EMPTY");
var levelMapping2 = [
  "ansi",
  "ansi",
  "ansi256",
  "ansi16m"
];
var styles22 = Object.create(null);
var applyOptions2 = (object, options23 = {}) => {
  if (options23.level && !(Number.isInteger(options23.level) && options23.level >= 0 && options23.level <= 3)) {
    throw new Error("The `level` option should be an integer from 0 to 3");
  }
  const colorLevel = stdoutColor2 ? stdoutColor2.level : 0;
  object.level = options23.level === undefined ? colorLevel : options23.level;
};
var chalkFactory2 = (options23) => {
  const chalk2 = (...strings) => strings.join(" ");
  applyOptions2(chalk2, options23);
  Object.setPrototypeOf(chalk2, createChalk2.prototype);
  return chalk2;
};
function createChalk2(options23) {
  return chalkFactory2(options23);
}
Object.setPrototypeOf(createChalk2.prototype, Function.prototype);
for (const [styleName, style] of Object.entries(ansi_styles_default2)) {
  styles22[styleName] = {
    get() {
      const builder = createBuilder2(this, createStyler2(style.open, style.close, this[STYLER2]), this[IS_EMPTY2]);
      Object.defineProperty(this, styleName, { value: builder });
      return builder;
    }
  };
}
styles22.visible = {
  get() {
    const builder = createBuilder2(this, this[STYLER2], true);
    Object.defineProperty(this, "visible", { value: builder });
    return builder;
  }
};
var getModelAnsi2 = (model2, level, type2, ...arguments_) => {
  if (model2 === "rgb") {
    if (level === "ansi16m") {
      return ansi_styles_default2[type2].ansi16m(...arguments_);
    }
    if (level === "ansi256") {
      return ansi_styles_default2[type2].ansi256(ansi_styles_default2.rgbToAnsi256(...arguments_));
    }
    return ansi_styles_default2[type2].ansi(ansi_styles_default2.rgbToAnsi(...arguments_));
  }
  if (model2 === "hex") {
    return getModelAnsi2("rgb", level, type2, ...ansi_styles_default2.hexToRgb(...arguments_));
  }
  return ansi_styles_default2[type2][model2](...arguments_);
};
var usedModels2 = ["rgb", "hex", "ansi256"];
for (const model2 of usedModels2) {
  styles22[model2] = {
    get() {
      const { level } = this;
      return function(...arguments_) {
        const styler = createStyler2(getModelAnsi2(model2, levelMapping2[level], "color", ...arguments_), ansi_styles_default2.color.close, this[STYLER2]);
        return createBuilder2(this, styler, this[IS_EMPTY2]);
      };
    }
  };
  const bgModel = "bg" + model2[0].toUpperCase() + model2.slice(1);
  styles22[bgModel] = {
    get() {
      const { level } = this;
      return function(...arguments_) {
        const styler = createStyler2(getModelAnsi2(model2, levelMapping2[level], "bgColor", ...arguments_), ansi_styles_default2.bgColor.close, this[STYLER2]);
        return createBuilder2(this, styler, this[IS_EMPTY2]);
      };
    }
  };
}
var proto2 = Object.defineProperties(() => {
}, {
  ...styles22,
  level: {
    enumerable: true,
    get() {
      return this[GENERATOR2].level;
    },
    set(level) {
      this[GENERATOR2].level = level;
    }
  }
});
var createStyler2 = (open, close, parent) => {
  let openAll;
  let closeAll;
  if (parent === undefined) {
    openAll = open;
    closeAll = close;
  } else {
    openAll = parent.openAll + open;
    closeAll = close + parent.closeAll;
  }
  return {
    open,
    close,
    openAll,
    closeAll,
    parent
  };
};
var createBuilder2 = (self2, _styler, _isEmpty) => {
  const builder = (...arguments_) => applyStyle2(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
  Object.setPrototypeOf(builder, proto2);
  builder[GENERATOR2] = self2;
  builder[STYLER2] = _styler;
  builder[IS_EMPTY2] = _isEmpty;
  return builder;
};
var applyStyle2 = (self2, string2) => {
  if (self2.level <= 0 || !string2) {
    return self2[IS_EMPTY2] ? "" : string2;
  }
  let styler = self2[STYLER2];
  if (styler === undefined) {
    return string2;
  }
  const { openAll, closeAll } = styler;
  if (string2.includes("\x1B")) {
    while (styler !== undefined) {
      string2 = stringReplaceAll2(string2, styler.close, styler.open);
      styler = styler.parent;
    }
  }
  const lfIndex = string2.indexOf("\n");
  if (lfIndex !== -1) {
    string2 = stringEncaseCRLFWithFirstIndex2(string2, closeAll, openAll, lfIndex);
  }
  return openAll + string2 + closeAll;
};
Object.defineProperties(createChalk2.prototype, styles22);
var chalk2 = createChalk2();
var chalkStderr2 = createChalk2({ level: stderrColor2 ? stderrColor2.level : 0 });
var source_default2 = chalk2;
var copyProperty2 = (to, from, property, ignoreNonConfigurable) => {
  if (property === "length" || property === "prototype") {
    return;
  }
  if (property === "arguments" || property === "caller") {
    return;
  }
  const toDescriptor = Object.getOwnPropertyDescriptor(to, property);
  const fromDescriptor = Object.getOwnPropertyDescriptor(from, property);
  if (!canCopyProperty2(toDescriptor, fromDescriptor) && ignoreNonConfigurable) {
    return;
  }
  Object.defineProperty(to, property, fromDescriptor);
};
var canCopyProperty2 = function(toDescriptor, fromDescriptor) {
  return toDescriptor === undefined || toDescriptor.configurable || toDescriptor.writable === fromDescriptor.writable && toDescriptor.enumerable === fromDescriptor.enumerable && toDescriptor.configurable === fromDescriptor.configurable && (toDescriptor.writable || toDescriptor.value === fromDescriptor.value);
};
var changePrototype2 = (to, from) => {
  const fromPrototype = Object.getPrototypeOf(from);
  if (fromPrototype === Object.getPrototypeOf(to)) {
    return;
  }
  Object.setPrototypeOf(to, fromPrototype);
};
var wrappedToString2 = (withName, fromBody) => `/* Wrapped ${withName}*/\n${fromBody}`;
var toStringDescriptor2 = Object.getOwnPropertyDescriptor(Function.prototype, "toString");
var toStringName2 = Object.getOwnPropertyDescriptor(Function.prototype.toString, "name");
var changeToString2 = (to, from, name) => {
  const withName = name === "" ? "" : `with ${name.trim()}() `;
  const newToString = wrappedToString2.bind(null, withName, from.toString());
  Object.defineProperty(newToString, "name", toStringName2);
  const { writable, enumerable, configurable } = toStringDescriptor2;
  Object.defineProperty(to, "toString", { value: newToString, writable, enumerable, configurable });
};
function mimicFunction2(to, from, { ignoreNonConfigurable = false } = {}) {
  const { name } = to;
  for (const property of Reflect.ownKeys(from)) {
    copyProperty2(to, from, property, ignoreNonConfigurable);
  }
  changePrototype2(to, from);
  changeToString2(to, from, name);
  return to;
}
var calledFunctions2 = new WeakMap;
var onetime2 = (function_, options23 = {}) => {
  if (typeof function_ !== "function") {
    throw new TypeError("Expected a function");
  }
  let returnValue;
  let callCount = 0;
  const functionName = function_.displayName || function_.name || "<anonymous>";
  const onetime22 = function(...arguments_) {
    calledFunctions2.set(onetime22, ++callCount);
    if (callCount === 1) {
      returnValue = function_.apply(this, arguments_);
      function_ = undefined;
    } else if (options23.throw === true) {
      throw new Error(`Function \`${functionName}\` can only be called once`);
    }
    return returnValue;
  };
  mimicFunction2(onetime22, function_);
  calledFunctions2.set(onetime22, callCount);
  return onetime22;
};
onetime2.callCount = (function_) => {
  if (!calledFunctions2.has(function_)) {
    throw new Error(`The given function \`${function_.name}\` is not wrapped by the \`onetime\` package`);
  }
  return calledFunctions2.get(function_);
};
var onetime_default2 = onetime2;
var signals2 = [];
signals2.push("SIGHUP", "SIGINT", "SIGTERM");
if (process.platform !== "win32") {
  signals2.push("SIGALRM", "SIGABRT", "SIGVTALRM", "SIGXCPU", "SIGXFSZ", "SIGUSR2", "SIGTRAP", "SIGSYS", "SIGQUIT", "SIGIOT");
}
if (process.platform === "linux") {
  signals2.push("SIGIO", "SIGPOLL", "SIGPWR", "SIGSTKFLT");
}
var processOk2 = (process122) => !!process122 && typeof process122 === "object" && typeof process122.removeListener === "function" && typeof process122.emit === "function" && typeof process122.reallyExit === "function" && typeof process122.listeners === "function" && typeof process122.kill === "function" && typeof process122.pid === "number" && typeof process122.on === "function";
var kExitEmitter2 = Symbol.for("signal-exit emitter");
var global22 = globalThis;
var ObjectDefineProperty2 = Object.defineProperty.bind(Object);

class Emitter2 {
  emitted = {
    afterExit: false,
    exit: false
  };
  listeners = {
    afterExit: [],
    exit: []
  };
  count = 0;
  id = Math.random();
  constructor() {
    if (global22[kExitEmitter2]) {
      return global22[kExitEmitter2];
    }
    ObjectDefineProperty2(global22, kExitEmitter2, {
      value: this,
      writable: false,
      enumerable: false,
      configurable: false
    });
  }
  on(ev, fn) {
    this.listeners[ev].push(fn);
  }
  removeListener(ev, fn) {
    const list2 = this.listeners[ev];
    const i5 = list2.indexOf(fn);
    if (i5 === -1) {
      return;
    }
    if (i5 === 0 && list2.length === 1) {
      list2.length = 0;
    } else {
      list2.splice(i5, 1);
    }
  }
  emit(ev, code, signal) {
    if (this.emitted[ev]) {
      return false;
    }
    this.emitted[ev] = true;
    let ret = false;
    for (const fn of this.listeners[ev]) {
      ret = fn(code, signal) === true || ret;
    }
    if (ev === "exit") {
      ret = this.emit("afterExit", code, signal) || ret;
    }
    return ret;
  }
}

class SignalExitBase2 {
}
var signalExitWrap2 = (handler32) => {
  return {
    onExit(cb2, opts) {
      return handler32.onExit(cb2, opts);
    },
    load() {
      return handler32.load();
    },
    unload() {
      return handler32.unload();
    }
  };
};

class SignalExitFallback2 extends SignalExitBase2 {
  onExit() {
    return () => {
    };
  }
  load() {
  }
  unload() {
  }
}

class SignalExit2 extends SignalExitBase2 {
  #hupSig = process122.platform === "win32" ? "SIGINT" : "SIGHUP";
  #emitter = new Emitter2;
  #process;
  #originalProcessEmit;
  #originalProcessReallyExit;
  #sigListeners = {};
  #loaded = false;
  constructor(process122) {
    super();
    this.#process = process122;
    this.#sigListeners = {};
    for (const sig of signals2) {
      this.#sigListeners[sig] = () => {
        const listeners = this.#process.listeners(sig);
        let { count } = this.#emitter;
        const p33 = process122;
        if (typeof p33.__signal_exit_emitter__ === "object" && typeof p33.__signal_exit_emitter__.count === "number") {
          count += p33.__signal_exit_emitter__.count;
        }
        if (listeners.length === count) {
          this.unload();
          const ret = this.#emitter.emit("exit", null, sig);
          const s32 = sig === "SIGHUP" ? this.#hupSig : sig;
          if (!ret)
            process122.kill(process122.pid, s32);
        }
      };
    }
    this.#originalProcessReallyExit = process122.reallyExit;
    this.#originalProcessEmit = process122.emit;
  }
  onExit(cb2, opts) {
    if (!processOk2(this.#process)) {
      return () => {
      };
    }
    if (this.#loaded === false) {
      this.load();
    }
    const ev = opts?.alwaysLast ? "afterExit" : "exit";
    this.#emitter.on(ev, cb2);
    return () => {
      this.#emitter.removeListener(ev, cb2);
      if (this.#emitter.listeners["exit"].length === 0 && this.#emitter.listeners["afterExit"].length === 0) {
        this.unload();
      }
    };
  }
  load() {
    if (this.#loaded) {
      return;
    }
    this.#loaded = true;
    this.#emitter.count += 1;
    for (const sig of signals2) {
      try {
        const fn = this.#sigListeners[sig];
        if (fn)
          this.#process.on(sig, fn);
      } catch (_23) {
      }
    }
    this.#process.emit = (ev, ...a5) => {
      return this.#processEmit(ev, ...a5);
    };
    this.#process.reallyExit = (code) => {
      return this.#processReallyExit(code);
    };
  }
  unload() {
    if (!this.#loaded) {
      return;
    }
    this.#loaded = false;
    signals2.forEach((sig) => {
      const listener = this.#sigListeners[sig];
      if (!listener) {
        throw new Error("Listener not defined for signal: " + sig);
      }
      try {
        this.#process.removeListener(sig, listener);
      } catch (_23) {
      }
    });
    this.#process.emit = this.#originalProcessEmit;
    this.#process.reallyExit = this.#originalProcessReallyExit;
    this.#emitter.count -= 1;
  }
  #processReallyExit(code) {
    if (!processOk2(this.#process)) {
      return 0;
    }
    this.#process.exitCode = code || 0;
    this.#emitter.emit("exit", this.#process.exitCode, null);
    return this.#originalProcessReallyExit.call(this.#process, this.#process.exitCode);
  }
  #processEmit(ev, ...args) {
    const og = this.#originalProcessEmit;
    if (ev === "exit" && processOk2(this.#process)) {
      if (typeof args[0] === "number") {
        this.#process.exitCode = args[0];
      }
      const ret = og.call(this.#process, ev, ...args);
      this.#emitter.emit("exit", this.#process.exitCode, null);
      return ret;
    } else {
      return og.call(this.#process, ev, ...args);
    }
  }
}
var process122 = globalThis.process;
var {
  onExit: onExit2,
  load: load3,
  unload: unload2
} = signalExitWrap2(processOk2(process122) ? new SignalExit2(process122) : new SignalExitFallback2);
var terminal2 = process132.stderr.isTTY ? process132.stderr : process132.stdout.isTTY ? process132.stdout : undefined;
var restoreCursor2 = terminal2 ? onetime_default2(() => {
  onExit2(() => {
    terminal2.write("\x1B[?25h");
  }, { alwaysLast: true });
}) : () => {
};
var restore_cursor_default2 = restoreCursor2;
var isHidden2 = false;
var cliCursor2 = {};
cliCursor2.show = (writableStream = process142.stderr) => {
  if (!writableStream.isTTY) {
    return;
  }
  isHidden2 = false;
  writableStream.write("\x1B[?25h");
};
cliCursor2.hide = (writableStream = process142.stderr) => {
  if (!writableStream.isTTY) {
    return;
  }
  restore_cursor_default2();
  isHidden2 = true;
  writableStream.write("\x1B[?25l");
};
cliCursor2.toggle = (force, writableStream) => {
  if (force !== undefined) {
    isHidden2 = force;
  }
  if (isHidden2) {
    cliCursor2.show(writableStream);
  } else {
    cliCursor2.hide(writableStream);
  }
};
var cli_cursor_default2 = cliCursor2;
var import_cli_spinners3 = __toESM22(require_cli_spinners2(), 1);
function isUnicodeSupported22() {
  if (process152.platform !== "win32") {
    return process152.env.TERM !== "linux";
  }
  return Boolean(process152.env.CI) || Boolean(process152.env.WT_SESSION) || Boolean(process152.env.TERMINUS_SUBLIME) || process152.env.ConEmuTask === "{cmd::Cmder}" || process152.env.TERM_PROGRAM === "Terminus-Sublime" || process152.env.TERM_PROGRAM === "vscode" || process152.env.TERM === "xterm-256color" || process152.env.TERM === "alacritty" || process152.env.TERMINAL_EMULATOR === "JetBrains-JediTerm";
}
var main2 = {
  info: source_default2.blue("\u2139"),
  success: source_default2.green("\u2714"),
  warning: source_default2.yellow("\u26A0"),
  error: source_default2.red("\u2716")
};
var fallback3 = {
  info: source_default2.blue("i"),
  success: source_default2.green("\u221A"),
  warning: source_default2.yellow("\u203C"),
  error: source_default2.red("\xD7")
};
var logSymbols2 = isUnicodeSupported22() ? main2 : fallback3;
var log_symbols_default2 = logSymbols2;
function ansiRegex32({ onlyFirst = false } = {}) {
  const ST = "(?:\\u0007|\\u001B\\u005C|\\u009C)";
  const pattern = [
    `[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?${ST})`,
    "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))"
  ].join("|");
  return new RegExp(pattern, onlyFirst ? undefined : "g");
}
var regex22 = ansiRegex32();
function stripAnsi32(string2) {
  if (typeof string2 !== "string") {
    throw new TypeError(`Expected a \`string\`, got \`${typeof string2}\``);
  }
  return string2.replace(regex22, "");
}
function isAmbiguous2(x22) {
  return x22 === 161 || x22 === 164 || x22 === 167 || x22 === 168 || x22 === 170 || x22 === 173 || x22 === 174 || x22 >= 176 && x22 <= 180 || x22 >= 182 && x22 <= 186 || x22 >= 188 && x22 <= 191 || x22 === 198 || x22 === 208 || x22 === 215 || x22 === 216 || x22 >= 222 && x22 <= 225 || x22 === 230 || x22 >= 232 && x22 <= 234 || x22 === 236 || x22 === 237 || x22 === 240 || x22 === 242 || x22 === 243 || x22 >= 247 && x22 <= 250 || x22 === 252 || x22 === 254 || x22 === 257 || x22 === 273 || x22 === 275 || x22 === 283 || x22 === 294 || x22 === 295 || x22 === 299 || x22 >= 305 && x22 <= 307 || x22 === 312 || x22 >= 319 && x22 <= 322 || x22 === 324 || x22 >= 328 && x22 <= 331 || x22 === 333 || x22 === 338 || x22 === 339 || x22 === 358 || x22 === 359 || x22 === 363 || x22 === 462 || x22 === 464 || x22 === 466 || x22 === 468 || x22 === 470 || x22 === 472 || x22 === 474 || x22 === 476 || x22 === 593 || x22 === 609 || x22 === 708 || x22 === 711 || x22 >= 713 && x22 <= 715 || x22 === 717 || x22 === 720 || x22 >= 728 && x22 <= 731 || x22 === 733 || x22 === 735 || x22 >= 768 && x22 <= 879 || x22 >= 913 && x22 <= 929 || x22 >= 931 && x22 <= 937 || x22 >= 945 && x22 <= 961 || x22 >= 963 && x22 <= 969 || x22 === 1025 || x22 >= 1040 && x22 <= 1103 || x22 === 1105 || x22 === 8208 || x22 >= 8211 && x22 <= 8214 || x22 === 8216 || x22 === 8217 || x22 === 8220 || x22 === 8221 || x22 >= 8224 && x22 <= 8226 || x22 >= 8228 && x22 <= 8231 || x22 === 8240 || x22 === 8242 || x22 === 8243 || x22 === 8245 || x22 === 8251 || x22 === 8254 || x22 === 8308 || x22 === 8319 || x22 >= 8321 && x22 <= 8324 || x22 === 8364 || x22 === 8451 || x22 === 8453 || x22 === 8457 || x22 === 8467 || x22 === 8470 || x22 === 8481 || x22 === 8482 || x22 === 8486 || x22 === 8491 || x22 === 8531 || x22 === 8532 || x22 >= 8539 && x22 <= 8542 || x22 >= 8544 && x22 <= 8555 || x22 >= 8560 && x22 <= 8569 || x22 === 8585 || x22 >= 8592 && x22 <= 8601 || x22 === 8632 || x22 === 8633 || x22 === 8658 || x22 === 8660 || x22 === 8679 || x22 === 8704 || x22 === 8706 || x22 === 8707 || x22 === 8711 || x22 === 8712 || x22 === 8715 || x22 === 8719 || x22 === 8721 || x22 === 8725 || x22 === 8730 || x22 >= 8733 && x22 <= 8736 || x22 === 8739 || x22 === 8741 || x22 >= 8743 && x22 <= 8748 || x22 === 8750 || x22 >= 8756 && x22 <= 8759 || x22 === 8764 || x22 === 8765 || x22 === 8776 || x22 === 8780 || x22 === 8786 || x22 === 8800 || x22 === 8801 || x22 >= 8804 && x22 <= 8807 || x22 === 8810 || x22 === 8811 || x22 === 8814 || x22 === 8815 || x22 === 8834 || x22 === 8835 || x22 === 8838 || x22 === 8839 || x22 === 8853 || x22 === 8857 || x22 === 8869 || x22 === 8895 || x22 === 8978 || x22 >= 9312 && x22 <= 9449 || x22 >= 9451 && x22 <= 9547 || x22 >= 9552 && x22 <= 9587 || x22 >= 9600 && x22 <= 9615 || x22 >= 9618 && x22 <= 9621 || x22 === 9632 || x22 === 9633 || x22 >= 9635 && x22 <= 9641 || x22 === 9650 || x22 === 9651 || x22 === 9654 || x22 === 9655 || x22 === 9660 || x22 === 9661 || x22 === 9664 || x22 === 9665 || x22 >= 9670 && x22 <= 9672 || x22 === 9675 || x22 >= 9678 && x22 <= 9681 || x22 >= 9698 && x22 <= 9701 || x22 === 9711 || x22 === 9733 || x22 === 9734 || x22 === 9737 || x22 === 9742 || x22 === 9743 || x22 === 9756 || x22 === 9758 || x22 === 9792 || x22 === 9794 || x22 === 9824 || x22 === 9825 || x22 >= 9827 && x22 <= 9829 || x22 >= 9831 && x22 <= 9834 || x22 === 9836 || x22 === 9837 || x22 === 9839 || x22 === 9886 || x22 === 9887 || x22 === 9919 || x22 >= 9926 && x22 <= 9933 || x22 >= 9935 && x22 <= 9939 || x22 >= 9941 && x22 <= 9953 || x22 === 9955 || x22 === 9960 || x22 === 9961 || x22 >= 9963 && x22 <= 9969 || x22 === 9972 || x22 >= 9974 && x22 <= 9977 || x22 === 9979 || x22 === 9980 || x22 === 9982 || x22 === 9983 || x22 === 10045 || x22 >= 10102 && x22 <= 10111 || x22 >= 11094 && x22 <= 11097 || x22 >= 12872 && x22 <= 12879 || x22 >= 57344 && x22 <= 63743 || x22 >= 65024 && x22 <= 65039 || x22 === 65533 || x22 >= 127232 && x22 <= 127242 || x22 >= 127248 && x22 <= 127277 || x22 >= 127280 && x22 <= 127337 || x22 >= 127344 && x22 <= 127373 || x22 === 127375 || x22 === 127376 || x22 >= 127387 && x22 <= 127404 || x22 >= 917760 && x22 <= 917999 || x22 >= 983040 && x22 <= 1048573 || x22 >= 1048576 && x22 <= 1114109;
}
function isFullWidth2(x22) {
  return x22 === 12288 || x22 >= 65281 && x22 <= 65376 || x22 >= 65504 && x22 <= 65510;
}
function isWide2(x22) {
  return x22 >= 4352 && x22 <= 4447 || x22 === 8986 || x22 === 8987 || x22 === 9001 || x22 === 9002 || x22 >= 9193 && x22 <= 9196 || x22 === 9200 || x22 === 9203 || x22 === 9725 || x22 === 9726 || x22 === 9748 || x22 === 9749 || x22 >= 9776 && x22 <= 9783 || x22 >= 9800 && x22 <= 9811 || x22 === 9855 || x22 >= 9866 && x22 <= 9871 || x22 === 9875 || x22 === 9889 || x22 === 9898 || x22 === 9899 || x22 === 9917 || x22 === 9918 || x22 === 9924 || x22 === 9925 || x22 === 9934 || x22 === 9940 || x22 === 9962 || x22 === 9970 || x22 === 9971 || x22 === 9973 || x22 === 9978 || x22 === 9981 || x22 === 9989 || x22 === 9994 || x22 === 9995 || x22 === 10024 || x22 === 10060 || x22 === 10062 || x22 >= 10067 && x22 <= 10069 || x22 === 10071 || x22 >= 10133 && x22 <= 10135 || x22 === 10160 || x22 === 10175 || x22 === 11035 || x22 === 11036 || x22 === 11088 || x22 === 11093 || x22 >= 11904 && x22 <= 11929 || x22 >= 11931 && x22 <= 12019 || x22 >= 12032 && x22 <= 12245 || x22 >= 12272 && x22 <= 12287 || x22 >= 12289 && x22 <= 12350 || x22 >= 12353 && x22 <= 12438 || x22 >= 12441 && x22 <= 12543 || x22 >= 12549 && x22 <= 12591 || x22 >= 12593 && x22 <= 12686 || x22 >= 12688 && x22 <= 12773 || x22 >= 12783 && x22 <= 12830 || x22 >= 12832 && x22 <= 12871 || x22 >= 12880 && x22 <= 42124 || x22 >= 42128 && x22 <= 42182 || x22 >= 43360 && x22 <= 43388 || x22 >= 44032 && x22 <= 55203 || x22 >= 63744 && x22 <= 64255 || x22 >= 65040 && x22 <= 65049 || x22 >= 65072 && x22 <= 65106 || x22 >= 65108 && x22 <= 65126 || x22 >= 65128 && x22 <= 65131 || x22 >= 94176 && x22 <= 94180 || x22 === 94192 || x22 === 94193 || x22 >= 94208 && x22 <= 100343 || x22 >= 100352 && x22 <= 101589 || x22 >= 101631 && x22 <= 101640 || x22 >= 110576 && x22 <= 110579 || x22 >= 110581 && x22 <= 110587 || x22 === 110589 || x22 === 110590 || x22 >= 110592 && x22 <= 110882 || x22 === 110898 || x22 >= 110928 && x22 <= 110930 || x22 === 110933 || x22 >= 110948 && x22 <= 110951 || x22 >= 110960 && x22 <= 111355 || x22 >= 119552 && x22 <= 119638 || x22 >= 119648 && x22 <= 119670 || x22 === 126980 || x22 === 127183 || x22 === 127374 || x22 >= 127377 && x22 <= 127386 || x22 >= 127488 && x22 <= 127490 || x22 >= 127504 && x22 <= 127547 || x22 >= 127552 && x22 <= 127560 || x22 === 127568 || x22 === 127569 || x22 >= 127584 && x22 <= 127589 || x22 >= 127744 && x22 <= 127776 || x22 >= 127789 && x22 <= 127797 || x22 >= 127799 && x22 <= 127868 || x22 >= 127870 && x22 <= 127891 || x22 >= 127904 && x22 <= 127946 || x22 >= 127951 && x22 <= 127955 || x22 >= 127968 && x22 <= 127984 || x22 === 127988 || x22 >= 127992 && x22 <= 128062 || x22 === 128064 || x22 >= 128066 && x22 <= 128252 || x22 >= 128255 && x22 <= 128317 || x22 >= 128331 && x22 <= 128334 || x22 >= 128336 && x22 <= 128359 || x22 === 128378 || x22 === 128405 || x22 === 128406 || x22 === 128420 || x22 >= 128507 && x22 <= 128591 || x22 >= 128640 && x22 <= 128709 || x22 === 128716 || x22 >= 128720 && x22 <= 128722 || x22 >= 128725 && x22 <= 128727 || x22 >= 128732 && x22 <= 128735 || x22 === 128747 || x22 === 128748 || x22 >= 128756 && x22 <= 128764 || x22 >= 128992 && x22 <= 129003 || x22 === 129008 || x22 >= 129292 && x22 <= 129338 || x22 >= 129340 && x22 <= 129349 || x22 >= 129351 && x22 <= 129535 || x22 >= 129648 && x22 <= 129660 || x22 >= 129664 && x22 <= 129673 || x22 >= 129679 && x22 <= 129734 || x22 >= 129742 && x22 <= 129756 || x22 >= 129759 && x22 <= 129769 || x22 >= 129776 && x22 <= 129784 || x22 >= 131072 && x22 <= 196605 || x22 >= 196608 && x22 <= 262141;
}
function validate3(codePoint) {
  if (!Number.isSafeInteger(codePoint)) {
    throw new TypeError(`Expected a code point, got \`${typeof codePoint}\`.`);
  }
}
function eastAsianWidth22(codePoint, { ambiguousAsWide = false } = {}) {
  validate3(codePoint);
  if (isFullWidth2(codePoint) || isWide2(codePoint) || ambiguousAsWide && isAmbiguous2(codePoint)) {
    return 2;
  }
  return 1;
}
var emoji_regex_default2 = () => {
  return /[#*0-9]\uFE0F?\u20E3|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26AA\u26B0\u26B1\u26BD\u26BE\u26C4\u26C8\u26CF\u26D1\u26E9\u26F0-\u26F5\u26F7\u26F8\u26FA\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2757\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B55\u3030\u303D\u3297\u3299]\uFE0F?|[\u261D\u270C\u270D](?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?|[\u270A\u270B](?:\uD83C[\uDFFB-\uDFFF])?|[\u23E9-\u23EC\u23F0\u23F3\u25FD\u2693\u26A1\u26AB\u26C5\u26CE\u26D4\u26EA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2795-\u2797\u27B0\u27BF\u2B50]|\u26D3\uFE0F?(?:\u200D\uD83D\uDCA5)?|\u26F9(?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?(?:\u200D[\u2640\u2642]\uFE0F?)?|\u2764\uFE0F?(?:\u200D(?:\uD83D\uDD25|\uD83E\uDE79))?|\uD83C(?:[\uDC04\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]\uFE0F?|[\uDF85\uDFC2\uDFC7](?:\uD83C[\uDFFB-\uDFFF])?|[\uDFC4\uDFCA](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDFCB\uDFCC](?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF43\uDF45-\uDF4A\uDF4C-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uDDE6\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF]|\uDDE7\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF]|\uDDE8\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF7\uDDFA-\uDDFF]|\uDDE9\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF]|\uDDEA\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA]|\uDDEB\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7]|\uDDEC\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE]|\uDDED\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA]|\uDDEE\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9]|\uDDEF\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5]|\uDDF0\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF]|\uDDF1\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE]|\uDDF2\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF]|\uDDF3\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF]|\uDDF4\uD83C\uDDF2|\uDDF5\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE]|\uDDF6\uD83C\uDDE6|\uDDF7\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC]|\uDDF8\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF]|\uDDF9\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF]|\uDDFA\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF]|\uDDFB\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA]|\uDDFC\uD83C[\uDDEB\uDDF8]|\uDDFD\uD83C\uDDF0|\uDDFE\uD83C[\uDDEA\uDDF9]|\uDDFF\uD83C[\uDDE6\uDDF2\uDDFC]|\uDF44(?:\u200D\uD83D\uDFEB)?|\uDF4B(?:\u200D\uD83D\uDFE9)?|\uDFC3(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?|\uDFF3\uFE0F?(?:\u200D(?:\u26A7\uFE0F?|\uD83C\uDF08))?|\uDFF4(?:\u200D\u2620\uFE0F?|\uDB40\uDC67\uDB40\uDC62\uDB40(?:\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDC73\uDB40\uDC63\uDB40\uDC74|\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F)?)|\uD83D(?:[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3]\uFE0F?|[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC](?:\uD83C[\uDFFB-\uDFFF])?|[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4\uDEB5](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD74\uDD90](?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?|[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC25\uDC27-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE41\uDE43\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEDC-\uDEDF\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB\uDFF0]|\uDC08(?:\u200D\u2B1B)?|\uDC15(?:\u200D\uD83E\uDDBA)?|\uDC26(?:\u200D(?:\u2B1B|\uD83D\uDD25))?|\uDC3B(?:\u200D\u2744\uFE0F?)?|\uDC41\uFE0F?(?:\u200D\uD83D\uDDE8\uFE0F?)?|\uDC68(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDC68\uDC69]\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFE])))?))?|\uDC69(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?[\uDC68\uDC69]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?|\uDC69\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?))|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFE])))?))?|\uDC6F(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDD75(?:\uD83C[\uDFFB-\uDFFF]|\uFE0F)?(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDE2E(?:\u200D\uD83D\uDCA8)?|\uDE35(?:\u200D\uD83D\uDCAB)?|\uDE36(?:\u200D\uD83C\uDF2B\uFE0F?)?|\uDE42(?:\u200D[\u2194\u2195]\uFE0F?)?|\uDEB6(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?)|\uD83E(?:[\uDD0C\uDD0F\uDD18-\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5\uDEC3-\uDEC5\uDEF0\uDEF2-\uDEF8](?:\uD83C[\uDFFB-\uDFFF])?|[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD\uDDCF\uDDD4\uDDD6-\uDDDD](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDDDE\uDDDF](?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD0D\uDD0E\uDD10-\uDD17\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCC\uDDD0\uDDE0-\uDDFF\uDE70-\uDE7C\uDE80-\uDE89\uDE8F-\uDEC2\uDEC6\uDECE-\uDEDC\uDEDF-\uDEE9]|\uDD3C(?:\u200D[\u2640\u2642]\uFE0F?|\uD83C[\uDFFB-\uDFFF])?|\uDDCE(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?|\uDDD1(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1|\uDDD1\u200D\uD83E\uDDD2(?:\u200D\uD83E\uDDD2)?|\uDDD2(?:\u200D\uD83E\uDDD2)?))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFC-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFD-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFD\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFE]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?))?|\uDEF1(?:\uD83C(?:\uDFFB(?:\u200D\uD83E\uDEF2\uD83C[\uDFFC-\uDFFF])?|\uDFFC(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFD-\uDFFF])?|\uDFFD(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])?|\uDFFE(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFD\uDFFF])?|\uDFFF(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFE])?))?)/g;
};
var segmenter2 = new Intl.Segmenter;
var defaultIgnorableCodePointRegex2 = /^\p{Default_Ignorable_Code_Point}$/u;
function stringWidth22(string2, options23 = {}) {
  if (typeof string2 !== "string" || string2.length === 0) {
    return 0;
  }
  const {
    ambiguousIsNarrow = true,
    countAnsiEscapeCodes = false
  } = options23;
  if (!countAnsiEscapeCodes) {
    string2 = stripAnsi32(string2);
  }
  if (string2.length === 0) {
    return 0;
  }
  let width = 0;
  const eastAsianWidthOptions = { ambiguousAsWide: !ambiguousIsNarrow };
  for (const { segment: character } of segmenter2.segment(string2)) {
    const codePoint = character.codePointAt(0);
    if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
      continue;
    }
    if (codePoint >= 8203 && codePoint <= 8207 || codePoint === 65279) {
      continue;
    }
    if (codePoint >= 768 && codePoint <= 879 || codePoint >= 6832 && codePoint <= 6911 || codePoint >= 7616 && codePoint <= 7679 || codePoint >= 8400 && codePoint <= 8447 || codePoint >= 65056 && codePoint <= 65071) {
      continue;
    }
    if (codePoint >= 55296 && codePoint <= 57343) {
      continue;
    }
    if (codePoint >= 65024 && codePoint <= 65039) {
      continue;
    }
    if (defaultIgnorableCodePointRegex2.test(character)) {
      continue;
    }
    if (emoji_regex_default2().test(character)) {
      width += 2;
      continue;
    }
    width += eastAsianWidth22(codePoint, eastAsianWidthOptions);
  }
  return width;
}
function isInteractive2({ stream: stream2 = process.stdout } = {}) {
  return Boolean(stream2 && stream2.isTTY && true && !("CI" in process.env));
}
function isUnicodeSupported32() {
  const { env: env52 } = process162;
  const { TERM, TERM_PROGRAM } = env52;
  if (process162.platform !== "win32") {
    return TERM !== "linux";
  }
  return Boolean(env52.WT_SESSION) || Boolean(env52.TERMINUS_SUBLIME) || env52.ConEmuTask === "{cmd::Cmder}" || TERM_PROGRAM === "Terminus-Sublime" || TERM_PROGRAM === "vscode" || TERM === "xterm-256color" || TERM === "alacritty" || TERM === "rxvt-unicode" || TERM === "rxvt-unicode-256color" || env52.TERMINAL_EMULATOR === "JetBrains-JediTerm";
}
var ASCII_ETX_CODE2 = 3;

class StdinDiscarder2 {
  #activeCount = 0;
  start() {
    this.#activeCount++;
    if (this.#activeCount === 1) {
      this.#realStart();
    }
  }
  stop() {
    if (this.#activeCount <= 0) {
      throw new Error("`stop` called more times than `start`");
    }
    this.#activeCount--;
    if (this.#activeCount === 0) {
      this.#realStop();
    }
  }
  #realStart() {
    if (process172.platform === "win32" || !process172.stdin.isTTY) {
      return;
    }
    process172.stdin.setRawMode(true);
    process172.stdin.on("data", this.#handleInput);
    process172.stdin.resume();
  }
  #realStop() {
    if (!process172.stdin.isTTY) {
      return;
    }
    process172.stdin.off("data", this.#handleInput);
    process172.stdin.pause();
    process172.stdin.setRawMode(false);
  }
  #handleInput(chunk) {
    if (chunk[0] === ASCII_ETX_CODE2) {
      process172.emit("SIGINT");
    }
  }
}
var stdinDiscarder2 = new StdinDiscarder2;
var stdin_discarder_default2 = stdinDiscarder2;
var import_cli_spinners22 = __toESM22(require_cli_spinners2(), 1);

class Ora2 {
  #linesToClear = 0;
  #isDiscardingStdin = false;
  #lineCount = 0;
  #frameIndex = 0;
  #options;
  #spinner;
  #stream;
  #id;
  #initialInterval;
  #isEnabled;
  #isSilent;
  #indent;
  #text;
  #prefixText;
  #suffixText;
  color;
  constructor(options23) {
    if (typeof options23 === "string") {
      options23 = {
        text: options23
      };
    }
    this.#options = {
      color: "cyan",
      stream: process182.stderr,
      discardStdin: true,
      hideCursor: true,
      ...options23
    };
    this.color = this.#options.color;
    this.spinner = this.#options.spinner;
    this.#initialInterval = this.#options.interval;
    this.#stream = this.#options.stream;
    this.#isEnabled = typeof this.#options.isEnabled === "boolean" ? this.#options.isEnabled : isInteractive2({ stream: this.#stream });
    this.#isSilent = typeof this.#options.isSilent === "boolean" ? this.#options.isSilent : false;
    this.text = this.#options.text;
    this.prefixText = this.#options.prefixText;
    this.suffixText = this.#options.suffixText;
    this.indent = this.#options.indent;
    if (process182.env.NODE_ENV === "test") {
      this._stream = this.#stream;
      this._isEnabled = this.#isEnabled;
      Object.defineProperty(this, "_linesToClear", {
        get() {
          return this.#linesToClear;
        },
        set(newValue) {
          this.#linesToClear = newValue;
        }
      });
      Object.defineProperty(this, "_frameIndex", {
        get() {
          return this.#frameIndex;
        }
      });
      Object.defineProperty(this, "_lineCount", {
        get() {
          return this.#lineCount;
        }
      });
    }
  }
  get indent() {
    return this.#indent;
  }
  set indent(indent = 0) {
    if (!(indent >= 0 && Number.isInteger(indent))) {
      throw new Error("The `indent` option must be an integer from 0 and up");
    }
    this.#indent = indent;
    this.#updateLineCount();
  }
  get interval() {
    return this.#initialInterval ?? this.#spinner.interval ?? 100;
  }
  get spinner() {
    return this.#spinner;
  }
  set spinner(spinner) {
    this.#frameIndex = 0;
    this.#initialInterval = undefined;
    if (typeof spinner === "object") {
      if (spinner.frames === undefined) {
        throw new Error("The given spinner must have a `frames` property");
      }
      this.#spinner = spinner;
    } else if (!isUnicodeSupported32()) {
      this.#spinner = import_cli_spinners3.default.line;
    } else if (spinner === undefined) {
      this.#spinner = import_cli_spinners3.default.dots;
    } else if (spinner !== "default" && import_cli_spinners3.default[spinner]) {
      this.#spinner = import_cli_spinners3.default[spinner];
    } else {
      throw new Error(`There is no built-in spinner named '${spinner}'. See https://github.com/sindresorhus/cli-spinners/blob/main/spinners.json for a full list.`);
    }
  }
  get text() {
    return this.#text;
  }
  set text(value = "") {
    this.#text = value;
    this.#updateLineCount();
  }
  get prefixText() {
    return this.#prefixText;
  }
  set prefixText(value = "") {
    this.#prefixText = value;
    this.#updateLineCount();
  }
  get suffixText() {
    return this.#suffixText;
  }
  set suffixText(value = "") {
    this.#suffixText = value;
    this.#updateLineCount();
  }
  get isSpinning() {
    return this.#id !== undefined;
  }
  #getFullPrefixText(prefixText = this.#prefixText, postfix = " ") {
    if (typeof prefixText === "string" && prefixText !== "") {
      return prefixText + postfix;
    }
    if (typeof prefixText === "function") {
      return prefixText() + postfix;
    }
    return "";
  }
  #getFullSuffixText(suffixText = this.#suffixText, prefix = " ") {
    if (typeof suffixText === "string" && suffixText !== "") {
      return prefix + suffixText;
    }
    if (typeof suffixText === "function") {
      return prefix + suffixText();
    }
    return "";
  }
  #updateLineCount() {
    const columns = this.#stream.columns ?? 80;
    const fullPrefixText = this.#getFullPrefixText(this.#prefixText, "-");
    const fullSuffixText = this.#getFullSuffixText(this.#suffixText, "-");
    const fullText = " ".repeat(this.#indent) + fullPrefixText + "--" + this.#text + "--" + fullSuffixText;
    this.#lineCount = 0;
    for (const line of stripAnsi32(fullText).split("\n")) {
      this.#lineCount += Math.max(1, Math.ceil(stringWidth22(line, { countAnsiEscapeCodes: true }) / columns));
    }
  }
  get isEnabled() {
    return this.#isEnabled && !this.#isSilent;
  }
  set isEnabled(value) {
    if (typeof value !== "boolean") {
      throw new TypeError("The `isEnabled` option must be a boolean");
    }
    this.#isEnabled = value;
  }
  get isSilent() {
    return this.#isSilent;
  }
  set isSilent(value) {
    if (typeof value !== "boolean") {
      throw new TypeError("The `isSilent` option must be a boolean");
    }
    this.#isSilent = value;
  }
  frame() {
    const { frames } = this.#spinner;
    let frame = frames[this.#frameIndex];
    if (this.color) {
      frame = source_default2[this.color](frame);
    }
    this.#frameIndex = ++this.#frameIndex % frames.length;
    const fullPrefixText = typeof this.#prefixText === "string" && this.#prefixText !== "" ? this.#prefixText + " " : "";
    const fullText = typeof this.text === "string" ? " " + this.text : "";
    const fullSuffixText = typeof this.#suffixText === "string" && this.#suffixText !== "" ? " " + this.#suffixText : "";
    return fullPrefixText + frame + fullText + fullSuffixText;
  }
  clear() {
    if (!this.#isEnabled || !this.#stream.isTTY) {
      return this;
    }
    this.#stream.cursorTo(0);
    for (let index = 0;index < this.#linesToClear; index++) {
      if (index > 0) {
        this.#stream.moveCursor(0, -1);
      }
      this.#stream.clearLine(1);
    }
    if (this.#indent || this.lastIndent !== this.#indent) {
      this.#stream.cursorTo(this.#indent);
    }
    this.lastIndent = this.#indent;
    this.#linesToClear = 0;
    return this;
  }
  render() {
    if (this.#isSilent) {
      return this;
    }
    this.clear();
    this.#stream.write(this.frame());
    this.#linesToClear = this.#lineCount;
    return this;
  }
  start(text22) {
    if (text22) {
      this.text = text22;
    }
    if (this.#isSilent) {
      return this;
    }
    if (!this.#isEnabled) {
      if (this.text) {
        this.#stream.write(`- ${this.text}\n`);
      }
      return this;
    }
    if (this.isSpinning) {
      return this;
    }
    if (this.#options.hideCursor) {
      cli_cursor_default2.hide(this.#stream);
    }
    if (this.#options.discardStdin && process182.stdin.isTTY) {
      this.#isDiscardingStdin = true;
      stdin_discarder_default2.start();
    }
    this.render();
    this.#id = setInterval(this.render.bind(this), this.interval);
    return this;
  }
  stop() {
    if (!this.#isEnabled) {
      return this;
    }
    clearInterval(this.#id);
    this.#id = undefined;
    this.#frameIndex = 0;
    this.clear();
    if (this.#options.hideCursor) {
      cli_cursor_default2.show(this.#stream);
    }
    if (this.#options.discardStdin && process182.stdin.isTTY && this.#isDiscardingStdin) {
      stdin_discarder_default2.stop();
      this.#isDiscardingStdin = false;
    }
    return this;
  }
  succeed(text22) {
    return this.stopAndPersist({ symbol: log_symbols_default2.success, text: text22 });
  }
  fail(text22) {
    return this.stopAndPersist({ symbol: log_symbols_default2.error, text: text22 });
  }
  warn(text22) {
    return this.stopAndPersist({ symbol: log_symbols_default2.warning, text: text22 });
  }
  info(text22) {
    return this.stopAndPersist({ symbol: log_symbols_default2.info, text: text22 });
  }
  stopAndPersist(options23 = {}) {
    if (this.#isSilent) {
      return this;
    }
    const prefixText = options23.prefixText ?? this.#prefixText;
    const fullPrefixText = this.#getFullPrefixText(prefixText, " ");
    const symbolText = options23.symbol ?? " ";
    const text22 = options23.text ?? this.text;
    const fullText = typeof text22 === "string" ? " " + text22 : "";
    const suffixText = options23.suffixText ?? this.#suffixText;
    const fullSuffixText = this.#getFullSuffixText(suffixText, " ");
    const textToWrite = fullPrefixText + symbolText + fullText + fullSuffixText + "\n";
    this.stop();
    this.#stream.write(textToWrite);
    return this;
  }
}
function clone3(items) {
  if (Array.isArray(items)) {
    return [...items];
  }
  return { ...items };
}
function variadic3(args) {
  if (Array.isArray(args)) {
    return args;
  }
  return [args];
}
function deleteKeys3(obj, ...keys2) {
  variadic3(keys2).forEach((key) => {
    delete obj[key];
  });
}
var isArray3 = (item) => Array.isArray(item);
function isObject23(item) {
  return typeof item === "object" && !Array.isArray(item) && item !== null;
}
var isFunction4 = (item) => typeof item === "function";
function nestedValue3(mainObject, key) {
  try {
    return key.split(".").reduce((obj, property) => obj[property], mainObject);
  } catch (err22) {
    return mainObject;
  }
}
function values3(items) {
  if (Array.isArray(items)) {
    return [...items];
  }
  if ("all" in items && typeof items.all === "function") {
    return items.all();
  }
  return Object.values(items);
}
function collect3(items) {
  return new Collection3(items);
}

class Collection3 {
  items;
  constructor(items = []) {
    this.items = items;
  }
  [Symbol.iterator] = SymbolIterator3;
  toJSON() {
    return this.items;
  }
  all() {
    return this.items;
  }
  average(key) {
    if (key === undefined) {
      return this.sum() / Number(this.items.length);
    }
    if (isFunction4(key)) {
      return Number(new this.constructor(this.items).sum(key)) / Number(this.items.length);
    }
    return Number(new this.constructor(this.items).pluck(key).sum()) / Number(this.items.length);
  }
  avg = this.average;
  chunk(size) {
    const chunks = [];
    const items = Array.isArray(this.items) ? this.items : Object.values(this.items);
    for (let i5 = 0;i5 < items.length; i5 += size) {
      chunks.push(items.slice(i5, i5 + size));
    }
    return new Collection3(chunks);
  }
  collapse() {
    return new this.constructor([].concat(...this.items));
  }
  combine(values22) {
    if (typeof values22 === "string") {
      values22 = [values22];
    }
    if (!Array.isArray(values22)) {
      throw new TypeError("The values must be an array or a string");
    }
    const collection = {};
    const keys2 = Array.isArray(this.items) ? this.items : Object.keys(this.items);
    keys2.forEach((key, index) => {
      if (values22[index] !== undefined) {
        collection[key] = values22[index];
      }
    });
    return new Collection3(collection);
  }
  concat(collectionOrArrayOrObject) {
    let list2 = collectionOrArrayOrObject;
    if (collectionOrArrayOrObject instanceof this.constructor) {
      list2 = collectionOrArrayOrObject.all();
    } else if (typeof collectionOrArrayOrObject === "object") {
      list2 = [];
      Object.keys(collectionOrArrayOrObject).forEach((property) => {
        list2.push(collectionOrArrayOrObject[property]);
      });
    }
    const collection = clone3(this.items);
    list2.forEach((item) => {
      if (typeof item === "object") {
        Object.keys(item).forEach((key) => collection.push(item[key]));
      } else {
        collection.push(item);
      }
    });
    return new this.constructor(collection);
  }
  contains(key, value) {
    if (typeof key === "function") {
      return this.items.some(key);
    }
    if (Array.isArray(this.items)) {
      return this.items.includes(key);
    }
    if (value !== undefined) {
      if (Array.isArray(this.items)) {
        return this.items.some((item) => item[key] !== undefined && item[key] === value);
      }
      return key in this.items && this.items[key] === value;
    }
    if (Array.isArray(this.items)) {
      return this.items.includes(key);
    }
    return Object.values(this.items).includes(key);
  }
  containsOneItem() {
    if (typeof this.items === "string") {
      return true;
    }
    return Object.keys(this.items).length === 1;
  }
  count(predicate) {
    if (predicate) {
      return this.filter(predicate).count();
    }
    return Object.keys(this.items).length;
  }
  countBy(callback) {
    const counts = {};
    this.each((item) => {
      const key = callback ? callback(item) : item;
      counts[key] = (counts[key] || 0) + 1;
    });
    return new Collection3(counts);
  }
  crossJoin(...values22) {
    function join23(collection, constructor, args) {
      let current = args[0];
      if (current instanceof Collection3) {
        current = current.all();
      }
      const rest = args.slice(1);
      const last = !rest.length;
      let result2 = [];
      for (let i5 = 0;i5 < current.length; i5 += 1) {
        const collectionCopy = collection.slice();
        collectionCopy.push(current[i5]);
        if (last) {
          result2.push(collectionCopy);
        } else {
          result2 = result2.concat(join23(collectionCopy, constructor, rest));
        }
      }
      return result2;
    }
    return new this.constructor(join23([], this.constructor, [].concat([this.items], values22)));
  }
  dd() {
    console.log(JSON.stringify(this.all(), null, 2));
    process192.exit();
  }
  diff(values22) {
    let valuesToDiff;
    if (values22 instanceof this.constructor) {
      valuesToDiff = values22.all();
    } else {
      valuesToDiff = values22;
    }
    const collection = this.items.filter((item) => !valuesToDiff.includes(item));
    return new this.constructor(collection);
  }
  diffAssoc(values22) {
    let diffValues = values22;
    if (values22 instanceof this.constructor) {
      diffValues = values22.all();
    }
    const collection = {};
    Object.keys(this.items).forEach((key) => {
      if (diffValues[key] === undefined || diffValues[key] !== this.items[key]) {
        collection[key] = this.items[key];
      }
    });
    return new this.constructor(collection);
  }
  diffKeys(object) {
    let objectToDiff;
    if (object instanceof this.constructor) {
      objectToDiff = object.all();
    } else {
      objectToDiff = object;
    }
    const objectKeys = Object.keys(objectToDiff);
    const remainingKeys = Object.keys(this.items).filter((item) => !objectKeys.includes(item));
    return new this.constructor(this.items).only(remainingKeys);
  }
  diffUsing(array, callback) {
    console.log("Original collection:", this.items);
    console.log("Array to compare:", array);
    if (array === null) {
      return new Collection3(this.items);
    }
    const collection = this.items.filter((item) => {
      const index = array.findIndex((otherItem) => {
        return callback(item, otherItem) === 0;
      });
      return index === -1;
    });
    return new Collection3(collection);
  }
  doesntContain(key, value) {
    console.log("doesntContain called with:", { key, value });
    if (typeof key === "function") {
      console.log("Function branch");
      return !this.contains(key);
    }
    if (value !== undefined) {
      console.log("Key-value pair branch");
      return !this.contains((item) => {
        console.log("Comparing:", item[key], "with", value);
        return item[key] === value;
      });
    }
    console.log("Single value branch");
    return !this.contains(key);
  }
  dump() {
    console.log(this.items);
    return this;
  }
  duplicates() {
    const occuredValues = [];
    const duplicateValues = {};
    const stringifiedValue = (value) => {
      if (Array.isArray(value) || typeof value === "object") {
        return JSON.stringify(value);
      }
      return value;
    };
    if (Array.isArray(this.items)) {
      this.items.forEach((value, index) => {
        const valueAsString = stringifiedValue(value);
        if (!occuredValues.includes(valueAsString)) {
          occuredValues.push(valueAsString);
        } else {
          duplicateValues[index] = value;
        }
      });
    } else if (typeof this.items === "object") {
      Object.keys(this.items).forEach((key) => {
        const valueAsString = stringifiedValue(this.items[key]);
        if (!occuredValues.includes(valueAsString)) {
          occuredValues.push(valueAsString);
        } else {
          duplicateValues[key] = this.items[key];
        }
      });
    }
    return new this.constructor(duplicateValues);
  }
  each(fn) {
    let stop = false;
    if (Array.isArray(this.items)) {
      const { length } = this.items;
      for (let index = 0;index < length && !stop; index += 1) {
        stop = fn(this.items[index], index, this.items) === false;
      }
    } else {
      const keys2 = Object.keys(this.items);
      const { length } = keys2;
      for (let index = 0;index < length && !stop; index += 1) {
        const key = keys2[index];
        stop = fn(this.items[key], key, this.items) === false;
      }
    }
    return this;
  }
  eachSpread(fn) {
    this.each((values22, key) => {
      fn(...values22, key);
    });
    return this;
  }
  every(fn) {
    const items = values3(this.items);
    return items.every(fn);
  }
  except(keys2) {
    const result2 = { ...this.items };
    const keysArray = Array.isArray(keys2) ? keys2 : [keys2];
    keysArray.forEach((key) => delete result2[key]);
    return new Collection3(result2);
  }
  filter(callback) {
    console.log("Filter method called with callback:", callback);
    console.log("Current items:", this.items);
    if (typeof callback !== "function") {
      console.log("No callback provided, removing falsy values");
      const filteredItems2 = this.items.filter((item) => {
        console.log("Filtering item:", item);
        return Boolean(item);
      });
      console.log("Filtered items:", filteredItems2);
      return new Collection3(filteredItems2);
    }
    const filteredItems = this.items.filter((item, index) => {
      console.log("Filtering item:", item, "at index:", index);
      return callback(item, index);
    });
    console.log("Filtered items:", filteredItems);
    return new Collection3(filteredItems);
  }
  first(fn, defaultValue) {
    if (isFunction4(fn)) {
      const keys2 = Object.keys(this.items);
      for (let i5 = 0;i5 < keys2.length; i5 += 1) {
        const key = keys2[i5];
        const item = this.items[key];
        if (fn(item, key)) {
          return item;
        }
      }
      if (isFunction4(defaultValue)) {
        return defaultValue();
      }
      return defaultValue;
    }
    if (Array.isArray(this.items) && this.items.length || Object.keys(this.items).length) {
      if (Array.isArray(this.items)) {
        return this.items[0];
      }
      const firstKey = Object.keys(this.items)[0];
      return this.items[firstKey];
    }
    if (isFunction4(defaultValue)) {
      return defaultValue();
    }
    return defaultValue;
  }
  firstOrFail(callback) {
    const found = this.items.find(callback || (() => true));
    if (found === undefined) {
      throw new Error("Item not found.");
    }
    return found;
  }
  firstWhere(key, operator, value) {
    return this.where(key, operator, value).first() || null;
  }
  flatMap(fn) {
    return this.map(fn).collapse();
  }
  flatten(depth2 = Number.POSITIVE_INFINITY) {
    const flatten = (item, d5) => {
      if (!Array.isArray(item) && typeof item !== "object") {
        return [item];
      }
      return d5 > 0 ? Object.values(item).reduce((acc, val2) => acc.concat(Array.isArray(val2) || typeof val2 === "object" ? flatten(val2, d5 - 1) : val2), []) : Array.isArray(item) ? [...item] : [item];
    };
    return new Collection3(flatten(this.items, depth2));
  }
  flip() {
    const flipped = {};
    if (Array.isArray(this.items)) {
      this.items.forEach((value, index) => {
        flipped[value] = index;
      });
    } else {
      Object.entries(this.items).forEach(([key, value]) => {
        flipped[value] = key;
      });
    }
    return new this.constructor(flipped);
  }
  forPage(page, chunk) {
    let collection = {};
    if (Array.isArray(this.items)) {
      collection = this.items.slice(page * chunk - chunk, page * chunk);
    } else {
      Object.keys(this.items).slice(page * chunk - chunk, page * chunk).forEach((key) => {
        collection[key] = this.items[key];
      });
    }
    return new this.constructor(collection);
  }
  forget(key) {
    if (Array.isArray(this.items)) {
      this.items = this.items.filter((item, index) => index !== Number.parseInt(key, 10));
    } else if (typeof this.items === "object" && this.items !== null) {
      delete this.items[key];
    }
    return this;
  }
  get(key, defaultValue = null) {
    if (Array.isArray(this.items)) {
      return this.items[key] ?? defaultValue;
    }
    return this.items[key] ?? defaultValue;
  }
  groupBy(fn) {
    const groups = {};
    this.each((item, key) => {
      const groupKey = typeof fn === "function" ? fn(item) : item[fn];
      if (!(groupKey in groups)) {
        groups[groupKey] = new Collection3;
      }
      groups[groupKey].push(item);
    });
    return new Collection3(groups);
  }
  has(key) {
    if (Array.isArray(this.items)) {
      return key in this.items;
    }
    return key in this.items;
  }
  implode(key, glue) {
    if (glue === undefined) {
      return this.items.join(key);
    }
    return new this.constructor(this.items).pluck(key).all().join(glue);
  }
  includes(key) {
    if (Array.isArray(this.items)) {
      return this.items.includes(key);
    }
    return Object.values(this.items).includes(key);
  }
  intersect(values22) {
    let intersectValues = values22;
    if (values22 instanceof this.constructor) {
      intersectValues = values22.all();
    }
    const collection = this.items.filter((item) => intersectValues.includes(item));
    return new this.constructor(collection);
  }
  intersectByKeys(values22) {
    let intersectKeys = Object.keys(values22);
    if (values22 instanceof this.constructor) {
      intersectKeys = Object.keys(values22.all());
    }
    const collection = {};
    Object.keys(this.items).forEach((key) => {
      if (intersectKeys.includes(key)) {
        collection[key] = this.items[key];
      }
    });
    return new this.constructor(collection);
  }
  isEmpty() {
    return this.count() === 0;
  }
  isNotEmpty() {
    return !this.isEmpty();
  }
  join(glue, finalGlue) {
    const collection = this.values();
    if (finalGlue === undefined) {
      return collection.implode(glue);
    }
    const count = collection.count();
    if (count === 0) {
      return "";
    }
    if (count === 1) {
      return collection.last();
    }
    const finalItem = collection.pop();
    return collection.implode(glue) + finalGlue + finalItem;
  }
  keyBy(key) {
    const collection = {};
    if (isFunction4(key)) {
      this.items.forEach((item) => {
        collection[key(item)] = item;
      });
    } else {
      this.items.forEach((item) => {
        const keyValue = nestedValue3(item, key);
        collection[keyValue || ""] = item;
      });
    }
    return new this.constructor(collection);
  }
  keys() {
    return new Collection3(Object.keys(this.items));
  }
  last(fn, defaultValue) {
    let { items } = this;
    if (isFunction4(fn)) {
      items = this.filter(fn).all();
    }
    if (Array.isArray(items) && !items.length || !Object.keys(items).length) {
      if (isFunction4(defaultValue)) {
        return defaultValue();
      }
      return defaultValue;
    }
    if (Array.isArray(items)) {
      return items[items.length - 1];
    }
    const keys2 = Object.keys(items);
    return items[keys2[keys2.length - 1]];
  }
  macro(name, fn) {
    this.constructor.prototype[name] = fn;
  }
  make(items = []) {
    return new this.constructor(items);
  }
  map(fn) {
    if (Array.isArray(this.items)) {
      return new this.constructor(this.items.map(fn));
    }
    const collection = {};
    Object.keys(this.items).forEach((key) => {
      collection[key] = fn(this.items[key], Number(key));
    });
    return new this.constructor(collection);
  }
  mapSpread(fn) {
    return this.map((values22, key) => fn(...values22, key));
  }
  mapToDictionary(fn) {
    const collection = {};
    this.items.forEach((item, k5) => {
      const [key, value] = fn(item, k5);
      if (collection[key] === undefined) {
        collection[key] = [value];
      } else {
        collection[key].push(value);
      }
    });
    return new this.constructor(collection);
  }
  mapInto(ClassName) {
    return this.map((value, key) => new ClassName(value, key));
  }
  mapToGroups(fn) {
    const collection = {};
    this.items.forEach((item, key) => {
      const [keyed, value] = fn(item, key);
      if (collection[keyed] === undefined) {
        collection[keyed] = [value];
      } else {
        collection[keyed].push(value);
      }
    });
    return new this.constructor(collection);
  }
  mapWithKeys(fn) {
    const collection = {};
    if (Array.isArray(this.items)) {
      this.items.forEach((item, index) => {
        const [keyed, value] = fn(item, index);
        collection[keyed] = value;
      });
    } else {
      Object.keys(this.items).forEach((key) => {
        const [keyed, value] = fn(this.items[key], Number(key));
        collection[keyed] = value;
      });
    }
    return new this.constructor(collection);
  }
  max(key) {
    if (typeof key === "string") {
      const filtered = this.items.filter((item) => item[key] !== undefined);
      return Math.max(...filtered.map((item) => item[key]));
    }
    return Math.max(...this.items);
  }
  median(key) {
    const { length } = this.items;
    if (key === undefined) {
      if (length % 2 === 0) {
        return (this.items[length / 2 - 1] + this.items[length / 2]) / 2;
      }
      return this.items[Math.floor(length / 2)];
    }
    if (length % 2 === 0) {
      return (this.items[length / 2 - 1][key] + this.items[length / 2][key]) / 2;
    }
    return this.items[Math.floor(length / 2)][key];
  }
  merge(object) {
    const merged = { ...this.items, ...object };
    return new Collection3(merged);
  }
  mergeRecursive(items) {
    const merge2 = (target, source) => {
      const merged = {};
      const mergedKeys = Object.keys({ ...target, ...source });
      mergedKeys.forEach((key) => {
        if (target[key] === undefined && source[key] !== undefined) {
          merged[key] = source[key];
        } else if (target[key] !== undefined && source[key] === undefined) {
          merged[key] = target[key];
        } else if (target[key] !== undefined && source[key] !== undefined) {
          if (target[key] === source[key]) {
            merged[key] = target[key];
          } else if (!Array.isArray(target[key]) && typeof target[key] === "object" && !Array.isArray(source[key]) && typeof source[key] === "object") {
            merged[key] = merge2(target[key], source[key]);
          } else {
            merged[key] = [].concat(target[key], source[key]);
          }
        }
      });
      return merged;
    };
    if (!items) {
      return this;
    }
    if (items.constructor.name === "Collection") {
      return new this.constructor(merge2(this.items, items.all()));
    }
    return new this.constructor(merge2(this.items, items));
  }
  min(key) {
    if (key !== undefined) {
      const filtered = this.items.filter((item) => item[key] !== undefined);
      return Math.min(...filtered.map((item) => item[key]));
    }
    return Math.min(...this.items);
  }
  mode(key) {
    const values22 = [];
    let highestCount = 1;
    if (!this.items.length) {
      return null;
    }
    this.items.forEach((item) => {
      const tempValues = values22.filter((value) => {
        if (key !== undefined) {
          return value.key === item[key];
        }
        return value.key === item;
      });
      if (!tempValues.length) {
        if (key !== undefined) {
          values22.push({ key: item[key], count: 1 });
        } else {
          values22.push({ key: item, count: 1 });
        }
      } else {
        tempValues[0].count += 1;
        const { count } = tempValues[0];
        if (count > highestCount) {
          highestCount = count;
        }
      }
    });
    return values22.filter((value) => value.count === highestCount).map((value) => value.key);
  }
  nth(n5, offset = 0) {
    const items = values3(this.items);
    const collection = items.slice(offset).filter((item, index) => index % n5 === 0);
    return new this.constructor(collection);
  }
  only(keys2) {
    const result2 = {};
    keys2.forEach((key) => {
      if (key in this.items)
        result2[key] = this.items[key];
    });
    return new Collection3(result2);
  }
  pad(size, value) {
    const abs = Math.abs(size);
    const count = this.count();
    if (abs <= count) {
      return this;
    }
    let diff = abs - count;
    const items = clone3(this.items);
    const isArray23 = Array.isArray(this.items);
    const prepend = size < 0;
    for (let iterator = 0;iterator < diff; ) {
      if (!isArray23) {
        if (items[iterator] !== undefined) {
          diff += 1;
        } else {
          items[iterator] = value;
        }
      } else if (prepend) {
        items.unshift(value);
      } else {
        items.push(value);
      }
      iterator += 1;
    }
    return new this.constructor(items);
  }
  partition(fn) {
    let arrays;
    if (Array.isArray(this.items)) {
      arrays = [new this.constructor([]), new this.constructor([])];
      this.items.forEach((item) => {
        if (fn(item) === true) {
          arrays[0].push(item);
        } else {
          arrays[1].push(item);
        }
      });
    } else {
      arrays = [new this.constructor({}), new this.constructor({})];
      Object.keys(this.items).forEach((prop) => {
        const value = this.items[prop];
        if (fn(value) === true) {
          arrays[0].put(prop, value);
        } else {
          arrays[1].put(prop, value);
        }
      });
    }
    return new this.constructor(arrays);
  }
  pipe(fn) {
    return fn(this);
  }
  pluck(value, key) {
    if (value.includes("*")) {
      const keyPathMap = buildKeyPathMap5(this.items);
      const keyMatches = [];
      if (key !== undefined) {
        const keyRegex = new RegExp(`0.${key}`, "g");
        const keyNumberOfLevels = `0.${key}`.split(".").length;
        Object.keys(keyPathMap).forEach((k5) => {
          const matchingKey = k5.match(keyRegex);
          if (matchingKey) {
            const match = matchingKey[0];
            if (match.split(".").length === keyNumberOfLevels) {
              keyMatches.push(keyPathMap[match]);
            }
          }
        });
      }
      const valueMatches = [];
      const valueRegex = new RegExp(`0.${value}`, "g");
      const valueNumberOfLevels = `0.${value}`.split(".").length;
      Object.keys(keyPathMap).forEach((k5) => {
        const matchingValue = k5.match(valueRegex);
        if (matchingValue) {
          const match = matchingValue[0];
          if (match.split(".").length === valueNumberOfLevels) {
            valueMatches.push(keyPathMap[match]);
          }
        }
      });
      if (key !== undefined) {
        const collection = {};
        this.items.forEach((item, index) => {
          collection[keyMatches[index] || ""] = valueMatches;
        });
        return new this.constructor(collection);
      }
      return new this.constructor([valueMatches]);
    }
    if (key !== undefined) {
      const collection = {};
      this.items.forEach((item) => {
        if (nestedValue3(item, value) !== undefined) {
          collection[item[key] || ""] = nestedValue3(item, value);
        } else {
          collection[item[key] || ""] = null;
        }
      });
      return new this.constructor(collection);
    }
    return this.map((item) => {
      if (nestedValue3(item, value) !== undefined) {
        return nestedValue3(item, value);
      }
      return null;
    });
  }
  pop(count = 1) {
    if (this.isEmpty()) {
      return null;
    }
    if (isArray3(this.items)) {
      if (count === 1) {
        return this.items.pop();
      }
      return new this.constructor(this.items.splice(-count));
    }
    if (isObject23(this.items)) {
      const keys2 = Object.keys(this.items);
      if (count === 1) {
        const key = keys2[keys2.length - 1];
        const last = this.items[key];
        deleteKeys3(this.items, key);
        return last;
      }
      const poppedKeys = keys2.slice(-count);
      const newObject = poppedKeys.reduce((acc, current) => {
        acc[current] = this.items[current];
        return acc;
      }, {});
      deleteKeys3(this.items, poppedKeys);
      return new this.constructor(newObject);
    }
    return null;
  }
  prepend(value, key) {
    if (key !== undefined) {
      return this.put(key, value);
    }
    this.items.unshift(value);
    return this;
  }
  pull(key, defaultValue = null) {
    if (Array.isArray(this.items)) {
      const index = Number(key);
      if (Number.isNaN(index))
        return defaultValue;
      const value2 = this.items[index];
      this.items.splice(index, 1);
      return value2 ?? defaultValue;
    }
    const value = this.items[key];
    delete this.items[key];
    return value ?? defaultValue;
  }
  push(...items) {
    this.items = [...this.items, ...items];
    return this;
  }
  put(key, value) {
    this.items[key] = value;
    return this;
  }
  random(length = null) {
    const items = values3(this.items);
    const collection = new this.constructor(items).shuffle();
    if (length !== Number.parseInt(length, 10)) {
      return collection.first();
    }
    return collection.take(length);
  }
  reduce(fn, carry) {
    let reduceCarry = null;
    if (carry !== undefined) {
      reduceCarry = carry;
    }
    if (Array.isArray(this.items)) {
      this.items.forEach((item) => {
        reduceCarry = fn(reduceCarry, item);
      });
    } else {
      Object.keys(this.items).forEach((key) => {
        reduceCarry = fn(reduceCarry, this.items[key], key);
      });
    }
    return reduceCarry;
  }
  reject(fn) {
    return new this.constructor(this.items).filter((item) => !fn(item));
  }
  replace(items) {
    if (!items) {
      return this;
    }
    if (Array.isArray(items)) {
      const replaced2 = this.items.map((value, index) => items[index] || value);
      return new this.constructor(replaced2);
    }
    if (items.constructor.name === "Collection") {
      const replaced2 = { ...this.items, ...items.all() };
      return new this.constructor(replaced2);
    }
    const replaced = { ...this.items, ...items };
    return new this.constructor(replaced);
  }
  replaceRecursive(items) {
    const replace22 = (target, source) => {
      const replaced = { ...target };
      const mergedKeys = Object.keys({ ...target, ...source });
      mergedKeys.forEach((key) => {
        if (!Array.isArray(source[key]) && typeof source[key] === "object") {
          replaced[key] = replace22(target[key], source[key]);
        } else if (target[key] === undefined && source[key] !== undefined) {
          if (typeof target[key] === "object") {
            replaced[key] = { ...source[key] };
          } else {
            replaced[key] = source[key];
          }
        } else if (target[key] !== undefined && source[key] === undefined) {
          if (typeof target[key] === "object") {
            replaced[key] = { ...target[key] };
          } else {
            replaced[key] = target[key];
          }
        } else if (target[key] !== undefined && source[key] !== undefined) {
          if (typeof source[key] === "object") {
            replaced[key] = { ...source[key] };
          } else {
            replaced[key] = source[key];
          }
        }
      });
      return replaced;
    };
    if (!items) {
      return this;
    }
    if (!Array.isArray(items) && typeof items !== "object") {
      return new this.constructor(replace22(this.items, [items]));
    }
    if (items.constructor.name === "Collection") {
      return new this.constructor(replace22(this.items, items.all()));
    }
    return new this.constructor(replace22(this.items, items));
  }
  reverse() {
    const collection = [].concat(this.items).reverse();
    return new this.constructor(collection);
  }
  search(valueOrFunction, strict) {
    let result2;
    const find = (item, key) => {
      if (isFunction4(valueOrFunction)) {
        return valueOrFunction(this.items[key], key);
      }
      if (strict) {
        return this.items[key] === valueOrFunction;
      }
      return this.items[key] == valueOrFunction;
    };
    if (isArray3(this.items)) {
      result2 = this.items.findIndex(find);
    } else if (isObject23(this.items)) {
      result2 = Object.keys(this.items).find((key) => find(this.items[key], key));
    }
    if (result2 === undefined || result2 < 0) {
      return false;
    }
    return result2;
  }
  shift(count = 1) {
    if (this.isEmpty()) {
      return null;
    }
    if (isArray3(this.items)) {
      if (count === 1) {
        return this.items.shift();
      }
      return new this.constructor(this.items.splice(0, count));
    }
    if (isObject23(this.items)) {
      if (count === 1) {
        const key = Object.keys(this.items)[0];
        const value = this.items[key];
        delete this.items[key];
        return value;
      }
      const keys2 = Object.keys(this.items);
      const poppedKeys = keys2.slice(0, count);
      const newObject = poppedKeys.reduce((acc, current) => {
        acc[current] = this.items[current];
        return acc;
      }, {});
      deleteKeys3(this.items, poppedKeys);
      return new this.constructor(newObject);
    }
    return null;
  }
  shuffle() {
    const items = values3(this.items);
    let j23;
    let x22;
    let i5;
    for (i5 = items.length;i5; i5 -= 1) {
      j23 = Math.floor(Math.random() * i5);
      x22 = items[i5 - 1];
      items[i5 - 1] = items[j23];
      items[j23] = x22;
    }
    this.items = items;
    return this;
  }
  skip(number) {
    if (isObject23(this.items)) {
      return new this.constructor(Object.keys(this.items).reduce((accumulator, key, index) => {
        if (index + 1 > number) {
          accumulator[key] = this.items[key];
        }
        return accumulator;
      }, {}));
    }
    return new this.constructor(this.items.slice(number));
  }
  skipUntil(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction4(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray3(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== true) {
          previous = callback(item);
        }
        return previous;
      });
    }
    if (isObject23(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== true) {
          previous = callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  skipWhile(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction4(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray3(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== true) {
          previous = !callback(item);
        }
        return previous;
      });
    }
    if (isObject23(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== true) {
          previous = !callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  slice(remove2, limit) {
    let collection = this.items.slice(remove2);
    if (limit !== undefined) {
      collection = collection.slice(0, limit);
    }
    return new this.constructor(collection);
  }
  sole() {
    if (this.items.length !== 1) {
      throw new Error("Collection does not contain exactly one item.");
    }
    return this.items[0];
  }
  some(key) {
    return this.items.some((item) => item.hasOwnProperty(key));
  }
  sort(fn) {
    const collection = [].concat(this.items);
    if (fn === undefined) {
      if (this.every((item) => typeof item === "number")) {
        collection.sort((a5, b23) => a5 - b23);
      } else {
        collection.sort();
      }
    } else {
      collection.sort(fn);
    }
    return new this.constructor(collection);
  }
  sortDesc() {
    return this.sort().reverse();
  }
  sortBy(valueOrFunction) {
    const collection = [].concat(this.items);
    const getValue = (item) => {
      if (isFunction4(valueOrFunction)) {
        return valueOrFunction(item);
      }
      return nestedValue3(item, valueOrFunction);
    };
    collection.sort((a5, b23) => {
      const valueA = getValue(a5);
      const valueB = getValue(b23);
      if (valueA === null || valueA === undefined) {
        return 1;
      }
      if (valueB === null || valueB === undefined) {
        return -1;
      }
      if (valueA < valueB) {
        return -1;
      }
      if (valueA > valueB) {
        return 1;
      }
      return 0;
    });
    return new this.constructor(collection);
  }
  sortByDesc(valueOrFunction) {
    return this.sortBy(valueOrFunction).reverse();
  }
  sortKeys() {
    const ordered = {};
    Object.keys(this.items).sort().forEach((key) => {
      ordered[key] = this.items[key];
    });
    return new this.constructor(ordered);
  }
  sortKeysDesc() {
    const ordered = {};
    Object.keys(this.items).sort().reverse().forEach((key) => {
      ordered[key] = this.items[key];
    });
    return new this.constructor(ordered);
  }
  splice(index, limit, replace22) {
    const slicedCollection = this.slice(index, limit);
    this.items = this.diff(slicedCollection.all()).all();
    if (Array.isArray(replace22)) {
      for (let iterator = 0, { length } = replace22;iterator < length; iterator += 1) {
        this.items.splice(index + iterator, 0, replace22[iterator]);
      }
    }
    return slicedCollection;
  }
  split(numberOfGroups) {
    const itemsArray = this.toArray();
    const groups = [];
    const size = Math.ceil(itemsArray.length / numberOfGroups);
    for (let i5 = 0;i5 < itemsArray.length; i5 += size) {
      groups.push(itemsArray.slice(i5, i5 + size));
    }
    return new Collection3(groups);
  }
  sum(key) {
    const items = values3(this.items);
    let total = 0;
    if (key === undefined) {
      for (let i5 = 0, { length } = items;i5 < length; i5 += 1) {
        total += Number.parseFloat(items[i5]);
      }
    } else if (isFunction4(key)) {
      for (let i5 = 0, { length } = items;i5 < length; i5 += 1) {
        total += Number.parseFloat(key(items[i5]));
      }
    } else {
      for (let i5 = 0, { length } = items;i5 < length; i5 += 1) {
        total += Number.parseFloat(items[i5][key]);
      }
    }
    return Number.parseFloat(total.toPrecision(12));
  }
  take(length) {
    if (!Array.isArray(this.items) && typeof this.items === "object") {
      const keys2 = Object.keys(this.items);
      let slicedKeys;
      if (length < 0) {
        slicedKeys = keys2.slice(length);
      } else {
        slicedKeys = keys2.slice(0, length);
      }
      const collection = {};
      keys2.forEach((prop) => {
        if (slicedKeys.includes(prop)) {
          collection[prop] = this.items[prop];
        }
      });
      return new this.constructor(collection);
    }
    if (length < 0) {
      return new this.constructor(this.items.slice(length));
    }
    return new this.constructor(this.items.slice(0, length));
  }
  takeUntil(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction4(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray3(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== false) {
          previous = !callback(item);
        }
        return previous;
      });
    }
    if (isObject23(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== false) {
          previous = !callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  takeWhile(valueOrFunction) {
    let previous = null;
    let items;
    let callback = (value) => value === valueOrFunction;
    if (isFunction4(valueOrFunction)) {
      callback = valueOrFunction;
    }
    if (isArray3(this.items)) {
      items = this.items.filter((item) => {
        if (previous !== false) {
          previous = callback(item);
        }
        return previous;
      });
    }
    if (isObject23(this.items)) {
      items = Object.keys(this.items).reduce((acc, key) => {
        if (previous !== false) {
          previous = callback(this.items[key]);
        }
        if (previous !== false) {
          acc[key] = this.items[key];
        }
        return acc;
      }, {});
    }
    return new this.constructor(items);
  }
  tap(fn) {
    fn(this);
    return this;
  }
  times(n5, fn) {
    for (let iterator = 1;iterator <= n5; iterator += 1) {
      this.items.push(fn(iterator));
    }
    return this;
  }
  toArray() {
    return Array.isArray(this.items) ? this.items : Object.values(this.items);
  }
  toJson() {
    return JSON.stringify(this.items);
  }
  transform(fn) {
    if (Array.isArray(this.items)) {
      this.items = this.items.map(fn);
    } else {
      const collection = {};
      Object.keys(this.items).forEach((key) => {
        collection[key] = fn(this.items[key], key);
      });
      this.items = collection;
    }
    return this;
  }
  undot() {
    if (Array.isArray(this.items)) {
      return this;
    }
    let collection = {};
    Object.keys(this.items).forEach((key) => {
      if (key.includes(".")) {
        const obj = collection;
        key.split(".").reduce((acc, current, index, array) => {
          if (!acc[current]) {
            acc[current] = {};
          }
          if (index === array.length - 1) {
            acc[current] = this.items[key];
          }
          return acc[current];
        }, obj);
        collection = { ...collection, ...obj };
      } else {
        collection[key] = this.items[key];
      }
    });
    return new this.constructor(collection);
  }
  unless(value, fn, defaultFn) {
    if (!value) {
      return fn(this);
    }
    if (defaultFn)
      return defaultFn();
    return;
  }
  unlessEmpty(callback) {
    if (!this.isEmpty()) {
      callback(this);
    }
    return this;
  }
  unlessNotEmpty(callback) {
    if (this.isEmpty()) {
      callback(this);
    }
    return this;
  }
  union(object) {
    const collection = JSON.parse(JSON.stringify(this.items));
    Object.keys(object).forEach((prop) => {
      if (this.items[prop] === undefined) {
        collection[prop] = object[prop];
      }
    });
    return new this.constructor(collection);
  }
  unique() {
    const uniqueItems = Array.from(new Set(this.items));
    return new this.constructor(uniqueItems);
  }
  unwrap() {
    return this.items;
  }
  values() {
    return new Collection3(Object.values(this.items));
  }
  when(value, callback, defaultCallback) {
    if (value) {
      callback(this, value);
    } else if (defaultCallback) {
      defaultCallback();
    }
    return this;
  }
  whenEmpty(fn, defaultFn) {
    if (Array.isArray(this.items) && !this.items.length) {
      return fn(this);
    }
    if (!Object.keys(this.items).length) {
      return fn(this);
    }
    if (defaultFn !== undefined) {
      if (Array.isArray(this.items) && this.items.length) {
        return defaultFn(this);
      }
      if (Object.keys(this.items).length) {
        return defaultFn(this);
      }
    }
    return this;
  }
  whenNotEmpty(fn, defaultFn) {
    if (Array.isArray(this.items) && this.items.length) {
      return fn(this);
    }
    if (Object.keys(this.items).length) {
      return fn(this);
    }
    if (defaultFn !== undefined) {
      if (Array.isArray(this.items) && !this.items.length) {
        return defaultFn(this);
      }
      if (!Object.keys(this.items).length) {
        return defaultFn(this);
      }
    }
    return this;
  }
  where(key, operator, value) {
    if (arguments.length === 1) {
      return new Collection3(this.items.filter((item) => item[key] !== undefined));
    }
    if (arguments.length === 2) {
      value = operator;
      operator = "===";
    }
    const compareValues = (item, key2, value2, operator2) => {
      const itemValue = item[key2];
      switch (operator2) {
        case "===":
          return itemValue === value2;
        case "!==":
          return itemValue !== value2;
        case "<":
          return itemValue < value2;
        case "<=":
          return itemValue <= value2;
        case ">":
          return itemValue > value2;
        case ">=":
          return itemValue >= value2;
        default:
          return itemValue == value2;
      }
    };
    return new Collection3(this.items.filter((item) => compareValues(item, key, value, operator)));
  }
  whereBetween(key, values22) {
    return this.filter((item) => {
      const itemValue = typeof item === "object" ? item[key] : item;
      return itemValue >= values22[0] && itemValue <= values22[1];
    });
  }
  whereIn(key, values22) {
    return this.filter((item) => {
      const itemValue = typeof item === "object" ? item[key] : item;
      return values22.includes(itemValue);
    });
  }
  whereNotBetween(key, values22) {
    return this.filter((item) => {
      const itemValue = typeof item === "object" ? item[key] : item;
      return itemValue < values22[0] || itemValue > values22[1];
    });
  }
  whereNotIn(key, values22) {
    const filteredItems = this.items.filter((item) => {
      const keys2 = key.split(".");
      let value = item;
      for (const k5 of keys2) {
        if (value[k5] === undefined)
          return true;
        value = value[k5];
      }
      return !values22.includes(value);
    });
    return new Collection3(filteredItems);
  }
  getNestedValue(item, key) {
    const keys2 = key.split(".");
    return keys2.reduce((obj, k5) => obj && obj[k5] !== undefined ? obj[k5] : null, item);
  }
  whereInstanceOf(type2) {
    return this.filter((item) => item instanceof type2);
  }
  whereNotNull(key) {
    return this.where(key, "!==", null);
  }
  whereNull(key) {
    return this.where(key, "===", null);
  }
  static wrap(value) {
    if (value instanceof Collection3)
      return value;
    return new Collection3(Array.isArray(value) ? value : [value]);
  }
  static unwrap(value) {
    if (value instanceof Collection3) {
      return value.all();
    }
    return value;
  }
  wrap(value) {
    if (value instanceof Collection3) {
      return value;
    }
    if (typeof value === "object") {
      return new Collection3(value);
    }
    return new Collection3([value]);
  }
  zip(...arrays) {
    const arrayOfArrays = arrays.map((arg) => this.constructor.wrap(arg).all());
    const zipped = this.items.map((item, index) => {
      const values22 = [item];
      arrayOfArrays.forEach((array) => {
        values22.push(array[index]);
      });
      return new this.constructor(values22);
    });
    return new this.constructor(zipped);
  }
}
var buildKeyPathMap5 = function buildKeyPathMap23(items) {
  const keyPaths = {};
  items.forEach((item, index) => {
    function buildKeyPath(val2, keyPath) {
      if (isObject23(val2)) {
        Object.keys(val2).forEach((prop) => {
          buildKeyPath(val2[prop], `${keyPath}.${prop}`);
        });
      } else if (isArray3(val2)) {
        val2.forEach((v23, i5) => {
          buildKeyPath(v23, `${keyPath}.${i5}`);
        });
      }
      keyPaths[keyPath] = val2;
    }
    buildKeyPath(item, index);
  });
  return keyPaths;
};
function SymbolIterator3() {
  let index = -1;
  return {
    next: () => {
      index += 1;
      return {
        value: this.items[index],
        done: index >= this.items.length
      };
    }
  };
}
init_utils14();
var quotes3 = collect3([
  "The best way to get started is to quit talking and begin doing.",
  "The pessimist sees difficulty in every opportunity. The optimist sees opportunity in every difficulty.",
  "Don\u2019t let yesterday take up too much of today.",
  "You learn more from failure than from success. Don\u2019t let it stop you. Failure builds character.",
  "It\u2019s not whether you get knocked down, it\u2019s whether you get up.",
  "If you are working on something that you really care about, you don\u2019t have to be pushed. The vision pulls you.",
  "People who are crazy enough to think they can change the world, are the ones who do.",
  "Failure will never overtake me if my determination to succeed is strong enough.",
  "Entrepreneurs are great at dealing with uncertainty and also very good at minimizing risk. That\u2019s the classic entrepreneur.",
  "We may encounter many defeats but we must not be defeated.",
  "Knowing is not enough; we must apply. Wishing is not enough; we must do.",
  "Imagine your life is perfect in every respect; what would it look like?",
  "We generate fears while we sit. We overcome them by action.",
  "Whether you think you can or think you can\u2019t, you\u2019re right.",
  "Security is mostly a superstition. Life is either a daring adventure or nothing."
]);
var export_prompts2 = import_prompts3.default;
var import_node_forge2 = __toESM4(require_lib23(), 1);
function deepMerge2(target, ...sources) {
  if (!sources.length)
    return target;
  const source = sources.shift();
  if (isObject33(target) && isObject33(source)) {
    for (const key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        const sourceValue = source[key];
        if (isObject33(sourceValue) && isObject33(target[key])) {
          target[key] = deepMerge2(target[key], sourceValue);
        } else {
          target[key] = sourceValue;
        }
      }
    }
  }
  return deepMerge2(target, ...sources);
}
function isObject33(item) {
  return item && typeof item === "object" && !Array.isArray(item);
}
async function loadConfig3({ name, cwd, defaultConfig }) {
  const configPath2 = resolve6(cwd || process23.cwd(), `${name}.config`);
  try {
    const importedConfig = await import(configPath2);
    const loadedConfig = importedConfig.default || importedConfig;
    return deepMerge2(defaultConfig, loadedConfig);
  } catch (error) {
    return defaultConfig;
  }
}
var config42 = await loadConfig3({
  name: "tls",
  defaultConfig: {
    altNameIPs: ["127.0.0.1"],
    altNameURIs: ["localhost"],
    organizationName: "Local Development",
    countryName: "US",
    stateName: "California",
    localityName: "Playa Vista",
    commonName: "stacks.localhost",
    validityDays: 180,
    hostCertCN: "stacks.localhost",
    domain: "stacks.localhost",
    rootCAObject: { certificate: "", privateKey: "" },
    caCertPath: path8.join(os23.homedir(), ".stacks", "ssl", `stacks.localhost.ca.crt`),
    certPath: path8.join(os23.homedir(), ".stacks", "ssl", `stacks.localhost.crt`),
    keyPath: path8.join(os23.homedir(), ".stacks", "ssl", `stacks.localhost.crt.key`),
    verbose: false
  }
});
var import_node_forge = __toESM4(require_lib23(), 1);
function makeNumberPositive(hexString) {
  let mostSignificativeHexDigitAsInt = Number.parseInt(hexString[0], 16);
  if (mostSignificativeHexDigitAsInt < 8)
    return hexString;
  mostSignificativeHexDigitAsInt -= 8;
  return mostSignificativeHexDigitAsInt.toString() + hexString.substring(1);
}
function findFoldersWithFile(rootDir, fileName) {
  const result2 = [];
  function search(dir) {
    try {
      const files2 = fs6.readdirSync(dir);
      for (const file of files2) {
        const filePath = path22.join(dir, file);
        const stats = fs6.lstatSync(filePath);
        if (stats.isDirectory()) {
          search(filePath);
        } else if (file === fileName) {
          result2.push(dir);
        }
      }
    } catch (error) {
      console.warn(`Error reading directory ${dir}: ${error}`);
    }
  }
  search(rootDir);
  return result2;
}
function debugLog2(category, message, verbose) {
  if (verbose || config42.verbose) {
    console.debug(`[tlsx:${category}] ${message}`);
  }
}
function randomSerialNumber(verbose) {
  debugLog2("cert", "Generating random serial number", verbose);
  const serialNumber = makeNumberPositive(import_node_forge2.default.util.bytesToHex(import_node_forge2.default.random.getBytesSync(20)));
  debugLog2("cert", `Generated serial number: ${serialNumber}`, verbose);
  return serialNumber;
}
function getCertNotBefore(verbose) {
  debugLog2("cert", "Calculating certificate not-before date", verbose);
  const twoDaysAgo = new Date(Date.now() - 172800000);
  const year = twoDaysAgo.getFullYear();
  const month = (twoDaysAgo.getMonth() + 1).toString().padStart(2, "0");
  const day = twoDaysAgo.getDate().toString().padStart(2, "0");
  const date = new Date(`${year}-${month}-${day}T23:59:59Z`);
  debugLog2("cert", `Certificate not-before date: ${date.toISOString()}`, verbose);
  return date;
}
function getCertNotAfter(notBefore, verbose) {
  debugLog2("cert", "Calculating certificate not-after date", verbose);
  const validityDays = config42.validityDays;
  const daysInMillis = validityDays * 60 * 60 * 24 * 1000;
  const notAfterDate = new Date(notBefore.getTime() + daysInMillis);
  const year = notAfterDate.getFullYear();
  const month = (notAfterDate.getMonth() + 1).toString().padStart(2, "0");
  const day = notAfterDate.getDate().toString().padStart(2, "0");
  const date = new Date(`${year}-${month}-${day}T23:59:59Z`);
  debugLog2("cert", `Certificate not-after date: ${date.toISOString()} (${validityDays} days validity)`, verbose);
  return date;
}
function getCANotAfter(notBefore, verbose) {
  debugLog2("cert", "Calculating CA not-after date", verbose);
  const year = notBefore.getFullYear() + 100;
  const month = (notBefore.getMonth() + 1).toString().padStart(2, "0");
  const day = notBefore.getDate().toString().padStart(2, "0");
  const date = new Date(`${year}-${month}-${day}T23:59:59Z`);
  debugLog2("cert", `CA not-after date: ${date.toISOString()} (100 years validity)`, verbose);
  return date;
}
async function createRootCA(options23) {
  debugLog2("ca", "Creating new Root CA Certificate", options23?.verbose);
  debugLog2("ca", "Generating 2048-bit RSA key pair", options23?.verbose);
  const { privateKey, publicKey } = import_node_forge2.pki.rsa.generateKeyPair(2048);
  const mergedOptions = {
    ...config42,
    ...options23 || {}
  };
  debugLog2("ca", "Setting certificate attributes", options23?.verbose);
  const attributes = [
    { shortName: "C", value: mergedOptions.countryName },
    { shortName: "ST", value: mergedOptions.stateName },
    { shortName: "L", value: mergedOptions.localityName },
    { shortName: "O", value: "Local Development CA" },
    { shortName: "CN", value: "Local Development Root CA" }
  ];
  debugLog2("ca", "Setting certificate extensions", options23?.verbose);
  const extensions = [
    {
      name: "basicConstraints",
      cA: true,
      critical: true
    },
    {
      name: "keyUsage",
      keyCertSign: true,
      cRLSign: true,
      critical: true
    },
    {
      name: "subjectKeyIdentifier"
    }
  ];
  debugLog2("ca", "Creating CA certificate", options23?.verbose);
  const caCert = import_node_forge2.pki.createCertificate();
  caCert.publicKey = publicKey;
  caCert.serialNumber = randomSerialNumber(options23?.verbose);
  caCert.validity.notBefore = getCertNotBefore(options23?.verbose);
  caCert.validity.notAfter = getCANotAfter(caCert.validity.notBefore, options23?.verbose);
  caCert.setSubject(attributes);
  caCert.setIssuer(attributes);
  caCert.setExtensions(extensions);
  debugLog2("ca", "Signing certificate with SHA-256", options23?.verbose);
  caCert.sign(privateKey, import_node_forge2.default.md.sha256.create());
  const pemCert = import_node_forge2.pki.certificateToPem(caCert);
  const pemKey = import_node_forge2.pki.privateKeyToPem(privateKey);
  debugLog2("ca", "Root CA Certificate created successfully", options23?.verbose);
  return {
    certificate: pemCert,
    privateKey: pemKey,
    notBefore: caCert.validity.notBefore,
    notAfter: caCert.validity.notAfter
  };
}
async function generateCert(options23) {
  debugLog2("cert", "Generating new host certificate", options23?.verbose);
  debugLog2("cert", `Options: ${JSON.stringify(options23)}`, options23?.verbose);
  if (!options23?.hostCertCN?.trim()) {
    debugLog2("cert", "Error: hostCertCN is required", options23?.verbose);
    throw new Error('"hostCertCN" must be a String');
  }
  if (!options23.domain?.trim()) {
    debugLog2("cert", "Error: domain is required", options23?.verbose);
    throw new Error('"domain" must be a String');
  }
  if (!options23.rootCAObject || !options23.rootCAObject.certificate || !options23.rootCAObject.privateKey) {
    debugLog2("cert", "Error: rootCAObject is invalid or missing", options23?.verbose);
    throw new Error('"rootCAObject" must be an Object with the properties "certificate" & "privateKey"');
  }
  debugLog2("cert", "Converting Root CA PEM to forge objects", options23?.verbose);
  const caCert = import_node_forge2.pki.certificateFromPem(options23.rootCAObject.certificate);
  const caKey = import_node_forge2.pki.privateKeyFromPem(options23.rootCAObject.privateKey);
  debugLog2("cert", "Generating 2048-bit RSA key pair for host certificate", options23?.verbose);
  const hostKeys = import_node_forge2.pki.rsa.generateKeyPair(2048);
  debugLog2("cert", "Setting certificate attributes", options23?.verbose);
  const attributes = [
    { shortName: "C", value: options23.countryName || config42.countryName },
    { shortName: "ST", value: options23.stateName || config42.stateName },
    { shortName: "L", value: options23.localityName || config42.localityName },
    { shortName: "O", value: options23.organizationName || config42.organizationName },
    { shortName: "CN", value: options23.commonName || config42.commonName }
  ];
  const domain = options23.domain || config42.domain;
  const wildcardDomain = `*.${domain.includes(".") ? domain.split(".").slice(1).join(".") : domain}`;
  const altNames = [
    { type: 2, value: wildcardDomain },
    { type: 2, value: "localhost" },
    { type: 2, value: domain }
  ];
  debugLog2("cert", "Setting certificate extensions", options23?.verbose);
  const extensions = [
    {
      name: "basicConstraints",
      cA: false,
      critical: true
    },
    {
      name: "keyUsage",
      digitalSignature: true,
      keyEncipherment: true,
      critical: true
    },
    {
      name: "extKeyUsage",
      serverAuth: true,
      clientAuth: false
    },
    {
      name: "subjectAltName",
      altNames
    }
  ];
  debugLog2("cert", "Creating new host certificate", options23?.verbose);
  const newHostCert = import_node_forge2.pki.createCertificate();
  newHostCert.publicKey = hostKeys.publicKey;
  debugLog2("cert", "Setting certificate properties", options23?.verbose);
  newHostCert.serialNumber = randomSerialNumber(options23?.verbose);
  newHostCert.validity.notBefore = getCertNotBefore(options23?.verbose);
  newHostCert.validity.notAfter = getCertNotAfter(newHostCert.validity.notBefore, options23?.verbose);
  newHostCert.setSubject(attributes);
  newHostCert.setIssuer(caCert.subject.attributes);
  newHostCert.setExtensions(extensions);
  debugLog2("cert", "Signing certificate with SHA-256", options23?.verbose);
  newHostCert.sign(caKey, import_node_forge2.default.md.sha256.create());
  debugLog2("cert", "Converting certificate to PEM format", options23?.verbose);
  const pemHostCert = import_node_forge2.pki.certificateToPem(newHostCert);
  const pemHostKey = import_node_forge2.pki.privateKeyToPem(hostKeys.privateKey);
  debugLog2("cert", "Host certificate generated successfully", options23?.verbose);
  return {
    certificate: pemHostCert,
    privateKey: pemHostKey,
    notBefore: newHostCert.validity.notBefore,
    notAfter: newHostCert.validity.notAfter
  };
}
async function addCertToSystemTrustStoreAndSaveCert(cert, caCert, options23) {
  debugLog2("trust", `Adding certificate to system trust store with options: ${JSON.stringify(options23)}`, options23?.verbose);
  debugLog2("trust", "Storing certificate and private key", options23?.verbose);
  const certPath = storeCert(cert, options23);
  debugLog2("trust", "Storing CA certificate", options23?.verbose);
  const caCertPath = storeCACert(caCert, options23);
  const platform23 = os42.platform();
  debugLog2("trust", `Detected platform: ${platform23}`, options23?.verbose);
  const args = "TC, C, C";
  if (platform23 === "darwin") {
    debugLog2("trust", "Adding certificate to macOS keychain", options23?.verbose);
    await runCommand2(`sudo security add-trusted-cert -d -r trustRoot -k /Library/Keychains/System.keychain ${caCertPath}`);
  } else if (platform23 === "win32") {
    debugLog2("trust", "Adding certificate to Windows certificate store", options23?.verbose);
    await runCommand2(`certutil -f -v -addstore -enterprise Root ${caCertPath}`);
  } else if (platform23 === "linux") {
    debugLog2("trust", "Adding certificate to Linux certificate store", options23?.verbose);
    const rootDirectory = os42.homedir();
    const targetFileName = "cert9.db";
    debugLog2("trust", `Searching for certificate databases in ${rootDirectory}`, options23?.verbose);
    const foldersWithFile = findFoldersWithFile(rootDirectory, targetFileName);
    for (const folder of foldersWithFile) {
      debugLog2("trust", `Processing certificate database in ${folder}`, options23?.verbose);
      try {
        debugLog2("trust", `Attempting to delete existing cert for ${config42.commonName}`, options23?.verbose);
        await runCommand2(`certutil -d sql:${folder} -D -n ${config42.commonName}`);
      } catch (error) {
        debugLog2("trust", `Warning: Error deleting existing cert: ${error}`, options23?.verbose);
        console.warn(`Error deleting existing cert: ${error}`);
      }
      debugLog2("trust", `Adding new certificate to ${folder}`, options23?.verbose);
      await runCommand2(`certutil -d sql:${folder} -A -t ${args} -n ${config42.commonName} -i ${caCertPath}`);
      log3.info(`Cert added to ${folder}`);
    }
  } else {
    debugLog2("trust", `Error: Unsupported platform ${platform23}`, options23?.verbose);
    throw new Error(`Unsupported platform: ${platform23}`);
  }
  debugLog2("trust", "Certificate successfully added to system trust store", options23?.verbose);
  return certPath;
}
function storeCert(cert, options23) {
  debugLog2("storage", `Storing certificate and private key with options: ${JSON.stringify(options23)}`, options23?.verbose);
  const certPath = options23?.certPath || config42.certPath;
  const certKeyPath = options23?.keyPath || config42.keyPath;
  debugLog2("storage", `Certificate path: ${certPath}`, options23?.verbose);
  debugLog2("storage", `Private key path: ${certKeyPath}`, options23?.verbose);
  const certDir = path32.dirname(certPath);
  if (!fs22.existsSync(certDir)) {
    debugLog2("storage", `Creating certificate directory: ${certDir}`, options23?.verbose);
    fs22.mkdirSync(certDir, { recursive: true });
  }
  debugLog2("storage", "Writing certificate file", options23?.verbose);
  fs22.writeFileSync(certPath, cert.certificate);
  const certKeyDir = path32.dirname(certKeyPath);
  if (!fs22.existsSync(certKeyDir)) {
    debugLog2("storage", `Creating private key directory: ${certKeyDir}`, options23?.verbose);
    fs22.mkdirSync(certKeyDir, { recursive: true });
  }
  debugLog2("storage", "Writing private key file", options23?.verbose);
  fs22.writeFileSync(certKeyPath, cert.privateKey);
  debugLog2("storage", "Certificate and private key stored successfully", options23?.verbose);
  return certPath;
}
function storeCACert(caCert, options23) {
  debugLog2("storage", "Storing CA certificate", options23?.verbose);
  const caCertPath = options23?.caCertPath || config42.caCertPath;
  debugLog2("storage", `CA certificate path: ${caCertPath}`, options23?.verbose);
  const caCertDir = path32.dirname(caCertPath);
  if (!fs22.existsSync(caCertDir)) {
    debugLog2("storage", `Creating CA certificate directory: ${caCertDir}`, options23?.verbose);
    fs22.mkdirSync(caCertDir, { recursive: true });
  }
  debugLog2("storage", "Writing CA certificate file", options23?.verbose);
  fs22.writeFileSync(caCertPath, caCert);
  debugLog2("storage", "CA certificate stored successfully", options23?.verbose);
  return caCertPath;
}
var export_tls = import_node_forge2.tls;
var export_pki = import_node_forge2.pki;
var export_forge = import_node_forge2.default;

// src/https.ts
function httpsConfig() {
  const domain = config6.to || "stacks.localhost";
  const defaultConfig = {
    domain,
    hostCertCN: domain,
    caCertPath: path9.join(os8.homedir(), ".stacks", "ssl", `${domain}.ca.crt`),
    certPath: path9.join(os8.homedir(), ".stacks", "ssl", `${domain}.crt`),
    keyPath: path9.join(os8.homedir(), ".stacks", "ssl", `${domain}.crt.key`),
    altNameIPs: ["127.0.0.1"],
    altNameURIs: ["localhost"],
    organizationName: "stacksjs.org",
    countryName: "US",
    stateName: "California",
    localityName: "Playa Vista",
    commonName: domain,
    validityDays: 180,
    verbose: false
  };
  if (config6.https === true)
    return defaultConfig;
  return {
    ...defaultConfig,
    ...config6.https
  };
}
async function generateCertificate(domain) {
  if (config6.https === true)
    config6.https = httpsConfig();
  else if (config6.https === false)
    return;
  domain = domain ?? config6.https.domain;
  log.info(`Generating a self-signed SSL certificate for: ${domain}`);
  const caCert = await createRootCA(config6.https);
  const hostCert = await generateCert({
    hostCertCN: config6.https.commonName ?? domain,
    domain,
    altNameIPs: config6.https.altNameIPs,
    altNameURIs: config6.https.altNameURIs,
    countryName: config6.https.countryName,
    stateName: config6.https.stateName,
    localityName: config6.https.localityName,
    organizationName: config6.https.organizationName,
    validityDays: config6.https.validityDays,
    rootCAObject: {
      certificate: caCert.certificate,
      privateKey: caCert.privateKey
    },
    verbose: config6.https.verbose || config6.verbose
  });
  await addCertToSystemTrustStoreAndSaveCert(hostCert, caCert.certificate, config6.https);
  log.success("Certificate generated");
}

// src/start.ts
var activeServers = new Set;
async function cleanup() {
  debugLog("cleanup", "Starting cleanup process", config6.verbose);
  console.log(`\n`);
  log.info("Shutting down proxy servers...");
  const cleanupPromises = [];
  const serverClosePromises = Array.from(activeServers).map((server) => new Promise((resolve5) => {
    server.close(() => {
      debugLog("cleanup", "Server closed successfully", config6.verbose);
      resolve5();
    });
  }));
  cleanupPromises.push(...serverClosePromises);
  if (config6.etcHostsCleanup) {
    debugLog("cleanup", "Cleaning up hosts file entries", config6.verbose);
    try {
      const toUrl = new URL(config6.to.startsWith("http") ? config6.to : `http://${config6.to}`);
      const hostname = toUrl.hostname;
      if (!hostname.includes("localhost") && !hostname.includes("127.0.0.1")) {
        log.info("Cleaning up hosts file entries...");
        cleanupPromises.push(removeHosts([hostname]).then(() => {
          debugLog("cleanup", `Removed hosts entry for ${hostname}`, config6.verbose);
        }).catch((err4) => {
          debugLog("cleanup", `Failed to remove hosts entry: ${err4}`, config6.verbose);
          log.warn(`Failed to clean up hosts file entry for ${hostname}:`, err4);
        }));
      }
    } catch (err4) {
      debugLog("cleanup", `Error parsing URL during hosts cleanup: ${err4}`, config6.verbose);
      log.warn("Failed to parse URL for hosts cleanup:", err4);
    }
  }
  try {
    await Promise.all(cleanupPromises);
    debugLog("cleanup", "All cleanup tasks completed successfully", config6.verbose);
    log.success("All cleanup tasks completed successfully");
    process24.exit(0);
  } catch (err4) {
    debugLog("cleanup", `Error during cleanup: ${err4}`, config6.verbose);
    log.error("Error during cleanup:", err4);
    process24.exit(1);
  }
}
process24.on("SIGINT", cleanup);
process24.on("SIGTERM", cleanup);
process24.on("uncaughtException", (err4) => {
  debugLog("process", `Uncaught exception: ${err4}`, config6.verbose);
  log.error("Uncaught exception:", err4);
  cleanup();
});
async function loadSSLConfig(options4) {
  debugLog("ssl", "Loading SSL configuration", options4.verbose);
  if (options4.https === true)
    options4.https = httpsConfig();
  else if (options4.https === false)
    return null;
  if (!options4.https?.keyPath && !options4.https?.certPath) {
    debugLog("ssl", "No SSL configuration provided", options4.verbose);
    return null;
  }
  if (options4.https?.keyPath && !options4.https?.certPath || !options4.https?.keyPath && options4.https?.certPath) {
    const missing = !options4.https?.keyPath ? "keyPath" : "certPath";
    debugLog("ssl", `Invalid SSL configuration - missing ${missing}`, options4.verbose);
    throw new Error(`SSL Configuration requires both keyPath and certPath. Missing: ${missing}`);
  }
  try {
    if (!options4.https?.keyPath || !options4.https?.certPath)
      return null;
    try {
      debugLog("ssl", "Reading SSL certificate files", options4.verbose);
      const key = await fs7.promises.readFile(options4.https?.keyPath, "utf8");
      const cert = await fs7.promises.readFile(options4.https?.certPath, "utf8");
      debugLog("ssl", "SSL configuration loaded successfully", options4.verbose);
      return { key, cert };
    } catch (error) {
      if (error.code === "ENOENT") {
        debugLog("ssl", "Certificates not found, generating new ones", options4.verbose);
        await generateCertificate(options4.to);
        debugLog("ssl", "Reading newly generated certificates", options4.verbose);
        const key = await fs7.promises.readFile(options4.https?.keyPath, "utf8");
        const cert = await fs7.promises.readFile(options4.https?.certPath, "utf8");
        debugLog("ssl", "New SSL certificates loaded successfully", options4.verbose);
        return { key, cert };
      }
      throw error;
    }
  } catch (err4) {
    const error = err4;
    const detail = error.code === "ENOENT" ? `File not found: ${error.path}` : error.message;
    debugLog("ssl", `SSL configuration error: ${error}`, options4.verbose);
    throw new Error(`SSL Configuration Error: ${detail}`);
  }
}
function isPortInUse(port, hostname, verbose) {
  debugLog("port", `Checking if port ${port} is in use on ${hostname}`, verbose);
  return new Promise((resolve5) => {
    const server = net.createServer();
    server.once("error", (err4) => {
      if (err4.code === "EADDRINUSE") {
        debugLog("port", `Port ${port} is in use`, verbose);
        resolve5(true);
      }
    });
    server.once("listening", () => {
      debugLog("port", `Port ${port} is available`, verbose);
      server.close();
      resolve5(false);
    });
    server.listen(port, hostname);
  });
}
async function findAvailablePort(startPort, hostname, verbose) {
  debugLog("port", `Finding available port starting from ${startPort}`, verbose);
  let port = startPort;
  while (await isPortInUse(port, hostname, verbose)) {
    debugLog("port", `Port ${port} is in use, trying ${port + 1}`, verbose);
    port++;
  }
  debugLog("port", `Found available port: ${port}`, verbose);
  return port;
}
async function testConnection(hostname, port, verbose) {
  debugLog("connection", `Testing connection to ${hostname}:${port}`, verbose);
  return new Promise((resolve5, reject) => {
    const socket = net.connect({
      host: hostname,
      port,
      timeout: 5000
    });
    socket.once("connect", () => {
      debugLog("connection", `Successfully connected to ${hostname}:${port}`, verbose);
      socket.end();
      resolve5();
    });
    socket.once("timeout", () => {
      debugLog("connection", `Connection to ${hostname}:${port} timed out`, verbose);
      socket.destroy();
      reject(new Error(`Connection to ${hostname}:${port} timed out`));
    });
    socket.once("error", (err4) => {
      debugLog("connection", `Failed to connect to ${hostname}:${port}: ${err4}`, verbose);
      socket.destroy();
      reject(new Error(`Failed to connect to ${hostname}:${port}: ${err4.message}`));
    });
  });
}
async function startServer(options4) {
  debugLog("server", `Starting server with options: ${JSON.stringify(options4)}`, options4?.verbose);
  if (!options4)
    options4 = config6;
  if (!options4.from)
    options4.from = config6.from;
  if (!options4.to)
    options4.to = config6.to;
  const fromUrl = new URL(options4.from.startsWith("http") ? options4.from : `http://${options4.from}`);
  const toUrl = new URL(options4.to.startsWith("http") ? options4.to : `http://${options4.to}`);
  const fromPort = Number.parseInt(fromUrl.port) || (fromUrl.protocol.includes("https:") ? 443 : 80);
  const hostsToCheck = [toUrl.hostname];
  if (!toUrl.hostname.includes("localhost") && !toUrl.hostname.includes("127.0.0.1")) {
    debugLog("hosts", `Checking if hosts file entry exists for: ${toUrl.hostname}`, options4.verbose);
    try {
      const hostsExist = await checkHosts(hostsToCheck);
      if (!hostsExist[0]) {
        log.info(`Adding ${toUrl.hostname} to hosts file...`);
        log.info("This may require sudo/administrator privileges");
        try {
          await addHosts(hostsToCheck);
        } catch (addError) {
          log.error("Failed to add hosts entry:", addError.message);
          log.warn("You can manually add this entry to your hosts file:");
          log.warn(`127.0.0.1 ${toUrl.hostname}`);
          log.warn(`::1 ${toUrl.hostname}`);
          if (process24.platform === "win32") {
            log.warn("On Windows:");
            log.warn("1. Run notepad as administrator");
            log.warn("2. Open C:\\Windows\\System32\\drivers\\etc\\hosts");
          } else {
            log.warn("On Unix systems:");
            log.warn("sudo nano /etc/hosts");
          }
        }
      } else {
        debugLog("hosts", `Host entry already exists for ${toUrl.hostname}`, options4.verbose);
      }
    } catch (checkError) {
      log.error("Failed to check hosts file:", checkError.message);
    }
  }
  if (config6.https) {
    if (config6.https === true)
      config6.https = httpsConfig();
    const domain = toUrl.hostname;
    if (typeof options4.https !== "boolean" && options4.https) {
      options4.https.keyPath = config6.https.keyPath || path10.join(os9.homedir(), ".stacks", "ssl", `${domain}.crt.key`);
      options4.https.certPath = config6.https.certPath || path10.join(os9.homedir(), ".stacks", "ssl", `${domain}.crt`);
      debugLog("server", `HTTPS enabled, using cert paths: ${options4.https.keyPath}, ${options4.https.certPath}`, options4.verbose);
    }
  }
  debugLog("server", `Parsed URLs - from: ${fromUrl}, to: ${toUrl}`, options4.verbose);
  try {
    await testConnection(fromUrl.hostname, fromPort, options4.verbose);
  } catch (err4) {
    debugLog("server", `Connection test failed: ${err4}`, options4.verbose);
    log.error(err4.message);
    process24.exit(1);
  }
  let sslConfig = null;
  if (config6.https) {
    try {
      sslConfig = await loadSSLConfig(options4);
    } catch (err4) {
      debugLog("server", `SSL config failed, attempting to generate certificates: ${err4}`, options4.verbose);
      await generateCertificate(options4.to);
      sslConfig = await loadSSLConfig(options4);
    }
  }
  await setupReverseProxy({
    ...options4,
    from: options4.from,
    to: toUrl.hostname,
    fromPort,
    sourceUrl: {
      hostname: fromUrl.hostname,
      host: fromUrl.host
    },
    ssl: sslConfig
  });
}
async function createProxyServer(from, to, fromPort, listenPort, hostname, sourceUrl, ssl, verbose) {
  debugLog("proxy", `Creating proxy server ${from} -> ${to}`, verbose);
  const requestHandler = (req, res) => {
    debugLog("request", `Incoming request: ${req.method} ${req.url}`, verbose);
    const proxyOptions = {
      hostname: sourceUrl.hostname,
      port: fromPort,
      path: req.url,
      method: req.method,
      headers: {
        ...req.headers,
        host: sourceUrl.host
      }
    };
    debugLog("request", `Proxy request options: ${JSON.stringify(proxyOptions)}`, verbose);
    const proxyReq = http.request(proxyOptions, (proxyRes) => {
      debugLog("response", `Proxy response received with status ${proxyRes.statusCode}`, verbose);
      const headers = {
        ...proxyRes.headers,
        "Strict-Transport-Security": "max-age=31536000; includeSubDomains; preload",
        "X-Content-Type-Options": "nosniff"
      };
      res.writeHead(proxyRes.statusCode || 500, headers);
      proxyRes.pipe(res);
    });
    proxyReq.on("error", (err4) => {
      debugLog("request", `Proxy request failed: ${err4}`, verbose);
      log.error("Proxy request failed:", err4);
      res.writeHead(502);
      res.end(`Proxy Error: ${err4.message}`);
    });
    req.pipe(proxyReq);
  };
  const serverOptions = ssl ? {
    key: ssl.key,
    cert: ssl.cert,
    ca: ssl.ca,
    minVersion: "TLSv1.2",
    maxVersion: "TLSv1.3",
    requestCert: false,
    rejectUnauthorized: false,
    ciphers: [
      "TLS_AES_128_GCM_SHA256",
      "TLS_AES_256_GCM_SHA384",
      "TLS_CHACHA20_POLY1305_SHA256",
      "ECDHE-ECDSA-AES128-GCM-SHA256",
      "ECDHE-RSA-AES128-GCM-SHA256",
      "ECDHE-ECDSA-AES256-GCM-SHA384",
      "ECDHE-RSA-AES256-GCM-SHA384"
    ].join(":"),
    allowHTTP1: true,
    ALPNProtocols: ["h2", "http/1.1"]
  } : undefined;
  debugLog("server", `Creating server with SSL config: ${!!ssl}`, verbose);
  const server = ssl && serverOptions ? https.createServer(serverOptions, requestHandler) : http.createServer(requestHandler);
  if (ssl) {
    server.on("secureConnection", (tlsSocket) => {
      debugLog("tls", `TLS Connection established: ${JSON.stringify({
        protocol: tlsSocket.getProtocol?.(),
        cipher: tlsSocket.getCipher?.(),
        authorized: tlsSocket.authorized,
        authError: tlsSocket.authorizationError
      })}`, verbose);
    });
  }
  activeServers.add(server);
  return new Promise((resolve5, reject) => {
    server.listen(listenPort, hostname, () => {
      debugLog("server", `Server listening on port ${listenPort}`, verbose);
      console.log("");
      console.log(`  ${green(bold("reverse-proxy"))} ${green(`v${version}`)}`);
      console.log("");
      console.log(`  ${green("\u279C")}  ${dim(from)} ${dim("\u279C")} ${ssl ? "https" : "http"}://${to}`);
      if (listenPort !== (ssl ? 443 : 80))
        console.log(`  ${green("\u279C")}  Listening on port ${listenPort}`);
      if (ssl) {
        console.log(`  ${green("\u279C")}  SSL enabled with:`);
        console.log(`     - TLS 1.2/1.3`);
        console.log(`     - Modern cipher suite`);
        console.log(`     - HTTP/2 enabled`);
        console.log(`     - HSTS enabled`);
      }
      resolve5();
    });
    server.on("error", (err4) => {
      debugLog("server", `Server error: ${err4}`, verbose);
      reject(err4);
    });
  });
}
async function setupReverseProxy(options4) {
  debugLog("setup", `Setting up reverse proxy: ${JSON.stringify(options4)}`, options4.verbose);
  const { from, to, fromPort, sourceUrl, ssl, verbose } = options4;
  const httpPort = 80;
  const httpsPort = 443;
  const hostname = "0.0.0.0";
  try {
    if (ssl) {
      const isHttpPortBusy = await isPortInUse(httpPort, hostname, verbose);
      if (!isHttpPortBusy) {
        debugLog("setup", "Starting HTTP redirect server", verbose);
        startHttpRedirectServer(verbose);
      } else {
        debugLog("setup", "Port 80 is in use, skipping HTTP redirect", verbose);
        log.warn("Port 80 is in use, HTTP to HTTPS redirect will not be available");
      }
    }
    const targetPort = ssl ? httpsPort : httpPort;
    const isTargetPortBusy = await isPortInUse(targetPort, hostname, verbose);
    if (isTargetPortBusy) {
      debugLog("setup", `Port ${targetPort} is busy, finding alternative`, verbose);
      const availablePort = await findAvailablePort(ssl ? 8443 : 8080, hostname, verbose);
      log.warn(`Port ${targetPort} is in use. Using port ${availablePort} instead.`);
      log.info(`You can use 'sudo lsof -i :${targetPort}' (Unix) or 'netstat -ano | findstr :${targetPort}' (Windows) to check what's using the port.`);
      await createProxyServer(from, to, fromPort, availablePort, hostname, sourceUrl, ssl, verbose);
    } else {
      debugLog("setup", `Using default port ${targetPort}`, verbose);
      await createProxyServer(from, to, fromPort, targetPort, hostname, sourceUrl, ssl, verbose);
    }
  } catch (err4) {
    debugLog("setup", `Setup failed: ${err4}`, verbose);
    log.error(`Failed to setup reverse proxy: ${err4.message}`);
    cleanup();
  }
}
function startHttpRedirectServer(verbose) {
  debugLog("redirect", "Starting HTTP redirect server", verbose);
  const server = http.createServer((req, res) => {
    const host = req.headers.host || "";
    debugLog("redirect", `Redirecting request from ${host}${req.url} to HTTPS`, verbose);
    res.writeHead(301, {
      Location: `https://${host}${req.url}`
    });
    res.end();
  }).listen(80);
  activeServers.add(server);
  debugLog("redirect", "HTTP redirect server started", verbose);
}
function startProxy(options4) {
  const finalOptions = {
    ...config6,
    ...options4
  };
  debugLog("proxy", `Starting proxy with options: ${JSON.stringify({
    from: finalOptions.from,
    to: finalOptions.to,
    https: finalOptions.https
  })}`, finalOptions.verbose);
  startServer(finalOptions).catch((err4) => {
    debugLog("proxy", `Failed to start proxy: ${err4}`, finalOptions.verbose);
    log.error(`Failed to start proxy: ${err4.message}`);
    cleanup();
  });
}
function startProxies(options4) {
  if (Array.isArray(options4)) {
    debugLog("proxies", `Starting multiple proxies: ${options4.length}`, options4[0]?.verbose);
    Promise.all(options4.map((option) => startServer(option))).catch((err4) => {
      debugLog("proxies", `Failed to start proxies: ${err4}`, options4[0]?.verbose);
      log.error("Failed to start proxies:", err4);
      cleanup();
    });
  } else if (options4) {
    debugLog("proxies", "Starting single proxy", options4.verbose);
    startServer(options4).catch((err4) => {
      debugLog("proxies", `Failed to start proxy: ${err4}`, options4.verbose);
      log.error("Failed to start proxy:", err4);
      cleanup();
    });
  }
}

// bin/cli.ts
var cli = new CAC("reverse-proxy");
cli.command("start", "Start the Reverse Proxy Server").option("--from <from>", "The URL to proxy from", { default: config6.from }).option("--to <to>", "The URL to proxy to", { default: config6.to }).option("--key-path <path>", "Absolute path to the SSL key", { default: config6.keyPath }).option("--cert-path <path>", "Absolute path to the SSL certificate", { default: config6.certPath }).option("--verbose", "Enable verbose logging", { default: config6.verbose }).example("reverse-proxy start --from localhost:5173 --to my-project.localhost").example("reverse-proxy start --from localhost:3000 --to my-project.localhost/api").example("reverse-proxy start --from localhost:3000 --to localhost:3001").example("reverse-proxy start --from localhost:5173 --to my-project.test --key-path /absolute/path/to/key --cert-path /absolute/path/to/cert").action(async (options4) => {
  startProxy({
    from: options4?.from,
    to: options4?.to,
    keyPath: options4?.keyPath,
    certPath: options4?.certPath,
    verbose: options4?.verbose
  });
});
cli.command("update:etc-hosts", "Update the /etc/hosts file with the proxy domains. Please note, this command requires sudo/admin permissions.").alias("update-etc-hosts").example("sudo reverse-proxy update:etc-hosts").example("sudo reverse-proxy update-etc-hosts").action(async () => {
  log.info("Ensuring /etc/hosts file covers the proxy domain/s...");
  const hostsFilePath2 = os10.platform() === "win32" ? "C:\\Windows\\System32\\drivers\\etc\\hosts" : "/etc/hosts";
  if (config6 && typeof config6 === "object") {
    const entriesToAdd = Object.entries(config6).map(([from, to]) => `127.0.0.1 ${to} # reverse-proxy mapping for ${from}`);
    entriesToAdd.push("127.0.0.1 localhost # essential localhost mapping");
    try {
      let currentHostsContent = export_readFileSync(hostsFilePath2, "utf8");
      let updated = false;
      for (const entry of entriesToAdd) {
        const [ip, host] = entry.split(" ", 2);
        const regex4 = new RegExp(`^${ip}\\s+${host.split(" ")[0]}(\\s|\$)`, "m");
        if (!regex4.test(currentHostsContent)) {
          currentHostsContent += `\n${entry}`;
          updated = true;
        } else {
          log.info(`Entry for ${host} already exists in the hosts file.`);
        }
      }
      if (updated) {
        export_writeFileSync(hostsFilePath2, currentHostsContent, "utf8");
        log.success("Hosts file updated with latest proxy domains.");
      } else {
        log.info("No new entries were added to the hosts file.");
      }
    } catch (error) {
      if (error.code === "EACCES")
        console.error("Permission denied. Please run this command with administrative privileges.");
      else
        console.error(`An error occurred: ${error.message}`);
    }
  } else {
    console.log("No proxies found. Is your config configured properly?");
  }
});
cli.command("version", "Show the version of the Reverse Proxy CLI").action(() => {
  console.log(version);
});
cli.version(version);
cli.help();
cli.parse();
